package bibles

func ES_LSB_LoadInfo(CurrentBible *Bible) {
	CurrentBible.SetInfo("es.lsb", "La Santa Biblia")
	CurrentBible.AddBook("VPGN", "Génesis")
	CurrentBible.AddBook("VPEX", "Éxodo")
	CurrentBible.AddBook("VPLV", "Levítico")
	CurrentBible.AddBook("VPNM", "Números")
	CurrentBible.AddBook("VPDT", "Deuteronomio")
	CurrentBible.AddBook("VHIE", "Josué")
	CurrentBible.AddBook("VHID", "Jueces")
	CurrentBible.AddBook("VH1S", "1 Samuel")
	CurrentBible.AddBook("VH2S", "2 Samuel")
	CurrentBible.AddBook("VH1R", "1 Reyes")
	CurrentBible.AddBook("VH2R", "2 Reyes")
	CurrentBible.AddBook("VH1P", "1 Crónicas")
	CurrentBible.AddBook("VH2P", "2 Crónicas")
	CurrentBible.AddBook("VHED", "Esdrás")
	CurrentBible.AddBook("VHNH", "Nehemias")
	CurrentBible.AddBook("VH1M", "1 Macabeos")
	CurrentBible.AddBook("VH2M", "2 Macabeos")
	CurrentBible.AddBook("VMIS", "Isaías")
	CurrentBible.AddBook("VMIE", "Jeremías")
	CurrentBible.AddBook("VMEZ", "Ezequiel")
	CurrentBible.AddBook("VNOS", "Oseas")
	CurrentBible.AddBook("VNIL", "Joel")
	CurrentBible.AddBook("VNAM", "Amós")
	CurrentBible.AddBook("VNAB", "Abdías")
	CurrentBible.AddBook("VNIN", "Jonás")
	CurrentBible.AddBook("VNMI", "Miqueas")
	CurrentBible.AddBook("VNNH", "Nahún")
	CurrentBible.AddBook("VNHA", "Habacuc")
	CurrentBible.AddBook("VNSO", "Sofonías")
	CurrentBible.AddBook("VNAG", "Ageo")
	CurrentBible.AddBook("VNZA", "Zacarías")
	CurrentBible.AddBook("VNML", "Malaquías")
	CurrentBible.AddBook("VMDN", "Daniel")
	CurrentBible.AddBook("VSIB", "Job")
	CurrentBible.AddBook("VSPR", "Proverbios")
	CurrentBible.AddBook("VSEE", "Qohélet")
	CurrentBible.AddBook("VSCC", "Cantar")
	CurrentBible.AddBook("VHRT", "Rut")
	CurrentBible.AddBook("VMLM", "Lamentaciones")
	CurrentBible.AddBook("VHET", "Ester")
	CurrentBible.AddBook("VHTB", "Tobías")
	CurrentBible.AddBook("VHIH", "Judit")
	CurrentBible.AddBook("VMBR", "Baruc")
	CurrentBible.AddBook("VSSP", "Sabiduría")
	CurrentBible.AddBook("VSEI", "Sirácida")
	CurrentBible.AddBook("VSPS", "Salmos")
	CurrentBible.AddBook("NEMT", "Mateo")
	CurrentBible.AddBook("NEMC", "Marcos")
	CurrentBible.AddBook("NELC", "Lucas")
	CurrentBible.AddBook("NEIO", "Juan")
	CurrentBible.AddBook("NTAA", "Hechos")
	CurrentBible.AddBook("NPRM", "Romanos")
	CurrentBible.AddBook("NP1C", "1 Corintios")
	CurrentBible.AddBook("NP2C", "2 Corintios")
	CurrentBible.AddBook("NPGA", "Gálatas")
	CurrentBible.AddBook("NPEP", "Efesios")
	CurrentBible.AddBook("NPPP", "Filipenses")
	CurrentBible.AddBook("NPCL", "Colosenses")
	CurrentBible.AddBook("NPPM", "Filemón")
	CurrentBible.AddBook("NP1E", "1 Tesalonicenses")
	CurrentBible.AddBook("NP2E", "2 Tesalonicenses")
	CurrentBible.AddBook("NP1I", "1 Timoteo")
	CurrentBible.AddBook("NP2I", "2 Timoteo")
	CurrentBible.AddBook("NPTT", "Tito")
	CurrentBible.AddBook("NTHB", "Hebreos")
	CurrentBible.AddBook("NCIB", "Santiago")
	CurrentBible.AddBook("NC1P", "1 Pedro")
	CurrentBible.AddBook("NC2P", "2 Pedro")
	CurrentBible.AddBook("NCID", "Judas")
	CurrentBible.AddBook("NC1I", "1 Juan")
	CurrentBible.AddBook("NC2I", "2 Juan")
	CurrentBible.AddBook("NC3I", "3 Juan")
	CurrentBible.AddBook("NTAI", "Apocalipsis")
}

func ES_LSB_LoadBooks(CurrentBible *Bible) {
	for x := range CurrentBible.Codes {
		var cb *Book = NewBook(CurrentBible.Codes[x], CurrentBible.Names[x])
		switch CurrentBible.Codes[x] {
		case "VPGN":
			ES_LSB_LoadVPGNChapters(cb)
		case "VPEX":
			ES_LSB_LoadVPEXChapters(cb)
		case "VPLV":
			ES_LSB_LoadVPLVChapters(cb)
		case "VPNM":
			ES_LSB_LoadVPNMChapters(cb)
		case "VPDT":
			ES_LSB_LoadVPDTChapters(cb)
		case "VHIE":
			ES_LSB_LoadVHIEChapters(cb)
		case "VHID":
			ES_LSB_LoadVHIDChapters(cb)
		case "VH1S":
			ES_LSB_LoadVH1SChapters(cb)
		case "VH2S":
			ES_LSB_LoadVH2SChapters(cb)
		case "VH1R":
			ES_LSB_LoadVH1RChapters(cb)
		case "VH2R":
			ES_LSB_LoadVH2RChapters(cb)
		case "VH1P":
			ES_LSB_LoadVH1PChapters(cb)
		case "VH2P":
			ES_LSB_LoadVH2PChapters(cb)
		case "VHED":
			ES_LSB_LoadVHEDChapters(cb)
		case "VHNH":
			ES_LSB_LoadVHNHChapters(cb)
		case "VH1M":
			ES_LSB_LoadVH1MChapters(cb)
		case "VH2M":
			ES_LSB_LoadVH2MChapters(cb)
		case "VMIS":
			ES_LSB_LoadVMISChapters(cb)
		case "VMIE":
			ES_LSB_LoadVMIEChapters(cb)
		case "VMEZ":
			ES_LSB_LoadVMEZChapters(cb)
		case "VNOS":
			ES_LSB_LoadVNOSChapters(cb)
		case "VNIL":
			ES_LSB_LoadVNILChapters(cb)
		case "VNAM":
			ES_LSB_LoadVNAMChapters(cb)
		case "VNAB":
			ES_LSB_LoadVNABChapters(cb)
		case "VNIN":
			ES_LSB_LoadVNINChapters(cb)
		case "VNMI":
			ES_LSB_LoadVNMIChapters(cb)
		case "VNNH":
			ES_LSB_LoadVNNHChapters(cb)
		case "VNHA":
			ES_LSB_LoadVNHAChapters(cb)
		case "VNSO":
			ES_LSB_LoadVNSOChapters(cb)
		case "VNAG":
			ES_LSB_LoadVNAGChapters(cb)
		case "VNZA":
			ES_LSB_LoadVNZAChapters(cb)
		case "VNML":
			ES_LSB_LoadVNMLChapters(cb)
		case "VMDN":
			ES_LSB_LoadVMDNChapters(cb)
		case "VSIB":
			ES_LSB_LoadVSIBChapters(cb)
		case "VSPR":
			ES_LSB_LoadVSPRChapters(cb)
		case "VSEE":
			ES_LSB_LoadVSEEChapters(cb)
		case "VSCC":
			ES_LSB_LoadVSCCChapters(cb)
		case "VHRT":
			ES_LSB_LoadVHRTChapters(cb)
		case "VMLM":
			ES_LSB_LoadVMLMChapters(cb)
		case "VHET":
			ES_LSB_LoadVHETChapters(cb)
		case "VHTB":
			ES_LSB_LoadVHTBChapters(cb)
		case "VHIH":
			ES_LSB_LoadVHIHChapters(cb)
		case "VMBR":
			ES_LSB_LoadVMBRChapters(cb)
		case "VSSP":
			ES_LSB_LoadVSSPChapters(cb)
		case "VSEI":
			ES_LSB_LoadVSEIChapters(cb)
		case "VSPS":
			ES_LSB_LoadVSPSChapters(cb)
		case "NEMT":
			ES_LSB_LoadNEMTChapters(cb)
		case "NEMC":
			ES_LSB_LoadNEMCChapters(cb)
		case "NELC":
			ES_LSB_LoadNELCChapters(cb)
		case "NEIO":
			ES_LSB_LoadNEIOChapters(cb)
		case "NTAA":
			ES_LSB_LoadNTAAChapters(cb)
		case "NPRM":
			ES_LSB_LoadNPRMChapters(cb)
		case "NP1C":
			ES_LSB_LoadNP1CChapters(cb)
		case "NP2C":
			ES_LSB_LoadNP2CChapters(cb)
		case "NPGA":
			ES_LSB_LoadNPGAChapters(cb)
		case "NPEP":
			ES_LSB_LoadNPEPChapters(cb)
		case "NPPP":
			ES_LSB_LoadNPPPChapters(cb)
		case "NPCL":
			ES_LSB_LoadNPCLChapters(cb)
		case "NPPM":
			ES_LSB_LoadNPPMChapters(cb)
		case "NP1E":
			ES_LSB_LoadNP1EChapters(cb)
		case "NP2E":
			ES_LSB_LoadNP2EChapters(cb)
		case "NP1I":
			ES_LSB_LoadNP1IChapters(cb)
		case "NP2I":
			ES_LSB_LoadNP2IChapters(cb)
		case "NPTT":
			ES_LSB_LoadNPTTChapters(cb)
		case "NTHB":
			ES_LSB_LoadNTHBChapters(cb)
		case "NCIB":
			ES_LSB_LoadNCIBChapters(cb)
		case "NC1P":
			ES_LSB_LoadNC1PChapters(cb)
		case "NC2P":
			ES_LSB_LoadNC2PChapters(cb)
		case "NCID":
			ES_LSB_LoadNCIDChapters(cb)
		case "NC1I":
			ES_LSB_LoadNC1IChapters(cb)
		case "NC2I":
			ES_LSB_LoadNC2IChapters(cb)
		case "NC3I":
			ES_LSB_LoadNC3IChapters(cb)
		case "NTAI":
			ES_LSB_LoadNTAIChapters(cb)
		}
		CurrentBible.Books = append(CurrentBible.Books, *cb)
	}
}

func ES_LSB_LoadNC1IChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Lo que era desde el principio, lo que hemos oído, lo que hemos visto con nuestros propios ojos, lo que hemos contemplado, lo que han tocado nuestras manos acerca de la palabra de la vida,"
,"2":"pues la vida se ha manifestado, la hemos visto, damos testimonio de ella y os anunciamos la vida eterna, que estaba junto al Padre y se nos ha manifestado;"
,"3":"eso que hemos visto y oído, os lo anunciamos para que estéis unidos con nosotros, como lo estamos nosotros con el Padre y con su Hijo Jesucristo."
,"4":"Os escribimos todo esto para que nuestra alegría sea completa."
,"5":"Éste es el mensaje que le hemos oído a él y os anunciamos a vosotros: Dios es luz, y en él no hay tinieblas."
,"6":"Si decimos que estamos unidos a él y andamos en tinieblas, mentimos y no practicamos la verdad;"
,"7":"pero si andamos en la luz, como él está en la luz, entonces estamos unidos unos con otros, y la sangre de Jesús, su Hijo, nos purifica de todo pecado."
,"8":"Si decimos que no tenemos pecado, nos engañamos a nosotros mismos y no decimos la verdad."
,"9":"Si confesamos nuestros pecados, Dios, que es justo y fiel, nos perdona nuestros pecados y nos purifica de toda injusticia."
,"10":"Si decimos que no hemos pecado, le hacemos mentiroso, y su palabra no está en nosotros."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Hijos míos, os escribo esto para que no pequéis. Pero si alguno peca, tenemos junto al Padre un defensor, Jesucristo, el justo."
,"2":"Él se ofrece en expiación por nuestros pecados; y no sólo por los nuestros, sino por los de todo el mundo."
,"3":"Sabemos que le conocemos en que guardamos sus mandamientos."
,"4":"El que afirma que le conoce, pero no guarda sus mandamientos, es un mentiroso y la verdad no está en él."
,"5":"Pero el que guarda su palabra, verdaderamente es perfecto en él."
,"6":"En esto sabemos que estamos unidos a él: el que afirma que está unido debe comportarse como él se comportó."
,"7":"Queridos míos, no os escribo un mandamiento nuevo, sino un mandamiento viejo, que tenéis desde el principio: el mandamiento viejo es la palabra que habéis oído."
,"8":"Es, por otra parte, también un mandamiento nuevo el que os escribo -que es verdadero en él y en vosotros-; porque se disipan las tinieblas y la luz verdadera brilla ya."
,"9":"El que afirma que está en la luz y odia a su hermano está aún en las tinieblas."
,"10":"El que ama a su hermano está en la luz, y no hay en él ocasión alguna de caída."
,"11":"Pero el que odia a su hermano está en las tinieblas, anda en las tinieblas y no sabe adónde va, porque las tinieblas le han cegado los ojos."
,"12":"Hijos míos, os escribo porque se os han perdonado los pecados por su nombre."
,"13":"Padres, os escribo porque habéis conocido al que es desde el principio. Jóvenes, os escribo porque habéis vencido al maligno."
,"14":"Niños, os escribo porque habéis conocido al Padre. Padres, os escribo porque habéis conocido al que es desde el principio. Jóvenes, os escribo porque sois fuertes, la palabra de Dios está en vosotros y habéis vencido al maligno."
,"15":"No améis al mundo ni lo que hay en él. Si alguno ama al mundo, el amor del Padre no está en él."
,"16":"Porque todo lo que hay en el mundo, las pasiones carnales, el ansia de las cosas y la arrogancia, no provienen del Padre, sino del mundo."
,"17":"El mundo pasa, y con él sus deseos insaciables; pero el que hace la voluntad de Dios vive para siempre."
,"18":"Hijos míos, estamos en la última hora, y, como habéis oído, el anticristo viene; y ahora ya han surgido muchos anticristos; por eso conocemos que es la última hora."
,"19":"Han surgido de entre nosotros, pero no eran de los nuestros; porque si hubieran sido de los nuestros, hubieran permanecido con nosotros; pero ha sucedido esto para que se manifieste que todos éstos no eran de los nuestros."
,"20":"Vosotros, sin embargo, habéis recibido la unción que viene del Santo, y todos tenéis conocimiento."
,"21":"No os he escrito porque no conozcáis la verdad, sino porque la conocéis y sabéis que ninguna mentira puede proceder de la verdad."
,"22":"Y ¿quién es el mentiroso sino el que dice que Jesús no es el Cristo? Éste es el anticristo, el que niega al Padre y al Hijo."
,"23":"El que niega al Hijo, no tiene al Padre; el que confiesa al Hijo, tiene también al Padre."
,"24":"Vosotros seguid siendo fieles a lo que habéis oído desde el principio. Así permaneceréis unidos con el Hijo y con el Padre."
,"25":"Ésta es la promesa que él mismo os ha hecho: La vida eterna."
,"26":"Os he escrito esto acerca de los que quieren seduciros."
,"27":"Pero vosotros haced que la unción que habéis recibido de él permanezca en vosotros; no tenéis necesidad de que nadie os enseñe, ya que la unción, que dice la verdad y nunca la mentira, os enseña todas las cosas; permaneced unidos a Cristo, según ella os ha enseñado."
,"28":"Ahora, hijos míos, permaneced unidos a Cristo, para que, cuando él venga, podamos sentirnos seguros y no nos avergoncemos de encontrarnos lejos de él en su venida."
,"29":"Si sabéis que él es justo, reconoced también que el que practica la justicia ha nacido de él."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Mirad qué gran amor nos ha dado el Padre al hacer que nos llamemos hijos de Dios y lo seamos de verdad. Si el mundo no nos conoce, es porque no le ha conocido a él."
,"2":"Queridos míos, desde ahora somos hijos de Dios, y aún no se ha manifestado lo que seremos. Sabemos que, cuando se manifieste, seremos semejantes a él, porque le veremos tal y como es."
,"3":"El que tiene esta esperanza en él se purifica a sí mismo, como él es puro."
,"4":"Pero el que peca se enfrenta a la ley, pues el pecado es el quebrantamiento de la ley."
,"5":"Y sabéis que él se ha manifestado para quitar los pecados, y que no hay pecado en él."
,"6":"El que permanece en él, no peca; el que peca, ni le ha visto ni le ha conocido."
,"7":"Hijos míos, que no os engañe nadie. El que practica la justicia es justo como él es justo;"
,"8":"quien peca es del diablo, porque el diablo es pecador desde el principio. El Hijo de Dios se ha manifestado para destruir las obras del diablo."
,"9":"El que ha nacido de Dios no peca, porque la semilla de Dios permanece en él; y no puede pecar porque ha nacido de Dios."
,"10":"En esto se distinguen los hijos de Dios y los hijos del diablo: el que no practica la justicia no es de Dios, ni el que no ama a su hermano."
,"11":"Porque éste es el mensaje que habéis oído desde el principio: que nos amemos los unos a los otros;"
,"12":"no como Caín, que era del maligno y mató a su hermano. Y ¿por qué lo mató? Porque sus obras eran malas, y las de su hermano justas."
,"13":"No os extrañéis si el mundo os odia."
,"14":"Nosotros sabemos que hemos pasado de la muerte a la vida porque amamos a los hermanos. El que no ama permanece en la muerte."
,"15":"El que odia a su hermano es un homicida, y vosotros sabéis que ningún homicida tiene la vida eterna en sí mismo."
,"16":"En esto hemos conocido el amor: en que él ha dado su vida por nosotros; y nosotros debemos dar también la vida por nuestros hermanos."
,"17":"Si alguno tiene bienes de este mundo, ve a su hermano en la necesidad y le cierra sus entrañas, ¿cómo puede estar en él el amor de Dios?"
,"18":"Amémonos no de palabra ni de boquilla, sino con obras y de verdad."
,"19":"En esto conoceremos que somos de la verdad y tranquilizaremos nuestra conciencia delante de él:"
,"20":"en que, si alguna vez nuestra conciencia nos acusa, Dios está por encima de nuestra conciencia y lo sabe todo."
,"21":"Queridos míos, si nuestra conciencia no nos acusa, podemos estar tranquilos ante él."
,"22":"Todo lo que pidamos, él nos lo concederá porque guardamos sus mandamientos y hacemos lo que le agrada."
,"23":"Éste es su mandamiento: que creamos en el nombre de su Hijo Jesucristo y que nos amemos los unos a los otros, según el mandamiento que nos ha dado."
,"24":"El que guarda sus mandamientos permanece en Dios, y Dios en él. Por esto conocemos que él permanece en nosotros: por el Espíritu que nos ha dado."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Queridos míos, no os fiéis de todos los que dicen que hablan en nombre de Dios; comprobadlo antes."
,"2":"En esto distinguiréis si son de Dios; el que confiesa que Jesús es el mesías hecho hombre es de Dios;"
,"3":"y el que no confiesa a Jesús no es de Dios, sino del anticristo, del cual habéis oído decir que estaba para venir y ya está en el mundo."
,"4":"Hijos míos, vosotros sois de Dios, y lo habéis vencido. Porque el que está en vosotros es más grande que el que está en el mundo."
,"5":"Ellos son del mundo, y por eso hablan según el mundo, y el mundo los escucha."
,"6":"Pero nosotros somos de Dios. El que conoce a Dios nos escucha; y el que no es de Dios no nos escucha. En esto distinguimos el espíritu de la verdad y el espíritu del error."
,"7":"Queridos míos, amémonos los unos a los otros, porque el amor es de Dios; y todo el que ama ha nacido de Dios y conoce a Dios."
,"8":"El que no ama no ha conocido a Dios, porque Dios es amor."
,"9":"En esto se ha manifestado el amor de Dios por nosotros: en que ha mandado a su Hijo único al mundo para que nosotros vivamos por él."
,"10":"En esto consiste el amor: no en que nosotros hayamos amado a Dios, sino en que Dios nos ha amado a nosotros y ha enviado a su Hijo como víctima expiatoria por nuestros pecados."
,"11":"Queridos míos, si Dios nos ha amado de este modo, también nosotros debemos amarnos los unos a los otros."
,"12":"Jamás ha visto nadie a Dios. Si nos amamos los unos a los otros, Dios está en nosotros, y su amor en nosotros es perfecto."
,"13":"Por esto conocemos que estamos con él y él en nosotros: porque él nos ha dado su Espíritu."
,"14":"Nosotros hemos visto y testificamos que el Padre ha enviado a su Hijo, el Salvador del mundo."
,"15":"Si uno confiesa que Jesús es el Hijo de Dios, Dios está en él y él en Dios."
,"16":"Nosotros hemos conocido el amor que Dios nos tiene, y hemos creído. Dios es amor; y el que está en el amor está en Dios, y Dios en él."
,"17":"En esto consiste la perfección del amor en nosotros: en que tenemos confianza absoluta en el día del juicio; porque como es él, así somos nosotros en este mundo."
,"18":"En el amor no hay temor; por el contrario, el amor perfecto desecha el temor, pues el temor supone castigo, y el que teme no es perfecto en el amor."
,"19":"Nosotros amamos porque él nos amó primero."
,"20":"Si alguno dice que ama a Dios y odia a su hermano, es un mentiroso. El que no ama a su hermano, al que ve, no puede amar a Dios, al que no ve."
,"21":"Éste es el mandamiento que hemos recibido de él: que el que ame a Dios, ame también a su hermano."
}`)
	CurrentBook.AddChapter(5, `{
"1":"El que cree que Jesús es el mesías, ha nacido de Dios; el que ama al que da el ser, ama también al que ha nacido de Dios."
,"2":"En esto conocemos que amamos a los hijos de Dios: en que amamos a Dios y guardamos sus mandamientos."
,"3":"Porque el amor de Dios consiste en guardar sus mandamientos, y sus mandamientos no son pecados."
,"4":"Porque todo lo que ha nacido de Dios vence al mundo. Y ésta es la victoria que ha vencido al mundo: nuestra fe."
,"5":"¿Quién es el que vence al mundo sino el que cree que Jesús es el Hijo de Dios?"
,"6":"Es él, Jesucristo, el que ha venido con agua y sangre; no sólo con agua, sino con agua y sangre. Y es el Espíritu el que da testimonio, porque el Espíritu es la verdad."
,"7":"Pues tres son los que dan testimonio:"
,"8":"el Espíritu, el agua y la sangre, y los tres están de acuerdo."
,"9":"Si aceptamos el testimonio de los hombres, el testimonio de Dios es más grande; pues el testimonio de Dios es que ha testificado de su Hijo."
,"10":"El que cree en el Hijo de Dios tiene en sí mismo el testimonio. El que no cree en Dios le considera mentiroso, porque no cree en el testimonio que Dios ha dado de su Hijo."
,"11":"Éste es el testimonio que Dios nos ha dado: la vida eterna, y esta vida está en su Hijo."
,"12":"El que tiene al Hijo, tiene la vida; y el que no tiene al Hijo de Dios, no tiene la vida."
,"13":"Os escribo esto para que sepáis que vosotros, que creéis en el nombre del Hijo de Dios, tenéis la vida eterna."
,"14":"Ésta es la seguridad que tenemos en Dios: que si pedimos algo según su voluntad, nos escucha."
,"15":"Y si sabemos que nos escucha en todo lo que le pedimos, sabemos también que poseemos ya lo que le hemos pedido."
,"16":"Si alguno ve a su hermano cometer un pecado que lleve a la muerte, rece por él, y Dios le dará la vida; esto lo digo para los pecados que no llevan a la muerte. Hay un pecado que lleva a la muerte; por éste no digo que recen."
,"17":"Toda injusticia es un pecado, pero hay pecados que no llevan a la muerte."
,"18":"Sabemos que el que ha nacido de Dios no peca; pero el Hijo de Dios lo guarda, y el maligno no lo toca."
,"19":"Nosotros sabemos que somos de Dios, y que todo el mundo está en poder del maligno."
,"20":"Sabemos también que el Hijo de Dios ha venido y nos ha dado inteligencia para conocer al Verdadero. Nosotros estamos en el Verdadero, en su Hijo Jesucristo. Él es el verdadero Dios y la vida eterna."
,"21":"Hijos míos, guardaos de los falsos dioses."
}`)

}
func ES_LSB_LoadNC1PChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Pedro apóstol de Jesucristo a los emigrantes esparcidos por el Ponto Galacia Capadocia Asia y Bitinia"
,"2":"elegidos por designio de Dios Padre para ser santificados por el Espíritu para obedecer a Jesucristo y ser purificados con su sangre os deseo la gracia y la paz en abundancia"
,"3":"Bendito sea Dios Padre de nuestro Señor Jesucristo que llevado de su gran misericordia nos ha hecho nacer de nuevo mediante la resurrección de Jesucristo de entre los muertos a una esperanza viva"
,"4":"a una herencia incorruptible incontaminada e imperecedera reservada en el cielo para vosotros,"
,"5":"a los que el poder divino asegura mediante la fe la salvación que ha de manifestarse en los últimos tiempos."
,"6":"Por eso estáis alegres aunque de momento os veáis obligados a sufrir diversas pruebas,"
,"7":"para que la pureza de vuestra fe mucho más preciosa que el oro que aunque acrisolado por el fuego se corrompe aparezca digna de alabanza de gloria y de honor cuando tenga lugar la manifestación de Jesucristo,"
,"8":"al que amáis y en el que creéis sin haberlo visto por el que os alegráis con un gozo inenarrable y radiante,"
,"9":"seguros de alcanzar la salvación objeto de vuestra fe."
,"10":"En esta salvación centraron sus estudios e investigaciones los profetas que anunciaron la gracia que Dios os tenía destinada."
,"11":"El Espíritu de Cristo que estaba en ellos les dio a conocer de antemano lo que Cristo tenía que sufrir y la gloria que iba a alcanzar Ellos se esforzaron por investigar cuándo y cómo se iba a realizar eso,"
,"12":"y Dios les hizo saber que lo que ellos anunciaban no era para ellos sino para vosotros esto es lo que ahora os anuncian los que predican el evangelio con el poder del Espíritu Santo enviado del cielo esto es lo que los mismos ángeles están deseando contemplar."
,"13":"Por eso, estad preparados vivid sobriamente, y poned toda vuestra esperanza en la gracia que se os dará el día de la manifestación de Jesucristo."
,"14":"Como hijos obedientes no viváis conforme a las pasiones que os tenían esclavizados en otro tiempo cuando caminabais en la ignorancia;"
,"15":"antes al contrario sed santos en toda vuestra vida como es santo el que os ha llamado,"
,"16":"pues así lo dice la Escritura Sed santos porque yo soy santo."
,"17":"Y si invocáis como Padre al que juzga imparcialmente a cada uno según sus obras comportaos respetuosamente mientras estáis de paso en este mundo."
,"18":"Sabed que habéis sido rescatados de vuestra vida estéril heredada de vuestros mayores no con bienes perecederos como el oro o la plata,"
,"19":"sino con la preciosa sangre de Cristo el cordero sin tacha ni defecto"
,"20":"predestinado desde toda la eternidad y manifestado en los últimos tiempos por amor hacia vosotros,"
,"21":"los que por él creéis en Dios, el cual habiéndole resucitado de entre los muertos y coronado de gloria viene a ser por lo mismo el objeto de vuestra fe y de vuestra esperanza."
,"22":"Purificados por la obediencia a la verdad con el fin de llegar a una fraternidad sincera amaos entrañablemente unos a otros,"
,"23":"como quienes han nacido de nuevo y no de una semilla corruptible sino incorruptible la palabra viva y eterna de Dios;"
,"24":"pues: Todo mortal es hierba,toda su gloria como flor del campo. La hierba se seca, la flor se marchita,"
,"25":"pero la palabra del Señor,permanece por siempre. Ésta es la palabra que os ha traído el evangelio"
}`)
	CurrentBook.AddChapter(2, `{
"1":"Desechad toda maldad todo engaño y toda clase de hipocresía envidia o maledicencia."
,"2":"Como niños recién nacidos apeteced la leche espiritual no adulterada, para que alimentados con ella crezcáis en orden a la salvación,"
,"3":"ya que habéis experimentado qué bueno es el Señor."
,"4":"Acercaos a él, piedra viva, rechazada por los hombres, pero escogida y apreciada por Dios;"
,"5":"disponeos como piedras vivientes, a ser edificados en casa espiritual y sacerdocio santo, para ofrecer víctimas espirituales agradables a Dios por mediación de Jesucristo;"
,"6":"pues dice la Escritura: Yo pongo en Sión una piedra angular, escogida, preciosa; el que crea en ella no será defraudado."
,"7":"Para vosotros, los creyentes, es piedra de gran valor. Para los incrédulos, en cambio, la piedra que desecharon los constructores se ha convertido en la piedra angular"
,"8":"piedra de tropiezo y roca que puede hacer caer. Tropiezan precisamente porque no quieren creer en el evangelio a eso es a lo que estaban destinados"
,"9":"Vosotros, por el contrario, sois linaje escogido, sacerdocio real, nación consagrada, pueblo de su propiedad, para anunciar las grandezas del que os ha llamado de las tinieblas a su luz maravillosa,"
,"10":"los que en un tiempo no erais pueblo de Dios, ahora habéis venido a ser pueblo suyo; habéis conseguido misericordia los que en otro tiempo estabais excluidos de ella."
,"11":"Queridos hermanos, como a gente de paso en tierra extraña, os exhorto a que os abstengáis de las pasiones carnales, que hacen la guerra al espíritu."
,"12":"Comportaos ejemplarmente en medio de los paganos, para que lo mismo que os calumnian como malhechores, al ver vuestras buenas obras glorifiquen a Dios el día que venga a visitarlos."
,"13":"Sed sumisos a toda autoridad humana por amor al Señor:"
,"14":"al emperador como a soberano, a los gobernadores como delegados suyos para castigar a los que obran mal y premiar a los que obran bien."
,"15":"Ésta es la voluntad de Dios que reduzcamos al silencio la ignorancia de los insensatos con nuestra conducta ejemplar."
,"16":"Comportaos como hombres libres, pero sin usar la libertad como pretexto para encubrir la malicia sino obrando como siervos de Dios."
,"17":"Respetad a todos amad a los hermanos reverenciad a Dios, honrad al rey."
,"18":"Esclavos, someteos con todo respeto a los amos; no sólo a los buenos y amables, sino también a los de carácter duro,"
,"19":"pues es algo hermoso soportar por amor a Dios las vejaciones injustas."
,"20":"¿Qué mérito tenéis en soportar los castigos que merecen vuestras culpas?. Pero soportar pacientemente los sufrimientos habiendo obrado bien eso agrada a Dios."
,"21":"Más aún, ésta es vuestra vocación, pues también Cristo sufrió por vosotros, y os dejó ejemplo para que sigáis sus pasos."
,"22":"Él, en quien no hubo pecado y en cuyos labios no se encontró engaño;"
,"23":"él, que, siendo ultrajado no respondía con ultrajes siendo maltratado no amenazaba sino que se ponía en manos del que juzga con justicia;"
,"24":"él que llevó en su propio cuerpo nuestros pecados sobre la cruz para que, muertos para el pecado, vivamos para la justicia: por sus heridas hemos sido curados."
,"25":"Pues erais como ovejas descarriadas, pero ahora habéis vuelto al pastor y guardián de vuestras vidas."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Vosotras mujeres, sed sumisas a vuestros maridos, para que si alguno de ellos se muestra reacio a la palabra, pueda ser ganado sin necesidad de palabras por vuestra conducta"
,"2":"al ver vuestro comportamiento respetuoso y honesto."
,"3":"Lo importante no es el adorno exterior, compuesto de peinados, joyas y vestidos,"
,"4":"sino el interior que radica en la integridad de un alma dulce y apacible; eso es lo que tiene valor ante Dios."
,"5":"Así se adornaban en otro tiempo las santas mujeres que tenían su esperanza puesta en Dios y obedecían a sus maridos;"
,"6":"ejemplo es Sara que obedeció a Abrahán, llamándole señor. Vosotras podéis ostentar el título de hijas suyas si hacéis el bien sin dejaros atemorizar por nada."
,"7":"Igualmente, vosotros, maridos, comportaos sabiamente con vuestras esposas, como con un sexo más débil. Puesto que son herederas, con el mismo título que vosotros, del don de la vida sed respetuosos con ellas para que vuestras oraciones no encuentren obstáculos."
,"8":"Finalmente, vivid todos unidos en armonía. Sed compasivos, fraternales, misericordiosos, humildes,"
,"9":"no devolváis mal por mal ni injuria, por injuria sino todo lo contrario bendecid siempre pues para esto habéis sido llamados para ser herederos de la bendición."
,"10":"¿Quién es el que ama la vida y quiere vivir años felices?. Guarde del mal su lengua y sus labios de palabras mentirosas."
,"11":"Apártese del mal y haga el bien busque la paz y corra en pos de ella."
,"12":"Pues el Señor mira por los que practican la justicia y tiene los oídos atentos a sus súplicas; pero el Señor se enfrenta con los criminales"
,"13":"¿Quién podría haceros daño si os empeñaseis en hacer el bien?."
,"14":"Si, a pesar de todo, os veis obligados a padecer por la justicia ¡dichosos vosotros!. No temáis sus amenazas, ni os turbéis."
,"15":"Glorificad en vuestros corazones a Cristo, el Señor, dispuestos siempre a contestar a todo el que os pida razón de vuestra esperanza;"
,"16":"pero hacedlo con dulzura y con respeto, con la conciencia tranquila, para que los que interpretan mal vuestra vida cristiana queden avergonzados de sus mismas palabras."
,"17":"Mejor es sufrir por hacer el bien que por hacer el mal, si Dios así lo dispone."
,"18":"Pues también Cristo murió una vez por los pecados el justo por los injustos, con el fin de llevarnos a Dios. Sufrió la muerte corporal, pero fue devuelto a la vida espiritual;"
,"19":"fue a anunciar la salvación incluso a los espíritus que estaban en prisión,"
,"20":"los cuales se habían mostrado reacios a la fe en otro tiempo en los días de Noé cuando Dios esperaba con paciencia mientras se construía el arca en la cual unos pocos ocho personas se salvaron del agua;"
,"21":"agua que presagiaba el bautismo, que ahora os salva a vosotros, no mediante la purificación de la inmundicia corporal sino mediante la súplica hecha a Dios por una conciencia buena la cual recibe su eficacia de la resurrección de Jesucristo,"
,"22":"el cual una vez sometidos los ángeles las potestades y las virtudes, subió al cielo y está sentado a la diestra de Dios."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Por eso, si Cristo sufrió en su carne mortal, haceos la cuenta de que también vosotros tenéis que sufrir, el que está dispuesto a sufrir en su carne ha roto con el pecado."
,"2":"Los días restantes de su vida mortal estarán al servicio no de las pasiones humanas, sino de la voluntad de Dios."
,"3":"Ya es suficiente que hayáis empleado el tiempo pasado en vivir a lo pagano, en groserías, liviandades, desenfrenos, orgías borracheras y nefandas idolatrías."
,"4":"Extrañados ahora de que ya no os mezcláis con ellos en ese desbordamiento de inmoralidad os insultan."
,"5":"De todo darán cuenta al que está pronto para el juicio de vivos y muertos."
,"6":"Para esto se anunció el evangelio a los muertos, para que los encadenados en la carne por los hombres vivan según Dios en el espíritu."
,"7":"Se acerca el fin de todas las cosas. Sed sobrios y dedicaos a la oración."
,"8":"Ante todo amaos ardientemente unos a otros, pues el amor alcanza el perdón de todos los pecados."
,"9":"Practicad de todo corazón la hospitalidad unos con otros."
,"10":"Que cada cual ponga al servicio de los demás los dones que haya recibido como corresponde a buenos administradores de los distintos carismas de Dios;"
,"11":"el que tenga el don de la palabra, que use de él como el que comunica palabras de Dios; el que presta un servicio que lo haga como mandatario de Dios de manera que en todo sea Dios glorificado por Jesucristo al cual se debe la gloria y el poder por los siglos de los siglos. Amén."
,"12":"Queridos hermanos, no os extrañéis, como si fuera algo raro, de veros sometidos al fuego de la prueba;"
,"13":"al contrario, alegraos de participar en los sufrimientos de Cristo, para que, asimismo, os podáis alegrar gozosos el día en que se manifieste su gloria."
,"14":"Dichosos vosotros, si sois ultrajados en nombre de Cristo, pues el Espíritu de la gloria, que es el Espíritu de Dios alienta en vosotros."
,"15":"Que ninguno de vosotros tenga que sufrir por ser homicida, ladrón, malhechor o por mezclarse en asuntos ajenos"
,"16":"pero si padece por ser cristiano, no se avergüence, antes al contrario dé gracias a Dios porque lleva este nombre."
,"17":"Pues ha llegado el tiempo de comenzar el juicio de Dios por el pueblo de Dios. Y si el juicio empieza por nosotros, ¿cuál será el fin que aguarda a los que se han mostrado rebeldes al evangelio de Dios?."
,"18":"Pues si el justo se salva a duras penas, ¿adónde irán a parar el injusto y el pecador?."
,"19":"Así pues, incluso los que sufren en conformidad con la voluntad de Dios, que continúen haciendo el bien y que se pongan en manos del creador, que es fiel."
}`)
	CurrentBook.AddChapter(5, `{
"1":"A los presbíteros que hay entre vosotros los exhorto yo, presbítero también, testigo de los sufrimientos de Cristo y participante en la gloria que habrá de manifestarse en el futuro:"
,"2":"Apacentad el rebaño que Dios os ha confiado y cuidad de él no a la fuerza, sino de buena gana, como Dios quiere; no por una vil ganancia, sino con generosidad;"
,"3":"no como dictadores, sino como modelos para el rebaño."
,"4":"Y cuando aparezca el supremo pastor, recibiréis la corona imperecedera de la gloria."
,"5":"De igual manera vosotros, jóvenes, vivid sumisos a los ancianos. Revestíos todos mutuamente de humildad, como servidores unos de los otros; porque Dios se enfrenta a los soberbios, pero da su gracia a los humildes."
,"6":"Humillaos, pues bajo la poderosa mano de Dios, para que os ensalce a su debido tiempo."
,"7":"Descargad sobre él todas vuestras preocupaciones, pues él cuida de vosotros."
,"8":"¡Sed sobrios y estad en guardia!. Vuestro enemigo el diablo como león rugiente da vueltas y busca a quién devorar."
,"9":"Resistidlo firmes en la fe, sabiendo que vuestros hermanos, esparcidos por el mundo soportan los mismos sufrimientos."
,"10":"El Dios de toda gracia que os llamó en Cristo a su eterna gloria, él mismo os perfeccionará después de un breve padecer, os confirmará, os fortalecerá y os consolidará."
,"11":"A él la gloria y el poder por los siglos de los siglos. Amén."
,"12":"Por medio de Silvano, a quien tengo por un fiel hermano vuestro, os he escrito estas pocas palabras para exhortaros y aseguraros que la gracia de Dios, en la cual vosotros os mantenéis firmes, es la verdadera"
,"13":"Os saluda la iglesia de Babilonia, elegida por Dios lo mismo que vosotros y Marcos, mi hijo."
,"14":"Saludaos mutuamente con el abrazo del amor fraternal. Que la paz esté con todos los que sois de Cristo."
}`)

}
func ES_LSB_LoadNC2IChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Yo, el presbítero, a la señora elegida y a sus hijos, que amo de verdad -no sólo yo, sino también todos los que han conocido la verdad-,"
,"2":"gracias a la verdad que está y estará siempre con nosotros;"
,"3":"que la gracia, la misericordia y la paz de Dios Padre y de Jesucristo, el Hijo del Padre, estén con nosotros, junto con la verdad y el amor."
,"4":"Me he alegrado grandemente al encontrar que tus hijos caminan en la verdad, conforme al mandamiento recibido del Padre."
,"5":"Te ruego, oh señora -aunque no te escribo un mandamiento nuevo, sino el que tenemos desde el principio-, que nos amemos los unos a los otros."
,"6":"El amor consiste en que caminemos según sus mandamientos. Y este mandamiento, tal y como lo habéis recibido desde el principio, es que caminéis en el amor."
,"7":"Porque han irrumpido en el mundo muchos seductores, que no confiesan a Jesús como el mesías hecho hombre. Ése es el seductor, el anticristo."
,"8":"Estad alerta, para que no perdáis el fruto de vuestros trabajos, sino para que recibáis una recompensa plena."
,"9":"El que se sobrepasa y no permanece en la doctrina de Cristo, no tiene a Dios; pero el que permanece en la doctrina tiene al Padre y al Hijo."
,"10":"Si alguno os visita y no lleva esta doctrina, no lo recibáis en casa y no le saludéis,"
,"11":"pues el que le saluda participa de sus malas obras."
,"12":"Tengo muchas más cosas que escribiros, pero no he querido hacerlo en papel y tinta, pues espero ir pronto a veros y hablaros de viva voz, para que vuestra alegría sea completa."
,"13":"Te saludan los hijos de tu hermana elegida."
}`)

}
func ES_LSB_LoadNC2PChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Simón Pedro, siervo y apóstol de Jesucristo, a los que han alcanzado una fe no menos preciosa que la nuestra mediante la justicia de nuestro Dios y Salvador Jesucristo."
,"2":"¡La gracia y la paz abunde en vosotros mediante el conocimiento de Dios y Jesús, nuestro Señor!"
,"3":"El poder divino nos ha otorgado todo lo necesario para la vida y la piedad, dándonos a conocer al que nos ha llamado por su propia gloria y su grandeza."
,"4":"Por ellos hemos entrado en posesión de las más ricas y preciosas promesas para hacernos así partícipes de la naturaleza divina, una vez que hayamos escapado de la corrupción que hay en el mundo por causa de las pasiones."
,"5":"Por eso debéis esforzaros en añadir a vuestra fe virtud,"
,"6":"a la virtud ciencia, a la ciencia templanza, a la templanza paciencia, a la paciencia piedad,"
,"7":"a la piedad cariño fraterno, al cariño fraterno amor;"
,"8":"pues si estas virtudes se encuentran en vosotros y van en aumento, no permaneceréis ociosos y estériles en el conocimiento de nuestro Señor Jesucristo."
,"9":"Al contrario, el que carece de ellas es ciego y miope, que se ha olvidado de purificar sus antiguos pecados."
,"10":"Por consiguiente, hermanos, esforzaos más y más por asegurar vuestra vocación y elección; de esta manera no tropezaréis jamás"
,"11":"y se os abrirán de par en par las puertas del reino eterno de nuestro Señor y Salvador Jesucristo."
,"12":"Por más que ya las sepáis y estéis incluso afianzados en la presente verdad, nunca cesaré de recordaros estas cosas,"
,"13":"pues considero un deber estimularos con mis exhortaciones mientras habito en esta tienda de campaña,"
,"14":"que pronto abandonaré, según me ha manifestado nuestro Señor Jesucristo."
,"15":"Pero me esforzaré para que en todo tiempo, después de mi partida, podáis tener presentes estas cosas."
,"16":"Porque no os hemos dado a conocer el poder y la venida de nuestro Señor Jesucristo basados en fábulas hábilmente imaginadas, sino como testigos oculares de su majestad."
,"17":"Él recibió de Dios Padre el honor y la gloria cuando desde la excelsa gloria se le hizo llegar esta voz: Éste es mi Hijo querido, mi predilecto."
,"18":"Esta voz bajada del cielo la oímos nosotros cuando estábamos con él en el monte santo,"
,"19":"con lo cual nos confirmamos más aún en la palabra de los profetas. Por tanto, vosotros mismos hacéis bien en poner en ella vuestra atención, como en lámpara que luce en lugar tenebroso hasta que alboree el día y el lucero de la mañana despunte en vuestros corazones."
,"20":"Ante todo sabed que ninguna profecía de la Escritura es objeto de interpretación personal,"
,"21":"pues los profetas nunca hablaron por su propia cuenta, sino que hablaron de parte de Dios movidos por el Espíritu Santo."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Como hubo falsos profetas en el pueblo, también habrá entre vosotros falsos maestros, los cuales enseñarán doctrinas de perdición, negarán al Señor que los redimió y se buscarán una ruina fulminante."
,"2":"Muchos los seguirán en sus desvergüenzas, y por su causa será maldecido el camino de la verdad."
,"3":"Llevados de la avaricia, os explotarán con palabras llenas de falsedad; hace mucho tiempo que la condenación los amenaza y su ruina no duerme."
,"4":"Dios no perdonó a los ángeles pecadores, sino que los arrojó al infierno, y los encerró en las prisiones tenebrosas en espera del juicio;"
,"5":"no perdonó al mundo antiguo, sino que, reservándose sólo ocho personas, entre las cuales Noé, como heraldo de justicia, desencadenó el diluvio sobre el mundo de los que practicaban la injusticia;"
,"6":"condenó a la destrucción y redujo a cenizas las ciudades de Sodoma y Gomorra para que sirviesen de ejemplo a todos los que en el futuro practicaran la injusticia,"
,"7":"y libró al justo Lot, entristecido ante la conducta lujuriosa de aquellos hombres desenfrenados ("
,"8":"ya que, viéndose obligado a habitar en medio de ellos, este justo sentía torturada su alma inocente día tras día a causa de las obras perversas que veía y oía...)."
,"9":"El Señor sabe librar a los piadosos de la tentación y reservar a los criminales para ser castigados el día del juicio,"
,"10":"especialmente los que siguen los deseos impuros de la carne y desprecian la autoridad del Señor. Atrevidos y arrogantes, no tienen miedo en blasfemar contra los seres gloriosos,"
,"11":"cuando los mismos ángeles, aun siendo superiores en fuerza y en poder, no se atreven a pronunciar contra ellos ninguna injuria en presencia del Señor."
,"12":"Estos hombres son como animales irracionales, destinados por ley natural a ser cazados y a morir; hablan mal contra las cosas que no conocen, y morirán como los animales;"
,"13":"ése será el pago merecido por su injusticia; encuentran su felicidad en el placer de un día; hombres corrompidos e inmundos, se gozan en sus engaños mientras banquetean con vosotros;"
,"14":"tienen sus ojos llenos de adulterio y no se hartan de pecar; seducen a los inestables; tienen el corazón habituado a la avaricia, son gente maldita."
,"15":"Abandonaron el buen camino, se extraviaron y siguieron el ejemplo de Balaán, hijo de Beor, que habiendo buscado el salario de la injusticia,"
,"16":"encontró la reprensión de su falta de honradez cuando una muda bestia de carga habló con voz humana y frenó la insensatez del profeta."
,"17":"Éstos son fuentes sin agua, nubes azotadas por el viento, a quienes les aguardan densas tinieblas."
,"18":"Con sus discursos pomposos y vacíos despiertan los deseos carnales y el desenfreno de aquellos que apenas habían logrado escapar de los que viven en el error."
,"19":"Les prometen la libertad, mientras ellos son esclavos de la corrupción, puesto que somos esclavos de aquel que nos ha dominado."
,"20":"En efecto, si después de haber escapado de la corrupción del mundo mediante el conocimiento del Señor y Salvador Jesucristo se dejan de nuevo envolver y vencer por ellas, su estado final viene a ser peor que el primero."
,"21":"Mejor les hubiera sido no haber conocido el camino de la justicia que, después de haberlo conocido, apartarse del mandamiento santo que se les había transmitido."
,"22":"Se cumple en ellos la verdad de aquel dicho: El perro vuelve a comer lo que había vomitado y la cerda lavada vuelve a revolcarse en el cieno."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Queridos hermanos, ésta es la segunda carta que os escribo. En las dos, mi propósito es el mismo: conseguir, con mis consejos, que penséis rectamente."
,"2":"Recordad las palabras que os anunciaron los santos profetas, y el mandamiento del Señor y Salvador transmitido por vuestros apóstoles."
,"3":"Sabed ante todo que en los últimos días aparecerán charlatanes dominados por sus propias pasiones, que, burlándose de todo,"
,"4":"preguntarán: ¿En qué ha venido a quedar la promesa de que Cristo volvería? Nuestros padres han muerto y nada ha cambiado, todo sigue igual desde que el mundo es mundo."
,"5":"Intencionadamente quieren desconocer cómo desde el principio existían los cielos y la tierra; que, por la palabra de Dios, la tierra surgió del agua y se consolidó en medio del agua."
,"6":"Aquel mundo pereció hundido en las aguas del diluvio."
,"7":"En cambio, la misma palabra de Dios tiene reservados y guardados los cielos y la tierra actuales para el día del juicio y de la perdición de los malhechores."
,"8":"Queridos hermanos, no debéis olvidar una cosa: que un día es ante Dios como mil años, y mil años como un día."
,"9":"El Señor no retarda el cumplimiento de la promesa, como creen algunos que le acusan de tardanza, sino que usa de paciencia con vosotros, pues no quiere que nadie perezca, sino que todos alcancen el arrepentimiento."
,"10":"El día del Señor vendrá como ladrón: los cielos se desintegrarán entonces con gran estrépito, los elementos del mundo quedarán hechos ceniza y la tierra con todo cuanto hay en ella desaparecerá."
,"11":"Si todo ha de desaparecer de esta manera, no hace falta decir que debéis llevar una vida santa y religiosa"
,"12":"mientras esperáis y aceleráis la venida del día de Dios, cuando los cielos incendiados se desintegrarán y los elementos quedarán hechos ceniza."
,"13":"Pero, según su promesa, nosotros esperamos unos cielos nuevos y una tierra nueva, en los que reinará la justicia."
,"14":"Por lo cual, queridos hermanos, en espera de todas estas cosas, esforzaos por encontraros sin mancha, sin culpa y en paz en presencia del Señor."
,"15":"Tened en cuenta que la paciencia de nuestro Señor es nuestra salvación, como ya os lo escribió nuestro queridísimo hermano Pablo, con la sabiduría que Dios le ha dado;"
,"16":"de hecho, así se expresa en todas las cartas cuando trata de este tema. Es cierto que en éstas se encuentran algunos puntos difíciles, que los ignorantes e inestables tergiversan para su propia perdición, lo mismo que hacen con el resto de la Sagrada Escritura."
,"17":"Vosotros, sin embargo, queridísimos hermanos, avisados de antemano, estad en guardia, no sea que, arrastrados por el error de los libertinos, decaigáis de vuestra firmeza;"
,"18":"creced más bien en la gracia y en el conocimiento de nuestro Señor y Salvador Jesucristo. ¡A él la gloria ahora y hasta el día de la eternidad!"
}`)

}
func ES_LSB_LoadNC3IChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Yo, el presbítero, al queridísimo Gayo, a quien quiero de verdad."
,"2":"Queridísimo, deseo que prosperen todas tus cosas y que tu salud corporal sea tan buena como la espiritual."
,"3":"Me he alegrado mucho cuando han llegado los hermanos y han testificado que te mantienes firme en la verdad."
,"4":"Mi mayor alegría está en oír que mis hijos caminan en la verdad."
,"5":"Queridísimo, obras fielmente en todo lo que haces por los hermanos, aunque sean extranjeros;"
,"6":"ellos han dado público testimonio de tu amor ante la Iglesia. Harás muy bien en darles todo lo que necesiten para el viaje, como Dios se merece."
,"7":"Porque se pusieron en viaje por amor a Cristo, sin recibir nada de los paganos."
,"8":"Es nuestro deber acoger a estos hombres, para ser así cooperadores de la verdad."
,"9":"He escrito algo a la Iglesia; pero Diotrefes, con su ambición de dominarlo todo, no me hace caso."
,"10":"Por eso, si llego a ir, no dejaré de recordarle su conducta, pues anda diciendo desvergonzadamente cosas falsas contra mí. No contento con esto, no recibe a los hermanos y reprende y echa de la comunidad a los que quieren recibirlos."
,"11":"Queridísimo, no imites el mal, sino el bien. El que hace el bien ha nacido de Dios; el que hace el mal, no ha visto a Dios."
,"12":"En cuanto a Demetrio, todo el mundo da testimonio de él, aun la misma verdad. Nosotros mismos damos testimonio de él, y tú sabes que nuestro testimonio es verdadero."
,"13":"Tengo muchas cosas que decirte, pero no quiero hacerlo con tinta y pluma."
,"14":"Espero verte pronto, y hablaremos de viva voz."
,"15":"Que la paz esté contigo. Te saludan tus amigos. Saluda a los amigos uno por uno."
}`)

}
func ES_LSB_LoadNCIBChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Santiago, siervo de Dios y de Jesucristo el Señor, a las doce tribus dispersas por el mundo, salud."
,"2":"Hermanos míos, tened como suprema alegría las diversas pruebas a que podéis ser sometidos,"
,"3":"sabiendo que la fe probada produce la constancia."
,"4":"Pero que la constancia vaya acompañada de obras perfectas, para que seáis perfectos, irreprochables, sin dejar nada que desear."
,"5":"Si alguno de vosotros está falto de sabiduría, que se la pida a Dios -que a todos da con generosidad y sin echarlo en cara-, y le será concedida."
,"6":"Pero que pida con confianza, sin dudar nada; porque el que duda es semejante a las olas del mar, agitadas por el viento y llevadas de una parte a otra."
,"7":"Un hombre así no piense recibir nada del Señor:"
,"8":"es un hombre indeciso, inconstante en todos sus caminos."
,"9":"Que el hermano de humilde condición se sienta orgulloso de su alta dignidad,"
,"10":"y el rico de su humillación, porque pasará como la flor del heno."
,"11":"El sol ardiente se levanta y seca el heno, se marchita la flor y desaparece su belleza; así se marchitará el rico en sus empresas;"
,"12":"dichoso el hombre que soporta la prueba; porque si la ha superado, recibirá la corona de la vida que Dios ha prometido a los que le aman."
,"13":"Nadie diga en la tentación que es tentado por Dios. Porque Dios ni puede ser tentado al mal ni tienta a nadie,"
,"14":"sino que cada uno es tentado por su propio deseo, que lo atrae y lo seduce."
,"15":"Después su propio deseo, una vez consentido, engendra el pecado; y el pecado, una vez cometido, produce la muerte."
,"16":"No os engañéis, mis queridos hermanos."
,"17":"Todo don excelente y todo don perfecto viene de lo alto, del Padre de las luces, en el que no hay cambio ni sombra de variación."
,"18":"Él nos ha engendrado según su voluntad por la palabra de la verdad, para que seamos como las primicias de sus criaturas."
,"19":"Mis queridos hermanos, sabed que todo hombre debe ser pronto para escuchar, pero lento para hablar y para airarse;"
,"20":"porque el hombre airado no practica la justicia de Dios."
,"21":"Por eso, alejad de vosotros todo vicio y toda manifestación de malicia, y recibid con docilidad la palabra que ha sido plantada en vosotros y que puede salvaros."
,"22":"Cumplid la palabra y no os contentéis sólo con escucharla, engañándoos a vosotros mismos."
,"23":"Porque si uno escucha la palabra y no la practica, es semejante a un hombre que mira su cara en un espejo"
,"24":"y, después de haberla visto, se olvida en seguida de cómo era."
,"25":"Pero el que considera atentamente la ley perfecta de la libertad y persevera en ella, no como un oyente olvidadizo, sino como un activo cumplidor, será dichoso en practicarla."
,"26":"El que cree que es religioso, pero no refrena su lengua, se engaña a sí mismo y su religiosidad no vale para nada."
,"27":"La práctica religiosa pura y sin mancha delante de Dios, nuestro Padre, consiste en visitar a los huérfanos y a las viudas en sus tribulaciones y en guardarse de los vicios del mundo."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Hermanos míos, no mezcléis con favoritismos la fe de nuestro Señor Jesucristo glorificado."
,"2":"Si entra en vuestra asamblea un hombre con anillo de oro y vestido elegantemente, y entra también un pobre con vestido miserable,"
,"3":"y vosotros volvéis vuestra mirada al que viste elegantemente y le decís: Tú, siéntate aquí, en el puesto de honor, y al pobre: Tú estáte de pie o siéntate aquí, a mis pies,"
,"4":"¿no hacéis así distinción entre vosotros mismos, y no juzgáis con pensamientos perversos?"
,"5":"Mis queridos hermanos, escuchad. ¿No ha elegido Dios a los pobres según el mundo para ser ricos en la fe y herederos del reino que ha prometido a los que le aman?"
,"6":"Pero vosotros despreciáis al pobre. ¿No son los ricos los que os oprimen y los que os arrastran a los tribunales?"
,"7":"¿No son ellos los que blasfeman el hermoso nombre que ha sido invocado sobre vosotros?"
,"8":"Si cumplís la ley regia de la Escritura que dice: Amarás a tu prójimo como a ti mismo, hacéis bien."
,"9":"Pero si tenéis favoritismos, cometéis un pecado, y la ley os condena como transgresores."
,"10":"Porque el que guarda toda la ley, pero peca aunque sólo sea contra un mandamiento, se hace culpable de todos."
,"11":"Pues el que ha dicho: No cometerás adulterio, ha dicho también: No matarás. Porque si no cometes adulterio y matas, te haces transgresor de la ley."
,"12":"Hablad y obrad como quien debe ser juzgado por una ley de libertad."
,"13":"Porque el juicio será sin misericordia para el que no ha tenido misericordia; pero la misericordia triunfa sobre el juicio."
,"14":"Hermanos, ¿de qué le sirve a uno decir que tiene fe si no tiene obras?"
,"15":"Si un hermano o una hermana están desnudos y les falta el alimento cotidiano,"
,"16":"y uno de vosotros les dice: 'Id en paz, calentaos y alimentaos', sin darles lo necesario para el cuerpo, ¿de qué sirve esto?"
,"17":"Lo mismo es la fe: si no tiene obras, está muerta en sí misma."
,"18":"Por el contrario, alguien dirá: 'Tú tienes la fe, y yo las obras. Muéstrame, si puedes, tu fe sin obras, y yo con mis obras te mostraré la fe'."
,"19":"¿Tú crees que hay un solo Dios? Muy bien. Los demonios lo creen también, y tiemblan."
,"20":"¿Quieres saber, oh insensato, que la fe sin obras es estéril?"
,"21":"Abrahán, nuestro Padre, ¿no fue justificado por las obras cuando ofreció a su hijo Isaac sobre el altar?"
,"22":"Tú ves que la fe cooperaba con las obras y que la fe se hizo perfecta con las obras."
,"23":"Se cumplió la Escritura, que decía: Abrahán creyó en Dios y le fue tenido como justicia y fue llamado amigo de Dios."
,"24":"Veis, pues, que el hombre es justificado por las obras, y no sólo por la fe."
,"25":"¿Y Rajab, la prostituta, no fue también justificada por las obras, al recibir a los mensajeros y hacerles partir por otro camino?"
,"26":"De la misma manera que el cuerpo sin el alma está muerto, así la fe sin las obras está muerta."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Hermanos míos, no queráis ser todos maestros, sabiendo que tendremos un juicio más severo."
,"2":"Todos faltamos de muchas maneras. Si uno no falta en las palabras, es un hombre perfecto, capaz de refrenar también todo su cuerpo."
,"3":"Metemos el freno en la boca a los caballos para que nos obedezcan y podamos así dirigir todo su cuerpo."
,"4":"De la misma manera las naves, que, aun siendo tan grandes y azotadas por vientos impetuosos, son dirigidas por un pequeño timón, según la voluntad del piloto."
,"5":"Así también la lengua es un pequeño miembro que se atreve a grandes cosas. Observad que una pequeña chispa puede incendiar un bosque inmenso."
,"6":"La lengua es también de fuego; el mundo de la injusticia. La lengua puesta en medio de nuestros miembros infecta todo nuestro cuerpo y prende fuego al curso de nuestra vida, cuando ella está incendiada con el fuego del infierno."
,"7":"Toda clase de bestias y de aves, de reptiles y de peces es domable, y ha sido de hecho domada por los hombres."
,"8":"Pero nadie ha podido domar nunca la lengua: es un azote irrefrenable, llena de veneno mortífero."
,"9":"Con ella bendecimos al Señor, nuestro Padre; y con ella maldecimos a los hombres, hechos a imagen de Dios."
,"10":"De la misma boca salen las bendiciones y las maldiciones. Pero no debe ser así, hermanos míos."
,"11":"¿Acaso una fuente echa por el mismo caño agua dulce y amarga?"
,"12":"¿Acaso, hermanos míos, la higuera puede producir aceitunas y la viña higos? El agua salada no dará jamás agua dulce."
,"13":"¿Quién es sabio y experimentado entre vosotros? Que muestre, con su buena conducta, su dulzura y su sabiduría."
,"14":"Pero si tenéis en vuestros corazones envidia amarga y espíritu de contradicción, no presumáis ni mintáis contra la verdad."
,"15":"Esta sabiduría no viene de arriba, sino que es terrena, sensual, endemoniada;"
,"16":"pues donde hay envidia y espíritu de contradicción, allí hay desorden y toda clase de obras malas."
,"17":"La sabiduría de arriba, por el contrario, es ante todo pura, pacífica, condescendiente, conciliadora, llena de misericordia y de buenos frutos, imparcial, sin hipocresía."
,"18":"El fruto de la justicia se siembra en la paz para los que obran la paz."
}`)
	CurrentBook.AddChapter(4, `{
"1":"¿De dónde vienen las luchas y los litigios entre vosotros? ¿No provienen acaso de vuestras pasiones, que luchan en vuestros miembros?"
,"2":"Ambicionáis y no tenéis, entonces matáis; envidiáis y no podéis alcanzar nada, entonces combatís y os hacéis la guerra. No tenéis porque no pedís."
,"3":"Pedís y no recibís porque pedís para malgastarlo en vuestros caprichos."
,"4":"Adúlteros, ¿no sabéis que la amistad del mundo es enemistad de Dios? El que quiere ser amigo del mundo se hace enemigo de Dios."
,"5":"¿O pensáis que en vano dice la Escritura: El Espíritu de Dios, que habita en nosotros, ama hasta con celos?"
,"6":"Pero da una gracia mayor, según dice la Escritura: Dios resiste a los soberbios, pero da la gracia a los humildes."
,"7":"Someteos, por tanto, a Dios; resistid al diablo, y huirá de vosotros;"
,"8":"acercaos a Dios, y se acercará a vosotros; lavaos las manos, pecadores, purificad vuestros corazones, gentes de alma doble, y reconoced vuestra miseria; llorad y clamad;"
,"9":"que vuestra risa se convierta en llanto y vuestra alegría en tristeza."
,"10":"Humillaos ante el Señor. Él os ensalzará."
,"11":"Hermanos, no habléis mal unos de otros. El que habla mal de su hermano o juzga a su hermano, habla mal de la ley y juzga la ley; y si juzgas la ley no eres cumplidor de la ley, sino juez."
,"12":"Uno solo es el legislador y juez, el cual puede salvar y perder; pero tú, ¿quién eres para juzgar a tu prójimo?"
,"13":"Y ahora vosotros, los que decís: 'Hoy o mañana iremos a tal ciudad, y pasaremos allí el año, negociando y ganando dinero';"
,"14":"vosotros, que no sabéis qué pasará mañana. ¿Qué es vuestra vida? Sois humo, que aparece un instante y luego se disipa."
,"15":"Debéis decir, en vez de eso: 'Si el Señor quiere, viviremos y haremos esto o lo otro'."
,"16":"En cambio, presumís de vuestras fanfarronadas. Esta clase de jactancia es mala."
,"17":"Pues el que sabe hacer el bien y no lo hace comete pecado."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Y vosotros, los ricos, llorad con fuertes gemidos por las desventuras que van a sobreveniros."
,"2":"Vuestra riqueza se ha podrido y vuestros vestidos se han apolillado."
,"3":"Vuestro oro y vuestra plata se han puesto roñosos, y su roña será un testimonio en contra vuestra y devorará vuestra carne como fuego. Atesorasteis en los últimos días."
,"4":"El jornal de los obreros que segaron vuestros campos, defraudado por vosotros, clama, y los lamentos de los segadores han llegado a los oídos del Señor todopoderoso."
,"5":"Habéis vivido sobre la tierra en delicias y placeres y habéis engordado para el día de la matanza."
,"6":"Habéis condenado y habéis asesinado al inocente sin que él os opusiera resistencia."
,"7":"Tened paciencia, hermanos, hasta la venida del Señor. Ved cómo el labrador espera el precioso fruto de la tierra, aguardando pacientemente hasta que caigan las lluvias tempranas y las tardías."
,"8":"Aguardad también vosotros pacientemente; fortaleced vuestros ánimos, porque la venida del Señor está próxima."
,"9":"Hermanos, no os quejéis unos de otros, para que no seáis condenados. Mirad que el juez está a las puertas."
,"10":"Hermanos, tomad como modelos de constancia y de paciencia a los profetas, que hablaron en nombre del Señor."
,"11":"Mirad cómo tenemos por dichosos a los que fueron pacientes. Habéis oído la paciencia de Job y habéis visto el designio del Señor, porque el Señor es compasivo y misericordioso."
,"12":"Hermanos míos, ante todo no juréis ni por el cielo ni por la tierra, ni con cualquier otro juramento, sino que vuestro 'sí' sea 'sí' y vuestro 'no', 'no', para no incurrir en condenación."
,"13":"¿Está afligido alguno de vosotros? Que rece. ¿Está alegre? Que cante."
,"14":"¿Está enfermo? Que llame a los presbíteros de la Iglesia para que recen por él y lo unjan con aceite en nombre del Señor."
,"15":"La oración hecha con fe salvará al enfermo, y el Señor lo restablecerá y le serán perdonados los pecados que haya cometido."
,"16":"Confesaos los pecados unos a otros y rezad unos por otros, para que os curéis. La oración fervorosa del justo tiene un gran poder."
,"17":"Elías era un hombre de vuestra misma condición: oró fervorosamente para que no lloviese, y no llovió sobre la tierra por tres años y seis meses."
,"18":"Oró de nuevo, y el cielo dio la lluvia y la tierra produjo su fruto."
,"19":"Hermanos míos, si alguno de vosotros se desvía de la verdad y otro le hace volver al buen camino,"
,"20":"sabed que el que hace volver a un pecador de su camino equivocado le salva de la muerte y hace desaparecer una multitud de pecados."
}`)

}
func ES_LSB_LoadNCIDChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Judas, siervo de Jesucristo, hermano de Santiago, a los elegidos y amados de Dios Padre y conservados para Jesucristo:"
,"2":"os deseo en abundancia la misericordia, la paz y el amor."
,"3":"Queridísimos, tenía un gran deseo de escribiros acerca de nuestra común salvación, y me he visto obligado a hacerlo para exhortaros a luchar por la fe, que de una vez para siempre ha sido transmitida a los creyentes."
,"4":"Porque se han infiltrado entre vosotros algunos hombres, destinados desde antiguo a caer en la condenación, gente malvada que han convertido en libertinaje la gracia de nuestro Dios y niegan a nuestro único dueño y Señor, Jesucristo."
,"5":"Quiero recordaros, aunque conozcéis perfectamente todas estas cosas, que el Señor, después de haber liberado al pueblo de la opresión de Egipto, a continuación aniquiló a los incrédulos;"
,"6":"y ha reservado en eterna prisión, en el fondo de las tinieblas, para el día del juicio final, a los ángeles que no guardaron su condición privilegiada y perdieron su propia mansión;"
,"7":"como a Sodoma y Gomorra y las ciudades circunvecinas, que, al igual que aquéllas, se dedicaron a la lujuria y la homosexualidad y quedaron como ejemplo, sujetas a la pena del fuego eterno."
,"8":"De un modo semejante, también estos, alucinados en sus delirios, manchan su cuerpo, desprecian la autoridad del Señor y blasfeman contra los seres gloriosos."
,"9":"El mismo arcángel Miguel, cuando luchaba con el demonio disputándole el cuerpo de Moisés, no se atrevió a echarle una maldición, sino que dijo: Que el Señor te reprenda."
,"10":"Pero ellos injurian aun a lo que no conocen; y lo que conocen por instinto, como los animales, sólo les sirve para su ruina."
,"11":"­Ay de ellos!, porque siguieron el camino de Caín, se precipitaron en el pecado de Bala n por ansia de dinero y perecieron en la rebelión de Coré."
,"12":"Estos son una vergüenza para vuestras comidas fraternas, comen y beben desvergonzadamente, cebándose a sí mismos. Nubes sin agua arrastradas por el viento; arboles infructuosos en el otoño, dos veces muertos, arrancados de cuajo;"
,"13":"olas bravías del mar, que arrojan la espuma de sus impurezas; estrellas errantes, a las que est reservada la oscuridad de las tinieblas por toda la eternidad."
,"14":"Ya profetizó de ellos Henoc, séptimo patriarca después de Adán, diciendo: Mirad, el Señor viene con miles y miles de ángeles"
,"15":"a entablar juicio contra todos y a condenar a todos los criminales por todos los crímenes que cometieron y por todas las blasfemias que estos pecadores pronunciaron contra él."
,"16":"Son murmuradores, descontentos, que viven conforme a sus pasiones; su boca profiere fanfarronadas, adulando a las personas con vistas a su propio interés."
,"17":"Pero vosotros, queridos míos, acordaos de las palabras que os predijeron los apóstoles de nuestro Señor Jesucristo."
,"18":"Os decían: En los últimos tiempos habrá impostores que vivirán según sus deseos malvados."
,"19":"Estos son los que provocan discordias, hombres sensuales, privados del Espíritu."
,"20":"Vosotros, en cambio, queridos, asentaos en el cimiento de vuestra santa fe, orad en el Espíritu Santo;"
,"21":"conservaos en el amor de Dios, aguardando la misericordia de nuestro Señor Jesucristo para la vida eterna."
,"22":"A los que dudan, convencedlos;"
,"23":"a unos salvadlos, arrancadlos del fuego; a otros, tenedlos compasión, pero con cuidado, aborreciendo hasta la túnica manchada por su cuerpo."
,"24":"Al único Dios, nuestro Salvador, que es poderoso para guardaros sin pecado y presentaros intachables ante su gloria con alegría,"
,"25":"gloria, majestad, soberanía y poder con Jesucristo nuestro Señor, desde siempre, ahora y por los siglos de los siglos. Amén."
}`)

}
func ES_LSB_LoadNEIOChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"En el principio existía aquel,que es la Palabra, y aquel que es la Palabra,estaba con Dios y era Dios."
,"2":"Él estaba en el principio con Dios."
,"3":"Todo fue hecho por él,y sin él nada se hizo."
,"4":"Cuanto ha sido hecho en él es vida, y la vida es la luz de los hombres;"
,"5":"la luz luce en las tinieblas,y las tinieblas no la sofocaron."
,"6":"Hubo un hombre enviado por Dios, de nombre Juan."
,"7":"Éste vino como testigo, para dar testimonio de la luz, a fin de que todos creyeran por él."
,"8":"No era él la luz, sino testigo de la luz."
,"9":"Existía la luz verdadera, que con su venida a este mundo,ilumina a todo hombre."
,"10":"Estaba en el mundo; el mundo fue hecho por él, y el mundo no lo conoció."
,"11":"Vino a los suyos, y los suyos no lo recibieron."
,"12":"A todos los que lo reciben, a los que creen en su nombre, les da el ser hijos de Dios;"
,"13":"él, que no nació ni de sangre ni de carne, ni por deseo de hombre,sino de Dios."
,"14":"Y aquel que es la Palabra,se hizo carne, y habitó entre nosotros, y nosotros vimos su gloria, gloria cual de unigénito,venido del Padre, lleno de gracia y de verdad."
,"15":"Juan daba testimonio de él,y proclamaba: 'Éste es del que yo dije: El que viene detrás de mí,ha sido antepuesto a mí, porque era antes que yo'."
,"16":"De su plenitud, en efecto, todos nosotros hemos recibido, y gracia sobre gracia."
,"17":"Porque la ley fue dada por Moisés, pero la gracia y la fidelidad,vinieron por Cristo Jesús."
,"18":"A Dios nadie lo ha visto jamás; el Hijo único, que está en el Padre, nos lo ha dado a conocer."
,"19":"Los judíos de Jerusalén enviaron sacerdotes y levitas a preguntar a Juan:"
,"20":"'Tú, ¿quién eres?'. Su testimonio fue claro y rotundo: 'Yo no soy el mesías'. Y le preguntaron:"
,"21":"'Entonces, ¿qué?; ¿eres Elías?'. Y dijo: 'No lo soy'. '¿Eres el profeta?'. Respondió: 'No'."
,"22":"Ellos insistieron: 'Pues, ¿quién eres, para llevar una respuesta a los que nos han enviado? ¿Qué dices de ti mismo?'."
,"23":"Dijo: 'Yo soy una voz que grita en el desierto: Allanad el camino del Señor' (como dijo el profeta Isaías)."
,"24":"Entre los enviados había fariseos."
,"25":"Éstos le preguntaron: 'Entonces, ¿por qué bautizas, si tú no eres el mesías, ni Elías, ni el profeta?'."
,"26":"Juan respondió: 'Yo bautizo con agua, pero en medio de vosotros está uno que no conocéis;"
,"27":"viene después de mí, pero yo no soy digno de desatar la correa de sus sandalias'."
,"28":"Estas cosas pasaron en Betania, al otro lado del Jordán, donde Juan bautizaba."
,"29":"Al día siguiente, Juan vio a Jesús que venía hacia él, y dijo: 'Éste es el cordero de Dios, que quita el pecado del mundo."
,"30":"Éste es de quien yo dije: Después de mí viene uno que es superior a mí, porque existía antes que yo."
,"31":"Yo no lo conocía; pero si yo he venido a bautizar con agua es para que él se dé a conocer a Israel'."
,"32":"Y Juan atestiguó: 'He visto al Espíritu descender del cielo en forma de paloma y posarse sobre él."
,"33":"Yo no lo conocía, pero el que me envió a bautizar con agua me dijo: Sobre el que veas descender y posarse el Espíritu, ése es el que bautiza en el Espíritu Santo."
,"34":"Yo lo he visto y doy testimonio de que éste es el hijo de Dios'."
,"35":"Al día siguiente, Juan estaba todavía allí con dos de sus discípulos;"
,"36":"vio a Jesús, que pasaba, y dijo: 'Éste es el cordero de Dios'."
,"37":"Los dos discípulos lo oyeron y se fueron con Jesús."
,"38":"Jesús se volvió y, al verlos, les dijo: '¿Qué buscáis?'. Ellos le dijeron: 'Rabí (que significa maestro), ¿dónde vives?'."
,"39":"Él les dijo: 'Venid y lo veréis'. Fueron, vieron dónde vivía y permanecieron con él aquel día. Eran como las cuatro de la tarde."
,"40":"Andrés, el hermano de Simón Pedro, era uno de los dos que había oído a Juan, y se había ido con Jesús."
,"41":"Andrés encontró a su hermano Simón y le dijo: 'Hemos encontrado al mesías' (que significa el Cristo)."
,"42":"Y se lo presentó a Jesús. Jesús le miró y dijo: 'Tú eres Simón, el hijo de Juan; tú te llamarás Cefas' (que significa piedra)."
,"43":"Al día siguiente, Jesús decidió salir para Galilea; encontró a Felipe, y le dijo: 'Sígueme'."
,"44":"Felipe era de Betsaida, patria de Andrés y de Pedro."
,"45":"Felipe encontró a Natanael y le dijo: 'Hemos encontrado a aquel de quien Moisés escribió en la ley y los profetas. Es Jesús de Nazaret, el hijo de José'."
,"46":"Natanael respondió: '¿De Nazaret puede salir algo bueno?'. Felipe contestó: 'Ven y verás'."
,"47":"Jesús vio a Natanael, que se le acercaba, y dijo de él: 'Éste es un israelita auténtico, en el que no hay engaño'."
,"48":"Natanael le dijo: '¿De qué me conoces?'. Jesús le contestó: 'Antes que Felipe te llamase, te vi yo, cuando estabas debajo de la higuera'."
,"49":"Natanael le respondió: 'Rabí, tú eres el hijo de Dios, tú eres el rey de Israel'. Jesús le contestó:"
,"50":"'¿Porque te he dicho que te vi debajo de la higuera crees? Cosas mayores que éstas verás'."
,"51":"Y añadió: 'Os aseguro que veréis el cielo abierto y a los ángeles de Dios subir y bajar sobre el hijo del hombre'."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Tres días después hubo una boda en Caná de Galilea, en la que estaba la madre de Jesús."
,"2":"Invitaron también a la boda a Jesús y a sus discípulos."
,"3":"Se terminó el vino, y la madre de Jesús le dijo: 'No tienen vino'."
,"4":"Jesús le contestó: '¿A ti y a mí qué, mujer? Mi hora todavía no ha llegado'."
,"5":"Su madre dijo a los sirvientes: 'Haced lo que él os diga'."
,"6":"Había allí seis tinajas de piedra de unos cien litros cada una para los ritos de purificación de los judíos."
,"7":"Jesús les dijo: 'Llenad de agua las tinajas'. Y las llenaron hasta arriba."
,"8":"Añadió: 'Sacad ahora y llevádselo al maestresala'. Y se lo llevaron."
,"9":"Tan pronto como el maestresala probó el agua convertida en vino (sin saber de dónde era, aunque sí lo sabían los sirvientes que habían sacado el agua), llamó al novio y le dijo:"
,"10":"'Todos sirven primero el vino mejor; y cuando se ha bebido en abundancia, el peor. Tú, en cambio, has guardado el vino mejor hasta ahora'."
,"11":"Así, en Caná de Galilea, Jesús comenzó sus milagros, manifestó su gloria y sus discípulos creyeron en él."
,"12":"Después fue a Cafarnaún con su madre, sus hermanos y sus discípulos; pero estuvieron allí sólo unos días."
,"13":"Se acercaba la pascua de los judíos. Jesús subió a Jerusalén,"
,"14":"y halló en el templo vendedores de bueyes, ovejas y palomas, y cambistas en sus puestos."
,"15":"Hizo un látigo de cuerdas y los echó a todos del templo, con las ovejas y los bueyes; esparció por el suelo las monedas de los cambistas y volcó las mesas."
,"16":"Y dijo a los vendedores de palomas: 'Quitad esto de aquí; no hagáis de la casa de mi Padre un mercado'."
,"17":"Sus discípulos se acordaron que está escrito: El celo de tu casa me devora."
,"18":"Entonces los judíos dijeron: '¿Qué señal nos das para obrar así?'."
,"19":"Jesús les respondió: 'Destruid este templo y en tres días lo levantaré'."
,"20":"Los judíos replicaron: 'Cuarenta y seis años se tardó en construir este templo, ¿y tú lo vas a levantar en tres días?'."
,"21":"Pero él hablaba del templo de su cuerpo."
,"22":"Por eso, cuando resucitó de entre los muertos, se acordaron sus discípulos de que ya lo había dicho, y creyeron en la Escritura y en la palabra de Jesús."
,"23":"Mientras estaba Jesús en Jerusalén en la fiesta de la pascua, muchos creyeron en él al ver los milagros que hacía;"
,"24":"pero Jesús no se fiaba de ellos, pues los conocía a todos."
,"25":"No necesitaba que le informasen de nadie, pues él conocía muy bien el interior del hombre."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Había entre los fariseos un hombre importante, llamado Nicodemo."
,"2":"Una noche fue a ver a Jesús y le dijo: 'Maestro, sabemos que Dios te ha enviado para enseñarnos, porque nadie puede hacer los milagros que tú haces si no está Dios con él'."
,"3":"Jesús le respondió: 'Te aseguro que el que no nace de nuevo no puede ver el reino de Dios'."
,"4":"Nicodemo le preguntó: '¿Cómo puede uno nacer de nuevo siendo viejo? ¿Es que puede volver al seno de su madre y nacer de nuevo?'."
,"5":"Jesús respondió: 'Te aseguro que el que no nace del agua y del Espíritu no puede entrar en el reino de Dios."
,"6":"Lo que nace de la carne es carne, y lo que nace del Espíritu es espíritu."
,"7":"No te extrañe que te diga: Es necesario nacer de nuevo."
,"8":"El viento sopla donde quiere; oyes su voz, pero no sabes de dónde viene y a dónde va; así es todo el que nace del Espíritu'."
,"9":"Nicodemo preguntó: '¿Cómo puede ser eso?'."
,"10":"Jesús respondió: '¿Tú eres maestro de Israel y no lo sabes?"
,"11":"Te aseguro que hablamos de lo que sabemos y atestiguamos lo que hemos visto, y, a pesar de todo, no aceptáis nuestro testimonio."
,"12":"Si os hablo de cosas terrenas y no me creéis, ¿cómo me creeríais si os hablara de cosas celestiales?"
,"13":"Nadie ha subido al cielo sino el que bajó del cielo, el hijo del hombre, que está en el cielo."
,"14":"Como levantó Moisés la serpiente en el desierto, así será levantado el hijo del hombre,"
,"15":"para que todo el que crea en él tenga vida eterna'."
,"16":"'Porque tanto amó Dios al mundo que dio a su hijo único, para que quien crea en él no perezca, sino que tenga vida eterna."
,"17":"Pues Dios no envió a su hijo al mundo para condenar al mundo, sino para que el mundo se salve por él."
,"18":"El que cree en él no será condenado; pero el que no cree ya está condenado, porque no ha creído en el hijo único de Dios."
,"19":"La causa de la condenación consiste en que la luz vino al mundo, y los hombres prefirieron las tinieblas a la luz porque sus obras eran malas."
,"20":"En efecto, el que obra mal odia la luz y no va a la luz, para que no se descubran sus obras."
,"21":"Pero el que practica la verdad va a la luz, para que se vean sus obras, que están hechas como Dios quiere'."
,"22":"Después de esto, Jesús fue con sus discípulos a la comarca de Judea; allí vivía con ellos y bautizaba."
,"23":"Juan también bautizaba en Ainón, próximo a Salín, pues allí abundaba el agua, y acudían muchos a bautizarse."
,"24":"Esto era antes de que metieran a Juan en la cárcel."
,"25":"Surgió una discusión entre los discípulos de Juan y un judío acerca de los ritos de la purificación."
,"26":"Fueron a Juan y le dijeron: 'Maestro, el que estaba contigo al otro lado del Jordán, del que tú diste testimonio, está bautizando y todos acuden a él'."
,"27":"Juan respondió: 'El hombre no puede apropiarse nada si Dios no se lo da."
,"28":"Vosotros mismos sois testigos de que dije: Yo no soy el mesías, sino que he sido enviado delante de él."
,"29":"La esposa pertenece al esposo. Pero el amigo del esposo, el que está a su lado y lo oye, se alegra mucho al oír la voz del esposo. Así que mi gozo es completo."
,"30":"Él debe crecer y yo menguar. El que viene de arriba está sobre todos."
,"31":"El que es de la tierra es terreno y habla como terreno; el que viene del cielo está sobre todos."
,"32":"Da testimonio de lo que ha visto y oído, pero nadie acepta su testimonio."
,"33":"El que lo acepta certifica que Dios dice la verdad."
,"34":"Porque el que Dios ha enviado dice las palabras de Dios, pues Dios le ha dado su espíritu sin medida."
,"35":"El Padre ama al hijo y ha puesto en sus manos todas las cosas."
,"36":"El que cree en el hijo tiene vida eterna; el que no quiere creer en el hijo no verá la vida; la ira de Dios pesa sobre él'."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Cuando supo Jesús que los fariseos conocían que él hacía y bautizaba más discípulos que Juan"
,"2":"(aunque él mismo no bautizaba, sino sus discípulos),"
,"3":"dejó Judea y salió otra vez para Galilea."
,"4":"Tenía que pasar por Samaría."
,"5":"Llegó a un pueblo llamado Sicar, junto a la heredad que Jacob dio a su hijo José."
,"6":"Allí estaba el pozo de Jacob. Jesús, cansado del camino, se sentó junto al pozo. Era cerca del mediodía."
,"7":"Llegó una mujer de Samaría a sacar agua, y Jesús le dijo: 'Dame de beber'."
,"8":"(Sus discípulos habían ido a la ciudad a comprar de comer)."
,"9":"La samaritana le dijo: '¿Cómo tú, siendo judío, me pides de beber a mí, que soy samaritana?'. (Es que los judíos no se tratan con los samaritanos)."
,"10":"Jesús contestó: 'Si conocieras el don de Dios y quién es el que te dice: Dame de beber, tú le habrías pedido a él, y él te habría dado agua viva'."
,"11":"La mujer le dijo: 'Señor, no tienes con qué sacarla y el pozo es profundo; ¿de dónde sacas esa agua viva?"
,"12":"¿Eres acaso tú más que nuestro padre Jacob, que nos dio este pozo, del cual bebió él, sus hijos y sus ganados?'."
,"13":"Jesús le respondió: 'El que bebe esta agua tendrá otra vez sed,"
,"14":"pero el que beba del agua que yo le dé no tendrá sed jamás; más aún, el agua que yo le daré será en él manantial que salta hasta la vida eterna'."
,"15":"La mujer le dijo: 'Señor, dame esa agua, para no tener sed ni venir aquí a sacarla'."
,"16":"Jesús contestó: 'Anda, llama a tu marido y vuelve aquí'."
,"17":"La mujer contestó: 'No tengo marido'. Jesús le dijo: 'Muy bien has dicho que no tienes marido."
,"18":"Porque has tenido cinco maridos, y el que ahora tienes no es marido tuyo. En esto has dicho la verdad'."
,"19":"La mujer le dijo: 'Señor, veo que tú eres profeta."
,"20":"Nuestros padres adoraron a Dios en este monte, y vosotros decís que el sitio donde se ha de adorar es Jerusalén'."
,"21":"Jesús le dijo: 'Créeme, mujer: se acerca la hora en que ni en este monte ni en Jerusalén adoraréis al Padre."
,"22":"Vosotros adoráis lo que no conocéis; nosotros adoramos lo que conocemos, porque la salvación viene de los judíos."
,"23":"Pero llega la hora, y en ella estamos, en que los verdaderos adoradores adorarán al Padre en espíritu y en verdad. Porque así son los adoradores que el Padre quiere."
,"24":"Dios es espíritu, y sus adoradores han de adorarlo en espíritu y en verdad'."
,"25":"La mujer le dijo: 'Sé que vendrá el mesías (es decir, el Cristo). Cuando él venga, nos lo aclarará todo'."
,"26":"Jesús le dijo: 'Soy yo, el que habla contigo'."
,"27":"En esto llegaron sus discípulos y se admiraron de que estuviera hablando con una mujer. Pero ninguno se atrevió a decirle qué le estaba preguntando o por qué estaba hablando con ella."
,"28":"La mujer dejó su cántaro y fue a la ciudad a decir a la gente:"
,"29":"'Venid a ver un hombre que me ha adivinado todo lo que he hecho. ¿Será acaso éste el mesías?'."
,"30":"Salieron de la ciudad y fueron adonde estaba Jesús."
,"31":"Entretanto, sus discípulos le insistían: 'Maestro, come'."
,"32":"Pero él les dijo: 'Yo tengo una comida que vosotros no conocéis'."
,"33":"Los discípulos se decían unos a otros: '¿Le habrá traído alguien de comer?'."
,"34":"Jesús les dijo: 'Mi alimento es hacer la voluntad del que me envió y completar su obra."
,"35":"¿No decís vosotros que faltan todavía cuatro meses para la siega? Pues yo os digo: Alzad los ojos y ved los campos ya dorados para la siega."
,"36":"El segador cobra el salario y recoge el fruto para la vida eterna. Así se alegra tanto el que siega como el que siembra."
,"37":"Porque en esto se cumple aquel proverbio: Uno es el que siembra y otro el que siega."
,"38":"Yo os he enviado a segar lo que no habéis trabajado. Otros han trabajado, y vosotros os habéis beneficiado de su trabajo'."
,"39":"Muchos samaritanos de aquella ciudad creyeron en él por el testimonio de la mujer, que decía: 'Me ha adivinado todo lo que he hecho'."
,"40":"Cuando llegaron los samaritanos, le rogaron que se quedara con ellos. Él se quedó allí dos días,"
,"41":"y creyeron muchos más al oírlo."
,"42":"Y decían a la mujer: 'No creemos ya por lo que tú nos has dicho; nosotros mismos lo hemos oído y estamos convencidos de que éste es de verdad el salvador del mundo'."
,"43":"Después de estos dos días salió de allí para Galilea."
,"44":"El mismo Jesús había afirmado que ningún profeta es bien considerado en su propio país."
,"45":"Cuando llegó a Galilea, los galileos, testigos oculares de todo lo que había hecho en Jerusalén durante la fiesta, lo recibieron muy bien."
,"46":"Jesús regresó a Caná de Galilea, donde él había convertido el agua en vino. Un oficial real tenía un hijo enfermo en Cafarnaún."
,"47":"Al oír que Jesús venía de Judea a Galilea, salió a su encuentro y le suplicó que fuera a curar a su hijo, que estaba moribundo."
,"48":"Jesús le dijo: 'Si no veis milagros y portentos, no creéis'."
,"49":"El oficial dijo: 'Señor, anda antes que muera mi hijito'."
,"50":"Jesús respondió: 'Vete, tu hijo vive'. El hombre creyó en la palabra de Jesús y se fue."
,"51":"Cuando iba de regreso, sus criados salieron a su encuentro y le dijeron: 'Tu hijo vive'."
,"52":"Les preguntó a qué hora había empezado a mejorar, y le dijeron: 'Ayer, a la una de la tarde, le dejó la fiebre'."
,"53":"El padre reconoció que aquélla era la hora en que Jesús le había dicho: 'Tu hijo vive'. Y creyó en él con toda su casa."
,"54":"Éste fue el segundo milagro que hizo Jesús al ir de Judea a Galilea."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Después de esto, los judíos celebraban una fiesta, y Jesús fue a Jerusalén."
,"2":"Hay en Jerusalén, junto a la puerta de las Ovejas, una piscina llamada en hebreo Bezatá, con cinco soportales."
,"3":"En estos soportales había muchos enfermos, ciegos, cojos y paralíticos. Periódicamente bajaba un ángel a la piscina y agitaba el agua y el primero que se mentía, apenas agitada el agua, quedaba curado."
,"5":"Había allí un hombre, enfermo hacía treinta y ocho años."
,"6":"Jesús lo vio echado y, sabiendo que llevaba mucho tiempo, le dijo: '¿Quieres curarte?'."
,"7":"El enfermo le respondió: 'Señor, no tengo a nadie que, al agitarse el agua, me meta en la piscina; y, en lo que yo voy, otro baja antes que yo'."
,"8":"Jesús le dijo: 'Levántate, toma tu camilla y anda'."
,"9":"En aquel mismo instante el hombre quedó curado, tomó la camilla y comenzó a andar. Aquel día era sábado."
,"10":"Los judíos dijeron al que había sido curado: 'Es sábado y no puedes llevar tu camilla'."
,"11":"Él les dijo: 'El mismo que me curó me dijo: Toma tu camilla y anda'."
,"12":"Le preguntaron: '¿Quién es el hombre que te dijo: Toma tu camilla y anda?'."
,"13":"Pero él no sabía quién era, porque Jesús había desaparecido entre la mucha gente que allí había."
,"14":"Más tarde Jesús lo encontró en el templo y le dijo: 'Mira, has sido curado. No peques más, para que no te suceda algo peor'."
,"15":"Él fue y dijo a los judíos que le había curado Jesús,"
,"16":"y los judíos perseguían a Jesús porque hacía tales cosas en sábado."
,"17":"Jesús les dijo: 'Mi padre no deja de trabajar, y yo también trabajo'."
,"18":"Por eso principalmente los judíos querían matarlo; porque no sólo violaba el sábado, sino que también llamaba a Dios su propio padre, haciéndose igual a Dios."
,"19":"Jesús les dijo: 'Os aseguro que el hijo no puede hacer nada de por sí que no vea hacerlo al Padre, y lo que éste hace lo hace igualmente el hijo."
,"20":"Porque el Padre ama al hijo y le muestra todo cuanto hace; y le mostrará obras mayores que éstas, de tal manera que os quedaréis asombrados."
,"21":"Pues como el Padre resucita a los muertos y los hace revivir, así también el hijo da la vida a los que quiere."
,"22":"El Padre no juzga a nadie, sino que ha entregado al hijo toda potestad de juzgar,"
,"23":"para que todos honren al hijo como honran al Padre. El que no honra al hijo no honra al Padre que lo envió."
,"24":"Os aseguro que el que escucha mis palabras y cree en el que me ha enviado tiene vida eterna y no será condenado, sino que ha pasado de la muerte a la vida."
,"25":"Os aseguro que llega la hora, y en ella estamos, en que los muertos escucharán la voz del hijo de Dios, y los que la escuchen vivirán."
,"26":"Porque como el Padre tiene vida en sí mismo, así ha dado al hijo que tenga vida en sí mismo."
,"27":"Y le ha dado potestad de juzgar, ya que es el hijo del hombre."
,"28":"No os maravilléis de esto, pues llegará la hora en que todos los que están en los sepulcros oirán su voz"
,"29":"y saldrán; los que hicieron el bien resucitarán para la vida, y los que hicieron el mal resucitarán para la condenación."
,"30":"Yo no puedo hacer nada por mí mismo. Yo juzgo como me ordena el Padre, y mi juicio es justo porque no busco mi voluntad, sino la voluntad del que me envió."
,"31":"'Si yo testificara de mí mismo, mi testimonio no sería verdadero."
,"32":"Otro es el que testifica de mí, y sé que es verdadero el testimonio que da de mí."
,"33":"Vosotros enviasteis una embajada a Juan, y él dio testimonio de la verdad."
,"34":"Yo no necesito testimonio de ningún hombre; digo estas cosas para que vosotros os salvéis."
,"35":"Juan era la antorcha que arde y luce, y vosotros quisisteis recrearos con su luz por un momento."
,"36":"Pero yo tengo un testimonio mayor que el de Juan, pues las obras que el Padre me encargó realizar, las mismas que yo hago, testifican de mí que el Padre me ha enviado."
,"37":"El Padre que me envió ha dado también testimonio de mí. No habéis oído jamás su voz, ni habéis visto su rostro,"
,"38":"ni guardáis su palabra, pues no creéis en el que él ha enviado."
,"39":"Estudiáis cuidadosamente las Escrituras, pensando encontrar en ellas la vida eterna; ellas testifican de mí."
,"40":"¡Y no queréis venir a mí para tener vida!"
,"41":"No acepto honores humanos;"
,"42":"yo sé bien que no amáis a Dios."
,"43":"Yo he venido en nombre de mi Padre, y vosotros no me aceptáis; si otro viniera en su propio nombre, a ése lo aceptaríais."
,"44":"¿Cómo podéis creer, si sólo buscáis honores los unos de los otros, y no buscáis el honor que viene del Dios único?"
,"45":"No creáis que yo os acuso ante el Padre; os acusa Moisés, en quien vosotros esperáis."
,"46":"Porque si creyeseis en Moisés, creeríais en mí, pues él escribió de mí."
,"47":"Pero si no creéis en sus escritos, ¿cómo creeréis en mis palabras?'."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Después Jesús pasó al otro lado del lago de Galilea (o Tiberíades)."
,"2":"La gente lo seguía, porque veían los prodigios que hacía con los enfermos."
,"3":"Jesús subió al monte y allí se sentó con sus discípulos."
,"4":"Estaba cerca la pascua, la fiesta de los judíos."
,"5":"Jesús alzó los ojos y, al ver tanta gente, dijo a Felipe: '¿Dónde compraremos panes para que coman todos ellos?'."
,"6":"Decía esto para probarlo, pues él sabía lo que iba a hacer."
,"7":"Felipe le contestó: 'El sueldo de un año no bastaría para que cada uno de ellos comiera un poco'."
,"8":"Entonces, uno de los discípulos, Andrés, el hermano de Simón Pedro, dijo:"
,"9":"'Aquí hay un muchacho que tiene cinco panes de cebada y dos peces. Pero, ¿qué es esto para tantos?'."
,"10":"Jesús dijo: 'Decidles que se sienten'. Había mucha hierba en aquel sitio. Eran unos cinco mil hombres."
,"11":"Jesús tomó los panes, dio gracias y los distribuyó entre todos; y lo mismo hizo con los peces. Les dio todo lo que quisieron."
,"12":"Cuando se saciaron, dijo a sus discípulos: 'Recoged los trozos sobrantes para que no se pierda nada'."
,"13":"Los recogieron, y llenaron doce canastos de las sobras de los cinco panes de cebada."
,"14":"La gente, al ver el milagro que había hecho Jesús, decía: 'Éste es el profeta que tenía que venir al mundo'."
,"15":"Y Jesús, dándose cuenta de que querían llevárselo para hacerle rey, se retiró otra vez al monte él solo."
,"16":"Al llegar la tarde, los discípulos bajaron al lago,"
,"17":"subieron a una barca y se dirigieron a la otra orilla rumbo a Cafarnaún. Había ya oscurecido, y Jesús no se había aún juntado con ellos."
,"18":"Un fuerte viento agitaba el lago."
,"19":"Habían remado como unos cinco kilómetros cuando vieron a Jesús, que caminaba sobre el mar y se acercaba a la barca; y se asustaron."
,"20":"Él les dijo: 'Soy yo, no tengáis miedo'."
,"21":"Quisieron recogerlo en la barca, y al instante la barca tocó tierra en el lugar adonde se dirigían."
,"22":"Al día siguiente la gente, que se había quedado a la otra parte del lago, notó que allí había sólo una barca y que Jesús no había subido a ella con sus discípulos, pues éstos se habían ido solos."
,"23":"Entretanto, llegaron otras barcas de Tiberíades y atracaron cerca de donde habían comido el pan después que el Señor dio gracias."
,"24":"Cuando la gente vio que no estaban allí ni Jesús ni sus discípulos, subieron a las barcas y fueron a Cafarnaún en busca de Jesús."
,"25":"Lo encontraron al otro lado del lago, y le dijeron: 'Maestro, ¿cuándo has venido aquí?'."
,"26":"Jesús les contestó: 'Os aseguro que no me buscáis porque habéis visto milagros, sino porque habéis comido pan hasta hartaros."
,"27":"Procuraos no el alimento que pasa, sino el que dura para la vida eterna; el que os da el hijo del hombre, a quien Dios Padre acreditó con su sello'."
,"28":"Le preguntaron: '¿Qué tenemos que hacer para trabajar como Dios quiere?'."
,"29":"Jesús les respondió: 'Lo que Dios quiere que hagáis es que creáis en el que él ha enviado'."
,"30":"Le replicaron: '¿Qué milagros haces tú para que los veamos y creamos en ti? ¿Cuál es tu obra?"
,"31":"Nuestros padres comieron el maná en el desierto, como está escrito: Les dio a comer pan del cielo'."
,"32":"Jesús les dijo: 'Os aseguro que no fue Moisés quien os dio el pan del cielo; mi Padre es el que os da el verdadero pan del cielo."
,"33":"Porque el pan de Dios es el que baja del cielo y da la vida al mundo'."
,"34":"Ellos le dijeron: 'Señor, danos siempre de ese pan'."
,"35":"Jesús les dijo: 'Yo soy el pan de la vida. El que viene a mí no tendrá hambre, y el que cree en mí no tendrá sed jamás."
,"36":"Pero ya os he dicho que, aunque me habéis visto, no creéis."
,"37":"Todos los que el Padre me da vendrán a mí. Al que viene a mí no lo rechazo,"
,"38":"pues he bajado del cielo no para hacer mi voluntad, sino la voluntad del que me ha enviado."
,"39":"Y ésta es la voluntad del que me ha enviado, que yo no pierda a ninguno de los que él me ha dado, sino que los resucite en el último día."
,"40":"Pues es voluntad de mi Padre que todo el que vea al hijo y crea en él tenga vida eterna y yo lo resucite en el último día'."
,"41":"Los judíos criticaban a Jesús porque había dicho: 'Yo soy el pan que ha bajado del cielo',"
,"42":"y decían: '¿No es éste Jesús, el hijo de José? Nosotros conocemos a su padre y a su madre. ¿Cómo dice ahora que ha bajado del cielo?'."
,"43":"Jesús les dijo: 'Dejad de criticar."
,"44":"Nadie puede venir a mí si el Padre que me envió no lo trae, y yo lo resucitaré en el último día."
,"45":"Está escrito en los profetas: Todos serán enseñados por Dios. Todo el que escucha al Padre y acepta su enseñanza viene a mí."
,"46":"Esto no quiere decir que alguien haya visto al Padre. Sólo ha visto al Padre el que procede de Dios."
,"47":"Os aseguro que el que cree tiene vida eterna."
,"48":"Yo soy el pan de la vida."
,"49":"Vuestros padres comieron el maná en el desierto y murieron."
,"50":"Éste es el pan que baja del cielo; el que come de él no muere'."
,"51":"'Yo soy el pan vivo bajado del cielo. El que coma de este pan vivirá eternamente; y el pan que yo daré es mi carne por la vida del mundo'."
,"52":"Los judíos discutían entre ellos: '¿Cómo puede éste darnos a comer su carne?'."
,"53":"Jesús les dijo: 'Os aseguro que si no coméis la carne del hijo del hombre y no bebéis su sangre no tendréis vida en vosotros."
,"54":"El que come mi carne y bebe mi sangre tiene vida eterna y yo lo resucitaré en el último día."
,"55":"Porque mi carne es verdadera comida y mi sangre verdadera bebida."
,"56":"El que come mi carne y bebe mi sangre vive en mí y yo en él."
,"57":"Como el Padre que me ha enviado vive y yo vivo por el Padre, así el que me come vivirá por mí."
,"58":"Éste es el pan que ha bajado del cielo; no como el que comieron los padres, y murieron. El que come este pan vivirá eternamente'."
,"59":"Dijo todo esto enseñando en la sinagoga de Cafarnaún."
,"60":"Muchos de sus discípulos, al oírlo, dijeron: 'Esto que dice es inadmisible. ¿Quién puede admitirlo?'."
,"61":"Jesús, conociendo que sus discípulos hacían esas críticas, les dijo: '¿Esto os escandaliza?"
,"62":"¡Pues si vierais al hijo del hombre subir adonde estaba antes!"
,"63":"El espíritu es el que da vida. La carne no sirve para nada. Las palabras que os he dicho son espíritu y vida."
,"64":"Pero entre vosotros hay algunos que no creen'. (Jesús ya sabía desde el principio quiénes eran los que no creían y quién lo iba a traicionar)."
,"65":"Y añadió: 'Por esto os he dicho que nadie puede venir a mí si no le es dado por el Padre'."
,"66":"Desde entonces muchos de sus discípulos se volvieron atrás y no andaban con él."
,"67":"Jesús preguntó a los doce: '¿También vosotros queréis iros?'."
,"68":"Simón Pedro le contestó: 'Señor, ¿a quién iremos? Tú tienes palabras de vida eterna."
,"69":"Nosotros creemos y sabemos que tú eres el santo de Dios'."
,"70":"Jesús le respondió: '¿No os elegí yo a los doce? Y, sin embargo, uno de vosotros es un diablo'."
,"71":"Hablaba de Judas, hijo de Simón Iscariote; pues éste lo iba a traicionar, y era uno de los doce."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Después de esto Jesús andaba por Galilea y evitaba andar por Judea, porque los judíos intentaban matarlo."
,"2":"Estaba cerca la fiesta judía de los tabernáculos."
,"3":"Sus hermanos le dijeron: 'Vete a Judea, para que también tus discípulos vean las obras que haces;"
,"4":"nadie actúa en secreto si quiere darse a conocer. Ya que haces tales cosas, date a conocer a todo el mundo'."
,"5":"Porque ni sus hermanos creían en él."
,"6":"Jesús les dijo: 'Todavía no ha llegado mi hora; sin embargo, para vosotros cualquier hora es buena."
,"7":"El mundo no os puede odiar; pero a mí me odia, porque testifico de él que sus obras son malas."
,"8":"Id vosotros a la fiesta. Yo no voy a esta fiesta, pues todavía no ha llegado mi hora'."
,"9":"Dijo esto, y se quedó en Galilea."
,"10":"En cuanto sus hermanos fueron a la fiesta, él también fue; pero no públicamente, sino en secreto."
,"11":"Los judíos lo buscaban durante la fiesta y decían: '¿Dónde está ése?'."
,"12":"Acerca de él había muchas habladurías entre la gente. Unos decían: 'Es bueno'. Otros, por el contrario, decían: 'Nada de bueno: engaña a la gente'."
,"13":"Pero nadie hablaba públicamente de él por miedo a los judíos."
,"14":"Mediada ya la fiesta, Jesús subió al templo y se puso a enseñar."
,"15":"Los judíos se quedaban sorprendidos y decían: '¿Cómo sabe tanto sin haber estudiado?'."
,"16":"Jesús les respondió: 'Esta doctrina no es mía, sino del que me ha enviado."
,"17":"El que quiera hacer la voluntad de Dios conocerá si mi doctrina es de Dios o si hablo por mi cuenta."
,"18":"El que habla por su propia cuenta busca su propio honor; pero el que busca el honor del que lo ha enviado es veraz, y en él no hay injusticia."
,"19":"¿No os ha dado Moisés la ley? Y ninguno de vosotros la cumple. ¿Por qué intentáis matarme?'."
,"20":"La gente contestó: '¡Estás endemoniado! ¿Quién intenta matarte?'."
,"21":"Jesús le contestó: 'Una obra hice, y todos estáis maravillados."
,"22":"Pues bien: Moisés os ha impuesto la circuncisión (no es que venga de Moisés, sino de los patriarcas) y vosotros circuncidáis hasta en sábado."
,"23":"Por tanto, si el hombre recibe la circuncisión en sábado y no por eso se quebranta la ley de Moisés, ¿por qué os irritáis contra mí por haber curado a un hombre en sábado?"
,"24":"No juzguéis por las apariencias, juzgad con justicia'."
,"25":"Algunos de Jerusalén decían: '¿No es éste al que intentaban matar?"
,"26":"Habla en público y nadie le dice una palabra. ¿Es que habrán reconocido los jefes que éste es verdaderamente el mesías?"
,"27":"Pero éste sabemos de dónde es; en cambio, cuando venga el mesías, nadie sabrá de dónde es'."
,"28":"Jesús, enseñando en el templo, exclamó: 'Me conocéis, sí, y sabéis de dónde soy; pero no he venido por mi propia cuenta, sino que me ha enviado el que es veraz, al que vosotros no conocéis."
,"29":"Yo lo conozco, porque procedo de él y él me ha enviado'."
,"30":"Querían prenderlo, pero nadie puso en él las manos porque su hora no había llegado todavía."
,"31":"Muchos del pueblo creyeron en él y decían: 'Cuando venga el mesías, ¿hará acaso más milagros que éste?'."
,"32":"Los fariseos oyeron lo que la gente decía de él y, de acuerdo con los sumos sacerdotes, mandaron guardias a prenderlo."
,"33":"Jesús les dijo: 'Por un poco de tiempo estaré aún con vosotros; luego volveré al que me envió."
,"34":"Me buscaréis y no me encontraréis; donde yo esté no podéis ir vosotros'."
,"35":"Los judíos comentaban: '¿A dónde irá éste, que nosotros no podamos encontrarlo? ¿Se irá tal vez con los judíos emigrados entre los griegos para anunciar su doctrina a los griegos?"
,"36":"¿Qué significa esto que dice: Me buscaréis y no me encontraréis, y: Donde yo esté no podéis ir vosotros?'."
,"37":"El último día, el más solemne de la fiesta, Jesús en pie y en voz alta dijo: 'El que tenga sed, que venga a mí;"
,"38":"el que cree en mí que beba. Lo dice la Escritura: De sus entrañas brotarán ríos de agua viva'."
,"39":"Eso lo dijo refiriéndose al Espíritu que habrían de recibir los que creyeran en él. Pues aún no había Espíritu, porque Jesús no había sido aún glorificado."
,"40":"Al escuchar estas palabras, algunos de entre la gente decían: 'Éste es verdaderamente el profeta'."
,"41":"Y otros: 'Éste es el mesías'. Otros, por el contrario: '¿Es que el mesías puede venir de Galilea?"
,"42":"¿No dice la Escritura que el mesías tiene que venir de la estirpe de David y de Belén, el pueblecito de donde era David?'."
,"43":"Así pues, acerca de él había entre la gente división de opiniones."
,"44":"Y algunos querían prenderlo, pero nadie puso las manos en él."
,"45":"Los guardias volvieron sin él. Los fariseos y los sumos sacerdotes les dijeron: '¿Por qué no lo habéis traído?'."
,"46":"Los guardias respondieron: 'Nadie habló jamás como habla este hombre'."
,"47":"Los fariseos les dijeron: '¿También vosotros os habéis dejado engañar?"
,"48":"¿Ha creído acaso en él algún jefe o algún fariseo?"
,"49":"Esa gente que no conoce la ley son unos malditos'."
,"50":"Uno de ellos, Nicodemo, que había ido a él anteriormente, les dijo:"
,"51":"'¿Es que nuestra ley permite condenar a alguien sin haberlo escuchado y sin saber qué ha hecho?'."
,"52":"Y le contestaron: '¿También tú eres de Galilea? Investiga y verás que de Galilea no puede salir ningún profeta'."
,"53":"Y cada uno se fue a su casa."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Jesús se fue al monte de los Olivos."
,"2":"Al amanecer estaba de nuevo en el templo. Todo el pueblo acudía a él; y él, sentado, les enseñaba."
,"3":"Los maestros de la ley y los fariseos le llevaron una mujer sorprendida en adulterio, la pusieron en medio y le dijeron:"
,"4":"'Maestro, esta mujer ha sido sorprendida en flagrante adulterio."
,"5":"En la ley, Moisés mandó apedrear a estas mujeres. Tú ¿qué dices?'."
,"6":"Decían esto para probarlo y tener de qué acusarlo. Pero Jesús, agachándose, se puso a escribir con el dedo en el suelo."
,"7":"Como insistían en la pregunta, se alzó y les dijo: 'El que de vosotros no tenga pecado que tire la primera piedra'."
,"8":"Y, agachándose otra vez, continuó escribiendo en el suelo."
,"9":"Al oír estas palabras, se fueron uno tras otro, comenzando por los más ancianos, y se quedó Jesús solo, con la mujer allí en medio."
,"10":"Entonces Jesús se alzó y le dijo: 'Mujer, ¿dónde están? ¿Ninguno te ha condenado?'."
,"11":"Y ella contestó: 'Ninguno, Señor'. Jesús le dijo: 'Tampoco yo te condeno. Vete, y no peques más'."
,"12":"Jesús les habló de nuevo: 'Yo soy la luz del mundo. El que me siga no andará en tinieblas, sino que tendrá la luz de la vida'."
,"13":"Los fariseos le dijeron: 'Tú das testimonio de ti mismo; tu testimonio no es válido'."
,"14":"Jesús les respondió: 'Aunque yo dé testimonio de mí mismo, mi testimonio es válido, porque si de dónde vengo y adónde voy; pero vosotros no sabéis de dónde vengo y adónde voy."
,"15":"Vosotros juzgáis con criterios mundanos; yo no juzgo a nadie."
,"16":"Y si juzgo, mi juicio es válido, porque no estoy solo, pues el Padre que me envió está conmigo."
,"17":"En vuestra ley está escrito que el testimonio coincidente de dos hombres es válido."
,"18":"Yo doy testimonio de mí mismo, y lo da también el Padre que me ha enviado'."
,"19":"Entonces le dijeron: '¿Dónde está tu Padre?'. Jesús respondió: 'Ni a mí ni a mi Padre conocéis. Si me conocierais a mí, conoceríais también a mi Padre'."
,"20":"Así habló junto al tesoro enseñando en el templo, y ninguno lo prendió porque su hora no había llegado todavía."
,"21":"En otra ocasión les dijo: 'Yo me voy. Me buscaréis, pero moriréis en vuestro pecado. Adonde yo voy no podéis ir vosotros'."
,"22":"Los judíos decían: '¿Irá a suicidarse, pues dice: Adonde yo voy, no podéis ir vosotros?'."
,"23":"Jesús continuó: 'Vosotros sois de abajo. Yo soy de arriba. Vosotros sois de este mundo. Yo no soy de este mundo."
,"24":"Os he dicho que moriréis en vuestros pecados, porque si no creyereis que 'yo soy el que soy' moriréis en vuestros pecados'."
,"25":"Y le decían: 'Y ¿tú quién eres?'. Jesús les contestó: 'Pues lo que os vengo diciendo."
,"26":"Tengo muchas cosas que decir y condenar de vosotros; pero el que me envió es veraz, y yo digo al mundo lo que le he oído a él'."
,"27":"Ellos no entendieron que les hablaba del Padre."
,"28":"Jesús les dijo: 'Cuando hayáis levantado al hijo del hombre, conoceréis que yo soy el que soy y que nada hago por mi cuenta, sino que digo lo que me enseñó el Padre."
,"29":"El que me ha enviado está conmigo y no me deja solo, porque yo hago siempre lo que le agrada a él'."
,"30":"Cuando dijo esto, muchos creyeron en él."
,"31":"Jesús dijo a los judíos que habían creído en él: 'Si os mantenéis firmes en mi doctrina, sois de veras discípulos míos,"
,"32":"conoceréis la verdad y la verdad os hará libres'."
,"33":"Ellos le dijeron: 'Somos descendientes de Abrahán y jamás hemos servido a nadie. ¿Cómo dices tú: Seréis libres?'."
,"34":"Jesús les respondió: 'Os aseguro que quien comete pecado es un esclavo."
,"35":"Y el esclavo no vive en la casa para siempre, el hijo sí."
,"36":"Por tanto, si el hijo os libera, seréis de veras libres."
,"37":"Ya sé que sois descendientes de Abrahán, pero intentáis matarme porque no os entra mi doctrina."
,"38":"Yo os digo lo que he visto junto al Padre, y vosotros hacéis lo que habéis aprendido de vuestro padre'."
,"39":"Le contestaron: 'Nuestro padre es Abrahán'. Jesús les dijo: 'Si fuerais hijos de Abrahán, haríais lo que él hizo."
,"40":"Sin embargo, tratáis de matarme a mí, que os he dicho la verdad que oí junto a Dios. Esto no lo hacía Abrahán."
,"41":"Vosotros hacéis lo que hace vuestro padre'. Le dijeron: 'Nosotros no somos hijos bastardos; tenemos un solo padre: Dios'."
,"42":"Jesús les dijo: 'Si Dios fuera vuestro Padre me amaríais, porque yo vengo de parte de Dios y aquí me tenéis; no he venido por propia cuenta, sino que me ha enviado él."
,"43":"¿Por qué no entendéis mi lenguaje? Porque no queréis aceptar mi doctrina."
,"44":"Vosotros sois hijos del diablo y queréis cumplir los deseos de vuestro padre. Él fue homicida desde el principio y no se mantuvo en la verdad, pues no hay verdad en él. Cuando dice mentira, habla según su propia naturaleza, porque es mentiroso y padre de la mentira."
,"45":"Pero a mí no me creéis porque digo la verdad."
,"46":"¿Quién de vosotros podrá acusarme con razón de que he cometido alguna falta? Si digo verdad, ¿por qué no me creéis?"
,"47":"El que es de Dios acepta las palabras de Dios. Vosotros no las aceptáis porque no sois de Dios'."
,"48":"Los judíos le replicaron: 'Con razón decimos que eres samaritano y que estás endemoniado'."
,"49":"Jesús contestó: 'Yo no estoy endemoniado; honro a mi Padre; pero vosotros me deshonráis a mí."
,"50":"Yo no busco mi honor; hay quien lo busca, y él hará justicia."
,"51":"Os aseguro que el que guarda mi palabra nunca morirá'."
,"52":"Los judíos le dijeron: 'Ahora estamos seguros de que estás endemoniado. Abrahán y los profetas murieron, y tú dices: El que guarde mi palabra nunca morirá."
,"53":"¿Es que eres tú más que nuestro padre Abrahán, que murió? Y los profetas también murieron. ¿Por quién te tienes?'."
,"54":"Jesús respondió: 'Si yo me diera a mí mismo el honor, mi honor no sería nada. Es mi Padre el que me honra; el que decís vosotros que es vuestro Dios,"
,"55":"y no lo conocéis; pero yo lo conozco. Si dijera que no lo conozco, sería un mentiroso como vosotros; pero lo conozco y guardo su palabra."
,"56":"Vuestro padre Abrahán se alegró deseando ver mi día: lo vio y se regocijó'."
,"57":"Los judíos le dijeron: 'No tienes cincuenta años, ¿y has visto a Abrahán?'."
,"58":"Jesús les dijo: 'Os aseguro que antes que naciera Abrahán existo yo'."
,"59":"Entonces agarraron piedras para tirárselas. Pero Jesús se escondió y salió del templo."
}`)
	CurrentBook.AddChapter(9, `{
"1":"De camino, vio a un hombre ciego de nacimiento."
,"2":"Sus discípulos le preguntaron: 'Maestro, ¿quién pecó, éste o sus padres, para que naciera ciego?'."
,"3":"Jesús respondió: 'Ni éste ni sus padres. Nació ciego para que resplandezca en él el poder de Dios."
,"4":"Debemos hacer las obras del que me envió mientras es de día. Cuando viene la noche nadie puede trabajar."
,"5":"Mientras estoy en el mundo, soy la luz del mundo'."
,"6":"Dicho esto, escupió en tierra e hizo lodo con la saliva, le untó con ello los ojos y le dijo:"
,"7":"'Ve a lavarte en la piscina de Siloé' (que significa enviado). Fue, se lavó y volvió con vista."
,"8":"Entonces los vecinos y los que solían verlo pidiendo limosna decían: '¿No es éste el que se sentaba a pedir?'. Unos decían: 'Es éste'."
,"9":"Y otros: 'No, es uno que se le parece'. Pero él decía: 'Soy yo'."
,"10":"Y le preguntaban: 'Pues, ¿cómo se te han abierto los ojos?'."
,"11":"Él contestó: 'Ese hombre que se llama Jesús hizo lodo, me untó con ello los ojos y me dijo: Ve a lavarte a Siloé. Fui, me lavé y vi'."
,"12":"Y le preguntaron: '¿Dónde está ése?'. Contestó: 'No lo sé'. ´"
,"13":"Llevaron a los fariseos al que antes había sido ciego,"
,"14":"pues era sábado el día en que Jesús había hecho lodo y abierto sus ojos."
,"15":"Los fariseos, a su vez, le preguntaron cómo había obtenido la vista. Él les dijo: 'Me puso lodo en los ojos, me lavé y veo'."
,"16":"Algunos fariseos dijeron: 'Ése no puede ser un hombre de Dios, pues no guarda el sábado'. Otros decían: '¿Cómo puede hacer tales milagros un hombre pecador?'. Estaban divididos."
,"17":"Preguntaron de nuevo al ciego: 'A ti te ha abierto los ojos: ¿qué piensas de él?'. Él contestó: 'Que es un profeta'."
,"18":"Los judíos no podían creer que hubiera sido ciego y ahora viese, hasta que llamaron a sus padres"
,"19":"y les preguntaron: '¿Es éste vuestro hijo, del que decís que nació ciego? ¿Cómo es que ahora ve?'."
,"20":"Los padres contestaron: 'Sabemos que éste es nuestro hijo y que nació ciego."
,"21":"Cómo ve ahora, no lo sabemos; ignoramos quién abrió sus ojos. Preguntádselo a él; ya es mayor y os puede responder'."
,"22":"Sus padres hablaron así por miedo a los judíos, que habían decidido expulsar de la sinagoga al que reconociera que Jesús era el mesías."
,"23":"Por eso los padres dijeron: 'Ya es mayor y os puede responder; preguntádselo a él'."
,"24":"Llamaron otra vez al que había sido ciego, y le dijeron: 'Di la verdad ante Dios; nosotros sabemos que este hombre es pecador'."
,"25":"Él respondió: 'No sé si es pecador o no; sólo sé que yo era ciego y ahora veo'."
,"26":"Le preguntaron: '¿Qué te hizo? ¿Cómo te abrió los ojos?'. Respondió:"
,"27":"'Ya os lo he dicho y no me habéis hecho caso. ¿Por qué queréis oírlo otra vez? ¿Queréis también vosotros haceros sus discípulos?'."
,"28":"Ellos le insultaron diciendo: 'Tú eres su discípulo; nosotros lo somos de Moisés."
,"29":"Nosotros sabemos que a Moisés le habló Dios. Pero de éste no sabemos ni de dónde es'."
,"30":"Él les contestó: 'Es curioso: Vosotros no sabéis ni de dónde es, y él me ha abierto los ojos."
,"31":"Sabemos que Dios no escucha a los pecadores, sino al que le es fiel y hace su voluntad."
,"32":"Jamás se ha oído decir que alguien haya abierto los ojos a un ciego de nacimiento."
,"33":"Si él no fuera de Dios, no podría hacer nada'."
,"34":"Le respondieron: 'Todo tú eres pecado desde que naciste, y ¿nos enseñas a nosotros?'. Y lo expulsaron de la sinagoga."
,"35":"Jesús oyó que lo habían expulsado; fue a buscarlo y le dijo: '¿Tú crees en el hijo del Hombre?'."
,"36":"Él le respondió: '¿Y quién es, Señor, para que crea en él?'."
,"37":"Jesús le dijo: 'Lo estás viendo; es el que habla contigo'."
,"38":"Respondió: 'Creo, Señor'. Y se puso de rodillas ante él."
,"39":"Jesús dijo: 'Yo he venido a este mundo para que los que no ven vean, y los que ven se queden ciegos'."
,"40":"Al oír esto, algunos fariseos que estaban con él le preguntaron: '¿Somos también nosotros ciegos?'."
,"41":"Jesús les dijo: 'Si fueseis ciegos, no tendríais culpa; pero como decís que veis, seguís en pecado'."
}`)
	CurrentBook.AddChapter(10, `{
"1":"'Os aseguro que el que no entra por la puerta en el redil de las ovejas, sino saltando por otra parte, es un ladrón y un salteador."
,"2":"Pero el que entra por la puerta es el pastor de las ovejas."
,"3":"El guarda le abre la puerta y las ovejas reconocen su voz; él llama a sus ovejas por sus nombres y las saca fuera."
,"4":"Y cuando ha sacado todas sus ovejas, va delante de ellas, y las ovejas lo siguen porque conocen su voz."
,"5":"Pero no seguirán a un extraño, sino que huirán de él, porque no conocen la voz de los extraños'."
,"6":"Jesús les puso esta semejanza, pero ellos no entendieron qué quería decir."
,"7":"Por eso Jesús se lo explicó así: 'Os aseguro que yo soy la puerta de las ovejas."
,"8":"Todos los que vinieron antes de mí eran ladrones y salteadores, pero las ovejas no les hicieron caso."
,"9":"Yo soy la puerta; el que entra por mí se salvará; entrará y saldrá y encontrará pastos."
,"10":"El ladrón sólo entra para robar, matar y destruir. Yo he venido para que tengan vida y la tengan abundante."
,"11":"'Yo soy el buen pastor. El buen pastor da su vida por las ovejas."
,"12":"Pero el asalariado, que no es el pastor ni el propietario de las ovejas, en viendo venir al lobo deja las ovejas y huye, y el lobo ataca y las dispersa,"
,"13":"porque es un asalariado y no le importan las ovejas."
,"14":"Yo soy el buen pastor, y conozco mis ovejas y ellas me conocen a mí,"
,"15":"igual que mi Padre me conoce a mí, y yo conozco al Padre; yo doy mi vida por las ovejas."
,"16":"Tengo otras ovejas que no son de este redil. También a ellas tengo que apacentarlas. Ellas escucharán mi voz, y habrá un solo rebaño y un solo pastor."
,"17":"El Padre me ama, porque yo doy mi vida para recobrarla de nuevo."
,"18":"Nadie me la quita, sino que la doy yo por mí mismo. Tengo el poder de darla y el poder de recobrarla. Tal es el mandato que he recibido de mi Padre'."
,"19":"Estas palabras causaron una nueva división entre los judíos."
,"20":"Muchos decían: 'Está endemoniado y loco. ¿A qué lo escucháis?'."
,"21":"Otros decían: 'Estas palabras no son de un endemoniado. ¿Es que un endemoniado puede abrir los ojos a los ciegos?'."
,"22":"Se celebraba en Jerusalén la fiesta de la dedicación del templo. Era invierno."
,"23":"Jesús se paseaba en el templo, por el pórtico de Salomón."
,"24":"Los judíos lo rodearon y le preguntaron: '¿Hasta cuándo nos has de tener en vilo? Si tú eres el mesías, dínoslo claramente'."
,"25":"Jesús les respondió: 'Os lo he dicho y no me habéis creído. Las obras que yo hago en nombre de mi Padre lo demuestran claramente."
,"26":"Pero vosotros no creéis, porque no sois ovejas mías."
,"27":"Mis ovejas escuchan mi voz. Yo las conozco y ellas me siguen;"
,"28":"yo les doy la vida eterna y no perecerán jamás; no me las arrebatará nadie de mis manos."
,"29":"Mi Padre, que me las ha dado, es más que todas las cosas; y nadie puede arrebatar nada de la mano de mi Padre."
,"30":"Yo y el Padre somos una sola cosa'."
,"31":"De nuevo los judíos agarraron piedras para apedrearlo."
,"32":"Jesús les replicó: 'He hecho muchas obras buenas ante vosotros de parte de mi Padre; ¿por cuál de ellas me apedreáis?'."
,"33":"Los judíos le contestaron: 'No te apedreamos por ninguna obra buena, sino por blasfemia; porque tú, siendo hombre, te haces Dios'."
,"34":"Jesús les respondió: '¿No está escrito en vuestra ley: Yo dije: sois dioses?"
,"35":"Si la ley llamó dioses a los que se dirigió la palabra de Dios, y la Escritura no puede fallar,"
,"36":"¿por qué decís que blasfemo yo, que he sido consagrado y enviado al mundo por el Padre, porque he dicho: Soy hijo de Dios?"
,"37":"Si no hago las obras de mi Padre, no me creáis;"
,"38":"pero si las hago, aunque no me creáis a mí, creed en las obras, para que sepáis y reconozcáis que el Padre está en mí y yo en el Padre'."
,"39":"Por eso intentaban prenderlo de nuevo, pero se les escapó de las manos."
,"40":"Fue nuevamente al otro lado del Jordán, al lugar donde Juan había estado al principio bautizando, y se quedó allí."
,"41":"Muchos acudieron a él y decían: 'Juan no hizo ningún milagro, pero todo lo que dijo sobre éste era verdad'."
,"42":"Y muchos creyeron en él."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Había un enfermo, Lázaro, de Betania, el pueblecito de María y de su hermana Marta."
,"2":"María era la que ungió con perfume al Señor y le enjugó los pies con sus cabellos; su hermano estaba enfermo."
,"3":"Las hermanas mandaron a decir al Señor: 'Tu amigo está enfermo'."
,"4":"Jesús, al enterarse, dijo: 'Esta enfermedad no es de muerte, sino para que resplandezca la gloria de Dios y la gloria del hijo de Dios'."
,"5":"Jesús era muy amigo de Marta, de su hermana y de Lázaro."
,"6":"Y aunque supo que estaba enfermo, se entretuvo aún dos días donde estaba."
,"7":"Sólo entonces dijo a sus discípulos: 'Vamos otra vez a Judea'."
,"8":"Los discípulos le dijeron: 'Maestro, hace poco querían apedrearte los judíos, ¿y vas a volver allí?'."
,"9":"Jesús contestó: '¿No tiene doce horas el día? Si uno anda de día, no tropieza, porque ve la luz de este mundo;"
,"10":"pero si uno anda de noche, tropieza, porque le falta la luz'."
,"11":"Dijo esto, y añadió: 'Lázaro, nuestro amigo, duerme; pero voy a despertarlo'."
,"12":"Los discípulos le dijeron: 'Señor, si duerme, se recuperará'."
,"13":"Pero Jesús hablaba de su muerte, y ellos creyeron que hablaba del reposo del sueño."
,"14":"Entonces Jesús les dijo claramente: 'Lázaro ha muerto;"
,"15":"y me alegro por vosotros de no haber estado allí, para que creáis. Vamos a verlo'."
,"16":"Entonces Tomás, llamado el Mellizo, dijo a sus compañeros: 'Vamos también nosotros a morir con él'."
,"17":"A su llegada, Jesús se encontró con que hacía cuatro días que Lázaro estaba muerto."
,"18":"Betania distaba de Jerusalén unos tres kilómetros,"
,"19":"y muchos judíos habían ido a casa de Marta y María para consolarlas."
,"20":"Así que oyó Marta que llegaba Jesús, salió a su encuentro, mientras que María se quedó en casa."
,"21":"Marta dijo a Jesús: 'Señor, si hubieras estado aquí, no habría muerto mi hermano."
,"22":"Pero yo sé que Dios te concederá todo lo que le pidas'."
,"23":"Jesús le dijo: 'Tu hermano resucitará'."
,"24":"Marta le respondió: 'Sé que resucitará cuando la resurrección, el último día'."
,"25":"Jesús le dijo: 'Yo soy la resurrección y la vida. El que cree en mí, aunque muera, vivirá."
,"26":"Y todo el que vive y cree en mí no morirá para siempre."
,"27":"¿Crees esto?'. Le contestó: 'Sí, Señor, yo creo que tú eres el mesías, el hijo de Dios que tenía que venir al mundo'."
,"28":"Dicho esto, fue a llamar a María, su hermana, y le dijo al oído: 'El Maestro está ahí y te llama'."
,"29":"Ella, así que lo oyó, se levantó rápidamente y salió al encuentro de Jesús."
,"30":"Jesús aún no había entrado en el pueblo; estaba todavía en el sitio donde lo había encontrado Marta."
,"31":"Los judíos que estaban en casa de María y la consolaban, al verla levantarse y salir tan aprisa, la siguieron, creyendo que iba al sepulcro a llorar."
,"32":"Cuando María llegó donde estaba Jesús, al verlo, se echó a sus pies, diciendo: 'Señor, si hubieras estado aquí, mi hermano no habría muerto'."
,"33":"Jesús, al verla llorar y que los judíos que la acompañaban también lloraban, se estremeció y, profundamente emocionado,"
,"34":"dijo: '¿Dónde lo habéis puesto?'. Le contestaron: 'Ven a verlo, Señor'."
,"35":"Jesús se echó a llorar,"
,"36":"por lo que los judíos decían: 'Mirad cuánto lo quería'."
,"37":"Pero algunos dijeron: 'Éste, que abrió los ojos al ciego, ¿no pudo impedir que Lázaro muriese?'."
,"38":"Jesús se estremeció profundamente otra vez al llegar al sepulcro, que era una cueva con una gran piedra puesta en la entrada."
,"39":"Jesús dijo: 'Quitad la piedra'. Marta, la hermana del difunto, le dijo: 'Señor, ya huele, pues lleva cuatro días'."
,"40":"Jesús le respondió: '¿No te he dicho que, si crees, verás la gloria de Dios?'."
,"41":"Entonces quitaron la piedra. Jesús levantó los ojos al cielo y dijo: 'Padre, te doy gracias porque me has escuchado."
,"42":"Yo bien sabía que siempre me escuchas; pero lo he dicho por la gente que me rodea, para que crean que tú me has enviado'."
,"43":"Y dicho esto, gritó muy fuerte: '¡Lázaro, sal fuera!'."
,"44":"Y el muerto salió atado de pies y manos con vendas, y envuelta la cara en un sudario. Jesús les dijo: 'Desatadlo y dejadlo andar'."
,"45":"Muchos de los judíos que habían venido a casa de María y vieron lo que hizo creyeron en él."
,"46":"Pero algunos se fueron a los fariseos y les contaron lo que había hecho Jesús."
,"47":"Los sumos sacerdotes y los fariseos convocaron el consejo y decían: '¿Qué hacemos? Este hombre hace muchos milagros."
,"48":"Si lo dejamos, creerán en él todos y vendrán los romanos y destruirán nuestro templo y nuestra nación'."
,"49":"Uno de ellos, Caifás, que era el sumo sacerdote aquel año, les dijo:"
,"50":"'Vosotros no sabéis nada; no os dais cuenta de que nos conviene que muera un solo hombre por el pueblo antes que perezca la nación entera'."
,"51":"Esto no lo dijo por propia iniciativa, sino que, como era el sumo sacerdote aquel año, profetizó que Jesús debía morir por la nación;"
,"52":"y no sólo por la nación, sino también para reunir a los hijos de Dios dispersos."
,"53":"Desde aquel momento decidieron matarlo."
,"54":"Por eso Jesús no andaba ya públicamente entre los judíos, sino que se fue a una región cerca del desierto, a una ciudad llamada Efraín, y allí se quedó con sus discípulos."
,"55":"Estaba próxima la pascua de los judíos, y muchos de la región fueron a Jerusalén antes de la pascua para celebrar los ritos de purificación."
,"56":"Buscaban a Jesús en el templo y se decían: '¿Qué os parece? ¿Vendrá a la fiesta?'."
,"57":"Los sumos sacerdotes y los fariseos habían ordenado que, si alguno sabía dónde estaba, lo denunciase para prenderlo."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Jesús, seis días antes de la pascua, fue a Betania, donde estaba Lázaro, al que había resucitado de entre los muertos."
,"2":"Allí le ofrecieron una cena. Marta servía, y Lázaro era uno de los comensales."
,"3":"María, por su parte, tomó una libra de perfume de nardo puro, de gran precio, y ungió los pies de Jesús, enjugándolos luego con sus cabellos, por lo que la casa se llenó del olor del perfume."
,"4":"Entonces dijo Judas Iscariote, uno de los discípulos, el que lo iba a entregar:"
,"5":"'¿Por qué no se ha vendido este perfume a gran precio y se ha dado a los pobres?'."
,"6":"Esto lo dijo no porque le preocuparan los pobres, sino porque era ladrón; y como tenía la bolsa, robaba de lo que había en ella."
,"7":"Jesús dijo: 'Déjala que lo haga para el día de mi sepultura."
,"8":"A los pobres siempre los tenéis con vosotros, pero a mí no me tendréis siempre'."
,"9":"Muchos judíos supieron que Jesús estaba allí y acudieron no sólo por Jesús, sino también por ver a Lázaro, al que había resucitado de entre los muertos."
,"10":"Por eso los sumos sacerdotes determinaron matar también a Lázaro,"
,"11":"pues por él muchos judíos se apartaban de ellos y creían en Jesús."
,"12":"Al día siguiente, la gente que había ido a la fiesta, al oír que Jesús venía a Jerusalén,"
,"13":"tomaron ramos de palmas y salieron a su encuentro, gritando: '¡Viva! ¡Bendito el que viene en nombre del Señor! ¡El rey de Israel!'."
,"14":"Y Jesús encontró un asno y se montó en él, según está escrito:"
,"15":"No temas, ciudad de Sión; mira, tu rey viene montado en un asno."
,"16":"Los discípulos no comprendieron estas cosas entonces; pero cuando Jesús fue glorificado, se acordaron de que habían sido escritas de él y que así habían ocurrido."
,"17":"Los que estuvieron presentes cuando llamó a Lázaro del sepulcro y lo resucitó de entre los muertos daban ahora testimonio de ello."
,"18":"Por esto también la gente le salió al encuentro, pues se habían enterado de que había hecho este milagro."
,"19":"Los fariseos se dijeron: 'Veis que no adelantamos nada. Mirad cómo todo el mundo se va tras de él'."
,"20":"Entre los que habían ido a Jerusalén para dar culto a Dios en la fiesta había algunos griegos."
,"21":"Éstos se acercaron a Felipe, el de Betsaida de Galilea, y le dijeron: 'Señor, queremos ver a Jesús'."
,"22":"Felipe se lo fue a decir a Andrés; Andrés y Felipe se lo dijeron a Jesús."
,"23":"Jesús les respondió: 'Ha llegado la hora en que va a ser glorificado el hijo del hombre."
,"24":"Os aseguro que si el grano de trigo que cae en la tierra no muere, queda infecundo; pero si muere, produce mucho fruto."
,"25":"El que ama su vida la perderá; y el que odia su vida en este mundo la conservará para la vida eterna."
,"26":"El que quiera ponerse a mi servicio, que me siga, y donde esté yo allí estará también mi servidor. A quien me sirva, mi Padre lo honrará."
,"27":"Ahora estoy profundamente angustiado. ¿Y qué voy a decir? ¿Pediré al Padre que me libre de esta hora? No, pues para esto precisamente he llegado a esta hora."
,"28":"Padre, glorifica tu nombre'. Entonces dijo una voz del cielo: 'Lo he glorificado y lo glorificaré de nuevo'."
,"29":"La gente que estaba allí y lo oyó, dijeron que había sido un trueno. Oros decían que le había hablado un ángel."
,"30":"Jesús replicó: 'Esta voz no ha venido por mí, sino por vosotros."
,"31":"Ahora es cuando va a ser juzgado este mundo; ahora el príncipe de este mundo va a ser echado fuera."
,"32":"Y yo, cuando sea levantado de la tierra, a todos los atraeré hacia mí'."
,"33":"Decía esto indicando de qué muerte iba a morir."
,"34":"La gente le dijo: 'Nosotros sabemos por la ley que el mesías permanece eternamente; ¿cómo dices tú que el hijo del hombre debe ser levantado en alto? ¿Quién es este hijo del hombre?'."
,"35":"Jesús les contestó: 'Por poco tiempo está aún la luz entre vosotros. Andad mientras tenéis luz, para que no os sorprendan las tinieblas; que quien camina en tinieblas no sabe adónde va."
,"36":"Mientras tenéis luz, creed en la luz, para ser hijos de la luz'. Dicho esto, se fue y se escondió de ellos."
,"37":"Aunque había hecho tan grandes milagros delante de ellos, no creían en él."
,"38":"Así se cumplió lo que dijo Isaías: Señor, ¿quién ha creído en nuestra doctrina? ¿A quién se ha manifestado el poder del Señor?"
,"39":"Y no podían creer, porque ya había dicho también Isaías:"
,"40":"Les has cegado sus ojos,y has embotado su mente,para que sus ojos no vean,ni su mente comprenda; así no podrán convertirse,ni yo los tendré que sanar."
,"41":"Isaías dijo esto porque vio su gloria y habló de él."
,"42":"A pesar de todo, muchos, aun de los mismos jefes, creyeron en él; pero por miedo a los fariseos no lo confesaban, para que no los expulsaran de la sinagoga,"
,"43":"pues preferían la honra que dan los hombres a la honra que da Dios."
,"44":"Jesús proclamó: 'El que cree en mí no cree en mí, sino en el que me ha enviado;"
,"45":"y el que me ve a mí ve al que me ha enviado."
,"46":"Yo he venido como luz al mundo, para que todo el que crea en mí no quede en tinieblas."
,"47":"Yo no condeno al que oye mis palabras y no las guarda, pues no he venido a condenar al mundo, sino a salvarlo."
,"48":"El que me rechaza y no acepta mi doctrina ya tiene quien lo juzgue; la doctrina que yo he enseñado lo condenará en el último día,"
,"49":"porque yo no he hablado por mi propia cuenta; el Padre que me ha enviado me ha ordenado lo que tengo que decir y enseñar,"
,"50":"y yo sé que su mandato es vida eterna. Por eso lo que yo os digo, lo digo tal y como me lo ha dicho el Padre'."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Antes de la fiesta de la pascua, sabiendo que le había llegado la hora de pasar de este mundo al Padre, Jesús, que había amado a los suyos que estaban en el mundo, los amó hasta el fin."
,"2":"Se pusieron a cenar. El diablo había metido en la cabeza a Judas Iscariote, hijo de Simón, la idea de traicionar a Jesús."
,"3":"Jesús, sabiendo que el Padre había puesto en sus manos todas las cosas, que había salido de Dios y que a Dios volvía,"
,"4":"se levantó de la mesa, se quitó el manto, tomó una toalla y se la ciñó."
,"5":"Luego echó agua en un barreño y comenzó a lavar los pies de sus discípulos y a enjugárselos con la toalla que se había ceñido."
,"6":"Al llegar a Simón Pedro, éste le dijo: 'Señor, ¿tú lavarme a mí los pies?'."
,"7":"Jesús le respondió: 'Lo que yo hago ahora tú no lo entiendes; lo entenderás más tarde'."
,"8":"Pedro dijo: 'Jamás me lavarás los pies'. Jesús le replicó: 'Si no te lavo, no tendrás parte conmigo'."
,"9":"Simón Pedro dijo: 'Señor, no sólo los pies, sino también las manos y la cabeza'."
,"10":"Jesús le dijo: 'El que se ha bañado no necesita lavarse más que los pies, pues está completamente limpio; y vosotros estáis limpios, aunque no todos'."
,"11":"Jesús sabía muy bien quién iba a traicionarlo; por eso dijo: 'No todos estáis limpios'."
,"12":"Después de lavarles los pies, se puso el manto, se sentó de nuevo a la mesa y les dijo: '¿Entendéis lo que os he hecho?"
,"13":"Vosotros me llamáis el maestro y el señor; y decís bien, porque lo soy."
,"14":"Pues si yo, el señor y el maestro, os he lavado los pies, también vosotros os los debéis lavar unos a otros."
,"15":"Yo os he dado ejemplo, para que hagáis vosotros lo mismo que he hecho yo."
,"16":"Os aseguro que el criado no es más que su amo, ni el enviado más que quien lo envía."
,"17":"Si sabéis esto y lo ponéis en práctica, seréis dichosos."
,"18":"No hablo de vosotros. Yo sé muy bien a quiénes he elegido; pero debe cumplirse la Escritura: El que come conmigo se ha vuelto contra mí."
,"19":"Os lo digo ahora antes que suceda, para que cuando suceda creáis que yo soy el que soy."
,"20":"Os aseguro que el que reciba al que yo envíe me recibe a mí, y el que me recibe a mí recibe al que me ha enviado'."
,"21":"Al decir esto, se sintió profundamente conmovido y dijo: 'Os aseguro que uno de vosotros me entregará'."
,"22":"Los discípulos se miraban unos a otros, pues no sabían de quién hablaba."
,"23":"Uno de los discípulos, el preferido de Jesús, estaba junto a Jesús."
,"24":"Simón Pedro le hizo señas para que le preguntara a quién se refería."
,"25":"Entonces él, recostándose en el pecho de Jesús, le preguntó: 'Señor, ¿quién es?'."
,"26":"Y Jesús respondió: 'Aquel a quien yo dé un trozo de pan mojado'. Mojó el pan y se lo dio a Judas, el de Simón Iscariote."
,"27":"Y tras el bocado entró en él Satanás."
,"28":"Jesús le dijo: 'Lo que vas a hacer, hazlo pronto'. Pero ninguno de los comensales supo por qué le dijo esto."
,"29":"Algunos pensaban que, como Judas tenía la bolsa, Jesús le decía que comprase todo lo que se necesitaba para la fiesta, o que diese algo a los pobres."
,"30":"Judas tomó el bocado y salió en seguida. Era de noche."
,"31":"Tan pronto como Judas salió, Jesús dijo: 'Ahora ha sido glorificado el hijo del hombre y Dios en él."
,"32":"Si Dios ha sido glorificado en él, Dios lo glorificará a él y lo glorificará en seguida'."
,"33":"'Hijos míos, voy a estar ya muy poco con vosotros. Me buscaréis, pero os digo lo mismo que dije a los judíos: Adonde yo voy no podéis ir vosotros."
,"34":"Os doy un mandamiento nuevo: que os améis unos a otros. Que como yo os he amado, así también os améis unos a otros."
,"35":"En esto reconocerán todos que sois mis discípulos, en que os amáis unos a otros'."
,"36":"Simón Pedro le preguntó: 'Señor, ¿a dónde vas?'. Jesús respondió: 'Adonde yo voy, no puedes seguirme ahora; me seguirás más tarde'."
,"37":"Pedro dijo: 'Señor, ¿por qué no puedo seguirte ahora? Yo daré mi vida por ti'."
,"38":"Jesús le contestó: '¿Que darás tu vida por mí? Te aseguro que no cantará el gallo antes que tú me niegues tres veces."
}`)
	CurrentBook.AddChapter(14, `{
"1":"'No estéis angustiados. Confiad en Dios, confiad también en mí."
,"2":"En la casa de mi Padre hay sitio para todos; si no fuera así, os lo habría dicho; voy a prepararos un sitio."
,"3":"Cuando me vaya y os haya preparado el sitio, volveré y os llevaré conmigo, para que, donde yo estoy, estéis también vosotros;"
,"4":"ya sabéis el camino para ir adonde yo voy'."
,"5":"Tomás le dijo: 'Señor, no sabemos a dónde vas, ¿cómo vamos a saber el camino?'."
,"6":"Jesús le dijo: 'Yo soy el camino, la verdad y la vida. Nadie va al Padre sino por mí."
,"7":"Si me habéis conocido a mí, conoceréis también a mi Padre. Y desde ahora lo conocéis y lo habéis visto'."
,"8":"Felipe le dijo: 'Señor, muéstranos al Padre y nos basta'."
,"9":"Jesús le dijo: 'Llevo tanto tiempo con vosotros, ¿y todavía no me conoces, Felipe? El que me ha visto a mí ha visto al Padre. ¿Cómo dices tú: Muéstranos al Padre?"
,"10":"¿No crees que yo estoy en el Padre y el Padre en mí? Las palabras que os digo no las digo por mi propia cuenta; el Padre, que está en mí, es el que realiza sus propias obras."
,"11":"Creedme: yo estoy en el Padre y el Padre en mí. Creedlo al menos por las obras mismas'."
,"12":"'Os aseguro que el que cree en mí hará las obras que yo hago y las hará aún mayores que éstas, porque yo me voy al Padre;"
,"13":"y lo que pidáis en mi nombre, yo lo haré, para que el Padre sea glorificado en el hijo."
,"14":"Lo que pidáis en mi nombre, yo lo haré'."
,"15":"'Si me amáis, guardaréis mis mandamientos."
,"16":"Yo pediré al Padre que os mande otro defensor que esté siempre con vosotros,"
,"17":"el Espíritu de la verdad, que el mundo no puede recibir porque no lo ve ni lo conoce. Vosotros lo conocéis, porque vive con vosotros y está en vosotros'."
,"18":"'No os dejaré abandonados; volveré a estar con vosotros."
,"19":"Dentro de poco el mundo no me verá más; pero vosotros me veréis, porque yo vivo y vosotros también viviréis."
,"20":"Aquel día vosotros conoceréis que yo estoy en mi Padre, vosotros en mí y yo en vosotros."
,"21":"El que conoce mis mandamientos y los guarda, ése me ama; y al que me ama lo amará mi Padre, y yo también lo amaré y me manifestaré a él'."
,"22":"Judas, no el Iscariote, sino el otro, le preguntó: 'Señor, ¿cómo es que te has de manifestar a nosotros y no al mundo?'."
,"23":"Jesús le contestó: 'El que me ama guardará mi doctrina, mi Padre lo amará y mi Padre y yo vendremos a él y viviremos en él."
,"24":"El que no me ama no guarda mi doctrina; y la doctrina que escucháis no es mía, sino del Padre que me ha enviado'."
,"25":"'Os he dicho estas cosas estando con vosotros;"
,"26":"pero el defensor, el Espíritu Santo, el que el Padre enviará en mi nombre, él os lo enseñará todo y os recordará todo lo que os he dicho'."
,"27":"'La paz os dejo, mi paz os doy; no como el mundo la da, os la doy yo. No estéis angustiados ni tengáis miedo."
,"28":"Ya sabéis lo que os he dicho: Me voy, pero volveré a estar con vosotros. Si me amáis, os alegraréis de que me vaya al Padre, porque el Padre es mayor que yo."
,"29":"Os lo he dicho ahora, antes que suceda, para que cuando suceda creáis."
,"30":"No hablaré ya muchas cosas con vosotros, porque el príncipe de este mundo está para llegar. No tiene poder sobre mí;"
,"31":"pero debe ser así para que el mundo conozca que yo amo al Padre y que hago lo que el Padre me ha ordenado. Levantaos, vámonos de aquí'."
}`)
	CurrentBook.AddChapter(15, `{
"1":"'Yo soy la vid verdadera y mi Padre el viñador."
,"2":"Él corta todos los sarmientos que no dan fruto en mí, y limpia los que dan fruto para que den más."
,"3":"Vosotros estáis ya limpios por la palabra que os he dicho."
,"4":"Seguid unidos a mí, que yo lo seguiré estando con vosotros. Como el sarmiento no puede dar fruto por sí mismo si no está unido a la vid, así tampoco vosotros si no estáis unidos a mí."
,"5":"Yo soy la vid, vosotros los sarmientos. El que permanece unido a mí y yo en él, da mucho fruto; porque sin mí no podéis hacer nada."
,"6":"Al que no está unido a mí se lo echa fuera, como a los sarmientos, que se los amontona, se secan y se los prende fuego para que se quemen."
,"7":"Si estáis unidos a mí y mis enseñanzas permanecen en vosotros, pedid todo lo que queráis y se os concederá'."
,"8":"'Mi Padre es glorificado si dais mucho fruto y sois mis discípulos."
,"9":"Como el Padre me ama a mí, así os he amado yo; permaneced en mi amor."
,"10":"Si guardáis mis mandamientos, permaneceréis en mi amor, como yo he guardado los mandamientos de mi Padre y permanezco en su amor."
,"11":"Os he dicho estas cosas para que mi alegría esté dentro de vosotros y vuestra alegría sea completa'."
,"12":"'Éste es mi mandamiento: amaos unos a otros como yo os he amado."
,"13":"Nadie tiene mayor amor que el que da la vida por sus amigos."
,"14":"Vosotros sois mis amigos si hacéis lo que os mando."
,"15":"Ya no os llamo siervos, pues el siervo no sabe qué hace su señor; yo os he llamado amigos porque os he dado a conocer todas las cosas que he oído a mi Padre."
,"16":"No me elegisteis vosotros a mí, sino yo a vosotros; y os designé para que vayáis y deis fruto y vuestro fruto permanezca, a fin de que todo lo que pidáis al Padre en mi nombre os lo conceda."
,"17":"Esto os mando: amaos unos a otros'."
,"18":"'Si el mundo os odia, sabed que me ha odiado a mí antes que a vosotros."
,"19":"Si fueseis del mundo, el mundo os amaría como cosa suya. Pero como no sois del mundo, pues yo os elegí y os saqué del mundo, por eso el mundo os odia."
,"20":"Recordad que os he dicho: 'El criado no es más que su amo'. Si a mí me han perseguido, también os perseguirán a vosotros; y si han rechazado mi doctrina, también rechazarán la vuestra."
,"21":"Todas estas cosas harán con vosotros por mi nombre, porque no conocen al que me ha enviado'."
,"22":"'Si yo no hubiera venido ni les hubiera hablado, no tendrían culpa; pero ahora no tienen excusa para su pecado."
,"23":"El que me odia a mí odia también a mi Padre."
,"24":"Si no hubiera hecho ante ellos obras que nadie ha hecho, no tendrían culpa. Pero han visto esas obras y, a pesar de todo, me odian a mí y a mi Padre."
,"25":"Para que se cumpla lo que está escrito en su ley: Me han odiado sin motivo."
,"26":"Cuando venga el defensor, que yo os enviaré de parte del Padre, el Espíritu de la verdad, que procede del Padre, él dará testimonio de mí."
,"27":"Y vosotros también lo daréis, porque estáis conmigo desde el principio'."
}`)
	CurrentBook.AddChapter(16, `{
"1":"'Os he dicho estas cosas para que no os deprimáis."
,"2":"Os echarán de las sinagogas; más aún, se acerca la hora en que os quitarán la vida creyendo que con ello dan culto a Dios."
,"3":"Os harán esto porque no conocen ni al Padre ni a mí."
,"4":"Pero yo os lo digo de antemano, para que cuando llegue el momento os acordéis de que ya os lo había anunciado. No os lo dije al principio porque estaba con vosotros'."
,"5":"'Ahora vuelvo al que me envió, y ninguno de vosotros me pregunta: ¿A dónde vas?,"
,"6":"sino que, porque os he dicho estas cosas, la tristeza ha llenado vuestro corazón."
,"7":"Pero os digo la verdad: os conviene que yo me vaya; porque si no me voy, el defensor no vendrá a vosotros; y si me voy, os lo enviaré."
,"8":"Cuando él venga demostrará al mundo en qué está el pecado, la justicia y la condena."
,"9":"El pecado consiste en que no creen en mí;"
,"10":"la justicia, en que me voy al Padre y no me veréis más,"
,"11":"y la condena, en que el príncipe de este mundo está ya condenado."
,"12":"Muchas cosas tengo que deciros todavía, pero ahora no estáis capacitados para entenderlas."
,"13":"Cuando venga él, el Espíritu de la verdad, os guiará a la verdad completa. Pues no os hablará por su cuenta, sino que os dirá lo que ha oído y os anunciará las cosas venideras."
,"14":"Él me honrará a mí, porque recibirá de lo mío y os lo anunciará."
,"15":"Todo lo que el Padre tiene es mío; por eso os he dicho que recibe de lo mío y os lo anunciará."
,"16":"Un poco, y ya no me veréis; y otro poco, y me veréis'."
,"17":"Entonces algunos discípulos se preguntaban: '¿Qué es lo que dice: Un poco, y no me veréis; y otro poco, y me veréis, y: Me voy al Padre?'."
,"18":"Decían: '¿Qué quiere decir ese 'poco' No lo entendemos'."
,"19":"Jesús se dio cuenta de que le querían preguntar algo, y les dijo: 'Andáis discutiendo sobre lo que acabo de decir: Un poco, y no me veréis; y otro poco, y me veréis."
,"20":"Os aseguro que vosotros lloraréis y gemiréis, pero el mundo gozará; vosotros os entristeceréis, pero vuestra tristeza se cambiará en alegría."
,"21":"La mujer cuando está de parto se siente angustiada, porque ha llegado su hora; pero cuando ya ha dado a luz al niño, no se acuerda más de la angustia por la alegría de que ha nacido un hombre en el mundo."
,"22":"Así también vosotros estáis ahora tristes; pero yo os veré otra vez, y vuestro corazón se alegrará y nadie os quitará ya vuestra alegría."
,"23":"En aquel día no me preguntaréis nada. Os aseguro que todo lo que pidáis en mi nombre al Padre os lo concederá'."
,"24":"'Hasta ahora no habéis pedido nada en mi nombre. Pedid y recibiréis, para que vuestra alegría sea completa."
,"25":"Os he dicho estas cosas en lenguaje figurado; se acerca la hora en que ya no os hablaré más en este lenguaje, sino que os hablaré del Padre con toda claridad."
,"26":"En aquel día pediréis al Padre en mi nombre. Yo no os voy a decir que rezaré por vosotros al Padre,"
,"27":"porque el mismo Padre os ama, ya que vosotros me habéis amado y habéis creído que yo salí de Dios'."
,"28":"'Salí del Padre y vine al mundo; de nuevo dejo el mundo y vuelvo al Padre'."
,"29":"Sus discípulos dijeron: 'Ahora hablas claramente, y no en lenguaje figurado."
,"30":"Ahora conocemos que lo sabes todo y nadie necesita preguntarte; por eso creemos que has salido de Dios'."
,"31":"Jesús les respondió: '¿Ahora creéis?"
,"32":"Pues se acerca la hora, es decir, ya ha llegado, en que os dispersaréis cada uno por su lado y me dejaréis solo; pero yo no estoy solo, pues el Padre está conmigo."
,"33":"Os he dicho estas cosas para que tengáis paz en mí. En el mundo tendréis tribulaciones; pero tened ánimo, que yo he vencido al mundo'."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Así habló Jesús. Luego, levantando sus ojos al cielo, dijo: 'Padre, ha llegado la hora; glorifica a tu hijo, para que tu hijo te glorifique a ti,"
,"2":"y que por el poder que tú le has dado sobre todos los hombres, él dé vida eterna a todos los que le has confiado. ("
,"3":"Y la vida eterna es que te conozcan a ti, el único Dios verdadero, y al que tú has enviado, Jesucristo)."
,"4":"Yo te he glorificado en la tierra, llevando a término la obra que me encomendaste."
,"5":"Ahora, Padre, glorifícame tú junto a ti con la gloria que tenía contigo antes de existir el mundo'."
,"6":"'He manifestado tu nombre a los hombres que escogiste del mundo y me los confiaste; tuyos eran, y tú me los confiaste; y ellos han guardado tu doctrina."
,"7":"Ahora han conocido que todo lo que me confiaste viene de ti;"
,"8":"porque les he comunicado las enseñanzas que tú me diste, y ellos las han aceptado. Ahora saben con toda certeza que salí de ti, y ya están convencidos de que tú me enviaste."
,"9":"Yo te ruego por ellos: no te ruego por el mundo, sino por los que tú me has confiado, pues son tuyos;"
,"10":"todo lo mío es tuyo, y lo tuyo mío; y yo he sido glorificado en ellos."
,"11":"Ya no estoy en el mundo; pero ellos están en el mundo, y yo voy a ti. Padre santo, guarda con tu poder a los que me has confiado, para que sean, como nosotros, una sola cosa."
,"12":"Cuando yo estaba con ellos, yo los guardaba y los protegía con tu poder; tú me los confiaste, y ninguno se perdió, a no ser el que tenía que perderse para que se cumpliera la Escritura."
,"13":"Pero ahora voy a ti, y digo estas cosas cuando todavía estoy en el mundo para que tengan la plenitud de mi alegría."
,"14":"Yo les he confiado tu doctrina; el mundo los odia porque no son del mundo, como tampoco yo soy del mundo."
,"15":"No te pido que los saques del mundo, sino que los guardes del mal."
,"16":"Ellos no son del mundo, como tampoco yo soy del mundo."
,"17":"Conságralos en la verdad: tu palabra es la verdad."
,"18":"Como tú me enviaste al mundo, así también los envío yo al mundo."
,"19":"Por ellos yo me consagro a ti, para que también ellos sean consagrados en la verdad'."
,"20":"'No ruego sólo por ellos, sino también por los que crean en mí a través de su palabra."
,"21":"Que todos sean una sola cosa; como tú, Padre, estás en mí y yo en ti, que también ellos sean una sola cosa en nosotros, para que el mundo crea que tú me has enviado."
,"22":"Yo les he dado la gloria que tú me diste para que sean uno, como nosotros somos uno."
,"23":"Yo en ellos y tú en mí, para que sean perfectos en la unidad, y así el mundo reconozca que tú me has enviado y que los amas a ellos como me amas a mí."
,"24":"Padre, yo quiero que también los que me has confiado estén conmigo donde yo estoy, para que vean mi gloria, que me has dado, porque antes de la creación del mundo ya me amabas."
,"25":"Padre justo, el mundo no te ha conocido, pero yo sí te he conocido; y ellos han reconocido que tú me has enviado."
,"26":"Yo les he dado a conocer tu nombre y se lo seguiré dando a conocer, para que el amor que tú me tienes esté en ellos y yo también esté con ellos'."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Dicho esto, Jesús se fue con sus discípulos al otro lado del torrente Cedrón, y entraron en un huerto."
,"2":"Judas, el que lo iba a entregar, conocía también aquel lugar, porque Jesús se había retirado allí muchas veces con sus discípulos."
,"3":"Judas, al frente de la tropa y de los guardias de los sumos sacerdotes y fariseos, fue allí con linternas, antorchas y armas."
,"4":"Y Jesús, que sabía todo lo que iba a sucederle, salió y les dijo: '¿A quién buscáis?'."
,"5":"Respondieron: 'A Jesús Nazareno'. Jesús les dijo: 'Yo soy'. Judas, el traidor, estaba también con ellos."
,"6":"Así que les dijo 'Yo soy', retrocedieron y cayeron en tierra."
,"7":"De nuevo les preguntó: '¿A quién buscáis?'. Ellos dijeron: 'A Jesús Nazareno'."
,"8":"Jesús respondió: 'Os he dicho que yo soy. Si me buscáis a mí, dejad que éstos se vayan'."
,"9":"Para que se cumpliera la palabra que había dicho: 'No he perdido ninguno de los que me confiaste'."
,"10":"Entonces Simón Pedro, que tenía una espada, la sacó, dio un golpe al criado del sumo sacerdote y le cortó la oreja derecha. El criado se llamaba Malco."
,"11":"Jesús dijo a Pedro: 'Mete la espada en la vaina; ¿es que no tengo que beber el cáliz que me da el Padre?'"
,"12":"La tropa, el oficial y los guardias de los judíos prendieron a Jesús, lo ataron"
,"13":"y lo llevaron primero a Anás, por ser suegro de Caifás. Éste era sumo sacerdote aquel año."
,"14":"Caifás era el que había asegurado a los judíos: 'Conviene que muera un hombre por el pueblo'."
,"15":"Simón Pedro y otro discípulo seguían a Jesús. Y este discípulo, como era conocido del sumo sacerdote, entró con Jesús en el atrio del sumo sacerdote;"
,"16":"pero Pedro se quedó fuera, a la puerta. Salió entonces el otro discípulo, conocido del sumo sacerdote, habló a la portera y pasó a Pedro."
,"17":"Y la portera dijo a Pedro: '¿No eres tú también de los discípulos de ese hombre?'. Y él le dijo: 'No soy'."
,"18":"Los criados y los guardias estaban en pie, calentándose, pues habían encendido fuego porque hacía frío. Pedro estaba también en pie calentándose con ellos."
,"19":"El sumo sacerdote preguntó a Jesús acerca de sus discípulos y de su doctrina."
,"20":"Jesús le respondió: 'Yo he hablado públicamente a todo el mundo; siempre he enseñado en la sinagoga y en el templo, donde se reúnen todos los judíos, y nada he hablado en secreto."
,"21":"¿Qué me preguntas a mí? Pregunta a los que me han oído qué les he dicho; ellos saben lo que yo he dicho'."
,"22":"Al decir esto Jesús, uno de los guardias allí presentes le dio una bofetada, diciendo: '¿Así respondes al sumo sacerdote?'."
,"23":"Jesús le contestó: 'Si he hablado mal, demuéstramelo; pero si he hablado bien, ¿por qué me pegas?'."
,"24":"Entonces Anás lo mandó atado a Caifás, el sumo sacerdote."
,"25":"Simón Pedro continuaba allí, de pie, calentándose. Le preguntaron: '¿No eres tú también de sus discípulos?'. Él lo negó, diciendo: 'No soy'."
,"26":"Uno de los criados del sumo sacerdote, pariente de aquel al que Pedro cortó la oreja, replicó: '¿No te vi yo en el huerto con él?'."
,"27":"Pedro lo negó otra vez. En seguida cantó el gallo."
,"28":"De casa de Caifás llevaron a Jesús al palacio del gobernador. Era de madrugada. Los judíos no entraron en el palacio para no contaminarse y poder comer la cena de la pascua."
,"29":"Pilato salió fuera y les dijo: '¿Qué acusación traéis contra este hombre?'."
,"30":"Le respondieron: 'Si no fuera un criminal, no te lo hubiéramos entregado'."
,"31":"Pilato les dijo: 'Pues tomadlo vosotros y juzgadlo según vuestra ley'. Los judíos replicaron: 'A nosotros no se nos permite condenar a muerte a nadie'."
,"32":"Para que se cumpliera la palabra que había dicho Jesús, indicando de qué muerte iba a morir."
,"33":"Pilato volvió a entrar en el palacio, llamó a Jesús y le preguntó: '¿Eres tú el rey de los judíos?'."
,"34":"Jesús respondió: '¿Dices esto por ti mismo o te lo han dicho otros de mí?'."
,"35":"Pilato respondió: '¿Soy yo acaso judío? Tu pueblo y los sumos sacerdotes te han entregado a mí. ¿Qué has hecho?'."
,"36":"Jesús respondió: 'Mi reino no es de este mundo. Si mi reino fuera de este mundo, mis súbditos lucharían para que yo no fuera entregado a los judíos. Pero mi reino no es de aquí'."
,"37":"Pilato le dijo: '¿Luego tú eres rey?'. Jesús respondió: 'Tú lo dices: yo soy rey. Yo para eso nací y para eso he venido al mundo: para dar testimonio de la verdad. Todo el que es de la verdad escucha mi voz'."
,"38":"Pilato le dijo: '¿Y qué es la verdad?'. Dicho esto, salió fuera otra vez y dijo a los judíos: 'Yo no encuentro en él culpa alguna."
,"39":"Vosotros acostumbráis a que os suelte un preso por la pascua; ¿queréis que os suelte al rey de los judíos?'."
,"40":"Entonces gritaron nuevamente: '¡A ése no! ¡A Barrabás!'. Barrabás era un bandido."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Entonces Pilato mandó azotar a Jesús."
,"2":"Los soldados trenzaron una corona de espinas, se la pusieron en la cabeza, le vistieron un manto de púrpura;"
,"3":"se acercaban a él y le decían: '¡Viva el rey de los judíos!'. Y le daban bofetadas."
,"4":"Pilato salió otra vez fuera y les dijo: 'Ved que os lo saco para que sepáis que no encuentro en él culpa alguna'."
,"5":"Jesús salió fuera, llevando la corona de espinas y el manto de púrpura. Pilato les dijo: '¡Aquí tenéis al hombre!'."
,"6":"Los sumos sacerdotes y sus criados, al verlo, gritaron: '¡Crucifícalo! ¡Crucifícalo!'. Pilato les dijo: 'Tomadlo vosotros y crucificadlo, pues yo no encuentro culpa en él'."
,"7":"Los judíos respondieron: 'Nosotros tenemos una ley, y según esa ley debe morir, porque se hace hijo de Dios'."
,"8":"Pilato, al oír estas palabras, tuvo aún más miedo."
,"9":"Entró de nuevo en el palacio y preguntó a Jesús: '¿De dónde eres tú?'. Pero Jesús no le contestó."
,"10":"Pilato le dijo: '¿Por qué no me contestas? ¿No sabes que puedo darte la libertad o crucificarte?'."
,"11":"Jesús le respondió: 'No tendrías ningún poder sobre mí si no te lo hubiera dado Dios; por eso, el que me ha entregado a ti es más culpable que tú'."
,"12":"Desde entonces Pilato buscaba la manera de dejarlo en libertad. Pero los judíos gritaban: 'Si lo dejas en libertad, no eres amigo del césar; todo el que se hace rey va contra el césar'."
,"13":"Pilato, al oír estas palabras, sacó fuera a Jesús y se sentó en el tribunal, en el sitio que llamaban 'enlosado', en hebreo 'Gábbata'."
,"14":"Era la víspera de la pascua, hacia el mediodía. Pilato dijo a los judíos: 'Aquí tenéis a vuestro rey'."
,"15":"Ellos gritaron: '¡Fuera! ¡Fuera! ¡Crucifícalo!'. Dijo Pilato: '¿Voy a crucificar a vuestro rey?'. Los sumos sacerdotes respondieron: 'No tenemos más rey que el césar'."
,"16":"Y se lo entregó para que lo crucificaran."
,"17":"Jesús quedó en manos de los judíos y, cargado con la cruz, salió hacia el lugar llamado 'la calavera', en hebreo 'Gólgota',"
,"18":"donde lo crucificaron. Con él crucificaron a otros dos, uno a cada lado, y Jesús en medio."
,"19":"Pilato, por su parte, escribió y puso sobre la cruz este rótulo: 'Jesús Nazareno, el rey de los judíos'."
,"20":"Muchos judíos leyeron la inscripción, porque donde Jesús fue crucificado era un sitio cercano a la ciudad; y estaba escrito en hebreo, en latín y en griego."
,"21":"Entonces los sumos sacerdotes de los judíos dijeron a Pilato: 'No escribas 'El rey de los judíos', sino que él dijo: 'Soy rey de los judíos'."
,"22":"Pilato respondió: 'Lo que he escrito, escrito está'."
,"23":"Los soldados, después de crucificar a Jesús, se repartieron la ropa en cuatro partes, una para cada uno. Dejaron aparte la túnica, tejida de una pieza de arriba abajo sin costura alguna."
,"24":"Por eso se dijeron: 'No debemos partirla; echémosla a suertes a ver a quién le toca'. Para que se cumpliera la Escritura: Se repartieron mis vestidos y echaron a suertes mi túnica. Es cabalmente lo que hicieron los soldados."
,"25":"Estaban en pie junto a la cruz de Jesús su madre, María de Cleofás, hermana de su madre, y María Magdalena."
,"26":"Jesús, al ver a su madre y junto a ella al discípulo preferido, dijo a su madre: 'Mujer, ahí tienes a tu hijo'."
,"27":"Luego dijo al discípulo: 'Ahí tienes a tu madre'. Y desde aquel momento el discípulo se la llevó con él."
,"28":"Después de esto, Jesús, sabiendo que todo se había consumado, para que se cumpliera la Escritura, dijo: 'Tengo sed'."
,"29":"Había allí un vaso lleno de vinagre; empaparon una esponja en el vinagre, la pusieron en una caña y se la acercaron a la boca."
,"30":"Cuando Jesús lo probó, dijo: 'Todo está cumplido'. E, inclinando la cabeza, expiró."
,"31":"Como era la víspera de la pascua, para que no quedaran los cuerpos en la cruz el sábado -pues era un día muy solemne-, los judíos rogaron a Pilato que se les quebraran las piernas y los quitaran."
,"32":"Los soldados fueron y quebraron las piernas a los dos que habían sido crucificados con Jesús."
,"33":"Al llegar a Jesús y verlo muerto, no le quebraron las piernas;"
,"34":"pero uno de los soldados le traspasó el costado con una lanza, y al punto salió sangre y agua."
,"35":"El que lo ha visto da testimonio de ello, y su testimonio es verdadero; y él sabe que dice verdad, para que vosotros creáis."
,"36":"Todo esto sucedió para que se cumpliera la Escritura: No le quebrarán hueso alguno."
,"37":"Y también otra Escritura que dice: Verán al que traspasaron."
,"38":"José de Arimatea, que era discípulo de Jesús, aunque lo tenía en secreto por miedo a los judíos, pidió a Pilato que le dejara llevar el cuerpo de Jesús. Pilato se lo permitió. Fue y se llevó el cuerpo de Jesús."
,"39":"Llegó también Nicodemo, aquel que anteriormente había estado con él por la noche, con unas cien libras de una mezcla de mirra y de áloe."
,"40":"Se llevaron el cuerpo de Jesús y lo envolvieron en lienzos con aromas, como acostumbraban los judíos a sepultar."
,"41":"En el lugar donde fue crucificado había un huerto, y en el huerto un sepulcro nuevo, en el que nadie había sido sepultado."
,"42":"Como el sepulcro estaba cerca y tenían que preparar la fiesta del día siguiente, pusieron allí a Jesús."
}`)
	CurrentBook.AddChapter(20, `{
"1":"El primer día de la semana, al rayar el alba, antes de salir el sol, María Magdalena fue al sepulcro y vio la piedra quitada."
,"2":"Entonces fue corriendo a decírselo a Simón Pedro y al otro discípulo preferido de Jesús; les dijo: 'Se han llevado del sepulcro al Señor y no sabemos dónde lo han puesto'."
,"3":"Pedro y el otro discípulo salieron"
,"4":"corriendo hacia el sepulcro los dos juntos. El otro discípulo corrió más que Pedro, y llegó antes al sepulcro;"
,"5":"se asomó y vio los lienzos por el suelo, pero no entró."
,"6":"En seguida llegó Simón Pedro, entró en el sepulcro y vio los lienzos por el suelo;"
,"7":"el sudario con que le habían envuelto la cabeza no estaba en el suelo con los lienzos, sino doblado en un lugar aparte."
,"8":"Entonces entró el otro discípulo que había llegado antes al sepulcro, vio y creyó;"
,"9":"pues no había entendido aún la Escritura según la cual Jesús tenía que resucitar de entre los muertos."
,"10":"Los discípulos se volvieron a su casa."
,"11":"María se quedó fuera, junto al sepulcro, llorando. Sin dejar de llorar, se asomó al sepulcro"
,"12":"y vio a dos ángeles con vestiduras blancas, sentados uno a la cabecera y otro a los pies, donde había sido puesto el cuerpo de Jesús."
,"13":"Ellos le dijeron: 'Mujer, ¿por qué lloras?'. Contestó: 'Porque se han llevado a mi Señor, y no sé dónde lo han puesto'."
,"14":"Al decir esto, se volvió hacia atrás y vio a Jesús allí de pie, pero no sabía que era Jesús."
,"15":"Jesús le dijo: 'Mujer, ¿por qué lloras? ¿A quién buscas?'. Ella, creyendo que era el hortelano, le dijo: 'Señor, si te lo has llevado tú, dime dónde lo has puesto, y yo iré a recogerlo'."
,"16":"Jesús le dijo: '¡María!'. Ella se volvió y exclamó en hebreo: '¡Rabbuní!' (es decir, '¡Maestro!')."
,"17":"Jesús le dijo: 'Suéltame, que aún no he subido al Padre; anda y di a mis hermanos que me voy con mi Padre y vuestro Padre, con mi Dios y vuestro Dios'."
,"18":"María Magdalena fue a decir a los discípulos que había visto al Señor y a anunciarles lo que él le había dicho."
,"19":"En la tarde de aquel día, el primero de la semana, y estando los discípulos con las puertas cerradas por miedo a los judíos, llegó Jesús, se puso en medio y les dijo: '¡La paz esté con vosotros!'."
,"20":"Y les enseñó las manos y el costado. Los discípulos se llenaron de alegría al ver al Señor."
,"21":"Él repitió: '¡La paz esté con vosotros! Como el Padre me envió a mí, así os envío yo a vosotros'."
,"22":"Después sopló sobre ellos y les dijo: 'Recibid el Espíritu Santo."
,"23":"A quienes perdonéis los pecados, les serán perdonados; a quienes se los retengáis, les serán retenidos'."
,"24":"Tomás, uno de los doce, a quien llamaban 'el Mellizo', no estaba con ellos cuando llegó Jesús."
,"25":"Los otros discípulos le dijeron: 'Hemos visto al Señor'. Él les dijo: 'Si no veo en sus manos la señal de los clavos y no meto mi dedo en el lugar de los clavos y la mano en su costado, no lo creo'."
,"26":"Ocho días después, estaban nuevamente allí dentro los discípulos, y Tomás con ellos. Jesús llegó, estando cerradas las puertas, se puso en medio y les dijo: '¡La paz esté con vosotros!'."
,"27":"Luego dijo a Tomás: 'Trae tu dedo aquí y mira mis manos; trae tu mano y métela en mi costado, y no seas incrédulo sino creyente'."
,"28":"Tomás contestó: '¡Señor mío y Dios mío!'."
,"29":"Jesús dijo: 'Has creído porque has visto. Dichosos los que creen sin haber visto'."
,"30":"Otros muchos milagros hizo Jesús en presencia de sus discípulos, que no están escritos en este libro."
,"31":"Éstos han sido escritos para que creáis que Jesús es el mesías, el hijo de Dios, y para que creyendo tengáis vida en su nombre."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Jesús se manifestó de nuevo a los discípulos en el mar de Tiberíades. Fue de este modo:"
,"2":"Estaban juntos Simón Pedro, Tomás 'el Mellizo', Natanael el de Caná de Galilea, los hijos de Zebedeo y otros dos discípulos."
,"3":"Simón Pedro les dijo: 'Voy a pescar'. Le contestaron: 'Nosotros también vamos contigo'. Salieron y subieron a la barca. Aquella noche no pescaron nada."
,"4":"Al amanecer, estaba Jesús en la orilla; pero los discípulos no sabían que era Jesús."
,"5":"Jesús les dijo: 'Muchachos, ¿tenéis algo que comer?'. Le contestaron: 'No'."
,"6":"Él les dijo: 'Echad la red al lado derecho de la barca y encontraréis'. La echaron, y no podían sacarla por la cantidad de peces."
,"7":"Entonces el discípulo preferido de Jesús dijo a Pedro: 'Es el Señor'. Simón Pedro, al oír que era el Señor, se vistió, pues estaba desnudo, y se echó al mar."
,"8":"Los demás discípulos llegaron con la barca, ya que no estaban lejos de tierra, a unos cien metros, arrastrando la red con los peces."
,"9":"Al saltar a tierra, vieron unas brasas y un pescado sobre ellas, y pan."
,"10":"Jesús les dijo: 'Traed los peces que acabáis de pescar'."
,"11":"Simón Pedro subió a la barca y sacó a tierra la red llena de ciento cincuenta y tres peces grandes. Y, a pesar de ser tantos, no se rompió la red."
,"12":"Jesús les dijo: 'Venid y comed'. Ninguno de los discípulos se atrevió a preguntarle: '¿Tú quién eres?', pues sabían que era el Señor."
,"13":"Entonces Jesús se acercó, tomó el pan y se lo dio; y lo mismo el pescado."
,"14":"Ésta fue la tercera vez que se apareció a los discípulos después de haber resucitado de entre los muertos."
,"15":"Después de comer, Jesús dijo a Simón Pedro: 'Simón, hijo de Juan, ¿me amas más que éstos?'. Pedro le contestó: 'Sí, Señor, tú sabes que te amo'. Jesús le dijo: '¡Apacienta mis corderos!'."
,"16":"Por segunda vez le preguntó: 'Simón, hijo de Juan, ¿me amas?'. Él le respondió: 'Sí, Señor, tú sabes que te amo'. Jesús le dijo: '¡Apacienta mis ovejas!'."
,"17":"Por tercera vez le preguntó: 'Simón, hijo de Juan, ¿me amas?'. Pedro se entristeció porque le había preguntado por tercera vez si lo amaba, y le respondió: 'Señor, tú lo sabes todo; tú sabes que te amo'. Jesús le dijo: '¡Apacienta mis ovejas!'."
,"18":"'Te aseguro que cuando eras más joven, tú mismo te sujetabas la túnica con el cinturón e ibas adonde querías; pero cuando seas viejo, extenderás tus manos, otro te la sujetará y te llevará adonde tú no quieras'."
,"19":"Dijo esto para indicar con qué muerte iba a glorificar a Dios. Después añadió: '¡Sígueme!'."
,"20":"Pedro se volvió y vio que lo seguía el discípulo preferido de Jesús, el que en la pascua se recostó en su pecho y le había preguntado: 'Señor, ¿quién es el que te va a entregar?'."
,"21":"Pedro, al verlo, dijo a Jesús: 'Señor, y éste, ¿qué?'."
,"22":"Jesús le dijo: 'Si yo quiero que éste se quede hasta que yo venga, a ti ¿qué? Tú sígueme'."
,"23":"Y entre los hermanos se corrió la voz de que aquel discípulo no moriría. Y no le dijo que no moriría, sino: 'Si quiero que él quede hasta que yo venga, a ti ¿qué?'."
,"24":"Éste es el discípulo que da testimonio de estas cosas, y el que las ha escrito; y sabemos que su testimonio es verdadero."
,"25":"Otras muchas cosas hizo Jesús. Si se escribieran una por una, me parece que en el mundo entero no cabrían los libros que podrían escribirse."
}`)

}
func ES_LSB_LoadNELCChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Ilustre Teófilo: Puesto que muchos han intentado componer la narración de las cosas realizadas entre nosotros"
,"2":"según nos lo han enseñado los mismos que desde el principio fueron testigos oculares y ministros de la palabra,"
,"3":"me ha parecido también a mí, que he investigado cuidadosamente todo desde los orígenes, hacerte una narración ordenada,"
,"4":"para que conozcas el fundamento de las enseñanzas que has recibido de palabra."
,"5":"En tiempos de Herodes, rey de Judea, había un sacerdote de nombre Zacarías, del grupo de Abías, cuya mujer era descendiente de Aarón y se llamaba Isabel."
,"6":"Ambos eran justos ante Dios, pues guardaban irreprochablemente todos los mandamientos y preceptos del Señor."
,"7":"No tenían hijos, porque Isabel era estéril y los dos de avanzada edad."
,"8":"Estando él de servicio ante Dios en el turno de su grupo, le tocó en suerte,"
,"9":"conforme al uso litúrgico, entrar en el santuario del Señor a ofrecer el incienso."
,"10":"Todo el pueblo estaba fuera orando a la hora del incienso."
,"11":"Y se le apareció a Zacarías un ángel del Señor, en pie, a la derecha del altar del incienso."
,"12":"Zacarías se asustó al verlo, y se llenó de miedo."
,"13":"El ángel le dijo: 'No tengas miedo, Zacarías, pues tu petición ha sido escuchada, y tu mujer Isabel te dará un hijo, al que pondrás por nombre Juan."
,"14":"Será para ti causa de gozo y alegría; y muchos se alegrarán de su nacimiento,"
,"15":"porque será grande ante el Señor; no beberá vino ni licores y estará lleno de Espíritu Santo ya desde el seno de su madre."
,"16":"Convertirá a muchos israelitas al Señor, su Dios."
,"17":"Irá delante del Señor con el espíritu y el poder de Elías, para reconciliar a los padres con los hijos y enseñar a los rebeldes la sabiduría de los justos, a fin de preparar al Señor un pueblo bien dispuesto'."
,"18":"Zacarías dijo al ángel: '¿Cómo sabré que es así? Pues yo soy viejo, y mi mujer de avanzada edad'."
,"19":"El ángel le contestó: 'Yo soy Gabriel, que estoy delante de Dios, y he sido enviado a hablarte y darte esta buena noticia."
,"20":"Te quedarás mudo y no podrás hablar hasta que suceda todo esto por no haber creído en mis palabras, que se cumplirán a su tiempo'."
,"21":"La gente estaba esperando a Zacarías y se extrañaba de que permaneciese tanto en el santuario."
,"22":"Cuando salió, no podía hablarles, por lo que comprendieron que había tenido alguna visión en el santuario. Él les hacía señas y permaneció mudo."
,"23":"Al cumplir el tiempo de su ministerio, se fue a su casa."
,"24":"Unos días después, Isabel, su mujer, quedó encinta; estuvo cinco meses sin salir de casa; y se decía:"
,"25":"'El Señor ha hecho esto conmigo y me ha librado de la vergüenza ante la gente'."
,"26":"A los seis meses envió Dios al ángel Gabriel a una ciudad de Galilea, llamada Nazaret,"
,"27":"a una joven virgen, prometida de un hombre descendiente de David, llamado José. La virgen se llamaba María."
,"28":"Entró donde ella estaba, y le dijo: 'Alégrate, llena de gracia; el Señor está contigo'."
,"29":"Ante estas palabras, María se turbó y se preguntaba qué significaría tal saludo."
,"30":"El ángel le dijo: 'No tengas miedo, María, porque has encontrado gracia ante Dios."
,"31":"Concebirás y darás a luz un hijo, al que pondrás por nombre Jesús."
,"32":"Será grande y se le llamará Hijo del altísimo; el Señor le dará el trono de David, su padre;"
,"33":"reinará sobre la casa de Jacob para siempre y su reino no tendrá fin'."
,"34":"María dijo al ángel: '¿Cómo será esto, pues no tengo relaciones?'."
,"35":"El ángel le contestó: 'El Espíritu Santo vendrá sobre ti y el poder del altísimo te cubrirá con su sombra; por eso el niño que nazca será santo y se le llamará Hijo de Dios."
,"36":"Mira, tu parienta Isabel ha concebido también un hijo en su ancianidad, y la que se llamaba estéril está ya de seis meses,"
,"37":"porque no hay nada imposible para Dios'."
,"38":"María dijo: 'Aquí está la esclava del Señor; hágase en mí según tu palabra'. Y el ángel la dejó."
,"39":"Unos días después María se dirigió presurosa a la montaña, a una ciudad de Judá."
,"40":"Entró en casa de Zacarías y saludó a Isabel."
,"41":"Cuando Isabel oyó el saludo de María, el niño saltó en su seno e Isabel quedó llena del Espíritu Santo."
,"42":"Y dijo alzando la voz: '¡Bendita tú entre las mujeres y bendito el fruto de tu vientre!"
,"43":"¿Y cómo es que la madre de mi Señor viene a mí?"
,"44":"Tan pronto como tu saludo sonó en mis oídos, el niño saltó de alegría en mi seno."
,"45":"¡Dichosa tú que has creído que se cumplirán las cosas que te ha dicho el Señor!'."
,"46":"María dijo: 'Mi alma glorifica al Señor"
,"47":"y mi espíritu se regocija en Dios, mi salvador,"
,"48":"porque se ha fijado en la humilde condición de su esclava. Desde ahora me llamarán dichosa,todas las generaciones,"
,"49":"porque el todopoderoso ha hecho conmigo cosas grandes, su nombre es santo;"
,"50":"su misericordia de generación en generación,para todos sus fieles."
,"51":"Ha desplegado la fuerza de su brazo, ha destruido los planes de los soberbios,"
,"52":"ha derribado a los poderosos de sus tronos,y ha encumbrado a los humildes;"
,"53":"ha colmado de bienes a los hambrientos,y despedido a los ricos,con las manos vacías."
,"54":"Ha socorrido a su siervo Israel, acordándose de su misericordia,"
,"55":"como había prometido a nuestros padres, en favor de Abrahán,y su descendencia para siempre'."
,"56":"María estuvo con ella unos tres meses y se volvió a su casa."
,"57":"A Isabel se le cumplió el tiempo de su parto y dio a luz un hijo."
,"58":"Los vecinos y parientes, al enterarse del gran favor que el Señor le había hecho, fueron a felicitarla."
,"59":"A los ocho días llevaron a circuncidar al niño. Querían que se llamara Zacarías, como su padre."
,"60":"Pero su madre dijo: 'No. Se llamará Juan'."
,"61":"Le advirtieron: 'No hay nadie en tu familia que se llame así'."
,"62":"Preguntaron por señas al padre cómo quería que se llamase."
,"63":"Él pidió una tablilla y escribió: 'Su nombre es Juan'. Todos se quedaron admirados."
,"64":"Inmediatamente se le soltó la lengua y empezó a hablar bendiciendo a Dios."
,"65":"Todos los vecinos se llenaron de temor. Estas cosas se comentaban en toda la montaña de Judea."
,"66":"Todos los que las oían decían pensativos: '¿Qué llegará a ser este niño?'. Porque la mano del Señor estaba con él."
,"67":"Zacarías, su padre, lleno del Espíritu Santo, profetizó así:"
,"68":"'Bendito sea el Señor, Dios de Israel, porque ha intervenido para liberar a su pueblo;"
,"69":"nos ha suscitado un poderoso salvador en la casa de David, su siervo,"
,"70":"como lo había anunciado desde antiguo,por boca de sus santos profetas;"
,"71":"que nos libraría de nuestros enemigos,y de la mano de todos los que nos odian,"
,"72":"mostrándose compasivo con nuestros padres, recordando su santa alianza"
,"73":"y el juramento que hizo a nuestro padre Abrahán,de concedernos que,"
,"74":"liberados de las manos de nuestros enemigos, podamos servirle sin temor,"
,"75":"con santidad y justicia ante él toda nuestra vida."
,"76":"Y tú, niño, serás llamado profeta del altísimo, pues irás delante del Señor,para preparar sus caminos,"
,"77":"para anunciar a su pueblo la salvación, el perdón de sus pecados,"
,"78":"gracias a la bondad misericordiosa de nuestro Dios, por la que nos visitará,como el sol que nace de lo alto,"
,"79":"para iluminar a los que yacen en tinieblas y en sombras de muerte, y para guiar nuestros pasos por el camino de la paz'."
,"80":"El niño crecía y se fortalecía en el espíritu. Y vivió en el desierto hasta el día de su manifestación a Israel."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Por aquellos días salió un decreto de César Augusto para que se empadronara todo el mundo."
,"2":"Éste es el primer censo que se hizo siendo Cirino gobernador de Siria."
,"3":"Todos iban a empadronarse, cada uno a su ciudad."
,"4":"También José, por ser descendiente de David, fue desde la ciudad de Nazaret de Galilea a Judea, a la ciudad de David, que se llama Belén,"
,"5":"para empadronarse con María, su mujer, que estaba encinta."
,"6":"Mientras estaban allí se cumplió el tiempo del parto,"
,"7":"y dio a luz a su hijo primogénito; lo envolvió en pañales y lo reclinó en un pesebre, porque no encontraron sitio en la posada."
,"8":"Había en la misma región unos pastores acampados al raso, guardando por turno sus rebaños."
,"9":"Se les presentó el ángel del Señor, y la gloria del Señor los envolvió con su luz. Ellos se asustaron."
,"10":"El ángel les dijo: 'No tengáis miedo, pues os anuncio una gran alegría, que lo será para todo el pueblo."
,"11":"En la ciudad de David hoy os ha nacido un salvador, el mesías, el Señor."
,"12":"Esto os servirá de señal: Encontraréis un niño envuelto en pañales acostado en un pesebre'."
,"13":"Y en seguida se unió al ángel una multitud del ejército celestial, que alababa a Dios diciendo:"
,"14":"'Gloria a Dios en el cielo y paz en la tierra a los hombres que él ama'."
,"15":"Cuando los ángeles los dejaron y se fueron al cielo, los pastores se decían unos a otros: 'Vamos a Belén y veamos ese acontecimiento que el Señor nos ha anunciado'."
,"16":"Fueron deprisa, y encontraron a María, a José y al niño acostado en el pesebre."
,"17":"Al verlo, manifestaron lo que les habían dicho acerca del niño."
,"18":"Todos los que lo oían se admiraban de lo que decían los pastores."
,"19":"María, por su parte, guardaba todas estas cosas, meditándolas en su corazón."
,"20":"Los pastores volvieron glorificando y alabando a Dios por todo lo que habían visto y oído. Todo tal y como se les había dicho."
,"21":"A los ocho días, cuando debían circuncidarlo, le pusieron el nombre de Jesús, como lo había llamado el ángel antes de su concepción."
,"22":"Cuando se cumplieron los días de la purificación, según la ley de Moisés, lo llevaron a Jerusalén para ofrecerlo al Señor,"
,"23":"como está escrito en la ley del Señor: Todo varón primogénito será consagrado al Señor,"
,"24":"y para ofrecer el sacrificio según lo ordenado en la ley del Señor: un par de tórtolas o dos pichones."
,"25":"Había entonces en Jerusalén un hombre llamado Simeón, justo y piadoso, que esperaba la liberación de Israel: El Espíritu Santo estaba en él,"
,"26":"y le había anunciado que no moriría sin ver al mesías del Señor."
,"27":"Movido por el Espíritu fue al templo, y, al entrar los padres con el niño Jesús para cumplir lo establecido por la ley acerca de él,"
,"28":"lo recibió en sus brazos y bendijo a Dios diciendo:"
,"29":"'Ahora, Señor, puedes dejar morir en paz a tu siervo, porque tu promesa se ha cumplido:"
,"30":"Mis propios ojos han visto al Salvador"
,"31":"que has preparado ante todos los pueblos,"
,"32":"luz para iluminar a las naciones y gloria de tu pueblo, Israel'."
,"33":"Su padre y su madre estaban admirados de las cosas que decían de él."
,"34":"Simeón los bendijo, y dijo a María, su madre: 'Este niño está destinado en Israel para que unos caigan y otros se levanten; será signo de contradicción"
,"35":"para que sean descubiertos los pensamientos de todos; y a ti una espada te atravesará el corazón'."
,"36":"Estaba también la profetisa Ana, hija de Fanuel, de la tribu de Aser, de edad muy avanzada. Se había casado muy joven, y a los siete años de matrimonio había enviudado."
,"37":"Tenía ochenta y cuatro años. Estaba siempre en el templo, sirviendo a Dios noche y día con ayunos y oraciones."
,"38":"Se presentó en aquel mismo momento, y daba gloria a Dios hablando del niño a todos los que esperaban la liberación de Israel."
,"39":"Cuando cumplieron todas las cosas que mandaba la ley del Señor, regresaron a Galilea, a su ciudad de Nazaret."
,"40":"El niño crecía y se fortalecía, lleno de sabiduría, y la gracia de Dios estaba con él."
,"41":"Sus padres iban todos los años a Jerusalén por la fiesta de la pascua."
,"42":"Cuando tuvo doce años, fueron a la fiesta, como era costumbre."
,"43":"Terminada la fiesta, emprendieron el regreso; pero el niño Jesús se quedó en Jerusalén sin que sus padres se dieran cuenta."
,"44":"Creyendo que iba en la caravana, anduvieron una jornada, al cabo de la cual se pusieron a buscarlo entre los parientes y conocidos;"
,"45":"al no encontrarlo, volvieron a Jerusalén en busca suya."
,"46":"A los tres días lo encontraron en el templo sentado en medio de los doctores, oyéndolos y preguntándoles."
,"47":"Todos los que le oían estaban admirados de su inteligencia y de sus respuestas."
,"48":"Al verlo, se quedaron maravillados; y su madre le dijo: 'Hijo, ¿por qué has hecho esto? Tu padre y yo te hemos estado buscando muy angustiados'."
,"49":"Les contestó: '¿Por qué me buscabais? ¿No sabíais que yo debo ocuparme en los asuntos de mi Padre?'."
,"50":"Ellos no comprendieron lo que les decía."
,"51":"Jesús fue con ellos a Nazaret, y les estaba sumiso. Su madre guardaba todas estas cosas en su corazón."
,"52":"Jesús crecía en sabiduría, en estatura y en gracia delante de Dios y de los hombres."
}`)
	CurrentBook.AddChapter(3, `{
"1":"El año quince del reinado de Tiberio César, siendo Poncio Pilato gobernador de Judea, estando Herodes al frente de Galilea, su hermano Filipo al frente de Iturea y de la región de Traconítida, y Lisanias al frente de Abilene,"
,"2":"bajo el sumo sacerdocio de Anás y Caifás, Dios habló a Juan, el hijo de Zacarías, en el desierto."
,"3":"Y él fue recorriendo toda la región del Jordán, predicando un bautismo de conversión para recibir el perdón de los pecados,"
,"4":"como está escrito en el libro del profeta Isaías: Voz que grita en el desierto: Preparad el camino del Señor, allanad sus sendas;"
,"5":"que los valles se eleven, que los montes y colinas se abajen, que los caminos tortuosos,se hagan rectos,y los escabrosos llanos,"
,"6":"para que todos vean,la salvación de Dios."
,"7":"Iban muchos a que los bautizara. Juan les decía: 'Raza de víboras, ¿quién os ha enseñado a huir del castigo inminente?"
,"8":"Demostrad con obras vuestro arrepentimiento, y no os pongáis a decir: Tenemos por padre a Abrahán; porque yo os digo que Dios puede sacar de estas piedras hijos de Abrahán."
,"9":"Además, ya está el hacha puesta a la raíz de los árboles, y todo árbol que no dé buen fruto será cortado y echado al fuego'."
,"10":"La gente le preguntaba: '¿Qué tenemos que hacer?'."
,"11":"Y él contestaba: 'El que tenga dos túnicas reparta con el que no tiene ninguna, y el que tiene alimentos que haga igual'."
,"12":"Acudieron también unos publicanos a bautizarse, y le dijeron: 'Maestro, ¿qué tenemos que hacer nosotros?'."
,"13":"Y él les respondió: 'No exijáis nada más de lo que manda la ley'."
,"14":"Le preguntaron también unos soldados: 'Y ¿nosotros qué debemos hacer?'. Y les contestó: 'No intimidéis a nadie, no denunciéis falsamente y contentaos con vuestra paga'."
,"15":"Como la gente estaba expectante y se preguntaba si no sería Juan el mesías,"
,"16":"Juan declaró públicamente: 'Yo os bautizo con agua, pero ya viene el que es más fuerte que yo, y a quien no soy digno de desatar la correa de sus sandalias. Él os bautizará con Espíritu Santo y con fuego."
,"17":"Tiene en su mano el bieldo para aventar su parva, llevar el trigo a su granero y quemar la paja en fuego que no se apaga'."
,"18":"Con estas y otras muchas exhortaciones evangelizaba al pueblo."
,"19":"El virrey Herodes, censurado por Juan a causa de Herodías, la mujer de su hermano, y por todos los crímenes que había cometido,"
,"20":"añadió a todos ellos uno más y metió a Juan en la cárcel."
,"21":"Después de bautizar Juan al pueblo y a Jesús, aconteció que, mientras Jesús estaba orando, se abrió el cielo,"
,"22":"descendió el Espíritu Santo sobre él en forma corporal, como una paloma, y se oyó una voz del cielo: 'Tú eres mi hijo amado, mi predilecto'."
,"23":"Jesús, al comenzar, tenía unos treinta años, y se le tenía por hijo de José, de Helí,"
,"24":"de Matat, de Leví, de Melquí, de Jannaí, de José,"
,"25":"de Matatías, de Amós, de Nahún, de Eslí, de Nagai,"
,"26":"de Maat, de Matatías, de Semeín, de Josec, de Jodá,"
,"27":"de Joanán, de Resá, de Zorobabel, de Salatiel, de Nerí,"
,"28":"de Melquí, de Abdí, de Cosán, de Elmadán, de Er,"
,"29":"de Jesús, de Eliezer, de Jorín, de Matat, de Leví,"
,"30":"de Simeón, de Judá, de José, de Jonán, de Eliaquín,"
,"31":"de Meleá, de Mená, de Matatá, de Natán, de David,"
,"32":"de Jesé, de Obed, de Booz, de Salmá, de Naasón,"
,"33":"de Aminadab, de Admín, de Arní, de Jesrón, de Fares, de Judá,"
,"34":"de Jacob, de Isaac, de Abrahán, de Tara, de Nacor,"
,"35":"de Seruc, de Ragau, de Fálec, de Eber, de Salá,"
,"36":"de Cainán, de Arfaxad, de Sem, de Noé, de Lamec,"
,"37":"de Matusalén, de Henoc, de Jaret, de Maleleel, de Cainán,"
,"38":"de Enós, de Set, de Adán, de Dios."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Jesús, lleno de Espíritu Santo, regresó del Jordán. El Espíritu Santo lo llevó al desierto,"
,"2":"donde durante cuarenta días fue tentado por el diablo. Durante esos días no comió nada, y al final tuvo hambre."
,"3":"Entonces el diablo le dijo: 'Si eres hijo de Dios, di que estas piedras se conviertan en pan'."
,"4":"Jesús le respondió: 'Está escrito: No sólo de pan vive el hombre'."
,"5":"Luego el diablo lo llevó a un lugar alto, le mostró todos los reinos del mundo en un instante"
,"6":"y le dijo: 'Te daré todo este imperio y el esplendor de estos reinos, porque son míos y se los doy a quien quiero."
,"7":"Si te pones de rodillas y me adoras, todo será tuyo'."
,"8":"Jesús respondió: 'Está escrito: Al Señor tu Dios adorarás y a él solo servirás'."
,"9":"Entonces lo llevó a Jerusalén, lo subió al alero del templo y le dijo: 'Si eres hijo de Dios, tírate de aquí abajo;"
,"10":"porque está escrito: Ordenará a sus ángeles que cuiden de ti,"
,"11":"que te lleven en las manos para que no tropiece tu pie con ninguna piedra'."
,"12":"Jesús le respondió: 'También está escrito: No tentarás al Señor tu Dios'."
,"13":"Y acabada toda tentación, el diablo se alejó de él hasta el tiempo oportuno."
,"14":"Jesús, impulsado por el Espíritu, regresó a Galilea, y su fama se extendió por toda la comarca."
,"15":"Enseñaba en las sinagogas y todos lo alababan."
,"16":"Llegó a Nazaret, donde se había criado. El sábado entró, según su costumbre, en la sinagoga y se levantó a leer."
,"17":"Le entregaron el libro del profeta Isaías, desenrolló el volumen y encontró el pasaje en el que está escrito:"
,"18":"El Espíritu del Señor está sobre mí, porque me ha ungido. Me ha enviado a llevar la buena nueva a los pobres, a anunciar la libertad a los presos, a dar la vista a los ciegos, a liberar a los oprimidos"
,"19":"y a proclamar un año de gracia del Señor."
,"20":"Enrolló el libro, se lo dio al ayudante de la sinagoga y se sentó; todos tenían sus ojos clavados en él;"
,"21":"y él comenzó a decirles: 'Hoy se cumple ante vosotros esta Escritura'."
,"22":"Todos daban su aprobación y, admirados de las palabras tan hermosas que salían de su boca, decían: '¿No es éste el hijo de José?'."
,"23":"Él les dijo: 'Seguramente me diréis aquel refrán: Médico, cúrate a ti mismo. Lo que hemos oído que has hecho en Cafarnaún, hazlo también aquí, en tu patria'."
,"24":"Y continuó: 'Os aseguro que ningún profeta es bien recibido en su tierra."
,"25":"Os aseguro, además, que en tiempo de Elías, cuando se cerró el cielo por tres años y seis meses y hubo gran hambre en toda la tierra, había muchas viudas en Israel,"
,"26":"y a ninguna de ellas fue enviado Elías, sino a una mujer viuda de Sarepta, en Sidón."
,"27":"Y había muchos leprosos en Israel cuando Eliseo profeta, pero ninguno de ellos fue limpiado de su lepra sino Naamán, el sirio'."
,"28":"Al oír esto, todos los que estaban en la sinagoga se llenaron de ira,"
,"29":"se levantaron, lo sacaron de la ciudad y lo llevaron a la cima del monte sobre el que estaba edificada la ciudad para despeñarlo."
,"30":"Pero Jesús pasó por en medio de todos y se fue."
,"31":"Fue a Cafarnaún, ciudad de Galilea, donde les enseñaba los sábados."
,"32":"Y ellos se asombraban de su doctrina porque hablaba con autoridad."
,"33":"En la sinagoga había un hombre poseído de un espíritu inmundo, que se puso a gritar:"
,"34":"'¿Qué tenemos que ver contigo, Jesús nazareno? ¿Has venido a perdernos? Sé quién eres: El Santo de Dios'."
,"35":"Jesús le increpó: 'Cállate, y sal de él'. El demonio lo tiró por tierra, pero salió de él sin hacerle daño."
,"36":"Todos quedaron estupefactos y se preguntaban unos a otros: '¿Qué es esto? ¡Manda con autoridad y energía a los espíritus inmundos, y le obedecen!'."
,"37":"Y su fama se extendió por toda la comarca."
,"38":"Salió de la sinagoga y fue a casa de Simón. La suegra de éste se encontraba enferma con fiebre muy alta, y le pidieron que la curara."
,"39":"Él se inclinó sobre ella, ordenó a la fiebre, y la fiebre la dejó. Ella se levantó inmediatamente y se puso a atenderle."
,"40":"A la puesta del sol, todos los que tenían enfermos de cualquier dolencia se los llevaron; Jesús imponía las manos sobre cada uno de ellos y los curaba."
,"41":"De muchos salían también los demonios, gritando: 'Tú eres el hijo de Dios'. Pero los reprendía y no les dejaba hablar, porque sabían que él era el mesías."
,"42":"Al amanecer se fue a un lugar solitario, y la gente andaba buscándolo. Lo encontraron y trataron de que no se alejara de ellos."
,"43":"Pero él les dijo: 'Debo anunciar también el reino de Dios a las demás ciudades, porque para esto he sido enviado'."
,"44":"E iba predicando por las sinagogas de Judea."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Mientras la gente se agolpaba en torno a él para oír la palabra de Dios, él estaba junto al lago de Genesaret"
,"2":"y vio dos barcas situadas al borde del lago. Los pescadores habían bajado a tierra y estaban lavando las redes."
,"3":"Subió a una de las barcas, que era de Simón, y le pidió que la separase un poco de la tierra. Se sentó en ella, y enseñaba a la gente desde la barca."
,"4":"Cuando terminó de hablar, dijo a Simón: 'Rema mar adentro y echad vuestras redes para la pesca'."
,"5":"Simón le respondió: 'Maestro, hemos estado trabajando toda la noche y no hemos pescado nada, pero ya que tú lo dices, echaremos las redes'."
,"6":"Así lo hicieron, y pescaron tan gran cantidad de peces que casi se rompían las redes."
,"7":"Hicieron señas a sus compañeros de la otra barca para que fueran a ayudarlos. Ellos acudieron, y llenaron tanto las dos barcas que casi se hundían."
,"8":"Al ver esto Simón Pedro, cayó a los pies de Jesús, diciendo: 'Señor, apártate de mí, que soy un hombre pecador'."
,"9":"Y es que tanto él como sus compañeros habían quedado pasmados ante la pesca realizada;"
,"10":"y lo mismo Santiago y Juan, hijos de Zebedeo, que eran compañeros de Simón. Jesús dijo a Simón: 'No tengas miedo; desde ahora serás pescador de hombres'."
,"11":"Ellos llevaron las barcas a tierra, lo dejaron todo y lo siguieron."
,"12":"Estando Jesús en una ciudad, un hombre lleno de lepra, al verlo, se puso de rodillas ante él y le dijo: 'Señor, si quieres, puedes limpiarme'."
,"13":"Jesús extendió la mano, lo tocó y dijo: 'Quiero; queda limpio'. Y al instante quedó limpio de su lepra."
,"14":"Y le ordenó: 'No se lo digas a nadie; pero, anda, muéstrate al sacerdote y presenta la ofrenda que ordenó Moisés para que les conste tu curación'."
,"15":"Su fama se extendió mucho, y mucha gente acudía para oírlo y para que los curase de sus enfermedades."
,"16":"Pero él se retiraba a los lugares solitarios para orar."
,"17":"Un día Jesús estaba enseñando. Estaban presentes unos fariseos y unos maestros de la ley que habían venido de todas las aldeas de Galilea y de Judea y de Jerusalén. Jesús hacía curaciones con el poder del Señor."
,"18":"En esto llegan unos hombres trayendo en una camilla a un paralítico. Querían entrar en la casa y ponerlo delante de Jesús."
,"19":"No encontrando por dónde meterlo porque había mucha gente, subieron a la terraza, lo bajaron por el techo en la camilla y lo pusieron en medio de todos, delante de Jesús."
,"20":"Él, al ver su fe, dijo: 'Hombre, tus pecados te son perdonados'."
,"21":"Los maestros de la ley y los fariseos se dijeron: '¿Quién es éste que dice blasfemias? ¿Quién puede perdonar los pecados sino sólo Dios?'."
,"22":"Jesús, conociendo sus pensamientos, les dijo: '¿Por qué pensáis así?"
,"23":"¿Qué es más fácil decir: Tus pecados te son perdonados, o decir: Levántate y anda?"
,"24":"Pues para que sepáis que el hijo del hombre tiene poder en la tierra para perdonar los pecados, dijo al paralítico: Tú, levántate, carga con tu camilla y vete a tu casa'."
,"25":"E inmediatamente se levantó delante de todos, se cargó la camilla en que había estado tendido y se fue a su casa, alabando a Dios."
,"26":"Todos quedaron sobrecogidos, y glorificaron a Dios. Llenos de temor, decían: 'Hoy hemos visto cosas maravillosas'."
,"27":"Después de esto, salió, vio a un publicano, llamado Leví, sentado en la oficina de los impuestos, y le dijo: 'Sígueme'."
,"28":"Él lo dejó todo, se levantó y lo siguió."
,"29":"Obsequió a Jesús con un gran convite en su casa; y había muchos publicanos y otras personas con ellos a la mesa."
,"30":"Los fariseos y los maestros de la ley murmuraban diciendo a sus discípulos: '¿Por qué coméis y bebéis con publicanos y pecadores?'."
,"31":"Jesús les contestó: 'Los sanos no tienen necesidad de médico, sino los enfermos."
,"32":"No he venido a llamar a los justos, sino a los pecadores para que se conviertan'."
,"33":"Ellos le dijeron: 'Los discípulos de Juan y los de los fariseos ayunan con frecuencia y hacen oraciones, pero tus discípulos comen y beben'."
,"34":"Jesús les contestó: '¿Es que pueden ayunar los invitados a la boda mientras el esposo está con ellos?"
,"35":"Pero vendrán días en que les quiten al esposo; entonces ayunarán'."
,"36":"Les dijo además una parábola: 'Nadie corta una pieza de un traje nuevo para remendar un vestido viejo, pues estropearía el nuevo y la pieza nueva no caería bien en el viejo."
,"37":"Y nadie echa vino nuevo en odres viejos, porque el vino nuevo reventaría los odres, el vino se derramaría y los odres se perderían;"
,"38":"sino que el vino nuevo se echa en odres nuevos."
,"39":"Y nadie, después de haber bebido vino añejo, quiere luego el nuevo, pues dice: El vino añejo es mejor'."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Un sábado, Jesús atravesaba unos sembrados, y sus discípulos comenzaron a cortar espigas y a comerlas, desgranándolas con las manos."
,"2":"Unos fariseos dijeron: '¿Por qué hacéis lo que no está permitido hacer en sábado?'."
,"3":"Jesús les respondió: '¿No habéis leído lo que hizo David cuando tuvo hambre él y los suyos?"
,"4":"¿Cómo entró en la casa de Dios, comió los panes de la proposición y dio a los que le acompañaban, aunque a nadie le es permitido comer de ellos, sino sólo a los sacerdotes?'."
,"5":"Y les decía: 'El hijo del hombre es Señor también del sábado'."
,"6":"Otro sábado entró en la sinagoga y se puso a enseñar. Allí había un hombre que tenía seca su mano derecha."
,"7":"Los maestros de la ley y los fariseos espiaban a Jesús a ver si curaba en sábado, para acusarlo."
,"8":"Él, que conocía sus pensamientos, dijo al hombre de la mano seca: 'Levántate y ponte en medio'. Él se levantó y se puso."
,"9":"Jesús les dijo: '¿Está permitido en sábado hacer el bien o el mal, salvar una vida o destruirla?'."
,"10":"Y mirando a todos los circundantes, le dijo: 'Extiende tu mano'. La extendió, y quedó sana."
,"11":"Pero ellos, en el colmo de su locura, discutían sobre lo que tenían que hacer con Jesús."
,"12":"Por aquellos días fue Jesús a la montaña a orar, y pasó la noche orando a Dios."
,"13":"Cuando llegó el día, llamó a sus discípulos y eligió doce de entre ellos, a los que llamó también apóstoles:"
,"14":"Simón, a quien llamó Pedro; su hermano Andrés, Santiago, Juan, Felipe, Bartolomé,"
,"15":"Mateo, Tomás, Santiago el hijo de Alfeo, Simón el llamado cananeo,"
,"16":"Judas hijo de Santiago y Judas Iscariote, el que le traicionó."
,"17":"Bajó con ellos y se detuvo en una explanada en la que había un gran número de discípulos y mucha gente del pueblo de toda Judea, de Jerusalén y del litoral de Tiro y Sidón,"
,"18":"que habían llegado para escucharlo y ser curados de sus enfermedades. Los que eran atormentados por espíritus inmundos también eran curados."
,"19":"Toda la gente quería tocarlo, porque salía de él una fuerza que curaba a todos."
,"20":"Entonces Jesús, levantando los ojos hacia sus discípulos, comenzó a decir: 'Dichosos los pobres, porque vuestro es el reino de Dios. "
,"21":"Dihosos los que ahora tenéis hambre, pues seréis hartos. Dichosos los que ahora lloráis, porque reiréis."
,"22":"Dichosos seréis si os odian los hombres, si os expulsan, os insultan y proscriben vuestro nombre como infame por causa del hijo del hombre."
,"23":"Alegraos aquel día y saltad de gozo, porque vuestra recompensa será grande en el cielo. Así trataban también sus padres a los profetas'."
,"24":"'Pero ¡ay de vosotros, los ricos, porque ya tenéis vuestra consolación!"
,"25":"¡Ay de vosotros, los que ahora estáis hartos, porque tendréis hambre! ¡Ay de vosotros, los que ahora reís, porque gemiréis y lloraréis!"
,"26":"¡Ay de vosotros cuando os alaben todos los hombres! Así alababan sus padres a los falsos profetas'."
,"27":"'Yo os digo a vosotros que me escucháis: Amad a vuestros enemigos; haced el bien a los que os odian;"
,"28":"bendecid a los que os maldicen; orad por los que os calumnian."
,"29":"Al que te abofetea en una mejilla, ofrécele también la otra; a quien te quita el manto, dale también la túnica."
,"30":"Da a quien te pida, y no reclames a quien te roba lo tuyo."
,"31":"Tratad a los hombres como queréis que ellos os traten a vosotros."
,"32":"Si amáis a los que os aman, ¿qué mérito tendréis? También los pecadores aman a quienes los aman."
,"33":"Y si hacéis el bien a los que os lo hacen, ¿qué mérito tendréis? Los pecadores también lo hacen."
,"34":"Y si prestáis a aquellos de quienes esperáis recibir, ¿qué mérito tendréis? También los pecadores prestan a los pecadores para recibir de ellos otro tanto."
,"35":"Pero vosotros amad a vuestros enemigos, haced el bien y prestad sin esperar remuneración; así será grande vuestra recompensa y seréis hijos del altísimo, porque él es bueno con los desagradecidos y con los malvados."
,"36":"Sed misericordiosos, como vuestro Padre es misericordioso'."
,"37":"'No juzguéis y no seréis juzgados; no condenéis y no seréis condenados. Perdonad y seréis perdonados."
,"38":"Dad y se os dará; se os dará una buena medida, apretada, rellena, rebosante; porque con la medida con que midáis seréis medidos vosotros'."
,"39":"Y les dijo una parábola: '¿Puede un ciego guiar a otro ciego? ¿No caerán los dos en el hoyo?"
,"40":"El discípulo no es superior a su maestro; el discípulo bien formado será como su maestro."
,"41":"¿Cómo es que ves la paja en el ojo de tu hermano si no adviertes la viga en el tuyo?"
,"42":"¿Cómo puedes decir a tu hermano: Deja que saque la paja de tu ojo, tú que no ves la viga en el tuyo? Hipócrita, quita primero la viga de tu ojo, y entonces verás para quitar la paja del ojo de tu hermano'."
,"43":"'No hay ningún árbol bueno que dé frutos malos, ni árbol malo que dé frutos buenos."
,"44":"El árbol se conoce por sus frutos. Porque no se cosechan higos de los espinos, ni se vendimian uvas de los zarzales."
,"45":"El hombre bueno saca el bien de la bondad que atesora en su corazón, y el malo saca el mal de la maldad que tiene, porque de la abundancia del corazón habla la boca'."
,"46":"'¿Por qué me llamáis ¡Señor! ¡Señor!, y no hacéis lo que os digo?"
,"47":"Os diré a quién se parece todo el que viene a mí y escucha mi palabra y la pone en práctica."
,"48":"Se parece a un hombre que al construir su casa cavó, profundizó y puso el cimiento sobre la roca; cuando luego vino la crecida y el río se precipitó contra la casa, no pudo derruirla porque estaba bien cimentada."
,"49":"Pero el que escucha mis palabras y no las pone en práctica se parece al que construyó una casa sobre la arena, sin cimiento; chocó el río contra ella, y rápidamente se cayó y se arruinó totalmente'."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Cuando terminó de hablar a la gente, entró en Cafarnaún."
,"2":"Un oficial, que tenía un criado que estaba muriéndose,"
,"3":"oyó hablar de Jesús, y mandó unos ancianos de los judíos a rogarle que fuese a curar a su criado."
,"4":"Ellos se acercaron a Jesús y le suplicaron con insistencia, diciendo: 'Merece que se lo concedas,"
,"5":"porque ama a nuestro pueblo y nos ha edificado una sinagoga'."
,"6":"Jesús se puso en camino con ellos. No estaban lejos de la casa, cuando el oficial mandó unos amigos a decirle: 'Señor, no te molestes, pues no soy digno de que entres en mi casa."
,"7":"Por eso ni me he atrevido a ir yo personalmente. Di una palabra, y mi criado se curará."
,"8":"Porque yo, que soy hombre sujeto al mando, tengo a mis órdenes soldados, y digo a éste: Vete, y va; y a otro: Ven, y viene; y a mi criado: Haz esto, y lo hace'."
,"9":"Al oírlo, quedó admirado y dijo a los que lo seguían: 'Os aseguro que ni en Israel he encontrado una fe como ésta'."
,"10":"Cuando los enviados regresaron a casa, encontraron curado al criado."
,"11":"Después fue a un pueblo llamado Naín, acompañado de sus discípulos y de mucha gente."
,"12":"Al llegar a la puerta de la ciudad, se encontró con que llevaban a enterrar un muerto, hijo único de una madre viuda; la acompañaba todo el pueblo."
,"13":"El Señor, al verla, se compadeció de ella y le dijo: 'No llores'."
,"14":"Luego se acercó y tocó el féretro; los que lo llevaban se detuvieron; él dijo: 'Joven, yo te lo mando: Levántate'."
,"15":"El muerto se sentó y comenzó a hablar; y él se lo entregó a su madre."
,"16":"Todos quedaron sobrecogidos y alababan a Dios, diciendo: 'Un gran profeta ha surgido entre nosotros. Dios ha visitado a su pueblo'."
,"17":"Y este suceso se propagó por toda Judea y por toda aquella comarca."
,"18":"Los discípulos de Juan le contaron todo esto. Juan llamó a dos de ellos y"
,"19":"los mandó al Señor a preguntarle: '¿Eres tú el que ha de venir o tenemos que esperar a otro?'."
,"20":"Ellos se presentaron a Jesús y le dijeron: '¿Eres tú el que ha de venir o tenemos que esperar a otro?'."
,"21":"En aquel momento Jesús curó a muchos de sus enfermedades, dolencias y espíritus malignos, y dio la vista a muchos ciegos."
,"22":"Y les respondió: 'Id y contad a Juan lo que habéis visto y oído: los ciegos ven, los cojos andan, los leprosos quedan limpios, los sordos oyen, los muertos resucitan, se anuncia el evangelio a los pobres."
,"23":"¡Y dichoso el que no se escandalice de mí!'."
,"24":"Cuando los mensajeros de Juan se fueron, comenzó a hablar de él a las gentes: '¿Qué salisteis a ver en el desierto? ¿Una caña movida por el viento?"
,"25":"¿Qué salisteis a ver? ¿Un hombre vestido lujosamente? Los que visten lujosamente y viven con regalo están en los palacios de los reyes."
,"26":"Entonces, ¿qué salisteis a ver? ¿Un profeta? Sí, yo os lo aseguro; y más que un profeta."
,"27":"Él es de quien está escrito: Yo envío delante de ti a mi mensajero para que te prepare el camino."
,"28":"Os aseguro que no hay hombre alguno más grande que Juan; pero el más pequeño en el reino de Dios es más grande que él'."
,"29":"Todo el pueblo que lo escuchó, incluso los publicanos, hicieron justicia a Dios recibiendo el bautismo de Juan."
,"30":"Pero los fariseos y los doctores de la ley frustraron el plan de Dios para con ellos, no haciéndose bautizar por él."
,"31":"'¿A qué compararé esta generación? ¿A quién se parece?"
,"32":"Se parece a esos chiquillos sentados en la plaza, que se gritan unos a otros: Os hemos tocado la flauta y no habéis bailado. Hemos cantado lamentaciones y no habéis llorado."
,"33":"Porque ha venido Juan, el Bautista, que ni comía ni bebía, y dijisteis: Tiene un demonio."
,"34":"Ha venido el hijo del hombre, que come y bebe, y decís: Éste es un comilón y un borracho."
,"35":"Pero la sabiduría ha sido justificada por todos sus discípulos'."
,"36":"Un fariseo invitó a Jesús a comer con él. Jesús fue a su casa y se puso a la mesa."
,"37":"Había en la ciudad una mujer pecadora, la cual, al enterarse de que Jesús estaba a la mesa en casa del fariseo, se presentó allí con un vaso de alabastro lleno de perfume,"
,"38":"se puso detrás de él a sus pies, y, llorando, comenzó a regarlos con sus lágrimas y a enjugarlos con los cabellos de su cabeza, los besaba y ungía con el perfume."
,"39":"El fariseo que le había invitado, al verlo, se decía: 'Si éste fuera profeta, conocería quién y qué clase de mujer es la que lo toca. ¡Una pecadora!'."
,"40":"Jesús manifestó: 'Simón, tengo que decirte una cosa'. Y él: 'Maestro, di'."
,"41":"'Un prestamista tenía dos deudores; uno le debía diez veces más que el otro."
,"42":"Como no podían pagarle, se lo perdonó a los dos. ¿Quién de ellos le amará más?'."
,"43":"Simón respondió: 'Supongo que aquel a quien perdonó más'. Jesús le dijo: 'Has juzgado bien'."
,"44":"Y, volviéndose hacia la mujer, dijo a Simón: '¿Ves a esta mujer? Yo entré en tu casa y no me diste agua para los pies; ella, en cambio, ha bañado mis pies con sus lágrimas y los ha enjugado con sus cabellos."
,"45":"Tú no me diste el beso; pero ella, desde que entró, no ha cesado de besar mis pies."
,"46":"Tú no me pusiste ungüento en la cabeza, y ésta ha ungido mis pies con perfume."
,"47":"Por lo cual te digo que si ama mucho es porque se le han perdonado sus muchos pecados. Al que se le perdona poco ama poco'."
,"48":"Y dijo a la mujer: 'Tus pecados te son perdonados'."
,"49":"Los invitados comenzaron a decirse: '¿Quién es éste que hasta perdona los pecados?'."
,"50":"Él dijo a la mujer: 'Tu fe te ha salvado; vete en paz'."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Después de esto, iba por los pueblos y las aldeas predicando el reino de Dios. Le acompañaban los doce"
,"2":"y algunas mujeres que había curado de espíritus malignos y enfermedades; María Magdalena, de la que había echado siete demonios;"
,"3":"Juana, mujer de Cusa, administrador de Herodes; Susana y algunas otras, las cuales le asistían con sus bienes."
,"4":"Un día se reunió en torno a Jesús mucha gente que había venido de los pueblos. Él les dijo esta parábola:"
,"5":"'Salió el sembrador a sembrar su semilla. Al sembrar, una parte cayó junto al camino, fue pisoteada y las aves se la comieron."
,"6":"Otra parte cayó en un pedregal y, nada más nacer, se secó por falta de humedad."
,"7":"Otra cayó entre zarzas; las zarzas crecieron y la ahogaron."
,"8":"Y otra cayó en tierra buena, nació y dio fruto, el ciento por uno'. Dicho esto, exclamó: '¡El que tenga oídos que oiga!'."
,"9":"Sus discípulos le preguntaron qué significaba esa parábola."
,"10":"Él dijo: 'A vosotros se os ha dado conocer los secretos del reino de Dios, pero a los demás sólo en parábolas, para que aunque miren no vean y aunque oigan no entiendan."
,"11":"'La parábola quiere decir esto: La semilla es la palabra de Dios."
,"12":"Los de junto al camino son los que la oyen, pero luego viene el diablo y se lleva la palabra de Dios de sus corazones para que no crean y se salven."
,"13":"Los que están sobre el pedregal son los que oyen la palabra y la aceptan con alegría; pero no tienen raíz, creen por algún tiempo y en el momento de la prueba se vuelven atrás."
,"14":"La semilla que cayó entre zarzas son los que la escuchan, pero luego se ahogan en las preocupaciones, riquezas y placeres de la vida, y no llegan a la madurez."
,"15":"Y la que cayó en tierra buena son los que escuchan la palabra con corazón bueno y generoso, la conservan y por su constancia dan fruto'."
,"16":"'Nadie enciende una lámpara y la oculta en una vasija o la pone debajo de la cama; la coloca en un candelabro para que los que entren vean la luz."
,"17":"Porque nada hay oculto que no sea descubierto, ni secreto que no sea conocido y puesto en claro."
,"18":"Mirad bien cómo escucháis; porque al que tiene se le dará más, y al que no tiene se le quitará aun lo que cree que tiene'."
,"19":"Llegaron la madre y los hermanos de Jesús, pero no podían acercarse a él porque había mucha gente."
,"20":"Se lo anunciaron: 'Tu madre y tus hermanos están ahí fuera y quieren verte'."
,"21":"Él respondió: 'Mi madre y mis hermanos son los que oyen la palabra de Dios y la cumplen'."
,"22":"Un día subió Jesús con sus discípulos a una barca y les dijo: 'Pasemos a la otra orilla'. Y se adentraron en el lago."
,"23":"Mientras navegaban se durmió. Y cayó sobre el lago tal torbellino que la barca se inundaba y corrían peligro."
,"24":"Los discípulos se acercaron y lo despertaron, diciendo: '¡Maestro, maestro, que perecemos!'. Él se levantó, increpó al viento y a las olas, que cesaron, y se hizo la calma."
,"25":"Entonces les dijo: '¿Dónde está vuestra fe?'. Llenos de miedo y de admiración, se decían: '¿Quién es éste, que manda incluso a los vientos y al agua y le obedecen?'."
,"26":"Tomaron tierra en la región de los gerasenos, frente a Galilea."
,"27":"Al desembarcar, les salió al encuentro un hombre de la ciudad, poseído por demonios; desde hacía mucho tiempo andaba desnudo y no vivía en ninguna casa, sino en el cementerio."
,"28":"Al ver a Jesús, se puso a gritar y se postró ante él diciendo a voces: '¡Déjame en paz, Jesús, hijo del Dios altísimo! Te ruego que no me atormentes'."
,"29":"Es que Jesús mandaba al espíritu impuro que saliera de aquel hombre. Muchas veces se había apoderado de él, y entonces lo ataban con cadenas y con grillos; pero rompía las ataduras y el demonio lo arrastraba a los despoblados."
,"30":"Jesús le preguntó: '¿Cómo te llamas?'. Él contestó: 'Me llamo legión'. Porque habían entrado en él muchos demonios."
,"31":"Y le rogaban que no les mandara volver al abismo."
,"32":"Había allí una gran piara de cerdos paciendo en el monte, y le suplicaron que les permitiera entrar en ellos. Él se lo permitió."
,"33":"Los demonios salieron del hombre y entraron en los cerdos, y la piara se lanzó al lago por un precipicio y se ahogó."
,"34":"Viendo los pastores lo ocurrido, huyeron y lo contaron en el pueblo y en los caseríos."
,"35":"La gente fue a ver qué había sucedido y, al llegar, encontraron al hombre del que habían salido los demonios sentado a los pies de Jesús, vestido y en su sano juicio; y se llenaron de miedo."
,"36":"Los que habían visto cómo había sido librado el endemoniado lo contaban."
,"37":"Y toda la gente de la comarca de los gerasenos rogó a Jesús que se fuera de allí porque estaban llenos de miedo. Él subió a la barca y regresó."
,"38":"Por su parte, el hombre de quien habían salido los demonios le pidió que le dejara ir con él; pero Jesús lo despidió diciéndole:"
,"39":"'Vuelve a tu casa y cuenta lo que Dios ha hecho contigo'. Y él se fue publicando por todo el pueblo lo que Jesús había hecho con él."
,"40":"Al volver Jesús, la gente lo recibió con alegría, pues todos estaban esperándolo."
,"41":"Llegó uno de los jefes de la sinagoga, llamado Jairo, se echó a sus pies y le rogó que fuera a su casa,"
,"42":"porque su hija única, de unos doce años, se estaba muriendo. Mientras Jesús iba, la gente lo apretujaba."
,"43":"Una mujer que padecía hemorragias desde hacía doce años y que había gastado en médicos toda su fortuna sin que ninguno pudiera curarla,"
,"44":"se acercó por detrás, tocó la orla de su manto e inmediatamente cesó la hemorragia."
,"45":"Jesús dijo: '¿Quién me ha tocado?'. Como todos lo negaban Pedro dijo: 'Maestro, es la gente que te rodea y te apretuja'."
,"46":"Jesús le dijo: 'Alguien me ha tocado, porque yo he sentido que de mí ha salido una fuerza'."
,"47":"La mujer, al verse descubierta, se acercó toda temblando, se postró a sus pies y contó ante todo el pueblo por qué lo había tocado y cómo se había curado instantáneamente."
,"48":"Él le dijo: 'Hija, tu fe te ha curado; vete en paz'."
,"49":"Todavía estaba hablando cuando llegó uno de casa del jefe de la sinagoga diciendo: 'Tu hija ha muerto; no molestes ya al maestro'."
,"50":"Pero Jesús, al oírlo, le dijo: 'No temas; basta que tengas fe, y se curará'."
,"51":"Al llegar a la casa, sólo dejó entrar con él a Pedro, a Juan, a Santiago y a los padres de la niña."
,"52":"Todos lloraban y se lamentaban por ella; pero él dijo: 'No lloréis, porque no está muerta; está dormida'."
,"53":"Y se reían de él, porque sabían que estaba muerta."
,"54":"Él la tomó de la mano y dijo: 'Niña, despierta'."
,"55":"La niña recobró la vida, y al instante se levantó. Jesús mandó que le dieran de comer."
,"56":"Y los padres se quedaron asombrados, pero él les ordenó que no dijeran a nadie lo sucedido."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Reunió a los doce, les dio poder y autoridad sobre todos los demonios y de curar enfermedades,"
,"2":"y los envió a predicar el reino de Dios y a curar a los enfermos."
,"3":"Les dijo: 'No llevéis nada para el camino: ni bastón, ni alforja, ni pan, ni dinero, ni dos túnicas."
,"4":"Quedaos en la casa donde entréis hasta que dejéis aquel lugar."
,"5":"Y si no os reciben, al salir de aquel pueblo, sacudid el polvo de vuestros pies en testimonio contra ellos'."
,"6":"Fueron y recorrieron las aldeas, anunciando la buena nueva y haciendo curaciones por todas partes."
,"7":"El virrey Herodes se enteró de todas estas cosas y estaba desconcertado, porque unos decían que Juan había resucitado de entre los muertos,"
,"8":"otros que había aparecido Elías y otros que uno de los antiguos profetas había vuelto a la vida."
,"9":"Pero Herodes decía: 'A Juan yo le corté la cabeza; ¿quién es éste de quien oigo tales cosas?'. Y buscaba verlo. A su regreso, los discípulos le contaron todo lo que habían hecho. "
,"10":"Jesús se fue con ellos a un lugar retirado en dirección a un pueblo llamado Betsaida."
,"11":"La gente, al saberlo, lo siguió. Él los recibió bien, les habló sobre el reino de Dios y curó a los que lo necesitaban."
,"12":"Al caer el día se le acercaron los doce y le dijeron: 'Despídelos para que vayan a las aldeas y caseríos del contorno a buscar alojamiento y comida, pues aquí estamos en descampado'."
,"13":"Pero Jesús les dijo: 'Dadles vosotros de comer'. Ellos le dijeron: 'No tenemos más que cinco panes y dos peces. ¡A no ser que vayamos a comprar alimentos para toda esta gente!'."
,"14":"Pues eran unos cinco mil hombres. Jesús dijo a sus discípulos: 'Decidles que se sienten en grupos de cincuenta'."
,"15":"Así lo hicieron, y dijeron que se sentaran todos."
,"16":"Jesús tomó los cinco panes y los dos peces, alzó los ojos al cielo, los bendijo, los partió y se los dio a los discípulos para que se los distribuyeran a la gente."
,"17":"Y todos comieron hasta hartarse. Y se recogieron doce canastos llenos de las sobras."
,"18":"Un día que Jesús estaba orando en un lugar retirado y sus discípulos se encontraban con él, les preguntó: '¿Quién dice la gente que soy yo?'."
,"19":"Ellos le dijeron: 'Unos que Juan el Bautista, otros que Elías y otros que uno de los antiguos profetas resucitado'."
,"20":"Él les dijo: 'Y vosotros, ¿quién decís que soy?'. Pedro tomó la palabra y dijo: 'El mesías de Dios'."
,"21":"Y les ordenó que no se lo dijeran a nadie."
,"22":"Jesús añadió que el hijo del hombre tenía que padecer mucho, ser rechazado por los ancianos, los sumos sacerdotes y los maestros de la ley, ser matado y resucitar al tercer día."
,"23":"Y les decía a todos: 'El que quiera venir en pos de mí niéguese a sí mismo, tome su cruz cada día y sígame."
,"24":"Porque el que quiera salvar su vida la perderá; pero quien pierda la vida por mí, la salvará."
,"25":"¿Qué le vale al hombre ganar el mundo entero si se pierde o se destruye a sí mismo?"
,"26":"Porque si alguien se avergüenza de mí y de mi doctrina, el hijo del hombre se avergonzará de él cuando venga con su gloria y con la del Padre y los santos ángeles."
,"27":"Os aseguro que hay algunos entre los aquí presentes que no morirán antes que venga el reino de Dios'."
,"28":"Unos ocho días después Jesús tomó consigo a Pedro, a Juan y Santiago y los llevó al monte a orar."
,"29":"Mientras él oraba, cambió el aspecto de su rostro y sus vestidos se volvieron de una blancura resplandeciente."
,"30":"Dos hombres, de improviso, se pusieron a hablar con él. Eran Moisés y Elías,"
,"31":"que aparecieron con un resplandor glorioso y hablaban con él de su muerte, que iba a tener lugar en Jerusalén."
,"32":"Pedro y sus compañeros estaban cargados de sueño, pero lograron mantenerse despiertos y vieron la gloria de Jesús y a los dos hombres que estaban con él."
,"33":"Cuando éstos se alejaban de Jesús, Pedro dijo: 'Maestro, ¡qué bien se está aquí! Hagamos tres tiendas: una para ti, otra para Moisés y otra para Elías'. No sabía lo que decía."
,"34":"Mientras él estaba diciendo esto, vino una nube y los cubrió. Al entrar en la nube, los discípulos se asustaron."
,"35":"Y una voz desde la nube dijo: 'Éste es mi hijo, el elegido, escuchadlo'."
,"36":"Tan pronto como cesó la voz, Jesús se quedó solo. Los discípulos guardaron silencio, y a nadie contaron por entonces lo que habían visto."
,"37":"Al día siguiente, al bajar del monte, la gente vino a su encuentro."
,"38":"Y, de pronto, un hombre de entre la gente gritó: 'Maestro, por favor, mira a mi hijo, el único que tengo."
,"39":"Un espíritu maligno se apodera de él, y de repente se pone a gritar; lo retuerce entre espumarajos y a duras penas se aleja de él, dejándolo extenuado."
,"40":"He pedido a tus discípulos que lo echasen, y no han podido'."
,"41":"Jesús respondió: '¡Gente incrédula y perversa! ¿Hasta cuándo tendré que estar con vosotros? ¿Hasta cuándo tendré que soportaros? Tráeme aquí a tu hijo'."
,"42":"Y mientras el muchacho se acercaba, el demonio lo tiró por tierra y lo retorció violentamente. Jesús increpó al espíritu impuro, curó al muchacho y lo devolvió a su padre."
,"43":"Y todos se quedaron atónitos ante la grandeza de Dios. Mientras todos estaban admirados por las cosas que hacía, Jesús dijo a sus discípulos: "
,"44":"'Grabaos bien estas palabras: El hijo del hombre va a ser entregado en manos de los hombres'."
,"45":"Pero ellos no entendían esta expresión; era para ellos tan oscura, que no podían entenderla; pero no se atrevían a decirle que se la aclarara."
,"46":"Los discípulos se pusieron a discutir sobre quién de ellos sería el más grande."
,"47":"Pero Jesús, conociendo sus pensamientos, tomó un niño, lo puso a su lado"
,"48":"y les dijo: 'El que acoge a este niño en mi nombre me acoge a mí, y el que me acoge a mí acoge al que me ha enviado; porque el más pequeño entre todos vosotros, ése es el más grande'."
,"49":"Juan dijo a Jesús: 'Maestro, hemos visto a uno que echaba los demonios en tu nombre y se lo hemos prohibido, porque no anda con nosotros'."
,"50":"Jesús le dijo: 'No se lo impidáis, porque el que no está contra vosotros está a vuestro favor'."
,"51":"Al llegar el tiempo de su partida de este mundo, resolvió ir a Jerusalén,"
,"52":"y envió mensajeros por delante. Éstos entraron en una aldea de samaritanos para prepararle alojamiento."
,"53":"Pero los samaritanos no lo recibieron porque iba camino de Jerusalén."
,"54":"Al ver esto, los discípulos Santiago y Juan dijeron: 'Señor, ¿quieres que digamos que baje fuego del cielo y los consuma?'."
,"55":"Jesús se volvió hacia ellos y los reprendió."
,"56":"Y se fueron a otra aldea."
,"57":"Mientras iban de camino, uno le dijo: 'Te seguiré adondequiera que vayas'."
,"58":"Jesús le dijo: 'Las raposas tienen madrigueras y las aves del cielo nidos, pero el hijo del hombre no tiene donde reclinar la cabeza'."
,"59":"Dijo a otro: 'Sígueme'. Y él respondió: 'Señor, déjame antes ir a enterrar a mi padre'."
,"60":"Y le contestó: 'Deja que los muertos entierren a sus muertos; tú ven a anunciar el reino de Dios'."
,"61":"Un tercero dijo a Jesús: 'Yo te seguiré, Señor, pero permíteme que me despida antes de mi familia'."
,"62":"Y Jesús le dijo: 'El que pone la mano en el arado y mira atrás no es apto para el reino de Dios'."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Después de esto, el Señor designó otros setenta y dos, y los envió delante de él, de dos en dos, a todos los pueblos y lugares adonde él pensaba ir."
,"2":"Y les dijo: 'La mies es mucha, pero los obreros son pocos. Rogad al dueño de la mies que envíe obreros a su mies."
,"3":"¡Andad!; mirad que yo os envío como corderos en medio de lobos."
,"4":"No llevéis bolsa, ni alforja, ni sandalias; no saludéis a nadie por el camino."
,"5":"Cuando entréis en una casa, decid primero: Paz a esta casa."
,"6":"Si allí vive gente de paz, vuestra paz reposará sobre ellos; si no, se volverá a vosotros."
,"7":"Quedaos en esa casa, comiendo y bebiendo lo que tengan, porque el obrero tiene derecho a su salario. No andéis de casa en casa."
,"8":"Si llegáis a un pueblo y os reciben bien, comed lo que os sirvan;"
,"9":"curad a los enfermos que haya y decidles: El reino de Dios está cerca de vosotros."
,"10":"Pero si llegáis a un pueblo y no os reciben, id por las calles diciendo:"
,"11":"Hasta el polvo de vuestro pueblo que se nos pegó a los pies nos lo sacudimos."
,"12":"Yo os digo que en el día del juicio habrá más tolerancia para Sodoma que para ese pueblo'."
,"13":"'¡Ay de ti, Corozaín! ¡Ay de ti, Betsaida! Porque si en Tiro y en Sidón se hubieran hecho los milagros que en vosotras, hace ya tiempo que se hubieran arrepentido cubiertas de saco y de ceniza."
,"14":"En el día del juicio habrá más tolerancia para Tiro y Sidón que para vosotras."
,"15":"Y tú, Cafarnaún, ¿crees que te vas a elevar hasta el cielo? ¡Hasta el abismo te hundirás!"
,"16":"El que os escucha a vosotros me escucha a mí; y el que os rechaza a vosotros me rechaza a mí; y el que me rechaza a mí rechaza al que me ha enviado'."
,"17":"Los setenta y dos volvieron llenos de alegría, diciendo: 'Señor, hasta los demonios se nos someten en tu nombre'."
,"18":"Y Jesús les dijo: 'Yo veía a Satanás cayendo del cielo como un rayo."
,"19":"Ved que os he dado poder de pisar serpientes y escorpiones, y sobre todas las fuerzas del enemigo, sin que nada os dañe."
,"20":"Pero no os alegréis de que los espíritus os estén sometidos; alegraos más bien de que vuestros nombres están escritos en el cielo'."
,"21":"En aquel momento, lleno de gozo bajo la acción del Espíritu Santo, dijo: 'Yo te alabo, Padre, señor del cielo y de la tierra, porque has ocultado estas cosas a los hombres sabios y a los entendidos, y se las has manifestado a los sencillos. Sí, Padre, porque así has querido."
,"22":"Mi Padre me ha confiado todas las cosas; nadie conoce al hijo sino el Padre; y nadie conoce al Padre sino el hijo y aquel a quien el hijo se lo quiera manifestar'."
,"23":"Se volvió a los discípulos y les dijo aparte: '¡Dichosos los ojos que ven lo que vosotros veis!"
,"24":"Os digo que muchos profetas y reyes quisieron ver lo que vosotros veis y no lo vieron, y oír lo que vosotros oís y no lo oyeron'."
,"25":"Se levantó entonces un doctor de la ley y le dijo para tentarlo: 'Maestro, ¿qué debo hacer para heredar la vida eterna?'."
,"26":"Jesús le respondió: '¿Qué está escrito en la ley? ¿Qué lees en ella?'."
,"27":"Él le contestó: 'Amarás al Señor, tu Dios, con todo tu corazón, con toda tu alma, con todas tus fuerzas y con toda tu mente, y a tu prójimo como a ti mismo'."
,"28":"Jesús le dijo: 'Has respondido muy bien; haz eso y vivirás'."
,"29":"Pero él, queriendo justificarse, dijo a Jesús: '¿Quién es mi prójimo?'."
,"30":"Jesús respondió: 'Un hombre bajaba de Jerusalén a Jericó y cayó entre ladrones, que le robaron todo lo que llevaba, le hirieron gravemente y se fueron dejándolo medio muerto."
,"31":"Un sacerdote bajaba por aquel camino; al verlo, dio un rodeo y pasó de largo."
,"32":"Igualmente un levita, que pasaba por allí, al verlo, dio un rodeo y pasó de largo."
,"33":"Pero llegó un samaritano, que iba de viaje, y, al verlo, se compadeció de él;"
,"34":"se acercó, le vendó las heridas, echando en ellas aceite y vino; lo montó en su cabalgadura, lo llevó a una posada y cuidó de él."
,"35":"Al día siguiente sacó unos dineros y se los dio al posadero, diciendo: Cuida de él, y lo que gastes de más yo te lo pagaré a la vuelta."
,"36":"¿Quién de los tres te parece que fue el prójimo del que cayó en manos de los ladrones?'."
,"37":"Y él contestó: 'El que se compadeció de él'. Jesús le dijo: 'Anda y haz tú lo mismo'."
,"38":"Camino adelante, llegó Jesús a una aldea; y una mujer, de nombre Marta, lo recibió en su casa."
,"39":"Marta tenía una hermana llamada María, la cual, sentada a los pies del Señor, escuchaba sus palabras."
,"40":"Marta, que andaba afanosa en los muchos quehaceres, se paró y dijo: 'Señor, ¿te parece bien que mi hermana me deje sola con las faenas? Dile que me ayude'."
,"41":"El Señor le contestó: 'Marta, Marta, tú te preocupas y te apuras por muchas cosas,"
,"42":"y sólo es necesaria una. María ha escogido la parte mejor, y nadie se la quitará'."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Jesús estaba orando en cierto lugar. Cuando acabó, uno de sus discípulos le dijo: 'Señor, enséñanos a orar, como Juan enseñó a sus discípulos'."
,"2":"Él les dijo: 'Cuando oréis decid: Padre, santificado sea tu nombre; venga tu reino;"
,"3":"danos cada día nuestro pan cotidiano;"
,"4":"perdónanos nuestros pecados, porque también nosotros perdonamos a todo el que nos debe, y no nos dejes caer en la tentación'."
,"5":"Y les dijo: 'Suponed que uno de vosotros tiene un amigo que acude a él a medianoche y le dice: Amigo, préstame tres panes,"
,"6":"pues un amigo mío ha venido de viaje a mi casa y no tengo qué darle;"
,"7":"y que él le responde desde dentro: No me molestes; la puerta está cerrada, y yo y mis hijos acostados; no puedo levantarme a dártelos."
,"8":"Yo os aseguro que si no se levanta a dárselos por ser su amigo, al menos para que deje de molestarle se levantará y le dará todo lo que necesite."
,"9":"Pues bien, yo os digo: Pedid y se os dará; buscad y encontraréis; llamad y se os abrirá."
,"10":"Porque el que pide recibe; el que busca encuentra, y al que llama se le abre."
,"11":"¿Qué padre de entre vosotros, si su hijo le pide un pan, le dará una piedra? ¿Y si le pide un pez, le dará en lugar de un pez una serpiente?"
,"12":"O si le pide un huevo, ¿le dará un escorpión?"
,"13":"Pues si vosotros, que sois malos, sabéis dar a vuestros hijos cosas buenas, ¿cuánto más el Padre del cielo dará el Espíritu Santo a quienes se lo piden?'."
,"14":"Acababa de expulsar a un demonio que había dejado mudo a un hombre. Cuando el demonio se fue, el mudo habló. La gente se quedó asombrada."
,"15":"Pero algunos dijeron: 'Éste echa a los demonios con el poder de Belcebú, príncipe de los demonios'."
,"16":"Otros, para probarlo, le pedían un milagro del cielo."
,"17":"Pero él, conociendo sus pensamientos, les dijo: 'Todo reino dividido contra sí mismo será desolado y cae casa sobre casa."
,"18":"Si Satanás se divide contra sí mismo, ¿cómo podrá subsistir su reino? ¿Por qué decís que yo echo los demonios con el poder de Belcebú?"
,"19":"Si yo echo los demonios con el poder de Belcebú, ¿con qué poder los echan vuestros hijos? Por eso, ellos mismos serán vuestros jueces."
,"20":"Pero si yo echo los demonios con el poder de Dios, es señal de que el reino de Dios ha llegado a vosotros."
,"21":"Cuando un hombre fuerte y armado guarda su palacio, está segura su hacienda."
,"22":"Pero si sobreviene otro más fuerte que él y lo vence, le quita las armas en que confiaba y reparte todos sus bienes."
,"23":"El que no está conmigo está contra mí, y el que no recoge conmigo desparrama."
,"24":"Cuando el espíritu inmundo sale de un hombre, anda por lugares áridos buscando descanso y, al no encontrarlo, se dice: Volveré a mi casa, de donde salí."
,"25":"Al volver, la encuentra barrida y arreglada."
,"26":"Entonces va y trae consigo otros siete espíritus peores que él, entran todos y se instalan allí. Así el estado final de aquel hombre resulta peor que el primero'."
,"27":"Mientras decía esto, una mujer de entre la gente gritó: 'Dichoso el vientre que te llevó y los pechos que te amamantaron'."
,"28":"Pero él le dijo: 'Dichosos más bien los que escuchan la palabra de Dios y la ponen en práctica'."
,"29":"Como la gente se apelotonaba a su alrededor, se puso a decir: 'Esta generación es malvada; pide una señal milagrosa y no se le dará otra que la señal de Jonás."
,"30":"Como Jonás fue una señal para los ninivitas, así el hijo del hombre lo será para esta generación."
,"31":"La reina del Sur se levantará en el día del juicio con los hombres de esta generación y los condenará, porque ella vino desde los confines de la tierra a escuchar la sabiduría de Salomón, ¡y aquí hay algo que es más que Salomón!"
,"32":"Los hombres de Nínive se levantarán en el día del juicio con esta generación y la condenarán, porque se arrepintieron por la predicación de Jonás, ¡y aquí hay algo que es más que Jonás!'"
,"33":"'Nadie enciende una lámpara y la pone en un lugar escondido ni la oculta en una vasija, sino que la pone en el candelero para que alumbre a los que entren."
,"34":"La lámpara de tu cuerpo son los ojos; si tus ojos están sanos, todo tu cuerpo estará iluminado; pero si están enfermos, tu cuerpo estará oscuro."
,"35":"Cuida, por tanto, de que la luz que hay en ti no esté apagada."
,"36":"Pues si todo tu cuerpo está iluminado, al no haber en él parte alguna oscura, todo él resplandecerá como cuando la lámpara te ilumina con su resplandor'."
,"37":"Cuando terminó de hablar, un fariseo lo invitó a comer con él. Jesús entró y se puso a la mesa."
,"38":"El fariseo se extrañó al ver que no se había lavado antes de comer."
,"39":"Pero el Señor le dijo: 'Vosotros los fariseos limpiáis por fuera la copa y el plato, pero vuestro interior está lleno de rapiña y de maldad."
,"40":"¡Insensatos! ¿No hizo también lo interior el que hizo lo exterior?"
,"41":"Dad limosna de lo de dentro, y lo tendréis todo limpio."
,"42":"Mas, ¡ay de vosotros, fariseos, que pagáis el diezmo de la menta y de la ruda y de todas las legumbres, y olvidáis la justicia y el amor de Dios! ¡Hay que hacer una cosa sin descuidar la otra!"
,"43":"¡Ay de vosotros, fariseos, que os gusta ocupar los primeros asientos en las sinagogas y ser saludados en las plazas!"
,"44":"¡Ay de vosotros, que sois como sepulcros que nadie ve y sobre los que caminan los hombres sin saberlo!'."
,"45":"Entonces uno de los doctores de la ley le dijo: 'Maestro, hablando así nos ofendes también a nosotros'."
,"46":"Y él replicó: '¡Ay de vosotros también, doctores de la ley, que echáis sobre los demás cargas insoportables, y vosotros no las tocáis ni con un dedo!"
,"47":"¡Ay de vosotros, que construís los sepulcros de los profetas, y fueron vuestros padres quienes los asesinaron!"
,"48":"Así manifestáis que estáis de acuerdo con lo que hicieron vuestros padres, pues ellos los mataron y vosotros construís los sepulcros."
,"49":"Por eso dijo también la sabiduría de Dios: Les enviaré profetas y apóstoles; a unos los matarán y a otros los perseguirán."
,"50":"Pero Dios pedirá cuentas a esta generación de la sangre de todos los profetas asesinados desde la creación del mundo,"
,"51":"desde la sangre de Abel hasta la sangre de Zacarías, asesinado entre el altar y el santuario. Sí, yo os digo que Dios pedirá cuentas a esta generación."
,"52":"¡Ay de vosotros, doctores de la ley, que os habéis apoderado de la llave de la ciencia, y ni entráis vosotros ni dejáis entrar a los demás!'."
,"53":"Cuando salió de allí, los fariseos y los maestros de la ley comenzaron a acosarlo y a proponerle muchas cuestiones,"
,"54":"tendiéndole trampas para sorprenderlo en alguna de sus palabras."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Entre tanto se agolparon miles y miles de personas, hasta pisarse unos a otros. Y comenzó a decir primeramente a sus discípulos: 'Guardaos del fermento de los fariseos, que es la hipocresía."
,"2":"Pues nada hay tan oculto que no se llegue a descubrir, y nada tan secreto que no se llegue a saber."
,"3":"Por eso, todo lo que hayáis dicho en las tinieblas será escuchado a la luz del día, y lo que hayáis hablado al oído en los aposentos será proclamado desde las terrazas."
,"4":"Yo os digo, amigos míos, que no tengáis miedo de los que matan el cuerpo y no pueden hacer más."
,"5":"Os diré a quién debéis de temer: Temed al que después de haberos matado puede echaros en el fuego. Sí, temed a éste."
,"6":"¿No se venden cinco pájaros por unos cuartos? Y, sin embargo, Dios no se olvida de ninguno de ellos."
,"7":"¡Hasta los cabellos de vuestra cabeza están todos contados! ¡No tengáis miedo! Vosotros valéis más que una bandada de pájaros."
,"8":"Os digo además: Al que me confiese delante de los hombres, el hijo del hombre lo confesará delante de los ángeles de Dios;"
,"9":"pero al que me niegue delante de los hombres, él lo negará delante de los ángeles de Dios."
,"10":"Al que hable mal del hijo se le perdonará, pero a quien blasfeme contra el Espíritu Santo no se le perdonará."
,"11":"Cuando os lleven a las sinagogas o ante los magistrados y autoridades, no os preocupéis sobre cómo habéis de hablar o qué habéis de decir."
,"12":"El Espíritu Santo os enseñará en aquel momento lo que debéis decir'."
,"13":"Uno de la gente le dijo: 'Maestro, di a mi hermano que reparta la herencia conmigo'."
,"14":"Él le respondió: 'Hombre, ¿quién me ha hecho juez y repartidor entre vosotros?'."
,"15":"Y prosiguió: 'Guardaos bien de toda avaricia; que, aunque uno esté en la abundancia, no tiene asegurada la vida con sus riquezas'."
,"16":"Y les dijo una parábola: 'Las fincas de un hombre rico dieron una gran cosecha."
,"17":"Y él pensó: ¿Qué haré, pues no tengo donde almacenar mis cosechas?"
,"18":"Y se dijo: Destruiré mis graneros, los ampliaré y meteré en ellos todas mis cosechas y mis bienes."
,"19":"Luego me diré: Tienes muchos bienes almacenados para largos años; descansa, come, bebe y pásalo bien."
,"20":"Pero Dios le dijo: ¡Insensato, esta misma noche morirás!; ¿para quién será lo que has acaparado?"
,"21":"Así sucederá al que amontona riquezas para sí y no es rico a los ojos de Dios'."
,"22":"Después dijo a sus discípulos: 'Por eso os digo: No os angustiéis por vuestra vida pensando qué vais a comer, ni por vuestro cuerpo, qué vais a poneros."
,"23":"Porque la vida es más que el alimento, y el cuerpo más que el vestido."
,"24":"Mirad los cuervos: No siembran, ni siegan, no tienen despensas ni graneros, y Dios los alimenta. ¡Cuánto más valéis vosotros que los pájaros!"
,"25":"¿Quién de vosotros, por mucho que cavile, puede añadir una sola hora al tiempo de su vida?"
,"26":"Si no podéis ni las cosas más pequeñas, ¿a qué preocuparse de las demás?"
,"27":"Mirad cómo crecen los lirios del campo; no se fatigan, ni hilan; pero yo os digo que ni Salomón en todo su esplendor se vistió como uno de ellos."
,"28":"Pues si Dios viste así a la hierba del campo, que hoy brota y mañana se la echa al fuego, ¿no hará más por vosotros, hombres de poca fe?"
,"29":"No os angustiéis buscando qué comer o qué beber."
,"30":"Por todas esas cosas se afanan los paganos. Vuestro Padre ya sabe que las necesitáis."
,"31":"Buscad su reino, y todo eso se os dará por añadidura."
,"32":"No tengáis miedo, pequeño rebaño, porque vuestro Padre ha decidido daros el reino."
,"33":"Vended lo que tengáis y dad limosna con ello. Haceos bolsas que no se gasten y riquezas inagotables en el cielo, donde no entra ningún ladrón, ni roe la polilla;"
,"34":"porque donde esté vuestra riqueza, allí estará vuestro corazón'."
,"35":"'Estad preparados y tened encendidas vuestras lámparas."
,"36":"Sed como los criados que esperan a su amo de retorno de las bodas para abrirle tan pronto como llegue y llame."
,"37":"¡Dichosos los criados a quienes el amo encuentra en vela a su llegada! Os aseguro que los hará sentar a la mesa y se pondrá a servirlos él mismo."
,"38":"Si llega a medianoche o de madrugada y los encuentra así, ¡dichosos ellos!"
,"39":"Tened en cuenta que si el amo de casa supiera a qué hora iba a venir el ladrón, estaría en guardia y no dejaría que asaltaran su casa."
,"40":"Estad preparados también vosotros, porque a la hora que menos penséis vendrá el hijo del hombre'."
,"41":"Entonces Pedro le dijo: 'Señor, esta parábola, ¿la dices por nosotros o por todos?'."
,"42":"El Señor contestó: '¿Quién es, entonces, el administrador fiel y prudente, para que dé a la servidumbre la comida a su hora?"
,"43":"¡Dichoso ese criado si, al llegar su amo, lo encuentra cumpliendo con su deber!"
,"44":"Os aseguro que le pondrá al frente de todos sus bienes."
,"45":"Pero si ese criado, pensando que su amo va a tardar en venir, se pone a maltratar a los demás criados y criadas y a comer y a beber hasta emborracharse,"
,"46":"su amo vendrá el día y la hora que él menos lo espere, lo castigará severamente y lo pondrá en la calle, donde se pone a los que no son fieles."
,"47":"El criado que sabe lo que su amo quiere y no lo hace será severamente castigado."
,"48":"Pero el que no lo sabe, si hace algo que merece castigo, será castigado con menos severidad. Al que mucho se le da, mucho se le reclamará; y al que mucho se le confía, más se le pedirá."
,"49":"'He venido a traer fuego a la tierra, ¡y cuánto deseo ya que arda!"
,"50":"Tengo que recibir un bautismo de dolores, y estoy angustiado hasta que se realice."
,"51":"¿Creéis que he venido a traer la paz al mundo? Os digo que no, sino división."
,"52":"Pues en adelante estarán divididos cinco en una casa, tres contra dos y dos contra tres."
,"53":"Estará dividido el padre contra el hijo y el hijo contra el padre, la madre contra la hija y la hija contra la madre, la suegra contra la nuera y la nuera contra la suegra'."
,"54":"Decía también a la gente: 'Cuando veis levantarse una nube por poniente, decís: Va a llover, y así es."
,"55":"Y cuando sentís soplar el viento del sur, decís: Va a hacer calor, y así sucede."
,"56":"¡Hipócritas!, sabéis interpretar el aspecto de la tierra y del cielo, ¿y cómo no sabéis interpretar el tiempo presente?"
,"57":"¿Por qué no juzgáis vosotros mismos con justicia?"
,"58":"Cuando vayas con tu adversario al juez, procura ponerte de acuerdo con él en el camino, no sea que te entregue al juez, el juez te ponga en manos de la policía y la policía te meta en la cárcel."
,"59":"Te aseguro que no saldrás de allí hasta que hayas pagado el último céntimo'."
}`)
	CurrentBook.AddChapter(13, `{
"1":"En aquel momento llegaron algunos anunciándole que Pilato había matado a unos galileos, mezclando su sangre con la de las víctimas que ofrecían en sacrificio."
,"2":"Jesús les dijo: '¿Pensáis que esos galileos eran los más pecadores de todos los galileos porque sufrieron eso?"
,"3":"Os digo que no; y, si no os arrepentís, todos pereceréis igualmente."
,"4":"¿Creéis que aquellos dieciocho sobre los que cayó la torre de Siloé y los mató eran los únicos culpables entre todos los vecinos de Jerusalén?"
,"5":"Os digo que no. Todos pereceréis igualmente si no os arrepentís'."
,"6":"Les contó esta parábola: 'Un hombre tenía una higuera plantada en su viña; fue a buscar higos en ella, y no los encontró."
,"7":"Dijo al viñador: Hace ya tres años que vengo a buscar higos en ella y no los encuentro. Córtala. ¿Por qué va a ocupar un terreno inútilmente?"
,"8":"El viñador dijo: Señor, déjala también este año; yo cavaré alrededor y le echaré estiércol,"
,"9":"a ver si da higos; si no los da, la cortas'."
,"10":"Un sábado estaba enseñando en una sinagoga."
,"11":"Había allí una mujer poseída de un espíritu inmundo, que la tenía enferma hacía dieciocho años; estaba encorvada y no podía de ninguna manera enderezarse."
,"12":"Jesús, al verla, la llamó y le dijo: 'Mujer, quedas libre de tu enfermedad'."
,"13":"Le impuso las manos y, al instante, se enderezó y empezó a alabar a Dios."
,"14":"El jefe de la sinagoga, indignado porque Jesús había curado en sábado, decía al pueblo: 'Hay seis días para trabajar; venid en ésos y curaos; no vengáis en sábado'."
,"15":"Jesús le respondió: '¡Hipócritas! ¿No suelta cada uno de vosotros su buey o su asno del pesebre en sábado y lo lleva a beber?"
,"16":"Y a esta mujer, que es una hija de Abrahán, a la que Satanás tenía atada desde hace dieciocho años, ¿no se la puede soltar de su atadura en sábado?'."
,"17":"Y al decir esto, todos sus adversarios quedaron avergonzados, mientras que la gente se regocijaba por los milagros que él hacía."
,"18":"Jesús les dijo: '¿A qué se parece el reino de Dios y a qué lo compararé?"
,"19":"Es como un grano de mostaza, que toma un hombre, lo echa en su huerto y crece hasta llegar a ser como un árbol, en cuyas ramas anidan las aves."
,"20":"¿A qué compararé el reino de Dios?"
,"21":"Es como la levadura que una mujer toma y la mete en tres medidas de harina, hasta que fermenta toda la masa'."
,"22":"Camino de Jerusalén, iba recorriendo pueblos y aldeas, enseñando."
,"23":"Uno le preguntó: 'Señor, ¿son pocos los que se salvan?'. Le respondió:"
,"24":"'Esforzaos por entrar por la puerta estrecha, porque os digo que muchos intentarán entrar y no podrán."
,"25":"Una vez que el amo de la casa se haya levantado y cerrado la puerta, os quedaréis fuera y comenzaréis a llamar a la puerta: ¡Señor, ábrenos!"
,"26":"Y empezaréis a decir: Hemos comido y bebido contigo, tú has enseñado en nuestras plazas."
,"27":"Pero él os dirá: No sé de dónde sois; apartaos de mí, agentes de injusticias."
,"28":"Allí será el llanto y el rechinar de dientes cuando veáis a Abrahán, a Isaac y a Jacob y a todos los profetas en el reino de Dios, mientras que vosotros sois echados fuera."
,"29":"De oriente y de occidente, del norte y del sur vendrán a sentarse a la mesa en el reino de Dios."
,"30":"Pues hay últimos que serán primeros y hay primeros que serán últimos'."
,"31":"En aquel momento se acercaron unos fariseos, y le dijeron: 'Anda, vete de aquí, porque Herodes quiere matarte'."
,"32":"Y él les dijo: 'Id y decid a ese zorro: Hoy y mañana seguiré echando demonios y haciendo curaciones, y pasado mañana terminaré."
,"33":"Por lo demás, seguiré mi camino hoy, mañana y pasado mañana, porque no puede ser que un profeta muera fuera de Jerusalén'."
,"34":"'¡Jerusalén, Jerusalén!, que matas a los profetas y apedreas a los que te son enviados. ¡Cuántas veces he querido reunir a tus hijos como una gallina a sus polluelos bajo las alas, y no has querido!"
,"35":"Sabed que vuestra casa se queda abandonada. Y os digo que ya no me veréis hasta que llegue el momento en que digáis: Bendito el que viene en nombre del Señor'."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Un sábado fue a comer en casa de uno de los jefes de los fariseos; éstos lo estaban acechando."
,"2":"Delante de él había un hombre hidrópico."
,"3":"Jesús preguntó a los doctores de la ley y a los fariseos: '¿Está permitido curar en sábado o no?'."
,"4":"Y ellos se quedaron callados. Jesús le agarró de la mano, lo curó y lo despidió."
,"5":"Luego les dijo: '¿Quién de vosotros, si su hijo o un buey cae a un pozo, no lo saca inmediatamente, aunque sea sábado?'."
,"6":"Y no pudieron responderle."
,"7":"Jesús, al observar que los invitados escogían los primeros puestos, les dijo esta parábola: 'Cuando alguien te invite a una boda,"
,"8":"no te pongas en el primer asiento, no sea que haya otro invitado más honorable que tú,"
,"9":"venga el que te invitó y te diga: Cede el sitio a éste, y entonces tengas que ir avergonzado a ocupar el último puesto."
,"10":"Por el contrario, cuando seas invitado, ponte en el último puesto, y así, cuando venga el que te invitó, te dirá: Amigo, sube más arriba. Entonces te verás honrado ante todos los comensales."
,"11":"Porque el que se ensalza será humillado y el que se humilla será ensalzado'."
,"12":"Dijo también al que le había invitado: 'Cuando des una comida o una cena, no invites a tus amigos, ni a tus hermanos, ni a tus parientes, ni a tus vecinos ricos; no sea que ellos te inviten a su vez y ya quedas pagado."
,"13":"Cuando des un banquete invita a los pobres, a los inválidos, a los cojos, a los ciegos;"
,"14":"entonces serás dichoso porque ellos no pueden pagarte, y recibirás tu recompensa en la resurrección de los justos'."
,"15":"Uno de los convidados, al oír esto, le dijo: 'Dichoso el que participe en el convite del reino de Dios'."
,"16":"Él le contestó: 'Un hombre daba un gran banquete e invitó a muchos."
,"17":"A la hora del banquete mandó a sus criados a decir a los invitados: Venid, que ya está preparado el banquete."
,"18":"Y todos a una comenzaron a excusarse. El primero dijo: He comprado un campo y necesito ir a verlo; te ruego que me excuses."
,"19":"Otro dijo: He comprado cinco pares de bueyes y voy a probarlos; te ruego que me excuses."
,"20":"Un tercero dijo: Me he casado y no puedo ir."
,"21":"El criado regresó y se lo contó a su amo. El amo, irritado, dijo a su criado: Sal de prisa a las plazas y a las calles de la ciudad y trae a los pobres y a los inválidos, a los ciegos y a los cojos."
,"22":"El criado dijo: Señor, he hecho lo que me mandaste y todavía hay sitio."
,"23":"El amo le dijo: Sal por los caminos y cercados, y obliga a la gente a entrar para que se llene la casa."
,"24":"Pues os digo que ninguno de los invitados probará mi banquete'."
,"25":"Le seguía mucha gente. Él se volvió y les dijo:"
,"26":"'Si uno viene a mí y no deja a su padre y a su madre, a su mujer y a sus hijos, hermanos y hermanas, y aun su propia vida, no puede ser discípulo mío."
,"27":"El que no carga con su cruz y me sigue, no puede ser mi discípulo."
,"28":"Porque, ¿quién de vosotros, si quiere construir una torre, no se sienta primero para calcular los gastos y ver si tendrá para terminarla?"
,"29":"No sea que, si pone los cimientos y no puede acabar la obra, todos los que se enteren comiencen a burlarse de él,"
,"30":"diciendo: Éste comenzó a construir y no ha podido terminar."
,"31":"O ¿qué rey, si va a ir a la guerra contra otro, no se sienta antes a considerar si puede enfrentarse con diez mil al que viene contra él con veinte mil?"
,"32":"Y si ve que no, cuando todavía está lejos, envía una embajada pidiendo la paz."
,"33":"Así pues, el que de vosotros no renuncie a todos sus bienes, no puede ser mi discípulo."
,"34":"Buena es la sal; pero si hasta la sal se vuelve sosa, ¿con qué se sazonará?"
,"35":"No sirve ni para la tierra ni para el estercolero; se la tira. ¡El que tenga oídos para oír que oiga!'."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Los publicanos y los pecadores se acercaban para oírlo."
,"2":"Y los fariseos y los maestros de la ley lo criticaban: 'Éste acoge a los pecadores y come con ellos'."
,"3":"Entonces les propuso esta parábola:"
,"4":"'¿Quién de vosotros, si tiene cien ovejas y se le pierde una, no deja las noventa y nueve en el campo y va en busca de la perdida hasta que la encuentra?"
,"5":"Cuando la encuentra, se la echa sobre sus hombros lleno de alegría,"
,"6":"y, al llegar a casa, llama a los amigos y vecinos y les dice: ¡Alegraos conmigo, porque he encontrado mi oveja perdida!"
,"7":"Pues bien, os digo que habrá más alegría en el cielo por un pecador que se arrepiente que por noventa y nueve justos que no necesitan arrepentirse'."
,"8":"'O ¿qué mujer que tenga diez monedas, si pierde una, no enciende una luz y barre la casa y la busca cuidadosamente hasta encontrarla?"
,"9":"Y cuando la encuentra, llama a sus amigas y vecinas y les dice: Alegraos conmigo, porque he encontrado la moneda que había perdido."
,"10":"Os digo que así se alegrarán los ángeles de Dios por un pecador que se arrepiente'."
,"11":"Y continuó: 'Un hombre tenía dos hijos."
,"12":"Y el menor dijo a su padre: Padre, dame la parte de la herencia que me corresponde. Y el padre les repartió la herencia."
,"13":"A los pocos días el hijo menor reunió todo lo suyo, se fue a un país lejano y allí gastó toda su fortuna llevando una mala vida."
,"14":"Cuando se lo había gastado todo, sobrevino una gran hambre en aquella comarca y comenzó a padecer necesidad."
,"15":"Se fue a servir a casa de un hombre del país, que le mandó a sus tierras a guardar cerdos."
,"16":"Tenía ganas de llenar su estómago con las algarrobas que comían los cerdos, y nadie se las daba."
,"17":"Entonces, reflexionando, dijo: ¡Cuántos jornaleros de mi padre tienen pan de sobra, y yo aquí me muero de hambre!"
,"18":"Volveré a mi padre y le diré: Padre, he pecado contra el cielo y contra ti."
,"19":"Ya no soy digno de llamarme hijo tuyo: tenme como a uno de tus jornaleros."
,"20":"Se puso en camino y fue a casa de su padre. Cuando aún estaba lejos, su padre lo vio y, conmovido, fue corriendo, se echó al cuello de su hijo y lo cubrió de besos."
,"21":"El hijo comenzó a decir: Padre, he pecado contra el cielo y contra ti. Ya no soy digno de llamarme hijo tuyo."
,"22":"Pero el padre dijo a sus criados: Sacad inmediatamente el traje mejor y ponédselo; poned un anillo en su mano y sandalias en sus pies."
,"23":"Traed el ternero cebado, matadlo y celebremos un banquete,"
,"24":"porque este hijo mío había muerto y ha vuelto a la vida, se había perdido y ha sido encontrado. Y se pusieron todos a festejarlo."
,"25":"El hijo mayor estaba en el campo y, al volver y acercarse a la casa, oyó la música y los bailes."
,"26":"Llamó a uno de los criados y le preguntó qué significaba aquello."
,"27":"Y éste le contestó: Que ha vuelto tu hermano, y tu padre ha matado el ternero cebado porque lo ha recobrado sano."
,"28":"Él se enfadó y no quiso entrar. Su padre salió y se puso a convencerlo."
,"29":"Él contestó a su padre: Hace ya tantos años que te sirvo sin desobedecer jamás tus órdenes, y nunca me has dado ni un cabrito para celebrar una fiesta con mis amigos."
,"30":"¡Ahora llega ese hijo tuyo, que se ha gastado toda su fortuna con malas mujeres, y tú le matas el ternero cebado!"
,"31":"El padre le respondió: ¡Hijo mío, tú estás siempre conmigo, y todo lo mío es tuyo!"
,"32":"En cambio, tu hermano, que estaba muerto, ha vuelto a la vida; estaba perdido y lo hemos encontrado. Convenía celebrar una fiesta y alegrarse'."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Dijo también a sus discípulos: 'Un hombre rico tenía un administrador que fue denunciado como malversador de bienes."
,"2":"Entonces lo llamó y le dijo: ¿Qué es lo que oigo de ti? Dame cuenta de tu administración, porque quedas despedido."
,"3":"Entonces el administrador se puso a pensar: ¿Qué voy a hacer, pues mi amo me quita la administración? Cavar, ya no puedo; mendigar, me da vergüenza."
,"4":"Ya sé lo que voy a hacer, para que haya quien me reciba en su casa cuando no tenga la administración."
,"5":"Llamó a todos los deudores de su amo, y preguntó al primero: ¿Cuánto debes a mi amo?"
,"6":"Él contestó: Cien barriles de aceite. Él le dijo: Toma tu recibo, siéntate y escribe cincuenta."
,"7":"Luego dijo a otro: ¿Y tú cuánto debes? Él respondió: Cien fanegas de trigo. Él le dijo: Toma tu recibo y escribe ochenta."
,"8":"El amo alabó al administrador infiel, porque había actuado con sagacidad. Pues los hijos del mundo son más sagaces en sus relaciones que los hijos de la luz."
,"9":"Y yo os digo: Haceos amigos con el dinero injustamente adquirido, para que, cuando os falte, os reciban en las moradas eternas."
,"10":"El que es fiel en lo poco lo es también en lo mucho, y el que es injusto en lo poco lo es también en lo mucho."
,"11":"Si no habéis sido fieles con el dinero injustamente adquirido, ¿quién os confiará los bienes verdaderos?"
,"12":"Y si no habéis sido fieles en lo ajeno, ¿quién os dará lo que es vuestro?'"
,"13":"'Nadie puede servir a dos amos, porque odiará a uno y amará al otro, o se apegará a uno y despreciará al otro. No podéis servir a Dios y al dinero'."
,"14":"Los fariseos, amigos del dinero, oían esto y se burlaban de él."
,"15":"Y les dijo: 'Vosotros presumís de justos delante de los hombres, pero Dios conoce vuestros corazones; porque lo que se estima tanto entre los hombres, no tiene valor alguno ante Dios."
,"16":"La ley y los profetas llegan hasta Juan; desde entonces se anuncia el reino de Dios y todos se esfuerzan para entrar en él."
,"17":"Es más fácil que pasen el cielo y la tierra que caiga una sola letra de la ley."
,"18":"Todo el que se divorcia de su esposa y se casa con otra comete adulterio, y el que se casa con una mujer divorciada comete adulterio'."
,"19":"'Había un hombre rico que se vestía de púrpura y de lino y banqueteaba a diario espléndidamente."
,"20":"Un pobre, llamado Lázaro, cubierto de úlceras, estaba sentado a la puerta del rico;"
,"21":"quería quitarse el hambre con lo que caía de la mesa del rico; hasta los perros se acercaban y le lamían sus úlceras."
,"22":"Murió el pobre, y los ángeles le llevaron al seno de Abrahán. Murió también el rico, y lo enterraron."
,"23":"Y estando en el infierno, entre torturas, levantó los ojos y vio a lo lejos a Abrahán, y a Lázaro a su lado."
,"24":"Y gritó: Padre Abrahán, ten compasión de mí y envía a Lázaro para que moje en agua la yema de su dedo y refresque mi lengua, porque me atormentan estas llamas."
,"25":"Abrahán repuso: Hijo, acuérdate que ya recibiste tus bienes durante la vida, y Lázaro, por el contrario, males. Ahora él está aquí consolado, y tú eres atormentado."
,"26":"Y no es esto todo. Entre vosotros y nosotros hay un gran abismo, de tal manera que los que quieran ir de acá para allá no puedan, ni los de allí venir para acá."
,"27":"El rico dijo: Entonces, padre, te ruego que le envíes a mi casa paterna,"
,"28":"pues tengo cinco hermanos, para que les diga la verdad y no vengan también ellos a este lugar de tormentos."
,"29":"Abrahán respondió: Ya tienen a Moisés y a los profetas; ¡que los escuchen!"
,"30":"Pero él dijo: No, padre Abrahán; que si alguno de entre los muertos va a verlos, se arrepentirán."
,"31":"Abrahán contestó: Si no escuchan a Moisés y a los profetas, no harán caso ni aunque resucite un muerto'."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Después dijo a sus discípulos: 'Es inevitable que haya escándalos; pero ¡ay de aquel que los provoca!"
,"2":"Más le valdría que le ataran al cuello una piedra de molino y lo tiraran al mar antes que escandalizar a uno de estos pequeñuelos."
,"3":"Tened cuidado'. 'Si tu hermano peca, repréndelo; y si se arrepiente, perdónalo. "
,"4":"Y si peca contra ti siete veces al día y otras tantas se acerca a ti diciendo: Me arrepiento, perdónalo'."
,"5":"Los apóstoles le dijeron: 'Acrecienta nuestra fe'."
,"6":"Y el Señor dijo: 'Si tuvierais una fe tan grande como un grano de mostaza y dijerais a este sicómoro: Arráncate y trasplántate al mar, él os obedecería'."
,"7":"'¿Quién de vosotros, que tenga un criado arando o pastoreando, le dice cuando llega del campo: Pronto, ven y siéntate a la mesa?"
,"8":"Más bien le dirá: Prepárame de cenar, y ponte a servirme hasta que yo coma y beba. Después comerás y beberás tú."
,"9":"¿Tendría que estar agradecido al criado porque hizo lo que se le había ordenado?"
,"10":"Así también vosotros, cuando hayáis hecho lo que se os haya ordenado, decid: Somos siervos inútiles; hemos hecho lo que debíamos hacer'."
,"11":"Yendo Jesús camino de Jerusalén, pasó por entre Samaría y Galilea."
,"12":"Al entrar en una aldea, salieron diez leprosos a su encuentro, que se detuvieron a distancia"
,"13":"y se pusieron a gritar: 'Jesús, maestro, ten compasión de nosotros'."
,"14":"Al verlos, les dijo: 'Id a presentaros a los sacerdotes'. Y mientras iban, quedaron limpios."
,"15":"Uno de ellos, al verse curado, volvió alabando a Dios en voz alta"
,"16":"y se echó a los pies de Jesús, dándole gracias. Éste era samaritano."
,"17":"Jesús dijo: '¿No han quedado limpios los diez? ¿Dónde están los otros nueve?"
,"18":"¿No hubo quien volviera a dar gracias a Dios, sino este extranjero?'."
,"19":"Y le dijo: 'Levántate, anda; tu fe te ha salvado'."
,"20":"Los fariseos le preguntaron cuándo iba a llegar el reino de Dios. Él respondió: 'La llegada del reino de Dios no será espectacular."
,"21":"No se dirá: Está aquí o allí, porque el reino de Dios está dentro de vosotros'."
,"22":"Y dijo a sus discípulos: 'Tiempo vendrá en que desearéis ver uno de los días del hijo del hombre y no lo veréis."
,"23":"Y os dirán: Miradlo allí, o miradlo aquí. No vayáis, ni corráis."
,"24":"Porque de la misma manera que el relámpago brilla desde un punto a otro del cielo, así será cuando venga el hijo del hombre en su día."
,"25":"Pero antes es preciso que sufra mucho y que sea rechazado por esta generación."
,"26":"Como sucedió en los días de Noé, así será en los días del hijo del hombre."
,"27":"Comían, bebían y se casaban ellos y ellas, hasta que Noé entró en el arca, vino el diluvio y acabó con todos."
,"28":"Lo mismo que sucedió en los días de Lot: Comían, bebían, compraban, vendían, plantaban, edificaban;"
,"29":"pero el día en que Lot salió de Sodoma llovió fuego y azufre del cielo y acabó con todos."
,"30":"Así sucederá el día en que el hijo del hombre se manifieste."
,"31":"Aquel día, el que esté en la terraza y tenga en la casa sus enseres, que no baje a recogerlos; el que esté en el campo, que no vuelva atrás a buscar nada."
,"32":"Acordaos de la mujer de Lot."
,"33":"El que intente salvar su vida la perderá, y el que la pierda la encontrará."
,"34":"Os digo que en aquella noche dos estarán juntos en una mesa; a uno se lo llevarán, y a otro lo dejarán."
,"35":"Estarán dos mujeres moliendo juntas, a una se la llevarán y a otra la dejarán'."
,"36":"Y le preguntaron: '¿Dónde será, Señor?'."
,"37":"Él contestó: 'Donde esté el cuerpo, allí se reunirán los buitres'."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Sobre la necesidad de orar siempre sin desfallecer jamás, les dijo esta parábola:"
,"2":"'Había en una ciudad un juez que no temía a Dios ni respetaba a los hombres."
,"3":"Una viuda, también de aquella ciudad, iba a decirle: Hazme justicia contra mi enemigo."
,"4":"Durante algún tiempo no quiso; pero luego pensó: Aunque no temo a Dios ni respeto a los hombres,"
,"5":"le voy a hacer justicia para que esta viuda me deje en paz y no me moleste más'."
,"6":"Y el Señor dijo: 'Considerad lo que dice el juez injusto."
,"7":"¿Y no hará Dios justicia a sus elegidos, que claman a él día y noche? ¿Les va a hacer esperar?"
,"8":"Yo os digo que les hará justicia prontamente. Pero el hijo del hombre, cuando venga, ¿encontrará fe en la tierra?'."
,"9":"A unos que se tenían por justos y despreciaban a los demás les dijo esta parábola:"
,"10":"'Dos hombres fueron al templo a orar; uno era fariseo y el otro publicano."
,"11":"El fariseo, de pie, hacía en su interior esta oración: Dios mío, te doy gracias porque no soy como el resto de los hombres: ladrones, injustos, adúlteros, ni como ese publicano;"
,"12":"yo ayuno dos veces por semana y pago los diezmos de todo lo que poseo."
,"13":"El publicano, por el contrario, se quedó a distancia y no se atrevía ni a levantar sus ojos al cielo, sino que se golpeaba el pecho y decía: Dios mío, ten compasión de mí, que soy un pecador."
,"14":"Os digo que éste volvió a su casa justificado, y el otro no. Porque el que se ensalza será humillado, y el que se humilla será ensalzado'."
,"15":"Le presentaron unos niños para que les impusiera las manos. Los discípulos, al verlo, los regañaban."
,"16":"Pero Jesús los llamó y dijo: 'Dejad que los niños se acerquen a mí y no se lo impidáis, porque de los que son como ellos es el reino de Dios."
,"17":"Os aseguro que el que no reciba el reino de Dios como un niño no entrará en él'."
,"18":"Un hombre dintinguido le preguntó: 'Maestro bueno, ¿qué tengo que hacer para heredar la vida eterna?'."
,"19":"Jesús le contestó: '¿Por qué me llamas bueno? El único bueno es Dios."
,"20":"Sabes los mandamientos: No cometerás adulterio, no matarás, no robarás, no levantarás falso testimonio, honra a tu padre y a tu madre'."
,"21":"Él dijo: 'Todo eso lo he guardado desde mi juventud'."
,"22":"Al oírlo Jesús, le dijo: 'Aún te queda una cosa por hacer: Vende todo lo que tienes, dáselo a los pobres y tendrás un tesoro en el cielo; después, ven y sígueme'."
,"23":"El joven, al oír esto, se quedó muy triste, porque era muy rico."
,"24":"Jesús dijo al verlo tan triste: '¡Qué difícilmente entrarán en el reino de Dios los que tienen riquezas!"
,"25":"Pues es más fácil que un camello pase por el ojo de una aguja que un rico entre en el reino de Dios'."
,"26":"Los presentes dijeron: 'Entonces, ¿quién podrá salvarse?'."
,"27":"Y Jesús les contestó: 'Lo que es imposible a los hombres es posible para Dios'."
,"28":"Entonces Pedro le dijo: 'Nosotros lo hemos dejado todo y te hemos seguido'."
,"29":"Jesús dijo: 'Os aseguro que nadie deja casa, mujer, hermanos, parientes e hijos por el reino de Dios,"
,"30":"sin que reciba mucho más en este mundo y después la vida eterna'."
,"31":"Llevó aparte a los doce y les dijo: 'Mirad, vamos a Jerusalén y se va a cumplir todo lo que escribieron los profetas sobre el hijo del hombre."
,"32":"Lo entregarán a los paganos, se burlarán de él, lo insultarán, lo escupirán"
,"33":"y, después de azotarlo, lo matarán; pero al tercer día resucirará'."
,"34":"Ellos no entendieron nada de todo esto, pues eran palabras oscuras para ellos y no entendían su significado."
,"35":"Cuando se acercaba a Jericó, había un ciego sentado al lado del camino pidiendo limosna."
,"36":"Al oír pasar a la gente, preguntó qué era aquello."
,"37":"Y le dijeron: 'Es que pasa Jesús de Nazaret'."
,"38":"Entonces gritó: '¡Jesús, hijo de David, ten compasión de mí!'."
,"39":"Los que iban delante lo reprendieron para que callase, pero él gritaba con más fuerza: '¡Hijo de David, ten compasión de mí!'."
,"40":"Jesús se detuvo y mandó que se lo trajeran. Cuando se acercó, le preguntó:"
,"41":"'¿Qué quieres que te haga?'. Y él le contestó: 'Señor, que vea'."
,"42":"Jesús le dijo: '¡Ve! Tu fe te ha salvado'."
,"43":"Y al instante recobró la vista y lo siguió dando gracias a Dios. Todo el pueblo, al ver esto, alababa a Dios."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Entró en Jericó y andaba por la ciudad."
,"2":"Había allí un hombre, llamado Zaqueo, jefe de publicanos y rico."
,"3":"Intentaba ver a Jesús, pero no podía por la gente, porque era bajo de estatura."
,"4":"Se adelantó y se subió a un sicómoro para poder verlo, porque iba a pasar por allí."
,"5":"Cuando Jesús llegó al lugar, levantó los ojos y le dijo: 'Zaqueo, baja en seguida, porque hoy tengo que hospedarme en tu casa'."
,"6":"Bajó en seguida y lo recibió muy contento."
,"7":"Al ver esto, todos murmuraban y decían: 'Se ha hospedado en casa de un pecador'."
,"8":"Zaqueo, puesto en pie, dijo al Señor: 'Señor, voy a dar la mitad de mis bienes a los pobres; y si he estafado a alguien, le devolveré cuatro veces más'."
,"9":"Jesús le dijo: 'Hoy ha entrado la salvación en esta casa, porque también éste es hijo de Abrahán."
,"10":"El hijo del hombre ha venido a buscar y a salvar lo que estaba perdido'."
,"11":"Como la gente lo escuchaba, les propuso una parábola, ya que estaban cerca de Jerusalén y creían que la manifestación del reino de Dios era inminente."
,"12":"Dijo: 'Un hombre de la nobleza marchó a un país lejano para recibir la dignidad real y volver."
,"13":"Llamó a diez criados, les dio diez monedas de gran valor y les dijo: Negociad mientras vengo."
,"14":"Pero sus conciudadanos lo odiaban y enviaron tras él una embajada diciendo: No lo queremos por rey."
,"15":"Él regresó investido de la realeza, y mandó llamar a los criados a los que había dado el dinero para saber cuánto había ganado cada uno."
,"16":"El primero se presentó y dijo: Señor, tu dinero ha producido diez veces más."
,"17":"Y le contestó: Muy bien, criado bueno; puesto que has sido fiel en lo poco, recibe el gobierno de diez ciudades."
,"18":"El segundo llegó y dijo: Señor, tu dinero ha producido cinco veces más."
,"19":"Y dijo igualmente a éste: Manda tú también en cinco ciudades."
,"20":"Llegó otro y dijo: Señor, aquí tienes tu dinero, que he tenido guardado en un pañuelo,"
,"21":"porque tuve miedo de ti, pues eres un hombre duro; recoges lo que no pusiste y cosechas lo que no sembraste."
,"22":"Él le dijo: Por tus mismas palabras te juzgo, mal criado. ¿Sabías que soy muy duro, que recojo lo que no he puesto y cosecho lo que no he sembrado?"
,"23":"Y ¿por qué no pusiste mi dinero en la banca, y yo, al volver, lo hubiera retirado con los intereses?"
,"24":"Y dijo a los que estaban presentes: Quitadle la moneda y dádsela al que tiene diez monedas."
,"25":"Ellos le dijeron: Señor, ya tiene diez monedas."
,"26":"Yo os digo que al que tiene se le dará, y al que no tiene aun lo que tiene se le quitará."
,"27":"En cuanto a mis enemigos, esos que no me quisieron por rey, traedlos aquí y degolladlos en mi presencia'."
,"28":"Y dicho esto, continuó adelante camino de Jerusalén."
,"29":"Al llegar cerca de Betfagé y de Betania, junto al monte de los Olivos, envió a dos discípulos diciéndoles:"
,"30":"'Id a la aldea de enfrente y, a la entrada, encontraréis un pollino atado sobre el que nadie ha montado aún; desatadlo y traedlo."
,"31":"Si alguien os pregunta: ¿Por qué lo desatáis?, decidle: El Señor lo necesita'."
,"32":"Los enviados fueron y lo encontraron como les había dicho."
,"33":"Mientras ellos desataban el pollino, sus dueños les dijeron: '¿Por qué desatáis el pollino?'."
,"34":"Ellos replicaron: 'El Señor lo necesita'."
,"35":"Y se lo llevaron a Jesús. Echaron sus mantos sobre el pollino y montaron a Jesús."
,"36":"A medida que avanzaba, ellos extendían sus mantos en el camino a modo de alfombra."
,"37":"Al acercarse a la bajada del monte de los Olivos, todos los que iban con él, llenos de alegría, comenzaron a alabar a Dios a grandes voces por todos los milagros que habían visto,"
,"38":"diciendo: ¡Bendito el que viene, el rey, en nombre del Señor!,¡Paz en el cielo!,¡Viva Dios altísimo!."
,"39":"Algunos fariseos de entre la gente le dijeron: 'Maestro, reprende a tus discípulos'."
,"40":"Él les dijo: 'Os digo que si éstos se callaran gritarían las piedras'."
,"41":"Al acercarse y ver la ciudad, lloró por ella,"
,"42":"y dijo: '¡Ojalá en este día conocieras también tú el mensaje de paz! Pero está oculto y no puedes verlo."
,"43":"Porque llegará un día en que tus enemigos te rodearán con trincheras, te cercarán y te estrecharán por todas partes"
,"44":"y te echarán al suelo. Matarán a todos tus habitantes y no dejarán de ti piedra sobre piedra, porque no has conocido el tiempo en el que Dios te ha visitado'."
,"45":"Entró en el templo y se puso a echar a los vendedores,"
,"46":"diciéndoles: 'Está escrito: Mi casa es casa de oración, pero vosotros la habéis convertido en una cueva de ladrones'."
,"47":"Todos los días enseñaba en el templo. Los sumos sacerdotes, los maestros de la ley y los principales del pueblo trataban de prenderlo;"
,"48":"pero no sabían cómo hacerlo, porque todo el pueblo estaba pendiente de él escuchándole."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Un día, mientras enseñaba al pueblo en el templo y anunciaba el evangelio, los sumos sacerdotes, los maestros de la ley y los ancianos"
,"2":"se le acercaron, y le preguntaron: '¿Con qué autoridad haces todo esto? ¿Quién te ha dado esa autoridad?'."
,"3":"Él les respondió: 'Yo también os haré una pregunta. Decidme:"
,"4":"¿El bautismo de Juan era del cielo o de los hombres?'."
,"5":"Ellos se hicieron este razonamiento: 'Si decimos que del cielo, nos dirá: Entonces ¿por qué no creísteis en él?"
,"6":"Y si decimos que de los hombres, todo el pueblo nos apedreará, porque están convencidos de que Juan era profeta'."
,"7":"Y respondieron: 'No lo sabemos'."
,"8":"Jesús entonces les dijo: 'Tampoco yo os digo con qué autoridad hago todo esto'."
,"9":"Se puso luego a decir al pueblo esta parábola: 'Un hombre plantó una viña, la arrendó a unos viñadores y se fue de viaje por mucho tiempo."
,"10":"A su debido tiempo mandó un criado a los viñadores para que le dieran su parte de la vendimia. Pero los viñadores lo golpearon y lo despidieron con las manos vacías."
,"11":"De nuevo les mandó otro criado; y también a éste lo golpearon, lo maltrataron y lo despidieron con las manos vacías."
,"12":"Les envió un tercero, y también lo hirieron y lo echaron."
,"13":"El dueño de la viña se dijo entonces: ¿Qué haré? Enviaré a mi hijo querido; a él lo respetarán."
,"14":"Pero los viñadores, al verlo, se dijeron: Éste es el heredero; matémoslo, y nos quedaremos con su herencia."
,"15":"Lo echaron fuera de la viña, y lo mataron. ¿Qué hará con ellos el dueño de la viña?"
,"16":"Irá, acabará con los viñadores y dará la viña a otros'. Al oír esto dijeron: '¡No lo quiera Dios!'."
,"17":"Jesús los miró y les dijo: '¿Pues qué significa aquello que está escrito: La piedra que los constructores,desecharon, ésa ha venido a ser piedra angular?"
,"18":"El que caiga sobre esa piedra se estrellará, y sobre el que ella caiga será aplastado'."
,"19":"Los maestros de la ley y los sumos sacerdotes quisieron entonces mismo echarle mano, pues comprendieron que la parábola iba por ellos, pero temieron al pueblo."
,"20":"Se quedaron en acecho y enviaron espías que aparentaban ser justos, para cazarlo en alguna palabra y así entregarlo al poder y a la autoridad del gobernador."
,"21":"Le preguntaron: 'Maestro, sabemos que hablas y enseñas con rectitud, que no te importa nada el qué dirán y que enseñas de verdad el camino del Señor."
,"22":"¿Nos es lícito pagar el impuesto al césar o no?'."
,"23":"Jesús, conociendo su malicia, les dijo: 'Mostradme una moneda."
,"24":"¿De quién es la efigie y la inscripción?'. Respondieron: 'Del césar'."
,"25":"Él les dijo: 'Pues dad al césar lo que es del césar y a Dios lo que es de Dios'."
,"26":"No pudieron cazarlo en ninguna de sus palabras en presencia del pueblo y, maravillados de su respuesta, se callaron."
,"27":"Se le acercaron unos saduceos, que niegan la resurrección, y le preguntaron:"
,"28":"'Maestro, Moisés nos prescribió: Si el hermano de uno muere, dejando mujer, sin hijos, su hermano debe casarse con la viuda y dar descendencia al hermano."
,"29":"Eran siete hermanos. El primero se casó, y murió sin dejar hijos."
,"30":"El segundo"
,"31":"y el tercero, y así hasta el séptimo, se casaron con la viuda, y murieron sin dejar hijos."
,"32":"Finalmente murió también la mujer."
,"33":"En la resurrección, ¿de quién de ellos será mujer? Porque los siete la tuvieron por mujer'."
,"34":"Jesús les dijo: 'Los hijos de este mundo se casan unos con otros;"
,"35":"pero los que han sido dignos de tener parte en el otro mundo y en la resurrección de los muertos, hombres y mujeres, no se casarán."
,"36":"Ya no pueden morir, pues son como los ángeles, hijos de Dios, al ser hijos de la resurrección."
,"37":"Y que los muertos resucitan, el mismo Moisés lo da a entender en lo de la zarza, cuando llama al Señor: Dios de Abrahán, Dios de Jacob, Dios de Isaac."
,"38":"No es un Dios de muertos, sino de vivos, porque para él todos viven'."
,"39":"Entonces unos maestros de la ley dijeron: '¡Bien dicho, maestro!'."
,"40":"Y no se atrevieron a preguntarle más."
,"41":"Y les preguntó: '¿Cómo puede decirse que el mesías es hijo de David,"
,"42":"pues David mismo dice en el libro de los Salmos: El Señor dijo a mi Señor: Siéntate a mi derecha,"
,"43":"hasta que ponga a tus enemigos, debajo de tus pies?"
,"44":"Pues si el mismo David lo llama Señor, ¿cómo puede ser hijo suyo?'."
,"45":"Y dijo a sus discípulos ante todo el pueblo:"
,"46":"'Guardaos de los maestros de la ley, a los que les gusta llevar vestidos ostentosos, ser saludados en las plazas, ocupar los primeros puestos en las sinagogas"
,"47":"y que devoran los bienes de las viudas mientras aparentan hacer largas oraciones. Ellos serán juzgados muy severamente'."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Levantando la vista, vio a unos ricos que echaban sus ofrendas en las arcas del tesoro."
,"2":"Vio también que una viuda echaba unos céntimos,"
,"3":"y dijo: 'Os aseguro que esta pobre viuda ha echado más que todos los demás;"
,"4":"porque esos otros han echado de lo que les sobra, pero ella ha echado de su pobreza todo lo que tenía para vivir'."
,"5":"Como algunos decían que el templo era muy bello por sus piedras tan hermosas y por los exvotos, dijo:"
,"6":"'Llegará un día en que de eso que veis no quedará piedra sobre piedra. Todo será destruido'."
,"7":"Y le preguntaron: 'Maestro, ¿cuándo sucederá eso y cuál será la señal de que estas cosas van a cumplirse?'."
,"8":"Él contestó: 'Mirad que no os engañen, porque vendrán muchos en mi nombre diciendo: 'Yo soy el mesías' y 'El tiempo ha llegado'. No los sigáis."
,"9":"Cuando oigáis hablar de guerras y de revoluciones, no os alarméis, porque es necesario que eso suceda; pero todavía no será el fin'."
,"10":"Y continuó diciendo: 'Se levantarán pueblos contra pueblos y reinos contra reinos;"
,"11":"habrá grandes terremotos, hambre y peste en diversos lugares, sucesos espantosos y grandes señales en el cielo."
,"12":"Pero antes de todo esto, os echarán mano, os perseguirán, os llevarán a las sinagogas y a las cárceles y os harán comparecer ante los reyes y los gobernadores por causa mía."
,"13":"Esto os servirá para dar testimonio."
,"14":"No os preocupéis de vuestra defensa,"
,"15":"pues yo os daré un lenguaje y una sabiduría que no podrán resistir ni contradecir todos vuestros adversarios."
,"16":"Hasta vuestros padres, hermanos, parientes y amigos os entregarán, e incluso harán que maten a algunos de vosotros."
,"17":"Todos os odiarán por causa mía."
,"18":"Pero ni un cabello de vuestra cabeza perecerá."
,"19":"Con vuestra perseverancia salvaréis vuestras vidas'."
,"20":"'Cuando veáis a Jerusalén cercada por ejércitos, sabed que se aproxima su destrucción."
,"21":"Entonces los que estén en Judea que huyan a los montes, los que estén dentro de la ciudad que se alejen y los que estén en el campo que no entren en la ciudad."
,"22":"Serán días de castigo, en los que se cumplirá todo lo que está escrito."
,"23":"¡Ay de las que estén encinta y criando en aquellos días! Porque habrá una grande angustia sobre la tierra y un gran castigo contra este pueblo."
,"24":"Caerán al filo de la espada, irán prisioneros a todas las naciones y Jerusalén será pisoteada por los paganos hasta que llegue a su fin el tiempo de los paganos'."
,"25":"'Habrá señales en el sol, en la luna y en los astros; las naciones estarán angustiadas en la tierra y enloquecidas por el estruendo del mar y de las olas;"
,"26":"los hombres, muertos de terror y de ansiedad por lo que se le echa encima al mundo, pues las columnas de los cielos se tambalearán."
,"27":"Entonces verán al hijo del hombre venir en una nube con gran poder y majestad."
,"28":"Cuando comiencen a suceder estas cosas, tened ánimo y levantad la cabeza, porque se acerca vuestra liberación'."
,"29":"Les puso un ejemplo: 'Mirad la higuera y todos los árboles:"
,"30":"cuando echan hojas, conocéis que el verano se acerca."
,"31":"Así también vosotros, cuando veáis todo esto, sabed que el reino de Dios está cerca."
,"32":"Os aseguro que no pasará esta generación antes de que suceda todo esto."
,"33":"El cielo y la tierra pasarán, pero mis palabras no pasarán."
,"34":"'Cuidad de que vuestros corazones no se emboten por el vicio, la borrachera y las preocupaciones de la vida, y caiga de improviso sobre vosotros este día"
,"35":"como un lazo, porque así vendrá ese día sobre todos los habitantes de la tierra."
,"36":"Estad alerta y orad en todo momento para que podáis libraros de todo lo que ha de venir y presentaros ante el hijo del hombre'."
,"37":"Por el día enseñaba en el templo y las noches salía a pasarlas en el monte de los Olivos."
,"38":"Y todo el pueblo madrugaba para acudir al templo a oírlo."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Se acercaba la fiesta de los panes sin levadura, llamada la pascua."
,"2":"Y los sumos sacerdotes y los maestros de la ley buscaban la manera de quitarlo de en medio, pues temían al pueblo."
,"3":"Satanás entró en Judas, el llamado Iscariote, que era uno de los doce."
,"4":"Y fue a hablar con los sumos sacerdotes y con los jefes militares sobre la manera de entregárselo."
,"5":"Ellos se alegraron y se comprometieron a darle dinero."
,"6":"Judas aceptó la propuesta, y buscaba la ocasión de entregarlo sin que la gente se enterara."
,"7":"Llegó el día de los panes sin levadura, cuando había que sacrificar el cordero pascual,"
,"8":"y Jesús envió a Pedro y a Juan, diciendo: 'Id y preparad la cena de la pascua'."
,"9":"Ellos le dijeron: '¿Dónde quieres que la preparemos?'."
,"10":"Él les dijo: 'Al entrar en la ciudad, encontraréis un hombre que lleva un cántaro de agua; seguidlo hasta la casa donde entre,"
,"11":"y diréis al dueño de la casa: El maestro manda decirte: ¿Dónde está la sala en la que voy a comer con mis discípulos la cena de la pascua?"
,"12":"Él os mostrará en el piso de arriba una habitación grande y alfombrada; preparadla allí'."
,"13":"Fueron y encontraron todo como les había dicho, y prepararon la cena de la pascua."
,"14":"A la hora determinada se puso a la mesa con sus discípulos."
,"15":"Y les dijo: 'He deseado vivamente comer esta pascua con vosotros antes de mi pasión."
,"16":"Os digo que ya no la comeré hasta que se cumpla en el reino de Dios'."
,"17":"Tomó una copa, dio gracias y dijo: 'Tomad y repartidla entre vosotros,"
,"18":"pues os digo que ya no beberé del fruto de la vid hasta que llegue el reino de Dios'."
,"19":"Luego tomó pan, dio gracias, lo partió y se lo dio, diciendo: 'Esto es mi cuerpo, que es entregado por vosotros; haced esto en recuerdo mío'."
,"20":"Y de la misma manera el cáliz, después de la cena, diciendo: 'Este cáliz es la nueva alianza sellada con mi sangre, que es derramada por vosotros."
,"21":"Pero ved que la mano del que me entrega está conmigo en la mesa."
,"22":"Porque el hijo del hombre se va, según lo decretado; pero ¡ay del hombre que lo entrega!'."
,"23":"Ellos comenzaron a preguntarse unos a otros quién sería el que iba a cometer tal acción."
,"24":"Surgió también una discusión entre ellos sobre quién debía ser considerado como el más grande."
,"25":"Él les dijo: 'Los reyes de las naciones las tiranizan y sus príncipes reciben el nombre de bienhechores."
,"26":"Entre vosotros no ha de ser así, sino que el mayor entre vosotros será como el más joven, y el que mande como el que sirve."
,"27":"En efecto, ¿quién es más grande, el que se sienta a la mesa o el que sirve? ¿No es el que se sienta a la mesa? Pues bien, yo estoy en medio de vosotros como el que sirve."
,"28":"Vostros habéis perseverado conmigo en mis pruebas,"
,"29":"y yo os voy a dar el reino como mi Padre me lo dio a mí,"
,"30":"para que comáis y bebáis a mi mesa en mi reino y os sentéis sobre tronos para juzgar a las doce tribus de Israel'."
,"31":"'Simón, Simón, mira que Satanás ha pedido poder cribaros como el trigo,"
,"32":"pero yo he rogado por ti para que no desfallezca tu fe. Y tú, cuando te arrepientas, confirma a tus hermanos'."
,"33":"Pero él le dijo: 'Señor, estoy dispuesto a ir contigo a la cárcel y hasta a la muerte'."
,"34":"Jesús le contestó: 'Pedro, te digo que no cantará hoy el gallo antes que hayas negado tres veces que me conoces'."
,"35":"Después les dijo: 'Cuando os envié sin bolsa, sin alforjas y sin sandalias, ¿os faltó algo?'. Ellos contestaron: 'Nada'."
,"36":"Y añadió: 'Ahora, el que tenga bolsa que la tome, y lo mismo la alforja; y el que no tenga, venda su manto y compre una espada."
,"37":"Pues os digo que debe cumplirse en mí lo que está escrito: Y fue contado entre los delincuentes. Porque se acerca el cumplimiento de todo lo que se refiere a mí'."
,"38":"Ellos le dijeron: 'Señor, aquí hay dos espadas'. Les respondió: 'Es bastante'."
,"39":"Salió y fue, según su costumbre, al monte de los Olivos. Sus discípulos lo acompañaban."
,"40":"Cuando llegó al lugar, les dijo: 'Orad para no caer en la tentación'."
,"41":"Él se apartó de ellos como un tiro de piedra, se arrodilló y se puso a orar,"
,"42":"diciendo: 'Padre, si quieres, aleja de mí este cáliz, pero no se haga mi voluntad, sino la tuya'."
,"43":"Y se le apareció un ángel del cielo reconfortándolo."
,"44":"Entró en agonía, y oraba más intensamente; sudaba como gotas de sangre, que corrían por el suelo."
,"45":"Se levantó de la oración, fue a sus discípulos y los encontró dormidos por la tristeza."
,"46":"Y les dijo: '¿Por qué dormís? Levantaos y orad para que no caigáis en la tentación'."
,"47":"Aún estaba hablando, cuando apareció un gran tropel de gente encabezado por el llamado Judas, uno de los doce, el cual se acercó a Jesús para besarlo."
,"48":"Jesús le dijo: 'Judas, ¿con un beso entregas al hijo del hombre?'."
,"49":"Los que estaban con él, viendo lo que iba a ocurrir, le dijeron: 'Señor, ¿les damos con la espada?'."
,"50":"Uno de ellos dio un golpe al criado del sumo sacerdote y le cortó la oreja derecha."
,"51":"Jesús dijo: '¡Basta ya! ¡Dejad!'. Y tocando la oreja lo curó."
,"52":"Y dijo a los sumos sacerdotes, a los oficiales del templo y a los ancianos que habían venido a prenderlo: 'Habéis venido a prenderme como a un ladrón, con espadas y palos."
,"53":"Todos los días estaba con vosotros en el templo, y no me echasteis mano; pero ésta es vuestra hora y el poder de las tinieblas'."
,"54":"Lo apresaron y lo condujeron a la casa del sumo sacerdote. Pedro lo seguía de lejos."
,"55":"Ellos encendieron fuego en medio del patio y se sentaron alrededor; Pedro se sentó entre ellos."
,"56":"Una criada lo vio sentado junto al fuego, lo miró fijamente y dijo: 'También éste andaba con él'."
,"57":"Pedro lo negó, diciendo: 'No lo conozco, mujer'."
,"58":"Poco después otro, al verlo, dijo: 'Tú también eres de ellos'. Y Pedro dijo: 'Hombre, no lo soy'."
,"59":"Transcurrió como una hora, y otro afirmó rotundamente: 'Seguro que también éste andaba con él, porque es galileo'."
,"60":"Pedro dijo: 'Hombre, no sé lo que dices'. E inmediatamente, mientras aún estaba hablando, cantó un gallo."
,"61":"El Señor se volvió, miró a Pedro, y Pedro se acordó de la palabra del Señor cuando le había dicho: 'Antes que cante el gallo hoy, me negarás tres veces'."
,"62":"Y saliendo fuera, lloró amargamente."
,"63":"Los que custodiaban a Jesús se burlaban de él y lo golpeaban;"
,"64":"lo cubrieron con un velo y le preguntaban: 'Adivina quién te ha pegado'."
,"65":"Y le decían muchas otras injurias."
,"66":"Al amanecer, celebraron consejo los ancianos del pueblo, los sumos sacerdotes y los maestros de la ley; lo llevaron al tribunal"
,"67":"y le dijeron: 'Si tú eres el mesías, dínoslo'. Jesús les contestó: 'Si os lo digo, no me vais a creer;"
,"68":"y si yo os pregunto, no me vais a responder."
,"69":"Pero desde ahora el hijo del hombre estará sentado a la derecha de Dios todopoderoso'."
,"70":"Todos dijeron: 'Luego ¿eres tú el hijo de Dios?'. Y él les respondió: 'Vosotros lo decís: Yo lo soy'."
,"71":"Ellos replicaron: '¿Qué necesidad tenemos ya de testigos, si nosotros mismos lo hemos oído de su boca?'."
}`)
	CurrentBook.AddChapter(23, `{
"1":"Se levantó la asamblea, lo condujeron a Pilato"
,"2":"y comenzaron a acusarle, diciendo: 'Nosotros lo hemos encontrado alborotando a nuestra nación, prohibiendo pagar tributo al césar y diciendo que él es el cristo rey'."
,"3":"Pilato le preguntó: '¿Tú eres el rey de los judíos?'. Y él respondió: 'Tú lo dices'."
,"4":"Pilato dijo a los sumos sacerdotes y a la gente: 'No encuentro ninguna culpa en este hombre'."
,"5":"Pero ellos insistían con más energía: 'Alborota al pueblo enseñando por toda Judea, desde Galilea, donde empezó, hasta aquí'."
,"6":"Pilato al oír esto, preguntó si era galileo;"
,"7":"al asegurarse de que era de la jurisdicción de Herodes, se lo envió, porque Herodes estaba también en Jerusalén por aquellos días."
,"8":"Herodes se alegró mucho de ver a Jesús, porque hacía bastante tiempo que quería verlo, pues había oído hablar de él y esperaba verle hacer algún milagro."
,"9":"Le hizo muchas preguntas, pero él no respondía nada."
,"10":"Por su parte, los sumos sacerdotes y los maestros de la ley estaban allí y lo acusaban duramente."
,"11":"Herodes, con sus soldados, trató con desprecio a Jesús, se burló de él, le puso un vestido blanco y lo envió a Pilato."
,"12":"Aquel día Herodes y Pilato se hicieron amigos, pues antes eran enemigos."
,"13":"Pilato convocó a los sumos sacerdotes, a las autoridades y al pueblo, y les dijo:"
,"14":"'Me habéis traído a este hombre como alborotador del pueblo; yo lo he interrogado delante de vosotros y no lo he encontrado culpable de las cosas de que lo acusáis."
,"15":"Herodes tampoco, puesto que nos lo ha devuelto. Nada ha hecho, pues, que merezca la muerte."
,"16":"Por tanto, lo pondré en libertad después de haberlo castigado'."
,"17":"Por la fiesta tenía por costumbre sortarles a un preso."
,"18":"Ellos gritaban todos a una: 'Quita de en medio a ése y deja en libertad a Barrabás'."
,"19":"Éste había sido encarcelado por una revuelta ocurrida en la ciudad y por un homicidio."
,"20":"De nuevo Pilato les habló, pues quería dejar en libertad a Jesús."
,"21":"Pero ellos gritaron: '¡Crucifícalo! ¡Crucifícalo!'."
,"22":"Y Pilato, por tercera vez, les dijo: '¿Pero qué mal ha hecho? No he encontrado en él causa alguna de muerte; por tanto, lo dejaré en libertad después de haberlo castigado'."
,"23":"Pero ellos insistían a grandes voces pidiendo que fuera crucificado, y sus gritos cada vez eran más fuertes."
,"24":"Pilato decidió que se hiciera como pedían."
,"25":"Dejó en libertad al que pedían (el que había sido encarcelado por una revuelta y un homicidio), y les entregó a Jesús para que hicieran con él lo que quisieran."
,"26":"Cuando lo conducían, echaron mano de un tal Simón de Cirene, que venía del campo, y le cargaron la cruz para que la llevara detrás de Jesús."
,"27":"Lo seguía mucha gente del pueblo y mujeres, que se daban golpes de pecho y se lamentaban por él."
,"28":"Jesús se volvió a ellas y les dijo: 'Hijas de Jerusalén, no lloréis por mí; llorad por vosotras y por vuestros hijos,"
,"29":"porque vienen días en los que se dirá: Dichosas las estériles, los vientres que no han dado a luz y los pechos que no han amamantado."
,"30":"Entonces comenzarán a decir a las montañas: Caed sobre nosotros, y a los collados: Sepultadnos;"
,"31":"porque si esto hacen al leño verde, ¿qué no harán al seco?'."
,"32":"Llevaban también a dos criminales para ejecutarlos con él."
,"33":"Cuando llegaron al lugar llamado Calvario, crucificaron allí a Jesús y a los criminales, uno a la derecha y otro a la izquierda."
,"34":"Jesús decía: 'Padre, perdónalos, porque no saben lo que hacen'. Y se repartieron sus vestidos a suertes."
,"35":"El pueblo estaba mirando. Las mismas autoridades se burlaban, diciendo: 'Ha salvado a otros; que se salve a sí mismo si es el mesías de Dios, el elegido'."
,"36":"También los soldados se burlaban de él, se acercaban y le daban vinagre,"
,"37":"diciendo: 'Si tú eres el rey de los judíos, sálvate a ti mismo'."
,"38":"Encima de él había un letrero que decía: 'Éste es el rey de los judíos'."
,"39":"Uno de los criminales crucificados le insultaba diciendo: '¿No eres tú el mesías? Sálvate a ti mismo y a nosotros'."
,"40":"Pero el otro le reprendió diciendo: '¿Ni siquiera temes a Dios tú que estás en el mismo suplicio?"
,"41":"Nosotros estamos aquí en justicia, porque recibimos lo que merecen nuestras fechorías; pero éste no ha hecho nada malo'."
,"42":"Y decía: 'Jesús, acuérdate de mí cuando vengas como rey'."
,"43":"Y le contestó: 'Te aseguro que hoy estarás conmigo en el paraíso'."
,"44":"Hacia el mediodía las tinieblas cubrieron toda la tierra hasta las tres de la tarde."
,"45":"El sol se eclipsó y la cortina del templo se rasgó por medio."
,"46":"Y Jesús, con fuerte voz, dijo: 'Padre, en tus manos encomiendo mi espíritu'. Dijo esto y expiró."
,"47":"El oficial, al ver lo que había ocurrido, daba gloria a Dios, diciendo: 'Verdaderamente este hombre era justo'."
,"48":"Y toda la gente que había asistido al espectáculo, al ver lo sucedido, regresaba dándose golpes de pecho."
,"49":"Todos los conocidos de Jesús estaban a distancia, igual que las mujeres que lo habían seguido desde Galilea, presenciando todo esto."
,"50":"Un hombre llamado José, miembro del tribunal supremo, hombre bueno y justo,"
,"51":"de Arimatea, ciudad de Judea, el cual no estaba de acuerdo con las actuaciones del tribunal y que esperaba el reino de Dios,"
,"52":"se presentó a Pilato y le pidió el cuerpo de Jesús."
,"53":"Lo bajó de la cruz, lo envolvió en una sábana y lo puso en un sepulcro excavado en la roca, en el que todavía no había sido puesto nadie."
,"54":"Era el día de la preparación de la pascua, y rayaba ya el sábado."
,"55":"Las mujeres que habían acompañado a Jesús desde Galilea lo siguieron de cerca y vieron el sepulcro y cómo fue colocado su cuerpo."
,"56":"Regresaron y prepararon aromas y ungüentos. El sábado descansaron, como estaba prescrito."
}`)
	CurrentBook.AddChapter(24, `{
"1":"El primer día de la semana, al rayar el alba, volvieron al sepulcro llevando los aromas preparados."
,"2":"Y se encontraron con que la piedra había sido rodada del sepulcro."
,"3":"Entraron y no encontraron el cuerpo de Jesús, el Señor."
,"4":"Mientras ellas estaban desconcertadas por esto, se presentaron dos varones con vestidos deslumbrantes."
,"5":"Ellas se asustaron y bajaron los ojos; ellos les dijeron: '¿Por qué buscáis entre los muertos al que vive?"
,"6":"No está aquí, ha resucitado. Recordad lo que os dijo estando aún en Galilea,"
,"7":"que el hijo del hombre debía ser entregado en manos de pecadores, ser crucificado y resucitar al tercer día'."
,"8":"Ellas se acordaron de estas palabras."
,"9":"Regresaron del sepulcro y contaron todo a los once y a todos los demás."
,"10":"Eran María Magdalena, Juana y María la de Santiago y las demás que estaban con ellas las que decían estas cosas a los apóstoles."
,"11":"Aquellas palabras les parecieron un delirio, y no las creían."
,"12":"Pero Pedro se levantó y se fue corriendo al sepulcro; se asomó, y sólo vio los lienzos; y regresó a casa maravillado de lo ocurrido."
,"13":"Aquel mismo día, dos de ellos se dirigían a una aldea llamada Emaús, distante de Jerusalén unos trece kilómetros."
,"14":"Iban hablando de todos estos sucesos;"
,"15":"mientras ellos hablaban y discutían, Jesús mismo se les acercó y se puso a caminar con ellos."
,"16":"Pero estaban tan ciegos que no lo reconocían."
,"17":"Y les dijo: '¿De qué veníais hablando en el camino?'. Se detuvieron entristecidos."
,"18":"Uno de ellos, llamado Cleofás, respondió: '¿Eres tú el único forastero en Jerusalén que no sabes lo que ha sucedido en ella estos días?'."
,"19":"Él les dijo: '¿Qué?'. Ellos le contestaron: 'Lo de Jesús de Nazaret, que fue un profeta poderoso en obras y palabras ante Dios y ante todo el pueblo,"
,"20":"cómo nuestros sumos sacerdotes y nuestras autoridades lo entregaron para ser condenado a muerte y lo crucificaron."
,"21":"Nosotros esperábamos que él sería el libertador de Israel, pero a todo esto ya es el tercer día desde que sucedieron estas cosas."
,"22":"Por cierto que algunas mujeres de nuestro grupo nos han dejado asombrados: fueron muy temprano al sepulcro,"
,"23":"no encontraron su cuerpo y volvieron hablando de una aparición de ángeles que dicen que vive."
,"24":"Algunos de los nuestros fueron al sepulcro y lo encontraron todo como las mujeres han dicho, pero a él no lo vieron'."
,"25":"Entonces les dijo: '¡Qué torpes sois y qué tardos para creer lo que dijeron los profetas!"
,"26":"¿No era necesario que Cristo sufriera todo eso para entrar en su gloria?'."
,"27":"Y empezando por Moisés y todos los profetas, les interpretó lo que sobre él hay en todas las Escrituras."
,"28":"Llegaron a la aldea donde iban, y él aparentó ir más lejos;"
,"29":"pero ellos le insistieron, diciendo: 'Quédate con nosotros, porque es tarde y ya ha declinado el día'. Y entró para quedarse con ellos."
,"30":"Se puso a la mesa con ellos, tomó el pan, lo bendijo, lo partió y se lo dio."
,"31":"Entonces sus ojos se abrieron y lo reconocieron; pero él desapareció de su lado."
,"32":"Y se dijeron uno a otro: '¿No ardía nuestro corazón mientras nos hablaba en el camino y nos explicaba las Escrituras?'."
,"33":"Se levantaron inmediatamente, volvieron a Jerusalén y encontraron reunidos a los once y a sus compañeros,"
,"34":"que decían: 'Verdaderamente el Señor ha resucitado y se ha aparecido a Simón'."
,"35":"Ellos contaron lo del camino y cómo lo reconocieron al partir el pan."
,"36":"Estaban hablando de todo esto, cuando Jesús mismo se presentó en medio de ellos y les dijo: 'La paz esté con vosotros'."
,"37":"Aterrados y llenos de miedo, creían ver un espíritu."
,"38":"Él les dijo: '¿Por qué os asustáis y dudáis dentro de vosotros?"
,"39":"Ved mis manos y mis pies. Soy yo mismo. Tocadme y ved que un espíritu no tiene carne ni huesos, como veis que yo tengo'."
,"40":"Dicho esto, les mostró las manos y los pies."
,"41":"Y como ellos no creían aún de pura alegría y asombro, les dijo: '¿Tenéis algo de comer?'."
,"42":"Le dieron un trozo de pez asado."
,"43":"Lo tomó y comió delante de ellos."
,"44":"Luego les dijo: 'De esto os hablaba cuando estaba todavía con vosotros: Es necesario que se cumpla todo lo que está escrito acerca de mí en la ley de Moisés, en los Profetas y en los Salmos'."
,"45":"Entonces les abrió la inteligencia para que entendieran las Escrituras. Y les dijo:"
,"46":"'Estaba escrito que el mesías tenía que sufrir y resucitar de entre los muertos al tercer día,"
,"47":"y que hay que predicar en su nombre el arrepentimiento y el perdón de los pecados a todas las naciones, comenzando por Jerusalén."
,"48":"Vosotros sois testigos de estas cosas."
,"49":"Sabed que voy a enviar lo que os ha prometido mi Padre. Por vuestra parte quedaos en la ciudad hasta que seáis revestidos de la fuerza de lo alto'."
,"50":"Los sacó hasta cerca de Betania."
,"51":"Levantó las manos y los bendijo. Y mientras los bendecía, se separó de ellos y subió al cielo."
,"52":"Ellos lo adoraron y se volvieron a Jerusalén llenos de alegría."
,"53":"Estaban continuamente en el templo bendiciendo a Dios."
}`)

}
func ES_LSB_LoadNEMCChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Principio del evangelio de Jesucristo, hijo de Dios."
,"2":"Como está escrito en el profeta Isaías: Yo envío delante de ti a mi mensajero, para que te prepare el camino. "
,"3":"Voz que grita en el desierto: Preparad el camino del Señor. Allanad sus sendas."
,"4":"Juan Bautista se presentó en el desierto bautizando y predicando un bautismo para la conversión y el perdón de los pecados."
,"5":"Y acudían a él de la región de Judea y todos los de Jerusalén, confesaban sus pecados, y él los bautizaba en el río Jordán."
,"6":"Juan tenía un vestido de pelo de camello con un cinturón de cuero a la cintura, y se alimentaba de saltamontes y miel silvestre."
,"7":"Y decía: 'Detrás de mí viene el que es más fuerte que yo, y yo no soy digno de agacharme para desatarle la correa de sus sandalias."
,"8":"Yo os bautizo con agua, pero él os bautizará en el Espíritu Santo'."
,"9":"Por aquellos días Jesús vino desde Nazaret de Galilea y fue bautizado por Juan en el Jordán."
,"10":"En el momento en que salía del agua, vio los cielos abiertos y al Espíritu Santo como una paloma bajando sobre él,"
,"11":"y se oyó una voz del cielo: 'Tú eres mi hijo amado, mi predilecto'."
,"12":"Luego el Espíritu lo llevó al desierto."
,"13":"Y estuvo en él durante cuarenta días, siendo tentado por Satanás; y vivía entre las bestias salvajes, pero los ángeles le servían."
,"14":"Después de ser Juan encarcelado, Jesús fue a Galilea a predicar el evangelio de Dios;"
,"15":"y decía: 'Se ha cumplido el tiempo y el reino de Dios está cerca. Arrepentíos y creed en el evangelio'."
,"16":"Pasando junto al lago de Galilea, vio a Simón y a Andrés, el hermano de Simón, echando las redes en el lago, pues eran pescadores."
,"17":"Jesús les dijo: 'Venid conmigo y os haré pescadores de hombres'."
,"18":"Al instante dejaron las redes y lo siguieron."
,"19":"Fue más adelante, y vio a Santiago, el de Zebedeo, y a su hermano Juan, que estaban también dentro de la barca, remendando sus redes,"
,"20":"y al punto los llamó. Ellos, dejando a su padre Zebedeo en la barca con los jornaleros, le siguieron."
,"21":"Entraron en Cafarnaún, y, el sábado, Jesús fue a la sinagoga y se puso a enseñar."
,"22":"Todos se maravillaban de su doctrina, porque les enseñaba como quien tiene autoridad, y no como los maestros de la ley."
,"23":"En la sinagoga había un hombre poseído de un espíritu inmundo, que se puso a gritar:"
,"24":"'¿Qué tenemos que ver contigo, Jesús Nazareno? ¿Has venido a perdernos? Sé quién eres: ¡El santo de Dios!'."
,"25":"Jesús le increpó: 'Cállate y sal de él'."
,"26":"Y el espíritu inmundo, retorciéndole y gritando, salió de él."
,"27":"Todos quedaron estupefactos y se preguntaban unos a otros: '¿Qué es esto? ¡Una doctrina nueva con tanta autoridad! ¡Manda a los espíritus inmundos y le obedecen!'."
,"28":"Y su fama se extendió rápidamente por todas partes en todo el territorio de Galilea."
,"29":"Salieron de la sinagoga y fueron a la casa de Simón y de Andrés, con Santiago y Juan."
,"30":"Le dijeron que la suegra de Simón estaba en cama con fiebre."
,"31":"Él la agarró de la mano y la levantó. La fiebre desapareció, y ella se puso a atenderle."
,"32":"Al anochecer le llevaron todos los enfermos y endemoniados,"
,"33":"y toda la ciudad se agolpó a la puerta."
,"34":"Jesús curó a muchos pacientes de diversas enfermedades y lanzó muchos demonios; pero no les dejaba hablar, porque lo conocían."
,"35":"Muy de madrugada se levantó, salió y se fue a un lugar solitario, y allí estuvo rezando."
,"36":"Simón y sus compañeros lo buscaron,"
,"37":"lo encontraron y le dijeron: 'Todos te están buscando'."
,"38":"Él les dijo: 'Vamos a otra parte, a los pueblos vecinos, a predicar también allí, pues para eso he salido'."
,"39":"Y marchó a predicar en las sinagogas por toda Galilea, y echaba a los demonios."
,"40":"Se acercó a él un leproso, se puso de rodillas y le dijo: 'Si quieres, puedes limpiarme'."
,"41":"Él, compadecido, extendió la mano, lo tocó y le dijo: 'Quiero, queda limpio'."
,"42":"Y al instante quedó limpio de su lepra."
,"43":"Luego lo despidió, advirtiéndole severamente:"
,"44":"'Mira, no se lo digas a nadie; pero anda, muéstrate al sacerdote y presenta la ofrenda que ordenó Moisés para que les conste tu curación'."
,"45":"Mas él, en cuanto se retiró, comenzó a divulgar a voces lo ocurrido, de manera que ya no podía Jesús entrar públicamente en ciudad alguna, sino que andaba fuera de poblado, en lugares solitarios, y acudían a él de todas partes."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Entró de nuevo en Cafarnaún después de algunos días, y se supo que estaba en casa."
,"2":"Acudieron tantos que ni a la puerta cabían; y él les dirigía la palabra."
,"3":"Le trajeron entre cuatro un paralítico."
,"4":"Como había tanta gente, no podían presentárselo. Entonces levantaron la techumbre donde él estaba, hicieron un boquete y descolgaron la camilla con el paralítico."
,"5":"Jesús, al ver su fe, dijo al paralítico: 'Hijo, tus pecados te son perdonados'."
,"6":"Algunos de los maestros de la ley se dijeron:"
,"7":"'¿Cómo habla así éste? ¡Blasfema! ¿Quién puede perdonar los pecados sino sólo Dios?'."
,"8":"Jesús, conociendo sus pensamientos, les dijo: '¿Por qué pensáis así?"
,"9":"¿Qué es más fácil, decir al paralítico: Tus pecados son perdonados, o decirle: Levántate, carga con tu camilla y anda?"
,"10":"Pues para que veáis que el hijo del hombre tiene poder en la tierra para perdonar los pecados, dijo al paralítico:"
,"11":"¡Tú, levántate, carga con tu camilla y vete a tu casa!'."
,"12":"El paralítico se levantó, cargó inmediatamente con la camilla y salió a la vista de todos. Todos se quedaron sobrecogidos y glorificaron a Dios, diciendo: 'Jamás hemos visto cosa igual'."
,"13":"Fue de nuevo a la orilla del lago; toda la gente acudía a él, y él les enseñaba."
,"14":"Al pasar, vio a Leví, el de Alfeo, sentado en la oficina de los impuestos, y le dijo: 'Sígueme'. Él se levantó y lo siguió."
,"15":"Y estando en su casa a la mesa, muchos publicanos y pecadores se pusieron a la mesa con Jesús y sus discípulos, pues eran muchos los que lo seguían."
,"16":"Los maestros de la ley y los fariseos, al verlo comiendo con los pecadores y publicanos, decían a sus discípulos: '¿Por qué come con publicanos y pecadores?'."
,"17":"Jesús lo oyó y les dijo: 'No tienen necesidad de médico los sanos, sino los enfermos; no he venido a llamar a los justos, sino a los pecadores'."
,"18":"Los discípulos de Juan y los fariseos estaban ayunando. Se le acercaron y le preguntaron: '¿Por qué los discípulos de Juan y los discípulos de los fariseos ayunan, y en cambio los tuyos no ayunan?'."
,"19":"Jesús les dijo: '¿Es que pueden ayunar los invitados a bodas mientras el esposo está con ellos? Mientras tienen consigo al esposo no pueden ayunar."
,"20":"Pero vendrán días en que les quiten al esposo, y entonces ayunarán."
,"21":"Nadie remienda con paño nuevo un vestido viejo, pues el remiendo nuevo tiraría de lo viejo y el rasgón se haría mayor."
,"22":"Ni echa vino nuevo en odres viejos, pues el vino reventaría los odres y se perdería el vino y los odres, sino que el vino nuevo se echa en odres nuevos'."
,"23":"Un sábado iba Jesús por los sembrados, y sus discípulos comenzaron a cortar espigas al pasar."
,"24":"Los fariseos le dijeron: '¡Mira!, ¿por qué hacen en sábado lo que no está permitido?'."
,"25":"Él les respondió: '¿No habéis leído lo que hizo David cuando tuvo necesidad y sintió hambre él y los suyos?"
,"26":"¿Cómo entró en la casa de Dios, siendo sumo sacerdote Abiatar, y comió los panes de la proposición, que sólo pueden comer los sacerdotes, y dio también a los que iban con él?'."
,"27":"Y añadió: 'El sábado ha sido hecho para el hombre, y no el hombre para el sábado."
,"28":"Así que el hijo del hombre es Señor también del sábado'."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Entró de nuevo en la sinagoga. Había allí un hombre que tenía una mano seca."
,"2":"Y estaban acechando a ver si Jesús lo curaba en sábado, para acusarlo."
,"3":"Él dijo al hombre que tenía la mano seca: 'Levántate y ponte en medio'."
,"4":"Luego les dijo: '¿Está permitido en sábado hacer el bien o el mal, salvar una vida o destruirla?'. Ellos callaban."
,"5":"Entonces, mirándolos indignado y apenado por la dureza de sus corazones, dijo al hombre: 'Extiende tu mano'. La extendió y quedó sana."
,"6":"Los fariseos salieron y, con los herodianos, tomaron la resolución de acabar con él."
,"7":"Pero Jesús se retiró con sus discípulos hacia el lago, y mucha gente de Galilea lo siguió."
,"8":"Otros muchos de Judea, de Jerusalén, de Idumea, de Transjordania y de los alrededores de Tiro y Sidón, al oír las cosas que hacía, acudieron a él."
,"9":"Dijo entonces a sus discípulos que le reservaran una barca, pues la gente lo estrujaba."
,"10":"Había curado a tantos, que todos los que tenían alguna enfermedad se echaban sobre él para tocarlo."
,"11":"Los espíritus inmundos, cuando lo veían, se postraban ante él y gritaban: '¡Tú eres el hijo de Dios!'."
,"12":"Pero él les ordenaba severamente que no lo publicasen."
,"13":"Después subió al monte, llamó a los que él quiso, y ellos se acercaron a él."
,"14":"Y designó a doce para que estuvieran con él y para enviarlos a predicar"
,"15":"con poder de echar los demonios."
,"16":"Designó a estos doce: Simón, a quien llamó Pedro;"
,"17":"Santiago y su hermano Juan, hijos de Zebedeo, a quienes llamó Boanerges, que significa hijos del trueno;"
,"18":"Andrés y Felipe; Bartolomé y Mateo; Tomás y Santiago, hijo de Alfeo; Tadeo y Simón el cananeo,"
,"19":"y Judas Iscariote, el mismo que le traicionó."
,"20":"Cuando volvieron a casa, se reunió de nuevo tanta gente que no podían comer."
,"21":"Los suyos, al enterarse, salieron para llevárselo con ellos, pues decían que estaba loco."
,"22":"Los maestros de la ley, que habían venido de Jerusalén, decían: '¡Tiene a Belcebú!'; y también: '¡Echa a los demonios con el poder del príncipe de los demonios!'."
,"23":"Jesús entonces los llamó y les dijo en parábolas:"
,"24":"'¿Cómo puede ser que Satanás eche a Satanás? Si un reino está dividido contra sí mismo, ese reino no puede subsistir."
,"25":"Y si una casa está dividida contra sí misma, esa casa no puede subsistir."
,"26":"Si Satanás se alza contra sí mismo, está dividido y no puede subsistir; toca a su fin."
,"27":"Por otra parte, nadie puede entrar en la casa de un hombre fuerte y arrebatarle sus cosas si antes no lo ata; sólo así podrá saquear su casa'."
,"28":"'Os aseguro que a los hombres se les perdonarán todos los pecados y blasfemias que digan;"
,"29":"pero quien blasfeme contra el Espíritu Santo no tendrá perdón jamás y cargará con su pecado eternamente'."
,"30":"Y es que los maestros de la ley decían: 'Tiene un espíritu inmundo'."
,"31":"Llegaron la madre y los hermanos de Jesús; se quedaron fuera y lo mandaron llamar."
,"32":"La gente estaba sentada a su alrededor cuando le dijeron: 'Mira, ahí afuera te buscan tu madre y tus hermanos y hermanas'."
,"33":"Él respondió: '¿Quiénes son mi madre y mis hermanos?'."
,"34":"Y mirando a los que estaban sentados a su alrededor, dijo: 'Éstos son mi madre y mis hermanos."
,"35":"Porque el que hace la voluntad de Dios, ése es mi hermano, mi hermana y mi madre'."
}`)
	CurrentBook.AddChapter(4, `{
"1":"De nuevo comenzó a enseñar a la orilla del lago. Acudió a él tanta gente que subió a sentarse en una barca en el lago, mientras toda la gente se quedó en tierra en la orilla."
,"2":"Les enseñó muchas cosas en parábolas. Les dijo:"
,"3":"'Escuchad: Salió el sembrador a sembrar"
,"4":"y, al sembrar, parte de la semilla cayó junto al camino, vinieron las aves y se la comieron."
,"5":"Otra parte cayó en un pedregal, donde no había mucha tierra, y brotó en seguida porque la semilla no tenía profundidad en la tierra;"
,"6":"pero al salir el sol la abrasó, y por no tener raíz se secó."
,"7":"Otra cayó entre zarzas; las zarzas crecieron, la ahogaron y no dio fruto."
,"8":"Otra parte cayó en tierra buena y dio fruto lozano y crecido, una treinta, otra sesenta y otra ciento'."
,"9":"Y añadió: '¡El que tenga oídos que oiga!'."
,"10":"Cuando se quedó a solas, los doce y los que estaban a su alrededor le preguntaron el significado de las parábolas."
,"11":"Y les dijo: 'A vosotros se os ha dado conocer los secretos del reino de Dios; pero a los demás, a los que están fuera, todo les llega en parábolas"
,"12":"para que aunque miren no vean y aunque oigan no entiendan, no sea que se conviertan y sean perdonados'."
,"13":"Y les dijo: '¿No entendéis esta parábola? ¿Cómo, entonces, vais a entender las demás parábolas?"
,"14":"El sembrador siembra la palabra."
,"15":"Los de junto al camino son aquellos en los que se siembra la palabra, pero que, apenas la han oído, va Satanás y arrebata la palabra sembrada en ellos."
,"16":"Los sembrados en el pedregal son aquellos que oyen la palabra y la aceptan con alegría;"
,"17":"pero no tienen raíces, son inconstantes y, en cuanto les sobreviene, a causa de la palabra, una tribulación o persecución, inmediatamente se vienen abajo."
,"18":"Los que reciben la semilla entre zarzas son los que oyen la palabra;"
,"19":"pero en ellos brotan las preocupaciones del mundo, el engaño de las riquezas y demás ambiciones, y ahogan la palabra haciéndola infructuosa."
,"20":"Los que reciben la semilla en tierra buena son aquellos que oyen la palabra, la aceptan y dan fruto, el treinta, el sesenta o el ciento por uno'."
,"21":"También les dijo: '¿Acaso se trae una lámpara para ocultarla en una vasija o ponerla debajo de la cama? ¿No es para colocarla en el candelero?"
,"22":"Porque nada hay oculto que no sea descubierto, y nada secreto que no sea puesto en claro."
,"23":"El que tenga oídos para oír que oiga'."
,"24":"Les decía también: '¡Atención a lo que oís! Con la misma medida con que midáis seréis medidos, y se os dará con creces."
,"25":"Porque al que tiene se le dará, y al que no tiene, aun lo que tiene se le quitará'."
,"26":"También les dijo: 'El reino de Dios es como un hombre que echa una semilla en la tierra."
,"27":"Lo mismo si está dormido como si está despierto, si es de noche como si es de día, la semilla, sin que él sepa cómo, germina y crece."
,"28":"La tierra por sí misma da el fruto: primero la hierba, luego la espiga, después el grano gordo en la espiga."
,"29":"Y cuando el fruto está maduro, el hombre echa la hoz porque es el tiempo de la cosecha'."
,"30":"También les dijo: '¿Con qué compararemos el reino de Dios o con qué parábola lo explicaremos?"
,"31":"Es como un grano de mostaza, que, cuando se siembra, es la más pequeña de las semillas de la tierra;"
,"32":"pero, una vez sembrada, crece y se hace la más grande entre todas las hortalizas, y echa ramas tan grandes que las aves pueden anidar a su sombra'."
,"33":"Con muchas parábolas por el estilo les exponía la doctrina según ellos podían comprenderla,"
,"34":"y no les hablaba sin parábolas; a sus discípulos se las explicaba a solas."
,"35":"Aquel mismo día, ya caída la tarde, les dijo: 'Pasemos a la otra orilla'."
,"36":"Y dejando a la gente, lo llevaron con ellos en la barca tal como se encontraba; y le acompañaban otras barcas."
,"37":"Se levantó entonces una fuerte borrasca, y las olas saltaban por encima de la barca, de suerte que estaba a punto de llenarse."
,"38":"Jesús estaba durmiendo sobre un cabezal en la popa. Ellos lo despertaron y le dijeron: 'Maestro, ¿no te importa que perezcamos?'."
,"39":"Él se levantó, increpó al viento y dijo al mar: '¡Calla! ¡Cálmate!'. Y el viento cesó y se hizo una gran calma."
,"40":"Después les dijo: '¿Por qué sois tan miedosos? ¿Por qué no tenéis fe?'."
,"41":"Ellos quedaron sumamente atemorizados, y se decían unos a otros: '¿Quién es éste, que hasta el viento y el mar le obedecen?'."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Llegaron a la orilla opuesta, a la región de los gerasenos;"
,"2":"y, al desembarcar, le salió al encuentro, del cementerio, un hombre poseído de espíritu impuro,"
,"3":"que vivía en el cementerio y al que nadie podía sujetar ni siquiera con cadenas,"
,"4":"pues muchas veces lo habían atado con grillos y cadenas, pero él había roto las cadenas y destrozado los grillos y nadie podía sujetarlo."
,"5":"Se pasaba el día y la noche entre los sepulcros y en los montes gritando y golpeándose con piedras."
,"6":"Al ver desde lejos a Jesús, corrió, se postró ante él"
,"7":"y empezó a gritar: 'Déjame en paz, Jesús, hijo del Dios altísimo. ¡Te conjuro por Dios que no me atormentes!'."
,"8":"Es que Jesús le había ordenado: '¡Espíritu impuro, sal de ese hombre!'."
,"9":"Jesús le preguntó: '¿Cómo te llamas?'. Él contestó: 'Me llamo legión, pues somos muchos'."
,"10":"Y se puso a rogarle insistentemente que no lo echara de aquella región."
,"11":"Había por allí, en la ladera del monte, una gran piara de cerdos paciendo."
,"12":"Los espíritus impuros pidieron a Jesús: 'Envíanos a los cerdos para que entremos en ellos'."
,"13":"Y se lo permitió. Ellos salieron, se metieron en los cerdos; y la piara, de unos dos mil cerdos, se lanzó al lago por un precipicio y se ahogaron."
,"14":"Los porqueros huyeron y lo contaron en el pueblo y en los caseríos. La gente fue a ver lo que había sucedido."
,"15":"Al llegar a Jesús y ver sentado, vestido y en su sano juicio al endemoniado que había tenido la legión, se llenaron de miedo."
,"16":"Los que lo habían visto contaban lo ocurrido con el endemoniado y con los cerdos."
,"17":"Entonces rogaron a Jesús que se fuera de allí."
,"18":"Al subir a la barca Jesús, el endemoniado le pidió que le dejara ir con él."
,"19":"Jesús no le dejó, sino que le dijo: 'Vete a tu casa con los tuyos y cuéntales todo lo que el Señor, compadecido de ti, ha hecho contigo'."
,"20":"Él se fue y comenzó a publicar por la Decápolis lo que Jesús había hecho con él; y todos se admiraban."
,"21":"Cuando Jesús regresó en barca a la otra orilla, se reunió con él mucha gente, y se quedó junto al lago."
,"22":"Llegó uno de los jefes de la sinagoga, llamado Jairo, y, al ver a Jesús, se echó a sus pies"
,"23":"rogándole con insistencia: 'Mi hijita se está muriendo; ven a poner tus manos sobre ella para que se cure y viva'."
,"24":"Jesús fue con él. Lo seguía mucha gente, que lo apretujaba."
,"25":"Y una mujer que padecía hemorragias desde hacía doce años,"
,"26":"que había sufrido mucho con muchos médicos y había gastado toda su fortuna sin obtener ninguna mejoría, e incluso había empeorado,"
,"27":"al oír hablar de Jesús, se acercó a él por detrás entre la gente y le tocó el manto,"
,"28":"pues se decía: 'Con sólo tocar sus vestidos, me curo'."
,"29":"Inmediatamente, la fuente de las hemorragias se secó y sintió que su cuerpo estaba curado de la enfermedad."
,"30":"Jesús, al sentir que había salido de él aquella fuerza, se volvió a la gente y dijo: '¿Quién me ha tocado?'."
,"31":"Sus discípulos le contestaron: 'Ves que la multitud te apretuja, ¿y dices que quién te ha tocado?'."
,"32":"Él seguía mirando alrededor para ver a la que lo había hecho."
,"33":"Entonces la mujer, que sabía lo que había ocurrido en ella, se acercó asustada y temblorosa, se postró ante Jesús y le dijo toda la verdad."
,"34":"Él dijo a la mujer: 'Hija, tu fe te ha curado; vete en paz, libre ya de tu enfermedad'."
,"35":"Todavía estaba hablando, cuando llegaron algunos de casa del jefe de la sinagoga diciendo: 'Tu hija ha muerto. No molestes ya al maestro'."
,"36":"Pero Jesús, sin hacer caso de ellos, dijo al jefe de la sinagoga: 'No tengas miedo; tú ten fe, y basta'."
,"37":"Y no dejó que le acompañaran más que Pedro, Santiago y Juan, el hermano de Santiago."
,"38":"Al llegar a la casa del jefe de la sinagoga, Jesús vio el alboroto y a la gente que no dejaba de llorar y gritar."
,"39":"Entró y dijo: '¿Por qué lloráis y alborotáis así? La niña no está muerta, está dormida'."
,"40":"Y se reían de él. Jesús echó a todos fuera; se quedó sólo con los padres de la niña y los que habían ido con él, y entró donde estaba la niña."
,"41":"La agarró de la mano y le dijo: 'Talitha kumi', que significa: 'Muchacha, yo te digo: ¡Levántate!'."
,"42":"Inmediatamente la niña se levantó y echó a andar, pues tenía doce años."
,"43":"La gente se quedó asombrada. Y Jesús les recomendó vivamente que nadie se enterara. Luego mandó que diesen de comer a la niña."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Jesús salió de allí y se fue a su tierra acompañado de sus discípulos."
,"2":"El sábado se puso a enseñar en la sinagoga, y la gente, al oírlo, decía asombrada: '¿De dónde le viene a éste todo esto? ¿Cómo tiene tal sabiduría y hace tantos milagros?"
,"3":"¿No es éste el carpintero, el hijo de María y el hermano de Santiago, de José, de Judas y de Simón? ¿Y sus hermanas no viven con nosotros?'. Y se escandalizaban de él."
,"4":"Jesús les dijo: 'Sólo en su tierra, entre sus parientes y en su casa desprecian al profeta'."
,"5":"Y no pudo hacer allí ningún milagro, aparte de curar a algunos enfermos imponiéndoles las manos."
,"6":"Y se quedó sorprendido de su falta de fe. Recorrió después las aldeas del contorno enseñando. "
,"7":"Llamó a los doce y los envió de dos en dos, dándoles poder sobre los espíritus inmundos."
,"8":"Les ordenó que, aparte de un bastón, no llevasen nada para el camino: ni pan, ni alforja, ni dinero en la faja;"
,"9":"que fueran calzados con sandalias, pero que no llevaran dos túnicas."
,"10":"También les dijo: 'Quedaos en la casa en que entréis hasta que dejéis aquel lugar;"
,"11":"y si no os reciben ni os escuchan, al salir de allí sacudid el polvo de vuestros pies en testimonio contra ellos'."
,"12":"Ellos se fueron a predicar que se convirtieran;"
,"13":"echaban muchos demonios, ungían con aceite a muchos enfermos y los curaban."
,"14":"La fama de Jesús llegó a oídos del rey Herodes. Unos decían: 'Ése es Juan Bautista, que ha resucitado y tiene el poder de hacer milagros';"
,"15":"otros decían: 'Es Elías', y otros: 'Es un profeta como los antiguos'."
,"16":"Pero Herodes, al oír hablar de esto, decía: 'Es Juan, a quien yo mandé cortar la cabeza, que ha resucitado'."
,"17":"Y es que Herodes había detenido a Juan y lo había metido en la cárcel por causa de Herodías, la mujer de su hermano Filipo, que él tenía como esposa."
,"18":"Porque Juan le decía: 'No te está permitido tener la mujer de tu hermano'."
,"19":"Herodías odiaba a Juan y quería matarlo; pero no podía,"
,"20":"porque Herodes respetaba a Juan, pues reconocía que era un hombre justo y santo, y lo protegía; cuando lo oía quedaba perplejo, pero lo escuchaba con gusto."
,"21":"Y llegó el día oportuno. Herodes ofrecía un banquete en su cumpleaños a los magnates, a los tribunos y a los grandes personajes de Galilea."
,"22":"La hija de Herodías en persona entró, danzó y agradó a Herodes y a los invitados. Entonces el rey dijo a la muchacha: 'Pídeme lo que quieras y te lo daré'."
,"23":"Y juró: 'Te daré lo que me pidas, aunque sea la mitad de mi reino'."
,"24":"Ella salió y preguntó a su madre: '¿Qué pido?'. Su madre contestó: 'La cabeza de Juan el Bautista'."
,"25":"Corrió de nuevo a donde estaba el rey, entró y dijo: 'Quiero que me des inmediatamente la cabeza de Juan el Bautista en una bandeja'."
,"26":"El rey se entristeció mucho, pero no quiso desairarla por el juramento y por los invitados."
,"27":"Inmediatamente el rey mandó a un verdugo que trajera la cabeza de Juan. Él fue a la cárcel, le cortó la cabeza,"
,"28":"la trajo en una bandeja y se la dio a la muchacha, y la muchacha se la dio a su madre."
,"29":"Sus discípulos, al enterarse, fueron, recogieron el cadáver y lo sepultaron."
,"30":"Se reunieron de nuevo los apóstoles con Jesús y le contaron lo que habían hecho y enseñado."
,"31":"Él les dijo: 'Venid conmigo a un lugar retirado y tranquilo y descansad un poco'. Porque eran tantos los que iban y venían, que no tenían tiempo ni para comer."
,"32":"Y se fueron en la barca a un lugar tranquilo ellos solos."
,"33":"Al ver que se iban, muchos se dieron cuenta, y de todos los poblados corrieron allá a pie y se les adelantaron."
,"34":"Jesús, al desembarcar y ver tanta gente, se compadeció de ellos porque eran como ovejas sin pastor, y se puso a enseñarles muchas cosas."
,"35":"Como se hiciera ya muy tarde, se le acercaron sus discípulos y le dijeron:"
,"36":"'El lugar está despoblado y es ya muy tarde; despídelos, para que vayan a las aldeas y caseríos del contorno a comprarse algo de comer'."
,"37":"Jesús les respondió: 'Dadles vosotros de comer'. Ellos le dijeron: '¿Cómo vamos a comprar nosotros pan suficiente para darles de comer?'."
,"38":"Él les dijo: '¿Cuántos panes tenéis? Id a ver'. Lo averiguaron, y le dijeron: 'Cinco panes y dos peces'."
,"39":"Les mandó que se sentasen todos por grupos sobre la hierba verde."
,"40":"Y se sentaron en corros de ciento y de cincuenta."
,"41":"Jesús tomó los cinco panes y los dos peces, alzó los ojos al cielo y los bendijo; partió los panes, y se los dio a los discípulos para que se los distribuyeran a la gente. Repartió también a todos los dos peces."
,"42":"Todos comieron y se hartaron;"
,"43":"y se recogieron doce canastos llenos con las sobras de los panes y de los peces."
,"44":"Los que comieron fueron cinco mil hombres."
,"45":"Después obligó a sus discípulos a que se embarcaran y se le adelantaran rumbo a Betsaida, mientras él despedía a la gente."
,"46":"Y una vez que la despidió, se fue al monte a orar."
,"47":"Al caer la tarde, la barca estaba en medio del lago, y Jesús solo en tierra."
,"48":"Al verlos navegar fatigados, pues tenían viento contrario, hacia la madrugada fue a ellos caminando sobre el lago, e iba ya a pasar de largo;"
,"49":"ellos al verlo andar sobre el lago, dieron gritos creyendo que era un fantasma,"
,"50":"pues todos lo vieron y se asustaron. Jesús, en seguida, les habló y les dijo: 'Tranquilizaos; soy yo, no tengáis miedo'."
,"51":"Subió a la barca con ellos, y el viento se calmó."
,"52":"Los discípulos no salían de su asombro, pues no habían entendido lo de los panes y sus mentes estaban embotadas."
,"53":"Acabada la travesía, tomaron tierra en Genesaret y atracaron."
,"54":"Al desembarcar, fue reconocido en seguida;"
,"55":"se pusieron a recorrer toda aquella región, y las gentes acudían llevando en las camillas todos sus enfermos a donde oían que Jesús se encontraba."
,"56":"Adonde entraba, aldeas, ciudades o caseríos, ponían a los enfermos en las plazas y le pedían que les dejase tocar al menos la orla de su manto, y todos los que lo tocaban quedaban curados."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Los fariseos y algunos maestros de la ley de Jerusalén se acercaron a Jesús,"
,"2":"y vieron que algunos de sus discípulos se ponían a comer con manos impuras, es decir, sin habérselas lavado."
,"3":"Porque los fariseos y todos los judíos, siguiendo la tradición de sus mayores, no se ponen a comer sin haberse lavado cuidadosamente las manos;"
,"4":"y si vienen de la plaza, no comen sin haberse lavado; y tienen otras muchas prácticas que observan por tradición, tales como lavar copas, jarros y bandejas."
,"5":"Así que los fariseos y los maestros de la ley preguntaron a Jesús: '¿Por qué tus discípulos no observan la tradición de los mayores, sino que comen con las manos impuras?'."
,"6":"Él les contestó: 'Hipócritas, Isaías profetizó muy bien acerca de vosotros, según está escrito: Este pueblo me honra con los labios, pero su corazón está lejos de mí."
,"7":"En vano me rinden culto,enseñando doctrinas,que son preceptos humanos."
,"8":"Dejáis el mandamiento de Dios y os aferráis a la tradición de los hombres'."
,"9":"Y añadió: 'Vosotros, para guardar vuestras tradiciones, quebrantáis el mandamiento de Dios. "
,"10":"Porque Moisés dijo: Honra a tu padre y a tu madre, y el que maldiga a su padre o a su madre será condenado a muerte."
,"11":"Vosotros, en cambio, decís: Al que diga a su padre o a su madre: Lo que tenía para ayudarte lo he ofrecido al templo,"
,"12":"ya no le permitís hacer nada por su padre o por su madre."
,"13":"Así habéis anulado el mandamiento de Dios por una tradición que vosotros mismos os habéis transmitido. Y hacéis muchas cosas semejantes'."
,"14":"Llamó de nuevo a la gente y les dijo: 'Oídme todos y entended bien:"
,"15":"Nada que entra de fuera puede manchar al hombre; lo que sale de dentro es lo que puede manchar al hombre."
,"16":"¡El que tenga oídos para oír que oiga!'."
,"17":"Cuando dejó a la gente y entró en casa, los discípulos le dijeron que les explicara la parábola."
,"18":"Jesús les dijo: '¿Pero tampoco vosotros entendéis? ¿No comprendéis que todo lo que de fuera entra en el hombre no puede mancharlo?"
,"19":"Porque no entra en su corazón, sino en el vientre, y luego va a parar al retrete'. (Así declaraba que todos los alimentos eran puros)."
,"20":"Y continuó: 'Lo que sale del hombre es lo que mancha al hombre;"
,"21":"porque del corazón del hombre proceden los malos pensamientos, las fornicaciones, robos, homicidios,"
,"22":"adulterios, avaricia, maldad, engaño, desenfreno, envidia, blasfemia, soberbia y estupidez."
,"23":"Todas esas cosas malas salen de dentro y hacen impuro al hombre'."
,"24":"Jesús salió de allí y se fue a las regiones de Tiro y de Sidón. Entró en una casa, y no quería que se supiera; pero no pudo pasar inadvertido,"
,"25":"pues en cuanto una mujer, cuya hija tenía un espíritu inmundo, oyó hablar de Jesús, fue y se postró a sus pies."
,"26":"Esta mujer era pagana, sirofenicia de origen, y suplicaba a Jesús que echase de su hija al demonio."
,"27":"Él le respondió: 'Deja que se harten antes los hijos, que no está bien tomar el pan de los hijos para echárselo a los perros'."
,"28":"Ella dijo: 'Cierto, Señor; pero también los perros comen debajo de la mesa las migajas de los hijos'."
,"29":"Jesús le dijo: 'Vete, pues por tus palabras ya ha salido de tu hija el demonio'."
,"30":"Ella se fue a su casa, y encontró a la niña echada en la cama y que el demonio se había ido."
,"31":"Salió del territorio de Tiro, fue por Sidón y atravesó la Decápolis hacia el lago de Galilea."
,"32":"Le llevaron un sordo tartamudo y le rogaron que le impusiera sus manos."
,"33":"Jesús lo llevó aparte de la gente, le metió los dedos en los oídos, con su saliva le tocó la lengua,"
,"34":"alzó los ojos al cielo, suspiró y le dijo: '¡Epheta!', que quiere decir '¡Ábrete!'."
,"35":"Inmediatamente se le abrieron los oídos y se le soltó la atadura de la lengua, de modo que hablaba correctamente."
,"36":"Les encargó que no lo dijeran a nadie; pero cuanto más se lo ordenaba, más lo proclamaban."
,"37":"Y en el colmo de la admiración decían: 'Todo lo ha hecho bien, hasta a los sordos hace oír y a los mudos hablar'."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Por aquellos días se reunió de nuevo con él mucha gente, y no tenían qué comer. Jesús llamó a sus discípulos y les dijo:"
,"2":"'Me da lástima de esta gente, pues ya llevan tres días conmigo y no tienen qué comer."
,"3":"Si los envío en ayunas a sus casas, desfallecerán en el camino, pues algunos han venido desde lejos'."
,"4":"Sus discípulos le respondieron: '¿De dónde podremos sacar pan para hartar a tanta gente aquí, en un despoblado?'."
,"5":"Jesús les dijo: '¿Cuántos panes tenéis?'. Ellos contestaron: 'Siete'."
,"6":"Mandó a la gente que se sentara en el suelo, tomó los siete panes, dio gracias, los partió y se los entregó a sus discípulos para que los repartieran. Y los repartieron a la gente."
,"7":"Tenían también unos peces; los bendijo y mandó que los repartieran."
,"8":"Comieron todos hasta hartarse y se recogieron siete espuertas de las sobras."
,"9":"Eran como unos cuatro mil. Luego los despidió."
,"10":"A continuación subió con sus discípulos a la barca y se fue a la región de Dalmanuta."
,"11":"Los fariseos se acercaron y se pusieron a discutir con él. Para tentarlo, le pidieron una señal del cielo."
,"12":"Jesús, dando un profundo suspiro, dijo: '¿Para qué pedirá esta generación una señal? Os aseguro que no se dará ninguna señal a esta generación'."
,"13":"Los dejó y se embarcó de nuevo rumbo a la otra orilla."
,"14":"Los discípulos se habían olvidado de llevar pan, y sólo tenían uno en la barca."
,"15":"Jesús les hizo esta amonestación: 'Mirad, guardaos de la levadura de los fariseos y de la de Herodes'."
,"16":"Ellos comentaban: 'Es que no hemos traído pan'."
,"17":"Jesús, dándose cuenta, les dijo: '¿Por qué comentáis que no tenéis pan? ¿Aún no entendéis ni comprendéis? ¿Tenéis encallecido vuestro corazón?"
,"18":"¿Teniendo ojos no veis, y teniendo oídos no oís?"
,"19":"¿No os acordáis ya de cuando repartí cinco panes para cinco mil hombres? ¿Cuántos cestos recogisteis de las sobras?'. Ellos respondieron: 'Doce'."
,"20":"'Y cuando repartí los siete para los cuatro mil, ¿cuántas espuertas recogisteis?'. Dijeron: 'Siete'."
,"21":"Y él añadió: '¿Todavía no entendéis?'."
,"22":"Llegaron a Betsaida, le trajeron un ciego y le suplicaron que lo tocase."
,"23":"Jesús cogió de la mano al ciego, lo sacó fuera de la aldea, le echó saliva en los ojos, le impuso las manos y le preguntó: '¿Ves algo?'."
,"24":"Empezó a ver, y dijo: 'Veo hombres, y los veo andar como si fueran árboles'."
,"25":"Luego le puso otra vez las manos sobre los ojos, y vio claramente; recobró la vista, y veía todo desde lejos."
,"26":"Jesús le mandó a su casa, diciéndole: 'No entres siquiera en la aldea'."
,"27":"Salió Jesús con sus discípulos hacia las aldeas de Cesarea de Filipo, y en el camino les preguntó: '¿Quién dice la gente que soy yo?'."
,"28":"Ellos le dijeron: 'Unos que Juan el Bautista, otros que Elías y otros que uno de los profetas'."
,"29":"Él les dijo: 'Y vosotros, ¿quién decís que soy?'. Pedro tomó la palabra y dijo: 'Tú eres el mesías'."
,"30":"Y Jesús les ordenó que no se lo dijeran a nadie."
,"31":"Desde entonces comenzó a declararles que el hijo del hombre tenía que padecer mucho, ser rechazado por los ancianos, los sumos sacerdotes y los maestros de la ley, morir y resucitar al tercer día."
,"32":"Esto lo decía con toda claridad. Pedro se lo llevó aparte y se puso a reprenderle."
,"33":"Jesús se volvió y, mirando a sus discípulos, riñó a Pedro diciéndole: '¡Apártate de mí, Satanás!, porque tus sentimientos no son los de Dios, sino los de los hombres'."
,"34":"Llamó a la gente y a sus discípulos y les dijo: 'El que quiera venir en pos de mí, niéguese a sí mismo, tome su cruz y sígame."
,"35":"Porque el que quiera salvar su vida la perderá, pero el que pierda su vida por mí y por el evangelio la salvará."
,"36":"¿De qué le vale al hombre ganar el mundo entero si pierde su vida?"
,"37":"¿Y qué dará el hombre a cambio de su vida?"
,"38":"Porque si alguien se avergüenza de mí y de mi doctrina ante esta generación adúltera y pecadora, también el hijo del hombre se avergonzará de él cuando venga en la gloria de su Padre con los santos ángeles'."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Y les decía: 'Os aseguro que algunos de los presentes no morirán sin haber visto venir el reino de Dios con poder'."
,"2":"Seis días después Jesús tomó consigo a Pedro, a Santiago y a Juan, y los llevó a un monte alto a solas. Y se transfiguró ante ellos."
,"3":"Sus vestidos se volvieron de una blancura resplandeciente, como ningún batanero de la tierra podría blanquearlos."
,"4":"Y se les aparecieron Elías y Moisés hablando con Jesús."
,"5":"Pedro tomó la palabra y dijo a Jesús: 'Maestro, ¡qué bien se está aquí! Hagamos tres tiendas, una para ti, otra para Moisés y otra para Elías'."
,"6":"Es que no sabía lo que decía, pues estaban asustados."
,"7":"Una nube los cubrió con su sombra; y desde la nube se oyó una voz: 'Éste es mi hijo amado. Escuchadlo'."
,"8":"Miraron inmediatamente alrededor, y ya no vieron a nadie más que a Jesús solo con ellos."
,"9":"Mientras bajaban del monte, Jesús les ordenó que no contasen a nadie lo que habían visto hasta que el hijo del hombre hubiera resucitado de entre los muertos."
,"10":"Ellos guardaron el secreto, pero discutían qué querría decir con eso de 'resucitar de entre los muertos'."
,"11":"Y le preguntaron: '¿Por qué dicen los maestros de la ley que Elías debe venir antes?'."
,"12":"Él respondió: 'Elías vendrá antes a ponerlo todo en orden. Ahora bien, ¿cómo está escrito que el hijo del hombre tendrá que padecer mucho y ser despreciado?"
,"13":"Yo os digo que Elías ya ha venido y lo han tratado a su antojo, como estaba escrito de él'."
,"14":"Al llegar adonde estaban los discípulos, vio que los rodeaba mucha gente y que unos maestros de la ley discutían con ellos."
,"15":"En cuanto la gente vio a Jesús, todos quedaron sorprendidos y corrieron a saludarlo."
,"16":"Y les preguntó: '¿De qué discutíais con ellos?'."
,"17":"Uno de entre la gente le respondió: 'Maestro, te he traído a mi hijo, que tiene un espíritu mudo;"
,"18":"y cuando se apodera de él, lo tira al suelo, echa espumarajos, rechina los dientes y se queda tieso. He pedido a tus discípulos que lo echasen, pero no han podido'."
,"19":"Jesús respondió: '¡Gente incrédula! ¿Hasta cuándo tendré que estar con vosotros? ¿Hasta cuándo tendré que soportaros? Traédmelo'."
,"20":"Y se lo llevaron. Apenas el espíritu vio a Jesús, retorció violentamente al muchacho, el cual se cayó al suelo revolcándose y echando espumarajos."
,"21":"Jesús preguntó al padre: '¿Cuánto tiempo hace que le sucede esto?'. Él respondió: 'Desde la infancia;"
,"22":"y muchas veces lo tira al fuego y al agua para matarlo. Si puedes hacer algo, apiádate de nosotros y ayúdanos'."
,"23":"Jesús le dijo: '¡Si puedes...! Todo es posible para el que cree'."
,"24":"Entonces el padre del muchacho exclamó: 'Yo creo. Ayúdame a creer más'."
,"25":"Jesús, al ver que acudía más gente, increpó al espíritu inmundo diciendo: 'Espíritu mudo y sordo, yo te lo ordeno: Sal del muchacho y nunca más vuelvas a entrar en él'."
,"26":"Y el espíritu, dando gritos y haciendo que el muchacho se retorciera violentamente, salió de él, dejándolo como muerto, tanto que muchos decían que estaba muerto."
,"27":"Pero Jesús lo agarró de la mano, lo levantó, y el muchacho se mantuvo en pie."
,"28":"Cuando Jesús entró en casa, sus discípulos, a solas con él, le preguntaron: '¿Por qué nosotros no pudimos echarlo?'."
,"29":"Y él les dijo: 'A esa raza sólo se la puede expulsar con la oración y el ayuno'."
,"30":"Salieron de allí y atravesaron Galilea. Jesús no quería que se supiera,"
,"31":"porque estaba enseñando a sus discípulos. Les decía: 'El hijo del hombre va a ser entregado en manos de los hombres; lo matarán y, después de muerto, a los tres días resucitará'."
,"32":"Pero ellos no entendían estas palabras y no se atrevían a preguntarle."
,"33":"Llegaron a Cafarnaún y, una vez en casa, les preguntó: '¿Qué discutíais por el camino?'."
,"34":"Pero ellos callaban, porque en el camino habían discutido sobre quién entre ellos sería el más grande."
,"35":"Jesús se sentó, llamó a los doce y les dijo: 'El que quiera ser el primero que sea el último y el servidor de todos'."
,"36":"Tomó en sus brazos a un niño, lo puso en medio de ellos y les dijo:"
,"37":"'El que acoge a uno de estos pequeños en mi nombre me acoge a mí; y el que me acoge a mí, no es a mí a quien acoge, sino al que me ha enviado a mí'."
,"38":"Juan dijo a Jesús: 'Maestro, hemos visto a uno que echaba los demonios en tu nombre y no anda con nosotros, y se lo hemos prohibido'."
,"39":"Jesús dijo: 'No se lo prohibáis, porque nadie que haga un milagro en mi nombre puede después hablar mal de mí;"
,"40":"y el que no está en contra de nosotros está a nuestro favor'."
,"41":"'El que os dé de beber un vaso de agua por ser del mesías, os aseguro que no se quedará sin recompensa'."
,"42":"'Al que escandalice a uno de estos pequeñuelos que creen en mí, más le valdría que le ataran al cuello una rueda de molino y lo tiraran al mar."
,"43":"Si tu mano es para ti ocasión de pecado, córtatela. Más te vale entrar manco en la vida que ir con las dos manos al fuego que no se apaga."
,"44":"Y si tu pie es para ti ocasión de pecado, córtatelo."
,"45":"Más te vale entrar cojo en la vida que ser arrojado al fuego con los dos pies."
,"46":"Y si tu ojo es para ti ocasión de pecado, sácatelo."
,"47":"Más te vale entrar con un solo ojo en el reino de Dios que ser arrojado con los dos ojos"
,"48":"donde el gusano no muere y el fuego no se apaga."
,"49":"Porque todos serán salados con el fuego."
,"50":"La sal es buena; pero si se hace insípida, ¿con qué la salaréis? Tened sal en vosotros y vivid en paz los unos con los otros'."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Jesús partió de allí y se fue a Judea y al otro lado del Jordán. La gente volvió a reunirse a su alrededor; y él, según su costumbre, empezó a enseñarles."
,"2":"Se le acercaron unos fariseos y le preguntaron con intención de tentarlo: '¿Le está permitido al hombre separarse de su mujer?'."
,"3":"Jesús les respondió: '¿Qué os mandó Moisés?'."
,"4":"Ellos dijeron: 'Moisés mandó escribir un acta de divorcio y despedirla'."
,"5":"Jesús les dijo: 'Moisés escribió este precepto por la dureza de vuestros corazones."
,"6":"Pero al principio de la creación Dios los hizo macho y hembra."
,"7":"Por eso el hombre dejará a su padre y a su madre"
,"8":"y se unirá a su mujer y serán los dos una sola carne. De manera que ya no son dos, sino una sola carne."
,"9":"Por lo tanto, lo que Dios ha unido, que no lo separe el hombre'."
,"10":"Ya en casa, de nuevo los discípulos le preguntaron acerca de esto;"
,"11":"Jesús les dijo: 'El que se separe de su mujer y se case con otra comete adulterio contra la primera;"
,"12":"y si la mujer se separa de su marido y se casa con otro comete adulterio'."
,"13":"Le presentaron unos niños para que les impusiera las manos. Los discípulos los regañaban."
,"14":"Pero Jesús, al verlo, se indignó y les dijo: 'Dejad que los niños se acerquen a mí; no se lo impidáis, porque de los que son como ellos es el reino de Dios."
,"15":"Os aseguro que el que no reciba el reino de Dios como un niño no entrará en él'."
,"16":"Los tenía en brazos y los bendecía imponiéndoles las manos."
,"17":"Al salir Jesús de camino, un hombre corrió a preguntarle, arrodillándose ante él: 'Maestro bueno, ¿qué tengo que hacer para alcanzar la vida eterna?'."
,"18":"Jesús le dijo: '¿Por qué me llamas bueno? El único bueno es Dios."
,"19":"Ya conoces los mandamientos: No matarás, no cometerás adulterio, no robarás, no levantarás falso testimonio, no estafarás, honra a tu padre y a tu madre'."
,"20":"Él dijo: 'Maestro, todo eso lo he guardado desde mi juventud'."
,"21":"Jesús lo miró con amor y le dijo: 'Te queda una cosa que hacer: Anda, vende todo lo que tienes, dáselo a los pobres y tendrás un tesoro en el cielo. Después, ven y sígueme'."
,"22":"Al oír esto, el joven se fue muy triste, porque tenía muchos bienes."
,"23":"Jesús miró alrededor y dijo a sus discípulos: '¡Qué difícilmente entrarán en el reino de Dios los que tienen riquezas!'."
,"24":"Los discípulos se quedaron asombrados ante estas palabras. Pero Jesús les repitió: 'Hijos, ¡qué difícil es entrar en el reino de Dios!"
,"25":"Es más fácil que un camello pase por el ojo de una aguja que un rico entre en el reino de Dios'."
,"26":"Ellos, más asombrados todavía, se decían: 'Entonces, ¿quién puede salvarse?'."
,"27":"Jesús los miró y les dijo: 'Para los hombres esto es imposible; pero no para Dios, pues para Dios todo es posible'."
,"28":"Entonces Pedro le dijo: 'Nosotros lo hemos dejado todo y te hemos seguido'."
,"29":"Jesús dijo: 'Os aseguro que nadie deja casa, hermanos, hermanas, padre, madre, hijos o tierras por mí o por el evangelio,"
,"30":"que no reciba el ciento por uno ya en este mundo, en casas, hermanos, hermanas, madres, hijos y tierras, con persecuciones, y en el siglo venidero, la vida eterna."
,"31":"'Muchos primeros serán los últimos, y los últimos los primeros'."
,"32":"Iban camino de Jerusalén, y Jesús marchaba delante. Los discípulos lo seguían asombrados y las gentes con miedo. Llevó aparte a los doce y comenzó a decirles lo que iba a suceder."
,"33":"'Mirad, vamos a Jerusalén, y el hijo del hombre será entregado a los sumos sacerdotes y a los maestros de la ley; lo condenarán a muerte y lo entregarán a los paganos,"
,"34":"se burlarán de él, lo escupirán, lo azotarán y lo matarán, pero a los tres días resucitará'."
,"35":"Santiago y Juan, los hijos de Zebedeo, se le acercaron y dijeron: 'Maestro, queremos que hagas lo que te vamos a pedir'."
,"36":"Él les dijo: '¿Qué queréis que haga por vosotros?'."
,"37":"Y ellos dijeron: 'Que nos sentemos uno a tu derecha y otro a tu izquierda en tu gloria'."
,"38":"Jesús les dijo: '¡No sabéis lo que pedís! ¿Podéis beber el cáliz que yo beberé o ser bautizados con el bautismo con que yo seré bautizado?'."
,"39":"Ellos contestaron: '¡Podemos!'. Jesús les dijo: 'Beberéis el cáliz que yo beberé y seréis bautizados con el bautismo con el que yo seré bautizado,"
,"40":"pero el sentarse a mi derecha o a mi izquierda no es cosa mía el concederlo; es para quienes ha sido reservado'."
,"41":"Los otros diez, al oír esto, se indignaron contra Santiago y Juan."
,"42":"Jesús los llamó y les dijo: 'Sabéis que los jefes de las naciones las tiranizan y que los grandes las oprimen con su poderío."
,"43":"Entre vosotros no debe ser así, sino que si alguno de vosotros quiere ser grande que sea vuestro servidor,"
,"44":"y el que de vosotros quiera ser el primero que sea el servidor de todos;"
,"45":"de la misma manera que el hijo del hombre no ha venido a ser servido, sino a servir y a dar su vida como rescate por todos'."
,"46":"Fueron a Jericó. Y al salir de Jericó con sus discípulos y mucha gente, el hijo de Timeo (Bartimeo), un mendigo ciego, estaba sentado junto al camino."
,"47":"Al oír que pasaba Jesús el nazareno comenzó a gritar: '¡Jesús, hijo de David, ten compasión de mí!'."
,"48":"La gente le reprendía para que se callase, pero él gritaba con más fuerza: '¡Hijo de David, ten compasión de mí!'."
,"49":"Jesús se detuvo y dijo: '¡Llamadlo!'. Y llamaron al ciego diciéndole: '¡Ánimo! Levántate, que te llama'."
,"50":"Él, tirando su manto, saltó y se acercó a Jesús."
,"51":"Jesús le dijo: '¿Qué quieres que te haga?'. El ciego respondió: 'Maestro, que vuelva a ver'."
,"52":"Jesús le dijo: 'Anda, tu fe te ha curado'. Inmediatamente recobró la vista, y seguía a Jesús en el camino."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Al acercarse a Jerusalén, cerca de Betfagé y Betania, junto al monte de los Olivos, Jesús envió a dos de sus discípulos, diciéndoles:"
,"2":"'Id a la aldea de enfrente, y a la entrada encontraréis un pollino atado, que nadie ha montado aún; soltadlo y traedlo."
,"3":"Y si alguien os dice: ¿Por qué hacéis eso?, decidle: El Señor lo necesita, y en seguida os lo devolverá'."
,"4":"Ellos fueron, encontraron el pollino atado a la puerta, afuera, en la calle, y lo desataron."
,"5":"Algunos de los que estaban allí les dijeron: '¿Por qué desatáis el pollino?'."
,"6":"Ellos respondieron lo que les había dicho Jesús, y los dejaron."
,"7":"Llevaron el pollino a Jesús, pusieron encima sus mantos y Jesús se montó en él."
,"8":"Muchos alfombraban el camino con sus mantos, y otros con ramas que cortaban en los campos."
,"9":"Los que iban delante y detrás gritaban:"
,"10":"¡Bendito el que viene,en el nombre del Señor!,¡Bendito el reino que llega, de nuestro padre David!,¡Viva Dios altísimo!"
,"11":"Y entró en Jerusalén en el templo y, después de haberlo visto todo, ya tarde, salió con los doce para Betania."
,"12":"Al día siguiente, al salir de Betania, Jesús sintió hambre"
,"13":"y, viendo desde lejos una higuera que tenía hojas, fue a ver si encontraba algo en ella; pero al llegar sólo encontró hojas, pues no era tiempo de higos."
,"14":"Entonces dijo a la higuera: 'Nadie coma jamás fruto de ti'. Y lo oyeron sus discípulos."
,"15":"Llegaron a Jerusalén y, entrando en el templo, echó a los que estaban allí vendiendo y comprando; volcó las mesas de los cambistas y los asientos de los vendedores de palomas,"
,"16":"y no permitía que transportaran objetos por el templo."
,"17":"Y les enseñaba diciendo: '¿No está escrito que mi casa es casa de oración para todas las naciones? Pero vosotros la habéis convertido en una cueva de ladrones'."
,"18":"Los sumos sacerdotes y los maestros de la ley, al enterarse, buscaron el modo de acabar con él, pues le tenían miedo porque toda la gente estaba asombrada de su doctrina."
,"19":"Al atardecer, Jesús salió de la ciudad."
,"20":"Al pasar otra vez por la mañana cerca de la higuera, la vieron seca de raíz."
,"21":"Pedro se acordó y dijo a Jesús: '¡Maestro, mira!, la higuera que maldijiste se ha secado'."
,"22":"Y Jesús le respondió: 'Tened fe en Dios."
,"23":"Os aseguro que el que sin dudar interiormente lo más mínimo, sino creyendo que se cumplirán sus palabras, diga a ese monte: Quítate de ahí y échate al mar, lo alcanzará."
,"24":"Por eso os digo: Todo lo que pidáis en la oración creed que lo recibiréis, y lo tendréis."
,"25":"Cuando os pongáis a orar, si tenéis algo contra alguien, perdonádselo, para que también vuestro Padre celestial os perdone vuestros pecados."
,"26":"Pues si vosotros no perdonáis, tampoco vuestro Padre celestial os perdonará vuestras culpas'."
,"27":"Llegaron de nuevo a Jerusalén y, cuando andaba Jesús por el templo, se le acercaron los sumos sacerdotes, los maestros de la ley y los ancianos del pueblo"
,"28":"y le preguntaron: '¿Con qué autoridad haces todo esto? ¿Quién te ha dado esa autoridad?'."
,"29":"Jesús les respondió: 'Yo también os haré una pregunta, y si me contestáis os diré con qué autoridad hago todo esto."
,"30":"¿El bautismo de Juan era del cielo o era de los hombres? ¡Respondedme!'."
,"31":"Ellos se hicieron este razonamiento: 'Si decimos que del cielo, nos dirá: Entonces, ¿por qué no creísteis en él?;"
,"32":"y ¿cómo vamos a decir que de los hombres...?'. Temían al pueblo, porque todos tenían a Juan como verdadero profeta."
,"33":"Y respondieron a Jesús: 'No lo sabemos'. Y Jesús les dijo: 'Tampoco yo os digo con qué autoridad hago todo esto'."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Y se puso a hablarles en parábolas: 'Un hombre plantó una viña, la cercó con una valla, cavó en ella un lagar, edificó una torre para guardarla, la arrendó a unos viñadores y se fue de viaje."
,"2":"A su debido tiempo mandó un criado a los viñadores para recibir su parte de la vendimia;"
,"3":"pero lo agarraron, lo golpearon y lo despidieron con las manos vacías."
,"4":"De nuevo les mandó otro criado, y también lo descalabraron y lo insultaron."
,"5":"Envió a otro, y lo mataron; mandó otros muchos, y a unos los golpearon y a otros los mataron."
,"6":"Aún le quedaba uno, su hijo querido. Se lo envió el último, pensando: Respetarán a mi hijo."
,"7":"Pero los viñadores se dijeron: Éste es el heredero. Matémoslo, y nos quedaremos con su herencia."
,"8":"Lo agarraron, lo mataron y lo echaron fuera de la viña."
,"9":"¿Qué hará el dueño de la viña? Irá él, acabará con los viñadores y dará la viña a otros."
,"10":"¿No habéis leído aquello de la Escritura: La piedra que los constructores desecharon, en piedra angular se ha convertido;"
,"11":"esto ha sido obra del Señor, una maravilla a nuestros ojos'?"
,"12":"Intentaban prenderlo, porque comprendieron que la parábola iba por ellos; pero temían a la gente. Lo dejaron, y se fueron."
,"13":"Le enviaron entonces algunos fariseos y herodianos para cazarlo en alguna palabra."
,"14":"Llegaron y le dijeron: 'Maestro, sabemos que eres sincero y que no te importa nada el qué dirán, porque no tienes respetos humanos y enseñas de verdad el camino de Dios. ¿Es lícito pagar el impuesto al césar o no? ¿Lo debemos dar o no?'."
,"15":"Jesús, conociendo su hipocresía, les dijo: '¿Por qué me tentáis? Traedme una moneda, que la vea'."
,"16":"Se la llevaron, y les dijo: '¿De quién es esta efigie y esta inscripción?'. Respondieron: 'Del césar'."
,"17":"Él les dijo: 'Pues dad al césar lo que es del césar y a Dios lo que es de Dios'. Y quedaron admirados ante esa respuesta."
,"18":"Se le acercaron también unos saduceos, que niegan la resurrección, y le preguntaron:"
,"19":"'Maestro, Moisés nos escribió: Si el hermano de uno muere dejando mujer sin hijos, su hermano debe casarse con la viuda y dar descendencia a su hermano."
,"20":"Eran siete hermanos. El primero se casó, y murió sin dejar hijos."
,"21":"El segundo se casó con la viuda, y murió sin dejar descendencia; e igualmente el tercero."
,"22":"Ninguno de los siete dejó descendencia. Finalmente murió también la mujer."
,"23":"En la resurrección, cuando resuciten, ¿de quién de ellos será mujer? Porque los siete la tuvieron por mujer'."
,"24":"Jesús les dijo: 'Estáis en un error, porque no entendéis las Escrituras ni el poder de Dios."
,"25":"Porque, en la resurrección, ni los hombres ni las mujeres se casarán, sino que serán como ángeles en los cielos."
,"26":"Y acerca de la resurrección de los muertos, ¿no habéis leído en el libro de Moisés, en lo de la zarza, cómo le dijo Dios: Yo soy el Dios de Abrahán, el Dios de Isaac y el Dios de Jacob?"
,"27":"No es un Dios de muertos, sino de vivos. ¡Estáis en un grande error!'."
,"28":"Un maestro de la ley que había oído la discusión, viendo que les había contestado bien, se le acercó y le preguntó: '¿Cuál es el primero de todos los mandamientos?'."
,"29":"Jesús respondió: 'El primero es: Escucha, Israel: el Señor, Dios nuestro, es el único Señor;"
,"30":"y amarás al Señor tu Dios con todo tu corazón, con toda tu alma, con toda tu mente y con todas tus fuerzas."
,"31":"El segundo es éste: Amarás a tu prójimo como a ti mismo. No hay mandamiento mayor que éstos'."
,"32":"El escriba le dijo: 'Muy bien, maestro; con razón has dicho que él es uno solo y que no hay otro fuera de él,"
,"33":"y amarlo con todo el corazón, con toda la inteligencia y con todas las fuerzas, y amar al prójimo como a sí mismo vale mucho más que todos los holocaustos y sacrificios'."
,"34":"Jesús, al ver que había respondido tan sabiamente, le dijo: 'No estás lejos del reino de Dios'. Y ya nadie se atrevió a preguntarle más."
,"35":"Jesús, enseñando en el templo, preguntó: '¿Cómo pueden decir los maestros de la ley que el mesías es hijo de David?"
,"36":"David mismo, inspirado por el Espíritu Santo, dice: El Señor dijo a mi Señor: Siéntate a mi derecha,hasta que ponga a tus enemigos,debajo de tus pies."
,"37":"Pues si el mismo David le llama Señor, ¿cómo puede ser hijo suyo?'. Y la multitud lo escuchaba con sumo gusto."
,"38":"Y en sus enseñanzas decía: 'Guardaos de los maestros de la ley, a los que les gusta pasearse con vestidos ostentosos, ser saludados en las plazas,"
,"39":"ocupar los primeros asientos en las sinagogas y los primeros puestos en los banquetes;"
,"40":"devoran los bienes de las viudas pretextando hacer largas oraciones. Ellos serán juzgados muy severamente'."
,"41":"Sentado frente al tesoro, estaba mirando cómo la gente echaba en las arcas. Muchos ricos echaban mucho."
,"42":"Pero llegó una viuda pobre y echó unos céntimos."
,"43":"Llamó a sus discípulos y les dijo: 'Os aseguro que esa pobre viuda ha echado más que todos,"
,"44":"pues todos han echado de lo que les sobra; en cambio, ella ha echado de su indigencia todo lo que tenía para vivir'."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Al salir Jesús del templo, le dijo uno de sus discípulos: '¡Maestro, mira qué piedras y qué edificios!'."
,"2":"Jesús le dijo: '¿Ves esos grandes edificios? No quedará aquí piedra sobre piedra; todo será destruido'."
,"3":"Y estando sentado en el monte de los Olivos, de cara al templo, le preguntaron a solas Pedro, Santiago, Juan y Andrés:"
,"4":"'Dinos, ¿cuándo sucederá eso y cuál será la señal de que todas esas cosas van a cumplirse?'."
,"5":"Jesús les contestó: 'Mirad que nadie os engañe."
,"6":"Muchos vendrán usando mi nombre y diciendo: Yo soy, y engañarán a muchos."
,"7":"Cuando oigáis hablar de guerras y noticias de batallas, no os alarméis porque es necesario que eso suceda; pero todavía no será el fin."
,"8":"Se levantarán pueblos contra pueblos y reinos contra reinos; habrá hambre y terremotos por diversos lugares. Eso será el comienzo de los dolores."
,"9":"'Mirad por vosotros mismos. Os entregarán a los tribunales, os torturarán en las sinagogas y compareceréis ante los gobernadores y los reyes por causa mía; daréis testimonio entre ellos."
,"10":"Pero antes de todo, el evangelio será predicado a todos los pueblos."
,"11":"Cuando os lleven para entregaros, no os angustiéis por lo que habréis de decir; decid lo que os sea inspirado en aquella hora, pues no hablaréis vosotros, sino el Espíritu Santo."
,"12":"El hermano entregará a la muerte a su hermano, y el padre al hijo, y los hijos se alzarán contra los padres y los matarán."
,"13":"Todos os odiarán por causa mía; pero el que persevere hasta el fin se salvará'."
,"14":"'Cuando veáis el ídolo repugnante puesto donde no debe estar (el que lea que entienda), entonces los que estén en Judea que huyan a los montes;"
,"15":"el que esté en la terraza que no baje a recoger nada de su casa,"
,"16":"y el que esté en el campo que no vuelva por su manto."
,"17":"¡Ay de las que estén encinta y criando en aquellos días!"
,"18":"Rezad para que esto no caiga en invierno."
,"19":"Porque en aquellos días habrá una angustia tan grande como no la ha habido desde el principio del mundo que Dios creó hasta ahora, ni la habrá jamás."
,"20":"Y si el Señor no acortase aquellos días, nadie se salvaría; pero, en atención a los elegidos que él se escogió, acortará esos días'."
,"21":"'Entonces, si alguien os dice: El mesías está aquí o allá, no lo creáis."
,"22":"Surgirán falsos mesías y falsos profetas, y harán señales y prodigios para engañar, si fuera posible, aun a los mismos elegidos."
,"23":"Tened cuidado, pues os lo he dicho todo de antemano'."
,"24":"'En aquellos días, después de esta angustia, el sol se oscurecerá, la luna no alumbrará,"
,"25":"las estrellas caerán del cielo y las columnas de los cielos se tambalearán."
,"26":"Entonces se verá venir el hijo del hombre entre nubes con gran poder y majestad."
,"27":"Mandará a sus ángeles a reunir a sus elegidos de los cuatro vientos, desde uno a otro extremo del cielo y de la tierra'."
,"28":"'Aprended del ejemplo de la higuera. Cuando sus ramas se ponen tiernas y echan hojas, conocéis que el verano se acerca."
,"29":"Así también vosotros, cuando veáis todo esto, sabed que él ya está cerca, a las puertas."
,"30":"Os aseguro que no pasará esta generación antes de que suceda todo esto."
,"31":"El cielo y la tierra pasarán, pero mis palabras no pasarán."
,"32":"Respecto de aquel día y aquella hora, nadie los conoce, ni los ángeles del cielo, ni el hijo, sino sólo el Padre."
,"33":"Estad alerta; velad, porque ignoráis el momento."
,"34":"Es como un hombre que marchó de viaje y, al dejar su casa, puso todo en manos de sus siervos, señalando a cada cual su tarea, y encargó al portero que vigilase."
,"35":"Estad en vela, porque no sabéis cuándo viene el dueño de la casa, si por la tarde, si a medianoche, al canto del gallo o de madrugada;"
,"36":"no sea que llegue de repente y os encuentre dormidos."
,"37":"Lo que os digo a vosotros, se lo digo a todos: ¡Estad en vela!'."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Faltaban dos días para la fiesta de la pascua y los panes sin levadura. Los sumos sacerdotes y los maestros de la ley andaban buscando el modo de prenderlo con engaño y quitarlo de en medio."
,"2":"Pero decían: 'Durante la fiesta no, para que el pueblo no se alborote'."
,"3":"Estando Jesús en Betania, en casa de Simón el leproso, y puesto a la mesa, llegó una mujer llevando un frasco de alabastro con perfume de nardo auténtico, de mucho valor; rompió el alabastro y lo derramó sobre su cabeza."
,"4":"Algunos se indignaron y dijeron: '¿A qué viene este derroche de perfume?"
,"5":"Se pudo vender a gran precio y dárselo a los pobres'. Y la criticaban."
,"6":"Jesús dijo: 'Dejadla; ¿por qué la molestáis? Ha hecho una obra buena conmigo;"
,"7":"porque siempre tenéis pobres entre vosotros, y cuando queráis podéis hacerles bien; pero a mí no me tendréis siempre."
,"8":"Ha hecho lo que ha podido; se ha anticipado a ungir mi cuerpo para la sepultura."
,"9":"Os aseguro que donde se predique el evangelio, en todo el mundo, se hablará también de lo que ésta ha hecho para recuerdo suyo'."
,"10":"Entonces Judas Iscariote, uno de los doce, fue a los sumos sacerdotes para poner en sus manos a Jesús."
,"11":"Ellos, al oírlo, se alegraron y prometieron darle dinero. Y él buscaba oportunidad para entregarlo."
,"12":"El primer día de la fiesta de los panes sin levadura, cuando se sacrificaba el cordero pascual, sus discípulos le preguntaron: '¿Dónde quieres que vayamos a preparar la cena de la pascua?'."
,"13":"Mandó entonces a dos de sus discípulos y les dijo: 'Id a la ciudad, y os encontraréis con un hombre que lleva un cántaro de agua; seguidlo"
,"14":"y, donde entre, decid al dueño: El maestro dice: ¿Dónde está mi sala, en la que voy a comer con mis discípulos la cena de la pascua?"
,"15":"Él os mostrará una sala en el piso de arriba, grande, alfombrada y dispuesta. Preparadla allí'."
,"16":"Los discípulos fueron, llegaron a la ciudad y encontraron todo como les había dicho; y prepararon la cena de la pascua."
,"17":"Al atardecer, llegó él con los doce."
,"18":"Estando a la mesa y comiendo, Jesús dijo: 'Os aseguro que uno de vosotros, que come conmigo, me entregará'."
,"19":"Muy entristecidos, comenzaron a decirle uno tras otro: '¿Soy yo?'."
,"20":"Él les dijo: 'Es uno de los doce, el que moja conmigo en el mismo plato."
,"21":"El hijo del hombre se va, según está escrito de él; pero ¡ay de aquel por quien el hijo del hombre es entregado! ¡Mejor le fuera no haber nacido!'."
,"22":"Durante la cena Jesús tomó pan, lo bendijo, lo partió y se lo dio, diciendo: 'Tomad, esto es mi cuerpo'."
,"23":"Después tomó un cáliz, dio gracias, se lo pasó a ellos y bebieron de él todos."
,"24":"Y les dijo: 'Ésta es mi sangre, la sangre de la alianza, que será derramada por todos."
,"25":"Os aseguro que ya no beberé más de este fruto de la vid hasta el día en que beba un vino nuevo en el reino de Dios'."
,"26":"Después de haber cantado los himnos, salieron hacia el monte de los Olivos."
,"27":"Jesús les dijo: 'Todos tendréis en mí ocasión de caída, porque está escrito: Heriré al pastor y las ovejas se dispersarán."
,"28":"Pero después resucitaré e iré delante de vosotros a Galilea'."
,"29":"Pedro le dijo: 'Aunque fueras para todos ocasión de caída, para mí no'."
,"30":"Jesús le dijo: 'Te aseguro que esta misma noche, antes de que el gallo cante dos veces, me negarás tres'."
,"31":"Pedro insistió: '¡Aunque tenga que morir contigo, jamás te negaré!'. Y lo mismo dijeron todos los demás."
,"32":"Llegaron al huerto llamado Getsemaní, y dijo a sus discípulos: 'Quedaos aquí mientras voy a orar'."
,"33":"Tomó consigo a Pedro, a Santiago y a Juan, y comenzó a sentir terror y angustia;"
,"34":"y les dijo: 'Me muero de tristeza; quedaos aquí y velad conmigo'."
,"35":"Avanzó unos pasos, cayó de bruces y pidió que, si era posible, pasara lejos de él aquella hora."
,"36":"Decía: '¡Abba, Padre!, todo te es posible; aparta de mí este cáliz, pero no sea lo que yo quiero, sino lo que quieres tú'."
,"37":"Volvió, los encontró dormidos, y dijo a Pedro: '¡Simón!, ¿duermes? ¿No has podido velar una hora?"
,"38":"Velad y orad, para que no caigáis en tentación. El espíritu está dispuesto, pero la carne es débil'."
,"39":"De nuevo se alejó, y oró repitiendo las mismas palabras."
,"40":"Volvió otra vez y los encontró dormidos, vencidos por el sueño; y no sabían qué responder."
,"41":"Volvió por tercera vez y les dijo: '¡Dormid ya y descansad! ¡Se terminó! ¡Ha llegado la hora! El hijo del hombre va a ser entregado en manos de los pecadores."
,"42":"¡Levantaos, vamos! El que me entrega llega ya'."
,"43":"Aún estaba hablando, cuando llegó Judas, uno de los doce, y con él un gran tropel de gente con espadas y palos, enviados por los sumos sacerdotes, los maestros de la ley y los ancianos."
,"44":"El traidor les había dado esta señal: 'Al que yo bese, ése es; prendedlo y conducidlo bien seguro'."
,"45":"Llegó, se acercó y dijo: '¡Maestro!', y le besó."
,"46":"Ellos le echaron mano y lo prendieron."
,"47":"Pero uno de los que estaban con Jesús sacó la espada, dio un golpe al criado del sumo sacerdote y le cortó la oreja."
,"48":"Jesús les dijo: '¡Habéis venido a prenderme como a un ladrón con espadas y palos!"
,"49":"¡Todos los días estaba con vosotros enseñando en el templo y no me prendisteis! ¡Pero todo esto sucede para que se cumplan las Escrituras!'."
,"50":"Todos lo abandonaron y huyeron."
,"51":"Un joven, cubierto sólo con una sábana, seguía a Jesús. Le echaron mano."
,"52":"Pero él, soltando la sábana, se escapó desnudo."
,"53":"Llevaron a Jesús ante el sumo sacerdote; y se reunieron todos los sumos sacerdotes, los ancianos y los maestros de la ley."
,"54":"Pedro le había seguido de lejos hasta el patio del palacio del sumo sacerdote, y se quedó con los criados calentándose al fuego."
,"55":"Los sumos sacerdotes y el tribunal supremo en pleno buscaban un testimonio contra Jesús para condenarlo a muerte, y no lo encontraban."
,"56":"Muchos testificaban en falso contra él, pero no coincidían los testimonios."
,"57":"Algunos se levantaron para testificar en falso contra él, diciendo:"
,"58":"'Nosotros le hemos oído decir: Yo derribaré este templo hecho por mano de hombre, y en tres días edificaré otro que no estará hecho por manos humanas'."
,"59":"Y ni en esto coincidían sus testimonios."
,"60":"Entonces, en medio de la asamblea, se levantó el sumo sacerdote y preguntó a Jesús: '¿No respondes nada a lo que éstos testifican contra ti?'."
,"61":"Él permaneció callado y no respondió nada. De nuevo el sumo sacerdote le preguntó: '¿Eres tú el mesías, el hijo del Bendito?'."
,"62":"Jesús le dijo: '¡Yo soy!, y veréis al hijo del hombre sentado a la diestra del todopoderoso y venir entre las nubes del cielo'."
,"63":"Entonces el sumo sacerdote se rasgó las vestiduras y dijo: '¿Qué necesidad tenemos ya de testigos?"
,"64":"Habéis oído la blasfemia. ¿Qué os parece?'. Todos lo condenaron a muerte."
,"65":"Luego se pusieron a escupirlo; le taparon la cara y lo abofeteaban diciendo: '¡Adivina! ¡Haz el profeta!'. Y los criados le daban puñetazos."
,"66":"Pedro estaba sentado abajo, en el patio; llegó una de las criadas del sumo sacerdote"
,"67":"y, al ver a Pedro calentándose, lo miró y le dijo: 'También tú andabas con Jesús el nazareno'."
,"68":"Él lo negó diciendo: 'No sé ni entiendo lo que dices'. Salió fuera al vestíbulo, y cantó el gallo."
,"69":"Al verlo de nuevo la criada, volvió a decir a los presentes: 'Éste es de ellos'."
,"70":"Él lo negó otra vez. Y poco después los presentes decían a Pedro: 'Ciertamente eres de ellos, porque eres galileo'."
,"71":"Pero él se puso a maldecir y a perjurar: 'No conozco a ese hombre que decís'."
,"72":"Y al instante cantó el gallo por segunda vez. Pedro se acordó de lo que Jesús le había dicho: 'Antes que el gallo cante dos veces, me negarás tres'. Y se echó a llorar."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Al amanecer, celebraron consejo los sumos sacerdotes, los ancianos, y los maestros de la ley y el tribunal supremo en pleno. Ataron a Jesús, lo llevaron y se lo entregaron a Pilato. "
,"2":"Pilato le preguntó: '¿Eres tú el rey de los judíos?'. Y él respondió: 'Tú lo dices'."
,"3":"Y los sumos sacerdotes le acusaban de muchas cosas."
,"4":"Pilato le preguntó de nuevo: '¿No respondes nada? Mira de cuántas cosas te acusan'."
,"5":"Pero Jesús no respondió nada, hasta el punto de que Pilato quedó muy extrañado."
,"6":"Por la fiesta concedía la libertad a un preso, el que ellos quisieran."
,"7":"Había entonces un preso, llamado Barrabás, junto con los sediciosos que en un motín habían cometido un homicidio;"
,"8":"llegó la gente y se puso a pedirle la gracia que solía concederles."
,"9":"Pilato les dijo: '¿Queréis que os ponga en libertad al rey de los judíos?'."
,"10":"Pilato sabía que los sumos sacerdotes se lo habían entregado por envidia."
,"11":"Pero los sumos sacerdotes azuzaron al pueblo para que pidieran que les pusiera en libertad a Barrabás."
,"12":"Pilato les dijo: '¿Qué queréis que haga con el que llamáis rey de los judíos?'."
,"13":"Ellos gritaron: '¡Crucifícalo!'."
,"14":"Pilato replicó: 'Pero, ¿qué mal ha hecho?'. Y ellos gritaban más alto: '¡Crucifícalo!'."
,"15":"Pilato, entonces, queriendo satisfacer a la gente, les puso en libertad a Barrabás y les entregó a Jesús, para que lo azotaran y lo crucificaran."
,"16":"Los soldados llevaron a Jesús dentro del palacio, al pretorio, y reunieron a toda la tropa;"
,"17":"le vistieron una túnica de púrpura, le pusieron una corona trenzada de espinas"
,"18":"y comenzaron a saludarlo: 'Viva el rey de los judíos'."
,"19":"Y le golpeaban la cabeza con una caña, lo escupían y, doblando la rodilla, le hacían reverencias."
,"20":"Después de haberse burlado de él, le quitaron la túnica, le pusieron sus ropas y lo llevaron a crucificar."
,"21":"Pasaba por allí un tal Simón de Cirene, que venía del campo, padre de Alejandro y de Rufo, y le obligaron a llevar la cruz de Jesús."
,"22":"Lo llevaron a un lugar llamado Gólgota (que significa 'la calavera')."
,"23":"Le dieron vino mezclado con mirra, pero no lo bebió."
,"24":"Lo crucificaron y se repartieron a suertes sus vestidos, a ver qué se llevaría cada uno."
,"25":"Eran las nueve de la mañana cuando lo crucificaron."
,"26":"La inscripción con la causa de su condena decía: 'El rey de los judíos'."
,"27":"Con él crucificaron a dos ladrones, uno a la derecha y otro a la izquierda."
,"28":"Así se cumplió la Escritura que dice: Fue contado entre los criminales."
,"29":"Los que pasaban por allí lo insultaban moviendo la cabeza y diciendo: '¡Bah! ¡Tú, que destruías el templo y lo edificabas en tres días,"
,"30":"sálvate a ti mismo y baja de la cruz!'."
,"31":"Del mismo modo los sumos sacerdotes y los maestros de la ley se burlaban de él y decían: 'Ha salvado a otros y no puede salvarse a sí mismo."
,"32":"¡El mesías, el rey de Israel!; que baje ahora de la cruz, para que veamos y creamos'. Los que estaban crucificados con él también lo insultaban."
,"33":"Desde el mediodía se oscureció toda la tierra hasta las tres de la tarde."
,"34":"Y hacia las tres de la tarde Jesús gritó con fuerte voz: 'Eloí, Eloí, lemá sabaktani', que quiere decir: '¡Dios mío, Dios mío!, ¿por qué me has abandonado?'."
,"35":"Algunos de los presentes, al oírlo, decían: 'Mirad, llama a Elías'."
,"36":"Uno fue corriendo a buscar una esponja, la empapó en vinagre, la puso en una caña y le dio a beber, diciendo: 'Dejad, a ver si viene Elías a bajarlo'."
,"37":"Pero Jesús, lanzando un gran grito, expiró."
,"38":"La cortina del templo se rasgó en dos de arriba abajo."
,"39":"El oficial, situado frente a él, al verlo expirar así, exclamó: 'Verdaderamente este hombre era hijo de Dios'."
,"40":"Había también unas mujeres mirando desde lejos. Entre ellas María Magdalena, María la madre de Santiago el menor y de José, y Salomé,"
,"41":"las cuales, cuando estaba Jesús en Galilea, lo acompañaban y lo servían; y otras muchas que habían subido con él a Jerusalén."
,"42":"Al caer la tarde, como era la preparación de la pascua, es decir, la víspera del sábado,"
,"43":"José de Arimatea, insigne miembro del tribunal supremo, que esperaba también el reino de Dios, se atrevió a ir a Pilato a pedirle el cuerpo de Jesús."
,"44":"Pilato se extrañó de que ya hubiese muerto; llamó al oficial y le preguntó si había muerto ya."
,"45":"Al saberlo por el oficial, concedió el cadáver a José."
,"46":"Éste compró una sábana, lo bajó de la cruz, lo envolvió en la sábana y lo puso en un sepulcro excavado en la roca. Luego hizo rodar una losa para cerrar la puerta del sepulcro."
,"47":"María Magdalena y María la madre de José estuvieron mirando dónde lo ponían."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Pasado el sábado, María Magdalena, María la madre de Santiago y Salomé compraron perfumes para ir a embalsamarlo."
,"2":"El primer día de la semana, muy de madrugada, al salir el sol, fueron al sepulcro."
,"3":"Iban diciéndose: '¿Quién nos rodará la losa de la puerta del sepulcro?'."
,"4":"Levantaron los ojos, y vieron que la losa había sido removida; era muy grande."
,"5":"Entraron en el sepulcro y, al ver a un joven sentado a la derecha, vestido con una túnica blanca, se asustaron."
,"6":"Pero él les dijo: 'No os asustéis. Buscáis a Jesús nazareno, el crucificado. Ha resucitado. No está aquí. Ved el sitio donde lo pusieron."
,"7":"Id, decid a sus discípulos y a Pedro que él irá delante de vosotros a Galilea. Allí lo veréis, como él os dijo'."
,"8":"Ellas salieron huyendo del sepulcro, porque se había apoderado de ellas el temor y el espanto, y no dijeron nada a nadie porque tenían miedo."
,"9":"Jesús resucitó al amanecer del primer día de la semana, y se apareció primero a María Magdalena, de la que había lanzado siete demonios."
,"10":"Ella fue a decírselo a los que habían andado con él, que estaban llenos de tristeza y llorando."
,"11":"Ellos, al oír que vivía y que ella lo había visto, no lo creyeron."
,"12":"Después de esto se apareció con una figura distinta a dos de ellos en el camino, cuando iban al campo."
,"13":"Éstos volvieron a dar la noticia a los demás, pero tampoco les creyeron."
,"14":"Después se apareció a los once estando a la mesa, y les reprendió su incredulidad y dureza de corazón, porque no habían creído a los que lo habían visto resucitado de entre los muertos."
,"15":"Y les dijo: 'Id por todo el mundo y predicad el evangelio a toda criatura."
,"16":"El que crea y sea bautizado se salvará, pero el que no crea se condenará."
,"17":"A los que crean les acompañarán estos prodigios: en mi nombre echarán los demonios; hablarán lenguas nuevas;"
,"18":"agarrarán las serpientes y, aunque beban veneno, no les hará daño; pondrán sus manos sobre los enfermos y los curarán'."
,"19":"Jesús, el Señor, después de haber hablado con ellos, subió al cielo y se sentó a la diestra de Dios."
,"20":"Ellos se fueron a predicar por todas partes. El Señor cooperaba con ellos y confirmaba su doctrina con los prodigios que los acompañaban."
}`)

}
func ES_LSB_LoadNEMTChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Genealogía de Jesucristo, hijo de David, hijo de Abrahán:"
,"2":"Abrahán fue padre de Isaac; Isaac de Jacob; Jacob de Judá y sus hermanos;"
,"3":"Judá tuvo de Tamar a Fares y a Zéraj; Fares fue padre de Jesrón; Jesrón de Arán;"
,"4":"Arán de Aminadab; Aminadab de Naasón; Naasón de Salmón;"
,"5":"Salmón tuvo de Rajab a Booz; Booz tuvo de Rut a Obed; Obed fue padre de Jesé;"
,"6":"Jesé, del rey David. David, de la mujer de Urías, tuvo a Salomón. "
,"7":"Salomón fue padre de Roboán; Roboán de Abías; Abías de Asá;"
,"8":"Asá de Josafat; Josafat de Jorán; Jorán de Ozías;"
,"9":"Ozías de Joatán; Joatán de Acaz; Acaz de Ezequías;"
,"10":"Ezequías de Manasés; Manasés de Amón; Amón de Josías;"
,"11":"Josías de Jeconías y sus hermanos, cuando la deportación a Babilonia."
,"12":"Después de la deportación, Jeconías fue padre de Salatiel; Salatiel de Zorobabel;"
,"13":"Zorobabel de Abiud; Abiud de Eliaquín; Eliaquín de Azor;"
,"14":"Azor de Sadoc; Sadoc de Aquín; Aquín de Eliud;"
,"15":"Eliud de Eleazar; Eleazar de Matán; Matán de Jacob;"
,"16":"Jacob de José, el esposo de María, de la cual nació Jesús, que es el mesías."
,"17":"Por tanto, las generaciones desde Abrahán hasta David son en total catorce; desde David hasta la deportación a Babilonia, catorce, y desde la deportación hasta el mesías, catorce."
,"18":"El nacimiento de Jesucristo fue así: María, su madre, estaba desposada con José, y, antes de que vivieran juntos, se encontró encinta por virtud del Espíritu Santo."
,"19":"José, su marido, que era un hombre justo y no quería denunciarla, decidió dejarla en secreto."
,"20":"Estaba pensando en esto, cuando un ángel del Señor se le apareció en sueños y le dijo: 'José, hijo de David, no tengas ningún reparo en recibir en tu casa a María, tu mujer, pues el hijo que ha concebido viene del Espíritu Santo."
,"21":"Dará a luz un hijo, y le pondrás el nombre de Jesús, porque él salvará a su pueblo de sus pecados'."
,"22":"Todo esto sucedió para que se cumpliese lo que el Señor había dicho por medio del profeta:"
,"23":"La Virgen concebirá,y dará a luz un hijo, y le pondrán por nombre Emanuel, que significa 'Dios con nosotros'."
,"24":"Cuando José despertó del sueño, hizo lo que le había mandado el ángel del Señor y recibió en su casa a su mujer."
,"25":"Y sin haber tenido relaciones, María dio a luz un hijo, al que él puso por nombre Jesús."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Jesús nació en Belén de Judea, en tiempo del rey Herodes. Unos magos de oriente se presentaron en Jerusalén"
,"2":"preguntando: '¿Dónde está el que ha nacido, el rey de los judíos? Porque hemos visto su estrella en el oriente y venimos a adorarlo'."
,"3":"Al oír esto el rey Herodes, se inquietó, y con él toda Jerusalén;"
,"4":"convocó a todos los sumos sacerdotes y a los maestros de la ley y les preguntó por el lugar de nacimiento del mesías."
,"5":"Ellos le contestaron: En Belén de Judá, pues así está escrito por el profeta:"
,"6":"Y tú, Belén, tierra de Judá, de ningún modo eres la menor,entre las principales ciudades de Judá, porque de ti saldrá un jefe,que será el pastor,de mi pueblo Israel."
,"7":"Entonces Herodes llamó en secreto a los magos y se informó cuidadosamente de ellos sobre el tiempo en que había aparecido la estrella;"
,"8":"luego los envió a Belén, y les dijo: 'Id y averiguad todo lo que podáis sobre ese niño, y, cuando lo encontréis, avisadme, para que vaya yo también a adorarlo'."
,"9":"Ellos, después de oír al rey, se marcharon; y la estrella que habían visto en oriente iba delante de ellos, hasta que fue a posarse sobre el lugar donde estaba el niño."
,"10":"Al ver la estrella experimentaron una grandísima alegría."
,"11":"Entraron en la casa y vieron al niño con María, su madre; se pusieron de rodillas y lo adoraron; abrieron sus tesoros y le ofrecieron regalos: oro, incienso y mirra."
,"12":"Luego regresaron a su país por otro camino, pues les habían dicho en sueños que no volvieran adonde estaba Herodes."
,"13":"Tan pronto como se marcharon, un ángel del Señor se apareció en sueños a José y le dijo: 'Levántate, toma al niño y a su madre, huye a Egipto y estáte allí hasta que yo te avise, porque Herodes va a buscar al niño para matarlo'."
,"14":"Él se levantó, tomó al niño y a su madre de noche, se fue a Egipto"
,"15":"y estuvo allí hasta la muerte de Herodes, para que se cumpliera lo que había dicho el Señor por medio del profeta: 'De Egipto llamé a mi hijo'."
,"16":"Entonces Herodes, al ver que los magos se habían burlado de él, montó en cólera y mandó matar a todos los niños de Belén y de todo su territorio, de dos años para abajo, según el tiempo que había calculado por los magos."
,"17":"Y se cumplió lo que había dicho el profeta Jeremías:"
,"18":"Una voz se oyó en Ramá, llanto y lamento grande. Es Raquel que llora a sus hijos,y no quiere ser consolada, porque ya no existen."
,"19":"Al morir Herodes, un ángel del Señor se apareció en sueños a José en Egipto"
,"20":"y le dijo: 'Levántate, toma al niño y a su madre y vuelve a la tierra de Israel, porque han muerto los que atentaban contra la vida del niño'."
,"21":"Él se levantó, tomó al niño y a su madre y se fue a la tierra de Israel."
,"22":"Pero, al enterarse de que Arquelao reinaba en Judea en lugar de su padre Herodes, tuvo miedo de ir allí y, avisado en sueños, se retiró a la región de Galilea."
,"23":"Y fue a vivir a una ciudad llamada Nazaret, para que se cumpliera lo que habían anunciado los profetas, que sería nazareno."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Por aquellos días apareció Juan el Bautista predicando en el desierto de Judea"
,"2":"y diciendo: 'Convertíos, porque está cerca el reino de Dios'."
,"3":"Éste es aquel que el profeta Isaías había anunciado cuando dijo: Voz que grita en el desierto: Preparad el camino al Señor, allanad sus senderos."
,"4":"Juan tenía un vestido de pelo de camello y un cinturón de cuero a la cintura, y se alimentaba de saltamontes y miel silvestre."
,"5":"Acudían a él de Jerusalén, de toda Judea y de toda la región del Jordán;"
,"6":"ellos confesaban sus pecados, y él los bautizaba en el Jordán."
,"7":"Al ver venir a su bautismo a muchos de los fariseos y saduceos, les dijo: 'Raza de víboras, ¿quién os ha enseñado a huir de la ira que os amenaza?"
,"8":"Dad frutos dignos de conversión,"
,"9":"y no os ilusionéis con decir en vuestro interior: Tenemos por padre a Abrahán, porque os digo que Dios puede suscitar hijos a Abrahán hasta de estas piedras."
,"10":"Ya está el hacha puesta a la raíz de los árboles, y todo árbol que no dé buen fruto será cortado y arrojado al fuego."
,"11":"Yo os bautizo en agua para que os arrepintáis; pero el que viene detrás de mí es más fuerte que yo, y yo no soy digno de descalzarle las sandalias. Él os bautizará con Espíritu Santo y fuego."
,"12":"Tiene en su mano el bieldo, limpiará su era y recogerá su trigo en el granero; pero quemará la paja con fuego que no se apaga nunca'."
,"13":"Entonces Jesús fue de Galilea al Jordán para que Juan lo bautizara."
,"14":"Pero Juan quería impedirlo, diciendo: 'Soy yo el que necesito ser bautizado por ti, ¿y tú vienes a mí?'."
,"15":"Jesús le respondió: '¡Déjame ahora, pues conviene que se cumpla así toda justicia!'."
,"16":"Entonces Juan accedió a ello. Una vez bautizado, Jesús salió del agua; y en esto los cielos se abrieron y vio al Espíritu de Dios descender en forma de paloma y posarse sobre él."
,"17":"Y se oyó una voz del cielo: 'Éste es mi hijo amado, mi predilecto'."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Luego el Espíritu llevó a Jesús al desierto para ser tentado por el diablo."
,"2":"Y después de haber ayunado cuarenta días y cuarenta noches, al final tuvo hambre."
,"3":"El tentador se acercó y le dijo: 'Si eres hijo de Dios, di que estas piedras se conviertan en panes'."
,"4":"Pero él respondió: 'Está escrito: No sólo de pan vive el hombre, sino de toda palabra que sale de la boca de Dios'."
,"5":"Luego el diablo lo llevó a la ciudad santa, lo subió al alero del templo y"
,"6":"le dijo: 'Si eres hijo de Dios, tírate de aquí abajo, porque está escrito: Ordenará a sus ángeles que cuiden de ti, que te lleven en las manos para que no tropiece tu pie con ninguna piedra'."
,"7":"Jesús le dijo: 'También está escrito: No tentarás al Señor tu Dios'."
,"8":"De nuevo el diablo lo llevó a un monte muy alto, le mostró todos los reinos del mundo y su esplendor,"
,"9":"y le dijo: 'Todo esto te daré si te pones de rodillas y me adoras'."
,"10":"Jesús le dijo: 'Retírate, Satanás, porque está escrito: Al Señor tu Dios adorarás y a él solo servirás'."
,"11":"Entonces el diablo lo dejó, y los ángeles llegaron y se pusieron a servirle."
,"12":"Cuando oyó que Juan estaba en la cárcel, Jesús se retiró a Galilea."
,"13":"Dejó Nazaret, y se fue a vivir a Cafarnaún, en la ribera del lago, en los términos de Zabulón y Neftalí,"
,"14":"para que se cumpliese lo que había anunciado el profeta Isaías:"
,"15":"Tierra de Zabulón y de Neftalí, camino del mar, al otro lado del Jordán, Galilea de los paganos;"
,"16":"el pueblo que yace en las tinieblas,ha visto gran luz, y para los que yacen,en la región tenebrosa de la muerte,ha brillado una luz."
,"17":"Desde entonces comenzó Jesús a predicar y decir: 'Convertíos, porque el reino de Dios está cerca'."
,"18":"Paseando junto al lago de Galilea, vio a dos hombres: Simón, llamado Pedro, y Andrés, su hermano, echando la red en el lago, pues eran pescadores."
,"19":"Y les dijo: 'Venid conmigo y os haré pescadores de hombres'."
,"20":"Ellos, al instante, dejaron las redes y lo siguieron."
,"21":"Fue más adelante y vio a otros dos hermanos: Santiago, el de Zebedeo, y Juan, su hermano, en la barca con su padre Zebedeo, remendando las redes;"
,"22":"y los llamó. Ellos, al instante, dejaron la barca y a su padre, y lo siguieron."
,"23":"Jesús recorría toda Galilea enseñando en sus sinagogas, predicando el evangelio del reino y curando todas las enfermedades y dolencias del pueblo."
,"24":"Su fama se extendió por toda Siria. Le traían todos los que se sentían mal, aquejados de diversas enfermedades y sufrimientos, endemoniados, lunáticos y paralíticos, y los curaba."
,"25":"Y lo siguieron grandes muchedumbres de Galilea, Decápolis, Jerusalén y de la Transjordania."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Al ver las multitudes subió al monte, se sentó y se le acercaron sus discípulos;"
,"2":"y se puso a enseñarles así:"
,"3":"'Dichosos los pobres de espíritu, porque de ellos es el reino de Dios."
,"4":"Dichosos los afables, porque ellos heredarán la tierra."
,"5":"Dichosos los afligidos, porque ellos serán consolados."
,"6":"Dichosos los que tienen hambre y sed de justicia, porque ellos serán saciados."
,"7":"Dichosos los misericordiosos, porque ellos alcazarán misericordia."
,"8":"Dichosos los limpios de corazón, porque ellos verán a Dios."
,"9":"Dichosos los que trabajan por la paz, porque ellos serán llamados hijos de Dios."
,"10":"Dichosos los perseguidos por ser justos, porque de ellos es el reino de Dios."
,"11":"Dichosos seréis cuando os injurien, os persigan y digan contra vosotros toda suerte de calumnias por causa mía."
,"12":"Alegraos y regocijaos, porque vuestra recompensa será grande en los cielos. Pues también persiguieron a los profetas antes que a vosotros'."
,"13":"'Vosotros sois la sal de la tierra. Si la sal se desvirtúa, ¿con qué se salará? Para nada vale ya, sino para tirarla a la calle y que la gente la pise'."
,"14":"'Vosotros sois la luz del mundo. Una ciudad situada en la cima de un monte no puede ocultarse."
,"15":"No se enciende una lámpara para ocultarla en una vasija, sino para ponerla en el candelero y que alumbre a todos los que están en casa."
,"16":"Brille de tal modo vuestra luz delante de los hombres que vean vuestras obras buenas y glorifiquen a vuestro Padre, que está en los cielos'."
,"17":"'No penséis que he venido a derogar la ley y los profetas; no he venido a derogarla, sino a perfeccionarla."
,"18":"Porque os aseguro que, mientras no pasen el cielo y la tierra, ni un punto ni una coma desaparecerán de la ley hasta que todo se cumpla."
,"19":"Por lo tanto, el que quebrante uno solo de estos preceptos mínimos y lo enseñe así a los hombres será tenido por el menor en el reino de Dios. Pero el que los cumpla y enseñe será tenido por grande en el reino de Dios."
,"20":"Porque yo os digo que si vuestra justicia no supera la de los maestros de la ley y la de los fariseos, no entraréis en el reino de Dios'."
,"21":"'Sabéis que se dijo a los antiguos: No matarás, y el que mate será llevado a juicio."
,"22":"Pero yo os digo que el que se irrite con su hermano será llevado a juicio; el que insulte a su hermano será llevado ante el tribunal supremo, y el que lo injurie gravemente será llevado al fuego."
,"23":"Por tanto, si al llevar tu ofrenda al altar te recuerdas allí que tu hermano tiene algo contra ti,"
,"24":"deja tu ofrenda delante del altar y vete antes a reconciliarte con tu hermano; después vuelve y presenta tu ofrenda'."
,"25":"'Ponte a buenas con tu adversario pronto, mientras vas con él por el camino, no sea que te entregue al juez, y el juez al alguacil, y te metan en la cárcel."
,"26":"Te aseguro que no saldrás de allí hasta que pagues el último céntimo'."
,"27":"'Sabéis que se dijo: No cometerás adulterio."
,"28":"Pero yo os digo que todo el que mira a una mujer con mal deseo ya ha cometido con ella adulterio en su corazón."
,"29":"Por tanto, si tu ojo derecho te pone en peligro de pecar, arráncatelo y tíralo, porque te conviene perder uno de tus miembros antes que todo tu cuerpo sea arrojado al fuego."
,"30":"Y si tu mano derecha te pone en peligro de pecar, córtatela y tírala, porque te conviene perder uno de tus miembros antes que todo tu cuerpo vaya al fuego'."
,"31":"'También se dijo: El que se separe de su mujer, que le dé el acta de divorcio."
,"32":"Pero yo os digo que todo el que se separe de su mujer, excepto en caso de concubinato, la expone a cometer adulterio, y el que se casa con una mujer divorciada comete adulterio'."
,"33":"'También sabéis que se dijo a los antiguos: No jurarás en falso, sino que cumplirás al Señor tus juramentos."
,"34":"Pero yo os digo que no juréis de ninguna manera; ni por el cielo, porque es el trono de Dios;"
,"35":"ni por la tierra, porque es el estrado de sus pies; ni por Jerusalén, porque es la ciudad del gran rey;"
,"36":"ni por tu cabeza, porque ni un cabello puedes volver blanco o negro."
,"37":"Decid sencillamente sí o no. Lo que pasa de esto viene del maligno'."
,"38":"'Sabéis que se dijo: Ojo por ojo y diente por diente."
,"39":"Pero yo os digo que no hagáis frente al que os ataca. Al contrario, al que te abofetee en la mejilla derecha, preséntale también la otra;"
,"40":"y al que te quiera llevar a juicio para quitarte la túnica, déjale también el manto;"
,"41":"al que te obligue a ir con él un kilómetro, vete con él dos."
,"42":"Da a quien te pida, y no vuelvas la espalda al que desea que le prestes algo'."
,"43":"'Sabéis que se dijo: Amarás a tu prójimo y odiarás a tu enemigo."
,"44":"Pero yo os digo: Amad a vuestros enemigos y rezad por los que os persiguen,"
,"45":"para que seáis hijos de vuestro Padre celestial, que hace salir el sol sobre buenos y malos y hace llover sobre justos e injustos."
,"46":"Porque si amáis a los que os aman, ¿qué mérito tendréis? ¿No hacen eso mismo los publicanos?"
,"47":"Y si saludáis solamente a vuestros hermanos, ¿qué hacéis de especial? ¿No hacen eso también los paganos?"
,"48":"Vosotros sed perfectos, como vuestro Padre celestial es perfecto'."
}`)
	CurrentBook.AddChapter(6, `{
"1":"'Guardaos de practicar vuestra justicia delante de los hombres para que os vean; de otro modo, no tendréis mérito delante de vuestro Padre celestial'."
,"2":"'Por tanto, cuando des limosna, no toques la trompeta delante de ti, como hacen los hipócritas en las sinagogas y en las calles para que los hombres los alaben. Os aseguro que ya recibieron su recompensa."
,"3":"Tú, cuando des limosna, que no sepa tu mano izquierda lo que hace tu derecha,"
,"4":"para que tu limosna quede en secreto; y tu Padre, que ve lo secreto, te recompensará'."
,"5":"'Cuando recéis, no seáis como los hipócritas, que prefieren rezar de pie en las sinagogas y en las esquinas de las plazas para que los vea todo el mundo. Os aseguro que ya recibieron su recompensa."
,"6":"Tú, cuando reces, entra en tu habitación, cierra la puerta y reza a tu Padre, que está presente en lo secreto; y tu Padre, que ve en lo secreto, te recompensará."
,"7":"Al rezar, no os convirtáis en charlatanes como los paganos, que se imaginan que serán escuchados por su mucha palabrería."
,"8":"No hagáis como ellos, porque vuestro Padre conoce las necesidades que tenéis antes de que vosotros le pidáis'."
,"9":"'Vosotros rezad así: Padre nuestro que estás en el cielo, santificado sea tu nombre,"
,"10":"venga a nosotros tu reino, hágase tu voluntad en la tierra como en el cielo."
,"11":"Danos hoy nuestro pan de cada día,"
,"12":"perdona nuestras ofensas como también nosotros perdonamos a los que nos ofenden,"
,"13":"no nos dejes caer en la tentación y líbranos del mal'."
,"14":"'Porque si vosotros perdonáis a los hombres sus ofensas, también os perdonará a vosotros vuestro Padre celestial;"
,"15":"pero si no perdonáis a los hombres sus ofensas, tampoco vuestro Padre perdonará las vuestras'."
,"16":"'Cuando ayunéis, no estéis tristes como los hipócritas, que desfiguran su rostro para hacer ver a la gente que ayunan. Os aseguro que ya recibieron su recompensa."
,"17":"Tú, cuando ayunes, perfuma tu cabeza y lávate la cara,"
,"18":"para que los hombres no se den cuenta de que ayunas, sino tu Padre, que está en lo secreto; y tu Padre, que ve en lo secreto, te recompensará'."
,"19":"'No atesoréis en la tierra, donde la polilla y el orín corroen y donde los ladrones socaban y roban'."
,"20":"'Atesorad, más bien, en el cielo, donde ni la polilla ni el orín corroen, ni los ladrones socaban ni roban;"
,"21":"porque donde está tu tesoro, allí está también tu corazón'."
,"22":"'La lámpara de tu cuerpo son los ojos; si tus ojos están sanos, todo tu cuerpo estará iluminado;"
,"23":"pero si están enfermos, todo tu cuerpo estará oscuro. Y si la luz que hay en ti está apagada, ¡cuánta será la oscuridad!'"
,"24":"'Nadie puede servir a dos amos, porque odiará a uno y amará al otro, o bien despreciará a uno y se apegará al otro'. 'No podéis servir a Dios y al dinero. "
,"25":"Por esto os digo: No os angustiéis por vuestra vida, qué vais a comer; ni por vuestro cuerpo, qué vais a vestir. Porque la vida es más que el alimento, y el cuerpo más que el vestido."
,"26":"Mirad las aves del cielo; no siembran, ni siegan, ni recogen en graneros, y vuestro Padre celestial las alimenta. ¿No valéis vosotros más que ellas?"
,"27":"¿Quién de vosotros, por mucho que cavile, puede añadir una sola hora al tiempo de su vida?"
,"28":"Y del vestido, ¿por qué os preocupáis? Mirad cómo crecen los lirios del campo, no se fatigan ni hilan;"
,"29":"pero yo os digo que ni Salomón en todo su esplendor se vistió como uno de ellos."
,"30":"Pues si Dios viste así a la hierba del campo, que hoy es y mañana se la echa al fuego, ¿no hará más por vosotros, hombres de poca fe?"
,"31":"No os inquietéis, diciendo: '¿Qué comeremos?' o '¿qué beberemos?' o '¿cómo vestiremos?'."
,"32":"Por todas esas cosas se afanan los paganos. Vuestro Padre celestial ya sabe que las necesitáis."
,"33":"Buscad primero el reino de Dios y su justicia, y todo eso se os dará por añadidura."
,"34":"Así que no os inquietéis por el día de mañana, que el mañana traerá su inquietud. A cada día le bastan sus problemas'."
}`)
	CurrentBook.AddChapter(7, `{
"1":"'No juzguéis y no seréis juzgados."
,"2":"Porque con el juicio con que juzguéis seréis juzgados, y con la medida con que midáis seréis medidos."
,"3":"¿Cómo es que ves la paja en el ojo de tu hermano si no adviertes la viga en el tuyo?"
,"4":"¿Cómo puedes decir a tu hermano: Deja que saque la paja de tu ojo, teniendo una viga en el tuyo?"
,"5":"¡Hipócrita!, quita primero la viga de tu ojo, y entonces verás para quitar la paja del ojo de tu hermano'."
,"6":"'No deis lo santo a los perros ni echéis vuestras perlas a los puercos, no sea que las pisoteen, se vuelvan contra vosotros y os despedacen'."
,"7":"'Pedid y se os dará; buscad y encontraréis; llamad y se os abrirá."
,"8":"Porque todo el que pide recibe, y el que busca encuentra y al que llama se le abre."
,"9":"¿O quién de vosotros si su hijo le pide pan le dará una piedra?"
,"10":"O si le pide un pez, ¿le dará una serpiente?"
,"11":"Pues si vosotros, que sois malos, sabéis dar a vuestros hijos cosas buenas, ¡cuánto más vuestro Padre celestial dará cosas buenas a quien se las pida!'"
,"12":"'Por tanto, todo lo que queráis que hagan con vosotros los hombres hacedlo también vosotros con ellos, porque en eso consiste la ley y los profetas'."
,"13":"'Entrad por la puerta estrecha. Que es ancha la puerta y espacioso el camino que lleva a la perdición, y son muchos los que entran por ella."
,"14":"Y es estrecha la puerta y angosto el camino que lleva a la vida, y son pocos los que lo encuentran'."
,"15":"'Guardaos de los falsos profetas, que vienen a vosotros con vestido de oveja y por dentro son lobos rapaces."
,"16":"Por sus frutos los conoceréis. ¿Acaso se cosechan uvas de los espinos o higos de los cardos?"
,"17":"Así también, todo árbol bueno da frutos buenos, pero el árbol malo da frutos malos'."
,"18":"'Un árbol bueno no puede dar frutos malos, ni un árbol malo frutos buenos."
,"19":"Todo árbol que no da buen fruto es cortado y echado al fuego."
,"20":"Por sus frutos los conoceréis'."
,"21":"'No todo el que me dice: ¡Señor! ¡Señor!, entrará en el reino de Dios, sino el que hace la voluntad de mi Padre celestial."
,"22":"Muchos me dirán en aquel día: ¡Señor! ¡Señor!, ¿no hemos profetizado en tu nombre, y en tu nombre hemos arrojado a los demonios y hecho muchos milagros en tu nombre?"
,"23":"Entonces yo les diré: 'Nunca os conocí. Apartaos de mí, agentes de injusticias'."
,"24":"El que escucha mis palabras y las pone en práctica se parece a un hombre sensato que ha construido su casa sobre roca."
,"25":"Cayó la lluvia, se desbordaron los ríos, soplaron los vientos y se echaron sobre ella; pero la casa no se cayó, porque estaba cimentada sobre la roca."
,"26":"Y todo el que escucha mis palabras y no las pone en práctica se parece a un hombre insensato que ha construido su casa sobre arena."
,"27":"Cayó la lluvia, se desbordaron los ríos, soplaron los vientos y se precipitaron sobre ella, y la casa se cayó y se arruinó totalmente'."
,"28":"Cuando acabó Jesús estos discursos, la gente se quedó atónita de su doctrina,"
,"29":"porque les enseñaba como quien tiene autoridad, y no como sus maestros de la ley."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Cuando bajó del monte, lo siguieron las multitudes."
,"2":"En esto se le acercó un leproso, se puso de rodillas ante él y le dijo: 'Señor, si quieres puedes limpiarme'."
,"3":"Jesús extendió la mano, lo tocó y dijo: 'Quiero. Queda limpio'. Y al instante quedó limpio de su lepra."
,"4":"Jesús le dijo: 'Mira, no se lo digas a nadie; pero anda, muéstrate al sacerdote y presenta la ofrenda que ordenó Moisés, para que les conste tu curación'."
,"5":"Al entrar Jesús en Cafarnaún, se le acercó un oficial suplicándole:"
,"6":"'Señor, mi criado está paralítico en casa con unos dolores terribles'."
,"7":"Jesús le dijo: 'Yo iré a curarlo'."
,"8":"El oficial respondió: 'Señor, no soy digno de que entres en mi casa; dilo sólo de palabra, y mi criado quedará curado."
,"9":"Porque yo, que soy un hombre sujeto al mando, tengo bajo mis órdenes soldados, y digo a éste: 'Vete', y va; y a otro: 'Ven', y viene; y a mi criado: 'Haz esto', y lo hace'."
,"10":"Jesús, al oírlo, quedó admirado y dijo a los que lo seguían: 'Os aseguro que en Israel no he encontrado a nadie con una fe como ésta."
,"11":"Muchos del oriente y del occidente vendrán y se sentarán con Abrahán, Isaac y Jacob en el reino de Dios,"
,"12":"pero los hijos del reino serán echados a las tinieblas de fuera: allí será el llanto y el crujir de dientes'."
,"13":"Y Jesús dijo al oficial: 'Anda, y que suceda como has creído'. Y en aquella misma hora el criado se curó."
,"14":"Cuando Jesús llegó a casa de Pedro, vio a la suegra de éste, que estaba en cama y con fiebre. Él la agarró de la mano"
,"15":"y desapareció la fiebre; ella se levantó y se puso a atenderle."
,"16":"Al anochecer, le presentaron muchos endemoniados; y con su palabra echó a los espíritus y curó a todos los enfermos,"
,"17":"para que se cumpliera lo que había dicho el profeta Isaías: Él tomó nuestras flaquezas,y cargó con nuestras enfermedades."
,"18":"Jesús, al verse rodeado de tanta gente, mandó que lo llevaran a la otra orilla del lago."
,"19":"Entonces llegó un maestro de la ley y le dijo: 'Maestro, te seguiré adondequiera que vayas'."
,"20":"Jesús le dijo: 'Las raposas tienen madrigueras y las aves del cielo nidos, pero el hijo del hombre no tiene donde reclinar la cabeza'."
,"21":"Otro de sus discípulos le dijo: 'Señor, déjame ir a enterrar a mi padre'."
,"22":"Jesús le dijo: 'Sígueme y deja que los muertos entierren a sus muertos'."
,"23":"Jesús subió a una barca acompañado de sus discípulos."
,"24":"De pronto se alborotó tanto el mar que las olas saltaban por encima de la barca, y él dormía."
,"25":"Se acercaron los discípulos y lo despertaron, diciendo: '¡Señor, sálvanos, que perecemos!'."
,"26":"Jesús les dijo: '¿Por qué tembláis, hombres de poca fe?'. Entonces se levantó, increpó a los vientos y al mar y sobrevino una gran calma."
,"27":"Los discípulos, asombrados, decían: '¿Quién es éste que hasta el viento y el mar le obedecen?'."
,"28":"Al llegar a la orilla opuesta, a la región de los gadarenos, fueron a su encuentro dos endemoniados que salían del cementerio, tan furiosos que nadie podía pasar por aquel camino."
,"29":"Y gritaron: '¡Déjanos en paz, hijo de Dios! ¿Has venido aquí antes de tiempo para atormentarnos?'."
,"30":"Pacía no lejos de ellos una gran piara de cerdos,"
,"31":"y los demonios le pidieron: 'Si nos echas, envíanos a la piara de cerdos'."
,"32":"Jesús les dijo: 'Id'. Ellos salieron, se metieron en los cerdos y, al instante, toda la piara se lanzó al lago por un precipicio y se ahogaron."
,"33":"Los porqueros huyeron y, al llegar al pueblo, contaron todo, también lo de los endemoniados."
,"34":"El pueblo entero salió al encuentro de Jesús y, al verlo, le rogaron que se fuera de allí."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Jesús subió a una barca, pasó a la otra orilla y fue a su ciudad."
,"2":"De pronto le llevaron un paralítico tendido en una camilla. Jesús al ver su fe, dijo al paralítico: 'Ánimo, hijo, tus pecados te son perdonados'."
,"3":"Algunos maestros de la ley se dijeron: 'Éste blasfema'."
,"4":"Jesús, conociendo sus pensamientos, dijo: '¿Por qué pensáis tan mal?"
,"5":"¿Qué es más fácil, decir: Tus pecados te son perdonados, o decir: Levántate y anda?"
,"6":"Pues para que veáis que el hijo del hombre tiene poder en la tierra para perdonar los pecados, dijo al paralítico: 'Tú, levántate, carga con tu camilla y vete a tu casa'."
,"7":"Él se levantó y se fue a su casa."
,"8":"Las gentes, al ver esto, quedaron sobrecogidas y glorificaron a Dios que dio tal poder a los hombres."
,"9":"Al salir de allí, Jesús vio a un hombre, llamado Mateo, sentado en la oficina de los impuestos, y le dijo: 'Sígueme'. Él se levantó y lo siguió."
,"10":"Y estando en su casa a la mesa, muchos publicanos y pecadores vinieron y se pusieron a la mesa con Jesús y sus discípulos."
,"11":"Los fariseos, al verlo, decían a los discípulos: '¿Por qué vuestro maestro come con los publicanos y pecadores?'."
,"12":"Jesús los oyó y dijo: 'No tienen necesidad de médico los sanos, sino los enfermos."
,"13":"Id y aprended lo que significa: Misericordia quiero y no sacrificios; pues no he venido a llamar a los justos, sino a los pecadores'."
,"14":"Entonces se le acercaron los discípulos de Juan y le preguntaron: '¿Por qué nosotros y los fariseos ayunamos tantas veces, y tus discípulos no ayunan?'."
,"15":"Jesús les dijo: '¿Es que los compañeros del esposo pueden estar tristes mientras el esposo está con ellos? Pero vendrán días en que les quiten al esposo; entonces ayunarán."
,"16":"Nadie remienda con paño nuevo un vestido viejo, pues el remiendo nuevo tirará del vestido y el rasgón se hará mayor."
,"17":"Ni echan vino nuevo en odres viejos, porque los odres revientan, y se pierden al mismo tiempo el vino y los odres; sino que el vino nuevo se echa en odres nuevos, y así ambos se conservan'."
,"18":"Les estaba hablando así, cuando llegó un personaje importante, se echó a sus pies y le dijo: 'Mi hija acaba de morir; pero anda, pon tu mano sobre ella y vivirá'."
,"19":"Jesús se levantó y fue con él acompañado de sus discípulos."
,"20":"Una mujer, que padecía hemorragias desde hacía doce años, se acercó por detrás y tocó la orla de su manto,"
,"21":"pues se decía: 'Con sólo tocar sus vestidos me curo'."
,"22":"Jesús se volvió y, al verla, le dijo: 'Ánimo, hija, tu fe te ha curado'. Y la mujer quedó curada desde aquel momento."
,"23":"Jesús llegó a la casa y, al ver a los flautistas y el alboroto de la gente, les dijo:"
,"24":"'Salid, que la niña no está muerta; está dormida'. Ellos se reían de él."
,"25":"Cuando salió la gente, entró, la agarró de la mano y la niña se levantó."
,"26":"Y la noticia se extendió por toda la comarca."
,"27":"Cuando salió de allí, le siguieron dos ciegos, gritando: '¡Ten compasión de nosotros, hijo de David!'."
,"28":"Al entrar en la casa, se le acercaron los ciegos, y Jesús les dijo: '¿Creéis que puedo hacer esto?'. Le dijeron: '¡Sí, Señor!'."
,"29":"Entonces les tocó los ojos, diciendo: 'Hágase en vosotros según vuestra fe'. Y se les abrieron los ojos."
,"30":"Jesús les ordenó severamente: 'Mirad, que nadie lo sepa'."
,"31":"Pero ellos, nada más salir, lo publicaron por toda la comarca."
,"32":"Cuando éstos salían, le presentaron un hombre mudo endemoniado;"
,"33":"Jesús echó al demonio, y el mudo empezó a hablar. Las gentes decían maravilladas: 'Jamás se ha visto cosa semejante en Israel'."
,"34":"Pero los fariseos decían: 'Echa a los demonios con el poder del príncipe de los demonios'."
,"35":"Jesús recorría ciudades y aldeas, enseñando en sus sinagogas, predicando el evangelio del reino y curando todas las enfermedades y dolencias."
,"36":"Y al ver a la gente, se compadecía de ella, porque estaban cansados y decaídos como ovejas sin pastor."
,"37":"Entonces dijo a sus discípulos: 'La mies es mucha y los obreros pocos."
,"38":"Pedid al dueño de la mies que mande obreros a su mies'."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Reunió a sus doce apóstoles, y les dio poder de echar los espíritus inmundos y de curar todas las enfermedades y dolencias."
,"2":"Los nombres de los doce apóstoles son: primero, Simón, llamado Pedro, y su hermano Andrés; Santiago y su hermano Juan, hijos de Zebedeo;"
,"3":"Felipe y Bartolomé; Tomás y Mateo el publicano; Santiago, el de Alfeo, y Tadeo;"
,"4":"Simón el Cananeo y Judas el Iscariote, el que le traicionó."
,"5":"Jesús envió a estos doce con estas instrucciones: 'No vayáis por tierra de paganos, ni entréis en ciudad de samaritanos."
,"6":"Id a las ovejas perdidas de la casa de Israel."
,"7":"Id predicando que el reino de Dios está cerca."
,"8":"Curad a los enfermos, resucitad a los muertos, limpiad a los leprosos, echad a los demonios: gratis lo habéis recibido, dadlo gratis."
,"9":"No llevéis oro, ni plata, ni dinero en vuestras fajas;"
,"10":"ni alforja para el camino, ni dos túnicas, ni calzados, ni bastón, porque el obrero merece su salario."
,"11":"Cuando entréis en una ciudad, informaos de quién hay allí digno de confianza, y quedaos en su casa hasta que os vayáis de allí."
,"12":"Cuando entréis en la casa, saludadla;"
,"13":"y si la casa se lo merece, la paz de vuestro saludo descenderá sobre ella; y si no se lo merece, la paz se volverá a vosotros."
,"14":"Si no os reciben ni os escuchan, al salir de la casa o del pueblo sacudid el polvo de vuestros pies."
,"15":"Os aseguro que el día del juicio habrá más tolerancia para Sodoma y Gomorra que para esa ciudad'."
,"16":"'Os envío como ovejas en medio de lobos. Sed prudentes como las serpientes y sencillos como las palomas."
,"17":"Tened cuidado con la gente, porque os entregarán a los tribunales y os azotarán en sus sinagogas."
,"18":"Seréis conducidos por mi causa ante los gobernadores y reyes para dar testimonio ante ellos y ante los paganos."
,"19":"Pero cuando os entreguen, no os preocupéis sobre cómo habéis de hablar o qué habéis de decir, porque en aquel momento se os sugerirá lo que debéis decir."
,"20":"Pues no sois vosotros los que habláis, es el Espíritu de vuestro Padre el que habla en vosotros."
,"21":"El hermano entregará a su hermano a la muerte, y el padre a su hijo. Los hijos se levantarán contra sus padres y los matarán;"
,"22":"todos os aborrecerán por causa mía, pero el que persevere hasta el fin se salvará."
,"23":"Cuando os persigan en una ciudad, huid a otra; y si también en ésta os persiguen, huid a otra. Os aseguro que no se acabarán las ciudades de Israel hasta que venga el hijo del hombre'."
,"24":"'El discípulo no está por encima de su maestro, ni el criado por encima de su amo."
,"25":"Al discípulo le basta ser como su maestro, y al criado como su amo. Si al amo de la casa le han llamado Belcebú, ¡qué no dirán de los de la casa!"
,"26":"No les tengáis miedo, porque no hay nada tan oculto que no se llegue a descubrir, y nada tan secreto que no se llegue a saber."
,"27":"Lo que os digo en la oscuridad decidlo a plena luz, y lo que oís al oído predicadlo sobre las terrazas."
,"28":"No tengáis miedo de los que matan el cuerpo, pero no pueden matar el alma; temed más bien al que puede perder el alma y el cuerpo en el fuego."
,"29":"¿No se venden dos pájaros por unos cuartos? Y, sin embargo, ninguno de ellos cae en tierra sin el consentimiento de vuestro Padre."
,"30":"En cuanto a vosotros, hasta los cabellos de la cabeza están contados."
,"31":"Así que no tengáis miedo; vosotros valéis más que una bandada de pájaros."
,"32":"Al que me confiese delante de los hombres, le confesaré también yo delante de mi Padre celestial;"
,"33":"pero al que me niegue delante de los hombres, yo también lo negaré delante de mi Padre celestial'."
,"34":"'No penséis que he venido a traer la paz al mundo; no he venido a traer paz, sino espada."
,"35":"Porque he venido a poner al hijo en contra de su padre, a la hija en contra de su madre, a la nuera en contra de su suegra."
,"36":"De suerte que los enemigos del hombre son los de su propia casa'."
,"37":"'El que ama a su padre o a su madre más que a mí no es digno de mí, y el que ama a su hijo o a su hija más que a mí no es digno de mí,"
,"38":"y el que no carga con su cruz y me sigue no es digno de mí."
,"39":"El que encuentre su vida la perderá, y el que la pierda por mí la encontrará'."
,"40":"'El que os recibe a vosotros me recibe a mí, y quien me recibe a mí recibe a quien me ha enviado."
,"41":"El que recibe a un profeta como profeta recibirá premio de profeta, y el que recibe a un justo como justo recibirá premio de justo;"
,"42":"el que dé de beber a uno de estos pequeñuelos tan sólo un vaso de agua fresca porque es mi discípulo, os aseguro que no perderá su recompensa'."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Cuando Jesús acabó de dar estas instrucciones a sus doce discípulos, se fue de allí para enseñar y predicar en aquellos pueblos."
,"2":"Juan, que oyó en la cárcel las obras de Jesús, envió a sus discípulos"
,"3":"a preguntarle: '¿Eres tú el que ha de venir o tenemos que esperar a otro?'."
,"4":"Jesús les respondió: 'Id y contad a Juan lo que habéis visto y oído:"
,"5":"los ciegos ven, los cojos andan, los leprosos quedan limpios, los sordos oyen, los muertos resucitan y se anuncia el evangelio a los pobres:"
,"6":"¡dichoso el que no se escandalice de mí!'."
,"7":"Cuando se fueron, Jesús comenzó a hablar de Juan a las gentes: '¿Qué salisteis a ver en el desierto? ¿Una caña movida por el viento?"
,"8":"¿Pues qué salisteis a ver? ¿Un hombre vestido lujosamente? Los que visten lujosamente están en los palacios de los reyes."
,"9":"¿Entonces, qué salisteis a ver? ¿Un profeta? Sí, os lo digo; y más que un profeta."
,"10":"Él es de quien está escrito: Yo envío delante de ti a mi mensajero para que te prepare el camino."
,"11":"Os aseguro que no hay hombre alguno más grande que Juan Bautista, pero el más pequeño en el reino de Dios es más grande que él."
,"12":"Desde los tiempos de Juan Bautista hasta ahora el reino de Dios sufre violencia, y los violentos lo arrebatan."
,"13":"En efecto, todos los profetas y la ley anunciaron este reino hasta que vino Juan."
,"14":"Y si queréis admitirlo, él es Elías, el que había de venir."
,"15":"¡El que tenga oídos que oiga!'."
,"16":"'¿A qué compararé esta generación? Se parece a esos chiquillos sentados en las plazas, que se gritan unos a otros:"
,"17":"'Os hemos tocado la flauta y no habéis bailado, hemos cantado lamentaciones y no habéis llorado'."
,"18":"Porque vino Juan, que ni comía ni bebía, y dijeron: Tiene un demonio."
,"19":"Ha venido el hijo del hombre, que come y bebe, y dicen: Éste es un comilón y un borracho, amigo de publicanos y pecadores. Pero la sabiduría ha sido justificada con sus obras'."
,"20":"Entonces empezó a increpar a las ciudades en que había hecho la mayoría de sus milagros, porque no se habían convertido."
,"21":"'¡Ay de ti, Corozaín! ¡Ay de ti, Betsaida!, porque si en Tiro y en Sidón se hubieran hecho los milagros que en vosotras, haría ya tiempo que se hubieran arrepentido cubiertas de saco y ceniza."
,"22":"Pero os digo que en el día del juicio habrá más tolerancia para Tiro y Sidón que para vosotras."
,"23":"Y tú, Cafarnaún, ¿crees que te vas a elevar hasta el cielo? ¡Hasta el abismo te hundirás! Porque si en Sodoma se hubieran hecho los milagros realizados en ti, duraría hasta el día de hoy."
,"24":"Pero os digo que el día del juicio habrá más tolerancia para Sodoma que para ti'."
,"25":"En aquel tiempo Jesús dijo: 'Yo te alabo, Padre, Señor del cielo y de la tierra, porque has escondido estas cosas a los sabios y a los entendidos, y se las has manifestado a los sencillos."
,"26":"Sí, Padre, porque así lo has querido."
,"27":"Mi Padre me ha confiado todas las cosas; nadie conoce perfectamente al Hijo sino el Padre, y nadie conoce al Padre sino el Hijo y aquel a quien el Hijo se lo quiera manifestar."
,"28":"Venid a mí todos los que estáis cansados y oprimidos, y yo os aliviaré."
,"29":"Cargad con mi yugo y aprended de mí, que soy afable y humilde de corazón, y encontraréis descanso para vuestras almas."
,"30":"Porque mi yugo es llevadero y mi carga ligera'."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Por aquel tiempo iba Jesús un sábado por los sembrados. Sus discípulos tenían hambre, y comenzaron a cortar espigas y a comerlas."
,"2":"Los fariseos, al verlo, le dijeron: 'Mira, tus discípulos hacen lo que no está permitido hacer en sábado'."
,"3":"Él les respondió: '¿No habéis leído lo que hizo David cuando tuvo hambre él y los suyos,"
,"4":"cómo entró en la casa de Dios y comió los panes de la proposición, de los que no estaba permitido comer ni a él ni a los suyos, sino sólo a los sacerdotes?"
,"5":"¿O no habéis leído en la ley que en día de sábado los sacerdotes en el templo quebrantan el sábado y no son culpables?"
,"6":"Pues yo os digo que hay aquí algo más grande que el templo."
,"7":"Si hubierais comprendido qué quiere decir: Misericordia quiero y no sacrificios, no condenaríais a los inocentes."
,"8":"Porque el hijo del hombre es Señor del sábado'."
,"9":"De allí pasó a la sinagoga."
,"10":"Había en ella un hombre que tenía seca una mano, y preguntaron a Jesús para acusarle: '¿Está permitido curar en sábado?'."
,"11":"Él les dijo: '¿Quién de vosotros que tenga una sola oveja, si cae en un hoyo en día de sábado no le echa una mano y la saca?"
,"12":"Pues, ¡cuánto más vale un hombre que una oveja! Así que está permitido hacer el bien en sábado'."
,"13":"Entonces dijo al hombre: 'Extiende tu mano'. Él la extendió y quedó sana como la otra."
,"14":"Pero los fariseos salieron y tomaron en consejo la resolución de acabar con él."
,"15":"Jesús se enteró y se alejó de allí. Lo siguieron muchos y los curó a todos,"
,"16":"encargándoles severamente que no lo publicasen,"
,"17":"para que se cumpliera lo que había anunciado el profeta Isaías:"
,"18":"Éste es mi siervo, mi elegido, mi amado, la alegría de mi alma; pondré mi espíritu sobre él,para que anuncie,la justicia a las naciones."
,"19":"No disputará ni gritará, nadie oirá su voz en las plazas."
,"20":"No romperá la caña cascada,y no apagará la mecha humeante,hasta que haga triunfar la justicia."
,"21":"En él pondrán las gentes,su esperanza."
,"22":"Entonces le presentaron un endemoniado ciego y mudo y lo curó, de manera que el mudo hablaba y veía."
,"23":"Y todo el pueblo, asombrado, decía: '¿No es éste el hijo de David?'."
,"24":"Pero los fariseos, al oírlo, dijeron: 'Éste echa los demonios con el poder de Belcebú, príncipe de los demonios'."
,"25":"Jesús, conociendo su pensamiento, les dijo: 'Todo reino dividido será desolado, y toda ciudad o casa dividida no puede subsistir."
,"26":"Si Satanás echa a Satanás, está dividido contra sí mismo; ¿cómo podrá, entonces, subsistir su reino?"
,"27":"Si yo echo los demonios con el poder de Belcebú, ¿con qué poder lo echan vuestros hijos? Por eso ellos mismos serán vuestros jueces."
,"28":"Pero si echo los demonios con el Espíritu de Dios, es señal de que ha llegado a vosotros el reino de Dios."
,"29":"¿Cómo puede uno entrar en la casa de un hombre fuerte y arrebatarle sus cosas si antes no lo ata? Sólo así podrá saquear su casa."
,"30":"El que no está conmigo está contra mí, y el que no recoge conmigo desparrama'."
,"31":"'Por eso os digo: A los hombres se les perdonarán todos sus pecados y blasfemias, pero la blasfemia contra el Espíritu no se les perdonará."
,"32":"Al que hable contra el hijo del hombre se le perdonará, pero al que hable contra el Espíritu Santo no se le perdonará ni en esta vida ni en la otra."
,"33":"Decís que el árbol es bueno si es bueno su fruto; decís que el árbol es malo si es malo su fruto. Porque el árbol se conoce por su fruto."
,"34":"¡Raza de víboras! ¿Cómo podéis vosotros hablar de cosas buenas, siendo malvados? Porque de lo que rebosa el corazón habla la boca."
,"35":"El hombre bueno, de su bondad saca buenas cosas; y el hombre malo, de su maldad saca cosas malas."
,"36":"Y yo os digo que de toda palabra ociosa que digan los hombres darán cuenta el día del juicio."
,"37":"Porque por tus palabras serás justificado y por tus palabras serás condenado'."
,"38":"Entonces algunos maestros de la ley y algunos fariseos le dijeron: 'Maestro, queremos verte hacer una señal milagrosa'."
,"39":"Él respondió: 'Esta generación malvada y adúltera pide una señal, y no se le dará otra que la señal del profeta Jonás."
,"40":"De la misma manera que Jonás estuvo tres días y tres noches en el vientre del cetáceo, así estará el hijo del hombre tres días y tres noches en el corazón de la tierra."
,"41":"Los hombres de Nínive se levantarán en el día del juicio con esta generación y la condenarán, porque se arrepintieron por la predicación de Jonás; y aquí hay algo que es más que Jonás."
,"42":"La reina del sur se levantará en el día del juicio con esta generación y la condenará, porque ella vino de los confines de la tierra para escuchar la sabiduría de Salomón; y aquí hay algo que es más que Salomón."
,"43":"Cuando el espíritu impuro sale de un hombre, anda por lugares áridos buscando descanso, y, al no encontrarlo,"
,"44":"dice: Volveré a mi casa de donde salí. Al volver, la encuentra libre, barrida y arreglada."
,"45":"Entonces va y trae consigo otros siete espíritus peores que él, y entran y se instalan allí. Así el estado final de aquel hombre resulta peor que el primero. Eso sucederá también a esta generación malvada'."
,"46":"Mientras él hablaba a la gente, su madre y sus hermanos estaban fuera y querían hablar con él."
,"47":"Y uno le dijo: 'Tu madre y tus hermanos están afuera y quieren hablar contigo'."
,"48":"Él respondió: '¿Quién es mi madre y quiénes son mis hermanos?'."
,"49":"Y extendiendo su mano hacia sus discípulos, dijo: 'Éstos son mi madre y mis hermanos."
,"50":"Porque el que hace la voluntad de mi Padre celestial, ése es mi hermano, mi hermana y mi madre'."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Aquel día, Jesús salió de su casa y se sentó a la orilla del lago."
,"2":"Acudió a él tanta gente, que subió a sentarse en una barca, y toda la gente quedó en la playa."
,"3":"Y les dijo muchas cosas en parábolas: 'Salió el sembrador a sembrar"
,"4":"y, al sembrar, parte de la semilla cayó junto al camino; vinieron las aves y se la comieron."
,"5":"Otra parte cayó en un pedregal, donde no había mucha tierra, y brotó en seguida porque la semilla no tenía profundidad en la tierra;"
,"6":"pero al salir el sol la abrasó y, por no tener raíz, se secó."
,"7":"Otra cayó entre zarzas; las zarzas crecieron y la ahogaron."
,"8":"Otra parte cayó en tierra buena, y dio frutos; una ciento, otra sesenta, otra treinta."
,"9":"¡El que tenga oídos que oiga!'."
,"10":"Los discípulos se le acercaron y le preguntaron: '¿Por qué les hablas en parábolas?'."
,"11":"Y él les respondió: 'A vosotros se os ha dado conocer los misterios del reino de Dios, pero a ellos no."
,"12":"Pues al que tiene se le dará más y tendrá de sobra; pero al que no tiene, aun lo que tiene se le quitará."
,"13":"Por esto les hablo en parábolas, porque miran y no ven, escuchan y no oyen ni entienden."
,"14":"Así se cumple en ellos la profecía de Isaías: Oiréis pero no entenderéis, miraréis pero no veréis."
,"15":"Porque la mente de este pueblo,está embotada, tienen tapados los oídos,y los ojos cerrados, para no ver nada con sus ojos,ni oír con sus oídos, ni entender con la mente,ni convertirse a mí,para que yo los cure."
,"16":"'¡Dichosos vuestros ojos porque ven, y vuestros oídos porque oyen!"
,"17":"Os aseguro que muchos profetas y justos desearon ver lo que veis y no lo vieron, y oír lo que oís y no lo oyeron'."
,"18":"'Así que vosotros entended la parábola del sembrador."
,"19":"Si uno oye la palabra del reino y no la entiende, viene el maligno y le arrebata lo sembrado en el corazón. Éste es lo sembrado junto al camino."
,"20":"El pedregal es el que oye la palabra de momento y la acepta con alegría;"
,"21":"pero no tiene raíz, es inconstante y, cuando llega la prueba o la persecución a causa de la palabra, inmediatamente se viene abajo."
,"22":"Lo sembrado entre zarzas es el que oye la palabra, pero las preocupaciones de esta vida y la seducción de la riqueza ahogan la palabra y queda sin fruto."
,"23":"Lo sembrado en tierra buena es el que oye la palabra y la entiende y da fruto, ciento, sesenta y treinta por uno'."
,"24":"Les propuso otra parábola: 'El reino de Dios es semejante a un hombre que sembró buena semilla en un campo."
,"25":"Mientras sus hombres dormían, vino su enemigo, esparció cizaña en medio del trigo y se fue."
,"26":"Pero cuando creció la hierba y llevó fruto, apareció también la cizaña."
,"27":"Los criados fueron a decir a su amo: ¿No sembraste buena semilla en tu campo? ¿Cómo es que tiene cizaña?"
,"28":"Él les dijo: Un hombre enemigo hizo esto. Los criados dijeron: ¿Quieres que vayamos a recogerla?"
,"29":"Les contestó: ¡No!, no sea que, al recoger la cizaña, arranquéis con ella el trigo."
,"30":"Dejad crecer juntas las dos cosas hasta la siega; en el tiempo de la siega diré a los segadores: Recoged primero la cizaña y atadla en haces para quemarla, pero el trigo recogedlo en mi granero'."
,"31":"Les propuso otra parábola: 'El reino de Dios es como un grano de mostaza que toma un hombre y lo siembra en su campo."
,"32":"Es la más pequeña de todas las semillas; pero cuando crece es la mayor de las hortalizas y se hace árbol, de tal suerte que las aves vienen y anidan en sus ramas'."
,"33":"Les dijo otra parábola: 'El reino de Dios es semejante a la levadura que una mujer toma y la mete en tres medidas de harina hasta que fermenta toda la masa'."
,"34":"Jesús decía a la gente todas estas cosas en parábolas, y no les decía nada sin parábolas,"
,"35":"para que se cumpliera lo que había anunciado el profeta: Abriré mi boca para decir parábolas y publicaré lo que estaba oculto desde la creación del mundo."
,"36":"Jesús dejó a la gente y se fue a casa. Sus discípulos se le acercaron y le dijeron: 'Explícanos la parábola de la cizaña del campo'."
,"37":"Él respondió: 'El que siembra la buena semilla es el hijo del hombre."
,"38":"El campo es el mundo. La buena semilla son los hijos del reino, y la cizaña son los hijos del maligno."
,"39":"El enemigo que la siembra es el diablo. La siega es el fin del mundo, y los segadores los ángeles."
,"40":"Como se recoge la cizaña y se quema en el fuego, así también será al fin del mundo."
,"41":"El hijo del hombre enviará a sus ángeles, que recogerán de su reino a todos los que son causa de pecado y a todos los agentes de injusticias"
,"42":"y los echarán al horno ardiente: allí será el llanto y el crujir de dientes."
,"43":"Entonces los justos resplandecerán como el sol en el reino de su Padre. ¡El que tenga oídos que oiga!'"
,"44":"'El reino de Dios es semejante a un tesoro escondido en el campo. El que lo encuentra lo esconde y, lleno de alegría va, vende todo lo que tiene y compra aquel campo'."
,"45":"'El reino de Dios es semejante a un mercader que busca perlas preciosas."
,"46":"Cuando encuentra una de gran valor, va, vende todo lo que tiene y la compra'."
,"47":"'El reino de Dios es semejante a una red que se echa al mar y recoge toda clase de peces;"
,"48":"cuando está llena, los pescadores la sacan a la orilla, se sientan, recogen los buenos en cestos y tiran los malos."
,"49":"Así será al fin del mundo. Vendrán los ángeles, separarán a los malos de los justos"
,"50":"y los echarán al horno ardiente: allí será el llanto y el crujir de dientes."
,"51":"¿Habéis entendido todo esto?'. Le contestaron: '¡Sí!'."
,"52":"Y él les dijo: 'Por eso, el maestro de la ley que se ha hecho discípulo del reino de Dios es como el amo de la casa que saca de su tesoro cosas nuevas y viejas'."
,"53":"Cuando Jesús acabó estas parábolas, se fue de allí."
,"54":"Se fue a su tierra y se puso a enseñar en la sinagoga. La gente, asombrada, decía: '¿De dónde le viene a éste esa sabiduría y esos prodigios?"
,"55":"¿No es éste el hijo del carpintero? ¿No es su madre María, y sus hermanos Santiago, José, Simón y Judas?"
,"56":"Y sus hermanas, ¿no viven con nosotros? ¿De dónde le viene todo esto?'."
,"57":"Y aquello les parecía un escándalo. Pero Jesús les dijo: 'Sólo en su tierra y en su casa desprecian al profeta'."
,"58":"Y no hizo allí muchos milagros por su falta de fe."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Por entonces la fama de Jesús llegó a oídos del virrey Herodes,"
,"2":"el cual dijo a sus cortesanos: 'Ése es Juan Bautista, que ha resucitado de entre los muertos, y por eso tiene poder de obrar milagros'."
,"3":"Y es que Herodes había detenido a Juan, lo había encadenado y lo había metido en la cárcel por causa de Herodías, la mujer de su hermano Filipo;"
,"4":"pues Juan le decía: 'No te es permitido tenerla'."
,"5":"Quiso matarlo; pero tuvo miedo del pueblo, que lo tenía por profeta."
,"6":"Al llegar el cumpleaños de Herodes, la hija de Herodías bailó en presencia de todos, y tanto agradó a Herodes,"
,"7":"que juró darle lo que pidiera."
,"8":"Ella, instigada por su madre, le dijo: 'Dame ahora mismo en una bandeja la cabeza de Juan Bautista'."
,"9":"El rey se entristeció, pero por el juramento y por los invitados ordenó que se la dieran,"
,"10":"y envió a cortar la cabeza de Juan en la cárcel."
,"11":"Trajeron la cabeza en una bandeja y se la entregaron a la muchacha, la cual se la llevó a su madre."
,"12":"Sus discípulos fueron, recogieron el cadáver y lo sepultaron. Fueron después a decírselo a Jesús."
,"13":"Al saber esto, Jesús se fue de allí en una barca a un lugar tranquilo y solitario; la gente, al enterarse, lo siguió a pie desde las ciudades."
,"14":"Al desembarcar y ver a tanta gente, se compadeció de ella y curó a sus enfermos."
,"15":"Al caer el día, se le acercaron sus discípulos y le dijeron: 'Estamos en un descampado y ya es muy tarde; despide a la gente para que vayan a las aldeas a comprarse algo de comer'."
,"16":"Jesús les dijo: 'No hace falta que se vayan. Dadles vosotros de comer'."
,"17":"Ellos le dijeron: 'Sólo tenemos aquí cinco panes y dos peces'."
,"18":"Él dijo: 'Traédmelos'."
,"19":"Mandó que la gente se echase sobre la hierba, tomó los cinco panes y los dos peces, alzó los ojos al cielo y los bendijo; partió los panes y se los dio a los discípulos para que se los distribuyeran a la gente."
,"20":"Todos comieron y se hartaron; y se recogieron doce canastos llenos de las sobras."
,"21":"Los que comieron eran unos cinco mil hombres, sin contar mujeres y niños."
,"22":"Después obligó a los discípulos a que se embarcaran y se le adelantaran rumbo a la otra orilla, mientras él despedía a la gente."
,"23":"Y una vez que la despidió, subió al monte, a solas, para orar; al caer la tarde, estaba solo allí."
,"24":"Mientras, la barca se hallaba ya en medio del lago, batida por las olas, porque el viento era contrario."
,"25":"Hacia las tres de la madrugada se dirigió a ellos andando sobre el lago."
,"26":"Los discípulos, al verlo caminar sobre el lago, se asustaron y decían: '¡Es un fantasma!', y se pusieron a gritar llenos de miedo."
,"27":"Jesús les dijo: 'Tranquilizaos. Soy yo, no tengáis miedo'."
,"28":"Pedro le respondió: 'Señor, si eres tú, mándame ir a ti sobre las aguas'."
,"29":"Él dijo: 'Ven'. Pedro saltó de la barca y fue hacia Jesús andando sobre las aguas."
,"30":"Pero, al ver la fuerza del viento, se asustó y, como empezaba a hundirse, gritó: '¡Sálvame, Señor!'."
,"31":"Jesús le tendió la mano, lo agarró y le dijo: 'Hombre de poca fe, ¿por qué has dudado?'."
,"32":"Cuando subieron a la barca, el viento se calmó."
,"33":"Y los que estaban en ella se postraron ante él, diciendo: 'Verdaderamente tú eres el hijo de Dios'."
,"34":"Acabada la travesía, tomaron tierra en Genesaret."
,"35":"Las gentes del lugar lo reconocieron y propagaron la noticia por toda la comarca. Le trajeron todos los enfermos"
,"36":"y le suplicaban que les dejase tan sólo tocar la orla de su manto. Y todos los que lo tocaron se curaron."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Entonces se acercaron a Jesús unos fariseos y maestros de la ley de Jerusalén y le dijeron:"
,"2":"'¿Por qué tus discípulos quebrantan las tradiciones de los ancianos, pues no se lavan las manos al comer?'."
,"3":"Él les respondió: '¿Por qué vosotros mismos, por vuestra tradición, quebrantáis el mandato de Dios?"
,"4":"Porque Dios dijo: Honra a tu padre y a tu madre y el que maldiga a su padre y a su madre será condenado a muerte."
,"5":"Pero vosotros decís: El que diga a su padre o a su madre: Lo que tenía para ayudarte lo he ofrecido al templo,"
,"6":"queda libre de la obligación de ayudar a su padre y a su madre. Así habéis anulado el mandato de Dios con vuestra tradición."
,"7":"¡Hipócritas!, bien profetizó Isaías de vosotros:"
,"8":"Este pueblo me honra,con sus labios, pero su corazón está lejos de mí;"
,"9":"en vano me rinde culto, enseñando doctrinas,que son preceptos humanos."
,"10":"Llamó a la gente y les dijo: 'Oíd y entended:"
,"11":"No mancha al hombre lo que entra por la boca, sino lo que sale de la boca; eso es lo que mancha al hombre'."
,"12":"Entonces los discípulos se le acercaron y le dijeron: '¿Sabes que los fariseos, al oír tus palabras, se han escandalizado?'."
,"13":"Él respondió: 'Toda planta que no ha plantado mi Padre celestial será arrancada de raíz."
,"14":"Dejadlos. Son ciegos, guías de ciegos; y si un ciego guía a otro ciego, ambos caerán en el hoyo'."
,"15":"Pedro tomó la palabra y dijo: 'Explícanos esa parábola'."
,"16":"Él dijo: '¿Pero tampoco vosotros entendéis?"
,"17":"¿No sabéis que todo lo que entra por la boca va al vientre y termina en el retrete?"
,"18":"Pero lo que sale de la boca procede del corazón, y eso es lo que mancha al hombre."
,"19":"Porque del corazón provienen los malos pensamientos, homicidios, adulterios, fornicaciones, robos, falsos testimonios, blasfemias."
,"20":"Eso es lo que mancha al hombre; pero comer con las manos sin lavar no mancha al hombre'."
,"21":"Jesús salió de allí y se fue a las regiones de Tiro y Sidón."
,"22":"Y una mujer cananea salió de aquellos contornos y se puso a gritar: '¡Ten compasión de mí, Señor, hijo de David! Mi hija está atormentada por un demonio'."
,"23":"Pero él no le respondió nada. Sus discípulos se acercaron y le dijeron: 'Despídela, porque viene gritando detrás de nosotros'."
,"24":"Él respondió: 'No he sido enviado sino a las ovejas perdidas de la casa de Israel'."
,"25":"Pero ella se acercó, se puso de rodillas ante él y le suplicó: '¡Señor, ayúdame!'."
,"26":"Él respondió: 'No está bien quitarle el pan a los hijos para echárselo a los perros'."
,"27":"Ella dijo: 'Cierto, Señor; pero también los perros comen las migajas que caen de la mesa de sus amos'."
,"28":"Entonces Jesús le dijo: '¡Oh mujer, qué grande es tu fe! Que te suceda como quieres'. Y desde aquel momento su hija quedó curada."
,"29":"Jesús salió de allí, llegó a la costa del lago de Galilea, subió al monte y se sentó."
,"30":"Se le acercó mucha gente que llevaba cojos, ciegos, sordos, mancos y otros muchos enfermos, y los pusieron a sus pies. Y él los curó,"
,"31":"de suerte que la gente se maravillaba al ver a los mudos que hablaban, a los mancos sanos, a los cojos andando, a los ciegos que recobraban la vista. Y alabaron al Dios de Israel."
,"32":"Jesús llamó a sus discípulos y les dijo: 'Me da lástima de esta gente, pues ya llevan tres días conmigo y no tienen qué comer. No quiero despedirlos en ayunas, no sea que desfallezcan en el camino'."
,"33":"Los discípulos le dijeron: '¿De dónde podremos sacar pan para hartar a tanta gente aquí, en un despoblado?'."
,"34":"Jesús les dijo: '¿Cuántos panes tenéis?'. Ellos contestaron: 'Siete y algunos peces'."
,"35":"Mandó a la gente que se sentara en el suelo."
,"36":"Tomó los siete panes y los peces, dio gracias, los partió y los dio a los discípulos, y éstos a la gente."
,"37":"Comieron todos y se saciaron, y se recogieron siete espuertas de las sobras."
,"38":"Los que comieron eran cuatro mil hombres, sin contar las mujeres y los niños."
,"39":"Despidió a la gente, subió a la barca y se fue a la región de Magadán."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Los fariseos y los saduceos se le acercaron para tentarlo, y le pidieron que les mostrase una señal del cielo."
,"2":"Él les respondió: 'Por la tarde decís: Hará buen tiempo, porque el cielo se enrojece."
,"3":"Y por la mañana: Mal tiempo, porque el cielo se enrojece con sombras. Sabéis interpretar el aspecto del cielo, ¿y no sois capaces de interpretar las señales de los tiempos?'"
,"4":"'Esta generación malvada y adúltera pide una señal, pero no se les dará sino la señal de Jonás'. Los dejó y se fue."
,"5":"Al ir los discípulos a la otra orilla, se olvidaron de llevar pan."
,"6":"Jesús les dijo: 'Tened cuidado y guardaos de la levadura de los fariseos y saduceos'."
,"7":"Ellos comentaban: 'Es que no hemos traído pan'."
,"8":"Jesús, dándose cuenta, les dijo: '¿Por qué habláis de que no tenéis pan? ¡Hombres de poca fe!"
,"9":"¿Aún no entendéis? ¿No os acordáis ya de cuando repartí cinco panes para cinco mil hombres? ¿Cuántos cestos recogisteis de las sobras?"
,"10":"¿Y de cuando repartí los siete para los cuatro mil? ¿Cuántas espuertas recogisteis?"
,"11":"¿Cómo no entendéis que no os hablaba de panes? Guardaos de la levadura de los fariseos y saduceos'."
,"12":"Entonces comprendieron que no les había dicho que se guardasen del fermento del pan, sino de la doctrina de los fariseos y saduceos."
,"13":"Al llegar Jesús a la región de Cesarea de Filipo, preguntó a sus discípulos: '¿Quién dice la gente que es el hijo del hombre?'."
,"14":"Ellos le dijeron: 'Unos, que Juan el Bautista; otros, que Elías; otros, que Jeremías o uno de los profetas'."
,"15":"Él les dijo: 'Vosotros, ¿quién decís que soy yo?'."
,"16":"Simón tomó la palabra y dijo: 'Tú eres el mesías, el hijo del Dios vivo'."
,"17":"Jesús le respondió: 'Dichoso tú, Simón, hijo de Juan, porque eso no te lo ha revelado la carne ni la sangre, sino mi Padre que está en los cielos."
,"18":"Yo te digo que tú eres Pedro y sobre esta piedra edificaré mi Iglesia, y las puertas del infierno no prevalecerán contra ella."
,"19":"Te daré las llaves del reino de Dios; y lo que ates en la tierra quedará atado en los cielos, y lo que desates en la tierra quedará desatado en los cielos'."
,"20":"Entonces ordenó a sus discípulos que no dijesen a nadie que él era el mesías."
,"21":"Desde entonces comenzó Jesús a declarar a sus discípulos que él tenía que ir a Jerusalén y padecer mucho de parte de los ancianos del pueblo, de los sumos sacerdotes y de los maestros de la ley, ser matado y resucitar al tercer día."
,"22":"Pedro se lo llevó aparte y se puso a reprenderle: '¡Dios te libre, Señor! ¡No te sucederá eso!'."
,"23":"Pero él, volviéndose, le dijo: '¡Apártate de mí, Satanás!, pues eres un obstáculo para mí, porque tus sentimientos no son los de Dios, sino los de los hombres'."
,"24":"Luego dijo a sus discípulos: 'El que quiera venir en pos de mí, niéguese a sí mismo, tome su cruz y sígame."
,"25":"Porque el que quiera salvar su vida la perderá, pero el que pierda su vida por mí la encontrará."
,"26":"¿Qué le vale al hombre ganar el mundo entero si pierde su vida? ¿Y qué dará el hombre a cambio de su vida?"
,"27":"Porque el hijo del hombre vendrá en la gloria de su Padre con sus ángeles, y entonces dará a cada uno según sus obras."
,"28":"Os aseguro que algunos de los presentes no morirán sin haber visto al hijo del hombre venir como rey'."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Seis días después Jesús tomó consigo a Pedro, a Santiago y a Juan, su hermano, y los llevó a un monte alto a solas."
,"2":"Y se transfiguró ante ellos. Su rostro brilló como el sol y sus vestiduras se volvieron blancas como la luz."
,"3":"Y se le aparecieron Moisés y Elías hablando con él."
,"4":"Pedro tomó la palabra y dijo a Jesús: 'Señor, qué bien se está aquí. Si quieres, hago aquí tres tiendas: una para ti, otra para Moisés y otra para Elías'."
,"5":"Aún estaba hablando, cuando una nube luminosa los cubrió, y una voz desde la nube dijo: 'Éste es mi hijo amado, mi predilecto, escuchadlo'."
,"6":"Al oírlo, los discípulos cayeron de bruces, aterrados de miedo."
,"7":"Jesús se acercó, los tocó y les dijo: 'Levantaos y no tengáis miedo'."
,"8":"Alzaron ellos sus ojos y no vieron a nadie, sino sólo a Jesús."
,"9":"Y mientras bajaban del monte, Jesús les ordenó: 'No contéis a nadie esta visión hasta que el hijo del hombre haya resucitado de entre los muertos'."
,"10":"Los discípulos le preguntaron: '¿Por qué dicen los maestros de la ley que Elías debe venir antes?'."
,"11":"Él respondió: 'Elías vendrá antes a ponerlo todo en orden."
,"12":"Pero yo os digo: Elías ha venido ya y no lo han reconocido, sino que lo han tratado a su antojo. Así también el hijo del hombre ha de padecer por parte de ellos'."
,"13":"Entonces entendieron los discípulos que les había hablado de Juan el Bautista."
,"14":"Al llegar donde estaba la gente, se le acercó un hombre, se puso de rodillas ante él y le dijo:"
,"15":"'Señor, ten compasión de mi hijo, que es epiléptico y está muy mal. Muchas veces cae en el fuego y otras muchas en el agua."
,"16":"Lo he presentado a tus discípulos y no han podido curarlo'."
,"17":"Jesús respondió: '¡Gente incrédula y perversa! ¿Hasta cuándo tendré que soportaros? Traédmelo'."
,"18":"Jesús lo increpó, el demonio salió del muchacho y en aquel momento quedó curado."
,"19":"Entonces los discípulos se acercaron a Jesús y, a solas con él, le preguntaron: '¿Por qué nosotros no pudimos echarlo?'."
,"20":"Les dijo: 'Por vuestra poca fe; os aseguro que si tuvierais fe como un grano de mostaza, diríais a este monte: Vete de aquí allá, y se trasladaría; nada os sería imposible'."
,"22":"Estando en Galilea, Jesús les dijo: 'El hijo del hombre va a ser entregado en manos de los hombres,"
,"23":"lo matarán y al tercer día resucitará'. Y ellos se entristecieron mucho."
,"24":"Cuando llegaron a Cafarnaún, los recaudadores de los impuestos se acercaron a Pedro y le dijeron: '¿Vuestro maestro no paga el impuesto?'."
,"25":"Respondió: 'Sí'. Cuando entró en casa, se anticipó Jesús diciéndole: '¿Qué te parece, Simón? Los reyes de la tierra, ¿de quiénes cobran los impuestos? ¿De sus hijos o de los extraños?'."
,"26":"Él contestó que de los extraños. Jesús le dijo: 'Luego los hijos están libres."
,"27":"Pero, para no escandalizarlos, vete al mar, echa el anzuelo y al primer pez que suba sácalo, ábrele la boca y encontrarás en ella la moneda precisa. Tómala y dásela a ellos por mí y por ti'."
}`)
	CurrentBook.AddChapter(18, `{
"1":"En aquel momento se acercaron los discípulos a Jesús y le preguntaron: '¿Quién es, entonces, el más grande en el reino de Dios?'."
,"2":"Jesús llamó a un niño, lo puso en el centro"
,"3":"y dijo: 'Os aseguro que si no cambiáis y os hacéis como niños, no entraréis en el reino de Dios."
,"4":"El que se haga pequeño como este niño, ése es el más grande en el reino de Dios'."
,"5":"'El que acoge en mi nombre a un niño como éste, a mí me acoge."
,"6":"Al que escandalice a uno de estos pequeñuelos que creen en mí, más le valdría que le ataran al cuello una piedra de molino y lo tiraran al mar."
,"7":"¡Ay del mundo por los escándalos! Es inevitable que haya escándalos; pero ¡ay del hombre por el que venga el escándalo!"
,"8":"Si tu mano o tu pie son para ti ocasión de pecado, córtatelos y tíralos lejos de ti. Más te vale entrar en la vida manco o cojo que con las dos manos o los dos pies ser arrojado al fuego eterno."
,"9":"Y si tu ojo es para ti ocasión de pecado, sácatelo y tíralo lejos de ti. Es mejor entrar con un solo ojo en la vida que con dos ojos ser arrojado al fuego."
,"10":"Guardaos de despreciar a uno de estos pequeñuelos, porque yo os digo que sus ángeles en los cielos están continuamente en la presencia de mi Padre celestial."
,"11":"Porque el hijo del hombre ha venido a salvar lo que estaba perdido'."
,"12":"'¿Qué os parece? Si un hombre tiene cien ovejas y se le extravía una de ellas, ¿no dejará en los montes las noventa y nueve e irá a buscar la extraviada?"
,"13":"Y si la encuentra, os aseguro que se alegra por ella más que por las noventa y nueve que no se habían extraviado."
,"14":"De la misma manera, vuestro Padre celestial no quiere que se pierda ni uno solo de esos pequeñuelos'."
,"15":"'Si tu hermano ha pecado contra ti, ve y repréndelo a solas; si te escucha, habrás ganado a tu hermano;"
,"16":"pero si no te escucha, toma todavía contigo uno o dos, para que toda causa sea decidida por la palabra de dos o tres testigos."
,"17":"Si no quiere escucharles, dilo a la comunidad; y si tampoco quiere escuchar a la comunidad, considéralo como pagano y publicano."
,"18":"Os aseguro que todo lo que atéis en la tierra quedará atado en el cielo, y todo lo que desatéis en la tierra quedará desatado en el cielo'."
,"19":"'Os aseguro que, si dos de vosotros se ponen de acuerdo sobre la tierra, cualquier cosa que pidan les será concedida por mi Padre celestial."
,"20":"Porque donde hay dos o tres reunidos en mi nombre, allí estoy yo en medio de ellos'."
,"21":"Pedro se acercó y le dijo: 'Señor, ¿cuántas veces tengo que perdonar a mi hermano las ofensas que me haga? ¿Hasta siete veces?'."
,"22":"Jesús le dijo: 'No te digo hasta siete veces, sino hasta setenta veces siete'."
,"23":"'El reino de Dios es semejante a un rey que quiso arreglar sus cuentas con sus empleados."
,"24":"Al comenzar a tomarlas, le fue presentado uno que le debía millones."
,"25":"No teniendo con qué pagar, el señor mandó que fuese vendido él, su mujer y sus hijos y todo cuanto tenía, y que le fuera pagada la deuda."
,"26":"El empleado se echó a sus pies y le suplicó: Dame un plazo y te lo pagaré todo."
,"27":"El señor se compadeció de él, lo soltó y le perdonó la deuda."
,"28":"El empleado, al salir, se encontró con uno de sus compañeros que le debía un poco de dinero; lo agarró por el cuello y le dijo: ¡Paga lo que debes!"
,"29":"El compañero se echó a sus pies y le suplicó: ¡Dame un plazo y te pagaré!"
,"30":"Pero él no quiso, sino que fue y lo metió en la cárcel hasta que pagara la deuda."
,"31":"Al ver sus compañeros lo ocurrido, se disgustaron mucho y fueron a contar a su señor todo lo que había pasado."
,"32":"Entonces su señor lo llamó y le dijo: Malvado, te he perdonado toda aquella deuda porque me lo suplicaste."
,"33":"¿No debías tú también haberte compadecido de tu compañero, como yo me compadecí de ti?"
,"34":"Y el señor, irritado, lo entregó a los torturadores, hasta que pagase toda la deuda."
,"35":"Así hará mi Padre celestial con vosotros si cada uno de vosotros no perdona de corazón a su hermano'."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Cuando acabó de decir estas cosas, Jesús salió de Galilea y se fue a Judea, al otro lado del Jordán."
,"2":"Lo siguió mucha gente, y allí los curó."
,"3":"Se le acercaron unos fariseos y le preguntaron para ponerlo a prueba: '¿Le está permitido al hombre separarse de su mujer por cualquier motivo?'."
,"4":"Él respondió: '¿No habéis leído que el creador desde el principio los hizo macho y hembra,"
,"5":"y que dijo: Por esto el hombre dejará a su padre y a su madre y se unirá a su mujer y serán los dos una sola carne?"
,"6":"De tal manera que ya no son dos, sino una sola carne. Por tanto, lo que Dios ha unido que no lo separe el hombre'."
,"7":"Le replicaron: 'Entonces, ¿por qué Moisés ordenó darle el acta de divorcio cuando se separa de ella?'."
,"8":"Les dijo: 'Moisés os permitió separaros de vuestras mujeres por la dureza de vuestro corazón, pero al principio no era así."
,"9":"Por tanto, os digo que el que se separe de su mujer, excepto en el caso de concubinato, y se case con otra, comete adulterio'."
,"10":"Los discípulos le dijeron: 'Si tal es la condición del hombre respecto a su mujer, no conviene casarse'."
,"11":"Pero él les dijo: 'No todos comprenden esta doctrina, sino aquellos a quienes les es concedido."
,"12":"Porque hay eunucos que nacieron así del vientre de su madre, los hay que fueron hechos eunucos por los hombres y los hay que a sí mismos se hicieron tales por el reino de Dios. ¡El que sea capaz de hacer esto que lo haga!'."
,"13":"Entonces le presentaron unos niños para que les impusiera las manos y rezase por ellos. Los discípulos los regañaban,"
,"14":"pero Jesús dijo: 'Dejad que los niños se acerquen a mí y no se lo impidáis, porque de los que son como ellos es el reino de Dios'."
,"15":"Y después de imponerles las manos, continuó su camino."
,"16":"Se le acercó un hombre y le dijo: 'Maestro, ¿qué tengo que hacer de bueno para alcanzar la vida eterna?'."
,"17":"Él le dijo: '¿Qué me preguntas acerca de lo que es bueno? El único bueno es Dios. Pero, si quieres entrar en la vida, guarda los mandamientos'."
,"18":"Replicó: '¿Cuáles?'. Jesús dijo: 'No matarás, no cometerás adulterio, no robarás, no levantarás falsos testimonios,"
,"19":"honra a tu padre y a tu madre y ama a tu prójimo como a ti mismo'."
,"20":"El joven le dijo: 'Todo eso lo he guardado. ¿Qué más hace falta?'."
,"21":"Jesús le dijo: 'Si quieres ser perfecto, anda, vende todo lo que tienes y dáselo a los pobres, y tendrás un tesoro en el cielo; después, ven y sígueme'."
,"22":"Al oír esto, el joven se fue muy triste, porque tenía muchos bienes."
,"23":"Jesús dijo a sus discípulos: 'Os aseguro que un rico difícilmente entrará en el reino de Dios."
,"24":"Es más fácil que un camello pase por el ojo de una aguja que un rico entre en el reino de Dios'."
,"25":"Al oír esto los discípulos, se quedaron asombrados y dijeron: 'Entonces, ¿quién puede salvarse?'."
,"26":"Jesús los miró y les dijo: 'Para los hombres esto es imposible, pero para Dios todo es posible'."
,"27":"Entonces Pedro le dijo: 'Nosotros lo hemos dejado todo y te hemos seguido; ¿qué nos espera?'."
,"28":"Jesús les dijo: 'Os aseguro que vosotros, los que me habéis seguido, en la nueva creación, cuando el hijo del hombre se siente en el trono de su gloria, os sentaréis también sobre doce tronos para juzgar a las doce tribus de Israel."
,"29":"Y todo el que deje casa, hermanos o hermanas, padre o madre, o hijos o campos por mi causa recibirá el ciento por uno y heredará la vida eterna'."
,"30":"'Muchos primeros serán los últimos, y los últimos los primeros'."
}`)
	CurrentBook.AddChapter(20, `{
"1":"'El reino de Dios es como un amo que salió muy de mañana a contratar obreros para su viña."
,"2":"Convino con los obreros en un denario al día, y los envió a su viña."
,"3":"Fue también a las nueve de la mañana, vio a otros que estaban parados en la plaza"
,"4":"y les dijo: Id también vosotros a la viña, yo os daré lo que sea justo."
,"5":"Y fueron. De nuevo fue hacia el mediodía, y otra vez a las tres de la tarde, e hizo lo mismo."
,"6":"Volvió por fin hacia las cinco de la tarde, encontró a otros que estaban parados y les dijo: ¿Por qué estáis aquí todo el día sin hacer nada?"
,"7":"Le dijeron: Porque nadie nos ha contratado. Él les dijo: Id también vosotros a la viña."
,"8":"Al caer la tarde dijo el dueño de la viña a su administrador: Llama a los obreros y págales el jornal, empezando por los últimos hasta los primeros."
,"9":"Vinieron los de las cinco de la tarde y recibieron un denario cada uno."
,"10":"Al llegar los primeros, pensaron que cobrarían más, pero también ellos recibieron un denario cada uno."
,"11":"Y, al tomarlo, murmuraban contra el amo"
,"12":"diciendo: Esos últimos han trabajado una sola hora y los has igualado a nosotros, que hemos soportado el peso del día y el calor."
,"13":"Él respondió a uno de ellos: Amigo, no te hago ninguna injusticia. ¿No convinimos en un denario?"
,"14":"Toma lo tuyo y vete. Pero yo quiero dar a este último lo mismo que a ti."
,"15":"¿No puedo hacer lo que quiera con lo mío? ¿O ves con malos ojos el que yo sea bueno?"
,"16":"Así pues, los últimos serán los primeros, y los primeros los últimos'."
,"17":"Cuando Jesús iba camino de Jerusalén, llevó aparte a los doce discípulos y les dijo:"
,"18":"'Mirad, vamos a Jerusalén, y el hijo del hombre será entregado a los sumos sacerdotes y a los maestros de la ley; lo condenarán a muerte,"
,"19":"lo entregarán a los paganos, se burlarán de él, lo azotarán y lo crucificarán, pero al tercer día resucitará'."
,"20":"Entonces se le acercó la madre de los hijos de Zebedeo con ellos y se puso de rodillas para pedirle algo."
,"21":"Él dijo: '¿Qué quieres?'. Ella dijo: 'Di que estos dos hijos míos se sienten uno a tu derecha y otro a tu izquierda en tu reino'."
,"22":"Jesús respondió: 'No sabéis lo que pedís. ¿Podréis beber el cáliz que yo he de beber?'. Contestaron: 'Podemos'."
,"23":"Jesús les dijo: 'Beberéis, ciertamente, mi cáliz; pero el sentarse a mi derecha o a mi izquierda no es cosa mía el concederlo; es para quienes ha sido reservado por mi Padre'."
,"24":"Los otros diez, al oír esto, se indignaron contra los dos hermanos."
,"25":"Jesús los llamó y les dijo: 'Sabéis que los jefes de las naciones las tiranizan y que los grandes las oprimen con su poderío."
,"26":"Entre vosotros no debe ser así, sino que si alguno de vosotros quiere ser grande, que sea vuestro servidor;"
,"27":"y el que de vosotros quiera ser el primero, que sea el servidor de todos;"
,"28":"de la misma manera que el hijo del hombre no ha venido a ser servido, sino a servir y dar su vida por la liberación de todos'."
,"29":"Al salir de Jericó, los siguió mucha gente."
,"30":"Dos ciegos, sentados junto al camino, oyeron que pasaba Jesús, y gritaron: '¡Señor, hijo de David, ten compasión de nosotros!'."
,"31":"La gente los reprendió para que se callasen, pero ellos gritaban con más fuerza: '¡Señor, hijo de David, ten compasión de nosotros!'."
,"32":"Jesús se detuvo, los llamó y les dijo: '¿Qué queréis que os haga?'."
,"33":"Le dijeron: '¡Señor, que se abran nuestros ojos!'."
,"34":"Jesús se compadeció, tocó sus ojos, y al punto recobraron la vista y se fueron tras él."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Al acercarse a Jerusalén, llegaron a Betfagé, al monte de los Olivos; Jesús envió a dos discípulos,"
,"2":"diciéndoles: 'Id a la aldea de enfrente; a la entrada encontraréis una borriquilla atada, y con ella un pollino; desatadlos y traédmelos."
,"3":"Y si alguien os dice algo, decidle: 'El Señor los necesita, y en seguida los devolverá'."
,"4":"Esto ocurrió para que se cumpliera lo que había dicho el profeta:"
,"5":"Decid a la hija de Sión: Mira que tu rey viene a ti,humilde y montado en un asno, en un pollino, hijo de animal de carga."
,"6":"Los discípulos fueron e hicieron como Jesús les ordenó,"
,"7":"y trajeron la borriquilla y el pollino. Pusieron sobre ellos sus mantos, y Jesús se montó."
,"8":"Muchos alfombraban el camino con sus mantos, y otros con ramas que cortaban de los árboles."
,"9":"Los que iban delante y detrás gritaban: ¡Viva el hijo de David!,Bendito el que viene,en nombre del Señor. ¡Viva Dios altísimo!"
,"10":"Al entrar él en Jerusalén, toda la ciudad se conmovió; decían: '¿Quién es éste?'."
,"11":"Y la gente respondía: 'Éste es Jesús, el profeta de Nazaret de Galilea'."
,"12":"Jesús entró en el templo y echó a todos los que estaban allí vendiendo y comprando. Volcó las mesas de los cambistas y los puestos de los vendedores de palomas,"
,"13":"y les dijo: 'Está escrito: Mi casa es casa de oración; pero vosotros la habéis convertido en una cueva de ladrones'."
,"14":"Se llegaron a él en el templo ciegos y cojos, y los curó."
,"15":"Pero los sumos sacerdotes y los maestros de la ley, al ver las maravillas que hacía y a los niños que gritaban en el templo '¡Viva el hijo de David!', se indignaron y le dijeron:"
,"16":"¿Oyes lo que éstos dicen?'. Jesús les contestó: 'Sí. ¿Nunca habéis leído: De la boca de los pequeños y de los niños de pecho te procuraste alabanzas?'."
,"17":"Y dejándoles, salió de la ciudad, se fue a Betania y allí pasó la noche."
,"18":"Cuando volvía muy temprano a la ciudad, sintió hambre."
,"19":"Vio una higuera junto al camino, se acercó a ella y no encontró más que hojas. Entonces dijo: 'Jamás brote de ti fruto alguno'. Y la higuera se secó en aquel mismo instante."
,"20":"Al ver esto los discípulos, admirados, decían: '¡Cómo se ha secado de repente la higuera!'."
,"21":"Jesús les respondió: 'Os aseguro que si tuvierais fe y no dudarais, no sólo haríais lo de la higuera, sino que si decís a este monte: Quítate de ahí y échate al mar, así se hará."
,"22":"Todo lo que pidáis en oración con fe lo recibiréis'."
,"23":"Entró en el templo y, mientras enseñaba, se le acercaron los sumos sacerdotes y los ancianos del pueblo y le preguntaron: '¿Con qué autoridad haces todo esto? ¿Quién te ha dado esa autoridad?'."
,"24":"Jesús les respondió: 'Yo también os haré una pregunta; y si me contestáis, os diré con qué autoridad hago todo esto."
,"25":"El bautismo de Juan, ¿era del cielo o de los hombres?'. Ellos se hicieron este razonamiento: 'Si decimos que del cielo, nos dirá: Entonces, ¿por qué no creísteis en él?"
,"26":"Y si decimos que de los hombres, tememos a la gente, porque todos tienen a Juan por profeta'."
,"27":"Y respondieron a Jesús: 'No lo sabemos'. Él les replicó: 'Tampoco yo os digo con qué autoridad hago todo esto'."
,"28":"'¿Qué os parece? Un hombre tenía dos hijos; se acercó al primero y le dijo: Hijo, vete a trabajar hoy a la viña."
,"29":"Y él respondió: No quiero. Pero después se arrepintió y fue."
,"30":"Se acercó al otro hijo y le dijo lo mismo, y éste respondió: Voy, señor; pero no fue."
,"31":"¿Cuál de los dos hizo la voluntad de su padre?'. Le contestaron: 'El primero'. Jesús dijo: 'Os aseguro que los publicanos y las prostitutas entrarán en el reino de Dios antes que vosotros."
,"32":"Porque Juan vino por el camino de la justicia, y no creísteis en él, mientras que los publicanos y las prostitutas han creído en él. Pero vosotros, aun viendo esto, no os habéis arrepentido ni creído en él'."
,"33":"'Oíd otra parábola: Un hacendado plantó una viña, la cercó con una valla, cavó en ella un lagar, edificó una torre para guardarla, la arrendó a unos viñadores y se fue de viaje."
,"34":"Cuando llegó el tiempo de la vendimia, mandó sus criados a los viñadores para recibir su parte."
,"35":"Pero los viñadores agarraron a los criados, y a uno le pegaron, a otro lo mataron y a otro lo apedrearon."
,"36":"Mandó de nuevo otros criados, más que antes, e hicieron con ellos lo mismo."
,"37":"Finalmente les mandó a su hijo diciendo: Respetarán a mi hijo."
,"38":"Pero los viñadores, al ver al hijo, se dijeron: Éste es el heredero. Matémoslo y nos quedaremos con su herencia."
,"39":"Lo agarraron, lo echaron fuera de la viña y lo mataron."
,"40":"Cuando venga el dueño de la viña, ¿qué hará con aquellos viñadores?'."
,"41":"Le dijeron: 'Hará morir de mala muerte a esos malvados y arrendará la viña a otros viñadores que le paguen los frutos a su tiempo'."
,"42":"Jesús les dijo: '¿No habéis leído nunca en las Escrituras: La piedra que los constructores,desecharon, en piedra angular se ha convertido; esto ha sido obra del Señor, una maravilla a nuestros ojos?'"
,"43":"'Pues bien, os digo que se os quitará a vosotros el reino de Dios para dárselo a un pueblo que pague sus frutos."
,"44":"El que caiga sobre esta piedra se estrellará, y sobre el que ella caiga será triturado'."
,"45":"Cuando los sumos sacerdotes y los fariseos oyeron estas parábolas, comprendieron que se refería a ellos"
,"46":"y querían prenderlo, pero temían a la gente porque lo tenían por profeta."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Y Jesús se puso a hablar de nuevo en parábolas:"
,"2":"'El reino de Dios es semejante a un rey que celebró las bodas de su hijo."
,"3":"Envió sus criados a llamar a los invitados a las bodas, y no quisieron venir."
,"4":"Mandó de nuevo a otros criados con este encargo: Decid a los invitados: Mi banquete está preparado, mis terneros y cebones dispuestos, todo está a punto; venid a las bodas."
,"5":"Pero ellos no hicieron caso y se fueron, unos a su campo y otros a su negocio;"
,"6":"los demás echaron mano a los criados, los maltrataron y los mataron."
,"7":"El rey, entonces, se irritó, mandó sus tropas a exterminar a aquellos asesinos e incendió su ciudad."
,"8":"Luego dijo a sus criados: El banquete de bodas está preparado, pero los invitados no eran dignos."
,"9":"Id a las encrucijadas de los caminos y a todos los que encontréis convidadlos a la boda."
,"10":"Los criados salieron a los caminos y recogieron a todos los que encontraron, malos y buenos, y la sala de bodas se llenó de invitados."
,"11":"El rey entró para ver a los invitados, reparó en un hombre que no tenía traje de boda"
,"12":"y le dijo: Amigo, ¿cómo has entrado aquí sin tener un traje de boda? Pero él no contestó."
,"13":"Entonces el rey dijo a los camareros: Atadlo de pies y manos y arrojadlo a las tinieblas exteriores: allí será el llanto y el crujir de dientes."
,"14":"Porque muchos son los llamados, pero pocos los escogidos'."
,"15":"Los fariseos se fueron a deliberar y ver cómo le podrían cazar en alguna palabra."
,"16":"Le enviaron discípulos suyos con los herodianos a decirle: 'Maestro, sabemos que eres sincero, que enseñas de verdad el camino de Dios y que no te importa nada el qué dirán, porque no tienes respetos humanos."
,"17":"Dinos tu parecer: ¿Es lícito pagar el impuesto al césar o no?'."
,"18":"Jesús, conociendo su malicia, dijo:"
,"19":"'Enseñadme la moneda del tributo'. Ellos le presentaron un denario."
,"20":"Jesús les dijo: '¿De quién es esta efigie y esta inscripción?'."
,"21":"Respondieron: 'Del césar'. Él les dijo: 'Pues dad al césar lo que es del césar y a Dios lo que es de Dios'."
,"22":"Al oírlo se asombraron, lo dejaron y se fueron."
,"23":"El mismo día se le acercaron unos saduceos, que niegan la resurrección, y le preguntaron:"
,"24":"'Maestro, Moisés dijo: Si muere un hombre casado sin tener hijos, su hermano se casará con la viuda para dar descendencia a su hermano."
,"25":"Eran siete hermanos; el primero se casó y murió sin dejar hijos, por lo que la viuda se casó con el hermano siguiente."
,"26":"Igualmente el segundo y el tercero, hasta el séptimo."
,"27":"Finalmente murió también la mujer."
,"28":"En la resurrección, ¿de cuál de los siete será esa mujer? Porque todos la tuvieron por mujer'."
,"29":"Jesús les respondió: 'Estáis en un error, porque no entendéis las Escrituras ni el poder de Dios."
,"30":"Porque en la resurrección ni los hombres ni las mujeres se casarán, sino que serán como ángeles en el cielo."
,"31":"Y acerca de la resurrección de los muertos, ¿no habéis leído lo que dijo Dios:"
,"32":"Yo soy el Dios de Abrahán, el Dios de Isaac y el Dios de Jacob? No es un Dios de muertos, sino de vivos'."
,"33":"Al oírlo, la gente se admiraba de su doctrina."
,"34":"Cuando los fariseos oyeron que había tapado la boca a los saduceos, se reunieron,"
,"35":"y uno de ellos, doctor en la ley, le preguntó para tentarlo:"
,"36":"'Maestro, ¿cuál es el mandamiento principal de la ley?'."
,"37":"Él le dijo: 'Amarás al Señor, tu Dios, con todo tu corazón, con toda tu alma y con toda tu mente."
,"38":"Éste es el principal y primer mandamiento."
,"39":"El segundo es semejante a éste: Amarás a tu prójimo como a ti mismo."
,"40":"En estos dos mandamientos se resume toda la ley y los profetas'."
,"41":"Jesús preguntó a los fariseos cuando estaban reunidos:"
,"42":"'¿Qué opináis del mesías? ¿De quién es hijo?'. Dijeron: 'De David'."
,"43":"Él les replicó: 'Pues, ¿cómo David, inspirado por el Espíritu, le llama Señor cuando dice:"
,"44":"El Señor dijo a mi Señor: Siéntate a mi derecha, hasta que ponga a tus enemigos,debajo de tus pies?'"
,"45":"'Pues si el mismo David le llama Señor, ¿cómo puede ser hijo suyo?'."
,"46":"Nadie podía responderle; y desde aquel día nadie se atrevió a preguntarle."
}`)
	CurrentBook.AddChapter(23, `{
"1":"Entonces Jesús dijo a la gente y a sus discípulos:"
,"2":"'Los maestros de la ley y los fariseos se sientan en la cátedra de Moisés."
,"3":"Haced y guardad lo que os digan, pero no hagáis lo que ellos hacen, porque dicen y no hacen."
,"4":"Atan cargas pesadas e insoportables y las echan a los hombros del pueblo, pero ellos ni con un dedo quieren moverlas."
,"5":"Hacen todas sus obras para que los vean los demás. Ensanchan sus filacterias y alargan los flecos del manto."
,"6":"Les gusta ocupar los primeros puestos en los banquetes y en las sinagogas,"
,"7":"ser saludados en las plazas y que los llamen ¡maestros!"
,"8":"Pero vosotros no os dejéis llamar maestro, porque uno es vuestro maestro y todos vosotros sois hermanos."
,"9":"A nadie en la tierra llaméis padre, porque uno solo es vuestro Padre, el celestial."
,"10":"Ni os dejéis llamar preceptores, porque uno solo es vuestro preceptor: el mesías."
,"11":"El más grande de vosotros que sea vuestro servidor."
,"12":"Pues el que se ensalza será humillado y el que se humilla será ensalzado'."
,"13":"'¡Ay de vosotros, maestros de la ley y fariseos hipócritas, que cerráis el reino de Dios a los hombres! ¡No entráis vosotros ni dejáis entrar a los que quieren!"
,"15":"¡Ay de vosotros, maestros de la ley y fariseos hipócritas, que recorréis mares y tierras para hacer un prosélito y, cuando llega a serlo, lo hacéis reo del fuego dos veces más que vosotros!"
,"16":"¡Ay de vosotros, guías ciegos, que decís: Si se jura por el santuario, no es nada; pero el que jura por el oro del santuario queda obligado!"
,"17":"¡Necios y ciegos! ¿Qué es más? ¿El oro o el santuario que santifica el oro?"
,"18":"Y decís además: Jurar por el altar no es nada, pero el que jura por lo ofrendado sobre él queda obligado."
,"19":"¡Ciegos! ¿Qué es más? ¿La ofrenda o el altar que santifica a la ofrenda?"
,"20":"El que jura por el altar jura por él y por todo lo que está sobre él,"
,"21":"y el que jura por el santuario jura por él y por quien lo habita,"
,"22":"y el que jura por el cielo jura por el trono de Dios y por el que está sentado en él."
,"23":"¡Ay de vosotros, maestros de la ley y fariseos hipócritas, que pagáis el diezmo de la menta, del anís y del comino, y descuidáis lo más importante de la ley: la justicia, la misericordia y la fe! Hay que hacer una cosa sin descuidar la otra."
,"24":"¡Guías ciegos, que coláis un mosquito y os tragáis un camello!"
,"25":"¡Ay de vosotros, maestros de la ley y fariseos hipócritas, que limpiáis por fuera el vaso y el plato, pero por dentro están llenos de rapiña y codicia!"
,"26":"¡Fariseo ciego, limpia primero el vaso y el plato por dentro, para que también por fuera queden limpios!"
,"27":"¡Ay de vosotros, maestros de la ley y fariseos hipócritas, que sois como sepulcros blanqueados, que por fuera aparecen hermosos, pero por dentro están llenos de huesos de muertos y de podredumbre!"
,"28":"Así también vosotros por fuera parecéis justos ante los hombres, pero por dentro estáis llenos de hipocresía y de crímenes."
,"29":"¡Ay de vosotros, maestros de la ley y fariseos hipócritas, que edificáis sepulcros a los profetas, adornáis las tumbas de los justos"
,"30":"y decís: Si hubiéramos vivido en tiempo de nuestros padres, no habríamos participado con ellos en la sangre de los profetas!"
,"31":"Así testificáis contra vosotros mismos, que sois hijos de los que mataron a los profetas."
,"32":"Colmad, pues, la medida de vuestros padres."
,"33":"¡Serpientes, raza de víboras! ¿Cómo escaparéis de la condenación del fuego? Por eso yo os envío profetas, sabios y maestros de la ley;"
,"34":"a unos los mataréis y crucificaréis, y a otros los azotaréis en vuestras sinagogas y los perseguiréis de ciudad en ciudad,"
,"35":"para que caiga sobre vosotros toda la sangre inocente vertida sobre la tierra, desde la sangre del justo Abel hasta la sangre de Zacarías, hijo de Baraquías, a quien asesinasteis entre el santuario y el altar."
,"36":"Os aseguro que todo eso vendrá sobre esta generación'."
,"37":"'¡Jerusalén, Jerusalén, que matas a los profetas y apedreas a los que te son enviados! ¡Cuántas veces he querido reunir a tus hijos como la gallina reúne a sus polluelos debajo de las alas y no has querido!"
,"38":"He aquí que se queda desierta vuestra casa."
,"39":"Os digo que ya no me veréis hasta que digáis: ¡Bendito el que viene en nombre del Señor!'."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Jesús salió del templo e iba caminando, cuando se le acercaron sus discípulos para mostrarle las construcciones del templo."
,"2":"Pero él les dijo: '¿Veis todo esto? Os aseguro que no quedará aquí piedra sobre piedra; todo será destruido'."
,"3":"Estando él sentado en el monte de los Olivos, fueron los discípulos y le preguntaron a solas: 'Dinos, ¿cuándo sucederá eso y cuál será la señal de tu venida y del fin del mundo?'."
,"4":"Jesús les respondió: 'Mirad que nadie os engañe."
,"5":"Muchos vendrán en mi nombre diciendo: Yo soy el mesías, y engañarán a muchos."
,"6":"Cuando oigáis hablar de guerras y noticias de batallas, no os alarméis, porque es necesario que todo eso ocurra; pero todavía no será el fin."
,"7":"Se levantarán pueblos contra pueblos y reinos contra reinos; habrá hambre y terremotos en diversos lugares."
,"8":"Eso será sólo el comienzo de los dolores."
,"9":"Entonces os entregarán a la tortura y a la muerte. Por mi causa os odiarán todos los pueblos."
,"10":"Muchos se escandalizarán, se traicionarán y odiarán unos a otros."
,"11":"Surgirán muchos falsos profetas y engañarán a muchos."
,"12":"El exceso de la maldad enfriará la caridad de mucha gente,"
,"13":"pero el que persevere hasta el fin se salvará."
,"14":"Este evangelio del reino se predicará en el mundo entero en testimonio para todas las naciones, y luego vendrá el fin'."
,"15":"'Cuando veáis en el lugar santo el ídolo repugnante anunciado por el profeta Daniel (el que lea que entienda),"
,"16":"entonces los que estén en Judea que huyan a los montes,"
,"17":"el que esté en la terraza que no baje a recoger nada de su casa"
,"18":"y el que esté en el campo que no vuelva por su manto."
,"19":"¡Ay de las que estén encinta y criando en aquellos días!"
,"20":"Rezad para que vuestra huida no caiga en invierno ni en sábado."
,"21":"Porque entonces habrá una angustia tan grande como no la ha habido desde el principio del mundo hasta ahora ni la habrá jamás."
,"22":"Si aquellos días no se acortasen, nadie se salvaría; pero, en atención a los elegidos, aquellos días serán acortados'."
,"23":"'Entonces si alguno os dice: El mesías está aquí o allá, no lo creáis."
,"24":"Surgirán falsos mesías y falsos profetas, y harán grandes señales y prodigios para engañar, si fuera posible, aun a los mismos elegidos."
,"25":"Mirad que os lo he dicho todo de antemano."
,"26":"Si os dicen que está en el desierto, no salgáis; si en un escondite, no lo creáis."
,"27":"Porque como el relámpago sale del oriente y brilla hasta el occidente, así será la venida del hijo del hombre."
,"28":"Donde esté el cadáver, allí se reunirán los buitres'."
,"29":"'En aquellos días, después de esta angustia, el sol se oscurecerá, la luna no alumbrará, las estrellas caerán del cielo y las columnas del cielo se tambalearán."
,"30":"Entonces aparecerá en el cielo la señal del hijo del hombre; todas las tribus de la tierra se golpearán el pecho y verán venir al hijo del hombre sobre las nubes del cielo con gran poder y majestad."
,"31":"Y mandará a sus ángeles con potentes trompetas, y reunirán de los cuatro vientos a los elegidos desde uno a otro extremo del mundo'."
,"32":"'Aprended del ejemplo de la higuera. Cuando sus ramas se ponen tiernas y echan hojas, conocéis que el verano se acerca."
,"33":"Así también vosotros, cuando veáis todo esto, sabed que él ya está cerca, a las puertas."
,"34":"Os aseguro que no pasará esta generación antes de que suceda todo esto."
,"35":"El cielo y la tierra pasarán, pero mis palabras no pasarán."
,"36":"Pero aquel día y aquella hora nadie los conoce, ni los ángeles del cielo, ni el hijo, sino sólo el Padre'."
,"37":"'Como en los tiempos de Noé, así será la venida del hijo del hombre."
,"38":"Porque como en los días que precedieron al diluvio comían, bebían y se casaban ellos y ellas, hasta el día en que entró Noé en el arca,"
,"39":"y no se dieron cuenta hasta que vino el diluvio y los barrió a todos, así sucederá cuando venga el hijo del hombre."
,"40":"Entonces estarán dos en el campo; a uno se lo llevarán y a otro lo dejarán."
,"41":"Estarán dos mujeres moliendo juntas; a una se la llevarán y a otra la dejarán."
,"42":"Estad en guardia, porque no sabéis en qué día va a venir vuestro Señor."
,"43":"Tened en cuenta que si el amo de casa supiera a qué hora de la noche iba a venir el ladrón, estaría en guardia y no dejaría que le asaltaran la casa."
,"44":"Estad preparados también vosotros, porque a la hora que menos penséis vendrá el hijo del hombre'."
,"45":"'¿Quién es el criado fiel y prudente, puesto por el amo al frente de su servidumbre, para que les dé la comida a su hora?"
,"46":"Dichoso ese criado si, al llegar su amo, lo encuentra cumpliendo con su deber."
,"47":"Os aseguro que lo pondrá al frente de todos sus bienes."
,"48":"Pero si ese criado es de mala condición y, pensando que su amo va a tardar en venir,"
,"49":"se pone a maltratar a sus compañeros, a comer y a beber con los borrachos,"
,"50":"su amo vendrá el día que él menos lo espere,"
,"51":"le castigará severamente y le asignará su suerte con los hipócritas. Allí será el llanto y el crujir de dientes'."
}`)
	CurrentBook.AddChapter(25, `{
"1":"'Entonces el reino de Dios será semejante a diez muchachas, que tomaron sus lámparas y salieron al encuentro del esposo."
,"2":"Cinco de ellas eran necias y cinco sensatas."
,"3":"Las necias llevaron sus lámparas, pero no se proveyeron de aceite,"
,"4":"mientras que las sensatas llevaron las lámparas y aceiteras con aceite."
,"5":"Como tardara el esposo, les entró sueño a todas y se durmieron."
,"6":"A medianoche se oyó un grito: Ya está ahí el esposo, salid a su encuentro."
,"7":"Entonces se despertaron todas las muchachas y se pusieron a aderezar sus lámparas."
,"8":"Las necias dijeron a las sensatas: Dadnos de vuestro aceite, pues nuestras lámparas se apagan."
,"9":"Las sensatas respondieron: No sea que no baste para nosotras y vosotras, mejor es que vayáis a los vendedores y lo compréis."
,"10":"Mientras fueron a comprarlo, vino el esposo, y las que estaban dispuestas entraron con él a las bodas y se cerró la puerta."
,"11":"Más tarde llegaron también las otras muchachas diciendo: ¡Señor, señor, ábrenos!"
,"12":"Y él respondió: Os aseguro que no os conozco."
,"13":"Por tanto, estad en guardia, porque no sabéis el día ni la hora'."
,"14":"'Porque es como un hombre que, al irse de viaje, llamó a sus criados y les confió su hacienda."
,"15":"A uno dio cinco millones, a otro dos y a otro uno, a cada uno según su capacidad; y se fue."
,"16":"El que había recibido cinco se puso en seguida a trabajar con ellos y ganó otros cinco."
,"17":"Asimismo el de los dos ganó otros dos."
,"18":"Pero el que había recibido uno solo fue, cavó en la tierra y enterró allí el dinero de su señor."
,"19":"Después de mucho tiempo, volvió el amo de aquellos criados y les tomó cuenta."
,"20":"Llegó el que había recibido cinco millones y presentó otros cinco, diciendo: Señor, me diste cinco millones; aquí tienes otros cinco que he ganado."
,"21":"El amo le dijo: ¡Bien, criado bueno y fiel!; has sido fiel en lo poco, te confiaré lo mucho. Entra en el gozo de tu señor."
,"22":"Se presentó también el de los dos millones, y dijo: Señor, me diste dos millones; mira, he ganado otros dos."
,"23":"Su amo le dijo: ¡Bien, criado bueno y fiel!; has sido fiel en lo poco, te confiaré lo mucho. Entra en el gozo de tu señor."
,"24":"Se acercó también el que había recibido un solo millón, y dijo: Señor, sé que eres duro, que cosechas donde no has sembrado y recoges donde no has esparcido."
,"25":"Tuve miedo, fui y escondí tu millón en la tierra. Aquí tienes lo tuyo."
,"26":"Su amo le respondió: Siervo malo y holgazán, ¿sabías que quiero cosechar donde no he sembrado y recoger donde no he esparcido?"
,"27":"Debías, por tanto, haber entregado mi dinero a los banqueros para que, al volver yo, retirase lo mío con intereses."
,"28":"Quitadle, pues, el millón y dádselo al que tiene diez."
,"29":"Porque al que tiene se le dará y le sobrará; pero al que no tiene, aun lo que tiene se le quitará."
,"30":"Y a ese criado inútil echadlo a las tinieblas exteriores. Allí será el llanto y el crujir de dientes'."
,"31":"'Cuando venga el hijo del hombre en su gloria con todos sus ángeles se sentará sobre el trono de su gloria."
,"32":"Todos los pueblos serán llevados a su presencia; y él separará a unos de otros, como el pastor separa las ovejas de las cabras."
,"33":"Pondrá las ovejas a su derecha y las cabras a su izquierda."
,"34":"Entonces el rey dirá a los de su derecha: Venid, benditos de mi Padre, tomad posesión del reino preparado para vosotros desde el principio del mundo."
,"35":"Porque tuve hambre y me disteis de comer, tuve sed y me disteis de beber, fui emigrante y me acogisteis,"
,"36":"estuve desnudo y me vestisteis, enfermo y me visitasteis, preso y fuisteis a estar conmigo."
,"37":"Entonces los justos le responderán: Señor, ¿cuándo te vimos hambriento y te alimentamos, sediento y te dimos de beber?"
,"38":"¿Y cuándo te vimos emigrante y te acogimos, o desnudo y te vestimos?"
,"39":"¿Cuándo te vimos enfermo o en la cárcel y fuimos a verte?"
,"40":"Y el rey les dirá: Os aseguro que cuando lo hicisteis con uno de estos mis hermanos más pequeños, conmigo lo hicisteis."
,"41":"Luego dirá a los de la izquierda: Apartaos de mí, malditos, al fuego eterno preparado para el diablo y sus ángeles."
,"42":"Porque tuve hambre y no me disteis de comer, tuve sed y no me disteis de beber,"
,"43":"fui emigrante y no me acogisteis, estuve desnudo y no me vestisteis, enfermo y en la cárcel y no me visitasteis."
,"44":"Entonces responderán también ellos diciendo: Señor, ¿cuándo te vimos hambriento o sediento o emigrante o enfermo o en prisión y no te asistimos?"
,"45":"Y él les contestará: Os aseguro que cuando no lo hicisteis con uno de esos pequeñuelos, tampoco conmigo lo hicisteis."
,"46":"Y éstos irán al castigo eterno, pero los justos a la vida eterna'."
}`)
	CurrentBook.AddChapter(26, `{
"1":"Cuando Jesús terminó todos estos razonamientos, dijo a sus discípulos:"
,"2":"'Sabéis que dentro de dos días es la pascua, y el hijo del hombre será entregado para que lo crucifiquen'."
,"3":"Entonces se reunieron los sumos sacerdotes y los ancianos del pueblo en el palacio del sumo sacerdote, llamado Caifás,"
,"4":"y acordaron prender con engaño a Jesús y quitarle del medio."
,"5":"Pero decían: 'Durante la fiesta no, para que el pueblo no se alborote'."
,"6":"Estando Jesús en Betania, en casa de Simón el leproso,"
,"7":"se acercó a él una mujer con un vaso de alabastro de un perfume muy caro, y lo derramó sobre su cabeza mientras estaba puesto a la mesa."
,"8":"Al ver esto los discípulos, se indignaron y dijeron: '¿A qué viene este derroche?"
,"9":"Se pudo vender a gran precio y dárselo a los pobres'."
,"10":"Jesús se dio cuenta, y les dijo: '¿Por qué molestáis a esa mujer? Ha hecho una buena obra conmigo."
,"11":"Pues siempre tendréis pobres con vosotros, pero a mí no me tendréis siempre."
,"12":"Al derramar este perfume sobre mi cuerpo, lo ha hecho para mi sepultura."
,"13":"Os aseguro que donde se predique este evangelio, en todo el mundo, se hablará también de lo que ésta ha hecho para recuerdo suyo'."
,"14":"Entonces Judas Iscariote, uno de los doce, fue a los sumos sacerdotes"
,"15":"y les dijo: '¿Qué me queréis dar, y yo os lo entrego?'. Ellos le ofrecieron treinta monedas de plata."
,"16":"Desde ese momento buscaba oportunidad para entregarlo."
,"17":"El primer día de la fiesta de los panes sin levadura se acercaron los discípulos a Jesús y le preguntaron: '¿Dónde quieres que te preparemos la cena de la pascua?'."
,"18":"Él dijo: 'Id a la ciudad, a casa de Fulano, y decidle: El maestro dice: Mi hora está cerca; quiero celebrar en tu casa la cena de la pascua con mis discípulos'."
,"19":"Ellos hicieron lo que Jesús les ordenó, y prepararon la cena de la pascua."
,"20":"Al atardecer, se puso a la mesa con los doce."
,"21":"Y, mientras comían, les dijo: 'Os aseguro que uno de vosotros me entregará'."
,"22":"Muy entristecidos, comenzaron a decirle uno por uno: '¿Soy yo, Señor?'."
,"23":"Él respondió: 'El que mete la mano conmigo en el plato, ése me entregará."
,"24":"El hijo del hombre se va, según está escrito de él; pero ¡ay de aquel por quien el hijo del hombre es entregado! ¡Mejor le fuera no haber nacido!'."
,"25":"Entonces preguntó Judas, el que lo iba a entregar: '¿Soy yo acaso, maestro?'. Jesús le respondió: 'Tú lo has dicho'."
,"26":"Durante la cena Jesús tomó pan, lo bendijo, lo partió y lo dio a sus discípulos, diciendo: 'Tomad y comed. Esto es mi cuerpo'."
,"27":"Después tomó un cáliz, dio gracias y se lo dio, diciendo: 'Bebed todos de él,"
,"28":"porque ésta es mi sangre, la sangre de la nueva alianza, que será derramada por todos para remisión de los pecados."
,"29":"Os digo que ya no beberé más de este fruto de la vid hasta el día en que beba con vosotros un vino nuevo en el reino de mi Padre'."
,"30":"Después de haber cantado los himnos, salieron hacia el monte de los Olivos."
,"31":"Jesús les dijo: 'Yo seré para vosotros esta noche ocasión de caída, pues así lo dice la Escritura: Heriré al pastor y se dispersarán las ovejas del rebaño."
,"32":"Pero después resucitaré e iré delante de vosotros a Galilea'."
,"33":"Pedro le dijo: 'Aunque fueras para todos ocasión de caída, para mí no'."
,"34":"Jesús le dijo: 'Te aseguro que esta misma noche, antes que el gallo cante, me negarás tres veces'."
,"35":"Pedro le dijo: 'Aunque tenga que morir contigo, jamás te negaré'. Y lo mismo dijeron todos los demás."
,"36":"Jesús fue con ellos a un huerto llamado Getsemaní, y dijo a los discípulos: 'Quedaos aquí mientras voy más allá a orar'."
,"37":"Se llevó consigo a Pedro y a los dos hijos de Zebedeo; y comenzó a sentir tristeza y angustia."
,"38":"Y les dijo: 'Me muero de tristeza. Quedaos aquí y velad conmigo'."
,"39":"Avanzó unos pasos más, cayó de bruces y se puso a orar así: 'Padre mío, si es posible, que pase de mí este cáliz; pero no sea lo que yo quiero, sino lo que quieres tú'."
,"40":"Volvió a los discípulos, los encontró dormidos y dijo a Pedro: '¿Conque no habéis podido velar una hora conmigo?"
,"41":"Velad y orad para que no caigáis en tentación. El espíritu está dispuesto, pero la carne es débil'."
,"42":"De nuevo, por segunda vez, se fue a orar, diciendo: 'Padre mío, si no es posible que este cáliz pase sin que yo lo beba, hágase tu voluntad'."
,"43":"Volvió y los encontró dormidos, vencidos por el sueño."
,"44":"Los dejó y volvió a orar de nuevo, por tercera vez, repitiendo las mismas palabras."
,"45":"Después fue a los discípulos y les dijo: '¡Dormid ahora y descansad! Ya llega la hora, y el hijo del hombre va a ser entregado en manos de los pecadores."
,"46":"Levantaos, vamos. El que me entrega llega ya'."
,"47":"Aún estaba hablando, cuando llegó Judas, uno de los doce, y con él un gran tropel de gente con espadas y palos, enviados por los sumos sacerdotes y los ancianos del pueblo."
,"48":"El traidor les había dado esta señal: 'Al que yo bese, ése es; prendedle'."
,"49":"Se acercó a Jesús y le saludó: '¡Hola, maestro!', y lo besó."
,"50":"Jesús le dijo: 'Amigo, ¡a lo que vienes!'. Entonces se acercaron a Jesús, le echaron mano y lo prendieron. "
,"51":"Uno de los que estaban con Jesús sacó la espada, dio un golpe al criado del sumo sacerdote y le cortó una oreja."
,"52":"Jesús le dijo: 'Vuelve la espada a su sitio, que todos los que manejan espada a espada morirán."
,"53":"¿O crees que no puedo pedir ayuda a mi Padre, que me mandaría ahora mismo más de doce legiones de ángeles?"
,"54":"Pero ¿cómo se cumplirían entonces las Escrituras, según las cuales tiene que suceder así?'."
,"55":"Jesús dijo a aquel tropel de gente: '¡Habéis venido a prenderme como a un ladrón, con espadas y palos! Todos los días enseñaba sentado en el templo y no me prendisteis."
,"56":"Pero todo esto sucede para que se cumpla lo que escribieron los profetas'. Entonces todos los discípulos lo abandonaron y huyeron."
,"57":"Los que prendieron a Jesús lo llevaron a casa de Caifás, el sumo sacerdote, donde los maestros de la ley y los ancianos estaban reunidos."
,"58":"Pedro lo había seguido de lejos hasta el palacio del sumo sacerdote; entró y se sentó con los criados para ver el fin."
,"59":"Los sumos sacerdotes y el tribunal supremo en pleno buscaban un falso testimonio contra Jesús para condenarle a muerte."
,"60":"Pero no lo encontraron, aunque se presentaron muchos testigos falsos."
,"61":"Al fin llegaron dos que dijeron: 'Éste dijo: Puedo derribar el templo de Dios y en tres días reedificarlo'."
,"62":"El sumo sacerdote se levantó y le dijo: '¿No respondes nada a lo que éstos atestiguan contra ti?'."
,"63":"Pero Jesús permaneció callado. El sumo sacerdote le dijo: '¡Te conjuro por Dios vivo que nos digas si tú eres el mesías, el hijo de Dios!'."
,"64":"Jesús contestó: 'Tú lo has dicho. Y os declaro que desde ahora veréis al hijo del hombre sentado a la diestra del Padre y venir sobre las nubes del cielo'."
,"65":"Entonces el sumo sacerdote se rasgó las vestiduras y dijo: '¡Ha blasfemado! ¿Qué necesidad tenemos ya de testigos? Habéis oído la blasfemia."
,"66":"¿Qué os parece?'. Ellos respondieron: '¡Que es reo de muerte!'."
,"67":"Lo escupieron en la cara y le dieron bofetadas y puñetazos,"
,"68":"mientras le decían: 'Adivina, mesías, quién te dio'."
,"69":"Pedro estaba fuera sentado en el atrio. Se le acercó una criada y le dijo: 'Tú también estabas con Jesús, el galileo'."
,"70":"Pero él lo negó delante de todos, diciendo: 'No sé lo que dices'."
,"71":"Al salir hacia el portal, lo vio otra criada, y dijo a los que estaban allí: 'Éste estaba con Jesús el Nazareno'."
,"72":"Y él de nuevo lo negó con juramento: 'No conozco a ese hombre'."
,"73":"Al poco tiempo se acercaron a Pedro los que estaban allí y le dijeron: 'Seguro que tú también eres de ellos, pues tu misma habla te descubre'."
,"74":"Entonces él comenzó a jurar y perjurar: 'No conozco a ese hombre'. Y en aquel instante cantó el gallo."
,"75":"Entonces Pedro recordó que Jesús le había dicho: 'Antes de que cante el gallo me negarás tres veces'. Y saliendo fuera, se echó a llorar amargamente."
}`)
	CurrentBook.AddChapter(27, `{
"1":"Al amanecer, los sumos sacerdotes y los ancianos del pueblo decidieron condenar a muerte a Jesús."
,"2":"Lo ataron y lo llevaron al gobernador Pilato."
,"3":"Judas, el traidor, al ver que Jesús había sido condenado, se arrepintió y devolvió las treinta monedas de plata a los sumos sacerdotes y a los ancianos, diciendo:"
,"4":"'He pecado entregando sangre inocente'. Ellos dijeron: '¿A nosotros qué? ¡Tú verás!'."
,"5":"Tiró en el templo las monedas, fue y se ahorcó."
,"6":"Los sumos sacerdotes recogieron las monedas de plata y dijeron: 'No es lícito echarlas en el tesoro del templo, porque son precio de sangre'."
,"7":"Decidieron comprar con ellas el 'campo del Alfarero' para sepultura de los extranjeros."
,"8":"Por eso aquel campo se llamó 'campo de sangre' hasta el día de hoy."
,"9":"Así se cumplió lo que dijo el profeta Jeremías: Tomaron las treinta monedas de plata en que fue tasado aquel a quien pusieron precio los israelitas,"
,"10":"y las dieron por el campo del Alfarero, según lo que me ordenó el Señor."
,"11":"Jesús compareció ante el gobernador, quien le preguntó: '¿Eres tú el rey de los judíos?'. Jesús respondió: 'Tú lo dices'."
,"12":"Pero nada respondió a las acusaciones que le hacían los sumos sacerdotes y los ancianos."
,"13":"Pilato le dijo: '¿No oyes todo lo que dicen contra ti?'."
,"14":"Pero él no le respondió nada, hasta el punto de que el gobernador se quedó muy extrañado."
,"15":"Por la fiesta el gobernador solía conceder al pueblo la libertad de un preso, el que ellos quisieran."
,"16":"Había entonces un preso famoso, llamado Barrabás."
,"17":"Pilato preguntó a todos los que estaban allí: '¿A quién queréis que os deje en libertad? ¿A Barrabás o a Jesús, a quien llaman el mesías?'."
,"18":"Pues sabía que lo habían entregado por envidia."
,"19":"Estando en el tribunal, su mujer mandó a decirle: 'No resuelvas nada contra ese justo, porque he sufrido mucho hoy en sueños por causa de él'."
,"20":"Pero los sumos sacerdotes y los ancianos convencieron a la gente de que pidieran la libertad de Barrabás y la muerte de Jesús."
,"21":"Y al decirles el gobernador: '¿A quién de los dos queréis que os suelte?', ellos respondieron: 'A Barrabás'."
,"22":"Pilato les dijo: '¿Qué haré entonces con Jesús, a quien llaman el mesías?'. Todos dijeron: '¡Que lo crucifiquen!'."
,"23":"Él replicó: 'Pues, ¿qué mal ha hecho?'. Ellos gritaron más fuerte: '¡Que lo crucifiquen!'."
,"24":"Viendo Pilato que nada conseguía, sino que aumentaba el alboroto, mandó que le trajeran agua y se lavó las manos ante el pueblo, diciendo: 'Soy inocente de esta sangre. ¡Vosotros veréis!'."
,"25":"Y todo el pueblo respondió: 'Que su sangre caiga sobre nosotros y sobre nuestros hijos'."
,"26":"Entonces puso en libertad a Barrabás y les entregó a Jesús, después de azotarlo, para que fuera crucificado."
,"27":"Luego los soldados del gobernador llevaron a Jesús al pretorio y reunieron en torno de él a toda la tropa."
,"28":"Lo desnudaron, le vistieron una túnica de púrpura,"
,"29":"trenzaron una corona de espinas y se la pusieron en la cabeza, y una caña en su mano derecha; y, arrodillándose delante, se burlaban de él, diciendo: '¡Viva el rey de los judíos!'."
,"30":"Le escupían y le pegaban con la caña en la cabeza."
,"31":"Después de haberse burlado de él, le quitaron la túnica, le pusieron sus ropas y lo llevaron a crucificar."
,"32":"Cuando salían, encontraron a un hombre de Cirene, llamado Simón, y le obligaron a llevar la cruz."
,"33":"Al llegar a un lugar llamado Gólgota (que significa la Calavera)"
,"34":"dieron de beber a Jesús vino mezclado con hiel; pero él lo probó y no lo quiso beber."
,"35":"Los que lo crucificaron se repartieron sus vestidos a suertes."
,"36":"Y se sentaron allí para custodiarlo."
,"37":"Sobre su cabeza pusieron la causa de su condena: 'Éste es Jesús, el rey de los judíos'."
,"38":"Con él crucificaron a dos ladrones, uno a la derecha y otro a la izquierda."
,"39":"Los que pasaban por allí le insultaban moviendo la cabeza"
,"40":"y diciendo: '¡Tú que destruías el templo y lo reedificabas en tres días, sálvate a ti mismo si eres hijo de Dios, y baja de la cruz!'."
,"41":"Del mismo modo los sumos sacerdotes, los maestros de la ley y los ancianos se burlaban de él y decían:"
,"42":"'Ha salvado a otros y no puede salvarse a sí mismo. ¡Es rey de Israel! ¡Que baje de la cruz y creeremos en él!"
,"43":"Confiaba en Dios. Que lo libre ahora, si es que lo ama, puesto que ha dicho: Soy hijo de Dios'."
,"44":"Los ladrones crucificados con él también lo insultaban."
,"45":"Desde el mediodía se oscureció toda la tierra hasta las tres de la tarde."
,"46":"Hacia las tres de la tarde Jesús gritó con fuerte voz: 'Elí, Elí, lemá sabactani?' (que quiere decir: Dios mío, Dios mío, ¿por qué me has abandonado?)."
,"47":"Algunos de los presentes, al oírlo, decían: '¡Éste llama a Elías!'."
,"48":"En aquel momento uno de ellos fue corriendo a buscar una esponja, la empapó en vinagre, la puso en una caña y le dio de beber."
,"49":"Los otros decían: '¡Deja! A ver si viene Elías a salvarlo'."
,"50":"Y Jesús, dando de nuevo un fuerte grito, expiró."
,"51":"Entonces el velo del templo se rasgó en dos de arriba abajo; la tierra tembló y las piedras se resquebrajaron;"
,"52":"se abrieron los sepulcros y muchos cuerpos de santos que estaban muertos resucitaron"
,"53":"y, saliendo de los sepulcros, después de la resurrección de Jesús, entraron en la ciudad santa y se aparecieron a muchos."
,"54":"El centurión, por su parte, y los que con él estaban custodiando a Jesús, al ver el terremoto y las cosas que ocurrían, tuvieron mucho miedo y decían: 'Verdaderamente éste era hijo de Dios'."
,"55":"Había también allí, mirando desde lejos, muchas mujeres que habían seguido a Jesús desde Galilea para atenderle."
,"56":"Entre ellas estaba María Magdalena, María la madre de Santiago y José, y la madre de los hijos de Zebedeo."
,"57":"Al caer la tarde, vino un hombre rico de Arimatea, llamado José, que era también discípulo de Jesús."
,"58":"Se presentó a Pilato, le pidió el cuerpo de Jesús, y Pilato mandó que se lo dieran."
,"59":"José tomó el cuerpo, lo envolvió en una sábana limpia"
,"60":"y lo depositó en su propio sepulcro nuevo, que había hecho excavar en la roca. Hizo rodar una losa grande para cerrar la puerta del sepulcro y se fue."
,"61":"Estaban allí María Magdalena y la otra María, sentadas frente al sepulcro."
,"62":"Al otro día, el siguiente a la preparación de la pascua, los sumos sacerdotes y los fariseos fueron juntos a Pilato y le dijeron:"
,"63":"'Señor, nos hemos acordado de que ese seductor dijo cuando aún vivía: A los tres días resucitaré."
,"64":"Manda asegurar el sepulcro hasta el día tercero, no sea que vengan sus discípulos, lo roben y digan al pueblo: Ha resucitado de entre los muertos, y el último engaño sea peor que el primero'."
,"65":"Pilato les dijo: 'Tenéis guardias, id y aseguradlo como creáis'."
,"66":"Ellos fueron y aseguraron el sepulcro, sellando la piedra y montando la guardia."
}`)
	CurrentBook.AddChapter(28, `{
"1":"Pasado el sábado, al rayar el alba, el primer día de la semana, fueron María Magdalena y la otra María a ver el sepulcro."
,"2":"De pronto hubo un gran terremoto, pues un ángel del Señor bajó del cielo, se acercó, hizo rodar la losa del sepulcro y se sentó en ella."
,"3":"Su aspecto era como un rayo, y su vestido blanco como la nieve."
,"4":"Los guardias temblaron de miedo y se quedaron como muertos."
,"5":"Pero el ángel, dirigiéndose a las mujeres, les dijo: 'No temáis; sé que buscáis a Jesús, el crucificado."
,"6":"No está aquí. Ha resucitado, como dijo. Venid, ved el sitio donde estaba."
,"7":"Id en seguida a decir a sus discípulos: Ha resucitado de entre los muertos y va delante de vosotros a Galilea. Allí le veréis. Ya os lo he dicho'."
,"8":"Ellas se alejaron a toda prisa del sepulcro, y con miedo y gran alegría corrieron a llevar la noticia a los discípulos."
,"9":"De pronto Jesús salió a su encuentro y les dijo: 'Dios os guarde'. Ellas se acercaron, se agarraron a sus pies y lo adoraron."
,"10":"Jesús les dijo: 'No tengáis miedo; id y decid a mis hermanos que vayan a Galilea, que allí me verán'."
,"11":"Mientras ellas se iban, algunos de los guardias fueron a la ciudad y contaron a los sumos sacerdotes todo lo que había ocurrido."
,"12":"Éstos se reunieron con los ancianos y acordaron en consejo dar bastante dinero a los soldados,"
,"13":"advirtiéndoles: 'Decid que sus discípulos fueron de noche y lo robaron mientras dormíais."
,"14":"Y si eso llega por casualidad a oídos del gobernador, nosotros le convenceremos y conseguiremos que no os castigue'."
,"15":"Ellos tomaron el dinero e hicieron como les habían dicho. Y este rumor se divulgó entre los judíos hasta el día de hoy."
,"16":"Los once discípulos fueron a Galilea, al monte que Jesús había señalado,"
,"17":"y, al verlo, lo adoraron. Algunos habían dudado hasta entonces."
,"18":"Jesús se acercó y les dijo: 'Se me ha dado todo poder en el cielo y en la tierra."
,"19":"Id, pues, y haced discípulos míos en todos los pueblos, bautizándolos en el nombre del Padre y del Hijo y del Espíritu Santo,"
,"20":"y enseñándoles a guardar todo lo que yo os he mandado. Y sabed que yo estoy con vosotros todos los días hasta el fin del mundo'."
}`)

}
func ES_LSB_LoadNP1CChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Pablo, apóstol de Cristo Jesús por designio y llamada de Dios, y el hermano Sóstenes,"
,"2":"a la Iglesia de Dios que está en Corinto, a los consagrados por Cristo Jesús, llamados y consagrados, con todos los que invocan en cualquier lugar el nombre de nuestro Señor Jesucristo, Señor de ellos y nuestro;"
,"3":"os deseo la gracia y la paz de Dios, nuestro Padre, y de Jesucristo, el Señor."
,"4":"No ceso de dar gracias a Dios por la generosidad que ha tenido con vosotros."
,"5":"Por medio de Cristo Jesús os ha enriquecido en todo, en el saber y en el hablar."
,"6":"De tal manera que el testimonio de Cristo se ha consolidado en vosotros."
,"7":"De este modo no carecéis de ningún carisma, mientras esperáis la manifestación de nuestro Señor Jesucristo."
,"8":"Él os mantendrá firmes hasta el fin, para que nadie os pueda reprochar nada el día de la venida de nuestro Señor Jesucristo."
,"9":"Dios es fiel y él os ha llamado a vivir en unión con su Hijo, Jesucristo, nuestro Señor."
,"10":"Hermanos, por el nombre de nuestro Señor Jesucristo, os ruego que os pongáis de acuerdo y que no haya divisiones entre vosotros, sino que conservéis la armonía en el pensar y en el sentir."
,"11":"Os digo esto, hermanos míos, porque los de Cloe me han informado de que hay discordias entre vosotros."
,"12":"Me refiero a lo que cada uno de vosotros dice: 'Yo soy de Pablo, yo de Apolo, yo de Cefas, yo de Cristo'."
,"13":"¿Está dividido Cristo? ¿Acaso Pablo fue crucificado por vosotros o habéis sido bautizados en su nombre?"
,"14":"Doy gracias a Dios de no haber bautizado a ninguno de vosotros, excepto a Crispo y Gayo."
,"15":"Así nadie puede decir que fuisteis bautizados en mi nombre."
,"16":"También bauticé a la familia de Esteban; no recuerdo haber bautizado a nadie más."
,"17":"Pues Cristo no me mandó a bautizar, sino a evangelizar; y esto sin alardes literarios, para que no se desvirtúe la cruz de Cristo."
,"18":"Porque el lenguaje de la cruz es una locura para los que se pierden; pero para nosotros, que nos salvamos, es poder de Dios."
,"19":"Pues dice la Escritura: Inutilizaré la sabiduría de los sabios y anularé la inteligencia de los inteligentes."
,"20":"¿Dónde está el sabio? ¿Dónde el maestro? ¿Dónde el estudioso de este mundo? ¡Dios ha convertido en tontería la sabiduría del mundo!"
,"21":"El mundo con su propia sabiduría no reconoció a Dios en la sabiduría manifestada por Dios en sus obras. Por eso Dios ha preferido salvar a los creyentes por medio de una doctrina que parece una locura."
,"22":"Porque los judíos piden milagros, y los griegos buscan la sabiduría;"
,"23":"pero nosotros anunciamos a Cristo crucificado, escándalo para los judíos y locura para los paganos,"
,"24":"pero poder y sabiduría de Dios para los llamados, judíos o griegos."
,"25":"Pues la locura de Dios es más sabia que los hombres; y la debilidad de Dios, más fuerte que los hombres."
,"26":"Considerad si no, hermanos, vuestro grupo de llamados: no hay muchos sabios, ni muchos poderosos, ni muchos nobles;"
,"27":"Dios eligió lo que el mundo tiene por necio para humillar a los sabios; lo débil, para humillar a los fuertes;"
,"28":"lo vil, lo despreciable, lo que es nada, para anular a los que son algo;"
,"29":"para que nadie presuma delante de Dios."
,"30":"Por él vosotros estáis en Cristo Jesús, el cual de parte de Dios se ha hecho para nosotros sabiduría, justicia, santificación y redención,"
,"31":"para que, como dice la Escritura, el que quiera presumir de algo, que presuma de lo que ha hecho el Señor."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Hermanos, cuando llegué a vuestra ciudad, llegué anunciándoos el misterio de Dios no con alardes de elocuencia o de sabiduría;"
,"2":"pues nunca entre vosotros me precié de saber otra cosa que a Jesucristo, y a Jesucristo crucificado."
,"3":"Me presenté entre vosotros débil y temblando de miedo."
,"4":"Y mi palabra y mi predicación no se basaban en la elocuencia persuasiva de la sabiduría, sino en la demostración del poder del Espíritu,"
,"5":"para que vuestra fe no se fundase en la sabiduría humana, sino en el poder de Dios."
,"6":"Entre los formados usamos la sabiduría, pero no la de este mundo, ni la de los gobernantes pasajeros de este mundo;"
,"7":"una sabiduría divina, misteriosa, oculta, que Dios destinó para nuestra gloria antes de crear el mundo."
,"8":"Esto no lo entendieron los gobernantes de este mundo, pues si lo hubieran entendido no habrían crucificado al Señor de la gloria."
,"9":"Pero como dice la Escritura: Lo que el ojo no vio, lo que el oído no oyó, lo que ningún hombre imaginó, eso preparó Dios para los que le aman."
,"10":"Y a nosotros nos lo manifestó Dios por medio de su Espíritu, pues el Espíritu lo penetra todo, hasta las cosas más profundas de Dios."
,"11":"¿Qué hombre, en efecto, conoce lo íntimo del hombre, sino el espíritu del hombre que está en él? De la misma manera, nadie conoce las cosas de Dios, sino el Espíritu de Dios."
,"12":"Y nosotros no hemos recibido el espíritu del mundo, sino el Espíritu que viene de Dios, para que conozcamos lo que Dios generosamente nos ha dado."
,"13":"Hablamos de esto con un lenguaje que no nos ha enseñado la sabiduría humana, sino el Espíritu, que expresa las cosas espirituales en términos espirituales."
,"14":"El hombre mundano no acepta las cosas del Espíritu de Dios; son locura para él, y no puede entenderlas, ya que hay que juzgarlas espiritualmente."
,"15":"El espiritual, por el contrario, lo juzga todo, y a él nadie le juzga."
,"16":"Porque, ¿quién conoció el pensamiento del Señor para poder enseñarlo? Pero nosotros poseemos el pensamiento de Cristo."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Hermanos, yo no pude hablaros como a espirituales, sino como a carnales, como a niños en Cristo."
,"2":"Os di a beber leche, no alimento sólido, porque no lo podíais soportar; ni podéis todavía,"
,"3":"pues aún sois carnales. Desde el momento que hay envidias y discordias entre vosotros, ¿no es porque aún sois carnales y vivís a lo humano?"
,"4":"Porque cuando uno dice: 'Yo soy de Pablo', y otro: 'Yo de Apolo', ¿no procedéis de una manera puramente humana?"
,"5":"Pues ¿qué es Apolo y qué es Pablo? Simples servidores, por medio de los cuales habéis abrazado la fe, según la medida que Dios ha repartido a cada uno."
,"6":"Yo planté y Apolo regó, pero quien hizo crecer fue Dios."
,"7":"Nada son ni el que planta ni el que riega, sino Dios, que hace crecer."
,"8":"El que planta y el que riega son lo mismo, y cada uno recibirá la recompensa según su trabajo."
,"9":"Nosotros somos colaboradores de Dios; vosotros, labrantío de Dios, edificio de Dios."
,"10":"Según el don que Dios me ha concedido, yo puse los cimientos como buen arquitecto, y otro construye el edificio. Que cada uno mire cómo construye."
,"11":"Porque nadie puede poner otro fundamento que el que está ya puesto, que es Jesucristo."
,"12":"Sobre este fundamento uno puede construir con oro, plata, piedras preciosas, maderas, caña y paja."
,"13":"El trabajo de cada uno aparecerá claro el día del juicio, porque ese día se manifestará con fuego, y el fuego probará la obra de cada uno."
,"14":"Si la obra resiste la prueba del fuego, recibirá el premio;"
,"15":"si se consume, lo perderá todo, aunque él se salvará, pero como el que escapa del fuego."
,"16":"¿No sabéis que sois templos de Dios, y que el Espíritu de Dios habita en vosotros? Si alguno destruye el templo de Dios, Dios lo destruirá a él;"
,"17":"porque el templo de Dios, que sois vosotros, es santo."
,"18":"Nadie se engañe a sí mismo. Si alguno entre vosotros piensa que es sabio según la sabiduría de este mundo, que se haga necio para llegar a ser sabio."
,"19":"Porque la sabiduría de este mundo es necedad ante Dios, como dice la Escritura: Atrapa a los sabios en su astucia."
,"20":"Y además: El Señor conoce cuán vanos son los pensamientos de los sabios."
,"21":"Por tanto, que nadie presuma de los que son sólo hombres, pues todo es para vosotros:"
,"22":"Pablo, Apolo, Cefas, el mundo, la vida, la muerte, el presente y el futuro, todo es vuestro;"
,"23":"vosotros, de Cristo, y Cristo, de Dios."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Que la gente nos tenga como servidores de Cristo y administradores de los misterios de Dios."
,"2":"Ahora bien, lo que se pide a los administradores es que sean fieles."
,"3":"A mí poco me importa ser juzgado por vosotros o por un tribunal humano. Ni yo mismo me juzgo."
,"4":"No me siento culpable de nada; pero no por esto quedo justificado, porque quien me juzga es el Señor."
,"5":"Así pues, nada juzguéis antes de tiempo, hasta que venga el Señor, que iluminará los escondrijos de las tinieblas y pondrá de manifiesto las intenciones del corazón, y entonces cada uno recibirá de Dios la alabanza que merezca."
,"6":"Hermanos, me he aplicado esto a mí y a Apolo para que aprendáis a no ir más allá de lo que está escrito, a fin de que nadie se apasione por uno con detrimento para el otro."
,"7":"Pues ¿quién te hace a ti superior? Y ¿qué tienes que no hayas recibido? Y si lo has recibido, ¿por qué presumes como si no lo hubieras recibido?"
,"8":"¡Ya estáis satisfechos! ¡Ya sois ricos! ¡Habéis llegado a reinar sin nosotros! ¡Ojalá reinaseis de verdad, para que reinásemos con vosotros!"
,"9":"Pues creo que Dios nos ha presentado a nosotros, los apóstoles, como lo último, como condenados a muerte, porque hemos llegado a ser el espectáculo del mundo, de los ángeles y de los hombres."
,"10":"Nosotros tontos por Cristo, vosotros sabios en Cristo; nosotros débiles, vosotros fuertes; vosotros honrados, nosotros despreciados."
,"11":"Hasta ahora padecemos hambre, sed y falta de ropa. Somos abofeteados, andamos errantes"
,"12":"y nos fatigamos trabajando con nuestras propias manos. Nos insultan, y bendecimos; nos persiguen, y aguantamos;"
,"13":"nos calumnian, y respondemos con bondad. Hemos sido hasta ahora como basura del mundo, como desecho de todos."
,"14":"No os escribo esto para avergonzaros, sino para amonestaros como a hijos míos muy queridos."
,"15":"Porque aunque tuvierais diez mil pedagogos que os hablen de Cristo, no tendríais muchos padres, pues por medio del evangelio yo os he engendrado en Cristo Jesús."
,"16":"Os suplico, por tanto, que sigáis mi ejemplo."
,"17":"Por esto os he enviado a Timoteo, hijo mío muy querido y fiel en el Señor, quien os recordará mis normas de conducta en Cristo Jesús y lo que enseño por doquier en todas las iglesias."
,"18":"Algunos se han llenado de orgullo pensando que no volveré a veros."
,"19":"Pero iré a veros y pronto, si el Señor quiere; entonces me enteraré no de la palabrería de estos engreídos, sino de su valor."
,"20":"Porque el reino de Dios no consiste en la palabrería, sino en la virtud."
,"21":"¿Qué queréis? ¿Que vaya con la vara o con amor y con ternura?"
}`)
	CurrentBook.AddChapter(5, `{
"1":"Es cosa pública entre vosotros la deshonestidad, y tal deshonestidad que no se encuentra ni entre los paganos, hasta el punto de convivir uno con la mujer de su padre."
,"2":"Y vosotros estáis orgullosos, en vez de manifestar intenso dolor, para que desaparezca de entre vosotros el que tal acto ha cometido."
,"3":"Pues yo, por mi parte, corporalmente ausente, pero espiritualmente presente, he dictado ya mi sentencia sobre el que está actuando así:"
,"4":"que congregados en nombre de nuestro Señor Jesucristo, vosotros y mi espíritu, y con el poder de Jesús, Señor nuestro, este tal"
,"5":"sea entregado a Satanás, con el fin de que, aunque quede corporalmente destrozado, pueda salvarse el día del Señor."
,"6":"La cosa no es para que os sintáis orgullosos. ¿No sabéis que un poco de levadura hace fermentar toda la masa?"
,"7":"Echad fuera la vieja levadura para ser una masa nueva, puesto que sois panes sin levadura; porque Cristo, nuestro cordero pascual, ya ha sido inmolado."
,"8":"Así que celebremos la fiesta, no con levadura vieja, con levadura de malicia y de maldad, sino con panes sin levadura, panes de sinceridad y de verdad."
,"9":"Os dije en mi carta que no tratéis con los lujuriosos;"
,"10":"pero no me refería, de un modo absoluto, a todos los lujuriosos de este mundo, a todos los avaros, ladrones o idólatras, pues en tal caso tendríais que salir de este mundo."
,"11":"Lo que os decía es que no trataseis con el que presume de cristiano y es lujurioso, avaro, idólatra, calumniador, borracho o ladrón; con éstos, ni comer."
,"12":"A mí no me corresponde juzgar a los de fuera. Pero a vosotros sí os corresponde juzgar a los de dentro."
,"13":"A los de fuera, Dios los juzgará. Echad de entre vosotros al malvado."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Cuando tenéis un pleito con otro, ¿por qué lleváis el asunto a un tribunal pagano, y no lo resolvéis entre los creyentes?"
,"2":"¿No sabéis que los creyentes juzgarán al mundo? Pues si vais a juzgar al mundo, ¿seréis incapaces de juzgar causas más pequeñas?"
,"3":"¿No sabéis que hasta juzgaremos a los ángeles? Con mucha más razón las cosas de esta vida."
,"4":"Para los asuntos de esta vida elegís como jueces a los que no tienen que ver nada con la Iglesia."
,"5":"¿No os da vergüenza? ¿No hay entre vosotros algún hombre prudente, capaz de hacer justicia entre sus hermanos?"
,"6":"En cambio, el hermano pleitea con el hermano, ¡y encima ante jueces paganos!"
,"7":"¡Ya es una desgracia para vosotros andar pleiteando unos con otros! ¿Por qué no preferís dejaros robar?"
,"8":"Pero sois vosotros los injustos y los ladrones, y esto con vuestros hermanos."
,"9":"¿Es que no sabéis que los injustos no heredarán el reino de Dios? No os engañéis; ni los lujuriosos, ni los idólatras, ni los adúlteros, ni los afeminados, ni los invertidos,"
,"10":"ni los ladrones, ni los avaros, ni los borrachos, ni los difamadores, ni los salteadores heredarán el reino de Dios."
,"11":"Eso erais antes algunos; pero habéis sido lavados, consagrados y justificados en el nombre de nuestro Señor Jesucristo y en el Espíritu de nuestro Dios."
,"12":"Dicen por ahí: 'Todo me está permitido'. Pero no todo es conveniente. 'Todo me está permitido'. Pero no me haré esclavo de nada."
,"13":"'Los manjares para el estómago y el estómago para los manjares'. Pero Dios exterminará ambas cosas. El cuerpo no es para la lujuria, sino para el Señor, y el Señor, para el cuerpo."
,"14":"Dios resucitó al Señor, y nos resucitará también a nosotros con su poder."
,"15":"¿No sabéis que vuestros cuerpos son miembros de Cristo? ¿Y voy yo a usar los miembros de Cristo para hacerlos miembros de una prostituta? ¡Jamás!"
,"16":"¿No sabéis que quien se une a una prostituta se hace un solo cuerpo con ella? Pues, como dice la Escritura, los dos serán una sola carne."
,"17":"Pero el que se une al Señor es un solo espíritu con él."
,"18":"Huid de la lujuria. Cualquier otro pecado cometido por el hombre queda fuera del cuerpo, pero el pecado de lujuria daña al propio cuerpo."
,"19":"¿No sabéis que vuestro cuerpo es templo del Espíritu Santo, que habita en vosotros, y que habéis recibido de Dios? Ya no os pertenecéis a vosotros mismos."
,"20":"Habéis sido comprados a gran precio; glorificad, pues, a Dios en vuestro cuerpo."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Sobre lo que me habéis escrito, os digo lo siguiente. Está bien renunciar al matrimonio;"
,"2":"pero para evitar la lujuria, que cada uno tenga su mujer, y cada mujer su marido."
,"3":"Tanto el marido como la mujer deben cumplir la obligación conyugal."
,"4":"La mujer no es dueña de su cuerpo, sino el marido; igualmente el marido no es dueño de su cuerpo, sino la mujer."
,"5":"No os neguéis el uno al otro esa obligación, a no ser de común acuerdo y por cierto tiempo, para dedicaros a la oración; después volved de nuevo a juntaros, para que no os tiente Satanás si no podéis guardar continencia."
,"6":"Esto os lo digo como concesión, no como mandato."
,"7":"Pues yo quisiera que todos los hombres fuesen como yo; pero cada uno tiene de Dios su propio don: unos de una manera, otros de otra."
,"8":"A los solteros y a las viudas, que se queden como yo;"
,"9":"pero si no pueden guardar continencia, que se casen. Es mejor casarse que consumirse de pasión."
,"10":"A los casados les mando (es decir, no yo, sino el Señor) que la mujer no se separe del marido;"
,"11":"y si se separa, que no se case o que se reconcilie con su marido; y que el marido no se divorcie de la mujer."
,"12":"A los demás les digo yo, no el Señor: Si un cristiano está casado con una mujer pagana, pero acepta vivir con él, que no se divorcie de ella."
,"13":"Y si una mujer cristiana está casada con un hombre no creyente, pero acepta vivir con ella, que no se divorcie de él."
,"14":"Pues el marido no creyente queda consagrado a Dios por la mujer cristiana, y la mujer no creyente queda consagrada a Dios por el marido cristiano; de lo contrario, vuestros hijos serían impuros, mientras que ahora pertenecen al pueblo de Dios."
,"15":"Pero si el cónyuge no creyente se separa, que se separe; en ese caso el otro cónyuge creyente queda en plena libertad, porque el Señor nos ha llamado a vivir en paz."
,"16":"En realidad, ¿cómo vas a saber tú, mujer, si conseguirás salvar a tu marido? ¿Y tú, marido, si conseguirás salvar a tu mujer?"
,"17":"Que cada uno permanezca en la condición que Dios le ha asignado, la que tenía cuando fue llamado. Así lo dispongo en todas las Iglesias."
,"18":"Si uno fue llamado estando circuncidado, que no intente aparecer como no circuncidado. Si uno fue llamado sin estar circuncidado, que no se circuncide."
,"19":"Da igual estar o no estar circuncidado: lo que importa es guardar los mandamientos de Dios."
,"20":"Que cada uno permanezca en el estado en que estaba cuando Dios le llamó."
,"21":"¿Fuiste llamado siendo esclavo? No te preocupes. Aunque si tienes ocasión de conseguir la libertad, debes aprovecharla;"
,"22":"porque la llamada del Señor hace libre al esclavo y esclavo de Cristo al libre."
,"23":"A gran precio fuisteis comprados; no os hagáis esclavos de los hombres."
,"24":"Hermanos, que cada cual permanezca ante Dios en el estado que tenía cuando fue llamado."
,"25":"Acerca de los solteros, no tengo ningún precepto del Señor; pero doy mi opinión particular como quien es digno de crédito por la misericordia del Señor."
,"26":"Yo creo que en estos tiempos difíciles en que vivimos es mejor quedarse como se está."
,"27":"¿Estás unido a mujer? No busques la separación. ¿Estás soltero? No te cases."
,"28":"Pero si te casas, no pecas. Y si una mujer soltera se casa, tampoco peca. Lo que pasa es que yo quisiera evitaros los problemas que vais a tener en el matrimonio."
,"29":"Por tanto, los que tienen mujer vivan como si no la tuvieran;"
,"30":"los que lloran, como si no llorasen; los que se alegran, como si no se alegrasen; los que compran, como si no poseyesen;"
,"31":"los que gozan del mundo, como si no disfrutasen; porque este mundo que contemplamos está para acabar."
,"32":"Os quiero libres de preocupaciones. El soltero se preocupa de las cosas del Señor y de cómo agradarle."
,"33":"El casado se preocupa de las cosas del mundo y de cómo agradar a la mujer; está, pues, dividido."
,"34":"La mujer no casada y la joven soltera se preocupan de las cosas del Señor, y se consagran a él en cuerpo y alma. Pero la que está casada se preocupa de las cosas del mundo y de cómo agradar a su marido."
,"35":"Os digo esto para vuestro bien, no para tenderos un lazo, sino mirando a lo más perfecto y a lo que os unirá enteramente con el Señor."
,"36":"Si alguno cree que, dada la edad de su novia, debe casarse, y que eso es lo más indicado, que haga lo que quiera; que se case, pues eso no es pecado."
,"37":"Y si alguno, con entera libertad, sin que nadie lo fuerce, tiene en su interior el firme propósito de no casarse con su novia y así lo decide, hace bien."
,"38":"En conclusión, el que se casa con su novia hace bien, y el que no se casa hace mejor."
,"39":"La mujer está ligada todo el tiempo que vive su marido; pero si el marido se muere, queda libre para casarse con quien quiera, con tal que sea cristiano."
,"40":"Pero, a mi parecer, será más feliz si continúa como está; ésta es mi opinión; y creo que yo también tengo el Espíritu de Dios."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Sobre la carne ofrecida en sacrificio a los ídolos, está claro que todos tenemos la ciencia suficiente. Pero la ciencia envanece; lo único verdaderamente provechoso es el amor."
,"2":"Si alguno cree que sabe algo, no lo sabe como lo debía saber."
,"3":"Pero el que ama a Dios, ése es conocido por él."
,"4":"Viniendo, pues, a lo de la comida de las carnes ofrecidas en sacrificio a los ídolos, sabemos que los ídolos no son nada en el mundo y que no hay más Dios que uno solo."
,"5":"Pues aunque hay esos llamados dioses, tanto en el cielo como en la tierra, y en ese sentido hay muchas divinidades y muchos señores,"
,"6":"para nosotros hay un solo Dios, el Padre, del que proceden todas las cosas y por el que hemos sido creados; y un solo Señor, Jesucristo, por quien existen todas las cosas, y por el que también nosotros existimos."
,"7":"Pero no todos saben esto; pues algunos, acostumbrados hasta ahora a adorar a los ídolos, comen las carnes pensando que están consagradas a los ídolos, y su conciencia, que no está bien formada, les hace sentirse culpables."
,"8":"No es la comida la que nos acerca a Dios. Por comer o por no comer, no somos ni menos ni más."
,"9":"Pero procurad que vuestra libertad no sirva de escándalo a los débiles en la fe."
,"10":"Si tú, que tienes conocimiento claro de todo esto, te sientas a comer carne ofrecida en sacrificio a los ídolos, ¿no podrás inducir a que otro, con la conciencia insegura, se decida también a comer esa carne?"
,"11":"Así tú, con tu conocimiento claro, has echado a perder a ese hermano poco formado todavía, por el que Cristo murió."
,"12":"De este modo pecáis contra los hermanos, al hacer daño a su conciencia aún no formada, y contra el mismo Cristo."
,"13":"Por tanto, si una comida escandaliza a mi hermano, jamás comeré carne para no escandalizarle."
}`)
	CurrentBook.AddChapter(9, `{
"1":"¿No soy libre? ¿No soy apóstol? ¿Es que no he visto a Jesús, Señor nuestro? ¿No sois vosotros mi obra en el Señor?"
,"2":"Si para otros no soy apóstol, para vosotros ciertamente lo soy; pues vosotros sois, en el Señor, el sello de mi apostolado."
,"3":"Ésta es mi respuesta a los que me critican."
,"4":"¿Es que no tenemos derecho a comer y a beber?"
,"5":"¿No tengo derecho a llevar conmigo una mujer cristiana, como los demás apóstoles, los hermanos del Señor, y hasta el mismo Pedro?"
,"6":"¿O es que sólo Bernabé y yo tenemos obligación de trabajar?"
,"7":"¿Cuándo se ha visto que un militar haga la guerra a sus expensas? ¿Quién planta una viña y no come de su fruto? ¿Quién apacienta un rebaño y no toma leche del rebaño?"
,"8":"¿Hablo sólo con criterio humano o lo dice también la ley?"
,"9":"Porque en la ley de Moisés está escrito: No pondrás bozal al buey que trilla. ¿Es que Dios se preocupa de los bueyes?"
,"10":"¿O lo dice, evidentemente, por nosotros? Sí, se dice por nosotros. Porque tanto el que labra la tierra como el que trilla el grano lo hacen con la esperanza de recibir parte de la cosecha."
,"11":"Si sembramos en vosotros bienes espirituales, ¿es mucho que recojamos bienes materiales?"
,"12":"Si otros usan este derecho con vosotros, ¿por qué, y con más razón, no podemos usarlo nosotros? Pero no hemos usado este derecho, y lo hemos soportado todo para no poner obstáculo alguno al evangelio de Cristo."
,"13":"¿No sabéis que los que ejercen funciones sagradas viven del templo, y los que sirven al altar del altar participan?"
,"14":"Así también el Señor ordenó a los que anuncian el evangelio que vivan del evangelio."
,"15":"Pero yo no he hecho uso de ninguno de estos derechos. Y no escribo esto para reivindicar estos derechos. Prefiero morir antes que verme privado de este glorioso título."
,"16":"Porque si predico el evangelio, no tengo de qué sentir orgullo; es mi obligación hacerlo. Pues ¡ay de mí si no evangelizare!"
,"17":"Si hiciera esto por propia voluntad, merecería recompensa; pero si lo hago por mandato, cumplo con una misión que se me ha confiado."
,"18":"¿Cuál es, pues, mi recompensa? Que predico el evangelio y lo hago gratuitamente, no haciendo valer mis derechos por la evangelización."
,"19":"Libre, de hecho, como estoy de todos, me hago esclavo de todos para ganarlos a todos."
,"20":"Con los judíos me hago judío; con los que están bajo la ley, como quien está bajo ella, sin estarlo, para ganar a los que están bajo la ley;"
,"21":"con los que están sin ley, como quien está sin ella, para ganarlos, yo que no estoy sin ley de Dios, sino bajo la ley de Cristo."
,"22":"Con los débiles en la fe me hago débil para ganar a los débiles; me hago todo para todos, para salvarlos a todos."
,"23":"Todo lo hago por el evangelio, para participar de sus bienes."
,"24":"¿No sabéis que los que corren en el estadio todos corren, pero sólo uno consigue el premio? Corred de modo que lo conquistéis."
,"25":"Los atletas se privan de muchas cosas, y lo hacen para conseguir una corona corruptible; en cambio, nosotros, por una incorruptible."
,"26":"Yo no corro sin ton ni son, ni peleo como quien da golpes al aire,"
,"27":"sino que me impongo una disciplina y domino mi cuerpo, no sea que después de predicar a los demás, yo quede descalificado."
}`)
	CurrentBook.AddChapter(10, `{
"1":"No quiero que olvidéis que nuestros antepasados estuvieron todos bajo la nube, todos atravesaron el mar"
,"2":"y todos, al ser bautizados en la nube y en el mar, quedaron unidos a Moisés;"
,"3":"todos comieron el mismo alimento espiritual"
,"4":"y bebieron la misma bebida espiritual. Bebían de la piedra espiritual que les seguía; y la piedra era Cristo."
,"5":"Pero la mayoría no agradó a Dios, y quedaron tendidos en el desierto."
,"6":"Todo esto sucedió para ejemplo nuestro, para que no codiciemos lo malo como lo codiciaron ellos."
,"7":"No os hagáis idólatras, como algunos de ellos, según dice la Escritura: El pueblo se sentó a comer y beber, y se levantó para divertirse."
,"8":"No nos entreguemos a la lujuria, como se entregaron algunos de ellos, y cayeron veintitrés mil en un solo día."
,"9":"No provoquemos al Señor como algunos de ellos lo hicieron, y perecieron mordidos por las serpientes."
,"10":"No protestéis contra Dios como algunos de ellos lo hicieron, y acabaron en manos del exterminador."
,"11":"Todo esto les sucedía para que escarmentaran, y fue escrito como aviso para nosotros, que vivimos en los tiempos definitivos."
,"12":"Por tanto, el que crea estar firme, tenga cuidado de no caer."
,"13":"No os ha llegado ninguna prueba insuperable. Dios es fiel y no permitirá que seáis sometidos a pruebas superiores a vuestras fuerzas; ante la prueba os dará fuerza para superarla."
,"14":"Por esto, queridos míos, huid de la idolatría."
,"15":"Os hablo como a personas inteligentes: juzgad lo que os digo."
,"16":"El cáliz de bendición que bendecimos, ¿no es la comunión con la sangre de Cristo? Y el pan que partimos, ¿no es la comunión con el cuerpo de Cristo?"
,"17":"Puesto que sólo hay un pan, todos formamos un solo cuerpo, pues todos participamos del mismo pan."
,"18":"Fijaos en el pueblo de Israel. ¿No quedan unidos al altar los que comen de las víctimas ofrecidas en él?"
,"19":"¿Quiero decir con esto que las víctimas ofrecidas y los ídolos son algo?"
,"20":"No, pues los paganos ofrecen sus sacrificios a los demonios y no a Dios, y yo no quiero que entréis en comunión con los demonios."
,"21":"No podéis beber a la vez el cáliz del Señor y el de los demonios. No podéis participar a la vez de la mesa del Señor y de la de los demonios."
,"22":"¿O queremos provocar celos al Señor? ¿Somos acaso más fuertes que él?"
,"23":"Siguen insistiendo: 'Todo está permitido'. Pero no todo es conveniente. 'Todo está permitido'. Pero no todo es provechoso."
,"24":"Que nadie busque su propio interés, sino el de los demás."
,"25":"Comed todo lo que se vende en el mercado, sin andar averiguando nada por motivos de conciencia,"
,"26":"pues del Señor es la tierra y cuanto la llena."
,"27":"Si algún pagano os invita y queréis ir, comed todo lo que os presente sin más averiguaciones por motivos de conciencia."
,"28":"Pero si alguno os dice: 'Esto ha sido ofrecido a los ídolos', no comáis en atención al que lo dijo y por motivos de conciencia."
,"29":"No de tu conciencia, sino la del otro. Pues, ¿por qué mi libertad ha de ser juzgada por conciencia ajena?"
,"30":"Si yo doy gracias a Dios al comerlo, ¿qué razón hay para que me critiquen porque lo coma?"
,"31":"Ya comáis, ya bebáis, hagáis lo que hagáis, hacedlo todo para gloria de Dios."
,"32":"No escandalicéis ni a los judíos, ni a los paganos, ni a la Iglesia de Dios;"
,"33":"haced en todo como yo, que me esfuerzo en complacer a todos en todo, no buscando mi interés, sino el de los demás, para que se salven."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Seguid mi ejemplo, como yo sigo el de Cristo."
,"2":"Os felicito porque os acordáis siempre de mí y conserváis las tradiciones tal como os las transmití."
,"3":"Quiero que sepáis que la cabeza de todo hombre es Cristo; que la cabeza de la mujer es el hombre, y la cabeza de Cristo, Dios."
,"4":"El hombre que ora o profetiza con la cabeza cubierta deshonra a Cristo, que es su cabeza."
,"5":"Y la mujer que ora o profetiza con la cabeza descubierta deshonra al marido, que es su cabeza, exactamente igual que si se la hubiera rapado."
,"6":"Por tanto, si una mujer no quiere llevar velo, que se corte el pelo al cero. Y si es vergonzoso para una mujer cortarse el pelo o raparse la cabeza, que lleve velo."
,"7":"El hombre no debe cubrirse la cabeza, porque es imagen y gloria de Dios, pero la mujer es gloria del hombre."
,"8":"Pues el hombre no procede de la mujer, sino la mujer del hombre;"
,"9":"el hombre no fue creado para la mujer, sino la mujer para el hombre."
,"10":"Por esto la mujer debe llevar en la cabeza una señal de sujeción por respeto a los ángeles."
,"11":"Pero entre cristianos debemos reconocer que la mujer depende del hombre y el hombre de la mujer."
,"12":"Porque así como la mujer procede del hombre, así también el hombre nace de la mujer; y todo viene de Dios."
,"13":"Juzgad vosotros mismos. ¿Es decente que la mujer ore a Dios con la cabeza descubierta?"
,"14":"¿No os enseña la misma naturaleza que es una vergüenza que el hombre se deje el pelo largo,"
,"15":"mientras que para la mujer eso es un orgullo? El pelo largo que tiene le sirve de velo."
,"16":"Pero si alguno quiere discutir este asunto, sepa que nosotros y la Iglesia no tenemos esta costumbre."
,"17":"Al daros estos consejos, no puedo felicitaros, pues, al parecer, vuestras reuniones, en lugar de haceros bien, os hacen daño."
,"18":"En primer lugar, he oído decir que, cuando os reunís, hay divisiones entre vosotros, y en parte lo creo;"
,"19":"y hasta es conveniente que haya divisiones entre vosotros para que se sepa quiénes son de virtud probada."
,"20":"Cuando os reunís en común, ya no es eso comer la cena del Señor."
,"21":"Porque cada cual se adelanta a comer su propia cena; y mientras uno pasa hambre, otro se emborracha."
,"22":"¿Es que no tenéis vuestra casa para comer y beber? ¿O es que despreciáis a la Iglesia de Dios y queréis dejar en vergüenza a los que no tienen? ¿Qué os voy a decir? ¿He de felicitaros? En esto no os puedo felicitar."
,"23":"Yo recibí del Señor lo que os he transmitido: Que Jesús, el Señor, en la noche que fue entregado, tomó pan,"
,"24":"dio gracias, lo partió y dijo: 'Esto es mi cuerpo, que se entrega por vosotros; haced esto en memoria mía'."
,"25":"Después de cenar, hizo lo mismo con el cáliz, diciendo: 'Este cáliz es la nueva alianza sellada con mi sangre; cada vez que la bebáis, hacedlo en memoria mía'."
,"26":"Pues siempre que coméis este pan y bebéis este cáliz anunciáis la muerte del Señor hasta que vuelva."
,"27":"Por eso, el que come del pan o bebe del cáliz del Señor indignamente será reo del cuerpo y de la sangre del Señor."
,"28":"Por tanto, examine cada uno su propia conciencia, y entonces coma del pan y beba del cáliz."
,"29":"Porque el que come y bebe sin considerar que se trata del cuerpo del Señor, come y bebe su propia condenación."
,"30":"Por eso muchos de vosotros estáis enfermos y débiles, y otros han muerto."
,"31":"Si nos examinásemos a nosotros mismos, no seríamos castigados."
,"32":"Y si el Señor nos castiga, es para corregirnos y para que no seamos condenados con el mundo."
,"33":"Por tanto, hermanos míos, cuando os reunáis para la cena, esperaos unos a otros."
,"34":"Y si alguno tiene hambre, que coma en su casa, y que en vuestras reuniones no haya motivo alguno para castigaros. Lo demás lo arreglaré a mi llegada."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Hermanos, no quiero que ignoréis lo tocante a los dones espirituales."
,"2":"Sabéis bien que cuando erais paganos os dejabais arrastrar irresistiblemente por los ídolos mudos."
,"3":"Por eso os manifiesto que nadie, movido por el Espíritu de Dios, puede decir: 'Maldito sea Jesús'; y nadie puede decir: 'Jesús es el Señor', si no es movido por el Espíritu."
,"4":"Hay diversidad de dones espirituales, pero el Espíritu es el mismo;"
,"5":"diversidad de funciones, pero el mismo Señor;"
,"6":"diversidad de actividades, pero el mismo Dios, que lo hace todo en todos."
,"7":"A cada cual se le da la manifestación del Espíritu para el bien común."
,"8":"Así, el Espíritu a uno le concede hablar con sabiduría; a otro, por el mismo Espíritu, hablar con conocimiento profundo;"
,"9":"el mismo Espíritu a uno le concede el don de la fe; a otro el poder de curar a los enfermos;"
,"10":"a otro el don de hacer milagros; a otro el decir profecías; a otro el saber distinguir entre los espíritus falsos y el Espíritu verdadero; a otro hablar lenguas extrañas, y a otros saber interpretarlas."
,"11":"Todo esto lo lleva a cabo el único y mismo Espíritu, repartiendo a cada uno sus dones como quiere."
,"12":"Del mismo modo que el cuerpo es uno, aunque tiene muchos miembros, y todos los miembros del cuerpo, con ser muchos, forman un cuerpo, así también Cristo."
,"13":"Porque todos nosotros, judíos y griegos, esclavos y libres, fuimos bautizados en un solo Espíritu, para formar un solo cuerpo. Y todos hemos bebido del mismo Espíritu."
,"14":"Porque el cuerpo no es un miembro, sino muchos."
,"15":"Aunque el pie diga: 'Como no soy mano, no soy del cuerpo', no por eso deja de ser del cuerpo."
,"16":"Aunque el oído diga: 'Como no soy ojo, no soy del cuerpo', no por eso deja de ser del cuerpo."
,"17":"Si todo el cuerpo fuese ojo, ¿dónde estaría el oído? Si todo oído, ¿dónde estaría el olfato?"
,"18":"Pero Dios ha dispuesto cada uno de los miembros del cuerpo como ha querido."
,"19":"Y si todos fueran un solo miembro, ¿dónde estaría el cuerpo?"
,"20":"Hay muchos miembros, pero un solo cuerpo."
,"21":"El ojo no puede decir a la mano: 'No te necesito'; ni la cabeza a los pies: 'No os necesito'."
,"22":"Más aún, los miembros aparentemente más débiles son los más necesarios;"
,"23":"y a los que parecen menos dignos, los rodeamos de mayor cuidado; a los que consideramos menos presentables los tratamos con mayor recato,"
,"24":"lo cual no es necesario hacer con los miembros más presentables. Y es que Dios hizo el cuerpo, dando mayor honor a lo menos noble,"
,"25":"para evitar divisiones en el cuerpo y para que todos los miembros se preocupen unos de otros."
,"26":"Así, si un miembro sufre, con él sufren todos los miembros; si un miembro recibe una atención especial, todos los miembros se alegran."
,"27":"Ahora bien, vosotros sois el cuerpo de Cristo, y cada uno por su parte es miembro de ese cuerpo."
,"28":"Y así Dios ha puesto en la Iglesia en primer lugar a los apóstoles; en segundo lugar, a los profetas; en tercero, a los maestros; luego, los que tienen el poder de hacer milagros; después, los que tienen el don de curar, de asistir a los necesitados, de gobernar, de hablar lenguas extrañas."
,"29":"¿Son todos apóstoles? ¿O todos profetas? ¿O todos maestros? ¿Tienen todos el poder de hacer milagros?"
,"30":"¿Tienen todos el don de curar? ¿Hablan todos lenguas? ¿O todos las interpretan?"
,"31":"Ambicionad dones más altos. Pero os voy a mostrar un camino, que es el mejor."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Aunque hable las lenguas de los hombres y de los ángeles, si no tengo amor, no soy más que una campana que toca o unos platillos que resuenan."
,"2":"Aunque tenga el don de profecía y conozca todos los misterios y toda la ciencia, y aunque tenga tanta fe que traslade las montañas, si no tengo amor, no soy nada."
,"3":"Aunque reparta todos mis bienes entre los pobres y entregue mi cuerpo a las llamas, si no tengo amor, de nada me sirve."
,"4":"El amor es paciente, es servicial; el amor no tiene envidia, no es presumido ni orgulloso;"
,"5":"no es grosero ni egoísta, no se irrita, no toma en cuenta el mal;"
,"6":"el amor no se alegra de la injusticia; se alegra de la verdad."
,"7":"Todo lo excusa, todo lo cree, todo lo espera, todo lo tolera."
,"8":"El amor nunca falla. Desaparecerán las profecías, las lenguas cesarán y tendrá fin la ciencia."
,"9":"Nuestra ciencia es imperfecta, e imperfecta también nuestra profecía."
,"10":"Cuando llegue lo perfecto, desaparecerá lo imperfecto."
,"11":"Cuando yo era niño, hablaba como niño, pensaba como niño, razonaba como niño. Cuando llegué a hombre, desaparecieron las cosas de niño."
,"12":"Ahora vemos como por medio de un espejo, confusamente; entonces veremos cara a cara. Ahora conozco de una manera imperfecta; entonces conoceré de la misma manera que Dios me conoce a mí."
,"13":"Tres cosas hay que permanecen: la fe, la esperanza y el amor. Pero la más grande de las tres es el amor."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Buscad el amor; aspirad a los dones espirituales, pero sobre todo al don de profecía."
,"2":"Porque el que habla en lenguas extrañas, no habla a los hombres, sino a Dios; de hecho, ninguno le entiende, pues movido por el Espíritu dice cosas misteriosas."
,"3":"Pero el que profetiza, habla a los hombres, los forma, los anima y los consuela."
,"4":"El que habla en lenguas extrañas se aprovecha a sí mismo; el que profetiza, lo hace en beneficio de la Iglesia."
,"5":"Me gustaría que todos hablaseis en esas lenguas, pero prefiero que profeticéis; pues para la formación de la Iglesia es mejor profetizar que hablar en lenguas, a no ser que haya quien los interprete."
,"6":"Hermanos, si yo fuera a veros y os hablara en lenguas extrañas, ¿qué os aprovecharía? Absolutamente nada. Lo provechoso sería que os comunicase alguna revelación, conocimiento, profecía o enseñanza."
,"7":"Los instrumentos musicales, como la flauta o el arpa, que emiten sonidos, si no los emiten con precisión, ¿cómo se conocerá que se toca con la flauta o con el arpa?"
,"8":"Si la corneta da un sonido indefinido, ¿quién se pondrá en orden de batalla?"
,"9":"Así también vosotros, si vuestra lengua no utiliza palabras claras, ¿cómo se entenderá lo que decís? Sería como hablar al aire."
,"10":"En el mundo hay muchos idiomas, pero todos tienen sentido."
,"11":"Si yo desconozco el significado de las palabras, ni yo le entenderé a él ni él a mí."
,"12":"Así pues, ya que ambicionáis los dones espirituales, procurad tener los que sirven para la formación de la Iglesia."
,"13":"Por tanto, el que hable en lenguas, pida a Dios el don de interpretarlas."
,"14":"Porque si rezo en lenguas, mi espíritu reza, pero mi entendimiento no saca fruto."
,"15":"¿Qué debo hacer entonces? Debo orar con el espíritu, pero también con el entendimiento; debo cantar con el espíritu, pero también con el entendimiento."
,"16":"Porque si tú bendices con el espíritu, ¿cómo dirá 'amén' a tu acción de gracias quien asiste como simple fiel si no entiende lo que dices?"
,"17":"Sin duda será buena tu acción de gracias, pero el otro no saca ningún provecho."
,"18":"Doy gracias a Dios de hablar en lenguas más que vosotros;"
,"19":"pero prefiero hablar en la iglesia cinco palabras con sentido, para instruir a los demás, que diez mil palabras en lenguas."
,"20":"Hermanos, no seáis como niños en vuestros pensamientos; sed como niños en lo que se refiere al mal, pero como hombres adultos en vuestra manera de pensar."
,"21":"Está escrito en la ley: Hablaré a este pueblo en lenguas extrañas y por boca de extranjeros, y ni aun así me escucharán, dice el Señor."
,"22":"Así que las lenguas son una señal, no para los fieles, sino para los paganos; en cambio, la profecía, no para los paganos, sino para los fieles."
,"23":"Supongamos que se reúne toda la iglesia y que todos hablan en lenguas extrañas; si entra un simple fiel o un incrédulo, ¿no dirán que estáis locos?"
,"24":"Pero si todos están hablando en nombre de Dios, ese simple fiel o incrédulo por lo que oye a todos puede recapacitar, examinarse a sí mismo y convencerse de su pecado;"
,"25":"quedarán al descubierto sus secretos íntimos y, postrado de rodillas, adorará a Dios y proclamará que Dios está verdaderamente entre vosotros."
,"26":"En conclusión, hermanos: cuando os reunís, unos pueden cantar, otros enseñar, otros manifestar una revelación, otros hablar en lenguas extrañas y otros interpretarlas. Pero que sea para aprovechamiento de todos."
,"27":"Si se habla en lenguas extrañas, que hablen dos o a lo sumo tres, y por turno, y que uno les interprete."
,"28":"Y si no hay intérprete, que se guarde silencio en la asamblea, y que hablen consigo mismo y con Dios."
,"29":"En cuanto a los profetas, que hablen dos o tres, y los demás que den su parecer."
,"30":"Si uno que está sentado tiene una revelación, que se calle el que está hablando."
,"31":"Podéis profetizar todos, pero uno por uno, para que todos aprendan y se animen."
,"32":"Los que hablan en nombre de Dios deben estar sometidos a los que tienen ese don,"
,"33":"pues Dios es Dios de paz y no de confusión. Como en todas las demás iglesias cristianas, "
,"34":"las mujeres en las reuniones que se callen, pues no les está permitido hablar; deben estar sometidas a sus maridos, como dice la ley."
,"35":"Y si quieren aprender algo, que pregunten en casa a sus maridos, pues no está bien que la mujer hable en la asamblea."
,"36":"La palabra de Dios no ha salido de vosotros, ni vosotros sois los únicos que la habéis recibido."
,"37":"Si alguno se tiene por profeta o por hombre de espíritu, sabrá que lo que os escribo es mandato del Señor."
,"38":"Y si no lo sabe, que no lo sepa."
,"39":"En resumen, hermanos, ambicionad el don de profecía, y no impidáis hablar en lenguas;"
,"40":"pero hágase todo con decoro y orden."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Hermanos, os recuerdo el evangelio que os anuncié, el que aceptasteis, en el que permanecéis firmes,"
,"2":"y por el que os salvaréis, si lo retenéis tal y como os lo anuncié, pues de lo contrario habríais creído en vano."
,"3":"Os transmití, en primer lugar, lo que a mi vez yo recibí: que Cristo murió por nuestros pecados, según las Escrituras;"
,"4":"que fue sepultado y resucitó al tercer día, según las Escrituras,"
,"5":"y que se apareció a Pedro y luego a los doce."
,"6":"Se apareció también a más de quinientos hermanos de una vez, de los que la mayoría viven todavía; otros murieron."
,"7":"Luego se apareció a Santiago, después a todos los apóstoles;"
,"8":"y después de todos, como a uno que nace antes de tiempo, también se me apareció a mí."
,"9":"Porque yo soy el menor de los apóstoles, indigno de ser llamado apóstol, por haber perseguido a la Iglesia de Dios."
,"10":"Pero por la gracia de Dios soy lo que soy, y la gracia de Dios no ha sido estéril en mí; pues he trabajado más que los demás; pero no yo, sino la gracia de Dios conmigo."
,"11":"Pues bien, tanto ellos como yo, esto es lo que predicamos y lo que habéis creído."
,"12":"Ahora bien, si se predica que Cristo ha resucitado de entre los muertos, ¿cómo algunos de vosotros dicen que no hay resurrección de los muertos?"
,"13":"Porque si no hay resurrección de los muertos, tampoco Cristo ha resucitado."
,"14":"Y si Cristo no ha resucitado, vana es nuestra predicación y vana nuestra fe."
,"15":"Incluso seríamos falsos testigos de Dios, pues contra Dios testificamos que ha resucitado a Cristo, mientras que no lo ha resucitado si los muertos no resucitan."
,"16":"Porque si los muertos no resucitan, tampoco Cristo ha resucitado."
,"17":"Y si Cristo no ha resucitado, vana es nuestra fe: todavía estáis en vuestros pecados;"
,"18":"y, por tanto, los cristianos que han muerto están perdidos."
,"19":"Si lo que esperamos de Cristo es sólo para esta vida, somos los hombres más desgraciados."
,"20":"Pero Cristo ha resucitado de entre los muertos como primicias de los que mueren."
,"21":"Porque como por un hombre vino la muerte, así, por un hombre, la resurrección de los muertos."
,"22":"Y como todos mueren en Adán, así también todos revivirán en Cristo."
,"23":"Pero cada uno por su turno: el primero, Cristo; luego, cuando Cristo vuelva, los que son de Cristo."
,"24":"Entonces vendrá el fin, cuando él destruya todo señorío, todo poder y toda fuerza y entregue el reino a Dios Padre."
,"25":"Pues es necesario que él reine hasta poner a todos sus enemigos bajo sus pies."
,"26":"El último enemigo en ser destruido será la muerte;"
,"27":"porque todo lo puso bajo sus pies. Pero cuando dice que todo le está sometido, está claro que exceptúa a Dios, que fue quien le sometió todas las cosas."
,"28":"Cuando todo le esté sometido, entonces también el Hijo se someterá al Padre, que le sometió todo a él para que Dios sea todo en todas las cosas."
,"29":"Si no fuera así, ¿a qué bautizarse por los muertos? Si realmente los muertos no resucitan, ¿a qué bautizarse por ellos?"
,"30":"¿Y por qué exponernos nosotros al peligro a cada instante?"
,"31":"Hermanos, os aseguro que todos los días estoy al borde de la muerte, y que vosotros sois mi gloria en Cristo Jesús, Señor nuestro."
,"32":"Si luché con las fieras en Éfeso con miras humanas, ¿de qué me sirvió? Si los muertos no resucitan, comamos y bebamos, que mañana moriremos."
,"33":"No os dejéis engañar: 'Las malas compañías corrompen las buenas costumbres'."
,"34":"Entrad en razón y no pequéis, pues algunos tienen gran ignorancia de Dios. Os lo digo para vergüenza vuestra."
,"35":"Alguno preguntará: ¿Cómo resucitarán los muertos? ¿Con qué cuerpo?"
,"36":"¡Necio! Lo que tú siembras no germina si no muere."
,"37":"Y lo que siembras no es la planta que ha de nacer, sino un sencillo grano; de trigo, por ejemplo, o de alguna otra semilla."
,"38":"Y Dios le da el cuerpo que quiere, y un cuerpo propio a cada semilla."
,"39":"No todos los cuerpos son iguales; uno es el cuerpo de los hombres, otro el de los ganados, otro el de las aves y otro el de los peces."
,"40":"Hay cuerpos celestes y cuerpos terrestres, pero uno es el resplandor de los cuerpos celestes y otro el de los terrestres."
,"41":"Uno es el resplandor del sol, otro el de la luna y otro el de las estrellas. Incluso cada estrella tiene un resplandor diferente."
,"42":"Eso mismo pasa con la resurrección de los muertos. Se siembra algo corruptible, y resucita incorruptible."
,"43":"Se siembra una cosa despreciable, y resucita gloriosa; se siembra una cosa débil, y resucita con fuerza."
,"44":"Se siembra un cuerpo animal, y resucita un cuerpo espiritual. Si hay cuerpo animal, lo hay también espiritual;"
,"45":"la Escritura dice: Adán, el primer hombre, fue creado un ser viviente; el último Adán, como espíritu que da vida."
,"46":"Pero lo primero no es lo espiritual, sino lo animal; después, lo espiritual."
,"47":"El primer hombre, sacado de la tierra, es terrestre; el segundo, por el contrario, del cielo."
,"48":"Como el terrestre, así son los terrestres; como el celeste, así son los celestes."
,"49":"Y así como llevamos la imagen del terrestre, llevaremos también la del celeste."
,"50":"Hermanos, os digo que la carne y la sangre no pueden heredar el reino de Dios, ni lo corruptible heredará lo incorruptible."
,"51":"Ahora os voy a declarar un misterio: no todos moriremos, pero todos seremos transformados."
,"52":"En un momento, en un abrir y cerrar de ojos, al son de la última trompeta, pues sonará la trompeta, los muertos resucitarán incorruptos, y nosotros seremos transformados."
,"53":"Porque esto corruptible ha de vestirse de incorruptibilidad, y esto mortal de inmortalidad."
,"54":"Cuando esto corruptible se vista de incorruptibilidad y esto mortal de inmortalidad, entonces se cumplirá lo que dice la Escritura: La muerte ha sido destruida por la victoria."
,"55":"¿Dónde está, muerte, tu victoria? ¿Dónde, muerte, tu aguijón venenoso?"
,"56":"El aguijón de la muerte es el pecado, y la fuerza del pecado, la ley."
,"57":"¡Demos gracias a Dios que nos da esta victoria por medio de nuestro Señor Jesucristo!"
,"58":"Por esto, queridos hermanos, manteneos firmes, inconmovibles, trabajando más y más en la obra del Señor, sabiendo que el Señor no dejará sin recompensa vuestro trabajo."
}`)
	CurrentBook.AddChapter(16, `{
"1":"En cuanto a la colecta en favor de los cristianos, haced lo que ordené a las iglesias de Galacia."
,"2":"Los domingos, cada uno de vosotros separe lo que pueda, según lo que gane, sin esperar a mi llegada para hacer la colecta."
,"3":"Cuando vaya, enviaré a Jerusalén con cartas de presentación a los que elijáis para llevar lo que hayáis recogido."
,"4":"Y si vale la pena que vaya también yo, iremos juntos."
,"5":"Llegaré allí después de visitar Macedonia, pues quiero pasar por Macedonia."
,"6":"Tal vez me detenga con vosotros, y hasta quizá pase el invierno para que me ayudéis a proseguir el viaje."
,"7":"Ahora no quiero ir de pasada; espero permanecer algún tiempo con vosotros, si Dios quiere."
,"8":"En Éfeso me quedaré hasta pentecostés;"
,"9":"pues se me ha abierto una puerta grande y prometedora para mi trabajo, aunque tengo muchos en contra."
,"10":"Si llega Timoteo, procurad que se sienta a gusto entre vosotros, pues trabaja como yo en la obra del Señor."
,"11":"Que nadie le haga de menos; ayudadle para que continúe el viaje y venga a verme, pues los hermanos y yo estamos esperándole."
,"12":"En cuanto al hermano Apolo, le insistí en que fuera con los hermanos a veros, pero ahora no ha querido ir en modo alguno; irá cuando se le presente una buena oportunidad."
,"13":"Estad alerta, permaneced firmes en la fe, sed hombres, sed fuertes."
,"14":"Haced todo con amor."
,"15":"Hermanos, os voy a pedir un favor: sabéis que la familia de Esteban fue la primera que se hizo cristiana en la región de Acaya y que se ha consagrado al servicio de los fieles."
,"16":"Sed deferentes con ellos y con cuantos como ellos trabajan y se afanan en esta obra."
,"17":"Me ha alegrado la visita de Esteban, Fortunato y Acaico, quienes han llenado el vacío de vuestra ausencia,"
,"18":"tranquilizándome a mí, como ahora lo harán a vosotros. A personas así debéis estar reconocidos."
,"19":"Os saludan las iglesias de Asia. Os mandan muchos saludos Áquila y Prisca, con la iglesia que se reúne en su casa."
,"20":"Os saludan todos los hermanos. Saludaos unos a otros con el abrazo de la paz."
,"21":"El saludo es de mi mano: Pablo."
,"22":"Maldito sea el que no ama al Señor. ¡Ven, Señor nuestro!"
,"23":"Que la gracia de Jesús, el Señor, esté con vosotros."
,"24":"Os amo a todos en Cristo Jesús."
}`)

}
func ES_LSB_LoadNP1EChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Pablo, Silvano y Timoteo a la Iglesia de los Tesalonicenses. Os deseamos la gracia y la paz de Dios Padre y de Jesucristo, el Señor."
,"2":"Continuamente damos gracias a Dios por todos vosotros y os recordamos en nuestras oraciones."
,"3":"Sin cesar presentamos a Dios, nuestro Padre, la actividad de vuestra fe, la eficacia de vuestro amor y la firmeza de vuestra esperanza en nuestro Señor Jesucristo."
,"4":"Sabemos muy bien, hermanos queridos de Dios, que habéis sido elegidos."
,"5":"Porque nuestro mensaje evangélico no os fue transmitido solamente con palabras, sino también con obras portentosas bajo la acción del Espíritu Santo y, por parte nuestra, con una profunda entrega. En efecto, vosotros sabéis cuál fue nuestra actuación entre vosotros para vuestro bien."
,"6":"Y vosotros habéis seguido mi ejemplo y el del Señor, recibiendo la predicación con el gozo del Espíritu Santo aun en medio de grandes tribulaciones,"
,"7":"hasta convertiros en modelo para todos los creyentes de Macedonia y de Acaya."
,"8":"Así es como desde vosotros se ha difundido la palabra del Señor; y no solamente en Macedonia y en Acaya, sino por doquier es conocida vuestra fe en Dios, de suerte que no tenemos necesidad de hablar de ella."
,"9":"Ellos mismos van refiriendo la acogida que nos hicisteis, y cómo dejasteis la idolatría y os convertisteis para servir al Dios vivo y verdadero,"
,"10":"con la esperanza de que su Hijo Jesús, al que él resucitó de entre los muertos, vuelva del cielo y nos libre del desastre inminente."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Bien sabéis vosotros, hermanos, que nuestra estancia entre vosotros no ha sido infructuosa."
,"2":"Como sabéis, después de haber sido maltratados y ultrajados en Filipos, llenos de confianza en el Señor, nos atrevimos a anunciaros su evangelio en medio también de grandes luchas."
,"3":"En efecto, nuestra predicación no se basa en el error, en malas intenciones o en ánimo de engañar."
,"4":"Por el contrario, fue Dios el que nos eligió y nos confió su evangelio, y así es como hablamos. No tratamos de agradar a los hombres, sino a Dios, que sondea nuestros corazones."
,"5":"Nunca, como sabéis y Dios es testigo de ello, fueron móviles nuestros la adulación y la avaricia;"
,"6":"nunca hemos buscado honores, ni de vosotros ni de nadie."
,"7":"Aunque, como apóstoles de Cristo, hemos podido hacer uso de nuestra autoridad, hemos sido todo bondad en medio de vosotros. Más aún, como una madre cuida cariñosamente a sus hijos,"
,"8":"así, en nuestra ternura hacia vosotros, hubiéramos querido entregaros, al mismo tiempo que el evangelio de Dios, nuestra propia vida. ¡Tanto os queríamos!"
,"9":"Hermanos, recordad nuestros trabajos y fatigas; cómo trabajábamos día y noche para no ser gravosos a ninguno de vosotros mientras os anunciábamos el evangelio de Dios."
,"10":"Vosotros sois testigos, y también Dios, de que nos comportamos con vosotros, los creyentes, de una manera noble, justa e irreprochable."
,"11":"Bien sabéis que hemos sido para cada uno de vosotros como un padre para sus hijos;"
,"12":"y así os exhortábamos, os animábamos y os alentábamos a llevar una vida digna de Dios, que os llama a su reino y a su gloria."
,"13":"Por todo ello damos continuamente gracias a Dios: porque, al recibir la palabra de Dios que os predicamos, la abrazasteis no como palabra de hombre, sino como lo que es en verdad, la palabra de Dios, que permanece vitalmente activa en vosotros, los creyentes."
,"14":"Hermanos, os habéis hecho imitadores de las iglesias de Dios que hay en Judea y que son de Cristo Jesús, pues habéis padecido de parte de vuestros conciudadanos lo mismo que ellos de parte de los judíos,"
,"15":"que mataron a Jesús, el Señor, y a los profetas; y a nosotros nos han perseguido y desagradan a Dios, siendo enemigos de todos los hombres"
,"16":"al impedirnos predicar a los paganos para que se salven. Con lo cual van colmando la medida de su pecado. Pero el castigo de Dios está para caer pesadamente sobre ellos."
,"17":"Nosotros, hermanos, en este breve espacio de tiempo que hemos estado separados de vosotros, aunque espiritualmente no lo hemos estado, hemos sentido un deseo todavía más vivo de volver a veros."
,"18":"Y así, una y otra vez nos propusimos, en particular yo, Pablo, ir a veros; pero Satanás nos lo impidió."
,"19":"Y es que, ¿quién es en verdad nuestra esperanza, nuestro gozo, nuestra corona de gloria delante de nuestro Señor Jesucristo en el día de su venida? ¿Quién sino vosotros?"
,"20":"Sí, ciertamente, vosotros sois nuestra corona y nuestro gozo."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Pues bien, no pudiendo resistir más, resolvimos quedarnos solos en Atenas,"
,"2":"y enviamos a Timoteo, nuestro hermano y ministro de Dios en el evangelio de Cristo, con la misión de confortaros y alentaros en vuestra fe,"
,"3":"para que nadie se deje desalentar por estas tribulaciones. Pues bien sabéis vosotros mismos que son parte de nuestra vocación."
,"4":"Durante nuestra estancia entre vosotros os predecíamos ya que habríamos de tener tribulaciones, como realmente ha sucedido. Bien lo sabéis."
,"5":"Por esto, no pudiendo resistir ya más, le envié para que me informara de vuestra fe; no fuera que os hubiese tentado ya Satanás y hubiera resultado estéril nuestro trabajo."
,"6":"Ahora Timoteo ha regresado de Tesalónica y nos ha traído buenas noticias de vuestra fe y de vuestro amor, y de cómo conserváis constantemente un afectuoso recuerdo de nosotros, deseando vivamente vernos, lo mismo que nosotros a vosotros."
,"7":"Con todo ello, y principalmente por vuestra fe, nos habéis procurado un gran consuelo en medio de las presentes tribulaciones y congojas."
,"8":"Ahora nos parece vivir de nuevo, porque vosotros os mantenéis firmes en el Señor."
,"9":"¿Cómo podremos agradecer a Dios todo este gozo que nos habéis proporcionado ante nuestro Dios?"
,"10":"Noche y día le pedimos con renovada insistencia que nos conceda veros personalmente y poder completar así lo que falta todavía a vuestra fe."
,"11":"Que Dios, nuestro Padre, y nuestro Señor Jesucristo me encaminen felizmente hacia vosotros."
,"12":"Que el Señor os haga crecer más y más en el amor entre vosotros y para con todos, como nosotros lo tenemos para con vosotros."
,"13":"Que él fortalezca vuestros corazones en una santidad sin tacha ante Dios, nuestro Padre, para cuando venga Jesús, nuestro Señor, con todos los suyos."
}`)
	CurrentBook.AddChapter(4, `{
"1":"En fin, hermanos, os pedimos y os exhortamos en el nombre de Jesús, el Señor, a que os portéis de la manera que os enseñamos para agradar a Dios; ya lo hacíais, pero hacedlo todavía mejor."
,"2":"Bien sabéis las instrucciones que os dimos en nombre de Jesús, el Señor."
,"3":"Ahora bien, ésta es la voluntad de Dios, vuestra santificación: que huyáis de la impureza,"
,"4":"que cada uno de vosotros sepa tratar su propio cuerpo de una manera digna y honesta,"
,"5":"sin dejarse llevar por la pasión, como hacen los paganos, que no conocen a Dios."
,"6":"Que en este punto nadie abuse ni engañe a su hermano, pues el Señor tomará venganza de todo esto, como ya os lo dejamos dicho y recalcado."
,"7":"Y es que Dios no nos ha llamado a la impureza, sino a vivir en la santidad."
,"8":"Por tanto, el que desprecie todo esto no desprecia a un hombre, sino a Dios, el cual os da su Espíritu Santo."
,"9":"Acerca del amor fraterno no necesitáis que se os escriba, porque personalmente habéis aprendido de Dios cómo debéis amaros los unos a los otros."
,"10":"Y, en efecto, así lo hacéis con todos los hermanos de toda Macedonia. Sin embargo, queremos exhortaros, hermanos, a que progreséis todavía más"
,"11":"y a que con todo empeño os afanéis en vivir pacíficamente, ocupándoos en vuestros quehaceres y trabajando con vuestras propias manos, como os lo tenemos recomendado."
,"12":"Así llevaréis una vida honrada a los ojos de los de fuera y no tendréis necesidad de nadie."
,"13":"Hermanos, no queremos que ignoréis la suerte de los difuntos, para que no os aflijáis como los que no tienen esperanza."
,"14":"Porque si creemos que Jesús ha muerto y ha resucitado, así también reunirá consigo a los que murieron unidos a Jesús."
,"15":"Ved, pues, lo que os decimos como palabra del Señor: nosotros, los vivos, los que estamos todavía en tiempo de la venida del Señor, no precederemos a los que murieron."
,"16":"Porque el Señor mismo, a la señal dada por la voz del arcángel y al son de la trompeta de Dios, bajará del cielo, y los muertos unidos a Cristo resucitarán los primeros."
,"17":"Después nosotros, los vivos, los que estemos hasta la venida del Señor, seremos arrebatados juntamente con ellos entre nubes por los aires al encuentro del Señor. Y ya estaremos siempre con el Señor."
,"18":"Consolaos, pues, mutuamente con estas palabras."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Hermanos, en cuanto al tiempo preciso, no tenéis necesidad de que se os escriba."
,"2":"Vosotros sabéis perfectamente que el día del Señor vendrá como el ladrón en la noche."
,"3":"Andarán diciendo: 'Todo es paz y seguridad'; y entonces, de improviso, les sorprenderá la perdición, como los dolores del parto a la mujer encinta, y no podrán escapar."
,"4":"Hermanos, vosotros no vivís en la oscuridad para que ese día pueda sorprenderos, como el ladrón."
,"5":"Todos vosotros sois hijos de la luz e hijos del día; no sois hijos de la noche ni de las tinieblas."
,"6":"Por tanto, no nos echemos a dormir como los otros, sino estemos alerta y seamos sobrios."
,"7":"Porque los que duermen, de noche duermen; y los que se emborrachan, se emborrachan de noche."
,"8":"Por el contrario, nosotros, hijos del día, seamos sobrios; revistámonos de la coraza de la fe y del amor, cubriéndonos con el yelmo de la esperanza de la salvación."
,"9":"Dios no nos ha destinado al castigo, sino a la adquisición de la salvación por nuestro Señor Jesucristo,"
,"10":"que murió por nosotros para que, vivos o muertos, vivamos siempre con él."
,"11":"Por eso, animaos mutuamente y ayudaos los unos a los otros, como ya lo venís haciendo."
,"12":"Hermanos, os pedimos que tengáis consideración con los que trabajan entre vosotros y en el nombre del Señor os dirigen y amonestan."
,"13":"Corresponded a sus desvelos con amor siempre creciente. Vivid en paz entre vosotros."
,"14":"Hermanos, os pedimos también que corrijáis a los indisciplinados, que animéis a los cobardes, que sostengáis a los débiles y que seáis pacientes con todos."
,"15":"Procurad que nadie vuelva a otro mal por mal; tened siempre por meta el bien, tanto entre vosotros como para los demás."
,"16":"Estad siempre alegres."
,"17":"Orad sin cesar."
,"18":"Dad gracias en toda coyuntura, porque esto es lo que Dios quiere de todos vosotros en Cristo Jesús."
,"19":"No apaguéis el Espíritu."
,"20":"No despreciéis las profecías."
,"21":"Examinadlo todo, y quedaos con lo bueno."
,"22":"Evitad toda clase de mal."
,"23":"Que el Dios de la paz os santifique plenamente, y que todo vuestro ser, espíritu, alma y cuerpo, sea conservado irreprochablemente para la venida de nuestro Señor Jesucristo."
,"24":"El que os ha llamado es leal y cumplirá su palabra."
,"25":"Hermanos, rezad por nosotros."
,"26":"Saludad a todos los hermanos con el abrazo de la paz."
,"27":"Os conjuro por el Señor que hagáis leer esta carta a todos los hermanos."
,"28":"La gracia de nuestro Señor Jesucristo esté con todos vosotros."
}`)

}
func ES_LSB_LoadNP1IChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Pablo, apóstol de Cristo Jesús, por mandato de Dios, nuestro Salvador, y de Cristo Jesús, nuestra esperanza,"
,"2":"a Timoteo, verdadero hijo en la fe. Te deseo la gracia, la misericordia y la paz de Dios Padre y de Jesucristo, nuestro Señor."
,"3":"Al partir para Macedonia te rogué que permanecieras en Éfeso, con el fin de que ordenaras a algunos que no enseñen cosas extrañas"
,"4":"y no presten atención a fábulas y genealogías interminables, más aptas para promover discusiones que para la realización de los planes de Dios, que se fundan en la fe."
,"5":"El fin de esta recomendación es establecer el amor, que procede de un corazón puro, de una conciencia buena y de una fe sincera."
,"6":"Algunos se han desviado de todo esto y se han perdido en vanas palabrerías,"
,"7":"pretendiendo ser maestros de la ley, sin comprender ni lo que dicen ni lo que categóricamente afirman."
,"8":"Pues sabemos que la ley es buena si se hace de ella un legítimo uso,"
,"9":"conscientes de que la ley no es para el justo, sino para los malvados y los rebeldes, los criminales y los pecadores, los sacrílegos y los profanadores, los parricidas y los matricidas, los asesinos,"
,"10":"los lujuriosos, los homosexuales, los traficantes de esclavos, los mentirosos, los que juran en falso; en una palabra, para todo el que se opone a la sana doctrina"
,"11":"del glorioso evangelio que Dios bendito me ha confiado."
,"12":"Doy gracias a Cristo Jesús, Señor nuestro, que me ha fortalecido y me ha juzgado digno de confianza llamándome a su servicio"
,"13":"a mí, que fui antes un blasfemo y violento perseguidor de la Iglesia. Pero tuvo misericordia conmigo, porque, careciendo de fe, obré por ignorancia;"
,"14":"la gracia de nuestro Señor me colmó de fe y de amor cristiano."
,"15":"Esta doctrina es digna de crédito y debe ser aceptada sin reserva: que Cristo Jesús vino al mundo para salvar a los pecadores, el primero de los cuales soy yo."
,"16":"Por esto he obtenido yo misericordia, para que Jesucristo demostrase en mí su generosidad para ejemplo de los que por creer en él conseguirán la vida eterna."
,"17":"Al rey de los siglos, inmortal, invisible, único Dios, honor y gloria por los siglos de los siglos. Amén."
,"18":"Ésta es la recomendación que te hago, Timoteo, hijo mío, en conformidad con los augurios que anteriormente se hicieron sobre ti: apoyado en ellos libra el buen combate,"
,"19":"manténte firme en la fe, ten la conciencia limpia. Por despreocuparse de la conciencia, algunos naufragaron en la fe,"
,"20":"entre los que se encuentran Himeneo y Alejandro, a quienes entregué a Satanás para que aprendan a no blasfemar."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Te ruego, ante todo, que se hagan peticiones, oraciones, súplicas, acciones de gracias por todos los hombres,"
,"2":"por los reyes y por todos los que gozan de poder, a fin de que podamos disfrutar de una vida pacífica y tranquila con toda piedad y honestidad."
,"3":"Esto es bueno y agradable a Dios, nuestro Salvador,"
,"4":"el cual quiere que todos los hombres se salven y lleguen al conocimiento de la verdad."
,"5":"Porque hay un solo Dios y un solo mediador entre Dios y los hombres, Cristo Jesús, también él hombre,"
,"6":"que se entregó a sí mismo para liberarnos a todos; testimonio dado a su debido tiempo,"
,"7":"del que yo he sido nombrado pregonero y apóstol -digo verdad, no miento-, para instruir a los paganos en la fe y en la verdad."
,"8":"Quiero, pues, que los hombres oren en todo lugar levantando sus manos limpias, sin ira ni rencores."
,"9":"De la misma manera, que las mujeres se presenten vestidas con decencia, con recato y modestia, no con peinados llamativos, ni con oro, perlas o vestidos costosos,"
,"10":"sino como corresponde a mujeres que hacen profesión de piedad, con obras buenas."
,"11":"La mujer se debe dejar instruir en silencio con toda sumisión."
,"12":"No tolero que la mujer enseñe, ni que se tome autoridad sobre el marido; que esté callada,"
,"13":"pues Adán fue formado el primero, luego Eva."
,"14":"Y no fue Adán el engañado, sino Eva la que se dejó engañar y cayó en pecado."
,"15":"No obstante, se salvará por su condición de madre, si persevera con modestia en la fe, en el amor y en la santidad."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Esto es cierto: el que aspira al episcopado aspira a una noble tarea."
,"2":"Es necesario que el obispo sea intachable, casado una sola vez, sobrio, prudente, de porte educado, hospitalario, capaz de enseñar;"
,"3":"no debe emborracharse, ni ser amigo de peleas; debe ser ecuánime, pacífico y desinteresado;"
,"4":"que sepa gobernar bien su propia casa y hacer que sus hijos sean obedientes y respetuosos;"
,"5":"porque si uno no sabe gobernar su propia casa, ¿cómo podrá cuidar de la Iglesia de Dios?"
,"6":"Que no sea recién convertido, para que no le seduzca el orgullo y venga a caer en la condenación del diablo."
,"7":"Es también necesario que tenga buena fama ante los de fuera, para que no incurra en el descrédito y en los lazos del diablo."
,"8":"Asimismo, que los diáconos sean hombres dignos, formales, no aficionados a la bebida y a los negocios sucios."
,"9":"Que guarden las verdades de la fe con una conciencia limpia."
,"10":"Primero, que sean probados; y si son irreprochables, que ejerzan el ministerio del diaconado."
,"11":"Las mujeres, igualmente, que sean dignas, no chismosas, moderadas en la bebida, fieles en todo."
,"12":"Los diáconos sean casados una sola vez, que sepan gobernar bien a sus hijos y sus propias casas."
,"13":"Los que desempeñan bien su ministerio consiguen gran honor y mucha seguridad en la fe en Cristo Jesús."
,"14":"Aunque espero ir a verte pronto, te escribo estas cosas"
,"15":"por si tardo, para que sepas cómo has de conducirte en la casa de Dios, que es la Iglesia de Dios vivo, columna y fundamento de la verdad."
,"16":"Y sin duda alguna es grande el misterio de nuestra religión: 'Que se ha manifestado,como hombre, ha sido acreditado por el Espíritu, se ha mostrado a los ángeles, ha sido anunciado a las naciones, creído en el mundo, elevado a la gloria'."
}`)
	CurrentBook.AddChapter(4, `{
"1":"El Espíritu claramente dice que en los últimos tiempos algunos renegarán de la fe, dando oídos a espíritus seductores y enseñanzas diabólicas,"
,"2":"inducidos por la hipocresía de impostores, cuya conciencia se halla marcada al rojo vivo,"
,"3":"que prohíben el matrimonio y ciertos alimentos que Dios ha creado para que los creyentes y los que conocen la verdad los coman y den gracias a Dios por ello."
,"4":"Pues todo lo que Dios ha creado es bueno, y nada se debe rechazar, sino recibirlo con agradecimiento,"
,"5":"pues la palabra de Dios y la oración todo lo hace bueno."
,"6":"Serás buen ministro de Cristo Jesús si enseñas estas cosas a los hermanos, alimentando tu espíritu con las enseñanzas de la fe y de la buena doctrina, de que tan fiel discípulo te has mostrado."
,"7":"Rechaza las fábulas profanas, cuentos de viejas. Ejercítate en las prácticas religiosas,"
,"8":"pues los ejercicios corporales son útiles para bien poco, mientras que la religión es útil para todo, pues tiene promesas para la vida presente y para la futura."
,"9":"Esta doctrina es digna de crédito y debe aceptarse sin reservas."
,"10":"Por esto nos esforzamos y luchamos, porque tenemos puesta nuestra esperanza en Dios vivo, que es el Salvador de todos los hombres, sobre todo de los creyentes."
,"11":"Estas cosas has de recomendar y enseñar."
,"12":"Que nadie te menosprecie por ser joven; debes ser, más bien, ejemplo para los creyentes, en el modo de hablar, en el comportamiento, en el amor, en la fe, en la honestidad."
,"13":"Mientras llego, aplícate a la lectura, a la exhortación, a la enseñanza."
,"14":"No descuides el carisma que has recibido y que se te confirió en virtud del Espíritu, cuando te impusieron las manos los presbíteros de la Iglesia."
,"15":"Pon tu atención en estas cosas, entrégate de lleno a ellas, para que todos vean tus progresos."
,"16":"Cuida de ti mismo y de lo que enseñas. Persevera en estas cosas. Si lo haces así, te salvarás a ti y a los que te escuchan."
}`)
	CurrentBook.AddChapter(5, `{
"1":"No reprendas con dureza al anciano, sino más bien exhórtalo como a un padre; a los jóvenes, como a hermanos;"
,"2":"a las ancianas, como a madres; a las jóvenes, como a hermanas, con toda pureza."
,"3":"Ayuda a las viudas que lo sean de verdad."
,"4":"Si la viuda tiene hijos o nietos, ellos, antes que nadie, son los que deben cuidar de su propia familia y de recompensar a sus progenitores por los beneficios que han recibido de ellos, pues esto es lo que Dios quiere."
,"5":"La verdaderamente viuda y desamparada tiene puesta su esperanza en Dios y persevera día y noche en las plegarias y en las oraciones."
,"6":"Pero la que lleva una vida alegre, viviendo está muerta."
,"7":"Inculca estas cosas, para que sean irreprochables."
,"8":"El que no se preocupa de los suyos, y especialmente de los de su casa, ha renegado de su fe y es peor que un incrédulo."
,"9":"Para ser inscrita en el grupo de las viudas, ha de tener por lo menos sesenta años, haberse casado una sola vez"
,"10":"y estar acreditada por sus buenas obras, tales como haber educado bien a sus hijos, haber ejercitado la hospitalidad, haber lavado los pies a los creyentes, haber socorrido a los atribulados, haber practicado toda clase de obra buena."
,"11":"Descarta, en cambio, a las viudas jóvenes; porque en cuanto los deseos del placer las apartan de Cristo, quieren casarse de nuevo"
,"12":"y se hacen culpables por no haber sido fieles a su primer compromiso."
,"13":"Además se dedican a ir de casa en casa sin hacer nada; no sólo no hacen nada, sino que se dedican al chismorreo y a curiosearlo todo, hablando de lo que no deben."
,"14":"Por eso quiero que las viudas jóvenes se vuelvan a casar, que tengan hijos, que gobiernen su casa y que no den motivos de crítica a los adversarios,"
,"15":"pues algunas ya se han extraviado yendo en pos de Satanás."
,"16":"Si alguna mujer tiene viudas en su familia, que procure socorrerlas y no cargue con ellas a la Iglesia, con el fin de que ésta pueda atender a las verdaderamente viudas."
,"17":"Los presbíteros que cumplen bien su misión son merecedores de una doble remuneración, especialmente los que se ocupan de la predicación y la enseñanza."
,"18":"Pues dice la Escritura: No pondrás bozal al buey que trilla y el obrero merece su salario."
,"19":"No admitas acusación alguna contra un presbítero, si no está sostenida por dos o tres testigos."
,"20":"Reprende públicamente a los que no cumplen con su obligación, para que sirva de escarmiento a los demás."
,"21":"Yo te conjuro ante Dios, ante Cristo Jesús y ante los ángeles elegidos, que observes estas cosas imparcialmente, sin dejarte llevar de favoritismos."
,"22":"No impongas a nadie las manos sin haberlo pensado muy bien; no te hagas cómplice de los pecados ajenos. Consérvate honesto."
,"23":"No bebas agua sola, mézclala con un poco de vino, por tu mal de estómago y tus frecuentes indisposiciones."
,"24":"Los delitos de algunos hombres son conocidos aun antes del juicio; los de otros, sólo con ocasión de él."
,"25":"Lo mismo ocurre con las obras buenas: unas son manifiestas, y las que no lo son no podrán permanecer ocultas."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Los que se encuentran bajo el yugo de la esclavitud, que miren a sus propios amos como dignos de todo respeto, para que el nombre de Dios y su doctrina no sean blasfemados."
,"2":"Los que tienen amos creyentes, que no les falten al respeto por ser hermanos en la fe; al contrario, sírvanles mejor, puesto que los que reciben sus servicios son creyentes y hermanos muy queridos. Esto es lo que has de enseñar e inculcar."
,"3":"Si alguno enseña cosas distintas y no admite la enseñanza salvadora de nuestro Señor Jesucristo y la doctrina de nuestra religión,"
,"4":"es un orgulloso que no sabe nada; que desvaría en discusiones y palabrerías, de donde provienen envidias, riñas, insultos, desconfianzas,"
,"5":"conflictos interminables, propios de personas obcecadas e ignorantes, que piensan que la religión es un negocio;"
,"6":"y ciertamente lo es, pero para el que se contenta con lo necesario."
,"7":"Nada hemos traído a este mundo, y nada nos llevaremos de él."
,"8":"Debemos contentarnos con tener lo suficiente para comer y vestir."
,"9":"Pues los que quieren enriquecerse caen en la tentación y en la trampa de deseos insensatos y funestos que hunden a los hombres en la ruina y en la perdición."
,"10":"Porque el amor al dinero es la raíz de todos los males. Algunos, arrastrados por ese amor al dinero, se han apartado de la fe y están atormentados por muchos remordimientos."
,"11":"Pero tú, hombre de Dios, huye de estas cosas, y practica la justicia, la religiosidad, la fe, el amor, la paciencia, la amabilidad."
,"12":"Sostén el noble combate de la fe, conquista la vida eterna, para la cual fuiste llamado y de la que hiciste hermosa confesión ante muchos testigos."
,"13":"Delante de Dios, que da vida a todas las cosas, y de Cristo Jesús, que dio testimonio de la verdad ante Poncio Pilato, te pido"
,"14":"que guardes el mandamiento sin mancha y sin reproche hasta la manifestación de nuestro Señor Jesucristo,"
,"15":"manifestación que, a su debido tiempo, llevará a cabo el bienaventurado y único Soberano, Rey de reyes y Señor de los señores,"
,"16":"el único que posee la inmortalidad, que habita una luz inaccesible, a quien ningún hombre vio ni puede ver. A él, honor y poder eterno. Amén."
,"17":"A los ricos de este mundo recomiéndales que no sean orgullosos y que no pongan su esperanza en las riquezas caducas, sino en Dios, que nos provee abundantemente de todas las cosas para que disfrutemos de ellas;"
,"18":"que hagan el bien, que sean ricos en buenas obras; que sean generosos y estén dispuestos a repartir con los demás lo que tienen."
,"19":"Así reunirán un capital sólido para el futuro, con el que conseguirán la verdadera vida."
,"20":"Timoteo, guarda el depósito de la fe que te ha sido confiado. No hagas caso de la estéril y mundana palabrería ni de las contradicciones de una falsa ciencia."
,"21":"Algunos, por hacer caso de ella, han perdido la fe. La gracia esté con vosotros."
}`)

}
func ES_LSB_LoadNP2CChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Pablo, apóstol de Jesucristo por voluntad de Dios, y el hermano Timoteo, a la Iglesia de Dios que hay en Corinto, y a todos los creyentes de la región de Acaya;"
,"2":"os deseo la gracia y la paz de Dios, nuestro Padre, y de Jesucristo, el Señor."
,"3":"Bendito sea Dios y Padre de nuestro Señor Jesucristo, padre de las misericordias y de todo consuelo,"
,"4":"que nos consuela en todos nuestros sufrimientos para que nosotros podamos consolar a todos los que sufren con el consuelo que nosotros mismos recibimos de Dios."
,"5":"Pues si participamos grandemente en los sufrimientos de Cristo, también gracias a Cristo recibimos un gran consuelo."
,"6":"Si tenemos que sufrir, es para vuestro consuelo y salvación. Si somos consolados, es para que vosotros también lo seáis y tengáis ánimos para soportar con paciencia los sufrimientos que nosotros pasamos."
,"7":"Tenemos en vosotros una esperanza firme, convencidos de que, como participáis en los sufrimientos, participaréis también en el consuelo."
,"8":"Hermanos, no queremos que ignoréis las grandes dificultades que encontramos en Asia. Fue tan dura la prueba y tan por encima de nuestras fuerzas, que perdimos toda esperanza de seguir viviendo."
,"9":"Tuvimos como segura la sentencia de muerte, para que no confiemos en nosotros mismos, sino en Dios, que resucitará a los muertos."
,"10":"Él es quien nos libró de aquel peligro mortal y nos seguirá librando. Esperamos que lo siga haciendo en adelante"
,"11":"con la ayuda de vuestra oración; si muchos piden a Dios por nosotros, muchos le darán gracias por los favores que nos concede."
,"12":"Nos sentimos orgullosos de que nuestra conciencia nos asegure que nos hemos comportado con todo el mundo, y especialmente con vosotros, con la sencillez y la sinceridad que Dios da, y no por la sabiduría humana, sino por la gracia de Dios."
,"13":"En mis cartas sólo hay lo que leéis y entendéis, y espero que entendáis plenamente"
,"14":"lo que ya en parte habéis entendido, que en el día de Jesús nuestro Señor vosotros estaréis orgullosos de nosotros y nosotros lo estaremos de vosotros."
,"15":"Convencido de esto, quise empezar mi viaje por vosotros para haceros una doble visita:"
,"16":"ir a Macedonia pasando por Corinto, y de Macedonia volver a Corinto para que vosotros me ayudéis a proseguir mi viaje a Judea."
,"17":"¿Obré a la ligera al hacer este proyecto? ¿O fue un proyecto hecho por interés humano, como de quien dice a la vez 'sí' y 'no'?"
,"18":"Dios es testigo de que no os decimos 'sí' y 'no' al mismo tiempo."
,"19":"Porque el Hijo de Dios, Jesucristo, a quien os hemos predicado Silvano, Timoteo y yo, no fue 'sí' y 'no', sino que fue 'sí'."
,"20":"Pues todas las promesas de Dios se cumplieron en él. Por eso, cuando glorificamos a Dios, decimos 'amén' por Jesucristo."
,"21":"Dios es el que a nosotros y a vosotros nos mantiene firmes en Cristo y nos ha consagrado."
,"22":"Él nos ha marcado con su sello y ha puesto en nuestros corazones el Espíritu como prenda de salvación."
,"23":"Pongo a Dios por testigo, y que me muera si miento, de que no he vuelto a Corinto por consideración a vosotros;"
,"24":"no porque quiera controlar autoritariamente vuestra fe, pues os mantenéis firmes en ella, sino para contribuir a vuestra alegría."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Por eso decidí no ir a causaros tristeza."
,"2":"Porque si yo os entristezco, ¿quién podría alegrarme sino vosotros a los que yo mismo causé tristeza?"
,"3":"Por eso os escribí, para que cuando llegue no me causéis tristeza los que debéis alegrarme. Estoy, además, convencido de que mi alegría es también la vuestra."
,"4":"Os escribí esa carta profundamente acongojado y angustiado, y hasta con lágrimas en los ojos, no para causaros tristeza, sino para manifestaros el amor tan grande que os tengo."
,"5":"Pues bien, si alguno ha causado tristeza, no sólo me la ha causado a mí, sino -en cierto modo, para no exagerar- a todos vosotros."
,"6":"A ése ya le basta con el castigo que le ha impuesto la mayoría."
,"7":"De modo que ahora debéis más bien perdonarle y consolarle, no sea que se desespere de tanta tristeza."
,"8":"Por esto os suplico que le deis pruebas de vuestro amor."
,"9":"Con este fin os escribí: para conocer y probar si sois obedientes en todo."
,"10":"Al que perdonáis, yo también lo perdono; lo que yo perdono, si es que tengo algo que perdonar, lo perdono por amor a vosotros y en la presencia de Cristo;"
,"11":"para que Satanás no se aproveche de todo, pues no ignoramos sus astucias."
,"12":"Llegué a Tróade para anunciar el evangelio de Cristo; y, aunque se me presentó una ocasión propicia para trabajar por el Señor,"
,"13":"mi corazón no estaba tranquilo por no haber encontrado a Tito, mi hermano. Me despedí de ellos, y partí para Macedonia."
,"14":"Gracias sean dadas a Dios, que siempre nos hace triunfar en Cristo y descubre en todo lugar, mediante nosotros, la fragancia de su conocimiento."
,"15":"Porque somos el perfume que Cristo ofrece a Dios, tanto para los que se salvan como para los que se pierden:"
,"16":"para éstos, olor de muerte que mata; para aquéllos, olor de vida que da vida. ¿Y quién está a la altura de tal misión?"
,"17":"Nosotros no hacemos negocio con la palabra de Dios, como hacen muchos, sino que la predicamos con sinceridad, de parte de Dios, en presencia de Dios, en unión con Cristo."
}`)
	CurrentBook.AddChapter(3, `{
"1":"¿Estoy comenzando a recomendarme de nuevo? ¿O es que necesito, como algunos, cartas de recomendación para vosotros o de vosotros?"
,"2":"Mi carta sois vosotros, carta escrita en nuestros corazones, conocida y leída por todos los hombres;"
,"3":"pues es claro que vosotros sois una carta de Cristo redactada por mí y escrita, no con tinta, sino con el Espíritu de Dios vivo; no en tablas de piedra, sino en las tablas de carne, en vuestros corazones."
,"4":"Tal es la confianza que, gracias a Cristo, tenemos ante Dios."
,"5":"No es que sea capaz por mí mismo de hacer algo como cosa mía, pues mi capacidad viene de Dios,"
,"6":"que me ha capacitado para ser ministro de la nueva alianza; no de la letra, sino del espíritu, pues la letra mata, pero el espíritu da vida."
,"7":"Y si el ministerio de muerte, grabado en letras sobre piedras, fue glorioso hasta el punto que los israelitas no podían mirar fijamente al rostro de Moisés a causa del resplandor, que era pasajero,"
,"8":"¡cuánto más glorioso no será el ministerio del espíritu!"
,"9":"Si el ministerio de condenación fue glorioso, mucho más lo será el ministerio de salvación."
,"10":"Más aún; lo que bajo este aspecto fue glorioso en aquel ministerio ni siquiera merece tenerse en cuenta comparado con esta gloria soberana del evangelio."
,"11":"Pues si lo pasajero fue glorioso, mucho más lo será lo permanente."
,"12":"Teniendo tal esperanza, procedamos con entera libertad;"
,"13":"y no como Moisés, que se tapaba la cara con un velo para que los israelitas no se fijasen en su resplandor, que era pasajero."
,"14":"Pero sus entendimientos se embotaron, y aquel velo permanece de tal modo que les impide comprender el Antiguo Testamento, y no se dan cuenta de que Cristo ha descorrido ya el velo."
,"15":"Hasta hoy, siempre que leen a Moisés, el velo nubla su mente."
,"16":"Pero cuando se conviertan al Señor, desaparecerá el velo."
,"17":"El Señor es Espíritu; y donde está el Espíritu del Señor, allí hay libertad."
,"18":"Y todos nosotros, con la cara descubierta, reflejando como en un espejo la gloria del Señor, nos transformamos en su misma imagen, resultando siempre más gloriosos, bajo el influjo del Espíritu del Señor."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Por eso, teniendo este ministerio por la misericordia de Dios, no nos desanimamos."
,"2":"Rechazamos la desvergüenza y la hipocresía, no procedemos con astucia ni falsificamos la palabra de Dios. Decimos siempre la verdad, y esto es nuestra recomendación a toda conciencia humana delante de Dios."
,"3":"Si todavía queda encubierto nuestro evangelio, lo es para los que se pierden,"
,"4":"para los incrédulos, cuyas inteligencias cegó el dios de este siglo para que no brille el resplandor del evangelio de la gloria de Cristo, que es imagen de Dios."
,"5":"Porque no nos predicamos a nosotros mismos, sino a Jesucristo, el Señor; nosotros somos vuestros siervos por amor de Jesús."
,"6":"Pues el mismo Dios, que dijo: Brille la luz de entre las tinieblas, iluminó nuestros corazones para que brille el conocimiento de la gloria de Dios, reflejada en el rostro de Cristo."
,"7":"Pero llevamos este tesoro en vasijas de barro, para que aparezca claro que esta pujanza extraordinaria viene de Dios y no de nosotros."
,"8":"Estamos acosados por todas partes, pero no derrotados; perplejos, pero no desesperados;"
,"9":"perseguidos, pero no abandonados; desechados, pero no aniquilados;"
,"10":"llevamos siempre y por doquier en el cuerpo los sufrimientos de muerte de Jesús, para que la vida de Jesús se manifieste también en nosotros."
,"11":"Porque, viviendo, estamos siempre expuestos a la muerte por causa de Jesús, para que la vida de Jesús se manifieste también en nuestra carne mortal."
,"12":"Así que la muerte actúa en nosotros, pero en vosotros la vida."
,"13":"Sin embargo, teniendo el mismo espíritu de fe, según lo que dice la Escritura: Creí, por eso hablé, también nosotros creemos y por eso hablamos;"
,"14":"convencidos de que quien resucitó a Jesús, el Señor, también nos resucitará a nosotros con Jesús, y nos dará un puesto con él en vuestra compañía."
,"15":"Porque todo es por vosotros, para que la gracia, cada vez más abundante, multiplique la acción de gracias para gloria de Dios."
,"16":"Por esto no desfallecemos, pues aunque nuestro hombre exterior vaya perdiendo, nuestro hombre interior se renueva de día en día."
,"17":"Pues el peso momentáneo y ligero de nuestras penalidades produce, sobre toda medida, un peso eterno de gloria"
,"18":"para los que no miramos las cosas que se ven, sino las que no se ven; pues las visibles son temporales, las invisibles eternas."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Sabemos que si esta tienda en que habitamos en la tierra se destruye, tenemos otra casa, que es obra de Dios; una morada eterna en los cielos, no construida por mano de hombres."
,"2":"Por esto gemimos en el estado actual, deseando ardientemente ser revestidos de nuestra morada celestial,"
,"3":"supuesto que seamos hallados vestidos y no desnudos."
,"4":"Mientras estamos en esta tienda gemimos oprimidos, ya que no queremos ser desnudados, sino ser revestidos, para que la mortalidad sea absorbida por la vida."
,"5":"El que nos ha hecho para este destino es Dios, y como garantía nos ha dado su Espíritu."
,"6":"Estamos siempre confiados, sabiendo que, mientras habitamos en el cuerpo, caminamos lejos del Señor,"
,"7":"porque caminamos en fe y no en clara visión."
,"8":"Pero estamos seguros, y preferimos salir de este cuerpo para vivir junto al Señor."
,"9":"Por eso, en el cuerpo o fuera del cuerpo, nos esforzamos por agradar al Señor,"
,"10":"pues todos debemos comparecer ante el tribunal de Cristo, para que cada cual reciba lo que mereció durante su vida mortal, conforme a lo que hizo, bueno o malo."
,"11":"Sabiendo que debemos respetar al Señor, tratamos de convencer a los hombres, pues somos bien conocidos de Dios, y espero que lo seamos también de vuestras conciencias."
,"12":"No intentamos recomendarnos de nuevo, sino daos ocasión de que os sintáis orgullosos de nosotros, para que podáis responder a los que lo hacen externamente, pero no de corazón."
,"13":"Pues si hemos perdido el juicio, es por Dios; si somos cuerdos, es por vosotros."
,"14":"Porque el amor de Cristo nos apremia, pensando que si uno murió por todos, todos murieron con él;"
,"15":"y murió por todos, para que los que viven no vivan para sí, sino para quien murió y resucitó por ellos."
,"16":"Así que en adelante a nadie conoceremos a lo humano; y si un tiempo conocimos a Cristo a lo humano, ahora ya no lo conocemos así."
,"17":"De modo que, el que está en Cristo, es una criatura nueva; lo viejo ya pasó, y ha aparecido lo nuevo."
,"18":"Todo viene de Dios, que nos reconcilió con él por medio de Cristo, y nos confió el ministerio de la reconciliación."
,"19":"Pues Dios, por medio de Cristo, estaba reconciliando el mundo, no teniendo en cuenta sus pecados y haciéndonos a nosotros depositarios de la palabra de la reconciliación."
,"20":"Somos, pues, embajadores de Cristo, como si Dios exhortase por nosotros. En nombre de Cristo os rogamos: reconciliaos con Dios."
,"21":"Al que no conoció pecado, le hizo pecado en lugar nuestro, para que nosotros seamos en él justicia de Dios."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Siendo, pues, colaboradores, os exhortamos a no recibir en vano la gracia de Dios."
,"2":"Porque él dice: En el tiempo propicio te escuché y en el día de la salvación te ayudé. Ahora es el tiempo propicio, ahora es el día de la salvación."
,"3":"En nada damos motivo de escándalo, para que no sea desacreditado nuestro ministerio,"
,"4":"sino que en todo nos mostramos como ministros de Dios, con gran paciencia en sufrimientos, estrecheces, angustias,"
,"5":"golpes, cárceles, motines, fatigas, noches sin dormir y días sin comer,"
,"6":"castidad, ciencia, paciencia, bondad, Espíritu Santo, amor sincero;"
,"7":"con la palabra de verdad, con el poder de Dios; mediante las armas ofensivas y defensivas de la justicia;"
,"8":"en medio de gloria y de ignominia, de calumnia y buena fama; como impostores, aunque veraces;"
,"9":"como desconocidos, aunque conocidos; como moribundos, aunque estamos vivos; como castigados, aunque sin ser condenados a la muerte;"
,"10":"como tristes, aunque siempre alegres; como miserables, aunque enriquecemos a muchos; como quienes nada tienen, aunque lo poseemos todo."
,"11":"Corintios, me he desahogado con vosotros y mi corazón se me ha ensanchado."
,"12":"Yo no tengo reservas con vosotros; sois vosotros los que las tenéis conmigo."
,"13":"Pagadme con la misma moneda. Os digo como a hijos: ensanchad también vuestro corazón."
,"14":"No os mezcléis con los paganos; pues, ¿qué tiene que ver la justicia con la injusticia, y qué tienen de común la luz y las tinieblas?"
,"15":"¿Qué armonía hay entre Cristo y Belial, o qué parte tiene el fiel con el pagano?"
,"16":"¿Qué relación hay entre el templo de Dios y los ídolos? Porque nosotros somos templos del Dios vivo. Como dijo Dios: Habitaré y caminaré en medio de ellos, yo seré su Dios y ellos serán mi pueblo."
,"17":"Por esto: Salid y separaos de ellos -dice el Señor-; no toquéis nada impuro, y yo os recibiré;"
,"18":"seré para vosotros Padre, y vosotros seréis para mí hijos e hijas, dice el Señor todopoderoso."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Hermanos míos, ya que tenemos estas promesas, purifiquémonos de todo lo que mancha el cuerpo o el espíritu, perfeccionando nuestra consagración en el temor de Dios."
,"2":"Escuchadme. A nadie hemos hecho daño, a nadie hemos arruinado, a nadie hemos explotado."
,"3":"No lo digo para condenaros, pues acabo de decir que, para muerte o para vida, os tengo dentro de mi corazón."
,"4":"Tengo gran confianza en vosotros, me siento orgulloso de vosotros, estoy lleno de consuelo y de alegría en medio de todas mis penalidades."
,"5":"Cuando llegué a Macedonia tampoco pude estar tranquilo; encontré dificultades por todas partes; por fuera conflictos, por dentro temores."
,"6":"Pero Dios, que consuela a los afligidos, nos consoló con la llegada de Tito."
,"7":"Y no sólo con su llegada, sino con el ánimo que vosotros le habíais infundido; me habló de vuestro deseo de verme, de vuestras lágrimas, de vuestro interés por mí; así que me alegré mucho."
,"8":"Pues aunque os entristecí con la carta, no me arrepiento. Y si antes me pesó, viendo que aquella carta os entristeció, aunque por breve tiempo,"
,"9":"ahora me alegro; no porque os entristecisteis, sino porque esa tristeza sirvió para vuestro arrepentimiento. Como fue una tristeza querida por Dios, no os hice ningún daño."
,"10":"La tristeza querida por Dios produce un arrepentimiento salvador, de la que no hay que lamentarse, mientras que la tristeza producida por el mundo engendra la muerte."
,"11":"Considerad lo que esa tristeza querida por Dios ha producido en vosotros: qué solicitud, qué disculpas, qué indignación, qué temor, qué deseos, qué emulación, qué escarmiento. Demostrasteis ser totalmente inocentes en este asunto."
,"12":"Así pues, si os escribí no fue por el que causó la ofensa ni por el ofendido, sino para que manifestaseis vuestro interés por nosotros delante de Dios."
,"13":"Esto nos ha llenado de consuelo. Y mucho más que por el consuelo que hemos recibido, nos hemos alegrado al ver a Tito tan contento por lo bien que le habéis tratado y por los ánimos que le habéis dado."
,"14":"Y si a él le dije que estaba orgulloso de vosotros, no me habéis dejado en mal lugar; pues así como es verdad todo lo que os dije a vosotros, también lo es lo que le dije a él: que estoy orgulloso de vosotros."
,"15":"Él os ha cobrado más cariño al ver cómo le obedecisteis y con qué respeto le tratasteis."
,"16":"Me alegro de poder confiar plenamente en vosotros."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Hermanos, quiero daros a conocer la gracia que Dios ha concedido a las iglesias de Macedonia."
,"2":"En medio de las pruebas con que son probadas, tienen una grande alegría, y a pesar de su extrema pobreza han sido muy generosos."
,"3":"Puedo asegurar que dieron lo que podían, y más aún de lo que podían."
,"4":"Espontáneamente y con mucha insistencia me pidieron el favor de colaborar en esta ayuda a los hermanos."
,"5":"Dieron más de lo que yo esperaba; incluso ofrecieron sus personas, primero al Señor y luego a mí, conforme a la voluntad de Dios,"
,"6":"hasta el punto que he pedido a Tito, que ya que había comenzado, que termine entre vosotros esta obra de caridad."
,"7":"Sobresalís en todo: en fe, en elocuencia, en ciencia, en vuestra preocupación por todo y en vuestro amor para conmigo; sobresalid también en esta obra de caridad."
,"8":"Esto no es una orden; os hablo de la buena disposición de otros para poner a prueba la sinceridad de vuestro amor."
,"9":"Vosotros ya conocéis la generosidad de nuestro Señor Jesucristo, el cual siendo rico se hizo pobre por vosotros para enriqueceros con su pobreza."
,"10":"Os doy mi opinión: ya que el año pasado os decidisteis a realizar esta obra y empezasteis a hacerla,"
,"11":"os conviene terminarla según las posibilidades de cada uno y con el mismo entusiasmo que demostrasteis al proyectarla."
,"12":"Cuando se da de corazón y según lo que se tiene, Dios lo acepta; a nadie se le piden imposibles."
,"13":"No se trata de que vosotros paséis estrecheces para que otros vivan holgadamente; se trata de que haya igualdad para todos."
,"14":"Por eso, ahora vuestra abundancia debe socorrer su pobreza, y un día su abundancia socorrerá vuestra pobreza. Y así reinará la igualdad,"
,"15":"como dice la Escritura: Al que tenía mucho no le sobraba y al que tenía poco no le faltaba."
,"16":"Gracias a Dios, que ha suscitado en Tito mi misma preocupación por vosotros,"
,"17":"pues ha respondido a mi petición y se ha puesto rápidamente en camino hacia vosotros por su propia iniciativa."
,"18":"Con él envío al hermano de quien todas las iglesias hacen grandes elogios por todo lo que ha hecho por el evangelio;"
,"19":"además fue elegido por las iglesias como compañero de nuestro viaje para esta obra de caridad, a la que nos consagramos para gloria del Señor y en prueba de nuestra buena voluntad."
,"20":"Así queremos evitar que nadie pueda reprocharos nada a causa de esta gran suma que hemos recogido;"
,"21":"pues procuramos hacerlo bien no sólo ante Dios, sino también ante los hombres."
,"22":"Os envío con ellos a uno de nuestros hermanos, cuya entrega he podido comprobar muchas veces y en diversas ocasiones, y mucho más ahora, por la gran confianza que tiene en vosotros."
,"23":"En cuanto a Tito, es compañero y colaborador mío entre vosotros; los otros hermanos son delegados de las iglesias y gloria de Cristo."
,"24":"Dadle pruebas de vuestro amor y demostradle ante las iglesias que tengo razón fundada para sentirme orgulloso de vosotros."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Sobre esta colecta para nuestros hermanos no hace falta decir más,"
,"2":"pues conozco vuestra buena voluntad, de la que me siento orgulloso ante los macedonios. Les he dicho que los de Acaya están dispuestos desde el año pasado, y esta buena disposición vuestra ha sido un estímulo para la mayoría."
,"3":"Os envío a los hermanos para que lo que he presumido de vosotros no quede desmentido y para que estéis preparados,"
,"4":"pues si van los macedonios y se encuentran con que no estáis preparados, sería una vergüenza para mí, y sobre todo para vosotros."
,"5":"Por eso he creído necesario pedir a los hermanos que vayan por delante y preparen vuestro donativo generoso, que habéis prometido. Así vuestra colecta será una muestra de generosidad, y no de tacañería."
,"6":"Pensad: el que siembra con mezquindad, con mezquindad cosechará; y el que siembra con abundancia cosechará abundantemente."
,"7":"Que cada uno dé lo que le dicte la conciencia; no de mala gana o por compromiso, pues Dios ama a quien da con alegría."
,"8":"Y Dios puede volcar sus gracias sobre vosotros, para que, teniendo siempre lo suficiente en todo, crezcáis en toda obra buena."
,"9":"Como dice la Escritura: Ha repartido con generosidad a los pobres; su justicia permanece para siempre."
,"10":"El que provee simiente al que siembra y pan para comer, proveerá y multiplicará vuestros sembrados y aumentará los frutos de vuestra justicia."
,"11":"Siendo ricos en todo, podréis ejercitar abundantemente vuestra generosidad, lo que, por mediación mía, hará que los hermanos den gracias a Dios."
,"12":"Porque al llevar esta ayuda a los hermanos no sólo les remediamos en sus necesidades, sino que también los impulsamos a que den gracias a Dios."
,"13":"Al darles esta ayuda, ellos alabarán a Dios, pues comprueban que obedecéis al evangelio de Cristo, ya que demostráis tener una generosa solidaridad con ellos y con todos."
,"14":"Ellos pedirán por vosotros con mucho cariño por tantas gracias como Dios os ha dado."
,"15":"Gracias sean dadas a Dios por este don indecible que nos ha hecho."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Yo mismo, Pablo, os lo pido por la ternura y la bondad de Cristo; yo, tan tímido cuando estoy entre vosotros y tan valiente cuando estoy lejos."
,"2":"Os ruego que no me obliguéis cuando esté con vosotros a dar pruebas de esta valentía, de la que estoy dispuesto a usar contra los que piensan que procedo por motivos puramente humanos;"
,"3":"soy humano, pero no lucho por motivos humanos;"
,"4":"las armas con que lucho no son humanas, sino divinas; capaces de destruir fortalezas, de deshacer las acusaciones"
,"5":"y toda altanería que se levante contra el conocimiento de Dios, de someter todo entendimiento a la voluntad de Cristo,"
,"6":"y dispuestos a castigar cualquier desobediencia, una vez que vuestra obediencia sea perfecta."
,"7":"Sólo os fijáis en las apariencias. Si alguno se precia de ser de Cristo, piense que yo lo soy tanto como él;"
,"8":"y si yo presumo algo más de la cuenta del poder que el Señor me ha dado para vuestro provecho y no para vuestra ruina, no me arrepiento de ello."
,"9":"Para que no parezca que quiero amedrentaros con mis cartas -"
,"10":"porque dicen que mis cartas son duras y fuertes, pero que mi presencia corporal es muy poca cosa y mi palabra lamentable-,"
,"11":"piense ese individuo que lo que digo de lejos por carta soy capaz de llevarlo a la práctica cuando esté con vosotros."
,"12":"Ciertamente, no me atrevo a igualarme ni a compararme con algunos que se alaban a sí mismos; pues, midiéndose y comparándose consigo mismos, demuestran poca inteligencia."
,"13":"Sin embargo, yo no quiero presumir demasiado; me quedo en los límites del campo de acción que Dios me ha señalado al permitirme llegar hasta vosotros."
,"14":"No traspasamos los límites debidos, como si no hubiéramos llegado a vosotros, pues hasta vosotros hemos llegado con el evangelio de Cristo."
,"15":"No presumo indebidamente de trabajos ajenos; espero que con el progreso de vuestra fe aumentará nuestro trabajo entre nosotros, aunque dentro de los límites que Dios nos ha señalado;"
,"16":"esperamos anunciar el evangelio a regiones más allá de las vuestras, pero sin invadir campos ajenos, para no presumir de trabajos que han hecho otros;"
,"17":"pues el que quiera presumir de algo, que presuma de lo que ha hecho en el Señor."
,"18":"Porque no es digno de aprobación el que se alaba a sí mismo, sino aquel a quien Dios alaba."
}`)
	CurrentBook.AddChapter(11, `{
"1":"¡Ojalá me toleraseis un poco mi desatino! Sí, soportádmelo."
,"2":"Tengo celos divinos de vosotros, porque os he desposado con un solo marido, os he presentado a Cristo como una virgen pura."
,"3":"Pero temo que, como la serpiente engañó con su astucia a Eva, pervierta también vuestros pensamientos y os apartéis de la fidelidad y de la consagración a Cristo."
,"4":"Porque si alguno viene a predicaros otro Jesucristo diferente del que yo os he predicado, o si recibís otro Espíritu diferente del que habéis recibido, u otro evangelio que el que abrazasteis, lo aceptáis con gusto."
,"5":"Pero yo creo que en nada soy inferior a esos eminentes apóstoles."
,"6":"Y si soy torpe de palabra, no lo soy de ciencia; que en todo y de todas las maneras lo hemos probado ante vosotros."
,"7":"¿Acaso cometí un pecado porque me humillé a mí mismo para ensalzaros a vosotros, predicándoos de balde el evangelio de Dios?"
,"8":"He aceptado dinero de otras iglesias, con la impresión de que les estaba explotando, para estar a vuestro servicio."
,"9":"Cuando estaba entre vosotros y necesité algo no fui carga para nadie, pues remediaron mi necesidad los hermanos llegados de Macedonia; me guardé muy bien y me seguiré guardando de ser carga para nadie."
,"10":"Tan cierto como la verdad de Cristo, que poseo, que nadie en la región de Acaya me quitará esta honra."
,"11":"¿Por qué? ¿Porque no os quiero? Dios sabe lo que os quiero."
,"12":"Y lo que hago, lo seguiré haciendo, para cortar todo pretexto a los que buscan ocasión para presumir de ser como yo."
,"13":"Éstos son falsos apóstoles, obreros engañosos, que se disfrazan de apóstoles de Cristo."
,"14":"Lo cual no es de extrañar, pues también Satanás se disfraza de ángel de luz."
,"15":"No es, por tanto, de extrañar que sus ministros se disfracen de ministros de justicia; pero su fin será conforme a sus obras."
,"16":"Lo repito: Nadie me tome por loco; y si no, aunque sea como loco, recibidme para que presuma también yo un poco."
,"17":"Lo que voy a decir, no lo diré inspirado por el Señor, sino como un ataque de locura, en la seguridad de que tengo también de qué presumir."
,"18":"Si muchos presumen de méritos humanos, yo también voy a presumir de lo mismo."
,"19":"Vosotros, tan sensatos, soportáis con mucho gusto a los insensatos."
,"20":"De hecho, si alguno os esclaviza, os explota, os engaña, os trata con soberbia, os abofetea, todo lo aguantáis."
,"21":"Me da vergüenza decirlo: todo esto hace creer que me he portado con demasiada debilidad con vosotros. Pero de lo que otro se atreva a presumir -hablo a lo loco-, también yo."
,"22":"¿Son hebreos? También yo. ¿Son israelitas? También yo. ¿Del linaje de Abrahán? También yo."
,"23":"¿Son ministros de Cristo? Voy a decir una locura: yo mucho más que ellos. Más en trabajos, más en prisiones; en palizas, inmensamente más; en peligros de muerte, muchas veces."
,"24":"Cinco veces recibí de los judíos los treinta y nueve latigazos,"
,"25":"tres veces fui azotado con varas, una vez apedreado, naufragué tres veces, he pasado en los abismos del mar un día y una noche;"
,"26":"incontables viajes con peligros de ríos, peligros de salteadores, peligros de los de mi raza, peligros de los paganos, peligros en la ciudad, peligros en los desiertos, peligros en el mar, peligros de los falsos hermanos;"
,"27":"en trabajos y fatigas, en noches sin dormir, en hambre y sed, en días sin comer, en frío y desnudez;"
,"28":"y además, mi obsesión diaria: mi preocupación por todas las iglesias."
,"29":"¿Quién desfallece que yo no desfallezca? ¿Quién se escandaliza que yo no me indigne?"
,"30":"Si hay que presumir, presumiré de mi debilidad."
,"31":"Dios, y padre de Jesús, el Señor, eternamente bendito, sabe que no miento."
,"32":"En Damasco, el gobernador del rey Aretas montó guardia en la ciudad de los damascenos para prenderme,"
,"33":"y por una ventana fui descolgado muro abajo en un canasto, y así escapé de sus manos."
}`)
	CurrentBook.AddChapter(12, `{
"1":"¿Hay que seguir presumiendo? Aunque no está bien, hablaré de las visiones y revelaciones del Señor."
,"2":"Conozco a un hombre, un cristiano, que hace catorce años -en cuerpo o en espíritu, no lo sé, Dios lo sabe- fue arrebatado hasta el tercer cielo."
,"3":"Y sé que este hombre -en cuerpo o en espíritu, no lo sé, Dios lo sabe-"
,"4":"fue arrebatado al paraíso, y oyó palabras inefables que el hombre no puede expresar."
,"5":"De ese hombre presumiré, pero de mí no presumiré sino de mis flaquezas."
,"6":"Si intentase presumir, no sería ninguna tontería, pues diría la verdad; pero no lo hago, para que nadie me considere sobre lo que ve en mí y oye de mí."
,"7":"Y para que no sea orgulloso por la sublimidad de las revelaciones, me han clavado una espina en el cuerpo, un ángel de Satanás, que me abofetea para que no me haga un soberbio."
,"8":"Tres veces he pedido al Señor que me saque esa espina,"
,"9":"y las tres me ha respondido: 'Te basta mi gracia, pues mi poder triunfa en la flaqueza'. Con gusto, pues, presumiré de mis flaquezas para que se muestre en mí el poder de Cristo."
,"10":"Por esto me alegro de mis flaquezas, de los insultos, de las dificultades, de las persecuciones, de todo lo que sufro por Cristo; pues cuando me siento débil, es cuando soy más fuerte."
,"11":"He hecho el tonto, pero vosotros me obligasteis. Pues debíais alabarme, ya que en nada les fui en zaga a los más eximios apóstoles, aunque nada soy."
,"12":"Lo característico del verdadero apóstol se verificó ante vosotros: paciencia constante, señales, prodigios y milagros."
,"13":"¿En qué habéis sido menos que las demás iglesias, si no es en no haber sido yo una carga para vosotros? ¡Perdonadme este agravio!"
,"14":"Por tercera vez estoy a punto de ir a veros, y tampoco seré una carga para vosotros; pues no busco vuestras cosas, sino a vosotros mismos. Porque no son los hijos los que deben ahorrar para los padres, sino los padres para los hijos."
,"15":"Yo gastaré lo que tenga y me desgastaré yo mismo por vosotros, aunque, amándoos yo tanto a vosotros, vosotros me améis menos a mí."
,"16":"Yo no fui una carga para vosotros; pero algunos decís que, como soy muy astuto, os hice caer en la trampa."
,"17":"¿Es que os exploté por medio de alguno de los que os envié?"
,"18":"Pedí a Tito que fuera, y envié con él a un hermano. ¿Es que os explotó Tito? ¿No es más cierto que procedemos con el mismo espíritu y seguimos los mismos pasos?"
,"19":"Os parecerá hace rato que me estoy justificando ante vosotros. Estoy hablando ante Dios y como creyente en Cristo; queridísimos, todo esto es para vuestro provecho."
,"20":"Pues temo que cuando yo vaya no os encuentre como yo quisiera, y vosotros no me encontréis a mí como vosotros quisierais; temo que haya rivalidades, envidias, animosidades, ambiciones, discordias, detracciones, murmuraciones, engreimientos, alborotos;"
,"21":"y que, cuando llegue, me humille mi Dios por causa vuestra y tenga que llorar por muchos que antes pecaron y no se han arrepentido de la impureza, de la lujuria y el desenfreno a que se entregaron."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Por tercera vez voy a visitaros. Toda cuestión se decidirá por el testimonio de dos o tres testigos."
,"2":"Lo dije entonces, en mi segunda visita, y lo vuelvo a decir ahora, lejos de vosotros, a los que pecaron antes, como a todos los demás; cuando vuelva no andaré con miramientos,"
,"3":"puesto que buscáis una prueba de que Cristo habla en mí. Cristo no ha sido débil con vosotros, ha demostrado su poder entre vosotros."
,"4":"Fue crucificado en razón de su flaqueza, pero ahora vive por el poder de Dios. Yo también participo de su debilidad y participaré, frente a vosotros, de su poderosa vida divina. "
,"5":"Examinaos a vosotros mismos a ver si estáis firmes en la fe; poneos vosotros mismos a prueba. ¿No reconocéis que Jesucristo está en vosotros? A ver si es que no superáis la prueba."
,"6":"Espero que reconozcáis que yo sí la he superado."
,"7":"Pedimos a Dios que no hagáis ningún mal; no para demostrar que yo he aprobado, sino para que practiquéis el bien, aunque yo quede descalificado."
,"8":"Porque no tengo ningún poder contra la verdad; sólo lo tengo a favor de ella."
,"9":"Y nos alegramos de que yo sea débil y vosotros fuertes. Lo que pedimos en nuestras oraciones es vuestra perfección."
,"10":"Por eso escribo esto ahora que estoy ausente, para que cuando esté presente no tenga que proceder con severidad, en virtud del poder que el Señor me ha dado para edificar y no para destruir."
,"11":"Nada más, hermanos. Vivid alegres; buscad la perfección, animaos unos a otros, vivid en armonía y en paz, y el Dios del amor y de la paz estará con vosotros."
,"12":"Saludaos unos a otros con el abrazo de la paz. Os saludan todos los hermanos."
,"13":"La gracia de Jesucristo, el Señor, el amor de Dios y la comunión del Espíritu Santo esté con todos vosotros."
}`)

}
func ES_LSB_LoadNP2EChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Pablo, Silvano y Timoteo a la Iglesia de los tesalonicenses, en Dios, nuestro Padre, y en Jesucristo, el Señor."
,"2":"Os deseamos la gracia y la paz de Dios Padre y de Jesucristo, el Señor."
,"3":"Hermanos, es nuestro deber y es de justicia dar gracias a Dios por vosotros, por los grandes progresos de vuestra fe y por el amor cada vez más grande que os tenéis unos a otros,"
,"4":"hasta el punto de que nos sentimos orgullosos de vosotros en medio del pueblo de Dios por la fortaleza y por la fe con que soportáis los sufrimientos y las persecuciones."
,"5":"Esto es una manifestación del justo juicio de Dios, para haceros así dignos de su reino, por el cual padecéis."
,"6":"Porque es propio de la justicia divina retribuir con sufrimientos a los que os hacen sufrir,"
,"7":"y a vosotros, que sufrís, daros el descanso en compañía nuestra, cuando Jesús, el Señor, aparezca en el cielo con sus ángeles poderosos,"
,"8":"entre llamas de fuego, para tomar venganza de los que no conocen a Dios y no obedecen al evangelio de Jesús, nuestro Señor."
,"9":"Todos éstos sufrirán el castigo de una perdición eterna lejos de la presencia del Señor y de su gloria esplendorosa,"
,"10":"cuando aquel día se presente glorioso entre los suyos y admirable para todos los que creyeron. Ahora bien, vosotros habéis recibido nuestro testimonio."
,"11":"En este sentido pedimos sin cesar por vosotros: que nuestro Dios os haga dignos de vuestra vocación y que con su poder lleve a término todos vuestros buenos deseos y la obra de vuestra fe."
,"12":"De este modo el nombre de Jesús, nuestro Señor, será glorificado entre vosotros, y vosotros lo seréis en él con la gracia de nuestro Dios y de Jesucristo, el Señor."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Hermanos, respecto de la venida de nuestro Señor Jesucristo y de nuestra reunión con él, os rogamos"
,"2":"que no os dejéis tan fácilmente impresionar ni os alarméis por supuestas revelaciones, palabras o cartas que os induzcan a pensar que el día del Señor es inminente, por más que se os diga que son nuestras."
,"3":"Que nadie os engañe en modo alguno, porque antes ha de venir la apostasía y ha de aparecer el hombre de la iniquidad, el destinado a la perdición, el adversario,"
,"4":"que se levantará contra todo lo divino y todo lo que tenga carácter religioso, hasta llegar a sentarse en el santuario de Dios, haciéndose pasar a sí mismo por Dios."
,"5":"¿No recordáis que, estando todavía entre vosotros, os decía ya esto?"
,"6":"Vosotros sabéis muy bien qué es lo que le retiene ahora, impidiendo su aparición hasta su tiempo."
,"7":"Realmente el misterio de iniquidad está ya en acción; sólo falta que el que ahora lo retiene sea quitado de en medio."
,"8":"Entonces se manifestará el hombre de la iniquidad, a quien Jesús, el Señor, hará desaparecer con el soplo de su boca y aniquilará con el resplandor de su venida."
,"9":"La venida de este hombre inicuo, en razón de la actividad de Satanás, irá acompañada de toda suerte de prodigios, de señales y de portentos engañosos,"
,"10":"y de todas las seducciones propias de la maldad para aquellos que están abocados a la perdición por no haber aceptado el amor de la verdad que los habría salvado."
,"11":"Por esto mismo Dios les envía un poder engañoso, que los impulsa a creer en la mentira;"
,"12":"de suerte que serán condenados todos aquellos que no solamente se resistieron a creer en la verdad, sino que además se complacieron en la iniquidad."
,"13":"Pero nosotros debemos dar continuamente gracias a Dios por vosotros, hermanos queridos del Señor, porque Dios os ha escogido desde el principio para salvaros por la acción santificadora del Espíritu y la fe en la verdad."
,"14":"Precisamente para esto os llamó por nuestra predicación del evangelio, para que alcancéis la gloria de nuestro Señor Jesucristo."
,"15":"Por tanto, hermanos, manteneos firmes y guardad las enseñanzas que habéis recibido de nosotros de palabra y por escrito."
,"16":"Y que el mismo Señor Jesucristo y Dios, nuestro Padre, que nos ha amado y por su gracia nos ha dado un consuelo eterno y una hermosa esperanza,"
,"17":"consuele vuestros corazones y los confirme en toda clase de buenas obras y buenas palabras."
}`)
	CurrentBook.AddChapter(3, `{
"1":"En fin, hermanos, rogad por nosotros, para que la palabra del Señor siga difundiéndose y sea estimada, como lo es entre vosotros,"
,"2":"y para que nosotros nos veamos libres de los hombres malos y perversos, porque no todos son de fiar."
,"3":"Pero el Señor sí es de fiar; él os fortalecerá y os defenderá del maligno."
,"4":"En cuanto a vosotros, tenemos plena confianza en el Señor en que cumplís y seguiréis cumpliendo cuanto os tenemos ordenado."
,"5":"Que el Señor dirija vuestros corazones hacia el amor de Dios y la paciencia de Cristo."
,"6":"Hermanos, en nombre de nuestro Señor Jesucristo os mandamos que os apartéis del hermano que no quiera trabajar y no se porte de acuerdo con las enseñanzas que habéis recibido de nosotros."
,"7":"Bien sabéis lo que debéis hacer para seguir nuestro ejemplo. No vivimos entre vosotros sin trabajar,"
,"8":"ni comimos gratis el pan de nadie, sino que, con sudor y fatiga, trabajamos de noche y de día para no resultar gravosos a ninguno de vosotros;"
,"9":"y no porque no tuviéramos derecho, sino porque queríamos daros un ejemplo que imitar."
,"10":"En efecto, cuando todavía estábamos entre vosotros, os dimos esta norma: el que no trabaje, que no coma."
,"11":"No obstante, nos hemos enterado de que algunos de vosotros viven sin trabajar, sin otra ocupación que curiosear."
,"12":"Pues bien, a estos tales exhortamos y amonestamos en nombre de Jesucristo, el Señor, a trabajar en paz y a ganarse el pan que comen."
,"13":"Hermanos, no os canséis de hacer el bien."
,"14":"Si alguno no hace caso de lo que decimos en esta carta, señaladle y cortad todo trato con él, para que así se sienta avergonzado."
,"15":"No obstante, no le miréis como a enemigo, sino corregidle como a hermano."
,"16":"Que el Señor de la paz os dé él mismo la paz, siempre y en todos los órdenes. El Señor esté con todos vosotros."
,"17":"El saludo es de mi puño y letra: Pablo. Ésta es la señal que distingue todas mis cartas. Ésta es mi letra."
,"18":"La gracia de nuestro Señor Jesucristo esté con todos vosotros."
}`)

}
func ES_LSB_LoadNP2IChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Pablo, apóstol de Cristo Jesús por voluntad de Dios para anunciar la promesa de la vida que tenemos en Cristo Jesús,"
,"2":"a Timoteo, mi hijo querido: Te deseo la gracia, la misericordia y la paz de Dios Padre y de Cristo Jesús, Señor nuestro."
,"3":"Doy gracias a Dios, a quien sirvo, como mis antepasados, con conciencia limpia, y te tengo presente en mis oraciones día y noche."
,"4":"Cuando me acuerdo de tus lágrimas, me entran ganas de ir a verte para llenarme de alegría,"
,"5":"avivando el recuerdo de tu fe sincera, la que primero tuvieron tu abuela Loida y tu madre Eunice y que, con toda seguridad, tienes tú también."
,"6":"Por eso te recomiendo que reavives la gracia de Dios, que te fue conferida por la imposición de mis manos."
,"7":"Pues el Señor no nos ha dado espíritu de temor, sino de fortaleza, de amor y de prudencia."
,"8":"Así pues, no te avergüences de dar testimonio de nuestro Señor, ni de mí, su prisionero. Al contrario, soporta conmigo los sufrimientos por el evangelio, con la ayuda del poder de Dios,"
,"9":"que nos ha salvado y nos ha llamado a una vida consagrada a él, no por nuestras obras, sino por pura voluntad suya y por la gracia que nos ha dado en Cristo Jesús, desde toda la eternidad,"
,"10":"y que ahora se ha manifestado con la aparición de nuestro Señor, Cristo Jesús, que destruyó la muerte y ha hecho brillar la vida y la inmortalidad por el evangelio,"
,"11":"del cual yo he sido constituido pregonero, apóstol y maestro."
,"12":"Ésta es la causa de todos estos sufrimientos; pero no me avergüenzo, pues sé en quién he puesto mi confianza y estoy seguro de que él puede guardar hasta el último día lo que me ha encomendado."
,"13":"Conserva como modelo de sana doctrina lo que oíste de mí, con la fe y el amor de Cristo Jesús."
,"14":"Guarda este preciado depósito con la ayuda del Espíritu Santo, que habita en nosotros."
,"15":"Sabes que me han abandonado todos los de Asia, entre ellos Figelo y Hermógenes."
,"16":"Que el Señor tenga misericordia de la familia de Onesíforo, porque muchas veces me ha reconfortado y no se avergonzó de mis cadenas,"
,"17":"sino que, tan pronto como llegó a Roma, se puso sin descanso a buscarme hasta que me encontró."
,"18":"Que el Señor tenga misericordia de él en el último día. Tú sabes mejor que nadie los servicios que prestó en Éfeso."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Hijo mío, que la gracia de Cristo Jesús te haga fuerte;"
,"2":"y las cosas que me oíste a mí ante muchos testigos, confíalas a hombres leales, capaces de enseñárselas a otros."
,"3":"Soporta conmigo las fatigas, como buen soldado de Cristo."
,"4":"Ningún soldado se enreda en asuntos de la vida civil si quiere complacer al que lo alistó en el ejército."
,"5":"El atleta no puede conseguir la victoria si no se atiene a las reglas del deporte."
,"6":"Si el labrador quiere recoger la cosecha, antes tiene que trabajar el campo."
,"7":"Creo que comprendes lo que te quiero decir. En todo caso, el Señor te lo hará comprender."
,"8":"Acuérdate de Jesucristo, resucitado de entre los muertos, del linaje de David, según el evangelio que predico,"
,"9":"y por el que sufro estas cadenas, como si fuera un criminal; pero la palabra de Dios no está encadenada."
,"10":"Todo lo soporto por los elegidos, para que también ellos alcancen la salvación que tenemos en Cristo Jesús y la gloria eterna."
,"11":"Esta doctrina es digna de crédito: si morimos con él, también viviremos con él;"
,"12":"si sufrimos con él, también reinaremos con él; si le negamos, él nos negará a nosotros;"
,"13":"si nosotros no le somos fieles, él seguirá siendo fiel, pues no puede negarse a sí mismo."
,"14":"Recuérdales estas cosas y adviérteles en nombre de Dios que se dejen de discutir por cuestiones de palabras, pues esas discusiones no valen para nada y hacen daño a los que las escuchan."
,"15":"Esfuérzate por presentarte ante Dios como un hombre probado, como un obrero que no tiene de qué ruborizarse, como fiel predicador de la palabra divina."
,"16":"Evita las palabrerías vacías y profanas, que contribuyen cada vez más a la maldad,"
,"17":"y su enseñanza se extiende como gangrena. Éste es el caso de Himeneo y Fileto,"
,"18":"los cuales se desviaron de la verdad diciendo que la resurrección se ha realizado ya, y pervierten la fe de algunos."
,"19":"Sin embargo, el sólido fundamento de Dios se mantiene firme bajo este lema: El Señor conoce a los suyos y que se aparte de la injusticia el que pronuncia el nombre del Señor."
,"20":"En una casa grande no sólo hay vajillas de oro y plata, sino también de madera y barro. Unos utensilios son para usos nobles, y otros para usos vulgares."
,"21":"Quien se conserve libre de estos errores será un utensilio para usos nobles, santificado, útil a su dueño, dispuesto siempre a hacer el bien."
,"22":"Huye de las pasiones propias de la juventud, y practica la justicia, la fe, el amor, la paz con quienes invocan al Señor con corazón puro."
,"23":"Evita las discusiones estúpidas y tontas, consciente de que sólo engendran altercados."
,"24":"Ahora bien, el que sirve al Señor no debe andar en altercados, sino ser amable con todos, saber enseñar y soportar los sufrimientos con paciencia,"
,"25":"corregir con dulzura a los adversarios, para ver si Dios les concede el arrepentimiento, llegar al conocimiento de la verdad"
,"26":"y retornar al buen sentido, libres del lazo del diablo, que los tenía esclavizados."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Debes saber que en los últimos días vendrán momentos difíciles."
,"2":"Pues los hombres serán egoístas, amigos del dinero, altivos, orgullosos, blasfemos, rebeldes con los padres, ingratos, injustos,"
,"3":"desnaturalizados, desleales, calumniadores, desenfrenados, inhumanos, enemigos de todo lo bueno,"
,"4":"traidores, temerarios, obcecados, más amigos de los placeres que de Dios,"
,"5":"los cuales tienen una apariencia de religiosidad, pero en realidad están lejos de ella. Apártate de ellos."
,"6":"Pues los hay que se introducen en las casas y cautivan a mujerzuelas cargadas de pecados; que se dejan llevar de toda clase de concupiscencias,"
,"7":"que siempre están aprendiendo sin poder llegar jamás al conocimiento de la verdad."
,"8":"Lo mismo que Janes y Jambrés se opusieron a Moisés, así también éstos se oponen a la verdad, hombres de mente corrompida, pervertidos en cuanto a la fe."
,"9":"Pero no llegarán muy lejos, porque su insensatez, como la de ellos, será manifiesta a todos."
,"10":"Pero tú me has seguido de cerca en la doctrina, en mi conducta, en mis planes, en la fe, en la paciencia, en el amor, en la constancia,"
,"11":"en las persecuciones y en los sufrimientos que me sobrevinieron en Antioquía, en Iconio, en Listra, donde tantas penalidades tuve que sufrir; pero de todas ellas me libró el Señor."
,"12":"Es seguro que todos los que quieren vivir como buenos cristianos sufrirán persecuciones."
,"13":"Los hombres malvados irán de mal en peor; engañarán y serán engañados."
,"14":"Tú, en cambio, permanece fiel en lo que has aprendido y de lo que estás convencido. Conoces bien a tus maestros."
,"15":"Desde la infancia conoces las Sagradas Escrituras, las cuales pueden darte la sabiduría que conduce a la salvación por la fe en Jesucristo."
,"16":"Pues toda la Escritura divinamente inspirada es útil para enseñar, para reprender, para corregir, para educar en la justicia,"
,"17":"a fin de que el hombre de Dios sea perfecto, dispuesto a hacer siempre el bien."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Yo te conjuro ante Dios y ante Jesucristo, que ha de venir como rey a juzgar a los vivos y a los muertos:"
,"2":"predica la palabra, insiste a tiempo y a destiempo, reprende, corrige, exhorta con toda paciencia y con preparación doctrinal."
,"3":"Pues vendrá el tiempo en que los hombres no soportarán la sana doctrina, sino que, llevados de sus caprichos, buscarán maestros que les halaguen el oído;"
,"4":"se apartarán de la verdad y harán caso de los cuentos."
,"5":"Pero tú estate siempre alerta, soporta con paciencia los sufrimientos, predica el evangelio, cumple bien con tu trabajo."
,"6":"Yo estoy ya a punto de ser ofrecido en sacrificio; el momento de mi partida está muy cerca."
,"7":"He combatido el buen combate, he concluido mi carrera, he conservado la fe;"
,"8":"sólo me queda recibir la corona merecida, que en el último día me dará el Señor, justo juez; y no sólo a mí, sino también a todos los que esperan con amor su venida."
,"9":"Ven lo antes que puedas,"
,"10":"pues Dimas, llevado por el amor a las cosas de este mundo, me ha abadonado y se ha marchado a Tesalónica; Crescente se ha ido a Galacia, y Tito a Dalmacia."
,"11":"Sólo Lucas está conmigo. Tráete a Marcos contigo, pues me es muy útil para el ministerio."
,"12":"A Tíquico lo envié a Éfeso."
,"13":"Cuando vengas, tráeme el capote que me dejé en Tróade, en casa de Carpo; tráeme también los libros, sobre todo los pergaminos."
,"14":"Alejandro, el herrero, me ha hecho mucho daño; el Señor le dará su merecido."
,"15":"Ten cuidado con él, pues está en abierta oposición a nuestra enseñanza."
,"16":"En mi primera defensa nadie me ayudó; todos me abandonaron. ¡Que Dios no se lo tenga en cuenta!"
,"17":"Pero el Señor me ayudó y me dio fuerzas, de tal modo que la palabra ha sido anunciada cumplidamente por mí y oída por los paganos. Y yo he sido librado de la boca del león."
,"18":"El Señor me librará de todo mal y me dará la salvación en su reino celestial. A él la gloria por los siglos de los siglos. Amén."
,"19":"Saluda a Prisca y Áquila, y a la familia de Onesíforo."
,"20":"Erasto se quedó en Corinto. A Trófimo lo dejé enfermo en Mileto."
,"21":"Ven antes del invierno. Te saludan Eubulo, Pudente, Lino, Claudia y todos los hermanos."
,"22":"Que Jesús, el Señor, esté contigo. Que la gracia esté con vosotros."
}`)

}
func ES_LSB_LoadNPCLChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Pablo, apóstol de Jesucristo por voluntad de Dios, y Timoteo, el hermano,"
,"2":"a los creyentes y fieles hermanos en Cristo residentes en Colosas. Os deseamos la gracia y la paz de Dios nuestro Padre."
,"3":"Damos gracias a Dios, Padre de nuestro Señor Jesucristo, orando siempre por vosotros,"
,"4":"porque estamos informados de vuestra fe en Cristo Jesús y del amor fraterno que tenéis a todos los creyentes"
,"5":"por la esperanza de lo que os está reservado en los cielos, de la que ya oísteis hablar por la palabra de la verdad del evangelio"
,"6":"que llegó hasta vosotros, y que, como fructifica y crece en todo el mundo, así también ha sucedido entre vosotros desde el día en que oísteis y conocisteis la gracia de Dios en la verdad,"
,"7":"conforme la aprendisteis de Epafras, nuestro querido compañero y fiel ministro de Cristo en lugar nuestro,"
,"8":"quien también nos ha manifestado lo que nos amáis en el Espíritu."
,"9":"Por esta razón nosotros, desde el día en que lo oímos, no cesamos de rogar y pedir por vosotros, para que seáis llenos del conocimiento de su voluntad con toda sabiduría e inteligencia espiritual,"
,"10":"y os comportéis de una manera digna del Señor, intentando complacerle en todo, fructificando en toda obra buena y creciendo en el conocimiento de Dios,"
,"11":"dotados de una fortaleza a toda prueba por el poder de su gloria para así soportar todo con alegría y con paciencia;"
,"12":"dando gracias al mismo tiempo a Dios, que os ha hecho capaces de participar en la herencia de su pueblo en la gloria,"
,"13":"que nos rescató del poder de las tinieblas y nos transportó al reino de su Hijo querido,"
,"14":"en quien tenemos la liberación y el perdón de los pecados. a) En la creación del mundo. "
,"15":"Cristo es imagen de Dios invisible, primogénito de toda la creación,"
,"16":"porque por él mismo fueron creadas todas las cosas, las de los cielos y las de la tierra, lo invisible y lo visible, tanto los tronos como las dominaciones, los principados como las potestades; absolutamente todo fue creado por él y para él;"
,"17":"y él mismo existe antes que todas las cosas, y todas subsisten en él. b) En la Iglesia. "
,"18":"Él es también la cabeza del cuerpo, de la Iglesia, siendo el principio, el primogénito entre los muertos, para ser el primero en todo,"
,"19":"ya que en él quiso el Padre que habitase toda la plenitud. c) En la obra de reconciliación. "
,"20":"Quiso también por medio de él reconciliar consigo todas las cosas, tanto las de la tierra como las del cielo, pacificándolas por la sangre de su cruz."
,"21":"Y a vosotros, que fuisteis un día extraños y enemigos de corazón y de obra,"
,"22":"ahora, en fin, os ha reconciliado completamente por la muerte de su cuerpo mortal, para presentaros limpios, inmaculados e irreprensibles ante su presencia,"
,"23":"siempre que perseveréis sólidamente cimentados en la fe y estables e inconmovibles en la esperanza del evangelio que oísteis, el que ha de ser predicado a toda criatura bajo el cielo, y del que yo, Pablo, he sido elegido ministro."
,"24":"Ahora me alegro de sufrir por vosotros, y por mi parte completo en mi carne lo que falta a las tribulaciones de Cristo por su cuerpo, que es la Iglesia,"
,"25":"de la que fui hecho ministro según la misión que Dios me dio para bien vuestro, con el fin de dar cumplimiento a su mensaje divino,"
,"26":"el plan secreto de Dios, escondido desde los siglos y desde las generaciones y ahora manifestado a los creyentes,"
,"27":"a quienes Dios quiso descubrir cuál es la riqueza sublime de este secreto entre los paganos, que es Cristo entre vosotros, la esperanza de la gloria,"
,"28":"a quien nosotros anunciamos amonestando e instruyendo a todos los hombres en toda sabiduría, para presentarlos perfectos en Jesucristo;"
,"29":"con miras a lo cual me fatigo y lucho apoyado en la fuerza de Cristo, que obra poderosamente en mí."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Quiero que sepáis qué intensa lucha soporto por vosotros, por los que residen en Laodicea y por todos los que no me conocen personalmente,"
,"2":"para que cobren ánimo, se mantengan unidos en el amor y alcancen así el conocimiento pleno de todo y descubran el secreto de Dios, que es Cristo,"
,"3":"en el que se encuentran ocultos todos los tesoros de la sabiduría y de la ciencia."
,"4":"Digo esto para que nadie os engañe con razonamientos falsos."
,"5":"Pues, aunque corporalmente me hallo ausente, en espíritu me encuentro en vuestra compañía, complaciéndome al ver la disposición inquebrantable de vuestra fe en Cristo."
,"6":"Ya que habéis aceptado a Jesucristo, el Señor, vivid como él quiere,"
,"7":"arraigados y cimentados en él; manteneos firmes en la fe tal y como aprendisteis, en continua acción de gracias."
,"8":"Cuidado con que nadie os engañe con falsas teorías y vanos razonamientos, apoyados en las tradiciones de los hombres y en los elementos del mundo, y no en Cristo."
,"9":"Porque en él habita corporalmente toda la plenitud de la divinidad,"
,"10":"y en él, cabeza de todo principado y potestad, habéis alcanzado la plenitud."
,"11":"En él también fuisteis circuncidados con una circuncisión hecha no por la mano del hombre, sino con la circuncisión de Cristo, que consiste en despojaros de vuestros apetitos carnales."
,"12":"En el bautismo fuisteis sepultados con Cristo, habéis resucitado también con él por la fe en el poder de Dios, que lo resucitó de entre los muertos."
,"13":"Y a vosotros, que estabais muertos por vuestras faltas y por no haber dominado los apetitos carnales, os volvió a dar la vida juntamente con él, y nos ha perdonado todos los pecados."
,"14":"Ha destruido el acta que había contra nosotros con sus acusaciones legales, quitándola de en medio y clavándola en la cruz;"
,"15":"y destituyó a los principados y a las potestades, y los expuso a la pública irrisión, triunfando de ellos en la cruz."
,"16":"Por consiguiente, que nadie os juzgue por las comidas o bebidas o por la participación en las fiestas, lunas nuevas o sábados,"
,"17":"lo cual es una sombra del futuro, cuyo fundamento es Cristo."
,"18":"Que nadie, con simulada humildad o culto de ángeles, os niegue el premio de la victoria, metiéndose en cosas que no ha visto, presumiendo vanamente a la luz de su inteligencia carnal,"
,"19":"en lugar de adherirse a la cabeza, por la que todo el cuerpo, sustentado y ligado por las articulaciones y junturas, aumenta su crecimiento en Dios."
,"20":"Si habéis muerto con Cristo a los elementos del mundo, ¿por qué os sometéis como si todavía fueseis del mundo a preceptos como:"
,"21":"no tomes, no gustes, no toques?"
,"22":"¿No son cosas que llegan a destruirse por el uso, conforme a las ordenanzas e instrucciones de los hombres?"
,"23":"Estas cosas pueden tener un aspecto de sabiduría, porque manifiestan cierta religiosidad, cierta humildad y un desprecio por el cuerpo; pero, en realidad, no tienen valor alguno, pues sólo tienden a satisfacer los apetitos carnales."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Por consiguiente, si habéis resucitado con Cristo, buscad las cosas de arriba, donde Cristo está sentado a la diestra de Dios;"
,"2":"pensad en las cosas de arriba, no en las de la tierra."
,"3":"Vosotros habéis muerto, y vuestra vida está escondida con Cristo en Dios."
,"4":"Cuando Cristo se manifieste, él que es vuestra vida, entonces vosotros también apareceréis con él en la gloria."
,"5":"Por tanto, destruid todo lo que hay de terrenal en vuestro cuerpo: la lujuria, la impureza, las pasiones, los apetitos desordenados y la avaricia que es una idolatría;"
,"6":"acciones por las que sobreviene la ira divina sobre los rebeldes"
,"7":"y que practicabais en vuestra vida pasada."
,"8":"Pero ahora dejad todo eso: la ira, el rencor, la malicia, los insultos y las groserías."
,"9":"No os engañéis unos a otros, pues os habéis despojado del hombre viejo con su manera de actuar"
,"10":"para revestiros del hombre nuevo, que se renueva sin cesar a imagen de su creador hasta adquirir el conocimiento perfecto."
,"11":"Ya no hay distinción entre griego y judío, circunciso o incircunciso, extranjero o ignorante, esclavo o libre, sino que Cristo es todo en todos."
,"12":"Dios os ama y os ha elegido para que seáis miembros de su pueblo. Por tanto, sed compasivos, bondadosos, humildes, pacientes y comprensivos."
,"13":"Soportaos unos a otros y perdonaos si alguno tiene queja contra otro. Del mismo modo que el Señor os perdonó, así también vosotros debéis perdonaros."
,"14":"Pero, por encima de todo, tened amor, que es el lazo de la perfección."
,"15":"Que la paz de Cristo reine en vuestros corazones, en la que fuisteis llamados para formar un solo cuerpo. Y sed agradecidos."
,"16":"Que la palabra de Cristo viva entre vosotros con toda su riqueza. Enseñaos y aconsejaos unos a otros con talento. Con profundo agradecimiento cantad a Dios salmos, himnos y canciones religiosas."
,"17":"Y todo lo que hagáis o digáis, hacedlo en nombre de Jesús, el Señor, dando gracias a Dios Padre por medio de él."
,"18":"Mujeres, estad sumisas a vuestros maridos, pues eso es lo que debéis hacer como creyentes."
,"19":"Maridos, amad a vuestras esposas y no os irritéis contra ellas."
,"20":"Hijos, obedeced a vuestros padres en todo, porque esto agrada al Señor."
,"21":"Padres, no exasperéis a vuestros hijos, para que no se desalienten."
,"22":"Esclavos, obedeced a vuestros amos temporales; no sólo cuando os ven, como para quedar bien con ellos, sino de todo corazón y por respeto al Señor."
,"23":"Todo lo que hagáis, hacedlo con gusto, como si sirvieseis al Señor y no a los hombres,"
,"24":"sabiendo que en pago recibiréis la herencia. Vosotros servís a Cristo, el Señor."
,"25":"Al que comete injusticia le darán la paga de sus injusticias, pues ante Dios todos somos iguales."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Amos, practicad la justicia y la equidad con los siervos, puesto que sabéis que también vosotros tenéis a vuestro amo en el cielo."
,"2":"Perseverad en la oración, siempre alerta y dando gracias a Dios,"
,"3":"pidiendo también por mí, para que Dios me dé la oportunidad de manifestar el secreto de Cristo, por el que estoy encadenado."
,"4":"Pedid para que sepa anunciarlo con el lenguaje conveniente."
,"5":"Portaos sabiamente con los de afuera, aprovechando las ocasiones propicias."
,"6":"Que vuestra conversación sea siempre agradable, sazonada con la sal de la gracia, sabiendo cómo debéis responder a cada uno."
,"7":"Tíquico, hermano muy querido, fiel ministro del Señor y compañero de trabajo, os contará cómo van todas mis cosas;"
,"8":"os lo envío precisamente para esto, para que tengáis noticias mías y os dé ánimos."
,"9":"Con él va Onésimo, vuestro fiel y querido hermano. Os informará de todo cuanto aquí llevamos a cabo."
,"10":"Os saluda Aristarco, mi compañero de prisión, y Marcos, el primo de Bernabé, de quien recibisteis instrucciones (si recurre a vosotros, acogedle),"
,"11":"y Jesús, llamado Justo. Éstos son los únicos judíos que trabajan conmigo por el reino de Dios; ellos me sirvieron de consuelo."
,"12":"Os saluda Epafras, vuestro compatriota, siervo de Jesucristo, que continuamente se esfuerza suplicando por vosotros, para que os mantengáis firmes y totalmente sometidos a la voluntad de Dios."
,"13":"Soy testigo de lo mucho que se preocupa por vosotros, por los de Laodicea y por los de Hierápolis."
,"14":"Os saluda Lucas, el médico tan querido, y Dimas."
,"15":"Saludad a los hermanos de Laodicea, a Ninfa y a la iglesia que se reúne en su casa."
,"16":"Cuando vosotros hayáis leído esta carta, procurad que también sea leída en la iglesia de Laodicea, y la de Laodicea leedla también vosotros."
,"17":"Decid a Arquipo que procure cumplir el ministerio que el Señor le ha encomendado."
,"18":"El saludo es de mi puño y letra: Pablo. Acordaos de que estoy en la cárcel. Que la gracia de Dios esté con vosotros."
}`)

}
func ES_LSB_LoadNPEPChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Pablo, apóstol de Jesucristo por designio de Dios, a los consagrados y fieles de Cristo Jesús."
,"2":"Os deseo la gracia y la paz de Dios, nuestro Padre, y de Jesucristo, el Señor."
,"3":"Bendito sea Dios, Padre de nuestro Señor Jesucristo, que nos ha bendecido en Cristo con toda clase de bendiciones espirituales y celestiales."
,"4":"Él nos ha elegido en Cristo antes de crear el mundo, para que fuésemos santos e irreprochables a sus ojos."
,"5":"Por puro amor nos ha predestinado a ser sus hijos adoptivos, por medio de Jesucristo y conforme al beneplácito de su voluntad,"
,"6":"para hacer resplandecer la gracia maravillosa que nos ha concedido por medio de su querido Hijo."
,"7":"Él nos ha obtenido con su sangre la redención, el perdón de los pecados, según la riqueza de su gracia,"
,"8":"que ha derramado sobre nosotros con una plenitud de sabiduría y de prudencia,"
,"9":"dándonos a conocer el designio misterioso de su voluntad, según los planes que se propuso realizar por medio de Cristo"
,"10":"cuando se cumpliera el tiempo: recapitular todas las cosas en Cristo, las de los cielos y las de la tierra."
,"11":"En Cristo también hemos sido hechos herederos, predestinados según el designio del que todo lo hace conforme a su libre voluntad,"
,"12":"a fin de que nosotros, los que antes habíamos esperado en Cristo, seamos alabanza de su gloria;"
,"13":"también vosotros los que habéis escuchado la palabra de la verdad, el evangelio de vuestra salvación, en el que habéis creído, habéis sido sellados con el Espíritu Santo prometido,"
,"14":"el cual es garantía de nuestra herencia, para la plena liberación del pueblo de Dios y alabanza de su gloria."
,"15":"Por lo cual, yo, al conocer vuestra fe en Jesús, el Señor, y el amor a todos los creyentes,"
,"16":"no ceso de dar gracias por vosotros recordándoos en mis oraciones,"
,"17":"para que el Dios de nuestro Señor Jesucristo, el Padre de la gloria, os conceda espíritu de sabiduría que os revele un conocimiento profundo de él;"
,"18":"que ilumine los ojos de vuestro corazón, para que conozcáis cuál es la esperanza de su llamada, cuál la riqueza de la gloria de su herencia otorgada a su pueblo"
,"19":"y cuál la excelsa grandeza de su poder para con nosotros, los creyentes, según la fuerza de su poderosa virtud,"
,"20":"la que ejerció en Cristo resucitándolo de entre los muertos, sentándolo a su derecha en los cielos"
,"21":"por encima de todo principado, potestad, autoridad, señorío y de todo lo que hay en este mundo y en el venidero;"
,"22":"todo lo sometió bajo sus pies y a él lo constituyó cabeza de la Iglesia por encima de todas las cosas;"
,"23":"la Iglesia es su cuerpo, la plenitud de todo lo que existe."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Vosotros estabais muertos por las culpas y los pecados"
,"2":"que cometisteis siguiendo el modo de vivir de este mundo, bajo el príncipe de las potestades aéreas, el espíritu que actúa en los que se rebelan contra Dios."
,"3":"Nosotros también éramos de ésos cuando nos dejábamos llevar de las apetencias carnales, sujetos a los deseos de nuestros instintos y a nuestra imaginación. Éramos, por naturaleza, objeto de la ira divina, igual que los demás."
,"4":"Pero Dios, rico en misericordia, por el inmenso amor con que nos amó,"
,"5":"nos dio vida juntamente con Cristo (pues habéis sido salvados por pura gracia) cuando estábamos muertos por el pecado,"
,"6":"nos resucitó y nos hizo sentar con él en los cielos con Cristo Jesús,"
,"7":"a fin de manifestar en los siglos venideros la excelsa riqueza de su gracia mediante su bondad para con nosotros en Cristo Jesús."
,"8":"Habéis sido salvados gratuitamente por la fe; y esto no es cosa vuestra, es un don de Dios;"
,"9":"no se debe a las obras, para que nadie se llene de vanidad."
,"10":"Él nos ha hecho, él nos ha creado por medio de Cristo Jesús, para hacer obras buenas tal y como él lo dispuso de antemano."
,"11":"Por lo cual, acordaos de que vosotros, los paganos de nacimiento, a los que los judíos llaman 'incircuncisos' -ellos llevan en su carne la circuncisión hecha por mano de hombres-,"
,"12":"estabais en otro tiempo sin Cristo, alejados de la ciudadanía de Israel y ajenos a las alianzas, sin esperanza de la promesa y sin Dios en el mundo;"
,"13":"mientras que ahora, unidos a Cristo Jesús gracias a su muerte, los que antes estabais lejos, ahora estáis cerca."
,"14":"Él es nuestra paz; el que de ambos pueblos hizo uno, derribando el muro que los separaba, la enemistad;"
,"15":"anulando en su propio cuerpo la ley, sus mandamientos y decretos. Él ha formado de los dos, en su propia persona, una nueva humanidad, haciendo así la paz."
,"16":"Él hizo de los dos un solo cuerpo y los ha reconciliado con Dios por medio de la cruz, destruyendo en sí mismo la enemistad;"
,"17":"con su venida anunció la paz a los que estabais lejos y a los que estaban cerca;"
,"18":"porque por él los unos y los otros tenemos acceso al Padre en un mismo Espíritu."
,"19":"De tal suerte que ya no sois extranjeros y huéspedes, sino que sois ciudadanos de los consagrados y miembros de la familia de Dios,"
,"20":"edificados sobre el fundamento de los apóstoles y de los profetas. La piedra angular de este edificio es Cristo Jesús,"
,"21":"en el que todo el edificio, perfectamente ensamblado, se levanta para convertirse en un templo consagrado al Señor;"
,"22":"por él también vosotros estáis integrados en el edificio, para ser mediante el Espíritu morada de Dios."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Por esto yo, Pablo, estoy preso por Cristo Jesús para bien de vosotros, los paganos;"
,"2":"pues conocéis la misión que Dios generosamente me ha encomendado en favor vuestro,"
,"3":"cuando Dios me dio a conocer su plan secreto, del que más arriba os hablé brevemente;"
,"4":"leyéndolo, podréis saber el conocimiento que yo tengo del secreto de Cristo,"
,"5":"secreto que no se dio a conocer a los hombres de las generaciones pasadas, y que ahora se lo ha manifestado a sus santos apóstoles y profetas por medio del Espíritu."
,"6":"Este secreto consiste en que los paganos comparten la misma herencia con los judíos, son miembros del mismo cuerpo y, en virtud del evangelio, participan de la misma promesa en Jesucristo."
,"7":"Yo he llegado a ser ministro de este evangelio gracias a la acción poderosa de Dios."
,"8":"A mí, el más insignificante de todos los cristianos, se me ha concedido el privilegio de evangelizar a los paganos, de anunciar la incalculable riqueza de Cristo,"
,"9":"de declarar el cumplimiento de este plan secreto, escondido desde todos los siglos en Dios, creador de todas las cosas."
,"10":"Así, de ahora en adelante, por medio de la Iglesia, los principados y potestades celestiales podrán conocer la incalculable sabiduría de Dios,"
,"11":"según el plan eterno que Dios ha realizado en Cristo Jesús, Señor nuestro."
,"12":"Gracias a la fe que tenemos en Cristo, nos acercamos a Dios con entera libertad y plena confianza."
,"13":"Por eso os pido que no os desalentéis al ver lo que sufro por vosotros, pues esto debe ser un honor para vosotros."
,"14":"Por estas razones doblo mis rodillas ante el Padre,"
,"15":"del que toma su nombre toda familia en el cielo y en la tierra,"
,"16":"para que os conceda, conforme a la riqueza de su gloria, el ser fortalecidos poderosamente por su Espíritu en orden al progreso de vuestro hombre interior,"
,"17":"y que Cristo habite en vuestros corazones por la fe, para que, arraigados y fundamentados en el amor,"
,"18":"podáis comprender con todos los creyentes cuál es la anchura, la longitud, la altura y la profundidad,"
,"19":"y conocer el amor de Cristo, que sobrepasa todo conocimiento, a fin de que seáis llenos de toda la plenitud de Dios."
,"20":"A aquel que es poderoso para hacer muchísimo más de lo que pedimos o pensamos, en virtud de su poder que actúa en nosotros,"
,"21":"a él la gloria en la Iglesia y en Cristo Jesús, en todas las generaciones, por los siglos de los siglos. Amén."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Yo -que estoy preso por la causa del Señor- os pido que caminéis de una manera digna de la vocación que habéis recibido."
,"2":"Sed humildes, amables y pacientes. Soportaos unos a otros con amor."
,"3":"Esforzaos por mantener la unidad del espíritu con el vínculo de la paz."
,"4":"Hay un solo cuerpo y un solo Espíritu, como una es la esperanza a la que habéis sido llamados."
,"5":"Hay un solo Señor, una sola fe, un solo bautismo"
,"6":"y un solo Dios, padre de todos, que está sobre todos, por todos y en todos."
,"7":"Pero cada uno de nosotros hemos recibido un don en la medida en que Cristo nos lo ha querido dar."
,"8":"Por eso dice la Escritura: Subió a lo alto llevando presa a la prisión, repartió dones a los hombres."
,"9":"Eso de que 'subió' significa que antes bajó a lo profundo de la tierra."
,"10":"El mismo que bajó es el que subió a lo más alto del cielo, para que se cumpliesen todas las cosas."
,"11":"Él a unos constituyó apóstoles; a otros, profetas; a unos evangelistas, y a otros pastores y maestros,"
,"12":"a fin de perfeccionar a los cristianos en la obra de su ministerio y en la edificación del cuerpo de Cristo,"
,"13":"hasta que todos lleguemos a la unidad de la fe y al conocimiento completo del Hijo de Dios, y a constituir el estado del hombre perfecto a la medida de la edad de la plenitud de Cristo,"
,"14":"para que no seamos niños vacilantes y no nos dejemos arrastrar por ningún viento de doctrina al capricho de gente astuta que induce al error;"
,"15":"antes al contrario, practicando sinceramente el amor, crezcamos en todos los sentidos hacia aquel que es la cabeza, Cristo."
,"16":"Por él, el cuerpo entero, trabado y unido por medio de todos sus ligamentos, según la actividad propia de cada miembro, crece y se desarrolla en el amor."
,"17":"Os digo y os pido en nombre del Señor que no viváis como viven los paganos, con sus vanos pensamientos"
,"18":"y su mente oscurecida, apartados de la vida de Dios por su ignorancia y la dureza de su corazón;"
,"19":"han perdido todo sentido moral y se han entregado al vicio, realizando desenfrenadamente toda clase de inmoralidades."
,"20":"No es eso lo que vosotros habéis aprendido de Cristo;"
,"21":"pues si verdaderamente habéis oído hablar de él y os han instruido en la verdad de Jesús,"
,"22":"debéis despojaros de vuestra vida pasada, del hombre viejo, corrompido por las concupiscencias engañosas,"
,"23":"renovaos en vuestro espíritu y en vuestra mente"
,"24":"y revestíos del hombre nuevo, creado según Dios, en justicia y santidad verdadera."
,"25":"Por esto, desterrad la mentira, y que cada uno diga la verdad a su prójimo, pues somos miembros los unos de los otros."
,"26":"Si os indignáis, no lleguéis a pecar y que vuestra indignación cese ates de que se ponga el sol;"
,"27":"no deis ninguna oportunidad al diablo."
,"28":"El que robaba, que ya no robe más y que se ponga a trabajar honradamente con sus propias manos para tener con qué ayudar a los necesitados."
,"29":"No digáis palabras groseras; que vuestro lenguaje sea bueno, edificante y oportuno, para que hagáis bien a los que os escuchan."
,"30":"No entristezcáis al Espíritu Santo de Dios, que os ha marcado con su sello para distinguiros el día de la liberación."
,"31":"Desterrad la amargura, la ira, los gritos, los insultos y toda clase de maldad."
,"32":"Sed bondadosos y compasivos; perdonaos unos a otros, como Dios os ha perdonado por medio de Cristo."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Sed imitadores de Dios, como hijos muy amados."
,"2":"Vivid en el amor, siguiendo el ejemplo de Cristo, que nos amó y se entregó por nosotros a Dios como ofrenda y sacrificio de olor agradable."
,"3":"En lo que se refiere a la lujuria y a toda clase de impureza o avaricia, que ni siquiera se nombre entre vosotros, como debe ser entre creyentes;"
,"4":"ni palabras torpes, groserías o bajezas, cosas que no están bien; por el contrario, alabad a Dios."
,"5":"Porque tened bien entendido que ningún lujurioso, impuro o avaro -que es lo mismo que un idólatra- ha de heredar el reino de Cristo y de Dios."
,"6":"Que nadie os engañe con vanas palabras, pues por estas cosas vendrá la ira de Dios sobre los rebeldes."
,"7":"No tengáis parte alguna con ellos."
,"8":"Antes erais tinieblas, ahora sois luz en el Señor; caminad como hijos de la luz"
,"9":"(porque el fruto de la luz consiste en la bondad, en la justicia y en la verdad)."
,"10":"Buscad lo que agrada al Señor,"
,"11":"y no toméis parte en las obras infructuosas de las tinieblas; por el contrario, condenadlas abiertamente,"
,"12":"porque las cosas que ellos hacen en secreto da vergüenza decirlas."
,"13":"Cuando todas estas cosas son manifestadas por la luz, quedan al descubierto, y lo que queda al descubierto se convierte en luz."
,"14":"Por eso se dice: Despierta tú, que duermes, y levántate de entre los muertos, y Cristo te iluminará."
,"15":"A ver cómo os comportáis; que no sea como insensatos, sino como inteligentes,"
,"16":"aprovechando el tiempo, porque los días son malos."
,"17":"Por consiguiente, no actuéis como necios, sino procurad conocer cuál es la voluntad del Señor."
,"18":"No bebáis vino hasta emborracharos, pues eso lleva al desenfreno; al contrario, llenaos del Espíritu Santo"
,"19":"recitando entre vosotros salmos, himnos y cánticos espirituales, cantando y alabando al Señor en vuestros corazones,"
,"20":"dando siempre gracias por todo a Dios Padre en nombre de nuestro Señor Jesucristo."
,"21":"Respetaos unos a otros por fidelidad a Cristo."
,"22":"Que las mujeres sean sumisas a sus maridos como si se tratara del Señor;"
,"23":"porque el marido es cabeza de la mujer, del mismo modo que Cristo es cabeza de la Iglesia, cuerpo suyo, del cual él es el Salvador."
,"24":"Así como la Iglesia está sujeta a Cristo, así también las mujeres lo deben estar a sus maridos en todo."
,"25":"Maridos, amad a vuestras esposas, como Cristo amó a la Iglesia y se entregó él mismo por ella,"
,"26":"a fin de santificarla por medio del agua del bautismo y de la palabra,"
,"27":"para prepararse una Iglesia gloriosa, sin mancha ni arruga ni cosa parecida, sino santa y perfecta."
,"28":"Así los maridos deben también amar a sus mujeres como a su propio cuerpo. El que ama a su mujer se ama a sí mismo."
,"29":"Porque nadie odia jamás a su propio cuerpo, sino que, por el contrario, lo alimenta y lo cuida, como hace Cristo con la Iglesia,"
,"30":"pues somos miembros de su cuerpo."
,"31":"Por eso el hombre dejará a su padre y a su madre y se unirá a su mujer, y los dos serán una sola carne."
,"32":"Éste es un gran misterio, que yo aplico a Cristo y a la Iglesia."
,"33":"Por lo que toca a vosotros, que cada uno ame a su mujer como a sí mismo, y que la mujer respete a su marido."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Hijos, obedeced a vuestros padres por amor al Señor, porque esto es de justicia."
,"2":"Honra a tu padre y a tu madre (que es el primer mandamiento con promesa),"
,"3":"para que seáis felices y tengáis larga vida sobre la tierra."
,"4":"Y vosotros, padres, no exasperéis a vuestros hijos, sino educadlos en la disciplina y en la corrección como quiere el Señor."
,"5":"Esclavos, obedeced a vuestros amos temporales con respeto, lealtad y de todo corazón, como si fuera a Cristo;"
,"6":"servidles no sólo cuando os ven, como para quedar bien con ellos, sino como esclavos de Cristo, haciendo de corazón la voluntad del Señor;"
,"7":"servidles de buena gana, como si fuera al Señor y no a hombres,"
,"8":"considerando que el Señor retribuirá a cada uno todo el bien que haga, lo mismo al esclavo que al libre."
,"9":"Y vosotros, amos, haced con ellos las mismas cosas, dejándoos de amenazas, considerando que ellos y vosotros tenéis un mismo amo en el cielo, para el que todos son iguales."
,"10":"En definitiva, cobrad fuerzas en el poder soberano del Señor."
,"11":"Revestíos de la armadura de Dios para que podáis resistir las tentaciones del diablo."
,"12":"Porque nuestra lucha no es contra gente de carne y hueso, sino contra los principados y potestades, contra los dominadores de este mundo tenebroso, contra los espíritus del mal, que moran en los espacios celestes."
,"13":"Por esto, recibid la armadura de Dios, para que podáis resistir en el día malo y ser perfectos en todo."
,"14":"Manteneos firmes, ceñidos vuestros lomos con la verdad, revestidos con la coraza de la justicia"
,"15":"y teniendo calzados los pies, prontos para anunciar el evangelio de la paz."
,"16":"Empuñad en todas las ocasiones el escudo de la fe, con el cual podáis inutilizar los dardos encendidos del Maligno."
,"17":"Tomad también el yelmo de la salud y la espada del Espíritu, que es la palabra de Dios,"
,"18":"orando sin cesar bajo la guía del Espíritu con toda clase de oraciones y súplicas; estad alerta y pedid constantemente por todos los creyentes;"
,"19":"pedid también por mí, para que Dios ponga en mis labios las palabras adecuadas y anuncie con valentía el plan secreto de Dios, el evangelio,"
,"20":"del que soy un embajador encadenado, hablando con valor y como debo hacerlo."
,"21":"Tíquico, hermano muy querido y fiel ministro del Señor, os contará cómo van mis cosas y todo lo que hago;"
,"22":"os lo envío precisamente para esto, para que tengáis noticias mías y os dé ánimos."
,"23":"Que Dios Padre y Jesucristo, el Señor, os concedan a todos los hermanos la paz, el amor y la fe."
,"24":"Que la gracia esté con todos los que profesan a nuestro Señor Jesucristo un amor inalterable."
}`)

}
func ES_LSB_LoadNPGAChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Pablo, apóstol -no de parte de los hombres ni por mediación de los hombres, sino por Jesucristo y por Dios Padre, que lo resucitó de entre los muertos-,"
,"2":"y todos los hermanos que están conmigo, a las iglesias de Galacia."
,"3":"Os deseamos la gracia y la paz de Dios nuestro Padre y de Jesucristo nuestro Señor,"
,"4":"que se entregó a sí mismo por nuestros pecados para sacarnos de este mundo perverso, conforme a la voluntad de nuestro Dios y Padre,"
,"5":"a quien sea la gloria por los siglos de los siglos. Amén."
,"6":"Estoy sorprendido de que tan rápidamente os hayáis apartado de aquel que os llamó por la gracia de Cristo y os hayáis pasado a otro evangelio."
,"7":"Eso no es otro evangelio; lo que pasa es que algunos siembran entre vosotros la confusión y quieren deformar el evangelio de Cristo."
,"8":"Pero si yo mismo o incluso un ángel del cielo os anuncia un evangelio distinto del que yo os anuncié, sea maldito."
,"9":"Os repito lo que ya os dije antes. Si alguien os anuncia un evangelio distinto del que habéis recibido, sea maldito."
,"10":"¿A quién busco agradar, a los hombres o a Dios? Si tratara de agradar a los hombres, no agradaría a Dios."
,"11":"Hermanos, os aseguro que el evangelio predicado por mí no es un producto humano;"
,"12":"pues yo no lo recibí ni lo aprendí de hombre alguno, sino por revelación de Jesucristo."
,"13":"Conocéis mi conducta anterior dentro del judaísmo: con qué crueldad perseguía y trataba de aniquilar a la Iglesia de Dios,"
,"14":"y cómo aventajaba en el judaísmo a muchos de mi edad en conservar con todo rigor las tradiciones de mis antepasados."
,"15":"Pero cuando Dios, que me había elegido desde el vientre de mi madre, me llamó por su gracia"
,"16":"y me dio a conocer a su Hijo para que yo lo anunciara entre los paganos, inmediatamente, sin consultar a nadie,"
,"17":"en lugar de ir a Jerusalén a ver a los que eran apóstoles antes que yo, me fui a Arabia y luego volví a Damasco."
,"18":"Al cabo de tres años fui a Jerusalén para conocer a Pedro, y estuve con él quince días."
,"19":"Y no vi a ningún otro apóstol fuera de Santiago, el hermano del Señor."
,"20":"En todo esto que os escribo, bien sabe Dios que no miento."
,"21":"Después fui a las regiones de Siria y de Cilicia,"
,"22":"y en cambio era desconocido personalmente por las iglesias cristianas de Judea."
,"23":"Tan sólo oían decir: El que antes nos perseguía, ahora anuncia la fe que trataba de destruir;"
,"24":"y glorificaban a Dios por causa mía."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Al cabo de catorce años, volví a Jerusalén con Bernabé, llevando también a Tito."
,"2":"Fui, impulsado por una revelación divina; y, en privado, expuse a los dirigentes el evangelio que predico a los paganos, para saber si estaba o no trabajando inútilmente."
,"3":"Pues ni Tito, mi compañero, que era griego, fue obligado a circuncidarse,"
,"4":"a pesar de que esos falsos hermanos intrusos se habían infiltrado entre nosotros para espiar la libertad que tenemos en Cristo Jesús y hacernos esclavos de la ley."
,"5":"Pero ni por un momento les prestamos sumisión, para que la verdad del evangelio persevere entre vosotros."
,"6":"Los dirigentes no me añadieron nada -lo que ellos fueron antes, no me interesa, pues Dios no juzga por las apariencias-,"
,"7":"antes al contrario, vieron que yo había recibido la misión de anunciar el evangelio a los paganos, como Pedro a los judíos,"
,"8":"pues el mismo Dios que hizo a Pedro apóstol de los judíos me ha hecho a mí apóstol de los paganos;"
,"9":"y Santiago, Pedro y Juan, que eran considerados como columnas, reconocieron que Dios me ha dado este privilegio, y nos dieron la mano a mí y a Bernabé en señal de que estaban de acuerdo en que nosotros nos dedicáramos a los paganos"
,"10":"y ellos a los judíos, con tal que nos acordásemos de los pobres, lo que he procurado hacer con el máximo interés."
,"11":"Cuando Pedro vino a Antioquía, yo me enfrenté a él cara a cara y le reprendí."
,"12":"Pues antes de que viniesen algunos de parte de Santiago, él comía con los paganos; pero cuando vinieron, se retrajo y se apartó por miedo a los judíos;"
,"13":"los otros judíos creyentes le imitaron en la misma hipocresía, incluso el mismo Bernabé."
,"14":"Cuando vi que no se portaban conforme a la verdad del evangelio, dije a Pedro en presencia de todos: Si tú, siendo judío, vives como los paganos y no como los judíos, ¿cómo obligas a los paganos a seguir los ritos judíos? "
,"15":"Nosotros somos judíos de nacimiento, y no pecadores paganos;"
,"16":"pero sabemos que nadie se justifica por las obras de la ley, sino por la fe en Jesucristo; nosotros creemos en Cristo Jesús para ser justificados por la fe de Cristo, no por las obras de la ley; porque nadie será justificado por las obras de la ley."
,"17":"Pero si buscando ser justificados por Cristo resulta que somos pecadores, ¿será acaso Cristo ministro del pecado? De ninguna manera."
,"18":"Porque si reconstruyo las mismas cosas que destruí, demuestro que entonces fui culpable."
,"19":"Pues yo, por la ley, he muerto a la ley, a fin de vivir para Dios. Estoy crucificado con Cristo;"
,"20":"y ya no vivo yo, pues es Cristo el que vive en mí. Mi vida presente la vivo en la fe en el Hijo de Dios, el cual me amó y se entregó a sí mismo por mí."
,"21":"No rechazo la gracia de Dios; pues si la justicia se obtiene por la ley, entonces Cristo murió inútilmente."
}`)
	CurrentBook.AddChapter(3, `{
"1":"¡Oh insensatos gálatas! ¿Quién os fascinó a vosotros, ante cuyos ojos fue presentada la figura de Jesucristo crucificado?"
,"2":"Solamente quiero saber esto de vosotros: ¿recibisteis el Espíritu por las obras de la ley o por haber aceptado la fe que os anunciaron?"
,"3":"¿Tan insensatos sois que, habiendo comenzado por el Espíritu, termináis en la materia?"
,"4":"Parece imposible que tantas experiencias hayan sido inútiles."
,"5":"Pues el que os da el Espíritu y obra milagros en vosotros, ¿lo hace porque cumplís la ley o porque habéis aceptado la fe que os anunciaron?"
,"6":"Como está escrito: Abrahán creyó en Dios y esto le fue contado como justicia."
,"7":"Sabed, pues, que los que tienen fe, ésos son hijos de Abrahán."
,"8":"Pues la Escritura, previendo que Dios justificaría por la fe a los paganos, anunció con anterioridad a Abrahán: En ti serán bendecidas todas las gentes."
,"9":"De suerte que los que tienen fe son bendecidos con el creyente Abrahán."
,"10":"Pero los que se atienen al cumplimiento de la ley están bajo maldición, como dice la Escritura: Maldito sea el que no cumple todo lo que está escrito en la ley."
,"11":"Es claro que nadie se justifica ante Dios por la ley, porque el justo vivirá gracias a la fe."
,"12":"Pero la ley no procede de la fe, sino que dice: El que cumpla estos preceptos, por ellos vivirá."
,"13":"Cristo nos liberó de la maldición de la ley, haciéndose maldición por nosotros, como dice la Escritura: Maldito el que está colgado en un madero,"
,"14":"para que la bendición de Abrahán hecha en Cristo Jesús se extendiese a todas las naciones, a fin de que, mediante la fe, recibiésemos el Espíritu prometido."
,"15":"Hermanos, voy a hablar a lo humano. Si un hombre hace un testamento en regla, nadie puede anularlo o modificarlo."
,"16":"Ahora bien, Dios hizo las promesas a Abrahán y a su descendencia. No dice 'a tus descendientes', como si fueran muchos, sino a tu descendencia, refiriéndose a Cristo."
,"17":"Lo que quiero decir es esto: Dios hizo un pacto con Abrahán en toda regla; por tanto, una ley, que vino cuatrocientos años después, no pudo anularlo ni dejar sin valor la promesa de Dios."
,"18":"Pues si la herencia depende del cumplimiento de la ley, ya no se debe a la promesa; pero la verdad es que Dios prometió a Abrahán dársela gratuitamente."
,"19":"Entonces, ¿para qué la ley? Fue añadida para declarar lo que era delito hasta que llegara el descendiente a que se refería la promesa. La ley fue promulgada por ángeles a través de un mediador."
,"20":"Pero el mediador no lo es de uno solo, y Dios es uno solo."
,"21":"La ley, por tanto, ¿está contra las promesas de Dios? De ninguna manera. Si se hubiera dado una ley capaz de vivificar, entonces la justicia hubiera sido realmente por la ley."
,"22":"Pero, según la Escritura, todo el mundo está bajo el pecado, para que la promesa de Dios se cumpla en los creyentes por la fe en Jesucristo."
,"23":"Ahora bien, antes de venir la fe estábamos encerrados bajo la custodia de la ley, en espera de la fe que debía manifestarse."
,"24":"De suerte que la ley ha sido nuestro pedagogo hasta Cristo, para que por la fe fuéramos justificados;"
,"25":"pero, después de haber venido la fe, ya no estamos bajo el pedagogo."
,"26":"Porque todos sois hijos de Dios por la fe en Cristo Jesús;"
,"27":"pues los que habéis sido bautizados en Cristo os habéis revestido de Cristo."
,"28":"No hay judío ni griego, no hay esclavo ni libre, no hay hombre ni mujer, pues todos vosotros sois uno en Cristo Jesús."
,"29":"Y si vosotros sois de Cristo, sois descendencia de Abrahán, herederos según la promesa."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Quiero decir esto: Mientras el heredero es niño en nada se diferencia de un esclavo, aunque sea el dueño de todo."
,"2":"Está bajo tutores y administradores hasta el tiempo señalado por el padre."
,"3":"Así también nosotros, cuando éramos menores de edad, estábamos esclavizados bajo los elementos del mundo."
,"4":"Pero cuando se cumplió el tiempo, Dios envió a su Hijo, nacido de una mujer, nacido bajo la ley,"
,"5":"para que redimiese a los que estaban bajo la ley, a fin de que recibiésemos la condición de hijos adoptivos."
,"6":"Y como prueba de que sois hijos, Dios ha enviado a vuestros corazones el Espíritu de su Hijo, que clama: ¡Abba, Padre!"
,"7":"De suerte que ya no eres esclavo, sino hijo; y si eres hijo, eres también heredero por la gracia de Dios."
,"8":"Entonces no conocíais a Dios y erais esclavos de unos dioses que no eran dioses;"
,"9":"pero ahora que conocéis a Dios, o, mejor dicho, que sois conocidos por Dios, ¿cómo os volvéis de nuevo a los débiles y pobres elementos, a los cuales nuevamente queréis servir otra vez como esclavos?"
,"10":"Lleváis cuenta de los días, los meses, las estaciones y los años."
,"11":"Mucho me temo que todo lo que he trabajado entre vosotros haya sido inútil."
,"12":"Hermanos, os ruego que os hagáis como yo, porque yo también me he hecho como vosotros. No me habéis ofendido en nada."
,"13":"Pero sabéis que, debido a una enfermedad que tuve, os anuncié por primera vez el evangelio;"
,"14":"y aunque mi enfermedad fue para vosotros una prueba, no me despreciasteis ni me rechazasteis, sino que me acogisteis como a un ángel de Dios, como a Cristo Jesús."
,"15":"¿Dónde están ahora aquellos entusiasmos vuestros por mí? Doy fe de que, si hubiera sido posible, hasta os hubierais arrancado los ojos para dármelos a mí."
,"16":"¿Y ahora he pasado a ser enemigo vuestro sólo por haberos dicho la verdad?"
,"17":"Os demuestran un afecto de mala ley, os quieren aislar de mí para que los sigáis a ellos."
,"18":"Lo mejor es demostrar un sano interés por los demás; pero siempre, y no solamente cuando estoy entre vosotros."
,"19":"Hijos míos, sufro por vosotros como si os estuviera de nuevo dando a luz hasta que Cristo sea formado en vosotros."
,"20":"Quisiera estar entre vosotros para poder hablaros de la forma conveniente, pues no sé cómo hacerlo."
,"21":"Los que queréis estar bajo la ley, ¿habéis escuchado lo que dice la ley?"
,"22":"En ella se dice: Abrahán tuvo dos hijos: uno de la esclava y otro de la libre."
,"23":"Pero el de la esclava nació de modo natural; el de la libre, sin embargo, en virtud de la promesa."
,"24":"Estas cosas están dichas en sentido alegórico, pues estas mujeres representan dos alianzas; una, la del monte Sinaí, que engendra esclavos, y está representada en Agar."
,"25":"Pues el Sinaí es un monte que está en Arabia, y corresponde a la Jerusalén de ahora, porque ella con sus hijos está sometida a esclavitud."
,"26":"Pero la Jerusalén de arriba es libre, la cual es madre nuestra,"
,"27":"pues dice la Escritura: Alégrate, estéril, que no das a luz; da gritos de alegría tú, que no conoces los dolores del parto, porque muchos son,los hijos de la abandonada, muchos más,que los de la que tiene marido."
,"28":"Hermanos, vosotros, como Isaac, sois hijos de la promesa."
,"29":"Pero igual que entonces el nacido de un modo natural perseguía al que nació en virtud del Espíritu, así también ahora."
,"30":"Pero ¿qué dice la Escritura? Echa fuera a la esclava y a su hijo, pues el hijo de la esclava no será heredero con el hijo de la libre."
,"31":"Por consiguiente, hermanos, no somos hijos de la esclava, sino de la libre."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Cristo nos ha liberado para que seamos hombres libres; permaneced firmes y no os dejéis poner de nuevo el yugo de la esclavitud."
,"2":"Mirad; yo, Pablo, os digo que si os circuncidáis, Cristo de nada os aprovechará."
,"3":"Y declaro de nuevo que todo el que se circuncida queda obligado a cumplir toda la ley."
,"4":"Los que queréis ser justificados por la ley quedáis desligados de Cristo y separados de la gracia."
,"5":"Nosotros aguardamos la justicia esperada por la fe mediante la fe del Espíritu."
,"6":"Si creemos en Cristo, da lo mismo estar o no estar circuncidados; lo que importa es la fe y que esta fe se exprese en obras de amor."
,"7":"Ibais bien. ¿Quién os cortó el camino de la sumisión a la verdad?"
,"8":"No fue el que os llamó."
,"9":"Un poco de levadura hace fermentar toda la masa."
,"10":"Yo confío en que, gracias al Señor, no penséis de otro modo; pero el que os perturba, sea quien sea, recibirá el castigo que merece."
,"11":"Hermanos, en cuanto a mí, si es verdad que sigo predicando la circuncisión, ¿por qué soy todavía perseguido? Entonces, se acabó el escándalo de la cruz."
,"12":"¡Ojalá que se castrasen todos los que os perturban!"
,"13":"Hermanos, vosotros habéis sido llamados a ser hombres libres; pero procurad que la libertad no sea un pretexto para dar rienda suelta a las pasiones, antes bien, servíos unos a otros por amor."
,"14":"Porque toda la ley se resume en ese precepto: Amarás a tu prójimo como a ti mismo."
,"15":"Pero si os mordéis y devoráis los unos a los otros, llegaréis a destruiros mutuamente."
,"16":"Yo os digo: Dejaos conducir por el Espíritu, y no os dejéis arrastrar por las apetencias de la carne."
,"17":"Porque la carne lucha contra el espíritu, y el espíritu contra la carne; pues estas cosas están una frente a la otra para que no hagáis lo que queréis."
,"18":"Pues si os dejáis conducir por el Espíritu, no estáis bajo la ley."
,"19":"Ahora bien, las obras de la carne son bien claras: lujuria, impureza, desenfreno,"
,"20":"idolatría, supersticiones, enemistades, disputas, celos, iras, litigios, divisiones, partidismos,"
,"21":"envidias, homicidios, borracheras, comilonas y cosas semejantes a éstas. Os advierto, como ya antes os advertí, que los que se entregan a estas cosas no heredarán el reino de Dios."
,"22":"Por el contrario, los frutos del Espíritu son: amor, alegría, paz, generosidad, benignidad, bondad, fe,"
,"23":"mansedumbre, continencia; contra estas cosas no hay ley."
,"24":"Los que son de Cristo Jesús han crucificado la carne con sus pasiones y concupiscencias."
,"25":"Si vivimos por el Espíritu, dejémonos conducir por el Espíritu."
,"26":"No busquemos la vanagloria, provocándonos mutuamente y teniendo envidia unos a otros."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Hermanos, si un hombre es sorprendido en alguna falta, vosotros, hombres de espíritu, corregidle con amabilidad. Ten mucho cuidado, pues tú también puedes ser puesto a prueba."
,"2":"Ayudaos unos a otros a llevar las cargas, y así cumpliréis la ley de Cristo."
,"3":"Porque si alguno se imagina ser algo, siendo así que es nada, se engaña a sí mismo."
,"4":"Que cada uno examine su propia conducta, y entonces encontrará en sí mismo, y no en otro, el motivo de sentirse satisfecho;"
,"5":"porque cada uno llevará su propia carga."
,"6":"El que es instruido en la fe, que comparta sus bienes con el que lo instruye."
,"7":"No os engañéis: de Dios no se burla nadie. Pues lo que el hombre haya sembrado, eso mismo cosechará."
,"8":"Porque el que siembra en su propia carne, de la carne cosechará corrupción; pero el que siembra en el espíritu, del espíritu cosechará la vida eterna."
,"9":"No nos cansemos de hacer el bien, porque a su tiempo cosecharemos, si no desfallecemos."
,"10":"Por consiguiente, siempre que tengamos oportunidad, hagamos el bien a todos, y especialmente a los hermanos en la fe."
,"11":"Fijaos con qué letras tan grandes os escribo de mi propia mano."
,"12":"Los que os quieren obligar a circuncidaos lo hacen únicamente para quedar bien ante los demás y no ser perseguidos por causa de la cruz de Cristo."
,"13":"Ni los mismos circuncidados guardan la ley; pero quieren que vosotros os circuncidéis para presumir de que ellos os obligaron a hacerlo."
,"14":"Yo, por mi parte, sólo quiero presumir de la cruz de nuestro Señor Jesucristo, por la cual el mundo está crucificado para mí y yo para el mundo."
,"15":"Da igual estar o no estar circuncidado. Lo que importa es ser un hombre nuevo."
,"16":"Paz y misericordia a todos los que vivan conforme a esta regla y al Israel de Dios."
,"17":"Que en adelante nadie me haga sufrir más, que bastante tengo con llevar marcadas en mi cuerpo las señales de Jesús, el Señor."
,"18":"Hermanos, que la gracia de nuestro Señor Jesucristo esté con vosotros. Amén."
}`)

}
func ES_LSB_LoadNPPMChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Pablo, preso por Cristo Jesús, y el hermano Timoteo, a Filemón, amigo querido y colaborador nuestro;"
,"2":"a la hermana Apia, a Arquipo, nuestro compañero de fatigas, y a la Iglesia que se reúne en su casa:"
,"3":"os deseamos la gracia y la paz de Dios Padre y de Jesucristo, el Señor."
,"4":"Te tengo siempre presente en mis oraciones y doy gracias a Dios,"
,"5":"al oír hablar del amor y de la fe que profesas a Jesús, el Señor, y a todo el pueblo de Dios."
,"6":"Yo pido a Dios que esta fe, que nos es común, se muestre activa y dé a conocer todo el bien que se realiza en nosotros por Cristo."
,"7":"Tu amor me ha colmado de alegría y de consuelo, porque, gracias a ti, hermano, el corazón de los creyentes se ha tranquilizado."
,"8":"Por lo cual, aunque tengo plena libertad en Cristo para ordenarte lo que debes hacer,"
,"9":"prefiero apelar a tu amor. Yo, Pablo, viejo ya y ahora, además, preso por Cristo Jesús,"
,"10":"te pido un favor para Onésimo, mi hijo querido, al que he engendrado a la fe en mi prisión."
,"11":"En otro tiempo fue inútil para ti, pero ahora es bien útil para ti y para mí."
,"12":"Te lo envío como si te enviara mi propio corazón."
,"13":"Yo querría retenerlo a mi lado, para que me ayudase en tu lugar en mi prisión por el evangelio;"
,"14":"pero nada he querido hacer sin tu consentimiento, a fin de que me hagas esta buena obra no a la fuerza, sino de buena gana."
,"15":"Tal vez por esto se separó de ti, para que lo tuvieras para siempre,"
,"16":"no ya como esclavo, sino como un hermano querido, que lo es muchísimo para mí, ¡cuánto más debe serlo para ti como persona y como cristiano!"
,"17":"Si me tienes por amigo, recíbele a él como me recibirías a mí."
,"18":"Si en algo te ofendió o algo te debe, ponlo a mi cuenta."
,"19":"Yo, Pablo, lo firmo con mi puño y letra; yo pagaré, aunque podría decirte que tú te me debes a mí por entero."
,"20":"Hermano, como cristiano que eres, hazme este favor; dame este consuelo en Cristo."
,"21":"Te he escrito confiado en que me atenderás, sabiendo que tú harás más de lo que te pido."
,"22":"A la vez ve preparándome el hospedaje, pues espero que, gracias a vuestras oraciones, volveré pronto a veros."
,"23":"Te saluda Epafras, mi compañero de prisión por Cristo Jesús;"
,"24":"Marcos, Aristarco, Dimas y Lucas, mis colaboradores."
,"25":"La gracia de Jesucristo, el Señor, esté con vosotros."
}`)

}
func ES_LSB_LoadNPPPChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Pablo y Timoteo, siervos de Jesucristo, a todos los cristianos que viven en Filipos con sus obispos y diáconos."
,"2":"Os deseamos la gracia y la paz de Dios nuestro Padre y de Jesucristo, el Señor."
,"3":"Siempre que me acuerdo de vosotros doy gracias a mi Dios;"
,"4":"y cuando pido por vosotros en mis oraciones, lo hago con alegría,"
,"5":"por vuestra participación en el progreso del evangelio desde el primer día hasta ahora,"
,"6":"persuadido de que quien comenzó en vosotros la buena obra la llevará a feliz término para el día de Cristo Jesús."
,"7":"Es justo que yo sienta así de todos vosotros, pues os llevo en el corazón, ya que compartís conmigo el privilegio de estar preso y de defender y consolidar el evangelio."
,"8":"Dios es testigo de todo lo que os quiero en las entrañas de Cristo Jesús."
,"9":"Y le pido que vuestro amor crezca cada día más en conocimiento y en discreción,"
,"10":"para que sepáis discernir lo más perfecto, a fin de que seáis puros e irreprensibles para el día de Cristo,"
,"11":"llenos de frutos de justicia por Jesucristo, para gloria y alabanza de Dios."
,"12":"Hermanos, quiero que sepáis que las cosas que me han ocurrido han venido a favorecer el progreso del evangelio,"
,"13":"hasta el punto de que en palacio y en todo lugar es notorio que llevo las cadenas de Cristo;"
,"14":"y la mayoría de los hermanos, alentados en el Señor por mis cadenas, se muestran más intrépidos, anunciando sin temor la palabra de Dios."
,"15":"Cierto que algunos predican a Cristo por espíritu de envidia y competencia, pero otros lo hacen con recta intención,"
,"16":"éstos movidos por el amor, sabiendo que estoy puesto para defensa del evangelio;"
,"17":"aquéllos por rivalidad predican a Cristo, creyendo que así hacen más dura mi prisión."
,"18":"Pero, al fin y al cabo, ¿qué importa? De cualquier manera que Cristo sea anunciado, hipócrita o sinceramente, yo me alegro, y me alegraré;"
,"19":"pues sé que esto redundará en provecho mío por vuestra oración y la asistencia del Espíritu de Jesucristo."
,"20":"Con viva esperanza confío en que en nada seré defraudado, sino que con toda seguridad, como siempre, también ahora Jesucristo será glorificado en mi cuerpo, sea por la vida, sea por la muerte."
,"21":"Pues para mí la vida es Cristo, y la muerte ganancia."
,"22":"Mas si continuar viviendo es para mí fruto de apostolado, no sé qué elegir."
,"23":"Me siento apremiado por ambas partes: por una, deseo la muerte para estar con Cristo, lo que es mejor para mí;"
,"24":"por otra, deseo continuar viviendo, lo que juzgo más necesario para vosotros."
,"25":"Estoy seguro de que me quedaré y permaneceré con vosotros para vuestro progreso y gozo en la fe."
,"26":"Así, cuando vaya por segunda vez a veros, tendréis un nuevo motivo de satisfacción en Cristo Jesús."
,"27":"Os pido sobre todo que viváis una vida digna del evangelio de Cristo para que, sea que vaya y lo vea, sea que ausente lo oiga, perseveréis firmes en un mismo espíritu, luchando con una sola alma por la fe del evangelio,"
,"28":"sin dejaros intimidar en lo más mínimo ante vuestros adversarios; lo que para ellos es señal de perdición, lo es en cambio para vosotros de salvación, y esto por obra de Dios."
,"29":"Pues vosotros tenéis el privilegio no sólo de creer en Cristo, sino también de padecer por él,"
,"30":"teniendo que sostener el mismo combate que antes visteis en mí y ahora oís de mí."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Si tenéis algún consuelo en Cristo, alguna muestra de amor; si estáis unidos en el mismo Espíritu; si tenéis entrañas de misericordia,"
,"2":"llenadme de gozo teniendo todos un mismo pensar, un mismo amor, una sola alma y unos mismos sentimientos."
,"3":"No hagáis cosa alguna por espíritu de rivalidad o de vanagloria; sed humildes y tened a los demás por superiores a vosotros,"
,"4":"preocupándoos no sólo de vuestras cosas, sino también de las cosas de los demás."
,"5":"Procurad tener los mismos sentimientos que tuvo Cristo Jesús,"
,"6":"el cual, teniendo la naturaleza gloriosa de Dios, no consideró como codiciable tesoro el mantenerse igual a Dios,"
,"7":"sino que se anonadó a sí mismo tomando la naturaleza de siervo, haciéndose semejante a los hombres;"
,"8":"y, en su condición de hombre, se humilló a sí mismo haciéndose obediente hasta la muerte, y muerte de cruz."
,"9":"Por ello Dios le exaltó sobremanera y le otorgó un nombre que está sobre cualquier otro nombre,"
,"10":"para que al nombre de Jesús doblen su rodilla los seres del cielo, de la tierra y del abismo,"
,"11":"y toda lengua confiese que Jesucristo es Señor para gloria de Dios Padre."
,"12":"Por tanto, queridos hermanos, como siempre habéis obedecido, no sólo durante mi presencia, sino también y mucho más mientras estuve ausente, trabajad por vuestra salvación con profundo acatamiento"
,"13":"pues es Dios el que obra en vosotros el querer y el obrar, según su voluntad."
,"14":"Hacedlo todo sin críticas ni discusiones,"
,"15":"a fin de que seáis irreprochables y sin malicia, hijos de Dios irreprensibles en medio de esta generación perversa y descarriada, en medio de la cual brilláis como astros en el universo,"
,"16":"manteniendo firme la palabra de vida, de modo que pueda presumir en el día de Cristo de no haber corrido ni trabajado inútilmente."
,"17":"Y aunque tuviera que derramar mi sangre como libación sobre el sacrificio y la ofrenda de vuestra fe, me gozo y congratulo con todos vosotros."
,"18":"Alegraos también vosotros de esto mismo y congratulaos conmigo."
,"19":"Confiado en Jesús, el Señor, espero enviaros pronto a Timoteo, a fin de que también yo me sienta reconfortado al tener noticias de vosotros."
,"20":"Pues a nadie tengo de tan idénticos sentimientos conmigo, que tan sinceramente se preocupe de vuestras cosas;"
,"21":"pues todos buscan sus intereses personales, no los de Jesucristo."
,"22":"Vosotros conocéis su probada virtud, que como un hijo con su padre se ha conducido conmigo en la causa del evangelio."
,"23":"Pienso enviároslo tan pronto como pueda entrever el resultado de mi causa, y,"
,"24":"confiado en el Señor, espero ir yo mismo pronto."
,"25":"Entre tanto he juzgado necesario enviaros a Epafrodito, nuestro hermano, colaborador y compañero de fatigas, el que vosotros me enviasteis con el encargo de socorrerme en mis necesidades,"
,"26":"pues está deseando veros a todos vosotros y siente profunda inquietud porque sabe que ha llegado a vosotros la noticia de su enfermedad."
,"27":"Cierto que enfermó y estuvo a las puertas de la muerte, pero Dios tuvo misericordia de él; y no sólo de él, sino también de mí, para que no tuviese yo tristeza sobre tristeza."
,"28":"Por ello os lo envío más prontamente, a fin de que, viéndole de nuevo, os gocéis y yo me sienta aliviado en mi tristeza."
,"29":"Recibidlo cristianamente, con alegría, y tened en honor a personas como él,"
,"30":"que por la obra de Cristo estuvo a punto de morir poniendo en peligro su vida para proporcionarme en vuestra ausencia los servicios que vosotros no me podíais prestar."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Por lo demás, hermanos míos, alegraos en el Señor. No me resulta molesto escribiros las mismas cosas, y a vosotros os es útil."
,"2":"¡Cuidado con los perros, cuidado con los malos obreros, cuidado con los de la circuncisión!"
,"3":"La verdadera circuncisión somos nosotros, los que damos culto llevados del Espíritu de Dios y estamos orgullosos de Cristo Jesús, no poniendo nuestra confianza en algo humano,"
,"4":"aunque yo sí podría confiar en lo humano; pues si alguno cree poder confiar en lo humano, más podría yo."
,"5":"Fui circuncidado al octavo día; soy del linaje de Israel; de la tribu de Benjamín; hebreo, hijo de hebreos y, por lo que a la ley se refiere, fariseo;"
,"6":"por amor a la ley fui perseguidor de la Iglesia; en cuanto a la justicia que viene del cumplimiento de la ley, irreprensible."
,"7":"Pero todo lo que tuve entonces por ventaja, lo juzgo ahora daño por Cristo;"
,"8":"más aún, todo lo tengo por pérdida ante el sublime conocimiento de Cristo Jesús, mi Señor, por quien he sacrificado todas las cosas, y las tengo por basura con tal de ganar a Cristo"
,"9":"y encontrarme en él; no en posesión de mi justicia, la que viene de la ley, sino de la que se obtiene por la fe en Cristo, la justicia de Dios, que se funda en la fe,"
,"10":"a fin de conocerle a él y la virtud de su resurrección y la participación en sus padecimientos, configurándome con su muerte"
,"11":"para alcanzar la resurrección de los muertos."
,"12":"No quiero decir con esto que haya alcanzado ya la perfección, sino que corro tras ella con la pretensión de darle alcance, por cuanto yo mismo fui alcanzado por Cristo Jesús."
,"13":"Hermanos, yo no creo haberla alcanzado ya; de una cosa me ocupo: olvidando lo que queda atrás, me lanzo en persecución de lo que está delante;"
,"14":"corro hacia la meta, hacia la vocación celeste de Dios en Cristo Jesús."
,"15":"Así pues, cuantos somos perfectos sintamos de este modo; y si alguno siente de otra manera, Dios os iluminará a este propósito."
,"16":"De cualquier modo, en la meta que hubiéramos alcanzado perseveremos firmes."
,"17":"Hermanos, seguid todos mi ejemplo y observad a los que se conducen conforme al modelo que tenéis en mí."
,"18":"Pues hay muchos entre vosotros, de quienes muchas veces os dije, y ahora tengo que repetirlo con lágrimas en los ojos, que son enemigos de la cruz de Cristo;"
,"19":"su fin será la perdición, su dios es su vientre, su gloria lo que los deshonra y tienen puesto su corazón en las cosas de la tierra."
,"20":"Nuestra patria está en los cielos, de donde esperamos al Salvador y Señor Jesucristo,"
,"21":"el cual transformará nuestro cuerpo lleno de miserias conforme a su cuerpo glorioso en virtud del poder que tiene para someter a sí todas las cosas."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Por tanto, hermanos míos queridísimos, mi alegría y mi corona, manteneos firmes en el Señor, queridos míos."
,"2":"Ruego a Evodia y Síntique que tengan unos mismos sentimientos en el Señor."
,"3":"Y a ti, leal compañero, te ruego que prestes tu ayuda a éstas, que han trabajado mucho en el evangelio conmigo y con Clemente y demás colaboradores míos, cuyos nombres están en el libro de la vida."
,"4":"Alegraos en el Señor siempre; lo repito: alegraos."
,"5":"Que vuestra bondad sea notoria a todos los hombres. El Señor está cerca."
,"6":"No os inquietéis por cosa alguna, sino más bien en toda oración y plegaria presentad al Señor vuestras necesidades con acción de gracias."
,"7":"Y la paz de Dios, que sobrepasa toda inteligencia, guardará vuestros corazones y vuestros pensamientos en Cristo Jesús."
,"8":"Por lo demás, hermanos, considerad lo que hay de verdadero, de noble, de justo, de puro, de amable, de buena fama, de virtuoso, de laudable;"
,"9":"practicad lo que habéis aprendido y recibido, lo que habéis oído y visto en mí, y el Dios de la paz estará con vosotros."
,"10":"He sentido una gran alegría en el Señor porque habéis reavivado vuestros sentimientos por mí; vosotros los sentíais, pero no habíais tenido ocasión de manifestarlos."
,"11":"No digo esto inducido por mi indigencia, pues he aprendido a contentarme con mi suerte."
,"12":"Sé carecer de lo necesario y vivir en la abundancia; estoy enseñado a todas y cada una de estas cosas, a sentirme harto y a tener hambre, a nadar en la abundancia y a experimentar estrecheces."
,"13":"Todo lo puedo en aquel que me conforta."
,"14":"Habéis hecho bien, sin embargo, en haceros cargo de mi tribulación."
,"15":"Sabéis muy bien vosotros, filipenses, que al principio de la predicación del evangelio, cuando partí de Macedonia, ninguna iglesia tuvo conmigo cuenta de 'haber' y 'debe', a no ser vosotros solos;"
,"16":"pues ya en Tesalónica me enviasteis una y otra vez con qué atender a mi necesidad."
,"17":"No es que busque que me deis algo; lo que busco es que se acreciente el fruto que redunda en favor vuestro."
,"18":"Tengo lo que podía necesitar, y más todavía; tengo de sobra después de haber recibido de Epafrodito vuestros socorros, ofrenda de suave olor, sacrificio grato, agradable a Dios."
,"19":"Mi Dios, a su vez, proveerá colmadamente a vuestra indigencia, según sus riquezas, en Cristo Jesús."
,"20":"A Dios, Padre nuestro, la gloria por los siglos de los siglos. Amén."
,"21":"Saludad a todos los que creen en Cristo Jesús. Os saludan los hermanos que están conmigo."
,"22":"Os saludan todos los que pertenecen al pueblo de Dios, en especial los de la casa del César."
,"23":"La gracia de Jesucristo, el Señor, esté con vosotros."
}`)

}
func ES_LSB_LoadNPRMChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Pablo, siervo de Jesucristo, apóstol por la llamada de Dios, elegido para predicar el evangelio de Dios,"
,"2":"que por sus profetas había anunciado antes en las Escrituras Santas,"
,"3":"acerca de su Hijo (nacido de la estirpe de David según la carne,"
,"4":"constituido Hijo de Dios en poder según el Espíritu de santificación por su resurrección de la muerte) Jesucristo, nuestro Señor,"
,"5":"por quien hemos recibido el don del apostolado para conseguir en honor de su nombre que obedezcan a la fe todos los pueblos,"
,"6":"entre los cuales estáis también vosotros, llamados por Jesucristo."
,"7":"A todos los que estáis en Roma, predilectos de Dios, llamados y consagrados, os deseo la gracia y la paz de Dios, nuestro Padre, y de Jesucristo, el Señor."
,"8":"En primer lugar doy gracias a mi Dios, por medio de Jesucristo, por todos vosotros, porque vuestra fe es conocida en todo el mundo."
,"9":"Dios, a quien sirvo de todo corazón predicando el evangelio de su Hijo, es testigo de que os recuerdo constantemente,"
,"10":"pidiendo a Dios que, si es su voluntad, pueda algún día por fin ir a visitaros."
,"11":"Tengo muchas ganas de veros, para comunicaros algún don espiritual que os fortalezca."
,"12":"Así nos animaríamos mutuamente unos a otros con la fe, la vuestra y la mía."
,"13":"Quiero que sepáis, hermanos, que muchas veces me he propuesto ir a veros (pero hasta el presente no he podido) para lograr algún fruto también entre vosotros como entre los demás pueblos."
,"14":"Me debo por igual a griegos y a extranjeros, a sabios y a ignorantes."
,"15":"De aquí mi deseo de evangelizaros también a vosotros, los que estáis en Roma."
,"16":"Yo no me avergüenzo del evangelio, que es poder de Dios para la salvación de todo el que cree, del judío primero y también del griego."
,"17":"Porque la justicia de Dios se manifiesta en él por la fe en continuo crecimiento, según está escrito: El justo vivirá por la fe."
,"18":"La ira de Dios se manifiesta desde el cielo contra toda la impiedad e injusticia de los hombres que detienen la verdad con la injusticia;"
,"19":"ya que lo que se puede conocer de Dios, ellos lo tienen a la vista, pues Dios mismo se lo ha manifestado."
,"20":"Desde la creación del mundo, lo invisible de Dios, su eterno poder y su divinidad, se pueden descubrir a través de las cosas creadas. Hasta el punto que no tienen excusa"
,"21":"porque, conociendo a Dios, no lo glorificaron ni le dieron gracias; por el contrario, su mente se dedicó a razonamientos vanos y su insensato corazón se llenó de oscuridad."
,"22":"Alardeando de sabios, se hicieron necios;"
,"23":"y cambiaron la gloria del Dios inmortal por la imagen del hombre mortal, de aves, de cuadrúpedos y de reptiles."
,"24":"Por eso Dios los abandonó a sus bajas pasiones y a la inmoralidad, de forma que ellos mismos degradan sus propios cuerpos;"
,"25":"cambiaron la verdad de Dios por la mentira, y adoraron y dieron culto a la criatura en lugar de al creador, el cual es bendito por los siglos. Amén."
,"26":"Por esto Dios los abandonó a sus pasiones vergonzosas; pues, por una parte, sus mujeres cambiaron las relaciones naturales del sexo por otras contra la naturaleza."
,"27":"Por otra, también los hombres, dejando las relaciones naturales con la mujer, se entregaron a la homosexualidad, hombres con hombres, cometiendo acciones vergonzosas y recibiendo en su propio cuerpo el castigo merecido por su extravío."
,"28":"Y como no se preocuparon de tener el conocimiento cabal de Dios, Dios los abandonó a su mente depravada, que los empuja a hacer lo que no deben."
,"29":"Están llenos de injusticia, malicia, perversidad, codicia, maldad; rebosantes de odio, de asesinatos, de disputas, de engaño, de malignidad; chismosos,"
,"30":"calumniadores, aborrecedores de Dios, insolentes, altaneros, soberbios, inventores de maldades, desobedientes a los padres,"
,"31":"insensatos, desleales, sin amor y sin piedad;"
,"32":"saben bien que Dios declara reos de muerte a los que hacen tales cosas y, sin embargo, ellos las hacen y aplauden a los que las hacen."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Por eso no tienes excusa, tú, quienquiera que seas, al juzgar; porque en lo que juzgas a otro, a ti mismo te condenas, ya que haces tú las mismas cosas que juzgas."
,"2":"Pues sabemos que el juicio de Dios contra los que hacen tales cosas es conforme a la verdad."
,"3":"¿Y piensas que escaparás al juicio de Dios tú que juzgas a los que hacen tales cosas?"
,"4":"¿O es que desprecias la grandeza de su bondad, de su paciencia y de su generosidad, y no te das cuenta de que la bondad de Dios te empuja al arrepentimiento?"
,"5":"Tú, con tu corazón impenitente y duro, estás amontonando castigos para el día del castigo, cuando se manifieste el justo juicio de Dios,"
,"6":"el cual pagará a cada uno según sus obras:"
,"7":"la vida eterna a los que, mediante la perseverancia en las buenas obras, buscan la gloria, el honor y la inmortalidad;"
,"8":"pero a los egoístas, a los que rechazan la verdad y se entregan a la injusticia, un castigo implacable."
,"9":"Tribulación y angustia para todo el que obra el mal, tanto judío como griego;"
,"10":"gloria, en cambio, honor y paz a todo el que obra bien, tanto judío como griego;"
,"11":"pues ante Dios todos son iguales."
,"12":"Todos los que pecaron sin estar bajo la ley, sin la ley también perecerán; y cuantos pecaron bajo la ley, según la ley serán juzgados."
,"13":"Porque para ser justos ante Dios no basta con escuchar la ley: hay que cumplirla."
,"14":"Pues cuando los paganos, que no tienen ley, practican de una manera natural lo que manda la ley, aunque no tengan ley, ellos mismos son su propia ley."
,"15":"Ellos muestran que llevan la ley escrita en sus corazones, según lo atestiguan su conciencia y sus pensamientos, que unas veces los acusan y otras los defienden,"
,"16":"como se verá el día en que juzgue Dios los secretos del hombre, por medio de Jesucristo y según el evangelio que yo predico. Los judíos que violan la ley tienen mayor culpa. "
,"17":"Si tú te llamas judío, confías en la ley, estás orgulloso de tu Dios,"
,"18":"conoces su voluntad, sabes discernir lo mejor instruido por la ley,"
,"19":"presumes de ser tú mismo guía de ciegos, luz de los que están en tinieblas,"
,"20":"educador de ignorantes, maestro de niños por tener en la ley la norma de la ciencia y de la verdad;"
,"21":"tú, que enseñas a otro, ¿por qué no te enseñas a ti mismo? Tú, que predicas que no hay que robar, ¿por qué robas?"
,"22":"Tú, que dices que no hay que cometer adulterio, ¿por qué lo cometes? Tú, que aborreces a los ídolos, ¿por qué saqueas los templos?"
,"23":"Tú, que presumes de la ley, ¿por qué ofendes a Dios violando la ley?"
,"24":"Pues por vuestra culpa los paganos blasfeman contra el nombre de Dios, como dice la Escritura."
,"25":"La circuncisión ciertamente es útil, si cumples la ley; pero si no la cumples, da igual que estés circuncidado o no lo estés."
,"26":"Si los que no están circuncidados cumplen los preceptos de la ley, ¿no serán considerados como si lo estuvieran?"
,"27":"Aunque no esté físicamente circuncidado, si cumple la ley, te juzgará a ti que estás circuncidado y tienes la ley, pero que no la cumples."
,"28":"Porque no es judío el que lo es exteriormente, ni es circuncisión lo que aparece exteriormente en la carne;"
,"29":"sino que es judío el que lo es en el interior, y la verdadera circuncisión es la del corazón, según el espíritu, no según la letra; cuya alabanza no viene de los hombres, sino de Dios."
}`)
	CurrentBook.AddChapter(3, `{
"1":"¿Cuál es, entonces, la ventaja del judío, o cuál es la utilidad de la circuncisión?"
,"2":"Grande, en todos los sentidos. En primer lugar, porque le fueron confiadas las promesas de Dios."
,"3":"No importa que algunos fueran infieles. ¿Es que su infidelidad va a anular la fidelidad de Dios?"
,"4":"¡Nunca jamás! Pues es necesario reconocer que Dios es leal y los hombres desleales, como dice la Escritura: Tus palabras demostrarán que eres inocente y saldrás vencedor en el juicio."
,"5":"Y si nuestra injusticia hace resaltar la justicia de Dios, ¿qué diremos? ¿Es que Dios es injusto al descargar su ira? Hablo con criterio humano."
,"6":"¡De ninguna manera! Si no, ¿cómo podría Dios juzgar al mundo?"
,"7":"Si mi infidelidad resalta y engrandece la fidelidad de Dios, ¿por qué yo voy a ser condenado como pecador?"
,"8":"Entonces, ¿por qué -como se nos calumnia y como afirman algunos que decimos nosotros- no hemos de hacer el mal para que venga el bien? La condenación de éstos es justa."
,"9":"Entonces, ¿qué? ¿Tenemos alguna ventaja? Ninguna. Pues hemos probado antes que todos, tanto los judíos como los paganos, están bajo pecado,"
,"10":"como dice la Escritura: No hay un justo, ni siquiera uno;"
,"11":"no hay ni un cuerdo, no hay quien busque a Dios."
,"12":"Todos descarriados, en masa pervertidos, no hay quien haga el bien, ni uno siquiera."
,"13":"Sepulcro abierto es su garganta, con sus lenguas urdieron engaños, veneno de áspides bajo sus labios."
,"14":"Su boca está llena de maldición y amargura."
,"15":"Veloces son sus pies,para derramar sangre,"
,"16":"ruina e infelicidad en sus caminos;"
,"17":"no conocen el camino de la paz."
,"18":"El temor de Dios no existe para ellos."
,"19":"Ahora bien, sabemos que todo lo que dice la ley lo dice para los que están bajo la ley; para que toda boca enmudezca y el mundo entero se reconozca culpable ante Dios."
,"20":"Porque por las obras de la ley no será justificado mortal alguno delante de él; pues por la ley tenemos solamente el conocimiento del pecado."
,"21":"Pero ahora, sin ley, se ha manifestado la justicia de Dios, atestiguada por la ley y los profetas;"
,"22":"justicia de Dios mediante la fe en Jesucristo, para todos los creyentes, sin distinción alguna;"
,"23":"porque todos pecaron y están privados de la gloria de Dios;"
,"24":"ahora son justificados gratuitamente por su gracia, mediante la redención de Cristo Jesús,"
,"25":"a quien Dios ha propuesto como propiciación para que, mediante la fe, se obtenga por su sangre el perdón de los pecados. Puso de manifiesto su justicia al pasar pacientemente por alto los pecados del pasado,"
,"26":"pero al presente la pone más aún demostrando que él es justo y es quien justifica al que tiene fe en Jesús."
,"27":"¿Dónde queda el orgullo? Ha sido eliminado. ¿Por qué ley? ¿La de las obras? No, sino por la ley de la fe."
,"28":"Decimos, pues, con razón, que el hombre es justificado por la fe sin la observancia de la ley."
,"29":"¿O es que Dios es solamente Dios de los judíos? ¿No lo es también de los paganos? Sí, también de los paganos;"
,"30":"porque sólo hay un Dios, que justificará por la fe tanto a los circuncidados como a los no circuncidados."
,"31":"¿Quiere decir esto que anulamos la ley con la fe? De ninguna manera. Al contrario, consolidamos la ley."
}`)
	CurrentBook.AddChapter(4, `{
"1":"¿Qué diremos, entonces, de Abrahán, nuestro padre carnal?"
,"2":"Si Abrahán hubiera sido justificado por el cumplimiento de la ley, podría estar orgulloso, aunque nunca ante Dios."
,"3":"Pero ¿qué dice la Escritura?: Abrahán creyó en Dios y le fue contado como justicia."
,"4":"Ahora bien, al que trabaja no se le abona el jornal como una gratificación, sino como una deuda;"
,"5":"en cambio, al que no trabaja, pero cree en el que justifica al culpable, su fe se le cuenta como justicia."
,"6":"Así también David llama bienaventurado al hombre a quien Dios le cuenta la justicia independientemente de las obras:"
,"7":"Dichoso aquel a quien,se le ha perdonado la culpa,y se ha cubierto su pecado."
,"8":"Dichoso aquel a quien el Señor,no le tiene en cuenta su delito. La circuncisión, señal de la justicia por la fe."
,"9":"Esta bienaventuranza, ¿es sólo para los que están circuncidados o también para los que no lo están?"
,"10":"Porque decimos que a Abrahán la fe le fue contada como justicia. ¿Cuándo le fue tenido esto en cuenta? ¿Antes o después de la circuncisión? No después, sino antes."
,"11":"Y recibió la señal de la circuncisión como sello de la justicia que había obtenido antes de la circuncisión; así se convertía en padre de todos los no circuncidados que creyesen, para que también a ellos se les contase como justicia;"
,"12":"y padre también de los circuncidados, que no sólo están circuncidados, sino que siguen también las huellas de la fe de nuestro padre Abrahán cuando no estaba circuncidado."
,"13":"A Abrahán y a su descendencia le fue hecha la promesa de ser él el heredero del mundo, no por la ley, sino por la justicia que viene de la fe."
,"14":"Porque si los hijos de la ley son los herederos, la fe queda sin valor y la promesa anulada."
,"15":"En realidad, la ley lleva consigo el castigo; pero donde no hay ley no hay transgresión de la ley."
,"16":"Por esto la justicia viene de la fe, para que sea gratuita, a fin de que sea firme la promesa a toda la descendencia; no sólo a la que es por la fe de Abrahán, el cual es padre de todos nosotros,"
,"17":"como dice la Escritura: Te he constituido padre de muchos pueblos. Lo es delante de Dios, en quien creyó; el Dios que da la vida a los muertos y llama a la existencia a las cosas que no existen."
,"18":"Abrahán, apoyado en la esperanza, creyó, contra toda esperanza, que llegaría a ser padre de muchos pueblos, tal y como Dios había dicho: Así será tu descendencia."
,"19":"Su fe no decayó, aunque veía que su cuerpo estaba ya sin vigor al tener casi cien años, y que el seno de Sara estaba ya como muerto."
,"20":"Ante la promesa de Dios no dudó ni desconfió, sino que se reafirmó en la fe, dando gloria a Dios,"
,"21":"bien convencido de que él es poderoso para cumplir lo que ha prometido,"
,"22":"por lo cual le fue también contado como justicia."
,"23":"Eso de 'le fue contado' no se escribió solamente por él,"
,"24":"también por nosotros, a quienes se ha de contar; a los que creemos en el que resucitó a Jesús, nuestro Señor, de entre los muertos,"
,"25":"el cual fue entregado por nuestros pecados y resucitado para nuestra justificación."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Justificados por la fe, estamos en paz con Dios por nuestro Señor Jesucristo."
,"2":"A él debemos, en virtud de la fe, este estado de gracia, en que nos mantenemos firmes y nos alegramos con la esperanza de alcanzar la gloria de Dios."
,"3":"Y no sólo esto, sino que nos alegramos también en los sufrimientos, conscientes de que los sufrimientos producen la paciencia,"
,"4":"la paciencia consolida la fidelidad, la fidelidad consolidada produce la esperanza"
,"5":"y la esperanza no nos defrauda, porque el amor de Dios ha sido derramado en nuestros corazones por medio del Espíritu Santo que nos ha dado."
,"6":"Pues Cristo, cuando aún éramos nosotros débiles, en el tiempo ya establecido, murió por los malvados."
,"7":"Difícilmente habrá quien esté dispuesto a morir por un hombre justo, aunque por un hombre de bien tal vez alguien lo esté;"
,"8":"pero Dios mostró su amor para con nosotros en que, siendo aún pecadores, Cristo murió por nosotros."
,"9":"Con mucha más razón, justificados ahora por su sangre, seremos librados por él del castigo."
,"10":"Porque si, siendo enemigos, fuimos reconciliados con Dios por medio de la muerte de su Hijo, mucho más, una vez reconciliados, seremos salvados por su vida."
,"11":"Más aún: nos alegramos en Dios por nuestro Señor Jesucristo, por medio del cual hemos conseguido la reconciliación."
,"12":"Por tanto, así como por un hombre entró el pecado en el mundo, y por el pecado la muerte, y así la muerte pasó a todos los hombres, porque todos pecaron..."
,"13":"Pues ya antes de la ley se cometían delitos en el mundo, pero cuando no hay ley, el delito no se toma en cuenta;"
,"14":"sin embargo, la muerte reinó desde Adán hasta Moisés, aun sobre aquellos que no habían cometido un delito como el de Adán, que es figura del que había de venir."
,"15":"Pero el delito de Adán no puede compararse con el don de Dios. Si por el delito de uno solo murieron todos, con mayor razón el don de Dios, ofrecido generosamente por un solo hombre, Jesucristo, se concede más abundantemente a todos."
,"16":"El delito de uno solo no puede compararse con el don de Dios, pues por un solo delito vino la condenación, y por el don de Dios, a pesar de muchos delitos, vino la absolución."
,"17":"Si la muerte reinó como consecuencia del delito de uno solo, con más razón reinarán en la vida por medio de uno solo, Jesucristo, los que han recibido tan abundantemente la gracia y el don de la justicia."
,"18":"Como el delito de uno solo trajo la condenación a todos, así la justicia de uno solo trae a todos la justificación que da la vida."
,"19":"Porque como por la desobediencia de un solo hombre fueron constituidos pecadores todos, así también por la obediencia de uno solo serán todos constituidos justos."
,"20":"La ley llegó para que abundase el delito; pero donde abundó el delito, sobreabundó la gracia,"
,"21":"para que, como el delito trajo el reinado de la muerte, así también la gracia trajera el reinado de la justicia para la vida eterna por medio de Jesucristo, nuestro Señor."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Entonces, ¿qué diremos? ¿Permaneceremos en el pecado para que abunde la gracia?"
,"2":"¡Nunca jamás! Los que hemos muerto al pecado, ¿cómo vamos a seguir viviendo en él?"
,"3":"¿No sabéis que, al quedar unidos a Cristo mediante el bautismo, hemos quedado unidos a su muerte?"
,"4":"Por el bautismo fuimos sepultados con Cristo y morimos, para que así como Cristo fue resucitado de entre los muertos por la gloria del Padre, así también nosotros caminemos en nueva vida."
,"5":"Pues si hemos llegado a ser una misma cosa con él por una muerte semejante a la suya, también lo seremos por una resurrección parecida."
,"6":"Sabemos que nuestro hombre viejo ha sido crucificado con él para que el cuerpo del pecado sea destruido, a fin de que ya no seamos esclavos del pecado;"
,"7":"pues el que muere queda libre del pecado."
,"8":"Y si morimos con Cristo, creemos que también viviremos con él;"
,"9":"sabemos que Cristo, resucitado de entre los muertos, ya no vuelve a morir, la muerte ya no tiene dominio sobre él."
,"10":"Al morir, murió al pecado una vez para siempre; pero al vivir, vive para Dios."
,"11":"Así, también vosotros consideraos muertos al pecado, pero vivos para Dios en unión con Cristo Jesús."
,"12":"Que el pecado no reine más en vuestro cuerpo mortal, y que no os obligue a obedecer a vuestras bajas pasiones."
,"13":"No entreguéis vuestros miembros al pecado como instrumentos de injusticia. Al contrario, entregaos a Dios como muertos que han vuelto a la vida, entregad vuestros miembros a Dios como instrumentos de justicia;"
,"14":"pues el pecado no tendrá dominio sobre vosotros, porque no estáis bajo el dominio de la ley, sino bajo la acción de la gracia."
,"15":"Entonces, ¿qué? ¿Vamos a pecar porque no estamos bajo el dominio de la ley, sino bajo la acción de la gracia? Eso, ¡jamás!"
,"16":"¿No sabéis que al entregaros a alguien como esclavos para obedecerle, sois esclavos de aquel a quien obedecéis? Si obedecéis al pecado, terminaréis en la muerte; y si obedecéis a Dios, en la justicia."
,"17":"Pero gracias a Dios vosotros, después de haber sido esclavos del pecado, habéis obedecido de todo corazón a la norma de doctrina en la cual habéis sido instruidos;"
,"18":"y libres del pecado, os habéis entregado al servicio de la justicia"
,"19":"(os estoy hablando en lenguaje sencillo para que podáis entenderme). Porque lo mismo que antes entregasteis vuestro cuerpo al servicio de la inmoralidad y el desorden, para vivir desordenadamente, así ahora entregadlo al servicio de la justicia, para vivir consagrados a Dios."
,"20":"Pues cuando erais esclavos del pecado, os considerabais libres respecto a la justicia."
,"21":"¿Qué frutos lograbais entonces? Aquellos de los que ahora os avergonzáis, porque su fin es la muerte."
,"22":"Pero ahora, libres del pecado y al servicio de Dios, tenéis como fruto la consagración a Dios y como resultado final la vida eterna."
,"23":"Porque el salario del pecado es la muerte; pero el don de Dios es la vida eterna en Cristo Jesús, Señor nuestro."
}`)
	CurrentBook.AddChapter(7, `{
"1":"¿Es que no sabéis, hermanos -hablo a los entendidos en leyes-, que el hombre está bajo el dominio de la ley sólo mientras vive?"
,"2":"La mujer casada está atada por la ley al marido mientras éste vive; pero si muere el marido, queda desligada de la ley del matrimonio."
,"3":"Por consiguiente, mientras vive el marido, será adúltera si se une con otro hombre; pero si el marido muere, queda libre de la ley del matrimonio y no es adúltera si se une con otro."
,"4":"Así también vosotros, hermanos míos, habéis muerto a la ley en la persona de Cristo, a fin de pertenecer a otro, al resucitado de entre los muertos, para que produzcamos frutos para Dios."
,"5":"Pues cuando seguíamos nuestros bajos instintos, la ley avivaba nuestras pasiones pecaminosas, que producían en nuestro cuerpo frutos de muerte."
,"6":"Pero ahora, al morir a la ley, a la cual estábamos sujetos, hemos quedado libres para servir a Dios no conforme a la letra de la vieja ley, sino conforme a la nueva vida del Espíritu."
,"7":"¿Queremos decir con esto que la ley es pecado? ¡De ninguna manera! Aunque yo conocí el pecado sólo por la ley. Yo no conocería la codicia si la ley no dijera: No codiciarás."
,"8":"Pero el pecado, apoyándose en el mandamiento, despertó en mí toda clase de malos deseos, pues el pecado sin la ley está muerto."
,"9":"En un tiempo en que no había ley, yo estaba vivo; pero cuando llegó el mandamiento, el pecado revivió,"
,"10":"y yo quedé muerto. Así resultó que el mandamiento, que debía darme la vida, me trajo la muerte."
,"11":"Porque el pecado, apoyándose en el mandamiento, me engañó y me causó la muerte."
,"12":"La ley es santa, y el mandamiento santo, justo y bueno."
,"13":"Y lo que es bueno, ¿ha sido muerte para mí? Nada de eso. Lo que pasa es que el pecado para demostrar que es pecado, valiéndose de lo bueno, me causó la muerte. De este modo, por medio del mandamiento, quedó plenamente demostrada la perversidad del pecado."
,"14":"Sabemos que la ley es espiritual, pero yo soy carnal, vendido como esclavo al poder del pecado."
,"15":"No entiendo lo que me pasa, pues no hago lo que quiero; y lo que detesto, eso es justamente lo que hago."
,"16":"Y si lo que no quiero, eso es lo que hago, reconozco con ello que la ley es buena."
,"17":"No soy yo el que lo hace, sino el pecado que hay en mí."
,"18":"Yo sé que en mí, es decir, en mis bajos instintos, no hay nada bueno, pues quiero hacer el bien y no puedo."
,"19":"No hago el bien que quiero, sino el mal que no quiero: eso es lo que hago."
,"20":"Y si lo que no quiero, eso es lo que hago, ya no soy yo el que lo hace, sino el pecado que hay en mí."
,"21":"Quiero hacer el bien, y me encuentro haciendo el mal."
,"22":"En mi interior me agrada la ley de Dios;"
,"23":"pero veo en mi cuerpo una ley que lucha contra la ley de mi espíritu y me esclaviza a la ley del pecado que hay en mi cuerpo."
,"24":"¡Desdichado de mí! ¿Quién me librará de este cuerpo mortal?"
,"25":"Doy gracias a Dios por Jesucristo, nuestro Señor. Así que yo mismo con el espíritu sirvo a la ley de Dios, pero con la carne a la ley del pecado."
}`)
	CurrentBook.AddChapter(8, `{
"1":"No hay condenación alguna para los que están unidos a Cristo Jesús."
,"2":"Porque la ley del espíritu, que da la vida en Cristo Jesús, me ha librado de la ley del pecado y de la muerte."
,"3":"En efecto, lo que la ley era incapaz de hacer, debido a los bajos instintos del hombre, lo hizo Dios enviando a su propio Hijo en condición semejante a la del hombre pecador, como sacrificio por el pecado y para condenar el pecado en su misma naturaleza humana."
,"4":"Así nosotros, que vivimos conforme al Espíritu y no conforme a los bajos instintos, podemos practicar la justicia que ordena la ley."
,"5":"Pues los que viven según la carne piensan en las cosas carnales; y los que viven según el espíritu, en las espirituales."
,"6":"Porque el deseo de la carne es la muerte, pero el pensamiento del espíritu es la vida y la paz."
,"7":"Por lo cual el deseo de la carne es enemigo de Dios, porque no se somete a la ley de Dios, ni puede en realidad someterse."
,"8":"Los que viven según la carne no pueden agradar a Dios;"
,"9":"pero vosotros no vivís según la carne, sino según el espíritu, si es que el Espíritu de Dios habita en vosotros. Pues si alguno no tiene el Espíritu de Cristo no es de Cristo."
,"10":"Y si Cristo está en vosotros, el cuerpo ciertamente está muerto por el pecado, pero el espíritu está vivo por la justicia."
,"11":"Y si el Espíritu del que resucitó a Jesús de entre los muertos habita en vosotros, el que resucitó a Cristo Jesús de entre los muertos vivificará también vuestros cuerpos mortales por obra de su Espíritu, que habita en vosotros."
,"12":"Así pues, hermanos, no somos deudores de los bajos instintos para tener que vivir de acuerdo con ellos."
,"13":"Porque si vivís según los bajos instintos, moriréis; pero si, conforme al Espíritu, dais muerte a las acciones carnales, viviréis."
,"14":"Los que se dejan guiar por el Espíritu de Dios son hijos de Dios."
,"15":"Porque no recibisteis el espíritu de esclavitud para recaer de nuevo en el temor, sino que recibisteis el espíritu de hijos adoptivos, que nos hace exclamar: ¡Abba! ¡Padre!"
,"16":"El mismo Espíritu da testimonio juntamente con nuestro espíritu de que somos hijos de Dios."
,"17":"Y si somos hijos, somos también herederos: herederos de Dios, coherederos de Cristo; si es que padecemos con él, para ser también glorificados con él."
,"18":"Estimo, en efecto, que los padecimientos del tiempo presente no se pueden comparar con la gloria que ha de manifestarse en nosotros."
,"19":"Porque la creación está aguardando en anhelante espera la manifestación de los hijos de Dios,"
,"20":"ya que la creación fue sometida al fracaso, no por su propia voluntad, sino por el que la sometió, con la esperanza"
,"21":"de que la creación será librada de la esclavitud de la destrucción para ser admitida a la libertad gloriosa de los hijos de Dios."
,"22":"Sabemos que toda la creación gime y está en dolores de parto hasta el momento presente."
,"23":"No sólo ella, sino también nosotros, que tenemos las primicias del Espíritu, gemimos dentro de nosotros mismos, esperando la adopción filial, la redención de nuestro cuerpo."
,"24":"Porque en la esperanza fuimos salvados; pero la esperanza que se ve no es esperanza, porque lo que uno ve, ¿cómo puede esperarlo?"
,"25":"Si esperamos lo que no vemos, debemos esperarlo con paciencia."
,"26":"Igulmente, el Espíritu viene en ayuda de nuestra flaqueza, porque no sabemos lo que nos conviene, pero el mismo Espíritu intercede por nosotros con gemidos inenarrables."
,"27":"Y el que penetra los corazones, conoce los pensamientos del Espíritu y sabe que lo que pide para los creyentes es lo que Dios quiere."
,"28":"Y sabemos que Dios ordena todas las cosas para bien de los que le aman, de los que han sido elegidos según su designio."
,"29":"Porque aquellos que de antemano conoció, también los predestinó a ser conformes con la imagen de su Hijo, para que él sea el primogénito entre muchos hermanos."
,"30":"Y a los que predestinó, los llamó; y a los que llamó, los justificó; y a los que justificó, los hizo partícipes de su gloria."
,"31":"¿Qué más podremos decir? Si Dios está con nosotros, ¿quién estará contra nosotros?"
,"32":"El que no perdonó ni a su propio Hijo, sino que lo entregó por todos nosotros, ¿cómo no nos dará gratuitamente con él todas las cosas?"
,"33":"¿Quién podrá acusar a los hijos de Dios? Dios es el que absuelve."
,"34":"¿Quién será el que condene? Cristo Jesús, el que murió, mejor dicho, el que resucitó, el que está a la diestra de Dios y el que intercede por nosotros."
,"35":"¿Quién podrá separarnos del amor de Cristo? ¿La tribulación, la angustia, la persecución, el hambre, la desnudez, el peligro, la espada?"
,"36":"Dice la Escritura: Por tu causa estamos expuestos a la muerte todo el día, somos como ovejas destinadas al matadero."
,"37":"Pero en todas estas cosas salimos triunfadores por medio de aquel que nos amó."
,"38":"Porque estoy persuadido de que ni la muerte, ni la vida, ni los ángeles, ni los principados, ni las cosas presentes ni las futuras, ni las potestades,"
,"39":"ni la altura ni la profundidad, ni otra criatura alguna podrá separarnos del amor que Dios nos ha manifestado en Cristo Jesús, nuestro Señor."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Como cristiano que soy, digo la verdad, no miento. Mi conciencia, bajo la acción del Espíritu Santo, me asegura que digo la verdad."
,"2":"Tengo una tristeza inmensa y un profundo y continuo dolor."
,"3":"Quisiera ser objeto de maldición, separado incluso de Cristo, por el bien de mis hermanos, los de mi propia raza;"
,"4":"son los israelitas, a los que Dios adoptó como hijos y a los que se apareció gloriosamente; de ellos es la alianza, la ley, el culto y las promesas;"
,"5":"de ellos son también los patriarcas; de ellos procede Cristo en cuanto hombre, el que está por encima de todas las cosas y es Dios bendito por los siglos. Amén."
,"6":"Y no es que las promesas de Dios no se hayan cumplido, porque no todos los descendientes de Israel son Israel;"
,"7":"no todos los descendientes de Abrahán son hijos suyos. Lo que se dijo fue esto: Tu descendencia se perpetuará por medio de Isaac."
,"8":"Esto quiere decir que los hijos de Dios no son los que pertenecen a una raza, sino los que nacen en virtud de la promesa."
,"9":"Ésta fue la promesa: Por este mismo tiempo yo volveré, y Sara tendrá un hijo."
,"10":"No es sólo esto. Rebeca concibió de un solo hombre, Isaac, nuestro antepasado, dos gemelos."
,"11":"Cuando todavía no habían nacido sus dos hijos y, por tanto, no habían hecho nada bueno ni malo (para que el designio de Dios permaneciese conforme a su elección,"
,"12":"no por las obras, sino por el que llama), se dijo a Rebeca: El mayor servirá al menor,"
,"13":"como dice la Escritura: Amé a Jacob y aborrecí a Esaú."
,"14":"¿Diremos entonces que Dios es injusto? De ninguna manera."
,"15":"Pues a Moisés le dice: Tendré misericordia de quien quiera y tendré compasión de quien quiera."
,"16":"Por consiguiente, no es obra del que quiere ni del que se esfuerza, sino de Dios, que tiene misericordia."
,"17":"Pues la Escritura dice al Faraón: Te he constituido para mostrar en ti mi poder y para que mi nombre sea anunciado en toda la tierra."
,"18":"Así pues, tiene misericordia de quien quiere, y a quien quiere le endurece el corazón."
,"19":"Tú me podrás decir: Entonces, ¿por qué culpa a nadie? Porque nadie puede resistir a su voluntad."
,"20":"En todo caso, ¿quién eres tú, pobre hombre, para pedir cuentas a Dios? ¿Acaso dice el vaso al alfarero: Por qué me hiciste así?"
,"21":"¿O es que el alfarero no tiene poder sobre el barro para hacer de una misma masa un vaso de lujo y otro corriente?"
,"22":"¿Qué tienes tú que decir en contra, si Dios, queriendo manifestar su indignación y dar a conocer su poder, soportó con gran paciencia a los que estaban preparados para la destrucción;"
,"23":"y obró así para dar a conocer la riqueza de su generosidad con los que eran objeto de su amor, los que él predispuso para gloria,"
,"24":"a saber, nosotros, a los que él llamó, no sólo de entre los judíos, sino también de entre los paganos?"
,"25":"Como dice en el libro de Oseas: Llamaré al que no es mi pueblo, pueblo mío; y a la no amada, amada."
,"26":"Y donde les dije: Vosotros no sois mi pueblo, allí serán llamados,hijos del Dios vivo."
,"27":"Isaías clama sobre Israel: Aunque el número de los israelitas,fuera como la arena del mar, sólo un resto se salvará;"
,"28":"porque pronto y con exactitud,el Señor cumplirá,en la tierra su palabra."
,"29":"Ya el mismo Isaías había predicho: Si el Señor todopoderoso,no nos hubiera dejado descendencia, seríamos como Sodoma, iguales a Gomorra."
,"30":"Entonces, ¿qué diremos? Que los paganos, que no perseguían la justicia, alcanzaron la justicia, la justicia de la fe;"
,"31":"pero Israel, persiguiendo la ley de la justicia, no llegó a conseguir esa ley."
,"32":"¿Por qué? Porque no fue por el camino de la fe, sino por el de las obras, como si por ellas pudiera alcanzarla. De este modo tropezaron en la piedra de tropiezo,"
,"33":"como dice la Escritura: Mirad, yo pongo en Sión una piedra de tropiezo, una roca que os puede hacer caer; pero el que crea en ella no quedará defraudado."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Hermanos, el buen deseo de mi corazón y la súplica que dirijo a Dios es que consigan su salvación."
,"2":"Yo soy testigo de que buscan ardientemente a Dios, pero sin saber cómo,"
,"3":"pues no reconociendo la justicia de Dios y buscando establecer la justicia propia, no se sometieron a la justicia de Dios;"
,"4":"porque el fin de la ley es Cristo, para justificación de todo el que cree."
,"5":"Moisés dice de la justicia que viene de la ley que el hombre que la practica, por ella, vivirá."
,"6":"Pero la justicia que viene de la fe dice así: No digas en tu corazón: ¿Quién subirá al cielo? (esto es, para hacer bajar a Cristo),"
,"7":"o ¿quién descenderá al abismo? (esto es, para hacer subir a Cristo de entre los muertos)."
,"8":"Pero ¿qué dice la Escritura? La palabra está cerca de ti, en tu boca, en tu corazón, esto es, la palabra de la fe que proclamamos."
,"9":"Porque si confiesas con tu boca que Jesús es el Señor y crees en tu corazón que Dios lo resucitó de entre los muertos, te salvarás."
,"10":"Con el corazón se cree para la justicia, y con la boca se confiesa la fe para la salvación."
,"11":"Pues dice la Escritura: Todo el que cree en él, no será defraudado."
,"12":"No hay distinción entre el judío y el griego, porque Jesús es el mismo Señor de todos, rico para todos los que lo invocan."
,"13":"Por tanto, todo el que invoque el nombre del Señor se salvará."
,"14":"Ahora bien, ¿cómo van a invocar a aquel en quien no creen? ¿Cómo van a creer en él si no han oído hablar de él? ¿Y cómo van a oír hablar de él si nadie les predica?"
,"15":"Y ¿cómo predicarán si no son enviados? Como dice la Escritura: ¡Bienvenidos los que traen buenas noticias!"
,"16":"Pero no todos prestaron oído al evangelio, porque Isaías dice: Señor, ¿quién creyó en nuestra predicación?"
,"17":"Por consiguiente, la fe proviene de la predicación; y la predicación es el mensaje de Cristo."
,"18":"Yo pregunto: ¿Es que no han oído? Sí, lo han oído. Porque dice la Escritura: Por toda la tierra se extendió su voz, y hasta los confines del mundo llegaron sus palabras."
,"19":"Pero digo además: ¿Será que Israel no se ha dado cuenta? Moisés dice: Yo os provocaré a celos de uno que no es mi pueblo, y os irritaré contra un pueblo insensato."
,"20":"Isaías se atreve a decir: Me encontraron los que no me buscaban y me manifesté a los que no preguntaban por mí."
,"21":"Pero a Israel dice: Todo el día extendí mis manos a un pueblo incrédulo y rebelde."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Yo pregunto: ¿Es que Dios ha rechazado a su pueblo? De ninguna manera. Porque también yo soy israelita, de la descendencia de Abrahán, de la tribu de Benjamín."
,"2":"Dios no ha rechazado a su pueblo, a quien de antemano eligió. ¿Es que no sabéis lo que dice la Escritura a propósito de Elías, cuando éste interviene contra Israel?"
,"3":"Señor, han matado a tus profetas, han derribado tus altares, he quedado yo solo y quieren matarme."
,"4":"Pero Dios le contestó: Me he reservado siete mil hombres que no han doblado la rodilla ante Baal."
,"5":"Pues así también en el tiempo presente Dios ha elegido generosamente un resto."
,"6":"Lo ha hecho por pura generosidad suya, y no por méritos humanos; si no fuera así, no podríamos hablar de la generosidad de Dios."
,"7":"Esto quiere decir que lo que Israel buscaba no lo alcanzó, mientras que los elegidos lo consiguieron; y los demás fueron endurecidos,"
,"8":"como dice la Escritura: Dios les embotó el espíritu, les dio ojos para no ver y oídos para no oír hasta el día de hoy."
,"9":"Y David dice: Que su mesa se convierta en un lazo para ellos, en trampa, en tropiezo y en castigo;"
,"10":"que se queden para siempre ciegos y que para siempre se doblen sus riñones."
,"11":"Por tanto, yo pregunto: ¿Es que tropezaron sólo para caer? De ninguna manera. Su caída ha servido para la salvación de los paganos, provocando así la envidia en Israel."
,"12":"Y si su caída es la riqueza del mundo, si su fracaso es riqueza de los paganos, ¡cuánto más lo será su conversión en masa!"
,"13":"Ahora me dirijo a vosotros, los paganos. Como apóstol vuestro, procuro dar gran realce a mi ministerio,"
,"14":"por ver si a los de mi raza les entra envidia y logro salvar a algunos de ellos."
,"15":"Porque si su pérdida ha servido para la reconciliación del mundo, su readmisión será como un volver de la muerte a la vida."
,"16":"Pues si la primicia es santa, también lo será la masa; y si la raíz es santa, también lo serán las ramas."
,"17":"Ahora bien, si algunas ramas fueron desgajadas, y tú, siendo olivo silvestre, fuiste injertado en ellas e incorporado a la raíz y a la pingüe savia del olivo,"
,"18":"no te engrías contra las ramas; y si te engríes, piensa que tú no sustentas la raíz, sino la raíz a ti."
,"19":"Pero dirás: Las ramas fueron cortadas para que yo fuera injertado."
,"20":"Bien, fueron cortadas por su incredulidad, y tú por la fe estás en pie. No seas orgulloso y ten mucho cuidado."
,"21":"Porque si Dios no perdonó a las ramas naturales, a ti tampoco te perdonará."
,"22":"Ten presente la bondad y la severidad de Dios: severidad para con los caídos; bondad para contigo, con tal que permanezcas en esa bondad; pues, de lo contrario, también tú serás cortado."
,"23":"Y ellos, si dejan la incredulidad, serán injertados; pues Dios tiene poder para injertarlos de nuevo."
,"24":"Porque si tú fuiste cortado del que por naturaleza era olivo silvestre, y contra la propia naturaleza fuiste injertado en el olivo bueno, ¡cuánto más ellos, las ramas naturales, serán injertadas en el propio olivo!"
,"25":"Hermanos, no quiero que ignoréis este misterio -para que no presumáis de vosotros mismos-: el endurecimiento de una parte de Israel ha sucedido hasta que todos los paganos hayan entrado;"
,"26":"entonces todo Israel se salvará, como dice la Escritura: Vendrá el libertador de Sión, apartará los crímenes de Jacob."
,"27":"Y ésta será mi alianza con ellos, cuando yo perdone sus pecados."
,"28":"En cuanto al evangelio, son tenidos como enemigos para vuestro bien; pero en cuanto a la elección, siguen siendo muy queridos de Dios en atención a sus antepasados;"
,"29":"porque los dones y el llamamiento de Dios son irrevocables."
,"30":"Pues así como vosotros en otro tiempo fuisteis desobedientes a Dios y ahora habéis conseguido misericordia por la desobediencia de ellos,"
,"31":"así también ahora ellos han sido desobedientes, para que con ocasión de la misericordia que os ha concedido a vosotros también ellos alcancen misericordia."
,"32":"Pues Dios encerró a todos en la desobediencia para tener misericordia con todos."
,"33":"¡Qué profundidad de riqueza, de sabiduría y de ciencia la de Dios! ¡Qué incomprensibles son sus decisiones y qué irrastreables sus caminos!"
,"34":"Porque ¿quién conoció el pensamiento del Señor?, ¿quién fue su consejero?"
,"35":"O ¿quién le ha dado algo a él para pedirle que se lo devuelva?"
,"36":"Porque de él y por él y para él son todas las cosas. A él la gloria por los siglos de los siglos. Amén."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Hermanos, os ruego, por la misericordia de Dios, que ofrezcáis vuestros cuerpos como sacrificio vivo, consagrado, agradable a Dios; éste es el culto que debéis ofrecer."
,"2":"Y no os acomodéis a este mundo; al contrario, transformaos y renovad vuestro interior para que sepáis distinguir cuál es la voluntad de Dios: lo bueno, lo que le agrada, lo perfecto."
,"3":"En virtud de la misión que Dios me ha encomendado, os digo a cada uno de vosotros que no se tenga en más de lo que debe tenerse, sino que procure pensar siempre de sí con sencillez, conforme a la fe que Dios le haya dado."
,"4":"Porque así como en un cuerpo tenemos muchos miembros, pero no todos tienen la misma función,"
,"5":"así nosotros, aunque somos muchos, formamos un solo cuerpo en Cristo y somos todos miembros unos de otros."
,"6":"Pero tenemos carismas diferentes, según lo que Dios ha querido dar a cada uno; el que tenga el carisma de la profecía, que lo ejerza conforme a la fe;"
,"7":"el que tenga el de servicio a los demás, que les sirva bien; el que tenga el de enseñar, que se dedique a la enseñanza;"
,"8":"el que tenga el de exhortar, que se dedique a exhortar; el que tiene el de repartir limosna, que reparta con generosidad; el que tiene el de presidir, que presida con seriedad; el que hace obras de misericordia, que las haga con alegría."
,"9":"Que vuestro amor sea sincero. Odiad el mal y abrazad el bien."
,"10":"Amaos de corazón unos a otros, como buenos hermanos; que cada uno ame a los demás más que a sí mismo."
,"11":"No os echéis atrás en el trabajo, tened buen ánimo, servid al Señor;"
,"12":"alegres en la esperanza, pacientes en los sufrimientos, constantes en la oración;"
,"13":"socorred las necesidades de los creyentes, practicad la hospitalidad."
,"14":"Bendecid a los que os persiguen; bendecid, y no maldigáis."
,"15":"Alegraos con los que se alegran, llorad con los que lloran."
,"16":"Vivid en armonía unos con otros. No seáis orgullosos, poneos al nivel de los humildes. No os consideréis los sabios."
,"17":"No devolváis a nadie mal por mal. Procurad hacer el bien ante todos los hombres."
,"18":"En cuanto de vosotros depende, haced todo lo posible para vivir en paz con todo el mundo."
,"19":"Queridos míos, no os toméis la justicia por vuestra mano; dejad que sea Dios el que castigue, como dice la Escritura: Yo haré justicia, yo daré a cada cual su merecido."
,"20":"También dice: Si tu enemigo tiene hambre, dale de comer; si tiene sed, dale de beber; que si haces esto, harás que se sonroje."
,"21":"No te dejes vencer por el mal; al contrario, vence el mal con el bien."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Que cada uno se someta a las autoridades que están en el poder, porque no hay autoridad que no venga de Dios; y los que hay han sido puestos por Dios."
,"2":"Así que el que se opone a la autoridad, se opone al orden puesto por Dios; y los que se oponen recibirán su propia condenación."
,"3":"Los gobernantes no están para amedrentar a los que obran bien, sino a los que obran mal. ¿Quieres vivir sin miedo a la autoridad? Pórtate bien, y tendrás su aprobación;"
,"4":"pues la autoridad está al servicio de Dios para ayudarte a portarte bien. Pero si te portas mal, échate a temblar, porque no en vano la autoridad lleva la espada y está al servicio de Dios para castigar al delincuente."
,"5":"Por lo cual es necesario que os sometáis no solamente por temor al castigo, sino más bien por un deber de conciencia."
,"6":"También por esta razón pagáis los impuestos, porque los gobernantes están al servicio de Dios y se dedican a ese oficio."
,"7":"Pagad a cada uno lo que le corresponda: contribuciones, impuestos, respeto, honores, lo que haya que darle."
,"8":"No debáis nada a nadie; amaos unos a otros, pues el que ama al prójimo ha cumplido la ley."
,"9":"Porque: No cometerás adulterio, no matarás, no robarás, no codiciarás y cualquier otro mandamiento, todo se reduce a esto: Amarás a tu prójimo como a ti mismo."
,"10":"El que ama no hace mal al prójimo; así que la plenitud de la ley es el amor."
,"11":"Tened en cuenta en qué tiempos estamos: ya es hora de despertar del sueño, porque ahora está más cerca de nosotros la salvación que cuando abrazamos la fe."
,"12":"La noche está avanzada y el día está cerca; por lo tanto, dejemos a un lado las obras de las tinieblas y revistámonos de las armas de la luz."
,"13":"Comportémonos decentemente, como en pleno día; nada de comilonas ni borracheras, nada de lujuria ni desenfreno, nada de peleas ni envidias;"
,"14":"al contrario, revestíos de Jesucristo, el Señor, y no busquéis satisfacer los bajos instintos."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Acoged al que es débil en la fe, pero no para discutir con él."
,"2":"Porque hay quien cree que puede comer de todo; en cambio, otro, que es débil en la fe, come sólo verduras."
,"3":"El que come de todo no desprecie al que no come de todo, y el que no come de todo no critique al que come de todo, pues Dios lo ha acogido."
,"4":"¿Quién eres tú para juzgar al criado ajeno? Que se mantenga en pie o que caiga es algo que importa sólo a su amo; pero se mantendrá en pie, pues poderoso es el Señor para sostenerlo."
,"5":"Uno distingue un día de otro día, otro juzga todos los días iguales; cada uno proceda según su propia opinión."
,"6":"El que celebra determinados días lo hace para honrar al Señor, y el que come de todo lo hace en honor del Señor, pues al comer da gracias a Dios; y el que no come de todo lo hace en honor del Señor, pues también da gracias a Dios."
,"7":"Porque ninguno de vosotros vive para sí, y ninguno muere para sí."
,"8":"Pues si vivimos, para el Señor vivimos; y si morimos, para el Señor morimos. Así que, vivamos o muramos, somos del Señor."
,"9":"Porque por esto Cristo murió y resucitó: para reinar sobre muertos y vivos."
,"10":"Pero tú, ¿por qué juzgas a tu hermano? O ¿por qué desprecias a tu hermano? Pues todos tenemos que presentarnos ante el tribunal de Dios."
,"11":"Porque dice la Escritura: Por mi vida, dice el Señor, que ante mí se doblará toda rodilla, y toda lengua alabará a Dios."
,"12":"Por lo tanto, cada uno de nosotros tiene que dar cuenta a Dios de sí mismo."
,"13":"Así que no nos juzguemos ya más unos a otros; al contrario, procurad no poner obstáculo o escándalo al hermano."
,"14":"Yo sé, y estoy convencido en Jesús, el Señor, de que de suyo no hay nada impuro; pero si alguno piensa que alguna cosa es impura, para él es impura."
,"15":"Porque si por comer de algo haces daño a tu hermano, ya no te guías por el amor. Que tu comida no sea causa de que se pierda aquel por quien Cristo ha muerto."
,"16":"Que vuestra libertad no sea objeto de calumnia;"
,"17":"porque el reino de Dios no es comida ni bebida, sino justicia, paz y gozo en el Espíritu Santo."
,"18":"Pues el que en esto sirve a Cristo, agrada a Dios y es estimado de los hombres."
,"19":"Por tanto, busquemos la paz y la ayuda mutua."
,"20":"No destruyas la obra de Dios por causa de la comida. Todos los alimentos son puros, pero no se debe comer algo que escandalice a los demás."
,"21":"Es mejor no comer carne ni beber vino o cualquier otra cosa que pueda escandalizar a tu hermano."
,"22":"Tú, la creencia que tienes, guárdala para ti y para Dios. Dichoso el que toma una decisión y no obra contra su conciencia."
,"23":"En cambio, el que duda, si come, se siente culpable, porque no procede según la conciencia; y todo lo que no es según la conciencia es pecado."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Nosotros, los fuertes, debemos sobrellevar las deficiencias de los débiles y no buscar lo que nos agrada a nosotros mismos."
,"2":"Cada uno de nosotros debe procurar agradar a su prójimo para su bien y su robustecimiento en la fe."
,"3":"Porque Cristo no buscó lo que le agradaba, como dice la Escritura: Las ofensas de los que te insultaban cayeron sobre mí."
,"4":"Pues todo lo que ha sido escrito en el pasado, lo fue para nuestra enseñanza, a fin de que por la paciencia y el consuelo que dan las Escrituras tengamos esperanza."
,"5":"Y Dios, que da la paciencia y el consuelo, os conceda vivir en armonía unos con otros a ejemplo de Jesucristo,"
,"6":"para que con un solo corazón y todos a una podáis dar gloria a Dios, Padre de nuestro Señor Jesucristo."
,"7":"Por tanto, acogeos unos a otros, como también Cristo nos acogió para gloria de Dios."
,"8":"Os digo que Cristo se hizo servidor de los judíos para demostrar que Dios es fiel y cumple las promesas hechas a los patriarcas,"
,"9":"y para que los paganos alaben a Dios por su misericordia como dice la Escritura: Por eso te alabaré entre las naciones y cantaré himnos en tu honor."
,"10":"Y en otro lugar: Alegraos, naciones, con el pueblo de Dios."
,"11":"Y de nuevo: Alabad al Señor todas las naciones y alabadle todos los pueblos."
,"12":"También dice Isaías: Brotará la raíz de Jesé, se levantará para regir las naciones; y las naciones esperarán en él."
,"13":"Que el Dios de la esperanza llene de alegría y paz vuestra fe, y que la fuerza del Espíritu Santo os colme de esperanza."
,"14":"Hermanos, yo estoy convencido de que tenéis muy buena voluntad y mucha sabiduría para aconsejaros unos a otros."
,"15":"A pesar de todo, me he atrevido a escribiros para recordaros algunas cosas. Lo hago en virtud del privilegio que Dios me ha concedido"
,"16":"de ser ministro de Cristo Jesús entre los paganos; mi tarea sagrada consiste en anunciar el evangelio de Dios, para que la ofrenda de los paganos sea agradable a Dios, consagrada por el Espíritu Santo."
,"17":"Como creyente en Cristo Jesús, tengo motivos para estar orgulloso de mi servicio a Dios."
,"18":"No me atrevería a hablar de alguna cosa que Cristo no hubiera hecho por medio de mi ministerio para conseguir que los paganos aceptaran el evangelio. Esto se ha conseguido con palabras y acciones,"
,"19":"con la fuerza de milagros y prodigios y con el poder del Espíritu Santo; de manera que desde Jerusalén en todas direcciones hasta Iliria he anunciado el evangelio de Cristo;"
,"20":"he puesto todo mi empeño en no anunciar el evangelio allí donde ya habían oído hablar de Cristo, para no construir sobre cimientos puestos por otros,"
,"21":"sino hacer lo que dice la Escritura: Los que no tenían noticias de él, lo verán; los que no habían oído hablar de él, entenderán."
,"22":"Ésta es la razón por la que no he podido ir a veros;"
,"23":"pero ahora, como ya no hay nada que me retenga en estas regiones y como desde hace tiempo tengo muchas ganas de ir a veros,"
,"24":"en mi viaje para España espero pasar por ahí. Como también espero que, tras disfrutar durante algún tiempo de vuestra compañía, me ayudéis a continuar el viaje."
,"25":"Ahora me dirijo a Jerusalén para ayudar a aquellos hermanos."
,"26":"Macedonia y Acaya han hecho una colecta, y voy a llevársela a los hermanos pobres de Jerusalén."
,"27":"Lo han decidido voluntariamente, y han hecho muy bien; pues si los judíos creyentes han compartido sus bienes espirituales con los paganos, éstos deben compartir sus bienes materiales con ellos."
,"28":"Cuando cumpla esta misión y haya entregado la colecta, emprenderé mi viaje a España y pasaré por ahí."
,"29":"Estoy bien seguro de que cuento con todas las bendiciones de Cristo para ir a veros."
,"30":"Hermanos, por nuestro Señor Jesucristo y por el amor del Espíritu Santo, os pido que luchéis conmigo orando a Dios por mí,"
,"31":"para que me vea libre de los incrédulos que hay en Judea y para que la ayuda que llevo a Jerusalén sea bien recibida por los hermanos."
,"32":"De esta manera, si Dios quiere, iré muy contento a veros y descansaré algo con vosotros."
,"33":"Que el Dios de la paz esté con todos vosotros. Amén."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Os recomiendo a Febe, nuestra hermana, que es diaconisa de la iglesia de Cencreas,"
,"2":"para que la recibáis bien en nombre del Señor, como se debe hacer entre los creyentes, y la ayudéis en todo lo que necesite, porque también ella ha ayudado a muchos, y en particular a mí."
,"3":"Saludad a Prisca y a Áquila, mis colaboradores en la obra de Cristo Jesús,"
,"4":"los cuales, por salvarme a mí se jugaron la vida; no sólo yo les estoy agradecido, sino también todas las iglesias del mundo pagano."
,"5":"Saludad también a la comunidad que se reúne en su casa. Saludad a mi querido Epéneto, que es el primer creyente cristiano de Asia."
,"6":"Saludad a María, que tanto ha trabajado entre nosotros."
,"7":"Saludad a Andrónico y a Junias, paisanos míos y compañeros de cárcel, que se han distinguido en el apostolado, y que fueron creyentes en Cristo antes que yo."
,"8":"Saludad a Ampliato, mi querido amigo en el Señor."
,"9":"Saludad a Urbano, colaborador mío en la obra de Cristo, y a Estaquis, mi amigo."
,"10":"Saludad a Apeles, que ha dado pruebas de su fe en Cristo. Saludad a los de la casa de Aristóbulo."
,"11":"Saludad a mi paisano Herodión. Saludad a la familia de Narciso, creyentes en el Señor."
,"12":"Saludad a Trifena y a Trifosa, que trabajan en la obra del Señor. Saludad a la querida Pérsida, que tanto ha trabajado en la obra del Señor."
,"13":"Saludad a Rufo, escogido por el Señor, y a su madre, que lo es también mía."
,"14":"Saludad a Asíncrito, a Flegón, a Hermes, a Patrobas, a Hermas y a los hermanos que viven con ellos."
,"15":"Saludad a Filólogo y a Julia, a Nereo y a su hermana, a Olimpia y a todos los hermanos que viven con ellos."
,"16":"Saludaos unos a otros con el abrazo de la paz. Os saludan todas las Iglesias de Cristo."
,"17":"Hermanos, os ruego que no perdáis de vista a los que causan divisiones y escándalos contra la doctrina que habéis aprendido, y apartaos de ellos;"
,"18":"porque ésos no sirven a Cristo nuestro Señor, sino a su estómago, y con palabras dulces y agradables engañan a la gente sencilla."
,"19":"Porque vuestra obediencia a la fe es ya conocida de todos. Por esto estoy satisfecho de vosotros, pero quiero que seáis listos para el bien y simples para el mal."
,"20":"El Dios de la paz pronto aplastará a Satanás bajo vuestros pies. La gracia de nuestro Señor Jesucristo esté con vosotros."
,"21":"Os saluda Timoteo, mi colaborador, y Lucio, Jasón y Sosípatro, mis paisanos."
,"22":"Yo, Tercio, que he escrito esta carta, os saludo en el Señor."
,"23":"Os saluda Gayo, huésped mío y de toda la comunidad."
,"24":"Os saluda Erasto, tesorero de la ciudad, y el hermano Cuarto."
,"25":"Al que puede fortaleceros en el evangelio que yo anuncio, en la proclamación de Jesucristo y en la revelación del misterio mantenido en secreto desde tiempo eterno,"
,"26":"pero manifestado ahora por los escritos proféticos, dado a conocer a todas las naciones por orden del Dios eterno para que abracen la fe,"
,"27":"a Dios, el único sabio, por medio de Jesucristo, la gloria por los siglos de los siglos. Amén."
}`)

}
func ES_LSB_LoadNPTTChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Pablo, siervo de Dios y apóstol de Jesucristo para dar a los elegidos de Dios la fe y el conocimiento de la verdad de nuestra religión,"
,"2":"basada en la esperanza de la vida eterna. Dios, que no puede mentir, prometió esa vida desde la eternidad;"
,"3":"y ahora, a su debido tiempo, ha manifestado su palabra mediante la predicación que me ha sido confiada por disposición de Dios, nuestro Salvador:"
,"4":"a Tito, mi verdadero hijo en nuestra fe común, te deseo la gracia y la paz de Dios Padre y de Cristo Jesús, nuestro Salvador."
,"5":"Te dejé en Creta con el fin de que pusieses en toda regla lo que faltaba que ordenar y constituyeses presbíteros por las ciudades, conforme a las instrucciones que te he dado:"
,"6":"que el candidato sea irreprochable; casado una sola vez; que tenga hijos creyentes, a los que no se les pueda inculpar de libertinaje o indisciplina."
,"7":"Es necesario que el obispo sea irreprochable, como administrador que es de la casa de Dios; no debe ser arrogante, ni colérico, ni borracho, ni amigo de peleas ni de negocios sucios;"
,"8":"al contrario, debe ser hospitalario, amigo del bien, prudente, justo, religioso, con dominio de sí mismo,"
,"9":"guardador fiel de la doctrina que se le enseñó, para que sea capaz de animar a otros y de refutar a los que contradicen."
,"10":"Pues hay muchos insubordinados, charlatanes y embaucadores, sobre todo entre los judíos convertidos,"
,"11":"a los que es preciso tapar la boca. Revuelven familias enteras enseñando lo que no deben, llevados por el ansia de ganancias sucias."
,"12":"Ya dijo uno de ellos, su propio profeta: 'Los cretenses son siempre mentirosos, malas bestias, glotones y gandules'"
,"13":"¡Y qué verdad es! Por eso, repréndelos con energía, para que se mantengan sanos en la fe"
,"14":"y dejen de prestar oídos a fábulas judaicas y a preceptos de hombres que vuelven sus espaldas a la verdad."
,"15":"Todo es limpio para los limpios; pero para los contaminados y los que no tienen fe nada es puro, porque tienen contaminada su mente y su conciencia."
,"16":"Hacen profesión de conocer a Dios, pero le niegan con las obras, pues son odiosos y rebeldes, incapaces de hacer nada bueno."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Tú, en cambio, predica lo que está conforme con la sana doctrina."
,"2":"Que los ancianos sean sobrios, hombres ponderados, prudentes, sanos en la fe, en el amor, en la paciencia;"
,"3":"que las ancianas, igualmente, observen una conducta digna de personas santas; que no sean calumniadoras, ni dadas a la bebida, sino capaces de instruir en el bien,"
,"4":"a fin de que enseñen a las mujeres jóvenes a amar a sus maridos y a sus hijos,"
,"5":"a ser prudentes, honestas, cuidadosas de los quehaceres domésticos, buenas, sumisas a sus maridos, de modo que no den ocasión a que se blasfeme contra la palabra de Dios."
,"6":"A los jóvenes, de la misma manera, exhórtalos a que sean prudentes en todo,"
,"7":"presentándote como ejemplo de buenas obras, un hombre íntegro en la doctrina, de porte digno,"
,"8":"de palabra sana, irreprochable, de modo que el adversario quede en vergüenza al no poder alegar contra nosotros nada malo."
,"9":"Los esclavos, que se muestren sumisos en todo a sus amos, que traten de agradarles, que no les contradigan"
,"10":"ni les engañen; por el contrario, que sean modelo de fidelidad perfecta, para hacer honor en todo a la doctrina de Dios, nuestro Salvador."
,"11":"Pues se ha manifestado la gracia de Dios, fuente de salvación para todos los hombres,"
,"12":"enseñándonos a renunciar a la maldad y a los deseos mundanos y a llevar una vida sobria, justa y religiosa,"
,"13":"mientras aguardamos el feliz cumplimiento de lo que se nos ha prometido y la manifestación gloriosa del gran Dios y Salvador nuestro Jesucristo,"
,"14":"que se entregó a sí mismo por nosotros para redimirnos y hacer de nosotros un pueblo escogido, limpio de todo pecado y dispuesto a hacer siempre el bien."
,"15":"Esto es lo que tienes que enseñar, predicar y defender con toda autoridad. Que nadie te haga de menos."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Aconséjales que vivan sumisos a los gobernantes, a las autoridades; que les presten obediencia, que estén dispuestos a hacer siempre el bien;"
,"2":"que no hablen mal de nadie, que sean pacíficos, comprensivos y sumamente amables con todo el mundo."
,"3":"Nosotros también en otro tiempo fuimos unos locos, desobedientes, descarriados, esclavos de toda clase de concupiscencias y placeres, malos y envidiosos, odiados de todos y odiándonos mutuamente unos a otros."
,"4":"Pero Dios, nuestro Salvador, al manifestar su bondad y su amor por los hombres,"
,"5":"nos ha salvado, no por la justicia que hayamos practicado, sino por puro amor, mediante el bautismo regenerador y la renovación del Espíritu Santo,"
,"6":"que derramó abundantemente sobre nosotros por Jesucristo, nuestro Salvador,"
,"7":"a fin de que, justificados por su gracia, seamos herederos de la vida eterna, tal y como lo esperamos."
,"8":"Esta doctrina es digna de crédito; quiero que inculques constantemente estas cosas, para que los que han creído en Dios sobresalgan en buenas obras. Estas cosas son buenas y útiles para los hombres."
,"9":"Evita, en cambio, las cuestiones tontas, las genealogías, las discusiones y polémicas sobre la ley, pues son inútiles y vanas."
,"10":"Al hombre que fomenta la división amonéstale una y otra vez; y si no te hace caso, apártate de él,"
,"11":"pues está pervertido y, al perseverar en su pecado, se está condenando a sí mismo."
,"12":"Voy a enviarte a Artemas o a Tíquico. En cuanto lleguen, vete a verme a Nicópolis, pues tengo decidido pasar allí el invierno."
,"13":"Preocúpate de que Zenas, el abogado, y Apolo tengan todo lo necesario para el viaje."
,"14":"Que nuestros hermanos sean los primeros en hacer el bien y en atender a las necesidades urgentes; así serán útiles para los demás."
,"15":"Te saludan todos los que están conmigo. Saluda a nuestros amigos en la fe. La gracia esté con todos vosotros."
}`)

}
func ES_LSB_LoadNTAAChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Querido Teófilo: En mi primer libro traté de todo lo que Jesús hizo y enseñó desde el principio"
,"2":"hasta el día en que subió al cielo después de haber dado instrucciones a los apóstoles que había elegido bajo la acción del Espíritu Santo."
,"3":"Después de su pasión se presentó a ellos, dándoles muchas pruebas evidentes de que estaba vivo: se apareció durante cuarenta días y les habló de las cosas del reino de Dios."
,"4":"Una vez que estaba comiendo con ellos les mandó que no saliesen de Jerusalén, sino que aguardasen la promesa del Padre, de la que os hablé;"
,"5":"porque Juan bautizó con agua, pero vosotros seréis bautizados en el Espíritu Santo dentro de pocos días."
,"6":"Los que estaban con él le preguntaron: 'Señor, ¿vas a restablecer ya el reino de Israel?'."
,"7":"Les respondió: 'No os toca a vosotros saber los tiempos y las circunstancias que el Padre ha fijado con su autoridad;"
,"8":"pero recibiréis la fuerza del Espíritu Santo, que vendrá sobre vosotros para que seáis mis testigos en Jerusalén, en toda Judea, en Samaría y hasta los confines de la tierra'."
,"9":"Dicho esto, lo vieron subir, hasta que una nube lo ocultó a su vista."
,"10":"Ellos se quedaron mirando fijamente al cielo mientras él se iba, cuando se les aparecieron dos hombres vestidos de blanco,"
,"11":"que les dijeron: 'Galileos, ¿qué hacéis ahí mirando al cielo? Este Jesús que acaba de subir al cielo volverá tal como lo habéis visto irse al cielo'."
,"12":"Entonces regresaron a Jerusalén desde el monte de los Olivos, que dista poco de Jerusalén, lo que se permitía andar en sábado."
,"13":"Y así que entraron, subieron a la estancia de arriba, donde se alojaban habitualmente. Eran Pedro y Juan, Santiago y Andrés, Felipe y Tomás, Bartolomé y Mateo, Santiago el de Alfeo, Simón el Zelotes y Judas el de Santiago."
,"14":"Todos ellos hacían constantemente oración en común con las mujeres, con María, la madre de Jesús, y con sus hermanos."
,"15":"Un día de aquellos, en que se habían reunido unos ciento veinte, Pedro se puso en pie en medio de los hermanos y dijo:"
,"16":"'Hermanos, tenía que cumplirse lo que anunció el Espíritu Santo por boca de David acerca de Judas, el guía de los que prendieron a Jesús."
,"17":"Era uno de nosotros y formaba parte de nuestro ministerio."
,"18":"Con lo que le dieron por el delito se compró un terreno, en el que se tiró de cabeza desde lo alto, se reventó por medio y se desparramaron todas sus entrañas."
,"19":"Esto fue notorio a todos los habitantes de Jerusalén, de modo que el campo se llamó en su lengua 'Hacéldama', es decir, 'campo de sangre'."
,"20":"Porque está escrito en el libro de los Salmos: Que su morada se convierta en un desierto y no haya quien habite en ella. Y: que ocupe otro su cargo."
,"21":"Conviene, por tanto, que uno de los que nos han acompañado todo el tiempo que Jesús, el Señor, estuvo con nosotros,"
,"22":"a partir del bautismo de Juan hasta el día en que subió al cielo, sea constituido testigo de su resurrección con nosotros'."
,"23":"Y presentaron a dos: a José, llamado Barsabá, por sobrenombre Justo, y a Matías."
,"24":"Y oraron así: 'Tú, Señor, que conoces el corazón de todos los hombres, muéstranos a cuál de estos dos has elegido"
,"25":"para ocupar en este ministerio del apostolado el puesto que abandonó Judas para irse a su lugar'."
,"26":"Lo echaron a suertes, y cayó la suerte sobre Matías, que fue agregado a los once apóstoles."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Al llegar el día de pentecostés, estaban todos juntos en el mismo lugar."
,"2":"De repente un ruido del cielo, como de viento impetuoso, llenó toda la casa donde estaban."
,"3":"Se les aparecieron como lenguas de fuego, que se repartían y se posaban sobre cada uno de ellos."
,"4":"Todos quedaron llenos del Espíritu Santo y comenzaron a hablar en lenguas extrañas, según el Espíritu Santo les movía a expresarse."
,"5":"Había en Jerusalén judíos piadosos de todas las naciones que hay bajo el cielo."
,"6":"Al oír el ruido, la multitud se reunió y se quedó estupefacta, porque cada uno los oía hablar en su propia lengua."
,"7":"Fuera de sí todos por aquella maravilla, decían: '¿No son galileos todos los que hablan?"
,"8":"Pues, ¿cómo nosotros los oímos cada uno en nuestra lengua materna?"
,"9":"Partos, medos y elamitas, habitantes de Mesopotamia, Judea y Capadocia, el Ponto y el Asia,"
,"10":"Frigia y Panfilia, Egipto y las regiones de Libia y de Cirene, forasteros romanos,"
,"11":"judíos y prosélitos, cretenses y árabes, los oímos hablar en nuestras lenguas las grandezas de Dios'."
,"12":"Todos fuera de sí y desconcertados, se decían unos a otros: '¿Qué significa esto?'."
,"13":"Pero otros, burlándose, decían: 'Están borrachos'."
,"14":"Entonces Pedro, en pie con los once, les dirigió en voz alta estas palabras: 'Judíos y habitantes todos de Jerusalén: percataos bien de esto y prestad atención a mis palabras."
,"15":"No; éstos no están borrachos, como vosotros suponéis, pues son las nueve de la mañana;"
,"16":"lo que pasa es que se está cumpliendo lo que dijo el profeta Joel:"
,"17":"En los últimos días, dice Dios: derramaré mi espíritu,sobre todos los hombres, vuestros hijos y vuestras hijas,profetizarán, vuestros ancianos tendrán sueños,y vuestros jóvenes visiones,"
,"18":"y hasta en los esclavos y esclavas,derramaré mi espíritu aquellos días."
,"19":"Y haré aparecer señales,en el cielo y en la tierra: sangre, fuego y columnas de humo."
,"20":"El sol se cambiará en tinieblas,y la luna en sangre,antes que llegue el día del Señor,grande y glorioso."
,"21":"Pero el que invoque,el nombre del Señor se salvará."
,"22":"Israelitas, escuchadme: Dios acreditó ante vosotros a Jesús el Nazareno con los milagros, prodigios y señales que hizo por medio de él, como bien sabéis."
,"23":"Conforme al plan proyectado y previsto por Dios, os lo entregaron, y vosotros lo matasteis crucificándolo por manos de los paganos;"
,"24":"pero Dios lo ha resucitado, rompiendo las ligaduras de la muerte, pues era imposible que la muerte dominara sobre él."
,"25":"Porque David dice de él: Veía siempre al Señor,en mi presencia, lo tengo a mi derecha, y así nunca tropiezo."
,"26":"Por eso se alegra mi corazón, se gozan mis entrañas, todo mi ser descansa bien seguro,"
,"27":"pues tú no me entregarás a la muerte,ni dejarás que tu fiel amigo,vea la corrupción."
,"28":"Me has enseñado el camino de la vida,me has llenado de gozo,en tu presencia."
,"29":"Hermanos, hablemos con franqueza. El patriarca David murió y fue sepultado, y su sepulcro subsiste entre nosotros hasta el día de hoy."
,"30":"Pero era profeta y sabía que Dios le había jurado solemnemente sentar sobre su trono un descendiente suyo. Por eso"
,"31":"previó y anunció la resurrección del mesías cuando dijo que no sería abandonado en el abismo ni su cuerpo vería la corrupción."
,"32":"Dios ha resucitado a éste, que es Jesús, de lo que todos nosotros somos testigos."
,"33":"Exaltado, pues, por la diestra de Dios, y habiendo recibido del Padre el Espíritu Santo, objeto de la promesa, lo ha derramado. Esto es lo que estáis viendo y oyendo."
,"34":"Porque David no subió al cielo, sino que él dice: Dijo el Señor a mi Señor: Siéntate a mi derecha"
,"35":"hasta que haga a tus enemigos,estrado de tus pies."
,"36":"Tenga, pues, todo Israel la certeza de que Dios ha constituido señor y mesías a este Jesús a quien vosotros habéis crucificado'."
,"37":"Al oírle, se conmovieron profundamente y dijeron a Pedro y a los demás apóstoles: '¿Qué debemos hacer, hermanos?'."
,"38":"Y Pedro les dijo: 'Arrepentíos, y que cada uno de vosotros se bautice en el nombre de Jesucristo para el perdón de vuestros pecados; entonces recibiréis el don del Espíritu Santo."
,"39":"Porque la promesa es para vosotros y para vuestros hijos, y también para todos los extranjeros que llame el Señor Dios nuestro'."
,"40":"Y con otras muchas palabras los apremiaba y los exhortaba diciendo: 'Salvaos de esta generación perversa'."
,"41":"Y los que acogieron su palabra se bautizaron; y aquel día se agregaron unas tres mil personas."
,"42":"Eran constantes en escuchar la enseñanza de los apóstoles, en la unión fraterna, en partir el pan y en las oraciones."
,"43":"Todos estaban impresionados ante los prodigios y señales que hacían los apóstoles."
,"44":"Todos los creyentes vivían unidos y lo tenían todo en común;"
,"45":"vendían las posesiones y haciendas, y las distribuían entre todos, según la necesidad de cada uno."
,"46":"Todos los días acudían juntos al templo, partían el pan en las casas, comían juntos con alegría y sencillez de corazón,"
,"47":"alabando a Dios y gozando del favor de todo el pueblo. El Señor añadía cada día al grupo a todos los que entraban por el camino de la salvación."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Pedro y Juan iban un día al templo a la hora de la oración, a las tres de la tarde."
,"2":"Todos los días llevaban a un cojo de nacimiento y lo ponían a la puerta del templo llamada Hermosa para pedir limosna a los que entraban."
,"3":"Al ver a Pedro y a Juan que iban a entrar en el templo, les pidió limosna."
,"4":"Pedro y Juan clavaron sus ojos en él; y Pedro le dijo: 'Míranos'."
,"5":"Él los miraba, esperando que le dieran algo."
,"6":"Pedro dijo: 'No tengo plata ni oro; pero lo que tengo, eso te doy: en nombre de Jesucristo, el Nazareno, echa a andar'."
,"7":"Lo agarró de la mano derecha y lo levantó; y al instante sus pies y sus tobillos se fortalecieron;"
,"8":"y de un salto se puso en pie y echó a andar; y entró con ellos en el templo andando, saltando y alabando a Dios."
,"9":"Todo el pueblo lo vio andar y alabar a Dios."
,"10":"Y reconocían que era el que solía sentarse junto a la puerta Hermosa a pedir limosna; y se quedaron admirados y desconcertados por lo que le había sucedido."
,"11":"Él no se apartaba de Pedro y de Juan; y todo el pueblo, asombrado, fue corriendo a juntarse con ellos en el pórtico de Salomón."
,"12":"Pedro, al ver esto, dijo al pueblo: 'Israelitas, ¿por qué os asombráis de esto y por qué nos miráis como si por nuestro propio poder o por nuestra bondad hubiéramos hecho andar a éste?"
,"13":"El Dios de Abrahán, de Isaac y de Jacob, el Dios de nuestros padres, glorificó a su Hijo Jesús, al que vosotros entregasteis y rechazasteis ante Pilato, el cual decidió ponerlo en libertad;"
,"14":"pero vosotros rechazasteis al santo y justo, y pedisteis la libertad de un asesino;"
,"15":"matasteis al autor de la vida, a quien Dios resucitó de entre los muertos; de lo cual nosotros somos testigos."
,"16":"Como éste, que veis y que conocéis, ha tenido fe en él, ha quedado fortalecido; la fe en Jesús lo ha curado completamente, como todos veis."
,"17":"Hermanos, sé que obrasteis por ignorancia, igual que vuestros jefes."
,"18":"Pero Dios cumplió así lo que anunció de antemano por boca de todos los profetas: que su mesías tenía que padecer."
,"19":"Por tanto, arrepentíos y convertíos para que sean borrados vuestros pecados;"
,"20":"así llegarán los tiempos de consuelo, y el Señor os enviará al mesías destinado para vosotros, es decir, a Jesús,"
,"21":"al que el cielo debe retener hasta los tiempos de la restauración universal, de que habló Dios por boca de sus profetas desde muy antiguo."
,"22":"Moisés dijo: El Señor Dios vuestro os suscitará de entre vuestros hermanos un profeta como yo: escuchadlo en todo lo que os diga."
,"23":"Y el que no escuche a este profeta será exterminado del pueblo."
,"24":"Todos los profetas que hablaron, a partir de Samuel, anunciaron estos días."
,"25":"Vosotros sois los hijos de los profetas y de la alianza que estableció Dios con vuestros padres cuando dijo a Abrahán: En tu descendencia serán bendecidas todas las familias de la tierra."
,"26":"Por vosotros, en primer lugar, Dios, después de haber resucitado a su Hijo, lo envió a bendeciros, para que os arrepintáis cada uno de vuestros pecados'."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Mientras hablaban al pueblo, se les presentaron los sacerdotes, el oficial del templo y los saduceos,"
,"2":"molestos de que enseñasen al pueblo y anunciasen que la resurrección de entre los muertos se había realizado ya en la persona de Jesús;"
,"3":"los detuvieron y los metieron en la cárcel hasta el día siguiente, pues era ya tarde."
,"4":"Pero muchos de los que oyeron el discurso creyeron; y el número de los hombres llegó a unos cinco mil."
,"5":"Al día siguiente se reunieron en Jerusalén los jefes del pueblo, los ancianos y los maestros de la ley."
,"6":"Estaban Anás, el sumo sacerdote; Caifás, Juan, Alejandro y todos los familiares de los sumos sacerdotes."
,"7":"Los pusieron en medio y les preguntaron: '¿Con qué poder o en nombre de quién habéis hecho esto?'."
,"8":"Entonces Pedro, lleno del Espíritu Santo, les dijo: 'Jefes del pueblo y ancianos de Israel,"
,"9":"ya que se nos pide cuentas por el bien que hemos hecho a un hombre enfermo y se nos pregunta de qué modo ha sido curado,"
,"10":"sabed todos vosotros y todo el pueblo de Israel que éste se encuentra sano ante vosotros en virtud del nombre de Jesucristo, el Nazareno, a quien vosotros crucificasteis y Dios resucitó de entre los muertos."
,"11":"Él es la piedra que vosotros, los constructores, habéis desechado, y que ha venido a ser la piedra angular."
,"12":"Y no hay salvación en ningún otro, pues no se nos ha dado a los hombres ningún otro nombre debajo del cielo para salvarnos'."
,"13":"Al ver, por una parte, la valentía de Pedro y Juan, y comprendiendo, por otra, que eran hombres sin instrucción y cultura, estaban sorprendidos. Reconocían que habían estado con Jesús;"
,"14":"pero al ver con ellos en pie al hombre que había sido curado, no podían replicarles nada."
,"15":"Les ordenaron salir de la sala del tribunal, y se pusieron a deliberar entre ellos,"
,"16":"preguntándose: '¿Qué haremos con estos hombres? Porque ciertamente han hecho un milagro notorio y manifiesto a todos los habitantes de Jerusalén, y no podemos negarlo."
,"17":"Pero para que no se divulgue más entre el pueblo, vamos a amenazarlos para que no vuelvan a hablar a nadie de ese hombre'."
,"18":"Los llamaron, y les ordenaron que no volvieran a hablar ni a enseñar nada sobre la persona de Jesús."
,"19":"Pedro y Juan les replicaron: '¿Os parece justo ante Dios que os obedezcamos a vosotros antes que a él?"
,"20":"Nosotros no podemos dejar de decir lo que hemos visto y oído'."
,"21":"Pero ellos los despidieron amenazándoles de nuevo, sin encontrar modo de castigarlos por causa del pueblo, porque todos alababan a Dios por lo sucedido,"
,"22":"pues el hombre milagrosamente curado era de más de cuarenta años."
,"23":"Puestos en libertad, fueron a reunirse con los suyos y les contaron lo que les habían dicho los sumos sacerdotes y los ancianos."
,"24":"Después de escucharlos, hicieron todos juntos, en voz alta, esta oración a Dios: 'Soberano Señor, tú eres el Dios que has hecho el cielo y la tierra, el mar y cuanto hay en ellos;"
,"25":"el que por boca de nuestro padre David, tu siervo, dijiste: ¿Por qué se amotinan las naciones,y los pueblos hacen proyectos vanos?"
,"26":"Se levantan los reyes de la tierra,y los príncipes conspiran a una,contra el Señor y su mesías."
,"27":"Así ha sido. En esta ciudad, Herodes y Poncio Pilato se confabularon con los paganos y gentes de Israel contra tu santo siervo Jesús, tu mesías,"
,"28":"para hacer lo que tu poder y tu sabiduría habían determinado que se hiciera."
,"29":"Ahora, Señor, mira sus amenazas y concede a tus siervos predicar tu palabra,"
,"30":"y extiende tu mano para curar y obrar señales y prodigios en el nombre de tu santo siervo Jesús'."
,"31":"Acabada su oración, tembló el lugar en que estaban reunidos, y quedaron todos llenos del Espíritu Santo, y anunciaban con absoluta libertad la palabra de Dios."
,"32":"Todos los creyentes tenían un solo corazón y una sola alma, y nadie llamaba propia cosa alguna de cuantas poseían, sino que tenían en común todas las cosas."
,"33":"Los apóstoles daban testimonio con toda firmeza de la resurrección de Jesús, el Señor. Y todos gozaban de gran simpatía."
,"34":"No había entre ellos indigentes, porque todos los que poseían haciendas o casas las vendían, llevaban el precio de lo vendido,"
,"35":"lo ponían a los pies de los apóstoles y se repartía a cada uno según sus necesidades."
,"36":"José, llamado por los apóstoles Bernabé -que significa hijo de la consolación-, levita, chipriota de nación,"
,"37":"tenía un campo, lo vendió, trajo el dinero y lo puso a los pies de los apóstoles."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Un tal Ananías, de acuerdo con Safira, su mujer, vendió una propiedad"
,"2":"y se quedó con parte del precio, sabiéndolo su mujer; llevó el resto y lo puso a los pies de los apóstoles."
,"3":"Pedro le dijo: 'Ananías, ¿por qué has dejado que entre dentro de ti Satanás para mentir al Espíritu Santo y quedarte con parte del precio del campo?"
,"4":"¿Es que antes de venderlo no era tuyo, y aun después de vendido no continuaba en tu poder? ¿Por qué resolviste hacer esto? No has mentido a los hombres, sino a Dios'."
,"5":"Ananías, al oír estas palabras, cayó muerto. Y cuantos lo supieron se llenaron de miedo."
,"6":"Unos jóvenes fueron, lo amortajaron y lo llevaron a enterrar."
,"7":"Unas tres horas más tarde llegó su mujer sin saber lo ocurrido."
,"8":"Pedro le preguntó: 'Dime si vendisteis el campo en tanto'. Y ella contestó: 'Sí, en tanto'."
,"9":"Pedro replicó: '¿Por qué os pusisteis de acuerdo para tentar al Espíritu del Señor? Ahí tienes a la puerta los pies de los que acaban de enterrar a tu marido; ellos te llevarán a ti también'."
,"10":"Cayó fulminantemente a los pies de él y expiró. Los jóvenes entraron, la encontraron muerta y la llevaron a enterrar junto a su marido."
,"11":"Toda la Iglesia y todos los que oyeron esto se quedaron sobrecogidos de terror."
,"12":"Los apóstoles hacían muchos milagros y prodigios en el pueblo; todos se reunían en el pórtico de Salomón."
,"13":"Los demás no se atrevían a unirse a ellos; pero el pueblo los tenía en gran estima."
,"14":"Y el número de hombres y mujeres que creían en el Señor aumentaba cada vez más;"
,"15":"y hasta sacaban los enfermos a las plazas y los ponían en camillas y angarillas para que, al pasar Pedro, al menos su sombra tocase alguno de ellos."
,"16":"De las aldeas próximas a Jerusalén acudía también mucha gente llevando enfermos y poseídos por espíritus inmundos, y todos eran curados."
,"17":"Intervino entonces el sumo sacerdote con todos los de su partido -la secta de los saduceos-. Llenos de furor,"
,"18":"detuvieron a los apóstoles y los metieron en la cárcel pública."
,"19":"Pero un ángel del Señor abrió por la noche las puertas de la cárcel, los sacó y dijo:"
,"20":"'Id al templo y anunciad con valentía al pueblo todo lo referente a esta nueva vida'."
,"21":"Obedecieron, entraron de madrugada en el templo y se pusieron a enseñar. Entretanto, el sumo sacerdote y sus partidarios convocaron al tribunal supremo y a todos los dirigentes de Israel, y mandaron a la cárcel a buscar a los apóstoles."
,"22":"Los alguaciles fueron, pero no los encontraron en la cárcel; volvieron y lo comunicaron diciendo:"
,"23":"'Hemos encontrado la cárcel bien cerrada y los guardias junto a las puertas; pero al abrir no hemos encontrado a nadie dentro'."
,"24":"Al oír esto, tanto el prefecto del templo como los sumos sacerdotes quedaron desconcertados, pensando qué habría sido de ellos."
,"25":"Llegó uno diciendo: 'Los hombres que metisteis en la cárcel están en el templo enseñando al pueblo'."
,"26":"Entonces el prefecto fue con los alguaciles y los trajo, pero sin emplear la violencia, porque temían que el pueblo los apedrease."
,"27":"Los trajeron y los presentaron al tribunal supremo. El sumo sacerdote les preguntó:"
,"28":"'¿No os ordenamos solemnemente que no enseñaseis en nombre de ése? Y, sin embargo, habéis llenado Jerusalén de vuestra doctrina y queréis hacernos responsables de la sangre de este hombre'."
,"29":"Pedro y los apóstoles respondieron: 'Hay que obedecer a Dios antes que a los hombres."
,"30":"El Dios de nuestros padres ha resucitado a Jesús, a quien vosotros matasteis colgándolo de un madero."
,"31":"Dios lo ha ensalzado con su diestra como jefe y salvador para dar a Israel el arrepentimiento y el perdón de los pecados."
,"32":"Nosotros somos testigos de estas cosas, como lo es también el Espíritu Santo que Dios ha dado a los que lo obedecen'."
,"33":"Ellos, enfurecidos con estas palabras, querían matarlos."
,"34":"Un fariseo llamado Gamaliel, doctor de la ley, respetado por todo el pueblo, se levantó en el tribunal, mandó que sacaran de la sala por unos momentos a los apóstoles y dijo:"
,"35":"'Israelitas, mirad bien lo que vais a hacer con estos hombres."
,"36":"Porque no hace mucho se alzó Teudas diciendo que él era alguien, y le siguieron unos cuatrocientos hombres; pero lo mataron, todos sus seguidores se dispersaron y de aquello ya no queda nada."
,"37":"Después de éste surgió Judas, el galileo, en los días del empadronamiento, que arrastró al pueblo tras de sí; también él cayó, y todos sus seguidores se dispersaron."
,"38":"Por lo que hace al caso presente, os digo que no os metáis con estos hombres y que los dejéis en paz; porque si su empresa es cosa de hombres, se desvanecerá por sí misma;"
,"39":"pero si es de Dios, no podréis deshacerla. No os expongáis a luchar contra Dios'. Aceptaron su consejo."
,"40":"Llamaron a los apóstoles, los azotaron, les prohibieron terminantemente hablar más de Jesús y los soltaron."
,"41":"Ellos salieron del tribunal muy contentos por haber sido dignos de ser ultrajados por tal nombre."
,"42":"No dejaban un día de enseñar, en el templo y en las casas, y de anunciar la buena noticia de que Jesús es el mesías."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Como el número de los discípulos aumentaba, los griegos se quejaron contra los hebreos porque descuidaban a sus viudas en el suministro cotidiano."
,"2":"Los doce convocaron a todos los fieles, y dijeron: 'No está bien que nosotros abandonemos la palabra de Dios por servir a las mesas."
,"3":"Elegid, pues, cuidadosamente entre vosotros, hermanos, siete hombres de buena reputación, llenos del Espíritu Santo y de sabiduría, y nosotros les encomendaremos este servicio;"
,"4":"nosotros perseveraremos en la oración y en el ministerio de la palabra'."
,"5":"Agradó la proposición a toda la asamblea, y eligieron a Esteban, hombre lleno de fe y del Espíritu Santo, y a Felipe y Prócoro, a Nicanor y a Timón, a Parmenas y a Nicolás, prosélito antioqueno;"
,"6":"los presentaron a los apóstoles, los cuales, después de orar, les impusieron las manos."
,"7":"La palabra de Dios crecía, el número de los fieles aumentaba considerablemente en Jerusalén, e incluso muchos sacerdotes abrazaban la fe."
,"8":"Esteban, por su parte, lleno de gracia y de poder, realizaba grandes prodigios y milagros en el pueblo."
,"9":"Unos cuantos de la sinagoga llamada de los Libertos, de Cirene, Alejandría, Cilicia y Asia, se pusieron a discutir con Esteban;"
,"10":"pero no podían resistir la sabiduría y el espíritu con que hablaba."
,"11":"Entonces sobornaron a unos hombres para que dijeran: 'Nosotros hemos oído a éste decir blasfemias contra Moisés y contra Dios'."
,"12":"Con esto amotinaron al pueblo, a los ancianos y a los maestros de la ley, los cuales se echaron sobre él, lo prendieron y lo llevaron al tribunal supremo."
,"13":"Después presentaron testigos falsos, que dijeron: 'Este hombre no cesa de decir palabras contra este lugar santo y contra la ley;"
,"14":"le hemos oído decir que ese Jesús, el Nazareno, destruirá este lugar y cambiará las costumbres que nos transmitió Moisés'."
,"15":"Entonces todos los que estaban sentados en el tribunal clavaron sus ojos en él y vieron su rostro como el rostro de un ángel."
}`)
	CurrentBook.AddChapter(7, `{
"1":"El sumo sacerdote preguntó: '¿Es esto verdad?'."
,"2":"Y él dijo: 'Hermanos y padres, escuchad: El Dios de la gloria se apareció a nuestro padre Abrahán cuando estaba en Mesopotamia, antes de vivir en Jarán,"
,"3":"y le dijo: Sal de tu tierra, deja tu familia y ven a la tierra que yo te mostraré."
,"4":"Salió entonces de la tierra de los caldeos y vivió en Jarán. Y allí, después de la muerte de su padre, Dios lo trasladó a esta tierra en que vosotros habitáis ahora;"
,"5":"y no le dio propiedad en esta región, ni siquiera un pie de tierra; pero prometió dársela en posesión a él y a su descendencia después de él, aunque no tenía hijos."
,"6":"Dios le declaró que su descendencia sería emigrante en tierra extranjera, y la esclavizarían y la maltratarían durante cuatrocientos años;"
,"7":"pero añadió: Yo juzgaré a la nación que los esclavice; y después de esto saldrán y me adorarán en este lugar."
,"8":"Y le dio la alianza de la circuncisión; por eso circuncidó a su hijo Isaac a los ocho días de nacer; e Isaac a Jacob, y Jacob a los doce patriarcas."
,"9":"Los patriarcas, envidiosos de José, lo vendieron a Egipto. Pero Dios estaba con él,"
,"10":"y lo libró de todas sus tribulaciones; le dio una gran sabiduría, con lo que se ganó el favor del Faraón, rey de Egipto, que lo hizo gobernador de Egipto y de toda la casa real."
,"11":"Sobrevino entonces en todo Egipto y en Canaán tal hambre y escasez que nuestros padres no encontraban qué comer."
,"12":"Jacob oyó que en Egipto había trigo y envió allí por primera vez a nuestros padres."
,"13":"La segunda vez José se dio a conocer a sus hermanos, y el Faraón conoció a la familia de José."
,"14":"Entonces José mandó llamar a su padre Jacob y a toda la familia, compuesta de setenta y cinco personas."
,"15":"Jacob fue a Egipto, donde él y nuestros padres murieron."
,"16":"Sus cuerpos fueron trasladados a Siquén y puestos en el sepulcro que Abrahán había comprado con dinero a los hijos de Jamot."
,"17":"A medida que se acercaba el tiempo en que se debía cumplir la promesa que Dios había hecho a Abrahán, el pueblo aumentaba y se multiplicaba en Egipto,"
,"18":"hasta que surgió otro rey que no conocía a José."
,"19":"Éste se portó cruelmente con nuestros padres y les obligó a abandonar a sus hijos recién nacidos, para que se extinguiese la raza."
,"20":"En este momento nació Moisés, que fue grato a Dios. Criado durante tres meses en casa de su padre,"
,"21":"fue abandonado, y la hija del Faraón lo recogió y lo crió como hijo propio."
,"22":"Moisés fue instruido en todo el saber de los egipcios, y era poderoso en palabras y obras."
,"23":"Cuando cumplió cuarenta años, se propuso visitar a sus hermanos, los israelitas."
,"24":"Vio maltratar a uno de ellos, salió en su defensa y se vengó de él matando al egipcio."
,"25":"Esperaba que sus hermanos comprendieran que Dios les daba por medio de él la libertad; pero ellos no lo entendieron."
,"26":"Al día siguiente los sorprendió riñendo y trató de reconciliarlos, diciendo: Hombres, sois hermanos; ¿por qué os maltratáis unos a otros?"
,"27":"El que maltrataba a su prójimo lo rechazó diciendo: ¿Quién te ha puesto de jefe y juez sobre nosotros?"
,"28":"¿Es que quieres matarme, como mataste ayer al egipcio?"
,"29":"Al oír esto, Moisés huyó y se fue a vivir como extranjero a la tierra de Madián, donde tuvo dos hijos."
,"30":"Cuarenta años después, se le apareció en el desierto del monte Sinaí un ángel en la llama de una zarza ardiente."
,"31":"Moisés se sorprendió de lo que veía; al acercarse para verlo mejor, se oyó la voz del Señor:"
,"32":"Yo soy el Dios de tus padres, el Dios de Abrahán, de Isaac y de Jacob. Moisés, tembloroso, no se atrevió a mirar."
,"33":"El Señor le dijo: Descálzate, porque el lugar en que estás es tierra santa."
,"34":"He visto bien la esclavitud de mi pueblo en Egipto; he oído sus gemidos y he bajado a librarlos. Y ahora ven, que te voy a enviar a Egipto."
,"35":"A este Moisés a quien habían rechazado diciendo: ¿Quién te ha puesto por jefe y juez?, a ése Dios lo envió como jefe y libertador por mediación del ángel que se le apareció en la zarza."
,"36":"Él fue quien los sacó, obrando prodigios y milagros en Egipto, en el mar Rojo y en el desierto durante cuarenta años."
,"37":"Él es el que dijo a los israelitas: Dios os suscitará de entre vuestros hermanos un profeta como yo."
,"38":"Él es el que, en la asamblea, en el desierto, estuvo con el ángel que les hablaba en el monte Sinaí, y con nuestros padres; el que escribió palabras de vida para transmitírnoslas;"
,"39":"al que no quisieron obedecer nuestros padres, sino que lo rechazaron, y, con el corazón puesto en Egipto,"
,"40":"dijeron a Aarón: Haznos dioses que vayan delante de nosotros; porque ese Moisés que nos sacó de Egipto no sabemos qué ha sido de él."
,"41":"Hicieron en aquellos días un becerro, ofrecieron sacrificios al ídolo y se regocijaron en la obra de sus manos."
,"42":"Dios, entonces, les volvió las espaldas y los entregó al culto de los astros, como está escrito en el libro de los profetas: ¿Me ofrecisteis sacrificios y ofrendas en el desierto durante cuarenta años, casa de Israel?"
,"43":"Pero llevasteis la tienda de Moloc y la estrella del dios Refán, las imágenes que hicisteis para adorarlas. También yo os desterraré más allá de Babilonia."
,"44":"Nuestros padres tenían en el desierto la tienda del testimonio, como ordenó aquel que dijo a Moisés que lo hiciera según el modelo que había visto."
,"45":"Nuestros antepasados se fueron pasando la tienda de padres a hijos y la introdujeron, guiados por Josué, en la tierra conquistada a los paganos, a los que expulsó Dios delante de ellos. Así hasta los días de David,"
,"46":"el cual gozaba del favor de Dios, y le pidió que le permitiera construir una morada al Dios de Jacob."
,"47":"Sin embargo, fue Salomón el que la construyó."
,"48":"Pero el altísimo no habita en obras hechas por manos de hombres, como dice el profeta:"
,"49":"El cielo es mi trono, y la tierra, el estrado de mis pies; ¿qué casa podríais construirme,y qué lugar para reposo mío?"
,"50":"¿No hizo mi mano todas estas cosas?"
,"51":"Hombres de cabeza dura e incircuncisos de corazón y de oídos, vosotros resistís siempre al Espíritu Santo; como fueron vuestros padres, así sois también vosotros."
,"52":"¿A qué profeta no persiguieron vuestros padres? Mataron a los que predijeron la venida del Justo, del cual vosotros ahora sois los traidores y asesinos;"
,"53":"vosotros, que habéis recibido la ley por ministerio de los ángeles, y no la habéis guardado'."
,"54":"Al oír esto estallaban de rabia sus corazones, y rechinaban los dientes contra él."
,"55":"Pero él, lleno del Espíritu Santo, con los ojos fijos en el cielo, vio la gloria de Dios y a Jesús de pie a la derecha de Dios,"
,"56":"y dijo: 'Veo los cielos abiertos y al hijo del hombre de pie a la derecha de Dios'."
,"57":"Ellos, lanzando grandes gritos, se taparon los oídos y se lanzaron todos a una sobre él;"
,"58":"lo llevaron fuera de la ciudad y se pusieron a apedrearlo. Los testigos habían dejado sus vestidos a los pies de un joven llamado Saulo."
,"59":"Mientras lo apedreaban, Esteban oró así: 'Señor Jesús, recibe mi espíritu'."
,"60":"Y puesto de rodillas, gritó con fuerte voz: 'Señor, no les tengas en cuenta este pecado'. Y diciendo esto, expiró. Saulo aprobaba este asesinato."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Aquel día se desencadenó una gran persecución contra la Iglesia de Jerusalén; y todos, excepto los apóstoles, se dispersaron por las regiones de Judea y Samaría."
,"2":"Unos hombres piadosos enterraron a Esteban e hicieron gran duelo por él."
,"3":"Saulo, en cambio, asolaba la Iglesia; entraba en las casas, sacaba a rastras a hombres y mujeres y los metía en la cárcel."
,"4":"Los que tuvieron que salir huyendo fueron por todas partes anunciando la palabra."
,"5":"Felipe llegó a la ciudad de Samaría, y se puso a predicar a Cristo."
,"6":"La gente escuchaba con atención a Felipe, pues había oído hablar de los milagros que hacía y ahora los estaban viendo:"
,"7":"de muchos posesos salían los espíritus impuros dando grandes voces, y muchos paralíticos y cojos quedaban curados."
,"8":"La ciudad se llenó de alegría."
,"9":"Hacía tiempo que venía practicando la magia en la ciudad un tal Simón, que tenía asombrada a la gente de Samaría, diciendo que él era algo grande."
,"10":"Todos, desde el más chico al más grande, le seguían y decían: 'Éste es el poder mismo de Dios, el que llaman el Grande'."
,"11":"Lo seguían porque durante bastante tiempo los había asombrado con magias."
,"12":"Pero cuando Felipe les habló del reino de Dios y de Jesucristo, hombres y mujeres creyeron en él y se bautizaron."
,"13":"El mismo Simón creyó y se bautizó; y ya no se apartaba de Felipe, viendo maravillado los prodigios y milagros insignes que hacía."
,"14":"Los apóstoles, que estaban en Jerusalén, al saber que Samaría había recibido la palabra de Dios, les enviaron a Pedro y a Juan;"
,"15":"llegaron y oraron por los samaritanos, para que recibieran el Espíritu Santo;"
,"16":"pues aún no había bajado sobre ninguno de ellos, y sólo habían recibido el bautismo en el nombre de Jesús, el Señor."
,"17":"Entonces les impusieron las manos, y recibieron el Espíritu Santo."
,"18":"Simón, al ver que mediante la imposición de las manos de los apóstoles se confería el Espíritu Santo, les ofreció dinero,"
,"19":"diciendo: 'Dadme también a mí ese poder, para que al que imponga las manos reciba el Espíritu Santo'."
,"20":"Pedro le dijo: 'Al infierno tú y tu dinero, por haber creído que el don de Dios se compra con dinero."
,"21":"No tienes parte ni herencia en esto, porque tu corazón no es recto delante de Dios."
,"22":"Arrepiéntete de tu maldad y pide al Señor que te perdone, si es posible, el mal pensamiento que has tenido;"
,"23":"pues veo que no tienes buenas intenciones y estás atrapado en los lazos de la iniquidad'."
,"24":"Simón respondió: 'Pedid vosotros por mí al Señor para que no me suceda nada de lo que acabáis de decir'."
,"25":"Ellos, después de haber dado testimonio y haber predicado la palabra del Señor, se volvieron a Jerusalén, evangelizando muchas aldeas de los samaritanos."
,"26":"El ángel del Señor dijo a Felipe: 'Ponte en marcha hacia el sur, por el camino que va de Jerusalén a Gaza a través del desierto'."
,"27":"Y se puso en marcha. En esto un etíope eunuco, ministro de Candaces, reina de Etiopía, administrador de todos sus bienes, que había venido a Jerusalén,"
,"28":"regresaba y, sentado en su carro, leía al profeta Isaías."
,"29":"El Espíritu dijo a Felipe: 'Avanza y acércate a ese carro'."
,"30":"Felipe corrió, oyó que leía al profeta Isaías y dijo: '¿Entiendes lo que estás leyendo?'."
,"31":"Él respondió: '¿Cómo lo voy a entender si alguien no me lo explica?'. Y rogó a Felipe que subiera y se sentara con él."
,"32":"El pasaje de la Escritura que leía era éste: Como cordero llevado al matadero, como ante sus esquiladores,una oveja muda,y sin abrir la boca."
,"33":"Por ser pobre, no le hicieron justicia. Nadie podrá hablar,de su descendencia, pues fue arrancado,de la tierra de los vivos."
,"34":"El eunuco dijo a Felipe: 'Por favor, ¿de quién dice esto el profeta? ¿De él o de otro?'."
,"35":"Felipe tomó la palabra y, comenzando por este pasaje de la Escritura, le anunció la buena nueva de Jesús."
,"36":"Continuaron su camino y llegaron a un lugar donde había agua; el eunuco dijo: 'Mira, aquí hay agua; ¿qué impide que me bautice?'."
,"38":"Y mandó detener el carro. Bajaron los dos al agua, Felipe y el eunuco, y lo bautizó."
,"39":"Al salir del agua, el Espíritu del Señor arrebató a Felipe. El eunuco ya no lo vio más, y continuó su camino muy contento."
,"40":"Felipe se encontró con que estaba en Azoto, y fue evangelizando todas las ciudades hasta llegar a Cesarea."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Saulo, por su parte, respirando aún amenazas de muerte contra los discípulos del Señor, se presentó al sumo sacerdote"
,"2":"y le pidió cartas para las sinagogas de Damasco, con el fin de que si encontraba algunos que siguieran este camino, hombres o mujeres, pudiera llevarlos presos a Jerusalén."
,"3":"En el camino, cerca ya de Damasco, de repente le envolvió un resplandor del cielo;"
,"4":"cayó a tierra y oyó una voz que le decía: 'Saulo, Saulo, ¿por qué me persigues?'."
,"5":"Él preguntó: '¿Quién eres, Señor?'. Y él: 'Yo soy Jesús, a quien tú persigues."
,"6":"Levántate y entra en la ciudad; allí te dirán lo que debes hacer'."
,"7":"Los que lo acompañaban se quedaron atónitos, oyendo la voz, pero sin ver a nadie."
,"8":"Saulo se levantó del suelo, y, aunque tenía los ojos abiertos, no veía nada; lo llevaron de la mano a Damasco,"
,"9":"donde estuvo tres días sin ver y sin comer ni beber."
,"10":"Había en Damasco un discípulo llamado Ananías, a quien el Señor llamó en una visión: '¡Ananías!'. Y él respondió: 'Aquí estoy, Señor'."
,"11":"El Señor le dijo: 'Vete rápidamente a la casa de Judas, en la calle Recta, y pregunta por un tal Saulo de Tarso, que está allí en oración"
,"12":"y ha tenido una visión: un hombre llamado Ananías entraba y le imponía las manos para devolverle la vista'."
,"13":"Ananías respondió: 'Señor, he oído a muchos hablar de ese hombre y decir todo el mal que ha hecho a tus fieles en Jerusalén."
,"14":"Y está aquí con plenos poderes de los sumos sacerdotes para prender a todos los que te invocan'."
,"15":"El Señor le dijo: 'Anda, que éste es un instrumento que he elegido yo para llevar mi nombre a los paganos, a los reyes y a los israelitas."
,"16":"Yo le mostraré cuánto debe padecer por mí'."
,"17":"Ananías partió inmediatamente y entró en la casa, le impuso las manos y le dijo: 'Saulo, hermano mío, vengo de parte de Jesús, el Señor, el que se te apareció en el camino por el que venías, para que recobres la vista y quedes lleno del Espíritu Santo'."
,"18":"En el acto se le cayeron de los ojos como escamas, y recobró la vista; se levantó y fue bautizado."
,"19":"Comió y recobró fuerzas. Y se quedó unos días con los discípulos que había en Damasco."
,"20":"Y en seguida se puso a predicar en las sinagogas proclamando que Jesús es el Hijo de Dios."
,"21":"Todos los que lo escuchaban se quedaban estupefactos y decían: '¿No es éste el que perseguía en Jerusalén a los que invocan ese nombre, y no ha venido aquí para llevarlos encadenados a los sumos sacerdotes?'."
,"22":"Saulo cobraba cada vez más ánimo y tenía confundidos a los judíos de Damasco, demostrando que Jesús es el mesías."
,"23":"Cuando pasaron bastantes días, los judíos acordaron en consejo matarlo;"
,"24":"pero Saulo se enteró de este complot. Custodiaban las puertas de la ciudad día y noche con intención de asesinarlo,"
,"25":"pero los discípulos lo descolgaron de noche por la muralla en un cesto."
,"26":"Cuando llegó a Jerusalén, trató de unirse a los demás discípulos; pero todos lo temían, no creyendo que fuera de verdad discípulo."
,"27":"Entonces Bernabé lo tomó consigo, lo presentó a los apóstoles y les refirió cómo en el camino Saulo había visto al Señor, que le había hablado, y cómo en Damasco había predicado públicamente en el nombre de Jesús."
,"28":"Desde entonces se movía libremente en Jerusalén, hablando con libertad en el nombre del Señor."
,"29":"Hablaba y discutía con los helenistas, los cuales intentaron matarle."
,"30":"Los hermanos, al enterarse, lo llevaron escoltado a Cesarea y le hicieron partir para Tarso."
,"31":"La Iglesia gozaba de paz en toda Judea, Galilea y Samaría; se consolidaba y progresaba en la fidelidad al Señor, y se extendía alentada por el Espíritu Santo."
,"32":"Pedro, que lo recorría todo, fue también a visitar a los fieles de Lida."
,"33":"Allí encontró a un tal Eneas, paralítico, postrado en una camilla desde hacía ocho años."
,"34":"Pedro le dijo: 'Eneas, Jesús, el mesías, te cura; levántate y haz tú mismo la cama'. Y al instante se levantó."
,"35":"Todos los habitantes de Lida y Sarón lo vieron y se convirtieron al Señor."
,"36":"En Jafa había una discípula llamada Tabita, que significa 'gacela', la cual se dedicaba a hacer buenas obras y muchas limosnas."
,"37":"Por aquellos días cayó enferma y se murió. La lavaron y la pusieron en la estancia de arriba."
,"38":"Como Lida está cerca de Jafa, los discípulos enviaron dos hombres para pedirle que fuera rápidamente a Jafa."
,"39":"Pedro se levantó y se fue con ellos. Cuando llegó, lo subieron a la estancia de arriba. Allí le rodearon todas las viudas, llorando y mostrando las túnicas y mantos que les hacía Gacela cuando vivía con ellas."
,"40":"Pedro echó fuera a todos; luego se arrodilló y se puso a orar; se acercó después al cadáver y dijo: 'Tabita, levántate'. Ella abrió sus ojos y, al ver a Pedro, se incorporó."
,"41":"Pedro le dio la mano y la levantó. Llamó a los fieles y a las viudas y se la presentó viva."
,"42":"Esto fue notorio en toda Jafa, y muchos creyeron en el Señor."
,"43":"Y se quedó bastantes días en Jafa, en casa de un tal Simón, que era curtidor."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Había en Cesarea un hombre llamado Cornelio, centurión de la cohorte Itálica."
,"2":"Piadoso y temeroso de Dios, con toda su casa, hacía muchas limosnas al pueblo y oraba continuamente a Dios."
,"3":"Hacia las tres de la tarde tuvo una visión, en la que vio claramente al ángel de Dios, que se le presentó y le dijo: '¡Cornelio!'."
,"4":"Y él, mirándolo fijamente y atemorizado, dijo: '¿Qué pasa, Señor?'. Y le dijo: 'Tus oraciones y tus limosnas han subido a la presencia de Dios, que se ha acordado de ti."
,"5":"Manda a unos hombres a Jafa a llamar a Simón Pedro."
,"6":"Está en casa de un tal Simón, curtidor, junto al mar'."
,"7":"Cuando se marchó el ángel que le hablaba, llamó a dos de sus criados y un soldado piadoso, de los que le asistían,"
,"8":"les explicó todo y los mandó a Jafa."
,"9":"Al día siguiente, mientras ellos caminaban y se acercaban a la ciudad, Pedro subió a la azotea a orar hacia el mediodía."
,"10":"Tuvo hambre y quiso comer algo; y mientras le preparaban de comer, tuvo un éxtasis:"
,"11":"vio el cielo abierto y un objeto a modo de un gran lienzo, que colgado de las cuatro puntas descendía hacia la tierra;"
,"12":"en él había toda clase de cuadrúpedos, reptiles de la tierra y aves del cielo."
,"13":"Una voz le dijo: 'Levántate, Pedro, mata y come'."
,"14":"Pedro dijo: 'De ningún modo, Señor, porque jamás he comido cosa profana o impura'."
,"15":"La voz le dijo de nuevo: 'Lo que Dios ha purificado no lo llames impuro'."
,"16":"Esto se repitió por tres veces. Y luego el objeto fue arrebatado al cielo."
,"17":"Pedro estaba perplejo, pensando lo que podría significar la visión que acababa de tener, cuando los hombres enviados por Cornelio, que habían averiguado dónde estaba la casa de Simón, se presentaron en la puerta."
,"18":"Llamaron, y preguntaron si se alojaba allí Simón Pedro."
,"19":"Pedro seguía pensando en la visión; el Espíritu Santo le dijo: 'Ahí te buscan tres hombres;"
,"20":"baja y no dudes en ir con ellos, porque los he enviado yo'."
,"21":"Pedro bajó y les dijo: 'Yo soy el que buscáis. ¿Por qué habéis venido?'."
,"22":"Ellos dijeron: 'El centurión Cornelio, varón justo y temeroso de Dios, que goza de la reputación de todos los judíos, ha recibido aviso de un santo ángel para que te mande llamar y vayas a su casa y oír lo que tengas que decirle'."
,"23":"Pedro los invitó y los hospedó. Al día siguiente se levantó y fue con ellos; y lo acompañaron algunos hermanos de Jafa."
,"24":"Al día siguiente llegaron a Cesarea. Cornelio estaba esperándolos, y había convocado a sus parientes y amigos íntimos."
,"25":"Tan pronto como entró Pedro, Cornelio le salió al encuentro, cayó a sus pies y le adoró."
,"26":"Pedro lo levantó diciendo: 'Levántate, que yo también soy hombre'."
,"27":"Y conversando con él, entró y encontró a muchos reunidos;"
,"28":"y les dijo: 'Vosotros sabéis que a un judío le está prohibido juntarse con extranjeros y entrar en su casa. Pero Dios me ha enseñado a no llamar profano o impuro a ningún hombre;"
,"29":"por lo cual he venido sin vacilar al ser llamado. Yo os pregunto ahora por qué motivo me habéis llamado'."
,"30":"Cornelio respondió: 'Hace cuatro días, justamente a esta misma hora, las tres de la tarde, estaba yo orando en mi casa, cuando se presentó delante de mí un hombre con un vestido resplandeciente,"
,"31":"y me dijo: Cornelio, Dios ha escuchado tu oración y tiene presente tus limosnas."
,"32":"Envía a Jafa a llamar a Simón Pedro, que se hospeda en casa de Simón, curtidor, junto al mar."
,"33":"Te mandé a buscar en seguida; y has hecho bien en venir. Y ahora aquí estamos todos delante de Dios para escuchar todos los preceptos que el Señor te ha dado'."
,"34":"Pedro tomó la palabra y dijo: 'Compruebo que Dios no hace distinción de personas,"
,"35":"que acepta al que le es fiel y practica la justicia, sea de la nación que sea."
,"36":"Él ha enviado su palabra a los israelitas anunciando la paz por medio de Jesucristo, que es el Señor de todos."
,"37":"Vosotros conocéis lo que ha pasado en Judea, comenzando por Galilea, después del bautismo que predicó Juan:"
,"38":"cómo Dios ungió con el Espíritu Santo y llenó de poder a Jesús de Nazaret, el cual pasó haciendo el bien y curando a los oprimidos por el demonio, porque Dios estaba con él."
,"39":"Nosotros somos testigos de todo lo que hizo en el país de los judíos y en Jerusalén. Ellos lo mataron, colgándolo de un madero."
,"40":"Pero Dios lo resucitó al tercer día y le concedió que se manifestase"
,"41":"no a todo el pueblo, sino a los testigos elegidos de antemano por Dios, a nosotros, que hemos comido y bebido con él después de su resurrección de entre los muertos;"
,"42":"y nos encargó predicar al pueblo y proclamar que Dios lo ha constituido juez de vivos y muertos."
,"43":"Todos los profetas testifican que el que crea en él recibirá, por su nombre, el perdón de los pecados'."
,"44":"Todavía estaba hablando Pedro, cuando descendió el Espíritu Santo sobre todos los que escuchaban sus palabras."
,"45":"Todos los fieles circuncisos que habían venido con Pedro se extrañaban de que el don del Espíritu Santo se hubiera derramado también sobre los paganos,"
,"46":"pues los oían hablar lenguas extrañas y glorificar a Dios."
,"47":"Pedro dijo entonces: '¿Se puede negar el agua del bautismo a éstos, que han recibido el Espíritu Santo como nosotros?'."
,"48":"Y ordenó que fuesen bautizados en el nombre de Jesucristo. Entonces le suplicaron que se quedara con ellos algunos días."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Los apóstoles y los hermanos que estaban en Judea supieron que también los paganos habían recibido la palabra de Dios."
,"2":"Cuando Pedro llegó a Jerusalén, los partidarios de la circuncisión le echaron en cara:"
,"3":"'¿Por qué has entrado en casa de hombres incircuncisos y has comido con ellos?'."
,"4":"Entonces Pedro comenzó a explicarles por orden, diciendo:"
,"5":"'Estaba yo en la ciudad de Jafa orando, cuando tuve en éxtasis una visión: un objeto descendía a modo de un gran lienzo, colgado por las cuatro puntas desde el cielo, y llegó hasta mí."
,"6":"Yo lo miré fijamente, lo examiné y vi cuadrúpedos, bestias, reptiles y aves."
,"7":"Oí también una voz que me decía: Levántate, Pedro, mata y come."
,"8":"Pero yo dije: De ninguna manera, Señor; porque nada profano o impuro ha entrado jamás en mi boca."
,"9":"Pero la voz del cielo dijo por segunda vez: Lo que Dios ha purificado, tú no lo llames impuro."
,"10":"Esto se repitió por tres veces, y todo fue arrebatado de nuevo al cielo."
,"11":"Entonces mismo se presentaron en la casa donde yo estaba tres hombres que me habían enviado desde Cesarea."
,"12":"Y el Espíritu me dijo que fuera con ellos sin dudar. Estos seis hermanos vinieron también conmigo y entramos en la casa del hombre en cuestión,"
,"13":"el cual nos contó que se le había aparecido un ángel y que le había dicho: Manda a Jafa a llamar a Simón Pedro,"
,"14":"el cual, con sus palabras, te traerá la salvación a ti y a tu familia."
,"15":"Y al comenzar yo a hablar, descendió el Espíritu Santo sobre ellos, como al principio sobre nosotros."
,"16":"Recordé estas palabras del Señor: Juan bautizó en agua, pero vosotros seréis bautizados en el Espíritu Santo."
,"17":"Pues si Dios les ha dado a ellos el mismo don que a nosotros por haber creído en el Señor Jesucristo, ¿cómo podía yo oponerme a Dios?'."
,"18":"Al oír esto callaron y glorificaron a Dios, diciendo: 'Así que también a los paganos Dios ha concedido el arrepentimiento para alcanzar la vida'."
,"19":"Los que se habían dispersado a causa de la persecución ocurrida con ocasión de Esteban, llegaron hasta Fenicia, Chipre y Antioquía, predicando sólo a los judíos."
,"20":"Pero había entre ellos algunos chipriotas y cirenenses, quienes, llegados a Antioquía, se dirigieron también a los griegos, anunciando a Jesús, el Señor."
,"21":"El Señor estaba con ellos, y un gran número creyó y se convirtió al Señor."
,"22":"Llegó la noticia a oídos de la Iglesia de Jerusalén, y enviaron a Bernabé a Antioquía."
,"23":"Al llegar y ver la gracia de Dios, se llenó de alegría y exhortaba a todos a perseverar con un corazón firme, fieles al Señor,"
,"24":"porque era un hombre bueno y lleno del Espíritu Santo y de fe. Y una gran multitud se unió al Señor."
,"25":"Se fue a Tarso en busca de Saulo; lo encontró y se lo llevó a Antioquía."
,"26":"Y estuvieron un año entero en aquella Iglesia instruyendo en la fe a muchas personas. Fue en Antioquía donde por primera vez los discípulos recibieron el nombre de cristianos."
,"27":"Por entonces unos profetas fueron de Jerusalén a Antioquía."
,"28":"Se levantó uno de ellos, llamado Agabo, y, movido por el Espíritu, anunció que iba a sobrevenir sobre toda la tierra una gran escasez. Fue la que vino en tiempo de Claudio."
,"29":"Los discípulos, cada uno según sus posibilidades, decidieron enviar socorro a los hermanos de Judea."
,"30":"Y así lo hicieron, enviándolo a los presbíteros por medio de Bernabé y Saulo."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Por entonces el rey Herodes prendió a algunos de la Iglesia para maltratarlos."
,"2":"Hizo morir a espada a Santiago, hermano de Juan."
,"3":"Y viendo que esto agradaba a los judíos, hizo prender también a Pedro. Eran los días de la pascua."
,"4":"Lo prendió, lo encarceló y mandó que lo custodiasen cuatro piquetes de cuatro soldados, con intención de hacerlo comparecer ante el pueblo después de la pascua."
,"5":"Mientras Pedro estaba de este modo custodiado en la cárcel, la Iglesia oraba sin cesar por él a Dios."
,"6":"La misma noche en que Herodes iba a hacerlo comparecer, Pedro estaba dormido entre dos soldados, atado con cadenas; los centinelas montaban la guardia en la puerta de la cárcel."
,"7":"De repente se presentó un ángel del Señor, y la celda quedó toda iluminada. El ángel tocó a Pedro en el costado y lo despertó diciendo: 'Levántate en seguida'. Y se le cayeron las cadenas de las manos."
,"8":"El ángel le dijo: 'Cíñete y ponte tus sandalias'. Así lo hizo. Y añadió: 'Échate el manto y sígueme'."
,"9":"Pedro salió y lo siguió, sin saber si era realidad lo que el ángel hacía, pues se figuraba que era una visión."
,"10":"Pasaron la primera y segunda guardia, y llegaron a la puerta de hierro que da a la ciudad, la cual se les abrió por sí sola. Salieron y avanzaron por una calle; y de repente el ángel lo dejó."
,"11":"Entonces Pedro, dándose cuenta de lo que pasaba, dijo: 'Ahora sé realmente que el Señor ha enviado su ángel y me ha arrancado de la mano de Herodes y de todo lo que esperaba el pueblo judío'."
,"12":"Y tras reflexionar, se fue a casa de María, la madre de Juan, apellidado Marcos, donde había muchos reunidos y orando."
,"13":"Tocó a la puerta del portal, y salió a escuchar una muchacha llamada Rode,"
,"14":"la cual, al conocer la voz de Pedro, de alegría no abrió, sino que fue corriendo a decir que estaba Pedro a la puerta."
,"15":"Ellos le dijeron: 'Estás loca'. Pero ella insistía en que era así. Y ellos decían: 'Es su ángel'."
,"16":"Pedro continuaba golpeando. Cuando abrieron y vieron que era él, quedaron estupefactos."
,"17":"Pedro les hizo señas con la mano de que callasen y contó cómo el Señor lo había sacado de la cárcel. Y añadió: 'Comunicádselo a Santiago y a los hermanos'. Luego salió y se fue a otro sitio."
,"18":"Al venir el día hubo una gran confusión entre los soldados por lo que habría sido de Pedro."
,"19":"Herodes lo buscó y, al no encontrarlo, interrogó a los guardias y los mandó ajusticiar. De Judea se fue a Cesarea, y allí se quedó."
,"20":"Herodes estaba irritado con los tirios y sidonios, que de común acuerdo se presentaron ante él, y habiéndose ganado a Blasto, que era camarero del rey, solicitaban la paz, porque su país se abastecía del país real."
,"21":"El día señalado, Herodes, vestido con atavíos reales y sentado en el tribunal, los arengó."
,"22":"Y el pueblo gritaba: 'Es un dios que habla, y no un hombre'."
,"23":"Pero en aquel instante un ángel del Señor lo hirió de muerte, por haberse arrogado el honor de Dios, y murió roído de gusanos."
,"24":"Mientras tanto la palabra del Señor crecía y se multiplicaba."
,"25":"Bernabé y Saulo, después de haber cumplido su misión, volvieron de Jerusalén, llevando consigo a Juan Marcos."
}`)
	CurrentBook.AddChapter(13, `{
"1":"En la Iglesia de Antioquía había profetas y doctores: Bernabé y Simón, apodado el Negro; Lucio de Cirene; Manahén, hermano de leche de Herodes el virrey, y Saulo."
,"2":"Mientras celebraban el culto del Señor y ayunaban, el Espíritu Santo dijo: 'Separadme a Bernabé y a Saulo para la obra a la que los he llamado'."
,"3":"Entonces, después de haber ayunado y orado, les impusieron las manos y los despidieron."
,"4":"Con esta misión del Espíritu Santo fueron a Seleucia, desde donde se embarcaron hacia Chipre."
,"5":"Al llegar a Salamina, se pusieron a anunciar la palabra de Dios en las sinagogas de los judíos. Tenían también a Juan como auxiliar."
,"6":"Atravesaron toda la isla de Pafos y encontraron a un mago pseudoprofeta judío, llamado Bar Jesús,"
,"7":"que estaba con el procónsul Sergio Paulo, hombre prudente, el cual llamó a Bernabé y Saulo deseoso de oír la palabra de Dios."
,"8":"Pero Elimas, el mago (tal es el significado de su nombre), se les oponía procurando apartar al procónsul de la fe."
,"9":"Entonces, Saulo, llamado también Pablo, lleno del Espíritu Santo, clavó en él sus ojos y le dijo:"
,"10":"'Embustero, malvado hijo del diablo, enemigo de toda justicia, ¿cuándo vas a cesar de hacer tortuosos los rectos caminos del Señor?"
,"11":"Pues ahora la mano del Señor está sobre ti; te vas a quedar ciego sin ver el sol por cierto tiempo'. Y en el mismo instante quedó sumergido en la oscuridad y en las tinieblas; y, dando vueltas, buscaba quien lo llevara de la mano."
,"12":"Entonces el procónsul, viendo lo que había sucedido, creyó, lleno de admiración por la doctrina del Señor."
,"13":"Pablo y los suyos zarparon de Pafos y llegaron a Perge de Panfilia. Juan los dejó y se volvió a Jerusalén."
,"14":"Ellos continuaron su viaje, y de Perge pasaron a Antioquía de Pisidia. El sábado entraron en la sinagoga y se sentaron."
,"15":"Después de la lectura de la ley y de los profetas, los jefes de la sinagoga les mandaron a decir: 'Hermanos, si tenéis alguna palabra que comunicar al pueblo, decidla'."
,"16":"Pablo se levantó y, haciendo con la mano señal de silencio, dijo: 'Israelitas y los que sois fieles a Dios, escuchad."
,"17":"El Dios de este pueblo, Israel, eligió a nuestros padres y acrecentó al pueblo durante su exilio en Egipto, y con brazo poderoso los sacó de allí."
,"18":"Por espacio de cuarenta años los asistió en el desierto,"
,"19":"y después de haber destruido a siete naciones en tierra de Canaán, les dio la posesión de sus tierras"
,"20":"al cabo de unos cuatrocientos cincuenta años. Después de esto, les dio jueces hasta el profeta Samuel."
,"21":"Luego pidieron rey, y Dios les dio a Saúl, hijo de Cis, de la tribu de Benjamín, que reinó durante cuarenta años."
,"22":"Después lo destituyó y les dio como rey a David, hijo de Jesé, de quien dio este testimonio: He encontrado a David, hombre de mi agrado, quien cumplirá todos mis deseos."
,"23":"Dios, según sus promesas, de la descendencia de éste ha suscitado para Israel un salvador, Jesús."
,"24":"Antes de su venida, Juan había predicado a todo el pueblo de Israel un bautismo de conversión."
,"25":"Cuando estaba para terminar su misión, Juan decía: Yo no soy lo que vosotros creéis que soy, sino que viene en pos de mí aquel de quien no soy digno de desatar la sandalia."
,"26":"Hermanos, hijos de la estirpe de Abrahán, y los que sois fieles a Dios: a vosotros ha sido enviada esta palabra de salvación."
,"27":"Porque los habitantes de Jerusalén y sus jefes han cumplido, sin saberlo, las palabras de los profetas que se leen cada sábado;"
,"28":"y sin haber encontrado ninguna causa de muerte, le condenaron y pidieron a Pilato que lo matase."
,"29":"Y así que cumplieron lo que acerca de él estaba escrito, lo bajaron del leño y lo sepultaron."
,"30":"Pero Dios lo resucitó de entre los muertos;"
,"31":"él se apareció durante muchos días a los que habían ido con él de Galilea a Jerusalén, y que ahora son sus testigos ante el pueblo."
,"32":"Nosotros os anunciamos la buena nueva: la promesa hecha a nuestros padres"
,"33":"Dios la ha cumplido en nosotros, sus hijos, resucitando a Jesús, según está escrito en el salmo segundo: Tú eres mi hijo, yo te he engendrado hoy."
,"34":"Y que Dios lo ha resucitado de los muertos de forma que no vuelva más a la corrupción, lo había afirmado: Os cumpliré las promesas firmes que hice a David."
,"35":"Por lo cual dice también en otra parte: No permitirás que tu santo vea la corrupción."
,"36":"Pues bien, David, después de haber cumplido durante su vida la voluntad de Dios, murió, fue sepultado con sus padres y vio la corrupción."
,"37":"Pero el que Dios ha resucitado no ha visto la corrupción."
,"38":"Sabed, pues, hermanos, que por medio de éste se os anuncia el perdón de los pecados;"
,"39":"y quien cree en él es justificado de todas las cosas de las que no pudisteis ser justificados por la ley de Moisés."
,"40":"Mirad, por tanto, que no os suceda lo dicho en los profetas:"
,"41":"Mirad, engreídos, y quedaos admirados y asombrados, pues voy a realizar,en vuestros días una obra,que no creeríais,si alguno os la contara'."
,"42":"Y al salir les rogaron que continuaran hablando de lo mismo el próximo sábado."
,"43":"Cuando se disolvió la reunión, muchos judíos y prosélitos practicantes seguían a Pablo y a Bernabé, los cuales hablaban con ellos exhortándolos a ser fieles a la gracia de Dios."
,"44":"El sábado siguiente casi toda la ciudad acudió a escuchar la palabra de Dios."
,"45":"Los judíos, al ver tanta gente, se enfurecieron y se opusieron con blasfemias a lo que Pablo decía."
,"46":"Entonces Pablo y Bernabé dijeron con toda libertad: 'A vosotros había que anunciar antes que a nadie la palabra de Dios; pero ya que la rechazáis y no os juzgáis dignos de la vida eterna, nos vamos a los paganos."
,"47":"Así nos lo mandó el Señor: Te he puesto como luz de las naciones, para que lleves la salvación hasta el fin de la tierra'."
,"48":"Los paganos, al oírlo, se llenaron de alegría y aplaudieron la palabra del Señor; y todos los que estaban destinados a la vida eterna abrazaron la fe."
,"49":"La palabra del Señor se difundía por todo el país."
,"50":"Pero los judíos soliviantaron a las mujeres religiosas y nobles y a los principales de la ciudad, provocaron una persecución contra Pablo y Bernabé y los echaron de su territorio."
,"51":"Éstos sacudieron el polvo de sus pies contra ellos y se fueron a Iconio."
,"52":"Y los discípulos estaban llenos de gozo y del Espíritu Santo."
}`)
	CurrentBook.AddChapter(14, `{
"1":"En Iconio entraron también en la sinagoga de los judíos, y hablaron de tal modo que muchos judíos y paganos abrazaron la fe."
,"2":"Pero los judíos que no quisieron creer soliviantaron a los paganos y los indispusieron contra los hermanos."
,"3":"Allí se quedaron bastante tiempo, hablando con valentía del Señor, que confirmaba su doctrina de gracia realizando por su medio prodigios y milagros."
,"4":"La población de la ciudad se dividió. Unos estaban con los judíos y otros con los apóstoles."
,"5":"Los paganos y los judíos se confabularon a una con las autoridades para torturarlos y apedrearlos."
,"6":"Pero ellos se dieron cuenta y huyeron a las ciudades de Licaonia, Listra y Derbe y sus alrededores,"
,"7":"donde se pusieron a anunciar la buena nueva."
,"8":"En Listra había un hombre imposibilitado de los pies, sentado; cojo de nacimiento, jamás había andado."
,"9":"Oyó hablar a Pablo, el cual, mirándolo fijamente y viendo que tenía fe para ser curado,"
,"10":"dijo en alta voz: 'Levántate y tente derecho sobre tus pies'. Él dio un salto y echó a andar."
,"11":"La gente, al ver lo que había hecho Pablo, se puso a gritar en licaonio: 'Los dioses, en forma humana, han descendido a nosotros'."
,"12":"Y llamaban a Bernabé Júpiter y a Pablo Mercurio, porque era el más elocuente."
,"13":"El sacerdote de Júpiter, que estaba a la entrada de la ciudad, llevó toros adornados con guirnaldas ante las puertas, y, en unión de la muchedumbre, quería ofrecerles un sacrificio."
,"14":"Cuando se enteraron de ello los apóstoles Bernabé y Pablo, rasgaron sus vestidos y se lanzaron entre la gente gritando:"
,"15":"'Amigos, ¿por qué hacéis esto? Nosotros somos hombres como vosotros, que hemos venido a anunciaros que dejéis los dioses falsos y os convirtáis al Dios vivo, que ha hecho el cielo, la tierra, el mar y todo lo que hay en ellos."
,"16":"El cual ha permitido en las pasadas generaciones que todas las naciones siguiesen sus caminos;"
,"17":"sin embargo, no ha cesado jamás de dar testimonio de sí mismo haciendo el bien, mandándoos desde el cielo lluvias y estaciones fructíferas y saciándoos de comida y llenando vuestros corazones de felicidad'."
,"18":"Con estas palabras lograron a duras penas impedir que la gente les ofreciera un sacrificio."
,"19":"Llegaron de Antioquía e Iconio unos judíos que se ganaron a la gente. Apedrearon a Pablo y lo arrastraron fuera de la ciudad, dándolo por muerto."
,"20":"Pero cuando los discípulos se juntaron en torno a él, se levantó y entró en la ciudad. Al día siguiente marchó a Derbe en compañía de Bernabé."
,"21":"Después de haber evangelizado aquella ciudad y haber hecho un buen número de discípulos, se volvieron a Listra, Iconio y Antioquía,"
,"22":"animando a los discípulos, exhortándolos a permanecer en la fe y diciéndoles que tenemos que pasar por muchas tribulaciones para entrar en el reino de Dios."
,"23":"Instituyeron presbíteros en cada Iglesia, y, después de orar y ayunar, los encomendaron al Señor, en el que habían creído."
,"24":"Atravesaron Pisidia y llegaron a Panfilia;"
,"25":"predicaron en Perge y bajaron a Atalía."
,"26":"Allí se embarcaron para Antioquía, de donde habían partido y donde los habían encomendado a la gracia de Dios para la obra que acababan de cumplir."
,"27":"Cuando llegaron, reunieron a la Iglesia y contaron todo lo que había hecho Dios por medio de ellos, y cómo había abierto a los paganos la puerta de la fe."
,"28":"Y allí permanecieron largo tiempo con los discípulos."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Algunos que vinieron de Judea enseñaban a los hermanos: 'Si no os circuncidáis según el rito de Moisés, no podéis salvaros'."
,"2":"Después de un altercado y discusión no pequeña de Pablo y Bernabé contra ellos, se decidió que Pablo y Bernabé y algunos otros de entre ellos fueran a Jerusalén para tratar esta cuestión con los apóstoles y los presbíteros."
,"3":"Ellos, enviados por la Iglesia, atravesaron Fenicia y Samaría, narrando la conversión de los paganos y causando un gran gozo a todos los hermanos."
,"4":"Al llegar a Jerusalén, fueron acogidos por la Iglesia, los apóstoles y los presbíteros, y entonces contaron todo lo que Dios había hecho con ellos."
,"5":"Algunos de la secta de los fariseos que habían abrazado la fe se levantaron y dijeron que los paganos debían circuncidarse y guardar la ley de Moisés."
,"6":"Los apóstoles y los presbíteros se reunieron para estudiar el asunto."
,"7":"Tras una larga discusión, se levantó Pedro y les dijo: 'Hermanos, vosotros sabéis que hace mucho tiempo Dios me eligió entre vosotros para que los paganos oyesen de mis labios la palabra del evangelio y abrazaran la fe."
,"8":"Y Dios, conocedor de los corazones, dio testimonio en su favor, dándoles el Espíritu Santo, igual que a nosotros;"
,"9":"y no ha hecho diferencia alguna entre ellos y nosotros, purificando sus corazones con la fe."
,"10":"Ahora bien, ¿por qué tentáis a Dios imponiendo sobre el cuello de los discípulos un yugo que ni nuestros padres ni nosotros hemos podido soportar?"
,"11":"Nosotros creemos que nos salvamos por la gracia de Jesús, el Señor, igual que ellos'."
,"12":"Toda la asamblea guardó silencio para escuchar a Bernabé y a Pablo, que contaban todos los prodigios y milagros que había hecho Dios entre los paganos por medio de ellos."
,"13":"Cuando ellos terminaron, intervino Santiago: 'Hermanos, escuchadme."
,"14":"Simón ha contado cómo Dios dispuso desde el principio escoger de entre los paganos un pueblo consagrado a su nombre."
,"15":"Con esto están de acuerdo las palabras de los profetas, según está escrito:"
,"16":"Después de esto volveré,y restauraré la choza caída de David; repararé sus ruinas,y la volveré a levantar,"
,"17":"para que los demás hombres,busquen al Señor,y todas las naciones,que han sido consagradas,a mi nombre, dice el Señor, autor de estas cosas,"
,"18":"conocidas desde la eternidad."
,"19":"Por eso yo creo que no hay que inquietar a los paganos que se convierten a Dios,"
,"20":"sino escribirles que se abstengan de las contaminaciones de los ídolos, de la fornicación, de comer sangre o carne de animales ahogados."
,"21":"Pues en cada ciudad hay desde antiguo quienes leen y proclaman la ley de Moisés los sábados en la sinagoga'."
,"22":"Entonces los apóstoles y los presbíteros, con toda la Iglesia, decidieron elegir a algunos de entre ellos y enviarlos a Antioquía con Pablo y Bernabé. Eligieron a Judas Barsabás y a Silas, hombres eminentes entre los hermanos."
,"23":"Por medio de ellos les mandaron esta carta: 'Los apóstoles y los presbíteros, vuestros hermanos, a los hermanos de Antioquía, Siria y Cilicia procedentes del paganismo."
,"24":"Nos hemos enterado de que algunos de los nuestros, sin nuestro mandato, os han inquietado y alarmado con sus palabras."
,"25":"Hemos decidido de común acuerdo elegir unos delegados y enviarlos a vosotros, con nuestros queridos Bernabé y Pablo,"
,"26":"hombres que han entregado sus vidas por el nombre de nuestro Señor Jesucristo."
,"27":"Os enviamos a Judas y a Silas, que os dirán lo mismo de palabra."
,"28":"Porque el Espíritu Santo y nosotros hemos decidido no poneros ninguna carga más que estas imprescindibles:"
,"29":"abstenerse de la fornicación, de comer sangre y carne sacrificada a los ídolos o de animales ahogados. Haréis bien en guardaros de estas cosas. Adiós'."
,"30":"Los delegados fueron a Antioquía, reunieron a la gente y entregaron la carta."
,"31":"Al leerla, se llenaron de alegría por su contenido alentador."
,"32":"Judas y Silas, que eran también profetas, alentaron y confortaron a los hermanos en una larga conversación."
,"33":"Al cabo de cierto tiempo, los despidieron con saludos de paz para los hermanos que los habían delegado."
,"35":"Pablo y Bernabé se quedaron en Antioquía, enseñando y evangelizando la palabra del Señor en unión de otros muchos."
,"36":"Pasados unos días, Pablo dijo a Bernabé: 'Volvamos a visitar a los hermanos por todas las ciudades en que anunciamos la palabra del Señor, a ver cómo están'."
,"37":"Bernabé quería llevar también a Juan Marcos."
,"38":"Pablo, en cambio, juzgaba que no debían llevar al que los había dejado en Panfilia y no los había acompañado en la tarea."
,"39":"Discutieron entre ellos, y terminaron por separarse el uno del otro. Bernabé tomó consigo a Marcos, y se embarcó hacia Chipre;"
,"40":"Pablo escogió a Silas y partió, después de encomendarlo los hermanos a la gracia del Señor."
,"41":"Recorrió Siria y Cilicia, confirmando en la fe a las Iglesias."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Llegó a Derbe y luego a Listra, donde había un discípulo llamado Timoteo, hijo de una judía creyente y de padre griego."
,"2":"Los hermanos de Listra e Iconio hablaban muy bien de él."
,"3":"Pablo quiso llevárselo con él, y lo circuncidó en consideración a los judíos que había en aquellos lugares, pues todos sabían que su padre era griego."
,"4":"Según iban pasando por las ciudades, les comunicaban, para que los guardaran, los decretos dados por los apóstoles y los presbíteros de Jerusalén."
,"5":"Las Iglesias se reafirmaban en la fe y aumentaban en número de día en día."
,"6":"Atravesaron Frigia y la región de Galacia, pues el Espíritu Santo les impidió anunciar la palabra en Asia."
,"7":"Llegaron a Misia e intentaron entrar en Bitinia, pero el Espíritu de Jesús no se lo permitió."
,"8":"Cruzaron, pues, Misia, y bajaron a Tróade."
,"9":"Durante la noche Pablo tuvo una visión: un macedonio, puesto en pie, le suplicaba: 'Ven a Macedonia y ayúdanos'."
,"10":"Inmediatamente después de la visión intentamos pasar a Macedonia, persuadidos de que Dios nos había llamado para evangelizarlos."
,"11":"Zarpamos de Tróade y fuimos derechos a Samotracia; al día siguiente a Neápolis,"
,"12":"y de allí a Filipos, ciudad del primer distrito de Macedonia, colonia romana, en la que permanecimos algunos días."
,"13":"El sábado salimos fuera de la ciudad y fuimos por la orilla del río, donde pensábamos que estaba el lugar de oración. Nos sentamos y nos pusimos a hablar con las mujeres que se habían reunido."
,"14":"Una mujer llamada Lidia, vendedora de púrpura, de la ciudad de Tiatira, fiel a Dios, nos estaba escuchando. El Señor abrió su corazón para que aceptase las cosas que Pablo decía."
,"15":"Después de haber sido bautizada con toda su familia, nos suplicó: 'Si consideráis que soy fiel al Señor, venid y quedaos en mi casa'. Y nos obligó a ello."
,"16":"Otra vez, cuando íbamos al lugar de la oración, nos salió al encuentro una muchacha que tenía un espíritu adivinador, la cual con sus adivinaciones procuraba a sus amos muchas ganancias."
,"17":"Iba detrás de Pablo y de nosotros gritando: 'Estos hombres son siervos del Dios altísimo, y os anuncian el camino de la salvación'."
,"18":"Esto lo hizo muchos días, hasta que Pablo, ya cansado, se volvió y dijo al espíritu: 'En nombre de Jesucristo te mando salir de ella'. Y en el mismo instante salió."
,"19":"Sus amos, al ver que había desaparecido la esperanza de su ganancia, prendieron a Pablo y a Silas y los llevaron a la plaza pública ante las autoridades."
,"20":"Los presentaron a los pretores y dijeron: 'Estos hombres alborotan nuestra ciudad. Son judíos,"
,"21":"y predican costumbres que nosotros, siendo romanos, no podemos aceptar ni practicar'."
,"22":"La gente se sublevó contra ellos, y los pretores mandaron que los desnudaran y les dieran de palos."
,"23":"Después de haberles dado muchos palos, los metieron en la cárcel, encargando al carcelero que los tuviera bien seguros;"
,"24":"él, al recibir tal orden, los metió en la celda más segura, y sujetó sus pies en el cepo."
,"25":"Hacia la medianoche, Pablo y Silas estaban en oración cantando himnos a Dios, y los presos escuchaban."
,"26":"De repente se produjo tan gran terremoto que se conmovieron los cimientos de la cárcel; se abrieron todas las puertas de la cárcel y se soltaron las cadenas de todos."
,"27":"El carcelero se despertó y, al ver abiertas las puertas de la cárcel, creyendo que los presos se habrían fugado, desenvainó la espada para matarse."
,"28":"Pablo le gritó: 'No te hagas daño, que todos estamos aquí'."
,"29":"Él pidió una luz, entró y se echó temblando ante Saulo y Silas;"
,"30":"los sacó fuera y dijo: 'Señores, ¿qué debo hacer para salvarme?'."
,"31":"Ellos le dijeron: 'Cree en Jesús, el Señor, y te salvarás tú y tu familia'."
,"32":"Y le anunciaron la palabra del Señor a él y a todos los que había en su casa."
,"33":"A aquellas horas de la noche el carcelero les lavó las heridas, y seguidamente se bautizó él con todos los suyos."
,"34":"Los subió a su casa, puso la mesa y celebró con toda su familia el haber creído en Dios."
,"35":"Al llegar el día, los magistrados mandaron a los alguaciles a decir al carcelero: 'Pon en libertad a esos hombres'."
,"36":"El carcelero dijo a Pablo: 'Los magistrados han ordenado que seáis libertados. Salid, pues, y marchad en paz'."
,"37":"Pablo les dijo: 'Nos han apaleado públicamente y, sin juzgarnos, a pesar de ser ciudadanos romanos, nos han metido en la cárcel, y ¿ahora quieren sacarnos?"
,"38":"Pues no; que vengan ellos a sacarnos'. Los alguaciles llevaron la respuesta a los magistrados, los cuales, al oír que eran romanos, tuvieron miedo."
,"39":"Fueron y les pidieron excusas; los sacaron y les suplicaron que se fueran de la ciudad."
,"40":"Salieron de la cárcel y fueron a casa de Lidia; vieron a los hermanos, los animaron y se fueron."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Pasaron por Anfípolis y Apolonia, donde los judíos tenían una sinagoga."
,"2":"Pablo, según su costumbre, se presentó allí, y durante tres sábados discutió con ellos sobre las Escrituras,"
,"3":"explicando y probando que el mesías debía padecer y resucitar de entre los muertos; y 'el mesías, decía, es el Jesús que yo os anuncio'."
,"4":"Algunos de ellos se convencieron y se unieron a Pablo y Silas, así como muchos prosélitos griegos y buen número de mujeres nobles."
,"5":"Los judíos, llevados por la envidia, echaron mano de unos gamberros, que provocaron tumultos y alborotaron la ciudad. Se presentaron ante la casa de Jasón para llevarlos ante la plebe;"
,"6":"al no encontrarlos, arrastraron a Jasón y algunos hermanos ante los magistrados, gritando: 'Éstos, que han revolucionado el mundo entero, se han presentado también aquí,"
,"7":"y Jasón los ha hospedado. Todos éstos actúan contra los decretos del césar, diciendo que hay otro rey, Jesús'."
,"8":"La plebe y los magistrados, al oír esto, se alarmaron; y"
,"9":"exigieron una fianza a Jasón y a los restantes para ponerlos en libertad."
,"10":"Al llegar la noche, los hermanos hicieron partir en seguida a Pablo y a Silas hacia Berea. Así que llegaron, fueron a la sinagoga de los judíos."
,"11":"Los judíos de Berea eran más abiertos que los de Tesalónica, y recibieron la palabra con buena disposición, estudiando diariamente las Escrituras para ver si todo era así."
,"12":"Muchos judíos abrazaron la fe, así como gran número de paganos, mujeres distinguidas y hombres."
,"13":"Cuando los judíos de Tesalónica supieron que Pablo anunciaba también en Berea la palabra de Dios, fueron allá para agitar y alborotar a la plebe."
,"14":"Entonces los hermanos hicieron partir a Pablo hacia el mar, y Silas y Timoteo se quedaron allí."
,"15":"Los que acompañaban a Pablo lo llevaron hasta Atenas, y se volvieron en seguida con el encargo para Silas y Timoteo de que se unieran con él lo más pronto posible."
,"16":"Mientras Pablo los esperaba en Atenas, se llenaba de indignación al contemplar la ciudad llena de ídolos."
,"17":"Discutía en la sinagoga con los judíos y con los prosélitos, y diariamente en la plaza con los que se encontraba."
,"18":"Algunos filósofos epicúreos y estoicos conversaban con él; unos decían: '¿Qué querrá decir ese charlatán?'. Y otros: 'Parece ser un predicador de divinidades extranjeras' (porque anunciaba a Jesús y la resurrección)."
,"19":"Lo llevaron al Areópago, y le preguntaron: '¿Podemos saber qué doctrina nueva enseñas?"
,"20":"Nos tienes cansados los oídos con cosas extrañas, y queremos saber de qué se trata'."
,"21":"Todos los atenienses y los extranjeros residentes sólo se entretenían en decir o en oír novedades."
,"22":"Pablo, puesto en pie en medio del Areópago, dijo: 'Atenienses, por todo veo que sois muy religiosos."
,"23":"Al recorrer vuestra ciudad y contemplar vuestros monumentos sagrados, me he encontrado incluso un altar con esta inscripción: 'Al Dios desconocido'. Pues bien, lo que veneráis sin conocerlo, eso es lo que yo os vengo a anunciar."
,"24":"El Dios que ha hecho el mundo y todo l que hay en él, siendo señor del cielo y de la tierra, no habita en templos construidos por la mano del hombre."
,"25":"Ni es servido por manos humanas, como si necesitase algo él, que da a todos la vida, el aliento y todas las cosas;"
,"26":"de un solo hombre ha hecho todo el género humano para que habite sobre toda la superficie de la tierra, determinando los tiempos y los límites de su morada,"
,"27":"para que buscasen a Dios, y a ver si buscando a tientas lo podían encontrar; aunque no está lejos de cada uno de nosotros,"
,"28":"ya que en él vivimos, nos movemos y existimos, como alguno de vuestros poetas ha dicho también: 'Porque somos de su linaje'."
,"29":"Pues si nosotros somos linaje de Dios, no debemos pensar que la divinidad es semejante a oro o plata o piedra, escultura hecha por el arte y el ingenio del hombre."
,"30":"Dios, pasando por alto los tiempos de la ignorancia, hace saber ahora a los hombres que todos, en todas partes, se arrepientan,"
,"31":"puesto que ha establecido un día en el que ha de juzgar al universo con justicia por medio de un hombre, a quien ha designado y acreditado ante todos al resucitarlo de entre los muertos'."
,"32":"Al oír hablar de la resurrección de los muertos, unos se burlaban y otros dijeron: 'Te oiremos sobre esto otra vez'."
,"33":"Así Pablo se separó de ellos."
,"34":"Algunos, sin embargo, se unieron a él y creyeron; entre ellos se encontraba Dionisio Areopagita, una mujer llamada Dámaris y algunos otros."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Después de esto, Pablo salió de Atenas y fue a Corinto."
,"2":"Allí encontró a un judío llamado Áquila, oriundo del Ponto, que acababa de llegar de Italia con su mujer, Priscila, por haber decretado Claudio que salieran de Roma todos los judíos."
,"3":"Pablo se relacionó con ellos; y como eran del mismo oficio, se quedó trabajando en su casa; se dedicaban a fabricar tiendas de campaña."
,"4":"Todos los sábados discutía en la sinagoga, intentando convencer a judíos y a griegos."
,"5":"Cuando Silas y Timoteo llegaron de Macedonia, Pablo se entregó por completo a la predicación de la palabra, proclamando ante los judíos que Jesús era el mesías."
,"6":"Como ellos le llevaban la contraria y lo insultaban, se sacudió la ropa y dijo: 'Que vuestra sangre caiga sobre vuestras cabezas; yo soy inocente; desde ahora me iré con los paganos'."
,"7":"Partió de allí, y fue a casa de un prosélito, que vivía junto a la sinagoga."
,"8":"Crispo, el jefe de la sinagoga, creyó en el Señor con toda su familia; y muchos de los corintios que habían oído a Pablo creyeron y se bautizaron."
,"9":"Una noche el Señor dijo en visión a Pablo: 'No tengas miedo, habla y no calles,"
,"10":"porque yo estoy contigo, y nadie intentará hacerte mal, pues tengo en esta ciudad un pueblo numeroso'."
,"11":"Y se detuvo allí un año y medio, enseñando entre ellos la palabra de Dios."
,"12":"Siendo Galión procónsul de Acaya, los judíos se sublevaron a una contra Pablo y lo llevaron ante el tribunal"
,"13":"con esta acusación: 'Éste incita a los hombres a que den culto a Dios en contra de la ley'."
,"14":"Pablo iba a hablar, cuando Galión dijo a los judíos: 'Si se tratase de un crimen o de un delito grave, yo os escucharía pacientemente, como es de justicia;"
,"15":"pero si es cuestión de palabras y nombres y cosas de vuestra ley, allá vosotros; yo no quiero ser juez de estos asuntos'."
,"16":"Y los echó del tribunal."
,"17":"Entonces se apoderaron de Sóstenes, el jefe de la sinagoga, y lo golpearon delante del tribunal, sin que nada de esto le importara a Galión."
,"18":"Pablo permaneció aún cierto tiempo en Corinto; después se despidió de los hermanos y se embarcó hacia Siria. Lo acompañaban Priscila y Áquila. En Cencreas se había rapado la cabeza porque había hecho un voto."
,"19":"Llegaron a Éfeso, donde se separó de ellos. Fue a la sinagoga y estuvo discutiendo con los judíos."
,"20":"Ellos le pidieron que se quedase más tiempo; pero no accedió;"
,"21":"y se despidió con estas palabras: 'Volveré de nuevo, si Dios quiere'."
,"22":"Zarpó de Éfeso, desembarcó en Cesarea, fue a saludar a la Iglesia y bajó a Antioquía."
,"23":"Allí estuvo algún tiempo y recorrió nuevamente la región de Galacia y Frigia, alentando a todos los discípulos."
,"24":"Un judío llamado Apolo, oriundo de Alejandría, hombre elocuente, muy versado en las Escrituras, llegó a Éfeso."
,"25":"Había sido instruido en el camino del Señor. Lleno de entusiasmo, hablaba y enseñaba con bastante exactitud lo referente a Jesús, aunque sólo conocía el bautismo de Juan."
,"26":"Él se puso a hablar con toda libertad en la sinagoga. Mas cuando lo oyeron Priscila y Áquila, lo llevaron aparte y le expusieron con mayor exactitud el camino de Dios."
,"27":"Como quería ir a Acaya, los hermanos lo animaron y escribieron a los discípulos para que le hicieran una buena acogida. Una vez allí, con la gracia de Dios, ayudó mucho a los creyentes."
,"28":"Con argumentos sólidos refutaba en público a los judíos, demostrando por las Escrituras que Jesús era el mesías."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Mientras Apolo estaba en Corinto, Pablo, después de haber recorrido las regiones montañosas, llegó a Éfeso, encontró algunos discípulos"
,"2":"y les preguntó: '¿Habéis recibido el Espíritu Santo al abrazar la fe?'. Ellos contestaron: 'Ni siquiera hemos oído decir que haya Espíritu Santo'."
,"3":"Él les preguntó: '¿Pues qué bautismo habéis recibido?'. Ellos contestaron: 'El bautismo de Juan'."
,"4":"Pablo dijo: 'Juan bautizó con bautismo de conversión, diciendo al pueblo que creyese en el que había de venir después de él, es decir, en Jesús'."
,"5":"Al oírlo, se bautizaron en el nombre de Jesús, el Señor."
,"6":"Cuando Pablo les impuso las manos, descendió sobre ellos el Espíritu Santo y se pusieron a hablar en lenguas extrañas y a profetizar."
,"7":"Eran en total unas doce personas."
,"8":"Pablo entró después en la sinagoga, donde habló con absoluta libertad durante tres meses, discutiendo y esforzándose por convencerlos acerca del reino de Dios."
,"9":"Pero como algunos se obstinaban en no creer y desacreditaban el camino del Señor ante la gente, se apartó de ellos, hizo un grupo aparte con los discípulos y se puso a enseñar diariamente en la escuela de Tirano."
,"10":"Esto duró dos años, de manera que todos los habitantes de Asia, tanto judíos como paganos, oyeron la palabra de Dios."
,"11":"Dios hacía milagros extraordinarios por medio de Pablo,"
,"12":"hasta el punto de que, con sólo aplicar a los enfermos los pañuelos o cualquier otra prenda de Pablo, se curaban y salían los espíritus malignos."
,"13":"Algunos exorcistas judíos ambulantes intentaron también invocar el nombre de Jesús, el Señor, sobre los que estaban poseídos por espíritus malignos, diciendo: 'Os conjuro por Jesús, a quien Pablo predica'."
,"14":"Hacían esto los siete hijos de Esceva, sumo sacerdote judío."
,"15":"Pero el espíritu maligno les respondió: 'Conozco a Jesús y sé quién es Pablo; pero vosotros, ¿quiénes sois?'."
,"16":"El hombre poseído del espíritu maligno saltó sobre ellos, se apoderó de los dos y los maltrató, de modo que escaparon de aquella casa desnudos y heridos."
,"17":"Esto se divulgó entre todos los habitantes de Éfeso, judíos y griegos; un gran temor se apoderó de todos ellos y se ensalzaba el nombre de Jesús, el Señor."
,"18":"Muchos creyentes venían a confesar y a manifestar sus prácticas de magia."
,"19":"Y bastantes de los que habían practicado artes mágicas llevaron sus libros y los quemaron en presencia de todos; su valor fue calculado en cincuenta mil monedas de plata."
,"20":"Así crecía poderosamente y se consolidaba la palabra del Señor."
,"21":"Después de esos sucesos, Pablo se propuso atravesar Macedonia y Acaya e ir a Jerusalén. Se decía: 'Debo visitar también Roma'."
,"22":"Mandó a Macedonia a dos de sus colaboradores, Timoteo y Erasto, y él se detuvo algún tiempo en Asia."
,"23":"Por entonces se produjo un gran motín a propósito del nuevo camino del Señor."
,"24":"Un platero llamado Demetrio, que hacía en plata templos de Diana, proporcionaba a los artífices grandes ganancias;"
,"25":"reunió a todos los que tenían el mismo oficio y les dijo: 'Amigos, sabéis que nuestro bienestar depende de esta industria;"
,"26":"veis y oís que no sólo en Éfeso, sino en casi toda Asia, ese Pablo ha apartado y persuadido a mucha gente, diciendo que no son dioses los que han sido hechos con las manos de los hombres."
,"27":"No sólo hay peligro de que nuestra industria se desacredite, sino también de que sea tenido en nada el templo de la gran Diana y de que sea despojada de la majestad aquella a quien venera toda Asia y el orbe entero'."
,"28":"Al oír esto se llenaron de ira, y se pusieron a gritar: 'Grande es la Diana de los efesios'."
,"29":"El desorden cundió por toda la ciudad y se lanzaron a una hacia el teatro, arrastrando consigo a Gayo y a Aristarco, macedonios, compañeros de Pablo."
,"30":"Pablo quería presentarse ante el pueblo, pero los discípulos no lo dejaron."
,"31":"Algunas autoridades de Asia, amigos suyos, le mandaron también recado, rogándole que no se presentase en el teatro."
,"32":"Cada uno gritaba una cosa, de modo que la asamblea estaba alborotada y la mayor parte no sabía por qué se habían reunido."
,"33":"Algunos judíos empujaron a Alejandro para que hablara a la gente, y Alejandro hizo señal con la mano de que quería hablar al pueblo."
,"34":"Pero cuando se dieron cuenta de que era judío, todos a una gritaron por espacio de casi dos horas: '¡Grande es la Diana de los efesios!'."
,"35":"El letrado logró calmar a la multitud y dijo: 'Efesios, ¿quién puede ignorar que la ciudad de los efesios es la guardiana de la gran Diana y de su estatua caída del cielo?"
,"36":"Siendo todo esto incontestable, conviene que os mantengáis serenos y no hagáis nada con precipitación."
,"37":"Porque habéis traído a estos hombres, que no son ni sacrílegos ni blasfemadores de vuestra Diana."
,"38":"Si Demetrio y los artífices que están con él tienen algo contra alguno, para eso hay tribunales y procónsules: que apelen las dos partes a los tribunales."
,"39":"Y si solicitáis algo más, será resuelto en la asamblea legal."
,"40":"Porque corremos peligro de ser acusados de rebelión por todo lo que ha sucedido hoy, no habiendo ningún motivo que pueda justificar este alboroto'. Dicho esto, se disolvió la asamblea."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Después que cesó el alboroto, Pablo llamó a los discípulos, les dio ánimo, se despidió de ellos y partió para Macedonia."
,"2":"Recorrió aquellas regiones exhortando a los discípulos en largas conversaciones. Por fin llegó a Grecia,"
,"3":"donde pasó tres meses. Cuando iba a embarcarse para Siria, se enteró de que los judíos habían preparado un atentado contra él, por lo que determinó volver por Macedonia."
,"4":"Le acompañaban Sópatros, hijo de Pirro, de Berea; Aristarco y Segundo, de Tesalónica; Gayo, de Derbe, y Timoteo; y los asiáticos Tíquico y Trófimo."
,"5":"Éstos se adelantaron y nos esperaron en Tróade."
,"6":"Nosotros nos embarcamos en Filipos después de la pascua, y a los cinco días los alcanzamos en Tróade, donde nos detuvimos siete días."
,"7":"El primer día de la semana nos reunimos para partir el pan. Pablo, que iba a partir al día siguiente, estuvo hablando con ellos hasta medianoche."
,"8":"En la sala de arriba, donde estábamos reunidos, había muchas lámparas."
,"9":"Un joven, llamado Eutico, estaba sentado en la ventana. Como Pablo se alargaba demasiado en su conversación, le entró un sueño tan profundo que, vencido por él, se cayó desde el tercer piso abajo, y lo levantaron ya cadáver."
,"10":"Pablo bajó, se echó sobre él y, abrazándolo, dijo: 'Tranquilos, que está vivo'."
,"11":"Subió de nuevo, partió el pan y comió, estuvo hablando hasta el alba y se marchó."
,"12":"Al muchacho lo trajeron vivo, con gran consuelo para todos."
,"13":"Nosotros zarpamos con tiempo suficiente rumbo a Aso, donde teníamos que recoger a Pablo, pues él había decidido hacer el viaje por tierra."
,"14":"Así que llegó a Aso, lo recogimos y fuimos a Mitilene."
,"15":"Seguimos navegando, y al día siguiente nos encontramos frente a Quío; al otro día atracamos en Samos; al siguiente llegamos a Mileto."
,"16":"Pablo había resuelto pasar de largo por Éfeso para no perder tiempo en Asia, pues tenía prisa por encontrarse en Jerusalén el día de pentecostés, si era posible."
,"17":"Desde Mileto mandó a Éfeso a llamar a los presbíteros de la Iglesia."
,"18":"Cuando llegaron, les dijo: 'Vosotros sabéis cómo me he portado con vosotros todo el tiempo desde el primer día que entré en Asia,"
,"19":"sirviendo al Señor con toda humildad y con lágrimas, en medio de las pruebas que me han sobrevenido por las asechanzas de los judíos."
,"20":"Jamás dejé de anunciaros y enseñaros en público y por las casas todo cuanto os pudiera ser útil,"
,"21":"instando a judíos y griegos a convertirse a Dios y a la fe en Jesús nuestro Señor."
,"22":"Y ahora voy a Jerusalén empujado por el Espíritu, sin saber lo que allí me va a suceder;"
,"23":"únicamente sé que el Espíritu Santo me asegura en todas las ciudades que me esperan prisiones y tribulaciones."
,"24":"Pero a mí no me preocupa mi vida ni la juzgo estimable, con tal de acabar mi carrera y cumplir el ministerio que he recibido de Jesús, el Señor, de anunciar la buena nueva, la gracia de Dios."
,"25":"Yo sé que todos vosotros, entre los que he pasado predicando el reino, no me volveréis a ver."
,"26":"Por lo cual os declaro en el día de hoy que tengo la conciencia limpia respecto a todos vosotros,"
,"27":"porque jamás dejé de anunciaros todo el plan de Dios."
,"28":"Cuidad de vosotros y de todo el rebaño del que el Espíritu Santo os ha constituido como guardianes para apacentar la Iglesia de Dios, que ha adquirido con su propia sangre."
,"29":"Yo sé que después de mi partida se introducirán entre vosotros lobos crueles, que no perdonarán al rebaño;"
,"30":"y que de entre vosotros mismos surgirán hombres que enseñarán doctrinas perversas con el fin de arrastrar a los discípulos en pos de sí."
,"31":"Por lo cual, estad alerta y recordad que durante tres años no he cesado noche y día de aconsejar con lágrimas en los ojos a cada uno de vosotros."
,"32":"Y ahora os encomiendo a Dios y a su mensaje de amor, que tiene poder para construir el edificio y dar la herencia a todos los consagrados."
,"33":"De nadie he deseado plata, oro o vestidos."
,"34":"Vosotros mismos sabéis que estas manos han provisto a mis necesidades y a las de los que andan conmigo."
,"35":"En todo os he mostrado que se debe trabajar así para socorrer a los necesitados, recordando las palabras de Jesús, el Señor: 'Hay más felicidad en dar que en recibir'."
,"36":"Cuando terminó de hablar, se puso de rodillas y oró con todos ellos."
,"37":"Todos rompieron a llorar, se echaron al cuello de Pablo y lo besaron,"
,"38":"afligidos sobre todo porque les había dicho que no volverían a verlo. Y le acompañaron hasta el barco."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Nos separamos de ellos, nos embarcamos y fuimos derechos a Cos, y al día siguiente a Rodas, y de allí a Pátara."
,"2":"Allí encontramos un barco que iba a Fenicia; subimos a él y partimos."
,"3":"Al dar vista a Chipre, que dejamos a babor, navegamos hacia Siria y desembarcamos en Tiro, porque el barco tenía que dejar allí la carga."
,"4":"Encontramos a los discípulos y estuvimos con ellos una semana. Ellos, movidos por el Espíritu, decían a Pablo que no fuera a Jerusalén."
,"5":"Pero, al pasar la semana, partimos. Nos acompañaron todos, con sus mujeres y niños, hasta fuera de la ciudad. Nos pusimos de rodillas en la playa, oramos,"
,"6":"nos despedimos mutuamente y subimos al barco; ellos se volvieron a sus casas."
,"7":"Nosotros, al terminar la navegación, fuimos de Tiro a Tolemaida, donde saludamos a los hermanos y nos quedamos un día con ellos."
,"8":"Al día siguiente partimos y llegamos a Cesarea. Fuimos a ver a Felipe, el evangelista, uno de los siete, y nos quedamos con él."
,"9":"Éste tenía cuatro hijas solteras con el don de profecía."
,"10":"Al cabo de varios días de estar allí, llegó de Judea un profeta llamado Agabo,"
,"11":"el cual fue a nuestro encuentro, tomó el cinto de Pablo, se ató los pies y las manos, y dijo: 'Esto dice el Espíritu Santo: Así atarán en Jerusalén los judíos al hombre de quien es este cinto y lo entregarán en manos de los paganos'."
,"12":"Cuando oímos esto, le suplicamos, tanto nosotros como los de aquel lugar, que no fuera a Jerusalén."
,"13":"Pablo respondió: '¿Qué hacéis llorando y partiéndome el corazón? Yo estoy dispuesto no sólo a ser atado, sino también a morir en Jerusalén por el nombre de Jesús, el Señor'."
,"14":"Y como no había manera de convencerlo, desistimos, diciendo: 'Hágase la voluntad del Señor'."
,"15":"Después de unos días, preparamos nuestro equipaje y nos fuimos a Jerusalén."
,"16":"Fueron también con nosotros algunos discípulos de Cesarea, y nos llevaron a casa de un tal Nasón, chipriota, antiguo discípulo, donde debíamos hospedarnos."
,"17":"Cuando llegamos a Jerusalén, los hermanos nos recibieron con grande alegría."
,"18":"Al día siguiente Pablo fue con nosotros a casa de Santiago, donde se reunieron todos los presbíteros."
,"19":"Después de saludarlos, contó una por una las cosas que había hecho Dios entre los paganos por su ministerio."
,"20":"Ellos, al oír todo esto, alabaron a Dios, y dijeron a Pablo: 'Ves, hermano, cuántos millares de judíos han creído, y todos siguen siendo fieles observantes de la ley."
,"21":"Pero han oído decir de ti que induces a los judíos que viven entre paganos a que dejen la ley de Moisés, que no circunciden a sus hijos y que no sigan las tradiciones."
,"22":"¿Qué hacemos? Seguro que se enterarán de que has llegado."
,"23":"Haz lo que te vamos a decir. Hay entre nosotros cuatro hombres que han hecho un voto;"
,"24":"tómalos, purifícate con ellos y paga por ellos para que se rasuren la cabeza. Así sabrán todos que no es verdad nada de lo que han oído decir de ti, sino que tú también sigues guardando la ley."
,"25":"Por lo que respecta a los paganos que han abrazado la fe, les hemos mandado a decir que se debían abstener de la fornicación, de comer sangre y carne sacrificada a los ídolos o de animales ahogados'."
,"26":"Al día siguiente Pablo tomó consigo a los hombres, se purificó con ellos y entró en el templo para fijar la fecha en la que terminaban los días de la purificación y en la que sería presentada la ofrenda por cada uno de ellos."
,"27":"Cuando iban ya a cumplirse los siete días, los judíos de Asia, al verlo en el templo, alborotaron a la gente y le echaron mano,"
,"28":"gritando: 'Israelitas, ayudadnos: éste es el hombre que va enseñando por todas partes y a todos contra el pueblo, contra la ley, contra este lugar; más aún, ha metido a los griegos en el templo, profanando este lugar santo'."
,"29":"Y es que habían visto antes a Trófimo de Éfeso con él en la ciudad, y pensaron que Pablo lo había metido en el templo."
,"30":"Toda la ciudad se alborotó y la gente acudió en masa. Prendieron a Pablo, lo arrastraron fuera del templo y cerraron rápidamente las puertas."
,"31":"Mientras intentaban matarlo, se avisó al comandante de la guarnición de que toda Jerusalén estaba alborotada;"
,"32":"sin perder un instante, fue corriendo con soldados y oficiales. Ellos, al ver al comandante y a los soldados, dejaron de sacudir a Pablo."
,"33":"El comandante llegó, agarró a Pablo y mandó sujetarlo con cadenas; luego preguntó quién era y qué había hecho."
,"34":"En aquella masa de gente cada uno gritaba una cosa; y no logrando saber nada cierto por aquel alboroto, mandó que lo llevasen a la fortaleza."
,"35":"Cuando llegaron a las escaleras, los soldados tuvieron que llevar en volandas a Pablo, debido a la violencia de la gente."
,"36":"Porque todo el pueblo venía detrás, gritando: '¡Mátalo!'."
,"37":"Cuando estaban para meterlo en la fortaleza, Pablo dijo al comandante: '¿Puedo decirte una cosa?'. Y él dijo: '¿Sabes griego?"
,"38":"¿Es que no eres tú el egipcio que hace unos días amotinó a cuatro mil guerrilleros y se fue al desierto con ellos?'."
,"39":"Pablo dijo: 'Yo soy judío, ciudadano de Tarso, una ciudad no desconocida de Cilicia. Te ruego que me permitas hablar al pueblo'."
,"40":"El comandante se lo permitió. Pablo, puesto en pie sobre las escaleras, hizo ademán al pueblo con la mano, y se hizo un gran silencio. Entonces habló en lengua hebrea:"
}`)
	CurrentBook.AddChapter(22, `{
"1":"'Hermanos y padres, escuchad ahora mi defensa ante vosotros'."
,"2":"Cuando oyeron que les hablaba en lengua hebrea, el silencio se hizo más profundo."
,"3":"Él siguió: 'Yo soy judío, nacido en Tarso de Cilicia, pero educado aquí, en esta ciudad, a los pies de Gamaliel, instruido en la fiel observancia de la ley de nuestros padres, partidario entusiasta de la causa de Dios, como todos vosotros los sois en este día;"
,"4":"yo he perseguido a muerte este nuevo camino, encadenando y metiendo en la cárcel a hombres y a mujeres,"
,"5":"como me es testigo el sumo sacerdote y el colegio de los ancianos; ellos me dieron cartas para los hermanos de Damasco y fui allá con el fin de traer presos a Jerusalén a los creyentes que encontrara para que fueran castigados."
,"6":"Pero sucedió que cerca ya de Damasco, hacia mediodía, de repente me envolvió un gran resplandor del cielo."
,"7":"Caí a tierra, y oí una voz que me decía: Saulo, Saulo, ¿por qué me persigues?"
,"8":"Yo pregunté: ¿Quién eres, Señor? Y me dijo: Yo soy Jesús de Nazaret, a quien tú persigues."
,"9":"Los que estaban conmigo vieron la luz, pero no oyeron la voz del que me hablaba."
,"10":"Yo dije: ¿Qué tengo que hacer, Señor? Y el Señor me dijo: Levántate y entra en Damasco; allí te dirán lo que debes hacer."
,"11":"Como no veía nada debido a aquel gran resplandor, entré en Damasco llevado de la mano de mis compañeros de viaje."
,"12":"Un tal Ananías, fiel cumplidor de la ley, estimado por todos los judíos de la ciudad,"
,"13":"se me presentó y me dijo: Hermano Saulo, recobra la vista. Y en el mismo instante la recobré y lo vi."
,"14":"Él dijo: El Dios de nuestros padres te ha destinado a conocer su voluntad, a ver al Justo y a oír su voz,"
,"15":"porque serás su testigo ante todos los hombres de lo que has visto y oído."
,"16":"Y ahora, ¿qué esperas? Levántate, bautízate y lava tus pecados invocando su nombre."
,"17":"Cuando volví a Jerusalén, estando yo orando en el templo, fui arrebatado en éxtasis"
,"18":"y vi al Señor, que me decía: Date prisa y sal pronto de Jerusalén, porque no recibirán tu testimonio acerca de mí."
,"19":"Yo le dije: Señor, ellos saben que yo iba por las sinagogas para meter en la cárcel y torturar a los que creían en ti."
,"20":"Cuando se derramó la sangre de Esteban, tu testigo, yo mismo estaba allí, consintiendo y guardando las ropas de los que lo mataban."
,"21":"Y me dijo: Ponte en camino, que te voy a enviar a pueblos más lejanos'."
,"22":"Hasta aquí lo estuvieron escuchando, pero entonces se pusieron a gritar: 'Quita del mundo a este hombre, porque no merece vivir'."
,"23":"Como ellos continuaban gritando, agitaban los mantos y tiraban polvo al aire,"
,"24":"el comandante mandó meterlo en la fortaleza, con orden de que lo azotaran a ver si confesaba y lograba saber por qué gritaban así contra él."
,"25":"Pero cuando le iban a sujetar con correas, Pablo dijo al oficial allí presente: '¿Está permitido azotar a un ciudadano romano sin haberlo juzgado antes?'."
,"26":"Al oír esto, el oficial salió a comunicárselo al comandante: '¿Qué vas a hacer? Este hombre es romano'."
,"27":"El comandante fue y le dijo: 'Dime, ¿eres romano?'. Pablo contestó: 'Sí'."
,"28":"El comandante dijo: 'Yo he conseguido este derecho de ciudadanía mediante una importante suma'. Pablo replicó: 'Pues yo lo tengo de nacimiento'."
,"29":"Al instante los que iban a torturarlo para hacerlo hablar se fueron. Y el comandante tuvo miedo, al darse cuenta de que era romano y que lo había encadenado."
,"30":"Al día siguiente, queriendo saber con certeza de qué lo acusaban los judíos, lo desató y mandó que se reunieran los sumos sacerdotes y el tribunal supremo. Después bajó a Pablo y lo hizo comparecer ante ellos."
}`)
	CurrentBook.AddChapter(23, `{
"1":"Pablo, mirando fijamente al tribunal, dijo: 'Hermanos, yo me he comportado con buena conciencia ante Dios hasta el día de hoy'."
,"2":"El sumo sacerdote Ananías mandó a los que estaban junto a él que le dieran un puñetazo en la boca."
,"3":"Pablo le dijo: 'Dios te golpeará a ti, pared blanqueada. Tú estás sentado para juzgarme según la ley, ¿y violando la ley mandas golpearme?'."
,"4":"Los presentes dijeron: '¡Tú insultas al sumo sacerdote de Dios!'."
,"5":"Pablo dijo: 'No sabía, hermanos, que fuera el sumo sacerdote, pues está escrito: No insultarás al jefe de tu pueblo'."
,"6":"Pablo, sabiendo que una parte del tribunal eran saduceos y otra fariseos, gritó así: 'Hermanos, yo soy fariseo, hijo de fariseos; soy juzgado por la esperanza en la resurrección de los muertos'."
,"7":"Al decir esto, surgió una discusión entre los fariseos y los saduceos, y se dividió la asamblea."
,"8":"Porque los saduceos dicen que no hay resurrección, ni ángeles, ni espíritus, mientras que los fariseos admiten una y otra cosa."
,"9":"Se produjo un gran alboroto. Algunos maestros de la ley de la parte de los fariseos se levantaron y afirmaron enérgicamente: 'Nosotros no encontramos nada malo en este hombre. ¿Y si le ha hablado un espíritu o un ángel?'."
,"10":"Como la discordia crecía cada vez más, el comandante, temiendo que despedazaran a Pablo, ordenó que bajara la tropa, que lo sacaran de allí y que lo llevaran a la fortaleza."
,"11":"A la noche siguiente se le apareció el Señor y le dijo: 'Ten ánimo, pues como has dado testimonio en Jerusalén acerca de mí, así conviene también que lo des en Roma'."
,"12":"Cuando se hizo de día, los judíos convocaron una reunión, en la que se comprometieron bajo juramento a no comer ni beber hasta que matasen a Pablo."
,"13":"Eran más de cuarenta los que hicieron tal conjuración."
,"14":"Se presentaron a los sumos sacerdotes y a los ancianos, y dijeron: 'Nos hemos comprometido bajo juramento a no comer nada hasta matar a Pablo."
,"15":"Ahora vosotros y el tribunal supremo tenéis que pedir al comandante que lo haga comparecer en vuestra presencia con el pretexto de examinar más a fondo su causa; nosotros estamos preparados para matarlo antes que llegue'."
,"16":"Pero el hijo de la hermana de Pablo, que tuvo conocimiento de la conjuración, se presentó, entró en la fortaleza y avisó a Pablo."
,"17":"Pablo llamó a uno de los oficiales y le dijo: 'Lleva a este joven ante el comandante, porque tiene algo que comunicarle'."
,"18":"Él lo levó al comandante, al cual dijo: 'El preso Pablo me ha llamado y me ha suplicado que te traiga a este joven, que tiene algo que decirte'."
,"19":"El comandante lo agarró de la mano, se lo llevó aparte y le preguntó: '¿Qué es lo que tienes que decirme?'."
,"20":"Contestó: 'Que los judíos han acordado pedirte que hagas bajar mañana a Pablo al tribunal con el pretexto de examinar más a fondo su caso."
,"21":"Tú no lo creas, porque más de cuarenta hombres de entre ellos le van a tender una emboscada, y se han comprometido bajo juramento a no comer ni beber hasta que lo hayan matado; y ahora están preparados, esperando tan sólo tu respuesta'."
,"22":"El comandante despidió al muchacho y le ordenó que no dijera a nadie que le había dicho aquello."
,"23":"Después llamó a dos oficiales y les dijo: 'A las nueve de la noche hay que salir para Cesarea. Preparad doscientos soldados de infantería, setenta de caballería y doscientos lanceros'."
,"24":"Disponed también cabalgaduras para montar a Pablo y llevarlo sano y salvo al gobernador Félix."
,"25":"Y escribió una carta en estos términos:"
,"26":"'Claudio Lisias al excelentísimo gobernador Félix, salud."
,"27":"Los judíos se han apoderado de este hombre, y ya estaban para matarlo, cuando intervine yo con los soldados y lo libré, al saber que era ciudadano romano."
,"28":"Queriendo conocer la causa por la que lo acusaban, lo conduje a su tribunal supremo;"
,"29":"he encontrado que lo acusaban por cuestiones de su ley y que no había cometido delito que merezca la muerte o la prisión."
,"30":"Pero informado de que se armaba una conjuración contra este hombre, inmediatamente lo he enviado a ti, notificando a los acusadores que digan ante ti lo que tengan contra él. Salud'."
,"31":"Los soldados, según las órdenes recibidas, tomaron a Pablo y lo llevaron durante la noche a Antípatris;"
,"32":"y al día siguiente se volvieron a la fortaleza, dejando que fuesen con él los de caballería,"
,"33":"los cuales, al llegar a Cesarea, entregaron la carta al procurador y le presentaron también a Pablo."
,"34":"Él leyó la carta, y preguntó a Pablo de qué provincia era; informado de que era de Cilicia,"
,"35":"dijo: 'Te oiré cuando se presenten tus acusadores'. Y mandó que lo custodiaran en el palacio de Herodes."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Cinco días más tarde, el sumo sacerdote Ananías llegó a Cesarea con algunos ancianos y un tal Tértulo, abogado, y presentaron acusación ante el gobernador contra Pablo."
,"2":"Cuando Pablo compareció, Tértulo comenzó a acusarle así:"
,"3":"'Gracias a ti, oh excelentísimo Félix, gozamos de una gran tranquilidad, y si esta nación ha obtenido saludables reformas, se debe a tu providencia; nosotros lo reconocemos siempre y en todas partes con la más profunda gratitud."
,"4":"Mas para no entretenerte demasiado, te ruego que nos escuches un momento, con tu acostumbrada bondad."
,"5":"Hemos comprobado que este hombre es peor que la peste, promueve motines entre todos los judíos esparcidos en el mundo y es el jefe de la secta de los nazarenos;"
,"6":"hasta ha intentado profanar el templo. Lo hemos arrestado y hemos querido juzgarlo conforme a nuestra ley;"
,"7":"pero llegó el comandante Lisias y nos lo arrebató de las manos,"
,"8":"mandando que sus acusadores compareciesen ante ti. Tú mismo, si le interrogas, podrás comprobar todas las cosas de que lo acusamos'."
,"9":"Los judíos corroboraron la acusación diciendo que era como se había dicho."
,"10":"Pablo, después de darle el gobernador la señal de hablar, respondió: 'Como sé que desde hace muchos años eres el juez de esta nación, haré confiadamente mi defensa."
,"11":"Tú puedes averiguar que no hace más de doce días que fui a Jerusalén a rendir culto a Dios."
,"12":"No me han encontrado discutiendo con nadie en el templo ni amotinando a la gente en las sinagogas o en la ciudad;"
,"13":"ni tampoco pueden probarte las cosas de que ahora me acusan."
,"14":"Pero te confieso que, conforme al nuevo camino, que ellos llaman secta, sirvo al Dios de nuestros padres, creyendo en todo lo que está escrito en la ley y en los profetas;"
,"15":"teniendo en Dios la esperanza que estos mismos tienen de que habrá resurrección, tanto de justos como de injustos."
,"16":"Por tanto, yo me esfuerzo por tener una conciencia intachable para con Dios y para con los hombres."
,"17":"Después de muchos años he venido a traer limosnas a mi nación y a presentar ofrendas."
,"18":"Me encontraron en el templo porque participé en el rito de purificación con unos judíos de Asia, pero sin promover motín o desorden alguno."
,"19":"Ellos eran los que deberían comparecer ante ti y acusarme, si es que tienen algo contra mí;"
,"20":"o que digan estos mismos qué delito me encontraron cuando comparecí ante el tribunal,"
,"21":"a no ser que me acusen por esta frase que pronuncié ante ellos: 'Yo soy juzgado hoy ante vosotros por la resurrección de los muertos'."
,"22":"Félix, que sabía detalladamente las cosas referentes al nuevo camino, les dio largas diciendo: 'Cuando venga el comandante Lisias examinaré a fondo vuestra causa'."
,"23":"Y mandó al oficial que lo custodiase, que le permitiese tener alguna libertad y que no prohibiese a ninguno de los suyos que le asistiera."
,"24":"Unos días después vino Félix con Drusila, su mujer, que era judía, llamó a Pablo y le escuchó acerca de la fe en Cristo Jesús."
,"25":"Cuando él hablaba de la justicia, la continencia y el juicio futuro, Félix, aterrorizado, dijo: 'Por ahora vete; te llamaré en ocasión oportuna'."
,"26":"Esperaba al mismo tiempo que Pablo le diese dinero. Por eso lo llamaba con frecuencia y conversaba con él."
,"27":"A los dos años sucedió a Félix Porcio Festo; queriendo congraciarse con los judíos, Félix dejó a Pablo en la cárcel."
}`)
	CurrentBook.AddChapter(25, `{
"1":"Festo, a los tres días de su llegada a la provincia, subió desde Cesarea a Jerusalén."
,"2":"Los sumos sacerdotes y los jefes de los judíos se le presentaron para acusar a Pablo"
,"3":"y le pidieron como favor que lo trasladara a Jerusalén, mientras preparaban una emboscada para matarlo por el camino."
,"4":"Festo respondió que Pablo estaba custodiado en Cesarea y que él mismo tenía que irse de Jerusalén muy pronto;"
,"5":"y añadió: 'Por lo tanto, que vengan conmigo vuestras autoridades y que lo acusen, si es que ese hombre ha cometido algún delito'."
,"6":"Festo se quedó con ellos unos ocho o diez días. Después bajó a Cesarea. Al día siguiente se sentó en el tribunal, y mandó que trajesen a Pablo."
,"7":"Cuando se presentó, lo rodearon los judíos que habían llegado de Jerusalén, aduciendo muchas y graves acusaciones, que no podían probar,"
,"8":"mientras que Pablo se defendió diciendo: 'Yo no he cometido ningún delito ni contra la ley de los judíos, ni contra el templo, ni contra el césar'."
,"9":"Pero Festo, queriendo congraciarse con los judíos, preguntó a Pablo: '¿Quieres ir a Jerusalén y ser allí juzgado ante mí de estas cosas?'."
,"10":"Pablo dijo: 'Estoy ante el tribunal del césar, donde debo ser juzgado. Yo no he cometido ningún delito contra los judíos, como tú sabes muy bien."
,"11":"Si he cometido algún delito que merezca la muerte, no me niego a morir; pero si no hay nada de lo que éstos me acusan, nadie puede entregarme a ellos. Apelo al césar'."
,"12":"Entonces Festo, después de haber consultado con su consejo, respondió: 'Has apelado al césar, al césar irás'."
,"13":"Unos días después, el rey Agripa y Berenice llegaron a Cesarea para saludar a Festo."
,"14":"Como se detuvieron allí muchos días, Festo expuso al rey el asunto de Pablo: 'Aquí tenemos un hombre que Félix ha dejado en la cárcel."
,"15":"Cuando estuve en Jerusalén, los sumos sacerdotes y los ancianos de los judíos me presentaron acusaciones contra él, pidiendo su condena."
,"16":"Yo les respondí que no es costumbre entre los romanos condenar un hombre antes de que el acusado esté en presencia de los acusadores y tenga la ocasión de defenderse de la acusación."
,"17":"Ellos vinieron conmigo; y yo, sin ninguna dilación, al día siguiente me senté en el tribunal y mandé traer al hombre."
,"18":"Comparecieron los acusadores, pero no adujeron ninguno de los crímenes que yo sospechaba;"
,"19":"sólo tenían contra él ciertas cuestiones acerca de su propia religión y de un tal Jesús, que ha muerto y que Pablo decía que estaba vivo."
,"20":"No sabiendo qué decisión tomar en tales cosas, le pregunté si quería ir a Jerusalén y ser allí juzgado de ellas."
,"21":"Pero Pablo ha apelado y quiere ser sometido al juicio de Augusto. He ordenado que lo custodien hasta que lo remita al César'."
,"22":"Agripa dijo a Festo: 'También yo desearía oír a este hombre'. Festo le contestó: 'Mañana le oirás'."
,"23":"Así pues, al día siguiente Agripa y Berenice llegaron con gran pompa y entraron en la audiencia con los jefes militares y las autoridades de la ciudad. Festo mandó que trajeran a Pablo."
,"24":"Festo dijo: 'Rey Agripa y cuantos os encontráis aquí con nosotros: Aquí tenéis a este hombre; todos los judíos a una, tanto en Jerusalén como aquí, me han pedido a gritos su cabeza."
,"25":"Yo he constatado que él no había hecho nada que mereciera la muerte; pero como él mismo ha apelado a Augusto, he decidido enviarlo."
,"26":"Como no tengo nada concreto que escribir al emperador acerca de él, lo presento ante vosotros, especialmente ante ti, rey Agripa, para, después de este interrogatorio, tener algo que escribir."
,"27":"No me parece razonable enviar un preso y no indicar los cargos que hay contra él'."
}`)
	CurrentBook.AddChapter(26, `{
"1":"Agripa dijo a Pablo: 'Tienes permiso para hablar en tu defensa'. Entonces Pablo, con la mano extendida, presentó su defensa:"
,"2":"'Feliz me considero, oh rey Agripa, al poder defenderme ante ti de todas las acusaciones de los judíos,"
,"3":"sobre todo porque tú conoces bien las costumbres y las cuestiones de los judíos; te ruego, pues, que me escuches con paciencia."
,"4":"Todos los judíos conocen bien cuál ha sido mi vida a partir de mi juventud, pues desde el principio he vivido en medio de mi pueblo, en Jerusalén."
,"5":"Ellos me conocen hace mucho tiempo y, si quieren, pueden testificar que he vivido como fariseo, conforme a la secta más rigurosa de nuestra religión."
,"6":"Ahora estoy sometido a juicio por la esperanza de la promesa hecha por Dios a nuestros padres,"
,"7":"a la que aspiran nuestras doce tribus, sirviendo a Dios asiduamente día y noche. Por causa de esta esperanza, oh rey, soy acusado por los judíos."
,"8":"¿Os parece increíble que Dios resucite a los muertos?"
,"9":"También yo creí deber mío obrar enérgicamente contra el nombre de Jesús Nazareno;"
,"10":"y lo hice, en efecto, en Jerusalén; con la autorización de los sumos sacerdotes, metí en la cárcel a muchos fieles y di mi voto para que los condenaran a muerte."
,"11":"Recorrí las sinagogas y, a fuerza de torturas, los obligaba a renegar. Me ensañé contra ellos de tal modo que los perseguía hasta en las ciudades extranjeras."
,"12":"Pensando en esto, me dirigía una vez hacia Damasco, con la autorización y el permiso de los sumos sacerdotes;"
,"13":"al mediodía vi en el camino, oh rey, una luz venida del cielo, más brillante que la del sol, que me envolvió a mí y a los que iban conmigo."
,"14":"Todos caímos a tierra, y yo oí una voz que me decía en hebreo: Saulo, Saulo, ¿por qué me persigues? Duro es para ti dar coces contra el aguijón."
,"15":"Yo dije: ¿Quién eres tú, Señor? Y el Señor dijo: Yo soy Jesús, a quien tú persigues."
,"16":"Pero levántate y ponte en pie; que me he aparecido a ti para hacerte ministro y testigo de lo que has visto de mí y de lo que te voy a mostrar."
,"17":"Te voy a librar de tu pueblo y de los paganos, a quienes te enviaré"
,"18":"a abrirles los ojos, para que pasen de las tinieblas a la luz y del poder de Satanás a Dios; para que, por la fe en mí, reciban el perdón de los pecados y la herencia entre los consagrados."
,"19":"Yo no fui desobediente, oh rey Agripa, a la visión celeste,"
,"20":"sino que, primero a los de Damasco, luego a los de Jerusalén y de todo el territorio de Judea y, por fin, a los paganos les he predicado que se arrepientan y se conviertan a Dios observando una conducta de arrepentimiento sincera."
,"21":"Por esto me prendieron los judíos en el templo e intentaron matarme."
,"22":"Pero con la ayuda de Dios me mantengo hasta hoy dando testimonio a chicos y grandes, no afirmando nada fuera de lo que los profetas y Moisés dijeron que había de suceder:"
,"23":"que el Mesías tenía que padecer; que sería el primero en resucitar de entre los muertos, y así anunciaría la luz tanto al pueblo como a los paganos'. Juicio de Festo y Agripa. "
,"24":"Mientras así se defendía, Festo exclamó: '¡Estás loco, Pablo! Las muchas letras te hacen perder la cabeza'."
,"25":"Pablo dijo: 'No estoy loco, excelentísimo Festo, sino que pronuncio palabras de verdad y de sensatez."
,"26":"El rey está bien enterado de estas cosas; pues no creo que se le oculte nada, ya que no han ocurrido en un rincón."
,"27":"¿Crees, rey Agripa, a los profetas? Sé que crees'."
,"28":"Agripa dijo a Pablo: 'Por poco me persuades a hacerme cristiano'."
,"29":"Pablo repuso: '¡Quisiera Dios que, por poco o por mucho, no sólo tú, sino todos los que me escuchan hoy, fueran en todo como yo, menos en estas cadenas!'."
,"30":"El rey, el gobernador, Berenice y todos los sentados se levantaron,"
,"31":"y al retirarse iban diciendo: 'Este hombre no ha hecho nada que merezca la muerte o la cárcel'."
,"32":"Agripa dijo a Festo: 'Se le podía haber dado la libertad si no hubiera apelado al césar'."
}`)
	CurrentBook.AddChapter(27, `{
"1":"Cuando se decidió que embarcásemos para Italia, entregaron a Pablo y algunos otros presos a un oficial de la legión Augusta, llamado Julio."
,"2":"Subimos a un barco de Adrumeto, que tenía que dirigirse a las costas de Asia. Partimos en compañía de Aristarco, macedonio de Tesalónica."
,"3":"Al día siguiente llegamos a Sidón; y Julio, que trataba con benevolencia a Pablo, le permitió ir a casa de sus amigos para que le cuidasen."
,"4":"Partimos de allí y costeamos Chipre, porque los vientos eran contrarios;"
,"5":"surcamos el mar de Cilicia y Panfilia y llegamos a Mira de Licia."
,"6":"Allí el oficial encontró un barco de Alejandría que se dirigía a Italia, y nos hizo transbordar a él."
,"7":"Navegamos despacio durante varios días, y a duras penas llegamos frente a Gnido. El viento no nos permitió aproximarnos, y fuimos costeando Creta por el cabo Salmón;"
,"8":"después que lo doblamos, seguimos navegando con grandes dificultades hasta llegar a un lugar llamado Puertos Hermosos, no lejos de la ciudad de Lasea."
,"9":"Habíamos perdido mucho tiempo y la navegación era peligrosa, pues ya había entrado el otoño. Pablo les avisó:"
,"10":"'Amigos, veo que la navegación no podrá hacerse sin peligro y sin graves daños no sólo del cargamento y del barco, sino también de nuestras vidas'."
,"11":"El oficial, sin embargo, se fiaba del piloto y del patrón del barco más que de lo que decía Pablo."
,"12":"Y como el puerto no era a propósito para pasar el invierno, la mayoría decidió hacerse a la mar desde allí, por si podían alcanzar Fenice, puerto de Creta, orientado al suroeste y al noroeste y pasar allí el invierno."
,"13":"Se levantó el viento del sur y creyeron que podrían llevar a cabo su proyecto; levaron anclas y costearon Creta más de cerca."
,"14":"Al poco tiempo se desencadenó del lado de la isla un viento huracanado, llamado euroaquilón."
,"15":"El barco fue embestido y, no pudiendo resistir al viento, nos dejamos llevar a la deriva."
,"16":"Al pasar al abrigo de un islote llamado Cauda, a duras penas logramos hacernos con el bote salvavidas;"
,"17":"una vez izado a bordo, reforzaron con cables el casco del barco y así nos dejamos llevar del viento con el áncora suelta, por temor a chocar contra la Sirte."
,"18":"Como la tempestad seguía arreciando contra nosotros, al día siguiente echaron al mar la carga,"
,"19":"y al tercer día arrojaron con sus propias manos los aparejos del barco."
,"20":"Durante muchos días no aparecieron ni el sol ni las estrellas, y teníamos encima una tempestad tan fuerte, que perdimos toda esperanza de poder salvarnos."
,"21":"Como llevábamos sin comer mucho tiempo, Pablo, puesto en pie en medio de ellos, dijo: 'Amigos míos, más valía que me hubierais hecho caso y no hubiéramos partido de Creta para evitar este desastre y estos daños."
,"22":"Pero ahora os recomiendo que tengáis ánimo, porque ninguno de vosotros perderéis la vida; sólo se perderá el barco."
,"23":"Esta noche un ángel del Dios al que pertenezco y a quien sirvo se me ha aparecido y me ha dicho:"
,"24":"'No temas, Pablo; tienes que comparecer ante el césar; y he aquí que Dios te ha concedido la vida de todos los que navegan contigo'."
,"25":"Por lo cual tened ánimos, amigos; porque confío en Dios, y estoy seguro de que sucederá tal como se me ha dicho."
,"26":"Tenemos que dar en una isla'."
,"27":"A los catorce días de andar a la deriva por el Adriático, hacia la medianoche los marineros sospecharon la proximidad de tierra."
,"28":"Echaron la sonda, y encontraron que había veinte brazas; la echaron de nuevo un poco más adelante, y encontraron quince brazas."
,"29":"Por temor a chocar contra los escollos, echaron a popa cuatro anclas, esperando con ansiedad que se hiciera de día."
,"30":"Los marineros intentaron abandonar el barco y arriaron el bote salvavidas con el pretexto de que iban a dar cable a las anclas de proa."
,"31":"Pablo dijo al oficial y a los soldados: 'Si éstos no se quedan a bordo, no podréis salvaros vosotros'."
,"32":"Entonces los soldados cortaron los cables del bote y lo dejaron caer."
,"33":"Mientras esperaban a que se hiciera de día, Pablo instaba a todos a que comiesen, diciéndoles: 'Lleváis ya catorce días esperando, en ayunas, sin comer nada;"
,"34":"os aconsejo que comáis algo, que os vendrá bien para vuestra salud; pues ni un cabello de vuestra cabeza se perderá'."
,"35":"Dicho esto, y tomando pan, dio gracias a Dios en presencia de todos, lo partió y comenzó a comer."
,"36":"Todos se animaron y se pusieron también a comer."
,"37":"Estábamos a bordo un total de doscientas setenta y seis personas."
,"38":"Cuando quedaron satisfechos, aligeraron la nave echando el trigo al mar."
,"39":"Al llegar el día, los marineros no reconocieron aquella tierra; pero divisaron una ensenada que tenía playa y decidieron hacer todo lo posible para varar allí el barco."
,"40":"Soltaron las anclas y las dejaron caer al mar, aflojando a la vez las ataduras de los timones. Izaron al viento la vela de proa y se dirigieron hacia la playa."
,"41":"Pero fueron a dar a un lugar azotado por una doble corriente, y el barco encalló; la proa, hincada, quedó inmóvil, mientras que la popa se deshacía por la violencia de las olas."
,"42":"Los soldados decidieron matar a los presos para que no se escapase ninguno nadando."
,"43":"Pero el oficial, queriendo salvar a Pablo, se lo impidió, y ordenó que los que supieran nadar se echasen al agua los primeros y saliesen a tierra,"
,"44":"y que los restantes saliesen unos sobre tablas y otros sobre restos del barco. Y así llegaron todos a tierra sanos y salvos."
}`)
	CurrentBook.AddChapter(28, `{
"1":"Una vez a salvo, supimos que la isla se llamaba Malta."
,"2":"Los indígenas nos trataron con una humanidad poco común; como estaba lloviendo y hacía frío, encendieron una hoguera y nos invitaron a calentarnos."
,"3":"Pablo recogió un montón de ramaje y, al echarlo al fuego, una víbora, que escapaba de las llamas, le mordió la mano."
,"4":"Cuando los indígenas vieron la víbora colgando de su mano, se decían unos a otros: 'Este hombre es ciertamente un asesino; se ha librado del mar, pero la justicia divina no le permite vivir'."
,"5":"Mas él se sacudió la víbora, la echó al fuego y no sufrió daño alguno."
,"6":"Ellos estaban esperando que se le hinchara la mano y cayese muerto de repente; pero después de un largo rato sin que le pasara nada, cambiaron de parecer y decían que era un dios."
,"7":"Cerca de allí tenía una finca el principal de la isla, llamado Publio, el cual nos acogió durante tres días con afectuosa hospitalidad."
,"8":"El padre de Publio estaba en cama, atacado de fiebre y disentería. Pablo lo visitó; rezó, le impuso las manos y lo curó."
,"9":"Ante esto, los demás isleños enfermos acudieron también y fueron curados."
,"10":"Nos tributaron muchos honores y, al marchar, nos suministraron todo lo necesario."
,"11":"Al cabo de tres meses nos hicimos a la mar en un barco de Alejandría que había invernado en la isla. Era el 'Cástor y Pólux'."
,"12":"Arribamos a Siracusa y nos detuvimos tres días;"
,"13":"desde allí, costeando, fuimos a Regio. Al día siguiente se levantó el viento del sur, y dos días después llegamos a Pozzuoli,"
,"14":"donde encontramos hermanos, que nos instaron a quedarnos con ellos una semana; desde allí nos dirigimos a Roma."
,"15":"Los hermanos de Roma, que tenían noticias de nuestra llegada, nos salieron al encuentro en Foro Apio y Tres Tabernas; Pablo, al verlos, dio gracias a Dios y cobró ánimos."
,"16":"Cuando entramos en Roma, a Pablo le permitieron quedarse en una casa particular con un soldado que lo custodiase."
,"17":"A los tres días Pablo convocó a los judíos principales; y, cuando estaban reunidos, les dijo: 'Hermanos, sin haber hecho nada contra el pueblo o las costumbres de nuestros padres, he sido encarcelado en Jerusalén y entregado en manos de los romanos;"
,"18":"los cuales, después de haberme interrogado, querían ponerme en libertad por no haber encontrado en mí nada que mereciese la muerte;"
,"19":"pero como se oponían los judíos, me vi obligado a apelar al césar, aunque sin intención de acusar en nada a mi pueblo."
,"20":"Éste es el motivo de haberos llamado para veros y conversar con vosotros, pues por la esperanza de Israel estoy cargado de cadenas'."
,"21":"Ellos le dijeron: 'Nosotros ni hemos recibido de Judea cartas referentes a ti, ni ninguno de los hermanos que han venido nos ha traído malos informes o ha hablado mal de ti."
,"22":"Pero deseamos que nos digas lo que tú piensas; pues sabemos que esta secta encuentra oposición en todas partes'."
,"23":"Señalaron un día, y fueron a su alojamiento en mayor número. Desde la mañana hasta la tarde les anunció el reino de Dios, dando testimonio y esforzándose por convencerlos de quién era Jesús, apoyándose en la ley de Moisés y en los profetas."
,"24":"Unos creyeron lo que decía, pero otros no quisieron creer."
,"25":"Al despedirse sin ponerse de acuerdo unos con otros, Pablo terminó con estas palabras: 'Con razón dijo el Espíritu Santo a vuestros padres por medio del profeta Isaías:"
,"26":"Ve a este pueblo y diles: Oiréis con los oídos, y no entenderéis; miraréis con vuestros ojos, y no veréis."
,"27":"Porque la mente de este pueblo se ha embotado, han tapado sus oídos y han cerrado sus ojos para no ver con sus ojos, ni oír con los oídos, ni entender con la mente, ni convertirse para que los cure."
,"28":"Sabed, pues, que esta salvación de Dios ha sido enviada a los paganos; ellos sí que la escucharán'."
,"30":"Pablo estuvo dos años en una casa alquilada; allí recibía a todos los que iban a verlo,"
,"31":"predicando el reino de Dios y enseñando las cosas referentes al Señor Jesucristo con toda libertad y sin obstáculo alguno."
}`)

}
func ES_LSB_LoadNTAIChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Revelación de Jesucristo, que Dios le ha dado para mostrar a sus servidores lo que va a suceder en seguida; Dios la ha dado a conocer, por medio de un ángel, a su siervo Juan,"
,"2":"el cual atestigua, como palabra de Dios y testimonio de Jesucristo, todo lo que ha visto."
,"3":"Dichoso el que lea y los que escuchen las palabras de esta profecía y observen su contenido, porque el tiempo está cerca."
,"4":"Juan, a las siete Iglesias de Asia: a vosotros la gracia y la paz de parte del que es, el que era y el que viene, y de parte de los siete espíritus que están delante de su trono;"
,"5":"y de parte de Jesucristo, el testigo fiel, el primogénito de entre los muertos y el rey de los reyes de la tierra. A aquel que nos ama y nos ha lavado de nuestros pecados con su propia sangre,"
,"6":"y nos ha hecho un reino de sacerdotes para su Dios y Padre; a él la gloria y el poder por los siglos de los siglos. Amén."
,"7":"Miradlo, viene entre nubes; lo verán todos, aun los que lo traspasaron, y se lamentarán sobre él todas las naciones de la tierra. Sí. Amén."
,"8":"Yo soy el alfa y la omega, dice el Señor Dios, el que es, el que era y el que viene, el todopoderoso."
,"9":"Yo, Juan, vuestro hermano y vuestro compañero en el sufrimiento, en el reino y en la constancia, en Jesús, yo me encontraba en la isla de Patmos por haber predicado la palabra de Dios y por haber dado testimonio de Jesús."
,"10":"Caí en éxtasis el día del Señor y oí detrás de mí una voz potente como de trompeta,"
,"11":"que decía: 'Lo que ves escríbelo en un libro y mándaselo a las siete Iglesias: a Éfeso, a Esmirna, Pérgamo, Tiatira, Sardes, Filadelfia y Laodicea'."
,"12":"Me volví para ver quién me hablaba; y, al volverme, vi siete candelabros de oro,"
,"13":"y en medio de los candelabros como un hijo del hombre, vestido con una larga túnica y ceñido con un cinturón de oro alrededor de su pecho."
,"14":"Su cabeza y sus cabellos eran blancos como la lana blanca, como la nieve; sus ojos, como una llama de fuego;"
,"15":"sus pies, como el bronce fundido a fuego; su voz, como el rumor de aguas caudalosas;"
,"16":"en su mano derecha tenía siete estrellas, y de su boca salía una espada aguda de dos filos; su cara era como el sol que brilla en todo su esplendor."
,"17":"Al verle, caí a sus pies como muerto; pero él me tocó con su mano derecha, y me dijo: 'No tengas miedo; soy yo, el primero y el último, el viviente;"
,"18":"estuve muerto, pero ya estoy vivo por los siglos de los siglos; y tengo las llaves de la muerte y del abismo."
,"19":"Escribe lo que has visto, lo presente y lo que sucederá en seguida."
,"20":"Éste es el secreto de las siete estrellas que has visto en mi mano derecha y de los siete candelabros de oro: las siete estrellas son los ángeles de las siete Iglesias, y los siete candelabros son las siete Iglesias'."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Escribe al ángel de la Iglesia de Éfeso: Esto es lo que dice el que tiene las siete estrellas, el que camina en medio de los siete candelabros de oro."
,"2":"Conozco tus obras, tus fatigas y tu constancia. Sé que no puedes soportar a los malos, que has puesto a prueba a los que se llaman apóstoles sin serlo y los has encontrado mentirosos;"
,"3":"que eres constante y que has sufrido por mi nombre sin desfallecer."
,"4":"Pero tengo esto contra ti: has perdido el amor del principio."
,"5":"Acuérdate, pues, de dónde te has caído, arrepiéntete y vuelve a obrar como antes. Porque, si no te conviertes, iré a ti rápidamente y te quitaré el candelabro de su puesto."
,"6":"Tienes, sin embargo, a tu favor que odias las obras de los nicolaítas, que yo odio también."
,"7":"El que tenga oídos que oiga lo que el Espíritu dice a las Iglesias. Al vencedor le daré a comer del árbol de la vida, que está en el paraíso de Dios."
,"8":"Escribe al ángel de la Iglesia de Esmirna: Esto es lo que dice el primero y el último, el que murió y ha vuelto a la vida."
,"9":"Conozco tu sufrimiento y tu pobreza (aunque eres rico) y las calumnias de parte de los que se llaman judíos sin serlo, pues son más bien una sinagoga de Satanás."
,"10":"No te acobardes ante lo que vas a sufrir. El diablo va a encarcelar a algunos de vosotros; es para poneros a prueba; sufriréis una prueba de diez días. Sé fiel hasta la muerte, y te daré la corona de la vida."
,"11":"El que tenga oídos que oiga lo que el Espíritu dice a las Iglesias. El vencedor no será víctima de la segunda muerte."
,"12":"Escribe al ángel de la Iglesia de Pérgamo: Esto dice el que tiene la espada aguda de dos filos."
,"13":"Sé dónde vives. Allí está el trono de Satanás; pero permaneces fiel a mi nombre y no has renegado de mi fe, ni siquiera en los días de Antipas, mi fiel testigo, al que mataron en vuestra ciudad, donde vive Satanás."
,"14":"Pero tengo algo contra ti: tienes secuaces de la doctrina de Balaán, el cual enseñaba a Balac la manera de hacer caer a los israelitas, incitándoles a comer carnes sacrificadas a los ídolos y a fornicar."
,"15":"Así también tú tienes adeptos a la doctrina de los nicolaítas."
,"16":"Arrepiéntete, pues de lo contrario iré cuanto antes y lucharé contra ellos con la espada de mi boca."
,"17":"El que tenga oídos que oiga lo que el Espíritu dice a las Iglesias. Al vencedor le daré el maná escondido y una piedra blanca, y en la piedra escribiré un nombre nuevo, que sólo conoce el que la recibe."
,"18":"Escribe al ángel de la Iglesia de Tiatira: Esto es lo que dice el hijo de Dios, que tiene los ojos como una llama y los pies como el bronce fundido a fuego."
,"19":"Conozco tus obras, tu amor, tu fe, tu servicio, tu constancia; tus últimas obras son más numerosas que las primeras."
,"20":"Pero tengo esto contra ti: dejas que Jezabel, esa mujer que se dice profetisa, enseñe y seduzca a mis servidores hasta hacerles vivir en la lujuria y comer las carnes sacrificadas a los ídolos."
,"21":"Ya le he dado tiempo para que se arrepienta, pero ella no quiere convertirse de su lujuria."
,"22":"La voy a tirar a un lecho de dolores; y a sus compañeros de prostitución a una prueba terrible, si no se arrepienten de sus enseñanzas;"
,"23":"y a sus hijos los voy a herir de muerte; de este modo todas las Iglesias sabrán que soy yo el que penetra los sentimientos y los pensamientos, y os daré a cada uno según sus obras."
,"24":"En cuanto a vosotros, los demás fieles de Tiatira, todos los que no compartís esta doctrina, que no habéis conocido los secretos de Satanás -como ellos dicen-, declaro que no os impongo otra carga;"
,"25":"únicamente permaneced fieles a la fe que tenéis hasta que yo vaya."
,"26":"Al vencedor, al que permanezca fiel a mi servicio hasta el fin, le daré poder sobre las naciones,"
,"27":"y las apacentará con vara de hierro, como se rompen los vasos de arcilla;"
,"28":"así he recibido también yo este poder de mi Padre; y le daré la estrella de la mañana."
,"29":"El que tenga oídos que oiga lo que el Espíritu dice a las Iglesias."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Escribe al ángel de la Iglesia de Sardes: Esto es lo que dice el que tiene los siete espíritus de Dios y las siete estrellas. Conozco tus obras: tú pasas por vivo, pero estás muerto."
,"2":"Despierta y consolida lo que queda y está a punto de perecer, porque no he encontrado tus obras perfectas delante de Dios."
,"3":"Acuérdate de cómo recibiste y oíste la palabra; guárdala y arrepiéntete. Porque, si no despiertas, caeré sobre ti como un ladrón, sin que sepas a qué hora te voy a sorprender."
,"4":"Pero tienes todavía en Sardes algunas personas que no han manchado sus vestidos; ellas caminarán conmigo con vestiduras blancas, porque son dignas de ello."
,"5":"El vencedor será revestido de vestiduras blancas, yo no borraré jamás su nombre del libro de la vida y reconoceré su nombre delante de mi Padre y de los ángeles."
,"6":"El que tenga oídos que oiga lo que el Espíritu dice a las Iglesias."
,"7":"Escribe al ángel de la Iglesia de Filadelfia: Esto es lo que dice el santo, el veraz, el que tiene la llave de David, el que abre y nadie cerrará, el que cierra y nadie abrirá:"
,"8":"Conozco tus obras: tengo abierta delante de ti una puerta que nadie puede cerrar, porque, a pesar de tu debilidad, has guardado mi palabra y no has renegado de mí."
,"9":"Pongo en tus manos a los de la sinagoga de Satanás, que se dicen judíos sin serlo, los mentirosos; les haré venir a postrarse a tus pies para que sepan que te amo."
,"10":"Porque has guardado mi consigna de perseverancia, yo te guardaré en la hora de la prueba que va a sobrevenir sobre todo el mundo para probar a los habitantes de la tierra."
,"11":"Mi venida está próxima; guarda bien lo que tienes, para que nadie te quite tu corona."
,"12":"Al vencedor le haré columna del templo de mi Dios, y no saldrá más; escribiré sobre él el nombre de mi Dios, el nombre de la ciudad de mi Dios -la nueva Jerusalén, que baja del cielo de junto a mi Dios- y mi nombre nuevo."
,"13":"El que tenga oídos que oiga lo que el Espíritu dice a las Iglesias."
,"14":"Escribe al ángel de la Iglesia de Laodicea: Esto es lo que dice el amén, el testigo fiel y veraz, el principio de la creación de Dios."
,"15":"Conozco tus obras: no eres ni frío ni caliente. Ojalá fueses frío o caliente."
,"16":"Pero porque eres tibio, y no eres ni frío ni caliente, te voy a vomitar de mi boca."
,"17":"Estás diciendo: Yo soy rico, yo me he enriquecido, a mí no me falta nada; y no sabes que eres desdichado, miserable, pobre, ciego y desnudo."
,"18":"Te aconsejo que me compres oro acrisolado en el fuego para enriquecerte, vestiduras blancas para vestirte, y que no aparezca la vergüenza de tu desnudez, y un colirio para que unjas tus ojos y veas."
,"19":"Yo reprendo y castigo a los que amo; por tanto, sé fervoroso y arrepiéntete."
,"20":"Yo estoy a la puerta y llamo; si alguno oye mi voz y me abre, entraré en su casa, cenaré con él y él conmigo."
,"21":"Al vencedor lo sentaré conmigo en mi trono, igual que yo, que he vencido y me he sentado con mi Padre en su trono."
,"22":"El que tenga oídos que oiga lo que el Espíritu dice a las Iglesias."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Después de esto tuve una visión. Vi una puerta abierta en el cielo; y la voz del principio, la que oí hablarme como con sonido de trompeta, me dijo: 'Sube aquí y te mostraré lo que va a suceder en seguida'."
,"2":"Al instante caí en éxtasis, y vi un trono en el cielo y uno sentado en el trono."
,"3":"El que estaba sentado tenía el aspecto de una piedra de jaspe y de sardónica. El trono estaba rodeado de un arco iris, parecido a la esmeralda."
,"4":"Alrededor del trono había veinticuatro tronos, sobre los que estaban sentados veinticuatro ancianos, vestidos de blanco y con coronas de oro en la cabeza."
,"5":"Del trono salían rayos, voces y truenos. Siete lámparas de fuego ardían delante del trono (que son los siete espíritus de Dios)."
,"6":"Delante del trono había como un mar transparente, como de cristal; en medio del trono y alrededor, cuatro seres vivientes llenos de ojos por delante y por detrás."
,"7":"El primero era parecido a un león, el segundo, a un toro; el tercero tenía la cara parecida a la de un hombre; y el cuarto, parecido a un águila que vuela."
,"8":"Los cuatro animales tenían cada uno seis alas, y alrededor y en el interior estaban llenos de ojos. Y repetían sin cesar día y noche: Santo, santo, santo es el Señor, el todopoderoso, el que era, el que es, el que viene."
,"9":"Cada vez que los cuatro seres vivientes dan gloria, honor y acción de gracias al que se sienta en el trono y que vive por los siglos de los siglos,"
,"10":"los veinticuatro ancianos se arrodillan delante del que está sentado en el trono, adoran al que vive por los siglos de los siglos y arrojan sus coronas delante del trono, diciendo:"
,"11":"Señor, Dios nuestro, tú eres digno,de recibir la gloria, el honor y el poder, porque tú has creado,todas las cosas, por tu voluntad existen,y han sido creadas."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Vi en la mano derecha del que está sentado en el trono un libro escrito por las dos caras, sellado con siete sellos."
,"2":"Vi un ángel poderoso que exclamaba con voz potente: ¿Quién es digno de abrir el libro y de romper los sellos?"
,"3":"Y nadie, ni en el cielo, ni en la tierra, ni debajo de la tierra podía abrir el libro y leerlo."
,"4":"Yo lloré mucho, porque no se había encontrado a nadie digno de abrir el libro y de leerlo."
,"5":"Uno de los ancianos me dijo: Deja de llorar, que ha vencido el león de la tribu de Judá, el vástago de David; él abrirá el libro y sus siete sellos."
,"6":"Entonces, junto al trono, vi un cordero rodeado de los cuatro vivientes y de los ancianos. Estaba de pie y como degollado. Tenía siete cuernos y siete ojos (éstos son los siete espíritus de Dios enviados por todo el mundo)."
,"7":"Se acercó y tomó el libro de la mano derecha del que estaba sentado en el trono."
,"8":"Entonces los cuatro seres vivientes y los veinticuatro ancianos se pusieron de rodillas delante del cordero, teniendo cada uno en la mano un arpa y copas de oro llenas de perfumes (las oraciones de los santos)."
,"9":"Ellos cantaban un cántico nuevo: Tú eres digno de tomar el libro,y de abrir sus sellos, porque has sido degollado,y has rescatado para Dios,con tu sangre,a los hombres de toda raza, lengua, pueblo y nación."
,"10":"De ellos has hecho para nuestro Dios,un reino de sacerdotes, que reinarán sobre la tierra."
,"11":"En mi visión oí la voz de una multitud de ángeles que estaban alrededor del trono, de los seres vivientes y de los ancianos; eran miles de miles, millones de millones."
,"12":"Y decían con fuerte voz: El cordero degollado,es digno de recibir poder, riqueza, sabiduría, fuerza, gloria y alabanza."
,"13":"Oí que todas las criaturas del cielo, de la tierra, de debajo de la tierra y del mar decían: Al que se sienta en el trono,y al cordero,la alabanza, el honor, la gloria y el poder,por los siglos de los siglos."
,"14":"Y los cuatro seres vivientes decían: Amén. Y los ancianos se pusieron de rodillas en profunda adoración."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Tuve una visión en el momento en que el cordero abrió el primero de los siete sellos. Oí al primero de los cuatro seres vivientes, que gritaba como con una voz de trueno: Ven."
,"2":"Vi aparecer un caballo blanco; el jinete tenía arco, se le dio una corona y salió como vencedor y para vencer."
,"3":"Cuando el cordero abrió el segundo sello, oí gritar al segundo ser viviente: Ven."
,"4":"Y salió otro caballo rojo; a su jinete se le dio poder para quitar la paz de la tierra y hacer que los hombres se mataran unos a otros, y se le dio una gran espada."
,"5":"Cuando el cordero abrió el tercer sello, oí gritar al tercer ser viviente: Ven. Y vi aparecer un caballo negro, cuyo jinete tenía en la mano una balanza."
,"6":"Y oí como una voz que salía de los cuatro seres vivientes, que decía: Un celemín de trigo por el salario de un día; tres celemines de cebada por el salario de un día; pero el aceite y el vino no tocarlos."
,"7":"Cuando el cordero abrió el cuarto sello, oí el grito del cuarto ser viviente: Ven."
,"8":"Y apareció un caballo pajizo, cuyo jinete se llamaba muerte (el abismo le acompañaba). Le fue dado poder sobre la cuarta parte de la tierra, para matar con la espada, con el hambre, con la peste y con las fieras de la tierra."
,"9":"Cuando el cordero abrió el quinto sello, vi debajo del altar vivos a los que habían sido degollados por proclamar la palabra de Dios y por el testimonio que habían dado."
,"10":"Gritaron con voz potente: '¿Hasta cuándo, tú, el maestro, el santo, el veraz, vas a esperar a hacer justicia y a vengar nuestra sangre de los habitantes de la tierra?'."
,"11":"Dieron a cada uno una vestidura blanca, y les dijeron que tuvieran paciencia aún por un poco de tiempo, hasta que se completase el número de sus compañeros de servicio y de sus hermanos, que iban a morir como ellos."
,"12":"Cuando el cordero abrió el sexto sello, se produjo un terremoto violento, el sol se oscureció como un tejido de crin, la luna se hizo toda como de sangre,"
,"13":"y las estrellas del cielo se cayeron sobre la tierra, como una higuera deja caer sus higos verdes sacudida por un viento fuerte;"
,"14":"el cielo desapareció como un volumen que se enrolla, y todas las montañas y todas las islas fueron removidas de su sitio."
,"15":"Los reyes de la tierra, los príncipes, los generales, los ricos, los poderosos, todos los hombres, esclavos y libres, se escondieron en las cavernas y en las rocas de las montañas."
,"16":"Y decían a las montañas y a las rocas: Caed sobre nosotros y ocultadnos lejos de la cara del que está sentado en el trono y de la ira del cordero;"
,"17":"porque ha llegado el gran día de su ira, y ¿quién podrá resistir?"
}`)
	CurrentBook.AddChapter(7, `{
"1":"Después de esto vi cuatro ángeles en pie en los cuatro ángulos de la tierra, que retenían los cuatro vientos de la tierra para que no soplase el viento ni sobre la tierra, ni sobre el mar, ni sobre ningún árbol."
,"2":"Después vi otro ángel, que subía del oriente y llevaba el sello del Dios vivo; y gritó con voz potente a los cuatro ángeles a los que se les había dado el poder de dañar la tierra y el mar:"
,"3":"'No toquéis la tierra, ni el mar, ni los árboles hasta que hayamos sellado en la frente a los servidores de nuestro Dios'."
,"4":"Y oí el número de los sellados de todas las tribus de Israel: ciento cuarenta y cuatro mil:"
,"5":"de la tribu de Judá, doce mil; de la tribu de Rubén, doce mil; de la tribu de Gad, doce mil;"
,"6":"de la tribu de Aser, doce mil; de la tribu de Neftalí, doce mil; de la tribu de Manasés, doce mil;"
,"7":"de la tribu de Simeón, doce mil; de la tribu de Leví, doce mil; de la tribu de Isacar, doce mil;"
,"8":"de la tribu de Zabulón, doce mil; de la tribu de José, doce mil; de la tribu de Benjamín, doce mil."
,"9":"Después de esto vi aparecer una gran muchedumbre, que nadie podía contar, de toda nación, raza, pueblo y lengua. Estaban en pie delante del trono de Dios y delante del cordero, vestidos con vestiduras blancas y con palmas en sus manos."
,"10":"Gritaban con voz potente: La victoria es de nuestro Dios, que está sentado en el trono, y del cordero."
,"11":"Todos los ángeles estaban en pie,alrededor del trono, de los ancianos,y de los cuatro seres vivientes. Cayeron de rodillas ante el trono,y adoraron a Dios, diciendo:"
,"12":"Amén. La bendición, la gloria, la sabiduría, la acción de gracias, el honor, el poder y la fuerza a nuestro Dios,por los siglos de los siglos. Amén."
,"13":"Uno de los ancianos tomó la palabra y me dijo: 'Esos que están vestidos con vestiduras blancas, ¿quiénes son y de dónde han venido?'."
,"14":"Yo le respondí: 'Señor, tú lo sabes'. Él me dijo: 'Ésos son los supervivientes de la gran persecución, y han lavado sus vestiduras y las han blanqueado en la sangre del cordero."
,"15":"Por eso están delante del trono de Dios, y le sirven día y noche en su templo; el que está sentado en el trono los cobijará bajo su tienda."
,"16":"Ellos ya no tendrán más hambre ni sed; no sentirán más el fuego ardiente del sol;"
,"17":"porque el ángel que está en medio del trono será su pastor y los conducirá a las fuentes de las aguas de la vida; y Dios enjugará todas las lágrimas de sus ojos'."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Cuando el cordero abrió el séptimo sello, se hizo en el cielo un silencio como de media hora."
,"2":"Entonces vi a los siete ángeles que están en pie delante de Dios; les dieron siete trompetas."
,"3":"Después vino otro ángel, que se paró de pie junto al altar, con un incensario de oro; le dieron muchos perfumes para que los ofreciese juntamente con las oraciones de todos los santos sobre el altar de oro colocado delante del trono."
,"4":"Y de la mano del ángel, el humo de los perfumes se elevaba delante de Dios con las oraciones de los santos."
,"5":"Después el ángel tomó el incensario, lo llenó de fuego del altar y lo lanzó sobre la tierra. Entonces se produjeron truenos, relámpagos, voces y terremotos."
,"6":"Y los siete ángeles que tenían las siete trompetas se dispusieron a tocarlas."
,"7":"El primero tocó la trompeta, y cayó sobre la tierra granizo y fuego mezclado con sangre; la tercera parte de la tierra quedó abrasada, la tercera parte de los árboles quedó abrasada y la tercera parte de la hierba verde quedó abrasada."
,"8":"El segundo ángel tocó la trompeta, y una enorme mole de brasas, como una montaña, fue lanzada al mar; la tercera parte del mar se convirtió en sangre,"
,"9":"pereció la tercera parte de los seres del mar y la tercera parte de las naves fue destruida."
,"10":"El tercer ángel tocó la trompeta, cayó del cielo una gran estrella, ardiente como una llama; cayó sobre la tercera parte de los ríos y sobre las fuentes de las aguas."
,"11":"El nombre de la estrella es ajenjo. Y la tercera parte de las aguas se convirtió en ajenjo, y muchos hombres murieron por estas aguas, que se habían vuelto amargas."
,"12":"El cuarto ángel tocó la trompeta, y la tercera parte del sol, la tercera parte de la luna y la tercera parte de las estrellas quedaron heridas de muerte de tal manera que se oscureció la tercera parte de las mismas y el día perdió una tercera parte de su esplendor, lo mismo que la noche."
,"13":"En mi visión oí un águila que volaba por medio del cielo y gritaba con voz potente: '¡Ay, ay, ay de los habitantes de la tierra tan pronto como suenen las trompetas que los tres ángeles van a tocar!'."
}`)
	CurrentBook.AddChapter(9, `{
"1":"El quinto ángel tocó la trompeta, y vi una estrella que había caído del cielo sobre la tierra; y le dieron la llave del pozo del abismo."
,"2":"Cuando ella abrió el pozo del abismo, subió del pozo un humo como de un gran horno, de suerte que el sol y la atmósfera se oscurecieron;"
,"3":"del humo salieron langostas que se esparcieron sobre la tierra, y a las que se dio un poder semejante al de los escorpiones de la tierra."
,"4":"Pero se les ordenó que no hicieran daño a la hierba, al verde y a los árboles, sino solamente a los hombres que no tuvieran la señal de Dios en la frente;"
,"5":"pero que no los mataran, sino que los torturaran durante cinco meses con un dolor semejante al que produce la picadura del escorpión."
,"6":"En aquellos días los hombres buscarán la muerte, pero no la encontrarán; desearán morir, pero la muerte huirá de ellos."
,"7":"Las langostas se parecían a caballos preparados para la guerra: en sus cabezas tenían coronas como de oro, y sus rostros eran como los de los hombres;"
,"8":"tenían los cabellos como los de las mujeres y los dientes como los de los leones;"
,"9":"su pecho, como una coraza de hierro, y el rumor de sus alas, como el ruido de carros de muchos caballos que corren a la batalla;"
,"10":"sus colas, como las de los escorpiones, con aguijones, tienen el poder de dañar a los hombres durante cinco meses."
,"11":"Tienen como rey al ángel del abismo; su nombre en hebreo es 'Abaddón', y en griego 'Apolión', el exterminador."
,"12":"El primer 'ay' ha pasado; quedan todavía dos 'ayes'."
,"13":"El sexto ángel tocó la trompeta, y oí una voz que salía de los cuatro ángulos del altar de oro que está delante de Dios,"
,"14":"la cual decía al sexto ángel, que tenía la trompeta: 'Suelta sobre el río Éufrates a los cuatro ángeles que están encadenados'."
,"15":"Y fueron soltados los cuatro ángeles que estaban dispuestos para la hora, el día, el mes y el año, a fin de exterminar a la tercera parte de los hombres."
,"16":"El gran ejército de caballería constaba de doscientos millones: yo oí su número."
,"17":"Así vi a los caballos y a los jinetes: éstos tenían corazas de color de fuego, de jacinto y de azufre; los caballos tenían las cabezas como las de los leones, y de su boca salía fuego y azufre."
,"18":"La tercera parte de los hombres fue exterminada por estas tres plagas, fuego, humo y azufre, que salían de las bocas de los caballos."
,"19":"Porque el poder de los caballos está en sus bocas y en sus colas; sus colas, parecidas a las serpientes, tienen cabezas, de las que se sirven para dañar."
,"20":"Los demás hombres que no fueron exterminados por estas plagas no se arrepintieron de las obras de sus manos, ni cesaron de adorar a los demonios y a los ídolos de oro, de plata, de bronce, de piedra y de madera, que no podían ni ver, ni oír, ni caminar;"
,"21":"no se arrepintieron ni de sus homicidios, ni de sus maleficios, ni de su lujuria, ni de sus robos."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Después vi otro ángel vigoroso, que bajaba del cielo envuelto en una nube; sobre la cabeza tenía el arco iris; su rostro era como el sol, y sus piernas como columnas de fuego."
,"2":"Tenía en la mano un librito abierto. Puso el pie derecho sobre el mar y el izquierdo sobre la tierra,"
,"3":"y gritó con voz potente, como el rugido del león. Cuando gritó, los siete truenos hicieron oír sus voces."
,"4":"Cuando hablaron los siete truenos, me dispuse a escribir; pero oí una voz del cielo, que decía: 'Ten en secreto lo que han dicho los siete truenos, y no lo escribas'."
,"5":"El ángel que había visto en pie sobre el mar y sobre la tierra alzó la mano derecha hacia el cielo"
,"6":"y juró por aquel que vive por los siglos de los siglos -el que creó el cielo y lo que hay en él, la tierra y todo lo que contiene, el mar y todo lo que hay en él-: 'Se acabó el plazo';"
,"7":"cuando suene la trompeta del séptimo ángel, Dios cumplirá su plan secreto, anunciado a sus siervos los profetas."
,"8":"Después, la voz del cielo que había oído me habló de nuevo y me dijo: 'Anda, toma el libro abierto en la mano del ángel que está en pie sobre el mar y sobre la tierra'."
,"9":"Corrí hacia el ángel y le dije que me diera el librito. Él me contestó: 'Tómalo y cómetelo; te amargará las entrañas, pero en tu boca será dulce como la miel'."
,"10":"Tomé el librito de la mano del ángel y me lo comí; era dulce como la miel en mi boca, pero en cuanto me lo comí se me llenaron de amargura las entrañas."
,"11":"Entonces me dijeron: 'Es necesario que profetices aún acerca de muchos pueblos, naciones, lenguas y reyes'."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Después me dieron una caña como de una vara, y me dijeron: 'Levántate y mide el templo de Dios, el altar y a los adoradores que hay en él;"
,"2":"pero el patio exterior del templo déjalo, no lo midas; porque ha sido entregado a los paganos, que pisotearán la ciudad santa durante cuarenta y dos meses."
,"3":"Yo haré que mis dos testigos profeticen vestidos de saco durante mil doscientos sesenta días'."
,"4":"Éstos son los dos olivos y los dos candelabros puestos delante del señor de la tierra."
,"5":"Si alguno intenta hacerles daño, saldrá fuego de su boca, que devorará a sus enemigos. Así perecerá el que intente hacerles daño."
,"6":"Ellos tienen poder para cerrar el cielo con el fin de que no llueva durante los días de su predicación; tienen asimismo poder sobre las aguas para cambiarlas en sangre, y poder para herir a la tierra con toda clase de plagas todas las veces que quieran."
,"7":"Cuando hayan acabado de dar su testimonio, la bestia que sube del abismo les hará la guerra, los vencerá y los matará."
,"8":"Su cadáver quedará tendido en la plaza de la gran ciudad, que simbólicamente se llama Sodoma y Egipto (donde también ha sido crucificado su Señor)."
,"9":"Gentes de toda raza, pueblo, lengua y nación contemplarán durante tres días y medio su cadáver, y no se permitirá que sus cuerpos sean sepultados."
,"10":"Los habitantes de la tierra se alegrarán de esto y harán fiesta de tal modo que se intercambiarán regalos, porque estos dos profetas eran su tormento."
,"11":"Pero, después de tres días y medio, un soplo de vida que venía de Dios entró en ellos; ellos se pusieron de pie, y los que estaban mirándolos se quedaron aterrorizados."
,"12":"Y oyeron una voz potente que venía del cielo y que les decía: 'Subid aquí'. Entonces, a la vista de sus enemigos, subieron al cielo en la nube."
,"13":"En aquel momento se produjo un gran terremoto y se derrumbó la décima parte de la ciudad, y en el cataclismo perecieron siete mil personas. Los supervivientes, llenos de terror, dieron gloria al Dios del cielo."
,"14":"El segundo 'ay' ha pasado, y el tercero viene en seguida."
,"15":"El séptimo ángel tocó la trompeta, y se oyeron en el cielo voces potentes que decían: El imperio del mundo,ha pasado a nuestro señor,y a su mesías; él reinará por los siglos,de los siglos."
,"16":"Y los veinticuatro ancianos que estaban sentados en sus tronos delante de Dios cayeron de rodillas y adoraron a Dios,"
,"17":"diciendo: Te damos gracias, Señor, Dios todopoderoso, el que es, el que era, porque has tomado posesión,de tu gran poder,y has entrado en tu reino."
,"18":"Los pueblos habían montado,en cólera; pero ha llegado tu ira,y el momento de juzgar,a los muertos; de dar la recompensa,a tus siervos los profetas, a los santos,y a los que veneran tu nombre, pequeños y grandes, y de exterminar,a los que destruían la tierra."
,"19":"Entonces se abrió el templo de Dios, el que está en el cielo, se vio en su templo el arca de su alianza en medio de rayos, voces, truenos, terremotos y fuerte granizada."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Una gran señal apareció en el cielo: una mujer vestida del sol, con la luna bajo sus pies y una corona de doce estrellas en la cabeza."
,"2":"Estaba encinta, y gritaba con los dolores de parto y las angustias de dar a luz."
,"3":"Otra señal apareció en el cielo: un dragón color de fuego, con siete cabezas y diez cuernos; sobre sus cabezas, siete diademas;"
,"4":"su cola arrastraba la tercera parte de las estrellas del cielo y las lanzó sobre la tierra. El dragón se puso delante de la mujer en trance de dar a luz, para devorar al hijo tan pronto como le diera a luz."
,"5":"Ella dio a luz un hijo varón, el que debía regir a todas las naciones con una vara de hierro. El hijo fue arrebatado hacia Dios y a su trono."
,"6":"Y la mujer huyó al desierto, donde tiene un lugar preparado por Dios, para ser alimentada allí durante mil doscientos sesenta días."
,"7":"Entonces hubo una batalla en el cielo: Miguel y sus ángeles lucharon contra el dragón. El dragón y sus ángeles combatieron,"
,"8":"pero no pudieron vencer, y ya no hubo lugar para ellos en el cielo."
,"9":"Y fue precipitado a la tierra el gran dragón, la serpiente antigua, que se llama 'Diablo' y 'Satanás', el seductor del mundo entero, y sus ángeles fueron precipitados con él."
,"10":"Oí una voz potente en el cielo, que decía: Ahora ha llegado la victoria, el poder, el reino de nuestro Dios,y la soberanía de su mesías, porque ha sido expulsado,el acusador de nuestros hermanos, el que día y noche,les acusaba ante nuestro Dios."
,"11":"Ellos le han vencido,por la sangre del cordero,y por el testimonio que proclamaron, y han despreciado su vida,hasta sufrir la muerte."
,"12":"Por eso, alegraos, oh cielos, y vosotros, los que habitáis en ellos. ¡Ay de la tierra y del mar, porque el diablo ha bajado,hasta vosotros con gran furor, sabiendo que le queda poco tiempo!"
,"13":"El dragón, al verse precipitado sobre la tierra, persiguió a la mujer que había dado a luz al varón."
,"14":"Pero dieron a la mujer dos alas de águila real para volar al desierto, el lugar donde es alimentada por un tiempo, dos tiempos y medio tiempo lejos de la vista de la serpiente."
,"15":"La serpiente arrojó de su boca como un río de agua detrás de la mujer para que el río se la llevase."
,"16":"Pero la tierra vino en ayuda de la mujer, abrió su boca y se tragó el río que el dragón había arrojado de su boca."
,"17":"El dragón se irritó contra la mujer, y se fue a hacer la guerra al resto de su descendencia, a los que guardan los mandamientos de Dios y son fieles testigos de Jesús."
,"18":"El dragón se plantó sobre la arena del mar."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Entonces vi surgir del mar una bestia que tenía diez cuernos y siete cabezas; sobre sus cuernos tenía diez diademas, y sobre sus cabezas nombres blasfemos."
,"2":"La bestia que vi era semejante a una pantera; sus pies eran como los de un oso, y su boca como la de un león. El dragón le dio su poder y su trono con un gran imperio."
,"3":"Vi una de sus cabezas como herida de muerte, pero su llaga mortal había sido curada. Toda la tierra, maravillada, seguía a la bestia."
,"4":"Adoraron al dragón, porque había dado su poder a la bestia, y adoraron a la bestia diciendo: '¿Quién es semejante a la bestia y quién podrá luchar contra ella?'."
,"5":"Le dieron una boca que profería palabras arrogantes y blasfemias, y poder para hacerlo durante cuarenta y dos meses."
,"6":"Abrió su boca para blasfemar contra Dios, contra su nombre, contra su santuario y contra los que habitan en el cielo."
,"7":"Y le permitieron hacer la guerra a los santos y vencerlos; le dieron poder sobre toda raza, pueblo, lengua y nación."
,"8":"La adorarán todos los habitantes de la tierra, cuyos nombres no están escritos desde el principio del mundo en el libro de la vida del cordero degollado."
,"9":"El que tenga oídos, que oiga:"
,"10":"Si alguno está destinado al cautiverio, irá al cautiverio; el que mata con la espada, a espada morirá. Aquí la perseverancia y la fe de los santos."
,"11":"Vi otra bestia que subía de la tierra; tenía dos cuernos, como los de un cordero, pero hablaba como un dragón."
,"12":"Ella ejerce todo el poder de la primera bestia en su presencia y hace que la tierra y sus habitantes adoren a la primera bestia, cuya llaga mortal había sido curada."
,"13":"Hace grandes prodigios, hasta hacer descender fuego del cielo a la tierra a la vista de los hombres."
,"14":"Con los prodigios que le ha sido concedido realizar en presencia de la bestia seduce a los habitantes de la tierra y les dice que hagan una estatua a la bestia (la que fue herida con espada y revivió)."
,"15":"Le dieron el poder de dar vida a la estatua de la bestia hasta el punto de hacerla hablar y que hiciera matar a todos los que no la adorasen."
,"16":"Hizo que todos, pequeños y grandes, ricos y pobres, libres y esclavos, recibieran una marca en la mano derecha o en la frente,"
,"17":"de forma que ninguno pudiera comprar o vender si no había sido marcado con el nombre de la bestia o con la cifra de su nombre."
,"18":"Aquí la sabiduría. El que tenga inteligencia, que calcule la cifra de la bestia, una cifra de hombre. Su cifra es 666."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Después vi al cordero, que estaba en pie sobre el monte Sión, acompañado de ciento cuarenta y cuatro mil personas que tenían escrito en las frentes su nombre y el nombre de su Padre."
,"2":"Oí una voz que venía del cielo, semejante a la voz de aguas caudalosas y al ruido de un gran trueno. El sonido que oí era como el de citaristas que tocan sus cítaras."
,"3":"Cantaban un cántico nuevo delante del trono, delante de los cuatro seres vivientes y de los ancianos. Ninguno podía aprender el cántico, a excepción de los ciento cuarenta y cuatro mil rescatados de la tierra."
,"4":"Éstos son los que no se han manchado con mujeres, porque son vírgenes; éstos siguen al cordero adondequiera que va; fueron rescatados de entre los hombres como primicias para Dios y para el cordero;"
,"5":"en su boca no se ha encontrado mentira. Son irreprensibles."
,"6":"Vi otro ángel que volaba por medio del cielo y tenía una buena nueva eterna que anunciar a los habitantes de la tierra, a toda nación, raza, lengua y pueblo."
,"7":"Decía con voz potente: 'Reverenciad a Dios y dadle gloria, porque ha llegado la hora de su juicio; adorad a aquel que ha hecho el cielo y la tierra, el mar y las fuentes del agua'."
,"8":"Y lo siguió un segundo ángel, que gritaba: 'Ha caído, ha caído Babilonia la grande, la que ha abrevado a todos los pueblos con el vino de su ardiente lujuria'."
,"9":"Los siguió un tercer ángel, gritando con voz potente: 'Si alguno adora a la bestia o a su estatua y recibe su marca en la frente o en la mano,"
,"10":"beberá el vino de la ira de Dios, que ha sido vertido sin mezcla en el cáliz de su cólera, y será atormentado en el fuego y en el azufre en presencia de los cuatro ángeles y del cordero."
,"11":"El humo de su suplicio sube por los siglos de los siglos, y no tienen reposo ni de día ni de noche los que adoran a la bestia y a su estatua y los que reciben la marca de su nombre'."
,"12":"Aquí la paciencia de los santos, los que guardan los mandamientos de Dios y la fe de Jesús."
,"13":"Oí una voz que venía del cielo y decía: 'Escribe: Dichosos desde ahora los muertos que mueren en el Señor. Sí, dice el Espíritu, para que descansen de sus trabajos, porque sus obras los acompañan'."
,"14":"Después vi una nube blanca, y sobre la nube sentado como un hijo del hombre, con una corona de oro en la cabeza y una hoz afilada en su mano."
,"15":"Salió otro ángel del templo, gritando con voz potente al que estaba sentado sobre la nube: 'Echa tu hoz y siega, porque ha llegado la hora de la siega, pues está seca la mies de la tierra'."
,"16":"Y el que estaba sentado sobre la nube echó su hoz sobre la tierra, y la tierra quedó segada."
,"17":"Salió luego otro ángel del templo que está en el cielo, teniendo también una hoz afilada."
,"18":"Salió todavía del altar otro ángel, el que tiene poder sobre el fuego, y gritó con voz potente al que tenía la hoz afilada: 'Echa tu hoz afilada y vendimia los racimos de la viña de la tierra, pues la uva está madura'."
,"19":"El ángel echó la hoz afilada sobre la tierra y vendimió la viña de la tierra, y arrojó las uvas en la gran cuba de la ira de Dios."
,"20":"La cuba fue pisada fuera de la ciudad, y de la cuba salió sangre hasta los frenos de los caballos sobre una distancia de unos trescientos kilómetros."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Vi en el cielo otra señal grande y maravillosa: siete ángeles, que tenían en las manos las siete últimas plagas, porque con ellos se termina la ira de Dios."
,"2":"Vi como un mar de cristal, mezclado con fuego, y los que habían vencido a la bestia, a su estatua y a la cifra de su nombre estaban de pie sobre el mar de cristal con las cítaras de Dios."
,"3":"Y cantaban el cántico de Moisés, siervo de Dios, y el cántico del cordero, diciendo: ¡Grandes y maravillosas son tus obras, oh Señor, Dios todopoderoso!, ¡justos y verdaderos son tus caminos, oh rey de las naciones!"
,"4":"¿Quién no te respetará, oh Señor, y no glorificará tu nombre?,Porque tú solo eres santo, y todos los pueblos vendrán,a postrarse delante de ti, porque se han publicado,tus justas sentencias."
,"5":"Después vi abrirse en el cielo el templo, la tienda del testimonio;"
,"6":"y los siete ángeles que tenían las siete plagas salieron del templo vestidos de lino puro y brillante y ceñidos con cinturones de oro."
,"7":"Entonces uno de los cuatro seres vivientes dio a los siete ángeles siete copas de oro llenas de la ira de Dios, que vive por los siglos de los siglos."
,"8":"El templo se llenó del humo que salía de la gloria de Dios y de su poder. Nadie podía entrar en el templo hasta la consumación de las siete plagas de los siete ángeles."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Oí una voz que salía del templo y decía a los siete ángeles: 'Id y verted sobre la tierra las siete copas de la ira de Dios'."
,"2":"El primero fue y vertió su copa sobre la tierra, y una úlcera cruel y maligna sobrevino a los hombres que tenían la marca de la bestia y adoraban su estatua."
,"3":"El segundo vertió su copa sobre el mar, que se hizo como sangre de un muerto, y perecieron todos los seres vivientes del mar."
,"4":"El tercero vertió su copa sobre los ríos y sobre las fuentes de las aguas, que se hicieron sangre."
,"5":"Y oí al ángel de las aguas que decía: Tú eres justo; tú, el que es, el que era; tú, el santo, al haber castigado así."
,"6":"Ellos han derramado la sangre,de los santos y de los profetas, y tú les has dado a beber sangre: se lo merecían."
,"7":"Y oí al altar que decía: Sí, Señor, Dios todopoderoso, tus sentencias son objetivas y justas."
,"8":"El cuarto vertió su copa sobre el sol, al que le dieron poder para quemar a los hombres con el fuego."
,"9":"Los hombres fueron quemados con terribles quemaduras, y blasfemaron contra el nombre de Dios, que tiene poder sobre estas plagas, en vez de arrepentirse para darle gloria."
,"10":"El quinto vertió su copa sobre el trono de la bestia; su reino quedó sumergido en las tinieblas; las gentes se mordían la lengua de dolor, y"
,"11":"blasfemaban contra el Dios del cielo por los dolores de sus úlceras en vez de arrepentirse de sus obras."
,"12":"El sexto vertió su copa sobre el río grande, el Éufrates, y sus aguas se secaron, dejando paso libre a los reyes del oriente."
,"13":"Después vi salir de la boca del dragón, de la bestia y de la del falso profeta tres espíritus inmundos, como ranas:"
,"14":"los espíritus de demonios que hacen prodigios y van a reunir a los reyes de toda la tierra para la guerra del gran día del Dios todopoderoso."
,"15":"'Mirad, vengo como un ladrón. ¡Dichoso el que está dispuesto y con la ropa puesta, para no tener que andar desnudo y dejar ver sus vergüenzas!'."
,"16":"Y los reunieron en el lugar llamado en hebreo 'Harmagedón'."
,"17":"El último vertió su copa en el aire, y salió del templo una voz potente que venía del trono: 'Está hecho'."
,"18":"Y hubo relámpagos, voces y truenos, con un gran terremoto, como no lo hubo nunca de violento desde que el hombre está sobre la tierra."
,"19":"La gran ciudad se despedazó en tres partes, y las ciudades de las naciones se hundieron. Y Dios se acordó de Babilonia la grande, para darle el cáliz del vino de su ardiente ira."
,"20":"Huyeron todas las islas, y desaparecieron las montañas."
,"21":"Granizos enormes -como adoquines- cayeron sobre los hombres, que blasfemaron contra Dios por la plaga del granizo, porque esta plaga era muy grande."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Uno de los siete ángeles que tenían las siete copas vino a decirme: 'Ven, que te voy a enseñar la sentencia de la gran prostituta que está sentada sobre las vastas aguas,"
,"2":"con la cual han adulterado los reyes de la tierra, y la que ha emborrachado a los habitantes de la tierra con el vino de su lujuria'."
,"3":"Y me transportó en espíritu a un desierto. Y vi a una mujer sentada sobre una bestia escarlata, llena de nombres blasfemos, con siete cabezas y diez cuernos."
,"4":"La mujer estaba vestida de púrpura y de escarlata, de piedras preciosas y de perlas; tenía en la mano una copa de oro llena de cosas horrorosas y de las inmundicias de su lujuria;"
,"5":"sobre su frente, un nombre escrito -un misterio-: 'Babilonia la grande, la madre de las prostitutas y de las monstruosidades de la tierra'."
,"6":"Y vi a la mujer emborracharse de la sangre de los santos y de los mártires de Jesús, y al verla me quedé estupefacto."
,"7":"El ángel me dijo: '¿De qué te extrañas? Yo te explicaré el misterio de la mujer y de la bestia que la soporta, que tiene siete cabezas y diez cuernos."
,"8":"La bestia que has visto era, pero ya no es; va a subir del abismo y a encaminarse hacia su ruina. Los habitantes de la tierra, cuyos nombres no están escritos en el libro de la vida desde la fundación del mundo, se llenarán de estupor cuando vean reaparecer a la bestia que era y ya no es."
,"9":"Aquí la inteligencia y la sabiduría. Las siete cabezas son siete montañas, sobre las que se sienta la mujer."
,"10":"Son también siete reyes, de los cuales cinco han caído, uno vive y el otro no ha venido aún, pero cuando venga durará poco tiempo."
,"11":"Y la bestia, que era y que ya no es, es el octavo, uno de los siete, que camina hacia su ruina."
,"12":"Los diez cuernos que has visto son diez reyes, que no han recibido aún el reino, pero que recibirán con la bestia el poder de reyes por una hora."
,"13":"Están todos de acuerdo en poner a disposición de la bestia su fuerza y su poder."
,"14":"Harán la guerra al cordero, y el cordero los vencerá porque es el señor de señores y el rey de reyes; y con él vencerán los suyos, los llamados, los elegidos, los fieles'."
,"15":"El ángel me dijo: 'Las aguas que has visto, sobre las que se sienta la prostituta, son los pueblos, las muchedumbres, las naciones y las lenguas."
,"16":"Los diez cuernos que has visto y la bestia odiarán a la prostituta, la despojarán de sus vestiduras toda desnuda, comerán sus carnes y la quemarán."
,"17":"Porque Dios les ha inspirado la resolución de ejecutar su propio designio y ponerse de acuerdo para poner a disposición de la bestia su poder real hasta que se cumplan las palabras de Dios."
,"18":"Y la mujer que has visto es la gran ciudad, que reina sobre los reyes de la tierra'."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Después de esto vi a otro ángel bajar del cielo con gran poder; la tierra fue iluminada con su esplendor."
,"2":"Gritó con voz potente: Ha caído, ha caído Babilonia la grande,y ha venido a ser morada,de demonios, guarida de todo espíritu impuro, refugio de toda ave inmunda y odiosa;"
,"3":"porque todas las naciones han bebido,el vino de su ardiente lujuria, los reyes de la tierra,han adulterado con ella,y los comerciantes de la tierra,se han enriquecido,por su lujo desenfrenado."
,"4":"Oí otra voz que venía del cielo y decía: Sal de ella, oh pueblo mío, para que no seas solidario,de sus pecados,y no participes de sus plagas;"
,"5":"porque sus pecados,se han acumulado hasta el cielo,y Dios se ha acordado,de sus crímenes."
,"6":"Pagadle con su misma moneda, dadle el doble de lo que ha hecho; en la copa en que ella ha vertido, verted el doble;"
,"7":"cuanto se ha procurado,de gloria y de lujo, dadle de tormento y de duelo. Porque ella dice en su corazón: Estoy sentada como reina, y no soy viuda; no conoceré jamás el duelo,"
,"8":"por eso en un solo día lloverán sobre ella las plagas, la muerte, el duelo y el hambre; ella será consumida por el fuego, porque es un poderoso señor el Dios que la ha condenado."
,"9":"Los reyes de la tierra, que han adulterado con ella y han participado del orgullo de su lujo, cuando vean el humo de su incendio llorarán y se lamentarán sobre ella,"
,"10":"permaneciendo a distancia por miedo a sus tormentos, y dirán: ¡Ay, ay de la gran ciudad, Babilonia, la ciudad fuerte; en un instante ha llegado tu sentencia!"
,"11":"Los comerciantes de la tierra lloran y se lamentan sobre ella, porque ninguno comprará ya sus mercancías:"
,"12":"mercancías de oro y de plata, de piedras preciosas y de perlas, de lino y de púrpura, de seda y de escarlata; toda clase de maderas olorosas, objetos de marfil, de maderas preciosas, de bronce, de hierro y de mármol;"
,"13":"de canela, cinamomo y perfumes, mirra e incienso, vino y aceite, flor de harina y trigo; bestias de carga, ovejas, caballos y carros, esclavos y otros seres humanos."
,"14":"Los frutos que tanto deseabas,se han alejado de ti; todos los productos,delicados y magníficos,se han perdido para ti,y no se volverán a encontrar."
,"15":"Los comerciantes que se enriquecían con este comercio se mantendrán a distancia por miedo a sus tormentos, y llorando y lamentándose, dirán:"
,"16":"¡Ay, ay de la gran ciudad, que estaba vestida de lino, de púrpura y escarlata, adornada de oro, de piedras preciosas y de perlas,"
,"17":"y en un momento,tan gran riqueza ha sido destruida!,Todos los pilotos, todos los navegantes, los marineros y los que trafican en el mar se mantuvieron a distancia "
,"18":"y gritaron al ver el humo de su incendio: '¿Qué ciudad hubo nunca semejante a la gran ciudad?'."
,"19":"Y echándose polvo en sus cabezas, gritaban; y llorando y lamentándose, decían: ¡Ay, ay de la gran ciudad, que con su opulencia enriqueció,a cuantos tenían naves en el mar, y en un momento ha sido desolada!"
,"20":"Alégrate sobre ella, ¡oh cielo!; y vosotros, santos, apóstoles y profetas, porque Dios, al condenarla, ha vengado vuestra causa."
,"21":"Después un ángel vigoroso tomó una piedra, como una gran piedra de molino, y la tiró al mar, diciendo: Así, de un golpe, será tirada Babilonia, la gran ciudad, y no se la encontrará jamás."
,"22":"Y ya no se oirán en ti,las voces de los citaristas, de los músicos, de los flautistas,y de los trompeteros; y no se volverá a encontrar en ti,artífice de cualquier arte; ni se oirá más el ruido de la muela;"
,"23":"la luz de la lámpara,ya no brillará en ti, ni se oirá jamás en ti,la voz del esposo y de la esposa, porque tus comerciantes,eran los grandes de la tierra,y tus sortilegios,han seducido a todas las naciones;"
,"24":"y en ella se ha encontrado la sangre,de los profetas, de los santos y de,todos los que han sido degollados,en la tierra."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Después de esto oí en el cielo la voz de una gran multitud que decía: ¡Aleluya! La victoria, la gloria y el poder,a nuestro Dios,"
,"2":"porque sus sentencias,son objetivas y justas, porque ha castigado,a la gran prostituta,que corrompía la tierra,con su prostitución; él ha vengado en ella,la sangre de sus siervos."
,"3":"Después continuaron diciendo: ¡Aleluya!,Su humo sube,por los siglos de los siglos."
,"4":"Entonces los veinticuatro ancianos y los cuatro seres vivientes cayeron de rodillas y adoraron a Dios, que está sentado sobre el trono, diciendo: Amén. ¡Aleluya!"
,"5":"Y una voz que salía del trono, decía: Alabad a nuestro Dios,todos sus siervos, todos sus fieles, pequeños y grandes."
,"6":"Luego oí como una voz de potentes truenos, que decía: ¡Aleluya!,El Señor, nuestro Dios, todopoderoso, ha establecido su reino."
,"7":"Gocémonos y alegrémonos, y démosle gloria; porque han llegado,las bodas del cordero, su esposa está ya preparada,"
,"8":"y a él le ha concedido vestirse,de lino fino, limpio y brillante."
,"9":"Y el ángel me dijo: 'Dichosos los invitados al banquete de las bodas del cordero'. Y añadió: 'Estas palabras de Dios dicen la verdad'."
,"10":"Yo caí a sus pies para adorarle, pero él me dijo: 'No lo hagas; yo soy un siervo como tú y tus hermanos, que dan el testimonio de Jesús. Adora a Dios' (dar testimonio de Jesús es tener espíritu de profecía)."
,"11":"Luego vi el cielo abierto, y apareció un caballo blanco; el jinete se llama el fiel, el veraz, y juzga y lucha con justicia."
,"12":"Sus ojos son como una llama de fuego; sobre su cabeza tiene muchas diademas; tiene un nombre escrito, que él solo conoce;"
,"13":"está vestido con un manto teñido de sangre, y su nombre es la palabra de Dios."
,"14":"Y los ejércitos celestes lo acompañan sobre caballos blancos, vestidos de lino fino, blanco y limpio."
,"15":"De su boca sale una espada afilada para herir a las naciones; él las regirá con vara de hierro; él pisa el lagar del vino de la ardiente ira del Dios todopoderoso."
,"16":"Lleva sobre el manto y sobre su muslo un nombre escrito: 'Rey de reyes y Señor de señores'."
,"17":"Después vi un ángel puesto de pie en el sol, que gritó con voz potente a todas las aves que volaban en el cielo: 'Venid y reuníos para el gran banquete de Dios,"
,"18":"para que comáis la carne de los reyes, la carne de los generales, la carne de los valerosos, la carne de los caballos y de sus jinetes, la carne de todos, libres y esclavos, pequeños y grandes'."
,"19":"Y vi a la bestia y a los reyes de la tierra y a sus ejércitos reunidos para hacer la guerra contra el que estaba montado en el caballo y contra su ejército."
,"20":"Pero la bestia fue apresada, y con ella el falso profeta, que con sus prodigios ante la otra bestia había seducido a los que llevaban la marca de la bestia y habían adorado su estatua. Y fueron arrojadas vivas las dos a un estanque de fuego, de azufre ardiente."
,"21":"Los demás fueron matados con la espada que salía de la boca del que estaba montado en el caballo; y todas las aves se saciaron de sus carnes."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Vi un ángel que bajaba del cielo; tenía en la mano la llave del abismo y una gran cadena."
,"2":"Prendió al dragón, la antigua serpiente -que es el diablo, Satanás-, lo encadenó por mil años,"
,"3":"lo arrojó al abismo, que cerró y selló después, para que no pudiese seducir más a las naciones hasta que no se cumpliesen los mil años, después de los cuales debe ser soltado por poco tiempo."
,"4":"Vi también unos tronos; a los que se sentaron sobre ellos, les dieron el poder de juzgar. Vi a los que habían sido degollados por dar testimonio de Jesús y por la palabra de Dios, los que no habían adorado a la bestia ni su estatua y no habían recibido la marca ni en sus frentes ni en sus manos. Éstos vivieron y reinaron con Cristo mil años."
,"5":"Los otros muertos no vivieron hasta que no se cumplieron los mil años. Ésta es la primera resurrección."
,"6":"Dichoso y santo el que tiene parte en la primera resurrección; sobre éstos no tiene poder la segunda muerte, sino que serán sacerdotes de Dios y de Cristo, con el que reinarán mil años."
,"7":"Cuando se hayan cumplido los mil años, Satanás será liberado de su prisión"
,"8":"y saldrá a seducir a las naciones que están en los cuatro ángulos de la tierra, a Gog y Magog, con el fin de reunirlos para la batalla, en número tan grande como la arena del mar."
,"9":"Subieron a la superficie de la tierra, y rodearon el campamento de los santos, la ciudad amada; pero cayó fuego del cielo y los devoró."
,"10":"El diablo, que lo seducía, fue arrojado al estanque de fuego y de azufre, donde están la bestia y el falso profeta, y serán atormentados día y noche por los siglos de los siglos."
,"11":"Vi un gran trono blanco y al que estaba sentado sobre él. El cielo y la tierra huyeron de su presencia, sin que se encontrase su lugar."
,"12":"Vi los muertos, grandes y pequeños, en pie delante del trono; entonces fueron abiertos los libros; fue abierto también otro libro, el libro de la vida. Y los muertos fueron juzgados según el contenido de los libros, cada uno según sus obras."
,"13":"El mar devolvió los muertos que guardaba; la muerte y el abismo devolvieron los muertos que guardaban, y cada uno fue juzgado según sus obras."
,"14":"La muerte y el abismo fueron arrojados al estanque de fuego: el estanque de fuego es la segunda muerte."
,"15":"Y el que no fue encontrado escrito en el libro de la vida fue arrojado al estanque de fuego."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Vi un cielo nuevo y una tierra nueva, porque el primer cielo y la primera tierra habían desaparecido; y el mar ya no existía."
,"2":"Y vi a la ciudad santa, la nueva Jerusalén, que bajaba del cielo del lado de Dios, dispuesta como una esposa ataviada para su esposo."
,"3":"Y oí venir del trono una voz potente que decía: 'Ésta es la morada de Dios con los hombres; él habitará con ellos, ellos serán su pueblo y Dios mismo morará con los hombres."
,"4":"Enjugará las lágrimas de sus ojos y no habrá más muerte, ni luto, ni llanto, ni pena, porque el primer mundo ha desaparecido'."
,"5":"Y el que estaba sentado en el trono dijo: 'Ahora hago nuevas todas las cosas'. Luego me dijo: 'Escribe que estas palabras son fieles y veraces'."
,"6":"Y añadió: 'Está hecho. Yo soy el alfa y la omega, el principio y el fin. Al que tenga sed yo le daré gratuitamente de la fuente del agua de la vida."
,"7":"El vencedor heredará estas cosas; yo seré su Dios, y él será mi hijo."
,"8":"Pero los cobardes, los incrédulos, los depravados, los homicidas, los lujuriosos, los hechiceros, los idólatras y todos los mentirosos tendrán su herencia en el estanque ardiente de fuego y de azufre: ésta es la segunda muerte'."
,"9":"Uno de los siete ángeles que tenían las siete copas llenas de las últimas plagas se acercó a mí y me dijo: 'Ven, que te voy a mostrar la esposa del cordero'."
,"10":"Y me llevó en espíritu sobre un monte grande y alto, y me mostró la ciudad santa, Jerusalén, que bajaba del cielo de junto a Dios"
,"11":"con la gloria misma de Dios: su esplendor era como el de una piedra preciosísima, como el jaspe cristalino."
,"12":"Tenía un muro grande y alto con doce puertas; sobre las puertas, doce ángeles y nombres escritos, los de las doce tribus de Israel."
,"13":"Al oriente, tres puertas; al norte, tres puertas; al mediodía, tres puertas; al occidente, tres puertas."
,"14":"El muro de la ciudad tenía doce fundamentos, y sobre ellos doce nombres, los de los doce apóstoles del cordero."
,"15":"El que me hablaba tenía una medida de una caña de oro para medir la ciudad, sus puertas y su muralla."
,"16":"La ciudad es un cuadrado, y su largura es igual que su anchura. Midió la ciudad con la medida: dos mil doscientos veinte kilómetros: su largura, su anchura y su altura son iguales."
,"17":"Midió su muralla: setenta y siete metros, medida de hombre, que es también medida de ángel."
,"18":"La estructura de su muralla es de jaspe, y la ciudad es de oro puro, semejante al del puro cristal."
,"19":"Los fundamentos del muro de la ciudad están adornados de toda clase de piedras preciosas: el primer fundamento es de jaspe; el segundo, de zafiro; el tercero, de calcedonia; el cuarto, de esmeralda;"
,"20":"el quinto, de sardónica; el sexto, de sardio; el séptimo, de crisólito; el octavo, de berilo; el noveno, de topacio; el décimo, de crisopasa; el undécimo, de jacinto; el duodécimo, de amatista."
,"21":"Las doce puertas son doce perlas: todas las puertas están hechas de una sola perla. La plaza de la ciudad es de oro puro, como cristal transparente."
,"22":"No vi en ella ningún templo, porque su templo es el Señor, Dios todopoderoso, y el cordero."
,"23":"La ciudad no tiene necesidad de sol ni de luna que la iluminen, porque la gloria de Dios la ilumina, y su lámpara es el cordero."
,"24":"A su luz caminarán las naciones, y los reyes de la tierra llevarán a ella su gloria."
,"25":"Sus puertas no se cerrarán nunca, pues en ella no habrá noche."
,"26":"A ella llevarán la gloria y el honor de las naciones."
,"27":"En ella no entrará nada impuro ni quien comete abominación o mentira, sino únicamente quienes han sido inscritos en el libro de la vida del cordero."
}`)
	CurrentBook.AddChapter(22, `{
"1":"El ángel me mostró un río de agua viva, transparente como un cristal, que manaba del trono de Dios y del cordero."
,"2":"En medio de la plaza de la ciudad, y a un lado y otro del río, hay árboles de la vida, que dan doce frutos al año, una vez al mes. Las hojas de los árboles sirven para curar a las naciones."
,"3":"Ya no habrá maldición alguna. El trono de Dios y del cordero estará en la ciudad, y los servidores de Dios lo adorarán;"
,"4":"verán su cara y llevarán su nombre en la frente."
,"5":"No habrá ya noche, no tendrán ya necesidad de la luz de una lámpara ni de la del sol, porque el Señor Dios los alumbrará, y reinarán por los siglos de los siglos."
,"6":"Y me dijo: 'Estas palabras son ciertas y auténticas, y el Señor Dios de los espíritus de los profetas ha enviado a su ángel a mostrar a sus servidores lo que va a suceder en seguida."
,"7":"Voy a llegar en seguida. Dichoso el que guarda la palabra de la profecía de este libro'."
,"8":"Yo, Juan, soy el que he oído y visto estas cosas. Cuando las oí y vi, caí a los pies del ángel que me las había mostrado para adorarlo."
,"9":"Pero él me dijo: 'No lo hagas, pues yo soy un servidor, como tú y tus hermanos los profetas y los que guardan las palabras de este libro. Adora a Dios'."
,"10":"Y me dijo: 'No selles las palabras de la profecía de este libro, porque el tiempo está próximo."
,"11":"Que el pecador continúe pecando, que el inmundo siga en su inmundicia, pero que el justo continúe practicando la justicia y que el santo siga santificándose."
,"12":"Yo voy a llegar en seguida, y llevo conmigo la recompensa que voy a dar a cada uno según sus obras."
,"13":"Yo soy el alfa y la omega, el principio y el fin."
,"14":"Dichosos los que lavan sus vestidos para tener derecho al árbol de la vida y a entrar en la ciudad por las puertas."
,"15":"Fuera los perros, los hechiceros, los impuros, los homicidas, los idólatras y todos los que aman y practican la mentira."
,"16":"Yo, Jesús, he enviado a mi ángel para testificar estas cosas acerca de las Iglesias. Yo soy la raíz y la descendencia de David, la estrella radiante de la mañana'."
,"17":"El Espíritu y la esposa dicen: 'Ven'. El que escuche, diga: 'Ven'. El que tenga sed, que venga; y el que quiera, tome gratuitamente del agua de la vida."
,"18":"Yo aseguro a todo el que escucha las palabras de la profecía de este libro que si alguno hace añadiduras a esto, Dios le añadirá a él las plagas descritas en este libro."
,"19":"Y si alguno quita algo de las palabras de este libro profético, Dios quitará su parte del árbol de la vida y de la ciudad santa, descritas en este libro."
,"20":"El que afirma estas cosas dice: 'Sí, yo voy a llegar en seguida'. Amén. ¡Ven, Señor Jesús!"
,"21":"La gracia de Jesús, el Señor, esté con todos. Amén."
}`)

}
func ES_LSB_LoadNTHBChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Dios, después de haber hablado muchas veces y en diversas formas a nuestros padres por medio de los profetas,"
,"2":"en estos días, que son los últimos, nos ha hablado por el Hijo, a quien ha constituido heredero de todas las cosas, por quien hizo también el universo."
,"3":"Él, que es el resplandor de su gloria y la impronta de su ser, sostiene todas las cosas con su palabra poderosa, y, una vez que realizó la purificación de los pecados, se sentó a la derecha de la Majestad en lo más alto del cielo,"
,"4":"llegando a ser superior a los ángeles en la medida en que los aventaja el nombre que ha recibido en herencia."
,"5":"En efecto, ¿a cuál de los ángeles dijo Dios alguna vez: Tú eres mi hijo, yo te he engendrado hoy; y además: Yo seré su Padre, y él será mi Hijo?"
,"6":"Y de nuevo, cuando introdujo al Primogénito en el mundo, dijo: Que le adoren todos los ángeles de Dios."
,"7":"Mientras que, cuando habla de los ángeles, dice: Hace a sus ángeles como vientos, y a sus ministros como llama de fuego."
,"8":"Del Hijo, en cambio, afirma: Tu trono, oh Dios, dura eternamente; y: el cetro de tu reino es cetro de justicia."
,"9":"Has amado la justicia y odiado la iniquidad; por eso Dios, tu Dios, te ha ungido con óleo de alegría con preferencia a tus compañeros."
,"10":"Más todavía: Señor, tú pusiste al principio los cimientos de la tierra, y los cielos son obra de tus manos."
,"11":"Ellos perecerán, pero tú quedarás, todos se desgastarán como la ropa;"
,"12":"tú los doblarás como se dobla un manto; serán como la muda que se cambia. Mas tú eres siempre el mismo y tus años no terminan nunca."
,"13":"Y ¿a cuál de los ángeles dijo nunca: Siéntate a mi derecha hasta que haga de tus enemigos estrado de tus pies?"
,"14":"¿No son todos ellos espíritus encargados de un ministerio, enviados al servicio de aquéllos que deben heredar la salvación?"
}`)
	CurrentBook.AddChapter(2, `{
"1":"Por eso debemos prestar más atención a las enseñanzas recibidas, no sea que marchemos a la deriva."
,"2":"Porque si la palabra promulgada por los ángeles estaba garantizada hasta el punto de que toda transgresión y desobediencia recibió su justo castigo,"
,"3":"¿cómo podríamos escapar nosotros si descuidamos una salvación tan grande? La cual, inaugurada por la predicación del Señor, nos ha sido transmitida con garantía por aquellos que le oyeron,"
,"4":"confirmando Dios su testimonio con signos, prodigios y toda clase de milagros, y con los dones que el Espíritu Santo reparte según su voluntad."
,"5":"Porque, de hecho, no sometió a los ángeles el mundo venidero, del cual hablamos."
,"6":"Alguien afirmó en cierto lugar: ¿Qué es el hombre, para que de él te acuerdes; el ser humano, para que de él te preocupes?"
,"7":"Lo hiciste poco inferior a los ángeles, lo coronaste de gloria y dignidad."
,"8":"Todo lo sometiste bajo sus pies. Si se le ha sometido todo, no ha quedado nada fuera de su dominio. De momento, es cierto, no vemos todavía esta sumisión universal."
,"9":"Pero al que fue rebajado un poco con relación a los ángeles, Jesús, le vemos coronado de gloria y dignidad por haber sufrido la muerte; de modo que, por la gracia de Dios, gustó la muerte en beneficio de todos."
,"10":"Convenía, en efecto, que aquel por quien y para quien todo fue hecho, queriendo llevar a la gloria un gran número de hijos, hiciese perfecto, mediante los sufrimientos, al jefe que debía guiarlos a la salvación."
,"11":"Porque el santificador y los santificados tienen todos el mismo origen. Por lo cual no se avergüenza de llamarlos hermanos,"
,"12":"diciendo: Anunciaré tu nombre a mis hermanos, en plena asamblea te alabaré."
,"13":"Y además: En él pondré mi confianza. Más todavía: Aquí estoy yo con los hijos que Dios me ha dado."
,"14":"Pues de la misma manera que los hijos participan de la misma carne y sangre, también él participó de modo parecido, para reducir a la impotencia mediante la muerte a aquel que tiene el imperio de la muerte, es decir, al diablo,"
,"15":"y libertar a todos aquellos que, por miedo a la muerte, estaban sometidos durante toda su vida a la esclavitud."
,"16":"Porque, ciertamente, no vino en auxilio de los ángeles, sino que vino en auxilio de la descendencia de Abrahán."
,"17":"Por lo cual debió hacerse en todo semejante a sus hermanos, para convertirse en sumo sacerdote misericordioso y fiel ante Dios, para alcanzar el perdón de los pecados del pueblo."
,"18":"Pues por el hecho de haber sufrido y haber sido probado, está capacitado para venir en ayuda de aquellos que están sometidos a la prueba."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Por eso, hermanos, miembros del pueblo de Dios, partícipes de una vocación celeste, considerad al apóstol y sumo sacerdote de la fe que profesamos, a Jesús,"
,"2":"modelo de fidelidad a Dios, que le dio tal nombramiento como lo fue Moisés en toda la casa de Dios."
,"3":"Él, en efecto, ha sido considerado digno de una gloria superior a la de Moisés, en la misma medida en que la dignidad del arquitecto de una casa supera a la casa misma."
,"4":"Toda casa ha sido construida por alguien, pero es Dios quien ha construido todas las cosas."
,"5":"Moisés, cierto, fue fiel en toda la casa de Dios, en calidad de siervo, como ministro, para dar testimonio de las cosas que debían ser manifestadas;"
,"6":"Cristo, por el contrario, lo ha sido en calidad de Hijo, al frente de su casa. Y su casa somos nosotros, con tal que permanezcamos inquebrantables hasta el fin, confesando valientemente nuestra fe y confiados en la esperanza que tenemos."
,"7":"Por eso, como dice el Espíritu Santo: Hoy, si oís su voz,"
,"8":"no endurezcáis vuestros corazones, como ocurrió en la rebelión, el día de la tentación en el desierto,"
,"9":"cuando vuestros padres me desafiaron y me pusieron a prueba, aunque habían visto mis obras durante cuarenta años."
,"10":"Por eso me irrité contra aquella generación, y dije: 'Su corazón siempre anda extraviado; nunca conocen mis caminos."
,"11":"Y juré en mi indignación: No entrarán jamás en mi descanso'."
,"12":"Hermanos, tened cuidado, que no haya entre vosotros un corazón tan malo e incrédulo que se aparte del Dios vivo."
,"13":"Más bien, animaos mutuamente cada día mientras dura este 'hoy', de modo que ninguno de vosotros se endurezca por la seducción del pecado."
,"14":"Porque hemos llegado a ser partícipes de Cristo, si seguimos manteniendo inquebrantable hasta el fin nuestra fe inicial."
,"15":"Cuando se dice: Hoy, si oís su voz, no endurezcáis vuestros corazones, como ocurrió en la rebelión,"
,"16":"¿quiénes fueron los que, después de haber oído, se rebelaron? ¿No fueron todos aquellos que salieron de Egipto gracias a Moisés?"
,"17":"Y ¿contra quién se irritó Dios durante cuarenta años? ¿No fue contra los culpables, cuyos cadáveres cayeron en el desierto?"
,"18":"Y ¿a quién juró él que no entrarían en su descanso sino a aquellos que habían sido desobedientes?"
,"19":"Vemos, pues, que ellos no pudieron entrar a causa de su incredulidad."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Mientras sigue en vigor la promesa de entrar en su descanso, hay que tener mucho cuidado, no sea que alguno de vosotros no lo consiga."
,"2":"Porque también nosotros, como ellos, hemos recibido la buena nueva; pero a ellos no les aprovechó la palabra que habían oído, porque al escucharla no se unieron a ella por la fe."
,"3":"Entremos, pues, nosotros, que hemos creído, en el descanso, según lo que dijo: Y juré en mi indignación: ¡No entrarán jamás en mi descanso! Las obras de Dios ya estaban acabadas desde la creación del mundo."
,"4":"Pues en cierto pasaje dijo acerca del séptimo día: Y Dios descansó de todo su trabajo el séptimo día."
,"5":"Y de nuevo en este lugar: No entrarán en mi descanso."
,"6":"Y como, por una parte, es cierto que algunos deben entrar en él, y, por otra, los primeros que recibieron la buena nueva no entraron a causa de su desobediencia,"
,"7":"de nuevo Dios fija un día, un 'hoy', diciendo por David, después de tanto tiempo, lo que ya ha sido dicho: ¡Hoy, si oís su voz, no endurezcáis vuestros corazones!..."
,"8":"Pues si Josué les hubiese procurado el reposo, (David) no hubiese hablado después de esto de otro día."
,"9":"Existe, pues, un reposo reservado para el pueblo de Dios;"
,"10":"pues aquel que entre en el reposo de Dios, descansará también él de sus obras, como Dios de las suyas."
,"11":"Esforcémonos, pues, por entrar en este reposo, para que nadie sucumba imitando aquel ejemplo de desobediencia."
,"12":"Pues la palabra de Dios es viva y eficaz y más aguda que espada de dos filos; ella penetra hasta la división del alma y del espíritu, de las articulaciones y de la médula, y es capaz de juzgar los sentimientos y los pensamientos."
,"13":"Y no hay criatura alguna que esté oculta ante ella, sino que todo está desnudo y descubierto a los ojos de aquel a quien debemos dar cuenta."
,"14":"Puesto que tenemos un sumo sacerdote extraordinario, que ha penetrado en los cielos, Jesús, el Hijo de Dios, permanezcamos firmes en la fe que profesamos."
,"15":"Pues no tenemos un sumo sacerdote incapaz de compadecerse de nuestras debilidades, ya que fue probado en todo a semejanza nuestra, a excepción del pecado."
,"16":"Acerquémonos, pues, con confianza al trono de la gracia, a fin de obtener misericordia y hallar la gracia del auxilio oportuno."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Porque todo sacerdote es elegido de entre los hombres para representar a los hombres ante Dios y ofrecer dones y sacrificios por los pecados,"
,"2":"siendo capaz de mostrarse comprensivo con los ignorantes y extraviados, ya que también él está rodeado de debilidad;"
,"3":"por esta razón debe ofrecer sacrificios por sus pecados, así como lo hace por los del pueblo."
,"4":"Y nadie puede arrogarse este honor si no es llamado por Dios, como Aarón."
,"5":"Así también Cristo no se atribuyó la gloria de constituirse sumo sacerdote, sino que la recibió de aquel que le dijo: Tú eres mi Hijo, yo te he engendrado hoy."
,"6":"Como dice también en otro lugar: Tú eres sacerdote para siempre, a la manera de Melquisedec."
,"7":"Él, en los días de su vida mortal, presentó con gran clamor y lágrimas oraciones y súplicas al que podía salvarle de la muerte, y fue escuchado en atención a su obediencia;"
,"8":"aunque era hijo, en el sufrimiento aprendió a obedecer;"
,"9":"así alcanzó la perfección y se convirtió para todos aquellos que le obedecen en principio de salvación eterna,"
,"10":"pues fue proclamado por Dios sumo sacerdote a la manera de Melquisedec."
,"11":"Acerca de esto tendríamos muchas cosas que decir, difíciles de explicar, porque sois torpes para comprender."
,"12":"Pues debiendo ser ya maestros por razón del tiempo, todavía tenéis necesidad de que se os enseñen los primeros rudimentos de oráculos divinos, y habéis llegado a tener necesidad de leche, no de alimento sólido."
,"13":"Ahora bien, aquel que se alimenta de leche no puede gustar la doctrina de la justicia, porque es niño todavía."
,"14":"El alimento sólido es para los perfectos, que por razón de la costumbre tienen el sentido moral desarrollado para distinguir entre el bien y el mal."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Por eso, dejando aparte la doctrina elemental sobre Cristo, elevémonos a la doctrina perfecta, sin volver a echar los cimientos del arrepentimiento de las obras muertas y de la fe en Dios,"
,"2":"de la doctrina sobre los bautismos y la imposición de las manos, de la resurrección de los muertos y del juicio eterno."
,"3":"Esto es lo que vamos a hacer con el auxilio de Dios."
,"4":"Los que una vez fueron iluminados, que gustaron el don celeste, que fueron hechos partícipes del Espíritu Santo,"
,"5":"que saborearon la dulzura de la palabra de Dios y las maravillas del mundo venidero"
,"6":"y que a pesar de todo recayeron, es imposible que se renueven otra vez por la penitencia, ya que de nuevo crucifican por su cuenta al Hijo de Dios y le declaran infame."
,"7":"En efecto, la tierra que absorbe el agua caída repetidas veces sobre ella y que produce frutos abundantes para aquellos que la cultivan, recibe la bendición de Dios;"
,"8":"pero la que produce espinas y abrojos es tierra baldía, será tierra maldita que terminará siendo pasto de las llamas."
,"9":"Queridos hermanos, aunque hablamos así, estamos persuadidos de que vosotros estáis en una situación mejor y más favorable con respecto a la salvación."
,"10":"Porque Dios no es injusto como para olvidar vuestras buenas obras y el amor que habéis demostrado hacia su nombre en el servicio que habéis prestado y seguís prestando a los creyentes."
,"11":"Deseamos solamente que cada uno de vosotros demuestre el mismo empeño por guardar intacta hasta el fin vuestra esperanza,"
,"12":"que no os descuidéis y que sigáis el ejemplo de aquellos que por la fe y la perseverancia entran en posesión de las promesas."
,"13":"Dios, al hacer la promesa a Abrahán, no teniendo otra persona mayor por quien jurar, juró por sí mismo,"
,"14":"diciendo: Sí, te colmaré de bendiciones y multiplicaré tu descendencia."
,"15":"Y así, por la perseverancia, Abrahán alcanzó la realización de la promesa."
,"16":"Los hombres, en efecto, juran por lo que es más grande que ellos, y el juramento es la garantía que pone fin a sus controversias."
,"17":"Por eso Dios, queriendo dar a los herederos de la promesa una prueba nueva de que su decisión era irrevocable, se comprometió con juramento,"
,"18":"para que por estas dos cosas inmutables, en las cuales es imposible que Dios mienta, tengamos mayor ánimo los que nos refugiamos en la adhesión firme de la esperanza a la que estamos destinados;"
,"19":"esta esperanza es para nosotros como un áncora segura y firme, que penetra más allá de la cortina del santuario,"
,"20":"donde, como precursor nuestro, entró Jesús, convertido en sumo sacerdote para siempre a la manera de Melquisedec."
}`)
	CurrentBook.AddChapter(7, `{
"1":"En efecto, este Melquisedec, rey de Salén, sacerdote del Dios altísimo, que salió al encuentro de Abrahán cuando éste volvía de la derrota de los reyes, y le bendijo,"
,"2":"y a quien Abrahán dio la décima parte de todo; cuyo nombre se interpreta en primer lugar como 'rey de justicia', y también como rey de Salén, es decir, 'rey de paz',"
,"3":"aparece sin padre, sin madre y sin antepasados; no se conoce ni su nacimiento ni su muerte; a semejanza del Hijo de Dios, permanece sacerdote para siempre."
,"4":"Considerad, pues, la dignidad de aquel a quien el mismo patriarca Abrahán dio la décima parte de lo mejor del botín."
,"5":"Aquellos que de la tribu de Leví reciben el sacerdocio tienen el mandato, según la ley, de exigir la décima parte de todo al pueblo, es decir, a sus hermanos, aunque también ellos pertenezcan a la posteridad de Abrahán;"
,"6":"sin embargo, uno que no desciende de él por generación recibió la décima parte del botín conquistado por Abrahán y bendijo al portador de la promesa."
,"7":"Ahora bien, está fuera de duda que el inferior es bendecido por el superior."
,"8":"Además, los que aquí reciben la décima parte son hombres mortales; mientras que allí, uno de quien se afirma que vive."
,"9":"Y, por decirlo así, fue el mismo Leví, quien ahora cobra la décima parte de los bienes, el que, en la persona de Abrahán pagó a Melquisedec esa décima parte,"
,"10":"pues Leví estaba ya en las entrañas de su padre Abrahán cuando le salió al encuentro Melquisedec."
,"11":"Por consiguiente, si la perfección hubiese sido realizada por el sacerdocio levítico -ya que por su medio el pueblo recibió la ley-, ¿qué necesidad habría entonces de que surgiese otro sacerdote a la manera de Melquisedec, y que no lo fuese según el orden de Aarón?"
,"12":"Ahora bien, cambiando el sacerdocio, se sigue necesariamente el cambio de la ley."
,"13":"Porque aquel de quien se dicen estas cosas pertenecía a otra tribu, de la cual ningún miembro sirvió nunca al altar;"
,"14":"porque es sabido que nuestro Señor nació de la tribu de Judá, la cual no es mencionada por Moisés al tratar de los sacerdotes."
,"15":"Y esto se hace todavía más evidente si, a semejanza de Melquisedec, surge otro sacerdote"
,"16":"que no ha llegado a serlo según la ley de una disposición carnal, sino más bien según el poder de una vida imperecedera."
,"17":"Porque de él se ha dado este testimonio: Tú eres sacerdote para siempre, a la manera de Melquisedec."
,"18":"Y así queda abrogado el orden anterior a causa de su impotencia e inutilidad;"
,"19":"porque la ley no llevó cosa alguna a la perfección; y en su lugar entra una esperanza mejor, por lo cual nos acercamos a Dios."
,"20":"Tanto más cuanto que esto no se realiza sin juramento. Mientras que aquéllos fueron instituidos sacerdotes sin juramento,"
,"21":"éste lo fue con juramento por aquel que le dijo: El Señor lo ha jurado y no se vuelve atrás: tú eres sacerdote para siempre."
,"22":"Esto es precisamente lo que hace que Jesús sea la garantía de una alianza superior."
,"23":"Además, mientras que aquellos sacerdotes eran muchos porque la muerte les impedía permanecer en su función,"
,"24":"éste, en cambio, posee un sacerdocio inmutable, porque permanece para siempre."
,"25":"De ahí proviene que pueda salvar perfectamente a aquellos que por él se acercan a Dios, estando siempre vivo para interceder en su favor."
,"26":"Tal era precisamente el sumo sacerdote que nos convenía: santo, inocente, sin mancha, separado de los pecadores y elevado más alto que los cielos;"
,"27":"que no necesita diariamente, como los sumos sacerdotes, ofrecer sacrificios primero por sus propios pecados y después por los del pueblo. Esto lo hizo él de una vez para siempre cuando se ofreció a sí mismo."
,"28":"La ley, en efecto, constituye sumos sacerdotes a hombres débiles; pero la palabra del juramento posterior a la ley constituye sacerdote al Hijo, hecho perfecto para siempre."
}`)
	CurrentBook.AddChapter(8, `{
"1":"El punto capital de lo que estamos diciendo es que tenemos un sumo sacerdote que está sentado a la derecha del trono de la majestad en los cielos,"
,"2":"como ministro del santuario y del verdadero tabernáculo construido por el Señor, no por un hombre."
,"3":"En efecto, todo sumo sacerdote es instituido para ofrecer dones y sacrificios; por lo cual es necesario que éste tenga también algo que ofrecer."
,"4":"Por tanto, si estuviese sobre la tierra no sería sacerdote en modo alguno, porque ya hay encargados de ofrecer los dones según la ley."
,"5":"Éstos realizan un culto que es la imagen y sombra de las realidades celestes, según le fue advertido divinamente a Moisés cuando iba a construir el tabernáculo: Mira y hazlo todo según el modelo que se te ha mostrado en la montaña."
,"6":"Pero ahora Cristo ha obtenido un ministerio tanto más excelente cuanto mejor es la alianza de la cual es mediador y más ventajosas las promesas sobre las que está fundada."
,"7":"Porque si la primera alianza hubiese sido perfecta, no hubiese habido lugar para buscar una segunda."
,"8":"Sin embargo, les dice en tono de recriminación: Vienen días dice el Señor, en que yo haré con la casa de Israel,y la casa de Judá una alianza nueva,"
,"9":"no como la alianza que hice con sus padres,cuando los tomé de la mano,y los saqué de Egipto, alianza que ellos violaron,y por lo cual los rechacé, dice el Señor."
,"10":"Ésta es la alianza que haré con la casa de Israel, después de aquellos días, dice el Señor. Pondré mis leyes en su mente, las escribiré en su corazón, yo seré su Dios y ellos serán mi pueblo."
,"11":"Ya nadie tendrá que enseñar a su conciudadano, ni a su hermano, diciendo: Conoce al Señor, porque todos me conocerán, desde el más pequeño hasta el mayor."
,"12":"Porque perdonaré sus crímenes,y no me acordaré más de sus pecados."
,"13":"Al hablar de alianza 'nueva', Dios ha declarado anticuada la primera. Ahora bien, lo que es viejo y anticuado está a punto de desaparecer."
}`)
	CurrentBook.AddChapter(9, `{
"1":"La primera alianza tenía una liturgia propia y un santuario terrestre."
,"2":"En efecto, se construyó un tabernáculo, en cuya parte anterior se encontraban el candelabro, la mesa y los panes de la proposición; es lo que se llama el lugar santo."
,"3":"Después, detrás de la segunda cortina estaba el lugar santísimo,"
,"4":"con el altar de oro para los perfumes y el arca de la alianza totalmente recubierta de oro, que contenía un vaso de oro lleno de maná, la vara de Aarón que había florecido y las tablas de la alianza;"
,"5":"y sobre el arca, los querubines de la gloria cubrían con su sombra el propiciatorio. No es éste el lugar para hablar de todo esto en detalle."
,"6":"Dispuestas así las cosas, los sacerdotes entran a diario en la primera parte del tabernáculo para celebrar el culto."
,"7":"En la segunda, por el contrario, entra solamente el sumo sacerdote una vez al año, y provisto de sangre, que ofrece por sus pecados y por los del pueblo."
,"8":"El Espíritu Santo quería demostrar con esto que el camino del santuario no estaba abierto mientras subsistiese el primer tabernáculo."
,"9":"Esto es una imagen del tiempo presente; significa que en su régimen se ofrecen dones y sacrificios que no tienen el poder de hacer perfecto interiormente al que celebra el culto;"
,"10":"se trata de normas externas referentes a los alimentos, a las bebidas y a los ritos purificatorios, válidos solamente hasta el establecimiento del nuevo orden de cosas."
,"11":"Cristo, por el contrario, se presentó como sumo sacerdote de los bienes venideros, a través de un tabernáculo más santo y más perfecto, no hecho por mano de hombre, es decir, no de esta creación,"
,"12":"y entró de una vez para siempre en el santuario, no con sangre de machos cabríos y de becerros, sino con su propia sangre, adquiriéndonos una liberación eterna."
,"13":"Pues si la sangre de los machos cabríos y de los becerros y la ceniza de la vaca, con las que se asperja a aquellos que están manchados, los santifica procurándoles la pureza del cuerpo,"
,"14":"¿cuánto más la sangre de Cristo, que por virtud del Espíritu eterno se ofreció a sí mismo a Dios como víctima inmaculada, purificará nuestra conciencia de sus obras muertas, para servir al Dios vivo?"
,"15":"Por eso es el mediador de una nueva alianza, a fin de que, consiguiendo con su muerte el perdón de los delitos cometidos en el tiempo de la primera alianza, aquellos que son llamados reciban la herencia eterna prometida."
,"16":"Porque donde hay testamento, es necesario que sea constatada la muerte del testador."
,"17":"Un testamento no es válido sino en caso de muerte, porque no entra en vigor mientras vive el testador."
,"18":"Por eso, ni siquiera la primera alianza fue inaugurada sin derramamiento de sangre."
,"19":"En efecto, Moisés, después de haber promulgado ante el pueblo todos los mandamientos según estaban escritos en la ley, tomó la sangre de machos cabríos y de becerros, con agua, lana escarlata y el hisopo, y roció con ella el libro mismo y a todo el pueblo,"
,"20":"diciendo: Ésta es la sangre de la alianza que Dios ha establecido para vosotros."
,"21":"Después roció también con sangre la tienda y todos los objetos del culto."
,"22":"Por lo demás, según la ley, casi todo es purificado con la sangre, y sin derramamiento de sangre no hay perdón."
,"23":"Era, pues, necesario que las figuras de las cosas celestes fuesen purificadas de esta manera, y las realidades mismas celestes lo fuesen también, pero con sacrificios superiores a los de aquí abajo."
,"24":"Porque Cristo no entró en un santuario hecho por mano de hombre, simple figura del verdadero, sino en el mismo cielo, para presentarse ahora ante Dios en favor nuestro."
,"25":"No para ofrecerse a sí mismo más veces, como lo hace el sumo sacerdote, que entra cada año en el santuario, con sangre ajena;"
,"26":"porque, de otro modo, hubiese tenido que padecer muchas veces desde la creación del mundo; pero ahora se ha manifestado una sola vez, al fin de los tiempos, para abolir el pecado por su sacrificio."
,"27":"Y del mismo modo que está establecido para los hombres que mueran una sola vez y después haya un juicio,"
,"28":"así también Cristo, después de haberse ofrecido una sola vez para quitar los pecados del mundo, aparecerá una segunda vez, sin pecado, para dar la salvación a los que le esperan."
}`)
	CurrentBook.AddChapter(10, `{
"1":"En efecto, no siendo la ley más que una sombra de los bienes venideros y no la realidad misma de las cosas, ofrece cada año perpetuamente los mismos sacrificios sin poder hacer perfectos a aquellos que se acercan a Dios."
,"2":"De otro modo, ¿no hubiesen cesado de ofrecerlos, supuesto que quienes ofrecían este culto, purificados una vez para siempre, no tendrían ya conciencia alguna de pecado?"
,"3":"Por el contrario, estos sacrificios traen cada año a la mente el recuerdo de los pecados;"
,"4":"porque es imposible que la sangre de toros y machos cabríos quite los pecados."
,"5":"Por eso, al entrar en este mundo, Cristo dijo: No has querido sacrificios ni ofrendas, pero en su lugar me has formado un cuerpo."
,"6":"No te han agradado los holocaustos ni los sacrificios por el pecado."
,"7":"Entonces dije: Aquí estoy yo para hacer tu voluntad, como en el libro está escrito de mí."
,"8":"Primero dice que no ha querido sacrificios ni ofrendas y que no le han agradado los holocaustos y los sacrificios por el pecado;"
,"9":"y luego añade: Aquí estoy yo para hacer tu voluntad, con lo que deroga el primer régimen para fundar el segundo."
,"10":"Y en virtud de esta voluntad nosotros somos santificados, de una vez para siempre, por la ofrenda del cuerpo de Jesucristo."
,"11":"Y mientras todo sacerdote se presenta diariamente, oficiando y ofreciendo muchas veces los mismos sacrificios, que no tienen poder alguno para quitar los pecados,"
,"12":"él, por el contrario, habiendo ofrecido un solo sacrificio por los pecados, se sentó para siempre a la derecha de Dios,"
,"13":"esperando desde entonces que sus enemigos sean colocados como estrado de sus pies."
,"14":"Porque por una ofrenda única ha hecho perfectos para siempre a aquellos que santifica."
,"15":"Esto mismo nos atestigua también el Espíritu Santo; porque después de haber dicho:"
,"16":"Ésta es la alianza que haré con ellos después de estos días, dice el Señor: Pondré mis leyes en su mente y las escribiré en sus corazones"
,"17":"y no me acordaré más de sus crímenes y de sus pecados."
,"18":"Ahora bien, donde hay perdón de los pecados no hay necesidad de ofrenda por el pecado."
,"19":"Así pues, hermanos, puesto que tenemos la gozosa esperanza de entrar en el santuario en virtud de la sangre de Jesús,"
,"20":"siguiendo el camino nuevo y viviente que él ha inaugurado a través de la cortina, es decir, de su propia carne,"
,"21":"y puesto que tenemos un nuevo sumo sacerdote al frente de la casa de Dios,"
,"22":"acerquémonos con un corazón sincero, con fe perfecta, purificados los corazones de toda mancha de la que tengamos conciencia, y el cuerpo lavado con agua pura."
,"23":"Mantengamos firmemente la esperanza que profesamos, pues el que ha prometido es fiel;"
,"24":"y miremos los unos por los otros para estimularnos en el amor y en las obras buenas;"
,"25":"no abandonéis vuestras propias asambleas, como algunos tienen por costumbre hacer, sino más bien animaos mutuamente, y esto tanto más cuanto que veis acercarse el día."
,"26":"Porque si pecamos deliberadamente después de haber recibido el conocimiento de la verdad, ya no queda sacrificio alguno por los pecados,"
,"27":"sino una terrible expectación y el ardor vindicativo del fuego que consumirá a los rebeldes."
,"28":"Pues si el que viola la ley de Moisés es condenado irremisiblemente a muerte por el testimonio de dos o tres testigos,"
,"29":"¿de cuánto mayor castigo pensáis vosotros que será digno quien haya pisoteado al Hijo de Dios y haya tratado como cosa profana la sangre de la alianza por la cual fue santificado, y haya ultrajado el Espíritu de la gracia?"
,"30":"Porque conocemos a aquel que ha dicho: A mí la venganza, yo daré a cada cual lo que merezca. Y también: El Señor juzgará a su pueblo."
,"31":"Es espantoso caer en las manos del Dios vivo."
,"32":"Recordad, en cambio, aquellos primeros días en que, después de haber sido iluminados, obtuvisteis grandes luchas de sufrimientos,"
,"33":"unas veces expuestos públicamente a ultrajes y torturas y otras haciéndoos solidarios de aquellos que eran así tratados."
,"34":"Porque vosotros habéis compartido las penas de los presos, habéis aceptado con alegría el que os quitaran vuestros bienes, siendo conscientes de que estáis en posesión de una riqueza mejor y permanente."
,"35":"No perdáis vuestra esperanza cierta, que tendrá una gran recompensa."
,"36":"Es necesario que seáis constantes en el cumplimiento de la voluntad de Dios, para que alcancéis lo que os está prometido."
,"37":"Porque dentro de poco, muy poco tiempo, el que ha de venir llegará sin retrasos."
,"38":"Mi justo vivirá por la fe; pero si se acobarda, dejará de agradarme."
,"39":"Nosotros, sin embargo, no somos de aquellos que se retiran cobardemente para la perdición, sino de aquellos que se salvan por la fe."
}`)
	CurrentBook.AddChapter(11, `{
"1":"La fe es la garantía de las cosas que se esperan, la prueba de aquellas que no se ven."
,"2":"Por ella recibieron testimonio de admiración los antiguos."
,"3":"Por la fe conocemos que el mundo fue creado por la palabra de Dios, de suerte que lo visible tiene una causa invisible."
,"4":"Por la fe Abel ofreció a Dios un sacrificio más perfecto que el de Caín; por ella fue proclamado justo, dando el mismo Dios testimonio en favor de sus dones, y por ella, aunque muerto, sigue hablando."
,"5":"Por la fe fue arrebatado de este mundo Henoc sin experimentar la muerte; nadie lo pudo encontrar, porque lo había arrebatado Dios. Y la Escritura dice que antes de ser arrebatado había agradado a Dios."
,"6":"Ahora bien, sin la fe es imposible agradarle; porque aquel que se acerca a Dios debe creer que existe y que recompensará a aquellos que lo buscan."
,"7":"Por la fe Noé, divinamente advertido acerca de las cosas que todavía no se veían, movido de un religioso temor, construyó un arca para salvar a su familia; por la fe condenó al mundo y se convirtió en heredero de la justicia que se obtiene por la fe."
,"8":"Por la fe Abrahán, obedeciendo la llamada divina, partió para un país que recibiría en posesión, y partió sin saber a dónde iba."
,"9":"Por la fe vino a habitar en la tierra prometida como en un país extranjero, viviendo en tiendas de campaña, con Isaac y Jacob, herederos con él de la misma promesa."
,"10":"Porque él esperaba la ciudad de sólidos cimientos, cuyo arquitecto y constructor es Dios."
,"11":"Por la fe recibió también Sara el poder de concebir, fuera de la edad propicia, porque creyó; en la fidelidad de aquel que se lo había prometido."
,"12":"Precisamente por esto, de un solo hombre, ya casi muerto, nació una descendencia tan numerosa como las estrellas del cielo y como los incontables granos de arena que hay en las playas del mar."
,"13":"Todos éstos murieron en la fe sin haber obtenido la realización de las promesas, pero habiéndolas visto y saludado de lejos y reconociendo que eran extranjeros y peregrinos en la tierra."
,"14":"Ahora bien, aquellos que hablan así demuestran claramente que buscan la patria."
,"15":"Y si ellos hubiesen pensado en aquella de la que habían salido, hubiesen tenido oportunidad para volver a ella."
,"16":"Ellos, en cambio, aspiraban a una patria mejor, es decir, celeste. Por eso Dios no se avergüenza de ellos, de llamarse 'su Dios', porque les ha preparado una ciudad."
,"17":"Por la fe Abrahán, puesto a prueba, ofreció a Isaac; e inmolaba a su hijo único a aquel que había recibido las promesas,"
,"18":"a aquel de quien le había sido dicho: De Isaac saldrá una descendencia que llevará tu nombre."
,"19":"Porque pensaba que Dios tiene poder incluso para resucitar a los muertos. Por eso recobró a su hijo. Esto es un símbolo para nosotros."
,"20":"Por la fe Isaac bendijo a Jacob y a Esaú con vistas al futuro."
,"21":"Por la fe Jacob, al morir, bendijo a cada uno de los hijos de José y se postró ante Dios apoyándose en la empuñadura de su bastón."
,"22":"Por la fe José, al fin de su vida, refiriéndose al éxodo de los israelitas dio disposiciones acerca de sus restos mortales."
,"23":"Por la fe Moisés, apenas nacido, fue ocultado por sus padres durante tres meses, porque vieron que el niño era hermoso y no temieron el edicto del rey."
,"24":"Por la fe Moisés, siendo ya mayor, no quiso ser tenido por hijo de la hija del Faraón,"
,"25":"escogiendo más bien ser maltratado con el pueblo de Dios que disfrutar de las delicias pasajeras del pecado;"
,"26":"con los ojos puestos en la recompensa, consideró mayor riqueza el oprobio del ungido que los tesoros de Egipto."
,"27":"Por la fe huyó de Egipto sin temor a las iras del rey y se mantuvo firme como si viese al invisible."
,"28":"Por la fe celebró la pascua y roció con sangre las puertas para que el exterminador no tocase a los primogénitos de Israel."
,"29":"Por la fe pasaron el mar Rojo como por tierra seca; e intentando hacer lo mismo los egipcios, fueron sumergidos en las olas."
,"30":"Por la fe cayeron los muros de Jericó, después de dar la vuelta a su alrededor durante siete días."
,"31":"Por la fe Rajab, la prostituta, no pereció con los incrédulos, por haber dado asilo a los espías."
,"32":"¿Y qué más diré? Me faltaría tiempo para hablar de Gedeón, Barac, Sansón, Jefté, David, lo mismo que de Samuel y los profetas,"
,"33":"los cuales por la fe subyugaron reinos, ejercieron la justicia, alcanzaron las promesas, cerraron la boca de los leones,"
,"34":"apagaron la violencia del fuego, escaparon al filo de la espada, convalecieron de la enfermedad, fueron valientes en la guerra, pusieron en fuga a los ejércitos enemigos."
,"35":"Hubo mujeres que recuperaron sus muertos resucitados. Unos se dejaron torturar, no aceptando la liberación, para obtener una resurrección mejor."
,"36":"Otros soportaron burlas y latigazos, incluso cadenas y cárceles;"
,"37":"fueron apedreados, torturados, aserrados, pasados a filo de espada, anduvieron errantes, cubiertos con pieles de ovejas y de cabras, desprovistos de todo, oprimidos, maltratados,"
,"38":"de quienes no era digno el mundo, errantes por los desiertos, las montañas, las cavernas y cuevas de la tierra."
,"39":"Y todos éstos, mártires de la fe, no alcanzaron el objeto de la promesa;"
,"40":"porque Dios había previsto para nosotros una suerte mejor, y aquéllos no debían llegar sin nosotros a la perfección."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Precisamente por eso también nosotros, envueltos como estamos en una gran nube de testigos, debemos liberarnos de todo aquello que es un peso para nosotros y del pecado, que fácilmente nos seduce, y correr con perseverancia en la prueba que se nos propone,"
,"2":"fijando nuestra mirada en Jesús, el autor y consumador de la fe, quien, para obtener la gloria que se le proponía, soportó la cruz, aceptando valientemente la ignominia, y está sentado a la diestra del trono de Dios."
,"3":"Pensad, pues, continuamente en aquel que soportó tan grande contradicción de parte de los pecadores, para que no desfallezcáis perdiendo el ánimo."
,"4":"Todavía no habéis resistido hasta el derramamiento de sangre en la lucha contra el pecado."
,"5":"Habéis olvidado la exhortación que os dirige como a hijos: Hijo mío, no desprecies la corrección del Señor, ni te desalientes cuando te reprenda;"
,"6":"porque el Señor corrige al que ama, y castiga al que recibe como hijo."
,"7":"El castigo que soportáis os sirve para educaros. Dios os trata como a hijos. ¿Hay algún hijo que no sea corregido por su padre?"
,"8":"Si estuvieseis exentos de castigo, que a todos alcanza, no seríais hijos legítimos, sino bastardos."
,"9":"Además, si nosotros respetábamos a nuestros padres cuando nos corregían, ¿con cuánta mayor razón debemos someternos a nuestro Padre celestial para tener la vida?"
,"10":"Nuestros padres nos educaron lo mejor que pudieron para un tiempo limitado, mientras que Dios lo hace para nuestro verdadero provecho, para comunicarnos su propia santidad."
,"11":"Es cierto que todo castigo, en el momento de recibirlo, es desagradable y motivo de disgusto; pero después, en los que se han ejercitado en él, produce frutos de paz y de justicia."
,"12":"Por lo cual, enderezad vuestras manos abatidas y vuestras rodillas debilitadas,"
,"13":"dirigid vuestros pasos por caminos llanos para que el pie cojo en lugar de dislocarse se cure."
,"14":"Buscad afanosamente la paz con todos y la santidad, sin la cual nadie verá al Señor;"
,"15":"vigilad para que nadie sea privado de la gracia de Dios, para que ninguna raíz amarga vuelva a brotar y os perturbe, lo cual contaminaría la masa;"
,"16":"que nadie sea lujurioso ni desprecie la religión, como Esaú, quien, por una comida, vendió sus derechos de primogénito."
,"17":"Sabéis bien que, como consecuencia, cuando quiso recibir la bendición, le fue negada, y no logró cambiar lo que había hecho, aunque lo intentó con lágrimas."
,"18":"Porque no os habéis acercado a una montaña que se pueda tocar con la mano, como los israelitas. No os habéis enfrentado al fuego ardiente, al torbellino, a la oscuridad densa, a la tempestad,"
,"19":"al sonido de la trompeta y al clamor de las palabras que aquéllos oyeron, y suplicaron que no les volviera a hablar Dios,"
,"20":"porque no podían soportar esta prohibición: El que pise la montaña, incluso si es una bestia, será apedreado."
,"21":"Y el espectáculo era tan terrible que Moisés dijo: Estoy aterrado y temblando."
,"22":"Vosotros, en cambio, os habéis acercado a la montaña de Sión, a la ciudad del Dios vivo, la Jerusalén celestial, a millares de ángeles, a la asamblea festiva,"
,"23":"a la congregación de los primogénitos que están escritos en los cielos, a Dios, juez universal, y a los espíritus de los justos, que han sido hechos perfectos,"
,"24":"a Jesús, mediador de una alianza nueva, que nos roció con una sangre, que habla más elocuentemente que la de Abel."
,"25":"Cuidado con no escuchar al que os habla; pues si aquéllos, por no escuchar al que promulgaba oráculos en la tierra no escaparon al castigo, ¡con cuánta mayor razón no escaparemos nosotros si volvemos la espalda a aquel que habla desde el cielo!"
,"26":"Aquel cuya voz conmovió entonces la tierra nos ha hecho ahora esta promesa: Una vez más conmoveré no sólo la tierra, sino también el cielo."
,"27":"Estas palabras: una vez más, indican que las cosas conmovidas serán cambiadas, porque son cosas creadas, para que subsistan aquellas que son inmutables."
,"28":"Así pues, puesto que entramos en posesión de un reino inmutable, retengamos firmemente la gracia, y por ella ofrezcamos a Dios un culto agradable con reverencia y con respeto."
,"29":"Porque nuestro Dios es fuego devorador."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Perseverad en el amor fraterno."
,"2":"No olvidéis la hospitalidad, ya que, gracias a ella, algunos, sin saberlo, hospedaron a ángeles."
,"3":"Acordaos de los presos, de los que sufren torturas, como si estuvieseis en su mismo cuerpo."
,"4":"Que el matrimonio sea tenido en gran honor y el lecho conyugal esté sin mancha, porque Dios juzgará a los lujuriosos y a los adúlteros."
,"5":"Que la avaricia no se apodere de vosotros. Contentaos con lo que tenéis, porque Dios mismo ha dicho:"
,"6":"No te dejaré ni te abandonaré; de suerte que podemos decir con confianza: El Señor es mi auxilio; no temeré. ¿Qué podrán hacerme los hombres?"
,"7":"Acordaos de vuestros jefes, aquellos que os anunciaron la palabra de Dios; y, considerando el fin de su vida, imitad su fe."
,"8":"Jesucristo es el mismo ayer y hoy, y lo será por siempre."
,"9":"No os dejéis engañar por doctrinas distintas y extrañas; porque es mejor afianzar el corazón con la gracia que con alimentos que no son de provecho alguno para quienes se aferran a ellos."
,"10":"Tenemos un altar del cual no tienen derecho a comer los que sirven en el tabernáculo."
,"11":"En efecto, el cuerpo de las víctimas, cuya sangre introduce el sumo sacerdote en el santuario para el rito de la absolución de los pecados, es quemado fuera del campamento."
,"12":"Por eso también Jesucristo, para santificar al pueblo por su propia sangre, murió fuera de la ciudad."
,"13":"Salgamos, pues, a su encuentro, fuera del campamento, compartiendo sus ultrajes."
,"14":"Porque no tenemos aquí abajo ciudad permanente, sino que buscamos la futura."
,"15":"Por él ofrezcamos a Dios sin cesar un sacrificio de alabanza, es decir, el fruto de los labios que confiesan su nombre."
,"16":"No os olvidéis de hacer el bien y de compartir vuestros bienes con los demás, pues ésos son los sacrificios que agradan a Dios."
,"17":"Obedeced a vuestros jefes y estadles sumisos, porque ellos cuidan de vuestras vidas, de las cuales deberán dar cuenta, para que lo hagan con alegría y no con lágrimas, lo que no os beneficiaría nada."
,"18":"Rezad por nosotros. Sabemos que tenemos la conciencia tranquila, resueltos como estamos a portarnos bien en todo."
,"19":"Os ruego encarecidamente que lo hagáis, para que cuanto antes pueda estar con vosotros."
,"20":"El Dios de la paz, que por la sangre de la alianza eterna resucitó de entre los muertos al gran Pastor de las ovejas, nuestro Señor Jesucristo,"
,"21":"os haga aptos para cumplir su voluntad en toda clase de obras buenas, obrando en vosotros lo que le es agradable a sus ojos por Jesucristo, a quien sea la gloria por los siglos de los siglos. Amén."
,"22":"Hermanos, os ruego que aceptéis estas palabras de exhortación, acompañadas de estas breves líneas."
,"23":"Sabed que nuestro hermano Timoteo ha sido puesto en libertad. Si viene pronto, iré a veros con él."
,"24":"Saludad a vuestros jefes y a todos los creyentes. Los de Italia os saludan."
,"25":"¡Que la gracia esté con todos vosotros! Amén."
}`)

}
func ES_LSB_LoadVH1MChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Alejandro de Macedonia, hijo de Filipo, salió de su país, derrotó a Darío y reinó en su lugar, comenzando por Grecia;"
,"2":"emprendió numerosas guerras, expugnó fortalezas y mató a los reyes de la región;"
,"3":"llegó hasta los confines de la tierra y saqueó muchas naciones. La tierra enmudeció ante él, y él se llenó de orgullo y de soberbia."
,"4":"Reclutó un poderoso ejército y sometió a su poder provincias, naciones y reyes, que le pagaron tributo."
,"5":"Pero después de todo esto cayó enfermo y se dio cuenta de que iba a morir."
,"6":"Llamó a sus generales y nobles, educados con él desde la juventud, y, todavía en vida, les dividió el reino."
,"7":"Alejandro murió a los doce años de su reinado."
,"8":"Sus generales tomaron el poder, cada cual en su provincia."
,"9":"Después de su muerte, todos ciñeron la corona real, y sus hijos después de ellos durante muchos años; pero llenaron la tierra de crueldades."
,"10":"De ellos brotó un vástago perverso, Antíoco Epífanes, hijo del rey Antíoco, que había estado en Roma como rehén y comenzó a reinar el año 137 de la era de los griegos."
,"11":"Por entonces surgieron en Israel hombres perversos, que sedujeron a muchos, diciendo: 'Pactemos con las naciones vecinas, pues desde que nos hemos apartado de ellas nos han sobrevenido muchas calamidades'."
,"12":"Esto les agradó,"
,"13":"y algunos del pueblo fueron a ver al rey, quien les autorizó a seguir las costumbres paganas."
,"14":"Construyeron en Israel un gimnasio al modo de los gentiles,"
,"15":"disimularon la circuncisión, se alejaron de la alianza santa para unirse a los paganos y se vendieron para cometer el mal."
,"16":"Cuando Antíoco se percató de que su reinado estaba bien consolidado, concibió la idea de apoderarse también de Egipto para reinar en las dos naciones."
,"17":"Entró en Egipto con un ejército impresionante, con carros, elefantes, caballos y una gran flota."
,"18":"Atacó a Tolomeo, rey de Egipto, que se retiró ante él y luego huyó, muriendo muchos de los suyos."
,"19":"Ocupó las ciudades egipcias fortificadas y las saqueó."
,"20":"Después de conquistar Egipto, el año 143, marchó contra Israel y Jerusalén con un ejército numeroso."
,"21":"Entró altivamente en el templo y se apoderó del altar de oro, del candelabro con todos sus accesorios,"
,"22":"de la mesa de los panes de la proposición, copas, tazas, incensarios de oro, el velo, coronas y la decoración de oro de la fachada del templo."
,"23":"Se llevó también la plata, el oro, los objetos preciosos y los tesoros escondidos que encontró."
,"24":"Todo se lo llevó a su patria después de haber derramado mucha sangre y haber hablado con insolencia y con orgullo."
,"25":"Hubo entonces un gran luto en todo Israel."
,"26":"Jefes y ancianos gimieron; doncellas y jóvenes perdieron su vigor,y se desvaneció la belleza de las mujeres."
,"27":"El joven esposo entonó lamentaciones, y la joven esposa se angustió en el tálamo nupcial."
,"28":"La tierra tembló por sus habitantes, y toda la casa de Jacob se cubrió de vergüenza."
,"29":"Dos años después mandó el rey a las ciudades de Judá al misarca, que llegó a Jerusalén con un ejército imponente."
,"30":"Se presentó con astucia en son de paz, y lo creyeron. Pero, inesperadamente, irrumpió en la ciudad y la asestó un terrible golpe, matando a muchos en Israel."
,"31":"Saqueó la ciudad, la incendió y destruyó las casas y las murallas que la cercaban."
,"32":"Sus gentes hicieron prisioneros a mujeres y niños y se apoderaron de sus ganados."
,"33":"Fortificaron la ciudad de David con un muro grande y sólido, defendido con torres fuertes, y la convirtieron en ciudadela."
,"34":"Instalaron gente perversa, hombres desalmados, que en ella se hicieron fuertes."
,"35":"Almacenaron armas y víveres, reunieron el botín recogido en Jerusalén y se convirtieron en un enclave molesto,"
,"36":"en un peligro constante para el templo y en una continua amenaza para Israel."
,"37":"Derramaron sangre inocente junto al templo,y profanaron los lugares sagrados."
,"38":"Por temor a ellos huyeron los habitantes de Jerusalén, que se convirtieron en una colonia de extranjeros. Sus hijos se sentían extranjeros en ella,y llegaron a abandonarla."
,"39":"Su templo quedó vacío como el desierto; sus fiestas se cambiaron en luto; sus sábados, en oprobio; su honor, en desprecio."
,"40":"Tan grande como su gloria fue su ignominia, y su grandeza se cambió en duelo."
,"41":"El rey publicó en todo su reino la orden de formar un solo pueblo,"
,"42":"renunciando cada uno a las costumbres propias. Todas las naciones acataron la orden del rey."
,"43":"Muchos israelitas aceptaron su culto, ofrecieron sacrificios a los ídolos y profanaron el sábado."
,"44":"El rey mandó emisarios a Jerusalén y a las ciudades de Judá con órdenes escritas para que aceptaran las costumbres extrañas a su país;"
,"45":"suprimieran los holocaustos, los sacrificios y las ofrendas del templo y profanaran el sábado y las fiestas;"
,"46":"contaminaran el templo y los lugares santos;"
,"47":"edificaran altares y templos a los ídolos y sacrificaran a los cerdos y animales inmundos;"
,"48":"dejaran sin circuncidar a sus hijos y se mancharan con toda clase de inmundicias y profanaciones,"
,"49":"de modo que se olvidaran de la ley y abandonaran todas sus prescripciones."
,"50":"El que no cumpliera las órdenes del rey sería castigado con la muerte."
,"51":"En este tenor el rey escribió a todo el reino, nombró inspectores sobre el pueblo y mandó que todas y cada una de las ciudades de Judá ofrecieran sacrificios."
,"52":"Muchos del pueblo, los que abandonaban la ley, se les unieron, cometieron tales crueldades en el país"
,"53":"y obligaron a los israelitas a esconderse en toda clase de refugio."
,"54":"El 15 del mes de quisleu del año 145, Antíoco levantó un ídolo repugnante sobre el altar de los holocaustos y edificó altares en todas las ciudades circunvecinas de Judá."
,"55":"En las puertas de las casas y en las plazas ofrecían incienso;"
,"56":"y destrozaban y quemaban los libros de la ley que encontraban."
,"57":"Al que se le encontraba el libro de la alianza, o al que observaba la ley, se le condenaba a muerte en virtud del decreto real."
,"58":"Abusando de la fuerza, se ensañaban con los israelitas que descubrían cada mes en las ciudades."
,"59":"El 25 del mes ofrecían sacrificios en el altar construido sobre el altar antiguo."
,"60":"A las mujeres que, contra el decreto, habían circuncidado a sus hijos las mataron"
,"61":"con los niños colgados al cuello; y lo mismo a los familiares y a los que habían realizado la circuncisión."
,"62":"A pesar de esto, muchos israelitas permanecieron firmes y resueltos a no comer alimentos inmundos."
,"63":"Prefirieron morir antes que contaminarse con tales alimentos, violando la alianza santa, y murieron."
,"64":"Fue terrible la ira desencadenada sobre Israel."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Por entonces Matatías, hijo de Juan, hijo de Simeón, sacerdote de la familia de Yoarib, abandonó Jerusalén y fue a establecerse en Modín."
,"2":"Tenía cinco hijos: Juan, llamado Gaddi;"
,"3":"Simón, llamado Tasi;"
,"4":"Judas, apellidado Macabeo;"
,"5":"Eleazar, apellidado Avarán, y Jonatán, apellidado Apfús."
,"6":"Matatías, al ver los sacrilegios que se cometían en Judá y Jerusalén,"
,"7":"exclamó: '¡Ay de mí! ¿He nacido para ver la ruina de mi pueblo y de la ciudad santa, y quedarme impávido mientras es entregada en manos de sus enemigos y su templo en poder de los extranjeros?"
,"8":"Su templo es como un hombre deshonrado;"
,"9":"sus objetos preciosos llevados como botín. Sus hijos muertos en las plazas, y sus jóvenes, pasados por la espada enemiga."
,"10":"¿Qué nación no ha invadido su reino,y no se ha adueñado de sus despojos?"
,"11":"De todo adorno ha sido despojada; de libre ha pasado a ser esclava."
,"12":"Nuestro templo, que era nuestra belleza,y nuestro orgullo, se ha cambiado en desierto, y ha sido por los gentiles profanado."
,"13":"¿Para qué vivir más?'."
,"14":"Mataías y sus hijos rasgaron sus vestiduras, se cubrieron de saco y lloraron amargamente."
,"15":"Entretanto, los emisarios del rey llegaron a Modín para promover la apostasía y obligar a ofrecer sacrificios."
,"16":"Muchos israelitas los seguían, pero Matatías y sus hijos se mantuvieron alejados."
,"17":"Entonces los emisarios del rey dijeron a Matatías: 'Tú eres en esta ciudad un célebre y poderoso jefe, secundado por hijos y familiares."
,"18":"Acércate el primero y cumple el mandato del rey, como lo han hecho los de Judá y los que han quedado en Jerusalén. Tú y los tuyos seríais honrados con la amistad del rey, y premiados con plata, oro y muchos regalos'."
,"19":"Matatías les respondió en voz bien alta: 'Aunque todas las naciones que constituyen el imperio siguieran al rey, abandonando la religión de sus padres y obedeciendo sus órdenes,"
,"20":"yo, mis hijos y mis familiares seguiremos la alianza de nuestros padres."
,"21":"No permita Dios que abandonemos la ley y las tradiciones."
,"22":"No oiremos las órdenes del rey y no nos apartaremos de la religión ni a la derecha ni a la izquierda'."
,"23":"Apenas terminó de decir estas palabras, se adelantó a la vista de todos un judío para ofrecer un sacrificio, según el mandato del rey."
,"24":"Matatías al verlo se llenó de celo y se estremecieron sus entrañas; y encendido en justa ira, se arrojó sobre él y lo mató sobre el altar."
,"25":"Al mismo tiempo mató al emisario del rey por obligar al pueblo a ofrecer sacrificios, y después destruyó el altar."
,"26":"Su celo por la ley fue semejante al de Fineés contra Zimrí, hijo de Salú."
,"27":"Matatías se puso luego a gritar en la ciudad: 'El que tenga celo por la ley y quiera mantener la alianza, que me siga'."
,"28":"Él y sus hijos huyeron a las montañas, dejando en la ciudad todo lo que tenían."
,"29":"Entonces muchos amantes de la justicia y del derecho se fueron al desierto,"
,"30":"donde se establecieron con sus hijos, mujeres y ganados, pues los males habían llegado al colmo."
,"31":"Refirieron a los ministros del rey y a las fuerzas estacionadas en Jerusalén, ciudad de David, que algunos hombres, transgresores de la orden del rey, se habían refugiado en el desierto."
,"32":"Muchos soldados los persiguieron y, cuando los encontraron, acamparon frente a ellos, dispuestos a atacarlos en día de sábado."
,"33":"Les dijeron: 'Si salís y cumplís la orden del rey, salvaréis la vida'."
,"34":"Respondieron: 'Ni saldremos ni cumpliremos la orden del rey de profanar el sábado'."
,"35":"Inmediatamente los atacaron."
,"36":"Pero ellos ni lanzaron piedras ni taponaron sus escondrijos."
,"37":"'Moriremos -decían-, pero el cielo y la tierra serán testigos de nuestra injusta muerte'."
,"38":"Los atacaron en pleno sábado, y perecieron ellos con sus mujeres, hijos y ganados, unas mil personas."
,"39":"Cuando lo supieron Matatías y los suyos, lloraron amargamente,"
,"40":"y se dijeron unos a otros: 'Si hacemos todos así y no luchamos contra los paganos, defendiendo nuestras vidas y nuestras tradiciones, pronto nos borrarán de la tierra'."
,"41":"Así que aquel día tomaron la siguiente determinación: 'Lucharemos contra todo el que nos presente batalla en día de sábado, para no morir como nuestros hermanos en sus escondrijos'."
,"42":"Entonces se unió a ellos el grupo de asideos, israelitas valientes y entusiastas defensores de la ley."
,"43":"Todos los que huían de aquellas desgracias se unieron a ellos, sirviéndoles de gran refuerzo."
,"44":"Así lograron formar un ejército poderoso, que comenzó a castigar en su ira y en su furor a los injustos y a los apóstatas. Éstos buscaban su salvación entre los gentiles."
,"45":"Matatías y los suyos hicieron incursiones y destruyeron altares."
,"46":"Obligaba a circuncidarse a cuantos encontraban incircuncisos en todo el territorio de Israel."
,"47":"Daban caza a los insolentes, y la empresa prosperaba bajo su dirección."
,"48":"Defendieron la ley contra naciones y reyes, y redujeron a impotencia a los pecadores."
,"49":"Llegada la hora de morir, dijo a sus hijos: 'Ahora es el reinado de la soberbia y del ultraje, el tiempo del desorden y de la ira rabiosa. "
,"50":"Por eso, hijos míos, tened celo por la ley y ofreced vuestra vida por la alianza de vuestros padres."
,"51":"Recordad las gestas de vuestros padres en su tiempo, y os granjearéis inmensa gloria y nombre eterno."
,"52":"Abrahán fue hallado fiel en la prueba, y se le apuntó como justicia."
,"53":"En el tiempo de su opresión, José observó la ley, y llegó a ser señor de Egipto."
,"54":"Fineés, nuestro padre, por tener ardiente celo recibió la promesa de un sacerdocio eterno."
,"55":"Josué, por la observancia de la ley, llegó a ser juez de Israel."
,"56":"Caleb, por dar testimonio en la asamblea, recibió la heredad en esta tierra."
,"57":"David, por su piedad, heredó el trono de un reino eterno."
,"58":"Elías, por su ardiente celo por la ley, fue arrebatado hasta el cielo."
,"59":"Ananías, Azarías y Misael, por haber tenido fe, fueron salvados del fuego."
,"60":"Daniel, por su rectitud fue librado de la boca de los leones."
,"61":"Considerad así, que, de generación en generación, los que esperan en él nunca perecen."
,"62":"No temáis nunca las amenazas del hombre pecador, porque su gloria es estiércol y gusanos."
,"63":"Se engríe hoy y mañana ya no existe, porque ha vuelto al polvo de donde vino y se esfumaron sus anhelos."
,"64":"Vosotros, hijos míos, tened valor y sed fuertes en la defensa de la ley, porque ella os cubrirá de gloria."
,"65":"Yo sé que Simón, vuestro hermano, es hombre de consejo; escuchadlo siempre, y él será vuestro padre."
,"66":"Judas Macabeo, valiente desde joven, será el jefe de vuestro ejército y quien dirija la guerra contra los gentiles."
,"67":"Vosotros ganad para vuestra causa a cuantos observan la ley y vengad a vuestro pueblo."
,"68":"Dad a los gentiles su merecido y observad los preceptos de la ley'."
,"69":"Después los bendijo y fue a reunirse con sus padres."
,"70":"Murió el año 146. Sus hijos lo enterraron en Modín, en el sepulcro de sus padres, y todo Israel le guardó gran luto."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Le sucedió su hijo Judas, apellidado Macabeo."
,"2":"Sus hermanos y los partidarios de su padre le apoyaron y lucharon con entusiasmo por Israel."
,"3":"Engrandeció el nombre de su pueblo, vistió la coraza como un gigante, y se ciñó las armas de la guerra. Emprendió muchas batallas,y defendió el campamento con su espada."
,"4":"En sus empresas parecía un león, como un cachorro que ruge ante su presa."
,"5":"Persiguió a los malvados en sus escondites,y quemó a los opresores del pueblo."
,"6":"Ante él, los malvados se llenaron de terror, los agentes de la maldad se estremecieron, y la liberación fue por él felizmente conseguida."
,"7":"Él amargó la vida a muchos reyes, y con sus hazañas alegró a Jacob. Su memoria será bendita para siempre."
,"8":"Recorrió las ciudades de Judá, exterminó a los malvados,y apartó de Israel la cólera divina."
,"9":"Su fama llegó hasta los confines de la tierra,y reunió a los que estaban a punto de ser exterminados."
,"10":"Apolonio movilizó a los gentiles y un poderoso refuerzo de samaritanos para luchar contra Israel."
,"11":"Apenas lo supo Judas, le salió al encuentro, lo venció y lo mató. Muchos fueron los heridos y los demás huyeron."
,"12":"Recogieron el botín, y Judas se quedó con la espada de Apolonio y la llevó siempre a la guerra."
,"13":"Serón, jefe del ejército sirio, al saber que Judas se había rodeado de numerosos seguidores, hombres leales y valientes, se dijo:"
,"14":"'Me haré famoso y adquiriré gloria en el reino luchando contra Judas y sus seguidores, que no hacen caso de la orden del rey'."
,"15":"Se puso en marcha con un numeroso ejército de hombres perversos para vengarse de los israelitas."
,"16":"Cuando llegaron cerca de la cuesta de Bejorón, le salió al encuentro Judas con sus hombres,"
,"17":"quienes, a la vista del numeroso ejército que avanzaba contra ellos, dijeron a Judas: '¿Cómo nosotros, tan pocos, podremos luchar contra una muchedumbre tan grande y tan poderosa? Estamos además extenuados, porque hoy estamos en ayunas'."
,"18":"Judas les respondió: 'Es fácil que muchos caigan en manos de pocos, y para el cielo es lo mismo salvar con muchos que con pocos;"
,"19":"porque en la guerra la victoria no está en la muchedumbre del ejército, pues la fuerza viene del cielo."
,"20":"Ellos vienen contra nosotros llenos de insolencia y de maldad, para llevarse nuestras mujeres y nuestros hijos y saquearnos."
,"21":"Nosotros luchamos por nuestras vidas y por nuestras leyes,"
,"22":"y él los aniquilará ante nosotros; no los temáis'."
,"23":"Apenas terminó de hablar, cayó inesperadamente sobre sus enemigos. Serón y su ejército fueron derrotados."
,"24":"Lo siguieron por la bajada de Bejorón hasta la llanura, cayendo cerca de ochocientos hombres y huyendo los demás al país de los filisteos."
,"25":"Judas y sus hermanos comenzaron a ser temidos, y el miedo se extendió entre las naciones limítrofes."
,"26":"Su fama llegó hasta el rey, y todos los pueblos hablaban de sus hazañas."
,"27":"Cuando el rey Antíoco se enteró de todo esto montó en cólera y mandó reclutar todas las fuerzas de su reino para formar un poderosísimo ejército."
,"28":"Abrió las arcas del tesoro y entregó a los soldados la paga de un año, diciéndoles que estuviesen preparados para cualquier eventualidad."
,"29":"Pero se dio cuenta de que el dinero faltaba en el tesoro y que los tributos de la provincia habían bajado debido a las discordias y daños que él había causado en el país al suprimir las leyes vigentes desde antiguo."
,"30":"Temió entonces no tener -ya le había sucedido otras veces- para los gastos y regalos que antes repartía generosamente, superando a los reyes anteriores."
,"31":"Llegó a preocuparse seriamente, y decidió personarse en Persia para cobrar los tributos de aquellas provincias y allegar dinero."
,"32":"Dejó a Lisias, hombre noble y de familia real, encargado de los asuntos de estado desde el río Éufrates hasta los confines de Egipto,"
,"33":"así como de la educación de su hijo Antíoco, hasta su vuelta."
,"34":"Le entregó la mitad de sus tropas con los elefantes y le informó sobre sus decisiones, y en particular con relación a los habitantes de Judá y Jerusalén,"
,"35":"contra quienes debía mandar el ejército para aplastar y destruir las fuerzas de Israel y las que quedaban en Jerusalén hasta borrar su memoria de aquel lugar,"
,"36":"instalar en todo su territorio gentes de otras naciones y repartirles por sorteo la tierra."
,"37":"El rey, con la otra mitad del ejército, salió de Antioquía, capital de su reino, el año 147; pasó el Éufrates y atravesó las provincias del norte."
,"38":"Lisias escogió entre los amigos del rey a Tolomeo, hijo de Dorimeno; a Nicanor y Gorgias, personajes influyentes;"
,"39":"los puso al frente de cuarenta mil soldados de infantería y de siete mil de caballería para que invadieran Judá y la devastaran, según la orden del rey."
,"40":"Partieron con sus tropas y acamparon en la llanura, cerca de Emaús."
,"41":"Los mercaderes del país, al conocer su llegada, se presentaron en el campamento con mucha plata, oro y criados para comprar como esclavos a los israelitas. Se le unieron también fuertes contingentes de Idumea y del territorio de los filisteos."
,"42":"Judas y sus hermanos vieron que se agravaba la situación y que las tropas acampaban en su territorio. Tuvieron también noticias de la orden del rey de arrasar totalmente al pueblo."
,"43":"Y se dijeron: 'Libremos a nuestro pueblo de la ruina, y luchemos por él y por el templo'."
,"44":"Convocaron la asamblea a fin de prepararse para la guerra, y para rezar y pedir a Dios piedad y misericordia."
,"45":"Jerusalén estaba despoblada como un desierto. Ninguno de sus hijos entraba o salía. El templo estaba profanado, extranjeros habitaban en la ciudadela, convertida en morada de gentiles. La alegría de Jacob ya no existía, ni la flauta ni la cítara se oían."
,"46":"Se juntaron y fueron a Mispá, frente a Jerusalén, pues Mispá había sido ya lugar de oración para Israel."
,"47":"Aquel día ayunaron y se vistieron de saco, se cubrieron de ceniza la cabeza y rasgaron sus vestiduras."
,"48":"Consultaron luego el libro de la ley para saber lo que los gentiles piden a las imágenes de sus ídolos."
,"49":"Llevaron también las vestiduras sacerdotales, las primicias y los diezmos y a los nazireos que habían terminado el tiempo de su voto."
,"50":"Clamaron al cielo, diciendo: '¿Qué haremos de éstos y dónde los dejaremos?"
,"51":"Tu templo ha sido pisoteado y profanado; tus sacerdotes están de luto y humillados;"
,"52":"y ahora los gentiles han venido para aniquilarnos. Tú sabes lo que traman contra nosotros."
,"53":"¿Cómo podremos resistirles si tú no nos ayudas?'."
,"54":"Tocaron las trompetas y clamaron a grandes gritos."
,"55":"Después Judas nombró jefes del pueblo: de mil, de cien, de cincuenta y de diez."
,"56":"A los que estaban construyendo su casa, a los recién casados, a los que estaban plantando viñas y a los que tuvieron miedo, les dijeron que se volvieran a sus casas, como permitía la ley."
,"57":"Se pusieron en marcha y acamparon al sur de Emaús."
,"58":"Judas habló así a los suyos: 'Ceñíos las armas, sed fuertes y disponeos a asaltar mañana a estas gentes reunidas contra nosotros para destruirnos a nosotros y al templo."
,"59":"Es mejor morir luchando que ver las calamidades de nuestra nación y de nuestro templo."
,"60":"Y que sea lo que Dios quiera'."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Gorgias tomó cinco mil soldados escogidos de infantería y mil de caballería, y se puso en marcha de noche"
,"2":"para caer sobre los judíos y atacarlos por sorpresa. Les hacían de guía los de la ciudadela."
,"3":"Judas lo supo, y se puso también en marcha con los más valientes para asaltar al ejército real, que estaba en Emaús,"
,"4":"mientras que sus efectivos estaban todavía dispersos."
,"5":"Gorgias llegó de noche al campamento de Judas; pero al no encontrar a nadie, se puso a buscarlos en los montes, pues decía: 'Huyen ante nosotros'."
,"6":"Al amanecer apareció Judas en la llanura con tres mil hombres, que no tenían ni los escudos ni las espadas que hubieran deseado."
,"7":"Al ver el campo de los gentiles, poderoso, bien defendido y rodeado de la caballería, con hombres expertos en la guerra,"
,"8":"Judas arengó a los suyos: 'No temáis el número ni os acobarden sus ataques."
,"9":"Recordad cómo nuestros padres fueron salvados en el mar Rojo cuando los perseguía el Faraón con su ejército."
,"10":"Clamemos al cielo; se compadecerá de nosotros, se acordará de la alianza hecha a nuestros padres y derrotará hoy a este ejército ante nosotros."
,"11":"Conocerán entonces todas las naciones que hay quien libra y salva a Israel'."
,"12":"Los extranjeros levantaron la mirada y, al ver que los judíos se dirigían contra ellos,"
,"13":"salieron del campamento para comenzar la batalla. Los de Judas tocaron las trompetas,"
,"14":"y se entabló el combate. Los gentiles, desconcertados, huyeron a la llanura;"
,"15":"los últimos murieron a espada. Los persiguieron hasta Gázara, los llanos de Idumea, de Asdod y de Yamnia. Cayeron cerca de tres mil enemigos."
,"16":"Cuando Judas con su ejército volvió de perseguirlos,"
,"17":"dijo al pueblo: 'No recojáis el botín, porque se prepara otra batalla."
,"18":"Gorgias está con su ejército en los montes cercanos. Manteneos firmes ante nuestros enemigos y luchad contra ellos; después recogeréis tranquilamente el botín'."
,"19":"No había terminado de hablar, cuando apareció una división explorando desde el monte."
,"20":"Observaron que los suyos habían huido y que el campamento estaba incendiado, pues el humo lo denunciaba."
,"21":"Tal visión los llenó de pánico. Al ver luego en la llanura al ejército de Judas dispuesto para la lucha,"
,"22":"huyeron todos al país de los filisteos."
,"23":"Entonces Judas se volvió para saquear el campamento, y los soldados se apoderaron de mucho oro, plata, telas de jacinto y púrpura marina y otras muchas riquezas."
,"24":"A la vuelta alababan y bendecían al cielo 'porque es bueno, porque es eterno su amor'."
,"25":"Aquel día consiguió Israel una gran victoria."
,"26":"Los extranjeros que se salvaron comunicaron lo sucedido a Lisias,"
,"27":"que quedó consternado y abatido, pues las cosas en Israel no le habían salido como él quería y como le había ordenado el rey."
,"28":"Al año siguiente, Lisias reclutó sesenta mil hombres de infantería y cinco mil de caballería para luchar contra los judíos."
,"29":"Llegaron a Idumea y acamparon cerca de Bet Sur. Judas les salió al encuentro con diez mil hombres."
,"30":"A la vista de un ejército tan temible, oró así: 'Bendito seas tú, oh Salvador de Israel, que quebrantaste la fortaleza de un gigante por medio de tu siervo David y entregaste el ejército de los filisteos a Jonatán, hijo de Saúl, y a su escudero."
,"31":"Haz que este ejército caiga en manos de tu pueblo Israel, que queden confundidos con su fuerza y con su caballería,"
,"32":"que cunda en ellos el pánico, deshaz el orgullo que tienen en su poder, que se confundan con su derrota."
,"33":"Derrótalos con la espada de los que te aman, y te alabarán con cánticos cuantos conocen tu nombre'."
,"34":"Entraron en batalla cinco mil hombres del ejército de Lisias."
,"35":"Lisias, al ver la huida de los suyos y el entusiasmo de los judíos, dispuestos a vivir o a morir como héroes, se volvió a Antioquía para reclutar mercenarios y volver a Judea con más fuerza que antes."
,"36":"Entonces Judas y sus hermanos dijeron: 'Ya que nuestros enemigos han sido vencidos, purifiquemos y consagremos de nuevo el templo'."
,"37":"Todo el ejército se reunió y fue al monte Sión."
,"38":"Cuando vieron el templo desierto, el altar profanado, quemadas las puertas, la hierba crecida en los atrios, como en el bosque o en los montes, y derruidas las habitaciones,"
,"39":"rasgaron sus vestiduras y se cubrieron de ceniza la cabeza."
,"40":"Se postraron rostro en tierra y, a la señal de las trompetas, lanzaron gritos al cielo."
,"41":"Judas ordenó a sus hombres atacar a los de la ciudadela mientras duraba la purificación del templo."
,"42":"Escogió sacerdotes sin mancha, observantes de la ley,"
,"43":"que purificaron el templo y llevaron las piedras contaminadas a un lugar inmundo."
,"44":"Deliberaron sobre el altar de los holocaustos, que había sido profanado, y"
,"45":"tuvieron la feliz idea de destruirlo para que no les sirviera de oprobio, pues los gentiles lo habían contaminado. Lo demolieron"
,"46":"y amontonaron las piedras en el monte del templo, en lugar conveniente, hasta que viniera un profeta y dijera lo que había que hacer con ellas."
,"47":"Tomaron piedras sin labrar, según la ley, y levantaron un altar igual que el primero."
,"48":"Repararon el santuario y el interior del templo, purificaron los atrios,"
,"49":"hicieron nuevos vasos sagrados, llevaron al templo el candelabro, el altar de los perfumes y la mesa."
,"50":"Quemaron incienso sobre el altar y encendieron las lámparas del candelabro, que iluminaron el interior del templo."
,"51":"Colocaron los panes sobre la mesa, colgaron las cortinas, y así dieron fin a los trabajos."
,"52":"El 25 del mes noveno, el de quisleu, del año 148, se levantaron al alba"
,"53":"y ofrecieron un sacrificio legal en el altar de los holocaustos que habían construido."
,"54":"El altar fue inaugurado al son de cítaras, liras y címbalos en el mismo mes y día en que fue profanado por los gentiles."
,"55":"Todo el pueblo se postró rostro en tierra; luego alabaron al que les había concedido el éxito,"
,"56":"y celebraron con alegría la dedicación del altar, ofreciendo durante ocho días holocaustos y sacrificios de acción de gracias."
,"57":"Adornaron la fachada del templo con coronas de oro y con escudos, restauraron las estradas y las habitaciones"
,"58":"y les pusieron puertas; y el pueblo se regocijó grandemente, olvidándose del oprobio que le habían causado los gentiles."
,"59":"Judas, sus hermanos y toda la asamblea de Israel acordaron festejar con alegría la dedicación del altar cada año, a su tiempo, durante ocho días, a partir del 25 de quisleu."
,"60":"Por entonces fortificaron también el monte Sión con murallas y fuertes torres, para que, si volvían los gentiles, no las pudieran destruir, como había sucedido."
,"61":"Judas emplazó allí una guarnición y fortificó Betsur para que el pueblo contara con una fortaleza contra Idumea."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Cuando los pueblos vecinos supieron que el altar había sido reconstruido y restaurado, como antes el templo, se irritaron grandemente"
,"2":"y decidieron exterminar a los israelitas que vivían entre ellos; así que comenzaron a matarlos y a destruirlos."
,"3":"Judas declaró entonces la guerra a los descendientes de Esaú en Idumea, en Acrabatene, porque asediaban a los israelitas. Les infligió una fuerte derrota, los humilló y se apoderó de su botín."
,"4":"Después recordó la malicia de la gente de Beán, que tendían lazos y emboscadas al pueblo en los caminos."
,"5":"Les obligó a encerrarse en sus torres, los bloqueó y condenó a muerte, incendiando las torres con todo lo que había dentro."
,"6":"Luego pasó a los amonitas, donde encontró un poderoso ejército y un pueblo numeroso a las órdenes de Timoteo."
,"7":"Los atacó varias veces, venciéndolos y haciéndoles grandes destrozos."
,"8":"Se apoderó de Yazer y sus aldeas, y se volvió a Judea."
,"9":"Los gentiles de Galaad se conjuraron contra los israelitas que vivían en su territorio para exterminarlos. Pero éstos se refugiaron en la fortaleza de Datema"
,"10":"y enviaron cartas a Judas y a sus hermanos en las que decían: 'Los gentiles que nos rodean se han conjurado contra nosotros para exterminarnos,"
,"11":"y se preparan para expugnar la fortaleza en la que estamos refugiados. Su jefe es Timoteo."
,"12":"Venid y libradnos de sus manos, pues muchos de los nuestros han caído ya."
,"13":"Han matado a todos nuestros hermanos que vivían en Tob, han sometido a esclavitud a sus mujeres y a sus hijos y se han llevado sus bienes: han muerto allí unos mil hombres'."
,"14":"No habían terminado de leer esta carta, cuando llegaron de Galilea otros emisarios con vestidos rotos, trayendo parecidas noticias"
,"15":"y diciendo: 'Los de Tolemaida, Tiro y Sidón se han conjurado contra nosotros, con toda la Galilea de los gentiles, para exterminarnos'."
,"16":"En cuanto Judas y el pueblo recibieron tales noticias, se convocó una gran asamblea para ver lo que podían hacer por sus hermanos que, atacados por los enemigos, se encontraban en grandes apuros."
,"17":"Judas dijo a su hermano Simón: 'Escoge hombres y ve a librar a tus hermanos en Galilea; yo y mi hermano Jonatán iremos a Galaad'."
,"18":"A José, hijo de Zacarías, y a Azarías, los dejó como jefes del pueblo, con el resto del ejército, para defender a Judea,"
,"19":"dándoles estas órdenes: 'Gobernad al pueblo, pero no ataquéis a los gentiles hasta que volvamos'."
,"20":"A Simón se le entregaron tres mil hombres para la campaña en Galilea; a Judas, ocho mil, para la de Galaad."
,"21":"Simón llegó a Galilea, donde presentó varias batallas a los gentiles, que fueron derrotados."
,"22":"Los persiguió hasta las puertas de Tolemaida; cayeron unos tres mil hombres, y él se apoderó de sus bienes."
,"23":"Tomó después consigo a los judíos de Galilea y Arbata con sus mujeres, hijos y todo lo que tenían, y los llevó con gozo a Judea."
,"24":"Entretanto Judas Macabeo y su hermano Jonatán pasaron el Jordán y caminaron por el desierto durante tres días."
,"25":"Les salieron al encuentro los nabateos, que los recibieron amistosamente y les narraron lo sucedido a los hebreos en Galaad,"
,"26":"y cómo muchos estaban prisioneros en Bosora, Bosor, Alema, Casfo, Maqued y Carnayín, todas ellas ciudades grandes y fortificadas."
,"27":"Refirieron también que había prisioneros en otras ciudades de Galaad y que habían decidido asaltar al día siguiente las fortalezas, tomarlas y exterminarlos a todos en un solo día."
,"28":"Entonces Judas partió con su ejército hacia el desierto de Bosora, ocupó las ciudades, pasó a espada a todos los varones, se apoderó del botín y luego las incendió."
,"29":"De noche partieron hacia las fortalezas."
,"30":"Al alborear, vieron una inmensa muchedumbre con escaleras y máquinas para apoderarse de las fortalezas. Ya se atacaba a los sitiados."
,"31":"Judas, viendo que el asalto había comenzado y que el fragor de la batalla, unido al son de las trompetas, llegaba al cielo,"
,"32":"dijo a los suyos: 'Luchad hoy por vuestros hermanos'."
,"33":"Después ordenó en tres grupos el avance hacia el enemigo por la espalda, tocando las trompetas y rezando a gritos."
,"34":"Cuando el ejército de Timoteo supo que estaba allí el Macabeo, huyeron ante él; sufrieron una gran derrota, pues aquel día murieron unos ocho mil hombres."
,"35":"Judas de allí pasó a Alema. La asaltó, la ocupó, mató a todos los varones, se apoderó del botín y luego la incendió."
,"36":"Salió de allí y se apoderó de Casfo, Maqued y Bosor, con las demás ciudades de Galaad."
,"37":"Después de estos acontecimientos, Timoteo reunió otro ejército y acampó frente a Rafón, al otro lado del torrente."
,"38":"Judas mandó a explorar el campo, y le dijeron: 'Todos los gentiles que nos rodean se le han unido, formando un ejército enorme."
,"39":"Además tienen mercenarios árabes como fuerzas auxiliares y están acampados al otro lado del torrente, dispuestos a atacarte'. Judas fue a su encuentro."
,"40":"Cuando Judas con su ejército se acercaba al torrente, Timoteo dijo a los jefes de su ejército: 'Si pasa él primero hacia nosotros, no podremos resistirle, porque nos sacarán ventaja;"
,"41":"si, por el contrario, tiene miedo y acampa al otro lado, iremos contra él y lo venceremos'."
,"42":"Judas llegó al torrente, dispuso a lo largo de él a los escribas del pueblo y les ordenó: 'No permitáis que nadie se pare, sino que todos vayan a luchar'."
,"43":"Él pasó el primero hacia los enemigos, seguido de todo el pueblo. Ante él los gentiles se replegaron, tiraron sus armas y huyeron al templo de Carnayín."
,"44":"Los judíos ocuparon la ciudad e incendiaron el templo con todos los que había dentro. Carnayín fue conquistada sin poder resistir a Judas."
,"45":"Después de esto Judas reunió a todos los israelitas que se encontraban en Galaad, chicos y grandes, con sus mujeres, hijos y equipajes, enorme muchedumbre, para volver a Judea."
,"46":"Llegaron a Efrón, ciudad importante y bien fortificada, situada en el camino. No era posible desviarse ni a derecha ni a izquierda, sino que había que atravesarla."
,"47":"Los de la ciudad cerraron la entrada, tapiando las puertas con piedras."
,"48":"Judas les envió este mensaje de paz: 'Permitidnos atravesar vuestro territorio para volver al nuestro; nadie os hará mal, pues no haremos más que pasar a pie'. Pero no quisieron abrir."
,"49":"Judas entonces ordenó que todos se mantuvieran donde estaban."
,"50":"Los más valientes se prepararon para el asalto; atacaron la ciudad durante todo el día y toda la noche hasta que se rindió."
,"51":"Pasó a espada a los varones, arrasó la ciudad, se apoderó del botín y pasó por encima de los cadáveres."
,"52":"Atravesaron el Jordán y llegaron a la gran llanura de Betsán."
,"53":"Durante el viaje, Judas atendía a los retrasados y animaba al pueblo hasta llegar a Judá."
,"54":"Con gozo y alegría subieron al monte Sión y ofrecieron holocaustos por haber vuelto felizmente y sin bajas."
,"55":"Mientras Judas y Jonatán estaban en Galaad y su hermano Simón en Galilea, frente a Tolemaida,"
,"56":"José, hijo de Zacarías, y Azarías, jefes del ejército, conociendo sus hazañas y batallas victoriosas,"
,"57":"se dijeron: 'Hagámonos también famosos luchando contra los gentiles que nos rodean'."
,"58":"Comunicaron las órdenes a su ejército y marcharon hacia Yamnia."
,"59":"Pero les salió al encuentro Gorgias con su gente para atacarlos."
,"60":"José y Azarías fueron derrotados y perseguidos hasta los límites de Judá. Aquel día cayeron dos mil hombres de Israel."
,"61":"Grave derrota de los israelitas por no haber escuchado a Judas y a sus hermanos, creyéndose capaces de grandes hazañas."
,"62":"No eran éstos de aquella raza de hombres por los que vino la salvación de Israel."
,"63":"Judas y sus hermanos, por el contrario, se hicieron famosos en Israel y en las naciones a donde llegaba su nombre."
,"64":"El pueblo los rodeaba y los aclamaba."
,"65":"Judas, con sus hermanos, se puso en marcha para luchar contra los descendientes de Esaú en la región meridional. Tomó Hebrón y sus aldeas, derribó sus fortificaciones e incendió las torres de sus murallas."
,"66":"Después levantó el campamento para dirigirse al país de los filisteos, pasando por Maresá."
,"67":"Algunos sacerdotes cayeron aquel día, pues, queriendo hacerse los valientes, entraron imprudentemente en batalla."
,"68":"Judas de allí pasó a Asdod, en el país de los filisteos; derribó sus altares, incendió las estatuas de sus dioses, saqueó la ciudad y luego se volvió a Judá."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Mientras el rey Antíoco recorría las provincias del norte, supo que Elimaida, en Persia, era una ciudad famosa por la abundancia de oro y plata;"
,"2":"que había un templo riquísimo con piezas de armadura de oro, coraza y armas dejadas por Alejandro, hijo de Filipo, rey de Macedonia, primer rey de Grecia."
,"3":"Fue allá, e intentó apoderarse de la ciudad; pero no lo consiguió porque sus habitantes conocieron su intención y"
,"4":"salieron armados contra él; tuvo que huir, alejándose con inmensa tristeza, para volver a Babilonia."
,"5":"Estando todavía en Persia le comunicaron las derrotas de los ejércitos enviados a Judea;"
,"6":"que Lisias, aunque había ido con un ejército poderosísimo, tuvo que huir ante los judíos, que se habían fortalecido con las armas y abundante botín apresados a los ejércitos vencidos;"
,"7":"que habían destruido el ídolo repugnante levantado por él sobre el altar de Jerusalén y habían rodeado de altas murallas, como antes, el templo y Betsur, una de sus ciudades."
,"8":"Estas noticias le afectaron profundamente, hasta el punto que cayó enfermo en cama de tristeza por no haber realizado sus propósitos."
,"9":"Así estuvo muchos días, en estado de profunda angustia. Creyendo que iba a morir,"
,"10":"llamó a sus amigos y les dijo: 'El sueño ha huido de mis ojos, y la angustia me agobia el corazón."
,"11":"Y me digo: ¡A qué tribulaciones he llegado y en qué mar de tristezas me encuentro yo, que era feliz y amado en los días de mi poder!"
,"12":"Pasan ahora por mi mente los crímenes cometidos en Jerusalén, los objetos de plata y oro que quité, los habitantes de Judea que exterminé sin motivo."
,"13":"Ahora reconozco que por esto me han venido estas desgracias y que muero de pena en tierra extraña'."
,"14":"Llamó a Filipo, uno de sus amigos, y lo nombró jefe de todo su reino;"
,"15":"le dio su corona, el mando y el anillo, con el encargo de educar a su hijo Antíoco y prepararlo para el gobierno."
,"16":"Atíoco murió allí el año 149."
,"17":"Lisias, al enterarse de la muerte del rey, proclamó rey a su hijo Antíoco, a quien había educado desde niño, y le apellidó Eupator."
,"18":"Los de la ciudadela tenían bloqueados a los israelitas en torno al templo y trataban continuamente de hacerles daño y apoyar a los gentiles."
,"19":"Judas decidió acabar con ellos, y convocó a todo el pueblo para sitiarlos."
,"20":"Se reunieron, y comenzaron el asedio el año 150, con ballestas y máquinas de guerra."
,"21":"Pero algunos asediados rompieron el cerco, se juntaron con unos israelitas renegados"
,"22":"y fueron a decir al rey: '¿Cuándo irás a hacer justicia y a vengar a nuestros hermanos?"
,"23":"Nosotros aceptamos servir a tu padre, obedecer sus órdenes y observar sus leyes."
,"24":"Por esto nos han odiado los de nuestro pueblo, han matado a cuantos de nosotros han encontrado y nos han quitado nuestros bienes."
,"25":"Y no sólo han puesto su mano sobre nosotros, sino también sobre los países limítrofes."
,"26":"Han sitiado la ciudadela de Jerusalén para conquistarla, y han fortificado el templo y Betsur."
,"27":"Si no te apresuras a detenerlos, harán cosas peores y no podrás frenarlos'."
,"28":"Al oír esto el rey montó en cólera y reunió a sus amigos, los jefes del ejército y los capitanes de caballería."
,"29":"Llegaron de otros reinos y de las islas del mar tropas mercenarias,"
,"30":"juntando un ejército de cien mil soldados de infantería, veinte mil de caballería y treinta y dos elefantes adiestrados para la guerra."
,"31":"Atravesaron Idumea, acamparon junto a Betsur y la asaltaron durante muchos días con máquinas de guerra; pero los sitiados salieron y quemaron las máquinas, luchando heroicamente."
,"32":"Entonces Judas se alejó de la ciudadela y acampó en Bet Zacaría, frente al campamento del rey."
,"33":"El rey se levantó temprano, y mandó a su ejército avanzar rápidamente hacia Bet Zacaría, donde sus tropas se pusieron en orden de batalla al toque de las trompetas."
,"34":"Los soldados emborracharon a los elefantes con zumo de uvas y moras para excitarlos en la lucha."
,"35":"Repartieron los animales entre los batallones, poniendo con cada elefante mil hombres con corazas de malla y yelmos de bronce en la cabeza; quinientos jinetes escogidos"
,"36":"precedían todos los movimientos de la bestia y la acompañaban a todas partes sin alejarse jamás de ella."
,"37":"Sobre cada elefante, como defensa, iba montada una torre sólida de madera, bien protegida y sujeta con cinchas; y en cada torre tres hombres valientes, además del indio que lo guiaba."
,"38":"El rey dispuso el resto de la caballería en los dos flancos del ejército para provocar el temor y proteger a los batallones."
,"39":"Cuando el sol se reflejó en los escudos de oro y bronce, resplandecieron las montañas y brillaron como llamas de fuego."
,"40":"Una parte del ejército del rey se desplegó en las cumbres de las montañas; otra en la llanura, avanzando todos con seguridad y orden."
,"41":"Cuantos oían el clamor de aquella muchedumbre, la marcha de tanta gente y el ruido de las armas quedaban aterrorizados: era verdaderamente un ejército numeroso y temible."
,"42":"Judas se acercó con su ejército y atacó; cayeron seis mil hombres del ejército real."
,"43":"Eleazar, apellidado Avarán, observó que un elefante, engualdrapado con coraza regia, sobresalía de los demás; y suponiendo que el rey estaría montado en él,"
,"44":"se propuso salvar a su pueblo y conquistar fama inmortal."
,"45":"Corrió con arrojo hacia el elefante por en medio del batallón, matando a derecha e izquierda y consiguiendo que todos se apartasen de él."
,"46":"Se puso bajo el elefante, le clavó la espada y lo mató. El elefante cayó encima de él, y murió."
,"47":"Pero los judíos, al ver las fuerzas del rey y el valor de su ejército, se retiraron."
,"48":"El ejército real los persiguió hasta Jerusalén, acampó en Judea y sitió el monte Sión;"
,"49":"hizo las paces con los de Betsur, que salieron de la ciudad, pues no tenían víveres para mantener el asedio por ser año sabático para la tierra."
,"50":"El rey se apoderó así de Betsur y puso una guarnición para custodiarla."
,"51":"Durante muchos días acampó ante el templo y allí colocó ballestas, máquinas de guerra, lanzafuegos, catapultas, escorpiones para lanzar flechas y hondas."
,"52":"Los sitiados también construyeron máquinas contra las de los sitiadores y lucharon largo tiempo."
,"53":"Pero carecían de víveres en los almacenes por ser el año séptimo y porque los israelitas llegados a Judea de los países paganos habían consumido las reservas."
,"54":"Quedaron pocos hombres en el templo, pues había ya mucha hambre; los otros se fueron cada uno a su casa."
,"55":"Entretanto, Filipo, a quien el rey Antíoco había confiado en vida la educación de su hijo Antíoco para prepararlo para gobernar,"
,"56":"había vuelto de Persia y Media con el ejército que había acompañado al rey, e intentaba hacerse con las riendas del gobierno."
,"57":"Lisias, al enterarse de esto, decidió partir rápidamente, y dijo al rey, a los generales del ejército y a los soldados: 'Cada día venimos a menos, escasean los víveres, el lugar que sitiamos está fuertemente defendido, y tenemos la obligación de ocuparnos de los problemas del reino."
,"58":"Hagamos la paz con estos hombres y un pacto con su nación."
,"59":"Dejémosles que vivan según sus costumbres como antes, pues se han enfurecido contra nosotros y han hecho todo esto porque nosotros hemos abolido sus leyes'."
,"60":"Esto agradó al rey y a los jefes, y el rey envió a tratar la paz con los judíos, quienes la aceptaron."
,"61":"El rey y los jefes confirmaron el tratado con juramento, y los judíos salieron de la fortaleza."
,"62":"El rey subió al monte Sión y, al ver las fortificaciones, rompió el juramento y mandó destruir el muro que lo cercaba."
,"63":"Luego partió aprisa y volvió a Antioquía, donde encontró a Filipo dueño de la ciudad. Luchó contra él, y se apoderó de la ciudad por la fuerza."
}`)
	CurrentBook.AddChapter(7, `{
"1":"El año 151 Demetrio, hijo de Seleuco, huyó de Roma y llegó con unos cuantos hombres a una ciudad marítima, donde se proclamó rey."
,"2":"Cuando avanzaba hacia Antioquía, residencia real de sus padres, el ejército hizo prisioneros a Antíoco y Lisias para entregárselos."
,"3":"Demetrio, al saberlo, dijo: 'No quiero ni verlos'."
,"4":"Los soldados los mataron, y Demetrio se sentó en el trono de su reino."
,"5":"Todos los israelitas, criminales y renegados, con Alcimo a la cabeza, el cual quería ser sumo sacerdote, se presentaron ante el rey"
,"6":"y acusaron a su propio pueblo: 'Judas y sus hermanos han exterminado a todos sus amigos y nos han echado de nuestro país."
,"7":"Manda a alguien de tu confianza para que compruebe las ruinas que han causado en nuestro país y en las provincias del rey, y que los castigue a ellos y a sus partidarios'."
,"8":"El rey eligió a Báquides, uno de sus amigos, comandante de la región occidental del Éufrates y uno de los grandes del reino, fiel al rey."
,"9":"Lo mandó con el pérfido Alcimo, al que hizo sumo sacerdote, con la misión de vengarse de los israelitas."
,"10":"Partieron con un ejército numeroso, llegaron a Judea y enviaron mensajeros a Judas y a sus hermanos con falsas propuestas de paz."
,"11":"Pero éstos no se fiaron de sus palabras, al saber que habían llegado con un ejército numeroso."
,"12":"No obstante, una comisión de escribas se presentó a Alcimo y a Báquides para tratar de encontrar una solución satisfactoria."
,"13":"Los asideos fueron los primeros entre los israelitas en pedir la paz,"
,"14":"pues decían: 'Un sacerdote de la estirpe de Aarón viene con el ejército; él no nos hará mal'."
,"15":"Báquides les dirigió palabras de paz y prometió con juramento: 'No trataremos mal ni a vosotros ni a vuestros amigos'."
,"16":"Ellos le creyeron; pero arrestó a sesenta hombres y los ejecutó en el mismo día, según la palabra de la Escritura:"
,"17":"'En torno a Jerusalén han esparcido las carnes de tus santos y su sangre, y no había quien los sepultara'."
,"18":"El pueblo entero se llenó de temor y espanto, y decía: 'No hay en ellos ni verdad ni justicia, pues han quebrantado el pacto y el juramento prestado'."
,"19":"Báquides se alejó de Jerusalén y acampó en Bet Zet; prendió a muchos que se habían separado de él y a algunos del pueblo, a los que mandó ejecutar y arrojar en un pozo profundo."
,"20":"Luego confió el país a Alcimo, le dejó tropas de apoyo y se volvió adonde el rey."
,"21":"Alcimo luchaba por asegurarse el sumo sacerdocio."
,"22":"Lo seguían todos los perturbadores del pueblo. Se apoderaron de Judea y causaron grandes males a Israel."
,"23":"Judas, viendo que todo el mal que Alcimo y los suyos hacían a los israelitas era mayor que el de los mismos paganos,"
,"24":"recorrió todo el territorio de Judea y sus alrededores y se vengó de aquellos traidores, impidiéndoles realizar correrías por el país."
,"25":"Cuando Alcimo comprendió que Judas y los suyos le superaban en fuerza y que no podía oponerse a ellos, se volvió al rey y los acusó de muchos delitos."
,"26":"El rey mandó a Nicanor, uno de sus más ilustres generales y enemigo declarado de Israel, con la misión de destruir al pueblo."
,"27":"Nicanor llegó a Jerusalén con un ejército numeroso, y envió mensajeros a Judas y a sus hermanos con falsas propuestas de paz:"
,"28":"'No haya guerra entre vosotros y yo; llegaré a vosotros con pocos hombres para tratar como amigos'."
,"29":"Se presentó a Judas y se saludaron cortésmente, pero los enemigos estaban preparados para apoderarse de Judas."
,"30":"Judas se dio cuenta de que había llegado con engaño, tuvo miedo y no quiso verlo más."
,"31":"Nicanor comprendió que su plan había sido descubierto y fue a luchar contra Judas en Cafarsalán."
,"32":"Cayeron cerca de quinientos hombres de los de Nicanor, y el resto huyó a la ciudad de David."
,"33":"Después de este suceso, Nicanor subió al monte Sión, y algunos sacerdotes salieron del templo para saludarlo amistosamente y mostrarle el sacrificio que ofrecían por el rey."
,"34":"Pero él se burló de ellos, los despreció, los escupió y les habló con arrogancia,"
,"35":"jurando lleno de rabia: 'Si Judas y sus hombres no se entregan en mis manos, quemaré este edificio al volver victorioso'. Y se marchó furioso."
,"36":"Los sacerdotes entraron y, de pie ante el altar del templo y entre sollozos, dijeron:"
,"37":"'Tú elegiste esta casa para que en ella fuera invocado tu nombre, para que fuera casa de oración y súplica para tu pueblo."
,"38":"Castiga a este hombre y a su ejército; caigan a espada. Acuérdate de sus blasfemias, y no les dejes vivir'."
,"39":"Nicanor abandonó Jerusalén y acampó en Bejorón, donde se le unió el ejército de Siria."
,"40":"Por su parte, Judas acampó en Adasa con tres mil hombres, y rezó así:"
,"41":"'Cuando los mensajeros del rey blasfemaban, vino tu ángel y mató ciento ochenta y cinco mil asirios."
,"42":"Así hoy extermina a este ejército que está ante nosotros, para que sepan los supervivientes que ha hablado inicuamente contra tu templo. Júzgalo según su perversidad'."
,"43":"El 13 del mes de adar se enfrentaron los dos ejércitos. Fue derrotado el de Nicanor, quien cayó el primero en el combate."
,"44":"Cuando el ejército vio muerto a Nicanor, arrojó las armas y huyó."
,"45":"Los judíos los siguieron durante un día desde Adasa hasta Gazara, tocando detrás de ellos las trompetas."
,"46":"La gente salía de todas las aldeas de Judea y cercaba a los fugitivos, obligándolos a volverse unos contra otros. Así cayeron todos a espada, sin quedar ni uno solo."
,"47":"Los vencedores se apoderaron del botín de guerra, cortaron la cabeza de Nicanor y la mano derecha que él había levantado con orgullo, y la colgaron en Jerusalén a la vista de todos."
,"48":"El pueblo, loco de contento, pasó aquel día con gran regocijo."
,"49":"Se acordó celebrar solemnemente cada año este día, el 13 del mes de adar."
,"50":"El país de Judea gozó de paz durante algún tiempo."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Judas supo que los romanos eran poderosos, que se mostraban benévolos con sus aliados y hacían pactos de amistad con los que acudían a ellos."
,"2":"Le contaron sus guerras, las hazañas realizadas en las Galias, cómo se habían apoderado de ellas y las habían sometido a tributo;"
,"3":"lo que habían hecho en España, cómo se habían apoderado de las minas de plata y oro,"
,"4":"y cómo habían sometido a aquel país con prudencia y perseverancia, a pesar de ser un país lejano; cómo habían derrotado a los reyes que los habían atacado desde los confines de la tierra, infligiéndoles fuerte derrota, y cómo los demás les pagaban un tributo anual."
,"5":"Habían vencido y sometido a Filipo y a Perseo, reyes de Macedonia, y a cuantos les habían hecho frente."
,"6":"Habían vencido a Antíoco el Grande, rey de Asia, que les presentó batalla con ciento veinte elefantes, caballería y carros y un ejército incontable."
,"7":"Cayó vivo en sus manos, y le impusieron a él y a sus sucesores un impuesto gravoso, dar rehenes y ceder territorios,"
,"8":"como la India, Media y Lidia, sus mejores provincias, que luego entregaron al rey Eumeno."
,"9":"Los griegos habían decidido ir a exterminarlos;"
,"10":"pero los romanos se enteraron y enviaron a luchar contra ellos a un solo general; cayeron muchos griegos, y los romanos se llevaron cautivas a sus mujeres y a sus hijos, saquearon sus bienes, se apoderaron de sus tierras, derribaron sus murallas y los sometieron a esclavitud hasta el día de hoy."
,"11":"Asimismo destruyeron y sometieron a los reinos e islas que les opusieron resistencia."
,"12":"Pero a sus amigos y a cuantos en ellos confiaban les guardaban gran fidelidad. Han conquistado reinos próximos y lejanos, y todos los que oyen hablar de ellos les tienen miedo."
,"13":"Reinan aquellos a los que ellos ayudan a reinar y deponen a los que quieren. Tienen un inmenso poder."
,"14":"A pesar de esto, ninguno de ellos se ha hecho coronar ni ha vestido la púrpura para engrandecerse."
,"15":"Han constituido un senado, donde deliberan cada día trescientos veinte hombres, que se preocupan del bien del pueblo y del mantenimiento del orden."
,"16":"Eligen cada año a uno con poder y dominio en todo el imperio, y le obedecen todos sin que tengan envidias o celos."
,"17":"Judas eligió a Eupólemo, hijo de Juan, hijo de Acos, y a Jasón, hijo de Eleazar, y los envió a Roma para hacer con ellos un tratado de amistad"
,"18":"y conseguir la libertad del yugo de los griegos, pues éstos querían esclavizar a Israel."
,"19":"Fueron a Roma. Después de un viaje muy largo, entraron en el senado y dijeron:"
,"20":"'Judas Macabeo, sus hermanos y el pueblo de los judíos nos han mandado para hacer con vosotros un tratado de amistad y para ser contados entre vuestros aliados y amigos'."
,"21":"La petición fue acogida favorablemente."
,"22":"He aquí la copia de la carta que esculpieron en tablas de bronce y enviaron a Jerusalén para que sirviese a los judíos como documento de tratado de paz:"
,"23":"'Prosperidad a los romanos y a la nación judía en el mar y en la tierra para siempre. Lejos esté de ellos la espada y el enemigo."
,"24":"Si estalla una guerra contra Roma o contra cualquiera de sus aliados en todo su imperio,"
,"25":"la nación judía combatirá ardientemente a su lado, según lo permitan las circunstancias."
,"26":"No dará ni suministrará al enemigo trigo, ni armas, ni dinero o naves, según ha decidido Roma, y cumplirá estos compromisos sin compensación alguna."
,"27":"Igualmente, si la nación judía fuera atacada antes, los romanos lucharemos a su lado con todo ardor, según lo permitan las circunstancias,"
,"28":"y no darán a los enemigos trigo, ni armas, ni dinero o naves según ha decidido Roma; y cumplirá estos compromisos sin engaños."
,"29":"En estos términos hacen los romanos su tratado con la nación judía."
,"30":"Si posteriormente unos u otros quisieran añadir o quitar algo, lo harán de común acuerdo, y lo añadido o lo quitado tendrá carácter obligatorio."
,"31":"Con relación a los daños causados por Demetrio a los judíos, le hemos escrito así: ¿Por qué mantienes tan pesado yugo sobre los judíos, nuestros amigos y aliados?"
,"32":"Si vuelven a acusarte, defenderemos sus derechos luchando contra ti por mar y tierra'."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Demetrio, al enterarse de la muerte de Nicanor y de la derrota de su ejército, decidió mandar a Judea otra vez a Báquides y Alcimo como jefes del ala derecha de su ejército."
,"2":"Éstos tomaron el camino de Galilea y acamparon en Mesalot de Arbela, se apoderaron de ella y mataron a muchos de sus habitantes."
,"3":"En el primer mes del año 152 acamparon frente a Jerusalén;"
,"4":"y veinte mil hombres de infantería y dos mil de caballería se dirigieron a Berea."
,"5":"Judas tenía su campamento en Elasa con tres mil hombres selectos."
,"6":"Pero cuando los suyos vieron a aquel gran número de enemigos, se llenaron de miedo y muchos huyeron del campo, quedando sólo ochocientos hombres."
,"7":"Judas, viendo la dispersión de su ejército cuando era inminente la lucha, se sintió profundamente apenado, pues no tenía tiempo para volverlos a juntar."
,"8":"Desalentado, habló a los que quedaban: '¡Luchemos contra nuestros enemigos; quizá podamos vencerlos!'."
,"9":"Ellos le respondieron: 'No podremos; ahora tratemos de salvarnos; volveremos más tarde con nuestros hermanos, y entonces lucharemos; ahora somos demasiado pocos'."
,"10":"Pero Judas les contestó: 'Jamás haré semejante cosa: huir delante de ellos. Si ha llegado nuestra hora, muramos valientemente por nuestros hermanos sin manchar nuestra gloria'."
,"11":"El ejército enemigo salió del campo y le hizo frente con la caballería dividida en dos alas; los hombres y los arqueros, todos valientes, avanzaban a la cabeza del ejército como fuerza de choque. Báquides iba en el ala derecha."
,"12":"El ejército, dividido en dos partes, avanzaba al sonido de las trompetas."
,"13":"La tierra temblaba por el estruendo de los ejércitos. El combate se entabló a la mañana y duró hasta la tarde."
,"14":"Judas se dio cuenta de que Báquides y la parte más fuerte del ejército estaban en la derecha, y, juntándose con los más decididos,"
,"15":"derrotó el ala derecha y la persiguió hasta los montes de Azara."
,"16":"Los del ala izquierda, viendo la derrota del ala derecha, siguieron por la espalda a Judas y a los suyos."
,"17":"Fue una lucha encarnizada, cayendo muchos de una y otra parte."
,"18":"También cayó Judas; los demás huyeron."
,"19":"Jonatán y Simón recogieron a su hermano y lo enterraron en la tumba de sus padres, en Modín."
,"20":"Todo el pueblo de Israel le guardó luto y lo lloró durante mucho tiempo, repitiendo la lamentación:"
,"21":"'¡Cómo ha caído el héroe, el salvador de Israel!'."
,"22":"El resto de la historia de Judas, sus guerras, las hazañas por él realizadas y sus timbres de gloria no han sido escritos; son demasiado numerosos."
,"23":"Después de la muerte de Judas aparecieron de nuevo los criminales en todo el territorio de Israel y levantaron la cabeza los autores de la iniquidad."
,"24":"Hubo por entonces una gran carestía, hasta el punto de parecer que la tierra se puso de su parte."
,"25":"Entonces Báquides escogió hombres malvados para gobernar el país."
,"26":"Éstos hacían averiguaciones y pesquisas para descubrir a los amigos de Judas, llevándolos luego a Báquides, que los castigaba y se burlaba de ellos."
,"27":"Hubo una opresión tal en Israel como no se había conocido desde que no había profetas."
,"28":"Los amigos de Judas se reunieron y dijeron a Jonatán:"
,"29":"'Desde la muerte de tu hermano Judas, no ha surgido nadie semejante a él, capaz de enfrentarse a nuestros enemigos, a Báquides y a cuantos odian nuestra nación."
,"30":"Te elegimos a ti para ocupar su puesto como nuestro jefe y guía en la batalla emprendida'."
,"31":"Jonatán tomó el mando y sucedió a su hermano Judas."
,"32":"Báquides lo supo y trató de matarlo."
,"33":"Jonatán, su hermano Simón y los que lo acompañaban se enteraron, huyeron al desierto de Técoa y acamparon junto a la cisterna de Asfar."
,"34":"Informaron de esto a Báquides en día de sábado, y él y su ejército atravesaron rápidamente el Jordán."
,"35":"Jonatán envió a su hermano, que iba al frente de la comitiva, a rogar a sus amigos los nabateos que les permitieran dejarles en depósito todo el bagaje, que era mucho."
,"36":"Pero los descendientes de Jambrí salieron de Madaba, capturaron a Juan con todo el bagaje y se fueron con ello."
,"37":"Después de esto anunciaron a Jonatán y a Simón, su hermano, que los descendientes de Jambrí estaban celebrando una boda solemne y que llevaban desde Madaba, con gran pompa, a la novia, hija de uno de los más ilustres personajes de Canaán."
,"38":"Entonces se acordaron de su hermano Juan y se escondieron en el recodo del monte."
,"39":"Levantaron la vista y vieron, en medio de un rumor confuso, un cortejo numeroso, el esposo, sus amigos y hermanos, que avanzaban hacia ellos con tamboriles, instrumentos musicales y rica armadura."
,"40":"Los judíos salieron de su escondite, se precipitaron sobre ellos y los mataron. Hubo muchas víctimas; otros huyeron al monte; ellos se apoderaron de todo lo que llevaban."
,"41":"Así la boda se convirtió en luto y el alegre son de la música en lamentaciones."
,"42":"Se vengaron de su hermano y se volvieron a la ribera pantanosa del Jordán."
,"43":"Báquides se enteró de esto y llegó en día de sábado a las riberas del Jordán."
,"44":"Jonatán entonces habló así a los suyos: '¡Ánimo! Luchemos por nuestras vidas, pues hoy no es como ayer o anteayer."
,"45":"Tenemos al enemigo delante y a nuestra espalda; aquí y allí están las aguas del Jordán, terreno pantanoso, bosque; no hay salida."
,"46":"Clamad, pues, al cielo para que nos libre de nuestros enemigos'."
,"47":"Se trabó la batalla, y Jonatán alargó la mano para herir a Báquides, pero éste le esquivó echándose hacia atrás."
,"48":"Entonces Jonatán y los suyos salvaron el Jordán atravesándolo a nado; sus enemigos no los siguieron."
,"49":"Aquel día cayeron unos mil hombres de Báquides."
,"50":"Báquides volvió a Jerusalén y se puso a construir plazas fuertes en Judea, las fortalezas de Jericó, Emaús, Bejorón, Betel, Tamnata, Faratón y Tefón, con altas murallas y puertas con cerrojos,"
,"51":"dejando en cada una una guarnición para hostigar a Israel."
,"52":"También fortificó las ciudades de Bet Sur y Guézer y la ciudadela, dejando en ellas soldados y depósitos de víveres."
,"53":"Tomó, finalmente, a los hijos de los jefes del país como rehenes y los puso bajo vigilancia en la ciudadela de Jerusalén."
,"54":"El año 153, en el segundo mes, Alcimo mandó derribar el muro del atrio interior del templo, destruyendo así la obra de los profetas. Ya se había comenzado a demoler,"
,"55":"cuando Alcimo tuvo un ataque y quedaron suspendidas las obras. Se le cerró la boca y quedó paralizada, de modo que no podía hablar ni dar órdenes en su casa."
,"56":"Alcimo murió en medio de grandes sufrimientos."
,"57":"Báquides, viendo que Alcimo había muerto, regresó a la corte real. El país tuvo paz durante dos años."
,"58":"Entonces todos los criminales tomaron esta resolución: 'Jonatán y los suyos viven en paz, sin temor alguno. Hagamos venir a Báquides, y nos haremos con todos en una sola noche',"
,"59":"y fueron a deliberar con él."
,"60":"Báquides se puso en camino con un ejército numeroso. Mandó clandestinamente cartas a sus partidarios de Judea para que prendiesen a Jonatán y a los suyos; pero no tuvo éxito, porque fueron descubiertos sus planes."
,"61":"Jonatán y los suyos apresaron a cincuenta hombres del país, cabecillas de la conjura, y los mataron."
,"62":"Jonatán y Simón se retiraron con los suyos a Betbasí, en el desierto, repararon las ruinas y la fortificaron."
,"63":"Apenas lo supo Báquides, reunió toda su gente y avisó a todos sus partidarios de Judea."
,"64":"Llegó a Betbasí, la sitió durante varios días y emplazó máquinas de guerra."
,"65":"Jonatán dejó en la ciudad a su hermano Simón, y salió por la región con un puñado de hombres."
,"66":"Derrotó a Odomera, a sus hermanos y a los hijos de Fasirón en sus tiendas; estos primeros golpes le sirvieron de refuerzo."
,"67":"Simón y los suyos salieron de la ciudad e incendiaron las máquinas."
,"68":"Atacaron a Báquides, que fue derrotado, y cayó en un profundo abatimiento, porque no habían resultado ni sus planes ni su expedición."
,"69":"Se enfureció grandemente contra los criminales que le habían aconsejado venir al país, mató a muchos y decidió volver a su tierra."
,"70":"Jonatán lo supo, y le envió emisarios para hacer con él un tratado de paz y canjear prisioneros."
,"71":"Él aceptó, prometió lealtad a las propuestas y juró no hacerle daño alguno durante su vida."
,"72":"Después de restituir a los prisioneros capturados en Judea, retornó a su tierra y no volvió más a Judea."
,"73":"Así hubo paz en Israel, y Jonatán fijó su residencia en Micmás, donde comenzó a gobernar al pueblo y a exterminar a la gente perversa de Israel."
}`)
	CurrentBook.AddChapter(10, `{
"1":"El año 160 Alejandro Epífanes, hijo de Antíoco, fue y se apoderó de Tolemaida, donde fue bien recibido y se proclamó rey."
,"2":"Cuando lo supo Demetrio, reunió un ejército numeroso y salió a luchar contra él."
,"3":"Al mismo tiempo mandó a Jonatán una carta con propuestas de amistad y promesas de engrandecerle en el poder."
,"4":"Porque se decía: 'Démonos prisa a hacer las paces con él antes que las haga con Alejandro contra nosotros,"
,"5":"pues recordará todos los males que hemos cometido contra él, contra su hermano y contra su nación'."
,"6":"Le autorizaba a formar un ejército, a armarse y llamarle su aliado, y ordenó que se le entregasen los rehenes de la ciudadela."
,"7":"Jonatán fue a Jerusalén y leyó la carta delante de todo el pueblo y de los de la ciudadela,"
,"8":"quienes se llenaron de temor al saber que el rey le había facultado para formar un ejército."
,"9":"Los de la ciudadela entregaron los rehenes a Jonatán, quien los devolvió a sus parientes."
,"10":"Jonatán fijó entonces su residencia en Jerusalén y comenzó a reconstruir y renovar la ciudad."
,"11":"Mandó a los obreros reconstruir las murallas y rodear el monte Sión con piedras de sillería para fortificarla. Así se hizo."
,"12":"Los extranjeros estacionados en la fortaleza construida por Báquides huyeron;"
,"13":"abandonaron sus puestos y regresaron a su país."
,"14":"Sólo quedaron en Betsur los que habían renegado de la ley y de los preceptos, porque era lugar de refugio."
,"15":"Entretanto, el rey Alejandro se enteró de las promesas hechas por Demetrio a Jonatán. Le contaron también las batallas que habían librado y los actos heroicos que habían realizado él y sus hermanos, así como las penalidades que habían pasado."
,"16":"Y dijo: '¿Podremos encontrar un hombre semejante? Hagámonos amigo y aliado suyo'."
,"17":"Le escribió una carta, en la que decía:"
,"18":"'El rey Alejandro al hermano Jonatán, salud."
,"19":"He oído que eres valiente y digno de ser nuestro amigo."
,"20":"Por tanto, te constituimos hoy sumo sacerdote de tu nación y te concedemos el título de amigo del rey -y le envió un vestido de púrpura y una corona de oro- para que te pongas de nuestra parte y nos guardes amistad'."
,"21":"Jonatán fue investido sumo sacerdote el séptimo mes del año 160 en la fiesta de los tabernáculos. Reclutó muchos soldados y fabricó muchas armas."
,"22":"Cuando Demetrio supo todo esto, se afligió mucho y dijo:"
,"23":"'¿Qué hemos hecho? Alejandro se ha adelantado en hacerse amigo de los judíos para ganarse su apoyo."
,"24":"También yo les escribiré cartas persuasivas, ofreciéndoles ventajas y recompensas para que me ayuden'."
,"25":"Y les escribió así: 'El rey Demetrio a la nación judía, salud."
,"26":"Habéis mantenido el tratado hecho con nosotros, habéis permanecido en nuestra amistad y no os habéis pasado a nuestros enemigos; lo sabemos, y nos ha complacido."
,"27":"Continuad guardándonos lealtad, y responderemos con beneficios a lo que habéis hecho por nosotros."
,"28":"Os liberaremos de muchos impuestos y os colmaremos de dones."
,"29":"Desde ahora y para siempre eximo a todos los judíos de los tributos, del impuesto de la sal y de las coronas."
,"30":"De hoy en adelante renuncio para siempre al tercio de la cosecha y a la mitad de la de los árboles frutales que me pertenecen en la región de Judea y en los tres distritos anexionados de Samaría y Galilea;"
,"31":"Jerusalén será ciudad santa y exenta de diezmos y tributos, igual que su territorio."
,"32":"Renuncio a la ciudadela que hay en Jerusalén, y la entrego al sumo sacerdote para que escoja a los hombres que quiera para custodiarla."
,"33":"Concedo la libertad gratuitamente a todos los judíos prisioneros fuera de Judea en todo mi reino. A todos los eximo de los tributos, aun de los ganados."
,"34":"Serán días de exención y de franquicia en todo mi reino, y para todos los judíos, todas las fiestas, los sábados, las lunas nuevas, los días señalados y los tres días que preceden y siguen a una fiesta."
,"35":"Nadie tendrá derecho a perseguirlos o perturbarlos por ningún motivo."
,"36":"En el ejército del rey se alistarán treinta mil judíos, a los que se les dará el sueldo como a todos los soldados del rey."
,"37":"Se les destinará a las fortalezas reales más importantes y se les confiarán cargos de confianza en el reino. Sus jefes serán de los suyos y vivirán conforme a sus leyes, como ha mandado el rey para la región de Judea."
,"38":"Los tres distritos de Samaría agregados a Judea se considerarán como parte de Judea, de modo que dependan de un solo jefe y obedezcan solamente al sumo sacerdote."
,"39":"Entrego como obsequio Tolemaida y su territorio al templo de Jerusalén para cubrir los gastos del culto."
,"40":"Yo daré cada año ciento ochenta kilos de plata, que se sacarán de los lugares más convenientes."
,"41":"Y todo lo demás que los funcionarios no hayan abonado, se abonará desde ahora para el servicio del templo."
,"42":"Además, los sesenta kilos de plata con que se gravaban las entradas del templo quedarán para los sacerdotes que ejercen su ministerio."
,"43":"Todos los que sean deudores del rey por cualquier título y se refugien en el templo de Jerusalén y en su recinto amurallado quedarán libres, así como todo lo que posean en mi reino."
,"44":"Los gastos de construcción y restauración del templo serán de cuenta del rey,"
,"45":"así como los gastos de reconstrucción de las murallas de Jerusalén, la fortificación de sus defensas y la construcción de murallas en las ciudades de Judea'."
,"46":"Jonatán y el pueblo oyeron esto; pero ni lo creyeron, ni lo aceptaron, pues tenían vivo el recuerdo de los grandes males y de la dura opresión que Demetrio había causado a Israel."
,"47":"Les gustaron, sin embargo, las palabras de Alejandro por haber sido el que primero les había hecho propuestas de paz, y se declararon sus fieles aliados."
,"48":"Entonces el rey Alejandro reunió un gran ejército y avanzó contra Demetrio."
,"49":"Los dos reyes comenzaron la lucha, y el ejército de Demetrio emprendió la fuga. Alejandro lo persiguió con gran ventaja."
,"50":"El combate se prolongó hasta la caída del sol, y aquel día murió Demetrio."
,"51":"Alejandro mandó emisarios a Tolomeo, rey de Egipto, con el siguiente mensaje"
,"52":"'Estoy de nuevo en mi reino sentándome en el trono de mis padres, porque me he apoderado del poder después de vencer a Demetrio y tomar posesión de mi país,"
,"53":"pues, trabada la batalla con él, lo derroté con todo su ejército y he ocupado su trono."
,"54":"Seamos amigos. Dame tu hija por mujer; yo seré tu yerno y te daré, lo mismo que a ella, regalos dignos de ti'."
,"55":"El rey Tolomeo respondió así: '¡Feliz el día en que has vuelto a la tierra de tus padres y has ocupado su trono real!"
,"56":"Haré lo que has dicho, pero ven a Tolemaida para que hablemos y seas mi yerno como has dicho."
,"57":"Tolomeo salió de Egipto el año 162 con su hija Cleopatra, y llegó a Tolemaida."
,"58":"Alejandro llegó antes. Tolomeo le dio a su propia hija Cleopatra, y celebraron las bodas con fastuosidad real."
,"59":"El rey Alejandro había escrito también a Jonatán para que se entrevistara con él."
,"60":"Jonatán llegó a Tolemaida con gran pompa, y se entrevistó con los dos reyes. A los dos y a sus amigos les ofreció una gran cantidad de oro y plata y otros muchos regalos, ganándose así su favor."
,"61":"Algunos hombres rastreros, la peste de Israel, se unieron para acusarlo, pero el rey no les hizo caso."
,"62":"Más aún, mandó que Jonatán se quitara sus vestiduras y fuese revestido de púrpura, como se hizo."
,"63":"El rey lo sentó a su lado y dijo a sus dignatarios: 'Id con él al centro de la ciudad y pregonad que nadie, bajo ningún pretexto, acuse a Jonatán; y que nadie, por ninguna causa, lo moleste'."
,"64":"Cuando los acusadores vieron los honores que se le rendían a la voz del heraldo y que estaba vestido de púrpura, huyeron todos."
,"65":"El rey lo inscribió en el rango de sus mejores amigos y lo nombró estratega y gobernador."
,"66":"Jonatán volvió a Jerusalén en paz y contento."
,"67":"El año 165, Demetrio, hijo de Demetrio, llegó de Creta a la tierra de sus padres."
,"68":"Al saberlo el rey Alejandro, quedó totalmente desconcertado y volvió a Antioquía."
,"69":"Demetrio nombró a su general Apolonio gobernador de Celesiria, quien reunió un gran ejército y fue a acampar junto a Yamnia, desde donde mandó al sumo sacerdote Jonatán el siguiente mensaje:"
,"70":"'Sólo tú nos resistes. Por tu causa he sido objeto de desprecio y de burla. ¿Por qué te haces fuerte contra nosotros en las montañas?"
,"71":"Si tienes confianza en tus tropas, baja a la llanura y allí mediremos nuestras fuerzas, pues yo tengo conmigo la flor de los combatientes."
,"72":"Infórmate, y averiguarás quién soy yo y quiénes mis aliados. Ellos dicen que no podréis resistirnos, pues ya dos veces fueron derrotados tus padres en tu país."
,"73":"Tú, ahora, no podrás resistir a la caballería ni a un ejército tan numeroso en una llanura donde no hay piedras, ni rocas, ni lugar de refugio'."
,"74":"Cuando Jonatán oyó las palabras de Apolonio, se indignó. Eligió diez mil hombres y salió para Jerusalén; su hermano Simón se unió a él con una tropa de socorro."
,"75":"Acampó junto a Jafa, pero los de la ciudad le cerraron las puertas porque había allí una guarnición de Apolonio. Comenzó el ataque."
,"76":"Atemorizados los de la ciudad, le abrieron las puertas, y Jonatán se apoderó de Jafa."
,"77":"Apolonio, al saberlo, movilizó tres mil soldados de caballería y numerosos soldados de infantería"
,"78":"y se dirigió a Asdod, simulando una marcha, pero se replegó repentinamente hacia la llanura, porque tenía mucha caballería, en la que confiaba. Jonatán lo persiguió hasta Asdod, y trabaron batalla."
,"79":"Apolonio había dejado atrás mil soldados de caballería escondidos."
,"80":"Jonatán fue informado de la emboscada. Los soldados de caballería cercaron a sus hombres y estuvieron lanzando flechas desde la mañana hasta la tarde;"
,"81":"pero la tropa resistió, como había ordenado Jonatán, hasta que los caballos se cansaron."
,"82":"Simón mandó a su gente atacar a la infantería enemiga, y, ya sin el apoyo de la caballería, los enemigos fueron derrotados y huyeron."
,"83":"La caballería se dispersó por la llanura, y los fugitivos llegaron a Asdod y entraron en el templo de Dagón, su ídolo, para salvar la vida."
,"84":"Pero Jonatán incendió Asdod y los poblados cercanos, y los saqueó; incendió asimismo el templo de Dagón con todos los que se habían refugiado en él."
,"85":"Fueron cerca de ocho mil entre los pasados por la espada y los quemados."
,"86":"Jonatán partió para Ascalón, donde los habitantes salieron a recibirlo y le rindieron grandes honores."
,"87":"De allí regresó con los suyos a Jerusalén con gran botín."
,"88":"Cuando el rey Alejandro conoció estos sucesos, concedió nuevos honores a Jonatán."
,"89":"Le envió un broche de oro, como se acostumbra dar a los parientes de los reyes, y le dio en posesión Ecrón y todo su territorio."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Pero el rey de Egipto reunió un ejército incontable como la arena de las playas del mar y muchas naves, pues intentaba apoderarse por engaño del reino de Alejandro y anexionarlo al suyo."
,"2":"Llegó a Siria con palabras de paz, y los habitantes de las ciudades le abrieron las puertas y le salieron al encuentro, porque así lo había mandado Alejandro, pues era su suegro."
,"3":"Pero en las ciudades donde entraba, Tolomeo dejaba guarniciones."
,"4":"Cuando se acercó a Asdod le mostraron el templo de Dagón incendiado, Asdod y sus alrededores destruidos, los cadáveres abandonados y los restos calcinados de todos los que Jonatán había quemado en la guerra, pues habían hecho montones a lo largo del recorrido del rey."
,"5":"Contaron al rey todo lo que había hecho Jonatán para que lo odiara, pero el rey callaba."
,"6":"Jonatán salió a Jafa a recibir al rey con grande aparato. Se cambiaron saludos y pasaron allí la noche."
,"7":"Jonatán acompañó al rey hasta el río Eléutero, y luego se volvió a Jerusalén."
,"8":"El rey Tolomeo se apoderó de todas las ciudades hasta Seleucia marítima, y fraguaba malos propósitos contra Alejandro."
,"9":"Así, mandó emisarios a Demetrio con este mensaje: 'Ven y hagamos un pacto; te daré a mi hija casada con Alejandro, y reinarás en el trono de tu padre."
,"10":"Yo me arrepiento de haberle entregado a mi hija, pues ha intentado matarme'."
,"11":"Lo calumniaba así porque aspiraba a su reino."
,"12":"Por eso le quitó la hija y se la dio a Demetrio, separándose de Alejandro, de modo que apareció públicamente su enemistad."
,"13":"Tolomeo entró en Antioquía y se ciñó la corona de Asia, juntando en su cabeza dos coronas, la de Egipto y la de Asia."
,"14":"Alejandro se encontraba entonces en Cilicia, por haberse sublevado los habitantes de aquella región."
,"15":"Alejandro, al saberlo, fue contra Tolomeo para luchar contra él. A su vez, Tolomeo le salió al encuentro con grandes contingentes y lo derrotó."
,"16":"Alejandro huyó a Arabia buscando refugio, mientras Tolomeo triunfaba."
,"17":"El árabe Zabdiel cortó la cabeza a Alejandro y se la envió a Tolomeo."
,"18":"Pero tres días después murió también Tolomeo, y los egipcios que estaban en las plazas fuertes fueron matados por los habitantes."
,"19":"Así Demetrio obtuvo el reinado el año 167."
,"20":"Por entonces, Jonatán reunió las tropas de Judea para atacar la ciudadela de Jerusalén, emplazando contra ella muchas máquinas de guerra."
,"21":"Pero algunos perversos, enemigos de su propia nación, anunciaron al rey el asedio de la ciudadela por parte de Jonatán."
,"22":"El rey, al saberlo, se indignó, e informado bien, partió sin tardanza y llegó a Tolemaida, desde donde escribió a Jonatán para que desistiese del asedio y viniese rápidamente a Tolemaida a hablar con él."
,"23":"Jonatán recibió el mensaje y mandó continuar el asedio, se rodeó de los ancianos de Israel y de algunos sacerdotes y resolvió aventurarse al peligro."
,"24":"Tomó consigo plata, oro, vestidos y otros muchos presentes y se encaminó hacia Tolemaida para hablar con el rey, obteniendo favorable acogida."
,"25":"Algunos perversos de su nación lo acusaron;"
,"26":"pero el rey se portó con él como sus predecesores, colmándolo de honores ante sus enemigos."
,"27":"Le confirmó en el sumo sacerdocio y en todos los privilegios anteriores y lo contó entre sus primeros amigos."
,"28":"Jonatán pidió al rey exenciones de impuestos para Judea y para los tres distritos de Samaría, prometiéndole a cambio diez mil kilos de plata."
,"29":"El rey se avino, y escribió a Jonatán una carta en estos términos:"
,"30":"'El rey Demetrio a Jonatán, su hermano, y a toda la nación judía, salud."
,"31":"Os enviamos una copia de la carta que hemos escrito a nuestro pariente Lástenes acerca de vosotros, para que estéis informados."
,"32":"El rey Demetrio a Lástenes, su padre, salud."
,"33":"Hemos decidido favorecer a la nación de los judíos, que son nuestros amigos y nos guardan fidelidad."
,"34":"Les confirmamos la posesión de los territorios de Judea y de los tres distritos de Aferema, Lida y Ramatáyim. Son desmembrados de Samaría, pasando a Judea, junto con sus dependencias, en favor de todos los que van a ofrecer sacrificios en Jerusalén, y en lugar de los tributos que el rey percibía todos los años, hasta ahora, por los productos de la tierra y por los frutos de los árboles."
,"35":"Con relación a los otros derechos que percibíamos sobre los diezmos e impuestos sobre las salinas y coronas que nos pertenecen, desde ahora se los perdonamos todos."
,"36":"Ninguno de estos privilegios será revocado jamás."
,"37":"Haced de todo esto una copia, que será entregada a Jonatán y colocada en el monte en lugar visible'."
,"38":"Viendo el rey Demetrio que el país estaba tranquilo y que nadie se le oponía, licenció a sus soldados, mandándolos a sus hogares, excepto las fuerzas extranjeras reclutadas en las islas de los gentiles; pero esto le trajo la hostilidad de los soldados de su padre."
,"39":"Entonces Trifón, que había sido partidario de Alejandro, oyendo las murmuraciones del ejército contra Demetrio, se dirigió al árabe Imalcúe, preceptor de Antíoco, hijo de Alejandro,"
,"40":"presionándole para que le entregase al niño, con el fin de que reinara en el puesto de su padre. Lo puso al corriente de todo lo que había hecho Demetrio y del odio que le tenían sus soldados, y permaneció allí muchos días."
,"41":"Entretanto, Jonatán pidió al rey que retirara los acuartelamientos de la ciudadela de Jerusalén y de las fortalezas, pues estaban siempre en guerra contra Israel."
,"42":"Demetrio le contestó: 'Por ti y por tu pueblo no sólo haré esto, sino que os colmaré de honores en cuanto tenga ocasión propicia."
,"43":"De momento harás bien mandándome tropas, porque mis soldados me han abandonado'."
,"44":"Jonatán le envió a Antioquía tres mil hombres valientes. Cuando se presentaron ante el rey, éste se puso muy contento."
,"45":"Pero ciento veinte mil hombres de la ciudad se reunieron con intención de matar al rey."
,"46":"Demetrio se refugió en su palacio, mientras los ciudadanos ocupaban las calles de la ciudad y comenzaban el ataque."
,"47":"Entonces el rey llamó en su ayuda a los judíos, que acudieron y se dispersaron después por la ciudad, matando aquel día cerca de cien mil."
,"48":"Incendiaron la ciudad y la saquearon. Así libertaron al rey."
,"49":"Viendo que los judíos dominaban la ciudad, se desalentaron y suplicaron al rey:"
,"50":"'Extiende tu mano derecha y haz que los judíos desistan de combatir contra nosotros y contra la ciudad'."
,"51":"Arrojaron las armas e hicieron las paces. Los judíos, cubiertos de gloria ante el rey y todos sus súbditos, se hicieron famosos en todo el reino y volvieron a Jerusalén cargados de botín."
,"52":"Cuando Demetrio se sintió seguro en su trono y estuvo el país en calma,"
,"53":"se olvidó de las promesas hechas, volvió las espaldas a Jonatán y no le reconoció los servicios prestados, sino que comenzó a maltratarlo de mil modos."
,"54":"Después de todo esto apareció Trifón con el jovencito Antíoco, que fue coronado rey."
,"55":"Las tropas que había licenciado Demetrio se pusieron del lado del rey y lucharon contra Demetrio, el cual tuvo que huir derrotado."
,"56":"Trifón capturó los elefantes y ocupó Antioquía."
,"57":"El joven Antíoco escribió a Jonatán: 'Te confirmo en el sumo sacerdocio, te nombro gobernador de los cuatro distritos y quiero contarte entre los amigos del rey'."
,"58":"Le envió una vajilla de oro y un servicio de mesa, autorizándolo a beber en copas de oro, a llevar la púrpura y el broche de oro."
,"59":"Nombró a su hermano Simón jefe militar en la región que va desde la Escala de Tiro hasta la frontera de Egipto."
,"60":"Jonatán se puso a recorrer las ciudades de la región del otro lado del Éufrates. Todo el ejército de Siria se incorporó a él para ayudarle. Cuando llegó a Ascalón, los habitantes de la ciudad salieron a recibirle con todos los honores."
,"61":"De allí marchó a Gaza, pero la ciudad le cerró las puertas. La asedió, incendió los alrededores y los saqueó."
,"62":"Los de Gaza se rindieron, y Jonatán hizo con ellos un tratado de paz; pero tomó como rehenes a los hijos de los jefes y los mandó a Jerusalén. Él continuó el recorrido por la región, y llegó hasta Damasco."
,"63":"Jonatán supo que habían llegado a Quedes de Galilea algunos generales de Demetrio con numerosos soldados para impedirle continuar su empresa."
,"64":"Les salió al paso, dejando en Judea a su hermano Simón."
,"65":"Simón sitió a Bet Sur y la atacó durante muchos días."
,"66":"Los habitantes se rindieron. Simón hizo con ellos un tratado de paz; pero los echó de allí, tomó posesión de la ciudad y dejó una guarnición en ella."
,"67":"Entretanto Jonatán, que con su ejército había acampado en las riberas del lago de Genesaret, llegaba muy de mañana a la llanura de Asor."
,"68":"El ejército extranjero avanzó contra ellos en la llanura, pero habían dejado hombres en la montaña para tenderles una emboscada. Así, mientras el ejército avanzaba de frente,"
,"69":"los emboscados salieron de sus escondrijos y se trabó la batalla."
,"70":"Los soldados de Jonatán huyeron todos, excepto Matatías, hijo de Absalón, y Judas, hijo de Calfi, capitanes del ejército."
,"71":"Jonatán rasgó sus vestiduras, se postró en tierra y oró."
,"72":"Se volvió luego contra los enemigos, los atacó y los puso en fuga."
,"73":"Los que habían huido, al ver esto, se volvieron a él, y con él persiguieron al enemigo hasta su campamento de Quedes, donde acamparon."
,"74":"Aquel día murieron tres mil extranjeros. Jonatán volvió a Jerusalén."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Jonatán, viendo que las circunstancias le eran favorables, escogió algunos hombres, que envió a Roma para confirmar y renovar la amistad con los romanos."
,"2":"En el mismo sentido escribió cartas a los espartanos y a otros pueblos."
,"3":"Los que fueron a Roma se presentaron al senado y dijeron: 'El sumo sacerdote Jonatán y la nación de los judíos nos han enviado para que renovéis con ellos el tratado de amistad que existía en el pasado'."
,"4":"Les dieron cartas de recomendación para las autoridades de cada país, para que les permitieran seguir en paz hasta el país de Judá."
,"5":"Copia de la carta que Jonatán escribió a los espartanos:"
,"6":"'Jonatán, sumo sacerdote, el senado de la nación, los sacerdotes y el resto del pueblo judío, a sus hermanos los espartanos, salud."
,"7":"Ya en otros tiempos Areios, vuestro rey, envió carta al sumo sacerdote Onías; una carta en la que declaraba que sois nuestros hermanos, como lo muestra la copia adjunta."
,"8":"Onías recibió con todos los honores al enviado y aceptó la carta, que contenía un tratado de amistad."
,"9":"Ahora nosotros, sin sentir necesidad, pues gozamos de la consolación de los libros sagrados que tenemos en nuestras manos,"
,"10":"hemos decidido mandaros embajadores que renueven la fraternidad y la amistad que nos une a vosotros, para que no seamos considerados por vosotros como extranjeros, pues se ha pasado mucho tiempo desde que nos recibisteis."
,"11":"No dejamos de acordarnos de vosotros tanto en las solemnidades como en los demás días, en los sacrificios que ofrecemos y en las oraciones, pues es justo y conveniente recordar a los hermanos."
,"12":"Nos alegramos de vuestra prosperidad."
,"13":"Nosotros, por el contrario, nos hemos visto envueltos en tribulaciones y guerras, pues nos han atacado los reyes vecinos."
,"14":"Pero no hemos querido servir de carga ni a vosotros ni a los demás aliados y amigos,"
,"15":"ya que hemos recibido ayuda del cielo. Ahora nos ha librado de los enemigos, que han sido humillados."
,"16":"Hemos elegido a Numenio, hijo de Antíoco, y a Antípatro, hijo de Jasón, y los hemos enviado a los romanos para renovar el antiguo tratado de amistad."
,"17":"Les hemos ordenado también que vayan a vosotros para saludaros y entregaros, de nuestra parte, esta carta, con la que queremos renovar nuestra fraternidad."
,"18":"Nos alegraría recibir respuesta favorable'."
,"19":"Copia de la carta escrita a Onías:"
,"20":"'Aerios, rey de los espartanos, a Onías, sumo sacerdote, salud."
,"21":"Hemos encontrado en un documento que espartanos y judíos son hermanos, por pertenecer a la raza de Abrahán."
,"22":"Ya que hemos conocido esto, os agradeceremos que nos informéis de vuestra prosperidad."
,"23":"En cuanto a nosotros, os decimos: vuestros ganados y vuestros bienes son nuestros, y los nuestros, vuestros. Por eso mandamos que se os comunique esto'."
,"24":"Jonatán supo que los generales de Demetrio habían vuelto con fuerzas más numerosas que antes para luchar contra él."
,"25":"Salió rápidamente de Jerusalén para hacerles frente en la región de Jamat, sin darles tiempo de entrar en su territorio."
,"26":"Envió espías al campo enemigo, quienes al volver refirieron que los sirios habían resuelto atacar a los judíos durante la noche."
,"27":"A la caída del sol, Jonatán ordenó a los suyos que durante toda la noche velaran con las armas en la mano, dispuestos a luchar, y apostó centinelas alrededor del campamento."
,"28":"Pero los enemigos, al saber que Jonatán velaba con los suyos dispuestos a dar batalla, tuvieron miedo y se desanimaron; por eso encendieron fuego en su campamento y huyeron."
,"29":"Pero ni Jonatán ni su ejército se apercibieron de su partida hasta el alba, pues veían las llamas."
,"30":"Jonatán los siguió sin poder alcanzarlos, porque habían pasado el río Eléutero."
,"31":"Jonatán se volvió contra los árabes llamados zabadeos, los derrotó y los saqueó."
,"32":"Levantó el campamento y llegó a Damasco después de recorrer toda la provincia."
,"33":"Entretanto, Simón había llegado hasta Ascalón y fortalezas vecinas; se dirigió a Jafa y se apoderó de ella,"
,"34":"pues había sabido que los habitantes querían entregar la plaza a los partidarios de Demetrio. Allí dejó una guarnición para defenderla."
,"35":"Jonatán, a su regreso, convocó a los ancianos del pueblo, con quienes decidió edificar fortalezas en Judea,"
,"36":"reconstruir las murallas de Jerusalén, levantar un muro entre la ciudadela y la ciudad, para separar aquélla de ésta y aislarla, de modo que los de dentro no pudieran comprar ni vender nada."
,"37":"Se reunieron para reconstruir la ciudad. Se había caído una parte del muro oriental sobre el torrente; Jonatán levantó aquella parte, y la llamó Cafenatá."
,"38":"Simón reconstruyó Adida, en la Sefela, la fortificó y le puso puertas y cerrojos."
,"39":"Trifón soñaba con reinar en Asia, ceñirse la corona y deshacerse del rey Antíoco."
,"40":"Pero temiendo que Jonatán no se lo permitiera y le declarara la guerra, buscaba el modo de prenderlo y matarlo. Se puso en camino, y llegó a Betsán."
,"41":"Jonatán salió a su encuentro con cuarenta mil hombres escogidos, y llegó también a Betsán."
,"42":"Trifón, al ver las tropas con que había llegado, tuvo miedo de echarle mano."
,"43":"Por eso lo recibió con honores, lo presentó a todos sus amigos, le hizo regalos y ordenó a sus amigos y soldados que le obedeciesen como a él mismo."
,"44":"Y luego dijo a Jonatán: '¿Por qué has movilizado a toda esta gente, si nosotros no estamos en guerra?"
,"45":"Despídelos, quédate con unos cuantos y ven conmigo a Tolemaida. Te entregaré la ciudad y demás fortalezas, así como el resto de las tropas y todos los funcionarios; después me volveré, pues sólo he venido para esto'."
,"46":"Jonatán le creyó e hizo como le dijo; licenció a las tropas, que regresaron a Judá."
,"47":"Se quedó con tres mil hombres: dejó dos mil en Galilea, y sólo mil le acompañaron."
,"48":"Apenas entró Jonatán en Tolemaida, los habitantes cerraron las puertas, lo prendieron a él y mataron a todos los que le acompañaban."
,"49":"Trifón envió el ejército y la caballería a Galilea y a la gran llanura para aniquilar a los partidarios de Jonatán."
,"50":"Pero éstos, al saber que Jonatán había sido preso con todos los que lo acompañaban, se animaron mutuamente y marcharon dispuestos a luchar."
,"51":"Cuando los perseguidores los vieron dispuestos a luchar por su vida, se volvieron."
,"52":"Así, sin ser molestados, entraron en Judea, lloraron a Jonatán y a los suyos y se llenaron de gran temor. Todo Israel hizo duelo."
,"53":"Entonces todas las naciones vecinas se propusieron exterminarlos, diciendo: 'No tienen jefe ni ayuda; hagámosles la guerra y borremos su memoria de entre los hombres'."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Simón supo que Trifón había reunido un gran ejército para dirigirse a Judea y devastarla."
,"2":"Viendo que el pueblo temblaba de miedo, fue a Jerusalén, lo reunió"
,"3":"y lo animó así: 'Conocéis todo lo que yo, mis hermanos y la casa de mi padre hemos hecho por las leyes y el templo, así como las guerras y angustias que hemos soportado."
,"4":"Por esto, por Israel, han muerto todos mis hermanos, quedando yo solo."
,"5":"Pues bien, jamás intentaré salvar mi vida en tiempos de opresión, pues no soy yo mejor que mis hermanos."
,"6":"Defenderé a mi pueblo, a vuestros hijos y a vuestras mujeres ahora que todas las naciones que nos odian conspiran para exterminarnos'."
,"7":"Al oír estas palabras, el pueblo se llenó de entusiasmo y todos exclamaron a grandes voces:"
,"8":"'Tú serás nuestro jefe en lugar de Judas y Jonatán, tu hermano;"
,"9":"toma la dirección de nuestras guerras y obedeceremos tus órdenes'."
,"10":"Entonces Simón reunió a todos los hombres de guerra, se apresuró a terminar las murallas de Jerusalén y la fortificó por todas partes."
,"11":"Luego mandó a Jonatán, hijo de Absalón, a Jafa con tropa suficiente. Expulsó a los habitantes y se estableció allí."
,"12":"Entretanto, Trifón salió de Tolemaida con numerosas tropas para invadir Judea, llevando consigo a Jonatán prisionero."
,"13":"Simón acampó en Adida, frente a la llanura."
,"14":"Pero cuando Trifón supo que Simón había tomado el mando en lugar de su hermano Jonatán y que estaba dispuesto a luchar contra él, le mandó algunos emisarios"
,"15":"para decirle: 'Hemos detenido a tu hermano Jonatán a causa del dinero que debe al tesoro real por los asuntos que él administraba."
,"16":"Envíanos tres mil cuatrocientos kilos de plata y dos de sus hijos en rehenes para que, una vez puesto en libertad, no se vuelva contra nosotros. Entonces lo libertaremos'."
,"17":"Aunque Simón comprendió que Trifón trataba de engañarlo, ordenó que le mandaran el dinero y los dos hijos, para no suscitar la animosidad del pueblo, que podría decir:"
,"18":"'Claro, no ha entregado el dinero y los hijos, y por esto ha muerto Jonatán'."
,"19":"Envió los hijos y los tres mil cuatrocientos kilos de plata, pero Trifón faltó a la palabra y no puso en libertad a Jonatán."
,"20":"Después Trifón avanzó hacia Judea con el fin de devastarla; pero dio un rodeo por Adora, porque Simón con su ejército le cerraba el paso."
,"21":"Entonces los de la ciudadela mandaron emisarios a Trifón, rogándole que viniera en su auxilio por el desierto y que les enviara provisiones."
,"22":"Trifón preparó toda su caballería para llegar; pero aquella noche cayó mucha nieve, por lo cual, no pudiendo avanzar, levantó el campamento y se dirigió a Galaad."
,"23":"Cerca de Bascama mató a Jonatán y lo sepultó allí."
,"24":"Después se volvió y marchó a su tierra."
,"25":"Simón mandó a buscar los restos de Jonatán y los sepultó en Modín, la ciudad de sus padres."
,"26":"Todo Israel guardó gran duelo por él y lo lloró durante muchos días."
,"27":"Simón construyó sobre el sepulcro de sus padres y de sus hermanos un mausoleo muy alto, para que se viera bien, adornado de mármoles en la fachada y en la parte posterior."
,"28":"Colocó siete pirámides, una frente a otra, por el padre, la madre y los cuatro hermanos."
,"29":"Las rodeó de grandes columnas, y sobre las columnas colocó panoplias para eterna memoria; y al lado de las panoplias, naves esculpidas, que vieran todos los marineros."
,"30":"Éste es el mausoleo que construyó en Modín y que existe hasta hoy."
,"31":"Trifón se comportó pérfidamente con el joven rey Antíoco y lo mató."
,"32":"Se proclamó rey en su lugar, se ciñó la corona de Asia y llenó de males al país."
,"33":"Simón reconstruyó la fortaleza de Judea, la rodeó de altas torres, de murallas sólidas, de puertas con cerrojos y depositó víveres en ellas."
,"34":"Simón envió a Demetrio algunos hombres escogidos para pedirle la inmunidad del país, pues toda la actividad de Trifón no era más que saqueos."
,"35":"El rey Demetrio le contestó conforme a sus propuestas en la siguiente carta:"
,"36":"'El rey Demetrio a Simón, sumo sacerdote y amigo del rey, a los ancianos y a la nación judía, salud."
,"37":"Hemos recibido la corona de oro y la palma que nos enviaste, y estamos dispuestos a firmar contigo una paz duradera y a comunicar a los funcionarios que te eximan de todo tributo."
,"38":"Todas nuestras concesiones a tu favor son definitivas, y las fortalezas que has edificado, tuyas son."
,"39":"Te perdonamos, además, los fallos y errores cometidos hasta hoy, así como la corona que debes. No será exigido desde ahora cualquier otro tributo que grave sobre Jerusalén."
,"40":"Si algunos de vuestros hombres quieren alistarse en nuestras tropas, que se alisten. Y haya paz entre nosotros'."
,"41":"El año 170 Israel fue libertado del yugo de los paganos,"
,"42":"y el pueblo comenzó a escribir en los actos públicos y en los contratos: 'Año primero de Simón, sumo sacerdote, estratega y jefe de los justos'."
,"43":"Por entonces Simón acampó frente a Guézer con su ejército. Construyó una torre móvil y la acercó a la ciudad; atacó una de las torres, y se apoderó de ella."
,"44":"Los que estaban en la torre móvil salieron a la ciudad, causando gran consternación."
,"45":"Los habitantes, con sus mujeres y sus hijos, subieron a las murallas, se rasgaron las vestiduras y pidieron a Simón la paz a grandes gritos, clamando:"
,"46":"'No nos trates según nuestra maldad, sino según tu clemencia'."
,"47":"Simón llegó a un acuerdo con ellos y dejó de luchar; pero los echó de la ciudad, purificó las casas donde habían estado los ídolos y entró cantando alabanzas y bendiciones al Señor."
,"48":"Quitó todo lo que sabía a pagano, estableció allí personas que observaban la ley, la fortificó y construyó una residencia para él."
,"49":"Los de la ciudadela de Jerusalén, al no poder salir al país, ni comprar ni vender, estaban extenuados y muchos murieron de hambre."
,"50":"Entonces, a grandes gritos, pidieron la paz a Simón, quien se la concedió; pero los echó de allí y purificó la ciudadela de toda huella de idolatría."
,"51":"Los judíos entraron el 23 del segundo mes, el año 171, con aclamaciones y palmas, al son de las arpas, címbalos y cítaras, cantando himnos y cánticos por haber sido vencido tan gran enemigo de Israel."
,"52":"Simón ordenó celebrar alegremente cada año este día. Fortificó la colina del templo, al lado de la ciudadela, y allí fijó su residencia con los suyos."
,"53":"Simón, viendo que Juan, su hijo, era ya un hombre, lo nombró capitán de todo el ejército, con residencia en Guézer."
}`)
	CurrentBook.AddChapter(14, `{
"1":"El año 172, el rey Demetrio reunió un ejército y fue a Media a procurarse ayuda para luchar contra Trifón."
,"2":"Pero cuando Arsaces, rey de Persia y de Media supo que Demetrio había entrado en su territorio, mandó a uno de sus generales a capturarlo vivo."
,"3":"El general fue, derrotó al ejército de Demetrio, capturó a éste y lo condujo a Arsaces, quien lo encarceló."
,"4":"Mientras vivió Simón, la región tuvo paz. Buscó el bienestar de su país, agradó al pueblo su gobierno,y gozó de su poder mientras vivió."
,"5":"Entre tantos títulos de gloria, tomó a Jafa y la hizo puerto, abriendo camino a las islas del mar."
,"6":"Extendió las fronteras de su propio país,y fue señor de su nación."
,"7":"Liberó a muchos prisioneros, conquistó Guézer, Bet Sur y la ciudadela, desterrando toda impureza, y nadie hubo capaz de resistirle."
,"8":"Los habitantes cultivaban en paz sus propias tierras, la tierra producía sus cosechas,y los árboles del campo daban frutos."
,"9":"Los ancianos reposaban en las plazas, todos se interesaban por la prosperidad, los jóvenes vestían vistosos trajes de guerra."
,"10":"Abasteció a las ciudades de alimento, las dotó de defensas convenientes,y su nombre fue glorioso hasta el fin del mundo."
,"11":"En el país restableció la paz,e Israel saltó de gozo."
,"12":"Cada cual se sentaba a la sombra de su vid,y de su higuera, y nadie le inquietaba."
,"13":"Desaparecieron del país sus enemigos, y los reyes eran derrotados."
,"14":"Dio fuerza a los humildes de su pueblo, dispersó a los malvados y perversos, fue observante de la ley."
,"15":"Devolvió al templo su esplendor antiguo, y los vasos sagrados aumentaron."
,"16":"Cuando llegó a Roma y a Esparta la noticia de la muerte de Jonatán, se afligieron profundamente."
,"17":"Pero al oír que su hermano Simón le había sucedido como sumo sacerdote y que mandaba en el país y en sus ciudades,"
,"18":"le escribieron en tablas de bronce para renovar el tratado de amistad concertado con sus hermanos Judas y Jonatán."
,"19":"Las cartas fueron leídas en Jerusalén ante toda la asamblea."
,"20":"Ésta es la copia de la que enviaron los espartanos: 'Los magistrados y el pueblo de Esparta a Simón, sumo sacerdote, a los ancianos, a los sacerdotes y a todo el pueblo de los judíos, sus hermanos, salud."
,"21":"Los emisarios que habéis mandado a nuestro pueblo nos han informado de vuestra gloria y felicidad. Nos ha llenado de gozo su venida,"
,"22":"y hemos registrado sus declaraciones en los actos públicos de este modo: Numenio, hijo de Antíoco, y Antípatro, hijo de Jasón, embajadores de los judíos, han venido para renovar la amistad con nosotros."
,"23":"Ha sido un placer para el pueblo recibirlos con grandes honores y depositar en los archivos públicos una copia de sus discursos para recuerdo del pueblo espartano. Hemos hecho una copia para el sumo sacerdote Simón'."
,"24":"Después de esto, Simón envió a Numenio a Roma con un gran escudo de oro que pesaba cuatrocientos cuarenta kilos de oro, para renovar el pacto con los romanos."
,"25":"Cuando e pueblo conoció estos hechos, dijo: '¿Qué recompensa daremos a Simón y a sus hijos?."
,"26":"Pues tanto él como sus hijos y la casa de sus padres han demostrado valentía, han luchado contra los enemigos de Israel y nos han devuelto la libertad'. Grabaron una inscripción en placas de bronce y las colgaron en columnas en el monte Sión."
,"27":"Copia del texto: 'El 18 de elul del año 172, tercero de Simón, sumo sacerdote, en Asaramel,"
,"28":"en la gran asamblea de sacerdotes del pueblo, de los jefes de la nación y de los ancianos del pueblo, se comunicó lo siguiente:"
,"29":"En las frecuentes batallas libradas en nuestro país, Simón, hijo de Matatías, de la familia de Yoarib, y sus hermanos, han expuesto con peligro sus vidas y han resistido a los enemigos de su nación para salvar el templo y la ley, conquistando gloria imperecedera para su nación."
,"30":"Jonatán realizó la unidad de su nación, llegó a ser sumo sacerdote y fue luego a reunirse con los suyos."
,"31":"Los enemigos de los judíos quisieron entonces invadir su país para devastarlo y poner las manos en su templo."
,"32":"Entonces surgió Simón para luchar por su pueblo. Se desprendió de muchas de sus propias riquezas procurando armas y pagas a las milicias de su nación."
,"33":"Fortificó las ciudades de Judea y de Bet Sur, villa fronteriza de Judea, donde antes se encontraban las fuerzas enemigas, y destacó allí una guarnición judía."
,"34":"Fortificó también a Jafa, junto al mar, y a Guézer, en los límites de Asdod, habitada antes por enemigos, y estableció allí colonos judíos, dotándolos de cuanto era necesario."
,"35":"El pueblo comprobó la lealtad de Simón y la gloria que pretendía conseguir para su nación. Lo nombró su caudillo y sumo sacerdote precisamente por los servicios prestados, por la justicia y la lealtad demostradas a su nación, buscando por todos los medios la elevación de su pueblo."
,"36":"A sus órdenes los judíos consiguieron expulsar a los paganos de los territorios ocupados, especialmente de la ciudad de David, Jerusalén, donde habían construido una ciudadela, de la que salían profanando los aledaños del templo e infligiendo graves ofensas a su santidad."
,"37":"Destacó en ella soldados judíos, la fortificó para seguridad de la nación y de la ciudad y levantó las murallas de Jerusalén."
,"38":"El rey Demetrio, por esto, le confirmó en el sumo sacerdocio,"
,"39":"le nombró uno de sus amigos y le prodigó honores,"
,"40":"pues sabía que los romanos llamaban a los judíos amigos, aliados y hermanos, y habían recibido con honores a los emisarios de Simón;"
,"41":"que los judíos y los sacerdotes a una habían resuelto que Simón fuera su caudillo y sumo sacerdote hasta la aparición de un profeta acreditado;"
,"42":"que fuera su general, que se preocupara del templo, de la administración de la nación, de los armamentos y de las fortificaciones;"
,"43":"que administrara el templo, que se hiciera obedecer por todos, que todos los documentos de la nación fueran realizados en su nombre y que vistiera la púrpura y llevara ornamentos de oro."
,"44":"No será permitido a ninguno del pueblo y de los sacerdotes rechazar ninguno de estos puntos, ni contradecir las órdenes que dé, ni reunirse en la nación sin su consentimiento, ni vestir la púrpura o llevar el broche de oro."
,"45":"Todo el que obre contra estas decisiones o viole alguna de ellas será castigado'."
,"46":"El pueblo aprobó conferir a Simón el derecho de obrar según estas disposiciones."
,"47":"Simón aceptó y consintió ejercer el sumo sacerdocio, ser caudillo y jefe de los judíos y de los sacerdotes y ser cabeza de todos."
,"48":"Decidieron que este escrito fuera grabado en placas de bronce, que deberían colocarse en un lugar visible del templo,"
,"49":"y que se depositaran copias en el tesoro del templo para que estuvieran a disposición de Simón y de sus hijos."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Antíoco, hijo del rey Demetrio, envió desde las islas del mar a Simón, sumo sacerdote y jefe de los judíos, y a toda la nación"
,"2":"la siguiente carta: 'El rey Antíoco a Simón, sumo sacerdote y jefe, y a la nación judía, salud."
,"3":"Puesto que hombres malvados se han apoderado del reino de nuestros padres, me he propuesto recobrarlo para restablecer la situación anterior. He reunido numerosas tropas y equipado naves de guerra"
,"4":"para desembarcar en el país y vengarme de los que han devastado y asolado muchas ciudades de mi reino."
,"5":"Te confirmo todas las exenciones de tributos y todas las demás prerrogativas concedidas por mis predecesores."
,"6":"Te autorizo a acuñar moneda para tu nación."
,"7":"Concedo la libertad a Jerusalén y al templo, y que todas las armas que has fabricado y las fortalezas que has construido y ocupado te pertenezcan."
,"8":"Desde ahora y para siempre te perdono todo lo que debes al rey y debas en el futuro;"
,"9":"y cuando me haya posesionado de mi reino te llenaré de honores a ti, a tu nación y al templo, de modo que vuestra gloria se manifieste en toda la tierra'."
,"10":"El año 174, Antíoco entró en la tierra de sus padres; todas las fuerzas armadas se le unieron, quedando sólo pocos partidarios de Trifón."
,"11":"Antíoco lo persiguió, y Trifón se refugió en Dora del Mar."
,"12":"Sabía las calamidades que le esperaban al haberlo abandonado su ejército."
,"13":"Antíoco acampó junto a Dora con ciento veinte mil soldados de infantería y ocho mil de caballería."
,"14":"Sitió la ciudad, mientras las naves se situaban en el mar. Así la ciudad quedó cercada por tierra y por mar, sin que nadie pudiera entrar ni salir."
,"15":"Entretanto habían vuelto de Roma Numenio y sus colegas, con cartas, dirigidas a los reyes y a las naciones, del tenor siguiente:"
,"16":"'Lucio, cónsul de los romanos, al rey Tolomeo, salud."
,"17":"Han llegado a nosotros emisarios de los judíos, nuestros amigos y aliados, para renovar el antiguo tratado de amistad, mandados por el sumo sacerdote Simón y por el pueblo judío."
,"18":"Trajeron un escudo de oro que pesaba cuatrocientos cuarenta kilos."
,"19":"Nos es grato escribir a los reyes y a los pueblos que no les hagan mal, que no les declaren la guerra ni a ellos, ni a sus ciudades, ni a su país, y que no pacten con sus enemigos."
,"20":"Nos ha parecido bien aceptar de los judíos el escudo."
,"21":"Si hombres perversos de su país se refugian en el vuestro, entregadlos al sumo sacerdote Simón para que él los castigue según su ley'."
,"22":"La misma carta fue dirigida al rey Demetrio, a Atalo, a Ariarates, a Arsaces"
,"23":"y a todas las naciones, a Samsamo, a los espartanos, a Delos, a Mindo, a Sición, a Caria, a Samos, a Panfilia, a Licia, a Halicarnaso, a Rodas, a Fasélida, a Cos, a Side, a Arados, a Gortina, a Cnido, a Chipre y a Cirene."
,"24":"Al sumo sacerdote Simón le mandaron también copias de estas cartas."
,"25":"El rey Antíoco acampó frente a Dora, en el suburbio, avanzando siempre con sus fuerzas, sirviéndose de las máquinas. Estrechó el cerco tanto, que nadie podía ni entrar ni salir."
,"26":"Simón le envió dos mil hombres escogidos para ayudarle, con plata, oro y muchas armas."
,"27":"Pero él no quiso aceptarlos; más aún, revocó las concesiones hechas a Simón y se declaró su enemigo."
,"28":"Envió a Atenobio, uno de sus amigos, para conferenciar con él y decirle: 'Habéis ocupado Jafa, Guézer y la ciudadela de Jerusalén, ciudades de mi reino."
,"29":"Habéis devastado su territorio, habéis hecho daño al país y os habéis apoderado de muchas ciudades de mi reino."
,"30":"Restituye las ciudades arrebatadas y los tributos obtenidos de los lugares ocupados fuera de los límites de Judea,"
,"31":"o dad en compensación mil setecientos kilos de plata por las destrucciones llevadas a cabo, y otros mil setecientos por los tributos de las ciudades; si no, te declararé la guerra'."
,"32":"Atenobio, amigo del rey, llegó a Jerusalén y, viendo la fastuosidad de Simón, su vajilla de oro y plata y el aparato con que se rodeaba, quedó maravillado. Pero le comunicó las palabras del rey."
,"33":"Simón le respondió: 'No hemos ocupado tierra extranjera ni retenemos nada de nadie, sino la herencia de nuestros padres, que en un tiempo injustamente nos fue arrebatada por nuestros enemigos."
,"34":"Hemos recuperado en ocasión propicia la heredad de nuestros padres."
,"35":"Jafa y Guézer, que reclamas, fueron causa de grandes males para nuestro pueblo y desolaban nuestro país, pero estamos dispuestos a darte trescientos cuarenta kilos de plata por ellas'."
,"36":"Atenobio no le respondió nada, pero se volvió furioso al rey y le comunicó la respuesta y fastuosidad de Simón, con todo lo que había visto. El rey se enfureció."
,"37":"Trifón, entretanto, huyó a Ortosia en una nave."
,"38":"El rey nombró a Cendebeo general, entregándole una parte de las tropas de infantería y de caballería."
,"39":"Le ordenó acampar frente a Judea, fortificar Cedrón, consolidar sus fuerzas y luchar contra el pueblo. El rey perseguía a Trifón."
,"40":"Cendebeo llegó a Yamnia y comenzó a hostigar al pueblo, a invadir Judea, a hacer prisioneros y a realizar matanzas."
,"41":"Fortificó Cedrón, dejando allí tropas de infantería y caballería para hacer salidas y patrullar por los caminos conforme a las órdenes del rey."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Juan salió de Guézer para referir a Simón, su padre, todo lo que hacía Cendebeo."
,"2":"Entonces Simón llamó a sus dos hijos mayores y les dijo: 'Yo, mis padres y la casa de mi padre hemos luchado desde nuestra juventud hasta hoy contra los enemigos de Israel y hemos conseguido muchas veces liberar a Israel."
,"3":"Pero ahora yo soy viejo, mientras vosotros, gracias al altísimo, estáis en la plenitud de la vida. Ocupad mi puesto y el de mis hermanos; luchad por vuestra patria, y que la ayuda del cielo esté con vosotros'."
,"4":"Eligió después en el país a veinte mil hombres de infantería y otros de caballería y los envió contra Cendebeo. Pernoctaron en Modín."
,"5":"Muy de mañana avanzaban por la llanura, cuando vieron que un ejército numeroso de infantería y de caballería les salía al encuentro. Sólo un torrente los separaba."
,"6":"Juan, con sus tropas, acampó frente a los enemigos, y al notar que sus hombres tenían miedo de cruzar el torrente, lo cruzó él el primero; al verlo, sus hombres lo siguieron."
,"7":"Luego dividió el ejército en dos cuerpos, colocando la caballería en medio de la infantería, pues la caballería enemiga era muy numerosa."
,"8":"Sonaron las trompetas, y Cendebeo y su ejército fueron vencidos; muchos cayeron muertos, y el resto huyó a la fortaleza."
,"9":"Entonces fue herido Judas, el hermano de Juan; pero Juan los persiguió hasta Cedrón, fortificada por Cendebeo,"
,"10":"y muchos se refugiaron en las torres de la campiña de Asdod. Juan incendió la ciudad y murieron unos dos mil enemigos. Juan regresó a Judea sano y salvo."
,"11":"Tolomeo, hijo de Abubos, era el jefe de la región de Jericó. Tenía mucha plata y oro,"
,"12":"porque era yerno del sumo sacerdote."
,"13":"Hombre orgulloso, quería ser jefe de la nación y conspiraba contra Simón y sus hijos."
,"14":"Simón inspeccionaba las ciudades de Judea para enterarse si la administración era justa. El undécimo mes, el de sabat, del año 177 llegó a Jericó con sus dos hijos, Matatías y Judas."
,"15":"El hijo de Abubos los recibió hipócritamente en una pequeña fortaleza llamada Doc, que él había construido. Les dio un gran banquete, pero puso hombres al acecho."
,"16":"Cuando Simón y sus hijos se pusieron alegres, se levantó con sus hombres, tomaron las armas, volvieron a la sala del festín y mataron a Simón, a sus hijos y a algunos de sus servidores."
,"17":"Tolomeo cometió una gran traición, devolviendo mal por bien."
,"18":"Se apresuró después a enviar cartas al rey, informándole de lo sucedido y pidiéndole el envío de fuerzas y socorro, a fin de entregarle las ciudades y el país."
,"19":"Mandó también emisarios a Guézer con la orden de matar a Juan. Solicitó por carta de los comandantes de las tropas judías que se unieran a él, prometiéndoles plata, oro y regalos."
,"20":"Mandó a otros partidarios suyos para que se apoderasen de Jerusalén y del monte del templo."
,"21":"Pero hubo un hombre que corrió a Guézer a anunciar a Juan que su padre y sus hermanos habían sido matados y que habían mandado a alguien para matarlo también a él."
,"22":"Juan quedó consternado con esta noticia. Prendió a los que habían venido a matarle y los mató, pues sabía que venían a matarlo."
,"23":"El resto de la historia de Juan, sus batallas, las gestas llevadas a cabo, los muros que construyó y otras empresas suyas,"
,"24":"todo está escrito en los anales de su pontificado, desde el día en que sucedió a su padre como sumo sacerdote."
}`)

}
func ES_LSB_LoadVH1PChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Adán, Set, Enós,"
,"2":"Quenán, Mahalalel, Yéred,"
,"3":"Henoc, Matusalén, Lamec,"
,"4":"Noé, Sem, Cam y Jafet."
,"5":"Hijos de Jafet: Gómer, Magog, Maday, Yaván, Tubal, Mésec y Tirás."
,"6":"Hijos de Gómer: Asquenaz, Rifat y Togarma."
,"7":"Hijos de Yaván: Elisá, Tarsis, los queteos y los rodenses."
,"8":"Hijos de Cam: Etiopía, Egipto, Put y Canaán."
,"9":"Hijos de Etiopía: Sebá, Javilá, Sabtá, Ramá y Sabtecá. Hijos de Ramá: Sebá y Dedán."
,"10":"Etiopía engendró a Nemrod, el primer héroe de la tierra."
,"11":"Egipto engendró a los lidios, anamitas, lehabitas, naftujitas,"
,"12":"patrositas, caslujitas y cretenses, de los cuales proceden los filisteos."
,"13":"Canaán engendró a Sidón, su primogénito; luego a Het,"
,"14":"y a los jebuseos, amorreos, guirgaseos,"
,"15":"heveos, arquitas, sinitas,"
,"16":"arvadeos, semareos y jamateos."
,"17":"Hijos de Sem: Elán, Asur, Arfaxad, Lidia y Arán. Hijos de Arán: Us, Jul, Guéter y Mésec."
,"18":"Arfaxad engendró a Sélaj, y Sélaj a Héber."
,"19":"Héber tuvo dos hijos: el primero se llamaba Péleg, porque en su tiempo se dividió la tierra, y su hermano Yotán."
,"20":"Yotán engendró a Almodad, Sélef, Jasarmávet, Yéraj,"
,"21":"Hadorán, Uzal, Diclá,"
,"22":"Ebal, Abimael, Sebá,"
,"23":"Ofir, Javilá y Yobab. Tales los hijos de Yoctán."
,"24":"Sem, Arfaxad, Sélaj,"
,"25":"Héber, Péleg, Reú,"
,"26":"Sarug, Najor, Téraj,"
,"27":"Abrán, o sea Abrahán."
,"28":"Hijos de Abrahán: Isaac e Ismael."
,"29":"Ésta es su descendencia: Nebayot, primogénito de Ismael, Quedar, Adbeel, Mibsán,"
,"30":"Mismá, Dumá, Masá, Jadad, Temá,"
,"31":"Yetur, Nafís y Quedma. Tales los hijos de Ismael. Hijos de Quetura, concubina de Abrahán: dio a luz a Zimrán, Yocsán, Medán, Madián, Yisbac y Súaj. "
,"32":"Hijos de Yocsán: Sebá y Dedán."
,"33":"Hijos de Madián: Efá, Efer, Henoc, Abidá y Eldaá. Tales los hijos de Quetura."
,"34":"Abrahán engendró a Isaac. Hijos de Isaac: Esaú e Israel."
,"35":"Hijos de Esaú: Elifaz, Reuel, Yeús, Yalán y Coré."
,"36":"Hijos de Elifaz: Temán, Omar, Sefí, Gatán, Quenaz, Timná y Amalec."
,"37":"Hijos de Reuel: Nájat, Zéraj, Samá y Mizá."
,"38":"Hijos de Seír: Lotán, Sobal, Sibeón, Aná, Disón, Eser y Disán."
,"39":"Hijos de Lotán: Jorí y Hemán. Hermana de Lotán: Timná."
,"40":"Hijos de Sobal: Albán, Manájat, Ebal, Sefí y Onán. Hijos de Sibeón: Ayá y Aná."
,"41":"Hijo de Aná: Disón. Hijos de Disón: Jamrán, Esbán, Yitrán y Querán."
,"42":"Hijos de Eser: Bilán, Zaaván y Yaacán. Hijos de Disán: Us y Arán."
,"43":"Éstos son los reyes que reinaron en Edón antes que reinase rey alguno en Israel: Bela, hijo de Beor; su ciudad se llamaba Dinhabá."
,"44":"Bela murió y le sucedió Yobab, hijo de Zéraj, de Bosra."
,"45":"Murió Yobab y le sucedió Jusán, de Temán."
,"46":"Murió Jusán y le sucedió Hadad, hijo de Bedad, que derrotó a los madianitas en los campos de Moab. Su ciudad se llamaba Avit."
,"47":"Murió Hadad y le sucedió Samlá, de Masrecá."
,"48":"Murió Samlá y le sucedió Saúl, de Rejobot del Río."
,"49":"Murió Saúl y le sucedió Baal Janán, hijo de Acbor."
,"50":"Murió Baal Janán y le sucedió Hodad; su ciudad se llamaba Pani y su mujer Mehetabel, hija de Matred de Mezahab."
,"51":"A la muerte de Hodad, en Edón hubo jefes: Timná, Alvá, Yetet,"
,"52":"Olibamá, Elá, Finón,"
,"53":"Quenaz, Temán, Mibsar,"
,"54":"Magdiel e Irán. Tales fueron los jefes de Edón."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Éstos son los doce hijos de Israel: Rubén, Simeón, Leví, Judá, Isacar, Zabulón,"
,"2":"Dan, José, Benjamín, Neftalí, Gad y Aser."
,"3":"Hijos de Judá: Er, Onán y Selá; los tres le nacieron de la hija de Súa, la cananea. Er, primogénito de Judá, era malo a los ojos del Señor, que lo hizo morir."
,"4":"Tamar, nuera de Judá, le dio a luz a Fares y Zéraj. En total, los hijos de Judá fueron cinco."
,"5":"Hijos de Fares: Jesrón y Jamul."
,"6":"Hijos de Zéraj: Zimrí, Etán, Hemán, Calcol y Dardá: cinco en total."
,"7":"Hijo de Carmí: Acar, que fue la desgracia para Israel por haber violado la ley del anatema."
,"8":"Hijo de Etán: Azarías."
,"9":"Hijos de Jesrón: Yerajmeel, Ram y Quelubay."
,"10":"Ram engendró a Aminadab; Aminadab engendró a Nasón, príncipe de los hijos de Judá;"
,"11":"Nasón engendró a Salmá; Salmá engendró a Booz;"
,"12":"Booz engendró a Obed; Obed engendró a Jesé;"
,"13":"Jesé engendró a Eliab, su primogénito; a Abinadab, el segundo, a Simeá, el tercero;"
,"14":"a Netanel, el cuarto; a Raday, el quinto;"
,"15":"a Osen, el sexto, y a David, el séptimo."
,"16":"Sus hermanas fueron Sarvia y Abigaíl. Hijos de Sarvia: Abisay, Joab y Asael: tres."
,"17":"Abigaíl dio a luz a Amasá. El padre de Amasá fue Yéter, ismaelita."
,"18":"Caleb, hijo de Jesrón, engendró de Azubá a Yeriot. Hijos de Azubá: Yéser, Sobab y Ardón."
,"19":"Al morir Azubá, Caleb se casó con Efrata, de la que tuvo a Jur."
,"20":"Jur engendró a Urí, y Urí engendró a Besalel."
,"21":"Jesrón a los sesenta años se casó con la hija de Maquir, padre de Galaad, de la que tuvo a Segub."
,"22":"Segub engendró a Yaír, que tuvo veintitrés ciudades en la tierra de Galaad."
,"23":"Los guesureos y los arameos les conquistaron los poblados de Yaír y Quenat con sus aldeas: sesenta pueblos. Todos estos eran hijos de Maquir, padre de Galaad."
,"24":"Después de la muerte de Jesrón, Caleb se casó con Éfrata, que había sido esposa de Jesrón, su padre, de la que tuvo a Asjur, padre de Técoa."
,"25":"Hijos de Yerajmeel, primogénito de Jesrón: Ram, primogénito; Buná, Orén, Osen y Ajías."
,"26":"Yerajmeel tuvo otra mujer llamada Atará, la madre de Onán."
,"27":"Hijos de Ram, primogénito de Yerajmeel: Maas, Yamín y Equer."
,"28":"Hijos de Onán: Samay y Yadá. Hijos de Samay: Nadab y Abisur."
,"29":"La mujer de Abisur se llamaba Abijail, de la que tuvo a Ajbán y Molid."
,"30":"Hijos de Nadab: Séled y Apaín. Séled murió sin hijos."
,"31":"Hijos de Apaín: Yiseí. Hijo de Yiseí: Sesán. Hijo de Sesán: Ajlay."
,"32":"Hijos de Jadá, hermano de Samay: Yéter y Jonatán. Yéter murió sin hijos."
,"33":"Hijos de Jonatán: Pélet y Zazá. Tales fueron los hijos de Yerajmeel."
,"34":"Sesán no tuvo hijos, sino hijas. Sesán tenía un esclavo egipcio llamado Yarjá."
,"35":"A éste dio Sesán por esposa una de sus hijas, de la que tuvo a Atay."
,"36":"Atay engendró a Natán. Natán engendró a Zabad,"
,"37":"Zabad engendró a Efal, Efal engendró a Obed."
,"38":"Obed engendró a Jehú, Jehú engendró a Azarías,"
,"39":"Azarías engendró a Jales, Jales engendró a Elasá,"
,"40":"Elasá engendró a Sismay, Sismay engendró a Salún,"
,"41":"Salún engendró a Yecamías, Yecamías engendró a Elisamá."
,"42":"Hijos de Caleb, hermano de Yerajmeel: Mesá, su primogénito, que fue padre de Zif, y Maresá, padre de Hebrón."
,"43":"Hijos de Hebrón: Coré, Tapúaj, Requen y Sama."
,"44":"Sama engendró a Raján, padre de Yorqueán. Requen engendró a Samay."
,"45":"Hijo de Samay fue Maón, Maón, padre de Bet Sur."
,"46":"Efá, concubina de Caleb, dio a luz a Jarán, Mosá y Gazez. Jarán engendró a Gazez."
,"47":"Hijos de Yahday: Requén, Jotán, Guesán, Pelet, Efá y Sáaf."
,"48":"Maacá, concubina de Caleb, dio a luz a Séber y Tirjaná."
,"49":"También dio a luz a Sáaf, padre de Madmaná, y a Sebá, padre de Macbená y de Guibeá. Caleb tuvo también una hija llamada Axa."
,"50":"Tales fueron los hijos de Caleb. Hijos de Ur, primogénito de Éfrata: Sobal, padre de Quiriat Yearín. "
,"51":"Salmá, padre de Belén, y Járet, padre de Bet-Gáder."
,"52":"Hijos de Sobal, padre de Quiriat Yearín: Aroé, es decir, la mitad de los menajitas,"
,"53":"los clanes de Quiriat Yearín, los jeturitas, putitas, sumatitas y misraítas. De estos clanes salieron los de Sorea y Estaol."
,"54":"Hijos de Salmá: Belén, los netofatitas, Atrot, Bet-Joab, la otra mitad de los menajitas, los soreítas,"
,"55":"los clanes soforitas que habitaban en Yabés, los tiretitas, simeítas y sucatitas. Éstos son los quenitas, descendientes de Jamat, padre de la casa de Recab."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Hijos de David nacidos en Hebrón: Amnón, el primogénito, de Ajinoán de Yezrael; Daniel, el segundo, de Abigaíl de Carmelo;"
,"2":"Absalón, el tercero, hijo de Maacá, hija de Talmay, rey de Guesur; Adonías, el cuarto hijo de Yaguit;"
,"3":"Sefatías, el quinto, de Abital; Yitreán, el sexto, de Eglá, su mujer."
,"4":"Éstos fueron los seis hijos que le nacieron a David en Hebrón, donde reinó siete años y seis meses. Después reinó treinta y tres años en Jerusalén,"
,"5":"donde le nacieron estos hijos: Samúa, Sobab, Natán y Salomón, los cuatro de Betsabé, hija de Aahiel;"
,"6":"Yibjar, Elisamá, Elifélet,"
,"7":"Nogah, Néfeg, Yafía,"
,"8":"Elisamá, Elyadá y Elifélet: nueve."
,"9":"Todos éstos fueron los hijos de David, sin contar los hijos de las concubinas. Tenían una hermana que se llamaba Tamar."
,"10":"Hijos de Salomón: Roboán; Abías, hijo de Roboán; Asá, hijo de Abías; Josafat, hijo de Asá;"
,"11":"Jorán, hijo de Josafat; Ocozías, hijo de Jorán; Joás, hijo de Ocozías;"
,"12":"Amasías, hijo de Joás; Azarías, hijo de Amasías; Jotán, hijo de Azarías;"
,"13":"Acaz, hijo de Jotán; Ezequías, hijo de Acaz; Manasés, hijo de Ezequías;"
,"14":"Amón, hijo de Manasés; Josías, hijo de Amón."
,"15":"Hijos de Josías: Yojanán, el primogénito; Joaquín, el segundo; Sedecías, el tercero; Salún, el cuarto."
,"16":"Hijos de Joaquín: Jeconías y Sedecías."
,"17":"Hijos de Jeconías, el prisionero: Sealtiel,"
,"18":"Malquirán, Pedayas, Senasar, Yecamías, Hosamá y Nedabías."
,"19":"Hijos de Pedayas: Zorobabel y Simeí. Hijos de Zorobabel: Mesulán, Ananías y Selomit, su hermana."
,"20":"Hijos de Mesulán: Jasubá, Ohel, Berequías, Jasadías, Yusab-Jésed: cinco."
,"21":"Hijos de Ananías: Pelatías e Isaías, los hijos de Refayas, padre de Arnán, padre de Abdías, padre de Secanías."
,"22":"Hijos de Secanías: Semayas, Jatús, Yigal, Baríaj, Nearías y Safat: seis."
,"23":"Hijos de Nearías: Elyoenay, Ezequías y Azricán: tres."
,"24":"Hijos de Elyoenay: Hodayas, Elyasib, Pelayas, Acub, Yojanán, Delayas y Ananí: siete."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Hijos de Judá: Fares, Jesrón, Carmí, Jur y Sobal."
,"2":"Reayas, hijo de Sobal; engendró a Yájat, y Yájat engendró a Ajumay y Lahad. Tales los clanes soreítas."
,"3":"Hijos de Jur, padre de Etán: Yezrael, Yismá y Yidbás. Tenían una hermana que se llamaba Haslelponí."
,"4":"Penuel era padre de Guedor y Ézer, padre de Jusá. Tales son los hijos de Jur, primogénito de Éfrata, padre de Belén."
,"5":"Asjur, padre de Técoa, tuvo dos mujeres: Jelá y Naará."
,"6":"Naará le dio a Ajuzán, Jéfer, Temní y Ajastarí; tales son los hijos de Naará."
,"7":"Hijos de Jelá: Séret, Yesójar y Etnán."
,"8":"Cos engendró a Anub, Asbebá y los clanes de Ajarjel, hijo de Harún."
,"9":"Yabés fue el más famoso de sus hermanos. Su madre le dio el nombre de Yabés, diciendo: 'Le he dado a luz con dolor'."
,"10":"Yabés invocó al Dios de Israel, diciendo: 'Bendíceme, ensancha mi territorio, ayúdame, aleja de mí el infortunio y pon fin a mi aflicción'. Dios le concedió todo lo que había pedido."
,"11":"Quelub, hermano de Sujá, engendró a Majir, padre de Estón."
,"12":"Estón engendró a Bet-Rafá, Paséaj y Tejiná, padre de Ir-Najas; éstos son los hombres de Recab."
,"13":"Hijos de Quenaz: Otniel y Serayas. Hijos de Otniel: Jatat y Meonatay."
,"14":"Meonatay engendró a Ofrá. Serayas engendró a Joab, padre del valle llamado de los Artesanos, pues tal era el oficio de sus habitantes."
,"15":"Hijos de Caleb, hijo de Jefoné: Iru, Elá y Naan. Hijo de Elá: Quenaz."
,"16":"Hijos de Yehalelel: Zif, Zifá, Tiryá y Asarel."
,"17":"Hijos de Esdras: Yéter, Méred, Efer y Yalón. La mujer de Méred dio a luz a Miriam, Samay y Yisbaj, padre de Estemoa;"
,"18":"la mujer de éste, que era judía, dio a luz a Yéred, padre de Guedor; a Jeber, padre de Soco, y a Yecutiel, padre de Zanóaj. Éstos son los hijos de Bitía, la hija del Faraón, esposa de Méred."
,"19":"Hijos de la mujer de Odías, hermana de Najan, padre de Queilá, el garmita, y Estemoa, el macateo."
,"20":"Hijos de Simón: Amnón, Riná, Ben-Janán y Tilón. Hijos de Yiseí: Zójet y Ben-Zójet."
,"21":"Hijos de Selá, hijo de Judá: Er, padre de Lecá; Laedá, padre de Maresá; los clanes de los productores de lino de la casa de Asbea."
,"22":"Joaquín, los hombres de Cozebá, Joás y Saraf, que dominaron en Moab antes de volver a Belén. (Estos hechos son antiguos)."
,"23":"Estos eran alfareros y habitaban en Netaín y Guederá: vivían junto al rey y trabajaban a su servicio."
,"24":"Hijos de Simeón: Nemuel, Yamín, Yarib, Zéraj y Saúl."
,"25":"Salún fue hijo de Saúl, Mibsán de Salún, Mismá de Mibsán."
,"26":"Jamuel de Mismá, Zacur de Jamuel y Simeí de Zacur."
,"27":"Simeí tuvo dieciséis hijos y seis hijas, pero sus hermanos tuvieron pocos hijos, y sus clanes no se multiplicaron como los de los hijos de Judá."
,"28":"Habitaban en Berseba, Moladá, Jasar-Sual,"
,"29":"Bilhá, Esen, Tolad,"
,"30":"Batuel, Jormá, Sicelag,"
,"31":"Bet-Marcabot, Jasar-Susín, Bet-Birí y Saaráyim. Éstas fueron sus ciudades hasta el reinado de David."
,"32":"También eran dominios suyos: Etán, Ain, Rimón, Toquén y Asán: cinco ciudades."
,"33":"Y todos los pueblos de sus términos hasta Baal. Éstos fueron los lugares que habitaron y sus genealogías."
,"34":"Mesobab, Yamlec; Yosá, hijo de Amasías;"
,"35":"Joel; Jehú, hijo de Yosibías, hijo de Asiel;"
,"36":"Elyoenay, Jacoba, Yesojaya, Asayas, Adiel, Yesimiel, Benayas,"
,"37":"Zizá, hijo de Sifeí, hijo de Alón, hijo de Yedayas, hijo de Simrí, hijo de Semayas."
,"38":"Estos hombres, designados nominalmente, eran jefes en sus respectivos clanes, y sus casas patriarcales se propagaron largamente."
,"39":"Fueron desde la entrada de Guedor hasta el oriente del valle en busca de pastos para sus ganados."
,"40":"Encontraron buenos y abundantes pastos y una región vasta, tranquila y apacible, que había sido habitada antes por los camitas."
,"41":"Los simeonitas, descritos más arriba nominalmente, vinieron en tiempo de Ezequías, rey de Judá, conquistaron sus campamentos y sus casas y las destruyeron totalmente hasta el día de hoy, y se establecieron en su lugar, pues allí había pastos para sus rebaños."
,"42":"Quinientos simeonitas se fueron al monte Seír bajo la guía de Pelatías, Nearías, Refayas y Uziel, hijo de Yisí;"
,"43":"derrotaron a los supervivientes de Amalec y se establecieron allí hasta el día de hoy."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Hijos de Rubén, primogénito de Israel. (Rubén era, en efecto, el primogénito; pero cuando profanó el lecho de su padre pasó el derecho de la primogenitura a los hijos de José, hijo de Israel, y perdió la primogenitura."
,"2":"Judá fue más poderoso que sus hermanos y de él salió un jefe, pero la primogenitura fue de José)."
,"3":"Hijos de Rubén, primogénito de Israel: Henoc, Falú, Jesrón y Carmí."
,"4":"Hijos de Joel: Semayas, Gog, Simeí,"
,"5":"Micá, Reayas, Baal"
,"6":"y Beerá, que fue llevado cautivo por Teglat-Falasar, rey de Asiria; era príncipe de los rubenitas."
,"7":"Sus hermanos, por clanes y genealogías: el primero Yeiel, Zacarías,"
,"8":"Belá, hijo de Azaz, hijo de Sema, hijo de Joel. Rubén fue quien se estableció en Aroer, extendiéndose hasta Nebo y Baal Meón. "
,"9":"Por el oriente llegó hasta la entrada del desierto, que se extiende hasta el Éufrates, pues tenía muchos ganados en la tierra de Galaad."
,"10":"En tiempo de Saúl hicieron la guerra a los agareos, los derrotaron y se establecieron en sus tiendas en toda la zona oriental de Galaad."
,"11":"Frente a ellos, los hijos de Gad habitaban la tierra de Basán hasta Salcá."
,"12":"Joel fue el primero; Safán, el segundo; luego Yanai y Safat, en Basán."
,"13":"Sus hermanos, por familias patriarcales: Miguel, Mesulán, Seba, Yoray, Yacán, Zía y Eber: siete."
,"14":"Hijos de Abijail: Ben Jurí, Ben Zaróaj, Ben Galaad, Ben Miguel, Ben Jesisay, Ben Yajdó, Ben Buz."
,"15":"Ají, hijo de Abdiel, hijo de Guni, era el jefe de la familia patriarcal."
,"16":"Vivían en Galaad, en Basán y regiones adyacentes y en los pastizales del Sarón hasta sus últimos confines."
,"17":"Todos éstos fueron catalogados en genealogías en tiempo de Jotán, rey de Judá, y de Jeroboán, rey de Israel."
,"18":"Los hijos de Rubén, los de Gad y la media tribu de Manasés, hombres guerreros, portadores del escudo y de la espada, diestros en el manejo del arco y hábiles en el arte de la guerra, en número de 44.760, aptos para las armas,"
,"19":"hicieron la guerra a los agareos, a Yetur, a Nafís y a Nodab."
,"20":"Dios vino en su ayuda contra aquéllos, y los agareos y todos sus aliados cayeron en sus manos, pues en medio del combate invocaron el nombre de Dios, que escuchó su clamor por haber puesto en él su confianza."
,"21":"Se adueñaron de sus ganados: 50.000 camellos, 250.000 ovejas, 2.000 asnos y 100.000 personas;"
,"22":"como Dios había dirigido el combate, la mayor parte habían muerto en él. Se instalaron en sus territorios hasta que fueron llevados al destierro."
,"23":"Los hijos de la media tribu de Manasés se establecieron en la región que se extiende entre Basán y Baal Hermón, el Sanir y el monte de Hermón. Eran numerosos."
,"24":"Éstos son los jefes de sus casas patriarcales: Efer, Yiseí, Eliel, Azriel, Jeremías, Hodavías y Yajdiel. Eran hombres valerosos, gente famosa, jefes de sus casas patriarcales."
,"25":"Pero fueron infieles al Dios de sus padres y adoraron a los dioses de las gentes del país que Dios había destruido ante ellos."
,"26":"El Dios de Israel incitó contra ellos a Pul, rey de Asiria (es decir, a Teglat-Falasar), el cual desterró a los rubenitas, a los gaditas y a la media tribu de Manasés: los deportó a Jalaj, Jabor, Jará y el río Gozán, donde viven hasta el día de hoy."
}`)
	CurrentBook.AddChapter(6, `{
"1":"(27 )Hijos de Leví: Guersón Quehat y Merarí."
,"2":"(28 )Hijos de Quehat Amrán, Yishar, Hebrón y Uziel."
,"3":"(29 )Hijos de Amrán: Aarón, Moisés y María. Hijos de Aarón: Nadab, Abihú, Eleazar e Itamar."
,"4":"(30 )Eleazar engendró a Fineés, Fineés engendró a Abisúa,"
,"5":"(31 )Abisúa engendró a Buquí, Buquí engendró a Uzí,"
,"6":"(32 )Uzí engendró a Zerajías, Zerajías engendró a Merayot"
,"7":"(33 )Merayot engendró a Amarías, Amarías engendró a Ajitub,"
,"8":"(34 )Ajitub engendró a Sadoc, Sadoc engendró a Ajimaas,"
,"9":"(35 )Ajimaas engendró a Azarías, Azarías engendró a Yojanán"
,"10":"(36 )Yojanán engendró a Azarías, que ejerció el sacerdocio en el templo edificado por Salomón en Jerusalén."
,"11":"(37 )Azarías engendró a Amarías, Amarías engendró a Ajitub,"
,"12":"(38 )Ajitub engendró a Sadoc, Sadoc engendró a Salún,"
,"13":"(39 )Salún engendró a Jelcías, Jelcías engendró a Azarías,"
,"14":"(40 )Azarías engendró a Serayas, Serayas engendró a Yehosadac,"
,"15":"(41 )Yehosadac fue llevado al destierro cuando el Señor desterró a Judá y a Jerusalén por mano de Nabucodonosor."
,"16":"(1 )Hijos de Leví: Guersón, Quehat y Merarí."
,"17":"(2 )Hijos de Guersón: Libní y Simeí."
,"18":"(3 )Hijos de Quehat: Amrán, Yishar, Hebrón y Uziel."
,"19":"(4 )Hijos de Merarí: Majlí y Musí. Tales son los clanes de Leví por casas patriarcales."
,"20":"(5 )Por Guersón: Libní, Yájat, Zimmá"
,"21":"(6 )y Oaj, Idó, Zéraj y Yeatray."
,"22":"(7 )Por Quehat: Aminadab, Coré, Asir,"
,"23":"(8 )Elcaná, Ebyasat, Asir,"
,"24":"(9 )Tájat, Uriel, Uzías, Saúl."
,"25":"(10 )Hijos de Elcaná: Amasay y Ajimot."
,"26":"(11 )Hijos de Ajimot: Elcaná, Sofay, Najat,"
,"27":"(12 )Eliab, Yeroján y Elcaná."
,"28":"(13 )Hijos de Samuel: Joel, el primogénito, y Abías, el segundo."
,"29":"(14 )Hijos de Merarí: Majlí, Libní, Simeí, Uzá,"
,"30":"(15 )Simá, Yaguías y Asayas."
,"31":"(16 )Éstos son los cantores nombrados por David para dirigir el canto en el templo del Señor cuando se colocó allí el arca."
,"32":"(17 )Servían como cantores en la tienda de la reunión hasta que Salomón edificó el templo del Señor en Jerusalén: ejercían su servicio según reglas propias."
,"33":"(18 )Eran éstos, junto con sus hijos: de los descendientes de Quehat: Hemán, el cantor, hijo de Joel, hijo de Samuel,"
,"34":"(19 )hijo de Elcaná, hijo de Yeroján, hijo de Eliel, hijo de Tóaj,"
,"35":"(20 )hijo de Suf, hijo de Elcaná, hijo de Májat, hijo de Amasay,"
,"36":"(21 )hijo de Elcaná, hijo de Joel, hijo de Azarías, hijo de Sofonías,"
,"37":"(22 )hijo de Tájat, hijo de Asir, hijo de Ebyasaf, hijo de Coré,"
,"38":"(23 )hijo de Yishar, hijo de Quehat, hijo de Leví, hijo de Israel."
,"39":"(24 )A su derecha estaba su pariente Asaf, hijo de Baraquías, hijo de Simá,"
,"40":"(25 )hijo de Miguel, hijo de Baasías, hijo de Malquías,"
,"41":"(26 )hijo de Etní, hijo de Zéraj, hijo de Adayas,"
,"42":"(27 )hijo de Etán, hijo de Zimá, hijo de Simeí,"
,"43":"(28 )hijo de Yáiat, hijo de Guersón, hijo de Leví."
,"44":"(29 )A la izquierda de los descendientes de Merarí, su pariente Etán, hijo de Cusí, hijo de Abdí, hijo de Maluc,"
,"45":"(30 )hijo de Jasabías, hijo de Amasías, hijo de Jelcías,"
,"46":"(31 )hijo de Amasí, hijo de Baní, hijo de Sémer,"
,"47":"(32 )hijo de Majlí, hijo de Musí, hijo de Merarí, hijo de Leví."
,"48":"(33 )Sus hermanos los levitas estaban enteramente dedicados al servicio del templo de Dios."
,"49":"(34 )Aarón y sus hijos ofrecían los sacrificios sobre el altar de los holocaustos, y el incienso sobre el altar de los perfumes; se ocupaban de todo lo que se refería al lugar santísimo, y del rito de absolución sobre Israel, en todo lo cual se ajustaban a lo prescrito por Moisés, siervo de Dios."
,"50":"(35 )Hijos de Aarón: Eleazar, Fineés, Abisúa,"
,"51":"(36 )Buquí, Uzí, Zerayas,"
,"52":"(37 )Merayot, Amarías, Ajitub,"
,"53":"(38 )Sadoc y Ajimaas."
,"54":"(39 )Éstas fueron sus ciudades con su demarcación: A los hijos de Aarón, del clan quehatita, les tocó en suerte "
,"55":"(40 )Hebrón, en territorio de Judá, con sus ejidos"
,"56":"(41 )menos el campo y sus poblados, que se los dieron a Caleb, hijo de Jefoné"
,"57":"(42 )les dieron también como ciudades de refugio: Hebrón y Libná con sus ejidos Yatir y Estemoa con sus ejidos,"
,"58":"(43 )Jelón y Debir con sus ejidos,"
,"59":"(44 )Asán y Bet Semes con sus ejidos."
,"60":"(45 )En la tribu de Benjamín les dieron Gueba, Alémet y Anatot con sus ejidos. En total, trece ciudades."
,"61":"(46 )A los otros hijos de Quehat les tocaron en suerte diez ciudades de la tribu de Efraín, de la de Dan y de la media tribu de Manasés."
,"62":"(47 )A los hijos de Guersón y sus clanes, trece ciudades de las tribus de Isacar, de Aser, de Neftalí y de Manasés, en Basán"
,"63":"(48 )A los hijos de Merarí y sus clanes, doce ciudades de las tribus de Rubén, de Gad y de Zabulón."
,"64":"(49 )Los israelitas dieron a los levitas estas ciudades con sus ejidos."
,"65":"(50 )Les dieron por sorteo las ciudades de las tribus de Judá, de Simeón y de Benjamín ya citadas."
,"66":"(51 )A otros hijos de Quehat les tocaron en suerte ciudades de la tribu de Efraín;"
,"67":"(52 )les dieron también como ciudades de refugio: Siquén y sus ejidos en la montaña de Efraín, Guézer y sus ejidos,"
,"68":"(53 )Yocmeán Bejorón"
,"69":"(54 )Ayalón y Gat Rimón con sus ejidos."
,"70":"(55 )De la media tribu de Manasés les dieron: Aner y Bileán con sus ejidos. Todo esto para el clan de los otros hijos de Quehat."
,"71":"(56 )A los hijos de Guersón: de la media tribu de Manasés: Golán y sus ejidos en Basán, Astarot y sus ejidos;"
,"72":"(57 )de la tribu de Isacar: Cades y Dobrat con sus ejidos,"
,"73":"(58 )Ramot y Anén con sus ejidos;"
,"74":"(59 )de la tribu de Aser: Masal y Abdón con sus ejidos,"
,"75":"(60 )Jucot y Rejob con sus ejidos;"
,"76":"(61 )de la tribu de Neftalí: Cades de Galilea con sus ejidos, Jammón y Quiriat Yearín con sus ejidos."
,"77":"(62 )A los demás hijos de Merarí les dieron, de la tribu de Zabulón: Rimón y Tabor con sus ejidos;"
,"78":"(63 )del otro lado del Jordán, frente a Jericó, al oriente del Jordán, de la tribu de Rubén: Béser y Yahsa con sus ejidos,"
,"79":"(64 )Quedemot y Mefaat con sus ejidos;"
,"80":"(65 )y de la tribu de Gad: Ramot de Galaad y Majanáyim con sus ejidos"
,"81":"(66 )Jesbón y Yazer con sus ejidos."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Hijos de Isacar: Tolá, Puá, I Yasub y Simrón: cuatro."
,"2":"Hijos de Tolá: Uzí, Refayas, Yeriel, Yajmay, Yibsán y Samuel, jefes de las familias patriarcales de Tolá. Estos sumaban en los días de David 22.600 hombres valerosos, agrupados por linajes."
,"3":"Hijos de Uzí: Yizrajías, padre de Miguel; Abdías, Joel, Yisías: cinco jefes en total,"
,"4":"que mandaban 36.000 hombres de guerra, divididos por descendencias y familias patriarcales. Eran muchas las mujeres y los niños."
,"5":"Sus hermanos, incluidos todos los clanes de Isacar, sumaban un total de 87.000 hombres: todos agrupados en sus genealogías."
,"6":"Hijos de Benjamín: Bela, Béquer y Yediael: tres."
,"7":"Hijos de Bela: Esbón, Uziel, Yerimot e Irí: cinco jefes de casa patriarcal, hombres valerosos, registrados con sus genealogías en número de 22.034."
,"8":"Hijos de Béquer: Zemirá, Joás, Eliezer, Elyoenai, Omrí, Yeremot, Abías, Anatot y Alémet: todos éstos eran hijos de Béquer,"
,"9":"jefes de casas patriarcales, hombres valerosos, agrupados en genealogías según sus linajes, en número de 20.200."
,"10":"Hijos de Yediael: Bilhán, padre de Yehús, Benjamín, Ehúd, Quenaná, Zetán, Tarsis y Ajisajar:"
,"11":"todos hijos de Yediael, jefes de sus casas patriarcales, hombres valerosos, en número de 17.200, aptos para salir a la guerra y al combate."
,"12":"Supín y Jupín, hijos de Ir; Jusín, hijo de Ajer."
,"13":"Hijos de Neftalí: Yajsiel, Guní, Yézer y Salún, hijos de Bilhá."
,"14":"Hijos de Manasés: Asriel tenía por madre a la concubina aramea de Manasés, la cual dio a luz también a Maquir, padre de Galaad."
,"15":"Maquir tomó una mujer para Jupín y Supín. Su hermana se llamaba Maacá. El nombre del segundo hijo de Manasés era Selofjad. Selofjad tuvo hijas."
,"16":"Maacá, mujer de Maquir, tuvo un hijo y le llamó Fares. Su hermano se llamaba Seres, y sus hijos Ulán y Requen."
,"17":"Hijo de Ulán: Bedán. Éstos fueron los hijos de Galaad, hijo de Maquir, hijo de Manasés."
,"18":"Su hermana Hamoléquet dio a luz a Ishod, Abiezer y Majlá."
,"19":"Hijos de Semidá: Ajián, Siquén, Liqjí y Anián."
,"20":"Hijos de Efraín: Sutélaj, Bered, su hijo; Tájat,"
,"21":"Zabad; Sutélaj; Ezer y Elead. Los nativos de Gat los mataron porque habían bajado a robar sus ganados."
,"22":"Efraín, su padre, les guardó luto durante mucho tiempo, y sus hermanos vinieron a consolarlo."
,"23":"Después se unió a su mujer, la cual concibió y dio a luz un hijo, al que llamó Beriá, aflicción, pues nació cuando estaba su casa afligida."
,"24":"Su hija Será edificó Bejorón de Abajo y Bejorón de Arriba y Uzenserá."
,"25":"Hijos de Beriá: Réfaj, Résef, Télaj, Taján,"
,"26":"Ladán, Amihud, Elisamá,"
,"27":"Nun y Josué."
,"28":"Sus dominios y ciudades eran: Betel; al oriente, Naarán; al occidente, Guézer; Siquén y Ayá con sus respectivas aldeas."
,"29":"Pertenecían también a los hijos de Manasés: Betrán, Tanac, Megido y Dor con sus respectivas aldeas. En estas ciudades residían los hijos de Josué, hijo de Israel."
,"30":"Hijos de Aser: Yimná, Yisvá, Yisví, Beriá y Seraj, su hermana."
,"31":"Hijos de Beriá: Jéber y Malquiel, padre de Birzayit."
,"32":"Jéber engendró a Yaflet, Somer, Yotán y a Suá, su hermana."
,"33":"Hijos de Yaflet: Pasac, Bimhal y Asvat."
,"34":"Hijos de Somer, su hermano: Ají, Rohgá, Jubá y Arán."
,"35":"Hijos de Elén, su hermano: Sofaj, Yimná, Seles y Amal."
,"36":"Hijos de Sofaj: Súaj, Jarnéfer, Sual, Berí, Yimrá,"
,"37":"Béser, Hod, Sammá, Silsá, Yitrán y Beerá."
,"38":"Hijos de Yeter: Jefoné, Pispá y Ará."
,"39":"Hijos de Ulá: Araj, Janiel y Risiá."
,"40":"Todos éstos eran hijos de Aser, jefes de casas patriarcales, gente selecta y guerreros valerosos, jefes de príncipes; los registrados por genealogías, aptos para la guerra y el combate, sumaban 26.000 hombres."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Benjamín engendró a Bela, su primogénito; a Asbel, el segundo; a Ajraj, el tercero;"
,"2":"a Nojá, el cuarto, y a Rafá, el quinto."
,"3":"Hijos de Bela: Adar, Guerá, Abihud,"
,"4":"Abisúa, Naamán, Ajoaj,"
,"5":"Guerá, Sefufán y Jurán."
,"6":"Hijos de Ejud, jefes de familia que vivían en Gueba y fueron deportados a Manajat:"
,"7":"Naamán, Ajías y Guerá. Éste fue quien los llevó al destierro; engendró a Uzá y Ajijud."
,"8":"Sajaráyim tuvo más hijos en el país de Moab, después de haberse divorciado de sus mujeres Jusín y Bará."
,"9":"De su nueva mujer tuvo a Yobab, Sibiá, Mesá, Malcón,"
,"10":"Yeús, Saquías y Mirmá. Éstos son sus hijos, jefes de familias."
,"11":"De Jusín había tenido a Abitub y Elpáal."
,"12":"Hijos de Elpáal: Héber, Misán y Semed, que fundó Onó y Lod con sus aldeas."
,"13":"Beriá y Sema, jefes de familia entre los habitantes de Ayalón, hicieron huir a los habitantes de Gat."
,"14":"Sasac y Yeremot eran sus hermanos:"
,"15":"Zebadías, Arad, Eder,"
,"16":"Miguel, Yispá y Yojá eran hijos de Beriá."
,"17":"Zebadías, Mesulán, Jizquí, Jéber,"
,"18":"Yismeray, Yizliá y Yobab eran hijos de Elpáal."
,"19":"Joaquín, Zicrí, Zabdí,"
,"20":"Elyoenay, Siltay, Eliel,"
,"21":"Adayas, Barayas y Simrat eran hijos de Semeí."
,"22":"Yispán, Eber, Eliel,"
,"23":"Abdón, Zicrí, Janán,"
,"24":"Jananías, Elán, Antotías,"
,"25":"Yifdías y Penuel eran hijos de Sasac."
,"26":"Samseray, Sejarías, Atalías,"
,"27":"Yaresías, Elías y Zicrí eran hijos de Yeroján."
,"28":"Éstos eran jefes de familia, agrupados según sus linajes; habitaban en Jerusalén."
,"29":"El padre de Gabaón vivía en Gabaón. Su mujer se llamaba Maacá."
,"30":"Su hijo primogénito fue Abdón; después vinieron Sur, Quis, Baal, Nadab,"
,"31":"Guedor, Ajiá, Zequer y Miclot."
,"32":"Miclot engendró a Simá. Éstos vivían también en Jerusalén con sus hermanos."
,"33":"Ner engendró a Quis, Quis engendró a Saúl, Saúl engendró a Jonatán, Malquisúa, Abinadab e Isbaal."
,"34":"Hijo de Jonatán: Meribaal, que engendró a Micá."
,"35":"Hijos de Micá: Pitón, Mélec, Tarea y Ajaz."
,"36":"Ajaz engendró a Yehoadá, Yehoadá engendró a Alémet, Azmávet y Zimrí; Zimrí engendró a Mosá,"
,"37":"Mosá engendró a Biná, padre de Rafá, padre de Eleasá, padre de Asel."
,"38":"Asel tuvo seis hijos: Azricán, Bocrú, Ismael, Searías, Abdías y Janán."
,"39":"Hijos de Esec, su hermano: Ulán, su primogénito; Yehús, el segundo, y Elifélet el tercero."
,"40":"Los hijos de Ulán eran guerreros valerosos, diestros en el manejo del arco; tuvieron muchos hijos y nietos, hasta 150. Todos éstos fueron descendientes de Benjamín."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Todos los israelitas fueron agrupados por genealogías e inscritos en el libro de los reyes de Israel y de Judá cuando fueron deportados a Babilonia en castigo de sus prevaricaciones."
,"2":"Los primeros en volver a habitar en sus dominios y ciudades fueron israelitas laicos, sacerdotes, levitas y servidores del templo."
,"3":"En Jerusalén se establecieron algunos de Judá, de Benjamín, de Efraín y de Manasés."
,"4":"Utay, hijo de Amihúd, hijo de Omrí, hijo de Imrí, hijo de Baní, del linaje de Fares, hijo de Judá."
,"5":"De los silonitas: Asaya, el primogénito, y sus hijos."
,"6":"De Zéraj: Yeuel y sus hermanos: 690 hombres."
,"7":"De Benjamín: Salú, hijo de Mesulán, hijo de Hodavías, hijo de Hasenúa;"
,"8":"Yibnayas, hijo de Yeroján; Elá, hijo de Uzí, hijo de Micrí; Mesulán, hijo de Sefatías, hijo de Reuel, hijo de Yibnías,"
,"9":"además de sus hermanos, distribuidos por linajes: 956. Todos éstos eran cabezas de familia."
,"10":"De los sacerdotes: Jedaías, Yehoyarib, Yoaquín,"
,"11":"Azarías, hijo de Jelcías, hijo de Masulán, hijo de Sadoc, hijo de Merayot, hijo de Ajitub, jefe del templo de Dios;"
,"12":"Adayas, hijo de Yeroján, hijos de Pasjur, hijo de Malaquías; Masay, hijo de Adiel, hijo de Yajzerá, hijo de Mesulán, hijo de Mesilemit, hijo de Imer;"
,"13":"además de sus hermanos, cabezas de familia: 1.760 hombres valerosos, dedicados al servicio de la casa de Dios."
,"14":"De los levitas: Semayas, hijo de Jasub, hijo de Azricán, hijo de Jasabías, de los descendientes de Merarí;"
,"15":"Bacbacar, Jeres, Galal; Matanías, hijo de Micá, hijo de Zicrí, hijo de Asaf;"
,"16":"Abdías, hijo de Semayas, hijo de Galal, hijo de Yedutún; Berequías, hijo de Asá, hijo de Elcaná, que habitaba en los poblados netofatitas."
,"17":"De los porteros: Salún, Acub, Talmón, Ajinán y sus hermanos. Salún era el jefe."
,"18":"Hasta el presente estaban encargados de la puerta real, al oriente, y eran porteros en los campamentos de los hijos de Leví."
,"19":"Salún, hijo de Coré, hijo de Abiasaf, hijo de Córaj, y sus hermanos, los corajitas, de la misma casa patriarcal, se dedicaban al servicio litúrgico y guardaban como porteros la entrada de la tienda, como habían hecho sus padres un día con la entrada del campamento del Señor."
,"20":"Fineés, hijo de Eleazar, había sido su jefe en otro tiempo. El Señor estaba con él."
,"21":"Zacarías, hijo de Meselemías, era portero de la entrada de la tienda de la reunión."
,"22":"Los porteros que guardaban las entradas, hombres elegidos, sumaban en total 212, registrados por poblaciones. Los habían constituido en sus funciones David y Samuel, el vidente, como premio a su fidelidad."
,"23":"Ellos y sus descendientes tenían a su cargo las puertas del templo del Señor, la tienda."
,"24":"Los porteros estaban colocados en los cuatro puntos cardinales: este, oeste, norte y sur."
,"25":"Sus hermanos, que seguían en sus aldeas, venían a ayudarlos periódicamente por turno de siete días."
,"26":"En cambio, los cuatro jefes de los porteros que permanecían allí siempre eran levitas y tenían a su cargo las cámaras y tesoros del templo de Dios."
,"27":"Pasaban la noche en los alrededores de la casa de Dios, pues estaban encargados de custodiarla y de abrir sus puertas cada mañana."
,"28":"Algunos de ellos tenían a su cargo los utensilios del culto, que eran contados cuando salían y cuando entraban."
,"29":"Otros cuidaban del mobiliario, de los objetos sagrados, de la flor de harina, del vino, del aceite, del incienso y los perfumes."
,"30":"Los que preparaban la mezcla de los perfumes aromáticos eran sacerdotes."
,"31":"Matatías, uno de los levitas, primogénito de Samuel el corajita, tenía la misión de preparar las tortas fritas en sartén."
,"32":"Otros de sus hermanos, descendientes de Quehat, cuidaban de preparar para cada sábado los panes de la proposición."
,"33":"Los cantores, jefes de familias levíticas, que vivían en las cámaras del templo, estaban exentos de toda otra función, pues día y noche estaban ocupados en su oficio."
,"34":"Éstos eran los cabezas de las familias levíticas por linajes. Vivían en Jerusalén."
,"35":"Jeiel, padre de Gabaón, vivía en Gabaón. Su mujer se llamaba Maacá."
,"36":"Su hijo primogénito fue Abdón; después vinieron Sur, Quis, Baal, Ner, Nadab,"
,"37":"Guedor, Ajió, Zacarías y Miclot."
,"38":"Miclot engendró a Simán. Éstos vivían también en Jerusalén con sus hermanos."
,"39":"Ner engendró a Quis, Quis engendró a Saúl, Saúl engendró a Jonatán, Malquisúa, Abinadab e Isbaal."
,"40":"Hijo de Jonatán: Meribaal, que engendró a Micá."
,"41":"Hijos de Micá: Pitón, Mélec, Tarea y Acaz."
,"42":"Acaz engendró a Yaía, Yaía engendró a Alémet, Azmávet y Zimrí; Zimrí engendró a Mosá."
,"43":"Mosá engendró a Bineá, padre de Rafayas, padre de Eleasá, padre de Asel."
,"44":"Asel tuvo seis hijos: Azricán, Bocrú, Ismael, Searías, Abdías, y Janán. Éstos son los hijos de Asel."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Los filisteos libraron la batalla contra Israel. Los israelitas huyeron ante los filisteos, y cayeron muertos en gran número en el monte Gelboé."
,"2":"Los filisteos persiguieron a Saúl y a sus hijos, y mataron a Jonatán, Abinadab y Malquisúa, hijos de Saúl."
,"3":"El peso de la batalla cayó sobre Saúl; los arqueros lo alcanzaron y fue mal herido."
,"4":"Saúl dijo entonces a su escudero: 'Desenvaina tu espada y traspásame con ella, no vengan esos incircuncisos y se burlen de mí'. Pero su escudero no quiso, pues tenía mucho miedo. Entonces tomó Saúl su espada y se echó sobre ella."
,"5":"Cuando el escudero vio que Saúl había muerto, se echó también sobre su espada y murió con él."
,"6":"Y así murieron juntos Saúl, sus tres hijos y toda su casa."
,"7":"Cuando los israelitas del valle vieron que habían huido y que Saúl con sus tres hijos habían muerto, abandonaron también ellos sus ciudades y se dieron a la fuga. Los filisteos vinieron y se establecieron en ellas."
,"8":"Al día siguiente los filisteos fueron a despojar a los caídos y encontraron a Saúl y sus hijos caídos en el monte Gelboé."
,"9":"Les despojaron de sus armas, les cortaron la cabeza e hicieron publicar la buena nueva por todo el país de los filisteos, a los cuatro vientos, a sus ídolos y al pueblo."
,"10":"Depositaron las armas de Saúl en la casa de su dios y colgaron la cabeza en el templo de Dagón."
,"11":"Cuando los habitantes de Yabés Galaad supieron lo que los filisteos habían hecho con Saúl,"
,"12":"todos los valientes se pusieron en marcha, tomaron los cuerpos de Saúl y sus hijos, los llevaron a Yabés, los sepultaron bajo la encina de Yabés y ayunaron durante siete días."
,"13":"Saúl murió por haber sido infiel al Señor: no había observado sus palabras y, además, había preguntado y consultado a una nigromántica."
,"14":"No consultó al Señor, que le hizo morir, transfiriendo el reino a David, hijo de Jesé."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Todos los israelitas fueron a Hebrón a decir a David: 'Mira, nosotros somos hueso de tu hueso y carne de tu carne."
,"2":"Ya antes, cuando todavía reinaba Saúl, eras tú el que mandabas el ejército de Israel. El Señor te había dicho: Tú apacentarás a mi pueblo, Israel, y tú serás el jefe de mi pueblo, Israel'."
,"3":"Todos los ancianos de Israel fueron a Hebrón a ver al rey, y el rey David hizo con ellos un pacto ante el Señor. Ungieron a David por rey de Israel, según la palabra del Señor transmitida por Samuel."
,"4":"David y todo Israel marcharon sobre Jerusalén, que se llamaba Jebús, en cuya región estaban establecidos los jebuseos."
,"5":"Los habitantes de Jebús dijeron a David: 'No entrarás aquí'. Pero David se apoderó de la fortaleza de Sión, llamada luego ciudad de David."
,"6":"David había dicho: 'El primero que mate a un jebuseo será el jefe primero'. Joab, hijo de Sarvia, fue el primero, y fue nombrado jefe."
,"7":"David se estableció en la fortaleza, que por eso se llamó la ciudad de David."
,"8":"Reconstruyó la ciudad, todo alrededor desde el terraplén hacia la periferia, y Joab reconstruyó el resto de la ciudad."
,"9":"David iba fortaleciéndose de día en día, y el Señor todopoderoso estaba con él."
,"10":"Éstos son los jefes de los héroes de David que estaban a su servicio y lo ayudaban con todo Israel a asegurar su dominio para establecerlo como rey, según la palabra que el Señor había pronunciado sobre Israel."
,"11":"He aquí la lista de los héroes de David: Yasobán, jacamonita, jefe de los tres, el cual blandió la lanza contra trescientos, a los que mató de un solo golpe. "
,"12":"Después de él, Eleazar, hijo de Dodó, el ajojita, uno de los tres héroes."
,"13":"Estaba con David en Pas Damín, cuando los filisteos se reunieron allí para la lucha. Había allí un campo plantado de cebada, y el ejército huía ya delante de los filisteos;"
,"14":"pero él se puso en medio del campo, lo defendió y derrotó a los filisteos. El Señor alcanzó de nuevo una gran victoria."
,"15":"Tres de los treinta fueron a la roca de la cueva de Adulán, donde estaba David, mientras los filisteos estaban acampados en el valle de Refaín."
,"16":"David estaba en el refugio mientras los filisteos tenían una guarnición en Belén."
,"17":"David expresó este deseo: '¡Quién me diera de beber agua del pozo que está en la puerta de Belén!'."
,"18":"Entonces los tres, abriéndose camino a través del campamento filisteo, sacaron agua del pozo que está en la puerta de Belén, la llevaron y se la ofrecieron a David; pero David no quiso beberla y la derramó como ofrenda ante el Señor, diciendo:"
,"19":"'¡Líbreme Dios de hacer tal cosa! ¿Voy a beber yo la sangre de estos hombres, que han traído el agua con riesgo de sus vidas?'. Y no quiso beberla. Esto hicieron los tres héroes."
,"20":"Abisay, hermano de Joab, era jefe de los treinta. Él fue quien blandió su lanza contra trescientos, los mató y adquirió fama entre los treinta."
,"21":"Llegó a ser el más famoso de los treinta, y se convirtió en su jefe; pero no llegaba a los tres."
,"22":"Benayas, hijo de Yehoyadá, hombre valiente, rico en hazañas, de Cabseel, mató a los dos héroes de Moab; y él fue también quien, un día de nieve, bajó a una cisterna y mató a un león."
,"23":"Mató también a un egipcio que medía dos metros y medio de alto y tenía una lanza semejante a un enjullo de tejedor; fue contra él con un palo, le quitó al egipcio la lanza y con ella lo mató."
,"24":"Esto hizo Benayas, hijo de Yehoyadá, que se hizo famoso entre los treinta."
,"25":"Fue el más famoso de los treinta, pero no llegaba a los tres. David lo puso a la cabeza de su guardia personal."
,"26":"Los héroes del ejército eran: Asael, hermano de Joab; Eljanán, hijo de Dodó, de Belén;"
,"27":"Samot, de Harod, y Jeles, pelonita;"
,"28":"Irá, hijo de Iqués, de Tecoa; Abiezer, de Anatot;"
,"29":"Sibecay, jusita; Ilay, ajojita;"
,"30":"Mahray, netofatita; Jéled, hijo de Baná, netofatita;"
,"31":"Itay, hijo de Ribay, de Guibeá de Benjamín; Benayas, piratonita;"
,"32":"Juray, de los valles de Gaas; Abiel, arbatita;"
,"33":"Azmávet, bajurinita; Elyajabá, saalbonita;"
,"34":"Jasén, gunita; Jonatán, hijo de Sagué, ararita;"
,"35":"Ajián, hijo de Sacar, ararita; Elifal, hijo de Ur;"
,"36":"Jéfer, de Mequerá; Ajías, el pelonita;"
,"37":"Jesró, de Carmelo; Naaray, hijo de Ezbay;"
,"38":"Joel, hermano de Natán; Mibjar, hijo de Hagrí;"
,"39":"Selec, amonita; Najray, de Berot, escudero de Joab, hijo de Sarvia;"
,"40":"Irá, de Yatir; Gareb, de Yatir;"
,"41":"Urías, hitita; Zabad, hijo de Ajlay;"
,"42":"Adiná, hijo de Sizá, rubenita, jefe de los rubenitas, y treinta con él;"
,"43":"Janán, hijo de Maacá; Josafat, el mitnita;"
,"44":"Uzías, de Astarot; Samá y Yequiel, hijo de Jotán, de Aroer,"
,"45":"Yediael, hijo de Simrí; Yojá, su hermano, tisita;"
,"46":"Eliel, de Majavín; Yeribay y Yosavías, hijos de Elnaán; Yitmá, moabita;"
,"47":"Eliel, Obed y Yaasiel, de Sobá."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Éstos son los que se unieron a David en Sicelag, cuando todavía estaba alejado de Saúl, hijo de Quis, los cuales formaban parte de los héroes que le prestaron su ayuda durante la guerra;"
,"2":"arqueros hábiles en lanzar piedras y flechas lo mismo con la derecha que con la izquierda. Entre los hermanos de Saúl, de la tribu de Benjamín: "
,"3":"Ajiezer, el jefe; Joás, hijo de Semaá, de Guibeá; Yeziel y Pélet, hijo de Azmávet; Beracá y Jehú, de Anatot;"
,"4":"Yismayas, de Gabaón, uno de los treinta héroes y jefe de los treinta;"
,"5":"Jeremías, Yajaziel, Yojanán, Yozabad de Guederá,"
,"6":"Eluzay, Yerimot, Bealías, Semarías, Sefatías, de Jarif;"
,"7":"Elcaná, Isaías, Azarel, Yoézer y Yasobeán, corejitas;"
,"8":"Joela y Jebadías, hijos de Yeroján, de Guedor."
,"9":"También algunos gaditas se unieron a David cuando estaba en el refugio del desierto. Eran hombres valerosos, hombres guerreros, prontos al combate, hábiles en el manejo del escudo y de la lanza, semejantes a leones y ligeros como las gacelas de los montes."
,"10":"Ezer, el jefe; Abdías, el segundo; Eliab, el tercero;"
,"11":"Mismaná, el cuarto; Jeremías, el quinto;"
,"12":"Atay, el sexto; Eliel, el séptimo;"
,"13":"Yojanán, el octavo; Elzabad, el noveno;"
,"14":"Jeremías, el décimo; Macbanay, el undécimo."
,"15":"Todos éstos eran de la tribu de Gad, jefes del ejército, el más pequeño podía hacer frente a cien hombres; el mayor, a mil."
,"16":"Éstos fueron los que cruzaron el Jordán el mes primero, cuando se desbordaba por todas sus márgenes, y pusieron en fuga a los habitantes del valle, tanto a los de la ribera oriental como a los de la occidental."
,"17":"Algunos de la tribu de Benjamín y de Judá fueron asimismo a unirse a David en su refugio."
,"18":"David les salió al encuentro y les dijo: 'Si venís con buenas intenciones, para prestarme ayuda, mi corazón estará con el vuestro; pero si es para traicionarme en provecho de mis enemigos, siendo yo inocente, que lo vea el Dios de nuestros padres y haga justicia'."
,"19":"El espíritu se apoderó de Amasay, jefe de los treinta, que dijo: '¡Somos tuyos, David. Estamos contigo, hijo de Jesé. La paz, la paz contigo y con los tuyos, porque tu ayuda es Dios!'. David los recibió y los puso entre los jefes de tropa."
,"20":"También de la tribu de Manasés se unieron algunos a David cuando iba con los filisteos a luchar contra Saúl; pero no llegó a luchar contra él, pues los príncipes de los filisteos decidieron despedirle diciendo: 'Se pasaría a Saúl, con peligro de nuestras cabezas'."
,"21":"Cuando regresó a Sicelag, se unieron a él algunos de la tribu de Manasés: Adnas, Yozabad, Yediael, Miguel, Yozabad, Elihú y Siltay, jefes de batallones de Manasés."
,"22":"Fue un buen refuerzo para David y su tropa, pues eran todos hombres valerosos, y llegaron a ser jefes del ejército."
,"23":"David recibía diariamente nuevos refuerzos, de manera que su ejército llegó a ser gigantesco."
,"24":"Éste es el total de combatientes equipados para la guerra, que se reunieron en torno a David para transferirle el reino de Saúl, según la orden del Señor:"
,"25":"De la tribu de Judá, armados de escudo y lanza, 6.800 combatientes, equipados para la guerra;"
,"26":"de la tribu de Simeón, 7.100 hombres, valerosos para la guerra;"
,"27":"de la tribu de Leví, 4.600,"
,"28":"más 3.700 de la familia de Aarón mandados por Yehoyadá,"
,"29":"y Sadoc, joven valeroso, con veintidós jefes más de su casa patriarcal;"
,"30":"de la tribu de Benjamín, 3.000 parientes de Saúl, la mayoría de los cuales habían permanecido hasta entonces fieles a la casa de Saúl;"
,"31":"de la tribu de Efraín, 20.800 guerreros valientes y hombres ilustres de su casa patriarcal;"
,"32":"de la media tribu de Manasés, 18.000 hombres designados nominalmente para ir a proclamar rey a David;"
,"33":"de la tribu de Isaca, buenos conocedores del momento en que debía actuar Israel y el modo como debía hacerlo, 200 jefes y todos los hermanos a sus órdenes;"
,"34":"de la tribu de Zabulón, 50.000 hombres prontos a luchar y completamente equipados;"
,"35":"de la tribu de Neftalí, 1.000 jefes con 37.000 hombres armados de escudo y lanza;"
,"36":"de la tribu de Dan, 28.600 hombres en orden de batalla;"
,"37":"de la tribu de Aser, 40.000 hombres de guerra, prontos a combatir;"
,"38":"de Transjordania, de la tribu de Rubén, Gad y la otra media de Manasés, 120.000 hombres perfectamente equipados para la guerra."
,"39":"Todos estos hombres de guerra, prontos para la lucha, se reunieron en Hebrón con entusiasmo y sinceridad para proclamar a David rey de todo Israel, y los demás israelitas estaban también de acuerdo con esta proclamación real."
,"40":"Durante tres días permanecieron allí comiendo y bebiendo con David, pues sus hermanos los habían provisto de víveres."
,"41":"Más aún, desde los alrededores inmediatos hasta las lejanas tribus de Isacar, Dan y Neftalí venían a Hebrón con asnos, camellos, mulos y bueyes con pan, harina, higos, pasas, vino, aceite, ganado mayor y menor en abudancia, pues era fiesta en Israel."
}`)
	CurrentBook.AddChapter(13, `{
"1":"David celebró consejo con los mandos, jefes y oficiales,"
,"2":"y dijo a toda la asamblea de Israel: 'Si os parece bien y creéis que ésta es la voluntad del Señor, nuestro Dios, enviaremos mensajeros a nuestros hermanos esparcidos por todo Israel, a los sacerdotes y a los levitas que habitan en las ciudades y campos de alrededor, para que vengan a reunirse con nosotros,"
,"3":"con el fin de traer con nosotros el arca de nuestro Dios, de la que no nos hemos vuelto a ocupar desde los tiempos de Saúl'."
,"4":"Toda la asamblea resolvió hacerlo así, pues la cosa pareció bien a todos los presentes."
,"5":"Entonces David reunió a todo el pueblo, desde el torrente de Egipto hasta el valle de Jamat, para traer de Quiriat Yearín, en Judá, el arca de Dios."
,"6":"David fue con todo Israel a Baalá, cerca de Quiriat Yearín, en Judá, con el fin de trasladar el arca de Dios, llamada 'el Señor todopoderoso, el que se sienta sobre los querubines'."
,"7":"Tomaron el arca de Dios de casa de Abinadab y la pusieron en un carro nuevo, guiado por Uzá y Ajió."
,"8":"David y todo Israel iban delante cantando y bailando con todas sus fuerzas al son de las cítaras, arpas, tambores, címbalos y trompetas."
,"9":"Cuando llegaban a la era de Quidón, Uzá extendió la mano para sujetar el arca, porque los bueyes la iban a tirar."
,"10":"La cólera del Señor se encendió contra Uzá y lo hirió por haber tocado el arca con la mano. Uzá murió allí, ante Dios."
,"11":"David se apesadumbró al ver que el Señor había herido a Uzá, y llamó aquel lugar 'Peres Uzá', nombre que todavía lleva hoy."
,"12":"El temor de Dios se apoderó aquel día de David, que dijo: '¿Cómo voy a llevar a mi casa el arca de Dios?'."
,"13":"Y David no llevó el arca a su casa, a la ciudad de David, sino que la llevó a casa de Obededón, de Gat."
,"14":"Allí, en la casa de Obededón, permaneció el arca de Dios durante tres meses. Y el Señor bendijo la casa de Obededón y todas sus cosas."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Jirán, rey de Tiro, envió mensajeros a David con madera de cedro, albañiles y carpinteros para que le construyeran un palacio."
,"2":"Entonces David comprendió que el Señor confirmaba su realeza sobre Israel y que ensalzaba su reino por amor de su pueblo, Israel."
,"3":"Una vez en Jerusalén, David tomó más mujeres y engendró más hijos e hijas."
,"4":"Éstos son los hijos que tuvo en Jerusalén: Samúa, Sobat, Natán, Salomón,"
,"5":"Yibjar, Elisúa, Elpálet,"
,"6":"Noga, Néfeg, Yafía,"
,"7":"Elisamá, Belyadá y Elifélet."
,"8":"Cuando los filisteos supieron que David había sido ungido rey de todo Israel, fueron todos en su busca. David se enteró y les salió al encuentro."
,"9":"Los filisteos llegaron y se desplegaron por el valle de Refaín."
,"10":"David consultó a Dios: '¿Debo atacar a los filisteos? ¿Los pondrás en mis manos?'. El Señor le respondió: 'Atácalos, porque los pondré en tus manos'."
,"11":"Los filisteos fueron a Baal Perasín, donde fueron derrotados por David. David dijo: 'Dios ha dispersado a mis enemigos ante mí como se dispersan las aguas'. Por eso se llamó este lugar Baal Perasín."
,"12":"Los filisteos dejaron abandonados allí sus dioses. Y David mandó que les prendieran fuego."
,"13":"Los filisteos ocuparon de nuevo el valle."
,"14":"David consultó otra vez a Dios, y Dios le respondió: 'No los ataques de frente; da un rodeo por detrás y atácalos por el lado de las balsameras."
,"15":"Cuando oigas ruido de pasos por las copas de las balsameras, ataca rápidamente, porque Dios irá delante de ti para derrotar al ejército filisteo'."
,"16":"David hizo como Dios le había mandado y derrotó a los filisteos desde Gabaón hasta Guézer."
,"17":"La fama de David se extendió por toda la región, y el Señor hizo que todos los pueblos le tuvieran miedo."
}`)
	CurrentBook.AddChapter(15, `{
"1":"David construyó casas en la ciudad de su nombre y preparó un lugar para el arca de Dios, donde plantó una tienda."
,"2":"Entonces dijo: 'El arca de Dios no puede ser transportada más que por los levitas, pues el Señor los ha elegido para transportar el arca y estar perpetuamente a su servicio'."
,"3":"David reunió en Jerusalén a todo Israel para trasladar el arca del Señor al lugar que le había preparado."
,"4":"Reunió a los hijos de Aarón y a los levitas:"
,"5":"hijos de Quehat: Uriel, el jefe, y sus 120 hermanos;"
,"6":"hijos de Merarí: Asayas, el jefe, y sus 220 hermanos;"
,"7":"hijos de Guersón: Joel, el jefe, y sus 130 hermanos;"
,"8":"hijos de Elisafán: Semayas, el jefe, y sus 200 hermanos;"
,"9":"hijos de Hebrón: Eliel, el jefe, y sus 80 hermanos;"
,"10":"hijos de Uziel: Aminadab, el jefe, y sus 112 hermanos."
,"11":"David llamó aparte a los sacerdotes Sadoc y Abiatar, a los levitas Uriel, Asayas, Joel, Semayas, Eliel y Aminadab,"
,"12":"y les dijo: 'Vosotros sois los jefes de las familias levíticas; purificaos, vosotros y vuestros hermanos, para trasladar el arca del Señor, el Dios de Israel, al lugar que yo le tengo preparado."
,"13":"Por no estar vosotros allí la primera vez, el Señor, nuestro Dios, nos castigó, porque no le consultamos como es debido'."
,"14":"Sacerdotes y levitas se purificaron para trasladar el arca del Señor, Dios de Israel."
,"15":"Los levitas transportaron el arca apoyando las barras sobre sus hombros, como lo había prescrito Moisés, por orden del Señor."
,"16":"David ordenó a los jefes de los levitas que dispusieran a sus hermanos los cantores con todos los instrumentos musicales de acompañamiento, arpas, cítaras y címbalos, e hicieron resonar bellas melodías en señal de regocijo."
,"17":"Los levitas designaron a Hemán, hijo de Joel; a Asaf, uno de sus hermanos, que era hijo de Baraquías; a Etán, hijo de Cusayas, uno de los meraritas, sus hermanos."
,"18":"Después de ellos, en segundo lugar, estaban sus hermanos: Zacarías, Yaziel, Semiramot, Yejiel, Uní, Eliab, Benayas, Maaseyas, Matatías, Eliflehú, Micneyas, Obededón y Yeiel, porteros;"
,"19":"Hemán, Asaf y Etán, cantores, hacían resonar címbalos de bronce;"
,"20":"Zacarías, Uziel, Semiramot, Yejiel, Uní, Eliab, Maaseyas y Benayas tocaban arpas;"
,"21":"Matatías, Eliflehú, Micneyas, Obededón, Yejiel y Azazías tocaban cítaras a la octava;"
,"22":"Quenanías, jefe de los levitas encargados de llevar el arca, dirigía el cortejo, pues era muy experto;"
,"23":"Berequías y Elcaná eran porteros del arca;"
,"24":"Sebanías, Josafat, Natanael, Amasay, Zacarías, Benayas y Eliezer, sacerdotes, tocaban la trompeta delante del arca de Dios. Obededón y Yejías eran también porteros del arca."
,"25":"David, los ancianos de Israel y los jefes de millares fueron con gran alegría a trasladar el arca de la alianza del Señor desde la casa de Obededón."
,"26":"Puesto que Dios asistía a los levitas que llevaban el arca de la alianza del Señor, se inmolaron siete toros y siete carneros."
,"27":"David vestía un manto de lino, lo mismo que todos los levitas que llevaban el arca, los cantores, Quenanías, director del cortejo y los porteros. David llevaba además el efod de lino."
,"28":"Todo Israel trasladó el arca de la alianza del Señor en medio de aclamaciones al son de las bocinas, las trompetas, los címbalos, las liras y las cítaras."
,"29":"Cuando el arca de la alianza del Señor llegó a la ciudad de David, Mical, la hija de Saúl, estaba mirando por la ventana, y al ver al rey David saltando y bailando, lo despreció en su corazón."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Metieron el arca de Dios y la colocaron en medio de la tienda que David había levantado para ella. Ofrecieron luego al Señor holocaustos y sacrificios de reconciliación."
,"2":"Cuando David terminó de ofrecer los holocaustos y los sacrificios de reconciliación, bendijo al pueblo en nombre del Señor"
,"3":"y distribuyó a todos los israelitas presentes, hombres y mujeres, una torta de pan a cada uno, un pedazo de carne y un racimo de uvas pasas."
,"4":"David puso levitas al servicio del arca del Señor para que invocaran, glorificaran y alabaran al Señor, Dios de Israel:"
,"5":"Asaf era el jefe; Zacarías, el segundo; seguían Uziel, Semiramot, Yejiel, Matatías, Eliab, Benayas, Obededón y Yeiel; éstos tocaban la lira y la cítara, mientras Asaf sonaba los címbalos."
,"6":"Los sacerdotes Benayas y Yajaziel tocaban ininterrumpidamente las trompetas delante del arca de la alianza de Dios."
,"7":"Fue aquel día cuando David ordenó por primera vez a Asaf y a sus hermanos elevar al Señor esta alabanza:"
,"8":"'Alabad al Señor, invocad su nombre, anunciad entre los pueblos sus hazañas."
,"9":"Cantad para él al son de instrumentos, celebrad todas sus maravillas."
,"10":"Gloriaos en su santo nombre, alégrese el corazón de los que buscan al Señor."
,"11":"Buscad al Señor y su poder, buscad su rostro sin descanso."
,"12":"Recordad las maravillas que hizo, sus milagros y las sentencias de su boca,"
,"13":"descendientes de Israel, su siervo, hijos de Jacob, su elegido."
,"14":"Es el Señor, nuestro Dios, el que gobierna toda la tierra."
,"15":"Recordad eternamente su alianza, la palabra con que se ha comprometido para siempre,"
,"16":"la alianza que hizo con Abrahán, que confirmó con juramento a Isaac;"
,"17":"a Jacob se la dio como ley, y a Israel como alianza eterna:"
,"18":"'Te daré la tierra de Canaán,como porción de tu heredad'."
,"19":"Entonces, cuando no eran más que un puñado, poco numerosos, extranjeros en la tierra,"
,"20":"e iban de nación en nación, de un reino a otro pueblo diferente,"
,"21":"no permitió que nadie los oprimiera; por ellos castigó a reyes:"
,"22":"'¡No toquéis a mis ungidos, no hagáis mal a mis profetas!'."
,"23":"Cantad al Señor, habitantes todos de la tierra, proclamad día tras día su salvación."
,"24":"Contad a las naciones su gloria, sus maravillas a todos los pueblos."
,"25":"Grande es el Señor y digno de alabanza, temible sobre todos los dioses."
,"26":"Nada son los dioses de los pueblos, es el Señor quien ha hecho los cielos."
,"27":"En su presencia, esplendor y majestad; en su santuario, poder y alegría."
,"28":"Dad al Señor, familias de la tierra, dad al Señor la gloria y la alabanza,"
,"29":"dad gloria al nombre del Señor. Traed ofrendas y entrad en su presencia, adorad al Señor en el atrio sagrado."
,"30":"Temblad en su presencia,los de la tierra entera. El Señor fijó el orbe y no se moverá."
,"31":"Alégrense los cielos, regocíjese la tierra,y pregonen los pueblos: 'El Señor es rey'."
,"32":"Truene el mar y cuanto lo llena, cante el campo con todos sus frutos."
,"33":"Alégrense árboles y selvas en presencia del Señor, que viene a juzgar la tierra."
,"34":"Dad gracias al Señor, porque es bueno, porque es eterno su amor."
,"35":"Decid: '¡Sálvanos, oh Dios, salvación nuestra!; reúnenos y sácanos de en medio de las gentes, para que podamos glorificar tu nombre,y nosotros mismos nos gloriemos en tu alabanza."
,"36":"Bendito sea el Señor, Dios de Israel,por eternidad de eternidades. Y todo el pueblo diga: Amén. Aleluya'."
,"37":"David dejó allí delante del arca de la alianza del Señor a Asaf y a sus hermanos para que hicieran el servicio permanente del arca, según el ritual cotidiano,"
,"38":"y estableció a Obededón, hijo de Yedutún, a Josá y a sus sesenta y ocho hermanos como porteros."
,"39":"A Sadoc y a sus hermanos los sacerdotes los dejó delante de la tienda del Señor en el alto de Gabaón,"
,"40":"para que ofrecieran sacrificios diariamente, mañana y tarde, sobre el altar de los holocaustos e hiciesen cuanto está escrito en la ley dada por el Señor a Israel."
,"41":"Con ellos estaba Hemán, Yedutún y los demás, que habían sido elegidos nominalmente para cantar al Señor: 'Porque es eterno su amor'."
,"42":"Éstos tenían consigo a Hemán y Yedutún encargados de tocar las trompetas, los címbalos y los instrumentos destinados a acompañar las alabanzas de Dios. Los hijos de Yedutún estaban destinados a la puerta."
,"43":"Todo el pueblo se fue cada uno a su casa, y David se fue a bendecir la suya."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Cuando David se estableció en su palacio, dijo al profeta Natán: 'Yo estoy viviendo en una casa de cedro, mientras que el arca de la alianza del Señor está bajo una tienda'."
,"2":"Natán respondió a David: 'Haz lo que piensas, porque el Señor está contigo'."
,"3":"Pero aquella misma noche el Señor dijo a Natán:"
,"4":"'Vete y di a mi siervo David: Esto dice el Señor: No serás tú el que me construyas una casa para que habite en ella."
,"5":"Yo no he habitado en casa desde el día en que liberé a Israel hasta hoy, sino que he estado peregrinando en una tienda de campaña."
,"6":"Durante todo el tiempo que anduve errante con los israelitas, jamás dije a ninguno de los jueces de Israel, a los que puse para que gobernaran a mi pueblo, que me construyera una casa de cedro."
,"7":"Di a mi siervo David: Esto dice el Señor todopoderoso: Yo te saqué de detrás de las ovejas para que fueras el jefe de mi pueblo Israel."
,"8":"He estado contigo en todas tus empresas, he exterminado delante de ti a todos tus enemigos. Haré que tu nombre sea como el de los grandes de la tierra."
,"9":"Asignaré un territorio a mi pueblo, Israel; en él lo estableceré para que lo habite y no vuelva a ser perturbado ni los malvados continúen oprimiéndolo como antes,"
,"10":"en el tiempo en que yo constituí a los jueces sobre mi pueblo Israel. Humillaré a todos tus enemigos y a ti te engrandeceré. Te hago saber, además, que te daré una dinastía,"
,"11":"pues cuando llegues al término de tus días y descanses con tus padres haré surgir un descendiente tuyo, que saldrá de tus entrañas y lo confirmaré en el reino."
,"12":"Él me construirá un templo y yo consolidaré su trono para siempre."
,"13":"yo seré para él un padre y él será para mí un hijo; no retiraré de él mi favor, como lo retiré de tu antecesor."
,"14":"Lo mantendré siempre en mi casa y en mi reino, y su trono será firme eternamente'."
,"15":"Natán comunicó a David todo lo que había visto y oído."
,"16":"El rey David se presentó ante el Señor y le dijo: '¿Quién soy yo, Señor Dios, y qué es mi casa para que me hayas hecho llegar hasta aquí?"
,"17":"Y aun esto es todavía poco para ti, que extiendes tu promesa a la casa de tu siervo para un futuro lejano y me consideras como alguien importante, oh Señor Dios."
,"18":"¿Qué más podrá decirte David respecto de la gloria que has otorgado a tu siervo? Tú ya conoces a tu siervo, Señor."
,"19":"Por amor a tu siervo, y según tu corazón, has hecho todas estas maravillas y las has dado a conocer."
,"20":"Señor, no hay nadie como tú, ni hay Dios fuera de ti, como hemos oído."
,"21":"¿Hay sobre la tierra un pueblo como tu pueblo, Israel, al que Dios mismo vino a rescatarlo para hacerlo su pueblo, para hacerlo famoso, para hacer en su favor terribles y grandes prodigios y expulsar a las naciones delante de tu pueblo al que rescataste de la esclavitud de Egipto?"
,"22":"Has afirmado a tu pueblo Israel como pueblo tuyo para siempre, y tú, Señor, te has hecho su Dios."
,"23":"y ahora, Señor, mantén firme para siempre la promesa que has hecho a tu siervo y a su casa y haz como has dicho."
,"24":"Que tu nombre sea siempre engrandecido y que digan: El Señor todopoderoso es el Dios de Israel. Que la casa de David, tu siervo, sea estable en tu presencia,"
,"25":"pues tú mismo, Dios mío, has prometido a tu siervo que le edificarás una casa; por eso se ha atrevido a dirigirte esta súplica."
,"26":"Sí, Señor, tú eres Dios y has hecho a tu siervo esta gran promesa;"
,"27":"bendice la casa de tu siervo para que subsista eternamente en tu presencia; porque aquel a quien tú bendices, será bendito para siempre'."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Después de esto, David derrotó a los filisteos y los sometió; les arrebató Gat y sus aldeas."
,"2":"Derrotó a Moab, y los moabitas quedaron sometidos a David y le pagaron tributo."
,"3":"Venció también a Hadadézer, rey de Sobá, en Jamat, cuando éste iba a extender su dominio hasta el Éufrates."
,"4":"Le arrebató mil carros de combate e hizo prisioneros a siete mil soldados de caballería y a veinte mil de infantería. Desjarretó a todos los caballos de tiro, dejando sólo cien."
,"5":"Los sirios de Damasco fueron a socorrer a Hadadézer, rey de Sobá, y David mató a veintidós mil sirios."
,"6":"David puso guarnición en Siria de Damasco, y los sirios le quedaron sometidos y le pagaron tributo. El Señor daba la victoria a David por dondequiera que iba."
,"7":"David se apoderó de los escudos de oro que llevaba la guardia de Hadadézer y los llevó a Jerusalén."
,"8":"En Tibjab y en Cun, ciudades de Hadadézer, se apoderó también de una gran cantidad de bronce, que sirvió a Salomón para hacer la pila, las columnas y los utensilios de bronce."
,"9":"Cuando Tou, rey de Jamat, supo que David había derrotado a todo el ejército de Hadadézer, rey de Sobá,"
,"10":"envió a su hijo Hadorán al rey David para saludarlo y felicitarlo por haber atacado y vencido a Hadadézer, pues Tou estaba en guerra con Hadadézer. Le envió objetos de oro, plata y bronce,"
,"11":"que el rey David consagró al Señor junto con la plata y oro que había quitado a otras naciones: a Edón, a Moab, a los amonitas, a los filisteos y a Amalec."
,"12":"Abisay, hijo de Sarvia, derrotó en el valle de la Sal a dieciocho mil edomitas."
,"13":"Puso guarniciones en Edón, y los edomitas quedaron sometidos a David. El Señor daba la victoria a David por dondequiera que iba."
,"14":"David reinó sobre todo Israel administrando derecho y justicia a todo su pueblo."
,"15":"Joab, hijo de Sarvia, era el jefe de su ejército; Josafat, hijo de Ajilud, era cronista;"
,"16":"Sadoc, hijo de Ajitub, y Ajimelec, hijo de Abiatar, eran sacerdotes; Sesa era secretario;"
,"17":"Benayas, hijo de Yehoyadá, era jefe de los quereteos y peleteos. Los hijos de David eran los primeros al lado del rey."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Después de esto murió Najás, rey de los amonitas, y le sucedió su hijo."
,"2":"David se dijo: 'Yo trataré con benevolencia a Janún, como su padre me trató a mí'. David le envió una embajada de pésame por la muerte de su padre. Pero cuando los siervos de David llegaron a la tierra de los amonitas,"
,"3":"los jefes amonitas dijeron a Janún: '¿Tú crees que David te envía consoladores con el fin de honrar a tu padre? ¿No los habrá enviado más bien con el fin de explorar, espiar y destruir el país?'."
,"4":"Entonces Janún agarró a los siervos de David, los afeitó, les cortó los vestidos por la mitad a la altura de las nalgas y los despachó."
,"5":"Cuando David se enteró, mandó que les salieran al encuentro, porque aquellos hombres estaban llenos de vergüenza, y les dijeran de parte del rey: 'Quedaos en Jericó hasta que os crezca la barba, y luego vendréis'."
,"6":"Los amonitas se dieron cuenta de que se habían hecho odiosos a David, y Janún y los amonitas enviaron unas treinta y cuatro toneladas de plata para contratar como mercenarios tropas de caballería y carros de combate sirios en Mesopotamia, Maacá y Sobá."
,"7":"Contrataron a sueldo al rey de Maacá, sus tropas y treinta y dos mil carros, que acamparon frente a Madabá, mientras los amonitas, reunidos fuera ya de sus ciudades, estaban prontos al combate."
,"8":"Cuando David lo supo, mandó a Joab con todo su ejército y los héroes."
,"9":"Los amonitas salieron y se pusieron en orden de batalla a la entrada de la ciudad. Los reyes que habían venido a sueldo estaban en el campo."
,"10":"Joab, viendo que tenía dos frentes, uno delante y otro detrás, seleccionó la flor y nata del ejército de Israel y los puso en orden de batalla frente a los sirios;"
,"11":"y el resto del ejército, bajo la dirección de su hermano Abisay, lo enfrentó con los amonitas."
,"12":"Y dijo: 'Si los sirios me ganan a mí, tú vendrás en mi ayuda; y si los amonitas te ganan a ti, yo iré en tu ayuda."
,"13":"¡Ánimo!, luchemos valientemente por nuestro pueblo y por las ciudades de nuestro Dios. Que el Señor haga lo que bien le parezca'."
,"14":"Joab y su ejército se lanzaron al ataque contra los sirios, y éstos huyeron ante ellos."
,"15":"Los amonitas, al ver huir a los sirios, huyeron también ellos ante Abisay, el hermano de Joab, y entraron en la ciudad. Joab se volvió a Jerusalén."
,"16":"Los sirios, viendo que habían sido derrotados por Israel, mandaron a buscar a los sirios del otro lado del Éufrates; se puso al frente de ellos Sofac, general en jefe del ejército de Hadadézer."
,"17":"David, al saberlo, reunió a todo Israel, cruzó el Jordán, los alcanzó y tomó posiciones en orden de batalla y luchó contra los sirios."
,"18":"Éstos huyeron ante Israel y David les mató siete mil caballos de tiro y cuarenta mil hombres. Cayó también Sofac, el general."
,"19":"Cuando los aliados de Hadadézer se vieron derrotados por Israel, firmaron la paz con David y le quedaron sometidos. Desde entonces los sirios no se atrevieron a volver a ayudar más a los amonitas."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Al año siguiente, al tiempo en que suelen salir los reyes de campaña, Joab, a la cabeza de un gran ejército, marchó contra la tierra de los amonitas y la devastó. Luego puso asedio a Rabá, mientras David estaba en Jerusalén. Joab se apoderó de Rabá y la destruyó."
,"2":"David quitó de la cabeza de Milcón la corona de oro, que pesaba treinta y cuatro kilos; y la piedra preciosa que había en ella fue puesta en la corona de David. El botín que tomó en la ciudad fue inmenso."
,"3":"Se llevó cautivos a sus habitantes y los puso a trabajar con sierras, picos y hachas. Lo mismo hizo con todas las ciudades amonitas. David y todo su ejército volvieron a Jerusalén."
,"4":"Después de esto continuó la guerra en Guézer contra los filisteos. Fue entonces cuando Sibecay, el jusatita, mató a Sipay, un descendiente de los gigantes. Los filisteos quedaron sometidos."
,"5":"Se reanudó la lucha con los filisteos, y Eljanán, hijo de Yaír, mató a Lajmí, hermano de Goliat de Gat, el cual llevaba una lanza cuya asta era como un enjullo de tejedor."
,"6":"Se dio otra batalla en Gat, donde había un gigante que tenía veinticuatro dedos, seis en cada extremidad. También éste era descendiente de los gigantes."
,"7":"Él desafió a Israel, y Jonatán, hijo de Simeá, hermano de David, lo mató."
,"8":"Estos gigantes eran descendientes de los gigantes de Gat, y cayeron en manos de David y sus hombres."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Satán se levantó contra Israel e indujo a David a hacer el censo de Israel."
,"2":"David dijo a Joab y a los jefes del pueblo: 'Id y haced el censo de Israel desde Dan hasta Berseba, y venid a decirme su número'."
,"3":"Joab respondió: '¡El Señor multiplique su pueblo cien veces más! ¡Oh rey, señor mío!, ¿no son todos servidores tuyos? ¿Para qué hacer este censo, señor? ¿Por qué cargar esta culpa sobre Israel?'."
,"4":"El rey mantuvo su orden, y Joab salió a recorrer todo Israel, regresando luego a Jerusalén"
,"5":"para dar a David cuenta del censo del pueblo: el total ascendía a un millón cien mil hombres en edad de guerra, en Israel, y cuatrocientos setenta mil en Judá."
,"6":"La orden del rey había desagradado tanto a Joab, que no hizo el censo de la tribu de Leví y Benjamín."
,"7":"Dios vio con malos ojos el censo y castigó a Israel."
,"8":"David dijo entonces a Dios: 'He cometido un gran pecado. Perdona el pecado de tu siervo, pues he obrado como un insensato'."
,"9":"El Señor dijo a Gad, a quien David consultaba:"
,"10":"'Anda y di a David: Esto dice el Señor: Te propongo tres castigos, para que elijas uno de ellos'."
,"11":"Gad se presentó a David y le dijo: 'Esto dice el Señor: Elige entre estas tres cosas:"
,"12":"tres años de hambre, una derrota de tres meses perseguido por tus enemigos armados de espada o tres días de peste en el país bajo la espada del Señor y el ángel del Señor haciendo estragos en todo Israel. Elige y dime qué debo responder al que me envía'."
,"13":"David dijo a Gad: 'Me veo en gran aprieto. Pongámonos en manos de Dios, porque es grande su misericordia, antes de caer en manos de los hombres'."
,"14":"El Señor descargó la peste sobre Israel y perecieron setenta mil hombres."
,"15":"Luego envió al ángel destructor a Jerusalén y, cuando ya estaba a punto de exterminarla, el Señor sintió compasión por tanta desgracia y dijo al ángel exterminador: 'Basta, retira tu mano'. El ángel del Señor estaba junto a la era de Ornán, el jebuseo. "
,"16":"David levantó los ojos y vio al ángel del Señor que estaba entre la tierra y el cielo, con la espada desenvainada en su mano y vuelta hacia Jerusalén. El rey y los ancianos, vestidos de saco, cayeron con sus rostros en tierra,"
,"17":"y David dijo a Dios: '¿No soy yo quien ordenó el censo del pueblo? Yo soy quien ha pecado y ha obrado mal; pero estos otros, el rebaño, ¿qué han hecho? Señor, Dios mío, que tu mano caiga sobre mí y mi familia, pero que el pueblo se vea libre del castigo'."
,"18":"El ángel del Señor ordenó a Gad que David levantara un altar al Señor en la era de Ornán, el jebuseo."
,"19":"David fue, como se lo había dicho Gad cumpliendo la orden del Señor."
,"20":"Ornán se volvió y vio al ángel, y se iba a esconder con sus cuatro hijos; Ornán estaba trillando el trigo."
,"21":"David se acercaba, y Ornán, al ver al rey, le salió al encuentro y se postró ante él rostro en tierra."
,"22":"David dijo a Ornán: 'Cédeme el solar de la era para levantar en ella un altar al Señor. Cédemela por su justo precio en plata, para que el castigo se retire del pueblo'."
,"23":"Ornán respondió: 'Tómala, y que mi señor, el rey, haga de ella lo que quiera. Más aún, te doy los bueyes para el holocausto, los trillos para el fuego y el grano para la ofrenda. Todo está en tus manos'."
,"24":"El rey David dijo a Ornán: 'No, quiero comprarla por su justo precio en plata, pues no voy a presentar yo al Señor lo que es tuyo, ofreciendo holocaustos que no me cuestan nada'."
,"25":"David pagó a Ornán por la era seiscientas monedas de oro,"
,"26":"y levantó en ella un altar al Señor sobre el cual ofreció holocaustos y sacrificios de reconciliación. David invocó al Señor, que le respondió haciendo caer del cielo el fuego sobre el altar de los holocaustos,"
,"27":"y ordenó al ángel envainar su espada."
,"28":"David, al ver que el Señor lo había escuchado en la era de Ornán, el jebuseo, empezó a ofrecer los sacrificios allí;"
,"29":"pues la tienda del Señor que Moisés había hecho en el desierto y el altar de los holocaustos estaban, por entonces, en el alto de Gabaón,"
,"30":"y David no se atrevía a ir allá para orar ante el Señor, porque todavía le duraba el temor que le había causado la espada del ángel del Señor."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Por eso dijo David: 'Ésta será la casa del Señor Dios, y aquí estará el altar de los holocaustos de Israel'."
,"2":"David ordenó que se reunieran todos los extranjeros que había en Israel, y los empleó como canteros en labrar piedras para la construcción de la casa de Dios."
,"3":"Preparó también hierro en abundancia para clavar los batientes de las puertas y las barras; bronce en cantidad incalculable"
,"4":"y maderas de cedro sin tasa, pues sidonios y tirios habían traído a David troncos de cedro en abundancia."
,"5":"David se decía: 'Mi hijo Salomón es todavía joven y tierno, y la casa que tiene que edificar al Señor ha de ser famosa en todo el mundo por su esplendor y grandeza. Quiero dejarle hechos los preparativos'."
,"6":"Llamó luego a su hijo Salomón, le encomendó la construcción de un templo al Señor, Dios de Israel,"
,"7":"y le dijo: 'Hijo mío, yo quise construir un templo al nombre del Señor, mi Dios;"
,"8":"pero el Señor me dijo: Tú has derramado mucha sangre y has hecho muchas guerras. Tú no podrás edificar un templo a mi nombre, pues has derramado mucha sangre sobre la tierra en mi presencia."
,"9":"Tendrás un hijo, que será hombre de paz con todos los enemigos de alrededor. Salomón será su nombre; yo concederé paz y tranquilidad a Israel durante los días de su vida."
,"10":"Él edificará un templo a mi nombre; será para mí un hijo y yo seré para él un padre, y afirmaré su trono real sobre Israel para siempre."
,"11":"Ahora, hijo mío, que el Señor esté contigo y puedas concluir con éxito el templo del Señor, tu Dios, conforme te lo ha prometido."
,"12":"Que el Señor te dé sabiduría e inteligencia cuando te constituya sobre Israel, para que puedas observar la ley del Señor, tu Dios."
,"13":"Si observas los mandamientos y preceptos que el Señor ordenó a Israel por medio de Moisés, tendrás éxito. Ten valor y firmeza. No tengas miedo ni te acobardes."
,"14":"Yo mismo con mi trabajo he podido reunir para el templo del Señor tres mil cuatrocientas toneladas de oro, treinta y cuatro mil toneladas de plata y una cantidad incalculable de bronce y de hierro. He preparado también madera y piedra, a la cual tú añadirás más."
,"15":"Tienes a tu disosición buen número de obreros: canteros, escultores, carpinteros y hombres especializados en toda clase de obras."
,"16":"Oro, plata, bronce y hierro hay en abundancia. ¡Adelante, manos a la obra y que el Señor te ayude!'."
,"17":"David ordenó a todos los jefes de Israel que ayudaran a su hijo Salomón:"
,"18":"'El Señor, vuestro Dios, está con vosotros; os ha dado tranquilidad por todas partes, entregando en mis manos a los habitantes de la tierra y poniendo a ésta bajo el dominio del Señor y de su pueblo."
,"19":"Poned, pues, vuestro corazón y vuestra alma al servicio del Señor, vuestro Dios. Aprestaos y edificad el santuario del Señor, vuestro Dios, para trasladar al templo edificado al nombre del Señor el arca de la alianza del Señor y los utensilios consagrados a Dios'."
}`)
	CurrentBook.AddChapter(23, `{
"1":"Viejo ya David y cargado de días, nombró a su hijo Salomón rey de Israel."
,"2":"Reunió a todos los jefes de Israel, a los sacerdotes y a los levitas."
,"3":"Se hizo el censo de los levitas mayores de treinta años; contados uno a uno, resultaron treinta y ocho mil."
,"4":"De éstos destinó veinticuatro mil para dirigir los trabajos del templo del Señor, seis mil eran escribas y jueces,"
,"5":"cuatro mil porteros y los otros cuatro mil alababan al Señor con los instrumentos que para este fin había hecho David."
,"6":"David los dividió en clases según los tres hijos de Leví: Guersón, Quehat, Merarí."
,"7":"Guersonitas: Ladán y Simeí."
,"8":"Hijos de Ladán: Yejiel, el primero; Zetán y Joel, tres en total."
,"9":"Hijos de Simeí: Selomit, Jaziel y Harán, tres en total. Éstos son los jefes de familia de Ladán."
,"10":"Hijos de Simeí: Yájat, Zizá, Yeús y Beriá, éstos fueron los cuatro hijos de Simeí."
,"11":"'Yájat era el primero, Zizá el segundo, luego Yeús y Beriá, que no tuvieron muchos hijos y fueron registrados en una sola familia."
,"12":"Quehatitas: Amrán, Yishar, Hebrón y Uziel, cuatro en total."
,"13":"Hijos de Amrán: Aarón y Moisés. Aarón fue elegido, con sus hijos, para servir perpetuamente en las cosas más santas: ofrecer el incienso delante del Señor, darle culto y bendecir en su nombre eternamente."
,"14":"Moisés fue un hombre de Dios, y sus hijos fueron computados con la tribu de Leví."
,"15":"Hijos de Moisés: Guersón y Eliezer."
,"16":"Hijos de Guersón: Sebuel fue el jefe."
,"17":"Hijos de Eliezer: Rejabías, el jefe. Eliezer no tuvo más hijos, pero los hijos de Rejabías fueron muy numerosos."
,"18":"Hijos de Yishar: Selomit fue el jefe."
,"19":"Hijos de Hebrón: Yerías, el primero, Amarías, el segundo; Yajaziel, el tercero, y Yacamán, el cuarto."
,"20":"Hijos de Uziel: Micá, el primero; Yisías, el segundo."
,"21":"Meraritas: Majlí y Musí. Hijos de Majlí: Eleazar y Quis."
,"22":"Eleazar murió sin dejar hijos, pero dejó hijas, que se casaron con los hijos de Quis, sus hermanos."
,"23":"Hijos de Musí: Majlí, Eder y Yeremot, tres en total."
,"24":"Éstos eran los descendientes de Leví por familias, y éstos los cabezas de familia registrados en el censo nominal uno por uno. Estaban dedicados al servicio de la casa del Señor desde los veinte años."
,"25":"David había dicho: 'Ya que el Señor, Dios de Israel, ha otorgado paz a su pueblo y ha fijado para siempre su morada en Jerusalén,"
,"26":"tampoco los levitas tendrán que transportar más la morada y los objetos destinados a su servicio'."
,"27":"De hecho, según las últimas disposiciones de David, los levitas inscritos en el censo eran sólo mayores de veinte años."
,"28":"Su obligación era estar a las órdenes de los hijos de Aarón en el servicio del templo del Señor en lo referente a los atrios, las cámaras, limpieza de las cosas santas y de los demás oficios del templo del Señor."
,"29":"Estaban encargados también de los panes de la proposición, de la flor de harina para la ofrenda, de las tortas de pan sin levadura, de las tortas fritas y cocidas y de las medidas de capacidad y longitud."
,"30":"Tenían que presentarse diariamente, mañana y tarde, para dar gracias y alabar al Señor,"
,"31":"y siempre que se ofrecían holocaustos al Señor, los sábados, los novilunios y las fiestas, según el número y los ritos prescritos."
,"32":"En una palabra, su obligación era el servicio de la tienda de la reunión, del santuario, de los hijos de Aarón, sus hermanos, y del servicio del templo del Señor."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Clases de los descendientes de Aarón. Hijos de Aarón: Nadab, Abihú, Eleazar e Itamar."
,"2":"Nadab y Abihú murieron antes que su padre y no dejaron hijos, de manera que el sacerdocio recayó sobre Eleazar e Itamar."
,"3":"David, con la ayuda de Sadoc, descendiente de Eleazar y Ajimélec, descendiente de Itamar, los distribuyó en clases según sus servicios;"
,"4":"como los descendientes de Eleazar eran más numerosos que los de Itamar, la clasificación quedó así: dieciséis jefes de familia entre los hijos de Eleazar y ocho entre los hijos de Itamar."
,"5":"La distribución se hizo por suerte entre unos y otros, pues tanto los descendientes de Eleazar como los de Itamar tenían funcionarios sagrados y funcionarios de Dios."
,"6":"Semayas, hijo de Natanael, un escriba levita, los registró en presencia del rey, de los jefes, del sacerdote Sadoc, de Ajimélec, hijo de Abiatar, y de los jefes de familias de sacerdotes y levitas: se sacaban alternativamente por suerte dos familias de los hijos de Eleazar y una familia de los hijos de Itamar."
,"7":"La primera suerte cayó sobre Yehoyarib, la segunda sobre Yedayas,"
,"8":"la tercera sobre Jarín, la cuarta sobre Seorín,"
,"9":"la quinta sobre Malaquías, la sexta sobre Miyyamín,"
,"10":"la séptima sobre Hacós, la octava sobre Abías,"
,"11":"la novena sobre Yesúa, la décima sobre Secanías,"
,"12":"la undécima sobre Elyasib, la duodécima sobre Yaquín,"
,"13":"la decimotercera sobre Jupá, la decimocuarta sobre Yishaal,"
,"14":"la decimoquinta sobre Bilgá, la decimosexta sobre Imer,"
,"15":"la decimoséptima sobre Jezir, la decimoctava sobre Hapisés,"
,"16":"la decimonona sobre Petayas, la vigésima sobre Ezequiel,"
,"17":"la vigésimo primera sobre Yaquín, la vigésimo segunda sobre Gamul,"
,"18":"la vigésimo tercera sobre Delayas y la vigésimo cuarta sobre Maazías."
,"19":"Éstos son los turnos de servicio para entrar en el templo del Señor según la ordenación transmitida por Aarón, su padre, conforme al mandato recibido del Señor, Dios de Israel."
,"20":"En cuanto a los demás descendientes de Leví, sus jefes eran: para los hijos de Amrán, Subael; para los de Subael, Yejdías;"
,"21":"para los de Rejabías, Yisías;"
,"22":"para los yisharitas, Selomot; para los de Selomot, Yájat."
,"23":"Hijos de Hebrón: Yesías, el primero; Amarías, el segundo; Yajaziel, el tercero; Yecamán, el cuarto."
,"24":"Hijos de Uziel: Micá; para los hijos de Micá, Samir."
,"25":"Hermano de Micá: Yisías; para los hijos de Yisías, Zacarías."
,"26":"Hijos de Merarí: Majlí y Musí; Uzías era también hijo suyo."
,"27":"Hijos de Merarí a través de Uzías, su hijo: Sohán, Zacur e Ibrí;"
,"28":"para Majlí, Eleazar, que no tuvo hijos."
,"29":"En cuanto a Quis: hijos de Quis: Yerajmeel."
,"30":"Hijos de Musí: Majlí, Eder y Yerimot. Éstos fueron los descendientes de Leví por familias. "
,"31":"También éstos, lo mismo que los hijos de Aarón, fueron clasificados por suerte en presencia del rey David, de Sadoc, de Ajimélec y de los jefes de familias sacerdotales y levíticas, sin distinción de ninguna clase."
}`)
	CurrentBook.AddChapter(25, `{
"1":"David y los jefes del ejército seleccionaron también para el servicio a los hijos de Asaf, de Hemán y de Yedutún, profetas que se acompañaban de cítaras, arpas y címbalos. Se hizo el censo de estos hombres entregados a sus servicios."
,"2":"Hijos de Asaf: Zacur, José, Natanías y Asarela, que estaban bajo la dirección de Asaf, su padre, el cual profetizaba según las órdenes del rey."
,"3":"Hijos de Yedutún: Godolías, Serí, Isaías, Simeí, Yasabías y Matatías, seis, bajo la dirección de Yedutún, que profetizaba al son de la cítara en honor y alabanza del Señor."
,"4":"Hijos de Hemán: Buquías, Matanías, Uziel, Sebuel, Yerimot, Jananías, Jananí, Eliatá, Guidalti, Romanti Ezer, Yosbecasa, Maloti, Hotir y Majaziot."
,"5":"Todos éstos eran hijos de Hemán, el vidente del rey, que le transmitía las palabras de Dios y exaltaba su poder. Dios dio a Hemán catorce hijos y tres hijas."
,"6":"Todos cantaban bajo la dirección de su padre en el templo del Señor al son de címbalos, arpas y cítaras en servicio del templo de Dios, bajo las órdenes del rey: Asaf, Yedutún y Hemán."
,"7":"Su número, junto con el de sus hermanos, expertos en el arte de cantar al Señor, era de doscientos ochenta y ocho."
,"8":"Echaron también a suertes el servicio, sin distinción entre pequeño y grande, maestro y discípulo."
,"9":"El primero en suerte fue José, descendiente de Asaf; el segundo, Godolías; él, sus hermanos e hijos: doce en total;"
,"10":"el tercero, Zacur, sus hijos y hermanos: doce en total;"
,"11":"el cuarto, Yisrí, sus hijos y hermanos: doce en total;"
,"12":"el quinto, Natanías, sus hijos y hermanos: doce en total;"
,"13":"el sexto, Buquías, sus hijos y hermanos: doce en total;"
,"14":"el séptimo, Yesarela, sus hijos y hermanos: doce en total;"
,"15":"el octavo, Isaías, sus hijos y hermanos: doce en total;"
,"16":"el noveno, Matanías, sus hijos y hermanos: doce en total;"
,"17":"el décimo, Simeí, sus hijos y hermanos: doce en total;"
,"18":"el undécimo, Azarel, sus hijos y hermanos: doce en total;"
,"19":"el duodécimo, Yasabías, sus hijos y hermanos: doce en total;"
,"20":"el decimotercero, Subael, sus hijos y hermanos: doce en total;"
,"21":"el decimocuarto, Matatías, sus hijos y hermanos: doce en total;"
,"22":"el decimoquinto, Yeremot, sus hijos y hermanos: doce en total;"
,"23":"el decimosexto, Jananías, sus hijos y hermanos: doce en total;"
,"24":"el decimoséptimo, Yosbecasa, sus hijos y hermanos: doce en total;"
,"25":"el decimoctavo, Jananí, sus hijos y hermanos: doce en total;"
,"26":"el decimonono, Malotí, sus hijos y hermanos: doce en total;"
,"27":"el vigésimo, Eliatá, sus hijos y hermanos: doce en total;"
,"28":"el vigésimo primero, Otir, sus hijos y hermanos: doce en total;"
,"29":"el vigésimo segundo, Guidalti, sus hijos y hermanos: doce en total;"
,"30":"el vigésimo tercero, Majaziot, sus hijos y hermanos: doce en total;"
,"31":"el vigésimo cuarto, Romanti Ezer, sus hijos y hermanos: doce en total."
}`)
	CurrentBook.AddChapter(26, `{
"1":"En cuanto a la distribución de los porteros: De los corajitas: Meselemías, hijo de Coré, de los hijos de Abiasaf. "
,"2":"Hijos de Meselemías: Zacarías, el primogénito; Yediel, el segundo; Zebadías, el tercero; Yatniel, el cuarto;"
,"3":"Elán, el quinto; Yehojanán, el sexto; Elyoenay, el séptimo."
,"4":"Hijos de Obededón: Semayas, el primogénito; Yehozabad, el segundo; Yoaj, el tercero; Sacar, el cuarto; Natanael, el quinto;"
,"5":"Amiel, el sexto; Isacar, el séptimo; Pueletay, el octavo, pues Dios le había bendecido."
,"6":"Su hijo Semayas tuvo hijos que tuvieron autoridad en sus casas patriarcales porque eran hombres valerosos."
,"7":"Hijos de Semayas: Otní, Rafael, Obed, Elzabad y sus hermanos, los valerosos Elihú y Samaquías."
,"8":"Todos éstos eran hijos de Obededón; ellos, sus hijos y hermanos eran hombres valientes, duros en el servicio. De Obededón, sesenta y dos en total."
,"9":"Los hijos y hermanos de Meselemías, hombres valientes, sumaban en total dieciocho."
,"10":"Josá, descendiente de Merarí, también tuvo hijos. Su jefe fue Simrí; así lo dispuso su padre, aunque no era el primogénito;"
,"11":"Jilquías, el segundo; Tebalías, el tercero; Zacarías, el cuarto; los hijos y hermanos de Josá sumaban en total trece."
,"12":"Éstos tuvieron sus clases de porteros. A los jefes de estos valientes les fueron señaladas sus obligaciones, igual que a sus hermanos, en el servicio del templo del Señor."
,"13":"Se sorteó la custodia de cada una de las puertas entre las distintas familias patriarcales, sin distinción entre grandes y pequeños."
,"14":"La puerta oriental le tocó a Selamías. A su hijo Zacarías, sabio consejero, le tocó la del norte."
,"15":"A Obededón le tocó la del mediodía, y a sus hijos los almacenes."
,"16":"A Supín y a Josá les tocó la occidental con la puerta de Saléquet, sobre la calzada superior. Las puertas de guardia se correspondían. Distribución de las puertas de guardia:"
,"17":"seis por día en la oriental, cuatro por día en la del norte, cuatro por día en la meridional, dos y dos en los almacenes;"
,"18":"para el Parbar, al occidente: cuatro en la calzada y dos para el Parbar."
,"19":"Éstas eran las clases de porteros en que se distribuían los descendientes de Córaj y Merarí."
,"20":"Los levitas, sus hermanos, velaban sobre los tesoros de la casa de Dios y las cosas sagradas."
,"21":"De los hijos de Ladán, descendientes de Guersón y de Yejielí."
,"22":"Los hijo de Yejielí, Zetán y su hermano Joel, eran los encargados de los tesoros del templo del Señor."
,"23":"De los descendientes de Amrán, Yishar, Hebrón y Uziel"
,"24":"fue constituido superintendente jefe de los tesoros Sebuel, hijo de Guersón, hijo de Moisés."
,"25":"De sus hermanos, por parte de Eliezer: Rejabías, su hijo; Isaías, su hijo; Jorán, su hijo; Zicrí, su hijo; Selomit, su hijo."
,"26":"Este Selomit y sus hermanos fueron constituidos superintendentes de todos los depósitos de cosas santas consagradas por David y por los jefes de familias en calidad de jefes de millares, de centurias y jefes del ejército,"
,"27":"que provenían del botín de guerra y de los despojos y habían dedicado al mantenimiento del templo del Señor."
,"28":"Todo lo que había consagrado Samuel, el vidente; Saúl, hijo de Quis; Abner, hijo de Ner, y Joab, hijo de Sarvia; todo lo consagrado estaba bajo la custodia de Selomit y sus hermanos."
,"29":"De los descendientes de Yishar, Jeconías y sus hijos estaban dedicados a los asuntos profanos de Israel como escribas y jueces."
,"30":"De los descendientes de Hebrón, Jasabías y sus hermanos, hombres valientes, 1.700 en total, tenían a su cargo la custodia de Israel, al oeste del Jordán, en todos los asuntos que se referían al Señor y al servicio del rey."
,"31":"El jefe de los hebronitas era Yerías. En el año cuarenta del reinado de David se hicieron indagaciones sobre las genealogías y familias hebronitas, y se encontraron entre ellos hombres valerosos en Yazer de Galaad."
,"32":"El rey David nombró a 2.700 hermanos de Yerías, hombres valerosos y jefes de familias, como inspectores de las tribus de Rubén, de Gad y de la media tribu de Manasés, en todos los asuntos referentes a Dios y al rey."
}`)
	CurrentBook.AddChapter(27, `{
"1":"Censo de los israelitas. Los cabezas de familia, los jefes de millar y de centurias, y los oficiales estaban al servicio del rey en todo lo referente a las divisiones, que se turnaban cada mes, de manera que todos los meses del año había una división en funciones. Cada división tenía 24.000 hombres."
,"2":"El jefe de la primera división, que prestaba servicio el primer mes, era Yasobeán, hijo de Zabdiel;"
,"3":"Zabdiel era descendiente de Fares y mandaba a todos los oficiales de la división en servicio durante el primer mes."
,"4":"La división del segundo mes la mandaba Doday, el ajojita."
,"5":"Jefe de la tercera división, que prestaba servicio el tercer mes, era Benayas, hijo del sacerdote Yehoyadá."
,"6":"Éste es el Benayas que pertenecía a los treinta héroes; estaba al frente de los treinta y de su clase. Hijo suyo era Amizadab."
,"7":"El jefe de la cuarta división, para el cuarto mes, era Asael, hermano de Joab, que tuvo por sucesor a su hijo Zebadías."
,"8":"El jefe de la quinta división, para el quinto mes, era Samhut, de Zéraj."
,"9":"El jefe de la sexta división, para el sexto mes, era Irá, hijo de Iqués, de Técoa."
,"10":"El jefe de la séptima división, para el séptimo mes, era Jeles pelonita, descendiente de Efraín."
,"11":"El jefe de la octava división, para el octavo mes, era Sibcay de Jusá, zarejita."
,"12":"El jefe de la novena división, para el noveno mes, era Abiézer de Anatot, descendiente benjaminita."
,"13":"El jefe de la décima división, para el décimo mes, era Maray de Netofá, descendiente zerajita."
,"14":"El jefe de la undécima división, para el undécimo mes, era Benayas de Piratón, descendiente efraimita."
,"15":"El jefe de la duodécima división, para el duodécimo mes, era Jelday de Netofá, descendiente de Otniel."
,"16":"Estos son los jefes de las tribus de Israel: jefe de Rubén, Eliezer, hijo de Zicrí; de Simeón, Sefatías, hijo de Maacá;"
,"17":"de Leví, Jasabías, hijo de Quemuel; de Aarón, Sadoc;"
,"18":"de Juá, Elihú, hermano de David; de Isacar, Omrí, hijo de Miguel;"
,"19":"de Zabulón, Yismayas, hijo de Abdías; de Neftalí, Yerimot, hijo de Azriel;"
,"20":"de Efraín, Oseas, hijo de Azarías; de la media tribu de Manasés, Joel, hijo de Pedayas;"
,"21":"de la media tribu de Manasés en Galaad, Yidón, hijo de Zacarías; de Benjamín, Yasiel, hijo de Abner;"
,"22":"de Dan, Azarael, hijo de Yeroján. Éstos eran los jefes de las tribus de Israel."
,"23":"David no contó los menores de veinte años, pues el Señor le había prometido que multiplicaría a Israel como las estrellas del cielo."
,"24":"Joab, hijo de Sarvia, comenzó el censo, pero no lo terminó. Por eso se encendió la cólera de Dios contra Israel, y su número no se encuentra en las crónicas del rey David."
,"25":"Al frente de los almacenes del rey estaba Azmávet, hijo de Adiel; al frente de los almacenes de las ciudades, aldeas y fortalezas de la provincia estaba Jonatán, hijo de Uzías;"
,"26":"al frente de los obreros del campo, que labran las tierras, Ezrí, hijo de Quelub;"
,"27":"al frente de las viñas, Simeí de Ramá; al frente de las bodegas, Zabdí de Sefán;"
,"28":"al frente de los olivos y sicómoros en la Sefela, Baaljanán, de Guéder; al frente de los depósitos de aceite, Joás;"
,"29":"al frente del ganado mayor que pastea en los valles, Safat, hijo de Adlay;"
,"30":"al frente de los camellos, Obil, el ismaelita; al frente de las asnas, Yejdías de Meronot;"
,"31":"al frente del ganado menor, Yaziz, el agareno. Todos éstos eran superintendentes de la hacienda perteneciente al rey David."
,"32":"Jonatán, tío de David, consejero, sabio y escriba, se ocupaba de los hijos del rey, juntamente con Yejiel, hijo de Jacmoní."
,"33":"Ajitófel era consejero del rey. Yusay, el arquita, era amigo del rey."
,"34":"Yehoyadá, hijo de Benayas, y Abiatar sucedieron a Ajitófel. Joab era el jefe del ejército del rey."
}`)
	CurrentBook.AddChapter(28, `{
"1":"David convocó en Jerusalén a todos los jefes de Israel; jefes de tribu, jefes de las divisiones al servicio del rey, oficiales de millares y centurias, superintendentes de la hacienda, ganadería e hijos del rey, eunucos y héroes, todo el personal de valía."
,"2":"El rey se puso en pie y dijo: 'Escuchadme, hermanos míos y pueblo mío. Yo tenía el deseo de construir un templo donde estuviera permanentemente el arca de la alianza del Señor, estrado de los pies de nuestro Dios; había hecho incluso preparativos para la construcción,"
,"3":"pero Dios me dijo: Tú no construirás un templo a mi nombre, porque tú has sido hombre de guerra y has derramado sangre."
,"4":"Pero el Señor, Dios de Israel, me eligió entre toda la casa de mi padre para rey eterno de Israel. En efecto, eligió a Judá para caudillo, de Judá eligió a la casa de mi padre, y entre los hijos de mi padre se fijó en mí para hacerme reinar sobre Israel."
,"5":"Entre todos mis hijos, pues el Señor me ha dado muchos, ha elegido a mi hijo Salomón para que se siente en el trono del reino del Señor sobre Israel."
,"6":"Me ha dicho: Tu hijo Salomón construirá mi templo y mis atrios, pues lo he elegido como hijo y yo seré un padre para él."
,"7":"Afirmaré su reino para siempre, si sigue practicando con la firmeza de hoy mis mandamientos y preceptos."
,"8":"Y ahora, ante todo Israel, ante la asamblea y ante el Señor que nos escucha, os digo: guardad y observad todos los mandamientos del Señor, nuestro Dios, para que podáis conservar la posesión de esta buena tierra y dejarla en herencia a vuestros hijos después de vosotros a perpetuidad."
,"9":"Y tú, Salomón, hijo mío, reconoce al Dios de tu padre, sírvele con todo tu corazón, con ánimo bien dispuesto, porque el Señor escudriña los corazones de todos y penetra sus más secretos pensamientos. Si tú lo buscas, él se dejará encontrar; pero si tú lo abandonas, él se retirará para siempre."
,"10":"Piensa ahora que el Señor te ha elegido para que le construyas una casa como santuario. ¡Animo y manos a la obra!'."
,"11":"David dejó a su hijo Salomón el modelo del pórtico, del cuerpo central, de las cámaras superiores, de las piezas interiores y de la cámara del propiciatorio."
,"12":"Le dejó también la descripción de todos sus proyectos respecto 2de los atrios del templo del Señor, las cámaras de alrededor, los tesoros del templo del Señor, los depósitos sagrados;"
,"13":"las clases de sacerdotes y levitas, todos los servicios del templo del Señor, todo el mobiliario para el servicio del templo del Señor;"
,"14":"el oro en lingotes, el oro destinado para cada uno de los objetos de tal o cual servicio, la plata en lingotes destinada para todos los objetos de plata, para cada uno de los objetos de tal o cual servicio;"
,"15":"los lingotes destinados a los candelabros de oro y a sus lámparas, el oro en lingotes destinado a cada candelabro y sus lámparas, los lingotes de plata destinados a los candelabros de plata, para el candelabro y sus lámparas, según el servicio de cada uno;"
,"16":"el oro en lingotes destinado a las mesas de los panes de la proposición, para cada una de las mesas, la plata para las mesas de plata;"
,"17":"los tenedores, las fuentes, los cálices de oro puro, los lingotes de oro puro para las copas;"
,"18":"los lingotes de oro puro destinados para el altar de los perfumes. Le dejó el modelo del carro de los querubines de oro que cubren con sus alas desplegadas el arca de la alianza del Señor;"
,"19":"todo esto se lo dio por escrito de parte del Señor para hacerle comprender todos los detalles del modelo."
,"20":"David dijo a su hijo Salomón: 'Sé fuerte, ten ánimo y pon manos a la obra. No tengas miedo ni te desanimes, porque el Señor, mi Dios, está contigo y no te dejará ni abandonará hasta que hayas concluido toda la obra para servicio del templo del Señor."
,"21":"Aquí están las clases de sacerdotes y levitas para todo el servicio del templo del Señor; contarás también con voluntarios expertos en cualquier clase de trabajo. Los jefes y todo el pueblo están a tu disposición'."
}`)
	CurrentBook.AddChapter(29, `{
"1":"El rey David dijo a toda la asamblea: 'Mi hijo Salomón, el único elegido por Dios, es todavía joven e inexperto, y la obra es grande, pues la casa no es para los hombres, sino para el Señor Dios."
,"2":"Por eso, según mis fuerzas, he preparado para el templo de mi Dios oro para los objetos de oro, plata para los de plata, bronce para los de bronce, hierro para los de hierro, madera para los de madera, piedras de ónice y de engaste, piedras multicolores, piedras preciosas de toda especie y alabastro en gran cantidad."
,"3":"Además, todo el oro y plata de mi propiedad personal lo doy por amor del templo de mi Dios;"
,"4":"cien mil kilos de oro de Ofir, doscientos treinta y cinco mil kilos de plata finísima para revestir las paredes de las salas;"
,"5":"oro y plata para los diversos objetos y para la obra de orfebrería. Y ahora, ¿quién quiere hacer donativos voluntarios para el Señor?'."
,"6":"Los jefes de las familias, los de las tribus de Israel, los de millares y centurias y los encargados de los trabajos del rey se comprometieron"
,"7":"a dar para los trabajos del templo de Dios: ciento setenta mil kilos de oro, diez mil monedas de oro, trescientos cuarenta mil kilos de plata, seiscientos diez mil kilos de bronce y tres millones cuatrocientos mil kilos de hierro."
,"8":"Todos los que poseían piedras preciosas se las entregaron a Yejiel, el guersonita, para el tesoro del templo del Señor."
,"9":"El pueblo se gozaba en estos donativos voluntarios, pues los daban con todo el corazón al Señor, y el mismo rey David experimentó una gran alegría."
,"10":"David bendijo al Señor ante toda la asamblea, diciendo: 'Bendito seas tú, Señor, Dios de Israel, nuestro padre, desde la eternidad y para siempre."
,"11":"Tuya es, Señor, la grandeza, el poder, el honor, la majestad y la gloria, pues todo cuanto hay en el cielo y en la tierra es tuyo. Tuyo, Señor, es el reino, porque te alzas soberanamente sobre todo."
,"12":"La riqueza y la gloria te preceden, tú eres el dueño de todo, en tu mano está la fuerza y el poder, en tu mano encuentran estabilidad y grandeza todas las cosas."
,"13":"Ahora, Dios nuestro, te damos gracias y alabamos tu glorioso nombre."
,"14":"¿Quién soy yo y quién es mi pueblo para que podamos ofrecerte tantas cosas? Pues todo viene de ti y tuyo es lo que te hemos dado."
,"15":"Ante ti somos extranjeros y emigrantes, como lo fueron todos nuestros padres. Nuestros días sobre la tierra pasan como sombra en la cual no hay esperanza."
,"16":"Señor, Dios nuestro, todo esto que hemos reunido para construir un templo a tu santo nombre es tuyo y a ti te pertenece."
,"17":"Yo sé, Dios mío, que tú sondeas los corazones y amas la rectitud; con rectitud de corazón he hecho yo mis ofrendas, y ahora veo con gozo al pueblo aquí presente comprometerse voluntariamente contigo."
,"18":"Señor, Dios de Abrahán, Isaac e Israel, nuestros padres, conserva para siempre en tu pueblo estos sentimientos y disposiciones y orienta sus corazones hacia ti."
,"19":"Concede a mi hijo Salomón un corazón perfecto para que guarde tus mandamientos, tus preceptos y tus leyes, para que los ponga en práctica y construya el templo que yo te he preparado'."
,"20":"David dijo a toda la asamblea: '¡Bendecid al Señor, nuestro Dios!'. Y toda la asamblea bendijo al Señor, Dios de sus padres, y postrándose se inclinaron reverentes ante el Señor y ante el rey."
,"21":"Al día siguiente ofrecieron sacrificios y holocaustos al Señor: 1.000 toros, 1.000 carneros, 1.000 corderos con sus ofrendas, y muchos sacrificios por todo Israel."
,"22":"Comieron y bebieron aquel día con gran regocijo en presencia del Señor y proclamaron rey por segunda vez a Salomón, hijo de David, ungiéndolo como príncipe delante del Señor. Sadoc fue asimismo ungido sacerdote."
,"23":"Salomón se sentó sobre el trono del Señor como rey, en lugar de David, su padre. Conoció la prosperidad y le obedeció Israel."
,"24":"Todos los jefes, todos los héroes, e incluso los demás hijos del rey David, se sometieron al rey Salomón."
,"25":"El Señor ensalzó grandemente al rey Salomón ante todo el pueblo y le concedió un reinado tan glorioso cual nunca rey alguno había tenido antes de él en Israel."
,"26":"David, hijo de Jesé, había reinado sobre todo Israel."
,"27":"Reinó cuarenta años: siete en Hebrón, y treinta y tres años en Jerusalén."
,"28":"Murió en buena vejez, lleno de días, de riqueza y de gloria. Le sucedió en el trono su hijo Salomón."
,"29":"Los hechos del rey David, desde el principio hasta el fin, están escritos en las crónicas de Samuel, el vidente; en las crónicas de Natán, el profeta, y en las crónicas de Gad, el vidente,"
,"30":"con todo su reinado, sus hazañas y los sucesos referentes a él, a Israel y a todos los reinos de las tierras."
}`)

}
func ES_LSB_LoadVH1RChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Cuando el rey David se hizo viejo, de edad muy avanzada, aunque lo arropaban bien, no entraba en calor."
,"2":"Sus servidores le dijeron: 'Vamos a buscar al rey una joven virgen, que le asista, le cuide y duerma con él, para que le haga entrar en calor'."
,"3":"Buscaron una joven hermosa por todo el territorio de Israel, y encontraron a Abisag, la sunamita. Y la llevaron al rey."
,"4":"La joven era muy hermosa. Cuidaba del rey y le servía. Pero el rey no tuvo relaciones con ella."
,"5":"Entretanto Adonías, el hijo de Jaguit, que quería hacerse rey, se procuró carros y caballería y cincuenta hombres de escolta."
,"6":"Su padre no le había reprendido en su vida, ni le había pedido cuentas de lo que hacía. Era de aspecto muy gallardo, y había nacido después de Absalón."
,"7":"Trataba con Joab, hijo de Sarvia, y con el sacerdote Abiatar, los cuales tomaron partido por Adonías."
,"8":"Pero el sacerdote Sadoc y Benayas, hijo de Yehoyadá; el profeta Natán; Semeí, amigo de David; Reí y la cohorte de valientes de David, no estaban con Adonías."
,"9":"Adonías mató ganado menor y mayor y animales cebados junto a la piedra de Zojélet, situada cerca de la fuente de Roguel, e invitó a todos sus hermanos, los hijos del rey, y a todos los varones de Judá, servidores del monarca."
,"10":"Pero al profeta Natán, a Benayas, a la cohorte de valientes de David y a su hermano Salomón, no los invitó."
,"11":"Natán dijo a Betsabé, la madre de Salomón: '¿No has oído que Adonías, el hijo de Jaguit, intenta reinar sin que lo sepa David, nuestro señor?"
,"12":"Pues bien, quiero darte un consejo, para que salves tu vida y la de tu hijo Salomón."
,"13":"Ve a visitar al rey David, y dile: ¿No me has jurado tú, ¡oh rey, mi señor!, que tu hijo Salomón te sucederá en tu trono? Entonces, ¿con qué derecho se ha hecho rey Adonías?"
,"14":"Y mientras tú estés hablando con el rey, entraré yo detrás de ti y corroboraré tus palabras'."
,"15":"Betsabé entró en la cámara del rey. El monarca estaba muy envejecido, y Abisag, la sunamita, le servía."
,"16":"Betsabé se inclinó e hizo reverencia al rey. El rey dijo: '¿Qué tienes?'."
,"17":"Ella le contestó: 'Señor mío, tú me has jurado por el Señor, tu Dios, que tu hijo Salomón te sucederá en el reino y él se sentará sobre tu trono."
,"18":"Pero ahora resulta que Adonías se ha hecho rey sin que tú, ¡oh rey, mi señor!, lo sepas."
,"19":"Ha matado bueyes, animales cebados y ganado menor en gran cantidad, y ha invitado a todos los hijos del rey, al sacerdote Abiatar y a Joab, general del ejército; pero a tu siervo Salomón no le ha invitado."
,"20":"Hacia ti, ¡oh rey, mi señor!, se dirigen los ojos de todo Israel, para que les manifiestes quién se debe sentar en el trono del rey, mi señor, después de él."
,"21":"Resultará, si no, que, cuando el rey, mi señor, descanse con sus padres, yo y mi hijo Salomón seremos tratados como reos'."
,"22":"Hablaba aún ella con el rey, cuando llegó Natán, el profeta."
,"23":"Se lo anunciaron al rey diciendo: 'Está aquí Natán, el profeta'. Se presentó ante el rey y le hizo reverencia, rostro en tierra."
,"24":"Luego dijo: '¡Oh rey, mi señor!, tú debes de haber ordenado que Adonías te suceda en el reino y se siente en tu trono."
,"25":"En efecto, hoy ha matado bueyes, animales cebados y ganado menor en gran cantidad y ha invitado a todos los hijos del rey, a los jefes del ejército y a Abiatar, el sacerdote. Están comiendo y bebiendo en su compañía y gritan: ¡Viva el rey Adonías!"
,"26":"Pero a mí, tu servidor; a Sadoc, el sacerdote; a Benayas, el hijo de Yehoyadá, y a Salomón, tu siervo, no nos ha invitado."
,"27":"¿Salió, tal vez, de mi señor, el rey, la orden de hacer esto, sin haber notificado a tus siervos quién se había de sentar sobre el trono de mi señor, el rey, después de él?'."
,"28":"El rey David respondió: 'Llamad a Betsabé'. Ella se presentó ante el rey y permaneció en pie."
,"29":"Entonces el rey juró de esta manera: '¡Vive el Señor, que me ha salvado de todo peligro!,"
,"30":"que, conforme te tengo jurado por el Señor, Dios de Israel: Salomón, tu hijo, me sucederá en el reino y él se sentará sobre mi trono en lugar mío; así lo haré hoy mismo'."
,"31":"Betsabé se inclinó rostro en tierra y dijo: '¡Viva mi señor, el rey David, por siempre!'."
,"32":"David ordenó: 'Llamad a Sadoc, el sacerdote; a Natán, el profeta, y a Benayas, el hijo de Yehoyadá'. Se presentaron ante el rey,"
,"33":"y él les ordenó: 'Tomad con vosotros a los servidores de vuestro señor, montad a mi hijo Salomón sobre mi propia mula y llevadlo a Guijón."
,"34":"Allí Sadoc, el sacerdote, y Natán, el profeta, lo ungirán por rey de Israel. Y vosotros tocaréis la trompeta y gritaréis: ¡Viva el rey Salomón!"
,"35":"Vendréis luego con él haciéndole escolta. Y, en llegando aquí, se sentará sobre mi trono y empezará a reinar en lugar mío, pues a él le he designado para ser soberano en Israel y en Judá'."
,"36":"Benayas, el hijo de Yehoyadá, respondió: '¡Amén! ¡Así lo disponga el Señor, Dios del rey, mi señor!"
,"37":"Que el Señor esté con Salomón como lo estuvo con el rey, mi señor, y que engrandezca su trono más que el trono de mi señor, el rey David'."
,"38":"Sadoc, el sacerdote; Natán, el profeta; Benayas, el hijo de Yehoyadá; los quereteos y los peleteos montaron a Salomón sobre la mula del rey David y lo llevaron a Guijón."
,"39":"Sadoc, el sacerdote, tomó del tabernáculo el cuerno del óleo y ungió a Salomón. Entonces se tocaron las trompetas y todo el pueblo gritó: '¡Viva el rey Salomón!'."
,"40":"Luego toda la gente subió tras él, tañendo flautas y con tan gran algazara que parecía que se iba a abrir la tierra con el vocerío."
,"41":"Adonías y los invitados oyeron el griterío cuando terminaban el banquete, y Joab dijo: '¿Qué significa ese vocerío de la ciudad?'."
,"42":"Aún estaba hablando, cuando llegó Jonatán, hijo de Abiatar, el sacerdote. Adonías le dijo: 'Entra, pues tú eres un valiente y traerás buenas nuevas'."
,"43":"Jonatán dijo a Adonías: '¡Sí, por cierto! Nuestro señor, el rey David, ha hecho proclamar rey a Salomón."
,"44":"El rey ha enviado con él a Sadoc, el sacerdote; a Natán, el profeta; a Benayas, hijo de Yehoyadá; a los quereteos y a los peleteos, y le han montado sobre la mula del rey;"
,"45":"y Sadoc, el sacerdote, y Natán, el profeta, le han ungido por rey en Guijón. Luego han subido desde allí, llenos de júbilo, y la ciudad se ha alborotado. Este es el tumulto que habéis oído."
,"46":"Además, se ha sentado Salomón sobre el trono del reino."
,"47":"Asimismo los servidores del rey han ido a felicitar a nuestro señor, el rey David, diciendo: Ensalce tu Dios el nombre de Salomón más que tu nombre y engrandezca su trono más que tu trono. Y el rey ha hecho una inclinación reverente desde su lecho."
,"48":"Además, el rey ha dicho: ¡Bendito sea el Señor, Dios de Israel, que ha puesto hoy sobre mi trono a un hijo mío viéndolo mis ojos!'."
,"49":"Todos los invitados de Adonías, consternados, se levantaron y se fueron cada uno por su lado."
,"50":"Y Adonías, por miedo a Salomón, se levantó y fue a agarrarse a los cuernos del altar."
,"51":"Informaron de ello a Salomón: 'Adonías tiene miedo del rey Salomón y se ha agarrado a los cuernos del altar diciendo: Júreme hoy el rey Salomón que no ha de matar a espada a su siervo'."
,"52":"Salomón dijo: 'Si se porta bien, no caerá en tierra uno solo de sus cabellos; pero si es sorprendido en delito, morirá'."
,"53":"El rey Salomón mandó que lo retiraran del altar. Adonías fue y se postró ante el rey. Salomón le dijo: 'Vete a tu casa'."
}`)
	CurrentBook.AddChapter(2, `{
"1":"David, próximo a la muerte, dio estas instrucciones a su hijo Salomón:"
,"2":"'Yo me voy a morir; ten ánimo y pórtate como un hombre."
,"3":"Observa los preceptos del Señor, tu Dios, caminando por sus sendas, guardando sus mandamientos, sus preceptos, sus decretos y normas, según está escrito en la ley de Moisés, a fin de que tengas éxito en cuanto hagas y emprendas,"
,"4":"para que el Señor cumpla la promesa que me hizo: Si tus hijos cumplen con su deber, andando en mi presencia fielmente con todo su corazón y toda su alma, no te faltará jamás alguien que se siente sobre el trono de Israel."
,"5":"Ya sabes lo que me ha hecho Joab, hijo de Sarvia; lo que hizo a los dos jefes de los ejércitos de Israel, Abner, hijo de Ner, y Amasá, hijo de Yéter, que los asesinó, vengando en plena paz la sangre derramada en tiempo de guerra y salpicando de sangre inocente el cinturón que ciño y el calzado que llevo."
,"6":"Actúa con inteligencia y no dejes bajar en paz sus canas al abismo."
,"7":"Por el contrario, a los hijos de Barzilay, el galaadita, trátalos bien, contándolos entre los comensales de tu mesa, porque así me trataron ellos cuando yo huía de tu hermano Absalón."
,"8":"Ahí tienes a Semeí, hijo de Guerá, el benjaminita, de Bajurín, el que me lanzó atroces imprecaciones cuando yo iba a Majanayín; pero bajó a mi encuentro al Jordán y le juré por el Señor que no le mataría."
,"9":"Tú no lo perdones; eres inteligente y sabrás lo que tienes que hacer con él para que baje al abismo con sus canas tintas en sangre'."
,"10":"David descansó con sus padres y fue sepultado en la ciudad de David."
,"11":"Reinó sobre Israel cuarenta años; en Hebrón reinó siete años, y en Jerusalén treinta y tres."
,"12":"Salomón subió al trono de su padre David, y su reino se consolidó firmemente."
,"13":"Adonías, hijo de Jaguit, se presentó a Betsabé, madre de Salomón, y ella le preguntó: '¿Vienes en son de paz?'. Él replicó: 'En son de paz'."
,"14":"Y prosiguió: 'Tengo que pedirte una cosa'. Ella replicó: 'Dime'."
,"15":"Y Adonías: 'Tú sabes que a mí me tocaba la dignidad real y que todo Israel había puesto en mí sus ojos, esperando que yo había de reinar. Pero la realeza se me escapó y pasó a mi hermano, porque el Señor se la había destinado a él."
,"16":"Pues bien, ahora te pido una sola cosa; no me la niegues'. Ella repuso: 'Dime'."
,"17":"Él continuó: 'Di, por favor, al rey Salomón que me dé a Abisag, la sunamita, por esposa. Él no te lo negará'."
,"18":"Betsabé respondió: 'Bien, yo se lo diré'."
,"19":"Betsabé entró en la sala del rey Salomón para hablarle en favor de Adonías. El monarca se levantó para recibirla, le hizo una inclinación, se sentó en el trono y mandó que pusieran un sillón a su madre, la cual se sentó a su derecha."
,"20":"Ella dijo: 'Te voy a pedir una cosa insignificante; no me la niegues'. El rey contestó: 'Pide, madre mía, que no te lo negaré'."
,"21":"Ella repuso: 'Que des Abisag, la sunamita, a tu hermano Adonías por esposa'."
,"22":"El rey Salomón dijo a su madre: '¿Cómo pides tú a Abisag, la sunamita, para Adonías? Pide ya para él la realeza, pues es mi hermano mayor y están por él Abiatar, el sacerdote, y Joab, el hijo de Sarvia'."
,"23":"El rey Salomón juró por el Señor: 'Que Dios me castigue si Adonías no paga con su vida el haber pedido esto."
,"24":"¡Vive el Señor, que me ha confirmado y me ha puesto en el trono de mi padre, David, y que me ha fundado una casa, según su promesa, que hoy morirá Adonías!'."
,"25":"El rey Salomón lo ordenó, y Benayas, hijo de Yehoyadá, mató a Adonías en el acto."
,"26":"El rey dijo al sacerdote Abiatar: 'Vete a Anatot, a tus tierras, pues eres reo de muerte. No te doy hoy muerte porque has llevado el arca del Señor, Dios de mi padre, David, y porque tuviste parte en todas las tribulaciones de mi padre'."
,"27":"Así Salomón destituyó a Abiatar del cargo de sacerdote del Señor, cumpliéndose de esta suerte la sentencia que el Señor había pronunciado contra la casa de Elí, en Silo."
,"28":"Joab, que había seguido el partido de Adonías, y no el de Absalón, al enterarse de la noticia, se refugió en el santuario del Señor y se agarró a los cuernos del altar."
,"29":"Cuando le comunicaron al rey Salomón que Joab se había refugiado en el santuario del Señor y que estaba junto al altar, ordenó a Benayas, hijo de Yehoyadá, que fuera y lo matara."
,"30":"Benayas entró en el santuario del Señor y le dijo: 'El rey ordena que salgas'. Él replicó: 'No, quiero morir aquí'. Entonces Benayas comunicó al rey lo que Joab había respondido."
,"31":"El rey le dijo: 'Haz lo que ha dicho; mátale y entiérrale. Así apartarás de mí y de la casa de mi padre la sangre inocente que Joab había derramado,"
,"32":"y el Señor la hará recaer sobre su cabeza; pues mató a dos hombres justos y mejores que él, y los asesinó a espada sin que lo supiera mi padre David: a Abner, hijo de Ner, general del ejército de Israel, y a Amasá, hijo de Yéter, general del ejército de Judá."
,"33":"Su sangre recaerá sobre la cabeza de Joab y de su descendencia para siempre, mientras que la paz del Señor estará siempre con David, su linaje, su casa y su trono'."
,"34":"Benayas, hijo de Yehoyadá, fue y lo mató. Lo enterraron en su casa, en el desierto."
,"35":"El rey puso a Benayas, hijo de Yehoyadá, al frente del ejército, y a Sadoc, el sacerdote, le puso en lugar de Abiatar."
,"36":"El rey mandó llamar a Semeí y le dijo: 'Hazte una casa en Jerusalén y vive allí sin salir a parte alguna,"
,"37":"pues el día que salgas y pases el torrente Cedrón, ten por cierto que morirás sin remedio; tu sangre recaerá sobre tu cabeza'."
,"38":"Semeí respondió al rey: 'Está bien; haré lo que me ha ordenado mi señor, el rey'. Semeí vivió en Jerusalén mucho tiempo."
,"39":"Pero sucedió que, al cabo de tres años, dos criados de Semeí huyeron adonde Aquís, hijo de Maacá, rey de Gat. Cuando le dijeron a Semeí que sus criados estaban en Gat,"
,"40":"se levantó, aparejó su asno, se fue a Gat, adonde Aquís, a buscar a sus criados, y se los trajo de allí."
,"41":"Salomón se enteró de que Semeí había ido de Jerusalén a Gat y había vuelto;"
,"42":"lo llamó y le dijo: '¿No te juré yo por el Señor y te advertí seriamente que el día que salieras o te fueras a algún sitio, morirías sin remedio, y me respondiste que te parecía bien y que quedabas enterado?"
,"43":"¿Por qué no has cumplido el juramento del Señor y la orden que te di?'."
,"44":"Y añadió: 'Bien sabes todo el mal que hiciste a David, mi padre; tu corazón lo reconoce; el Señor haga recaer tu maldad sobre tu cabeza."
,"45":"El rey Salomón, en cambio, sea bendito y el trono de David esté firme en la presencia del Señor para siempre'."
,"46":"Y el rey dio orden a Benayas, hijo de Yehoyadá, que lo mató en el acto. Así el poder real se consolidó en manos de Salomón."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Salomón emparentó con el Faraón, rey de Egipto, casándose con una hija suya. La llevó a la ciudad de David, hasta que acabase de edificar su palacio, el templo del Señor y las murallas en torno a Jerusalén."
,"2":"Sin embargo, el pueblo sacrificaba en las colinas, pues para entonces aún no había sido edificado un templo al nombre del Señor."
,"3":"Y Salomón, aunque amaba al Señor, siguiendo las normas de su padre, David, sacrificaba él mismo y quemaba incienso en las colinas."
,"4":"El rey fue a Gabaón a ofrecer sacrificios, porque ésa era la colina más importante. Ofreció mil víctimas sobre aquel altar."
,"5":"En Gabaón el Señor se apareció a Salomón en sueños durante la noche y le dijo: 'Pide lo que quieras y yo te lo daré'."
,"6":"Salomón respondió: 'Tú trataste con gran bondad a mi padre, David, porque él se portó contigo con fidelidad, justicia y rectitud de corazón; y le has perpetuado esa gran bondad dándole un hijo que se siente sobre su trono, como hoy sucede."
,"7":"Ahora bien, Señor, Dios mío, me has hecho rey a mí, tu siervo, en lugar de mi padre, David; pero yo soy muy joven y no sé cómo actuar."
,"8":"Estoy al frente del pueblo que te elegiste, pueblo numeroso, que no se puede contar ni calcular por su multitud."
,"9":"Concédeme un corazón prudente para gobernar a tu pueblo y saber discernir entre lo bueno y lo malo. Porque ¿quién, si no, podrá gobernar a este tu pueblo tan grande?'."
,"10":"El Señor vio con buenos ojos que Salomón hubiese pedido tal cosa,"
,"11":"y por eso le dijo: 'Ya que me has hecho esta petición, y no has pedido para ti una vida larga, ni has pedido riquezas, ni has pedido la muerte de tus enemigos, sino que me has pedido sabiduría para gobernar con justicia,"
,"12":"hago lo que has dicho. Te doy un corazón sabio y prudente, como no hubo antes de ti ni lo habrá después."
,"13":"Añado además lo que no has pedido: riquezas y fama tales que no habrá en tus días rey alguno como tú."
,"14":"Si sigues mis caminos y cumples mis leyes y mandamientos, como lo hizo tu padre David, yo alargaré tus días'."
,"15":"Salomón se despertó y vio que había sido un sueño. Volvió a Jerusalén y se presentó ante el arca de la alianza del Señor, ofreció holocaustos y sacrificios de reconciliación, y dio un banquete a todos sus seguidores."
,"16":"Dos prostitutas fueron a ver al rey; se presentaron ante él,"
,"17":"y una de ellas dijo: '¡Con permiso, señor mío! Esta mujer y yo vivimos en la misma casa, y yo di a luz junto a ella en casa."
,"18":"A los tres días de mi parto, dio a luz también esta mujer. Estábamos juntas y ningún extraño había con nosotras en casa, fuera de nosotras dos."
,"19":"Una noche murió el hijo de esta mujer, por haberse acostado ella sobre él;"
,"20":"ella se levantó a medianoche, tomó a mi niño de mi lado, mientras tu sierva dormía, y lo acostó en su regazo, y a su hijo muerto lo acostó en mi seno."
,"21":"Cuando por la mañana me fui a levantar para dar el pecho a mi hijo, lo encontré muerto. Pero, examinándole luego atentamente a la luz del día, vi que no era mi hijo, el que yo había dado a luz'."
,"22":"La otra mujer replicó: 'No es verdad, pues mi hijo es el vivo y el tuyo es el muerto'. La primera decía: 'No, tu hijo es el muerto, y mi hijo el vivo'. De esta suerte disputaban delante del rey."
,"23":"El rey reflexionó: 'La una dice: Éste es mi hijo, el vivo; el tuyo es el muerto. La otra replica: No, tu hijo es el muerto y mi hijo el vivo'."
,"24":"Y ordenó: 'Traedme una espada'. Se la trajeron,"
,"25":"y el rey ordenó: 'Partid en dos el niño vivo y dad la mitad a cada una'."
,"26":"Entonces la madre del niño vivo, sintiendo conmoverse sus entrañas por su hijo, dijo: '¡Por favor, señor mío! Dale a ella el niño vivo, pero matarle... ¡no, que no le maten!'. La otra, en cambio, decía: 'Que no sea ni para mí ni para ti; que lo partan'."
,"27":"Entonces el rey tomó la palabra y sentenció: 'Dad a la primera el niño vivo, y no le matéis; ella es su madre'."
,"28":"Todo Israel se enteró de la sentencia que el rey había pronunciado y todos temieron al rey, viendo que había en él una sabiduría divina para administrar justicia."
}`)
	CurrentBook.AddChapter(4, `{
"1":"El rey Salomón reinaba sobre todo Israel."
,"2":"Éstos eran sus ministros: Azarías, hijo de Sadoc, era el sumo sacerdote;"
,"3":"Elijóret y Ajías, hijos de Sisá, eran secretarios; Josafat, hijo de Ajilud, el canciller;"
,"4":"Benayas, hijo de Yehoyadá, mandaba el ejército; Sadoc y Abiatar eran los sumos sacerdotes."
,"5":"Azarías, hijo de Natán, era superintendente; y Zabud, hijo del sacerdote Natán, era el consejero del rey;"
,"6":"Ajisar era mayordomo del palacio, y Adonirán, hijo de Abdá, el prefecto de las prestaciones personales."
,"7":"Salomón tenía por todo Israel doce intendentes, que abastecían al rey y su palacio cada uno durante un mes al año."
,"8":"Eran éstos: Ben Hur, en la montaña de Efraín;"
,"9":"Ben Déquer, en Magás, Saalbín, Bet Semes y Elón hasta Batjanán."
,"10":"Ben Jésed, en Arubot; éste tenía también Soco y toda la región de Jéfer."
,"11":"Ben Abinadab, esposo de Tafat, hija de Salomón, en toda la costa de Dor;"
,"12":"Baaná, hijo de Ajilud, en Tanac, Meguido y hasta más allá de Yocmeán; en todo Betsán, que está por bajo de Yezrael, desde Betsán hasta Abel Mejolá, junto a Sartán."
,"13":"Ben Guéber, en Ramot Galaad; tenía las aldeas de Yaír, hijo de Manasés, situadas en Galaad, y la región de Argob, en el Basán: sesenta grandes ciudades amuralladas y con cerrojos de bronce;"
,"14":"Ajinadab, hijo de Idó, en Majanayín;"
,"15":"Ajimás, en Neftalí, el cual estaba también casado con Bosmat, hija de Salomón."
,"16":"Baaná, hijo de Yusay, en Aser y Alot;"
,"17":"Josafat, hijo de Paruaj, en Isacar;"
,"18":"Semeí, hijo de Elá, en Benjamín;"
,"19":"Guéber, hijo de Urí, en la región de Galaad, la tierra de Sijón, rey de los amorreos, y de Og, rey de Basán. Un intendente por cada región."
,"20":"Judá e Israel eran numerosos como la arena que hay en la orilla del mar, y comían, bebían y estaban satisfechos."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Salomón dominaba en todos los reinos, desde el río Éufrates hasta la tierra de los filisteos y hasta los confines de Egipto; todos le pagaron tributo y estuvieron sometidos a él mientras vivió."
,"2":"La provisión diaria de Salomón era: trece mil quinientos kilos de flor de harina y veintisiete mil de harina corriente;"
,"3":"diez toros cebados y veinte de pasto, cien ovejas, sin contar los ciervos, gacelas, corzos, gansos y aves cebadas;"
,"4":"dominaba desde Tifsaj hasta Gaza, en todos los reinos del lado de acá del río Éufrates y gozaba de paz por todos los lados en su derredor."
,"5":"Israel y Judá vivieron tranquilos, cada uno bajo su parra y su higuera, desde Dan hasta Berseba, durante toda la vida de Salomón."
,"6":"Salomón tenía caballerizas para cuarenta mil caballos de tiro, destinados a sus carros, y para doce mil caballos de silla."
,"7":"Los intendentes abastecían al rey Salomón y a cuantos se sentaban a su mesa, cada uno en su mes. No faltaba nada."
,"8":"Traían también la cebada y el trigo para los caballos de tiro y de montar al lugar donde él estaba, según su turno."
,"9":"Dios concedió a Salomón sabiduría y prudencia grandísimas y una inteligencia tan grande como las arenas de las playas del mar."
,"10":"Por eso la sabiduría de Salomón superó a la de todos los orientales y egipcios;"
,"11":"fue más sabio que cualquier otro hombre; más que Etán, el ezrajita; más que Hemán, Calcol y Darda, hijos de Majol; y su fama se extendió por todas las naciones circunvecinas."
,"12":"Salomón pronunció tres mil proverbios, y sus poemas llegaron a cinco mil;"
,"13":"trató acerca de los árboles, desde el cedro del Líbano hasta el hisopo que brota en la pared; disertó acerca de los animales, de las aves, de los reptiles y de los peces."
,"14":"Por eso venían de todos los pueblos a escuchar su sabiduría, y de parte de todos los reyes de la tierra que habían tenido noticia de su sabiduría."
,"15":"Jirán, rey de Tiro, al enterarse de que Salomón había sido ungido rey en lugar de su padre, le envió una embajada, pues Jirán había sido amigo de David toda su vida."
,"16":"Y Salomón mandó a decir a Jirán:"
,"17":"'Tú ya sabes cómo mi padre, David, no pudo construir la casa al nombre del Señor, su Dios, a causa de las guerras en que se vio envuelto, hasta que el Señor puso a sus enemigos bajo las plantas de sus pies."
,"18":"Pero ahora el Señor, mi Dios, me ha permitido vivir en paz sin ningún enemigo y ninguna adversidad."
,"19":"He decidido construir un templo a su nombre, tal como el Señor ordenó a mi padre, David: El hijo tuyo, que yo pondré en tu lugar sobre tu trono, ése construirá el templo a mi nombre."
,"20":"Así, pues, ordena que me corten cedros del Líbano. Mis súbditos se unirán a los tuyos, y yo te daré por tus súbditos el salario que tú me digas. Porque bien sabes que entre nosotros no hay nadie que sepa cortar los árboles como los sidonios'."
,"21":"Cuando Jirán escuchó el mensaje de Salomón, se alegró sobremanera y exclamó: ¡Bendito sea el Señor, que ha dado a David un hijo sabio, que gobierne a ese gran pueblo!'."
,"22":"Entonces Jirán mandó decir a Salomón: 'He recibido tu mensaje. Yo cumpliré todos tus deseos en cuanto a madera de cedro y abeto."
,"23":"Mis súbditos las bajarán del Líbano al mar; las pondré sobre el mar, en balsas, hasta el lugar que tú me indiques; allí las soltaré para que tú las transportes. Tú, a cambio, cumplirás mi deseo suministrando alimentos a mi corte'."
,"24":"Jirán daba a Salomón las maderas de cedro y abeto que pedía."
,"25":"Salomón, a cambio, suministraba cada año a Jirán, para alimento de su corte, nueve mil toneladas de trigo y novecientas de aceite."
,"26":"El Señor concedió a Salomón sabiduría, según le había prometido, y hubo paz entre Jirán y Salomón, los cuales hicieron un pacto."
,"27":"El rey Salomón hizo una leva de treinta mil hombres en todo Israel."
,"28":"Y los mandó al Líbano en brigadas de diez mil cada mes. Un mes estaban en el Líbano y dos meses en sus casas. Al frente de la leva estaba Adonirán."
,"29":"Salomón tenía setenta mil acarreadores y ochenta mil canteros en la montaña,"
,"30":"sin contar los tres mil trescientos capataces constituidos por Salomón, que vigilaban la tarea."
,"31":"El rey ordenó que se trajesen grandes bloques de piedra para cimentar el edificio con piedras sillares;"
,"32":"y las labraron los canteros de Salomón, los canteros de Jirán y los guiblios. Así prepararon el maderamen y las piedras para la fábrica del templo."
}`)
	CurrentBook.AddChapter(6, `{
"1":"El año cuatrocientos ochenta de la salida de los israelitas de Egipto, el cuarto año de reinado de Salomón sobre Israel, en el segundo mes, el mes de ziv, Salomón comenzó a construir el templo del Señor."
,"2":"El templo tenía treinta metros de largo, diez de ancho y quince de alto."
,"3":"El vestíbulo de delante del santuario tenía diez metros de largo a lo ancho del edificio, y cinco de ancho a lo largo del mismo."
,"4":"Hizo al templo ventanas con rejas,"
,"5":"y construyó, adosado al muro del templo, un anejo de tres pisos en torno a la nave central y a la cámara sagrada con departamentos."
,"6":"La planta baja tenía dos metros y medio de ancha; el piso del medio, tres, y el tercero, tres y medio; había dispuesto en el muro exterior del templo, todo en derredor, una entalladura, para no tener que empotrar en los muros del edificio."
,"7":"En la construcción del templo se emplearon piedras entalladas en la misma cantera, de suerte que mientras se construía el edificio no se oyó golpe de martillo, de hacha u otro cualquier instrumento de hierro en el templo."
,"8":"La puerta de entrada al departamento interior estaba en el costado derecho del edificio, y por una escalera de caracol se subía al intermedio, y del intermedio, al tercero."
,"9":"Una vez que hubo construido y ultimado el edificio, lo recubrió con artesonado de cedro."
,"10":"Construyó los departamentos que rodeaban el templo, de dos metros y medio de altura, y los trabó al edificio con vigas de cedro."
,"11":"Entonces el Señor dijo a Salomón:"
,"12":"'Por este templo que estás construyendo te prometo que, si caminas según mis leyes, pones en práctica mis mandamientos y cumples todos mis preceptos, cumpliré contigo la promesa que hice a tu padre, David."
,"13":"Habitaré en medio de los israelitas y no abandonaré a mi pueblo, Israel'."
,"14":"Salomón ultimó la fábrica del templo,"
,"15":"recubrió las paredes interiores del edificio con planchas de cedro, desde el pavimento del templo hasta las vigas del techo, revistiendo así de madera todo el interior; y el suelo del templo lo revistió con planchas de ciprés."
,"16":"Recubrió los diez metros de la parte posterior del templo con planchas de cedro, desde el suelo hasta las vigas, y destinó el interior para el lugar santísimo."
,"17":"La nave central que estaba delante del lugar santísimo tenía veinte metros de larga."
,"18":"Todo el interior del edificio era de cedro con bajorrelieves de coloquíntidas y guirnaldas de flores. Todo era cedro. No se veía la piedra."
,"19":"En el fondo del edificio, por dentro, preparó el lugar santísimo, para colocar allí el arca de la alianza del Señor."
,"20":"Tenía diez metros de largo, diez de ancho y diez de alto; lo cubrió de oro puro; hizo un altar de cedro"
,"21":"para delante del lugar santísimo, y lo recubrió también de oro puro."
,"22":"Todo el edificio lo revistió de oro de arriba abajo."
,"23":"Puso en el lugar santísimo dos querubines de madera de olivo de cinco metros de altura."
,"24":"Cada una de las dos alas de los querubines medía dos metros y medio, o sea, cinco metros de un extremo a otro."
,"25":"La medida y la forma eran las mismas para ambos querubines."
,"26":"La altura de los querubines era de cinco metros."
,"27":"Colocó los querubines en el centro del lugar santísimo y allí estaban con las alas desplegadas, de modo que un ala de uno tocaba en la pared y un ala del otro tocaba la pared opuesta; las otras dos alas se tocaban una a otra en medio del edificio."
,"28":"También revistió de oro los querubines."
,"29":"Y todos los muros del templo, en derredor, los hizo esculpir con bajorrelieves de querubines, palmas y flores, por dentro y por fuera."
,"30":"El pavimento del templo lo revistió de oro, por dentro y por fuera."
,"31":"Para la entrada del santuario hizo batientes de madera de olivo; el dintel y las jambas formaban un pentágono."
,"32":"Los dos batientes de la puerta eran de madera de olivo, y sobre ellos hizo esculpir entalladuras de querubines, palmas y guirnaldas de flores, recubriéndolas de oro, incluso los querubines y las palmas."
,"33":"Hizo asimismo para la entrada de la nave central puertas de madera de olivo, pero cuadrangulares,"
,"34":"y dos batientes de madera de ciprés, cada uno de los cuales tenía dos hojas giratorias,"
,"35":"con entalladuras de querubines, palmas y guirnaldas de flores, recubriéndolo de oro exactamente ajustado a las figuras."
,"36":"Y, en fin, construyó el atrio interior con tres hileras de sillares y una de vigas de cedro."
,"37":"El año cuarto, el mes de ziv, se echaron los cimientos del templo del Señor;"
,"38":"y el año undécimo, el mes de bul, o sea, el mes octavo, quedó ultimado el edificio en todas sus partes y con todo lo necesario. Se construyó, pues, en siete años."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Salomón construyó su palacio; tardó trece años en terminarlo."
,"2":"Construyó el palacio, 'Bosque del Líbano', de cincuenta metros de largo, veinticinco de ancho y quince de alto, sostenido sobre cuatro hileras de columnas de cedro, en las que se apoyaban vigas de cedro;"
,"3":"y un techado de cedro también en la parte superior, sobre las estancias, que se apoyaban en las cuarenta y cinco columnas, a quince por hilera;"
,"4":"y tres órdenes de pisos, con tres series de ventanas unas frente a otras."
,"5":"Todas las puertas y ventanas eran de marco cuadrangular, y las tres series se correspondían unas enfrente de otras."
,"6":"Hizo también el 'Pórtico de las columnas', de veinticinco metros de largo y quince de ancho; y delante de él otro pórtico, con columnata y arquitrabe."
,"7":"Hizo asimismo el 'Pórtico del trono', donde administraba justicia, llamado el 'Pórtico de la justicia', y lo recubrió de cedro desde el suelo hasta el techo."
,"8":"Del mismo estilo hizo la propia casa, en un atrio distinto detrás del pórtico; y a la hija del Faraón, que había tomado por esposa, le hizo una casa al estilo del pórtico."
,"9":"Todo esto era de piedras costosas, talladas a escuadra, cortadas con la sierra, por dentro y por fuera, desde los cimientos hasta las cornisas y desde fuera hasta el atrio grande."
,"10":"Los fundamentos eran de piedras costosas, grandes piedras de cuatro y cinco metros;"
,"11":"y la alzada, de piedras costosas, talladas a escuadra, y de madera de cedro."
,"12":"El atrio grande tenía en derredor tres órdenes de piedras, talladas a escuadra, y uno de vigas de cedro; y lo mismo el atrio interno del templo del Señor y el atrio del palacio."
,"13":"El rey Salomón mandó traer de Tiro a Jirán,"
,"14":"hijo de una viuda de la tribu de Neftalí y de padre tirio, que trabajaba el bronce. Estaba dotado de sabiduría, inteligencia y técnica para realizar cualquier trabajo en bronce. Se presentó al rey Salomón y ejecutó todos sus encargos."
,"15":"Modeló dos columnas de bronce, de nueve metros de altura y seis metros de perímetro y huecas por dentro."
,"16":"Hizo dos capiteles de bronce fundido, para ponerlos sobre las columnas, ambos de dos metros y medio."
,"17":"Y para los capiteles que estaban sobre las columnas fabricó guirnaldas en trenzado a manera de cadenas, una para cada capitel."
,"18":"Hizo también granadas en dos hileras alrededor de cada guirnalda, para cubrir los capiteles que estaban sobre las columnas."
,"19":"Los capiteles tenían forma de flor de loto, de dos metros."
,"20":"Cada capitel llevaba en su parte más alta y junto a la guirnalda, todo alrededor, doscientas granadas."
,"21":"Salomón levantó las columnas en el pórtico del santuario; al levantarlas llamó a la de la derecha 'yaquín', y a la de la izquierda, 'boaz'. La parte superior de las columnas tenía forma de flor de loto."
,"22":"Así quedó ultimada la obra de las columnas."
,"23":"Hizo también una pila de bronce muy grande, redonda, de cinco metros de diámetro, dos y medio de alto y quince de perímetro."
,"24":"Bajo el borde había alrededor de la pila una orla de coloquíntidas, diez por cada medio metro. Las hileras de coloquíntidas habían sido fundidas a la vez que la pila,"
,"25":"la cual descansaba sobre doce toros, tres de ellos vueltos al norte, tres al sur, tres al este y tres al oeste, y todas sus partes traseras quedaban hacia dentro."
,"26":"Su grosor era de veintidós centímetros, y su borde como el de una copa, en forma de flor de loto. Cabían unos noventa mil litros."
,"27":"Hizo diez basas de bronce, de cinco metros de largo cada una por dos de ancho y uno y medio de alto."
,"28":"Las basas se componían de barras y paneles entre los marcos."
,"29":"Sobre los paneles había esculpidos leones, bueyes y querubines; y sobre los marcos, tanto encima como debajo de los leones y bueyes, guirnaldas de flores formando colgantes."
,"30":"Cada basa tenía cuatro ruedas de bronce, con sus ejes también de bronce, y en sus cuatro ángulos había unos pies. Estos pies estaban fundidos por debajo del aguamanil y por detrás de cada una de las guirnaldas."
,"31":"La basa tenía en la parte superior interna una cavidad de medio metro de altura; la cavidad era redonda, hecha a la forma del aguamanil, y también sobre esa cavidad había entalladuras. Los paneles eran cuadrados, no redondos."
,"32":"Las cuatro ruedas estaban debajo de los paneles, y los ejes de las ruedas, unidos a las basas. La altura de cada rueda era de unos setenta y cinco centímetros."
,"33":"Las ruedas eran como las de carro; y los ejes, llantas, rayos y cubos, todo de bronce."
,"34":"En los cuatro ángulos de cada basa había cuatro pies formando todo un solo cuerpo."
,"35":"En lo más alto de la basa había una cavidad redonda de unos veinticinco centímetros de altura; y en la parte superior de la basa, los pies y paneles formaban un solo cuerpo con ella."
,"36":"Sobre las planchas de los ejes y sobre los paneles entalló querubines, leones y palmas, según el espacio de cada uno, con guirnaldas alrededor."
,"37":"Así hizo las diez basas, con una misma fundición, una misma medida y una misma forma para todas."
,"38":"Hizo también los diez aguamaniles de bronce, cada uno de dos metros, y con mil ochocientos litros de capacidad; cada aguamanil descansaba sobre una de las diez basas."
,"39":"Colocó cinco basas al lado derecho del templo y cinco al lado izquierdo, y la pila la puso al lado derecho del edificio, al sudeste."
,"40":"Jirán hizo también los calderos, palas y aspersorios. Así terminó Jirán de hacer toda la obra que llevó a cabo para el rey Salomón en el templo del Señor: "
,"41":"las dos columnas, las dos esferas para los capiteles de las dos columnas, las dos guirnaldas para cubrir las dos esferas de los capiteles de las columnas;"
,"42":"las cuatrocientas granadas para las dos guirnaldas, dos series de granadas para cada guirnalda;"
,"43":"las diez basas y los diez aguamaniles;"
,"44":"la pila y los doce toros;"
,"45":"los calderos, las palas y los aspersorios. Todos estos utensilios que Jirán hizo al rey para el templo del Señor eran de bronce bruñido."
,"46":"El rey los hizo fundir en moldes de arcilla en la región del Jordán, entre Sucot y Sartán."
,"47":"Salomón colocó todos estos utensilios. Por su grandísima cantidad no se pudo averiguar el peso del bronce."
,"48":"Salomón hizo todos los demás utensilios del templo del Señor: el altar de oro; la mesa de oro, sobre la que se ponían los panes de la proposición;"
,"49":"los candelabros de oro puro para delante del lugar santísimo, cinco a la derecha y cinco a la izquierda; flores, lámparas y despabiladeras de oro;"
,"50":"palanganas, cuchillos, aspersorios, bandejas y despabiladeras: todo de oro puro; los quicios de las puertas del lugar santísimo y de la nave central, también de oro."
,"51":"Cuando se terminaron todas las obras que el rey Salomón mandó hacer en el templo llevó todos los objetos que su padre, David, había dedicado al Señor: la plata, el oro, los utensilios, y los depositó en el tesoro del templo del Señor."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Salomón convocó en Jerusalén a los ancianos de Israel, a los jefes de las tribus y de las familias israelitas, para llevar el arca de la alianza del Señor, desde Sión, la ciudad de David."
,"2":"Se reunieron en torno al rey Salomón todos los israelitas en la fiesta del mes de etanín, el mes séptimo."
,"3":"Cuando llegaron todos los ancianos de Israel, los sacerdotes tomaron el arca"
,"4":"y la llevaron junto con la tienda de la reunión y todos los utensilios sagrados que había en ella. La llevaron los sacerdotes y los levitas."
,"5":"El rey Salomón y toda la comunidad israelita, reunidos delante del arca, sacrificaban ovejas y bueyes en cantidad incalculable."
,"6":"Los sacerdotes pusieron el arca de la alianza del Señor en el lugar santísimo del templo, bajo las alas de los querubines,"
,"7":"pues los querubines tenían las alas extendidas sobre el lugar del arca, cubriendo el arca y sus barras."
,"8":"Las barras eran tan largas que se podían ver sus extremidades desde la nave central que estaba delante del lugar santísimo, aunque no desde fuera. Allí han estado hasta el presente."
,"9":"En el arca no había más que las dos tablas de piedra, que puso allí Moisés en el Horeb, cuando el Señor hizo la alianza con los israelitas a su salida de Egipto."
,"10":"Mientras los sacerdotes salían del santuario, una nube llenó el templo del Señor,"
,"11":"de modo que los sacerdotes no pudieron continuar su servicio a causa de la nube, pues la gloria del Señor había llenado el templo."
,"12":"Entonces Salomón exclamó: 'Tú, Señor, has dicho que vives en la nube oscura."
,"13":"Yo te he construido una casa donde residas, un lugar donde vivas para siempre'."
,"14":"Luego el rey se volvió y bendijo a toda la comunidad israelita que estaba de pie,"
,"15":"y añadió: 'Bendito sea el Señor, Dios de Israel, que ha cumplido con su propia mano lo que con su boca había prometido a mi padre David diciendo:"
,"16":"Desde el día que saqué a mi pueblo de Egipto, no he escogido ninguna ciudad de entre las tribus de Israel para que se me construyera en ella un templo a mi nombre, sino que elegí a David para que estuviese al frente de mi pueblo Israel."
,"17":"Ahora bien, mi padre David quiso construir un templo en honor del Señor, Dios de Israel."
,"18":"Pero el Señor le dijo: Has proyectado construir un templo a mi nombre, y has hecho bien en proyectarlo."
,"19":"Pero no lo construirás tú, sino un hijo tuyo salido de tus entrañas será el que lo construya."
,"20":"Y el Señor ha cumplido su palabra. Yo me alcé en el puesto de mi padre David y me senté sobre el trono de Israel, como dijo el Señor; construí el templo en honor del Señor, Dios de Israel,"
,"21":"e instalé en él el arca donde está la alianza del Señor, la alianza que hizo con nuestros padres cuando los sacó de Egipto'."
,"22":"Entonces Salomón se puso delante del altar del Señor en presencia de toda la comunidad israelita, alzó sus manos al cielo y"
,"23":"dijo: 'Señor, Dios de Israel, no hay Dios semejante a ti, ni arriba en los cielos, ni abajo en la tierra. Tú guardas la alianza y la fidelidad con tus siervos que siguen tus caminos de todo corazón."
,"24":"Tú has cumplido la promesa que hiciste a tu siervo David, mi padre; tus manos han realizado lo que tus labios habían prometido, como hoy se ve."
,"25":"Ahora, Señor, Dios de Israel, cumple también lo que prometiste a tu siervo David, mi padre: No te faltará nunca en mi presencia un varón que se siente sobre el trono de Israel, con tal que tus hijos se porten bien y sigan mis caminos como lo has hecho tú."
,"26":"Así, pues, Dios de Israel, que se cumpla la promesa que hiciste a tu siervo David, mi padre."
,"27":"Pero, ¿será posible que Dios pueda habitar sobre la tierra? Si los cielos en toda su inmensidad no te pueden contener; ¡cuánto menos este templo que yo he construido!"
,"28":"Atiende, Señor, Dios mío, la oración y la súplica que tu siervo eleva hoy a ti;"
,"29":"ten tus ojos noche y día fijos sobre este templo, sobre este lugar del que dijiste: mi nombre estará aquí; y escucha la plegaria que tu siervo haga en este lugar."
,"30":"Escucha la plegaria que tu siervo y tu pueblo Israel te hagan en este lugar; escúchala desde tu morada en los cielos; escúchalos y perdona."
,"31":"Cuando alguno peque contra su prójimo y le obliguen a jurar ante tu altar en este templo,"
,"32":"escucha tú desde el cielo, intervén y haz justicia a tus siervos, condena al culpable haciendo recaer su maldad sobre su cabeza, y absuelve al inocente retribuyéndole conforme a su inocencia."
,"33":"Cuando tu pueblo, Israel, sea derrotado por el enemigo por haber pecado contra ti, si se convierte, te confiesa su pecado, te suplica y te ruega en este templo,"
,"34":"escucha tú en el cielo, perdona el pecado de tu pueblo Israel, y vuélvelo a la tierra que diste a sus padres."
,"35":"Cuando se cierre el cielo y no haya lluvia por haber pecado contra ti, si rezan en este lugar, te confiesan su pecado y se arrepienten a causa de tu castigo,"
,"36":"escucha tú en el cielo, perdona el pecado de tus siervos y de tu pueblo Israel, enséñales el buen camino por donde deben andar y manda la lluvia sobre la tierra que le diste en heredad."
,"37":"Cuando en el país haya hambre, peste, tizón, añublo, langosta o pulgón, si el enemigo los asedia en alguna de sus ciudades; en cualquier plaga o enfermedad,"
,"38":"toda oración, toda súplica que te dirija cualquier persona o todo tu pueblo Israel, reconociendo cada uno la plaga de su propio corazón y extendiendo sus manos hacia este templo,"
,"39":"escúchala tú desde el cielo, lugar de tu morada, y perdona; da a cada uno según su conducta, pues sólo tú conoces el corazón de todos los hombres;"
,"40":"así te respetarán mientras vivan en la tierra que diste a nuestros padres."
,"41":"También al extranjero, que no es de tu pueblo Israel, si viene de tierras lejanas atraído por la fama de tu nombre,"
,"42":"porque se tendrá noticia de tu nombre grandioso, de la fuerza de tu mano y del poder de tu brazo; si viene a orar en este templo,"
,"43":"escúchale tú en el cielo, lugar de tu morada, y haz todo lo que ese extranjero te haya pedido, para que todos los pueblos de la tierra conozcan tu nombre, te teman, como tu pueblo Israel, y reconozcan que tu nombre es invocado en este templo que he construido."
,"44":"Cuando tu pueblo salga a la guerra contra sus enemigos por el camino que tú les hayas señalado, si rezan al Señor vueltos hacia la ciudad que tú has elegido y hacia el templo que yo he construido a tu nombre,"
,"45":"escucha tú en el cielo su oración y súplica y hazles justicia."
,"46":"Cuando pequen contra ti -pues no hay hombre que no peque-, y tú, irritado contra ellos, los entregues al enemigo, que los llevará cautivos a tierra enemiga, lejana o cercana;"
,"47":"si ellos, volviendo en sí en el país a que hayan sido deportados, se convierten y te suplican en la tierra de su cautividad, diciendo: Hemos pecado, hemos obrado inicua e injustamente;"
,"48":"si se convierten a ti con todo su corazón y con toda su alma en la tierra de su cautividad, a la que han sido deportados; si rezan vueltos hacia la tierra que diste a sus padres, hacia la ciudad que tú has elegido y hacia el templo que yo he construido a tu nombre,"
,"49":"escucha tú en el cielo, lugar de tu morada, su oración y súplica; hazles justicia,"
,"50":"perdona a tu pueblo los pecados y todas las rebeliones que hayan cometido contra ti, y haz que encuentren misericordia en sus deportadores, para que éstos tengan de ellos piedad,"
,"51":"pues son tu pueblo y tu herencia, que sacaste de Egipto, el horno de fundición de hierro."
,"52":"Ten abiertos tus ojos a las súplicas de tu siervo y de tu pueblo Israel, y atiéndelos cuando te invoquen,"
,"53":"pues tú los separaste como heredad tuya de entre todos los pueblos de la tierra, conforme a lo que dijiste por medio de Moisés, tu siervo, cuando sacaste a nuestros padres de Egipto, ¡oh Señor, Señor!'."
,"54":"Al terminar de hacer al Señor esta oración y súplica, Salomón se levantó de delante del altar del Señor, donde estaba arrodillado, y con las manos levantadas hacia el cielo,"
,"55":"y puesto en pie, bendijo a toda la comunidad israelita en alta voz, diciendo:"
,"56":"'¡Bendito sea el Señor, que ha concedido la paz a su pueblo Israel, tal como lo había prometido! Ni una sola de sus promesas de bienandanza, hechas por medio de Moisés, su siervo, ha fallado."
,"57":"Que el Señor, nuestro Dios, esté con nosotros, como lo estuvo con nuestros padres; que no nos deje ni nos abandone,"
,"58":"sino que incline nuestro corazón hacia él, para que sigamos sus caminos y guardemos todos sus mandatos, sus leyes y sus preceptos, los que prescribió a nuestros padres."
,"59":"Que estas palabras con que he suplicado al Señor estén presentes ante él día y noche, a fin de que en todo tiempo defienda la causa de su siervo y de su pueblo Israel,"
,"60":"para que reconozcan todos los pueblos de la tierra que el Señor es Dios y que fuera de él no hay otro."
,"61":"Vuestro corazón sea todo para el Señor, Dios nuestro, caminando según sus preceptos y guardando sus mandamientos, como hoy lo hacéis'."
,"62":"El rey y todo Israel ofrecieron sacrificios al Señor."
,"63":"Salomón inmoló, como sacrificio de reconciliación ofrecido al Señor, veintidós mil toros y ciento veinte mil ovejas. De esta manera, el rey y todos los israelitas celebraron la dedicación del templo del Señor."
,"64":"En aquel día el rey consagró el centro del atrio que estaba delante del templo del Señor, pues allí ofreció los holocaustos, las ofrendas y las grasas de los sacrificios de reconciliación, porque el altar de bronce que estaba delante del Señor era pequeño para tantos holocaustos, ofrendas y grasas de los sacrificios de reconciliación."
,"65":"En aquella ocasión Salomón, y con él la inmensa comunidad de Israel venida desde la entrada de Jamat hasta el torrente de Egipto, celebraron la fiesta ante el Señor, Dios nuestro, durante siete días."
,"66":"Al octavo día despidió Salomón al pueblo, y ellos bendijeron al rey y se volvieron a sus casas alegres y contentos por todos los beneficios que el Señor había hecho a David, su siervo, y a su pueblo Israel."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Cuando acabó Salomón de construir el templo del Señor, el palacio real y todo cuanto se había propuesto hacer,"
,"2":"se le apareció el Señor por segunda vez, como se le había aparecido en Gabaón,"
,"3":"y le dijo: 'He escuchado la oración y súplica que me has hecho; he santificado este templo que has construido para que resida en él mi nombre por siempre y para que en él estén siempre fijos mis ojos y mi corazón."
,"4":"En cuanto a ti, si andas en mi presencia, como anduvo tu padre David, con pureza y rectitud de corazón; si cumples todo lo que yo te mande y si guardas mis leyes y mandamientos,"
,"5":"yo consolidaré el trono de tu reino sobre Israel para siempre, como se lo prometí a tu padre David, cuando dije: No te faltará un varón sobre el trono de Israel."
,"6":"Pero si vosotros y vuestros hijos os apartáis de mí y no guardáis mis leyes y mandamientos, que yo os he prescrito; si os vais a servir y a dar culto a dioses ajenos,"
,"7":"exterminaré a Israel de la tierra que les he dado y retiraré de mi presencia el templo que he consagrado a mi nombre, e Israel será irrisión y burla de todos los pueblos."
,"8":"Este templo será reducido a un montón de ruinas; todo el que pase delante de él se quedará asombrado y silbará. Preguntarán: ¿Por qué ha tratado así el Señor a esta tierra y a este templo?;"
,"9":"y les responderán: Porque abandonaron al Señor, su Dios, que había sacado a sus padres de Egipto, y se fueron a servir y a dar culto a dioses ajenos; por eso ha traído sobre ellos tantos males'."
,"10":"Salomón construyó los dos edificios, el templo del Señor y el palacio real, en veinte años."
,"11":"Jirán, rey de Tiro, había suministrado a Salomón maderas de cedro y de ciprés y oro, y Salomón entregó a Jirán veinte ciudades en la región de Galilea."
,"12":"Jirán fue a ver las ciudades que Salomón le había dado y, como no le gustaron,"
,"13":"dijo: '¿Qué ciudades son éstas que me has dado, hermano mío?'. Y les dio por nombre 'Tierra de Cabul', hasta nuestros días."
,"14":"Jirán había mandado al rey cuatro mil ciento cuarenta kilos de oro."
,"15":"La leva de prestación personal que el rey Salomón impuso para construir el templo del Señor, su palacio, el terraplén y la muralla de Jerusalén, Jasor, Meguido y Guézer, fue así:"
,"16":"Faraón, rey de Egipto, se había apoderado de Guézer y le había pegado fuego matando a los cananeos que habitaban la ciudad, y la había dado luego en dote a su hija, esposa de Salomón."
,"17":"Salomón reedificó Guézer, Bejorón de Abajo,"
,"18":"Baalat y Tamar en la parte desierta del país,"
,"19":"así como las ciudades almacenes para los carros y la caballería; hizo todo lo que quiso en Jerusalén, en el Líbano y en todo el territorio de su jurisdicción."
,"20":"A los que quedaban de los amorreos, hititas, fereceos, heveos y jebuseos, no pertenecientes al pueblo de Israel,"
,"21":"a los que los israelitas no habían podido exterminar, Salomón les impuso un servicio de prestación personal hasta nuestros días."
,"22":"A los israelitas no les impuso trabajos forzados: ellos eran sus guerreros, cortesanos, generales, prefectos y capitanes de carros y caballería."
,"23":"Los jefes y los capataces que tenía el rey Salomón al mando de los obreros eran quinientos cincuenta."
,"24":"Cuando la hija del Faraón se trasladó de la ciudad de David al palacio que le había edificado, Salomón construyó el terraplén."
,"25":"Tres veces al año ofrecía Salomón holocaustos y sacrificios de reconciliación sobre el altar que había levantado y quemaba incienso delante del Señor cuando hubo ultimado el templo."
,"26":"El rey Salomón construyó, además, una flota en Esyón Guéber, junto a Elat, en la costa del mar Rojo, en el territorio de Edón."
,"27":"Jirán mandó como tripulantes a servidores suyos, marineros expertos en las cosas del mar, que con los siervos de Salomón"
,"28":"fueron a Ofir y trajeron unos quince mil kilos de oro para el rey Salomón."
}`)
	CurrentBook.AddChapter(10, `{
"1":"La reina de Sabá tuvo conocimiento de la fama de Salomón y fue a ponerle a prueba con enigmas."
,"2":"Entró en Jerusalén con un gran séquito de camellos, cargados de aromas y oro en abundancia, y de piedras preciosas; se presentó a Salomón, y le propuso todo lo que pensaba."
,"3":"Salomón le resolvió todas sus cuestiones; no hubo nada que no pudiera resolver."
,"4":"Cuando la reina de Sabá vio la sabiduría de Salomón y el palacio que había construido,"
,"5":"los manjares de su mesa, el ordenamiento jerárquico de sus cortesanos, el comportamiento y el uniforme de sus camareros, sus provisiones de bebidas y los holocaustos que ofrecía en el templo del Señor, se quedó asombrada,"
,"6":"y dijo al rey: 'Realmente es verdad todo lo que yo había oído en mi tierra de tus obras y de tu sabiduría."
,"7":"Yo no lo quería creer hasta que he venido y lo he visto con mis propios ojos, pero reconozco que no se me había dicho ni la mitad. Tu sabiduría y grandeza sobrepasan la fama que había llegado a mis oídos."
,"8":"¡Dichosas tus gentes! ¡Dichosos tus servidores, que están siempre junto a ti y escuchan tu sabiduría!"
,"9":"¡Bendito sea el Señor, tu Dios, que se ha complacido en ti, poniéndote sobre el trono de Israel! En su amor eterno a Israel te ha constituido rey, para administrar el derecho y la justicia'."
,"10":"Luego ofreció al rey cuatro mil kilos de oro, gran cantidad de aromas y piedras preciosas. Nunca más se vio tanta cantidad de aromas como la que la reina de Sabá ofreció al rey Salomón."
,"11":"Y la flota de Jirán, que traía oro de Ofir, había traído también de allí maderas de sándalo y piedras preciosas en gran cantidad."
,"12":"Con las maderas, el rey hizo balaustradas para el templo del Señor y para el palacio real, y cítaras y arpas para los cantores. Madera de sándalo como aquélla no se ha traído ni se ha vuelto a ver hasta nuestros días."
,"13":"El rey Salomón, por su parte, dio a la reina de Sabá todo lo que ella quiso, aparte de lo que le regaló con la munificencia propia del rey Salomón. La reina se despidió y, con su séquito, emprendió el viaje de regreso a su país."
,"14":"El peso del oro que el rey Salomón recibía cada año era de unos veintitrés mil kilos,"
,"15":"sin contar el procedente del tráfico de los comerciantes y de los mercaderes ambulantes, de todos los reyes de Arabia y de los gobernadores del país."
,"16":"El rey Salomón hizo doscientos escudos de oro batido, empleando unos siete kilos de oro por escudo,"
,"17":"y seiscientos escudos más pequeños de oro batido, empleando poco más de kilo y medio por cada uno. Y el rey los puso en la sala 'Bosque del Líbano'."
,"18":"Hizo también un gran trono de marfil, y lo recubrió de oro puro."
,"19":"El trono tenía seis gradas: la parte superior, el respaldo redondo, brazos a ambos lados del asiento, dos leones apostados junto a los brazos"
,"20":"y doce leones a ambos lados de las gradas. Nunca se había hecho cosa semejante en reino alguno."
,"21":"Todos los vasos de beber del rey Salomón eran de oro, y toda la vajilla del palacio 'Bosque del Líbano', de oro fino. No había nada de plata, pues la plata no se estimaba en tiempo del rey Salomón."
,"22":"El rey tenía en el mar una flota junto con la flota de Jirán, y una vez cada tres años llegaba la flota de Tarsis cargada de oro, plata, marfil, monos y pavos reales."
,"23":"El rey Salomón superó a todos los reyes de la tierra en riqueza y sabiduría;"
,"24":"todo el mundo quería visitar a Salomón para escuchar la sabiduría que Dios le había dado,"
,"25":"y todos traían presentes, objetos de oro y plata, vestidos, armas, aromas, caballos y mulos. Esto todos los años."
,"26":"Salomón reunió carros y caballos, llegando a tener mil cuatrocientos carros y doce mil caballos, que destacó en las ciudades de guarnición y en Jerusalén, junto al rey."
,"27":"El monarca logró que la plata abundara en Jerusalén como las piedras, y los cedros como los sicómoros en la Sefela."
,"28":"La importación de caballos destinados a Salomón procedía de Musur y Cilicia, donde los mercaderes del rey los compraban al contado."
,"29":"Un carro por seiscientas monedas de plata, y un caballo por ciento cincuenta. Por el mismo precio los mercaderes se lo vendían también a los reyes hititas y sirios."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Pero el rey Salomón, además de la hija del Faraón, amó a muchas mujeres extranjeras, moabitas, amonitas, edomitas, sidonias e hititas,"
,"2":"esto es, de las naciones de quienes había dicho el Señor a los israelitas: 'No os unáis con ellas en matrimonio, pues inclinarán vuestro corazón hacia sus dioses'. Pero Salomón se enamoró de ellas,"
,"3":"y tuvo setecientas mujeres reinas y trescientas concubinas que pervirtieron su corazón."
,"4":"En su ancianidad ellas le desviaron el corazón hacia dioses extranjeros, de modo que su corazón no fue enteramente del Señor como lo fue el corazón de su padre David."
,"5":"Salomón rindió culto a Astarté, diosa de los sidonios, y a Milcón, abominación de los amonitas."
,"6":"Salomón hizo así lo que es malo a los ojos del Señor, y no le fue fiel, como su padre David."
,"7":"En el monte que está enfrente de Jerusalén construyó un santuario a Camós, ídolo repugnante de Moab, y a Milcón, ídolo repugnante de los amonitas."
,"8":"Lo mismo hizo para todas sus mujeres extranjeras, que en ellos quemaban incienso y ofrecían sacrificios a sus dioses."
,"9":"El Señor se irritó contra Salomón por haber desviado su corazón del Señor, Dios de Israel, que se le había aparecido dos veces"
,"10":"y le había ordenado precisamente esto: no ir tras dioses ajenos; y por no haber observado lo que el Señor le había mandado."
,"11":"El Señor dijo a Salomón: 'Puesto que te has portado así y no has guardado mi alianza ni los preceptos que te había inculcado, te quitaré el reino y lo daré a uno de tus servidores."
,"12":"Sin embargo, en atención a tu padre David, no lo haré en tus días; se lo quitaré a tu hijo;"
,"13":"pero no le quitaré el reino entero; le dejaré una tribu, en atención a mi siervo David y a Jerusalén, la ciudad que elegí'."
,"14":"El Señor suscitó a Salomón un enemigo en Hadad, un idumeo de la estirpe real de Edón."
,"15":"Cuando David derrotó a Edón, Joab, general del ejército, fue a enterrar a los muertos y degolló a todos los varones de Edón."
,"16":"Joab con todo Israel permaneció allí seis meses hasta que exterminó a todos los varones de Edón."
,"17":"Pero Hadad, con algunos hombres de entre los servidores de su padre, huyó a Egipto. Hadad era entonces un muchacho."
,"18":"Partieron de Madián, llegaron a Parán, tomaron de allí varios hombres y entraron en Egipto, al amparo del Faraón, rey de Egipto. Éste le dio casa, alimentos y tierras."
,"19":"Hadad le cayó bien al Faraón, que le dio por esposa a la hermana de su mujer, o sea, la hermana de la reina Tafnes."
,"20":"La hermana de Tafnes le dio a luz un hijo, Guenubat, a quien crió Tafnes en el palacio del Faraón. Así vivió Guenubat en la casa del Faraón entre sus hijos."
,"21":"Pero cuando Hadad se enteró de que David descansaba con sus antepasados y de que Joab, el general del ejército, había muerto, dijo al Faraón: 'Déjame volver a mi tierra'."
,"22":"El Faraón le replicó: '¿Pues qué te falta junto a mí, que tratas de volver a tu tierra?'. 'Nada -respondió-; pero déjame partir, por favor'. Y regresó a su tierra."
,"23":"Dios suscitó también otro enemigo a Salomón en Rezón, hijo de Elyadá, que había huido de su amo Hadadézer, rey de Sobá."
,"24":"Se le juntaron unos desalmados y él se hizo jefe de la banda, mientras David derrotaba a los sirios; se apoderó de Damasco y se estableció allí como rey;"
,"25":"fue enemigo de Israel durante todo el reinado de Salomón. Hadad reinó en Edón y fue también enemigo de Salomón."
,"26":"Jeroboán, hijo de Nabat -un efraimita de Seredá, cuya madre, llamada Servá, era viuda-, servidor de Salomón, se sublevó contra el rey."
,"27":"El motivo de la sublevación fue éste. Salomón edificaba el terraplén y rellenaba el desnivel de la ciudad de su padre David."
,"28":"Jeroboán era fuerte y vigoroso; y Salomón, viendo cómo cumplía aquel joven su tarea, le puso al frente de todas las prestaciones personales de la casa de José."
,"29":"Un día en que Jeroboán salió de Jerusalén, se encontró en el camino con el profeta Ajías, el silonita, vestido con un manto nuevo. Estaban los dos solos en el campo."
,"30":"Ajías cogió el manto nuevo que llevaba y lo rasgó en doce pedazos."
,"31":"Luego dijo a Jeroboán: 'Toma para ti diez pedazos, porque esto dice el Señor, Dios de Israel: Voy a rasgar el reino de manos de Salomón y te voy a dar diez tribus."
,"32":"Le quedará una tribu en atención a David, mi siervo, y Jerusalén, la ciudad que elegí entre todas las tribus de Israel."
,"33":"Porque me ha abandonado a mí y ha adorado a Astarté, diosa de los sidonios; a Camós, dios de Moab, y a Milcón, dios de los amonitas, y no ha seguido mis caminos, haciendo lo que es recto a mis ojos, ni ha guardado mis leyes y mis mandamientos, como su padre David."
,"34":"Sin embargo, no le quitaré el reino de su propia mano, sino que le mantendré en él todos los días de su vida, en atención a mi siervo David, a quien elegí y que guardó mis preceptos y mis leyes."
,"35":"Quitaré el reino a su hijo y te daré a ti diez tribus."
,"36":"A su hijo le dejaré una tribu, para que a mi siervo David le quede siempre ante mí una lámpara en Jerusalén, la ciudad que elegí para poner en ella mi nombre."
,"37":"Y a ti te tomaré para que reines a tu gusto y seas rey sobre Israel."
,"38":"Si me obedeces en todo lo que te ordene, sigues mis caminos y haces lo que es recto a mis ojos, observando mis leyes y mis preceptos, como lo hizo mi siervo David, yo estaré contigo y te edificaré una casa duradera, como la he edificado a David, y te entregaré Israel."
,"39":"Humillaré de este modo a la descendencia de David, mas no para siempre'."
,"40":"Salomón buscó entonces a Jeroboán para darle muerte, pero Jeroboán escapó, huyendo a Egipto, junto a Sosac, rey de Egipto, y allí estuvo hasta la muerte de Salomón."
,"41":"El resto de la historia de Salomón, todo lo que hizo, y su sabiduría, está escrito en el libro de los hechos de Salomón."
,"42":"Salomón reinó cuarenta años en Jerusalén sobre todo Israel."
,"43":"Descansó con sus padres, y fue sepultado en la ciudad de su padre David. Le sucedió en el trono su hijo Roboán."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Roboán fue a Siquén, pues allá había acudido todo Israel para proclamarlo rey."
,"2":"Cuando lo supo Jeroboán, hijo de Nabat, que estaba todavía en Egipto, adonde había huido para escapar del rey Salomón, se volvió de Egipto."
,"3":"Lo mandaron llamar y vino. Jeroboán y toda la comunidad de Israel se presentaron a Roboán y le dijeron:"
,"4":"'Tu padre nos ha puesto un yugo muy pesado. Alivia tú la dura servidumbre de tu padre y el pesado yugo que puso sobre nosotros, y te serviremos'."
,"5":"Él les respondió: 'Volved a verme dentro de tres días'. El pueblo se fue."
,"6":"El rey Roboán pidió consejo a los ancianos que habían estado al servicio de su padre Salomón, mientras éste vivía: '¿Qué me aconsejáis responder a este pueblo?'."
,"7":"Y ellos le respondieron: 'Si hoy eres condescendiente con este pueblo, les complaces y les respondes con buenas palabras, serán siempre servidores tuyos'."
,"8":"Pero él no siguió el consejo de los ancianos, y consultó a los jóvenes que se habían criado con él y estaban a su servicio."
,"9":"Les dijo: '¿Qué me aconsejáis responder a esta gente, que me ha hablado así: Aligéranos el yugo que tu padre puso sobre nosotros?'."
,"10":"Los jóvenes le respondieron: 'A esa gente, que te ha hablado en esos términos, debes responder lo siguiente: Mi dedo meñique es más grueso que la cintura de mi padre."
,"11":"Si mi padre os cargó un yugo pesado, yo lo haré más pesado todavía; si mi padre os castigó con azotes, yo os castigaré con latigazos'."
,"12":"Al tercer día, tal como el rey había dicho, Jeroboán y todo el pueblo se presentaron ante Roboán."
,"13":"Pero el rey les contestó duramente, desechó el consejo de los ancianos,"
,"14":"siguió el de los jóvenes y les habló de esta manera: 'Mi padre os puso un yugo pesado, yo lo haré más pesado todavía; mi padre os castigó con azotes, yo os castigaré con latigazos'."
,"15":"El rey no dio oídos al pueblo, porque así lo había dispuesto el Señor para que se cumpliera la palabra que el Señor había anunciado por medio de Ajías, el de Silo, a Jeroboán, hijo de Nabat."
,"16":"Los israelitas, al ver que el rey no les había hecho caso, le replicaron: '¿Qué tenemos que ver nosotros con David? ¡No tenemos ninguna heredad en común con el hijo de Jesé! ¡Cada uno a sus casas, Israel! Mira tú ahora por tu casa, David'. Y los israelitas se fueron a sus casas. "
,"17":"Roboán siguió reinando sobre los israelitas domiciliados en las ciudades de Judá."
,"18":"Roboán envió a Adorán, el intendente de las prestaciones personales; pero los israelitas le mataron a pedradas. Y el propio Roboán tuvo que apresurarse a subir a su carro y huir a Jerusalén."
,"19":"De este modo Israel se separó de la casa de David hasta nuestros días."
,"20":"Cuando todo Israel se enteró de que Jeroboán había vuelto, mandaron a llamarle a la asamblea y le proclamaron rey sobre todo Israel. Sólo la tribu de Judá permaneció fiel a la casa de David."
,"21":"Roboán llegó a Jerusalén, convocó a la casa de Judá y de Benjamín, ciento ochenta mil hombres de guerra, para luchar contra Israel y recuperar el reino."
,"22":"Pero Dios dijo a Semayas, hombre de Dios:"
,"23":"'Di a Roboán, hijo de Salomón, rey de Judá, a toda la casa de Judá y Benjamín y al resto del pueblo:"
,"24":"Esto dice el Señor: No vayáis a luchar con vuestros hermanos, los israelitas. Volveos a vuestras casas, pues esto ha sucedido porque yo lo he querido'. Ellos obedecieron la voz del Señor, y se volvieron, como lo ordenaba el Señor."
,"25":"Jeroboán fortificó Siquén, en las montañas de Efraín, y fijó en ella su residencia. Luego fortificó Penuel."
,"26":"Jeroboán pensó: 'Ahora puede el reino volver a la casa de David."
,"27":"Si este pueblo sube a ofrecer sacrificios en el templo del Señor, en Jerusalén, el corazón de esta gente se volverá a su señor, a Roboán, rey de Judá, y me matarán a mí, para tornar a Roboán, rey de Judá'."
,"28":"Y, después de aconsejarse, hizo dos becerros de oro y dijo al pueblo: '¡Basta ya de subir a Jerusalén! Aquí tienes a tu dios, oh Israel, el que te sacó de Egipto'."
,"29":"Y puso el uno en Betel, y el otro lo instaló en Dan."
,"30":"Esta acción fue incentivo de pecado, pues el pueblo iba hasta Dan para adorarlo."
,"31":"Construyó luego colinas, y de la asamblea del pueblo creó sacerdotes que pertenecían a la tribu de Leví."
,"32":"Estableció, además, una fiesta en el mes octavo, el día quince del mes, a semejanza de la que se celebraba en Judá, y él mismo subió al altar que había levantado en Betel, para ofrecer sacrificios a los becerros que había fabricado, y también en Betel nombró a los sacerdotes de las colinas que había edificado."
,"33":"El día quince del octavo mes, el mes que él, a capricho suyo, había elegido, subió al altar que había levantado en Betel. Instituyó una fiesta para los israelitas y subió al altar a quemar incienso."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Mientras Jeroboán estaba de pie junto al altar, quemando incienso, un hombre de Dios llegó de Judá a Betel por orden del Señor,"
,"2":"y gritó contra el altar por orden del Señor: '¡Altar, altar! Esto dice el Señor: Nacerá un hijo a la casa de David, llamado Josías, e inmolará sobre ti a los sacerdotes de las colinas que en ti queman incienso, de modo que arderán sobre ti huesos humanos'."
,"3":"Al mismo tiempo dio una señal, diciendo: 'Ésta será la señal de que ha hablado el Señor: El altar se va a partir y a derramarse la ceniza que hay sobre él'."
,"4":"El rey, al oír la amenaza que el hombre de Dios había gritado contra el altar de Betel, extendió su mano desde el altar, y dijo: '¡Prendedlo!'. Pero la mano que había extendido contra él se le quedó tiesa sin poderla mover."
,"5":"Y el altar se partió y la ceniza se derramó del altar, conforme a la señal que el hombre de Dios había dado por orden del Señor."
,"6":"Entonces el rey dijo al hombre de Dios: '¡Por favor! Suplica al Señor, tu Dios, y ruega por mí para que pueda mover mi mano'. El hombre de Dios invocó al Señor, y el rey pudo mover la mano, quedando como antes."
,"7":"El rey dijo al hombre de Dios: 'Ven a comer conmigo, que quiero hacerte un regalo'."
,"8":"Pero el hombre de Dios le contestó: 'Aunque me dieses la mitad de tu casa, no iría contigo, ni comería pan, ni bebería agua en este lugar;"
,"9":"pues el Señor me ha ordenado esto: No comerás pan, ni beberás agua, ni regresarás por el camino que fuiste'."
,"10":"Y se fue por otro camino distinto."
,"11":"En Betel vivía un profeta anciano, cuyos hijos fueron a contarle todo lo que había hecho el hombre de Dios aquel día en Betel y las palabras que había dirigido al rey. Se lo contaron,"
,"12":"y él les preguntó: '¿Por qué camino se ha ido?'. Sus hijos le indicaron el camino por donde el hombre de Dios, venido de Judá, se había ido."
,"13":"Él dijo: 'Aparejadme un asno'. Le aparejaron un asno, y él se montó encima;"
,"14":"fue en seguimiento del hombre de Dios, y lo encontró sentado bajo un terebinto. '¿Eres tú -le dijo- el hombre de Dios que ha llegado de Judá?'. 'Yo soy', respondió."
,"15":"Él dijo: 'Ven conmigo a mi casa a comer un bocado'."
,"16":"'No puedo volverme contigo ni acompañarte -replicó-. No comeré pan ni beberé agua contigo en este lugar,"
,"17":"pues el Señor me ha ordenado: No comerás allí pan, ni beberás agua, ni regresarás por el camino que fuiste'."
,"18":"El anciano insistió: 'También yo soy profeta como tú, y un ángel me ha dicho de parte del Señor: Hazle volver contigo a tu casa para que coma pan y beba agua'. Así le engañó."
,"19":"Se fue con él y comió pan en su casa y bebió agua."
,"20":"Mientras estaban sentados a la mesa, el Señor habló al profeta que le había hecho volverse,"
,"21":"el cual gritó al hombre de Dios que había llegado de Judá: 'Por haber sido rebelde a la orden del Señor y no haber obedecido el mandato que te dio el Señor,"
,"22":"por haber vuelto y haber comido y bebido donde él te había prohibido hacerlo, tu cadáver no reposará en el sepulcro de tus padres'."
,"23":"Después de haber comido y bebido, aparejó el asno al profeta que había hecho volver."
,"24":"Éste se fue; un león le salió por el camino y lo mató, quedando su cadáver tendido en el camino. El asno y el león se quedaron junto al cadáver."
,"25":"Unos hombres que pasaban vieron el cadáver tendido en el camino y el león al lado, llegaron a la ciudad del profeta anciano y lo contaron."
,"26":"Cuando se enteró el profeta que había hecho volver al otro de su camino exclamó: 'Es el hombre de Dios, que ha sido rebelde al mandato del Señor, y por eso el Señor lo ha entregado al león para que lo matara y lo despedazara, como había dicho el Señor'."
,"27":"Luego dijo a sus hijos: '¡Aparejadme el asno!'; ellos lo hicieron."
,"28":"Partió y halló el cadáver del otro tendido en el camino, y el asno y el león de pie junto al cadáver. El león no había devorado el cadáver ni había despedazado al asno."
,"29":"El profeta tomó el cadáver del hombre de Dios, lo cargó sobre el asno y se lo llevó con él a su ciudad para hacer duelo y sepultarlo."
,"30":"Lo enterró en su propia sepultura, y le lloraron: '¡Ay, hermano mío!'."
,"31":"Después de sepultarlo, dijo a sus hijos: 'Cuando yo me muera, me enterraréis en la sepultura en que el hombre de Dios está enterrado; poned mis huesos junto a los suyos,"
,"32":"porque con toda seguridad se cumplirá la palabra que de parte del Señor pronunció contra el altar que hay en Betel y contra todos los santuarios de las colinas que hay en las ciudades de Samaría'."
,"33":"A pesar de esto, Jeroboán no se volvió atrás de su mal camino, sino que continuó creando del pueblo bajo sacerdotes para las colinas. A todo el que lo deseaba, le consagraba y le hacía sacerdote de las colinas."
,"34":"Éste fue el pecado de la casa de Jeroboán, por el que fue destruida y exterminada de la tierra."
}`)
	CurrentBook.AddChapter(14, `{
"1":"En aquel tiempo enfermó Abías, hijo de Jeroboán,"
,"2":"y Jeroboán dijo a su mujer: 'Disfrázate de modo que nadie conozca que eres mi mujer, y vete a Silo. Allí está Ajías, el profeta, el que me anunció que había de ser rey de este pueblo."
,"3":"Llévate diez panes, unas tortas y un tarro de miel, y preséntate a él. Él te dirá lo que ha de ser del niño'."
,"4":"Así lo hizo; fue a Silo, y entró en la casa de Ajías. Ajías no podía ver, pues, por la vejez, tenía los ojos apagados."
,"5":"Pero el Señor había dicho a Ajías: 'Va a venir la mujer de Jeroboán a consultarte acerca de su hijo, que está enfermo. Le has de decir esto y esto'. Ella entró fingiéndose otra."
,"6":"Ajías, al oír el ruido de sus pasos cuando atravesaba el umbral, exclamó: 'Entra, mujer de Jeroboán. ¿Por qué te haces pasar por otra? Tengo una mala noticia para ti."
,"7":"Ve y di a Jeroboán: Esto dice el Señor: Yo te saqué de en medio del pueblo y te constituí jefe de mi pueblo Israel;"
,"8":"quité el reino a la casa de David para dártelo a ti; pero tú no has sido como mi siervo David, el cual observó mis preceptos y me siguió de todo corazón, haciendo sólo lo que es recto a mis ojos,"
,"9":"sino que has obrado peor que todos los predecesores; has ido a fabricarte dioses extranjeros e imágenes fundidas, provocando con ello mi ira, y a mí me has dado la espalda;"
,"10":"por eso, voy a traer la desventura sobre la casa de Jeroboán: exterminaré de ella a todos los varones, libres o esclavos, y barreré a la casa de Jeroboán como se barre el estiércol, totalmente."
,"11":"Al que de la casa de Jeroboán muera en la ciudad lo comerán los perros; al que muera en el campo lo comerán las aves del cielo. Porque así lo ha dicho el Señor."
,"12":"En cuanto a ti, levántate y vete a tu casa; al pisar tus pies la ciudad, el niño morirá."
,"13":"Todo Israel lo llorará, y le enterrarán; éste será el único de Jeroboán que vaya a parar a una sepultura, porque sólo en él, de la casa de Jeroboán, se ha encontrado algo grato al Señor, Dios de Israel."
,"14":"El Señor pondrá sobre Israel un rey que exterminará la casa de Jeroboán a su tiempo. ¿Y qué más?"
,"15":"El Señor golpeará a Israel como una caña agitada por el agua y arrancará a Israel de esta tierra fértil que dio a sus padres y los dispersará allende el río, porque se hicieron estelas irritando al Señor."
,"16":"Entregará a Israel por causa de los pecados de Jeroboán, los que él ha cometido y los que ha hecho cometer a Israel'."
,"17":"La mujer de Jeroboán se levantó y salió para Tirsá. Cuando entraba por el umbral de la casa, el niño murió."
,"18":"Lo enterraron, y todo Israel le lloró, como el Señor había dicho por medio de su siervo Ajías, el profeta."
,"19":"El resto de la historia de Jeroboán, las guerras que hizo y cómo reinó, está escrito en el libro de los anales de los reyes de Israel."
,"20":"Jeroboán reinó veintidós años. A su muerte le sucedió en el trono su hijo Nadab."
,"21":"Roboán, hijo de Salomón, reinó en Judá. Tenía cuarenta y un años cuando subió al trono, y reinó diecisiete años en Jerusalén, la ciudad elegida por el Señor entre todas las tribus de Israel para morada de su nombre. Su madre se llamaba Naamá, la amonita."
,"22":"Judá hizo lo que es malo a los ojos del Señor, y provocaron su enojo con los pecados que cometieron, más que lo hicieron sus padres."
,"23":"También ellos se edificaron colinas, estelas y cipos sagrados sobre cualquier colina elevada o bajo cualquier árbol frondoso;"
,"24":"hasta prostitución sagrada había en el país. Imitaron, pues, todas las infamias de las gentes que el Señor había echado delante de los israelitas."
,"25":"El año quinto del reinado de Roboán, Sesac, rey de Egipto, fue contra Jerusalén."
,"26":"Se apoderó de los tesoros del templo del Señor y del palacio real. Todo se lo llevó, incluso los escudos de oro que había hecho el rey Salomón."
,"27":"El rey Roboán hizo en su lugar otros escudos de bronce, que entregó a los jefes de la guardia que custodiaba la entrada del palacio real."
,"28":"Siempre que el rey iba al templo del Señor, la guardia los llevaba, y luego los volvía a poner en la sala de guardia."
,"29":"El resto de la historia de Roboán y todo lo que hizo está escrito en el libro de los anales de los reyes de Judá."
,"30":"Entre Roboán y Jeroboán hubo continua guerra."
,"31":"Roboán murió y fue sepultado con sus padres en la ciudad de David. Le sucedió en el trono su hijo Abías."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Abías comenzó a reinar en Judá el año dieciocho del reinado de Jeroboán."
,"2":"Reinó tres años en Jerusalén. Su madre, hija de Absalón, se llamaba Macá."
,"3":"Cometió todos los pecados que su padre antes de él había cometido, y su corazón no fue sumiso al Señor, como el corazón de su padre David."
,"4":"Sin embargo, en atención a David, el Señor, su Dios, le concedió una lámpara en Jerusalén, suscitando a su hijo después de él y manteniendo en pie a Jerusalén,"
,"5":"pues David había hecho lo que es recto a los ojos del Señor y no se había apartado durante toda su vida en nada de todo lo que el Señor le había mandado, excepto el caso de Urías, el hitita."
,"6":"El resto de la historia de Abías y todo lo que hizo está escrito en el libro de los anales de los reyes de Judá."
,"7":"Entre Abías y Jeroboán hubo continua guerra."
,"8":"Abías murió y fue sepultado con sus padres en la ciudad de David. Le sucedió en el trono su hijo Asá."
,"9":"El año veinte de Jeroboán, rey de Israel, subió al trono Asá, rey de Judá."
,"10":"Reinó en Jerusalén cuarenta y un años. Su abuela, hija de Absalón, se llamaba Macá."
,"11":"Asá hizo lo que es recto a los ojos del Señor, como su padre David."
,"12":"Extirpó del país la prostitución sagrada y retiró todos los ídolos fabricados por sus padres;"
,"13":"quitó la dignidad de reina madre a su abuela Macá por haber hecho una imagen de Aserá. Asá destruyó la imagen y la quemó en el torrente Cedrón."
,"14":"En cambio, no se quitaron las colinas, aunque Asá fue siempre fiel al Señor."
,"15":"Llevó al templo todas las ofrendas que él y su padre habían hecho al Señor: plata, oro y objetos varios."
,"16":"Entre Asá y Basá, rey de Israel, hubo continua guerra."
,"17":"Basá, rey de Israel, atacó Judá y fortificó Ramá, para cortar las comunicaciones a Asá, rey de Judá."
,"18":"Entonces Asá tomó la plata y el oro de los tesoros del templo del Señor y del palacio real, y por medio de sus servidores los envió a Ben Hadad, hijo de Tabrimón y nieto de Jezyón, rey de Siria, que tenía su residencia en Damasco, con este mensaje:"
,"19":"'Hagamos nosotros un pacto, como lo hicieron nuestros padres. Yo te envío este obsequio de plata y oro. Rompe tu pacto con Basá, rey de Israel, para que me deje en paz'."
,"20":"Ben Hadad dio oídos al rey Asá y mandó a los jefes de sus ejércitos contra las ciudades de Israel, y devastó a Iyón, Dan, Abel-bet-Maacá y toda la región de Genesaret con todo el territorio de Neftalí."
,"21":"Cuando Basá se enteró de ello, desistió de fortificar Ramá y se volvió a Tirsá."
,"22":"El rey Asá convocó a todo Judá, sin excepción alguna; y se llevaron las piedras y el maderamen con que Basá fortificaba Ramá para fortificar con ello Guibeá de Benjamín y Mispá."
,"23":"El resto de la historia de Asá, todas sus proezas y todo lo que hizo, las ciudades que edificó, está escrito en el libro de los anales de los reyes de Judá. Únicamente que, en su vejez, estuvo enfermo de los pies."
,"24":"Asá murió y fue sepultado con sus padres en la ciudad de David. Le sucedió su hijo Josafat."
,"25":"Nadab, hijo de Jeroboán, subió al trono de Israel el año segundo de Asá, rey de Judá, y reinó sobre Israel dos años."
,"26":"Hizo lo que es malo a los ojos del Señor y siguió los caminos de su padre y los pecados con que hizo pecar a Israel."
,"27":"Basá, hijo de Ajías, de la casa de Isacar, conspiró contra él, y le asesinó junto a Guibetón de los filisteos, mientras Nadab y todo Israel la estaban asediando."
,"28":"Le mató el año tercero de Asá, rey de Judá, y le sucedió en el trono."
,"29":"Y apenas subió al trono, exterminó a toda la casa de Jeroboán, matándolos a todos, sin dejar un viviente, como el Señor había dicho por medio de Ajías, el silonita,"
,"30":"por los pecados que Jeroboán había cometido y había hecho cometer a Israel, y por haber irritado al Señor, Dios de Israel."
,"31":"El resto de la historia de Nadab y todo lo que hizo está escrito en el libro de los anales de los reyes de Israel."
,"32":"Entre Asá y Basá, rey de Israel, hubo continua guerra."
,"33":"El año tercero de Asá, rey de Judá, subió al trono Basá, hijo de Ajías, sobre todo Israel, en Tirsá. Reinó veinticuatro años."
,"34":"Hizo lo que es malo a los ojos del Señor y siguió los caminos de Jeroboán y los pecados con que hizo pecar a Israel."
}`)
	CurrentBook.AddChapter(16, `{
"1":"El Señor dirigió a Jehú, hijo de Jananí, esta palabra contra Basá:"
,"2":"'Yo te había exaltado del polvo y te había constituido jefe de mi pueblo Israel, pero tú has seguido los caminos de Jeroboán y has hecho pecar a mi pueblo, Israel, irritándome con sus pecados;"
,"3":"por eso exterminaré a Basá y a su posteridad y haré de tu casa lo que hice de la casa de Jeroboán, hijo de Nabat."
,"4":"Al que de Basá muera en la ciudad lo comerán los perros, y al que muera en el campo lo comerán las aves del cielo'."
,"5":"El resto de la historia de Basá, sus proezas y todo lo que hizo está escrito en el libro de los anales de los reyes de Israel."
,"6":"Basá murió y fue sepultado con sus padres en Tirsá. Le sucedió en el trono su hijo Elá."
,"7":"El Señor, por medio del profeta Jehú, hijo de Jananí, dirigió su palabra contra Basá y contra su casa, no sólo por todo lo malo que hizo a los ojos del Señor, irritándole con sus acciones y haciéndose semejante a la casa de Jeroboán, sino por haber exterminado a ésta."
,"8":"El año veintiséis de Asá, rey de Judá, empezó a reinar Elá, hijo de Basá, sobre Israel, en Tirsá. Reinó dos años."
,"9":"Conspiró contra él su súbdito Zimrí, jefe de la mitad de los carros de guerra. Estaba en Tirsá bebiendo y borracho, en casa de Arsá, prefecto del palacio de Tirsá,"
,"10":"cuando Zimrí irrumpió, le acometió y le mató en el año veintisiete de Asá, rey de Judá, y le sucedió en el trono."
,"11":"Apenas se sentó como rey en el trono, exterminó a toda la casa de Basá, sin dejar vivo ningún varón pariente o amigo,"
,"12":"como el Señor había dicho contra Basá por medio del profeta Jehú,"
,"13":"por todos los pecados de Basá y por los pecados de Elá, su hijo, los que ellos cometieron y los que hicieron cometer a Israel, irritando al Señor, Dios de Israel, con sus ídolos."
,"14":"El resto de las historias de Elá y todo lo que hizo está escrito en el libro de los anales de los reyes de Israel."
,"15":"El año veintisiete de Asá, rey de Judá, subió al trono Zimrí. Reinó siete días en Tirsá. Mientras el pueblo estaba sitiando a Guibetón de los filisteos,"
,"16":"oyó decir: 'Zimrí ha tramado una conspiración y hasta ha dado muerte al rey'. Aquel mismo día, en el campo de batalla, Israel entero proclamó rey sobre todo Israel a Omrí, general del ejército."
,"17":"Omrí y todo Israel con él marcharon de Guibetón y pusieron sitio a Tirsá."
,"18":"Cuando Zimrí vio que la ciudad estaba tomada, se refugió en la ciudadela del palacio real; le prendió fuego, y así murió"
,"19":"por causa de los pecados que había cometido haciendo lo que es malo a los ojos del Señor y siguiendo los caminos de Jeroboán y sus pecados, con los que había hecho pecar a Israel."
,"20":"El resto de la historia de Zimrí y la conjuración que tramó está escrito en el libro de los anales de los reyes de Israel."
,"21":"Entonces el pueblo de Israel se dividió en dos partes: una parte del pueblo siguió a Tibní, hijo de Guinat, proclamándole rey; la otra parte, a Omrí."
,"22":"Pero prevaleció el pueblo que seguía a Omrí sobre los que seguían a Tibní, hijo de Guinat. Murió Tibní y quedó Omrí de rey."
,"23":"El año treinta y uno de Asá, rey de Judá, comenzó a reinar Omrí sobre Israel. Reinó doce años, seis en Tirsá."
,"24":"Compró el monte de Samaría a Sémer por unos sesenta kilos de plata, y lo fortificó; construyó en él una ciudad, a la que llamó Samaría en razón del nombre de Sémer, amo del monte."
,"25":"Omrí hizo lo que es malo a los ojos del Señor, y aun obró peor que sus predecesores;"
,"26":"imitó en todo a Jeroboán, hijo de Nabat, y por los pecados que hizo cometer a Israel, irritando al Señor, Dios de Israel, con sus ídolos."
,"27":"El resto de la historia de Omrí, sus proezas y todo lo que hizo está escrito en el libro de los anales de los reyes de Israel."
,"28":"Omrí murió y fue sepultado con sus padres en Samaría. Le sucedió en el trono su hijo Ajab."
,"29":"Ajab, hijo de Omrí, empezó a reinar sobre Israel el año treinta y ocho de Asá, rey de Judá, y reinó sobre Israel en Samaría veintidós años."
,"30":"Ajab hizo lo que es malo a los ojos del Señor, más que todos sus predecesores;"
,"31":"y, no bastándole imitar los pecados de Jeroboán, hijo de Nabat, tomó por esposa a Jezabel, hija de Etbaal, rey de los sidonios, y sirvió y adoró a Baal."
,"32":"Levantó un altar a Baal en el templo de Baal que edificó en Samaría."
,"33":"Hizo también una estela; y de este modo Ajab siguió irritando al Señor, Dios de Israel, más que todos los reyes de Israel que le habían precedido."
,"34":"En su tiempo Jiel, de Betel, reedificó a Jericó; pero a costa de su primogénito Abirán echó los cimientos, y de Segub, su hijo menor, asentó las puertas, como había dicho el Señor por medio de Josué, hijo de Nun."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Elías, el tesbita, de Tisbé, en Galaad, dijo a Ajab: '¡Vive el Señor, Dios de Israel, a cuyo servicio estoy!: en estos dos años no habrá lluvia ni rocío, mientras yo no lo diga'."
,"2":"El Señor le dijo:"
,"3":"'Sal de aquí y vete al oriente a esconderte en el torrente Querit, que está al este del Jordán."
,"4":"Beberás del torrente; yo he dado orden a los cuervos de que te alimenten allí'."
,"5":"Elías salió y, tal como el Señor le había ordenado, se estableció en el torrente Querit, al este del Jordán."
,"6":"Los cuervos le traían pan por la mañana y carne por la tarde, y bebía del torrente."
,"7":"Pero al cabo de algún tiempo se secó el torrente por no haber llovido en el país."
,"8":"Entonces el Señor le dijo:"
,"9":"'Levántate y ve a Sarepta, de Sidón, a establecerte allí. He dado orden allí a una mujer viuda de que te alimente'."
,"10":"Elías se levantó y se fue a Sarepta. Cuando entraba por las puertas de la ciudad, vio a una mujer viuda, que estaba recogiendo leña. La llamó y le dijo: 'Tráeme, por favor, en un vaso un poco de agua para beber'."
,"11":"Cuando ella iba por el agua, Elías le gritó: 'Tráeme también un pedazo de pan'."
,"12":"Ella entonces replicó: '¡Vive el Señor, tu Dios!, que no tengo una sola torta; sólo tengo un puñado de harina en la tinaja y un poco de aceite en la orza. Estaba recogiendo esta leña para prepararlo para mí y mi hijo, comérnoslo y luego morir'."
,"13":"Elías le dijo: 'No temas. Ve a casa y haz lo que has dicho, pero primero hazme a mí una torta pequeña y tráemela. Para ti y para tu hijo, la harás después."
,"14":"Porque esto dice el Señor, Dios de Israel: No se vaciará la tinaja de harina, ni la orza del aceite disminuirá hasta el día en que el Señor haga caer la lluvia sobre la faz de la tierra'."
,"15":"Fue e hizo lo que Elías le había dicho, y tuvieron para comer él, ella y toda su casa durante algún tiempo."
,"16":"La tinaja de harina no se vació, ni disminuyó la orza del aceite, según la promesa que el Señor había hecho por medio de Elías."
,"17":"Después de algún tiempo el hijo del ama de la casa cayó gravemente enfermo y murió."
,"18":"Entonces ella dijo a Elías: '¿Qué tengo yo que ver contigo, hombre de Dios? ¿Has entrado en mi casa para recordar mis pecados y dar muerte a mi hijo?'."
,"19":"Elías respondió: 'Dame a tu hijo'. Lo tomó del regazo de la viuda, lo subió al aposento superior, donde él dormía, y lo acostó sobre su lecho."
,"20":"Y clamó al Señor: 'Señor, Dios mío, ¿también afliges a esta viuda que me hospeda, haciendo morir a su hijo?'."
,"21":"Luego se tendió sobre el niño tres veces y clamó al Señor así: '¡Señor, Dios mío, te ruego que devuelvas la vida a este niño!'."
,"22":"El Señor escuchó a Elías, y el niño revivió."
,"23":"Elías tomó al niño, lo bajó del aposento superior de la casa y lo entregó a su madre, diciendo: '¡Mira, tu hijo está vivo!'."
,"24":"La mujer dijo a Elías: 'Ahora sí reconozco que eres un hombre de Dios y que la palabra del Señor en tu boca es verdad'."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Después de mucho tiempo, a los tres años, el Señor dijo a Elías: 'Anda, preséntate a Ajab, pues quiero hacer llover sobre la faz de la tierra'."
,"2":"Elías fue a presentarse a Ajab. Como el hambre arreciaba en Samaría, "
,"3":"Ajab llamó a Abdías, su mayordomo, el cual era muy temeroso del Señor:"
,"4":"cuando Jezabel exterminó a los profetas del Señor, Abdías recogió a cien profetas y los ocultó en grupos de cincuenta en unas cuevas, proveyéndoles de pan y agua."
,"5":"Ajab dijo a Abdías: 'Vamos a recorrer el país en busca de fuentes de agua y de arroyos, por si podemos encontrar pasto para mantener caballos y mulos, y no mueran todos los animales'."
,"6":"Se repartieron el país para recorrerlo. Ajab partió en una dirección, y Abdías en otra."
,"7":"Cuando Abdías iba por el camino, le salió al encuentro Elías. Al reconocerle, se postró rostro en tierra y dijo: '¿Eres tú Elías, mi señor?'."
,"8":"Le respondió: 'Lo soy. Anda y di a tu amo que está aquí Elías'. Él replicó:"
,"9":"'¿Qué pecado he cometido para que me entregues a Ajab y me mate?"
,"10":"¡Vive el Señor, tu Dios!, que no hay pueblo ni reino donde mi amo no haya mandado a buscarte, y cuando se respondía que no estabas allí, hacía jurar a aquel reino o pueblo que no te había encontrado;"
,"11":"y ahora me dices tú: anda y di a tu amo que está aquí Elías."
,"12":"Y va a suceder que, cuando yo me separe de ti, el espíritu del Señor te llevará a un lugar que yo no sé, y después de haber ido a dar la nueva a Ajab, él, al no encontrarte, me matará. Con todo, tu siervo teme al Señor desde su mocedad."
,"13":"¿Por ventura no le han contado a mi señor lo que hice cuando Jezabel mataba a los profetas del Señor, cómo oculté a cien de estos profetas del Señor por grupos de cincuenta en unas cuevas, alimentándolos con pan y agua?"
,"14":"Y ahora tú me dices: anda y di a tu amo que está aquí Elías, para que me mate'."
,"15":"Elías respondió: '¡Vive el Señor todopoderoso, a cuyo servicio estoy!, que hoy me presentaré a él'."
,"16":"Abdías fue a buscar a Ajab y se lo comunicó. Entonces Ajab salió al encuentro de Elías."
,"17":"Cuando lo vio, le dijo: '¿Eres tú, portador de desdichas de Israel?'."
,"18":"Elías replicó: 'Yo no soy portador de desdichas de Israel; lo eres tú y la casa de tu padre, por haber abandonado los mandamientos del Señor y haber dado culto a los baales."
,"19":"Ahora bien, manda reunir junto a mí en el monte Carmelo a todo Israel y a los cuatrocientos cincuenta profetas de Baal que comen a la mesa de Jezabel'."
,"20":"Y Ajab mandó llamar a todos los israelitas y reunió a los profetas en el monte Carmelo."
,"21":"Elías se presentó al pueblo y dijo: '¿Hasta cuándo andaréis cojeando de las dos piernas? Si el Señor es Dios, seguidle; y si lo es Baal, seguidle a él'. Pero el pueblo no respondió palabra."
,"22":"Entonces dijo Elías al pueblo: 'He quedado yo solo de los profetas del Señor; en cambio, los profetas de Baal son cuatrocientos cincuenta."
,"23":"Pues bien, que nos den dos novillos. Que ellos elijan un novillo, que lo descuarticen y que lo pongan sobre la leña, pero sin poner fuego."
,"24":"Que invoquen ellos el nombre de sus dioses y yo invocaré el nombre del Señor. El dios que responda enviando fuego, ése será el verdadero Dios'. El pueblo respondió: '¡Está muy bien!'."
,"25":"Entonces Elías dijo a los profetas de Baal: 'Elegid vosotros un novillo y preparadlo vosotros primero, porque sois más. Invocad el nombre de vuestros dioses sin prender fuego'."
,"26":"Les entregaron el novillo que eligieron, lo prepararon y se pusieron a invocar el nombre de Baal desde la mañana hasta el mediodía, diciendo: '¡Oh, Baal, respóndenos!'. Pero no se oía voz alguna, ni nadie respondía. Y ellos continuaban danzando en torno al altar que habían hecho."
,"27":"Cuando fue mediodía, Elías comenzó a burlarse de ellos, diciendo: '¡Gritad más fuerte, pues es dios! Pero está cavilando, o retirado, o se encontrará de viaje; tal vez esté durmiendo y tenga que despertarse'."
,"28":"Ellos, entonces, gritaban más fuerte, y según su costumbre, se hacían cortes con espadas y lanzas, hasta chorrear sangre por su cuerpo."
,"29":"Pasado el mediodía, continuaron en su paroxismo hasta la hora de la ofrenda del sacrificio. Pero no se oía voz alguna, ni nadie respondía ni hacía caso."
,"30":"Entonces Elías dijo a todo el pueblo: 'Acercaos a mí'. Y el pueblo entero se le acercó. Preparó el altar del Señor, que había sido destruido;"
,"31":"tomó doce piedras, una por cada tribu de los hijos de Jacob, a quien había dicho: 'Te llamarán Israel',"
,"32":"y construyó con ellas un altar en honor del Señor. Hizo en torno al altar una zanja como un surco para dos medidas de simiente,"
,"33":"dispuso la leña, descuartizó el novillo, lo puso sobre la leña"
,"34":"y ordenó: 'Llenad cuatro cántaros de agua y vertedla sobre la leña'. Luego dijo: 'Otra vez'. Y vertieron agua de nuevo. 'Por tercera vez', añadió. Y lo hicieron por tercera vez."
,"35":"El agua corría en torno al altar, hasta que se llenó la zanja."
,"36":"A la hora de la ofrenda del sacrificio de Elías, se adelantó y dijo: '¡Señor, Dios de Abrahán, de Isaac y de Israel!, que se sepa hoy que tú eres Dios de Israel y yo tu siervo, y que por orden tuya he hecho todas estas cosas."
,"37":"Respóndeme, Señor; respóndeme, y que sepa este pueblo que tú eres, Señor, el verdadero Dios, y así se convertirá de corazón'."
,"38":"Entonces cayó fuego del Señor y devoró el holocausto, la leña, las piedras y el polvo y secó el agua de la zanja."
,"39":"El pueblo, al ver esto, cayó rostro en tierra, y exclamó: '¡El Señor es Dios! ¡El Señor es Dios!'."
,"40":"Elías les dijo: 'Prended a los profetas de Baal. Que no escape ni uno solo'. Los prendieron y Elías los llevó al torrente Quisón y los hizo degollar allí."
,"41":"Luego Elías dijo a Ajab: 'Sube, come y bebe, porque ya se percibe el ruido de lluvia torrencial'."
,"42":"Y Elías subió a la cima del Carmelo y se postró en tierra, puesto su rostro entre las rodillas."
,"43":"Y dijo a su criado: 'Sube y mira en dirección del mar'. Subió, miró y dijo: 'No hay nada'. Le dijo: 'Sube hasta siete veces'."
,"44":"A la séptima vez dijo: 'Una nube pequeña como la palma de la mano de un hombre sube del mar'. Elías dijo: 'Corre y di a Ajab: Engancha y baja, para que no te impida la lluvia'."
,"45":"Y en unos instantes el cielo se oscureció con nubes y viento, y cayó una lluvia abundante. Ajab montó en su carro y fue a Yezrael."
,"46":"El Señor dio fuerzas a Elías, que se ciñó y fue corriendo delante de Ajab hasta Yezrael."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Ajab contó a Jezabel lo que Elías había hecho y cómo había degollado a espada a todos los profetas de Baal."
,"2":"Y entonces Jezabel envió este mensaje a Elías: 'Esto y cosa peor hagan conmigo los dioses si mañana a estas horas no te he puesto a ti como a uno de ellos'."
,"3":"Elías tuvo miedo y se escapó para salvar su vida; llegó a Berseba de Judá y dejó allí a su criado."
,"4":"Él se internó en el desierto una jornada de camino y fue a sentarse bajo una retama, deseándose la muerte y diciendo: '¡Ya basta, oh Señor! Quítame la vida, pues no soy yo mejor que mis padres'."
,"5":"Luego se acostó y se quedó dormido debajo de la retama. Un ángel le tocó y le dijo: 'Levántate y come'."
,"6":"Miró en derredor, y vio a su cabecera una torta cocida sobre piedras ardiendo y un vaso de agua. Comió, bebió y luego se volvió a acostar."
,"7":"El ángel del Señor volvió por segunda vez, le tocó y le dijo: 'Levántate y come, pues te resta un camino demasiado largo para ti'."
,"8":"Se levantó, comió y bebió, y con la fuerza de aquel manjar caminó cuarenta días y cuarenta noches hasta el monte de Dios, el Horeb."
,"9":"Llegó y pasó la noche en una cueva. El Señor le dijo: '¿Qué haces aquí, Elías?'."
,"10":"Respondió: 'Me he abrasado en celo por el Señor todopoderoso, porque los israelitas han abandonado tu alianza, han destruido tus altares, han pasado a espada a tus profetas. He quedado yo solo, y me buscan para quitarme la vida'."
,"11":"El Señor le dijo: 'Sal y quédate de pie en la montaña ante la presencia del Señor'. Y el Señor pasó. Sopló un viento fuerte e impetuoso que descuajaba los montes y quebraba las peñas delante del Señor; pero el Señor no estaba en el viento. Después del viento, un terremoto; pero el Señor no estaba en el terremoto."
,"12":"Tras el terremoto, un fuego; pero el Señor no estaba en el fuego. Y al fuego siguió un ligero susurro de aire."
,"13":"Elías, al oírlo, se cubrió el rostro con su capa, salió fuera y se quedó de pie a la entrada de la cueva. Y una voz le preguntó: '¿Qué haces aquí, Elías?'."
,"14":"Respondió: 'Me he abrasado en celo por el Señor todopoderoso, porque los israelitas han abandonado tu alianza, han destruido tus altares, han pasado a espada a tus profetas. He quedado yo solo y me buscan para quitarme la vida'."
,"15":"Y el Señor le dijo: 'Anda, vuelve a emprender tu camino por el desierto hacia Damasco, y, cuando llegues, ungirás a Jazael por rey de Siria;"
,"16":"a Jehú, hijo de Nimsí, le ungirás por rey de Israel; y a Eliseo, hijo de Safat, de Abel Mejolá, le ungirás profeta en tu lugar."
,"17":"A quien escape de la espada de Jazael le matará Jehú, y a quien escape de la espada de Jehú le matará Eliseo."
,"18":"Pero yo me reservaré en Israel siete mil: todas las rodillas que no se han doblado ante Baal y todas las bocas que no lo han besado'."
,"19":"Elías se fue de allí en busca de Eliseo, al que encontró arando. Tenía delante de sí doce yuntas de bueyes, y él araba con la duodécima. Elías pasó junto a él y le echó encima su capa."
,"20":"Eliseo, entonces, dejó los bueyes, corrió detrás de Elías y le dijo: 'Déjame dar un beso a mi padre y a mi madre, y luego te seguiré'. Elías respondió: 'Anda, vuélvete; pero ten en cuenta lo que he hecho contigo'."
,"21":"Se apartó de Elías, tomó la yunta de bueyes y la inmoló; y con los aperos de los bueyes coció la carne y la repartió a la gente para que la comiera. Luego se levantó, siguió a Elías y fue su servidor."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Ben Hadad, rey de Siria, reunió todo su ejército y, acompañado de treinta y dos reyes con carros y caballos, fue a sitiar Samaría y la atacó."
,"2":"Envió a la ciudad emisarios a decir a Ajab, rey de Israel:"
,"3":"'Esto dice Ben Hadad: Tu plata y tu oro son míos; tus mujeres y tus hijos a ti te pertenecen'."
,"4":"El rey de Israel contestó de esta manera: 'Como lo dices, ¡oh rey, mi señor! tuyo soy y todo lo que tengo'."
,"5":"Pero los emisarios volvieron de nuevo, diciendo: 'Esto dice Ben Hadad: Envío a decirte: Me debes entregar tu plata, tu oro, tus mujeres y tus hijos."
,"6":"Por tanto, mañana, a estas horas, te mandaré mis súbditos, que registrarán tu casa y las casas de tus súbditos. Todo lo que les agrade lo tomarán y se lo llevarán'."
,"7":"Entonces el rey de Israel convocó a todos los ancianos del país y dijo: 'Considerad y ved la injusticia que éste busca: me ha mandado a pedir mis mujeres y mis hijos, después de no haberle negado mi plata y mi oro'."
,"8":"Los ancianos y todo el pueblo le dijeron: 'No le hagas caso ni aceptes'."
,"9":"Y respondió a los emisarios de Ben Hadad: 'Decid al rey, mi señor: Todo lo que mandaste a decir a tu servidor en un principio, lo haré; pero esto otro no lo puedo hacer'. Los emisarios se fueron y dieron la respuesta."
,"10":"Ben Hadad mandó a decirle: 'Esto y cosa peor hagan conmigo los dioses si el polvo de Samaría basta para llenar los puños de toda la gente que me sigue'."
,"11":"Y el rey de Israel contestó: 'Decidle: No se engría quien se está ciñendo las armas como el que se despoja de ellas'."
,"12":"Cuando Ben Hadad se enteró de esta respuesta, estaba con los reyes, bebiendo en las tiendas, y mandó a sus súbditos: '¡A formar!'. Y formaron contra la ciudad."
,"13":"Un profeta se acercó a Ajab, rey de Israel, y dijo: 'Esto dice el Señor: ¿Ves toda esa inmensa multitud? Pues mira, yo la voy a poner hoy en tus manos para que sepas que yo soy el Señor'."
,"14":"Ajab replicó: '¿Por medio de quién?'. Y respondió: 'Por medio de los asistentes de los jefes de las provincias'. Él insistió: '¿Quién entablará el combate?'. Y respondió: 'Tú'."
,"15":"Ajab entonces pasó revista a los asistentes de los jefes de las provincias, y se contaron doscientos treinta y dos. Después de ellos revistó a toda la gente, todos los israelitas, que eran siete mil."
,"16":"Al mediodía se hizo una salida, mientras que Ben Hadad estaba en sus tiendas bebiendo y borracho, con los treinta y dos reyes que le ayudaban."
,"17":"Salieron en primer lugar los asistentes de los jefes de las provincias. Ben Hadad envió a informarse y le dieron este parte: 'Unos hombres han salido de Samaría'."
,"18":"Ordenó: 'Si han salido en son de paz, prendedlos vivos; y si en son de guerra, prendedlos vivos también'."
,"19":"Los asistentes de los jefes de las provincias salieron de la ciudad, seguidos por el ejército."
,"20":"Cada uno mató al que se le puso delante. Los sirios se dieron a la fuga, perseguidos por los israelitas, y Ben Hadad, rey de Siria, logró salvarse a caballo con algunos jinetes."
,"21":"Salió también el rey de Israel y se apoderó de caballos y de carros, asestando un recio golpe a los sirios."
,"22":"Se acercó entonces el profeta al rey de Israel y le dijo: 'Anda, refuérzate y considera lo que debes hacer; porque al cabo del año el rey de Siria vendrá contra ti'."
,"23":"Los súbditos del rey de Siria le dijeron: 'El dios de ellos es dios de las montañas; por eso nos han vencido; pero luchemos contra ellos en la llanura, y verás cómo los venceremos."
,"24":"Haz esto: quita a cada uno de los reyes de su puesto y pon en su lugar prefectos."
,"25":"Luego tú reunirás un ejército como el que perdiste, una caballería como aquélla y carros en igual número. Les presentaremos batalla en la llanura, y verás cómo los venceremos'. El rey escuchó sus razones y obró de esta manera."
,"26":"Al cabo de un año Ben Hadad pasó revista a los sirios y fue a Afec a luchar contra Israel."
,"27":"También los israelitas fueron revistados, y salieron a su encuentro. Los israelitas acamparon frente a ellos como dos hatillos de cabras, mientras los sirios llenaban el país."
,"28":"Entonces un hombre de Dios se llegó al rey de Israel, y le dijo: 'Esto dice el Señor: Ya que Siria ha dicho que el Señor es el Dios de las montañas y no el Dios de los valles, voy a entregar en tus manos a toda esa inmensa multitud, para que conozcáis que yo soy el Señor'."
,"29":"Siete días estuvieron acampados los unos frente a los otros. Al séptimo día se entabló la batalla, y los israelitas mataron en un solo día cien mil infantes de los sirios."
,"30":"Los supervivientes huyeron a la ciudad de Afec; pero la muralla se desplomó sobre los siete mil hombres que quedaban. También Ben Hadad huyó a la ciudad, escondiéndose de estancia en estancia."
,"31":"Sus súbditos le dijeron: 'Mira, hemos oído que los reyes de la casa de Israel son reyes clementes; deja que nos pongamos sayales en los lomos y sogas al cuello y salgamos ante el rey de Israel. ¡Quién sabe si nos perdonará la vida!'."
,"32":"Y ciñeron con sayales los lomos y con cuerdas el cuello, y se presentaron al rey de Israel diciendo: 'Tu servidor Ben Hadad dice: Perdóname la vida, por favor'. El rey respondió: '¿Está aún vivo? Es mi hermano'."
,"33":"Aquellos hombres lo dieron como buen augurio y se apresuraron a tomarle la palabra de la boca, diciendo: '¡Ben Hadad es tu hermano!'. Y él añadió: 'Id y traédmelo'. Ben Hadad se presentó ante Ajab, que le montó en su carro."
,"34":"Ben Hadad le dijo: 'Las ciudades que mi padre quitó al tuyo te las devolveré, y tú podrás establecer en Damasco plazas comerciales, como hizo mi padre en Samaría'. Ajab hizo este pacto con él y le dejó en libertad."
,"35":"Un discípulo de los profetas dijo de parte del Señor a un compañero suyo: 'Pégame'. Y como no quiso hacerlo,"
,"36":"le dijo: 'Por no haber obedecido a la voz del Señor, cuando te separes de mí, te matará un león'. Y apenas se separó de su lado, un león lo encontró y lo mató."
,"37":"Encontró luego a otro hombre y le dijo: 'Pégame'. Y aquel hombre lo golpeó y lo hirió."
,"38":"Fue entonces el profeta y se presentó al rey a la vera del camino, disfrazado con una venda en los ojos."
,"39":"Y cuando el rey pasaba, gritó: 'Tu servidor había salido de en medio de la refriega, cuando un hombre se le acercó, me trajo a otro y me dijo: Guarda a este hombre. Si se escapa, tu vida responderá por la suya o pagarás tres mil monedas de plata."
,"40":"Pero sucedió que, mientras tu siervo atendía acá y allá, el hombre desapareció'. El rey de Israel le dijo: 'Ésa es tu sentencia. Tú mismo la has pronunciado'."
,"41":"Él entonces se quitó la venda de los ojos, y el rey de Israel reconoció que era uno de los profetas."
,"42":"Y dijo al rey: 'Por haber dejado escapar al hombre que yo había consagrado al exterminio, tu vida responderá por la suya y tu pueblo por su pueblo'."
,"43":"Y el rey de Israel se fue a casa triste e irritado y entró en Samaría."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Nabot, el yezraelita, tenía una viña en Yezrael, junto al palacio de Ajab, rey de Samaría."
,"2":"Ajab dijo a Nabot: 'Dame tu viña, para que me sirva de huerto de hortaliza, ya que está contigua a mi palacio. Yo te daré en su lugar un huerto mejor, o, si lo prefieres, te daré su valor en dinero'."
,"3":"Nabot respondió a Ajab: '¡Dios me libre de darte la herencia de mis padres!'."
,"4":"Ajab entró en su palacio triste e irritado porque Nabot, el yezraelita, no le había querido dar la herencia de sus padres. Se metió en la cama, volvió la cara a la pared y no probó bocado."
,"5":"Su esposa Jezabel se acercó a él y le dijo: '¿Por qué estás de tan mal humor y no quieres comer?'."
,"6":"Le respondió: 'Porque he dicho a Nabot que me venda la viña o que me la cambie por otra y él no quiere'."
,"7":"Jezabel le dijo: '¿Eres tú realmente el rey de Israel?... Levántate, come y estáte tranquilo. Yo te daré la viña de Nabot, el yezraelita'."
,"8":"Entonces ella escribió en nombre de Ajab cartas, las selló con su sello y las envió a los ancianos y nobles conciudadanos de Nabot."
,"9":"En las cartas decía: 'Pregonad un ayuno y haced a Nabot sentarse a la cabeza de la asamblea."
,"10":"Poned ante él dos hombres perversos que atestigüen contra él así: Ha maldecido a Dios y al rey. Sacadle luego fuera, y matadle a pedradas'."
,"11":"Los hombres de la ciudad de Nabot, los ancianos y los nobles conciudadanos suyos hicieron lo que les había mandado Jezabel, tal y como estaba escrito en las cartas que les había enviado."
,"12":"Pregonaron un ayuno y pusieron a Nabot a la cabeza de la asamblea."
,"13":"Llegaron luego los dos hombres perversos y, encarándosele, testificaron ante la asamblea de esta suerte: 'Nabot ha maldecido a Dios y al rey'. Entonces lo sacaron fuera de la ciudad y lo mataron a pedradas."
,"14":"Y mandaron decir a Jezabel: 'Nabot ha sido matado a pedradas'."
,"15":"Apenas supo Jezabel que Nabot había sido matado a pedradas, dijo a Ajab: 'Levántate, toma posesión de la viña de Nabot, el yezraelita, que no quiso vendértela, pues Nabot ya no vive, sino que ha muerto'."
,"16":"Cuando Ajab oyó que Nabot había muerto, fue y se apoderó de su viña."
,"17":"Entonces el Señor dijo a Elías, el tesbita:"
,"18":"'Anda y vete a ver a Ajab, rey de Israel, en Samaría. Está en la viña de Nabot, adonde ha ido para apoderarse de ella. Le dirás: Esto dice el Señor: ¡De modo que, después de haber matado, robas!"
,"19":"Y añadirás: Esto dice el Señor: En el mismo lugar en que los perros han lamido la sangre de Nabot, lamerán también la tuya'."
,"20":"Ajab dijo a Elías: '¿Así que me has sorprendido, enemigo mío?'. 'Sí, te he sorprendido -respondió Elías-; por haberte prestado a hacer lo que es malo a los ojos del Señor,"
,"21":"voy a acarrear sobre ti la desgracia: barreré tu posteridad y exterminaré de Ajab todo varón, esclavo y libre, de Israel."
,"22":"Haré de tu casa como de la casa de Jeroboán, hijo de Nabat, o como de la casa de Basá, hijo de Ajías, por haberme irritado y haber hecho pecar a Israel."
,"23":"El Señor ha dicho también contra Jezabel: Los perros comerán a Jezabel en la propiedad de Yezrael."
,"24":"Al que de Ajab muera en la ciudad le comerán los perros, y al que muera en el campo le comerán las aves del cielo'."
,"25":"En verdad no hubo nadie que como Ajab se prestase a hacer lo que es malo a los ojos del Señor, a lo cual le incitaba su esposa Jezabel,"
,"26":"o cometiese tan grandes abominaciones dando culto a los ídolos, imitando a los amorreos, que el Señor había echado delante de los israelitas."
,"27":"Cuando Ajab oyó aquellas palabras, rasgó sus vestiduras, se vistió de saco y ayunó. Se acostaba con el cilicio y andaba muy afligido."
,"28":"Entonces el Señor dijo a Elías, el tesbita:"
,"29":"'¿Has visto cómo Ajab se ha humillado ante mí? Por eso, no acarrearé la desgracia sobre su casa en sus días, sino en los días de su hijo'."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Pasaron tres años sin guerra entre Siria e Israel."
,"2":"Y al tercer año, Josafat, rey de Judá, fue a visitar al rey de Israel,"
,"3":"el cual dijo a sus servidores: 'Sabéis bien que Ramot de Galaad nos pertenece, y, no obstante, nosotros estamos con los brazos cruzados sin quitársela al rey de Siria'."
,"4":"Y propuso a Josafat: '¿Quieres venir conmigo a atacar a Ramot de Galaad?'. Josafat le respondió: 'Tú y yo, tu pueblo y mi pueblo, tu caballería y mi caballería son una misma cosa'."
,"5":"Pero añadió: 'Por favor, consulta hoy la voluntad del Señor'."
,"6":"Entonces el rey de Israel reunió a los profetas, cuatrocientos, y les dijo: '¿Debo atacar a Ramot de Galaad, o no?'. Respondieron: 'Atácala, porque el Señor la pondrá en tus manos'."
,"7":"Josafat repuso: '¿No habrá aquí algún otro profeta del Señor, para consultarle?'."
,"8":"El rey de Israel respondió a Josafat: 'Hay todavía uno por medio del cual podemos consultar al Señor; pero yo le odio porque nunca me profetiza cosas buenas, sino cosas malas. Es Miqueas, hijo de Yimlá'. Josafat dijo: 'No hable así el rey'."
,"9":"Entonces el rey de Israel llamó a un funcionario y le dijo: 'Que venga inmediatamente Miqueas, hijo de Yimlá'."
,"10":"El rey de Israel y Josafat, rey de Judá, estaban sentados en sus tronos con sus vestiduras regias en la explanada, y ante ellos todos los profetas en trance de profetizar."
,"11":"Sedecías, hijo de Canaaná, se había hecho cuernos de hierro, y decía: 'Esto dice el Señor: Con éstos acornearás a Siria hasta exterminarlo'."
,"12":"Y todos los profetas profetizaban de la misma manera: 'Ataca a Ramot de Galaad y triunfarás, pues el Señor la pondrá en tus manos'."
,"13":"El mensajero que había ido a llamar a Miqueas le dijo: 'Mira que los profetas, todos a una, profetizan éxito al rey: haz tú como ellos, y profetiza el triunfo'."
,"14":"Miqueas respondió: '¡Vive el Señor, que diré lo que el Señor me mande!'."
,"15":"Se presentó al rey, y el rey le dijo: 'Miqueas, ¿debemos atacar a Ramot de Galaad, o no?'. Él respondió: 'Atácala y triunfarás, pues el Señor la pondrá en tus manos'."
,"16":"El rey le dijo: '¿Cuántas veces te voy a decir que no digas más que la verdad en nombre del Señor?'. Miqueas contestó:"
,"17":"'He visto a todo Israel disperso por los montes como rebaño sin pastor. Y el Señor decía: Éstos no tienen dueño. Que cada uno vuelva en paz a su casa'."
,"18":"El rey de Israel dijo a Josafat: '¿No te decía yo que nunca me profetiza bienes, sino males?'."
,"19":"Miqueas replicó: 'Escucha la palabra del Señor: He visto al Señor sentado en su trono y a toda la corte del cielo alineada a su derecha y a su izquierda."
,"20":"Y el Señor decía: ¿Quién seducirá a Ajab, para que vaya y muera en Ramot de Galaad? Y uno proponía una cosa y otro otra."
,"21":"Pero se adelantó un espíritu y, de pie ante el Señor, dijo: Yo lo seduciré. El Señor le preguntó: ¿Cómo?"
,"22":"Y él respondió: Saldré y seré espíritu de mentira en la boca de todos tus profetas. Y el Señor dijo: Tú lograrás seducirlo; vete y hazlo así."
,"23":"Sabe, pues, que el Señor ha puesto espíritu de mentira en la boca de todos tus profetas, porque el Señor ha decretado tu ruina'."
,"24":"Entonces Sedecías, hijo de Canaaná, dio una bofetada a Miqueas, y le dijo: '¿Es que el espíritu del Señor me ha dejado a mí para hablarte a ti?'."
,"25":"Miqueas contestó: 'Lo sabrás el día en que andes de aposento en aposento para esconderte'."
,"26":"El rey de Israel ordenó: 'Prende a Miqueas y condúcelo a Amón, prefecto de la ciudad, y a Joás, mi hijo,"
,"27":"y diles: Ésta es la orden del rey: Meted a este hombre en la cárcel y tenedlo a pan y agua, y poco de cada cosa, hasta que yo vuelva sano y salvo'."
,"28":"Miqueas repuso: 'Si vuelves sano y salvo, el Señor no ha hablado por mi boca'."
,"29":"El rey de Israel y Josafat, rey de Judá, fueron a atacar a Ramot de Galaad."
,"30":"El rey de Israel dijo a Josafat: 'Yo iré disfrazado a la batalla, pero tú irás con tu vestidura real'. Y se disfrazó y entró en batalla."
,"31":"Mas el rey de Siria había dado estas órdenes a los treinta y dos jefes de sus carros: 'No ataquéis a ninguno, sea oficial o soldado raso, sino únicamente al rey de Israel'."
,"32":"Cuando los jefes de los carros vieron a Josafat, se dijeron: 'Éste es el rey de Israel'. Y fueron contra él y lo atacaron. Josafat entonces lanzó un grito."
,"33":"Los jefes de los carros se dieron cuenta de que no era el rey de Israel y dejaron de perseguirlo."
,"34":"Pero un hombre disparó el arco al azar e hirió al rey de Israel entre las junturas de la coraza. El rey dijo a su auriga: 'Da la vuelta y sácame del campo, porque estoy herido'."
,"35":"Pero arreció tanto la lucha aquel día, que el rey de Israel siguió firme en su carro frente a los sirios y murió al atardecer: la sangre de la herida cayó al fondo del carro."
,"36":"Al ponerse el sol, corrió esta orden por el campamento: '¡Cada cual a su ciudad, cada cual a su tierra, el rey ha muerto!'."
,"37":"Llevaron al rey a Samaría, y allí lo enterraron."
,"38":"Lavaron el carro en la alberca de Samaría, los perros lamieron la sangre del rey y las prostitutas se bañaron en ella, como había dicho el Señor."
,"39":"El resto de la historia de Ajab, todo cuanto hizo, la casa de marfil que edificó y las ciudades que construyó, está escrito en el libro de los anales de los reyes de Israel."
,"40":"Ajab murió y le sucedió en el trono su hijo Ocozías."
,"41":"Josafat, hijo de Asá, comenzó a reinar sobre Judá el año cuarto de Ajab, rey de Israel."
,"42":"Tenía treinta y cinco años cuando subió al trono, y reinó en Jerusalén veinticinco años. Su madre, hija de Siljí, se llamaba Azubá."
,"43":"Siguió en todo la conducta de su padre, Asá, y no se apartó un punto de ella, haciendo lo que es recto a los ojos del Señor."
,"44":"Sin embargo, las colinas no desaparecieron, y el pueblo seguía aún ofreciendo sacrificios y quemando incienso en ellas."
,"45":"Estuvo en paz con el rey de Israel."
,"46":"El resto de la historia de Josafat, las proezas que realizó y las guerras que sostuvo están escritas en el libro de los anales de los reyes de Judá."
,"47":"Barrió del país los restos de la prostitución sagrada que habían quedado en los días de su padre, Asá."
,"48":"En Edón entonces no había rey; un gobernador hacía de tal."
,"49":"Josafat construyó naves de Tarsis para ir a Ofir por oro; pero no zarpó porque las naves se destrozaron en Esyón Guéber."
,"50":"Ocozías, hijo de Ajab, había dicho a Josafat: 'Que mis súbditos vayan con los tuyos en las naves'. Pero Josafat no había querido."
,"51":"Josafat murió y fue sepultado con sus padres en la ciudad de David, su antepasado. Le sucedió en el trono su hijo Jorán."
,"52":"Ocozías, hijo de Ajab, empezó a reinar sobre Israel en Samaría el año diecisiete de Josafat, rey de Judá. Reinó dos años sobre Israel."
,"53":"Hizo lo que es malo a los ojos del Señor e imitó la conducta de su padre, de su madre y de Jeroboán, hijo de Nabat, el que hizo pecar a Israel."
,"54":"Sirvió a Baal y le adoró, irritando al Señor, Dios de Israel, exactamente como lo había hecho su padre."
}`)

}
func ES_LSB_LoadVH1SChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Había un hombre de Ramá, un sufita de la montaña de Efraín, que se llamaba Elcaná, hijo de Yeroján, hijo de Elihú, hijo de Toju, hijo de Suf, efraimita."
,"2":"Tenía dos mujeres: una llamada Ana, y la otra, Peniná. Peniná tenía hijos; Ana no los tenía."
,"3":"Todos los años subía aquel hombre desde su ciudad a adorar y ofrecer sacrificios al Señor todopoderoso en Silo. Allí estaban los dos hijos de Elí, Jofní y Fineés, como sacerdotes del Señor."
,"4":"El día en que ofrecía el sacrificio daba sus raciones correspondientes a Peniná y a sus hijos."
,"5":"A Ana le daba sólo una ración, aunque él prefería a Ana; pero el Señor la había hecho estéril."
,"6":"Su rival la humillaba y se burlaba de ella porque el Señor la había hecho estéril."
,"7":"Así hacía año tras año, cada vez que subían a la casa del Señor; Ana lloraba y no quería comer."
,"8":"Elcaná, su marido, le dijo: 'Ana, ¿por qué estás tan triste? ¿No soy yo para ti más que diez hijos?'."
,"9":"Después que comieron y bebieron en Silo, Ana se levantó y se puso ante el Señor, mientras Elí, el sacerdote, estaba sentado en su silla ante la puerta del santuario del Señor."
,"10":"Ella, con el alma llena de amargura y bañada en lágrimas, se puso a rezar al Señor,"
,"11":"y le hizo esta promesa: '¡Oh Señor todopoderoso!, si quieres mirar la aflicción de tu sierva, te acuerdas de mí y me das un hijo varón, yo lo consagraré al Señor por todos los días de su vida, y la navaja no pasará por su cabeza'."
,"12":"Como ella prolongase su oración ante el Señor, Elí se fijó en sus labios."
,"13":"Y como Ana rezaba mentalmente, movía sus labios, pero no se oía su voz, Elí pensó que estaba borracha."
,"14":"Elí le dijo: '¿Hasta cuándo seguirás con tu borrachera? Anda, que se te pase tu vino'."
,"15":"Ana respondió: 'No, señor mío; soy una mujer desgraciada; no he bebido vino ni licor; estoy desahogando mi corazón ante el Señor."
,"16":"No tomes a tu sierva por una mujer perversa, porque no he hecho hasta ahora más que exponer la magnitud de mi dolor y amargura'."
,"17":"Elí le respondió: 'Vete en paz, y que el Dios de Israel te conceda lo que le has pedido'."
,"18":"Ella dijo: 'Que tu sierva alcance tu favor'. La mujer se marchó, comió y bebió, y ya no parecía la de antes."
,"19":"Se levantaron de madrugada, adoraron al Señor y se fueron a su casa de Ramá. Elcaná se unió a su mujer Ana, y el Señor se acordó de ella."
,"20":"Ana concibió y dio a luz un hijo, al que puso por nombre Samuel, porque dijo: 'Se lo pedí al Señor'."
,"21":"Elcaná, su marido, fue con toda su familia para ofrecer al Señor el sacrificio anual y cumplir su promesa."
,"22":"Ana no quiso acompañarle; le dijo a su marido: 'Cuando el niño haya sido destetado, yo lo llevaré para que sea presentado al Señor y se quede allí para siempre'."
,"23":"Elcaná respondió a su mujer: 'Haz lo que mejor te parezca; quédate hasta que le hayas destetado. Que el Señor te conceda cumplir tu promesa'. Ella se quedó en casa y amamantó al niño hasta que lo destetó."
,"24":"Cuando le quitó el pecho, lo llevó consigo al templo del Señor en Silo. Llevó también tres novillos, media fanega de harina y un odre de vino."
,"25":"Inmolaron un novillo y presentaron el niño a Elí."
,"26":"Ana le dijo: 'Perdón, señor; tan cierto como que tú vives, yo soy aquella mujer que estuvo aquí junto a ti orando al Señor."
,"27":"Yo le pedí un hijo, y el Señor me ha concedido lo que le pedía."
,"28":"Ahora yo se lo doy al Señor; estará dedicado al Señor todos los días de su vida'. Después adoraron al Señor."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Ana oró de esta manera: 'Tengo el corazón alegre,gracias al Señor, la frente alta gracias a Dios,y la boca abierta,contra mis enemigos; yo me regocijo en tu victoria."
,"2":"Nadie como el Señor es santo,-fuera de ti no hay otros-, no hay roca como nuestro Dios."
,"3":"No repitáis tanto palabras altaneras, no pronunciéis palabras arrogantes, porque el Señor es un Dios lleno de saber, un Dios que pesa las acciones."
,"4":"El arco de los valientes se ha roto, mientras que los cobardes,se ciñen de valor."
,"5":"Los hartos se contratan,por un poco de pan, mientras que los hambrientos,ya no se fatigan. La mujer estéril tiene siete hijos, y la madre fecunda se marchita."
,"6":"El Señor da la muerte y da la vida, hace bajar al abismo,y hace subir de él."
,"7":"El Señor empobrece y enriquece, el Señor humilla y enaltece."
,"8":"Él levanta del polvo al miserable, él saca al mendigo del estiércol,para hacer que se siente,con los nobles,y asignarle un trono glorioso; porque suyos son los pilares,de la tierra, y sobre ellos ha puesto él el orbe."
,"9":"Él guarda los pasos de sus fieles, mientras que los malvados,perecerán en las tinieblas, pues no es por la fuerza,como vence el hombre."
,"10":"El Señor aniquila a sus contrarios, el altísimo truena desde el cielo; el Señor juzga los confines de la tierra, dará fuerza a su rey,y levantará la frente de su ungido'."
,"11":"Elcaná volvió a su casa, a Ramá, y el niño quedó al servicio del Señor con el sacerdote Elí."
,"12":"Los hijos de Elí eran unos disolutos; no se cuidaban del Señor,"
,"13":"ni de los deberes de los sacerdotes para con el pueblo. Cuando alguno ofrecía un sacrificio, mientras se cocía la carne llegaba un criado del sacerdote con un tenedor en la mano,"
,"14":"lo metía en el perol, caldero, olla o puchero, y todo lo que sacaba con el tenedor era para el sacerdote. Así hacían con todos los israelitas que iban a Silo."
,"15":"Más aún: antes de que se quemase la grasa, llegaba el criado del sacerdote y decía al que iba a ofrecer el sacrificio: 'Dame la carne para asársela al sacerdote; porque no te aceptará carne cocida, sino cruda'."
,"16":"Y si alguno le decía: 'Primero deben quemarse las grasas; después toma lo que quieras', respondía: 'No, dámelo ahora; si no, lo tomaré por la fuerza'."
,"17":"El pecado de los jóvenes era muy grande ante el Señor, porque trataban con desprecio las ofrendas hechas al Señor."
,"18":"El joven Samuel estaba al servicio del Señor, vestido con un efod de lino."
,"19":"Su madre le hacía una pequeña túnica y se la llevaba todos los años, cuando subía con su marido para hacer el sacrificio anual."
,"20":"Elí bendecía a Elcaná y a su mujer, diciendo: 'Que el Señor te dé descendencia de esta mujer en lugar del que ella ha ofrecido al Señor'. Y ellos se volvían a su casa."
,"21":"El Señor bendijo a Ana, que concibió y dio a luz tres hijos y dos hijas. El joven Samuel crecía en la presencia del Señor."
,"22":"Elí era ya muy anciano. Se enteró de todo lo que hacían sus hijos a todo Israel y que se acostaban con las mujeres que estaban al servicio de la entrada de la tienda de la reunión,"
,"23":"y les dijo: '¿Por qué hacéis estas cosas que yo oigo de vosotros a todo el pueblo?"
,"24":"No, hijos míos, no es bueno lo que oigo de vosotros; vosotros hacéis pecar al pueblo del Señor."
,"25":"Si peca un hombre contra otro hombre, Dios puede intervenir en su favor; pero si un hombre peca contra el Señor, ¿quién intercederá por él?'. Pero ellos no hicieron caso a su padre, porque el Señor había decidido que muriesen."
,"26":"Por su parte, el joven Samuel iba creciendo, se hacía grato al Señor y a los hombres."
,"27":"Un hombre de Dios fue a ver a Elí y le dijo: 'Esto dice el Señor: Yo me manifesté claramente a la familia de tu padre, cuando estaban en Egipto, esclavos del Faraón."
,"28":"Yo los elegí de entre todas las tribus de Israel para ser mis sacerdotes, para subir a mi altar, para quemar el incienso y llevar el efod en mi presencia; yo concedí a la casa de tu padre todas las ofrendas de los israelitas;"
,"29":"¿por qué profanáis los sacrificios y las ofrendas que yo he mandado, y tienes en mayor estima a tus hijos que a mí, tomando para vosotros lo mejor de las ofrendas de mi pueblo Israel?"
,"30":"Por eso, palabra del Señor, Dios de Israel: Yo había prometido que tu casa y la casa de tu padre estarían por siempre ante mí para servirme; pero ahora, palabra del Señor, lejos de mí tal cosa; porque yo honro a los que me honran, y los que me desprecian serán tratados como nada."
,"31":"Se acerca el día en que yo cortaré tu brazo y el brazo de la casa de tu padre, de suerte que ninguno llegará a viejo en tu casa."
,"32":"Verás con envidia todo el bien que voy a hacer en Israel y ninguno llegará a viejo en tu casa."
,"33":"Pero no haré desaparecer de mi altar a todos los tuyos, para que se consuman de envidia sus ojos y desfallezca de dolor su alma; y la mayor parte de tu familia morirá por la espada en la plenitud de la edad."
,"34":"Te servirá de señal lo que sucederá a tus dos hijos, Jofní y Fineés: morirán los dos en el mismo día."
,"35":"Yo me nombraré un sacerdote fiel, que hará lo que yo quiero y deseo; le edificaré una casa estable y caminará siempre en presencia de mi ungido."
,"36":"Entonces el superviviente de tu casa vendrá a postrarse ante él pidiéndole una moneda de plata y una torta de pan, y dirá: Admíteme, por favor, en cualquier oficio sacerdotal, para que tenga un pedazo de pan que comer'."
}`)
	CurrentBook.AddChapter(3, `{
"1":"El joven Samuel estaba al servicio del Señor con Elí. En aquel tiempo era raro oír la palabra de Dios, y las visiones no eran frecuentes."
,"2":"Un día Elí permanecía acostado en su habitación. Sus ojos se habían debilitado y ya no podía ver."
,"3":"La lámpara de Dios todavía no estaba apagada, y Samuel dormía en el templo del Señor, donde estaba el arca de Dios."
,"4":"El Señor lo llamó: '¡Samuel, Samuel!'. Él respondió: 'Aquí estoy'."
,"5":"Fue corriendo donde estaba Elí y le dijo: 'Aquí estoy, pues me has llamado'. Elí dijo: 'No te he llamado; vuelve a dormir'. Y Samuel fue a acostarse."
,"6":"Por segunda vez lo llamó el Señor: '¡Samuel!'. Y Samuel se levantó, fue adonde estaba Elí y le dijo: 'Aquí estoy, pues me has llamado'. Elí respondió: 'No te he llamado; vuelve a acostarte, hijo mío'."
,"7":"Samuel no conocía todavía al Señor, pues la palabra del Señor todavía no se le había revelado."
,"8":"Por tercera vez lo llamó el Señor: '¡Samuel!'. Se levantó, fue adonde estaba Elí y le dijo: 'Aquí estoy, pues me has llamado'. Comprendió entonces Elí que era el Señor el que lo llamaba,"
,"9":"y le dijo: 'Vete a acostarte, y si te llaman, dirás: Habla, Señor, que tu siervo escucha'. Y Samuel fue a acostarse."
,"10":"El Señor se presentó y lo llamó como otras veces: '¡Samuel, Samuel!'. Samuel respondió: 'Habla, que tu siervo escucha'."
,"11":"El Señor le dijo: 'Voy a hacer en Israel una cosa tal que al que la oiga le zumbarán los oídos."
,"12":"Aquel día haré venir sobre Elí todo lo que he dicho contra su casa, desde el principio hasta el fin."
,"13":"Dile que yo condeno a su casa para siempre, porque él sabía que sus hijos maldecían a Dios y no los corrigió."
,"14":"Por eso juro a la casa de Elí que nunca podrá borrarse con sacrificios y ofrendas la culpa de la casa de Elí'."
,"15":"Samuel siguió acostado hasta la mañana, y entonces abrió las puertas del templo del Señor. Samuel tenía miedo de contar a Elí la visión que había tenido."
,"16":"Pero Elí le llamó, y le dijo: '¡Samuel, hijo mío!'. Él respondió: 'Aquí estoy'."
,"17":"Y le preguntó: '¿Qué es lo que te ha dicho? ¡No me ocultes nada! Que Dios te castigue si me ocultas una palabra de lo que él te ha dicho'."
,"18":"Entonces Samuel se lo contó todo; no le ocultó nada. Elí dijo: 'Él es el Señor; hágase su voluntad'."
,"19":"Samuel creció, y el Señor estaba con él; no dejó de cumplirse ni una sola de sus palabras."
,"20":"Todo Israel, desde Dan hasta Berseba, supo que Samuel estaba acreditado como profeta del Señor."
,"21":"El Señor continuó manifestándose en Silo, donde se revelaba a Samuel."
}`)
	CurrentBook.AddChapter(4, `{
"1":"La palabra de Samuel llegaba a todo Israel. Se reunieron entonces los filisteos para hacer la guerra a Israel. Los israelitas salieron a enfrentarse con ellos y acamparon en Eben Ezer, mientas que los filisteos estaban acampados en Afec."
,"2":"Los filisteos se pusieron en orden de batalla. El combate fue duro, e Israel fue derrotado por los filisteos; cayeron en el campo de batalla cerca de cuarenta mil hombres."
,"3":"El pueblo volvió al campamento, y los ancianos se preguntaron: '¿Por qué nos ha derrotado hoy el Señor ante los filisteos? Vamos a buscar a Silo el arca de la alianza del Señor, y que vaya con nosotros; así nos librará de la mano de nuestros enemigos'."
,"4":"El pueblo mandó mensajeros a Silo, y se trajo de allí el arca de la alianza del Señor todopoderoso, que se sienta sobre los querubines. Los dos hijos de Elí, Jofní y Fineés, acompañaban el arca."
,"5":"Cuando el arca de la alianza del Señor llegó al campamento, todo Israel la recibió con tales gritos que la tierra temblaba."
,"6":"Oyeron los gritos los filisteos y preguntaron: '¿Qué significa este clamor tan grande en el campamento de los hebreos?'. Y supieron que el arca del Señor había llegado al campamento."
,"7":"Los filisteos tuvieron miedo, porque decían: 'Ha venido Dios al campamento. ¡Ay de nosotros! Esto no había sucedido nunca."
,"8":"¡Ay de nosotros! ¿Quién nos salvará de la mano de este Dios poderoso? Es él quien castigó a Egipto con toda clase de plagas."
,"9":"Cobrad ánimo y sed valientes, filisteos, para no servir a los hebreos, como ellos os han servido a vosotros; sed hombres y luchad'."
,"10":"Los filisteos se lanzaron al ataque y derrotaron a los israelitas, que huyeron a la desbandada. Fue una gran derrota. Cayeron treinta mil hombres de la infantería israelita,"
,"11":"el arca de Dios fue capturada y los hijos de Elí, Jofní y Fineés, murieron."
,"12":"Un hombre de Benjamín escapó corriendo de las filas del ejército, y llegó aquel mismo día a Silo con los vestidos destrozados y la cabeza cubierta de polvo."
,"13":"Cuando llegó, Elí estaba sentado en su silla, al lado de la puerta, a la expectativa, pues su corazón temía por el arca de Dios. El hombre entró en la ciudad para contarlo, y toda la ciudad comenzó a gritar."
,"14":"Elí oyó el rumor de aquellos gritos, y preguntó: '¿Qué significa este ruido tumultuoso?'. Y aquel hombre fue deprisa a informar a Elí."
,"15":"Elí tenía noventa y ocho años, sus ojos se habían quedado fijos y ya no veía."
,"16":"Aquel hombre dijo a Elí: 'Yo vengo del campamento; he huido hoy mismo de las filas del ejército'. Elí preguntó: '¿Y qué ha pasado, hijo mío?'."
,"17":"El mensajero contestó: 'Israel ha huido ante los filisteos; ha sido una gran derrota; murieron también tus dos hijos, Jofní y Fineés, y el arca de Dios fue capturada'."
,"18":"Al mencionar el arca de Dios, Elí cayó de su silla hacia atrás, frente a la puerta, se rompió la nuca y murió, pues era ya viejo y estaba muy pesado. Elí fue juez en Israel durante cuarenta años."
,"19":"Su nuera, la mujer de Fineés, estaba encinta y a punto de dar a luz. Cuando oyó la noticia referente al arca de Dios, la muerte de su suegro y de su marido, se acostó y dio a luz, pues le asaltaron los dolores."
,"20":"Estando en trance de morir, los que estaban presentes le decían: 'No tengas miedo, que has dado a luz un hijo'. Pero ella no respondió ni hizo caso;"
,"21":"y al niño le puso por nombre Icabod, diciendo: 'Ha pasado la gloria de Israel', aludiendo a la pérdida del arca, a su suegro y a su marido."
,"22":"Ella dijo: 'Ha pasado la gloria de Israel, porque ha sido capturada el arca de Dios'."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Los filisteos se apoderaron del arca de Dios y la llevaron de Eben Ezer a Asdod,"
,"2":"al templo de Dagón, y la colocaron junto a Dagón."
,"3":"Cuando los de Asdod se levantaron por la mañana, encontraron a Dagón caído en tierra boca abajo ante el arca del Señor. Levantaron a Dagón y lo colocaron en su sitio."
,"4":"Cuando se levantaron a la mañana siguiente, Dagón estaba caído en tierra boca abajo ante el arca del Señor, y la cabeza de Dagón y sus dos manos cortadas estaban sobre el umbral; sólo quedaba de Dagón el tronco."
,"5":"Por eso, todavía hoy los sacerdotes de Dagón y todos lo que entran en su templo en Asdod no pisan el umbral de Dagón."
,"6":"La mano del Señor descargó sobre los de Asdod y sus alrededores, los llenó de espanto y los afligió con tumores."
,"7":"Los de Asdod, al ver esto, se dijeron: 'Que no continúe con nosotros el arca del Dios de Israel, porque es muy dura su mano sobre nosotros y sobre Dagón, nuestro Dios'."
,"8":"Convocaron a todos los jefes filisteos, y les preguntaron: '¿Qué haremos con el arca del Dios de Israel?'. Ellos respondieron: 'Llevadla a Gat'. Y allí la llevaron."
,"9":"Cuando la llevaron, la mano del Señor descargó sobre la ciudad y hubo en ella gran pánico, pues hirió a las gentes de la ciudad, desde el pequeño hasta el grande, y les salieron tumores."
,"10":"Entonces trasladaron el arca de Dios a Ecrón. Y cuando el arca de Dios llegó a Ecrón, los de Ecrón gritaban y decían: 'Han traído aquí el arca del Dios de Israel para matarnos a nosotros y a nuestro pueblo'."
,"11":"Entonces convocaron a los jefes filisteos y les dijeron: 'Llevaos de aquí el arca del Dios de Israel; que vuelva a su lugar, para que no nos mate a nosotros y a nuestro pueblo'. Pues había un pánico mortal en toda la ciudad, porque la mano de Dios había descargado allí duramente."
,"12":"La gente que no había muerto estaba afligida con tumores. El clamor de la ciudad llegaba hasta el cielo."
}`)
	CurrentBook.AddChapter(6, `{
"1":"El arca del Señor estuvo siete meses en territorio de los filisteos."
,"2":"Los filisteos convocaron a los sacerdotes y adivinos y les preguntaron: '¿Qué haremos con el arca del Señor? Decidnos cómo la devolveremos a su lugar'."
,"3":"Respondieron: 'Si queréis devolver el arca del Dios de Israel, no la mandéis sin nada; devolvedla con una ofrenda de reconciliación. Entonces curaréis y sabréis por qué su mano no se retiraba de vosotros'."
,"4":"Ellos preguntaron: '¿Cuál debe ser esa ofrenda de reconciliación?'. Respondieron: 'Cinco tumores de oro y cinco ratas de oro, una por cada jefe filisteo, porque la plaga fue la misma para vosotros y para vuestros jefes."
,"5":"Haced reproducciones de vuestros tumores y de las ratas que devastan vuestra tierra y dad gloria al Dios de Israel, a ver si levanta su mano de vosotros, vuestros dioses y vuestra tierra."
,"6":"No seáis testarudos, como fueron los egipcios y el Faraón; Dios los castigó duramente hasta que dejaron salir a los israelitas."
,"7":"Haced un carro nuevo, tomad dos vacas que estén criando y que no hayan llevado el yugo; uncid las vacas al carro y dejad sus crías en el establo."
,"8":"Tomad el arca del Señor y ponedla sobre el carro. Poned en un cofre junto a ella los objetos de oro que le dais en ofrenda de reconciliación, y dejadla andar."
,"9":"Fijaos bien: si va por el camino de su territorio hasta Bet Semes, es él quien nos ha hecho tanto mal; si no, sabremos que no ha sido su mano la que nos ha castigado, y que esto ha ocurrido por casualidad'."
,"10":"Así lo hicieron; tomaron dos vacas que estaban criando y las uncieron al carro, dejando sus crías en el establo."
,"11":"Pusieron en el carro el arca del Señor y el cofre con las ratas de oro y las reproducciones de sus tumores."
,"12":"Las vacas se fueron por el camino de Bet Semes y continuaron por él mugiendo, sin apartarse ni a la derecha ni a la izquierda. Los jefes filisteos las siguieron hasta el territorio de Bet Semes."
,"13":"Las gentes de Bet Semes estaban segando el trigo en el valle. Alzaron la vista, vieron el arca del Señor y salieron gozosamente a su encuentro."
,"14":"Cuando el arca llegó al campo de Josué, el de Bet Semes, se detuvo. Allí había una piedra grande. El carro lo hicieron astillas y ofrecieron las vacas en holocausto al Señor."
,"15":"Los levitas habían bajado el arca del Señor y el cofre que estaba junto a ella, que contenía los objetos de oro, y los habían colocado sobre aquella piedra grande. Aquel día las gentes de Bet Semes ofrecieron holocaustos y sacrificios de reconciliación al Señor."
,"16":"Los cinco jefes filisteos, después de ver aquello, se volvieron aquel mismo día a Ecrón."
,"17":"Éstos son los tumores de oro que los filisteos dieron en ofrenda de reconciliación al Señor: uno por Asdod, uno por Gaza, uno por Ascalón, uno por Gat y uno por Ecrón."
,"18":"El número de las ratas de oro era igual al de las ciudades de los cinco jefes filisteos, tanto de las ciudades fortificadas como de las ciudades desguarnecidas. La piedra grande sobre la que pusieron el arca del Señor existe todavía hoy en el campo de Josué, el de Bet Semes, como testigo."
,"19":"Los hijos de Jeconías no se alegraron con las gentes de Bet Semes cuando vieron el arca del Señor, y el Señor hirió a setenta hombres de entre ellos. El pueblo hizo gran duelo porque el Señor los había castigado tan duramente."
,"20":"Y las gentes de Bet Semes decían: '¿Quién podrá resistir al Señor, este Dios santo? Y ¿adónde enviaremos el arca, lejos de nosotros?'."
,"21":"Y mandaron a decir a las gentes de Quiriat Yearín: 'Los filisteos han devuelto el arca del Señor. Venid y llevadla con vosotros'."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Las gentes de Quiriat Yearín fueron y se llevaron el arca del Señor y la introdujeron en casa de Abinadad, en la colina, y consagraron a su hijo Eliezer para que la cuidara."
,"2":"Pasaron veinte años desde el día en que instalaron el arca del Señor en Quiriat Yearín, y toda la casa de Israel se lamentaba ante el Señor."
,"3":"Entonces Samuel dijo a todo el pueblo de Israel: 'Si os convertís al Señor de todo corazón, quitad de en medio de vosotros los dioses extranjeros y las astartés; poned vuestros corazones en el Señor y servidle a él solo; entonces el Señor os librará de la mano de los filisteos'."
,"4":"Los israelitas quitaron los baales y las astartés y sirvieron sólo al Señor."
,"5":"Samuel dijo: 'Convocad a todos los israelitas en Mispá, y yo rogaré al Señor por vosotros'."
,"6":"Se reunieron en Mispá, sacaron agua y la derramaron ante el Señor, ayunaron aquel día y dijeron: 'Hemos pecado contra el Señor'. Y Samuel fue juez de los israelitas en Mispá."
,"7":"Los filisteos se enteraron de que los israelitas se habían reunido en Mispá, y los jefes de los filisteos fueron contra ellos. Los israelitas, al saberlo, tuvieron miedo"
,"8":"y dijeron a Samuel: 'No dejes de rogar por nosotros al Señor, nuestro Dios, para que él nos salve de los filisteos'."
,"9":"Samuel tomó un cordero de leche y lo ofreció entero en holocausto al Señor. Samuel rogó al Señor por Israel, y el Señor le escuchó."
,"10":"Mientras Samuel ofrecía el holocausto, los filisteos entablaron el combate contra Israel; pero aquel día el Señor tronó con gran aparato contra los filisteos, se apoderó el pánico de ellos y fueron derrotados por Israel."
,"11":"Los israelitas salieron de Mispá, persiguieron a los filisteos y los atacaron hasta más abajo de Bejorón."
,"12":"Samuel puso una piedra entre Mispá y Yesaná, y la llamó Ben Ezer, diciendo: 'Hasta aquí nos ha ayudado el Señor'."
,"13":"Los filisteos fueron derrotados. No volvieron a invadir el territorio de Israel, y la mano del Señor pesó sobre los filisteos durante toda la vida de Samuel."
,"14":"Fueron devueltas a Israel las ciudades que le habían sido quitadas por los filisteos, desde Ecrón hasta Gat, e Israel libró su territorio de la mano de los filisteos. Además hubo paz entre Israel y los amorreos."
,"15":"Samuel fue juez de Israel durante toda su vida."
,"16":"Cada año hacía un recorrido por Betel, Guilgal y Mispá, y en todos estos sitios juzgaba a Israel."
,"17":"Después volvía a Ramá, donde tenía su casa, y allí juzgaba a Israel. También construyó allí un altar al Señor."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Cuando Samuel se hizo viejo, constituyó jueces en Israel a sus hijos."
,"2":"Su hijo mayor se llamaba Joel, y el menor, Abías. Eran jueces en Berseba."
,"3":"Pero sus hijos no siguieron sus caminos; se volvieron ambiciosos, se dejaban sobornar y dictaban sentencias injustas."
,"4":"Por eso se reunieron todos los ancianos de Israel, fueron a Ramá a ver a Samuel,"
,"5":"y le dijeron: 'Tú eres ya viejo, y tus hijos no siguen tus caminos. Danos un rey para que nos gobierne, como tienen todas las naciones'."
,"6":"A Samuel le desagradó que le dijesen: 'Danos un rey para que nos gobierne', y se puso a invocar al Señor."
,"7":"Pero el Señor dijo a Samuel: 'Obedece la voz del pueblo en todo lo que te diga, porque no te han rechazado a ti, sino a mí, para que no reine sobre ellos."
,"8":"Así se han portado conmigo desde el día que los saqué de Egipto hasta hoy, abandonándome para servir a dioses extranjeros, y así se portan ahora contigo."
,"9":"Atiende su petición; pero adviérteles bien y hazles saber los derechos del rey que van a tener'."
,"10":"Samuel transmitió al pueblo que le pedía un rey las palabras del Señor."
,"11":"Les dijo: 'Éstos son los derechos del rey que va a reinar sobre vosotros: tomará a vuestros hijos, se servirá de ellos para sus carros y sus caballos y los hará correr ante su carro."
,"12":"Los empleará como jefes de mil, de ciento y de cincuenta; los hará trabajar sus campos, segar sus mieses, fabricar sus armas de guerra y el atalaje de sus carros."
,"13":"Tomará a vuestras hijas para perfumeras, cocineras y panaderas."
,"14":"Se apoderará de vuestros mejores campos, de vuestras viñas y de vuestros olivares y se los dará a sus oficiales."
,"15":"Os cobrará los diezmos de vuestras mieses y de vuestras viñas para dárselos a sus eunucos y oficiales."
,"16":"Se adueñará de vuestros criados y criadas, de vuestros mejores bueyes y asnos para emplearlos en su servicio."
,"17":"Os exigirá el diezmo de vuestros rebaños, y vosotros mismos seréis sus esclavos."
,"18":"Entonces gritaréis contra el rey que vosotros mismos habéis elegido, pero el Señor no os atenderá'."
,"19":"Pero el pueblo no quiso escuchar a Samuel, y dijo: 'No; queremos un rey,"
,"20":"y así seremos como todas las naciones; nuestro rey nos juzgará, marchará a nuestra cabeza y combatirá nuestros combates'."
,"21":"Samuel oyó todas las palabras del pueblo y se las transmitió al Señor,"
,"22":"y el Señor le dijo: 'Atiende su petición y pon un rey sobre ellos'. Entonces Samuel dijo a los israelitas: 'Id cada uno a vuestra ciudad'."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Había un hombre de la tribu de Benjamín llamado Quis, hijo de Abiel, hijo de Seror, hijo de Becorat, hijo de Afiaj; un hombre valiente."
,"2":"Tenía un hijo llamado Saúl, buen mozo. No había entre los israelitas quien le superase; a todos les sacaba la cabeza."
,"3":"Un día a Quis se le extraviaron sus asnas; entonces dijo a su hijo Saúl: 'Toma contigo a uno de los mozos y vete a buscar las asnas'."
,"4":"Atravesaron las montañas de Efraín; pasaron la tierra de Salisá, pero no las encontraron; cruzaron el país de Salín, y no estaban allí; atravesaron el país de Benjamín, y no las encontraron."
,"5":"Cuando llegaron al país de Suf, Saúl dijo al mozo que le acompañaba: 'Demos la vuelta, no sea que mi padre, más que por las asnas, esté intranquilo por nosotros'."
,"6":"Pero éste le respondió: 'Mira, aquí, en esta ciudad, hay un hombre de Dios; es un hombre muy famoso; todo lo que él dice se realiza siempre. Vamos allá. Tal vez él nos indique el camino que debemos seguir'."
,"7":"Saúl respondió al mozo: 'Si, vamos allá, ¿qué llevaremos a ese hombre? Ya no hay pan en nuestros sacos y no tenemos nada que ofrecer al hombre de Dios. ¿Qué le daremos?'."
,"8":"El mozo dijo a Saúl: 'Mira, he encontrado en mi bolso una pequeña moneda de plata; se la daré al hombre de Dios para que nos indique el camino que debemos seguir'."
,"10":"Saúl respondió al mozo: 'Muy bien dicho; vamos'. Y fueron a la ciudad, donde estaba el hombre de Dios."
,"11":"Cuando subían por la cuesta de la ciudad, se encontraron a unas jóvenes que salían a coger agua, y les preguntaron: '¿Está aquí el vidente?'. ("
,"9":"Antiguamente, en Israel, cuando se iba a consultar a Dios, se decía: 'Venid, vamos al vidente'; pues al que hoy se llama profeta, antes se le llamaba vidente)."
,"12":"Ellas respondieron: 'Sí, aquí está. Acaba de llegar a la ciudad, porque hoy hay un sacrificio por el pueblo en el alto."
,"13":"En cuanto entréis en la ciudad, buscadlo rápidamente, antes de que suba al alto para la comida. El pueblo no comienza a comer antes de que llegue él, porque es él quien tiene que bendecir el sacrificio; después de esto comerán los invitados. Por tanto, subid rápidamente, y lo encontraréis'."
,"14":"Ellos subieron. Apenas habían entrado en la ciudad, cuando se encontró con ellos Samuel, que salía para subir al alto."
,"15":"El día antes de que llegara Saúl, el Señor había advertido a Samuel:"
,"16":"'Mañana a esta hora te enviaré un hombre de la tierra de Benjamín; tú le ungirás como jefe de mi pueblo Israel para que salve a mi pueblo de la mano de los filisteos, porque he visto la miseria de mi pueblo y su clamor ha llegado hasta mí'."
,"17":"Cuando Samuel vio a Saúl, el Señor le dijo: 'Éste es el hombre de que te hablé; éste es el que regirá a mi pueblo'."
,"18":"Saúl se acercó a Samuel en medio de la entrada y le dijo: 'Indícanos, por favor, dónde está la casa del vidente'."
,"19":"Samuel le respondió: 'Yo soy el vidente. Sube delante de mí al alto; hoy comerás conmigo, y mañana por la mañana os despediré después de haberte explicado todo lo que tienes en tu pensamiento."
,"20":"En cuanto a las asnas extraviadas hace ya tres días, no te preocupes, porque ya han aparecido. Además, ¿de quién será cuanto hay de precioso en Israel? ¿No será tuyo y de la casa de tu padre?"
,"21":"Saúl respondió: '¿No soy yo de Benjamín, la más pequeña de las tribus de Israel, y mi familia no es la más pequeña de todas las de la tribu de Benjamín? ¿Por qué me dices esto?'."
,"22":"Samuel llevó consigo a Saúl y a su mozo, los introdujo en la sala y les dio el primer puesto entre los invitados, que eran treinta personas."
,"23":"Después dijo Samuel al cocinero: 'Tráeme la ración que yo te di, la que te dije que pusieras aparte'."
,"24":"El cocinero tomó un pernil y el rabo y se lo sirvió a Saúl. Samuel le dijo: 'Ahí tienes la porción reservada; come, porque ella fue reservada para este momento cuando convoqué al pueblo'. Y aquel día Saúl comió con Samuel."
,"25":"Después bajaron a la ciudad, prepararon una cama para Saúl en la terraza y se acostó."
,"26":"Al despuntar el alba, Samuel llamó a Saúl y le dijo: 'Levántate y sigue tu camino'. Saúl se levantó y salieron los dos fuera."
,"27":"Cuando bajaron a las afueras de la ciudad, Samuel dijo a Saúl: 'Di al mozo que se adelante, pero tú párate, que tengo que comunicarte lo que Dios me ha dicho'."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Entonces Samuel tomó la redoma del aceite, la derramó sobre su cabeza, le besó y dijo: '¿No es el Señor quien te ha ungido como jefe de su pueblo, Israel? Tú regirás al pueblo del Señor y lo librarás de los enemigos que le rodean. Ésta es la señal de que el Señor te ha ungido como jefe de su heredad:"
,"2":"hoy, cuando te hayas alejado de mí, encontrarás junto a la tumba de Raquel, en los confines de Benjamín, a dos hombres, que te dirán: Han aparecido las asnas que andas buscando; tu padre se ha olvidado de las asnas y está intranquilo por vosotros, preguntándose qué puede hacer por su hijo."
,"3":"Más allá, cuando llegues a la cima del Tabor, encontrarás a tres hombres que suben a visitar a Dios, en Betel: uno lleva tres cabritos, otro tres panes y el tercero un odre de vino."
,"4":"Te saludarán y te darán dos panes, que tú aceptarás de su mano."
,"5":"Después llegarás a Guibeá de Dios, donde hay una guarnición de filisteos. Al entrar en la ciudad, te encontrarás con un grupo de profetas que bajan del alto, precedidos de arpas, tambores, flautas y cítaras, profetizando."
,"6":"Entonces se apoderará de ti el espíritu del Señor, profetizarás con ellos y serás transformado en otro hombre."
,"7":"Cuando te hayan sucedido todas estas señales, haz lo que se te ocurra, porque Dios está contigo."
,"8":"Baja delante de mí a Guilgal; yo iré para ofrecer holocaustos y sacrificios de reconciliación. Esperarás siete días hasta que yo vaya y te diga lo que tienes que hacer'."
,"9":"Cuando Saúl dio la vuelta y se alejó de Samuel, Dios le dio un corazón nuevo, y le sucedieron todas estas señales aquel mismo día."
,"10":"Cuando llegaron a Guibeá se encontraron con un grupo de profetas; el espíritu del Señor se apoderó de Saúl, y profetizó como ellos."
,"11":"Todos los que lo conocían de antes y lo veían profetizando con los profetas, se decían unos a otros: '¿Qué le ha pasado al hijo de Quis? ¿También Saúl anda entre los profetas?'."
,"12":"Uno de ellos dijo: '¿Y quién es su padre?'. Por eso quedó como proverbio: 'También Saúl anda entre los profetas'."
,"13":"Cuando terminó de profetizar, entró en su casa."
,"14":"Un tío suyo les dijo a él y al mozo: '¿Dónde habéis ido?'. Él respondió: 'A buscar las asnas; y como no las veíamos, fuimos a Samuel'."
,"15":"El tío le dijo: 'Cuéntame, por favor, lo que os dijo Samuel'."
,"16":"Saúl respondió: 'Nos dijo que las asnas habían sido encontradas'. Pero no le contó lo que le había dicho sobre el asunto del reino."
,"17":"Samuel convocó al pueblo ante el Señor en Mispá."
,"18":"Y dijo a los israelitas: 'Esto dice el Señor, Dios de Israel: Yo os saqué de Egipto y os libré de los egipcios y de todos los reinos que os oprimían."
,"19":"Y vosotros rechazáis hoy a vuestro Dios, que os ha salvado de todas vuestras desgracias y peligros, al pedir que os ponga un rey sobre vosotros. Por tanto, presentaos ante el Señor por tribus y por clanes'."
,"20":"Samuel hizo que se acercasen todas las tribus de Israel, y fue designada por suerte la tribu de Benjamín."
,"21":"Hizo acercarse a la tribu de Benjamín, por clanes, y fue designado por suerte el clan de Matrí. La suerte cayó, finalmente, sobre Saúl, hijo de Quis. Lo buscaron, pero no lo encontraban."
,"22":"Entonces consultaron al Señor: '¿Ha venido aquí Saúl?'. Y el Señor respondió: 'Está ahí, escondido entre los bagajes'."
,"23":"Fueron corriendo a sacarle de allí, y se presentó en medio del pueblo. Y sobresalía por encima de todo el pueblo de los hombros para arriba."
,"24":"Samuel dijo a todo el pueblo: 'Mirad al elegido del Señor. No hay nadie como él en todo el pueblo'. Y todo el pueblo gritó: '¡Viva el rey!'."
,"25":"Entonces Samuel expuso al pueblo el derecho real y lo escribió en un libro que está ante el Señor. Después ordenó que cada cual se fuese a su casa."
,"26":"También Saúl se fue a su casa, a Guibeá; y con él se fueron los valientes a los que Dios había tocado el corazón."
,"27":"Pero unos malvados dijeron: '¿Y éste es el que nos va a salvar?'. Lo despreciaron y no le rindieron honores. Mas Saúl ni se dio por enterado."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Un mes después, Najás, el amonita, fue a atacar a Yabés Galaad. Todas las gentes de Yabés le dijeron: 'Haz un pacto con nosotros y estaremos sometidos a ti'."
,"2":"Najás les respondió: 'Haré un pacto con vosotros con la condición de sacaros a todos el ojo derecho para imponer esta afrenta a todo Israel'."
,"3":"Los ancianos de Yabés le dijeron: 'Danos una tregua de siete días. Enviaremos mensajeros a todo el territorio de Israel; y si nadie viene a socorrernos, nos rendiremos a ti'."
,"4":"Los mensajeros llegaron a Guibeá de Saúl y expusieron estas cosas al pueblo, y todo el pueblo se puso a gritar y a llorar."
,"5":"En esto, llegó Saúl del campo detrás de los bueyes, y preguntó: '¿Qué pasa? ¿Por qué lloran?'. Entonces le contaron lo que decían los hombres de Yabés."
,"6":"Al oír Saúl estas cosas, el espíritu de Dios se apoderó de él y se encendió en cólera."
,"7":"Tomó un par de bueyes, los hizo pedazos y los envió a todo el territorio de Israel por medio de los mensajeros, diciendo: 'Así serán tratados los bueyes de todo aquel que no siga a Saúl'. Entonces el temor del Señor cayó sobre todo el pueblo y salieron como un solo hombre."
,"8":"Les pasó revista en Bézec. Eran trescientos mil de Israel y treinta mil de Judá."
,"9":"Luego dijo a los mensajeros que habían venido: 'Anunciad a las gentes de Yabés Galaad que mañana al mediodía les llegará el socorro'. Llegaron los mensajeros y se lo anunciaron a las gentes de Yabés, que se llenaron de alegría."
,"10":"Los de Yabés dijeron a Najás: 'Mañana nos rendiremos a vosotros y haréis de nosotros lo que os parezca'."
,"11":"Al día siguiente Saúl dividió al pueblo en tres cuerpos, que penetraron en el campamento antes del amanecer y estuvieron matando amonitas hasta el mediodía. Los supervivientes se dispersaron, hasta el punto de no quedar dos juntos."
,"12":"El pueblo dijo a Samuel: '¿Quién es el que decía que Saúl no iba a reinar sobre nosotros? Entréganos a esos hombres para matarlos'."
,"13":"Pero Saúl dijo: 'Hoy no se castigará a nadie con la muerte, porque hoy el Señor ha salvado a Israel'."
,"14":"Samuel dijo al pueblo: 'Venid, vamos a Guilgal a inaugurar allí la monarquía'."
,"15":"Fueron a Guilgal y allí, ante la presencia del Señor, proclamaron rey a Saúl y ofrecieron al Señor sacrificios de reconciliación. Y Saúl y todos los israelitas hicieron una gran fiesta."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Samuel dijo a los israelitas: 'Os he concedido todo lo que me habéis pedido y he puesto sobre vosotros un rey."
,"2":"Así que ahí tenéis al rey que os va a dirigir. Yo he envejecido y encanecido, y mis hijos están entre vosotros. He caminado delante de vosotros desde mi juventud hasta hoy."
,"3":"Aquí me tenéis; acusadme ante el Señor y ante su ungido si he quitado a alguien un buey o he robado a alguien un asno, si he oprimido o perjudicado a alguien o me he dejado sobornar. Acusadme, y yo os responderé'."
,"4":"Y respondieron: 'No nos has perjudicado ni oprimido, ni te has dejado sobornar'."
,"5":"Él les dijo: 'El Señor y su ungido son hoy testigos de que no habéis encontrado nada malo en mis manos'. Y respondieron: 'Testigos'."
,"6":"Samuel dijo al pueblo: 'Testigo es el Señor, que suscitó a Moisés y Aarón y sacó a vuestros padres de Egipto."
,"7":"Ahora, acercaos. Quiero juzgaros ante el Señor y recordaros los beneficios que os ha hecho a vosotros y a vuestros padres."
,"8":"Cuando Jacob y sus hijos bajaron a Egipto, los egipcios los oprimieron, y vuestros padres clamaron al Señor. El Señor envió a Moisés y Aarón, que los sacaron de Egipto y los instalaron en esta tierra."
,"9":"Pero ellos se olvidaron del Señor, su Dios, y él los entregó en manos de Sísara, jefe de los ejércitos de Jasor, en manos de los filisteos y en manos del rey de Moab, que les hicieron la guerra."
,"10":"Ellos clamaron al Señor: Hemos pecado, porque hemos abandonado al Señor y hemos servido a los baales y astartés; sálvanos del poder de nuestros enemigos y te serviremos."
,"11":"El Señor mandó a Yerubaal, a Barac, Jefté y Samuel, y os libró de la mano de vuestros vecinos enemigos, y habéis podido vivir seguros."
,"12":"Sin embargo, cuando visteis que Najás, rey de los amonitas, venía contra vosotros, me dijisteis: No, que reine un rey sobre nosotros, siendo así que el Señor, vuestro Dios, es vuestro rey."
,"13":"Pues bien, ahí tenéis al rey que habéis elegido. El Señor ha puesto un rey sobre vosotros."
,"14":"Si respetáis al Señor y le servís, si le obedecéis y no os rebeláis contra sus preceptos, si vosotros y el rey que os gobierna seguís al Señor, viviréis;"
,"15":"pero si no le obedecéis y os rebeláis contra sus preceptos, la mano del Señor descargará sobre vosotros y sobre vuestro rey."
,"16":"Estad atentos y ved este gran prodigio que el Señor va a hacer ante vuestros ojos."
,"17":"¿No estamos en el tiempo de la siega del trigo? Pues bien, voy a invocar al Señor y él mandará truenos y lluvia, para que sepáis y veáis el gran mal que le habéis hecho a los ojos del Señor al pedir para vosotros un rey'."
,"18":"Samuel invocó al Señor, y el Señor envió aquel día truenos y lluvia; y todo el pueblo tuvo gran miedo del Señor y de Samuel."
,"19":"Entonces todo el pueblo dijo a Samuel: 'Ruega al Señor, tu Dios, por tus siervos para que no muramos, porque hemos añadido a todos nuestros pecados la gran maldad de pedir para nosotros un rey'."
,"20":"Samuel les dijo: 'No tengáis miedo; es verdad que habéis cometido esa gran maldad; pero ahora no os apartéis del Señor y servidle con todo vuestro corazón."
,"21":"No os apartéis de él para servir a cosas vanas, que no ayudan y no salvan, porque son cosas vanas."
,"22":"El Señor no rechazará a su pueblo por la gloria de su gran nombre, porque el Señor se ha dignado hacer de vosotros su pueblo."
,"23":"Por mi parte, lejos de mí pecar contra el Señor dejando de rogar por vosotros y de enseñaros el camino bueno y recto."
,"24":"Respetad al Señor y servidle sinceramente con todo vuestro corazón, considerando las grandes cosas que ha hecho por vosotros."
,"25":"Pero si os portáis mal, pereceréis vosotros y vuestro rey."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Saúl tenía... años cuando comenzó a reinar, y reinó veintidós años sobre Israel."
,"2":"Saúl eligió tres mil hombres de Israel; dos mil estaban con él en Micmás y en la montaña de Betel, y mil con Jonatán en Guibeá de Benjamín; a los demás los mandó cada uno a su casa."
,"3":"Jonatán derrotó la guarnición de los filisteos que estaban en Guibeá. Los filisteos, al saberlo, se dijeron: 'Los hebreos se han sublevado'. Mientras tanto Saúl hizo sonar la trompeta en todo el país,"
,"4":"y todo Israel supo la noticia: Saúl ha derrotado a la guarnición de los filisteos, e Israel se ha hecho odioso a los filisteos. Y todo el pueblo se reunió con Saúl en Guilgal."
,"5":"Los filisteos se reunieron para luchar contra Israel con tres mil carros, seis mil jinetes y un ejército tan numeroso como la arena de la ribera del mar. Subieron y acamparon en Micmás, al oriente de Bet Avén."
,"6":"Los israelitas se vieron en las últimas, pues estaban cercados, y el pueblo se escondió en las grutas, en las cavernas, entre las rocas, en subterráneos y en cisternas;"
,"7":"algunos pasaron, atravesando el Jordán, al país de Gad y de Galaad. Saúl estaba todavía en Guilgal, y todo el pueblo que le seguía estaba lleno de miedo. "
,"8":"Él esperó siete días, el tiempo prefijado por Samuel; pero Samuel no llegaba a Guilgal y el pueblo se dispersaba lejos de Saúl."
,"9":"Entonces Saúl dijo: 'Traedme el holocausto y los sacrificios de reconciliación'. Y ofreció el holocausto."
,"10":"Cuando terminaba de ofrecer el holocausto, llegó Samuel, y Saúl salió a su encuentro para saludarle."
,"11":"Samuel le dijo: '¿Qué has hecho?'. Saúl respondió: 'Al ver que el pueblo se dispersaba lejos de mí y tú no llegabas en el día prefijado y que los filisteos se habían reunido en Micmás,"
,"12":"me dije: Ahora bajarán los filisteos contra mí a Guilgal, y yo no he aplacado al Señor. Entonces, violentándome, ofrecí el holocausto'."
,"13":"Samuel le respondió: '¡Has obrado neciamente! Si hubieras observado el mandamiento que el Señor, tu Dios, te había dado, entonces el Señor habría consolidado por siempre tu realeza sobre Israel."
,"14":"Pero ahora tu realeza no durará; el Señor se ha buscado un hombre según su corazón y le ha destinado para rey de su pueblo, porque tú no has observado lo que el Señor te ha mandado'."
,"15":"Samuel se levantó y se fue de Guilgal para seguir su camino. El resto del pueblo le siguió al encuentro del enemigo, y llegaron desde Guilgal a Guibeá de Benjamín. Saúl pasó revista al ejército que le seguía; eran como unos seiscientos hombres."
,"16":"Saúl, su hijo Jonatán y el ejército que les seguía se quedaron en Guibeá de Benjamín; los filisteos estaban acampados en Micmás."
,"17":"Del campamento de los filisteos salió la fuerza de choque dividida en tres bandas: una tomó el camino de Ofrá, hacia la tierra de Sual;"
,"18":"otra el camino de Bejorón, y la tercera el camino del alto que domina el valle de Seboín, hacia el desierto."
,"19":"En todo el territorio de Israel no había ni un herrero, porque los filisteos se habían dicho: '¡Que los hebreos no puedan fabricarse espadas ni lanzas!'."
,"20":"Por eso los israelitas tenían que ir a los filisteos para afilar cada uno su reja, su azadón, su sierra y su hoz."
,"21":"El precio era de dos tercios de siclo por las rejas y azadones y un tercio de siclo por afilar las sierras y las hoces."
,"22":"Por eso cuando llegó el día del combate ninguno de los que seguían a Saúl y Jonatán tenía espada o lanza. Sólo la tenían ellos dos."
,"23":"Una guarnición de filisteos salió hacia el paso de Micmás."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Un día, Jonatán, hijo de Saúl, dijo a su escudero: 'Ven, pasemos hasta la guarnición de los filisteos, que está al otro lado'. Pero no dijo nada a su padre."
,"2":"Saúl estaba sentado en el límite de Guibeá, debajo del granado que hay en Migrón; le acompañaban unos seiscientos hombres."
,"3":"Ajías, hijo de Ajitub, hermano de Icabod, hijo de Fineés, hijo de Elí, sacerdote del Señor en Silo, llevaba el efod. La gente no sabía que Jonatán se había ido."
,"4":"Jonatán intentaba llegar hasta la guarnición de los filisteos; tenía que pasar por entre dos peñascos llamados Boses y Sené,"
,"5":"uno al norte, frente a Micmás, y el otro al sur, frente a Guibeá."
,"6":"Jonatán dijo a su escudero: 'Vamos, pasemos a la guarnición de estos incircuncisos. Quién sabe lo que el Señor hará por nosotros, porque nada impide al Señor dar la victoria con muchos o pocos'."
,"7":"Su escudero le respondió: 'Haz lo que piensas; vamos donde quieras; estoy contigo'."
,"8":"Jonatán replicó: 'Vamos a pasar hasta esos hombres y dejarnos ver de ellos."
,"9":"Si nos echan el alto, nos quedaremos quietos en el mismo sitio y no subiremos hacia ellos."
,"10":"Pero si nos dicen que subamos, lo haremos, pues eso será la señal de que el Señor los ha entregado en nuestras manos'."
,"11":"Ellos se dejaron ver de la guarnición de los filisteos, y éstos se dijeron: 'Los hebreos salen de las cuevas donde se habían escondido'."
,"12":"Y las gentes de la guarnición, dirigiéndose a Jonatán y a su escudero, les dijeron: 'Subid aquí, porque tenemos que contaros una cosa'. Entonces Jonatán dijo a su escudero: 'Sube detrás de mí, porque el Señor los ha entregado en manos de Israel'."
,"13":"Jonatán, trepando con pies y manos, subió seguido de su escudero. Los filisteos caían ante Jonatán, y su escudero los remataba."
,"14":"Esta primera matanza que hicieron Jonatán y su escudero fue como de unos veinte hombres en el espacio de una media yugada."
,"15":"Entonces cundió el pánico en el campamento y fuera de él, en la guarnición y en la fuerza de choque. La tierra tembló y se produjo un pánico sobrehumano."
,"16":"Los centinelas de Saúl que estaban en Guibeá de Benjamín vieron que el campamento se dispersaba en todas las direcciones."
,"17":"Saúl dijo al pueblo que estaba con él: 'Pasad revista y ved quién falta de los nuestros'. Pasaron revista y vieron que faltaban Jonatán y su escudero."
,"18":"Saúl dijo a Ajías: 'Trae el efod' (porque aquel día era él quien llevaba el efod ante Israel)."
,"19":"Mientras Saúl hablaba con el sacerdote, el tumulto iba creciendo en el campamento de los filisteos. Saúl dijo al sacerdote: 'Retira tu mano'."
,"20":"Saúl y toda su gente se reunieron y avanzaron hasta el lugar del combate y vieron que la confusión era enorme, pues volvían su espada unos contra los otros."
,"21":"Los hebreos que estaban antes con los filisteos y habían subido con ellos al campamento se volvieron también para ponerse al lado de los israelitas que estaban con Saúl y Jonatán."
,"22":"Y todos los israelitas que se habían escondido en la montaña de Efraín, al oír que los filisteos habían huido, se pusieron también a perseguirlos."
,"23":"Así el Señor salvó aquel día a Israel. La batalla se extendió hasta Bejorón."
,"24":"Los israelitas estaban agotados. Entonces Saúl hizo prestar al pueblo este juramento: 'Maldito el hombre que tome alimento antes de la tarde, hasta que yo me haya vengado de mis enemigos'. Y nadie comió nada."
,"25":"Todo el pueblo llegó al bosque, donde había mucha miel en el suelo."
,"26":"El pueblo entró en el bosque y vio la miel que corría por el suelo, pero nadie llevó la mano a su boca, porque temían el juramento que habían hecho."
,"27":"Pero Jonatán no había oído el juramento que su padre hizo prestar al pueblo; y, alargando la punta del bastón que tenía en la mano, lo metió en un panal de miel, se lo llevó a la boca y sus ojos se iluminaron."
,"28":"Y le dijo uno: 'Tu padre ha hecho prestar este juramento a todo el pueblo: ¡Maldito el hombre que tome alimento hoy!'."
,"29":"Jonatán respondió: 'Mi padre ha causado mucho mal al país; mirad cómo mis ojos se han iluminado cuando yo he gustado un poco de miel."
,"30":"Seguro que si el pueblo hubiese comido hoy del botín que encontró entre sus enemigos, la derrota de los filisteos hubiese sido mayor'."
,"31":"Aquel día derrotaron a los filisteos desde Micmás hasta Ayalón, pero el pueblo estaba desfallecido."
,"32":"El pueblo se echó sobre el botín; se apoderaron de ovejas, bueyes y terneros; los degollaron en el suelo, y comieron la carne con la sangre."
,"33":"Se lo fueron a decir a Saúl: 'Mira, el pueblo ha pecado contra el Señor comiendo la carne con la sangre'. Él les dijo: 'Rodad hacia mí una piedra grande'."
,"34":"Y añadió: 'Dispersaos entre el pueblo y decidle que cada uno traiga su buey y su oveja y los sacrifiquen aquí; después los comeréis sin pecar contra el Señor comiendo la carne con la sangre'. Aquella noche cada uno llevó lo que tenía a mano y lo sacrificó allí."
,"35":"Y Saúl levantó un altar al Señor; fue el primer altar que levantó al Señor."
,"36":"Después dijo Saúl: 'Bajemos esta noche a perseguir y a saquear a los filisteos hasta despuntar el alba sin dejar a uno vivo'. Le respondieron: 'Haz lo que quieras'. Pero el sacerdote dijo: 'Antes, consultemos a Dios'."
,"37":"Saúl consultó a Dios: '¿Debo bajar contra los filisteos? ¿Los pondrás en manos de Israel?'. Pero aquel día no le respondió."
,"38":"Entonces dijo: 'Acercaos aquí todos los jefes del pueblo, investigad y ved quién ha cometido el pecado de hoy."
,"39":"Porque, vive el Señor, el salvador de Israel, que, aunque se trate de mi hijo Jonatán, morirá irremisiblemente'. Ninguno de entre el pueblo respondió nada."
,"40":"Y dijo a todo Israel: 'Poneos vosotros de un lado, y yo y mi hijo Jonatán nos pondremos del otro'. El pueblo respondió: 'Haz lo que quieras'."
,"41":"Saúl dijo entonces al Señor: '¿Por qué no has respondido hoy a tu siervo? Si el pecado está en mí o en mi hijo Jonatán, Señor, Dios de Israel, salga cara; y si este pecado está en tu pueblo Israel, salga cruz'. Fueron designados por la suerte Jonatán y Saúl, y el pueblo quedó libre."
,"42":"Saúl dijo: 'Echad la suerte entre mí y mi hijo Jonatán'. Y fue designado por la suerte Jonatán."
,"43":"Saúl preguntó a Jonatán: 'Dime qué has hecho'. Jonatán respondió: 'He gustado solamente un poco de miel con la punta del bastón que tenía en mi mano. Aquí estoy dispuesto a morir'."
,"44":"Saúl dijo: 'Que Dios me castigue si no mueres, Jonatán'."
,"45":"Entonces el pueblo dijo a Saúl: '¿Va a morir Jonatán, que ha hecho esta gran liberación en Israel? ¡Lejos de nosotros! Vive el Señor que no caerá a tierra un solo cabello de su cabeza, porque hoy ha actuado Dios con él'. Así salvó el pueblo a Jonatán y no murió."
,"46":"Saúl dejó de perseguir a los filisteos, y los filisteos regresaron a su país."
,"47":"Una vez que Saúl tomó posesión del reino de Israel, hizo la guerra a todos sus enemigos de alrededor: Moab, los amonitas, Edón, el rey de Sobá y los filisteos. Y siempre salía victorioso."
,"48":"Hizo verdaderas proezas. Derrotó a Amalec y libró a Israel de las bandas de salteadores."
,"49":"Los hijos de Saúl fueron: Jonatán, Isbaal y Malquisúa; los nombres de sus hijas eran: Merab, la mayor, y Mical, la más pequeña."
,"50":"La mujer de Saúl se llamaba Ajinoán, hija de Ajimaas; y el general de su ejército se llamaba Abner, hijo de Ner, tío de Saúl."
,"51":"Quis, padre de Saúl, y Ner, padre de Abner, eran hijos de Abiel."
,"52":"Durante toda la vida de Saúl hubo una guerra encarnizada contra los filisteos. Saúl se hacía con todos los hombres fuertes y valientes que veía."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Samuel dijo a Saúl: 'El Señor me ha enviado para ungirte rey sobre mi pueblo, Israel. Escucha las palabras del Señor."
,"2":"Esto dice el Señor todopoderoso: He resuelto castigar lo que Amalec hizo a Israel cuando le cerró el camino al subir de Egipto."
,"3":"Anda, castiga a Amalec y destruye sin piedad todas sus cosas; mata hombres y mujeres, mayores y pequeños, bueyes y ovejas, camellos y asnos'."
,"4":"Saúl convocó al pueblo y le pasó revista en Telán: doscientos mil de infantería y diez mil hombres de Judá."
,"5":"Saúl avanzó hasta la ciudad de Amalec y puso una emboscada en el valle."
,"6":"Entonces dijo a los quenitas: 'Id, retiraos, salid de en medio de Amalec, para que no os destruya juntamente con ellos, porque vosotros tratasteis bien a los israelitas cuando subían de Egipto'. Y los quenitas se retiraron de en medio de Amalec."
,"7":"Saúl derrotó a Amalec desde Javilá hasta la entrada de Sur, frente a Egipto."
,"8":"Capturó vivo a Agag, rey de Amalec, y a todo el pueblo lo pasó a espada."
,"9":"Pero Saúl y su ejército perdonaron la vida a Agag y a lo mejor de las ovejas y de las vacas, a las más gordas y a los corderos; es decir, respetaron todo lo de valor, pero destruyeron lo que no valía nada."
,"10":"El Señor dijo a Samuel:"
,"11":"'Me arrepiento de haber hecho a Saúl rey de Israel, porque se ha apartado de mí y no ha cumplido mis órdenes'. Samuel se entristeció y estuvo toda la noche rogando al Señor."
,"12":"En cuanto se levantó por la mañana, salió al encuentro de Saúl. Pero le dijeron que Saúl se había ido al Carmelo, que se había levantado allí un monumento, y que, a su regreso, había bajado a Guilgal."
,"13":"Samuel llegó donde estaba Saúl, el cual le dijo: '¡El Señor te bendiga! ¡He cumplido la orden del Señor!'."
,"14":"Samuel preguntó: '¿Qué es ese balar de ovejas que llega a mis oídos y el mugir de vacas que oigo?'."
,"15":"Saúl respondió: 'Han sido traídos de Amalec, porque el pueblo ha perdonado lo mejor de las ovejas y de las vacas para ofrecerlo en sacrificio al Señor, tu Dios; lo demás lo hemos destruido'."
,"16":"Samuel dijo a Saúl: 'Cállate y déjame exponerte lo que el Señor me ha revelado esta noche'. Él le dijo: 'Dime'."
,"17":"Samuel prosiguió: '¿No es cierto que siendo tú bien poca cosa has llegado a ser jefe de todas las tribus de Israel? El Señor te ungió por rey de Israel."
,"18":"El Señor te mandó a esta expedición y te ordenó: Anda y destruye a esos pecadores amalecitas, y hazles la guerra hasta acabar con ellos."
,"19":"¿Por qué no has obedecido la orden del Señor? ¿Por qué te has echado sobre el botín, haciendo lo que desagrada al Señor?'."
,"20":"Saúl le respondió: '¡Yo he obedecido al Señor! Fui a la expedición a la que él me mandó; he traído a Agag, rey de Amalec, y he exterminado a los amalecitas."
,"21":"Pero el pueblo se quedó con el botín, ovejas y vacas, lo mejor de lo consagrado al exterminio, para ofrecerlo en sacrificio al Señor en Guilgal'."
,"22":"Samuel respondió: '¿Se complace tanto el Señor en los holocaustos y sacrificios como en la obediencia a sus palabras? La obediencia vale más que el sacrificio, y la docilidad más que las grasas de los carneros."
,"23":"La desobediencia es un pecado de magia, y la resistencia, un crimen de idolatría. Porque has rechazado la palabra del Señor, él te rechaza a ti como rey'."
,"24":"Saúl dijo a Samuel: 'He pecado traspasando la orden del Señor y tus palabras, porque temí al pueblo y accedí a sus palabras."
,"25":"Ahora yo te suplico que perdones mi falta; vuelve a estar conmigo, y yo adoraré al Señor'."
,"26":"Samuel le respondió: 'No volveré a estar contigo, porque has rechazado la orden del Señor y el Señor te ha rechazado a ti para que no seas rey sobre Israel'."
,"27":"Samuel se dio la vuelta para marcharse, y Saúl le agarró por la orla del manto, que se rompió."
,"28":"Samuel le dijo: 'El Señor arranca hoy de ti tu reinado sobre Israel y se lo dará a un vecino tuyo, que es mejor que tú."
,"29":"Y aquel que es la gloria de Israel no miente ni se arrepiente, porque él no es un hombre para arrepentirse'."
,"30":"Saúl contestó: 'He pecado; pero ahora, por favor, ríndeme honores ante los ancianos de mi pueblo y ante Israel y vuelve conmigo para que yo adore al Señor, tu Dios'."
,"31":"Samuel volvió con Saúl, y éste adoró al Señor."
,"32":"Samuel dijo: 'Traedme aquí a Agag, rey de Amalec'. Agag se acercó temblando y diciendo: '¡Qué amarga es la muerte!'."
,"33":"Y dijo Samuel: 'Como tu espada ha dejado sin hijos a tantas mujeres, así tu madre entre todas quedará privada de su hijo'. Samuel mató a Agag ante el Señor en Guilgal."
,"34":"Después Samuel se fue a Ramá, y Saúl a su casa, a Guibeá de Saúl."
,"35":"Samuel no volvió a ver a Saúl hasta el día de su muerte. Samuel lloraba por Saúl porque el Señor se había arrepentido de haber hecho a Saúl rey de Israel."
}`)
	CurrentBook.AddChapter(16, `{
"1":"El Señor dijo a Samuel: '¿Hasta cuándo vas a estar llorando por Saúl, siendo así que yo lo he rechazado como rey de Israel? Llena tu cuerno de aceite. Yo te envío a casa de Jesé, de Belén, porque me he elegido un rey entre sus hijos'."
,"2":"Samuel dijo: '¿Cómo voy a ir? Cuando se entere Saúl, me matará'. El Señor le contestó: 'Lleva contigo una ternera, y dirás: He venido a ofrecer un sacrificio al Señor."
,"3":"Invitarás a Jesé al sacrificio, y yo te indicaré lo que debes hacer: Me ungirás al que yo diga'."
,"4":"Samuel hizo lo que el Señor le había mandado. Cuando llegó a Belén, los ancianos de la ciudad salieron temblando a su encuentro y le dijeron: '¿Traes la paz?'."
,"5":"Él respondió: 'La paz. He venido a ofrecer un sacrificio al Señor. Purificaos y venid conmigo al sacrificio'. Y él purificó a Jesé y a sus hijos y los invitó al sacrificio."
,"6":"Cuando llegaron y vio a Eliab, se dijo: 'Seguramente que el Señor tiene delante a su ungido'."
,"7":"El Señor dijo a Samuel: 'No consideres su aspecto ni su alta estatura, porque yo lo he descartado. El hombre no ve lo que Dios ve; el hombre ve las apariencias, y Dios ve el corazón'."
,"8":"Jesé llamó a Abinadab y le hizo pasar por delante de Samuel, que dijo: 'Tampoco es éste el elegido del Señor'."
,"9":"Jesé hizo pasar a Sammá, pero Samuel dijo: 'Tampoco es éste el elegido del Señor'."
,"10":"Jesé hizo pasar a sus siete hijos ante Samuel. Y Samuel le dijo: 'El Señor no ha elegido a ninguno de ellos'."
,"11":"Entonces Samuel preguntó a Jesé: '¿Están aquí todos tus muchachos?'. Él contestó: 'Falta el pequeño, que está guardando ovejas'. Samuel le dijo: 'Manda a buscarle, pues no nos sentaremos a la mesa hasta que haya venido'."
,"12":"Jesé mandó a buscarle. Era rubio, de buen aspecto y de buena presencia. Y el Señor dijo: 'Levántate y úngele, porque es éste'."
,"13":"Samuel tomó el cuerno del aceite y le ungió en presencia de sus hermanos. El espíritu del Señor se apoderó de David a partir de aquel día. Samuel se fue y volvió a Ramá."
,"14":"El espíritu del Señor se había retirado de Saúl, y un espíritu maligno, enviado por el Señor, se apoderó de él."
,"15":"Entonces los servidores de Saúl le dijeron: 'Un espíritu maligno, enviado por Dios, se apodera de ti."
,"16":"Da una orden, y tus siervos, que están a tu servicio, buscarán a un hombre que sepa tocar la cítara; cuando venga sobre ti el espíritu maligno, tocará con su mano, y tú mejorarás'."
,"17":"Saúl contestó a sus servidores: 'Buscadme un hombre que toque bien y traédmelo'."
,"18":"Uno de los jóvenes le dijo: 'Yo conozco a un hijo de Jesé, el de Belén, que toca muy bien la cítara; es valiente y hombre de guerra, sabio en sus palabras, de buena presencia, y el Señor está con él'."
,"19":"Saúl envió mensajeros a decir a Jesé: 'Mándame a tu hijo David, el que está con las ovejas'."
,"20":"Jesé tomó cinco panes, un odre de vino y un cabrito y se lo mandó a Saúl por medio de su hijo David."
,"21":"David se presentó a Saúl y se puso a su servicio. Saúl le tomó mucho cariño y le hizo su escudero."
,"22":"Saúl mandó decir a Jesé: 'Te suplico que David se quede a mi servicio, porque me agrada mucho'."
,"23":"Y así, cuando el espíritu maligno asaltaba a Saúl, David tomaba la cítara y tocaba; entonces Saúl se calmaba, mejoraba y el espíritu maligno se alejaba de él."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Los filisteos reunieron sus tropas para la guerra; se concentraron en Soco, que pertenece a Judá, y pusieron su campamento entre Soco y Azeca, en Efes Damín."
,"2":"Saúl y los israelitas se reunieron también, acamparon en el valle del Terebinto y se pusieron en orden de batalla frente a los filisteos."
,"3":"Por un lado estaban los filisteos en la montaña, y al lado opuesto estaban los de Israel; había un valle entre ellos."
,"4":"Entonces salió de las filas de los filisteos un campeón llamado Goliat, de Gat, cuya estatura era de unos tres metros."
,"5":"Llevaba sobre su cabeza un casco de bronce y vestía una coraza de malla, también de bronce, que pesaba sesenta kilos."
,"6":"Llevaba en las piernas unas polainas de bronce, y una jabalina, también de bronce, a la espalda."
,"7":"El asta de su lanza era como el enjullo del tejedor, y su punta de hierro pesaba unos siete kilos. Marchaba delante de él su escudero."
,"8":"Se detuvo y gritó a las filas de Israel: '¿Por qué habéis salido para poneros en orden de batalla? ¿No soy yo filisteo y vosotros servidores de Saúl? Escoged vosotros un hombre para que venga a luchar conmigo."
,"9":"Si es capaz de vencerme y me mata, entonces seremos vuestros siervos; pero si le venzo yo y le mato, vosotros quedaréis sometidos a nosotros y nos serviréis'."
,"10":"Y añadió: 'Yo desafío hoy a las filas de Israel; dadme un hombre para que luche conmigo'."
,"11":"Cuando Saúl y todo Israel oyeron estas palabras del filisteo, quedaron consternados y se llenaron de miedo."
,"12":"David era el hijo de un efrateo de Belén de Judá, llamado Jesé, que tenía ocho hijos. Este hombre, en tiempos de Saúl, era ya viejo, muy entrado en años."
,"13":"Los tres hijos mayores de Jesé habían marchado a la guerra con Saúl; el mayor se llamaba Eliab, el segundo Abinadab y el tercero Sammá."
,"14":"David era el más pequeño. Los tres mayores habían seguido a Saúl."
,"15":"David iba y venía del campamento a Belén para apacentar las ovejas de su padre."
,"16":"El filisteo se acercaba por la mañana y por la tarde, y así durante cuarenta días."
,"17":"Jesé dijo a su hijo David: 'Toma unos cuarenta y cinco kilos de trigo tostado y estos diez panes para tus hermanos y llévaselos de prisa al campamento."
,"18":"Estos diez quesos se los llevas al comandante. Te interesas por la salud de tus hermanos y tomarás de ellos una prenda."
,"19":"Ellos están con Saúl y con todos los israelitas en el valle del Terebinto luchando con los filisteos'."
,"20":"David se levantó de madrugada, dejó las ovejas al cuidado de un pastor, tomó su carga y partió, como se lo había mandado Jesé. Llegó al campamento cuando el ejército salía para tomar posiciones, lanzando gritos de guerra."
,"21":"Los israelitas y los filisteos se dispusieron en orden de batalla, ejército contra ejército."
,"22":"David dejó su carga en manos de un guardián del bagaje, corrió hacia las filas y, cuando llegó, preguntó a sus hermanos cómo se encontraban."
,"23":"Cuando estaba hablando con ellos, el campeón, llamado Goliat, de Gat, salió de las filas de los filisteos y repitió las mismas palabras. David las oyó."
,"24":"Todos los israelitas, al ver a aquel hombre, huían de él y tenían mucho miedo."
,"25":"Un israelita dijo: '¿Habéis visto a este hombre que avanza? Avanza a desafiar a Israel. Al hombre que le mate, el rey le colmará de riquezas, le dará su hija, y la casa de su padre quedará exenta de impuestos en Israel'."
,"26":"David preguntó a los que estaban a su lado: '¿Qué se hará con el que mate a este filisteo y quite esta ofensa de Israel? ¿Quién es este filisteo incircunciso que desafía al ejército del Dios vivo?'."
,"27":"Y la gente le respondía lo mismo: 'Esto se hará con el hombre que lo mate'."
,"28":"Eliab, su hermano mayor, oyó a David hablar con la gente, montó en cólera y le dijo: '¿Por qué has venido aquí? ¿A quién has dejado aquel pequeño rebaño en el desierto? Conozco bien tu orgullo y la malicia de tu corazón. Has venido sólo para ver la batalla'."
,"29":"David respondió: '¿Qué he hecho yo ahora? ¿Es que no puedo hablar?'."
,"30":"Y, dándole la espalda, se dirigió a otro. Preguntó lo mismo, y le respondieron como antes."
,"31":"Oyeron las palabras de David y se las contaron a Saúl, que lo mandó llamar."
,"32":"David dijo a Saúl: 'No se desanime mi señor. Tu siervo irá a luchar contra este filisteo'."
,"33":"Saúl le respondió: 'No puedes ir contra este filisteo y luchar con él, porque tú eres joven y él es hombre de guerra desde su juventud'."
,"34":"David le replicó: 'Cuando tu siervo apacentaba las ovejas de su padre y venía un león o un oso y se llevaba una oveja del rebaño,"
,"35":"yo lo perseguía, lo golpeaba y se la arrancaba de su boca. Si venía contra mí, lo agarraba por el cuello, lo golpeaba y lo mataba."
,"36":"Tu siervo ha matado al león y al oso. Ese filisteo incircunciso será como uno de ellos, porque ha desafiado a los ejércitos del Dios vivo'."
,"37":"Y añadió: 'El Señor, que me ha librado de las garras del león y del oso, me librará de las manos de ese filisteo'. Saúl dijo a David: '¡Vete, y que el Señor esté contigo!'."
,"38":"Saúl vistió a David con su armadura, puso sobre su cabeza un casco de bronce y le cubrió con una coraza."
,"39":"Le ciñó la espada sobre su armadura y David intentó en vano andar, porque no estaba entrenado. Y dijo a Saúl: 'No puedo andar con esto, porque no estoy entrenado'. Y se lo quitó de encima."
,"40":"David tomó su cayado, escogió en el torrente cinco piedras bien lisas y las metió en su zurrón de pastor; tomó la honda y avanzó hacia el filisteo."
,"41":"El filisteo se acercó más y más a David, precedido de su escudero."
,"42":"Miró el filisteo, vio a David y le despreció, porque era joven, rubio y de buena presencia."
,"43":"Y le dijo: '¿Te has creído que soy un perro, para venir contra mí con un cayado?'. Luego maldijo a David por sus dioses,"
,"44":"y le dijo: 'Ven acá, que yo daré tus carnes a las aves del cielo y a las bestias del campo'."
,"45":"David le respondió: 'Tú vienes contra mí con espada, lanza y venablo; pero yo voy contra ti en nombre del Señor todopoderoso, el Dios de los ejércitos de Israel, a quien tú has desafiado."
,"46":"Hoy el Señor te entregará en mis manos, te mataré, te cortaré la cabeza y hoy mismo daré tu cadáver y los cadáveres de los ejércitos filisteos, a las aves del cielo y a las bestias del campo, y todo el mundo sabrá que hay un Dios en Israel,"
,"47":"y todos reconocerán que no es por la espada ni por la lanza como el Señor da la victoria, porque la batalla es de Dios y os entregará en nuestras manos'."
,"48":"Cuando el filisteo se puso en movimiento y avanzó contra David, éste salió corriendo del campamento al encuentro del filisteo;"
,"49":"metió la mano en el zurrón y sacó de él una piedra, que lanzó con la honda. Hirió al filisteo en la frente. La piedra se clavó en su frente, y cayó de bruces en tierra."
,"50":"Así triunfó David del filisteo y le mató; no había espada en manos de David."
,"51":"David corrió, se detuvo ante el filisteo, tomó su espada y, sacándola de la vaina, le remató y le cortó la cabeza. Cuando los filisteos vieron muerto a su héroe, se dieron a la fuga. "
,"52":"Entonces los hombres de Israel y de Judá, lanzando gritos de guerra, persiguieron a los filisteos hasta la entrada de Gat y hasta las puertas de Ecrón. Y muchos filisteos cayeron muertos en el camino desde Saráyim hasta Gat y Ecrón."
,"53":"Los israelitas, al volver de la persecución contra los filisteos, saquearon sus campamentos."
,"54":"David tomó la cabeza del filisteo y la llevó a Jerusalén; las armas las puso en su propia tienda."
,"55":"Cuando Saúl vio a David salir al encuentro del filisteo, preguntó a Abner, jefe del ejército: '¿De quién es hijo este joven, Abner?'. Abner respondió: 'Por tu vida, oh rey, que no lo sé'."
,"56":"El rey le dijo: 'Pregunta tú de quién es hijo ese muchacho'."
,"57":"Cuando David volvía de matar al filisteo, Abner lo tomó y lo llevó ante Saúl, con la cabeza del filisteo en la mano."
,"58":"Saúl le preguntó: '¿De quién eres hijo, muchacho?'. David le respondió: 'Soy hijo de tu siervo Jesé, el de Belén'."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Cuando David terminó de hablar con Saúl, Jonatán quedó prendado de David, y Jonatán comenzó a amarlo como a sí mismo."
,"2":"Saúl le tomó consigo aquel día y no le dejó volver a casa de su padre."
,"3":"Jonatán estableció un pacto con David, porque le amaba como a sí mismo."
,"4":"Se quitó el manto que vestía y se lo dio a David, y su propia armadura, así como su espada, su arco y su cinturón."
,"5":"En todas las salidas a las que le enviaba Saúl, David tenía éxito. Por eso Saúl le puso al frente de sus hombres de guerra. Todo el pueblo le quería, incluso los oficiales de Saúl."
,"6":"Al volver David de la guerra después de dar muerte al filisteo, las mujeres salían de todas las ciudades de Israel, cantando y danzando ante el rey Saúl al son de tambores y arpas y con gritos de alegría;"
,"7":"danzaban y cantaban a coro: 'Saúl mató mil,y David diez mil'."
,"8":"Saúl se irritó mucho y, muy enojado, dijo: 'A David le dan diez mil y a mí me dan mil; ya no le falta más que el reino'."
,"9":"A partir de este día, Saúl miró a David con malos ojos."
,"10":"Al día siguiente un espíritu maligno enviado por Dios asaltó a Saúl, que andaba como loco por la casa. David se puso a tocar la cítara, como otros días. Saúl tenía una lanza en su mano"
,"11":"y la blandió, diciendo: 'Clavaré a David en la pared'. Pero David esquivó el golpe por dos veces."
,"12":"Saúl tenía miedo de David, porque el Señor estaba con él y se había retirado de Saúl."
,"13":"Saúl lo alejó de él y lo nombró comandante; David hacía expediciones al frente de la tropa."
,"14":"Tenía éxito en todas sus empresas y el Señor estaba con él."
,"15":"Viendo Saúl que tenía tan buen éxito, le temía;"
,"16":"pero todos en Israel y Judá querían a David, porque él dirigía todas sus actuaciones."
,"17":"Saúl dijo a David: 'Te voy a dar por mujer a mi hija mayor, Merab, a condición de que seas un valiente guerrero y combatas las batallas del Señor'. Saúl se decía: 'Que no caiga mi mano sobre él, sino la de los filisteos'."
,"18":"David le respondió: '¿Quién soy yo y quién es la familia de mi padre en Israel para que yo sea yerno del rey?'."
,"19":"Pero cuando llegó el momento de darle por esposa a Merab, se la dio a Adriel, de Mejolá."
,"20":"Mical, hija de Saúl, amaba a David; se lo dijeron a Saúl, y le agradó."
,"21":"Saúl se decía: 'Se la daré a él para que le sirva de lazo y la mano de los filisteos caiga sobre él'. Y Saúl dijo por segunda vez a David: 'Hoy serás mi yerno'."
,"22":"Saúl dio esta orden a sus siervos: 'Hablad en secreto a David y decidle: El rey te estima y todos sus servidores te aman; debes ser yerno del rey'."
,"23":"Los siervos de Saúl dijeron todo esto en secreto a David. David les respondió: '¿Os parece poca cosa llegar a ser yerno del rey? Yo soy poco y de baja condición'."
,"24":"Los siervos de Saúl le refirieron lo que David había dicho."
,"25":"Saúl repuso: 'Decid a David: El rey no quiere dote, sino cien prepucios de filisteos para venganza de los enemigos del rey'. Saúl tramaba hacer caer a David en manos de los filisteos."
,"26":"Los servidores de Saúl se lo dijeron, y a David le agradó esta proposición para llegar a ser yerno del rey."
,"27":"Antes de que se pasara el plazo fijado, David salió con sus gentes, mató a doscientos filisteos, llevó los prepucios y se los entregó al rey para ser su yerno. Y Saúl le dio por mujer a su hija Mical."
,"28":"Viendo Saúl que el Señor estaba con David y que todo Israel le apreciaba,"
,"29":"tuvo más miedo a David y fue su enemigo durante toda su vida."
,"30":"Los jefes de los filisteos hacían incursiones, y en todas ellas David obtenía mayor éxito que todos los demás servidores de Saúl. Y así su nombre se hizo muy famoso."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Saúl comunicó a su hijo Jonatán y a todos sus siervos su intención de hacer morir a David. Entonces Jonatán, que quería mucho a David,"
,"2":"le avisó: 'Mi padre, Saúl, trata de matarte; ponte en guardia mañana por la mañana; vete a un lugar oculto y escóndete."
,"3":"Yo saldré y estaré al lado de mi padre en el campo donde estás tú; hablaré de ti a mi padre para ver lo que piensa, y te informaré'."
,"4":"Jonatán habló bien de David a su padre Saúl. Y añadió: 'No peque el rey contra su siervo David, porque él no ha cometido falta alguna contra ti; al contrario, sus acciones te han sido sumamente útiles."
,"5":"Él expuso su propia vida, mató al filisteo y el Señor dio una gran victoria a todo Israel. Lo viste tú mismo y te alegraste. ¿Por qué quieres hacerte reo de sangre inocente, matando a David sin razón?'."
,"6":"Saúl escuchó las palabras de Jonatán e hizo este juramento: '¡Vive Dios que no morirá!'."
,"7":"Jonatán llamó a David y le refirió todo esto. Después le llevó ante Saúl, y David estuvo a su servicio como antes."
,"8":"Cuando comenzó de nuevo la guerra, David salió a campaña contra los filisteos; les infligió una gran derrota y se dieron a la fuga."
,"9":"Pero un espíritu maligno enviado por el Señor se apoderó de Saúl. Estaba sentado en su casa y tenía la lanza en su mano. David tocaba el arpa."
,"10":"Saúl intentó clavar a David en la pared con la lanza; pero David esquivó el golpe y la lanza se clavó en la pared. David huyó y se puso a salvo."
,"11":"Aquella misma noche Saúl mandó mensajeros a casa de David para montar vigilancia y matarlo por la mañana. Pero Mical, la mujer de David, le avisó: 'Si no te pones a salvo esta misma noche, mañana te matarán'."
,"12":"Mical descolgó a David por la ventana. Él salió huyendo y se puso a salvo."
,"13":"Tomó los ídolos familiares, los metió en la cama, puso en la cabecera una piel de cabra y los cubrió con un vestido."
,"14":"Cuando Saúl envió mensajeros para apoderarse de David, ella dijo: 'Está enfermo'."
,"15":"Saúl envió de nuevo a los mensajeros para visitar a David, con la orden siguiente: 'Traédmelo en la cama para matarle'."
,"16":"Los mensajeros entraron y se encontraron con los ídolos familiares en la cama y una piel de cabra en la cabecera."
,"17":"Saúl dijo a Mical: '¿Por qué me has engañado así, dejando huir a mi enemigo para que se pusiese a salvo?'. Mical respondió: 'Me dijo que me mataría si no le dajaba marchar'."
,"18":"David huyó y se puso a salvo. Fue a ver a Samuel, a Ramá, y le contó todo lo que Saúl había hecho. Después Samuel y David se fueron a vivir a Nayot."
,"19":"Cuando Saúl supo que David estaba en Nayot de Ramá,"
,"20":"envió mensajeros para que lo apresasen. Ellos vieron la comunidad de profetas profetizando. Samuel estaba al frente de ellos. Entonces el espíritu del Señor se apoderó de los mensajeros y se pusieron también ellos a profetizar."
,"21":"Se lo dijeron a Saúl, que mandó otros mensajeros; pero también ellos se pusieron a profetizar. Volvió a enviar Saúl por tercera vez otros mensajeros, pero también ellos se pusieron a profetizar."
,"22":"Entonces fue él mismo a Ramá y, cuando llegó a la cisterna de la era que se encuentra en la colina, preguntó: '¿Dónde están Samuel y David?'. Le respondieron: 'Están en Nayot de Ramá'."
,"23":"Desde allí fueron a Nayot de Ramá. Pero el espíritu del Señor se apoderó también de él y fue profetizando hasta su llegada a Nayot de Ramá."
,"24":"Allí se despojó también él de sus vestidos y profetizó en presencia de Samuel; después cayó desnudo en tierra y estuvo así todo el día y toda la noche. De ahí viene el dicho: '¿También Saúl entre los profetas?'."
}`)
	CurrentBook.AddChapter(20, `{
"1":"David huyó de Nayot de Ramá, fue a ver a Jonatán y le dijo: '¿Qué he hecho yo? ¿Cuál es mi falta? ¿Qué crimen he cometido contra tu padre para que atente contra mi vida?'."
,"2":"Él respondió: '¡Lejos de ti tal pensamiento! No morirás. Mira, mi padre no hace cosa alguna importante o insignificante sin manifestármela confidencialmente. ¿Por qué me iba a ocultar mi padre este asunto? No es posible'."
,"3":"David replicó: 'Tu padre sabe muy bien que yo soy tu amigo y se dice: Que no lo sepa Jonatán para que no se entristezca. Pero, por la vida del Señor y por tu vida, que estoy a un paso de la muerte'."
,"4":"Jonatán dijo a David: 'Dime lo que quieres que haga por ti'."
,"5":"David le respondió: 'Mira, mañana es la nueva luna y yo debería sentarme junto al rey para comer. Déjame ir, y estaré oculto en el campo hasta la tarde."
,"6":"Si tu padre me echa de menos, le dirás: David me pidió con insistencia que le permitiera hacer una escapada a Belén, su ciudad, porque celebran allí el sacrificio anual por el clan."
,"7":"Si dice: Está bien, tu siervo estará a salvo; pero si monta en cólera, es que ha decidido matarme."
,"8":"Anda, sé bueno conmigo, ya que hicimos un pacto ante el Señor. Si en mí hay culpa alguna, mátame tú mismo; ¿para qué llevarme hasta tu padre?'."
,"9":"Jonatán respondió: '¡Lejos de mí tal pensamiento! Si yo llego a saber que mi padre ha decidido matarte, ¿no te advertiría yo mismo?'."
,"10":"David preguntó a Jonatán: '¿Quién me comunicará si tu padre te da una respuesta dura?'."
,"11":"Jonatán dijo a David: 'Ven, salgamos al campo'. Y salieron los dos al campo."
,"12":"Jonatán dijo a David: '¡El Señor, Dios de Israel, sea testigo! Mañana a esta misma hora yo sondearé a mi padre. Si la cosa va bien para David y no mando a avisarte,"
,"13":"que el Señor castigue a Jonatán. Si mi padre ha decidido tu muerte, te lo haré saber confidencialmente y te dejaré marchar. Tú podrás ir sano y salvo, y que el Señor esté contigo como estuvo con mi padre."
,"14":"Si todavía vivo, entonces usa conmigo de la bondad del Señor; si he muerto,"
,"15":"no retires jamás de mi casa tu bondad; y cuando el Señor haya borrado de la tierra a todos los enemigos de David,"
,"16":"que el nombre de Jonatán subsista gracias a la casa de David, y que el Señor vengue a David de sus enemigos'."
,"17":"Jonatán reiteró su juramento a David por el amor que le tenía, pues le amaba como a sí mismo."
,"18":"Jonatán dijo: 'Mañana es la nueva luna y se te echará de menos, porque tu puesto estará vacío."
,"19":"Al tercer día se notará más tu ausencia; entonces vendrás al lugar en el que te escondiste el otro día y te sentarás junto a la piedra que tú sabes."
,"20":"Yo tiraré tres flechas del lado de acá, como si tirara al blanco."
,"21":"Entonces enviaré al mozo para que vaya a buscarlas. Si le digo: Mira, las flechas están del lado de acá de ti, entonces vienes, porque hay paz para ti y nada tienes que temer, vive Dios."
,"22":"Pero si yo digo al mozo: Mira, las flechas están del lado de allá de ti, entonces márchate, porque es el Señor el que quiere que te vayas."
,"23":"En cuanto a las palabras que hemos hablado tú y yo, Dios es nuestro testigo para siempre'."
,"24":"David se escondió en el campo. Cuando llegó la nueva luna, el rey se sentó a la mesa para comer."
,"25":"El rey estaba sentado en su sitio, según su costumbre, junto a la pared; Jonatán se puso enfrente; Abner se sentó al lado de Saúl, y el sitio de David estaba vacío."
,"26":"Saúl no dijo nada aquel día, porque pensaba: 'Tal vez no estará puro, no se habrá purificado'."
,"27":"Al día siguiente de la nueva luna, otra vez quedó vacío el sitio de David. Y Saúl preguntó a su hijo Jonatán: '¿Por qué no ha venido a comer el hijo de Jesé ni ayer ni hoy?'."
,"28":"Jonatán respondió: 'David me pidió con insistencia permiso para ir a Belén."
,"29":"Me dijo: Permíteme ir, porque tenemos un sacrificio de familia en la ciudad y mis hermanos me han reclamado. Si te parece bien, déjame hacer una escapada para ver a mis hermanos. Por eso no ha venido a la mesa del rey'."
,"30":"Entonces Saúl se encendió en cólera contra Jonatán y le dijo: '¡Hijo de mala madre! ¡Ya sabía yo que eres amigo del hijo de Jesé para tu vergüenza y para vergüenza de tu madre!"
,"31":"Porque mientras el hijo de Jesé viva sobre la tierra, ni tú, ni tu reino estaréis seguros. Ahora, mándalo llamar y tráemelo aquí, porque merece la muerte'."
,"32":"Jonatán le respondió: '¿Por qué tiene que morir? ¿Qué ha hecho?'."
,"33":"Entonces Saúl blandió su lanza contra él para herirle; y Jonatán, viendo que la muerte de David era cosa decidida por parte de su padre,"
,"34":"se levantó de la mesa encendido en cólera y no tomó alimento alguno el segundo día de la nueva luna, porque estaba apenado por David, ya que su padre lo había ultrajado."
,"35":"Al día siguiente por la mañana, Jonatán salió al campo, según el convenio que había hecho con David. Le acompañaba un muchacho joven."
,"36":"Y dijo al muchacho: 'Corre y búscame las flechas que voy a tirar'. Y mientras el muchacho iba corriendo, Jonatán lanzó una flecha más allá de él."
,"37":"Cuando el muchacho llegó al lugar donde estaba la flecha que había tirado Jonatán, éste gritó, diciendo: 'La flecha está más allá de ti'."
,"38":"Jonatán volvió a gritar al muchacho: 'Pronto, date prisa, no te detengas'. El muchacho recogió la flecha y se la llevó."
,"39":"El muchacho no comprendió nada, porque solamente conocían aquel asunto Jonatán y David."
,"40":"Jonatán entregó sus armas al muchacho que estaba con él y le dijo: 'Vete y llévalas a la ciudad'."
,"41":"El muchacho se marchó, y entonces David salió de junto al montón de piedras y se postró en tierra por tres veces. Después ambos se abrazaron y lloraron juntos largo tiempo."
,"42":"Jonatán dijo a David: 'Vete en paz. En cuanto al juramento que hemos hecho en nombre del Señor, que el Señor esté siempre entre tú y yo, entre mi descendencia y la tuya'."
}`)
	CurrentBook.AddChapter(21, `{
"1":"David se levantó y partió. Jonatán volvió a la ciudad."
,"2":"David llegó a Nob, donde el sacerdote Ajimélec. Ajimélec salió a su encuentro asustado y le dijo: '¿Por qué estás solo y no hay nadie contigo?'."
,"3":"David le respondió: 'El rey me ha dado esta orden: Que nadie conozca la misión que te confío y la orden que te he dado. Por eso he dado cita a mis hombres en tal lugar."
,"4":"Si tienes cinco panes a mano, dámelos, o lo que encuentres'."
,"5":"El sacerdote respondió: 'No tengo a mano pan ordinario; no hay más que pan santo, si es que tus hombres se han abstenido al menos de relaciones con mujeres'."
,"6":"David contestó: 'Seguro; siempre que salimos nos abstenemos de mujeres, aunque se trate de un viaje de carácter profano; con más razón hoy mis hombres están limpios'."
,"7":"Entonces el sacerdote le dio el pan santo, porque no había allí otro pan que el pan presentado al Señor, y ese mismo día se había retirado del altar para reemplazarlo por pan reciente."
,"8":"Aquel día estaba allí, retenido en el santuario del Señor, uno de los servidores de Saúl, llamado Doeg, idumeo, jefe de los portadores de Saúl."
,"9":"David dijo a Ajimélec: '¿No tienes a mano una lanza o una espada? Porque yo no traigo conmigo ni la espada ni mis armas, pues la orden del rey era urgente'."
,"10":"El sacerdote respondió: 'La espada de Goliat, el filisteo, a quien mataste en el valle del Terebinto; ahí está envuelta en un paño detrás del efod. Si quieres, puedes llevártela, porque aquí no hay más que ésa'. David respondió: 'Dámela; no hay otra como ella'."
,"11":"David se levantó y huyó aquel día lejos de Saúl, llegando a Aquís, rey de Gat."
,"12":"Los servidores dijeron a Aquís: '¿No es este David, el rey del país? ¿No es éste de quien se cantaba con danzas: Saúl mató mil,y David diez mil?'."
,"13":"David reflexionó sobre estas palabras y sintió gran miedo de Aquís, rey de Gat,"
,"14":"y se hizo el tonto y el loco delante de ellos; tocaba el tambor sobre los batientes de la puerta y dejaba caer la baba sobre su barba."
,"15":"Aquís dijo a sus servidores: 'Estáis viendo que es un loco. ¿Para qué me lo habéis traído?"
,"16":"¿Me faltan a mí locos, para que me traigáis éste a hacer locuras en mi propia casa?'."
}`)
	CurrentBook.AddChapter(22, `{
"1":"David se fue de allí y se refugió en la cueva de Adulán. Lo supieron sus hermanos y todos sus parientes, y fueron a reunirse con él."
,"2":"Se unieron a él todos los oprimidos, todos los que tenían deudas y todos los descontentos; David se hizo su jefe; llegaron a ser unos cuatrocientos hombres."
,"3":"De allí David fue a Mispá de Moab, y dijo al rey de Moab: 'Permite que mis padres se queden con vosotros hasta que sepa lo que Dios quiere de mí'."
,"4":"Él los dejó con el rey de Moab, y permanecieron con él todo el tiempo que David estuvo en el refugio."
,"5":"Pero el profeta Gad dijo a David: 'No te quedes en el refugio. Vete y entra en la tierra de Judá'. David partió y llegó al bosque de Járet."
,"6":"Saúl estaba en Guibeá, sentado bajo el tamarindo; tenía su lanza en la mano y todos sus servidores le rodeaban, cuando le anunciaron que David y sus hombres habían sido vistos."
,"7":"Saúl dijo: '¡Oídme, benjaminitas! ¿El hijo de Jesé os dará a todos vosotros campos y viñas y os nombrará a todos comandantes y capitanes?"
,"8":"Todos conspiráis contra mí, pues nadie me ha dicho que mi hijo ha hecho un pacto con el hijo de Jesé; ninguno de vosotros tiene compasión de mí y ninguno me informa de que mi hijo ha levantado a mi siervo contra mí para tenderme asechanzas, como hoy lo hace'."
,"9":"Doeg, el edomita, que estaba presente entre los servidores de Saúl, dijo: 'Yo vi al hijo de Jesé venir a Nob, a casa de Ajimélec, hijo de Ajitob."
,"10":"Éste consultó al Señor por él, le proveyó de víveres y le dio la espada de Goliat, el filisteo'."
,"11":"Entonces el rey mandó llamar al sacerdote Ajimélec, hijo de Ajitob, y a toda su familia, los sacerdotes de Nob, y se presentaron ante el rey."
,"12":"Saúl dijo: 'Escúchame, hijo de Ajitob'. Él respondió: 'Aquí me tienes, señor'."
,"13":"Saúl le dijo: '¿Por qué conspiráis contra mí, tú y el hijo de Jesé? Tú le diste pan y una espada y consultaste por él al Señor para que se levantase contra mí, como hoy lo hace'."
,"14":"Ajimélec respondió al rey: '¿Quién entre todos tus siervos es semejante a David: fiel, yerno del rey, jefe de tu guardia y honrado en tu casa?"
,"15":"¿Acaso es hoy cuando he comenzado a consultar a Dios por él? Lejos de mí todo otro pensamiento. Que el rey no haga cargo alguno a su siervo y a toda su familia, porque tu siervo no sabe de todo este asunto ni poco ni mucho'."
,"16":"El rey respondió: 'Ajimélec, morirás tú y toda tu familia'."
,"17":"Después dijo a los guardias que estaban junto a él: 'Matad a los sacerdotes del Señor, porque también ellos han prestado ayuda a David; pues sabiendo que había huido, no me avisaron'. Pero la guardia del rey no quiso poner su mano sobre los sacerdotes del Señor."
,"18":"Etonces el rey dijo a Doeg: 'Acércate tú y mata a los sacerdotes'. Y Doeg, el idumeo, se acercó y mató él mismo a los sacerdotes. Mató aquel día a ochenta y cinco hombres de los que llevan el efod."
,"19":"A Nob, ciudad sacerdotal, Saúl la pasó a espada: hombres y mujeres, niños, hasta los de pecho, bueyes, asnos y ovejas."
,"20":"Sólo se escapó un hijo de Ajimélec, hijo de Ajitob, llamado Abiatar, que huyó hacia David."
,"21":"Abiatar anunció a David que Saúl había matado a los sacerdotes del Señor."
,"22":"David dijo a Abiatar: 'Ya pensé yo, al estar allí aquel día Doeg, que seguramente se lo comunicaría a Saúl. Yo soy el responsable de la vida de toda tu familia."
,"23":"Quédate conmigo; no temas, porque quien atente contra tu vida, atenta contra la mía. Tú estás bajo mi custodia'."
}`)
	CurrentBook.AddChapter(23, `{
"1":"Llevaron a David esta noticia: 'Los filisteos están atacando a Queilá y saquean las eras'."
,"2":"David consultó al Señor: '¿Debo ir y podré derrotar a los filisteos?'. El Señor le respondió: 'Vete, derrotarás a los filisteos y librarás a Queilá'."
,"3":"Pero los hombres de David le dijeron: 'Mira, aquí, en Judá, vivimos asaltados por el terror; ¡cuánto más si vamos a Queilá contra las filas de los filisteos!'."
,"4":"David volvió a consultar al Señor. El Señor le respondió: 'Ánimo, baja a Queilá, porque yo entrego a los filisteos en tus manos'."
,"5":"Partió David con sus hombres hacia Queilá, atacó a los filisteos, se apoderó de sus ganados y les infligió una gran derrota. Así libró David a los habitantes de Queilá."
,"6":"Abiatar, hijo de Ajimélec, que se había refugiado junto a David, bajó a Queilá llevando consigo el efod."
,"7":"Anunciaron a Saúl que David había ido a Queilá. Saúl dijo: 'Dios le ha entregado en mis manos, porque se ha recluido al entrar en una ciudad con puertas y cerrojos'."
,"8":"Saúl llamó a la guerra a todo el pueblo para bajar a Queilá y asediar a David y a sus hombres."
,"9":"Cuando David supo que Saúl tramaba el mal contra él, pidió al sacerdote Abiatar que le llevara el efod."
,"10":"Y dijo: 'Señor, Dios de Israel, tu siervo ha oído decir que Saúl se dispone a venir a Queilá para destruir la ciudad por causa mía."
,"11":"¿Vendrá Saúl como ha oído tu siervo?'. El Señor respondió: 'Vendrá'."
,"12":"David preguntó: '¿Me entregarán los habitantes de Queilá a mí y a mis hombres en manos de Saúl?'. Y el Señor respondió: 'Te entregarán'."
,"13":"Entonces David partió con sus hombres, en número de unos seiscientos; salieron de Queilá y andaban errantes de acá para allá. Informado Saúl de que David había escapado de Queilá, desistió de la expedición."
,"14":"David quedó en el desierto, en los lugares fuertes, en la montaña del desierto de Zif. Saúl le buscaba continuamente, pero Dios no le puso en sus manos."
,"15":"David tuvo miedo, porque Saúl se puso en campaña para quitarle de en medio. David estaba en el desierto de Zif, en Jores."
,"16":"Jonatán, hijo de Saúl, se puso en camino y fue a ver a David en Jores; le dio ánimos en nombre de Dios y"
,"17":"le dijo: 'No tengas miedo, porque la mano de Saúl, mi padre, no te alcanzará. Tú reinarás sobre Israel, y yo seré tu segundo. Mi padre, Saúl, lo sabe muy bien'."
,"18":"Los dos hicieron un pacto ante el Señor. Después David se quedó en Jores, y Jonatán volvió a su casa."
,"19":"Los de Zif subieron a Guibeá para decir a Saúl: '¿Sabes que David está escondido entre nosotros en los lugares fuertes, en Jores, en la colina de Jaquilá, que está al mediodía del desierto?"
,"20":"Oh rey, cuando quieras venir, ven; nosotros lo pondremos en tus manos'."
,"21":"Saúl respondió: 'Que el Señor os bendiga, porque habéis tenido compasión de mí."
,"22":"Id, aseguraos más; informaos exactamente del lugar por donde anda, porque me han dicho que es muy astuto."
,"23":"Observad y reconoced todos los escondites donde se oculta y traedme una información exacta; entonces yo iré con vosotros y, si está en el país, yo le buscaré entre todas las familias de Judá'."
,"24":"Ellos se pusieron en camino y fueron a Zif antes que Saúl. Pero David y sus hombres estaban en el desierto de Maón, en la estepa, al sur del desierto."
,"25":"Saúl y sus hombres fueron en su busca; pero David, informado de ello, bajó al macizo rocoso que hay en el desierto de Maón. Saúl lo supo, y persiguió a David en el desierto de Maón."
,"26":"Saúl y sus hombres iban por un lado de la montaña, y David y los suyos por el otro. David se daba prisa para escapar de Saúl, y Saúl y sus hombres intentaban pasar al lado de David y de sus hombres para apoderarse de ellos."
,"27":"Entonces llegó un mensajero y dijo a Saúl: 'Ven, date prisa, pues los filisteos han invadido el país'."
,"28":"Saúl cesó de perseguir a David y fue al encuentro de los filisteos. Por eso se llamó a aquel lugar 'Roca de la separación'."
}`)
	CurrentBook.AddChapter(24, `{
"1":"De allí David fue a instalarse en los lugares fuertes de Engadí."
,"2":"Cuando Saúl volvió de perseguir a los filisteos, se enteró de que David estaba en el desierto de Engadí."
,"3":"Entonces tomó consigo tres mil hombres, escogidos en todo Israel, y marchó en busca de David y de sus gentes hasta las Rocas de las Gamuzas."
,"4":"Llegó a los rediles de las ovejas que hay junto al camino; allí hay una cueva, y Saúl entró en ella para hacer sus necesidades. David y sus hombres estaban escondidos en el fondo de la cueva. "
,"5":"Y los hombres de David le dijeron: 'Mira, hoy es el día del que te dijo el Señor: Yo pongo a tu enemigo en tu mano; trátale como bien te parezca'. David se levantó y sigilosamente cortó la orla del manto de Saúl."
,"6":"Después le remordía la conciencia por haber cortado la orla del manto de Saúl."
,"7":"Y dijo a sus hombres: 'El Señor me libre de hacer tal cosa a mi señor, el ungido del Señor, de poner mi mano sobre él, porque él es el ungido del Señor'."
,"8":"David refrenó a sus hombres y no les permitió lanzarse sobre Saúl."
,"9":"David se levantó y salió de la cueva tras él, gritando: '¡Oh rey, mi señor!'. Saúl miró para atrás, y David se inclinó en tierra y se prosternó."
,"10":"Después dijo a Saúl: '¿Por qué das oído a la gente que dice: David busca tu ruina?"
,"11":"Hoy mismo has visto con tus propios ojos cómo el Señor te puso en mis manos en la cueva, y no he querido matarte. Te he perdonado, diciéndome: No pondré mi mano sobre mi señor, porque es el ungido del Señor."
,"12":"Mira, padre mío, mira la orla de tu manto en mi mano. Puesto que he cortado la orla de tu manto y no te he matado, reconoce claramente que no hay en mí maldad ni rebeldía. Yo no he pecado contra ti; tú, por el contrario, me acechas para quitarme la vida."
,"13":"Que el Señor juzgue entre nosotros dos y que me vengue de ti; pero mi mano no te tocará."
,"14":"(Como dice el viejo proverbio: De los malos viene la malicia, pero mi mano no te tocará)."
,"15":"¿Contra quién ha salido a campaña el rey de Israel? ¿A quién persigues? ¡A un perro muerto, a una pulga!"
,"16":"Que el Señor sea el árbitro y juzgue entre nosotros dos. Que él examine y defienda mi causa y me haga justicia librándome de tu mano'."
,"17":"Cuando David terminó de hablar así, Saúl le dijo: '¿Es ésta tu voz, hijo mío, David?'. Y comenzó a llorar con grandes gritos."
,"18":"Después dijo a David: 'Tú eres mejor que yo, porque tú me has hecho el bien y yo te hago el mal."
,"19":"Hoy has demostrado que te portas bien conmigo, pues el Señor me ha puesto en tus manos y no me has matado."
,"20":"Cuando alguien encuentra a su enemigo, ¿le deja continuar en paz su camino? Que el Señor te recompense el bien que hoy has hecho conmigo."
,"21":"Ahora sé ciertamente que reinarás sobre Israel y que la realeza de Israel será estable en tus manos."
,"22":"Júrame que no destruirás mi posteridad después de mí y que no harás desaparecer mi nombre de la casa de mi padre'."
,"23":"David se lo juró a Saúl. Después Saúl partió para su casa, y David y sus hombres subieron a un lugar fuerte."
}`)
	CurrentBook.AddChapter(25, `{
"1":"Samuel murió, y todo Israel se reunió para llorarle. Le sepultaron en su casa, en Ramá. David se fue al desierto de Maón."
,"2":"En Maón había un hombre que tenía posesiones en el Carmelo. Era un hombre muy rico: tenía tres mil ovejas y mil cabras. Estaba entonces en el Carmelo para el esquileo de sus ovejas."
,"3":"Este hombre se llamaba Nabal, y su mujer, Abigaíl. La mujer era muy sensata y muy hermosa; el hombre, por el contrario, era duro y malo; era calebita."
,"4":"Al saber David en el desierto que Nabal estaba esquilando sus ovejas,"
,"5":"envió a diez jóvenes con esta orden: 'Subid al Carmelo, presentaos a Nabal y saludadle de mi parte."
,"6":"Le diréis: Paz a ti, paz a tu casa y paz a cuanto te pertenece."
,"7":"He sabido que estás esquilando. Pues bien, tus pastores estuvieron con nosotros; nunca les molestamos ni les faltó nada mientras estuvieron en el Carmelo."
,"8":"Pregunta a tus muchachos y te lo dirán. Atiende a estos jóvenes, ya que han llegado en un día de júbilo. Te ruego que des a tus siervos y a tu hijo David lo que encuentres a mano'."
,"9":"Los jóvenes llegaron donde Nabal, le dijeron todas estas cosas de parte de David y se quedaron esperando."
,"10":"Nabal respondió a los siervos de David: '¿Quién es David y quién es el hijo de Jesé? Hoy son muchos los siervos que andan huyendo de sus señores."
,"11":"¿Voy a tomar yo mi pan, mi agua y la carne de los animales que he matado para mis esquiladores, y se lo voy a dar a unos hombres que no sé de dónde son?'."
,"12":"Los jóvenes de David se volvieron por donde habían ido. Cuando llegaron, le contaron a David lo que Nabal había dicho."
,"13":"David ordenó a sus hombres: '¡Que cada uno se ciña su espada!'. Cada uno se ciñó su espada, y David se ciñó también la suya; y subieron en pos de David unos cuatrocientos hombres; doscientos se quedaron junto a los bagajes."
,"14":"Uno de los jóvenes dio la noticia a Abigaíl, mujer de Nabal: 'David ha enviado desde el desierto unos mensajeros para saludar a nuestro amo, y él los ha despreciado."
,"15":"Estos hombres han sido muy buenos con nosotros. No nos han molestado; no nos ha faltado nada durante todo el tiempo que anduvimos junto a ellos cuando estábamos en el campo."
,"16":"Noche y día han sido como un muro a nuestro alrededor durante todo el tiempo que hemos estado con ellos apacentando las ovejas."
,"17":"Piensa y mira lo que debes hacer, porque está decidida la ruina de nuestro amo y de toda su casa; él es tan insensato que no se le puede hablar'."
,"18":"Rápidamente Abigaíl tomó doscientos panes y dos odres de vino, cinco carneros ya preparados, cuarenta kilos de grano tostado, cien tortas de uvas pasas y doscientas tortas de higos secos. Lo cargó todo sobre asnos"
,"19":"y dijo a sus criados: 'Id vosotros delante; yo iré detrás'. No dijo nada a su marido."
,"20":"Cuando ella, montada sobre un asno, bajaba por la espesura del monte, David y sus hombres bajaban frente a ella, y se encontró con ellos."
,"21":"David había dicho: 'En vano he guardado todo lo que este hombre tiene en el desierto, de modo que nada le haya faltado de cuanto le pertenece; él me devuelve mal por bien."
,"22":"Que Dios me castigue doblemente si, de aquí a mañana, dejo con vida a ningún varón pariente de Nabal'."
,"23":"Cuando Abigaíl vio a David, bajó rápidamente del asno y se postró ante él rostro en tierra."
,"24":"Se echó a sus pies y dijo: 'Que la culpa recaiga sobre mí, señor. Deja hablar a tu sierva y escucha mis palabras."
,"25":"No haga caso mi señor de este hombre insensato, de Nabal, porque hace honor a su nombre. Se llama Nabal, y verdaderamente es un insensato. Tu sierva no vio a los jóvenes que mi señor envió."
,"26":"Ahora, mi señor, por la vida del Señor y por tu propia vida, por el Señor, que te ha impedido derramar sangre y hacerte justicia por tu mano, que tus enemigos y los que intentan hacerte daño corran la misma suerte que Nabal."
,"27":"En cuanto a este presente que tu sierva trae a mi señor, que sea repartido entre los jóvenes que te siguen."
,"28":"Te suplico que perdones la falta de tu sierva, pues el Señor hará ciertamente a mi señor una casa estable, porque mi señor combate las batallas del Señor y en los días de tu vida no se encontrará el mal en ti."
,"29":"Aunque alguno se levante para perseguirte y buscar tu vida, la vida de mi señor está guardada en la bolsa de la vida, junto al Señor, tu Dios; pero la vida de tus enemigos la lanzará lejos, como se lanzan las piedras con la honda."
,"30":"Cuando el Señor haya hecho a mi señor todo el bien que te ha prometido y te haya constituido soberano de Israel,"
,"31":"no será para ti un sufrimiento ni un remordimiento de conciencia el haber derramado sangre en vano y haberte hecho justicia por tu mano. Cuando el Señor haya hecho el bien a mi señor, acuérdate de tu sierva'."
,"32":"David respondió a Abigaíl: '¡Bendito sea el Señor, Dios de Israel, que te ha enviado hoy a mi encuentro!"
,"33":"¡Bendita tu sabiduría y bendita tú por haberme impedido hoy derramar la sangre y hacerme justicia por mi mano!"
,"34":"De otro modo, ¡vive el Señor, Dios de Israel, que me ha impedido hacerte el mal!, de no haber salido tú pronto a mi encuentro, al despuntar el alba no hubiese quedado de Nabal un solo varón'."
,"35":"David recibió de su mano lo que ella había traído y le dijo: 'Vete en paz a tu casa; ya ves que he escuchado tus palabras y que he accedido a tus ruegos'."
,"36":"Cuando Abigaíl llegó a su casa, se encontró a Nabal celebrando un banquete regio. Estaba muy alegre y completamente borracho. Ella no le dijo ni una palabra hasta la mañana siguiente."
,"37":"Por la mañana, cuando se le había pasado ya la borrachera, le contó todo lo sucedido. Entonces se le paralizó el corazón, y él se quedó como una piedra."
,"38":"Unos diez días después, el Señor hirió a Nabal y murió."
,"39":"Cuando David supo que Nabal había muerto, dijo: 'Bendito sea el Señor, que me ha hecho justicia del insulto que recibí de Nabal; impidió a su siervo hacer el mal e hizo recaer la maldad de Nabal sobre su cabeza'. Después David mandó a decir a Abigaíl que quería casarse con ella. "
,"40":"Los siervos de David fueron al Carmelo y dijeron a Abigaíl: 'David nos ha enviado para tomarte por esposa'."
,"41":"Ella se levantó, se postró rostro en tierra y dijo: 'Tu sierva es como una esclava para lavar los pies de los siervos de mi señor'."
,"42":"En seguida se preparó y montó sobre un asno; acompañada de cinco de sus sirvientes, siguió a los mensajeros de David y se casó con él."
,"43":"David se casó también con Ajinoán, de Yezrael; las dos fueron sus mujeres."
,"44":"Saúl había dado su hija Mical, mujer de David, a Paltí, hijo de Lais, de Galín."
}`)
	CurrentBook.AddChapter(26, `{
"1":"Los de Zif fueron a Guibeá a decir a Saúl: '¿Sabes que David está escondido en la colina de Jaquilá, frente al desierto?'."
,"2":"Saúl se puso en marcha con tres mil hombres elegidos de Israel para buscar a David en el desierto de Zif."
,"3":"Instaló el campamento en la colina de Jaquilá, frente al desierto, junto al camino. David, que estaba en el desierto, se dio cuenta de que Saúl venía para perseguirle;"
,"4":"envió espías y supo que, efectivamente, Saúl había llegado."
,"5":"Entonces fue al lugar donde estaba acampado Saúl y observó el sitio donde estaban acostados Saúl y Abner, hijo de Ner, jefe de su ejército. Saúl estaba acostado en el centro del campamento, y la tropa acampada a su alrededor."
,"6":"David dijo a Ajimélec, el hitita, y a Abisay, hijo de Sarvia: '¿Quién quiere venir conmigo al campamento de Saúl?'. Abisay respondió: 'Yo iré contigo'."
,"7":"David y Abisay fueron de noche al campamento; Saúl estaba acostado en el centro del campamento y dormía, con su lanza clavada en la tierra, junto a su cabecera. Abner y la tropa estaban acostados a su alrededor."
,"8":"Abisay dijo a David: 'Hoy ha puesto Dios a tu enemigo en tus manos. Permíteme que le clave en la tierra con su propia lanza de un solo golpe; no tendré que darle otro'."
,"9":"David le contestó: '¡No lo mates! Porque ¿quién puso su mano sobre el ungido del Señor y quedó sin castigo?'."
,"10":"Y añadió: '¡Vive el Señor!, que ha de ser él quien le hiera, ya le llegue el día de su muerte y muera, ya baje a la guerra y caiga."
,"11":"Pero que el Señor aleje de mí el pensamiento de poner mi mano en el ungido del Señor. Anda; coge su lanza y el jarro de agua, y vámonos'."
,"12":"David tomó de la cabecera de Saúl la lanza y el jarro de agua y se fueron. Nadie los vio; nadie se dio cuenta; nadie se despertó, pues todos dormían, porque el Señor había hecho caer sobre ellos un profundo sueño."
,"13":"David pasó al extremo opuesto y se detuvo a lo lejos sobre la cumbre de la montaña; había entre ellos un gran trecho."
,"14":"Entonces David gritó a los soldados y a Abner, hijo de Ner: '¡Abner!, ¿no respondes?'. Abner respondió: '¿Quién eres tú para gritar así al rey?'."
,"15":"David contestó a Abner: '¿No eres tú un hombre? ¿Quién como tú en Israel? ¿Entonces por qué no has guardado a tu señor, el rey? Porque uno del pueblo ha ido a matar al rey, tu señor."
,"16":"No está bien lo que has hecho. Vive el Señor, que merecéis la muerte por no haber guardado a vuestro señor, el ungido del Señor. ¿Dónde está la lanza del rey y el jarro de agua que tenía a su cabecera?'."
,"17":"Entonces Saúl reconoció la voz de David, y dijo: '¿Es ésta tu voz, hijo mío, David?'. David respondió: 'Sí, mi señor el rey'."
,"18":"Y añadió: '¿Por qué persigue mi señor de este modo a su siervo? ¿Qué he hecho yo? ¿Qué hay en mí de culpable?"
,"19":"Y ahora, que el rey, mi señor, se digne escuchar las palabras de su siervo: Si es el Señor quien te excita contra mí, que sea aplacado con una ofrenda; pero si son los hombres, malditos sean del Señor, pues me echan hoy para que no participe en la herencia del Señor, diciendo: Vete a servir a dioses extraños."
,"20":"Que mi sangre no caiga en tierra lejos de la presencia del Señor. Porque el rey ha salido a buscar mi vida como se persigue una perdiz por los montes'."
,"21":"Entonces Saúl dijo: 'He pecado. Vuelve, hijo mío, David, pues no volveré a hacerte mal, porque mi vida ha sido hoy preciosa a tus ojos. He obrado como un insensato y me he engañado lamentablemente'."
,"22":"David respondió: 'Aquí está la lanza del rey. Que uno de los jóvenes atraviese y venga a recogerla."
,"23":"El Señor retribuirá a cada uno según su justicia y su fidelidad, porque el Señor te puso hoy en mis manos y no quise poner mi mano sobre el ungido del Señor."
,"24":"Y así como tu vida ha sido hoy de gran valor a mis ojos, así también será estimada mi vida a los ojos del Señor, y él me librará de toda angustia'."
,"25":"Saúl dijo a David: 'Bendito seas, hijo mío, David. Tendrás éxito seguro en tus empresas y tu poder será grande'. David prosiguió su camino y Saúl volvió a su casa."
}`)
	CurrentBook.AddChapter(27, `{
"1":"David se dijo: 'Cualquier día voy a perecer a manos de Saúl; nada mejor para mí que refugiarme en el país de los filisteos. Así Saúl desistirá de perseguirme en el territorio de Israel y escaparé de su mano'."
,"2":"David se puso en marcha y se pasó, con los seiscientos hombres que tenía, a Aquís, hijo de Maoc, rey de Gat."
,"3":"Se estableció con sus hombres junto a Aquís, en Gat, cada uno con su familia; David con sus dos mujeres: Ajinoán de Yezrael y Abigaíl, la mujer de Nabal del Carmelo."
,"4":"Saúl se enteró de que David había huido a Gat y dejó de perseguirlo."
,"5":"David dijo a Aquís: 'Si quieres hacerme un favor, te suplico que me des un lugar en una de las ciudades del campo para habitar allí. Porque no está bien que tu siervo viva junto a ti en la capital del reino'."
,"6":"Aquel mismo día Aquís le dio Sicelag. Por eso Sicelag pertenece al rey de Judá hasta el día de hoy."
,"7":"David pasó en territorio filisteo un año y cuatro meses."
,"8":"David y sus gentes salían y hacían incursiones contra los guesuritas, los guirsitas y los amalecitas, pues éstos habitaban la región que va desde Telán, en dirección a Sur, hasta la tierra de Egipto."
,"9":"David devastaba la tierra y no dejaba con vida ni hombre ni mujer; se apoderaba de ovejas, bueyes, asnos, camellos y vestidos, y se volvía a Aquís."
,"10":"Cuando Aquís preguntaba: '¿Dónde habéis hecho incursión hoy?', David respondía: 'En el Negueb de Judá, en el Negueb de Yerajmeel, en el Negueb de los quenitas'."
,"11":"David no dejaba con vida ni hombre ni mujer, para que no fueran a Gat y dijeran lo que hacía. Tal fue su manera de proceder durante todo el tiempo que permaneció en territorio filisteo."
,"12":"Aquís tenía confianza en David y se decía: 'Seguramente se ha hecho odioso a su pueblo y será mi servidor para siempre'."
}`)
	CurrentBook.AddChapter(28, `{
"1":"Por entonces los filisteos reunieron sus tropas para salir a luchar contra Israel. Aquís dijo a David: 'Te comunico que tú y tus hombres tenéis que venir conmigo a la campaña'."
,"2":"David le respondió: 'Bien, ahora sabrás lo que va a hacer tu siervo'. Y le dijo Aquís: 'Pues bien, yo te constituiré guardián de mi persona para siempre'."
,"3":"Samuel había muerto; todo Israel le había llorado y le habían sepultado en Ramá, su ciudad. Saúl había expulsado del país a los nigromantes y adivinos."
,"4":"Los filisteos se reunieron y fueron a acampar en Sunán. Saúl reunió también a todo Israel y acamparon en Gelboé."
,"5":"Cuando Saúl vio el campamento de los filisteos, tuvo miedo y su corazón se llenó de angustia."
,"6":"Saúl consultó al Señor; pero el Señor no le respondió ni por los sueños, ni por las urim, ni por los profetas."
,"7":"Entonces dijo a sus servidores: 'Buscadme una mujer dedicada a la nigromancia para que vaya a consultarla'. Sus servidores le respondieron: 'En Endor hay una mujer que se dedica a la nigromancia'."
,"8":"Saúl se disfrazó, poniéndose otros vestidos, y partió llevando consigo otros dos hombres. Llegaron de noche a casa de la mujer, y le dijo: 'Adivíname el futuro por medio de un espíritu y evócame al que yo te diga'."
,"9":"Pero la mujer le respondió: 'Tú sabes bien lo que ha hecho Saúl, que ha expulsado del país a los nigromantes y adivinos. ¿Por qué tiendes insidias a mi vida para hacerme morir?'."
,"10":"Saúl le juró: '¡Vive el Señor, que no incurrirás en pena alguna por esto!'."
,"11":"Entonces la mujer preguntó: '¿A quién quieres que te evoque?'. Él contestó: 'Evócame a Samuel'."
,"12":"Entonces la mujer vio a Samuel y dio un grito. Le dijo a Saúl: '¿Por qué me has engañado? Tú eres Saúl'."
,"13":"Pero el rey le dijo: 'No temas. ¿Qué has visto?'. Y respondió: 'He visto un espíritu que sube de la tierra'."
,"14":"Saúl le preguntó: '¿Qué aspecto tiene?'. Ella respondió: 'Es un anciano que sube envuelto en un manto'. Saúl comprendió que era Samuel, inclinándose rostro en tierra se prosternó."
,"15":"Samuel dijo a Saúl: '¿Por qué has turbado mi descanso, evocándome?'. Saúl respondió: 'Estoy en gran aprieto, los filisteos me hacen la guerra y Dios se ha retirado de mí; no me responde ni por medio de los profetas ni por los sueños. Por eso te he evocado para saber qué hacer'."
,"16":"Samuel respondió: '¿Por qué me consultas, si el Señor se ha retirado de ti y se ha hecho tu enemigo?"
,"17":"El Señor ha hecho contigo lo que había anunciado por mediación mía; el Señor ha arrancado el reino de tu mano y se lo ha dado a otro, a David,"
,"18":"por no haber obedecido al Señor y no haber cumplido su deseo de destruir a Amalec. Por eso el Señor ha hecho esto contigo."
,"19":"El Señor te entregará a ti y a Israel en manos de los filisteos. Mañana tú y tus hijos estaréis conmigo, y el ejército de Israel será entregado también en manos de los filisteos'."
,"20":"Saúl cayó repentinamente en tierra todo lo largo que era, pues las palabras de Samuel le habían llenado de terror; además le faltaron las fuerzas, porque no había comido nada durante todo el día y toda la noche."
,"21":"La mujer se acercó a Saúl y, viéndole tan aterrado, le dijo: 'Tu sierva te obedeció; he expuesto mi vida obedeciendo las órdenes que me has dado."
,"22":"Y ahora, dígnate obedecer también tú a tu sierva: te voy a traer algo de comer; come y recupera fuerzas para proseguir tu camino'."
,"23":"Él no quería comer; pero sus servidores y la mujer le insistieron tanto que, por fin, aceptó. Se levantó del suelo y se sentó a la mesa."
,"24":"La mujer tenía en casa un ternero gordo; lo mató, tomó harina, amasó y coció panes sin levadura."
,"25":"Lo presentó a Saúl y sus servidores. Ellos comieron, se levantaron y partieron aquella misma noche."
}`)
	CurrentBook.AddChapter(29, `{
"1":"Los filisteos concentraron todas sus fuerzas en Afec; los israelitas acamparon cerca de la fuente de Yezrael."
,"2":"Los jefes de los filisteos avanzaban a la cabeza de centurias y millares, y David y sus hombres avanzaban en la retaguardia con Aquís."
,"3":"Los jefes de los filisteos preguntaron: '¿Por qué vienen estos hebreos?'. Aquís les respondió: 'Éste es David, servidor de Saúl, rey de Israel, que ha estado conmigo unos dos años, y no he encontrado nada que reprocharle desde el día en que vino a mí hasta hoy'."
,"4":"Pero los jefes de los filisteos se indignaron contra él y le dijeron: 'Haz que ese hombre vuelva al lugar que le has asignado. Que no venga con nosotros a la guerra, no sea que se vuelva contra nosotros en el combate. ¿Cómo podría este hombre congraciarse con su señor, mejor que con la cabeza de nuestros hombres?"
,"5":"¿No es éste aquel David del cual se cantaba danzando: Saúl mató mil,y David diez mil?'."
,"6":"Aquís llamó a David y le dijo: 'Vive el Señor, que eres un hombre leal y me ha agradado siempre tu comportamiento en el ejército; no tengo nada que reprocharte desde el día en que viniste hasta hoy; pero no eres grato a los ojos de los jefes."
,"7":"Vuélvete y vete en paz, para no hacer nada desagradable a los ojos de los jefes de los filisteos'."
,"8":"David dijo a Aquís: '¿Pero qué he hecho yo y qué has notado en tu siervo desde el día en que entré a tu servicio hasta hoy, para que no pueda yo ir a combatir a los enemigos de mi señor, el rey?'."
,"9":"Aquís le respondió: 'Bien sabes que eres grato a mis ojos como un ángel de Dios; pero los jefes de los filisteos han dicho: Que no vaya con nosotros a la guerra."
,"10":"Así que levantaos de madrugada tú y los siervos de tu señor que han venido contigo, e id al lugar que yo os he asignado. Os levantaréis de madrugada, y cuando venga el día partiréis'."
,"11":"David y sus hombres se levantaron de madrugada para partir por la mañana y volver al país de los filisteos. Los filisteos fueron a Yezrael."
}`)
	CurrentBook.AddChapter(30, `{
"1":"Cuando David y sus hombres llegaron al tercer día a Sicelag, los amalecitas habían hecho una incursión contra el Negueb y contra Sicelag. Habían devastado Sicelag y le habían prendido fuego."
,"2":"Habían hecho prisioneros a las mujeres y a todos los demás, chicos y grandes, pero sin matar a nadie. Los habían llevado y proseguían su camino."
,"3":"Cuando David y sus hombres llegaron a la ciudad y vieron que había sido quemada y que sus mujeres, sus hijos e hijas habían sido llevados prisioneros,"
,"4":"levantaron el grito y lloraron hasta quedarse sin fuerza para llorar."
,"5":"También las dos mujeres de David, Ajinoán de Yezrael y Abigaíl, mujer de Nabal del Carmelo, habían sido hechas prisioneras."
,"6":"David estaba muy angustiado porque la gente quería apedrearlo, pues todos estaban muy amargados, cada uno por sus hijos y por sus hijas. Pero David se confortó en el Señor, su Dios."
,"7":"David dijo al sacerdote Abiatar, hijo de Ajimélec: 'Tráeme, por favor, el efod'. Y Abiatar se lo llevó."
,"8":"David consultó al Señor: '¿Perseguiré a esa banda? ¿La alcanzaré?'. Y le respondió: 'Persíguela, porque la alcanzarás y libertarás a los prisioneros'."
,"9":"David partió con los seiscientos hombres que le acompañaban, y llegaron al arroyo Besor."
,"10":"Continuó la persecución con cuatrocientos hombres, pues doscientos se quedaron allí porque estaban muy fatigados para pasar el arroyo."
,"11":"Encontraron un egipcio en el campo y le condujeron a David. Le dieron de comer y de beber;"
,"12":"un trozo de torta de higos secos y dos racimos de uvas pasas. Él comió y se reanimó, pues no había comido ni bebido nada durante tres días y tres noches."
,"13":"David le preguntó: '¿A quién perteneces y de dónde eres?'. Él respondió: 'Soy un joven egipcio, esclavo de un amalecita. Mi señor me abandonó hace tres días porque me puse enfermo."
,"14":"Hemos hecho una incursión en el sur de los quereteos, de Judá y de Caleb. A Sicelag le prendimos fuego'."
,"15":"David le preguntó: '¿Quieres guiarme hacia esa banda?'. Él respondió: 'Júrame por Dios que no me matarás y que no me entregarás en manos de mi señor, y yo te guiaré hacia esa banda'."
,"16":"Él los guió; estaban diseminados por toda la región, comiendo, bebiendo y bailando por el botín tan grande que habían cogido en el país de los filisteos y en el país de Judá."
,"17":"David los atacó desde la mañana hasta la tarde y los mató a todos, menos a cuatrocientos jóvenes que montaron en los camellos y huyeron."
,"18":"David salvó todo lo que habían tomado los amalecitas y libertó también a sus dos mujeres."
,"19":"No les faltó nada, ni chico ni grande, ni hijos ni hijas. Todo lo que les había sido tomado fue recuperado por David."
,"20":"Ellos tomaron todo el ganado menor y el mayor y lo pusieron ante David, diciendo: 'Éste es el botín de David'."
,"21":"David llegó adonde estaban los doscientos hombres que, por encontrarse muy cansados, no habían podido seguirle y se habían quedado en el arroyo Besor. Ellos salieron al encuentro de David y de la tropa que le acompañaba. David se acercó a ellos y les saludó."
,"22":"Mas los hombres malvados y perversos de entre la gente que había ido con David tomaron la palabra y dijeron: 'Puesto que no habéis ido con nosotros, no os daremos nada del botín que hemos tomado, sino únicamente a cada uno su mujer y sus hijos; que los tomen y que se larguen'."
,"23":"Pero David dijo: 'No obréis así después de lo que el Señor nos ha concedido. Nos ha protegido y ha puesto en nuestras manos esta banda que había venido contra nosotros."
,"24":"¿Quién sería de vuestro parecer en este asunto? La parte debe ser la misma para el que ha ido a la batalla y para el que se ha quedado junto al bagaje: participarán lo mismo'."
,"25":"Y a partir de aquel día esto se convirtió en ley y norma para Israel hasta el día de hoy."
,"26":"Cuando David volvió a Sicelag, envió parte del botín a los ancianos de Judá según sus ciudades, diciendo: 'Os mando un presente del botín de los enemigos del Señor'."
,"27":"A los de Betul, de Ramá, del Negueb, de Yatir,"
,"28":"de Aroer, de Sifmot, de Estemoa;"
,"29":"a los del Carmelo, a los de las ciudades de Yerajmeel, a los de las ciudades de los quenitas,"
,"30":"a los de Jormá, de Borasán, de Atac,"
,"31":"de Hebrón y a todos los lugares donde habían estado David y sus hombres."
}`)
	CurrentBook.AddChapter(31, `{
"1":"Los filisteos libraron batalla con Israel, y los israelitas huyeron ante los filisteos y cayeron muertos en gran número en el monte Gelboé."
,"2":"Los filisteos persiguieron a Saúl y a sus hijos y mataron a Jonatán, a Abinadab y a Malquisúa, hijos de Saúl."
,"3":"El peso de la batalla cayó sobre Saúl. Los arqueros lo alcanzaron, y fue malherido por ellos."
,"4":"Entonces Saúl dijo a su escudero: 'Desenvaina tu espada y traspásame con ella, no sea que vengan esos incircuncisos y se burlen de mí'. Pero su escudero no quiso, pues tenía mucho miedo. Entonces Saúl agarró su espada y se echó sobre ella."
,"5":"Cuando su escudero vio que Saúl estaba muerto, se echó él también sobre su espada y murió con él."
,"6":"Y así murieron juntos el mismo día Saúl, sus tres hijos y su escudero."
,"7":"Cuando los israelitas del otro lado del valle y de la Transjordania vieron que los israelitas habían huido y que Saúl y sus tres hijos habían muerto, abandonaron también ellos sus ciudades y se dieron a la fuga. Los filisteos vinieron y se establecieron en ellas."
,"8":"Al día siguiente, los filisteos fueron a despojar a los caídos y encontraron a Saúl y a sus tres hijos en el monte Gelboé."
,"9":"Les cortaron la cabeza, les despojaron de sus armas e hicieron publicar la buena nueva por todo el país de los filisteos, a los cuatro vientos, a sus ídolos y al pueblo."
,"10":"Pusieron sus armas en el templo de Astarté y colgaron su cadáver en las murallas de Betsán."
,"11":"Cuando los habitantes de Yabés de Galaad supieron lo que los filisteos habían hecho con Saúl,"
,"12":"todos los valientes se pusieron en marcha, caminaron toda la noche y quitaron el cadáver de Saúl y de sus hijos de la muralla de Betsán, los llevaron a Yabés y allí los quemaron."
,"13":"Después sepultaron sus restos bajo el terebinto de Yabés y ayunaron durante siete días."
}`)

}
func ES_LSB_LoadVH2MChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"'A los hermanos judíos que habitan en Egipto, salud; los hermanos judíos de Jerusalén y de la comarca de Judea os desean paz y prosperidad."
,"2":"Que Dios os colme de bienes y se acuerde de su alianza santa con Abrahán, Isaac y Jacob, sus fieles servidores."
,"3":"Que os dé a todos el deseo de adorarle y hacer su voluntad con un corazón grande y un ánimo generoso."
,"4":"Que abra vuestro corazón a su ley y a sus preceptos, que os conceda la paz,"
,"5":"escuche vuestras súplicas, se reconcilie con vosotros y no os deje en los momentos de infortunio."
,"6":"Nosotros estamos ahora aquí rogando por vosotros."
,"7":"Reinando Demetrio, el año 169, nosotros, los judíos, os escribimos en la tribulación y persecución que nos sobrevino en estos años, después de que Jasón y sus partidarios marcharon de la ciudad santa y del reino."
,"8":"Incendiaron la puerta y derramaron sangre inocente. Acudimos al Señor, y fuimos escuchados; ofrecimos sacrificios y flor de harina, encendimos las lámparas y presentamos los panes."
,"9":"Y ahora, para que celebréis las fiestas de los tabernáculos, en el mes de quisleu, os escribimos el año 188'."
,"10":"'Los habitantes de Jerusalén y de Judea y el consejo de los ancianos y Judas, a Aristóbulo, maestro del rey Tolomeo, del linaje de los sacerdotes ungidos, y a los judíos de Egipto, salud y prosperidad."
,"11":"Librados por Dios de grandes peligros, le damos gracias de todo corazón porque lucha con nosotros contra el rey."
,"12":"Porque fue él quien expulsó a los que luchaban contra la ciudad santa."
,"13":"Estando en Persia su jefe, con un ejército que se creía invencible, fue despedazado en el templo de Nanea."
,"14":"Antíoco, con el pretexto de casarse con la diosa, entró en el templo acompañado de sus amigos para apoderarse de las enormes riquezas a título de dote."
,"15":"Los sacerdotes las sacaron para mostrarlas, y él entró con unos pocos en lo sagrado del templo."
,"16":"Ellos cerraron el templo, practicaron una abertura en el techo y, a pedradas, acabaron con el jefe (y los que habían entrado en él); los despedazaron y tiraron sus cabezas a los de afuera."
,"17":"Bendito sea Dios, que hizo morir a los sacrílegos."
,"18":"Debiendo celebrar la purificación del templo el día 25 del mes de quisleu, os lo comunicamos para que también vosotros celebréis los tabernáculos y la memoria del fuego, cuando Nehemías, después de reconstruir el templo y el altar, ofreció sacrificios."
,"19":"Porque cuando nuestros padres eran llevados a Persia, los piadosos sacerdotes de entonces tomaron en secreto el fuego del altar, lo escondieron en una concavidad, como un pozo seco, y lo ocultaron de modo que aquel lugar quedara ignorado de todos."
,"20":"Al cabo de muchos años, cuando Dios quiso, Nehemías, enviado por el rey de Persia, mandó a los descendientes de aquellos sacerdotes que lo habían escondido en busca del fuego. Según ellos nos dijeron, no encontraron fuego, sino un agua muy espesa, y mandó que se la llevaran."
,"21":"Cuando los sacrificios estuvieron preparados, Nehemías mandó a los sacerdotes rociar con el agua la leña y lo que estaba encima de ella."
,"22":"Lo hicieron, y cuando llegó el momento en que comenzó a brillar el sol, que había estado velado por nubes hasta entonces, se encendió un fuego grande, tanto que todos quedaron estupefactos."
,"23":"Mientras el sacrificio se iba consumiendo, los sacerdotes y todos los demás hacían oración. Jonatán entonaba y los demás, con Nehemías, continuaban."
,"24":"Ésta era la oración: Señor, Señor Dios, creador de todas las cosas; el terrible, poderoso, justo, clemente;"
,"25":"el solo rey y único bondadoso; el solo liberal, el solo justo, omnipotente, eterno, que libras a Israel de todo mal, que elegiste a nuestros padres y los santificaste,"
,"26":"acepta este sacrificio por todo tu pueblo Israel, guarda tu herencia y santifícala;"
,"27":"reúne a los nuestros dispersos, libra a los que viven en esclavitud en medio de las gentes, protege a los que son despreciados y aborrecidos, y conozcan los pueblos que tú eres nuestro Dios."
,"28":"Castiga a los que nos oprimen y ultrajan en su orgullo;"
,"29":"trasplanta tu pueblo a tu lugar santo, como dijo Moisés."
,"30":"Los sacerdotes entonaban himnos."
,"31":"Cuando se consumió lo del sacrificio, Nehemías mandó que el agua que quedaba fuera derramada sobre unas piedras."
,"32":"Lo hicieron, y se encendió una llama, la cual fue absorbida por la luz que ardía en el altar."
,"33":"Cuando esto se hizo público y se comunicó al rey de Persia que en el lugar donde los sacerdotes cautivos escondieron el fuego había aparecido agua con la que los compañeros de Nehemías santificaron el sacrificio, aquél, después de comprobar el hecho, hizo"
,"34":"cercar el lugar, decretó que fuera sagrado, y fue día de alegría,"
,"35":"en el que el rey recibió y dio muchos regalos."
,"36":"Los compañeros de Nehemías llamaron a aquel lugar 'Neftar' que significa purificación; pero muchos lo siguen llamando 'Nafta'."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Encontramos escrito en los documentos que el profeta Jeremías mandó a los deportados tomar del fuego antes dicho;"
,"2":"que les dio la ley y les recomendó que no olvidaran los preceptos de Dios, y que no se dejaran seducir al ver los ídolos de oro y plata y sus adornos."
,"3":"Los exhortó a que no alejasen la ley de sus corazones."
,"4":"Se dice también en los documentos que el profeta, ilustrado por revelación de Dios, mandó que llevaran tras él el tabernáculo y el arca. Salió hasta el monte a donde Moisés había subido para contemplar la tierra prometida por Dios."
,"5":"Una vez arriba, Jeremías encontró una caverna y en ella metió el tabernáculo, el arca y el altar del incienso, y cerró la entrada."
,"6":"Algunos de los que le acompañaban fueron luego a poner señales para acordarse del camino, y no pudieron encontrarlo."
,"7":"Jeremías, al enterarse, los reprendió y dijo: Este lugar quedará ignorado hasta que Dios realice la reunión de su pueblo y tenga misericordia de él."
,"8":"Entonces el Señor descubrirá todo esto y se manifestará la gloria del Señor y la nube, como se manifestó en tiempo de Moisés y como cuando Salomón oró para que el templo fuera gloriosamente santificado."
,"9":"Se dice también allí que, lleno de sabiduría, ofreció el sacrificio de la dedicación y la terminación del templo."
,"10":"Y que, así como cuando Moisés oró al Señor vino fuego del cielo que consumió el sacrificio, así también, cuando Salomón oró, bajó fuego y consumió los holocaustos."
,"11":"Y Moisés dijo: Ya que el sacrificio por el pecado no fue comido, ha sido consumido por el fuego."
,"12":"Del mismo modo Salomón celebró ocho días de fiesta."
,"13":"Todo esto se lee también en los anales y en las memorias de Nehemías; además se dice que reunió una biblioteca y que puso en ella los libros de los reyes, los escritos de los profetas, los de David y las cartas de los reyes relativas a las ofrendas."
,"14":"Del mismo modo Judas reunió todos los escritos dispersos por las guerras, y todos están en nuestro poder."
,"15":"Si los necesitáis, mandad por ellos."
,"16":"Os escribimos cuando nos disponemos a celebrar la fiesta de la purificación. Haréis bien en celebrar estos días."
,"17":"Esperamos que, así como Dios salvó a todo su pueblo y le dio la tierra de promisión, el reino, el sacerdocio y el santuario,"
,"18":"según había prometido en la ley, de igual manera tendrá pronto compasión de nosotros y nos reunirá en el lugar santo de todas las naciones que hay bajo el cielo; pues él nos ha salvado de grandes males y ha purificado su santuario'."
,"19":"La historia de Judas Macabeo y de sus hermanos, la purificación del templo glorioso y la dedicación del altar,"
,"20":"las guerras contra Antíoco Epífanes y contra su hijo Eupátor,"
,"21":"las manifestaciones celestes en favor de aquellos que luchaban valientemente por la causa del judaísmo, tanto que siendo pocos libertaron todo el país y pusieron en fuga a ejércitos extranjeros,"
,"22":"recuperaron el templo, célebre en toda la tierra, dieron libertad a la ciudad y restablecieron las leyes a punto de ser abolidas, mostrándoseles propicio el Señor con toda benignidad,"
,"23":"todo lo que Jasón de Cirene ha dicho en cinco volúmenes, procuraremos resumirlo en uno solo."
,"24":"Teniendo presente la cantidad de números y la dificultad que entraña la amplitud de la materia para aquellos que quieren ceñirse al estudio de la historia,"
,"25":"nos hemos preocupado de proporcionar placer espiritual a los aficionados a leer y de aliviar el trabajo a los que gustan de ejercitar la memoria, y así alguna utilidad a todo el que tome en sus manos el libro."
,"26":"Para nosotros, que nos hemos impuesto la tarea no fácil de resumir, ha sido obra de sudores y vigilias."
,"27":"Como aquel que quiere preparar un banquete y contentar a otros se impone una tarea nada fácil, nosotros, para complacer a otros, soportaremos con gusto esta fatiga."
,"28":"Dejando al autor el narrar con exactitud todas las cosas, nosotros nos enforzaremos en guiarnos por las normas de un sencillo compendio."
,"29":"Pues, así como el arquitecto de una casa nueva tiene que preocuparse de toda la construcción, mientras que los pintores y decoradores sólo se preocupan de la ornamentación, así creo que nos sucede a nosotros."
,"30":"Examinar y analizar los pormenores con todo cuidado corresponde al historiador;"
,"31":"pero a aquel que no intenta más que resumirla, se le permite la brevedad, sin que pueda exigírsele una narración completa de los hechos."
,"32":"Vamos, pues, a empezar la narración. Baste lo dicho como introducción, pues sería una necedad ser prolijos en el prólogo de la historia, y después ser breves en la historia misma."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Mientras la ciudad santa gozaba de una paz completa y se observaban todas las leyes por la piedad del sumo sacerdote Onías y su odio a toda maldad,"
,"2":"hasta los reyes honraban el lugar santo y lo enriquecían con ricos dones;"
,"3":"tanto que Saleuco, rey de Asia, proveía de sus propias rentas a los gastos de todos los sacrificios."
,"4":"Un tal Simón, de la tribu de Benjamín, inspector del templo, se enemistó con el sumo sacerdote por cuestiones de la administración de la ciudad y,"
,"5":"no pudiendo sobreponerse a Onías, se fue a Apolonio de Tarso, entonces gobernador de Celesiria y Fenicia,"
,"6":"a quien descubrió que en el tesoro del templo se guardaban riquezas increíbles, que la cantidad del dinero era innumerable, que no se empleaba en el servicio del templo y que el rey podría apoderarse de ello."
,"7":"Apolonio se entrevistó con el rey y le informó de las citadas riquezas. Éste escogió a Heliodoro, que estaba al frente de sus negocios, y le dio orden de apoderarse de aquellos tesoros."
,"8":"Heliodoro se puso pronto en camino, simulando visitar la Celesiria y la Fenicia, pero con el propósito de ejecutar los designios del rey."
,"9":"Llegó a Jerusalén, y fue recibido amigablemente por el sumo sacerdote y por la ciudad; informó de la denuncia recibida, y preguntó si las cosas eran así en realidad."
,"10":"El sumo sacerdote manifestó que se trataba de unos depósitos pertenecientes a huérfanos y viudas,"
,"11":"y de Hircano, hijo de Tobías, persona de noble posición -contra las falsas denuncias del malvado Simón-; y que todo el tesoro era de trece mil seiscientos kilos de plata y seis mil seiscientos de oro;"
,"12":"que era del todo injusto defraudar a aquellos que se habían confiado a la santidad del lugar y a la inviolabilidad del templo, honrado en todo el mundo."
,"13":"Pero Heliodoro, siguiendo las órdenes reales, sostenía que todos aquellos tesoros debían ir a manos del rey."
,"14":"En el día señalado se dispuso a entrar para inspeccionar aquellas riquezas,"
,"15":"lo cual causó no pequeño alboroto en la ciudad. Los sacerdotes, postrados ante el altar con sus vestiduras sacerdotales, invocaban al cielo, que había ordenado la ley de los depósitos, pidiendo que se guardaran intactos para quienes los habían depositado."
,"16":"No se podía mirar el rostro del sumo sacerdote sin quedar estremecido, pues su aspecto y su palidez demostraban la angustia de su interior."
,"17":"Le estremecía un temor y un temblor de cuerpo que dejaba adivinar a quienes le miraban el dolor de su corazón."
,"18":"Muchos salían en tropel de sus casas y organizaban rogativas públicas para salvar el lugar santo, que estaba en peligro de ser ultrajado."
,"19":"Las mujeres, con cilicios bajo los pechos, invadían las calles; las doncellas encerradas, unas corrían a las puertas, otras subían a las murallas, otras miraban por las ventanas."
,"20":"Todas, levantando las manos al cielo, oraban."
,"21":"Movía a compasión ver la muchedumbre confusa postrada en tierra y la ansiedad del sumo sacerdote, colmado de angustia."
,"22":"Todos imploraban al Dios omnipotente que los depósitos fueran guardados con seguridad para quienes los habían depositado."
,"23":"Heliodoro, en tanto, comenzaba a ejecutar sus intentos."
,"24":"Estaba ya con su escolta junto al tesoro del templo, cuando el Señor de los espíritus y rey de todo poder se manifestó con tan gran majestad que todos los que se habían atrevido a entrar en el templo, fulminados a la vista del poder de Dios, quedaron impotentes y atemorizados."
,"25":"Se les apareció un caballo adornado de riquísima montura y, sobre él, un jinete terrible. El caballo pateó con sus patas delanteras a Heliodoro; el que lo montaba iba armado con armadura de oro."
,"26":"Aparecieron también dos jóvenes robustos, de aspecto majestuoso, magníficamente vestidos, que se colocaron a ambos lados de Heliodoro y no paraban de azotarlo descargando sobre él una lluvia de golpes."
,"27":"Heliodoro cayó a tierra y quedó envuelto en profunda oscuridad; lo recogieron y lo llevaron en una litera."
,"28":"Así era llevado, incapaz de valerse por sí mismo, aquel que poco antes había entrado arrogante en la sala del tesoro con gran séquito y numerosa escolta, reconociendo todos claramente el poder de Dios."
,"29":"Por la intervención divina había quedado sin palabra y sin esperanza alguna de salud."
,"30":"Los judíos bendecían al Señor, que había glorificado su santuario y había llenado de gozo y alegría aquel templo, poco antes inundado de temor y de turbación, por la extraordinaria manifestación de Dios."
,"31":"Llegaron rápidamente algunos de los de Heliodoro, y suplicaban a Onías que rogara al altísimo para que concediera la vida a aquel que se encontraba en su último aliento."
,"32":"El sumo sacerdote, temiendo que el rey pensara que los judíos habían atentado contra la vida de Heliodoro, ofreció un sacrificio por su salud."
,"33":"Al tiempo que el sumo sacerdote ofrecía el sacrificio por el pecado, se presentaron de nuevo ante Heliodoro los mismos jóvenes, vestidos con las mismas vestiduras; se pusieron ante él y le dijeron: 'Da muchas gracias a Onías, sumo sacerdote, pues por él el Señor te ha dejado con vida."
,"34":"Tú, castigado por el cielo, publica a todos el gran poder de Dios'. Dicho esto, desaparecieron."
,"35":"Heliodoro, después de ofrecer un sacrificio al Señor y desear mucha prosperidad a aquel que le había concedido la vida, se despidió de Onías y se volvió con sus tropas a la corte del rey."
,"36":"Daba testimonio ante todos de las cosas maravillosas que había visto con sus mismos ojos, realizadas por Dios."
,"37":"El rey preguntó a Heliodoro por la persona más indicada para enviarla otra vez a Jerusalén."
,"38":"Heliodoro respondió: 'Si tienes alguna persona contraria y enemiga de tu gobierno, envíala allá, y la harás volver bien castigada, si es que consigue volver. En aquel lugar hay un poder divino."
,"39":"El mismo que habita el cielo vigila aquel lugar y lo guarda, hiriendo de muerte a los que penetran en él para profanarlo'."
,"40":"Esto fue lo que sucedió con Heliodoro, y así se salvó el tesoro."
}`)
	CurrentBook.AddChapter(4, `{
"1":"El tal Simón, delatador de los tesoros y traidor a la patria, calumniaba a Onías, como si hubiera sido el instigador contra Heliodoro y causa de sus males."
,"2":"Al bienhechor de la ciudad, al defensor de su pueblo y al celador de la ley se atrevía a llamar traidor del orden público;"
,"3":"creció tanto la enemistad, que uno de los partidarios de Simón cometió algunos asesinatos."
,"4":"Onías, viendo el peligro de la discordia y la insensatez de Apolonio, jefe de Celesiria y Fenicia, que apoyaba la maldad de Simón, se fue a ver al rey,"
,"5":"no para acusar a los suyos, sino por el interés general y particular de todo el pueblo,"
,"6":"pues veía que sin la intervención del rey era imposible conseguir la paz pública y que Simón cesara en su locura."
,"7":"Seleuco murió, y le sucedió en el trono Antíoco, por sobrenombre Epífanes. Jasón, hermano de Onías, ambicionaba el sumo sacerdocio,"
,"8":"y prometió al rey en una audiencia doce mil doscientos kilos de plata y otros dos mil setecientos de algunas rentas;"
,"9":"además de esto, prometía hacer escritura de otros cinco mil cien kilos si se le daba facultad para establecer un gimnasio y un centro juvenil y que los habitantes de Jerusalén tuvieran los mismos derechos que los antioquenos."
,"10":"El rey accedió; Jasón se apoderó del mando, y se empeñó en hacer pasar a los de su raza a las costumbres helénicas."
,"11":"Quitó los estatutos benévolos del rey, hechos por Juan, padre de Eupolemo, el embajador que hizo el tratado de amistad con los romanos. Abolió las leyes antiguas, y puso nuevos estatutos ilegales."
,"12":"Se atrevió a poner un gimnasio debajo de la acrópolis y obligó a los jóvenes distinguidos a vestir el traje de deportes."
,"13":"A tal punto llegó el helenismo y el incremento de costumbres extranjeras a causa del malvado, más que sumo sacerdote, Jasón,"
,"14":"que los sacerdotes no se ocupaban del servicio del altar, sino que despreciaban el templo, no se preocupaban de los sacrificios y se afanaban en tomar parte del injusto premio en la palestra con el lanzamiento del disco."
,"15":"Ni tenían en nada las glorias patrias, juzgando, en cambio, óptimas las glorias helénicas."
,"16":"Precisamente por esto les sobrevino una gran calamidad, pues aquellos mismos cuyas costumbres querían imitar en todo vinieron a ser sus enemigos y tiranos."
,"17":"Quebrantar y despreciar las leyes divinas no queda sin castigo, como lo demuestra lo que sigue."
,"18":"Cuando se celebraban en Tiro los juegos cuadrienales en presencia del rey,"
,"19":"el criminal Jasón envió a la fiesta desde Jerusalén espectadores, ciudadanos antioquenos, que llevaban trescientas dracmas de plata para el sacrificio de Hércules; pero dijeron que no convenía emplearlas en el sacrificio, sino en otros gastos."
,"20":"Sólo a la iniciativa de los que lo llevaban se debió que aquel dinero, enviado para el sacrificio de Hércules, se empleara en la construcción de trirremes."
,"21":"Apolonio, hijo de Menesteo, enviado a Egipto para la entronización de Tolomeo Filométor, hizo saber a Antíoco que aquel rey no aprobaba su política y sus planes, y por esto se dispuso a tomar medidas para su propia seguridad. Con este fin marchó a Jafa, y después se detuvo en Jerusalén."
,"22":"Fue recibido espléndidamente por Jasón, y toda la ciudad le acompañó y recibió con antorchas y aclamaciones. Desde allí marchó con sus tropas a Fenicia."
,"23":"Tres años después, Jasón mandó a Menelao, hermano del tal Simón, para que llevara dinero al rey y gestionara algunos asuntos urgentes y necesarios."
,"24":"Pero ganó la voluntad del rey, se hizo pasar por hombre de gran influencia y consiguió el sumo sacerdocio, ofreciendo diez mil doscientos kilos de plata más que Jasón."
,"25":"Vino con las órdenes reales, pero no presentaba nada digno de un sumo sacerdote, sino pasiones de tirano cruel e instintos de bestia salvaje."
,"26":"Y Jasón, que había suplantado a su hermano, suplantado a su vez por otro, tuvo que huir al país de los amonitas."
,"27":"Pero Menelao, cuando tomó posesión del cargo, no se preocupó de pagar el dinero prometido, a pesar de las intimaciones de Sóstrates, jefe de la acrópolis,"
,"28":"a quien tocaba cobrar los tributos. Ambos fueron citados delante del rey."
,"29":"Menelao dejó en su lugar en el sumo sacerdocio a su hermano Lisímaco; y, por su parte, Sóstrates fue nombrado gobernador de Chipre."
,"30":"Estando así las cosas, estalló la sublevación de las ciudades de Tarso y Malos porque habían sido dadas como regalo a Antioquida, concubina del rey."
,"31":"El rey partió rápidamente para reprimir la insurrección, dejando en su lugar a Andrónico, uno de los dignatarios más grandes de su corte."
,"32":"Menelao, juzgando que las circunstancias eran propicias para medrar, robó algunos objetos de oro del templo y se los dio a Andrónico; otros los vendió en Tiro y en las ciudades vecinas."
,"33":"Onías estaba retirado en Dafne, cerca de Antioquía, lugar de asilo y, al enterarse de estas cosas, reprendió a Menelao."
,"34":"Menelao, irritado, pidió a Andrónico que matara a Onías. Andrónico fue a ver a Onías, le dio la mano y le juró que no le haría nada; Onías no se fiaba, pero se dejó convencer y salió del lugar de asilo; inmediatamente Andrónico lo mató sin respetar la justicia."
,"35":"Esto causó indignación y mal efecto no sólo entre los judíos, sino también en otras naciones, por la muerte inicua y arbitraria de Onías."
,"36":"Cuando el rey volvió de las regiones de Cilicia, se presentó ante él una comisión de judíos y de griegos, que aborrecían el crimen, para protestar por la muerte de Onías."
,"37":"Antíoco se entristeció profundamente y se movió a compasión, y lloró al recordar la sabiduría y la prudencia del difunto."
,"38":"Encendido en indignación, quitó inmediatamente la púrpura a Andrónico e hizo que le rasgaran las vestiduras y lo llevaran por toda la ciudad hasta el lugar donde había cometido el crimen contra Onías. Allí mismo mandó matar al asesino; Dios le dio así el castigo merecido."
,"39":"Mientras tanto, en Jerusalén, Lisímaco cometía muchos robos con asentimiento de Menelao. Al saberlo, el pueblo se sublevó contra Lisímaco, pero ya muchos objetos habían sido exportados."
,"40":"Lisímaco, ante las turbas sublevadas y ebrias de furor, armó tres mil hombres y comenzó a hostigar cruelmente al pueblo; las tropas estaban acaudilladas por un tal Tirano, avanzado en edad y en locura."
,"41":"El pueblo, ante el ataque de los de Lisímaco, reaccionó con piedras y palos, y hasta recogían del suelo tierra para arrojarla contra los que rodeaban a Lisímaco."
,"42":"Consiguieron herir a unos, derribar a otros, ahuyentar a los demás, y al mismo sacrílego lo mataron junto al tesoro del templo."
,"43":"De todo esto se hizo un proceso contra Menelao."
,"44":"Cuando el rey llegó a Tiro, tres hombres enviados por el consejo de ancianos le dieron cuenta de aquellas crueldades."
,"45":"Menelao, viéndose perdido, prometió mucho dinero a Tolomeo, hijo de Dorimeno, para que le ganara el favor del rey."
,"46":"Tolomeo llevó al rey a un peristilo, como para tomar el fresco, y le hizo cambiar de parecer."
,"47":"En consecuencia, el rey absolvió a Menelao, causante de tanta crueldad, y condenó a muerte a aquellos infelices, que hubieran sido absueltos aun en el caso de que su causa se hubiera presentado ante un tribunal cruel."
,"48":"Inmediatamente se ejecutó la pena capital de aquellos cuyo delito fue defender la causa de la ciudad, el pueblo y los vasos sagrados."
,"49":"Los mismos de Tiro, indignados por un crimen semejante, les dieron honorífica sepultura."
,"50":"Menelao siguió en el poder, sostenido por la avaricia de los poderosos gobernantes, cada vez más criminal, convertido en tirano de los de su nación."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Por entonces, Antíoco preparaba una segunda expedición a Egipto."
,"2":"Durante cuarenta días se vieron en toda la ciudad carreras de jinetes corriendo por el aire, con vestiduras de oro, armados de lanzas y formados en escuadrones,"
,"3":"escuadrones de caballería en orden de batalla, choques y asaltos de unos contra otros, vibración de escudos, lanzas innumerables, espadas desenvainadas, tiros de flechas, brillar de armaduras y corazas de toda especie."
,"4":"Todos pedían que tales presagios y apariciones fueran de buen augurio."
,"5":"Se difundió el falso rumor de la muerte de Antíoco, y Jasón, con unos mil hombres, asaltó de improviso la ciudad. Ésta se defendió guarneciendo las murallas; pero Jasón tomó la ciudad, y Menelao se refugió en la acrópolis."
,"6":"Entonces Jasón hizo una matanza sin compasión en sus propios conciudadanos, olvidándose de que las victorias contra los de su propia nación son la mayor derrota; parecía que él no triunfaba de sus conciudadanos, sino de sus enemigos."
,"7":"Pero no pudo sostenerse en el poder y, manchado con la traición, tuvo que huir de nuevo a la tierra de Amán."
,"8":"Su fin fue desgraciado. Aretas, rey de los árabes, lo mandó encarcelar y, huyendo de ciudad en ciudad, perseguido y aborrecido por todos como transgresor de las leyes, execrado como verdugo de la patria, fue confinado en Egipto."
,"9":"Y el que a muchos había obligado a salir de la patria, pereció en tierra extranjera, entre los lacedemonios, en quienes pensaba encontrar protección en gracia de los lazos de familia."
,"10":"Y el que a muchos había dejado en su tierra sin sepultura, no tuvo quien lo llorase, ni pudo ser enterrado en el sepulcro de sus padres."
,"11":"Cuando el rey tuvo noticia de todo esto, temió que toda Judea se le iba a separar y sublevar; por esto subió de Egipto hecho una fiera, tomó la ciudad por las armas,"
,"12":"mandó a sus soldados que mataran sin compasión a cuantos encontraran y a cuantos se refugiaran en las terrazas de las casas."
,"13":"En consecuencia, hubo una horrible matanza de jóvenes y viejos; fueron exterminados hombres, mujeres y niños, fueron pasados por la espada doncellas y niños de pecho."
,"14":"Murieron ochenta mil; cuarenta mil cayeron asesinados, y no menos de los degollados fueron vendidos como esclavos."
,"15":"No fue esto sólo. El rey tuvo la osadía de entrar en el templo más santo de la tierra, guiado por Menelao, traidor a su patria y a sus leyes."
,"16":"Con sus manos impuras y criminales robó los vasos sagrados y las ofrendas hechas por otros reyes para gloria y honor del templo; todo lo profanó con sus impuras manos."
,"17":"No se daba cuenta Antíoco, lleno de orgullo, de que, por los pecados de los habitantes de la ciudad, y por breve tiempo, el Señor se había airado, y que por esta misma razón había sido profanado el templo."
,"18":"Pues si la ciudad no hubiera estado envuelta en pecado, Antíoco habría sido bien flagelado y reprimido en su audacia, como lo fue Heliodoro, mandado por Seleuco a robar el tesoro."
,"19":"Pero Dios no había escogido el pueblo para el templo, sino el templo para el pueblo."
,"20":"Por esto, también el templo ha participado de las desgracias del pueblo, así como después estuvo asociado a sus beneficios; y aunque fuera abandonado a la ira del omnipotente, fue exaltado de nuevo gloriosamente en la reconciliación del gran Dios."
,"21":"Antíoco robó sesenta y un mil kilos de plata del templo, y partió rápidamente para Antioquía, pensando en su orgullo y soñando en su vanagloria que podría navegar por tierra y andar a pie por el mar."
,"22":"Al marchar, dejó ministros suyos para hacer mal al pueblo: en Jerusalén, a Filipo, de origen frigio y de modales más salvajes que el que lo había puesto;"
,"23":"en Garizín, a Andrónico; y a éstos hay que añadir a Menelao, más pernicioso para sus ciudadanos y peor que los otros."
,"24":"No contento con esto, Antíoco envió al misarca Apolonio con un ejército de veintidós mil soldados, con orden de degollar a todos los de edad adulta y de vender las mujeres y los niños."
,"25":"Llegó a Jerusalén y, simulando la paz, esperó hasta el sábado. Entonces, viendo a los judíos en fiesta, mandó hacer un desfile militar"
,"26":"y matar a todos los que fueron a presenciar el espectáculo. Los soldados recorrieron las calles y mataron una gran muchedumbre."
,"27":"Pero Judas Macabeo, con otros nueve, se retiró al desierto. Allí compartió la vida de las fieras con los que estaban con él, alimentándose de hierbas para no mancharse con la contaminación general."
}`)
	CurrentBook.AddChapter(6, `{
"1":"No mucho después el rey envió a un senador ateniense, con el fin de obligar a los judíos a dejar las leyes paternas y a no gobernarse según las leyes de Dios."
,"2":"Le mandaba, además, profanar el templo de Jerusalén, dedicándolo a Júpiter Olímpico, y el de Garizín, a Júpiter Hospitalario, como lo pedían los habitantes del lugar."
,"3":"Pesado era para todos e insoportable el incremento de tantas maldades,"
,"4":"pues el templo se vio lleno de lujuria y de orgías de los gentiles, que allí banqueteaban con las prostitutas y tenían relaciones con mujeres en los pórticos, llenándolo todo de prácticas y cosas inmundas."
,"5":"El mismo altar estaba lleno de cosas impuras prohibidas por la ley."
,"6":"No se podía celebrar el sábado, ni guardar las fiestas patrias, ni ser llamado o declararse judío."
,"7":"Por el contrario, eran violentamente obligados a celebrar cada mes, con sacrificios, la fiesta del rey; y cuando llegaban las fiestas de Baco, eran forzados a ceñir sus frentes con hiedra, y así tomar parte en las procesiones."
,"8":"Por sugestión de los de Tolemaida, salió un decreto dirigido a las ciudades helenísticas vecinas, instigándoles a que emplearan los mismos procedimientos con los judíos, obligándoles a tomar parte en los banquetes sagrados,"
,"9":"de forma que los que no quisieran pasarse a los usos helenísticos fueran degollados. Entonces pudo apreciarse toda la extensión de los males que se venían encima."
,"10":"Dos mujeres fueron denunciadas por haber circuncidado a sus hijos; les ataron los hijos a los pechos, y así las pasearon por la ciudad; finalmente, las tiraron por la muralla."
,"11":"Otros, que se habían ocultado en una caverna para celebrar el sábado, fueron denunciados a Filipo y abrasados, pues no quisieron defenderse por la santidad del sábado."
,"12":"Pido a los que llegaren a leer este libro que no se escandalicen por estas adversidades; que tengan por cierto que no para nuestra ruina, sino para corrección de nuestro pueblo ha sucedido esto."
,"13":"En realidad, es señal de gran benevolencia no dejar impunes a los pecadores, sino aplicarles prontamente el castigo."
,"14":"En tanto que el Señor tiene paciencia con las otras gentes para darles el castigo cuando han llegado a la plenitud de la maldad, quiere conducirse con nosotros de una manera muy diversa."
,"15":"No espera a castigarnos cuando hemos llegado al colmo de nuestros pecados; no hace así con nosotros."
,"16":"Nunca aparta su misericordia de nosotros, no abandona a su pueblo, incluso cuando le castiga con la adversidad."
,"17":"Sirva lo referido para hacer resaltar estas verdades. Y dicho esto, volvamos al hilo de la narración."
,"18":"Eleazar, uno de los escribas principales, de edad provecta y aspecto venerable, era forzado a abrir la boca y comer carne de cerdo."
,"19":"Pero él prefirió una muerte gloriosa a una vida de ignominia, e iba por su propia voluntad al suplicio,"
,"20":"escupiendo la carne, como deben hacer con valentía los que con valor intentan abstenerse de aquellas cosas que no les es lícito gustar por amor a la vida."
,"21":"Los que estaban al frente del banquete sacrílego, llevados de la antigua amistad que con él tenían, le tomaron aparte y le instaban a que se hiciera llevar manjares permitidos, preparados por él mismo, a fin de simular que había comido de los manjares de los sacrificios, según el edicto del rey."
,"22":"Haciendo así, se libraría de la muerte. Le hacían este favor por la amistad antigua que tenían con él."
,"23":"Pero él, elevándose a más altas resoluciones, dignas de su edad y de su venerable ancianidad, de sus cabellos ya blancos y de su vida irreprensible desde la infancia, y sobre todo de las santas leyes establecidas por Dios, respondió que prefería que lo llevaran a la muerte."
,"24":"'Porque -decía él- no es digno de nuestra edad simular y fingir, ya que los jóvenes podrían decir que Eleazar, a sus noventa años, se había pasado a las costumbres extranjeras."
,"25":"Y serían inducidos a error, por su hipocresía y por el amor de una breve y precaria existencia, y me acarrearía vergüenza y oprobio en mi vejez."
,"26":"Pues, aunque pudiera escapar de las manos de los hombres, ni vivo ni muerto podría escapar de las manos de Dios omnipotente."
,"27":"Por tanto, renunciaré valientemente a mi vida y me mostraré digno de mi ancianidad,"
,"28":"dejando a los jóvenes un ejemplo generoso para morir valientemente por las sagradas y santas leyes'. Dicho esto, rápidamente se entregó al suplicio. "
,"29":"Los que lo conducían, al oír esto, trocaron su benevolencia anterior en aversión y odio, pues creían que hablaba con insensatez y obstinación."
,"30":"A punto de morir por los golpes de la flagelación, les decía gimiendo: 'El Señor, que todo lo sabe, ve bien que, pudiéndome librar de la muerte, estoy sufriendo en mi cuerpo los tormentos atroces de la flagelación; pero en el alma sufro gustoso todo esto por su santo temor'."
,"31":"Y así murió, dejando no sólo a los jóvenes, sino a la mayor parte de la nación un ejemplo de nobleza y un monumento de virtud y fortaleza con su muerte."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Siete hermanos fueron apresados junto con la madre y obligados a comer carnes de cerdo prohibidas; y por negarse a comerlas, fueron azotados con zurriagos y vergajos de toro."
,"2":"Uno de ellos, en nombre de todos, dijo: '¿Qué buscas o qué quieres de nosotros? Todos estamos dispuestos a morir antes que quebrantar las leyes patrias'."
,"3":"El rey, enfurecido, mandó poner fuego debajo de las sartenes y ollas; y, cuando estuvieron encendidas,"
,"4":"mandó cortar la lengua del que había hablado en nombre de todos, desollarle la cabeza y cortarle las extremidades, mientras sus hermanos y su madre lo presenciaban."
,"5":"Una vez completamente mutilado, mandó echarlo al fuego y freírlo cuando todavía vivía. El vapor de la caldera se extendía hasta lejos, y la madre y los hermanos se exhortaban mutuamente a morir valientemente,"
,"6":"diciendo: 'Dios lo ve todo y tendrá piedad de nosotros, como dijo Moisés en el cántico de protesta contra Israel: Tendrá piedad de sus siervos'."
,"7":"Así murió el primero. Acercaron entonces el segundo para torturarlo. Le arrancaron el cuero cabelludo, y le preguntaron: '¿Quieres comer para no ser atormentado en tu cuerpo, miembro por miembro?'."
,"8":"Él contestó en lengua patria: 'No'. Por esto se le dio el mismo tormento que al primero."
,"9":"A punto de expirar, dijo: 'Tú, criminal, nos quitas la vida presente; pero el rey del mundo nos dará después una vida eterna a los que morimos por sus leyes'."
,"10":"A continuación fue torturado el tercero. Le mandaron sacar la lengua; la sacó rápidamente"
,"11":"y extendió las manos con valor, diciendo con gallardía: 'Del cielo he recibido estos miembros, y ahora los desprecio por amor de sus leyes, porque sé que un día el mismo cielo me los devolverá'."
,"12":"El rey y cuantos estaban con él se maravillaron del ánimo y valor del joven, que así despreciaba los tormentos."
,"13":"Muerto éste, sometieron al cuarto a los mismos tormentos."
,"14":"Ya a punto de morir, dijo: 'Es preferible sucumbir a manos de hombres, teniendo en Dios la esperanza de ser resucitados de nuevo por él. Pero para ti no habrá resurrección para la vida'."
,"15":"Trajeron el quinto, y lo empezaron a torturar."
,"16":"Él entonces, mirando al rey, dijo: 'Tú, aunque eres mortal, tienes autoridad entre los hombres y haces lo que quieres. Pero no pienses que nuestra nación ha sido abandonada de Dios;"
,"17":"espera un poco y sentirás su gran poder sobre ti y cómo te castigará a ti y a toda tu descendencia'."
,"18":"Después trajeron al sexto, el cual, estando para morir, exclamó: 'No te hagas ilusiones. Nosotros padecemos esto por nuestras culpas. Estas cosas espantosas nos suceden a nosotros por haber pecado contra nuestro Dios."
,"19":"Pero no pienses que tú vas a quedar sin castigo, pues te has atrevido a desafiar a Dios'."
,"20":"Pero, sobre todo, fue admirable la madre, y digna de gloriosa memoria. Ella, viendo muertos a sus siete hijos en el espacio de un día, lo llevaba todo con ánimo grande por la esperanza que tenía en el Señor."
,"21":"Rebosando sentimientos generosos, exhortaba a cada uno en la lengua materna; y robusteciendo con ánimo varonil la fragilidad femenina,"
,"22":"les decía: 'No sé yo cómo habéis aparecido en mi seno, puesto que no he sido yo la que os ha dado el espíritu y la vida, ni la que unió los miembros de vuestro cuerpo."
,"23":"Dios, creador del mundo, que formó el género humano y ha creado cuanto existe, él os dará de nuevo el espíritu y la vida por su misericordia, ya que por sus santas leyes la despreciáis'."
,"24":"Antíoco sospechaba que lo despreciaba, y pensó que también lo recriminaba. Pero, con todo, al más joven, que quedaba todavía, no solamente le exhortaba con palabras, sino que le prometía con juramento enriquecerlo de una vez y hacerle el más feliz, y, una vez que hubiera renegado de su religión y abandonado las leyes patrias, tenerle como amigo, proveerle de todo lo necesario y darle un cargo de gobierno."
,"25":"El niño no le hacía caso, por lo cual el rey llamó a la madre y le indicó que aconsejara a su hijo para que pudiera salvar la vida."
,"26":"Como el rey se lo ordenara con insistencia, al fin ella accedió a convencer a su hijo."
,"27":"Se inclinó hacia él, y burlándose del cruel tirano, dijo en lengua patria: 'Hijo mío, ten compasión de mí, que durante nueve meses te llevé en mi seno, y te he amamantado durante tres años y te he alimentado y te he criado y educado hasta la edad que ahora tienes."
,"28":"Te pido, hijo mío, que mires al cielo y a la tierra y a todo lo que hay en ella, que reconozcas que Dios lo hizo todo de la nada y que de la misma manera hizo el género humano."
,"29":"No temas a este verdugo; hazte digno de tus hermanos y acepta la muerte, para que tengas parte en la misericordia con tus hermanos'."
,"30":"Todavía estaba hablando la madre, cuando el hijo exclamó: '¿Qué esperas? No obedezco las órdenes del rey; yo sigo y obedezco los preceptos de la ley dada a nuestros padres por Moisés."
,"31":"Tú, inventor de tormentos contra los hebreos, no podrás escapar de la mano de Dios."
,"32":"Nosotros padecemos por nuestros pecados."
,"33":"Si el Señor, Dios vivo, se ha indignado contra nosotros por breve tiempo para castigarnos y corregirnos, él se reconciliará con sus siervos de nuevo."
,"34":"Pero tú, el más criminal de todos los hombres, no te enorgullezcas sin motivo, confiando neciamente en esperanzas vanas, mientras te atreves a levantar tu mano contra sus siervos."
,"35":"No has escapado todavía al justo juicio del Dios omnipotente, que lo ve todo."
,"36":"Mis hermanos están ya en posesión de una promesa de vida eterna por haber sufrido un breve tormento. En cambio, tú sufrirás las penas debidas a tu soberbia."
,"37":"Yo, como mis hermanos, entrego mi cuerpo y mi vida por las leyes patrias, pidiendo a Dios que muestre pronto su misericordia con su pueblo, y a ti, con tormentos y castigos, te obligue a confesar que sólo él es Dios."
,"38":"Que termine en mí y en mis hermanos la ira del creador, que justamente ha venido sobre nuestro pueblo'."
,"39":"El rey, encendido en ira y herido por las sarcásticas recriminaciones, atormentó a éste más que a los otros."
,"40":"Así murió también éste, sin mancha, y confiando plenamente en el Señor."
,"41":"Después de todos los hijos, murió también la madre."
,"42":"Y baste lo dicho sobre la comida de alimentos impuros y las crueldades monstruosas."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Entretanto, Judas Macabeo y sus compañeros entraban a ocultas en los poblados, llamaban a sus parientes y reunían a los que habían permanecido fieles al judaísmo; juntaron hasta seis mil hombres."
,"2":"Y suplicaban al Señor que mirara al pueblo pisoteado por todos y que se compadeciera del templo contaminado por hombres sacrílegos,"
,"3":"que tuviera también piedad de la ciudad devastada, a punto de ser completamente arrasada; que oyera el clamor de la sangre, que pedía a gritos justicia;"
,"4":"que se acordara también de la muerte inicua de niños inocentes y de las blasfemias contra su nombre, y que mostrara su indignación contra los malvados."
,"5":"El Macabeo reunió sus tropas, se puso al frente de ellas y pronto se hizo invencible frente a los gentiles, pues el Señor había cambiado su ira en misericordia."
,"6":"Caía de improviso sobre ciudades y aldeas, y les prendía fuego; ocupaba posiciones estratégicas y ponía en fuga a numerosos enemigos."
,"7":"Prefería la noche para estas correrías, y por todas partes se extendía la fama de su valor."
,"8":"Filipo, al ver los éxitos crecientes de Judas y sus victorias cada vez mayores y más frecuentes, escribió a Tolomeo, general de Celesiria y Fenicia, para que viniera a poner a salvo los intereses del rey."
,"9":"Tolomeo designó a Nicanor, hijo de Patroclo, de los primeros amigos del rey; puso a sus órdenes más de veinte mil soldados de diversas naciones y le dio la orden de exterminar a toda la raza judía. Puso a su lado a Gorgias, caudillo militar que tenía experiencia en los asuntos de guerra."
,"10":"Nicanor se proponía obtener sesenta y ocho mil kilos de plata con la venta de esclavos judíos, para pagar el tributo debido por el rey a los romanos."
,"11":"Así pues, pasó aviso a las ciudades del litoral para que vinieran a comprar esclavos judíos, prometiendo dar noventa esclavos por treinta y cuatro kilos de plata, no cayendo en la cuenta que la justicia de Dios omnipotente caería sobre él."
,"12":"Judas se enteró de la marcha de Nicanor y comunicó a los suyos la venida de aquel ejército."
,"13":"Los cobardes y los que desconfiaban de la justicia de Dios se daban a la fuga."
,"14":"Otros, en cambio, vendían lo que les quedaba y suplicaban a Dios que los librara del malvado Nicanor, que los había vendido antes de llegar."
,"15":"Y si no por ellos, que al menos los librara por la alianza hecha con sus padres y por el venerable y augusto nombre con que ellos lo invocaban."
,"16":"El Macabeo reunió sus tropas, unos seis mil hombres, y los exhortó a que no tuvieran miedo a los enemigos y que no les asustara la muchedumbre de gentiles que, contra toda justicia, venía contra ellos,"
,"17":"sino que lucharan valientemente, teniendo presente la profanación sacrílega llevada a cabo en el lugar santo, la injuriosa opresión de la ciudad y la abolición de las instituciones antiguas."
,"18":"'Si confían en su audacia y en sus armas -les dijo-, nosotros confiamos en Dios omnipotente, que puede con un gesto exterminar a todos los que nos invaden, y aun al mundo entero'."
,"19":"Les recordó los auxilios recibidos por sus padres; el de los días de Senaquerib, cuando murieron ciento ochenta y cinco mil hombres,"
,"20":"y el que tuvo lugar en Babilonia en la batalla contra los gálatas, en la que lucharon ocho mil judíos y cuatro mil macedonios; y a pesar de que los macedonios no sabían qué hacer, los ocho mil judíos aniquilaron a ciento veinte mil enemigos con la ayuda que les vino del cielo, y consiguieron un gran botín."
,"21":"Con estas palabras les infundió valor, los dispuso a morir por la patria y sus leyes y dividió el ejército en cuatro alas."
,"22":"Al frente de cada una puso a sus hermanos Simón, José y Jonatán, cada uno con mil quinientos hombres."
,"23":"Mandó a Eleazar leer el libro sagrado, y dando como contraseña 'Dios ayuda', él mismo se puso al frente del primer escuadrón y cayó sobre Nicanor."
,"24":"Y con la ayuda del todopoderoso degollaron a más de nueve mil enemigos, hirieron y dejaron fuera de combate a la mayor parte del ejército de Nicanor, y a todos los pusieron en fuga."
,"25":"Se apoderaron del dinero de los que habían venido a comprarlos a ellos y los persiguieron largo trecho; pero a causa de la hora tardía, se vieron obligados a volverse."
,"26":"En realidad, era la vigilia del sábado, y por esta causa no prosiguieron la persecución."
,"27":"Recogieron las armas y el botín de los enemigos y celebraron el sábado, no cesando de alabar y bendecir a Dios, que los había salvado en aquel día y había comenzado a manifestarles su misericordia."
,"28":"Cuando pasó el sábado, distribuyeron el botín entre los damnificados, las viudas y los huérfanos, y lo demás se lo repartieron entre ellos y los suyos."
,"29":"Después hicieron oración en común a Dios misericordioso, suplicándole que se reconciliara plenamente con sus siervos."
,"30":"Lucharon contra Timoteo y Báquides, mataron a más de veinte mil y cayeron en su poder altas y sólidas fortalezas. Repartieron el abundante botín en dos partes iguales, una para ellos y otra para los débiles, los huérfanos, las viudas y los ancianos."
,"31":"Las armas tomadas al enemigo se guardaron cuidadosamente en lugares seguros; el resto del botín lo llevaron a Jerusalén."
,"32":"Mataron al filarca de Timoteo, hombre cruel que había hecho mucho mal a los judíos."
,"33":"Después, mientras celebraban el triunfo por la victoria en Jerusalén, quemaron vivos a los que, con Calístenes, habían incendiado las puertas del templo, los cuales se habían escondido en una casita. Así le dieron el pago merecido por su impiedad."
,"34":"Y el tres veces criminal Nicanor, que había traído miles de negociantes para comprar a los judíos,"
,"35":"con el auxilio de Dios quedó humillado por aquellos mismos que había despreciado; se quitó sus ricas vestiduras, huyó a través de los campos como esclavo fugitivo y llegó a Antioquía, profundamente avergonzado y entristecido por la pérdida de su ejército."
,"36":"Y el que se había propuesto pagar el tributo debido a los romanos con la venta de los que estaban en Jerusalén, afirmaba ahora que los judíos eran invencibles e invulnerables, pues tenían a Dios que luchaba por ellos, y cumplían las leyes impuestas por aquél."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Por aquel tiempo Antíoco tuvo que volverse de Persia cubierto de vergüenza."
,"2":"Había entrado en la ciudad de Persépolis, intentando saquear el templo y apoderarse de la ciudad; pero la muchedumbre empuñó las armas y atacó con gran ímpetu, y Antíoco con los suyos tuvo que huir avergonzado."
,"3":"Al llegar a Ecbatana, tuvo noticia de lo sucedido a Nicanor y a Timoteo."
,"4":"Lleno de ira, se propuso hacer pagar a los judíos la injuria recibida de quienes lo habían puesto en fuga. Y así mandó al conductor de su carro apresurar la marcha sin parar en el momento en que venía sobre él el juicio de Dios. Pues se decía, lleno de orgullo: 'En cuanto llegue a Jerusalén, haré de la ciudad un cementerio de judíos'."
,"5":"Pero el Señor, Dios de Israel, que lo ve todo, lo hirió con una llaga incurable e invisible. Pues no había terminado de hablar cuando sintió dentro de sí un insoportable dolor de entrañas, acompañado de agudos dolores en los intestinos."
,"6":"Y esto muy justamente, ya que había torturado las entrañas de otros con tormentos inauditos. Mas no por esto disminuyó su arrogancia, pues, lleno de orgullo y respirando ira contra los judíos, dio orden de apresurar más todavía la marcha."
,"7":"Pero sucedió que Antíoco se cayó del carro, lanzado a toda velocidad, con tan funesta caída, que todos los miembros de su cuerpo quedaron magullados."
,"8":"Aquel mismo que con arrogancia sobrehumana creía poder imperar a las olas del mar y soñaba poder pesar en su balanza las cimas de los montes, tenía que ser llevado en una litera, dando a todos testimonio evidente de la omnipotencia de Dios."
,"9":"Manaban gusanos del cuerpo de aquel criminal, y sus carnes, vivas aún, se caían a pedazos entre desgarramientos y dolores, apestando con su hedor a todo el ejército."
,"10":"El olor intolerable hacía que nadie se acercara a llevar a aquel que poco antes pensaba tocar los astros del cielo con su mano."
,"11":"Solamente entonces, torturado por aquellas llagas, comenzó a menguar en su extraordinaria soberbia y a darse cuenta de que aquel estado era un castigo de Dios, viendo que sus dolores aumentaban por momentos."
,"12":"No pudiendo soportar su propio hedor, dijo: 'Justo es someterse a Dios; el mortal no debe igualarse a él'."
,"13":"Y el malvado oraba a Dios -que no había de compadecerse de él-, y decía"
,"14":"que reedificaría y declararía libre aquella ciudad santa hacia la cual corría presuroso para arrasarla y convertirla en cementerio;"
,"15":"que igualaría en todo con los atenienses a aquellos judíos a quienes había negado la sepultura y que habían de ser arrojados, junto con sus hijos, para pasto de las fieras;"
,"16":"que adornaría el templo, sacrílegamente saqueado por él, con riquísimas ofrendas, devolviendo en mayor número sus vasos sagrados; que se comprometía a sufragar, con las propias rentas, todos los gastos de los sacrificios,"
,"17":"y, en fin, que se haría judío e iría por todos los lugares habitados proclamando el poder de Dios."
,"18":"Más aún; como ni así disminuían sus dolores, porque había venido sobre él el justo juicio de Dios, desesperado de su salud, escribió a los judíos esta carta en forma de súplica:"
,"19":"'A los honrados ciudadanos judíos, mucha salud, prosperidad y bienestar, el rey y general Antíoco."
,"20":"Si estáis bien, junto con vuestros hijos, y se cumplen vuestros deseos, damos gracias a Dios, teniendo confianza en los cielos."
,"21":"Yo, encontrándome enfermo, me acuerdo, agradecido, de vuestros honores y benevolencia. Volviendo de las regiones de Persia y habiendo contraído una enfermedad, me ha parecido necesario proveer a la seguridad común de todos."
,"22":"No es que desespere de mi estado, ya que confío seguramente librarme de esta enfermedad."
,"23":"Pero considerando que también mi padre, siempre que emprendía una expedición militar en el norte, designaba un futuro sucesor"
,"24":"para que sus súbditos no se turbaran si sucedía algún hecho imprevisto o llegaba alguna noticia desagradable, sabiendo todos en manos de quién quedaba el poder;"
,"25":"y también, teniendo presente que los reyes limítrofes y príncipes vecinos están expiando la ocasión y esperando el momento oportuno, he designado rey a mi hijo Antíoco, a quien ya os había presentado y recomendado muchísimo cuando tenía que ir a las regiones del norte. A él le he escrito la carta que va a continuación."
,"26":"Os pido que, teniendo en cuenta el bien común y el de cada uno, conservéis vuestra benevolencia hacia mí y hacia mi hijo."
,"27":"Estoy seguro de que él, siguiendo mis órdenes, usará con vosotros de moderación y humanidad'."
,"28":"De esta forma pasó de esta vida aquel homicida y blasfemo, sufriendo tormentos atroces. Murió entre montes y en tierra extraña, con una muerte miserable."
,"29":"El cuerpo fue transportado por Filipo, coetáneo suyo, que, no fiándose del hijo de Antíoco, se retiró a Egipto, a la corte de Tolomeo Filométor."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Con la ayuda de Dios, el Macabeo y los suyos se apoderaron del templo y de la ciudad."
,"2":"Destruyeron las aras puestas por los extranjeros en las plazas públicas y los altares idolátricos."
,"3":"Purificaron el templo, hicieron otro altar, sacaron fuego del pedernal, encendieron de nuevo la luz y el fuego y ofrecieron sacrificios; quemaron incienso y ofrecieron los panes de la proposición, renovándolo todo, después de una interrupción de dos años."
,"4":"Después, postrados en tierra, pedían al Señor que no volvieran ya a caer jamás en semejantes males; sino que, si de nuevo cometían la iniquidad, los castigara él mismo blandamente, sin entregarlos de nuevo en manos de gentiles, salvajes y blasfemos."
,"5":"Así sucedió que, precisamente en el día en que los extranjeros habían profanado el templo, ese mismo día se hizo la purificación, es decir, el 25 del mes de quisleu."
,"6":"Durante ocho días celebraron con regocijo la fiesta como la de los tabernáculos, recordando que poco antes habían pasado la fiesta de los tabernáculos en montes y cuevas, como si fueran animales salvajes."
,"7":"Por esto, llevando en sus manos tirsos, ramos verdes y palmas, elevaban himnos a aquel que todo lo había dispuesto felizmente hasta llegar a la restauración y purificación del templo."
,"8":"Se publicó un decreto, en el que se ordenaba que todo el pueblo judío debería conmemorar tales fiestas todos los años."
,"9":"Éste fue el fin de Antíoco, llamado Epífanes."
,"10":"Vamos ahora a narrar los acontecimientos sucedidos bajo Antíoco Eupátor, hijo del criminal, resumiendo los continuos males causados por las guerras."
,"11":"Al empuñar las riendas del gobierno, puso al frente de los negocios a un tal Lisias, jefe supremo de Celesiria y de Fenicia."
,"12":"Pues bien, Tolomeo, llamado Macrón, que amaba la justicia con los judíos, cansado de las injusticias cometidas contra ellos, se esforzaba en tratarlos pacíficamente."
,"13":"Pero, por esto mismo, fue acusado por los cortesanos ante Eupátor. Con frecuencia era acusado de traidor por haberse pasado al partido de Antíoco Epífanes, abandonando la isla de Chipre, que tenía en nombre de Filométor. Creyendo que ya no podría desempeñar con decoro tan alto cargo, desesperado, se envenenó, y así acabó la vida."
,"14":"Fue entonces cuando Gorgias, nombrado general de aquellas regiones, comenzó a reunir tropas mercenarias y a hostigar sin tregua a los judíos."
,"15":"También entonces los idumeos, dueños de fortalezas muy importantes, instigaban a los judíos, acogían a los que huían de Jerusalén y procuraban fomentar la guerra."
,"16":"Pero los soldados del Macabeo, después de hacer súplicas y pedir al Señor que viniera a luchar a su lado, atacaron las fortalezas de los idumeos."
,"17":"Dieron el asalto valerosamente y se apoderaron de las plazas fuertes; rechazaron a los que venían en su auxilio, degollaron a cuantos cayeron en sus manos y mataron a más de veinte mil."
,"18":"No menos de nueve mil hombres se refugiaron en dos torres fortísimas, con todo lo necesario para resistir un asedio prolongado."
,"19":"El Macabeo, dejando a Simón, José, Zaqueo y a los que con ellos estaban con fuerzas suficientes para mantener el asedio, se marchó a donde más urgía su presencia."
,"20":"Los soldados de Simón, seducidos por la avaricia, se dejaron comprar a precio de plata por los de las torres y, por setenta mil dracmas, dejaron escapar cierto número de ellos."
,"21":"Cuando el Macabeo se enteró, reunió a los jefes del pueblo y los recriminó por haber dejado escapar libres a los enemigos de sus hermanos, traicionando a éstos por dinero."
,"22":"Los condenó a muerte como traidores, e inmediatamente se apoderó de las torres."
,"23":"Mató a más de veinte mil en las dos fortalezas, dando así feliz remate a las empresas que había emprendido."
,"24":"Timoteo, que había sido vencido antes por los judíos, reunió una tropa ingente de mercenarios; unió a esta fuerza una buena parte de la caballería de Asia y se encaminó a Judea para hacer la guerra y apoderarse de ella."
,"25":"Cuando los del Macabeo supieron que se iban acercando, hicieron súplicas a Dios con la cabeza cubierta de ceniza y los lomos ceñidos con cilicios."
,"26":"Prosternados ante el altar, pedían a Dios que se mostrara propicio y fuera enemigo de sus enemigos y adversario de sus adversarios, como está escrito en la ley."
,"27":"Terminada la oración, tomaron las armas y salieron de la ciudad. Cuando llegaron cerca del enemigo, se detuvieron."
,"28":"Al salir el sol, se entabló la batalla. Unos llevaban como garantía de éxito y de victoria, además del valor y esfuerzo personal, la confianza ciega en su Señor; los otros, en cambio, sólo su propio odio."
,"29":"Cuando estaba más trabada la batalla, los enemigos vieron en el cielo cinco hombres resplandecientes que, montados sobre caballos con bridas de oro, defendían y acaudillaban a los judíos."
,"30":"Rodeando al Macabeo, dos de ellos lo defendían con las armas, lo hacían invulnerable y, al mismo tiempo, lanzaban flechas y rayos contra el enemigo, que caía y se dispersaba en el mayor desorden, herido de ceguera."
,"31":"Murieron veinte mil quinientos de a pie y seiscientos de a caballo."
,"32":"Timoteo huyó y se refugió en la fortaleza bien amurallada de Guézer, donde mandaba Quereas."
,"33":"Las fuerzas del Macabeo asediaron con todo entusiasmo la fortaleza durante cuatro días."
,"34":"Los de dentro, seguros y confiados en la robustez de la fortaleza, proferían maldiciones e insultos."
,"35":"Pero al amanecer del día quinto, veinte jóvenes de las tropas del Macabeo, encendidos de indignación por las blasfemias, se subieron valerosamente sobre la muralla y mataron a cuantos cayeron en sus manos."
,"36":"Otros, en tanto, subieron igualmente a la muralla, prendieron fuego a las torres y a las puertas y encendieron hogueras en las que quedaron abrasados vivos los blasfemos; derribaron las puertas, entraron todos los demás y se apoderaron de la ciudad."
,"37":"Mataron a Timoteo, que se había escondido en una cisterna; a Quereas, su hermano, y a Apolófanes."
,"38":"Después entonaron himnos y alabanzas al Señor, que había engrandecido a Israel y le había dado la victoria."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Poco tiempo después, Lisias, tutor del rey, pariente suyo y gobernador del reino, muy disgustado por estas cosas,"
,"2":"reunió casi ochenta mil hombres y todas las fuerzas de caballería y fue contra los judíos, dispuesto a hacer de Jerusalén una ciudad para los griegos,"
,"3":"someter a tributo el templo, así como los demás santuarios de los gentiles, y hacer del sumo sacerdocio un oficio que se debiera comprar anualmente."
,"4":"No se preocupaba para nada del temor de Dios, pagado y seguro como estaba con sus miríadas de soldados de infantería, sus millares de caballería y sus ochenta elefantes."
,"5":"Puso pie en Judea y se acercó a Bet Sur, plaza bien guarnecida y estratégica, situada en un desfiladero y a unos veinticinco kilómetros de Jerusalén, y la sitió."
,"6":"Cuando los hombres del Macabeo supieron que se ponía sitio a sus fortalezas, suplicaron al Señor, en unión con el pueblo, con gemidos y llantos, que se dignara enviar un ángel para salvar a Israel."
,"7":"Enseguida el Macabeo, tomando el primero las armas, exhortaba a los demás a unirse con él en el peligro para socorrer a sus hermanos."
,"8":"Cerca todavía de Jerusalén, mientras todos marchaban con ánimo igualmente decidido, se vio a la cabeza de ellos un jinete vestido de blanco, con armadura de oro, que hacía vibrar su lanza."
,"9":"Todos a una bendijeron a Dios misericordioso; y de tal forma cobraron ánimo y valor, que se sentían capaces de acometer no sólo a hombres, sino a fieras y aun a penetrar los muros de hierro."
,"10":"En esta forma marchaban en orden de batalla, teniendo a la cabeza aquel auxiliar celestial, señal de que el Señor se había compadecido de ellos."
,"11":"Llegado el momento, se lanzaron como leones sobre el enemigo; mataron a once mil soldados de infantería, a mil seiscientos de caballería, y pusieron en fuga a todos los demás."
,"12":"Todos tuvieron que huir, pero desarmados y heridos. Hasta el mismo Lisias hubo de ponerse a salvo con una fuga vergonzosa."
,"13":"Lisias, que era hombre cuerdo, meditando su derrota y viendo que los hebreos eran invencibles, ya que tenían por aliado al mismo Dios omnipotente,"
,"14":"envió mensajeros a los hebreos con ofrecimiento de entenderse con ellos a base de condiciones justas, y prometerles que él mismo persuadiría al rey a hacerse amigo de ellos."
,"15":"El Macabeo accedió, mirando por el bien común, a las ofertas de Lisias. Y, en efecto, el rey concedió todo lo que el Macabeo exigió a Lisias por escrito."
,"16":"La carta de Lisias decía así: 'Lisias al pueblo de los judíos, salud."
,"17":"Juan y Absalón, embajadores vuestros, nos han hecho entrega de vuestras peticiones por escrito y nos han suplicado que ejecutemos lo contenido en ellas."
,"18":"He expuesto al rey cuanto era conveniente exponerle, y él ha concedido todo lo que era razonable."
,"19":"Si vosotros conserváis vuestra buena voluntad para con los intereses del reino, yo, por mi parte, en adelante procuraré favoreceros y haceros bien."
,"20":"En cuanto a los pormenores, ya he encargado a vuestros embajadores y a los míos que los discutan con vosotros."
,"21":"Conservaos bien. El año 148, 24 del mes de Júpiter Corintio'."
,"22":"La carta de Antíoco decía así: 'El rey Antíoco, a su hermano Lisias, salud."
,"23":"Trasladado nuestro padre a los dioses, y deseando que todos nuestros súbditos puedan preocuparse de sus negocios sin temor alguno,"
,"24":"habiendo sabido que los judíos no quieren adoptar los usos helénicos, como deseaba nuestro padre, sino que prefieren conservar sus instituciones, pidiéndonos que les dejemos con sus leyes,"
,"25":"y deseando por nuestra parte que esta nación viva en paz, hemos decretado que les sea restituido el templo y se les deje vivir según las leyes y costumbres de sus mayores."
,"26":"Harás bien si envías embajadores para estipular la paz, a fin de que, sabiendo nuestra voluntad real, estén contentos y puedan dedicarse con alegría a sus propios intereses'."
,"27":"La carta del rey al pueblo de los judíos es ésta: 'El rey Antíoco al consejo de los ancianos y al pueblo judío, salud."
,"28":"Si gozáis de buena salud, nos alegramos de ello; también nosotros estamos bien."
,"29":"Nos ha informado Menelao que deseáis volveros a vuestras casas;"
,"30":"por tanto, todos los que para ello se pongan en camino antes del 30 del mes de xántico contarán con nuestra protección y seguridad."
,"31":"Los judíos podrán en adelante vivir según sus costumbres en cuanto a las comidas y gobernarse por sus propias leyes, como antes, y nadie será molestado por todo lo que hubiera hecho por ignorancia."
,"32":"He mandado a Menelao para que os confirme en estas seguridades y garantías."
,"33":"Conservaos bien. El año 148, el día 15 del mes de xántico'."
,"34":"También los romanos les enviaron una carta, que decía así: 'Quinto Memmio y Tito Manlio, legados de los romanos, a los de la nación de los judíos, salud."
,"35":"Todo lo que Lisias, pariente del rey, os ha otorgado, también nos parece bien a nosotros."
,"36":"Referente a lo que Lisias creyó conveniente informar y consultar con el rey, estudiad diligentemente el asunto y enviadnos enseguida a alguien, a fin de que nosotros podamos exponer al rey todo de un modo conveniente para vosotros, pues ahora nos dirigimos a Antioquía."
,"37":"Apresuraos a enviar alguno que nos exponga claramente vuestros deseos."
,"38":"Conservaos bien. El quince del mes de xántico del año ciento cuarenta y ocho'."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Una vez hechos estos tratados, Lisias volvió a la corte del rey, y los judíos comenzaron a entregarse a las labores del campo."
,"2":"Pero los jefes de las diversas regiones, Timoteo y Apolonio, hijo éste de Genneo, así como Jerónimo y Demofón, además de Nicanor, jefe de los chipriotas, no los dejaban gozar de paz y de reposo."
,"3":"Además, los habitantes de Jafa cometieron un enorme crimen. Con el pretexto de agasajar a los judíos que vivían entre ellos, los invitaron a subir con sus mujeres y sus hijos a una nave que tenían preparada, como si no tuvieran contra ellos intención alguna hostil."
,"4":"Los judíos, fiados en un documento respaldado por todos los ciudadanos, aceptaron, pues querían la paz a todo trance, sin sospechar mal alguno. Pero, cuando estuvieron en alta mar, los hundieron. Serían como doscientas personas."
,"5":"Cuando el Macabeo se enteró de la crueldad cometida contra sus compatriotas, llamó a los que estaban con él, invocó a Dios, justo juez, y"
,"6":"marchó contra los asesinos de sus hermanos. Prendió fuego al puerto por la noche, abrasó las naves y pasó a cuchillo a cuantos se habían refugiado en ellas."
,"7":"No pudiendo entrar en la ciudad porque habían cerrado las puertas, se retiró con intención de volver otra vez y exterminar de raíz a todos los habitantes de Jafa."
,"8":"Supo, entre tanto, que los de Yamnia se proponían usar el mismo sistema contra los judíos que vivían entre ellos."
,"9":"Cayó de noche sobre los yamnitas e incendió las naves y el puerto, de forma que se veía el resplandor desde Jerusalén, a una distancia de cuarenta y cinco kilómetros."
,"10":"A un kilómetro y medio de allí, cuando marchaban contra Timoteo, salieron contra ellos más de cinco mil soldados de infantería y quinientos de caballería, árabes."
,"11":"Se entabló una fuerte batalla, en la cual los de Judas, con la ayuda de Dios, salieron vencedores. Aquellos árabes nómadas, al verse vencidos, pidieron la paz. Por ella se comprometían a darles ganado y ayudarles cuanto pudiesen."
,"12":"Judas se convenció de que podrían ser útiles, y accedió a hacer con ellos la paz. Una vez hecha, se volvieron a sus tiendas."
,"13":"Judas asaltó una ciudad fortificada con foso y murallas. Vivían en ella gentes de todas las razas, y se llamaba Caspín."
,"14":"Los sitiados, fiados en la solidez de los muros y en los depósitos de víveres, despreciaban villanamente a los de Judas, llenándolos de injurias, blasfemando y profiriendo afrentas y palabras horribles."
,"15":"Pero Judas y sus soldados, en el nombre del gran Señor del universo, que en tiempo de Josué, sin arietes ni máquinas de guerra había derribado las murallas de Jericó, se lanzaron feroces contra la muralla."
,"16":"Dios quiso que se apoderaran de la ciudad, y entonces hicieron tal carnicería que un lago vecino, de cuatrocientos metros de ancho, parecía lleno de sangre."
,"17":"Tras una marcha de ciento cuarenta kilómetros llegaron a Jaraca, donde vivían los judíos llamados tubienses."
,"18":"No pudieron encontrar allí a Timoteo, pues se había ido de aquel lugar sin haber decidido nada, dejando en él una guarnición bien fortificada."
,"19":"Dositeo y Sosípatro, jefes de las tropas del Macabeo, marcharon contra ella y aniquilaron la guarnición dejada por Timoteo, de más de diez mil hombres."
,"20":"El Macabeo ordenó su ejército en divisiones, puso a aquellos dos al frente de ellas y marchó contra Timoteo, que tenía una fuerza de ciento veinte mil soldados de infantería y dos mil quinientos de caballería."
,"21":"Timoteo, informado de que Judas marchaba contra él, envió las mujeres, los niños y los bagajes a una fortaleza llamada Carnión, lugar inexpugnable y de acceso difícil por lo quebrado del terreno."
,"22":"Al presentarse la primera división de Judas, el miedo y el pánico se apoderó de los enemigos como consecuencia de una aparición de aquel que todo lo ve. Se dieron a la fuga, unos por un lado, otros por otro, de forma que eran arrastrados por sus propios compañeros y heridos por sus mismas espadas."
,"23":"Judas los perseguía con furia y ardor, y acuchilló y mató a unos treinta mil de aquellos criminales."
,"24":"Timoteo vino a caer en manos de las tropas de Dositeo y Sosípatro. Pedía con gran astucia que le perdonasen la vida, pues estaban en sus manos los padres y hermanos de muchos judíos, los cuales no serían perdonados si le mataban a él."
,"25":"Como dio muchas seguridades de que los devolvería a todos sanos y salvos, le dieron libertad para salvar la de sus hermanos."
,"26":"Judas marchó contra Carnión y contra el santuario de Atargates, y mató no menos de veinticinco mil hombres."
,"27":"Después se dirigió a Efrón, ciudad fuerte donde vivía Lisias y una población cosmopolita. Jóvenes robustos, alineados sobre los muros, se defendían con valor y brío, abundantemente provistos de proyectiles y de máquinas."
,"28":"Pero, después de invocar el auxilio de Dios omnipotente, cuya fuerza aplasta los poderes enemigos, se apoderaron de la ciudad y mataron a veinticinco mil de los que había dentro de ella."
,"29":"Desde allí marcharon contra Escitópolis, que distaba ciento catorce kilómetros de Jerusalén."
,"30":"Pero los judíos que vivían allí dieron garantías de la simpatía de los escitopolitanos para con los judíos y de que, en los días de desgracia, habían tenido con ellos muchas deferencias."
,"31":"Judas y sus hombres les dieron las gracias, encareciéndoles que fueran siempre benévolos con su pueblo; después se volvieron a Jerusalén, pues ya estaba cercana la fiesta de pentecostés."
,"32":"Después de la fiesta de pentecostés marcharon contra Gorgias, gobernador de Idumea."
,"33":"Éste salió a su encuentro con tres mil soldados de infantería y cuatrocientos de caballería."
,"34":"Se entabló la batalla y cayeron algunos de la parte de los judíos."
,"35":"Un tal Dositeo, de Bacenor, valiente caballero, agarró a Gorgias por el manto y tiraba de él con fuerza para apoderarse de aquel criminal vivo. Un caballero tracio que lo vio, se lanzó contra Dositeo y le cortó el brazo, y así Gorgias pudo escapar y refugiarse en Maresá."
,"36":"Las tropas de Esdrías estaban desfallecidas por tan larga batalla, pero Judas oró al Señor pidiendo que se manifestara como aliado suyo y caudillo en la batalla."
,"37":"Luego, entonando un canto de guerra en lengua patria, se lanzó de improviso contra las tropas de Gorgias y las puso en fuga."
,"38":"Judas reunió su ejército y lo llevó a Odolán. El día séptimo se purificaron, según la costumbre, y celebraron la solemnidad del sábado."
,"39":"Al día siguiente, porque ya urgía, los hombres de Judas fueron a recoger los cuerpos de los muertos y darles sepultura con los suyos, en el sepulcro de sus padres."
,"40":"Bajo la túnica de cada uno de los muertos encontraron objetos consagrados a los ídolos de Yamnia, prohibidos por la ley a los judíos. Entonces todos comprendieron que habían muerto por esto."
,"41":"Todos a una bendijeron al Señor, justo juez, que descubre las cosas ocultas."
,"42":"Y oraron al Señor pidiendo que aquel pecado les fuera plenamente perdonado. Judas exhortó a sus tropas a conservarse sin culpa, pues habían visto lo que había sucedido por el pecado de aquellos que habían muerto."
,"43":"Hizo una colecta soldado por soldado y reunió hasta dos mil dracmas de plata, que envió a Jerusalén para que ofrecieran un sacrificio por el pecado: acción elevada y noble, inspirada en el pensamiento de la resurrección."
,"44":"Puesto que si él no hubiera esperado que aquellos muertos habían de resucitar, vano y superfluo hubiera sido orar por ellos."
,"45":"Pero creyendo firmemente que está reservada una gran recompensa a los que mueren piadosamente,"
,"46":"idea santa y piadosa, por eso ofreció el sacrificio por los difuntos, para que Dios les perdonase sus pecados."
}`)
	CurrentBook.AddChapter(13, `{
"1":"En el año 149 las tropas de Judas se enteraron de que Antíoco, llamado Eupátor, venía a Judea con aguerridas y numerosas fuerzas,"
,"2":"y que con él venía Lisias, tutor y regente. Cada uno de ellos mandaba un ejército griego de ciento diez mil soldados de infantería, cinco mil trescientos de caballería, veintidós elefantes y unos trescientos carros de guerra armados con hoces."
,"3":"A ellos se unió Menelao, que adulaba hipócritamente a Antíoco, no para salvar a la patria, sino con la esperanza de ser repuesto en el poder."
,"4":"Pero el Rey de reyes despertó la ira de Antíoco contra este malvado cuando Lisias hizo ver al rey que Menelao era la causa de todos los males. Entonces el rey ordenó que lo llevaran a Berea y lo mataran según la costumbre de aquel lugar."
,"5":"Se alza allí una torre de veinticinco metros, llena de cenizas ardientes y que hace resbalar a las cenizas lo que se le pone encima."
,"6":"Con ella arrojan a las cenizas a los sacrílegos, ladrones o autores de otros crímenes horrendos."
,"7":"De esta forma fue a morir Menelao, sin que ni siquiera pudiese recibir sepultura."
,"8":"Castigo justísimo. Él había cometido muchos delitos contra el altar, cuyo fuego y ceniza son santos. Y en la ceniza encontró la muerte."
,"9":"El rey venía con el corazón lleno de propósitos salvajes, dispuesto a tratar a los judíos peor que su padre."
,"10":"Judas, al saberlo, mandó al pueblo que invocara a Dios día y noche, para que, como siempre, también ahora viniera en ayuda de los que temían verse privados de la ley, de la patria y del templo,"
,"11":"y para que aquel pueblo, que apenas había gozado un poco de libertad, no cayera de nuevo en manos blasfemas."
,"12":"Cumplieron esta orden e invocaron a Dios misericordioso con gemidos, ayunos y oraciones en común durante tres días. Judas los arengó y dio orden de estar preparados."
,"13":"Después de celebrar consejo con los ancianos, resolvió tomar la ofensiva y salir a resolver la situación antes de que el ejército del rey pudiera poner pie en Judea y se apoderara de la ciudad."
,"14":"Lo puso todo en manos de Dios y exhortó a sus tropas a luchar heroicamente hasta la muerte por las leyes, por el templo y la ciudad, por la patria y las instituciones de los mayores."
,"15":"Llegó con su ejército y acampó cerca de Modín. Les dio esta contraseña: 'Victoria de Dios'; y en seguida, con un puñado de jóvenes, los más selectos y valerosos, cayó por la noche sobre la tienda del rey y acuchilló hasta dos mil hombres y el mayor de los elefantes con la gente que llevaba encima."
,"16":"Se retiraron gozosos por la victoria, dejando el campo lleno de espanto y de terror."
,"17":"Al amanecer, todo había concluido gracias a la ayuda de Dios."
,"18":"El rey, al ver la valentía de los judíos, procuraba tantear las fortalezas, valiéndose de estratagemas."
,"19":"Llegó ante Betsur, plaza bien guarnecida por los judíos; la atacó, pero fue rechazado y vencido."
,"20":"Judas se preocupaba de proveer a los sitiados de todo lo necesario."
,"21":"Rodoco, uno de los hombres de Judas, descubrió secretos a los enemigos; pero lo encontraron, lo encarcelaron y lo ajusticiaron."
,"22":"El rey volvió a tener contacto con los defensores de Betsur, hizo la paz con ellos y se retiró. Cayó sobre las tropas de Judas, pero fue derrotado."
,"23":"Tuvo noticia de que Filipo, a quien había dejado al frente del reino en su ausencia, se había sublevado, y quedó consternado. Pidió la paz a los judíos y juró acceder a sus justas peticiones. Se reconcilió con ellos, ofreció sacrificios, llenó de honores el templo y lo trató con benevolencia."
,"24":"Distinguió al Macabeo y le nombró gobernador desde Tolemaida hasta Guerar."
,"25":"Vino a Tolemaida, donde sus habitantes se mostraron disgustados por aquellas condiciones de paz y, llenos de indignación, querían romper aquellas estipulaciones."
,"26":"Lisias subió a la tribuna para defender su causa. Los persuadió, los tranquilizó, los dejó bien dispuestos y partió para Antioquía. Éstos fueron los sucesos acaecidos en la retirada del rey."
}`)
	CurrentBook.AddChapter(14, `{
"1":"A los tres años, los de Judas se enteraron de que Demetrio, hijo de Seleuco, había desembarcado en Trípoli con un poderoso ejército y una gran flota,"
,"2":"y que se había hecho dueño del reino, matando a Antíoco y a su tutor, Lisias."
,"3":"Un tal Alcimo, que había llegado a ser sumo sacerdote, pero que en los días de la confusión se había contaminado voluntariamente, creyendo que no habría para él otra forma de salvación y de acercarse de nuevo al altar,"
,"4":"se presentó a Demetrio, hacia el año 151, y le regaló una corona de oro, una palma y unos ramos de olivo, que se creían procedentes del templo. Aquel día no pidió nada."
,"5":"Pero encontró ocasión propicia para su astucia cuando Demetrio le llamó al consejo y le preguntó en qué disposición y voluntad se encontraban los judíos; él respondió:"
,"6":"'La secta de los judíos llamada asideos, cuyo caudillo es Judas Macabeo, fomenta guerras y sediciones y no deja al reino vivir en paz."
,"7":"Por esto yo, privado de la dignidad de mis antepasados, es decir, del sumo sacerdocio, me presento ahora aquí,"
,"8":"mirando lo primero por los intereses del rey, pero también por los de mis conciudadanos; pues por la locura de los asideos nuestra nación está hecha un desastre."
,"9":"Infórmate, oh rey, de todo esto; cuídate de nuestra tierra y de nuestra desventurada nación, motivo de tu amor desinteresado hacia todos."
,"10":"Mientras subsista Judas es imposible que las cosas vayan en paz'."
,"11":"Al oír esto, los amigos del rey, enemigos de Judas, encendieron aún más la ira de Demetrio."
,"12":"Éste eligió inmediatamente a Nicanor, antiguo jefe de la sección de elefantes, lo nombró general en Judea"
,"13":"y lo hizo partir con órdenes de matar a Judas, de dispersar sus tropas y de restablecer a Alcimo como sumo sacerdote del magnífico templo."
,"14":"Los gentiles, que habían huido de Judea por temor a Judas, se agregaron en grandes grupos a Nicanor, pensando que las desgracias y las desventuras de los judíos serían su propia fortuna."
,"15":"Cuando los judíos se enteraron de la venida de Nicanor y de la invasión de los gentiles, se cubrieron de polvo y oraron a Dios, que había establecido su pueblo para siempre y protegido constantemente su heredad con milagros manifiestos."
,"16":"Luego se pusieron en marcha a las órdenes de su caudillo; el enfrentamiento tuvo lugar en la aldea de Desau."
,"17":"Simón, hermano de Judas, atacaba a Nicanor; pero sus tropas dudaron un momento, estupefactas por la repentina llegada de enemigos."
,"18":"A pesar de esto, Nicanor, conociendo el valor de los de Judas y el entusiasmo con que luchaban por la patria, no quiso aventurarse a ponerlo todo a prueba de sangre."
,"19":"Esto le movió a enviar a Posidonio, Teodoto y Matatías a ofrecer la paz."
,"20":"Después de larga deliberación, y oída la voz del pueblo, convinieron en concertar la paz."
,"21":"Se pusieron dos sillas, una frente a otra."
,"22":"Judas había dejado en sitios estratégicos hombres armados, dispuestos a intervenir, por temor de alguna perfidia imprevista por parte de los enemigos; pero tuvieron una buena entrevista."
,"23":"Nicanor permaneció en Jerusalén sin hacer mal alguno, y disolvió las tropas que se le habían agregado."
,"24":"Y tenía siempre a Judas en su presencia, pues lo amaba sinceramente."
,"25":"Le exhortó a casarse y a tener hijos. Se casó, y vivió tranquilamente en paz."
,"26":"Pero Alcimo, viendo lo bien que se entendían los dos y haciéndose con una copia de los pactos concertados, se presentó a Demetrio, acusando a Nicanor de traidor de los intereses del Estado, ya que había nombrado sucesor suyo a Judas, enemigo y perturbador del reino."
,"27":"El rey, exasperado e inducido por las calumnias de aquel malvado, escribió a Nicanor, diciéndole que no le agradaban los pactos concertados y que inmediatamente se le enviara preso a Antioquía a Judas."
,"28":"Nicanor quedó consternado y disgustado, pues no quería romper lo pactado, ya que Judas no había hecho nada malo."
,"29":"Pero no pudiendo oponerse a las órdenes del rey, buscaba una ocasión favorable para cumplirlas por medio de alguna estratagema."
,"30":"El Macabeo, viendo que Nicanor le demostraba un trato más reservado y frío en las entrevistas acostumbradas, comprendió que aquella conducta no podría proceder de cosa buena. Reunió a algunos de los suyos y no se dejó ver ya más de Nicanor."
,"31":"Nicanor, dándose cuenta de que Judas había desaparecido con astucia, subió al templo a la misma hora que los sacerdotes ofrecían la víctima y les mandó que le entregaran al Macabeo."
,"32":"Ellos juraron que no sabían dónde estaba el hombre que él buscaba. Nicanor extendió la mano hacia el templo, y juró así:"
,"33":"'Si no me entregáis preso a Judas, arrasaré este lugar, destruiré el altar y levantaré en su lugar un magnífico templo a Baco'."
,"34":"Dicho esto, se fue. Los sacerdotes, elevando las manos al cielo, suplicaban a quien siempre se había mostrado en defensa de nuestro pueblo, diciendo:"
,"35":"'Tú, Señor de todo el universo, que de nada necesitas, has querido que fuera levantado este templo y morada tuya entre nosotros."
,"36":"Pues bien, oh santo de toda santidad, Señor, conserva para siempre incontaminada esta morada tuya, que hace poco ha sido purificada'."
,"37":"Razías, uno de los ancianos de Jerusalén, varón amante de la ciudad, de muy buena fama y llamado por su bondad 'padre de los judíos', fue denunciado a Nicanor."
,"38":"En el anterior período de confusión había sido acusado de judaísmo, y por el judaísmo había expuesto su cuerpo y su vida con invencible constancia."
,"39":"Pues bien, Nicanor, queriendo mostrar su odio contra los judíos, mandó más de quinientos soldados a prenderlo."
,"40":"Creía que con la prisión de éste daba un grave golpe a los demás."
,"41":"Cuando ya los soldados estaban a punto de ocupar las torres y forzar la puerta de entrada y dada la orden de prenderle fuego, Razías, rodeado por todas partes, hundió en sí mismo su espada,"
,"42":"prefiriendo morir valerosamente antes que caer en manos extrañas y sufrir ultrajes indignos de su noble origen."
,"43":"Pero con las prisas, no se hizo una herida mortal y, cuando los soldados estaban a punto de penetrar por las puertas, se arrastró valerosamente sobre el muro y se arrojó varonilmente encima de los soldados."
,"44":"Al verlo, se retiraron rápidamente, y vino a caer en el espacio vacío que se había formado."
,"45":"No había muerto todavía y, encendido en valor, se levantó a pesar de la sangre que perdía por todas partes, pasó corriendo a través de los soldados,"
,"46":"se subió a una roca, y allí, casi sin sangre, se agarró los intestinos con ambas manos y los tiró sobre los soldados, pidiendo al Señor de la vida y del espíritu que un día se los devolviera; y así murió."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Nicanor, enterado de que Judas y su gente andaban por Samaría, se dispuso a atacarlos con toda seguridad un día de sábado."
,"2":"Los judíos, que le acompañaban por la fuerza, le decían: 'No intentes aniquilarlos tan feroz y tan salvajemente; ten respeto al día de sábado, honrado y declarado santo por aquel que todo lo ve'."
,"3":"Pero el malvado preguntó si, en efecto, había en el cielo un poderoso que hubiera ordenado santificar el día del sábado."
,"4":"Ellos le respondieron: 'Hay un Señor vivo, soberano del cielo, que ha mandado celebrar el día séptimo'."
,"5":"'Pues yo -respondió él- soy soberano sobre la tierra, que mando tomar las armas y ejecutar los decretos reales'. Pero no pudo llevar a cabo su bárbaro proyecto."
,"6":"Nicanor, llegado al colmo de su orgullo, se había propuesto levantar un monumento a la victoria sobre Judas y los suyos."
,"7":"En cambio, el Macabeo esperaba ciegamente que Dios había de venir en su auxilio."
,"8":"Exhortaba a los suyos a que no temieran la venida de los gentiles, sino que, recordando las veces que anteriormente Dios les había auxiliado, creyeran que también ahora, ciertamente, el todopoderoso les daría la victoria."
,"9":"Encendió sus ánimos con palabras de la ley y los profetas, les trajo a la memoria las batallas ganadas y les infundió valor."
,"10":"Encendidos así los ánimos, les puso delante la perfidia de los gentiles y las transgresiones de los juramentos."
,"11":"Quedó con esto cada uno armado, no con escudos y lanzas, sino con palabras alentadoras. Confirmó todo esto narrándoles un sueño digno de fe, que a todos les llenó de alegría."
,"12":"El sueño era éste: Onías, dulce en el trato, de palabra elegante y que desde la niñez se había ejercitado en la virtud, con las manos levantadas oraba por el pueblo de los judíos."
,"13":"Vio también a otro varón, rodeado de majestad y gloria y de una augusta y maravillosa dignidad."
,"14":"Onías tomó la palabra y dijo: 'Éste es el amante de los hermanos, que ora mucho por el pueblo y por la ciudad; es el profeta de Dios, Jeremías'."
,"15":"Extendió su diestra y entregó a Judas una espada de oro y, al entregársela, dijo:"
,"16":"'Toma esta santa espada, don precioso que Dios te envía, con la cual destruirás a tus adversarios'."
,"17":"Animados con estas palabras de Judas, sumamente bellas y aptas para enardecer los corazones de los jóvenes, determinaron no estarse a la espera en el campo, sino más bien lanzarse valerosamente y luchar con todo brío; y así decidieron la causa, pues peligraba la ciudad, las cosas santas y el templo."
,"18":"Porque para ellos el mayor temor era el santuario santificado, y su temor por las mujeres, hijos, hermanos y parientes era menor."
,"19":"La angustia de los que se habían quedado en la ciudad no era pequeña, preocupados por la batalla que se iba a dar en el campo."
,"20":"Todos esperaban con ansia el próximo desenlace; los enemigos estaban preparados: el ejército en sitio conveniente, los elefantes en situación estratégica y la caballería en las alas;"
,"21":"el Macabeo, al ver la muchedumbre que tenía delante, el aparato de las diversas armas y su ferocidad, levantó las manos al cielo e invocó al Dios que hace maravillas; pues bien sabía que la victoria no depende de las armas, sino de aquel que la concede a quien ve digno de ella."
,"22":"Judas dijo en su invocación: 'Tú, oh Señor, que enviaste tu ángel en los días de Ezequías, rey de Judá, y mató a ciento ochenta y cinco mil del campamento de Senaquerib,"
,"23":"envía también ahora, oh Señor del cielo, tu ángel bueno delante de nosotros para hacerles temer y temblar con el poder de tu brazo."
,"24":"Sean quebrantados con la fuerza de tu brazo los que vienen blasfemando contra tu santo pueblo'. Y con esto dio fin a sus palabras."
,"25":"Entretanto, Nicanor y los suyos avanzaban entre el estruendo de las trompetas y los cantos de guerra."
,"26":"Por su parte, Judas y los suyos entraron en combate con súplicas y oraciones."
,"27":"Mientras combatían con las manos, con su corazón oraban a Dios; y así, magníficamente confortados con la presencia manifiesta de Dios, hicieron morder el polvo a no menos de treinta y cinco mil enemigos."
,"28":"Terminada la batalla, y mientras volvían llenos de alegría, vieron que el mismo Nicanor yacía en tierra muerto, con toda su armadura."
,"29":"Estalló entonces un gran clamor y alarido, bendiciendo al todopoderoso en su lengua patria."
,"30":"Y el que en cuerpo y alma estaba consagrado a la defensa de sus ciudadanos y había guardado para ellos un ánimo varonil, dio orden de que cortaran la cabeza de Nicanor y su brazo derecho hasta el húmero y los llevaran a Jerusalén."
,"31":"Al llegar allí, reunió a sus conciudadanos y, en especial, a los sacerdotes; se puso en pie ante el altar y mandó venir a los de la ciudadela."
,"32":"Mostró a todos la cabeza del malvado Nicanor y la mano que el blasfemo había levantado orgulloso sobre la misma santa morada del todopoderoso"
,"33":"y, cortando la lengua del blasfemo Nicanor, mandó darla a las aves y colgar la mano derecha delante del templo en castigo de su locura."
,"34":"Entonces todos levantaron sus ojos al cielo y alabaron al Señor de la gloria: 'Bendito aquel que ha conservado sin mancha su templo santo'."
,"35":"Judas ordenó que la cabeza de Nicanor fuera colgada en la ciudadela como señal manifiesta del auxilio de Dios."
,"36":"Por común acuerdo se decretó no dejar pasar este día sin solemnizarlo,"
,"37":"fijándose como día festivo el 13 del mes duodécimo, adar en arameo, día que precede a la fiesta de Mardoqueo."
,"38":"Ésta fue la historia de Nicanor. Como desde aquellos días la ciudad ha estado en poder de los hebreos, también yo pondré fin a mi obra."
,"39":"Si ésta ha sido buena y bien ordenada, eso es lo que he deseado; mas si ha sido mediocre e imperfecta, he hecho lo que he podido."
,"40":"Por lo demás, como el beber siempre vino solo o agua sola puede ser dañino, mientras que el vino mezclado con un poco de agua produce un sabor grato, así el arte de saber disponer el relato y la narración produce placer en los lectores. Y aquí doy fin a mi obra."
}`)

}
func ES_LSB_LoadVH2PChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Salomón, hijo de David, se afirmó sobre su trono. El Señor, su Dios, estaba con él y lo llevó a la cumbre de la grandeza."
,"2":"Salomón habló a todo Israel, a los jefes de millares y de centurias, a los jueces y a todos los jefes de Israel, es decir, a todos los jefes de familias."
,"3":"Y con toda la asamblea fue al alto de Gabaón, donde estaba la tienda de la reunión de Dios, que Moisés, siervo del Señor, había hecho en el desierto."
,"4":"David había llevado el arca de Dios de Quiriat Yearín al lugar que le había preparado en Jerusalén;"
,"5":"pero el altar de bronce hecho por Besalel, hijo de Urí y nieto de Jur, seguía en Gabaón delante de la morada del Señor, y allí fueron Salomón y la asamblea."
,"6":"Allí, en presencia de Dios, Salomón subió al altar de bronce, que estaba junto a la tienda de la reunión, y ofreció sobre él 1.000 holocaustos."
,"7":"Aquella misma noche Dios se apareció a Salomón y le dijo: 'Pide lo que quieras, y yo te lo daré'."
,"8":"Salomón respondió: 'Tú trataste con gran bondad a mi padre David, y a mí me has constituido rey en su lugar."
,"9":"Ahora se cumple, Señor Dios, la promesa hecha a mi padre David, ya que tú me has constituido rey sobre un pueblo numeroso como el polvo de la tierra."
,"10":"Dame sabiduría e inteligencia para gobernar con acierto a este pueblo; pues ¿quién podría gobernar a un pueblo tan numeroso como es tu pueblo?'."
,"11":"Dios dijo a Salomón: 'Puesto que éste ha sido tu deseo y no has pedido ni riquezas, ni hacienda, ni fama, ni siquiera larga vida, sino que has pedido sabiduría e inteligencia para gobernar a mi pueblo, sobre el que te he constituido rey,"
,"12":"te concedo la sabiduría y la inteligencia. Pero te daré también riquezas, hacienda y fama como no las tuvieron los reyes que te han precedido, ni las tendrán los que vengan detrás de ti'."
,"13":"Salomón salió de Gabaón, de la tienda de la reunión, y regresó a Jerusalén, donde reinó sobre Israel."
,"14":"Salomón reunió carros y caballos, llegando a tener 1.400 carros y 12.000 caballos, que destacó en las ciudades guarnición y en Jerusalén, junto al rey."
,"15":"El rey logró que la plata y el oro abundaran en Jerusalén como las piedras, y los cedros tan numerosos como los sicómoros en la Sefela."
,"16":"Los caballos para Salomón venían de Musur y de Cilicia, donde los mercaderes del rey los compraban al contado."
,"17":"Un carro por 600 monedas de plata y un caballo por 150. Por el mismo precio los mercaderes se los vendían también a los reyes hititas y sirios."
,"18":"Salomón decidió construir el templo del Señor y el palacio real."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Salomón reclutó 70.000 hombres para el transporte, 80.000 para sacar la piedra de las canteras y 3.600 para capataces."
,"2":"Luego mandó decir a Jirán, rey de Tiro: 'Haz conmigo lo que hiciste con David, mi padre, enviándole madera de cedro para construir la casa de su residencia."
,"3":"También yo estoy para construir un templo al nombre del Señor, mi Dios, para consagrarlo a él, quemar incienso y aromas ante él, tener siempre ante él los panes de la proposición, ofrecer holocaustos diarios, mañana y tarde, los sábados, los novilunios y las demás fiestas del Señor, nuestro Dios; así se hará siempre en Israel."
,"4":"Quiero construir un templo grandioso, porque grande, más que todos los dioses, es nuestro Dios."
,"5":"Pero ¿quién sería capaz de construir un templo digno de él, cuando ni todos los cielos lo pueden contener? ¿Quién soy yo para construir un templo, aunque sea sólo para quemar incienso en su honor?"
,"6":"Mándame un hombre experto, que sepa trabajar el oro, la plata, el bronce, el hierro, la escarlata, el carmesí y el jacinto; que conozca el arte de cincelar, para que dirija a los artífices que tengo conmigo en Judea y Jerusalén, puestos a mi disposición por mi padre David."
,"7":"Mándame también madera de cedro, ciprés y sándalo del Líbano, pues conozco bien la habilidad de tus súbditos en derribar los árboles del Líbano. Mis súbditos trabajarán con los tuyos."
,"8":"Prepárame madera en cantidad, pues el templo que quiero construir deberá ser magnífico y grandioso."
,"9":"A los maderistas que corten los árboles les daré 9.000 toneladas de trigo, 9.000 de cebada, 900 de vino y 900 de aceite para mantenimiento de tus siervos'."
,"10":"Jirán, rey de Tiro, respondió con una carta dirigida a Salomón: 'El Señor ama a su pueblo, por eso te ha constituido rey de Israel'."
,"11":"Y continuaba: 'Bendito sea el Señor, Dios de Israel, creador del cielo y de la tierra, que ha dado al rey David un hijo sabio, entendido, sensato y prudente, que está para construir un templo al Señor y un palacio real."
,"12":"Te envío un hombre experto y de gran habilidad, Jurán Abí,"
,"13":"hijo de una mujer danita, pero de padre tirio. Sabe trabajar el oro, la plata, el bronce, el hierro, la piedra, la madera, la escarlata, el jacinto, el lino, el carmesí, y grabar toda suerte de diseños y figuras. Trabajará con tus obreros y con los de tu padre David, mi señor."
,"14":"Mándame el trigo, la cebada, el aceite y el vino prometidos a tus siervos,"
,"15":"y te cortaremos toda la madera que necesites del Líbano, haciéndotela llegar en balsas hasta Jafa, donde la recogerás tú para llevarla a Jerusalén'."
,"16":"Salomón hizo el censo de todos los extranjeros residentes en Israel, después del que había hecho su padre David, y salieron 153.600."
,"17":"De éstos, 70.000 fueron empleados como transportistas, 80.000 como canteros y 3.600 como capataces."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Salomón comenzó la construcción del templo del Señor en Jerusalén, sobre el monte Moria, allí donde su padre había tenido la visión. Era el lugar preparado por David en la era de Ornán, el jebuseo."
,"2":"Comenzó la construcción el día veinte del segundo mes, el cuarto año de su reinado."
,"3":"Los cimientos puestos por Salomón para el templo de Dios tenían treinta metros de largo y diez de ancho."
,"4":"El vestíbulo de delante del santuario tenía diez metros de largo a lo ancho del edificio, cinco de ancho a lo largo del mismo y sesenta de alto. Su interior estaba revestido de oro puro."
,"5":"La nave central estaba revestida de madera de ciprés, recubierta de oro puro, con palmas y cadenetas grabadas."
,"6":"Lo recubrió con piedras preciosas como adorno; el oro era oro de Parvaín."
,"7":"Recubrió la nave, las vigas, jambas, paredes y puertas. Sobre las paredes hizo grabar querubines."
,"8":"Construyó; luego el lugar santísimo, de diez metros de largo, diez de ancho y diez de alto. Lo revistió de oro puro, por un peso total de unas veinte toneladas."
,"9":"Los clavos, de oro también, pesaban quinientos cincuenta gramos cada uno. Revistió también de oro las salas superiores."
,"10":"Hizo dos querubines en metal forjado para el lugar santísimo, y los recubrió de oro."
,"11":"Las alas de los querubines tenían en conjunto diez metros de largas; cada ala medía dos metros y medio. Un ala rozaba con la pared y la otra con el ala del otro querubín."
,"12":"Paralelamente, un ala del otro querubín rozaba también con la pared contraria, y la otra con el ala del otro querubín."
,"13":"Las alas de los querubines, desplegadas, medían diez metros. Los querubines estaban de pie, con sus rostros vueltos hacia dentro."
,"14":"Hizo la cortina de púrpura violeta, escarlata, carmesí y lino, con querubines bordados."
,"15":"Delante del templo levantó dos columnas de dieciséis metros de altura, rematadas por capiteles que medían dos metros y medio."
,"16":"Hizo también unas guirnaldas en forma de collar y las puso en los capiteles, y entrelazó cien granadas con las guirnaldas."
,"17":"Puso las columnas en la fachada del templo, una a la derecha y la otra a la izquierda; llamó yaquín a la de la derecha y boaz a la de la izquierda."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Hizo un altar de bronce de diez metros de largo, diez de ancho y cinco de alto."
,"2":"Hizo también una pila muy grande de bronce, redonda, de cinco metros de diámetro, dos y medio de alto y quince de perímetro."
,"3":"Bajo el borde había alrededor de la pila dos series de figuras como de toros, veinte cada metro, fundidas con la pila en una sola pieza."
,"4":"La pila descansaba sobre doce toros, tres de ellos vueltos al norte, tres al sur, tres al este y tres al oeste; y todas sus partes traseras quedaban hacia dentro."
,"5":"El grosor de la pila era de veintidós centímetros, y su borde era como el de una copa en forma de flor de loto; cabían unos ciento treinta y cinco mil litros."
,"6":"Hizo diez aguamaniles, cinco a la derecha y cinco a la izquierda, para lavar y purificar en ellos la víctima del holocausto. Los sacerdotes se lavaban en la pila."
,"7":"Hizo diez candelabros de oro, según la forma prescrita, y los puso en el templo, cinco a la derecha y cinco a la izquierda."
,"8":"Hizo diez mesas, que colocó en la nave central, cinco a la derecha y cinco a la izquierda. Hizo cien aspersorios de oro."
,"9":"Construyó el atrio de los sacerdotes, el gran atrio y sus puertas, que recubrió de bronce."
,"10":"La pila la colocó a distancia, al lado derecho, hacia el sudeste."
,"11":"Jurán hizo las calderas, las palas y los aspersorios, concluyendo así todo el trabajo que el rey Salomón le había encargado para el templo del Señor:"
,"12":"las dos columnas, las dos esferas para los capiteles de las dos columnas, las dos guirnaldas para cubrir las dos esferas de los capiteles"
,"13":"y las cuatrocientas granadas para las guirnaldas, dos series de granadas para cada guirnalda,"
,"14":"las diez basas y los diez aguamaniles,"
,"15":"la pila y los doce toros que la sostenían,"
,"16":"las calderas, los palos, los tenedores y todos sus accesorios. Todos estos utensilios que Jurán hizo al rey para el templo del Señor eran de bronce bruñido."
,"17":"El rey los hizo fundir en moldes de arcilla en la región del Jordán, entre Sucot y Seredá."
,"18":"Salomón hizo utensilios en gran número, pues la cantidad de bronce era incalculable."
,"19":"Salomón hizo todos los demás utensilios para el templo de Dios: el altar de oro y las mesas sobre las que se ponían los panes de la proposición;"
,"20":"los candelabros de oro puro para delante del lugar santísimo según la ley;"
,"21":"flores, lámparas y despabiladeras, todo de oro puro;"
,"22":"cuchillos, aspersorios, bandejas y despabiladeras, todo de oro puro; los quicios de las puertas del lugar santísimo y de la nave central también de oro."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Cuando se terminaron las obras que Salomón había mandado hacer en el templo del Señor, el rey trajo la plata, el oro y el mobiliario que su padre David había dedicado al Señor y lo depositó en el tesoro del templo."
,"2":"Salomón convocó en Jerusalén a los ancianos de Israel, a los jefes de las tribus y de las familias israelitas, para trasladar desde Sión, la ciudad de David, el arca de la alianza del Señor."
,"3":"Se reunieron en torno al rey Salomón todos los israelitas en la fiesta del séptimo mes."
,"4":"Cuando llegaron los ancianos de Israel, los levitas tomaron el arca"
,"5":"y la llevaron al templo con la tienda de la reunión y todos los utensilios sagrados que había en ella. La llevaron los sacerdotes y los levitas."
,"6":"El rey Salomón y toda la comunidad israelita, reunidos delante del arca, sacrificaban ovejas y bueyes en cantidad incalculable."
,"7":"Los sacerdotes pusieron el arca de la alianza del Señor en el lugar santísimo del templo, bajo las alas de los querubines,"
,"8":"pues los querubines tenían las alas extendidas sobre el arca, cubriendo el arca y sus barras."
,"9":"Las barras eran tan largas que se podían ver sus extremidades desde la nave central, que estaba delante del lugar santísimo, aunque no desde fuera; allí han estado hasta el presente."
,"10":"En el arca no había más que las dos tablas que puso allí Moisés en el Horeb, cuando el Señor hizo la alianza con los israelitas a su salida de Egipto."
,"11":"Cuando los sacerdotes salieron del santuario (todos los sacerdotes presentes se habían purificado sin distinción de clases),"
,"12":"todos los levitas cantores, Asaf, Hemán y Yedutún, con sus hijos y hermanos, vestidos de lino, sonaban los címbalos, las arpas y cítaras, de pie al este del altar, con ciento veinte sacerdotes que los acompañaban tocando las trompetas."
,"13":"Todos, como un solo hombre, trompeteros y cantores, alababan y daban gracias al Señor. Y al son de las trompetas, címbalos y demás instrumentos musicales alababan al Señor: 'Porque es bueno, porque es eterno su amor'. Una nube llenó el templo del Señor,"
,"14":"de modo que los sacerdotes no pudieron continuar su servicio a causa de la nube, pues la gloria del Señor había llenado el templo de Dios."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Entonces Salomón exclamó: 'Tú, Señor, has dicho que vives en la nube oscura. "
,"2":"Yo te he construido una casa donde residas, un lugar donde vivas para siempre'."
,"3":"Luego el rey se volvió y bendijo a toda la comunidad israelita que estaba de pie."
,"4":"Y añadió: 'Bendito sea el Señor, Dios de Israel, que ha cumplido con su propia mano lo que con su boca había prometido a mi padre David, diciendo:"
,"5":"Desde el día que saqué a mi pueblo de Egipto, no he escogido ninguna otra ciudad de entre las tribus de Israel para que se me construyera en ella un templo como morada de mi nombre, ni tampoco he elegido un hombre para guía de mi pueblo Israel;"
,"6":"sino que elegí a Jerusalén para morada de mi nombre y elegí a David para que estuviera al frente de mi pueblo Israel."
,"7":"Mi padre David quiso construir un templo en honor del Señor, Dios de Israel."
,"8":"Pero el Señor le dijo: Has proyectado construir un templo a mi nombre, y has hecho bien en proyectarlo."
,"9":"Pero no lo construirás tú, sino un hijo tuyo salido de tus entrañas será el que lo construya."
,"10":"El Señor ha cumplido su palabra. Yo me alcé en el puesto de mi padre David y me senté sobre el trono de Israel, como dijo el Señor, y construí el templo en honor del Señor, Dios de Israel,"
,"11":"y he instalado en él el arca, donde está la alianza que el Señor hizo con los israelitas'."
,"12":"Salomón se puso delante del altar del Señor, en presencia de toda la comunidad israelita, y levantó sus manos."
,"13":"Salomón había levantado en medio del atrio una tribuna de bronce de dos metros y medio de larga, dos y medio de ancha y uno y medio de alta. Se subió a ella, se arrodilló, y mirando al cielo, con las manos juntas oró así en presencia de toda la comunidad:"
,"14":"'Señor, Dios de Israel, no hay Dios semejante a ti ni en el cielo ni en la tierra. Tú guardas la alianza y la fidelidad con tus siervos que siguen tus caminos de todo corazón."
,"15":"Tú has cumplido la promesa que hiciste a tu siervo David, mi padre; tus manos han realizado lo que tus labios habían prometido."
,"16":"Ahora, Señor, Dios de Israel, cumple también lo que prometiste a tu siervo David, mi padre: No te faltará nunca en mi presencia un varón que se siente sobre el trono de Israel, con tal que tus hijos se porten bien y sigan tus caminos, como lo has hecho tú."
,"17":"Así pues, Dios de Israel, que se cumpla la promesa que hiciste a tu siervo David."
,"18":"Pero ¿será posible que Dios habite en medio de los hombres sobre la tierra? Si los cielos en toda su inmensidad no pueden contenerte, ¡cuánto menos este templo que yo he construido!"
,"19":"Atiende, Señor, Dios mío, la oración y la súplica de tu siervo; escucha el grito y la súplica que tu siervo eleva hoy a ti."
,"20":"Ten tus ojos noche y día fijos sobre este templo, sobre este lugar que has hecho morada de tu nombre. Escucha la plegaria que tu siervo haga en este lugar."
,"21":"Escucha la plegaria que tu siervo y tu pueblo Israel hagan en este lugar; escúchala desde tu morada en los cielos, escúchalos y perdona."
,"22":"Cuando alguno peque contra su prójimo y le obliguen a jurar ante tu altar en este templo,"
,"23":"escucha tú desde el cielo, intervén y haz justicia a tus siervos; condena al culpable haciendo recaer su maldad sobre su cabeza y absuelve al inocente retribuyéndole conforme a su inocencia."
,"24":"Cuando tu pueblo Israel sea derrotado por el enemigo por haber pecado contra ti, si se convierte, te confiesa su pecado, te suplica y te ruega en este templo,"
,"25":"escucha tú en el cielo, perdona el pecado de tu pueblo Israel y vuélvelos a la tierra que diste a ellos y a sus padres."
,"26":"Cuando se cierre el cielo y no haya lluvia por haber pecado contra ti, si rezan en este lugar, te confiesan su pecado y se arrepienten a causa de tu castigo,"
,"27":"escucha tú en el cielo, perdona el pecado de tus siervos y de tu pueblo Israel, enséñales el buen camino por donde deben andar y manda la lluvia sobre la tierra que le diste en heredad."
,"28":"Cuando en el país haya hambre, peste, tizón, añublo, langosta o pulgón, o el enemigo del pueblo asedie una de sus ciudades, o cuando hubiere cualquier otra plaga o epidemia,"
,"29":"si una persona o todo el pueblo de Israel, arrepentidos y contritos, llegan a este templo con las manos extendidas rogando y suplicando,"
,"30":"escucha tú en el cielo, el lugar de tu morada, y perdona; da a cada uno según su conducta, pues sólo tú conoces el corazón de todos los hombres;"
,"31":"así te respetarán y seguirán tus caminos, mientras vivan en la tierra que diste a nuestros padres."
,"32":"También al extranjero, que no es de tu pueblo Israel, si viene de tierras lejanas atraído por la fama de tu nombre, la fuerza de tu mano y el poder de tu brazo a orar en este templo,"
,"33":"escúchalo tú en el cielo, lugar de tu morada, y haz todo lo que ese extranjero te haya pedido, para que todos los pueblos de la tierra conozcan tu nombre, te teman como tu pueblo Israel y reconozcan que tu nombre es invocado en el templo que yo he construido."
,"34":"Cuando tu pueblo salga a la guerra contra sus enemigos por el camino que tú le hayas señalado, si te rezan a ti vueltos hacia la ciudad que tú has elegido y hacia el templo que yo he construido a tu nombre,"
,"35":"escucha tú en el cielo su oración y súplica y hazles justicia."
,"36":"Cuando pequen contra ti, pues no hay hombre que no peque, y tú, irritado contra ellos, los entregues al enemigo que los llevará cautivos a tierra enemiga, lejana o cercana,"
,"37":"si recapacitan en la tierra de sus enemigos y dicen: Hemos pecado, hemos obrado inicua e injustamente;"
,"38":"si se convierten a ti con todo su corazón y con toda su alma en la tierra de su cautividad, a la que han sido deportados; si rezan, vueltos hacia la tierra que diste a sus padres, hacia el templo que yo he construido a tu nombre,"
,"39":"escucha tú en el cielo, lugar de tu morada, su oración y súplica, hazles justicia y perdona a tu pueblo los pecados cometidos contra ti."
,"40":"Dios mío, ten abiertos tus ojos y atentos tus oídos a las plegarias que suben a ti desde este lugar."
,"41":"Ahora, pues, levántate, Señor Dios, ven al lugar de tu morada, ven con el arca de tu poder. Que tus sacerdotes, Señor Dios, se revistan de salvación, que tus fieles gocen de felicidad."
,"42":"Señor Dios, no apartes tu mirada,de tu ungido. Recuerda los favores,que hiciste a tu siervo David'."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Cuando Salomón terminó su oración, bajó fuego del cielo, que consumió los holocaustos y las víctimas, y la gloria del Señor llenó el templo,"
,"2":"de manera que los sacerdotes no podían entrar en él, pues la gloria del Señor lo llenaba."
,"3":"Todos los israelitas, al ver descender el fuego y reposar sobre el templo la gloria del Señor, cayeron rostro a tierra sobre el pavimento, mientras adoraban y alababan al Señor repitiendo: 'Porque es bueno, porque es eterno su amor'."
,"4":"El rey y todo el pueblo ofrecieron sacrificios al Señor."
,"5":"El rey Salomón inmoló 22.000 toros y 120.000 ovejas; de esta manera el rey y el pueblo celebraron la dedicación del templo de Dios."
,"6":"Los sacerdotes asistían en su ministerio y los levitas tocaban con los instrumentos musicales del Señor, que había hecho el rey David para acompañar las alabanzas del Señor: 'Porque es eterno su amor'. De esta manera ejecutaban las alabanzas de David. Los sacerdotes sonaban frente a ellos las trompetas mientras todo Israel estaba en pie."
,"7":"Salomón consagró también el centro del atrio, que estaba delante del templo del Señor, pues allí ofreció los holocaustos y las grasas de los sacrificios de reconciliación, porque el altar de bronce hecho por Salomón era pequeño para tantos holocaustos, ofrendas y grasas."
,"8":"En aquella ocasión Salomón, y con él la inmensa comunidad de Israel venida desde la entrada de Jamat hasta el torrente de Egipto, celebraron la fiesta durante siete días."
,"9":"El octavo día celebraron asamblea solemne, pues la dedicación del altar había durado siete días, y luego otros siete días de fiesta."
,"10":"El veintitrés del séptimo mes Salomón despidió al pueblo, y ellos se fueron a sus casas alegres y contentos por todos los beneficios que el Señor había hecho a David, a Salomón y a su pueblo Israel."
,"11":"Cuando Salomón terminó de construir el templo del Señor y todo cuanto se había propuesto hacer en el templo y en el palacio real,"
,"12":"se le apareció el Señor de noche y le dijo: 'He escuchado tu oración y he elegido para mí este lugar como templo para mis sacrificios."
,"13":"Cuando yo cierre el cielo y no haya lluvia, cuando ordene a la langosta devorar la tierra, cuando envíe la peste sobre mi pueblo,"
,"14":"si este mi pueblo, el pueblo que lleva mi nombre, se humilla, reza, busca mi rostro y se convierte de sus malos caminos, yo escucharé desde el cielo, perdonaré sus pecados y restauraré su tierra."
,"15":"En adelante mis ojos estarán abiertos y mis oídos atentos a las plegarias que se hagan en este lugar."
,"16":"Yo he elegido y consagrado este templo para que resida en él mi nombre por siempre y para que en él estén siempre fijos mis ojos y mi corazón."
,"17":"En cuanto a ti, si andas en mi presencia como anduvo tu padre David, si cumples todo lo que te mande, si guardas mis leyes y mandamientos,"
,"18":"yo consolidaré el trono de tu reino como se lo prometí a tu padre David cuando le dije: No te faltará un varón sobre el trono de Israel."
,"19":"Pero si os apartáis de mí y no guardáis mis leyes y mandamientos que yo os he prescrito, si os vais a servir y dar culto a dioses ajenos,"
,"20":"yo os arrancaré de mi tierra, que os he dado, y retiraré de mi presencia el templo que he consagrado a mi nombre, para que sea irrisión, burla y escarnio de todos los pueblos."
,"21":"Por sublime que haya sido, este templo será la irrisión. Todo el que pase delante de él se quedará asombrado. Preguntarán: ¿Por qué ha tratado así el Señor a esta tierra y este templo?"
,"22":"Y les responderán: Porque abandonaron al Señor, el Dios de sus padres, que los había sacado de Egipto, y se fueron a servir y dar culto a dioses ajenos; por eso ha traído sobre ellos tantos males'."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Salomón construyó el templo del Señor y el palacio real en veinte años."
,"2":"Reconstruyó las ciudades que le había dado Jirán y estableció en ellas a los israelitas."
,"3":"Luego fue contra Jamat de Sobá y la ocupó."
,"4":"Reconstruyó Tadmor, en el desierto, y todas las ciudades que había construido para guarniciones en Jamat."
,"5":"Restauró Bejorón de Arriba y de Abajo, ciudades fuertes, dotadas de muros, puertas y barras;"
,"6":"Balat, todas las ciudades almacenes que le pertenecían para los carros y la caballería; hizo todo lo que quiso en Jerusalén, en el Líbano y en todo el territorio de su jurisdicción."
,"7":"A los que quedaban de los amorreos, hititas, fereceos, heveos y jebuseos, no pertenecientes al pueblo de Israel,"
,"8":"y a los que los israelitas no habían podido exterminar, Salomón les impuso un servicio de prestación personal hasta nuestros días."
,"9":"A los israelitas no les impuso trabajos forzados; éstos eran sus guerreros, cortesanos, generales, prefectos y capitanes de los carros y la caballería."
,"10":"Los jefes y capataces que tenía el rey Salomón al mando de los obreros eran doscientos cincuenta."
,"11":"Salomón trasladó a la hija del Faraón de la ciudad de David al palacio que había construido para ella, pues se decía: 'Una mujer mía no puede habitar en el palacio de David, rey de Israel, porque los lugares donde ha estado el arca del Señor son lugares santos'."
,"12":"Salomón ofreció entonces holocaustos al Señor sobre el altar que él había levantado delante del atrio,"
,"13":"ajustándose a las prescripciones de Moisés respecto de los holocaustos de cada día, de los sábados, de los novilunios y de las tres solemnidades del año: fiesta de los panes sin levadura, fiesta de las semanas y fiesta de los tabernáculos."
,"14":"Estableció luego en sus servicios, según las disposiciones de su padre, las clases sacerdotales; y lo mismo hizo con los levitas encargados de cantar las alabanzas y asistir a los sacerdotes, según el ritual cotidiano, y con las respectivas clases de porteros de cada una de las puertas; todo conforme a las disposiciones de David, hombre de Dios."
,"15":"No se apartó ni un ápice de la ordenación del rey respecto de los sacerdotes y levitas, ni en lo referente a los tesoros."
,"16":"Así se llevó a cabo toda la obra de Salomón, desde el día que se pusieron los cimientos del templo del Señor hasta su terminación."
,"17":"Entonces Salomón salió hacia Asiongaber y Elat, a orillas del mar, en el territorio de Edón."
,"18":"Jirán, por medio de sus servidores, le había enviado navíos y marineros expertos en las cosas del mar, que con los siervos de Salomón fueron a Ofir y trajeron unos dieciséis mil kilos de oro para el rey Salomón."
}`)
	CurrentBook.AddChapter(9, `{
"1":"La reina de Sabá tuvo conocimiento de la fama de Salomón, y fue a Jerusalén para ponerlo a prueba con enigmas. Iba revestida de poderío y seguida de una gran caravana de camellos cargados de aromas, oro en abundancia y piedras preciosas. Se presentó a Salomón y le planteó todo lo que pensaba."
,"2":"Salomón le resolvió todas sus cuestiones; no hubo nada que no pudiera resolver."
,"3":"Cuando la reina de Sabá vio la sabiduría de Salomón y el palacio que había construido,"
,"4":"los manjares de su mesa, el ordenamiento jerárquico de sus cortesanos, el comportamiento y el uniforme de sus camareros, sus provisiones de bebidas y los holocaustos que ofrecía en el templo del Señor, se quedó asombrada y"
,"5":"dijo al rey: 'Realmente es verdad todo lo que yo había oído en mi tierra de tus obras y tu sabiduría."
,"6":"Yo no lo quería creer hasta que he venido y lo he visto con mis propios ojos; pero reconozco que no se me había dicho ni la mitad. Tu sabiduría y tu grandeza sobrepasan con mucho la fama que había llegado a mis oídos."
,"7":"¡Dichosas tus mujeres!, ¡dichosos tus servidores, que están siempre junto a ti y escuchan tu sabiduría!"
,"8":"Bendito sea el Señor, tu Dios, que se ha complacido en ti y te ha puesto sobre su propio trono para reinar en nombre del Señor Dios. Porque tu Dios ama a Israel y quiere mantenerlo eternamente, por eso te ha constituido rey sobre su pueblo, para que administres el derecho y la justicia'."
,"9":"Luego ofreció al rey ciento cuatro mil kilos de oro y gran cantidad de aromas y piedras preciosas. Nunca más se vio tanta cantidad de aromas como la que la reina de Sabá ofreció al rey Salomón."
,"10":"Los súbditos de Jirán y los súbditos de Salomón, que traían oro de Ofir, habían traído también de allí madera de sándalo y piedras preciosas."
,"11":"Con las maderas el rey hizo balaustradas para el templo del Señor y para el palacio real, y cítaras y arpas para los cantores. Nunca se había visto una madera igual en el reino de Judá."
,"12":"El rey Salomón, por su parte, regaló a la reina de Sabá todo lo que ella quiso, superando lo que ella había traído al rey. Ella y su séquito emprendieron el viaje de regreso a su país."
,"13":"El peso del oro que el rey Salomón recibía cada año era de unos veintitrés mil kilos,"
,"14":"sin contar el procedente del tráfico de los comerciantes y de los mercaderes, de todos los reyes de Arabia y de los gobernantes del país, los cuales pagaban al rey Salomón tributos de oro y plata."
,"15":"El rey Salomón hizo 200 escudos de oro batido, empleando unos siete kilos de oro por escudo,"
,"16":"y 300 escudos de oro batido más pequeños, a tres kilos y medio de oro cada uno; y los pusieron en la sala 'Bosque del Líbano'."
,"17":"Hizo también un gran trono de marfil y lo recubrió de oro puro;"
,"18":"tenía seis gradas, un cordero de oro en el respaldo, brazos a ambos lados del asiento, dos leones apostados junto a los brazos"
,"19":"y doce leones a ambos lados de las gradas. Nunca se había hecho cosa semejante en reino alguno."
,"20":"Todos los vasos de beber del rey Salomón eran de oro, y toda la vajilla de la sala del 'Bosque del Líbano' era de oro fino. No había nada de plata, pues la plata no se estimaba en tiempos del rey Salomón."
,"21":"El rey tenía una flota que iba a Tarsis con los súbditos de Jirán, y cada tres años volvía cargada de oro, plata, marfil, monos y pavos reales."
,"22":"El rey Salomón superó a todos los reyes de la tierra en riqueza y en sabiduría."
,"23":"Todos los reyes de la tierra querían visitar a Salomón para escuchar la sabiduría que Dios le había dado,"
,"24":"y todos traían presentes: objetos de oro y plata, vestidos, armas, aromas, caballos y mulos. Esto todos los años."
,"25":"Salomón tenía 4.000 caballerizas para sus caballos y sus carros y 12.000 jinetes, que destacó en las ciudades de guarnición y en Jerusalén, junto al rey."
,"26":"Dominó sobre todos los reyes, desde el Éufrates hasta la tierra de los filisteos y hasta la frontera de Egipto."
,"27":"Logró que la plata abundara en Jerusalén como las piedras, y los cedros como los sicómoros en la Sefela."
,"28":"Los caballos para Salomón venían de Musur y de todas partes."
,"29":"El resto de la historia de Salomón, desde el principio al fin, está escrito en las crónicas de Natán, profeta, en la profecía de Ajías de Silo y en la visión de Idó, el vidente, sobre Jeroboán, hijo de Nabat."
,"30":"Salomón reinó cuarenta años en Jerusalén sobre todo Israel."
,"31":"Descansó con sus padres y fue sepultado en la ciudad de su padre David. Le sucedió en el trono su hijo Roboán."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Roboán fue a Siquén, pues allí había acudido Israel para proclamarlo rey."
,"2":"Cuando lo supo Jeroboán, hijo de Nabat, que estaba en Egipto, lejos del rey Salomón, regresó de Egipto."
,"3":"Lo mandaron llamar y vino. Jeroboán y toda la comunidad de Israel se presentaron a Roboán y le dijeron:"
,"4":"'Tu padre nos ha puesto un yugo muy pesado; alivia tú la dura servidumbre de tu padre y el pesado yugo que puso sobre nosotros, y te serviremos'."
,"5":"Él les respondió: 'Volved a verme dentro de tres días'. Y el pueblo se fue."
,"6":"El rey Roboán pidió consejo a los ancianos que habían estado al servicio de su padre Salomón mientras éste vivía: '¿Qué me aconsejáis responder a este pueblo?'."
,"7":"Ellos le respondieron: 'Si hoy eres condescendiente con este pueblo, los complaces y les respondes con buenas palabras, serán siempre servidores tuyos'."
,"8":"Pero él no siguió el consejo de los ancianos y consultó a los jóvenes que se habían criado con él y estaban a su servicio."
,"9":"Les dijo: '¿Qué me aconsejáis vosotros responder a esta gente que me ha hablado así: Aligéranos el yugo que tu padre puso sobre nosotros?'."
,"10":"Los jóvenes le respondieron: 'A esa gente, que te ha hablado en esos términos debes responder lo siguiente: Mi dedo meñique es más grueso que la cintura de mi padre;"
,"11":"si mi padre os cargó un yugo pesado, yo lo haré más pesado todavía; si mi padre os castigó con azotes, yo os castigaré con latigazos'."
,"12":"Al tercer día, tal como el rey había dicho, Jeroboán y todo el pueblo se presentaron ante Roboán."
,"13":"Pero el rey les contestó duramente, desechó el consejo de los ancianos, siguió el de los jóvenes"
,"14":"y les habló de esta manera: 'Mi padre os puso un yugo muy pesado, yo lo haré más pesado todavía; mi padre os castigó con azotes, yo os castigaré con latigazos'."
,"15":"El rey no dio oídos al pueblo, porque así lo había dispuesto el Señor, para que se cumpliera la palabra que el Señor había anunciado por medio de Ajías de Silo a Jeroboán, hijo de Nabat."
,"16":"Los israelitas, al ver que el rey no les había hecho caso, le replicaron: '¿Qué tenemos que ver nosotros con David? ¡No tenemos ninguna heredad en común con el hijo de Jesé! ¡Cada uno a sus casas, Israel! ¡Mira tú ahora por tu casa, David!'. Y los israelitas se fueron a sus casas."
,"17":"Y Roboán siguió reinando sobre los israelitas domiciliados en las ciudades de Judá."
,"18":"El rey Roboán envió a Adorán, intendente de prestaciones personales; pero los israelitas lo mataron a pedradas. El rey Roboán tuvo que apresurarse a subir a su carro y huir a Jerusalén."
,"19":"Israel ha sido infiel a la casa de David hasta el día de hoy."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Roboán llegó a Jerusalén y convocó a la casa de Judá y de Benjamín: 180.000 hombres de guerra, para luchar contra Israel y recuperar el reino."
,"2":"Pero el Señor dijo a Semayas, hombre de Dios:"
,"3":"'Di a Roboán, hijo de Salomón, rey de Judá, y a todos los israelitas de Judá y Benjamín:"
,"4":"Esto dice el Señor: No vayáis a luchar contra vuestros hermanos; volveos a vuestras casas, pues esto ha sucedido porque yo lo he querido'. Ellos obedecieron la voz del Señor, y se volvieron sin luchar contra Jeroboán."
,"5":"Roboán se estableció en Jerusalén y reconstruyó las ciudades fuertes de Judá."
,"6":"Reconstruyó Belén, Etán, Técoa,"
,"7":"Bet Sur, Socó, Adulán,"
,"8":"Gat, Maresá, Zif,"
,"9":"Adoraín, Laquis, Azeca,"
,"10":"Sora, Ayalón y Hebrón, todas en Judá y Benjamín."
,"11":"Reforzó sus defensas, puso al frente de ellas gobernadores y las proveyó de almacenes de víveres, aceite y vino."
,"12":"Las armó asimismo de escudos y lanzas con el fin de hacerlas lo más fuertes posible y poder mantener su dominio en Judá y Benjamín."
,"13":"Los sacerdotes y levitas esparcidos por Israel venían de todos sus distritos para establecerse junto a él."
,"14":"Abandonaban posesiones y heredades para venir a Judá y a Jerusalén, pues Jeroboán y sus hijos les prohibían el ejercicio del sacerdocio del Señor."
,"15":"Jeroboán había instituido su propio sacerdocio para las colinas, los sátiros y los becerros que había mandado fundir."
,"16":"Los fieles seguidores del Señor, de todas las tribus de Israel, siguieron el ejemplo de los sacerdotes y levitas, y se fueron a Jerusalén para ofrecer sacrificios al Señor, Dios de sus padres."
,"17":"De esta manera consolidaron el reino de Judá y reforzaron a Roboán, hijo de Salomón, los tres años que éste siguió el camino de David y Salomón."
,"18":"Roboán se casó con Majalat, hija de Yerimot, hijo de David y Abijaíl, hija de Eliab y nieta de Jesé,"
,"19":"con la que tuvo estos hijos: Yeús, Semarías y Zahán."
,"20":"Después se casó con Maacá, hija de Absalón, con la que tuvo éstos: Abías, Atay, Zizá y Selomit."
,"21":"Roboán amó a Maacá, hija de Absalón, más que a todas las demás mujeres y concubinas. Tuvo dieciocho mujeres y sesenta concubinas, con las que tuvo veintiocho hijos y sesenta hijas."
,"22":"Constituyó a Abías, hijo de Maacá, como cabeza y jefe de todos sus hermanos, porque quería hacerlo rey."
,"23":"Tuvo la sagacidad de repartir a sus hijos por todos los territorios de Judá y de Benjamín y las ciudades fortificadas, les dio abundancia de provisiones y les procuró muchas mujeres."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Cuando Roboán se consolidó en el reino y se sintió fuerte, abandonó la ley del Señor, y con él todo Israel."
,"2":"Por haber sido infieles al Señor, el año quinto del reinado de Roboán, Sesac, rey de Egipto, fue contra Jerusalén"
,"3":"con 1.200 carros, 60.000 caballos, seguidos de un ejército ingente, integrado por libios, suquíes y etíopes, que venían con él de Egipto."
,"4":"Conquistó las ciudades fuertes de Judá y llegó hasta Jerusalén."
,"5":"El profeta Semayas se presentó a Roboán y a los jefes de Judá, que ante el avance de Sesac se habían refugiado en Jerusalén, y les dijo: 'Esto dice el Señor: Vosotros me habéis abandonado a mí, y yo a mi vez os he abandonado en manos de Sesac'."
,"6":"Los jefes de Israel y el rey confesaron humildemente: 'El Señor es justo'."
,"7":"Cuando el Señor vio que se habían humillado, dijo a Semayas: 'Se han humillado, no los destruiré; pronto verán mi liberación; no descargaré mi ira contra Jerusalén por medio de Sesac."
,"8":"Sin embargo, le estarán sometidos durante algún tiempo, para que vean la diferencia entre servirme a mí y servir a los reyes de la tierra'."
,"9":"Sesac, rey de Egipto, atacó a Jerusalén y se apoderó de los tesoros del templo del Señor y del palacio real; todo se lo llevó, incluso los escudos de oro que había hecho el rey Salomón."
,"10":"El rey Roboán hizo en su lugar otros escudos de bronce, que entregó a los jefes de la guardia que custodiaba la entrada del palacio real;"
,"11":"siempre que el rey iba al templo del Señor la guardia los llevaba, y luego los volvían a poner en la sala de la guardia."
,"12":"Gracias a su humillación, la ira del Señor se apartó del rey sin causarle una aniquilación total; más aún, las cosas mejoraron en Judá."
,"13":"Roboán se reafirmó en Jerusalén y continuó su reinado. Tenía cuarenta y un años cuando comenzó a reinar, y reinó diecisiete años en Jerusalén, la ciudad elegida por el Señor entre todas las tribus de Israel para morada de su nombre. Su madre se llamaba Naamá, la amonita."
,"14":"Obró mal, pues su corazón estuvo alejado del Señor."
,"15":"La historia de Roboán, desde el principio al fin, está escrita en las crónicas del profeta Semayas y del profeta Idó. Roboán y Jeroboán estuvieron continuamente en guerra."
,"16":"Roboán murió y fue sepultado con sus padres en la ciudad de David. Le sucedió en el trono su hijo Abías."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Abías comenzó a reinar en Judá el año dieciocho del reinado de Jeroboán."
,"2":"Reinó tres años en Jerusalén. Su madre se llamaba Maacá, y era hija de Uriel, de Guibeá. Estalló la guerra entre Abías y Jeroboán."
,"3":"Abías atacó con un ejército de 400.000 hombres valerosos, y Jeroboán opuso un frente de 800.000 soldados, también valerosos."
,"4":"Abías, de pie sobre el monte Semaráyim, en las montañas de Efraín, gritó: 'Jeroboán, israelitas todos, escuchadme."
,"5":"¿Acaso habéis olvidado que el Señor, Dios de Israel, dio a David el reino sobre todo Israel a perpetuidad, y que fue refrendado con él y sus descendientes mediante un pacto inviolable?"
,"6":"A pesar de todo, Jeroboán, hijo de Nabat, siervo de Salomón, hijo de David, se ha levantado y se ha rebelado contra su señor"
,"7":"y se le han unido unos hombres miserables y perversos que se impusieron a Roboán, hijo de Salomón, pues era joven todavía y tímido y no los pudo resistir."
,"8":"¡Y ahora andáis vosotros pregonando que os mostraréis fuertes contra el reino del Señor que detentan los descendientes de David, porque sois una multitud innumerable y tenéis con vosotros los becerros de oro que os legó como dioses Jeroboán!"
,"9":"Habéis expulsado a los sacerdotes del Señor, hijos de Aarón, y a los levitas, y os habéis creado sacerdotes al estilo de los pueblos paganos; a todo el que trae un becerro y siete carneros lo consagráis sacerdote de dioses que no son dioses."
,"10":"Para nosotros, nuestro Dios es el Señor; no lo hemos abandonado; y los descendientes de Aarón son los sacerdotes al servicio del Señor, y los levitas cumplen sus funciones."
,"11":"Ofrecen diariamente holocaustos al Señor, mañana y tarde, queman perfumes aromáticos, ponen los panes de la proposición sobre la mesa limpia y encienden todas las tardes el candelabro de oro con sus lámparas; seguimos cumpliendo las disposiciones del Señor, nuestro Dios, que vosotros habéis abandonado."
,"12":"Traemos con nosotros a Dios a la cabeza; darán con las trompetas el toque de guerra contra vosotros. ¡Israelitas, no luchéis contra el Señor, el Dios de vuestros padres, pues no os saldrá bien!'."
,"13":"Jeroboán preparó una emboscada, que cercó a los de Judá por la espalda, de manera que Judá se vio rodeado por Jeroboán por delante y por detrás."
,"14":"Los de Judá miraron hacia atrás y se percataron de que los atacaban de frente y por la espalda. Clamaron al Señor, y los sacerdotes tocaron sus trompetas."
,"15":"Los de Judá lanzaron el grito de guerra; y mientras éste se prolongaba, Dios derrotó a Jeroboán y a Israel ante Abías y Judá."
,"16":"El ejército de Israel se dio a la fuga ante los hombres de Judá. Dios los entregó en sus manos."
,"17":"Abías y los suyos les causaron una gran derrota, en la que cayeron 500.000 hombres de Israel."
,"18":"Los de Israel quedaron humillados, mientras que los de Judá cobraron nuevas fuerzas, porque se habían apoyado en el Señor, Dios de sus padres."
,"19":"Abías persiguió a Jeroboán y le tomó varias ciudades: Betel, Yesaná y Efrón con sus respectivas aldeas."
,"20":"Jeroboán no recobró ya su poder durante la vida de Abías. Finalmente, el Señor lo hirió y murió."
,"21":"Abías, por el contrario, se reafirmó; tuvo catorce mujeres, veintidós hijos y dieciséis hijas."
,"22":"El resto de la historia de Abías, su conducta y sus obras están escritas en el comentario del profeta Idó."
,"23":"Abías murió y fue sepultado con sus padres en la ciudad de David. Le sucedió en el trono su hijo Asá; la tierra gozó de paz durante diez años."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Asá hizo lo que es bueno y justo delante del Señor, su Dios."
,"2":"Destruyó los altares de los dioses extranjeros, las colinas, las estelas y los cipos sagrados;"
,"3":"exhortó a los de Judá a buscar al Señor, Dios de sus padres, observando su ley y sus mandamientos."
,"4":"Hizo desaparecer de todas las ciudades de Judá los santuarios de las colinas y los cipos del culto solar. El reino disfrutó de tranquilidad durante sus días."
,"5":"Restauró las ciudades fuertes de Judá aprovechando aquellos años en que el país gozaba de tranquilidad y no había guerra alguna, porque el Señor le había concedido la paz."
,"6":"Por eso dijo a Judá: 'Restauremos estas ciudades, rodeémoslas de murallas, torres, puertas y barras mientras el país está en nuestras manos. Hemos buscado al Señor, y el Señor nos ha concedido la paz con nuestros vecinos'. Y realizaron todas las construcciones."
,"7":"Asá disponía de un ejército de 300.000 hombres armados de escudo y lanza en Judá, y 280.000 armados de escudo y arco en Benjamín, todos hombres valerosos."
,"8":"Zéraj, el etíope, salió contra ellos con 1.000.000 de hombres y 300 carros y llegó hasta Maresá."
,"9":"Asá le salió al encuentro y se alineó en orden de batalla en el valle de Sefatá, junto a Maresá."
,"10":"Asá invocó al Señor, su Dios: 'Señor, solamente tú puedes acudir en auxilio del débil frente al poderoso. Ven en nuestro auxilio, Señor, Dios nuestro, porque en ti nos apoyamos y en tu nombre venimos a enfrentarnos con esta horda. Señor, tú eres nuestro Dios; no permitas que el hombre prevalezca contra ti'."
,"11":"El Señor derrotó a los etíopes ante Asá y Judá. Los etíopes huyeron,"
,"12":"y Asá los persiguió con su ejército hasta Guerar; todos los etíopes cayeron, sin quedar ni un superviviente, pues quedaron destrozados ante el Señor y su ejército. Los de Asá se apoderaron de una gran cantidad de botín"
,"13":"y tomaron todas las ciudades de la región de Guerar, pues también sobre ellas se había extendido el terror del Señor. Todas fueron saqueadas, ya que era mucho su botín."
,"14":"Asaltaron asimismo los apriscos y establos de los ganados, y se llevaron una gran cantidad de ovejas y camellos."
,"15":"Después regresaron a Jerusalén."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Azarías, hijo de Oded, revestido del espíritu de Dios,"
,"2":"salió al encuentro de Asá y le dijo: 'Óyeme, Asá, y escuchadme todos los de Judá y Benjamín. El Señor está con vosotros porque vosotros estáis con él. Cuando vosotros le buscáis, él se deja encontrar por vosotros; pero si lo abandonáis, él se aleja."
,"3":"Durante mucho tiempo Israel habrá de vivir lejos del Dios verdadero, sin sacerdotes que lo instruyan y sin ley;"
,"4":"pero en medio de su angustia se convertirá al Señor, Dios de Israel. Lo buscarán, y él se dejará encontrar por ellos."
,"5":"En aquellos días no habrá paz ni para los que salen ni para los que entran, pues abundarán las tribulaciones sobre todos los habitantes de la tierra."
,"6":"Las naciones y las ciudades se destruirán unas a otras, porque Dios las llenará de terror con toda suerte de calamidades."
,"7":"Pero vosotros sed fuertes y no desfallezcáis, porque vuestras obras tendrán su recompensa'."
,"8":"Con estas palabras del profeta Azarías, hijo de Oded, Asá se sintió fortalecido e hizo desaparecer los ídolos de toda la tierra de Judá y de Benjamín y de las ciudades que había conquistado en la montaña de Efraín; restauró de nuevo el altar del Señor, que estaba delante del vestíbulo del Señor."
,"9":"Convocó a todo Judá y Benjamín, y a los de Efraín, Manasés y Simeón, que habitaban entre ellos, pues muchos de los de Israel se habían pasado al lado de Asá al ver que el Señor, su Dios, estaba con él."
,"10":"Se reunieron en Jerusalén el tercer mes del año quince del reinado de Asá."
,"11":"Aquel día ofrecieron en sacrificio al Señor 700 toros y 7.000 ovejas del botín que habían traído."
,"12":"Se comprometieron con un pacto a buscar al Señor, Dios de sus padres, con todo su corazón y toda su alma."
,"13":"Todo el que no buscara al Señor, Dios de Israel, sin distinguir entre grandes o pequeños, hombres o mujeres, sería condenado a muerte."
,"14":"Así se lo juraron al Señor con grandes gritos de alegría, entre el resonar de las trompetas y de los cuernos."
,"15":"Todo Judá estaba contento por el juramento que acababan de hacer con todo el corazón; con toda su buena voluntad habían buscado al Señor, y él se había dejado encontrar por ellos, y les había concedido la paz en todas sus fronteras."
,"16":"El rey Asá quitó la dignidad de reina a su madre Maacá, porque había hecho una imagen de Aserá; Asá destruyó la imagen y la quemó en el torrente Cedrón."
,"17":"En cambio, no se quitaron las colinas, aunque Asá fue siempre fiel al Señor."
,"18":"Llevó al templo todas las ofrendas que él y su padre habían hecho al Señor: oro, plata y objetos varios."
,"19":"No hubo guerra hasta el año treinta y cinco del reinado de Asá."
}`)
	CurrentBook.AddChapter(16, `{
"1":"El año treinta y seis del reinado de Asá, Basá, rey de Israel, atacó Judá y fortificó Ramá para cortar las comunicaciones a Asá, rey de Judá."
,"2":"Entonces Asá tomó la plata y el oro del templo y del palacio real y lo envió a Ben Hadad, rey de Siria, residente en Damasco, con este mensaje:"
,"3":"'Hagamos nosotros dos un pacto, como lo hicieron nuestros padres. Yo te envío este obsequio de plata y oro. Rompe tu pacto con Basá, rey de Israel, para que me deje en paz'."
,"4":"Ben Hadad dio oídos a Asá y mandó a los jefes de su ejército contra las ciudades de Israel, conquistando Iyón, Dan, Abel-Mayó y todas las ciudades de aprovisionamiento de Neftalí."
,"5":"Cuando Basá se enteró de ello, desistió de fortificar Ramá y paró las obras."
,"6":"El rey Asá convocó a todo Judá, sin excepción alguna, y se llevaron las piedras y el maderamen con que Basá fortificaba Ramá para fortificar con ello Guibeá y Mispá."
,"7":"Fue entonces cuando el profeta Jananí se presentó a Asá, rey de Judá, y le dijo: 'Por haberte apoyado sobre el rey de Siria y no sobre el Señor, tu Dios, por eso se te escapará de las manos la fuerza del rey de Siria."
,"8":"Los etíopes y los libios constituían un ejército numeroso, con una gran cantidad de carros y caballos. Y, sin embargo, fueron entregados en tus manos porque tú pusiste la confianza en el Señor."
,"9":"Pues los ojos del Señor recorren toda la tierra para sostener a cuantos le sirven de todo corazón. Tú has obrado como un insensato, por lo cual a partir de ahora vivirás en guerra'."
,"10":"Asá se indignó contra el profeta y lo metió en la cárcel, pues sus palabras le habían llenado de cólera contra él. Asá maltrató también a otros del pueblo."
,"11":"Los hechos de Asá, desde el principio al fin, están escritos en el libro de los reyes de Judá y de Israel."
,"12":"El año treinta y nueve de su reinado enfermó gravemente de los pies, y tampoco en su enfermedad confió en el Señor, sino en los médicos."
,"13":"Murió el año cuarenta y uno de su reinado."
,"14":"Fue enterrado en el sepulcro que se había mandado hacer en la ciudad de David."
,"15":"Fue colocado sobre un lecho lleno de aromas, esencias y ungüentos, preparados según el arte de la perfumería, y se hizo en su honor un fuego inmenso."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Le sucedió en el trono su hijo Josafat, que se mostró fuerte frente a Israel."
,"2":"Puso guarniciones en todas las ciudades fortificadas de Judá y nombró gobernadores tanto en la tierra de Judá como en las ciudades que su padre Asá había conquistado en Efraín."
,"3":"El Señor estuvo con Josafat porque siguió los caminos de su padre en la primera parte de su vida y no se dio a los baales,"
,"4":"sino que buscó al Dios de su padre y vivió según sus preceptos, sin imitar para nada la conducta de Israel."
,"5":"El Señor consolidó el reino en sus manos; todo Judá le pagaba tributo a Josafat, que llegó a tener muchas riquezas y gran fama."
,"6":"Siguió con orgullo los caminos del Señor, y quitó de nuevo de Judá las colinas y las imágenes de Aserá."
,"7":"El año tercero de su reinado mandó a sus jefes Benjail, Abdías, Zacarías, Natanael y Miqueas para que instruyesen a las ciudades de Judá."
,"8":"Mandó con ellos a los levitas Semayas, Natanías, Zebadías, Asael, Semiramot, Jonatán, Adonías, Tobías y Tobadonías, y a los sacerdotes Elisamá y Jorán."
,"9":"Con el libro de la ley del Señor fueron recorriendo las ciudades de Judá y enseñando al pueblo."
,"10":"El pánico del Señor cundió por todos los reinos de las tierras vecinas de Judá, y no hicieron la guerra a Josafat."
,"11":"Más aún, los filisteos vinieron a ofrecer a Josafat tributos y regalos de plata. Los árabes llevaron al rey ganado menor: 7.700 carneros y otros tantos machos cabríos."
,"12":"Josafat prosperaba más y más. Construyó en Judá fortalezas y ciudades para almacenes."
,"13":"Tenía abundantes provisiones en las ciudades de Judá y soldados valerosos en Jerusalén."
,"14":"Ésta era la lista por familias. Jefes de millares por Judá: Adná, el jefe, con 300.000 soldados valerosos;"
,"15":"bajo sus órdenes el jefe Yehojanán, con 280.000;"
,"16":"bajo sus órdenes Amasías, hijo de Zicrí, que se había consagrado voluntariamente al servicio del Señor, con 200.000."
,"17":"Por Benjamín: el valeroso Eliadá, con 200.000 hombres armados con escudo y arco;"
,"18":"bajo sus órdenes Yehozabad, con 180.000 prontos para el combate."
,"19":"Éstos estaban al servicio del rey, sin contar los que tenía en las ciudades fortificadas de todo Judá."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Josafat llegó a tener muchas riquezas y mucha fama, y emparentó con Ajab,"
,"2":"al cual fue a visitar después de algunos años a Samaría."
,"3":"Ajab, rey de Israel, dijo a Josafat, rey de Judá: '¿Quieres venir conmigo a atacar a Ramot de Galaad?'. Él contestó: 'Mi suerte y la tuya serán la misma, y la misma también la suerte de nuestros pueblos; iremos contigo a la guerra'."
,"4":"Pero añadió: 'Por favor, consulta hoy la voluntad del Señor'."
,"5":"El rey de Israel reunió a los profetas, 400 hombres, y les dijo: '¿Debo atacar a Ramot de Galaad o no?'. Respondieron: 'Atácala porque Dios la pondrá en tus manos'."
,"6":"Josafat repuso: '¿No habrá aquí algún otro profeta del Señor para consultarle?'."
,"7":"El rey de Israel respondió a Josafat: 'Hay todavía uno por medio del cual podemos consultar al Señor; pero yo le odio porque nunca me profetiza cosas buenas, sino cosas malas; es Miqueas, hijo de Yimlá'. Josafat dijo: 'No hable así el rey'."
,"8":"El rey de Israel llamó a un funcionario y le dijo: 'Que venga inmediatamente Miqueas, hijo de Yimlá'."
,"9":"El rey de Israel y Josafat, rey de Judá, estaban sentados en sus tronos, con sus vestiduras regias, y ante ellos todos los profetas en trance de profetizar."
,"10":"Sedecías, hijo de Canaaná, se había hecho unos cuernos de hierro y decía: 'Esto dice el Señor: Con éstos acornearás tú a los sirios hasta exterminarlos'."
,"11":"Y todos los profetas profetizaban de la misma manera: 'Ataca a Ramot de Galaad y triunfarás, pues el Señor la pondrá en tus manos'."
,"12":"El mensajero que había ido a llamar a Miqueas le dijo: 'Mira que los profetas, todos a una, profetizan éxito al rey; haz tú como ellos y profetiza triunfo'."
,"13":"Miqueas respondió: 'Vive el Señor, que diré lo que el Señor me mande'."
,"14":"Se presentó al rey, y el rey le dijo: 'Miqueas, ¿debemos atacar a Ramot de Galaad o no?'. Él respondió: 'Atacadla y triunfaréis, pues el Señor la pondrá en vuestras manos'."
,"15":"El rey le dijo: '¿Cuántas veces voy a decir que no me digas más que la verdad en nombre del Señor?'."
,"16":"Miqueas contestó: 'He visto a todo Israel disperso por los montes como rebaño sin pastor. El Señor decía: Éstos no tienen dueño; que cada uno vuelva en paz a su casa'."
,"17":"El rey de Israel dijo a Josafat: '¿No te decía yo que no me profetizaba bienes, sino males?'."
,"18":"Miqueas replicó: 'Escuchad la palabra del Señor: He visto al Señor sentado en su trono y toda la corte del cielo alineada a su derecha y a su izquierda."
,"19":"Y el Señor decía: ¿Quién seducirá a Ajab, rey de Israel, para que vaya y muera en Ramot de Galaad? Y uno proponía una cosa y otro otra."
,"20":"Pero se adelantó un espíritu, y de pie ante el Señor dijo: Yo lo seduciré. El Señor le preguntó: ¿Cómo?"
,"21":"Él respondió: Iré y seré espíritu de mentira en la boca de todos sus profetas. El Señor dijo: Tú lograrás seducirlo; vete y hazlo así."
,"22":"El Señor ha puesto espíritu de mentira en la boca de todos tus profetas, pues el Señor ha decretado tu ruina'."
,"23":"Entonces Sedecías, hijo de Canaaná, dio una bofetada a Miqueas, y le dijo: '¿Es que el espíritu del Señor me ha dejado a mí para hablarte a ti?'."
,"24":"Miqueas le contestó: 'Ya lo sabrás aquel día que andes de aposento en aposento para esconderte'."
,"25":"El rey de Israel ordenó: 'Prended a Miqueas y llevadlo a Amón, prefecto de la ciudad, y a Joás, mi hijo,"
,"26":"y decidles: Ésta es la orden del rey: Meted a este hombre en la cárcel y tenedlo a pan y agua y poco de cada cosa hasta que yo vuelva sano y salvo'."
,"27":"Miqueas respondió: 'si vuelves sano y salvo, el Señor no ha hablado por mi boca'."
,"28":"El rey de Israel y Josafat fueron a atacar a Ramot de Galaad."
,"29":"El rey de Israel dijo a Josafat: 'Yo iré disfrazado a la batalla, pero tú irás con tu vestidura real'. Y el rey de Israel se disfrazó y entró en batalla."
,"30":"El rey de Siria había dado esta orden a los jefes de sus carros: 'No ataquéis a ninguno, sea oficial o soldado raso, sino solamente al rey de Israel'."
,"31":"Cuando los jefes de los carros vieron a Josafat, se dijeron: 'Este es el rey de Israel'. Fueron contra él y lo atacaron. Josafat entonces lanzó un grito, y el Señor le ayudó y los apartó de él."
,"32":"Los jefes de los carros se dieron cuenta de que no era el rey de Israel y dejaron de perseguirlo."
,"33":"Pero un hombre disparó el arco al azar, e hirió al rey de Israel entre las junturas de la coraza. El rey dijo a su auriga: 'Da la vuelta y sácame del campo, porque estoy herido'."
,"34":"Pero arreció tanto la lucha aquel día, que el rey de Israel siguió firme en su carro frente a los sirios hasta el atardecer, y murió al ponerse el sol."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Josafat, rey de Judá, regresó sano y salvo a su casa, a Jerusalén."
,"2":"El profeta Jehú, hijo de Jananí, le salió al encuentro y le dijo: '¿Ayudas al malvado y amas a los enemigos del Señor para atraer así su ira contra ti?"
,"3":"No obstante, algo bueno hay en ti, pues has destruido las imágenes de Aserá y buscas a Dios de corazón'."
,"4":"Después de una estancia en Jerusalén, Josafat salió de nuevo a visitar al pueblo desde Berseba hasta la montaña de Efraín y atraerlo al Señor, Dios de sus padres."
,"5":"Estableció jueces en cada una de las ciudades de Judá,"
,"6":"y les dijo: 'Mirad lo que hacéis, pues no juzgáis en lugar de los hombres sino en nombre del Señor, que está presente cuando vosotros sentenciáis."
,"7":"Temed al Señor, sed justos, porque el Señor no tolera la injusticia, la parcialidad y el soborno'."
,"8":"Estableció asimismo en Jerusalén levitas, sacerdotes y jefes de familias de Israel como jueces en asuntos religiosos y civiles de los habitantes de Jerusalén."
,"9":"Les dio estas órdenes: 'Cumplid vuestra misión con temor de Dios, con fidelidad y con honradez."
,"10":"En todas las causas que os presenten vuestros hermanos que viven en sus ciudades, causas de sangre o cuestiones sobre la ley, mandamientos, preceptos o costumbres, vosotros los instruiréis, para que no pequen contra el Señor y no caiga su cólera sobre vosotros y sobre ellos. Si obráis así, salvaréis vuestra responsabilidad."
,"11":"Para los asuntos religiosos, ahí tenéis a Amarías, el sacerdote jefe; y para los asuntos civiles, a Zebadías, hijo de Ismael, jefe de la casa de Judá. Y como secretarios, tenéis a los levitas. Ánimo y manos a la obra; el Señor estará siempre con el bueno'."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Poco después, los moabitas, los amonitas y sus aliados los mineos declararon la guerra a Josafat."
,"2":"La noticia llegó a Josafat en estos términos: 'Una horda numerosa viene contra ti del otro lado del mar Muerto, de Edón; ya están en Jasasón Tamar, es decir, en Engadí'."
,"3":"Josafat, atemorizado, recurrió al Señor y promulgó ayuno en todo Judá."
,"4":"Todos se reunieron para invocar al Señor; de todas las ciudades de Judá vinieron a implorar el auxilio del Señor."
,"5":"Josafat, en medio de la asamblea de Judá y Jerusalén, en el templo del Señor, y de pie delante del atrio nuevo,"
,"6":"oró así: 'Señor, Dios de nuestros padres, tú eres el Dios de los cielos, tú gobiernas los reinos de la tierra, tú tienes en tu mano la fuerza y el poder; nadie puede resistirte."
,"7":"Tú, Señor, Dios nuestro, echaste a los habitantes de esta tierra para dársela a los hijos de Abrahán, tu amigo."
,"8":"Ellos se establecieron en esta tierra, construyeron un templo a tu nombre y dijeron:"
,"9":"Si nos sobreviene la desgracia, si la espada, el castigo, la peste o el hambre se abaten sobre nosotros, nos presentaremos en este templo delante de ti, porque en este santuario habita tu nombre, y en medio de nuestra angustia clamaremos a ti, y tú nos escucharás y nos salvarás."
,"10":"Mira ahora a los hijos de Amón, a los de Moab y a los de los montes de Seír, cuyas tierras no permitiste que atravesaran los israelitas cuando venían de Egipto, sino que les hiciste dar un largo rodeo para no destruirlos;"
,"11":"mira ahora cómo nos pagan viniendo a echarnos de la heredad que tú nos diste en propiedad."
,"12":"Dios nuestro, júzgalos tú, pues nosotros nos sentimos impotentes frente a esta horda ingente que nos asalta. No sabemos qué hacer; nuestros ojos se vuelven a ti'."
,"13":"Todo Judá permanecía de pie delante del Señor, incluidas sus mujeres e hijos pequeños."
,"14":"En medio de la asamblea, Yajaziel, hijo de Zacarías, hijo de Benayas, hijo de Yeiel, hijo de Matanías, levita descendiente de Asaf,"
,"15":"dijo: 'Atención, habitantes de Judá y de Jerusalén, y tú, oh rey Josafat. Esto os dice el Señor: No temáis ni os asustéis ante esta ingente multitud, porque la batalla no es cosa vuestra, sino de Dios."
,"16":"Bajad mañana contra ellos. Ellos subirán por la cuesta de Sis; los encontraréis en el extremo del valle, frente al desierto de Yeruel."
,"17":"Vosotros no tenéis necesidad de luchar; deteneos, estaos quietos y veréis la victoria que os da el Señor. Judá y Jerusalén, no temáis ni os asustéis; salid mañana a su encuentro, y el Señor estará con vosotros'."
,"18":"Josafat y los habitantes de Judá y Jerusalén se postraron ante el Señor y lo adoraron."
,"19":"Los levitas, descendientes de Quehat y de Coré, empezaron a alabar con fuertes voces al Señor, Dios de Israel."
,"20":"Se levantaron de madrugada y salieron hacia el desierto de Técoa. Cuando salían, Josafat se adelantó y dijo: 'Escuchadme, habitantes de Judá y de Jerusalén. Tened confianza en el Señor, Dios nuestro, y estaréis seguros; tened fe en sus profetas, y triunfaréis'."
,"21":"De acuerdo con el pueblo, designó cantores, que, revestidos con los ornamentos sagrados, iban delante del ejército cantando y alabando al Señor: 'Alabad al Señor, porque es eterno su amor'."
,"22":"Tan pronto como comenzó el canto de júbilo y alabanza, el Señor suscitó la confusión entre los amonitas, los moabitas y los de las montañas de Seír, que venían a atacar a Judá, y se enfrentaron unos contra otros."
,"23":"Los amonitas y los moabitas atacaron a los de las montañas de Seír y los destruyeron por completo. Cuando acabaron con los de Seír se destruyeron unos a otros."
,"24":"Cuando los de Judá llegaron a la cima que domina el desierto y volvieron sus ojos hacia la multitud, no vieron más que cadáveres tendidos en tierra. No se había salvado ni uno."
,"25":"Josafat y su pueblo fueron a adueñarse del botín y encontraron gran cantidad de ganado, riquezas, vestidos y otros objetos preciosos. Era tal la cantidad, que no pudieron llevarlo de una vez. Estuvieron tres días llevando botín; tanta era su abundancia."
,"26":"El cuarto día se reunieron en el valle de las Bendiciones para alabar al Señor. De ahí el nombre de 'calle de las Bendiciones', que lleva hasta hoy."
,"27":"Los hombres de Judá y Benjamín, con Josafat a la cabeza, regresaron llenos de gozo a Jerusalén, pues el Señor les había otorgado la alegría a costa de sus enemigos."
,"28":"Entraron en Jerusalén y, al son de las arpas, cítaras y trompetas, se dirigieron al templo del Señor."
,"29":"El terror del Señor se extendió por todos los reinos de las naciones cuando supieron que el Señor había derrotado a los enemigos de Israel."
,"30":"El reinado de Josafat fue tranquilo, y Dios le dio la paz en todas sus fronteras."
,"31":"Josafat reinó sobre Judá. Tenía treinta y cinco años cuando comenzó a reinar, y reinó veinticinco en Jerusalén. Su madre se llamaba Azubá, y era hija de Siljí."
,"32":"Siguió el camino de Asá, su padre, sin extraviarse, e hizo lo que es justo a los ojos del Señor."
,"33":"Sin embargo, las colinas no desaparecieron, y el pueblo continuó sin orientar su corazón hacia el Señor, el Dios de sus padres."
,"34":"El resto de la historia de Josafat, desde el principio hasta el fin, se encuentra en las crónicas de Jehú, hijo de Jananí, que fueron insertadas en el libro de los reyes de Israel."
,"35":"Más tarde Josafat se alió con Ocozías, rey de Israel, que era un malvado."
,"36":"Se asoció con él para construir naves que llegaran a Tarsis; las construían en Esyón Guéber."
,"37":"Eliezer, hijo de Dodayas de Maresá, profetizó contra Josafat: 'Por haberte aliado con Ocozías, el Señor destruirá tu obra'. Las naves se destrozaron y no pudieron partir para Tarsis."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Josafat murió y fue sepultado con sus padres en la ciudad de David. Le sucedió en el trono su hijo Jorán."
,"2":"Jorán tenía seis hermanos: Azarías, Yejiel, Zacarías, Azarías, Miguel y Sefatías; todos eran hijos de Josafat, rey de Judá."
,"3":"Su padre les había hecho grandes donaciones en plata, oro, objetos preciosos e incluso algunas ciudades fortificadas de Judá; pero la corona la había reservado para Jorán, porque era el primogénito."
,"4":"Jorán se posesionó del reino de su padre, y, cuando se sintió fuerte, hizo pasar a cuchillo a todos sus hermanos y también a algunos jefes de Israel."
,"5":"Jorán tenía treinta y dos años cuando empezó a reinar, y reinó ocho años en Jerusalén."
,"6":"Siguió la conducta de los reyes de Israel y de la casa de Ajab, pues estaba casado con una hija de éste. Hizo lo que es malo a los ojos del Señor."
,"7":"Sin embargo, el Señor no quiso exterminar la casa de David, por el pacto que había hecho con él y por la promesa que le había hecho de conservarle para siempre una lámpara a él y a sus hijos."
,"8":"En su tiempo, Edón se independizó de Judá y se eligió un rey."
,"9":"Jorán, con sus jefes y todos sus carros, atacó en plena noche y derrotó a los edomitas, que lo tenían cercado a él y a los jefes de los carros."
,"10":"Edón se independizó de Judá hasta el día de hoy. También entonces se independizó Libná, pues Jorán había abandonado al Señor, Dios de sus padres."
,"11":"Más aún, levantó lugares de culto sobre los montes de Judá, empujó hacia la idolatría a los mismos habitantes de Jerusalén y sedujo a Judá."
,"12":"Recibió un escrito del profeta Elías, que le decía: 'Esto dice el Señor, Dios de tu padre David: Por no haber seguido la conducta de tu padre Josafat, ni la de Asá, rey de Judá,"
,"13":"sino la de los reyes de Israel, empujando a Judá y a los habitantes de Jerusalén a la idolatría, como la casa de Ajab; por haber matado a tus hermanos y a la familia de tu padre, que eran mejores que tú,"
,"14":"el Señor va a descargar sobre tu pueblo, tus hijos, tus mujeres y tu hacienda una gran calamidad."
,"15":"Tú mismo serás castigado con una grave enfermedad que te consumirá los intestinos día tras día hasta que revientes'."
,"16":"El Señor excitó contra Jorán la hostilidad de los filisteos y de los árabes vecinos de los etíopes,"
,"17":"los cuales fueron contra Judá, la invadieron y se llevaron todo lo que encontraron en el palacio del rey, incluidos mujeres e hijos, menos a Ocozías, el más pequeño de todos."
,"18":"Después de esto, el Señor lo castigó con una enfermedad intestinal incurable,"
,"19":"que se fue agravando de día en día, hasta que, al cabo de dos años, reventó, muriendo así en medio de terribles sufrimientos. El pueblo no encendió fuego en su honor, como había hecho con sus antecesores."
,"20":"Tenía treinta y dos años cuando comenzó a reinar, y reinó ocho años en Jerusalén. Se fue sin ser llorado; lo sepultaron en la ciudad de David, pero no en el panteón real."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Los habitantes de Jerusalén proclamaron rey a Ocozías, el menor de sus hijos, pues todos los demás habían sido asesinados por las tropas árabes cuando invadieron el campamento. Así subió al trono Ocozías, hijo de Jorán, rey de Judá."
,"2":"Tenía cuarenta y dos años cuando empezó a reinar, y reinó un año en Jerusalén. Su madre, hija de Omrí, se llamaba Atalía."
,"3":"También Ocozías siguió la conducta de la casa de Ajab, guiado por los consejos de su madre."
,"4":"Hizo lo que es malo a los ojos del Señor, lo mismo que la casa de Ajab, que fue su consejera después de la muerte de su padre para perdición suya."
,"5":"Siguiendo sus consejos, fue con Jorán, hijo de Ajab, rey de Israel, a luchar contra Jazael, rey de Siria, a Ramot de Galaad, donde cayó herido Jorán,"
,"6":"que se vio obligado a retirarse a Yezrael para curarse de las heridas recibidas en Ramot mientras luchaba contra Jazael, rey de Siria. Ocozías, hijo de Jorán, rey de Judá, fue a visitar a Jorán, hijo de Ajab, en Yezrael, mientras convalecía."
,"7":"Dios tenía prevista esta visita a Jorán para ruina de Ocozías; pues, a su llegada, salió con Jorán al encuentro de Jehú, hijo de Nimsí, a quien el Señor había ungido para exterminar a la casa de Ajab."
,"8":"Mientras Jehú hacía justicia con la casa de Ajab, se encontró con los jefes de Judá y los sobrinos de Ocozías, que le prestaban servicio, y los mató."
,"9":"Mandó buscar a Ocozías, que fue alcanzado cuando iba a esconderse a Samaría. Se lo llevaron a Jehú, que lo mandó matar. Le dieron sepultura, pues se dijeron: 'Es hijo de Josafat, que buscó al Señor con todo su corazón'. En la casa de Ocozías no quedó nadie que fuera capaz de reinar. "
,"10":"Entonces la madre de Ocozías, al ver que su hijo había muerto, fue y exterminó a toda la descendencia real de la casa de Judá."
,"11":"Pero, cuando estaban matando a los hijos del rey, Josebá, hija del rey, tomó a Joás, hijo de Ocozías, y lo escondió con su nodriza en el dormitorio. De esta manera, Josebá, hija del rey Jorán, mujer del sacerdote Yehoyadá y hermana de Ocozías, lo libró de Atalía, que no lo mató."
,"12":"Estuvo escondido con ella seis años en el templo mientras Atalía reinaba en el país."
}`)
	CurrentBook.AddChapter(23, `{
"1":"El séptimo año Yehoyadá mandó llamar a los jefes de centuria: Azarías, hijo de Yeroján; Ismael, hijo de Yehojanán; Azarías, hijo de Oded; Maseyas, hijo de Adayas, y Elisafat, hijo de Zicrí, e hizo un pacto con ellos."
,"2":"Recorrieron Judá, y reunieron a los levitas de todas las ciudades y a los jefes de las familias de Israel. Regresaron a Jerusalén,"
,"3":"y toda la asamblea hizo en el templo de Dios un pacto con el rey. Yehoyadá les dijo: 'Éste es el hijo del rey, el que debe reinar según lo establecido por el Señor respecto de los hijos de David."
,"4":"Esto es lo que habéis de hacer: el tercio de vosotros, sacerdotes, levitas, que entra de servicio el sábado, harán guardia en las puertas del templo;"
,"5":"otro tercio estará en el palacio real; el último tercio en la puerta de los cimientos, y todo el pueblo en los atrios del templo del Señor."
,"6":"Que nadie entre en el templo del Señor más que los sacerdotes y levitas que estén de servicio; éstos podrán entrar porque están consagrados. Todo el pueblo observará las prescripciones del Señor."
,"7":"Los levitas acordonarán al rey, todos con sus armas en la mano, y lo acompañarán dondequiera que vaya. Al que intente entrar en el templo matadlo'."
,"8":"Los levitas y todo Judá hicieron cuanto el sacerdote Yehoyadá les mandó: cada uno tomó a sus hombres, a los que entraban de servicio el sábado y los que salían, porque el sacerdote Yehoyadá no había exceptuado ningún turno."
,"9":"El sacerdote Yehoyadá entregó a los jefes de centuria las lanzas, las adargas y los escudos del rey David, que estaban en el templo de Dios."
,"10":"Apostó a todo el pueblo, cada uno con sus armas en la mano, de sur a norte, entre el altar y el templo, alrededor del rey."
,"11":"Hicieron salir al hijo del rey, le impusieron la corona y las insignias y lo proclamaron rey. Yehoyadá y sus hijos lo ungieron y gritaron: '¡Viva el rey!'."
,"12":"Cuando Atalía oyó los gritos del pueblo que corría y aclamaba al rey, fue al templo donde estaban todos."
,"13":"Al ver al rey, que estaba de pie sobre el estrado, a la entrada, y a los cantores y trompeteros junto a él con toda la gente del país jubilosa y tocando las trompetas mientras los cantores con los instrumentos músicos entonaban cantos de alabanza, se rasgó las vestiduras y gritó: '¡Traición, traición!'."
,"14":"Pero el sacerdote Yehoyadá ordenó a los jefes de centuria que mandaban la fuerza: 'Sacadla de las filas, y matad al que la siga'. El sacerdote había dicho: 'No la matéis en el templo del Señor'."
,"15":"La echaron y, al pasar por la puerta de las caballerizas en el palacio real, la mataron."
,"16":"Yehoyadá selló un pacto entre el Señor, el pueblo y el rey, por el cual se comprometían a ser el pueblo del Señor."
,"17":"El pueblo entero fue al templo de Baal y lo destruyeron: hicieron pedazos los altares y sus imágenes, y mataron delante de los altares a Matán, sacerdote de Baal."
,"18":"Yehoyadá encomendó la custodia del templo del Señor a los sacerdotes levitas; pues David les había encomendado el templo del Señor como herencia para ofrecer en él holocaustos, según está escrito en la ley de Moisés, en medio de cánticos y júbilo, conforme a la ordenación de David."
,"19":"Puso porteros en las entradas del templo del Señor, para que bajo ningún pretexto entrara nadie impuro."
,"20":"Tomó, finalmente, a los jefes de centuria, a los nobles, a cuantos tenían autoridad en el pueblo y al pueblo entero y llevaron al rey del templo al palacio real; entraron por la puerta superior y lo sentaron sobre el trono real."
,"21":"Todo el pueblo hizo fiesta, y la ciudad recobró la tranquilidad. Atalía había muerto a espada."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Joás tenía siete años cuando subió al trono, y reinó cuarenta años en Jerusalén. Su madre se llamaba Sibyá, de Berseba."
,"2":"Hizo lo que es justo a los ojos del Señor mientras vivió el sacerdote Yehoyadá,"
,"3":"el cual le casó con dos mujeres, de las cuales tuvo hijos e hijas."
,"4":"Joás mostró deseos de restaurar el templo del Señor."
,"5":"Reunió a los sacerdotes y levitas y les dijo: 'Recorred las ciudades de Judá y reunid fondos de todo Israel para reparar, según las necesidades de cada año, el templo de nuestro Dios. Sed diligentes en las obras'. Pero los levitas no se mostraron diligentes."
,"6":"Entonces el rey llamó a Yehoyadá, sacerdote jefe, y le dijo: '¿Por qué no has tenido cuidado de que los levitas recojan en Judá y en Jerusalén la contribución impuesta por Moisés, siervo de Dios, a la asamblea de Israel para la tienda de la alianza?"
,"7":"Atalía y sus hijos, pervertidos por ella, han deteriorado el templo de Dios, e incluso han dedicado a los baales todas las santas reservas del templo del Señor'."
,"8":"El rey mandó hacer un arca, y la puso en la puerta del templo del Señor por la parte de fuera."
,"9":"Se anunció en Judá y Jerusalén la obligación de traer al Señor la contribución impuesta por Moisés, siervo de Dios, a Israel en el desierto,"
,"10":"y todos los jefes y el pueblo entero vinieron con alegría a depositar su dinero en el arca hasta llenarla."
,"11":"Cuando llegaba el momento de llevar el arca a la intendencia del rey, que estaba en manos de los levitas, si veían que contenía mucho dinero, el secretario real y el comisario del sumo sacerdote la vaciaban y la ponían de nuevo en su sitio. Así hicieron día tras día, llegando a reunir gran cantidad de dinero."
,"12":"El rey y Yehodayá lo entregaron a los capataces de los trabajos del templo, los cuales contrataron a salario canteros, carpinteros y expertos artífices en hierro y bronce para renovar y consolidar el templo del Señor."
,"13":"Los obreros se pusieron a trabajar a tal ritmo que bien pronto el templo de Dios estuvo restaurado en su estado primitivo y perfectamente consolidado."
,"14":"Cuando terminaron, llevaron al rey y a Yehoyadá el dinero sobrante, con el cual se hicieron utensilios para el templo del Señor: utensilios para el ministerio y los holocaustos, copas y objetos de oro y plata. Mientras vivió Yehoyadá, todos los días se ofrecieron holocaustos en el templo."
,"15":"Pero Yehoyadá envejeció y, colmado de días, murió a la edad de ciento treinta años."
,"16":"Fue sepultado en la ciudad de David con los reyes, porque había hecho el bien en Israel, y con Dios y su templo."
,"17":"Después de la muerte de Yehoyadá, los jefes de Judá fueron a postrarse delante del rey, que esta vez siguió sus consejos."
,"18":"Abandonaron el templo del Señor, Dios de sus padres, y dieron culto a imágenes de Aserá y a otros ídolos. Esto provocó la cólera divina, que cayó sobre Judá y Jerusalén."
,"19":"El Señor les envió profetas para convertirlos, pero no quisieron escuchar sus advertencias."
,"20":"Zacarías, hijo del sacerdote Yehoyadá, poseído del espíritu de Dios se presentó ante el pueblo y dijo: 'Esto dice Dios: ¿Por qué quebrantáis los mandamientos del Señor? No triunfaréis, pues si vosotros abandonáis al Señor, él os abandonará a vosotros'."
,"21":"Se conjuraron contra él y, por orden del rey, lo apedrearon en el atrio del templo del Señor."
,"22":"El rey Joás, olvidando los favores que le había hecho Yehoyadá, padre de Zacarías, mató a su hijo, que dijo al morir: 'Que el Señor lo vea y te pida cuentas'."
,"23":"Al cabo de un año, el ejército de Siria, penetró en Judá y Jerusalén, mató a todos los jefes del pueblo y llevó todo el botín al rey de Damasco."
,"24":"El ejército sirio había venido con pocos hombres; pero el Señor entregó en sus manos un ejército considerablemente mayor, porque había abandonado al Señor, el Dios de sus padres. Los sirios hicieron justicia con Joás."
,"25":"Al retirarse ellos, Joás quedó en grave estado, sus siervos se conjuraron contra él para vengar la sangre del hijo del sacerdote Yehoyadá, y lo mataron en su cama. Murió, y lo enterraron en la ciudad de David, pero no en el panteón real."
,"26":"Éstos fueron los conjurados: Zabad, hijo de Simat, la amonita; y Yehozabad, hijo de Simrit, la moabita."
,"27":"Lo referente a sus hijos, a los subidos tributos y a la restauración del templo de Dios, está escrito en el comentario del libro de los reyes. Le sucedió su hijo Amasías."
}`)
	CurrentBook.AddChapter(25, `{
"1":"Amasías tenía veinticinco años cuando empezó a reinar, y reinó veintinueve años en Jerusalén. Su madre se llamaba Yehoadán, de Jerusalén."
,"2":"Hizo lo que es justo a los ojos del Señor, pero no con entero corazón."
,"3":"Cuando se sintió fuerte en el trono, mató a los siervos que habían asesinado a su padre;"
,"4":"pero no mató a los hijos de los asesinos, conforme lo escrito en el libro de la ley de Moisés: 'Los padres no morirán por la culpa de los hijos, ni los hijos por la culpa de los padres, sino que cada uno morirá por su propio pecado'."
,"5":"Amasías reunió a los de Judá y los distribuyó en familias patriarcales bajo jefes de millar y centuria, por todo Judá y Benjamín. Registró a todos los mayores de veinte años, y sumaban trescientos mil hombres escogidos, aptos para la guerra y diestros en la lanza y el escudo."
,"6":"Reclutó además cien mil hombres valerosos de Israel por tres mil cuatrocientos kilos de plata."
,"7":"Un hombre de Dios se presentó a él y le dijo: '¡Oh rey, no lleves contigo tropas de Israel, porque el Señor no está con Israel ni con ninguno de los hijos de Efraín!"
,"8":"Si van contigo, aunque tú des en el combate pruebas de fuerza, Dios te hará caer ante tus enemigos, porque en Dios está el poder de sostener y derribar'."
,"9":"Amasías contestó al hombre de Dios: '¿Y los tres mil cuatrocientos kilos de plata que he entregado a las tropas de Israel?'. El hombre de Dios respondió: 'Mucho más que eso puede darte el Señor'."
,"10":"Amasías separó entonces la tropa que le había venido de Efraín, para mandarlos a sus casas; éstos montaron en cólera contra Judá y regresaron a sus tierras enfurecidos."
,"11":"Amasías cobró ánimo, partió a la cabeza de sus tropas y llegó al calle de la Sal, donde derrotó a diez mil hombres de Seír."
,"12":"Los de Judá capturaron vivos otros diez mil, que condujeron a la cima de la Roca, desde donde los despeñaron, muriendo todos estrellados."
,"13":"Entre tanto, las tropas que había despedido Amasías para no llevarlas con él a la guerra invadieron las ciudades de Judá, desde Samaría hasta Bejorón, mataron a tres mil personas y se apoderaron de un gran botín."
,"14":"Al regreso de la victoria sobre los edomitas, Amasías se trajo los dioses de Seír, los tomó como dioses suyos, se postró ante ellos y les quemó incienso."
,"15":"La ira del Señor se encendió contra Amasías y le envió un profeta a decirle: '¿Por qué has ido a buscar a los dioses del pueblo al que ellos no pudieron librar de tus manos?'."
,"16":"Amasías le interrumpió: '¿Has sido nombrado acaso consejero del rey? Termina ya, si no quieres que te mate'. El profeta se calló, pero antes dijo: 'Ya veo que Dios ha decidido tu perdición, porque has hecho esto y no has escuchado mi consejo'."
,"17":"Amasías, rey de Judá, después de aconsejarse, mandó a decir a Joás, hijo de Joacaz y nieto de Jehú, rey de Israel: 'Ven, que nos veamos las caras'."
,"18":"Joás, rey de Israel, mandó a decir a Amasías, rey de Judá: 'El cardo del Líbano manda a decir al cedro del Líbano: Da tu hija por esposa a mi hijo; pero pasaron las fieras del Líbano y pisotearon el cardo."
,"19":"Como has derrotado a Edón, te has engreído. Goza de tu gloria y quédate en tu casa. ¿Por qué quieres acarrearte la desgracia, y que caigas tú y Judá contigo?'."
,"20":"Pero Amasías no hizo caso, porque así estaba dispuesto por el Señor, que quería entregarlo en manos de Joás, por haberse ido tras los dioses de Edón."
,"21":"Entonces Joás, rey de Israel, fue y se vieron las caras él y Amasías, rey de Judá, en Bet Semes de Judá."
,"22":"Judá fue derrotado frente a Israel, y cada cual huyó a su casa."
,"23":"Joás, rey de Israel, hizo prisionero en Bet Semes a Amasías, rey de Judá; luego llegó a Jerusalén y abrió en sus murallas una brecha de doscientos metros, desde la puerta de Efraín hasta la puerta del Ángulo;"
,"24":"se apoderó de todo el oro y la plata y de todos los utensilios que había en el templo del Señor, en la casa de Obededón y en los tesoros del palacio real, tomó rehenes y se volvió a Samaría."
,"25":"Amasías, hijo de Joás, rey de Judá, vivió todavía quince años después de la muerte de Joás, hijo de Joacaz, rey de Israel."
,"26":"El resto de la historia de Amasías, desde el principio al fin, está escrito en el libro de los reyes de Judá y de Israel."
,"27":"Después que Amasías se apartó del Señor, tramaron contra él una conjura en Jerusalén, y huyó a Laquis, donde lo persiguieron y lo mataron."
,"28":"Lo transportaron sobre caballos y lo enterraron con sus padres en la ciudad de David."
}`)
	CurrentBook.AddChapter(26, `{
"1":"Todo el pueblo de Judá tomó a Ozías, que tenía dieciséis años, y lo proclamó rey en lugar de su padre Amasías."
,"2":"Él reconstruyó Elat y la devolvió a Judá, después de la muerte de su padre."
,"3":"Ozías tenía dieciséis años cuando comenzó a reinar, y reinó cincuenta y dos años en Jerusalén. Su madre se llamaba Yecolía, de Jerusalén."
,"4":"Hizo lo que es justo a los ojos del Señor, como lo había hecho su padre Amasías."
,"5":"Buscó a Dios mientras vivió Zacarías, que lo había educado en el temor de Dios; y, mientras buscó al Señor, Dios le hizo triunfar."
,"6":"Salió a luchar contra los filisteos, derribó las murallas de Gat, las de Yabné y las de Asdod y restauró ciudades en la región de Asdod, en la tierra de los filisteos."
,"7":"Dios lo asistió contra los filisteos, contra los árabes, contra los habitantes de Gur Baal y contra los meunitas."
,"8":"Los amonitas pagaron tributo a Ozías, y su fama se extendió hasta las fronteras de Egipto, porque había llegado a ser poderosísimo."
,"9":"Construyó torres en Jerusalén, en la puerta del Ángulo, en la puerta del Valle y en la puerta de la Esquina, y las fortificó."
,"10":"Levantó torres en el desierto y abrió muchos pozos porque tenía muchos ganados en la Sefela y en la meseta, labradores y viñadores en los montes y en las huertas, pues era amante de la agricultura."
,"11":"Tenía un ejército en pie de guerra, organizado por escuadrones, según el censo hecho bajo la supervisión del escriba Yeiel y del comisario Maseyas; el ejército estaba bajo las órdenes de Jananías, uno de los jefes reales."
,"12":"El número total de los jefes de familias, hombres valerosos, era de doce mil seiscientos."
,"13":"A sus órdenes estaban las tropas del ejército, trescientos siete mil guerreros valerosos, prontos a defender al rey contra los enemigos."
,"14":"Armó a todo el ejército con escudos, lanzas, cascos, corazas, arcos y hondas."
,"15":"Sus técnicos construyeron en Jerusalén máquinas lanzaflechas y lanzapiedras, que puso en las torres y en los ángulos de las murallas. Con la ayuda milagrosa de Dios, su poder y su fama fueron muy grandes."
,"16":"Al sentirse poderoso, se llenó de soberbia, lo que fue su perdición. Fue infiel al Señor y entró en el templo a ofrecer incienso sobre el altar de los perfumes."
,"17":"Después de él entró el sacerdote Azarías con otros ochenta sacerdotes del Señor, hombres valerosos,"
,"18":"que se enfrentaron al rey Ozías y le dijeron: 'Ozías, tú no puedes ofrecer el incienso al Señor; sólo pueden hacerlo los sacerdotes de Aarón, consagrados precisamente para eso. Sal fuera del santuario, porque has pecado y no tienes derecho a la gloria que viene del Señor Dios'."
,"19":"Ozías, todavía con el incensario en su mano para quemar el incienso, montó en cólera contra los sacerdotes y, al instante, brotó la lepra en su frente en presencia de los sacerdotes en el templo del Señor, junto al altar de los perfumes."
,"20":"Azarías, el sacerdote jefe, y todos los sacerdotes se fijaron en él, vieron la lepra en su frente y se apresuraron a echarlo de allí, cuando él mismo salía ya precipitadamente, porque el Señor lo había castigado."
,"21":"El rey Ozías continuó leproso hasta el día de su muerte. Vivió recluido en una casa aislada, pues, como leproso, estaba excluido del templo del Señor. Su hijo Jotán estaba al frente del palacio y del gobierno de la nación."
,"22":"El resto de la historia de Ozías, y todo lo que hizo, ha sido escrito por el profeta Isaías, hijo de Amós."
,"23":"Ozías murió y fue sepultado con sus padres en el campo de las sepulturas de los reyes, porque decían: 'Es un leproso'. Le sucedió su hijo Jotán."
}`)
	CurrentBook.AddChapter(27, `{
"1":"Jotán tenía veinticinco años cuando subió al trono, y reinó dieciséis años en Jerusalén. Su madre, hija de Sadoc, se llamaba Yerusá."
,"2":"Hizo lo que es justo a los ojos del Señor como su padre Ozías; sólo que no entró en el templo del Señor, pero el pueblo siguió corrompido."
,"3":"Construyó la puerta superior del templo del Señor e hizo muchos trabajos en el muro de Ofel."
,"4":"Construyó ciudades en la montaña de Judá y fortalezas y torres en los bosques."
,"5":"Luchó contra el rey de los amonitas y lo venció. Los amonitas le entregaron aquel años tres mil cuatrocientos kilos de plata, cuatro mil quinientas toneladas de trigo y otras tantas de cebada. La misma entrega se repitió un segundo y tercer año."
,"6":"Jotán llegó a ser poderoso, porque sus pasos iban seguros delante del Señor, su Dios."
,"7":"El resto de la historia de Jotán, todo lo que hizo, está escrito en el libro de los reyes de Israel y de Judá."
,"8":"Tenía veinticinco años cuando empezó a reinar, y reinó dieciséis años en Jerusalén."
,"9":"Jotán murió y fue sepultado en la ciudad de David. Le sucedió su hijo Acaz."
}`)
	CurrentBook.AddChapter(28, `{
"1":"Acaz tenía veinte años cuando subió al trono, y reinó dieciséis años en Jerusalén. No hizo lo que es justo a los ojos del Señor, como su padre David,"
,"2":"sino que siguió el camino de los reyes de Israel: hizo ídolos fundidos de Baal,"
,"3":"quemó ofrendas en el valle de Ben Hinnón y hasta hizo pasar por el fuego a su hijo, según las prácticas horrorosas de las gentes que el Señor había echado delante de los israelitas."
,"4":"Ofreció sacrificios y quemó ofrendas en los altozanos, en las colinas y bajo cualquier árbol frondoso."
,"5":"El Señor, su Dios, lo entregó en manos del rey de Siria, que lo derrotó, haciéndole gran número de prisioneros, que fueron conducidos cautivos a Damasco. Fue entregado también en manos del rey de Israel, que le infligió una gran derrota."
,"6":"Pécaj, hijo de Romelía, mató en un solo día ciento veinte mil hombres de Judá, guerreros valerosos; todo porque habían abandonado al Señor, el Dios de sus padres."
,"7":"Zicrí, valeroso soldado efraimita, mató a Maseyas, hijo del rey; a Azricán, mayordomo del palacio real, y a Elcaná, el segundo después del rey."
,"8":"Los israelitas hicieron doscientos mil prisioneros a sus hermanos entre mujeres, hijos e hijas, y se adueñaron de un enorme botín, que se llevaron para Samaría."
,"9":"Había allí un profeta del Señor, llamado Obed, que salió al encuentro del ejército que regresaba a Samaría, y les dijo: 'El Señor, Dios de nuestros padres, en su ira contra los de Judá los ha entregado en vuestras manos; pero vosotros los habéis matado con furor tal, que ha subido hasta el cielo."
,"10":"Y ahora queréis hacer a los de Judá y Jerusalén esclavos y esclavas vuestros. Pero es que ¿no sois también vosotros culpables ante el Señor vuestro Dios?"
,"11":"Escuchadme, y devolved los prisioneros que habéis hecho a vuestros hermanos, porque os amenaza la ardiente ira del Señor'."
,"12":"Azarías, hijo de Yehojanán; Berequías, hijo de Meselimot; Ezequías, hijo de Salún, y Amasá, hijo de Jadly, todos ellos jefes efraimitas, se enfrentaron contra los que volvían de la guerra,"
,"13":"y les dijeron: 'No traigáis aquí a los prisioneros, pues nos haríamos culpables ante el Señor. Habláis de aumentar nuestros pecados y nuestras deudas, pero nuestra culpa es ya ciertamente enorme, y la ardiente ira del Señor amenaza a Israel'."
,"14":"Los soldados soltaron a los prisioneros y dejaron el botín delante de los jefes y de toda la muchedumbre."
,"15":"Unos hombres designados expresamente confortaron a los prisioneros y, de lo mismo que les habían quitado, los vistieron, los calzaron, les dieron de comer, les curaron las heridas, montaron en asnos a los que estaban fatigados y los llevaron a Jericó, la ciudad de las palmeras, junto a sus hermanos; luego regresaron a Samaría."
,"16":"Por entonces el rey Acaz pidió ayuda al rey de Asiria."
,"17":"Los edomitas invadieron de nuevo Judá y se llevaron prisioneros."
,"18":"Los filisteos se extendieron por las ciudades de la tierra baja, Ayalón, Guederot, Socó y sus anejos, Timná y sus anejos, y se establecieron en ellas."
,"19":"Así humillaba el Señor a Judá a causa de Acaz, rey de Judá, que había traído la relajación a Judá y había sido infiel al Señor."
,"20":"Vino contra él Teglat-Falasar, rey de Asiria, y en vez de apoyarlo lo asedió."
,"21":"Acaz se apoderó de gran parte de los bienes del templo del Señor, del palacio real y de la casa de los jefes y se lo mandó al rey de Asiria, pero de nada le sirvió."
,"22":"Mientras estaba asediado, el rey Acaz aumentó sus pecados contra el Señor."
,"23":"Ofreció sacrificios a los dioses de Damasco, que lo habían derrotado, pues se decía: 'Puesto que los dioses de los reyes de Siria les ayudan, voy a ofrecerles sacrificios para que me ayuden también a mí'. Pero éstos fueron la causa de su ruina y de la de todo Israel."
,"24":"Acaz reunió objetos del templo de Dios y los hizo pedazos, cerró las puertas del templo del Señor e hizo altares en todos los rincones de Jerusalén,"
,"25":"y lugares de culto en todas las ciudades de Judá para quemar en ellos incienso a los ídolos, provocando así la ira del Señor, el Dios de sus padres."
,"26":"El resto de la historia de Acaz, todo lo que hizo, está escrito en el libro de los reyes de Judá y de Israel."
,"27":"Murió y fue sepultado con sus padres en Jerusalén, pero no en el panteón real. Le sucedió su hijo Ezequías."
}`)
	CurrentBook.AddChapter(29, `{
"1":"Ezequías tenía veinticinco años cuando subió al trono, y reinó veintinueve años en Jerusalén. Su madre se llamaba Abí, y era hija de Zacarías."
,"2":"Hizo lo que es justo a los ojos del Señor como su padre David."
,"3":"El primer año del reinado, en el mes primero, abrió las puertas del templo del Señor y las restauró."
,"4":"Mandó llamar a los sacerdotes y a los levitas, los reunió en la plaza oriental, y"
,"5":"les dijo: 'Levitas, escuchadme. Purificaos y purificad el templo del Señor, Dios de nuestros padres, eliminando la impureza de él."
,"6":"Sí, nuestros padres han pecado y han hecho lo que es malo a los ojos del Señor, nuestro Dios, lo han abandonado, han apartado su rostro de la morada del Señor y le han dado la espalda."
,"7":"Cerraron incluso las puertas del pórtico, apagaron las lámparas y dejaron de ofrecer incienso y holocaustos en el santuario al Dios de Israel."
,"8":"El Señor ha montado en cólera contra Judá y Jerusalén, los ha hecho objeto de terror, estupor y burla, como podéis ver con vuestros propios ojos."
,"9":"Por eso, nuestros padres cayeron en la guerra, y nuestros hijos y nuestras mujeres fueron hechos prisioneros."
,"10":"Yo quiero hacer un pacto con el Señor para que aparte su ira de nosotros."
,"11":"Por tanto, hijos míos, no seáis negligentes, pues vosotros sois los elegidos del Señor para estar en su presencia, servirle, ser sus ministros y quemar incienso."
,"12":"Se presentaron los levitas siguientes: por Quehat: Májat, hijo de Amasay, y Joel, hijo de Azarías; por Merarí: Quis, hijo de Abdí, y Azarías, hijo de Yahelelel; por Guersón: Yoaj, hijo de Zimmá, y Edén, hijo de Yoaj;"
,"13":"por Elisafán: Simrí y Yehiel; de los hijos de Asaf: Zacarías y Matanías;"
,"14":"por Hemán: Jejiel y Simeí; por Jedutún: Semeyas y Uziel;"
,"15":"reunieron a sus hermanos, se purificaron y, siguiendo la orden del rey y las palabras del Señor, entraron a purificar el templo."
,"16":"Entraron los sacerdotes en el interior del templo para purificarlo, y sacaron fuera, al atrio del templo del Señor, todas las cosas impuras que encontraron dentro del templo, y los levitas las tiraron al torrente Cedrón."
,"17":"Comenzaron la obra de purificación el día primero del primer mes, y el día octavo llegaron ya al vestíbulo del Señor. Emplearon otros ocho días en la purificación del templo: la obra quedó concluida el día dieciséis del primer mes."
,"18":"Se presentaron entonces al rey Ezequías y le dijeron: 'Hemos purificado todo el templo, el altar de los holocaustos y todos sus utensilios, la mesa de los panes de la proposición con todos sus accesorios;"
,"19":"hemos puesto en su sitio y purificado todos los objetos que había profanado Acaz durante su reinado: ya están delante del altar del Señor'."
,"20":"El rey Ezequías se levantó muy de mañana, reunió a los jefes de la ciudad y fue al templo."
,"21":"Llevaron siete toros, siete carneros, siete corderos y siete machos cabríos para ofrecerlos en sacrificio por el pecado en favor de la monarquía, el santuario y Judá. El rey ordenó a los sacerdotes descendientes de Aarón que los ofrecieran sobre el altar del Señor."
,"22":"Inmolaron los toros y derramaron la sangre sobre el altar. Inmolaron carneros y derramaron la sangre sobre el altar, y lo mismo hicieron con los corderos."
,"23":"Llevaron los machos cabríos destinados al sacrificio por el pecado ante el rey y la asamblea para que pusieran sobre ellos sus manos."
,"24":"Los sacerdotes los mataron y derramaron su sangre sobre el altar como sacrificio por los pecados de todo Israel, pues el rey había ordenado ofrecer por todo Israel el holocausto y el sacrificio por el pecado."
,"25":"Puso en el templo del Señor a los levitas con címbalos, arpas y cítaras, de acuerdo con la orden de David, de Gad, el vidente del rey, y del profeta Natán; la orden venía del Señor, a través de sus profetas."
,"26":"Cuando los levitas estuvieron en sus sitios con los instrumentos de David y los sacerdotes con las trompetas,"
,"27":"Ezequías mandó ofrecer el holocausto sobre el altar. Al comenzar el holocausto, comenzaron también las alabanzas del Señor al son de las trompetas en armonía con los instrumentos de David, rey de Israel."
,"28":"Toda la asamblea estaba de rodillas mientras se cantaban las alabanzas y sonaban las trompetas, así hasta que terminó el holocausto."
,"29":"Cuando terminó, el rey y los que le acompañaban se pusieron de rodillas en actitud de adoración."
,"30":"El rey Ezequías y los jefes dieron la orden a los levitas de alabar al Señor con los salmos de David y de Asaf, el vidente. Cantaron los salmos con gran alegría, y luego se arrodillaron en actitud de adoración."
,"31":"Ezequías tomó la palabra, y dijo: 'Ahora que estáis enteramente consagrados al Señor, acercaos y ofreced víctimas y sacrificios de acción de gracias en el templo del Señor'. La asamblea ofreció víctimas, sacrificios de acción de gracias y toda suerte de holocaustos voluntarios."
,"32":"Ofreció en holocausto al Señor setenta toros, cien carneros y doscientos corderos."
,"33":"En otras ofrendas sagradas, seiscientos toros y tres mil ovejas."
,"34":"Como los sacerdotes eran pocos y no bastaban para degollar todos los animales del holocausto, les ayudaron sus hermanos los levitas, hasta que terminó el trabajo y se purificaron los sacerdotes, porque los levitas habían sido más diligentes que los sacerdotes en purificarse."
,"35":"Hubo muchos holocaustos más, constituidos por la grasa de los sacrificios de acción de gracias y por las ofrendas de vino que acompañaban a los holocaustos. De esta manera se restableció el culto en el templo del Señor."
,"36":"Ezequías y todo el pueblo se alegraron de lo que Dios había hecho por el pueblo, pues todo se había hecho con gran rapidez."
}`)
	CurrentBook.AddChapter(30, `{
"1":"Ezequías mandó mensajeros por todo Israel y Judá, y escribió cartas a Efraín y Manasés para que vinieran al templo del Señor, a Jerusalén, a celebrar la pascua en honor del Señor, Dios de Israel."
,"2":"Después de previa deliberación, el rey, sus jefes y toda la asamblea de Jerusalén decidieron celebrar la pascua en el segundo mes,"
,"3":"ya que no se había podido celebrar a su debido tiempo, puesto que los sacerdotes no se habían purificado en número suficiente y el pueblo no se había reunido en Jerusalén."
,"4":"La decisión pareció justa a los ojos del rey y a los de toda la asamblea,"
,"5":"y determinaron correr la voz por todo Israel, desde Berseba hasta Dan, para que vinieran a Jerusalén a celebrar una pascua en honor del Señor, Dios de Israel, pues pocos habían cumplido lo prescrito."
,"6":"Con cartas de mano del rey y sus jefes, los correos recorrieron todo Israel y Judá proclamando la orden del rey: 'Israelitas, convertíos al Señor, Dios de Abrahán, de Isaac y de Israel, para que él vuelva a estar con todos los que habéis escapado de la mano de los reyes de Asiria."
,"7":"No seáis como vuestros padres y vuestros hermanos, que fueron infieles al Señor, Dios de sus padres, que los entregó a la destrucción, como vosotros estáis viendo."
,"8":"No seáis de cabeza dura como vuestros padres. Tended vuestras manos al Señor y venid al santuario que él ha santificado para siempre. Servid al Señor, Dios vuestro, y el furor de su ira se apartará de vosotros."
,"9":"Si os convertís al Señor, vuestros hermanos y vuestros hijos encontrarán misericordia ante los vencedores y volverán a esta tierra, pues el Señor, vuestro Dios, es clemente y misericordioso y no apartará de vosotros su rostro si de verdad os convertís a él'."
,"10":"Los correos recorrieron ciudad tras ciudad la tierra de Efraín y Manasés, llegando hasta Zabulón; pero las gentes se reían y se burlaban de ellos."
,"11":"Sólo algunos de Aser, Manasés y Zabulón se humillaron y fueron a Jerusalén."
,"12":"Todos los de Judá estuvieron de acuerdo en cumplir la orden del rey y de los jefes como lo había mandado el Señor."
,"13":"Acudió a Jerusalén una gran multitud de gente para celebrar la fiesta de los panes sin levadura en el segundo mes."
,"14":"Destruyeron los altares que había en Jerusalén para los sacrificios y para el incienso y los tiraron al torrente Cedrón."
,"15":"Inmolaron el cordero pascual el día catorce del segundo mes. Llenos de vergüenza, los sacerdotes y los levitas se purificaron y ofrecieron holocaustos en el templo del Señor."
,"16":"Cada uno ocupó su puesto según lo ordenado por la ley de Moisés, hombre de Dios: los sacerdotes derramaban la sangre que les daban los levitas."
,"17":"Como en la asamblea había muchos que no se habían purificado, los levitas estaban encargados de inmolar las víctimas pascuales en lugar de todos estos que no tenían la pureza necesaria para realizar un acto sagrado en honor del Señor."
,"18":"Un gran número de personas de Efraín, de Manasés, de Isacar y de Zabulón no se habían purificado, es decir, comieron la víctima pascual sin conformarse a lo prescrito, pero Ezequías oró por ellos así: 'El Señor, que es bueno, perdone"
,"19":"a los que buscan de todo corazón a Dios, el Señor, el Dios de sus padres, aun cuando no tengan la pureza necesaria para las cosas sagradas'."
,"20":"El Señor oyó a Ezequías y perdonó al pueblo."
,"21":"Los israelitas que se encontraban en Jerusalén celebraron la fiesta de los panes sin levadura durante siete días con gran alegría, mientras los levitas y los sacerdotes cantaban con toda fuerza las alabanzas del Señor día tras día."
,"22":"Ezequías tuvo palabras de elogio para todos los levitas que se habían distinguido en el servicio del Señor. Celebraron la fiesta durante siete días, inmolando las víctimas de los sacrificios de reconciliación y cantando las alabanzas del Señor, Dios de sus padres."
,"23":"Pero toda la asamblea decidió alargar la fiesta siete días más, y así se hizo con gran alegría,"
,"24":"porque Ezequías, rey de Judá, les regaló mil toros y siete mil ovejas, más otros mil toros y diez mil ovejas que habían regalado los jefes; muchos sacerdotes se habían purificado ya."
,"25":"Toda la asamblea de Judá, sacerdotes, levitas, todos los que habían venido de Israel, los extranjeros que habían venido de Israel, y los residentes en Judá, estaban rebosantes de alegría."
,"26":"Hubo una gran fiesta en Jerusalén, como no se había visto desde los días de Salomón, hijo de David, rey de Israel."
,"27":"Los sacerdotes y los levitas, de pie, dieron la bendición al pueblo. El Señor escuchó su voz, y su oración llegó hasta su santa morada en el cielo."
}`)
	CurrentBook.AddChapter(31, `{
"1":"Cuando todo acabó, los israelitas que habían estado presentes recorrieron las ciudades de Judá destruyendo los cipos sagrados, las imágenes de Aserá, los lugares de culto de las colinas y los altares en todo Judá, Benjamín, Efraín y Manasés hasta su extinción total. Luego regresaron a sus ciudades, cada uno a su propiedad."
,"2":"Ezequías restableció las clases de sacerdotes y de los levitas y asignó a cada uno su servicio: los holocaustos, los sacrificios de reconciliación, el servicio, la acción de gracias y la alabanza con las puertas del campamento del Señor."
,"3":"El rey había reservado parte de sus propios bienes para los holocaustos de la mañana y de la tarde, de los sábados, de los novilunios y de las solemnidades según está escrito en la ley del Señor."
,"4":"Ordenó a los habitantes de Jerusalén que entregaran la parte correspondiente a los sacerdotes y levitas para que éstos pudieran dedicarse enteramente a la ley del Señor."
,"5":"Tan pronto como se hizo pública la orden, los israelitas entregaron con gran generosidad las primicias del trigo, del mosto, del aceite, de la miel y de todos los productos del campo, y la décima parte de todos sus productos."
,"6":"Los de Israel y los de Judá, que vivían en otras ciudades de Judá, entregaron también la décima parte del ganado mayor y menor y de las cosas santas consagradas al Señor, su Dios: lo entregaron y lo distribuyeron por montones."
,"7":"Comenzaron a hacer los montones en el tercer mes y terminaron en el séptimo."
,"8":"Cuando Ezequías y sus jefes vieron tantos montones, bendijeron al Señor y a su pueblo Israel."
,"9":"Ezequías preguntó a los sacerdotes y a los levitas acerca de los montones."
,"10":"Azarías, de la familia de Sadoc y sumo sacerdote, le dijo: 'Desde que vinieron a traer las ofrendas al templo del Señor, hemos comido hasta saciarnos y ha sobrado en abundancia porque el Señor ha bendecido a su pueblo; aquí está amontonado lo que sobra'."
,"11":"Ezequías mandó preparar almacenes en el templo del Señor. Una vez preparados,"
,"12":"almacenaron fielmente las ofrendas, la décima parte que habían traído y las cosas consagradas al Señor. El levita Conanías fue el encargado mayor, y su hermano Simeí, el segundo."
,"13":"Yejiel, Azazías, Najat, Asael, Yerimot, Yozabad, Eliel, Jismaquías, Májat y Benayas eran inspectores bajo la dirección de Conanías y su hermano Simeí, según las órdenes del rey Ezequías y las de Azarías, prefecto del templo."
,"14":"Coré, hijo de Yimná, el levita, portero de la puerta oriental, estaba encargado de las ofrendas voluntarias hechas a Dios: debía distribuir las primicias ofrecidas al Señor y las cosas consagradas."
,"15":"Bajo sus órdenes estaban Eden, Minyamín, Jesúa, Semayas, Amarías y Secanías, los cuales residían permanentemente en las ciudades sacerdotales para hacer la distribución entre sus hermanos divididos en clases, lo mismo a grandes que a pequeños,"
,"16":"a todos los que iban al templo del Señor, según el estatuto diario, a prestar sus servicios según sus funciones y según sus clases con tal que estuvieran en el registro que incluía a los varones de tres años para arriba."
,"17":"El registro de los sacerdotes estaba hecho por familias patriarcales; y el de los levitas mayores de veinte años, por sus funciones y sus clases;"
,"18":"el registro incluía toda la familia: mujeres, hijos e hijas, y era válido para toda la comunidad, para que la distribución se hiciera con toda justicia."
,"19":"Respecto de los sacerdotes, descendientes de Aarón, que vivían en los campos de las respectivas ciudades, había en cada ciudad hombres expresamente designados para hacer las distribuciones a todo varón entre los sacerdotes y a todos los levitas inscritos."
,"20":"Ésta es la obra de Ezequías en todo Judá; hizo lo que es bueno, recto y fiel a los ojos del Señor, su Dios."
,"21":"En todo lo que hizo por el servicio del templo del Señor, de la ley y de los mandamientos, buscó siempre a su Dios con todo su corazón. Por eso tuvo éxito."
}`)
	CurrentBook.AddChapter(32, `{
"1":"Después de estos hechos y actos de fidelidad, vino Senaquerib, rey de Asiria, invadió Judá y asedió las ciudades fortificadas con el propósito de conquistarlas."
,"2":"Ezequías, viendo que Senaquerib avanzaba con la intención de atacar Jerusalén,"
,"3":"decidió, de acuerdo con sus jefes y sus oficiales, cegar las fuentes que había fuera de la ciudad."
,"4":"Se reunió una gran muchedumbre y cegaron todas las fuentes, así como el canal subterráneo, para que cuando llegaran los asirios no encontraran agua en abundancia."
,"5":"Ezequías, lleno de ánimo, reparó las murallas en todos sus puntos débiles, levantó torres sobre ellas, construyó un segundo muro exterior, restauró el terraplén en la ciudad de David y al mismo tiempo fabricó gran cantidad de dardos y escudos."
,"6":"Puso jefes militares al frente del pueblo, reunió a todos en la plaza de la puerta de la ciudad y les dirigió a todos esta arenga:"
,"7":"'Sed fuertes, tened valor. No tengáis miedo ante el rey de Asiria y ante esa horda que le acompaña, porque el que está con nosotros es más poderoso que el que está con él."
,"8":"Con él no hay más que brazos de carne; con nosotros está el Señor, nuestro Dios, pronto a socorrernos y combatir nuestros combates'. El pueblo cobró ánimo con las palabras de Ezequías, rey de Judá."
,"9":"Senaquerib, rey de Asiria, que estaba en Laquis con todo su ejército, envió una embajada a Jerusalén para decir a Ezequías, rey de Judá, y a todo el pueblo de Judá que estaba en Jerusalén:"
,"10":"'Esto dice Senaquerib, rey de Asiria: ¿En qué ponéis vuestra confianza para seguir viviendo sitiados en Jerusalén?"
,"11":"¿No os dais cuenta de que Ezequías os está engañando y exponiendo a morir de hambre y de sed mientras os dice: El Señor, nuestro Dios, nos librará de la mano del rey de Asiria?"
,"12":"¿No ha sido Ezequías quien ha destruido las colinas y sus altares y ha dicho a Judá y a Jerusalén que se postren sólo ante un altar y sólo en él quemen incienso?"
,"13":"¿Desconocéis todo lo que yo y mis padres hemos hecho con todos los pueblos de la tierra? ¿Los dioses de todos esos pueblos pudieron librarlos de mi poder?"
,"14":"¿Qué dioses de esos pueblos destruidos por mis padres pudieron librar a su pueblo de mi poder? ¿Podría, por tanto, vuestro Dios libraros a vosotros de mi poder?"
,"15":"Así que no os dejéis engañar por Ezequías ni os dejéis seducir de esta manera. No le creáis, porque si ningún dios de nación o reino alguno pudo salvar a su pueblo de mi poder y del poder de mis padres, mucho menos podrá libraros a vosotros vuestro Dios'."
,"16":"Esto y mucho más dijeron contra el Señor Dios y contra Ezequías, su servidor."
,"17":"Senaquerib escribió esta carta, en la que desafiaba al Señor, Dios de Israel: 'De la misma manera que los dioses de los pueblos de la tierra no pudieron librarlos de mi poder, tampoco el Dios de Ezequías podrá librar a su pueblo de mi poder'."
,"18":"Hablaban en hebreo y en alta voz al pueblo de Jerusalén, que estaba en las murallas, con el fin de intimidarlos, asustarlos y tomar así la ciudad."
,"19":"Hablaban del Dios de Jerusalén como de los dioses de los otros pueblos de la tierra, dioses hechos por los hombres."
,"20":"El rey Ezequías y el profeta Isaías, hijo de Amós, oraron y clamaron al cielo."
,"21":"y el Señor envió a un ángel, que aniquiló a todos los soldados, jefes y oficiales del campamento del rey de Asiria, el cual se vio obligado a regresar lleno de vergüenza a su tierra, donde murió asesinado a golpe de espada por sus propios hijos cuando estaba en el templo de su dios."
,"22":"El Señor libró a Ezequías y a los habitantes de Jerusalén del poder de Senaquerib, rey de Asiria, y de todos sus enemigos, dándoles paz en todas sus fronteras."
,"23":"Muchos llevaron ofrendas al Señor a Jerusalén y presentes a Ezequías, rey de Judá, que adquirió gran prestigio ante todas las naciones a raíz de estos acontecimientos."
,"24":"En aquellos días Ezequías cayó mortalmente enfermo. Rogó al Señor, que escuchó su oración y se curó milagrosamente."
,"25":"Pero Ezequías no correspondió al favor recibido, sino que se llenó de soberbia, por lo que la ira del Señor se encendió contra él, contra Judá y contra Jerusalén."
,"26":"Pero Ezequías se arrepintió de su soberbia y con él todos los habitantes de Jerusalén, por lo que la ira del Señor no cayó sobre ellos en vida de Ezequías."
,"27":"Ezequías fue muy rico y famoso. Atesoró una gran cantidad de plata, oro, piedras preciosas, aromas, escudos y toda clase de objetos valiosos."
,"28":"Construyó depósitos para almacenar vino, trigo y aceite, establos para las distintas clases de ganado y apriscos para sus rebaños."
,"29":"Edificó ciudades y tuvo gran cantidad de ganado mayor y menor, pues el Señor le dio riquezas inmensas."
,"30":"Ezequías fue también quien cegó el manantial superior de las aguas de Guijón y las condujo bajo tierra al lado occidental de la ciudad de David. Ezequías tuvo éxito en todas sus empresas."
,"31":"Cuando los príncipes de Babilonia le enviaron una embajada para preguntarle sobre el milagro que había tenido lugar en el país, si Dios le abandonó, fue sólo con el fin de probarlo y conocer el fondo de su corazón."
,"32":"El resto de la historia de Ezequías y sus obras de piedad están escritas en la visión del profeta Isaías, hijo de Amós, en el libro de los reyes de Judá y de Israel."
,"33":"Ezequías murió y fue sepultado en la subida hacia las tumbas de los hijos de David. Todo Judá y los habitantes de Jerusalén le rindieron honores. Le sucedió en el trono su hijo Manasés."
}`)
	CurrentBook.AddChapter(33, `{
"1":"Manasés tenía doce años cuando subió al trono, y reinó cincuenta y cinco años en Jerusalén."
,"2":"Hizo lo que es malo a los ojos del Señor, imitando las abominaciones de las gentes que el Señor había echado delante de los israelitas."
,"3":"Reconstruyó las colinas que su padre Ezequías había destruido, levantó altares a Baal, hizo imágenes de Aserá y adoró a todos los astros del cielo y les rindió culto."
,"4":"Levantó altares en el templo del Señor, del que el Señor había dicho: 'En Jerusalén habitará mi nombre eternamente'."
,"5":"Levantó altares a todos los astros del cielo en los dos atrios del templo del Señor."
,"6":"Quemó a sus propios hijos en el valle de Ben Hinnón. Se dio a la magia, a la adivinación, al ocultismo, se rodeó de nigromantes y encantadores; hizo tantas cosas malas a los ojos del Señor, que provocó su indignación."
,"7":"Y hasta puso la imagen de Aserá en el templo del Señor, del que Dios había dicho a David y a Salomón, su hijo: 'En este templo y en Jerusalén, elegida por mí entre todas las tribus de Israel, pondré mi nombre para siempre;"
,"8":"y no permitiré de nuevo que los israelitas anden errantes fuera de la tierra que he dado a sus padres con tal que hagan lo que yo les he ordenado y cumplan la ley, los mandamientos y preceptos que les di por medio de Moisés'."
,"9":"Pero Manasés descarrió a los de Judá y a los habitantes de Jerusalén, induciéndoles a hacer el mal más aún que las gentes que el Señor había destruido ante los israelitas."
,"10":"El Señor habló a Manasés y a su pueblo, pero no le escucharon."
,"11":"Entonces el Señor hizo venir contra ellos a los jefes del ejército del rey de Asiria, los cuales apresaron a Manasés con grillos y, cargado de cadenas, lo condujeron a Babel."
,"12":"En medio de su angustia imploró al Señor, su Dios, y se humilló profundamente delante del Dios de sus padres."
,"13":"Suplicó al Señor, y el Señor lo atendió, escuchó su oración y lo reintegró a su reino de Jerusalén. Manasés reconoció que el Señor era el auténtico Dios."
,"14":"Después de esto restauró la muralla exterior de la ciudad de David, al occidente de Guijón, en el valle, hasta la puerta de los Peces, la cual rodeaba al Ofel y era muy alta. Puso jefes militares en todas las ciudades fortificadas de Judá."
,"15":"Quitó del templo del Señor los dioses extranjeros, el ídolo y todos los altares que él mismo había levantado sobre el monte del templo y en Jerusalén, y los tiró fuera de la ciudad."
,"16":"Restauró el altar del Señor y ofreció sobre él sacrificios de reconciliación y de acción de gracias y mandó a Judá rendir culto al Señor, Dios de Israel."
,"17":"Pero el pueblo continuaba ofreciendo sacrificios en las colinas, aunque sólo al Señor, su Dios."
,"18":"El resto de la historia de Manasés, la oración que hizo a su Dios y las palabras de los profetas que le hablaron en nombre del Señor, Dios de Israel, están escritos en las crónicas de los reyes de Israel."
,"19":"Su oración y su acogida, todas sus prevaricaciones y su impiedad, los lugares en los que levantó altares y puso imágenes de Aserá e ídolos antes de su conversión, están escritos en las crónicas de Jozay."
,"20":"Manasés murió y fue sepultado en su palacio. Le sucedió en el trono su hijo Amón."
,"21":"Amón tenía veintidós años cuando subió al trono, y reinó dos años en Jerusalén."
,"22":"Hizo lo que es malo a los ojos del Señor, como su padre Manasés; ofreció sacrificios y dio culto a todos los ídolos que había hecho su padre Manasés."
,"23":"Pero no se humilló delante del Señor, como se había humillado su padre Manasés; al contrario, aumentó su culpabilidad."
,"24":"Sus mismos servidores tramaron una conjura contra él y lo asesinaron en su propia casa."
,"25":"El pueblo mató a todos los que se habían conjurado contra Amón, y proclamó rey a su hijo Josías."
}`)
	CurrentBook.AddChapter(34, `{
"1":"Josías tenía ocho años cuando subió al trono, y reinó treinta y un años en Jerusalén."
,"2":"Hizo lo que es justo a los ojos del Señor y siguió los caminos de su padre David, sin apartarse a derecha ni a izquierda."
,"3":"El año octavo de su reinado, siendo joven todavía, comenzó a buscar al Dios de su padre David, y en el año doce se puso a limpiar a Judá y a Jerusalén de las colinas, de las imágenes de Aserá, de los ídolos y de las estatuas."
,"4":"Fueron destruidos en su presencia los altares de Baal y los cipos que había sobre ellos. Rompió las imágenes de Aserá, los ídolos y las estatuas; los hizo polvo y lo esparció sobre las tumbas de quienes les habían ofrecido sacrificios."
,"5":"Quemó los huesos de los sacerdotes sobre sus altares, y así purificó a Judá y Jerusalén."
,"6":"Lo mismo hizo en las ciudades de Manasés, Efraín, Simeón y hasta Neftalí y sus respectivos anejos;"
,"7":"derribó los altares y las imágenes de Aserá; despedazó y pulverizó los ídolos y rompió los cipos en todo el territorio de Israel. Luego regresó a Jerusalén."
,"8":"El año dieciocho de su reinado, después de haber purificado la tierra y el templo, envió a Safán, hijo de Asalías, y Maasías, gobernador de la ciudad, y a su secretario Yoaj, hijo de Yoajaz, a reparar el templo del Señor, su Dios."
,"9":"Se presentaron al sumo sacerdote Jelcías, y le entregaron el dinero que había llegado al templo de Dios y el que los levitas porteros habían reunido; todo ello procedía de Manasés, de Efraín, de todo el resto de Israel, de Judá, de Benjamín y de los habitantes de Jerusalén."
,"10":"Se lo dieron luego a los encargados de las obras del templo del Señor para pagar a los obreros que trabajaban en la reparación y restauración del templo del Señor;"
,"11":"a los carpinteros y canteros para comprar piedras talladas y maderas para trabajar y entarimar las habitaciones que estaban en estado ruinoso por incuria de los reyes de Judá."
,"12":"Los hombres llevaban a cabo el trabajo con fidelidad, bajo la vigilancia y dirección de los levitas Yájat y Abdías, meraritas, y de Zacarías y Mesulán, quehatitas. Los levitas, expertos en instrumentos musicales,"
,"13":"estaban al frente de los acarreadores y de todos los que trabajaban en la obra. Algunos levitas eran cronistas, inspectores y porteros."
,"14":"Cuando estaban sacando el dinero reunido en el templo del Señor, el sacerdote Jelcías encontró el libro de la ley del Señor dada por medio de Moisés."
,"15":"Jelcías dijo a Safán, el secretario: 'He encontrado el libro de la ley en el templo del Señor'. Jelcías dio el libro a Safán."
,"16":"Safán llevó el libro al rey y le informó: 'Tus siervos están cumpliendo todo lo que les has encargado."
,"17":"Han recogido el dinero que había en el templo y se lo han dado a los encargados de las obras'."
,"18":"Después le comunicó la noticia: 'El sacerdote Jelcías me ha dado este libro'. Y Safán lo leyó en presencia del rey."
,"19":"Cuando el rey oyó las palabras del libro de la ley, rasgó sus vestiduras"
,"20":"y ordenó a Jelcías, a Ajicán, hijo de Safán, a Abdón, hijo de Miqueas, a Safán, el secretario, y a Asayas, cortesano del rey:"
,"21":"'Id y consultad al Señor por mí y por todos los supervivientes en Israel y en Judá acerca de las palabras de este libro que se ha encontrado, pues la cólera del Señor se ha encendido contra nosotros, porque nuestros padres no hicieron caso de las palabras de este libro, cumpliendo lo que está escrito en él'."
,"22":"Jelcías y las gentes del rey fueron a ver a la profetisa Julda, esposa de Salún, hijo de Ticuá y nieto de Jasrá, guardarropa del templo. Julda vivía en el barrio nuevo de Jerusalén. Le expusieron el caso,"
,"23":"y ella les dijo: 'Esto dice el Señor, Dios de Israel: Decid al hombre que os ha enviado:"
,"24":"Esto dice el Señor: Voy a traer la desgracia sobre este lugar y sobre sus habitantes, es decir, todas las maldiciones escritas en el libro que ha sido leído al rey de Judá,"
,"25":"por haberme abandonado y haber quemado incienso a dioses extranjeros provocando mi indignación con todas las obras de sus manos. Mi cólera se encenderá contra este lugar y no se apagará."
,"26":"Y al rey de Judá, que os ha mandado a consultar al Señor, decidle: Esto dice el Señor, Dios de Israel, respecto a las palabras que has escuchado:"
,"27":"Por haberse conmovido tu corazón y haberte humillado delante del Señor al oír las palabras con que él ha amenazado a este lugar y a sus habitantes, por haberte humillado delante de mí, por haberte rasgado las vestiduras y haber llorado delante de mí, también yo te he escuchado, dice el Señor."
,"28":"Por eso te concederé morir y ser enterrado en paz; tus ojos no verán toda la desventura que yo voy a acarrear sobre este lugar y sus habitantes'. Los mensajeros llevaron la respuesta al rey."
,"29":"El rey convocó a todos los ancianos de Judá y Jerusalén"
,"30":"y fue al templo del Señor con todos los hombres de Judá, los habitantes de Jerusalén, los sacerdotes, los levitas y todo el pueblo, chicos y grandes, y leyó ante ellos todas las palabras del libro de la alianza encontrado en el templo del Señor."
,"31":"Y luego, de pie en el estrado, selló ante la presencia del Señor el pacto de seguir al Señor, de guardar sus mandatos, sus instrucciones y sus leyes con todo el corazón y con toda el alma y de cumplir las cláusulas de la alianza escritas en aquel libro."
,"32":"Hizo que todos los presentes de Judá y de Benjamín ratificaran la alianza. Los habitantes de Jerusalén obraron según la alianza de Dios, Dios de sus padres."
,"33":"Josías quitó de todo el territorio de Israel todos los ídolos repugnantes e hizo que todos los que se encontraban en Israel sirvieran al Señor, su Dios. Durante todos los días de su vida no se apartaron del Señor, Dios de sus padres."
}`)
	CurrentBook.AddChapter(35, `{
"1":"Josías celebró en Jerusalén la pascua en honor del Señor. Se inmoló el cordero pascual el día catorce del primer mes."
,"2":"Estableció a los sacerdotes en sus oficios y los animó a servir en el templo del Señor."
,"3":"Luego dijo a los levitas encargados de instruir a todo Israel y consagrados al Señor: 'Colocad el arca santa en el templo que edificó Salomón, hijo de David, y rey de Israel; ya no será un peso para vuestros hombros. Ahora serviréis al Señor, vuestro Dios, y a su pueblo Israel."
,"4":"Organizaos en turnos por familias, según la ordenación escrita por David, rey de Israel, y su hijo Salomón."
,"5":"Estad en vuestros puestos en el santuario al servicio de las clases de las familias patriarcales, y de vuestros hermanos, hijos del pueblo. Un grupo de levitas por cada familia patriarcal."
,"6":"Inmolad el cordero pascual, purificaos y preparad todo lo necesario para que vuestros hermanos puedan cumplir lo que el Señor mandó por medio de Moisés'."
,"7":"Josías, de su propio ganado, dio a los presentes, para celebrar la pascua, 30.000 corderos y cabritos y 3.000 toros."
,"8":"Los oficiales del rey hicieron también donativos voluntarios al pueblo, a los sacerdotes y a los levitas. Jelcías, Zacarías y Yejiel, prefectos del templo del Señor, dieron a los sacerdotes para celebrar la pascua 2.600 corderos y 300 toros."
,"9":"Los jefes de los levitas, Conanías, Semayas y su hermano Natanael, Jasabías, Yeiel y Yozabad, dieron a los levitas, para celebrar la pascua, 5.000 corderos y 500 bueyes."
,"10":"El servicio se organizó así: los sacerdotes estaban en sus puestos y los levitas en sus funciones, de acuerdo con la ordenación real."
,"11":"Inmolaron los animales de la pascua; los sacerdotes derramaban la sangre y los levitas desollaban las víctimas."
,"12":"Separaban las partes que debían ser quemadas y distribuían el resto al pueblo por grupos de familias para que lo ofrecieran al Señor, según está escrito en el libro de Moisés. Lo mismo hicieron con el ganado mayor."
,"13":"Asaron al fuego el cordero pascual como está prescrito, cocieron las demás ofrendas sagradas en calderas, calderos y sartenes, y las distribuyeron luego diligentemente entre todo el pueblo."
,"14":"Finalmente, los levitas prepararon la parte correspondiente para ellos y para los sacerdotes, descendientes de Aarón, los cuales habían estado ocupados en la ofrenda de los holocaustos y de las grasas hasta la noche; por eso los levitas prepararon la parte correspondiente para ellos y para los sacerdotes, hijos de Aarón."
,"15":"Los cantores, hijos de Asaf, estaban en su puesto, según las prescripciones de David: Asaf, Hemán y Yedutún, el vidente del rey; los porteros de cada puerta no tuvieron necesidad de abandonar sus puestos, pues los levitas, sus hermanos, se lo prepararon."
,"16":"Así se organizó aquel día todo el servicio del Señor para la celebración de la pascua y la ofrenda de los holocaustos sobre el altar del Señor, según la ordenación del rey Josías."
,"17":"Los israelitas que se encontraban presentes celebraron la pascua, y durante siete días la fiesta de los panes sin levadura."
,"18":"Nunca en Israel había habido una pascua como ésta desde los días de Samuel, el vidente. Más aún, ningún rey de Israel había celebrado una pascua semejante a la celebrada por Josías en compañía de sacerdotes y levitas, presentes todo Judá e Israel, con los habitantes de Jerusalén."
,"19":"Fue el año dieciocho del reinado de Josías cuando se celebró esta pascua."
,"20":"Después de esto, cuando Josías ya había restaurado el templo del Señor, Necó, rey de Egipto, fue a presentar batalla en Cárquemis, junto al Éufrates. Josías le salió al paso,"
,"21":"y Necó mandó a decirle: '¿Qué tengo yo que ver contigo, rey de Judá? No es contra ti contra quien voy; es contra otra nación con la que estoy en guerra, y Dios me ha dicho que me dé prisa. No te opongas a Dios, que está conmigo, no sea que te destruya'."
,"22":"Josías, sin embargo, no quiso ceder, e incluso se preparaba para atacarlo, sin dar oídos a lo que Necó decía en nombre de Dios. Avanzó y presentó batalla en el valle de Meguido."
,"23":"Los arqueros dispararon contra el rey Josías, que dijo a sus oficiales: 'Retiradme, porque estoy gravemente herido'."
,"24":"Los oficiales lo sacaron de su carro, lo subieron a otro de los suyos y lo llevaron a Jerusalén, donde murió. Fue sepultado en las sepulturas de sus padres. Todo Judá y Jerusalén guardó luto por Josías."
,"25":"Jeremías compuso una lamentación sobre Josías, que todos los cantores y cantoras recitan todavía hoy entre sus elegías sobre el rey Josías; ha venido a ser una regla en Israel, y están escritas en las Lamentaciones."
,"26":"El resto de la historia de Josías, las obras de piedad que hizo, conforme a la ley del Señor,"
,"27":"todo lo que hizo, desde el principio al fin, está escrito en el libro de los reyes de Israel y de Judá."
}`)
	CurrentBook.AddChapter(36, `{
"1":"La gente del pueblo tomó a Joacaz, hijo de Josías, y lo proclamó rey en Jerusalén en lugar de su padre."
,"2":"Joacaz tenía veintitrés años cuando subió al trono, y reinó tres meses en Jerusalén."
,"3":"El rey de Egipto lo destronó de Jerusalén e impuso al país un tributo de 3.400 kilos de plata y 34 de oro."
,"4":"El rey de Egipto nombró a su hermano Eliaquín rey de Judá y Jerusalén y le cambió el nombre en Joaquín. A su hermano Joacaz lo llevó prisionero a Egipto."
,"5":"Joaquín tenía veinticinco años cuando subió al trono, y reinó once años en Jerusalén. Hizo lo que es malo a los ojos del Señor, su Dios."
,"6":"Nabucodonosor, rey de Babilonia, fue contra él y lo llevó a Babilonia cargado de cadenas."
,"7":"Nabucodonosor se llevó también a Babilonia parte de los objetos del templo del Señor y los puso en su palacio de Babilonia."
,"8":"El resto de la historia de Joaquín, las iniquidades que cometió y todo lo que ocurrió, está escrito en el libro de los reyes de Israel y de Judá. Le sucedió en el trono su hijo Jeconías."
,"9":"Jeconías tenía dieciocho años cuando subió al trono, y reinó tres meses y diez días en Jerusalén. Hizo lo que es malo a los ojos del Señor."
,"10":"A la vuelta del año, el rey Nabucodonosor mandó que lo llevaran a Babilonia con el valioso mobiliario del templo del Señor, y nombró rey de Judá y Jerusalén a su tío Sedecías."
,"11":"Sedecías tenía veintiún años cuando subió al trono, y reinó once años en Jerusalén."
,"12":"Hizo lo que es malo a los ojos del Señor, su Dios, y no quiso humillarse delante del profeta Jeremías, el cual hablaba en nombre del Señor."
,"13":"Se rebeló asimismo contra el rey Nabucodonosor, al cual había prestado juramento en el nombre de Dios. Fue terco y obstinado y no quiso convertirse al Señor, Dios de Israel."
,"14":"Igualmente, todos los jefes de los sacerdotes y del pueblo multiplicaron las infidelidades, siguiendo las prácticas abominables de las naciones y profanando el templo que el Señor se había consagrado en Jerusalén."
,"15":"El Señor, Dios de sus padres, les envió continuos mensajeros, porque quería salvar a su pueblo y a su templo."
,"16":"Pero ellos hacían escarnio de los enviados de Dios, despreciaban sus palabras, se burlaban de sus profetas, hasta el punto que la ira del Señor contra su pueblo se hizo irremediable."
,"17":"El Señor mandó contra ellos al rey de los caldeos, que pasó a espada a sus jóvenes en el santuario mismo, sin perdonar a nadie, ni joven ni virgen, ni anciano ni hombre encanecido. Dios los entregó a todos en sus manos."
,"18":"Nabucodonosor se llevó para Babilonia los objetos del templo de Dios, grandes y pequeños; los tesoros del templo y los tesoros del rey y a sus jefes."
,"19":"El templo del Señor fue pasto de las llamas, las murallas de Jerusalén derribadas, los palacios incendiados y los objetos preciesos destruidos."
,"20":"Nabucodonosor llevó al destierro de Babilonia a todos los que habían escapado de la espada, los cuales pasaron a ser esclavos del rey y de sus hijos hasta el establecimiento del reino persa."
,"21":"Así se cumplía la palabra del Señor pronunciada por Jeremías: 'Hasta que la tierra disfrute de su descanso, descansará durante todos los días de la desolación, hasta que se cumplan setenta años'."
,"22":"El año primero de Ciro, rey de Persia, en cumplimiento de su palabra anunciada por medio de Jeremías, el Señor impulsó a Ciro, rey de Persia, a que proclamara de viva voz y por escrito en todo su reino este edicto:"
,"23":"'Esto dice Ciro, rey de Persia: El Señor, Dios del cielo, me ha dado todos los reinos de la tierra y me ha encargado de construirle un templo en Jerusalén, en Judá. El que de vosotros pertenezca a su pueblo, que vaya a Jerusalén, y que el Señor, su Dios, lo ayude'."
}`)

}
func ES_LSB_LoadVH2RChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Después de la muerte de Ajab, Moab se rebeló contra Israel."
,"2":"Ocozías se cayó por una ventana del piso superior en Samaría, resultando gravemente herido. Y envió mensajeros a consultar a Belcebú, dios de Ecrón, si se curaría de sus heridas."
,"3":"Entonces el ángel del Señor dijo a Elías, el tesbita: 'Anda al encuentro de los mensajeros del rey de Samaría y diles: ¿Es que no hay Dios en Israel, para que vayáis a consultar a Belcebú, dios de Ecrón?"
,"4":"Pues esto dice el Señor: Ya no te levantarás de la cama, sino que morirás sin remedio'. Y Elías se fue."
,"5":"Los mensajeros regresaron, y Ocozías les preguntó: '¿Por qué os habéis vuelto?'."
,"6":"Ellos le respondieron: 'Un hombre nos ha salido al encuentro y nos ha dicho: Volveos al rey y decidle: Esto dice el Señor: ¿Es que no hay Dios en Israel para que mandes a consultar a Belcebú, dios de Ecrón? Por eso, ya no te levantarás de la cama, sino que morirás sin remedio'."
,"7":"Les preguntó: '¿Qué aspecto tenía el hombre que os ha salido al encuentro y os ha dicho estas cosas?'."
,"8":"Le respondieron: 'Era un hombre velludo y con una correa de cuero ceñida a la cintura'. 'Es Elías, el tesbita', exclamó el rey."
,"9":"Entonces le envió un capitán con sus cincuenta soldados. Llegó éste donde Elías, que estaba sentado en la cima del monte, y le dijo: 'Hombre de Dios, el rey ordena que vayas'."
,"10":"Elías le respondió: 'Si yo soy un hombre de Dios, que baje fuego del cielo y te devore a ti y a tus cincuenta'. Bajó fuego del cielo, y lo devoró a él y a sus cincuenta."
,"11":"Ocozías volvió a enviarle otro capitán con sus cincuenta, el cual fue y le dijo: 'Hombre de Dios, el rey ordena que vayas en seguida'."
,"12":"Elías respondió: 'Si yo soy un hombre de Dios, que baje fuego del cielo y te devore a ti y a tus cincuenta'. Bajó fuego del cielo y lo devoró a él y a sus cincuenta."
,"13":"El rey volvió a enviar un tercer capitán con sus cincuenta soldados. Pero este tercer capitán fue, se postró de rodillas ante Elías y le suplicó: 'Hombre de Dios, ¡por favor! Que mi vida y la de estos cincuenta siervos tuyos sea preciosa a tus ojos."
,"14":"Ha bajado fuego del cielo y ha devorado a los dos capitanes de cincuenta y a su gente, pero ahora, que mi vida sea preciosa a tus ojos'."
,"15":"El ángel del Señor dijo a Elías: 'Anda con él, no le tengas miedo'. Fue con él, se presentó ante el rey,"
,"16":"y le dijo: 'Esto dice el Señor: Por haber enviado mensajeros a consultar a Belcebú, dios de Ecrón, como si no hubiese Dios en Israel para consultar su oráculo, no te levantarás ya de la cama, sino que morirás sin remedio'."
,"17":"Ocozías murió como había dicho el Señor por medio de Elías. Le sucedió en el trono su hermano Jorán, el año segundo de Jorán, hijo de Josafat, rey de Judá, pues Ocozías no tenía hijos."
,"18":"El resto de la historia de Ocozías y todo lo que hizo está escrito en el libro de los anales de los reyes de Israel."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Cuando el Señor iba a arrebatar a Elías en torbellino al cielo, Elías y Eliseo salieron de Guilgal."
,"2":"Y Elías dijo a Eliseo: 'Quédate aquí, porque el Señor me manda ir hasta Betel'. Eliseo replicó: '¡Por Dios y por tu vida que no te dejaré!'. Y fueron juntos a Betel."
,"3":"Los discípulos de los profetas que había en Betel salieron al encuentro de Eliseo y le dijeron: '¿No sabes que el Señor va a llevarse a tu amo por encima de tu cabeza?'. Él contestó: 'También yo lo sé; callad'."
,"4":"Elías dijo a Eliseo: 'Quédate aquí, porque el Señor me manda ir a Jericó'. Él replicó: '¡Por Dios y por tu vida que no te dejaré!'. Y fueron juntos a Jericó."
,"5":"Los discípulos de los profetas de Jericó fueron y dijeron a Eliseo: '¿No sabes que el Señor se va a llevar hoy a tu amo por encima de tu cabeza?'. Él contestó: 'También yo lo sé, callad'."
,"6":"Luego Elías le dijo: 'Quédate aquí, porque el Señor me manda ir al Jordán'. Y él replicó: '¡Por Dios y por tu vida que no te dejaré!'. Y fueron los dos juntos."
,"7":"Cincuenta discípulos de los profetas fueron también y se pararon frente a ellos a cierta distancia, mientras que los dos se detuvieron junto al Jordán."
,"8":"Entonces Elías tomó su manto, lo enrolló y golpeó con él las aguas, las cuales se dividieron a uno y otro lado, de modo que pasaron ambos a pie enjuto."
,"9":"Y cuando pasaron, Elías dijo a Eliseo: 'Pídeme lo que quieras antes de que sea arrebatado de tu presencia'. Eliseo contestó: 'Que pasen a mí las dos terceras partes de tu espíritu'."
,"10":"Elías repuso: 'Difícil cosa has ido a pedir. Con todo, si me ves cuando sea arrebatado de tu presencia, te será concedida; y si no, no lo será'."
,"11":"Y mientras iban caminando y conversando, un carro de fuego, con caballos de fuego, pasó entre los dos, y Elías fue arrebatado en un torbellino hacia el cielo."
,"12":"Eliseo le veía y gritaba: '¡Padre mío, padre mío, carro y caballería de Israel!'. Y cuando dejó de verle, agarró sus vestiduras y las rasgó en dos pedazos."
,"13":"Alzó luego el manto de Elías, que se le había caído de encima, se volvió y se detuvo a la orilla del Jordán."
,"14":"Entonces tomó el manto, que se le había caído a Elías de encima, y golpeó con él las aguas, diciendo: '¿Dónde está el Señor, Dios de Elías? ¿Dónde está?'. Golpeó las aguas, y éstas se dividieron a uno y otro lado, y pasó a pie enjuto."
,"15":"Los discípulos de los profetas de Jericó lo vieron desde el otro lado, y exclamaron: 'El espíritu de Elías se ha posado sobre Eliseo'. Le salieron al encuentro y se prosternaron ante él rostro en tierra."
,"16":"Luego le dijeron: 'Mira, entre tus siervos hay cincuenta hombres robustos. Que vayan y busquen a tu amo, no sea que le haya arrebatado el espíritu del Señor y le haya arrojado en algún monte o en algún valle'. Pero él dijo: 'No los mandéis'."
,"17":"Y tanto le insistieron, que les dijo: 'Mandadlos'. Y mandaron cincuenta hombres, que lo buscaron durante tres días, pero no lo encontraron."
,"18":"Volvieron a Jericó, donde estaba Eliseo, que les dijo: '¿No os dije yo que no fuerais?'."
,"19":"Los vecinos de la ciudad dijeron a Eliseo: 'Mira, en esta ciudad se vive bien, como mi señor ve; pero las aguas son malas y esterilizan la tierra'."
,"20":"Él contestó: 'Traedme una escudilla nueva y poned en ella sal'. Y se la trajeron."
,"21":"Y fue al manantial del agua, y echó allí la sal, diciendo: 'Esto dice el Señor: Yo saneo estas aguas; no se originará de ellas en adelante muerte ni esterilidad'."
,"22":"Y el agua quedó saneada hasta el presente, tal como Eliseo había dicho."
,"23":"De allí Eliseo fue a Betel y, cuando iba por el camino, unos rapazuelos que habían salido de la ciudad empezaron a burlarse de él, diciéndole: '¡Sube, calvo! ¡Sube, calvo!'."
,"24":"Él se dio media vuelta, los miró y los maldijo en el nombre del Señor. Entonces salieron del bosque dos osas y despedazaron a cuarenta y dos de aquellos muchachos."
,"25":"De allí fue al monte Carmelo, y del Carmelo regresó a Samaría."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Jorán, hijo de Ajab, empezó a reinar sobre Israel en Samaría el año dieciocho de Josafat, rey de Judá. Reinó doce años."
,"2":"Hizo lo que es malo a los ojos del Señor, aunque no tanto como su padre y su madre, pues retiró la estela de Baal, que su padre había hecho."
,"3":"Sin embargo, cometió los mismos pecados que Jeroboán, hijo de Nabat, hizo cometer a Israel."
,"4":"Mesa, rey de Moab, era pastor, y pagaba en tributo al rey de Israel cien mil corderos y cien mil carneros de lana."
,"5":"Pero, al morir Ajab, el rey de Moab se rebeló contra el rey de Israel."
,"6":"Entonces Jorán salió de Samaría y pasó revista a todo Israel."
,"7":"Se puso en camino y mandó decir a Josafat, rey de Judá: 'El rey de Moab se ha rebelado contra mí. ¿Quieres venir conmigo a la guerra contra Moab?'. Contestó: 'Iré, pues tú y yo, tu pueblo y mi pueblo, tu caballería y mi caballería somos una misma cosa'."
,"8":"Luego preguntó: '¿Por qué camino iremos?'. Jorán respondió: 'Por el camino del desierto de Edón'."
,"9":"El rey de Israel, el rey de Judá y el rey de Edón se pusieron en marcha, y, después de un recorrido de siete días, faltó el agua para el ejército y las bestias de tiro."
,"10":"Entonces el rey de Israel exclamó: '¡Ay! Sin duda que el Señor ha reunido a estos tres reyes para entregarlos en manos de Moab'."
,"11":"Pero Josafat preguntó: '¿No habrá aquí algún profeta del Señor, para consultar al Señor por su medio?'. Uno de los servidores del rey de Israel dijo: 'Aquí está Eliseo, el hijo de Safat, el que vertía agua en las manos de Elías'."
,"12":"Y Josafat dijo: 'Con él está la palabra del Señor'. El rey de Israel, Josafat y el rey de Edón fueron a ver a Eliseo."
,"13":"Eliseo dijo al rey de Israel: '¿Qué tengo que ver yo contigo? Vete a consultar a los profetas de tu padre y a los de tu madre'. Pero el rey de Israel repuso: 'Es que el Señor nos ha reunido a tres reyes para entregarnos en manos de Moab'."
,"14":"Eliseo dijo: 'Vive el Señor todopoderoso, a quien adoro, que si no fuese en atención a Josafat, rey de Judá, no te haría caso ni te miraría."
,"15":"Traedme un arpista'. Y, mientras el arpista tañía el arpa, la mano del Señor fue sobre Eliseo,"
,"16":"que dijo: 'Esto dice el Señor: Cavad en este valle aljibes y más aljibes,"
,"17":"porque el Señor dice: No veréis viento, ni veréis lluvia; pero este valle se henchirá de agua, de modo que podáis beber vosotros, vuestros ganados y vuestras bestias de tiro."
,"18":"Y aun esto es poco para el Señor: él entregará a Moab en vuestras manos."
,"19":"Destruiréis todas las ciudades amuralladas, talaréis todos los árboles frutales, cegaréis todos los manantiales de agua y devastaréis con piedras todos los mejores campos'."
,"20":"En efecto, a la mañana siguiente, a la hora de la ofrenda del sacrificio perpetuo, por la parte de Edón empezó a llegar el agua hasta que la comarca quedó inundada."
,"21":"Por su parte, todos los moabitas, enterados de que los reyes avanzaban para luchar contra ellos, se concentraron todos, desde la edad de empuñar las armas para arriba, y se situaron en la frontera."
,"22":"Al levantarse por la mañana, cuando el sol reverberaba en el agua, los moabitas vieron a lo lejos las aguas rojizas como sangre,"
,"23":"y dijeron: 'Esto es sangre. Sin duda que los reyes se han acuchillado y se han matado unos a otros. Moabitas, ¡al botín!'."
,"24":"Marcharon sobre el campamento de Israel; pero los israelitas salieron y asestaron un rudo golpe a Moab, que se dio a la fuga. Ellos entraron en el país y derrotaron a Moab."
,"25":"Demolieron las ciudades y llenaron de piedras los campos fértiles; cegaron todos los manantiales de agua y talaron todos los árboles frutales, hasta que no quedó más que Quir Jareset. Los honderos la cercaron y la atacaron."
,"26":"El rey de Moab, viendo que la lucha era demasiado recia para sus fuerzas, tomó consigo setecientos hombres que empuñaban espada para abrir una brecha contra el rey de Edón, pero no lo consiguió."
,"27":"Etonces tomó a su hijo primogénito, el que debía sucederle en el trono, y lo ofreció en holocausto sobre la muralla. Sobrevino una gran indignación contra los israelitas, los cuales levantaron el campamento y volvieron a su tierra."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Una mujer, esposa de un discípulo de los profetas, fue a lamentarse a Eliseo: 'Mi marido ha muerto. Tú bien sabes que tu siervo era temeroso del Señor. Pues bien, el acreedor ha venido a llevarse mis dos hijos como esclavos'."
,"2":"Eliseo le dijo: '¿Qué puedo hacer por ti? Dime: ¿qué tienes en casa?'. Ella respondió: 'Sólo tengo una orza de aceite'."
,"3":"Él le dijo: 'Anda, que tus vecinos te presten vasijas vacías."
,"4":"Entra luego en tu casa, ciérrate dentro con tus hijos y vierte el aceite en todas esas vasijas, retirándolas según se van llenando'."
,"5":"Ella dejó a Eliseo, y se cerró en casa con sus hijos; éstos le presentaban las vasijas, y ella las llenaba."
,"6":"Cuando las vasijas estaban ya llenas, dijo a uno de sus hijos: 'Tráeme otra vasija'. Pero él respondió: 'No hay más vasijas'. Y el aceite se terminó."
,"7":"Entonces ella fue a contar la cosa al hombre de Dios, el cual le dijo: 'Anda, vende el aceite, paga a tu acreedor, y tú y tus hijos vivid de lo restante'."
,"8":"Un día Eliseo pasaba por Sunán. Vivía allí una mujer distinguida, que le invitó con insistencia a comer. Y en adelante, siempre que pasaba, se paraba allí a comer."
,"9":"Aquella mujer dijo a su marido: 'Mira, me he dado cuenta de que es un hombre de Dios, un santo, ese que pasa siempre por nuestra casa."
,"10":"Vamos a hacerle una habitación arriba, y pongamos allí una cama, una mesa, una silla y un candelabro, para que, cuando venga a nuestra casa, se recoja en ella'."
,"11":"Un día llegó Eliseo, se retiró al aposento y se acostó."
,"12":"Luego dijo a Guejazí, su criado: 'Llama a la sunamita'. La llamó y, cuando se presentó ante él,"
,"13":"Eliseo ordenó a su criado: 'Dile: Nos estás prodigando toda clase de cuidados; ¿qué podría hacer por ti? ¿Tienes alguna solicitud que elevar al rey o al jefe del ejército?'. Ella respondió: 'En medio de mi pueblo vivo'."
,"14":"Eliseo dijo: '¿Qué podríamos hacer por ella?'. Guejazí respondió: '¡No tiene hijos y su marido es ya viejo!'."
,"15":"Eliseo le dijo: 'Llámala'. La llamó, y ella se presentó a la puerta."
,"16":"Eliseo le dijo: 'El año próximo, por estas fechas, tendrás en brazos un hijo'. Ella respondió: 'No, señor mío, hombre de Dios, no engañes a tu sierva'."
,"17":"Y aquella mujer concibió, y al año siguiente, por aquellas fechas, dio a luz un hijo, tal como Eliseo le había anunciado."
,"18":"El niño creció, y un día, que fue adonde estaba su padre con los segadores,"
,"19":"dijo a su padre: '¡Ay mi cabeza! ¡Ay mi cabeza!'. Entonces el padre mandó a un criado: 'Llévaselo a su madre'."
,"20":"Él lo llevó a su madre, y estuvo recostado sobre sus rodillas hasta el mediodía, en que murió."
,"21":"Ella entonces lo subió y lo puso en el lecho del hombre de Dios; luego cerró la puerta y salió."
,"22":"Llamó a su marido y le dijo: 'Mándame uno de los criados y un asna; voy corriendo adonde está el hombre de Dios y vuelvo'."
,"23":"Él replicó: '¿Por qué vas hoy adonde él está, si no es novilunio ni sábado?'. Pero ella dijo: '¡Queda con Dios!'."
,"24":"Mandó aparejar el asna, y dijo al criado: 'Ve guiando, y no me detengas hasta que yo no te lo indique'."
,"25":"Partió, y llegó adonde estaba el hombre de Dios en el monte Carmelo. Cuando el hombre de Dios la divisó desde lejos, dijo a Guejazí, su criado: 'Aquélla es la sunamita."
,"26":"Sal a su encuentro y pregúntale: ¿Estás bien? ¿Está bien tu marido? ¿Está bien tu hijo?'. Ella respondió: 'Sí, bien'."
,"27":"Llegó adonde estaba el hombre de Dios en el monte, y se abrazó a sus pies. Guejazí fue a separarla, pero el hombre de Dios dijo: 'Déjala, porque está muy apenada; pero el Señor me lo ha tenido oculto y nada me ha manifestado'."
,"28":"Ella dijo: '¿Por ventura había pedido yo un hijo a mi señor? ¿No le dije que no me engañase?'."
,"29":"Entonces Eliseo dijo a Guejazí: 'Cíñete los lomos, toma en la mano mi bastón y vete. Si encuentras a alguien, no le saludes; si alguien te saluda, no le respondas. Pon mi bastón sobre el rostro del niño'."
,"30":"Pero la madre del niño replicó: '¡Por el Señor y por tu vida que no te dejaré!'. Eliseo se levantó y la siguió."
,"31":"Guejazí se les adelantó y puso el bastón sobre el rostro del niño, pero no resolló ni dio señal de vida. Entonces fue al encuentro de Eliseo, y le dijo: 'El niño no se ha despertado'."
,"32":"Cuando Eliseo llegó a la casa, el niño estaba muerto, echado en su cama."
,"33":"Entró, se cerró en el aposento con el niño y oró al Señor."
,"34":"Luego se subió a la cama y se echó sobre el niño; puso la boca sobre su boca, los ojos sobre sus ojos, las palmas sobre sus palmas, y estando así inclinado sobre él, el cuerpo del niño entró en calor."
,"35":"Eliseo se apartó y se puso a pasear por la casa de acá para allá. Luego subió y se tendió sobre él. Entonces el niño estornudó hasta siete veces y abrió los ojos."
,"36":"El profeta llamó a Guejazí, y le dijo: 'Llama a la sunamita'. La llamó y, cuando entró, Eliseo dijo: 'Toma a tu hijo'."
,"37":"Ella cayó a sus pies, y se postró en tierra. Tomó a su hijo y salió."
,"38":"Eliseo regresó a Guilgal. En el país había carestía. Y estando un día con él los discípulos de los profetas, dijo a su siervo: 'Pon la olla grande y cuece unas viandas para los discípulos de los profetas'."
,"39":"Uno de ellos salió al campo a recoger verduras, y habiendo encontrado una especie de cepa silvestre, recogió de ella los frutos hasta llenar su capa. Llegó a casa y los picó en la olla de las viandas, sin saber lo que eran."
,"40":"Sirvió luego a los hombres para que comiesen, pero apenas probaron del cocido, lanzaron un grito, exclamando: '¡La olla está envenenada, hombre de Dios!'. Y no pudieron comer."
,"41":"Él ordenó: 'Traedme harina'. La echó en la olla, y añadió: 'Sírveles ahora'. Y en la olla no se encontró ya nada malo."
,"42":"Un hombre llegó de Baal Salisá, trayendo al hombre de Dios el pan de las primicias, veinte panes de cebada y espigas nuevas en su alforja. Eliseo ordenó: 'Dalo a las gentes para que coman'."
,"43":"Pero su criado replicó: '¿Cómo voy a poner esto delante de cien hombres?'. Él dijo: 'Dalo a la gente para que coman, pues esto dice el Señor: Comerán, y sobrará'."
,"44":"Se lo sirvió y comieron; y sobró, como había dicho el Señor."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Naamán, general del ejército del rey de Siria, era un hombre tenido en mucho y apreciado por su señor, porque por su medio el Señor había concedido una victoria a Siria. Pero estaba leproso."
,"2":"En una de sus incursiones, los sirios se llevaron de la tierra de Israel a una muchacha que fue a parar al servicio de la mujer de Naamán."
,"3":"Y dijo a su señora: '¡Si mi señor se presentase al profeta que hay en Samaría, él le libraría de su lepra!'."
,"4":"Naamán fue a decir al rey lo que le había dicho la muchacha."
,"5":"Y el rey respondió: 'Está bien, anda y lleva una carta mía al rey de Israel'. Partió Naamán llevando consigo unos trescientos cuarenta kilos de plata, seis mil monedas de oro y diez mudas de vestidos. "
,"6":"Y presentó al rey de Israel la carta que decía: 'Y al presente, cuando te llegue esta carta, sabrás que te envío a mi servidor Naamán, para que lo cures de su lepra'."
,"7":"Cuando el rey de Israel leyó la carta, se rasgó las vestiduras y exclamó: '¿Es que soy yo un dios para dar la muerte y la vida, que este me manda a un hombre para que lo cure de la lepra? Fijaos bien, y veréis que anda buscando pretextos contra mí'."
,"8":"Cuando Eliseo, el hombre de Dios, se enteró de que el rey había rasgado sus vestiduras, le mandó a decir: '¿Por qué has rasgado tus vestiduras? Que venga a mí y sabrá que en Israel hay un profeta'."
,"9":"Naamán fue con sus caballos y su carro y se detuvo ante la puerta de la casa de Eliseo."
,"10":"Pero Eliseo le mandó a decir: 'Anda, báñate siete veces en el Jordán, y tu cuerpo quedará limpio'."
,"11":"Naamán se enfadó y se fue diciendo: 'Yo pensaba que saldría a recibirme, que invocaría el nombre del Señor, su Dios, que me tocaría con su mano y así sanaría de mi lepra."
,"12":"¿No son acaso el Abana y el Farfar, los ríos de Damasco, mejores que todas las aguas de Israel? ¿No me podría bañar en ellos y quedar limpio?'. Dio media vuelta y se fue muy indignado."
,"13":"Pero sus criados se le acercaron y le dijeron: 'Padre nuestro, si el profeta te hubiera mandado una cosa difícil, ¿no la habrías hecho? ¡Cuánto más habiéndote dicho: Lávate y quedarás limpio!'."
,"14":"Entonces bajó, se bañó siete veces en el Jordán, como había dicho el hombre de Dios, y su cuerpo quedó limpio como el de un niño."
,"15":"Acto seguido regresó con toda su comitiva adonde el hombre de Dios, y en pie ante él, dijo: 'Reconozco que no hay otro dios en toda la tierra fuera del Dios de Israel. Y ahora, dígnate recibir un regalo de tu siervo'."
,"16":"Pero Eliseo replicó: '¡Vive el Señor, a cuyo servicio estoy, que no tomaré nada!'. Y por más que insistió para hacérselo aceptar, lo rehusó."
,"17":"Naamán dijo: 'Déjame llevar tierra, la carga de un par de mulas, pues tu siervo no ofrecerá ya holocaustos y sacrificios a otros dioses fuera del Señor."
,"18":"Sólo pido que el Señor me perdone una cosa: cuando entre mi señor en el templo de Rimón y se apoye en mi brazo, para adorar allí, y yo me postre en el templo de Rimón mientras él se postra, que el Señor me lo perdone'."
,"19":"Eliseo le respondió: 'Vete en paz'. Se había alejado Naamán un tanto, "
,"20":"cuando Guejazí, el criado de Eliseo, el hombre de Dios, se dijo: 'Es claro que mi amo ha sido demasiado condescendiente con este sirio Naamán, hasta el punto de no aceptar de su mano lo que le había traído. ¡Vive el Señor, que voy tras él y consigo de él alguna cosa!'."
,"21":"Guejazí fue corriendo detrás de Naamán, y Naamán al ver que corría detrás de él, se bajó del carro y le dijo: '¿Va todo bien?'."
,"22":"Respondió: 'Bien. Mi señor me envía a decirte: Acaban de llegar a mí dos muchachos de la montaña de Efraín, de los discípulos de los profetas. Dales, por favor, setenta kilos de plata y dos mudas de vestidos'."
,"23":"Naamán respondió: 'Tómalo'. Insistió en que lo aceptara, metió la plata y las mudas de vestidos en dos sacos y se los dio a dos criados suyos, que se lo llevaron delante."
,"24":"Y cuando llegaron a la colina, Guejazí tomó los sacos, los escondió en su casa y despidió a los hombres, que se marcharon."
,"25":"Él entró y se presentó a Eliseo. Eliseo le dijo: '¿De dónde vienes?'. Guejazí respondió: 'Tu siervo no ha ido a ninguna parte'."
,"26":"Eliseo le dijo: '¿Es que no iba contigo mi espíritu cuando un hombre se bajó de su carro para saludarte? Ahora que has recibido dinero podrás comprar vestidos, olivares y viñedos, ovejas y bueyes, siervos y siervas;"
,"27":"pero la lepra de Naamán se os pegará a ti y a tu descendencia para siempre'. Y salió de su presencia blanco como la nieve de lepra."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Los discípulos de los profetas dijeron a Eliseo: 'Como ves, el lugar en que vivimos contigo es demasiado estrecho para nosotros."
,"2":"Déjanos ir hasta el Jordán, para tomar cada uno un madero y construirnos una casa'. Eliseo respondió: 'Podéis ir'."
,"3":"Pero uno de ellos dijo: 'Ven tú con nosotros'. Eliseo contestó: 'Iré'."
,"4":"Fue con ellos, llegaron al Jordán y se pusieron a cortar madera."
,"5":"A uno que estaba cortando un tronco se le cayó el hacha al agua; y empezó a gritar: 'Ay, maestro, que era prestada'."
,"6":"El hombre de Dios preguntó: '¿Dónde ha caído?'. El otro le indicó el sitio; él cortó un palo, lo echó allí, y el hacha salió a flote."
,"7":"Eliseo le dijo: 'Agárrala', y el otro alargó la mano y la recogió."
,"8":"El rey de Siria, que estaba en guerra contra Israel, concertó con sus ayudantes lo siguiente: 'Tendamos una emboscada en tal y tal lugar'."
,"9":"Pero el hombre de Dios mandó a decir al rey de Israel: 'No pases por tal lugar, porque los sirios están allí emboscados'."
,"10":"El rey de Israel, pues, mandó gente al lugar que el hombre de Dios le había avisado, y estuvo en guardia no una ni dos veces."
,"11":"Inquietado por este hecho, el rey de Siria llamó a sus ayudantes y les dijo: '¿Decidme quién de los nuestros avisa al rey de Israel?'."
,"12":"Y uno de sus ayudantes respondió: 'Nadie, oh rey, mi señor; Eliseo, el profeta que vive en Samaría, es el que comunica al rey de Israel incluso todo lo que tú dices en tu dormitorio'."
,"13":"El rey ordenó: 'Id y averiguad dónde se encuentra y yo lo mandaré prender'. Alguien le dijo: 'Está en Dotán',"
,"14":"y él envió allá caballos, carros y un fuerte contingente de tropas. Llegaron de noche y cercaron la ciudad."
,"15":"El criado del hombre de Dios se levantó de madrugada y, al salir, vio la tropa que sitiaba la ciudad con caballos y carros. El muchacho dijo a Eliseo: '¡Ay, señor mío!, ¿qué hacemos?'."
,"16":"Y él respondió: 'No temas, pues son más los que están con nosotros que los que están con ellos'."
,"17":"Y Eliseo oró así: 'Señor, ábrele los ojos para que vea'. Y el Señor abrió los ojos del muchacho, el cual vio el monte repleto de caballos y carros de fuego, que rodeaban a Eliseo."
,"18":"Y cuando los sirios bajaban contra él, Eliseo oró al Señor de esta manera: 'Ciega a esa gente'. Y el Señor los dejó ciegos, como había pedido Eliseo."
,"19":"Eliseo les dijo: 'No es éste el camino, ni ésta la ciudad. Seguidme y os guiaré donde está el hombre que buscáis'. Y los llevó a Samaría."
,"20":"Y cuando llegaron a Samaría, Eliseo dijo: 'Señor, ábreles los ojos, para que vean'. El Señor les abrió los ojos, y vieron que estaban en medio de Samaría."
,"21":"El rey de Israel, al verlos, dijo a Eliseo: 'Padre mío, ¿los mato?'."
,"22":"Respondió: 'No los mates. A los que has hecho prisioneros con tu espada y tu arco puedes matarlos; pero a éstos sírveles comida y bebida, para que coman y beban y se vuelvan adonde su señor'."
,"23":"El rey les preparó un gran banquete y, después que comieron y bebieron, los dejó en libertad. Ellos regresaron a su señor; pero en adelante las guerrillas de Siria no volvieron a penetrar en el país de Israel."
,"24":"Después de estos sucesos Ben Hadad, rey de Siria, reunió todo su ejército y fue a sitiar Samaría."
,"25":"El asedio fue tan largo que se originó un hambre muy grande, hasta el punto de que una cabeza de asno llegó a costar ochenta monedas de plata, y un cuarto de puerros, cinco monedas de plata."
,"26":"Pasaba el rey por la muralla, cuando una mujer le gritó: 'Socórreme, ¡oh rey, mi señor!'."
,"27":"Y el rey respondió: 'Si el Señor no te socorre, ¿con qué te voy a socorrer yo? ¿Con el producto de la era o del lagar?'."
,"28":"Y le preguntó: '¿Qué quieres?'. Ella respondió: 'Esta mujer me había dicho: Entrega a tu hijo y nos lo comeremos hoy; el mío nos lo comeremos mañana."
,"29":"Cocimos a mi hijo y nos lo comimos. Al día siguiente le dije: Trae a tu hijo para que nos lo comamos, pero ella escondió a su hijo'."
,"30":"Cuando el rey oyó las palabras de aquella mujer, rasgó sus vestiduras y, como pasaba sobre la muralla, la gente vio que llevaba interiormente el cilicio a raíz de la carne."
,"31":"Luego dijo: 'El Señor me castigue si la cabeza de Eliseo, hijo de Safat, queda hoy sobre sus hombros'."
,"32":"Eliseo estaba sentado en su casa, con los ancianos que le rodeaban, cuando el rey le envió a un mensajero; pero antes de que el mensajero llegase, Eliseo había dicho a los ancianos: '¿Habéis visto cómo este hijo de asesino ha mandado a cortarme la cabeza? Mirad, cuando el mensajero llegue, cerrad la puerta y no le dejéis pasar. ¿No sentís el ruido de los pasos de su señor detrás de él?'."
,"33":"Aún estaba hablando con ellos, cuando el rey bajó adonde él estaba y le dijo: 'Esta desgracia procede del Señor. ¿Qué más puedo esperar de él?'."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Entonces Eliseo dijo: 'Escuchad la palabra del Señor. Esto dice el Señor: Mañana a estas horas, a la puerta de Samaría, quince kilos de flor de harina se conseguirán por una moneda de plata, y treinta kilos de cebada también por una moneda'."
,"2":"El oficial sobre cuyo brazo solía apoyarse el rey dijo al hombre de Dios: 'Aunque el Señor abriera las ventanas del cielo, ¿podría suceder tal cosa?'. Eliseo respondió: 'Pues bien, tú mismo lo verás con tus propios ojos, pero no comerás de ello'."
,"3":"Cuatro leprosos estaban en la puerta de la ciudad, y se dijeron mutuamente: '¿Qué hacemos aquí esperando la muerte?"
,"4":"Si entramos en la ciudad, moriremos allí de hambre; y si nos quedamos aquí, moriremos también. Pasemos al campamento de los sirios: si nos dejan con vida, viviremos; y si nos matan, moriremos'."
,"5":"Al anochecer se dirigieron al campamento de los sirios, y cuando llegaron al campamento, vieron que no había nadie."
,"6":"El Señor había hecho oír en el campamento de Siria un estrépito de carros de combate y de caballos, estrépito como de un poderoso ejército, y se habían dicho unos a otros: 'El rey de Israel ha contratado a los reyes hititas y a los reyes de Egipto para atacarnos'."
,"7":"Y para salvar sus vidas, se levantaron y se dieron a la fuga al anochecer, abandonando sus tiendas, sus caballos, sus asnos y el campamento, tal como estaba."
,"8":"Los leprosos llegaron hasta el extremo del campamento, entraron en una tienda, comieron y bebieron y se llevaron plata, oro y vestidos, que fueron a esconder. Volvieron de nuevo, entraron en otra tienda, la desvalijaron y fueron a esconder el botín."
,"9":"Pero luego se dijeron el uno al otro: 'No debemos obrar así. Hoy es día de júbilo, y nosotros nos estamos callados. Si esperamos hasta el despuntar el día, incurriremos en un castigo. Vayamos a dar la noticia al palacio real'."
,"10":"Fueron y gritaron a los centinelas de la puerta de la ciudad y les comunicaron la noticia de esta manera: 'Hemos entrado en el campamento de los sirios y allí no hay nadie, ni se oye nada. No se ven más que caballos atados, asnos atados y tiendas intactas'."
,"11":"Los centinelas transmitieron a gritos la noticia al interior del palacio real."
,"12":"El rey se levantó, de noche como era, y dijo a sus oficiales: 'Yo os aclararé lo que han tramado contra nosotros los sirios. Sabiendo que nosotros estamos hambrientos, han salido del campamento para esconderse en el campo, diciendo: Sin duda saldrán de la ciudad, y entonces los coparemos vivos y entraremos en la ciudad'."
,"13":"Un oficial dijo: 'Que vayan cinco hombres en cinco caballos a ver qué pasa. Si quedan con vida, serán como los que quedan aquí; y si mueren, serán como los que ya han muerto'."
,"14":"Tomaron dos carros con los caballos, y el rey los mandó seguir al ejército de los sirios."
,"15":"Fueron tras ellos hasta el Jordán y vieron que todo el camino estaba lleno de vestidos y objetos que habían tirado los sirios en su precipitada huida. Los mensajeros regresaron y comunicaron al rey la noticia."
,"16":"Entonces salió el pueblo y saqueó el campamento de los sirios. Quince kilos de flor de harina, treinta de cebada se llegaron a dar por una moneda de plata, como había dicho el Señor."
,"17":"El rey había confiado la guardia de la puerta a aquel oficial sobre cuyo brazo solía apoyarse; pero el pueblo lo pisoteó en la puerta y murió, como había predicho el hombre de Dios cuando el rey bajó adonde él estaba."
,"18":"En efecto, el hombre de Dios dijo al rey: 'Mañana, a estas horas, en la puerta de Samaría, quince kilos de flor de harina o treinta de cebada valdrán una moneda de plata';"
,"19":"el oficial respondió al hombre de Dios: 'Aunque el Señor abriera las ventanas del cielo, ¿podría suceder tal cosa?'; él había añadido: 'Tú mismo lo verás con tus propios ojos, pero no comerás de ello'."
,"20":"Y así le sucedió. El pueblo lo pisoteó a la puerta y murió."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Eliseo dijo a la mujer cuyo hijo había resucitado: 'Levántate y vete con tu familia a fijar tu residencia dondequiera que sea, porque el Señor ha llamado al hambre, que penetrará en el país durante siete años'."
,"2":"La mujer hizo sin demora lo que el hombre de Dios le había dicho, se fue con su familia y residió como emigrante en el país de los filisteos durante siete años."
,"3":"Al cabo de siete años regresó del país de los filisteos y fue a presentarse ante el rey a reclamar su casa y su campo."
,"4":"El rey estaba entonces charlando con Guejazí, el criado del hombre de Dios, y le decía: 'Cuéntame todos los milagros que ha hecho Eliseo'."
,"5":"Y mientras él contaba al rey cómo había resucitado a un muerto, llegó la mujer a cuyo hijo había resucitado para reclamar ante el rey su casa y su campo. Guejazí dijo: '¡Oh rey, mi señor!, ésta es la mujer y éste es el hijo al que Eliseo resucitó'."
,"6":"Él preguntó a la mujer, y ella se lo contó todo. Y el monarca mandó a un eunuco con esta orden: 'Que le devuelvan todas sus propiedades y el producto de sus campos desde el día que abandonó el país hasta ahora'."
,"7":"Eliseo fue a Damasco. Ben Hadad, rey de Siria, que estaba enfermo, recibió la noticia de que había llegado el hombre de Dios."
,"8":"Entonces dijo a Jazael: 'Toma contigo un presente, vete a ver al hombre de Dios y consulta por su medio al Señor si me curaré de esta enfermedad."
,"9":"Jazael fue a verlo llevando consigo lo mejor de Damasco: una carga de cuarenta camellos. Llegó ante él y dijo: 'Tu hijo, Ben Hadad, rey de Siria, me ha enviado a ti para preguntarte si se curará de la enfermedad'."
,"10":"Eliseo le respondió: 'Anda y dile que se curará de la enfermedad, pero que de todos modos morirá'."
,"11":"Entonces levantó su cabeza, permaneció largo rato en silencio y, al fin, el hombre de Dios se echó a llorar."
,"12":"Jazael le preguntó: '¿Por qué llora mi señor?'. Él respondió: 'Porque sé el mal que has de hacer a los israelitas: pondrás fuego a sus fortalezas, degollarás a espada a sus jóvenes, estrellarás a sus niños de pecho y abrirás en canal a sus embarazadas'."
,"13":"Jazael replicó: '¿Pues qué es tu siervo, este perro, para realizar hazañas tan grandes?'. Y Eliseo respondió: 'El Señor me ha revelado que tú serás el rey de Siria'."
,"14":"Jazael dejó a Eliseo y fue donde su señor, el cual le preguntó: '¿Qué te ha dicho Eliseo?'. Respondió: 'Me ha dicho que te curarás'."
,"15":"Pero al día siguiente Jazael tomó el cobertor, lo empapó de agua y lo extendió sobre el rostro del rey, el cual murió. Jazael le sucedió en el trono."
,"16":"El año quinto de Jorán, hijo de Ajab, rey de Israel, subió al trono Jorán, hijo de Josafat, rey de Judá."
,"17":"Tenía treinta y dos años de edad cuando empezó a reinar, y reinó ocho años en Jerusalén."
,"18":"Siguió la conducta de los reyes de Israel y de la casa de Ajab, pues estaba casado con una hija de este. Hizo lo que es malo a los ojos del Señor."
,"19":"Sin embargo, el Señor no quiso exterminar a Judá, en atención a David, su siervo, conforme a la promesa que le había hecho de conservarle para siempre una lámpara para sus hijos."
,"20":"En su tiempo, Edón se independizó de Judá, y se eligieron un rey."
,"21":"Jorán se abrió paso hasta Seír con todos sus carros. Los edomitas lo cercaron. Una noche él y sus capitanes de los carros de combate atacaron a los edomitas y los derrotaron, pero las tropas huyeron a la desbandada."
,"22":"Edón se independizó de Judá hasta el día de hoy. También entonces se independizó Libná."
,"23":"El resto de la historia de Jorán y todo lo que hizo está escrito en los anales de los reyes de Judá."
,"24":"Jorán murió y fue enterrado con sus padres en la ciudad de David. Le sucedió en el trono su hijo Ocozías."
,"25":"El año doce de Jorán, hijo de Ajab, rey de Israel, subió al trono Ocozías, hijo de Jorán, rey de Judá."
,"26":"Tenía cuarenta y dos años cuando comenzó a reinar, y reinó un año en Jerusalén. Su madre, hija de Omrí, rey de Israel, se llamaba Atalía."
,"27":"Siguió la conducta de la casa de Ajab, haciendo lo que es malo a los ojos del Señor, como la casa de Ajab, con la cual estaba emparentado."
,"28":"Fue con Jorán, hijo de Ajab, a luchar contra Jazael, rey de Siria, en Ramot de Galaad, donde cayó herido Jorán,"
,"29":"que se vio obligado a retirarse a Yezrael para curarse de las heridas recibidas en Ramot cuando luchaba contra Jazael, rey de Siria. Ocozías, hijo de Jorán, rey de Judá, fue a visitar a Jorán, hijo de Ajab, en Yezrael, mientras convalecía."
}`)
	CurrentBook.AddChapter(9, `{
"1":"El profeta Eliseo llamó a uno de los hijos de los profetas y le dijo: 'Prepárate, toma en tu mano esta redoma de aceite y vete a Ramot de Galaad."
,"2":"Cuando llegues, irás a ver a Jehú, hijo de Josafat y nieto de Nimsí; entra, hazle levantar en medio de sus camaradas y llévalo a una estancia más apartada."
,"3":"Entonces tomarás la redoma de aceite y la derramarás sobre su cabeza, diciendo: 'Esto dice el Señor: Yo te unjo por rey de Israel'. Y, al momento, te escapas sin más'."
,"4":"Aquel joven profeta partió para Ramot de Galaad,"
,"5":"y llegó cuando los jefes del ejército estaban reunidos en sesión. Dijo: 'General, tengo que hablar contigo'. Jehú repuso: '¿Con cuál de todos nosotros?'. Respondió: 'Contigo, general'."
,"6":"Jehú se levantó y entró en la casa. Entonces el profeta derramó el aceite sobre su cabeza y le dijo: 'Esto dice el Señor, Dios de Israel: Yo te unjo por rey del pueblo del Señor, de Israel."
,"7":"Exterminarás a la casa de Ajab, tu señor, y yo tomaré venganza en Jezabel de la sangre de mis siervos, los profetas, y de la sangre de todos los siervos del Señor."
,"8":"Toda la casa de Ajab perecerá, porque yo exterminaré de Ajab todo varón, sea libre o esclavo, en Israel."
,"9":"Y haré de la casa de Ajab como de la casa de Jeroboán, hijo de Nabat, o de la casa de Basá, hijo de Ajías."
,"10":"A Jezabel la devorarán los perros en el campo de Yezrael, y no será sepultada'. Y enseguida escapó."
,"11":"Jehú salió adonde estaban los súbditos de su señor, que le preguntaron: '¿Hay novedad? ¿Por qué ha venido a ti ese loco?'. Él les respondió: 'Vosotros ya conocéis a ese individuo y su cantinela'."
,"12":"'¡Mentira! -replicaron-. Dínoslo tú'. Él respondió: 'Me ha hablado de esta y esta manera, y me ha dicho: Yo te unjo por rey de Israel'."
,"13":"Entonces tomaron cada uno su propio manto, los tendieron a sus pies sobre los desnudos escalones, y al son de las trompetas gritaron: '¡Jehú es rey!'."
,"14":"De este modo Jehú, hijo de Nimsí, conspiró contra Jorán. Jorán había defendido Ramot de Galaad, con todo Israel, frente a Jazael, rey de Siria;"
,"15":"pero tuvo que volver a Yezrael a curarse de las heridas que los sirios le habían producido cuando luchaba con Jazael, rey de Siria. Jehú dijo: 'Si estáis de veras conmigo, que nadie escape de la ciudad y vaya a Yezrael a dar la noticia'."
,"16":"Y Jehú montó sobre su carro y se dirigió a Yezrael, donde estaba Jorán convaleciente. Ocozías, rey de Judá, había ido a visitarlo."
,"17":"El centinela que estaba sobre la torre de Yezrael vio venir la tropa de Jehú y dijo: 'Diviso una tropa'. Jorán ordenó: 'Toma un jinete y mándalo a su encuentro, y que pregunte si vienen en son de paz'."
,"18":"El jinete fue a su encuentro y dijo: 'El rey pregunta si venís en son de paz'. Jehú respondió: '¿Qué te importa a ti la paz? Ponte a mi retaguardia'. Y el centinela notificó: 'El emisario ha llegado hasta ellos, pero no vuelve'."
,"19":"Jorán envió entonces un segundo jinete, el cual llegó y les dijo: 'El rey pregunta si venís en son de paz'. Pero Jehú replicó: '¿Qué te importa a ti la paz? Ponte a mi retaguardia'."
,"20":"El centinela notificó de nuevo: 'Ha llegado hasta ellos, y no vuelve. Pero la marcha se parece a la marcha de Jehú, hijo de Nimsí, pues avanza con mucho ímpetu'."
,"21":"Entonces Jorán ordenó: '¡Engancha!'. Le engancharon el carro, y Jorán, rey de Israel, y Ocozías, rey de Judá, salieron cada uno en su propio carro al encuentro de Jehú. Se encontraron con él en la heredad de Nabot, el Yezraelita."
,"22":"Cuando Jorán vio a Jehú, preguntó: '¿Hay paz, Jehú?'. Él replicó: '¿Qué paz ha de haber mientras duren las prostituciones de Jezabel, tu madre, y sus muchas hechicerías?'."
,"23":"Jorán, entonces, volvió las riendas y emprendió la fuga, diciendo a Ocozías: '¡Traición, Ocozías!'."
,"24":"Pero Jehú había echado ya mano a su arco e hirió a Jorán por la espalda, de suerte que la saeta le salió por el corazón, y cayó desplomado en su carro."
,"25":"Jehú dijo a Bidcar, su ayudante: 'Agárralo y tíralo en la heredad de Nabot, el yezraelita, porque me acuerdo que cuando tú y yo cabalgábamos enrolados en el séquito de Ajab, su padre, el Señor fulminó contra él esta sentencia:"
,"26":"¿No he visto ayer la sangre de Nabot y la sangre de sus hijos?,Oráculo del Señor. Pues en esta heredad te daré tu merecido: Oráculo del Señor. Por tanto, agárralo y tíralo a la heredad, conforme a la palabra del Señor'. "
,"27":"Ocozías, rey de Judá, al ver esto, huyó camino de Bet Hagán; pero Jehú lo persiguió, diciendo: '¡También a él!'. Y le hirieron en su carro, en la cuesta de Gur, cerca de Yibleán. Él huyó a Meguido, pero allí murió."
,"28":"Sus servidores lo transportaron en un carro a Jerusalén y lo sepultaron en su sepulcro, con sus padres, en la ciudad de David."
,"29":"Ocozías había subido al trono de Judá el año undécimo de Jorán, hijo de Ajab."
,"30":"Jehú, entretanto, llegó a Yezrael. Cuando Jezabel lo supo, se pintó los ojos, se compuso la cabellera y se asomó a la ventana."
,"31":"Al entrar Jehú por la puerta, ella dijo: '¿Está bien Zimrí, el asesino de su señor?'."
,"32":"Jehú levantó su rostro hacia la ventana y exclamó: '¿Quién está conmigo? ¿Quién?'. Se asomaron dos o tres eunucos,"
,"33":"y él les dijo: 'Tiradla abajo'. La tiraron, y su sangre salpicó la pared y a los caballos, que la pisotearon."
,"34":"Él entró, y después de haber comido y bebido, ordenó: 'Id a ver a esa maldita y sepultadla, porque es hija de reyes'."
,"35":"Fueron a sepultarla, pero no encontraron de ella más que el cráneo, los pies y las manos."
,"36":"Volvieron a comunicárselo a Jehú, el cual dijo: 'Es el oráculo que el Señor pronunció por medio de su siervo Elías, el tesbita, diciendo: En la heredad de Yezrael comerán los perros la carne de Jezabel;"
,"37":"y el cadáver de Jezabel será como estiércol en el campo, en la heredad de Yezrael, de modo que ni siquiera se podrá decir: Ésta es Jezabel'."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Ajab tenía setenta hijos en Samaría, y Jehú escribió cartas y las envió a Samaría a los grandes de la ciudad, a los ancianos y a los tutores de los hijos de Ajab, diciendo:"
,"2":"'Cuando os llegue esta carta, ya que tenéis con vosotros a los hijos de vuestro señor, y puesto que tenéis carros, caballos, una ciudad y armamento,"
,"3":"elegid al mejor y más capaz de los hijos de vuestro señor, colocadlo sobre el trono de su padre y luchad en pro de la casa de vuestro señor'."
,"4":"Pero ellos, llenos de miedo, dijeron: 'Si dos reyes no han podido hacerle frente, ¿cómo lo vamos a hacer nosotros?'."
,"5":"Así que el mayordomo de palacio, los grandes de la ciudad, los ancianos y los tutores mandaron a decir a Jehú: 'Somos tus siervos; haremos lo que nos mandes. A nadie proclamaremos rey; haz lo que quieras'."
,"6":"Entonces les escribió una segunda carta, diciendo: 'Si estáis conmigo y me obedecéis, tomad las cabezas de los hijos de vuestro señor y mañana, a estas horas, venid a mí a Yezrael'. Los setenta hijos del rey estaban con los grandes de la ciudad que los educaban."
,"7":"Pues bien, cuando les llegó la carta se apoderaron de ellos, degollaron a los setenta y, poniendo sus cabezas en cestos, se las enviaron a Yezrael."
,"8":"Vino delante un mensajero a notificar a Jehú: 'Han traído las cabezas de los hijos del rey'. Y él ordenó: 'Ponedlas en dos montones a la entrada de la puerta hasta mañana por la mañana'."
,"9":"Y al día siguiente por la mañana salió y dijo a todo el pueblo: 'Vosotros sois inocentes. Mirad, yo conspiré contra mi señor y le di muerte; pero a todos éstos, ¿quién los ha matado?"
,"10":"Reconoced que de las palabras pronunciadas por el Señor contra la casa de Ajab, por medio de su siervo Elías, ni una sola ha caído por tierra'."
,"11":"Jehú dio muerte también a todos los restantes de la casa de Ajab que había en Yezrael, a todos sus magnates, allegados y sacerdotes, hasta no dejar un superviviente."
,"12":"Luego se dirigió a Samaría. En el camino, al pasar por Betacad de los pastores,"
,"13":"se encontró con los hermanos de Ocozías, rey de Judá, y preguntó: '¿Quiénes sois vosotros?'. Ellos respondieron: 'Somos hermanos de Ocozías y vamos a saludar a los hijos del rey y de la reina'."
,"14":"Entonces él ordenó: 'Prendedlos vivos'. Los prendieron vivos y los degollaron en la cisterna de Bet Equed. Eran cuarenta y dos hombres, y no quedó de ellos ni uno solo."
,"15":"Jehú partió de allí y se encontró con Jonadab, hijo de Recab, que le salía al encuentro. Le saludó y le dijo: '¿Eres sincero conmigo como yo lo soy contigo?'. Jonadab respondió: 'Sí'. Entonces Jehú dijo: 'Si es así, dame la mano'. Le dio la mano y le hizo subir consigo al carro,"
,"16":"diciendo: 'Ven conmigo y verás mi celo por el Señor'. Y le llevó en su carro."
,"17":"Llegó a Samaría y dio muerte a cuantos quedaban allí de la casa de Ajab, hasta que los exterminó, como el Señor había dicho a Elías."
,"18":"Jehú congregó a todo el pueblo y les dijo: 'Ajab rindió poco culto a Baal; Jehú le rendirá mucho más."
,"19":"Pues bien, convocad ante mí a todos los profetas de Baal, a todos sus sacerdotes y a todos sus adoradores. Que nadie falte, porque tengo que ofrecer un sacrificio solemne a Baal. Todo el que falte morirá'. Jehú obraba así con astucia para hacer perecer a todos los adoradores de Baal."
,"20":"Y ordenó: 'Promulgad una fiesta en honor de Baal'. Y, en efecto, fue anunciada."
,"21":"Jehú envió emisarios por todo Israel, y todos los adoradores de Baal se presentaron; ni uno solo dejó de venir; y entraron en el templo de Baal, que quedó lleno de punta a cabo."
,"22":"Jehú dijo entonces al prefecto del vestuario: 'Saca vestiduras para todos los adoradores de Baal'. Y él les sacó las vestiduras."
,"23":"Jehú y Jonadab, hijo de Recab, entraron en el templo de Baal; Jehú ordenó a los adoradores de Baal: 'Registrad y mirad para que no haya aquí con vosotros ninguno de los adoradores del Señor, sino únicamente adoradores de Baal'."
,"24":"Entraron a ofrecer sacrificios y holocaustos, y Jehú apostó fuera cincuenta hombres, con esta orden: 'El que deje escapar a alguno de estos hombres que yo os pongo en las manos responderá con su vida de la vida de aquél'."
,"25":"Y cuando el holocausto estuvo terminado, Jehú ordenó a la escolta y a los oficiales: '¡Entrad, matadlos! Que no escape ni uno'. Y los pasaron a espada, y llegaron hasta el lugar más santo del templo de Baal."
,"26":"Sacaron fuera los cipos sagrados, y los quemaron;"
,"27":"destruyeron también la estatua de Baal y demolieron su templo, convirtiéndolo en un muladar hasta nuestros días."
,"28":"Así extirpó Jehú a Baal de Israel."
,"29":"Sin embargo, Jehú no se apartó de los pecados de Jeroboán, hijo de Nabat, el que hizo pecar a Israel; esto es, los becerros de oro, que había en Betel y en Dan."
,"30":"El Señor dijo a Jehú: 'Por haber obrado bien, haciendo lo que es recto a mis ojos al ejecutar con la casa de Ajab todo lo que yo había dispuesto, tus hijos se sentarán en el trono de Israel hasta la cuarta generación'."
,"31":"Pero Jehú no se cuidó de seguir la ley del Señor, Dios de Israel, con todo su corazón, y no se apartó del pecado de Jeroboán, el que hizo pecar a Israel."
,"32":"En aquel tiempo el Señor comenzó a desmembrar a Israel; y Jazael derrotó a los israelitas en todas las fronteras,"
,"33":"quitándoles, al oriente del Jordán, todo el país de Galaad, esto es, el territorio de los gaditas, rubenitas y manasitas, desde Aroer, junto al torrente Arnón, hasta Galaad y Basán."
,"34":"El resto de la historia de Jehú, sus proezas y todo lo que hizo está escrito en el libro de los anales de los reyes de Israel."
,"35":"Jehú murió y fue sepultado en Samaría. Le sucedió en el trono su hijo Joacaz."
,"36":"Jehú reinó sobre Israel en Samaría veintiocho años."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Cuando Atalía, madre de Ocozías, vio que su hijo había muerto, fue y exterminó a toda la familia real."
,"2":"Pero, cuando estaban matando a los hijos del rey, Josebá, hija del rey Jorán y hermana del rey Ocozías, tomó a Joás, hijo de Ocozías, y lo escondió con su nodriza en el dormitorio. De esta manera lo libró de Atalía, que no lo mató."
,"3":"Y estuvo escondido con ella seis años en el templo del Señor, mientras Atalía reinaba en el país."
,"4":"El año séptimo Yehoyadá mandó llamar a los jefes de centuria de los carios y de la escolta real y los hizo venir adonde él estaba, al templo del Señor. Hizo con ellos un pacto, y tomándoles juramento en el templo del Señor, les mostró al hijo del rey."
,"5":"Y les ordenó lo siguiente: 'Esto es lo que habéis de hacer: el tercio de vosotros que entra el sábado a hacer la guardia en el palacio real"
,"6":"y el otro tercio que está en la puerta del sur y el tercio que guarda la puerta que está detrás de la escolta real, haréis la guardia del templo por turno;"
,"7":"los otros dos grupos vuestros, es decir, todos los que salen de servicio el sábado, harán la guardia en el templo del Señor junto al rey;"
,"8":"acordonaréis al rey con las armas en la mano, y al que intente penetrar en las filas lo matáis. Acompañaréis al rey a todas partes'."
,"9":"Los jefes de centuria hicieron todo lo que el sacerdote Yehoyadá les mandó; cada uno tomó a sus hombres, los que entraban de servicio el sábado y los que salían, y se presentaron al sacerdote Yehoyadá."
,"10":"El sacerdote entregó a los jefes de centuria las lanzas y los escudos del rey David, que estaban en el templo del Señor."
,"11":"Los de la escolta real se apostaron, cada cual con sus armas en la mano, de sur a norte, entre el altar y el templo, alrededor del rey."
,"12":"Entonces Yehoyadá hizo salir al hijo del rey y le impuso la corona y las insignias, lo proclamó rey y lo ungió. Y todos aplaudieron y gritaron: '¡Viva el rey!'."
,"13":"Cuando Atalía oyó los gritos de la guardia y del pueblo, fue al templo del Señor donde estaban todos."
,"14":"Cuando vio al rey, que estaba de pie sobre el estrado, según el uso, y a los cantores y trompeteros junto a él, y a toda la gente del país, jubilosa y tocando las trompetas, se rasgó las vestiduras y gritó: '¡Traición, traición!'."
,"15":"Pero el sacerdote Yehoyadá ordenó a los jefes de centuria, que mandaban la fuerza: '¡Sacadla de las filas y matad al que la siga!'. Porque el sacerdote había dicho: 'Que no la maten en el templo del Señor'."
,"16":"La echaron y, al pasar por la puerta de las caballerizas en el palacio real, la mataron."
,"17":"Yehoyadá selló un pacto entre el Señor, el rey y el pueblo, por el cual se comprometían a ser el pueblo del Señor."
,"18":"El pueblo entero fue al templo de Baal y lo destruyeron; hicieron pedazos los altares y sus imágenes, mataron delante de los altares a Matán, sacerdote de Baal. Después, el sacerdote Yehoyadá puso guardias en el templo del Señor"
,"19":"y reunió a los jefes de centuria, a los carios, a los de la escolta real y a todo el pueblo. Llevaron al rey del templo del Señor al palacio real, entrando por la puerta de la escolta regia, y el monarca se sentó sobre el trono de los reyes."
,"20":"Todo el pueblo se llenó de júbilo, y la ciudad quedó tranquila, pues Atalía había muerto a espada en el palacio real."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Joás tenía siete años cuando subió al trono."
,"2":"Empezó a reinar el año séptimo de Jehú, y reinó cuarenta años en Jerusalén. Su madre se llamaba Sibía, de Berseba."
,"3":"Y Joás hizo lo que es justo a los ojos del Señor todo el tiempo que le dirigió el sacerdote Yehoyadá."
,"4":"Sin embargo, no desaparecieron las colinas, de modo que el pueblo seguía ofreciendo sacrificios y quemando incienso en ellas."
,"5":"Joás dijo a los sacerdotes: 'Todo el dinero que traigan al templo del Señor: el dinero de cada israelita empadronado, el dinero establecido por el rescate de las personas y todo el dinero que cada uno tenga a bien traer al templo del Señor,"
,"6":"lo recibirán los sacerdotes, cada uno de su conocido, y ellos repararán los desperfectos del templo en cualquier parte que se encuentre algún desperfecto'."
,"7":"Pero para el año veintitrés del rey Joás los sacerdotes no habían aún reparado los desperfectos del templo."
,"8":"Entonces el rey Joás llamó al sacerdote Yehoyadá y a los demás sacerdotes, y les dijo: '¿Por qué no habéis reparado aún los desperfectos del templo? De aquí en adelante no recibiréis más el dinero de vuestros conocidos, sino que lo entregaréis para los desperfectos del templo'."
,"9":"Y los sacerdotes accedieron a no recibir dinero de la gente y a no tener que reparar los desperfectos del templo."
,"10":"Entonces el sacerdote Yehoyadá tomó una caja, hizo un agujero en su tapa y la colocó junto al altar, a la derecha del que entraba en el templo del Señor. Y los sacerdotes que guardaban la puerta echaban allí todo el dinero que traían al templo del Señor."
,"11":"Cuando veían que en la caja había mucho dinero, el secretario real y el sumo sacerdote la vaciaban y contaban el dinero encontrado en el templo del Señor."
,"12":"Y este dinero, una vez pesado, lo entregaban a los capataces encargados de los trabajos del templo del Señor, los cuales lo pasaban a los carpinteros y constructores que trabajaban en el templo del Señor,"
,"13":"a los albañiles y a los canteros, para comprar maderas y piedras talladas con que reparar los desperfectos del templo del Señor, y para todo lo que se gastase en el templo en reparaciones."
,"14":"Pero con el dinero traído al templo del Señor no se hicieron para él copas de plata, cuchillos, aspersorios, trompetas ni instrumento alguno de oro o plata,"
,"15":"sino que se entregaba a los encargados de las obras, para que con él reparasen el templo del Señor."
,"16":"Y no se pedía cuentas a los hombres en cuyas manos se ponía el dinero para darlo a los obreros, porque se portaban con fidelidad."
,"17":"El dinero del sacrificio por la culpa y el dinero del sacrificio por el pecado no se traía al templo del Señor, sino que era para los sacerdotes."
,"18":"Jazael, rey de Siria, fue a atacar a Gat y la conquistó; luego se dispuso a ir contra Jerusalén."
,"19":"Pero Joás, rey de Judá, tomó todas las ofrendas que habían hecho al templo sus antepasados Josafat, Jorán y Ocozías, reyes de Judá, y las que él mismo había hecho, y todo el oro que había en el templo del Señor y en el palacio real, y se lo mandó todo a Jazael, rey de Siria, el cual se retiró de Jerusalén."
,"20":"El resto de la historia de Joás y todo lo que hizo está escrito en el libro de los anales de los reyes de Judá."
,"21":"Sus súbditos se rebelaron, urdieron una conjura y mataron a Joás cuando bajaba por el terraplén."
,"22":"Le asestaron el golpe sus siervos Yozacar, hijo de Simat, y Yehozabad, hijo de Somer, y murió. Fue sepultado con sus antepasados en la ciudad de David. Le sucedió en el trono su hijo Amasías."
}`)
	CurrentBook.AddChapter(13, `{
"1":"El año veintitrés de Joás, hijo de Ocozías, rey de Judá, comenzó a reinar sobre Israel, en Samaría, Joacaz, hijo de Jehú. Reinó diecisiete años."
,"2":"Hizo lo que es malo a los ojos del Señor y cometió los pecados con que Jeroboán, hijo de Nabat, hizo pecar a Israel, y no se apartó de ellos."
,"3":"Por eso la ira del Señor se encendió contra Israel, entregándolos en manos de Jazael, rey de Siria, y de Ben Hadad, hijo de Jazael, todo aquel tiempo."
,"4":"Pero Joacaz oró al Señor, y el Señor le escuchó, porque vio la opresión con que el rey de Siria oprimía a Israel."
,"5":"El Señor dio a Israel un salvador, que los libró del yugo de Siria, y los israelitas vivieron tranquilos en sus casas como antes."
,"6":"Sin embargo, no se apartaron de los pecados de la casa de Jeroboán, el que había hecho pecar a Israel; incluso el cipo sagrado siguió en pie en Samaría."
,"7":"Por eso no dejó a Joacaz otra gente que cincuenta jinetes, diez carros y diez mil infantes, porque el rey de Siria los había destruido y reducido como el polvo de la trilla."
,"8":"El resto de la historia de Joacaz, todo lo que hizo y su valor está escrito en el libro de los anales de los reyes de Israel."
,"9":"Joacaz murió y lo enterraron en Samaría. Le sucedió en el trono su hijo Joás."
,"10":"El año treinta y siete de Joás, rey de Judá, Joás, hijo de Joacaz, comenzó a reinar sobre Israel en Samaría. Reinó dieciséis años."
,"11":"Hizo lo que es malo a los ojos del Señor y no se apartó de los pecados con que Jeroboán, hijo de Nabat, hizo pecar a Israel, sino que caminó por ellos."
,"12":"El resto de la historia de Joás, todo lo que hizo y su valor cuando luchó contra Amasías, rey de Judá, está escrito en el libro de los anales de los reyes de Israel."
,"13":"Joás murió y fue sepultado en Samaría con los reyes de Israel. Le sucedió en el trono Jeroboán."
,"14":"Eliseo estaba enfermo de muerte. Joás, rey de Israel, fue a visitarlo; al verlo, se echó a llorar y decía: '¡Padre mío, padre mío, carro y caballería de Israel!'."
,"15":"Y Eliseo le dijo: 'Toma un arco y flechas'. Joás tomó un arco y flechas."
,"16":"Y Eliseo ordenó al rey de Israel: 'Pon tu mano en el arco'. Él puso su mano, y Eliseo puso la suya sobre las manos del rey."
,"17":"Y añadió: 'Abre la ventana de oriente'. El rey la abrió. Y Eliseo dijo: 'Dispara'. Y él disparó. Eliseo exclamó: '¡Flecha de victoria de parte del Señor! ¡Flecha de victoria sobre Siria! Derrotarás a Siria, en Afec, hasta el exterminio'."
,"18":"Y añadió: 'Toma las flechas'. Y las tomó. Eliseo entonces ordenó al rey de Israel: 'Golpea el suelo'. Lo golpeó tres veces, y se paró."
,"19":"Entonces el hombre de Dios se irritó contra él y dijo: 'Si hubieras golpeado cinco o seis veces, habrías derrotado a Siria hasta exterminarlo; pero ahora lo derrotarás sólo tres veces'."
,"20":"Eliseo murió y fue sepultado. Entrado el año, unas bandas de Moab hicieron correrías en el país;"
,"21":"y sucedió que mientras unos hombres estaban enterrando a un muerto, divisaron una banda, echaron al hombre en el sepulcro de Eliseo y escaparon. Apenas aquel hombre tocó los huesos de Eliseo, revivió y se puso en pie."
,"22":"Y Jazael, rey de Siria, oprimió a los israelitas toda la vida de Joacaz;"
,"23":"pero el Señor tuvo compasión de ellos y, en atención a su pacto con Abrahán, Isaac y Jacob, no quiso destruirlos, y hasta el presente no los ha echado de su presencia."
,"24":"Jazael, rey de Siria, murió y le sucedió en el trono su hijo Ben Hadad."
,"25":"Joás, hijo de Joacaz, quitó a Ben Hadad, hijo de Jazael, las ciudades que éste había arrebatado en la guerra a su padre, Joacaz. Le derrotó tres veces, y así recuperó las ciudades de Israel."
}`)
	CurrentBook.AddChapter(14, `{
"1":"El año segundo de Joás, hijo de Joacaz, rey de Israel, Amasías, hijo de Joás, rey de Judá, empezó a reinar."
,"2":"Tenía veinticinco años cuando subió al trono, y reinó veintinueve años en Jerusalén. Su madre se llamaba Yeoadán, de Jerusalén."
,"3":"Hizo lo que es justo a los ojos del Señor, pero no como David, su padre. Se portó como se había portado su padre, Joás."
,"4":"No obstante, no desaparecieron las colinas, de modo que el pueblo ofrecía todavía sacrificios y quemaba incienso en ellas."
,"5":"Cuando se sintió fuerte en el trono, mató a los siervos que habían asesinado a su padre."
,"6":"Pero no mató a los hijos de los asesinos, conforme a lo escrito en el libro de la ley de Moisés: 'Los padres no morirán por la culpa de los hijos, ni los hijos por culpa de los padres, sino que cada uno morirá por su propio pecado'."
,"7":"Él derrotó a Edón en el valle de la Sal, diez mil hombres en conjunto: tomó por asalto Selá, y le puso por nombre Yocteel, que conserva hasta el presente."
,"8":"Amasías mandó a decir a Joás, hijo de Joacaz y nieto de Jehú, rey de Israel: '¡Ven, que nos veamos las caras!'."
,"9":"Joás, rey de Israel, mandó a decir a Amasías, rey de Judá: 'El cardo del Líbano mandó a decir al cedro del Líbano: Da tu hija por esposa a mi hijo. Pero pasaron las fieras del Líbano y pisotearon el cardo."
,"10":"Como has derrotado a Edón, te has engreído. Goza de tu gloria y quédate en tu casa. ¿Por qué quieres acarrearte la desgracia, para que caigas tú y Judá contigo?'."
,"11":"Pero Amasías no hizo caso, y entonces Joás, rey de Israel, fue y se vieron las caras él y Amasías, rey de Judá, en Bet Semes de Judá."
,"12":"Judá fue derrotado frente a Israel, y cada cual huyó a su casa."
,"13":"Joás, rey de Israel, hizo prisionero en Bet Semes a Amasías, rey de Judá; luego llegó a Jerusalén y abrió en sus murallas una brecha de doscientos metros, desde la puerta de Efraín hasta la puerta del ángulo;"
,"14":"se apoderó de todo el oro y la plata y de todos los utensilios que había en el templo del Señor y en los tesoros del palacio real, tomó rehenes y se volvió a Samaría."
,"15":"El resto de la historia de Joás, lo que hizo y su valor cuando luchó contra Amasías, rey de Judá, está escrito en el libro de los anales de los reyes de Israel."
,"16":"Joás murió y fue sepultado en Samaría con los reyes de Israel. Le sucedió en el trono su hijo Jeroboán."
,"17":"Amasías, hijo de Joás, rey de Judá, vivió todavía quince años después de la muerte de Joás, hijo de Joacaz, rey de Israel."
,"18":"El resto de la historia de Amasías está escrito en el libro de los anales de los reyes de Judá."
,"19":"Tramaron contra él una conjura en Jerusalén, y huyó a Laquis, donde lo persiguieron y lo mataron."
,"20":"Lo transportaron sobre caballos y lo enterraron con sus padres en Jerusalén, la ciudad de David."
,"21":"Entonces todo el pueblo de Judá tomó a Azarías, que tenía dieciséis años, y lo proclamó rey en lugar de su padre Amasías."
,"22":"Él reconstruyó Elat y la devolvió a Judá, después de la muerte de su padre."
,"23":"El año quince de Amasías, hijo de Joás, rey de Judá, Jeroboán, hijo de Joás, rey de Israel, subió al trono en Samaría. Reinó cuarenta y un años."
,"24":"Hizo lo que es malo a los ojos del Señor y no se apartó de todos los pecados con que Jeroboán, hijo de Nabat, había hecho pecar a Israel."
,"25":"Él restableció las fronteras de Israel desde la entrada de Jamat hasta el mar de la Arabá, según el oráculo del Señor, Dios de Israel, pronunciado por medio de su siervo, el profeta Jonás, hijo de Amitay, que era de Gat Jéfer."
,"26":"Porque el Señor vio la amarguísima aflicción de Israel, que no quedaba ya esclavo ni libre y que no había quien socorriera a Israel."
,"27":"Y como el Señor no había decretado borrar el nombre de Israel de debajo del cielo, le salvó por medio de Jeroboán, hijo de Joás."
,"28":"El resto de la historia de Jeroboán, todo lo que hizo, el valor con que luchó contra Damasco y restituyó Jamat a Israel, está escrito en el libro de los anales de los reyes de Israel."
,"29":"Jeroboán murió y fue sepultado con los reyes de Israel. Le sucedió en el trono su hijo Zacarías."
}`)
	CurrentBook.AddChapter(15, `{
"1":"El año veintisiete de Jeroboán, rey de Israel, subió al trono Azarías, hijo de Amasías, rey de Judá."
,"2":"Tenía dieciséis años cuando comenzó a reinar, y reinó cincuenta y dos años en Jerusalén. Su madre se llamaba Yecolía, de Jerusalén."
,"3":"Hizo lo que es recto a los ojos del Señor, como había hecho su padre Amasías."
,"4":"Sin embargo, no desaparecieron las colinas, de modo que el pueblo ofrecía aún sacrificios y quemaba incienso en ellas."
,"5":"El Señor castigó al rey, que estuvo leproso hasta su muerte; vivió en una casa aislada, mientras su hijo Jotán estaba al frente del palacio del gobierno de la nación."
,"6":"El resto de la historia de Azarías y todo lo que hizo está escrito en el libro de los anales de los reyes de Judá."
,"7":"Azarías murió y fue sepultado con sus padres en la ciudad de David. Le sucedió en el trono su hijo Jotán."
,"8":"El año treinta y ocho de Azarías, rey de Judá, Zacarías, hijo de Jeroboán, comenzó a reinar sobre Israel. Reinó en Samaría seis meses."
,"9":"Hizo lo que es malo a los ojos del Señor, como habían hecho sus antepasados, y no se apartó de los pecados con que Jeroboán, hijo de Nabat, había hecho pecar a Israel."
,"10":"Pero Salún, hijo de Yabés, se conjuró contra él, lo atacó en Yibleán, lo mató y le sucedió en el trono."
,"11":"El resto de la historia de Zacarías está escrito en el libro de los anales de los reyes de Israel."
,"12":"Así se cumplió la palabra que el Señor había dado a Jehú: 'Tus hijos se sentarán en el trono hasta la cuarta generación'. Y así sucedió."
,"13":"Selún, hijo de Yabés, comenzó a reinar el año treinta y ocho de Ozías, rey de Judá, y reinó en Samaría un mes."
,"14":"Pero Menajén, hijo de Gadí, fue de Tirsá a Samaría y derrotó a Salún, hijo de Yabés; le mató y le sucedió en el trono."
,"15":"El resto de la historia de Salún y la conjura que tramó está todo ello escrito en el libro de los anales de los reyes de Israel."
,"16":"Menajén devastó a Tapúaj y todo lo que había en ella y en sus alrededores desde Tirsá, porque no le habían abierto las puertas de la ciudad; además rajó el vientre a todas las embarazadas."
,"17":"El año treinta y nueve de Azarías, rey de Judá, Menajén, hijo de Gadí, empezó a reinar sobre Israel. Reinó diez años en Samaría."
,"18":"Hizo lo que es malo a los ojos del Señor y no se apartó de los pecados con que Jeroboán, hijo de Nabat, hizo pecar a Israel."
,"19":"En su tiempo Pul, rey de Asiria, invadió el país, y Menajén entregó a Pul unos treinta y cuatro mil kilos de plata para que le ayudase a consolidar el poder real en sus manos."
,"20":"Menajén sacó este dinero a los ricos de Israel para darlo al rey de Asiria, a razón de medio kilo de plata cada uno. El rey de Asiria se retiró sin detenerse en el país."
,"21":"El resto de la historia de Menajén y todo lo que hizo está escrito en el libro de los anales de los reyes de Israel."
,"22":"Murió, y le sucedió en el trono su hijo Pecajías."
,"23":"El año cincuenta de Azarías, rey de Judá, comenzó a reinar sobre Israel en Samaría Pecajías, hijo de Menajén. Reinó dos años."
,"24":"Hizo lo que es malo a los ojos del Señor y no se apartó de los pecados con que Jeroboán, hijo de Nabat, hizo pecar a Israel."
,"25":"Pero se conjuró contra él Pécaj, hijo de Romelía, su capitán, que lo mató en Samaría, en la torre del palacio real, junto con Argob y Arié. Tenía consigo cincuenta hombres de Galaad. Lo mató y le sucedió en el trono."
,"26":"El resto de la historia de Pecajías y todo lo que hizo está escrito en el libro de los anales de los reyes de Israel."
,"27":"El año cincuenta y dos de Azarías, rey de Judá, Pécaj, hijo de Romelía, comenzó a reinar sobre Israel. Reinó veinte años en Samaría."
,"28":"Hizo lo que es malo a los ojos del Señor y no se apartó de los pecados con que Jeroboán, hijo de Nabat, hizo pecar a Israel."
,"29":"En tiempo de Pécaj, rey de Israel, TeglatFalasar, rey de Asiria, fue y tomó Iyón, Abel Bet Maacá, Yanóaj, Cades, Jasor, Galaad, Galilea y todo el país de Neftalí, deportando todos sus habitantes a Asiria."
,"30":"Oseas, hijo de Elá, tramó una conjura contra Pécaj, hijo de Romelía, lo hirió, lo mató y le sucedió en el trono el año veinte de Jotán, hijo de Ozías."
,"31":"El resto de la historia de Pécaj y todo lo que hizo está escrito en el libro de los anales de los reyes de Israel."
,"32":"El año segundo de Pécaj, hijo de Romelía, rey de Israel, comenzó a reinar Jotán, hijo de Ozías, rey de Judá."
,"33":"Tenía veinticinco años cuando subió al trono, y reinó dieciséis años en Jerusalén. Su madre, hija de Sadoc, se llamaba Yerusá."
,"34":"Hizo lo que es bueno a los ojos del Señor como su padre, Ozías."
,"35":"Sin embargo, no desaparecieron las colinas, de modo que el pueblo seguía ofreciendo sacrificios y quemando incienso en ellos. Él construyó la puerta superior del templo del Señor."
,"36":"El resto de la historia de Jotán y todo lo que hizo está escrito en el libro de los anales de los reyes de Judá."
,"37":"En aquel tiempo comenzó el Señor a enviar contra Judá a Rasín, rey de Siria, y a Pécaj, hijo de Romelía."
,"38":"Jotán murió y fue sepultado con sus padres en la ciudad de David, su padre. Le sucedió en el trono su hijo Acaz."
}`)
	CurrentBook.AddChapter(16, `{
"1":"El año diecisiete de Pécaj, hijo de Romelía, subió al trono Acaz, hijo de Jotán, rey de Judá."
,"2":"Tenía veinte años cuando subió al trono, y reinó dieciséis años en Jerusalén; no hizo lo que es justo a los ojos del Señor, su Dios, como su padre David,"
,"3":"sino que siguió el camino de los reyes de Israel, y hasta hizo pasar por el fuego a su hijo, según las prácticas horrorosas de las gentes que el Señor había echado de delante de los israelitas."
,"4":"Y ofreció sacrificios y quemó incienso en los altozanos, en las colinas y bajo cualquier árbol frondoso."
,"5":"Rasín, rey de Siria, y Pécaj, hijo de Romelía, rey de Israel, fueron a atacar a Jerusalén, y sitiaron a Acaz; pero no la pudieron tomar."
,"6":"En aquella ocasión, el rey de Edón recuperó Elat para Edón, echando de Elat a los judíos; y los edomitas tomaron Elat, y se establecieron en ella hasta el presente."
,"7":"Acaz había enviado mensajeros a decir de su parte a Teglat-Falasar, rey de Asiria: 'Soy tu siervo y tu hijo. Ven y sálvame de las manos del rey de Siria y del rey de Israel, que se han levantado contra mí."
,"8":"Acaz tomó la plata y el oro que había en el templo del Señor y en los tesoros del palacio real, y lo envió como presente al rey de Asiria."
,"9":"El rey de Asiria lo escuchó, atacó a Damasco y la conquistó; deportó sus habitantes a Quir, y mató a Rasín."
,"10":"El rey Acaz fue a Damasco al encuentro de Teglat-Falasar, rey de Asiria. Al ver el altar que había en Damasco, envió al sacerdote Urías las dimensiones del altar y un plano exacto del mismo."
,"11":"Y el sacerdote Urías construyó el altar, tal y como le había ordenado el rey Acaz desde Damasco, antes de que regresase de Damasco."
,"12":"Cuando el monarca llegó de Damasco y vio el altar, se acercó y"
,"13":"quemó sobre él su holocausto y su ofrenda, derramó su ofrenda de vino y esparció sobre el altar la sangre de sus sacrificios de reconciliación."
,"14":"En cuanto al altar de bronce que estaba ante el Señor, entre el altar nuevo y el templo del Señor, lo retiró de allí y lo puso al lado norte del altar nuevo."
,"15":"Luego el rey Acaz ordenó al sacerdote Urías: 'Sobre el altar grande quemarás el holocausto de la mañana y la ofrenda de la tarde, el holocausto del rey y su ofrenda, el holocausto de toda la gente del país, sus ofrendas de pan y vino; sobre él derramaréis la sangre de los holocaustos y sacrificios. En cuanto al altar de bronce, ya proveeré'."
,"16":"El sacerdote Urías hizo exactamente lo que el rey Acaz le había ordenado."
,"17":"El rey Acaz arrancó también los paneles de las basas, quitó los aguamaniles y la gran pila de encima de los toros de bronce que lo sostenían, y lo asentó sobre un zócalo de piedras."
,"18":"Y para complacer al rey de Asiria quitó del templo del Señor la tribuna del sábado, que se había construido en el templo, y la entrada externa, reservada al rey."
,"19":"El resto de la historia de todo lo que hizo Acaz está escrito en el libro de los anales de los reyes de Judá."
,"20":"Murió y fue sepultado con sus padres en la ciudad de David. Le sucedió en el trono su hijo Ezequías."
}`)
	CurrentBook.AddChapter(17, `{
"1":"El año dieciocho de Acaz, rey de Judá, Oseas, hijo de Elá, comenzó a reinar sobre Israel. Reinó en Samaría nueve años."
,"2":"Hizo lo que es malo a los ojos del Señor, pero no tanto como los reyes de Israel que le habían precedido."
,"3":"Salmanasar, rey de Asiria, lo atacó, y Oseas se hizo su vasallo y le pagó tributo."
,"4":"El rey de Asiria descubrió que Oseas le traicionaba -pues había enviado mensajeros a So, rey de Egipto, y no le pagaba el tributo anual-, por lo que mandó prenderlo y meterlo en la cárcel."
,"5":"El rey de Asiria invadió todo el país, atacó a Samaría y la sitió durante tres años."
,"6":"El año nueve de Oseas, el rey de Asiria se apoderó de Samaría, deportó a Asiria a los israelitas y los instaló en Jalaj, junto al Jabor, río de Gozán, y en las ciudades de Media."
,"7":"Esto sucedió porque los israelitas habían pecado contra el Señor, su Dios, el que los había sacado de Egipto, del poder del Faraón, rey de Egipto, y habían venerado a dioses extranjeros."
,"8":"Habían seguido las costumbres de las gentes que el Señor había echado ante ellos, así como las que los reyes de Israel habían introducido."
,"9":"Los israelitas cometieron acciones horrorosas contra el Señor, su Dios: se edificaron colinas en todas sus localidades; tanto en las torres de vigilancia como en las ciudades amuralladas,"
,"10":"levantaron estelas y cipos sagrados sobre toda colina elevada y bajo cualquier árbol frondoso,"
,"11":"y allí quemaron incienso como las gentes que el Señor había echado ante ellos, y cometieron toda clase de maldades, irritando al Señor,"
,"12":"y adoraron a los ídolos, cosa que el Señor les había prohibido."
,"13":"El Señor había advertido a Israel y a Judá por medio de los profetas y de los videntes: 'Arrepentíos de vuestros malos caminos, guardad mis preceptos y mandamientos y seguid la ley que di a vuestros padres y que os comuniqué por medio de mis siervos, los profetas'."
,"14":"Pero no hicieron caso, tuvieron una cabeza dura, como sus padres, que no confiaron en el Señor, su Dios;"
,"15":"rechazaron sus preceptos, la alianza que había hecho con sus padres y las amonestaciones que les había dirigido, siguieron a ídolos vanos y se hicieron ellos mismos vanos imitando a las gentes circunvecinas, siendo así que el Señor les había ordenado que no obrasen como ellas."
,"16":"Abandonaron todos los preceptos del Señor, su Dios, se hicieron dos becerros de bronce fundido y un cipo sagrado y adoraron a todos los astros del cielo y a Baal."
,"17":"Pasaron a sus hijos y a sus hijas por el fuego, practicaron adivinaciones y encantamientos y se entregaron a hacer todo lo que es malo a los ojos del Señor, provocando así su indignación."
,"18":"Y el Señor se irritó sobremanera contra Israel y lo echó de su presencia. No quedó más que la tribu de Judá."
,"19":"Tampoco Judá observó los mandatos del Señor, su Dios, sino que siguió las costumbres de Israel."
,"20":"Por eso el Señor rechazó a toda la raza de Israel, la humilló y la entregó en manos de saqueadores, hasta que la echó de su presencia."
,"21":"Pues cuando Israel se separó de la casa de David y proclamó rey a Jeroboán, hijo de Nabat, Jeroboán hizo que Israel se apartara del Señor y pecara gravemente."
,"22":"Y los israelitas cometieron siempre el pecado que Jeroboán había cometido, y no se apartaron de él;"
,"23":"hasta que el Señor echó de su presencia a Israel, según lo había predicho por boca de sus siervos los profetas. E Israel fue deportado de su país a Asiria hasta nuestros días."
,"24":"El rey de Asiria trajo gentes de Babilonia, de Cutá, de Avá, de Jamat y de Sefarváyim, y las instaló en las ciudades de Samaría, en lugar de los israelitas; tomaron posesión de Samaría y habitaron en sus ciudades."
,"25":"Como al empezar a residir allí no temían al Señor, el Señor les envió leones, que hacían estragos entre ellos."
,"26":"Entonces dijeron al rey de Asiria: 'Las gentes que trajiste e instalaste en las ciudades de Samaría no conocen el culto del Dios del país, el cual les ha mandado leones que hacen estragos entre ellos por no conocer el culto del Dios del país'."
,"27":"Y el rey de Asiria ordenó: 'Llevad allá uno de los sacerdotes que trajisteis cautivos para que viva con ellos y les enseñe el culto del Dios del país'."
,"28":"Vino uno de los sacerdotes que había sido deportado de Samaría, se estableció en Betel y les enseñaba cómo debían dar culto al Señor."
,"29":"Pero aquellas gentes se hicieron sus dioses, y los colocaron en los santuarios de las colinas que los samaritanos habían construido, cada uno en la ciudad en que vivía."
,"30":"Los de Babilonia hicieron a Sucot Benot; los de Cutá, a Nergal; los de Jamat, a Asima;"
,"31":"los de Avá, a Nibjás y Tartac, y los de Sefarváyim quemaban a sus hijos en el fuego en honor de sus dioses, Adramélec y Anamélec."
,"32":"Daban también culto al Señor. Nombraron sacerdotes de entre ellos mismos para que oficiaran el culto en los santuarios de las colinas."
,"33":"Así que daban culto al Señor y a sus dioses, según los ritos de las naciones de donde habían sido deportados."
,"34":"Todavía hoy siguen sus antiguas costumbres. No veneran al Señor, no obran conforme a sus estatutos y decretos, conforme a la ley y al mandato que prescribió a los hijos de Jacob, a quien puso por nombre Israel."
,"35":"El Señor había hecho con ellos una alianza y les había ordenado: 'No veneraréis a dioses extranjeros, no os postraréis ante ellos, no les serviréis ni les ofreceréis sacrificios;"
,"36":"sólo al Señor, que os sacó de Egipto con gran fuerza y poder, le daréis culto, os postraréis ante él y le ofreceréis sacrificios."
,"37":"Guardaréis fielmente los preceptos y las normas, las leyes y los mandamientos que os escribió. No daréis culto a dioses extranjeros."
,"38":"No olvidaréis la alianza que hice con vosotros y no daréis culto a dioses extranjeros,"
,"39":"sino sólo al Señor, y entonces él os librará de las manos de vuestros enemigos'."
,"40":"Pero ellos no hicieron caso, y siguieron sus antiguas costumbres."
,"41":"Y así aquellas gentes dieron al mismo tiempo culto al Señor y a sus ídolos. Y sus descendientes siguen haciendo hasta el día de hoy lo mismo que ellos."
}`)
	CurrentBook.AddChapter(18, `{
"1":"El año tercero de Oseas, hijo de Elá, rey de Israel, comenzó a reinar Ezequías, hijo de Acaz, rey de Judá."
,"2":"Tenía veinticinco años cuando subió al trono, y reinó veintinueve años en Jerusalén. Su madre se llamaba Abi, y era hija de Zacarías."
,"3":"Hizo lo que es justo a los ojos del Señor, como su padre David."
,"4":"Suprimió las colinas, hizo pedazos las estelas, arrancó los cipos sagrados y machacó la serpiente de bronce que Moisés había hecho (pues hasta entonces los israelitas le quemaban incienso; la llamaban Nejustán)."
,"5":"Puso su confianza en el Señor, Dios de Israel; ni antes ni después hubo un rey como él en Judá."
,"6":"Vivió unido al Señor y no se separó de él, guardando los preceptos que el Señor había ordenado a Moisés."
,"7":"Y el Señor estuvo con él, de modo que en todas sus empresas tuvo éxito; se rebeló contra el rey de Asiria y dejó de estarle sometido."
,"8":"Él fue quien derrotó a los filisteos hasta Gaza y su término, desde las torres de vigilancia hasta las ciudades fortificadas."
,"9":"El año cuarto del rey Ezequías, el séptimo de Oseas, hijo de Elá, rey de Israel, Salmanasar, rey de Asiria, atacó a Samaría y la sitió."
,"10":"Al cabo de tres años la tomó. El año sexto de Ezequías, el noveno de Oseas, rey de Israel, se conquistó Samaría."
,"11":"Y el rey de Asiria deportó a los israelitas a Asiria y los instaló en Jalaj, junto al Jabor, río de Gozán, y en las ciudades de Media,"
,"12":"porque no habían obedecido al Señor, su Dios, habían quebrantado su alianza y no habían cumplido lo que les había ordenado Moisés, siervo del Señor."
,"13":"El año catorce del rey Ezequías, Senaquerib, rey de Asiria, atacó a todas las ciudades fortificadas de Judá y las tomó."
,"14":"Entonces Ezequías, rey de Judá, envió a Laquis una embajada a decir al rey de Asiria: 'He obrado mal. Retírate de aquí y te pagaré el tributo que me impongas'. Y el rey de Asiria impuso a Ezequías, rey de Judá, unos diez mil kilos de plata y mil de oro."
,"15":"Ezequías entregó toda la plata que se encontraba en el templo del Señor y en los tesoros del palacio real."
,"16":"En aquella ocasión Ezequías desguarneció las puertas del santuario del Señor y las columnas que el mismo Ezequías, rey de Judá, había recubierto de oro, y lo entregó al rey de Asiria."
," 17":"El rey de Asiria mandó desde Laquis a un general en jefe, al jefe de los eunucos y al copero mayor, a Jerusalén, al rey Ezequías. Cuando llegaron a Jerusalén, se detuvieron junto al canal de la alberca superior, que está en el camino del campo del Batanero."
,"18":"Llamaron al rey, y se presentaron Eliaquín, hijo de Jelcías, el mayordomo, Sebná, el secretario, y Yoaj, hijo de Asaf, el heraldo."
,"19":"El copero mayor les dijo: 'Decid a Ezequías: Esto dice el gran rey, el rey de Asiria: ¿En qué pones tu confianza?"
,"20":"Piensas que los planes y la fuerza para la guerra son sólo cuestión de boca. ¿En quién has confiado para rebelarte contra mí?"
,"21":"Pones tu confianza en el sostén de esa caña rota, en Egipto, que a quienquiera que se apoye sobre ella se le hincará en la mano y se la traspasará. Así será el Faraón, rey de Egipto, para todos los que confían en él."
,"22":"Y si me decís: Confiamos en el Señor, nuestro Dios, ¿no es aquel cuyas colinas y cuyos altares ha suprimido Ezequías, diciendo a Judá y a Jerusalén: Sólo debéis postraros ante este altar en Jerusalén?"
,"23":"Y ahora acepta una apuesta con mi señor, el rey de Asiria. Yo te daré dos mil caballos, si puedes procurarte jinetes para ellos."
,"24":"No puedes hacer huir al más insignificante de los siervos de mi señor, ¿y esperas conseguir carros y caballos en Egipto?"
,"25":"Por otra parte, ¿es que he ido yo contra este lugar para devastarlo sin el consentimiento del Señor? El Señor me ha dicho: Anda contra esa tierra y destrúyela'."
,"26":"Entonces Eliaquín, hijo de Jelcías, Sebná y Yoaj dijeron al copero mayor: 'Por favor, habla a tus siervos en arameo, pues nosotros lo entendemos; no nos hables en judío a oídos del pueblo que está sobre la muralla'."
,"27":"Pero el copero mayor les respondió: '¿Es que me ha enviado mi señor a decir estas cosas a tu señor y a ti, y no más bien a los hombres que están sobre la muralla, los cuales, igual que vosotros, van a tener que comer sus excrementos y que beber sus orines?'."
,"28":"Y puesto en pie gritó en judío con voz potente: 'Oíd la palabra del rey grande, el rey de Asiria:"
,"29":"Esto dice el rey: Que Ezequías no os engañe, pues no podrá libraros de mi mano,"
,"30":"ni os haga confiar en el Señor, diciendo: El Señor nos librará y no entregará esta ciudad en manos del rey de Asiria."
,"31":"No escuchéis a Ezequías, pues esto dice el rey de Asiria: Haced la paz conmigo y entregaos a mí, y así podrá comer cada uno los frutos de su viña y de su higuera y beber el agua de su cisterna"
,"32":"hasta que yo venga a trasladaros a una tierra como la vuestra, tierra de grano y de mosto, tierra de pan y de viñas, tierra de aceite y de miel. Así viviréis y no moriréis. No hagáis caso de Ezequías, porque os engaña, diciendo: El Señor nos librará."
,"33":"¿Es que han librado los dioses de otras gentes a sus respectivos países de la mano del rey de Asiria?"
,"34":"¿Dónde están los dioses de Jamat y Arpad? ¿Dónde los dioses de Sefarváyim, de Hená y de Avá? ¿Dónde están los dioses de la tierra de Samaría? ¿Es que libraron a Samaría de mi mano?"
,"35":"¿Qué Dios de estos países es el que ha librado su tierra de mi mano, para que el Señor libre a Jerusalén de mi poder?'."
,"36":"Pero el pueblo se estuvo callado y no le respondió palabra, pues ésta era la orden del rey: 'No le respondáis'."
,"37":"Entonces Eliaquín, hijo de Jelcías, el mayordomo, Sebná, el secretario, y Yoaj, hijo de Asaf, el heraldo, se presentaron ante Ezequías, rasgadas sus vestiduras, y le refirieron las palabras del copero mayor."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Cuando el rey Ezequías oyó esto, rasgó sus vestiduras, se cubrió de saco y entró en el templo del Señor."
,"2":"Y mandó a Eliaquín, el mayordomo, a Sebná, el secretario, y a los sacerdotes más ancianos, vestidos de saco, a decir al profeta Isaías, hijo de Amós:"
,"3":"'Esto dice Ezequías: Día de angustia, de castigo y de ultraje es éste, pues los hijos han llegado a punto de nacer, y falta la fuerza para darlos a luz."
,"4":"Esperamos que el Señor, tu Dios, haya oído todas las palabras del copero mayor, el que ha sido enviado por el rey de Asiria, su señor, a insultar al Dios vivo, y le castigue por las palabras que el Señor, tu Dios, ha oído. Haz una oración por el resto que aún queda'."
,"5":"Los servidores del rey Ezequías se presentaron a Isaías,"
,"6":"y éste les respondió: 'Decid a vuestro señor: Esto dice el Señor: No te asustes por las palabras que has oído, con las cuales me han insultado los siervos del rey de Asiria."
,"7":"Voy a infundirle un espíritu tal que, al oír cierta noticia, se volverá a su tierra, y allí le haré morir a espada'."
,"8":"Entretanto el copero mayor regresó y encontró al rey de Asiria asaltando Libná, pues había oído que se había retirado de Laquis."
,"9":"Enterado Senaquerib del rumor de que Tirjaca, rey de Etiopía, había salido a luchar contra él, volvió a mandar mensajeros a Ezequías, diciendo:"
,"10":"'Así debéis hablar a Ezequías, rey de Judá: No te engañe tu Dios, en quien confías, diciéndote que Jerusalén no será entregada en manos del rey de Asiria."
,"11":"Estás enterado de lo que los reyes de Asiria han hecho con todos los países, entregándolos al exterminio, y ¿vas a escapar tú?"
,"12":"¿Los han librado acaso los dioses de aquellos pueblos, que mis padres han destruido, como Gozán, Jarán, Résef y los habitantes de Edén, que estaban en Telasar?"
,"13":"¿Dónde están ahora el rey de Jamat, el de Arpad, de la ciudad de Sefarváyim, de Hená y Avá?'."
,"14":"Ezequías tomo las cartas de manos de los mensajeros, las leyó, fue al templo y, desplegándolas en la presencia del Señor,"
,"15":"oró así ante él: '¡Señor, Dios de Israel, que estás sentado sobre los querubines! Tú solo eres Dios de todos los reinos de la tierra; tú has hecho los cielos y la tierra."
,"16":"Abre, ¡oh Dios!, tu oído y escucha; abre, ¡oh Señor!, tus ojos y mira. Escucha las palabras que Senaquerib ha mandado a decir para ultrajar al Dios vivo."
,"17":"Es cierto, ¡oh Señor!, los reyes de Asiria han desolado los pueblos y sus tierras;"
,"18":"han echado sus dioses al fuego, porque no eran dioses, sino hechura de manos de hombres, leños o piedras; y por eso los han podido destruir."
,"19":"Por tanto, Dios nuestro, sálvanos de sus manos, y sepan todos los reinos de la tierra que tú solo, Señor, eres Dios'."
,"20":"Entonces Isaías, hijo de Amós, mandó a decir a Ezequías: 'Esto dice el Señor, Dios de Israel: La oración que me has dirigido con motivo de Senaquerib, rey de Asiria, la he escuchado."
,"21":"Ésta es la palabra que el Señor ha pronunciado contra él: Te desprecia, se burla de ti,la virgen hija de Sión, detrás de ti menea la cabeza,la hija de Jerusalén."
,"22":"¿A quién has injuriado y ultrajado, o contra quién has alzado la voz?,Has levantado tus ojos al cielo,contra el Santo de Israel."
,"23":"Por boca de tus mensajeros,has injuriado al Señor, diciendo: Con la multitud de mis carros,me he hecho poderoso, he escalado la cima de los montes, las cumbres del Líbano, he cortado sus más altos cedros, lo mejor de sus cipreses, he penetrado en su más elevado lugar, en los más frondosos bosques."
,"24":"Yo he excavado y bebido,las aguas extranjeras, y he secado con la planta de mis pies,todos los ríos de Egipto."
,"25":"¿No estás enterado?,De antiguo lo he preparado, desde tiempos remotos lo tengo decidido; ahora lo llevo a efecto. Así redujiste a montones de escombros,las ciudades fortificadas;"
,"26":"sus habitantes, impotentes, quedaron consternados y confusos, hechos semejantes a la hierba del campo, al verdor del césped, al heno de los tejados,y al grano agostado antes de espigar."
,"27":"Pero sea que te levantes o te sientes, que entres o salgas, yo lo sé."
,"28":"Puesto que te has enfurecido,contra mí y tu insolencia,ha llegado a mis oídos, pondré mi anillo en tus narices,y mi freno en tus labios,y te haré volver por el camino,por el cual has venido."
,"29":"Sírvate esto de señal: este año se comerá lo que brote de la semilla caída, y el año que viene lo que nazca sin sembrar; pero al tercer año sembraréis y cosecharéis, plantaréis viñas y comeréis su fruto."
,"30":"El resto superviviente de la casa de Judá volverá a arraigar por debajo y dará fruto por encima;"
,"31":"porque de Jerusalén saldrá un resto y un grupo superviviente del monte de Sión. El celo del Señor todopoderoso hará esto."
,"32":"Por lo cual, esto dice el Señor,acerca del rey de Asiria: No entrará en esta ciudad, ni lanzará en ella una flecha, no le opondrá escudo, ni construirá contra ella terraplenes."
,"33":"Por el camino que ha venido regresará, y en esta ciudad no entrará. Oráculo del Señor."
,"34":"Yo protegeré a esta ciudad para salvarla,en atención a mí mismo,y a David, mi siervo'."
,"35":"Y aquella misma noche salió el ángel del Señor e hirió en el campamento de Asiria a ciento ochenta y cinco mil; y, al levantarse por la mañana, vieron que todos ellos eran cadáveres."
,"36":"Entonces Senaquerib, rey de Asiria, se retiró, y regresó a Nínive."
,"37":"Y cuando estaba haciendo oración en el templo de su dios Nisroc, sus hijos Adremélec y Saréser lo mataron a espada y huyeron a Ararat. Le sucedió en el trono su hijo Asaradón."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Por aquel tiempo, Ezequías cayó gravemente enfermo; Isaías, hijo de Amós, el profeta, se presentó a él y le dijo: 'Esto dice el Señor: Arregla los asuntos de tu casa, porque vas a morir; no curarás'."
,"2":"Entonces Ezequías se volvió contra la pared y oró al Señor así:"
,"3":"'¡Ay, Señor! Acuérdate de que me he conducido en tu servicio con fidelidad y de todo corazón, y he hecho lo que es justo a tus ojos'. Y Ezequías rompió a llorar amargamente."
,"4":"Aún no había salido Isaías del patio central, cuando el Señor le dijo:"
,"5":"'Vuélvete y di a Ezequías, jefe de mi pueblo: Esto dice el Señor, Dios de tu padre David: He escuchado tu oración y he mirado tus lágrimas. Te voy a devolver la salud. Dentro de tres días podrás ir al templo del Señor."
,"6":"Añadiré a tus días quince años, te libraré a ti y a esta ciudad de las manos del rey de Asiria y protegeré a esta ciudad en atención a mí mismo y a mi siervo David'."
,"7":"E Isaías ordenó: 'Traed un emplasto de higos secos'. Lo trajeron, lo aplicaron a la llaga y el rey se curó."
,"8":"Y Ezequías preguntó a Isaías: '¿Cuál será la señal de que el Señor me curará y podré ir dentro de tres días al templo del Señor?'."
,"9":"Isaías respondió: 'Ésta es la señal de que el Señor cumplirá la palabra que ha dado: ¿Quieres que la sombra adelante diez grados o que retroceda diez grados?'."
,"10":"Ezequías replicó: 'Fácil es a la sombra adelantar diez grados. No; que la sombra vuelva atrás diez grados'."
,"11":"Entonces el profeta Isaías invocó al Señor, el cual hizo retroceder a la sombra los diez grados en el cuadrante de Acaz."
,"12":"Por aquel tiempo, Merodac Baladán, hijo de Baladán, rey de Babilonia, envió cartas y un presente a Ezequías, al saber que se había curado de su enfermedad."
,"13":"Ezequías recibió gran contento y mostró a los enviados todo su tesoro, la plata, el oro, los aromas, los ungüentos preciosos, su armería y todo lo que tenía en sus almacenes; no hubo cosa en su palacio o en sus dominios que no se la mostrase."
,"14":"Pero el profeta Isaías se presentó al rey Ezequías y le dijo: '¿Qué han dicho estos hombres o de dónde han venido a ti?'. Ezequías respondió: 'Han venido de la lejana Babilonia'."
,"15":"'¿Qué han visto en tu casa?', replicó Isaías. Y Ezequías respondió: 'Han visto todo lo que hay; nada ha habido en mis almacenes que no se lo haya enseñado'."
,"16":"Isaías entonces dijo a Ezequías: 'Escucha la palabra del Señor:"
,"17":"Vienen días en que lo que hay en tu casa y lo que tus padres atesoraron hasta el día de hoy será llevado a Babilonia. No quedará nada, dice el Señor."
,"18":"A tus propios hijos los llevarán a Babilonia, para convertirlos en eunucos en la corte del rey'."
,"19":"Y Ezequías respondió a Isaías: 'Justa es la palabra del Señor que has pronunciado'. Pensó: 'Al menos en mis días habrá paz y seguridad'."
,"20":"El resto de la historia de Ezequías, sus hazañas y cómo construyó la alberca y el acueducto para conducir las aguas a la ciudad, está escrito en el libro de los anales de los reyes de Judá."
,"21":"Ezequías murió y le sucedió en el trono Manasés."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Manasés tenía doce años cuando subió al trono, y reinó en Jerusalén cincuenta y cinco. Su madre se llamaba Jefsibá."
,"2":"Hizo lo que es malo a los ojos del Señor, imitando las prácticas horrendas de las gentes que el Señor había echado ante los israelitas."
,"3":"Reconstruyó las colinas que su padre Ezequías había destruido; levantó altares a Baal, y un cipo sagrado, como había hecho Acaz, rey de Israel; adoró a todos los astros del cielo y les rindió culto."
,"4":"Construyó también altares en el templo del Señor, del que el Señor había dicho: 'Pondré en Jerusalén mi nombre'."
,"5":"Y levantó altares a todos los astros del cielo en los dos atrios del templo del Señor."
,"6":"Quemó a su hijo, se dio a la magia y a encantamientos, instituyó nigromantes y adivinos, e hizo tantas cosas malas a los ojos del Señor que provocó su indignación."
,"7":"Y hasta puso la imagen de Aserá en el templo del Señor, del que el Señor había dicho a David y a Salomón, su hijo: 'En este templo y en Jerusalén, elegida por mí entre todas las tribus de Israel, pondré mi nombre para siempre;"
,"8":"y no permitiré de nuevo que los israelitas anden errantes fuera de la tierra que he dado a sus padres, con tal que hagan lo que yo les he ordenado y cumplan la ley que les prescribió mi siervo Moisés'."
,"9":"Pero ellos no hicieron caso, y Manasés los descarrió, induciéndolos a hacer el mal, más aún que las gentes que el Señor había destruido ante los israelitas."
,"10":"Entonces el Señor habló así por medio de sus siervos los profetas:"
,"11":"'Puesto que Manasés, rey de Judá, ha cometido estas monstruosidades, peores que las de los amorreos que le precedieron, y ha hecho pecar a Judá con sus ídolos,"
,"12":"el Señor, Dios de Israel, dice lo siguiente: Voy a acarrear sobre Jerusalén y sobre Judá una desventura tal que zumbarán los oídos de todos los que la oigan."
,"13":"Y extenderé sobre Jerusalén la cuerda de Samaría y la plomada de la casa de Ajab, y fregaré a Jerusalén como se friega un plato, y fregado se vuelve boca abajo."
,"14":"Rechazaré el resto de mi heredad y lo entregaré en manos de sus enemigos, para que sean botín y despojo de sus adversarios;"
,"15":"porque han hecho lo que es malo a mis ojos, y han provocado mi indignación, desde el día que salieron sus padres de Egipto hasta el presente'."
,"16":"Además, Manasés vertió muchísima sangre inocente, hasta anegar Jerusalén de extremo a extremo, aun prescindiendo del pecado que hizo cometer a Judá haciendo lo que es malo a los ojos del Señor."
,"17":"El resto de la historia de Manasés, todo lo que hizo y el pecado que cometió está escrito en el libro de los anales de los reyes de Judá."
,"18":"Manasés murió y fue sepultado en el jardín de su palacio, en el jardín de Uzá. Le sucedió en el trono su hijo Amón."
,"19":"Amón tenía veintidós años cuando subió al trono, y reinó dos años en Jerusalén. Su madre se llamaba Mesulémet, hija de Jarús, de Yotbá."
,"20":"Hizo lo que es malo a los ojos del Señor, como su padre Manasés."
,"21":"Siguió los caminos de su padre y adoró a los ídolos que había adorado su padre."
,"22":"Abandonó al Señor, Dios de sus padres, y no siguió sus caminos."
,"23":"Sus mismos servidores tramaron una conjura contra él y lo asesinaron en su propia casa;"
,"24":"pero el pueblo mató a todos los que se habían conjurado contra el rey Amón y proclamó rey a su hijo Josías."
,"25":"El resto de la historia de Amón, todo lo que hizo, está escrito en el libro de los anales de los reyes de Judá."
,"26":"Fue sepultado en su sepulcro, en el jardín de Uzá. Le sucedió en el trono su hijo Josías."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Josías tenía ocho años cuando subió al trono, y reinó treinta y un años en Jerusalén. Su madre se llamaba Yedidá, hija de Adaya, de Boscat."
,"2":"Hizo lo que es justo a los ojos del Señor y anduvo por los caminos de su padre David, sin apartarse a derecha ni a izquierda."
,"3":"El año dieciocho de su reinado, Josías envió al templo a su secretario Safán, hijo de Asalías y nieto de Mesulán. Le dijo:"
,"4":"'Vete a ver al sumo sacerdote Jelcías y dile que reúna el dinero aportado al templo del Señor, que los guardas de la puerta han recogido del pueblo;"
,"5":"y que se lo den a los encargados de las obras del templo del Señor, para que éstos paguen a los obreros que reparan sus desperfectos:"
,"6":"carpinteros, maestros de obras y albañiles, y para comprar maderas y piedras talladas con que reparar el templo."
,"7":"Pero que no se les pida cuentas del dinero que se les dé, porque se portan fielmente'."
,"8":"Jelcías, el sumo sacerdote, dijo a Safán, el secretario: 'He encontrado el libro de la ley en el templo del Señor'. Jelcías dio el libro a Safán, quien lo leyó."
,"9":"Safán fue inmediatamente a informar al rey: 'Tus siervos han recogido el dinero que había en el templo y se lo han dado a los encargados de las obras'."
,"10":"Después le comunicó la noticia: 'El sacerdote Jelcías me ha dado un libro'. Y Safán lo leyó en presencia del rey."
,"11":"Cuando el rey oyó las palabras del libro de la ley, rasgó sus vestiduras"
,"12":"y ordenó al sacerdote Jelcías, a Ajicán, hijo de Safán, a Acbor, hijo de Miqueas, a Safán, el secretario, y a Asaías, cortesano del rey:"
,"13":"'Id y consultad al Señor por mí, por el pueblo y por todo Judá acerca de las palabras de este libro que se ha encontrado; pues la ira del Señor se ha encendido contra nosotros, porque nuestros padres no hicieron caso de las palabras de este libro que se ha encontrado cumpliendo lo que está escrito en él'."
,"14":"El sacerdote Jelcías, Ajicán, Acbor, Safán y Asaías fueron a ver a la profetisa Juldá, esposa de Salún, hijo de Ticua y nieto de Jarjás, el guardarropa del templo. Juldá vivía en el barrio nuevo de Jerusalén. Le expusieron el caso,"
,"15":"y ella les dijo: 'Esto dice el Señor, Dios de Israel: Decid al hombre que os ha enviado:"
,"16":"Esto dice el Señor: Voy a traer la desgracia sobre este lugar y sobre sus habitantes, es decir, todas las palabras del libro que ha oído el rey de Judá,"
,"17":"por haberme abandonado y haber quemado incienso a dioses extranjeros hasta provocar mi indignación con todas las obras de sus manos; mi cólera se encenderá contra este lugar y no se apagará."
,"18":"Y al rey de Judá, que os ha mandado a consultar al Señor, decidle: Esto dice el Señor, Dios de Israel, respecto a las palabras que has escuchado:"
,"19":"Por haberse conmovido tu corazón y haberte humillado delante del Señor al oír las palabras con que él ha amenazado a este lugar y a sus habitantes, el terror y la maldición, y haber llorado delante de mí, yo también te he escuchado, dice el Señor."
,"20":"Por eso, te concederé morir y ser enterrado en paz, y tus ojos no verán toda la desventura que yo voy a acarrear sobre este lugar'. Los mensajeros llevaron la respuesta al rey."
}`)
	CurrentBook.AddChapter(23, `{
"1":"El rey convocó a todos los ancianos de Judá y de Jerusalén,"
,"2":"fue al templo del Señor con todos los hombres de Judá, los habitantes de Jerusalén, los sacerdotes, los profetas y todo el pueblo, chicos y grandes, y leyó ante ellos todas las palabras del libro de la alianza encontrado en el templo del Señor."
,"3":"Luego, de pie en el estrado, selló ante la presencia del Señor el pacto de seguir al Señor, guardar sus mandatos, sus instrucciones y sus leyes con todo el corazón y con toda el alma, y de cumplir las cláusulas de la alianza escritas en aquel libro. Y todo el pueblo ratificó la alianza."
,"4":"El rey ordenó al sumo sacerdote Jelcías, al sacerdote segundo y a los guardianes de la puerta sacar fuera del templo del Señor todos los utensilios del culto de Baal, de Aserá y de los astros del cielo; los quemó a las afueras de Jerusalén en los campos del Cedrón y llevó sus cenizas a Betel."
,"5":"Luego suprimió los sacerdotes idólatras que los reyes de Judá habían instituido y que habían quemado incienso en las colinas, en las ciudades de Judá y en los aledaños de Jerusalén; suprimió también a los que habían quemado incienso a Baal, al sol, a la luna, a los planetas y todos los astros del cielo."
,"6":"Sacó del templo del Señor la imagen de Aserá, la quemó a las afueras de Jerusalén, junto al torrente Cedrón, y tiró sus cenizas en la fosa común."
,"7":"Demolió la casa de prostitución, contigua al templo del Señor, donde las mujeres tejían mantos para la Aserá."
,"8":"Mandó venir a todos los sacerdotes de las ciudades de Judá, profanó las colinas donde los sacerdotes habían quemado incienso desde Guibeá hasta Berseba y destruyó la colina de los sátiros que había a la entrada de la puerta de Josué, gobernador de la ciudad, la cual se encuentra a la derecha del que entra por la puerta de la ciudad."
,"9":"Pero los sacerdotes de las colinas no iban al altar del Señor en Jerusalén, aunque comían los panes sin levadura con sus hermanos."
,"10":"Además profanó el Tofet en el valle de Ben Hinnón, para que nadie pasase a su hijo o a su hija por el fuego en honor de Moloc."
,"11":"Suprimió los caballos consagrados al sol por los reyes de Judá a la entrada del templo del Señor, cerca del aposento cuidado por el eunuco Natanmélec, en el atrio, y quemó el carro del sol."
,"12":"Destruyó los altares que había sobre el terrado de la estancia superior de Acaz, construidos por los reyes de Judá, y los altares que Manasés había levantado en los dos atrios del templo del Señor; los hizo allí pedazos y arrojó el polvo al torrente Cedrón."
,"13":"Profanó las colinas que había al oriente de Jerusalén y al sur del monte Olivete, y que Salomón, rey de Israel, había edificado a Astarté, ídolo repugnante de Moab, y a Camós, ídolo repugnante de los amonitas."
,"14":"Despedazó las estelas, los cipos sagrados y llenó sus lugares de huesos humanos."
,"15":"Destruyó el altar que había en Betel, y el santuario,que había construido Jeroboán, hijo de Nabat, el que había inducido a Israel a pecar; hizo pedazos sus piedras, reduciéndolas a polvo, y quemó el cipo sagrado. "
,"16":"De regreso, al ver los sepulcros que había en el monte, envió a recoger los huesos de los sepulcros y los quemó en el altar; de este modo profanó, conforme a la palabra del Señor, pronunciada por el hombre de Dios cuando Jeroboán, durante la solemnidad, estaba de pie ante el altar."
,"17":"Luego, volvió su mirada hacia el sepulcro del hombre de Dios que había predicho estas cosas, y dijo: '¿Qué monumento es aquel que diviso?'. Los de la ciudad respondieron: 'Es el sepulcro del hombre de Dios que vino de Judá y predijo las cosas que tú has hecho sobre el altar de Betel'."
,"18":"Y él ordenó: 'Dejadlo; que nadie remueva sus huesos'. Así sus huesos fueron conservados junto con los huesos del profeta oriundo de Samaría."
,"19":"Josías suprimió también todos los santuarios de las colinas que había en las ciudades de Samaría, construidos por los reyes de Israel, irritando al Señor. Hizo con ellos lo mismo que había hecho en Betel."
,"20":"Inmoló sobre los altares a todos los sacerdotes de las colinas que había allí, quemó sobre ellos huesos humanos y luego se volvió a Jerusalén."
,"21":"El rey ordenó a todo el pueblo: 'Celebrad la pascua del Señor, vuestro Dios, conforme está escrito en el libro de la alianza'."
,"22":"En verdad, nunca se había celebrado una pascua como ésta desde el tiempo de los jueces que habían gobenado a Israel, ni en todo el tiempo de los reyes de Israel y de Judá."
,"23":"Sólo en el año dieciocho del rey Josías se celebró en Jerusalén una pascua semejante en honor del Señor."
,"24":"Josías exterminó también a los nigromantes, a los adivinos, los fetiches, los ídolos y todos los ídolos repugnantes que se veían en el país de Judá y en Jerusalén, a fin de llevar a efecto las palabras de la ley escritas en el libro que había encontrado el sacerdote Jelcías en el templo del Señor."
,"25":"Ni antes ni después de Josías hubo un rey que se volviera como él al Señor con todo su corazón, con toda su alma y con toda su fuerza, conforme en todo con la ley de Moisés."
,"26":"Sin embargo, el Señor no depuso su ira contra Judá a causa de todos los ultrajes con que le había irritado Manasés."
,"27":"Y el Señor dijo: 'Apartaré también de mi presencia a Judá, como aparté a Israel; y rechazaré a esta ciudad, Jerusalén, que había elegido, y el templo, del que había dicho: Allí estará mi nombre'."
,"28":"El resto de la historia de Josías y todo lo que hizo está escrito en el libro de los anales de los reyes de Judá."
,"29":"En su tiempo, el Faraón Necó, rey de Egipto, fue en ayuda del rey de Asiria hacia el río Éufrates. El rey Josías le salió al paso, pero el faraón le dio muerte al primer encuentro en Meguido."
,"30":"Sus oficiales llevaron su cadáver en un carro, de Meguido a Jerusalén, y lo enterraron en su sepulcro. El pueblo ungió y proclamó rey en su lugar a su hijo Joacaz."
,"31":"Joacaz tenía veintitrés años cuando subió al trono, y reinó tres meses en Jerusalén. Su madre se llamaba Jamutal, hija de Jeremías, de Libná."
,"32":"Hizo lo que es malo a los ojos del Señor, como lo habían hecho sus antepasados."
,"33":"Pero el Faraón Necó lo encadenó en Ribla, en el país de Jamat, lo destronó de Jerusalén e impuso al país un tributo de tres mil cuatrocientos kilos de plata y treinta y cuatro de oro."
,"34":"Y el Faraón Necó nombró rey a Eliaquín, hijo de Josías, en lugar de su padre Josías, y le cambió el nombre en Joaquín; a Joacaz, lo llevó a Egipto, donde murió."
,"35":"Joaquín entregó la plata y el oro al faraón. Para poder dar al faraón el oro y la plata tuvo que poner un impuesto a todo el país, a cada uno según sus bienes."
,"36":"Joaquín tenía veinticinco años cuando subió al trono, y reinó once años en Jerusalén. Su madre se llamaba Zebida, hija de Pedayas, de Rumá."
,"37":"Hizo lo que es malo a los ojos del Señor, igual que sus antepasados."
}`)
	CurrentBook.AddChapter(24, `{
"1":"En su tiempo, Nabucodonosor, rey de Babilonia, lo atacó, y Joaquín le estuvo sometido durante tres años; pero luego se rebeló contra él."
,"2":"Y el Señor mandó contra él bandas de caldeos, de sirios, moabitas y amonitas; las mandó contra Judá para destruirlo, conforme a la palabra que el Señor había pronunciado por medio de sus siervos los profetas."
,"3":"Esto sucedió contra Judá por mandato del Señor, que quería apartarlo de su presencia a causa de todos los pecados cometidos por Manasés"
,"4":"y de la sangre inocente que él había derramado hasta llenar Jerusalén. El Señor no quiso perdonar."
,"5":"El resto de la historia de Joaquín y todo lo que hizo está escrito en el libro de los anales de los reyes de Judá."
,"6":"Joaquín murió, y le sucedió en el trono su hijo Jeconías."
,"7":"El rey de Egipto no volvió a salir más de su país, porque el rey de Babilonia había conquistado todas sus posesiones desde el torrente de Egipto hasta el río Éufrates."
,"8":"Jeconías tenía dieciocho años cuando subió al trono, y reinó tres meses en Jerusalén. Su madre se llamaba Nejustá, hija de Elnatán, de Jerusalén."
,"9":"Hizo lo que es malo a los ojos del Señor, igual que su padre."
,"10":"En su tiempo las tropas de Nabucodonosor, rey de Babilonia, fueron contra Jerusalén, y la sitiaron."
,"11":"Nabucodonosor mismo, rey de Babilonia, llegó mientras sus tropas sitiaban la ciudad."
,"12":"Entonces Jeconías, rey de Judá, salió al encuentro del rey de Babilonia, él y su madre, sus cortesanos, sus magnates y sus eunucos. Y el rey de Babilonia los capturó al año octavo de su reinado."
,"13":"Sacó de allí, como había dicho el Señor, todos los tesoros del templo del Señor y del palacio real, e hizo pedazos todos los objetos de oro que Salomón, rey de Israel, había fabricado para el santuario del Señor."
,"14":"Deportó a todo Jerusalén, a todos los magnates y poderosos, unos diez mil, y a todos los herreros y cerrajeros. No dejó más que las gentes pobres."
,"15":"Llevó cautivos a Babilonia a Jeconías y a la madre del rey, a sus mujeres, a sus eunucos y a los nobles del país."
,"16":"Se llevó también a todos los ricos, unos siete mil, y a los herreros y cerrajeros, unos mil, todos ellos hombres aptos para la guerra."
,"17":"Y el rey de Babilonia, en lugar de Jeconías, puso por rey a Matanías, su tío, y le cambió el nombre en Sedecías."
,"18":"Sedecías tenía veintiún años cuando subió al trono, y reinó once años en Jerusalén. Su madre se llamaba Jamutal, hija de Jeremías, de Libná."
,"19":"Hizo lo que es malo a los ojos del Señor, igual que Joaquín."
,"20":"Por eso, el Señor montó en cólera contra Jerusalén y contra Judá y los apartó de su presencia. Sedecías se rebeló contra el rey de Babilonia."
}`)
	CurrentBook.AddChapter(25, `{
"1":"El año noveno de su reinado, el día décimo del mes décimo, Nabucodonosor, rey de Babilonia, llegó con todo su ejército contra Jerusalén, y la sitió; y construyeron un muro de asedio alrededor."
,"2":"La ciudad estuvo sitiada hasta el año undécimo del rey Sedecías."
,"3":"Al cuarto mes, el día noveno del mes, la carestía era tan recia en la ciudad que no había pan para el pueblo."
,"4":"Entonces se practicó una brecha en la ciudad, y todos los hombres de armas huyeron de noche por la puerta entre los dos muros que daban al jardín real, mientras los caldeos rodeaban la ciudad, y escaparon hacia la Arabá."
,"5":"Pero el ejército de los caldeos persiguió al rey y lo alcanzó en la llanura de Jericó; todo el ejército lo abandonó y se dispersó."
,"6":"Apresaron al rey, y lo condujeron a Ribla, ante el rey de Babilonia, el cual pronunció contra él la sentencia."
,"7":"Degolló a sus hijos en su presencia, y a él le sacó los ojos y lo llevó encadenado a Babilonia."
,"8":"El mes quinto, el séptimo día del mes -el año diecinueve del rey Nabucodonosor, rey de Babilonia-, Nebuzardán, jefe de la escolta y ministro del rey de Babilonia, llegó a Jerusalén;"
,"9":"incendió el templo del Señor y el palacio real y prendió fuego a todas las casas y palacios de Jerusalén."
,"10":"Todo el ejército de los caldeos, que estaba a las órdenes del jefe de la escolta, demolió las murallas de Jerusalén."
,"11":"Nebuzardán, jefe de la escolta, deportó al resto de la población que quedaba en la ciudad, a los prófugos que se habían pasado al rey de Babilonia y al resto de la plebe."
,"12":"Sólo dejó a los más pobres para el cultivo de los viñedos y los campos."
,"13":"Los caldeos hicieron pedazos las columnas de bronce que había en el templo del Señor, las basas y la pila de bronce, y llevaron el bronce a Babilonia."
,"14":"Tomaron las ollas, las palas, los cuchillos, las cazuelas y todos los instrumentos de cobre con los que se hacía el servicio sagrado."
,"15":"El jefe de la escolta tomó también los incensarios, las copas y demás objetos de oro y plata."
,"16":"No se podía calcular el peso de las dos columnas, de la pila y de las basas, hechas por Salomón para el templo del Señor, todo ello de bronce."
,"17":"La altura de una columna era de nueve metros, y encima había un capitel de bronce cuya altura era de dos metros y medio; alrededor del capitel había una guirnalda con granadas, todo ello de bronce. La segunda columna era igual."
,"18":"El jefe de la escolta apresó al sumo sacerdote Serayas, al sacerdote segundo Sofonías y a los tres guardianes de la puerta,"
,"19":"al eunuco que tenía a su cargo a la gente de la guerra y a cinco hombres de los íntimos del rey que se encontraban en la ciudad, al secretario del general del ejército que alistaba a la gente del país y a sesenta hombres que había en la ciudad."
,"20":"Nebuzardán, jefe de la escolta, los condujo ante el rey de Babilonia, en Ribla."
,"21":"Y el rey de Babilonia los mandó matar en Ribla, en la tierra de Jamat. Así Judá fue deportado lejos de su tierra."
,"22":"Nabucodonosor, rey de Babilonia, puso al frente del pueblo que quedó en Judá a Godolías, hijo de Ajicán, hijo de Safán."
,"23":"Cuando los jefes y el ejército se enteraron de que el rey de Babilonia había hecho gobernador a Godolías, fueron a presentarse a él en Mispá: Ismael, hijo de Netanías; Juan, hijo de Carej; Serayas, hijo de Tanjumet, el netofita; Yezanías, de Maacá, con sus hombres."
,"24":"Godolías les prestó juramento a ellos y a sus hombres, y les dijo: 'No tengáis miedo en servir a los caldeos; volved a vuestro país, servid al rey de Babilonia y gozaréis de bienestar'."
,"25":"Pero el séptimo mes llegó Ismael, hijo de Netanías y nieto de Elisamá, de estirpe real, con diez hombres y mató a Godolías y a los judíos y caldeos que estaban con él en Mispá."
,"26":"Entonces todo el pueblo, chicos y grandes, y los jefes de las milicias se levantaron y huyeron a Egipto, porque tenían miedo a los caldeos."
,"27":"El año treinta y siete de la cautividad de Jeconías, rey de Judá, el duodécimo mes, el día veintisiete del mes, Evil Merodac, rey de Babilonia, el año de su ascensión, indultó a Jeconías, rey de Judá, y lo sacó de la prisión."
,"28":"Le trató benévolamente y le concedió un trono sobre los tronos de los reyes que había en Babilonia."
,"29":"De este modo Jeconías se quitó el traje de preso y comió a la mesa real todos los días de su vida."
,"30":"Su sustento cotidiano le fue suministrado por el rey, día a día, mientras vivió."
}`)

}
func ES_LSB_LoadVH2SChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Después de la muerte de Saúl, David, que había vuelto a derrotar a los amalecitas, estuvo dos días en Sicelag."
,"2":"Al tercer día llegó un hombre del campamento de Saúl, con los vestidos desgarrados y la cabeza cubierta de polvo. Cuando llegó donde estaba David, se postró rostro en tierra."
,"3":"David le preguntó: '¿De dónde vienes?'. Él respondió: 'Vengo escapado del campamento de Israel'."
,"4":"David le preguntó: '¿Qué ha pasado? Infórmame'. Él respondió: 'El pueblo huyó de la batalla y muchos de entre el pueblo cayeron y murieron. Murieron también Saúl y su hijo Jonatán'."
,"5":"David continuó preguntando al muchacho: '¿Cómo sabes que murieron Saúl y su hijo Jonatán?'."
,"6":"El joven respondió: 'Yo me encontraba por casualidad en el monte Gelboé, y vi a Saúl apoyándose sobre su lanza y asediado por carros y caballeros."
,"7":"Volviéndose para atrás, me vio y me llamó. Yo respondí: Aquí me tienes."
,"8":"Me preguntó: ¿Quién eres? Yo respondí: Soy un amalecita."
,"9":"Él me dijo: Acércate a mí, por favor, y mátame; porque estoy en la agonía y no acabo de morir."
,"10":"Me acerqué a él y lo maté, porque sabía que no podría sobrevivir después de su caída. Tomé la corona que llevaba sobre su cabeza y el brazalete que tenía en su brazo y los he traído aquí, mi señor'."
,"11":"Entonces David se rasgó las vestiduras, y todos los que estaban con él hicieron lo mismo."
,"12":"Se lamentaron, lloraron y ayunaron hasta la tarde por Saúl y por su hijo Jonatán, por el pueblo del Señor y por la casa de Israel, porque habían caído bajo la espada."
,"13":"David dijo al joven que le había informado: '¿De dónde eres?'. Él respondió: 'Soy hijo de un refugiado amalecita'."
,"14":"Y David le preguntó: '¿Cómo te has atrevido a extender tu mano para matar al ungido del Señor?'."
,"15":"Entonces David llamó a uno de los jóvenes y le dijo: 'Acércate y mátalo'. Él le dio un golpe y lo mató."
,"16":"David le dijo: '¡Que tu sangre caiga sobre tu cabeza!, porque tu boca ha dado testimonio contra ti, diciendo: Yo he matado al ungido del Señor'."
,"17":"David cantó una elegía sobre Saúl y su hijo Jonatán."
,"18":"Está escrita en el Libro del Justo para que la enseñen a los hijos de Judá. Dijo:"
,"19":"'Tu gloria, Israel, ha perecido sobre tus montes. ¿Cómo han caído los héroes?"
,"20":"No deis la noticia en Gat, no lo publiquéis,por los caminos de Ascalón; que no se alegren las hijas de los filisteos, que no se regocijen,las hijas de los incircuncisos."
,"21":"¡Montes de Gelboé!, no caiga,sobre vosotros ni rocío ni lluvia, campos traidores; porque allí fue abatido,el escudo de los héroes, el escudo de Saúl: no estaba ungido con óleo,"
,"22":"sino con la sangre de los caídos, con la grasa de los valientes. El arco de Jonatán no se retiraba nunca, ni la espada de Saúl volvía vacía."
,"23":"Saúl y Jonatán, tan queridos y amados, no fueron separados ni en la vida,ni en la muerte; más veloces que águilas, más fuertes que leones."
,"24":"Hijas de Israel, llorad sobre Saúl, que os vestía de escarlata,y de lino fino y adornaba con oro,vuestros vestidos."
,"25":"¿Cómo cayeron los héroes en medio,del combate? ¡Jonatán!, en tu muerte he quedado sin consuelo;"
,"26":"estoy angustiado por ti, hermano mío, Jonatán, amigo queridísimo; tu amor era para mí más dulce,que el amor de mujeres."
,"27":"¿Cómo han caído los héroes, cómo han perecido,las armas de combate?'."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Después de esto, David consultó al Señor: '¿Debo ir a una de las ciudades de Judá?'. El Señor le respondió: 'Sí, vete'. David preguntó: '¿Dónde debo ir? Le respondió: 'A Hebrón'."
,"2":"David fue allá con sus dos mujeres, Ajinoán de Yezrael y Abigaíl, la mujer de Nabal del Carmelo."
,"3":"Llevó también a los hombres que estaban con él, cada uno con su familia, y se establecieron en las ciudades de Hebrón."
,"4":"Los hombres de Judá fueron allí y ungieron a David por rey de la casa de Judá. Informaron a David de que las gentes de Yabés Galaad habían dado sepultura a Saúl. "
,"5":"Entonces él envió mensajeros a los de Yabés Galaad para decirles: 'Que el Señor os bendiga por haber cumplido esta obra de misericordia con Saúl, vuestro señor, y por haberle dado sepultura."
,"6":"Que el Señor os trate con misericordia y fidelidad. También yo os pagaré esta buena obra por haberos portado así."
,"7":"Ahora sed valientes y tened ánimo; Saúl, vuestro señor, ha muerto; pero la casa de Judá me ha ungido a mí para ser su rey'."
,"8":"Abner, hijo de Ner, jefe del ejército de Saúl, tomó a Isbaal, hijo de Saúl, le trasladó a Majanayín,"
,"9":"y le constituyó rey sobre Galaad, los aseritas, Yezrael, Efraín, Benjamín y sobre todo Israel."
,"10":"Isbaal, hijo de Saúl, tenía cuarenta años cuando comenzó a reinar sobre Israel, y reinó dos años. Sólo la casa de Judá siguió a David."
,"11":"David reinó en Hebrón sobre la casa de Judá siete años y seis meses."
,"12":"Abner, hijo de Ner, y los oficiales de Isbaal salieron a campaña de Majanayín hacia Gabaón."
,"13":"Joab, hijo de Sarvia, y los oficiales de David salieron también, y se encontraron cerca del estanque de Gabaón. Acamparon unos a un lado del estanque, y otros al otro."
,"14":"Abner dijo a Joab: 'Que salgan unos cuantos jóvenes y luchen en nuestra presencia'. Joab respondió: 'Que salgan'."
,"15":"Salieron, y desfilaron doce de Benjamín por Isbaal, hijo de Saúl, y doce de los de David."
,"16":"Cada uno agarró a su adversario por la cabeza y le clavó la espada en el costado, de suerte que todos cayeron juntos. Por eso se llamó a aquel lugar 'Campo de los costados'; está cerca de Gabaón."
,"17":"Aquel día hubo una batalla muy dura, y Abner y los de Israel fueron vencidos por los partidarios de David."
,"18":"Estaban allí los tres hijos de Sarvia: Joab, Abisay y Asael. Asael era ligero para correr como un corzo del campo."
,"19":"Asael se puso a perseguir a Abner sin desviarse en su persecución ni a la derecha ni a la izquierda."
,"20":"Abner se volvió hacia atrás y dijo: '¿Eres tú Asael?'. Él respondió: 'Sí, soy yo'."
,"21":"Abner le dijo: 'Apártate a la derecha o a la izquierda, agarra a uno de los jóvenes y quítale lo que lleva'. Pero Asael no quiso apartarse de él."
,"22":"Abner volvió a decirle: 'Apártate de mí; ¿por qué me obligas a derribarte a tierra? ¿Cómo podría entonces levantar mis ojos en presencia de Joab, tu hermano?'."
,"23":"Pero él no quiso apartarse, y Abner le golpeó en el vientre con la culata de la lanza, y la lanza le salió por detrás. Cayó allí mismo y murió instantáneamente. Todos los que llegaban al lugar donde Asael había caído y había muerto se detenían."
,"24":"Joab y Abisay se pusieron a perseguir a Abner y, a la puesta del sol, llegaron a Ammá, al este del valle, en el camino del desierto de Gabaón."
,"25":"Los benjaminitas se agruparon en torno a Abner, formaron un solo cuerpo de ejército y se detuvieron en la cumbre de la colina de Ammá."
,"26":"Abner gritó a Joab: '¿Devorará siempre la espada? ¿No sabes que el fin puede ser amargo? ¿A qué esperas para decir al pueblo que deje de perseguir a sus hermanos?'."
,"27":"Joab respondió: 'Vive Dios, que si tú no hubieses hablado, el pueblo no hubiese cesado de perseguir cada uno a su hermano hasta mañana'."
,"28":"Joab hizo sonar la trompeta, y todo el pueblo se detuvo. Dejó de perseguir a Israel y cesó la lucha."
,"29":"Abner y sus hombres marcharon durante toda aquella noche por la Arabá, pasaron el Jordán y, después de caminar toda la mañana, llegaron a Majanayín."
,"30":"Joab cesó de perseguir a Abner y reunió a todo su ejército. Faltaban de entre los seguidores de David diecinueve hombres, además de Asael."
,"31":"Los de David habían matado trescientos sesenta hombres de Benjamín y de Abner."
,"32":"Llevaron a Asael y le sepultaron en el sepulcro de su padre, en Belén. Después Joab y sus hombres caminaron durante toda la noche y, al llegar el día, estaban en Hebrón."
}`)
	CurrentBook.AddChapter(3, `{
"1":"La guerra entre la casa de Saúl y la casa de David fue larga; pero mientras David iba fortaleciéndose, la casa de Saúl se iba debilitando."
,"2":"A David le nacieron hijos en Hebrón. Su primogénito fue Amnón, nacido de Ajinoán de Yezrael;"
,"3":"el segundo, Kilab, de Abigaíl, mujer de Nabal del Carmelo; el tercero, Absalón, hijo de Macá, la hija de Talmay, rey de Guesur;"
,"4":"el cuarto, Adonías, hijo de Jaguit; el quinto, Sefatías, hijo de Abital;"
,"5":"el sexto, Yitreán, nacido de Eglá, mujer de David. Todos estos hijos los tuvo David en Hebrón."
,"6":"Durante la guerra entre la casa de Saúl y la casa de David, Abner se hacía cada vez más fuerte en la casa de Saúl."
,"7":"Saúl había tenido una concubina llamada Rispá, hija de Ayá. Abner la tomó para sí. Isbaal dijo a Abner: '¿Por qué te has unido a la concubina de mi padre?'."
,"8":"Abner se indignó mucho por estas palabras de Isbaal, y le dijo: '¿Soy yo, acaso, una cabeza de perro? Yo he tenido piedad de la casa de Saúl, con sus hermanos y sus amigos, y no te he dejado caer en manos de David; ¿y ahora me recriminas por una mujer?"
,"9":"Que Dios castigue a Abner, si no hago que se cumpla lo que el Señor prometió con juramento a David:"
,"10":"quitar el reino a la casa de Saúl y establecer el trono de David sobre Israel y sobre Judá desde Dan hasta Berseba'."
,"11":"Isbaal no pudo responder palabra a Abner por el miedo que le tenía."
,"12":"Abner envió mensajeros a David para decirle: 'Haz un pacto conmigo, y yo te apoyaré para que todo Israel se ponga de tu parte'."
,"13":"David respondió: 'Bien, yo haré un pacto contigo; pero exijo de ti una sola cosa: no serás admitido ante mí si no me traes a Mical, hija de Saúl, cuando vengas a verme'."
,"14":"David envió mensajeros a Isbaal, hijo de Saúl, para decirle: 'Devuélveme a mi mujer, Mical, que yo adquirí por cien prepucios de filisteos'."
,"15":"Isbaal envió a quitársela a su marido, Paltiel, hijo de Lais."
,"16":"Su marido partió con ella y la siguió llorando hasta Bajurín. Abner le dijo: 'Anda, vuélvete'. Y él se volvió."
,"17":"Abner dijo a los ancianos de Israel: 'Hace tiempo que deseáis tener a David por vuestro rey."
,"18":"Hacedlo así; porque el Señor ha dicho a David: Yo libraré a mi pueblo de la mano de los filisteos y de todos sus enemigos por medio de mi siervo David'."
,"19":"Habló también a Benjamín; después fue a Hebrón a exponer a David todo lo que Israel y toda la casa de Benjamín habían visto con buenos ojos."
,"20":"Fue acompañado de veinte hombres, y David ofreció un banquete a Abner y a los hombres que le acompañaban."
,"21":"Abner dijo a David: 'Me voy a reunir a todo Israel junto a mi señor el rey. Ellos harán un pacto según los deseos de tu corazón'. David despidió a Abner, que se marchó en paz."
,"22":"Los hombres de David y Joab llegaron de una expedición trayendo un gran botín. Abner ya no estaba con David en Hebrón, pues le había despedido y había marchado en paz."
,"23":"Cuando llegaron Joab y todo el ejército que él mandaba, comunicaron a Joab que había venido Abner, hijo de Ner, y que el rey le había despedido y le había dejado ir en paz."
,"24":"Entonces Joab se presentó al rey y le dijo: '¿Qué has hecho? Abner ha venido a verte; ¿por qué le has despedido y le has dejado ir en paz?"
,"25":"¿Es que no conoces tú a Abner, hijo de Ner? Seguro que ha venido para engañarte, para conocer todos tus pasos y para saber lo que haces'."
,"26":"Joab, al salir de estar con David, envió mensajeros en persecución de Abner, que le hicieron volver desde la cisterna de Sirá, sin saberlo David."
,"27":"Cuando Abner volvió a Hebrón, Joab le llevó aparte, al lado de la puerta, como para hablar pacíficamente con él, y allí le hirió mortalmente en el vientre, por la sangre de Asael, su hermano."
,"28":"Cuando David supo lo que había pasado, dijo: 'Yo y mi reino somos inocentes por siempre ante el Señor de la sangre de Abner, hijo de Ner."
,"29":"Que caiga sobre la cabeza de Joab y de toda su familia y que no falte nunca en la casa de Joab quien padezca gonorrea o lepra, hombres que anden con bastón, que caigan bajo la espada o que pasen hambre'."
,"30":"Joab y su hermano Abisay mataron a Abner porque había dado muerte a su hermano Asael en la batalla de Gabaón."
,"31":"David dijo a Joab y a los que estaban con él: 'Rasgad vuestras vestiduras, vestíos de saco y guardad luto por Abner'. Y el rey David iba detrás del féretro."
,"32":"Sepultaron a Abner en Hebrón. El rey lloró en voz alta sobre el sepulcro de Abner, y todo el pueblo lloraba también."
,"33":"El rey cantó esta elegía sobre Abner: '¿Debía morir Abner,como muere un insensato?"
,"34":"Tus manos no estaban atadas, ni tus pies sujetos a los grillos. ¡Has caído como caen los criminales!'. Y todo el pueblo continuó llorando por él."
,"35":"Todo el mundo vino a invitar a David para que comiera algo, pues todavía era de día; pero David hizo este juramento: 'Que Dios me castigue si como pan o cualquier otra cosa antes de ponerse el sol'."
,"36":"El pueblo supo esto y le pareció bien, pues todo lo que hacía el rey le parecía bien al pueblo."
,"37":"Aquel día se convenció todo el pueblo y todo Israel de que no había partido del rey la orden de matar a Abner, hijo de Ner."
,"38":"Y el rey dijo a sus servidores: '¿No os dais cuenta de que hoy ha caído en Israel un príncipe y un gran hombre?"
,"39":"Yo soy débil todavía, aunque haya recibido la unción real, y estos hombres, los hijos de Sarvia, son más fuertes que yo. Que el Señor pague al que hizo el mal según su malicia'."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Cuando Isbaal, hijo de Saúl, supo que Abner había muerto en Hebrón, se quedó sin aliento, y todo Israel quedó consternado."
,"2":"Isbaal, hijo de Saúl, tenía dos hombres, jefes de banda, Baaná y Recab. Eran hijos de Rimón de Beerot, de los hijos de Benjamín, pues también Beerot era considerado de Benjamín."
,"3":"Los de Beerot habían huido a Guitayín y allí están como refugiados hasta hoy."
,"4":"Jonatán, hijo de Saúl, tenía un hijo cojo. Tenía cinco años cuando llegó de Yezrael la noticia sobre Saúl y Jonatán. Su nodriza le tomó para huir con él, pero en la precipitación de la fuga cayó y quedó cojo. Se llamaba Meribaal."
,"5":"Los hijos de Rimón de Beerot, Recab y Baaná, se pusieron en camino y llegaron, a la hora de más calor del día, a casa de Isbaal, que estaba durmiendo la siesta."
,"6":"La portera de la casa, que estaba limpiando el trigo, se había dormido, y Recab y su hermano Baaná"
,"7":"entraron sin ser vistos en la casa donde Isbaal estaba acostado en la cama de su dormitorio. Lo mataron, le cortaron la cabeza y caminaron durante toda la noche por el camino de la Arabá."
,"8":"Llevaron la cabeza de Isbaal a David, a Hebrón, y dijeron al rey: 'Aquí tienes la cabeza de Isbaal, hijo de Saúl, tu enemigo, que buscaba tu ruina. El Señor ha vengado hoy a mi señor, el rey, de Saúl y de su descendencia'."
,"9":"David les respondió: 'Vive el Señor, que ha salvado mi vida de todo peligro,"
,"10":"que si al que me anunció la muerte de Saúl creyendo que me daba una buena noticia, yo lo agarré y lo maté en Sicelag en lugar de darle una recompensa,"
,"11":"¡cuánto más ahora, cuando unos bandidos han matado a un hombre inocente, en su casa, sobre su lecho! ¿No deberé yo pediros cuenta de su sangre y borraros de la tierra?'."
,"12":"David ordenó a sus servidores que los matasen. Les cortaron las manos y los pies y los colgaron cerca de la piscina de Hebrón. Tomaron también la cabeza de Isbaal y la enterraron en el sepulcro de Abner, en Hebrón."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Todas las tribus de Israel fueron a Hebrón a decir a David: 'Mira, somos hueso de tus huesos y carne de tu carne."
,"2":"Ya antes, cuando todavía reinaba Saúl, eras tú el que mandaba el ejército de Israel. El Señor te había dicho: Tú apacentarás a mi pueblo Israel, serás el jefe de mi pueblo Israel'."
,"3":"Todos los ancianos de Israel fueron a Hebrón a ver al rey; el rey David hizo con ellos un pacto ante el Señor, y ungieron a David como rey de Israel."
,"4":"David tenía treinta años cuando subió al trono, y reinó cuarenta años."
,"5":"En Hebrón reinó sobre Judá siete años y seis meses; en Jerusalén reinó treinta y tres años sobre todo Israel y Judá."
,"6":"El rey y sus hombres marcharon sobre Jerusalén contra los jebuseos, que habitaban la región. Éstos dijeron a David: 'No entrarás aquí; los ciegos y los cojos te rechazarán'. Como diciendo: 'David no entrará aquí'."
,"7":"Pero David se apoderó de la fortaleza de Sión, llamada luego la ciudad de David."
,"8":"Aquel día dijo David: 'El que quiera derrotar al jebuseo, que entre por el canal. En cuanto a los cojos y a los ciegos, son enemigos de David'. Por eso se dice: 'Los ciegos y los cojos no entrarán en el templo del Señor'."
,"9":"David se estableció en la fortaleza y la llamó 'Ciudad de David'. Y reconstruyó la ciudad todo alrededor desde el terraplén hacia la periferia."
,"10":"David iba fortaleciéndose de día en día, y el Señor, Dios todopoderoso, estaba con él."
,"11":"Jirán, rey de Tiro, envió mensajeros a David con madera de cedro, albañiles y carpinteros para que le construyeran un palacio."
,"12":"Entonces David comprendió que el Señor confirmaba su realeza y que ensalzaba su reino por amor de su pueblo Israel."
,"13":"David tomó todavía más concubinas y mujeres en Jerusalén, después de haber venido de Hebrón, y le nacieron hijos e hijas."
,"14":"Éstos son los hijos que le nacieron en Jerusalén: Samúa, Sobab, Natán, Salomón,"
,"15":"Yibjar, Elisúa, Néfeg, Yafía,"
,"16":"Elisamá, Elyadá y Elifélet."
,"17":"Cuando los filisteos supieron que David había sido ungido rey de todo Israel, fueron todos en su busca. David se enteró y se metió en la fortaleza."
,"18":"Los filisteos llegaron y se desplegaron por el valle de Refaín."
,"19":"David consultó al Señor: '¿Atacaré a los filisteos? ¿Los pondrás en mis manos?'. El Señor respondió: 'Atácalos, porque los pondré en tus manos'."
,"20":"David fue a Baal Perasín y allí los derrotó. Y dijo: 'El Señor ha dispersado a mis enemigos ante mí como se dispersan las aguas'. Por eso se llamó este lugar Baal Perasín."
,"21":"Los filisteos abandonaron allí a sus dioses, y David y sus hombres los recogieron."
,"22":"Los filisteos volvieron a ocupar el valle de Refaín."
,"23":"David consultó de nuevo al Señor, y el Señor le respondió: 'No los ataques de frente; da un rodeo por detrás y atácalos por el lado de las balsameras."
,"24":"Cuando oigas ruido de pasos por las copas de las balsameras, ataca rápidamente, porque el Señor irá delante de ti para derrotar al ejército de los filisteos'."
,"25":"David hizo como el Señor le había mandado y derrotó a los filisteos desde Gabaón hasta Guézer."
}`)
	CurrentBook.AddChapter(6, `{
"1":"David volvió a reunir a todo lo selecto de Israel: treinta mil hombres."
,"2":"David, con todo el ejército que le acompañaba, se puso en marcha y fue a Baalá de Judá para traer de allí el arca de Dios, que lleva el nombre del Señor todopoderoso que se sienta sobre los querubines."
,"3":"Colocaron el arca de Dios sobre un carro nuevo y la sacaron de la casa de Abinadab, que está en la colina. Uzá y Ajió, hijos de Abinadab, conducían el carro."
,"4":"Uzá estaba al lado del arca de Dios, y Ajió iba delante del arca."
,"5":"David y toda la casa de Israel iban delante del arca cantando y bailando con todas sus fuerzas al son de las cítaras, arpas, tambores, sistros y címbalos."
,"6":"Cuando llegaron a la era de Nacón, Uzá extendió su mano hacia el arca de Dios para sujetarla porque los bueyes habían tropezado."
,"7":"Entonces la ira del Señor se encendió contra Uzá, lo hirió por la falta cometida, y allí mismo murió junto al arca de Dios."
,"8":"David se disgustó mucho porque el Señor había castigado a Uzá, y aquel lugar fue llamado 'Peres Uzá' hasta el día de hoy."
,"9":"Aquel día David tuvo miedo del Señor, y se dijo: '¿Cómo entrará el arca en mi casa?'."
,"10":"Por eso no quiso llevar el arca del Señor a su casa, a la ciudad de David, y la llevó a casa de Obededón de Gat."
,"11":"El arca del Señor estuvo tres meses en casa de Obededón de Gat, y el Señor bendijo a Obededón y a toda su casa."
,"12":"Cuando contaron al rey David que el Señor había bendecido a Obededón y todas sus cosas a causa del arca de Dios, David fue y trasladó el arca de Dios de casa de Obededón a la ciudad de David con gran júbilo."
,"13":"Cuando los que llevaban el arca habían dado seis pasos, se sacrificó un toro y un carnero."
,"14":"David bailaba ante el Señor con todas sus fuerzas; llevaba ceñido un efod de lino."
,"15":"Así David y toda la casa de Israel trasladaron el arca del Señor en medio de aclamaciones y del sonido de trompetas."
,"16":"Cuando el arca del Señor llegó a la ciudad de David, Mical, hija de Saúl, estaba mirando por la ventana y, al ver al rey David saltando y bailando, lo despreció en su corazón."
,"17":"Metieron el arca del Señor y la colocaron en medio de la tienda que David había levantado para ella. David ofreció al Señor holocaustos y sacrificios de reconciliación."
,"18":"Cuando David terminó de ofrecer los holocaustos y los sacrificios de reconciliación, bendijo al pueblo en el nombre del Señor todopoderoso."
,"19":"Y distribuyó a todos los israelitas presentes, hombres y mujeres, una torta de pan a cada uno, un pedazo de carne y un racimo de uvas pasas; luego todo el pueblo se fue cada uno a su casa."
,"20":"Cuando David volvió a su casa para bendecirla, Mical, hija de Saúl, le salió al encuentro y le dijo: '¡Qué bien ha quedado hoy el rey de Israel desnudándose ante la vista de las criadas de sus servidores, como lo haría un hombre cualquiera!'."
,"21":"David respondió a Mical: '¡Yo he bailado delante del Señor! Vive el Señor, que me eligió con preferencia a tu padre y a toda su casa para constituirme jefe de Israel, el pueblo del Señor, que delante del Señor bailaré"
,"22":"y me humillaré todavía más que esto; seré vil a tus ojos, pero ante las criadas de que hablas seré honrado'."
,"23":"Y Mical, hija de Saúl, no tuvo hijos hasta el día de su muerte."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Cuando David se estableció en su palacio y el Señor le dio descanso librándolo de todos sus enemigos de alrededor,"
,"2":"dijo al profeta Natán: 'Mira, yo estoy viviendo en una casa de cedro, mientras que el arca del Señor está bajo una tienda'."
,"3":"Y Natán dijo al rey: 'Haz lo que piensas, porque el Señor está contigo'."
,"4":"Pero aquella misma noche el Señor dijo a Natán:"
,"5":"'Vete y di a mi siervo David: No serás tú el que me construyas una casa para que habite en ella."
,"6":"Yo no he habitado en casa desde el día en que saqué de Egipto a los israelitas hasta hoy, sino que he estado peregrinando en una tienda de campaña."
,"7":"Durante todo el tiempo que anduve errante con los israelitas jamás dije a ninguno de los jueces de Israel, a los que puse para que gobernaran a mi pueblo, que me construyera una casa de cedro."
,"8":"Di a mi siervo David: Esto dice el Señor todopoderoso: Yo te saqué del aprisco, de detrás de las ovejas, para que fueras el jefe de mi pueblo, Israel."
,"9":"He estado contigo en todas tus empresas, he exterminado delante de ti a todos tus enemigos; haré que tu nombre sea como el de los grandes de la tierra."
,"10":"Asignaré un territorio a mi pueblo Israel y en él lo plantaré para que habite en él y no vuelva a ser perturbado, ni los malvados continúen oprimiéndolo como antes,"
,"11":"en el tiempo en que yo constituí a los jueces sobre mi pueblo Israel; yo le daré paz librándolo de todos sus enemigos. Te hago saber, además, que te daré una dinastía; "
,"12":"pues cuando llegues al término de tus días y descanses con tus padres, haré surgir un descendiente tuyo, que saldrá de tus entrañas, y lo confirmaré en el reino."
,"13":"Él me construirá un templo y yo consolidaré su trono para siempre."
,"14":"Yo seré para él un padre y él será para mí un hijo. Si hace mal, yo lo castigaré con varas de hombre y con castigos corrientes entre los hombres."
,"15":"Pero no le retiraré mi favor, como se lo retiré a Saúl, a quien rechacé de mi presencia."
,"16":"Tu casa y tu reino subsistirán por siempre ante mí, y tu trono se afirmará para siempre'."
,"17":"Natán comunicó a David todo lo que había visto y oído."
,"18":"El rey David se presentó ante el Señor y le dijo: '¿Quién soy yo, Señor, y qué es mi casa para que me hayas hecho llegar hasta aquí?"
,"19":"Y aun esto es todavía poco para ti, Señor, y extiendes también tu promesa a la casa de tu siervo para un futuro lejano, para la duración misma de la humanidad."
,"20":"¿Qué más podría decirte David? Tú conoces a tu siervo, Señor."
,"21":"Por amor a tu siervo has hecho todas estas maravillas y las has dado a conocer."
,"22":"Eres grande, Señor; no hay nadie como tú, ni hay Dios fuera de ti, como hemos oído."
,"23":"¿Hay sobre la tierra un pueblo como tu pueblo Israel, al cual Dios mismo vino a rescatarlo para hacerlo su pueblo, para hacerlo famoso, para hacer en su favor terribles y grandes prodigios y expulsar a las naciones y a sus dioses delante de tu pueblo, al que rescataste de Egipto?"
,"24":"Has afirmado a tu pueblo Israel como pueblo tuyo y para siempre, y tú, Señor, te has hecho su Dios."
,"25":"Y ahora, Señor, mantén firme para siempre la promesa que has hecho a tu siervo y a su casa, y haz como has dicho."
,"26":"Que tu nombre sea siempre engrandecido; y que digan: El Señor todopoderoso es Dios de Israel. Y que la casa de tu siervo David sea estable en tu presencia,"
,"27":"ya que tú, Señor todopoderoso, Dios de Israel, has prometido a tu siervo que le edificarás una casa; por eso se ha atrevido a dirigirte esta súplica."
,"28":"Sí, Señor, tú eres Dios, tus palabras son verdad, y has hecho a tu siervo esta gran promesa."
,"29":"Dígnate bendecir la casa de tu siervo para que permanezca siempre en tu presencia. Porque eres tú, Señor, el que has hablado, y con tu bendición la casa de tu siervo será bendita para siempre'."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Después de esto, David derrotó a los filisteos, los sometió y les quitó su hegemonía."
,"2":"Derrotó también a los moabitas, los hizo echarse a tierra y los midió con la cuerda. Condenó a muerte dos medidas de cuerda y dejó con vida una medida completa. Los moabitas quedaron sometidos a David y le pagaron tributo."
,"3":"David venció también a Hadadézer, hijo de Rejob, rey de Sobá, cuando iba a extender su dominio hasta el Éufrates."
,"4":"David le hizo prisioneros a mil setecientos soldados de caballería y veinte mil de infantería. Desjarretó a todos los caballos de tiro, dejando sólo los necesarios para cien carros."
,"5":"Los sirios de Damasco fueron a socorrer a Hadadézer, rey de Sobá, y David mató a veintidós mil sirios."
,"6":"David puso guarniciones en Siria de Damasco, y los sirios le quedaron sometidos y le pagaron tributo. El Señor daba la victoria a David por dondequiera que iba."
,"7":"David se apoderó de los escudos de oro que llevaba la guardia de Hadadézer y los llevó a Jerusalén."
,"8":"En Tébaj y en Berotay, ciudades de Hadadézer, se apoderó también de una gran cantidad de bronce."
,"9":"Cuando Tou, rey de Jamat, supo que David había derrotado a todo el ejército de Hadadézer,"
,"10":"envió a su hijo Hadorán al rey David para saludarlo y felicitarlo por haber atacado y haber vencido a Hadadézer, pues Tou estaba en guerra con Hadadézer. Hadorán llevaba consigo objetos de plata, de oro y de bronce, que"
,"11":"el rey David consagró al Señor, junto con la plata y el oro que ya había consagrado, procedentes de las naciones que él había sometido:"
,"12":"Edón, Moab, los amonitas, los filisteos, Amalec y el botín de Hadadézer, hijo de Rejob, rey de Sobá."
,"13":"David adquirió gran fama y, a su regreso, derrotó en el valle de la Sal a dieciocho mil edomitas."
,"14":"Puso guarniciones en Edón, y los edomitas quedaron sometidos a David. El Señor daba la victoria a David por dondequiera que iba."
,"15":"David reinó sobre todo Israel, y administró rectamente la justicia a todo su pueblo."
,"16":"Joab, hijo de Sarvia, era el jefe de su ejército; Josafat, hijo de Ajilud, era cronista;"
,"17":"Sadoc, hijo de Ajitub, y Abiatar, hijo de Ajimélec, eran sacerdotes, y Seraya, secretario. Benayas, hijo de Yehoyadá, era jefe de los quereteos y peleteos. Los hijos de David eran sacerdotes."
}`)
	CurrentBook.AddChapter(9, `{
"1":"David preguntó: '¿Queda algún superviviente de la casa de Saúl a quien pueda yo favorecer por amor a Jonatán?'."
,"2":"Había un siervo de la casa de Saúl, llamado Sibá. Lo mandaron venir, y el rey le dijo: '¿Tú eres Sibá?'. Él respondió: 'Para servirte'."
,"3":"El rey le preguntó: '¿Queda alguno de la casa de Saúl a quien yo pueda favorecer en nombre de Dios?'. Sibá respondió: 'Todavía queda un hijo de Jonatán, que está lisiado de ambos pies'."
,"4":"El rey le dijo: '¿Dónde está?'. Sibá respondió: 'En casa de Maquir, hijo de Amiel, de Lodabar'."
,"5":"El rey David mandó que lo trajeran de allí."
,"6":"Cuando Meribaal, hijo de Jonatán, hijo de Saúl, llegó junto a David, se postró en tierra. David dijo: '¡Meribaal!'. Y él respondió: 'Aquí tienes a tu siervo'."
,"7":"David le dijo: 'No temas, porque quiero favorecerte por amor a tu padre, Jonatán. Te devolveré las tierras de Saúl, tu abuelo, y comerás siempre a mi mesa'."
,"8":"Él se postró y dijo: '¿Quién es tu siervo para que te fijes en un perro muerto como yo?'."
,"9":"El rey llamó a Sibá, servidor de Saúl, y le dijo: 'Todo lo que pertenecía a Saúl y a su casa se lo doy al hijo de tu señor."
,"10":"Tú trabajarás para él la tierra, tú y tus hijos y tus esclavos; tú harás la recolección, para que la casa de tu señor tenga qué comer; en cuanto a Meribaal, hijo de tu señor, él comerá siempre a mi mesa'. Sibá tenía quince hijos y veinte esclavos."
,"11":"Sibá respondió al rey: 'Tu servidor hará todo lo que el rey, mi señor, ha mandado a su siervo'. Meribaal comía a la mesa del rey, como uno de sus hijos."
,"12":"Meribaal tenía un hijo pequeño que se llamaba Micá. Todos los que vivían en casa de Sibá estaban al servicio de Meribaal."
,"13":"Pero Meribaal vivía en Jerusalén, porque comía siempre a la mesa del rey; era cojo de ambos pies."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Después de esto, murió el rey de los amonitas y le sucedió su hijo Janún."
,"2":"David se dijo: 'Yo trataré con benevolencia a Janún, hijo de Najás, como su padre me trató a mí'. David le envió una embajada de pésame por la muerte de su padre. Pero cuando los servidores de David llegaron a la tierra de Amón,"
,"3":"los jefes amonitas dijeron a Janún: '¿Tú crees que David te envía consoladores con el fin de honrar a tu padre? ¿No los habrá enviado más bien con el fin de explorar, espiar y destruir el país?'."
,"4":"Entonces Janún agarró a los siervos de David, les cortó la mitad de la barba y los vestidos por la mitad, a la altura de las nalgas, y los despachó."
,"5":"Cuando David se enteró, mandó que les saliesen al encuentro, y que les dijesen: 'Quedaos en Jericó hasta que os crezca la barba y luego vendréis'."
,"6":"Los amonitas se dieron cuenta de que se habían hecho odiosos a David, y enviaron mensajeros para contratar como mercenarios a los sirios de Bet Rejob y de Sobá, veinte mil soldados de infantería, del rey de Maacá, mil hombres, y de Tob, doce mil."
,"7":"Cuando David lo supo, mandó a Joab con todo su ejército."
,"8":"Los amonitas salieron y se pusieron en orden de batalla a la entrada de la ciudad, mientras que los sirios de Sobá y de Rejob y los hombres de Tob y de Maacá estaban en el campo."
,"9":"Joab, viendo que tenía dos frentes, uno delante y otro detrás, seleccionó a la flor y nata del ejército de Israel y lo puso en orden de batalla frente a los sirios;"
,"10":"y el resto del ejército, bajo la dirección de su hermano Abisay, lo colocó frente a los amonitas."
,"11":"Y dijo: 'Si los sirios me ganan a mí, tú vendrás en mi ayuda; y si los amonitas te ganan a ti, yo iré en tu ayuda."
,"12":"¡Ánimo!, luchemos valientemente por nuestro pueblo y por las ciudades de nuestro Dios. Que el Señor haga lo que bien le parezca'."
,"13":"Joab con su ejército se lanzó al ataque contra los sirios y éstos huyeron ante él."
,"14":"Los amonitas, al ver huir a los sirios, se dieron también a la fuga ante Abisay y entraron en la ciudad. Entonces Joab volvió de la guerra contra los amonitas y entró en Jerusalén."
,"15":"Los sirios, viendo que habían sido derrotados por Israel, concentraron sus fuerzas."
,"16":"Hadadézer mandó buscar a los sirios del otro lado del Éufrates, y éstos vinieron a Jelán, mandados por Sobac, jefe del ejército de Hadadézer."
,"17":"David, al saberlo, reunió a todo Israel, pasó el Jordán y llegó a Jelán. Los sirios, puestos en orden de batalla, salieron al encuentro de David y lucharon con él."
,"18":"Pero los sirios huyeron ante Israel, y David les mató setecientos caballos de tiro y cuarenta mil hombres; hirió también a Sobac, jefe del ejército, que murió allí mismo."
,"19":"Cuando los reyes aliados de Hadadézer se vieron derrotados por Israel, firmaron la paz con Israel y le quedaron sometidos. Y en adelante los sirios no se atrevieron a volver a ayudar a los amonitas."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Al año siguiente, por el tiempo en que suelen los reyes salir a campaña, David envió a Joab, a sus oficiales y a todo Israel a devastar a los amonitas y a sitiar a Rabá. David se quedó en Jerusalén."
,"2":"Una tarde, después de la siesta, David, paseando por la terraza del palacio, vio a una mujer que estaba bañándose. La mujer era muy bella."
,"3":"David hizo que averiguasen quién era aquella mujer, y le dijeron: 'Es Betsabé, hija de Elián, mujer de Urías, el hitita'."
,"4":"Entonces David mandó que se la trajeran. Ella vino a su casa, y él se acostó con ella; ella acababa de purificarse de su impureza menstrual. Después se volvió a su casa."
,"5":"La mujer quedó encinta y mandó decir a David: 'Estoy encinta'."
,"6":"Entonces David envió este mensaje a Joab: 'Envíame a Urías, el hitita'. Y Joab envió a Urías a David."
,"7":"Cuando Urías llegó donde David, éste le preguntó cómo estaba Joab y el ejército y cómo iba la guerra."
,"8":"Después David dijo a Urías: 'Baja a tu casa y lávate los pies'. Urías salió del palacio y, tras él, le llevaron un obsequio de la mesa real."
,"9":"Urías se acostó a la puerta del palacio con los servidores de su señor y no fue a su casa."
,"10":"Comunicaron a David que Urías no había ido a su casa. Entonces David le preguntó: '¿No acabas de llegar de viaje? ¿Por qué no has bajado a tu casa?'."
,"11":"Urías le respondió: 'El arca, Israel y Judá habitan en tiendas; mi señor Joab y los oficiales de mi señor acampan al aire libre, ¿e iba yo a ir a mi casa para comer, beber y dormir con mi mujer? Por el Señor y por tu vida, que no haré tal cosa'."
,"12":"David dijo a Urías: 'Quédate aquí hoy todavía, y mañana te enviaré'. Urías se quedó en Jerusalén aquel día."
,"13":"Al día siguiente David le invitó a comer y beber con él, y Urías se emborrachó; por la tarde salió a acostarse en su cama con los servidores de su señor, pero no fue a su casa."
,"14":"A la mañana siguiente David escribió una carta a Joab y se la mandó por Urías."
,"15":"Decía en ella: 'Poned a Urías en el punto en que más recia sea la batalla; y después dejadle solo para que sea herido y muera'."
,"16":"Joab, que estaba asediando la ciudad, puso a Urías en el lugar donde sabía que estaban los hombres más valientes."
,"17":"Los hombres de la ciudad hicieron una salida para atacar a Joab; cayeron muchos del ejército y de los servidores de David y murió también Urías, el hitita."
,"18":"Joab mandó informar a David sobre todos los detalles del combate."
,"19":"Al mensajero le dio esta orden: 'Cuando hayas terminado de contar al rey todos los detalles del combate,"
,"20":"si el rey monta en cólera y te dice: ¿Por qué os habéis acercado tanto a la ciudad para atacarla? ¿No sabíais que tiran desde lo alto de los muros?"
,"21":"¿Quién mató a Abimélec, hijo de Yerubaal? ¿No fue una mujer, que tiró sobre él desde lo alto de los muros una rueda de molino, y murió en Tebes? ¿Por qué os habéis acercado tanto a las murallas?, tú le dirás: También murió tu siervo Urías, el hitita'."
,"22":"El mensajero partió, se presentó a David y le comunicó todo lo que Joab le había ordenado. Entonces David montó en cólera contra Joab y dijo al mensajero: '¿Por qué os habéis acercado tanto a la ciudad para atacarla? ¿No sabíais que tiran desde lo alto de los muros? ¿Quién mató a Abimélec, hijo de Yerubaal? ¿No fue una mujer que tiró sobre él desde lo alto de los muros una rueda de molino y murió en Tebes? ¿Por qué os habéis acercado tanto a las murallas?'."
,"23":"El mensajero respondió a David: 'Aquellos hombres tuvieron ventaja sobre nosotros; hicieron una salida contra nosotros al campo, y nosotros los rechazamos hasta la entrada de la puerta;"
,"24":"pero los arqueros tiraron sobre tus siervos desde lo alto de los muros y murieron muchos siervos del rey, y tu siervo Urías, el hitita, murió también'."
,"25":"Entonces David dijo al mensajero: 'Dile a Joab que no se preocupe por este asunto, porque la espada unas veces devora a unos y otras veces a otros; que refuerce ataques contra la ciudad hasta destruirla. Y tú dale ánimo'."
,"26":"Cuando la mujer de Urías supo que su esposo había muerto, le guardó luto."
,"27":"Una vez terminado el luto, David mandó a buscarla, la llevó a su casa y la tomó por mujer. Ella dio a luz un hijo. Pero esto que hizo David desagradó al Señor."
}`)
	CurrentBook.AddChapter(12, `{
"1":"El Señor envió al profeta Natán a ver a David. Se presentó a él y le dijo: 'En la ciudad había dos hombres, uno rico y otro pobre."
,"2":"El rico tenía ovejas y vacas en gran cantidad."
,"3":"El pobre no tenía nada; sólo una corderilla que había comprado. Él la había criado y había crecido con él y con sus hijos; comía de su pan, bebía de su vaso y dormía en su seno. La tenía como una hija."
,"4":"Llegó un huésped a casa del rico, y éste no quiso tomar de sus ovejas ni de sus bueyes para dar de comer al huésped. Robó la corderilla del hombre pobre y se la sirvió a su huésped'."
,"5":"David montó en cólera contra aquel hombre y dijo a Natán: 'Vive el Señor, que el que ha hecho tal cosa es digno de muerte,"
,"6":"y pagará cuatro veces el valor de la corderilla por haber hecho esto y haber obrado sin piedad'."
,"7":"Natán dijo a David: '¡Tú eres ese hombre! Esto dice el Señor, Dios de Israel: Yo te ungí por rey de Israel y te libré de las manos de Saúl;"
,"8":"te he dado la casa de tu señor y puse en tus brazos las mujeres de tu señor, y te he dado la casa de Israel y de Judá, y, por si esto fuera poco, te añadiré todavía más."
,"9":"Entonces, ¿por qué has despreciado al Señor haciendo lo que le desagrada? Mataste con la espada a Urías, el hitita, y tomaste por esposa a su mujer. Tú lo mataste con la espada de los amonitas."
,"10":"Por eso, no se apartará nunca de tu casa la espada, por haberme despreciado y haber tomado por esposa a la mujer de Urías, el hitita."
,"11":"Esto dice el Señor: Yo haré surgir el mal de tu propia casa; tomaré ante tus propios ojos a tus mujeres y se las daré a tu prójimo, que se acostará con tus mujeres a plena luz del sol."
,"12":"Tú lo has hecho en secreto, pero yo lo haré a la vista de todo Israel y a plena luz del sol'."
,"13":"David dijo a Natán: 'He pecado contra el Señor'. Entonces Natán dijo a David: 'El Señor, por su parte, ha perdonado tu pecado. No morirás."
,"14":"Pero como has ofendido al Señor con este asunto, morirá el niño que te ha nacido'. Y Natán se fue a su casa."
,"15":"El Señor hizo que el niño que la mujer de Urías había dado a David enfermara gravemente."
,"16":"David rogó a Dios por el niño: ayunó rigurosamente, se retiró y pasó la noche acostado en el suelo."
,"17":"Los ancianos de la casa le rogaron con insistencia que se levantara del suelo, pero él no quiso, ni tomó alimento alguno con ellos."
,"18":"Al séptimo día murió el niño. Los servidores de David tenían miedo de decírselo, pues pensaban: 'Si, cuando el niño vivía, le hablábamos y no quiso escucharnos, ¿cómo le diremos que el niño ha muerto? Hará un desatino'."
,"19":"David se dio cuenta de que sus servidores cuchicheaban entre sí y comprendió que el niño había muerto. David les preguntó: '¿Ha muerto el niño?'. Le respondieron: 'Sí, ha muerto'."
,"20":"Entonces David se levantó del suelo, se bañó, se perfumó, cambió sus ropas, entró en el templo y adoró al Señor. Volvió a su casa, pidió que le sirviesen de comer y comió."
,"21":"Sus servidores le dijeron: '¿Qué es lo que haces? Cuando el niño vivía, ayunabas y llorabas, ¡y ahora que el niño ha muerto te levantas y comes!'."
,"22":"Él respondió: 'Cuando todavía vivía el niño, ayunaba y lloraba, porque me decía: ¡Quién sabe si el Señor tendrá piedad de mí y hará que el niño viva!"
,"23":"Pero ahora que ha muerto, ¿para qué voy a ayunar? ¿Puedo yo volverle a la vida? Yo iré donde está él, pero él no volverá a mí'."
,"24":"Después David consoló a Betsabé, su mujer; se unió a ella y le dio un hijo, al que llamó Salomón. El Señor lo amó,"
,"25":"y mandó por medio del profeta Natán que le pusieran de sobrenombre Yedidías, en atención del Señor."
,"26":"Joab atacó a Rabá de los amonitas, se apoderó de la ciudad de las aguas y"
,"27":"envió mensajeros a David para decirle: 'He atacado a Rabá y me he apoderado de la ciudad de las aguas."
,"28":"Reúne el resto del ejército, ataca la ciudad y tómala, para que no sea yo quien la tome y se le imponga mi nombre'."
,"29":"David reunió todo el ejército y partió para Rabá; la asaltó y la tomó."
,"30":"Quitó de la cabeza de Milcón la corona de oro, que pesaba treinta y cuatro kilos, y la piedra preciosa que había puesta en ella fue puesta en la corona de David. El botín que tomó de la ciudad fue inmenso."
,"31":"Se llevó cautivos a sus habitantes y los puso a trabajar con sierras, picos y hachas y a hacer ladrillos. Lo mismo hizo con las ciudades de los amonitas. David y todo su ejército volvieron a Jerusalén."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Absalón, hijo de David, tenía una hermana que era muy bella. Se llamaba Tamar. Amnón, hijo de David, se enamoró de ella."
,"2":"Amnón andaba atormentado, hasta sentirse enfermo, por su hermana Tamar; pues siendo ella virgen, le resultaba difícil hacerle nada a ella."
,"3":"Amnón tenía un amigo que se llamaba Yonadab, hijo de Simá, hermano de David. Yonadab era un hombre muy hábil."
,"4":"Y le dijo: '¿Por qué estás cada día más macilento, hijo del rey? ¿No quieres explicármelo?'. Amnón le respondió: 'Es que estoy enamorado de Tamar, la hermana de mi hermano Absalón'."
,"5":"Yonadab le dijo: 'Acuéstate en tu cama y fíngete enfermo; y cuando venga tu padre a visitarte, le dirás: Que venga, por favor, mi hermana Tamar a darme de comer. Que ella prepare la comida delante de mí para que yo la vea y reciba el alimento de su mano'."
,"6":"Amnón se acostó y se fingió enfermo. El rey vino a visitarle, y le dijo: 'Que venga, por favor, mi hermana Tamar; que prepare dos tortas delante de mí, y yo las tomaré de su mano'."
,"7":"David mandó a decir a Tamar: 'Vete, por favor, a casa de tu hermano Amnón y prepárale algo de comer'."
,"8":"Tamar fue a casa de su hermano Amnón. Él estaba acostado. Ella tomó harina, la amasó, preparó las tortas delante de él y las frió."
,"9":"Tomó la sartén y le presentó las tortas, pero él no quiso comerlas. Y dijo: 'Que salgan todos de aquí'. Cuando habían salido todos,"
,"10":"Amnón dijo a Tamar: 'Trae el plato a la alcoba para que yo coma de tu mano'. Tamar tomó las tortas que había preparado y se las llevó a su hermano Amnón, a la alcoba."
,"11":"Ella se acercó a él para darle de comer. Entonces él la agarró con fuerza y le dijo: 'Ven, acuéstate conmigo, hermana mía'."
,"12":"Pero ella le respondió: '¡No, hermano mío! No me violentes, porque eso no se hace en Israel. No hagas esta insensatez."
,"13":"¿Dónde iría yo con mi deshonra? Y tú serías considerado como un villano en Israel. Pídeselo al rey, que no se opondrá a que yo sea tuya'."
,"14":"Pero él no quiso escucharla y, como era más fuerte que ella, la forzó y se acostó con ella."
,"15":"Después la aborreció con un odio extremo; de modo que el odio con el que la aborreció fue mayor que el amor con que la había amado, y le dijo: '¡Levántate! ¡Márchate!'."
,"16":"Ella le dijo: 'No, hermano mío; echarme sería peor que lo que me has hecho'. Pero él no la quiso escuchar."
,"17":"Llamó al joven que le servía, y le dijo: 'Echa a ésta de aquí, lejos de mí, y cierra la puerta'."
,"18":"Llevaba una túnica talar y con mangas, pues así se vestían en otro tiempo las hijas del rey todavía vírgenes. El criado la echó y cerró la puerta tras ella."
,"19":"Entonces Tamar echó polvo en su cabeza, rasgó la túnica y con las manos en la cabeza se marchó gritando."
,"20":"Su hermano Absalón le dijo: '¿Ha estado contigo tu hermano Amnón? Por el momento, hermana mía, guarda silencio; es tu hermano. No tomes a pecho este asunto'. Tamar se quedó, desolada, en casa de su hermano Absalón."
,"21":"Cuando el rey David lo supo, montó en cólera; pero no quiso contristar a su hijo Amnón, a quien amaba por ser su primogénito."
,"22":"Absalón no dirigió la palabra a Amnón, ni para bien ni para mal, pues lo odiaba por haber violado a su hermana Tamar."
,"23":"Al cabo de dos años, Absalón tenía los esquiladores en Baal Jasor, cerca de Efraín, e invitó a todos los hijos del rey."
,"24":"Absalón se presentó al rey y le dijo: 'Mira, tu siervo está haciendo el esquileo. Que el rey y sus servidores se dignen venir a la casa de tu siervo'."
,"25":"El rey respondió: 'No, hijo mío, no iremos todos, por no serte gravosos'. Absalón insistió; pero él no quiso ir, y lo bendijo."
,"26":"Absalón dijo: 'Permite, al menos, que venga con nosotros mi hermano Amnón'. El rey respondió: '¿Por qué ha de ir contigo?'."
,"27":"Pero Absalón le insistió, y el rey dejó ir a Amnón y a todos los hijos del rey. Absalón había preparado un gran banquete, un banquete regio, "
,"28":"y había dado órdenes a sus servidores: 'Cuando Amnón esté alegre por el vino y yo os diga: ¡Golpead a Amnón!, matadlo. No temáis, porque os lo he mandado yo. Cobrad ánimo y sed valientes'."
,"29":"Los servidores de Absalón hicieron con Amnón lo que Absalón les había ordenado. Entonces todos los hijos del rey montaron cada uno en su mulo y huyeron."
,"30":"Todavía estaban de camino, cuando llegó a David este rumor: 'Absalón ha matado a todos los hijos del rey; no ha quedado ni uno solo'."
,"31":"Entonces el rey se levantó, rasgó sus vestiduras y se echó por tierra. Y todos sus servidores que estaban con él rasgaron también sus vestiduras."
,"32":"Pero Yonadab, hijo de Simá, hermano de David, tomó la palabra y dijo: 'No crea mi señor que han matado a todos los jóvenes, hijos del rey. Sólo ha muerto Amnón, pues era cosa decidida por Absalón desde el día en que Amnón violó a Tamar, su hermana;"
,"33":"que mi señor, el rey, no se haga la idea de que han muerto todos los hijos del rey, porque solamente ha muerto Amnón'."
,"34":"Entonces Absalón huyó. El centinela levantó la vista y vio que venía mucha gente por el camino de Bajurín, del lado de la montaña. "
,"35":"Yonadab dijo al rey: 'Son los hijos del rey que vienen; es lo que había dicho tu siervo'."
,"36":"Apenas terminó él de hablar, cuando llegaron los hijos del rey, que se pusieron a llorar a voz en grito. También el rey y sus servidores lloraron con gran llanto."
,"37":"Absalón huyó y se fue con Talmay, hijo de Amijud, rey de Guesur. El rey lloraba todos los días por su hijo."
,"38":"Absalón permaneció allí tres años."
,"39":"Entretanto cesó la indignación del rey contra Absalón, porque ya se había consolado de la muerte de Amnón."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Joab, hijo de Sarvia, se dio cuenta de que el corazón del rey se había inclinado hacia Absalón."
,"2":"Entonces Joab mandó a buscar a Técoa una mujer hábil y le dijo: 'Finge que estás de luto y ponte vestidos de luto; no te perfumes, de modo que parezcas una mujer que, desde hace tiempo, lleva luto por un muerto."
,"3":"Te presentas al rey y le dices esto'. Y Joab le indicó lo que ella tenía que decir."
,"4":"La mujer de Técoa se presentó, pues, al rey, y se postró rostro en tierra. Después dijo: '¡Ayúdame, oh rey!'."
,"5":"El rey le dijo: '¿Qué tienes?'. Ella respondió: 'Soy una mujer viuda. Murió mi marido,"
,"6":"y tu sierva tenía dos hijos. Riñeron los dos en el campo y, no habiendo quien los separara, el uno golpeó al otro y lo mató."
,"7":"Y ahora todo el clan se levanta contra tu sierva y dice: Entréganos al que mató a su hermano y le daremos muerte por la vida de su hermano, a quien mató, y acabaremos al mismo tiempo con el heredero. Y quieren apagar así la chispa que me queda, para no dejar a mi marido ni nombre ni descendencia sobre la faz de la tierra'."
,"8":"Él dijo a la mujer: 'Vete a tu casa; yo daré las órdenes respecto a ti'."
,"9":"La mujer dijo al rey: 'Que la culpa, oh rey mi señor, caiga sobre mí y sobre la casa de mi padre; que el rey y su trono sean inocentes'."
,"10":"El rey respondió: 'Si alguno te inquieta, tráelo aquí, y no volverá a molestarte'."
,"11":"Ella dijo: 'Que el rey se digne pronunciar el nombre del Señor, su Dios, para que el vengador de sangre no aumente mi desgracia y no maten a mi hijo'. Él respondió: 'Vive el Señor, que no caerá en tierra ni un pelo de tu hijo'."
,"12":"La mujer añadió: 'Permite a tu sierva que diga todavía una palabra a mi señor, el rey'. El rey dijo: 'Habla'."
,"13":"Entonces la mujer dijo: '¿Por qué piensas tú de este modo contra el pueblo de Dios? El rey se hace culpable por las palabras que acaba de pronunciar, si no hace que vuelva el que ha huido de él."
,"14":"Porque todos morimos y somos como agua derramada en tierra y que no puede recogerse. Dios no quita la vida, ni quiere que el fugitivo esté exiliado lejos de él."
,"15":"Si he venido a hablar al rey de este asunto, ha sido porque el pueblo me ha atemorizado; y entonces tu sierva se dijo: yo hablaré al rey, pues tal vez haga lo que su sierva le indique;"
,"16":"pues el rey accederá a librar a su sierva de la mano del hombre que intenta extirparme, juntamente con mi hijo, de la herencia de Dios."
,"17":"Tu sierva se dijo: La palabra del rey, mi señor, servirá para tranquilizarnos; pues mi señor, el rey, es como un ángel de Dios para comprender el bien y el mal. Que el Señor, tu Dios, esté contigo'."
,"18":"Entonces el rey dijo a la mujer: 'Te pido que no me ocultes nada de cuanto voy a preguntarte'. La mujer respondió: 'Hable mi señor, el rey'."
,"19":"El rey le preguntó: '¿No está contigo la mano de Joab en todo este asunto?'. La mujer respondió: 'Por tu vida, que no se desvía a la derecha o a la izquierda nada de cuanto dice mi señor, el rey: Tu mismo siervo Joab es quien me ha mandado y me ha indicado todo lo que tenía que decirte."
,"20":"Tu siervo Joab ha obrado de este modo para dar otro aspecto al asunto. Pero mi señor es sabio con la sabiduría del ángel de Dios, y sabe cuanto pasa en la tierra'."
,"21":"Entonces el rey dijo a Joab: '¡Muy bien!, voy a hacer lo que has dicho: Vete y haz que vuelva el joven Absalón'."
,"22":"Joab se postró rostro en tierra, y bendijo al rey, diciendo: 'Hoy sé que cuento con tu favor, oh rey, mi señor, pues has cumplido el deseo de tu siervo'."
,"23":"Joab se puso en marcha, fue a Guesur, y trajo a Absalón a Jerusalén."
,"24":"Pero el rey dijo: 'Que se vaya a su casa y que no se presente ante mí'. Absalón se fue a su casa y no se presentó ante el rey."
,"25":"No había en todo Israel un hombre que fuese tan celebrado por su belleza como Absalón. Desde la planta de los pies hasta la coronilla de la cabeza no había defecto alguno en él."
,"26":"Cuando se cortaba el pelo, y lo hacía cada año, pues le pesaba tanto que tenía que cortárselo, el pelo de su cabeza pesaba dos kilos y medio, peso de rey."
,"27":"Absalón tuvo tres hijos y una hija, que se llamaba Tamar, y era muy bella."
,"28":"Absalón vivió dos años en Jerusalén sin ver al rey."
,"29":"Absalón mandó recado a Joab para que fuera a ver al rey de parte suya, pero Joab no quiso ir. Le mandó por segunda vez, y tampoco quiso ir."
,"30":"Entonces dijo a sus siervos: 'Conocéis el campo de Joab, que está junto al mío y en el que tiene cebada; id y prendedle fuego'. Y los siervos de Absalón prendieron fuego al campo."
,"31":"Entonces Joab se presentó a Absalón en su casa y le dijo: '¿Por qué tus siervos han prendido fuego a mi campo?'."
,"32":"Absalón le respondió: 'Te he mandado a decir que vinieses para enviarte al rey con este mensaje: ¿Para qué he venido de Guesur? Me hubiera sido mejor estar todavía allí. Quiero ver al rey; y, si tengo culpa, que me mate'."
,"33":"Joab se presentó al rey y se lo comunicó. Entonces el rey llamó a Absalón. Absalón se presentó y se postró rostro en tierra ante el rey. Y el rey besó a Absalón."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Después de esto, Absalón se procuró un carro y caballos y una guardia de cincuenta hombres."
,"2":"Absalón se levantaba pronto, se ponía junto al camino que lleva a la puerta y, cuando un hombre tenía un pleito que le llevaba ante el rey para el juicio, le llamaba y le decía: '¿De qué ciudad eres?'. Él respondía: 'Tu servidor es de tal tribu de Israel'."
,"3":"Absalón le decía: 'Mira, tu causa es buena y justa; pero no hay quien te escuche de parte del rey'."
,"4":"Y continuaba: '¡Quién me constituyese juez en el país, para que todos los que tuviesen un juicio o un pleito viniesen a mí y yo les hiciese justicia!'."
,"5":"Y cuando alguien se acercaba a él para postrarse ante él, le tendía la mano, lo abrazaba y lo besaba."
,"6":"Así procedía Absalón con todos los israelitas que venían a pedir justicia al rey, y así ganaba el corazón de los israelitas."
,"7":"Al cabo de cuatro años, Absalón dijo al rey: 'Permíteme que vaya a Hebrón a cumplir un voto que hice al Señor;"
,"8":"pues cuando estaba en Guesur, en Arán, hice este voto: Si el Señor me permite volver a Jerusalén, ofreceré al Señor un sacrificio en Hebrón'."
,"9":"El rey le respondió: 'Vete en paz'. Entonces Absalón partió para Hebrón."
,"10":"Absalón mandó mensajeros a todas las tribus de Israel, para decirles: 'Cuando oigáis el sonido de la trompeta, gritaréis: Absalón reina en Hebrón'."
,"11":"De Jerusalén habían ido con Absalón doscientos hombres invitados por él, que iban de buena fe, sin saber nada."
,"12":"Absalón mandó a buscar a su propia ciudad de Guiló a Ajitófel, guilonita, consejero de David, que estuvo con él mientras ofrecía el sacrificio. La conjuración se hizo fuerte y los partidarios de Absalón iban aumentando."
,"13":"Uno fue a informar a David: 'El corazón de toda la gente de Israel se va tras Absalón'."
,"14":"Entonces dijo David a todos sus servidores que estaban con él en Jerusalén: 'Levantaos y huyamos, porque no podremos escapar de Absalón. Daos prisa a salir, no sea que venga a toda prisa, nos sorprenda, haga caer sobre nosotros el mal y pase la ciudad a filo de espada'."
,"15":"Ellos contestaron: 'Estamos a tus órdenes, haremos lo que mandes',"
,"16":"y salió el rey y toda su casa detrás de él; pero el rey dejó diez concubinas para guardar la casa,"
,"17":"y se detuvo en la última casa."
,"18":"Todos sus servidores estaban a su lado. Todos los quereteos, los peleteos y los hititas que le habían seguido desde Gat, seiscientos hombres, marchaban delante del rey."
,"19":"El rey dijo a Itay, el de Gat: '¿Por qué vienes tú también con nosotros? Vuélvete y quédate con el rey, porque tú eres extranjero y también tú estás exiliado lejos de tu país."
,"20":"Llegaste ayer, y ¿te haré andar errante con nosotros hoy, sin saber yo mismo dónde voy? Vuélvete y lleva contigo a tus hermanos, y que el Señor tenga contigo misericordia y fidelidad'."
,"21":"Itay respondió al rey: 'Vive el Señor y vive mi señor, el rey, que en el lugar donde esté mi señor, el rey, para la muerte o para la vida, allí estará tu siervo'."
,"22":"David dijo a Itay: 'Anda, pasa'. E Itay de Gat pasó con todos sus hombres y toda su familia que estaba con él."
,"23":"Todo el mundo lloraba a voz en grito. El rey estaba de pie en el torrente Cedrón, y todo el pueblo desfiló delante de él por el camino que lleva al desierto."
,"24":"Iba también Sadoc con todos los levitas, que llevaban el arca de la alianza de Dios; y colocaron el arca de Dios junto a Abiatar, hasta que todo el pueblo terminó de salir de la ciudad."
,"25":"Entonces el rey dijo a Sadoc: 'Vuelve el arca de Dios a la ciudad. Si el Señor me favorece, él me hará volver para ver el arca y su santuario."
,"26":"Pero si dice que no le agrado, aquí me tiene; que haga conmigo lo que quiera'."
,"27":"El rey dijo al sacerdote Sadoc: 'Mira, tú y Abiatar volved en paz a la ciudad. Y que vuelva con vosotros Ajimás, tu hijo, y Jonatán, hijo de Abiatar;"
,"28":"yo esperaré en la estepa del desierto hasta que me llegue alguna noticia de vosotros'."
,"29":"Sadoc y Abiatar volvieron con el arca de Dios a Jerusalén y se quedaron allí."
,"30":"David subía la pendiente de los olivos; subía llorando, con la cabeza cubierta y los pies descalzos, y todo el pueblo que le acompañaba iba también con la cabeza cubierta y llorando."
,"31":"Cuando comunicaron a David que Ajitófel estaba con Absalón, entre los conjurados, dijo: '¡Te suplico, Señor, que hagas fracasar los planes de Ajitófel!'."
,"32":"Al llegar David a la cumbre, donde se adora a Dios, le salió al encuentro Jusay, el arquita, con los vestidos desgarrados y polvo sobre su cabeza."
,"33":"David le dijo: 'Si vienes conmigo, me serás una carga;"
,"34":"pero si vuelves a la ciudad y dices a Absalón: Yo seré tu siervo, oh rey, mi señor; antes servía a tu padre, pero ahora te serviré a ti, harás fracasar los planes de Ajitófel."
,"35":"¿No están allí contigo los sacerdotes Sadoc y Abiatar? Todo lo que oigas en el palacio real, se lo comunicarás a los sacerdotes Sadoc y Abiatar."
,"36":"Mira, están allí con ellos sus dos hijos: Ajimás, hijo de Sadoc, y Jonatán, hijo de Abiatar. Por medio de ellos me comunicaréis todo lo que sepáis'."
,"37":"Jusay, amigo de David, entró en la ciudad cuando Absalón llegaba a Jerusalén."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Apenas había David traspasado la cumbre, cuando Sibá, el servidor de Meribaal le salió al encuentro con dos asnos aparejados, que llevaban doscientos panes, cien racimos de uvas pasas, cien frutos del tiempo y un odre de vino."
,"2":"El rey preguntó a Sibá: '¿Qué quieres hacer con esto?'. Sibá respondió: 'Los asnos son para la familia del rey, para que monte en ellos; el pan y el fruto del tiempo, para que coman los muchachos, y el vino, para dar de beber al que esté fatigado en el desierto'."
,"3":"El rey le preguntó: '¿Dónde está el hijo de tu señor?'. Sibá contestó al rey: 'Se ha quedado en Jerusalén, porque se dijo: Hoy me devolverá la casa de Israel el reino de mi padre'."
,"4":"Entonces el rey dijo a Sibá: 'Todo lo que pertenecía a Meribaal será tuyo'. Y Sibá contestó: 'A tus pies, gracias por el favor que me haces'."
,"5":"Cuando el rey David llegó a Bajurín, salió de allí un hombre del mismo clan de Saúl, llamado Semeí, hijo de Guerá. Salía profiriendo maldiciones."
,"6":"Y tiraba piedras a David y a todos sus servidores, aunque todo el ejército y los valientes estaban a la derecha y a la izquierda del rey."
,"7":"Semeí profería estos insultos: '¡Vete, vete, hombre sanguinario y perverso!"
,"8":"El Señor ha hecho caer sobre ti toda la sangre de la casa de Saúl, a quien has usurpado el trono, y ha puesto el trono en manos de Absalón, tu hijo. Tú estás en la desgracia que mereces, porque eres un hombre sanguinario'."
,"9":"Abisay, hijo de Sarvia, dijo al rey: '¿Por qué insulta este perro muerto al rey, mi señor? Déjame que vaya y le corte la cabeza'."
,"10":"El rey dijo: 'Esto no os importa a vosotros, hijos de Sarvia. Si el Señor le ha ordenado que me maldiga, nadie podrá pedirle cuentas'."
,"11":"David dijo a Abisay y a todos sus servidores: 'Mirad, si mi hijo, salido de mis entrañas, busca mi vida, con mayor razón lo hará este hijo de Benjamín. Dejadle maldecir, si se lo ha ordenado el Señor."
,"12":"Tal vez el Señor vea mi aflicción y me devuelva bien en lugar de esta maldición de hoy'."
,"13":"David y sus hombres continuaron su camino, mientras Semeí iba por la falda del monte, frente a ellos; le insultaba, tiraba piedras y levantaba polvo."
,"14":"El rey y todo el pueblo que estaba con él llegaron extenuados y allí descansaron."
,"15":"Absalón entró en Jerusalén con todos los hombres de Israel. Ajitófel estaba con él."
,"16":"Jusay, el arquita, amigo de David, llegó junto a Absalón, y le dijo: '¡Viva el rey! ¡Viva el rey!'."
,"17":"Absalón dijo a Jusay: '¿Es éste el afecto que tienes a tu amigo? ¿Por qué no fuiste con tu amigo?'."
,"18":"Jusay le respondió: 'No, yo quiero estar y quedarme con aquel a quien ha elegido el Señor, todo este pueblo y toda la gente de Israel."
,"19":"En segundo lugar, ¿a quién me pongo a servir? ¿No es a su hijo? Como estuve al servicio de tu padre, así estaré a tu servicio'."
,"20":"Absalón dijo a Ajitófel: 'Celebrad consejo sobre lo que debemos hacer'."
,"21":"Ajitófel respondió a Absalón: 'Acuéstate con las concubinas de tu padre que él dejó para guardar el palacio; así sabrá todo Israel que te has hecho odioso a tu padre y se fortalecerán las manos de todos los que te siguen'."
,"22":"Plantaron en la terraza una tienda de campaña para Absalón, y Absalón se acostó con las concubinas de su padre a la vista de todo Israel."
,"23":"En aquellos días el consejo que daba Ajitófel era considerado como un oráculo de Dios. Así eran considerados todos los consejos de Ajitófel, tanto los que daba a David como los que daba a Absalón."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Ajitófel dijo a Absalón: 'Déjame elegir doce mil hombres para ir en persecución de David esta noche."
,"2":"Caeré sobre él cuando esté cansado y sin fuerzas, y le atemorizaré. Todo el pueblo que está con él se dará a la fuga, y mataré solamente al rey."
,"3":"Haré venir a ti a todo el pueblo, como la prometida viene a su esposo; y con la vida de un solo hombre, a quien tú buscas, todo el pueblo será salvo'."
,"4":"La proposición agradó a Absalón y a todos los ancianos de Israel."
,"5":"Pero Absalón dijo: 'Llamad también a Jusay, el arquita, para saber lo que él dice'."
,"6":"Jusay se presentó, y Absalón le dijo: 'Ajitófel ha hecho esta proposición. ¿Debemos hacer lo que él ha dicho? ¿Qué te parece?'."
,"7":"Jusay le contestó: 'No es bueno el consejo que Ajitófel ha dado esta vez'."
,"8":"Y añadió: 'Tú conoces a tu padre y a sus hombres; son valientes y están furiosos como una osa a la que se ha quitado la cría en el campo. Tu padre es un guerrero y no pasará la noche con el pueblo."
,"9":"Seguro que ahora estará escondido en una cueva o en cualquier otro lugar. Si al principio cae alguno de los nuestros, se esparcirá el rumor de un desastre en los seguidores de Absalón."
,"10":"Y entonces, aun el más valiente, el que tiene el corazón semejante al del león, perdería el ánimo; porque todo Israel sabe que tu padre es un valiente y que los que están con él son también valientes."
,"11":"Yo más bien aconsejo que todo Israel, desde Dan hasta Berseba, se reúna en torno a ti, tan numeroso como las arenas que hay a orillas del mar, y que tú mismo en persona vayas con ellos."
,"12":"Llegaremos al lugar en que se encuentre y caeremos sobre él como cae el rocío sobre la tierra, y no dejaremos con vida ni a él ni a uno solo de los hombres que le acompañan."
,"13":"Si se retira a una ciudad, todo Israel llevará cuerdas a esta ciudad y la arrastraremos al torrente, hasta que no quede en ella ni una piedra'."
,"14":"Absalón y todos los israelitas dijeron: 'El consejo de Jusay, el arquita, es mejor que el de Ajitófel'. El Señor había decidido traer la ruina sobre Absalón."
,"15":"Jusay dijo a los sacerdotes Sadoc y Abiatar: 'Ajitófel ha dado tal y tal consejo a Absalón y a los ancianos de Israel; yo, sin embargo, les he dado este otro."
,"16":"Mandad rápidamente a comunicárselo a David y a decirle que no pase la noche en las llanuras del desierto; que pase enseguida al otro lado, para que no sea exterminado él y todos los que le acompañan'."
,"17":"Jonatán y Ajimás estaban junto a la fuente de Roguel. Una sirvienta iba a llevarles las noticias para que fuesen ellos a informar al rey David, pues para no dejarse ver, no entraban en la ciudad."
,"18":"Pero les vio un joven y se lo comunicó a Absalón. Entonces los dos, caminando de prisa, llegaron a Bajurín, a casa de un hombre que tenía una cisterna en el patio, y allí se metieron."
,"19":"La mujer tomó una manta, la extendió sobre la boca de la cisterna y esparció sobre ella grano molido, de suerte que no se notaba nada."
,"20":"Llegaron los servidores de Absalón, entraron en la casa de la mujer y le preguntaron: '¿Dónde están Ajimás y Jonatán?'. La mujer les contestó: 'Pasaron en dirección al río'. Los buscaron y, al no encontrarlos, se volvieron a Jerusalén."
,"21":"Cuando ya se habían ido, salieron de la cisterna, fueron a informar a David y le dijeron: 'Poneos en marcha y pasad rápidamente el río, porque éste es el consejo que ha dado Ajitófel contra vosotros'."
,"22":"David y todo el pueblo que le acompañaba se pusieron en marcha y pasaron el Jordán, de modo que al amanecer no quedaba ninguno que no hubiese pasado el Jordán."
,"23":"Ajitófel, viendo que no se seguía su consejo, aparejó su asno y se fue a su casa, en su ciudad; puso todo en orden y se ahorcó. Así murió, y fue sepultado en el sepulcro de su padre."
,"24":"David había llegado a Majanayín cuando Absalón pasó el Jordán con todos los israelitas que le acompañaban."
,"25":"Absalón había puesto a la cabeza del ejército a Amasá, en lugar de Joab. Amasá era hijo de un hombre llamado Yitrá, el ismaelita, que se había unido a Aigaíl, hija de Jesé y hermana de Sarvia, la madre de Joab."
,"26":"Israel y Absalón pusieron el campamento en la tierra de Galaad."
,"27":"Cuando David llegó a Majanayín, Sobí, hijo de Najás, de Rabá de los amonitas, y Maquir, hijo de Amiel, de Lodebar, y Barzilay, el galaadita de Roguelín,"
,"28":"trajeron camas, mantas, copas y vasos de barro, trigo, cebada, harina, grano tostado, habas, lentejas,"
,"29":"miel, manteca y queso, carneros y toros, que ofrecieron a David y a su gente para que comieran; porque se dijeron: 'El pueblo ha sufrido hambre, fatiga y sed en el desierto'."
}`)
	CurrentBook.AddChapter(18, `{
"1":"David pasó revista al ejército que le acompañaba, y puso al frente de ellos jefes de millar y de centena."
,"2":"Dividió el ejército en tres cuerpos. Dio el mando de un tercio a Joab; de otro tercio, a Abisay, hijo de Sarvia, hermano de Joab, y de otro a Itay de Gat. Después dijo al ejército: 'Yo iré también con vosotros a la guerra'."
,"3":"El ejército respondió: 'No, tú no debes ir, porque si nosotros nos damos a la fuga, nadie se fijaría en nosotros; pero tú eres como diez mil hombres entre nosotros. Y es mejor que te quedes en la ciudad para venir a socorrernos'."
,"4":"El rey les dijo: 'Haré lo que os parezca'. El rey se puso en pie junto a la puerta, mientras salía el ejército por grupos de ciento y de mil."
,"5":"El rey dio a Joab, a Abisay y a Itay la orden siguiente: 'Respetad, por consideración a mí, al joven Absalón'. Y todo el pueblo supo que el rey había dado esta orden sobre Absalón a todos los jefes."
,"6":"El ejército salió al campo, al encuentro de Israel, y la batalla tuvo lugar en el monte de Efraín."
,"7":"El pueblo de Israel fue derrotado por los servidores de David, y aquel día fue grande la derrota: murieron veinte mil hombres."
,"8":"La batalla se extendió por toda la región, y aquel día el bosque causó más muertes que la espada."
,"9":"Absalón se encontró frente a frente con los hombres de David. Absalón iba montado en un mulo, y, al pasar por debajo de las ramas de una gran encina, la cabeza de Absalón se enredó en las ramas de la encina y quedó colgado entre el cielo y la tierra. El mulo siguió adelante."
,"10":"Lo vio uno y fue a decírselo a Joab: 'He visto a Absalón colgado en una encina'."
,"11":"Joab le contestó: 'Si lo has visto, ¿por qué no lo has matado y tirado al suelo? Yo te hubiera dado diez monedas de plata y un cinturón'."
,"12":"Pero el hombre respondió a Joab: 'Aunque me dieras mil monedas de plata, no pondría mi mano sobre el hijo del rey; porque llegó a nuestros oídos la orden que te dio el rey, lo mismo que a Abisay y a Itay, de que se respetara al joven Absalón."
,"13":"Si yo hubiese atentado a ocultas contra su vida, como al rey nada se le oculta, tú te habrías quedado al margen'."
,"14":"Joab respondió: 'No quiero perder el tiempo contigo'. Agarró tres dardos y los clavó en el corazón de Absalón, que todavía estaba vivo en la encina."
,"15":"Después llegaron diez jóvenes, escuderos de Joab, y lo remataron."
,"16":"Entonces Joab mandó tocar la trompeta, y el ejército cesó de perseguir a Israel, porque Joab lo detuvo."
,"17":"Tomaron a Absalón y lo echaron en una gran fosa en el bosque, y pusieron sobre él un gran montón de piedras. Todos los israelitas habían huido, cada uno a su tienda."
,"18":"Absalón, cuando todavía vivía, se había erigido un monumento en el Valle del Rey, porque pensaba: 'Yo no tengo hijos para conservar el recuerdo de mi nombre'. Y había puesto su nombre al monumento. Todavía hoy se llama 'el monumento de Absalón'."
,"19":"Ajimás, hijo de Sadoc, dijo 'Déjame ir corriendo a dar al rey esta buena nueva de que el Señor le ha hecho justicia, librándolo de las manos de sus enemigos'."
,"20":"Joab le respondió: 'No serás tú hoy el portador de la buena nueva; lo serás otro día; pero hoy no llevarás una buena nueva, porque ha muerto el hijo del rey'."
,"21":"Y Joab dijo al cusita: 'Vete y comunica al rey lo que has visto'. El cusita hizo una inclinación de cabeza ante Joab y partió corriendo."
,"22":"Ajimás, hijo de Sadoc, volvió a decir a Joab: 'Ocurra lo que ocurra, déjame que corra también yo tras el cusita'. Joab le dijo: '¿Por qué quieres correr, hijo mío? No encontrarás recompensa alguna'."
,"23":"Él prosiguió: 'Ocurra lo que ocurra, yo voy corriendo'. Joab le dijo: 'Pues, ¡hala!, corre'. Ajimás corrió por el camino de la llanura y adelantó al cusita."
,"24":"David estaba sentado entre las dos puertas. El centinela subió a la terraza de la puerta, sobre el muro, alzó la vista, vio a un hombre que venía corriendo solo"
,"25":"y se lo anunció al rey. El rey dijo: 'Si viene solo, es que trae buenas noticias'. Mientras él iba acercándose,"
,"26":"el centinela vio a otro hombre que venía corriendo, y el centinela que estaba sobre la puerta gritó: 'Otro hombre que viene corriendo solo'. Y el rey dijo: 'También éste trae buenas noticias'."
,"27":"El centinela dijo: 'El modo de correr del primero me parece el modo de correr de Ajimás, hijo de Sadoc'. El rey contestó: 'Es un hombre bueno; viene para traer buenas noticias'."
,"28":"Ajimás se acercó y dijo al rey: 'Salud'. Se postró ante el rey rostro en tierra, y prosiguió: 'Bendito sea el Señor, tu Dios, que ha entregado a los hombres que levantaban su mano contra mi señor, el rey'."
,"29":"El rey preguntó: '¿Está bien el joven Absalón?'. Ajimás respondió: 'Yo vi un gran alboroto en el momento que Joab enviaba a tu siervo, pero no sé lo que era'."
,"30":"El rey dijo: 'Retírate y quédate aquí'. Él se hizo a un lado y se quedó allí."
,"31":"Entonces llegó el cusita y dijo: 'Reciba mi señor, el rey, estas buenas noticias. El Señor te ha hecho justicia librándote de todos aquellos que se habían levantado contra ti'."
,"32":"El rey preguntó al cusita: '¿Está bien el joven Absalón?'. El cusita contestó: '¡Que corran la suerte de ese joven los enemigos de mi señor, el rey, y todos los que se han levantado contra ti para el mal!'."
}`)
	CurrentBook.AddChapter(19, `{
"1":"El rey se conmovió, subió a la habitación de encima de la puerta y se puso a llorar. Y decía sollozando: '¡Absalón, hijo mío! ¡Hijo mío, hijo mío, Absalón! ¡Quién me diera haber muerto yo en tu lugar, Absalón, hijo mío, hijo mío!'."
,"2":"Dijeron a Joab que el rey lloraba y se lamentaba por Absalón."
,"3":"Y aquel día la victoria se cambió en luto para todo el ejército, porque aquel día el ejército supo que el rey estaba afligido por su hijo."
,"4":"Por eso aquel día las tropas entraron furtivamente en la ciudad, como entra la gente avergonzada de haber huido en la batalla."
,"5":"El rey se había cubierto el rostro y daba grandes gritos: '¡Hijo mío, Absalón! ¡Absalón, hijo mío, hijo mío!'."
,"6":"Joab se presentó al rey, en su casa, y le dijo: 'Hoy cubres de vergüenza a tus siervos, que han salvado hoy tu vida, la vida de tus hijos y de tus hijas, la de tus mujeres y tus concubinas,"
,"7":"amando a quien te odia y odiando a quien te ama. Hoy has demostrado bien que nada te importan ni los jefes ni los soldados; porque bien sé que, si viviese Absalón y todos nosotros hubiésemos muerto, entonces estarías contento."
,"8":"Levántate, sal y habla al corazón de tus soldados; porque te juro por el Señor que, si no sales, no quedará contigo esta noche ni un solo hombre, y esto sería para ti el mayor de todos los males que hayan venido sobre ti desde tu juventud hasta hoy'."
,"9":"Entonces el rey se levantó y fue a sentarse a la puerta. Se informó a todo el ejército de que el rey estaba sentado a la puerta. Y todo el ejército se presentó ante el rey. Los de Israel habían huido cada uno a su tienda. "
,"10":"Toda la gente, en todas las tribus de Israel, discutía en estos términos: 'El rey nos ha salvado del poder de nuestros enemigos; él nos ha librado del poder de los filisteos y ahora ha tenido que huir del país a causa de Absalón."
,"11":"Ahora bien, Absalón, a quien habíamos ungido sobre nosotros, ha muerto en la batalla. Entonces, ¿por qué no hacéis algo para que vuelva el rey?'."
,"12":"Esto que se decía en todo Israel llegó a oídos del rey. Entonces David mandó decir a los sacerdotes Sadoc y Abiatar: 'Decid a los ancianos de Judá: ¿Por qué sois vosotros los últimos en hacer que el rey vuelva a su palacio?"
,"13":"Vosotros sois mis hermanos, hueso mío y carne mía. ¿Por qué sois los últimos en hacer que vuelva el rey?"
,"14":"Y a Amasá le diréis: ¿No eres tú hueso mío y carne mía? Que Dios me castigue si no te hago jefe de mi ejército para siempre en lugar de Joab'."
,"15":"Entonces se unieron todos los de Judá como un solo hombre y enviaron a decir al rey: 'Vuelve tú y todos tus servidores'."
,"16":"El rey volvió y llegó al Jordán. Judá venía a Guilgal para ir al encuentro del rey y ayudarle a pasar el Jordán."
,"17":"Semeí, hijo de Guerá, el benjaminita de Bajurín, se apresuró a bajar también con los hombres de Judá al encuentro del rey David."
,"18":"Llevaba consigo mil hombres de Benjamín. Sibá, el servidor de la casa de Saúl, con sus quince hijos y veinte siervos, se adelantaron al rey en el Jordán,"
,"19":"pasaron al otro lado y lo dispusieron todo para ayudar a pasar a la familia del rey y hacer lo que quisiera. Semeí, hijo de Guerá, se arrojó a los pies del rey cuando iba a pasar el Jordán, "
,"20":"y le dijo: '¡Que mi señor no me tenga en cuenta la falta y que no recuerde el delito que cometió tu siervo el día en que mi señor, el rey, salía de Jerusalén! Que el rey no lo tome a pecho."
,"21":"Porque tu siervo reconoce que ha pecado, y por eso he venido el primero de toda la casa de José para bajar al encuentro de mi señor, el rey'."
,"22":"Abisay, hijo de Sarvia, dijo: '¿Es que no va a morir Semeí, que maldijo al ungido del Señor?'."
,"23":"Y David respondió: '¿Qué os importa a vosotros, hijos de Sarvia, para que os convirtáis hoy en mis adversarios? ¿Es que va a morir hoy alguno en Israel? ¿Quizá no me doy cuenta de que hoy me constituyo en el rey de Israel?'."
,"24":"Y el rey dijo a Semeí: 'No morirás'. Y el rey se lo juró."
,"25":"Meribaal, hijo de Saúl, fue también a recibir al rey. No se había lavado los pies y las manos, no se había arreglado el bigote ni se había lavado sus vestidos desde el día en que se había ido el rey hasta que volvió en paz."
,"26":"Cuando llegó de Jerusalén ante el rey, éste le preguntó: '¿Por qué no viniste conmigo, Meribaal?'."
,"27":"Él respondió: 'Mi señor, el rey; mi servidor me engañó, pues tu siervo le dijo: Aparéjame el asno para montar en él e ir con el rey; porque tu siervo es cojo."
,"28":"Él calumnió a tu siervo ante mi señor, el rey. Pero mi señor, el rey, es como el ángel de Dios; haz lo que quieras."
,"29":"Porque toda la familia de mi padre es merecedora de la muerte por parte de mi señor, el rey; y, sin embargo, tú has admitido a tu siervo entre los que comen a tu mesa. ¿Qué derecho puedo tener yo para implorar todavía al rey?'."
,"30":"El rey le dijo: '¿Para qué tantas palabras? He decidido que tú y Sibá os repartáis las tierras'."
,"31":"Meribaal dijo al rey: 'Puede quedarse él con todas, que mi señor, el rey, ha vuelto en paz a su palacio'."
,"32":"Barzilay, el galaadita, fue también a Roguelín y continuó con el rey para guiarle hasta el Jordán."
,"33":"Barzilay era muy viejo. Tenía ochenta años. Él había provisto al rey durante su permanencia en Majanayín, pues era un hombre muy rico."
,"34":"El rey dijo a Barzilay: 'Ven conmigo, y yo te proveeré en las necesidades de tu vejez junto a mí, en Jerusalén'."
,"35":"Pero Barzilay dijo al rey: '¿Cuántos años me quedan de vida para ir con el rey a Jerusalén?"
,"36":"Tengo ahora ochenta años. ¿Puedo distinguir todavía entre el bien y el mal? ¿Puede saborear tu siervo lo que come y lo que bebe? ¿Puedo escuchar todavía la voz de los cantores y cantoras? ¿Por qué va a ser tu siervo una carga para mi señor, el rey?"
,"37":"Tu siervo hace bien poca cosa con acompañar al rey hasta pasar el Jordán; ¿por qué me concede el rey tal recompensa?"
,"38":"Déjame volver a mi ciudad para morir allí, junto al sepulcro de mis padres. Mi hijo Quimán, tu siervo, que continúe con mi señor, el rey, y haz con él lo que bien te parezca'."
,"39":"El rey contestó: 'Pues que venga conmigo Quimán, y yo haré con él lo que quieras; te concederé todo lo que me pidas'."
,"40":"Todo el pueblo pasó el Jordán; el rey pasó también. El rey besó a Barzilay y le bendijo, y éste se volvió a su casa."
,"41":"El rey pasó a Guilgal, y Quimán continuó con él. Todo el pueblo de Judá y la mitad del pueblo de Israel acompañaban al rey en la travesía."
,"42":"Todos los israelitas fueron a decir al rey: '¿Por qué te han acaparado nuestros hermanos de Judá, para hacer pasar el Jordán al rey, a su familia y a todos sus hombres?'."
,"43":"Los hombres de Judá respondieron a los de Israel: 'Porque el rey es mi pariente. ¿Por qué te irritas por esto? ¿Acaso hemos comido nosotros a expensas del rey o nos ha hecho regalos?'."
,"44":"Los de Israel respondieron a los de Judá: 'Nosotros tenemos diez partes en el rey, y además somos el primogénito. ¿Por qué nos despreciáis? ¿No hemos sido nosotros los primeros en hacer volver al rey?'. Las palabras de los de Judá fueron más duras que las de los de Israel."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Se encontraba allí un hombre perverso, llamado Sebá, hijo de Bicrí, un benjaminita, que tocó la trompeta y dijo: 'Nosotros no tenemos parte con David, nosotros no tenemos herencia,con el hijo de Jesé. ¡Cada uno a sus tiendas, Israel!'."
,"2":"Los hombres de Israel, abandonando a David, se fueron con Bicrí; pero los de Judá siguieron a su rey, desde el Jordán hasta Jerusalén."
,"3":"David entró en su palacio, en Jerusalén. Y el rey tomó a las diez concubinas que había dejado para guardar el palacio y las puso bajo su guardia. Él proveyó a su sustento, pero no volvió a tener relaciones con ellas, y estuvieron encerradas, como viudas, hasta el día de su muerte."
,"4":"El rey dijo a Amasá: 'Convócame a los hombres de Judá en el plazo de tres días. Tú estarás también aquí'."
,"5":"Amasá fue a congregar a los de Judá, pero tardó más del tiempo señalado."
,"6":"Entonces David dijo a Abisay: 'Ahora Sebá, hijo de Bicrí, nos hará más daño que Absalón. Toma contigo a los servidores de tu señor y persíguelo, para que no alcance las ciudades fuertes y se nos escape'."
,"7":"Con Abisay salieron a campaña Joab, los quereteos, los peleteos y todos los valientes; salieron de Jerusalén para perseguir a Sebá, hijo de Bicrí."
,"8":"Cuando estaban junto a la gran piedra que hay en Gabaón, llegó Amasá frente a ellos. Joab iba vestido con uniforme militar y llevaba al costado una espada envainada. La espada se le salió y se cayó."
,"9":"Joab preguntó a Amasá: '¿Estás bien, hermano mío?'. Y con la mano derecha le agarró de la barba, como para besarle."
,"10":"Amasá no se fijó en la espada que Joab tenía en la mano, y éste se la clavó en el vientre, esparció sus entrañas en la tierra y, sin repetirle el golpe, murió. Entonces Joab y su hermano Abisay salieron en persecución de Sebá, hijo de Bicrí."
,"11":"Uno de los soldados de Joab se quedó junto a Amasá y gritó: 'El que esté por Joab y por David, que siga a Joab'."
,"12":"Amasá, bañado en sangre, yacía en medio del camino. Aquel hombre, viendo que todo el mundo se detenía, apartó a Amasá del camino y lo tapó con una capa, porque veía que todos los que llegaban se detenían junto a él."
,"13":"Una vez apartado del camino, todos siguieron a Joab en persecución de Sebá, hijo de Bicrí."
,"14":"Sebá recorrió todas las tribus de Israel y llegó a Abel Bet Maacá; todos los bicritas se reunieron y le siguieron."
,"15":"Los de Joab llegaron y lo asediaron en Abel Bet Maacá. Levantaron un terraplén contra la ciudad, y todo el ejército que seguía a Joab hacía minas para hacer caer la muralla."
,"16":"Entonces una mujer, avisada, comenzó a gritar desde la ciudad: '¡Escuchad! ¡Escuchad! Decid a Joab que venga; que quiero hablar con él'."
,"17":"Joab fue, y ella le preguntó: '¿Eres tú Joab?'. Él respondió: 'Sí'. Ella le dijo: 'Escucha las palabras de tu sierva'. Él contestó: 'Escucho'."
,"18":"Ella dijo: 'En otro tiempo había la costumbre de decir: Para consultar, que se consulte en Abel y en Dan; y todo se arreglaba así."
,"19":"Nuestra ciudad es de las ciudades pacíficas, fieles e importantes de Israel, y tú intentas destruirla. ¿Por qué quieres destruir la heredad del Señor?'."
,"20":"Joab respondió: '¡Lejos, lejos de mí! Yo no quiero destruir ni devastar."
,"21":"No es eso, sino que un hombre de la montaña de Efraín, llamado Sebá, hijo de Bicrí, ha levantado su mano contra el rey David. Entregádmelo a él solo, y yo me alejaré de la ciudad'. La mujer le dijo: 'Mira, te tiraremos su cabeza por encima de la muralla'."
,"22":"La mujer, con su sabiduría, convenció a toda la ciudad, cortaron la cabeza a Sebá, hijo de Bicrí, y se la tiraron a Joab. Éste hizo sonar la trompeta y se alejaron de la ciudad, cada cual a su casa. Joab volvió a Jerusalén junto al rey."
,"23":"Joab mandaba todo el ejército de Israel; Benayas, hijo de Yehoyadá, mandaba a los quereteos y peleteos;"
,"24":"Adorán era el inspector de las prestaciones personales, y Josafat, hijo de Ajilud, cronista."
,"25":"Susa era secretario, y Sadoc y Abiatar, sacerdotes."
,"26":"Ira, de Yaír, era también sacerdote de David."
}`)
	CurrentBook.AddChapter(21, `{
"1":"En tiempos de David hubo una gran hambre durante tres años consecutivos. David consultó al Señor, y el Señor le dijo: 'Hay sangre sobre Saúl y sobre su casa, porque él mató a los gabaonitas'."
,"2":"Entonces el rey convocó a los gabaonitas y les habló (los gabaonitas no eran israelitas, sino un resto de los amorreos; pero los israelitas estaban ligados a ellos con juramento y, sin embargo, Saúl había intentado exterminarlos en su celo por Israel y Judá)."
,"3":"David dijo a los gabaonitas: '¿Qué debo yo hacer por vosotros y qué reparación tengo que hacer para que bendigáis la heredad del Señor?'."
,"4":"Los gabaonitas le respondieron: 'No se trata de una cuestión de plata o de oro con Saúl y su familia, ni queremos que nadie muera en Israel'. David dijo: 'Haré por vosotros lo que me digáis'."
,"5":"Ellos le dijeron: 'Un hombre pretendía destruirnos, exterminarnos y hacernos desaparecer de todo el territorio de Israel;"
,"6":"que nos entregue siete de sus hijos para que nosotros los colguemos ante el Señor, en Gabaón, en el monte del Señor'. Y el rey dijo: 'Os los entregaré'."
,"7":"El rey perdonó a Meribaal, hijo de Jonatán, hijo de Saúl;"
,"8":"pero a los dos hijos que Rispá, hija de Ayá, había dado a Saúl, Armoní y Meribaal, y a los cinco hijos que Merab, hija de Saúl, había dado a Adriel, hijo de Barzilay, de Mejolá,"
,"9":"se los entregó a los gabaonitas, que los colgaron en el monte ante el Señor. Los siete murieron en los primeros días de la cosecha, al principio de la recolección de la cebada."
,"10":"Rispá, hija de Ayá, extendió un saco en la roca y allí estuvo, desde el principio de la siega hasta que llegaron las lluvias, sin dejar que las aves del cielo se lanzasen sobre sus cadáveres durante el día ni las bestias del campo durante la noche."
,"11":"David se enteró de lo que había hecho Rispá, hija de Ayá, concubina de Saúl,"
,"12":"y fue a recoger los huesos de Saúl y de su hijo Jonatán, que los tenían los de Yabés de Galaad. Éstos los habían retirado de la muralla de Betsán, donde los habían colgado los filisteos el día que derrotaron a Saúl en Gelboé."
,"13":"David recogió los huesos de Saúl y de su hijo Jonatán y los juntó con los huesos de los que habían sido colgados."
,"14":"Y los enterraron todos en el territorio de Benjamín, en Selá, en el sepulcro de Quis, padre de Saúl. Se hizo todo lo que había ordenado el rey; y después de esto Dios tuvo piedad del país."
,"15":"De nuevo hubo guerra entre los filisteos e Israel. David con sus hombres acampó en Gob y lucharon contra los filisteos. David estaba cansado."
,"16":"Un gigante, descendiente de Rafá, que tenía una lanza que pesaba unos treinta kilos y ceñía una espada nueva, decía que iba a matar a David."
,"17":"Pero Abisay, hijo de Sarvia, vino en su ayuda, atacó al filisteo y lo mató. Entonces los hombres de David le conjuraron diciendo: 'Tú no volverás a salir con nosotros a la guerra, para que no apagues la luz de Israel'."
,"18":"Hubo otra batalla en Gob contra los filisteos, en la que Sibecay, el jusatita, mató a Saf, un descendiente de los gigantes."
,"19":"Hubo otra batalla en Gob contra los filisteos, y Eljanán, hijo de Yaír, de Belén, mató a Goliat, de Gat; el asta de su lanza era como un enjullo de tejedor."
,"20":"Se dio otra batalla en Gat, donde había un gigante que tenía veinticuatro dedos, seis en cada extremidad. También éste era descendiente de los gigantes."
,"21":"Él desafió a Israel, y Jonatán, hijo de Simá, hermano de David, lo mató."
,"22":"Estos cuatro gigantes eran descendientes de los gigantes de Gat, y cayeron en manos de David y de sus hombres."
}`)
	CurrentBook.AddChapter(22, `{
"1":"David dirigió al Señor este cántico, cuando le libró de todos sus enemigos y de Saúl:"
,"2":"'El Señor es mi roca, mi fortaleza, mi libertador,"
,"3":"mi Dios, mi roca, donde yo me refugio, mi escudo protector, mi salvación, mi asilo. Tú me salvas de la violencia."
,"4":"¡Alabado sea Dios! Yo le invoco,y salgo victorioso de mis enemigos."
,"5":"Las olas de la muerte me envolvían, los torrentes del averno me espantaban."
,"6":"Los lazos del abismo me envolvían, ante mí las trampas de la muerte."
,"7":"Clamé al Señor en mi angustia, hacia mi Dios alcé mi grito: y él escuchó mi voz desde su templo, mi grito llegó hasta sus oídos."
,"8":"Entonces se estremeció, tembló la tierra, las bases de los cielos vacilaron, retemblaron al estallido de su ira."
,"9":"Una humareda subía de sus narices,y de su boca un fuego destructor; de él salían carbones encendidos."
,"10":"Inclinó los cielos y bajó; una densa nube debajo de sus plantas."
,"11":"Montó sobre un querubín, emprendió el vuelo; sobre las alas del viento planeaba."
,"12":"Puso a su alrededor,la oscuridad por tienda, agua tenebrosa y densas nubes."
,"13":"Al resplandor de su presencia, se encienden carbones de fuego."
,"14":"El Señor tronó desde los cielos, el altísimo hizo sonar su voz."
,"15":"Lanzó sus flechas y los dispersó, fulminó sus rayos y los ahuyentó."
,"16":"Apareció el fondo de los mares, los cimientos de la tierra quedaron,al desnudo al fragor, oh Señor, de tu amenaza, al resollar del viento en tus narices."
,"17":"Desde arriba alargó la mano,y me agarró, me sacó de las aguas caudalosas."
,"18":"Me libró de un adversario poderoso, de enemigos más potentes que yo."
,"19":"En el día de mi desgracia me asaltaron, pero el Señor me sirvió de apoyo."
,"20":"Él me agarró, me puso a salvo; me libró, porque me amaba."
,"21":"El Señor me retribuye según mi justicia, me paga según la inocencia,de mis manos;"
,"22":"porque he seguido los caminos,del Señor y no he sido nunca infiel a Dios."
,"23":"Todas sus leyes han estado en mí, y no aparté de mí sus mandamientos."
,"24":"Fui para con él irreprochable, y estoy lejos de la injusticia."
,"25":"El Señor me retribuye según mi justicia, según la inocencia,que él ha visto en mis manos."
,"26":"Con el fiel tú eres fiel, con el hombre intachable,eres sin tacha;"
,"27":"con el sincero eres sincero, y con el astuto procedes,con astucia."
,"28":"Tú salvas al pueblo humilde,y humillas los ojos altaneros."
,"29":"Porque, oh Señor, tú eres mi lámpara, mi Dios ilumina mis tinieblas."
,"30":"Confiado en ti corro a la lucha, y con mi Dios asalto las murallas."
,"31":"El camino de Dios es perfecto, la palabra del Señor,se cumple siempre; escudo es de los que se refugian en él."
,"32":"¿Quién es Dios fuera del Señor?,¿Quién es roca fuera de nuestro Dios?"
,"33":"El Dios que me ciñe de poder,y hace seguro mi camino;"
,"34":"que asemeja mis pies a los del ciervo,y me mantiene firme en las alturas;"
,"35":"adiestra mis manos para la lucha,y mis brazos para tensar,arcos de bronce."
,"36":"Tú me das el escudo victorioso,y tu armadura me protege."
,"37":"Tú ensanchas el camino ante mis pasos,y mis pies no vacilan."
,"38":"Perseguí a mis enemigos, les di alcance; no me volví hasta acabar con ellos."
,"39":"Los derroté y no podían rehacerse, sucumbían debajo de mis pies."
,"40":"Me ceñiste de fortaleza en la batalla, aplastaste bajo mis pies a mis agresores."
,"41":"De mis enemigos,me hiciste ver la espalda,y exterminé a los que me odiaban."
,"42":"Gritaron, pero no hubo salvador; clamaron al Señor, pero no hubo respuesta."
,"43":"Yo los deshice como polvo al viento, los aplasté como el barro del camino."
,"44":"Tú me hiciste escapar,de las sediciones de los pueblos, a la cabeza de las naciones,me pusiste. Un pueblo que yo no conocía,ahora me sirve;"
,"45":"los hijos de extranjeros,forman mi corte, son todo oídos, me obedecen."
,"46":"Los hijos de extranjeros palidecen, y abandonan temblando sus refugios."
,"47":"¡Viva el Señor, bendita sea mi roca!,Alabado sea Dios, el Dios de mi victoria,"
,"48":"el Dios que me concede la venganza,y sojuzga a los pueblos a mis pies."
,"49":"Tú me libraste de furiosos enemigos, me haces triunfar sobre mis agresores, me libras del violento."
,"50":"Por eso, oh Señor, te alabaré entre las naciones, por eso cantaré,en honor de tu nombre."
,"51":"Él da grandes victorias a su rey,y otorga su favor a su mesías, a David y a su descendencia,para siempre'."
}`)
	CurrentBook.AddChapter(23, `{
"1":"Éstas son las últimas palabras de David: 'Oráculo de David, hijo de Jesé; oráculo del hombre enaltecido, del ungido del Dios de Jacob, del cantor de los cánticos de Israel."
,"2":"El espíritu del Señor ha hablado por mí, y su palabra está en mi lengua."
,"3":"El Dios de Jacob ha hablado, la roca de Israel me ha dicho: el que gobierna a los hombres,con justicia, el que gobierna con temor de Dios,"
,"4":"es como luz de la mañana,al levantarse el sol; una mañana sin nubes, que después,de la lluvia hace germinar la tierra."
,"5":"Mi casa es estable junto a Dios, porque hizo conmigo un pacto eterno, bien reglamentado,y garantizado en todo. Él hace que broten mis triunfos,y que se cumplan mis deseos."
,"6":"Pero los inicuos son todos,como espinas del desierto, que no se los agarra con la mano;"
,"7":"nadie los toca, a no ser con un hierro,o con el asta de la lanza, y son totalmente quemados en el fuego'."
,"8":"Éstos son los nombres de los héroes de David: Isbaal, el jacmonita, jefe de los tres, que blandió su lanza contra ochocientos hombres y los mató de una vez. "
,"9":"Después de él, Eleazar, hijo de Dodó, el ajojita, uno de los tres héroes; estaba con David en Pasdamín, cuando los filisteos se reunieron allí para la lucha y los israelitas se retiraron."
,"10":"Pero él se mantuvo firme y estuvo matando filisteos hasta que su mano se cansó y se le quedó pegada a la espada. El Señor otorgó aquel día una gran victoria y el ejército se volvió tras Eleazar, pero sólo para recoger el botín."
,"11":"Después de él, Samá, hijo de Elá, el ararita. Los filisteos se habían reunido en Lejí. Había allí un campo sembrado de lentejas. El ejército huyó ante los filisteos,"
,"12":"pero él se plantó en medio del campo, lo defendió y derrotó a los filisteos. Y el Señor otorgó una gran victoria."
,"13":"Tres de los treinta fueron en tiempo de la siega a ver a David en la cueva de Adulán, mientras los filisteos estaban acampados en el valle de Refaín."
,"14":"David estaba en el refugio, y había una guarnición de filisteos en Belén."
,"15":"David expresó este deseo: '¡Quién me diera de beber agua del pozo que está a la puerta de Belén!'."
,"16":"Entonces los tres héroes, abriéndose paso a través del campamento de los filisteos, sacaron agua del pozo que está a la puerta de Belén y se la ofrecieron a David; pero David no quiso beberla, y la derramó como ofrenda ante el Señor,"
,"17":"diciendo: '¡Líbreme Dios de hacer tal cosa! ¿Voy a beber yo la sangre de estos hombres que han traído el agua con riesgo de sus vidas?', y no quiso beberla. Esto hicieron los tres héroes."
,"18":"Abisay, hermano de Joab e hijo de Sarvia, era el jefe de los treinta. Él blandió la lanza contra trescientos, los mató y adquirió fama entre los treinta."
,"19":"Era el más famoso de los treinta y se convirtió en su jefe, pero no llegaba a los tres."
,"20":"Benayas, hijo de Yehoyadá, hombre valiente y rico en hazañas, de Cabseel, fue el que mató a los dos héroes de Moab; fue también el que bajó a la cisterna y mató en ella a un león un día de nieve."
,"21":"Mató también a un egipcio de gran talla. El egipcio blandía una lanza, y fue contra él con un palo; pero él le quitó la lanza al egipcio y le mató con su propia lanza."
,"22":"Esto hizo Benayas, hijo de Yehoyadá, y adquirió fama entre los treinta valientes;"
,"23":"era el más famoso de los treinta, pero no llegó a los tres. David le puso al frente de su guardia personal."
,"24":"Asael, hermano de Joab, era también de los treinta. Eljanán, hijo de Dodó, de Belén."
,"25":"Samá, de Jarod; Elicá, de Jarod;"
,"26":"Jeles, el peleteo; Irá, hijo de Iqués, de Técoa;"
,"27":"Abiezer, de Anatot; Libecay, de Jusá;"
,"28":"Salmón, de Ajoj; Mahray, de Netofá,"
,"29":"Jéleb, hijo de Baaná, de Netofá; Itay, hijo de Ribay, de Guibeá de Benjamín;"
,"30":"Benayas, de Piratón; Hiday, de los valles de Gaás;"
,"31":"Abibaal, arbatita; Azmávet, de Bajurín;"
,"32":"Elyajbá, saalbonita; Yasén, agunita;"
,"33":"Jonatán, hijo de Samá, ararita; Ajián, hijo de Sarar, ararita;"
,"34":"Elifélet, hijo de Ajitófel, de Guiló;"
,"35":"Yesray, de Carmelo; Paray, de Arab;"
,"36":"Yigal, hijo de Natán, de Sobá; Baní, el gadita;"
,"37":"Sélec, el amonita; Najray, de Beerot, escudero de Joab, hijo de Sarvia;"
,"38":"Irá, de Yatir; Gareb, de Yatir;"
,"39":"Urías, hitita. En total, treinta y siete."
}`)
	CurrentBook.AddChapter(24, `{
"1":"El Señor montó en cólera de nuevo contra los israelitas y excitó a David contra ellos, diciéndole: 'Vete, haz el censo de Israel y de Judá'."
,"2":"El rey dijo a Joab y a los jefes del ejército que estaban con él: 'Recorred todas las tribus de Israel, desde Dan hasta Berseba, y haced el censo del pueblo para que sepa yo su número'."
,"3":"Joab dijo al rey: 'Que el Señor, tu Dios, aumente la población otras cien veces más y que mi señor, el rey, lo vea con sus ojos; pero ¿para qué quiere esto mi señor, el rey?'."
,"4":"Pero el rey mantuvo su orden contra Joab y contra los jefes del ejército; y Joab y los jefes del ejército salieron de la presencia del rey para hacer el censo de la población de Israel."
,"5":"Pasaron el Jordán y, comenzando por Aroer y la ciudad que está al fondo del valle, fueron a Gad y hacia Yazer."
,"6":"Después fueron a Galaad y al país de los hititas, a Cades; pasaron a Dan, y desde Dan se volvieron hacia Sidón."
,"7":"Fueron luego a la fortaleza de Tiro y a todas las ciudades de los heveos y de los cananeos y terminaron en el Negueb de Judá, en Berseba."
,"8":"Recorrieron toda la tierra y, al cabo de nueve meses y veinte días, volvieron a Jerusalén."
,"9":"Joab dio al rey el resultado del censo del pueblo: había en Israel ochocientos mil hombres de guerra que blandían la espada, y en Judá, quinientos mil."
,"10":"Después de haber hecho el censo del pueblo, David sintió que le remordía la conciencia, y dijo al Señor: '¡He cometido un gran pecado por haber hecho esto! Señor, perdona el pecado de tu siervo, porque he obrado como un insensato'."
,"11":"Al día siguiente, cuando se levantó David, el Señor dijo al profeta Gad, a quien David consultaba:"
,"12":"'Anda y di a David: Te propongo tres castigos; elige uno de ellos, y yo lo llevaré a cabo'."
,"13":"Gad se presentó a David y le dijo: '¿Quieres que venga un hambre de tres años en tu país, o que tengas que huir durante tres meses ante tu enemigo que te perseguirá, o que haya tres días de peste en tu país? Elige y dime qué debo decir al que me envía'."
,"14":"David dijo a Gad: '¡Estoy en gran aprieto! Pongámonos en manos de Dios, porque es grande su misericordia, antes que caer en manos de los hombres'."
,"15":"Y David eligió la peste. Era el tiempo de la siega del trigo. Y el Señor envió la peste desde la mañana hasta el tiempo establecido; y murieron, desde Dan hasta Berseba, setenta mil hombres del pueblo. "
,"16":"El ángel extendió su mano sobre Jerusalén para exterminarla; pero el Señor se arrepintió del mal y dijo al ángel exterminador: 'Basta, retira tu mano'. El ángel del Señor estaba junto a la era de Ornán, el jebuseo."
,"17":"Cuando David vio al ángel que azotaba al pueblo, dijo al Señor: 'Yo soy quien ha pecado y ha obrado mal; pero estos otros, el rebaño, ¿qué han hecho? Que tu mano caiga sobre mí y sobre mi familia'."
,"18":"Aquel día Gad se presentó a David y le dijo: 'Anda y levanta un altar al Señor en la era de Ornán, el jebuseo'."
,"19":"Fue David como se lo había dicho Gad, cumpliendo la orden del Señor."
,"20":"Cuando Ornán vio al rey, que con sus servidores se dirigía hacia él, se adelantó y se postró ante él rostro en tierra."
,"21":"Ornán dijo: '¿Por qué viene mi señor, el rey, a su siervo?'. David respondió: 'A comprarte la era y levantar en ella un altar al Señor, para que el castigo se retire del pueblo'."
,"22":"Ornán dijo a David: 'Tómela mi señor, el rey, y ofrezca en ella lo que le agrade. Mira, ahí están los bueyes para el holocausto; los trillos y el yugo servirán de leña."
,"23":"El siervo de mi señor, el rey, se lo da todo al rey'. Y añadió: 'Que el Señor, tu Dios, te sea propicio'."
,"24":"El rey respondió a Ornán: 'No, yo quiero comprártelo a precio de plata. No quiero ofrecer al Señor, mi Dios, sacrificios que no me cuestan nada'. Y David compró la era y los bueyes en cincuenta monedas de plata."
,"25":"David levantó allí un altar al Señor y ofreció holocaustos y sacrificios de reconciliación. Entonces el Señor tuvo misericordia del país y retiró el castigo de Israel."
}`)

}
func ES_LSB_LoadVHEDChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"El año primero de Ciro, rey de Persia, en cumplimiento de su palabra anunciada por medio de Jeremías, el Señor impulsó a Ciro, rey de Persia, a que proclamara de viva voz y por escrito, en todo su reino, este edicto:"
,"2":"'Así habla Ciro, rey de Persia: El Señor, Dios del cielo, me ha dado todos los reinos de la tierra y me ha encargado de construirle un templo en Jerusalén, en Judá."
,"3":"El que de vosotros pertenezca a su pueblo, que su Dios lo ayude y que vaya a Jerusalén, en Judá, a construir el templo del Señor, Dios de Israel, el Dios que está en Jerusalén."
,"4":"Y a todos los supervivientes, dondequiera que vivan, ayúdeles la población del lugar en que residen, proporcionándoles plata, oro, bienes, ganado, así como otras ofrendas voluntarias para el templo del Señor que está en Jerusalén'."
,"5":"Los cabezas de familia de Judá y Benjamín, los sacerdotes y levitas, todos los que se sintieron movidos por el Señor, se dispusieron a ir a Jerusalén y reconstruir el templo del Señor."
,"6":"Y todos sus vecinos les proporcionaron toda clase de recursos: plata, oro, bienes, ganado, objetos preciosos, además de otras ofrendas voluntarias."
,"7":"El rey Ciro entregó los utensilios del templo del Señor que Nabucodonosor se había llevado de Jerusalén para el templo de su dios."
,"8":"Ciro, rey de Persia, le confió la tarea a Mitrídates, el tesorero, el cual se los entregó a Sesbasar, jefe de Judá."
,"9":"Éste era el inventario: treinta bandejas de oro y mil de plata, veintinueve cuchillos,"
,"10":"treinta copas de oro y cuatrocientas diez de plata y mil utensilios de otras clases."
,"11":"En total, cinco mil cuatrocientos objetos de oro y plata. Todo se lo llevó Sesbasar a Jerusalén al regresar del destierro de Babilonia."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Éstos son los israelitas de la provincia de Judá que regresaron del destierro de Babilonia, donde los había deportado Nabucodonosor, rey de Babilonia, y que volvieron a Jerusalén y Judá, cada uno a su ciudad."
,"2":"Vinieron con Zorobabel, Josué, Nehemías, Serayas, Reelayas, Mardoqueo, Bilsán, Mispar, Bigvay, Rejún, Baaná. Número de los hombres del pueblo de Israel: "
,"3":"descendientes de Parós, dos mil ciento setenta y dos;"
,"4":"de Sefatías, trescientos setenta y dos;"
,"5":"de Araj, setecientos setenta y cinco;"
,"6":"de Pajat Moab, es decir, de Josué y Joab, dos mil ochocientos doce;"
,"7":"de Elán, mil doscientos cincuenta y cuatro;"
,"8":"de Zatú, novecientos cuarenta y cinco;"
,"9":"de Zacay, setecientos sesenta;"
,"10":"de Baní, seiscientos cuarenta y dos;"
,"11":"de Bebay, seiscientos veintitrés;"
,"12":"de Azgad, mil doscientos veintidós;"
,"13":"de Adonicán, seiscientos sesenta y seis;"
,"14":"de Bigvay, dos mil cincuenta y seis;"
,"15":"de Adín, cuatrocientos cincuenta y cuatro;"
,"16":"de Ater, esto es, los descendientes de Ezequías, noventa y ocho;"
,"17":"de Besay, trescientos veintitrés;"
,"18":"de Yorá, ciento doce;"
,"19":"de Jasún, doscientos veintitrés;"
,"20":"de Guibar, noventa y cinco;"
,"21":"de Belén, ciento veintitrés;"
,"22":"de Netofá, cincuenta y seis;"
,"23":"de Anatot, ciento veintiocho;"
,"24":"de Azmávet, cuarenta y dos;"
,"25":"de Quiriat Yearín, Quefirá y Beerot, setecientos cuarenta y tres;"
,"26":"de Ramá y Gueba, seiscientos veintiuno;"
,"27":"de Micmás, ciento veintidós;"
,"28":"de Betel y Ay, doscientos veintitrés;"
,"29":"de Nebo, cincuenta y dos;"
,"30":"de Magbís, ciento cuarenta y seis;"
,"31":"del otro Elán, mil doscientos cincuenta y cuatro;"
,"32":"de Jarín, trescientos veinte;"
,"33":"de Lod, Jadid y Onó, setecientos veinticinco;"
,"34":"de Jericó, trescientos cuarenta y cinco;"
,"35":"de Senaá, tres mil seiscientos treinta."
,"36":"Sacerdotes: de Jedayas, de la casa de Josué, novecientos setenta y tres;"
,"37":"de Imer, mil cincuenta y dos;"
,"38":"de Pasjur, mil doscientos cuarenta y siete;"
,"39":"de Jarín, mil diecisiete."
,"40":"Levitas: de Josué, Cadmiel, de los hijos de Hodavías, setenta y cuatro."
,"41":"Cantores: de Asaf, ciento veintiocho."
,"42":"Porteros: de Salún, de Ater, de Talmón, de Acub, de Jatitá, de Sobay: ciento treinta y nueve."
,"43":"Sirvientes del templo: de Sijá, de Jasufá, de Tabaot,"
,"44":"de Querós, de Siahá, de Padón,"
,"45":"de Lebaná, de Jagabá, de Acub,"
,"46":"de Jagab, de Salmay, de Janán,"
,"47":"de Guidel, de Gajar, de Reayas,"
,"48":"de Resín, de Necodá, de Gazán,"
,"49":"de Uzá, de Paséaj, de Besay,"
,"50":"de Asná, de los meunitas, de los nefusitas,"
,"51":"de Bacbuc, de Jacufá, de Jarjur,"
,"52":"de Baslut, de Mejidá, de Jarsá,"
,"53":"de Barcós, de Siserá, de Témaj,"
,"54":"de Nesíaj, de Jatifá."
,"55":"Descendientes de los sirvientes de Salomón: de Sotay, de Soféret, de Perudá,"
,"56":"de Yaalá, de Darcón, de Guidel,"
,"57":"de Sefatías, de Jatil, de Poqueret-Hasebáyim, de Amí."
,"58":"Total de los sirvientes del templo y de los descendientes de los sirvientes de Salomón: trescientos noventa y dos."
,"59":"Los reseñados a continuación son los que regresaron de Tel-Mélaj, Tel-Jarsá, Querub, Adán e Imer, y que no pudieron demostrar que su familia y su estirpe eran de origen israelita:"
,"60":"los descendientes de Delayas, de Tobías, de Necodá: seiscientos cincuenta y dos."
,"61":"Y entre los sacerdotes: los descendientes de Jobayas, de Hacós, de Barzilay, el cual se había casado con una de las hijas de Barzilay, el galaadita, cuyo nombre adoptó."
,"62":"Éstos buscaron sus títulos genealógicos; pero, al no encontrarlos, fueron excluidos del sacerdocio,"
,"63":"y el gobernador les prohibió comer alimentos sagrados hasta que se presentase un sacerdote para consultar las suertes."
,"64":"El total de la comunidad era de cuarenta y dos mil trescientas sesenta personas,"
,"65":"sin contar sus esclavos y esclavas, que eran siete mil trescientos treinta y siete, más doscientos cantores y cantoras."
,"66":"Tenían, además, setecientos treinta y seis caballos, doscientos cuarenta y cinco mulos,"
,"67":"cuatrocientos treinta y cinco camellos y seis mil setecientos veinte asnos."
,"68":"Algunos de los cabezas de familia, al llegar al templo del Señor, en Jerusalén, hicieron generosos donativos para reconstruir el templo del Señor en su emplazamiento anterior."
,"69":"Con arreglo a sus posibilidades, entregaron al tesoro de la obra sesenta y un mil dracmas de oro, cinco mil minas de plata y cien túnicas sacerdotales."
,"70":"Los sacerdotes, los levitas y una parte del pueblo se establecieron en Jerusalén; los porteros, los cantores, los sirvientes del templo y los demás israelitas, en sus ciudades respectivas."
}`)
	CurrentBook.AddChapter(3, `{
"1":"El mes séptimo, instalados ya los israelitas en sus ciudades, el pueblo se reunió como un solo hombre en Jerusalén."
,"2":"Josué, hijo de Yosadac, con sus hermanos sacerdotes, y Zorobabel, hijo de Sealtiel, con sus hermanos, se pusieron a reconstruir el altar del Dios de Israel para ofrecer en él los holocaustos, como está escrito en la ley de Moisés, hombre de Dios."
,"3":"Levantaron el altar sobre sus mismos cimientos, a pesar del miedo que tenían a la población del país, y ofrecieron en él holocaustos al Señor: los holocaustos de la mañana y de la tarde."
,"4":"Celebraron también la fiesta de los tabernáculos, según está prescrito, ofreciendo cada día el número de holocaustos ritualmente establecidos."
,"5":"Ofrecieron el holocausto diario, los correspondientes a los novilunios y a las solemnidades consagradas al Señor, así como los que ofrecían voluntariamente al Señor."
,"6":"Desde el día primero del séptimo mes comenzaron a ofrecer holocaustos al Señor, aunque todavía no se habían echado los cimientos del templo del Señor."
,"7":"Dieron dinero a los canteros y a los carpinteros; mandaron víveres, bebidas y aceite a los sidonios y a los tirios para que enviasen por mar madera de cedro desde el Líbano a Jafa, conforme a la autorización que les había dado Ciro, rey de Persia."
,"8":"El mes segundo del año segundo de su llegada al templo de Dios en Jerusalén, Zorobabel, hijo de Sealtiel; Josué, hijo de Yosadac, con el resto de sus hermanos, sacerdotes y levitas, y todos los que habían vuelto del destierro a Jerusalén, pusieron manos a la obra y encargaron a los levitas de veinte años para arriba la dirección de los trabajos del templo del Señor."
,"9":"Josué con sus hijos y hermanos, Cadmiel y sus hijos, Hodavías y los hijos de Jenadad con sus hijos y hermanos levitas, se presentaron como un solo hombre para dirigir a los que trabajaban en el templo de Dios."
,"10":"Cuando los albañiles echaron los cimientos del templo del Señor, se presentaron los sacerdotes con sus ornamentos y sus trompetas, y los levitas, hijos de Asaf, con sus címbalos, para alabar al Señor, conforme a las disposiciones de David, rey de Israel."
,"11":"Alababan y daban gracias al Señor, y se respondía: 'Porque es bueno, porque es eterno su amor a Israel'. Y todo el pueblo prorrumpía en fuertes gritos de júbilo alabando al Señor porque se habían echado los cimientos del templo del Señor."
,"12":"Muchos de los sacerdotes, levitas y cabezas de familia, ya ancianos, que habían visto el primer templo y ahora veían con sus propios ojos que se echaban los cimientos de este otro templo, lloraban estrepitosamente, mientras que otros muchos daban gritos de alegría y júbilo."
,"13":"Nadie podía distinguir los acentos de júbilo de los acentos del llanto de la gente, porque el pueblo lanzaba grandes gritos y el estrépito se oía desde muy lejos."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Cuando los enemigos de Judá y Benjamín se enteraron de que los que habían vuelto del destierro estaban reconstruyendo el templo del Señor, Dios de Israel,"
,"2":"se presentaron a Zorobabel, a Josué y a los cabezas de familia y les dijeron: 'Dejadnos colaborar con vosotros en la construcción, ya que nosotros, lo mismo que vosotros, adoramos a vuestro Dios y le ofrecemos sacrificios desde cuando Asaradón, rey de Asiria, nos trajo aquí'."
,"3":"Pero Zorobabel, Josué y los otros cabezas de familia de Israel les contestaron: 'Eso no puede ser; debemos construirlo nosotros solos para el Señor, Dios de Israel, como nos ha ordenado Ciro, rey de Persia'."
,"4":"Entonces la población del país se puso a desanimar al pueblo de Judá y a meterles miedo, a fin de que dejasen la construcción."
,"5":"Sobornaron además contra ellos a algunos funcionarios del rey para hacer fracasar su proyecto. Este estado de cosas duró todo el tiempo que aún reinó Ciro, rey de Persia, hasta el reinado de Darío, rey de Persia."
,"6":"Al comienzo del reinado de Jerjes escribieron una denuncia contra los habitantes de Judá y Jerusalén."
,"7":"En tiempo de Artajerjes, Bislán, Mitrídates, Tabeel y sus demás colegas hicieron otra denuncia a Artajerjes, rey de Persia. El documento estaba escrito en caracteres arameos y en lengua aramea."
,"8":"Rejún, gobernador, y Simsay, secretario, escribieron al rey Artajerjes la siguiente carta contra Jerusalén:"
,"9":"'El gobernador Rejún, el secretario Simsay y sus demás colegas: los jueces y los legados, funcionarios persas, las gentes de Uruk, de Babilonia, de Susa, es decir, los elamitas,"
,"10":"y el resto de la población que el grande e ilustre Asurbanipal deportó y estableció en las ciudades de Samaría y en las otras regiones de allende el río...'."
,"11":"Copia de la carta: 'Al rey Artajerjes, tus servidores, las gentes de Transeufratina:"
,"12":"Sepa el rey que los judíos que vinieron y se establecieron en Jerusalén están reconstruyendo esta ciudad rebelde y malvada; quieren levantar las murallas y ya han echado los cimientos."
,"13":"Sepa el rey que si esta ciudad se reconstruye y se restauran sus murallas, ellos no pagarán más tributo ni impuestos, ni derechos de paso, y el erario regio se resentirá de ello."
,"14":"Ahora bien, nosotros, que vivimos a expensas del palacio, no podemos tolerar que se desprecie al rey de esta manera, por lo que remitimos al rey esta información."
,"15":"Investíguese en el libro de las memorias de tus padres; en ese libro comprobarás que esta ciudad es rebelde y funesta para los reyes y las provincias, y que en ella ya desde tiempos antiguos se han fomentado siempre insurrecciones. Por este motivo justamente fue destruida."
,"16":"Nosotros advertimos al rey que si esta ciudad se reconstruye y se restauran sus murallas, bien pronto no tendrás tú territorio alguno en Transeufratina'."
,"17":"El rey envió esta respuesta: 'Al gobernador Rejún, al secretario Simsay y a sus demás colegas residentes en Samaría y en los demás lugares de Transeufratina: ¡Salud!"
,"18":"La carta que me enviasteis ha sido leída puntualmente en mi presencia."
,"19":"Ordené que se investigara, y se ha comprobado efectivamente que esa ciudad se ha rebelado desde tiempos antiguos contra los reyes, y que en ella se han fomentado revueltas e insurrecciones;"
,"20":"que ha habido en Jerusalén reyes poderosos cuyo dominio se extendía sobre todo el territorio de Transeufratina y que recibían tributos, impuestos y derechos de paso."
,"21":"Ordenad, pues, que esos hombres suspendan su trabajo para que la ciudad no se reconstruya hasta que yo no ordene otra cosa."
,"22":"Procurad no ser negligentes en esto, no sea que el mal aumente en perjuicio de los reyes'."
,"23":"Tan pronto como leyeron la carta del rey Artajerjes, el gobernador Rejún, el secretario Simsay y sus colegas fueron inmediatamente a Jerusalén y obligaron por la fuerza a los judíos a parar las obras."
,"24":"Así tuvieron que suspender la reconstrucción del templo del Señor en Jerusalén, que no pudo ser reanudada hasta el año segundo del reinado de Darío, rey de Persia."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Los profetas Ageo y Zacarías, hijo de Idó, comenzaron a profetizar a los judíos residentes en Jerusalén y Judá en el nombre del Dios de Israel, y a su impulso"
,"2":"Zorobabel, hijo de Sealtiel, y Josué, hijo de Yosadac, decidieron reanudar la reconstrucción del templo de Dios en Jerusalén, con la asistencia de los dos profetas de Dios, que estaban con ellos animándoles."
,"3":"Tatenay, gobernador de Transeufratina, Setar Boznay y sus colegas fueron a decirles: '¿Quién os ha autorizado a reconstruir el templo y la muralla?'."
,"4":"Y añadieron: '¿Cómo se llaman los hombres que están construyendo este templo?'."
,"5":"Pero los ojos de su Dios velaban sobre los dirigentes judíos, y no les obligaron a parar la obra hasta que se mandara un informe a Darío y se recibiera su respuesta."
,"6":"Copia de la carta que Tatenay, gobernador de Transeufratina, Setar Boznay y sus colegas, las autoridades de Transeufratina, remitieron al rey Darío."
,"7":"Se decía: 'Al rey Darío: ¡Paz perfecta!"
,"8":"Sepa el rey que nosotros hemos ido a la provincia de Judá, al templo del gran Dios, que se está reconstruyendo con piedras de sillería; ahora están recubriendo de madera las paredes. La obra se va haciendo con esmero y a buen ritmo."
,"9":"Nosotros hemos preguntado a los dirigentes quién les había autorizado a reconstruir el templo y la muralla."
,"10":"Les hemos preguntado además cómo se llamaban, para comunicártelo a ti y darte por escrito los nombres de las personas que están al frente de ellos."
,"11":"Y nos han dado esta respuesta: Nosotros adoramos al Dios del cielo y de la tierra, y por eso estamos reconstruyendo el templo que fue construido y terminado hace muchos años por un gran rey de Israel."
,"12":"Pero nuestros padres irritaron al Dios del cielo, y él los entregó en manos del caldeo Nabucodonosor, rey de Babilonia, el cual destruyó este templo y deportó el pueblo a Babilonia."
,"13":"Sin embargo, en el primer año de su reinado, Ciro, rey de Babilonia, promulgó un edicto ordenando que fuese reconstruido este templo de Dios."
,"14":"Además, el rey Ciro mandó sacar del templo de Babilonia los utensilios de oro y plata del templo de Dios, que Nabucodonosor se había llevado del templo de Jerusalén para ponerlos en el templo de Babilonia, y se los entregó a un hombre llamado Sesbasar, a quien había nombrado gobernador."
,"15":"Y le dijo: Toma estos utensilios y llévalos al templo que está en Jerusalén, y que el templo de Dios sea reconstruido en el mismo sitio."
,"16":"Sesbasar vino y echó los cimientos del templo de Dios en Jerusalén, que se viene reconstruyendo desde aquel día hasta el presente, pero aún no está terminado."
,"17":"Si le parece bien al rey, investíguese en el archivo real de Babilonia, para ver si es verdad que la reconstrucción del templo de Dios en Jerusalén fue autorizada por el rey Ciro; y, en consecuencia, se nos remita la decisión del monarca sobre el particular'."
}`)
	CurrentBook.AddChapter(6, `{
"1":"El rey Darío ordenó que se hiciera investigación en Babilonia, en los depósitos donde se guardaban los archivos,"
,"2":"y se encontró en Ecbatana, la fortaleza situada en la provincia de Media, un rollo en el que estaba registrado lo siguiente: 'En memoria."
,"3":"Año primero del rey Ciro. El rey Ciro ha decretado respecto al templo de Dios en Jerusalén: Que sea reconstruido el templo en el mismo sitio, como lugar en el que se ofrezcan sacrificios. Tendrá treinta metros de alto y treinta de ancho,"
,"4":"tres hileras de piedras de sillería y una de madera; los gastos serán costeados por la casa del rey."
,"5":"Además, los utensilios de oro y plata del templo de Dios, que Nabucodonosor sacó del templo de Jerusalén y se llevó a Babilonia, serán restituidos, devueltos al templo de Jerusalén y colocados en su sitio propio en el templo de Dios."
,"6":"Así pues, tú, Tatenay, gobernador de Transeufratina, Setar Boznay y vosotros, sus colegas, las autoridades de Transeufratina, retiraos de Jerusalén,"
,"7":"dejad continuar las obras de ese templo de Dios al gobernador de Judá y a los dirigentes judíos, que deben reconstruir este templo de Dios en su mismo sitio."
,"8":"Éstas son mis órdenes acerca de lo que debéis hacer con esos dirigentes judíos para la reconstrucción del templo de Dios: de los ingresos reales procedentes de los tributos de Transeufratina ha de proveerse puntualmente a esos hombres el dinero necesario para que no se interrumpan las obras."
,"9":"Y todo lo que se precise para los holocaustos al Dios del cielo, novillos, carneros y corderos, sal, vino y aceite, según las exigencias de los sacerdotes de Jerusalén, se les dará cada día sin falta,"
,"10":"para que ofrezcan sacrificios agradables al Dios del cielo y rueguen por la vida del rey y de sus hijos."
,"11":"Ordeno, además, que a todo aquel que no cumpla este edicto se arranque una viga de su casa, se le amarre a ella y se le azote, y su casa sea reducida por este delito a un montón de escombros."
,"12":"Y el Dios que ha establecido allí su nombre aplaste a todo aquel rey o pueblo que trate de transgredir esto destruyendo ese templo de Dios en Jerusalén. Yo, Darío, he promulgado este decreto; sea ejecutado puntualmente'."
,"13":"Tatenay, gobernador de Transeufratina, Setar Boznay y sus colegas ejecutaron puntualmente lo que el rey Darío había ordenado."
,"14":"Así los dirigentes judíos continuaron las obras con éxito, confortados por la palabra inspirada de los profetas Ageo y Zacarías, hijo de Idó. Y llevaron a feliz término la reconstrucción, en conformidad con el mandato del Dios de Israel y con la orden de Ciro, de Darío y de Artajerjes, reyes de Persia."
,"15":"El templo fue terminado el día tres del mes de adar, el año sexto del reinado de Darío."
,"16":"Los israelitas, sacerdotes, levitas y demás repatriados celebraron con júbilo la dedicación del templo de Dios."
,"17":"Ofrecieron para la dedicación de este templo de Dios cien novillos, doscientos carneros, cuatrocientos corderos y, como sacrificio por el pecado de todo Israel, doce machos cabríos, conforme al número de las tribus de Israel."
,"18":"Organizaron los turnos de los sacerdotes y las clases de los levitas para el servicio del templo de Dios, en Jerusalén, conforme está escrito en el libro de Moisés."
,"19":"Los repatriados celebraron la pascua el día catorce del primer mes;"
,"20":"los sacerdotes y levitas se habían purificado: todos eran puros; ofrecieron el sacrificio de la pascua por todos los repatriados, por sus hermanos, los sacerdotes, y por ellos mismos."
,"21":"Los israelitas repatriados comieron el banquete pascual con todos aquellos que se habían separado de la impureza de los paganos del país y se habían unido a ellos para buscar al Señor, Dios de Israel."
,"22":"Celebraron con júbilo la fiesta de los panes sin levadura durante siete días, porque el Señor les había llenado de alegría al mover el corazón del rey de Asiria para ayudarles en las obras del templo de Dios, el Dios de Israel."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Después de estos acontecimientos, en el reinado de Artajerjes, rey de Persia, Esdras, hijo de Serayas, de Azarías, de Jelcías,"
,"2":"de Salún, de Sadoc, de Ajitub,"
,"3":"de Amarías, de Azarías, de Merayot,"
,"4":"de Zerajías, de Uzí, de Buquí,"
,"5":"de Abisúa, de Fineés, de Eleazar, hijo del sumo sacerdote Aarón,"
,"6":"volvió de Babilonia. Era un escriba experto en la ley de Moisés, dada por el Señor, Dios de Israel. El rey le concedió todo lo que deseaba, porque el Señor, su Dios, estaba con él."
,"7":"Fueron también a Jerusalén, el año siete del rey Artajerjes, otros israelitas: sacerdotes, levitas, cantores, porteros y sirvientes del templo."
,"8":"Esdras llegó a Jerusalén el mes quinto del año siete del rey."
,"9":"Salió de Babilonia el día uno del primer mes, y el día uno del quinto mes, con la ayuda de Dios, llegó a Jerusalén,"
,"10":"porque Esdras se había dedicado a estudiar la ley del Señor, a ponerla en práctica y a enseñar la ley y las costumbres en Israel."
,"11":"Copia del decreto que el rey Artajerjes entregó a Esdras, sacerdote y escriba experto en la ley del Señor y en sus prescripciones sobre Israel:"
,"12":"'Artajerjes, rey de reyes, a Esdras, sacerdote y escriba experto en la ley de Dios del cielo: ¡Salud!"
,"13":"He decretado que todos los israelitas de mi reino, sacerdotes y levitas, que quieran volver a Jerusalén, vayan contigo,"
,"14":"ya que tú eres el enviado del rey y de sus siete consejeros para supervisar en Judá y Jerusalén el cumplimiento de la ley de tu Dios, que está en tus manos;"
,"15":"y para llevar la plata y el oro que el rey y sus consejeros han ofrecido voluntariamente al Dios de Israel, cuya morada está en Jerusalén,"
,"16":"así como toda la plata y el oro que puedas reunir en toda la provincia de Babilonia, además de las ofrendas voluntarias del pueblo y los sacerdotes para el templo de su Dios en Jerusalén."
,"17":"Con este dinero comprarás novillos y corderos con las correspondientes ofrendas de pan y de vino para ofrecerlo luego en el altar del templo de vuestro Dios, en Jerusalén."
,"18":"Y con la plata y el oro que os sobre, haced lo que mejor os parezca a ti y a tus hermanos, conforme a la voluntad de vuestro Dios."
,"19":"Los utensilios que se te han entregado para el culto del templo de tu Dios, ponlos tú mismo delante de tu Dios, en Jerusalén."
,"20":"Si, a tu parecer, se necesita todavía alguna otra cosa para el templo de tu Dios, recibirás el dinero de los tesoros reales."
,"21":"Y yo, el rey Artajerjes, ordeno a todos los tesoreros de Transeufratina que todo lo que os pida Esdras, sacerdote y escriba experto en la ley del Dios del cielo, se lo deis puntualmente,"
,"22":"hasta tres mil cuatrocientos kilos de plata, cuarenta y cinco toneladas de trigo, cuatro mil quinientos litros de vino cuatro mil quinientos de aceite; la sal se le dará sin tasa."
,"23":"Todo lo dispuesto por el Dios del cielo debe ser cumplido puntualmente para el templo del Dios del cielo, a fin de que no caiga su cólera sobre el reino del rey y de sus hijos."
,"24":"Os hacemos saber también que a ninguno de los sacerdotes, levitas, cantores, porteros, sirvientes del templo, en una palabra, a ninguno de los que prestan servicio en este templo de Dios, se le podrá imponer tributo, impuesto o derecho de paso."
,"25":"Y tú, Esdras, conforme a la sabiduría de tu Dios que posees, establecerás jueces y magistrados que administren justicia a todo el pueblo de Transeufratina, es decir, a todos los que conocen la ley de tu Dios. A quienes la ignoran, habréis de enseñársela."
,"26":"Y todo aquel que no cumpla la ley de tu Dios, que es también la ley del rey, será severamente castigado con la muerte, con el destierro, con confiscación de bienes o con la cárcel'."
,"27":"¡Bendito sea el Señor, Dios de nuestros padres, que tan bien dispuso el corazón del rey para glorificar el templo del Señor en Jerusalén,"
,"28":"que me granjeó el favor del rey, de sus consejeros y de todos los funcionarios reales más influyentes! Así yo, animado por la ayuda del Señor, mi Dios, convoqué a los israelitas más importantes para que vinieran conmigo."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Éstos son, con su genealogía, los cabezas de familia que vinieron de Babilonia conmigo en el reinado de Artajerjes."
,"2":"De los descendientes de Fineés, Guersón; de los de Itamar, Daniel; de los de David, Jatús, hijo de Secanías;"
,"3":"de los de Parós, Zacarías; con él fueron registrados ciento cincuenta varones."
,"4":"De los de Pajat Moab, Elyoenay, hijo de Zerajías, y con él doscientos varones."
,"5":"De los de Zatú, Secanías, hijo de Yacaziel, y con él trescientos varones."
,"6":"De los de Adín, Ebed, hijo de Jonatán, y con él cincuenta varones."
,"7":"De los de Elán, Isaías, hijo de Atalías, y con él setenta varones."
,"8":"De los de Sefatías, Zebadías, hijo de Miguel, y con él ochenta varones."
,"9":"De los de Joab, Abdías, hijo de Yejiel, y con él doscientos dieciocho varones."
,"10":"De los de Baní, Selomit, hijo de Yosifías, y con él ciento sesenta varones."
,"11":"De los hijos de Bebay, Zacarías, hijo de Bebay, y con él veintiocho varones."
,"12":"De los de Azgad, Yojanán, hijo de Hacatán, y con él ciento diez varones."
,"13":"De los de Adonicán, los últimos, cuyos nombres son éstos: Elifélet, Yeiel y Semayas, y con ellos sesenta varones."
,"14":"Y de los de Bigvay, Utay, hijo de Zabud, y con él setenta varones."
,"15":"Yo los reuní junto al río que corre hacia Ahavá, donde estuvimos acampados tres días. Al pasar revista a la expedición, encontré laicos y sacerdotes, pero ningún levita."
,"16":"Entonces llamé a los jefes Eliezer, Ariel, Semayas, Elnatán, Jarib, Natán, Zacarías y Mesulán, hombres sensatos,"
,"17":"y los mandé al jefe Idó, en Casifías, y les indiqué lo que debían decirle a él y a sus hermanos, establecidos en Casifías: que nos mandaran ministros para el templo de nuestro Dios."
,"18":"Y gracias a la ayuda bondadosa de nuestro Dios, nos trajeron a Serebías, un hombre prudente, descendiente de Majlí, de Leví, de Israel, con sus hijos y hermanos: dieciocho personas en total;"
,"19":"nos trajeron también a Jasabías y a su hermano Isaías, descendientes de Merarí, con sus hijos respectivos: veinte personas en total;"
,"20":"y de los sirvientes del templo, a quienes David y los jefes habían destinado al servicio de los levitas, doscientos veinte. Todos éstos fueron registrados con sus nombres."
,"21":"Allí, a orillas del río Ahavá, proclamé un ayuno para humillarnos delante de nuestro Dios y pedirle un viaje feliz para nosotros, nuestras familias y toda nuestra hacienda."
,"22":"Pues me había avergonzado de solicitar del rey tropa y gente de a caballo para protegernos de eventuales enemigos durante el viaje, después de haber hablado al rey en estos términos: 'La mano de nuestro Dios se extiende para bendecir a todos los que lo buscan; su poder y su furor caen sobre todos los que lo abandonan'."
,"23":"Ayunamos invocando a nuestro Dios por esto, y él nos atendió."
,"24":"Escogí a doce jefes de los sacerdotes, a Serebías y Jasabías, y a diez de sus hermanos;"
,"25":"les pesé la plata, el oro y los utensilios que el rey, sus consejeros, sus príncipes y todos los israelitas que se encontraban allí habían ofrecido para el templo de nuestro Dios."
,"26":"Lo pesé y les entregué veintidós mil kilos de plata; utensilios de plata que pesaban tres mil cuatrocientos kilos; tres mil cuatrocientos kilos de oro;"
,"27":"veinte copas de oro, que pesaban ocho kilos, y dos vasos de hermoso cobre dorado, preciosos como el oro."
,"28":"Y les dije: 'Vosotros estáis consagrados al Señor, y sagrados son también estos utensilios; esta plata y este oro son una ofrenda voluntaria al Señor, Dios de nuestros padres."
,"29":"Estad atentos y guardadlos bien, hasta que los peséis ante los jefes de los sacerdotes, los levitas y los cabezas de familia de Israel, en Jerusalén, en los aposentos del templo del Señor'."
,"30":"Los sacerdotes y los levitas tomaron la plata, el oro y los utensilios para llevarlos a Jerusalén, al templo de nuestro Dios."
,"31":"Por fin partimos del río Ahavá hacia Jerusalén el día doce del primer mes; nuestro Dios nos protegió durante el viaje, y nos libró de toda violencia de enemigos y saqueadores."
,"32":"Llegamos a Jerusalén y descansamos allí tres días,"
,"33":"al cabo de los cuales se pesó la plata, el oro y los utensilios en el templo de nuestro Dios y se entregó todo al sacerdote Merimot, hijo de Urías, a quien acompañaba Eleazar, hijo de Fineés; estaban con ellos los levitas Yozabad, hijo de Josué, y Noadías, hijo de Binuy."
,"34":"Se contó, se pesó y se hizo el inventario de todo."
,"35":"Los repatriados ofrecieron holocaustos al Dios de Israel: doce novillos por todo Israel, noventa y seis carneros, setenta y siete corderos y doce machos cabríos por el pecado: todo en holocausto al Señor."
,"36":"Y se entregaron los decretos del rey a los sátrapas reales y a los gobernadores de Transeufratina, los cuales ayudaron al pueblo y al templo de Dios."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Al terminar aquello, se me presentaron los jefes para decirme: 'El pueblo de Israel, los sacerdotes y los levitas no se han separado de las gentes del país y han incurrido en las prácticas horrendas de los cananeos, hititas, fereceos, jebuseos, amonitas, moabitas, egipcios e idumeos."
,"2":"Ellos y sus hijos se han casado con las hijas de esas gentes mezclando la raza santa con las gentes del país, y los jefes y los magistrados han sido los primeros en incurrir en tal prevaricación'."
,"3":"Al oír esto, rasgué mis vestiduras y mi manto, me rasuré los pelos de la cabeza y la barba y me senté abrumado."
,"4":"Todos los temerosos de las palabras del Dios de Israel se reunieron conmigo al conocer la prevaricación de los repatriados. Yo permanecí sentado, abrumado hasta la hora del sacrificio de la tarde."
,"5":"A la hora del sacrificio de la tarde salí de mi abatimiento y, con los vestidos y el manto rasgados, me postré de rodillas, extendí mis manos hacia el Señor, mi Dios,"
,"6":"y exclamé: 'Dios mío, estoy confundido y me avergüenzo de levantar mi rostro hacia ti, porque nuestras iniquidades sobrepasan nuestra cabeza, y nuestros delitos llegan hasta el cielo."
,"7":"Desde los días de nuestros padres hasta hoy hemos pecado gravemente. Por nuestras iniquidades, nosotros, nuestros reyes y nuestros sacerdotes hemos sido entregados a los reyes extranjeros, a la espada, a la esclavitud, al saqueo, al oprobio, como todavía ahora sucede."
,"8":"A pesar de todo, ahora el Señor nos ha concedido la gracia de dejarnos un resto y de darnos un asilo en su tierra santa. El Señor ha iluminado nuestros ojos y nos ha dado un respiro en medio de nuestra esclavitud."
,"9":"Porque somos esclavos, pero nuestro Dios no nos ha desamparado en nuestra esclavitud; antes bien, nos ha granjeado el favor de los reyes de Persia, nos ha dado un respiro para reconstruir el templo de nuestro Dios y restaurar sus ruinas y nos ha procurado un refugio seguro en Judá y en Jerusalén."
,"10":"Pero ahora, oh Dios nuestro, ¿qué podemos decir? Después de tantos favores hemos abandonado tus mandamientos,"
,"11":"que nos habías prescrito por medio de tus siervos los profetas diciendo: El país que vais a ocupar es un país inmundo por la inmundicia de las gentes del país y las abominaciones de las que le han llenado de un extremo a otro con su impureza."
,"12":"Por tanto, no caséis a vuestras hijas con sus hijos, ni a vuestros hijos con sus hijas; no procuréis su paz ni su prosperidad, con el fin de que podáis haceros fuertes vosotros, gozar de los bienes de este país y dejarlos en herencia a vuestros hijos para siempre."
,"13":"Y después de todo lo que nos ha sobrevenido a causa de nuestras maldades y grandes culpas -y eso que tú, oh Dios nuestro, nos has imputado menos culpa de la que teníamos y nos has dejado este resto que somos-,"
,"14":"¿hemos de volver a violar tus mandamientos uniéndonos con estas gentes abominables? ¿No te irritarías entonces contra nosotros hasta exterminarnos, sin dejar siquiera este pequeño resto?"
,"15":"¡Oh Señor, Dios de Israel!, gracias a tu justicia hemos podido subsistir como un resto de supervivientes. Nos reconocemos culpables ante ti, somos indignos de estar en tu presencia'."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Mientras Esdras oraba y hacía esta confesión llorando y postrado ante el templo de Dios, se congregó junto a él una gran multitud de israelitas, mujeres y niños; todos lloraban amargamente."
,"2":"Entonces Secanías, hijo de Yejiel, descendiente de Elán, tomó la palabra y dijo a Esdras: 'Hemos sido infieles a Dios casándonos con mujeres extranjeras de naciones paganas. No obstante, todavía le queda una esperanza a Israel."
,"3":"Hagamos ahora con nuestro Dios un pacto de despedir a todas estas mujeres extranjeras y a los hijos que hemos tenido con ellas, si así te parece a ti y a los temerosos de los mandamientos de nuestro Dios; que se cumpla la ley."
,"4":"Levántate, pues este asunto te incumbe a ti; nosotros estamos contigo. ¡Ánimo, y manos a la obra!'."
,"5":"Esdras se levantó e hizo jurar a los jefes de los sacerdotes y los levitas y a todo Israel que actuarían así. Y ellos lo juraron."
,"6":"Esdras se retiró del templo de Dios y se fue al aposento de Jojanán, hijo de Eliasib, donde pasó la noche sin comer pan ni beber agua; tan desolado estaba con la prevaricación de los repatriados."
,"7":"Se publicó después un bando en Judá y Jerusalén para que todos los repatriados se reunieran en Jerusalén,"
,"8":"bajo la amenaza de confiscación de todos sus bienes y exclusión de la comunidad a todo aquel que no se presentara en el término de tres días, según la decisión de los jefes y los ancianos."
,"9":"A los tres días, se reunieron en Jerusalén todos los hombres de Judá y Benjamín. Era el día veinte del mes noveno. Todo el pueblo se situó en la plaza del templo de Dios, temblando por la gravedad del caso y porque llovía copiosamente."
,"10":"El sacerdote Esdras se levantó y dijo: 'Vosotros habéis prevaricado casándoos con mujeres extranjeras; a tantos otros delitos de Israel habéis añadido también éste."
,"11":"Reconoced vuestra culpa ante el Señor, Dios de nuestros padres, y cumplid su voluntad. Separaos de las gentes paganas y de las mujeres extranjeras'."
,"12":"Y toda la comunidad respondió en alta voz: 'Haremos lo que nos dices."
,"13":"Pero el pueblo es numeroso y estamos además en la estación de las lluvias y no podemos soportar la intemperie en un asunto como éste, que no es cosa de uno o dos días, ya que somos muchos los que hemos incurrido en este pecado."
,"14":"Que se queden nuestros jefes en representación de toda la comunidad, y todos los que se hayan casado con mujeres extranjeras vendrán en días señalados, acompañados de las autoridades y de los jueces de cada ciudad, hasta que hayamos apartado de nosotros el furor de nuestro Dios por este pecado'."
,"15":"Sólo Jonatán, hijo de Asael, y Yajzías, hijo de Tiquá, se opusieron a esta proposición, apoyados por Mesulán y el levita Sabtay."
,"16":"Los repatriados hicieron como se había propuesto. El sacerdote Esdras escogió como colaboradores a los cabezas de familia, según sus casas patriarcales, todos ellos designados nominalmente. Iniciaron éstos sus revisiones para examinar la situación el día uno del décimo mes."
,"17":"Y el día uno del primer mes habían terminado ya de contar a todos aquellos que se habían casado con mujeres extranjeras."
,"18":"Ésta es la relación de los miembros del sacerdocio que se habían casado con mujeres extranjeras. Entre los descendientes de Josué, hijo de Yosadac, y entre sus hermanos: Maasías, Eliezer, Yarib y Guedalías."
,"19":"Éstos se comprometieron bajo juramento a despedir a sus mujeres; y para reparar su culpa ofrecieron un carnero en sacrificio por el pecado."
,"20":"Entre los descendientes de Imer: Jananí y Zebadías."
,"21":"Entre los descendientes de Jarín: Maasaías, Elías, Semayas, Yejiel y Ozías."
,"22":"Entre los descendientes de Pasjur: Elyoenay, Maasías, Ismael, Natanael, Yozabad y Elasá."
,"23":"Entre los levitas: Yozabad, Simeí, Quelayas, esto es, Quelita; Petajías, Judá y Eliezer."
,"24":"Entre los cantores: Eliasib. Entre los porteros: Salún, Telén y Urí."
,"25":"Y entre los israelitas: De los descendientes de Parós: Ramías, Yidías, Malaquías, Miyamín, Eleazar, Malaquías y Benayas."
,"26":"De los de Elán: Matanías, Zacarías, Yejiel, Abdí, Yeremot y Elías."
,"27":"De los de Zatú: Elyoenay, Eliasib, Matanías, Yeremot, Zabat y Azizá."
,"28":"De los de Bebay: Yehojanón, Jananías, Zabay, Atlay."
,"29":"De los de Baní: Mesulán, Maluc, Adayas, Yasub, Seal, Yerimot."
,"30":"De los de Pajat Moab: Adná, Quelal, Benayas, Maasías, Matanías, Besalel, Binuy y Manasés."
,"31":"De los de Jarín: Eliezer, Yisías, Malaquías, Semayas, Simeón,"
,"32":"Benjamín, Maluc, Semarías."
,"33":"De los de Jasún: Matnay, Matatá, Zabad, Elifélet, Yeremías, Manasés, Simeí."
,"34":"De los de Baní: Maday, Amrán, Joel,"
,"35":"Benayas, Bedías, Quelaías,"
,"36":"Vanías, Maremot, Eliasib,"
,"37":"Matanías, Matnay, Jasay."
,"38":"De los de Binuy: Simeí,"
,"39":"Selemías, Natán, Adayas."
,"40":"De los de Zacay: Sasay, Saray,"
,"41":"Azarael, Selemías, Semarías,"
,"42":"Salún, Amarías, José."
,"43":"De los de Nebo: Yeiel, Matitías, Zabad, Zebiná, Yaday, Joel, Benayas."
,"44":"Todos éstos se habían casado con mujeres extranjeras: las despidieron a ellas y a sus hijos."
}`)

}
func ES_LSB_LoadVHETChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Era en tiempos del rey Asuero, el que reinó desde India hasta Etiopía sobre ciento veintisiete provincias."
,"2":"El año tercero de su reinado, el rey, que tenía establecido su trono real en la ciudad de Susa,"
,"3":"dio un banquete a todos los príncipes, ministros y jefes del ejército persa y medo, a los nobles y gobernadores de las provincias."
,"4":"Quería, con esto, poner de manifiesto durante muchos días, ciento ochenta exactamente, la riqueza y gloria de su imperio, el fasto y esplendor de su magnificencia."
,"5":"Transcurridos aquellos días, ofreció también un banquete durante siete días a toda la población de la ciudad de Susa, chicos y grandes, en el patio del jardín real."
,"6":"Colgaduras de lino blanco y celeste, sostenidas por cordones de seda y púrpura roja, pendían de anillas de plata, fijadas en columnas de mármol; se habían colocado divanes de oro y plata a lo largo del pavimento de piedras finas, de mármol blanco, de madreperla y de mosaico."
,"7":"Las bebidas se servían en copas de oro, todas diferentes, y se ofrecía vino abundante conforme a la esplendidez regia."
,"8":"El rey había ordenado a los mayordomos de palacio que no obligaran a beber a nadie y que fuesen condescendientes con los deseos de los invitados."
,"9":"La reina Vasti ofreció también un banquete a las mujeres en el palacio de Asuero."
,"10":"El séptimo día el rey, eufórico por el vino, mandó a Mehumán, Bizzetá, Jarboná, Bigtá, Abagtá, Zetar y Carcás, los siete eunucos que le servían,"
,"11":"que trajeran a su presencia a la reina Vasti con la corona real, para mostrar su belleza al pueblo y a los jefes, pues era muy hermosa."
,"12":"Pero la reina Vasti se negó, a pesar del mandato del rey transmitido por los eunucos. El rey se enfadó mucho, montó en cólera y"
,"13":"consultó a los sabios, expertos en leyes, pues era costumbre que los asuntos fuesen tratados ante expertos en leyes y derecho."
,"14":"Los más destacados eran Carsena, Setar, Admatá, Tarsis, Meres, Marsená y Memucán, los siete príncipes persas y medos que pertenecían al consejo real y ocupaban los primeros cargos del reino."
,"15":"El rey preguntó: '¿Qué ha de hacerse, según la ley, con la reina Vasti por no haber cumplido la orden del rey, transmitida por los eunucos?'."
,"16":"Memucán, ante el rey y los príncipes, respondió: 'La reina no ha ofendido solamente al rey, sino también a los príncipes y a los súbditos que viven en las provincias del rey."
,"17":"Porque cuando todas las mujeres se enteren de lo que ha hecho la reina, despreciarán a sus maridos, diciendo: El rey mandó llamar a la reina, y ella no quiso ir."
,"18":"Desde hoy las mujeres de los príncipes persas y medos, al saber lo que ha hecho la reina, hablarán con desprecio y con ira a sus maridos."
,"19":"Si al rey le parece bien, promulgue este decreto entre las leyes de los persas y de los medos: la reina Vasti no comparecerá más delante del rey, y su dignidad de reina se conferirá a otra mejor que ella."
,"20":"Cuando el decreto real se divulgue en todo el reino, todas las mujeres, desde las más grandes hasta las más insignificantes, honrarán a sus maridos'."
,"21":"El consejo de Memucán agradó al rey y a los príncipes, y el rey hizo lo siguiente:"
,"22":"escribió cartas a todas las provincias de su enorme imperio, a cada provincia en su escritura y a cada pueblo en su lengua, ordenando que en las casas mandaran los maridos."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Al cabo de algún tiempo, al rey se le pasó el enfado, se acordó de Vasti, de lo que había decretado contra ella."
,"2":"Los servidores del rey le dijeron: 'Búsquense para el rey jóvenes vírgenes y hermosas."
,"3":"Encargue el rey a hombres de confianza, en todas las provincias, que elijan las jóvenes vírgenes más bellas, para que se reúnan en la ciudad de Susa, en el harén, bajo la custodia de Hegué, eunuco del rey y guardián de las mujeres; que les hagan un tratamiento de belleza,"
,"4":"y la que más guste al rey será la reina en lugar de Vasti'. La idea agradó al rey, y así se hizo."
,"5":"En la ciudad de Susa había un judío llamado Mardoqueo, hijo de Yaír, hijo de Simeí, hijo de Quis, de la tribu de Benjamín,"
,"6":"uno de los numerosos cautivos que Nabucodonosor, rey de Babilonia, había deportado, desde Jerusalén, con Jeconías, rey de Judá."
,"7":"Había criado a una cierta Hedisa, es decir, Ester, hija de un tío suyo, huérfana de padre y madre. Era muy bella y hermosa, y a la muerte de sus padres, Mardoqueo la había tomado como hija suya."
,"8":"Cuando fue proclamado el edicto del rey, muchas jóvenes fueron llevadas a la ciudad de Susa y confiadas a Hegué, guardián de las mujeres."
,"9":"La joven le gustó, y él se apresuró a darle el tratamiento de belleza y alimentos, poniendo a su disposición siete doncellas elegidas entre las mejores del palacio real; luego la llevó con sus doncellas al sitio mejor del harén."
,"10":"Ester no había revelado ni su origen ni su familia, porque Mardoqueo se lo había prohibido."
,"11":"Mardoqueo, todos los días, paseaba delante del patio del harén para enterarse de la salud de Ester y de cómo la trataban."
,"12":"Cada joven debía presentarse por turno al rey Asuero, pasados los doce meses exigidos por el tratamiento de belleza: seis meses para untarse con aceite de mirra, y otros seis con bálsamo y cosméticos."
,"13":"Cuando pasaba al palacio real para presentarse al rey, cada joven podía llevar consigo del harén todo lo que quisiera."
,"14":"Entraba por la tarde, y a la mañana era llevada al segundo harén, bajo la vigilancia de Saasgaz, eunuco del rey y guardián de las concubinas. No volvía a presentarse ante el rey, a no ser que él lo desease y fuese llamada nominalmente."
,"15":"Cuando le llegó el turno a Ester, hija de Abijail, tío de Mardoqueo, a la que había adoptado por hija, no pidió más que lo que le había indicado Hegué, eunuco del rey y guardián de las mujeres. Pero Ester conquistaba a cuantos la veían."
,"16":"Ester fue llevada al palacio real y presentada al rey Asuero, el décimo mes, el mes tebet, en el año séptimo de su reinado."
,"17":"Y el rey la prefirió a todas las demás mujeres, puso la corona real sobre su cabeza y la eligió por reina en sustitución de Vasti."
,"18":"Dio después un espléndido banquete en honor de Ester a todos los príncipes y servidores. Concedió un día de fiesta a todas las provincias y repartió regalos con su esplendidez real."
,"19":"Al pasar al segundo harén, como las jóvenes,"
,"20":"Ester no reveló ni su origen ni su familia, según le había mandado Mardoqueo, pues ella continuaba haciendo todo lo que le decía, como cuando estaba bajo su tutela."
,"21":"Mardoqueo era por entonces empleado del palacio real. Bigtán y Teres, dos eunucos del rey, de la guardia de la puerta, llenos de ira, tramaban la muerte del rey."
,"22":"Mardoqueo lo supo e informó a Ester, y Ester lo comunicó al rey en nombre de Mardoqueo."
,"23":"Se abrió una información, se comprobó el hecho y los dos eunucos fueron ahorcados. El caso fue consignado en el libro de las crónicas en presencia del rey."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Algún tiempo después el rey Asuero encumbró a Amán, hijo de Hamdatá, el de Agag; le dio un alto cargo por encima de todos los funcionarios, sus compañeros."
,"2":"Todos los servidores del rey, que estaban al servicio de la puerta de palacio, se arrodillaban y postraban cuando Amán pasaba, según había ordenado el rey. Pero Mardoqueo no se arrodillaba ni se postraba ante él."
,"3":"Por eso los servidores del rey le preguntaron: '¿Por qué no cumples la orden del rey?'."
,"4":"Todos los días le repetían la misma pregunta, pero él no los escuchaba. Entonces lo denunciaron a Amán, para ver si tenían fundamento las pretensiones de Mardoqueo, pues les había dicho que era judío."
,"5":"Amán pudo comprobar que, a su paso, Mardoqueo ni se arrodillaba ni se postraba, y se llenó de ira."
,"6":"Y como le habían hablado de la raza de Mardoqueo, tuvo en poco meterse sólo con él y decidió exterminar a todos los judíos que había en el reino de Asuero."
,"7":"En el mes primero, el de nisán, en el año duodécimo del rey Asuero, se echó delante de Amán pur, es decir, suerte, para determinar el día y el mes, y salió el día trece del duodécimo mes, el de adar."
,"8":"Amán dijo al rey Asuero: 'En medio de las incontables gentes de tu reino y por todas las provincias hay esparcido y diseminado un pueblo, separado de los demás, que tiene leyes diferentes y no cumple las órdenes del rey. Los intereses del reino no permiten tolerarlo."
,"9":"Si al rey le parece bien, decrete que sea exterminado, y yo entregaré al tesoro real trescientas cuarenta toneladas de plata'."
,"10":"Asuero se quitó el anillo, se lo dio a Amán, hijo de Hamdatá, el de Agag, perseguidor de los judíos,"
,"11":"y le dijo: 'Guarda tu plata, y haz de ese pueblo lo que quieras'."
,"12":"El trece del primer mes, el de nisán, fueron convocados los secretarios del rey para sacar copias de las órdenes reales y mandarlas a todos los sátrapas del rey, a los gobernadores de las provincias y a los jefes de cada pueblo, según la escritura de cada provincia y la lengua de cada pueblo. Las copias fueron firmadas en nombre del rey Asuero y selladas con su anillo real."
,"13":"Los correos llevaron a todas las provincias del reino las cartas que mandaban exterminar a todos los judíos, jóvenes y viejos, niños y mujeres, el mismo día, es decir, el trece del duodécimo mes, el mes adar, y confiscar todos sus bienes."
,"14":"El texto de este decreto fue enviado a todas las provincias para su publicación como ley en toda la población y para que estuviesen preparados el día señalado."
,"15":"Los correos se aprestaron a cumplir el mandato del rey. El edicto fue promulgado también en la ciudad de Susa. Mientras el rey banqueteaba, en la ciudad de Susa reinaba la consternación."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Apenas supo Mardoqueo lo que se había hecho, rasgó sus vestiduras, se vistió de saco y ceniza y salió por la ciudad lanzando gritos de dolor: '¡Un pueblo inocente va a ser exterminado!'."
,"2":"Llegó hasta la puerta de palacio y allí se paró, pues nadie podía pasarla vestido de saco."
,"3":"En todas las provincias y lugares donde fue publicado el edicto del rey no había más que luto, ayunos, lloros y lamentos por parte de los judíos. El saco y las cenizas fueron el lecho de muchos."
,"4":"Las doncellas de Ester y sus eunucos fueron a decírselo. La reina lo sintió grandemente y envió vestidos a Mardoqueo para que se los pusiese y se quitase el saco, pero él no quiso."
,"5":"Llamó entonces Ester a Hatac, uno de los eunucos que el rey había puesto a su servicio, y lo mandó a preguntar a Mardoqueo qué pasaba y por qué hacía aquello."
,"6":"Hatac salió y fue a donde estaba siempre Mardoqueo, en la plaza que había delante de la puerta real."
,"7":"Mardoqueo le contó lo que pasaba y la cantidad que Amán había ofrecido entregar al tesoro del rey después de la destrucción de los judíos."
,"8":"Le entregó también una copia del decreto de exterminio, publicado en Susa, para que lo entregase a Ester y estuviese informada."
,"9":"Hatac volvió y contó a Ester lo que le había dicho Mardoqueo."
,"10":"Ester mandó a Hatac a decir a Mardoqueo:"
,"11":"'Todos los servidores del rey y el pueblo de las provincias saben que cualquiera, hombre o mujer, que entre en el vestíbulo interno, sin haber sido llamado, cae bajo la ley inexorable que lo condena a muerte, a no ser que el rey, tendiendo hacia él su cetro de oro, le conceda la gracia de la vida. Hace ya treinta días que no me ha llamado'."
,"12":"Comunicaron las palabras de Ester a Mardoqueo,"
,"13":"quien a su vez respondió: 'No creas que porque vives en el palacio del rey podrás salvarte tú sola entre todos los judíos."
,"14":"Si te obstinas en callar, los judíos encontrarán ayuda y salvación por otra parte, pero tú y la casa de tu padre pereceréis. ¡Y quién sabe si para una circunstancia como ésta no habrás llegado a ser reina!'."
,"15":"Ester le mandó a decir:"
,"16":"'Anda, reúne a todos los judíos de Susa, y ayunad por mi intención. No comáis ni bebáis durante tres días y tres noches. También yo, con mis doncellas, ayunaré. Luego me presentaré al rey, aun contra la ley, y si he de morir, moriré'."
,"17":"Mardoqueo se retiró y puso en práctica las instrucciones recibidas de Ester."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Tres días después, Ester, revestida de reina, llegó al atrio interior de palacio, ante la cámara real. Asuero estaba sentado en el trono en la sala real, de cara a la puerta."
,"2":"Cuando vio que la reina Ester estaba de pie en el atrio, le arrebató su encanto y tendió hacia ella el cetro de oro que tenía en la mano. Ester se acercó y tocó la punta del cetro."
,"3":"El rey le preguntó: '¿Qué te pasa, reina Ester? Pídeme lo que quieras, que te daré aunque sea la mitad de mi reino'."
,"4":"Ester dijo: 'Si agrada al rey, asista hoy con Amán al banquete que le he preparado'."
,"5":"El rey dijo: 'Avisad rápidamente a Amán, para complacer a Ester'. Y el rey y Amán asistieron al banquete que les había preparado Ester."
,"6":"Durante el banquete el rey dijo a Ester: 'Dime qué quieres y te lo daré. Di qué deseas y lo tendrás, aunque sea la mitad de mi reino'."
,"7":"Ester le respondió: 'Lo que pido y deseo es esto:"
,"8":"Si el rey quiere agradarme y concederme lo que pido y atender mi deseo, que vuelva mañana con Amán al banquete que prepararé, y daré mi respuesta al rey'."
,"9":"Aquel día Amán salió satisfecho y gozoso, pero cuando vio a Mardoqueo sentado delante de la puerta real y que ni siquiera se había levantado ni movido en su presencia, se enfureció contra él."
,"10":"No obstante, se contuvo. Al llegar a casa, llamó a sus amigos y a su mujer, Zeres,"
,"11":"y les habló largamente de sus riquezas fabulosas, del número de sus hijos y de la estima que el rey le había concedido, engrandeciéndolo por encima de todos sus príncipes y cortesanos. Y añadió:"
,"12":"'Pero esto no es todo; hasta la misma reina Ester, en el banquete que ha dado, no ha querido que hubiese nadie fuera del rey y yo, y nos ha invitado de nuevo para mañana."
,"13":"Pero nada me importa todo esto, mientras vea al judío Mardoqueo sentado a la puerta real'."
,"14":"Su mujer, Zeres, y sus amigos le respondieron: 'Manda preparar un patíbulo de veinticinco metros de altura, y mañana por la mañana propón al rey que se cuelgue en él a Mardoqueo, y así irás contento con el rey al banquete'. Agradó la propuesta a Amán, y ordenó que se preparase el patíbulo."
}`)
	CurrentBook.AddChapter(6, `{
"1":"No pudiendo el rey aquella noche conciliar el sueño, pidió que le trajesen el libro de los anales o crónicas y que se las leyeran."
,"2":"Allí estaba escrita la denuncia de Mardoqueo al rey sobre la conjura de Bigtán y Teres, eunucos guardias de la puerta, confabulados para matar al rey."
,"3":"El rey preguntó: '¿Qué honor y dignidad se le concedieron a Mardoqueo por esto?'. Los servidores respondieron: 'Absolutamente nada'."
,"4":"El rey prosiguió: '¿Quién está en el patio?'. (En aquel momento acababa de entrar Amán en el patio exterior de palacio para pedir al rey que se colgase a Mardoqueo en el patíbulo que él había preparado)."
,"5":"Le respondieron: 'Es Amán, que espera en el patio'. El rey dijo: 'Que entre'."
,"6":"Cuando Amán entró, el rey le preguntó: '¿Cómo debe tratarse a un hombre al que el rey quiere honrar?'. Amán pensaba: '¿A quién va a querer honrar el rey sino a mí?'. Y contestó:"
,"7":"'Si el rey quiere honrar a alguien,"
,"8":"que se le pongan vestiduras como las que usa el rey, que se suba a un caballo como los que monta el rey, con una corona real en la cabeza."
,"9":"El vestido, el caballo y la corona entréguense a uno de los más nobles y altos príncipes del rey. Éste vestirá al hombre a quien el rey quiere honrar y lo guiará a caballo por la plaza de la ciudad, gritando ante él: Así se trata a quien el rey quiere honrar'. El rey dijo a Amán:"
,"10":"'Toma en seguida las vestiduras y el caballo haz lo que has dicho con el judío Mardoqueo, que está sentado en la puerta real. No omitas nada de lo que has dicho'."
,"11":"Amán tomó los vestidos y el caballo, vistió a Mardoqueo y lo montó en el caballo en la plaza de la ciudad, gritando ante él: 'Así se trata a quien el rey quiere honrar'."
,"12":"Mardoqueo volvió luego a la puerta real, mientras Amán volvía a su casa triste y descompuesto."
,"13":"Refirió a su mujer, Zeres, y a todos sus amigos lo que había sucedido. Ellos le dijeron: 'Comienzas a declinar ante Mardoqueo; si pertenece a la raza judía, no podrás nada contra él, sino que caerás ante él'."
,"14":"Mientras todavía estaba hablando, llegaron los eunucos del rey para llevarlo aprisa al banquete que Ester había preparado."
}`)
	CurrentBook.AddChapter(7, `{
"1":"El rey y Amán llegaron al banquete de Ester."
,"2":"El rey dijo también este segundo día a Ester: 'Reina Ester, dime qué quieres y te lo daré; di qué deseas y lo tendrás, aunque sea la mitad de mi reino'."
,"3":"Ester le respondió: 'Si el rey quiere agradarme, concédeme la vida y la de mi pueblo; ésta es mi petición, éste es mi deseo;"
,"4":"pues yo y mi pueblo estamos condenados al exterminio, a la matanza, al aniquilamiento. Si al menos se hubiese tratado de vendernos como esclavos o esclavas, callaría; pero el enemigo no podrá compensar los daños al rey'."
,"5":"La interrumpió el rey para preguntarle: '¿Quién es y dónde está el hombre al que se le ha ocurrido tal cosa?'."
,"6":"Ester respondió: 'El opresor, nuestro enemigo, es este perverso de Amán'. Amán entonces se llenó de pánico ante el rey y la reina."
,"7":"El rey, furibundo, se levantó del banquete, y se fue al jardín de palacio; entretanto Amán, comprendiendo que su ruina estaba decretada, se quedó para implorar a Ester por su vida."
,"8":"Cuando el rey volvió del jardín a la sala del banquete, encontró a Amán reclinado sobre el diván en el que estaba reclinada Ester, y gritó: '¿También quieres violentar a la reina delante de mí, en mi palacio?'. Al terminar de pronunciar estas palabras, taparon el rostro de Amán, y"
,"9":"Harbona, uno de los eunucos del servicio del rey, dijo: 'La horca de veinticinco metros de altura que Amán ha preparado para Mardoqueo, que habló en favor del rey, está en casa de Amán'. El rey dijo: 'Colgadlo'."
,"10":"Amán fue ahorcado en el patíbulo que había preparado para Mardoqueo, y entonces se aplacó la ira del rey."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Aquel mismo día el rey Asuero regaló a la reina Ester la casa de Amán, el enemigo de los judíos, y Mardoqueo fue presentado al rey, pues Ester le había revelado lo que era para ella."
,"2":"El rey se quitó el anillo que había recobrado de Amán y se lo dio a Mardoqueo. Ester confió a Mardoqueo la gestión de la casa de Amán."
,"3":"Ester volvió a hablar al rey. Se echó a sus pies llorando y rogándole que anulase los malvados propósitos de Amán, el de Agag, y sus proyectos contra los judíos."
,"4":"El rey tendió el cetro de oro y ella se levantó, se puso delante del rey,"
,"5":"y le dijo: 'Si al rey le parece bien, si quiere agradarme, si mi petición le parece oportuna, si he merecido yo su afecto, deje sin efecto las cartas que Amán, el hijo de Hamdatá, el de Agag, escribió para exterminar a los judíos de todas las provincias del reino."
,"6":"Pues ¿cómo podría yo ver las desventuras que esperan a mi pueblo y la desaparición de mi raza?'."
,"7":"El rey respondió a la reina Ester y al judío Mardoqueo: 'He dado a Ester la casa de Amán, al que han ahorcado por haber querido acabar con los judíos."
,"8":"Escribid, pues, a los judíos como mejor os parezca en nombre del rey y selladlo con el sello del rey, pues un documento expedido en nombre del rey y sellado con su anillo es irrevocable'."
,"9":"El día veintitrés del tercer mes, el mes de siván, fueron convocados los amanuenses del rey para escribir cartas, como quiso Mardoqueo, a los judíos, a los sátrapas, a los gobernadores y a los jefes de las ciento veintisiete provincias que se extienden desde India a Etiopía. A cada provincia en su escritura, y a cada pueblo en su lengua; a los judíos también en su escritura y en su lengua."
,"10":"Las cartas se escribieron en nombre del rey Asuero, se sellaron con su anillo y se mandaron por correo, en veloces caballos de las caballerizas reales."
,"11":"En las cartas, el rey concedía a los judíos, fuera cualquiera la ciudad en que habitasen, el derecho de unirse para defender la propia vida, y de matar, exterminar y acabar con las personas armadas de cualquier pueblo o provincia que los atacasen, incluidos las mujeres y los niños, así como de apoderarse del botín."
,"12":"Esto sucedería el mismo día en todas las provincias del rey Asuero, es decir, el trece del segundo mes, el de adar."
,"13":"El decreto debía ser publicado como ley en todas las provincias y en todas las poblaciones, a fin de que los judíos estuviesen preparados aquel día para vengarse de sus enemigos."
,"14":"En caballos del rey salieron presurosos los correos, conforme a la orden del rey, y el decreto fue también publicado en la ciudad de Susa."
,"15":"Mardoqueo salió de la presencia del rey con vestiduras regias de color violeta y blanco, una gran corona de oro y manto de lino y púrpura. Toda la ciudad de Susa se regocijó grandemente."
,"16":"Para los judíos había nacido un día de luz, de alegría, de gloria y de triunfo."
,"17":"En las provincias y poblaciones adonde llegaban las órdenes del decreto real tuvieron los judíos alegría y gozo, convites y fiestas. Muchos se hacían judíos por el miedo que les tenían."
}`)
	CurrentBook.AddChapter(9, `{
"1":"El trece de adar, duodécimo mes del año, día en que los enemigos de los judíos esperaban apoderarse de ellos, ocurrió lo contrario, y fueron los judíos los que se apoderaron de sus enemigos."
,"2":"Los judíos se reunieron en sus ciudades, en todas las provincias del rey Asuero, para meterse contra los que habían intentado su exterminio, y nadie se les oponía porque era mucho el miedo que se había esparcido en las poblaciones."
,"3":"Los jefes de las provincias, los sátrapas, los gobernadores y los funcionarios reales defendían a los judíos por miedo a Mardoqueo."
,"4":"Mardoqueo era en realidad grande en palacio. Su fama había llegado a todas las provincias, y cada día aparecía más poderoso."
,"5":"Los judíos hirieron con la espada a todos sus enemigos. Fue una verdadera matanza, un auténtico exterminio, haciendo de sus enemigos todo lo que quisieron."
,"6":"Sólo en la ciudad de Susa los judíos mataron a quinientos hombres,"
,"7":"además de Parsandata, Dalfón, Aspata,"
,"8":"Porata, Adalía, Aridata,"
,"9":"Parmasta, Arisay, Ariday y Baizata,"
,"10":"los diez hijos de Amán, hijo de Hamdatá, el perseguidor de los judíos, pero no saquearon sus bienes."
,"11":"El mismo día el rey supo el número de los muertos en Susa."
,"12":"El rey dijo a Ester: 'Sólo en Susa los judíos han matado a quinientos hombres y a los diez hijos de Amán; ¿qué habrán hecho en las otras provincias? Dime ahora qué quieres y te lo daré, dime qué más deseas y se hará'."
,"13":"Ester respondió: 'Si al rey le parece bien, que se conceda también mañana a los judíos ejecutar el decreto en Susa, como lo han hecho hoy, y que se cuelgue en la horca a los diez hijos de Amán'."
,"14":"El rey ordenó que se hiciera así, y el nuevo decreto fue rápidamente proclamado en Susa, y colgados en la horca los diez hijos de Amán."
,"15":"Los judíos de Susa se reunieron también el catorce del mes de adar y mataron otros trescientos hombres, pero sin saquear sus bienes."
,"16":"Los demás judíos que habitaban el reino también se reunieron para defenderse y deshacerse de sus enemigos, matando setenta y cinco mil enemigos, pero sin saquear sus bienes."
,"17":"Esto sucedió el trece del mes de adar; el catorce descansaron, y fue para ellos día de banquete y alegría."
,"18":"Los judíos de Susa se habían reunido el trece y el catorce, descansando el quince, que fue para ellos día de banquete y alegría."
,"19":"Por eso los judíos de las provincias celebran el catorce del mes de adar como día de banquete y alegría, y se intercambian regalos."
,"20":"Mardoqueo escribió estos sucesos y envió cartas a todos los judíos de las provincias de Asuero, a las próximas y a las lejanas."
,"21":"Ordenó la celebración anual durante los días trece y catorce del mes de adar"
,"22":"como días en que los judíos se deshicieron de sus enemigos, y mes en que la tristeza se convirtió en alegría y el luto en regocijo. Estos dos días debían convertirse en días de banquete y alegría, haciéndose regalos unos a otros y dando donativos a los pobres."
,"23":"Los judíos aceptaron celebrar anualmente las fiestas que espontáneamente habían comenzado a observar, tal como les había escrito Mardoqueo:"
,"24":"'Amán, hijo de Hamdatá, el de Agag, enemigo de todos los judíos, había proyectado su destrucción echando pur, es decir, 'suerte', para destruirlos y acabar con ellos."
,"25":"Pero cuando Ester fue al rey, el rey ordenó por escrito que el proyecto malvado de Amán contra los judíos se llevara a cabo en él. Amán y sus hijos fueron colgados en la horca."
,"26":"Ésta es la razón de llamar a estos días purim, de pur'. Así pues, basados en esta carta y en lo que ellos mismos habían visto y comprobado, los judíos "
,"27":"se comprometieron irrevocablemente ellos, su descendencia y los prosélitos a celebrar cada año estos dos días según el modo prescrito y en el tiempo establecido."
,"28":"Conmemorados y celebrados de generación en generación en todas las familias, provincias y ciudades, estos días de purim no serán olvidados por los judíos, ni su recuerdo desaparecerá de su descendencia."
,"29":"La reina Ester, hija de Abijail, y el judío Mardoqueo escribieron de nuevo para confirmar con su autoridad esta segunda carta."
,"30":"La mandaron a todos los judíos de las ciento veintisiete provincias del rey Asuero, con palabras de paz y exhortación a la fidelidad,"
,"31":"ordenando celebrar los días de purim y en su fecha exacta, según habían establecido el judío Mardoqueo y la reina Ester, y cómo se habían obligado ellos y su descendencia en cuanto a ayunos y lamentaciones."
,"32":"El mandato de Ester dio valor de ley a lo referente a purim, y fue escrito en un libro."
}`)
	CurrentBook.AddChapter(10, `{
"1":"El rey impuso un tributo sobre la tierra y las islas del mar."
,"2":"Todas las manifestaciones de su poder y de su valor y la descripción de la grandeza a la que elevó a Mardoqueo está escrito en las crónicas de los reyes de Media y Persia."
,"3":"Está escrito cómo el judío Mardoqueo fue el segundo después del rey y fue estimado entre los judíos y querido por la muchedumbre de sus hermanos. Él procuró el bien de su pueblo y se preocupó del bienestar de su raza."
,"4":"Mardoqueo dijo: 'Todo lo sucedido es obra de Dios."
,"5":"Recuerdo un sueño que tuve sobre estos acontecimientos, y todo ha ocurrido:"
,"6":"la fuentecilla que se convirtió en río abundante de aguas, la luz que se transformó en sol. El río es Ester, a quien el rey tomó por esposa e hizo reina;"
,"7":"los dos dragones somos yo y Amán;"
,"8":"las gentes son todos los que se reunieron para destruir a los judíos;"
,"9":"mi pueblo es Israel, que acudió a Dios y lo salvó. Dios salvó a su pueblo y nos libró de todos los males; obró prodigios y maravillas, como jamás se vieron entre los gentiles."
,"10":"Preparó dos destinos: uno para el pueblo de Dios y otro para los gentiles."
,"11":"Se han cumplido estos dos destinos en la hora, tiempo y día establecidos por Dios y en la hora de su juicio."
,"12":"Dios se acordó de su pueblo Israel, que es su propiedad, y le hizo justicia."
,"13":"Estos dos días, el trece y el catorce del mes de adar, serán festejados eternamente en presencia de Dios con alegría y gozo por todo el pueblo de Israel'."
}`)
	CurrentBook.AddChapter(11, `{
"1":"El año cuarto del reinado de Tolomeo y Cleopatra, Dositeo, que decía ser sacerdote y levita, y su hijo Tolomeo, trajeron esta carta de purim, la declararon auténtica y dijeron que había sido traducida por Lisímaco, hijo de Tolomeo, de la comunidad de Jerusalén."
,"2":"El día uno del mes de nisán del año segundo del reinado del gran rey Asuero, Mardoqueo, hijo de Yaír, hijo de Simeí, de Quis, de la tribu de Benjamín,"
,"3":"judío que habitaba en Susa y personaje importante entre los primeros de la corte,"
,"4":"uno de los numerosos cautivos que Nabucodonosor, rey de Babilonia, había deportado desde Jerusalén, con Jeconías, rey de Judá,"
,"5":"tuvo este sueño: Gritos y tumultos, truenos y terremotos, desquiciamiento en la tierra. "
,"6":"Dos enormes dragones avanzan dispuestos a luchar. Lanzaron un gran aullido,"
,"7":"y a su grito todas las naciones se prepararon para luchar contra el pueblo de los justos."
,"8":"Fue aquél un día de tinieblas y oscuridad. La tribulación y la angustia, la aflicción y el pánico invadieron la tierra."
,"9":"Todo el pueblo de los justos, aterrorizado por las calamidades que se cernían sobre él, se dispuso a morir."
,"10":"Pero clamaron a Dios, y a su clamor, de una fuentecilla, surgió un gran río de agua abundante."
,"11":"Apareció después una luz, que se transformó en sol. Los oprimidos se levantaron y devoraron a los poderosos."
,"12":"Mardoqueo, después de haber tenido este sueño sobre lo que Dios se proponía ejecutar, se despertó y estuvo todo el día hasta la noche dándole vueltas, esforzándose por descifrarlo."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Mardoqueo vivía en el palacio con Gabata y Tarra, eunucos del rey y guardias de palacio."
,"2":"Supo las maquinaciones de los dos y adivinó sus designios, descubriendo que atentaban contra la vida del rey Asuero, y se lo comunicó al rey."
,"3":"El rey los sometió a interrogatorio; y ellos confesaron y fueron condenados a muerte."
,"4":"El rey consignó lo sucedido en las crónicas, y Mardoqueo también lo escribió."
,"5":"El rey dio un cargo a Mardoqueo en palacio y en agradecimiento le hizo muchos regalos."
,"6":"Pero Amán, hijo de Hamdatá, el de Agag, que era favorito del rey, tramaba cómo arruinar a Mardoqueo por lo de los dos eunucos del rey."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Copia del decreto: 'El gran rey Asuero a los gobernadores de las ciento veintisiete provincias, desde India hasta Etiopía, y a los jefes locales que le están sometidos:"
,"2":"Como jefe de pueblos incontables y señor de toda la tierra, no quiero abusar de la grandeza de mi poderío, sino gobernar a mis vasallos con moderación y clemencia para que pasen una vida tranquila, sin temores, y gocen de la paz tan deseada por todos los hombres."
,"3":"Pues bien, pedida orientación a mis consejeros de cómo conseguir esto, uno de ellos, Amán, que sobresale de los demás por su prudencia e inquebrantable fidelidad, que es el segundo en honores después del rey,"
,"4":"nos ha informado que, disperso entre todas las naciones de la tierra, existe un pueblo odioso por sus leyes, de costumbres contrarias a las de los demás pueblos y que siempre desprecia las órdenes del rey, impidiendo así que produzcan efecto las disposiciones de gobierno que de mí emanan."
,"5":"Considerando, pues, que el citado pueblo, único en conducta, se halla en permanente hostilidad con todo el género humano, que se distingue por sus leyes extrañas, que se opone a nuestros intereses y que comete los peores abusos,"
,"6":"ordenamos que todos los que os sean indicados en las cartas de Amán, que está al cargo de nuestros asuntos y es nuestro segundo padre, sean pasados a espada con sus mujeres e hijos, sin piedad y miramiento alguno, el día catorce del duodécimo mes, el de adar, del presente año."
,"7":"Así, al bajar a los infiernos en un solo día esos rebeldes de ayer y hoy, quedará asegurada la paz y tranquilidad de nuestro imperio'."
,"8":"Mardoqueo, recordando las grandes obras del Señor,"
,"9":"oró así: 'Señor, Señor, rey todopoderoso, todo está en tus manos, y no hay quien pueda oponerse,si tú quieres salvar a Israel."
,"10":"Tú has creado el cielo y la tierra,y las maravillas,que hay bajo el firmamento."
,"11":"Tú eres el Señor de todas las cosas, y nada hay que pueda oponerte resistencia, Señor."
,"12":"Tú lo sabes todo; tú sabes, Señor, que no por insolencia, ni por orgullo, ni vanidad,me negué a postrarme,ante el soberbio Amán."
,"13":"Porque por la salvación de Israel,estaría dispuesto,hasta a besarle los pies."
,"14":"Me he portado así,para no poner la gloria de un hombre,por encima de la gloria de Dios. Jamás me postraré ante nadie; sólo delante de ti, Señor; y no hago esto por orgullo."
,"15":"Y ahora, señor y rey, Dios de Abrahán, ten piedad de tu pueblo, pues proyectan nuestro exterminio,y desean acabar,con tu antigua heredad."
,"16":"No desprecies tu propiedad, que rescataste de Egipto."
,"17":"¡Oye mi oración,y sé propicio a tu pueblo!,Cambia nuestro luto en alegría, y viviremos cantando,a tu nombre, Señor. No permitas que enmudezcan,las lenguas de los que te alaban'."
,"18":"Todo Israel clamaba al Señor insistentemente, pues veía la muerte encima."
}`)
	CurrentBook.AddChapter(14, `{
"1":"También la reina Ester, aterrada por el inminente peligro de muerte que se cernía sobre ella, recurrió al Señor."
,"2":"Se despojó de sus vestiduras reales y se puso vestidos de llanto y de duelo; en vez de olorosos perfumes, cubrió su cabeza de polvo y ceniza, mortificó duramente su cuerpo con ayunos y ocultó la espléndida belleza de su cuerpo con sus cabellos en desorden."
,"3":"Rogó así al Señor, Dios de Israel: 'Señor mío, rey nuestro, tú eres único. Ayúdame en mi soledad, pues no tengo otro socorro que tú,"
,"4":"y me acecha de cerca,el peligro de muerte."
,"5":"He oído desde niña en mi familia,que tú, Señor, escogiste a Israel,entre todas las naciones, y a nuestros padres,entre todos sus antecesores,para tu eterna heredad; y has cumplido lo que prometiste."
,"6":"Pero ahora nosotros,hemos pecado ante ti, y nos has entregado,en manos de nuestros enemigos"
,"7":"porque hemos dado culto a sus dioses. Justo eres, Señor."
,"8":"Pero no se contentan ahora con la amargura de nuestra esclavitud, y han jurado ante sus ídolos"
,"9":"anular tus promesas,y exterminar tu propiedad, cerrar la boca de los que te alaban,y extinguir la gloria,de tu templo y de tu altar"
,"10":"para abrir la boca de los gentiles, que alabarán a sus ídolos,y engrandecerán para siempre,a un rey de carne."
,"11":"No entregues, Señor, tu cetro,a los que son nada; que no se rían los gentiles,de nuestra ruina. Vuelve sus propósitos contra ellos,e infiere ejemplar castigo,al que inició contra nosotros,esta guerra."
,"12":"Acuérdate, Señor, y hazte visible,en el día de nuestra angustia; dame valor, rey de dioses,y Señor omnipotente."
,"13":"Pon en mi boca palabras oportunas,cuando esté delante del león, y cambia su corazón en odio,contra nuestro enemigo,para que perezca con sus cómplices."
,"14":"Líbranos, Señor, con tu poder, y asísteme a mí, que estoy sola,y a nadie tengo sino a ti, Señor. Tú lo sabes todo,"
,"15":"tú sabes que aborrezco,la riqueza de los injustos, que detesto el lecho,de los incircuncisos, como el de cualquier extranjero."
,"16":"Tú conoces la grave situación,en que me encuentro,y sabes también,que detesto el distintivo,de mi grandeza,que ciñe mi cabeza,cuando aparezco en público. Sí, lo aborrezco,como a un paño inmundo, y jamás lo llevo en mi vida privada."
,"17":"Jamás tu sierva ha comido,en la mesa de Amán, ni ha honrado con su presencia,los convites del rey, ni ha bebido del vino,que ofrece a sus dioses."
,"18":"Ni tu sierva se ha alegrado,desde mi elección hasta hoy,sino en ti, Señor, Dios de Abrahán."
,"19":"¡Oh Dios, más poderoso que todos!, escucha la voz de los sin esperanza, líbranos del poder de los malvados,y quítame este miedo'."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Mardoqueo le mandó decir a Ester que se presentase al rey para pedirle clemencia e interceder por su pueblo."
,"2":"'Acuérdate -le decía- de los días de tu niñez, cuando te alimentaba con mi mano. Amán, la segunda personalidad del reino, ha hablado contra nosotros pidiendo nuestro exterminio."
,"3":"Invoca al Señor, habla por nosotros al rey, y líbranos de la muerte'."
,"4":"El día tercero, terminada su oración, se quitó sus vestiduras de duelo y se vistió de reina."
,"5":"Radiante de hermosura, invocó a Dios, árbitro y salvador de todos, y tomó consigo dos doncellas."
,"6":"Sobre una de ellas se apoyaba delicadamente;"
,"7":"la otra la acompañaba sosteniendo sus vestidos."
,"8":"Iba ella sonrosada, bella y atrayente, pero dentro le latía aceleradamente el corazón."
,"9":"Pasadas todas las puertas, se encontró ante el rey. Estaba sentado en su trono, revestido de todos los ornamentos solemnes, resplandeciente de oro y pedrerías. Su aspecto era imponente."
,"10":"Levantó su rostro centelleante y lanzó una mirada cargada de ira. La reina perdió el color, se desmayó y se apoyó en la doncella que la acompañaba."
,"11":"Dios entonces cambió en dulzura el corazón del rey, que apresuradamente saltó del trono, la tomó en sus brazos hasta que se rehizo, y animándola con palabras cariñosas le decía:"
,"12":"'¿Qué te pasa, Ester? Yo soy tu hermano, no temas."
,"13":"Tú no morirás. Esta ley es para los demás."
,"14":"Acércate'."
,"15":"Y levantando su cetro de oro, lo posó sobre su cuello, besó a Ester y le dijo: 'Háblame'."
,"16":"Ester habló: 'Te vi, señor, como un ángel de Dios, y mi corazón se turbó por el miedo de tu majestad."
,"17":"Eres maravilloso, señor, y tu rostro es fascinante'."
,"18":"Mientras así hablaba, se desvaneció de nuevo."
,"19":"El rey se conmovió, y sus servidores trataban de reanimarla."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Copia del decreto: 'El gran rey Asuero a los sátrapas y gobernadores de las ciento veintisiete provincias desde India hasta Etiopía, y a todos sus súbditos, salud."
,"2":"Muchos, inmensamente honrados por la abundante largueza de sus bienhechores, llegaron a ensoberbecerse."
,"3":"No sólo oprimen a nuestros súbditos, sino que, insatisfechos de los honores recibidos, maquinan contra sus mismos bienhechores."
,"4":"Y no sólo no se contentan con arrancar del corazón de los hombres los sentimientos de gratitud, sino que, enorgullecidos por los aplausos de los que ignoran el bien, pretenden sustraerse a la justa condena de Dios, que todo lo ve."
,"5":"Muchas veces los gobernantes se vieron envueltos en delitos irreparables y complicados en sangre inocente por haber confiado a amigos la administración de los negocios y haberse dejado influenciar por ellos,"
,"6":"pues abusaron con refinada perversidad de la buena fe e hidalguía de los príncipes."
,"7":"Vosotros mismos podéis constatar, no sólo leyendo las crónicas antiguas, sino mirando a vuestro alrededor, cuántas son las impiedades cometidas por esta clase de hombres."
,"8":"Debemos, pues, mirar al futuro y asegurar la tranquilidad y la paz para bien de todos,"
,"9":"haciendo los cambios necesarios y examinando con prudencia los asuntos que se presenten, para juzgarlos siempre con justicia."
,"10":"Pero queremos que entendáis mejor lo que decimos: Amán, hijo de Hamdatá, macedonio, extraño a la sangre persa y completamente ajeno a nuestra benignidad, fue recibido por nosotros como huésped"
,"11":"y acogido con los mejores sentimientos de amistad, hasta el punto de llamarlo nuestro padre, de ser reverenciado por todos y de ser el segundo personaje después del rey."
,"12":"Pero, incapaz de reprimir sus ambiciones, trató de privarnos del reino y de la vida."
,"13":"Utilizó toda clase de argucias para exterminar a Mardoqueo, que fue nuestro salvador y nuestro constante bienhechor; a Ester, la irreprochable reina de nuestro imperio, y a toda su raza."
,"14":"Él creía que con semejantes medidas quedaríamos aislados, y entonces habría podido transferir a los medos el imperio de los persas."
,"15":"Nosotros constatamos que los judíos, destinados a la muerte por el más malvado de los hombres, lejos de ser criminales, se rigen por leyes muy justas"
,"16":"y son hijos del Dios vivo, el grande y el altísimo, que nos conserva el reino en estado floreciente, como lo hizo con nuestros padres."
,"17":"Haréis, pues, bien anulando las cartas enviadas por Amán, hijo de Hamdatá,"
,"18":"pues su autor y su familia han sido ahorcados en las puertas de Susa en justo castigo que Dios, Señor universal, le ha infligido inmediatamente."
,"19":"Publicad el decreto que ahora os mandamos en todas las ciudades, permitid que los judíos sigan libremente sus leyes"
,"20":"y ayudadles para que puedan defenderse de los que estaban preparados para exterminarlos el día trece del duodécimo mes, el de adar."
,"21":"Dios todopoderoso ha querido cambiar en alegría, en favor de su pueblo escogido, el día que debía ser de luto y ruina."
,"22":"Celebrad, pues, vosotros, los judíos, con toda alegría, como una de vuestras fiestas solemnes, ese día memorable;"
,"23":"y que de ahora en adelante sea para vosotros y para todos los leales a los persas memorial de vuestra liberación, así como recuerdo infausto para vuestros enemigos."
,"24":"Toda ciudad o región que se niegue a seguir estas órdenes sea pasada a hierro y fuego y quede inhabitable para los hombres y eternamente detestable incluso para las fieras y aves del cielo'."
}`)

}
func ES_LSB_LoadVHIDChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Después de la muerte de Josué, los israelitas consultaron al Señor: '¿Quién de nosotros subirá el primero para luchar contra los cananeos?'."
,"2":"El Señor respondió: 'Subirá Judá, pues he puesto el país en sus manos'."
,"3":"Entonces Judá dijo a Simeón, su hermano: 'Sube conmigo al territorio que me ha tocado en suerte para luchar contra los cananeos; después lucharé yo contigo en tu territorio'. Y Simeón se le unió."
,"4":"Judá subió, y el Señor puso en sus manos a los cananeos y a los fereceos; derrotaron en Bézec a diez mil de ellos,"
,"5":"entre los que se encontraba Adonisedec."
,"6":"Adonisedec se dio a la fuga; pero ellos lo persiguieron, lo alcanzaron y le cortaron los pulgares de las manos y de los pies."
,"7":"Adonisedec dijo: 'Setenta reyes, cortados los pulgares de pies y manos, recogían las migajas debajo de mi mesa; Dios me paga con la misma medida'. Fue llevado a Jerusalén, y allí murió."
,"8":"Los de la tribu de Judá atacaron Jerusalén y la tomaron, pasaron a filo de espada a todos sus habitantes y le prendieron fuego."
,"9":"Después bajaron a atacar a los cananeos que vivían en la montaña, el Negueb y la Sefela."
,"10":"Atacaron también a los cananeos que vivían en Hebrón. Hebrón se llamaba antiguamente Quiriat Arbá. Y derrotaron a Sesay, a Ajimán y a Talmay."
,"11":"Luego atacaron la ciudad de Debir. Debir se llamaba antiguamente Quiriat Séfer."
,"12":"Entonces Caleb prometió: 'A quien ataque y tome Quiriat Séfer, le daré por mujer a mi hija Acsá'."
,"13":"La tomó Otoniel, hijo de Quenaz, hermano menor de Caleb, y éste le dio por esposa a su hija Acsá."
,"14":"Cuando la llevaban a casa de su marido, éste la convenció para que pidiera a su padre un campo. Ella se bajó del asno, y Caleb le preguntó: '¿Qué quieres?'."
,"15":"Ella respondió: 'Hazme un favor. Ya que me has dado una tierra de secano, dame al menos una fuente'. Y Caleb le dio la fuente de arriba y la de abajo."
,"16":"Los hijos de Jobab, el quenita, suegro de Moisés, subieron con los de Judá desde la ciudad de las palmeras al desierto que está al mediodía de Judá, en la bajada de Arad, y vivieron con los amalecitas."
,"17":"Después Judá fue con Simeón, su hermano, y derrotaron a los cananeos que vivían en Sefat, y entregaron al exterminio la ciudad. Por eso aquella ciudad se llamó Jormá."
,"18":"Pero no pudieron apoderarse de Gaza, Ascalón y Ecrón con sus respectivos términos."
,"19":"El Señor estaba con Judá, que conquistó la montaña; pero no pudo expulsar a los habitantes de la llanura, porque tenían carros de guerra."
,"20":"Siguiendo las órdenes de Moisés, Hebrón fue dado a Caleb, que echó de allí a los tres hijos de Anac."
,"21":"Sin embargo, los de la tribu de Benjamín no pudieron echar de Jerusalén a los jebuseos, que han continuado viviendo allí hasta el día de hoy con los de Benjamín."
,"22":"A su vez, la casa de José subió contra Betel, y el Señor estuvo con ella."
,"23":"Exploraron los alrededores de Betel, llamada antiguamente Luz."
,"24":"Los espías vieron a un hombre que salía de la ciudad y le dijeron: 'Indícanos por dónde se puede entrar en la ciudad y seremos benévolos contigo'."
,"25":"Él les indicó por dónde podían entrar en la ciudad. Pasaron a filo de espada a la ciudad, pero dejaron libre a aquel hombre con toda su parentela."
,"26":"Aquel hombre se fue al país de los hititas, edificó una ciudad y la llamó Luz, nombre que aún conserva hoy."
,"27":"Manasés no pudo echar a los habitantes de Betsán, de Tanac, de Dor, de Yibleán y de Meguido, con sus respectivas ciudades dependientes; los cananeos siguieron viviendo en ellas."
,"28":"Cuando los israelitas fueron más fuertes, los sometieron a trabajos forzados, pero no llegaron a echarlos de allí."
,"29":"Efraín tampoco pudo echar a los cananeos que vivían en Guézer, de suerte que los cananeos siguen viviendo entre ellos."
,"30":"Zabulón tampoco pudo echar de Quitrón y de Nahalol a los cananeos, que siguen viviendo entre ellos, pero sometidos a trabajos forzados."
,"31":"Tampoco Aser pudo echar de Aco, Sidón, Majaleb, Afec y Rejob a los cananeos,"
,"32":"que, al no poderlos echar, se quedaron a vivir entre ellos."
,"33":"Neftalí tampoco pudo echar a los habitantes de Bet Semes ni de Bet Anat, por lo que se quedaron a vivir entre los cananeos; pero a los habitantes de Bet Semes y Bet Anat los sometieron a trabajos forzados."
,"34":"Los amorreos contuvieron en la montaña a los de Dan y no los dejaron bajar a la llanura;"
,"35":"los amorreos se mantuvieron en Har Jeres, en Ayalón y en Saalbín, pero cuando creció el poder de la casa de José fueron sometidos a trabajos forzados."
,"36":"El territorio de los edonitas se extendía desde la subida de Acrabín hasta Sela, y seguía hacia arriba."
}`)
	CurrentBook.AddChapter(2, `{
"1":"El ángel del Señor subió de Guilgal a Betel y dijo: 'Yo os saqué de Egipto y os traje a esta tierra que había prometido con juramento a vuestros padres, diciendo: No romperé jamás mi alianza con vosotros."
,"2":"Por vuestra parte, no haréis pactos con los habitantes de este país, sino que destruiréis sus altares. Pero vosotros no habéis obedecido. ¿Por qué habéis hecho esto?"
,"3":"Por eso os digo: No echaré a estos pueblos delante de vosotros. Serán vuestros enemigos, y sus dioses serán una tentación para vosotros'."
,"4":"Cuando el ángel del Señor terminó de hablar, el pueblo se echó a llorar a gritos."
,"5":"Por eso llamaron a aquel lugar Boquín, y ofrecieron sacrificios al Señor."
,"6":"Josué despidió al pueblo, y los israelitas se fueron cada uno a tomar posesión de su territorio."
,"7":"El pueblo sirvió al Señor durante toda la vida de Josué y de los ancianos que sobrevivieron a Josué, que habían visto todas las grandes obras que el Señor había hecho en favor de Israel."
,"8":"Josué, hijo de Nun, siervo del Señor, murió a la edad de ciento diez años,"
,"9":"y lo enterraron en su propio territorio de Timná Séraj, en la montaña de Efraín, al norte del monte Gaas;"
,"10":"murió también toda aquella generación que no conocía al Señor ni lo que había hecho por Israel."
,"11":"Los israelitas hicieron lo que desagrada al Señor y adoraron a los baales."
,"12":"Abandonaron al Señor, Dios de sus padres, que los había sacado de Egipto, y se fueron tras otros dioses de los pueblos vecinos; los adoraron, provocando por ello la ira del Señor."
,"13":"Abandonaron al Señor para adorar a Baal y Astarté."
,"14":"Entonces se encendió contra Israel la ira del Señor; los entregó en manos de salteadores, que los saquearon, y los vendió a sus enemigos de alrededor, a los que no fueron capaces de oponer resistencia."
,"15":"En todas sus expediciones, la mano del Señor pesaba sobre ellos para hacerles mal, como el mismo Señor se lo había dicho y jurado."
,"16":"Entonces el Señor hizo surgir jueces que los libraron del poder de sus opresores."
,"17":"Pero ni aun a sus jueces obedecían. Se prostituyeron ante otros dioses y se prosternaron ante ellos. Se apartaron pronto del camino que habían seguido sus padres, dóciles a los mandamientos del Señor; pero ellos no lo hicieron así."
,"18":"El Señor hizo surgir los jueces. El Señor estaba con el juez y los libraba de la mano de sus enemigos mientras vivía el juez, pues se compadecía de ellos al oírles gemir bajo sus opresores y perseguidores."
,"19":"Pero cuando moría el juez, volvían a caer y obraban peor que sus padres; no abandonaban las prácticas condenables y la terca conducta de sus padres."
,"20":"La ira del Señor se encendió contra Israel y dijo: 'Ya que esta generación ha violado la alianza que yo había establecido con sus padres y no me ha obedecido,"
,"21":"desde ahora tampoco yo echaré delante de ellos a ninguna de las naciones que dejó Josué al morir,"
,"22":"a fin de probar por su medio a Israel, para ver si sigue o no los caminos del Señor, como los siguieron sus padres'."
,"23":"Por eso el Señor dejó en paz aquellas naciones, no expulsándolas de momento, ni poniéndolas en manos de Josué."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Éstas son las naciones que el Señor dejó para probar por su medio a los israelitas que no habían conocido ninguna de las guerras de Canaán"
,"2":"(fue únicamente para instruir en el arte de la guerra a los que no habían conocido las guerras de antes)."
,"3":"Los cinco principados filisteos, todos los cananeos, los sidonios y los hititas que habitaban la montaña del Líbano, desde la montaña de Baal Hermón hasta la entrada de Jamat."
,"4":"Ellos sirvieron para probar a Israel, para ver si guardaba los preceptos que el Señor había dado a sus padres por medio de Moisés."
,"5":"Por eso los israelitas vivieron entre los cananeos, los hititas, los amorreos, los fereceos, los heveos y los jebuseos;"
,"6":"y tomaron por esposas a sus hijas, casaron a sus propios hijos con las hijas de ellos y adoraron a sus dioses."
,"7":"Los israelitas hicieron lo que desagrada al Señor. Olvidaron al Señor, su Dios, para adorar a los baales y las aserás."
,"8":"Entonces la ira del Señor se encendió contra ellos y los entregó a Cusán Risatayín, rey de Edón. Los israelitas estuvieron sometidos a Cusán Risatayín ocho años;"
,"9":"clamaron al Señor, y el Señor hizo surgir un libertador para salvarlos: Otoniel, hijo de Quenaz, hermano menor de Caleb."
,"10":"El espíritu del Señor vino sobre él, fue juez de Israel y salió a combatir contra Cusán Risatayín, rey de Edón; el Señor se lo puso en sus manos y lo derrotó."
,"11":"Así el país estuvo en paz durante cuarenta años."
,"12":"Muerto Otoniel, hijo de Quenaz, los israelitas volvieron a hacer lo que desagrada al Señor, y el Señor dio poder a Eglón, rey de Moab, sobre Israel, porque habían hecho lo que desagradaba al Señor."
,"13":"Eglón se coligó con los amonitas y los amalecitas, marchó contra Israel, lo derrotó y se apoderó de la ciudad de las palmeras."
,"14":"Los israelitas estuvieron sometidos a Eglón, rey de Moab, dieciocho años."
,"15":"Los israelitas clamaron al Señor, y el Señor hizo surgir un libertador: Ehud, hijo de Guerá, benjaminita, que era zurdo. Los israelitas le encargaron que llevase el tributo a Eglón, rey de Moab."
,"16":"Ehud se hizo un puñal de dos filos, de medio metro de largo, y se lo ciñó bajo sus vestidos, al lado derecho."
,"17":"Presentó el tributo a Eglón, rey de Moab, que era un hombre muy gordo."
,"18":"Una vez terminada la presentación del tributo, salió a despedir a los hombres que le habían acompañado;"
,"19":"pero cuando llegó al lugar llamado 'Los Ídolos', cerca de Guilgal, se volvió y dijo: 'Tengo un mensaje secreto para ti, oh rey'. El rey respondió: '¡Silencio!', y mandó salir a todos los que estaban con él."
,"20":"Ehud entró. El rey estaba sentado en la sala de verano, reservada para él solo, tomando el fresco. Ehud le dijo: 'Tengo una palabra de Dios para ti, oh rey', y éste se levantó de la silla."
,"21":"Entonces Ehud, con la mano izquierda, tomó el puñal que llevaba al lado derecho y se lo metió en el vientre."
,"22":"La empuñadura entró con la hoja, y la grasa se cerró sobre ésta, pues no sacó el puñal del vientre; luego Ehud salió por la ventana."
,"23":"Ehud salió al pórtico, después de haber cerrado tras de sí las puertas de la habitación alta y haber echado el cerrojo."
,"24":"Después que él salió, vinieron los servidores del rey y, viendo cerradas con cerrojo las puertas de la habitación alta, se dijeron: 'Sin duda está haciendo sus necesidades en la sala de verano'."
,"25":"Esperaron hasta no saber qué pensar, pues él no abría las puertas de la sala de verano. Entonces tomaron una llave y abrieron. Su señor yacía en tierra, muerto."
,"26":"Mientras ellos esperaban, Ehud huyó, pasó el lugar llamado 'Los Ídolos' y se puso a salvo en Seirá."
,"27":"Tan pronto como llegó a tierra de Israel, tocó la trompeta en la montaña de Efraín, y los israelitas bajaron con él de la montaña. Él iba en cabeza."
,"28":"Y les dijo: 'Seguidme, porque el Señor pone a vuestros enemigos, a Moab, en vuestras manos'. Ellos lo siguieron, cortaron a Moab los pasos del Jordán y no dejaron pasar a ninguno."
,"29":"Aquel día derrotaron a Moab, cerca de diez mil hombres, todos robustos y valientes, sin que escapase ni uno solo."
,"30":"Aquel día Moab quedó derrotado bajo la mano de Israel, y la tierra estuvo en paz durante cuarenta años."
,"31":"Después de él, fue juez Sangar, hijo de Anat. Él derrotó a los filisteos, en número de seiscientos hombres, con una aguijada de bueyes. También él salvó a Israel."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Después de la muerte de Ehud, los israelitas volvieron a hacer lo que desagrada al Señor,"
,"2":"y el Señor los entregó en manos de Yabín, rey de Canaán, que reinaba en Jasor, y cuyo jefe militar era Sísara, que vivía en Jaróset Goyín."
,"3":"Los israelitas clamaron al Señor, porque Yabín tenía novecientos carros de guerra y había oprimido a los israelitas durante veinte años."
,"4":"Por aquel tiempo era juez en Israel Débora, profetisa, mujer de Lapidot."
,"5":"Se sentaba bajo la palmera de Débora, entre Ramá y Betel, en la montaña de Efraín, y los israelitas subían allí para arreglar sus litigios."
,"6":"Ella mandó llamar a Barac, hijo de Abinoán, de Cades, en Neftalí, y le dijo: 'El Señor, Dios de Israel, ha ordenado esto: Vete al monte Tabor y toma contigo diez mil hombres de la tribu de Neftalí y Zabulón."
,"7":"Yo te traeré allí, al torrente Quisón, a Sísara, el jefe del ejército de Yabín, con sus carros y sus tropas, y lo entregaré en tus manos'."
,"8":"Barac respondió: 'Si vienes tú conmigo, iré; pero si no vienes, no iré, porque yo no sé en qué día el ángel del Señor me dará la victoria'."
,"9":"Débora contestó: 'Iré contigo; pero el camino que vas a recorrer no será gloria tuya, porque en manos de una mujer entregará el Señor a Sísara'. Débora se puso en camino y, con Barac, se dirigió a Cades."
,"10":"Barac reunió a Zabulón y a Neftalí en Cades; lo siguieron diez mil hombres, y Débora fue con ellos."
,"11":"Jéber, el quenita, se había separado de la tribu de Caín, de los hijos de Jobab, suegro de Moisés, y había plantado sus tiendas alrededor de la encina de Saananín, cerca de Cades."
,"12":"Sísara, al enterarse de que Barac, hijo de Abinoán, había subido al monte Tabor,"
,"13":"reunió sus novecientos carros de hierro, y todas las tropas que tenía, desde Jaróset Goyín al arroyo Quisón."
,"14":"Débora dijo a Barac: 'Levántate, éste es el día en que el Señor entregará a Sísara en tus manos. ¿No va el Señor delante de ti?'. Y Barac dejó el monte Tabor con sus diez mil hombres."
,"15":"El Señor amedrentó a Sísara, a todos sus carros y a todo su ejército ante la presencia de Barac. Sísara, bajando de su carro, huyó a pie."
,"16":"Barac persiguió a los carros y al ejército hasta Jaróset Goyín. Todo el ejército de Sísara cayó bajo el filo de la espada y no escapó ni un solo hombre."
,"17":"Sísara huyó a pie hacia la tienda de Yael, mujer de Jéber, el quenita, porque había buenas relaciones entre Yabín, rey de Jasor, y la casa de Jéber, el quenita."
,"18":"Yael salió al encuentro de Sísara y le dijo: 'Entra, señor mío, entra; no tengas ningún miedo'. Él entró en la tienda, y ella lo cubrió con una alfombra."
,"19":"Él le dijo: 'Dame de beber un poco de agua, por favor, porque tengo sed'. Ella abrió el odre de la leche, le dio de beber y lo cubrió de nuevo."
,"20":"Sísara le dijo: 'Quédate a la puerta de la tienda, y si viene alguien preguntando: ¿Hay aquí algún hombre?, responderás: No'."
,"21":"Pero Yael, mujer de Jéber, tomó un clavo de la tienda y un martillo, y se acercó silenciosamente a él y le clavó en la sien el clavo, que llegó hasta la tierra. Sísara estaba profundamente dormido, agotado de cansancio, y murió."
,"22":"Entre tanto llegó Barac, que perseguía a Sísara. Yael salió a su encuentro y le dijo: 'Ven, y te enseñaré al hombre a quien buscas'. Entró con ella. Sísara yacía muerto, con el clavo en la sien."
,"23":"Así humilló Dios aquel día a Yabín, rey de Canaán, ante los israelitas."
,"24":"La mano de los israelitas pesó cada vez más sobre Yabín, rey de Canaán, hasta que acabaron con él."
}`)
	CurrentBook.AddChapter(5, `{
"1":"En aquel día Débora y Barac, hijo de Abinoán, cantaron así:"
,"2":"'Los príncipes de Israel,se pusieron al frente, el pueblo se ofreció voluntario. ¡Bendecid al Señor!"
,"3":"Oíd, reyes; prestad atención, príncipes: yo cantaré al Señor, Dios de Israel."
,"4":"Señor, cuando tú saliste de Seír, cuando avanzaste,desde los campos de Edón, la tierra tembló, se turbó el cielo, las nubes se deshicieron en agua."
,"5":"Los montes se derritieron,ante la presencia del Señor, ante la presencia del Señor, Dios de Israel."
,"6":"En los días de Sangar, hijo de Anat, en los días de Yael, los caminos estaban desiertos; los que andaban por los caminos, iban por senderos tortuosos."
,"7":"Faltaron los jefes de Israel, faltaron; hasta que surgiste tú, oh Débora, surgiste como madre de Israel."
,"8":"Se preferían dioses extranjeros; la guerra llegaba ya a las puertas; apenas se veía un escudo o una lanza,entre los cuarenta mil de Israel."
,"9":"Mi corazón se vuelve,a los jefes de Israel, a los valientes del pueblo: ¡Bendecid al Señor!"
,"10":"Los que montáis asnas blancas, sentados sobre tapices, y vosotros los que vais,por los caminos: ¡Cantad!"
,"11":"Al clamor de los que salen,a los abrevaderos, allí se celebran las gestas del Señor, las gestas de su dominio en Israel. bajó a las puertas)."
,"12":"Despiértate, despiértate, entona un cántico. Ánimo, levántate, Barac, y lleva tus prisioneros, hijo de Abinoán."
,"13":"Entonces Israel bajó a las puertas, el pueblo del Señor salió,en su defensa con los nobles."
,"14":"Los príncipes de Efraín,están en el llano, su hermano Benjamín,entre sus tropas; de Maquir bajaron los jefes, y de Zabulón los que llevan,el bastón de mando."
,"15":"Los príncipes de Isacar,están con Débora, Isacar fue el apoyo de Barac, pues se lanzó tras él al valle. En los clanes de Rubén,hay grandes decisiones."
,"16":"¿Por qué te quedaste en tus apriscos, escuchando las flautas,de los pastores?,En los clanes de Rubén,hay grandes decisiones."
,"17":"Galaad se quedó,al otro lado del Jordán; y Dan, ¿por qué se quedó,junto a las naves?,Aser se sentó a orillas del mar, y habita tranquilo en sus puertos."
,"18":"Zabulón arriesgó su vida, como Neftalí, en lo alto de sus campos."
,"19":"Vinieron los reyes, lucharon; entonces los reyes de Canaán,combatieron en Tanac, junto a las aguas de Meguido, pero no obtuvieron un botín de plata."
,"20":"Desde los cielos combatieron,las estrellas, desde sus órbitas,combatieron a Sísara."
,"21":"El arroyo Quisón los arrastró, arroyo sagrado el arroyo Quisón, los barrió con violencia."
,"22":"Los cascos de los caballos resonaron,al galope, al galope con sus jinetes."
,"23":"Maldecid a Meroz, dijo el ángel del Señor, maldecid, maldecid a sus habitantes, que no vinieron en ayuda del Señor, en ayuda del Señor entre los héroes."
,"24":"Bendita entre las mujeres sea Yael, bendita entre las mujeres,del campamento."
,"25":"Pidió agua, ella le dio leche; en copa preciosa le sirvió nata."
,"26":"Con su mano cogió el clavo, con la derecha el martillo,de los trabajadores. Le golpeó, le rompió la cabeza, le atravesó la sien."
,"27":"A sus pies se doblegó, cayó, yació, a sus pies se derrumbó, cayó; donde se doblegó, allí cayó muerto."
,"28":"La madre de Sísara,se asoma a la ventana, mira por entre las celosías. ¿Por qué tarda en venir su carro?,¿Por qué son tan lentas,sus cuadrigas?"
,"29":"La más avisada de sus damas,responde y se repite,las mismas palabras:"
,"30":"Seguramente han encontrado botín,y lo están repartiendo; una, dos jóvenes para cada guerrero, un vestido, dos vestidos,de colores para Sísara; un vestido, dos vestidos,bordados para su cuello."
,"31":"Así perezcan todos tus enemigos, oh, Señor; y aquellos que te aman, sean como el sol,cuando se levanta con todo vigor'."
,"32":"La tierra estuvo en paz,durante cuarenta años."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Los israelitas hicieron lo que desagradaba al Señor, y el Señor los entregó en manos de Madián durante siete años."
,"2":"La mano de Madián pesó fuertemente sobre Israel. Para escapar de Madián, los israelitas se sirvieron de las cuevas, cavernas y refugios de los montes."
,"3":"Siempre que los israelitas sembraban algo, los madianitas, los amalecitas y la gente del oriente los atacaban;"
,"4":"acampaban en su tierra, devastaban las mieses de la región hasta cerca de Gaza, y no dejaban a Israel medio alguno de subsistencia, ni ovejas, ni bueyes, ni asnos."
,"5":"Subían con sus rebaños y tiendas como una nube de langosta y lo destruían todo; sus camellos eran innumerables."
,"6":"Los israelitas se vieron reducidos a gran miseria por causa de Madián, y clamaron al Señor."
,"7":"Cuando los israelitas pidieron al Señor que los librara de Madián,"
,"8":"el Señor les envió un profeta que les dijo: 'Esto dice el Señor, Dios de Israel: Yo os saqué de Egipto, de la casa de la esclavitud."
,"9":"Os libré del poder de Egipto y de todos los que os oprimían, los eché de delante de vosotros y os di a vosotros sus tierras."
,"10":"Y os dije: Yo soy el Señor, vuestro Dios. No adoraréis a los dioses de los amorreos cuyas tierras vais a ocupar. Pero vosotros no me habéis obedecido'."
,"11":"El ángel del Señor vino y se sentó bajo la encina de Ofrá, que pertenecía a Joás, de Abiezer. Gedeón, su hijo, estaba limpiando el trigo en el lagar para ocultarlo a Madián."
,"12":"El ángel del Señor se le apareció y le dijo: 'El Señor está contigo, ¡guerrero valiente!'."
,"13":"Gedeón le respondió: 'Por favor, mi Señor; si el Señor está con nosotros, ¿por qué nos sucede todo esto? ¿Dónde están todos los prodigios que nos cuentan nuestros padres diciendo: No nos sacó el Señor de Egipto? Y ahora el Señor nos ha abandonado y nos ha entregado al poder de los madianitas'."
,"14":"El Señor lo miró y le dijo: 'Vete con la fuerza que tienes y salvarás a Israel del poder de los madianitas. ¿No soy yo quien te envía?'."
,"15":"Gedeón respondió: 'Por favor, Señor, ¿cómo salvaré yo a Israel? Mi familia es la más humilde de Manasés, y yo soy el último en la casa de mi padre'."
,"16":"El Señor le respondió: 'Yo estaré contigo, y tú derrotarás a Madián como si fuese un solo hombre'."
,"17":"Gedeón le dijo: 'Si he alcanzado tu favor, dame una señal de que eres tú quien me habla."
,"18":"Por favor, no te muevas de aquí hasta que yo vuelva'. Él le dijo: 'Aquí estaré hasta que vuelvas'."
,"19":"Gedeón se fue, preparó un cabrito, y con una media fanega de harina hizo panes sin levadura; puso la carne en una cesta y el caldo en una olla, lo llevó bajo la encina y se lo presentó."
,"20":"Entonces el ángel de Dios le dijo: 'Coge la carne y los panes sin levadura, ponlos sobre esta piedra y vierte el caldo'. Gedeón lo hizo así."
,"21":"El ángel del Señor tocó la carne y los panes sin levadura con la punta del bastón que llevaba, salió fuego de la roca y consumió la carne y los panes. Y el ángel del Señor desapareció de su vista."
,"22":"Entonces Gedeón se dio cuenta de que era el ángel del Señor, y dijo: '¡Ay, Señor! ¡He visto cara a cara al ángel del Señor!'."
,"23":"El Señor respondió: 'La paz esté contigo. No tengas miedo, no morirás'."
,"24":"Gedeón levantó allí un altar al Señor y le puso por nombre 'El Señor es la paz'. Este altar está todavía en Ofrá de Abiezer."
,"25":"Aquella misma noche el Señor dijo a Gedeón: 'Toma el toro gordo de tu padre, el de siete años, destruye el altar de Baal que tiene tu padre y corta el cipo que está a su lado."
,"26":"Después construirás al Señor, tu Dios, en la cumbre de este cerro, un altar bien preparado. Entonces ofrecerás el toro gordo en holocausto con la leña que habrás cortado'."
,"27":"Gedeón tomó consigo diez hombres de entre sus siervos e hizo como el Señor le había ordenado; pero como no se atrevía a hacerlo de día, por miedo a su familia y a la gente de la ciudad, lo hizo de noche."
,"28":"Al día siguiente, cuando se levantó la gente de la ciudad, vieron que el altar de Baal había sido destruido, el cipo que estaba junto a él cortado, y el toro gordo había sido ofrecido en holocausto sobre el nuevo altar."
,"29":"Y se preguntaban unos a otros: '¿Quién ha hecho esto?'. Indagaron, se informaron y concluyeron: 'Lo ha hecho Gedeón, el hijo de Joás'."
,"30":"Entonces los hombres de la ciudad dijeron a Joás: 'Saca a tu hijo, que lo vamos a matar, porque ha destruido el altar de Baal y ha cortado el cipo que estaba junto a él'."
,"31":"Joás respondió a todos los que estaban ante él: '¿Os corresponde a vosotros defender a Baal? ¿Sois vosotros los que tenéis que salvarlo? El que tome la defensa de Baal morirá antes de mañana. Si es Dios, se defenderá por sí mismo contra el que ha destruido su altar'."
,"32":"Aquel día dieron a Gedeón el nombre de Yerubaal, pues decían: 'Que Baal se defienda de él, ya que le ha destruido su altar'."
,"33":"Los madianitas, los amalecitas y la gente del oriente se habían unido. Atravesaron el Jordán y vinieron a acampar en la llanura de Yezrael."
,"34":"Entonces el espíritu del Señor se apoderó de Gedeón, tocó la trompeta, y Abiezer le siguió."
,"35":"Envió mensajeros a todo Manasés, que también le siguió; también envió mensajeros a Aser, a Zabulón y a Neftalí, que se pusieron en marcha para venir a su encuentro."
,"36":"Gedeón dijo a Dios: 'Si de verdad quieres salvar a Israel por mi mano, como has dicho,"
,"37":"mira, voy a poner un vellón de lana al sereno; si el rocío se posa solamente sobre el vellón estando seco todo el suelo, entonces sabré que librarás a Israel por mi mano, como has dicho'."
,"38":"Y así sucedió. Gedeón se levantó al día siguiente de madrugada, tomó el vellón, lo exprimió y sacó una cazuela llena de agua."
,"39":"Gedeón dijo a Dios: 'No se encienda tu ira contra mí si te hablo todavía una vez. Permíteme que haga una última vez la prueba del vellón: que quede seco solamente el vellón y en todo el suelo haya rocío'."
,"40":"Y Dios lo hizo así aquella noche. Quedó seco totalmente el vellón y en todo el suelo había rocío."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Yerubaal, o sea, Gedeón, se levantó de madrugada y todo el pueblo que estaba con él, y acamparon en En Jarod. El campamento de los madianitas se encontraba al norte del suyo, al pie de la colina de Moré, en el valle."
,"2":"El Señor dijo a Gedeón: 'El pueblo que está contigo es excesivamente numeroso para que yo entregue a los madianitas en vuestras manos. Israel podría gloriarse contra mí, diciendo: Es mi propia mano la que me ha librado."
,"3":"Por eso, llama al pueblo y dile: El que tenga miedo y tiemble, que se vuelva y se retire'. Se retiraron del pueblo veintidós mil, y quedaron diez mil."
,"4":"El Señor dijo a Gedeón: 'Todavía es demasiada gente. Que bajen al agua, y yo los probaré. El que yo te diga: Éste irá contigo, ése irá; y todo el que yo te diga: Que éste no vaya contigo, ése no irá'."
,"5":"Gedeón hizo bajar sus tropas al agua, y el Señor le dijo: 'A todos los que lamen el agua de su mano como la lamen los perros, ponlos a un lado; y a todos los que se arrodillan para beber, ponlos a otro'."
,"6":"Los que lamieron el agua de sus manos fueron trescientos. El resto del pueblo se arrodilló para beber."
,"7":"El Señor dijo a Gedeón: 'Con los trescientos hombres que han lamido el agua os libraré y pondré a los madianitas en tus manos. Que todos los demás se vayan cada uno a su casa'."
,"8":"Aquéllos cogieron en sus manos los cántaros y trompetas del pueblo. A todos los demás hombres de Israel los mandó a cada uno a su tienda, quedándose sólo con los trescientos. El campamento de los madianitas estaba debajo del suyo, en la llanura."
,"9":"Aquella noche el Señor ordenó a Gedeón: 'Levántate, baja al campamento, porque yo los entrego en tus manos."
,"10":"Pero si tienes miedo a atacar, baja al campamento con tu siervo Furá y"
,"11":"escucha lo que ellos dicen; después de esto cobrarás más ánimo y caerás sobre el campamento'. Bajó él con su siervo Furá hasta los últimos puestos de los hombres armados del campamento."
,"12":"Los madianitas, los amalecitas y la gente de oriente estaban desplegados en el valle, tan numerosos como langostas; sus camellos eran innumerables, como la arena que hay a orillas del mar."
,"13":"Cuando llegó Gedeón, un hombre estaba contando un sueño a un compañero suyo. Decía: 'He tenido un sueño: veía un pan redondo de cebada que rodaba por el campamento de los madianitas. Llegó a la tienda, chocó contra ella, le dio la vuelta y la derribó en tierra'."
,"14":"Su compañero le contestó: 'Esto no es otra cosa que la espada de Gedeón, hijo de Joás, de Israel. Dios ha entregado en su mano a los madianitas y a todo el campamento'."
,"15":"Cuando Gedeón oyó el sueño y su explicación, se prosternó. Volvió al campamento de Israel y dijo: 'Arriba, porque el Señor ha entregado en vuestras manos el campamento de los madianitas'."
,"16":"Gedeón dividió sus trescientos hombres en tres bandos. Puso en sus manos las trompetas y los cántaros vacíos y dentro de ellos teas encendidas,"
,"17":"y les dijo: 'Miradme a mí y haced lo que yo haga. Cuando llegue yo a los límites del campamento, lo que haga yo, hacedlo vosotros también."
,"18":"Yo tocaré la trompeta, yo y todos los que están conmigo; entonces vosotros tocaréis también las trompetas en torno al campamento y gritaréis: ¡Por el Señor y por Gedeón!'."
,"19":"Gedeón y los que estaban con él llegaron a los límites del campamento a medianoche cuando acababan de relevarse los centinelas, tocaron las trompetas y rompieron los cántaros que llevaban en la mano."
,"20":"Entonces los tres bandos tocaron las trompetas y rompieron los cántaros; con la mano izquierda agarraron las teas encendidas y con la derecha las trompetas para tocarlas, y gritaron: '¡Por el Señor y por Gedeón!'."
,"21":"Ellos quedaron cada uno en su puesto alrededor del campamento, y todo el campamento se puso a correr, a gritar y a huir."
,"22":"Mientras los trescientos tocaban las trompetas, el Señor hizo que cada uno volviese la espada contra su compañero. Todos huyeron hasta Bet Hassitá, hacia Serera, hasta la ribera de Abel Mejolá, frente por frente de Tabat."
,"23":"Entonces se reunieron los hombres de Israel, de Neftalí, de Aser y de todo Manasés y persiguieron a los madianitas."
,"24":"Gedeón envió mensajeros a toda la montaña de Efraín, diciendo: 'Bajad al encuentro de los madianitas y ocupad antes que ellos las fuentes hasta Bet Bará y el Jordán'. Y todos los efraimitas respondieron a la llamada y ocuparon los vados a lo largo del Jordán hasta Bet Bará."
,"25":"Hicieron prisioneros a los dos jefes madianitas, Oreb y Zeb; mataron a Oreb en la roca de Oreb, y a Zeb en el lagar de Zeb. Persiguieron a los madianitas, y llevaron a Gedeón, al otro lado del Jordán, las cabezas de Oreb y Zeb."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Los de la tribu de Efraín dijeron a Gedeón: '¿Qué manera es ésta de obrar con nosotros? ¿Cómo no nos has convocado cuando ibas a luchar contra los madianitas?'. Y se querellaron fuertemente contra él."
,"2":"Él les respondió: '¿Qué he hecho yo en comparación con vosotros? ¿Acaso no ha sido mejor el rebusco de Efraín que la vendimia de Abiezer?"
,"3":"El Señor puso en vuestras manos a los jefes madianitas, Oreb y Zeb. Lo que yo he hecho, ¿puede compararse con lo que habéis hecho vosotros?'. Ante estas palabras, ellos se calmaron."
,"4":"Gedeón, con sus trescientos, llegó al Jordán y lo atravesó. Él y los que lo acompañaban estaban muertos de hambre y de sed."
,"5":"Entonces dijo a la gente de Sucot: 'Dad, por favor, tortas de pan a la gente que me sigue, porque están extenuados, y yo quiero continuar persiguiendo a Zébaj y a Salmuná, reyes madianitas'."
,"6":"Pero los jefes de Sucot respondieron: '¿Acaso tienes ya en tus manos a Zébaj y a Salmuná, para que debamos suministrar pan a tu ejército?'."
,"7":"Gedeón contestó: 'Bien, cuando el Señor entregue en mi mano a Zébaj y a Salmuná, yo desgarraré vuestras carnes con espinas y cardos del desierto'."
,"8":"Desde allí subió a Penuel y les hizo la misma petición. Los hombres de Penuel respondieron lo mismo que los de Sucot."
,"9":"Y él les replicó de la misma manera: 'Cuando vuelva vencedor, destruiré esta torre'."
,"10":"Zébaj y Salmuná estaban en Carcor con sus ejércitos, alrededor de quince mil hombres, todos los que habían quedado del ejército del oriente. Habían caído ciento veinte mil guerreros."
,"11":"Gedeón subió por el camino de los beduinos, al este de Nóbaj y de Yogbohá, y atacó el campamento cuando menos lo esperaban."
,"12":"Zébaj y Salmuná huyeron; pero Gedeón los persiguió, e hizo prisioneros a los dos reyes de Madián, Zébaj y Salmuná, y derrotó a todo su ejército."
,"13":"Gedeón, hijo de Joás, volviendo de la batalla por la subida de Jares,"
,"14":"apresó a un joven de Sucot, le preguntó, y él le dio por escrito los nombres de los jefes de Sucot y de sus ancianos: setenta y siete hombres."
,"15":"Gedeón se presentó a la gente de Sucot, y dijo: 'Aquí están Zébaj y Salmuná, por los que os burlasteis de mí diciendo: ¿Acaso tienes ya en tus manos a Zébaj y a Salmuná para que debamos suministrar pan a tu ejército?'."
,"16":"Él apresó a los ancianos de Sucot y, con espinas y cardos del desierto, desgarró las carnes de las gentes de Sucot."
,"17":"Destruyó la torre de Penuel y mató a los hombres de la ciudad."
,"18":"Después preguntó a Zébaj y Salmuná: '¿Cómo eran los hombres que matasteis en el Tabor?'. Ellos respondieron: 'Eran como tú; cada uno de ellos parecía un príncipe'."
,"19":"Gedeón dijo: 'Eran hermanos míos, hijos de mi madre. ¡Por la vida del Señor! ¡Si los hubieseis dejado vivos, yo no os mataría!'."
,"20":"Y mandó a Yéter, su primogénito: 'Anda, mátalos'. Pero el joven no desenvainó la espada; no se atrevía, porque era todavía joven."
,"21":"Entonces Zébaj y Salmuná dijeron: 'Ánimo, mátanos tú; porque como es el hombre, así es su fuerza'. Entonces Gedeón se levantó, mató a Zébaj y Salmuná y se quedó con las lunetas que llevaban al cuello sus camellos."
,"22":"Los israelitas dijeron a Gedeón: 'Reina sobre nosotros tú, tu hijo y tu nieto, porque nos has librado de la mano de los madianitas'."
,"23":"Pero Gedeón les respondió: 'No reinaré yo sobre vosotros ni mi hijo, porque es el Señor quien debe reinar sobre vosotros'."
,"24":"Y añadió: 'Quiero pediros una cosa: Dadme cada uno de vosotros un anillo de los del botín, pues como los vencidos eran ismaelitas tenían anillos de oro'."
,"25":"Le contestaron: 'Te los damos con mucho gusto'. Él extendió su manto, y cada uno echó un anillo del botín."
,"26":"El peso de los anillos de oro que él había pedido ascendió a veinte kilos, sin contar las lunetas, los pendientes y los vestidos de púrpura que llevaban los reyes madianitas ni los collares que colgaban del cuello de sus camellos."
,"27":"Gedeón hizo con ellos un efod, que colocó en su ciudad, en Ofrá. Todo Israel se prostituyó ante él, y esto fue para Gedeón y su casa la causa de su ruina."
,"28":"Los madianitas quedaron sometidos a los israelitas y no volvieron a levantar cabeza. El país estuvo en paz cuarenta años mientras vivió Gedeón."
,"29":"Yerubaal, hijo de Joás, se fue a vivir a su casa."
,"30":"Gedeón tuvo setenta hijos, pues tenía muchas mujeres."
,"31":"También su concubina, que vivía en Siquén, le dio un hijo, al que puso por nombre Abimelec."
,"32":"Gedeón, hijo de Joás, murió en buena ancianidad y fue sepultado en la tumba de su padre, Joás, en Ofrá de Abiezer."
,"33":"Al morir Gedeón, los israelitas volvieron a prostituirse ante los baales y tomaron por dios a Baal Berit."
,"34":"Se olvidaron del Señor, su Dios, que los había librado de la mano de todos sus enemigos de alrededor,"
,"35":"y no demostraron agradecimiento a la casa de Yerubaal, o sea Gedeón, por todo el bien que había hecho a Israel."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Abimelec, hijo de Yerubaal, se fue a Siquén, a casa de los hermanos de su madre, y dirigió a ellos y a toda la familia de la casa de su madre estas palabras:"
,"2":"'Haced saber, por favor, a todos los nobles de Siquén: ¿Qué es mejor para vosotros: ser gobernados por setenta hombres, todos los hijos de Yerubaal, o ser gobernados por uno solo? Pensad, además, que yo soy hueso vuestro y carne vuestra'."
,"3":"Los hermanos de su madre hablaron de él a todos los nobles de Siquén, conforme a aquellas palabras, y se pusieron de parte de Abimelec, porque decían: 'Es nuestro hermano'."
,"4":"Y le dieron setenta monedas de plata del templo de Baal Berit. Con ellas Abimelec pagó el sueldo a mercenarios y aventureros que le siguieron."
,"5":"Fue a casa de su padre, a Ofrá, y mató a sus hermanos, los hijos de Yerubaal, setenta hombres, sobre una misma piedra. Sólo se salvó Jotán, el hijo menor de Yerubaal, porque se había escondido."
,"6":"Los hijos nobles de Siquén y de Bet Miló se reunieron y proclamaron a Abimelec junto a la encina de la estela que está en Siquén."
,"7":"Cuando Jotán lo supo, fue a situarse en la cumbre del monte Garizín, levantó su voz y dijo: '¡Oídme, nobles de Siquén, y que Dios os escuche!"
,"8":"Una vez los árboles se pusieron en camino para ungir un rey que reinase sobre ellos. Dijeron al olivo: Reina sobre nosotros."
,"9":"El olivo les respondió: ¿Voy a renunciar yo al aceite con el cual se honra a Dios y a los hombres para ir a balancearme sobre los árboles?"
,"10":"Entonces los árboles dijeron a la higuera: Ven tú, reina sobre nosotros."
,"11":"La higuera les respondió: ¿Voy yo a renunciar a mi dulzura y a mi excelente fruto para ir a balancearme sobre los árboles?"
,"12":"Entonces los árboles dijeron a la vid: Ven tú, reina sobre nosotros."
,"13":"La vid les respondió: ¿Voy a renunciar a mi mosto, alegría de Dios y de los hombres, para venir a balancearme sobre los árboles?"
,"14":"Por fin, los árboles dijeron a la zarza espinosa: Ven tú, reina sobre nosotros."
,"15":"La zarza espinosa les respondió: Si de verdad queréis ungirme por vuestro rey, venid y refugiaos a mi sombra; y si no, saldrá fuego de la zarza y devorará a los cedros del Líbano."
,"16":"Ahora bien, si habéis obrado de buena fe y con justicia al elegir por rey a Abimelec, si os habéis portado bien con Yerubaal y con su casa, si lo habéis tratado según sus méritos,"
,"17":"pues mi padre luchó por vosotros y expuso su propia vida para libraros del poder de los madianitas,"
,"18":"y vosotros os habéis levantado hoy contra la casa de mi padre, habéis matado a sus hijos, setenta hombres, sobre la misma piedra, y habéis puesto por rey sobre los nobles de Siquén a Abimelec, el hijo de una esclava suya, porque es vuestro hermano;"
,"19":"si habéis obrado de buena fe y con justicia con Yerubaal y su casa en el día de hoy, entonces que Abimelec sea vuestra gloria y vosotros la suya."
,"20":"Pero si no, que salga fuego de Abimelec y devore a los nobles de Siquén y de Bet Miló, y que salga fuego de los nobles de Siquén y de Bet Miló para devorar a Abimelec'."
,"21":"Después Jotán huyó y se fue a vivir en Beer, lejos de Abimelec, su hermano."
,"22":"Abimelec gobernó durante tres años a Israel."
,"23":"Después el Señor mandó un espíritu de discordia entre Abimelec y los nobles de Siquén, y los nobles de Siquén se levantaron contra Abimelec,"
,"24":"para que el crimen cometido contra los setenta hijos de Yerubaal y su sangre cayese sobre Abimelec, su hermano, que los había matado, y sobre los nobles de Siquén, que le dieron el poder para matar a sus hermanos."
,"25":"Los nobles de Siquén pusieron emboscadas sobre las cumbres de las montañas y asaltaban a todos los que pasaban por el camino. Y Abimelec se enteró de esto."
,"26":"Gaal, hijo de Obed, con sus hermanos, vino a pasar por Siquén, y los nobles de Siquén pusieron su confianza en él;"
,"27":"ellos salieron al campo, vendimiaron sus viñas, pisaron la uva y organizaron una gran fiesta; entraron en el templo de su dios, comieron y bebieron y maldijeron a Abimelec."
,"28":"Entonces Gaal, hijo de Obed, dijo: '¿Qué es Abimelec y quién es Siquén para que debamos ser sus siervos? ¿No sirvió el hijo de Yerubaal y Zebul, su lugarteniente, a las gentes de Jamor, padre de Siquén? ¿Por qué, entonces, debemos servirles nosotros?"
,"29":"¡Quién pusiera este pueblo en mis manos! Quitaría de en medio a Abimelec y le diría: Refuerza tu ejército y sal a la batalla'."
,"30":"Cuando Zebul, gobernador de la ciudad, se enteró de lo que andaba diciendo Gaal, hijo de Obed, montó en cólera,"
,"31":"y envió mensajeros a Abimelec para decirle: 'Gaal, hijo de Obed, con sus hermanos, ha llegado a Siquén y están agitando a la ciudad contra ti."
,"32":"Por tanto, sal esta noche con tu gente y ponte en emboscada en el campo."
,"33":"Mañana por la mañana, a la salida del sol, levántate y cae sobre la ciudad. Cuando Gaal, con su gente, salga contra ti, haz con ellos lo que mandan las circunstancias'."
,"34":"Abimelec salió de noche con toda su gente, y se pusieron en emboscada frente a Siquén en cuatro bandos."
,"35":"Gaal, hijo de Obed, salió y se detuvo a la puerta de la ciudad. Abimelec y su gente salieron de la emboscada."
,"36":"Gaal los vio y dijo a Zebul: 'Mira la gente que baja de la cumbre de los montes'. Zebul le respondió: 'Son las sombras de los montes que te parecen hombres'."
,"37":"Gaal insistió: 'Unos bajan por el ombligo de la tierra y otro bando viene por el camino de la encina de los adivinos'."
,"38":"Zebul le dijo: '¿Dónde está ahora tu boca, que decía: Quién es Abimelec para que le sirvamos? ¿No es ésta la gente a la que tú despreciabas? Sal ahora y preséntales batalla'."
,"39":"Salió Gaal a la cabeza de los nobles de Siquén y entabló batalla con Abimelec."
,"40":"Pero Abimelec lo derrotó y lo puso en fuga, y muchos cayeron muertos antes de alcanzar la puerta de la ciudad."
,"41":"Abimelec se quedó en Arumá, y Zebul echó de Siquén a Gaal y a sus hermanos."
,"42":"Al día siguiente los de Siquén se echaron al campo. Cuando Abimelec lo supo,"
,"43":"tomó a su gente, la dividió en tres bandos y se puso en emboscada en el campo. Cuando los vio salir de la ciudad, se lanzó contra ellos y los derrotó."
,"44":"Abimelec y su gente se desplegaron y tomaron posiciones en la puerta de la ciudad. Los otros dos cuerpos se desplegaron contra los que estaban en el campo y los mataron."
,"45":"Abimelec luchó todo aquel día contra la ciudad, se apoderó de ella y mató a todos sus habitantes y la destruyó y sembró de sal."
,"46":"Cuando los nobles de Torre Siquén lo supieron, se refugiaron en la cripta del templo de El Berit."
,"47":"Cuando Abimelec lo supo,"
,"48":"subió con su gente al monte Salmón. Abimelec agarró un hacha, cortó una rama de un árbol, la levantó y la puso sobre sus espaldas. Y dijo a su gente: 'Haced rápidamente lo mismo que me habéis visto hacer a mí'."
,"49":"Toda la tropa cortó una rama; siguieron a Abimelec, amontonaron las ramas sobre la cripta del templo y les prendieron fuego. Y perecieron todos los de Torre Siquén, alrededor de mil entre hombres y mujeres."
,"50":"Después Abimelec se dirigió a Tebes, la sitió y la tomó."
,"51":"En medio de la ciudad había una torre fortificada. Todos los hombres y mujeres de la ciudad se refugiaron en ella, cerraron la puerta por dentro y subieron a lo alto de la torre."
,"52":"Abimelec llegó a la torre y la sitió; se acercó a la puerta para prenderle fuego,"
,"53":"cuando una mujer tiró sobre la cabeza de Abimelec una piedra de molino y le rompió el cráneo."
,"54":"Él llamó rápidamente a su escudero y le dijo: 'Saca tu espada y mátame, para que no se diga de mí: le mató una mujer'. Su escudero lo atravesó, y murió."
,"55":"Cuando los israelitas vieron que Amibelec había muerto, cada uno se marchó a su casa."
,"56":"Así hizo caer Dios sobre la cabeza de Abimelec todo el mal que él había hecho a su padre, matando a sus setenta hermanos."
,"57":"Dios hizo igualmente recaer sobre la cabeza de los hombres de Siquén el mal que habían hecho, cumpliéndose la maldición de Jotán, el hijo de Yerubaal."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Después de Abimelec surgió, para salvar a Israel, Tolá, hijo de Fuá, hijo de Dodó, de la tribu de Isacar. Habitaba en Samir, en la montaña de Efraín."
,"2":"Fue juez en Israel durante veintitrés años. Murió y fue sepultado en Samir."
,"3":"Después de él surgió Yaír, de Galaad. Fue juez en Israel durante veintidós años."
,"4":"Tuvo treinta hijos, que montaban treinta asnos y tenían treinta ciudades llamadas Javot Yaír hasta el día de hoy, en Galaad."
,"5":"Yaír murió y fue sepultado en Camón."
,"6":"Los israelitas volvieron a hacer lo que desagrada al Señor; dieron culto a los Baales y Astartés y a los dioses de Arán y de Sidón, a los dioses de Moab, a los de los amonitas y filisteos. Abandonaron al Señor y dejaron de darle culto."
,"7":"La ira del Señor se encendió contra ellos y los entregó en manos de los filisteos y de los amonitas."
,"8":"Los amonitas y los filisteos oprimieron cruelmente durante dieciocho años a los israelitas de Transjordania, en el país amorreo, en Galaad."
,"9":"Los amonitas pasaron el Jordán para combatir a Judá, a Benjamín y a la casa de Efraín, e Israel se vio en grave aprieto."
,"10":"Los israelitas clamaron al Señor: 'Hemos pecado contra ti, porque hemos abandonado al Señor, nuestro Dios, para adorar a los Baales'."
,"11":"El Señor respondió: 'Cuando los egipcios y los amorreos, los amonitas y los filisteos,"
,"12":"los sidonios, amalecitas y madianitas os oprimían y clamasteis a mí, ¿no os salvé yo de su mano?"
,"13":"Pero vosotros me abandonasteis para adorar a otros dioses. Por eso no os salvaré ya más."
,"14":"Id, clamad a los dioses que os habéis elegido. ¡Que os salven ellos cuando estéis en aprietos!'."
,"15":"Los israelitas respondieron al Señor: '¡Hemos pecado! Haz con nosotros lo que te parezca bien; pero, por favor, líbranos ahora'."
,"16":"Quitaron de en medio de ellos los dioses extranjeros y adoraron al Señor. Y él no pudo soportar por más tiempo la aflicción de Israel."
,"17":"Los amonitas se reunieron y vinieron a acampar en Galaad; se reunieron también los israelitas y acamparon en Mispá."
,"18":"Entonces el pueblo, los jefes de Galaad, se dijeron unos a otros: 'El que comience a atacar a los amonitas, ése será el jefe de todos los habitantes de Galaad'."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Jefté, el galaadita, era un hombre fuerte y valiente. Era hijo de una prostituta. Su padre era Galaad."
,"2":"La mujer de Galaad le dio también otros hijos; y cuando crecieron, éstos echaron a Jefté y le dijeron: 'Tú no tendrás parte en la herencia de nuestro padre, porque eres hijo de una mujer extraña'."
,"3":"Jefté se fue lejos de sus hermanos y se estableció en el país de Tob. Se juntó con él una pandilla de bandoleros, que hacían incursiones bajo su mando."
,"4":"Al cabo de algún tiempo, los amonitas declararon la guerra a Israel,"
,"5":"y los ancianos de Galaad fueron a buscar a Jefté al país de Tob."
,"6":"Y le dijeron: 'Ven, sé nuestro caudillo en la guerra contra los amonitas'."
,"7":"Jefté les contesto: '¿No sois vosotros los que me odiabáis y me echásteis de la casa de mi padre? ¿Por qué recurrís a mí ahora que os encontráis angustiados?'."
,"8":"Los ancianos de Galaad le respondieron: 'Precisamente por eso recurrimos ahora a ti. Ven con nosotros para luchar contra los amonitas y serás nuestro jefe, el jefe de todos los habitantes de Galaad'."
,"9":"Jefté contestó: 'Si me hacéis volver con vosotros para luchar contra los amonitas y el Señor los entrega en mi mano, entonces seré vuestro jefe'."
,"10":"Los ancianos de Galaad le respondieron: 'Que el Señor sea testigo entre nosotros; aceptamos tu propuesta'."
,"11":"Jefté partió con ellos, y el pueblo lo eligió como jefe y caudillo. Y Jefté repitió en Mispá, ante el Señor, lo que antes había dicho."
,"12":"Jefté envió mensajeros al rey de los amonitas con esta misión: '¿Qué tienes contra mí para que vengas a hacerme la guerra en mi tierra?'."
,"13":"El rey de los amonitas respondió a los mensajeros de Jefté: 'Porque Israel, cuando venía de Egipto, se apoderó de mi tierra desde el Arnón hasta el Yaboc y hasta el Jordán. Así que ahora devuélvemela pacíficamente'."
,"14":"De nuevo Jefté envió mensajeros al rey de los amonitas"
,"15":"con esta respuesta: 'Esto dice Jefté: Israel no se apoderó de la tierra de los moabitas ni de la de los amonitas,"
,"16":"porque cuando venía de Egipto, cruzó el desierto hasta el mar Rojo y llegó a Cades."
,"17":"Desde allí Israel envió mensajeros al rey de Edón, diciendo: Déjame pasar, por favor, por tu tierra. Pero el rey de Edón no les dejó pasar. Envió también mensajeros al rey de Moab, pero él tampoco le dejó pasar. Por eso se quedó en Cades."
,"18":"Después marchó por el desierto, rodeando la tierra de Edón y de Moab, y llegó al este de Moab. Acampó al otro lado del río Arnón, sin entrar en los términos de Moab, porque Arnón es la frontera de Moab."
,"19":"Israel envió entonces mensajeros a Sijón, rey de los amorreos, rey de Jesbón, pidiéndole que le dejara pasar por su tierra hasta llegar a su destino."
,"20":"Pero Sijón no le dejó pasar por su territorio y, además, reunió a todo el pueblo, acampó en Yahsá y atacó a Israel."
,"21":"El Señor, Dios de Israel, entregó a Sijón y a todo su pueblo en manos de Israel, que los derrotó; e Israel se apoderó de todo el país de los amorreos que vivían en aquella región,"
,"22":"y así ocupó todo el término de los amorreos desde el Arnón hasta el Yaboc y desde el desierto hasta el Jordán."
,"23":"Y si el Señor, Dios de Israel, expulsó a los amorreos ante su pueblo, Israel, ¿quieres tú ahora quitarle su posesión?"
,"24":"¿No posees tú todo lo que Camós, tu dios, ha quitado a los que lo poseían? Así, lo que el Señor, nuestro Dios, ha quitado a los que lo poseían, lo poseemos nosotros."
,"25":"¿Acaso eres tú mejor que Balac, hijo de Sipor, rey de Moab? ¿Ha entrado él en discusión con Israel? ¿Le ha declarado la guerra?"
,"26":"Hace trescientos años que Israel vive en Jesbón y en sus ciudades anejas, en Aroar y en sus ciudades anejas y en todas las ciudades de la ribera del Arnón; ¿por qué no las habéis reclamado en todo este tiempo?"
,"27":"Por tanto, yo no te he ofendido, pero tú me haces injuria declarándome la guerra. Que el Señor, el juez, juzgue hoy entre los israelitas y los amonitas'."
,"28":"Pero el rey de los amonitas no escuchó las palabras que Jefté le mandó a decir."
,"29":"El espíritu del Señor vino sobre Jefté, que recorrió Galaad y Manasés, pasó a Mispá de Galaad, y de allí al territorio de los amonitas."
,"30":"Jefté hizo este voto al Señor: 'Si pones en mis manos a los amonitas,"
,"31":"el primero que salga de la puerta de mi casa para venir a mi encuentro cuando vuelva vencedor de los amonitas le ofreceré en holocausto al Señor'."
,"32":"Jefté marchó contra los amonitas y el Señor los entregó en sus manos."
,"33":"Los derrotó desde Aroer hasta Minit, veinte ciudades, y hasta Abel Keramín. Fue una gran derrota, y los israelitas dominaron a los amonitas."
,"34":"Cuando Jefté volvió de Mispá a su casa, su hija salió a su encuentro con tímpano y danzas. Era hija única. No tenía más hijos."
,"35":"Cuando la vio, rasgó sus vestiduras y gritó: '¡Ah, hija mía, infortunado de mí! Tú eres la causa de mi desgracia, pues he hecho una promesa al Señor y no puedo desdecirme'."
,"36":"Ella le respondió: 'Si has hecho una promesa al Señor, padre mío, haz conmigo lo que has prometido, ya que el Señor te ha concedido vengarte de tus enemigos, los amonitas'."
,"37":"Después dijo a su padre: 'Concédeme esta gracia: déjame libre durante dos meses para ir por los montes con mis compañeras llorando mi virginidad'."
,"38":"Él respondió: 'Vete'. Y la dejó libre durante dos meses. Ella y sus compañeras fueron por los montes y lloraron su virginidad."
,"39":"Pasados los dos meses, ella volvió a su padre, y éste cumplió con ella la promesa que había hecho. Ella no había tenido relaciones con ningún hombre; de aquí viene la costumbre de Israel"
,"40":"de que todos los años las israelitas vayan a llorar a la hija de Jefté, el galaadita, durante cuatro días."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Los de la tribu de Efraín se reunieron, pasaron a Safón y dijeron a Jefté: '¿Por qué fuiste a luchar contra los amonitas sin llamarnos para ir contigo? Vamos a prender fuego a tu casa y a ti'."
,"2":"Jefté les respondió: 'Mi pueblo y yo estábamos en una situación grave, oprimidos por los amonitas. Entonces os llamé a vosotros, y no vinisteis a ayudarnos."
,"3":"Viendo que nadie me socorría, expuse mi vida, ataqué a los amonitas y el Señor los entregó en mi mano. ¿Por qué venís ahora a hacerme la guerra?'."
,"4":"Entonces Jefté reunió a todos los hombres de Galaad, dio la batalla a Efraín, y los hombres de Galaad vencieron a los de Efraín. Los de Efraín decían que los de Galaad, que vivían entre Efraín y Manasés, eran fugitivos de Efraín."
,"5":"Los de Galaad quitaron a los de Efraín los vados del Jordán, y cuando los fugitivos de Efraín decían: 'Dejadnos pasar', les preguntaban: '¿Eres tú de Efraín?'. Si respondían: 'No',"
,"6":"le replicaban: 'Di, entonces, sibbólet'. Si él repetía sibbólet y no pronunciaba correctamente, lo agarraban y lo mataban en los vados del Jordán. En aquella ocasión murieron cuarenta y dos mil hombres de Efraín."
,"7":"Jefté fue juez de Israel durante seis años; murió y fue sepultado en Mispá de Galaad, su patria."
,"8":"Después de él fue juez de Israel Ibsán, de Belén."
,"9":"Tenía treinta hijos y treinta hijas. Casó a sus hijas fuera y trajo de fuera mujeres para sus hijos. Fue juez de Israel durante siete años."
,"10":"Murió y fue sepultado en Belén."
,"11":"Después de él fue juez de Israel, Elón, de Zabulón, durante diez años."
,"12":"Murió y fue sepultado en Ayalón, en la tierra de Zabulón."
,"13":"Después de él fue juez de Israel Abdón, hijo de Hilel, de Piratón."
,"14":"Tuvo cuarenta hijos y treinta nietos, que montaban setenta asnos. Fue juez de Israel durante ocho años."
,"15":"Murió y fue sepultado en la tierra de Efraín, en el monte de Salín."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Los israelitas volvieron a hacer lo que desagrada al Señor, y el Señor los entregó en manos de los filisteos durante cuarenta años."
,"2":"Había un hombre en Sorá, de la tribu de Dan, llamado Manóaj, cuya mujer era estéril. No había tenido ningún hijo."
,"3":"El ángel del Señor se apareció a esta mujer y le dijo: 'Tú eres estéril y no has tenido ningún hijo;"
,"4":"pero ahora ten cuidado; no bebas vino ni otras bebidas alcohólicas, ni comas nada impuro,"
,"5":"porque vas a concebir y darás a luz un hijo. No se le cortará el cabello, porque el niño estará consagrado al Señor desde el vientre de su madre. Él comenzará a salvar a Israel de la mano de los filisteos'."
,"6":"La mujer fue a contárselo a su marido: 'Me ha venido a ver un hombre de Dios; tenía el aspecto de un ángel de Dios, lleno de majestad. No le pregunté de dónde era ni él me dijo su nombre."
,"7":"Pero me dijo: Vas a concebir y darás a luz un hijo. No bebas vino ni otras bebidas alcohólicas, ni comas nada impuro, porque el niño estará consagrado a Dios desde el vientre de su madre hasta el día de su muerte'."
,"8":"Entonces Manóaj oró así al Señor: 'Te suplico, Señor mío, que el hombre de Dios que enviaste vuelva otra vez y nos diga lo que debemos hacer con el niño que va a nacer'."
,"9":"Dios escuchó la súplica de Manóaj, y el ángel del Señor se apareció otra vez a la mujer cuando estaba en el campo; no estaba con ella su marido."
,"10":"La mujer fue corriendo a avisar a su marido y le dijo: 'El hombre que vi el otro día se me ha vuelto a aparecer'."
,"11":"Manóaj se levantó, siguió a su mujer, llegó donde estaba el hombre y le dijo: '¿Eres tú el que ha hablado a esta mujer?'. Él respondió: 'Yo soy'."
,"12":"Manóaj le preguntó: 'Cuando se cumpla tu palabra, ¿qué norma hemos de seguir con el niño? ¿Qué haremos con él?'."
,"13":"El ángel del Señor le respondió: 'Que la mujer haga todo lo que le he dicho:"
,"14":"que no beba vino ni ningún otro producto de la uva, ni otras bebidas alcohólicas, y que no coma nada impuro. Que haga todo lo que le he mandado'."
,"15":"Manóaj dijo al ángel del Señor: 'Quédate con nosotros y te prepararemos un cabrito'."
,"16":"El ángel del Señor le respondió: 'Aunque me quedara, no comería tus manjares; pero, si quieres, prepara un holocausto y ofréceselo al Señor'. Manóaj no sabía que era el ángel del Señor,"
,"17":"y preguntó al ángel del Señor: '¿Cómo te llamas, para que cuando se cumpla tu palabra te estemos agradecidos?'."
,"18":"El ángel del Señor le respondió: '¿Para qué preguntas por mi nombre? Es misterioso'."
,"19":"Manóaj tomó el cabrito y la ofrenda y lo ofreció en holocausto sobre la roca al Señor, que hace maravillas."
,"20":"Cuando subía la llama del altar hacia el cielo, el ángel del Señor subió en la misma llama a la vista de Manóaj y de su mujer, que cayeron rostro en tierra."
,"21":"El ángel del Señor no se apareció más a Manóaj y a su mujer. Entonces comprendió Manóaj que era el ángel del Señor."
,"22":"Y dijo a su mujer: 'Moriremos, porque hemos visto al Señor'."
,"23":"Su mujer le respondió: 'Si el Señor quisiese hacernos morir, no hubiese aceptado el holocausto ni la ofrenda ni nos hubiese revelado todas estas cosas'."
,"24":"La mujer dio a luz un hijo y le puso por nombre Sansón. El niño crecía y el Señor le bendecía."
,"25":"Y el espíritu del Señor comenzó a actuar en él en el campo de Dan, entre Sorá y Estaol."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Sansón bajó a Timná y se fijó en una joven filistea."
,"2":"A su regreso dijo a sus padres: 'He visto en Timná a una joven filistea: pedídmela por esposa'."
,"3":"Sus padres le respondieron: '¿Es que no hay una mujer en nuestra tribu o en todo Israel, para que vayas a buscar mujer entre esos filisteos incircuncisos?'. Sansón respondió a su padre: 'Dame ésa, porque me gusta'."
,"4":"Sus padres no sabían que lo había dispuesto así el Señor, el cual buscaba un pretexto para atacar a los filisteos, que, por entonces, oprimían a Israel."
,"5":"Bajaba Sansón a Timná, y, al llegar a las viñas de Timná, le salió al encuentro un cachorro de león rugiendo."
,"6":"El espíritu del Señor se apoderó de Sansón y, con sólo las manos, desgarró al león como se desgarra un cabrito. Pero no contó a sus padres lo que había hecho."
,"7":"Bajó y habló con la joven que le gustaba."
,"8":"Después de algún tiempo volvió para casarse con ella; se desvió de su camino para ver el cadáver del león, y vio en los huesos del león un enjambre de abejas con miel."
,"9":"Sacó el panal con la mano y se fue comiendo la miel por el camino. Cuando alcanzó a sus padres, les dio y comieron; pero no les dijo que lo había cogido de la osamenta del león."
,"10":"El padre de Sansón fue a casa de la joven, y Sansón dio una fiesta, como era costumbre entre los mozos."
,"11":"Y como los filisteos le tenían miedo, eligieron treinta mozos para acompañarle."
,"12":"Sansón les dijo: 'Os voy a proponer un acertijo. Si lo adivináis dentro de los siete días de la fiesta, os daré treinta piezas de lino fino y treinta vestidos preciosos."
,"13":"Pero si no lo adivináis, me daréis vosotros las treinta piezas de lino fino y los treinta vestidos preciosos'. Ellos le respondieron: 'Dinos el acertijo: te escuchamos'."
,"14":"Él les dijo: 'Del que come salió comida, y del fuerte salió dulzura'. Durante tres días no pudieron resolver el acertijo. "
,"15":"Al cuarto día dijeron a la mujer de Sansón: 'Convence a tu marido para que te dé la solución del acertijo; de lo contrario, te quemaremos a ti y la casa de tu padre. ¿Es que nos habéis invitado para quitarnos lo nuestro?'."
,"16":"La mujer de Sansón se echó en brazos de él, llorando, y le dijo: 'Tú me odias, no me amas. Has propuesto un acertijo a mis paisanos y no me lo has explicado a mí'. Él le respondió: 'No se lo he explicado ni a mi padre ni a mi madre, ¿y te lo voy a explicar a ti?'."
,"17":"Ella le estuvo llorando los siete días que duraba la fiesta. Tanto le insistió que, por fin, al séptimo día se lo explicó, y ella dio a sus paisanos la solución del acertijo."
,"18":"El séptimo día, antes de que Sansón entrase en la habitación, los filisteos le dijeron: ¿Qué hay más dulce que la miel, qué hay más fuerte que el león?'. Él les replicó: 'Si no hubieseis arado con mi novilla, no habríais adivinado mi acertijo'."
,"19":"Entonces el espíritu del Señor se apoderó de Sansón, bajó a Ascalón y mató a treinta hombres, les quitó sus vestidos y se los dio a los que habían adivinado su acertijo; y, enfurecido, se volvió a la casa de su padre."
,"20":"La mujer de Sansón fue dada a uno de los compañeros que le había servido de mozo de compañía."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Algún tiempo después, en los días de la siega del trigo, Sansón fue a ver a su mujer. Le llevaba un cabrito. Y dijo: 'Quiero entrar a ver a mi mujer en la alcoba'. Pero el suegro no le dejó entrar,"
,"2":"y le dijo: 'Creí que ya no la querías y se la di a un compañero tuyo. Pero su hermana menor es más hermosa que ella. Tómala en su lugar'."
,"3":"Sansón le dijo: 'Ahora sí que soy inocente del mal que voy a hacer a los filisteos'."
,"4":"Se fue, cazó trescientas zorras, las ató por el rabo de dos en dos y puso una tea entre los rabos;"
,"5":"después prendió fuego a las teas y soltó a las zorras en las mieses de los filisteos; así incendió las gavillas y el trigo sin segar, las viñas y los olivos."
,"6":"Los filisteos preguntaron: '¿Quién ha hecho esto?'. Y les dijeron: 'Ha sido Sansón, el yerno del timnita, porque éste le ha quitado su mujer y se la ha dado a un compañero suyo'. Entonces los filisteos subieron y quemaron a la mujer y la casa de su padre."
,"7":"Sansón les dijo: 'Por haber hecho esto, yo no estaré tranquilo hasta que me haya vengado de vosotros'."
,"8":"Y les dio tal paliza que no les dejó hueso sano. Después se fue a vivir a la roca de Etán."
,"9":"Los filisteos fueron y acamparon en Judá y llegaron hasta Lejí."
,"10":"Los hombres de Judá les preguntaron: '¿Por qué habéis venido contra nosotros?'. Ellos respondieron: 'Hemos venido para atar a Sansón, para tratarle como él nos ha tratado'."
,"11":"Tres mil hombres de Judá fueron a la cueva de Etán para decir a Sansón: '¿No sabes que estamos bajo el dominio de los filisteos? ¿Qué es lo que has hecho?'. Él les respondió: 'Los he tratado como ellos me trataron a mí'."
,"12":"Entonces le dijeron: 'Hemos venido para atarte y entregarte en manos de los filisteos'. Sansón respondió: 'Juradme que no me mataréis'."
,"13":"Ellos le dijeron: 'No, nosotros solamente queremos atarte y entregarte en sus manos, pero no te mataremos'. Lo ataron con dos sogas nuevas y lo sacaron de la roca."
,"14":"Cuando llegó a Lejí, los filisteos corrieron a su encuentro. Entonces el espíritu del Señor se apoderó de él; las sogas con que estaba atado fueron como hilos de lino quemados por el fuego y las ataduras de sus brazos se deshicieron."
,"15":"Vio cerca una quijada de asno fresca, la agarró y mató a mil hombres:"
,"16":"Sansón dijo: 'Con la quijada de asno,los he zurrado bien; con la quijada de asno,he matado a mil hombres'."
,"17":"Terminó y tiró la quijada; por eso aquel lugar se llama Ramat Lejí."
,"18":"Devorado por la sed, clamó al Señor: 'Tú me has dado esta gran victoria, ¿y ahora me voy a morir de sed y a caer en manos de esos incircuncisos?'."
,"19":"El Señor abrió la pila que hay en Lejí, y salió de ella agua. Sansón bebió y se reanimó. Por eso a la fuente de Lejí se la llama hasta la fecha En Hacoré."
,"20":"Sansón fue juez de Israel durante veinte años, en la época de los filisteos."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Sansón se fue a Gaza, donde había una prostituta, y entró en su casa."
,"2":"Cuando los de Gaza supieron que Sansón estaba allí, la cercaron y estuvieron todo el día en acecho a las puertas de la ciudad. Por la noche se fueron tranquilos a sus casas diciendo: 'Al venir el día lo mataremos'."
,"3":"Sansón estuvo acostado hasta medianoche; a medianoche se levantó, cogió las dos hojas de las puertas de la ciudad, con los postes y el cerrojo, se las echó al hombro y se las llevó a la cima del monte que está frente por frente de Hebrón."
,"4":"Sansón se enamoró de una mujer del valle de Sorec, llamada Dalila."
,"5":"Los jefes de los filisteos fueron a verla, y le dijeron: 'Sedúcele y averigua de dónde le viene su extraordinaria fuerza y cómo podríamos atarle y reducirle a la impotencia. Te daremos cada uno mil cien monedas de plata'."
,"6":"Dalila dijo a Sansón: 'Dime, por favor, de dónde te viene tu extraordinaria fuerza y de qué modo podrías ser atado y sujetado'."
,"7":"Sansón le contestó: 'Si me atasen con siete cuerdas humedecidas, sin dejarlas secar, perdería mi fuerza y sería como otro hombre cualquiera'."
,"8":"Los jefes de los filisteos le llevaron las siete cuerdas humedecidas, sin secar, y Dalila lo ató con ellas."
,"9":"Tenía gentes escondidas en su habitación, y le gritó: '¡Sansón, los filisteos!'. Él rompió las cuerdas como se rompe un hilo de estopa quemado, y así no se conoció el secreto de su fuerza."
,"10":"Dalila dijo a Sansón: 'Te has burlado de mí, me has mentido. Dime, por favor, cómo habría que atarte'."
,"11":"Él respondió: 'Si me atasen fuertemente con sogas nuevas que nunca se hayan usado, perdería mi fuerza y sería como otro hombre cualquiera'."
,"12":"Dalila tomó sogas nuevas, lo ató con ellas, y le gritó: '¡Sansón, los filisteos!'. Tenía gentes escondidas en su habitación, pero él rompió las cuerdas que tenía sobre los brazos como si fueran un hilo."
,"13":"Dalila dijo a Sansón: 'Te has burlado de mí, me has mentido. Dime cómo habría que atarte'. Él respondió: 'Si me entretejes las siete trenzas de mi cabeza con hilos y las sujetas con un clavo de tejedor, perdería mi fuerza y sería como otro hombre cualquiera'."
,"14":"Ella le durmió y entretejió las siete trenzas de su cabeza con hilos y las sujetó con un clavo de tejedor, y gritó: '¡Sansón, los filisteos!'. Él se despertó y arrancó los hilos y el clavo de tejedor. Y así no se conoció el secreto de su fuerza."
,"15":"Dalila le dijo: '¡No digas que me amas cuando tu corazón no está conmigo! Por tres veces te has burlado de mí y no me dices el secreto de tu extraordinaria fuerza'."
,"16":"Y tanto le insistía día tras día con la misma pregunta que Sansón, ya desesperado,"
,"17":"le dijo la verdad: 'No me he cortado nunca el cabello, porque estoy consagrado a Dios desde el vientre de mi madre. Si me lo cortasen, perdería toda mi fuerza y sería como otro hombre cualquiera'."
,"18":"Dalila comprendió entonces que le había dicho la verdad. Y mandó llamar a los jefes de los filisteos, diciendo: 'Subid, porque esta vez me ha dicho la verdad'. Y los jefes de los filisteos fueron con el dinero en la mano."
,"19":"Ella durmió a Sansón sobre sus rodillas y llamó a un hombre, que le cortó las siete trenzas de su cabeza. Entonces él comenzó a perder su fuerza hasta que la perdió por completo."
,"20":"Ella dijo: '¡Sansón, los filisteos!'. Él se despertó y se dijo: 'Saldré como tantas otras veces y me las arreglaré'. Pero no sabía que el Señor lo había abandonado."
,"21":"Los filisteos lo apresaron, le sacaron los ojos y lo llevaron a Gaza. Lo sujetaron con dos cadenas de bronce y le pusieron a moler el grano en la cárcel."
,"22":"Entretanto su cabellera comenzó a crecer como antes."
,"23":"Los jefes de los filisteos se reunieron para ofrecer un gran sacrificio a Dagón, su dios, y celebrar su triunfo; y decían: 'Nuestro dios ha puesto en nuestras manos a Sansón, nuestro enemigo'."
,"24":"El pueblo, al verlo, alababa a su dios, gritando: 'Nuestro dios ha puesto,en nuestras manos,a Sansón, nuestro enemigo, que asolaba nuestros campos,y mató a tantos de los nuestros'."
,"25":"En medio de su alegría, dijeron: 'Que traigan a Sansón para que nos divierta'. Lo sacaron de la cárcel y se divirtieron con él. Lo habían puesto entre las columnas."
,"26":"Entonces Sansón dijo al joven que lo llevaba de la mano: 'Llévame hasta las columnas sobre las que descansa el edificio para que pueda apoyarme en ellas'."
,"27":"El edificio estaba lleno de hombres y de mujeres. Estaban todos los jefes de los filisteos, y en la parte de arriba había unos tres mil hombres y mujeres viendo cómo se divertían con Sansón."
,"28":"Entonces Sansón invocó al Señor así: 'Señor, Señor, te lo suplico, acuérdate de mí. Dame las fuerzas tan sólo una vez más, y de un solo golpe me vengaré de todos los filisteos por la pérdida de mis ojos'."
,"29":"Sansón palpó las dos columnas centrales sobre las que descansaba el edificio, e hizo fuerza sobre ellas, sobre una con la mano derecha y sobre la otra con la mano izquierda."
,"30":"Y gritó: 'Muera yo con los filisteos'. Se agarró con todas sus fuerzas, y el edificio se derrumbó sobre los jefes y sobre todo el pueblo que estaba allí. Fueron más los que mató al morir que los que había matado durante su vida."
,"31":"Sus hermanos y toda su familia fueron y se lo llevaron. Lo sepultaron entre Sorá y Estaol, en la tumba de Manóaj, su padre. Fue juez de Israel durante veinte años."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Había un hombre en la montaña de Efraín llamado Micá,"
,"2":"el cual dijo a su madre: 'Las mil cien monedas de plata que te quitaron y por las que maldijiste al ladrón, las tengo yo, las robé yo. Te las devuelvo'. La madre le respondió: 'Que Dios te bediga, hijo mío'."
,"3":"Él devolvió las mil cien monedas de plata a su madre, y ella dijo: 'Quiero consagrar este dinero al Señor y que de mi mano pase a la de mi hijo para hacer con él una imagen tallada y chapeada'."
,"4":"Tomó doscientas monedas de plata y se las dio al fundidor, el cual hizo con ellas una imagen tallada y chapeada, que fue colocada en la casa de Micá."
,"5":"Así Micá llegó a tener un santuario; hizo un efod e ídolos familiares y nombró sacerdote a uno de sus hijos."
,"6":"En aquel tiempo no había rey en Israel; cada cual hacía lo que le parecía mejor."
,"7":"Había en Belén un levita extranjero, de la tribu de Judá."
,"8":"Salió de Belén de Judá para establecerse donde pudiese. En su caminar llegó a la montaña de Efraín, a casa de Micá."
,"9":"Micá le preguntó: '¿De dónde vienes?'. Él le respondió: 'Soy un levita de Belén de Judá, y voy de camino para establecerme donde pueda'."
,"10":"Micá le dijo: 'Quédate conmigo y sé para mí un padre y sacerdote; te daré diez monedas de plata al año, de vestir y de comer'."
,"11":"El levita consintió en quedarse, y fue para él como uno de sus hijos."
,"12":"Micá le dio la investidura sacerdotal, de forma que el joven le hizo de sacerdote y vivió en su casa."
,"13":"Micá dijo: 'Ahora estoy seguro de que el Señor me bendecirá porque tengo a este levita por sacerdote'."
}`)
	CurrentBook.AddChapter(18, `{
"1":"En aquel tiempo no había rey en Israel. La tribu de Dan buscaba un territorio donde establecerse, porque hasta entonces no había recibido heredad entre las tribus de Israel."
,"2":"Los de Dan enviaron a cinco hombres valientes de Sorá y Estaol para reconocer la región y explorarla. Les dijeron: 'Id a explorar la tierra'. Los cinco hombres llegaron a la montaña de Efraín, a casa de Micá, y allí pasaron la noche."
,"3":"Cuando estaban cerca de la casa de Micá, reconocieron la voz del joven levita, fueron y le dijeron: '¿Quién te ha traído aquí? ¿Qué haces tú aquí? ¿En qué te ocupas?'."
,"4":"Él les respondió: 'Micá ha hecho conmigo esto y lo otro. Me da un salario, y yo le sirvo de sacerdote'."
,"5":"Ellos le dijeron: 'Consulta a Dios si tendrá éxito el viaje que estamos haciendo'."
,"6":"El sacerdote les respondió: 'Id en paz; el viaje que hacéis está bajo los auspicios del Señor'."
,"7":"De allí los cinco hombres se fueron a Lais. Vieron que las gentes de esta ciudad vivían seguros, a la manera de los sidonios, tranquilos y pacíficos, y que nada les faltaba de cuanto produce la tierra; además estaban lejos de los sidonios y sin relación alguna con los arameos."
,"8":"Regresaron a Sorá y Estaol, y sus hermanos les preguntaron: '¿Qué nuevas traéis?'."
,"9":"Ellos respondieron: 'Hemos ido y recorrido la región hasta Lais. ¡Ánimo! Vamos a atacarlos, porque hemos visto que la tierra es muy buena. No dudéis en poneros en camino para conquistar aquella tierra."
,"10":"Cuando lleguéis, os encontraréis con un pueblo sin defensa. Es una región espaciosa que Dios ha puesto en vuestras manos, y en la que no falta de nada'."
,"11":"Seiscientos hombres de la tribu de Dan salieron de Sorá y Estaol bien armados"
,"12":"y acamparon en Quiriat Yearín, en Judá. Por eso aquel lugar se llama todavía hoy 'el campamento de Dan'. Está al poniente de Quiriat Yearín."
,"13":"Desde allí pasaron a la montaña de Efraín y llegaron a casa de Micá."
,"14":"Los cinco hombres que habían ido a explorar el país dijeron a sus compañeros: '¿No sabéis que en esta casa hay un efod, ídolos familiares y una imagen tallada y chapeada? Pensad lo que conviene hacer'."
,"15":"Fueron a la casa del joven levita, la casa de Micá, y le saludaron."
,"16":"Los seiscientos hombres armados se pusieron a la entrada de la puerta."
,"17":"Y los cinco hombres que habían ido a explorar el país entraron, se apoderaron de la imagen tallada y chapeada, el efod y los ídolos familiares, mientras que el sacerdote estaba a la entrada de la puerta con los seiscientos hombres armados."
,"18":"Entonces el sacerdote les dijo: '¿Qué estáis haciendo?'."
,"19":"Ellos respondieron: 'Cállate; cierra la boca, ven con nosotros y serás para nosotros padre y sacerdote. ¿Qué es mejor para ti: ser sacerdote de una casa particular o ser el sacerdote de una tribu y de un clan de Israel?'."
,"20":"El sacerdote se alegró, tomó el efod, los ídolos familiares y la imagen tallada y chapeada y se fue con ellos."
,"21":"Ellos se pusieron en marcha poniendo en cabeza a las mujeres, los niños, los rebaños y las cosas de valor."
,"22":"Estaban ya lejos, cuando Micá y sus vecinos se reunieron y se pusieron en su persecución."
,"23":"Al oír los gritos de sus perseguidores, los de Dan se volvieron y preguntaron a Micá: '¿Qué te pasa para gritar así?'."
,"24":"Él respondió: '¿Me habéis robado el dios que me había hecho y el sacerdote y me habéis dejado sin nada, y todavía me preguntáis qué me pasa?'."
,"25":"Los de Dan le contestaron: 'No alces la voz, no sea que perdamos la paciencia y nos lancemos sobre vosotros con riesgo de tu vida y la de tu familia'."
,"26":"Y los de Dan siguieron su camino. Micá, viendo que eran más fuertes, se dio la vuelta y volvió a su casa."
,"27":"Y ellos, con el ídolo que se había hecho Micá y el sacerdote que tenía a su servicio, marcharon contra Lais, un pueblo tranquilo y confiado, lo pasaron a espada y prendieron fuego a la ciudad."
,"28":"No hubo nadie que los socorriese, porque estaban lejos de Sidón y no tenían relación alguna con los arameos. Estaba situada en el valle que se extiende hasta Bet Rejob. Ellos reedificaron la ciudad y se instalaron en ella."
,"29":"Y la llamaron Dan, de Dan, su padre, hijo de Israel. Antiguamente se llamaba Lais."
,"30":"Los de Dan entronizaron el ídolo para adorarlo, y Jonatán, hijo de Guersón, hijo de Moisés, él y sus hijos, fueron los sacerdotes de la tribu de Dan hasta el destierro."
,"31":"Y tuvieron entronizado el ídolo durante todo el tiempo que la casa de Dios estuvo en Silo."
}`)
	CurrentBook.AddChapter(19, `{
"1":"En aquel tiempo, cuando no había rey en Israel, un levita que vivía en la montaña de Efraín tomó por concubina a una mujer de Belén de Judá."
,"2":"Ella se disgustó con él y se fue a casa de su padre, a Belén de Judá, y estuvo allí cuatro meses."
,"3":"Su marido fue a buscarla para convencerla de que volviera con él. Llevaba consigo un criado y dos asnos. Ella lo hizo entrar en casa;"
,"4":"el suegro, al verlo, lo recibió con alegría y lo hizo quedarse con ellos. El levita y su criado estuvieron allí tres días, comiendo, bebiendo y durmiendo."
,"5":"Al cuarto día se levantó de madrugada para irse; pero el padre de la joven le dijo: 'Come algo antes de irte, aunque sea un pedazo de pan'."
,"6":"Y los dos se sentaron, comieron y bebieron. Después el padre de la joven le dijo: 'Anda, quédate y pasa contento aquí una noche más'."
,"7":"El levita se levantó para irse, pero su suegro le instó tanto a que se quedara, que se quedó allí a pasar la noche."
,"8":"El quinto día se levantó de madrugada para irse, pero el padre de la joven le dijo: 'Come algo antes de salir para recobrar las fuerzas'. Y así se les pasó el tiempo, hasta declinar el día, comiendo los dos juntos."
,"9":"El levita se levantó para irse con su concubina y su criado, pero su suegro le dijo: 'Mira, ya es tarde; pasa aquí contento la noche; mañana os iréis de madrugada'."
,"10":"Pero el levita no quiso pasar allí la noche. Se levantó y se fue. Avistaron a Jebús, o sea, Jerusalén. Llevaba los dos asnos cargados, la concubina y el criado."
,"11":"Cuando llegaron cerca de Jebús, era el atardecer, y el criado dijo a su amo: 'Vayamos a esta ciudad de los jebuseos para pasar en ella la noche'."
,"12":"Su amo le respondió: 'No debemos entrar en una ciudad de extranjeros, donde no hay israelitas: sigamos hasta Guibeá;"
,"13":"anda, intentemos llegar a uno de estos lugares para pasar la noche: Guibeá o Ramá'."
,"14":"Pasaron de largo y continuaron su camino. Llegaron a Guibeá de Benjamín a la puesta del sol,"
,"15":"y se dispusieron a pasar allí la noche. Entraron y se sentaron en la plaza de la ciudad, pero nadie les ofreció su casa para pasar la noche."
,"16":"En esto llegó un anciano, que venía de trabajar del campo. Era un hombre de la montaña de Efraín, que vivía en Guibeá; las gentes del lugar eran benjaminitas."
,"17":"Vio a aquel viajero en la plaza de la ciudad, y le dijo: '¿De dónde vienes y adónde vas?'."
,"18":"Él respondió: 'Venimos de Belén de Judá y vamos a la montaña de Efraín. Yo soy de allí. Fui a Belén de Judá, y ahora vuelvo a mi casa; pero nadie quiere hospedarme en su casa."
,"19":"Tenemos paja y forraje para nuestros asnos, y pan y vino para mí, para tu sierva y para el joven que acompaña a tu siervo. No nos falta nada'."
,"20":"El anciano le dijo: 'La paz esté contigo; yo te daré todo lo que te haga falta, pero no pases la noche en la plaza'."
,"21":"Los llevó a su casa, echó de comer a sus asnos, se lavaron los pies y después comieron y bebieron."
,"22":"Cuando más contentos estaban, unos hombres pervertidos de la ciudad empezaron a dar golpes a la puerta y a decir al anciano dueño de la casa: 'Sácanos al hombre que ha entrado en tu casa para que abusemos de él'."
,"23":"El dueño de la casa salió y les dijo: 'No, hermanos míos, no hagáis semejante barbaridad, por favor. Ya que está en mi casa, no debéis hacer esta infamia."
,"24":"Aquí está mi hija, que es virgen; os la sacaré fuera para que abuséis de ella y hagáis con ella lo que queráis; pero no cometáis con este hombre semejante infamia'."
,"25":"Pero no quisieron escucharlo. Entonces el levita les sacó a su concubina. Ellos abusaron de ella durante toda la noche hasta la mañana, y al salir la aurora la dejaron."
,"26":"Al amanecer, la mujer fue a la casa donde estaba su marido y cayó muerta a la puerta."
,"27":"Su marido se levantó, abrió la puerta de la casa para salir y continuar su camino, cuando vio a su concubina caída a la entrada de la casa con las manos en el umbral."
,"28":"Él le dijo: 'Levántate y vámonos'. Ella no respondió. Entonces la cargó sobre su asno y se puso en camino para ir a su casa."
,"29":"Cuando llegó a su casa, tomó un cuchillo, descuartizó el cadáver de su concubina en doce trozos y los mandó por todo el territorio de Israel."
,"30":"Todos los que lo veían comentaban: 'Hay que reflexionar y pensar lo que hay que hacer. Nunca ha sucedido ni se ha visto cosa semejante desde que los israelitas salieron de Egipto hasta hoy'."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Todos los israelitas como un solo hombre, desde Dan hasta Berseba y la región de Galaad, fueron a reunirse ante el Señor en Mispá."
,"2":"Los jefes de todo el pueblo, todas las tribus de Israel, asistieron a la asamblea del pueblo de Dios, cuatrocientos mil hombres de a pie que sabían manejar la espada."
,"3":"Los de la tribu de Benjamín supieron que los israelitas se habían reunido en Mispá. Los israelitas preguntaron: 'Contadnos cómo se ha cometido este crimen'."
,"4":"Entonces el levita, el marido de la víctima, les dijo: 'Yo llegué con mi concubina a Guibeá de Benjamín para pasar la noche."
,"5":"Los de Guibeá durante la noche rodearon la casa donde yo estaba con idea de matarme, y de tal manera abusaron de mi concubina que murió."
,"6":"Yo descuarticé en trozos su cadáver, los mandé por todo el territorio para que todo Israel se enterara del crimen tan cruel."
,"7":"Vosotros, como israelitas, deliberad y tomad una decisión'."
,"8":"Todo el pueblo se levantó como un solo hombre, diciendo: 'Ninguno de nosotros volverá a su tienda, ninguno volverá a su casa."
,"9":"Vamos a echar suertes a ver a quién le toca atacar a Guibeá;"
,"10":"uno de cada diez hombres de todas las tribus de Israel se encargará de conseguir víveres para el ejército; los demás irán a dar su merecido a Guibeá de Benjamín por la infamia que han cometido en Israel'."
,"11":"Todos los israelitas se unieron, como un solo hombre, para atacar a la ciudad."
,"12":"Las tribus de Israel enviaron mensajeros a la tribu de Benjamín para decir: '¿Qué crimen es éste que se ha cometido entre vosotros?"
,"13":"Entregad a esos hombres perversos que hay en Guibeá para que los matemos y hagamos desaparecer el mal de en medio de Israel'. Pero los de Benjamín no hicieron caso a sus hermanos, los israelitas."
,"14":"Los benjaminitas salieron de todas las ciudades y se reunieron en Guibeá para ir a luchar contra los israelitas."
,"15":"Los benjaminitas, venidos de todas las ciudades, sumaron veinticinco mil hombres diestros en el manejo de la espada, sin contar los de Guibeá."
,"16":"Entre ellos había setecientos hombres elegidos, zurdos, capaces de tirar una piedra contra un pelo sin errar el blanco."
,"17":"Y los israelitas, prescindiendo de los de Benjamín, eran cuatrocientos mil, todos gente de guerra y diestros en el manejo de la espada;"
,"18":"fueron a Betel para consultar a Dios: '¿Quién de nosotros subirá el primero a luchar contra los de Benjamín?'. El Señor respondió: 'Judá'."
,"19":"Los israelitas se pusieron en marcha por la mañana y acamparon en Guibeá"
,"20":"para luchar contra Benjamín, colocándose en orden de batalla contra ellos."
,"21":"Pero los de Benjamín hicieron una salida desde Guibeá y mataron en aquel día a veintidós mil israelitas."
,"22":"Los israelitas fueron a Betel, estuvieron llorando ante el Señor hasta la tarde y le consultaron: '¿Volveremos a luchar contra nuestros hermanos de Benjamín?'. El Señor respondió: 'Id contra él'."
,"23":"Entonces los israelitas se hicieron fuertes y volvieron a presentar batalla en el mismo lugar del día anterior."
,"24":"Se acercaron de nuevo a los de Benjamín,"
,"25":"pero los de Benjamín salieron a su encuentro desde Guibeá y mataron a otros dieciocho mil israelitas diestros en el manejo de la espada."
,"26":"Entonces todo el ejército de Israel y todo el pueblo fueron a Betel y allí lloraron ante el Señor y ayunaron aquel día hasta la tarde y ofrecieron al Señor holocaustos y sacrificios de reconciliación."
,"27":"Después consultaron al Señor. En aquel tiempo estaba allí el arca de la alianza del Señor,"
,"28":"y Fineés, hijo de Eleazar, hijo de Aarón, estaba a su servicio. Ellos preguntaron: '¿Saldremos otra vez a luchar contra nuestros hermanos de Benjamín, o nos damos por vencidos?'. El Señor contestó: 'Id, porque mañana los entregaré en vuestras manos'."
,"29":"Los israelitas tendieron una emboscada en torno a Guibeá;"
,"30":"al tercer día marcharon contra los de Benjamín y se pusieron en orden de batalla frente a Guibeá, como las otras veces."
,"31":"Los de Benjamín salieron a su encuentro, alejándose de la ciudad como las veces anteriores; mataron a unos treinta hombres por los caminos de Betel y de Gabaón."
,"32":"Los de Benjamín decían: 'Están derrotados ante nosotros, como la vez anterior'. Pero los israelitas se decían: 'Huyamos para traerlos lejos de la ciudad'."
,"33":"Entonces, mientras los israelitas se movieron de su puesto y se pusieron en orden de batalla en Baal Tamar, la emboscada de Israel surgió de su puesto al poniente de Guibeá."
,"34":"Y llegaron frente a Guibeá diez mil hombres escogidos de todo Israel. El combate fue duro, pues los de Benjamín no se dieron cuenta del mal que se les echaba encima."
,"35":"El Señor derrotó a Benjamín ante Israel, y los israelitas mataron aquel día veinticinco mil cien benjaminitas diestros en el manejo de la espada."
,"36":"Los de Benjamín se dieron cuenta de que estaban derrotados. Los israelitas habían cedido terreno a Benjamín porque confiaban en la emboscada que habían tendido junto a Guibeá."
,"37":"Los emboscados se desplegaron rápidamente sobre Guibeá, y pasaron a espada a toda la ciudad."
,"38":"Los israelitas habían convenido con los emboscados, como señal, que éstos harían surgir de la ciudad una columna de humo."
,"39":"Los israelitas volvieron la espalda en el combate. Benjamín había matado a unos treinta hombres de Israel y se decía: 'Están vencidos ante nosotros, como en la batalla anterior'."
,"40":"Pero entonces comenzó a levantarse de la ciudad la señal, una columna de humo; y Benjamín, volviendo los ojos atrás, se dio cuenta del incendio de la ciudad, que subía al cielo."
,"41":"Los israelitas les hicieron frente, y los de Benjamín, aterrados ante el desastre que les venía encima,"
,"42":"huyeron por el camino del desierto, pero los que venían de la ciudad los alcanzaron y los mataron;"
,"43":"los cercaron, los persiguieron y los derrotaron frente al oriente de Guibeá."
,"44":"Cayeron dieciocho mil benjaminitas, todos hombres valientes."
,"45":"Los otros volvieron la espalda y huyeron al desierto, hacia la roca de Rimón. Los israelitas mataron a cinco mil hombres por las subidas; después los persiguieron hasta Guidón y mataron a dos mil hombres."
,"46":"El total de los que cayeron de Benjamín aquel día fue de veinticinco mil hombres, todos diestros en el manejo de la espada y hombres valientes."
,"47":"Seiscientos hombres pudieron huir al desierto, a la roca de Rimón, y permanecieron allí durante cuatro meses."
,"48":"Los israelitas atacaron a los de Benjamín y los pasaron a espada, a los hombres, a los animales y a todo lo que encontraron. A todas las ciudades que encontraron les prendieron fuego."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Los israelitas habían hecho este juramento en Mispá: 'Ninguno de nosotros dará su hija a ninguno de Benjamín por mujer'."
,"2":"El pueblo fue a Betel y estuvo allí hasta la tarde ante Dios, levantando su voz y haciendo gran llanto, y decían:"
,"3":"'¿Por qué, oh Señor, Dios de Israel, ha pasado esto, que Israel haya sido privado de una de sus tribus?'."
,"4":"Al día siguiente el pueblo se levantó de madrugada, erigió allí un altar y ofreció holocaustos y sacrificios de reconciliación."
,"5":"Se preguntaron: '¿Quién de entre todas las tribus de Israel no acudió a la asamblea del Señor?'. Porque habían jurado solemnemente que quien no subiese a Mispá ante el Señor sería castigado con la muerte."
,"6":"Los israelitas se compadecieron de su hermano Benjamín. Y se decían: 'Hoy ha sido cortada de Israel una tribu."
,"7":"'¿Qué haremos para dar mujeres a los que quedan? Porque hemos jurado ante el Señor no darles nuestras hijas por mujeres'."
,"8":"Entonces se preguntaron: '¿Hay alguno de entre las tribus de Israel que no haya subido a Mispá ante el Señor?'. Y resultó que ninguno de Yabés de Galaad había venido al campamento, a la asamblea."
,"9":"El pueblo había sido contado y, en efecto, no había ninguno de Yabés de Galaad."
,"10":"Entonces la asamblea envió doce mil hombres de los más valientes con esta orden: 'Id y pasad a espada a todos los habitantes de Yabés de Galaad, a las mujeres y a los niños."
,"11":"Matad a todos los varones y a todas las mujeres que no sean vírgenes, pero dejad con vida a las vírgenes'. Así lo hicieron."
,"12":"Entre los habitantes de Galaad encontraron cuatrocientas vírgenes y las llevaron al campamento de Silo, en la tierra de Canaán."
,"13":"Toda la asamblea envió mensajeros a los de Benjamín, que estaban en la roca de Rimón, para ofrecerles la paz."
,"14":"Los de Benjamín regresaron, y los israelitas les dieron por mujeres las que habían quedado con vida en Yabés de Galaad; pero no había bastantes para todos."
,"15":"El pueblo se compadeció de Benjamín, porque el Señor había abierto una brecha en las tribus de Israel."
,"16":"Los ancianos de la comunidad se preguntaron: '¿Qué haremos para procurar mujeres a los que faltan, pues las mujeres de Benjamín fueron exterminadas?'."
,"17":"Y añadieron: '¿Cómo conservar un resto de Benjamín para que no desaparezca una tribu de Israel?"
,"18":"Porque nosotros no podemos darles por mujeres a nuestras hijas, ya que los israelitas hicieron este juramento: Maldito quien dé mujer a Benjamín'."
,"19":"Después dijeron: 'Está cerca la fiesta del Señor que se celebra todos los años en Silo, ciudad situada al norte de Betel, al oriente del camino que sube de Betel a Siquén y al sur de Leboná'."
,"20":"Y mandaron decir a los de Benjamín: 'Id y poneos en emboscada en las viñas."
,"21":"Os quedáis observando y, cuando veáis que las muchachas de Silo salen para bailar en coro, salís vosotros de las viñas y os lleváis cada uno una y os volvéis a vuestra tierra."
,"22":"Cuando sus padres o sus hermanos vengan a querellarse con vosotros, les diremos: Perdonadlos por haber tomado cada uno su mujer, como en guerra; porque si se las hubieseis dado vosotros, entonces vosotros seríais culpables'."
,"23":"Los de Benjamín lo hicieron así y tomaron de entre las que bailaban una cada uno. Después volvieron cada uno a su heredad, edificaron las ciudades y se establecieron en ellas."
,"24":"Los israelitas se fueron cada uno a su tribu y a su clan y volvieron cada uno a su heredad."
,"25":"En aquel tiempo no había rey en Israel y cada cual hacía lo que quería."
}`)

}
func ES_LSB_LoadVHIEChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Después de la muerte de Moisés, siervo del Señor, dijo el Señor a Josué, hijo de Nun y colaborador de Moisés:"
,"2":"'Moisés, mi siervo, ha muerto; ahora comienzas a actuar tú. Pasa el Jordán, que tienes a la vista, tú y todo este pueblo, hacia la tierra que voy a dar a los israelitas."
,"3":"Todo lugar que pisen vuestros pies os lo doy, como dije a Moisés."
,"4":"Vuestro territorio abarcará desde el desierto y el Líbano hasta el gran río, el Éufrates, y, por el oeste, hasta el mar Mediterráneo."
,"5":"Nadie podrá resistir ante ti mientras vivas; yo estaré contigo como estuve con Moisés; no te dejaré ni te abandonaré."
,"6":"Sé fuerte y ten ánimo, porque tú deberás dar a este pueblo la posesión de la tierra que a sus padres juré dar."
,"7":"Ten valor y firmeza para cumplir fielmente todo lo que te ordenó Moisés, mi siervo; no te desvíes ni a la derecha ni a la izquierda, para que tengas éxito en todas tus empresas."
,"8":"Que el libro de esta ley esté siempre en tu boca; medítalo día y noche para cumplir exactamente todo lo que está escrito en él. De este modo serás afortunado en todas tus empresas y tendrás éxito."
,"9":"Yo te lo mando. Sé fuerte y ten ánimo. No temas ni te asustes, porque el Señor, tu Dios, estará contigo dondequiera que vayas'."
,"10":"Entonces Josué dio a los jefes del pueblo la orden siguiente:"
,"11":"'Recorred el campamento y dad esta orden al pueblo: Haced provisiones, porque dentro de tres días pasaréis el Jordán para tomar posesión de la tierra que el Señor, vuestro Dios, os da en propiedad'."
,"12":"Después dijo a los rubenitas, a los gaditas y a la mitad de la tribu de Manasés:"
,"13":"'Recordad lo que os mandó Moisés, siervo del Señor, diciendo: El Señor, vuestro Dios, os concede el descanso al daros esta tierra."
,"14":"Vuestras mujeres, vuestros hijos y vuestros ganados pueden quedar en la tierra que os dio Moisés en Transjordania; pero vosotros, todos los hombres de guerra, iréis armados al frente de vuestros hermanos y les prestaréis vuestra ayuda,"
,"15":"hasta que el Señor dé un lugar de descanso a vuestros hermanos, como os lo ha dado a vosotros, y posean también ellos la tierra que el Señor, vuestro Dios, les da. Después podéis volver a la tierra que os pertenece para poseerla y que os dio Moisés, siervo del Señor, en Transjordania'."
,"16":"Ellos respondieron a Josué: 'Haremos todo lo que nos has mandado e iremos donde nos envíes."
,"17":"Lo mismo que obedecimos en todo a Moisés, así te obedeceremos a ti. Únicamente, que el Señor, tu Dios, esté contigo como estuvo con Moisés."
,"18":"Aquel que sea rebelde a tu voz y no obedezca tus órdenes en cualquier cosa que le mandes, morirá. Solamente una cosa: ¡Ten valor y firmeza!'."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Josué, hijo de Nun, envió secretamente desde Sittín dos espías con esta consigna: 'Id a explorar la tierra de Jericó'. Ellos fueron y entraron en casa de una prostituta llamada Rajab, y se alojaron allí."
,"2":"Llegó al rey de Jericó la noticia en estos términos: 'Unos israelitas han venido aquí esta noche para explorar el país'."
,"3":"Entonces el rey de Jericó mandó decir a Rajab: 'Saca a los hombres que han entrado en tu casa, porque son espías'."
,"4":"Pero ella los escondió y dijo: 'Sí, esos hombres vinieron a mi casa, pero yo no sabía de dónde eran;"
,"5":"al oscurecer, cuando se iba a cerrar la puerta de la ciudad, los hombres salieron, y no sé dónde fueron. Daos prisa, perseguidlos y seguro que los alcanzaréis'."
,"6":"Pero ella los había hecho subir a la azotea y los había escondido entre las cañas de lino que tenía allí."
,"7":"Los enviados del rey marcharon en su persecución camino del Jordán, hacia los vados, y se cerró la puerta después que salieron los que iban en su persecución."
,"8":"Antes que los espías se echaran a dormir, Rajab subió a la azotea"
,"9":"y les dijo: 'Yo sé que el Señor os ha dado esta tierra; nosotros estamos llenos de miedo, y todos los habitantes de la región tiemblan ante vosotros,"
,"10":"porque hemos oído cómo el Señor secó las aguas del mar Rojo ante vosotros cuando salíais de Egipto y cómo habéis tratado a los reyes amorreos de Transjordania, a Sijón y a Og, a quienes exterminasteis."
,"11":"Al oírlo nos hemos descorazonado ante vosotros, porque el Señor, vuestro Dios, es Dios tanto arriba en los cielos como abajo en la tierra."
,"12":"Ahora bien, os pido que me juréis por el Señor que, de la misma manera que yo os he tratado bien, así también vosotros trataréis bien a mi familia, y que me deis una señal segura de que"
,"13":"dejaréis con vida a mi padre y a mi madre, a mis hermanos y mis hermanas y a todos los suyos y nos libraréis de la muerte'."
,"14":"Ellos le contestaron: 'Con nuestras propias vidas respondemos de las vuestras, con tal que no nos denuncies. Cuando el Señor nos entregue esta tierra, obraremos contigo con benevolencia y lealtad'."
,"15":"Como Rajab vivía en una casa adosada a la muralla de la ciudad, con una soga les hizo bajar por la ventana."
,"16":"Y les dijo: 'Id hacia la montaña, para que no os encuentren los que os persiguen; estad escondidos allí durante tres días, hasta que ellos regresen, y luego seguid vuestro camino'."
,"17":"Ellos le dijeron: 'Quedaremos libres del juramento que te hemos hecho si no haces esto:"
,"18":"cuando entremos en la ciudad, atarás a la ventana por la que nos vamos a descolgar esta cinta de color escarlata, y reunirás junto a ti, en casa, a tu padre, a tu madre, a tus hermanos y a toda tu familia."
,"19":"Si alguno sale de tu casa, él será el responsable de su sangre, y nosotros seremos inocentes; mas si alguien pone la mano sobre el que esté contigo en casa, nosotros seremos los responsables."
,"20":"Pero si nos denuncias, quedaremos libres del juramento que te hemos hecho'."
,"21":"Ella respondió: 'Sea como decís'. Los despidió y se fueron. Y ella ató la cinta de color escarlata en la ventana."
,"22":"Ellos se fueron, llegaron a la montaña y estuvieron allí tres días, hasta que volvieron sus perseguidores, que los estuvieron buscando por todas partes y no los encontraron."
,"23":"Entonces los dos espías bajaron de la montaña, atravesaron el río, se presentaron a Josué, hijo de Nun, y le contaron lo que les había sucedido."
,"24":"Y dijeron: 'El Señor ha entregado toda esta región en nuestras manos; todos los habitantes están muertos de miedo ante nosotros'."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Josué se levantó de madrugada, partió de Sittín con todos los israelitas y llegaron hasta el Jordán. Allí acamparon antes de atravesarlo."
,"2":"Al cabo de tres días, los jefes recorrieron el campamento"
,"3":"y dieron al pueblo la siguiente orden: 'Cuando veáis que los sacerdotes levitas se disponen a llevar el arca de la alianza del Señor, vuestro Dios, poneos en marcha y seguidla."
,"4":"Pero entre ella y vosotros guardad una distancia de un kilómetro; no os acerquéis a ella. Así sabréis por dónde tenéis que ir, pues vosotros no habéis pasado nunca por este camino'."
,"5":"Josué dijo al pueblo: 'Purificaos, porque mañana el Señor hará prodigios ante vosotros'."
,"6":"Y a los sacerdotes: 'Llevad el arca de la alianza y pasad el río delante del pueblo'. Ellos tomaron el arca de la alianza y pasaron delante del pueblo."
,"7":"El Señor dijo a Josué: 'Hoy mismo comenzaré a engrandecerte ante todo Israel, para que sepa que estaré contigo como estuve con Moisés."
,"8":"Tú darás esta orden a los sacerdotes que llevan el arca: Cuando lleguéis a la orilla del Jordán, os pararéis dentro del río'."
,"9":"Y a los israelitas les dijo: 'Acercaos y escuchad las palabras del Señor, vuestro Dios'."
,"10":"Y añadió: 'En esto conoceréis que en medio de vosotros está un Dios viviente que echará delante de vosotros al cananeo, al hitita, al heveo, al fereceo, al guirgaseo, al amorreo y al jebuseo:"
,"11":"El arca de la alianza del Señor de toda la tierra va a atravesar delante de vosotros el Jordán."
,"12":"Y ahora escoged doce hombres de entre las tribus de Israel, uno por cada tribu."
,"13":"Tan pronto como las plantas de los pies de los sacerdotes que llevan el arca del Señor de toda la tierra toquen las aguas del Jordán, la corriente del río se cortará y las aguas que vienen de arriba se pararán formando como un muro'."
,"14":"El pueblo levantó el campamento para atravesar el Jordán, y los sacerdotes llevaban el arca de la alianza delante del pueblo."
,"15":"Cuando llegaron al Jordán y los pies de los sacerdotes que llevaban el arca pisaron el borde de las aguas -el Jordán se desborda por todas sus orillas durante el tiempo de la siega-,"
,"16":"las aguas que venían de arriba se pararon y se amontonaron a mucha distancia -desde Adán hasta la ciudad que está próxima a Sartán-, y las que bajaban al mar de Arabá, el mar Muerto, quedaron enteramente separadas de las otras, mientras el pueblo pasó frente a Jericó."
,"17":"Los sacerdotes que llevaban el arca de la alianza del Señor estuvieron en seco, a pie firme en medio del Jordán, mientras todo Israel atravesaba en seco, hasta que todo el pueblo terminó de pasar."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Cuando todo el pueblo terminó de pasar el Jordán, el Señor dijo a Josué:"
,"2":"'Escoged doce hombres de entre el pueblo, uno de cada tribu,"
,"3":"y dadles esta orden: Tomad de ahí, del medio del Jordán, del lugar donde han estado los sacerdotes a pie firme, doce piedras, llevadlas con vosotros y dejadlas en el lugar donde paséis esta noche'."
,"4":"Josué llamó a los doce hombres que había elegido de entre los israelitas, uno por cada tribu,"
,"5":"y les dijo: 'Pasad ante el arca del Señor, vuestro Dios, hasta el medio del Jordán, y que cada uno de vosotros se eche al hombro una piedra, según el número de las tribus de Israel,"
,"6":"para que esto sirva de memorial en medio de vosotros; porque el día de mañana os preguntarán vuestros hijos: ¿Qué significan esas piedras?"
,"7":"Y vosotros responderéis: Las aguas del Jordán se dividieron delante del arca de la alianza del Señor; se separaron a su paso por el Jordán. Estas piedras son para los israelitas un recuerdo perpetuo'."
,"8":"Los israelitas hicieron lo que les mandó Josué. Tomaron doce piedras del medio del Jordán, como había mandado el Señor a Josué, según el número de las tribus de Israel; las llevaron al lugar donde pasaron la noche y allí las dejaron."
,"9":"Después Josué erigió doce piedras en medio del Jordán, en el lugar donde habían estado los pies de los sacerdotes que llevaban el arca de la alianza, y allí están hasta el día de hoy."
,"10":"Los sacerdotes que llevaban el arca de la alianza estuvieron a pie firme en medio del Jordán hasta que se cumplió todo lo que el Señor había ordenado a Josué, y el pueblo se apresuró a pasar."
,"11":"Cuando todo el pueblo terminó de pasar, pasó el arca del Señor, y los sacerdotes se pusieron al frente del pueblo."
,"12":"Los rubenitas, los gaditas y la mitad de la tribu de Manasés pasaron, armados, a la cabeza de los israelitas, como se lo había mandado Moisés."
,"13":"Unos cuarenta mil, armados y listos para la guerra, pasaron ante el Señor para combatir en las llanuras de Jericó."
,"14":"En aquel día el Señor engrandeció a Josué a los ojos de todo Israel y lo respetaron, como habían respetado a Moisés, todos los días de su vida."
,"15":"El Señor dijo a Josué:"
,"16":"'Manda a los sacerdotes que llevan el arca que salgan del Jordán'."
,"17":"Josué los mandó salir."
,"18":"Y cuando los sacerdotes que llevaban el arca de la alianza del Señor salieron del medio del Jordán y las plantas de sus pies tocaron la tierra seca, las aguas del Jordán volvieron a su cauce extendiéndose, como antes, por todas las orillas."
,"19":"El pueblo salió del Jordán el día diez del primer mes y fijó su campamento en Guilgal, al este de Jericó."
,"20":"En cuanto a las doce piedras que habían sido tomadas del Jordán, Josué las levantó en Guilgal."
,"21":"Entonces dijo a los israelitas: 'Cuando el día de mañana vuestros hijos pregunten a sus padres: ¿Qué significan estas piedras?,"
,"22":"vosotros les daréis esta explicación: Israel pasó este Jordán a pie enjuto,"
,"23":"porque el Señor, vuestro Dios, secó las aguas del Jordán delante de nosotros hasta que pasamos, como lo había hecho con el mar Rojo, que también secó delante de nosotros hasta que pasamos,"
,"24":"para que todos los pueblos de la tierra conozcan el poder de la mano del Señor y para que vosotros respetéis siempre al Señor, vuestro Dios'."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Cuando los reyes amorreos de Cisjordania y los cananeos de occidente oyeron cómo había secado el Señor las aguas del Jordán ante los israelitas hasta que pasaron, se quedaron atónitos y acobardados ante ellos."
,"2":"El Señor dijo a Josué: 'Hazte cuchillos de piedra y circuncida de nuevo a los israelitas'."
,"3":"Y Josué se hizo cuchillos de piedra y circuncidó a los israelitas en la colina de los prepucios."
,"4":"La razón por la cual Josué hizo esta circuncisión es ésta: toda la población masculina que salió de Egipto en edad de llevar las armas había muerto en el desierto durante el camino después de la salida de Egipto."
,"5":"Los que salieron de Egipto estaban circuncidados, pero los que nacieron en el desierto durante el camino, después de la salida de Egipto, no lo estaban;"
,"6":"como los israelitas anduvieron por el desierto cuarenta años, ya habían muerto los que salieron de Egipto en edad militar. Porque no obedecieron al Señor, el Señor les había jurado que no les dejaría ver la tierra que él había prometido a sus padres, tierra que mana leche y miel."
,"7":"Y en su lugar suscitó a sus hijos; a éstos los circuncidó Josué, porque estaban incircuncisos, ya que no habían sido circuncidados durante el camino."
,"8":"Cuando se terminó de circuncidar a todo el pueblo, estuvieron descansando en el campamento hasta su curación."
,"9":"Y el Señor dijo a Josué: 'Hoy he quitado de vosotros el oprobio de Egipto'. Aquel lugar fue llamado Guilgal hasta el día de hoy."
,"10":"Los israelitas acamparon en Guilgal, y celebraron la pascua el día catorce del mes por la tarde, en la llanura de Jericó."
,"11":"Ese mismo día comieron panes sin levadura y trigo tostado; pero desde el día siguiente empezaron a comer los productos de la tierra."
,"12":"Desde ese momento el maná dejó de caer y los israelitas, desde aquel año, se alimentaron de los productos de la tierra de Canaán."
,"13":"Estando un día Josué cerca de Jericó, levantó los ojos y vio a un hombre delante de él con la espada desenvainada en su mano. Josué se le acercó y le dijo: '¿Eres de los nuestros o de los enemigos?'."
,"14":"Él respondió: 'No, yo soy el jefe del ejército del Señor y acabo de llegar'. Josué cayó rostro en tierra, le adoró y le dijo: '¿Cuáles son las órdenes de mi Señor a su siervo?'."
,"15":"El jefe del ejército del Señor le contestó: 'Descálzate, porque el lugar donde estás es sagrado'. Y Josué lo hizo así."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Jericó estaba fuertemente custodiada contra los israelitas; nadie salía ni entraba en ella."
,"2":"El Señor dijo a Josué: 'Mira, he puesto en tus manos a Jericó y a su rey. Todos vosotros, los combatientes,"
,"3":"hombres de guerra, daréis una vuelta alrededor de la ciudad, y así durante seis días."
,"4":"Siete sacerdotes llevarán siete trompetas delante del arca. El día séptimo daréis siete vueltas, y los sacerdotes tocarán las trompetas."
,"5":"Cuando suene el cuerno de carnero y vosotros oigáis el sonar de las trompetas, todo el pueblo dará con todas sus fuerzas el grito de guerra. Entonces las murallas de la ciudad se derrumbarán, y el pueblo la asaltará, cada uno de frente'."
,"6":"Josué, hijo de Nun, llamó a los sacerdotes y les dijo: 'Tomad el arca de la alianza, y que siete sacerdotes lleven siete trompetas de cuerno de carnero delante del arca del Señor'."
,"7":"Y al pueblo le dijo: 'Id y rodead la ciudad; que los armados vayan delante del arca del Señor'."
,"8":"Cuando Josué terminó de hablar al pueblo, los siete sacerdotes que llevaban las siete trompetas de cuerno de carnero delante del Señor se pusieron en marcha y tocaron las trompetas. El arca de la alianza del Señor iba detrás de ellos."
,"9":"Los armados iban delante de los sacerdotes que tocaban las trompetas, y la retaguardia iba detrás del arca; marchaban al son de las trompetas."
,"10":"Josué había dado esta orden al pueblo: 'No gritéis, no se oiga vuestra voz, no salga de vuestras bocas ni una sola palabra hasta el día en que os diga: Dad el grito de guerra. Entonces gritaréis'."
,"11":"El arca del Señor dio una vuelta a la ciudad; después todos volvieron al campamento, donde pasaron la noche."
,"12":"Josué se levantó de madrugada, y los sacerdotes tomaron el arca del Señor."
,"13":"Los siete sacerdotes que llevaban las trompetas de cuerno de carnero iban delante del arca del Señor tocando sus trompetas durante la marcha; delante de ellos iban los armados, y la retaguardia iba detrás del arca del Señor; marchaban al son de las trompetas."
,"14":"El segundo día dieron también una vuelta alrededor de la ciudad, y después volvieron al campamento. Así hicieron durante seis días."
,"15":"El día séptimo se levantaron con el alba, y dieron siete vueltas a la ciudad del mismo modo; sólo ese día dieron siete vueltas."
,"16":"A la séptima vuelta, mientras los sacerdotes tocaban las trompetas, Josué dijo al pueblo: 'Dad el grito de guerra, porque el Señor os ha entregado la ciudad'."
,"17":"'La ciudad, con todo lo que hay en ella, será entregada al exterminio en manos del Señor; solamente quedará Rajab, la prostituta, y todos los que estén con ella en su casa, porque escondió a los exploradores que habíamos enviado."
,"18":"Y vosotros, ojo con que toméis nada de lo que hay en la ciudad y ha sido entregado al exterminio en honor del Señor, porque eso sería exponer al exterminio el campamento de Israel acarreándole la desgracia."
,"19":"Toda la plata y el oro, todos los objetos de bronce y de hierro serán consagrados al Señor y entrarán en su tesoro'."
,"20":"El pueblo gritó, y las trompetas sonaron. Cuando el pueblo oyó el sonido de las trompetas, se puso a gritar con todas sus fuerzas, y las murallas de la ciudad se derrumbaron; entonces el pueblo se lanzó al asalto, cada uno de frente, y la tomaron."
,"21":"Y entregaron al exterminio todo lo que había en la ciudad, hombres y mujeres, jóvenes y viejos, incluso los bueyes, ovejas y asnos, pasándolos a filo de espada."
,"22":"Josué dijo a los dos hombres que habían explorado la tierra: 'Entrad en la casa de esa prostituta y sacadla fuera con todos los suyos, como se lo habíamos jurado'."
,"23":"Los exploradores entraron y sacaron a Rajab, a su padre, a su madre, a sus hermanos y a toda su familia, y los llevaron fuera del campamento de Israel."
,"24":"Después quemaron la ciudad y todo lo que había en ella, a excepción de la plata, el oro y los objetos de bronce y de hierro, que se depositaron en el tesoro de la casa del Señor."
,"25":"Josué perdonó la vida a Rajab, la prostituta, y a su familia, con todo lo que tenían. Ella vivió con los israelitas hasta el día de hoy por haber escondido a los espías enviados por Josué para explorar la tierra."
,"26":"Josué pronunció este juramento delante del Señor: 'Maldito el hombre que venga a edificar esta ciudad. Pondrá los cimientos sobre su primogénito, y sobre su hijo menor levantará las puertas'."
,"27":"El Señor estuvo con Josué, y su fama se extendió por toda la tierra."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Pero los israelitas cometieron una falta en lo tocante a las cosas consagradas al exterminio: Acán, hijo de Carmí, hijo de Zabdí, hijo de Zéraj, de la tribu de Judá, tomó lo que estaba consagrado al exterminio, y la ira del Señor se encendió contra los israelitas."
,"2":"Entonces Josué mandó desde Jericó hasta Ay, que está al oriente de Betel, hombres con esta consigna: 'Subid a explorar la tierra'. Y ellos subieron y exploraron Ay."
,"3":"Al volver, dijeron a Josué: 'No es necesario que suba todo el pueblo; que suban unos dos o tres mil hombres para tomar Ay. No hace falta que vaya todo el pueblo, pues ellos son pocos'."
,"4":"Subieron, pues, unos tres mil hombres, pero tuvieron que huir ante los de Ay,"
,"5":"que les hicieron treinta y seis bajas y los persiguieron desde la puerta hasta el Sebarín derrotándolos en la bajada. El pueblo se desalentó y se acobardó."
,"6":"Josué rasgó sus vestiduras y se postró rostro en tierra delante del arca del Señor hasta la tarde, y con él los ancianos de Israel; todos se echaron polvo sobre sus cabezas."
,"7":"Y Josué exclamó: 'Señor, ¿por qué has hecho pasar el Jordán a este pueblo, si es para entregarlo en manos del amorreo y destruirnos? ¡Ojalá nos hubiéramos quedado al otro lado del Jordán!"
,"8":"Señor, ¿qué podré yo decir ahora que Israel ha vuelto la espalda a sus enemigos?"
,"9":"Lo sabrán los cananeos y todos los habitantes de la región, y se unirán contra nosotros para hacer desaparecer nuestro nombre de la tierra. Y entonces, ¿qué harás tú por tu glorioso nombre?'."
,"10":"El Señor le respondió: 'Levántate. ¿Por qué estás postrado rostro en tierra?"
,"11":"Israel ha pecado, ha violado la alianza que hice con ellos; han tomado cosas que estaban consagradas al exterminio, han robado, han mentido y las han escondido entre sus enseres."
,"12":"Por eso los israelitas no podrán resistir ante sus enemigos; les volverán la espalda, porque ahora ellos se han hecho merecedores del exterminio. No estaré más con vosotros mientras no entreguéis al exterminio lo que yo ordené."
,"13":"Levántate, convoca al pueblo y diles: Purificaos para mañana, porque esto dice el Señor, Dios de Israel: Tú, Israel, has tomado algo de lo consagrado al exterminio, y mientras no lo destruyas, no podrás resistir a tus enemigos."
,"14":"Mañana por la mañana os presentaréis por tribus, y la tribu que el Señor señale por suerte se presentará por clanes, y el clan que el Señor señale por suerte se presentará por familias, y la familia que el Señor señale por suerte se presentará por individuos."
,"15":"El que sea sorprendido con el objeto consagrado al exterminio será quemado, él y todo lo que le pertenece, por haber roto la alianza con el Señor y haber cometido una infamia con Israel'."
,"16":"Josué se levantó de madrugada, hizo avanzar a Israel por tribus, y fue señalada por suerte la tribu de Judá."
,"17":"Hizo acercarse a los clanes de Judá, y fue señalado por suerte el clan de Zéraj. Hizo acercarse al clan de Zéraj por familias, y fue designado Zabdí."
,"18":"Josué hizo acercarse a la familia de Zabdí por individuos, y fue señalado por suerte Acán, hijo de Carmí, hijo de Zabdí, hijo de Zéraj, de la tribu de Judá."
,"19":"Josué dijo a Acán: 'Hijo mío, da gloria al Señor, Dios de Israel, y ríndele homenaje. Dime lo que has hecho, y no me ocultes nada'."
,"20":"Acán respondió a Josué: 'Es cierto, he pecado contra el Señor, Dios de Israel. He hecho esto y esto."
,"21":"Vi entre el botín un manto precioso, de Senaar, doscientas monedas de plata y una barra de oro de dos kilos y medio de peso y, dominado por la codicia, los tomé. Están escondidos en la tierra, en medio de mi tienda, y el dinero está debajo'."
,"22":"Entonces Josué envió unos mensajeros, que fueron corriendo hacia la tienda y encontraron lo que en ella estaba escondido, y el dinero debajo."
,"23":"Lo recogieron, lo llevaron a Josué y a los ancianos de Israel, y lo depositaron ante el Señor."
,"24":"Entonces Josué tomó a Acán, hijo de Zéraj, con el dinero, el manto y la barra de oro, a sus hijos, sus hijas, su buey, su asno, su pequeño rebaño, su tienda y todo lo que le pertenecía y, con todo Israel, lo llevaron al valle de Acor."
,"25":"Josué dijo: '¿Por qué nos has traído la desgracia? Ahora, que el Señor haga caer sobre ti la desgracia'. Y todos los israelitas lo mataron a pedradas."
,"26":"Y pusieron sobre él un gran montón de piedras, que existe hasta el día de hoy. Entonces el Señor aplacó su ardiente cólera. Por eso aquel lugar recibió el nombre de valle de Acor hasta el día de hoy."
}`)
	CurrentBook.AddChapter(8, `{
"1":"El Señor dijo a Josué: 'No tengas miedo ni te acobardes. Toma contigo todos los hombres de guerra, levántate y sube contra Ay. Mira, yo pongo en tus manos al rey de Ay, a su pueblo, su ciudad y su tierra."
,"2":"Tratarás a Ay y a su rey como trataste a Jericó y a su rey. Sólo tomaréis para vosotros el botín y el ganado. Tiende una emboscada contra la ciudad por detrás'."
,"3":"Josué se dispuso con todos los hombres de guerra para subir contra Ay. Escogió treinta mil hombres valientes y los hizo partir de noche,"
,"4":"después de haberles dado esta orden: '¡Atención! Tenderéis una emboscada contra la ciudad, pero por detrás; no os alejéis mucho de la ciudad, y estad preparados."
,"5":"Yo y todo el pueblo que me acompaña nos acercaremos a la ciudad y, cuando ellos salgan a nuestro encuentro como la primera vez, huiremos ante ellos."
,"6":"Ellos saldrán en nuestra persecución, y así los alejaremos de la ciudad, porque se dirán: Huyen delante de nosotros como la primera vez."
,"7":"Entonces vosotros saldréis de la emboscada para tomar la ciudad. El Señor, vuestro Dios, la pondrá en vuestras manos."
,"8":"Una vez que hayáis tomado la ciudad, le prenderéis fuego. Éstas son las órdenes que debéis cumplir. ¡Atención! Soy yo el que os lo mando'."
,"9":"Josué los hizo partir. Ellos fueron al lugar de la emboscada y se apostaron entre Betel y Ay, al occidente de Ay. Josué pasó la noche en el campamento."
,"10":"Josué se levantó de madrugada, pasó revista al pueblo y subió contra Ay, él y los ancianos de Israel a la cabeza del pueblo."
,"11":"Todos los hombres de guerra que estaban con él subieron, se acercaron, llegaron frente a la ciudad y acamparon al norte de Ay. Entre él y Ay había un valle."
,"12":"Josué tomó unos cinco mil hombres y los colocó en emboscada entre Betel y Ay, al poniente de la ciudad."
,"13":"El pueblo estaba acampado al norte de la ciudad, y la emboscada al poniente. Josué pasó aquella noche en el campamento."
,"14":"Cuando el rey de Ay vio la situación, salió a toda prisa a presentar batalla contra Israel, él y todo su pueblo, en la pendiente de frente a la Arabá; pero sin saber que le habían tendido una emboscada por detrás de la ciudad."
,"15":"Josué y todo Israel se fingieron vencidos por ellos y se dieron a la fuga por el camino del desierto."
,"16":"Entonces todo el pueblo que estaba en la ciudad se congregó para perseguirlos, y en la persecución se alejaron de la ciudad."
,"17":"No quedó nadie en Ay que no saliese a perseguir a Israel. Por perseguirlos dejaron indefensa la ciudad."
,"18":"El Señor dijo a Josué: 'Extiende hacia Ay la jabalina que tienes en la mano, porque te la voy a entregar'. Y Josué extendió hacia la ciudad la jabalina que tenía en la mano."
,"19":"Cuando extendió el brazo, los hombres de la emboscada salieron rápidamente de su escondite, tomaron carrera y, entrando en la ciudad, se apoderaron de ella y se dieron prisa a prenderle fuego."
,"20":"Cuando las gentes de Ay volvieron la vista atrás, vieron una humareda que subía de la ciudad hasta el cielo. Ya no pudieron ponerse a salvo por ningún lado, porque los israelitas que huían hacia el desierto se volvieron contra ellos."
,"21":"Josué y todo el pueblo, al ver que los de la emboscada habían tomado la ciudad y que le habían prendido fuego, se volvieron y atacaron a las gentes de Ay."
,"22":"Los otros salieron de la ciudad a su encuentro, de suerte que las gentes de Ay quedaron en medio de los israelitas, que los derrotaron hasta no dejar ni un superviviente ni un fugitivo."
,"23":"Pero al rey de Ay lo tomaron vivo y lo llevaron a Josué."
,"24":"Cuando terminaron de matar a todos los de Ay que habían salido al campo en su persecución, los israelitas se volvieron a la ciudad y la pasaron a cuchillo."
,"25":"El total de hombres y mujeres que cayeron en este día fue de doce mil; toda la gente de Ay."
,"26":"Josué no retiró la mano que tenía extendida con la jabalina hasta que todos los habitantes de Ay fueron exterminados."
,"27":"Los israelitas tomaron como botín solamente el ganado y lo que quedaba en la ciudad, tal como el Señor había ordenado a Josué."
,"28":"Josué incendió Ay e hizo de ella una ruina permanente hasta el día de hoy."
,"29":"Al rey de Ay lo colgó de un árbol hasta la tarde; a la puesta del sol mandó que descolgaran el cadáver y lo tiraran a la puerta de la ciudad. Y echaron sobre él un gran montón de piedras, que todavía existe hoy."
,"30":"Josué levantó al Señor Dios de Israel, en el monte Ebal, un altar,"
,"31":"como Moisés, siervo del Señor, había ordenado a los israelitas, según está escrito en el libro de la ley de Moisés: 'Un altar de piedras sin labrar'. Sobre él ofrecieron holocaustos al Señor y presentaron sacrificios de reconciliación."
,"32":"Allí escribió Josué sobre las piedras una copia del libro de la ley que Moisés había escrito para los israelitas."
,"33":"Todo Israel, sus ancianos, sus funcionarios y sus jueces, estaban en pie a los dos lados del arca ante los sacerdotes y levitas que llevaban el arca de la alianza del Señor; tanto los extranjeros como los ciudadanos se colocaron la mitad del lado del monte Garizín y la otra mitad del lado del monte Ebal, como Moisés, siervo del Señor, había mandado, cuando bendijo por primera vez al pueblo de Israel."
,"34":"Después Josué leyó todas las palabras del libro de la ley, la bendición y la maldición, conforme está escrito en el libro de la ley."
,"35":"No quedó ni una palabra de todo lo que había mandado Moisés que no fuera leída por Josué a toda la asamblea de Israel, incluyendo a las mujeres, a los niños y a los extranjeros residentes."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Cuando se enteraron de estas cosas los reyes de Cisjordania, de la montaña, de la Sefela y de toda la costa del mar Mediterráneo hasta el Líbano: hititas, amorreos, cananeos, fereceos, heveos y jebuseos,"
,"2":"se coligaron para luchar unidos contra Josué e Israel."
,"3":"Cuando los habitantes de Gabaón se enteraron de cómo había tratado Josué a Jericó y a Ay,"
,"4":"recurrieron por su parte a la estratagema. Se pusieron en camino, con provisiones, y colocaron sobre sus asnos sacos viejos y odres viejos de vino, rotos y remendados."
,"5":"Llevaban sandalias usadas y remendadas, y vestidos viejos. Todo el pan que llevaban para su comida estaba duro y hecho migas."
,"6":"Llegaron donde Josué, al campamento de Guilgal, y le dijeron a él y a todas las gentes de Israel: 'Venimos de un país lejano; haced un pacto con nosotros'."
,"7":"Los israelitas contestaron a los hititas: '¡A lo mejor vivís cerca de nosotros!; ¿cómo podremos hacer un pacto con vosotros?'."
,"8":"Respondieron a Josué: 'Somos siervos tuyos'. Y Josué les preguntó: '¿Quiénes sois y de dónde venís?'."
,"9":"Ellos replicaron: 'Tus siervos vienen de un país muy lejano por la fama del nombre del Señor, tu Dios, porque hemos oído hablar de su nombre, de todo lo que hizo en Egipto"
,"10":"y de todo lo que hizo a los dos reyes de los amorreos del lado de Transjordania, a Sijón, rey de Jesbón, y a Og, rey de Basán, que vivía en Astarot."
,"11":"Entonces nuestros ancianos y todos los habitantes de nuestra tierra nos dijeron: Tomad con vosotros víveres para el camino, id a su encuentro y decidles: Somos siervos vuestros, haced un pacto con nosotros."
,"12":"Mirad nuestro pan; todavía estaba caliente cuando lo tomamos en nuestras casas el día que partimos para salir a vuestro encuentro, y ahora está duro y hecho migas;"
,"13":"estos odres de vino eran nuevos cuando los llenamos, y ahora están rotos; nuestras sandalias y nuestros vestidos se han hecho viejos de tanto caminar'."
,"14":"Los jefes aceptaron de sus provisiones, pero sin consultar al Señor."
,"15":"Josué hizo un pacto de paz con ellos comprometiéndose a perdonarles la vida, y los jefes del pueblo juraron hacer lo mismo."
,"16":"Tres días después de haber hecho el pacto con ellos, se supo que eran vecinos y que vivían cerca."
,"17":"Los israelitas salieron en su busca y en tres días llegaron a sus ciudades, que eran: Gabaón, Kefirá, Beerot y Quiriat Yearín."
,"18":"Mas los israelitas no los mataron, porque los jefes del pueblo les habían jurado por el Señor, Dios de Israel, que les perdonarían la vida. Pero toda la comunidad murmuraba contra los jefes,"
,"19":"y los jefes dijeron a toda la asamblea: 'Nosotros lo hemos jurado por el Señor, Dios de Israel, y por consiguiente no los podemos matar."
,"20":"Tenemos que dejarles vivir, para no atraer sobre nosotros la cólera del Señor por el juramento que les hemos hecho'."
,"21":"Y los jefes añadieron: 'Que vivan, pero que sean los leñadores y aguadores al servicio de toda la comunidad'."
,"22":"Josué los llamó y les dijo: '¿Por qué nos habéis engañado, diciendo que veníais de muy lejos, siendo así que vivís aquí al lado?"
,"23":"Desde ahora mismo sois malditos, y no faltará de entre vosotros el esclavo que corte la leña y lleve el agua para la casa de mi Dios'."
,"24":"Ellos respondieron a Josué: 'Tus siervos habían sido informados de cómo el Señor, tu Dios, había mandado a Moisés, su siervo, que se os diera toda la tierra y de que todos sus habitantes fueran exterminados ante vosotros. Y, temiendo por nuestras vidas, hemos hecho esto."
,"25":"Y ahora estamos en tus manos; haz de nosotros lo que te parezca bueno y justo'."
,"26":"Y desde aquel día Josué los destinó a cortar leña y a llevar el agua, hasta el día de hoy, para toda la comunidad y para el altar del Señor en el lugar que el Señor eligiera."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Cuando supo Adonisedec, rey de Jerusalén, que Josué había tomado Ay y la había entregado al exterminio, tratando a Ay y a su rey como había tratado a Jericó y a su rey, y que los habitantes de Gabaón habían hecho las paces con Israel y que estaban con él,"
,"2":"se llenó de miedo, porque Gabaón era una ciudad importante, una de las ciudades reales, más grande que Ay, y todos sus habitantes eran valientes."
,"3":"Entonces Adonisedec, rey de Jerusalén, envió a decir a Ohán, rey de Hebrón; a Pirán, rey de Yarmut; a Yafia, rey de Laquis, y a Debir, rey de Eglón:"
,"4":"'Venid a ayudarme a combatir contra Gabaón, porque ha hecho las paces con Josué y con los israelitas'."
,"5":"Y los cinco reyes amorreos se coligaron: el rey de Jerusalén, el de Hebrón, el de Yarmut, el de Laquis y el de Eglón; subieron con todas sus tropas, acamparon cerca de Gabaón y la atacaron."
,"6":"Las gentes de Gabaón enviaron a decir a Josué al campamento de Guilgal: 'No niegues tu ayuda a tus siervos. Ven rápidamente a salvarnos y defendernos, porque se han coligado contra nosotros todos los reyes amorreos que habitan la montaña'."
,"7":"Josué salió de Guilgal, con todos los combatientes, lo más selecto del ejército."
,"8":"El Señor dijo a Josué: 'No temas, porque yo los he entregado en tus manos; ninguno de ellos podrá resistir ante ti'."
,"9":"Josué cayó sobre ellos de improviso, después de haber marchado toda la noche desde Guilgal."
,"10":"El Señor los dispersó ante Israel y les infligió una gran derrota en Gabaón; los persiguió en dirección de la bajada de Bejorón y los derrotó hasta Azeca y hasta Maqueda."
,"11":"Cuando huían ante Israel en la pendiente de Bejorón, el Señor hizo caer del cielo sobre ellos un pedrisco terrible hasta Azeca, y murieron más por las piedras de granizo que por la espada de los israelitas."
,"12":"Josué se dirigió al Señor el día en que puso a los amorreos en manos de los israelitas y dijo: 'Sol, detente sobre Gabaón, y tú, luna, sobre el valle de Ayalón."
,"13":"Y el sol se detuvo y la luna se paró,hasta que el pueblo se vengó,de sus enemigos'. ¿No está escrito esto en el libro del Justo? El sol se detuvo en medio del cielo y no se apresuró a ponerse en casi un día entero. "
,"14":"No ha habido un día como aquél ni antes ni después, en el que el Señor haya obedecido a la voz de un hombre. Es que el Señor combatía por Israel."
,"15":"Josué, con todo Israel, volvió al campamento de Guilgal."
,"16":"Aquellos cinco reyes se dieron a la fuga y se escondieron en una cueva cerca de Maqueda."
,"17":"Informaron a Josué: 'Los cinco reyes han sido descubiertos ocultos en una cueva, cerca de Maqueda'."
,"18":"Josué dijo: 'Rodad grandes piedras a la entrada de la cueva y apartad unos cuantos hombres para guardarla."
,"19":"Vosotros no os paréis, perseguid a vuestros enemigos, cortadles la retirada y no los dejéis entrar en sus ciudades, porque el Señor, vuestro Dios, los ha puesto en vuestras manos'."
,"20":"Después que Josué y los israelitas los derrotaron y los exterminaron, los que habían escapado se refugiaron en las ciudades fortificadas."
,"21":"Todo el pueblo volvió sano y salvo junto a Josué, en Maqueda. Nadie se atrevió a hacer nada contra los israelitas."
,"22":"Josué dijo: 'Abrid la boca de la cueva, sacad a los cinco reyes y traédmelos'."
,"23":"Y sacaron de la caverna a los cinco reyes: al rey de Jerusalén, al de Hebrón, al de Yarmut, al de Laquis y al de Eglón."
,"24":"Cuando los llevaron ante Josué, éste llamó a todos los hombres de Israel y dijo a los jefes del ejército que le habían acompañado: 'Acercaos y poned vuestros pies sobre el cuello de estos reyes'. Se acercaron y lo hicieron."
,"25":"Y Josué les dijo: 'No temáis ni os acobardéis; sed fuertes y decididos, porque así tratará el Señor a todos vuestros enemigos contra los que tenéis que combatir'."
,"26":"Después de esto, Josué los golpeó y los mató; y mandó que los colgaran de cinco árboles, y en ellos estuvieron colgados hasta la tarde."
,"27":"Pero, al ponerse el sol, Josué mandó descolgarlos y echarlos en la cueva donde se habían escondido. Y pusieron grandes piedras en la entrada de la cueva, y allí están todavía hoy."
,"28":"Ese mismo día Josué tomó a Maqueda y la destruyó; pasó a filo de espada a todos los que vivían en ella sin dejar ni un superviviente; al rey de Maqueda lo trató como había tratado al rey de Jericó."
,"29":"De Maqueda, Josué y los israelitas pasaron a Libná y la atacaron."
,"30":"El Señor la entregó también, con su rey, en manos de Israel, que la pasó a filo de espada con todos los que vivían en ella sin dejar un superviviente. Y trató a su rey como había tratado al de Jericó."
,"31":"De Libná pasaron a Laquis; la sitiaron y la atacaron."
,"32":"El Señor entregó a Laquis en manos de Israel, que la tomó al segundo día, y pasó a filo de espada a todos los que vivían en ella, como había hecho con Libná."
,"33":"Horán, el rey de Guézer, subió para socorrer a Laquis; pero Josué lo derrotó a él y a su pueblo, hasta que no quedó ni un superviviente."
,"34":"De Laquis pasaron a Eglón. La sitiaron y la atacaron."
,"35":"La tomaron aquel mismo día y pasaron a filo de espada a todos los que vivían en ella, exterminándolos completamente, como habían hecho con Laquis."
,"36":"De Eglón pasaron a Hebrón, y la asaltaron."
,"37":"La tomaron y pasaron a filo de espada al rey y a todos los que vivían en ella y en los pueblos vecinos, exterminándolos por completo y sin dejar un superviviente, como habían hecho con Eglón."
,"38":"Después volvieron contra Debir, y la atacaron."
,"39":"La tomaron y pasaron a filo de espada al rey y a todos los que vivían allí y en los pueblos vecinos, exterminándolos por completo y sin dejar un superviviente, como habían hecho con Hebrón y Libná y sus reyes."
,"40":"Josué conquistó toda la tierra: la montaña, el Negueb, la tierra baja y las pendientes con todos sus reyes, sin dejar ni un superviviente. Entregó al exterminio a todo ser viviente, como había mandado el Señor, Dios de Israel."
,"41":"Josué los derrotó desde Cades Barne hasta Gaza, y en todo el territorio de Gosen hasta Gabaón."
,"42":"Josué se apoderó de todos estos reyes y de sus territorios en una sola expedición, porque el Señor, Dios de Israel, combatía por Israel."
,"43":"Después Josué y todos los israelitas volvieron al campamento de Guilgal."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Cuando Yabín, rey de Jasor, supo todo esto, mandó una embajada a Yobab, rey de Madón, al rey de Simerón, al rey de Acsaf,"
,"2":"a los reyes de la montaña, al norte, y de la llanura al sur de Genesaret, de la tierra baja y de las alturas de Dor, al occidente;"
,"3":"al cananeo de oriente y occidente; al amorreo, al heveo, al fereceo y al jebuseo, en la montaña; al hitita, a los pies del Hermón, en el territorio de Mispá."
,"4":"Salieron con todos sus ejércitos, una multitud innumerable como la arena del mar, y con muchísimos caballos y carros de guerra."
,"5":"Todos estos reyes se pusieron de acuerdo, y acamparon junto a las aguas de Merón para luchar contra Israel."
,"6":"Y el Señor dijo a Josué: 'No los temas, porque mañana, a esta misma hora, todos ellos caerán muertos ante Israel; desjarretarás sus caballos y quemarás sus carros'."
,"7":"Josué, con su gente de guerra, llegó a las aguas de Merón y los atacó por sorpresa."
,"8":"El Señor los entregó en manos de Israel, que los derrotó y los persiguió hasta Sidón la Grande y hasta Misrefot, al occidente, y hasta el valle de Mispá, al oriente. Los derrotó de tal forma que no quedó ni un superviviente."
,"9":"Josué los trató como le había mandado el Señor: desjarretó sus caballos y quemó sus carros."
,"10":"Entonces Josué se volvió, tomó Jasor y pasó a filo de espada a su rey. Jasor era entonces la capital de todos estos reinos."
,"11":"Consagró al exterminio y pasó a filo de espada a todos los que vivían en ella. No quedó ni un superviviente, y Jasor fue pasto de las llamas."
,"12":"Josué se apoderó de todas las ciudades de estos reyes, y a todos los pasó a filo de espada, consagrándolos al exterminio, como había mandado Moisés, siervo del Señor."
,"13":"Sin embargo, Israel no quemó ninguna de las ciudades en ruinas edificadas sobre las colinas, a excepción de Jasor, que fue incendiada por Josué."
,"14":"Todo el botín de estas ciudades, incluido el ganado, lo tomaron para ellos los israelitas; pero a todas las personas las pasaron a filo de espada hasta su total exterminio, sin dejar ni un superviviente."
,"15":"Lo que el Señor había ordenado a Moisés, su siervo, Moisés se lo ordenó a Josué y Josué lo cumplió, sin dejar de hacer nada de lo que el Señor había ordenado a Moisés."
,"16":"De esta manera se apoderó Josué de todo este territorio: la montaña, todo el Negueb y toda la tierra de Gosen, la tierra baja, la Arabá, la montaña de Israel y sus llanuras,"
,"17":"desde el monte Pelado, que sube hacia Seír, hasta Baal Gad, en el valle del Líbano, a los pies del monte Hermón; se apoderó de todos sus reyes, a los que derrotó y dio muerte."
,"18":"Josué tuvo que combatir mucho tiempo contra todos estos reyes;"
,"19":"y como ninguna ciudad había hecho las paces con los israelitas, a excepción de los heveos, que vivían en Gabaón, a todas las pasó por las armas."
,"20":"Porque el Señor había decretado que todas estas ciudades endureciesen su corazón para que combatiesen contra los israelitas; y los israelitas los exterminaron por completo y sin piedad, como el Señor se lo había ordenado a Moisés."
,"21":"Josué se puso en marcha, exterminó a los anaquitas de la montaña, de Hebrón, de Debir, de Anab, de toda la montaña de Judá y de toda la montaña de Israel, y destruyó todas sus ciudades."
,"22":"No quedaron anaquitas en la tierra de los israelitas, excepto en Gaza, en Gat y en Asdod."
,"23":"Josué conquistó toda la tierra, como el Señor le había dicho a Moisés, y la repartió en heredad entre las tribus de Israel. Y el país gozó de paz."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Éstos son los reyes de la tierra a los que derrotaron los israelitas, y los territorios que conquistaron desde el río Arnón hasta el monte Hermón con toda la región oriental del valle del Jordán:"
,"2":"Sijón, rey de los amorreos, que vivía en Jesbón, dominaba desde Aroer, a orillas del río Arnón, incluyendo el medio de este valle, la mitad de Galaad, hasta el río Yeboc, límite de los amonitas;"
,"3":"la región oriental del valle del Jordán, desde el lago de Genesaret hasta el mar Muerto, hacia Bet Yesimot, y, por el sur, hasta más abajo de la pendiente de Pisga."
,"4":"Og, rey de Basán, superviviente de los refaimitas, que residía en Astarot y en Edreí,"
,"5":"dominaba el monte Hermón, y Salcá y todo Basán, hasta la frontera de los guesuritas y de los maacatitas y la mitad de Galaad, hasta la frontera de Sijón, rey de Jesbón."
,"6":"Moisés, siervo del Señor, los derrotó y dio su territorio en propiedad a los rubenitas, los gaditas y a la mitad de la tribu de Manasés."
,"7":"Éstos son los reyes del país a los que Josué y los israelitas derrotaron en Cisjordania, desde Baal Gad, en el valle del Líbano, hasta el monte Pelado, que sube hasta Seír, cuyo territorio repartió en propiedad a las tribus de Israel según sus familias,"
,"8":"en la montaña, en la Sefela, en la Arabá, en sus vertientes, en el desierto y en el Negueb, donde vivían los hititas, los amorreos, los cananeos, los fereceos, los heveos y los jebuseos."
,"9":"El rey de Jericó, el de Ay,"
,"10":"el de Jerusalén, el de Hebrón,"
,"11":"el de Yarmut, el de Laquis,"
,"12":"el de Eglón, el de Guézer,"
,"13":"el de Debir, el de Guéder,"
,"14":"el de Jormá, el de Arad,"
,"15":"el de Libná, el de Adulán,"
,"16":"el de Maqueda, el de Betel,"
,"17":"el de Tapúaj, el de Jéfer,"
,"18":"el de Afec, el de Sarón,"
,"19":"el de Madón, el de Jasor,"
,"20":"el de Simerón, el de Acsaf,"
,"21":"el de Tanac, el de Meguido,"
,"22":"el de Cades, el de Yocneán, en el Carmelo,"
,"23":"el de Dor, en las alturas de Dor, el de Tirsá. En total, treinta y un reyes."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Josué era ya viejo, entrado en años, y el Señor le dijo: 'Tú eres viejo, de edad avanzada, y la tierra que queda por conquistar es mucha."
,"2":"Ésta es la tierra que queda: todos los distritos de los filisteos y todo el territorio de los guesuritas;"
,"3":"desde el Sijor, en la frontera de Egipto, hasta los confines de Ecrón, al norte, considerado de los cananeos; los cinco principados filisteos: el de Gaza, el de Asdod, el de Ascalón, el de Gat y el de Ecrón; al sur, los heveos;"
,"4":"todo el país de los cananeos, desde Ava de los sidonios hasta Afec y hasta la frontera de los amorreos;"
,"5":"además, el país de los guiblitas y todo el Líbano, al oriente, desde Baal Gad, a los pies del monte Hermón, hasta la entrada de Jamat."
,"6":"Todos los habitantes de la montaña del Líbano hasta Misrefot, al occidente, y los sidonios. Yo los expulsaré ante los israelitas. Ahora reparte por suertes esta tierra a los israelitas, como yo te he ordenado."
,"7":"Ha llegado el momento de repartir esta tierra entre las nueve tribus y la media tribu de Manasés'."
,"8":"Las tribus de Rubén y de Gad y la otra media tribu de Manasés ya recibieron su parte, la que les dio Moisés en Transjordania, cuando se la distribuyó Moisés, el siervo del Señor:"
,"9":"desde Aroer, a orillas del río Arnón, y desde la ciudad que está en medio del valle, toda la llanura de Madabá hasta Dibón;"
,"10":"todas las ciudades de Sijón, rey de los amorreos, que reinó en Jesbón, hasta la frontera de los amonitas."
,"11":"Además, Galaad, el territorio de los guesuritas y maacatitas, toda la montaña del Hermón y todo Basán hasta Salcá;"
,"12":"en Basán, todo el reino de Og, que reinó en Astarot y Edreí, el último superviviente de los refaimitas; Moisés los derrotó y los expulsó."
,"13":"Pero no expulsaron a los guesuritas ni a los maacatitas, que siguieron viviendo con los israelitas hasta el día de hoy."
,"14":"Sólo a la tribu de Leví no se le dio heredad; el Señor, Dios de Israel, fue su heredad, como él se lo había dicho."
,"15":"Moisés había dado a la tribu de Rubén una parte, por clanes."
,"16":"Sus límites fueron desde Aroer, a orillas del río Arnón, y desde la ciudad que está en medio del valle, toda la llanura hasta Madabá,"
,"17":"Jesbón y todas las ciudades que están en la llanura: Dibón, Bamot Baal, Bet-Baal-Maón,"
,"18":"Yazá, Quedemot y Mefat;"
,"19":"Quiriat Yearín, Sibmá, Seret Sajar, en el monte y en el valle;"
,"20":"Bet Fegor, las pendientes del Pisga y Bet Yesimot;"
,"21":"todas las ciudades de la llanura y todo el reino de Sijón, rey de los amorreos, que reinó en Jesbón. Moisés le había derrotado, y a los príncipes de Madián, Eví, Requen, Sur, Jur y Rebá, vasallos de Sijón, que vivían en el país."
,"22":"Los israelitas pasaron, además, a filo de espada a Balaán, hijo de Beor, el adivino, y a otros muchos más;"
,"23":"así, el territorio de Rubén tuvo por límite el Jordán. Ésta fue, con sus ciudades y sus pueblos, la heredad de la tribu de Rubén, según sus clanes."
,"24":"Moisés dio también a la tribu de Gad una parte, por clanes."
,"25":"Su territorio comprendía: Yazer, todas las ciudades de Galaad y la mitad de la tierra de los amonitas hasta Aroer, que está frente a Rabá;"
,"26":"desde Jesbón hasta Ramat Mispá y Betonín, y desde Majanayín hasta el territorio de Lo Debir."
,"27":"En el valle: Bet Jarán, Bet Nimrá, Sucot, Safón y el resto del reino de Sijón, rey de Jesbón. El Jordán era el límite hasta el extremo sur del mar de Genesaret."
,"28":"Ésta fue, con sus ciudades y pueblos, la heredad de la tribu de Gad, según sus clanes."
,"29":"Moisés dio también a la media tribu de Manasés una parte, según sus clanes."
,"30":"Su territorio comprendía, desde Majanayín, todo Basán, todo el reino de Og, rey de Basán, y todos los pueblos de Yaír, en Basán: sesenta ciudades."
,"31":"La mitad de Galaad, Astarot y Edreí, ciudades del reino de Og, en Basán, fueron dadas a los hijos de Maquir, hijo de Manasés, a la mitad de los hijos de Maquir, según sus clanes."
,"32":"Éstas fueron las particiones hechas por Moisés en la estepa de Moab, en Transjordania, frente a Jericó, al oriente."
,"33":"Moisés no dio heredad alguna a la tribu de Leví, porque el Señor, Dios de Israel, es su heredad, según él les había dicho."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Esto es lo que recibieron en heredad los israelitas en la tierra de Canaán, lo que les asignaron el sacerdote Eleazar, Josué, hijo de Nun, y los jefes de familia de las tribus de Israel."
,"2":"Hicieron el reparto por suertes, como el Señor había ordenado a Moisés, entre las nueve tribus y media."
,"3":"Porque Moisés había dado ya su heredad a las otras dos tribus y media en Transjordania; a los levitas no les dio heredad."
,"4":"Los hijos de José formaban dos tribus: Manasés y Efraín. No se dio parte alguna a los levitas en la tierra, sino solamente algunas ciudades para habitar, y pastos para sus ganados y rebaños."
,"5":"Los israelitas hicieron el reparto de la tierra tal como el Señor había ordenado a Moisés."
,"6":"Los hijos de Judá acudieron a Josué en Guilgal; y Caleb, hijo de Jefoné el queniceo, le dijo: 'Tú sabes lo que el Señor dijo a Moisés, hombre de Dios, acerca de ti y de mí en Cades Barne."
,"7":"Yo tenía cuarenta años cuando Moisés, siervo del Señor, me envió a Cades Barne a explorar el país, y yo le informé con toda sinceridad."
,"8":"Mientras los hermanos que habían ido conmigo desalentaban al pueblo, yo seguí fielmente al Señor, mi Dios."
,"9":"Aquel día Moisés hizo este juramento: La tierra en la que has puesto tus pies te será dada en posesión perpetua a ti y a tus hijos, porque fuiste fiel al Señor, mi Dios."
,"10":"Y el Señor me ha conservado la vida, según su palabra, estos cuarenta y cinco años transcurridos desde cuando el Señor anunció esto a Moisés, mientras Israel peregrinaba por el desierto, y ahora tengo ochenta y cinco años."
,"11":"Estoy tan fuerte hoy como el día en que me confió Moisés esta misión; tengo el mismo vigor que entonces para luchar, para ir y venir."
,"12":"Dame, pues, esta montaña que el Señor me prometió aquel día, como tú mismo lo oíste. Allí están los anaquitas, y hay ciudades grandes y fortificadas. Si el Señor está conmigo, yo los echaré de allí, como él prometió'."
,"13":"Josué bendijo a Caleb, hijo de Jefoné, y le dio Hebrón en posesión."
,"14":"Por eso Hebrón es posesión de Caleb, hijo de Jefoné, el queniceo, hasta el día de hoy, porque fue fiel al Señor, Dios de Israel."
,"15":"El nombre primitivo de Hebrón era Quiriat Arbá. Arbá había sido el hombre más grande de los anaquitas. Y la tierra gozó de paz."
}`)
	CurrentBook.AddChapter(15, `{
"1":"El territorio que tocó en suerte a la tribu de Judá, por clanes, llegaba hasta la frontera de Edón y el extremo sur del desierto de Sin."
,"2":"Por ese lado la frontera partía de la punta del mar Muerto,"
,"3":"se dirigía hacia el sur por la cuesta de Acrabín, pasaba por Sin y subía al sur de Cades Barne; pasaba por Jesrón, subía a Adar, desde donde se volvía hacia Carcá;"
,"4":"pasaba por Asmón, llegaba hasta el río de Egipto y terminaba en el mar. 'Ésta será vuestra frontera meridional."
,"5":"La frontera oriental será el mar Muerto, hasta la desembocadura del Jordán'. La frontera norte empezaba en la entrada de la desembocadura del Jordán,"
,"6":"subía por Betjoglá, pasaba al norte de Bet Arabá y subía hasta la piedra de Boán, hijo de Rubén;"
,"7":"subía después por Debir, desde el valle de Akor, y volvía hacia Guilgal, que está enfrente de la subida de Adomín, al mediodía del río; pasaba las aguas del En Semes y llegaba a En Rogel."
,"8":"Subía después por el valle de Ben Hinnón hasta tocar la frontera sur del jebuseo, es decir, Jerusalén, y subía a la cima del monte que da vista al valle de Hinnón, a occidente, en el extremo norte de la llanura de Refaín."
,"9":"Desde la cima del monte, el límite torcía hacia las fuentes de Neftoaj, se dirigía hacia el monte de Efrón y se volvía en dirección a Baalá, es decir, Quiriat Yearín."
,"10":"Después de Baalá, la frontera torcía a occidente, hacia el monte Seír, pasaba por la vertiente norte del monte Yearín, es decir, Quesalón; descendía hasta Bet Semes y pasaba por Timná."
,"11":"Después la frontera alcanzaba el lado norte de Ecrón, volvía hacia Sikarón, pasaba por el monte Baalá, llegaba a Yabneel y terminaba en el mar."
,"12":"La frontera occidental era el mar Mediterráneo. Éstos eran los límites de los hijos de Judá, según sus clanes."
,"13":"A Caleb, hijo de Jefoné, se le dio una parte en medio de los hijos de Judá, tal como el Señor había ordenado a Josué: Quiriat Arbá, metrópoli de los anaquitas, es decir, Hebrón."
,"14":"Caleb echó de allí a los tres hijos de Anac: Sesay, Ajiman y Talmay, descendientes de Anac."
,"15":"Desde allí subió contra los habitantes de Debir, cuyo nombre primitivo era Quiriat Séfer."
,"16":"Caleb dijo: 'Al que venza y tome Quiriat Séfer, le daré por esposa a mi hija Acsá'."
,"17":"La tomó Otoniel, hijo de Quenaz, hermano de Caleb, y le dio a su hija Acsá por mujer."
,"18":"Cuando ella fue a casa de su marido, éste la convenció de que pidiera a su padre un campo. Acsá se bajó del asno, y Caleb le preguntó: '¿Qué quieres?'."
,"19":"Ella respondió: 'Hazme un favor; ya que me has destinado el desierto del Negueb, dame fuentes de agua'. Entonces él le dio las fuentes de arriba y las de abajo."
,"20":"Ésta es la heredad de la tribu de Judá, según sus clanes."
,"21":"Las ciudades de la tribu de los hijos de Judá, hacia la frontera de Edón, en el Negueb, eran: Cabseel, Eder, Yagur,"
,"22":"Quiná, Dimoná, Adadá,"
,"23":"Quedes, Jasor y Yitnán,"
,"24":"Zif, Télem, Bealot,"
,"25":"Jasor Hadatá, Queriyyot Jesrón, es decir, Jasor,"
,"26":"Amán, Sema, Moladá,"
,"27":"Jasar Gaddá, Jesmón Bet Pelet,"
,"28":"Jasar Sual, Berseba y Baciotia,"
,"29":"Baala, Iyyín, Esem,"
,"30":"Eltolad Quesil, Jormá,"
,"31":"Sicelag, Madmaná, Sansaná,"
,"32":"Lebaot, Siljín, en Remón; en total, veintinueve ciudades con sus aldeas."
,"33":"En la Sefela: Estaol, Sorá, Asná,"
,"34":"Zanoaj, En Ganín, Tapúaj, Enayín,"
,"35":"Yarmut, Adulán, Socó, Azecá,"
,"36":"Saarayín, Aditayín, Guederá, Guederotayín; catorce ciudades con sus aldeas."
,"37":"Senán, Jadasá, Migdal Gad,"
,"38":"Dilán, Mispeh, Jóctel,"
,"39":"Laquis, Boscat, Eglón,"
,"40":"Cabón, Lajmás, Kitlís,"
,"41":"Guederot, Bet Dagón, Naamá, Maqueda; dieciséis ciudades con sus aldeas."
,"42":"Libná, Éter, Asán,"
,"43":"Iftaj, Esná, Nesib,"
,"44":"Queilá, Aczib, Maresá; nueve ciudades con sus pueblos."
,"45":"Ecrón, con los pueblos y aldeas anejas;"
,"46":"desde Ecrón hasta el mar, todas las ciudades que están en la parte de Asdod con sus aldeas;"
,"47":"Asdod, con los pueblos y aldeas anejas; Gaza, con los pueblos y aldeas anejas, hasta el río de Egipto; el mar Mediterráneo era el límite."
,"48":"En la montaña: Samir, Yatir, Socó,"
,"49":"Daná, Quiriat Saná, es decir, Debir,"
,"50":"Anab, Estemó, Anín,"
,"51":"Gosen, Jolón, Guiló; once ciudades con sus aldeas."
,"52":"Arab, Dumá, Esán,"
,"53":"Yanún, Bet Tapúaj, Afecá,"
,"54":"Jumtá, Quiriat Arbá, es decir, Hebrón, Sior; nueve ciudades con sus aldeas."
,"55":"Maón, Calmel, Zif, Yuttá,"
,"56":"Yezrael, Yocdeán, Zanoaj,"
,"57":"Haqcayín, Guibeá, Timná; diez ciudades con sus aldeas."
,"58":"Jaljul, Bet Sur, Guedor,"
,"59":"Maarat, Bet Anot, Eltecón; seis ciudades con sus aldeas. Técoa, Éfrata, es decir, Belén, Fegor, Etán, Colón, Tatán, Sores, Carem, Galín, Béter, Manaj; once ciudades con sus aldeas."
,"60":"Quiriat Baal, es decir, Quiriat Yearín, Arabá; dos ciudades con sus aldeas."
,"61":"En el desierto: Bet Arabá, Middín, Secacá,"
,"62":"Nibsán, Ciudad de la Sal y Engadí; seis ciudades con sus aldeas."
,"63":"Pero los hijos de Judá no pudieron echar de Jerusalén a los jebuseos; por eso los jebuseos viven todavía hoy en Jerusalén junto con los hijos de Judá."
}`)
	CurrentBook.AddChapter(16, `{
"1":"El territorio que tocó en suerte a los hijos de José iba desde el Jordán al este de Jericó, y subía desde Jericó a la montaña de Betel."
,"2":"Salía de Betel, Luz, pasaba por los límites de los arquitas, en Atarot;"
,"3":"bajaba, por el oeste, hacia el territorio de los yafletitas, hasta el límite de Bejorón de Abajo y hasta Guézer, y terminaba en el mar."
,"4":"Tal era la heredad de los hijos de José: Manasés y Efraín."
,"5":"Éstos son los límites de Efraín, por clanes: al oriente, Atarot Adar hasta Bejorón de Arriba,"
,"6":"llegando al mar; al norte, Micnetat; la frontera volvía hacia el oriente, hacia Taanat Silo, y pasaba al este de Yanoaj;"
,"7":"de Yanoaj bajaba a Atarot y a Naarat, tocaba Jericó y terminaba en el Jordán."
,"8":"Desde Tapúaj, la frontera iba hacia occidente, por el arroyo de Caná, y terminaba en el mar. Tal era la heredad de la tribu de Efraín, por clanes,"
,"9":"aparte de las ciudades reservadas a Efraín en la heredad de Manasés; todas las ciudades y sus aldeas."
,"10":"Pero no pudieron echar de Guézer a los cananeos que vivían allí, y los cananeos viven todavía allí junto con Efraín, pero sometidos a tributo."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Éste es el territorio que tocó en suerte a la tribu de Manasés, el primogénito de José. A Maquir, primogénito de Manasés y padre de Galaad, hombre de guerra, le cayó en suerte Galaad y Basán."
,"2":"Se les dio también una parte a los demás hijos de Manasés, por clanes: los hijos de Abiezer, los de Jélec, los de Asriel, los de Siquén, los de Jéfer, los de Semidá; tales eran los hijos varones de Manasés, por clanes."
,"3":"Selofjad, hijo de Jéfer, hijo de Galaad, hijo de Maquir, hijo de Manasés, no tuvo hijos, sino solamente hijas, que se llamaban: Majlá, Noá, Joglá, Milcá, Tirsá."
,"4":"Éstas se presentaron ante el sacerdote Eleazar, ante Josué, hijo de Nun, y ante los jefes, y les dijeron: 'El Señor ordenó a Moisés que se nos diera una parte lo mismo que a nuestros hermanos'. Y tal como el Señor había ordenado se les dio una parte igual que a los parientes de su padre."
,"5":"Así, a Manasés le tocaron diez partes, además de la tierra de Galaad y Basán, en Transjordania,"
,"6":"pues las hijas de Manasés recibieron una parte igual que los varones. La tierra de Galaad fue para los otros hijos de Manasés."
,"7":"La frontera de Manasés iba de Aser a Micmetat, frente a Siquén; seguía a la derecha hacia Yasib, a la fuente de Tapúaj."
,"8":"El territorio de Tapúaj pertenecía a Manasés, pero Tapúaj, en la frontera de Manasés, pertenecía a Efraín."
,"9":"Después la frontera bajaba hacia el arroyo de Caná. Al sur del arroyo estaban las ciudades de Egreín; el territorio de Manasés estaba al norte del arroyo y terminaba en el mar."
,"10":"El territorio del sur pertenecía a Efraín, y el del norte a Manasés; el mar era su frontera; por el norte confinaban con Aser, y por el este con Isacar."
,"11":"Manasés tenía en los territorios de Isacar y de Aser los siguientes enclaves: Betsán, Yiblán, Dor, Endor, Tanac y Meguido, con sus correspondientes aldeas."
,"12":"Pero los hijos de Manasés no pudieron posesionarse de estas ciudades, y los cananeos continuaron viviendo en aquella región."
,"13":"Cuando los israelitas fueron poderosos, sometieron a los cananeos a tributo, pero no los echaron de allí."
,"14":"Los hijos de José dijeron a Josué: '¿Cómo nos has dado en heredad una sola parte, una sola porción, siendo un pueblo numeroso, al que el Señor ha bendecido hasta ahora?'."
,"15":"Josué les respondió: 'Si sois un pueblo tan numeroso, subid a la selva y roturad allí a vuestro gusto en la tierra de los fereceos y los refaimitas, ya que la montaña de Efraín es demasiado pequeña para vosotros'."
,"16":"Los hijos de José replicaron: 'La montaña no nos basta; pero los cananeos que viven en la llanura tienen carros de hierro, lo mismo que los de Betsán y sus aldeas y los de la llanura de Yezrael'."
,"17":"Josué respondió a los hijos de José, a Efraín y Manasés: 'Vosotros sois un pueblo numeroso y vuestra fuerza es grande; no tendréis una sola parte,"
,"18":"porque la montaña será vuestra; si es selva, la roturaréis y será vuestra con sus términos, porque vosotros echaréis de allí a los cananeos, aunque tengan carros de hierro y sean fuertes'."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Toda la comunidad israelita se reunió en Silo y establecieron allí la tienda de la reunión. El país les estaba sometido."
,"2":"Pero quedaban todavía siete tribus que no habían recibido su heredad."
,"3":"Josué dijo a los israelitas: '¿Qué esperáis para ir a conquistar la tierra que os ha dado el Señor, Dios de vuestros padres?"
,"4":"Elegid tres hombres por tribu; yo los mandaré a recorrer el país y que me hagan una descripción de él con vistas a su partición cuando vengáis'."
,"5":"La dividirán en siete partes. 'Judá permanecerá en su territorio, al sur, y los de la casa de José quedarán en su territorio, al norte."
,"6":"Una vez hecha la descripción del país en siete partes, me la traeréis a mí, y yo echaré las suertes aquí, ante el Señor Dios nuestro."
,"7":"Los levitas no tendrán parte como vosotros, ya que el sacerdocio será su heredad; y Gad, Rubén y la media tribu de Manasés ya han recibido en Transjordania la heredad que les dio Moisés, siervo del Señor'."
,"8":"Cuando se disponían a ir a hacer la descripción del país, Josué les dio estas órdenes: 'Id, recorred el país y haced su descripción; cuando volváis, yo echaré vuestras suertes ante el Señor en Silo'."
,"9":"Ellos marcharon, recorrieron el país e hicieron la descripción de las ciudades en siete lotes, en un plano que llevaron a Josué al campamento en Silo."
,"10":"Josué echó sus suertes en Silo, ante el Señor, y allí distribuyó el país entre los israelitas, por clanes."
,"11":"Salió la suerte de Benjamín por clanes, y el territorio que les tocó estaba entre Judá y José."
,"12":"Su frontera por el norte partía del Jordán, subía por la pendiente norte de Jericó, cruzaba la montaña, hacia occidente, y terminaba en el desierto de Bet Avén;"
,"13":"desde allí pasaba al sur de Luz, o sea, de Betel; bajaba a Atarot Adar, por la montaña que está al sur de Bejorón de Abajo."
,"14":"Volvía, plegándose por el oeste hacia el sur, desde la montaña que está frente a Bejorón, al sur, y terminaba en Quiriat Yearín, ciudad de Judá. Éste era el límite occidental."
,"15":"Por el sur la frontera partía del extremo de Quiriat Yearín, iba hacia Gasín y llegaba cerca de las aguas de la fuente de Neftoaj;"
,"16":"bajaba al final de la montaña que está frente al valle de Ben-Hinnón, al norte de la llanura de los refaimitas, y por el valle de Ben-Hinnón, al lado de los jebuseos, hacia el sur, hasta En Rogel;"
,"17":"volvía al norte, llegaba a En Semes, seguía por Gelilot, frente a la subida de Adomín, y bajaba a la Peña de Boján, hijo de Rubén;"
,"18":"pasaba por la vertiente frente a Bet Arabá, al norte, y bajaba a la Arabá;"
,"19":"seguía por el norte de Bet Joglá, para terminar en el extremo norte del mar Muerto, en la desembocadura del Jordán. Éste era el límite sur."
,"20":"El límite oriental era el Jordán. Ésta es la posesión de Benjamín, con todos sus límites, por clanes."
,"21":"Las ciudades de la tribu de Benjamín, por clanes, eran: Jericó, Bet Joglá, Émec Cesís,"
,"22":"Bet Arabá, Semarayín, Betel,"
,"23":"Avín, Afara, Ofrá,"
,"24":"Quefar Haamoná, Ofní, Gabá; doce ciudades con sus aldeas."
,"25":"Gabaón, Ramá, Berot,"
,"26":"Mispé, Kefirá, Amosá,"
,"27":"Requen, Yorfel, Tarala,"
,"28":"Sela Elef, Jebús, o sea Jerusalén, Guibeá y Quiriat; catorce ciudades con sus aldeas. Ésta fue la heredad de Benjamín, por clanes."
}`)
	CurrentBook.AddChapter(19, `{
"1":"El segundo lote tocó en suerte a Simeón, por clanes; su heredad quedaba dentro de la de Judá."
,"2":"Comprendía: Berseba, Semá, Moladá."
,"3":"Jasar Sual, Balá, Esem,"
,"4":"Eltolad, Betul, Jormá,"
,"5":"Sicelag, Bet Marcabot, Jasar Susá,"
,"6":"Bet Lebaot y Sarujén; trece ciudades con sus aldeas;"
,"7":"Aín, Remón, Etar y Asán, cuatro ciudades con sus aldeas,"
,"8":"y todas las aldeas que había alrededor de estas ciudades hasta Baalat Beer, o sea, Ramat del Negueb. Ésta fue la heredad de Simeón, por sus clanes;"
,"9":"se tomó de la parte asignada a Judá, porque ésta era demasiado grande; por eso los de Simeón tenían su heredad en medio de Judá."
,"10":"El tercer lote tocó en suerte a Zabulón, por sus clanes; su frontera se extendía hasta Sarid;"
,"11":"subía por el oeste, hacia Maralá, tocaba Daberat y llegaba al arroyo que está frente a Yocneán;"
,"12":"desde Sarid torcía al oriente al sol levante, hasta el límite de Quislot Tabor, se dirigía hacia Daberat y subía a Yafia;"
,"13":"allí pasaba en dirección a Jéfer, por Itacasín, subía hacia Remón y volvía hacia Neá."
,"14":"Volvía por el norte, hacia Anatón, y terminaba en el valle de Yeftael."
,"15":"Catat, Nahalal, Simrón, Yidala y Belén; doce ciudades con sus aldeas."
,"16":"Ésta es la heredad de Zabulón, por clanes, con sus ciudades y aldeas."
,"17":"El cuarto lote tocó en suerte a Isacar, por sus clanes."
,"18":"Su heredad comprendía: Yezrael, Quesulot, Sunem,"
,"19":"Jefarayín, Sión, Anajarat,"
,"20":"Daberat, Quisyón, Ebes,"
,"21":"Ramet, En Ganín, En Jadda y Bet Pases."
,"22":"La frontera tocaba en Tabor, Sajasima y Bet Semes, y terminaba en el Jordán; dieciséis ciudades con sus aldeas."
,"23":"Ésta es la heredad de Isacar, por clanes, con sus ciudades y aldeas."
,"24":"El quinto lote tocó en suerte a Aser, por sus clanes."
,"25":"Su heredad comprendía: Jelcat, Jalí, Beten, Acsaf,"
,"26":"Alammélec, Amad y Misal; su frontera por el oeste tocaba el Carmelo y el río Libnat;"
,"27":"por el este llegaba a Bet Dagón, y tocaba en Zabulón y en el norte del valle de Yiftajel; continuaba por Bet Emec y Nejiel, y llegaba por la izquierda a Cabul,"
,"28":"Abdón, Rejob, Jamón y Caná, hasta Sidón la Grande;"
,"29":"volvía hacia Ramá y hasta la plaza fuerte de Tiro; pasaba por Josá, y terminaba en el mar; Majaleb, Acziba,"
,"30":"Aco, Afec, Rejob; veintidós ciudades con sus aldeas."
,"31":"Ésta es la heredad de Aser, por clanes, con sus ciudades y aldeas."
,"32":"El sexto lote tocó en suerte a Neftalí, por sus clanes."
,"33":"Su frontera iba de Jélef y de la encina de Sananín a Adamí Nequeb, a Yabnel, hasta Lacún, y terminaba en el Jordán;"
,"34":"volvía, por occidente, hacia Aznot Tabor, llegaba hasta Jucoc, tocaba Zabulón al sur, Aser a occidente y el Jordán a oriente."
,"35":"Las ciudades fortificadas eran: Ser, Jamat, Racat, Genesaret,"
,"36":"Edmá, Ramá, Jasor,"
,"37":"Cades, Edreí, En Jasor,"
,"38":"Yirón, Migdalel, Jorén, Bet Anat, Bet Semes; diecinueve ciudades con sus aldeas."
,"39":"Ésta es la heredad de Neftalí, por clanes, con sus ciudades y aldeas."
,"40":"El séptimo lote tocó en suerte a Dan."
,"41":"Su heredad comprendía: Sorá, Estaol, Ir Semes,"
,"42":"Salbín, Ayalón, Jetela,"
,"43":"Elón, Timná, Ecrón,"
,"44":"Eltequé, Guibetón, Baalat,"
,"45":"Yehud, Bene Berac, Gat Rimón,"
,"46":"Mejarcón y Racón, con el territorio que queda frente a Jafa."
,"47":"Pero como este territorio les resultaba estrecho, los de la tribu de Dan subieron a atacar a Lesén, la tomaron y la pasaron a filo de espada; la ocuparon y se establecieron en ella. La llamaron Lesén-Dan, del nombre de Dan, su padre."
,"48":"Ésta es la heredad de Dan, por clanes, con sus ciudades y aldeas."
,"49":"Cuando terminaron de repartirse la tierra y delimitados sus territorios, los israelitas dieron a Josué, hijo de Nun, una heredad en medio de ellos."
,"50":"Tal como el Señor lo había ordenado, le dieron la ciudad que él mismo había pedido, Timná-Séraj, en la montaña de Efraín; reconstruyó la ciudad y vivió en ella."
,"51":"Éstas son las heredades que el sacerdote Eleazar, Josué, hijo de Nun, y los jefes de familia de las tribus de Israel repartieron por suerte en Silo, ante el Señor, a la entrada de la tienda de la reunión. Así se llevó a cabo el reparto de la tierra."
}`)
	CurrentBook.AddChapter(20, `{
"1":"El Señor dijo a Josué:"
,"2":"'Di a los israelitas: Designad las ciudades de asilo, de las que os he hablado por medio de Moisés,"
,"3":"en las que pueda refugiarse un homicida que haya matado a alguien involuntariamente y por inadvertencia, para que sirvan de refugio contra el vengador de sangre."
,"4":"El homicida huirá a una de estas ciudades, se detendrá a la entrada de la puerta de la ciudad y expondrá su caso a los ancianos de la ciudad. Éstos lo recibirán y le asignarán una casa para que viva con ellos."
,"5":"Si el vengador de sangre lo persigue, no lo entregarán en sus manos, porque mató involuntariamente a su prójimo, sin tenerle odio anteriormente."
,"6":"Se quedará en esa ciudad hasta que haya comparecido en juicio ante la comunidad, hasta la muerte del sumo sacerdote que esté en funciones en aquellos días. Entonces el homicida podrá marchar y entrar en su ciudad y en su casa, en la ciudad de donde había huido'."
,"7":"Designaron las siguientes: Cades, en Galilea, en la montaña de Neftalí; Siquén, en la montaña de Efraín; Quiriat Arbá, es decir, Hebrón, en la montaña de Judá."
,"8":"En Transjordania, al este de Jericó, en la meseta del desierto: Béser, de la tribu de Rubén; Ramot Galaad, de la tribu de Gad, y Golán-Basán, de la tribu de Manasés."
,"9":"Éstas fueron las ciudades asignadas a todos los israelitas y al extranjero residente, para que se refugiara en ellas el homicida involuntario y no cayera en manos del vengador de sangre antes de haber comparecido ante la asamblea."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Los jefes de familia de los levitas se presentaron en Silo, en el país de Canaán, al sacerdote Eleazar, a Josué, hijo de Nun, y a los jefes de familia de las tribus de Israel,"
,"2":"y les dijeron: 'El Señor, por medio de Moisés, mandó que se nos diesen ciudades para vivir con sus ejidos para nuestros ganados'."
,"3":"Entonces los israelitas dieron de sus propias heredades a los levitas, tal como lo había ordenado el Señor, las siguientes ciudades con sus ejidos."
,"4":"Se echó a suertes para los clanes de Quehat; a los levitas descendientes de Aarón les tocaron trece ciudades de las tribus de Judá, de Simeón y de Benjamín;"
,"5":"a los otros hijos de Quehat, por clanes, les tocaron diez ciudades de las tribus de Efraín, de Dan y de la media tribu de Manasés."
,"6":"A los hijos de Guersón, por clanes, les tocaron diez ciudades de las tribus de Isacar, de Aser, de Neftalí y de la media tribu de Manasés, en Basán."
,"7":"A los hijos de Merarí, por clanes, les tocaron doce ciudades de las tribus de Rubén, de Dan y de Zabulón."
,"8":"Los israelitas dieron en suerte a los levitas estas ciudades, con sus ejidos, tal como lo había ordenado el Señor por medio de Moisés."
,"9":"De las tribus de Judá y de Simeón les dieron las ciudades siguientes,"
,"10":"que tocaron a los levitas, de los clanes de Quehat, descendientes de Aarón:"
,"11":"Quiriat Arbá, ciudad principal de los anaquitas, o sea, Hebrón, en la montaña de Judá, y los ejidos de alrededor;"
,"12":"pero los términos de esta ciudad, con sus aldeas, se los dieron en propiedad a Caleb, hijo de Jefoné."
,"13":"Les dieron como ciudades de refugio para los homicidas: Hebrón, Libná,"
,"14":"Yatir, Estemó,"
,"15":"Jolón, Debir,"
,"16":"Asín, Yutá y Bet Semes, con sus respectivos ejidos: nueve ciudades de estas dos tribus."
,"17":"Y de la tribu de Benjamín, Gabaón, Gueba,"
,"18":"Anatot y Almón, con sus respectivos ejidos: cuatro ciudades."
,"19":"Suma total de las ciudades, de los hijos del sacerdote Aarón: trece ciudades con sus ejidos."
,"20":"A los otros clanes levitas descendientes de Quehat les tocaron en suerte ciudades de la tribu de Efraín."
,"21":"Se les dio como ciudades de refugio para los homicidas: Siquén, en la montaña de Efraín, Guézer,"
,"22":"Quibsayín, Bejorón, con sus respectivos ejidos: cuatro ciudades."
,"23":"De la tribu de Dan: Eltecó, Guibetón,"
,"24":"Ayalón, Gat Rimón, con sus respectivos ejidos: cuatro ciudades."
,"25":"De la media tribu de Manasés: Tanac y Yibleán, con sus respectivos ejidos: dos ciudades."
,"26":"Suma total de las ciudades, con sus ejidos, para estos clanes descendientes de Quehat; diez ciudades."
,"27":"A los clanes levitas descendientes de Guersón se les dio, de la media tribu de Manasés, como refugio para los homicidas: Golán, en Basán, y Astarot, con sus respectivos ejidos: dos ciudades."
,"28":"De la tribu de Isacar, Quisyón, Daberat,"
,"29":"Yarmut, En Ganín, con sus respectivos ejidos: cuatro ciudades."
,"30":"De la tribu de Aser; Misak, Abdón,"
,"31":"Jelcat, Rejob, con sus respectivos ejidos: cuatro ciudades."
,"32":"De la tribu de Neftalí, como ciudades de refugio para los homicidas: Cades, en Galilea, Jamot Dor y Racat, con sus respectivos ejidos; tres ciudades."
,"33":"Suma total de las ciudades de los clanes guersonitas: trece ciudades con sus ejidos."
,"34":"A los restantes clanes levitas, descendientes de Merarí, se les dio, de la tribu de Zabulón: Yocneán, Cartá,"
,"35":"Rimón y Nahalal, con sus respectivos ejidos: cuatro ciudades."
,"36":"En Transjordania, frente a Jericó, de la tribu de Rubén, como ciudades de refugio para los homicidas: Béser, en el desierto, y Yahás, en la llanura,"
,"37":"Quedemot y Mefat, con sus respectivos ejidos; cuatro ciudades."
,"38":"De la tribu de Gad, como ciudades de refugio para los homicidas: Ramot, Galaad, Majanayín,"
,"39":"Jesbón, con sus respectivos ejidos: cuatro ciudades."
,"40":"Suma total de las ciudades de los clanes levitas de Merarí, doce ciudades."
,"41":"Suma total de las ciudades cedidas a los levitas en medio del territorio de los israelitas: cuarenta y ocho ciudades con sus ejidos."
,"42":"Estas ciudades comprendían la ciudad con sus ejidos de alrededor, lo mismo en todas las ciudades."
,"43":"El Señor dio a Israel toda la tierra que había jurado dar a sus padres. Se posesionaron de ella y vivieron en ella."
,"44":"El Señor les dio paz con todos los pueblos vecinos, como había jurado a sus padres; ninguno de sus enemigos pudo resistirlos; a todos los entregó el Señor en sus manos."
,"45":"Ninguna de las promesas que el Señor había hecho a la casa de Israel cayó en el vacío; todas se cumplieron."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Josué convocó a los rubenitas, a los gaditas y a la media tribu de Manasés"
,"2":"y les dijo: 'Habéis cumplido todo lo que os ha mandado Moisés, siervo del Señor, y habéis obedecido mi palabra en todo lo que os he mandado."
,"3":"No habéis abandonado a vuestros hermanos durante mucho tiempo hasta este día, cumpliendo así fielmente el mandato del Señor, vuestro Dios."
,"4":"Ahora, puesto que el Señor, vuestro Dios, ha dado la paz a vuestros hermanos, como se lo había prometido, volveos e id a vuestras tiendas, a la tierra de vuestra heredad que os dio Moisés, siervo del Señor, en Transjordania."
,"5":"Pero poned sumo empeño en cumplir los mandamientos y la ley que os mandó Moisés, siervo del Señor, en amar al Señor, vuestro Dios, seguir sus caminos, observar sus mandamientos, permanecer unidos a él y en servirlo con todo vuestro corazón y con toda vuestra alma'."
,"6":"Josué los bendijo, los despidió, y se fueron a sus tiendas."
,"7":"Moisés había dado a la media tribu de Manasés un territorio en Basán; a la otra media se lo dio Josué en medio de sus hermanos, en Cisjordania. Y cuando Josué los envió a sus tiendas, los bendijo,"
,"8":"diciéndoles: 'Volvéis a vuestras tiendas con grandes riquezas, con muchísimo ganado, con plata, bronce, oro, hierro y con muchos vestidos; repartid con vuestros hermanos el botín de vuestros enemigos'."
,"9":"Los rubenitas, los gaditas y la media tribu de Manasés dejaron a los israelitas en Silo, en la tierra de Canaán, para ir a la tierra de Galaad, la tierra de su heredad, donde ellos se habían establecido, según la orden que el Señor había dado por medio de Moisés."
,"10":"Cuando llegaron a las regiones del Jordán, todavía en tierra cananea, levantaron allí un altar junto al Jordán, un altar de gran apariencia."
,"11":"Llegó a oídos de los israelitas que los rubenitas, los gaditas y la media tribu de Manasés habían levantado un altar en la frontera de Canaán, junto al Jordán, en territorio israelita;"
,"12":"en cuanto lo supieron, se reunieron en Silo para subir contra ellos y hacerles la guerra."
,"13":"Enviaron por delante a Fineés, hijo del sacerdote Eleazar,"
,"14":"con diez jefes, uno por cada una de las tribus de Israel, cabezas de familia."
,"15":"Se presentaron a los rubenitas, a los gaditas y a la media tribu de Manasés en Galaad, y les dijeron:"
,"16":"'Esto dice toda la comunidad del Señor: ¿Qué infidelidad es esta que habéis cometido contra el Dios de Israel? ¿Por qué os habéis levantado un altar en rebeldía contra el Señor?"
,"17":"¿No era bastante el crimen de Fegor, del cual no nos hemos purificado todavía y por el que cayó aquella plaga sobre la comunidad del Señor?"
,"18":"Vosotros os apartáis hoy del Señor. Hoy os rebeláis contra el Señor, y mañana se desahogará la ira de Dios contra toda la comunidad de Israel."
,"19":"Si vuestra heredad os parece impura, pasad a la tierra del Señor, donde él ha establecido su morada, y habitad en medio de nosotros; pero no os rebeléis contra el Señor levantando un altar rival del altar del Señor, nuestro Dios."
,"20":"Cuando Acán, hijo de Zéraj, cometió una infidelidad contra lo consagrado al exterminio, ¿no cayó la ira del Señor sobre toda la comunidad de Israel, aunque era un hombre solo? No murió él solo por su pecado'."
,"21":"Los rubenitas, los gaditas y la media tribu de Manasés respondieron a los jefes israelitas:"
,"22":"'El Señor, Dios de los dioses, él lo sabe, y que lo sepa Israel: si ha sido por rebelión o por infidelidad al Señor, que no nos salve hoy;"
,"23":"si hemos levantado un altar para desviarnos del Señor y para ofrecer en él holocaustos, ofrendas y sacrificios de reconciliación, que el Señor nos pida cuenta de ello."
,"24":"Más bien hemos hecho esto por temor, pensando que el día de mañana vuestros hijos podrán decir a los nuestros: ¿Qué hay de común entre vosotros y el Señor, Dios de Israel?"
,"25":"El Señor puso como frontera el Jordán entre nosotros y vosotros, los de Rubén y los de Gad. ¡Vosotros no tenéis parte en el Señor! Y así vuestros hijos harían que nuestros hijos no respetaran al Señor."
,"26":"Entonces nos dijimos: Levantemos un altar, no destinado a los holocaustos y demás sacrificios,"
,"27":"sino para que sirva de testimonio entre nosotros y vosotros y entre nuestros descendientes después de nosotros, de que damos culto al Señor con nuestros holocaustos y nuestros sacrificios por el pecado y de reconciliación; para que el día de mañana vuestros hijos no puedan decir de los nuestros: ¡No tenéis parte en el Señor!"
,"28":"Y dijimos: Si el día de mañana llegaran a decirnos esto a nosotros o a nuestros descendientes, responderíamos: Mirad la forma del altar del Señor que levantaron nuestros padres, no para ofrecer holocaustos u otros sacrificios, sino para que sirviese de testimonio entre nosotros y vosotros."
,"29":"Lejos de nosotros el pensamiento de rebelarnos contra el Señor y de querer abandonarle hoy levantando un altar para ofrecer holocaustos, sacrificios y ofrendas, fuera del altar del Señor, nuestro Dios, levantado en su morada'."
,"30":"Cuando el sacerdote Fineés, los jefes de la comunidad y los jefes de clanes que le acompañaban oyeron estas palabras de los rubenitas, los gaditas y la media tribu de Manasés, les pareció bien."
,"31":"Y Fineés, hijo del sacerdote Eleazar, dijo a los de Rubén, a los de Gad y a los de Manasés: 'Ahora reconocemos que el Señor está en medio de vosotros, porque no habéis cometido semejante infidelidad contra el Señor y habéis librado a los israelitas de la mano del Señor'."
,"32":"Fineés, hijo del sacerdote Eleazar, y los jefes dejaron a los de Rubén, a los de Gad y a la media tribu de Manasés en Galaad y volvieron a Canaán e informaron a los israelitas."
,"33":"La noticia agradó a los israelitas y bendijeron a Dios; no hablaron más de ir contra ellos para hacerles la guerra y devastar la tierra en que vivían los de Rubén y los de Gad."
,"34":"Los de Rubén y los de Gad llamaron al altar 'Testimonio', porque dijeron: 'Es un testimonio para nosotros de que el Señor es Dios'."
}`)
	CurrentBook.AddChapter(23, `{
"1":"Mucho tiempo después de que el Señor concediera a Israel la paz con todos los enemigos que le rodeaban, Josué, ya de edad avanzada,"
,"2":"convocó a todo Israel, ancianos, jefes, jueces y escribas, y les dijo: 'Yo soy viejo, muy entrado en años."
,"3":"Vosotros habéis visto todo lo que hizo el Señor, Dios vuestro, a todos estos pueblos ante vosotros; es el Señor, vuestro Dios, el que ha combatido por vosotros."
,"4":"Mirad, yo he repartido entre vosotros por suerte, como heredad para vuestras tribus, estos pueblos que han quedado, lo mismo que aquellos que yo he exterminado desde el Jordán hasta el mar Mediterráneo, a occidente."
,"5":"El Señor, vuestro Dios, los echará de sus tierras y vosotros las ocuparéis, tal como lo ha prometido el Señor, vuestro Dios'."
,"6":"'Esforzaos por cumplir todo lo que está escrito en el libro de la ley de Moisés, para que no os apartéis de ella ni a la derecha ni a la izquierda;"
,"7":"no os mezcléis con estos pueblos que quedan en medio de vosotros, no os acordéis del nombre de sus dioses, no los invoquéis en vuestros juramentos, no les sirváis ni os prosternéis ante ellos."
,"8":"Seguid siempre unidos al Señor, vuestro Dios, como lo habéis hecho hasta ahora."
,"9":"El Señor ha echado de vuestra presencia pueblos numerosos y fuertes; ninguno pudo resistir ante vosotros hasta el día de hoy."
,"10":"Uno solo de entre vosotros podía perseguir a mil, porque el Señor, vuestro Dios, combatía por vosotros, como os lo había prometido."
,"11":"Tened sumo empeño en amar al Señor, vuestro Dios, porque en ello os va la vida."
,"12":"Pero si os apartáis del Señor y os unís a estos pueblos que quedan entre vosotros, emparentándoos con ellos en matrimonios mixtos,"
,"13":"estad seguros de que el Señor, vuestro Dios, no echará de vuestra presencia a estos pueblos y serán para vosotros una red, un lazo, un látigo en vuestros costados y espinas en vuestros ojos, hasta que desaparezcáis de esta buena tierra que el Señor, vuestro Dios, os ha dado."
,"14":"Yo ya me voy a morir. Reconoced con todo vuestro corazón y con toda vuestra alma que ninguna de las promesas que el Señor, vuestro Dios, os había hecho, ha caído en el vacío; todas se han cumplido puntualmente; ni una siquiera cayó en el vacío."
,"15":"Pero del mismo modo que se han realizado todas las promesas hechas por el Señor, vuestro Dios, en vuestro favor, también el Señor hará caer sobre vosotros todas sus amenazas hasta haceros desaparecer de esta buena tierra que el Señor, vuestro Dios, os ha dado,"
,"16":"si rompéis la alianza que el Señor, vuestro Dios, os ha impuesto y os vais a servir a otros dioses; si os prosternáis ante ellos, entonces la ira del Señor se encenderá contra vosotros y muy pronto os hará desaparecer de esta buena tierra que él os ha dado'."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Josué reunió a todas las tribus de Israel en Siquén. Convocó a los ancianos, jefes, jueces y escribas, y en presencia del Señor"
,"2":"dijo a todo el pueblo: 'Esto dice el Señor, Dios de Israel: Vuestros padres, Téraj, padre de Abrahán y de Najor, vivían antiguamente al otro lado del río Éufrates y adoraban a otros dioses."
,"3":"Pero yo tomé a vuestro padre Abrahán del lado de allá del río y le hice recorrer toda la tierra de Canaán; multipliqué su descendencia y le di a Isaac."
,"4":"A Isaac le di Jacob y Esaú. A Esaú le di en posesión la montaña de Seír, y Jacob y sus hijos bajaron a Egipto."
,"5":"Envié después a Moisés y Aarón, y castigué a Egipto con los prodigios que hice en medio de él. Después os saqué de allí."
,"6":"Saqué de Egipto a vuestros padres, y llegasteis al mar; los egipcios persiguieron a vuestros padres con carros y caballos hasta el mar Rojo."
,"7":"Entonces ellos clamaron al Señor, y él puso densas tinieblas entre vosotros y los egipcios e hizo volver sobre ellos el mar, que los sumergió. Vosotros habéis visto con vuestros propios ojos lo que hice en Egipto; después vivisteis mucho tiempo en el desierto."
,"8":"Os traje a la tierra de los amorreos, que vivían en Transjordania; ellos combatieron contra vosotros, pero yo los entregué en vuestras manos; ocupasteis su tierra, porque yo los exterminé ante vosotros."
,"9":"Balac, hijo de Sipor, rey de Moab, se levantó para hacer la guerra a Israel y mandó llamar a Balaán, hijo de Beor, para que os maldijese."
,"10":"Pero yo no quise escuchar a Balaán; él os bendijo, y yo os libré de sus manos."
,"11":"Pasasteis el Jordán y llegasteis a Jericó. Los jefes de Jericó combatieron contra vosotros, así como los amorreos, los fereceos, los cananeos, los hititas, los guirgaseos, los heveos y los jebuseos, pero yo los entregué en vuestras manos."
,"12":"Mandé delante de vosotros avispas, que pusieron en fuga a los dos reyes amorreos. Esto no lo debes a tu espada ni a tu arco."
,"13":"Os he dado una tierra que vosotros no habéis cultivado, unas ciudades que no habéis edificado y en las que vivís; coméis los frutos de las viñas y de los olivos que no habéis plantado."
,"14":"Respetad al Señor y servidle con perfección y fidelidad, alejad los dioses a los que sirvieron vuestros padres al otro lado del río y en Egipto, y servid al Señor."
,"15":"Si no os parece bien servir al Señor, escoged hoy a quién queréis servir, si a los dioses a los que sirvieron vuestros padres al otro lado del río o a los dioses de los amorreos, cuya tierra ocupáis; yo y mi casa serviremos al Señor'."
,"16":"El pueblo respondió: 'Lejos de nosotros abandonar al Señor para servir a otros dioses,"
,"17":"porque el Señor es nuestro Dios; él nos sacó a nosotros y a nuestros padres de Egipto, de la casa de la esclavitud; ha realizado ante nuestros ojos estos grandes prodigios y nos ha protegido durante todo el camino que hemos recorrido y en todos los pueblos por los que hemos pasado."
,"18":"El Señor ha echado delante de nosotros a todos los pueblos y a los amorreos que vivían en el país. También nosotros serviremos al Señor, porque él es nuestro Dios'."
,"19":"Josué dijo al pueblo: 'Vosotros no podréis servir al Señor, porque él es un Dios santo, un Dios celoso, y no soportará vuestros delitos ni vuestros pecados."
,"20":"Si abandonáis al Señor para servir a dioses extraños, él se volverá contra vosotros y, después de haberos hecho tanto bien, os hará el mal y os exterminará'."
,"21":"El pueblo respondió a Josué: '¡No! Queremos servir al Señor'."
,"22":"Entonces Josué dijo al pueblo: 'Vosotros sois testigos contra vosotros mismos de que habéis elegido al Señor para servirle'. Y respondieron: 'Somos testigos'."
,"23":"'Entonces, quitad de en medio de vosotros los dioses extranjeros e inclinad vuestros corazones al Señor, Dios de Israel'."
,"24":"El pueblo respondió a Josué: 'Serviremos al Señor, nuestro Dios, y le obedeceremos'."
,"25":"Aquel día Josué hizo un pacto con el pueblo, le impuso leyes y preceptos en Siquén."
,"26":"Y escribió estas palabras en el libro de la ley de Dios. Tomó después una gran piedra y la levantó allí, debajo de la encina que había en el santuario del Señor."
,"27":"Y dijo a todo el pueblo: 'Esta piedra será testigo contra vosotros, porque ella ha oído todas las palabras que el Señor nos ha dirigido; será testigo contra vosotros para que no neguéis a vuestro Dios'."
,"28":"Después Josué despidió al pueblo, y cada uno se volvió a su heredad."
,"29":"Después de todo esto, Josué, hijo de Nun, siervo del Señor, murió a la edad de ciento diez años."
,"30":"Fue sepultado en el territorio de su propiedad, en Timná Séraj, que está en la montaña de Efraín, al norte del monte Gaas."
,"31":"Israel sirvió al Señor durante toda la vida de los ancianos que sobrevivieron a Josué y que conocían todo lo que el Señor había hecho en favor de Israel."
,"32":"Los huesos de José, que los israelitas habían traído de Egipto, fueron sepultados en Siquén, en la parte del campo que Jacob había comprado por cien monedas de plata a los hijos de Jamor, padre de Siquén, y que pasó a ser propiedad de los hijos de José."
,"33":"Después murió Eleazar, hijo de Aarón, y fue sepultado en Guibeá, ciudad de su hijo Fineés, a quien se la habían dado en la montaña de Efraín."
}`)

}
func ES_LSB_LoadVHIHChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Doce años hacía que Nabucodonosor, rey de Asiria, reinaba en la gran ciudad de Nínive, al mismo tiempo que Arfaxad, rey de Media, reinaba en Ecbatana."
,"2":"Éste amuralló Ecbatana con piedra tallada de metro y medio de anchura y tres de longitud. La muralla tenía treinta y cinco metros de alta y veinticinco de ancha."
,"3":"Sobre las puertas de la ciudad levantó torres de cincuenta metros de altura apoyadas en cimientos de veinte metros de anchura."
,"4":"Las puertas, de treinta y cinco metros de altas y veinte de anchas, permitían la salida de las fuerzas y el desfile de la infantería."
,"5":"Por entonces el rey Nabucodonosor declaró la guerra al rey Arfaxad en la amplia llanura que se encuentra en los confines de Ragau."
,"6":"Se unieron a él todos los habitantes de la montaña, los de las riberas del Éufrates, del Tigris y del Hidaspes, y los vasallos de Arioc, rey de Elán; eran, pues, muchos los pueblos alistados contra los descendientes de Jeleud."
,"7":"Nabucodonosor, rey de Asiria, envió emisarios a todos los habitantes de Persia y a todos los de las regiones occidentales, a los de Cilicia, Damasco, Líbano y Antilíbano, a todos los del litoral,"
,"8":"a las poblaciones del Carmelo, Galaad, alta Galilea, gran llanura de Esdrelón,"
,"9":"a los habitantes de Samaría y sus ciudades, a los de Cisjordania hasta Jerusalén, Batane, Jelús, Cades, el río de Egipto, Tafnes, Rameses y país de Gosen,"
,"10":"hasta más allá de Tanis y Menfis, a todas estas gentes de Egipto hasta las fronteras de Etiopía."
,"11":"Pero los habitantes de todas estas regiones despreciaron el llamamiento de Nabucodonosor, rey de Asiria, y no fueron con él a la guerra, porque no le temían; lo consideraban como un hombre cualquiera. Despidieron a sus emisarios con las manos vacías y llenos de vergüenza."
,"12":"Entonces Nabucodonosor se llenó de ira contra todas estas regiones y juró por su trono y por su imperio vengarse con su espada de las regiones de Cilicia, de Damasco y de Siria, así como de todos los habitantes de Moab, Amón, Judea y Egipto hasta los límites de los dos mares."
,"13":"El año diecisiete puso en pie de guerra a todos sus efectivos militares contra el rey Arfaxad y lo venció, desbaratando todo su ejército, su caballería y sus carros."
,"14":"Se adueñó de sus ciudades y llegó hasta Ecbatana; ocupó las torres, destruyó las plazas y convirtió en oprobio su esplendor."
,"15":"Persiguió a Arfaxad hasta las montañas de Ragau y lo acribilló de flechas, acabando con él."
,"16":"Luego regresó a Nínive con sus tropas y con toda la incontable multitud de guerreros que le habían seguido, y durante ciento veinte días se dedicaron a descansar y a comer."
}`)
	CurrentBook.AddChapter(2, `{
"1":"El día veintidós del primer mes del año dieciocho se trató en el palacio de Nabucodonosor, rey de Asiria, de vengarse de todas las naciones, como lo había prometido."
,"2":"Convocó a los ministros y a los nobles, y tuvo con ellos un consejo secreto. Él mismo expuso todos los planes contra las regiones."
,"3":"Y decidieron exterminar a todos los que habían despreciado las palabras del rey."
,"4":"Apenas terminó el consejo, Nabucodonosor, rey de Asiria, llamó a Holofernes, general jefe de su ejército, y le dijo:"
,"5":"'Esto dice el rey grande, el señor de toda la tierra: Mira, al salir de mi presencia, reúne contigo hombres de valor probado, unos ciento veinte mil de infantería y gran número de caballos con doce mil jinetes,"
,"6":"y marcha contra toda la región occidental, por haberse opuesto a mis planes."
,"7":"Diles que se rindan, porque iré enfurecido contra ellos; con los pies de mis soldados cubriré toda la tierra y la entregaré al pillaje."
,"8":"Los heridos llenarán los valles, y los cadáveres desbordarán los torrentes y los ríos."
,"9":"Los llevaré cautivos hasta el fin del mundo."
,"10":"Anda y conquista para mí todos sus territorios; se entregarán a ti, pero tú guárdamelos para el día del castigo."
,"11":"No te compadezcas de los que no quieran rendirse; entrégalos a la muerte y al pillaje en toda la tierra."
,"12":"Lo juro por mi vida y por el poderío de mi imperio: lo que he dicho, lo realizaré con mi mano."
,"13":"Y tú no quebrantes las órdenes de tu señor, sino ejecútalas escrupulosamente, como te he mandado, y realízalas pronto'."
,"14":"Holofernes salió y convocó a los generales, capitanes y oficiales del ejército asirio."
,"15":"Conforme a las órdenes recibidas de su señor, contó ciento veinte mil guerreros escogidos para la lucha y doce mil arqueros de a caballo,"
,"16":"a los que formó en orden de batalla."
,"17":"Se hizo con cantidades incontables de camellos, asnos y mulos, acémilas e innumerables ovejas, bueyes y cabras para el abastecimiento."
,"18":"Cada hombre recibió abundantes provisiones y gran cantidad de oro y plata facilitados por la casa real."
,"19":"Ante la presencia del rey Nabucodonosor partió la expedición de Holofernes con su ejército para invadir todos los países occidentales con sus carros, caballería y soldados escogidos de infantería."
,"20":"Le seguía una muchedumbre numerosa como la langosta y como la arena de la tierra, tan numerosa que no podía contarse."
,"21":"Durante la primera etapa, de tres días, llegaron desde Nínive a la llanura de Bectilet, y después de Bectilet acamparon junto a las montañas que están a la izquierda de la alta Cilicia."
,"22":"Desde allí penetró con su ejército, infantería, caballería y carros, en la región montañosa."
,"23":"Redujo a cenizas a Put y Lidia, saqueó a los habitantes de Rassis y a los de Ismael, que vivían en el desierto, al sur de Jeleón."
,"24":"Pasó el Éufrates, atravesó Mesopotamia y arrasó todas las ciudades fortificadas enclavadas junto al río Abrona, hasta el mar."
,"25":"Se apoderó de Cilicia, deshaciéndose de todos los que le ofrecían resistencia; llegó al país de Jafet, al sur, cara a la Arabia;"
,"26":"cercó a los madianitas, incendió sus tierras y tomó en botín sus ganados."
,"27":"Bajó a la llanura de Damasco durante la siega e incendió sus campos, dispersó sus ovejas y sus bueyes, saqueó sus ciudades, devastó sus campiñas y pasó al filo de la espada a todos los jóvenes."
,"28":"El temor y el pánico se apoderaron de todos los habitantes del litoral: de los habitantes de Sidón y Tiro, de Sur y Ocina y Yamnia. Los de Asdod, Ascalón y Gaza estaban aterrados."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Le enviaron emisarios en son de paz:"
,"2":"'Aquí nos tienes, siervos de Nabucodonosor, rey grande, rendidos ante ti; trátanos como quieras."
,"3":"Ahí están a tu entera disposición nuestras fincas, nuestro territorio y nuestros campos, nuestras ovejas y nuestras vacas y los apriscos de nuestros ganados. Haz con ellos lo que quieras."
,"4":"Tuyas son también nuestras ciudades, y siervos tuyos sus habitantes. Trátalos como quieras'."
,"5":"Aquellos hombres se presentaron a Holofernes y le transmitieron este mensaje."
,"6":"Holofernes bajó con su ejército hacia la costa, dejando guarniciones en las ciudades fortificadas y reclutando cuidadosamente, como refuerzo, fuerzas subsidiarias."
,"7":"Los de las ciudades y pueblos de los alrededores lo recibieron con coronas y danzando al son del tamboril."
,"8":"Pero él arrasó sus templos, taló sus bosques sagrados y destruyó todos sus dioses, para que adorasen solamente a Nabucodonosor, y todas las lenguas y todas las tribus le invocasen como dios."
,"9":"Llegó después a la llanura de Esdrelón, cerca de Dotán, situada frente a la llanura de Palestina."
,"10":"Acampó entre Gabá y Escitópolis, donde permaneció un mes para reorganizar el aprovisionamiento de su ejército."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Cuando los israelitas y los habitantes de Judá supieron lo que Holofernes, generalísimo de Nabucodonosor, rey de Asiria, había hecho con los pueblos y cómo había expoliado y destruido sus santuarios,"
,"2":"se llenaron de pánico y se angustiaron al tenerlo a las puertas, pensando en Jerusalén y en su templo."
,"3":"Hacía poco que habían vuelto del destierro, que el pueblo judío se había reunificado y que los objetos del culto, el altar y el templo habían sido purificados de su profanación."
,"4":"Así que dieron la voz de alarma a los montes de Samaría, Coná, Bejorón, Belmain, Jericó, Joba, Ajsora y al valle de Salén."
,"5":"Ocuparon las cimas de los montes, fortificaron los pueblos y reclutaron aprovisionamientos para sostener la guerra, pues habían terminado de segar sus campos."
,"6":"El sumo sacerdote Joaquín, que por entonces residía en Jerusalén, escribió a los habitantes de Betulia y de Betomestain, situada frente a Esdrelón, hacia la llanura de Dotán."
,"7":"Les decía que vigilasen las pendientes de las montañas, pues eran el paso hacia Judá. Les resultaría fácil obstaculizar el avance, pues el desfiladero era tan estrecho que no permitía pasar más que de dos en dos."
,"8":"Los israelitas hicieron como les había ordenado el sumo sacerdote Joaquín y el consejo de ancianos del pueblo de Israel, que habitaban en Jerusalén."
,"9":"Todos los israelitas se dirigieron fervorosamente a Dios y ayunaron rigurosamente."
,"10":"Los hombres y sus esposas, sus hijos, incluso pequeñitos; sus animales, los forasteros, los jornaleros y los esclavos, se pusieron cilicios sobre sus cuerpos."
,"11":"Todos los israelitas, hombres, mujeres y niños que habitaban en Jerusalén, se postraron ante el templo, se cubrieron de ceniza sus cabezas y se ciñeron con saco ante el Señor."
,"12":"Rodearon también el altar con sacos, y todos juntos pidieron fervorosamente al Dios de Israel que no entregase sus hijos al pillaje, que no fuesen sus mujeres arrebatadas ni sus ciudades destruidas y que el templo no fuese profanado y ultrajado por paganos."
,"13":"Dios oyó su clamor y comprendió su angustia. El pueblo ayunaba día tras día en Judá y Jerusalén, mirando al templo del Dios omnipotente."
,"14":"El sumo sacerdote Joaquín, los sacerdotes del servicio y los levitas, ceñidos sus cuerpos con cilicio, ofrecían el sacrificio perpetuo, las ofrendas y los dones voluntarios del pueblo."
,"15":"Tenían sus turbantes cubiertos de ceniza y clamaban al Señor con toda su fuerza para que velase por la casa de Israel."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Holofernes, general jefe del ejército asirio, supo que los israelitas se preparaban para la guerra, que habían bloqueado los pasos de las montañas, fortificado las cimas de los montes y levantado obstáculos en las llanuras."
,"2":"Se llenó entonces de ira y llamó a los generales moabitas, a los jefes amonitas y a todos los sátrapas del litoral."
,"3":"Y preguntó: 'Cananeos, decidme quién es el pueblo que habita en las montañas, cuáles son las ciudades que ocupa, qué contingente tiene de tropas, en qué consiste su fuerza y su poder, quién es el rey que guía su ejército"
,"4":"y por qué no se han dignado salir a recibirme como los otros países occidentales'."
,"5":"Ajior, jefe de todos los amonitas, le respondió: 'Escucha, señor, la palabra de boca de tu siervo y te anunciaré la verdad de ese pueblo que habita en la montaña, que reside cerca de ti, y no te diré ninguna mentira."
,"6":"Este pueblo desciende de los caldeos."
,"7":"Habitaron primero en Mesopotamia, porque no querían servir a los dioses de sus padres, a los dioses caldeos."
,"8":"Abandonaron el culto de sus padres y adoraron al Dios del cielo, al que reconocían. Arrojados por sus padres de la presencia de sus dioses, huyeron a Mesopotamia, donde residieron largo tiempo."
,"9":"Pero su Dios les dijo que dejasen su residencia y se instalasen en el país de Canaán, y aquí llegaron y se llenaron de oro y plata y de gran cantidad de ganados."
,"10":"Después bajaron a Egipto, porque hubo un hambre general en Canaán. Allí permanecieron mientras encontraron comida. Allí se multiplicaron hasta hacerse un pueblo numeroso e incontable."
,"11":"El rey de Egipto les forzó a hacer ladrillos, los humilló y redujo a la condición de esclavos."
,"12":"Clamaron a su Dios, y él llenó de plagas a Egipto, para las que no encontraban remedio. Los egipcios, entonces, los echaron de su tierra."
,"13":"Pero Dios secó el mar Rojo ante ellos"
,"14":"y los condujo hasta el Sinaí y Cadesbarne. Rechazaron a todos los habitantes del desierto."
,"15":"Habitaron luego en el país de los amorreos, y con su poder acabaron con todos los jesbonitas. Pasaron el Jordán y ocuparon la región montañosa,"
,"16":"y echaron de allí a los cananeos, fereceos y jebuseos, a los siquemitas y a todos los guirgaseos, y durante mucho tiempo habitaron en esta región."
,"17":"Mientras no ofendieron a su Dios, todo les fue bien, pues estaba con ellos el Dios que aborrece la injusticia."
,"18":"Pero cuando se apartaron del camino que Dios les había trazado, gran número pereció en numerosas batallas y fueron desterrados a tierras extrañas, el templo de Dios fue destruido y sus ciudades tomadas por los enemigos."
,"19":"Pero cuando se convirtieron a su Dios, volvieron a posesionarse de Jerusalén, donde está su santuario, y habitaron la región montañosa, que estaba libre."
,"20":"Así pues, poderoso señor, si hay algún delito en este pueblo, si han pecado contra su Dios, si existe algún motivo de caída, sepámoslo; y entonces, adelante, y los venceremos."
,"21":"Pero si no hay anomalías en esta gente, que se abstenga mi señor; porque si su Señor y Dios está con ellos, serviremos de irrisión a toda la tierra'."
,"22":"Tan pronto como Ajior terminó de hablar, todo el pueblo que estaba congregado ante la tienda comenzó a murmurar. Los magnates de Holofernes, los habitantes del litoral y los de Moab hablaban de despedazarlo."
,"23":"'No tememos a los israelitas, pues es un pueblo sin fuerza y sin poder para una lucha dura."
,"24":"Adelante, pues, que serán botín de tu ejército, poderoso Holofernes'."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Apaciguado el tumulto de la asamblea, Holofernes, general jefe del ejército asirio, dijo a Ajior y a los hombres de Moab, ante la muchedumbre de extranjeros:"
,"2":"'¿Quién eres tú, Ajior, y vosotros, mercenarios de Efraín, para profetizar hoy aquí y para intentar persuadirnos de no pelear contra Israel, pretextando que Dios lo protege? ¿Y qué Dios existe, a no ser Nabucodonosor? Él nos dará fuerza y los exterminará de la faz de la tierra, sin que pueda librarlos su Dios."
,"3":"Y nosotros, sus siervos, los barreremos como a un solo hombre y no podrán resistir el brío de nuestra caballería."
,"4":"Los quemaremos a todos, sus montañas chorrearán su sangre y sus llanuras serán cementerios. La planta de sus pies no resistirá ante nosotros, perecerán sin remedio, dice el rey Nabucodonosor, señor de toda la tierra. Él ha hablado, y no caerá en el vacío ninguna de sus palabras."
,"5":"Y tú, Ajior, mercenario amonita, que has pronunciado estas palabras en un día aciago para ti, no verás más mi rostro hasta que no me haya vengado de esta raza que escapó de Egipto."
,"6":"Entonces la espada de mis soldados y la multitud de mis servidores traspasarán tu cuerpo, y tú caerás con los heridos cuando yo avance."
,"7":"Mis hombres te llevarán a la región montañosa y te dejarán en una de las ciudades de la subida."
,"8":"No perecerás hasta que no seas exterminado con ellos."
,"9":"Si confías que no serán vencidos, ¡no pongas esa cara! Ninguna de las palabras que he dicho quedará sin cumplimiento'."
,"10":"Holofernes ordenó a los hombres que estaban en su tienda que prendiesen a Ajior, lo llevasen a Betulia y lo entregasen a los israelitas."
,"11":"Ellos lo sacaron fuera del campo, hacia la llanura. Pasaron la llanura, se encaminaron hacia la montaña y llegaron a las fuentes que hay bajo Betulia."
,"12":"Cuando los de la ciudad los divisaron, empuñaron sus armas y salieron hacia la cima del monte. Los prácticos en la honda impedían su subida disparándoles piedras."
,"13":"Ellos, deslizándose por la ladera, ataron a Ajior, lo abandonaron en la falda del monte y se volvieron adonde estaba su jefe."
,"14":"Los israelitas bajaron, se acercaron a él, lo desataron, lo llevaron a Betulia y lo presentaron a los jefes de la ciudad,"
,"15":"que eran entonces Ozías, hijo de Miqueas, de la tribu de Simeón; Cabris, hijo de Godoniel, y Carmis, hijo de Melquiel."
,"16":"Convocaron a todos los ancianos de la ciudad. Acudieron también a la asamblea los jóvenes y las mujeres. Ajior, puesto en medio del pueblo, fue interrogado por Ozías sobre lo sucedido."
,"17":"Les comunicó lo de la asamblea de Holofernes, lo que había dicho ante los jefes asirios y la grandilocuencia de Holofernes contra Israel."
,"18":"Entonces todo el pueblo se postró y adoró a Dios diciendo:"
,"19":"'Señor, Dios del cielo, considera su arrogancia y ten compasión de tu humillado pueblo; vuelve tu mirada a los que están consagrados a ti'."
,"20":"Aplaudieron a Ajior y lo felicitaron efusivamente."
,"21":"Ozías lo llevó a su casa y ofreció un banquete a los ancianos. Pasaron toda la noche invocando la protección del Dios de Israel."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Al día siguiente Holofernes ordenó a su ejército y a todas las tropas que se le habían unido para la guerra que marcharan hacia Betulia, ocuparan las pendientes de las montañas y lucharan contra los israelitas."
,"2":"Todos sus guerreros se pusieron en marcha. Las fuerzas armadas sumaban ciento setenta mil soldados de infantería y doce mil de caballería, sin contar el material y la gente que se les había unido. Era una muchedumbre incontable."
,"3":"Acamparon en el valle cercano de Betulia, en la fuente, extendiéndose a lo ancho desde Dotán hasta Belmain, y a lo largo desde Betulia hasta Ciamón, frente a Esdrelón."
,"4":"Cuando los israelitas vieron aquella ingente multitud, se aterrorizaron y se dijeron unos a otros: 'Éstos, sin duda, cubrirán toda la tierra, y ni los montes más altos, ni los desfiladeros, ni las colinas podrán detener su marcha'."
,"5":"Sin embargo, cada cual tomó su equipo guerrero e hicieron hogueras sobre las torres, permaneciendo en alarma toda la noche."
,"6":"El segundo día Holofernes hizo desfilar toda su caballería ante los israelitas de Betulia,"
,"7":"examinó todas las subidas de la ciudad e inspeccionó los manantiales, ocupándolos y destacando allí hombres de guerra. Después se volvió con su ejército."
,"8":"Los nobles edomitas, los jefes moabitas y los generales del litoral le dijeron:"
,"9":"'Escucha, señor, una palabra, y no habrá bajas en tu ejército."
,"10":"Este pueblo de los israelitas confía, más que en sus lanzas, en las alturas de sus montañas, donde están replegados y donde no es fácil subir."
,"11":"Por eso, si no quieres, señor, que perezca ninguno de los tuyos, no los ataques en lucha ordenada."
,"12":"Permanece en tu tienda, ahorrando hombres de tu ejército. Tus siervos ocuparán las fuentes que brotan de la falda de la montaña."
,"13":"Como de allí se surten de agua los de Betulia, los acosará la sed y tendrán que entregar su ciudad. Entonces nosotros y nuestras tropas subiremos a lo alto de las montañas, donde destacaremos puestos de guardia para impedir que nadie salga de la ciudad."
,"14":"Consumidos por el hambre, hombres, mujeres y niños quedarán tendidos por las plazas antes de que intervengas con la espada."
,"15":"Habrás así asestado un fuerte castigo a su rebeldía por no haber salido a recibirte en son de paz'."
,"16":"Agradó la propuesta a Holofernes y a sus ayudantes, y decidió actuar conforme a ella."
,"17":"Salió al campamento de los amonitas, y con ellos cinco mil asirios; llegaron al valle y ocuparon las aguas y las fuentes de los israelitas."
,"18":"Los hombres de Esaú y los amonitas subieron y acamparon en la montaña frente a Dotán, de donde enviaron algunos al sur y al este, cara a Egrebel, cerca de Jus, que está sobre el torrente Mocmur. El resto del ejército asirio acampó en la llanura, cubriendo todo el país. Sus tiendas y su equipamiento eran una mole ingente, pues era una muchedumbre impresionante."
,"19":"Los israelitas clamaron al Señor, su Dios, al ver que los rodeaban sus enemigos sin que hubiese posibilidad de escapar."
,"20":"El ejército asirio, la infantería, los carros y la caballería los tuvieron cercados durante treinta y cuatro días. Las reservas de agua llegaron a faltar a los habitantes de Betulia."
,"21":"Se agotaron las cisternas, y no podían saciarse de agua ni siquiera un solo día, porque se les daba racionada."
,"22":"Se desmayaban sus niños, desfallecían de sed sus mujeres y jóvenes y caían exánimes en las calles de la ciudad y en los pasos de las puertas."
,"23":"Entonces todo el pueblo, jóvenes, mujeres y niños, se amotinó contra Ozías y los jefes de la ciudad, clamando a grandes voces ante los ancianos:"
,"24":"'Juzgue Dios entre vosotros y nosotros. Cometéis una gran injusticia al no negociar la paz con los asirios."
,"25":"Ya no hay quien nos ayude, pues Dios nos ha entregado en sus manos para que perezcamos de sed ante ellos en lenta agonía."
,"26":"Llamadlos y entregad como botín la ciudad a las gentes de Holofernes y a su ejército."
,"27":"Mejor es para nosotros ser su botín. Seremos sus esclavos; pero viviremos y no veremos morir a nuestros niños ni perecer a nuestras mujeres y jóvenes."
,"28":"Os conjuramos por el cielo y la tierra, por nuestro Dios y Señor de nuestros padres, que nos castiga según nuestros pecados y los de nuestros padres, a tomar esta determinación hoy mismo'."
,"29":"Toda la asamblea se conmovió profundamente, clamando al Señor, su Dios, a grandes voces."
,"30":"Ozías les respondió: 'Tened calma, hermanos; resistamos todavía cinco días; en estos días, nuestro Dios se compadecerá de nosotros, pues él no nos abandonará totalmente."
,"31":"Si, pasados estos días, no llegara ningún socorro, haré lo que decís'."
,"32":"Hizo volver al pueblo a sus puestos, a las murallas y a las torres de la ciudad. A las mujeres y a los niños los mandó a sus casas. Pero en la ciudad había una gran consternación."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Todo esto lo supo Judit, hija de Merarí, hijo de Ox, de José, de Oziel, de Jelcías, de Ananías, de Gedeón, de Rafaín, de Ajitob, de Elías, de Jilquías, de Eliab, de Natanael, de Salamiel, de Sarasaday, de Israel."
,"2":"Su marido, Manasés, de su misma tribu y familia, había muerto durante la siega de la cebada."
,"3":"Mientras vigilaba en la besana a los atadores de las gavillas, le dio una insolación y tuvo que guardar cama. Murió en Betulia, su ciudad, y fue enterrado con sus padres en el campo situado entre Dotán y Balamón."
,"4":"Judit, viuda hacía tres años y cuatro meses,"
,"5":"vivía en una habitación que se había hecho en la terraza de la casa. Vestía un áspero sayal y siempre iba de luto."
,"6":"Desde que estaba viuda ayunaba todos los días, excepto los sábados y sus vísperas, los novilunios y sus vísperas, las fiestas y las conmemoraciones del pueblo de Israel."
,"7":"Era muy bella y de aspecto encantador. Su marido, Manasés, le había dejado muchas riquezas, criados y criadas, ganados y campos, y ella los administraba."
,"8":"Nadie podía hablar mal de ella, pues era muy temerosa de Dios."
,"9":"Judit se enteró de las duras palabras que el pueblo había dicho contra el jefe por la falta de agua. Supo también lo que había dicho Ozías y cómo había jurado entregar la ciudad a los asirios después de cinco días."
,"10":"Entonces mandó a la administradora de todos sus bienes que llamara a Cabris y a Carmis, los ancianos de la ciudad."
,"11":"Cuando llegaron, les dijo: 'Jefes de Betulia, escuchadme. Lo que hoy habéis dicho ante el pueblo no está bien. Habéis jurado entregar la ciudad a nuestros enemigos si Dios no viene en vuestra ayuda en estos días."
,"12":"¿Quiénes sois vosotros para tentar así a Dios y poneros por encima de él delante de los hombres?"
,"13":"Queréis poner a prueba al Dios omnipotente, cuando no sabéis nada."
,"14":"Si no podéis escrutar el fondo del corazón humano ni penetrar en los pensamientos de su mente, ¿cómo vais a comprender a Dios, creador de todas las cosas? ¿Cómo vais a conocer sus pensamientos y a entender sus designios? Hermanos, no irritéis al Señor, nuestro Dios."
,"15":"Si no quiere socorrernos en estos cinco días, tiene poder para ayudarnos cuando quiera o para exterminarnos a la vista de nuestros enemigos."
,"16":"Pero vosotros no forcéis la voluntad del Señor, nuestro Dios, pues Dios no es como un hombre, al que se puede amenazar y presionar."
,"17":"Por tanto, con la esperanza de que nos salve, pidámosle su ayuda; y, si le parece bien, escuchará nuestras súplicas."
,"18":"Por otra parte, no hay actualmente en nuestra nación ninguna tribu, familia, pueblo o ciudad que adore a los ídolos, como sucedió en otro tiempo."
,"19":"Por eso nuestros padres fueron entregados a la espada y al saqueo, y cayeron ante nuestros enemigos."
,"20":"Pero nosotros no conocemos otro Dios que él; por eso esperamos que no nos abandonará ni a nosotros ni a nuestra nación."
,"21":"Pues si caemos nosotros, caerá toda Judea, el templo será saqueado y nosotros seremos responsables ante Dios de su profanación,"
,"22":"de la matanza de nuestros hermanos, de la esclavitud de nuestra tierra, de la destrucción de nuestros bienes en medio de los pueblos donde estemos desterrados. Nuestros conquistadores nos humillarán y nos despreciarán,"
,"23":"y nuestra esclavitud no sería para nuestro bien, sino que el Señor, Dios nuestro, haría de ella nuestra deshonra."
,"24":"Por tanto, hermanos, seamos conscientes de que la vida de nuestros compatriotas depende de nosotros, y que el santuario, el templo y el altar pesan sobre nosotros."
,"25":"Por todo esto demos gracias al Señor, Dios nuestro, que nos quiere probar, como a nuestros padres."
,"26":"Recordad lo que hizo con Abrahán, cómo probó a Isaac y lo que sucedió a Jacob en Mesopotamia de Siria, mientras apacentaba los rebaños de Labán, hermano de su madre."
,"27":"Pues como probó a éstos para sondear su corazón, así lo hace con nosotros; pero no por venganza, pues Dios castiga a los que se acercan a él para corregirlos'."
,"28":"Ozías le respondió: 'Todo lo que has dicho, lo has dicho con buenas intenciones, y nadie puede despreciar tus palabras."
,"29":"No es hoy cuando se ha manifestado tu prudencia, pues desde siempre el pueblo conoce tu sagacidad y la bondad natural de tu corazón."
,"30":"Pero el pueblo moría de hambre y nos ha obligado a actuar como lo hemos hecho y a comprometernos con un juramento que jamás quebrantaremos."
,"31":"Pide por nosotros tú, que eres una mujer piadosa, y el Señor nos enviará lluvia abundante para llenar nuestras cisternas y que no perezcamos'."
,"32":"Judit le respondió: '¡Escuchadme! Voy a realizar una hazaña que se transmitirá de generación en generación a los hijos de nuestra raza."
,"33":"Estad vosotros esta noche a la puerta de la ciudad; saldré yo con mi doncella y, antes de expirar el tiempo fijado para entregar la ciudad a nuestros enemigos, habrá librado el Señor a Israel por mediación mía."
,"34":"Vosotros no intentéis conocer mi hazaña; no la conoceréis hasta que se realice'."
,"35":"Ozías y los jefes le dijeron: 'Vete en paz, y que el Señor Dios esté contigo para vengarte de nuestros enemigos'."
,"36":"Entonces salieron de la habitación y volvieron a sus puestos."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Judit se postró con el rostro en tierra, echó ceniza sobre su cabeza y dejó al descubierto el áspero sayal que llevaba. Era precisamente la hora en que se ofrecía en Jerusalén el incienso de la tarde en el templo de Dios, cuando clamó al Señor así:"
,"2":"'Señor, Dios de mi padre Simeón, en cuyas manos pusiste la espada para castigar a aquellos extranjeros que desnudaron, violaron y deshonraron a una virgen, profanando su seno. Hicieron todo eso, aunque tú habías prohibido hacerlo."
,"3":"Pero entregaste a sus jefes a la matanza y su lecho, que presenció su ignominia, al engaño y a la sangre; castigaste a los esclavos juntamente con los poderosos, y a éstos en sus tronos;"
,"4":"abandonaste a sus mujeres al rapto y a sus hijos al cautiverio, y todas sus posesiones a que fueran repartidas entre tus hijos predilectos, que ardiendo en celo por ti, detestaron la profanación de su sangre e invocaron tu ayuda."
,"5":"¡Oh Dios, Dios mío, escucha a esta viuda! Tuyo es el pasado, el presente y el futuro; lo que has pensado, se ha hecho. Las cosas que has decidido, se han realizado."
,"6":"Todos tus caminos están preparados y previstas tus decisiones."
,"7":"Los asirios se han crecido con su poder, se han enorgullecido de sus caballos y jinetes, se han jactado de la fortaleza de su infantería, confían en la espada y en la jabalina, en el arco y en la honda, pero no quieren reconocer que tú eres el Señor que decide las guerras."
,"8":"Tu nombre es 'el Señor'. Deshaz su fuerza con tu poder y humilla su dominio con tu ira, pues pretenden profanar tu santuario, violar el tabernáculo donde mora el nombre de tu gloria y arrancar con hierro los cuernos de tu altar."
,"9":"Mira su orgullo. Descarga tu ira sobre sus cabezas y da a mi mano de viuda la fuerza precisa."
,"10":"Castiga con la seducción de mis palabras al esclavo y al señor, al jefe y a su servidor. Acaba con su fanfarronería por medio de mi mano de mujer."
,"11":"Pues no está tu fuerza en la multitud ni en los poderosos tu dominio, sino que eres Dios de los humildes, socorro de los oprimidos, protector de los débiles, defensor de los abandonados, salvador de los desesperanzados."
,"12":"Sí, Dios de mi padre y Dios de Israel, Señor de cielos y tierra, creador de las aguas, rey de la creación entera, escucha mi plegaria."
,"13":"Dame palabras seductoras para herir y deshacer a los que tienen tan perversos planes contra tu alianza, contra tu santuario, el monte de Sión y la casa que pertenece a tus hijos."
,"14":"Haz que todo el pueblo y todas las tribus reconozcan que eres, oh Dios, todopoderoso y fuerte, y que fuera de ti no hay defensor del pueblo de Israel'."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Cuando terminó de invocar al Dios de Israel,"
,"2":"se levantó del lugar en que estaba postrada, llamó a su doncella, bajó a las habitaciones donde residía en los sábados y en las fiestas,"
,"3":"se quitó el áspero sayal que llevaba puesto, se despojó de sus vestidos de viuda, se bañó y se perfumó, se peinó, se ciñó la cabeza con un turbante y se adornó con los vestidos de fiesta que solía ponerse cuando vivía su esposo Manasés."
,"4":"Se calzó las sandalias, se cubrió de collares, ajorcas, anillos, pendientes, de todas sus joyas. Tan bella estaba, que atraería las miradas de cuantos hombres se encontrase."
,"5":"Entregó a su doncella una bota de vino y un tarro de aceite, llenó las alforjas con panes de cebada, tortas de higos y panes rituales; lo envolvió todo y se lo entregó."
,"6":"Se dirigieron después hacia la puerta de Betulia y hallaron junto a ella a Ozías y a los dos ancianos del pueblo, Cabris y Carmis."
,"7":"Al ver su rostro tan cambiado y mudados sus vestidos, se extasiaron ante su belleza y le dijeron:"
,"8":"'El Dios de nuestros padres te favorezca y realice tus planes para gloria de Israel y exaltación de Jerusalén'."
,"9":"Ella adoró a Dios y les dijo: 'Mandad abrir la puerta de la ciudad para que pueda salir a realizar lo que me acabáis de decir'. Mandaron a los jóvenes que abriesen, como ella había dicho."
,"10":"Cumplida la orden, Judit salió con su doncella. Los de la ciudad la seguían con la mirada mientras bajaba la montaña hasta pasar el valle; después la perdieron de vista."
,"11":"Ambas caminaban aprisa a través del valle, cuando les salieron al paso centinelas asirios,"
,"12":"que detuvieron a Judit y le preguntaron: '¿De quién eres? ¿De dónde vienes y adónde vas?'. Ella respondió: 'Soy una hebrea que huye de los hebreos, porque están a punto de caer en vuestras manos."
,"13":"Voy a presentarme a Holofernes, general jefe de vuestro ejército, para comunicarle información exacta. Yo le mostraré el camino para apoderarse de toda la montaña, sin perder ni un solo hombre'."
,"14":"Los soldados, al oír estas palabras, y prendados de su hermosura -era de belleza extraordinaria-, le dijeron:"
,"15":"'Has salvado tu vida apresurándote a venir a nuestro jefe. Vete a su tienda; algunos de nosotros te escoltaremos hasta allí."
,"16":"Cuando estés en su presencia, no tengas miedo; repítele todo lo que nos has dicho, y te tratará bien'."
,"17":"Escogieron a cien hombres, que las acompañaron y guiaron hasta la tienda de Holofernes."
,"18":"La noticia se propagó de tienda en tienda; de todo el campamento acudían y la rodeaban, mientras ella, fuera de la tienda de Holofernes, esperaba el anuncio de su llegada."
,"19":"Se maravillaban de su belleza y de los israelitas, y comentaban: '¿Quién puede despreciar al pueblo que tiene mujeres tan bellas? No sería prudente dejar ni un solo hombre, pues los supervivientes podrían seducir al mundo entero'."
,"20":"Los guardias personales de Holofernes y todos sus ayudantes de campo salieron y la introdujeron en la tienda."
,"21":"Holofernes descansaba en su lecho, bajo un baldaquino de púrpura y oro, adornado de esmeraldas y piedras preciosas."
,"22":"Anunciaron la llegada, y se dirigió a la entrada de su tienda, precedido de lámparas de plata."
,"23":"Cuando Judit se presentó ante él y sus ayudantes, todos se quedaron maravillados de la belleza de su rostro. Ella se postró en tierra, pero los ayudantes la levantaron."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Holofernes le dijo: 'Ten confianza, mujer, no tengas miedo; jamás he maltratado a los que han decidido servir a Nabucodonosor, rey de toda la tierra."
,"2":"Tampoco ahora habría levantado mi espada contra tu pueblo, que habita en la montaña, si no me hubiese despreciado; pero él lo ha querido."
,"3":"Y bien, dime por qué has huido y has venido a refugiarte entre nosotros. Lo has hecho para salvarte. Ten la seguridad de que salvarás tu vida esta noche y en adelante."
,"4":"Nadie te hará mal; te tratarán bien, como se trata a los servidores de mi señor el rey Nabucodonosor'."
,"5":"Judit respondió: 'Dígnate escuchar las palabras de tu sierva para que pueda hablar con libertad ante tu presencia, pues ninguna mentira diré a mi señor esta noche."
,"6":"Si escuchas las propuestas de tu sierva, Dios realizará plenamente en ti sus designios, y mi señor no quedará decepcionado en sus empresas."
,"7":"Viva Nabucodonosor, rey de toda la tierra, y viva su poder, que te ha enviado para restablecer el orden en todos los seres vivientes; ya que, gracias a ti, no sólo los hombres le sirven, sino hasta las bestias salvajes, los animales domésticos y las aves del cielo viven, gracias a tu poder, para Nabucodonosor y toda su dinastía."
,"8":"Hemos oído hablar de tu sabiduría y de la habilidad de tu espíritu, y toda la tierra sabe que tú solo en todo el reino eres hábil, rico de experiencia y prodigioso en campañas guerreras."
,"9":"Conocemos también las palabras que Ajior pronunció en tu asamblea, y hemos oído sus propuestas, pues los hombres de Betulia lo acogieron y él les contó todo lo que habían dicho delante de ti."
,"10":"Ahora bien, poderoso señor, no desprecies sus palabras, sino considéralas bien, pues son verdaderas. No será castigado nuestro pueblo ni la espada podrá con ellos si no han pecado contra su Dios."
,"11":"Pero para que no quedes decepcionado y fracasado, sabe que la muerte caerá sobre ellos. Están dominados por el pecado, por el que excitan la ira de su Dios cuando cometen algún despropósito."
,"12":"Puesto que les faltan los víveres y el agua escasea, han decidido echar mano de sus jumentos y consumir todo lo que Dios, con sus leyes, les tiene prohibido comer."
,"13":"Han determinado consumir las primicias del trigo y los diezmos del vino y del aceite, cosas sagradas reservadas a los sacerdotes de Jerusalén, que ningún seglar puede tocar ni siquiera con las manos."
,"14":"Han enviado delegados a Jerusalén, donde el pueblo hace lo mismo, para conseguir autorización de los ancianos."
,"15":"Cuando reciban la respuesta y se pongan a hacerlo, entonces Dios los pondrá en tus manos para que acabes con ellos."
,"16":"Así que yo, tu sierva, conociendo todo esto, he huido de ellos, y Dios me ha enviado para realizar contigo hazañas tales que toda la tierra, cuando las sepa, quedará estupefacta."
,"17":"Porque tu sierva es devota y honra al Dios del cielo día y noche. Me quedaré contigo, señor, y saldré cada noche al valle a rezar a Dios para que me diga cuándo han cometido el pecado."
,"18":"Te informaré entonces, y tú saldrás con tu ejército, y nadie podrá oponerte resistencia."
,"19":"Te llevaré yo por toda la Judea hasta llegar a Jerusalén y haré que te sientes en el centro de ella. Tú los conducirás como ovejas sin pastor, y ni siquiera un perro ladrará contra ti. Todo esto me ha sido manifestado para que lo conocieras anticipadamente; Dios me lo ha comunicado, y me ha mandado anunciártelo'."
,"20":"Estas palabras agradaron a Holofernes y a todos sus ayudantes de campo, que, admirados de su sabiduría, dijeron:"
,"21":"'En el mundo entero no hay una mujer comparable a ésta en la hermosura y en la sabiduría'."
,"22":"Holofernes le dijo: 'Dios ha hecho bien al enviarte por delante de tu pueblo para demostrarle que el poder está en mis manos y la ruina en los que desprecian a mi señor."
,"23":"Eres muy hermosa y muy lista. Si haces lo que has dicho, tu Dios será mi Dios, vivirás en el palacio de Nabucodonosor y alcanzarás renombre en toda la tierra'."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Mandó que la pasaran adonde tenía sus cubiertos de plata, y ordenó que se le sirviera de sus manjares y que le dieran a beber de su vino."
,"2":"Pero Judit le dijo: 'No puedo comer esos manjares para no caer en culpa; yo he traído mi propia comida'."
,"3":"Holofernes replicó: 'Si se te acaban tus provisiones, ¿cómo nos arreglaremos para procurarte otras, pues no hay entre nosotros nadie de tu raza?'."
,"4":"Judit respondió: 'Por tu vida, señor mío, que no habré terminado mis provisiones antes que el Señor haya realizado por mi mano sus designios'."
,"5":"Los ayudantes de campo la llevaron a su tienda. Durmió hasta medianoche, y se levantó de madrugada."
,"6":"Había pedido a Holofernes: 'Ordena, señor mío, que me permitan salir para la oración'."
,"7":"Y Holofernes lo había ordenado a sus guardias. Permaneció tres días en el campo, y cada noche marchaba al valle de Betulia y se lavaba en la fuente, junto al cuerpo de guardia."
,"8":"Mientras iba, rogaba al Dios de Israel que encaminase sus pasos para exaltación de los hijos de su pueblo."
,"9":"Volvía purificada, y permanecía en su tienda hasta el atardecer, en que tomaba sus alimentos."
,"10":"El cuarto día Holofernes ofreció un banquete sólo a sus servidores, sin invitar a ninguno de sus oficiales."
,"11":"Y dijo a Bagoas, el eunuco, que era su mayordomo: 'Trata de persuadir a la hebrea para que venga a comer y beber con nosotros."
,"12":"Sería vergonzoso dejar marchar semejante mujer sin habernos divertido con ella. Si no la conseguimos, se burlará de nosotros'."
,"13":"Bagoas fue adonde estaba Judit, y le dijo: 'Que esta hermosa joven no se niegue a venir donde mi señor, para ser agasajada por él, beber con nosotros el vino que causa alegría y ser como una de las mujeres asirias, que viven en el palacio de Nabucodonosor'."
,"14":"Judit le respondió: '¿Quién soy yo para oponerme a mi señor? Todo lo que sea de su agrado, lo haré con sumo gusto y será para mí un motivo de gozo hasta el fin de mi vida'."
,"15":"Ella se levantó, se puso un vestido de gala y sus adornos femeninos. Iba delante su doncella, que extendió en el suelo, junto a Holofernes, las pieles que Bagoas le había entregado para su uso diario, para comer recostada sobre ellas."
,"16":"Judit entró y se sentó. Holofernes sintió una fuerte pasión por ella y un ardiente deseo de poseerla; desde que la había visto aguardaba el momento de seducirla."
,"17":"Holofernes le decía: '¡Bebe y alégrate con nosotros!'."
,"18":"Judit le respondía: 'Con mucho gusto bebo, señor, porque jamás me ha parecido la vida tan bella como hoy'."
,"19":"Y ante él comía y bebía de lo que le había preparado su doncella."
,"20":"Holofernes estaba encantado de tenerla cerca, y bebió tal cantidad de vino cual no había bebido en ninguno de los días de su vida."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Cuando se hizo tarde, los servidores se retiraron. Bagoas cerró por fuera la puerta de la tienda, procurando dejar solo a su señor. Cansados de tanto comer y beber, todos se fueron a dormir."
,"2":"Solamente quedó Judit en la tienda con Holofernes, el cual, completamente borracho, estaba tumbado en la cama."
,"3":"Judit había dicho a su doncella que estuviera fuera del dormitorio, esperando su salida como los otros días, ya que había anunciado que saldría a la oración, de lo que había hablado al mismo Bagoas."
,"4":"Todos, grandes y pequeños, se habían ido, y no había nadie en la tienda. Judit, de pie junto a la cama, dijo interiormente: 'Señor, Dios omnipotente, mira en este momento la obra de mis manos para la exaltación de Jerusalén."
,"5":"Ha llegado el momento de ayudar a tu heredad y de realizar mis proyectos para derrotar a los enemigos que se han levantado contra nosotros'."
,"6":"Se acercó al poste que había sobre la cabeza de Holofernes, y tomó su alfanje."
,"7":"Fue a la cama, le agarró la cabeza por los cabellos, y dijo: 'Señor, Dios de Israel, dame ahora fuerzas'."
,"8":"Le dio por dos veces en el cuello con toda su fuerza, y le cortó la cabeza."
,"9":"Envolvió luego el cuerpo con la ropa de la cama y quitó las cortinas de las columnas. Salió aprisa y entregó la cabeza de Holofernes a su doncella,"
,"10":"quien la metió en las alforjas de las provisiones; luego salieron ambas a la oración, como de costumbre. Atravesaron el campo, bordearon el valle, faldearon la montaña de Betulia y llegaron a las puertas de la ciudad."
,"11":"Judit desde lejos gritó a los centinelas: '¡Abrid, abrid la puerta! Dios, nuestro Dios, está con nosotros, demostrando su poder a Israel y su fuerza contra los enemigos, como lo ha hecho hoy'."
,"12":"Tan pronto como los hombres de la ciudad oyeron su voz, se apresuraron a bajar a la puerta y llamaron a los ancianos."
,"13":"Todos, chicos y grandes, fueron corriendo; no esperaban su vuelta. Abrieron la puerta, las recibieron, encendieron fuego para verse y le hicieron corro."
,"14":"Ella les dijo a grandes voces: '¡Alabad a Dios, alabadlo! Alabad a Dios, que no ha apartado su misericordia del pueblo de Israel, sino que ha derrotado esta noche a nuestros enemigos valiéndose de mí'."
,"15":"Sacó la cabeza de las alforjas, se la mostró y dijo: 'Aquí está la cabeza de Holofernes, general del ejército asirio. Aquí están también las colgaduras bajo las que dormía borracho. El Señor le dio un golpe mortal por mano de una mujer."
,"16":"¡Viva el Señor, que me ha protegido en el camino recorrido! Mi rostro lo sedujo para su perdición. Pero no pudo pecar conmigo, lo que hubiera sido mi profanación y mi deshonra'."
,"17":"Todo el pueblo, entusiasmado, se postró, adorando a Dios y exclamando a coro: '¡Bendito eres, Dios nuestro, que has aniquilado hoy a los enemigos de tu pueblo!'."
,"18":"Ozías decía: 'Bendita seas tú, hija del Dios altísimo, entre todas las mujeres de la tierra, y bendito el Señor Dios, que creó los cielos y la tierra, y te ha guiado hasta cortar la cabeza del jefe de nuestros enemigos."
,"19":"La confianza que has demostrado no se borrará del corazón de los hombres, que siempre recordarán el poder de Dios."
,"20":"Que Dios te colme de bienes para tu exaltación eterna, pues viendo abatida nuestra raza, no has perdonado la vida, antes fuiste su socorro en la ruina, portándote con rectitud ante Dios'. Y todo el pueblo respondió: 'Así sea. Así sea'."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Judit les dijo: 'Oídme, hermanos. Tomad la cabeza y colgadla en lo alto de las murallas."
,"2":"Cuando amanezca y el sol haya salido, tomad vuestras armas, y que los más fuertes salgan de la ciudad con un jefe a la cabeza, como si quisieran bajar a la llanura contra las avanzadillas de los asirios, pero que no bajen."
,"3":"Ellos entonces empuñarán sus armas e irán al campo a despertar a los generales del ejército asirio, que se presentarán en la tienda de Holofernes, pero no lo encontrarán. Entonces cundirá el pánico y huirán ante vuestra presencia."
,"4":"Vosotros y los habitantes de todo el territorio de Israel los perseguiréis y los mataréis mientras huyen."
,"5":"Pero antes de realizar este plan, llamad a Ajior, el amonita, para que vea e identifique al que menospreciaba al pueblo de Israel y nos lo envió para morir'."
,"6":"Llamaron a Ajior, que estaba en casa de Ozías. Cuando llegó y vio la cabeza de Holofernes en manos de un hombre de los de la asamblea del pueblo, cayó al suelo sin sentido."
,"7":"Cuando volvió en sí, se echó a los pies de Judit y le dijo: 'Bendita seas en todas las tiendas y en todos los pueblos, que al oír tu nombre quedarán asombrados."
,"8":"Cuéntame ahora lo que hiciste estos días'. Judit, en medio del pueblo, le contó todo lo que había hecho desde su partida hasta el momento en que hablaba."
,"9":"Al terminar, todo el pueblo dio gritos de alegría, que resonaron en toda la ciudad."
,"10":"Viendo Ajior todo lo que había hecho el Dios de Israel, creyó firmemente en él y se circuncidó, agregándose para siempre al pueblo de Israel."
,"11":"Al rayar el alba, colgaron la cabeza de Holofernes en las murallas. Tomó cada cual sus armas y salieron en grupos hacia las subidas de la montaña."
,"12":"Los asirios, al verlos, se lo comunicaron a sus oficiales, los cuales a su vez informaron a los generales, a los capitanes y a todos los jefes."
,"13":"Llegaron a la tienda de Holofernes y dijeron a su ayudante: 'Despierta a nuestro jefe, pues los esclavos se han atrevido a bajar a luchar contra nosotros para su ruina total'."
,"14":"Bagoas entró y tocó la puerta de la tienda, pues creía que dormía con Judit."
,"15":"Al no responder nadie, entró en el dormitorio y lo encontró tendido en el suelo, muerto, con el cuerpo sin cabeza."
,"16":"Dio entonces grandes gritos, llorando, gimiendo, clamando fuertemente y rasgando sus vestiduras."
,"17":"Entró después en la tienda de Judit y no la encontró. Corrió al pueblo y gritó:"
,"18":"'¡Las esclavas nos han traicionado! Una mujer hebrea ha cubierto de vergüenza la casa de Nabucodonosor. Holofernes está tendido en el suelo sin cabeza'."
,"19":"Al oír estas palabras, los jefes del ejército asirio rasgaron sus vestiduras, se conmovieron profundamente y se pusieron a lanzar lamentos y gritos en medio del campamento."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Cuando los que estaban en las tiendas se enteraron de lo ocurrido, se quedaron estupefactos"
,"2":"y se llenaron de miedo y de terror. Ninguno quería permanecer allí; todos salieron a la desbandada, huyendo por todos los caminos de la llanura y de la montaña."
,"3":"Los que estaban apostados en torno a Betulia se dieron también a la fuga. Entonces los israelitas, preparados para el combate, se lanzaron sobre ellos."
,"4":"Ozías envió mensajeros a Betomestain, a Bebay, a Joba, a Cola y a todo Israel para informarles de lo ocurrido, y para que salieran a perseguir y destruir a los enemigos."
,"5":"Cuando los israelitas lo supieron, cayeron sobre ellos, los derrotaron y los persiguieron hasta Joba. Acudieron también los de Jerusalén y los de la región montañosa, pues ya sabían lo sucedido en el campamento de sus enemigos. Los de Galaad y los de Galilea les propinaron una gran derrota hasta más allá de Damasco y su región."
,"6":"Los que quedaron en Betulia bajaron al campo asirio, lo saquearon y se enriquecieron grandemente."
,"7":"Los israelitas que volvían de la matanza se adueñaban del resto. Las alquerías y las aldeas de la montaña y de la llanura obtuvieron un gran botín, pues la abundancia era enorme."
,"8":"El sumo sacerdote Joaquín y el consejo de los israelitas residentes en Jerusalén vinieron a admirar los beneficios que Dios había concedido a Israel, a ver a Judit y a felicitarla."
,"9":"Al verla, todos a una la ensalzaron así: 'Tú eres la gloria de Jerusalén, el honor de Israel, el orgullo de nuestra raza."
,"10":"Has hecho todo esto con tu mano, has procurado un gran bien a Israel y Dios se ha complacido en ello. Que el Señor todopoderoso te bendiga para siempre jamás'. Y todo el pueblo respondió: 'Así sea'."
,"11":"El pueblo estuvo saqueando el campamento durante treinta días. A Judit le entregaron la tienda de Holofernes, todos sus objetos de plata, su dormitorio, su vajilla y todo su ajuar. Ella lo tomó, preparó las mulas, enganchó los carros y lo cargó todo."
,"12":"Todas las mujeres de Israel se habían juntado para verla. La aclamaron y organizaron bailes en su honor. Ella llevaba tirsos en sus manos, y los repartía entre las que le acompañaban."
,"13":"Iban coronadas con hojas de olivo, y Judit, a la cabeza del pueblo, dirigía el baile de las mujeres. Los hombres de Israel, armados y coronados, las seguían cantando himnos."
,"14":"Judit entonó este himno de acción de gracias, que repetía todo el pueblo:"
}`)
	CurrentBook.AddChapter(16, `{
"1":"'Alabad a mi Dios con tamboriles, cantad al Señor con címbalos, cantad en su honor un cántico nuevo, ensalzad e invocad su nombre."
,"2":"El Señor es el Dios que acaba con las guerras, pues en el campamento, en medio del pueblo, me libró de las manos de mis perseguidores."
,"3":"Vinieron los asirios de las montañas del norte,con su ejército incontable. La multitud cerraba los valles,y los caballos cubrían los montes."
,"4":"Quisieron incendiar mi tierra, pasar a los jóvenes al filo de la espada, estrellar contra el suelo a los niños de pecho, llevarse como botín a los muchachos,y raptar a las doncellas."
,"5":"El Señor todopoderoso los deshizo por medio de una mujer."
,"6":"Su jefe no cayó a manos de jóvenes, ni lo hirieron titanes, ni lo atacaron gigantes. ¡Fue Judit, hija de Merarí!,Ella lo desarmó con su hermosura."
,"7":"Ella se quitó sus vestidos de viuda,para salvar a los afligidos de Israel. Untó su rostro con perfumes,"
,"8":"recogió su cabellera en un turbante,y se vistió de gala para seducirlo."
,"9":"Sus sandalias robaron sus ojos, y su belleza encadenó su alma; el alfanje segó su cuello."
,"10":"Los persas se estremecieron de su audacia, los medos se turbaron de su temeridad."
,"11":"Entonces mis humildes dieron la voz de alarma y ellos se asustaron; mis débiles gritaron, y ellos se llenaron de terror; dieron voces, y ellos se dieron a la fuga."
,"12":"Hijos de esposas jóvenes los atacaron, como a fugitivos los herían; perecieron por la acción de mi Señor."
,"13":"Cantad a mi Dios un cántico nuevo. Eres grande, Señor, y glorioso, admirable por tu fortaleza e invencible."
,"14":"Que te sirvan todas las criaturas, pues hablaste, y fueron creadas; enviaste tu espíritu, y existieron; y no hay nada que se resista a tu voz."
,"15":"Las aguas desquiciarán los cimientos de los montes; las rocas, ante ti, se derretirán como la cera; pero tú serás siempre propicio con tus fieles."
,"16":"Poca cosa son los sacrificios de olor agradable,y es menos que nada la grasa de los holocaustos, pero es grande sobremanera el que te teme."
,"17":"¡Ay de las naciones que se enfrentan a mi raza!,El Señor omnipotente las castigará en el día del juicio, pondrá fuego y gusanos en sus cuerpos,y llorarán atormentados para siempre'."
,"18":"Cuando llegaron a Jerusalén, adoraron a Dios, se purificaron y ofrecieron holocaustos, dones y ofrendas voluntarias."
,"19":"Judit ofreció a Dios todos los objetos de Holofernes, que el pueblo le había entregado, y los cortinajes que ella había quitado de su dormitorio."
,"20":"El pueblo estuvo celebrando fiestas ante el templo durante tres meses."
,"21":"Después, todos volvieron a sus casas; Judit regresó a Betulia, y se dedicó a su hacienda. Fue famosa en todo el pueblo mientras vivió."
,"22":"Tuvo muchos pretendientes, pero ella no quiso casarse desde que su marido Manasés murió, y fue a reunirse con su pueblo."
,"23":"Su fama crecía cada día hasta que se hizo vieja en casa de su marido Manasés; llegó a la edad de ciento cinco años. Dio la libertad a su esclava y murió en Betulia. La enterraron en el sepulcro de su marido Manasés."
,"24":"Hubo luto en el pueblo durante siete días. Antes de morir, repartió su hacienda entre los parientes de su marido y entre los suyos."
,"25":"Mientras vivió Judit, nadie amenazó a Israel, y ni siquiera en mucho tiempo después de su muerte."
}`)

}
func ES_LSB_LoadVHNHChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Palabras de Nehemías, hijo de Jacalías. En el mes de quisleu, el año veinte del rey Artajerjes, estando yo en la fortaleza de Susa,"
,"2":"Jananí, uno de mis hermanos, llegó con algunos hombres de Judá. Yo le pregunté por los judíos, los supervivientes salvados del destierro, y por Jerusalén."
,"3":"Me dijeron: 'Los supervivientes del destierro que quedan allí, en la provincia, se encuentran en gran estrechez y humillación; la muralla de Jerusalén está destrozada y sus puertas destruidas por el fuego'."
,"4":"Al oír estas palabras, yo me senté y me puse a llorar. Permanecí en duelo algunos días, ayunando y orando ante el rey del cielo."
,"5":"Y exclamé: '¡Ah Señor, Dios del cielo, Dios grande y terrible, que guardas la alianza y la fidelidad con los que te aman y observan tus mandamientos!"
,"6":"Que tus oídos estén atentos y tus ojos abiertos para escuchar la plegaria de tu siervo, que yo derramo ahora ante ti, día y noche, por los israelitas tus siervos, confesando los pecados que ellos han cometido contra ti. Yo mismo y la casa de mi padre hemos pecado;"
,"7":"nos hemos portado inicuamente contigo y no hemos guardado los mandamientos, las leyes y los preceptos que tú habías dado a tu siervo Moisés."
,"8":"Pero acuérdate de lo que dijiste a tu siervo Moisés: Si sois infieles, yo os dispersaré entre las naciones;"
,"9":"pero si os convertís a mí y observáis mis mandamientos, poniéndolos en práctica, aunque vuestros desterrados estuvieran en el extremo de los cielos, yo los recogeré de allí y los conduciré de nuevo al lugar que he escogido para morada de mi nombre."
,"10":"Pues bien, éstos son tus siervos y éste tu pueblo, a quienes tú has redimido con tu gran poder y tu fuerte brazo."
,"11":"Oh Señor, estén atentos tus oídos a la súplica de tu siervo y a la oración de tus servidores, que quieren ser fieles a ti. Concede éxito a tu siervo y haz que tengan buena acogida ante ese hombre'. Era yo entonces copero del rey."
}`)
	CurrentBook.AddChapter(2, `{
"1":"En el mes de nisán, el año veinte del rey Artajerjes, siendo yo encargado del vino, lo tomé y se lo serví al rey. Anteriormente nunca había estado triste ante él."
,"2":"Y el rey me dijo: '¿Por qué estás tan triste? Enfermo no estás; tu corazón está afligido'. Entonces, sumamente azorado,"
,"3":"dije al rey: 'Oh rey, vive eternamente. ¿Cómo no he de estar triste, cuando la ciudad donde están las tumbas de mis padres está destruida y sus puertas consumidas por el fuego?'."
,"4":"El rey me dijo: '¿Qué es lo que quieres?'. Yo, encomendándome al Dios del cielo,"
,"5":"le dije: 'Si le parece bien al rey y quiere hacer un favor a su siervo, déjame ir a Judá, a la ciudad de las tumbas de mis padres, para poderla reconstruir'."
,"6":"El rey, que tenía a la reina sentada a su lado, me preguntó: '¿Cuánto durará tu viaje y cuándo estarás de vuelta?'. Yo le fijé un plazo, que le pareció bien, y él me autorizó a marchar."
,"7":"Luego dije al rey: 'Si le parece bien al rey, tenga a bien darme cartas para los gobernadores de Transeufratina, a fin de que me dejen libre el paso hasta Judá,"
,"8":"y una carta dirigida a Asaf, el guarda del parque real, para que me dé madera de construcción para las puertas de la ciudadela del templo, para la muralla de la ciudad y la casa en que he de habitar yo'. El rey me lo concedió, porque mi Dios me protegía."
,"9":"El rey me puso una escolta de infantería y de caballería. Me presenté a los gobernadores de Transeufratina y les entregué las cartas del rey."
,"10":"Al enterarse de ello Sambalat, el joronita, y Tobías, el funcionario amonita, no les gustó nada que hubiera venido un hombre a procurar el bien de los israelitas."
,"11":"Llegué a Jerusalén y descansé tres días."
,"12":"Luego me levanté de noche, con unos cuantos hombres, sin manifestar a nadie lo que por inspiración divina iba a hacer por Jerusalén, llevando sólo el caballo que yo montaba."
,"13":"Salí, pues, de noche, por la puerta del Valle, me dirigí hacia la fuente del Dragón y luego a la puerta del Muladar, inspeccionando la muralla de Jerusalén destruida y las puertas consumidas por el fuego."
,"14":"Continué después hasta la puerta de la Fuente y la alberca del rey; pero, como no había sitio para pasar con mi cabalgadura,"
,"15":"volví a subir de noche por el torrente, inspeccionando siempre la muralla, hasta la puerta del Valle. Por allí regresé a casa,"
,"16":"sin que los prefectos supieran dónde había ido ni qué había hecho; pues hasta entonces no había comunicado nada a los judíos, ni a los sacerdotes, ni a los nobles, ni a los prefectos, ni a los otros responsables."
,"17":"Después les dije: 'Ya veis la triste situación en que nos encontramos: Jerusalén destruida, sus puertas consumidas por el fuego. Venid, reconstruyamos la muralla de Jerusalén y no seremos más objeto de escarnio'."
,"18":"Y les conté cómo Dios me había protegido y las palabras que el rey me había dirigido. Ellos exclamaron: '¡Ea, emprendamos la construcción!'. Y se animaron mutuamente para esta hermosa tarea."
,"19":"Pero al enterarse de ello Sambalat, el joronita, Tobías, el funcionario amonita, y Guesen, el árabe, se burlaron de nosotros y dijeron con desprecio: '¿Qué es lo que estáis haciendo? ¿Os vais a rebelar contra el rey?'."
,"20":"Yo les respondí: 'El Dios del cielo es quien nos dará éxito. Nosotros, sus siervos, vamos a ponernos a la obra. Vosotros no tenéis parte, ni derecho, ni nada en Jerusalén'."
}`)
	CurrentBook.AddChapter(3, `{
"1":"El sumo sacerdote Eliasib y sus hermanos los sacerdotes se encargaron de construir la puerta de las Ovejas; la armaron y colocaron sus hojas. Reconstruyeron también el tramo hasta la torre de Jananel."
,"2":"A su lado trabajaron los hombres de Jericó y, después de éstos, Zacur, hijo de Imrí."
,"3":"De la puerta de los Peces se encargaron los hijos de Hasnaá; la armaron y colocaron sus hojas, cerraduras y barras."
,"4":"A continuación de éstos trabajaron en la restauración Meremot, hijo de Urías, hijo de Hacós; después de éstos Mesulán, hijo de Berequías, hijo de Mesezabel, y a continuación Sadoc, hijo de Baaná."
,"5":"Al lado de éstos trabajaron los habitantes de Técoa; pero sus nobles no quisieron colaborar con sus señores."
,"6":"La puerta Vieja fue restaurada por Josadá, hijo de Paséaj, y Mesulán, hijo de Besodías; ellos armaron y colocaron sus hojas, cerraduras y barras."
,"7":"A su lado trabajaron Melatías de Gabaón, Yadón de Meronot, con los hombres de Gabaón y de Mispá, a expensas del gobernador de Transeufratina."
,"8":"A continuación trabajó Uziel, hijo de Jarjayas, del gremio de los orfebres, y después de él Jananías, del gremio de los perfumistas; ellos reconstruyeron Jerusalén hasta la muralla de la plaza."
,"9":"A continuación trabajó Refayas, hijo de Jur, jefe de la mitad del distrito de Jerusalén;"
,"10":"a su lado Jedayas, hijo de Jarumaf, frente a su casa, y después Jatús, hijo de Jasabnías."
,"11":"Malaquías, hijo de Jarín, y Jasub, hijo de Pajat Moab, repararon el tramo siguiente hasta la torre de los Hornos."
,"12":"A continuación trabajó, acompañado de sus hijos, Salún, hijo de Halojés, gobernador de la otra mitad del distrito de Jerusalén."
,"13":"Janún y los habitantes de Zanóaj restauraron la puerta del Valle; la construyeron y colocaron sus hojas, cerraduras y barras; repararon también quinientos metros de la muralla hasta la puerta del Muladar."
,"14":"De la puerta del Muladar se encargó Malaquías, hijo de Recab, jefe del distrito de Bet Haqérem; él la construyó y colocó sus hojas, cerraduras y barras."
,"15":"La puerta de la Fuente la restauró Salún, hijo de Col José, jefe del distrito de Mispá; la construyó, la techó y colocó sus hojas, cerraduras y barras; reparó también el muro de la alberca del rey, hasta la gradería que baja de la ciudad de David."
,"16":"A continuación de él trabajó Nehemías, hijo de Azbuc, jefe de la mitad del distrito de Bet Sur, hasta enfrente de los sepulcros de David, hasta la alberca artificial y la casa de los héroes."
,"17":"A continuación trabajaron los levitas: Rejún, hijo de Baní; con él Jasabías, jefe de la mitad del distrito de Queilá, por su distrito."
,"18":"A continuación sus hermanos: Binuy, hijo de Jenadad, jefe de la otra mitad del distrito de Queilá;"
,"19":"después Ézer, hijo de Josué, jefe de Mispá, reparó otro tramo frente a la subida de la armería hasta el ángulo."
,"20":"A continuación reparó otro tramo Baruc, hijo de Zabay, desde el ángulo hasta la puerta de la casa del sumo sacerdote Eliasib."
,"21":"A continuación Meremot, hijo de Urías, hijo de Hacós, restauró otro tramo desde la puerta de la casa de Eliasib hasta el extremo de la misma."
,"22":"A continuación trabajaron los sacerdotes que habitaban en la llanura."
,"23":"A continuación Benjamín y Jasub, el trecho frente a su casa; a continuación Azarías, hijo de Maasías, hijo de Ananías, el tramo junto a su casa."
,"24":"A continuación restauró otro trecho Binuy, hijo de Jenadad, desde la casa de Azarías hasta el ángulo."
,"25":"Palal, hijo de Uzay, reparó el trecho enfrente del ángulo de la torre que sobresale del palacio real alto y da al patio de la cárcel; a continuación Pedayas, hijo de Parós."
,"26":"Los sirvientes del templo, que habitaban en el Ofel, restauraron hasta la puerta del Agua, en dirección del levante y hasta la torre saliente."
,"27":"A continuación restauraron otro trecho los de Técoa, frente a la gran torre saliente hasta la muralla de Ofel."
,"28":"A partir de la puerta de los Caballos trabajaron los sacerdotes, cada uno frente a su propia casa."
,"29":"A continuación trabajó Sadoc, hijo de Imer, frente a su casa; a continuación Semayas, hijo de Secanías, guardián de la puerta Oriental."
,"30":"A continuación Jananías, hijo de Selemías, y Janún, sexto hijo de Salaf, repararon otro trecho. A continuación trabajó Mesulán, hijo de Baraquías, frente a su casa."
,"31":"A continuación Malaquías, del gremio de los orfebres, restauró hasta la casa de los sirvientes del templo y de los comerciantes, frente a la puerta de la Vigilancia y hasta la cámara alta del ángulo."
,"32":"Y entre la cámara alta del ángulo y la puerta de las Ovejas trabajaron los orfebres y los comerciantes."
,"33":"Cuando Sambalat se enteró de que estábamos reconstruyendo la muralla, ardió en cólera, y lleno de rabia se burlaba de los judíos,"
,"34":"diciendo en presencia de sus hermanos y de los magnates de Samaría: '¿Qué es lo que pretenden hacer esos miserables judíos? ¿Se les deberá dejar? ¿Llegarán a ofrecer sacrificios? ¿Acabarán algún día? ¿Harán revivir estas piedras calcinadas de entre los montones de escombros?'."
,"35":"Tobías, el amonita, que estaba junto a él, añadió: 'Construyan en buena hora; que si un chacal se lanza, derruirá su muralla de piedra'."
,"36":"¡Escucha, oh Dios nuestro, cómo somos despreciados! ¡Haz que su insulto recaiga sobre su cabeza! ¡Entrégales al desprecio en una tierra de esclavitud!"
,"37":"¡No pases por alto su iniquidad, ni su pecado sea borrado de tu presencia, pues han insultado a los constructores!"
,"38":"Construimos, pues, la muralla y la reparamos del todo hasta media altura, pues el pueblo se había entregado a la obra con gran empeño."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Cuando Sambalat, Tobías, los árabes, los amonitas y los de Asdod se enteraron de que la restauración de la muralla de Jerusalén adelantaba y que habían empezado a taparse las brechas, se enfurecieron enormemente"
,"2":"y se conjuraron todos ellos a una para atacar a Jerusalén y causarle todo el daño posible."
,"3":"Entonces nosotros recurrimos a nuestro Dios y montamos guardia contra ellos de día y de noche."
,"4":"Sin embargo, los judíos comenzaron a decir: '¡Empiezan a flaquear las fuerzas de los cargadores; son demasiados los escombros y no vamos a poder concluir la muralla!'."
,"5":"Por su parte, decían nuestros enemigos: 'Sin que se enteren ni se den cuenta, caeremos sobre ellos, los mataremos y así pondremos fin a la obra'."
,"6":"Pero los judíos que vivían entre ellos vinieron una y otra vez a prevenirnos por qué sitios vendrían los enemigos a atacarnos."
,"7":"Entonces yo emplacé al pueblo en las zonas más bajas, por detrás de la muralla, en los puntos descubiertos, dividiéndolos por familias, cada uno con sus espadas, sus lanzas y sus arcos."
,"8":"Lo inspeccioné todo, me puse en pie y dije a los nobles, a los prefectos y al resto del pueblo: '¡No les tengáis miedo. Pensad en el Señor, grande y terrible, y luchad por vuestros hermanos, vuestros hijos y vuestras hijas, vuestras mujeres y vuestras casas!'."
,"9":"Cuando nuestros enemigos se dieron cuenta de que estábamos advertidos y de que Dios había desbaratado sus planes, se retiraron, y nosotros volvimos a la muralla, cada cual a su tarea."
,"10":"Pero desde aquel día sólo la mitad de mis hombres trabajaban en la obra; la otra mitad empuñaba las lanzas, los escudos, las flechas y las lorigas, y los jefes estaban detrás de todos los judíos"
,"11":"que trabajaban en la muralla. También los cargadores estaban armados: con una mano trabajaban y con la otra empuñaban el arma."
,"12":"Cada uno de los constructores tenía ceñida a los lomos la espada mientras trabajaba. Y un corneta estaba siempre a mi lado."
,"13":"Pues yo había dicho a los nobles, a los prefectos y al resto del pueblo: 'La obra es grande y extensa, y estamos diseminados a lo largo de la muralla, lejos unos de otros."
,"14":"Donde oigáis el sonido del cuerno, corred allá para uniros a nosotros, y nuestro Dios luchará a nuestro lado'."
,"15":"De esta forma, mientras la mitad empuñaba las lanzas, trabajábamos desde el despuntar del alba hasta que aparecían las estrellas."
,"16":"Dije también al pueblo: 'Cada cual, con su criado, pase la noche en Jerusalén; de esta forma haremos guardia de noche y trabajaremos de día'."
,"17":"Y yo, mis hermanos, mis gentes y los hombres de guardia que me seguían ni siquiera nos desvestíamos; cada uno dormía con el arma en la mano."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Las gentes del pueblo y sus mujeres protestaron contra sus hermanos judíos."
,"2":"Unos decían: 'Tenemos que dar en prenda a nuestros hijos y nuestras hijas para obtener grano con que poder comer y vivir'."
,"3":"Otros: 'Tenemos que empeñar nuestros campos, nuestras viñas y nuestras casas para poder conseguir grano en esta penuria'."
,"4":"Y otros: 'Tenemos que hipotecar nuestros campos y nuestras viñas para pagar el tributo al rey."
,"5":"Nuestra carne es igual que la de nuestros hermanos; nuestros hijos son como los suyos; y, sin embargo, nos vemos obligados a someter nuestros hijos y nuestras hijas a la esclavitud. Algunas de nuestras hijas son ya esclavas, sin que podamos impedirlo, ya que nuestros campos y nuestras viñas pertenecen a otros'."
,"6":"Yo me indigné al oír sus quejas y razones"
,"7":"y, después de reflexionar, reprendí a los nobles y a los prefectos; les dije: '¡Qué carga imponéis a vuestros hermanos!'. Convoqué después contra ellos una gran asamblea,"
,"8":"y les dije: 'Nosotros hemos rescatado, según nuestras posibilidades, a nuestros hermanos judíos, que habían sido vendidos a los paganos. ¡Y ahora sois vosotros los que obligáis a vender a vuestros hermanos para que nosotros los rescatemos!'. Se quedaron mudos, sin saber qué responder."
,"9":"Y yo continué: 'No está bien lo que hacéis. ¿No sería mejor que caminarais en el temor de vuestro Dios, para no ser la burla de nuestros enemigos los paganos?"
,"10":"También yo, mis hermanos y mi gente les hemos dado en préstamo dinero y trigo. Pues bien, ¡perdonemos estas deudas!"
,"11":"Devolvedles ahora mismo sus campos, sus viñas, sus olivares y sus casas y perdonadles la deuda del dinero, del trigo, del vino y del aceite que les habíais prestado'."
,"12":"Respondieron: 'Se lo devolveremos y no reclamaremos nada; haremos lo que dices'. Entonces llamé a los sacerdotes y les hice jurar que actuarían según lo dicho. "
,"13":"Luego sacudí mi manto y dije: 'Así sacuda Dios la casa y la hacienda de aquel que no mantenga esta promesa; así sea sacudido y se quede sin nada'. Toda la asamblea respondió: '¡Así sea!'; y alabó al Señor. Y el pueblo cumplió lo que había prometido."
,"14":"Además, desde el día en que el rey me hizo gobernador del país de Judá, desde el año veinte hasta el treinta y dos del rey Artajerjes, es decir, durante doce años, ni yo ni mis hermanos comimos de la provisión debida al gobernador;"
,"15":"en cambio, los gobernadores que me habían precedido habían gravado al pueblo, percibiendo de él, en concepto de pan y vino, cuarenta monedas de plata cada día; y sus criados también oprimían al pueblo; pero yo no obré así, porque temía a Dios."
,"16":"Trabajé incluso en la reconstrucción de la muralla, a pesar de que no era propietario de campo alguno; y toda mi gente estaba también allí trabajando en las obras."
,"17":"A mi mesa se sentaban los judíos y los prefectos, ciento cincuenta hombres, aparte de los que venían de los pueblos limítrofes."
,"18":"Todos los días se consumía a expensas mías un toro, seis carneros selectos y aves; cada diez días se traía vino en abundancia. Sin embargo, no reclamé la provisión que me correspondía como gobernador, porque los trabajos gravaban ya bastante al pueblo."
,"19":"¡Acuérdate, oh Dios mío, para mi bien, de todo lo que he hecho por este pueblo!"
}`)
	CurrentBook.AddChapter(6, `{
"1":"Cuando Sambalat, Tobías, Guesen, el árabe, y los demás enemigos nuestros se enteraron de que yo había reconstruido la muralla y no quedaba brecha alguna en ella, aunque todavía no había colocado las hojas de las puertas,"
,"2":"Sambalat y Guesen me mandaron a decir: 'Ven a entrevistarte con nosotros en Quefirín, en la vega de Ono'. Como de lo que trataban era de hacerme mal,"
,"3":"les mandé a decir: 'Estoy ocupado en una obra importante y no me es posible ir; la obra se pararía si la dejo para ir a veros'."
,"4":"Sin embargo, volvieron a hacerme la misma invitación por cuatro veces; y yo les di siempre la misma respuesta."
,"5":"Entonces Sambalat me mandó a decir por quinta vez lo mismo por medio de un criado, que traía una carta abierta,"
,"6":"en la que se decía: 'Circula entre estas gentes -Gasmú lo afirma- el rumor de que tú y los judíos abrigáis el proyecto de sublevaros, y que para ello reconstruyes la muralla y tratas de hacerte su rey;"
,"7":"que incluso has designado profetas para que te proclamen rey de Judá en Jerusalén. Estos rumores llegarán sin duda a oídos del rey; ven para que tomemos juntos una decisión'."
,"8":"Pero yo le mandé a decir: 'No hay nada de lo que tú dices; son bulos inventados por ti'."
,"9":"Lo que intentaban era meternos miedo, pensando que dejaríamos el trabajo, y la obra no se llegaría a realizar. Pero, por el contrario, yo proseguí con más ánimo."
,"10":"Fui luego a casa de Semayas, hijo de Delayas, nieto de Mehetabel, que estaba impedido. Me dijo: 'Vamos al templo de Dios, al interior del santuario. Cerremos bien sus puertas, porque van a venir a matarte; sí, esta noche te vendrán a matar'."
,"11":"Pero yo respondí: '¿Un hombre como yo darse a la fuga? ¿Qué hombre de mi condición entraría en el santuario para salvar su vida? No, no entraré'."
,"12":"Comprendí claramente que no le había enviado Dios, sino que había pronunciado este oráculo sobre mí porque Tobías y Sambalat lo habían comprado,"
,"13":"con el fin de que yo, impulsado por el miedo, obrara así e incurriera en pecado, con lo que ellos encontrarían en esta mala nota un pretexto para desprestigiarme."
,"14":"¡Acuérdate, Dios mío, de Tobías y Sambalat por lo que han hecho, de la profetisa Noadías y de los demás profetas que trataron de asustarme!"
,"15":"La muralla fue terminada el día veinticinco del mes de elul, en cincuenta y dos días."
,"16":"Cuando nuestros enemigos lo supieron, se llenaron de miedo y se sintieron humillados al reconocer que esta obra había sido realizada con la ayuda de nuestro Dios."
,"17":"Por aquellos mismos días hubo mucha correspondencia epistolar entre los nobles de Judá y Tobías,"
,"18":"pues Tobías tenía muchos aliados en Judá por ser yerno de Secanías, hijo de Araj, y estar casado su hijo Yohojanán con la hija de Mesulán, hijo de Berequías."
,"19":"Lo alababan en mi presencia y le transmitían mis palabras. Y Tobías seguía mandando cartas para intimidarme."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Construida la muralla, y después de haber colocado las hojas de las puertas, quedaron encargados de la vigilancia los porteros, los cantores y los levitas."
,"2":"Puse al frente de Jerusalén a mi hermano Jananí y a Jananías, comandante de la ciudadela, porque era un hombre fiel y temeroso de Dios más que los otros,"
,"3":"y les di estas órdenes: 'No se abrirán las puertas de Jerusalén hasta que el sol comience ya a calentar; y antes que se ponga, se cerrarán bien echando las barras. Los habitantes de Jerusalén montarán guardia, unos en su puesto y otros delante de su propia casa'."
,"4":"La ciudad era espaciosa y grande, pero poco poblada, y no se construían casas."
,"5":"Mi Dios me inspiró la idea de reunir a los nobles, a los prefectos y al pueblo para hacer el censo. Tomé el libro del registro genealógico de los que habían vuelto la primera vez, y encontré escrito en él lo siguiente:"
,"6":"Éstos son los israelitas de la provincia de Judá que regresaron del destierro de Babilonia, donde los había deportado Nabucodonosor, rey de Babilonia, y que volvieron a Jerusalén y Judá, cada uno a su ciudad."
,"7":"Vinieron con Zorobabel, Josué, Nehemías, Azarías, Raamías, Najamaní, Mardoqueo, Bilsán, Mispéret, Bigvay, Najún y Baaná. Número de los hombres del pueblo de Israel: "
,"8":"descendientes de Parós: dos mil ciento setenta y dos;"
,"9":"de Sefatías: trescientos setenta y dos;"
,"10":"de Araj: seiscientos cincuenta y dos;"
,"11":"descendientes de Pajat Moab, es decir, de Josué y Joab: dos mil ochocientos dieciocho;"
,"12":"de Elán: mil doscientos cincuenta y cuatro;"
,"13":"de Zatú: ochocientos cuarenta y cinco;"
,"14":"de Zacay: setecientos setenta;"
,"15":"de Binuy: seiscientos cuarenta y ocho;"
,"16":"de Bebay: seiscientos veintiocho;"
,"17":"de Azgad: dos mil trescientos veintidós;"
,"18":"de Adonicán: seiscientos sesenta y siete;"
,"19":"de Bigvay: dos mil sesenta y siete;"
,"20":"de Adín: seiscientos cincuenta y cinco;"
,"21":"de Ater, es decir, de Ezequías: noventa y ocho;"
,"22":"de Jasún: trescientos veintiocho;"
,"23":"de Besay; trescientos veinticuatro;"
,"24":"de Jarif: ciento doce;"
,"25":"de Gabaón: noventa y cinco;"
,"26":"de Belén y Netofá: ciento ochenta y ocho;"
,"27":"de Anatot: ciento veintiocho;"
,"28":"de Bet Azmávet: cuarenta y dos;"
,"29":"de Quiriat Yearín, Quefirá y Beerot: setecientos cuarenta y tres;"
,"30":"de Ramá y Gueba: seiscientos veintiuno;"
,"31":"de Micmás: ciento veintidós;"
,"32":"de Betel y Ay: ciento veintitrés;"
,"33":"de Nebó: cincuenta y dos;"
,"34":"del otro Elán: mil doscientos cincuenta y cuatro;"
,"35":"de Jarín: trescientos veinte;"
,"36":"de Jericó: trescientos cuarenta y cinco;"
,"37":"de Lod, Jadid y Onó: setecientos veinticinco;"
,"38":"de Senaá, tres mil novecientos treinta."
,"39":"Sacerdotes: de Yedayas, de la casa de Josué: novecientos setenta y tres;"
,"40":"de Imer: mil cincuenta y dos;"
,"41":"de Pasjur: mil doscientos cuarenta y siete;"
,"42":"de Jarín: mil diecisiete."
,"43":"Levitas: de Josué y Cadmiel, de los hijos de Hodías: setenta y cuatro."
,"44":"Cantores: de Asaf: ciento cuarenta y ocho."
,"45":"Porteros: de Salún, de Ater, de Talmón, de Acub, de Jatitá, de Sobay: ciento treinta y ocho."
,"46":"Sirvientes del templo: de Sijá, de Jasufá, de Tabaot,"
,"47":"de Querós, de Siá, de Padón,"
,"48":"de Lebaná, de Jagabá, de Salmay,"
,"49":"de Janán, de Guidel, de Gajar,"
,"50":"de Reayas, de Resín, de Necodá,"
,"51":"de Gazán, de Uzá, de Paséaj,"
,"52":"de Besay, de los meunitas, de los nefusitas,"
,"53":"de Bacbuc, de Jacufá, de Jarjur,"
,"54":"de Baslit, de Mejidá, de Jarsá,"
,"55":"de Barcós, de Siserá, de Témaj,"
,"56":"de Nesíaj, de Jatifá."
,"57":"Descendientes de los sirvientes de Salomón: de Sotay, de Soféret, de Peridá,"
,"58":"de Yaalá, de Darcón, de Guidel,"
,"59":"de Sefatías, de Jatil, de Poquéret Hassebáyim, de Amón."
,"60":"Total de los sirvientes del templo y de los descendientes de los sirvientes de Salomón: trescientos noventa y dos."
,"61":"Los reseñados a continuación son los que regresaron de Tel-Mélaj, Tel-Jarsá, Querub, Addón e Imer, y no pudieron demostrar que su familia y su estirpe eran de origen israelita:"
,"62":"de Delayas, de Tobías, de Necodá: seiscientos cuarenta y dos."
,"63":"Y entre los sacerdotes: de Jobayas, de Hacós, de Barzilay, el cual se había casado con una de las hijas de Barzilay, el galaadita, cuyo nombre adoptó."
,"64":"Buscaron sus títulos genealógicos; pero al no encontrarlos, fueron excluidos del sacerdocio,"
,"65":"y el gobernador les prohibió comer alimentos sagrados hasta que se presentase un sacerdote para consultar las suertes."
,"66":"El total de la comunidad era de cuarenta y dos mil trescientas sesenta personas,"
,"67":"sin contar sus esclavos y esclavas, que eran siete mil trescientos treinta y siete, más doscientos cuarenta y cinco cantores y cantoras."
,"68":"Tenían, además, setecientos treinta y seis caballos, doscientos cuarenta y cinco camellos y seis mil setecientos veinte asnos."
,"69":"Algunos de los cabezas de familia hicieron donativos para la obra. El gobernador dio al tesoro mil dracmas de oro, cincuenta copas y treinta túnicas sacerdotales."
,"70":"Entre los cabezas de familia dieron al tesoro de la obra veinte mil dracmas de oro y dos mil doscientas minas de plata."
,"71":"El resto del pueblo entregó veinte mil dracmas de oro, dos mil minas de plata y siete túnicas sacerdotales."
,"72":"Los sacerdotes, los levitas y parte del pueblo se establecieron en Jerusalén; los porteros, los cantores, los sirvientes del templo y los demás israelitas, en sus ciudades respectivas."
}`)
	CurrentBook.AddChapter(8, `{
"1":"En el mes séptimo, cuando ya todos los israelitas estaban instalados en sus ciudades, el pueblo entero se congregó como un solo hombre en la plaza de la puerta del Agua y dijo al escriba Esdras que trajese el libro de la ley de Moisés, dada por el Señor a Israel."
,"2":"El día primero del séptimo mes, el sacerdote Esdras presentó la ley ante la comunidad, integrada por hombres y mujeres y cuantos tenían uso de razón."
,"3":"La estuvo leyendo en la plaza de la puerta del Agua desde por la mañana temprano hasta el mediodía ante los hombres, las mujeres y los que tenían uso de razón. Todo el pueblo estaba atento a la lectura del libro de la ley."
,"4":"Esdras, el escriba, estaba de pie sobre una tribuna de madera levantada al efecto; y junto a él estaban, a su derecha, Matitías, Semá, Ananías, Urías, Jelcías y Maasías; y a su izquierda, Pedayas, Misael, Malquías, Jasún, Jasbadana, Zacarías y Mesulán."
,"5":"Esdras abrió el libro a la vista de todo el pueblo -porque dominaba a toda la multitud- y, al abrirlo, el pueblo entero se puso de pie."
,"6":"Entonces Esdras bendijo al Señor, el gran Dios, y todo el pueblo, con las manos levantadas, respondió: 'Amén, amén', al tiempo que se inclinaban y adoraban al Señor, rostro en tierra."
,"7":"Los levitas Josué, Baní, Serebías, Jamín, Acub, Sabtay, Hodiyías, Maasías, Quelitá, Azarías, Yozabad, Janán y Pelayas explicaban la ley al pueblo mientras el pueblo permanecía en pie."
,"8":"Y Esdras leyó el libro de la ley de Dios, traduciendo y explicando el sentido. Así se pudo entender lo que se leía."
,"9":"Entonces Nehemías, el gobernador; Esdras, el sacerdote-escriba, y los levitas que instruían al pueblo dijeron a toda la asamblea: 'Este día está consagrado al Señor, vuestro Dios; no estéis tristes, no lloréis'. Porque todo el pueblo lloraba al escuchar las palabras de la ley."
,"10":"Nehemías les dijo: 'Id y comed buenos platos, bebed buenos vinos e invitad a los que no tienen nada preparado, pues este día está consagrado al Señor. ¡No os pongáis tristes; el gozo del Señor es vuestra fuerza!'."
,"11":"Y los levitas tranquilizaban a todo el pueblo, diciendo: '¡Calla, no os entristezcáis, porque este día es santo!'."
,"12":"Y el pueblo entero se fue a comer y beber, a invitar a los demás y a celebrar la fiesta, porque habían comprendido lo que les habían enseñado."
,"13":"El segundo día, los cabezas de familia de todo el pueblo, los sacerdotes y los levitas se reunieron con Esdras, el escriba, para seguir escuchando las palabras de la ley."
,"14":"Encontraron escrito en la ley que el Señor había prescrito por medio de Moisés: 'Los israelitas deberán vivir en cabañas durante la fiesta del séptimo mes'."
,"15":"Al saberlo, publicaron este bando por todas sus ciudades y en Jerusalén: 'Id al monte y traed ramos de olivo, de pino, de mirto, de palma y de otros árboles frondosos para hacer cabañas, como está prescrito'."
,"16":"El pueblo salió. Trajeron ramos y se hicieron cabañas cada uno en su propio terrado, en sus patios, en los atrios del templo de Dios, en la plaza de la puerta del Agua y en la plaza de la puerta de Efraín."
,"17":"Toda la comunidad de los repatriados hizo cabañas y se instaló en ellas. Desde los tiempos de Josué, hijo de Nun, no habían hecho una cosa así los israelitas hasta aquel día. Y la alegría fue inmensa."
,"18":"Esdras continuó leyendo en el libro de la ley de Dios cada día, desde el primero hasta el último. La fiesta duró una semana, y el día octavo se celebró, según lo prescrito, una reunión solemne."
}`)
	CurrentBook.AddChapter(9, `{
"1":"El día veinticuatro de aquel mismo mes, los israelitas, vestidos de saco y cubierta de tierra la cabeza, se congregaron para el ayuno."
,"2":"Los de la raza de Israel se separaron de todos los extranjeros y, puestos de pie, confesaron sus pecados y las iniquidades de sus padres."
,"3":"En pie, y cada uno en su sitio, leyeron en el libro de la ley del Señor, su Dios, durante tres horas; y durante otras tres horas confesaron sus pecados y adoraron al Señor, su Dios."
,"4":"Luego subieron a la tribuna de los levitas Josué, Baní, Cadmiel, Sebanías, Buní, Serebías, Baní y Quenaní, e invocaron en alta voz al Señor, su Dios."
,"5":"Y los levitas Josué, Cadmiel, Baní, Jasabnías, Serebías, Hodiyías, Sebanías y Petajías dijeron: 'Levantaos y bendecid al Señor, vuestro Dios, desde siempre y por siempre. ¡Bendito sea tu nombre sublime y excelso, superior a toda bendición y alabanza!"
,"6":"¡Tú solo, Señor, eres el único! Tú hiciste los cielos, el cielo de los cielos y todas sus estrellas, la tierra y todo cuanto encierra, los mares y todo lo que contienen; a todo ello tú le das la vida, y todos los astros del cielo te adoran."
,"7":"Tú eres, Señor, el Dios que elegiste a Abrán, le sacaste de Ur de los caldeos y le diste el nombre de Abrahán."
,"8":"Tú comprobaste que era un hombre fiel e hiciste con él un pacto, según el cual le darías a él y a su descendencia la tierra del cananeo, del hitita, del amorreo, del fereceo, del jebuseo, del guirgaseo; y has cumplido tu palabra, porque eres justo."
,"9":"Tú viste la aflicción de nuestros padres en Egipto y escuchaste su clamor junto al mar Rojo;"
,"10":"realizaste milagros y prodigios contra el Faraón, contra todos sus siervos y contra el pueblo entero de su país, porque sabías que los habían tratado con arrogancia, y te granjeaste un renombre que todavía hoy dura."
,"11":"Partiste en dos mitades el mar ante ellos y lo pasaron a pie enjuto, mientras a sus perseguidores los precipitaste en el abismo, como una piedra entre aguas impetuosas."
,"12":"Los guiaste de día mediante una columna de nube, de noche con una columna de fuego para alumbrarles el camino que tenían que seguir."
,"13":"Bajaste sobre el monte Sinaí, hablaste con ellos desde el cielo, les diste disposiciones justas, leyes verdaderas, preceptos y mandamientos buenos."
,"14":"Les diste a conocer tu santo sábado, les prescribiste mandamientos, preceptos y ley por medio de Moisés, tu siervo."
,"15":"Les diste pan del cielo para su hambre, y agua de la roca para su sed, y los mandaste que fueran a tomar posesión de la tierra que, mano en alto, habías jurado darles."
,"16":"Pero nuestros padres se obstinaron, endurecieron su cabeza, no obedecieron tus órdenes."
,"17":"No quisieron obedecer, olvidándose de las maravillas que tú habías realizado para ellos. Endurecieron su cabeza y se empeñaron, obstinados, en volver a Egipto, a su esclavitud. Pero tú eres un Dios pronto a perdonar, clemente y misericordioso, tardo a la ira y lleno de bondad; por eso no los abandonaste."
,"18":"Ni cuando se fabricaron un becerro de metal fundido y dijeron: ¡Éste es tu dios, que te ha sacado de Egipto!, cometiendo graves blasfemias."
,"19":"Ni siquiera entonces tú, en tu inmensa bondad, los abandonaste en el desierto: no se apartó de ellos la nube que durante el día los guiaba en su camino, ni la columna de fuego que por la noche alumbraba su ruta."
,"20":"Les diste tu espíritu bueno para instruirlos; no negaste el maná a su boca y les procuraste agua para calmar su sed."
,"21":"Cuarenta años los sustentaste en el desierto. No les faltó nada; sus vestidos no se gastaron ni se hincharon sus pies."
,"22":"Pusiste en sus manos reinos y pueblos, y se los repartiste según límites precisos; tomaron posesión del país de Sijón, rey de Jesbón, y del país de Og, rey de Basán."
,"23":"Multiplicaste sus hijos como las estrellas del cielo, y los llevaste a la tierra que habías prometido dar en propiedad a sus padres."
,"24":"Entraron los hijos y se apoderaron de la tierra; tú humillaste ante ellos a sus habitantes los cananeos, y los entregaste en sus manos, a ellos, a sus reyes y a los pueblos del país, para que los tratasen a su gusto."
,"25":"Ellos se apoderaron de ciudades fortificadas, de una tierra feraz, ocuparon casas llenas de toda clase de bienes, pozos, viñedos, olivares y árboles frutales en abundancia; y comieron, se saciaron, engordaron, se recrearon en la abundancia de tus bienes."
,"26":"Pero fueron insolentes, se rebelaron contra ti y echaron tu ley a sus espaldas; mataron a tus profetas, que les exhortaban a convertirse a ti, y te ofendieron gravemente."
,"27":"Entonces tú los entregaste en manos de sus enemigos, que los oprimieron. En el tiempo de su tribulación clamaron a ti, y tú les escuchaste desde el cielo, y en tu gran bondad les diste liberadores que los salvasen de las manos de sus enemigos."
,"28":"Pero en cuanto recobraron la paz, volvieron en seguida a obrar mal ante ti, y tú los abandonaste en manos de sus enemigos, que les sometieron a su yugo. Entonces volvían a suplicarte, y tú los escuchabas desde el cielo. ¡Cuántas veces los salvaste por tu gran bondad!"
,"29":"Les instabas a convertirse a tu ley; pero ellos, obstinados, no obedecieron a tus mandamientos y pecaron contra tus leyes, que dan la vida a quien las pone en práctica; se encogieron de hombros, endurecieron su cabeza y no quisieron obedecer."
,"30":"No obstante, tú los soportaste muchos años, los amonestaste con tu espíritu por medio de los profetas, pero no hicieron caso. Entonces los entregaste en manos de los pueblos del país."
,"31":"Pero en tu inmensa bondad no los aniquilaste ni los abandonaste, porque eres un Dios clemente y misericordioso."
,"32":"Y ahora, oh Dios nuestro, Dios grande, poderoso y terrible, que guardas la alianza y la misericordia, no tengas en poco todas las desgracias que han caído sobre nosotros, sobre nuestros reyes, nuestros jefes, nuestros sacerdotes, nuestros profetas, nuestros padres y todo tu pueblo, desde la época de los reyes de Asiria hasta el presente."
,"33":"Has sido justo en todo lo que nos ha sobrevenido, porque tú has demostrado tu lealtad, y nosotros, en cambio, nuestra maldad."
,"34":"Nuestros reyes, nuestros jefes, nuestros sacerdotes y nuestros padres no observaron tu ley ni obedecieron tus mandamientos y las normas que tú les habías dado."
,"35":"Cuando estaban en su reino, en medio de los abundantes bienes que tú les concedías en esta tierra ancha y feraz que tú habías puesto a su disposición, no te sirvieron ni se arrepintieron de su perversa conducta."
,"36":"Y ahora nosotros mismos somos esclavos; y en la tierra que tú diste a nuestros padres para que gozaran de sus frutos y sus bienes, en ella misma estamos sometidos a esclavitud."
,"37":"Sus frutos van a parar a los reyes que tú nos has impuesto por nuestros pecados y que disponen a su gusto de nosotros y de nuestro ganado. ¡Qué inmensa es nuestra angustia!"
}`)
	CurrentBook.AddChapter(10, `{
"1":"Por todo esto, aceptamos hoy un compromiso firme, escrito, sellado y firmado por nuestros jefes, levitas y sacerdotes."
,"2":"Firman el documento los siguientes: Sacerdotes: Nehemías, el gobernador, hijo de Jacalías, y Sedecías, "
,"3":"Serayas, Azarías, Jeremías,"
,"4":"Pasjur, Amarías, Malquías,"
,"5":"Jatús, Sebanías, Maluc,"
,"6":"Jarín, Meremot, Abdías,"
,"7":"Daniel, Guinetón, Baruc,"
,"8":"Mesulán, Abías, Miyamín,"
,"9":"Mazías, Bilgá, Semayas."
,"10":"Levitas: Josué, hijo de Azanías; Binuy, descendiente de Jenadad; Cadmiel"
,"11":"y sus hermanos Secanías, Odías, Quelitá, Pelayas, Janán,"
,"12":"Micá, Rejob, Jasabías,"
,"13":"Zacur, Serebías, Sebanías,"
,"14":"Hodiyías, Baní, Beninú."
,"15":"Jefes del pueblo: Parós, Pajat, Moab, Elán, Zatú, Baní,"
,"16":"Buní, Azgad, Bebay,"
,"17":"Adonías, Bigvay, Adín,"
,"18":"Ater, Ezequías, Azur,"
,"19":"Hodiyías, Jasún, Besay,"
,"20":"Jarif, Anatot, Nebay,"
,"21":"Magpías, Mesulán, Jezir,"
,"22":"Mesezabel, Sadoc, Yadúa,"
,"23":"Pelatías, Janán, Anayas,"
,"24":"Oseas, Jananías, Jasub,"
,"25":"Halojés, Piljá, Sobec,"
,"26":"Rejún, Jasabná, Mazías,"
,"27":"Ajías, Janán, Anán,"
,"28":"Maluc, Jarín, Baaná."
,"29":"El resto del pueblo, los sacerdotes, los levitas, los porteros, los cantores, los sirvientes del templo, en una palabra, todos los que se habían separado de las gentes del país para ajustarse a la ley de Dios, sus mujeres, sus hijos y sus hijas, todos los que tenían uso de razón,"
,"30":"se unieron a sus hermanos y a los jefes y se comprometieron, bajo juramento, a caminar en la ley de Dios, dada por medio de Moisés, siervo de Dios, y a observar y poner en práctica todos los mandamientos de nuestro Señor;"
,"31":"a no casar a nuestras hijas con extranjeros ni permitir que las extranjeras se casen con nuestros hijos;"
,"32":"a no comprar nada en sábado o en día festivo a las gentes del país cuando traigan a vender grano o cualquier clase de mercancía; a dejar la tierra sin cultivar y a perdonar todas las deudas en el año séptimo."
,"33":"Nos impusimos además las siguientes obligaciones: dar un tercio de siclo al año para el culto del templo de nuestro Dios,"
,"34":"para los panes de la proposición, para la ofrenda cotidiana, para el holocausto perpetuo, para los sacrificios de los sábados, de los novilunios, de las solemnidades, para los sacrificios de reconciliación, para los sacrificios por el pecado de Israel, en una palabra, para todo el servicio del templo de nuestro Dios;"
,"35":"los sacerdotes, los levitas y el pueblo regulamos también, por suertes, la aportación de la leña que cada familia, a su turno, debía suministrar cada año al templo de nuestro Dios para quemarla sobre el altar del Señor, nuestro Dios, como está escrito en la ley:"
,"36":"a traer cada año al templo del Señor las primicias de nuestras cosechas y de los frutos de todos los árboles,"
,"37":"así como los primogénitos de nuestros hijos y de nuestros ganados, como está prescrito en la ley; los primogénitos de nuestras reses vacunas y de nuestro ganado menor, para presentarlos en el templo de nuestro Dios a los sacerdotes encargados del culto del templo de nuestro Dios;"
,"38":"traer además a los sacerdotes, a las salas del templo de nuestro Dios, las primicias de nuestra harina, de los frutos de toda clase de árboles, del vino y del aceite; y dar la décima parte de nuestras cosechas a los levitas -los levitas mismos lo recogerán en todas las ciudades de nuestra labranza-."
,"39":"Un sacerdote, hijo de Aarón, acompañará a los levitas en la colecta, y los levitas llevarán la décima parte de la décima parte que hayan recogido al templo de nuestro Dios, a las salas del tesoro,"
,"40":"porque en estas salas es donde los israelitas y los levitas depositan las contribuciones del trigo, del vino y del aceite y donde se guarda el material del santuario, de los sacerdotes en servicio, de los porteros y de los cantores. En suma, no descuidaríamos más el templo de nuestro Dios."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Los jefes del pueblo se establecieron en Jerusalén. El resto del pueblo echó a suertes para que uno de cada diez viniese a habitar en Jerusalén, la ciudad santa, quedando los otros nueve en las ciudades."
,"2":"El pueblo bendijo a todos los que se ofrecían voluntarios para residir en Jerusalén."
,"3":"A continuación se reseñan los jefes de las provincias que se establecieron en Jerusalén y en las ciudades de Judá. Los israelitas, sacerdotes, levitas, sirvientes del templo y los descendientes de los siervos de Salomón habitaban en sus ciudades, cada uno en su propiedad."
,"4":"En Jerusalén se establecieron algunos de Judá y de Benjamín. De Judá: Atayas, hijo de Uzías, hijo de Zacarías, hijo de Amarías, hijo de Sefatías, hijo de Mahaleel, descendientes de Fares;"
,"5":"y Maasías, hijo de Baruc, hijo de Col José, hijo de Jazayas, hijo de Adayas, hijo de Yoyarib, hijo de Zacarías, hijo de Seloní."
,"6":"En total, los descendientes de Fares que se establecieron en Jerusalén eran cuatrocientos cincuenta y ocho hombres adultos."
,"7":"De Benjamín: Salú, hijo de Mesulán, hijo de Yoed, hijo de Pedayas, hijo de Colayas, hijo de Maasías, hijo de Itiel, hijo de Isaías"
,"8":"y sus hermanos: novecientos veintiocho hombres adultos."
,"9":"Joel, hijo de Zicrí, era el jefe de ellos, y Judá, hijo de Hasenúa, ocupaba el segundo puesto en la ciudad."
,"10":"Sacerdotes: Yedayas, hijo de Yoyarib; Joaquín,"
,"11":"Serayas, hijo de Helcías, hijo de Mesulán, hijo de Sadoc, hijo de Marayot, hijo de Ajitub, jefe del templo de Dios,"
,"12":"y sus hermanos, empleados en el servicio del templo: ochocientos veintidós; y Adayas, hijo de Yeroján, hijo de Pelalías, hijo de Amsí, hijo de Zacarías, hijo de Pasjur, hijo de Malquías,"
,"13":"y sus hermanos cabezas de familia: doscientos cuarenta y dos; y Amasay, hijo de Azarel, hijo de Ajzay, hijo de Mesilemot, hijo de Imer,"
,"14":"y sus hermanos: ciento veintiocho. Su jefe era Zabdiel, hijo de Hagadol."
,"15":"Levitas: Semayas, hijo de Jasub, hijo de Azricán, hijo de Jasabías, hijo de Buní;"
,"16":"Sabtay y Yozabab, jefes de los levitas, que estaban al frente de los asuntos exteriores del templo de Dios;"
,"17":"Matanías, hijo de Micá, hijo de Zabdí, hijo de Asaf, que dirigía el canto y entonaba la acción de gracias en la oración; Bacbuquías, el segundo entre sus hermanos, y Abdías, hijo de Samúa, hijo de Galal, hijo de Yedutún."
,"18":"En total, los levitas en la ciudad santa eran doscientos ochenta y cuatro."
,"19":"Los porteros: Acub, Talmón y sus hermanos, guardianes de las puertas: ciento sesenta y dos."
,"20":"El resto de Israel, de los sacerdotes y los levitas residían en todas las ciudades de Judá, cada uno en su propiedad."
,"21":"Los sirvientes del templo habitaban en el Ofel; y Sijá y Guispá eran sus jefes."
,"22":"El jefe de los levitas en Jerusalén era Uzí, hijo de Baní, hijo de Jasabías, hijo de Matanías, hijo de Micá, de los descendientes de Asaf, que eran cantores en el servicio del templo de Dios,"
,"23":"porque había una disposición del rey relativa a ellos, y un reglamento determinaba a los cantores su turno día a día."
,"24":"Petajías, hijo de Mesezabel, descendiente de Zéraj, hijo de Judá, era comisario del rey para todos los asuntos del pueblo."
,"25":"En las aldeas y diseminados por sus campos habitaban parte de los de Judá: en Quiriat Arbá y sus aldeas anejas, en Dibón y sus aldeas anejas, en Yacabsel y sus caseríos;"
,"26":"en Yesúa, en Moladá, en Bet Pélet,"
,"27":"en Jasar Sual, en Berseba y sus aldeas anejas;"
,"28":"en Sicelag, en Meconá y sus aldeas anejas;"
,"29":"en En Rimón, en orea, en Yarmut;"
,"30":"Zanóaj, Adulán y sus caseríos; Laquis y sus campos, Azecá y sus aldeas anejas; se establecieron, pues, desde Berseba hasta el valle de Hinnón."
,"31":"Los de Benjamín se establecieron en Guibeá, en Micmás, Ayá, Betel y sus aldeas anejas;"
,"32":"Anatot, Nob, Ananías,"
,"33":"Jasor, Ramá, Guitáyim,"
,"34":"Jadid, Seboín, Nebalat,"
,"35":"Lod y Onó y el valle de los Artesanos."
,"36":"De los levitas había grupos en Judá y Benjamín."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Sacerdotes y levitas que regresaron con Zorobabel, hijo de Sealtiel, y con Josué; Serayas, Jeremías, Esdras,"
,"2":"Amarías, Maluc, Jatús,"
,"3":"Secanías, Rejún, Merenot,"
,"4":"Idó, Guinetón, Abías,"
,"5":"Miyamín, Mazías, Bilgá,"
,"6":"Semayas, Yoyarib, Jedayas,"
,"7":"Salú, Amoc, Jelcías, Yedayas. Éstos eran los jefes de los sacerdotes y sus hermanos en tiempo de Josué."
,"8":"Levitas: Josué, Binuy, Cadmiel, Serebías, Judá, Matanías, el cual dirigía con sus hermanos el canto sagrado,"
,"9":"mientras Bacbuquías y Uní, hermanos suyos, lo alternaban con aquéllos, según sus clases respectivas."
,"10":"Josué engendró a Joaquín, Joaquín a Eliasib, Eliasib a Yoyadá,"
,"11":"Yoyadá a Yojanán y Yojanán a Yadúa."
,"12":"En tiempo de Joaquín, los cabezas de familias sacerdotales eran: de la de Serayas, Merayas; de la de Jeremías, Jananías;"
,"13":"de la de Esdras, Mesulán; de la de Amarías, Yehojanán;"
,"14":"de la de Maluk, Jonatán; de la de Secanías, José;"
,"15":"de la de Jarín, Adná; de la de Meremot, Jelcay;"
,"16":"de la de Idó, Zacarías; de la de Guinetón, Mesulán;"
,"17":"de la de Abías, Zicrí; de la de Miyamín, y de la de Mazías, Piltay;"
,"18":"de la de Bilgá, Samúa; de la de Semayas, Jonatán;"
,"19":"de la de Yoyarib, Matenay; de la de Yedayas, Uzí;"
,"20":"de la de Salú, Calay; de la de Amoc, Eber;"
,"21":"de la de Jelcías, Jasabías, de la de Yedayas, Natanael."
,"22":"En tiempos de Eliasib, Yoyadá, Yojanán y Yadúa, los cabezas de familias sacerdotales, fueron inscritos hasta el reino de Darío el Persa."
,"23":"Los levitas, cabezas de familia, fueron inscritos en el libro de las Crónicas; pero sólo hasta la época de Yojanán, nieto de Eliasib."
,"24":"Los jefes de los levitas eran Jasabías, Serebías, Josué, Binuy, Cadmiel; los otros levitas que formaban el segundo coro para alternar con aquéllos los himnos de alabanza y de acción de gracias, conforme a las normas de David, hombre de Dios, un coro frente a otro, eran:"
,"25":"Matanías, Bacbuquías y Abdías. Mesulán, Talmón y Acub eran porteros, que hacían guardia en las puertas de los almacenes."
,"26":"Éstos vivían en tiempo de Joaquín, hijo de Josué, hijo de Yosadac, y en tiempo de Nehemías, el gobernador, y de Esdras, el sacerdote-escriba."
,"27":"Para la inauguración de la muralla de Jerusalén se mandó a buscar a los levitas de todos los lugares donde habitaban para que viniesen a Jerusalén y se pudiese celebrar la inauguración con alegría, con himnos de acción de gracias y con cánticos, al son de címbalos, arpas y cítaras."
,"28":"Acudieron los cantores levitas de los alrededores de Jerusalén, de las aldeas de Netofat,"
,"29":"de Bet Guilgal, de las campiñas de Guibeá y de Azmávet, pues los cantores habían formado pueblos en los contornos de Jerusalén."
,"30":"Los sacerdotes y los levitas se purificaron los primeros, y después purificaron al pueblo, las puertas y la muralla."
,"31":"Luego yo hice subir a la muralla a los jefes de Judá y repartí en dos grandes coros a los encargados del canto."
,"32":"El primero marchaba por la muralla hacia la derecha, en dirección a la puerta del Muladar; detrás de él iban Osaías y la mitad de los jefes de Judá;"
,"33":"Azarías, Esdras, Mesulán,"
,"34":"Judá, Minyamín, Semayas, Jeremías;"
,"35":"y de los sacerdotes iban, provistos de trompetas, Zacarías, hijo de Jonatán, hijo de Semayas, hijo de Matanías, hijo de Miqueas, hijo de Zacur, hijo de Asaf,"
,"36":"y sus hermanos Semayas, Azarel, Milalay, Guilalay, Maay, Natanael, Judá, Jananí, con los instrumentos musicales prescritos por David, hombre de Dios. Esdras, el escriba, iba al frente de ellos."
,"37":"En la puerta de la Fuente subieron derecho, junto a la escalinata de la ciudad de David, por encima de la muralla, y por la subida del palacio de David hasta la puerta del Agua, a oriente."
,"38":"El segundo coro marchaba por la izquierda; yo los seguía con la otra mitad de los jefes del pueblo, por encima de la muralla, pasando por la torre de los Hornos hasta la muralla de la plaza,"
,"39":"luego por encima de la puerta de Efraín, la puerta de los Peces, la torre de Jananel hasta la puerta de las Ovejas; se hizo alto en la puerta de la Vigilancia."
,"40":"Los dos coros se pararon en el templo de Dios; y yo también, la mitad de los jefes que me acompañaba"
,"41":"y los sacerdotes Eliaquín, Maasías, Minyamín, Miqueas, Elyoenay, Zacarías, Jananías, con las trompetas,"
,"42":"Maasías, Semayas, Eleazar, Uzí, Yehojanán, Malaquías, Elán y Ezer. Los cantores entonaron sus himnos bajo la dirección de Yisrajías."
,"43":"Aquel día se ofrecieron muchos sacrificios entre la alegría general, pues Dios les había dado un motivo de gran alegría. También las mujeres y los niños se regocijaron, de modo que la alegría de Jerusalén se oía desde lejos."
,"44":"En aquel tiempo se nombraron intendentes de los almacenes destinados a guardar las provisiones, las ofrendas, las primicias y los diezmos, para que recogiesen de ellas, del territorio de las diversas ciudades, las porciones legales correspondientes a los sacerdotes y levitas, pues los de Judá estaban contentos con los sacerdotes y levitas en funciones."
,"45":"Ellos, los cantores y los porteros eran los que realizaban el servicio de Dios y el rito de la purificación, conforme a las prescripciones de David y de su hijo Salomón."
,"46":"Pues ya en los lejanos tiempos de David y de Asaf existían grupos de cantores y colecciones de cánticos de alabanza y de acción de gracias a Dios."
,"47":"En tiempo de Zorobabel y de Nehemías todo Israel daba a los cantores y a los porteros las porciones correspondientes a sus necesidades diarias; daba también a los levitas la parte que les correspondía, y los levitas pasaban su parte a los descendientes de Aarón."
}`)
	CurrentBook.AddChapter(13, `{
"1":"En aquel tiempo, leyendo el libro de Moisés en presencia del pueblo, se encontró escrito en él que los amonitas y los moabitas no debían entrar jamás a tomar parte en la comunidad de Dios,"
,"2":"por no haber salido a recibir a los israelitas con pan y agua y por haber alquilado a Balaán para que los maldijese, aunque nuestro Dios cambiara la maldición en bendición."
,"3":"Así que cuando oyeron la ley, excluyeron de Israel a todos los extranjeros."
,"4":"Anteriormente, el sacerdote Eliasib, que estaba encargado de los almacenes del templo de nuestro Dios y era pariente de Tobías,"
,"5":"había puesto a disposición de éste un local grande en el que antes se depositaban las ofrendas, el incienso, los utensilios, los diezmos del grano, del vino y del aceite, es decir, lo que les correspondía a los levitas, a los cantores y a los porteros y la porción debida a los sacerdotes."
,"6":"Cuando ocurría todo esto no estaba yo en Jerusalén, porque el año treinta y dos de Artajerjes, rey de Babilonia, regresé a la corte. Al cabo de algún tiempo pedí de nuevo un permiso al rey"
,"7":"y vine a Jerusalén; aquí me enteré del mal que había hecho Eliasib en favor de Tobías, proporcionándole un local en el atrio mismo del templo de Dios."
,"8":"Esto me desagradó tanto que eché fuera del local todos los muebles de la casa de Tobías;"
,"9":"luego mandé purificar el local e hice reintegrar allí los utensilios del templo de Dios, las ofrendas y el incienso."
,"10":"Me enteré también de que no se habían vuelto a entregar las porciones de los levitas, y que los levitas y los cantores encargados del servicio habían tenido que irse cada uno a su campo."
,"11":"Por eso reprendí a los dirigentes y les dije: '¿Por qué ha sido abandonado el templo de Dios?'. Después los reuní de nuevo y los restablecí en sus funciones;"
,"12":"y todo Judá trajo a los almacenes la décima parte del trigo, del vino y del aceite."
,"13":"Puse al cargo de los almacenes al sacerdote Selemías, al escriba Sadoc y al levita Pedayas y, como adjunto, a Janán, hijo de Zacur y nieto de Matanías, porque eran tenidos como personas de confianza. Su misión era hacer las reparticiones entre sus hermanos."
,"14":"¡Acuérdate de mí por esto, oh Dios mío, y no olvides las obras buenas que hice por el templo de mi Dios y por su servicio!"
,"15":"Por entonces advertí que había en Judá quienes en día de sábado pisaban los lagares, acarreaban los haces, los cargaban sobre los asnos, así como vino, uva, higos y toda clase de cargas, para traerlos a Jerusalén en día de sábado, y los amonesté para que no vendiesen sus productos en tal día."
,"16":"Igualmente, algunos tirios que habitaban en la ciudad traían pescado y toda clase de mercancías, y las vendían en día de sábado a los judíos, y esto en la misma Jerusalén."
,"17":"Yo reprendí a los jefes de Judá, diciéndoles: '¡Qué acción tan detestable cometéis profanando el día del sábado!"
,"18":"¿No fue esto lo que hicieron vuestros padres y por lo que nuestro Dios hizo caer sobre nosotros y sobre esta ciudad toda esta calamidad? ¡Y vosotros aumentáis el ardor de su ira contra Israel profanando el sábado!'."
,"19":"Por eso ordené que, en cuanto la sombra cubriese las puertas de Jerusalén, la víspera del sábado, se cerrasen las puertas, y que no se abrieran hasta después del sábado; y emplacé junto a las puertas algunos de mis hombres para que no entrase carga alguna en día de sábado."
,"20":"Sin embargo, todavía una o dos veces pasaron la noche fuera de Jerusalén los mercaderes y vendedores de toda clase de mercancías."
,"21":"Y yo los amonesté diciéndoles: '¿Por qué pernoctáis delante de la muralla? Si el hecho se repite, os echaré mano'. Desde entonces no volvieron más en día de sábado."
,"22":"Ordené también a los levitas que se purificasen y viniesen a guardar las puertas, para que se santificara el sábado. ¡También por esto, acuérdate de mí, oh Dios mío, y ten piedad de mí conforme a tu gran misericordia!"
,"23":"Vi también en aquellos días a judíos que se habían casado con mujeres asdoditas, amonitas y moabitas."
,"24":"La mitad de sus hijos hablaban asdodeo o la lengua de otros pueblos y no sabían hablar judío."
,"25":"Yo los reprendí, los maldije, hice azotar a algunos de ellos, les arranqué los cabellos y les hice jurar en el nombre de Dios: 'No caséis a vuestras hijas con extranjeros, y vosotros y vuestros hijos no os caséis con extranjeras."
,"26":"¿No fue éste el pecado de Salomón, rey de Israel? Y eso que entre tantas naciones no había un rey semejante a él: era amado de su Dios, y Dios le había constituido rey de todo Israel; sin embargo, también a él lo arrastraron al pecado las mujeres extranjeras."
,"27":"¿Habrá que oír también que vosotros cometéis esta gran iniquidad de traicionar a nuestro Dios casándoos con mujeres extranjeras?'."
,"28":"Hasta a uno de los hijos de Yoyadá, hijo del sumo sacerdote Eliasib, yerno de Sambalat, el joronita, lo alejé de mi lado."
,"29":"¡Acuérdate, oh Dios mío, de esta gente, que ha profanado el sacerdocio y el pacto de los sacerdotes y los levitas!"
,"30":"Así los purifiqué de todo elemento extranjero y restablecí los servicios de los sacerdotes y los levitas, regulando la función de cada uno,"
,"31":"la ofrenda de la leña en sus plazos señalados y la de las primicias. ¡Acuérdate de mí, oh Dios mío, para mi bien!"
}`)

}
func ES_LSB_LoadVHRTChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"En los días en que gobernaban los jueces hubo una gran carestía en Palestina, y un hombre de Belén de Judá emigró al país de Moab con su mujer y sus dos hijos."
,"2":"Él se llamaba Elimélec, su esposa Noemí y sus dos hijos Majlón y Kilión, todos efrateos de Belén de Judá. Llegaron a Moab y se establecieron allí."
,"3":"Murió Elimélec, marido de Noemí, y quedó ella sola con sus dos hijos,"
,"4":"que se casaron con dos moabitas: una se llamaba Orfá y la otra Rut."
,"5":"A los diez años murieron también Majlón y Kilión, y Noemí se quedó sin hijos y sin marido."
,"6":"Noemí salió de Moab con sus dos nueras para volver a su patria, pues había oído que el Señor se preocupaba de su pueblo, dándole pan."
,"7":"Salió con sus dos nueras del lugar de su emigración y, de camino hacia la tierra de Judá,"
,"8":"les dijo: 'Ea, volveos a la casa de vuestra madre; que el Señor tenga con vosotras la misma fidelidad que habéis tenido con nuestros difuntos y conmigo."
,"9":"El Señor os conceda la paz en la casa de un nuevo marido'."
,"10":"Y las besó. Entonces ellas se echaron a llorar y le dijeron: 'No, iremos contigo a tu pueblo'."
,"11":"Noemí insistía: 'Volveos, hijas mías; ¿por qué queréis venir conmigo? Yo ya no podré tener más hijos que puedan ser vuestros maridos."
,"12":"Volveos, hijas mías, marchaos. Soy demasiado vieja para volverme a casar. Y aunque pudiese decir: tengo todavía esperanza, concebiré esta noche y tendré hijos,"
,"13":"¿podríais vosotras esperar a que fuesen mayores? ¿Ibais por eso a dejar de casaros de nuevo? No, hijas mías; me llenaría de pena por vosotras; la mano del Señor pesa sobre mí'."
,"14":"Ellas se echaron nuevamente a llorar. Después Orfá besó a su suegra y volvió a su pueblo, pero Rut se echó en brazos de Noemí."
,"15":"Noemí le dijo: 'Mira, tu cuñada vuelve a su pueblo y a su dios; vete tú también con ella'."
,"16":"Rut le respondió: 'No insistas más en que te deje, alejándome de ti; donde tú vayas, iré yo; donde tú vivas, viviré yo; tu pueblo será mi pueblo, y tu Dios será mi Dios;"
,"17":"donde tú mueras, yo moriré, y allí quiero ser enterrada. Que Dios me castigue si algo, fuera de la muerte, me separa de ti'."
,"18":"Noemí, viendo a Rut tan resuelta a seguirla, ya no insistió."
,"19":"Partieron juntas y llegaron a Belén. A su llegada se impresionó toda la ciudad. Las mujeres comentaban: '¿Pero es ésta Noemí?"
,"20":"Ella decía: 'No me llaméis Noemí; llamadme Mara, porque el todopoderoso me ha llenado de amargura."
,"21":"Salí llena, y el Señor me devuelve vacía. ¿Por qué llamarme todavía Noemí, si el Señor me ha humillado tanto y el Todopoderoso me ha hecho desgraciada?'."
,"22":"Así fue como Noemí, con su nuera Rut, la moabita, volvió de Moab a Belén al comienzo de la siega de la cebada."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Noemí tenía, por parte de su marido, un pariente muy rico llamado Booz, de la familia de Elimélec."
,"2":"Un día Rut, la moabita, dijo a su suegra: 'Déjame ir a espigar al campo del que me lo permita'. Ella le respondió: 'Anda, hija mía'."
,"3":"Rut salió para espigar en un campo detrás de los segadores, y quiso la providencia que fuese a dar a una parcela de Booz, de la familia de Elimélec."
,"4":"Booz de Belén llegó y saludó a los segadores: 'El Señor esté con vosotros'. Ellos le respondieron: 'El Señor te bendiga'."
,"5":"Booz preguntó luego al capataz: '¿De quién es esa joven?'."
,"6":"Él respondió: 'Es la moabita que ha venido con Noemí del país de Moab."
,"7":"Me ha pedido que la deje espigar detrás de los segadores, y desde que entró en el campo ha estado, desde esta mañana hasta ahora, sin descansar ni siquiera un instante'."
,"8":"Booz dijo a Rut: 'Escucha, hija mía; no vayas a espigar a otro campo y no te alejes de aquí. Sigue los pasos de mis criados."
,"9":"Fíjate en el campo donde siegan y ve detrás de ellos. Voy a dar órdenes a mis criados para que no te molesten. Y cuando tengas sed, te vas al hato y bebes de lo que beban ellos'."
,"10":"Rut se postró en tierra y dijo: '¿Por qué tienes esta consideración conmigo y te interesas por mí siendo yo extranjera?'."
,"11":"Booz le respondió: 'Me han contado lo que has hecho por tu suegra después de la muerte de tu marido: que has dejado a tu padre, a tu madre, a tu patria, para venir a un pueblo desconocido para ti."
,"12":"Que el Señor pague tu acción y que tu recompensa sea grande ante el Señor, Dios de Israel, bajo cuyas alas has venido a refugiarte'."
,"13":"Rut dijo: 'Has sido muy amable conmigo, señor; me has consolado y me has hablado al corazón, aunque yo no soy ni siquiera como una de tus criadas'."
,"14":"A la hora de comer, Booz le dijo: 'Ven aquí, come de nuestra comida y moja tu pan en la vinagreta'. Ella se sentó junto a los segadores, y Booz le ofreció trigo tostado. Después de comer y quedar satisfecha, recogió lo sobrante y lo guardó,"
,"15":"y de nuevo se puso a espigar. Booz ordenó a sus criados: 'Dejadla que espigue también entre las gavillas, y no la molestéis."
,"16":"Dejad caer espigas de vuestros manojos para que las recoja, sin inquietarla'."
,"17":"Estuvo espigando hasta la tarde, luego apaleó lo recogido, y había como unos cuarenta y cinco kilos de cebada."
,"18":"Lo cargó, fue a la ciudad y se lo enseñó a su suegra; sacó lo sobrante de la comida y se lo dio."
,"19":"Noemí dijo: '¿Dónde has estado espigando? ¡Bendito el que te ha favorecido tanto!'. Rut le dijo: 'He estado trabajando en el campo de un hombre que se llama Booz'."
,"20":"Noemí exclamó: 'Que el Señor te bendiga; el Señor que es ahora bueno con nosotros, como antes lo fue con los muertos. Ese hombre es pariente nuestro, uno de los que tienen derecho de levirato sobre nosotras'."
,"21":"Rut añadió: 'Me ha dicho además: Sigue a mis segadores hasta que se termine la siega'."
,"22":"Noemí respondió a su nuera: 'Es mejor, hija mía, que vayas con sus segadores, no sea que te molesten en otro campo'."
,"23":"Y Rut siguió a los segadores de Booz, espigando hasta la terminación de la siega de la cebada y del trigo y viviendo con su suegra."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Después le dijo su suegra Noemí: 'Hija mía, yo debo buscar tu felicidad."
,"2":"Booz, con cuyos segadores has estado, es nuestro pariente. Mira, esta tarde él limpiará en su era."
,"3":"Lávate, perfúmate, vístete con los mejores vestidos y vete a la era, pero sin dejarte ver hasta que haya terminado de comer y beber."
,"4":"Cuando se haya acostado, fíjate bien dónde duerme; ve después, le descubres los pies y te acuestas; él te indicará lo que debes hacer'."
,"5":"Rut respondió: 'Haré lo que me dices'."
,"6":"Rut fue a la era e hizo exactamente lo que le había dicho su suegra."
,"7":"Booz comió, bebió y se acostó muy feliz al lado del muelo de la cebada. Llegó entonces ella muy despacio, destapó sus pies y se acostó."
,"8":"Ya de madrugada, Booz se sobresaltó e, incorporándose, vio una mujer acostada a sus pies."
,"9":"'¿Quién eres tú?', preguntó. Ella respondió: 'Soy Rut, tu sierva; extiende tu manto sobre mí, porque tienes el derecho de levirato'."
,"10":"Él replicó: 'Hija mía; este segundo acto de piedad es todavía mejor que el primero, pues no has buscado ningún joven, rico o pobre."
,"11":"No tengas miedo, hija mía; haré con gusto lo que pides, pues todo el pueblo sabe que eres mujer virtuosa."
,"12":"Sí, es cierto que soy tu pariente, pero hay otro pariente más próximo que yo."
,"13":"Pasa ahí la noche, y mañana, si él quiere hacer uso de su derecho, que lo haga; y si no quiere, vive Dios que yo lo haré. Duérmete hasta mañana'."
,"14":"Ella durmió a sus pies hasta la mañana, levantándose antes de que pudiesen distinguirse las personas. Booz le había dicho: 'Que no se sepa que una mujer ha venido a la era'."
,"15":"Después añadió: 'Quítate el manto que te cubre y sosténlo'. Ella lo sostuvo, y le echó seis medidas de cebada; se las echó a cuestas, y entró en la ciudad."
,"16":"Cuando llegó a casa de su suegra, ésta le preguntó: '¿Qué ha pasado, hija mía?'. Rut le contó lo que Booz había hecho por ella,"
,"17":"y añadió: 'Mira, me dio estas seis medidas de cebada y me dijo: No quiero que vuelvas a casa de tu suegra con las manos vacías'."
,"18":"Noemí le dijo: 'Estáte tranquila, hija mía, hasta que sepas en qué para la cosa, pues este hombre no descansará hasta haber resuelto el asunto'."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Booz subió a la puerta de la ciudad y se sentó. Cuando pasó el citado pariente le dijo: 'Oye, ven acá y siéntate'. Se acercó y se sentó."
,"2":"Booz llamó a diez ancianos de la ciudad y les dijo: 'Sentaos'. Y se sentaron."
,"3":"Booz dijo al pariente: 'Noemí ha vuelto del país de Moab y ha puesto en venta el campo de nuestro hermano Elimélec."
,"4":"He determinado informarte para decirte: Cómpralo en presencia de los ancianos de la ciudad. Si quieres comprarlo, cómpralo; si no, dímelo, porque antes de ti no hay ninguno que pueda comprarlo, y yo soy el segundo'. Él respondió: 'Lo compraré'."
,"5":"Booz añadió: 'Pero si compras el campo a Noemí, deberás casarte con Rut, la moabita, mujer del difunto, para perpetuar el nombre de Elimélec en su heredad'."
,"6":"El pariente contestó: 'No puedo comprarlo por no perjudicar a mis herederos; usa tú de mi derecho de levirato, pues yo no puedo'."
,"7":"Había entonces en Israel, para ratificar las compras o cambios, el siguiente rito: uno se quitaba su zapato y lo entregaba al otro. Tal era el modo de hacer fe en Israel."
,"8":"El pariente dijo a Booz: 'Cómpralo tú para ti'; y quitándose el zapato se lo entregó."
,"9":"Entonces Booz dijo a los ancianos y a todo el pueblo: 'Vosotros sois testigos de que yo compro a Noemí lo que es de Elimélec, de Kilión y de Majlón;"
,"10":"tomo además por mujer a Rut, la moabita, mujer que fue de Majlón, para perpetuar el nombre del difunto sobre su heredad y para que no se borre su nombre de entre sus hermanos y de la puerta de la ciudad. Vosotros sois hoy testigos de ello'."
,"11":"Todo el pueblo, que se encontraba a la puerta con los ancianos, dijo: 'Somos testigos. Que el Señor haga a la mujer que va a entrar en tu casa semejante a Raquel y a Lía, quienes edificaron la casa de Israel. Que seas poderoso en Éfrata y adquieras renombre en Belén."
,"12":"Que sea tu casa como la de Fares, el que Tamar dio a Judá, por la posteridad que el Señor te dé de esta joven'."
,"13":"Booz se casó con Rut, se unió a ella, y el Señor hizo que concibiese y tuviera un hijo."
,"14":"Las mujeres decían a Noemí: 'Bendito sea el Señor, que ha querido que no te faltase un heredero y que el nombre del difunto se conserve en Israel."
,"15":"El niño será para ti consuelo y amparo en tu vejez, pues te lo ha dado tu nuera que tanto te ama y es para ti mejor que siete hijos'."
,"16":"Noemí tomó al niño, lo puso en su regazo y fue su nodriza."
,"17":"Las vecinas decían: 'A Noemí le ha nacido un hijo'. Y lo llamaron Obed, que fue el padre de Jesé, padre de David."
,"18":"Ésta es la descendencia de Fares: Fares engendró a Jesrón,"
,"19":"Jesrón a Ram, Ram a Aminadab,"
,"20":"Aminadab a Nasón, Nasón a Salmón,"
,"21":"Salmón a Booz, Booz a Obed,"
,"22":"Obed a Jesé y Jesé a David."
}`)

}
func ES_LSB_LoadVHTBChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Historia de Tobit, hijo de Tobiel, hijo de Ananiel, hijo de Aduel, hijo de Gabael, descendientes de Asiel, de la tribu de Neftalí,"
,"2":"que en tiempos de Salmanasar, rey de Asiria, fue llevado cautivo desde Tisbe, que está a la derecha de Cades de Neftalí, en la alta Galilea, por encima de Jasor, hacia occidente al norte de Safed."
,"3":"Yo, Tobit, he seguido los caminos de la verdad y de la justicia todos los días de mi vida, dando muchas limosnas a mis hermanos de raza que fueron deportados conmigo a Nínive, en Asiria."
,"4":"Cuando yo era joven y me encontraba en la tierra de Israel, toda la tribu de nuestro padre Neftalí se había separado de la dinastía de David y de Jerusalén, ciudad elegida entre todas las tribus de Israel para ofrecer sacrificios, pues allí se había construido y consagrado para siempre el templo, morada de Dios."
,"5":"Todas las tribus que habían apostatado, incluida la de nuestro padre Neftalí, ofrecían sacrificios al becerro de oro que había levantado Jeroboán, rey de Israel, en Dan, sobre todos los montes de Galilea."
,"6":"Sin embargo, yo, la mayoría de las veces solo, iba a Jerusalén para participar en las fiestas, como está mandado a todo Israel con mandamiento eterno, llevando las primicias, la décima parte de las cosechas y las primicias del esquileo de las ovejas,"
,"7":"y se lo entregaba a los sacerdotes, descendientes de Aarón, para el altar. A los levitas, que prestan sus servicios en Jerusalén, les entregaba la décima parte del trigo, del vino y del aceite, de las granadas, de los higos y de los otros frutos de los árboles. Otra décima parte la hacía dinero y lo distribuía cada año en Jerusalén."
,"8":"Y otra décima parte la repartía entre los huérfanos y las viudas y los prosélitos extranjeros que convivían con los israelitas. Se lo entregaba cada tres años, y lo comíamos conforme a lo mandado en la ley de Moisés y las exhortaciones de Débora, madre de Ananiel, nuestro abuelo, pues mi padre había muerto, dejándome huérfano."
,"9":"Cuando fui mayor, me casé con una mujer de nuestra familia, llamada Ana, de la que tuve un hijo llamado Tobías."
,"10":"Cautivo de los asirios, llegué a Nínive. Mis hermanos y compatriotas comían el alimento de los paganos;"
,"11":"pero yo no lo comía,"
,"12":"pues me acordaba de mi Dios con todo mi corazón."
,"13":"El altísimo me granjeó la simpatía y el favor de Salmanasar, y me convertí en su proveedor general."
,"14":"Por eso fui a Media y allí estuve haciendo compras para él hasta que murió. Yo había dejado en depósito a Gabael, hijo de Gabri, que vivía en Ragués de Media, trescientos kilos de plata."
,"15":"Pero a la muerte de Salmanasar, a quien sucedió su hijo Senaquerib, se cerraron las comunicaciones, y yo no pude volver a Media."
,"16":"En vida de Salmanasar, yo había dado muchas limosnas a mis hermanos de raza."
,"17":"Daba pan a los hambrientos y vestidos a los desnudos; yo enterraba los cadáveres de mis compatriotas que veía tras las murallas de Nínive."
,"18":"Di sepultura también a los que mató Senaquerib a su vuelta de Judea, después de la derrota propinada por el rey del cielo a aquel blasfemo. Rabioso, mató a muchos israelitas; y yo escondía sus cadáveres, y luego los enterraba. Senaquerib los buscó, pero no pudo encontrarlos."
,"19":"Un ninivita dijo al rey que era yo quien los había enterrado a escondidas. Cuando supe que el rey estaba enterado de todo y que me buscaba para matarme, tuve miedo y huí."
,"20":"Todos mis bienes fueron confiscados, pasando al tesoro real. No me quedó nada más que Ana, mi mujer, y Tobías."
,"21":"No habían pasado cuarenta días, cuando el rey fue asesinado por sus dos hijos, quienes huyeron a las montañas de Ararat, sucediéndole en el reino Asaradón. Ajicar, hijo de mi hermano Anael, fue encargado de toda la contabilidad del reino, con autoridad también sobre la administración general."
,"22":"Entonces Ajicar intercedió por mí y pude volver a Nínive. Ajicar había sido el jefe de los coperos, custodio del sello real, administrador y contador con Senaquerib, rey de los asirios, y Asaradón le confirmó en sus cargos. Era mi sobrino."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Bajo el reinado de Asaradón volví a mi casa, y me devolvieron a mi mujer Ana y a mi hijo Tobías. En nuestra fiesta de pentecostés, que es la fiesta santa de las siete semanas, me prepararon un buen banquete, y yo me puse a comer."
,"2":"Como la mesa estaba preparada para mí con alimentos abundantes, dije a mi hijo Tobías: 'Hijo mío, ve en busca de un pobre de entre nuestros compatriotas cautivos en Nínive que de veras se acuerde del Señor, y tráelo a comer conmigo. Espero hasta que vuelvas'."
,"3":"Tobías salió en busca de un pobre de entre nuestros connacionales, volvió y me dijo: 'Padre'. Yo le respondí: '¿Qué, hijo mío?'. Replicó: 'Padre, uno de nuestro pueblo ha sido estrangulado y tirado en la plaza'."
,"4":"Me levanté, dejando mi comida, lo saqué de la plaza y lo llevé a una pequeña casa hasta la puesta del sol, en que pudiera enterrarlo."
,"5":"Después me lavé y, lleno de tristeza, me puse a comer."
,"6":"Me acordé de las palabras del profeta Amós, hablando de Betel: 'Vuestras fiestas se cambiarán en luto, y vuestros cantos de gozo en lamentaciones'. Y lloré."
,"7":"Cuando se puso el sol, fui, cavé una fosa y lo enterré."
,"8":"Mis vecinos se reían de mí, diciendo: 'No tiene miedo. Por eso mismo lo buscaron para matarlo y tuvo que huir; y, ahora, otra vez entierra a los muertos...'."
,"9":"Aquella noche, después de lavarme, me eché a dormir junto a la pared del patio, con la cara al aire porque hacía mucho calor."
,"10":"No me di cuenta de que en la pared había golondrinas y, estando con los ojos abiertos, las golondrinas dejaron caer sobre mis ojos sus excrementos calientes, causándome unas manchas blancas. Acudí a los médicos buscando curación; pero cuantos más ungüentos me aplicaban, menos veía, hasta que me quedé completamente ciego. Durante cuatro años no pude ver. Mis hermanos estaban afligidos. Ajicar se preocupó de mi alimento durante dos años, hasta que se marchó a Elimaida."
,"11":"En este tiempo, Ana, mi mujer, se dedicaba a trabajos femeninos,"
,"12":"los llevaba a sus clientes y ellos le pagaban. El siete del mes distro terminó un trozo de tela y lo llevó a los clientes. Ellos le pagaron, y además le regalaron un cabrito."
,"13":"Cuando volvió a casa, el cabrito comenzó a balar. Yo la llamé y le dije: '¿De dónde proviene este cabrito? ¿No habrá sido robado? Devuélvelo a sus propietarios, pues no tenemos derecho a comer nada robado'."
,"14":"Ella me respondió: 'Es un regalo que me han hecho además del precio fijado'. Pero yo no la creí y le ordené que lo devolviera a los propietarios; me avergonzaba por ella. Entonces ella me respondió: '¿Dónde están tus limosnas? ¿Dónde tus buenas obras? Lo saben los que se han aprovechado'."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Entonces profundamente afligido, gemía y lloraba y entre suspiros comencé a rezar:"
,"2":"'¡Justo eres, Señor, y justas son tus obras; la misericordia y la verdad,son tus caminos, y tú eres el juez del mundo!"
,"3":"Y ahora, Señor, acuérdate de mí, mírame y no castigues mis pecados, mi ignorancia y la de mis padres, que pecaron contra ti."
,"4":"Hemos desobedecido tus mandatos, y tú nos has abandonado al pillaje, a la esclavitud, a la muerte, y nos has hecho la fábula, la risa,y el oprobio en las naciones paganas,en que nos has dispersado."
,"5":"Todos tus juicios son justos,cuando decides contra mí por mis pecados,y por los de mis padres, porque no hemos cumplido tus mandatos,ni hemos caminado lealmente,en tu presencia."
,"6":"Haz conmigo lo que quieras; quítame la vida, para que desaparezca,de la faz de la tierra,y me convierta en polvo; porque prefiero la muerte a la vida; pues los insultos mentirosos,que he escuchado me han causado,una profunda pena. Líbrame, Señor, de esta angustia, y llegue yo a la eterna morada. No apartes, Señor, tu faz de mí, pues la muerte es preferible,a ver tanta miseria en mi vida,y a escuchar tantas injurias'."
,"7":"Aquel mismo día, Sara, hija de Ragüel, el de Ecbatana de Media, fue injuriada por una de las criadas de su padre,"
,"8":"porque había tenido siete maridos, y el perverso demonio Asmodeo los había matado antes de que consumaran el matrimonio. 'Tú eres -le decía la criada- la que matas a tus maridos. Te han dado a siete, y de ninguno has gozado."
,"9":"¿Por qué entonces nos castigas, si han muerto? Vete con ellos, y que jamás veamos hijo o hija tuya'."
,"10":"Ella se entristeció profundamente y, llorando, subió a la habitación de su padre dispuesta a ahorcarse. Pero lo pensó mejor y dijo: 'Se reirían de mi padre y le dirían: La única hija que tenías, tan querida para ti, se ha ahorcado por sus desventuras. Sería yo la causa de que las canas de mi padre descendiesen con dolor a la región de los muertos. Mejor será no ahorcarme, sino pedir al Señor la muerte para que nadie vuelva a ultrajarme'."
,"11":"Entonces mismo, extendiendo las manos hacia la ventana, se puso a rezar así: 'Bendito seas, Señor, Dios misericordioso, y por siempre sea bendito tu nombre; que por siempre tus obras te bendigan."
,"12":"Hacia ti vuelvo mi rostro y mis ojos."
,"13":"Sácame de este mundo,para que no escuche más insultos."
,"14":"Tú conoces, Señor, que soy pura,de todo contacto de hombre,"
,"15":"y que jamás deshonré mi nombre,ni el de mi padre en este país de destierro. Soy hija única y heredera de mi padre; no tiene él ni pariente próximo,ni compatriota a quien darme por esposa. Siete maridos he perdido; ¿para qué quiero la vida?,Pero si no quieres quitármela, mírame,y ten piedad de mí, para que no escuche,jamás tales ultrajes'."
,"16":"En aquel momento Dios oyó la oración de los dos"
,"17":"y envió a Rafael para curarlos; a Tobit, de las manchas blancas de sus ojos, para que volviese a ver la luz del cielo, y a Sara, hija de Ragüel, para darla por esposa a Tobías, hijo de Tobit, librándola del maligno demonio Asmodeo, pues correspondía a Tobías casarse con ella con preferencia a todos los demás pretendientes. Al mismo tiempo que Tobit volvía del patio de su casa, Sara, hija de Ragüel, bajaba del piso superior."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Entonces Tobit se acordó del dinero que había entregado en depósito a Gabael de Ragués, en Media."
,"2":"Y pensaba: 'Acabo de pedir la muerte; ¿por qué no llamar a mi hijo Tobías y enterarle de lo del dinero antes de morir?'."
,"3":"Llamó a su hijo Tobías y le dijo: 'Cuando muera, dame una sepultura digna. Honra a tu madre y no la abandones nunca. Haz lo que le agrade y nunca la entristezcas con tu conducta."
,"4":"Acuérdate, hijo mío, de los peligros a que estuvo expuesta cuando te llevaba en su seno. Cuando muera, entiérrala junto a mí, en la misma tumba."
,"5":"Acuérdate siempre del Señor, hijo mío, y no peques ni violes jamás sus mandamientos. Durante toda tu vida practica la justicia y no sigas los caminos de la injusticia;"
,"6":"porque si obras rectamente tendrás éxito en tus empresas, como todos los que practican la justicia."
,"7":"Practica con tus bienes la limosna y no apartes tu rostro de ningún pobre, porque así no apartará de ti su rostro el Señor."
,"8":"Da limosna según tus posibilidades: si tienes mucho, da mucho; si tienes poco, da con largueza de ese poco."
,"9":"Así acumularás un tesoro para el día de la necesidad,"
,"10":"pues la limosna libra de la muerte e impide andar en tinieblas."
,"11":"La limosna, para todos los que la dan, es un precioso depósito ante el altísimo."
,"12":"Hijo mío, guárdate de toda inmoralidad, y ante todo elige una mujer de la raza de tus padres. No te cases con mujer extranjera, o que no sea de la raza de tus padres, pues somos descendientes de los profetas. Recuerda, hijo mío, que Noé, Abrahán, Isaac y Jacob, nuestros padres, se casaron con mujeres de su parentela y fueron bendecidos en sus hijos y su posteridad heredó la tierra."
,"13":"Ama a tus hermanos, y no desprecies a los hijos y a las hijas de tu pueblo, teniendo a menos elegir una mujer entre ellas, porque en la soberbia está la ruina y la discordia, y en la ociosidad, penuria y hambre, pues la ociosidad es la madre del hambre."
,"14":"No retengas el salario a tus obreros; dáselo en seguida; si sirves a Dios, recibirás tu recompensa. Ten cuidado con lo que haces y muéstrate correcto en tu conducta."
,"15":"Lo que no quieras para ti, no lo hagas a nadie. No bebas vino hasta emborracharte y no tengas a la borrachera como compañera de tu vida."
,"16":"Da de tu pan al hambriento y de tus vestidos al desnudo. Da limosna de todo lo que te sobre, y no seas tacaño al dar limosna."
,"17":"Parte tu pan en los sepulcros de los justos, y no en los de los pecadores."
,"18":"Aconséjate de persona sensata, y no desprecies los consejos útiles."
,"19":"Bendice al Señor Dios en todo tiempo; pídele que tus caminos sean rectos y prósperos tus planes; porque no es del hombre el consejo, sino el Señor es quien da todos los bienes y humilla, según quiere, hasta lo más profundo. Recuerda, hijo mío, todos mis mandatos, y que jamás se borren de tu corazón. "
,"20":"Y ahora, hijo mío, te comunico que entregué en depósito trescientos kilos de plata a Gabael, hijo de Gabri, en Ragués de Media."
,"21":"No te preocupes porque hayamos empobrecido. Si temes a Dios, huyes del pecado y haces lo que agrada al Señor, tu Dios, tienes la riqueza más grande'."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Tobías respondió a su padre: 'Haré todo lo que me has mandado, padre;"
,"2":"pero ¿cómo recuperaré la plata, si él no me conoce ni yo a él? ¿Qué señal le daré para que me conozca, me crea y me la dé? Tampoco conozco los caminos para llegar a Media'."
,"3":"Tobit le respondió: 'Gabael y yo firmamos un contrato, y lo partimos por la mitad; cada uno se quedó con una parte, y yo le di la plata. Hace veinte años que hice este depósito. Busca, hijo mío, un hombre de confianza que te acompañe; le pagaremos el sueldo hasta la vuelta; pero recupera la plata'."
,"4":"Tobías salió en busca de un conocedor del camino que le acompañase a Media, y encontró al ángel Rafael, pero sin saber que era un ángel de Dios."
,"5":"Y le dijo: '¿De dónde eres, joven?'. Le respondió: 'Soy un israelita, compatriota tuyo, que he venido buscando trabajo'. Tobías le preguntó: '¿Conoces bien el camino de Media?'."
,"6":"El ángel le dijo: 'Sí, he ido allí muchas veces, y conozco bien los caminos. He estado en Media y me he albergado en casa de Gabael, uno de nuestros hermanos, que vive en Ragués de Media; se necesitan dos días de camino para ir de Ecbatana a Ragués, que se encuentra entre montañas'."
,"7":"Tobías le respondió: 'Espérame, joven, que voy a comunicárselo a mi padre, pues necesito que vengas conmigo; te pagaré lo que sea'."
,"8":"Él le respondió: 'Te espero, pero no tardes mucho'."
,"9":"Tobías fue a su casa y dijo a su padre: 'He encontrado a un israelita, compatriota nuestro'. Su padre le respondió: 'Llámalo para que sepa a qué familia y tribu pertenece y, si es persona de confianza, para acompañarte'."
,"10":"Tobías salió y le dijo: 'Joven, mi padre te llama'. El ángel entró, Tobit lo saludó, y él respondió: '¡Que seas siempre feliz!'. Pero Tobit añadió: '¿Qué felicidad puedo yo esperar? Estoy ciego; no puedo ver la luz del cielo; vivo en tinieblas, como los muertos que no pueden ver la luz. Soy un vivo entre los muertos. Oigo la voz de los hombres, pero no los veo'. El ángel le respondió: '¡Ánimo! Pronto te curará Dios. ¡Ánimo!'. Tobit le dijo: 'Mi hijo quiere ir a Media; ¿puedes tú acompañarle y guiarle? Te daré lo que sea, hermano'. 'Sí, puedo acompañarle -respondió el ángel-. Conozco todos los caminos; he ido frecuentemente a Media, he atravesado las llanuras y las montañas y conozco todos sus senderos'."
,"11":"Tobit preguntó: '¿De qué familia y tribu eres, hermano?'. Él respondió:"
,"12":"'No necesitas saberlo'. Tobit dijo: 'Quisiera saber con exactitud quién eres y cómo te llamas'."
,"13":"'Yo -respondió- soy Azarías, hijo de Ananías, uno de tus hermanos'."
,"14":"Tobit exclamó: '¡Dios te conserve sano y salvo, hermano! No te molestes si he querido conocer la verdad acerca de tu familia. Eres de nuestros hermanos, de buena y noble alcurnia. Conozco a Ananías y a Natán, los dos hijos del gran Semayas. Íbamos juntos a Jerusalén, juntos rezábamos allí, y nunca se han descarriado. Tus hermanos son buenos, tu familia es noble. ¡Bienvenido seas!'. Y"
,"15":"añadió: 'Por salario te daré una dracma cada día y todo lo que necesites, como a mi hijo."
,"16":"Anda con él y, si volvéis sanos, te aumentaré el salario'."
,"17":"Le respondió: 'De acuerdo. Le acompañaré. No temas. Sanos y salvos partimos, y sanos y salvos volveremos, pues el camino es seguro'. Tobit le dijo: 'Buen viaje, hermano'. Y a su hijo: 'Prepara, hijo mío, todo lo necesario para el viaje y parte con tu hermano. Que el Dios del cielo os guarde y os traiga de nuevo sanos y salvos. Que su ángel os acompañe y os proteja en el camino, hijo mío'. Antes de partir, Tobías besó a sus padres. Tobit le dijo: '¡Buen viaje!'."
,"18":"La madre lloraba y decía a Tobit: '¿Por qué has dejado marchar a mi hijo? ¿No era él nuestro apoyo y el que nos acompañaba siempre?"
,"19":"¡Dinero y más dinero! ¡Que se pierda todo, antes que nuestro hijo!"
,"20":"Lo que el Señor nos ha dado nos bastaba para vivir'."
,"21":"Le respondió: 'Deja esos pensamientos, mujer. Sano y salvo ha marchado nuestro hijo, y sano y salvo volverá, y entonces tus ojos podrán verlo con buena salud."
,"22":"Mujer, deja esas ideas; no te angusties por ellos. Un ángel bueno le acompañará; el viaje será feliz, y volverá sano y salvo'."
,"23":"Ella dejó de llorar."
}`)
	CurrentBook.AddChapter(6, `{
"1":"El joven y el ángel partieron. Y el perro se fue con ellos. Caminaron hasta el anochecer. Pasaron la noche a la orilla del río Tigris."
,"2":"Tobías bajó al río a lavarse los pies. Un pez enorme saltó del agua y quería devorarle el pie. Tobías gritó."
,"3":"El ángel le dijo: 'Agarra al pez y no lo dejes escapar'. Tobías lo agarró y lo sacó a tierra."
,"4":"'Abre el pez -le dijo el ángel-, quítale la hiel, el corazón y el hígado y guárdalos; tira las tripas. La hiel, el corazón y el hígado son medicinas excelentes'."
,"5":"El joven abrió el pez y extrajo el corazón y el hígado. Asó parte del pez y tiró el resto."
,"6":"Continuaron de nuevo el viaje los dos hasta llegar cerca de Media."
,"7":"Tobías preguntó al ángel: 'Hermano Azarías, ¿para qué sirve la medicina que hay en el corazón, en el hígado y en la hiel del pez?'."
,"8":"Le respondió: 'El corazón y el hígado del pez se queman delante de un hombre o mujer atormentados por el demonio o por un espíritu maligno, y el tormento desaparece para siempre."
,"9":"La hiel sirve de ungüento para las manchas blancas de los ojos; se sopla sobre ellas, y se curan'."
,"10":"Llegaron a Media, y se acercaban a Ecbatana."
,"11":"Rafael dijo a Tobías: 'Hermano Tobías'. Le respondió: '¿Qué quieres?'. Le dijo: 'Esta noche la pasaremos en casa de Ragüel. Es tu pariente. Tiene una hija llamada Sara."
,"12":"Es hija única. El pariente más próximo eres tú y el que tiene más derecho que nadie a casarse con ella y heredar los bienes de su padre. Es una joven sensata, valiente, muy hermosa, y su padre es muy bueno."
,"13":"Tú tienes derecho a casarte con ella. Escúchame, hermano. Esta noche hablaré yo a su padre para que te la dé por esposa; y luego, cuando volvamos de Ragués, celebraremos el matrimonio. Sé bien que Ragüel no podrá negártela a ti para casarla con otro, pues se haría reo de muerte según la ley de Moisés, porque tú tienes derecho preferente sobre los demás a casarte con su hija. Escúchame, hermano. Hablaremos de la joven esta noche y la pediremos en matrimonio para ti y, al volver de Ragués, celebraremos la boda y la llevaremos con nosotros a tu casa'."
,"14":"Tobías respondió a Rafael: 'Hermano Azarías, he oído decir que la joven se ha casado ya siete veces y que los siete maridos murieron en la habitación matrimonial la noche de bodas cuando iban a unirse a ella. He oído también decir que es un demonio quien los mataba."
,"15":"Yo, la verdad, tengo miedo. A ella no le hace nada, porque la quiere; pero sí mata al que intenta acercarse. Soy el hijo único de mi padre y temo que, si muero, lleve a la tumba, de dolor, a mi padre y a mi madre, que no tienen otro hijo que los entierre'."
,"16":"El ángel respondió: '¿No recuerdas los consejos de tu padre, que te recomendaba casarte con una mujer de su familia? Hermano, no te preocupes por el demonio, y cásate con ella. Te aseguro que esta noche será tu esposa."
,"17":"Cuando entres en la habitación matrimonial, toma un trozo del hígado y del corazón del pez y échalos en el brasero del incienso. Dará olor y, en cuanto huela, el demonio huirá para no volver más."
,"18":"Todavía antes de vuestra unión, rogad los dos al Señor del cielo para que tenga misericordia de vosotros y os proteja. No temas, pues ella estaba destinada para ti desde toda la eternidad; tú la salvarás, irá contigo y tendrás de ella hijos, que serán para ti como hermanos. No te preocupes'."
,"19":"Cuando Tobías oyó lo que dijo Rafael y que Sara era de su raza y de la casa de su padre, se enamoró de ella."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Al llegar a Ecbatana, Tobías dijo: 'Hermano Azarías, llévame en seguida a casa de nuestro pariente Ragüel'. Lo llevó a la casa de Ragüel, el cual estaba en el patio. Al saludarlo, les respondió: 'Bienvenidos seáis, hermanos'. Y los hizo entrar en casa."
,"2":"Dijo a Edna, su mujer: '¡Cómo se parece este joven a mi pariente Tobit!'."
,"3":"Edna les preguntó: '¿De dónde sois, jóvenes?'. Le respondieron: 'Somos de la tribu de Neftalí, cautivos en Nínive'."
,"4":"Ella insistió: '¿Conocéis a nuestro pariente Tobit?'. Le contestaron: 'Sí, lo conocemos'. '¿Está bien?'."
,"5":"'Vive y está bien'. Tobías añadió: 'Es mi padre'."
,"6":"Ragüel entonces se levantó, lo abrazó y se echó a llorar. Después le dijo: 'Bendito seas, joven, hijo de un padre tan bueno. ¡Qué pena que un hombre tan honrado y tan caritativo se haya quedado ciego!'. Abrazó de nuevo a Tobías, y se puso a llorar."
,"7":"Edna, su mujer, y Sara, su hija, también lloraban."
,"8":"Mató luego un carnero, y les ofreció una acogida muy cordial."
,"9":"Se lavaron y se sentaron a la mesa. Tobías dijo a Rafael: 'Hermano Azarías, di a Ragüel que me dé a mi pariente Sara por esposa'."
,"10":"Ragüel lo oyó y dijo al joven: 'Come y bebe y pasa alegre la noche, pues nadie tiene el derecho que tú de casarte con mi hija Sara. Además yo no puedo darla a otro que no seas tú, pues eres mi pariente más cercano. Pero debo decirte toda la verdad:"
,"11":"ya se la he dado en matrimonio a siete hombres de nuestra familia, y todos murieron la noche de bodas. Tú come y bebe, que el Señor proveerá'."
,"12":"Tobías respondió: 'No comeré ni beberé hasta que no te hayas decidido a ello'. Ragüel dijo: 'Bien, te la doy por esposa conforme a lo prescrito en la ley de Moisés, pues así estaba determinado por el cielo. Hazte cargo de ella. Desde ahora tú serás su esposo, y ella tu esposa será tuya para siempre. Que el Señor del cielo os asista esta noche y os conceda su amor y su paz'."
,"13":"Ragüel llamó a su hija Sara, la cogió de la mano y se la dio a Tobías, diciéndole: 'Hazte cargo de ella, conforme a la ley y lo que está mandado en el libro de Moisés, y llévala a casa de tu padre. Que el Dios del cielo os guíe en paz'."
,"14":"Luego dijo a la madre que trajera un papel, en el que escribieron el contrato matrimonial, es decir, que daba a su hija por mujer a Tobías según lo prescrito en la ley de Moisés. Y lo selló. Después se pusieron a comer y beber."
,"15":"Ragüel dijo a su esposa Edna: 'Mujer, prepara otro dormitorio y lleva allí a Sara'."
,"16":"Aderezó la cama, como le dijo su marido, y, llorando, acompañó a su hija. Pero, enjugando sus lágrimas, le decía:"
,"17":"'Ten confianza, hija mía. Que el Señor del cielo te conceda gozo en lugar de tristeza. Ten confianza, hija mía'. Y salió."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Al terminar la cena, se fueron a dormir, y acompañaron al joven a la habitación matrimonial."
,"2":"Tobías recordó entonces las palabras de Rafael. Sacó de su talega el hígado y el corazón del pez y los echó en el brasero del incienso."
,"3":"El olor del pez se esparció por la habitación y el demonio huyó al alto Egipto, adonde fue Rafael y lo ató, dejándolo inmóvil."
,"4":"Habían salido todos, y la puerta del dormitorio estaba ya cerrada. Tobías se levantó y le dijo a Sara: 'Levántate, mujer; recemos y supliquemos a nuestro Señor que tenga misericordia de nosotros y nos proteja'."
,"5":"Ella se levantó, y rezaron y suplicaron al Señor que los protegiera. Tobías rezó así: 'Bendito seas, Dios de nuestros padres, y bendito tu nombre para siempre. Que los cielos y todas las criaturas,te bendigan por los siglos."
,"6":"Tú creaste a Adán,y le diste a Eva, su mujer, como ayuda y compañera; y de los dos ha nacido,toda la raza humana. Tú dijiste: No está bien que el hombre esté solo, hagámosle una ayuda semejante a él."
,"7":"Ahora, Señor, yo no me caso con esta mujer por lujuria, sino con elevados sentimientos. Ten misericordia de los dos, y haz que vivamos larga vida'."
,"8":"Los dos exclamaron: 'Amén, amén'."
,"9":"Y durmieron toda la noche."
,"10":"Ragüel se levantó temprano, llamó a sus criados y cavaron una fosa. Se dijo: 'No sea que muera, y seamos objeto de burla e irrisión'."
,"11":"Al terminar la fosa, Ragüel volvió a casa"
,"12":"y dijo a su mujer: 'Manda una criada a ver si vive; pues si ha muerto, lo enterraremos sin que nadie se entere'."
,"13":"Mandó una criada, que encendió una lámpara, abrió la puerta, entró y vio que dormían profundamente."
,"14":"La criada salió y les dijo que vivía y que nada malo les había sucedido."
,"15":"Bendijeron entonces al Señor de esta manera: 'Bendito seas, oh Dios, con toda alabanza pura. Bendito seas por los siglos."
,"16":"Bendito seas por haberme consolado, porque lo que temía no ha llegado, sino que te has portado con nosotros,según tu gran misericordia. Bendito seas porque has tenido compesión,de estos dos hijos únicos."
,"17":"Concédeles, Señor, tu misericordia y tu protección, y una vida llena de alegría y felicidad'."
,"18":"Luego mandó que sus criados rellenasen la fosa antes del amanecer."
,"19":"Dijo a su mujer que preparase pan en abundancia. Él se fue a la vacada, trajo dos toros y cuatro carneros, mandó que los mataran y comenzaron los preparativos."
,"20":"Luego llamó a Tobías y le dijo: 'Tienes que quedarte aquí dos semanas comiendo y bebiendo en mi casa y alegrando a mi hija, que tanto ha sufrido."
,"21":"Luego tomarás la mitad de mis bienes y te irás feliz a casa de tus padres; heredarás la otra mitad cuando hayamos muerto mi mujer y yo. Ánimo, hijo, que soy ya para siempre tu padre y Edna tu madre, como lo somos de tu mujer Sara. Ánimo, hijo'."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Tobías llamó a Rafael y le dijo:"
,"2":"'Hermano Azarías, toma cuatro criados y dos camellos y vete a Ragués."
,"3":"Entrevístate con Gabael, entrégale el recibo, cobra el dinero e invítale a la boda."
,"4":"Sabes bien que mi padre está contando los días y, si me retardase más, le daría un disgusto. Has sido testigo del juramento de Ragüel, que no puedo quebrantar'."
,"5":"Rafael partió con cuatro criados y dos camellos para Ragués de Media y se hospedaron en casa de Gabael. Le entregaron el recibo y le comunicó que Tobías, hijo de Tobit, se había casado y le invitaba a la boda. Gabael trajo las talegas con los sellos, y las cargaron."
,"6":"A buena hora se pusieron en camino y llegaron a la boda. Al entrar en casa de Ragüel, encontraron a Tobías sentado a la mesa. Se levantó y saludó a Gabael, que se echó a llorar y lo bendijo así: '¡Hombre bueno y honrado, hijo de un hombre honrado, justo y limosnero! Que el Señor te bendiga con bendiciones celestiales a ti, a tu mujer, a su padre y a su madre. Bendito sea Dios, que he visto a Tobías tan parecido a mi primo Tobit'."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Uno por uno contaba Tobit los días necesarios para ir y volver. Cuando pasaron sin que su hijo llegara,"
,"2":"pensó: 'Quizá se haya entretenido en Ragués o a lo mejor se ha muerto Gabael y no hay quien le entregue el dinero'."
,"3":"Comenzó a preocuparse."
,"4":"Ana, su mujer, repetía: 'Mi hijo ha muerto, ya no vive'. Y lloraba y se lamentaba:"
,"5":"'¡Desgraciada de mí, hijo mío, luz de mis ojos! ¡Por qué te dejé marchar!'."
,"6":"Tobit contestaba: 'Cálmate, mujer; no te preocupes, que está bueno y salvo. Le habrá salido algún imprevisto; pero el hombre que le acompañaba es persona de confianza y uno de nuestros compatriotas. No te entristezcas, mujer, que pronto llegará'."
,"7":"Ella le respondía: '¡Que no me preocupe, cuando ha muerto mi hijo!...'. Todos los días salía a las afueras y oteaba el camino por donde había marchado su hijo. De nadie se fiaba. Al caer la tarde, volvía a casa, y durante la noche suspiraba y lloraba, sin poder dormir."
,"8":"Cuando transcurrieron los catorce días de boda que Ragüel había prometido celebrar en honor de su hija, Tobías dijo a Ragüel: 'Déjame ya marchar. Sé que mis padres están pensando que no me verán más. Te ruego que me permitas marchar a casa de mi padre. Ya te he dicho cómo lo dejé'."
,"9":"Pero Ragüel le decía: 'Quédate, hijo mío, quédate todavía conmigo, que yo mandaré emisarios a tu padre para darle noticias de ti'. Tobías respondió: 'No, no; te ruego que me dejes partir para llegar cuanto antes a casa de mi padre'."
,"10":"Ragüel le entregó a Sara, su mujer, y la mitad de sus bienes: criados y criadas, vacas y ovejas, asnos y camellos, vestidos, dinero y utensilios;"
,"11":"y lo dejó partir sano y salvo; y lo despidió así: 'Adiós, hijo mío, que tengas buen viaje. Que el Dios del cielo te conceda a ti y a Sara, tu mujer, un feliz viaje, y que pueda yo ver a vuestros hijos antes de morir'."
,"12":"Después dijo a su hija Sara: 'Honra a tus suegros, pues desde ahora son tus padres como nosotros, que te hemos engendrado. Vete en paz, hija, y que tenga yo, mientras viva, buenas noticias de ti'. Los abrazó y los dejó partir."
,"13":"Edna, a su vez, dijo a Tobías: 'Hijo y hermano querido, quiera el Señor que vuelvas y que yo vea a vuestros hijos antes de morir. Confío mi hija a tu protección. No la hagas sufrir. Vete en paz. Desde ahora yo soy tu madre, y Sara, tu mujer. Que vivamos todos felices durante toda nuestra vida'. Los besó y los dejó partir en paz."
,"14":"Feliz y dichoso salió Tobías de casa de Ragüel, bendiciendo al Señor de cielos y tierra, rey del universo, por haber llevado a feliz éxito su viaje. Y bendijo a Ragüel y Edna: 'Que el Señor me conceda honraros todos los días de mi vida'."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Cuando se acercaron a Caserín, que está enfrente de Nínive, dijo Rafael a Tobías:"
,"2":"'Tú sabes cómo dejamos a tu padre."
,"3":"Adelantémonos a tu mujer para preparar la casa antes que ella llegue'."
,"4":"Se adelantaron los dos, y Rafael le dijo: 'Ten a mano la hiel'. El perro los seguía."
,"5":"Entretanto Ana, que estaba observando el camino por el que debía volver su hijo,"
,"6":"presintió que llegaba y dijo a su marido: 'Mira, tu hijo viene con el hombre con el que marchó'."
,"7":"Rafael había dicho a Tobías antes de llegar a casa de su padre: 'Sus ojos se abrirán."
,"8":"Unta sus ojos con la hiel del pez; al escocerle, se frotará y desaparecerán las manchas blancas. Tu padre recobrará la vista y verá la luz'."
,"9":"Ana se echó al cuello de su hijo, exclamando: 'Te he vuelto a ver, hijo mío; ahora ya puedo morir'. Y lloraba."
,"10":"Tobit también se levantó y, tropezando, pudo llegar a la puerta del patio."
,"11":"Tobías fue a su encuentro con la hiel del pez en la mano; le sopló en los ojos, lo abrazó y le dijo: 'Ánimo, padre'. Después le aplicó el remedio, que le provocó escozor."
,"12":"Con las dos manos quitó las manchas blancas de los lagrimales de sus ojos."
,"13":"Tobit se echó al cuello de su hijo y, llorando, le decía: 'Te veo, hijo mío, luz de mis ojos'. Y añadió:"
,"14":"'Bendito sea Dios, bendito sea su glorioso nombre, benditos sean todos sus santos ángeles. Que su nombre glorioso nos proteja. Porque el Señor me había castigado, pero ha tenido compasión de mí,y ahora puedo ver a mi hijo Tobías'."
,"15":"Tobías entró en casa muy contento, alabando a Dios con todas sus fuerzas. Después contó a su padre el éxito de su viaje, que traía el dinero, que se había casado con Sara, hija de Ragüel, la cual estaba ya a las puertas de Nínive."
,"16":"Tobit, contento y bendiciendo a Dios, salió al encuentro de su nuera a la puerta de Nínive. Los que le veían caminar, firme y sin que nadie le ayudase, quedaban maravillados. Tobit confesaba delante de todos que Dios había tenido compasión de él y le había curado."
,"17":"Después se acercó a Sara, mujer de Tobías, y la bendijo así: 'Bienvenida seas, hija mía. Benditos sean tus padres, bendito Tobías, mi hijo, y bendita tú, hija mía. Entra en tu casa, bienvenida seas; a ti la bendición y la alegría; entra, hija mía'."
,"18":"Aquel día fue de gozo para todos los judíos de Nínive."
,"19":"Ajicar y Nadab, sobrinos de Tobit, llegaron para alegrarse con él."
,"20":"Se celebró la boda con gran regocijo durante siete días, en los que se recibieron muchos regalos."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Cuando terminó la boda, Tobit llamó a su hijo Tobías y le dijo: 'Hijo mío, piensa cuánto debes dar al hombre que te acompañó y cuánto debes añadir a lo convenido'."
,"2":"Tobías contestó: '¿Cuánto tendré que darle? No saldría perjudicado dándole la mitad de todo lo que hemos traído."
,"3":"Me ha devuelto sano y salvo, curó a mi mujer, me procuró el dinero y te ha curado a ti; ¿cuánto deberé darle?'."
,"4":"Tobit le respondió: 'Justo es, hijo mío, darle la mitad de cuanto habéis traído'."
,"5":"Tobías llamó al ángel y le dijo: 'Toma como salario la mitad de todo lo que has traído y vete en paz'."
,"6":"Entonces el ángel llamó a los dos aparte y les dijo: 'Bendecid a Dios y dadle gracias, honradle y alabadle ante todo el mundo porque os ha colmado de bienes. Bendecidle y cantad himnos a su nombre. Dad a conocer a todos los hombres las obras de Dios, como es justo, y no os canséis de darle gracias."
,"7":"Bueno es guardar el secreto del rey, pero hay que celebrar y publicar las obras de Dios. Haced el bien, y no os ocurrirá ninguna desgracia."
,"8":"Mejor es la oración con ayuno y la limosna con justicia que la riqueza con injusticia. Buena es la limosna, y mejor que amontonar tesoros."
,"9":"La limosna libra de la muerte y purifica de todo pecado. Los que dan limosna tendrán larga vida."
,"10":"Los que cometen el pecado y la injusticia son enemigos de sí mismos."
,"11":"Os voy a decir toda la verdad, y no os ocultaré nada. Os he dicho que es bueno guardar el secreto del rey y que hay que celebrar y publicar las obras de Dios."
,"12":"Cuando rezabais tú y Sara, yo presentaba vuestras oraciones al Señor. Cuando enterrabas a los muertos, yo estaba a tu lado."
,"13":"Cuando dejabas la comida para dar sepultura a los muertos, yo fui enviado para probarte."
,"14":"Y Dios también me envió para curarte a ti y a Sara, tu nuera."
,"15":"Yo soy Rafael, uno de los siete ángeles que están ante la gloria del Señor y en su presencia."
,"16":"Temblaron entonces los dos, cayeron con el rostro en tierra y se llenaron de pánico."
,"17":"Pero él les dijo: 'No temáis; la paz esté con vosotros. Bendecid siempre al Señor."
,"18":"Cuando estaba con vosotros, no estaba por mi propia voluntad, sino por voluntad de Dios. Bendecidle y cantad himnos en su honor todos los días."
,"19":"Me veíais, pero no comía; era una apariencia lo que veíais."
,"20":"Vosotros ahora bendecid en la tierra al Señor y dadle gracias; yo me voy al que me envió. Escribid lo que os ha sucedido'. Y desapareció."
,"21":"Ellos se levantaron y no le vieron más."
,"22":"Bendecían y cantaban a Dios y le daban gracias por las maravillas que había hecho, porque se les había aparecido un ángel de Dios."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Tobit dijo: 'Bendito sea Dios, que vive para siempre, y que reina por todos los siglos;"
,"2":"porque castiga y perdona, lleva a la profundidad de los abismos,y saca de la gran perdición. Nadie puede escapar de su mano."
,"3":"Israelitas, bendecidlo,ante las naciones, porque él os ha dispersado entre ellas,"
,"4":"y os ha demostrado su grandeza. Ensalzadlo ante todos los vivientes, pues él es nuestro Señor,y nuestro Dios, él es nuestro padre para siempre."
,"5":"Él os castiga por vuestras iniquidades,y después os perdona,y os reunirá de entre todas las naciones,en que os ha dispersado."
,"6":"Si os convertís a él de todo corazón,y toda el alma, practicando la verdad, él volverá a vosotros, y nunca más os esconderá su rostro."
,"7":"Considerad lo que ha hecho,por vosotros,y con voz potente dadle gracias. Bendecid al Señor de la justicia, ensalzad al rey de los siglos."
,"8":"Le daré gracias en el país,de mi destierro,y anunciaré su poder y su grandeza,a mi pueblo pecador. Convertíos, pues, pecadores, y practicad ante él la justicia, seguros de que él mostrará,su misericordia con vosotros."
,"9":"Ensalzaré a Dios, rey de los cielos, y mi alma radiante de júbilo,proclamará su grandeza."
,"10":"Anúncienlo todos, y todos en Jerusalén le den gracias. Jerusalén, ciudad santa, el Señor te castigará,por las obras de tus hijos, luego se apiadará de los hijos,que practican la justicia."
,"11":"Da gracias dignamente al Señor,y bendice al rey de los siglos, porque de nuevo su templo,será con gozo construido,"
,"12":"y alegrará en ti a todos los cautivos,y amará en ti para siempre,a todos los miserables."
,"13":"Una luz resplandeciente brillará,hasta el último rincón de la tierra. Pueblos numerosos acudirán a ti,desde muy lejos, desde tierras lejanas vendrán,a celebrar tu nombre santo, trayendo dones en sus manos,para el rey del cielo. Generaciones y generaciones,en ti se alegrarán, y tu nombre,será glorioso para siempre."
,"14":"Malditos los que te insulten, malditos todos los que te destruyan, los que arrasen tus murallas, derriben tus torres y quemen tus casas. Pero benditos para siempre,todos los que te reconstruyan."
,"15":"Gózate y alégrate,por los hijos de los justos, pues todos se reunirán de nuevo,y alabarán al Señor de la eternidad. Bienaventurados los que te aman,y los que se alegran de tu paz."
,"16":"Bienaventurados también todos,los hombres que lloren tus calamidades, porque se alegrarán en ti,contemplando tu gloria para siempre. Alma mía, bendice al Señor, el rey grande,"
,"17":"porque Jerusalén,será de nuevo edificada, la ciudad que es morada para siempre. Bienaventurado seré,si el resto de mi raza,puede contemplar tu gloria,y dar gracias al rey del cielo. Las puertas de Jerusalén,serán construidas,con zafiro y esmeraldas, y todas sus murallas,con piedras preciosas. Las torres de Jerusalén,serán reconstruidas con oro, y sus baluartes, con oro puro. Las plazas de Jerusalén,serán pavimentadas,con rubíes y con piedras de Ofir."
,"18":"Las puertas de Jerusalén,entonarán cánticos jubilosos, y todos sus habitantes repetirán: Aleluya. Bendito sea el Dios de Israel. Y todos los que por él son bendecidos, bendecirán dichosos,su nombre santo,por siempre jamás'."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Así terminó Tobit su canto."
,"2":"Tobit murió en paz a la edad de ciento doce años y fue dignamente sepultado en Nínive. Tenía sesenta y dos años cuando se quedó ciego. Después de recuperar la vista abundó en bienes e hizo limosnas; continuó alabando a Dios y celebrando su grandeza."
,"3":"Estando para morir, llamó a su hijo Tobías y le hizo estas exhortaciones: 'Hijo mío,"
,"4":"vete a Media con tus hijos, pues creo en la palabra que pronunció Nahún sobre Nínive en nombre de Dios. Todo llegará y sucederá sobre Asiria y Nínive. Todo lo que han anunciado los profetas de Israel, enviados de Dios, se verificará y ninguna de sus palabras fallará, sino que todo se cumplirá a su debido tiempo. Será más fácil salvarse en Media que en Asiria o Babilonia. Sé y creo que sucederá todo lo que ha dicho y que ninguna de sus palabras fallará: Nuestros hermanos que viven en Israel serán dispersados y llevados cautivos, e Israel será un desierto; desiertas quedarán Samaría y Jerusalén, y el templo de Dios será incendiado y quedará desolado por algún tiempo."
,"5":"Pero Dios tendrá otra vez misericordia, volverán a Israel y reconstruirán el templo; pero no como el primero, hasta que se cumpla el tiempo prefijado. Tras esto volverán todos de su destierro y reconstruirán Jerusalén con dignidad, como también el templo, según lo previsto por los profetas de Israel."
,"6":"Todos los pueblos del mundo se convertirán y temerán sinceramente a Dios. Enterrarán a sus ídolos, causa de sus extravíos y sus errores, y alabarán, como es justo, al Señor de los siglos."
,"7":"Todos los israelitas que se salven entonces y que se acuerden de verdad de Dios se juntarán, irán a Jerusalén y habitarán con seguridad para siempre en la tierra de Abrahán, que se les entregará de nuevo. Los que aman a Dios de verdad se alegrarán, mientras que los pecadores y los injustos desaparecerán de la tierra."
,"8":"Y ahora, hijos míos, os mando que sirváis a Dios sinceramente. Haced lo que a él le agrada, enseñad a vuestros hijos la justicia y la misericordia. Que se acuerden de Dios, de bendecir sinceramente su nombre en todo tiempo y con todas sus fuerzas."
,"9":"Vete, hijo mío, de Nínive; no te quedes aquí. El día en que entierres a tu madre junto a mí, pasa los límites de Nínive. Yo sé bien que se cometen muchas injusticias y muchos fraudes sin avergonzarse por ello."
,"10":"Mira, hijo mío, lo que hizo Nadab con Ajicar, que lo había criado: lo enterró vivo. Pero Dios castigó su injusticia: Ajicar volvió a la luz, mientras que Nadab bajó a las tinieblas eternas por haber intentado matarlo. Ajicar se libró de la muerte tramada por Nadab por dar limosna, mientras que Nadab cayó en el lazo y pereció."
,"11":"Tened, pues, presente, hijos míos, los efectos de la limosna y los de la injusticia, que conduce a la muerte. Siento que se me escapa la vida'. Lo llevaron al lecho y murió. Fue enterrado solemnemente."
,"12":"Cuando murió su madre, Tobías la enterró junto a su padre. Entonces él y su familia se fueron a Media, y se quedaron a vivir en Ecbatana con su suegro Ragüel."
,"13":"Cuidó respetuosamente a sus suegros en su vejez y los enterró en Ecbatana de Media, heredando entonces lo de Ragüel y lo de su padre Tobit."
,"14":"Murió a la edad de ciento diecisiete años."
,"15":"Antes de morir conoció la ruina de Nínive. Vio a los cautivos llevados a Media por el rey Ciaxares. Alabó a Dios por todo lo que había hecho con los ninivitas y asirios. Pudo también alegrarse de la suerte de Nínive y bendijo a Dios por los siglos de los siglos."
}`)

}
func ES_LSB_LoadVMBRChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Éste es el texto del libro escrito por Baruc, hijo de Nerías, hijo de Majsías, hijo de Sedecías, hijo de Asadías, hijo de Jelcías, en Babilonia,"
,"2":"el año quinto, el día siete del mismo mes en que los caldeos habían tomado e incendiado Jerusalén."
,"3":"Baruc leyó el texto de este libro ante Jeconías, hijo de Joaquín, rey de Judá, y ante todo el pueblo congregado para escuchar esta lectura,"
,"4":"ante los dignatarios, los familiares del rey, los ancianos; en una palabra, ante el pueblo entero, desde el más chico al más grande, de todos los que habitaban en Babilonia, a orillas del río Sud."
,"5":"Todos lloraban, hacían ayunos y oraciones en la presencia del Señor."
,"6":"Luego hicieron una colecta de dinero, según las posibilidades de cada uno,"
,"7":"y lo mandaron a Jerusalén, al sacerdote Joaquín, hijo de Jelcías, hijo de Salón, a los demás sacerdotes y al resto del pueblo que se encontraban con él en Jerusalén."
,"8":"Ya Baruc, el día diez del mes de siván, había recobrado los utensilios del templo del Señor, sacados del templo, para restituirlos a Judá; utensilios de plata, mandados hacer por Sedecías, hijo de Josías, rey de Judá;"
,"9":"después que Nabucodonosor, rey de Babilonia, se había llevado de Jerusalén a Jeconías, a los príncipes, a los rehenes, a los nobles y a los plebeyos, y los había deportado a Babilonia."
,"10":"Les decían: 'Ahí os mandamos dinero para que con él compréis holocaustos, sacrificios por el pecado e incienso; haced ofrendas y presentadlas sobre el altar del Señor Dios nuestro."
,"11":"Rogad por la vida de Nabucodonosor, rey de Babilonia, y por la vida de su hijo Baltasar, para que sus días en la tierra sean como los del cielo."
,"12":"El Señor nos dé fuerzas e ilumine nuestros ojos para vivir a la sombra de Nabucodonosor, rey de Babilonia, y de su hijo Baltasar, sirviéndolos largo tiempo y gozando de su favor."
,"13":"Rogad también por nosotros al Señor Dios nuestro, porque hemos pecado contra él y todavía hoy no se ha retirado de nosotros la indignación y la ira del Señor."
,"14":"Y leed este libro que os mandamos, para que se haga pública confesión en el templo del Señor, en el día de fiesta y en los días de la asamblea."
,"15":"Diréis: Al Señor Dios nuestro pertenece la justicia, y a nosotros en cambio en este día la vergüenza: la vergüenza para los hombres de Judá y para los habitantes de Jerusalén,"
,"16":"para nuestros reyes, nuestros príncipes, nuestros sacerdotes, nuestros profetas y nuestros padres."
,"17":"Porque hemos pecado contra el Señor,"
,"18":"le hemos desobedecido y no hemos escuchado la voz del Señor Dios nuestro, ni hemos seguido los preceptos que el Señor nos había puesto delante."
,"19":"Desde que el Señor sacó a nuestros padres de Egipto hasta el día de hoy hemos sido infieles al Señor Dios nuestro y nos hemos alejado para no oír su voz."
,"20":"Por esto se nos han pegado las calamidades y la maldición que el Señor comunicó a su siervo Moisés, cuando sacó a nuestros padres de Egipto, para darnos una tierra que mana leche y miel; éste es nuestro caso presente."
,"21":"Nosotros no hemos escuchado la voz del Señor Dios nuestro, conforme a todas las palabras de los profetas que nos ha enviado,"
,"22":"sino que cada uno de nosotros ha seguido el capricho de su perverso corazón, sirviendo a dioses extraños y haciendo lo que desagrada al Señor Dios nuestro."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Por eso el Señor Dios nuestro ha cumplido la amenaza que había pronunciado contra nosotros, contra nuestros jueces que gobernaron a Israel, contra nuestros reyes y nuestros príncipes, contra las gentes de Israel y de Judá."
,"2":"Jamás ocurrió debajo del cielo entero nada semejante a lo ocurrido en Jerusalén, como estaba escrito en la ley de Moisés:"
,"3":"que llegáramos a comer uno la carne de su propio hijo, otro la carne de su propia hija."
,"4":"Además, el Señor los entregó en manos de todos los reinos de alrededor para que fuesen objeto de oprobio y maldición entre todos los pueblos de los contornos, donde el Señor los dispersó."
,"5":"Hemos sido hechos esclavos en lugar de señores, porque hemos pecado contra el Señor Dios nuestro, no escuchando su voz."
,"6":"Al Señor Dios nuestro le pertenece la justicia; a nosotros y a nuestros padres, la vergüenza, como es el caso presente."
,"7":"El Señor nos había amenazado con todas estas calamidades que ahora nos han sobrevenido."
,"8":"Pero nosotros no hemos aplacado el rostro del Señor convirtiéndose cada uno de los pensamientos de su perverso corazón."
,"9":"Por eso el Señor ha vigilado sobre los castigos y los ha descargado contra nosotros, porque el Señor es justo en todo lo que nos ordenó hacer."
,"10":"Pero nosotros no hemos escuchado su voz siguiendo los mandamientos que nos había puesto delante."
,"11":"Y ahora, oh Señor, Dios de Israel, que sacaste a tu pueblo de Egipto con mano fuerte, entre señales y prodigios, con gran poder y tu brazo extendido, y te ganaste así un nombre hasta el día de hoy,"
,"12":"nosotros hemos pecado, hemos procedido con crímenes y con injusticias, Señor Dios nuestro, contra todos tus mandamientos."
,"13":"Retírese tu ira de nosotros, porque hemos quedado bien escasos en medio de las gentes entre las que nos dispersaste."
,"14":"Escucha, Señor, nuestra oración y nuestra súplica, líbranos por tu honor y haz que ganemos el favor de los que nos deportaron,"
,"15":"para que sepa toda la tierra que tú eres el Señor Dios nuestro y que tu nombre se invoca sobre Israel y sobre su raza."
,"16":"Míranos, Señor, desde tu santa morada, atiéndenos; inclina, Señor, tu oído y escucha."
,"17":"Abre los ojos y mira, que no son los muertos en el abismo, aquellos cuyo espíritu fue separado de sus entrañas, los que celebran tu gloria y tu justicia,"
,"18":"sino el alma cargada de aflicción, el que camina encorvado y extenuado, los ojos lánguidos y el estómago hambriento, ésos son los que celebran tu gloria y tu justicia, Señor."
,"19":"No apoyamos en los méritos de nuestros padres y de nuestros reyes la misericordia que te suplicamos, oh Señor Dios nuestro."
,"20":"Porque has descargado sobre nosotros tu cólera y tu furor, como habías amenazado por medio de tus siervos los profetas al decir:"
,"21":"'Esto dice el Señor: Doblegad vuestras espaldas, servid al rey de Babilonia y seguiréis viviendo en la tierra que yo di a vuestros padres."
,"22":"Pero si no escucháis la invitación del Señor a servir al rey de Babilonia,"
,"23":"haré desaparecer de las ciudades de Judá y de Jerusalén el canto de alegría y de alborozo, el canto del esposo y de la esposa, y todo el país quedará hecho un desierto, sin habitantes'."
,"24":"Pero nosotros no hicimos caso de tu invitación de servir al rey de Babilonia; y tú entonces has cumplido tus amenazas pronunciadas por medio de tus siervos los profetas; esto es, que los huesos de nuestros reyes y de nuestros padres serían sacados de sus sepulcros."
,"25":"Y, efectivamente, han sido tirados por el suelo al calor del día y al frío de la noche, y ellos murieron en medio de atroces penalidades de hambre, de espada y de peste."
,"26":"Y al templo que lleva tu nombre lo has reducido al miserable estado en que se encuentra ahora, a causa de las injusticias de la casa de Israel y de la casa de Judá."
,"27":"Sin embargo, has obrado con nosotros, Señor Dios nuestro, según toda tu bondad y tu gran misericordia,"
,"28":"como habías hablado por medio de tu siervo Moisés, el día en que le ordenaste escribir tu ley en presencia de los israelitas, diciendo:"
,"29":"'Si no escucháis mi voz, esta grande, enorme muchedumbre quedará con toda seguridad reducida a un pequeño número en medio de las naciones entre las que yo los dispersaré."
,"30":"Pues bien sé que no me escucharán, porque son un pueblo de cabeza dura; pero en el país de su destierro recapacitarán,"
,"31":"entonces reconocerán que yo soy el Señor su Dios. Yo les daré un corazón y unos oídos que oigan."
,"32":"Y ellos me alabarán en el país de su destierro, se acordarán de mi nombre,"
,"33":"desistirán de su cabeza dura y de sus perversas obras, acordándose de lo que les sucedió a sus padres, que pecaron contra mí."
,"34":"Y los volveré a la tierra que bajo juramento prometí a sus padres, a Abrahán, a Isaac y a Jacob, y tomarán posesión de ella. Allí los multiplicaré, y ya no menguarán."
,"35":"Y estableceré con ellos una alianza eterna: yo seré su Dios, ellos serán mi pueblo, y no volveré a echar nunca más a mi pueblo Israel de la tierra que les di."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Oh Señor todopoderoso, Dios de Israel, un alma angustiada, un espíritu abatido es el que clama a ti."
,"2":"Escucha, Señor, ten piedad, porque hemos pecado contra ti."
,"3":"Tú te sientas en tu trono eternamente, mas nosotros por siempre pereceremos."
,"4":"Señor todopoderoso, Dios de Israel, de los hijos de aquellos que pecaron contra ti. No dieron ellos oídos a la voz del Señor, su Dios, y por eso se han pegado a nosotros esas calamidades."
,"5":"No te acuerdes de las injusticias de nuestros padres; acuérdate ahora de tu mano y de tu nombre."
,"6":"Pues tú eres el Señor Dios nuestro, y nosotros queremos alabarte, Señor."
,"7":"Para eso has llenado de tu temor nuestros corazones, para que invocásemos tu nombre. Queremos alabarte en nuestro destierro, porque hemos apartado de nuestro corazón toda la injusticia de nuestros padres, que pecaron ante ti."
,"8":"Y aquí estamos todavía en nuestro destierro, donde tú nos dispersaste para que fuésemos oprobio, maldición, condenación por todas las injusticias de nuestros padres, que se apartaron del Señor Dios nuestro."
,"9":"Escucha, Israel, los preceptos de vida, tiende tu oído para aprender la sabiduría."
,"10":"¿Por qué, Israel, por qué te encuentras en tierra de enemigos, envejeces en un país extraño,"
,"11":"te has contaminado con los muertos,y eres contado entre los que bajan al abismo?"
,"12":"Es que has abandonado,la fuente de la sabiduría;"
,"13":"si hubieras andado por el camino de Dios, habrías vivido en paz eternamente."
,"14":"Aprende dónde está la prudencia, dónde la fuerza, dónde la inteligencia, para saber con ello dónde está la longevidad y la vida, dónde la lumbre de los ojos y la paz."
,"15":"Pero ¿quién ha encontrado su mansión, quién ha entrado en sus tesoros?"
,"16":"¿Dónde están los príncipes de las naciones,y los que doman las bestias de la tierra?"
,"17":"¿Los que juegan con las aves del cielo, los que acumulan la plata y el oro, en que confían los hombres,y nunca se cansan de adquirirlas;"
,"18":"los que con tanto afán labran la plata, sin que haya rival para sus obras?"
,"19":"Han desaparecido, han bajado al abismo; otros han surgido en su lugar;"
,"20":"otros más jóvenes han visto la luz,y han vivido en la tierra; pero el camino de la ciencia no lo han conocido,"
,"21":"no han sabido sus senderos. Sus hijos tampoco han dado con ella, han quedado lejos de su camino."
,"22":"No se oyó hablar de ella en Canaán, ni fue vista en Temán."
,"23":"Los hijos de Agar, que andan buscando la prudencia en la tierra, los mercaderes de Madián y de Temán, los narradores de fábulas,y los buscadores de prudencia,no conocieron el camino de la sabiduría, ni descubrieron sus senderos."
,"24":"¡Oh Israel, qué grande es la morada de Dios, qué vasto el lugar de su dominio!"
,"25":"Grande es y sin límites, excelso e inmenso."
,"26":"Allí nacieron los gigantes, los famosos de antiguo, de elevada estatura, expertos en la guerra."
,"27":"Pero Dios no eligió a éstos, ni a ellos enseñó el camino de la sabiduría,"
,"28":"y por eso perecieron; por no tener prudencia, perecieron por su insensatez."
,"29":"¿Quién subió al cielo y la tomó?,¿Quién la hizo bajar desde las nubes?"
,"30":"¿Quién atravesó el mar para alcanzarla,y la trajo a precio de oro puro?"
,"31":"Nadie conoce su camino, nadie sabe sus senderos."
,"32":"Pero aquel que todo lo sabe la conoce, con su inteligencia la descubrió; el que estableció la tierra para siempre,y la llenó de animales,"
,"33":"el que envía la luz y ella va, la llama y temblorosa le obedece."
,"34":"Brillan los astros en su sitio llenos de alegría;"
,"35":"los llama él y responden: aquí estamos, y brillan jubilosos para su hacedor."
,"36":"Éste es nuestro Dios; ningún otro es comparable a él."
,"37":"Él descubrió los caminos de la sabiduría,y se los enseñó a Jacob, su siervo, a Israel, su preferido."
,"38":"Así apareció ella en la tierra,y llegó al alcance de los hombres."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Ella es el libro,de los mandamientos de Dios, la ley que permanece eternamente. Todos los que la guardan alcanzarán la vida, mas los que la abandonan morirán."
,"2":"Vuélvete, Jacob, y abrázala, camina al resplandor de su luz."
,"3":"No cedas tu gloria a otro, ni tu dignidad a nación extranjera."
,"4":"Felices somos, Israel, pues podemos descubrir lo que agrada al Señor."
,"5":"¡Ánimo, pueblo mío, memorial de Israel!"
,"6":"Habéis sido vendidos a las naciones, mas no para ser aniquilados, sino que por haber provocado la cólera de Dios,habéis sido entregados a los enemigos."
,"7":"Pues irritasteis a vuestro creador, ofreciendo sacrificios a los demonios, y no a Dios."
,"8":"Olvidasteis al Dios eterno, el que os sustentó; y afligisteis a Jerusalén, la que os crió."
,"9":"Vio ella desencadenarse,contra vosotros la cólera de Dios, y dijo: Escuchad, vecinas de Sión: Dios me ha enviado un gran dolor."
,"10":"He visto el cautiverio de mis hijos y mis hijas, que el eterno les mandó."
,"11":"Con gozo los había yo criado,y los he visto partir con llanto y duelo."
,"12":"Nadie se regocije de mí, de verme viuda, abandonada de tantos. Estoy en soledad por los pecados de mis hijos, porque se apartaron de la ley de Dios;"
,"13":"no conocieron sus preceptos, no caminaron en los mandamientos de Dios, ni siguieron las sendas de la educación,conforme a su justicia."
,"14":"¡Vengan las vecinas de Sión!,Acordaos del cautiverio de mis hijos y mis hijas, que el eterno les mandó."
,"15":"Pues fue él quien trajo sobre ellos,una nación de lejos, nación desvergonzada y de lengua extraña, que no respetó al anciano, ni tuvo compasión del niño"
,"16":"y se llevó a los hijos preferidos de la viuda,y la dejó desolada, privada de sus hijas."
,"17":"Y yo, ¿cómo puedo ayudaros?"
,"18":"Aquel que trajo sobre vosotros,estas calamidades os arrancará,de las manos de vuestros enemigos."
,"19":"¡Seguid, hijos, seguid vuestro camino!,Que yo me quedo sola."
,"20":"Me he quitado el vestido de la paz, me he puesto el sayal de mis súplicas; clamaré al eterno mientras viva."
,"21":"Ánimo, hijos míos, aclamad al Señor; él os librará de la tiranía, de las manos de vuestros enemigos."
,"22":"Yo espero del eterno vuestra salvación; del santo me viene la alegría, por la misericordia,que pronto llegará a vosotros,de parte del eterno, vuestro salvador."
,"23":"Os he visto partir con llanto y duelo, pero el Señor os devolverá a mí,entre alegría y gozo para siempre."
,"24":"Y como las vecinas de Sión,ven ahora vuestro cautiverio, así verán pronto vuestra salvación de parte de Dios, que os llegará con gran gloria,y esplendor del eterno."
,"25":"Hijos, soportad con paciencia la ira,que de parte de Dios os ha alcanzado; tu enemigo te ha perseguido, pero pronto verás su ruina,y pondrás tu pie en su nuca."
,"26":"Mis hijos más mimados han tenido,que recorrer caminos ásperos, han sido llevados,como rebaño arrebatado por enemigos."
,"27":"Ánimo, hijos míos, clamad a Dios, pues el que os ha castigado,se acordará de vosotros;"
,"28":"y si vuestro pensamiento,sólo fue apartaros de Dios, volved ahora y buscadle,con ardor diez veces mayor."
,"29":"Pues el que trajo sobre vosotros,estas calamidades os traerá, con vuestra salvación, la alegría perdurable."
,"30":"Ten ánimo, Jerusalén; te consolará aquel que te ha dado un nombre."
,"31":"¡Desdichados los que te maltrataron,y se alegraron de tu caída!"
,"32":"Desdichadas las ciudades,a las que sirvieron tus hijos, desdichada la que a tus hijos recibió."
,"33":"Pues como se alegró de tu caída,y festejó tu ruina, así se afligirá por su propia devastación."
,"34":"Yo le quitaré la alegría de su abundante población,y su júbilo se convertirá en luto."
,"35":"Un fuego caerá sobre ella,de parte del eterno por muchos días, y será morada de demonios mucho tiempo."
,"36":"Vuelve tus ojos al oriente, Jerusalén, y contempla el gozo que te viene de Dios."
,"37":"Mira, vuelven tus hijos, los que viste partir; vuelven reunidos desde oriente a occidente, por la palabra del santo, alegres de la gloria de Dios."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Jerusalén, quítate tu ropa,de luto y aflicción,y vístete para siempre,la magnificencia de la gloria,que te viene de Dios."
,"2":"Ponte el manto de la justicia de Dios, corona tu cabeza con la diadema de gloria del eterno,"
,"3":"porque Dios mostrará tu esplendor,a todas las naciones que hay bajo el cielo,"
,"4":"porque Dios te dará este nombre para siempre: 'Paz de la justicia',y 'Gloria de la piedad'."
,"5":"Levántate, Jerusalén, sube a lo alto, vuelve tus ojos hacia oriente,y mira a tus hijos reunidos,del oriente al occidente,por la palabra del santo, alegres del recuerdo de Dios."
,"6":"Salieron de ti marchando a pie, llevados por los enemigos, pero el Señor te los devuelve traídos con honor, como en un trono real."
,"7":"Porque Dios ha ordenado,que sean rebajados todo monte elevado,y los collados eternos, y colmados los valles,hasta allanar la tierra, para que Israel camine segura,bajo la gloria de Dios."
,"8":"Y hasta las selvas y todo árbol aromático,harán sombra a Israel, por orden de Dios."
,"9":"Porque Dios guiará a Israel con alegría, a la luz de su gloria, escoltándolo con su misericordia y su justicia."
}`)
	CurrentBook.AddChapter(6, `{
"0":"Copia de la carta que mandó Jeremías a los que iban a ser deportados a Babilonia por el rey de los babilonios, para informarles de lo que Dios le había encomendado."
,"1":"Por los pecados que habéis cometido delante de Dios vais a ser llevados cautivos a Babilonia por Nabucodonosor, rey de los babilonios."
,"2":"Una vez llegados a Babilonia, estaréis allí durante largos años, mucho tiempo, hasta siete generaciones; después de lo cual yo os sacaré de allí en paz."
,"3":"Vais a ver en Babilonia dioses de plata, de oro y de madera, que son llevados a hombros y que meten miedo a los paganos."
,"4":"Estad en guardia: no hagáis como esos extranjeros, no os dejéis asustar por esos dioses,"
,"5":"cuando veáis multitudes delante y detrás de ellos adorándolos, decid interiormente: 'A ti sólo se debe adoración, Señor'."
,"6":"Porque mi ángel está con vosotros; él tendrá cuidado de vuestras vidas."
,"7":"Porque la lengua de esos dioses ha sido limada por el artífice y ellos, por más dorados y plateados que estén, son pura farsa y no pueden hablar."
,"8":"Como para una muchacha presumida, así se toma oro y se hacen coronas para la cabeza de esos dioses."
,"9":"A veces los sacerdotes roban a sus dioses oro y plata para sus propios gastos, e incluso pagan con ello a las prostitutas del templo."
,"10":"Adornan también con lujosos vestidos, como si fuesen hombres, a sus dioses de plata, de oro y de madera; pero éstos no se libran ni de la roña ni de los gusanos,"
,"11":"por más que estén vestidos de púrpura. Tienen que limpiarles también la cara del polvo del templo que se acumula en ellos."
,"12":"Entre ellos hay quien empuña el cetro, como un gobernador de provincia, pero no podría matar a quien le ofende."
,"13":"Otro tiene en su diestra espada y hacha, pero no puede defenderse de la guerra o de los ladrones."
,"14":"Por donde se puede ver que no son dioses. Por tanto, no les tengáis miedo."
,"15":"Lo mismo que un vaso que se usa se hace inservible cuando se rompe, así son sus dioses colocados en el templo."
,"16":"Sus ojos están llenos del polvo levantado por los pies de los que entran."
,"17":"Como a uno que ha ofendido al rey y está para ser ajusticiado se lo tiene bien encerrado por todas partes, así los sacerdotes aseguran los templos de estos dioses con puertas, cerrojos y trancas, para que no sean saqueados por los ladrones."
,"18":"Les encienden lámparas y en número mayor que para ellos mismos; pero de ellas los dioses no ven ni una sola."
,"19":"Les pasa lo mismo que a las vigas del templo, cuyo interior, como dicen, está carcomido por la polilla. A los gusanos que suben del suelo y los devoran a ellos y sus vestidos no los sienten."
,"20":"Sus caras están ennegrecidas por el humo del templo."
,"21":"Sobre su cuerpo y sus cabezas revolotean las lechuzas, los vencejos y otros pájaros; también tienen gatos encima."
,"22":"Por donde se puede ver que no son dioses. ¡No les tengáis miedo!"
,"23":"El oro mismo que los reviste para embellecerlos no brillaría si no hubiera quien les limpiara la herrumbre. Ni cuando eran fundidos se daban cuenta."
,"24":"A precios fabulosos fueron comprados esos dioses en los que no hay soplo de vida."
,"25":"Al no tener pies, son llevados a hombros, exhibiendo a los hombres su propia ignominia. Y quedan también avergonzados sus servidores; porque si aquéllos caen en tierra, tienen que ser ellos los que los levanten."
,"26":"Si se les pone derechos, no pueden moverse por sí mismos; si se les inclina, no logran enderezarse solos; como delante de cadáveres, se les presentan las ofrendas."
,"27":"Las ofrendas que les hacen, los sacerdotes las venden para su provecho, otra parte la ponen en conserva sus mujeres, sin repartir nada al pobre y al enfermo. Y las mujeres que acaban de dar a luz y las que están en estado de menstruación tocan esas ofrendas."
,"28":"Claro está, por tanto, que no son dioses; así que no los temáis."
,"29":"Y ¿cómo pueden llamarse dioses? Son mujeres las que presentan ofrendas ante estos dioses de plata, de oro y de madera."
,"30":"Y en sus templos los sacerdotes están sentados, con las túnicas desgarradas, las cabezas y las barbas rapadas y con la cabeza descubierta;"
,"31":"vocean y chillan delante de sus dioses como se hace en un banquete fúnebre."
,"32":"Los sacerdotes toman las ropas de sus dioses para vestir a sus mujeres y a sus hijos."
,"33":"Si se les hace algún bien o algún mal no pueden dar el pago correspondiente. Ni pueden poner ni quitar rey."
,"34":"Tampoco son capaces de dar ni riquezas ni dinero. Si alguien les hace una promesa y no la cumple, no pueden pedir cuentas."
,"35":"Son incapaces de librar a un hombre de la muerte o de arrancar al débil de las garras del prepotente."
,"36":"No pueden devolver la vista al ciego ni librar al que se halla en la miseria."
,"37":"No sienten compasión de la viuda ni favorecen al huérfano."
,"38":"A los peñascos del monte se parecen esos dioses de madera, dorados o plateados; sus servidores quedarán avergonzados."
,"39":"¿Cómo, pues, se puede pensar o decir que son dioses?"
,"40":"Los mismos caldeos los desacreditan: cuando ven a un mudo que no puede hablar, se lo presentan a Bel, pidiéndole que le haga hablar; ¡como si este dios pudiera oír!"
,"41":"Y son incapaces de darse cuenta de esto y de abandonar a sus dioses, ¡tan insensatos son!"
,"42":"Las mujeres ceñidas de cuerdas se sientan junto a los caminos quemando como incienso el salvado;"
,"43":"y cuando una de ellas, solicitada por algún transeúnte, se acuesta con él, reprocha a su vecina no haber sido escogida como ella y de que su cuerda no haya sido rota."
,"44":"Así todo lo que se hace en honor de ellos es embuste. ¿Cómo, pues, se puede pensar o decir que son dioses?"
,"45":"Han sido hechos por artesanos y orfebres, y no son otra cosa que lo que sus artífices quieren que sean."
,"46":"Los mismos autores no duran mucho tiempo; por tanto, ¿cómo van a ser dioses los fabricados por ellos?"
,"47":"Sólo mentira y vergüenza han dejado a su posteridad."
,"48":"Cuando sobreviene una guerra o alguna calamidad, los sacerdotes andan pensando dónde refugiarse con sus dioses."
,"49":"¿Cómo, pues, no comprender que no son dioses los que no pueden salvarse de la guerra y de las calamidades?"
,"50":"No siendo otra cosa que madera, dorada o plateada, fácilmente se puede deducir de aquí que no son más que mentira. Para todos, naciones y reyes, resultará claro que no son dioses, sino hechura de manos de hombres, y que en ellos no hay ninguna operación divina."
,"51":"¿A quién, pues, no parecerá evidente que no son dioses?"
,"52":"No pueden establecer un rey en un país, ni dar a los hombres la lluvia."
,"53":"No saben hacer justicia ni evitar la injusticia, pues no pueden nada; son como cornejas entre el cielo y la tierra."
,"54":"Y si llega a prenderse fuego el templo de esos dioses de madera, dorados o plateados, sus sacerdotes escaparán y se pondrán a salvo; pero ellos se quedarán como postes, presa de las llamas."
,"55":"Tampoco pueden resistir a un rey ni a un ejército enemigo."
,"56":"¿Cómo, pues, creer o pensar que son dioses?"
,"57":"No pueden defenderse de ladrones ni de salteadores estos dioses de madera, plateados o dorados; aquéllos, más fuertes que ellos, les quitan el oro, la plata y los vestidos que los recubren, y se van con ello sin que los dioses puedan socorrerse a sí mismos."
,"58":"Mucho mejor es ser un rey que demuestra su poder o un utensilio provechoso en una casa, del cual se sirve su dueño, que no estos falsos dioses; o una puerta en una casa, que pone en seguro cuanto hay dentro de ella, que no estos falsos dioses; o un poste de madera en un palacio, que no estos falsos dioses."
,"59":"El sol, la luna y las estrellas, que brillan y cumplen su cometido, son obedientes;"
,"60":"igualmente el relámpago, cuando aparece, es bien visible; asimismo el viento sopla en todo país;"
,"61":"las nubes, cuando reciben de Dios la orden de recorrer toda la tierra, la ejecutan al punto; y el fuego, enviado de lo alto a devorar montes y bosques, cumple lo que se le ha encomendado."
,"62":"Pero estos dioses no pueden compararse a ninguna de estas cosas, ni en belleza ni en potencia."
,"63":"Así que no s puede creer ni pensar que sean dioses, cuando no pueden hacer justicia ni proporcionar bien alguno a los hombres."
,"64":"Sabiendo, pues, que no son dioses, no los temáis."
,"65":"Son incapaces de maldecir a los reyes o de bendecirlos;"
,"66":"no hacen ver a las gentes señales en el cielo, ni resplandecen como el sol, ni alumbran como la luna."
,"67":"Las mismas bestias tienen mayores posibilidades que ellos, puesto que pueden refugiarse bajo cubierto y protegerse a sí mismas."
,"68":"Por ningún lado, pues, aparece que sean dioses. Así que no los temáis."
,"69":"Como un espantajo en un melonar, que no guarda nada, así son sus dioses de madera, dorados o plateados."
,"70":"Como un espino en un huerto, en el que todos los pájaros vienen a posarse; en fin, como un muerto echado en la oscuridad, así son sus dioses de madera, dorados y plateados."
,"71":"Por la púrpura y el lino, que se pudre encima de ellos, conoceréis también que no son dioses. Finalmente, ellos mismos serán carcomidos y quedarán hechos una vergüenza en el país."
,"72":"Mucho más vale, pues, el hombre justo que no tiene ídolos; él será preservado de la vergüenza"
}`)

}
func ES_LSB_LoadVMDNChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"El año tercero del reinado de Joaquín, rey de Judá, Nabucodonosor, rey de Babilonia, fue a Jerusalén y la sitió."
,"2":"El Señor entregó en sus manos a Joaquín, rey de Judá, y una parte de los objetos del templo de Dios. Él los llevó a la tierra de Senaar y los depositó en el tesoro de sus dioses."
,"3":"El rey ordenó después a Aspenaz, jefe de los eunucos, que escogiese de entre los israelitas algunos jóvenes de estirpe real y de familia noble:"
,"4":"sin defecto alguno, de buen parecer, expertos en todos los campos del saber, inteligentes y aptos para servir en el palacio real. Ordenó también que se les enseñase la escritura y el idioma de los caldeos."
,"5":"El rey les asignó una ración diaria de la comida del monarca y del vino que él bebía. Su formación duraría tres años, al cabo de los cuales serían admitidos al servicio del rey."
,"6":"Entre éstos se encontraban los judíos Daniel, Ananías, Misael y Azarías."
,"7":"Pero el jefe de los eunucos les cambió el nombre: a Daniel le llamó Baltasar; a Ananías, Sidrac; a Misael, Misac, y a Azarías, Abdénago."
,"8":"Daniel tenía el propósito de no contaminarse con la comida del rey ni con el vino que él bebía, y suplicó al jefe de los eunucos que no le obligara a contaminarse."
,"9":"Dios concedió a Daniel favor y simpatía ante el jefe de los eunucos."
,"10":"Sin embargo, éste dijo a Daniel: 'Temo que el rey, mi señor, que ha asignado vuestra comida y vuestra bebida, os encuentre más flacos que los jóvenes de vuestra edad, y así seáis la causa de que el rey me condene a muerte'."
,"11":"Daniel dijo al inspector a quien el jefe de los eunucos había confiado el cuidado de Daniel, Ananías, Misael y Azarías:"
,"12":"'Haz una prueba con tus siervos durante diez días. Que nos den legumbres por comida y agua por bebida;"
,"13":"después puedes comparar nuestro aspecto con el de los jóvenes que comen los manjares del rey y tratar a tus siervos con arreglo a lo que hayas visto'."
,"14":"Él aceptó la propuesta y los puso a prueba durante diez días."
,"15":"Al cabo de este tiempo su rostro apareció más bello y su aspecto más rollizo que el de todos los jóvenes que comían los manjares del rey."
,"16":"Desde entonces el inspector siguió retirándoles su ración de comida y su vino y dándoles tan sólo legumbres."
,"17":"Dios concedió a aquellos cuatro jóvenes ciencia e inteligencia en materia de escritura y en sabiduría. Daniel, en particular, sabía interpretar toda clase de visiones y sueños."
,"18":"Al cabo del tiempo establecido por el rey para que le fueran presentados los jóvenes, el jefe de los eunucos los llevó ante Nabucodonosor."
,"19":"El rey se entretuvo hablando con ellos, pero entre todos los otros no encontró ninguno que pudiese compararse con Daniel, Ananías, Misael y Azarías; por eso quedaron ellos al servicio del rey."
,"20":"En todos los asuntos que requerían sabiduría e inteligencia sobre los que el rey interrogó, los encontró diez veces superiores a todos los magos y adivinos que había en su reino entero."
,"21":"Daniel permaneció en la corte hasta el año primero del rey Ciro."
}`)
	CurrentBook.AddChapter(2, `{
"1":"El año segundo de su reinado, Nabucodonosor tuvo un sueño que le preocupó tanto, que no podía dormir."
,"2":"El rey mandó llamar a los magos, adivinos, hechiceros y astrólogos para que le explicaran su sueño. Vinieron y se presentaron al rey,"
,"3":"el cual les dijo: 'He tenido un sueño y estoy preocupado por encontrar una explicación'."
,"4":"Los caldeos respondieron al rey: '¡Oh rey, vive eternamente! Cuenta el sueño a tus siervos y nosotros te daremos su interpretación'."
,"5":"El rey les respondió: 'Tened bien presente mi decisión: Si no me decís el sueño y no me dais su interpretación, seréis cortados en pedazos y vuestras casas serán reducidas a un montón de ruinas."
,"6":"Pero si me acertáis el sueño y me dais su interpretación, recibiréis de mí regalos, obsequios y grandes honores; por tanto, decidme el sueño y su interpretación'."
,"7":"Ellos replicaron: 'Cuente el rey su sueño, que nosotros le daremos su interpretación'."
,"8":"El monarca les respondió: 'Bien veo que vosotros tratáis de ganar tiempo, porque sabéis que mi decisión es irrevocable."
,"9":"Si no me acertáis el sueño, a todos os espera una misma sentencia; es que os habéis puesto de acuerdo para decirme mentiras y embustes, en espera de que cambie la situación. Por tanto, indicadme el sueño y sabré que podéis darme su interpretación'."
,"10":"Los caldeos respondieron al rey: 'No hay hombre en el mundo que pueda adivinar lo que quiere el rey. Asimismo, jamás hubo rey, gobernador o jefe que preguntase una cosa semejante a algún mago, adivino o astrólogo."
,"11":"Lo que el rey pide es difícil y no hay nadie que pueda satisfacer al rey, salvo los dioses; pero ellos no están entre los hombres'."
,"12":"Entonces el rey se encolerizó terriblemente y dio orden de matar a todos los sabios de Babilonia."
,"13":"Promulgado el decreto de matar a los sabios, fueron buscados también Daniel y sus compañeros para ejecutarlos."
,"14":"Entonces Daniel habló sabia y prudentemente a Arioc, capitán de la guardia real, que iba a matar a los sabios de Babilonia."
,"15":"Dijo a Arioc, plenipotenciario del rey: '¿Por qué un decreto tan tajante de parte del rey?'. Arioc explicó la cosa a Daniel, "
,"16":"el cual se presentó al rey implorando que le fijase un límite de tiempo, dentro del cual daría su interpretación."
,"17":"Daniel, de regreso a su casa, informó en seguida del caso a Ananías, Misael y Azarías, sus compañeros,"
,"18":"para que implorasen el favor del Dios del cielo acerca de aquel enigma y no pereciesen Daniel y sus compañeros junto con los otros sabios de Babilonia."
,"19":"El enigma fue manifestado a Daniel en una visión nocturna. Y bendijo al Dios del cielo,"
,"20":"diciendo: 'Bendito sea el nombre de Dios,por los siglos de los siglos, pues suyos son el saber y la fuerza."
,"21":"Él es quien hace cambiar tiempos y estaciones, depone a los reyes y los entroniza, da sabiduría a los sabios y ciencia,a los que saben comprender."
,"22":"Él es quien revela las cosas profundas y secretas, conoce lo que hay en las tinieblas, la luz mora junto a él."
,"23":"A ti, oh Dios de mis padres, te alabo y te doy gracias, porque me has dado sabiduría y fuerza, me has manifestado lo que habíamos pedido,y nos has dado a conocer el secreto del rey'."
,"24":"Después Daniel se presentó a Arioc, a quien el rey había encomendado el exterminio de los sabios de Babilonia, y le dijo: '¡No hagas perecer a los sabios de Babilonia! Llévame ante el rey y yo le daré la interpretación'."
,"25":"Arioc se apresuró a llevar a Daniel ante el rey, y le dijo: 'He encontrado un hombre entre los deportados de Judá que puede indicar al rey la interpretación'."
,"26":"El rey se dirigió a Daniel, a quien llamaban Baltasar, y le dijo: '¿Eres capaz de decirme el sueño que he tenido y darme su interpretación?'."
,"27":"Daniel le respondió: 'El misterio que el rey quiere saber no hay sabios ni magos, adivinos ni astrólogos que se lo puedan acertar."
,"28":"Pero hay un Dios en el cielo que revela los secretos; él ha querido manifestar al rey Nabucodonosor lo que ha de suceder en el futuro. Voy a explicar tu sueño y las visiones de tu imaginación cuando estabas en la cama."
,"29":"Oh rey, los pensamientos que te preocupaban en la cama se referían al futuro, y aquel que revela los secretos te ha dado a conocer lo que sucederá."
,"30":"En cuanto a mí, este misterio me ha sido revelado no porque yo posea una sabiduría superior a la de todos los hombres, sino con el solo objeto de indicar la interpretación al rey y de que tú comprendieras los pensamientos de tu corazón."
,"31":"Tú, oh rey, tuviste esta visión: Ante ti se levantaba una estatua muy grande, de extraordinario esplendor y de aspecto terrible."
,"32":"Su cabeza era de oro puro; el pecho y los brazos, de plata; el vientre y los muslos, de bronce;"
,"33":"las piernas, de hierro, y los pies, parte de hierro y parte de arcilla."
,"34":"Tú seguías mirando; de pronto una piedra se desprendió de un monte sin intervención humana alguna, alcanzó a la estatua en los pies de hierro y arcilla y los pulverizó."
,"35":"Entonces se hizo pedazos todo: el hierro, la arcilla, el bronce, la plata y el oro; quedaron como el tamo de la era en verano, y fueron arrebatados por el viento sin que quedara rastro alguno de ellos; en cambio, la piedra que había herido a la estatua se convirtió en un gran monte, que llenó la tierra entera."
,"36":"Tal fue el sueño. Ahora diremos ante el rey su significado."
,"37":"Tú, oh rey de reyes, a quien el Dios del cielo ha dado el imperio, la fuerza, el poder y la gloria,"
,"38":"y en cuyas manos ha dejado a los hombres, las bestias del campo y los pájaros del cielo dondequiera que habiten, y a quien ha hecho soberano sobre todos ellos, tú eres la cabeza de oro."
,"39":"Después de ti surgirá otro imperio de plata inferior al tuyo, y luego un tercer imperio, de bronce, que tendrá el dominio de toda la tierra."
,"40":"Y, finalmente, un cuarto imperio, que será fuerte como el hierro; el hierro lo aplasta y pulveriza todo; así aquél aplastará y pulverizará a todos los otros."
,"41":"En cuanto a lo que viste, que los pies y los dedos eran parte de arcilla y parte de hierro, esto significa que era un reino dividido, aunque tendrá ciertamente la consistencia del hierro, ya que viste el hierro mezclado con la arcilla;"
,"42":"y el que los dedos de los pies fueran parte de hierro y parte de arcilla quiere decir que una parte del imperio será resistente y otra parte, en cambio, frágil."
,"43":"El hecho de haber visto tú el hierro mezclado con la arcilla significa que se mezclarán entre sí por simiente humana, pero no formarán un cuerpo uno con otro, de la misma manera que el hierro no se amalgama con la arcilla."
,"44":"En los días de estos reyes, el Dios del cielo hará surgir un imperio que jamás será destruido y cuya soberanía no pasará a otro pueblo. Pulverizará y aniquilará a todos estos imperios, mientras que él subsistirá eternamente,"
,"45":"tal como has visto, que una piedra se desprendió, sin intervención humana, del monte, y pulverizó el hierro, el bronce, la arcilla, la plata y el oro. El Dios grande ha manifestado al monarca lo que sucederá en el futuro. El sueño es verdadero, y digna de fe su interpretación'."
,"46":"Entonces el rey Nabucodonosor cayó rostro en tierra y se postró ante Daniel y ordenó que le ofrecieran sacrificios e incienso."
,"47":"Después el monarca dijo a Daniel: 'Ciertamente vuestro Dios es el Dios de los dioses, el Señor de los reyes, el revelador de los misterios, ya que tú has podido descifrar este enigma'."
,"48":"El rey concedió a Daniel un alto grado, le hizo muchos regalos valiosos y le nombró gobernador de todas las provincias de Babilonia, así como jefe de todos los sabios de Babilonia."
,"49":"Luego, a propuesta de Daniel, el rey nombró administradores de la provincia a Sidrac, Misac y Abdénago. Daniel se quedó en la corte real."
}`)
	CurrentBook.AddChapter(3, `{
"1":"El rey Nabucodonosor hizo una estatua de oro, de treinta metros de alta por tres de ancha; la levantó en la llanura de Dura, en la provincia de Babilonia."
,"2":"Luego el rey Nabucodonosor dio orden de que se reuniesen los sátrapas, prefectos, gobernadores generales, tesoreros, jueces, magistrados y todas las autoridades provinciales, y asistiesen a la inauguración de la estatua que él había levantado."
,"3":"Los sátrapas, prefectos, gobernadores generales, jueces, magistrados y todas las autoridades provinciales se reunieron para la inauguración de la estatua levantada por el rey Nabucodonosor. Todos estaban en pie ante la estatua."
,"4":"Y el pregonero gritó con fuerza: 'A vosotros, pueblos, naciones y lenguas, se os hace saber:"
,"5":"En el momento en que oigáis sonar el cuerno, el pífano, la cítara, la sambuca, el salterio, la zampoña y toda clase de instrumentos musicales, os prosternaréis y adoraréis la estatua que ha levantado el rey Nabucodonosor."
,"6":"Aquellos que no se prosternen y la adoren serán al punto arrojados en un ardiente horno de fuego'."
,"7":"Con tal motivo, en cuanto se oyó sonar el cuerno, el pífano, la cítara, la sambuca, el salterio, la zampoña y toda clase de instrumentos de música, todos los pueblos, naciones y gentes de todas las lenguas se prosternaron y adoraron la estatua de oro levantada por el rey Nabucodonosor."
,"8":"Sin embargo, algunos caldeos se presentaron a acusar a los judíos."
,"9":"Y dijeron al rey Nabucodonosor: 'Oh rey, vive eternamente."
,"10":"Tú, oh rey, has decretado que todo hombre, apenas oiga sonar el cuerno, el pífano, la cítara, la sambuca, el salterio, la zampoña y toda clase de instrumentos de música, se postre y adore la estatua de oro,"
,"11":"y que aquellos que no se postren para adorarla sean arrojados en un ardiente horno de fuego."
,"12":"Pues hay algunos judíos, aquellos a quienes pusiste al frente de la administración de la provincia de Babilonia, esto es, Sidrac, Misac y Abdénago, que no te hacen caso, oh rey; no veneran a tu dios ni adoran la estatua de oro que has levantado'."
,"13":"Entonces Nabucodonosor montó en cólera y mandó traer a Sidrac, Misac y Abdénago, los cuales fueron llevados a la presencia del rey."
,"14":"Nabucodonosor les preguntó: '¿Es cierto, Sidrac, Misac y Abdénago, que no veneráis a mis dioses ni adoráis la estatua de oro que yo he levantado?"
,"15":"¿Estáis dispuestos cuando oigáis sonar el cuerno, el pífano, la cítara, la sambuca, el salterio, la zampoña y toda clase de instrumentos musicales a postraros y adorar la estatua que he hecho? Si no la adoráis, seréis inmediatamente arrojados en un ardiente horno de fuego; y ¿qué Dios os podrá librar de mis manos?'."
,"16":"Sidrac, Misac y Abdénago respondieron al rey Nabucodonosor: 'No necesitamos darte una respuesta sobre este particular."
,"17":"Si nuestro Dios, a quien nosotros veneramos, quiere librarnos del ardiente horno de fuego y de tus manos, oh rey, nos librará."
,"18":"Pero si no nos librase, has de saber, oh rey, que no serviremos a tu dios ni adoraremos la estatua de oro que has levantado'."
,"19":"Entonces Nabucodonosor, lleno de furor y con el rostro desencajado de ira contra Sidrac, Misac y Abdénago, dio orden de que se encendiese el horno siete veces más de lo corriente"
,"20":"y mandó a los hombres más fuertes de su ejército que ataran a Sidrac, Misac y Abdénago y los arrojaran al ardiente horno de fuego."
,"21":"Éstos, vestidos con sus túnicas, ropas y gorros, fueron atados y arrojados en el ardiente horno de fuego."
,"22":"Como la orden del rey era apremiante y el horno estaba muy encendido, las llamas alcanzaron y mataron a los hombres que llevaban a Sidrac, Misac y Abdénao,"
,"23":"mientras que Sidrac, Misac y Abdénago cayeron atados dentro del horno de fuego."
,"24":"Pero andaban por entre las llamas alabando a Dios y bendiciendo al Señor."
,"25":"Y Azarías, en pie en medio del fuego, oraba así:"
,"26":"'Bendito seas, Señor, Dios de nuestros padres; que tu nombre sea glorificado,por los siglos."
,"27":"Porque eres justo,en todo lo que has hecho, todas tus obras son verdad, rectos todos tus caminos, verdad todos tus juicios."
,"28":"Tú has ejecutado sentencias justas,en todos los males,que nos has mandado a nosotros,y a la ciudad santa,de nuestros padres, Jerusalén; pues tú nos has tratado así,conforme a la verdad y la justicia, a causa de nuestros pecados."
,"29":"Sí, hemos pecado, hemos obrado inicuamente,alejándonos de ti; hemos fallado en todo,y no hemos guardado tus preceptos,"
,"30":"no los hemos puesto en práctica, ni hemos obrado,como tú nos mandabas,para que todo fuese bien."
,"31":"Sí, en todo lo que has hecho caer,sobre nosotros, en todos los castigos,que nos has mandado, has obrado con perfecta justicia."
,"32":"Nos has entregado,en manos de enemigos, hombres inicuos, los peores,entre los malvados; en manos de un rey injusto, el más perverso de toda la tierra."
,"33":"Ahora no podemos abrir,nuestra boca; la vergüenza, el deshonor,son el destino,de tus siervos y de tus fieles."
,"34":"¡Oh, no nos desampares,para siempre, por amor de tu nombre, no rechaces tu alianza."
,"35":"No nos retires tu misericordia, por amor de Abrahán, tu amigo; de Isaac, tu siervo, y de Israel, tu santo,"
,"36":"a quienes prometiste,multiplicar su descendencia,como las estrellas del cielo, como la arena de las playas,del mar."
,"37":"¡Oh Señor! Somos el más pequeño,de los pueblos,y estamos humillados,en toda la tierra,por causa de nuestros pecados."
,"38":"No tenemos ya príncipe, profeta, ni caudillo, ni holocausto, ni sacrificio, ni ofrendas, ni incienso, ni lugar donde ofrecerte,las primicias"
,"39":"y alcanzar tu misericordia. Pero tenemos un corazón contrito,y un alma humillada;"
,"40":"acéptalos como holocausto,de carneros y toros, de millares de corderos cebados. Tal sea hoy nuestro sacrificio,ante ti para agradarte, pues no quedan defraudados,quienes ponen en ti su confianza."
,"41":"Y ahora te seguimos de todo corazón, te tememos y buscamos tu rostro."
,"42":"No nos dejes avergonzados; trátanos conforme a tu bondad, según tu gran misericordia."
,"43":"Líbranos con tu poder maravilloso,y da gloria a tu nombre, oh Señor."
,"44":"Y queden avergonzados,los que persiguen a tus siervos, sean cubiertos de vergüenza, derribado su imperio,y aniquilada su potencia;"
,"45":"sepan que tú eres el Señor, el Dios único, glorioso en toda la tierra'."
,"46":"Los siervos del rey que los habían echado en el horno no cesaban de atizar el fuego con nafta, pez, estopa y sarmientos."
,"47":"La llama se levantaba por encima del horno unos veinticinco metros,"
,"48":"y expandiéndose fuera abrasó a los caldeos que encontró cerca del horno."
,"49":"Pero un ángel del Señor bajó al horno junto a Ananías y sus compañeros, empujó fuera la llama"
,"50":"e hizo soplar en medio del horno como un viento fresco de rocío, y no los tocó en absoluto el fuego, ni les causó daño ni molestia alguna."
,"51":"Entonces los tres, a coro, se pusieron a cantar, glorificando y bendiciendo a Dios dentro del horno. Decían:"
,"52":"'Bendito seas, Señor, Dios de nuestros padres, alabado y ensalzado eternamente. Bendito sea tu nombre,santo y glorioso, alabado y ensalzado eternamente."
,"53":"Bendito seas en el templo,de tu santa gloria, alabado y ensalzado eternamente."
,"54":"Bendito seas en el trono,de tu reino, alabado y ensalzado eternamente."
,"55":"Bendito tú que sondeas los abismos,y te sientas sobre querubines, alabado y ensalzado eternamente."
,"56":"Bendito seas,en el firmamento del cielo, alabado y ensalzado eternamente."
,"57":"Obras todas del Señor, bendecid al Señor, alabadlo y ensalzadlo eternamente."
,"58":"Ángeles del Señor, bendecid al Señor, alabadlo y ensalzadlo eternamente."
,"59":"Cielos, bendecid al Señor, alabadlo y ensalzadlo eternamente."
,"60":"Aguas que estáis sobre los cielos, bendecid al Señor, alabadlo y ensalzadlo eternamente."
,"61":"Fuerzas todas del Señor, bendecid al Señor, alabadlo y ensalzadlo eternamente."
,"62":"Sol y luna, bendecid al Señor, alabadlo y ensalzadlo eternamente."
,"63":"Astros del cielo, bendecid al Señor, alabadlo y ensalzadlo eternamente."
,"64":"Lluvia y rocío, bendecid al Señor, alabadlo y ensalzadlo eternamente."
,"65":"Vientos todos, bendecid al Señor, alabadlo y ensalzadlo eternamente."
,"66":"Fuego y calor, bendecid al Señor, alabadlo y ensalzadlo eternamente."
,"67":"Frío y calor, bendecid al Señor, alabadlo y ensalzadlo eternamente."
,"68":"Heladas y nieves, bendecid al Señor, alabadlo y ensalzadlo eternamente."
,"69":"Frío y hielo, bendecid al Señor, alabadlo y ensalzadlo eternamente."
,"70":"Nieves y escarchas, bendecid al Señor, alabadlo y ensalzadlo eternamente."
,"71":"Noches y días, bendecid al Señor, alabadlo y ensalzadlo eternamente."
,"72":"Luz y tinieblas, bendecid al Señor, alabadlo y ensalzadlo eternamente."
,"73":"Rayos y nubes, bendecid al Señor, alabadlo y ensalzadlo eternamente."
,"74":"Que la tierra bendiga al Señor, que lo alabe,y lo ensalce eternamente."
,"75":"Montes y colinas, bendecid al Señor, alabadlo y ensalzadlo eternamente."
,"76":"Todo lo que germina en la tierra, bendecid al Señor, alabadlo y ensalzadlo eternamente."
,"77":"Fuentes, bendecid al Señor, alabadlo y ensalzadlo eternamente."
,"78":"Mares y ríos, bendecid al Señor, alabadlo y ensalzadlo eternamente."
,"79":"Cetáceos y todo,lo que se mueve en las aguas, bendecid al Señor, alabadlo y ensalzadlo eternamente."
,"80":"Aves todas del cielo, bendecid al Señor, alabadlo y ensalzadlo eternamente."
,"81":"Fieras y ganados, bendecid al Señor, alabadlo y ensalzadlo eternamente."
,"82":"Hombres todos, bendecid al Señor, alabadlo y ensalzadlo eternamente."
,"83":"Israel, bendice al Señor, alabadlo y ensalzadlo eternamente."
,"84":"Sacerdotes, bendecid al Señor, alabadlo y ensalzadlo eternamente."
,"85":"Siervos del Señor, bendecid al Señor, alabadlo y ensalzadlo eternamente."
,"86":"Espíritus y almas de los justos, bendecid al Señor, alabadlo y ensalzadlo eternamente."
,"87":"Santos y humildes de corazón, bendecid al Señor, alabadlo y ensalzadlo eternamente."
,"88":"Ananías, Azarías, Misael, bendecid al Señor, alabadlo y ensalzadlo eternamente, porque nos ha salvado de la fosa, nos ha arrancado,de la mano de la muerte, nos ha librado del horno,de llama ardiente, de en medio del fuego nos libró."
,"89":"Alabad al Señor, porque es bueno, porque es eterna su misericordia."
,"90":"Fieles del Señor, bendecid al Dios de los dioses, alabadlo y dadle gracias,porque es eterna su misericordia'."
,"91":"Entonces el rey Nabucodonosor se acercó y se quedó estupefacto; se levantó rápidamente y dijo a sus ministros: '¿No hemos echado nosotros al fuego a estos tres hombres atados?'. Respondieron al rey: 'Ciertamente, oh rey'."
,"92":"El rey añadió: 'Pues yo veo a cuatro hombres desatados que andan por medio del fuego, sin sufrir daño alguno; más aún, el aspecto del cuarto se parece a un hijo de los dioses'."
,"93":"Después Nabucodonosor se acercó a la boca del horno de fuego ardiente y dijo: '¡Sidrac, Misac y Abdénago, siervos del Dios altísimo, salid fuera y venid aquí!'. Sidrac, Misac y Abdénago salieron del fuego. "
,"94":"Los sátrapas, prefectos, gobernadores y ministros se acercaron y comprobaron que el fuego no había hecho ningún mal a la persona de aquellos jóvenes y que ni siquiera un pelo de su cabeza se había quemado, ni sus vestidos se habían alterado; más aún, ni el olor del fuego había quedado en ellos."
,"95":"Nabucodonosor entonces exclamó: '¡Bendito sea el Dio de Sidrac, Misac y Abdénago, el cual ha mandado a su ángel a librar a sus siervos, que confiaron en él y desobedecieron la orden del rey, exponiendo su vida, por no postrarse a adorar a ningún otro fuera de su Dios!"
,"96":"Por tanto, yo ordeno que todo el que blasfeme contra el Dios de Sidrac, Misac y Abdénago, de cualquier pueblo, nación o lengua, que sea cortado en pedazos y su casa hecha un montón de escombros, porque no hay ningún dios que pueda salvar como éste'."
,"97":"En consecuencia, el rey exaltó aún más la condición de Sidrac, Misac y Abdénago en la provincia de Babilonia."
,"98":"'El rey Nabucodonosor a todos los pueblos, naciones y gentes de todas las lenguas que habitan en la tierra: ¡Que vuestra paz sea grande!"
,"99":"Me ha parecido bien daros a conocer los prodigios y maravillas que ha hecho conmigo el Dios altísimo."
,"100":"¡Grandes son sus prodigios, poderosas sus maravillas; su reino es un reino eterno, su imperio dura por todas las edades!"
}`)
	CurrentBook.AddChapter(4, `{
"1":"Yo, Nabucodonosor, estaba tranquilo en mi casa, viviendo felizmente en mi palacio,"
,"2":"cuando tuve un sueño que me asustó, y los pensamientos que me asaltaron estando en la cama y las visiones de mi imaginación me dejaron turbado."
,"3":"Entonces promulgué la orden de que se presentaran ante mí todos los sabios de Babilonia, a fin de que me diesen la interpretación del sueño."
,"4":"Los magos, adivinos, caldeos y astrólogos vinieron y yo les conté mi sueño, pero no supieron darme una explicación."
,"5":"Finalmente vino a mi presencia Daniel, llamado Baltasar según el nombre de mi Dios, hombre en quien está el espíritu del Dios santo, y le conté el sueño."
,"6":"Baltasar, jefe de los magos, yo sé que el espíritu del Dios santo mora en ti y ningún secreto ofrece para ti dificultad: Ésta es la visión que he tenido; dame su interpretación."
,"7":"Ésta era la visión de mi espíritu, en mi cama. Yo veía en medio de la tierra un árbol de impresionante altura."
,"8":"El árbol creció, se hizo robusto; su copa tocaba el cielo; se le veía desde todos los confines de la tierra."
,"9":"Su ramaje era hermoso, abundante su fruto, había en él comida para todos; a su sombra se cobijaban las bestias de los campos, en sus ramas hacían nidos los pájaros del cielo,y de él se alimentaba todo ser viviente."
,"10":"Yo contemplaba en mi cama las visiones de mi mente. De pronto bajó del celo un vigilante, un santo,"
,"11":"el cual gritó fuertemente: ¡Derribad el árbol, cortad sus ramas, desmochad su ramaje, desparramad sus frutos, retírense las bestias de su sombra,y los pájaros de sus ramas!"
,"12":"Pero dejad en tierra el tocón con sus raíces; sea atado con cadenas de hierro y bronce,entre la hierba del campo. Caiga sobre él el rocío del cielo, comparta con las bestias salvajes la hierba del suelo."
,"13":"Su corazón dejará de ser un corazón de hombre; se le dará un corazón de bestia. Después pasarán por él siete períodos."
,"14":"Ésta es la sentencia que dictan los vigilantes, la orden decidida por los santos, a fin de que sepan los vivientes,que el altísimo domina sobre el imperio de los hombres; a quien quiere se lo da y eleva a él,al más humilde de los hombres."
,"15":"Tal es el sueño que he tenido yo, el rey Nabucodonosor. Y tú, Baltasar, indícame su interpretación, ya que los sabios de mi reino no fueron capaces de darme una explicación, mientras que tú eres capaz, porque en ti mora el espíritu del Dios santo'."
,"16":"Daniel, a quien llamaban Baltasar, quedó turbado y aturdido un rato; sus pensamientos le atormentaban. Pero el rey rompió el silencio y dijo: 'Baltasar, no te asuste el sueño ni su interpretación'. Baltasar le dijo: '¡Oh mi Señor, ojalá el sueño se volviera contra los que te odian y su significado contra los enemigos!"
,"17":"El árbol visto por ti, que se hizo grande y robusto, tan alto que llegaba hasta el cielo y era visible en toda la tierra,"
,"18":"cuyo follaje era hermoso y abundantes los frutos, suficientes para alimentar a todos, bajo el cual se cobijaban las bestias del campo y en cuyas ramas anidaban los pájaros del cielo,"
,"19":"eres tú, oh rey, que te has hecho grande y poderoso, tanto que tu grandeza ha crecido y ha llegado hasta el cielo y tu poder hasta los confines del mundo."
,"20":"El rey ha visto también bajar del cielo un vigilante, un santo, que decía: Derribad el árbol y hacedlo trozos, pero dejad el tocón con sus raíces en la tierra y sea atado entre la hierba del campo con cadenas de bronce y hierro, bañado por el rocío del cielo y comparta la suerte con los animales salvajes hasta que hayan pasado por él siete períodos."
,"21":"Éste es, oh rey, el significado de la visión, que es una sentencia del altísimo sobre mi señor el rey:"
,"22":"Serás expulsado de entre los hombres y tendrás tu morada con las bestias salvajes; hierba como los bueyes tendrás por comida y serás bañado por el rocío del cielo. Siete períodos pasarán así por ti, hasta que reconozcas que el altísimo tiene poder sobre el imperio de los hombres y se lo da a quien quiere."
,"23":"En cuanto a la orden de dejar el tocón del árbol y sus raíces, quiere decir que tu reino se te conservará una vez que hayas reconocido que todo poder proviene del cielo."
,"24":"Por tanto, oh rey, acepta mi consejo: Redime tus pecados mediante la justicia, y tu iniquidad con la misericordia para con los pobres. Tal vez así lograrás alargar tu prosperidad'."
,"25":"Todo lo dicho le sobrevino al rey Nabucodonosor."
,"26":"Doce meses después, paseando por su palacio real de Babilonia,"
,"27":"el rey se decía: '¿No es ésta la gran Babilonia que yo he edificado para residencia real con mi inmenso poder y para gloria de mi majestad?'."
,"28":"Aún tenía el rey la palabra en la boca, cuando se oyó una voz del cielo: 'A ti te hablo, Nabucodonosor; se te ha quitado el imperio;"
,"29":"serás expulsado de la sociedad humana e irás a vivir con las bestias salvajes. Te alimentarás de hierba como los bueyes y pasarán por ti siete períodos, hasta que reconozcas que el altísimo tiene poder sobre el imperio de los hombres y se lo da a quien quiere'."
,"30":"La sentencia contra Nabucodonosor se ejecutó inmediatamente: fue expulsado de la sociedad humana, comenzó a comer hierba como los bueyes y su cuerpo fue bañado por el rocío del cielo hasta que sus cabellos llegaron a crecerle como las plumas del águila y las uñas como las de las aves."
,"31":"'Transcurrido aquel tiempo, yo, Nabucodonosor, alcé mis ojos al cielo y la razón volvió a mí; entonces bendije al altísimo, alabando y glorificando al que vive eternamente, a aquel cuyo reino es un reino eterno, cuyo imperio perdura de generación en generación."
,"32":"Ante él todos los habitantes de la tierra no valen nada; él hace lo que quiere con las milicias de los cielos y con los habitantes de la tierra. No hay nadie que pueda detener su mano, o le diga: ¿Qué haces?"
,"33":"En aquel momento mi razón volvió a mí y, para gloria de mi reino, me fue devuelta mi majestad y mi esplendor. Mis consejeros y mis magnates vinieron a buscarme; se me restableció en mi reino y me fue dado un poder aún mayor."
,"34":"Ahora yo, Nabucodonosor, alabo, ensalzo y glorifico al rey del cielo, porque todas sus obras son verdad, todos sus caminos son justicia y porque sabe humillar a los que proceden con orgullo'."
}`)
	CurrentBook.AddChapter(5, `{
"1":"El rey Baltasar convidó a un gran festín a mil de sus dignatarios, y en su presencia se dio a beber vino."
,"2":"Animado por el vino, Baltasar mandó traer las copas de oro y plata que su padre Nabucodonosor se había llevado del templo de Jerusalén, para que bebieran en ellas el rey, sus dignatarios, sus mujeres y sus concubinas."
,"3":"Trajeron las copas de oro y plata, robadas en el santuario del templo de Dios, en Jerusalén, y bebieron en ellas el rey, sus dignatarios, sus mujeres y sus concubinas."
,"4":"Bebían vino y celebraban a sus dioses de oro y plata, de bronce, hierro, madera y piedra."
,"5":"De pronto aparecieron los dedos de una mano humana, que se pusieron a escribir, delante del candelabro, en la pared del palacio real. El rey, al ver la mano que escribía,"
,"6":"mudó de color y le asaltaron terribles pensamientos; se le relajaron las articulaciones de sus caderas y sus rodillas se pusieron a temblar una contra otra."
,"7":"El rey gritó con fuerza que trajeran a los adivinos, los magos y los astrólogos; en cuanto llegaron les dijo: 'El que lea ese escrito y me dé su interpretación será vestido de púrpura, se le pondrá al cuello un collar de oro y será el tercero en el gobierno del reino'."
,"8":"Todos los sabios del rey se acercaron, pero no lograron leer lo escrito ni dar al rey una explicación."
,"9":"Entonces el rey Baltasar se llenó de miedo y su semblante mudó de color; también sus dignatarios quedaron desconcertados."
,"10":"La reina, enterada de las palabras del rey y de sus dignatarios, entró en la sala del convite, rompió el silencio y dijo: '¡Oh rey, vive eternamente! No te turben tus pensamientos ni se te mude el color del semblante."
,"11":"Hay en tu reino un hombre en quien mora el espíritu del Dios santo. Ya en tiempo de tu padre demostró tener una intuición, una inteligencia y una sabiduría semejante a la de los dioses, tanto que el rey Nabucodonosor, tu padre, le nombró jefe de los magos, los adivinos, los caldeos y los astrólogos."
,"12":"En efecto, en Daniel, a quien el rey puso el nombre de Baltasar, se encontró un espíritu superior, una inteligencia, una intuición especial para comprender sueños, descifrar enigmas y resolver dificultades. Llamad, pues, a Daniel, que él dará la interpretación'."
,"13":"Daniel fue llevado ante el rey, el cual le dijo: '¿Así que tú eres Daniel, uno de los judíos deportados, que el rey mi padre trajo de Judea?"
,"14":"He oído decir que tú posees el espíritu de Dios y que tienes una intuición, una inteligencia y una sabiduría extraordinarias."
,"15":"Hace un momento acaban de ser traídos a mi presencia los sabios y los magos para que leyeran este escrito y me dieran su interpretación, y no han sido capaces de descifrarlo."
,"16":"Pero yo he oído decir que tú eres capaz de dar interpretaciones y resolver dificultades. Si logras leer el escrito y me indicas su significado, serás vestido de púrpura, llevarás al cuello un collar de oro y serás el tercero en el gobierno del reino'."
,"17":"Entonces Daniel respondió al rey: 'Quédate con tus regalos y da tus obsequios a otro; yo leeré igualmente al rey el escrito y le manifestaré su significado."
,"18":"Oh rey, el Dios altísimo dio a tu padre Nabucodonosor el reino, el poder, la majestad y la gloria;"
,"19":"y por este poder que le dio, todos los pueblos, naciones y lenguas temblaban y se estremecían en su presencia. Él mataba a quien quería, dejaba vivir a quien quería, a quien quería exaltaba y humillaba a quien quería."
,"20":"Pero tan pronto como se ensoberbeció su corazón y su espíritu se obstinó en el orgullo, fue depuesto de su trono real y se le quitó su gloria."
,"21":"Fue expulsado de la sociedad de los hombres; su corazón fue hecho semejante al de las bestias y fue a convivir con los asnos salvajes; se le dio de comer hierba como a los toros, y su cuerpo se humedeció con rocío del cielo, hasta que reconoció que el Dios altísimo tiene poder sobre el imperio de los hombres y pone en él a quien quiere."
,"22":"Y tú, Baltasar, hijo suyo, tampoco has conservado humilde tu corazón, a pesar de que sabías todo esto;"
,"23":"más aún, te has levantado contra el Señor del cielo: has mandado traer las copas de su templo, y tú, tus dignatarios, tus mujeres y tus concubinas habéis bebido vino en ellas. Has celebrado a los dioses de oro y plata, de bronce, hierro, madera y piedra, que no ven, ni oyen, ni entienden, pero no has glorificado al Dios que tiene en sus manos tu propio aliento y todos tus caminos."
,"24":"Fue él quien mandó esa mano que trazó estas palabras."
,"25":"Ésta es, pues, la escritura trazada: Mené, Teqel y Parsín,"
,"26":"y éste su significado: Mené: Dios ha contado tu reino y le ha puesto fin;"
,"27":"Teqel: Has sido pesado en la balanza y encontrado falto de peso."
,"28":"Parsín: Tu imperio ha sido dividido y entregado a los medos y los persas'."
,"29":"Entonces Baltasar ordenó que se le pusiera a Daniel un vestido de púrpura y un collar de oro al cuello, y se proclamó que quedaba constituido el tercero en el gobierno del reino."
,"30":"Aquella misma noche Baltasar, rey de los caldeos, fue asesinado."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Y recibió el reino Darío el medo, a la edad de sesenta y dos años."
,"2":"Darío decidió establecer en el gobierno de las provincias ciento veinte sátrapas y distribuirlos por todo el reino,"
,"3":"poniendo al frente de ellos tres ministros, uno de los cuales era Daniel. Los sátrapas debían rendir cuentas de los asuntos a los tres ministros, de suerte que el monarca no sufriera perjuicio."
,"4":"Daniel se distinguía entre los ministros y los sátrapas por estar dotado de un espíritu superior, tanto que el rey pensaba darle una autoridad sobre todo el reino."
,"5":"Por ello los ministros y los sátrapas se pusieron a buscar un pretexto para poder acusar a Daniel de algún asunto de la administración del reino; pero no lograban encontrar ningún motivo de censura o falta alguna, porque él era leal y jamás se le pudo acusar de negligencia ni de culpa alguna."
,"6":"Entonces aquellos hombres se dijeron: 'No encontraremos contra Daniel ningún motivo de acusación si no lo buscamos en lo que respecta a la ley de su Dios'."
,"7":"Y los ministros y los sátrapas, después de reunirse, se presentaron al rey y le dijeron: '¡Rey Darío, vive eternamente!"
,"8":"Todos los jefes del reino, prefectos y sátrapas, ministros y gobernadores, han llegado a la conclusión de que debe promulgarse el siguiente decreto real que tenga valor de ley: Todo el que en el espacio de treinta días dirija una oración a cualquier dios u hombre, fuera de ti, oh rey, será arrojado en el foso de los leones."
,"9":"Oh rey, promulga esta prohibición y firma el documento para que sea irreformable, conforme a la ley de los medos y los persas, que es irrevocable'."
,"10":"El rey Darío, siguiendo el consejo, firmó el documento de prohibición."
,"11":"En cuanto Daniel se enteró de que había sido firmado el documento, se fue a su casa. Tenía ventanas en su cuarto superior abiertas en dirección a Jerusalén, y tres veces al día se ponía de rodillas para orar y dar gracias a su Dios; así lo había hecho siempre hasta aquel día."
,"12":"Entonces aquellos hombres vinieron en masa y sorprendieron a Daniel orando y suplicando a su Dios."
,"13":"En seguida se presentaron al rey y le dijeron a propósito del decreto de prohibición: '¿No has firmado una prohibición que todo el que en el espacio de treinta días dirija una oración a cualquier dios u hombre fuera de ti, oh rey, sea arrojado en la fosa de los leones?'. El rey respondió: 'Sí, así está establecido según la ley de los medos y los persas, que es irrevocable'."
,"14":"'Pues bien -respondieron-, Daniel, ese deportado de Judá, no hace caso ni de ti, oh rey, ni de la prohibición que has firmado, sino que tres veces al día hace su oración'."
,"15":"Al oír esto, el rey se afligió mucho y se propuso salvar a Daniel; hasta la puesta del sol estuvo buscando el modo de librarlo."
,"16":"Pero aquellos hombres se presentaron atropelladamente ante el rey y le dijeron: 'No olvides, oh rey, que, según la ley de los medos y los persas, ninguna prohibición o edicto que haya dado el rey puede ser revocada'."
,"17":"Entonces el rey tuvo que ordenar que Daniel fuese traído y arrojado en el foso de los leones. El rey dijo a Daniel: 'Tu Dios, a quien sirves con tanta perseverancia, podrá salvarte'."
,"18":"Trajeron una piedra y la colocaron en la boca del foso; y el rey la selló con su anillo y con el anillo de sus dignatarios, con el fin de que no pudiese ser mudada la suerte de Daniel."
,"19":"Después el rey volvió a su palacio y pasó la noche en ayuno sin permitir que vinieran con él las concubinas, y el sueño huyó de sus ojos."
,"20":"Por la mañana, al rayar el alba, el rey se levantó y marchó precipitadamente al foso de los leones."
,"21":"Al llegar junto a él, llamó a Daniel con voz angustiada, gritando: 'Daniel, siervo del Dios vivo; tu Dios, a quien sirves con tanta fidelidad, ¿ha logrado librarte de los leones?'."
,"22":"Daniel respondió al rey: '¡Oh rey, vive eternamente!"
,"23":"Mi Dios ha mandado a su ángel, que ha cerrado la boca de los leones, y no me han hecho ningún mal, porque soy inocente a sus ojos; y tampoco ante ti, oh rey, he cometido falta alguna'."
,"24":"Entonces el rey se alegró enormemente y mandó sacar a Daniel del foso. Sacaron a Daniel del foso, y no se le encontró lesión alguna porque había confiado en su Dios."
,"25":"El rey ordenó que fueran traídos y arrojados al foso de los leones aquellos hombres que habían calumniado a Daniel, ellos, sus mujeres y sus hijos. Y aún no habían tocado el suelo del foso, cuando los leones se lanzaron sobre ellos y trituraron todos sus huesos."
,"26":"El rey Darío escribió entonces a todos los pueblos, naciones y lenguas que habitan en toda la tierra: 'Vuestra paz sea muy grande."
,"27":"He dado la orden de que en todos los dominios de mi reino tiemblen todos y teman ante el Dios de Daniel: Porque él es el Dios vivo, que existe por los siglos; su reino no será jamás destruido y su imperio no tendrá fin."
,"28":"El que salva y libera, obra prodigios y maravillas,en el cielo y en la tierra; el que ha salvado a Daniel de las garras de los leones'."
,"29":"Así Daniel vivió en gran honor en el reinado de Darío y en el reinado de Ciro el persa."
}`)
	CurrentBook.AddChapter(7, `{
"1":"El año primero de Baltasar, rey de Babilonia, Daniel, mientras estaba en la cama, tuvo un sueño y pasaron por su espíritu unas visiones. En seguida puso por escrito el sueño."
,"2":"Daniel tomó la palabra y dijo: 'Veía yo en visiones durante la noche que los cuatro vientos del cielo agitaban el mar grande;"
,"3":"y que cuatro bestias enormes, diferentes una de otra, salían del mar."
,"4":"La primera era como un león con alas de águila. Vi que le arrancaron las alas, la levantaron de la tierra y la incorporaron como un hombre y le dieron un corazón humano."
,"5":"Después de ésta apareció otra bestia, la segunda, semejante a un oso; iba levantada de un lado y tenía tres costillas en las fauces entre sus dientes; y le dijeron: ¡Ea, devora mucha carne!"
,"6":"Después vi otra bestia, como un leopardo, con cuatro alas de ave en su dorso; tenía también cuatro cabezas y le fue dado el poder."
,"7":"A continuación, y siempre en mi visión nocturna, vi una cuarta bestia terrible, espantosa, extraordinariamente fuerte. Tenía enormes dientes de hierro, comía y trituraba, y lo sobrante lo pisoteaba con sus patas; era diferente de todas las otras bestias que la habían precedido y tenía diez cuernos."
,"8":"Yo miraba los cuernos y observé que de en medio de ellos despuntaba otro cuerno, y que tres de los diez precedentes le eran arrancados para dar cabida a aquél. Vi también que el nuevo cuerno tenía ojos como los de un hombre y una boca que decía cosas monstruosas."
,"9":"Yo seguía observando: se instalaron unos tronos, y un anciano se sentó. Sus vestiduras eran blancas como la nieve; como lana pura el cabello de su cabeza; su trono era de llamas, con ruedas de fuego ardiente."
,"10":"Un río de fuego manaba y salía delante de él. Miles de millares le servían, millones y millones estaban de pie en su presencia. El tribunal se sentó y los libros se abrieron."
,"11":"Yo seguía mirando, atraído por el ruido de las palabras monstruosas que aquel cuerno profería, hasta que mataron a la bestia, la descuartizaron y la arrojaron a las llamas ardientes."
,"12":"En cuanto a las otras bestias, fueron privadas del poder; pero se les concedió un período de vida, durante un tiempo y una fecha determinada."
,"13":"Yo seguía contemplando en mis visiones nocturnas: En las nubes del cielo venía uno como un hijo de hombre; se dirigió hacia el anciano y se presentó ante él."
,"14":"Se le dio poder, gloria e imperio, y todos los pueblos, naciones y lenguas le servían. Su poder era un poder eterno, que nunca pasará, y su reino no será destruido jamás."
,"15":"Yo, Daniel, quedé profundamente turbado y las visiones que contemplé me dejaron asustado."
,"16":"Me acerqué a uno de los que estaban allí de pie y le rogué que me informara del sentido de todo aquello. Él me respondió y me indicó la interpretación de las visiones:"
,"17":"Estas cuatro bestias enormes son cuatro reyes, que aparecerán sobre la tierra;"
,"18":"pero después recibirán el reino los santos del altísimo y lo poseerán por siempre, eternamente."
,"19":"Entonces quise saber la verdad sobre la cuarta bestia, que era diferente de las otras, extraordinariamente terrible, con dientes de hierro y uñas de bronce, que comía y trituraba y lo sobrante lo pisoteaba con sus patas."
,"20":"Pregunté también acerca de los diez cuernos que había en su cabeza y del cuerno que despuntó y ante el cual habían caído tres, de aquel cuerno que tenía ojos y una boca que profería palabras monstruosas y que aparecía mayor que los otros cuernos."
,"21":"Había observado además que este cuerno hacía la guerra contra los santos y los vencía,"
,"22":"hasta que vino el anciano y se hizo justicia a los santos del altísimo, llegando finalmente el tiempo en que los santos tomaron posesión del reino."
,"23":"Él me respondió: La cuarta bestia significa que vendrá al mundo un cuarto reino, distinto de los otros, el cual devorará toda la tierra, la pisoteará, y la triturará."
,"24":"Los diez cuernos significan que de este reino surgirán diez reyes, y que después de ellos surgirá otro, distinto de los precedentes, que derribará a tres de ellos."
,"25":"Proferirá palabras monstruosas contra el altísimo, perseguirá a los santos del altísimo y tratará de cambiar festividades y leyes. El pueblo santo será entregado en su poder por un tiempo, dos tiempos y medio tiempo."
,"26":"Después el tribunal se sentará para juzgar y le quitará el poder para que sea exterminado y aniquilado para siempre."
,"27":"Y el reino, el poder y la grandeza de los reinos que hay bajo todo el cielo serán entregados al pueblo de los santos del altísimo; su reino será un reino eterno y todos los imperios le servirán y estarán sujetos a él."
,"28":"Aquí termina la relación. Yo, Daniel, quedé turbado por estos pensamientos y se me demudó el color del rostro. Pero lo guardé todo en mi corazón."
}`)
	CurrentBook.AddChapter(8, `{
"1":"El año tercero del reinado de Baltasar, yo, Daniel, tuve una segunda visión después de la precedente."
,"2":"Cuando tenía la visión me encontraba en Susa, plaza fuerte de la provincia de Elán, a orillas del río Ulay."
,"3":"Alcé los ojos, y vi un carnero que estaba delante del río: tenía dos cuernos, uno más alto que otro. El más alto había despuntado más tarde."
,"4":"Vi que el carnero acometía contra el oeste, el norte y el sur; ningún animal podía resistirlo ni librarse de su poder; hacía todo lo que quería, y así se crecía."
,"5":"Luego vi que un macho cabrío venía de occidente, recorriendo toda la superficie de la tierra sin tocar el suelo; el macho cabrío tenía un cuerno bien visible entre los ojos."
,"6":"Se acercó al carnero de dos cuernos que yo había visto situado delante del río, y se abalanzó contra él con todo el furor de su fuerza."
,"7":"Vi cómo alcanzó al carnero, cómo lo embistió, ebrio de cólera, y le quebró los dos cuernos, sin que el carnero tuviera fuerzas para hacerle frente; lo tumbó en tierra, lo pisoteó y no hubo quien librara al carnero vencido."
,"8":"Luego el macho cabrío se hizo extraordinariamente poderoso; pero cuando estaba en la cúspide de su poder, su gran cuerno se partió y, en su lugar, despuntaron otros cuatro bien visibles, hacia los cuatro vientos del cielo."
,"9":"De uno de ellos, el más pequeño, salió además otro cuerno, que creció enormemente en dirección del mediodía, del oriente y de la tierra santa."
,"10":"Se elevó hasta las milicias del cielo, hizo caer a tierra muchas estrellas y las pisoteó con sus pies."
,"11":"Llegó hasta el mismo príncipe de las milicias, suprimió su sacrificio cotidiano y derribó su santuario."
,"12":"En lugar del sacrificio cotidiano puso la perversidad y tiró por tierra la verdad. Así logró actuar con éxito."
,"13":"Oí entonces a un santo que hablaba y a otro santo que preguntaba al que estaba hablando: ¿Hasta cuándo durará lo que anuncia la visión: el sacrificio cotidiano, la perversidad desoladora, el santuario y las milicias pisoteados?"
,"14":"Le respondió: Hasta dos mil trescientas tardes y mañanas; después será restablecido el santuario."
,"15":"Mientras yo, Daniel, contemplaba la visión y trataba de comprenderla, vi que se situó ante mí uno, en forma de hombre,"
,"16":"y oí una voz humana sobre el Ulay que gritaba: Gabriel, explícale a éste la visión."
,"17":"Gabriel se llegó donde yo estaba. Cuando se acercó, quedé espantado y caí de bruces. Él me dijo: Hijo de hombre, entiende que la visión se refiere al tiempo del fin."
,"18":"Al hablarme quedé sin sentido con el rostro en tierra, pero él me tocó y me hizo incorporarme."
,"19":"Y dijo: 'Mira, voy a manifestarte lo que sucederá al final de la ira, pues esto se refiere al tiempo fijado para el fin."
,"20":"El carnero con dos cuernos que has visto, representa al rey de los medos y de los persas."
,"21":"El macho cabrío es el rey de los griegos, y el cuerno grande que tenía entre los ojos es el primer rey."
,"22":"El que éste se rompiera y salieran otros cuatro en su lugar significa que de esta nación saldrán cuatro reinos, pero de menor potencia."
,"23":"Al final de su dominio, cuando las perversidades hayan llegado al colmo, surgirá un rey desvergonzado y astuto,"
,"24":"el cual consolidará el poder, aunque no por su propio valor. Será causa de desastres, tendrá éxito en su empresa, exterminará a los fuertes y al pueblo de los santos."
,"25":"Gracias a su astucia, la traición tendrá éxito en sus manos, su corazón se inflará de soberbia y de improviso destruirá a una gran multitud. Se alzará también contra el príncipe de los príncipes. Pero será destruido sin intervención humana."
,"26":"La visión de las tardes y de las mañanas, de que se ha hablado, es verdadera. Pero tú manténla en secreto, pues se refiere a tiempos todavía lejanos."
,"27":"Entonces yo, Daniel, me sentí sin fuerzas y estuve enfermo algunos días. Después me levanté y me seguí ocupando de los asuntos del rey. Pero continuaba asustado por la visión, que me resultaba incomprensible."
}`)
	CurrentBook.AddChapter(9, `{
"1":"El año primero del reinado de Darío, hijo de Asuero, de la estirpe de los medos, que fue constituido rey sobre el imperio de los caldeos,"
,"2":"yo, Daniel, me puse a estudiar en los libros y a calcular el número de los años que, según la palabra del Señor dirigida al profeta Jeremías, debían pasar sobre las ruinas de Jerusalén: setenta semanas."
,"3":"Me dirigí al Señor implorándole con oraciones y súplicas, con ayuno, sayal y ceniza."
,"4":"Rogué al Señor, mi Dios, e hice esta confesión: '¡Señor, Dios grande y terrible, que mantienes el pacto y la fidelidad a quienes te aman y guardan tus mandamientos!"
,"5":"Nosotros hemos pecado, hemos cometido injusticias y delitos, nos hemos rebelado y apartado de tus mandamientos y tus preceptos."
,"6":"No hemos escuchado a los profetas, tus siervos, que hablaban en tu nombre a nuestros reyes, a nuestros príncipes, a nuestros padres y a todo el pueblo del país."
,"7":"A ti, oh Señor, la justicia; a nosotros la vergüenza, como ahora la soportan los hombres de Judá, los habitantes de Jerusalén y de todo el país, próximos y lejanos, en todas las tierras donde los has dispersado por los delitos que cometieron contra ti."
,"8":"Señor, a nosotros la vergüenza, a nuestros reyes, a nuestros príncipes, a nuestros padres, porque hemos pecado contra ti."
,"9":"Al Señor Dios nuestro la misericordia y el perdón, porque nos hemos rebelado contra él"
,"10":"y no hemos escuchado la voz del Señor, nuestro Dios; no hemos procedido conforme a las leyes que él nos dio por medio de sus siervos los profetas."
,"11":"Todo Israel ha quebrantado tu ley, se ha extraviado sin querer escuchar tu voz. Por esto nos han sobrevenido las maldiciones que están escritas bajo juramento en la ley de Moisés, siervo de Dios, porque hemos pecado contra él."
,"12":"Y él ha cumplido las amenazas que pronunció contra nosotros y contra los príncipes que nos gobernaban: que haría caer sobre nosotros un desastre tan grande como no ha habido jamás otro bajo el cielo, como le ha sucedido a Jerusalén."
,"13":"Este desastre nos ha sobrevenido tal y como está escrito en la ley de Moisés; pero nosotros no hemos tratado de aplacar la ira del Señor, nuestro Dios, convirtiéndonos de nuestros pecados y dando oídos a tu verdad."
,"14":"Atento el Señor a esta calamidad, la ha descargado sobre nosotros; pues el Señor nuestro Dios es justo en todas sus obras, mientras que nosotros no hemos escuchado su voz."
,"15":"Y ahora, Señor, Dios nuestro, que sacaste a tu pueblo de la tierra de Egipto con mano fuerte y te conseguiste una fama que dura hasta el presente, nosotros hemos sido pecadores y criminales."
,"16":"Señor, movido por tu misma justicia, retira tu cólera y tu furor de Jerusalén, que es tu ciudad, tu santo monte; pues a causa de nuestros pecados y de las injusticias de nuestros padres, Jerusalén y tu pueblo se han hecho el escarnio de todas las gentes circundantes."
,"17":"Ahora, pues, oh Dios nuestro, escucha la oración de tu siervo y sus súplicas y, por amor de ti mismo, haz brillar tu rostro sobre tu desolado santuario."
,"18":"Inclina, Dios mío, tus oídos y escucha. Abre tus ojos y mira nuestras ruinas y la ciudad sobre la cual se invoca tu nombre. Oh, no; no apoyados en nuestras obras justas presentamos nuestras súplicas ante ti, sino en tu gran misericordia."
,"19":"¡Señor, escucha! ¡Señor, perdona! ¡Señor, atiende y actúa! ¡No tardes más, por amor de ti mismo, oh Dios mío!, pues tu nombre se invoca sobre tu ciudad y sobre tu pueblo'."
,"20":"Todavía estaba yo hablando, rezando y confesando mis pecados y los pecados de mi pueblo Israel y derramando mi súplica ante el Señor, mi Dios, por el santo monte de mi Dios;"
,"21":"aún tenía en los labios las palabras de mi oración, cuando Gabriel, aquel personaje que había visto anteriormente en visión, volando raudo, se acercó a mí, hacia la hora de la ofrenda de la tarde,"
,"22":"y me dijo: 'Daniel, aquí estoy; he salido ahora para ilustrar tu inteligencia."
,"23":"Al comienzo de tu oración se pronunció una palabra y he venido a comunicártela, porque tú eres el preferido por Dios. Presta, pues, atención a la palabra y entiende la visión."
,"24":"Setenta semanas están fijadas sobre tu pueblo y tu ciudad santa, para poner fin al delito y a la injusticia, para perdonar los crímenes e instaurar una justicia eterna, para que se cumplan visión y profecía,y para consagrar el lugar santísimo."
,"25":"Sábelo, pues, y entiéndelo bien: Desde que se dio la orden de restaurar Jerusalén,hasta que surja un príncipe ungido, habrá siete semanas. Durante sesenta y dos semanas, plaza y muros serán restaurados,en medio de la angustia de los tiempos."
,"26":"Después de las sesenta y dos semanas, matarán a un ungido inocente. La ciudad y el santuario serán destruidos,por un príncipe que ha de venir. Su fin será en un cataclismo, y hasta el final habrá guerra,y devastaciones decretadas."
,"27":"Hará un pacto firme con mucha gente durante una semana, y a la mitad de la semana pondrá fin,a los sacrificios y a las ofrendas. Y en el templo se cometerá un sacrilegio horrible, hasta que la ruina decretada caiga sobre el devastador'."
}`)
	CurrentBook.AddChapter(10, `{
"1":"En el año tercero de Ciro, rey de Persia, una palabra fue revelada a Daniel, llamado por sobrenombre Baltasar; palabra verdadera, anuncio de una gran lucha. Él comprendió la palabra y alcanzó inteligencia en la visión."
,"2":"En aquellos días, yo, Daniel, me puse de luto durante tres semanas."
,"3":"No comí manjar sabroso, ni carne ni vino entraron en mi boca, ni me ungí con perfume en el curso de estas tres semanas."
,"4":"Y el día veinticuatro del mes primero, estando yo a la orilla del río grande, el Tigris,"
,"5":"levanté los ojos, miré y vi a un hombre vestido de lino, ceñidos los lomos de oro puro."
,"6":"Su cuerpo parecía de crisólito, su rostro era como el fulgor del relámpago, sus ojos como antorchas encendidas, sus brazos y sus pies como el destello del bronce bruñido y el rumor de sus palabras como el ruido de una multitud."
,"7":"Sólo yo, Daniel, contemplé la visión: los hombres que se encontraban conmigo no veían nada, pero un gran terror los invadió y huyeron a esconderse."
,"8":"Quedé así yo solo contemplando esta imponente visión; me sentí sin fuerzas, pálido el rostro casi hasta desvanecerme, porque las fuerzas me abandonaban."
,"9":"Oí entonces el rumor de sus palabras y, al sentirlo, perdí el sentido y caí de bruces, rostro en tierra."
,"10":"Una mano me tocó y me hizo enderezarme temblando sobre mis rodillas y sobre las palmas de mis manos."
,"11":"Y me dijo: 'Daniel, hombre preferido por Dios, presta atención a las palabras que te voy a decir e incorpórate, pues ahora he sido enviado a ti'. Al decirme esto, me incorporé temblando todavía."
,"12":"Él continuó: 'No temas, Daniel, pues desde el primer día que tú, con el fin de comprender, decidiste hacer penitencia ante tu Dios, fueron escuchadas tus palabras y, debido a ellas, he venido yo."
,"13":"El príncipe del reino de Persia me ha hecho resistencia durante veintiún días; pero Miguel, uno de los primeros príncipes, ha venido en mi ayuda; le he dejado allí junto al rey de Persia."
,"14":"Y he venido a darte a conocer lo que sucederá a tu pueblo al final de los tiempos, porque esta visión se refiere a días aún lejanos'."
,"15":"Al hablarme de esta manera, me postré en tierra sin decir nada."
,"16":"Entonces un ser de aspecto humano me tocó los labios. Abrí mi boca, hablé y dije a aquel que estaba delante de mí: 'Señor mío, con esta aparición me invade un malestar y me quedo sin fuerzas."
,"17":"¿Y cómo podría el siervo de mi Señor hablar con mi Señor, si me faltan fuerzas y ni aliento me queda?'."
,"18":"Entonces aquel personaje de aspecto humano me tocó de nuevo y me reanimó."
,"19":"Después me dijo: 'No temas, hombre preferido por Dios, la paz sea contigo; sé fuerte y ten ánimo'. Al hablarme así me sentí reanimado y dije: 'Hable mi Señor, pues me has confortado'."
,"20":"Entonces me dijo: '¿Sabes por qué he venido? Ahora me marcho otra vez a luchar con el príncipe de Persia. Cuando haya terminado, vendrá el príncipe de Grecia."
,"21":"Sin embargo, te comunicaré lo que está consignado en el libro de la verdad. Nadie me presta ayuda contra ellos, excepto Miguel, vuestro príncipe'."
}`)
	CurrentBook.AddChapter(11, `{
"1":"También yo, en el año primero de Darío, el medo, estaba junto a él para animarlo y ayudarlo."
,"2":"Ahora pues, te anunciaré la verdad. Mira, todavía habrá tres reyes en Persia. El cuarto superará en riqueza a todos los precedentes y, en cuanto se haya hecho poderoso por sus riquezas, lanzará todas sus fuerzas contra el rey de Grecia."
,"3":"Surgirá entonces un rey fuerte, que impondrá su gran dominio y hará todo lo que quiera."
,"4":"Una vez afirmado su imperio será destrozado y dividido a los cuatro vientos del cielo. No pasará a sus hijos, ni tendrá el mismo poder; su reino será exterminado y pasará a otros, excluidos sus descendientes."
,"5":"Se hará poderoso el rey del sur, pero uno de sus capitanes se hará más fuerte que él y alcanzará el poder, creándose un enorme imperio."
,"6":"Al cabo de algunos años harán un pacto, y la hija del rey del sur se presentará al rey del norte para ejecutar los convenios; pero llegará a faltarle el apoyo de su padre y no subsistirá su descendencia; será entregada a la muerte ella y las personas de su séquito, con su padre y quien la sostenía."
,"7":"En su lugar surgirá un vástago de sus raíces, que marchará contra el ejército del rey del norte, invadirá su fortaleza y le tratará como vencedor."
,"8":"Llevará a Egipto como botín a sus dioses, sus simulacros y sus vasos preciosos de plata y oro, y durante algunos años prevalecerá sobre el rey del norte."
,"9":"Éste marchará contra el rey del sur, pero tendrá que retroceder a su país."
,"10":"Sus hijos se armarán y reunirán un gran ejército, que, irrumpiendo como un río, inundará, pasará y luego se concentrará de nuevo para asaltar su fortaleza."
,"11":"Entonces el rey del sur, irritado, saldrá y combatirá contra él, contra el rey del norte, el cual movilizará un gran ejército, pero este ejército caerá en manos de aquél."
,"12":"Después de aniquilar a este ejército, el rey del sur se inflará de soberbia, aplastará aún a millares de hombres, pero no durará su fuerza."
,"13":"El rey del norte movilizará de nuevo una multitud más numerosa que la anterior y, al cabo de algunos años, irrumpirá con un gran ejército y con gran aparato."
,"14":"Por entonces se levantarán muchos contra el rey del sur, y algunos hombres violentos de tu pueblo se sublevarán para que se cumpla la visión, pero caerán."
,"15":"El rey del norte llegará, levantará un terraplén de asedio y tomará la ciudad muy fortificada; las fuerzas del sur no resistirán, ni siquiera los más valientes del pueblo; nada podrá resistir."
,"16":"Aquel que llega contra el rey del sur actuará a placer sin que haya quien pueda hacerle frente; se establecerá en la tierra santa llevando en su mano la destrucción."
,"17":"Concebirá el proyecto de apoderarse de todo el reino del sur; a tal fin, hará un pacto con él y le dará su propia hija como esposa para preparar su propia ruina; pero el proyecto no se logrará y no le saldrá bien."
,"18":"Entonces pondrá sus ojos en las ciudades marítimas y conquistará un buen número de ellas, pero un capitán pondrá fin a su prepotencia y le hará pagar cara su afrenta."
,"19":"Aún se volverá contra las fortalezas de su propio país; pero chocará, caerá y no se lo encontrará más."
,"20":"En su lugar surgirá otro, que enviará un exactor en el esplendor del reino; pero a los pocos días será destrozado, aunque no públicamente ni en guerra."
,"21":"Surgirá al fin en lugar de éste un hombre despreciable, a quien no se conferirá la dignidad real, sino que se introducirá mediante la astucia y se apoderará del reino a fuerza de intrigas."
,"22":"Las fuerzas enemigas serán completamente derrotadas por él y aniquiladas, así como un jefe del pacto."
,"23":"Actuará con perfidia aun contra quien se ha aliado con él, y se irá haciendo fuerte, aunque con poca gente."
,"24":"Invadirá de improviso las provincias más ricas y hará lo que ni sus padres ni los padres de sus padres hicieron. Distribuirá entre sus amigos presa, botín y riquezas, y urdirá sus tramas contra las fortalezas, aunque sólo hasta cierto tiempo."
,"25":"Reafirmará sus fuerzas y su corazón, marchando contra el rey del sur con un gran ejército. El rey del sur se aprestará a la guerra con un ejército muy grande y muy poderoso, pero no podrá resistirle, pues se tramarán contra él conspiraciones."
,"26":"Sus mismos comensales lo hundirán, su ejército se desbandará y muchos caerán muertos a espada."
,"27":"En cuanto a los dos reyes, su corazón no pensará más que en hacerse daño y, aun sentados a la misma mesa, se dirán mentiras. Pero nada lograrán, pues falta tiempo aún para el momento fijado."
,"28":"El rey del norte volverá a su país con muchas riquezas, urdiendo planes contra el pacto santo; los llevará a cabo, y luego regresará a su país."
,"29":"A su tiempo volverá a intentar la empresa contra el sur; pero esta segunda vez las cosas no saldrán como la primera."
,"30":"Vendrán contra él las naves de Chipre y tendrá que desistir de su propósito; pero desahogará su furor contra el pacto santo, tomará medidas hostiles y, volviendo, se entenderá con los desertores del pacto santo."
,"31":"Mandará parte de sus fuerzas a profanar el santuario y la fortaleza; pondrán fin al sacrificio perpetuo, y en su lugar establecerán el sacrificio horrible."
,"32":"Corromperá con halagos a los violadores del pacto, pero aquellos que conocen a su Dios se mantendrán firmes y actuarán."
,"33":"Los maestros del pueblo instruirán a muchos, pero caerán a espada o serán quemados o deportados o despojados de sus bienes durante algún tiempo."
,"34":"Y cuando caigan, pocos vendrán en su ayuda, porque los más les brindarán una traidora compañía."
,"35":"También caerán algunos maestros, a fin de acrisolar, purificar y blanquear a los otros hasta el tiempo fijado, porque aún falta para el tiempo fijado."
,"36":"Este rey actuará a placer; se hará orgulloso hasta engreírse por encima de toda divinidad; dirá cosas monstruosas contra el Dios de los dioses y prosperará hasta que se haya agotado la cólera, porque lo que está decidido se cumplirá."
,"37":"No hará caso del dios de sus padres, ni del dios favorito de las mujeres, ni de ningún otro dios, porque se creerá superior a todos ellos."
,"38":"En su lugar venerará al dios de las fortalezas; honrará con oro, plata, piedras preciosas y joyas a un dios a quien sus padres no conocieron."
,"39":"Y con la ayuda de este dios extraño construirá fortalezas; a los que le reconozcan los colmará de honores, les dará el mando de muchos y repartirá entre ellos el país como recompensa."
,"40":"Al final se enfrentará a él el rey del sur; pero el rey del norte se levantará contra él con sus carros y jinetes y con numerosas naves, entrará en su país, lo invadirá y lo atravesará."
,"41":"Después vendrá a la tierra santa, donde caerán muchísimos, pero se escaparán de sus manos los siguientes países: Edón, Moab y la parte principal de Amón."
,"42":"Extenderá su mano a otros países, y ni siquiera Egipto escapará libre:"
,"43":"se apoderará de los tesoros de oro y plata y de todos los objetos preciosos de Egipto, mientras los libios y los etíopes caerán a sus pies."
,"44":"Pero noticias venidas del oriente y del norte le turbarán. Partirá entonces con gran furor, dispuesto a destruir y exterminar a muchos."
,"45":"Plantará las tiendas reales entre el mar y los montes de la tierra santa. Pero entonces llegará a su fin y nadie vendrá a socorrerlo."
}`)
	CurrentBook.AddChapter(12, `{
"1":"En aquel tiempo surgirá Miguel, el gran príncipe, que hace guardia sobre los hijos de tu pueblo. Será aquél un período de angustia como no lo hubo desde que existen las naciones hasta aquel día. Entonces serán salvados, de entre el pueblo, todos aquellos que se hallen inscritos en el libro."
,"2":"Y muchos de los que duermen en el polvo de la tierra se despertarán; unos para la vida eterna, otros para la vergüenza y la ignominia perpetua."
,"3":"Los sabios brillarán entonces como el resplandor del firmamento, y los que enseñaron a muchos la justicia, como las estrellas por toda la eternidad."
,"4":"Tú, Daniel, mantén en secreto estas palabras y sella el libro hasta el tiempo prefijado. Muchos andarán perplejos, pero aumentará el saber."
,"5":"Yo, Daniel, seguía mirando y vi a otros dos que estaban de pie, uno a la orilla derecha del río y el otro a la orilla izquierda."
,"6":"Uno dijo al hombre vestido de lino, que estaba sobre las aguas del río: '¿Cuándo sucederán estas cosas extraordinarias?'."
,"7":"Yo oí al hombre vestido de lino, que estaba sobre las aguas del río, jurar, alzando la diestra y la izquierda, por aquel que vive eternamente: 'Ésto será dentro de un período de tiempo, de dos períodos y de medio período, y todas estas cosas se cumplirán cuando desaparezca aquel que oprime el poder del pueblo santo'."
,"8":"Yo oí, pero no lo entendí. Y pregunté: 'Señor mío, ¿cuál será el último de estos sucesos?'."
,"9":"Me respondió: 'Anda, Daniel, que estas palabras han de quedar cerradas y selladas hasta el momento final."
,"10":"Muchos serán acrisolados, purificados y blanqueados; los criminales continuarán cometiendo crímenes; ninguno de ellos comprenderá nada; los sabios, en cambio, comprenderán."
,"11":"Y desde el tiempo en que sea cesado el sacrificio cotidiano y sea sustituido por el sacrilegio horrible pasarán mil doscientos noventa días."
,"12":"Dichoso el que sepa esperar y llegue a mil trescientos treinta y cinco días."
,"13":"Y tú, vete a descansar; te levantarás para recibir tu suerte al final de los días'."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Había en Babilonia un hombre llamado Joaquín."
,"2":"Se casó con una mujer, llamada Susana, hija de Jelcías, muy bella y temerosa de Dios."
,"3":"Sus padres eran justos, y habían educado a su hija conforme a la ley de Moisés."
,"4":"Joaquín era muy rico, y tenía un jardín contiguo a su casa; los judíos solían ir a su casa, porque gozaba de gran estima entre todos."
,"5":"Aquel año fueron escogidos entre el pueblo y designados jueces dos ancianos de esos a quienes se refiere el Señor cuando dice: 'En Babilonia ha surgido la iniquidad de parte de los ancianos y de los jueces que se hacían guías del pueblo'."
,"6":"Éstos venían a menudo a casa de Joaquín, y a ellos se dirigían todos aquellos que tenían algún litigio que resolver."
,"7":"Cuando al mediodía toda la gente se marchaba, Susana solía salir a pasearse por el huerto de su marido."
,"8":"Los dos ancianos la veían todos los días cuando salía a pasear, y empezaron a desearla;"
,"9":"pervirtieron su mente y desviaron sus ojos, que ya no miraban al cielo ni se acordaban de sus justos juicios."
,"10":"Los dos ardían de pasión por ella, pero sin manifestarse mutuamente su tormento,"
,"11":"porque tenían vergüenza de descubrir su deseo de tener relaciones con ella;"
,"12":"y se afanaban por verla todos los días."
,"13":"Un día se dijeron el uno al otro: 'Vamos a casa, que es hora de comer'. Al salir, se separaron."
,"14":"Pero se dieron la vuelta y volvieron a encontrarse en el mismo sitio; se preguntaron el uno al otro el motivo, y se confesaron finalmente su pasión. Entonces, de común acuerdo, convinieron en buscar una ocasión en que pudieran sorprenderla sola."
,"15":"Una vez, mientras ellos seguían acechando la ocasión oportuna, salió ella, como de ordinario, con dos doncellas, y quiso bañarse en el jardín porque hacía mucho calor."
,"16":"No había allí nadie, excepto los dos ancianos, que estaban escondidos acechándola."
,"17":"Dijo a las doncellas: 'Traedme aceite y jabón, y cerrad después las puertas del jardín, pues voy a bañarme'."
,"18":"Ellas hicieron lo que Susana había ordenado; cerraron las puertas del jardín y entraron en casa por una puerta lateral para traer lo que les había mandado. No sabían que los dos ancianos estaban allí escondidos."
,"19":"En cuanto salieron las doncellas, los dos viejos se levantaron, fueron corriendo donde ella"
,"20":"y le dijeron: 'Mira, las puertas del jardín están cerradas y nadie nos ve. Nosotros te estamos deseando; consiente y acuéstate con nosotros;"
,"21":"si no lo haces, testificaremos contra ti que estaba contigo un joven y que por eso mandaste fuera a las doncellas'."
,"22":"Entonces Susana gimiendo exclamó: '¡Ay, estoy en un gran aprieto! Si consiento, me espera la muerte; si no consiento, no escaparé de vuestras manos."
,"23":"Pero prefiero caer en vuestras manos que consentir en aquello que es pecado ante el Señor'."
,"24":"Y Susana gritó fuertemente; pero también gritaron los dos viejos contra ella."
,"25":"Y uno de ellos corrió a abrir las puertas del jardín."
,"26":"A aquellos gritos los criados salieron rápidamente al jardín por la puerta lateral para ver qué había sucedido."
,"27":"Y cuando los dos viejos lo explicaron a su manera, los criados se sonrojaron mucho, porque jamás se había dicho de Susana una cosa semejante."
,"28":"Al día siguiente, cuando el pueblo se reunió en casa de su marido Joaquín, vinieron también los dos viejos malvados, decididos a hacerla condenar a muerte."
,"29":"Y dijeron ante el pueblo: 'Mandad llamar a Susana, hija de Jelcías, la mujer de Joaquín'."
,"30":"Ella vino acompañada de sus padres, de sus hijos y de todos sus parientes."
,"31":"Susana era encantadora y bellísima."
,"32":"Aquellos malvados le ordenaron que se quitase el velo -pues estaba velada- para poderse al menos saciar de su belleza,"
,"33":"mientras lloraban los suyos y todos los que la veían."
,"34":"Los dos viejos, en pie en medio del pueblo, pusieron sus manos sobre la cabeza de Susana."
,"35":"Ella, llorando, levantó los ojos al cielo, porque su corazón tenía puesta su confianza en el Señor."
,"36":"Los viejos empezaron a decir: 'Estando nosotros dos solos paseándonos por el jardín, entró ésta con dos doncellas, cerró la puerta del jardín y despachó a las doncellas."
,"37":"Entonces se acercó a ella un joven que estaba escondido en el jardín y se acostó con ella."
,"38":"Nosotros, que estábamos en un rincón del jardín, al ver la iniquidad, corrimos hacia ellos;"
,"39":"los sorprendimos juntos, pero no nos fue posible atraparlo a él porque tenía más fuerza que nosotros y abrió la puerta y se escapó."
,"40":"Entonces apresamos a ésta y le preguntamos quién era el joven,"
,"41":"pero no quiso decírnoslo. De todo esto nosotros somos testigos'. La asamblea los creyó, como ancianos y jueces del pueblo que eran. Y la condenaron a muerte."
,"42":"Susana exclamó fuertemente: 'Oh Dios eterno, que ves las cosas secretas y conoces todo antes que suceda."
,"43":"Tú sabes que éstos han dado testimonio falso contra mí; mira que voy a morir sin haber hecho nada de lo que la maldad de éstos ha tramado contra mí'."
,"44":"Y el Señor escuchó su voz."
,"45":"Cuando la llevaban para matarla, Dios suscitó el santo espíritu de un muchacho llamado Daniel,"
,"46":"el cual se puso a gritar:"
,"47":"'¡Yo soy inocente de la sangre de esa mujer!'. Todos los presentes se volvieron hacia él y le preguntaron: '¿Qué quieres decir con estas palabras?'."
,"48":"Él, plantado en medio de todos, dijo: 'Israelitas, estáis locos. ¡Habéis condenado a una hija de Israel sin juzgarla y sin aclarar los hechos!"
,"49":"¡Volved al lugar del juicio, porque el testimonio que éstos han dado contra ella es falso!'."
,"50":"Entonces todo el pueblo volvió en seguida atrás. Los ancianos dijeron a Daniel: 'Siéntate aquí en medio de nosotros y decláranos lo que piensas, ya que Dios te ha dado la madurez de la ancianidad'."
,"51":"Daniel dijo: 'Separadlos lejos el uno del otro, y yo los examinaré'."
,"52":"Una vez separados, tomó a uno y le dijo: 'Oh, envejecido en el mal, ahora has colmado la medida de los delitos cometidos en el pasado,"
,"53":"cuando dictabas sentencias injustas, condenabas a los inocentes y absolvías a los culpables, siendo así que el Señor ha dicho: No matarás al inocente y justo."
,"54":"Así pues, si es que viste realmente a ésta di: ¿Bajo qué árbol los viste juntos?'. Respondió: 'Debajo de una acacia'."
,"55":"Daniel replicó: 'Tu mentira recae sobre tu cabeza; un ángel de Dios ha recibido ya de él la orden de partirte por medio'."
,"56":"Retiró a éste, mandó traer al otro y le dijo: 'Raza de Canaán, que no de Judá, la hermosura te ha seducido y la pasión ha trastornado tu corazón."
,"57":"Así hacíais vosotros con las hijas de Israel, y ellas accedían por miedo a vuestros deseos; pero una hija de Judá no ha soportado vuestra iniquidad."
,"58":"Di: ¿Bajo qué árbol los sorprendiste juntos?'. Él respondió: 'Debajo de una encina'."
,"59":"Daniel le dijo: 'Tu mentira recae también sobre tu cabeza; ya está el ángel del Señor esperando, espada en mano, para partirte por medio y exterminaros'."
,"60":"Todos los presentes clamaron entonces a grandes voces y bendijeron al Señor, que salva a todos los que esperan en él."
,"61":"Se levantaron contra los dos viejos, a quienes, por su propia boca, había convencido Daniel de falso testimonio, e hicieron con ellos lo mismo que ellos habían maquinado pérfidamente contra el prójimo."
,"62":"Los condenaron a muerte, como prescribe la ley de Moisés, y así aquel día se salvó la sangre inocente."
,"63":"Jelcías y su mujer dieron gracias a Dios por su hija Susana, así como Joaquín, su marido, y todos sus parientes, porque nada malo se había encontrado en ella."
,"64":"Y Daniel gozó de gran estima ante el pueblo desde aquel día en adelante."
}`)
	CurrentBook.AddChapter(14, `{
"1":"El rey Astiages murió, y le sucedió en el reino Ciro el persa."
,"2":"Daniel era entonces confidente del rey, el cual le honraba más que a todos sus otros amigos."
,"3":"Los babilonios tenían un ídolo llamado Bel, en cuyo honor gastaban diariamente más de seis hectólitros de flor de harina, cuarenta ovejas y más de dos hectólitros de vino."
,"4":"También el rey lo veneraba e iba todos los días a adorarlo. Pero Daniel adoraba a su Dios."
,"5":"Le dijo un día el rey: '¿Por qué no adoras a Bel?'. Él respondió: 'Yo no adoro a ídolos hechos por mano humana, sino al Dios vivo, creador del cielo y de la tierra y Señor de todo viviente'."
,"6":"El rey le dijo: '¿Te parece que Bel no es un dios vivo? ¿No ves cuánto come y bebe cada día?'."
,"7":"Daniel respondió: 'No te engañes, rey; este Bel es barro por dentro y bronce por fuera, y no ha comido jamás'."
,"8":"Entonces el rey, lleno de cólera, llamó a los sacerdotes del ídolo y les dijo: 'Si no me decís quién es el que come estas ofrendas, moriréis; pero si demostráis que las come Bel, morirá Daniel, por haber blasfemado contra Bel'."
,"9":"Daniel dijo al rey: 'Hágase como dices'. Los sacerdotes de Bel eran setenta, sin contar mujeres e hijos."
,"10":"El rey y Daniel se dirigieron al templo de Bel;"
,"11":"los sacerdotes de Bel dijeron: 'Mira, nosotros nos salimos de aquí, y tú, oh rey, haz servir los manjares y el vino preparado; luego cierra la puerta y séllala con tu anillo. Si mañana por la mañana, al volver al templo, no encuentras que todo ha sido comido por Bel, nosotros moriremos; pero en caso contrario morirá Daniel, que miente contra nosotros'."
,"12":"Ellos estaban tranquilos porque habían hecho debajo de la mesa una abertura secreta por la cual entraban regularmente y comían las ofrendas."
,"13":"Una vez que salieron, el rey hizo depositar las viandas delante de Bel."
,"14":"Pero Daniel mandó a sus criados que trajeran ceniza y la esparcieron con un cedazo por todo el templo en presencia del rey; lego salieron, cerraron la puerta, la sellaron con el anillo del rey y se fueron."
,"15":"Durante la noche los sacerdotes entraron, como solían, con sus mujeres y sus hijos, y se lo comieron y bebieron todo."
,"16":"Al día siguiente, muy de mañana, el rey se dirigió al templo con Daniel."
,"17":"Y el rey dijo: '¿Están intactos los sellos, Daniel?'. Él respondió: 'Sí, oh rey'."
,"18":"Abrieron la puerta, el rey echó una ojeada a la mesa y exclamó en alta voz: 'Grande eres, Bel, y no hay en ti engaño alguno'."
,"19":"Pero Daniel se rió y detuvo al rey para que no entrara dentro; luego dijo: 'Mira bien el pavimento y observa de quién son estas huellas'."
,"20":"El rey dijo: 'Veo huellas de hombres, de mujeres y de niños'."
,"21":"Y, encolerizado, el rey hizo apresar a los sacerdotes con sus mujeres y sus hijos. Ellos le mostraron la puerta secreta por la cual entraban a consumir lo que había en la mesa."
,"22":"Entonces el rey mandó matarlos a todos y entregó a Bel en manos de Daniel, el cual lo destruyó juntamente con su templo."
,"23":"Había también un gran dragón al que los babilonios veneraban."
,"24":"El rey dijo a Daniel: 'Al menos, de éste no irás a decir que es de bronce; mira, está vivo y come y bebe; no negarás que es un dios viviente. Adóralo'."
,"25":"Daniel respondió: 'Yo adoro al Señor, mi Dios, porque es él el Dios vivo. Oh rey, dame licencia, y yo mataré a este dragón sin espada ni estaca'."
,"26":"El rey dijo: 'Te la doy'."
,"27":"Daniel entonces tomó pez, grasa y pelos y lo coció todo junto; hizo luego unas bolas y las echó en la boca del dragón, el cual, en cuanto las tragó, reventó. Y Daniel dijo: 'Eso es lo que adoráis'."
,"28":"Al enterarse de esto los babilonios, se indignaron y se volvieron contra el rey, diciendo: 'El rey se ha hecho judío; ha dejado destruir a Bel, ha dejado matar al dragón y suprimir a los sacerdotes'."
,"29":"Se presentaron al rey y le dijeron: 'Entréganos a Daniel; si no, te mataremos a ti y a toda tu casa'."
,"30":"El rey entonces, al verse en peligro por su violencia, se vio obligado a entregarles a Daniel."
,"31":"Ellos lo echaron en el foso de los leones, donde estuvo seis días."
,"32":"En aquel foso había siete leones, a los que se les daba diariamente dos cuerpos humanos y dos ovejas; pero entonces no se les dio nada con el fin de que devoraran a Daniel."
,"33":"Vivía a la sazón en Judea el profeta Habacuc; éste, después de haber preparado un cocido y desmenuzado pan en un plato, se dirigía al campo a llevárselo a los segadores."
,"34":"Pero el ángel del Señor dijo a Habacuc: 'Lleva la comida que has preparado a Babilonia para Daniel, que está en el foso de los leones'."
,"35":"Habacuc dijo: 'Señor, no he visto jamás Babilonia y no sé dónde está el foso'."
,"36":"Pero el ángel del Señor lo agarró por la cabeza y, llevándolo por los cabellos, lo puso en Babilonia encima del foso con la rapidez de su soplo."
,"37":"Habacuc gritó: 'Daniel, Daniel, toma la comida que el Señor te ha enviado'."
,"38":"Y Daniel exclamó: '¡Oh Dios, te has acordado de mí y no has desamparado a los que te aman!'."
,"39":"Luego se levantó y se puso a comer, mientras el ángel del Señor volvía a llevar a Habacuc a su lugar."
,"40":"El día séptimo vino el rey a llorar a Daniel; se acercó al foso, miró y vio que Daniel estaba allí sentado."
,"41":"Entonces exclamó entusiasmado: 'Grande eres tú, Señor, Dios de Daniel, y no hay otro Dios fuera de ti'."
,"42":"Y mandó sacar del foso a Daniel y arrojar allá a los que habían tramado su ruina, los cuales fueron devorados al instante en su presencia."
}`)

}
func ES_LSB_LoadVMEZChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"El año treinta, el mes cuarto, el día cinco del mes, me encontraba yo entre los deportados junto al río Quebar, cuando se abrieron los cielos y contemplé visiones divinas."
,"2":"El día cinco del mes -era ya el año quinto de la deportación del rey Joaquín-"
,"3":"fue dirigida la palabra del Señor a Ezequiel, hijo de Buzi, sacerdote, en la tierra de los caldeos, junto al río Quebar. Y allí el Señor puso su mano sobre él."
,"4":"Yo veía un viento huracanado que venía del norte, una gran nube con resplandores en torno, un fuego que despedía relámpagos y en su centro como el fulgor del electro, en el centro del fuego."
,"5":"En el medio aparecía la figura de cuatro seres, cuyo aspecto era el siguiente: presentaban forma humana,"
,"6":"pero cada uno tenía cuatro caras y cuatro alas."
,"7":"Sus piernas eran rectas y sus pies semejantes a las pezuñas de un toro, relucientes como bronce bruñido."
,"8":"Debajo de las alas, en los cuatro lados, salían manos humanas; los cuatro tenían el mismo aspecto y las alas de iguales dimensiones."
,"9":"Sus alas estaban juntas unas con otras; al andar no se volvían de espaldas, sino que cada uno caminaba de frente."
,"10":"En cuanto a su semblante, presentaban cara humana, pero los cuatro tenían cara de león a la derecha, cara de toro a la izquierda y los cuatro también cara de águila."
,"11":"Así estaban sus alas desplegadas hacia lo alto: cada uno tenía dos alas que se tocaban mutuamente, y otras dos que le cubrían el cuerpo."
,"12":"Cada cual marchaba de frente. Iban donde el espíritu los impulsaba, sin volverse de espaldas en su marcha."
,"13":"En medio de estos cuatro seres se veían como brazos incandescentes a modo de antorchas que se agitaban de acá para allá entre ellos. Resplandecía el fuego, y del fuego se desprendían fulgores."
,"14":"Los seres iban y venían lo mismo que el relámpago."
,"15":"Me fijé en el suelo, y vi una rueda al lado de cada uno de los cuatro seres."
,"16":"El aspecto de las ruedas, su estructura, resplandecía como el crisólito. Tenían las cuatro la misma forma y parecían dispuestas como si una estuviese en medio de la otra."
,"17":"Al rodar iban en las cuatro direcciones, sin volverse en su movimiento."
,"18":"Su circunferencia era de gran altura, y las llantas de las cuatro estaban cuajadas de ojos todo alrededor."
,"19":"Cuando los seres se movían, iban también las ruedas junto a ellos; y cuando aquéllos se elevaban de la tierra, se levantaban también las ruedas."
,"20":"Iban hacia donde los impulsaba el espíritu; y las ruedas también se elevaban, porque el espíritu de los seres estaba en las ruedas."
,"21":"Cuando andaban ellos, andaban las ruedas; y cuando se paraban ellos, se paraban también las ruedas; cuando ellos se elevaban de la tierra, se elevaban también ellas, porque el espíritu de los seres estaba en las ruedas."
,"22":"Sobre los seres había una especie de firmamento, esplendoroso como un cristal extendido por encima de sus cabezas,"
,"23":"y bajo el firmamento estaban extendidas sus alas una junto a otra, mientras que las otras dos alas de cada uno de los cuatro seres les cubrían el cuerpo."
,"24":"Sentí el rumor de las alas mientras se movían; parecía el rumor de aguas ingentes, semejante a la voz del todopoderoso; un ruido tumultuoso como el de un ejército. Y cuando se pararon, replegaron sus alas."
,"25":"Entonces resonó una voz desde el firmamento que había sobre sus cabezas."
,"26":"Por encima del firmamento que se extendía sobre sus cabezas apareció como una piedra de zafiro en forma de trono; y sobre esta especie de trono, una figura de aspecto semejante al de un hombre, que se erguía sobre él."
,"27":"Desde lo que parecían sus caderas hacia arriba vi que era como un bronce resplandeciente, algo que parecía fuego, dentro y alrededor de él; y desde lo que parecían sus caderas para abajo vi también algo así como un fuego, refulgente todo en torno,"
,"28":"semejante al arco iris que aparece en las nubes en un día de lluvia; tal era el fulgor que despedía. Esta visión era como la imagen de la gloria del Señor. A su vista yo caí rostro en tierra y oí una voz que hablaba."
}`)
	CurrentBook.AddChapter(2, `{
"1":"La voz me dijo: 'Hijo de hombre, levántate, que voy a hablarte'."
,"2":"Al decirme esto, el espíritu entró en mí, me hizo tenerme en pie y pude escuchar a aquel que me hablaba."
,"3":"Él me dijo: 'Hijo de hombre, yo te envío a los israelitas, a un pueblo de rebeldes, que se han rebelado contra mí, ellos y sus padres, hasta este mismo día."
,"4":"Hijos de cara dura y corazón de piedra son aquellos a quienes yo te envío. Les dirás: Esto dice el Señor Dios."
,"5":"Escuchen o no escuchen -puesto que son una raza de rebeldes-, sabrán que en medio de ellos se encuentra un profeta."
,"6":"Y tú, hijo de hombre, no los temas ni tengas miedo de sus palabras. No temas, aunque te encuentres entre cardos y zarzas y habites en medio de escorpiones. No temas sus palabras ni te asustes de sus miradas, porque no son más que una raza de rebeldes."
,"7":"Les comunicarás mis palabras, escuchen o no, porque son una raza de rebeldes."
,"8":"Pero tú, hijo de hombre, escucha lo que te digo; no seas rebelde como esta raza de rebeldes; abre la boca y come lo que te doy'."
,"9":"Yo miré y vi una mano tendida hacia mí con un libro enrollado."
,"10":"Lo desenrolló ante mi vista. Estaba escrito por dentro y por fuera, y contenía lamentaciones, gemidos y ayes."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Y me dijo: 'Hijo de hombre, cómelo; come este libro y vete a hablar a la casa de Israel'."
,"2":"Yo abrí la boca, y me hizo tragar el libro."
,"3":"Entonces me dijo: 'Hijo de hombre, aliméntate y sáciate de este libro que yo te doy'. Yo lo comí, y fue en mi boca dulce como la miel."
,"4":"Después me dijo: 'Hijo de hombre, anda, dirígete a la casa de Israel y comunícales mis palabras."
,"5":"Porque eres enviado no a un pueblo de lengua oscura e incomprensible, sino a la casa de Israel;"
,"6":"no a pueblos numerosos de lengua oscura e incomprensible, cuyas palabras no entenderías; si a ellos te enviara, te escucharían."
,"7":"Pero la casa de Israel no querrá escucharte a ti, como no quiere escucharme a mí, porque toda la casa de Israel es de cabeza dura y corazón de piedra."
,"8":"Pero mira, yo te doy una cara dura como la suya, una frente dura como la suya;"
,"9":"he hecho tu frente dura como el diamante, más dura que la roca. No los temas ni te asustes de ellos. Son una raza de rebeldes'."
,"10":"Me dijo también: 'Hijo de hombre, todas las palabras que yo te diga consérvalas en tu corazón, escúchalas con la mayor atención;"
,"11":"y anda, llégate a los deportados, a los hijos de tu pueblo, y diles: Así habla el Señor Dios, escuchen o no escuchen'."
,"12":"Entonces el espíritu me arrebató y oí detrás de mí el ruido de una gran trepidación, mientras la gloria del Señor se levantaba de su sitio;"
,"13":"era el rumor de las alas de aquellos seres al batir una con otra y el ruido de las ruedas como el ruido de gran terremoto."
,"14":"El espíritu me levantó y me arrebató; iba yo amargado, con el ánimo lleno de excitación, mientras la mano del Señor pesaba fuertemente sobre mí."
,"15":"Llegué a Tel-Abib, junto a los deportados que habitaban a lo largo del río Quebar, allí donde ellos habitaban, y permanecí como aturdido siete días en medio de ellos."
,"16":"Al cabo de estos siete días el Señor me dijo:"
,"17":"'Hijo de hombre, yo te he puesto como centinela de la casa de Israel. Cuando oigas de mi boca una palabra, los advertirás de parte mía."
,"18":"Cuando yo diga al malvado: ¡Morirás!, si tú no lo amonestas y no le adviertes que abandone su perversa conducta para que pueda vivir, morirá él por su maldad, pero a ti te pediré cuenta de su sangre."
,"19":"Pero si tú adviertes al malvado y él no se convierte de su maldad y de su conducta perversa, morirá él por su maldad, pero tú te habrás salvado."
,"20":"Asimismo, si el justo se desvía de su justicia y comete la injusticia por no haberle tú advertido, él morirá en su pecado y no será tenida en cuenta la justicia que había practicado, pero a ti te pediré cuenta de su sangre."
,"21":"Pero si tú adviertes al justo para que no peque y él no peca, vivirá él porque fue advertido y tú habrás salvado tu vida'."
,"22":"Allí mismo el Señor puso su mano sobre mí y me dijo: 'Levántate, sal a la vega y allí hablaré contigo'."
,"23":"Me levanté, salí a la vega, y he aquí que la gloria del Señor estaba allí, como la había contemplado junto al río Quebar; yo caí rostro en tierra."
,"24":"En seguida entró en mí el espíritu y me hizo tenerme en pie, me habló y me dijo: 'Anda, enciérrate en tu casa."
,"25":"Mira, hijo de hombre, te van a echar cuerdas con las que serás atado y no podrás presentarte en medio de ellos."
,"26":"Yo haré que tu lengua se te pegue al paladar; quedarás mudo y dejarás de ser su acusador, porque son una raza de rebeldes."
,"27":"Pero cuando yo te hable, abriré tu boca y les dirás: Así habla el Señor; quien quiera escuchar escuche, quien no quiera no escuche; porque son una raza de rebeldes'."
}`)
	CurrentBook.AddChapter(4, `{
"1":"'Hijo de hombre, toma un ladrillo, ponlo delante de ti y traza en él una ciudad, Jerusalén."
,"2":"Haz luego un simulacro de asedio contra ella; levanta contra ella torres movibles, amontona terraplenes, emplaza campamentos, sitúa arietes todo alrededor."
,"3":"Toma en seguida una sartén de hierro y colócala como muro de hierro entre ti y la ciudad. Fija en ella tus ojos; va a ser asediada y tú pondrás el cerco. Sea esto una señal para la casa de Israel."
,"4":"Acuéstate del lado izquierdo y pon sobre él el pecado de la casa de Israel. Durante el tiempo que estés acostado de este lado, cargarás con su pecado."
,"5":"Yo te fijo los años de su pecado en un número de días: ciento noventa días cargarás con el pecado de la casa de Israel."
,"6":"Concluido este plazo, te acostarás del lado derecho y llevarás el pecado de la casa de Judá durante cuarenta días; te fijo un día por cada año."
,"7":"Después volverás tus ojos al asedio de Jerusalén y, extendiendo tu brazo desnudo, profetizarás contra ella."
,"8":"Mira; yo te amarro con cuerdas, de suerte que no te puedas dar la vuelta de un lado al otro hasta que no hayas cumplido los días de tu asedio."
,"9":"Toma trigo, cebada, habas, lentejas, mijo y espelta; ponlos en un recipiente y haz con ello tu pan para comer durante el número de días que estés acostado del lado izquierdo, esto es, ciento noventa días."
,"10":"El alimento que comerás será el de un cuarto de kilo para todo el día."
,"11":"Tendrás también el agua racionada: un litro para todo el día."
,"12":"Y comerás este alimento en forma de galleta de cebada, que cocerás a la vista de ellos sobre excrementos humanos'."
,"13":"Y el Señor continuó: 'Así comerán su pan inmundo los israelitas en medio de las gentes donde los lanzaré'."
,"14":"'¡Ah, Señor Dios -exclamé yo-, mira que yo no me he manchado jamás, no he comido desde mi adolescencia hasta ahora bestia muerta ni despezada, ni jamás carne inmunda entró en mi boca!'."
,"15":"Y me respondió: 'Bien; en lugar de excrementos de hombre, te permito usar boñiga de ganado vacuno para que cuezas tu pan sobre ella'."
,"16":"Y añadió: 'Hijo de hombre, mira, voy a retirar a Jerusalén los víveres: comerán el pan a peso y con ansiedad, y beberán el agua a medida y con angustia,"
,"17":"para que, al faltar el pan y el agua, desfallezca cada uno junto a su hermano y se consuman en su pecado'."
}`)
	CurrentBook.AddChapter(5, `{
"1":"'Hijo de hombre, toma una hoja afilada; la usarás como navaja de barbero para pasarla por tu cabeza y tu barba. Toma luego una balanza de peso exacto y reparte los pelos."
,"2":"Cuando se cumplan los días del asedio, quemarás al fuego una tercera parte en medio de la ciudad, otra tercera parte la cortarás a espada en sus alrededores y la otra la esparcirás al viento, mientras que yo desenvainaré la espada detrás de ellos."
,"3":"Después tomarás un pequeño número de entre éstos y los atarás al vuelo de tu manto;"
,"4":"y de estos mismos tomarás todavía unos pocos, los echarás al fuego y los quemarás en él. De aquí saldrá el fuego. Y dirás a toda la casa de Israel: "
,"5":"Esto dice el Señor Dios: Ésta es la ciudad de Jerusalén, que yo había situado en medio de las naciones y de sus territorios."
,"6":"Pero ella se ha rebelado contra mis leyes con más perversidad que estas naciones, y contra mis decretos más que los países que la circundan, pues han desechado mis leyes y no han procedido según mis mandamientos."
,"7":"Por eso esto dice el Señor Dios: Vosotros sois más rebeldes que las naciones que os rodean, no habéis practicado mis mandamientos, no habéis cumplido mis órdenes, ni siquiera habéis obrado conforme a las costumbres de las naciones que os rodean."
,"8":"Por eso, esto dice el Señor Dios: También yo me vuelvo contra ti y haré justicia en medio de ti a los ojos de las gentes;"
,"9":"haré contigo lo que jamás he hecho ni volveré a hacer jamás, a causa de todas tus nefastas acciones."
,"10":"Los padres devorarán a sus hijos en medio de ti, y los hijos devorarán a sus padres. Ejecutaré contra ti la sentencia y esparciré a todos los vientos lo que aún quede de ti."
,"11":"Te lo juro, dice el Señor Dios: Tú has profanado mi santuario con tus ídolos y tus monstruosidades, pero también yo caeré sin misericordia y sin piedad."
,"12":"Un tercio de tus habitantes morirá de peste y se consumirá de hambre en medio de ti, otro tercio caerá a cuchillo en tus alrededores y el otro lo esparciré yo a todos los vientos, desenvainando detrás de ellos la espada."
,"13":"Desahogaré mi ira, saciaré en ellos mi furor y me vengaré. Entonces sabrán que yo soy el Señor, que yo he hablado en el ardor de mi cólera, cuando desahogue en ellos mi furor."
,"14":"Te reduciré a un desierto, a objeto de vergüenza entre las naciones que te rodean, a los ojos de todos los que pasen."
,"15":"Serás oprobio y vituperio, ejemplo y horror para las naciones circunvecinas, cuando yo haga en ti justicia con indignación y furor, con terrible venganza. Yo, el Señor, he hablado."
,"16":"Cuando yo dispare contra vosotros las terribles flechas del hambre, que harán estragos porque las lanzaré justamente para destruiros, aumentaré el hambre entre vosotros y os quitaré las reservas de víveres."
,"17":"Mandaré contra vosotros el hambre y las bestias feroces, que te dejarán sin hijos; la peste y la sangre pasarán por ti y descargaré contra ti la espada. Yo, el Señor, he hablado'."
}`)
	CurrentBook.AddChapter(6, `{
"1":"El Señor me dijo:"
,"2":"'Hijo de hombre, vuelve tu rostro hacia los montes de Israel y profetiza contra ellos así:"
,"3":"Montes de Israel, escuchad la palabra del Señor Dios. Así habla él a los montes y a las colinas, a las gargantas y a los valles: Ved que yo voy a hacer venir contra vosotros la espada y destruiré las colinas,"
,"4":"vuestros altares serán devastados y hechas pedazos vuestras columnas. Arrojaré a vuestros muertos delante de vuestros ídolos,"
,"5":"pondré los cadáveres de los israelitas delante de sus ídolos y esparciré vuestros huesos alrededor de vuestros altares."
,"6":"Por todo vuestro territorio las ciudades serán arruinadas y devastadas las colinas, a fin de que sean destruidos y devastados vuestros altares, despedazados y aventados vuestros ídolos, hechas añicos vuestras columnas y aniquiladas vuestras obras."
,"7":"Los muertos yacerán en medio de vosotros y sabréis que yo soy el Señor."
,"8":"Sin embargo, dejaré un resto de vosotros, los que hayan escapado a la espada, que dispersaré entre las naciones."
,"9":"Entonces los supervivientes se acordarán de mí en medio de las naciones donde sean deportados. Yo quebrantaré su corazón adúltero, que se apartó de mí, y sus ojos prostituidos ante sus ídolos. Tendrán horror de sí mismos por las perversidades que cometieron a causa de todas sus horribles acciones."
,"10":"Y sabrán que yo soy el Señor y que no en vano los había amenazado con mandarles todos estos males'."
,"11":"Esto dice el Señor Dios: 'Bate las manos, patalea y grita ¡Ay! por todas las horribles acciones de la casa de Israel, que va a caer por la espada, el hambre y la peste."
,"12":"El que está lejos morirá de peste, el que está cerca caerá a espada, el que quede sitiado perecerá de hambre. Desencadenaré contra ellos mi ira."
,"13":"Y sabréis que yo soy el Señor, cuando sus cadáveres, atravesados, estén allí en medio de sus ídolos, alrededor de sus altares, en toda colina elevada, en la cima de todos los montes, bajo todo árbol verde y bajo toda encina frondosa, dondequiera que hayan quemado los perfumes agradables a todos sus ídolos."
,"14":"Extenderé mi mano sobre ellos y dejaré su tierra desierta y desolada, desde el desierto hasta Ribla, dondequiera que habiten, y sabrán que yo soy el Señor'."
}`)
	CurrentBook.AddChapter(7, `{
"1":"El Señor me dijo:"
,"2":"'Hijo de hombre, anuncia: Esto dice el Señor a la tierra de Israel: ¡Se acabó! Ha llegado la hora a los cuatro extremos del país."
,"3":"Ya llega tu fin, porque yo desencadeno mi ira contra ti. Te juzgaré según tus obras y te pediré cuenta de todas tus horribles acciones."
,"4":"No sentiré por ti piedad ni tendré compasión, sino que te juzgaré responsable de tu proceder, porque tus nefastas acciones son manifiestas en medio de ti, y sabréis que yo soy el Señor."
,"5":"Esto dice el Señor: ¡Desventura, desventura!"
,"6":"Ya viene. Se acerca el fin, tu fin, ¡ya es inminente!"
,"7":"Ha sonado tu hora, oh habitante del país, se ha cumplido el tiempo, está cercano el día de consternación, que no de júbilo, en los montes."
,"8":"Dentro de poco derramaré mi furor sobre ti, y sobre ti desencadenaré mi ira. Te juzgaré según tus obras y te pediré cuentas de todas tus nefastas acciones."
,"9":"Y no tendré piedad de ti ni compasión, sino que te juzgaré responsable de tu proceder, porque tus nefastas acciones estarán manifestadas en medio de ti y sabréis que yo soy el Señor, el que hiere."
,"10":"He aquí el día, ya llega. Tu suerte está echada. Florece la injusticia, ha germinado el orgullo"
,"11":"y la violencia se ha hecho cetro de la injusticia. Nada quedará de ello, ni de su riqueza, ni de su esplendor, ni de su magnificencia."
,"12":"Ha llegado la hora, se acerca el día; no se alegre el comprador, el vendedor no se entristezca, porque la ira se cierne sobre todo el pueblo."
,"13":"El vendedor no recuperará lo vendido aunque quede entre los vivos, porque no será revocada la sentencia contra toda su multitud. Nadie tiene segura su vida a causa de sus crímenes."
,"14":"Tocad la trompeta, esté todo preparado. Ninguno marchará a combatir, porque mi furor se cierne sobre todo el pueblo."
,"15":"Está fuera la espada; la peste y el hambre dentro; el que se encuentre en el campo caerá de hambre y peste."
,"16":"Los que escapen huirán a los montes y andarán allí gimiendo como las palomas de los valles, cada uno por sus pecados."
,"17":"Todas las manos caerán, todas las rodillas desfallecerán."
,"18":"Se ceñirán de saco, mas los cubrirá el terror. Todo rostro será cubierto de vergüenza, toda cabeza será rasurada."
,"19":"Tirarán su plata por las calles y su oro se convertirá en basura. Su plata y su oro no lograrán salvarlos en el día de la ira del Señor. No saciarán con ello su hambre ni llenarán su estómago, porque fueron incentivo a su pecado."
,"20":"Estaban pagados del esplendor de sus joyas, con ellas fabricaron las detestables imágenes de sus ídolos; por eso yo se lo convertiré en basura."
,"21":"Se los entregaré como presa a los extranjeros y a los criminales del país como botín y los profanarán."
,"22":"Retiraré mi rostro de ellos y mi tesoro será profanado, penetrarán en él los invasores y lo profanarán."
,"23":"Fabricad cadenas, porque el país está lleno de delitos de sangre y la ciudad repleta de violencia."
,"24":"Yo haré venir a los pueblos más feroces, que se apoderarán de sus casas. Humillaré la soberbia de los poderosos y sus santuarios serán profanados."
,"25":"Llegará la angustia y buscarán paz, pero no la tendrán."
,"26":"Vendrá desgracia sobre desgracia, una mala noticia detrás de otra. Pedirán al profeta una visión; la ley se habrá ausentado del sacerdote, de los ancianos el consejo."
,"27":"El rey estará en duelo, el príncipe sumido en la desolación, las manos de la gente del pueblo temblarán. Yo los trataré según su proceder y los juzgaré según su manera de juzgar, y sabrán que yo soy el Señor'."
}`)
	CurrentBook.AddChapter(8, `{
"1":"El año sexto, el día cinco del sexto mes, estando en mi casa rodeado de los ancianos de Judá, el Señor puso su mano sobre mí."
,"2":"Miré y vi una figura como de un hombre. Desde lo que parecían sus caderas para abajo era de fuego, desde sus caderas para arriba un resplandor semejante al electro."
,"3":"Alargó una especie de mano, me agarró por los cabellos y el espíritu me elevó entre la tierra y el cielo y me llevó, en visiones divinas, a Jerusalén, a la entrada de la puerta interior que da al norte, allí donde estaba situado el ídolo que provoca los celos."
,"4":"Allí estaba la gloria del Señor, semejante a la visión que había tenido en la vega."
,"5":"Y me dijo: 'Hijo de hombre, levanta tus ojos hacia el norte'. Levanté mis ojos hacia el norte, y vi al norte de la puerta del altar el ídolo de los celos en la entrada."
,"6":"Y continuó: 'Hijo de hombre, ¿ves lo que hacen éstos, las acciones nefastas que la casa de Israel comete en este lugar para alejarme de mi santuario? Pues todavía verás acciones más nefastas'."
,"7":"Después me llevó a la entrada del atrio. Miré y vi en la pared un agujero."
,"8":"Y me ordenó: 'Hijo de hombre, atraviesa la pared'. Atravesé la pared y me encontré ante una puerta."
,"9":"'Entra -me dijo- y contempla las acciones nefastas que cometen éstos aquí'."
,"10":"Entré, observé y vi toda clase de reptiles y de animales repugnantes, todos los ídolos de la casa de Israel, pintados por toda la pared."
,"11":"Y setenta hombres de los ancianos de la casa de Israel, entre los cuales se encontraba Jazanías, hijo de Safán, estaban de pie ante aquéllos, cada uno con su incensario en la mano, del cual subía el perfume del incienso."
,"12":"Y me dijo: '¿Has visto, hijo de hombre, lo que hacen los ancianos de Israel en la oscuridad, cada uno en su estancia recargada de pinturas idolátricas, que están diciendo: El Señor no nos ve, el Señor ha abandonado el país?'."
,"13":"Y añadió: 'Verás todavía acciones nefastas peores que éstas'."
,"14":"Y me llevó a la entrada del pórtico del templo que da al norte: allí estaban unas mujeres sentadas plañiendo a Tamuz."
,"15":"Y me dijo: '¿Has visto, hijo de hombre? Pues todavía has de ver acciones nefastas peores que éstas'."
,"16":"Y me llevó al atrio interior del templo del Señor. A la entrada del templo del Señor, entre el vestíbulo y el altar, veinticinco hombres, vueltas sus espaldas al santuario del Señor y sus rostros a oriente, se postraban hacia oriente ante el sol."
,"17":"Y me dijo: '¿Has visto, hijo de hombre? ¿Acaso no le basta al pueblo de Judá cometer las acciones nefastas que cometen aquí, para que llenen también el país de violencia, hasta el punto de provocar aún mi cólera? Mira cómo se llevan el ramo a las narices."
,"18":"¡Pues yo también obraré con furor! No tendré piedad con ellos, ni compasión. Lanzarán gritos a mis oídos, pero no los escucharé'."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Después gritó a mis oídos con voz recia, y dijo: 'Acercaos los que habéis de castigar a la ciudad, cada uno con su instrumento de exterminio en la mano'."
,"2":"Y por la calle de la puerta de arriba que da al norte llegaron seis hombres, cada cual con su instrumento de exterminio en la mano. En medio de ellos había un personaje, vestido de lino, con la cartera de escriba a la cintura. Entraron y se detuvieron junto al altar de bronce."
,"3":"La gloria del Dios de Israel se había levantado del querubín sobre el cual estaba, y se dirigía hacia el umbral del templo. Llamó al hombre vestido de lino, que llevaba a la cintura la cartera de escribir,"
,"4":"y le dijo: 'Pasa por la ciudad, recorre Jerusalén y marca con una cruz la frente de los hombres que gimen y lloran por todas las nefastas acciones que se cometen dentro de ella'."
,"5":"Y pude oír lo que les dijo: 'Recorred la ciudad detrás de él y herid. No se compadezcan vuestros ojos ni tengáis piedad."
,"6":"Matad a ancianos, jóvenes, doncellas, niños y mujeres, hasta el exterminio. Pero no toquéis a los que tengan la cruz en la frente. Empezad por mi santuario'. Empezaron, pues, por los ancianos que estaban delante del templo."
,"7":"Después les dijo: 'Profanad el templo y llenad de muertos los atrios. Y ahora salid'. Salieron y comenzaron a herir por la ciudad."
,"8":"Mientras ellos hacían estragos, quedé yo solo, me arrojé rostro en tierra y grité: '¡Señor Dios! ¿Vas a exterminar a todo el resto de Israel, derramando tu furor sobre Jerusalén?'."
,"9":"Me respondió: '¡El crimen de la casa de Israel y de Judá es demasiado grande, inmenso; el país está cubierto de sangre y la ciudad llena de violencia! Han dicho: El Señor ha abandonado el país, el Señor no lo ve."
,"10":"Pues yo tampoco tendré piedad y compasión de ellos. Les pido cuenta de sus obras'."
,"11":"En aquel momento el hombre vestido de lino, que llevaba la cartera a la cintura, hizo su relación: 'He hecho conforme me mandaste'."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Miré y vi que sobre el firmamento que estaba encima de la cabeza de los querubines había como una piedra de zafiro, y sobre ellos aparecía algo así como un trono."
,"2":"Y dijo al hombre vestido de lino: 'Métete por entre las ruedas, debajo del querubín, toma a manos llenas brasas ardientes de entre los querubines y espárcelas por la ciudad'. Y vi que entró."
,"3":"Los querubines se habían detenido al lado derecho del templo cuando el hombre entró, y la nube llenaba el atrio interior."
,"4":"Después la gloria del Señor se elevó de encima del querubín hacia el umbral del templo, el cual se llenó de la nube, y el atrio quedó inundado del esplendor de la gloria del Señor."
,"5":"El rumor de las alas de los querubines llegaba hasta el atrio exterior, semejante a la voz del todopoderoso cuando habla."
,"6":"El hombre vestido de lino, al recibir la orden de tomar fuego del carro de entre los querubines, fue y se paró junto a la rueda."
,"7":"Entonces el querubín alargó su mano al fuego que estaba entre los querubines, tomó parte de él y lo puso en las manos del hombre vestido de lino, el cual lo tomó y salió."
,"8":"Apareció entonces bien visible en los querubines la forma de una mano humana debajo de sus alas."
,"9":"Yo miré y vi que había cuatro ruedas al lado de los querubines, una junto a cada uno. El aspecto de las ruedas brillaba como el crisólito."
,"10":"Y las cuatro ruedas tenían el mismo aspecto: parecía que estaban una dentro de otra."
,"11":"Al moverse giraban en los cuatro sentidos sin volverse en su dirección, porque se movían hacia el lado donde daba la cabeza, sin volverse en su dirección."
,"12":"Todo su cuerpo, su espalda, sus manos y sus alas, así como las ruedas, estaban cuajadas de ojos todo alrededor, y cada uno de los cuatro tenía su propia rueda."
,"13":"Y escuché que a las ruedas se les daba el nombre de 'torbellino'."
,"14":"Cada uno tenía cuatro caras. La primera era de querubín, la segunda de hombre, la tercera de león y la cuarta de águila."
,"15":"Los querubines se levantaron. Era el mismo ser que yo había visto junto al río Quebar."
,"16":"Cuando se movían los querubines, se movían también a su lado las ruedas; y cuando los querubines alzaban sus alas para elevarse de la tierra, tampoco se apartaban las ruedas de su lado."
,"17":"Cuando ellos se paraban, se paraban también las ruedas; y cuando los querubines se elevaban, se elevaban con ellos las ruedas, pues el espíritu del ser viviente estaba con ellas."
,"18":"La gloria del Señor salió del umbral del templo y se posó sobre los querubines."
,"19":"Los querubines alzaron sus alas y se elevaron de la tierra ante mi vista, y las ruedas se elevaron también junto a ellos. Fueron a posarse a la entrada de la puerta oriental del templo del Señor, y la gloria del Dios de Israel estaba en alto por encima de ellos."
,"20":"Aquellos seres eran los mismos que yo había visto debajo del Dios de Israel, junto al río Quebar, y comprendí que eran querubines."
,"21":"Tenían cada uno cuatro caras y cuatro alas, y bajo las alas algo que parecían manos humanas."
,"22":"Sus caras eran como aquellas que yo había visto junto al río Quebar. Cada uno marchaba de frente."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Después el espíritu me elevó y me llevó a la puerta oriental del templo del Señor, que da a levante; allí, en la entrada de la puerta, estaban veinticinco hombres, entre los cuales vi a Yazanías, hijo de Azur, y a Pelatías, hijo de Banayas, jefes del pueblo."
,"2":"El Señor me dijo: 'Hijo de hombre, éstos son los jefes que proyectan crímenes y traman injusticias en esta ciudad;"
,"3":"los que dicen: ¿acaso no se han construido en poco tiempo las casas de la ciudad? Ella es la olla, nosotros somos la carne."
,"4":"Por eso, profetiza contra ellos, profetiza, hijo de hombre'."
,"5":"Y el espíritu del Señor cayó sobre mí y me dijo: 'Di: Esto dice el Señor: Vosotros habéis dicho esto, oh casa de Israel; conozco la insolencia de vuestro espíritu."
,"6":"Vosotros habéis multiplicado las víctimas en esta ciudad, habéis llenado de cadáveres sus calles."
,"7":"Por tanto, esto dice el Señor Dios: Los muertos, los que vosotros habéis arrojado en medio de ella, son la carne y ella es la olla, pero yo os echaré de ella."
,"8":"Teméis la espada; pues justamente espada haré venir sobre vosotros, declara el Señor Dios."
,"9":"Os arrastraré fuera de la ciudad, os entregaré en manos de extranjeros y ejecutaré en vosotros mi justa venganza."
,"10":"A espada caeréis. Yo os juzgaré en el territorio de Israel y sabréis que yo soy el Señor."
,"11":"La ciudad no será vuestra olla, ni vosotros seréis la carne en medio de ella. Dentro de la frontera de Israel os juzgaré."
,"12":"Y sabréis que yo soy el Señor, cuyos preceptos no habéis observado ni guardado sus mandamientos, sino que habéis vivido según las costumbres de las naciones que os rodean'."
,"13":"Apenas había profetizado, cuando Pelatías, hijo de Banayas, cayó muerto. Entonces yo me arrojé rostro en tierra y grité con voz fuerte: '¡Señor Dios! ¿Vas a exterminar el resto de Israel?'."
,"14":"El Señor me dijo:"
,"15":"'Hijo de hombre, es de tus hermanos, de tus parientes y de toda la casa de Israel de quienes dicen los habitantes de Jerusalén: Estáis lejos del Señor, a nosotros se nos ha dado el país en posesión."
,"16":"Anúnciales: Esto dice el Señor Dios: Sí, yo los he alejado entre las naciones, los he dispersado por tierras extrañas; pero yo mismo he sido un santuario para ellos durante el breve tiempo en que están desterrados en estos países."
,"17":"Diles: Esto dice el Señor Dios: Os recogeré de entre las naciones, os congregaré de las tierras en las que habéis sido dispersados y os daré la tierra de Israel."
,"18":"Vendrán ellos y retirarán de ella todos sus ídolos y todas sus monstruosidades."
,"19":"Les daré un solo corazón e infundiré en ellos un espíritu nuevo; quitaré de su pecho el corazón de carne"
,"20":"para que caminen conforme a mis leyes, guarden mis preceptos y los pongan en práctica. Ellos serán mi pueblo y yo seré su Dios."
,"21":"Pero a aquellos cuyo corazón va tras los ídolos y todas sus horribles prácticas, yo haré recaer su conducta sobre su cabeza', dice el Señor Dios."
,"22":"Los querubines alzaron entonces sus alas y las ruedas se pusieron en movimiento al mismo tiempo que ellos, mientras la gloria del Dios de Israel estaba sobre ellos, en lo alto."
,"23":"Y la gloria del Señor se elevó, salió de la ciudad y fue a detenerse sobre el monte que está al oriente de ella."
,"24":"Entonces el espíritu se levantó y me llevó en visión, en el espíritu de Dios, a Caldea, donde los deportados. Después desapareció de mí la visión que había contemplado."
,"25":"Yo comuniqué entonces a todos los deportados todas las cosas que el Señor me había hecho ver."
}`)
	CurrentBook.AddChapter(12, `{
"1":"El Señor me dijo:"
,"2":"'Hijo de hombre, tú vives en medio de la raza de rebeldes. Tienen ojos para ver y no ven, oídos para oír y no oyen; son un pueblo de rebeldes."
,"3":"Hijo de hombre, prepara tu equipaje de emigrante y emigra en pleno día a sus propios ojos; emigrarás de tu lugar a otra localidad ante su vista. Es posible que comprendan, aunque son gente rebelde."
,"4":"Sacarás tu equipaje, como un equipaje de emigrante, en pleno día, ante sus ojos. Saldrás por la tarde, a la vista de ellos, como parte un emigrante."
,"5":"Haz, ante sus ojos, un agujero en la pared y sal por él."
,"6":"A su vista, cargarás el equipaje a la espalda y partirás con la cara cubierta para no ver la tierra, pues te he puesto como símbolo para la casa de Israel'."
,"7":"Yo lo hice todo como me había sido ordenado. Preparé mi equipaje de emigrante en pleno día; por la tarde hice un agujero en el muro con las manos y salí en la oscuridad con el equipaje a mis espaldas ante su vista."
,"8":"Por la mañana el Señor me dijo:"
,"9":"'Hijo de hombre, ¿no te ha preguntado la casa de Israel, esta gente rebelde: qué haces?"
,"10":"Contéstales: Esto dice el Señor Dios: Este oráculo se refiere al rey de Jerusalén y a toda la casa de Israel que habita en ella."
,"11":"Diles: Yo soy un símbolo para vosotros. Como he hecho yo, así tendréis que hacer vosotros. Seréis deportados, iréis al destierro."
,"12":"Hasta el rey, que se sienta en medio de ellos, se cargará el equipaje a las espaldas, saldrá en la oscuridad de la noche por una brecha que abrirán en el muro para sacarlo fuera y se tapará la cara para no ver su país con sus propios ojos."
,"13":"Pero yo tenderé mi red sobre él y quedará preso en mi redada; y le conduciré a Babilonia, a la tierra de los caldeos, pero no la verá y morirá allí."
,"14":"Esparciré a todos los vientos a su séquito, su guardia y sus servidores, y desenvainaré la espada detrás de ellos."
,"15":"Y sabrán que yo soy el Señor, cuando los haya dispersado entre las gentes y los haya esparcido entre las naciones."
,"16":"Sin embargo, todavía preservaré a algunos de ellos de la espada, del hambre y de la peste, para que cuenten entre las gentes donde sean dispersados todas las nefastas acciones que cometieron. Y sabrán que yo soy el Señor'."
,"17":"El Señor me dirigió de nuevo la palabra y me dijo:"
,"18":"'Hijo de hombre, come tu pan con temor y bebe tu agua con estremecimiento y angustia."
,"19":"Y dirás al pueblo del país: Esto dice el Señor Dios a los habitantes de Jerusalén y a la tierra de Israel: Comerán su pan con angustia y beberán su agua con estremecimiento, porque su tierra será devastada a causa de la violencia de todos sus habitantes."
,"20":"Las ciudades populosas quedarán desiertas y la tierra será desolada, y sabréis que yo soy el Señor'."
,"21":"El Señor me volvió a dirigir la palabra y me dijo:"
,"22":"'Hijo de hombre, ¿qué significa ese proverbio que andáis repitiendo acerca de la tierra de Israel: Pasan los días y toda visión se desvanece?"
,"23":"Diles: Esto dice el Señor Dios: Haré que calle este proverbio y no se oirá repetir más en Israel. Diles en cambio: Se acercan los días y el cumplimiento de toda visión."
,"24":"Porque de ahora en adelante no habrá más visiones mentirosas ni adivinaciones falsas en medio de la casa de Israel."
,"25":"Pues yo, el Señor, hablaré. Todo cuanto yo diga será dicho y hecho sin tardanza. Porque será en vuestro tiempo, oh gente rebelde, cuando yo diré algo y lo cumpliré', dice el Señor Dios."
,"26":"El Señor me dijo:"
,"27":"'Hijo de hombre, la casa de Israel está diciendo: La visión que éste contempla se refiere a tiempos futuros; éste profetiza para un porvenir lejano."
,"28":"Diles: Esto dice el Señor Dios: Ninguna de mis palabras se diferirá más. Será cosa dicha y hecha', dice el Señor Dios."
}`)
	CurrentBook.AddChapter(13, `{
"1":"El Señor me dijo:"
,"2":"'Hijo de hombre, profetiza contra los profetas de Israel, habla y anuncia a los que profetizan por su propia cuenta: Oíd la palabra del Señor."
,"3":"Esto dice el Señor Dios: ¡Ay de los profetas insensatos, que siguen su propio espíritu y no ven nada!"
,"4":"Como chacales entre las ruinas son tus profetas, oh Israel."
,"5":"No habéis escalado a las brechas, ni habéis reconstruido los muros de la casa de Israel, para que pueda resistir en la batalla el día del Señor."
,"6":"Tienen visiones falsas y profetizan mentiras los que dicen: ¡Oráculo del Señor!, sin que el Señor los haya mandado, ¡y esperan que se cumpla su palabra!"
,"7":"¿No es cierto que tenéis visiones falsas y anunciáis presagios mentirosos cuando decís: Oráculo del Señor, siendo así que yo no he hablado?"
,"8":"Por tanto, esto dice el Señor Dios: Porque vuestras palabras son falsas y vuestras visiones mentirosas, yo me pongo contra vosotros, declara el Señor Dios."
,"9":"Caerá mi mano sobre los profetas que tienen visiones falsas y anuncian presagios mentirosos, no serán admitidos en el consejo de mi pueblo, no serán inscritos en el libro de la casa de Israel, ni entrarán en la tierra de los hijos de Jacob, y sabréis que yo soy el Señor Dios."
,"10":"Porque han engañado a mi pueblo asegurándole: ¡Paz!, cuando no había paz, y mientras el pueblo construye un muro ellos lo recubren de argamasa,"
,"11":"di a los que recubren con argamasa: ¡Se caerá! Sobrevendrá un aguacero torrencial, caerá abundante granizo y soplará un viento de tempestad;"
,"12":"mirad el muro, se ha derrumbado; no se os dirá entonces: ¿Dónde está la argamasa con que lo recubristeis?"
,"13":"Por tanto, esto dice el Señor Dios: En mi cólera desencadenaré un viento impetuoso, lluvia a torrentes caerá en mi furor, granizos sin cuento en el ardor de la destrucción."
,"14":"Derribaré el muro que habéis revocado de argamasa, lo echaré por tierra hasta que aparezcan sus cimientos. Se desplomará y pereceréis entre los escombros; sabréis entonces que yo soy el Señor."
,"15":"Desahogaré mi cólera contra el muro y contra los que lo recubren de argamasa. Y os diré: Ya no existe el muro ni los que lo revocaron,"
,"16":"esto es, los profetas de Israel que profetizaban sobre Jerusalén y tenían para ella visiones de paz, no habiendo paz', dice el Señor Dios."
,"17":"Y tú, hijo de hombre, encárate con las hijas de tu pueblo que profetizan por su propia cuenta, y profetiza contra ellas."
,"18":"Les dirás: Esto dice el Señor Dios: ¡Ay de aquellas que cosen bandas para toda clase de puños y hacen velos para cabezas de todas las tallas, con ánimo de cazar sus vidas! Queréis cazar la vida de las gentes de mi pueblo y salvaguardar vuestra propia vida."
,"19":"Me habéis profanado ante mi pueblo por un puñado de cebada y un pedazo de pan, dais muerte a quien debe vivir y dejáis vivir a quien debe morir, engañando a mi pueblo que cree en mentiras."
,"20":"Por tanto, esto dice el Señor: Aquí estoy yo contra vuestras bandas con las que cazáis a las gentes como pájaros; las arrancaré de vuestros brazos y soltaré al aire libre las gentes que cazáis."
,"21":"Rasgaré vuestros velos y libraré a mi pueblo de vuestras manos; ya no será más vuestra presa y sabréis que yo soy el Señor."
,"22":"Porque habéis entristecido el corazón del justo con mentiras, cuando yo mismo no lo entristezco, y habéis apoyado al criminal para que no se convierta de su mala conducta y salve su vida,"
,"23":"por esto no tendréis más visiones mentirosas, ni anunciaréis más presagios. Yo arrancaré a mi pueblo de vuestras manos y sabréis que yo soy el Señor."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Algunos ancianos de Israel vinieron a verme y se sentaron ante mí."
,"2":"El Señor me dirigió entonces la palabra y me dijo:"
,"3":"'Hijo de hombre, estos hombres han metido sus ídolos en su corazón y tienen continuamente ante sus ojos la ocasión de pecar. ¿Me dejaré consultar por ellos?"
,"4":"Por eso, anúnciales: Esto dice el Señor Dios: A todo aquel de la casa de Israel que haya acogido a sus ídolos en su corazón y tenga ante sus ojos el incentivo de su pecado y luego se presente al profeta, le responderé yo mismo, el Señor, a pesar de la multitud de sus ídolos,"
,"5":"a fin de llegar hasta el corazón de la casa de Israel, que se ha alejado de mí a causa de todos sus ídolos."
,"6":"Por eso, di a la casa de Israel: Esto dice el Señor Dios: Convertíos, alejaos de vuestros ídolos y dejad vuestras prácticas detestables."
,"7":"Porque a todo aquel de la casa de Israel o de los extranjeros que viven en Israel que se aleje de mí y meta sus ídolos en su corazón, teniendo así ante los ojos el incentivo de su pecado, y venga luego al profeta para consultarme, yo mismo, el Señor, le daré respuesta."
,"8":"Volveré mi rostro contra ese hombre, le haré un ejemplo proverbial y le extirparé de en medio de mi pueblo, y sabréis que yo soy el Señor."
,"9":"Y si hasta el profeta se deja seducir y habla, es que yo, el Señor, he dejado a este profeta sucumbir a la seducción; y extenderé mi mano contra él y lo extirparé de en medio de mi pueblo Israel."
,"10":"Ambos sufrirán la pena de su maldad; el castigo del que consulta será semejante al del profeta,"
,"11":"a fin de que la casa de Israel no se descarríe más lejos de mí, ni siga manchándose con sus crímenes, sino que sean mi pueblo y yo sea su Dios', dice el Señor Dios."
,"12":"El Señor me dirigió de nuevo la palabra y me dijo:"
,"13":"'Hijo de hombre, si un país peca contra mí y comete un crimen, yo extenderé mi mano contra él, le quitaré los víveres, mandaré el hambre a aquella tierra y exterminaré en ella hombres y animales."
,"14":"Pero si en ese país se encontrasen estos tres hombres: Noé, Daniel y Job, ellos, debido a su justicia, lograrían salvar su vida, dice el Señor Dios."
,"15":"Y si yo hiciese venir contra este país animales dañinos que lo asolaran y redujeran a un desierto que nadie se atreviera a cruzar por miedo a las fieras,"
,"16":"y se encontraran allí esos tres hombres, lo juro, dice el Señor Dios, que ni a sus hijos ni a sus hijas salvarían; sólo se salvarían ellos, y el país quedaría igualmente convertido en un desierto."
,"17":"O si yo hiciese venir contra ese país la espada y dijese: Que pase la espada por ese país y extermine hombres y animales,"
,"18":"si se encontrasen allí aquellos tres hombres, lo juro, dice el Señor Dios, que no salvarían ni a sus hijos ni a sus hijas, sólo se salvarían ellos."
,"19":"Y si mandase la peste sobre aquel país y desahogase en sangre mi ira contra ellos exterminando hombres y animales,"
,"20":"si se encontrasen entre ellos Noé, Daniel y Job, lo juro, dice el Señor Dios, que no salvarían ni a sus hijos ni a sus hijas, sólo se salvarían ellos debido a su justicia'."
,"21":"Esto dice el Señor Dios: 'Cuando yo mande contra Jerusalén estos cuatro azotes: espada, hambre, animales feroces y peste para exterminar de ella hombres y animales,"
,"22":"dejaré, sin embargo, supervivientes que pondrán a salvo hijos e hijas. Y vendrán donde vosotros, para que conozcáis su conducta y sus obras y os consoléis de los males que yo he mandado contra Jerusalén, de todo lo que he desencadenado contra ella."
,"23":"Ellos os consolarán cuando veáis su conducta y sus obras y os convenzáis de que no sin motivo hice todo lo que hice en Jerusalén', dice el Señor Dios."
}`)
	CurrentBook.AddChapter(15, `{
"1":"El Señor me dirigió la palabra y me dijo:"
,"2":"'Hijo de hombre, ¿en qué supera el leño de la vid al leño de cualquier otro árbol del bosque?"
,"3":"¿Acaso se toma de esta madera para hacer algún trabajo o se hace de él alguna estaca para colgar un objeto?"
,"4":"No, se echa al fuego para que lo consuma: el fuego consume sus dos extremos, y el centro queda quemado; ¿acaso es útil todavía para alguna obra?"
,"5":"Ya cuando estaba intacto no se podía hacer nada con él; pues, ¿se podrá hacer algo con él después que el fuego lo ha quemado y consumido?"
,"6":"Por tanto, esto dice el Señor Dios: lo mismo que el leño de la vid entre los árboles del bosque, al cual he entregado como pasto al fuego, así trataré a los habitantes de Jerusalén."
,"7":"He vuelto contra ellos mi rostro. Del fuego han escapado, pero otro fuego los devorará. Y sabréis que yo soy el Señor, cuando vuelva mi rostro contra ellos."
,"8":"Convertiré el país en un desierto por los delitos que han cometido', dice el Señor Dios."
}`)
	CurrentBook.AddChapter(16, `{
"1":"El Señor me dijo:"
,"2":"'Hijo de hombre, haz saber a Jerusalén todas sus prácticas detestables."
,"3":"Dirás: Esto dice el Señor a Jerusalén: Tus orígenes y tu nacimiento proceden de la tierra de los cananeos; tu padre fue un amorreo y tu madre una hitita."
,"4":"Cuando naciste, el día que viniste al mundo, no te fue cortado el cordón, no fuiste lavada con agua pura para limpiarte; no te hicieron las fricciones de sal, ni fuiste envuelta en pañales."
,"5":"Nadie hizo contigo estos deberes de piedad por compasión a ti, sino que, como un ser despreciable, fuiste expuesta en campo abierto el día de tu nacimiento."
,"6":"Pero yo, pasando junto a ti, te vi agitándote en tu sangre y te dije cuando estabas en tu sangre: Vive"
,"7":"y crece como la hierba de los campos. Y tú creciste, te desarrollaste y llegaste a la flor de tu juventud; se formaron tus senos y tu pelo brotó; pero seguías desnuda y descubierta."
,"8":"Yo pasé junto a ti y te vi. Estabas ya en la edad del amor; entonces extendí el vuelo de mi manto sobre ti y recubrí tu desnudez; luego te presté juramento, me uní en alianza contigo, dice el Señor Dios, y tú fuiste mía."
,"9":"Te lavé con agua, te limpié tu sangre y te ungí con óleo;"
,"10":"te vestí con vestidos recamados, te di zapatos de cuero fino, te ceñí de lino y te cubrí de seda."
,"11":"Te adorné con joyas, puse brazaletes en tus muñecas y un collar en tu cuello;"
,"12":"puse un anillo en tu nariz, pendientes en tus orejas y una espléndida corona en tu cabeza."
,"13":"Brillabas así de oro y de plata, cubierta de lino fino, de seda y bordados; flor de harina, miel y aceite era tu alimento. Te hiciste cada vez más hermosa y llegaste a la dignidad real."
,"14":"La fama de tu belleza se difundió entre las gentes, porque era perfecta por el esplendor que yo te había dado, dice el Señor Dios."
,"15":"Pero tú, confiada en tu belleza y valiéndote de tu fama, te metiste a prostituta y te ofreciste a todo el que pasaba, entregándote a él;"
,"16":"tomaste tus vestidos y te preparaste en las colinas tiendas de abigarrados colores, para entregarte en ellas a la lujuria, como no había sucedido ni sucederá jamás."
,"17":"Tomaste tus espléndidos adornos de oro y plata, que yo te había regalado, y te hiciste con ellos estatuas de hombre para prostituirte ante ellas;"
,"18":"las recubriste con tus vestidos recamados y ofreciste ante ellas mi aceite y mis perfumes."
,"19":"El pan que yo te había dado, la flor de harina, el óleo y la miel con que te alimentaba lo presentaste ante ellas, como ofrenda de perfume agradable, dice el Señor Dios."
,"20":"Tomaste también a tus hijos y a tus hijas que me habías dado, y los ofreciste en sacrificio, como alimento, a aquellos ídolos. ¿Acaso no era suficiente tu prostitución,"
,"21":"que degollaste también a mis hijos y los ofreciste en su honor, quemándolos en el fuego?"
,"22":"Y entre todas tus prácticas detestables y tus prostituciones no te acordaste de los días de tu infancia, cuando estabas desnuda y descubierta, agitándote en tu sangre."
,"23":"Pero para colmo de perversión -¡ay, ay de ti!, dice el Señor Dios-,"
,"24":"en toda plaza te preparaste un prostíbulo y te construiste un lugar elevado;"
,"25":"en toda cabecera de camino te levantaste un lugar de pecado y deshonraste tu belleza ofreciéndote a cualquiera que pasaba, multiplicando tus prostituciones."
,"26":"Te prostituiste a los hijos de Egipto, tus vecinos de cuerpos fornidos, y multiplicaste tus prostituciones para irritarme."
,"27":"Entonces yo extendí mi mano contra ti, reduje tu ración y te abandoné a merced de tus enemigas, las hijas de los filisteos, que se avergonzaban de tu conducta descarada."
,"28":"Después, no harta todavía, te prostituiste a los hijos de Asiria; te prostituiste, pero tampoco quedaste satisfecha."
,"29":"Multiplicaste tus prostituciones en la tierra de los comerciantes, los caldeos, y tampoco quedaste harta."
,"30":"¡Oh, qué débil era tu corazón, dice el Señor Dios, cuando hacías todas estas cosas, dignas de una prostituta desvergonzada!"
,"31":"¡Cuando te levantabas un prostíbulo a la cabecera de todo camino y te construías un lugar de pecado en toda plaza! Ni siquiera fuiste como la prostituta que recoge la paga,"
,"32":"sino como la adúltera que, en lugar de su marido, toma ajenos."
,"33":"A toda prostituta se la da su paga; pero tú has dado tu dote a cuantos te hacían la corte y les has ofrecido regalos para que vinieran de todas partes y se prestasen a tus prostituciones."
,"34":"Te ha sucedido al revés que a las otras mujeres en tus prostituciones; ninguno corrió detrás de ti solicitándote, sino que repartías tú misma regalos, mientras que a ti ninguno te pagó. ¡Ha sucedido lo contrario!"
,"35":"Por tanto, prostituta, escucha la palabra del Señor."
,"36":"Esto dice el Señor Dios: Por haber prodigado tu vergüenza y descubierto tu desnudez en tus prostituciones con tus amantes, por todos tus horrendos ídolos y por la sangre de los hijos que les has ofrecido,"
,"37":"por eso yo reuniré a todos tus amantes a quienes te entregabas, no sólo a los que amaste, sino también a los que aborreciste; los congregaré contra ti de todas partes y les descubriré tu desnudez para que la vean."
,"38":"Te impondré el castigo reservado a las adúlteras y a las homicidas y te abandonaré a la saña y a los celos."
,"39":"Te entregaré en sus manos y ellos derruirán tus lugares de culto, demolerán tus prostíbulos, te despojarán de tus vestidos, te arrancarán tus espléndidos adornos y te dejarán desnuda y al descubierto."
,"40":"Traerán contra ti una multitud, te apedrearán y te atravesarán con sus espadas."
,"41":"Prenderán fuego a tus casas, ejecutarán la sentencia contra ti a la vista de otras muchas mujeres y haré que dejes de prostituirte y no vuelvas a dar salario de prostituta."
,"42":"Cuando haya desahogado mi ira contra ti, mi celo por ti se aplacará, me apaciguaré y no me encolerizaré más."
,"43":"Porque no te has acordado del tiempo de tu juventud y me has provocado la ira con todas estas cosas, yo también haré recaer tu conducta sobre tu cabeza, dice el Señor Dios. Pues, ¿no has cometido un crimen horrible con todas tus prácticas detestables?"
,"44":"Los que dicen refranes dirán de ti éste: Cual la madre, tal la hija."
,"45":"Eres digna de tu madre, que abandonó a su marido y a sus hijos; digna hermana de tus hermanas, que abandonaron a sus maridos y a sus hijos. Vuestra madre fue una hitita, vuestro padre un amorreo."
,"46":"Tu hermana mayor es Samaría, que, junto con sus hijas, habita a tu izquierda, y tu hermana menor es Sodoma, que, junto con sus hijas, habita a tu derecha."
,"47":"Y no sólo has seguido su conducta y has imitado sus prácticas detestables, sino que te has comportado peor que ellas en todo tu proceder."
,"48":"Te juro, dice el Señor Dios, que tu hermana Sodoma y sus hijas no fueron tan perversas como tú y tus hijas."
,"49":"Éste fue el crimen de Sodoma, tu hermana, y de sus hijas: soberbia, gula y pereza; no socorrieron al pobre, al indigente,"
,"50":"sino que se llenaron de orgullo y cometieron lo que yo detesto; por eso los aniquilé, como has visto."
,"51":"Samaría no cometió ni la mitad de tus pecados. Tú has multiplicado tus acciones detestables más que ellas, hasta hacer que parezcan justas tus hermanas al lado de todas las infamias que tú has cometido."
,"52":"Carga, por tanto, con tu deshonra; tú, que con tus pecados, mucho más horribles que los de tus hermanas, las has rehabilitado a ellas, pues a tu lado ellas parecen inocentes. Avergüénzate, pues, tú y carga con tu deshonra, porque has hecho que tus hermanas parezcan inocentes."
,"53":"Mas yo cambiaré su suerte, la suerte de Sodoma y de sus hijas, la suerte de Samaría y de sus hijas y tu propia suerte en medio de ellas,"
,"54":"a fin de que cargues con tu deshonra y te avergüences de cuanto has hecho, para consuelo de ellas."
,"55":"Tu hermana Sodoma y sus hijas serán restablecidas en su antiguo estado; Samaría y sus hijas serán restablecidas en su antiguo estado, y también tú y tus hijas seréis restablecidas en vuestra primera condición."
,"56":"¿No hiciste acaso burla de tu hermana Sodoma el día de tu soberbia,"
,"57":"antes que fuese puesta al descubierto tu desnudez? Pues ahora eres tú la burla de las edomitas y de todos sus alrededores y de las filisteas, que por todas partes te desprecian."
,"58":"Llevas sobre ti el peso de tu desvergüenza y de tus acciones detestables, dice el Señor."
,"59":"Porque esto dice el Señor Dios: Te he pagado con arreglo a lo que hiciste, al menospreciar el juramento hasta el punto de quebrantar la alianza."
,"60":"Pero yo me acordé de la alianza pactada contigo en los días de tu juventud y renovaré contigo una alianza eterna."
,"61":"Tú te acordarás de tu conducta y te avergonzarás de ella cuando recibas a tus hermanas mayores junto con las menores; yo te las daré como hijas, pero no en virtud de la alianza pactada contigo."
,"62":"Porque seré yo quien renueve mi alianza contigo, y sabrás entonces que yo soy el Señor,"
,"63":"para que te acuerdes y te avergüences y no te atrevas a abrir más la boca de sonrojo, cuando yo te haya perdonado todo lo que has hecho', dice el Señor Dios."
}`)
	CurrentBook.AddChapter(17, `{
"1":"El Señor me dijo:"
,"2":"'Hijo de hombre, propón un enigma y cuenta una parábola a la casa de Israel."
,"3":"Les dirás: Esto dice el Señor: El águila grande, de las grandes alas, de enormes plumas, de espeso plumaje abigarrado, vino al Líbano y cortó la copa de un cedro;"
,"4":"arrancó la punta de sus ramas, la llevó al país de los mercaderes,y la puso en una ciudad de comerciantes."
,"5":"Luego tomó un brote del país,y lo puso en un campo preparado; lo colocó junto a aguas generosas, lo plantó como un sauce"
,"6":"y germinó y se hizo una vid desbordante, de poca altura; sus sarmientos tiraban hacia el águila,y sus raíces estaban bajo ella. Se hizo una vid, echó ramas, multiplicó los sarmientos."
,"7":"Había también otra águila grande, de largas alas y espeso plumaje. Y he aquí que esta vid tendió sus raíces hacia ella, hacia ella alargó sus sarmientos, para que la regase más que la tierra donde estaba plantada."
,"8":"En buen terreno, junto a aguas generosas estaba plantada, para echar pámpanos y dar fruto, para hacerse una vid exuberante."
,"9":"Di: Esto dice el Señor Dios: ¿Podrá prosperar?,¿No arrancará sus raíces el águila, hará caer sus frutos y se secará?,Sí, se secarán sus brotes tiernos,y no hará falta gran esfuerzo,ni pueblo numeroso para arrancarla de raíz."
,"10":"Miradla, está plantada; ¿podrá prosperar?,O al soplar el viento del este, ¿no se secará?,En el mismo suelo en que germinó se secará'."
,"11":"El Señor me dijo:"
,"12":"'Di a esta raza rebelde: ¿No sabéis lo que significa todo esto? Diles: Mirad, el rey de Babilonia llegó a Jerusalén, tomó a su rey y a sus príncipes y los llevó a Babilonia."
,"13":"Después escogió uno de estirpe real e hizo con él un pacto. Le obligó bajo juramento y se llevó a los magnates del país,"
,"14":"a fin de que quedase un reino humilde que no pudiese sublevarse de nuevo, sino que guardase su pacto para poder subsistir."
,"15":"Pero éste se ha rebelado contra él enviando sus mensajeros a Egipto en busca de caballos y hombres en abundancia. ¿Podrá tener éxito? ¿Podrá librarse quien hizo tales cosas? El que ha quebrantado un pacto, ¿podrá escapar?"
,"16":"Vivo yo, dice el Señor Dios, que en el país del rey que le había dado el trono, cuyo juramento ha despreciado y cuyo pacto ha roto, allí, en Babilonia, morirá."
,"17":"No le apoyará el Faraón en la guerra con grandes fuerzas ni muchos hombres cuando se levanten terraplenes y se construyan baluartes de asedio para exterminar a muchas personas."
,"18":"Ha despreciado el juramento, ha roto el pacto; después de haber dado su mano, ha hecho todo esto. No tendrá remedio."
,"19":"Por tanto, esto dice el Señor Dios: Le juro que el juramento mío que ha menospreciado, mi pacto que ha roto haré que recaiga sobre su cabeza."
,"20":"Extenderé sobre él mi red y quedará preso en mi redada. Lo llevaré a Babilonia y allí le pediré cuentas de la infidelidad cometida contra mí."
,"21":"Los mejores soldados de todos sus escuadrones caerán a espada, y los que queden serán esparcidos a todos los vientos; y sabréis que yo, el Señor, he hablado'."
,"22":"Esto dice el Señor Dios: 'También yo tomaré la copa de un alto cedro y la plantaré; de la punta de sus ramas tomaré un ramo,y lo plantaré yo mismo en un monte muy alto,"
,"23":"en el monte sublime de Israel lo plantaré; echará ramas y dará frutos y se hará un magnífico cedro. Bajo él habitarán toda clase de pájaros, toda clase de aves morará a la sombra de sus ramas."
,"24":"Y sabrán todos los árboles del bosque que yo, el Señor, humillo al árbol elevado y exalto al árbol humilde, hago secarse el árbol verde y reverdecer el árbol seco. Yo, el Señor, lo he dicho y lo haré'."
}`)
	CurrentBook.AddChapter(18, `{
"1":"El Señor me dijo:"
,"2":"'¿Por qué circula entre vosotros este refrán en el país de Israel: Los padres comieron el agraz,y los dientes de los hijos tienen la dentera?"
,"3":"Por mi vida, dice el Señor Dios, que no repetiréis más este refrán en Israel."
,"4":"Pues todas las vidas son mías; la vida del padre lo mismo que la vida del hijo; quien peque es el que morirá."
,"5":"Si un hombre es justo y observa el derecho y la justicia;"
,"6":"si no banquetea en los montes ni alza sus ojos a los ídolos de la casa de Israel; si no deshonra a la mujer de su prójimo ni se acerca a la mujer en la menstruación;"
,"7":"si no oprime a nadie, devuelve la prenda al deudor, no comete robo, da su pan al hambriento y viste al desnudo;"
,"8":"si no presta con usura ni toma interés; si aparta su mano de la injusticia y juzga con imparcialidad entre hombre y hombre;"
,"9":"si camina en mis preceptos y observa mis leyes obrando con fidelidad, tal hombre es justo y vivirá, dice el Señor Dios."
,"10":"Y si éste engendra un hijo violento y sanguinario que cometa alguna de estas cosas"
,"11":"que él mismo no había cometido, un hijo que banquetea en los montes, deshonra a la mujer de su prójimo,"
,"12":"oprime al pobre y al indigente, comete robos, no restituye la prenda, alza los ojos a los ídolos, practica cosas detestables,"
,"13":"presta con usura y acepta interés, este hijo no vivirá, porque ha cometido todas estas monstruosidades; morirá y su sangre recaerá sobre él."
,"14":"Pero si engendra un hijo que, después de haber visto todos los pecados cometidos por su padre, teme y no los imita:"
,"15":"no va a banquetear en los montes, no alza los ojos a los ídolos de la casa de Israel, no deshonra a la mujer de su prójimo,"
,"16":"no oprime a nadie, no se guarda la prenda, no comete robos, da su pan al hambriento y viste al desnudo,"
,"17":"aparta su mano de la injusticia, no presta a interés con usura, observa mis preceptos y camina según mis leyes, un hijo así no morirá por la injusticia de su padre; vivirá."
,"18":"Su padre, en cambio, que oprimió o despojó al prójimo y no hizo el bien en medio de su pueblo, morirá por sus propios pecados."
,"19":"Me diréis: ¿Por qué no carga el hijo con la culpa de su padre? Porque el hijo ha practicado el derecho y la justicia, ha observado todos mis preceptos y los ha puesto en práctica. Por eso vivirá."
,"20":"El que peca es el que morirá. El hijo no cargará con la culpa del padre, ni el padre con la del hijo. Al justo se le imputará su justicia y al injusto su injusticia."
,"21":"Y si el delincuente se convierte de todos los delitos que ha cometido, observa todos mis preceptos y practica el derecho y la justicia, vivirá, sin duda; no morirá."
,"22":"Ninguno de los delitos cometidos le será recordado, sino que debido a la justicia que ha practicado vivirá."
,"23":"¿Es que yo me complazco en la muerte del delincuente, dice el Señor Dios, y no más bien en que se convierta y viva?"
,"24":"Igualmente, si el justo se aparta de su justicia, comete la injusticia, según las acciones detestables cometidas por el criminal, ¿podrá vivir? No se recordará nada de toda la justicia que había practicado. Por la infidelidad y por el delito que ha cometido morirá."
,"25":"Me diréis: El camino del Señor no es justo. Escucha, casa de Israel: ¿Que no son justos mis caminos? ¿No son más bien vuestros caminos los que no son justos?"
,"26":"Si el justo se aparta de su justicia para cometer la injusticia y en ella muere, muere por la injusticia que ha cometido."
,"27":"Y si el criminal se aparta de la injusticia que había cometido y practica el derecho y la justicia, salvará su vida."
,"28":"Ha abierto los ojos y se ha convertido de los delitos cometidos; por eso vivirá, no morirá."
,"29":"Mas la casa de Israel anda diciendo: Los caminos del Señor no son justos. ¿Que no son justos mis caminos, casa de Israel? ¿No son más bien los vuestros los que no son justos?"
,"30":"Yo juzgaré, pues, a cada cual según su conducta, casa de Israel, dice el Señor Dios. Convertíos y abandonad todas vuestras injusticias, y la injusticia no será más vuestra ruina."
,"31":"Libraos de todos los pecados que habéis cometido contra mí, formaos un corazón nuevo y un espíritu nuevo. ¿Por qué queréis morir, casa de Israel?"
,"32":"Yo no quiero la muerte de nadie, sea quien sea, dice el Señor Dios. Convertíos y viviréis."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Y tú entona una elegía sobre los príncipes de Israel"
,"2":"y di: '¿Qué era tu madre? Una leona entre leones. Echada en medio de los leoncillos crió a sus cachorros."
,"3":"Exaltó a uno de sus cachorros, que se hizo un león joven, aprendió a atrapar la presa y a devorar hombres."
,"4":"Mandaron gentes contra él. Quedó preso en su fosa y lo llevaron con grillos a Egipto."
,"5":"Al ver la leona que tardaba, que no había esperanza de retorno, tomó otro de sus cachorros y le hizo león joven."
,"6":"Andaba éste entre los leones, se hizo un león joven, aprendió a atrapar la presa y a devorar hombres."
,"7":"Devastó sus palacios, asoló sus ciudades; país y habitantes estaban espantados al oír su rugido."
,"8":"A su caza salieron las gentes de las regiones circundantes, tendieron contra él una red y en su fosa quedó preso."
,"9":"Con grillos lo encerraron en jaula, lo llevaron al rey de Babilonia, que lo metió en una fortaleza, para que no se oyera más su rugido por los montes de Israel."
,"10":"Tu madre era como una vid plantada junto a las aguas, exuberante de frutos y ramas por la abundancia de agua."
,"11":"Echó un ramo robusto, que llegó a ser cetro real. Su tronco sobresalió entre los arbustos, se distinguía por su altura y su abundancia de sarmientos."
,"12":"Mas fue arrancada con furor, derribada en tierra, y el viento del este agostó sus frutos; quedó rota, su rama robusta se secó y lo devoró todo el fuego."
,"13":"Ahora está plantada en el desierto, en tierra árida y reseca."
,"14":"Ha salido fuego de su tronco que devoró ramas y frutos. No ha quedado ni un solo ramo fuerte, ni un cetro real'."
}`)
	CurrentBook.AddChapter(20, `{
"1":"En el año séptimo, el día diez del quinto mes, vinieron a consultar al Señor algunos ancianos de Israel y se sentaron a mi alrededor."
,"2":"Y el Señor me dijo:"
,"3":"'Hijo de hombre, di a estos ancianos de Israel: Esto dice el Señor Dios: ¿Venís a consultarme? Os juro que no me he de dejar consultar por vosotros, dice el Señor Dios."
,"4":"Hijo de hombre, celebra un juicio contra éstos; sí, júzgalos y hazles saber las acciones detestables de sus padres."
,"5":"Diles: Esto dice el Señor Dios: El día que yo elegí a Israel alcé mi mano por la estirpe de la casa de Jacob, me manifesté a ellos en la tierra de Egipto y les juré diciendo: Yo, el Señor, soy vuestro Dios."
,"6":"Aquel día alcé mi mano ante ellos jurando sacarlos de Egipto y llevarlos a una tierra que había escogido para ellos, una tierra que mana leche y miel, un paraíso entre todas las tierras."
,"7":"Y les dije: Tirad los ídolos que seducen vuestros ojos y no os contaminéis con los ídolos de Egipto: Yo soy el Señor, vuestro Dios."
,"8":"Mas ellos se rebelaron contra mí y no quisieron escucharme. No tiraron los ídolos que seducían sus ojos ni abandonaron los ídolos de Egipto."
,"9":"Pero cambié de propósito en honor a mi nombre, para que no fuese vilipendiado a los ojos de las gentes entre las que ellos se encontraban, porque había prometido sacar a mi pueblo de Egipto ante los ojos de sus habitantes."
,"10":"Los saqué de Egipto y los llevé al desierto."
,"11":"Allí les di mis preceptos y les di a conocer mis leyes, que son fuente de vida para quien las observa."
,"12":"Les di además mis sábados, como señal entre ellos y yo, para que quedase claro que soy yo, el Señor, quien los santifica."
,"13":"Pero el pueblo de Israel se rebeló contra mí en el desierto; no caminaron según mis preceptos, despreciaron mis leyes que dan la vida a quien las observa, y profanaron mis sábados, por lo cual decidí derramar sobre ellos mi furor en el desierto y exterminarlos."
,"14":"Sin embargo, cambié otra vez de propósito en honor a mi nombre para que no fuese vilipendiado ante las gentes, en cuya presencia los había hecho salir."
,"15":"Pero en el desierto alcé mi mano y les juré que no los llevaría al país destinado para ellos, tierra que mana leche y miel, un paraíso entre las tierras,"
,"16":"porque habían despreciado mis preceptos, no habían observado mis sábados y su corazón se había ido en pos de sus ídolos."
,"17":"No obstante, mis ojos se compadecieron de ellos y dejé de pensar en exterminarlos y aniquilarlos en el desierto."
,"18":"Pero advertí a sus hijos en el desierto: No sigáis las normas de vuestros padres, no imitéis sus costumbres ni os contaminéis con sus ídolos."
,"19":"Yo soy el Señor, vuestro Dios. Caminad según mis preceptos, guardad mis leyes y ponedlas en práctica."
,"20":"Santificad mis sábados, como señal entre mí y vosotros, para que se sepa que yo, el Señor, soy vuestro Dios."
,"21":"Pero también los hijos se rebelaron contra mí; no caminaron según mis preceptos, no guardaron ni pusieron en práctica mis leyes, que dan la vida a quien las observa, y profanaron mis sábados. Entonces pensé derramar sobre ellos mi furor y desfogar mi ira contra ellos en el desierto."
,"22":"Pero una vez más retiré mi mano y cambié de propósito en honor a mi nombre, para que no fuese vilipendiado ante las gentes, en cuya presencia los había hecho salir."
,"23":"Pero en el desierto alcé mi mano y les juré desperdigarlos entre las gentes y esparcirlos entre las naciones"
,"24":"por no haber practicado mis leyes, haber despreciado mis preceptos, profanado mis sábados y entregado su corazón a los ídolos de sus padres."
,"25":"Y llegué a darles preceptos que no eran buenos y leyes por las cuales no podrían vivir;"
,"26":"les hice contaminarse con sus propias ofrendas, haciéndoles sacrificar a todo primogénito para castigarlos, a fin de que conociesen que yo soy el Señor."
,"27":"Hijo de hombre, di a la casa de Israel: Esto dice el Señor Dios: Todavía me hicieron vuestros padres la injuria siguiente, entre tantas infidelidades que cometieron contra mí."
,"28":"Yo los llevé hasta la tierra que había jurado, mano en alto, darles. Pero al ver cualquier colina elevada o cualquier árbol frondoso, ofrecieron allí sus sacrificios, presentaron sus ofrendas irritantes, quemaron sus perfumes y derramaron sus ofrendas de vino."
,"29":"Yo les pregunté: ¿Qué es el lugar alto donde vosotros vais? Y ellos le pusieron el nombre de colina, hasta el día de hoy."
,"30":"Di a la casa de Israel: Esto dice el Señor Dios: Vosotros os contamináis con las costumbres de vuestros padres, os degradáis yendo en pos de sus prácticas detestables,"
,"31":"presentando vuestras ofrendas, haciendo pasar por el fuego a vuestros hijos; os contamináis con todos vuestros ídolos hasta el día de hoy, ¿y queréis que me deje consultar por vosotros, oh casa de Israel?,Vivo yo, dice el Señor Dios, que no me he de dejar consultar por vosotros. "
,"32":"Y no sucederá lo que pasa por vuestra mente, cuando andáis diciendo: ¡Seremos como las gentes, como los pueblos de los otros países, adoradores del leño y la piedra!"
,"33":"Os juro, dice el Señor Dios, que seré yo quien reine sobre vosotros con mano fuerte y brazo extendido, desencadenando mi furor."
,"34":"Después os sacaré de entre los pueblos y os reuniré en los países en los cuales, con mano fuerte y brazo extendido, desencadenando mi furor, os había dispersado."
,"35":"Os conduciré al desierto de los pueblos, y allí cara a cara os juzgaré."
,"36":"Como juzgué a vuestros padres en el desierto de Egipto, así os juzgaré a vosotros, dice el Señor Dios."
,"37":"Os someteré con la vara y os ligaré de nuevo a las leyes de la alianza."
,"38":"Separaré de vosotros a los rebeldes, y a cuantos se han apartado de mí los haré salir del país en que viven, pero no entrarán en la tierra de Israel, y sabréis que yo soy el Señor."
,"39":"En cuanto a vosotros, casa de Israel, esto dice el Señor Dios: ¡Servid, servid, cada uno a vuestros ídolos! Pero más tarde, sí, me escucharéis y no profanaréis más mi santo nombre con vuestras ofrendas y vuestros ídolos;"
,"40":"porque en mi santo monte, en el excelso monte de Israel, dice el Señor, me servirá todo el pueblo de Israel, cuantos vivan en el país; allí aceptaré gustosamente y solicitaré vuestras ofrendas, las primicias de vuestros dones, todo lo que queráis ofrecerme."
,"41":"Os aceptaré gustosamente, como perfume agradable, cuando os haya sacado de entre los pueblos y os haya reunido de los países en los cuales os había dispersado. Y manifestaré mi santidad en vosotros ante los ojos de las gentes."
,"42":"Y sabréis que yo soy el Señor, cuando os haya reintegrado a la tierra de Israel, al país que juré, mano en alto, dar a vuestros padres."
,"43":"Entonces os acordaréis de vuestra conducta, de todas las acciones con las cuales os manchasteis, y sentiréis asco de vosotros mismos por todas las injusticias que habéis cometido."
,"44":"Y sabréis que yo soy el Señor, cuando actúe con vosotros en honor a mi nombre, y no con arreglo a vuestra detestable conducta, oh casa de Israel, dice el Señor Dios."
}`)
	CurrentBook.AddChapter(21, `{
"1":"El Señor me dijo:"
,"2":"'Hijo de hombre, vuélvete a la derecha y pronuncia tu oráculo hacia el sur, profetiza contra el bosque de la región del Negueb."
,"3":"Dirás al bosque del Negueb: Escucha la palabra del Señor: Esto dice el Señor: Mira que yo voy a prenderte fuego, que devorará todos los árboles verdes lo mismo que los secos. La llama devoradora no se apagará y arderá todo en el Negueb de sur a norte."
,"4":"Entonces todo mortal verá que yo, el Señor, lo he encendido. ¡No se apagará!'."
,"5":"Yo exclamé: 'Señor Dios, éstos me andan diciendo: Éste sólo sabe hablar en parábolas'."
,"6":"El Señor me dijo:"
,"7":"'Hijo de hombre, vuelve tu rostro hacia Jerusalén, pronuncia tu oráculo contra su santuario y profetiza contra la tierra de Israel."
,"8":"Dirás al país de Israel: Esto dice el Señor Dios: Aquí estoy contra ti; sacaré la espada de la vaina y mataré en ti al justo y al malvado."
,"9":"Para eso saldrá mi espada de su vaina contra todo mortal, de sur a norte, para exterminar de ti al justo y al malvado."
,"10":"Y todo el mundo sabrá que yo, el Señor, he sacado mi espada de la vaina, ¡no será envainada!"
,"11":"Y tú, hijo de hombre, ponte a gemir; gime ante su vista con corazón angustiado y amargura."
,"12":"Y cuando te pregunten: ¿Por qué gimes?, les dirás: Por una noticia, a cuya llegada se derretirá todo corazón, desmayarán todos los brazos, se consternará todo ánimo y todas las rodillas vacilarán. Ya llega, ya se cumple, dice el Señor Dios'."
,"13":"El Señor me dijo:"
,"14":"'Hijo de hombre, profetiza y di: Esto dice el Señor Dios: ¡Espada, espada! Afilada está, bruñida."
,"15":"Afilada para matar, bruñida para fulgurar."
,"16":"Se la ha hecho bruñir para empuñarla; espada afilada y bruñida para ponerla en mano de asesino."
,"17":"Grita, aúlla, hijo de hombre, porque está destinada a mi pueblo, todos los príncipes de Israel, entregados a la espada junto con mi pueblo. Hiérete las caderas,"
,"18":"pues la prueba está hecha. ¿Qué pasará si se despreciara el cetro?,No subsistirá, dice el Señor Dios."
,"19":"Tú, hijo de hombre, profetiza y bate palmas; que la espada se duplique, se triplique: la espada de la matanza, la gran espada de la matanza,que los tiene rodeados."
,"20":"Para que tiemblen los corazones y se acrecienten las víctimas, he puesto en todas las puertas la espada del estrago; hecha estás para fulgurar, afilada para matar."
,"21":"¡Hiere a derecha y a izquierda, dondequiera se vuelva tu hoja!"
,"22":"También yo batiré palmas y aplacaré mi cólera. Yo, el Señor, he hablado'."
,"23":"El Señor me dijo:"
,"24":"'Y tú, hijo de hombre, traza dos caminos por donde llegue la espada del rey de Babilonia; de un mismo país partirán ambos. Pon una señal que, partiendo de allí, indique el camino que conduce a una ciudad."
,"25":"Trazarás un camino que lleve la espada a Rabat de los amonitas, y otra a Judá, a la fortaleza de Jerusalén."
,"26":"Pues el rey de Babilonia se ha detenido en una encrucijada donde los dos caminos se dividen, para consultar a la suerte. Ya sacude las flechas, interroga a sus ídolos, examina el hígado."
,"27":"La suerte cae a su derecha: Jerusalén, para situar arietes, dar órdenes de matanza, lanzar el grito de guerra, levantar arietes contra las puertas, amontonar terraplenes, disponer el cerco."
,"28":"Pero a sus ojos les parece esto un presagio mentiroso; se les había hecho una promesa, pero él recuerda su iniquidad, por la cual serán deportados."
,"29":"Por tanto, esto dice el Señor Dios: Por haber pregonado con jactancia vuestros crímenes, descubriendo vuestras rebeliones y manifestando vuestros pecados en todo vuestro proceder; por haber llamado así la atención sobre vosotros, por eso seréis castigados."
,"30":"Y en cuanto a ti, infame y criminal rey de Israel, ha llegado tu hora, el tiempo en que se acabará tu crueldad."
,"31":"Esto dice el Señor Dios: Quítate el turbante y la corona. Todo cambiará; lo humilde será exaltado y lo alto será humillado."
,"32":"Ruina, ruina, ruina, como jamás se vio; a esto lo reduciré, hasta que llegue aquel a quien le corresponde el juicio por derecho; a él se lo entregaré."
,"33":"Y tú, hijo de hombre, profetiza y di: Esto dice el Señor Dios contra los amonitas y contra sus insultos. Les dirás: ¡La espada, la espada está desenvainada para la matanza, bruñida para exterminar, fulgurar,"
,"34":"para descargarla -mientras tú recibes visiones falsas y se te adivinan presagios mentirosos- sobre el cuello de los viles criminales, cuya hora ha llegado con el fin de sus crímenes!"
,"35":"Desenvaina la espada. Yo te juzgaré en el lugar en que fuiste creada, en la tierra de tu nacimiento."
,"36":"Desencadenaré sobre ti mi furor, soplaré contra ti el fuego de mi cólera y te entregaré en manos de hombres crueles, agentes de destrucción."
,"37":"Serás pasto del fuego, la tierra se empapará de tu sangre y se perderá incluso tu memoria, pues yo, el Señor, he hablado'."
}`)
	CurrentBook.AddChapter(22, `{
"1":"El Señor me dijo:"
,"2":"'Y tú, hijo de hombre, ¿no vas a juzgar? ¿No vas a juzgar a la ciudad sanguinaria? Indícales todas sus detestables acciones."
,"3":"Dirás: Esto dice el Señor Dios: ¡Ay de la ciudad que vierte sangre de sus habitantes para acelerar su destrucción y fabricar ídolos con los que se contamina!"
,"4":"Por la sangre que has derramado te has hecho culpable, te has manchado con los ídolos que te has hecho; así has adelantado tu hora, has llegado al término de tus años. Sí, te haré el oprobio de las gentes, el escarnio de toda la tierra."
,"5":"Se burlarán de ti los pueblos vecinos y los lejanos, oh ciudad de mala fama, llena de corrupción."
,"6":"Ved, los príncipes de Israel, cada uno por su cuenta, están ocupados en derramar sangre."
,"7":"En ti se desprecia al padre y a la madre, en ti se trata mal al forastero, en ti son oprimidos los huérfanos y la viuda."
,"8":"Has despreciado mis santuarios, has profanado mis sábados."
,"9":"Hay en ti gente que calumnia para hacer verter sangre. En ti se banquetea en los montes, en ti se hacen cosas detestables,"
,"10":"en ti se descubre la desnudez del propio padre, en ti se fuerza a la mujer en la menstruación."
,"11":"Hay quien comete adulterio con la mujer de su prójimo, quien mancha con crimen nefando a su nuera, quien fuerza a su hermana, a la hija de su propio padre."
,"12":"En ti se acepta soborno para derramar sangre; aceptas usura e interés, despojas con violencia a tu prójimo y te has olvidado de mí, dice el Señor Dios."
,"13":"Mira, yo bato mis palmas por tus actos de pillaje y por la sangre que corre en medio de ti."
,"14":"¿Aguantará tu corazón, permanecerán firmes tus manos el día en que yo te pida cuentas? Yo, el Señor, lo digo y lo hago."
,"15":"Te dispersaré entre las naciones y te esparciré entre gentes extrañas. Así te purificaré de tu impureza."
,"16":"Cargarás con tu propia deshonra a los ojos de las naciones y sabrás que yo soy el Señor'."
,"17":"El Señor me dijo:"
,"18":"'Hijo de hombre, la casa de Israel se ha convertido para mí en escoria; todos son cobre, estaño, hierro y plomo en el horno. Tan sólo escoria."
,"19":"Por tanto, esto dice el Señor Dios: Por haberos convertido todos en escoria, yo os reúno en Jerusalén."
,"20":"Como se echa plata, cobre, hierro, plomo y estaño en el horno y se sopla el fuego para fundirlos, así os reuniré en mi cólera y en mi furor y os fundiré."
,"21":"Os reuniré, soplaré contra vosotros el fuego de mi furor y os fundiré dentro de la ciudad."
,"22":"Como se funde la plata en el horno, así seréis fundidos vosotros dentro de la ciudad y sabréis que yo, el Señor, he desencadenado mi furor contra vosotros'."
,"23":"El Señor me dijo:"
,"24":"'Hijo de hombre, di a Jerusalén: Eres una tierra que no ha sido purificada ni lavada por la lluvia el día de la ira."
,"25":"En ella sus príncipes son como león rugiente ávido de presa, devoran a las personas, se apoderan de haciendas y riquezas y aumentan el número de las viudas."
,"26":"Sus sacerdotes han quebrantado mi ley y profanado mi santuario. No han distinguido entre lo sagrado y lo profano, ni han enseñado a discernir lo puro de lo impuro. Han cerrado sus ojos a las violaciones de mis sábados y yo he sido deshonrado en medio de ellos."
,"27":"Los jefes de la ciudad son como lobos ávidos de presa; derraman sangre y matan a las personas para amasar más y más dinero."
,"28":"Y sus profetas los recubren de argamasa, adulándolos con visiones vanas y oráculos mentirosos, diciendo: Esto dice el Señor Dios, cuando el Señor no ha hablado."
,"29":"La gente del país comete violencia y se entrega al pillaje, pisotea al pobre, maltrata al menesteroso y oprime al emigrante contra todo derecho."
,"30":"He buscado entre ellos un hombre que reparase el muro y se mantuviera en la brecha frente a mí en defensa del país, para que yo no lo devastase, y no lo he encontrado."
,"31":"Por eso he desencadenado mi furor sobre ellos, los he exterminado con el fuego de mi cólera y he hecho caer su proceder sobre su cabeza', dice el Señor Dios."
}`)
	CurrentBook.AddChapter(23, `{
"1":"El Señor me dijo:"
,"2":"'Hijo de hombre, había dos mujeres, hijas de una misma madre."
,"3":"Se prostituyeron en Egipto desde su juventud. Allí palparon su pecho y acariciaron su seno virginal."
,"4":"Sus nombres eran: Oholá, la mayor, y Oholibá, su hermana. Fueron mías, y dieron a luz hijos e hijas. Sus nombres correspondían: Oholá a Samaría, Oholibá a Jerusalén."
,"5":"Oholá se prostituyó, me abandonó y se enamoró locamente de sus amantes, los asirios, vecinos suyos,"
,"6":"de vestidos de púrpura, gobernadores y lugartenientes, todos ellos jóvenes apuestos y ágiles caballeros."
,"7":"Con ellos se manchó, con la flor de los hijos de Asiria, de los que se había prendado, y se contaminó con todos sus ídolos."
,"8":"Ni renegó de sus prostituciones de Egipto, donde se habían acostado con ella, en su juventud, acariciando sus pechos virginales y derramando en ella su impureza."
,"9":"Por eso la entregué en manos de sus amantes, en poder de los asirios, de los que se había enamorado locamente."
,"10":"Ellos descubrieron su desnudez, tomaron a sus hijos y a sus hijas y los mataron a espada. Samaría vino a ser un ejemplo para las naciones por el escarmiento que se hizo en ella."
,"11":"Su hermana Oholibá, aunque había sido testigo de esto, enloqueció aún más que ella y sus prostituciones fueron peores que las de su hermana."
,"12":"Se enamoró locamente de los asirios, gobernadores y lugartenientes, vecinos suyos, de vestidos espléndidos, ágiles caballeros y jóvenes apuestos todos ellos."
,"13":"Yo vi que se había manchado; ambas seguían un mismo proceder."
,"14":"Pero ésta fue aún más lejos en sus prostituciones. Vio hombres representados en las paredes, figuras de caldeos pintadas en bermellón,"
,"15":"con cinto en las caderas, amplios turbantes en sus cabezas, con aspecto de grandes señores todos ellos; eran retratos de babilonios, cuyo país de origen es Caldea."
,"16":"Con sólo verlos se enamoró de ellos y les envió mensajeros a Caldea."
,"17":"Los babilonios vinieron a ella, al lecho de los amores; la mancharon con sus prostituciones y se contaminó con ellos, hasta que se hastió."
,"18":"Entonces patentizó su desvergüenza y descubrió su desnudez; y yo me aparté de ella como me había apartado de su hermana."
,"19":"Ella multiplicó sus prostituciones, recordando los días de su juventud, cuando se prostituía en Egipto"
,"20":"y se enamoraba perdidamente de aquellos disolutos, de vigor de asnos y flujo de sementales."
,"21":"Renovaste así la infamia de tu juventud, cuando los egipcios palpaban tu pecho y acariciaban tu seno virginal."
,"22":"Por eso, Oholibá, esto dice el Señor Dios: Yo suscitaré contra ti a todos tus amantes, de quienes te has hastiado, y los conduciré contra ti de todas partes:"
,"23":"los babilonios y todos los caldeos, los de Pecod, Soa y Coa, y con ellos todos los asirios, jóvenes apuestos, gobernadores y lugartenientes todos ellos, guerreros famosos y ágiles caballeros."
,"24":"Vendrán contra ti por el norte, con carros y carretas al frente de una multitud de pueblos. Armados de paveses, escudos y yelmos, vendrán contra ti por todas partes. Les he dado el encargo de juzgarte, y te juzgarán conforme a sus leyes."
,"25":"Desencadenaré mis celos contra ti y te tratarán con furor; te arrancarán la nariz y las orejas, y lo que quede de tu descendencia caerá a espada. Se llevarán a tus hijos y a tus hijas, y lo que en ti quede será pasto del fuego."
,"26":"Te despojarán de tus vestidos y se apoderarán de tus joyas."
,"27":"Yo pondré fin a tu sensualidad y a las prostituciones comenzadas en Egipto. No levantarás más tus ojos hacia ellos, ni te volverás a acordar de Egipto."
,"28":"Pues esto dice el Señor Dios: Yo voy a entregarte en manos de aquellos que odias, en manos de aquellos de quienes te has hastiado."
,"29":"Ellos te tratarán con odio y se llevarán todo lo que has reunido, dejándote desnuda, al descubierto. Será descubierta la vergüenza de tus prostituciones. Tus impurezas y tu desvergüenza"
,"30":"han sido la causa de todo esto, porque, prostituyéndote ante las naciones, te has contaminado con sus ídolos."
,"31":"Has seguido el camino de tu hermana, y por eso yo pondré su copa en tu mano."
,"32":"Esto dice el Señor Dios: 'Beberás la copa de tu hermana, copa ancha y profunda,que te hará objeto de burla y escarnio, tan grande es su cabida."
,"33":"Te empaparás de borrachera y de tristeza; copa de horror y desolación es la copa de tu hermana Samaría."
,"34":"La beberás, la apurarás, roerás incluso sus cascotes, que te desgarrarán el seno. He hablado yo, dice el Señor Dios."
,"35":"Porque esto dice el Señor Dios: Puesto que me has abandonado y me has echado a tus espaldas, carga tú también con tu desvergüenza y tus prostituciones'."
,"36":"También me dijo el Señor: 'Hijo de hombre, juzga a Oholá y a Oholibá y descúbreles las acciones detestables que han cometido,"
,"37":"pues se han hecho adúlteras y sus manos están llenas de sangre; se han prostituido con sus ídolos, y hasta a sus hijos, que me habían engendrado, los han hecho pasar por el fuego para sacrificarlos."
,"38":"Han llegado hasta esto: en un mismo día contaminaban mi santuario y profanaban mis sábados."
,"39":"Después de haber inmolado a sus hijos ante sus ídolos, entraban aquel mismo día en mi santuario para profanarlo. Esto es lo que han hecho dentro de mi templo."
,"40":"Además, para honrar a hombres venidos de lejos, invitados por conducto de un mensajero, te lavaste, te pintaste los ojos, te adornaste con tus vestidos preciosos,"
,"41":"te reclinaste luego sobre un magnífico diván, ante el cual había una mesa dispuesta en la que pusiste mi óleo y mis perfumes."
,"42":"Se oía el ruido de una multitud gozosa. Hombres venidos del desierto pusieron brazaletes en sus manos y una corona magnífica en su cabeza."
,"43":"Yo dije entonces sobre la ciudad consumida por la disolución: ¿También ella continuará ahora cometiendo sus detestables acciones?"
,"44":"Pues se acercan a ella como se va a una mujer prostituta; así se llegaban a Oholá y a Oholibá, a estas mujeres infames."
,"45":"Pero hombres justos las juzgaron según la ley de las adúlteras y de las homicidas. Porque son adúlteras y sus manos están llenas de sangre."
,"46":"Esto dice el Señor Dios: Se reunirá contra ellas una asamblea y serán abandonadas al terror y al pillaje."
,"47":"La turba las apedreará y con sus espadas las cortarán en pedazos. Matarán a sus hijos y a sus hijas y prenderán fuego a sus casas."
,"48":"Así pondré fin a esta infamia en el país y aprenderán las demás mujeres a no imitar vuestros nefandos crímenes."
,"49":"Haré recaer sobre vosotros vuestra infamia, cargaréis con los pecados de vuestra idolatría y sabréis que yo soy el Señor Dios'."
}`)
	CurrentBook.AddChapter(24, `{
"1":"El año noveno, el día diez del décimo mes, el Señor me dijo:"
,"2":"'Hijo de hombre, pon por escrito esta fecha, porque el rey de Babilonia se ha lanzado sobre Jerusalén justamente en este día."
,"3":"Después di esta parábola a esa raza de rebeldes. Esto dice el Señor Dios: Arrima la olla, arrímala, y echa agua en ella."
,"4":"Pon luego trozos de carne, trozos buenos, pierna y costilla; llénala de los huesos mejores."
,"5":"Toma lo más selecto del rebaño. Apila debajo leña; hazla hervir a borbotones, de modo que hasta los huesos se cuezan."
,"6":"Porque esto dice el Señor Dios: ¡Ay de la ciudad sanguinaria, olla toda roñosa, cuya herrumbre no se quita!,Vacíala trozo a trozo, sin echar suerte sobre ella,"
,"7":"porque la sangre por ella vertida está dentro de ella; la ha esparcido sobre roca desnuda, no la ha vertido en tierra para que el polvo la cubriese."
,"8":"Para que estalle mi furor, para tomar venganza, he puesto su sangre sobre roca desnuda, de suerte que no pueda taparse."
,"9":"Por tanto, esto dice el Señor Dios: ¡Ay de la ciudad sanguinaria!,También yo apilaré mucha leña."
,"10":"Apila la leña, enciende el fuego, cuece la carne, quita el caldo, para que los huesos se abrasen."
,"11":"Deja la olla vacía sobre las brasas, para que se caliente, se ponga al rojo el cobre, se funda dentro de ella su suciedad,y se consuma su herrumbre."
,"12":"Me ha cansado la fatiga mas no desaparece de ella,su enorme herrumbre, que hasta el fuego resiste."
,"13":"He tratado de purificarte de tu mancha vergonzosa, pero no te has dejado purificar de tu inmundicia. No serás, pues, purificada hasta que yo no desencadene sobre ti mi furor."
,"14":"Yo, el Señor, lo digo y lo hago; así sucederá; no me retraeré, no tendré piedad ni compasión. Te juzgaré según mi conducta y tus obras', declara el Señor Dios."
,"15":"El Señor me dijo:"
,"16":"'Hijo de hombre, mira, voy a quitarte, de improviso, la delicia de tus ojos; pero tú no te lamentes, no llores, no dejes correr tus lágrimas."
,"17":"Suspira en silencio, no hagas luto; cíñete el turbante a tu cabeza, ponte en los pies las sandalias; no te cubras la barba, no comas el pan del duelo'."
,"18":"Había hablado yo por la mañana al pueblo, y por la tarde murió mi esposa. Al día siguiente hice como se me había ordenado."
,"19":"El pueblo me dijo: 'Explícanos qué significado tiene para nosotros lo que estás haciendo'."
,"20":"Yo les respondí: 'El Señor me dijo:"
,"21":"Di a la casa de Israel: Esto dice el Señor Dios: Mirad, voy a profanar mi santuario, orgullo de vuestra fuerza, delicia de vuestros ojos, amor de vuestras almas. Vuestros hijos y vuestras hijas, que habéis dejado, caerán a espada."
,"22":"Y habéis de hacer como he hecho yo: no os cubriréis la barba, no comeréis el pan del duelo."
,"23":"Llevaréis vuestro turbante a la cabeza y las sandalias en los pies; no os lamentaréis ni lloraréis, sino que os consumiréis a causa de vuestras iniquidades y os lamentaréis unos con otros."
,"24":"Ezequiel será para vosotros como un símbolo; cuando esto suceda, haréis exactamente lo que él ha hecho y sabréis que yo soy el Señor."
,"25":"Y tú, hijo de hombre, el día en que yo les quite su fuerza, la alegría de sus glorias, la delicia de sus ojos, el amor de su alma, sus hijos y sus hijas,"
,"26":"aquel día llegará a ti el fugitivo, que te traerá la noticia."
,"27":"Entonces se abrirá tu boca para hablar con el fugitivo; recuperarás la palabra y no quedarás ya mudo; serás un símbolo para ellos. Y sabrán que yo soy el Señor'."
}`)
	CurrentBook.AddChapter(25, `{
"1":"El Señor me dijo:"
,"2":"'Hijo de hombre, vuelve tu rostro hacia los amonitas y profetiza contra ellos."
,"3":"Les dirás: Escuchad la palabra del Señor Dios. Esto dice el Señor Dios: Porque os reíais cuando mi santuario era profanado, cuando la tierra de Israel era devastada, cuando la casa de Judá marchaba al destierro,"
,"4":"por eso yo te entrego en manos de los hijos de oriente. Levantarán en ti sus campamentos, emplazarán en ti sus tiendas, comerán tus frutos y beberán tu leche."
,"5":"Convertiré a Rabá en establo de camellos y a las otras ciudades de Amón en rediles de rebaños, y sabréis que yo soy el Señor'."
,"6":"Pues esto dice el Señor Dios: 'Por haber aplaudido y haber dado saltos de alegría, por haber despreciado a Israel,"
,"7":"por esto yo extiendo mi mano contra ti y te entrego como presa a las naciones. Te exterminaré de entre los pueblos y te borraré del número de las tierras. Te aniquilaré y sabrás que yo soy el Señor'."
,"8":"Esto dice el Señor Dios: 'Porque Moab y Seír han dicho: ¡Mirad, la casa de Judá es como todos los otros pueblos!,"
,"9":"por eso yo abro la espalda de Moab; destruyo sus ciudades hasta la última, la gloria del país, Bet Yesimot, Baal Meón y Quiriatáyim."
,"10":"En manos de los hijos de oriente la entrego, junto con los amonitas, para que no quede ya recuerdo de los amonitas entre los pueblos."
,"11":"También con Moab haré justicia y sabrán que yo soy el Señor'."
,"12":"Esto dice el Señor: 'Porque Edón ha ejercitado cruelmente la venganza contra la casa de Judá y se ha hecho culpable de delito al vengarse de ella,"
,"13":"esto dice el Señor Dios: Extenderé mi mano contra Edón, exterminaré de ella hombres y animales y la reduciré a un desierto. Desde Temán a Dedán caerán a espada."
,"14":"Mi venganza sobre Edón la pondré en manos de mi pueblo Israel, que tratará a Edón conforme a mi cólera y mi furor; conocerán mi venganza, dice el Señor Dios'."
,"15":"Esto dice el Señor Dios: 'Porque los filisteos han actuado por espíritu de venganza y se han vengado, llena el alma de odio, exterminando a impulsos de una enemistad de siglos,"
,"16":"esto dice el Señor Dios: Yo extiendo mi mano contra los filisteos y exterminaré a los quereteos; haré perecer también al resto de los habitantes de la costa."
,"17":"Ejecutaré contra ellos terribles venganzas, castigándolos con furor, y sabrán que yo soy el Señor, cuando ejecute mi venganza en ellos'."
}`)
	CurrentBook.AddChapter(26, `{
"1":"En el año undécimo, el día primero del mes, el Señor me dijo:"
,"2":"'Hijo de hombre, porque Tiro se ha burlado de Jerusalén diciendo: ¡Ja, ja, ha sido rota la puerta de los pueblos! Se vuelve hacia mí, yo me enriquezco: ¡Está devastada!,"
,"3":"por eso esto dice el Señor Dios: Aquí estoy contra ti, Tiro; haré avanzar contra ti gentes innumerables, como el mar levanta sus olas."
,"4":"Derruirán las murallas de Tiro y demolerán sus torres, barreré de ella hasta el polvo y la dejaré como roca desnuda."
,"5":"Quedará en medio del mar como un tendedero de redes. Pues yo he hablado, dice el Señor Dios: Tiro será presa de los pueblos."
,"6":"Y sus hijas, que están tierra adentro, serán pasadas a cuchillo. Y sabrán que yo soy Dios."
,"7":"Pues esto dice el Señor Dios: Yo traigo, por el norte, sobre Tiro a Nabucodonosor, rey de Babilonia, rey de reyes, con caballos, carros, jinetes y gran número de tropas."
,"8":"A tus hijas, las de tierra adentro, pasará a cuchillo, y contra ti pondrá una trinchera de asedio, levantará un terraplén y alzará contra ti un baluarte;"
,"9":"dará golpes de ariete contra tus murallas y derribará tus torres con sus máquinas."
,"10":"La nube de sus caballos te cubrirá de polvo; al estrépito de sus jinetes, sus carros y sus carretas vacilarán tus murallas, cuando entre él por tus puertas como se entra en una ciudad expugnada."
,"11":"Con los cascos de sus caballos pisoteará todas tus calles; a tu pueblo pasará a cuchillo y derribará tus vigorosas columnas."
,"12":"Saquearán tus riquezas, arrebatarán tus mercancías. Derruirán tus muros, demolerán tus magníficas casas, tirarán al mar tus piedras, vigas y escombros."
,"13":"Pondré silencio a tus armoniosas canciones, no se volverá a oír el son de tus cítaras."
,"14":"Te convertiré en desnudo escollo, secadero de redes serás, y no volverás a ser reconstruida, porque yo, el Señor, he hablado', dice el Señor Dios."
,"15":"Esto dice el Señor Dios a Tiro: 'Al estruendo de tu desplome, al gemido de tus heridos, cuando la carnicería hierva en medio de ti, ¿no temblarán las islas?"
,"16":"Bajarán de sus tronos todos los príncipes del mar, se quitarán sus mantos y se despojarán de sus vestiduras recamadas; se vestirán de luto, se sentarán en tierra, sufrirán incesantes temblores y estarán consternados por ti."
,"17":"Y entonarán sobre ti esta elegía: ¡Ah! ¡Cómo has caído, desaparecido de los mares, tú, la ciudad famosa, tan poderosa en el mar, con tus habitantes, los que infundían su terror,a los del continente!"
,"18":"Ahora se estremecen las islas, el día de tu caída, las islas del mar se aterran de tu fin."
,"19":"Pues esto dice el Señor Dios: Cuando te haya reducido a un desierto, como las ciudades ya no habitadas, y se abalance sobre ti el océano y las aguas en masa te cubran,"
,"20":"te precipitaré con los que han bajado a la fosa, con las generaciones del pasado; te haré habitar en las profundidades de la tierra, en las soledades perpetuas, con los que yacen en la fosa, a fin de que no seas restablecida nunca en la tierra de los vivos."
,"21":"Te haré objeto de espanto y no existirás más. Se te buscará, pero no se te encontrará jamás, afirma el Señor Dios."
}`)
	CurrentBook.AddChapter(27, `{
"1":"El Señor me dijo:"
,"2":"'Hijo de hombre, entona una elegía sobre Tiro."
,"3":"Dirás a Tiro: Oh tú, que te sientas a la orilla del mar,y traficas con pueblos esparcidos en islas sin cuento,esto dice el Señor Dios. Tiro, tú has dicho: Yo soy la perfecta hermosura."
,"4":"En alta mar se encuentran tus confines. Tus fundadores te hicieron de perfecta hermosura."
,"5":"Con cipreses de Hermón construyeron tus planchas, con cedro del Líbano hicieron tu mástil,"
,"6":"con encinas del Basán tus remos; tu cubierta la hicieron de marfil incrustado,de cedro de las costas de Chipre;"
,"7":"tu vela de lino recamado, importado de Egipto, que te servía de enseña; púrpura y escarlata,de las islas de Elisá formaban tu cabina."
,"8":"Los habitantes de Sidón y de Arvad eran tus remeros; los más expertos que tenías, oh Tiro, eran tus timoneles."
,"9":"Y estaban los ancianos de Guebal,y sus peritos para reparar tus averías. Todas las naves del mar y sus marineros venían a ti para canjear sus mercancías. "
,"10":"Gentes de Persia, de Lidia y Libia servían en tu ejército, eran tus guerreros. Colgaban en ti el yelmo y el escudo y te daban esplendor."
,"11":"Los hijos de Arvad con su armada guarnecían por todas partes tus murallas y hacían guardia ante tus torres; alrededor de tus murallas colgaban sus escudos y te daban más esplendor."
,"12":"Tarsis comerciaba contigo por tus riquezas de todo género; con plata, hierro, estaño y plomo pagaba tus mercancías."
,"13":"Yaván, Tubal y Mesec traficaban contigo; pagaban tus mercancías con esclavos y objetos de bronce."
,"14":"Los de Bet Togarma cambiaban tus artículos por caballos de tiro, de carrera y mulos."
,"15":"Los hijos de Rodas traficaban contigo. En tus manos estaba el comercio de innumerables costas; te pagaban con colmillos de marfil y ébano."
,"16":"Edón comerciaba contigo por la multitud de tus productos; pagaba tus artículos con piedras preciosas, púrpura, recamados, lino fino, corales y rubíes."
,"17":"Contigo comerciaban Judá y la tierra de Israel; te daban a cambio trigo de Minit, perfumes, miel, aceite y bálsamo."
,"18":"Damasco traficaba contigo, dándote a cambio de tus numerosos productos, de tus variadas riquezas, vino de Jelbón y lana de Sajar."
,"19":"Vedán y Jayin, desde Uzal, te abastecían de hierro forjado, de canela y caña a cambio de tus mercancías."
,"20":"Rodas traficaba contigo sillas de montar."
,"21":"Arabia y todos los príncipes de Cedar eran tus clientes y traficaban contigo corderos, carneros y machos cabríos."
,"22":"Los mercaderes de Sabá y Ramá cambiaban tus artículos por los más exquisitos aromas, por oro y toda clase de piedras preciosas."
,"23":"Jarrán, Canné y Edén, así como los mercaderes de Sabá, Asiria y Media, tenían estrechas relaciones comerciales contigo;"
,"24":"traían a tu mercado vestidos de lujo, mantos de púrpura y brocado, tapices multicolores, maromas trenzadas y fuertes."
,"25":"Las naves de Tarsis te transportaban tus mercancías. ¡Oh!, eres rica y poderosa en el corazón de los mares."
,"26":"A alta mar te condujeron tus remeros. Y el viento de levante te destrozó en el corazón de los mares."
,"27":"Tus riquezas, tus mercancías y tus fletes, tus marineros, tus pilotos, tus calafates, tus agentes comerciales, todos los guerreros que en ti van,y la multitud inmensa que transportas se hundirán,en el corazón de los mares el día de tu caída."
,"28":"A los gritos de tus timoneles se estremecerán las costas."
,"29":"Entonces desembarcarán de sus naves todos los remeros. Los pilotos, todos los hombres de mar, bajarán a tierra."
,"30":"Y lanzarán su clamor por ti, gritarán amargamente, se echarán polvo sobre sus cabezas, se revolcarán en la ceniza."
,"31":"Por tu causa se raparán el pelo, se vestirán de saco, por ti derramarán, en la amargura de su alma, lágrimas angustiosas."
,"32":"En su dolor entonarán por ti una elegía, lanzarán estos lamentos: ¿Quién era como Tiro, que ahora está muda en medio del mar?"
,"33":"Cuando desembarcabas del mar tus mercancías,para saciar a innumerables pueblos, con la abundancia de tus riquezas y productos enriquecías,a los reyes de la tierra."
,"34":"Mas ahora has sido tragada por las olas,en lo profundo del mar; tus mercancías y tus hombres todos se fueron a pique contigo."
,"35":"Todos los habitantes de las islas están atónitos de tu fracaso. Sus reyes se han sobresaltado, están con rostro descompuesto."
,"36":"Los mercaderes de los otros pueblos silban ahora sobre ti; te has convertido en objeto de espanto, has desaparecido para siempre."
}`)
	CurrentBook.AddChapter(28, `{
"1":"El Señor me dijo:"
,"2":"'Hijo de hombre, di al príncipe de Tiro: Esto dice el Señor Dios: Tu corazón se ha enorgullecido y has dicho: Un dios soy yo, en la morada de un dios habito, en medio del mar. Tú, que eres un hombre y no un dios, has equiparado tu corazón al corazón de Dios."
,"3":"¡Oh, sí!, más sabio eres que Daniel, ningún sabio te iguala."
,"4":"Con tu sabiduría y tu inteligencia te has procurado riquezas, has acumulado oro y plata en tus tesoros;"
,"5":"por tu gran habilidad en el comercio has aumentado tus riquezas, y tu corazón se ha engreído por tu opulencia."
,"6":"Por eso, esto dice el Señor Dios: Porque has hecho tu corazón semejante al corazón de Dios,"
,"7":"he aquí que yo haré venir contra ti a extranjeros, los más feroces de los pueblos, y desenvainarán su espada contra la prez de tu sabiduría,y borrarán tu esplendor."
,"8":"Te harán bajar a la fosa,y morirás atravesado en el corazón del mar."
,"9":"¿Podrás decir aún: Un dios soy yo, ante los verdugos?,Un hombre eres, y no un dios, en manos de quienes te traspasan."
,"10":"¡Tendrás la muerte de los incircuncisos, en manos de extranjeros! He hablado yo', dice el Señor Dios."
,"11":"El Señor me dijo:"
,"12":"'Hijo de hombre, entona una elegía sobre el príncipe de Tiro. Le dirás: Esto dice el Señor Dios: Tú eras el dechado de la perfección, lleno de sabiduría y de espléndida belleza."
,"13":"En Edén, jardín de Dios, vivías. Innumerables piedras preciosas adornaban tu manto: rubí, topacio, diamante, crisólito, piedra de ónice, jaspe, zafiro, carbunclo y esmeralda; de oro era el borde de tu manto, de oro las incrustaduras, todo a punto desde el día en que fuiste creado."
,"14":"Como un querubín protector,yo te había puesto en el monte santo de Dios,y caminabas entre brasas ardientes."
,"15":"Eras perfecto en tus caminos desde el día en que fuiste creado, hasta que apareció en ti la iniquidad."
,"16":"Con el progreso de tu tráfico te llenaste de violencia,y pecados, y yo te he arrojado del monte de Dios,y te he exterminado, oh querubín protector, de entre las brasas ardientes."
,"17":"Tu belleza te llenó de orgullo. Tu esplendor te hizo perder tu sabiduría. Yo te derribé por tierra y te di en espectáculo a los reyes."
,"18":"Por la multitud de tus delitos, con la injusticia de tu comercio, has profanado tus santuarios, y yo he sacado de ti mismo un fuego que te devore; te he reducido a cenizas sobre la tierra,a los ojos de cuantos te contemplan."
,"19":"Todos los pueblos que te conocían se espantan al verte. Te has hecho un objeto de terror,y has desaparecido para siempre'."
,"20":"El Señor me dijo:"
,"21":"'Hijo de hombre, vuelve tu rostro hacia Sidón y profetiza contra ella."
,"22":"Le dirás: Esto dice el Señor Dios: Aquí estoy contra ti, Sidón; en medio de ti seré glorificado. Se sabrá que yo soy el Señor cuando haga justicia en ella,y manifieste mi santidad."
,"23":"Mandaré contra ella la peste, y la sangre correrá por sus calles. Caerán en ella atravesados por la espada, desenvainada por todas partes contra ella."
,"24":"Y no habrá ya más para la casa de Israel espina que punza ni zarza que lacera entre todos sus vecinos que la desprecian, y sabrán que yo soy el Señor'."
,"25":"Esto dice el Señor Dios: 'Cuando yo recoja a la casa de Israel de entre las naciones donde estaba dispersa, manifestaré en ellos mi santidad a los ojos de las gentes y habitarán la tierra que un día regalé a mi siervo Jacob."
,"26":"Residirán allí con seguridad, construirán y plantarán viñas. Vivirán seguros, cuando yo haya ejecutado mis sentencias contra todas las gentes de los alrededores que los desprecian. Y sabrán que yo, el Señor, soy su Dios'."
}`)
	CurrentBook.AddChapter(29, `{
"1":"El año décimo, el doce del décimo mes, el Señor me dirigió la palabra y me dijo:"
,"2":"'Hijo de hombre, vuelve tu rostro contra el Faraón, rey de Egipto, y profetiza contra él y contra todo Egipto."
,"3":"Diles: Esto dice el Señor Dios: Aquí estoy contra ti, Faraón, rey de Egipto, cocodrilo gigante, recostado en medio de tus ríos, tú que has dicho: Mis Nilos son míos, yo me los he hecho."
,"4":"Yo te pondré garfios en las quijadas, pegaré a tus escamas los peces de tus Nilos, de en medio de tus Nilos te sacaré con todos los peces,de tus ríos pegados a tus escamas."
,"5":"Te arrojaré al desierto a ti,y a todos los peces de tus Nilos. Caerás en campo abierto, no serás recogido ni enterrado; a las bestias de la tierra y a las aves del cielo,te entregaré como pasto,"
,"6":"para que sepan todos los habitantes de Egipto,que yo soy el Señor. Porque has sido un báculo de caña,para la casa de Israel;"
,"7":"cuando te agarraban, te rompías en sus manos,y rasgabas toda su palma; cuando se apoyaban en ti, te hacías pedazos,y hacías vacilar sus caderas."
,"8":"Por tanto, esto dice el Señor Dios: Mira, yo haré venir contra ti la espada y exterminaré de ti hombres y animales."
,"9":"La tierra de Egipto quedará desolada y desierta, y sabrán que yo soy el Señor. Por haber dicho: El Nilo es mío, yo lo he hecho,"
,"10":"yo me declaro contra ti y contra tus Nilos. Haré de Egipto un desierto desolado, desde Migdol a Siene y hasta la frontera de Etiopía."
,"11":"No pasará por él pie de hombre ni le pisará pie de animal; quedará deshabitado durante cuarenta años."
,"12":"Haré de Egipto un país desolado entre tierras desiertas, y sus ciudades serán una desolación entre ciudades destruidas, durante cuarenta años. Dispersaré a los egipcios entre las naciones y los esparciré por los países."
,"13":"Porque esto dice el Señor Dios: Al cabo de cuarenta años recogeré de nuevo a Egipto de entre los pueblos en los que lo había dispersado;"
,"14":"haré regresar a los cautivos de Egipto y los volveré a la tierra de Patrós, a su país de origen, donde formarán un reino humilde."
,"15":"Será el más débil de los reinos y no subyugará más a las naciones. Los haré pequeños para que no dominen más a otros pueblos."
,"16":"No volverán a ser la esperanza de la casa de Israel, sino que recordarán más bien sus iniquidades cuando se iba detrás de ellos. Y sabrán que yo soy el Señor Dios'."
,"17":"El año veintisiete, el día uno del primer mes, el Señor me dirigió la palabra y me dijo:"
,"18":"'Hijo de hombre, Nabucodonosor, rey de Babilonia, ha emprendido con su ejército grandes movimientos contra Tiro. Toda cabeza ha quedado calva, toda espalda llagada; pero no ha obtenido de Tiro, ni para sí ni para sus tropas, ninguna ventaja del trabajo ejecutado contra ella."
,"19":"Por tanto, esto dice el Señor Dios: Yo entrego a Nabucodonosor, rey de Babilonia, el país de Egipto; él se apoderará de sus riquezas, lo saqueará, lo entregará al pillaje. Tal será la paga para su ejército."
,"20":"Por sus esfuerzos hechos contra Tiro, realizados por mi causa, les he dado como paga el país de Egipto, dice el Señor Dios."
,"21":"Aquel día haré crecer el poder de la casa de Israel y a ti te permitiré abrir la boca en medio de ellos. Y sabrán que yo soy el Señor'."
}`)
	CurrentBook.AddChapter(30, `{
"1":"El Señor me dijo:"
,"2":"'Hijo de hombre, profetiza y di: Esto dice el Señor Dios: ¡Gritad: Ay de aquel día!"
,"3":"Pues está cercano el día, está próximo el día del Señor, día cargado de nubarrones será el tiempo de las naciones."
,"4":"Caerá la espada sobre Egipto,y el terror llegará hasta Etiopía, cuando caigan en Egipto los muertos, cuando sean saqueadas sus riquezas,y sus cimientos destruidos'."
,"5":"Etiopía las gentes de Put y de Lidia, toda la Arabia, las gentes de Libia y los hijos de las tierras aliadas caerán con ellos a espada."
,"6":"Esto dice el Señor: 'Caerán los apoyos de Egipto, se desplomará el orgullo de su potencia. Desde Migdol a Siene caerán todos a espada, dice el Señor Dios. "
,"7":"Quedarán como un desierto entre tierras asoladas, sus ciudades serán del número de las ciudades desiertas."
,"8":"Y sabrán que yo soy el Señor, cuando prenda fuego a Egipto y sean quebrantados todos sus apoyos."
,"9":"Aquel día saldrán mensajeros de parte mía en navíos a sembrar el terror en Etiopía, que se cree segura; el terror invadirá a sus habitantes el día de Egipto; vedle aquí que llega."
,"10":"Así habla el Señor Dios: Exterminaré a la inmensa población de Egipto,por mano de Nabucodonosor, rey de Babilonia."
,"11":"Él y su pueblo, el más feroz de las naciones, serán enviados a asolar el país, desenvainarán contra Egipto sus espadas,y llenarán la tierra de muertos."
,"12":"Dejaré secos sus Nilos, abandonaré el país,en manos de asesinos, devastaré la tierra,y cuanto encierra por mano de extranjeros. Yo, el Señor, he hablado."
,"13":"Esto dice el Señor Dios: Aniquilaré los ídolos de Menfis,y no saldrán más príncipes de la tierra de Egipto. Sembraré el terror en el país de Egipto."
,"14":"Devastaré a Patrós, prenderé fuego a Tanis, haré justicia en Tebas."
,"15":"Derramaré mi ira en Pelusio, fortaleza de Egipto, y exterminaré la población de Tebas."
,"16":"Prenderé fuego a Egipto, Pelusio será presa de angustias, una brecha será abierta en Tebas. Menfis será inundada."
,"17":"Los jóvenes de Heliópolis y de Bubastis caerán a espada,y sus mujeres irán al destierro."
,"18":"En Tafnis se oscurecerá el día, cuando yo despedace allí el cetro de Egipto,y se acabe el orgullo de su fuerza. Un nubarrón la cubrirá y sus hijas irán al destierro."
,"19":"Así haré justicia con Egipto,y sabrán que yo soy el Señor'."
,"20":"El año undécimo, el día siete del primer mes, el Señor me dirigió la palabra y me dijo:"
,"21":"'Hijo de hombre, he roto el brazo del Faraón, rey de Egipto, y no ha sido vendado. No se le han aplicado medicamentos ni vendas para que, recobrado el vigor, pueda de nuevo empuñar la espada."
,"22":"Por tanto, esto dice el Señor Dios: Aquí estoy contra el Faraón, rey de Egipto. Le despedazaré los dos brazos, el brazo sano y el que está roto, y haré que la espada caiga de su mano."
,"23":"Dispersaré a los egipcios entre los pueblos, los esparciré por las naciones."
,"24":"Robusteceré los brazos del rey de Babilonia, pondré en su mano mi espada y romperé los brazos del Faraón, que gemirá ante él, como un herido de muerte."
,"25":"Sí, robusteceré los brazos del rey de Babilonia, mientras que los brazos del Faraón caerán. Sabrán entonces que yo soy el Señor, cuando ponga mi espada en la mano del rey de Babilonia y él la esgrima sobre la tierra de Egipto."
,"26":"Dispersaré a los egipcios entre los pueblos, los esparciré por las naciones y sabrán que yo soy el Señor'."
}`)
	CurrentBook.AddChapter(31, `{
"1":"El año undécimo, el día uno del tercer mes, el Señor me dirigió la palabra y me dijo:"
,"2":"'Hijo de hombre, di al Faraón, rey de Egipto, y a su pueblo: ¿A quién te pareces en tu grandeza?"
,"3":"A un cedro del Líbano de espléndido ramaje, espesa fronda y altura sublime; entre las nubes despuntaba su copa."
,"4":"Las lluvias lo hicieron grande, las aguas subterráneas lo hicieron crecer,llevando sus corrientes al lugar donde estaba plantado, mandando sus canales a todos los árboles del campo."
,"5":"Así aquel cedro superó en altura a todos los árboles del campo; crecieron sus ramas sin cuento, su ramaje se alargaba por la abundancia de agua,que junto a él corría."
,"6":"En sus ramas anidaban todas las aves del cielo, bajo su fronda parían todos los animales del campo, a su sombra se sentaban gentes de todas las razas."
,"7":"Era imponente por su grandeza, por la amplitud de su ramaje, porque hundía sus raíces junto a aguas generosas."
,"8":"No le igualaban los demás cedros en el jardín de Dios, los cipreses no podían competir con su ramaje, los plátanos no tenían su follaje. Ningún árbol, en el jardín de Dios, era a él comparable en belleza."
,"9":"Yo le había hecho hermoso por la abundancia de sus ramas; todos los árboles de Edén, que había en el jardín de Dios, le tenían envidia."
,"10":"Pues bien, esto dice el Señor Dios: Por haberse estirado en su altura levantando su copa hasta las nubes, y haberse engreído su corazón por su grandeza,"
,"11":"yo lo he entregado en manos del príncipe de las naciones para que proceda con él conforme a su maldad; lo he desechado."
,"12":"Un pueblo extranjero, el más feroz de las naciones, lo ha talado y derribado; en los montes y por todos los valles han caído sus ramas, y su fronda yace destrozada por todos los barrancos del país. Todos los pueblos de la tierra se han retirado de su sombra y lo han abandonado."
,"13":"Sobre sus despojos se posan todas las aves del cielo y en su ramaje se acuestan todos los animales del campo,"
,"14":"para que ningún árbol plantado al borde del agua se engría por su altura ni levante su copa por entre las nubes, y para que no confíen en sí mismos y en su altura cuantos son regados por las aguas. Pues todos ellos están destinados a la muerte, a la morada subterránea, entre los hijos del hombre, entre los que bajan a la fosa."
,"15":"Esto dice el Señor Dios: El día en que bajó al reino de la muerte, en señal de duelo por él cerré el abismo, contuve sus ríos y las abundantes aguas se estancaron; vestí por él de luto al Líbano, y todos los árboles del campo se secaron por él."
,"16":"Hice temblar a las naciones con el estrépito de su caída; cuando le hice bajar al reino de la muerte con los que bajan a la fosa, se consolaron en las moradas subterráneas todos los árboles de Edén, los bellos y magníficos árboles del Líbano, regados todos por las aguas."
,"17":"También bajaron con él al reino de la muerte, junto a los atravesados por la espada, aquellos que moraban a su sombra en medio de las naciones."
,"18":"¿A quién te pareces en majestad y grandeza de entre los árboles de Edén? Pues también tú serás precipitado con los árboles de Edén a las moradas subterráneas, y entre incircuncisos yacerás con las víctimas de la espada. Tal será la suerte del Faraón y de todos sus súbditos', dice el Señor Dios."
}`)
	CurrentBook.AddChapter(32, `{
"1":"El año undécimo, el día uno del duodécimo mes, el Señor me dirigió la palabra y me dijo:"
,"2":"'Hijo de hombre, entona una elegía sobre el Faraón, rey de Egipto. Le dirás: ¡León entre las gentes, ya estás aniquilado!,Eras como un cocodrilo en el agua, agitabas los ríos con el soplo de tus narices, enturbiabas las aguas con tus patas, removías sus corrientes."
,"3":"Esto dice el Señor Dios: Tenderé sobre ti mi red, una manada de pueblos innumerables; en mi red te sacarán a tierra."
,"4":"Te dejaré en la tierra, en medio del campo te abandonaré. Haré posarse sobre ti todas las aves del cielo,y hartaré de ti a todas las bestias de la tierra."
,"5":"Tiraré tu carne por los montes, de tu carroña llenaré los valles."
,"6":"Con tus despojos regaré la tierra; con tu sangre, hasta la cima de los montes, hasta que rebosen los torrentes."
,"7":"Cuando te extingas, cubriré los cielos, oscureceré las estrellas, cubriré el sol de nubes,y la luna no dará ya su luz."
,"8":"Por ti oscureceré a todos los astros que brillan en el cielo,y cubriré de tinieblas tu país, dice el Señor Dios."
,"9":"Entristeceré el corazón de muchos pueblos cuando lleve a tus cautivos por las naciones, a tierras que no conoces."
,"10":"Por ti llenaré de terror a muchos pueblos y sus reyes; por tu causa se estremecerán de espanto, cuando yo blanda mi espada ante ellos; sin tregua temblarán por su propia vida el día de tu caída'."
,"11":"Pues esto dice el Señor Dios: 'La espada del rey de Babilonia te alcanzará."
,"12":"Abatiré a tu población innumerable por la espada de guerreros, todos ellos los más feroces de los pueblos; aniquilarán el orgullo de Egipto,y será exterminada toda su población."
,"13":"Haré perecer a todo tu ganado junto a las aguas abundantes. No ha de enturbiarlas más pie de hombre; pezuña de animales no volverá a enturbiarlas."
,"14":"Entonces amansaré sus aguas, haré correr sus ríos como aceite, dice el Señor Dios."
,"15":"Cuando yo deje desierta la tierra de Egipto,y el país sea despojado de cuanto contiene, cuando hiera a todos los que en él habitan, sabrán que yo soy el Señor'."
,"16":"Tal es la elegía que cantarán las hijas de las naciones, la cantarán sobre Egipto y sobre todo su pueblo, dice el Señor Dios."
,"17":"El año duodécimo, el quince del primer mes, el Señor me dirigió la palabra y me dijo:"
,"18":"'Hijo de hombre, compón un canto fúnebre sobre el pueblo de Egipto; hazle bajar a él y a las hijas de naciones poderosas a las moradas subterráneas, junto a los que bajan a la fosa."
,"19":"¿A quién superas en belleza?,¡Baja, échate entre los incircuncisos!"
,"20":"Caerán en medio de los atravesados por la espada. La espada está entregada: desplómese Egipto con toda su muchedumbre."
,"21":"Los héroes más ilustres, con sus asistentes, le hablarán de en medio del abismo. ¡Han caído, yacen entre incircuncisos, víctimas de la espada!"
,"22":"Allí está Asiria con todos sus guerreros en torno a su sepulcro; todos ellos han caído, víctimas de la espada."
,"23":"Sus sepulcros han sido puestos en las profundidades de la fosa y sus guerreros están en torno a su espada, los que sembraban el pánico en la tierra de los vivos."
,"24":"Allí yace Elán con todos sus guerreros en torno a su sepulcro; todos muertos, caídos a espada, hundidos como incircuncisos en las moradas subterráneas, ellos que sembraban el pánico en la tierra de los vivos. Han cargado con su ignominia junto a aquellos que bajan a la fosa."
,"25":"Una camilla le fue preparada en medio de sus muertos, y toda la gente está en torno a su sepulcro; todos incircuncisos, muertos a espada, ellos que sembraban el pánico con su ignominia junto a aquellos que bajan a la fosa y yacen entre los muertos a espada."
,"26":"Allí están Mesec, Tubal y todo su ejército, en torno a su sepulcro; son todos incircuncisos, muertos a espada, por haber sembrado el pánico en la tierra de los vivos."
,"27":"No yacen con los héroes caídos de antiguo, que bajaron al abismo con sus armas de guerra, cuyas espadas les fueron puestas bajo la cabeza y los escudos debajo de sus huesos, porque el terror de los héroes campeaba en la tierra de los vivos."
,"28":"Pero tú yacerás en medio de los incircuncisos, entre los muertos a espada."
,"29":"Allí está Edón con sus reyes y todos sus príncipes, quienes, a pesar de su prepotencia, fueron puestos junto con los muertos a espada; yacen entre los incircuncisos, entre los que bajan a la fosa."
,"30":"Allí están todos los jefes del norte y todos los sidonios, que descendieron con los muertos, a pesar del pánico que sembraban, confundidos a pesar de su prepotencia; yacen, incircuncisos, con los muertos a espada. Han cargado con su ignominia junto con los que bajan a la fosa."
,"31":"El Faraón los verá y se consolará de la suerte de su pueblo. Porque el Faraón será muerto a espada con todo su ejército, dice el Señor Dios."
,"32":"Había sembrado el pánico en la tierra de los vivos y allí está tendido en medio de los incircuncisos, con los muertos a espada: El Faraón y todo su ejército', afirma el Señor Dios."
}`)
	CurrentBook.AddChapter(33, `{
"1":"El Señor me dijo:"
,"2":"'Hijo de hombre, habla a los israelitas y diles: En caso de que yo haga venir la espada sobre un país dado, si la gente de este país toma a un hombre de entre los suyos y lo pone como centinela,"
,"3":"y éste, viendo avanzar la espada sobre el país, toca la trompeta y da la alarma al pueblo,"
,"4":"aquel que haya oído el sonido de la trompeta, si no hace caso y la espada, llegando, le sorprende, será él mismo responsable de su propia muerte."
,"5":"Oyó el sonido de la trompeta, pero no hizo caso. Por tanto, él es el culpable de su muerte, pues si hubiera hecho caso, habría salvado su vida."
,"6":"Si, por el contrario, el centinela, al ver que la espada se acerca, no da la alarma con la trompeta y el pueblo no es prevenido, y la espada, irrumpiendo, hiere a alguno, éste perecerá por su culpa, pero de su sangre pediré yo cuentas al centinela."
,"7":"Ahora bien, hijo de hombre, yo te he constituido a ti centinela de la casa de Israel. Cuando oigas de mi boca una palabra, los pondrás en guardia de mi parte."
,"8":"Si, cuando yo diga al malvado: ¡Morirás!, tú no hablas para amonestarlo que se corrija de su conducta, él, el malvado, morirá por su culpa, pero de su sangre te pediré cuentas a ti."
,"9":"Si, por el contrario, tú previenes al malvado acerca de su conducta para que se corrija y él no se corrige, morirá él por su culpa y tú habrás salvado tu vida."
,"10":"Hijo de hombre, di también a la casa de Israel: Así andáis diciendo vosotros: Nuestros delitos y nuestros pecados pesan sobre nosotros y por causa de ellos nos consumimos poco a poco. ¿Cómo podríamos vivir?"
,"11":"Diles: Por mi vida, dice el Señor Dios, que no me complazco en la muerte del malvado, sino en que se convierta de su conducta y viva. Convertíos, convertíos de vuestros perversos caminos. ¿Por qué queréis morir, oh casa de Israel?"
,"12":"Hijo de hombre, di aún a los hijos de tu pueblo: La justicia del justo no le salvará si se pervierte, ni el injusto perecerá por su injusticia si se convierte, así como el justo no podrá vivir por su justicia, si llega a pecar."
,"13":"Si yo digo al justo: Vivirás, pero él, confiado en su justicia, comete la injusticia, ninguna de sus obras justas será recordada. Morirá por la injusticia que ha cometido."
,"14":"Y si digo al injusto: ¡Morirás!, y él se convierte de sus pecados y practica la justicia y el derecho,"
,"15":"devuelve la prenda, restituye lo que ha robado y procede con arreglo a mis preceptos de vida sin volver a cometer el delito, vivirá y no morirá."
,"16":"Ninguno de los delitos que ha cometido le será ya imputado. Ha practicado la justicia y el derecho, por tanto vivirá."
,"17":"Pero las gentes de tu pueblo andan diciendo: ¡No es justo el camino del Señor, cuando son sus caminos los que no son justos!"
,"18":"Si el justo se desvía de su justicia y comete injusticia, por ella morirá."
,"19":"Y si el injusto se convierte de su injusticia y practica la justicia y el derecho, por ello vivirá."
,"20":"Vosotros andáis diciendo: ¡No es justo el camino del Señor! Pero yo os juzgaré a cada uno según su conducta, oh casa de Israel'."
,"21":"El año duodécimo de nuestro cautiverio, el día cinco del décimo mes, llegó a mí el fugitivo de Jerusalén y me dijo: '¡Ha sido tomada la ciudad!'."
,"22":"El Señor había puesto su mano sobre mí la tarde antes de llegar el fugitivo y había abierto mi boca antes que a la mañana siguiente llegara a mí el fugitivo. Entonces mi boca habló y no estuve mudo más."
,"23":"El Señor me dijo:"
,"24":"'Hijo de hombre, los habitantes que quedan entre las ruinas, en la tierra de Israel, andan diciendo: Uno solo era Abrahán y obtuvo el país en herencia, mientras que nosotros somos muchos; a nosotros se nos ha dado el país en posesión."
,"25":"Diles: Esto dice el Señor Dios: Coméis carne con sangre, alzáis los ojos hacia vuestros ídolos, derramáis sangre, ¿y vais a poseer el país?"
,"26":"Confiáis en vuestras espadas, cometéis acciones detestables, cada cual deshonra a la mujer de su prójimo, ¿y vais a poseer el país?"
,"27":"Les dirás lo siguiente: Esto dice el Señor Dios: Por mi vida que los que habitan entre las ruinas morirán a espada, los que andan por el campo los entregaré como pasto a las fieras y los que están en las fortalezas y en las cuevas morirán de peste."
,"28":"Reduciré la tierra a una soledad desolada y cesará el orgullo de su fuerza. Los montes de Israel serán devastados, sin que haya quien por allí pase."
,"29":"Y sabrán que yo soy el Señor, cuando haya convertido el país en un desierto desolado por todas las acciones detestables que han cometido."
,"30":"En cuanto a ti, hijo de hombre, las gentes de tu pueblo hablan de ti junto a los muros y en las puertas de las casas y se dicen los unos a los otros: Vamos a escuchar cuál es la palabra que viene de parte del Señor."
,"31":"Vienen a ti en masa, mi pueblo se sienta delante de ti, escucha tus palabras; pero luego no las ponen en práctica, porque tienen en su boca la mentira y su corazón va tras la ganancia injusta."
,"32":"Tú eres para ellos como una canción de amor, graciosamente cantada con acompañamiento de instrumentos de cuerda. Escuchan tus palabras y no las ponen en práctica."
,"33":"Pero cuando todo esto se cumpla -y esto ya llega- sabrán que había un profeta en medio de ellos'."
}`)
	CurrentBook.AddChapter(34, `{
"1":"El Señor me dijo:"
,"2":"'Hijo de hombre, profetiza contra los pastores de Israel y diles: Pastores, esto dice el Señor Dios: ¡Ay de los pastores de Israel que se apacientan a sí mismos! ¿No es el rebaño al que deben apacentar los pastores?"
,"3":"Vosotros os tomáis la leche y os vestís con la lana; matáis las ovejas cebadas, pero no apacentáis el rebaño."
,"4":"No habéis fortalecido a las débiles ni habéis curado a las enfermas; no habéis vendado a las heridas, no habéis hecho volver a las descarriadas ni buscado a las perdidas, sino que las habéis conducido con crueldad y violencia."
,"5":"Y ahora andan dispersas, por falta de pastor, presa de todas las fieras del campo;"
,"6":"andan dispersas mis ovejas; errantes por todos los montes, por todos los collados; dispersas mis ovejas por todo el país, sin que las busque nadie ni las cuide."
,"7":"Escuchad, pues, pastores, la palabra del Señor:"
,"8":"Por mi vida, dice el Señor Dios, que por haber sido mi rebaño expuesto al pillaje y mis ovejas pasto de todas las fieras del campo por falta de pastor, por no haber cuidado mis pastores mi ganado y haberse en cambio apacentado a sí mismos en lugar de mi rebaño,"
,"9":"por eso, escuchad, pastores, la palabra del Señor."
,"10":"Esto dice el Señor Dios: Aquí estoy yo contra los pastores reclamando mi rebaño de sus manos. No les confiaré más el pastoreo de mi rebaño; así no se apacentarán más a sí mismos. Les arrebataré mi ganado de su boca y ya no les servirá de pasto."
,"11":"Pues esto dice el Señor Dios: Yo mismo cuidaré de mi ganado y le pasaré revista."
,"12":"Como un pastor pasa revista a su ganado cuando se encuentra entre su rebaño disperso, así pasaré yo revista a mis ovejas y las recobraré de todos los lugares donde se habían dispersado en día de nubes y tinieblas."
,"13":"Las sacaré de en medio de los pueblos y las recogeré de entre los países. Las llevaré a su tierra, las pastorearé por los montes de Israel, por los valles y en todos los lugares habitados del país."
,"14":"Las apacentaré en pastos escogidos; su majada estará en los montes altos de Israel; allí descansarán en cómodo aprisco y pacerán pingües pastos por los montes de Israel."
,"15":"Yo mismo llevaré mi rebaño a pastar y lo devolveré al lugar de su descanso, dice el Señor Dios."
,"16":"Buscaré la oveja perdida y haré volver a la descarriada; vendaré a la herida, fortaleceré a la flaca, cuidaré de la gorda y robusta; las apacentaré como es justo."
,"17":"En cuanto a vosotros, rebaño mío, esto dice el Señor Dios: Yo mismo juzgaré entre oveja y oveja, entre carnero y macho cabrío."
,"18":"¿No os basta pacer en buenos pastos para que pisoteéis el resto del pasto? ¿No os basta beber el agua limpia para que enturbiéis el resto con los pies?"
,"19":"¿Ha de pastar mi rebaño lo que vosotros habéis pisoteado y beber lo que habéis enturbiado con vuestros pies?"
,"20":"Por eso, esto les dice el Señor Dios: Yo mismo juzgaré entre la oveja gorda y la flaca;"
,"21":"porque vosotros habéis empujado con el flanco y el lomo, con los cuernos habéis topado a las más débiles hasta echarlas fuera;"
,"22":"yo defenderé a mi rebaño y no servirán más de presa; haré justicia entre oveja y oveja."
,"23":"Yo les suscitaré un pastor que las apaciente, mi siervo David. Él las conducirá al pasto y será su pastor."
,"24":"Yo, el Señor, seré su Dios, y mi siervo David será príncipe en medio de ellos: Yo, el Señor, he hablado."
,"25":"Haré con ellos un pacto de paz y exterminaré del país las bestias feroces; morarán tranquilos hasta en el desierto y reposarán en los bosques."
,"26":"Los asentaré en torno a mi colina. Mandaré a su tiempo las lluvias, lluvias de bendición."
,"27":"El árbol del campo dará sus frutos y la tierra dará sus productos. Habitarán seguros en su tierra y sabrán que yo soy el Señor, cuando haya despedazado las coyundas de su yugo y les haya librado de las manos de quienes los tienen esclavizados."
,"28":"No volverán a ser presa de las gentes ni los devorarán las fieras del país, habitarán seguros sin que nadie los espante."
,"29":"Haré brotar para ellos una plantación gloriosa, no serán más consumidos por el hambre en el país, ni sufrirán más el ultraje de las naciones."
,"30":"Y sabrán que yo, el Señor, su Dios, estoy con ellos, y que ellos, la casa de Israel, son mi pueblo, dice el Señor Dios:"
,"31":"Vosotras, ovejas mías, sois el rebaño de mi pasto y yo soy vuestro Dios, dice el Señor Dios'."
}`)
	CurrentBook.AddChapter(35, `{
"1":"El Señor me dijo:"
,"2":"'Hijo de hombre, vuelve tu rostro hacia la montaña de Seír y profetiza contra ella."
,"3":"Dirás: Esto dice el Señor: Aquí estoy contra ti, montaña de Seír; extenderé mi mano contra ti,y te reduciré a un desierto desolado;"
,"4":"convertiré en ruinas tus ciudades, quedarás hecha una desolación,y sabrás que yo soy el Señor."
,"5":"Porque has alimentado un odio secular y has entregado a la espada a los israelitas el día de su último crimen,"
,"6":"por mi vida, dice el Señor, que te llenaré de sangre y la sangre te perseguirá."
,"7":"Haré de los montes de Seír una desolación, un desierto, y extirparé de allí a todo el que circula."
,"8":"Llenaré de muertos sus montañas. En sus collados, en sus valles, en todos sus barrancos caerán los muertos a espada."
,"9":"A desolación eterna te reduciré, no serán ya habitadas tus ciudades y sabréis que yo soy el Señor."
,"10":"Por haber dicho: Las dos naciones, los dos países son míos; los poseeremos en herencia aunque esté allí el Señor,"
,"11":"por mi vida, dice el Señor Dios, que procederé contigo con arreglo al furor y a la pasión que tú has mostrado en tu odio contra ellos, y me manifestaré en medio de ellos cuando te juzgue."
,"12":"Y sabrás que yo, el Señor, he oído todos los ultrajes que lanzabas contra los montes de Israel cuando decías: Están devastados, nos han sido dados como presa."
,"13":"Me habéis desafiado con vuestra boca y habéis acumulado contra mí vuestras palabras: Yo lo he oído."
,"14":"Y ahora esto dice el Señor Dios: Mientras toda la tierra se alegra, yo haré de ti una desolación."
,"15":"Como tú te alegraste cuando la heredad de la casa de Israel era devastada, así haré yo contigo; en desolación te convertirás, monte de Seír, así como Edón entero, y se sabrá que yo soy el Señor."
}`)
	CurrentBook.AddChapter(36, `{
"1":"Hijo de hombre, profetiza ahora sobre los montes de Israel. Dirás: Montes de Israel, escuchad la palabra del Señor."
,"2":"Esto dice el Señor Dios: Por haber dicho el enemigo contra vosotros: ¡Ja, ja, estas colinas eternas han pasado a nuestra herencia!,"
,"3":"por eso profetiza y di: Esto dice el Señor Dios: Porque habéis sido devastados y tomados por todas partes y estáis ahora en poder de otras naciones, hechos blanco de burlas y de insultos por parte del pueblo,"
,"4":"por eso, escuchad, montes de Israel, la palabra del Señor. Esto dice el Señor Dios a los montes y a las colinas, a los torrentes y a los valles, a las ruinas desiertas y a las ciudades desoladas que han sido botín y blanco de burlas de las naciones circunvecinas."
,"5":"Esto dice el Señor Dios: Lo juro en el ardor de mi cólera; a los restos de las naciones, a Edón entero me dirijo, a los que se han atribuido la posesión de mi tierra, con la alegría en el corazón y el desprecio en el alma para saquearla y expoliarla."
,"6":"Por eso, profetiza sobre el país de Israel, di a los montes y a las colinas, a los torrentes y a los valles: Esto dice el Señor Dios: Aquí estoy; en mis celos y en mi furor he hablado; porque habéis sido expuestos al oprobio de las naciones,"
,"7":"esto dice el Señor Dios: Yo levanto mi mano y juro que las naciones circunvecinas soportarán también ellas su oprobio."
,"8":"Y vosotros, montes de Israel, echad vuestros ramos, producid vuestros frutos para mi pueblo Israel, porque está ya para volver."
,"9":"Aquí estoy, me acerco a vosotros, a vosotros me dirijo: volveréis a ser labrados y sembrados."
,"10":"Multiplicaré en medio de vosotros a los hombres, toda la casa de Israel. Las ciudades serán repobladas y las ruinas reconstruidas."
,"11":"Multiplicaré en vosotros los hombres y los animales, serán numerosos y fecundos; os poblaré como antaño, seré más generoso con vosotros que anteriormente y sabréis que yo soy el Señor."
,"12":"Acumularé hombres en vosotros, mi pueblo Israel, tú serás su propiedad y su herencia y no volverás a privarles de sus hijos."
,"13":"Esto dice el Señor Dios: Porque se ha dicho de ti: Eres una tierra devoradora de hombres, has privado de hijos a tu pueblo,"
,"14":"por eso ya no devorarás más hombres, ni privarás a tu nación de hijos, dice el Señor Dios."
,"15":"No consentiré que se oiga más contra ti el ultraje de las naciones, no soportarás más el escarnio de los pueblos ni privarás de hijos a tu nación', dice el Señor Dios."
,"16":"El Señor me dijo:"
,"17":"'Hijo de hombre, los israelitas cuando habitaban en su tierra la mancharon con su proceder y sus acciones. Como la impureza de una mujer en la menstruación era su conducta ante mí."
,"18":"Yo derramé mi furor sobre ellos por la sangre que habían vertido en el país y por los ídolos con los cuales lo habían contaminado."
,"19":"Los dispersé entre las naciones, los esparcí por diversos países, los juzgué según su conducta y sus acciones."
,"20":"Y en las naciones donde llegaron profanaron mi santo nombre, al decirse de ellos: Son el pueblo del Señor y han tenido que abandonar su país."
,"21":"Pero yo tuve consideración de mi santo nombre, que la casa de Israel profanaba en medio de las gentes entre las que se encontraba."
,"22":"Di, pues, a la casa de Israel: Esto dice el Señor Dios: No hago esto por consideración a vosotros, casa de Israel, sino por mi santo nombre, que vosotros habéis profanado entre las gentes donde fuisteis."
,"23":"Santificaré mi gran nombre, profanado entre las naciones, deshonrado por vosotros en medio de ellas, y sabrán las naciones que yo soy el Señor, dice el Señor Dios, cuando me glorifique en vosotros a la vista de ellos."
,"24":"Os tomaré de entre las gentes donde estáis, os recogeré de todos los países y os conduciré a vuestra tierra."
,"25":"Os rociaré con agua pura y os purificaré de todas vuestras inmundicias y de todos vuestros ídolos."
,"26":"Os daré un corazón nuevo y os infundiré un espíritu nuevo; quitaré de vuestro cuerpo el corazón de piedra y os daré un corazón de carne."
,"27":"Infundiré mi espíritu en vosotros y haré que viváis según mis preceptos, observando y guardando mis leyes."
,"28":"Habitaréis entonces en la tierra que di a vuestros padres, seréis mi pueblo y yo seré vuestro Dios."
,"29":"Os libraré de todas vuestras inmundicias; llamaré al trigo, lo multiplicaré y no pasaréis más hambre."
,"30":"Haré que los árboles den en abundancia sus frutos y el campo sus productos, a fin de que no sufráis más el oprobio del hambre entre las naciones."
,"31":"Recordaréis vuestra perversa conducta y vuestras malas acciones y sentiréis asco de vosotros mismos por vuestras iniquidades y vuestras detestables acciones."
,"32":"Sabed, sin embargo, que no hago esto por consideración a vosotros, dice el Señor Dios. ¡Avergonzaos, más bien, y abochornaos de vuestra conducta, oh casa de Israel!"
,"33":"Esto dice el Señor Dios: El día que os limpie de vuestras iniquidades repoblaré las ciudades y haré que resurjan las ruinas."
,"34":"La tierra desolada, donde el viandante no veía más que devastación, será cultivada de nuevo."
,"35":"Entonces se dirá: La tierra que estaba hasta ahora devastada se ha convertido como en un jardín de Edén, y las ciudades arruinadas, demolidas y destruidas son de nuevo fortalezas habitadas."
,"36":"Entonces las naciones que queden a vuestro alrededor sabrán que yo, el Señor, he reedificado lo que estaba destruido y he replantado lo que estaba asolado: Yo, el Señor, lo digo y lo hago."
,"37":"Esto dice el Señor Dios: Aún me dejaré aplacar por la casa de Israel, los multiplicaré como un rebaño humano,"
,"38":"como un rebaño de ovejas consagradas, como el rebaño reunido en Jerusalén en las fiestas solemnes. Así estarán llenas de rebaños humanos las ciudades destruidas, y sabrán que yo soy el Señor."
}`)
	CurrentBook.AddChapter(37, `{
"1":"El Señor puso su mano sobre mí, me trasladó por medio de su espíritu y me dejó en medio de la vega, que estaba llena de huesos."
,"2":"Me hizo pasar por ellos en todas las direcciones. Era una cantidad inmensa a lo largo de la vega y estaban completamente secos."
,"3":"Y me dijo: 'Hijo de hombre, ¿podrán revivir estos huesos?'. Yo le respondí: 'Señor Dios, tú lo sabes'."
,"4":"Y me dijo: 'Profetiza sobre estos huesos y diles: ¡Huesos resecos, escuchad la palabra del Señor!"
,"5":"Esto dice el Señor Dios a estos huesos: Yo haré que entre de nuevo el espíritu en vosotros y reviviréis."
,"6":"Os cubriré de nervios, haré crecer sobre vosotros la carne, os echaré encima la piel y os infundiré el espíritu y viviréis, y sabréis que yo soy el Señor'."
,"7":"Yo profeticé como me había ordenado, y mientras profetizaba se sintió un ruido; hubo un estremecimiento y los huesos se juntaron unos a otros."
,"8":"Miré y vi aparecer sobre ellos los nervios, crecer la carne y recubrirse todo de piel. Pero no tenían el espíritu de vida."
,"9":"Entonces él me dijo: 'Profetiza al espíritu, profetiza, hijo de hombre, y di al espíritu: Esto dice el Señor Dios: ¡Ven, espíritu, de los cuatro vientos y sopla sobre estos muertos para que revivan!'."
,"10":"Profeticé como el Señor me había ordenado, y el espíritu entró en aquellos huesos, que se reanimaron y se pusieron en pie. Era una cantidad inmensa."
,"11":"Y me dijo: 'Hijo de hombre, estos huesos son toda la casa de Israel. Ellos andan diciendo: ¡Se han secado nuestros huesos, se ha desvanecido nuestra esperanza, estamos perdidos para siempre!"
,"12":"Pr eso profetiza y diles: Esto dice el Señor Dios: Mirad, yo abriré vuestras tumbas, os haré salir de vuestros sepulcros, pueblo mío, y os llevaré a la tierra de Israel."
,"13":"Y sabréis que yo soy el Señor, cuando abra vuestras tumbas y os haga salir de vuestros sepulcros, pueblo mío."
,"14":"Infundiré en vosotros mi espíritu y reviviréis; os estableceré en vuestro suelo y sabréis que yo, el Señor, lo digo y lo hago', dice el Señor."
,"15":"El Señor me dijo:"
,"16":"'Y tú, hijo de hombre, toma un trozo de madera y escribe en él: Judá y los israelitas asociados con ella. Toma luego otro trozo y escribe: José, leño de Efraín, y toda la casa de Israel asociada con él."
,"17":"Junta después la una con la otra, de suerte que formen una sola pieza de madera, que sean una sola cosa en tu mano."
,"18":"Y cuando te pregunten las gentes de tu pueblo: ¿Querrías explicarnos qué significa esto?,"
,"19":"les responderás: Esto dice el Señor Dios: Voy a tomar la vara de José, que está en la mano de Efraín y de las tribus de Israel que están con él, y la voy a unir con la vara de Judá, de forma que, unidas en mi mano, sean una sola cosa."
,"20":"Los leños en los cuales hayas escrito los tendrás en la mano ante sus ojos"
,"21":"y dirás: Esto dice el Señor Dios: Yo recogeré a los israelitas de entre las naciones a las que emigraron y los congregaré de todas partes para llevarlos a su tierra."
,"22":"Haré de ellos un solo pueblo en mi tierra, en los montes de Israel; tendrán todos un solo rey y ya no serán dos naciones, dos reinos divididos."
,"23":"No se contaminarán más con sus ídolos, sus acciones repugnantes y sus crímenes. Los salvaré de todas las infidelidades que cometieron y los purificaré. Serán mi pueblo y yo seré su Dios."
,"24":"Reinará sobre ellos mi siervo David. Todos ellos tendrán un solo pastor y caminarán por la senda de mis mandamientos, guardando mis leyes y poniéndolas en práctica."
,"25":"Habitarán la tierra que yo di a mi siervo Jacob, donde habitaron vuestros padres. Allí habitarán ellos, sus hijos y los hijos de sus hijos siempre. David, mi siervo, será su príncipe eternamente."
,"26":"Haré con ellos una alianza de paz que no tendrá fin; los estableceré y los multiplicaré y pondré mi santuario en medio de ellos para siempre."
,"27":"Sobre ellos estableceré mi morada; seré su Dios y ellos serán mi pueblo."
,"28":"Y sabrán las gentes que yo, el Señor, consagro a Israel, cuando mi santuario esté en medio de ellos por siempre'."
}`)
	CurrentBook.AddChapter(38, `{
"1":"El Señor me dijo:"
,"2":"'Hijo de hombre, vuelve tu rostro hacia Gog, del país de Magog, príncipe soberano de Mesec y Tubal, y profetiza contra él."
,"3":"Dirás: Esto dice el Señor Dios: Aquí estoy contra ti, Gog, príncipe de Mesec y Tubal;"
,"4":"yo te haré volver, te pondré garfios en las quijadas; te haré salir con todo tu ejército, caballos y caballeros, todos bien equipados; huestes inmensas con adargas y escudos, todos diestros en el manejo de la espada."
,"5":"Persia, Etiopía y Put los acompañan, todos con escudos y yelmos;"
,"6":"Gómer con todas sus huestes, Bet Togorma, las regiones extremas del norte con todas sus fuerzas, pueblos innumerables están contigo."
,"7":"Ponte en guardia, prepárate tú y todas las tropas que se han congregado en torno a ti, y ponte a mi disposición."
,"8":"Al cabo de muchos días recibirás órdenes; después de muchos años marcharás contra la nación escapada a la espada, que fue congregada de numerosos pueblos en los montes de Israel, largo tiempo desiertos. Ella regresó de entre las naciones y habitan todos en seguridad."
,"9":"Subirás, llegarás al país como un huracán, como un nubarrón que cubrirá la tierra, tú y todas tus huestes y los numerosos pueblos que están contigo."
,"10":"Esto dice el Señor Dios: Aquel día te vendrán a la mente proyectos y concebirás un plan perverso."
,"11":"Dirás: Voy a subir contra un país sin defensa; caeré sobre sus gentes pacíficas, que viven seguras y habitan todas sin defensas de muros, cerrojos y puertas."
,"12":"Iré a saquear, a pillar botín, a extender la mano sobre ruinas repobladas y sobre un pueblo congregado de entre las naciones, que está entregado a reponer el ganado y la hacienda y que habita en el corazón de la tierra."
,"13":"Sebá y Rodas, los mercaderes de Tarsis, y todos sus leoncillos te dirán: ¿Vienes a saquear? ¿Has reunido acaso tus tropas para darte al pillaje, llevarte oro y plata, apoderarte de ganados y bienes, para hacer un gran botín?"
,"14":"Por eso, hijo de hombre, profetiza y di a Gog: Esto dice el Señor Dios: Sí, aquel día, cuando mi pueblo Israel viva tranquilo, tú lo sabrás"
,"15":"y vendrás de tu región de los confines del norte, junto con otros pueblos numerosos, todos montados a caballo, una turba innumerable, un ejército poderoso."
,"16":"Subirás contra mi pueblo Israel como un nublado que cubre el país. Será al fin de los tiempos cuando yo te haga venir a mi tierra a fin de que las gentes me conozcan, al manifestar yo mi santidad en ti, oh Gog, ante sus ojos."
,"17":"Esto dice el Señor Dios: Tú eres aquel de quien yo hablé antaño por medio de mis siervos los profetas de Israel, que profetizaron en aquella época prediciendo que yo te haría venir contra ellos."
,"18":"Pero aquel día, cuando Gog llegue a la tierra de Israel, dice el Señor Dios, mi ira explotará"
,"19":"y en mis celos, en el ímpetu de mi furor, lo aseguro: Aquel día habrá un gran temblor de tierra en el suelo de Israel."
,"20":"Temblarán ante mí los peces del mar, los pájaros del cielo, los animales del campo, todos los reptiles que serpean sobre el suelo y todos los hombres de la superficie de la tierra."
,"21":"Se hundirán los montes, caerán las rocas, todos los muros se desplomarán."
,"22":"Convocaré contra él terrores de todas clases, dice el Señor Dios. Sus gentes volverán las espadas unos contra otros."
,"23":"Haré con él justicia mandándole peste y sangre; haré caer una lluvia torrencial, con granizo, fuego y azufre sobre él, sobre sus huestes y sobre los numerosos pueblos que lo acompañan."
,"24":"Así manifestaré mi grandeza y mi santidad, me daré a conocer a los ojos de muchos pueblos y sabrán que yo soy el Señor."
}`)
	CurrentBook.AddChapter(39, `{
"1":"Hijo de hombre, profetiza contra Gog y di: Esto dice el Señor Dios: Aquí estoy contra ti, Gog, príncipe soberano de Mesec y Tubal."
,"2":"Yo te haré ir y volver, te conduciré, y desde los confines del norte te traeré a los montes de Israel;"
,"3":"pero allí despedazaré el arco de tu mano izquierda y haré caer las flechas de tu diestra."
,"4":"Sobre los montes de Israel caerás juntamente con tus huestes y los pueblos que te acompañan, porque te he destinado como pasto a toda clase de aves de rapiña y a las fieras salvajes."
,"5":"Caerás en pleno campo; porque he hablado yo, dice el Señor Dios."
,"6":"Y mandaré fuego sobre Magog y sobre los que viven seguros en las islas, y sabrán que yo soy el Señor."
,"7":"Manifestaré mi santo nombre en medio de mi pueblo Israel, no permitiré que vuelva a ser profanado mi santo nombre y sabrán las naciones que yo soy el Señor, el Santo de Israel."
,"8":"Todo esto se acerca y se va a cumplir, dice el Señor Dios; éste es el día que he anunciado."
,"9":"Entonces los habitantes de las ciudades de Israel saldrán fuera y prenderán fuego y quemarán las armas, escudos y paveses, arcos y flechas, mazas y lanzas; harán fuego con ello durante siete años."
,"10":"No irán a buscar leña en los campos ni la cortarán en los bosques, porque harán fuego con las armas; saquearán a sus saqueadores y despojarán a sus despojadores, dice el Señor Dios."
,"11":"Aquel día asignaré a Gog como sepulcro un lugar famoso en Israel, el valle de los montes de Abarín, al este del mar, el que corta el paso a los viandantes; allí será enterrado Gog con toda su multitud, y se llamará por eso valle de Hamón Gog."
,"12":"La casa de Israel los enterrará, a fin de purificar el país durante siete años."
,"13":"Toda la población del país será movilizada para enterrarlos y permanecerá ante ellos conmemorando el día de mi glorificación, dice el Señor Dios."
,"14":"Se escogerán hombres que recorran el país enterrando a los que hayan quedado por el suelo para purificarlo; durante siete meses continuarán su búsqueda."
,"15":"Y cuando, al recorrer el país, encuentren huesos humanos, pondrán junto a ellos una señal hasta que los entierren los sepultureros en el valle de Hamón Gog."
,"16":"La localidad se llamará también Hamoná. Así purificarán el país."
,"17":"En cuanto a ti, hijo de hombre, esto dice el Señor Dios: Di a las aves de todas clases y a todas las bestias salvajes: Reuníos y venid; reuníos de todas partes en torno al sacrificio inmenso sobre los montes de Israel. Comeréis carne y beberéis sangre."
,"18":"Carne de héroes comeréis, sangre de príncipes de la tierra beberéis. Carneros, corderos, machos cabríos, terneros, pingües toros de Basán."
,"19":"Comeréis grasa a saciedad y beberéis sangre hasta la embriaguez del sacrificio que yo hago para vosotros."
,"20":"Os hartaréis a mi mesa de caballos y caballeros, de héroes y toda clase de guerreros, dice el Señor Dios."
,"21":"Así manifestaré mi gloria a las naciones, y todas las naciones verán la sentencia que yo ejecutaré y la mano que pondré sobre ellos."
,"22":"La casa de Israel sabrá que yo, el Señor, soy su Dios, desde aquel día en adelante."
,"23":"Y sabrán las naciones que la casa de Israel fue deportada por causa de sus iniquidades, por haberse rebelado contra mí. Por eso la privé yo de mi favor y la entregué en manos de sus enemigos y murieron todos a espada."
,"24":"Los traté según sus inmundicias y sus pecados; por esto, les volví la espalda."
,"25":"Esto dice el Señor Dios: Ahora haré regresar a los cautivos de Jacob, me compadeceré de toda la casa de Israel y me mostraré celoso de mi santo nombre."
,"26":"Y cuando vivan seguros en su territorio sin que nadie los atemorice, sentirán el peso de su ignominia y de todas las infidelidades que cometieron contra mí."
,"27":"Cuando yo los haga volver de entre las gentes, los recoja de la tierra de sus enemigos y manifieste en ellos mi santidad a los ojos de innumerables pueblos,"
,"28":"sabrán que yo soy el Señor, su Dios, porque después de haberlos llevado al destierro entre las gentes, los reuní en su territorio sin haber dejado allí ni a uno solo."
,"29":"No les volveré más la espalda, pues derramaré mi espíritu sobre la casa de Israel, dice el Señor Dios."
}`)
	CurrentBook.AddChapter(40, `{
"1":"El año veinticinco de nuestro destierro, al comienzo del año, el día diez del mes, catorce años después de la caída de la ciudad, aquel día el Señor puso su mano sobre mí y me llevó,"
,"2":"en visiones divinas, a la tierra de Israel. Me posó sobre un monte altísimo, en cuya cima parecía que estaba edificada una ciudad mirando al mediodía."
,"3":"Me llevó allá; había allí un personaje de aspecto semejante al bronce, que tenía en la mano una cuerda de lino y una vara de medir, y estaba de pie junto a la puerta."
,"4":"Aquel personaje me dijo: 'Hijo de hombre, mira bien, escucha atentamente y fíjate en todo lo que te voy a mostrar. Has sido traído para que yo te lo muestre y comuniques luego a la casa de Israel cuanto yo te enseñe'."
,"5":"Yo vi un muro exterior, que rodeaba el templo por todas partes. La vara de medir que el personaje tenía en sus manos era de tres metros. Luego midió el muro, y tenía una vara de ancho y otra de alto."
,"6":"Fue después al pórtico que mira hacia oriente, subió sus gradas y midió el umbral del pórtico: una vara de profundidad."
,"7":"Cada sala medía una vara de largo y otra de ancho; la pilastra entre sala y sala era de dos metros y medio, y el umbral del pórtico por el lado de su vestíbulo hasta el interior medía una vara."
,"8":"Midió el vestíbulo del pórtico hacia el interior:"
,"9":"era de cuatro metros, y sus pilares de un metro. El vestíbulo del pórtico estaba situado hacia el interior."
,"10":"Las salas del pórtico oriental eran tres por un lado y tres por el otro, todas ellas de la misma medida, así como tenían también la misma medida las pilastras de los dos lados."
,"11":"Después midió la anchura del vano del pórtico: cinco metros; la longitud del pórtico era de seis metros y medio."
,"12":"Delante de cada sala había un parapeto de medio metro por un lado y por el otro, y cada una de las celdas tenía tres metros por ambos lados."
,"13":"Midió a continuación el pórtico desde el fondo de una sala al de la otra. La anchura era de doce metros y medio entre cada abertura."
,"14":"Las pilastras tenían treinta metros; en la pilastra comenzaba el atrio que rodeaba el pórtico por todos lados."
,"15":"Desde la extremidad del pórtico por el exterior hasta el frente del vestíbulo por dentro había veinticinco metros."
,"16":"Sobre las salas y las pilastras por todo alrededor se abrían ventanas enrejadas hacia el interior; igualmente había en torno ventanas que daban al interior del vestíbulo. Sobre las pilastras había palmeras diseñadas."
,"17":"Me llevó después al atrio exterior. También allí había salas y un enlosado alrededor del atrio; treinta salas daban al enlosado."
,"18":"El enlosado iba por los costados de las puertas y su ancho era igual al largo de éstas: esto el enlosado de abajo."
,"19":"Midió también la distancia desde la puerta de abajo hasta la puerta del atrio interior: cincuenta metros."
,"20":"Después midió la anchura y la longitud del pórtico que daba al norte, en el atrio exterior."
,"21":"Sus salas eran tres por ambos lados, y sus pilastras y vestíbulos tenían las mismas dimensiones que el primer pórtico: veinticinco metros de largo por doce y medio de ancho."
,"22":"Sus ventanas, su vestíbulo y sus palmeras tenían las mismas medidas que las del pórtico cuya fachada miraba a oriente. Se subía al pórtico por siete gradas, y su vestíbulo estaba situado hacia el interior."
,"23":"Había un pórtico en el atrio interior frente al pórtico norte, como en el pórtico este. Midió la distancia entre pórtico y pórtico: era de cincuenta metros."
,"24":"Después me llevó hacia el lado sur. Había allí un pórtico en dirección del mediodía. Midió las salas, las pilastras y el vestíbulo: tenían la misma dimensión que las otras."
,"25":"Alrededor del pórtico y del vestíbulo había ventanas iguales a las anteriores: su longitud era de veinticinco metros y su anchura de doce y medio."
,"26":"Se subía a él por siete gradas, y su vestíbulo estaba situado hacia el interior. Sus pilastras por ambos lados estaban diseñadas de palmeras."
,"27":"El atrio interior tenía también un pórtico hacia el sur; midió la distancia entre un pórtico y otro en dirección sur: cincuenta metros."
,"28":"A continuación me llevó al atrio interior por el pórtico sur. Midió este pórtico que daba al sur: tenía iguales dimensiones que los otros."
,"29":"Sus celdas, sus pilastras y su vestíbulo tenían idénticas medidas. Tenía ventanas por todo alrededor, así como su vestíbulo. Su longitud era de veinticinco metros y su anchura de doce y medio."
,"30":"En torno giraba un vestíbulo de doce metros y medio de largo y dos y medio de ancho."
,"31":"Su vestíbulo daba al atrio exterior, sus pilastras tenían palmeras diseñadas y se subía a él por ocho gradas."
,"32":"Después me llevó al pórtico que mira al este, y lo midió. Tenía las mismas dimensiones de los otros."
,"33":"Las celdas, las pilastras y el vestíbulo medían igual que los precedentes. El pórtico y su vestíbulo tenían ventanas alrededor: era de veinticinco metros de largo y doce y medio de ancho."
,"34":"Su vestíbulo daba al atrio exterior. Sobre las pilastras de ambos lados había diseños de palmeras y se subía a él por ocho gradas."
,"35":"Me llevó después al pórtico norte y lo midió."
,"36":"Las mismas dimensiones que los anteriores tenían sus celdas, pilastras y vestíbulo. Había también ventanas alrededor. Era de veinticinco metros de largo y doce y medio de ancho."
,"37":"Su vestíbulo daba al atrio exterior; sobre las pilastras de ambos lados había diseños de palmeras y se subía a él por ocho gradas."
,"38":"Había también una sala, cuya entrada se hallaba en el vestíbulo de los pórticos; allí se lavaban los holocaustos."
,"39":"En el vestíbulo del pórtico había dos mesas en cada un de los dos lados para degollar sobre ellas los holocaustos, los sacrificios por el pecado y los de reparación."
,"40":"Otras dos mesas había en el lado exterior, para el que sube, a la entrada del pórtico norte, y otras dos al otro lado, hacia el vestíbulo del pórtico."
,"41":"A cada lado del pórtico, cuatro mesas: ocho en total, sobre las que se degollaban las víctimas,"
,"42":"además de las otras cuatro mesas de piedra tallada para los holocaustos, de setenta y cinco centímetros de largas, setenta y cinco de anchas y cincuenta de altas. Sobre ellas se colocaban los instrumentos con los que se degollaban los holocaustos y las otras víctimas."
,"43":"Las mesas tenían un reborde de veinticinco centímetros de altura alrededor, y sobre ellas se ponía la carne de las víctimas sacrificadas."
,"44":"Me llevó al atrio interior. Había dos salas, una al lado del pórtico norte, con su fachada al sur; otra al lado del pórtico sur, cuya fachada da al norte."
,"45":"Y me dijo: 'La sala que da al sur es para los sacerdotes encargados del servicio del templo;"
,"46":"la sala cuya fachada da al norte, para los sacerdotes que desempeñan el servicio del altar. Son los hijos de Sadoc, los que, entre los hijos de Leví, se acercan al Señor para servirle'."
,"47":"Midió luego el atrio: era un cuadrado de cincuenta metros de lado. El altar estaba frente al templo."
,"48":"Después me llevó al vestíbulo del templo y midió sus pilastras: dos metros y medio por cada lado; la anchura del pórtico era de metro y medio por ambos lados."
,"49":"El vestíbulo tenía diez metros de longitud y seis de anchura. Se subía a él por diez gradas. Y junto a las pilastras había columnas, una a cada lado."
}`)
	CurrentBook.AddChapter(41, `{
"1":"Después me introdujo en la nave central y midió sus pilastras: tres metros de anchura por un lado y tres por el otro."
,"2":"La anchura de la puerta era de cinco metros: dos metros y medio por un lado y dos y medio por el otro. Midió también el santuario: veinte metros de largo por diez de ancho."
,"3":"De allí penetró en el interior y midió las pilastras de la puerta: un metro; la puerta: tres metros; la anchura de la puerta: tres metros y medio."
,"4":"La longitud: diez metros; la anchura por el lado del santo: diez metros. Y me dijo: 'Éste es el lugar santo'."
,"5":"Midió después el muro del templo: tres metros, y la anchura de las salas laterales: dos metros, todo alrededor del templo."
,"6":"Las salas laterales estaban superpuestas, en tres pisos, una sobre otra. Treinta en cada piso. Para estribar las salas, en todo el círculo, había, en el muro del templo, salientes, de suerte que las salas no se incrustaban en el muro del templo."
,"7":"La anchura de las salas aumentaba a medida que se subía, porque el saliente del muro, en cada piso, giraba en torno al templo y así por arriba el templo dejaba a las salas una amplitud un poco mayor. Del piso inferior se podía subir al del medio, y de éste al superior."
,"8":"Observé que el templo estribaba alrededor sobre un basamento sobreelevado. Era la base de las salas laterales, que medía tres metros."
,"9":"El espesor del muro exterior de las salas era de dos metros y medio; quedaba un paso libre junto a las salas del templo."
,"10":"Entre las salas había una anchura de diez metros todo alrededor del templo."
,"11":"Las cámaras laterales tenían dos entradas: una daba al norte, y la otra al mediodía. La anchura del paso libre era de dos metros y medio todo alrededor."
,"12":"La construcción que daba al atrio por el lado oeste tenía treinta y cinco metros de anchura; y el muro de la construcción: dos metros y medio de espesor y cuarenta y cinco de longitud."
,"13":"Después midió el templo: cincuenta metros de longitud; el espacio cercado, más la construcción y sus muros: cincuenta metros de longitud."
,"14":"Anchura de la fachada del templo más el espacio cercado en dirección este: cincuenta metros."
,"15":"Midió también la longitud del edificio frente al espacio cercado de la parte de atrás, con sus pórticos a uno y a otro lado: cincuenta metros. El interior del santuario y los vestíbulos del atrio, "
,"16":"los umbrales, las ventanas enrejadas y las galerías de tres pisos, comenzando desde la entrada, estaban recubiertos de madera. Desde el pavimento hasta las ventanas, veladas con cortinas;"
,"17":"desde la puerta hasta el fondo del templo, por dentro y por fuera, las paredes internas y externas estaban cubiertas de figuras:"
,"18":"había esculpidos querubines y palmeras. Entre querubín y querubín había una palmera; cada querubín tenía dos caras:"
,"19":"una cara de hombre vuelta hacia una palmera y una cara de león hacia la otra, representados todo alrededor del templo."
,"20":"Desde el suelo hasta la parte superior de la puerta había representados querubines y palmeras, así como por las paredes internas del santuario."
,"21":"Las jambas del santuario eran cuadrangulares. Delante del lugar santo había algo así como "
,"22":"un altar de madera de metro y medio de alto, un metro de largo y uno de ancho; sus ángulos, su base y su pared eran de madera. Y me dijo el personaje: 'Ésta es la mesa que está delante del Señor'."
,"23":"Había además dos puertas: una para la nave central y otra para el lugar santo."
,"24":"Cada puerta tenía dos hojas, que a su vez se replegaban sobre sí mismas: dos tableros en una hoja y dos en la otra."
,"25":"En las puertas del santuario estaban esculpidos querubines y palmeras, como los de los muros; y sobre la fachada del vestíbulo, por el exterior, había un arquitrabe de madera."
,"26":"A cada lado de los muros laterales del vestíbulo había ventanas enrejadas y palmeras, así como salas anejas al templo y arquitrabes."
}`)
	CurrentBook.AddChapter(42, `{
"1":"Después me sacó al atrio exterior del lado norte y me introdujo en la sala opuesta al espacio cercado, esto es, frente al edificio, hacia el norte."
,"2":"La longitud de su frente era de cincuenta metros, hacia el norte, por una anchura de veinticinco metros."
,"3":"Enfrente de los pórticos del atrio interior y enfrente del enlosado del atrio exterior había una galería frente a la galería de tres pisos,"
,"4":"y por delante de las salas pasaba un corredor de cinco metros de ancho hacia el interior y cien codos de largo; sus puertas daban al norte."
,"5":"Las salas superiores del edificio, al quitarles las galerías parte de su espacio, eran más estrechas que las inferiores y las intermedias."
,"6":"Eran, en efecto, tres pisos, pero sin columnas como las del atrio; por eso las superiores eran más estrechas respecto de las inferiores y las intermedias."
,"7":"La cerca exterior, paralela a las salas por el lado del atrio exterior, tenía veinticinco metros de longitud."
,"8":"En efecto, la longitud de las salas que daban al atrio exterior era de veinticinco metros, mientras que por el lado de la fachada del santuario era de cincuenta metros."
,"9":"Debajo de las salas estaba la entrada, mirando al oriente para el que entraba viniendo del atrio exterior."
,"10":"A todo lo largo de la cerca del atrio, hacia el sur, delante del espacio cercado y del edificio, había salas."
,"11":"Ante ellas se abría un corredor como el de las salas de la parte norte; tenía la misma longitud y la misma anchura, así como iguales salidas, idéntica disposición y puertas semejantes."
,"12":"Eran iguales a las puertas de las salas de la parte sur; una puerta al comienzo de cada corredor, frente a la cerca paralela para el que entra viniendo de la parte este."
,"13":"Y me dijo: 'Las salas del norte y las del sur, que hay enfrente del espacio cercado, son salas sagradas; en ellas comerán las cosas santísimas los sacerdotes que se acercan al Señor, allí depositarán también las cosas santísimas: las ofrendas, el sacrificio por el pecado y el sacrificio de reparación, porque este lugar es santo."
,"14":"Cuando los sacerdotes entren allí no saldrán de este lugar santo al atrio exterior sin haber dejado en él sus vestiduras litúrgicas usadas en el servicio divino, porque estas vestiduras son santas, y sin haberse puesto otras ropas para acercarse a los lugares destinados al pueblo'."
,"15":"Cuando acabó de medir el interior del templo, me sacó fuera hacia el pórtico este y midió el atrio todo en torno."
,"16":"Midió el lado este con la vara de medir: doscientos cincuenta metros de la vara de medir."
,"17":"Midió el lado norte: doscientos cincuenta metros de la vara de medir."
,"18":"Midió el lado sur: doscientos cincuenta metros."
,"19":"Midió el lado oeste: doscientos cincuenta metros."
,"20":"Midió, por fin, el muro que lo cercaba todo alrededor: doscientos cincuenta metros de largo por doscientos cincuenta metros de ancho; servía para separar el lugar sagrado del profano."
}`)
	CurrentBook.AddChapter(43, `{
"1":"Me llevó luego al pórtico que mira al este:"
,"2":"la gloria del Dios de Israel llegaba a la parte de oriente. Su ruido era como el ruido de una masa de agua, y la tierra resplandecía de gloria."
,"3":"Esta visión era como la que había visto cuando vine para la destrucción de la ciudad y como la visión que tuve junto al río Quebar. Yo caí de bruces en el suelo,"
,"4":"mientras la gloria del Señor entraba en el templo por la puerta este."
,"5":"Entonces el espíritu me levantó y me llevó al atrio interior. La gloria del Señor llenaba el templo."
,"6":"Oí una voz que me hablaba desde el templo, mientras aquel personaje permanecía en pie junto a mí."
,"7":"La voz me decía: 'Hijo de hombre, éste es el lugar de mi trono y el lugar donde se posarán mis pies, donde yo habitaré, en medio de los israelitas, para siempre. El pueblo de Israel no profanará más mi santo nombre, como tampoco sus monarcas, con sus fornicaciones, ni con los cadáveres de sus reyes difuntos."
,"8":"No pondrán su umbral junto a mi umbral, ni sus jambas junto a mis jambas, con un muro común entre ellos y yo, profanando así mi santo nombre con todas las prácticas detestables que cometieron y por las que yo los aniquilé en mi cólera."
,"9":"De ahora en adelante alejarán de mí sus fornicaciones y los cadáveres de sus reyes, y yo moraré en medio de ellos para siempre."
,"10":"Y tú, hijo de hombre, describe este templo a la casa de Israel para que queden avergonzados de sus iniquidades y tomen nota de su plan."
,"11":"Si se avergüenzan de todo lo que han hecho, enséñales la imagen de este templo, su estructura, sus salidas y sus entradas, su disposición y su forma, todos sus ritos y sus leyes. Escríbelo todo ante sus ojos para que guarden con exactitud toda su organización y todos sus ritos y los pongan en práctica."
,"12":"Ésta es la ley para el templo: en la cumbre del monte, todo el espacio que lo circunda será santo. Tal es la ley para el templo'."
,"13":"Éstas son las medidas del altar. La base, de medio metro de alta por medio de ancha. El bordillo, de veinticinco centímetros. Así la base del altar."
,"14":"De la base que estribaba en el suelo hasta el zócalo inferior, un metro de altura por medio de anchura; desde el zócalo inferior, un metro de altura por medio de anchura, y desde el zócalo pequeño hasta el grande, dos metros de altura por medio de anchura."
,"15":"El fogón, de dos metros de altura, y de su ángulo emergían cuatro cuernos."
,"16":"El fogón medía seis metros de largo por seis de ancho: un cuadrado perfecto."
,"17":"El zócalo grande era también un cuadrado de siete metros de lado. Alrededor del fogón había un reborde de veinticinco centímetros, y la base, de medio metro todo en torno; sus gradas estaban vueltas hacia oriente."
,"18":"Y me dijo: 'Hijo de hombre, esto dice el Señor Dios: Éstas son las leyes del altar para cuando sea reconstruido, a fin de que sobre él se ofrezcan holocaustos y se derrame sangre."
,"19":"A los sacerdotes levitas, de la descendencia de Sadoc, que se acercan a mí para servirme -dice el Señor Dios-, les darás un novillo en sacrificio por el pecado."
,"20":"Tomarás de su sangre y rociarás los cuatro cuernos del altar, los cuatro ángeles del zócalo y el bordillo que rodea la base. Ésta será la purificación del altar y su expiación."
,"21":"Luego tomarás el novillo del sacrificio por el pecado y lo quemarás en el lugar del templo designado para ello, fuera del santuario."
,"22":"Al día siguiente ofrecerás por el pecado un macho cabrío sin defecto, y el altar será purificado de la misma forma que con el novillo."
,"23":"Una vez terminado el rito expiatorio, ofrecerás un novillo y un carnero del ganado sin tacha."
,"24":"Los ofrecerás ante el Señor, y los sacerdotes les echarán sal y los ofrecerán en holocausto al Señor."
,"25":"Durante siete días ofrecerás diariamente un macho cabrío en sacrificio por el pecado, y un novillo y un carnero del ganado sin defectos."
,"26":"Durante siete días se hará la purificación del altar; lo purificarán y lo inaugurarán."
,"27":"Pasada esta semana, desde el día octavo en adelante, los sacerdotes inmolarán sobre el altar vuestros sacrificios pacíficos y yo os seré propicio', dice el Señor Dios."
}`)
	CurrentBook.AddChapter(44, `{
"1":"Me llevó después hacia la puerta exterior del templo, la que da a oriente: estaba cerrada."
,"2":"Y el Señor me dijo: 'Esta puerta permanecerá cerrada, porque por aquí ha entrado el Señor, el Dios de Israel; quedará, pues, cerrada."
,"3":"Pero el príncipe podrá sentarse en ella para comer delante del Señor; entrará por el vestíbulo de la puerta y por el mismo saldrá'."
,"4":"Después me hizo entrar por la puerta del norte hasta la fachada del templo. Miré y vi que la gloria del Señor llenaba el templo del Señor, y caí de bruces en tierra."
,"5":"Y el Señor me dijo: 'Hijo de hombre, pon atención, mira bien y escucha atentamente todo lo que te voy a decir acerca de todas las prescripciones del templo del Señor y de todas sus leyes. Te fijarás bien en todo lo que respecta a la admisión en el templo y a la exclusión de él."
,"6":"Dirás a los rebeldes, a la casa de Israel: Esto dice el Señor Dios: Ya son demasiadas las monstruosidades que habéis cometido, oh casa de Israel;"
,"7":"habéis introducido extranjeros, incircuncisos de corazón e incircuncisos de cuerpo en mi santuario para que profanen mi templo, mientras vosotros me ofrecíais mi pan, grasa y sangre, quebrantando así mi alianza con todas vuestras monstruosidades."
,"8":"No habéis observado mis ritos sagrados, sino que se lo habéis encomendado a extranjeros en mi santuario."
,"9":"Esto dice el Señor Dios: Ningún extranjero, incircunciso de corazón e incircunciso de cuerpo, entrará en mi santuario; ninguno de los extranjeros que viven entre los israelitas."
,"10":"También los levitas, que se alejaron de mí cuando Israel me abandonó para ir en pos de sus ídolos, cargarán con el peso de sus pecados."
,"11":"Servirán en mi santuario como guardas de las puertas del templo y ministros del servicio del templo. Inmolarán las víctimas de los holocaustos y las otras víctimas en favor del pueblo y estarán a su disposición para servirle."
,"12":"Sirvieron primero al pueblo ante sus ídolos y fueron ocasión de pecado para la casa de Israel; por eso he levantado mi mano contra ellos, dice el Señor Dios. Los levitas cargarán con el peso de su pecado."
,"13":"Por eso no se acercarán más a mí para servirme en las funciones sacerdotales, ni para tocar mis cosas santas y santísimas, sino que soportarán la ignominia de las monstruosidades que han cometido."
,"14":"Les encargo la custodia del templo, confiándoles su servicio y cuanto haya que hacer en él."
,"15":"En cambio, los sacerdotes levitas, descendientes de Sadoc, que se mantuvieron fieles al servicio de mi santuario cuando los israelitas se extraviaron lejos de mí, serán quienes se acerquen a mí para servirme y quienes lleguen a mi presencia a ofrecerme la grasa y la sangre, dice el Señor Dios."
,"16":"Ellos entrarán en mi santuario, ellos se acercaron a mi mesa para servirme, ellos desempeñarán mi servicio."
,"17":"Al entrar por los pórticos del atrio interior vestirán hábito de lino; no llevarán vestidos de lana cuando oficien en los pórticos del atrio interior y dentro del templo."
,"18":"Llevarán en la cabeza turbantes de lino y fajas de lino a los riñones, pero no se vestirán nada que provoque el sudor."
,"19":"Cuando salgan al atrio exterior, donde está el pueblo, se despojarán de las vestiduras con que hayan oficiado; las dejarán en las salas del santuario y se pondrán otros vestidos, con el fin de no santificar al pueblo con sus vestiduras."
,"20":"No se raparán la cabeza ni se dejarán crecer libremente el cabello, sino que llevarán el pelo corto."
,"21":"Ningún sacerdote beberá vino el día en que tenga que entrar en el atrio a oficiar."
,"22":"No tomarán por esposa ni una viuda ni una mujer divorciada, sino una virgen de la casa de Israel; podrán, no obstante, casarse con una viuda de un sacerdote."
,"23":"Enseñarán a mi pueblo a distinguir lo santo de lo profano y le mostrarán la diferencia entre lo impuro y lo puro."
,"24":"En los pleitos harán de jueces y los fallarán con arreglo a mi derecho. Observarán en todas mis fiestas mis leyes y mis preceptos, y santificarán mis sábados."
,"25":"Ninguno de ellos se acercará a un cadáver para no contaminarse. Pero podrán contaminarse con el cadáver del padre o de la madre, de un hijo o una hija, de un hermano o una hermana aún no casada."
,"26":"Después de haberse purificado, tendrá cada cual que esperar una semana;"
,"27":"y el día en que vuelva a entrar en el santuario, en el atrio interior para oficiar en el santuario, ofrecerá un sacrificio por el pecado, dice el Señor Dios."
,"28":"No tendrán heredad alguna: yo soy su heredad. No les daréis ninguna posesión en Israel: yo soy su posesión."
,"29":"Su alimento serán las ofrendas, las víctimas por el pecado y las de reparación. A ellos pertenecerá también todo lo que en Israel sea dado al exterminio."
,"30":"Lo mejor de todas vuestras primicias y de toda clase de productos vuestros, todas las ofrendas que hagáis, pertenecerán a los sacerdotes. Así daréis a los sacerdotes lo mejor de vuestra parte, a fin de que la bendición repose sobre vuestras casas."
,"31":"Los sacerdotes no comerán carne muerta o destrozada, sea de ave o de otro animal."
}`)
	CurrentBook.AddChapter(45, `{
"1":"Cuando os repartáis por sorteo la tierra en patrimonio, reservaréis al Señor la parte sagrada del territorio: una extensión de doce kilómetros y medio de larga por diez de ancha. Este coto será todo él sagrado."
,"2":"En el medio quedará reservado para el templo un cuadrado de doscientos cincuenta metros de lado, y en torno a él una zona libre de veinticinco metros."
,"3":"En esta superficie medirás doce kilómetros y medio de largo por cinco de ancho; aquí estará el santuario, el lugar santo."
,"4":"Será una porción santa del país reservada a los sacerdotes que ejercen el ministerio del santuario y se acercan al Señor para servirle; aquí podrán construir sus casas y tendrán un espacio consagrado al santuario."
,"5":"Otro territorio de doce kilómetros y medio de largo por cinco de ancho será propiedad de los levitas, que ejercen el ministerio en el templo, con ciudades para vivir."
,"6":"Y como propiedad de la ciudad asignaréis un terreno de dos kilómetros y medio de ancho por doce y medio de largo, paralelo a la porción del santuario; éste será para toda la casa de Israel."
,"7":"Al príncipe le tocará un terreno a los dos lados del coto del santuario y del término de la ciudad, por la parte de occidente hacia occidente y por la parte de oriente hacia oriente, de una longitud igual a cada una de las partes, desde la frontera occidental hasta la oriental"
,"8":"del país. Ésta será su posesión en Israel. Así mis príncipes no oprimirán más al pueblo, sino que dejarán el país a la casa de Israel, a sus tribus."
,"9":"Esto dice el Señor Dios: ¡Ya tenéis bastante, príncipes de Israel! Desistid de la violencia y la rapiña, practicad el derecho y la justicia, quitad las confiscaciones de mi pueblo, dice el Señor Dios."
,"10":"Usad balanzas justas, pesos y medidas justos."
,"11":"La unidad para sólidos y líquidos será igual, una décima parte de la unidad mayor, o sea, cuarenta y cinco kilos y cuarenta y cinco litros."
,"12":"En cuanto a los pesos, la unidad será de doce gramos; la unidad mayor será de setecientos veinte gramos."
,"13":"Ésta será la ofrenda que habréis de ofrecer: ocho kilos por cada cuatrocientos cincuenta de trigo y de cebada, respectivamente."
,"14":"Normas para el aceite: cuatro litros y medio por cada cuatrocientos cincuenta."
,"15":"Del ganado menor se tomará una oveja por cada doscientas del patrimonio de Israel, para las ofrendas, holocaustos y sacrificios de reconciliación para hacer el rito de absolución sobre el pueblo, dice el Señor Dios."
,"16":"Toda la población del país estará obligada a presentar tal ofrenda al príncipe de Israel."
,"17":"Mas el príncipe se ocupará de los holocaustos y de las ofrendas de pan y vino en las solemnidades, novilunios y sábados, en todas las fiestas en que se congrega la casa de Israel. Él tendrá que proveer lo necesario para el sacrificio por el pecado, la ofrenda, el holocausto y los sacrificios de reconciliación para hacer el rito de absolución sobre la casa de Israel."
,"18":"Esto dice el Señor Dios: El día uno del primer mes tomarás un novillo sin defecto y realizarás el rito de expiación del santuario."
,"19":"El sacerdote tomará de la sangre del sacrificio por el pecado y la derramará sobre las jambas del templo, sobre los cuatro ángulos del zócalo del altar y sobre las jambas del pórtico del atrio interior."
,"20":"De la misma manera haréis el día siete del mes en favor de todo aquel que haya pecado por inadvertencia o ligereza. Así harás la expiación del templo."
,"21":"El día catorce del primer mes celebraréis la fiesta de la pascua, y durante siete días se comerá el pan sin levadura."
,"22":"El príncipe ofrecerá aquel día por él y por todo el pueblo del país un novillo en sacrificio por el pecado."
,"23":"Durante siete días de la fiesta ofrecerá un holocausto al Señor cada día, siete novillos y siete carneros sin defecto, y un macho cabrío en sacrificio por el pecado;"
,"24":"ofrecerá cuarenta y cinco kilos por novillo, cuarenta y cinco por carnero y siete litros y medio de aceite por cada cuarenta y cinco kilos."
,"25":"El día quince del séptimo mes, con ocasión de la fiesta, hará igualmente durante aquellos siete días, tanto en lo referente a los sacrificios por el pecado como a los holocaustos, las ofrendas y el aceite."
}`)
	CurrentBook.AddChapter(46, `{
"1":"Esto dice el Señor Dios: La puerta del atrio interior, que mira a oriente, permanecerá cerrada en los días laborables, pero el sábado se abrirá, así como el día de la luna nueva."
,"2":"El príncipe entrará desde fuera por el vestíbulo de la puerta y se quedará junto a las jambas de la puerta, mientras los sacerdotes ofrecerán su holocausto y sus sacrificios de reconciliación. Se prosternará sobre el umbral de la puerta, luego saldrá y la puerta no se cerrará hasta la tarde."
,"3":"Los laicos se postrarán ante el Señor a la entrada de esta puerta los sábados y los días de luna nueva."
,"4":"El holocausto que el príncipe ofrecerá al Señor será el siguiente: los sábados, seis corderos y un carnero sin defecto;"
,"5":"ofrecerá cuarenta y cinco kilos por carnero; por los corderos ofrecerá lo que pueda o quiera, y siete litros y medio de aceite por cada cuarenta y cinco kilos."
,"6":"En el día de luna nueva: un novillo sin defecto, seis corderos y un carnero sin defecto."
,"7":"Ofrecerá cuarenta y cinco kilos por novillo y cuarenta y cinco por el carnero; por los corderos lo que pueda o quiera, y siete litros y medio de aceite por cada cuarenta y cinco kilos."
,"8":"Cuando entre el príncipe, pasará por el vestíbulo del porche y saldrá por el mismo."
,"9":"Cuando los laicos vengan ante el Señor en las fiestas para adorar, los que entren por la puerta norte saldrán por la puerta sur, y los que entren por la puerta sur saldrán por la del norte; no saldrán por la puerta que entraron, sino que saldrán por la de enfrente."
,"10":"El príncipe irá en medio de ellos; entrará cuando ellos entren y saldrá cuando salgan."
,"11":"En las solemnidades y en las fiestas la ofrenda será de cuarenta y cinco kilos por novillo y cuarenta y cinco por carnero; por los corderos lo que pueda o quiera, y siete litros y medio de aceite por cada cuarenta y cinco kilos."
,"12":"Cuando el príncipe haga una ofrenda voluntaria al Señor, sea holocausto y sacrificio de reconciliación, se le abrirá la puerta que da a oriente, ofrecerá su holocausto o su sacrificio de reconciliación según el mismo ceremonial de los días de sábado, saldrá luego y la puerta se cerrará cuando haya salido."
,"13":"Todos los días ofrecerá en holocausto al Señor un cordero de un año sin defecto; lo ofrecerá cada mañana."
,"14":"Añadirá además, cada mañana, como ofrenda, ocho kilos y dos litros y medio de aceite para amasar la flor de harina. Es la ofrenda al Señor, una ley eterna, para siempre."
,"15":"Le ofrecerá el cordero y hará la ofrenda de aceite, cada mañana, en holocausto perpetuo."
,"16":"Esto dice el Señor Dios: Si el príncipe hace un regalo a alguno de sus hijos, tomándolo de los bienes propios, el regalo pertenecerá a sus hijos y lo poseerán como herencia."
,"17":"Pero si de su heredad hace un regalo a alguno de sus servidores, pertenecerá a éste sólo hasta el año jubilar, en que volverá al príncipe. Su heredad pasará sólo a sus hijos."
,"18":"El príncipe no podrá apoderarse de nada de los bienes del pueblo, despojándolo de su propiedad; sólo su propia hacienda pasará en herencia a sus hijos, a fin de que ninguno de mi pueblo sea privado de la propiedad que le corresponde."
,"19":"Luego, por la entrada que está al lado de la puerta me llevó a las salas del santuario reservadas a los sacerdotes, las que dan al norte. Allí en el fondo había un espacio reservado, hacia occidente."
,"20":"Y me dijo: 'Éste es el lugar donde los sacerdotes cocerán las víctimas del sacrificio por el pecado y las de reparación y donde cocerán las ofrendas, con el fin de que no lo saquen al atrio exterior, santificando así al pueblo'."
,"21":"Luego me llevó al atrio exterior y me hizo pasar junto a los cuatro ángulos del atrio. En cada uno de los ángulos del atrio había un patio,"
,"22":"esto es, en los cuatro ángulos del atrio había cuatro patios pequeños, de veinte metros de longitud por quince de anchura. Todos tenían la misma dimensión."
,"23":"Una pared cercaba los cuatro patios por todas partes, y en la parte baja de la pared, todo alrededor, estaban levantados unos fogones."
,"24":"Y me dijo: 'Éstos son los fogones donde los servidores del templo cocerán los sacrificios del pueblo'."
}`)
	CurrentBook.AddChapter(47, `{
"1":"Después me llevó a la entrada del templo. Allí, bajo el umbral del templo, brotaba agua en dirección este, pues la fachada del templo miraba al este. Estas aguas se deslizaban de debajo del costado derecho del templo, al sur del altar."
,"2":"Me hizo salir por la puerta norte y dar la vuelta por fuera hasta la puerta exterior, que da al este, y he aquí que las aguas corrían por el lado derecho."
,"3":"El hombre salió en dirección este y con un cordel que llevaba en la mano midió quinientos metros y me hizo atravesar el agua, que me llegaba hasta los tobillos."
,"4":"Midió otros quinientos metros y me hizo atravesar el agua, que me llegaba hasta las rodillas; midió quinientos más, y me hizo atravesar otra vez el agua; me llegaba hasta la cintura;"
,"5":"midió, por fin, otros quinientos. Era ya un río que no podía atravesar, pues el agua había crecido y sólo se podía pasar a nado."
,"6":"Entonces me dijo: '¿Has visto, hijo de hombre?'. Después me hizo volver a la orilla del río"
,"7":"y, al volver, vi que junto al río, a una y otra orilla, había una arboleda espesísima."
,"8":"Y me dijo: 'Estas aguas que se deslizan hacia la región oriental bajan a la Arabá y desembocan en el mar, en el agua salada, que queda saneada."
,"9":"Por dondequiera que pase este río, todo ser viviente que en él se mueva vivirá; los peces serán muy abundantes, porque donde llegan estas aguas todo queda saneado; la vida prosperará donde llegue este río."
,"10":"A sus orillas vendrán numerosos pescadores; desde Engadí hasta Enegláyim será un tendedero de redes. Los peces serán muy abundantes, en sus diversas especies, como los peces del mar Mediterráneo."
,"11":"Sin embargo, sus marismas y sus lagunas no serán saneadas; serán abandonadas a la sal."
,"12":"Junto al río crecerán, a una y otra margen, toda clase de árboles frutales, cuyo follaje no se marchitará y cuyo fruto no se agotará nunca. Todos los meses darán frutos nuevos, porque sus aguas manan del santuario. Sus frutos servirán de alimento y sus hojas de medicina."
,"13":"Esto dice el Señor Dios: Éstas serán las fronteras de la tierra que repartiréis entre las doce tribus del país, teniendo presente que José recibirá una porción doble."
,"14":"Recibiréis cada uno por igual la parte que os toca del territorio que yo, mano en alto, juré dar a vuestros padres; esta tierra será vuestra heredad."
,"15":"Éstos serán los límites del país. Por el norte: Desde el mar Mediterráneo, pasando por Jetlón, hasta la entrada de Jamat, Sedad,"
,"16":"Berota, Sibráyim, que está entre el territorio de Damasco y el de Jamat, Haser Enón, en la frontera del Haurán."
,"17":"Así pues, la frontera correrá desde el mar hasta Haser Enón, dejando al norte el territorio de Damasco y el territorio de Jamat. Éste el límite norte."
,"18":"Por oriente: entre el Haurán, Damasco, Galaad y la tierra de Israel, será frontera el Jordán hasta el mar Muerto, hasta Tamar. Éste el límite este."
,"19":"Por el sur: la frontera correrá desde Tamar hasta las aguas de Meribá de Cades, en la dirección del torrente hasta el mar Mediterráneo. Éste el límite sur."
,"20":"Por el oeste: la frontera será el mar Mediterráneo hasta enfrente de la entrada de Jamat. Éste el límite oeste."
,"21":"Os repartiréis esta tierra según las tribus de Israel."
,"22":"Os la repartiréis como heredad entre vosotros y los extranjeros domiciliados en vuestro territorio que hayan engendrado hijos entre vosotros; consideraréis a éstos como ciudadanos israelitas, y con vosotros echarán suertes para obtener su parte en medio de las tribus de Israel."
,"23":"En la tribu en que el extranjero se haya establecido, allí le daréis una heredad, dice el Señor Dios."
}`)
	CurrentBook.AddChapter(48, `{
"1":"Éstos son los nombres de las tribus. Desde el extremo norte, en la dirección de Jetlón, hasta la entrada de Jamat y de Haser Enón, dejando al norte el territorio de Damasco, y a lo largo de Jamat; el territorio se extenderá desde la frontera oriental hasta la occidental: Dan, una parte."
,"2":"Limitando con Dan, desde la frontera oriental hasta la occidental: Aser, una parte."
,"3":"Limitando con Aser, desde la frontera oriental hasta la occidental: Neftalí, una parte."
,"4":"Limitando con Neftalí, desde la frontera oriental hasta la occidental: Manasés, una parte."
,"5":"Limitando con Manasés, desde la frontera oriental hasta la occidental: Efraín, una parte."
,"6":"Limitando con Efraín, desde la frontera oriental hasta la occidental: Rubén, una parte."
,"7":"Limitando con Rubén, desde la frontera oriental hasta la occidental: Judá, una parte."
,"8":"Y limitando con Judá, desde la frontera oriental hasta la occidental, estará la porción que reservaréis, de doce kilómetros y medio de ancha y de larga como una de las otras partes, desde la frontera oriental hasta la occidental; en medio de ella se levantará el santuario."
,"9":"La parte que reservaréis al Señor tendrá doce kilómetros y medio de larga por diez de ancha."
,"10":"Comprenderá la parte del territorio sagrado reservada a los sacerdotes: doce kilómetros y medio hacia el norte, cinco de ancha hacia el oeste, cinco de ancha hacia el este y doce y medio de larga hacia el sur. En medio se levantará el santuario del Señor."
,"11":"Esta parte pertenecerá sólo a los sacerdotes consagrados, pertenecientes a la estirpe de Sadoc, los cuales permanecieron fieles a mi servicio y no se descarriaron al descarriarse los israelitas, como se descarriaron los levitas."
,"12":"Así les corresponderá una porción tomada sobre la parte santísima del país, junto al territorio de los levitas."
,"13":"Los levitas tendrán, como el territorio de los sacerdotes, una parte de doce kilómetros y medio de longitud por cinco de anchura. En total tendrán en su territorio una longitud de doce kilómetros y medio por una anchura de diez."
,"14":"No podrán vender, ni cambiar, ni ceder nada de esta parte mejor del país, porque está consagrada al Señor."
,"15":"Los dos kilómetros y medio que quedan de la anchura de los doce y medio serán un terreno profano para la ciudad, para sus construcciones y sus pastos. La ciudad quedará en medio"
,"16":"y tendrá las siguientes medidas: el lado norte, dos mil doscientos cincuenta metros; el sur, dos mil metros; el este, dos mil; el oeste, dos mil."
,"17":"Los pastos de la ciudad se extenderán ciento veinticinco metros por el sur, ciento veinticinco por el norte, ciento veinticinco por el este, ciento veinticinco por el oeste."
,"18":"Quedará así una extensión, a lo largo de la porción sagrada, de cinco kilómetros por el este y cinco por el oeste, a lo largo de la porción sagrada; sus productos servirán para la manutención de los trabajadores de la ciudad."
,"19":"Los que trabajen en la ciudad serán tomados de todas las tribus de Israel."
,"20":"Toda la zona reservada formará un cuadrado de doce kilómetros y medio de lado. Reservaréis, en efecto, la zona sagrada, incluyendo la posesión de la ciudad."
,"21":"Lo que quede a uno y otro lado de la zona sagrada y de la posesión de la ciudad pertenecerá al príncipe; su porción se extenderá así a lo largo de los doce kilómetros y medio de la zona sagrada al este, hasta la frontera oriental, y al oeste a lo largo de los doce kilómetros y medio, hasta la frontera occidental; esto para el príncipe, en correspondencia con las demás porciones. Así en el medio estará la zona sagrada y el santuario del templo,"
,"22":"entre la posesión de los levitas y la de la ciudad y entre la porción correspondiente al príncipe, la cual se encuentra entre el territorio de Judá y el de Benjamín."
,"23":"Para las otras tribus: desde la frontera oriental hasta la occidental: Benjamín, una parte."
,"24":"Limitando con Benjamín, desde la frontera oriental hasta la occidental: Simeón, una parte."
,"25":"Limitando con Simeón, desde la frontera oriental hasta la occidental: Isacar, una parte."
,"26":"Limitando con Isacar, desde la frontera oriental hasta la occidental: Zabulón, una parte."
,"27":"Limitando con Zabulón, desde la frontera oriental hasta la occidental: Gad, una parte."
,"28":"Limitando con Gad, la frontera sur correrá desde Tamar hasta las aguas de Meribá de Cades, siguiendo el torrente hasta el mar Mediterráneo."
,"29":"Tal es la tierra que repartiréis a suertes como heredad entre las tribus de Israel y tales sus partes, dice el Señor Dios."
,"30":"Y he aquí las salidas de la ciudad: por el lado norte, dos mil doscientos cincuenta metros."
,"31":"Las puertas de la ciudad llevarán los nombres de las tribus de Israel. Al norte, tres puertas: la puerta de Rubén, la puerta de Judá, la puerta de Leví."
,"32":"Por el lado este, dos mil doscientos cincuenta metros y tres puertas: la puerta de José, la puerta de Benjamín, la puerta de Dan."
,"33":"Por el lado sur, dos mil doscientos cincuenta metros y tres puertas: la puerta de Simeón, la puerta de Isacar, la puerta de Zabulón."
,"34":"Por el lado oeste, dos mil doscientos cincuenta metros y tres puertas: la puerta de Gad, la puerta de Aser, la puerta de Neftalí."
,"35":"El perímetro medirá un total de nueve mil metros. Y desde aquel día el nombre de la ciudad será: 'El Señor está allí'."
}`)

}
func ES_LSB_LoadVMIEChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Éstas son las palabras de Jeremías, hijo de Jelcías, de la familia de sacerdotes que habitaban en Anatot, en el territorio de Benjamín."
,"2":"A él fue dirigida la palabra del Señor en tiempos de Josías, hijo de Amón, rey de Judá, el año trece de su reinado,"
,"3":"y después en tiempos de Joaquín, hijo de Josías, rey de Judá, hasta el fin del año undécimo de Sedecías, hijo de Josías, rey de Judá, hasta la deportación de Jerusalén, en el mes quinto."
,"4":"El Señor me dijo:"
,"5":"'Antes de formarte,en el vientre de tu madre te conocí; antes que salieras del seno te consagré; como profeta de las gentes te constituí'."
,"6":"Yo dije: '¡Ah, Señor Dios, mira que yo no sé hablar; soy joven!'."
,"7":"Pero el Señor me respondió: 'No digas: ¡soy joven!, porque adonde yo te envíe, irás; y todo lo que yo te ordene, dirás."
,"8":"No tengas miedo de ellos, porque yo estoy contigo para protegerte, dice el Señor'."
,"9":"El Señor extendió su mano, tocó mi boca,y me dijo: 'Yo pongo mis palabras en tu boca."
,"10":"Mira, en este día te constituyo,sobre las naciones y sobre los reinos,para arrancar y destruir, para derribar y deshacer, para edificar y plantar'."
,"11":"El Señor me dijo: '¿Qué ves, Jeremías?'. Respondí: 'Veo una rama de almendro'."
,"12":"El Señor me dijo: 'Bien has visto, porque yo velo por mi palabra para que se cumpla'."
,"13":"Por segunda vez el Señor me dijo: '¿Qué ves?'. Respondí: 'Veo una olla hirviente que viene del norte'."
,"14":"El Señor me dijo: 'Desde el norte se derramará la desgracia,sobre todos los habitantes de la tierra."
,"15":"Pues aquí estoy yo para convocar,a todos los reinos del norte, dice el Señor. Vendrán y pondrán cada uno su sede,ante las puertas de Jerusalén, alrededor de sus muros,y ante todas las ciudades de Judá."
,"16":"Y yo pronunciaré mis sentencias contra ellas, contra toda su malicia, porque me han abandonado,para quemar incienso a dioses extraños, para postrarse ante la obra de sus manos."
,"17":"Pero tú, cíñete la cintura, levántate para decirles,todo lo que yo te ordene. No tiembles ante ellos, no sea que te haga yo temblar,en su presencia."
,"18":"Yo te constituyo en este día,como ciudad fortificada, como columna de hierro, como muro de bronce frente a todo el país: frente a los reyes de Judá, sus jefes, sus sacerdotes,y el pueblo de la tierra."
,"19":"Lucharán contra ti, pero no podrán vencerte, porque yo estoy contigo para librarte, dice el Señor'."
}`)
	CurrentBook.AddChapter(2, `{
"1":"El Señor me dijo:"
,"2":"Anda, grita a los oídos de Jerusalén: Esto dice el Señor: Me he acordado de ti, en los tiempos de tu juventud, de tu amor de novia, cuando me seguías en el desierto, en una tierra sin cultivar."
,"3":"Israel era la posesión santa del Señor, las primicias de su cosecha; todo el que comía de ella lo pagaba, la desgracia caía sobre él, dice el Señor."
,"4":"Escuchad la palabra del Señor, casa de Jacob,y todas las familias de la casa de Israel."
,"5":"Esto dice el Señor: ¿En qué me encontraron desleal vuestros padres,para que se alejaran de mí?,Corrieron en pos de la vanidad, y en vanidad se convirtieron ellos mismos."
,"6":"No dijeron: ¿Dónde está el Señor, que nos sacó de Egipto, que nos guió a través del desierto,por una tierra árida y escabrosa, tierra reseca y de tinieblas, tierra por donde no pasa ningún hombre,y donde nadie se establece?"
,"7":"Yo os conduje a un país feraz,para que gozarais de sus frutos y sus bienes. Pero vosotros, nada más entrar, profanasteis mi tierra, convertisteis mi heredad en lugar aborrecible."
,"8":"Los sacerdotes no dijeron: ¿Dónde está el Señor?,Los intérpretes de la ley no me conocieron; los pastores se rebelaron contra mí; los profetas profetizaron tras dioses impotentes."
,"9":"Por eso, voy a pleitear,contra vosotros -dice el Señor-,y a pleitear contra los hijos de vuestros hijos."
,"10":"Llegad a las costas de Chipre y mirad; enviad a Quedar para informaros,si sucedió jamás cosa semejante."
,"11":"¿Acaso algún pueblo cambia de dioses?,-y eso que ni dioses son-. Pues mi pueblo ha cambiado,su gloria por la impotencia."
,"12":"¡Pasmaos de esto, cielos; espantaos, temblad de inmenso horror!,-dice el Señor-."
,"13":"Doble iniquidad ha cometido mi pueblo: me han abandonado a mí, la fuente de agua viva,para excavarse aljibes, aljibes agrietados, que no retienen agua."
,"14":"¿Es acaso Israel un esclavo, un siervo nacido en casa, para que se convirtiese en presa?"
,"15":"Contra él han rugido leones, han lanzado su aullido. Ha sido devastada su tierra, sus ciudades incendiadas, despobladas."
,"16":"Hasta los hijos de Nof y de Tafnes,te han rasurado la cabeza."
,"17":"¿No te ha sucedido esto,por haber abandonado al Señor tu Dios, cuando él te guiaba por el camino?"
,"18":"Y ahora, ¿a qué fin dirigirte a Egipto,para beber el agua del Nilo?,¿A qué fin marchar a Asiria,para beber el agua del río?"
,"19":"Tus iniquidades te castigan, tus infidelidades te condenan. Date cuenta, comprende qué funesto es,y qué amargo abandonar al Señor tu Dios, no tener ya temor de mí, dice el Señor Dios todopoderoso."
,"20":"Desde antiguo has quebrado tu yugo, has roto tus coyundas,y has dicho: 'No quiero servir'. En efecto, sobre toda colina elevada, bajo todo árbol verde,te has tumbado como una prostituta."
,"21":"Yo te había plantado de cepa generosa, toda de semillas legítimas. ¿Cómo te has convertido,en planta degenerada,de una viña bastarda?"
,"22":"Aunque te laves con potasa,y gastes lejía en abundancia, la mancha de tu iniquidad,aún quedaría ante mí, dice el Señor Dios."
,"23":"¿Cómo te atreves a decir: 'No estoy manchada, no he ido en pos de los ídolos?'. Mira tus huellas en el valle, reconoce lo que has hecho, camella lasciva, errante por los caminos."
,"24":"Asna salvaje, avezada al desierto, que en el ardor de su deseo sorbe el viento; su apetencia, ¿quién la calmará?,El que la busca no tiene que esforzarse, la encuentra en el mes de su celo."
,"25":"Ten cuidado, no se descalce tu pie,y se seque tu garganta. Pero tú dices: '¡Déjame en paz; yo amo a extranjeros y tras ellos quiero irme!'."
,"26":"Como se avergüenza un ladrón,al ser sorprendido, así se avergonzarán los de la casa de Israel, ellos, sus reyes y sus jefes, sus sacerdotes y sus profetas,"
,"27":"que dicen al leño: 'Tú eres mi padre', y a la piedra: 'Tú me has engendrado'. Ellos me dan la espalda y no la cara, mas cuando llega la desgracia gritan: '¡Levántate, sálvanos!'."
,"28":"¿Dónde están los dioses,que te has fabricado?,¡Levántense ellos a ver,si te salvan en el tiempo de tu angustia!,Porque tan numerosos,como tus ciudades son tus dioses, oh Judá."
,"29":"¿Por qué pretendéis pleitear conmigo?,Todos vosotros me habéis sido infieles, dice el Señor."
,"30":"En vano he castigado a vuestros hijos; no habéis aprendido la lección; vuestra espada devoró a vuestros profetas,como un león devastador."
,"31":"¡Qué generación la vuestra!,Ved lo que dice el Señor: ¿He sido yo un desierto para Israel,o una tierra tenebrosa?,Pues, ¿por qué dice mi pueblo: 'Nosotros nos vamos, no volveremos más a ti'?"
,"32":"¿Puede una joven olvidarse de sus joyas, una novia de su cinturón?,Pues mi pueblo me ha olvidado a mí,hace ya mucho tiempo."
,"33":"¡Ah, qué bien conoces el camino,para buscar el amor!,Así también al camino del mal,te has acostumbrado."
,"34":"Hasta en la orla de tu vestido,tienes sangre de los pobres y de los inocentes; ¡a éstos no los sorprendiste en ningún delito, sino junto a los terebintos!"
,"35":"Y aún dices: 'Soy inocente; ¡oh, sí, su cólera se ha alejado de mí!'. Pues aquí estoy para juzgarte, ya que dices: No he pecado."
,"36":"¡Qué inconstante eres cambiando de caminos!,¡También con Egipto quedarás corrida,como lo fuiste con Asiria!"
,"37":"También de allí saldrás,con las manos en la cabeza, porque el Señor ha desechado,a aquellos en los que confiabas,y no tendrás éxito con ellos."
}`)
	CurrentBook.AddChapter(3, `{
"1":"El Señor me dijo: Si un hombre se divorcia de su mujer,y ella, al separarse de él, se casa con otro, ¿podrá volver a él de nuevo?,¿No se ha infamado totalmente esa mujer?,Tú te has prostituido con innumerables amantes, ¿y pretendes volver a mí? -dice el Señor-."
,"2":"Alza los ojos hacia los collados y mira: ¿Hay un lugar en que no te hayas entregado?,Junto a los caminos te sentabas, esperándolos como un árabe en el desierto. Has profanado esta tierra,con tus prostituciones y tus crímenes."
,"3":"Cesaron los aguaceros,y la lluvia tardía no llegó; pero con tu rostro de mujer perdida,ni siquiera te has sonrojado."
,"4":"Ahora, sí, me llamas: ¡Padre mío, tú eres el amigo de mi juventud!"
,"5":"¿Estará airado siempre?,¿Durará eternamente su cólera?,Así hablas, pero sigues haciendo todo el mal que puedes."
,"6":"El Señor me dijo en tiempo del rey Josías: ¿Has visto lo que hace la rebelde Israel? Ha subido a todo monte alto, y bajo todo árbol verde se ha prostituido."
,"7":"Yo pensaba: Después de haber hecho todo esto, se volverá a mí. Pero no ha vuelto. Y Judá, su pérfida hermana, ha visto todo esto."
,"8":"Ha visto también que, por todos sus adulterios, yo repudié a la rebelde Israel y le di su acta de divorcio. Pero su hermana, la pérfida Judá, no se ha asustado; ha ido también ella a prostituirse."
,"9":"Y con la vergüenza de su prostitución ha profanado la tierra; ha cometido adulterio con la piedra y con el leño."
,"10":"Y con todo esto, Judá, su pérfida hermana, no ha vuelto a mí de todo corazón, su arrepentimiento es falso, dice el Señor."
,"11":"El Señor me dijo: En comparación de Judá, la pérfida, Israel, la rebelde, parece justa."
,"12":"Vete, pues, a pronunciar estas palabras hacia el lado del norte. Dirás: Vuelve, rebelde Israel, dice el Señor. No apartaré mi rostro de vosotros, porque soy misericordioso, dice el Señor; no estaré airado eternamente."
,"13":"Tan sólo reconoce tu iniquidad: Te has rebelado contra el Señor, tu Dios, has ido a todas partes en pos de extraños,y no has escuchado mi voz, dice el Señor."
,"14":"Volved, hijos rebeldes -dice el Señor-, porque yo soy vuestro dueño; os tomaré, uno de cada ciudad y dos de cada familia, y os conduciré a Sión."
,"15":"Os daré pastores según mi corazón, que os apacentarán con inteligencia y sabiduría;"
,"16":"y cuando os hayáis multiplicado y fructificado en el país, en aquellos días -dice el Señor- no se dirá ya: ¿Dónde está el arca de la alianza del Señor? No se pensará más en ella, no se la recordará más, no se echará de menos ni se hará otra nueva."
,"17":"Entonces se llamará a Jerusalén 'el trono del Señor'; a ella acudirán, en el nombre del Señor, todas las naciones y no seguirán más la obstinación de su propio corazón perverso."
,"18":"En aquellos días irán de la mano la casa de Judá y la casa de Israel, y juntas vendrán del país del norte a la tierra que yo di en herencia a vuestros padres."
,"19":"Y yo me decía: ¿Te contaré entre mis hijos,y te daré un país de delicias, la heredad más preciosa de las naciones?,Yo pensaba: Me llamarás padre, y ya no te alejarás de mí."
,"20":"Mas como una mujer,traiciona a su amante, así me ha traicionado a mí,la casa de Israel -dice el Señor-."
,"21":"Un grito se deja oír,en los collados; llantos y súplicas,de los hijos de Israel, porque han perdido su camino, han olvidado al Señor, su Dios."
,"22":"Volved, hijos rebeldes, yo curaré vuestras rebeldías. 'Aquí estamos, a ti venimos, porque tú eres el Señor, nuestro Dios."
,"23":"Oh, sí, las colinas,no son más que mentira, así como el tumulto de los montes. Realmente sólo el Señor, nuestro Dios, es la salvación de Israel."
,"24":"La ignominia ha devorado el fruto,del trabajo de nuestros padres, desde nuestra juventud."
,"25":"¡Acostémonos en nuestra ignominia,y nos cubra nuestro oprobio, porque contra el Señor, nuestro Dios, hemos pecado nosotros,y nuestros padres,desde nuestra juventud,hasta el presente,y no hemos escuchado,la voz del Señor, nuestro Dios!'."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Si tú quieres volver, oh Israel -dice el Señor-, a mí es a quien has de volver; si quitas de mi vista tus inmundicias, no andarás errante de acá,para allá lejos de mí."
,"2":"Si juras por la vida del Señor,con verdad, rectitud y justicia, las naciones se congratularán con él, y en él se gloriarán."
,"3":"Porque así habla el Señor,a la gente de Judá y de Jerusalén: 'Labrad un campo nuevo, no sembréis entre espinas."
,"4":"Circuncidaos para el Señor, quitad el prepucio,de vuestro corazón, oh gentes de Judá, habitantes de Jerusalén, no sea que estalle mi furor,como fuego,y arda sin que haya,quien lo apague,por la maldad de vuestras obras'."
,"5":"Anunciadlo en Judá, publicadlo en Jerusalén, tocad la trompeta en el país, gritad con voz potente y decid: ¡Reuníos, entremos,en las ciudades fortificadas!"
,"6":"Izad una señal,hacia la parte de Sión. ¡Huid, no os detengáis!,Pues la desgracia,voy a traer del norte, una inmensa catástrofe."
,"7":"De su espesura se abalanza el león, el destructor de naciones,se pone en marcha, abandona su morada,para reducir tu país a un desierto; tus ciudades serán arrasadas, despobladas."
,"8":"Por eso, vestíos de sacos, lamentaos, gemid, porque no se retira de nosotros,la ardiente ira del Señor."
,"9":"El día aquel -dice el Señor-,desfallecerá el corazón del rey,y el corazón de los jefes; los sacerdotes quedarán consternados, y estupefactos los profetas."
,"10":"Y dirán: '¡Ah, Señor Dios, cómo has engañado a este pueblo,y a Jerusalén, diciéndole: Tendréis paz, cuando la espada se ha clavado,hasta el alma!'."
,"11":"En aquel tiempo se dirá,a este pueblo,y a Jerusalén: Un viento ardiente,sopla del desierto,contra la hija de mi pueblo, y no para aventar,ni para limpiar."
,"12":"Un viento impetuoso viene contra mí. Y ahora voy a pronunciar,sobre ellos la sentencia."
,"13":"Helo aquí que avanza,como una nube, sus carros semejan al huracán, más veloces que las águilas,sus caballos. ¡Ay de nosotros, estamos perdidos!"
,"14":"Purifica tu corazón del mal, oh Jerusalén, para que puedas salvarte. ¿Hasta cuándo guardarás en ti,tus perversos pensamientos?"
,"15":"Una voz desde Dan,lanza la alarma, desde los montes de Efraín,se anuncia la desgracia."
,"16":"Publicadlo a las gentes, anunciadlo en Jerusalén: Los enemigos llegan,de un lejano país, lanzan su grito,contra las ciudades de Judá."
,"17":"Como guardas de campo,cercan a Jerusalén,por haberse rebelado contra mí, dice el Señor."
,"18":"Tu conducta, tus acciones,te han merecido esto. He ahí tu maldad: amargura es que el corazón te punza."
,"19":"¡Ay, mis entrañas, mis entrañas!,¡Cómo sufro!,¡Entretelas de mi corazón!,El corazón se me salta; ya no puedo callarme,porque he oído el sonido del clarín, el clamor de guerra."
,"20":"Se anuncia desastre tras desastre, todo el país está arrasado. De golpe han sido destruidas mis tiendas, en un instante mis pabellones."
,"21":"¿Hasta cuándo he de ver el estandarte,y escucharé el sonido del clarín?"
,"22":"¡Oh, necio es mi pueblo, no me conocen; son hijos insensatos, no tienen inteligencia, diestros sólo para el mal, pero no saben hacer el bien!"
,"23":"He mirado a la tierra: un caos era; a los cielos: y estaban sin luz."
,"24":"He mirado a los montes: retemblaban, y todas las colinas,se estremecían."
,"25":"He mirado: no quedaba un alma: todos los pájaros del cielo,habían huido."
,"26":"He mirado: la campiña era un desierto, todas las ciudades,destruidas por el Señor, por el ardor de su cólera."
,"27":"Sí, así habla el Señor: Todo el país será devastado, yo llevaré a cabo,un total exterminio."
,"28":"Por eso la tierra se pondrá de luto, y los cielos en lo alto,se oscurecerán. Porque he hablado,y no me arrepentiré; lo he resuelto,y no me volveré atrás."
,"29":"Ante el clamor de los jinetes,y de los arqueros,todas las ciudades,se dan a la fuga; se esconden en los bosques, escalan las rocas. Toda la ciudad está desierta; no queda en ella un alma."
,"30":"Y tú, desolada, ¿qué vas a hacer?,Aunque te vistas de púrpura,y te adornes de joyas de oro, aunque te agrandes los ojos,con cosméticos, en vano te pones bella. Tus amantes te desprecian, tu vida es lo que buscan."
,"31":"Sí, oigo gritos,como de mujer en parto, angustias como de primeriza. Son los gritos de la hija de Sión, que gime y alarga las manos. '¡Ay de mí, que voy a sucumbir,bajo los golpes de los asesinos!'."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Recorred las calles de Jerusalén, mirad, informaos bien, buscad por sus plazas, a ver si encontráis un hombre, uno solo que practique la justicia, que busque la verdad, y yo perdonaré a esta ciudad."
,"2":"Pues, aunque dicen: '¡Vive Dios!', ciertamente juran en falso."
,"3":"¡Oh Señor!, ¿no buscan tus ojos la verdad?,Tú les has herido, y no han acusado el golpe; los has aplastado, y no han querido,aprender la lección. Han endurecido su frente,como la roca, han rehusado convertirse."
,"4":"Yo me decía: Sólo el vulgo,procede neciamente, porque no conocen,el camino del Señor,y el precepto de su Dios."
,"5":"Me dirigiré, pues, a los grandes y les hablaré, porque éstos conocen,el camino del Señor,y el precepto de su Dios. ¡Pero unos y otros,han quebrado el yugo,y han roto las coyundas!"
,"6":"Por eso el león de la selva,los asalta, el lobo del desierto,los destroza, el leopardo está al acecho,ante sus ciudades; todo el que sale fuera,es despedazado; porque son muchos sus delitos, abundantes sus rebeldías."
,"7":"¿Por qué he de perdonarte?,Tus hijos me han abandonado, juran por dioses que no existen. Los he saciado, y se han hecho adúlteros; frecuentan la casa de la prostituta."
,"8":"Como sementales rollizos y vigorosos, cada uno relincha,tras la mujer del prójimo."
,"9":"¿Y no he de castigar,tales acciones? -dice el Señor-. ¿De una nación como ésta,no he de vengarme?"
,"10":"Escalad sus cercas, destruidlas, arrasadlas totalmente, arrancad sus sarmientos, porque no pertenecen al Señor."
,"11":"Sí, harto me han traicionado,la casa de Israel y la casa de Judá,-dice el Señor-."
,"12":"Han renegado del Señor. Han dicho: '¡No es él; ningún mal nos sobrevendrá; no veremos ni espada ni escasez!"
,"13":"Y los profetas no son más que el viento, la palabra en ellos no se alberga'."
,"14":"Por eso así habla el Señor, Dios todopoderoso: He aquí lo que va a ocurrir,por haber afirmado tales cosas. Yo pondré mis palabras en tu boca,como un fuego, y haré de este pueblo,leña que él devorará."
,"15":"Yo haré venir sobre vosotros,una nación de muy lejos, oh casa de Israel -dice el Señor-; una nación invencible, una nación muy antigua, una nación cuya lengua desconoces,y cuyo hablar no comprendes."
,"16":"Su aljaba es un sepulcro abierto; son una legión de héroes."
,"17":"Ella devorará tu cosecha y tu pan, devorará a tus hijos,y a tus hijas, devorará tus carneros y tus vacas, devorará tus viñas y tus higos, arrasará tus ciudades fuertes,en las que tanta confianza pones."
,"18":"Sin embargo -dice el Señor-, ni siquiera en aquellos días,os destruiré por completo."
,"19":"Y cuando pregunten: '¿Por qué el Señor, nuestro Dios, ha hecho todo esto con nosotros?', les responderás: 'Como vosotros,me habéis abandonado,para servir en vuestro país,a dioses extraños, de igual modo serviréis,a extranjeros,en un país que no es vuestro'."
,"20":"Anunciad esto en la casa de Jacob, hacedlo saber en Judá; decid:"
,"21":"Escucha, pueblo necio e insensato, que tiene ojos y no ve, oídos y no oye."
,"22":"¿No lograréis temerme,-dice el Señor-, no temblaréis ante mí, que he puesto la arena,como límite al mar, como barrera eterna,que no ha de traspasar?,Por más que se agita, es impotente; sus olas braman, mas no la rebasarán."
,"23":"Pero este pueblo tiene,un corazón indómito y rebelde; se han apartado y se han ido."
,"24":"No han dicho en su corazón: 'Temamos al Señor nuestro Dios, que nos manda la lluvia, la lluvia temprana,y la lluvia tardía a su tiempo, y que nos concede,las semanas justas para la cosecha'."
,"25":"Vuestras injusticias,han trastornado este orden, vuestros pecados os han privado,de estos bienes."
,"26":"Sí, hay en mi pueblo criminales, que colocan redes; como pajareros ponen trampas, mas para cazar a los hombres."
,"27":"Como una jaula llena de pájaros, así están sus casas,llenas de rapiña; así se han hecho grandes y ricos,"
,"28":"gordos y rollizos. Han sobrepasado la medida del mal, no hacen justicia, no respetan el derecho de los huérfanos, ni dictan sentencia,en favor de los pobres."
,"29":"¿Y no he de castigar todo esto?,-dice el Señor-. ¿No me vengaré de una nación como ésta?"
,"30":"Cosas horrorosas, execrables tienen lugar en este país."
,"31":"Los profetas profetizan mentiras, los sacerdotes enseñan con su mal ejemplo. ¡Y mi pueblo en ello se complace!,Mas ¿qué haréis cuando llegue el fin?"
}`)
	CurrentBook.AddChapter(6, `{
"1":"¡Huid, hijos de Benjamín, lejos de Jerusalén!,¡Tocad la trompeta en Técoa!,¡Sobre Betqueren izad una señal!,Pues por el norte,asoma la desgracia, un inmenso desastre."
,"2":"¡Oh hermosa y delicada, estás perdida, hija de Sión!"
,"3":"Hacia ella vienen pastores,con sus rebaños; por todo su cerco,plantan tiendas; cada uno apacienta su porción."
,"4":"Preparad la guerra,contra ella. ¡En pie!,¡Vayamos al asalto,en pleno mediodía!,¡Ay de vosotros, que ya el día declina,y se extienden,las sombras del crepúsculo!"
,"5":"¡En pie!,¡Vayamos al asalto por la noche, destruyamos sus palacios!"
,"6":"Pues así habla el Señor todopoderoso: Derribad sus árboles, alzad un terraplén,en torno a Jerusalén; ésta es la ciudad de la mentira, en ella sólo hay opresión."
,"7":"Como un pozo hace manar sus aguas, así hace manar ella sus crímenes. ¡Violencia! ¡Injusticia!,Esto es lo que se oye en ella; ante mí, sin cesar, sufrimientos y heridas."
,"8":"Déjate amonestar, Jerusalén, si no quieres que mi alma,se retire de ti,y te conviertas en un desierto, en un país despoblado."
,"9":"Esto dice el Señor todopoderoso: Rebusca, rebusca, como en una viña, o que queda de Israel; pasa aún la mano, como un vendimiador, por los sarmientos."
,"10":"¿A quién he de hablar?,¿A quién conjurar para que escuche?,Ved, su oído está incircunciso, no pueden escuchar. Ved, la palabra del Señor,es para ellos objeto de irrisión; han perdido su gusto."
,"11":"Estoy lleno de furor del Señor, cansado estoy de contenerlo. Derrámalo sobre el niño de la calle, sobre las cuadrillas de jóvenes también. Todos serán presas: marido y mujer, el adulto y el hombre lleno de años."
,"12":"Sus casas pasarán a otros,y también sus campos y sus mujeres, porque yo extenderé mi mano,sobre los habitantes,de esta tierra -dice el Señor-."
,"13":"Pues desde el más chico,hasta el mayor, todos están llenos de rapiña; desde el profeta al sacerdote, todos practican la estafa."
,"14":"Curan ellos la herida,de su pueblo livianamente, diciendo: ¡Paz, paz!,siendo así que no hay paz."
,"15":"Tendrían que avergonzarse,de sus acciones execrables, pero han perdido la vergüenza; no saben ya enrojecer. Por eso han de caer,entre los que perecen, y se desplomarán,cuando yo los visite,-dice el Señor-."
,"16":"Esto dice el Señor: 'Apostaos en las sendas de antaño, informaos de los caminos antiguos. Ése es el buen camino; seguidlo y hallaréis descanso,para vuestras almas'. Pero ellos han dicho: '¡No lo seguiremos!'."
,"17":"He emplazado sobre ellos centinelas. '¡Atención al sonar de la trompeta!'. Pero han dicho: '¡No estaremos atentos!'."
,"18":"Por eso, naciones, escuchad, sabed todos lo que voy a hacer."
,"19":"Escucha, tierra. He aquí que yo traigo,la desgracia sobre este pueblo; es el fruto de sus rebeliones, porque no han atendido a mis palabras,y han desechado mi ley."
,"20":"¿Qué me importa el incienso,traído de Sabá,y la caña aromática,que viene de lejano país?,Vuestros holocaustos no me agradan, ni vuestros sacrificios me complacen."
,"21":"Por eso, esto dice el Señor: 'Voy a poner ante este pueblo,obstáculos en los que tropiecen. Padres e hijos a una, vecinos y amigos perecerán'."
,"22":"Esto dice el Señor: Mirad, un pueblo llega,del país del norte, una gran nación se levanta,de los confines de la tierra."
,"23":"Están armados de arcos y espadas; son crueles, sin piedad. Su clamor es como el estruendo del mar, cabalgan en corceles, cada uno está armado,para la batalla,contra ti, hija de Sión."
,"24":"Hemos oído la noticia, han desfallecido nuestros brazos, la angustia nos invade, un dolor cual de mujer en parto."
,"25":"No salgáis a los campos, no andéis por los caminos; pues allí está la espada del enemigo, terror por todas partes."
,"26":"Hija de mi pueblo, vístete de saco, échate en la ceniza, ponte de luto,como por un hijo único, con amargos lamentos. Porque cae de improviso,el devastador sobre nosotros."
,"27":"Yo te he establecido,como examinador en medio de mi pueblo, para que conozcas y examines su conducta."
,"28":"Son todos empedernidos rebeldes, sembradores de calumnias, todos ellos corrompidos."
,"29":"Sopla con fuerza el fuelle,para que el plomo,sea consumido por el fuego. En vano se fatiga el fundidor."
,"30":"¡'Plata de desecho' se les llamará, porque el Señor los ha desechado!"
}`)
	CurrentBook.AddChapter(7, `{
"1":"El Señor dijo a Jeremías:"
,"2":"Ponte a la puerta del templo del Señor y publica allí esta palabra: Escuchad la palabra del Señor, vosotros todos, hombres de Judá, que entráis por esta puerta para adorar al Señor."
,"3":"Esto dice el Señor todopoderoso, Dios de Israel: Mejorad vuestra conducta y vuestras obras y yo habitaré con vosotros en este lugar."
,"4":"No os hagáis ilusiones con repetir palabras mentirosas: Aquí está el templo del Señor. ¡Qué templo del Señor, templo del Señor!"
,"5":"Si mejoráis vuestra conducta y vuestras obras; si practicáis de verdad la justicia mutuamente;"
,"6":"si no oprimís al extranjero, al huérfano y a la viuda; si no derramáis sangre inocente en este lugar; si no vais, para daño vuestro, en pos de dioses extraños,"
,"7":"entonces yo me quedaré con vosotros en este lugar, en el país que he dado a vuestros padres desde antiguo y para siempre."
,"8":"Pero vosotros os hacéis ilusiones con palabras engañosas que de nada os servirán."
,"9":"¡Cómo! ¡Robáis, matáis, cometéis adulterio, juráis en falso, ofrecéis sacrificios a Baal, corréis tras dioses que no conocéis,"
,"10":"y luego venís a presentaros ante mí en este templo, que lleva mi nombre, y decís: 'Ya estamos seguros', para continuar aún cometiendo todos esos crímenes!"
,"11":"¿Es que a vuestros ojos es una cueva de ladrones este templo que lleva mi nombre? Pero yo no estoy ciego -dice el Señor-."
,"12":"Id, pues, a mi morada de Silo, donde al principio puse yo mi nombre, y mirad qué he hecho de ella a causa de los crímenes de mi pueblo Israel."
,"13":"Y ahora, por haber hecho todas esas cosas -dice el Señor-, por no haberme escuchado cuando yo os hablaba con insistencia y sin tregua y no haber respondido a mis llamadas,"
,"14":"yo trataré a este templo que lleva mi nombre y en el que ponéis vuestra confianza lo mismo que al país que os he dado a vosotros y a vuestros padres; como traté a Silo."
,"15":"Os echaré de mi presencia, como eché a todos vuestros hermanos, a toda la estirpe de Efraín."
,"16":"Y tú no intercedas en favor de este pueblo, no eleves por ellos súplicas ni oraciones, no insistas cerca de mí, pues yo no te escucharé."
,"17":"¿Es que no ves lo que ellos hacen en las ciudades de Judá y en las calles de Jerusalén?"
,"18":"Los niños amontonan leña y los padres encienden el fuego; las mujeres amasan harina para hacer tortas a la reina del cielo y presentan ofrendas en honor de dioses extranjeros para herirme a mí."
,"19":"¿Acaso me hieren sólo a mí -dice el Señor-, y no más bien a sí mismos, para su propia vergüenza?"
,"20":"Por eso, esto dice el Señor: He aquí que mi cólera, mi furor, se va a desencadenar sobre este lugar, sobre los hombres y los animales, sobre los árboles del campo y sobre los frutos de la tierra. Y quemará sin apagarse."
,"21":"Esto dice el Señor todopoderoso, Dios de Israel: ¡Multiplicad cuanto queráis vuestros sacrificios y holocaustos y comed la carne!"
,"22":"Yo no dije nada ni di orden alguna a vuestros padres, el día en que los saqué del país de Egipto, referente a sacrificios y holocaustos."
,"23":"Ésta es la orden que les di: 'Escuchad mi voz, y yo seré entonces vuestro Dios y vosotros seréis mi pueblo; seguid cabalmente el camino que os he prescrito para vuestra felicidad'."
,"24":"Pero ellos no me escucharon, no me hicieron caso. Se fueron tras su propio capricho, tras la perversidad de su corazón; me dieron la espalda, y no la cara."
,"25":"Desde el día en que vuestros padres salieron de Egipto hasta el presente, os he mandado continuamente a mis siervos, los profetas."
,"26":"Pero no me escucharon ni me hicieron caso. Endurecieron su cabeza y se portaron peor que sus padres."
,"27":"Tú les dirás todas estas cosas, y no responderán."
,"28":"Diles: Ésta es la nación que no ha escuchado la voz del Señor, su Dios, y que no ha aprendido la lección. ¡La verdad ha muerto, ha desaparecido de su boca!"
,"29":"Corta tu larga cabellera y tírala. Eleva una lamentación sobre los collados, porque el Señor ha desechado y rechazado,a la generación objeto de su ira."
,"30":"Sí, los hijos de Judá han hecho lo que desagrada a mis ojos -dice el Señor-; han colocado la inmundicia de sus ídolos en el templo donde se invoca mi nombre, para profanarlo."
,"31":"Han construido los lugares de culto de Tofet, en el valle de Ben-Hinnón, para quemar a sus hijos y sus hijas en el fuego, cosa que yo no les ordené ni se me ocurrió jamás."
,"32":"Por esto, vienen días -dice el Señor- en que no se dirá más 'Tofet' ni 'valle de Ben-Hinnón', sino 'valle de la matanza'. Y Tofet llegará a ser lugar de sepultura por no haber otro lugar."
,"33":"Los cadáveres de este pueblo serán pasto de las aves del cielo y de las bestias de la tierra, que nadie ahuyentará."
,"34":"Y yo haré cesar en las ciudades de Judá y en las calles de Jerusalén los gritos de júbilo y algazara, los cantos del esposo y de la esposa, porque el país se convertirá en una desolación."
}`)
	CurrentBook.AddChapter(8, `{
"1":"En aquel tiempo -dice el Señor- sacarán de sus sepulcros los huesos de los reyes de Judá, los de los príncipes, los de los sacerdotes, los de los profetas y los de los habitantes de Jerusalén."
,"2":"Serán esparcidos al sol, a la luna y a todos los astros del cielo, a quienes amaron, sirvieron y siguieron, y a los que consultaron y adoraron. No serán recogidos ni enterrados, sino que quedarán sobre la tierra como estiércol."
,"3":"Y será preferible la muerte a la vida para todos los supervivientes de esta raza perversa, en todos los lugares donde yo los arroje -dice el Señor todopoderoso-."
,"4":"Les dirás: Esto dice el Señor: ¿Acaso el que cae,no puede levantarse?,¿El que se ha extraviado,no puede volver?"
,"5":"¿Por qué este pueblo,se rebela tercamente?,Se aferran al engaño,y no quieren arrepentirse."
,"6":"He escuchado atentamente; no hablan como se debe; ninguno se arrepiente de su perversidad, y dicen: '¿Qué es lo que he hecho?'. Todos siguen su desenfrenada carrera, como el caballo vuela,donde hierve la lucha."
,"7":"Hasta la cigüeña,en el cielo conoce su estación; la tórtola, la golondrina y la grulla,siguen la época de sus migraciones. Pero mi pueblo no conoce,la justicia del Señor."
,"8":"¿Cómo podéis decir: Sabios somos, tenemos con nosotros,la ley del Señor?,Ciertamente la ha cambiado en falsedad,la pluma mendaz de los escribas."
,"9":"Los sabios están confundidos, consternados, prendidos en el lazo. Han desechado la palabra del Señor; ¿qué sabiduría pueden poseer?"
,"10":"Por eso daré a otros sus mujeres, sus campos a nuevos propietarios, porque desde el más chico,al más grande,todos están llenos de rapiña; desde el profeta al sacerdote, todos practican el engaño."
,"11":"Intentan ellos curar,la herida de mi pueblo,insensatamente diciendo: ¡Paz, paz!, siendo así que no hay paz."
,"12":"Tendrían que avergonzarse,de sus acciones execrables, pero han perdido la vergüenza; no saben ya ni sonrojarse. Por eso han de caer,entre los que perecen; se desplomarán cuando yo los visite, -dice el Señor-."
,"13":"Voy a arrancarlos de raíz,-dice el Señor-, pues no hay racimos en la vid, no hay higos en la higuera, y hasta el follaje está marchito. Les mandaré un pueblo que los aventará."
,"14":"¿Por qué nos estamos sentados?,Reuníos, entremos en nuestras ciudades,fortificadas para morir allí, porque el Señor nuestro Dios,nos entrega a la muerte, nos da a beber agua envenenada,por haber pecado contra él."
,"15":"Esperábamos la paz, y no ha llegado bien alguno; el tiempo de la curación, y he aquí el terror."
,"16":"Desde Dan se siente,el relinchar de sus caballos; al grito estrepitoso de sus corceles, toda la tierra tiembla. Vienen a devorar el país y sus bienes, la ciudad y sus habitantes."
,"17":"He aquí que yo envío,contra vosotros serpientes venenosas, inaccesibles al encanto; os morderán -dice el Señor-,y sin remedio."
,"18":"Me invade la tristeza, desfallece mi corazón."
,"19":"El grito de angustia,de la hija de mi pueblo,se escucha a todo lo largo del país. '¿Ya no está el Señor en Sión?,¿Su rey ya no está allí?'. ¿Por qué me han irritado con sus ídolos, con sus divinidades extranjeras?"
,"20":"'Ha pasado la siega, ha acabado el verano, y nosotros no hemos sido salvados'."
,"21":"Por la herida,de la hija de mi pueblo,estoy herido, angustiado; el espanto me invade."
,"22":"¿No queda bálsamo en Galaad?,¿No hay allí ningún médico?,¿Por qué, pues, no ha adelantado,la curación de la hija de mi pueblo?"
,"23":"¡Quién convirtiera en fuente mi cabeza,y mis ojos en manantial de lágrimas, para llorar día y noche,a los muertos de la hija de mi pueblo!"
}`)
	CurrentBook.AddChapter(9, `{
"1":"¡Quién me brindara en el desierto,un albergue de ambulantes!,Abandonaría entonces a mi pueblo; me alejaría de él, porque son todos adúlteros, una pandilla de traidores."
,"2":"Tensan su lengua como un arco; la mentira, y no la verdad, prevalece en este país; sí, caminan de delito en delito,y no me conocen a mí, dice el Señor."
,"3":"Desconfíe cada uno de su prójimo, no os fiéis de un hermano, pues todo hermano estafa,y todo amigo siembra calumnias."
,"4":"Uno a otro se engañan, no se dicen la verdad, han acostumbrado su lengua,a la mentira. Están pervertidos, son incapaces de cambiar."
,"5":"¡Fraude sobre fraude!,¡Engaño sobre engaño!,No quieren conocerme,-dice el Señor-."
,"6":"Por eso, esto dice el Señor todopoderoso: 'Voy a probarlos en el crisol; ¿qué otra cosa puedo hacer,con la hija de mi pueblo?"
,"7":"Saeta mortífera es su lengua, tan sólo falsedad sale de su boca; paz auguran a su prójimo,pero en su corazón le preparan un lazo."
,"8":"¿Y no he de castigarlos yo,por estas cosas -dice el Señor-, y de un pueblo como éste,no he de tomar venganza?'."
,"9":"Alzad sobre los montes llantos y lamentos, una elegía por los pastizales de la estepa, pues han sido abrasados,y nadie pasa ya por ellos,ni se siente el mugir de los ganados. Aves del cielo,y animales han huido, se han ido."
,"10":"Y yo voy a hacer de Jerusalén,un montón de piedras, un cubil de chacales; y de las ciudades de Judá un desierto, donde nadie habite."
,"11":"¿Qué sabio hay que comprenda esto?,¿A quién se lo ha dicho,la boca del Señor?,Que lo publique, ¿por qué el país está perdido, abrasado como el desierto, por donde nadie pasa?"
,"12":"El Señor ha respondido: 'Porque han abandonado mi ley, que yo les había propuesto, y no han escuchado mi voz ni la han seguido."
,"13":"Han seguido, en cambio, el capricho de su endurecido corazón y han ido tras los baales que les enseñaron sus padres'."
,"14":"Por eso, esto dice el Señor todopoderoso, Dios de Israel: 'Yo daré de comer a este pueblo ajenjo y les haré beber agua envenenada."
,"15":"Los dispersaré entre las naciones que no conocieron ni ellos ni sus padres y enviaré tras ellos la espada hasta exterminarlos'."
,"16":"'Ea, llamad a las plañideras, mandadles venir; escoged a las más hábiles; que vengan"
,"17":"y se apresten a entonar una elegía,sobre nosotros. Destilen nuestros ojos lágrimas, derramen llanto nuestros párpados."
,"18":"Sí, un lamento llega de Sión: ¡Ah, en qué desastre estamos!,¡Qué vergüenza nos cubre!,¡Tener que abandonar la patria,y dejar nuestra casa!"
,"19":"¡Vosotras, mujeres, escuchad la palabra del Señor, reciban vuestros oídos,la palabra de su boca!,Enseñad a vuestras hijas esta elegía, decíos unas a otras esta lamentación:"
,"20":"Ha escalado la muerte,por nuestras ventanas, ha penetrado en nuestros palacios, segando a los niños por las calles, a los jóvenes por las plazas."
,"21":"Los cadáveres de los hombres,yacen como estiércol en los campos, como gavillas tras el segador, sin haber quién las recoja'."
,"22":"Esto dice el Señor: No presuma el sabio de su sabiduría, no presuma el fuerte de su fuerza, no presuma el rico de su riqueza;"
,"23":"quien quiera presumir, que presuma de esto: De tener inteligencia y conocerme, porque yo soy el Señor, que hago misericordia, derecho y justicia en la tierra. Sí, esto es lo que me agrada,-dice el Señor-."
,"24":"Vienen días -dice el Señor- en que yo visitaré a todos los circuncisos que lo sean en la carne, y no en el corazón:"
,"25":"Egipto, Judá, Edón, Amón, Moab, todos los árabes que se rasuran las sienes y habitan en el desierto; porque todos estos pueblos,son incircuncisos, pero toda la casa de Israel es incircuncisa de corazón."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Escuchad la palabra,que os dirige el Señor, oh casa de Israel."
,"2":"Esto dice el Señor: 'No sigáis los caminos de los gentiles, no temáis las señales del cielo, como los gentiles las temen."
,"3":"Pues los dioses de esos pueblos,son pura nada: un leño cortado en el bosque, labrado con azuela,por las manos de un artífice,"
,"4":"que luego de plata y oro lo recubre, y lo sujeta con clavos,a golpes de martillo, para que no se mueva."
,"5":"Como espantajo de melonar, no hablan; y hay que llevarlos, porque no pueden andar. No los temáis, que no pueden hacer daño,ni tampoco beneficio'."
,"6":"Nadie hay semejante a ti, Señor; tú eres grande, y grande es tu nombre poderoso."
,"7":"¿Quién no te temerá, rey de las naciones?,Sí, a ti se te debe el temor, porque entre todos los sabios de las naciones, en todos sus reinos, no hay nadie como tú."
,"8":"Todos ellos son brutos e insensatos, y la enseñanza de los ídolos,es la de un trozo de madera;"
,"9":"recubiertos están de láminas de plata,importada de Tarsis, y de oro de Ofir, trabajo de escultor, de manos de un orfebre; vestidos de púrpura violeta y escarlata, todos ellos son sólo obras de artífices."
,"10":"En cambio, el Señor es el Dios verdadero, el Dios viviente, el rey eterno; cuando él se irrita, la tierra se estremece, y las naciones no pueden,soportar su cólera."
,"11":"He aquí lo que diréis de ellos: 'Dioses que no han hecho,ni el cielo ni la tierra,desaparecerán de la tierra,y de debajo del cielo'."
,"12":"Él con su poder hizo la tierra, con su sabiduría el orbe estableció, con su inteligencia desplegó los cielos."
,"13":"A su voz se amontonan,en el cielo las aguas; él levanta las nubes,del extremo de la tierra, provoca con los relámpagos la lluvia,y saca de sus depósitos el viento."
,"14":"Todo hombre entonces,se siente torpe y perplejo; todo orfebre se avergüenza de su ídolo, porque sus estatuas son una mentira,y les falta el aliento."
,"15":"Son cosas vanas, obras ridículas; en el tiempo del castigo desaparecerán."
,"16":"No es así la porción de Jacob, porque él ha formado el universo,y la tribu de su heredad es Israel; su nombre es Señor omnipotente."
,"17":"Haz tu equipaje, sal del país tú que moras,en la ciudad cercada,"
,"18":"porque esto dice el Señor: 'Ved que voy a lanzar muy lejos,a los habitantes del país esta vez, y los pondré en angustias,a fin de que me encuentren'."
,"19":"¡Ay, infeliz de mí!,¡Qué desventura!,Mi herida es incurable. ¡Y yo que me decía: éste es mi mal, lo podré soportar!"
,"20":"Pero ahora mi tienda está asolada, cortadas todas mis cuerdas. Mis hijos me han abandonado, han desaparecido. No queda ya quien vuelva,a levantar mi tienda, a desplegar mis toldos."
,"21":"Necios han sido los pastores; no han buscado al Señor. Por eso no han prosperado,y todo su rebaño ha quedado disperso."
,"22":"¡Escuchad!,¡Ya llega la noticia!,Un gran tumulto viene del norte,a reducir las ciudades de Judá a un desierto, cobijo de chacales."
,"23":"Bien sé, Señor, que el camino del hombre,no está en sus manos, y que no depende del hombre,que camina enderezar sus pasos."
,"24":"Castígame, Señor, mas con justa medida, y no según tu cólera, no sea que me aniquiles."
,"25":"Derrama tu furor sobre las naciones,que no te conocen, sobre los pueblos,que tu nombre no invocan, porque han devorado a Jacob, lo han consumido,y han devastado su morada."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Palabra que el Señor dirigió a Jeremías:"
,"2":"'Escucha las cláusulas y repítelas a los hombres de Judá y a los habitantes de Jerusalén."
,"3":"Les dirás: Esto dice el Señor, Dios de Israel: Maldito el hombre que no observa las prescripciones de esta alianza"
,"4":"que yo impuse a vuestros padres el día en que los saqué de Egipto, horno de hierro, diciéndoles: Escuchad mi voz y poned por obra todo lo que yo os mando; entonces seréis mi pueblo y yo seré vuestro Dios"
,"5":"y cumpliré el juramento que hice a vuestros padres de darles una tierra que mana leche y miel, como sucede al presente'. Yo respondí: 'Sí, Señor'."
,"6":"Y el Señor me dijo: 'Publica por las ciudades de Judá y por las calles de Jerusalén este aviso: Escuchad las prescripciones de esta alianza y observadlas,"
,"7":"porque con insistencia advertí a vuestros padres desde el día en que los saqué de Egipto, y lo he repetido sin cesar hasta este día: ¡Escuchad mi voz!"
,"8":"Pero ellos no escucharon ni hicieron caso, sino que cada cual siguió el capricho de su perverso corazón. Entonces yo cumplí contra ellos todas las palabras de esta alianza que les había ordenado observar y que no observaron'."
,"9":"Y el Señor añadió: '¡Se han puesto de acuerdo los hombres de Judá y los habitantes de Jerusalén!"
,"10":"Han reincidido en las iniquidades de sus antepasados, que se negaron a escuchar mis palabras; también éstos se han ido tras dioses extraños para servirlos. La casa de Israel y la casa de Judá han violado mi alianza que yo había hecho con sus padres'."
,"11":"Por eso, esto dice el Señor: 'Voy a mandar contra ellos un desastre al que no podrán escapar; clamarán a mí, pero yo no los escucharé."
,"12":"Entonces las ciudades de Judá y los habitantes de Jerusalén podrán ir a pedir auxilio a los dioses a quienes han quemado incienso; a buen seguro que estos dioses no los salvarán en el día de su angustia."
,"13":"Porque tus dioses, oh Judá, son tan numerosos como tus ciudades; y tantos como las calles que hay en Jerusalén son los altares de infamia que vosotros habéis levantado para ofrecer incienso a Baal."
,"14":"Y tú no intercedas en favor de este pueblo, no eleves por ellos ni súplicas ni oraciones: porque no les escucharé cuando acudan en el tiempo de su desgracia'."
,"15":"¿Qué viene a hacer mi amada en mi casa, tras haber cometido tantas iniquidades?,¿Crees que los votos,y las carnes sagradas alejarán de ti,la desgracia y podrás escapar?"
,"16":"'Olivo siempre verde, bello por sus magníficos frutos',es el nombre que el Señor,te había dado. Con gran estrépito prende él fuego,a su ramaje y se queman sus ramos."
,"17":"Pues el Señor todopoderoso, que te había plantado, ha decretado contra ti la desgracia a causa de las iniquidades cometidas por la casa de Israel y la casa de Judá, que me han irritado quemando incienso a Baal'."
,"18":"El Señor me ha advertido y he llegado a entenderlo. Tú, Señor, me has manifestado sus maniobras."
,"19":"Yo era como un manso cordero que es llevado al matadero, ignorante de las tramas que estaban urdiendo contra mí. '¡Destruyamos el árbol con su fruto, arranquémoslo de la tierra de los vivos y no se recuerde más su nombre!'."
,"20":"¡Pero tú, Señor omnipotente, que juzgas con justicia,y ves los sentimientos y los pensamientos, haz que yo pueda ver tu venganza,contra ellos, porque a ti he confiado mi causa!"
,"21":"Y el Señor omnipotente ha hablado así contra las gentes de Anatot, que andan buscando mi vida y dicen: ¡No profetices en nombre del Señor, si no quieres morir a nuestras manos!"
,"22":"'Yo los castigaré; sus jóvenes caerán a espada, sus hijos y sus hijas morirán de hambre,"
,"23":"y de ellos no quedará ni resto, cuando yo mande la desgracia sobre las gentes de Anatot, el año de mi visita'."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Muy justo eres tú, Señor, para que yo trate de litigar contigo. No obstante, quiero sólo,exponerte un caso: ¿Por qué los malvados,prosperan en sus caminos?,¿Por qué viven en paz los traidores?"
,"2":"Tú los plantas y ellos echan raíces, crecen y dan fruto. Tú estás cerca de su boca, pero muy lejos de su corazón."
,"3":"A mí en cambio, Señor, me conoces, pruebas mi corazón,y ves que está contigo. Sepáralos como ovejas para el matadero, guárdalos para el día de la matanza."
,"4":"¿Hasta cuándo estará de luto la tierra, y reseca la hierba de todo el campo?,Por la maldad de los habitantes,perecen bestias y aves, porque dicen: '¡Dios no ve nuestros caminos!'."
,"5":"Si te agotas corriendo con los de a pie, ¿cómo podrás competir con los de caballería?,Si no estás seguro en un país tranquilo, ¿qué harás en la espesura del Jordán?"
,"6":"Pues hasta tus hermanos,y tu familia te traicionan. Ellos mismos, a tus espaldas, te critican a voces. No te fíes de ellos,cuando te dan buenas palabras."
,"7":"He dejado mi casa, he abandonado mi heredad, he entregado lo que más quería,en manos de sus enemigos."
,"8":"Mi heredad ha sido para mí,como un león en la selva; ha lanzado contra mí sus rugidos; por eso la detesto."
,"9":"¿Es acaso mi heredad un ave jaspeada?,Las aves rapaces revolotean,sobre ella por todas partes. ¡Ea, juntaos, fieras todas del campo, venid a devorarla!"
,"10":"Numerosos pastores han devastado mi viña, han pisoteado mi tierra, han convertido mi campo tan querido,en un desierto desolado."
,"11":"Lo han hecho una desolación lamentable ante mí. ¡Todo el país está arrasado,y ninguno se preocupa!"
,"12":"A todas las alturas peladas del desierto,han llegado los devastadores,-porque el Señor blande,una espada que devora-; de un extremo al otro del país,no hay paz para nadie."
,"13":"Sembraron trigo y recogen espinas; se han fatigado sin provecho. Les dan vergüenza sus cosechas, por el furor de la ira del Señor."
,"14":"Esto dice el Señor: 'A todos mis perversos vecinos, que invaden la heredad cuya posesión di a mi pueblo Israel, yo los arrancaré de su tierra, y de en medio de ellos arrancaré la casa de Judá."
,"15":"Pero después de haberlos arrancado, volveré a compadecerme de ellos y restableceré a cada uno en su heredad, a cada uno en su país."
,"16":"Y si aprenden bien los caminos de mi pueblo, si aprenden a jurar en mi nombre: '¡Vive Dios!', como ellos enseñaron a mi pueblo a jurar por Baal, entonces serán establecidos en medio de mi pueblo."
,"17":"Pero si no quieren escuchar, yo arrancaré a esa gente' -dice el Señor-."
}`)
	CurrentBook.AddChapter(13, `{
"1":"El Señor me dijo: 'Anda a comprarte un cinturón de lino y póntelo a la cintura; pero no lo metas en agua'."
,"2":"Yo compré un cinturón, como el Señor me había mandado y me lo puse a la cintura."
,"3":"Por segunda vez me llegó la palabra del Señor:"
,"4":"'Toma el cinturón que has comprado y que llevas a la cintura, levántate, vete al Éufrates y escóndelo allí en la grieta de una roca'."
,"5":"Fui y lo escondí junto al Éufrates, como el Señor me había mandado."
,"6":"Bastantes días después, el Señor me dijo de nuevo: 'Levántate y vete al Éufrates a buscar el cinturón que yo te mandé esconder en aquel lugar'."
,"7":"Fui al Éufrates, busqué y tomé el cinturón del lugar en donde lo había escondido; pero el cinturón estaba ya podrido y no servía para nada."
,"8":"Entonces el Señor me dijo:"
,"9":"'Esto dice el Señor: De la misma manera aniquilaré yo el orgullo de Judá y de Jerusalén."
,"10":"Este pueblo malvado, que no quiere escuchar mi palabra, que sigue el capricho de su duro corazón y va en pos de otros dioses para servirlos y postrarse ante ellos, quedará como ese cinturón, que ya no sirve para nada."
,"11":"Pues, igual que un cinturón se ajusta a la cintura del hombre, así había hecho yo que se ajustara a mí toda la casa de Israel y la casa de Judá, dice el Señor, para que fuese mi pueblo, mi honra, mi gloria y mi honor; ¡pero no me han escuchado!'."
,"12":"Tú les dirás también estas palabras: 'Esto dice el Señor, Dios de Israel: ¡Todo odre puede llenarse de vino!'. Ellos te responderán: '¿Es que no sabemos ya nosotros que todo odre puede llenarse de vino?'."
,"13":"Y tú les replicarás: 'Esto dice el Señor: Voy a emborrachar a todos los habitantes de este país, a los reyes que se sientan en el trono de David, a los sacerdotes, a los profetas y a todos los habitantes de Jerusalén."
,"14":"Los estrellaré el uno contra el otro, los padres contra los hijos, dice el Señor. Sin piedad, sin misericordia, sin perdón, los aniquilaré'."
,"15":"Escuchad, haced caso, no seáis arrogantes: es el Señor el que habla."
,"16":"Dad gloria al Señor, vuestro Dios, antes que lleguen las tinieblas; antes que vuestros pies tropiecen,por los montes tenebrosos; vosotros esperáis luz, pero él la cambiará en noche, la convertirá en tinieblas."
,"17":"Si no escucháis este aviso, mi alma llorará en secreto,por vuestro orgullo; llorará sin descanso,y mis ojos derramarán lágrimas, porque el rebaño del Señor,es conducido al cautiverio."
,"18":"Di al rey y a la reina: Sentaos en el suelo, porque ha caído de vuestra cabeza,vuestra magnífica corona."
,"19":"Las ciudades del sur están cercadas, nadie puede entrar en ellas. Todo Judá es desterrado, desterrado todo él."
,"20":"Levanta los ojos,y mira a los que vienen del norte. ¿Dónde está el rebaño,que te fue confiado, la grey de tu gloria?"
,"21":"¿Qué dirás cuando te visiten,como triunfadores aquellos,a quienes habías acostumbrado,a tus confidencias?,¿No te invadirán dolores,como de mujer en parto?"
,"22":"Acaso digas en tu corazón: ¿Por qué me suceden tales desventuras?,Por la multitud de tus iniquidades,han levantado tus vestidos,y has sido violada."
,"23":"¿Puede un negro cambiar su piel,o un leopardo sus manchas?,¿Y vosotros, habituados al mal, podréis hacer el bien?"
,"24":"Yo os dispersaré,como una paja arrebatada,por el viento del desierto."
,"25":"Ésta es tu parte, la suerte que te he asignado,-dice el Señor-, por haberte olvidado de mí,poniendo tu confianza en la mentira."
,"26":"Yo mismo levantaré,tu ropa hasta la cabeza, para que tu desnudez quede al descubierto."
,"27":"Tus adulterios, tus gritos de lujuria, tus prostituciones vergonzosas,sobre los collados y en el campo, todas tus infamias yo las he visto. ¡Ay de ti, Jerusalén, que continúas impura!,¿Hasta cuándo todavía?"
}`)
	CurrentBook.AddChapter(14, `{
"1":"Palabra del Señor, que fue dirigida a Jeremías con ocasión de la gran sequía."
,"2":"Judá está de luto, sus ciudades languidecen, yacen postradas en tierra,y un grito de angustia sale de Jerusalén."
,"3":"Los ricos mandan a sus siervos,a buscar agua; éstos van a los aljibes, no encuentran agua,y vuelven con sus cántaros vacíos; quedan consternados, humillados, y se cubren la cabeza."
,"4":"El suelo no da su fruto, porque no hay lluvia en el país; los labradores, consternados, se cubren la cabeza."
,"5":"Hasta la cierva, en pleno campo, abandona su camada por falta de hierba."
,"6":"Los asnos salvajes, tendidos sobre las colinas peladas, aspiran el aire como los chacales, mientras sus ojos palidecen,por falta de pasto."
,"7":"Si nuestras iniquidades,dan testimonio contra nosotros, actúa, Señor, por el honor de tu nombre. Sí, nuestras rebeldías han sido numerosas, hemos pecado contra ti."
,"8":"Oh Señor, esperanza de Israel, su salvador en el tiempo de la angustia, ¿por qué has de ser,como un extranjero en este país, como un caminante,que se detiene sólo para pernoctar?"
,"9":"¿Por qué eres como un hombre deprimido, como un guerrero incapaz de salvar?,Pero tú estás en medio de nosotros, oh Señor, y nosotros llevamos tu nombre. ¡No nos desampares!"
,"10":"Esto dice el Señor a este pueblo: '¡Cómo les gusta correr de acá para allá; no dan descanso a sus pies! Pero no agradan al Señor. Se acuerda todavía de su iniquidad y castiga sus pecados'."
,"11":"Y el Señor me dijo: 'No intercedas en favor de este pueblo."
,"12":"Aunque ayunen, no escucharé su súplica; aunque ofrezcan holocaustos y ofrendas, no los aceptaré; antes bien, aniquilaré a este pueblo con la espada, el hambre y la peste'."
,"13":"Yo exclamé: '¡Ah, Señor Dios! Mira que los profetas les dicen: No veréis la espada ni sufriréis hambre, sino que os daré una paz segura en este lugar'."
,"14":"Y el Señor me contestó: 'Estos profetas anuncian mentiras en mi nombre; yo no les he enviado, no les he dado órdenes, no les he hablado. Visiones falsas, vanos presagios, fantasías de su propia invención, eso es lo que profetizan'."
,"15":"Por eso, esto dice el Señor: 'Esos profetas que hablan en mi nombre sin que yo les haya mandado, y que opinan que no habrá en este país espada ni hambre, esos profetas morirán a espada y de hambre;"
,"16":"y el pueblo a quienes ellos profetizan será arrojado por las calles de Jerusalén, víctima del hambre y de la espada, y no habrá quien los sepulte, ni a ellos ni a sus mujeres, ni a sus hijos, ni a sus hijas. Yo haré recaer sobre ellos su iniquidad'."
,"17":"Tú les dirás estas palabras: 'Mis ojos se derriten,en lágrimas noche y día sin descanso, por el gran desastre,que quebranta a la virgen, hija de mi pueblo, por su gravísima herida."
,"18":"Si salgo al campo, sólo veo caídos a espada; si entro en la ciudad, allí están las angustias del hambre. Hasta los profetas y los sacerdotes,vagan por el país. ¡Ya no lo conocen!"
,"19":"¿Has desechado del todo a Judá, sientes náuseas de Sión?,¿Por qué nos has herido,sin esperanza de remedio?,¡Esperábamos paz, y nada bueno llega; el tiempo de curación, y he aquí el espanto!"
,"20":"Reconocemos, Señor, nuestra iniquidad,y la perversidad de nuestros padres. Sí, hemos pecado contra ti."
,"21":"¡No nos deseches, por amor de tu nombre!,¡No desprecies tu trono glorioso!,¡Acuérdate, no rompas tu alianza con nosotros!"
,"22":"¿Hay acaso entre los ídolos de las gentes,quien pueda hacer llover?,¿Son los cielos los que dan la lluvia?,¿No eres tú solo, Señor?,¡Oh Dios nuestro, en ti esperamos, porque eres tú quien hace todo esto!'."
}`)
	CurrentBook.AddChapter(15, `{
"1":"El Señor me dijo: 'Aunque se presentaran ante mí Moisés y Samuel, mi alma no se inclinaría hacia este pueblo. Échalos de mi presencia, que se vayan."
,"2":"Y si te dicen: ¿Adónde vamos a ir?, les responderás: Esto dice el Señor: ¡Quien está destinado,a la peste, a la peste; quien a la espada, a la espada; quien al hambre, al hambre; quien al cautiverio, al cautiverio!"
,"3":"Y aún suscitaré contra ellos cuatro azotes -dice el Señor-: Espada para matarlos, perros para arrastrarlos, aves del cielo y bestias de la tierra para devorarlos y exterminarlos."
,"4":"Y los convertiré en objeto de horror para todos los pueblos de la tierra, a causa de Manasés, hijo de Ezequías, rey de Judá, por los crímenes que perpetuó en Jerusalén."
,"5":"¿Quién se apiadará de ti, Jerusalén?,¿Quién te consolará?,¿Quién te detendrá,para preguntarte cómo estás?"
,"6":"Tú me has abandonado,-dice el Señor-, me has vuelto la espalda, y yo he extendido mi mano,contra ti para aniquilarte: ¡Ya estoy cansado de compadecerme!"
,"7":"Yo los he aventado con el bieldo,por las ciudades del país; he privado de hijos a mi pueblo, lo he aniquilado, porque no desiste de seguir sus caminos."
,"8":"Sus viudas son más numerosas,que la arena del mar. Sobre las madres de jóvenes guerreros he traído, en pleno día, al devastador; hago caer sobre ellas de repente terror y espanto."
,"9":"Languidece la madre de siete hijos, está para entregar el alma; su sol se pone siendo aún pleno día, está avergonzada y humillada. Y lo que de ellos queda,lo entregaré a la espada, ante sus enemigos' -dice el Señor-."
,"10":"¡Ay de mí, madre mía, que me engendraste hombre de querella,y de discordia para todo el país!,No he prestado dinero, no he recibido préstamo, pero todos me maldicen."
,"11":"El Señor ha dicho: ¿No te había yo empujado hacia el bien?,¿No he hecho yo que el enemigo,te suplicase en el tiempo,de la desgracia y de la angustia?"
,"12":"¿Puede romperse el hierro, el hierro del norte y el bronce?"
,"13":"Tus bienes y tus tesoros,voy a entregarlos al saqueo,en pago de tus pecados,en todo el territorio."
,"14":"Y te haré esclavo de tus enemigos,en un país que no conoces, porque el fuego de mi cólera se enciende,y va a arder sobre vosotros."
,"15":"Tú lo sabes, Señor; acuérdate de mí, cuida de mí, véngame de mis perseguidores; que no muera yo,por ser tú con ellos tan paciente, piensa que por tu causa,soporto tanto ultraje."
,"16":"Cuando recibía tus palabras,yo las devoraba; tus palabras eran mi delicia, la alegría de mi corazón, pues tu nombre se invocaba sobre mí, oh Señor Dios omnipotente."
,"17":"Jamás he ido a divertirme,a una reunión de burlones; bajo el peso de tu mano,he estado solitario, pues tú me habías llenado de tu ira."
,"18":"¿Por qué mi dolor no tiene fin?,¿Por qué mi herida es incurable, indócil al remedio?,¿Vas a ser para mí como un arroyo engañador, de aguas caprichosas?"
,"19":"Entonces me dijo el Señor: 'Si vuelves, yo te haré volver,y continuarás a mi servicio; y si separas lo precioso de lo vil, serás como mi boca. Ellos volverán a ti, no tú a ellos."
,"20":"Yo te constituiré para este pueblo, cual muralla de bronce inconmovible. Lucharán contra ti, mas no te vencerán, pues yo estaré contigo para salvarte,y librarte -dice el Señor-."
,"21":"Te libraré de la mano de los malvados,y te arrancaré de las garras de los violentos'."
}`)
	CurrentBook.AddChapter(16, `{
"1":"El Señor me dijo:"
,"2":"'No te cases, no tengas hijos ni hijas en este lugar."
,"3":"Porque esto dice el Señor acerca de los hijos y las hijas que nazcan en este lugar, acerca de las madres que los den a luz y de los padres que los engendren en este país."
,"4":"Morirán de mala muerte; no serán llorados ni sepultados, sino que quedarán como estiércol en el campo; perecerán por la espada y el hambre, y sus cadáveres serán pasto de las aves del cielo y de las bestias salvajes'."
,"5":"Pues esto dice el Señor: 'No entres en la casa en que se hace duelo. No vayas a llorar, ni a consolarlos, porque -dice el Señor- yo he retirado de este pueblo mi paz, mi misericordia y mi compasión."
,"6":"Grandes y pequeños morirán en este país sin ser sepultados ni llorados; por ellos no se harán cortes en el cuerpo ni se raparán el cabello."
,"7":"Nadie partirá el pan con quien está de duelo para consolarlo por un muerto; nadie le ofrecerá la copa del consuelo por la muerte del padre o de la madre."
,"8":"No entres en la casa en que se celebra un convite para sentarte a comer y beber con ellos;"
,"9":"porque esto dice el Señor todopoderoso, Dios de Israel: Voy a suprimir de este lugar, a vuestros ojos y en vuestros días, los gritos de gozo y algazara, los cantos del esposo y de la esposa."
,"10":"Y cuando anuncies a este pueblo todas estas cosas y te pregunten: ¿Por qué ha decretado el Señor contra nosotros esta gran calamidad? ¿Cuál es nuestro crimen y qué falta hemos cometido contra el Señor nuestro Dios?"
,"11":"Les responderás: Porque vuestros padres me abandonaron y no observaron mi ley."
,"12":"Y porque vosotros habéis obrado peor que vuestros padres, pues cada uno de vosotros sigue el capricho de su perverso corazón sin escucharme a mí."
,"13":"Pero yo os expulsaré de este país a un país desconocido para vosotros y para vuestros padres. Allí serviréis día y noche a otros dioses, porque yo no os concederé más misericordia."
,"14":"Sin embargo, vienen días -dice el Señor- en que ya no se dirá: '¡Vive el Señor, que sacó a los israelitas de Egipto!',"
,"15":"sino '¡Vive el Señor, que trajo a los israelitas de las regiones del norte y de todos los países en que los había dispersado!'. Yo los restableceré en la tierra que había dado a sus padres."
,"16":"Sí, yo mandaré muchos pescadores, dice el Señor, que los pescarán; mandaré muchos cazadores, que los cazarán en todo monte, en toda colina y en las grietas de las rocas."
,"17":"Porque mis ojos vigilan todos sus caminos; no se me ocultan, ni su perversidad está fuera de mi vista."
,"18":"Pero primero les haré pagar el doble su iniquidad y sus pecados. Porque han profanado mi tierra con los cadáveres de sus ídolos y han atestado mi heredad con sus horrores'."
,"19":"Oh Señor, mi fuerza y mi fortaleza, mi refugio en el día de la tribulación; a ti vendrán las naciones,desde los confines de la tierra,y dirán: Sólo mentira,poseyeron nuestros padres, vanidad e impotencia."
,"20":"¿Puede un hombre fabricarse sus dioses?,¡Pero ellos no son dioses!"
,"21":"Por eso, he aquí que voy a manifestarles, esta vez se lo manifestaré, mi mano y mi poder, y sabrán que mi nombre es el Señor."
}`)
	CurrentBook.AddChapter(17, `{
"1":"El pecado de Judá,está escrito con estilete de hierro; con punta de diamante,está grabado sobre la tabla de su corazón,y en los ángulos de sus altares,"
,"2":"para memoria de sus hijos,junto a todo árbol verde, sobre los altos collados"
,"3":"y las montañas, en plena campiña). Tus bienes, todos tus tesoros,los entregaré al saqueo,por todos los pecados cometidos,en las colinas en todo el territorio."
,"4":"Tendrás que desprenderte de tu heredad,que yo te había regalado, y te haré esclavo de tus enemigos,en un país que no conoces, porque has encendido el fuego de mi cólera, que arderá eternamente."
,"5":"Esto dice el Señor: '¡Maldito el hombre,que confía en el hombre, que en el mortal se apoya,y su corazón se aparta del Señor!"
,"6":"Es como tamarisco en la estepa, que no siente cuándo llega la dicha, porque arraiga en los lugares,abrasados del desierto, en tierra salobre y despoblada."
,"7":"Bendito el hombre que confía en el Señor, y en el Señor pone su esperanza."
,"8":"Es como un árbol plantado junto al agua, que alarga hacia la corriente sus raíces; nada teme cuando llega el calor; su follaje se mantiene verde; en año de sequía no se preocupa, ni deja de producir sus frutos."
,"9":"El corazón es complejo,más que toda otra cosa y perverso: ¿quién lo conoce a fondo?"
,"10":"Yo, el Señor, escruto el corazón, sondeo las entrañas,para dar a cada cual según su conducta, según el fruto de sus obras."
,"11":"Perdiz que empolla huevos,que no ha puesto,es quien amasa riquezas injustas: a la mitad de sus días,las tendrá que dejar, y al final no será más que un necio'."
,"12":"Trono de gloria, desde el principio excelso, es nuestro lugar santo."
,"13":"¡Oh esperanza de Israel, Señor, todos los que te abandonan,serán cubiertos de vergüenza; los que se apartan de ti, serán condenados, porque abandonaron al Señor, la fuente de agua viva!"
,"14":"Cúrame, Señor, y quedaré curado; sálvame y seré salvo, porque tú eres mi gloria."
,"15":"Mira cómo me dicen: '¿Dónde está la palabra del Señor?,¡Que se cumpla!'."
,"16":"A pesar de todo, yo no te he insistido,para que adelantases el desastre; no he deseado el día de la desgracia, tú lo sabes; lo que ha salido de mis labios,está ante tu presencia."
,"17":"No me seas causa de terror, tú, mi refugio, en el día de la desgracia."
,"18":"Que sean cubiertos de vergüenza mis perseguidores, y no yo; queden ellos consternados, y no yo. Haz venir sobre ellos,el día de la desgracia, destrózalos con doble destrozo."
,"19":"El Señor me ha dicho: 'Anda y ponte a la puerta de los hijos del pueblo, por donde entran y salen los reyes de Judá, y luego a todas las puertas de Jerusalén."
,"20":"Diles: Escuchad la palabra del Señor, reyes de Judá, y vosotros, judíos todos y habitantes de Jerusalén que pasáis por estas puertas."
,"21":"Esto dice el Señor: Si queréis salvar la vida, guardaos de transportar carga en día de sábado y de pasarla por las puertas de Jerusalén."
,"22":"No saquéis carga de vuestras casas en día de sábado ni hagáis trabajo alguno. Santificad el día del sábado como yo lo ordené a vuestros padres."
,"23":"Ellos no escucharon ni hicieron caso, sino que endurecieron su cabeza para no escuchar ni aceptar la enseñanza."
,"24":"Si vosotros me escucháis de verdad, dice el Señor; si no acarreáis carga por las puertas de esta ciudad en día de sábado, sino que por el contrario santificáis el día del sábado no realizando en él trabajo alguno,"
,"25":"entonces, por las puertas de esta ciudad, reyes y príncipes, herederos del trono de David, entrarán montados en carrozas y caballos, ellos y sus ministros, las gentes de Judá y los habitantes de Jerusalén. Y esta ciudad será habitada eternamente."
,"26":"Y vendrán de las ciudades de Judá y de los alrededores de Jerusalén, de la tierra de Benjamín, de la llanura, de la montaña y del Negueb, trayendo holocaustos, sacrificios, ofrendas, incienso y sacrificios de acción de gracias al templo del Señor."
,"27":"Pero si no escucháis mi mandamiento de santificar el sábado y de no transportar carga ni acarrearla por las puertas de Jerusalén en día de sábado, prenderé fuego a sus puertas y devorará, inextinguible, los palacios de Jerusalén'."
}`)
	CurrentBook.AddChapter(18, `{
"1":"El Señor dijo a Jeremías:"
,"2":"'Levántate y baja a casa del alfarero. Allí te comunicaré mis palabras'."
,"3":"Bajé, pues, a casa del alfarero y lo encontré haciendo un trabajo a la rueda."
,"4":"Cuando la vasija que hacía le salía mal, como suele ocurrir con la arcilla en manos del alfarero, volvía a hacer otra vasija a su gusto."
,"5":"Entonces el Señor me dijo:"
,"6":"'¿No puedo yo hacer con vosotros, oh casa de Israel, lo mismo que este alfarero? -dice el Señor-. Como la arcilla en mano del alfarero, así sois vosotros en mi mano, oh casa de Israel."
,"7":"A veces yo decido, contra una nación o contra un reino, arrancarlo, destruirlo y aniquilarlo;"
,"8":"pero si esa nación, contra la que he hablado, se convierte de su iniquidad, también yo me arrepiento del castigo que iba a ponerle."
,"9":"Otras veces decido, sobre una nación o un reino, edificarlo y plantarlo;"
,"10":"pero si esa nación comete el mal que yo repruebo en lugar de escuchar mi voz, entonces yo también me arrepiento del bien que había decidido hacerle'."
,"11":"Habla, pues, ahora a las gentes de Judá y a los habitantes de Jerusalén de esta manera: 'Esto dice el Señor: Mirad, yo estoy preparando contra vosotros una desgracia y madurando un proyecto en daño vuestro. Arrepentíos cada uno de vuestra mala conducta, mejorad vuestra conducta, vuestra manera de actuar'."
,"12":"Pero ellos van a decir: '¡Es inútil, nosotros seguiremos nuestros caprichos y obraremos cada cual según la dureza de nuestro perverso corazón!'."
,"13":"Por eso dice el Señor: 'Preguntad a las naciones. ¿Quién oyó cosas semejantes?,Un crimen horrible ha cometido,la virgen de Israel."
,"14":"¿Podrá faltar a la roca,que domina la llanura la nieve del Líbano?,¿Se agotarán acaso las aguas de los altos, que corren frescas?"
,"15":"¡Pues mi pueblo me ha olvidado a mí,y ofrece incienso a la pura nada!,Han tropezado en sus caminos, en las sendas antiguas, para tomar veredas tortuosas, un camino no allanado;"
,"16":"para hacer de su país un desierto, un objeto de irrisión perpetua; todo el que pase por él,quedará atónito y meneará la cabeza."
,"17":"Como el viento solano, los dispersaré ante el enemigo. Les daré las espaldas, y no la cara, el día de su desastre'."
,"18":"Ellos han dicho: '¡Venid, tramemos un atentado contra Jeremías, pues no ha de faltar por eso del sacerdote la enseñanza, ni del sabio el consejo, ni del profeta la palabra! ¡Ea, matémosle con la lengua; no prestemos atención a ninguna de sus palabras!'."
,"19":"¡Atiéndeme, Señor, y escucha lo que dicen mi acusadores!:"
,"20":"¿Acaso se devuelve mal por bien?,Pues están cavando una fosa para mí. Recuerda cómo me he presentado ante ti,para hablarte en favor suyo,y alejar de ellos tu furor."
,"21":"¡Entrega, pues, a sus hijos al hambre, abandónalos a merced de la espada!,¡Quédense sus mujeres sin hijos y sin marido!,¡Mueran de peste sus hombres, y sus jóvenes atravesados,por la espada en la guerra!"
,"22":"¡Óiganse salir gemidos,de sus casas cuando, de improviso, mandes tú contra ellos,hordas de saqueadores!,Pues han cavado una fosa para cazarme,y han tendido lazos a mis pies."
,"23":"Pero tú, Señor, conoces bien,sus planes asesinos contra mí. No perdones su crimen, no borres de tu vista su pecado. ¡Caigan derribados ante ti, actúa contra ellos en el día de tu cólera!"
}`)
	CurrentBook.AddChapter(19, `{
"1":"El Señor me dijo: 'Vete a comprar una vasija de barro, toma contigo algunos de los ancianos del pueblo y de los sacerdotes"
,"2":"y sal al valle de Ben-Hinnón, a la entrada de la puerta de la Alfarería. Allí pregonarás las palabras que yo te diga."
,"3":"Dirás: Escuchad la palabra del Señor, reyes de Judá, y vosotros, habitantes de Jerusalén. Esto dice el Señor todopoderoso, Dios de Israel: Voy a traer sobre este pueblo una desgracia tal que el que lo oiga se quedará aturdido;"
,"4":"me han abandonado, han enajenado este lugar, han ofrecido en él incienso a dioses extraños que no habían conocido ni ellos ni sus padres ni los reyes de Judá, han llenado este lugar de sangre inocente."
,"5":"Han construido lugares de culto a Baal para quemar a sus propios hijos en su honor, cosa que yo no había prescrito ni ordenado, ni se me había ocurrido jamás."
,"6":"Por eso vienen días -dice el Señor- en que este lugar no se llamará ya 'Tofet' ni 'Valle de Ben-Hinnón', sino 'Valle de Matanza'."
,"7":"En este lugar yo haré fracasar la política de Judá y de Jerusalén; los haré caer a espada ante sus enemigos, en manos de aquellos que buscan su muerte, y daré sus cadáveres como pasto a las aves del cielo y a las bestias de la tierra."
,"8":"Haré de esta ciudad un desierto, una irrisión: todo el que pase junto a ella se asombrará y silbará a la vista de todas sus heridas."
,"9":"Le haré comer la carne de sus hijos y la de sus hijas, y se devorarán mutuamente en la extrema angustia del asedio y en medio de los apuros con que les estrujarán sus enemigos, los que buscan su muerte."
,"10":"Tú romperás la vasija de barro a la vista de los hombres que te acompañan,"
,"11":"y les dirás: Esto dice el Señor todopoderoso: Así romperé yo a este pueblo y a esta ciudad, como se hace añicos un vaso de alfarero que ya no puede recomponerse. Y se enterrará en Tofet por falta de sitio en otra parte."
,"12":"Así haré con este lugar, dice el Señor, y con sus habitantes: convertiré a esta ciudad en un Tofet."
,"13":"De suerte que las casas de Jerusalén y las de los reyes de Judá serán inmundas como el lugar de Tofet: todas estas casas sobre cuyas terrazas han ofrecido incienso a toda la milicia del cielo y han derramado ofrendas de vino en honor de dioses extranjeros'."
,"14":"Al volver Jeremías del Tofet, adonde el Señor le había mandado a profetizar, se detuvo en el atrio del templo del Señor y dijo a todo el pueblo:"
,"15":"'Esto dice el Señor todopoderoso, Dios de Israel: Yo traeré sobre esta ciudad y sobre sus ciudades anejas todas las calamidades con las que le he amenazado por haberse endurecido negándose a escuchar mis palabras'."
}`)
	CurrentBook.AddChapter(20, `{
"1":"El sacerdote Pasjur, hijo de Imer, que era inspector jefe del templo del Señor, al oír a Jeremías profetizar tales cosas,"
,"2":"mandó golpear al profeta Jeremías y luego le puso en el cepo que estaba en la puerta de Benjamín, la más alta, en el templo del Señor."
,"3":"Al día siguiente Pasjur mandó sacar a Jeremías del cepo, y Jeremías le dijo: 'El Señor no te llama Pasjur, sino 'Terror por todas partes';"
,"4":"pues esto dice el Señor: Te voy a entregar al terror, a ti y a todos tus amigos: caerán bajo la espada de sus enemigos ante tus propios ojos. Y a todo Judá la entregaré en poder del rey de Babilonia, que los deportará a Babilonia y los matará a espada."
,"5":"Entregaré también todos los bienes de Jerusalén, toda su fortuna, todos sus objetos de valor, todos los tesoros de los reyes de Judá, en manos de sus enemigos, que los saquearán, se apoderarán de ellos y los llevarán a Babilonia."
,"6":"Y tú, Pasjur, y todos los que viven en tu casa, marcharéis al destierro; irás a Babilonia y allí morirás y serás enterrado tú y todos tus amigos, a quienes profetizas la mentira'."
,"7":"Tú me has seducido, Señor, y yo me he dejado seducir; has sido más fuerte que yo, me has podido. Me he convertido en irrisión continua, todos se burlan de mí."
,"8":"Pues cada vez que hablo,tengo que gritar y proclamar: '¡Violencia y ruina!'. La palabra del Señor es para mí oprobio,y burla todo el día."
,"9":"Yo me decía: No pensaré más en él, no hablaré más en su nombre. Pero había en mi corazón,como un fuego abrasador,encerrado en mis huesos; me he agotado en contenerlo,y no lo he podido soportar."
,"10":"Pues he escuchado la calumnia de la gente: '¡Terror por todas partes!,¡Anunciadlo, anunciémoslo!'. Todos los que eran mis amigos,me espiaban a ver si daba un paso en falso: '¡Quizás se deje seducir; nosotros lo venceremos y nos vengaremos de él!'."
,"11":"Pero el Señor está conmigo,como un héroe potente: caerán mis adversarios derrotados; ahí están en su fracaso avergonzados, en ignominia perpetua, inolvidable."
,"12":"¡Señor omnipotente que juzgas con justicia, que ves los sentimientos y los pensamientos, haz que yo vea tu venganza sobre ellos, pues en tus manos he dejado mi causa!"
,"13":"Cantad al Señor, alabad al Señor, porque él libra al pobre,del poder de los malvados."
,"14":"¡Maldito el día en que nací; el día en que mi madre me dio a luz,no sea bendito!"
,"15":"¡Maldito el hombre que dio a mi padre la noticia: 'Un hijo varón te ha nacido', y le llenó de gozo!"
,"16":"¡Sea ese hombre como las ciudades,que el Señor destruyó sin compasión!,¡Oiga el grito de alarma por la mañana, el alarido de guerra al mediodía!"
,"17":"¡Por qué no me hizo morir,en el seno materno!,Mi madre hubiera sido mi sepulcro, y yo eterna preñez de sus entrañas."
,"18":"¿Por qué salí del seno,para no ver más que dolores y tormentos,y consumir mis días en la confusión?"
}`)
	CurrentBook.AddChapter(21, `{
"1":"Palabra que el Señor dirigió a Jeremías cuando el rey Sedecías mandó a decirle por medio de Pasjur, hijo de Malaquías, y del sacerdote Sofonías, hijo de Maasías:"
,"2":"'Consulta al Señor acerca de nosotros, porque Nabucodonosor, rey de Babilonia, nos hace la guerra. Tal vez el Señor renueve en favor nuestro todas sus maravillas y nuestro enemigo se aleje de nosotros'."
,"3":"Jeremías les dijo: 'Responderéis a Sedecías lo siguiente:"
,"4":"Esto dice el Señor, Dios de Israel: Yo haré volver atrás las armas que lleváis en vuestras manos y con las cuales combatís fuera de las murallas contra el rey de Babilonia y los caldeos que os tienen asediados, y las amontonaré en medio de esta ciudad."
,"5":"Y yo mismo combatiré contra vosotros con mano fuerte y brazo extendido, con cólera, furor y gran indignación."
,"6":"Heriré a los habitantes de esta ciudad, hombres y bestias, con una gran peste, y morirán."
,"7":"Después de esto, dice el Señor, entregaré a Sedecías, rey de Judá, a sus servidores y a los habitantes de esta ciudad que hayan escapado a la peste, a la espada y al hambre, en manos de Nabucodonosor, rey de Babilonia, en manos de sus enemigos, de aquellos que buscan su vida; él los pasará a filo de espada sin consideración, sin piedad y sin compasión'."
,"8":"Y a este pueblo le dirás: Esto dice el Señor: Mirad, yo pongo ante vosotros el camino de la vida y el de la muerte."
,"9":"El que quede en esta ciudad morirá de espada, de hambre o de peste; el que salga y se rinda a los caldeos que os asedian, vivirá. Conservará su vida como botín."
,"10":"Porque yo he vuelto mi rostro a esta ciudad, pero para mal, no para su bien -dice el Señor-. Será entregada al rey de Babilonia, que la prenderá fuego."
,"11":"Dirás a la casa real de Judá: Escuchad la palabra del Señor:"
,"12":"Casa de David, esto dice el Señor: 'Haced justicia cada mañana, librad al oprimido,de las manos de sus explotadores, no sea que salte como un fuego mi ira, se encienda y no haya quien la apague,a causa de tus acciones perversas."
,"13":"A ti me dirijo, moradora del valle, roca de la llanura -dice el Señor-, a vosotros que decís: '¿Quién podrá asaltarnos,y penetrar en nuestros refugios?'."
,"14":"Yo os castigaré como lo merecen vuestras obras,-dice el Señor-; prenderé fuego a su bosque, y devorará todos sus alrededores'."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Esto dice el Señor: Baja a la casa del rey de Judá y pronuncia allí esta profecía."
,"2":"Escucha la palabra del Señor, oh rey de Judá, que te sientas en el trono de David, tú, así como tus servidores y tu pueblo, los que entráis por estas puertas."
,"3":"Esto dice el Señor: Practicad el derecho y la justicia y librad al oprimido de las manos del explotador; no maltratéis al extranjero, al huérfano y a la viuda; no los hagáis violencia, ni derraméis sangre inocente en este lugar."
,"4":"Si observáis de verdad esta orden, entonces por las puertas de esta casa entrarán reyes, herederos del trono de David, montados en carrozas y caballos, así ellos como sus servidores y su pueblo."
,"5":"Pero si no escucháis estas palabras, por mí mismo juro -dice el Señor- que esta casa será reducida a un montón de escombros."
,"6":"Pues esto dice el Señor acerca de la casa real de Judá: Eras para mí como un Galaad, como una cima del Líbano. Pero yo te transformaré en desierto, en ciudad despoblada."
,"7":"Prepararé devastadores contra ti, cada uno con sus hoces; talarán tus cedros más selectos, y al fuego los arrojarán."
,"8":"Y cuando pasen muchas gentes junto a Jerusalén y se pregunten: '¿Por qué el Señor ha tratado así a esta ciudad?',"
,"9":"se responderá: 'Por haber abandonado la alianza del Señor, su Dios, para adorar y servir a dioses extraños'."
,"10":"No lloréis al que está muerto, no hagáis duelo por él; llorad amargamente por el que parte, porque no volverá más, no verá más la tierra en que nació."
,"11":"Pues esto dice el Señor,respecto de Salún, hijo de Josías, rey de Judá, que ha sucedido a Josías, su padre, y que ha salido de este lugar: No volverá más,"
,"12":"sino que morirá en el lugar,adonde ha sido deportado, y no volverá a ver esta tierra."
,"13":"¡Ay de aquel que edifica,su casa con injusticias,y sus pisos contra todo derecho; del que hace trabajar a su prójimo de balde, sin pagarle su salario;"
,"14":"del que dice: Voy a construirme,un gran palacio con grandes salones, y abre sus ventanas, lo artesona de cedro,y lo pinta de rojo!"
,"15":"¿Piensas asegurar tu reinado,con tu pasión por el cedro?,Tu padre sí comía y bebía, pero practicaba el derecho y la justicia, y todo le iba bien."
,"16":"Hacía justicia al débil y al pobre, y todo le iba bien. ¿No es eso conocerme? -dice el Señor-."
,"17":"Pero tus ojos y tu corazón,buscan tan sólo tu propio interés, sangre inocente que derramar, explotación y violencia que ejercer."
,"18":"Por eso, esto dice el Señor,respecto de Joaquín, hijo de Josías, rey de Judá: No harán lamentos sobre él: ¡Ay, hermano! ¡Ay, hermana!,No le llorarán: ¡Ay, Señor; ay, majestad!"
,"19":"Será enterrado como un asno, será arrastrado,y tirado fuera de las puertas de Jerusalén."
,"20":"Sube al Líbano y grita, haz resonar tu voz desde Basán, vocifera desde Albarín, porque han sido destrozados todos tus amantes."
,"21":"Te hablé en la hora de tu prosperidad. Tú dijiste: '¡No quiero escuchar!'. Ése ha sido tu camino desde tu juventud: no escuchar mi voz."
,"22":"El viento apacentará a todos tus pastores, y tus amantes marcharán al destierro. Entonces tendrás vergüenza,y confusión de toda tu perversidad."
,"23":"Tú, que has puesto tu morada en el Líbano,y anidas en los cedros. ¡Cómo gemirás cuando te vengan los dolores, angustias como de mujer en parto!"
,"24":"Por mi vida -dice el Señor-,que aunque Jeconías, hijo de Joaquín, rey de Judá, fuera un anillo en mi mano derecha, le arrancaría de allí."
,"25":"Te entregaré en manos,de los que buscan tu muerte, en manos de aquellos,que tanto miedo te infunden: en manos de Nabucodonosor, rey de Babilonia, y en manos de los caldeos."
,"26":"Y te arrojaré a ti y a tu madre, que te dio a luz, a otra tierra donde no habéis nacido, pero donde moriréis."
,"27":"Pero a esta tierra, adonde tanto desean volver, no volverán jamás."
,"28":"¿Es acaso un vaso vil y roto este hombre, Jeconías, un objeto que ninguno quiere?,¿Por qué han sido expulsados,él y su estirpe, y arrojados a una tierra,que no conocían?"
,"29":"¡Tierra, tierra, tierra, escucha la palabra del Señor!"
,"30":"Esto dice el Señor: Inscribid así a este hombre; sin hijos, uno que no prosperó en su tiempo; porque ninguno de su estirpe,logrará sentarse en el trono de David,y reinar en Judá."
}`)
	CurrentBook.AddChapter(23, `{
"1":"¡Ay de los pastores que dejan perecer y dispersarse al rebaño de mi pasto, dice el Señor!"
,"2":"Por tanto, esto dice el Señor, Dios de Israel, sobre los pastores que guían a mi pueblo: Vosotros habéis dispersado mi rebaño, lo habéis descarriado sin preocuparos de él. Pero yo me voy a ocupar ahora de vosotros -dice el Señor-, castigando vuestras perversas acciones."
,"3":"Yo mismo recogeré los restos de mi rebaño de todos los países donde los dispersé y los haré volver a sus pastos, donde crecerán y se multiplicarán."
,"4":"Suscitaré para ellos pastores que los apacentarán; no sufrirán más temor y angustia, ni se volverá a perder ninguno -dice el Señor-."
,"5":"Vienen días -dice el Señor-,en que yo suscitaré a David,un vástago legítimo, que reinará como verdadero rey, con sabiduría, y ejercerá el derecho y la justicia,en la tierra."
,"6":"En sus días se salvará Judá, e Israel vivirá en seguridad. Y éste será el nombre,con que le llamarán: 'El Señor nuestra justicia'."
,"7":"Vienen días -dice el Señor- en que no se dirá ya: 'Vive Dios, que sacó a los israelitas de Egipto',"
,"8":"sino: '¡Vive Dios, que sacó y trajo a la estirpe de la casa de Israel del país del norte y de todos los lugares donde los había dispersado para que habiten de nuevo en su propia tierra!'."
,"9":"Contra los profetas: 'Mi corazón se rompe dentro de mí, todos mis miembros se estremecen; soy como un borracho, como un hombre vencido por el vino,ante el Señor y sus santas palabras."
,"10":"Pues el país está lleno de adúlteros; a causa de la maldición,el país está de luto, resecos los oasis del desierto. El afán de su carrera es el mal; su esfuerzo, la injusticia."
,"11":"Sí, hasta el profeta y el sacerdote,practican la injusticia, hasta en mi propia casa,he encontrado su maldad, -dice el Señor-."
,"12":"Por eso su camino,va a ser para ellos,despeñadero entre tinieblas; serán empujados y caerán en él. Voy a traer sobre ellos la desgracia,el año en que tengan que rendir cuentas,-dice el Señor-."
,"13":"En los profetas de Samaría,vi cosas repugnantes: profetizaban en nombre de Baal,y pervertían a mi pueblo Israel."
,"14":"Pero en los profetas de Jerusalén,he visto monstruosidades: adulterio, obstinación en la falsedad, apoyo a los criminales,para que ninguno se convierta,de su perversidad; son todos ellos para mí como Sodoma; y sus habitantes, como Gomorra."
,"15":"Por esto, así dice el Señor omnipotente,sobre los profetas: Yo les daré a comer ajenjo, y a beber agua envenenada; porque de los profetas de Jerusalén,sale la impiedad para todo el país'."
,"16":"Esto dice el Señor omnipotente: No escuchéis las palabras de los profetas, porque os engañan; os cuentan visiones de su fantasía, no de la boca del Señor."
,"17":"Dicen a quienes desprecian,la palabra del Señor: '¡Tendréis paz!', y a todos los que siguen,el capricho de su corazón: '¡No os sobrevendrá ningún mal!'."
,"18":"Pero ¿quién ha asistido al consejo del Señor?,¿Quién ha visto y oído su palabra?,¿Quién ha prestado atención,a su palabra y la ha escuchado?"
,"19":"Mirad, la borrasca del Señor estalla, un huracán se desencadena, se precipita sobre la cabeza de los malhechores."
,"20":"La ira del Señor no volverá atrás,hasta que no haya ejecutado y realizado,los designios de su corazón. En los tiempos futuros,comprenderéis bien esto."
,"21":"No he enviado yo a estos profetas, y ellos corren; no les he dicho nada, ¡y ellos profetizan!"
,"22":"Si es que han asistido a mi consejo, ¡anuncien mis palabras a mi pueblo, hagan que se convierta,de su mal camino, de la perversidad de sus acciones!"
,"23":"¿Acaso soy yo Dios sólo de cerca,-dice el Señor-,y de lejos no soy Dios?"
,"24":"Si un hombre se oculta en escondrijo, ¿no le veré yo acaso?,-dice el Señor-. ¿Es que los cielos y la tierra,no los lleno yo?,-dice el Señor-."
,"25":"He oído lo que dicen los profetas que profetizan mentiras en mi nombre. Dicen: 'He tenido un sueño, he tenido un sueño'."
,"26":"¿Hasta cuándo los profetas anunciarán profecías falsas y profetizarán las fantasías de su muerte?"
,"27":"Con los sueños que se cuentan unos a otros tratan de hacer que mi pueblo se olvide de mi nombre, como sus padres se olvidaron de mi nombre por Baal."
,"28":"El profeta que haya tenido un sueño, que cuente su sueño. Y aquel que ha recibido mi palabra, que anuncie fielmente mi palabra. ¿Qué tiene que ver la paja con el grano? -dice el Señor-."
,"29":"¿No es mi palabra como el fuego, como el martillo que deshace la roca?"
,"30":"Por eso, estoy contra los profetas -dice el Señor- que se roban mutuamente mis palabras."
,"31":"Estoy contra los profetas -dice el Señor- que no tienen más que abrir su boca para proferir oráculos."
,"32":"Me levanto contra los profetas que profetizan sueños mentirosos -dice el Señor- y, contándolos, desorientan a mi pueblo con sus mentiras y sus extravagancias. Yo no los he enviado ni les he confiado mis órdenes, y ellos no sirven de nada a este pueblo -dice el Señor-."
,"33":"Cuando un hombre de este pueblo, o un profeta, o un sacerdote te pregunte: '¿Cuál es la carga del Señor?', responderás: '¡Vosotros sois la carga del Señor, y yo os rechazaré!'."
,"34":"Y al profeta, al sacerdote, al hombre del pueblo que diga: '¡Carga del Señor!', yo le castigaré a él y a su casa."
,"35":"Esto es lo que tenéis que deciros unos a otros: '¿Qué ha respondido el Señor o qué ha dicho el Señor?'."
,"36":"Pero no habléis más de '¡Carga del Señor!'. La 'carga' será para cada uno su propia palabra; porque vosotros falsificáis las palabras del Dios vivo, el Señor todopoderoso, vuestro Dios."
,"37":"Tú hablarás así al profeta: '¿Qué te ha respondido el Señor?'."
,"38":"Pero si decís: 'Carga del Señor'; entonces el Señor dirá: 'Puesto que vosotros repetís la expresión '¡Carga del Señor!', siendo así que yo os he prohibido usarla,"
,"39":"por eso yo os levantaré como una carga y os echaré lejos de mi presencia, a vosotros y a esta ciudad que yo había dado a vosotros y a vuestros padres,"
,"40":"y os cubriré de perpetuo desprecio y de eterna ignominia, que jamás será olvidada'."
}`)
	CurrentBook.AddChapter(24, `{
"1":"El Señor me mostró dos cestas de higos, que estaban delante del templo del Señor. Esto sucedió después que Nabucodonosor, rey de Babilonia, había llevado al destierro, de Jerusalén a Babilonia, a Jeconías, hijo de Joaquín, rey de Judá, con sus nobles, sus cerrajeros y sus herreros."
,"2":"Uno de los cestos contenía higos muy buenos, como lo son los tempranos; el otro tenía higos muy malos, tan malos que no se podían comer."
,"3":"Y me dijo: '¿Qué ves, Jeremías?'. Respondí: 'Higos: los buenos son excelentes; los malos son tan malos que no se pueden comer'."
,"4":"Y el Señor me dijo:"
,"5":"'Esto dice el Señor, Dios de Israel:"
,"6":"Como se mira con agrado a estos higos buenos, así miraré yo favorablemente a los desterrados de Judá, a quienes arrojo de este lugar al país de los caldeos."
,"7":"Volveré a ellos mis ojos y los haré regresar a esta tierra; los restableceré y no los volveré a destruir; los plantaré para no arrancarlos ya."
,"8":"Y les daré inteligencia para que conozcan que yo soy el Señor; ellos serán mi pueblo y yo seré su Dios, porque se convertirán a mí de todo corazón."
,"9":"Pero como a estos higos malos, tan malos que no pueden comerse -dice el Señor-, así trataré yo a Sedecías, rey de Judá, a sus oficiales y al resto de los habitantes de Jerusalén que han quedado en este país o que habitan en el país de Egipto."
,"10":"Los convertiré en objeto de horror para todos los reinos de la tierra; oprobio, chisme, escarnio y maldición en todos los países en que los arroje."
,"11":"Y mandaré contra ellos la espada, el hambre y la peste, hasta que hayan desaparecido del suelo que di a ellos y a sus padres'."
}`)
	CurrentBook.AddChapter(25, `{
"1":"Palabra que fue dirigida a Jeremías acerca de todo el pueblo de Judá el año cuarto de Joaquín, hijo de Josías, rey de Judá, esto es, el año primero de Nabucodonosor, rey de Babilonia."
,"2":"El profeta Jeremías se la comunicó a todo el pueblo de Judá y a todos los habitantes de Jerusalén, diciendo:"
,"3":"'Hace ya veintitrés años, desde el año trece de Josías, hijo de Amón, rey de Judá, hasta el día de hoy, que se me viene dirigiendo la palabra del Señor y que, sin descanso, yo os la he anunciado, pero vosotros no habéis escuchado."
,"4":"El Señor, además, os ha enviado a todos sus siervos, los profetas, sin interrupción, y vosotros no habéis escuchado ni habéis hecho caso."
,"5":"Os he dicho: Convertíos cada uno de vuestra mala conducta y de vuestras perversas acciones, y viviréis en la tierra que el Señor os dio a vosotros y a vuestros padres desde siempre y para siempre."
,"6":"No corráis en pos de dioses extraños para servirlos y adorarlos; no provoquéis mi cólera con las obras de vuestras manos, y yo no os haré ningún mal."
,"7":"Pero no me habéis escuchado -dice el Señor-, sino que me habéis irritado con las obras de vuestras manos para desgracia vuestra."
,"8":"Por tanto, esto dice el Señor todopoderoso: Por no haber escuchado vosotros mis palabras,"
,"9":"yo mando a buscar a todas las tribus del norte -dice el Señor- y a Nabucodonosor, rey de Babilonia, mi siervo, y los traeré contra este país, contra sus habitantes y contra todas estas naciones de los contornos; las aniquilaré y las dejaré convertidas en objeto de horror, de escarnio y de oprobio perpetuo."
,"10":"Haré desaparecer de entre ellos los gritos de alegría y algazara, el canto del esposo y de la esposa, el ruido del molino y la luz de la lámpara."
,"11":"Todo este país será convertido en ruinas, en desolación, y permanecerán en esclavitud entre las naciones durante setenta años."
,"12":"Al cabo de estos setenta años yo castigaré al rey de Babilonia y a aquella nación -dice el Señor- por sus crímenes, así como al país de los caldeos, y haré de él una desolación eterna."
,"13":"Ejecutaré con este país todas las cosas que he predicho contra él, todo lo que está escrito en este libro: lo que Jeremías profetizó contra todas las naciones."
,"14":"Ellas serán subyugadas por naciones poderosas y reyes poderosos, y yo les pagaré según sus actos y según las obras de sus manos'."
,"15":"El Señor, Dios de Israel, me dijo: 'Toma de mi mano esta copa de vino y dásela a beber a todas las naciones a las que yo te mando,"
,"16":"para que beban y se tambaleen y deliren ante la espada que yo voy a mandar en medio de ellos'."
,"17":"Tomé la copa de la mano del Señor y se la di a beber a todas las naciones a las que el Señor me había mandado:"
,"18":"a Jerusalén, a las ciudades de Judá, a sus reyes, a sus príncipes, para hacer de todo ello un desierto, un horror, un objeto de escarnio, una maldición, como es la condición actual;"
,"19":"al Faraón, rey de Egipto, a sus ministros, a sus servidores y a todo el pueblo,"
,"20":"así como a todo el conjunto de los extranjeros; a todos los reyes del país de Us, a todos los reyes del país de los filisteos: Ascalón, Gaza, Ecrón y a lo que queda de Asdod;"
,"21":"a Edón, a Moab, a Amón,"
,"22":"a todos los reyes de Tiro, a todos los reyes de Sidón y a los reyes de las islas del otro lado del mar;"
,"23":"a Dedán, a Temá, a Buz y a todos los que se afeitan las sienes;"
,"24":"a todos los reyes de Arabia y de los que viven en el desierto;"
,"25":"a todos los reyes de Zimrí, a todos los reyes de Elán y a todos los reyes de Media;"
,"26":"a todos los reyes del norte, próximos y lejanos, uno detrás de otro, a todos los reinos de la tierra. El rey de Sesac beberá después de ellos."
,"27":"Y les dirás: 'Esto dice el Señor todopoderoso, Dios de Israel: ¡Bebed, emborrachaos, vomitad, caed para no levantaros más bajo la espada que yo voy a enviar en medio de vosotros'."
,"28":"Y si se niegan a tomar de tu mano la copa y a beber, les dirás: 'Esto dice el Señor todopoderoso: ¡La beberéis sin remedio!"
,"29":"Porque si estáis viendo que es en la ciudad que lleva mi nombre donde comienzo a desencadenar el mal, ¿vais a quedar vosotros sin castigo? No quedaréis, porque yo convoco la espada contra todos los habitantes de la tierra' -dice el Señor-."
,"30":"Y tú anúnciales todas estas palabras y diles: El Señor ruge desde lo alto, desde su santa morada lanza su voz; ruge con fuerza contra su hacienda, lanza el grito de júbilo de los pisadores de la uva contra todos los habitantes de la tierra."
,"31":"Llega el estruendo hasta el extremo de la tierra, porque el Señor entabla un proceso contra las naciones, entra en juicio contra todos los mortales; a los criminales los entrega a la espada -dice el Señor-."
,"32":"Esto dice el Señor omnipotente: La desgracia va pasando de pueblo en pueblo, y una enorme tempestad se desencadena hasta los confines de la tierra."
,"33":"Y habrá aquel día víctimas del Señor de un extremo a otro de la tierra; no serán lloradas, ni recogidas, ni sepultadas; quedarán en el suelo como estiércol."
,"34":"¡Gritad, pastores; gritad, revolcaos en la tierra, mayorales del rebaño, porque ha llegado el día de vuestra matanza; caeréis como carneros escogidos!"
,"35":"No hay ya evasión para los pastores, ni salvación para los mayorales del rebaño."
,"36":"Escuchad el clamor de los pastores, el griterío de los mayorales del rebaño, porque el Señor devasta sus pastos."
,"37":"Quedan desoladas las tranquilas praderías ante el ardor de la ira del Señor."
,"38":"El león ha abandonado su guarida, su tierra se ha convertido en un desierto ante la espada destructora, ante el ardor de la ira del Señor."
}`)
	CurrentBook.AddChapter(26, `{
"1":"Al comienzo del reinado de Joaquín, hijo de Josías, rey de Judá, me fue dirigida esta palabra de parte del Señor:"
,"2":"Esto dice el Señor: 'Vete al atrio del templo del Señor y anuncia a todos los habitantes de las ciudades de Judá que vienen a prosternarse en el templo del Señor todo lo que yo te he ordenado decirles, sin omitir una sola palabra."
,"3":"Tal vez te escuchen y se conviertan cada uno de su mal camino; entonces yo retiraré el castigo que pensaba darles por sus malas acciones."
,"4":"Les dirás: Esto dice el Señor: Si no me hacéis caso, siguiendo la ley que yo os prescribo,"
,"5":"y no escucháis las palabras de mis siervos los profetas que yo os envío incesantemente y a quienes no habéis escuchado,"
,"6":"trataré a este templo como a Silo y haré de esta ciudad una maldición para todas las naciones de la tierra'."
,"7":"Los sacerdotes, los profetas y todo el pueblo oyeron a Jeremías pronunciar estas palabras en el templo del Señor."
,"8":"Y en cuanto Jeremías terminó de decir lo que el Señor le había ordenado comunicar a todo el pueblo, los sacerdotes y los profetas lo apresaron, diciendo: '¡Vas a morir!"
,"9":"¿Por qué has profetizado en nombre del Señor diciendo que este templo será como Silo, y que esta ciudad quedará desolada y despoblada?'. Y todo el pueblo se apelotonó contra Jeremías en el templo del Señor."
,"10":"Al enterarse de ello los magistrados de Judá, subieron desde el palacio real al templo del Señor y se sentaron a la entrada de la puerta nueva del templo."
,"11":"Los sacerdotes y los profetas dijeron a los magistrados y a todo el pueblo: 'Este hombre debe ser condenado a muerte porque ha profetizado contra la ciudad, como habéis escuchado con vuestros propios oídos'."
,"12":"Entonces Jeremías se dirigió a todos los magistrados y al pueblo entero, diciendo: 'El Señor me ha enviado a profetizar acerca de este templo y de esta ciudad todo lo que habéis oído."
,"13":"Así, pues, enmendad vuestra conducta y vuestra manera de obrar, escuchad la llamada del Señor, vuestro Dios, y el Señor retirará la desgracia con que os ha amenazado."
,"14":"En cuanto a mí, en vuestras manos estoy: haced de mí lo que queráis y os parezca justo;"
,"15":"pero pensad y tened en cuenta que, si me matáis, derramaréis sangre inocente sobre vosotros mismos, sobre esta ciudad y sus habitantes, porque es verdad que el Señor me ha mandado a vosotros a pronunciar todas estas palabras para que las escuchéis'."
,"16":"Entonces los magistrados y el pueblo entero dijeron a los sacerdotes y a los profetas: 'Este hombre no debe ser condenado a muerte, porque nos ha hablado en el nombre del Señor, nuestro Dios'."
,"17":"Es que se habían levantado algunos de entre los ancianos del país y habían dicho a la multitud congregada:"
,"18":"'Miqueas de Morasti, que profetizaba en tiempos de Ezequías, rey de Judá, dijo también a todo el pueblo de Judá: Esto dice el Señor todopoderoso: Sión será arada como un campo, Jerusalén se convertirá en un montón de piedras, y el monte del templo en una selva."
,"19":"¿Acaso por eso le condenaron a muerte Ezequías, rey de Judá, y todo Judá? ¿No temieron más bien al Señor; no imploraron su gracia, hasta obtener que retirara la desgracia con que les había amenazado? ¿Y vamos nosotros a cargar con un delito tan grave?'."
,"20":"Hubo también otro hombre que profetizaba en nombre del Señor: Urías, hijo de Semayas, de Quiriat Yearín; él profetizó contra esta ciudad y este país exactamente lo mismo que Jeremías."
,"21":"El rey Joaquín, con todos los oficiales y magistrados, al oír sus palabras trató de darle muerte. Urías se enteró de ello y atemorizado huyó a Egipto."
,"22":"Pero el rey Joaquín mandó algunos hombres a Egipto: Elnatán, hijo de Acbor, con otros cuantos,"
,"23":"los cuales sacaron de Egipto a Urías y lo condujeron al rey Joaquín, quien le mandó matar a espada y arrojar el cadáver a la fosa común."
,"24":"En cuanto a Jeremías, fue protegido por Ajicán, hijo de Safán, y así no fue entregado en manos del pueblo para darle muerte."
}`)
	CurrentBook.AddChapter(27, `{
"1":"Al comienzo del reinado de Sedecías, hijo de Josías, rey de Judá, fue dirigida a Jeremías de parte del Señor esta palabra."
,"2":"'El Señor me ha dicho esto: Hazte unas coyundas y un yugo y póntelo en tu cuello."
,"3":"Luego se las enviarás al rey de Edón, al rey de Moab, al rey de los amonitas, al rey de Tiro y al rey de Sidón, por medio de los embajadores que han venido a Jerusalén cerca de Sedecías, rey de Judá."
,"4":"Encárgales que digan a sus soberanos: Esto dice el Señor todopoderoso, Dios de Israel: He aquí lo que diréis a vuestros soberanos:"
,"5":"Yo, con mi gran fuerza y desplegando mi poder he hecho la tierra, los hombres y los animales que existen sobre ella, y se la doy a quien quiero."
,"6":"Ahora, he entregado todos estos países en manos de mi siervo Nabucodonosor, rey de Babilonia, y he puesto a su servicio incluso las bestias del campo."
,"7":"Todas las naciones estarán sujetas a él, a su hijo y a su nieto, hasta que le llegue la hora también a su país; entonces lo subyugarán muchas naciones y reyes poderosos."
,"8":"Pero antes la nación y el reino que no se someta a Nabucodonosor, rey de Babilonia, y no ofrezca su cuello al yugo del rey de Babilonia, serán castigados por mí con espada, hambre y peste -dice el Señor-, hasta que los ponga en sus manos."
,"9":"No hagáis caso, por tanto, a vuestros profetas, adivinos, soñadores, agoreros y magos que os dicen: 'Vosotros no serviréis al rey de Babilonia'."
,"10":"Mentira tan sólo os profetizan, cuyo resultado será que os harán salir de vuestra tierra, que yo os disperse y perezcáis."
,"11":"Pero a la nación que doble el cuello bajo el yugo del rey de Babilonia y se someta a él, yo la dejaré en paz en su tierra -dice el Señor-, la cultivará y vivirá en ella'."
,"12":"En los mismos términos hablé también a Sedecías, rey de Judá. Le dije: 'Ofreced vuestro cuello al yugo del rey de Babilonia; someteos a él y a su pueblo, y viviréis."
,"13":"¿Por qué tú y tu pueblo queréis exponeros a morir a espada, de hambre y de peste, como ha anunciado el Señor a la nación que se niegue a someterse al rey de Babilonia?"
,"14":"No escuchéis las palabras de esos profetas que os dicen: No serviréis al rey de Babilonia, porque sólo mentiras os profetizan."
,"15":"Pues yo no los he enviado -dice el Señor-; usurpan mi nombre para profetizar mentiras, y el resultado será que yo os dispersaré y pereceréis vosotros y los profetas que os profetizan'."
,"16":"Y a los sacerdotes y a todo este pueblo les dije: 'Esto dice el Señor: No escuchéis las palabras de esos profetas que os dicen: Pronto volverán de Babilonia los utensilios del templo del Señor, pues es mentira lo que os dicen."
,"17":"No los escuchéis; someteos al rey de Babilonia y viviréis. ¿Por qué esta ciudad ha de convertirse en un montón de ruinas?"
,"18":"Si fuesen profetas, si poseyesen la palabra del Señor, intercederían ante el Señor todopoderoso para que los utensilios que quedan aún en el templo del Señor, en el palacio real de Judá y en Jerusalén no vayan a parar a Babilonia."
,"19":"Pues así habla el Señor todopoderoso acerca de las columnas, del mar, de las basas y de los demás utensilios que quedan aún en esta ciudad"
,"20":"y que Nabucodonosor, rey de Babilonia, no se llevó cuando deportó de Jerusalén a Babilonia a Jeconías, hijo de Joaquín, rey de Judá, y a todos los principales de Judá y Jerusalén."
,"21":"Sí, esto dice el Señor todopoderoso, Dios de Israel, respecto de los utensilios que han quedado en el templo del Señor, en el palacio real de Judá y en Jerusalén:"
,"22":"Serán transportados a Babilonia, y allí estarán hasta el día en que yo me ocupe de ellos -dice el Señor-, en que yo los haré devolver a este lugar'."
}`)
	CurrentBook.AddChapter(28, `{
"1":"Aquel mismo año, al comienzo del reinado de Sedecías, rey de Judá, el quinto mes del año cuarto, el profeta Ananías, hijo de Azur, natural de Gabaón, me dijo en el templo del Señor delante de los sacerdotes y de todo el pueblo:"
,"2":"Esto dice el Señor todopoderoso, Dios de Israel: '¡Yo he roto el yugo del rey de Babilonia!"
,"3":"Dentro de dos años haré devolver a este lugar todos los utensilios del templo del Señor, que Nabucodonosor, rey de Babilonia, se llevó de este lugar a Babilonia."
,"4":"Haré también regresar a este lugar a Jeconías, hijo de Joaquín, rey de Judá, y a todos los cautivos de Judá que fueron a Babilonia -dice el Señor-. Sí, yo romperé el yugo del rey de Babilonia'."
,"5":"Entonces el profeta Jeremías respondió al profeta Ananías delante de los sacerdotes y de todo el pueblo presente en el templo del Señor."
,"6":"El profeta Jeremías dijo: '¡Amén! ¡El Señor haga que se cumplan las palabras de tu profecía, devolviendo de Babilonia a este lugar todos los utensilios del templo del Señor y a todos los cautivos!"
,"7":"De todas formas, escucha bien la palabra que voy a pronunciar a tus oídos y delante de todo el pueblo."
,"8":"Los profetas que nos han precedido a ti y a mí ya desde antiguo predijeron a muchos países y a grandes reinos guerra, hambre y peste."
,"9":"Un profeta que profetiza la paz será reconocido por verdadero profeta mandado por el Señor si se realiza todo lo que ha profetizado'."
,"10":"Entonces el profeta Ananías tomó el yugo del cuello de Jeremías, lo rompió"
,"11":"y dijo delante de todo el pueblo: 'Esto dice el Señor: De la misma manera, dentro de dos años, romperé yo el yugo de Nabucodonosor, rey de Babilonia, quitándolo del cuello de todas las naciones'. Y el profeta Jeremías se marchó."
,"12":"Después que el profeta Ananías rompió el yugo del cuello del profeta Jeremías, el Señor dirigió su palabra a Jeremías:"
,"13":"'Vete a decir a Ananías: Esto dice el Señor: Has roto el yugo de madera, pero lo tendrás que sustituir con un yugo de hierro."
,"14":"Pues esto dice el Señor todopoderoso, Dios de Israel: Un yugo de hierro pongo al cuello de todas estas naciones para someterlas a Nabucodonosor, rey de Babilonia; y estarán sometidas a él, así como las bestias del campo, que también le he entregado'."
,"15":"Y el profeta Jeremías dijo al profeta Ananías: 'Escucha bien, Ananías: El Señor no te ha enviado, y tú has hecho que este pueblo crea en la mentira."
,"16":"Por tanto, esto dice el Señor: Te voy a quitar de la faz de la tierra; este año vas a morir por haber predicado la rebelión contra el Señor'."
,"17":"Y aquel año, en el mes séptimo, murió el profeta Ananías."
}`)
	CurrentBook.AddChapter(29, `{
"1":"He aquí el texto de la carta que el profeta Jeremías envió desde Jerusalén a los ancianos de la cautividad, a los sacerdotes, a los profetas y a todo el pueblo que Nabucodonosor había deportado de Jerusalén a Babilonia,"
,"2":"después de partir de Jerusalén el rey Jeconías y la reina madre, los eunucos, los príncipes de Judá y de Jerusalén, los herreros y los cerrajeros."
,"3":"La carta fue llevada por Elasa, hijo de Safán, y Gamarías, hijo de Jelcías, a quienes Sedecías, rey de Judá, había enviado a Babilonia, donde Nabucodonosor, rey de Babilonia. Decía:"
,"4":"'Esto dice el Señor todopoderoso, Dios de Israel, a todos los cautivos deportados de Jerusalén a Babilonia:"
,"5":"Edificad casas y habitadlas, plantad huertos y comed su fruto,"
,"6":"casaos y engendrad hijos e hijas, tomad mujer para vuestros hijos, casad a vuestras hijas para que tengan hijos e hijas, multiplicaos ahí, no disminuya vuestro número."
,"7":"Procurad el bien de la nación adonde yo os he deportado y rogad por ella al Señor, porque su prosperidad será también la vuestra."
,"8":"Porque esto dice el Señor todopoderoso, Dios de Israel: No os dejéis engañar por los profetas que están entre vosotros, ni por vuestros adivinos; no hagáis caso de los sueños que os cuentan,"
,"9":"porque no es verdad que os hablen en mi nombre. Yo no los he mandado -dice el Señor-."
,"10":"Esto dice el Señor: Cuando terminen los setenta años concedidos a Babilonia, yo me ocuparé de vosotros y cumpliré en vosotros mi promesa de restituiros a este lugar."
,"11":"Porque yo sé bien los proyectos que tengo sobre vosotros -dice el Señor-, proyectos de prosperidad y no de desgracia, de daros un porvenir lleno de esperanza."
,"12":"Entonces, cuando me invoquéis y me dirijáis vuestras súplicas, yo os escucharé."
,"13":"Me buscaréis y me hallaréis, porque me habréis buscado de todo corazón."
,"14":"Yo me dejaré encontrar por vosotros -dice el Señor-; cambiaré vuestra suerte y os reuniré de todos los países y de todos los lugares por los que os he dispersado -dice el Señor-. Os volveré a traer a este lugar de donde os desterré."
,"15":"Me diréis: El Señor nos ha suscitado profetas en Babilonia."
,"16":"Pues bien, esto dice el Señor acerca del rey que se sienta en el trono de David y de todo el pueblo que habita esta ciudad, hermanos vuestros que no fueron deportados como vosotros."
,"17":"Esto dice el Señor todopoderoso: Yo voy a mandar contra ellos la espada, el hambre y la peste; los convertiré en higos malos, que de malos no se puedan comer."
,"18":"Los perseguiré con la espada, el hambre y la peste; los dejaré hechos un horror para todos los reinos de la tierra, maldición, espanto, escarnio y oprobio de todas las naciones en que los dispersé,"
,"19":"por no haber escuchado mis palabras -dice el Señor-, que yo les he dirigido por medio de los profetas, mis siervos; se los he enviado incesantemente, y no los han escuchado -dice el Señor-."
,"20":"Pero vosotros, todos los desterrados que mandé de Jerusalén a Babilonia, escuchad la palabra del Señor."
,"21":"Esto dice el Señor todopoderoso, Dios de Israel, acerca de Ajab, hijo de Colayas, y de Sedecías, hijo de Masías, que os profetizan mentiras en mi nombre: 'Yo los entregaré en manos de Nabucodonosor, rey de Babilonia, que les dará muerte a vuestros mismos ojos."
,"22":"Y quedarán como tipo de maldición entre todos los desterrados de Judá que están en Babilonia, los cuales dirán: El Señor haga contigo como con Sedecías y con Ajab, a quienes el rey de Babilonia tostó al fuego."
,"23":"Porque hicieron algo que es una infamia en Israel: cometieron adulterio con mujeres de otros y pronunciaron en mi nombre palabras falsas, cosas no ordenadas por mí. Yo lo sé muy bien y soy testigo de ello -dice el Señor-'."
,"24":"Y acerca de Semayas, el nejlamita, esto dice el Señor todopoderoso, Dios de Israel:"
,"25":"'Tú has enviado, por su propia cuenta, cartas a todo el pueblo que está en Jerusalén; al sacerdote Sofonías, hijo de Masayas y a todos los sacerdotes, diciendo:"
,"26":"El Señor te ha constituido sacerdote en lugar de Yehoyadá, para que ejerzas la inspección en el templo del Señor sobre todo aquel que se las dé de profeta y le metas en el cepo y en prisión."
,"27":"¿Por qué, pues, no has prohibido actuar a Jeremías de Anatot, que se hace pasar por profeta entre vosotros?"
,"28":"Pues nos ha remitido a Babilonia este mensaje: La cosa va para largo; edificaos casas y habitadlas, plantad huertos y comed sus frutos'."
,"29":"El sacerdote Sofonías había dado lectura de esta carta del profeta Jeremías."
,"30":"Entonces la palabra del Señor fue dirigida a Jeremías en estos términos:"
,"31":"'Manda a decir a todos los desterrados: Esto dice el Señor acerca de Semayas, el nejlamita: Porque Semayas os ha profetizado sin que yo le haya mandado y os ha hecho creer en la mentira,"
,"32":"por eso, esto dice el Señor: Yo castigaré a Semayas de Nejelán y a su descendencia. Ninguno de los suyos habitará en medio de este pueblo, ni verá el bien que yo voy a hacer a mi pueblo -dice el Señor-, por haber predicado la rebeldía contra el Señor'."
}`)
	CurrentBook.AddChapter(30, `{
"1":"Palabra que el Señor dirigió a Jeremías:"
,"2":"'Esto dice el Señor, Dios de Israel: Escribe en un libro todas las palabras que yo te he dicho."
,"3":"Porque vienen días -dice el Señor- en que haré volver a los desterrados de mi pueblo, Israel y Judá -dice el Señor-; los haré volver a la tierra que di a sus padres, y la poseerán'."
,"4":"He aquí las palabras que ha pronunciado el Señor acerca de Israel y Judá."
,"5":"Esto dice el Señor: Un grito de terror se ha oído, espanto, que no paz."
,"6":"Preguntad y mirad: ¿puede dar a luz un varón? ¿Por qué, si no, veo a todo hombre con las manos en las caderas como mujer en parto? ¿Por qué todos los rostros descompuestos, lívidos?"
,"7":"¡Ay! Porque es grande este día y ningún otro lo iguala. Tiempo de angustia para Jacob, pero del que será liberado."
,"8":"Aquel día -dice el Señor todopoderoso- yo quebraré el yugo que pesa sobre el cuello y romperé sus coyundas. No estarán más sometidos a extranjeros,"
,"9":"sino que servirán al Señor, su Dios, y a David, su rey, que yo les suscitaré."
,"10":"Y tú, siervo mío Jacob, no temas -dice el Señor-; no te espantes, Israel; yo te sacaré de tierras lejanas, y a tu descendencia, del país de su destierro. Jacob volverá a vivir,tranquilo y en paz, sin que nadie lo inquiete."
,"11":"Porque yo estoy contigo,-dice el Señor- para salvarte. Aniquilaré a todas las naciones,entre las que te he dispersado. A ti no te aniquilaré; sólo te castigaré como mereces,y no te dejaré pasar nada."
,"12":"Esto dice el Señor: Tu herida es incurable, insanable tu llaga."
,"13":"Nadie se cuida de tu dolencia, no hay remedio que te pueda curar."
,"14":"Todos tus amantes te han olvidado, ya no se interesan por ti. Sí, yo te he herido como hiere un enemigo, con castigo cruel, por tus innumerables crímenes, por tus pecados incontables."
,"15":"¿Por qué gritas por tu herida?,Incurable es tu dolor. Por tu enorme iniquidad, por tus delitos incontables,te he hecho esto."
,"16":"Pero todos los que te devoran,serán devorados, todos tus opresores,irán al destierro, todos tus despojadores,serán despojados,y todos tus saqueadores,serán saqueados."
,"17":"Sí, yo te devolveré la salud, yo curaré tus heridas,-dice el Señor-, porque te han llamado la Abandonada, Sión, de quien nadie se cuida."
,"18":"Esto dice el Señor: Yo restableceré las tiendas de Jacob, tendré compasión de sus moradas. Será reedificada la ciudad,sobre sus ruinas, y el palacio se elevará,en su antiguo lugar."
,"19":"Y allí resonarán los cantos de alabanza,y los gritos de alegría. Los multiplicaré y ya no menguarán, los ensalzaré en lugar de humillarlos."
,"20":"Serán sus hijos como antaño, su comunidad será estable ante mí, y castigaré a todos sus opresores."
,"21":"De su seno saldrá su caudillo, de en medio de ella surgirá su soberano. Le dará audiencia, y se acercará a mí; pues ¿quién, si no, arriesgaría su vida,para acercarse a mí?,-dice el Señor-."
,"22":"Vosotros seréis mi pueblo,y yo seré vuestro Dios."
,"23":"El huracán del Señor se desata, una tempestad se desencadena; sobre la cabeza de los criminales,se precipita."
,"24":"No se calmará la ira del Señor,hasta que haya ejecutado,y realizado los planes de su mente. Más tarde lo comprenderéis."
}`)
	CurrentBook.AddChapter(31, `{
"1":"En aquel tiempo -dice el Señor-,yo seré el Dios,de todas las familias de Israel,y ellos serán mi pueblo."
,"2":"Esto dice el Señor: Ha hallado gracia,en el desierto,el pueblo escapado de la espada. Israel se dirige a su descanso."
,"3":"De lejos el Señor se le ha aparecido. Con amor eterno te he amado, por eso te trato con lealtad."
,"4":"Te construiré de nuevo,y serás reconstruida, oh virgen de Israel. De nuevo te adornarás con tus panderos,y saldrás a danzar gozosamente."
,"5":"De nuevo plantarás viñas,en los montes de Samaría, plantarán los plantadores y cosecharán."
,"6":"Sí, vendrá un día,en que los centinelas gritarán,en la montaña de Efraín: '¡Levantaos, subamos a Sión, hacia el Señor, nuestro Dios!'."
,"7":"Esto dice el Señor: ¡Gritad de gozo por Jacob, aclamad a la primera de las naciones!,¡Publicad, alabad, decid: El Señor ha librado a su pueblo, al resto de Israel!"
,"8":"Yo los traigo de la tierra del norte,y los congrego de los extremos de la tierra; están todos: el cojo y el ciego, la embarazada y la parturienta, una gran multitud que vuelve aquí."
,"9":"Entre lágrimas habían partido, entre consuelos los devuelvo,junto a los arroyos de las aguas, por un camino llano, donde no dan traspiés. Pues soy un padre para Israel, Efraín es mi primogénito."
,"10":"Naciones, escuchad la palabra del Señor, y anunciadla en las islas lejanas; decid: 'El que dispersó a Israel lo reúne, lo guarda como un pastor su rebaño'."
,"11":"Sí, el Señor ha reivindicado Jacob, lo ha librado de una mano más fuerte."
,"12":"Y vendrán cantando de alegría,a la altura de Sión, volverán a gozar,de los bienes del Señor: el trigo, el vino y el aceite, las ovejas y los bueyes. Su alma será un huerto bien regado,y no volverán ya a languidecer."
,"13":"Entonces las jóvenes,se alegrarán bailando, jóvenes y viejos vivirán felices; cambiaré su luto en alegría; los consolaré, los alegraré después de su dolor."
,"14":"Saciaré a los sacerdotes,con la mejor comida, y mi pueblo se hartará de mis bienes,-dice el Señor-."
,"15":"Esto dice el Señor: Un grito se ha oído en Ramá, un lamento, llanto amargo: es Raquel, que llora a sus hijos, y no quiere consolarse de sus hijos,porque ya no existen."
,"16":"Esto dice el Señor: Deja de lamentarte, seca el llanto de tus ojos, porque hay compensación para tu pena: volverán del país enemigo."
,"17":"Hay esperanza para tu descendencia: tus hijos volverán a su tierra."
,"18":"Escucho, escucho el lamento de Efraín: 'Me has castigado, y he sufrido el castigo,como novillo indómito; haz que vuelva y volveré, pues tú eres el Señor, mi Dios."
,"19":"Sí, después de mi desvío,me has arrepentido, he comprendido,y me he golpeado el pecho. Estoy humillado, lleno de vergüenza; mi juventud ha sido un escándalo, y ahora soporto las consecuencias'."
,"20":"¿Es para mí Efraín un hijo tan querido, un niño que hace mis delicias?,Pues cada vez que lo amenazo,me vuelvo a acordar de él, se me conmueven las entrañas,y tengo compasión de él,-dice el Señor-."
,"21":"Pon mojones, coloca señales, marca bien la ruta, el camino que ya anduviste. Vuelve, virgen de Israel, vuelve a estas ciudades, que son tuyas."
,"22":"¿Hasta cuándo andarás lejos, hija rebelde?,Pues el Señor crea una cosa nueva en la tierra: la mujer rodeará al varón."
,"23":"Esto dice el Señor todopoderoso, Dios de Israel: Todavía ha de emplearse esta expresión en la tierra de Judá y en sus ciudades cuando mejore yo su suerte: '¡Que el Señor te bendiga, sede de justicia, monte santo!'."
,"24":"En esta tierra habitarán Judá y todas sus ciudades, los labradores y los pastores."
,"25":"Porque yo daré de beber a los sedientos y saciaré a los que se mueren de hambre."
,"26":"En esto, me desperté y abrí los ojos. Mi sueño había sido agradable."
,"27":"Vienen días -dice el Señor- en que yo sembraré en la casa de Israel y en la casa de Judá simiente de hombres y simiente de animales."
,"28":"Y así como he vigilado sobre ellos para devastar, para derruir, para demoler, para aniquilar y para afligir, así también vigilaré sobre ellos para edificar y plantar -dice el Señor-."
,"29":"En aquellos días no se dirá ya: 'Los padres comieron agraces, y los dientes de los hijos sufren la dentera',"
,"30":"sino que cada cual morirá por su propia iniquidad. El que coma agraces será el que sufra la dentera."
,"31":"Vienen días -dice el Señor- en que yo haré con la casa de Israel y la casa de Judá una alianza nueva."
,"32":"No como la alianza que hice con sus padres cuando los tomé de la mano y los saqué del país de Egipto, alianza que ellos violaron, por lo cual los rechacé -dice el Señor-."
,"33":"Ésta es la alianza que haré con la casa de Israel después de aquellos días -dice el Señor-: pondré mi ley en su interior, la escribiré en su corazón, y seré su Dios y ellos serán mi pueblo."
,"34":"No tendrán ya que instruirse mutuamente, diciéndose unos a otros: '¡Conoced al Señor!', pues todos me conocerán, desde el más pequeño al mayor -dice el Señor-, porque perdonaré su crimen y no me acordaré más de sus pecados."
,"35":"Esto dice el Señor, el que establece el sol,para alumbrar el día, la luna y las estrellas,para alumbrar la noche, el que agita el mar,y hace bramar sus olas, cuyo nombre es 'el Señor todopoderoso'."
,"36":"Si dejaran de valer a,quellas leyes ante mí,-dice el Señor-, entonces la casa de Israel,dejará también de ser una nación,ante mí para siempre."
,"37":"Esto dice el Señor: Si pudieran medirse los cielos,allá arriba,y sondearse por abajo,los cimientos de la tierra, también yo rechazaría,a la casa de Israel,por todo lo que ha hecho,-dice el Señor-."
,"38":"Vienen días -dice el Señor- en que será reedificada la ciudad del Señor desde la torre de Jananel hasta la puerta del Ángulo."
,"39":"E incluso hasta la colina de Gareb se tirará el cordel de medir, para volver luego hacia Goa."
,"40":"Y todo el valle de los cadáveres y de la ceniza, así como todos los campos a lo largo del torrente Cedrón, hasta el ángulo de la puerta de los Caballos por oriente, serán consagrados al Señor; no volverán a ser destruidos ni devastados jamás."
}`)
	CurrentBook.AddChapter(32, `{
"1":"Palabra que el Señor dirigió a Jeremías el año décimo de Sedecías, rey de Judá, esto es, el año dieciocho de Nabucodonosor."
,"2":"El ejército del rey de Babilonia estaba a la sazón asediando a Jerusalén, y el profeta Jeremías estaba detenido en el patio de la cárcel del palacio real de Judá,"
,"3":"donde le había mandado encerrar el rey Sedecías con esta acusación: '¿Por qué andas profetizando y proclamando: Esto dice el Señor: Yo entregaré esta ciudad en manos del rey de Babilonia, quien la tomará;"
,"4":"y Sedecías, rey de Judá, no escapará de las manos de los caldeos, sino que caerá sin remedio en manos del rey de Babilonia, que podrá hablar con él cara a cara y sus ojos verán los ojos de él,"
,"5":"y conducirá a Sedecías a Babilonia, donde estará hasta que yo me ocupe de él -dice el Señor-. Si vosotros combatís contra los caldeos, no tendréis éxito?'."
,"6":"Jeremías respondió: La palabra del Señor me ha sido dirigida en estos términos:"
,"7":"'Mira, Janamel, hijo de tu tío Salún, vendrá a decirte: Cómprame el campo que tengo en Anatot, puesto que tú tienes el derecho de rescate para adquirirlo'."
,"8":"En efecto, conforme a la palabra del Señor, Janamel, mi primo, vino a verme, al patio de la prisión, y me dijo: 'Compra el campo que tengo en Anatot, en la tierra de Benjamín, porque tú tienes el derecho de propiedad y el de rescate para adquirirlo'. Comprendí que era una orden del Señor,"
,"9":"y compré a mi primo Janamel el campo de Anatot, y le pagué el precio: diecisiete monedas de plata."
,"10":"Redacté el contrato, lo sellé en presencia de los testigos que había buscado y pesé el dinero en la balanza."
,"11":"Luego tomé el contrato de compra, la copia sellada y la abierta, según las prescripciones de la ley,"
,"12":"y entregué el acta de compra a Baruc, hijo de Nerías, hijo de Majsías, en presencia de mi primo Janamel, de los testigos que habían firmado el acta de compra y en presencia de todos los judíos que se encontraban en el patio de la prisión."
,"13":"Delante de ellos di este encargo a Baruc:"
,"14":"sto dice el Señor todopoderoso, Dios de Israel: Toma estos documentos, este contrato de compra sellado y esta copia abierta y mételos en una vasija de barro, a fin de que puedan conservarse mucho tiempo."
,"15":"Porque esto dice el Señor todopoderoso, Dios de Israel: Aún se comprarán casas, campos y viñas en este país."
,"16":"Después de haber entregado a Baruc, hijo de Nerías, el contrato de compra, hice al Señor esta súplica:"
,"17":"'Señor Dios, tú has creado el cielo y la tierra con tu gran fuerza y desplegando tu poder. ¡Nada hay imposible para ti!"
,"18":"Tú otorgas tu favor a millares de generaciones y castigas la iniquidad de los padres tan sólo en los hijos que vienen después de ellos, Dios grande y poderoso, que te llamas 'el Señor todopoderoso',"
,"19":"grande en tus consejos, poderoso en tus obras. Tus ojos están abiertos sobre todos los caminos de los humanos para retribuir a cada uno según su conducta y según el fruto de sus obras."
,"20":"Tú realizaste maravillas y prodigios en Egipto y luego en Israel y entre todos los hombres hasta el día de hoy, y te has hecho famoso."
,"21":"Tú sacaste a tu pueblo Israel de Egipto, entre maravillas y prodigios, con la fuerza de tu mano, y desplegando tu poder e infundiendo gran terror."
,"22":"Y les diste este país, conforme habías jurado a sus padres, tierra que mana leche y miel."
,"23":"Ellos entraron y tomaron posesión de ella; pero luego no escucharon tu voz ni caminaron según tu ley; no hicieron nada de cuanto les habías ordenado, y por eso has traído contra ellos toda esta desventura."
,"24":"Mira, los terraplenes que han levantado para el asalto alcanzan ya la ciudad, y la ciudad va a ser entregada en manos de los caldeos, que la atacan con la espada, el hambre y la peste. Todo lo que has anunciado se está verificando, y tú lo ves."
,"25":"A pesar de todo, tú, oh Señor Dios, me dices: Compra por dinero este campo y toma testigos, mientras la ciudad cae en manos de los caldeos'."
,"26":"Entonces el Señor dirigió su palabra a Jeremías:"
,"27":"'Mira, yo soy el Señor, el Dios de todos los mortales. ¿Qué puede haber imposible para mí?"
,"28":"Por tanto, esto dice el Señor: Voy a entregar esta ciudad en manos de los caldeos y de Nabucodonosor, rey de Babilonia, quien la tomará."
,"29":"Los caldeos que están atacando esta ciudad vendrán y la prenderán fuego, incendiarán sus casas, sobre cuyas terrazas se han ofrecido sacrificios a Baal y se han hecho ofrendas a dioses extraños para irritarme."
,"30":"Porque el pueblo de Israel y el pueblo de Judá tan sólo han hecho desde su juventud lo que me desagrada; sí, los israelitas no han hecho más que irritarme con las obras de sus manos -dice el Señor-."
,"31":"Así esta ciudad se ha hecho el blanco de mi furor y de mi indignación desde el día en que se fundó hasta el día de hoy, y tendré que venir a hacerla desaparecer de mi vista"
,"32":"a causa de todas las iniquidades que el pueblo de Israel y el pueblo de Judá han cometido para irritarme, ellos y sus reyes, sus príncipes, sus sacerdotes, sus profetas, los hombres de Judá y los habitantes de Jerusalén."
,"33":"La espalda me han dado, y no la cara; y mientras yo trataba de instruirlos y educarlos con constancia y sin cesar, no han querido escuchar ni aceptar la lección."
,"34":"Hasta en el templo que lleva mi nombre han colocado sus ídolos detestables para profanarlo."
,"35":"Y han construido además los lugares de culto a Baal en el valle de Ben-Hinnón para sacrificar a sus hijos y a sus hijas a Moloc, cosa que yo no les había ordenado, ni había pasado jamás por mi mente que se cometiera tal horror para arrastrar a Judá al pecado."
,"36":"Mas ahora, y por la misma causa, esto dice el Señor, Dios de Israel, a propósito de esta ciudad, de la que vosotros decís: Por la espada, el hambre y la peste ha sido entregada en manos del rey de Babilonia:"
,"37":"Yo los recogeré de todos los países en que los he arrojado en mi cólera, mi furor y mi gran indignación. Los volveré a este lugar y haré que habiten en él con seguridad."
,"38":"Ellos serán mi pueblo y yo seré su Dios,"
,"39":"y les daré otro corazón y otro camino, para que me respeten siempre, en bien suyo y de sus hijos después de ellos."
,"40":"Y haré con ellos una alianza eterna: no cesaré de concederles favores, haré que me respeten y que no se aparten más de mí."
,"41":"Cifraré mi gozo en hacerles bien, los plantaré sólidamente en esta tierra, con todo mi corazón y con toda mi alma."
,"42":"Pues esto dice el Señor: 'Como he traído sobre este pueblo toda esta desventura, así traeré sobre ellos toda la ventura que les prometo'."
,"43":"Aún se comprarán campos en este país, del que afirmáis: 'Es un desierto sin hombres ni animales; ha caído en manos de los caldeos'."
,"44":"Se comprarán campos por dinero, se redactarán contratos, se los sellará y se tomarán testigos en el territorio de Benjamín, en los alrededores de Jerusalén y en las ciudades de Judá, en las de la montaña, en las del llano y en las del Negueb; porque haré cambiar su suerte -dice el Señor-'."
}`)
	CurrentBook.AddChapter(33, `{
"1":"Por segunda vez, estando todavía Jeremías detenido en el patio de la cárcel, le fue dirigida la palabra del Señor en estos términos:"
,"2":"'Así habla el Señor, el que creó la tierra, dándole forma y estabilidad; el Señor es su nombre."
,"3":"Llámame y te responderé, te comunicaré cosas grandes y ocultas, que tú desconoces."
,"4":"Porque esto dice el Señor, Dios de Israel, acerca de las casas de esta ciudad y de las casas de los reyes de Judá que van a ser destruidas. Ellas servirán de muros de defensa y de baluarte"
,"5":"para aquellos que vienen a combatir contra los caldeos. Pero esto no conducirá a otra cosa que a llenar la ciudad de los cadáveres de aquellos a quienes yo hiera en mi cólera y mi furor al retirar mi rostro de esta ciudad por motivo de toda su perversidad:"
,"6":"Yo les devolveré la salud, los curaré y sanaré y les haré ver abundancia de paz y seguridad."
,"7":"Cambiaré la suerte de Judá y la de Israel, y los restableceré como antes."
,"8":"Los purificaré de todos los crímenes que han cometido contra mí, les perdonaré todos los crímenes con los que me ofendieron y me despreciaron."
,"9":"Y todo ello me granjeará renombre, gozo, alabanza y gloria entre las naciones de la tierra que, al conocer todo el bien que yo he hecho a los míos, quedarán maravillados y admirados por todos los bienes, por toda la prosperidad que yo les concederé'."
,"10":"Esto dice el Señor: En este lugar que vosotros decís desierto, porque no hay hombres ni animales; en las ciudades de Judá y por las calles de Jerusalén, que están ahora desoladas, sin habitantes y sin ganados, se volverá a sentir"
,"11":"el grito de alegría y alborozo, el canto del esposo y de la esposa, la voz de aquellos que, al llevar al templo del Señor los sacrificios de acción de gracias, cantarán: 'Dad gracias al Señor omnipotente, porque el Señor es bueno, porque es eterno su amor'. Pues yo voy a cambiar la suerte de este país a su condición primera, dice el Señor."
,"12":"Esto dice el Señor: Volverá a haber en este lugar, ahora desierto, sin hombres ni animales, así como en todas las ciudades, pastos donde los pastores apacentarán el rebaño."
,"13":"En las ciudades de la montaña, en las de la llanura, en las de Negueb, en la tierra de Benjamín, en los alrededores de Jerusalén y en las ciudades de Judá, pasará de nuevo el ganado por las manos de quien lo recuenta -dice el Señor-."
,"14":"Vienen días -dice el Señor- en que yo cumpliré la promesa que tengo hecha a la casa de Israel y a la casa de Judá."
,"15":"En aquel tiempo, en aquellos días, suscitaré a David un vástago legítimo, que ejecutará el derecho y la justicia en el país."
,"16":"En aquellos días Judá será salvada y Jerusalén vivirá en seguridad, y éste será el nombre con que se la llamará: 'El Señor es nuestra justicia'."
,"17":"Pues esto dice el Señor: No le faltará jamás a David un descendiente que se siente en el trono de la casa de Israel,"
,"18":"así como tampoco les faltarán a los sacerdotes levitas descendientes que vengan ante mí a ofrecerme holocaustos, a quemar ofrendas y a celebrar sacrificios diariamente."
,"19":"El Señor dijo a Jeremías:"
,"20":"Esto dice el Señor: 'Si es que puede romperse mi alianza con el día y con la noche de modo que el día y la noche no se sucedan a su debido tiempo,"
,"21":"entonces se podrá romper también mi alianza con mi siervo David, de suerte que no tenga hijos que reinen sobre su trono, así como con los sacerdotes levitas, mis ministros."
,"22":"Como las innumerables estrellas de los cielos y las incontables arenas del mar, así multiplicaré yo la descendencia de mi siervo David y la de los levitas, mis ministros'."
,"23":"El Señor dijo a Jeremías:"
,"24":"¿No te has fijado en lo que dicen estas gentes: 'Las dos familias que el Señor había escogido han sido desechadas'? Así desprecian a mi pueblo, que para ellos ya no es una nación."
,"25":"Esto dice el Señor: Yo, que he hecho un pacto con el día y con la noche, y que he fijado leyes al cielo y a la tierra,"
,"26":"jamás rechazaré a la descendencia de Jacob y de David, mi siervo, ni dejaré de tomar de sus descendientes príncipes que gobiernen la posteridad de Abrahán, de Isaac y de Jacob. Pues voy a cambiar su suerte y a tener piedad de ellos."
}`)
	CurrentBook.AddChapter(34, `{
"1":"Palabra que el Señor dirigió a Jeremías cuando Nabucodonosor, rey de Babilonia, con todo su ejército, con todos los reinos de la tierra sometidos a su imperio y a todos los pueblos, atacaban a Jerusalén y a todas sus ciudades."
,"2":"Esto dice el Señor, Dios de Israel: Vete a hablar a Sedecías, rey de Judá, y dile: Esto dice el Señor: Voy a entregar esta ciudad en manos del rey de Babilonia, que la prenderá fuego."
,"3":"Y tú no podrás escapar ante él. Serás hecho prisionero y caerás en sus manos; te llevarán a su presencia, él te hablará cara a cara, y después irás a Babilonia."
,"4":"Sin embargo, escucha, oh Sedecías, rey de Judá, la palabra del Señor: Esto dice el Señor: No caerás a espada,"
,"5":"morirás en paz; y así como se quemaron perfumes en honor de tus antepasados, los reyes que te han precedido, así también en tu honor se quemarán y se hará esta lamentación por ti: '¡Ay, Señor!'. Soy yo quien te lo anuncio -dice el Señor-."
,"6":"El profeta Jeremías refirió todo esto a Sedecías, rey de Judá, en Jerusalén,"
,"7":"mientras el ejército del rey de Babilonia combatía contra Jerusalén y contra las ciudades de Judá: Laquis y Azeca, que, entre las plazas fuertes de Judá, eran las únicas que todavía resistían."
,"8":"Palabra dirigida a Jeremías de parte del Señor, después que el rey Sedecías contrajo con todo el pueblo de Jerusalén un compromiso para proclamar una manumisión:"
,"9":"Cada cual debía dejar libre a sus esclavos y esclavas hebreos, con el fin de no tener sometido a esclavitud a ningún judío, hermano suyo."
,"10":"Todas las autoridades y el pueblo entero, que habían aceptado el compromiso de manumitir a sus respectivos esclavos y esclavas y no tenerlos más sometidos a esclavitud, obedecieron y los emanciparon."
,"11":"Pero bien pronto cambiaron de parecer y volvieron a tomar a los esclavos y esclavas que habían dejado en libertad, y los sometieron de nuevo a esclavitud."
,"12":"Entonces la palabra del Señor fue dirigida a Jeremías en estos términos:"
,"13":"'Esto dice el Señor, Dios de Israel: Yo hice tomar este compromiso a vuestros padres el día en que los saqué de Egipto, de la casa de la esclavitud:"
,"14":"Al cabo de siete años cada uno de vosotros dejará libre a su hermano hebreo que le haya sido vendido; estará a tu servicio seis años y luego lo dejarás en libertad. Pero vuestros padres no escucharon ni hicieron caso."
,"15":"Vosotros os habíais convertido hoy y hacíais lo que me parece justo proclamando la manumisión de vuestros hermanos, bajo compromiso sellado ante mí en el templo que lleva mi nombre."
,"16":"Pero en seguida os habéis vuelto atrás y habéis profanado mi nombre volviendo a tomar cada uno a sus propios esclavos y esclavas a quienes habíais concedido la libertad, y los habéis forzado a ser vuestros esclavos como antes."
,"17":"Por tanto, esto dice el Señor: Vosotros no me habéis escuchado, concediendo cada uno la libertad a su propio hermano, a su prójimo. Pues bien, yo también -dice el Señor- voy a proclamar contra vosotros la libertad de la espada, la peste y el hambre. Os convertiré en objeto de horror para todos los reinos de la tierra."
,"18":"Y a aquellos que han faltado al compromiso, que no han cumplido los términos del compromiso que aceptaron ante mí, los voy a dejar como el novillo que cortaron en dos y por entre cuyas dos mitades pasaron."
,"19":"A los príncipes de Judá y Jerusalén, a los eunucos, a los sacerdotes y a todo el pueblo del país que pasó por entre los dos trozos del novillo,"
,"20":"los entregaré en manos de sus enemigos, en manos de aquellos que buscan su muerte. Sus cadáveres serán pasto de las aves del cielo y de las bestias del campo."
,"21":"Entregaré también a Sedecías, rey de Judá, y a sus oficiales en manos de sus enemigos, de aquellos que buscan su muerte, en poder del ejército de Babilonia, que acaba de replegarse lejos de vosotros."
,"22":"Yo daré orden -dice el Señor- de que vuelvan sobre esta ciudad; que la ataquen, la tomen y la prendan fuego; y a todas las ciudades de Judá las dejaré hechas un desierto despoblado'."
}`)
	CurrentBook.AddChapter(35, `{
"1":"Palabra que el Señor dirigió a Jeremías en tiempo de Joaquín, hijo de Josías, rey de Judá."
,"2":"'Vete donde la comunidad de los recabitas y háblales; llévalos luego al templo del Señor, a una de las salas, y dales a beber vino'."
,"3":"Yo tomé a Yazanías, hijo de Jeremías, hijo de Habasinías, a sus hermanos, a todos sus hijos y a toda la familia de los recabitas"
,"4":"y los llevé al templo del Señor, a la sala de Benhanán, hombre de Dios, la que está junto a la sala de los dignatarios, encima de la de Maasías, hijo de Salún, guardián de la puerta."
,"5":"Presenté a los miembros de la comunidad de los recabitas jarros y copas llenos de vino y les dije: '¡Bebed vino!'."
,"6":"Ellos respondieron: 'No bebemos vino, porque Jonadab, hijo de Recab, nuestro antepasado, nos prohibió: No bebáis jamás vino, ni vosotros ni vuestros hijos;"
,"7":"ni edifiquéis casas, ni sembréis campos, ni plantéis viñas, ni tengáis posesiones; sino que durante toda vuestra vida habitaréis en tiendas, a fin de que podáis vivir largos días en el territorio en el que sois extranjeros."
,"8":"Nosotros hemos obedecido a la voz de nuestro antepasado Jonadab, hijo de Recab, en todo lo que nos ha ordenado, y así en toda nuestra vida no bebemos vino, ni nosotros, ni nuestras mujeres,"
,"9":"ni nuestros hijos, ni nuestras hijas. No edificamos casas para vivir en ellas, ni poseemos viñas, campos ni sembrados,"
,"10":"sino que habitamos en tiendas. Hemos obedecido todas las órdenes que nos dio nuestro antepasado Jonadab."
,"11":"Sólo que, al llegar a nuestra tierra Nabucodonosor, rey de Babilonia, dijimos: Vámonos a Jerusalén, para escapar del ejército de los caldeos y de los sirios, y nos hemos establecido en Jerusalén'."
,"12":"Entonces el Señor dijo a Jeremías:"
,"13":"'Esto dice el Señor todopoderoso, Dios de Israel. Vete a decir a los hombres de Judá y a los habitantes de Jerusalén: ¿No aprenderéis vosotros esta lección, escuchando mis palabras? -dice el Señor-."
,"14":"Se han observado las órdenes de Jonadab, hijo de Recab, que prohibió a sus descendientes beber vino, y ellos, fieles al mandato de su antepasado, no lo han bebido hasta el presente. En cambio, yo os he hablado a vosotros insistentemente, sin cansarme y no me habéis escuchado."
,"15":"Os he mandado repetidamente, sin cansarme, a mis siervos los profetas para avisaros: Convertíos cada uno de su perverso camino, enmendad vuestra conducta, no vayáis tras dioses extraños, no los adoréis, y de esta forma podréis vivir en la tierra que yo os di a vosotros y a vuestros padres. Pero no habéis obedecido ni me habéis hecho caso."
,"16":"Los hijos de Jonadab, hijo de Recab, han sido fieles a la orden recibida de su padre; este pueblo, en cambio, no ha querido obedecerme a mí."
,"17":"Por tanto, esto dice el Señor todopoderoso, Dios de Israel: Voy a traer sobre Judá y sobre todos los habitantes de Jerusalén todas las calamidades con las que los he amenazado, porque los he avisado y no me han hecho caso, los he llamado y no han respondido."
,"18":"En cambio, a la comunidad de los recabitas, Jeremías les dijo: 'Esto dice el Señor todopoderoso, Dios de Israel: Porque habéis obedecido la orden de vuestro padre Jonadab y, fieles a sus mandatos, habéis practicado cuanto os prescribió,"
,"19":"esto dice el Señor todopoderoso, Dios de Israel: No faltará jamás a Jonadab, hijo de Recab, un descendiente que esté en mi presencia'."
}`)
	CurrentBook.AddChapter(36, `{
"1":"El año cuarto de Joaquín, hijo de Josías, rey de Judá, el Señor dio esta orden a Jeremías:"
,"2":"'Toma un libro y escribe en él todas las palabras que te he comunicado acerca de Jerusalén, Judá y todas las naciones, desde el día en que comencé a hablarte, en tiempo de Josías, hasta el presente."
,"3":"Tal vez el pueblo de Judá, al escuchar todas las calamidades que proyecto mandarles, se convierta de su mala conducta y yo pueda perdonarles sus crímenes y sus pecados'."
,"4":"Jeremías llamó a Baruc, hijo de Nerías, y Baruc escribió, al dictado de Jeremías, todas las palabras que el Señor había dirigido al profeta."
,"5":"Luego Jeremías dio esta orden a Baruc: 'Yo tengo un impedimento y no puedo ir al templo del Señor."
,"6":"Vete tú, y en el libro en que has escrito a mi dictado las palabras del Señor, léelas en alta voz al pueblo en el templo del Señor un día de ayuno, y léelas también a los judíos que vengan de sus ciudades."
,"7":"Tal vez eleven súplicas al Señor y se conviertan de su mala conducta; pues grande es la cólera y el furor con que el Señor ha amenazado a este pueblo'."
,"8":"Baruc, hijo de Nerías, ejecutó exactamente lo que le había ordenado el profeta Jeremías. Leyó en el templo las palabras del Señor contenidas en el libro."
,"9":"Fue cuando en el año quinto de Joaquín, hijo de Josías, rey de Judá, fue convocado a un ayuno ante el Señor todo el pueblo de Jerusalén y toda la multitud llegada a Jerusalén de las ciudades de Judá."
,"10":"Entonces Baruc leyó en el libro las palabras de Jeremías. Era en el templo del Señor, en la sala de Gamarías, hijo del secretario Safán, en el vestíbulo superior, a la entrada de la puerta nueva del templo del Señor. Todo el pueblo podía oír."
,"11":"En cuanto Miqueas, hijo de Gamarías, hijo de Safán, oyó todas las palabras del Señor escritas en el libro,"
,"12":"bajó al palacio real, a la sala del secretario, donde estaban reunidos en sesión todos los dignatarios: Elisamá, el secretario; Delayas, hijo de Semayas; Elnatán, hijo de Acbor; Gamarías, hijo de Safán; Sedecías, hijo de Ananías, y todos los demás dignatarios."
,"13":"Miqueas les refirió todo lo que había oído cuando Baruc leía el libro al pueblo."
,"14":"Entonces todos los dignatarios mandaron a Yehudí, hijo de Natanías, hijo de Selemías, hijo de Cusí, a decir a Baruc: 'Tráenos el libro que has leído al pueblo'. Baruc, hijo de Nerías, tomó el libro y fue donde ellos."
,"15":"Le dijeron: 'Siéntate y léenoslo en alta voz'. Baruc se lo leyó en alta voz."
,"16":"Al oír aquellas palabras, se miraron unos a otros espantados y dijeron a Baruc: 'Tenemos que comunicar sin falta al rey todo esto'."
,"17":"Y preguntaron a Baruc: 'Indícanos cómo has escrito todas estas cosas'."
,"18":"Baruc les respondió: 'Él me dictaba todas estas palabras y yo las escribía con tinta en este libro'."
,"19":"Entonces los dignatarios dijeron a Baruc: 'Ve y escóndete, con Jeremías: que nadie sepa dónde estáis'."
,"20":"Después entraron donde el rey en el atrio del palacio, dejaron el libro en depósito en la sala del secretario Elisamá y refirieron al rey todo lo sucedido."
,"21":"Entonces el rey mandó a Yehudí a buscar el libro. Éste lo tomó de la sala del secretario Elisamá y se lo leyó en alta voz al rey y a todos los dignatarios reunidos en torno al monarca."
,"22":"El rey estaba sentado en su estancia de invierno -era el mes noveno- y un brasero ardía ante él."
,"23":"Y así que Yehudí leía tres o cuatro columnas, el rey las rasgaba con el cortaplumas del secretario y las tiraba al fuego que ardía en el brasero; hasta que el libro entero fue quemado por el fuego del brasero."
,"24":"Pero no se espantaron ni se rasgaron las vestiduras el rey ni ninguno de sus servidores al oír estas palabras;"
,"25":"más aún, por más que Elnatán, Delayas y Gamarías rogaron al rey que no quemara el libro, él no les hizo caso."
,"26":"Luego el rey ordenó al príncipe Yeragmeel, a Serayas, hijo de Azriel, y a Selemías, hijo de Abdeel, prender a Baruc, el secretario, y a Jeremías, el profeta. Pero el Señor los había escondido."
,"27":"Después que el rey quemó el libro con las palabras escritas por Baruc al dictado de Jeremías, la palabra del Señor fue dirigida al profeta Jeremías en estos términos:"
,"28":"'Toma otro libro y vuelve a escribir en él las mismas palabras que había en el libro anterior quemado por Joaquín, rey de Judá."
,"29":"Y contra Joaquín, rey de Judá, dirás: Esto dice el Señor: Tú has quemado este libro, diciendo: ¿Por qué has escrito en él: Vendrá sin remedio el rey de Babilonia, devastará este país y exterminará de él hombres y animales?"
,"30":"Por ello, esto dice el Señor contra Joaquín, rey de Judá: No tendrá ya quien se siente sobre el trono de David, y su cadáver será arrojado al calor del día y al frío de la noche."
,"31":"Lo castigaré a él, a su descendencia y a su servidumbre por sus crímenes, y haré venir sobre ellos y sobre los hombres de Judá todo el mal que les había anunciado sin que me escucharan'."
,"32":"Jeremías, pues, tomó otro libro y se lo entregó a su secretario Baruc, hijo de Nerías, el cual escribió en él, al dictado de Jeremías, todas las palabras del libro que había quemado Joaquín, rey de Judá. Fueron añadidas además otras muchas del mismo género."
}`)
	CurrentBook.AddChapter(37, `{
"1":"Sedecías, hijo de Josías, sucedió en el trono a Jeconías, hijo de Joaquín, a quien Nabucodonosor, rey de Babilonia, había constituido rey del país de Judá."
,"2":"Pero ni él, ni sus servidores, ni el pueblo del país escucharon las palabras que el Señor pronunció por medio del profeta Jeremías."
,"3":"El rey Sedecías mandó a Yucal, hijo de Selemías, y al sacerdote Sofonías, hijo de Maasías, a decir al profeta Jeremías: 'Ruega por nosotros al Señor, nuestro Dios'."
,"4":"Por entonces Jeremías andaba con libertad en medio del pueblo, pues todavía no había sido encarcelado."
,"5":"Por entonces también salió de Egipto el ejército del Faraón, y, al enterarse de ello los caldeos, que tenían puesto el cerco a Jerusalén, se retiraron de la ciudad."
,"6":"Entonces el Señor dirigió a Jeremías esta palabra:"
,"7":"'Esto dice el Señor, Dios de Israel: Así habréis de decir al rey de Judá, que os ha enviado a consultarme: El ejército del Faraón, que venía en vuestra ayuda, se va a volver a su país de Egipto,"
,"8":"y los caldeos volverán a atacar esta ciudad, la tomarán y la prenderán fuego."
,"9":"Esto dice el Señor: No os engañéis pensando que se van a ir del todo los caldeos, que se van a alejar de vosotros, porque no se irán."
,"10":"Aunque derrotarais al ejército entero de los caldeos que combaten contra vosotros y no quedasen entre ellos más que unos pocos malheridos, saldrían éstos uno a uno de su tienda y prenderían fuego a esta ciudad'."
,"11":"Cuando el ejército de los caldeos se retiró de Jerusalén debido a la inminencia del ejército del Faraón,"
,"12":"Jeremías quiso salir de la ciudad para dirigirse a la tierra de Benjamín a hacer las reparticiones del aprovisionamiento entre los suyos."
,"13":"Pero al llegar a la puerta de Benjamín, el guardia que estaba de turno, llamado Yirayas, hijo de Selemías, hijo de Ananías, arrestó al profeta Jeremías exclamando: '¡Tú te pasas a los caldeos!'."
,"14":"Jeremías respondió: '¡No es verdad, yo no me paso a los caldeos!'. Pero Yirayas, no haciéndole caso, prendió a Jeremías y lo llevó a los dignatarios."
,"15":"Éstos, encolerizados contra Jeremías, lo golpearon y lo encerraron en casa del secretario Jonatán, la cual había sido convertida en cárcel."
,"16":"Jeremías fue, pues, metido en un calabozo subterráneo abovedado y allí permaneció largo tiempo."
,"17":"El rey Sedecías envió a sacarlo y le interrogó en secreto en su palacio: '¿Hay alguna palabra de parte del Señor?'. 'Sí', respondió Jeremías; y añadió: 'Tú serás entregado en manos del rey de Babilonia'."
,"18":"Luego Jeremías dijo al rey Sedecías: '¿Qué mal he cometido contra ti, contra tus servidores o contra este pueblo, para que me hayáis metido en la cárcel?"
,"19":"¿Dónde están ahora los profetas que os profetizaban: No vendrá el rey de Babilonia contra vosotros ni contra este país?"
,"20":"Ahora, pues, por favor, escucha, oh rey, mi señor: Dígnate acoger mi súplica y no me vuelvas a mandar a la casa del secretario Jonatán, para que no muera yo allí'."
,"21":"Entonces el rey Sedecías dio orden de que Jeremías fuese llevado al patio de la guardia y que se le diera diariamente un pan procedente de la calle de los panaderos mientras hubiese pan en la ciudad. Así Jeremías quedó en el patio de la guardia."
}`)
	CurrentBook.AddChapter(38, `{
"1":"Pero Safatías, hijo de Tatán; Guedelías, hijo de Pasjur; Yucal, hijo de Selemías, y Pasjur, hijo de Malquías, habían oído a Jeremías dirigir al pueblo estas palabras:"
,"2":"'Esto dice el Señor: El que se quede en la ciudad morirá a espada, de hambre y de peste; pero el que se entregue a los caldeos vivirá. Su propia vida será su botín; sí, vivirá."
,"3":"Esto dice el Señor: Jerusalén caerá sin remedio en manos del ejército del rey de Babilonia, que la tomará'."
,"4":"Aquellos dignatarios dijeron al rey: 'Pedimos la muerte de este hombre, que desalienta a los combatientes que quedan en esta ciudad y a todo el pueblo, al hablarles en tales términos. Es evidente que este hombre no busca el bien de este pueblo, sino su desgracia'."
,"5":"El rey Sedecías respondió: 'En vuestras manos está, puesto que el rey no puede nada contra vosotros'."
,"6":"Entonces ellos agarraron a Jeremías y lo arrojaron en la cisterna del príncipe Malquías, situada en el patio de la guardia, bajándolo con cuerdas. En la cisterna no había agua, sino fango, y Jeremías se hundió en él."
,"7":"Ebedmélec, eunuco etíope del palacio real, oyó decir que habían echado a Jeremías en la cisterna. Y en una ocasión en que el rey se encontraba en la puerta de Benjamín,"
,"8":"salió Ebedmélec del palacio real y fue a decir al rey:"
,"9":"'Oh rey, mi señor, mal han procedido todos esos hombres en todo lo que han hecho al profeta Jeremías. Lo han echado en la cisterna, donde va a morir de hambre, pues ya no hay pan en la ciudad'."
,"10":"Entonces el rey dio a Ebedmélec, el etíope, esta orden: 'Toma de aquí contigo tres hombres y saca a Jeremías de la cisterna antes de que muera'."
,"11":"Ebedmélec tomó consigo a los hombres, entró en el palacio real, en el vestuario del tesoro, tomó unos cuantos trozos de ropas usadas y rotas y se las echó a Jeremías en la cisterna con unas cuerdas."
,"12":"Y dijo a Jeremías: 'Ponte estos paños usados y rotos bajo los sobacos, por debajo de las cuerdas'."
,"13":"Jeremías lo hizo así, y en seguida tiraron de él con las cuerdas y lo subieron de la cisterna. Y Jeremías quedó en el patio de la guardia."
,"14":"El rey Sedecías mandó a buscar al profeta Jeremías a la tercera puerta del templo del Señor; el rey dijo a Jeremías: 'Tengo que preguntarte una cosa, no me ocultes nada'."
,"15":"Jeremías respondió a Sedecías: 'Si te lo digo, me harás morir, ¿no es verdad? Si te doy un consejo, no me vas a escuchar'."
,"16":"Entonces el rey Sedecías juró en secreto a Jeremías: '¡Vive Dios que nos ha dado el aliento, que no te mataré ni te entregaré en poder de esos que andan buscando tu muerte!'."
,"17":"Jeremías dijo a Sedecías: 'Esto dice el Señor todopoderoso, Dios de Israel: Si sales y te entregas a los generales del rey de Babilonia, salvarás tu vida, y esta ciudad no será entregada a las llamas: te salvarás juntamente con tu familia."
,"18":"Pero si no sales a entregarte a los generales del rey de Babilonia, la ciudad caerá en manos de los caldeos, que la incendiarán, y tú no escaparás de sus manos'."
,"19":"El rey Sedecías dijo a Jeremías: 'Tengo miedo a los judíos que se han pasado a los caldeos; si caigo en sus manos me maltratarán'."
,"20":"Jeremías respondió: 'No te entregarán a ellos. Escucha la voz del Señor que yo te he referido y te resultará bien: Salvarás tu vida."
,"21":"Pero por si te niegas a rendirte, esto es lo que ha manifestado el Señor:"
,"22":"Mira, todas las mujeres que han quedado en el palacio del rey de Judá serán llevadas a los generales del rey de Babilonia, y serán ellas las que exclamarán: ¡Te han engañado, han podido contigo,tus buenos amigos!,¡Tus pies han hundido en el fango,y ellos te han dado la espalda!"
,"23":"Sí, todas tus mujeres y tus hijos serán sacados a los caldeos, y tú no escaparás de sus manos, sino que caerás preso en manos del rey de Babilonia y esta ciudad será destruida por las llamas'."
,"24":"Entonces Sedecías dijo a Jeremías: 'Nadie se entere de estas palabras; de lo contrario morirás."
,"25":"Si los dignatarios llegan a saber que yo he hablado contigo y se presentan a ti para decirte: Queremos saber qué has dicho al rey y qué es lo que el rey te ha respondido; no nos ocultes nada, de lo contrario te mataremos,"
,"26":"les dirás: Yo sólo he suplicado humildemente al rey que no me haga volver a casa de Jonatán a morir allí'."
,"27":"Vinieron, en efecto, todos los dignatarios a interrogar a Jeremías; pero él les contestó conforme a la sugerencia del rey y no lo molestaron más, pues la conversación no había sido oída."
,"28":"Y Jeremías permaneció en el patio de la guardia hasta el día en que fue tomada Jerusalén."
}`)
	CurrentBook.AddChapter(39, `{
"1":"El año noveno de Sedecías, rey de Judá, en el mes décimo, Nabucodonosor, rey de Babilonia, vino con todo su ejército contra Jerusalén y la cercó."
,"2":"El año undécimo de Sedecías, el día nueve del cuarto mes, fue abierta una brecha en la ciudad."
,"3":"Todos los oficiales del rey de Babilonia entraron y establecieron sus cuarteles en la puerta del medio: Nergal-Sareser, príncipe de Samgar, oficial mayor; Nebusasbán, alto dignatario, y todos los demás oficiales del rey de Babilonia."
,"4":"Al verlos, Sedecías, rey de Judá, y todos los combatientes emprendieron la huida, saliendo de noche de la ciudad por el camino del jardín real, por la puerta situada entre los dos muros, tomando el camino de la Arabá."
,"5":"Pero las tropas de los caldeos salieron en su persecución y alcanzaron a Sedecías en las estepas de Jericó. Lo prendieron y lo llevaron a Ribla, en el país de Jamot, ante Nabucodonosor, rey de Babilonia, el cual le anunció sus decisiones."
,"6":"En Ribla, el rey de Babilonia hizo degollar a los hijos de Sedecías ante sus propios ojos y dio muerte a todos los nobles de Judá."
,"7":"A Sedecías le sacó los ojos y lo aherrojó con una doble cadena de bronce para llevarlo luego a Babilonia."
,"8":"Los caldeos prendieron fuego al palacio real y a las casas del pueblo, y derruyeron los muros de Jerusalén."
,"9":"Al resto de la población que había quedado en la ciudad, a los que se habían rendido a él y a la gente restante, Nebuzardán, jefe de la escolta real, los deportó a Babilonia."
,"10":"En cambio, a la parte de la población que no poseía nada, Nebuzardán, jefe de la escolta, la dejó en la tierra de Judá, dándoles al mismo tiempo viñas y campos."
,"11":"En cuanto a Jeremías, Nabucodonosor, rey de Babilonia, había dado a Nebuzardán, jefe de la escolta, estas órdenes:"
,"12":"'Tómalo y protégelo. No le hagas mal alguno, sino que has de hacer de él lo que él te indique'."
,"13":"Así Nebuzardán, jefe de la escolta; Nabusasbán, alto dignatario; Nergal-Sareser, oficial mayor, y los otros oficiales del rey de Babilonia"
,"14":"mandaron sacar a Jeremías del patio de la guardia y lo entregaron a Godolías, hijo de Ajicán, hijo de Safán, para que lo llevase a su casa. Y así se quedó en medio del pueblo."
,"15":"Estando todavía Jeremías recluido en el patio de la guardia, le había sido dirigida la palabra de parte del Señor en estos términos:"
,"16":"'Vete a decir al etíope Ebedmélec: Esto dice el Señor todopoderoso, Dios de Israel: Mira: yo voy a cumplir sobre esta ciudad mis palabras, palabras de desgracia, que no de ventura. El día en que todo esto se cumpla ante tus propios ojos,"
,"17":"aquel día yo te libraré a ti -dice el Señor- y no caerás en manos de los hombres que temes."
,"18":"Sí, te salvaré. No caerás a espada, sino que la salvación de tu vida será tu botín, por haber puesto tu confianza en mí' -dice el Señor-."
}`)
	CurrentBook.AddChapter(40, `{
"1":"Palabra dirigida a Jeremías de parte del Señor, después que fue puesto en libertad en Ramá por Nebuzardán, jefe de la escolta, el cual lo había encontrado aherrojado entre los prisioneros de Jerusalén y Judá que eran deportados a Babilonia."
,"2":"El jefe de la escolta tomó aparte a Jeremías y le dijo: 'El Señor, tu Dios, había anunciado la presente desgracia sobre este lugar"
,"3":"y la ha llevado a cabo. El Señor ha cumplido todo lo que había dicho, porque vosotros pecasteis contra él y no escuchasteis su voz. Por eso os ha sobrevenido todo esto."
,"4":"En cuanto a ti, yo te libro ahora de las cadenas que tienes en las manos. Si quieres venir conmigo a Babilonia, ven, que yo cuidaré de ti; pero si no quieres venir conmigo a Babilonia, quédate. Mira, todo el país está ante ti: Vete adonde prefieras."
,"5":"Puedes dirigirte a Godolías, hijo de Ajicán, hijo de Safán, a quien el rey de Babilonia ha puesto al frente de las ciudades de Judá, y quedarte con él entre el pueblo; puedes ir también adonde quieras'. Luego el jefe de la escolta le dio provisiones y un regalo, y lo despidió."
,"6":"Y Jeremías se fue a Mispá, donde Godolías, hijo de Ajicán, y vivió con él entre el pueblo que había quedado en el país."
,"7":"En cuanto los jefes de las tropas, que se habían dispersado por el campo con sus hombres, se enteraron de que el rey de Babilonia había puesto al frente del país a Godolías, hijo de Ajicán, y que le había encomendado hombres, mujeres y niños, así como los pobres del país que no habían sido deportados a Babilonia,"
,"8":"se presentaron a Godolías en Mispá: Ismael, hijo de Netanías; Juan, hijo de Carej; Serayas, hijo de Tanjumet; los hijos de Efaí de Netofá, y Yenazías, de Maacá, con su gente respectiva."
,"9":"Godolías, hijo de Ajicán, hijo de Safán, les juró a ellos y a su gente: 'No temáis estar sometidos a los caldeos. Quedaos en el país, sujetos al rey de Babilonia, y os irá bien."
,"10":"Mirad, yo por mí me quedo en Mispá como representante del país ante los caldeos que vengan a nosotros. Vosotros recoged la uva, los frutos y el aceite, llenad vuestras tinajas y habitad en las ciudades que vais a ocupar'."
,"11":"Asimismo, los demás judíos que estaban en Moab, entre los amonitas, en Edón y en todos los otros países, en cuanto se enteraron de que el rey de Babilonia había dejado algunos judíos en Judá y de que había puesto al frente de ellos a Godolías, hijo de Ajicán, hijo de Safán,"
,"12":"regresaron todos ellos de los diversos lugares donde estaban dispersos, y vinieron a la tierra de Judá, donde Godolías, en Mispá, e hicieron una abundante recolección de vino y frutos."
,"13":"Juan, hijo de Carej, y todos los jefes de las tropas que andaban dispersos por el campo se presentaron a Godolías, en Mispá,"
,"14":"y le dijeron: '¿No sabes que Baalís, rey de los amonitas, ha enviado a Ismael, hijo de Netanías, para matarte?'. Pero Godolías, hijo de Ajicán, hijo de Safán, no dio crédito a estas palabras."
,"15":"Y Juan, hijo de Carej, dijo en secreto a Godolías, en Mispá: 'Yo iré y mataré a Ismael, hijo de Netanías, sin que nadie lo sepa. ¿Por qué te ha de matar? Significaría la dispersión de todos los judíos que están congregados en torno a ti, la ruina del resto de Judá'."
,"16":"Pero Godolías, hijo de Ajicán, dijo a Juan, hijo de Carej: 'No hagas eso, porque es falso lo que dices de Ismael'."
}`)
	CurrentBook.AddChapter(41, `{
"1":"En el mes séptimo, Ismael, hijo de Netanías, hijo de Elisamá, que era de estirpe real y uno de los grandes del rey, vino con diez hombres a visitar a Godolías, hijo de Ajicán, en Mispá, y mientras estaba comiendo con él,"
,"2":"Ismael, hijo de Netanías, y los diez hombres que le acompañaban se levantaron e hirieron a espada a Godolías, hijo de Ajicán, hijo de Safán, matando así a aquel a quien el rey de Babilonia había puesto al frente del país."
,"3":"Ismael mató asimismo a todos los judíos que estaban comiendo con Godolías, y a los caldeos -eran hombres de guerra- que se encontraban allí."
,"4":"Al día siguiente del asesinato de Godolías, del cual todavía nadie estaba enterado,"
,"5":"llegaron de Siquén, de Silo y de Samaría ochenta hombres con la barba rapada, los vestidos rasgados y el cuerpo lleno de cortaduras, trayendo ofrendas e incienso para ofrecerlos en el templo del Señor."
,"6":"Ismael, hijo de Netanías, salió de Mispá a su encuentro, llorando todo el camino, y, al llegar a su encuentro, les dijo: 'Venid donde Godolías, hijo de Ajicán'."
,"7":"Pero en cuanto llegaron al centro de la ciudad, Ismael, hijo de Netanías, y sus hombres los degollaron y los arrojaron en una cisterna."
,"8":"Aunque hubo diez de aquellos hombres que dijeron a Ismael: 'No nos mates, pues tenemos escondidas en el campo provisiones de trigo, cebada, aceite y miel'. Y él los respetó y no los mató como a sus compañeros."
,"9":"La cisterna en la que Ismael echó los cuerpos de los hombres matados es la que hizo excavar el rey Asá contra Basá, rey de Israel. Ismael, hijo de Netanías, la llenó de cadáveres."
,"10":"Después llevó preso a todo el resto del pueblo que había en Mispá y a las princesas reales que Nebuzardán, jefe de la escolta, había confiado a Godolías, hijo de Ajicán. Y muy de mañana, Ismael, hijo de Netanías, se puso en marcha hacia el país de los amonitas."
,"11":"Al enterarse Juan, hijo de Carej, y todos los jefes de las tropas que lo acompañaban de la matanza cometida por Ismael,"
,"12":"reunieron a todos los hombres y marcharon contra Ismael, hijo de Netanías. Lo encontraron junto al gran estanque de Gabaón."
,"13":"Cuando los prisioneros que llevaba Ismael divisaron a Juan, hijo de Carej, y a todos los oficiales que lo acompañaban, se llenaron de júbilo."
,"14":"Y todos éstos, los que Ismael había hecho prisioneros en Mispá, dieron la vuelta y se pasaron a Juan, hijo de Carej."
,"15":"Pero Ismael, hijo de Netanías, logró escapar con ocho hombres, de Juan, hacia el país de los amonitas."
,"16":"Entonces Juan, hijo de Carej, y todos los oficiales que estaban con él recogieron a todo el resto de la gente que Ismael, hijo de Netanías, se había llevado de Mispá, después de matar a Godolías, hijo de Ajicán: hombres, mujeres y niños, así como a los eunucos, traídos por ellos de Gabaón."
,"17":"Partieron e hicieron alto en Quimhán, cerca de Belén, para continuar después el viaje con ánimo de entrar en Egipto"
,"18":"y alejarse de los caldeos, a quienes temían, porque Ismael, hijo de Netanías, había matado a Godolías, hijo de Ajicán, puesto por el rey de Babilonia al frente del país."
}`)
	CurrentBook.AddChapter(42, `{
"1":"Entonces todos los oficiales, con Juan, hijo de Carej, y Azarías, hijo de Hosayas, y todo el resto del pueblo, grandes y pequeños,"
,"2":"se presentaron al profeta Jeremías y le dijeron: 'Acoge por favor nuestros ruegos y pide al Señor, tu Dios, por este pequeño resto que somos nosotros, ya que de tantos como éramos hemos quedado pocos, como estás viendo con tus propios ojos."
,"3":"Y que el Señor, tu Dios, nos indique el camino que hemos de seguir y lo que debemos hacer'."
,"4":"El profeta Jeremías les contestó: 'Os he oído. Yo pediré al Señor, vuestro Dios, conforme a vuestros deseos. Cualquier cosa que el Señor os responda yo os la comunicaré, sin ocultaros nada'."
,"5":"Ellos dijeron a Jeremías: 'Que el Señor sea testigo fidedigno y fiel contra nosotros, si no hacemos todo lo que el Señor, tu Dios, nos mande decir por medio de ti."
,"6":"Sea como sea, favorable o adversa, nosotros escucharemos la voz del Señor, nuestro Dios, ante quien te remitimos a ti, y así seremos felices por haber escuchado la voz del Señor, nuestro Dios'."
,"7":"Diez días después fue dirigida a Jeremías la palabra del Señor."
,"8":"Entonces él llamó a Juan, hijo de Carej, a todos los oficiales que lo acompañaban y al pueblo entero, desde el más chico al mayor,"
,"9":"y les dijo: 'Esto dice el Señor, Dios de Israel, ante quien me habéis remitido para que yo presentara vuestras súplicas:"
,"10":"Si seguís en este país, yo os edificaré y no os destruiré, os plantaré y no os arrancaré, pues me pesa el castigo que os he dado."
,"11":"No temáis al rey de Babilonia, a quien tanto miedo tenéis; no lo temáis -dice el Señor-, porque yo estoy con vosotros para salvaros y libraros de sus manos."
,"12":"Haré que tenga piedad de vosotros y él se compadecerá de vosotros, dejándoos vivir en vuestra tierra."
,"13":"Pero si decís: ¡No queremos vivir en este país!, negándoos a obedecer la voz del Señor, vuestro Dios,"
,"14":"si decís: ¡No!, nos iremos a Egipto, donde no veamos más la guerra, ni oigamos el sonido de la trompeta, ni suframos más hambre, allí nos instalaremos,"
,"15":"en tal caso, escucha, oh resto de Judá, la palabra del Señor. Esto dice el Señor todopoderoso, Dios de Israel: Si os obstináis en querer marchar a Egipto y vais para estableceros allí,"
,"16":"la espada que tanto teméis os alcanzará en Egipto, y el hambre que tanto os preocupa os perseguirá en Egipto y allí moriréis."
,"17":"Sí, todos aquellos que se obstinen en marchar a Egipto para vivir allí morirán a espada, de hambre y de peste; ninguno de ellos sobrevivirá, ninguno podrá escapar a la desgracia que yo mandaré sobre ellos."
,"18":"Pues esto dice el Señor todopoderoso, Dios de Israel: Como se derramó mi furor y mi indignación sobre los habitantes de Jerusalén, así se derramará mi furor sobre vosotros si marcháis a Egipto. Seréis objeto de execración, de horror, de maldición, de oprobio y de vergüenza, y no volveréis a ver más este lugar'."
,"19":"El Señor os dice a vosotros, supervivientes de Judá: No vayáis a Egipto. Tened bien en cuenta que yo os lo he advertido hoy solemnemente."
,"20":"Habéis puesto en peligro vuestra propia vida al enviarme al Señor, vuestro Dios, diciendo: Ruega por nosotros al Señor, nuestro Dios, y todo cuanto te diga comunícanoslo para que lo ejecutemos,"
,"21":"mientras que ahora que os lo he comunicado, no habéis querido escuchar la voz del Señor, vuestro Dios, en nada de lo que me ha mandado deciros."
,"22":"Por tanto, sabed bien que moriréis a espada, de hambre y de peste en el lugar a donde queréis ir a vivir'."
}`)
	CurrentBook.AddChapter(43, `{
"1":"Cuando Jeremías terminó de decir al pueblo todas las palabras del Señor, su Dios, que el Señor le había encargado decirles -todas las palabras precedentes-,"
,"2":"Azarías, hijo de Maasías; Juan, hijo de Carej, y todos los hombres altivos y rebeldes dijeron a Jeremías: 'Tú nos dices mentira. No ha sido el Señor, nuestro Dios, el que te ha enviado a decir: No vayáis a Egipto para vivir allí,"
,"3":"sino Baruc, hijo de Nerías, que te incita contra nosotros con el fin de entregarnos en manos de los caldeos para que nos maten o nos deporten a Babilonia'."
,"4":"Pero Juan, hijo de Carej, todos los oficiales y todo el pueblo no obedecieron la orden del Señor de quedarse en el país de Judá."
,"5":"Así pues, Juan, hijo de Carej, y todos los oficiales tomaron consigo a todos los supervivientes de Judá que habían vuelto de todas las naciones donde estaban dispersos a habitar en la tierra de Judá:"
,"6":"hombres, mujeres y niños, las princesas reales y cuantas personas había dejado Nebuzardán, jefe de la escolta, con Godolías, hijo de Ajicán, hijo de Safán; también se llevaron al profeta Jeremías y a Baruc, hijo de Nerías,"
,"7":"y entraron en Egipto, desobedeciendo así la voz del Señor, y llegaron hasta Tafnis."
,"8":"En Tafnis, el Señor dijo a Jeremías:"
,"9":"'Toma unas piedras grandes y, en presencia de los judíos, escóndelas en la argamasa de la obra de ladrillo que hay a la entrada del palacio del Faraón, en Tafnis,"
,"10":"y diles: Esto dice el Señor todopoderoso, Dios de Israel: Voy a mandar a buscar a mi siervo Nabucodonosor, rey de Babilonia, y pondré su trono sobre estas piedras que he escondido y él desplegará sobre ellas su dosel."
,"11":"Vendrá y herirá a la tierra de Egipto. ¡A quien esté destinado a la peste, la peste; a quien al cautiverio, cautiverio; a quien a la espada, espada!"
,"12":"Prenderá fuego a los templos de los dioses de Egipto, quemará a los dioses o los deportará; espulgará el país de Egipto como un pastor espulga su capa; y luego se marchará sano y salvo."
,"13":"Despedazará los obeliscos del templo del Sol, que se encuentra en On, y entregará a las llamas los templos de los dioses egipcios'."
}`)
	CurrentBook.AddChapter(44, `{
"1":"Ésta es la palabra dirigida a Jeremías acerca de todos los judíos que vivían en Egipto, con residencia en Migdol, Tafnis, Nof, así como en la región de Patrós."
,"2":"Esto dice el Señor todopoderoso, Dios de Israel: Ya habéis visto todos los males que yo he mandado sobre Jerusalén y sobre todas las ciudades de Judá; hoy son un montón de ruinas sin un alma que habite en ellas"
,"3":"a causa del mal que cometieron para irritarme, quemando incienso y sirviendo a dioses extraños, desconocidos de ellos, de vosotros y de vuestros padres."
,"4":"Yo os envié incesantemente, sin cansarme, a mis siervos los profetas para que os dijeran: no hagáis esas cosas horribles que yo detesto."
,"5":"Pero no quisieron escuchar ni hicieron caso, ni se convirtieron de su perversidad, ni dejaron de quemar incienso a dioses extraños."
,"6":"Por eso se encendieron mi furor y mi cólera y consumieron las ciudades de Judá y las calles de Jerusalén, dejándolas convertidas en desolación y ruinas, como lo están actualmente."
,"7":"Ahora, pues, esto dice el Señor todopoderoso, Dios de Israel: ¿Por qué cometéis tanto mal contra vosotros mismos? Vais a terminar exterminando del seno de Judá a hombres, mujeres, niños y lactantes, hasta que no quede rastro de vosotros,"
,"8":"porque me irritáis con las obras de vuestras manos, quemando incienso a dioses extraños en Egipto, adonde habéis venido a vivir, fraguando así vuestro exterminio y convirtiéndoos en maldición y oprobio ante todas las naciones de la tierra."
,"9":"¿Habéis olvidado acaso las maldades de vuestros padres, las maldades de los reyes de Judá y las de sus mujeres, vuestras propias maldades y las de vuestras mujeres cometidas en la tierra de Judá y en las calles de Jerusalén?"
,"10":"Y, sin embargo, hoy es el día en que todavía no han sentido arrepentimiento ni temor alguno, ni han procedido con arreglo a mi ley y mis preceptos, que yo promulgué a vosotros y a vuestros padres."
,"11":"Por eso, esto dice el Señor todopoderoso, Dios de Israel: Voy a volver yo mi rostro contra vosotros para vuestra desgracia y voy a exterminar a todo Judá."
,"12":"Tomaré a los supervivientes de Judá, los que se obstinaron en venir a vivir a Egipto, y perecerán todos en la tierra de Egipto. Caerán a espada, morirán de hambre, desde el más pequeño al mayor; a espada y de hambre morirán, y serán objeto de execración, de horror, de maldición, de oprobio."
,"13":"Castigaré a los que viven en Egipto, como castigué a Jerusalén, con la espada, el hambre y la peste."
,"14":"No escapará ninguno de los supervivientes de Judá que se han venido a vivir a Egipto; ni uno solo quedará que vuelva al país de Judá, donde tanto desean volver a vivir; no volverán, salvo unos pocos fugitivos."
,"15":"Entonces todos los hombres que sabían que sus mujeres quemaban incienso a dioses extranjeros, y todas las mujeres que estaban presentes -una gran asamblea-, así como todo el pueblo que habitaba en la tierra de Egipto, en Patrós, respondieron a Jeremías:"
,"16":"'La palabra que nos has dirigido en nombre del Señor no queremos escucharla,"
,"17":"sino que haremos decididamente todo lo que nos hemos propuesto: quemar incienso y hacer ofrendas de vino a la reina del cielo, tal como hemos hecho nosotros y como hicieron nuestros padres, nuestros reyes y nuestros príncipes en las ciudades de Judá y en las calles de Jerusalén. Entonces tuvimos pan hasta hartarnos, éramos felices y no veíamos desventuras."
,"18":"Pero desde que hemos dejado de quemar incienso y de hacer ofrendas de vino a la reina del cielo, carecemos de todo y por la espada y el hambre nos hemos consumido."
,"19":"Y cuando nosotras -añadieron las mujeres- quemamos incienso y hacemos ofrendas de vino a la reina del cielo, ¿acaso le hacemos tortas que representan su imagen y le presentamos ofrendas de vino a espaldas de nuestros maridos?'."
,"20":"Entonces Jeremías replicó a todo el pueblo, a los hombres, a las mujeres y a toda la gente que le había respondido así, y les dijo:"
,"21":"'¿No ha sido acaso el incienso que quemasteis en las ciudades de Judá y en las calles de Jerusalén vosotros, vuestros padres, vuestros reyes, vuestros príncipes y el pueblo del país lo que ha recordado el Señor, lo que le ha venido a la memoria?"
,"22":"El Señor no podía soportar más la maldad de vuestras acciones y las monstruosidades que habéis cometido; por eso vuestro país ha quedado convertido en un desierto, objeto de horror y execración, sin ningún habitante, como sucede actualmente."
,"23":"La causa de todo esto es que vosotros habéis quemado ofrendas pecando así contra el Señor, y no habéis escuchado su voz ni habéis caminado según su ley, sus preceptos y sus ordenanzas. Por eso os han sobrevenido todas estas desventuras, como sucede actualmente'."
,"24":"Luego Jeremías continuó dirigiéndose a todo el pueblo, y especialmente a las mujeres: 'Escuchad la palabra del Señor vosotros, los judíos que estáis en Egipto."
,"25":"Esto dice el Señor todopoderoso, Dios de Israel: Vosotros y vuestras mujeres habéis llevado a cabo con vuestras manos lo que habíais prometido con vuestra boca: Cumpliremos puntualmente los votos que hemos hecho de quemar incienso y presentar ofrendas de vino a la reina del cielo. Pues bien, cumplid vuestros votos, llevadlos a la práctica."
,"26":"Pero escuchad la palabra del Señor todos los judíos que vivís en Egipto: Yo también juro por mi gran nombre -dice el Señor- que no se pronunciará más mi nombre en Egipto por ningún judío que diga: ¡Vive el Señor Dios!"
,"27":"Voy a montar guardia sobre ellos para su daño y no para su bien, y todos los hombres de Judá que están en Egipto perecerán por la espada y el hambre hasta quedar completamente exterminados,"
,"28":"salvo unos pocos escapados a la espada, que regresarán de Egipto a la tierra de Judá. Entonces todos los supervivientes de Judá que han venido a refugiarse en Egipto sabrán qué palabra se ha cumplido, si la mía o la de ellos."
,"29":"Y ahora os voy a dar la señal -dice el Señor- de que os he de castigar en este lugar, para que sepáis que mis palabras se cumplirán sin remedio en vosotros para desgracia vuestra."
,"30":"Esto dice el Señor: Mirad, voy a entregar al faraón Ofrá, rey de Egipto, en manos de sus enemigos, de los que andan buscando su muerte, de la misma manera que entregué a Sedecías, rey de Judá, en manos de su enemigo Nabucodonosor, rey de Babilonia, que buscaba su muerte'."
}`)
	CurrentBook.AddChapter(45, `{
"1":"Palabra que el profeta Jeremías dirigió a Baruc, hijo de Nerías, cuando éste escribió en un libro estas palabras dictadas de labios de Jeremías, el año cuarto de Joaquín, hijo de Josías, rey de Judá:"
,"2":"'Esto dice el Señor, Dios de Israel, acerca de ti, Baruc."
,"3":"Tú dices: ¡Ay de mí, pues el Señor acumula en mí penas y dolores! Estoy agotado de gemir y no encuentro alivio."
,"4":"Esto dice el Señor: Le dirás: Lo que había construido, lo destruyo; lo que había plantado, lo arranco. Voy a herir a toda la tierra."
,"5":"¿Y tú andas buscando para ti cosas extraordinarias? No las busques, pues yo voy a mandar desventuras sobre todo mortal -dice el Señor-. A ti te concederé como botín la vida, dondequiera que vayas'."
}`)
	CurrentBook.AddChapter(46, `{
"1":"Palabra del Señor dirigida al profeta Jeremías sobre las naciones."
,"2":"Sobre Egipto. Contra el ejército del faraón Necó, rey de Egipto, que se encontraba junto al río Éufrates, en Cárquemis, y a quien derrotó Nabucodonosor, rey de Babilonia, el año cuarto de Joaquín, hijo de Josías, rey de Judá. "
,"3":"¡Preparad escudos y paveses, avanzad hacia el combate;"
,"4":"aparejad los caballos; montad, caballeros; alineaos con los yelmos, bruñid las lanzas, vestíos las corazas!"
,"5":"¿Qué veo? Están asustados, retroceden; los más valientes son despedazados, huyen a la desbandada,sin volver la cabeza. ¡Terror por todas partes!,-dice el Señor-."
,"6":"Ni el más veloz podrá escapar, ni el más valiente se salvará. Al norte, a orillas del Éufrates, se precipitan y caen."
,"7":"¿Quién era aquel,que subía como el Nilo, como torrente de revueltas aguas?"
,"8":"Era Egipto, que subía como el Nilo, como torrente de revueltas aguas."
,"9":"¡Adelante, caballos!,¡Al asalto, carros!,¡Avanzad, guerreros, los etíopes y libios portadores de escudo, y los lidios, tiradores de arco!"
,"10":"Es el día del Señor Dios, día de venganza, para vengarse de sus enemigos. Su espada devorará, se saciará, se embriagará de la sangre de ellos. ¡Un sacrificio que celebra,el Señor Dios omnipotente,en las tierras del norte, junto al río Éufrates!"
,"11":"¡Sube a Galaad a buscar bálsamo, oh virgen, hija de Egipto!,En vano multiplicarás los remedios. ¡Nada podrá curarte!"
,"12":"Conocen las naciones tu derrota, la tierra está llena de tus gritos. El guerrero tropieza con el guerrero, caen los dos a la vez."
,"13":"Palabra que el Señor dirigió al profeta Jeremías cuando Nabucodonosor, rey de Babilonia, vino con ánimo de atacar a Egipto."
,"14":"¡Anunciadlo en Egipto, publicadlo en Migdol, pregonadlo en Nof y en Tafnis!,Decid: ¡En pie! Estáte alerta, porque la espada devora en torno tuyo."
,"15":"-¡Cómo! ¿Apis se da a la fuga?,¿No resiste tu toro sagrado?,¡Sí, el Señor lo ha empujado,"
,"16":"ha vacilado y ya está en tierra!,Unos a otros se dicen: '¡En pie! Volvamos a nuestro pueblo, a nuestra patria, lejos de la espada que devora'."
,"17":"Dad este nombre al Faraón, rey de Egipto: '¡Tumulto que llega con retraso!'."
,"18":"Por mi vida -dice el rey-, cuyo nombre es el Señor todopoderoso, que como el Tabor entre los montes, como el Carmelo que domina el mar, alguien ha de venir."
,"19":"Prepara tu equipaje para el cautiverio, población de Egipto, pues Nof quedará hecha un desierto, devastada y despoblada."
,"20":"Una novilla magnífica es Egipto, mas un tábano del norte cae sobre ella."
,"21":"También sus mercenarios, dentro de ella, son como novillos bien cebados; mas ellos también vuelven la espalda,y huyen todos a una, sin poder resistir, porque cae sobre ellos el día de su infortunio, la hora de su castigo."
,"22":"Voz como de serpiente que silba; sí, avanza en masa, se echan sobre ella con sus hachas, como si fueran leñadores."
,"23":"Talan su bosque -dice el Señor-,porque son innumerables, multiplicados más que la langosta. Nadie puede contarlos."
,"24":"La población de Egipto,está cubierta de vergüenza, ha caído en manos de un pueblo del norte."
,"25":"El Señor todopoderoso, Dios de Israel, ha dicho: 'Voy a castigar a Amón de No, al Faraón, a Egipto con sus dioses y sus diosas, al Faraón y a quienes ponen en él su confianza."
,"26":"Los entregaré en manos,de aquellos que buscan su vida, en manos de Nabucodonosor, rey de Babilonia, y en la de sus servidores. Pero después de esto,volverá a ser habitado,como antaño' -dice el Señor-."
,"27":"Y tú no temas, siervo mío Jacob; ni tiembles, Israel. Mira, yo te libraré de tierras lejanas, y a tu descendencia de su país de exilio. Jacob volverá a vivir,en paz y en seguridad, sin que nadie lo inquiete."
,"28":"No, no temas, siervo mío Jacob -dice el Señor-, porque yo estoy contigo. Aniquilaré a todas las naciones,donde te he dispersado; pero a ti no te exterminaré, aunque te castigaré como mereces,y no te dejaré pasar nada."
}`)
	CurrentBook.AddChapter(47, `{
"1":"Palabra del Señor que fue dirigida al profeta Jeremías acerca de los filisteos, antes que el Faraón tomase Gaza."
,"2":"Esto dice el Señor: 'Suben aguas del norte; es un río desbordante,que inunda el país y cuanto encierra, las ciudades y sus habitantes. Gritan los hombres, lanzan gemidos,todos los habitantes del país,"
,"3":"al sonar de los cascos de sus caballos, al trepidar de sus carros, al estrépito de sus ruedas. Los padres no se vuelven ya,a sus hijos, sus brazos se desploman"
,"4":"por este día que llega,para ruina de todos los filisteos, para exterminar a Tiro y a Sidón,todos los aliados que les quedan; sí, el Señor extermina a los filisteos, restos de la isla de Caftor."
,"5":"Gaza está rapada al cero, Ascalón está en silencio,y tú, Asdod, resto de los anaquitas, ¿hasta cuándo te harás cortaduras?"
,"6":"¡Oh espada del Señor!, ¿nunca descansarás?,¡Vuelve a tu vaina, detente, cálmate!"
,"7":"¿Cómo se va a calmar,si el Señor le ha dado órdenes?,Contra Ascalón y la costa del mar, allí la ha destinado'."
}`)
	CurrentBook.AddChapter(48, `{
"1":"Sobre Moab. Esto dice el Señor todopoderoso, Dios de Israel: ¡Ay de Neb, que ha sido devastado!,¡Cubierta de vergüenza Quiriat Yearín, que ha sido tomada, avergonzada, en ruinas, la ciudadela!"
,"2":"¡No existe ya la fama de Moab!,En Jesbón se maquina su infortunio: ¡Vamos a suprimirla de entre las naciones!,También tú, Madmén, vas a caer; ya la espada está vuelta contra ti."
,"3":"Gritos salen de Joronáyim: ¡Devastación! ¡Ruina inmensa!"
,"4":"¡Moab está aplastada!, se anuncia a gritos hasta en Segor."
,"5":"¡Ay!, la cuesta de Lujit,la suben llorando; ¡ay!, por la bajada de Joronáyim,se oyen gritos de angustia."
,"6":"¡Escapad, salvaos, sed como el asno salvaje en el desierto!"
,"7":"Sí, por haber confiado,en tus obras y tesoros, también tú serás tomada. Camós irá al destierro,junto con sus sacerdotes y sus príncipes."
,"8":"Invadirá el devastador toda ciudad, sin que se escape una sola; el valle será devastado, saqueada la llanura, como ha dicho el Señor."
,"9":"Dad una tumba a Moab, porque está totalmente devastada. Sus ciudades son como un desierto: nadie ya habita en ellas."
,"10":"¡Maldito aquel que hace,la obra del Señor con negligencia!,¡Maldito el que retira,su espada de la sangre!"
,"11":"Tranquilo ha vivido Moab desde su juventud; descansaba como vino en su poso, sin haber sido trasvasado jamás, sin haber partido al destierro. Por ello ha conservado su sabor,y su aroma no se ha alterado."
,"12":"Pero vienen días -dice el Señor-,en que le mandaré trasvasadores,para que lo trasvasen. Vaciarán sus ánforas,y harán pedazos sus tinajas."
,"13":"Entonces Moab se avergonzará de Camós, como Israel se avergonzó de Betel, donde había puesto su confianza."
,"14":"¿Cómo os atrevéis a decir: 'Somos unos héroes, soldados valientes en el combate'?"
,"15":"El devastador de Moab avanza,contra sus ciudadelas; la flor de su juventud,va a bajar al matadero, dice el rey, cuyo nombre es 'el Señor omnipotente'."
,"16":"Cerca está la ruina de Moab, su desventura está ya encima."
,"17":"Compadecedlo, vosotros sus vecinos, todos los que su nombre conocéis. Decid: '¡Cómo se ha hecho pedazos,el bastón potente, el cetro glorioso!'."
,"18":"Desciende de tu esplendor, siéntate en el duro suelo, población de Dibón, porque el devastador de Moab sube contra ti,y destruye tus fortalezas."
,"19":"¡Plántate en el camino y mira, población de Aroer!,Pregunta al fugitivo, al escapado di: '¿Qué ha sucedido?'."
,"20":"Moab está avergonzada por su desastre. ¡Ululad, gritad!,¡Anunciad en el Arnón,que Moab ha sido devastada!"
,"21":"Se ha ejecutado la sentencia,contra el territorio de la meseta: Yahsá y Mefat,"
,"22":"Dibón, Nebo, Bet Diblatáyim,"
,"23":"Quiriat Yearín, Bet Gamul, Bet Maón,"
,"24":"Queriyot, Bosra,y contra todas las ciudades del país de Moab, tanto próximas como lejanas."
,"25":"Moab ha perdido toda su fuerza, su brazo se ha quebrado,-dice el Señor-."
,"26":"Emborrachadlo, porque se ha levantado,contra el Señor; que Moab se revuelque en su vómito,y sea objeto de burla también él."
,"27":"¿No ha sido Israel para ti,un objeto de burla?,¿Ha sido sorprendido entre ladrones, para que menees la cabeza,siempre que hablas de él?"
,"28":"¡Abandonad las ciudades, retiraos a las rocas, habitantes de Moab!,Sed como la paloma,que pone su nido en las paredes,de los precipicios."
,"29":"Conocemos el orgullo de Moab, el muy orgulloso; su soberbia, su arrogancia, su insolencia, la altivez de su corazón."
,"30":"Conozco bien su arrogancia -dice el Señor-: la inconsistencia de su palabrería, la inconsistencia de sus obras."
,"31":"Por eso me lamento por Moab, por Moab entero clamo, gimo por los hombres de Quir Jeres."
,"32":"Más que por Yazer lloro por ti, oh viña de Sibmá; tus sarmientos se alargaban,más allá del mar; hasta Yazer llegaban. Sobre tu cosecha y tu vendimia,ha caído el devastador."
,"33":"Han desaparecido el gozo y la alegría,del viñedo y de la campiña de Moab; he hecho que falte el vino en las cubas, el pisador no pisa ya, ni resuenan los cantos de alegría."
,"34":"Los gritos de Jesbón y de Elealé llegan hasta Yahas; se grita desde Soar hasta Joronáyim y Eglat Selisiya, pues también las aguas de Nimrín se convierten en un desierto."
,"35":"Yo exterminaré de Moab -dice el Señor- a aquellos que ofrecen sacrificios en las colinas y queman incienso a sus dioses."
,"36":"Por eso mi corazón gime,por Moab como una flauta; por los habitantes de Quir Jeres gime mi corazón como una flauta; ¡se ha perdido el tesoro acumulado! "
,"37":"Toda cabeza está rasurada, toda barba cortada; en todas las manos hay cortaduras, en todas las cinturas un cilicio."
,"38":"En todas las terrazas de Moab, en sus plazas, no hay más que lamentos, porque he hecho pedazos a Moab, como vasija inútil -dice el Señor-."
,"39":"¡Ay cómo ha quedado roto! ¡Gemid! ¡Cómo ha vuelto Moab la espalda vergonzosamente! Moab se ha convertido en la irrisión, el horror de todos sus vecinos."
,"40":"Pues esto dice el Señor: El enemigo planea como un águila,y despliega sus alas sobre Moab."
,"41":"Han sido tomadas las ciudades, ocupadas las fortalezas, y el corazón de los guerreros de Moab,es en este día,como el corazón de una mujer en parto."
,"42":"Moab será exterminado de entre los pueblos, por haberse levantado contra el Señor."
,"43":"Terror, foso y lazo sobre vosotros, habitantes de Moab -dice el Señor-."
,"44":"Quien escape al terror,caerá en el foso, y quien salga del foso,quedará prendido en el lazo. Sí, traeré todo esto sobre Moab,en el año de su castigo -dice el Señor-."
,"45":"Al abrigo de Jesbón,se detienen extenuados los fugitivos. Pero un fuego sale de Jesbón, una llama del medio de Sijón, que devora las sienes de Moab, el cráneo de esta gente revoltosa."
,"46":"¡Ay de ti, Moab!,Estás perdido, pueblo de Camós. Tus hijos son llevados al exilio,y tus hijas al cautiverio."
,"47":"Pero yo cambiaré la suerte de Moab,en días futuros -dice el Señor-. Aquí termina la sentencia contra Moab."
}`)
	CurrentBook.AddChapter(49, `{
"1":"Sobre Amón. Esto dice el Señor: ¿Es que Israel no tiene hijos, no tiene herederos?,¿Por qué Melcón ha heredado Gad, y su pueblo ocupa sus ciudades?"
,"2":"Por eso, vienen días,-dice el Señor-,en que haré resonar contra Rabat Amón,el grito de guerra; quedará convertida en un montón de ruinas,y sus poblaciones vecinas serán incendiadas. Entonces Israel heredará,a sus herederos -dice el Señor-."
,"3":"Gime, Jesbón, pues ha sido devastada Ay; chillad, poblaciones de Rabat; vestíos de sayal, llorad, callejead por entre los escombros, porque Melcón es llevado al cautiverio,junto con sus sacerdotes y sus jefes."
,"4":"¿Para qué presumes de tus valles, hija desleal?,Confiada en tus tesoros, decías: '¿Quién va a venir contra mí?'."
,"5":"Yo haré venir contra ti,el terror por todas partes,-dice el Señor omnipotente-; seréis dispersados, cada uno por su lado, sin que nadie congregue a los que huyen."
,"6":"Pero después de esto,cambiaré la suerte de Amón,-dice el Señor-."
,"7":"Sobre Edón: Esto dice el Señor omnipotente: ¿No hay ya sabiduría en Temán?,¿Se ha esfumado,el consejo de los inteligentes?,¿Se ha perdido su sabiduría?"
,"8":"Huid, volved la espalda, refugiaos en sitios escondidos, habitantes de Dedán; pues voy a traer sobre Esaú su ruina, la hora de su castigo."
,"9":"Si vienen sobre ti vendimiadores, no dejarán nada de rebusco; si ladrones por la noche, saquearán todo lo que puedan."
,"10":"Sí, yo despojo a Esaú, descubro sus escondites,y no podrá ocultarse. Su descendencia, sus hermanos,y sus vecinos serán devastados; no habrá nadie que diga:"
,"11":"'Déjame a tus huérfanos, y los criaré, y tus viudas tengan confianza en mí'."
,"12":"Esto dice el Señor: Los que no estaban destinados,a beber la copa,tendrán que beberla; y tú, ¿vas a quedar libre?,No, no quedarás libre: la beberás sin remedio."
,"13":"Pues por mí mismo he jurado,-dice el Señor-,que Bosra quedará hecha un desierto, un horror, un oprobio, una maldición, y todas sus ciudades,serán ruinas perpetuas."
,"14":"He recibido del Señor un mensaje, un heraldo ha sido enviado a las gentes: 'Congregaos, marchad contra este pueblo, ¡en pie para la guerra!'."
,"15":"Pues mira, yo te he hecho pequeño entre los pueblos, despreciable entre los hombres."
,"16":"El infundir terror,y la soberbia de tu corazón,te han engañado, tú que habitas en las cuevas de las rocas,y te agarras a las vetas de los montes. Aunque pusieses tu nido en lo alto, como el águila, de allí te precipitaría,-dice el Señor-."
,"17":"Edón quedará hecho un horror; todo el que por allí pase,quedará estupefacto,y silbará al contemplar todas sus llagas."
,"18":"Como en la destrucción de Sodoma y Gomorra,y de las ciudades vecinas,-dice el Señor-, no quedará allí nadie, ni un alma volverá a vivir allí."
,"19":"Como un león que sube de la espesura del Jordán,a un pasto de perenne verdor, así, en un instante, los haré salir de allí,y estableceré a mi elegido. Pues, ¿quién hay como yo?,¿Quién me podrá desafiar?,¿Quién es el pastor,que me pueda hacer frente?"
,"20":"Escuchad la decisión,que el Señor ha tomado contra Edón,y sus proyectos contra los habitantes de Temán: Sí, serán arrastrados cual débiles ovejas, y las praderas temblarán de espanto."
,"21":"Al estruendo de su caída,se estremece la tierra,y el eco resuena hasta en el mar Rojo."
,"22":"Se remonta y planea como un águila,y despliega sus alas sobre Bosra; el corazón de los guerreros de Edón,será aquel día,como el corazón de una mujer en parto."
,"23":"Sobre Damasco. Jamat y Arpad están avergonzadas, han recibido una mala noticia; están agitadas por el mar, turbadas sin poder sosegarse."
,"24":"Damasco, amedrentado, se dispone a escapar, el terror lo invade; es presa de angustia,y de dolores como mujer en parto."
,"25":"¡Ay, qué desolada está la ciudad famosa, la ciudad alegre!"
,"26":"Sí, en sus plazas caerán sus jóvenes, y todos sus guerreros perecerán aquel día,-dice el Señor omnipotente-."
,"27":"Yo prenderé fuego a las murallas de Damasco, y devorará los palacios de Ben Hadad."
,"28":"Sobre Quedar y los reinos de Jasor, derrotados por Nabucodonosor, rey de Babilonia. Esto dice el Señor: '¡En pie, subid contra Quedar, destruid a los hijos de oriente!"
,"29":"Sean ocupados sus tiendas y rebaños, sus toldos y todos sus utensilios; sean robados sus camellos. Y se grite sobre ellos: '¡Terror por todas partes!'."
,"30":"Huid, salid aprisa, ocultaos en escondrijos, habitantes de Jasor -dice el Señor-, porque Nabucodonosor, rey de Babilonia, ha formado contra vosotros un proyecto, ha urdido un plan contra vosotros."
,"31":"¡En pie, subid,contra un pueblo tranquilo, que vive confiado,-dice el Señor-, que no tiene puertas,ni cerrojos y habita solitario!"
,"32":"Serán sus camellos el botín, sus ganados incontables la presa. Yo esparciré a los cuatro vientos,a estos beduinos de rapadas sienes, y de todas partes,les traeré su ruina -dice el Señor-."
,"33":"Jasor quedará,como guarida de chacales, un desierto para siempre; nadie más habitará en ella, ni un alma volverá a vivir allí'."
,"34":"Palabra del Señor dirigida al profeta Jeremías sobre Elán, al comienzo del reinado de Sedecías, rey de Judá."
,"35":"Esto dice el Señor omnipotente. Yo rompo el arco de Elán, lo mejor de su fuerza viril."
,"36":"Traeré sobre Elán,los cuatro vientos,de los cuatro puntos cardinales. A todos estos vientos los dispersaré, y no habrá nación,adonde no lleguen fugitivos de Elán."
,"37":"Haré temblar a Elán,ante sus enemigos, frente a los que buscan su muerte. Traeré sobre ellos la desgracia, el furor de mi cólera,-dice el Señor-. Haré que la espada los persiga,hasta que yo los haya exterminado."
,"38":"Pondré mi trono en Elán,y extirparé de allí a sus reyes y a sus jefes,-dice el Señor-."
,"39":"Pero, en días futuros, yo cambiaré la suerte de Elán,-dice el Señor-."
}`)
	CurrentBook.AddChapter(50, `{
"1":"Palabra pronunciada por el Señor sobre Babilonia y sobre el país de los caldeos por boca del profeta Jeremías."
,"2":"¡Anunciadlo entre las naciones, publicadlo, izad una señal, pregonadlo, no ocultéis nada, gritad: Ha sido tomada Babilonia, confundido Bel, Marduc vencido; avergonzadas sus imágenes, destruidos sus ídolos!"
,"3":"Pues desde el norte,avanza contra ella un pueblo,que convertirá en un desierto su tierra, y nadie más habitará allí; hombres y bestias huyen, desaparecen."
,"4":"En aquellos días, en el tiempo aquel -dice el Señor-, israelitas y judíos vendrán juntos; harán su camino llorando,en busca del Señor, su Dios."
,"5":"Preguntarán por el camino hacia Sión,y hacia allí dirigirán su rostro: '¡Venid, unámonos al Señor,con una alianza eterna, que no se olvide más!'."
,"6":"Rebaño perdido era mi pueblo; sus pastores lo extraviaban, le hacían vagar por las montañas; de monte en colina caminaba, olvidando su aprisco."
,"7":"Todo el que lo encontraba lo devoraba, y sus enemigos decían: 'En esto no hacemos ningún mal, porque han pecado contra el Señor, sede de la justicia, esperanza de sus padres'."
,"8":"Huid de Babilonia, salid del país de los caldeos, sed como machos cabríos,a la cabeza del rebaño."
,"9":"Pues ved que yo suscito,y lanzo contra Babilonia,una coalición de grandes pueblos, que llegan del norte. Caerán sobre ella, y por allí será conquistada. Sus flechas, como de expertos guerreros, no caerán en el vacío."
,"10":"Caldea será saqueada, los saqueadores se hartarán,-dice el Señor-."
,"11":"Alegraos, sí, saltad de gozo, saqueadores de mi herencia; brincad como becerros en el prado, como caballos relinchad."
,"12":"Vuestra madre está llena de vergüenza, confundida la que os dio a luz. Vedla, la última de las naciones, desierto, aridez, estepa."
,"13":"Despoblada por la ira del Señor, será una desolación total. Todos los que pasen por Babilonia,quedarán estupefactos,y silbarán al ver tantos estragos."
,"14":"Alineaos en torno a Babilonia,todos los que tensáis el arco; tirad contra ella sin ahorrar flechas, porque ha pecado contra el Señor."
,"15":"¡Lanzad gritos,por todas partes contra ella!,Ya alarga su mano, caen sus torres, se desploman sus murallas. ¡Ésta es la venganza del Señor!,¡Vengaos de ella, haced como ella hizo!"
,"16":"Exterminad de Babilonia al sembrador,y al que empuña la hoz en tiempo de la siega. Ante la espada destructora, cada uno hacia su pueblo se dirija, cada cual escape a su país."
,"17":"Oveja descarriada era Israel, acosada por leones. Primero la devoró el rey de Asiria; luego Nabucodonosor, rey de Babilonia, le ha quebrado los huesos."
,"18":"Por eso, esto dice el Señor todopoderoso, Dios de Israel: Yo castigaré al rey de Babilonia,y a su país como castigué,al rey de Asiria."
,"19":"Y haré volver a Israel,a su pradera, y pacerá en el Carmelo y el Basán, y en los montes de Efraín,y Galaad volverá a hartarse."
,"20":"En aquellos días, en el tiempo aquel -dice el Señor-,se buscará la perversión de Israel,y ya no existirá, los pecados de Judá,y no se encontrarán, pues yo perdonaré a los que haya dejado."
,"21":"¡Sube al país de Meratáyim, sube contra él y contra los habitantes de Pecod!,¡Empuña la espada, extermínalos -dice el Señor-, ejecuta mis órdenes!"
,"22":"¡Clamor de guerra en el país, desastre inmenso!"
,"23":"¡Cómo ha sido roto, hecho pedazos, el martillo de toda la tierra!,¡Cómo ha quedado hecha un horror,Babilonia entre las naciones!"
,"24":"¡Te he tendido un lazo,y has quedado presa, Babilonia, sin que lo advirtieses!,Has sido prendida,y dominada por haberte enfrentado con el Señor."
,"25":"El Señor ha abierto su arsenal,y ha sacado las armas de su cólera, pues el Señor Dios todopoderoso,va a actuar en el país de los caldeos."
,"26":"Venid de todas partes contra ella, abrid sus graneros, amontonad el botín,como haces y destruidlo; que no quede nada de ella."
,"27":"Degollad todos sus toros, bajen al matadero. ¡Ay de ellos, que ha llegado su día, la hora de su castigo!"
,"28":"¿Oís? Fugitivos y escapados,del país de Babilonia,vienen a anunciar en Sión,la venganza del Señor, nuestro Dios."
,"29":"¡Convocad contra Babilonia a los arqueros!,Vosotros todos, los que tensáis el arco, acampad en torno a ella, que no tenga escape. Pagadle con arreglo a sus obras; todo lo que ella hizo, haced con ella, pues se ha insolentado contra el Señor, contra el Santo de Israel."
,"30":"Por eso caerán en sus calles,sus jóvenes y todos sus guerreros,perecerán aquel día,-dice el Señor-."
,"31":"Aquí estoy contra ti, oh insolencia -dice el Señor Dios omnipotente-; ha llegado tu día, la hora de tu castigo."
,"32":"Temblará la insolencia y caerá, sin tener quien la levante. Prenderé fuego a sus ciudades, y devorará todos sus contornos."
,"33":"Esto dice el Señor omnipotente: Oprimidos están los israelitas y los judíos; todos los que los han hecho cautivos,los retienen y se resisten a soltarlos."
,"34":"Pero su libertador es poderoso: su nombre es 'el Señor omnipotente'; él sabrá defender su causa, a fin de dar paz al país,y turbación a los habitantes de Babilonia."
,"35":"¡Espada contra los caldeos,-dice el Señor-, contra los habitantes de Babilonia, contra sus jefes y sus sabios!"
,"36":"¡Espada sobre sus adivinos, que se hagan necios; espada sobre sus guerreros, que cojan pánico!"
,"37":"¡Espada sobre sus caballos y sus carros, y sobre toda la amalgama de gentes,que hay en medio de ella, para que sean como mujeres!"
,"38":"¡Espada sobre sus tesoros, que sean saqueados!,¡Espada sobre sus aguas, que se sequen, porque es un país de ídolos,y están locos por sus espantajos!"
,"39":"Por eso allí habitarán las fieras y los chacales, los avestruces tendrán allí su morada. No volverá a ser habitada jamás, ni repoblada en todas las generaciones."
,"40":"Como en la destrucción de Sodoma y Gomorra,y de las ciudades vecinas,-dice el Señor-, no quedará allí nadie, ni un alma volverá a vivir allí."
,"41":"Viene un pueblo del norte, una gran nación; reyes numerosos se levantan,desde los confines de la tierra."
,"42":"Empuñan arco y jabalina, son bárbaros e inexorables; su ruido es como el bramido del mar; van a caballo, armado cada uno para la guerra,contra Babilonia."
,"43":"El rey de Babilonia ha tenido noticia,y han desfallecido sus brazos; le ha invadido la angustia, dolores como de mujer en parto."
,"44":"Como un león que sube de la espesura del Jordán,a una pradera de perenne verdor, así, en un instante, les haré salir de allí,y estableceré a mi elegido. Pues, ¿quién hay como yo?,¿Quién me podrá desafiar?,¿Quién es el pastor,que me puede hacer frente?"
,"45":"Escuchad, pues, la decisión,que ha tomado el Señor contra Babilonia,y sus proyectos contra el país de los caldeos: Sí, serán arrastrados cual débiles ovejas, y ante ellos sus praderas,temblarán de espanto."
,"46":"Al estruendo de la caída de Babilonia,se estremece la tierra,y el eco resuena entre las naciones."
}`)
	CurrentBook.AddChapter(51, `{
"1":"Esto dice el Señor: Voy a suscitar contra Babilonia,y contra los habitantes de Leb-Camay,el espíritu de un exterminador."
,"2":"Y mandaré a Babilonia,aventadores para aventarla,y limpiar su país. Pues la van a asediar,por todas partes en el día de la desgracia."
,"3":"¡No entese el arquero su arco, ni se cubra con su coraza!,No perdonéis a sus jóvenes, aniquilad todo su ejército."
,"4":"¡Caigan muertos en el país de los caldeos, atravesados en las calles de Babilonia!"
,"5":"Porque su tierra está llena,de delitos contra el Santo de Israel. Pero Israel y Judá,no están viudas de su Dios, el Señor omnipotente."
,"6":"¡Huid de Babilonia, cada cual salve su vida!,No perezcáis en su castigo, porque es la hora de la venganza del Señor,y va a pagarle como se merece."
,"7":"Una copa de oro era Babilonia,en las manos del Señor; toda la tierra emborrachaba; de su vino bebieron las naciones, y por eso deliraban."
,"8":"De repente ha caído Babilonia,y se ha hecho pedazos. ¡Ululad sobre ella!,Tomad bálsamo para su dolor, tal vez se cure."
,"9":"Queríamos curar a Babilonia, pero no se ha curado. Dejémosla y marchémonos,cada uno a nuestra tierra. Sí, su condenación llega hasta el cielo, se eleva hasta las nubes."
,"10":"El Señor ha hecho resplandecer nuestra justicia; venid, cantemos en Sión,la obra del Señor, nuestro Dios."
,"11":"¡Afilad las flechas, llenad las aljabas!,El Señor ha excitado,el espíritu del rey de los medos,y su plan contra Babilonia es destruirla; ésta es la venganza del Señor, la venganza por su templo."
,"12":"Contra los muros de Babilonia,izad bandera, reforzad la guardia, apostad centinelas, tended emboscadas, pues el Señor tenía un proyecto,y ha ejecutado,lo que había anunciado,contra los habitantes de Babilonia."
,"13":"¡Oh, tú que moras,a orillas de aguas abundantes, cuajada de tesoros, ha llegado tu fin, el término de tu destino!"
,"14":"El Señor omnipotente ha jurado por sí mismo: Yo te inundaré de hombres como de langostas, y levantarán sobre ti el grito de triunfo."
,"15":"Él ha hecho la tierra con su poder, ha asentado al mundo con su sabiduría,y con su inteligencia ha desplegado los cielos."
,"16":"A su voz se acumulan,las aguas en el cielo; hace subir las nubes,del extremo de la tierra, para la lluvia produce los relámpagos,y saca de sus depósitos el viento."
,"17":"Entonces todo hombre,se siente estúpido, insensato; todo orfebre se avergüenza de su ídolo, porque lo que ha fundido,no es más que mentira, que carece de aliento."
,"18":"Cosa vana son, obras ridículas. En el tiempo de su castigo desaparecerán."
,"19":"No es así la porción de Jacob, porque él ha formado el universo,e Israel es la tribu de su heredad; su nombre es 'el Señor omnipotente'."
,"20":"Tú has sido un martillo en mis manos, un arma de guerra. Contigo he machacado a las naciones, contigo he destruido muchos reinos;"
,"21":"contigo he machacado caballo y caballero; contigo he machacado carro y conductor;"
,"22":"contigo he machacado hombre y mujer, contigo he machacado anciano y niño, contigo he machacado joven y doncella,"
,"23":"contigo he machacado rebaño y pastor, contigo he machacado labrador y yunta, contigo he machacado gobernadores y magistrados."
,"24":"Pero a vuestros propios ojos,yo haré pagar a Babilonia,y a todos los habitantes de Caldea,todo el mal que han hecho,a Sión -dice el Señor-."
,"25":"Aquí estoy contra ti, montaña destructora -dice el Señor-, que arrasas toda la tierra. Voy a extender mi mano contra ti, te haré rodar de lo alto de las rocas,y te convertiré en monte calcinado."
,"26":"No se volverá a sacar de ti,piedra angular ni piedra de cimiento, pues quedarás como desolación perpetua,-dice el Señor-."
,"27":"Alzad bandera por la tierra, tocad la trompeta entre las naciones, preparad pueblos contra ella, convocad contra ella,a los reinos de Ararat, Miní y Asquenaz; enviad contra ella,el oficial de reclutamiento, lanzad los caballos,como nube de langostas erizadas."
,"28":"Preparad naciones para atacarla, a los reyes de Media, a sus gobernadores, a todos sus sátrapas,y a todo el territorio de su imperio."
,"29":"Tiembla la tierra y se estremece, porque se cumple,el decreto del Señor contra Babilonia: reducir el país de Babilonia,a un desierto despoblado."
,"30":"Han dejado de luchar,los guerreros de Babilonia, se han refugiado en las fortalezas; están agotadas sus fuerzas, se han convertido en mujeres. Han sido incendiadas sus moradas, hechos pedazos sus cerrojos."
,"31":"Se ven correr correo tras correo, mensajero tras mensajero, para anunciar al rey de Babilonia,que ha sido tomada su ciudad,por todos lados;"
,"32":"que los vados han sido ocupados, incendiados los baluartes,y que los guerreros están aterrados."
,"33":"Pues esto dice el Señor omnipotente, Dios de Israel: Babilonia es como una era,en la época en que se la pisa; dentro de poco llegará para ella,el tiempo de la cosecha."
,"34":"Me ha devorado, me ha consumido Nabucodonosor, rey de Babilonia; me ha dejado como un plato vacío, me ha tragado lo mismo que un dragón, ha llenado su vientre con mis mejores trozos."
,"35":"'¡Caigan sobre Babilonia,mis ultrajes y mis penas!',dice el pueblo de Sión. '¡Sobre los habitantes de Caldea mi sangre!', exclama Jerusalén."
,"36":"Por eso, esto dice el Señor: Mira, yo tomo en mis manos tu causa,y ejecutaré por ti la venganza. Haré que se seque su río,y agotaré sus fuentes."
,"37":"Babilonia quedará hecha un montón de piedras, guarida de chacales, horror y rechifla, vacía de habitantes."
,"38":"A una rugen como leones, gruñen como leoncillos."
,"39":"Cuando tengan calor, les serviré bebida; los emborracharé hasta que se aturdan,y caigan en sueño eterno,para no despertar jamás,-dice el Señor-."
,"40":"Los llevaré como corderos al matadero, como carneros y machos cabríos."
,"41":"¡Cómo ha sido tomada y conquistada,la que era gloria de toda la tierra!,¡Cómo ha quedado hecha un horror Babilonia,entre las naciones!"
,"42":"El mar ha invadido a Babilonia, la ha ahogado bajo la masa de sus olas."
,"43":"Sus ciudades se han convertido,en un desierto, en tierra árida, en estepa; nadie ya vivirá allí, ni un alma volverá a pasar por ella."
,"44":"Yo castigaré a Bel en Babilonia,y arrancaré de sus fauces,lo que ha devorado. Hacia él no afluirán,nunca más las naciones. Ya se ha desplomado,la muralla de Babilonia."
,"45":"Sal de en medio de ella, pueblo mío, y sálvese quien pueda del ardor,de la ira del Señor."
,"46":"No os acobardéis,ni os asustéis,por las noticias,que circularán por el país, pues un año correrá un rumor,y al año siguiente otro; la violencia reinará en el país,y un tirano suplantará a otro."
,"47":"Por eso, vienen días,en que visitaré a los ídolos de Babilonia. Toda su tierra se avergonzará,y todas sus víctimas yacerán,en medio de ella."
,"48":"Entonces el cielo y la tierra,y cuanto encierran entonarán sobre Babilonia,un cántico de triunfo, porque del norte llegan contra ella,los devastadores -dice el Señor-."
,"49":"Babilonia tiene que caer también,por los caídos de Israel, como por Babilonia cayeron,los muertos de toda la tierra."
,"50":"Vosotros, los escapados de la espada, salid, no os detengáis. Invocad al Señor en esta tierra lejana,y acordaos de Jerusalén."
,"51":"Estamos avergonzados escuchando insultos; la vergüenza ha cubierto nuestros rostros, porque han entrado extranjeros,en el santuario del templo del Señor."
,"52":"Por eso, vienen días -dice el Señor-,en que yo castigaré a sus ídolos,y en toda su tierra gemirán los caídos."
,"53":"Aunque Babilonia se elevara hasta el cielo,e hiciera inaccesibles sus fortalezas,en las altas esferas, de mi parte les alcanzarían los devastadores,-dice el Señor-."
,"54":"¡Escuchad! Agudos gritos,salen de Babilonia, un gran estrago del país de los caldeos."
,"55":"Es que el Señor devasta a Babilonia,y pone fin a su gran ruido,por más que sus olas rujan,como las grandes aguas,y resuene el estruendo de su voz."
,"56":"Pues un devastador cae sobre Babilonia,y son apresados sus guerreros, rotos sus arcos. Porque el Señor,es el Dios de las retribuciones,y paga meticulosamente."
,"57":"Yo emborracharé a sus príncipes,y a sus sabios, a sus gobernadores, sátrapas y héroes, y dormirán un sueño eterno,para no despertar -dice el rey-, cuyo nombre es 'El Señor omnipotente'."
,"58":"Esto dice el Señor omnipotente: La ancha muralla de Babilonia,será totalmente arrasada,y sus altas puertas consumidas por el fuego. Así los pueblos se fatigan por nada,y las naciones se cansan para el fuego."
,"59":"Orden dada por el profeta Jeremías a Serayas, hijo de Nerías, hijo de Majsías, cuando partió con Sedecías, rey de Judá, a Babilonia, el año cuarto de su reinado. Serayas era el mayordomo de viaje."
,"60":"Jeremías había escrito en un libro todo el mal que había de sobrevenir a Babilonia, todas estas palabras escritas acerca de Babilonia."
,"61":"Jeremías dijo a Serayas: 'Cuando llegues a Babilonia, cuida de leer todas estas palabras."
,"62":"Y dirás: ¡Señor! Tú mismo has sentenciado que este lugar será destruido y que nadie lo volverá a habitar; ni hombre, ni bestia, sino que será un perpetuo desierto."
,"63":"Y cuando hayas terminado de leer este libro, atarás a él una piedra y lo tirarás al fondo del Éufrates,"
,"64":"diciendo: ¡Así se hundirá Babilonia para no volver a resurgir de la desgracia que yo haré caer sobre ella!'. Hasta aquí las palabras de Jeremías."
}`)
	CurrentBook.AddChapter(52, `{
"1":"Veintiún años tenía Sedecías cuando subió al trono, y reinó en Jerusalén once años. Su madre se llamaba Jamital, hija de Jeremías, nativo de Libná."
,"2":"Hizo lo que desagrada al Señor, exactamente como había hecho Joaquín."
,"3":"Lo que sucedió en Jerusalén y Judá fue a causa de la ira del Señor, hasta llegar a rechazarla de su presencia. Sedecías se rebeló contra el rey de Babilonia."
,"4":"Y en el año noveno de su reinado, el día diez del décimo mes, Nabucodonosor, rey de Babilonia, llegó con todo su ejército contra Jerusalén. Acampó junto a ella y levantó alrededor un terraplén de asedio."
,"5":"La ciudad estuvo cercada hasta el año undécimo de Sedecías."
,"6":"El día nueve del mes cuarto, debido al hambre que se apoderaba de la ciudad y a la falta de víveres para la población,"
,"7":"abrieron una brecha en el muro de la ciudad, y el rey y todos los hombres de guerra salieron huyendo durante la noche por el camino de la puerta situada entre los dos muros, junto al jardín del rey -los caldeos cercaban la ciudad-, y tomaron el camino de la Arabá."
,"8":"Pero el ejército de los caldeos salió en persecución del rey, y dieron alcance a Sedecías en la llanura de Jericó; todos sus hombres lo abandonaron y se dispersaron."
,"9":"Prendieron al rey, lo llevaron a Ribla, en la región de Jamat, ante el rey de Babilonia, el cual pronunció la sentencia contra él."
,"10":"El rey de Babilonia mandó degollar a los hijos de Sedecías, ante sus propios ojos; asimismo degolló en Ribla a todos los dignatarios de Judá."
,"11":"Luego sacó los ojos a Sedecías y lo aherrojó con una doble cadena de bronce; finalmente, el rey de Babilonia lo llevó a Babilonia y lo metió en la cárcel, donde estuvo hasta el día de su muerte."
,"12":"El día diez del quinto mes -era el año diecinueve de Nabucodonosor, rey de Babilonia-, llegó a Jerusalén Nebuzardán, jefe de la escolta y del servicio personal del rey de Babilonia,"
,"13":"y prendió fuego al templo del Señor, al palacio real y a todas las casas de Jerusalén."
,"14":"Las tropas caldeas que estaban a las órdenes del jefe de la escolta demolieron toda la muralla de Jerusalén."
,"15":"Nebuzardán, jefe de la escolta, deportó al resto del pueblo que había quedado en la ciudad, a los que se habían pasado al rey de Babilonia y a todos los artesanos que quedaban."
,"16":"Sin embargo, Nebuzardán, jefe de la escolta, dejó parte de los pobres del país como viñadores y agricultores."
,"17":"Los caldeos hicieron pedazos las columnas de bronce del templo del Señor, así como las basas y la gran pila de bronce que había en el templo del Señor, y se llevaron todo el bronce a Babilonia."
,"18":"Se llevaron también las ollas, las paletas, los cuchillos, los aspersorios, los acetres y todos los demás utensilios de bronce utilizados para el culto."
,"19":"El jefe de la escolta se llevó también los barreños, los braseros, los acetres y las copas para las ofrendas de vino, todo lo que era de oro y plata."
,"20":"Las dos columnas, la gran pila para el agua, los doce bueyes de bronce que la sostenían y las basas que había hecho el rey Salomón para el templo del Señor; era imposible calcular lo que pesaba el bronce de todo esto."
,"21":"Por lo que hace a las columnas, tenía cada una de ellas nueve metros de altura, seis de circunferencia y ocho centímetros de espesor; por dentro estaban vacías."
,"22":"La coronaba un capitel de bronce de cinco codos de alto, y rodeado todo él, en forma de corona, por una rejilla con granadas, todo ello de bronce. La otra columna era igual, con el mismo número de granadas."
,"23":"Las granadas que pendían eran noventa y seis. El total de las granadas diseminadas en la rejilla era de cien."
,"24":"El jefe de la escolta apresó al sumo sacerdote, Serayas; al segundo sacerdote, Sofonías, y a los tres guardianes del umbral del templo."
,"25":"Entre los ciudadanos hizo prisionero a un eunuco, comisario de los hombres de guerra, y a siete familiares del rey que fueron encontrados en la ciudad; al secretario del jefe del ejército, encargado del reclutamiento, y a sesenta hombres del pueblo que se encontraban en la ciudad."
,"26":"Nebuzardán, jefe de la escolta, los hizo prisioneros y los llevó a Ribla ante el rey de Babilonia."
,"27":"Y el rey de Babilonia los mató en Ribla, en la región de Jamat. Así fue deportado Judá lejos de su tierra."
,"28":"El número de los deportados por Nabucodonosor es el siguiente. En el año séptimo: Tres mil veintitrés judíos;"
,"29":"el año dieciocho de Nabucodonosor fueron deportados de Jerusalén ochocientas treinta y dos personas;"
,"30":"el año veintitrés de Nabucodonosor, Nebuzardán, jefe de la escolta, deportó setecientos cuarenta y cinco judíos. En total: cuatro mil seiscientas personas."
,"31":"En el año treinta y siete de la deportación de Jeconías, rey de Judá, el día veinticinco del duodécimo mes, Evil Merodac, rey de Babilonia, el año de su subida al trono, indultó a Jeconías, rey de Judá, y lo sacó de la cárcel."
,"32":"Le habló amigablemente y le otorgó un trono más alto que el de los otros reyes que estaban con él en Babilonia;"
,"33":"mudó también sus ropas de cárcel y lo hizo sentar a su mesa los días restantes de su vida."
,"34":"Y el rey de Babilonia proveyó a su subsistencia cotidiana, mientras duró su vida, hasta el día de su muerte."
}`)

}
func ES_LSB_LoadVMISChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Visión que Isaías, hijo de Amós, tuvo acerca de Judá y Jerusalén en los días de Ozías. Jotán, Acaz y Ezequías, reyes de Judá."
,"2":"Escuchad, cielos; presta, tierra, oído, porque habla el Señor: He alimentado, he hecho crecer hijos, y ellos se han sublevado contra mí."
,"3":"Conoce el buey a su señor,y el asno el pesebre de su amo. Israel, en cambio, no conoce; mi pueblo no comprende."
,"4":"¡Ay, nación pecadora, pueblo cargado de crímenes, ralea de malvados, hijos perversos!,Han abandonado al Señor, han despreciado al Santo de Israel, le han vuelto la espalda."
,"5":"¿Para qué golpearos todavía, si os seguís rebelando?,Enferma está toda la cabeza, el corazón entero dolorido."
,"6":"Desde la planta del pie,hasta la cabeza,no hay en él nada sano: heridas, contusiones, llagas vivas, no curadas, ni vendadas, ni suavizadas con aceite."
,"7":"Vuestro país es un desierto; vuestras ciudades, pasto del fuego; vuestro suelo, ante vuestros mismos ojos, extranjeros lo devoran; es una desolación, como las ruinas de Sodoma."
,"8":"La hija de Sión ha quedado,como una choza en una viña, como un tugurio en melonar, como ciudad sitiada."
,"9":"Si el Señor todopoderoso,no nos hubiera dejado un residuo, seríamos como Sodoma, iguales a Gomorra."
,"10":"¡Escuchad la palabra del Señor, jefes de Sodoma; prestad oído a la ley de nuestro Dios, pueblo de Gomorra!"
,"11":"¿Qué me importa,la multitud de vuestros sacrificios?,-dice el Señor-. Estoy harto de holocaustos,de carneros y de grasas de becerros; la sangre de novillos, de corderos,y de machos cabríos me hastía."
,"12":"Cuando venís a presentaros ante mí, ¿quién pide esto de vosotros?,Dejad de hollar mis atrios"
,"13":"para traerme ofrendas vanas; me causa horror su incienso. Novilunios, sábados, asambleas...  ¡ya no soporto más sacrificios,ni fiestas!"
,"14":"Vuestros novilunios, vuestras solemnidades,me son aborrecibles: se me han vuelto un peso, y estoy harto de aguantarlas."
,"15":"Cuando extendéis las manos, aparto mis ojos de vosotros; aunque multipliquéis,vuestras plegarias, no las escucho. Vuestras manos están llenas,de sangre."
,"16":"Lavaos, purificaos, alejad,vuestras malas acciones de mis ojos; dejad de hacer el mal."
,"17":"Aprended a hacer el bien, buscad lo que es justo, socorred al oprimido, haced justicia al huérfano, defended a la viuda."
,"18":"Venid, pues, y discutamos, dice el Señor. Aunque vuestros pecados,sean como la grana, blanquearán como la nieve; si fueren rojos cual la púrpura, se volverán como la lana."
,"19":"Si sois sumisos y obedientes, comeréis los frutos del país;"
,"20":"pero si resistís y os rebeláis, seréis devorados por la espada. Lo ha dicho el Señor."
,"21":"¡Cómo se ha prostituido,la ciudad fiel, Sión, tan llena de justicia!,Moraba en ella el derecho; ¡ahora, en cambio, asesinos!"
,"22":"Tu plata se ha convertido en escoria, tu vino está mezclado con agua."
,"23":"Tus jefes son unos rebeldes, compinches de ladrones; todos hambrean recompensas,y van detrás de los regalos; no hacen justicia al huérfano, ni atienden la causa de la viuda."
,"24":"Por eso dice el Señor todopoderoso, el Fuerte de Israel: ¡Ah, yo me vengaré,de mis adversarios, daré cuenta de mis enemigos!"
,"25":"Volveré mi mano contra ti, fundiré tus escorias,y apartaré tu plomo."
,"26":"Haré a tus jueces como eran,y a tus consejeros como antes. En adelante se te llamará: ciudad de la justicia, ciudad fiel."
,"27":"Sión será redimida con el derecho, y sus convertidos con la justicia."
,"28":"Los rebeldes y los pecadores,serán a una destrozados, y aquellos que se alejen del Señor,perecerán."
,"29":"¡Oh, sí, tendréis vergüenza,de los terebintos,en que ahora os deleitáis, y os sonrojaréis de los jardines,que tanto os gustan!"
,"30":"Pues quedaréis igual,que un terebinto de hojas marchitas, lo mismo que un jardín,que ya no tiene agua."
,"31":"El hombre fuerte se hará estopa, y su obra una chispa; arderán los dos juntos, y no habrá quien lo extinga."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Visión de Isaías, hijo de Amós, acerca de Judá y Jerusalén."
,"2":"Sucederá en los días venideros,que el monte de la casa del Señor,será afincado en la cima,de los montes,y se alzará por encima,de los collados. Afluirán a él todas las gentes,"
,"3":"vendrán muchos pueblos y dirán: Venid, subamos al monte del Señor, a la casa del Dios de Jacob, para que nos enseñe sus caminos,y caminemos por sus sendas. Pues de Sión saldrá la ley,y de Jerusalén la palabra del Señor."
,"4":"Él gobernará las naciones,y dictará sus leyes a pueblos numerosos, que trocarán sus espadas en arados,y sus lanzas en hoces. No alzará ya la espada,pueblo contra pueblo,ni se entrenarán ya para la guerra."
,"5":"Casa de Jacob, venid; caminemos a la luz del Señor."
,"6":"Sí, tú has rechazado a tu pueblo, a la casa de Jacob; pues está llena de adivinos,y de agoreros, como los filisteos, y pacta con extranjeros."
,"7":"Su país está lleno de oro y plata, y sus tesoros son innumerables. Su país está lleno de caballos; innumerables son sus carros."
,"8":"Su país está lleno de ídolos: ellos se postran,ante la obra de sus manos, ante la hechura de sus dedos."
,"9":"Será el hombre humillado, el mortal abatido. ¡No los perdones!"
,"10":"Métete entre las rocas, escóndete en el polvo,ante el terror del Señor, de su imponente majestad, cuando venga a hacer temblar,la tierra."
,"11":"Los ojos soberbios del hombre,serán abatidos, y la arrogancia de los mortales,se doblegará; sólo el Señor será exaltado,el día aquel."
,"12":"Pues el Señor todopoderoso,tendrá su día,contra toda soberbia y todo orgullo, contra todo lo que se alza, para abatirlo;"
,"13":"contra todos los altos cedros,del Líbano, contra todas las encinas de Basán;"
,"14":"contra todas las montañas altivas, contra todas las colinas elevadas;"
,"15":"contra todas las torres excelsas, contra todas las murallas escarpadas;"
,"16":"contra todas las naves de Tarsis, contra todos los objetos preciosos."
,"17":"La arrogancia humana,será humillada, el orgullo del hombre será abatido; sólo el Señor será exaltado,el día aquel."
,"18":"Desaparecerán todos los ídolos."
,"19":"Se meterán en las grietas,de las rocas, en los antros de la tierra,ante el terror del Señor,y su imponente majestad, cuando venga a hacer,temblar la tierra."
,"20":"Aquel día todos arrojarán,a los topos y a los murciélagos,sus ídolos de plata,y sus ídolos de oro, que se hicieron para adorarlos."
,"21":"Se meterán en las grietas,de las rocas,y en los recodos de las peñas,ante el terror del Señor,y su imponente majestad, cuando venga a hacer,temblar la tierra."
,"22":"Dejad de confiar en el hombre, pues sólo un soplo hay en su nariz. ¿Cuánta estima merece?"
}`)
	CurrentBook.AddChapter(3, `{
"1":"Sí, el Señor Dios todopoderoso,quitará a Jerusalén y a Judá,todo apoyo y sostén, todo sostén de pan, todo sostén de agua:"
,"2":"el fornido, el guerrero, el juez, el profeta, el adivino y el anciano,"
,"3":"el capitán, el notable, el consejero, el hábil hechicero,y el sabio encantador."
,"4":"Y les pondrá muchachos por jefes, jovenzuelos los dirigirán."
,"5":"El pueblo se alzará, hombre contra hombre, vecino contra vecino; se lanzará el joven,contra el anciano, el plebeyo contra el noble."
,"6":"Y cada cual agarrará a su hermano,en la casa de su padre: Tú tienes manto, sé nuestro jefe; toma en tus manos estas ruinas."
,"7":"Pero él protestará el día aquel: Yo no soy médico, ni hay en mi casa pan ni manto; no me hagáis jefe del pueblo."
,"8":"Así Jerusalén caerá en ruinas,y Judá se hundirá, pues sus palabras,y sus hechos se oponen al Señor,y desafían su majestad."
,"9":"Su rostro descarado los delata; como Sodoma descubren sus pecados, no los ocultan. ¡Ay de ellos, que su propia desgracia,están fraguando!"
,"10":"Decid: ¡Dichoso el justo, pues comerá del fruto de sus obras!"
,"11":"¡Ay del injusto! Mal le irá, se le dará según la obra,de sus manos."
,"12":"Niños dominan a mi pueblo, mujeres lo gobiernan. Pueblo mío, tus conductores te extravían, pervierten la senda de tus pasos."
,"13":"El Señor se levanta ante el tribunal, en pie está para juzgar al pueblo."
,"14":"Entra en juicio el Señor,con los ancianos,y los jefes de su pueblo: Vosotros habéis devastado la viña, guardáis en casa lo robado al pobre."
,"15":"¿Por qué pisoteáis a mi pueblo,y aplastáis el rostro de los pobres?,Oráculo del Señor Dios todopoderoso."
,"16":"El Señor dice: Por la altivez de las hijas de Sión, que pasan erguida la cabeza,y los ojos provocadores; que caminan a pasitos menudos, haciendo tintinear,los aros de sus pies,"
,"17":"el Señor llenará de tiña,la cabeza de las hijas de Sión, el Señor descubrirá su vergüenza."
,"18":"Aquel día el Señor,arrancará los adornos: hebillas de pies, redecillas y lunetas,"
,"19":"pendientes, brazaletes, velos,"
,"20":"diademas, cadenillas de pies, cinturones, frascos de perfume y amuletos,"
,"21":"sortijas, aros de nariz,"
,"22":"vestidos preciosos, mantos, chales y bolsos,"
,"23":"espejos, lienzos finos, turbantes y mantillas."
,"24":"Y ved lo que sucederá: en lugar de perfume,habrá podredumbre; en lugar de cinturón, una cuerda; en lugar de peinados, calvicie; en lugar de vestidos lujosos,habrá un saco; en lugar de belleza, la marca de la infamia."
,"25":"Tus hombres caerán bajo la espada, y tus héroes en la lucha."
,"26":"Llanto y lamento habrá,en tus puertas, y yacerás desolada en el polvo."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Aquel día siete mujeres,se disputarán a un hombre,y le dirán: Nosotras comeremos nuestro pan,y nuestro vestido vestiremos; deja sólo que llevemos tu nombre, quítanos nuestra infamia."
,"2":"Aquel día el brote del Señor,será ornamento y gloria, y el fruto de la tierra,será orgullo y esplendor,de los librados de Israel."
,"3":"El que quede en Sión,y sobreviva en la ciudad,será llamado santo, será inscrito,para sobrevivir en Jerusalén."
,"4":"Cuando el Señor haya lavado,la mancha de las hijas de Sión,y haya limpiado a Jerusalén,de la sangre en ella derramada, cuando dicte la sentencia,y ejecute la pena,"
,"5":"entonces el Señor formará, sobre toda la extensión,del monte de Sión,y sobre sus asambleas, una nube de humo durante el día,y un resplandor de fuego llameante,por la noche. Pues encima de todo,la gloria del Señor será tienda"
,"6":"y cabaña, para dar sombra,de día contra el calor, y refugio y amparo,contra la tempestad y la lluvia."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Quiero cantar para mi amigo,una canción de amor hacia su viña. Mi amigo tenía una viña,en una loma feraz."
,"2":"La cavó, quitó las piedras, plantó cepas selectas; en medio de ella construyó una torre,y excavó también un lagar; esperaba que produjera uvas, pero sólo produjo agrazones."
,"3":"Ahora, habitantes de Jerusalén, hombres de Judá, juzgad entre mí y mi viña."
,"4":"¿Qué más podía hacerse con mi viña,que no lo haya hecho yo?,¿Por qué, si esperaba que diera uvas, sólo ha dado agrazones?"
,"5":"Ahora, pues, os diré,qué voy a hacer con mi viña: le quitaré el seto, y servirá de pasto; derribaré la tapia, y será pisoteada."
,"6":"Haré de ella un desierto; no será más podada ni escardada; toda será cardos y abrojos; y mandaré a las nubes,que no dejen caer más lluvia,sobre ella."
,"7":"Sí, la viña del Señor omnipotente,es el pueblo de Israel; y los hombres de Judá, su plantel escogido. El Señor esperaba de ellos,respeto a la ley, y hay sangre derramada; esperaba justicia, y sólo hay gritos de dolor."
,"8":"¡Ay de aquellos,que añaden casas a casas,y juntan campos con campos,hasta ocupar todo el lugar,y quedar como únicos propietarios,del país!"
,"9":"En mis oídos ha sonado,la palabra del Señor omnipotente: ¡Las muchas casas quedarán en ruinas; grandes y bellas, no habrá quien las habite!"
,"10":"Pues diez yugadas de viña,sólo producirán,cuarenta y cinco litros, y cuatrocientos cincuenta de semilla,sólo cuarenta y cinco."
,"11":"¡Ay de aquellos,que desde la mañana,se dan a las bebidas fuertes, y de noche hasta muy tarde,continúan bien calientes de vino!"
,"12":"Cítara y arpa, tambor, flauta,y vino no faltan en sus banquetes; pero no piensan en la obra del Señor, no atienden a la hechura,de sus manos."
,"13":"Por eso mi pueblo irá al destierro,por falta de inteligencia; sus nobles morirán de hambre, y sus gentes se abrasarán de sed."
,"14":"Por eso el abismo,ha ensanchado sus fauces, ha abierto su boca sin medida; ¡baja allá la grandeza (de Sión),y su turba bulliciosa y alegre!"
,"15":"Será doblegado el mortal, será humillado el hombre, y los ojos de los soberbios, abatidos."
,"16":"Pero el Señor omnipotente,será exaltado al juzgar; el Dios santo su santidad,mostrará al hacer justicia."
,"17":"Los corderos pastarán,como en su pasto, y los cabritos engordarán,entre las ruinas."
,"18":"¡Ay de aquellos,que tiran del castigo,con las cuerdas de la injusticia, y de la pena del pecado,como con cuerda de carreta;"
,"19":"de los que dicen: Que se dé prisa, que acelere su obra,para que la veamos, que se presenten,y que se realicen los planes,del Santo de Israel,para que los conozcamos."
,"20":"¡Ay de aquellos,que llaman bien al mal,y mal al bien; que cambian las tinieblas en luz,y la luz en tinieblas; que dan lo amargo por dulce,y lo dulce por amargo!"
,"21":"¡Ay de los sabios,a sus propios ojos, y en su estima prudentes!"
,"22":"¡Ay de los que triunfan,en beber vino,y son campeones,en mezclar bebidas fuertes;"
,"23":"de los que por soborno,absuelven al culpable,y no hacen justicia al inocente!"
,"24":"Como la lengua de la llama,devora el rastrojo,y como el heno es consumido,por el fuego, así su raíz se pudrirá,y su flor será aventada como polvo, por rechazar la ley,del Señor todopoderoso y despreciar,la palabra del Santo de Israel."
,"25":"Por eso la ira del Señor,se ha encendido contra su pueblo, extendió su mano contra él y lo hirió; temblaron los montes; sus cadáveres fueron,como carroña en medio de las calles. Con todo, su cólera no ha amainado; su mano aún está extendida."
,"26":"Hace señal a un pueblo lejano, con silbido le llama,desde el extremo de la tierra; mirad, ya se acerca veloz."
,"27":"Nadie es débil en él, nadie vacila, ni dormita, ni duerme, ni suelta el cinto de sus lomos, ni rompe la correa de sus sandalias."
,"28":"Son afiladas sus saetas, tensos están todos sus arcos; los cascos de sus caballos,son como pedernal, las ruedas de sus carros,igual que el huracán."
,"29":"Su rugido es como el de un león; ruge como los cachorros; gruñe, agarra la presa, la lleva y nadie se la quita."
,"30":"Habrá aquel día contra él,un bramido,como el bramido de la mar; mirarán al país, y habrá sólo oscuridad; la luz quedará oscurecida,por espesas nubes."
}`)
	CurrentBook.AddChapter(6, `{
"1":"El año de la muerte del rey Ozías,vi al Señor sentado,en su trono elevado y excelso: la orla de su vestido llenaba el templo."
,"2":"Estaban de pie serafines,por encima de él, cada uno con seis alas: con dos cubrían el rostro; con dos, los pies, y con las otras dos volaban."
,"3":"Y se gritaban el uno al otro Santo, santo, santo, Señor todopoderoso; la tierra toda está llena de su gloria."
,"4":"Las jambas del dintel retemblaban,por la voz de los que gritaban, y el templo se llenó de humo."
,"5":"Yo exclamé: ¡Ay de mí, estoy perdido, pues soy hombre de labios impuros; vivo entre un pueblo de labios impuros, y mis ojos han visto al rey, al Señor todopoderoso."
,"6":"Entonces voló hacia mí,uno de los serafines,llevando un carbón encendido,que había tomado del altar,con unas tenazas."
,"7":"Tocó con él mi boca y dijo: Mira, esto ha tocado tus labios: tu maldad queda borrada, tu pecado está perdonado."
,"8":"Y oí la voz del Señor, que decía: ¿A quién enviaré?,¿Quién irá por nosotros?"
,"9":"Y respondí: Aquí estoy yo, mándame a mí. Él me dijo: Vete y dile a este pueblo: Escuchad bien, pero sin comprender; mirad, pero sin ver."
,"10":"Embota el corazón de este pueblo, endurece su oído, ciega sus ojos, de suerte que no vea con sus ojos, ni oiga con sus oídos, ni entienda con su corazón, ni se convierta, ni se cure."
,"11":"Yo dije: ¿Hasta cuándo, Señor?,Y me respondió: Hasta que las ciudades,estén devastadas y desiertas, las casas vacías,y la tierra abandonada;"
,"12":"hasta que el Señor,haya alejado a los hombres,y sea grande la soledad en el país."
,"13":"Si aún quedara una décima parte, será también exterminada igual,que el terebinto o la encina, que, al ser talados, conservan un tronco; ese tronco será semilla santa."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Sucedió en tiempo de Acaz, hijo de Jotán, hijo de Ozías, rey de Judá, que Rasín, rey de Siria, y Pécaj, hijo de Romelías, rey de Israel, atacaron a Jerusalén con ánimo de expugnarla, pero no pudieron apoderarse de ella."
,"2":"Y se le anunció a la casa de David: 'Siria ha acampado en Efraín'. Entonces se estremeció el corazón del rey y el corazón del pueblo, como se estremecen con el viento los árboles del bosque."
,"3":"El Señor dijo a Isaías: 'Sal al encuentro de Acaz, con tu hijo Sear-Yasub, al extremo del canal de la alberca de arriba, junto al camino del campo del Batanero,"
,"4":"y dile: Pon atención, estáte tranquilo, no temas, no desmaye tu corazón por causa de esos dos tizones humeantes; por el furor de Rasín, rey de Siria, y del hijo de Romelías,"
,"5":"porque hayan tramado tu mal, diciendo:"
,"6":"Subamos contra Judá, aterroricémosla, apoderémonos de ella y hagamos rey al hijo de Tabel'."
,"7":"Esto dice el Señor Dios: Eso no pasará, no ocurrirá jamás."
,"8":"Capital de Siria es Damasco, y cabeza de Damasco, Rasín."
,"9":"capital de Efraín es Samaría, y cabeza de Samaría el hijo de Romelías. Dentro de cinco o seis años, Efraín será destruido, dejará de ser pueblo. Si no creéis, no podréis subsistir."
,"10":"El Señor se dirigió otra vez a Acaz y le dijo:"
,"11":"'Pide al Señor tu Dios una señal, aunque sea en las profundidades del abismo o en las alturas del cielo'."
,"12":"Acaz respondió: 'No la pediré, no quiero tentar al Señor'."
,"13":"Isaías dijo: Escuchad, pues, casa de David: ¿os parece poco cansar a los hombres, para que queráis también cansar a mi Dios?"
,"14":"El Señor mismo os dará una señal. Mirad: la virgen encinta da a luz un hijo, a quien ella pondrá el nombre de Emanuel."
,"15":"De cuajada y miel se alimentará,hasta que sepa rechazar el mal,y elegir el bien."
,"16":"Pues antes que el niño,sepa rechazar el mal,y elegir el bien,será devastado el país,de esos dos reyes,ante los que tiemblas tú."
,"17":"El Señor hará venir sobre ti, sobre tu pueblo y la casa de tu padre,días tales como nunca vinieron,desde que Efraín se separó de Judá, esto es, el rey de Asiria."
,"18":"Aquel día el Señor,llamará con silbido,al tábano del extremo del río de Egipto,y a la avispa de la tierra de Asiria."
,"19":"Vendrán y se posarán en masa,en los barrancos abruptos, en las hendiduras de las rocas, en todos los matorrales,y en todas las praderas."
,"20":"Aquel día el Señor,rasurará con navaja alquilada,al otro lado del río -el rey de Asiria-,la cabeza, los pelos de las piernas, y raerá la barba."
,"21":"Aquel día cada hombre,criará una vaca y dos ovejas;"
,"22":"y por la abundancia de leche que darán, se alimentará de cuajada, pues de cuajada y miel,se nutrirán cuantos queden en el país."
,"23":"Aquel día todo lugar,donde había mil cepas,por valor de mil monedas de plata,será reducido a espinas y zarzas."
,"24":"Habrá que entrar allá con flechas,y arcos porque todo el país,será espinas y zarzas."
,"25":"En todos los montes,que se cavaban con azadón,ninguno entrará ya por miedo,a las espinas y las zarzas; sólo serán pasto de bueyes, tierra hollada por ovejas."
}`)
	CurrentBook.AddChapter(8, `{
"1":"El Señor me dijo: 'Toma una tabla grande y escribe en ella en caracteres legibles: Maher-Salal-Jas-Baz,"
,"2":"y ponme por testigos fidedignos al sacerdote Urías y a Zacarías, hijo de Baraquías'."
,"3":"Después me acerqué a la profetisa, que concibió y dio a luz un hijo. Y el Señor me dijo: 'Ponle el nombre de Maher-Salal-Jas-Baz,"
,"4":"porque antes que el niño sepa decir papá y mamá, la riqueza de Damasco y el botín de Samaría serán llevados ante el rey de Asiria'."
,"5":"El Señor me habló de nuevo y me dijo:"
,"6":"Porque este pueblo ha despreciado,las plácidas aguas de Siloé,y se ha desmayado ante Rasín,y el hijo de Romelías,"
,"7":"el Señor va a hacer subir contra ellos,las aguas del río caudalosas y torrenciales: el rey de Asiria con todo su poder. Por todos sus cauces se saldrá, se desbordará por todas sus riberas,"
,"8":"invadirá Judá y la inundará,hasta que el agua llegue al cuello. Y el despliegue de sus olas,cubrirá toda la anchura de tu tierra, ¡oh Emanuel!"
,"9":"Enteraos, pueblos: ¡seréis aplastados!,Prestad oído, tierras lejanas; tomad las armas: seréis aplastados; tomad las armas: seréis aplastados."
,"10":"Haced planes: serán desbaratados; dad órdenes: inútiles serán, porque Dios está con nosotros."
,"11":"Así me habló el Señor,cuando me tomó de la mano,y me advirtió que no siguiera,la senda de este pueblo:"
,"12":"No llaméis conspiración,a todo lo que este pueblo llama conspiración; no temáis lo que él teme, no os asustéis."
,"13":"Sólo al Señor todopoderoso,tened por santo; temedle a él, sólo ante él temblad."
,"14":"Él será una piedra de tropiezo, una roca que puede hacer caer,para las dos casas de Israel; un lazo y una trampa,para los habitantes de Jerusalén."
,"15":"Muchos tropezarán en ella, caerán, se harán pedazos, serán prendidos en la trampa y apresados."
,"16":"Enrolla el testimonio, sella la ley en el corazón de mis discípulos."
,"17":"Con ansia espero en el Señor, que ha ocultado su rostro,a la casa de Jacob; en él confío."
,"18":"Ved: yo y los hijos,que el Señor me ha dado señales somos,y presagios en Israel,de parte del Señor omnipotente, que mora en el monte Sión."
,"19":"Y os dirán: Consultad a los espíritus,de los adivinos que murmuran y susurran. ¿Un pueblo no debe consultar a sus dioses, y a sus muertos acerca de los vivos"
,"20":"para recibir una enseñanza o un mensaje?,Seguro que os dirán eso."
,"21":"Y vagará por el país, abatido y hambriento; por el hambre se desesperará,y maldecirá a su rey y a su Dios. Levantará sus ojos a lo alto,"
,"22":"mirará hacia la tierra, y sólo habrá angustia, oscuridad, desolación y tinieblas, espesa lobreguez. Mas no (por siempre) las tinieblas,sobre el que está en angustia."
,"23":"Al principio cubrió él de ignominia,el país de Zabulón y el país de Neftalí; pero en el último tiempo,llenará de gloria la calzada del mar, la tierra allende el Jordán,y la región de los gentiles."
}`)
	CurrentBook.AddChapter(9, `{
"1":"El pueblo que andaba en tinieblas,vio una gran luz; sobre los moradores,de una tierra de sombras, la luz ha despuntado."
,"2":"Has acrecentado su alegría, has agrandado su júbilo; se regocijan ante ti,como en la algazara de la siega, como se alegran los que reparten un botín."
,"3":"Pues su penoso yugo, la vara sobre sus espaldas, el palo de su verdugo,tú lo quebraste como en el día de Madián."
,"4":"Porque todo calzado,de guerra estrepitoso, todo manto manchado,de sangre será quemado, pasto de las llamas."
,"5":"Que un niño nos ha nacido, un hijo se nos ha dado; sobre sus hombros el imperio, y su nombre será: Consejero admirable, Dios potente, Padre eterno, Príncipe de la paz,"
,"6":"para ensanchar el imperio, para una paz sin fin,en el trono de David y en su reino; para asentarlo y afirmarlo,en el derecho y la justicia,desde ahora para siempre. El celo del Señor omnipotente hará todo esto."
,"7":"El Señor ha lanzado,una orden contra Jacob,y va a caer sobre Israel."
,"8":"El pueblo entero lo sabrá; Efraín y los habitantes de Samaría, que dicen en su orgullo, en la soberbia de su corazón:"
,"9":"Se han caído los ladrillos, construiremos con piedras sillares; han sido talados los sicómoros, los sustituiremos con cedros."
,"10":"Pero el Señor levanta contra él,a sus adversarios, incita a sus enemigos:"
,"11":"Siria a oriente, los filisteos a occidente, que devoran a Israel a boca llena; y con todo no ha amainado su cólera, su brazo aún está extendido."
,"12":"Pero el pueblo no ha vuelto,hacia aquel que le hiere; no ha buscado al Señor omnipotente."
,"13":"Por eso el Señor cortó a Israel,cabeza y cola, palmera y junco en sólo un día:"
,"14":"el anciano y el noble son la cabeza; el profeta, maestro de mentiras, es la cola."
,"15":"Los guías de este pueblo lo extravían, y los guiados se han perdido."
,"16":"Por eso el Señor no tendrá,compasión de sus jóvenes, no se apiadará de sus viudas,ni de sus huérfanos; porque todos son malvados,y perversos y toda boca habla locuras. Y con todo no ha amainado su cólera; su brazo aún está extendido."
,"17":"Que la maldad arde como fuego; devora los cardos, los abrojos,y prende los bardales del bosque, levantando remolinos de humo."
,"18":"La cólera del Señor omnipotente,ha incendiado la tierra, y el pueblo se ha vuelto pasto de las llamas. Nadie perdona a su vecino."
,"19":"Se muerde a la derecha, y aún se tiene hambre; se come a la izquierda, y no se sacian; todos devoran la carne de su prójimo."
,"20":"Manasés a Efraín, Efraín a Manasés, y ambos a dos se lanzan contra Judá. Pero con todo no ha amainado su cólera, su brazo aún está extendido."
}`)
	CurrentBook.AddChapter(10, `{
"1":"¡Ay de aquellos que dictan,leyes de iniquidad!,¡Ay de los que publican,decretos de opresión;"
,"2":"que niegan la justicia a los débiles,y quitan su derecho,a los pobres de mi pueblo; que hacen de las viudas su presa,y de los huérfanos su botín!"
,"3":"¿Qué vais a hacer,el día de la invasión y de la catástrofe,que se acerca de lejos?,¿A quién acudiréis,para lograr socorro?,¿Dónde dejaréis vuestras riquezas?"
,"4":"No queda más que doblegarse,entre los prisioneros,o sucumbir con los muertos. Y con todo no ha amainado su cólera, su brazo aún está extendido."
,"5":"¡Ay de Asiria, vara de mi cólera, bastón que blande mi furor!"
,"6":"Yo la enviaba contra una nación malvada; la mandaba contra un pueblo,que me ha irritado, para robarlo, saquearlo y pisotearlo,como el lodo de las calles."
,"7":"Pero él no piensa así, no son los designios de su corazón; sólo sueña con destruir,y arrasar muchas naciones."
,"8":"Pues dice: ¿No son reyes mis jefes?"
,"9":"¿No es Calne como Cárquemis, Jamat igual que Arpad y Samaría como Damasco?"
,"10":"Como mi mano ha herido,los reinos de los ídolos, más repletos de imágenes,que Jerusalén y Samaría;"
,"11":"lo mismo que hice con Samaría y sus ídolos, ¿no podré hacerlo con Jerusalén y sus imágenes?"
,"12":"Cuando el Señor haya concluido,toda su obra en el monte Sión y en Jerusalén, castigará la altivez,del corazón del rey de Asiria,y la arrogancia de sus ojos altaneros."
,"13":"Porque dice: Con la fuerza de mi mano,he hecho esto; con mi saber, porque soy inteligente. He reducido las fronteras de los pueblos, he saqueado sus tesoros, he aplastado como un valiente a sus habitantes."
,"14":"Mi mano ha cogido, como un nido, las riquezas de los pueblos; como se toman huevos abandonados, he atrapado toda la tierra,sin que moviera nadie las alas, abriera el pico y piara."
,"15":"¿Presume acaso el hacha,contra quien la maneja?,¿Se envanece la sierra,contra aquel que la mueve?,¡Como si el palo mandase,a quien lo alza,o el bastón impulsara,a aquel que no es madera!"
,"16":"Por eso el Señor Dios omnipotente,enviará flaqueza a sus guerreros, y bajo su ejército potente,encenderá un fuego,lo mismo que un incendio."
,"17":"La luz de Israel se hará un fuego,y su Santo una llama que prenderá,y devorará sus abrojos,y sus cardos en un día."
,"18":"Sus espléndidos bosques, sus jardines arrasará, savia y tronco, y serán como un enfermo que se apaga."
,"19":"El residuo de los árboles del bosque,será fácil de numerar; un niño lo podría contar."
,"20":"Sucederá aquel día,que el resto de Israel,y los supervivientes de la casa de Jacob,dejarán de apoyarse en quien los hiere, y se apoyarán con lealtad en el Señor, el Santo de Israel."
,"21":"Un resto tornará, el resto de Jacob, al Dios fuerte."
,"22":"Pues aunque fuera tu pueblo, oh Israel, como la arena del mar, sólo un resto volverá. La destrucción está decretada,como plenitud de la justicia."
,"23":"El Señor Dios todopoderoso,llevará a cabo en todo el país,el exterminio decidido."
,"24":"Por eso dice el Señor Dios omnipotente: No temas a Asiria, pueblo mío que habitas en Sión, cuando te hiere con la vara,y alza el bastón contra ti, como lo hacía Egipto."
,"25":"Tan sólo un poco más, un momento, y acabará mi ira, y mi furor los aniquilará."
,"26":"El Señor todopoderoso blandirá,contra él el azote, como cuando hirió a Madián,en la roca de Horeb; y alzará su bastón sobre el mar, como otras veces sobre Egipto."
,"27":"El día aquel te quitará,su carga de tu hombro, su yugo dejará de pesar sobre tu cuello. Se acerca por el lado de Rimón,"
,"28":"avanza contra Ayat, atraviesa Migrón, deja su bagaje en Micmás."
,"29":"Atraviesan el desfiladero, pasan la noche en Guibeá, Ramá se sobresalta, Guibeá de Saúl se da a la fuga."
,"30":"¡Lanza tus gritos, hija de Galín; escúchalos, Lais; respóndele, Anatot!"
,"31":"Madmená se da a la huida; escapan los habitantes de Guebín."
,"32":"Hoy mismo estará en Nob; alzará ya su mano,contra el monte de la hija de Sión, contra la colina de Jerusalén."
,"33":"Ved ya al Señor Dios omnipotente,desgajando el ramaje con terrible violencia; caen los más altos, los más altivos son talados."
,"34":"Se rinde al hierro,la espesura del bosque, cae bajo el hacha el Líbano."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Un brote saldrá del tronco de Jesé, un vástago surgirá de sus raíces."
,"2":"Sobre él reposará el espíritu del Señor: espíritu de sabiduría y de inteligencia, espíritu de consejo y de fuerza, espíritu de conocimiento y de temor del Señor."
,"3":"En el temor del Señor se inspirará; no juzgará por lo que sus ojos vean, ni fallará por lo que oigan sus oídos;"
,"4":"juzgará con justicia a los débiles, y con rectitud a los pobres del país; al tirano herirá con la vara de su boca, matará al criminal con el soplo de sus labios."
,"5":"La justicia será el ceñidor de su cintura; la lealtad, el cinturón de sus caderas."
,"6":"El lobo habitará con el cordero, el leopardo se acostará junto al cabrito; ternero y leoncillo pacerán juntos, un chiquillo los podrá cuidar."
,"7":"La vaca y la osa pastarán en compañía, juntos reposarán sus cachorros, y el león como un buey comerá hierba."
,"8":"El niño de pecho jugará,junto al agujero de la víbora; en la guarida del áspid meterá,su mano el destetado."
,"9":"No harán ya mal, ni causarán más daño,en todo mi monte santo, porque el país estará lleno,del conocimiento del Señor, como las aguas llenan el mar."
,"10":"Aquel día la raíz de Jesé,se alzará como enseña de las gentes; la buscarán los pueblos, y será gloriosa su morada."
,"11":"Aquel día el Señor volverá,a alzar su mano para rescatar,el resto de su pueblo, lo que quede del destierro de Asiria y de Egipto, de Patrós, de Etiopía, de Elán, de Senaar, de Jamat y de las islas."
,"12":"Izará una enseña para las naciones,y reunirá a los dispersos de Israel; a los prófugos de Judá,convocará de los cuatro extremos de la tierra;"
,"13":"cesará la envidia de Efraín, serán exterminados los enemigos de Judá; Efraín no envidiará más a Judá, y Judá ya no será enemigo de Efraín,"
,"14":"sino que caerán, a occidente, sobre las costas de los filisteos, y juntos saquearán a los hijos de oriente; se apoderarán de Edón y de Moab, y los hijos de Amón serán sus súbditos."
,"15":"El Señor secará el golfo,del mar de Egipto; levantará su mano contra el Éufrates,con su potente soplo, y lo dividirá en siete arroyos,que se podrán pasar sandalia en pie;"
,"16":"habrá un sendero para el resto,de su pueblo superviviente de Asiria, como hubo uno para Israel,el día que subió de la tierra de Egipto."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Aquel día dirás: Yo te doy gracias, Señor, porque estabas irritado contra mí, pero tu cólera ha amainado,y me has consolado."
,"2":"Dios es mi salvador; confío en él, no temo, porque mi fuerza,y mi júbilo es el Señor; él es mi salvación."
,"3":"Sacaréis agua con alegría,de la fuente de la salvación."
,"4":"Y diréis aquel día: Dad gracias al Señor, invocad su nombre, proclamad sus proezas entre las naciones, repetid que su nombre es sublime."
,"5":"Cantad al Señor, porque ha hecho maravillas; toda la tierra lo conozca."
,"6":"Exulta, grita de júbilo, habitante de Sión, pues grande es en ti el Santo de Israel."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Oráculo contra Babilonia,revelado a Isaías, hijo de Amós."
,"2":"Izad una enseña sobre un monte pelado, lanzad gritos hacia ellos, indicad con la mano,que entren por las puertas de los nobles."
,"3":"He dado órdenes a mis santos guerreros; he llamado a los agentes de mi cólera, a mis gloriosos campeones."
,"4":"Clamor de multitudes en los montes, como de pueblo innumerable; ruido de tumulto de reinos, de pueblos aliados. El Señor omnipotente,pasa revista a sus fuerzas de guerra."
,"5":"Vienen de países lejanos, de los confines del cielo, el Señor y los instrumentos,de su cólera a devastar toda la tierra."
,"6":"¡Gritad, que el día del Señor se acerca; viene como una devastación del omnipotente!"
,"7":"Por eso todos los brazos se derrumban, todos los corazones se derriten."
,"8":"Están espantados; dolores y espasmos les asaltan, y se retuercen como mujer en parto; unos a otros se miran aterrados, sus rostros son una llama."
,"9":"Ved; ya viene el día del Señor, implacable, con furia y cólera encendida, a convertir la tierra en un desierto, a exterminar a los pecadores."
,"10":"Las estrellas del cielo y sus constelaciones,ya no alumbrarán; el sol se oscurecerá desde que sale, la luna ya no enviará su luz."
,"11":"Yo castigaré por su maldad al mundo, a los criminales por sus delitos; acabaré con la arrogancia,de los orgullosos,y humillaré el orgullo,de los tiranos."
,"12":"Haré a los hombres,más escasos que el oro, a los mortales,más raros que el oro de Ofir."
,"13":"Por eso haré temblar los cielos; se desquiciará la tierra de su sitio,por el furor del Señor omnipotente,el día en que estalle su cólera."
,"14":"Entonces, como una gacela asustada, como ganado que ninguno recoge, se volverá cada uno a su pueblo, cada cual huirá a su país."
,"15":"Todo el que sea sorprendido sucumbirá, todo apresado caerá al filo de la espada."
,"16":"Sus hijos serán despedazados,ante sus mismos ojos; sus casas saqueadas, violadas sus mujeres."
,"17":"Ved; yo suscitaré contra ellos,a los medos, que no estiman la plata,ni se afanan por el oro."
,"18":"Sus arcos abatirán a los jóvenes,y no se apiadarán del fruto de las entrañas; su ojo no tendrá,compasión de los niños."
,"19":"Babilonia, la joya de los reinos, la perla, el orgullo de los caldeos, será destruida por Dios,como Sodoma y Gomorra."
,"20":"No será más poblada,ni habitada al paso de las generaciones; el árabe no alzará allí su tienda, ni el pastor apacentará su ganado."
,"21":"Las fieras del desierto,vagarán por allí, los búhos llenarán sus casas, habitarán allí las avestruces,y brincarán los sátiros."
,"22":"Las hienas aullarán en sus torres vacías, en sus lujosos palacios los chacales. Su hora está cercana, no se alargarán sus días."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Pues el Señor se compadecerá de Jacob, elegirá otra vez a Israel y los restablecerá en su país. El extranjero seguirá también sus pasos y se unirá a la casa de Jacob."
,"2":"Los pueblos los acogerán y los harán llegar a su patria, y la casa de Israel los tomará como esclavos y esclavas en la tierra del Señor. Harán cautivos a los que les habían hecho cautivos a ellos, y dominarán a sus opresores."
,"3":"Entonces, cuando el Señor te conceda respiro de tus padecimientos, de tus inquietudes y de la dura esclavitud a la que estabas sometido,"
,"4":"pronunciarás esta sátira contra el rey de Babilonia: ¡Cómo ha acabado el tirano, en qué paró su arrogancia!"
,"5":"El Señor ha roto el palo de los criminales, el cetro de los dominadores;"
,"6":"al que hería a los pueblos,con saña golpeando sin tregua, y aplastaba con furia a las naciones,pisoteando sin piedad."
,"7":"Ya la tierra toda reposa tranquila,y exulta jubilosa."
,"8":"Hasta los cipreses se alegran de ti, hasta los cedros del Líbano: Desde que yaces en la tumba, ninguno sube ya a talarnos."
,"9":"Abajo el abismo se revuelve contra ti, presintiendo tu llegada; por ti despierta a las sombras, a todos los potentados de la tierra; hace levantarse de sus tronos,a todos los reyes de los pueblos."
,"10":"Todos a una se dirigen a ti y te dicen: También tú has sido anonadado como nosotros, te has hecho a nosotros semejante."
,"11":"Tu esplendor ha caído en el abismo,con el susurro de tus arpas. La gusanera te hace cama,y te cubren los gusanos."
,"12":"¿Cómo has caído desde el cielo, brillante estrella, hijo de la aurora?,¿Cómo has sido derribado a tierra tú, el vencedor de las naciones?"
,"13":"Te decías en tu corazón: El cielo escalaré, encima de las estrellas de Dios,levantaré mi trono; en el monte de la asamblea me sentaré, en lo último del norte."
,"14":"Subiré a las alturas de las nubes, seré igual que el altísimo."
,"15":"Mas, ay, has caído en lo profundo, en las honduras del abismo."
,"16":"Los que te ven se te quedan mirando, comentando te contemplan: ¿Éste es el hombre,que espantaba a la tierra, que hacía temblar a los reinos,"
,"17":"que convertía en un desierto el mundo, que destruía las ciudades,y no dejaba a sus cautivos,salir de la prisión?"
,"18":"Todos los reyes de las naciones,reposan con honor, cada uno en su tumba."
,"19":"Pero tú has sido arrojado,lejos de tu sepulcro, como un ramo despreciable, cubierto de asesinados, de atravesados por la espada, tirados contra las piedras de la fosa, como carroña que se pisa."
,"20":"No estarás tú junto a ellos en la tumba, porque tu tierra has desolado,y has matado a tu pueblo. Nunca jamás será nombrada,la raza de los criminales."
,"21":"¡Preparad la matanza de los hijos,por la malicia de sus padres; no se levanten más a conquistar la tierra,y llenar de ruinas la faz del mundo!"
,"22":"Contra ellos me levantaré,-oráculo del Señor omnipotente-,y extirparé de Babilonia nombre y resto, vástago y retoño,-oráculo del Señor omnipotente-."
,"23":"La convertiré en dominio de erizos, en lagunas, y la barreré con la escoba de la devastación,-oráculo del Señor omnipotente-."
,"24":"El Señor todopoderoso,ha jurado diciendo: Sí, como he proyectado sucederá, como he decidido se cumplirá:"
,"25":"destrozaré a Asiria en mi país, la pisotearé en mis montañas; así se quitará de ellos el yugo, y el peso caerá de sus hombros."
,"26":"Ésta es la decisión tomada,contra toda la tierra; está la mano extendida,sobre todas las naciones."
,"27":"El Señor omnipotente ha decidido: ¿quién lo puede invalidar?,Su mano está extendida: ¿quién la puede apartar?"
,"28":"El año de la muerte de Acaz,fue pronunciado este oráculo:"
,"29":"No te regocijes, Filistea toda, porque haya sido roto,el palo que te golpeaba; pues de la raza de la serpiente,saldrá un basilisco, y su fruto será un dragón volador."
,"30":"Entonces los pobres,comerán en mis pastos, y los indigentes reposarán en calma; pero a tu raza la haré morir de hambre, y mataré lo que quede."
,"31":"Aúlla, puerta; ciudad, grita; tiembla, Filistea entera; porque del norte llega una humareda, y nadie de sus huestes se rezaga."
,"32":"¿Qué se va a responder,a los mensajeros de ese pueblo?,Que el Señor ha fundado a Sión,y en ella se cobijarán,los pobres de su pueblo."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Oráculo sobre Moab: ¡Sí, la noche que Ar fue devastada,sucumbió Moab; la noche que Quir fue devastada, sucumbió Moab!"
,"2":"Ha subido la gente de Dibón,a las alturas a llorar; sobre el Nebo y Madaba gime Moab. Toda cabeza, calva; toda barba, cortada;"
,"3":"en sus calles, vestidos de saco; en sus techos aúllan y en sus plazas, derritiéndose en lágrimas."
,"4":"Gritan Jesbón y Elalé, hasta Yahas se oye su voz: los guerreros de Moab se estremecen, se amedrenta su ánimo."
,"5":"Mi corazón gime por Moab; sus fugitivos están ya en Soar, en Egla-Selisiyá. La subida de Lujit la suben llorando; por el camino de Joronáyim, lanzan gritos de angustia."
,"6":"Las aguas de Nimrín son yermo desolado: se ha secado la hierba, se ha marchitado el verde, ya no hay verdor."
,"7":"Por eso llevan lo que les queda, lo que han salvado, al otro lado del torrente de los Sauces."
,"8":"Los lamentos recorren el territorio de Moab: hasta Egláyim llega su grito; su aullido, hasta Beer-Elín."
,"9":"Porque están llenas de sangre,las aguas de Dimón, y aún más añadiré a Dimón: un león sobre los escapados de Moab,y sobre los que queden en el país."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Enviad el cordero,al soberano de la tierra; desde Sela, a través del desierto, al monte de la hija de Sión."
,"2":"Como pájaros inquietos, cual nidada dispersa,serán las hijas de Moab,en los vados del Arnón."
,"3":"Danos un consejo, toma una decisión, alarga tu sombra,cual la noche en pleno mediodía; esconde a los dispersos,y no traiciones al que huye."
,"4":"Deja que en ti se hospeden,los fugitivos de Moab; sé tú su cobijo frente al devastador,hasta que acabe la opresión, el devastador desaparezca,y se aleje del país el que lo arrasa."
,"5":"Entonces el trono,se afincará en la bondad; en él se sentará con fidelidad,bajo la tienda de David,un juez amante del derecho,y celador de la justicia."
,"6":"Hemos conocido la soberbia de Moab, demasiado orgulloso: su empaque, su vanidad, su arrogancia, sus huecas pretensiones."
,"7":"Por eso Moab gime por Moab; todos se lamentan,por las tortas de uvas de Quir Jaréset, todos suspiran consternados."
,"8":"Porque los campos de Jesbón,están marchitos; de las viñas de Sibmá, los señores de las naciones,han arrancado los mejores racimos, que se extendían hasta Yazer,y se alargaban hasta el desierto, y sus vástagos llegaban hasta más allá del mar."
,"9":"Por eso lloro yo, como llora Yazer, por las viñas de Sibmá; te inundo con mis lágrimas, Jesbón, Elalé, porque sobre tu siega,y tu vendimia cayó un grito de guerra."
,"10":"La alegría y el júbilo,han huido de los huertos; ya no hay en las viñas alborozo,ni clamores de fiesta; ya no se pisa el vino en el lagar, ha enmudecido el canto."
,"11":"Mis entrañas por Moab,se estremecen como un arpa; y mi corazón, por Quir Jaréset."
,"12":"Así ocurrirá que Moab se presentará, se cansará por las alturas; entrará a orar en su templo, y no logrará nada."
,"13":"Tal es el oráculo,que el Señor pronunció,hace tiempo contra Moab."
,"14":"Pero ahora el Señor dice: En tres años,-tres años como los de un jornalero-,el esplendor de Moab, con toda su enorme multitud, será humillado; y los supervivientes serán pocos, débiles e impotentes."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Oráculo contra Damasco: Mirad, Damasco dejará de ser ciudad, se trocará en montón de ruinas."
,"2":"Sus pueblos serán abandonados para siempre; serán morada de ganados, que allí se tumbarán,sin que nadie los eche."
,"3":"Desaparecerán los fortines de Efraín, el reino de Damasco; y el residuo de Siria,quedará como la gloria de los israelitas,-oráculo del Señor omnipotente-."
,"4":"Aquel día la gloria de Jacob,será humillada,y enflaquecerá la grasa de su carne."
,"5":"Será como cuando el segador,toma a brazadas la mies,y su mano siega las espigas; como cuando se recogen,las espigas en el valle de Refaín,"
,"6":"que sólo quedan rastrojos; o como cuando se varean las olivas; sólo dos o tres aceitunas en la copa, cuatro o cinco en las ramas del árbol,-oráculo del Señor, Dios de Israel-."
,"7":"Aquel día el hombre mirará a su creador, y sus ojos se volverán al Santo de Israel."
,"8":"Ya no mirará más a los altares, obra de sus manos, ni contemplará lo que sus dedos hicieron: los troncos sagrados,y las estelas del sol."
,"9":"Aquel día tus ciudades,quedarán desiertas,como las de los heveos y amorreos, que fueron abandonadas,ante los israelitas; se convertirán en un desierto."
,"10":"Porque has olvidado,al Dios de tu salvación,y no te acordaste de la roca de tu refugio, por eso has plantado huertos de delicias, y siembras en ellos semilla extranjera."
,"11":"El día que los plantas,haces que broten,y que al día siguiente,tu plantación florezca; mas se perderá la cosecha,el día de la herida, y el dolor será incurable."
,"12":"¡Ah, el rumor de inmensos pueblos!: rumor como el bramido de la mar; rugido de naciones, como el rugido de aguas impetuosas."
,"13":"Pero él las amenaza y huyen lejos, dispersas como paja en los montes por el viento, como un torbellino por el vendaval."
,"14":"¡Espanto al caer la tarde, y antes de la mañana ya no existen!,Tal es el botín de nuestros saqueadores, la suerte de quienes nos despojan."
}`)
	CurrentBook.AddChapter(18, `{
"1":"¡Ay de la tierra del zumbido de alas, más allá de los ríos de Etiopía;"
,"2":"la que manda por el mar mensajeros,en canoas de juncos sobre las aguas!,Marchad, mensajeros veloces, hacia la gente espigada y bronceada; al pueblo temido desde siempre, gente robusta, dominante, tierra surcada de ríos."
,"3":"Habitantes todos del orbe, pobladores de la tierra, cuando se alce la señal,en los montes, mirad; cuando suene la trompeta, escuchad."
,"4":"Esto me ha dicho el Señor: Me quedaré quieto,y miraré desde mi trono, como el calor ardiente,cuando el sol brilla, como nube de rocío,en el calor de la siega."
,"5":"Pues antes de la vendimia, pasada la floración, cuando la flor se hace uva que madura, entonces cortará los sarmientos con la podadera, arrancará y tirará los pámpanos."
,"6":"Todos juntos serán abandonados,a las aves rapaces de los montes,y a las fieras de la tierra. Allí pasarán el verano,las aves de rapiña,y las fieras del invierno."
,"7":"Entonces presentará ofrendas,al Señor omnipotente,el pueblo espigado y bronceado, el pueblo temido desde siempre, la gente robusta y dominante, cuya tierra está surcada de ríos, en el lugar donde reside,el nombre del Señor omnipotente, el monte Sión."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Oráculo contra Egipto: Ved al Señor que, cabalgando sobre una nube ligera, viene a Egipto. Los ídolos de Egipto tiemblan ante él, y el corazón de los egipcios,desfallece en su pecho."
,"2":"Yo azuzaré a egipcios contra egipcios; y marcharán hermano contra hermano, amigo contra amigo, ciudad contra ciudad, reino contra reino."
,"3":"Egipto perderá su cordura; yo desharé sus planes. Consultarán a los ídolos, a los hechiceros, a los nigromantes y a los adivinos."
,"4":"Yo entregaré a Egipto,en manos de un amo duro; un rey cruel los subyugará, dice el Señor Dios todopoderoso."
,"5":"Se evaporarán las aguas del mar; el río quedará seco, sin agua;"
,"6":"apestarán los canales, los brazos del Nilo menguarán,y se secarán, cañas y juncos se amustiarán."
,"7":"Las plantas de las orillas del Nilo,y los sembrados de sus márgenes se secarán."
,"8":"Gemirán los pescadores, se lamentarán,los que echan el anzuelo en el río; los que extienden la red,en el agua estarán desolados;"
,"9":"consternados los que trabajan en el lino, pálidos los tejedores de algodón,"
,"10":"abatidas las hilanderas,y entristecidos todos sus obreros."
,"11":"Realmente están locos los jefes de Soán; los sabios consejeros del Faraón,dictan necios consejos. ¿Cómo podéis decir al Faraón: Hijo de sabios soy, de antiguos reyes hijo?"
,"12":"¿Dónde están, pues, tus sabios?,Que te descubran y te revelen,lo que el Señor todopoderoso,ha resuelto contra Egipto."
,"13":"Locos están los jefes de Soán, necios los jefes de Nof; descarrían a Egipto,los jefes de sus tribus."
,"14":"El Señor ha vertido en medio de ellos,un espíritu de vértigo, y descarrían a Egipto,en todas sus acciones, como se tambalea un borracho que vomita."
,"15":"Y ya de nada le aprovecha a Egipto,lo que pueden hacer cabeza y cola, palmera y junco."
,"16":"Aquel día los egipcios,serán como mujerzuelas; se asustarán y se horrorizarán,al ver agitarse la mano,que el Señor todopoderoso,levantará contra ellos."
,"17":"Y el país de Judá,será el terror de Egipto; cada vez que se le recuerde, se espantarán por la decisión,que el Señor todopoderoso,ha tomado contra ellos."
,"18":"Aquel día habrá cinco ciudades,en la tierra de Egipto,que hablarán la lengua de Canaán,y jurarán por el Señor todopoderoso. Una de ellas se llamará Ciudad del Sol."
,"19":"Aquel día habrá un altar,dedicado al Señor,en medio de la tierra de Egipto, y una estela al Señor,cerca de la frontera;"
,"20":"serán señal y testimonio del Señor,en la tierra de Egipto. Cuando ante el opresor,clamen al Señor, él les mandará un salvador,que luchará por ellos y los salvará."
,"21":"El Señor se manifestará a Egipto; Egipto conocerá al Señor aquel día: le honrará con sacrificios y ofrendas, hará votos al Señor y los cumplirá."
,"22":"El Señor herirá a Egipto, pero para sanarlo luego; ellos se convertirán al Señor, que los acogerá y los curará."
,"23":"Aquel día habrá,una carretera de Egipto a Asiria; los asirios irán a Egipto,y los egipcios a Asiria, y Egipto y Asiria servirán al Señor."
,"24":"Aquel día Israel, el tercero con Egipto y Asiria, será una bendición en medio de la tierra."
,"25":"El Señor todopoderoso,los bendecirá de esta manera: Bendito sea mi pueblo, Egipto; Asiria, la obra de mis manos, e Israel, mi heredad."
}`)
	CurrentBook.AddChapter(20, `{
"1":"El año en que el generalísimo, enviado por Sargón, rey de Asiria, llegó a Azoto, la asaltó y la tomó,"
,"2":"el Señor habló por medio de Isaías, hijo de Amós, y dijo: 'Anda, despójate del sayal de tu cintura,y quítate las sandalias de tus pies'. Isaías lo hizo así, y andaba desnudo y descalzo."
,"3":"Entonces el Señor dijo: 'Así como mi siervo Isaías anda desnudo,y descalzo hace tres años"
,"4":"así el rey de Asiria,conducirá a los prisioneros de Egipto,y a los viejos, desnudos y descalzos,y con las posaderas descubiertas,-vergüenza para Egipto-."
,"5":"Bochorno y confusión habrá por Egipto, en quien se esperaba; y por Etiopía, en quien se confiaba."
,"6":"Los habitantes de estas costas,dirán aquel día: Mirad en lo que han parado,aquellos en quienes confiábamos,y a quienes acudíamos,para que nos socorriesen,y nos librasen del rey de Asiria. ¿Cómo podremos escapar nosotros?'."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Oráculo sobre el desierto marítimo: Como huracanes atravesando el Negueb, vienen del desierto, de región espantosa."
,"2":"Una dura visión me ha sido revelada: ¡El ladrón roba, el devastador devasta!,¡Avanza, Elán; pon cerco, Media!,A todo gemido pongo fin."
,"3":"Por eso están llenos de convulsiones mis riñones; soy presa de dolores, como los dolores de mujer en parto; la angustia me aturde, el espanto me ciega."
,"4":"Mi corazón se marea, el terror me sobrecoge; el crepúsculo que anhelaba,se me ha hecho un horror."
,"5":"Se dispone la mesa, se extiende el mantel, se come y se bebe. ¡En pie, capitanes; engrasad el escudo!"
,"6":"Pues así me ha hablado el Señor: Anda, coloca un centinela,que anuncie lo que vea."
,"7":"Si ve caballería, parejas de caballeros, hombres montados en asnos, hombres montados en camellos, preste atención, mucha atención."
,"8":"El centinela ha gritado: En la atalaya, Señor, estoy alerta todo el día; en mi puesto de guardia,estoy en pie toda la noche."
,"9":"Y he visto llegar caballería, una pareja de caballeros. Me han hablado, me han dicho: ¡Ha caído, ha caído Babilonia, y todas las estatuas de sus ídolos,están en tierra hechas pedazos!"
,"10":"¡Oh pueblo mío, trillado en la era; lo que he oído del Señor omnipotente, Dios de Israel, te anuncio!"
,"11":"Oráculo sobre Edón: Se me grita desde Seír: Centinela, ¿qué hora es de la noche?,Centinela, ¿qué hora es de la noche?"
,"12":"El centinela responde: Viene la mañana, y después la noche; convertíos, retornad."
,"13":"Oráculo sobre Arabia: Entre las matas de la estepa pernoctáis, caravanas de Dedán."
,"14":"Id al encuentro del sediento a llevarle agua, habitantes del país de Temá; para darle pan, salid al encuentro del fugitivo."
,"15":"Pues de las espadas van huyendo; de las espadas afiladas, de los arcos entesados, del encarnizamiento del combate."
,"16":"Sí, esto me ha dicho el Señor: Dentro de un año -año como el de un jornalero- habrá desaparecido todo el esplendor de Quedar;"
,"17":"y lo que quede del número de los valientes arqueros de Quedar no será casi nada, porque el Señor, Dios de Israel, ha hablado."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Oráculo sobre el valle de la Visión. ¿Qué es lo que tienes,para que hayas subido,toda entera a los tejados,"
,"2":"oh llena de ruidos, villa estrepitosa, ciudad alborozada?,Tus muertos no son víctimas de la espada,ni caídos en el combate."
,"3":"Tus caudillos huyeron todos a una, fueron apresados sin disparar el arco; todos tus guerreros fueron capturados, aunque habían huido lejos."
,"4":"Por esto digo: Retirad vuestros ojos de mí, dejad que llore amargamente; no tratéis de consolarme,por la ruina de la hija de mi pueblo."
,"5":"Porque es un día de consternación, de opresión y pánico,por obra del Señor Dios todopoderoso. En el valle de la Visión,los muros se desploman, y hasta la montaña llegan los gritos."
,"6":"Elán ha tomado la aljaba, el jinete ha montado en los caballos,y Quir ha sacado el escudo."
,"7":"Tus más hermosos valles,están llenos de carros, y la caballería se alinea contra la puerta:"
,"8":"ha caído la protección de Judá. Tú volviste los ojos aquel día,al arsenal de la casa del bosque."
,"9":"Las brechas de la ciudad de David,visteis que eran numerosas, y recogisteis las aguas de la piscina inferior."
,"10":"Contasteis las casas de Jerusalén, y derribasteis casas para fortificar la muralla."
,"11":"En el centro hicisteis una presa,entre los dos muros,para las aguas de la alberca antigua. Pero no volvíais los ojos,al autor de todo esto, ni veíais a aquel,que desde antiguo lo formó."
,"12":"Aquel día el Señor Dios omnipotente,os invitaba a tonsuraros,y a vestiros de saco."
,"13":"Mas hubo alegría y alborozo, sacrificio de bueyes y degüello de carneros, comer carne y beber vino: 'Comamos y bebamos, que mañana moriremos'."
,"14":"Pero el Señor omnipotente,ha revelado a mis oídos: ¡No será perdonado este pecado,hasta que muráis!,-dice el Señor Dios omnipotente-."
,"15":"Esto dice el Señor Dios omnipotente: Vete donde ese funcionario, Sobná, el mayordomo del palacio,"
,"16":"que se está haciendo,un sepulcro en lo alto,y tallando en la roca su mansión: ¿Qué tienes aquí; a quién conoces,para excavarte aquí un sepulcro?"
,"17":"He aquí que el Señor,te lanzará de un solo golpe, -te envolverá bien,"
,"18":"te enrollará fuerte en ovillo-, como una pelota en un terreno amplio. Allí morirás, allí irán,a parar los carros de tu orgullo, oh tú, vergüenza de la casa de tu señor."
,"19":"Yo te echaré de tu cargo, de tu puesto te arrancaré."
,"20":"Y llamaré aquel día,a mi siervo Eliaquín, hijo de Jelcías,"
,"21":"para vestirlo con tu túnica, ceñirlo con tu banda,y poner en sus manos tus poderes. Él será un padre,para los habitantes de Jerusalén,y para la casa de Judá."
,"22":"Pondré la llave de la casa de David,sobre sus hombros: si él abre, nadie cerrará; si cierra, nadie abrirá."
,"23":"Lo clavaré como estaca en lugar firme, y se hará un trono de gloria,para la casa de su padre."
,"24":"Y colgarán de ella,toda la gloria de la casa de su padre,-vástagos y descendientes-, toda la vasija menuda, desde las copas hasta las jarras."
,"25":"Aquel día -dice el Señor Dios omnipotente-,cederá la estaca clavada en lugar firme; se arrancará y caerá. Y toda la carga que colgaba de ella,se hará pedazos. Lo ha dicho el Señor."
}`)
	CurrentBook.AddChapter(23, `{
"1":"Oráculo sobre Tiro: ¡Ululad, naves de Tarsis, pues está destruida vuestra fortaleza!,Al volver de Chipre les llegó la noticia."
,"2":"Enmudeced, habitantes de la costa, mercaderes de Sidón, que con su carga surcaban el mar"
,"3":"de aguas enormes. El grano del Nilo, la cosecha del río eran su riqueza, la del emporio de los pueblos."
,"4":"Avergüénzate, Sidón, pues así habla el mar: No; no he estado de parto, ni he parido, ni he criado jóvenes, ni he nutrido doncellas."
,"5":"Cuando llegue la noticia a Egipto, se estremecerá por la suerte de Tiro."
,"6":"¡Pasad a Tarsis; ululad, habitantes de la costa!"
,"7":"¿Es ésta vuestra alegre ciudad, la de antiquísimos orígenes, cuyos pies la llevaron muy lejos,para establecerse allí?"
,"8":"¿Quién ha decretado esto,contra Tiro, la coronada, cuyos comerciantes eran príncipes, y sus mercaderes, grandes de la tierra?"
,"9":"El Señor todopoderoso lo ha decidido,para humillar el orgullo,de toda grandeza,y abatir a todos los ilustres de la tierra."
,"10":"Cultiva la tierra, hija de Tarsis, que ya no existe tu puerto."
,"11":"El Señor ha extendido,su mano sobre el mar,para aplastar sus reinos; ha dado órdenes sobre Canaán,de destruir sus fortalezas."
,"12":"Ha dicho: No te alegrarás ya más, virgen deshonrada, hija de Sidón. Levántate; vete a Chipre, que tampoco allí tendrás reposo."
,"13":"He aquí una tierra de caldeos: no eran un pueblo: Asiria la fundó para las bestias del desierto. Han levantado torres de asedio, han demolido sus palacios, la han convertido en montón de ruinas."
,"14":"¡Ululad, naves de Tarsis, pues está destruida vuestra fortaleza!"
,"15":"Aquel día sucederá que Tiro,será olvidada por espacio de setenta años, como la duración del reinado de un rey. Y, al cabo de setenta años, le sucederá a Tiro,como a la prostituta de la canción:"
,"16":"¡Toma la cítara, recorre la ciudad, prostituta olvidada; toca bien, canta muchas canciones, para que seas recordada!"
,"17":"Sucederá que, al cabo de setenta años, el Señor visitará a Tiro. Ella volverá a cobrar,su salario de prostituta, y se prostituirá a todos los reinos,del mundo que hay sobre la superficie de la tierra."
,"18":"Pero sus ganancias y su salario,serán consagrados al Señor. No serán amontonados ni guardados, sino que las ganancias serán,para aquellos que moran delante del Señor, a fin de que tengan comida abundante,y vestidos lujosos."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Ved que el Señor devasta la tierra, la arrasa y trastorna su faz,y dispersa a sus habitantes:"
,"2":"sacerdote igual que laico, esclavo lo mismo que señor, esclava y señora, comprador y vendedor, prestamista y rentero, acreedor y deudor."
,"3":"Devastada será, devastada la tierra, totalmente saqueada, porque el Señor así lo ha decretado."
,"4":"La tierra está de luto, maldita; mustio y marchito el universo, cielo y tierra marchitos."
,"5":"La tierra ha sido profanada,bajo los pies de sus habitantes, porque han transgredido la ley,y olvidado el precepto; han roto la alianza eterna."
,"6":"Por eso la maldición devora la tierra, y sus habitantes sufren los efectos; por eso los habitantes de la tierra se consumen, y sólo quedan unos pocos hombres."
,"7":"Se ha agotado el vino, se ha marchitado la viña; gimen todos los que tenían el corazón alegre."
,"8":"Ha cesado la alegría de los tambores, ha acabado el bullicio de las fiestas, ha terminado el son de las cítaras."
,"9":"Ya no se bebe vino entre los cánticos, amarga el licor hasta a los bebedores."
,"10":"En ruinas está la ciudad del vacío, cerrada la entrada en toda casa."
,"11":"Gritos hay por las calles,por la falta de vino, ha desaparecido toda alegría, ha huido del país el júbilo."
,"12":"No queda más que desolación en la ciudad; la puerta está hecha pedazos."
,"13":"Porque sucede en la tierra, entre los pueblos, como en el vareo de la aceituna, como en la rebusca de racimos,después de la vendimia."
,"14":"Ellos alzan su voz, gritan de júbilo; la gloria del Señor,aclaman desde el lado del mar."
,"15":"También desde oriente glorifican al Señor; en las islas del mar, el nombre del Señor, Dios de Israel."
,"16":"Desde el extremo de la tierra,cánticos oímos: ¡Gloria al justo!,Pero yo he dicho: Se acabó, se acabó, ¡ay de mí! Los violentos hacen violencia, los violentos violentamente hacen violencia."
,"17":"¡Terror, fosa y red sobre ti, habitante de la tierra!"
,"18":"El que escape al grito del terror,caerá en la fosa, y el que escape de la fosa,quedará preso en la red; pues las esclusas de allá arriba se abrirán,y se conmoverán los cimientos de la tierra."
,"19":"Sí, la tierra está sacudida; la tierra estallará, se agrietará; la tierra temblará, vacilará;"
,"20":"la tierra se tambaleará como un borracho, cabeceará como un tugurio; su iniquidad la oprimirá, y caerá para no volver a levantarse."
,"21":"Aquel día el Señor visitará,a las milicias del cielo allá en lo alto; y aquí abajo, a los reyes de la tierra."
,"22":"Y serán reunidos, encarcelados en un calabozo, recluidos en prisión, y al cabo de muchos días castigados."
,"23":"La luna enrojecerá, se avergonzará el sol; porque el Señor omnipotente,reinará en el monte Sión, en Jerusalén, y ante sus ancianos brillará su gloria."
}`)
	CurrentBook.AddChapter(25, `{
"1":"Señor, tú eres mi Dios; yo te ensalzo y bendigo tu nombre, porque has realizado los designios maravillosos,concebidos desde antiguo, firmes y seguros."
,"2":"Porque has convertido la ciudad,en un montón de escombros, la villa fortificada en una ruina; la ciudadela de los orgullosos,ya no es una ciudad, y no será jamás reconstruida."
,"3":"Por eso te glorifica un pueblo poderoso, la ciudad de gentes temibles te teme;"
,"4":"porque tú eres un refugio para el desvalido, un refugio para el pobre en su angustia, abrigo contra el aguacero, sombra contra el calor; pues el soplo de los tiranos,es como la lluvia que azota la pared,"
,"5":"como el calor en tierra seca. Mas tú apaciguas el tumulto de los orgullosos; como el calor a la sombra de una nube, reprimes el canto de los tiranos."
,"6":"El Señor todopoderoso brindará,a todos los pueblos en esta montaña,un festín de pingües manjares, un festín de vinos excelentes, de exquisitos manjares, de vinos refinados."
,"7":"Y quitará en esta montaña,el velo que tapaba a todos los pueblos, el sudario que cubría a todas las naciones:"
,"8":"destruirá para siempre la muerte. El Señor Dios secará las lágrimas,de todos los rostros, y la ignominia de su pueblo,la borrará de toda la tierra; porque el Señor ha hablado."
,"9":"Aquel día se dirá: Éste es nuestro Dios, de quien esperamos que nos salve; éste es el Señor, en quien esperamos. Alegrémonos, gocémonos, porque nos ha salvado."
,"10":"Pues la mano del Señor,reposa sobre esta montaña. Moab, en cambio, es pisoteado en su sitio, como se pisa la paja en el muladar."
,"11":"Y allí alarga sus manos, como las alarga el nadador para nadar; pero el Señor aplasta su orgullo,y los esfuerzos de sus manos."
,"12":"Tus murallas, altivas y soberbias, las destruye, las abate; por tierra las derriba."
}`)
	CurrentBook.AddChapter(26, `{
"1":"Aquel día se cantará este cántico,en la tierra de Judá: Tenemos una ciudad fortificada; él ha puesto para protegernos murallas y defensas."
,"2":"¡Abrid las puertas, para que entre el pueblo justo, que ha guardado la lealtad!"
,"3":"Su ánimo es firme y mantiene la paz, porque confía en ti."
,"4":"Confiad en el Señor incesantemente, porque el Señor es la roca eterna."
,"5":"Sí, él ha humillado,a los que habitaban en lo alto; ha abatido la ciudadela escarpada, la ha abatido a tierra, la ha derribado en el polvo:"
,"6":"la pisotean los pies de los humildes, los pasos de los pobres."
,"7":"El camino del justo va todo derecho, tú allanas el camino derecho del justo."
,"8":"Sí, en el camino de tus juicios,esperamos en ti, Señor; tu nombre y tu memoria son el anhelo del alma."
,"9":"Mi alma te ansía por la noche, y mi espíritu, en mi interior, te espera a la mañana; pues cuando tus juicios se ejecutan en la tierra, aprenden justicia los habitantes del mundo."
,"10":"Si se absuelve al delincuente, no aprende justicia; en la tierra de la rectitud,obrará inicuamente,y no verá la majestad del Señor."
,"11":"Señor, alzada está tu mano; pero ellos no la miran. ¡Vean tu celo por tu pueblo, y se avergüencen, y el fuego preparado,para tus enemigos los devore!"
,"12":"Señor, tú nos das la paz; tú realizas todas nuestras obras."
,"13":"Señor, Dios nuestro, otros señores nos han subyugado; pero nosotros sólo te reconocemos a ti,e invocamos tu nombre."
,"14":"Los muertos no revivirán, las sombras no resucitarán; porque los visitaste y aniquilaste, borrando todo recuerdo de ellos."
,"15":"Has acrecentado la nación, Señor, la has acrecentado; has manifestado tu gloria, has ensanchado las fronteras del país."
,"16":"Señor, en la angustia te buscábamos; te hemos invocado mientras tu castigo nos hería."
,"17":"Como mujer encinta para dar a luz,se retuerce y grita en sus dolores, así nosotros ante ti, Señor."
,"18":"Habíamos concebido, en dolores estábamos; mas sólo viento hemos dado a luz. No hemos traído la salvación al país, ni le han nacido habitantes al mundo."
,"19":"Pero revivirán tus muertos, sus cadáveres resucitarán. Despertaos, regocijaos,los que yacéis en el polvo; porque rocío de luz es tu rocío, y el país de las sombras dará a luz."
,"20":"Anda, pueblo mío, entra en tus aposentos,y cierra las puertas tras de ti; escóndete un instante,hasta que pase la cólera."
,"21":"Pues el Señor sale de su morada,para castigar los crímenes,de los habitantes de la tierra. La tierra vomitará su sangre,y no cubrirá ya más a sus víctimas."
}`)
	CurrentBook.AddChapter(27, `{
"1":"Aquel día el Señor castigará,con su espada dura, grande y fuerte a Leviatán, la serpiente huidiza; a Leviatán, la serpiente tortuosa, y matará al dragón del mar."
,"2":"Aquel día se dirá: ¡Oh, la viña deliciosa, cantadla!"
,"3":"Yo, el Señor, soy su guardián; en todo instante la riego,para que no caiga su follaje; de día y de noche la guardo."
,"4":"Ya no estoy indignado. Si echa espinas y abrojos, les haré la guerra, y los quemaré todos de golpe,"
,"5":"a menos que se acojan a mi protección,y hagan la paz conmigo; sí, la paz hagan conmigo."
,"6":"En el futuro Jacob echará raíces, Israel florecerá y fructificará, y llenarán la faz de la tierra sus frutos."
,"7":"¿Es que el Señor le ha herido, como hirió a sus perseguidores?,¿Le ha dado muerte, como dio muerte a los que le mataban?"
,"8":"Lo ha castigado con la dispersión, con el destierro; lo ha aventado con la fuerza de su soplo, como en día de viento solano."
,"9":"Así será perdonado el crimen de Jacob; éste será todo el precio del perdón de su pecado: que reduzca todas las piedras de los altares,a piedras calizas pulverizadas; que no se alcen más columnas sagradas,ni estelas solares."
,"10":"Pues la ciudad fortificada,ha quedado solitaria, como morada abandonada, desolada igual que un desierto; allí pasta el becerro, allí se tumba y come la maleza."
,"11":"Cuando los ramos están secos, se les rompe; vienen las mujeres y los queman. Por ser un pueblo sin inteligencia,no se compadece de él su creador, no le da su favor el que le ha formado."
,"12":"Aquel día el Señor sacudirá las espigas,desde el curso del río,hasta el torrente de Egipto, y vosotros seréis recogidos uno a uno, hijos de Israel."
,"13":"Aquel día se tocará la gran trompeta, y vendrán los perdidos en el país de Asiria,y los dispersos en el país de Egipto; a adorar al Señor en el monte santo, en Jerusalén."
}`)
	CurrentBook.AddChapter(28, `{
"1":"¡Ay de la soberbia corona,de los borrachos de Efraín, y de la flor marchita de orgulloso esplendor,que domina el fértil valle; ay de los cargados de vino!"
,"2":"He aquí que el Señor,envía a alguien fuerte, poderoso, como violenta granizada, como funesta tempestad, como aguacero impetuoso, arrasador, y los derribará en tierra con violencia."
,"3":"Será pisoteada la soberbia corona,de los borrachos de Efraín;"
,"4":"y la flor marchita de su orgulloso esplendor, que domina el fértil valle, será como el higo prematuro; el que lo ve, le echa mano y come."
,"5":"Aquel día el Señor omnipotente,será para el resto de su pueblo,corona de gloria y diadema de esplendor;"
,"6":"espíritu de justicia,para el que se sienta a juzgar, y espíritu de fortaleza,para el que rechaza a los que asaltan la puerta."
,"7":"También éstos se tambalean por el vino, y desatinan por los licores. Sacerdotes y profetas se tambalean por los licores, y el vino los domina: los licores les hacen desatinar, se tambalean como si tuvieran visiones, titubean al pronunciar sentencia."
,"8":"Sí, todas las mesas,están llenas de asquerosos vómitos; no queda sitio limpio."
,"9":"¿A quién va a enseñar la lección?,¿A quién quiere explicar sus sermones?,¡A los niños apenas destetados, a los recién apartados del pecho!"
,"10":"Cuando dice: Orden sobre orden, regla sobre regla, ora por aquí, ora por allá."
,"11":"Oh, sí, con labios balbucientes, en lenguaje extraño va a hablar a este pueblo."
,"12":"Él les había dicho: ¡Es el reposo; dejad que reposen los cansados, llega la calma!"
,"13":"Por eso el Señor les habla así: Orden sobre orden, regla sobre regla, ora por aquí, ora por allá; para que cuando anden, se caigan de espaldas, se fracturen huesos, y queden atrapados en el lazo y presos."
,"14":"Escuchad, pues, la palabra del Señor, los que os mofáis, jefes de este pueblo, que está en Jerusalén."
,"15":"Vosotros decís: Hemos firmado un pacto con la muerte, con el abismo hemos hecho un pacto: cuando pase el azote destructor, no nos alcanzará, porque hemos puesto en la mentira,nuestro abrigo, nuestro refugio en el engaño."
,"16":"Por eso, esto dice el Señor Dios: He aquí que pongo de cimiento en Sión,una piedra probada, una piedra angular, preciosa, bien asentada. El que crea, no vacilará."
,"17":"Pondré el derecho por regla,y la justicia por nivel. El granizo arrasará el refugio de la mentira, y las aguas arrollarán vuestro cobijo."
,"18":"Será anulado vuestro pacto con la muerte, no valdrá vuestro pacto con el abismo; cuando pase el azote destructor os aplastará;"
,"19":"os alcanzará siempre que pase. Y pasará mañana tras mañana, de día y de noche; y sólo habrá terror al conocer la noticia."
,"20":"El lecho será demasiado corto para estirarse, demasiado estrecha la manta para envolverse."
,"21":"Pues, como en el monte Parasín, se alzará el Señor; como en el valle de Gabaón se irritará, para llevar a cabo su obra, obra singular; para hacer su tarea, tarea extraordinaria."
,"22":"Así pues, dejad de burlaros,para que no se refuercen vuestras ataduras; pues he oído un decreto de exterminio,del Señor Dios todopoderoso para toda la tierra."
,"23":"Prestad oído, oíd mi voz; estad atentos, escuchad mi palabra."
,"24":"¿Acaso el labrador está arando todo el día, abriendo y rastrillando su tierra?"
,"25":"Cuando ha preparado el terreno, ¿no esparce la neguilla, siembra el comino,y luego pone el trigo,y la cebada en sus surcos,y la espelta en los bordes?"
,"26":"El que le enseña esta práctica,es su Dios, que lo instruye."
,"27":"Y que no debe trillarse la neguilla, ni la rueda del trillo se pasa por el comino, sino que con la vara se apalea la neguilla,y con el palo el comino."
,"28":"El trigo ¿se tritura?,No, pues no se le trilla indefinidamente; después de hacer pasar por él la rueda, se le limpia sin triturarlo."
,"29":"También esto procede del Señor omnipotente, admirable en sus consejos, grande en sus empresas."
}`)
	CurrentBook.AddChapter(29, `{
"1":"¡Ay Ariel, Ariel, ciudad donde acampó David!,Añadid año tras año, cumplan su ciclo las fiestas,"
,"2":"y yo asediaré a Ariel, y habrá tristeza y duelo. Tú serás para mí otro Ariel:"
,"3":"te asediaré como David, te cercaré de trincheras,y levantaré fortalezas contra ti."
,"4":"Aplastada, hablarás desde la tierra; desde el polvo saldrán sofocadas tus palabras; saldrá tu voz de la tierra,como la de un espectro; tu palabra del polvo, como un susurro."
,"5":"Pero la turba de tus enemigos,será como el polvo fino; como la paja aventada, la turba de los tiranos. Y pronto, de improviso,"
,"6":"serás visitado por el Señor todopoderoso, con truenos, terremotos, gran estruendo, con huracán, tempestad y fuego devorador."
,"7":"Será como un sueño, como visión nocturna, la turba de pueblos que luchan contra Ariel, todos los que combaten contra ella,y las fortalezas que la asedian."
,"8":"Como el hambriento,que sueña que come, pero despierta con el estómago vacío; o como el sediento,que sueña estar bebiendo, y se despierta extenuado por la sed, con las fauces secas; así le ocurrirá a la multitud de las naciones,que luchan contra el monte Sión."
,"9":"Deteneos y pasmaos, quedad ciegos, sin vista; borrachos, mas no de vino; tambaleándoos, pero no de licor;"
,"10":"porque el Señor ha derramado,sobre vosotros un espíritu de sopor, ha cerrado vuestros ojos: los profetas, y ha velado vuestras cabezas: los videntes."
,"11":"Toda visión se ha vuelto para vosotros,como las palabras de un libro sellado. Si se le entrega a uno que sepa leer, diciéndole: Lee esto, responde: No puedo, porque este libro está sellado."
,"12":"Y si se le da a uno que no sabe leer, diciéndole: Lee esto, contesta él: No sé leer."
,"13":"Ha dicho el Señor: Porque este pueblo se acerca a mí,tan sólo con palabras, y sólo de labios me honra, mientras su corazón está lejos de mí, siendo así su religión para conmigo,sólo un mandamiento humano, una lección aprendida,"
,"14":"por eso yo continuaré obrando maravillas, estupendas maravillas; entonces fracasará la sabiduría de sus sabios, y la inteligencia de sus inteligentes se eclipsará."
,"15":"¡Ay de aquellos que se esconden del Señor,para disimular sus designios; de los que maquinan en la oscuridad,y dicen: ¿Quién nos ve y nos conoce?!"
,"16":"¡Qué perversidad!,¡Como si el barro pudiese compararse con el alfarero, o la obra decirle a su autor: No me has hecho, o el vaso a su alfarero: Nada sabes!"
,"17":"Sí, dentro de poco tiempo el Líbano,se volverá un vergel, y el vergel se convertirá en selva."
,"18":"Los sordos oirán las palabras de un libro; y, liberados de las tinieblas y la oscuridad, verán los ojos de los ciegos."
,"19":"Aún volverán los humildes a alegrarse en el Señor, y los pobres se gozarán en el Santo de Israel;"
,"20":"porque ya no habrá tiranos, ni burlones, y habrán sido exterminados todos los maleantes,"
,"21":"los que por nada declaran culpable a un hombre, los que en la puerta tienden lazos al joven,y sin razón declaran reo al justo."
,"22":"Por eso, esto dice el Señor, Dios de la casa de Jacob, el que rescató a Abrahán: Ya nunca volverá Jacob a avergonzarse, ni palidecerá más su rostro;"
,"23":"porque verá en medio de él,la obra de mis manos, y santificará mi nombre. Santificarán al Santo de Jacob, y temerán al Dios de Israel."
,"24":"Los extraviados de espíritu entrarán en razón, y los murmuradores serán instruidos."
}`)
	CurrentBook.AddChapter(30, `{
"1":"¡Ay de estos hijos rebeldes!,-dice el Señor-. Ejecutan proyectos que no son los míos; conciertan pactos, mas no según mi espíritu, de modo que acumulan pecado tras pecado."
,"2":"Han salido en dirección a Egipto, sin haber consultado a mi boca, para refugiarse al amparo del Faraón,y acogerse a la sombra de Egipto."
,"3":"El amparo del Faraón,será vuestra vergüenza; y el refugio de la sombra de Egipto, vuestro oprobio."
,"4":"Sus jefes han ido a Soán, y sus embajadores han llegado a Hanés."
,"5":"Todos se verán defraudados,por un pueblo que de nada les sirve; que no les dará ayuda ni socorro, sino desengaño e ignominia."
,"6":"Oráculo sobre las bestias del Negueb: A través de una tierra de tribulación,y de angustia, guarida del león y la leona, de la víbora y de la serpiente voladora, llevan a lomos de asnos sus riquezas; en la giba de sus camellos sus tesoros, a un pueblo que de nada les servirá."
,"7":"El apoyo de Egipto será vano y vacío; por eso yo le llamo el monstruo perezoso."
,"8":"Ahora vete, graba esto en una tabla, escríbelo en un libro, y que sirva de testimonio perpetuo para el futuro."
,"9":"Porque es un pueblo rebelde, hijos mentirosos, que no quieren oír la voz del Señor."
,"10":"Dicen a los videntes: No tengáis visiones, y a los profetas: No profeticéis la verdad para nosotros: decidnos cosas seductoras, profetizad ilusiones;"
,"11":"apartaos del camino, desviaos del sendero; quitad de nuestra presencia al Santo de Israel."
,"12":"Por tanto, esto dice el Santo de Israel: Pues rechazáis esta palabra,y os dais a lo perverso,y desleal apoyándoos en ello,"
,"13":"por eso este pecado será para vosotros,como brecha ruinosa,que se abre en elevado muro, el cual en un momento, de repente, se desploma"
,"14":"y se hace pedazos,como un jarro de alfarero estrellado sin piedad: entre sus trozos no se encuentra,ni un cascote para coger fuego del fogón,o sacar agua de la cisterna."
,"15":"Pues esto dice el Señor Dios, el Santo de Israel: En la conversión y la calma,está vuestra salvación, en la mesura y la confianza,se encuentra vuestra fuerza. Mas no lo habéis querido,"
,"16":"y habéis dicho: -¡No! ¡Huiremos a caballo!,-¡Pues bien, huid!,-Cabalgaremos en veloces corceles. -¡Pues bien, perseguidos seréis por pies veloces!"
,"17":"Mil huirán ante la amenaza de uno solo; ante la amenaza de cinco, vosotros huiréis, hasta que sólo quedéis,como mástil en la cima de un monte, como señal sobre una colina."
,"18":"Pero el Señor espera la hora,de otorgaros su gracia; por eso se levanta para apiadarse de vosotros, porque el Señor es un Dios de justicia; felices los que en él esperan."
,"19":"Sí, pueblo de Sión,que habitas en Jerusalén, no llorarás más: él te dará su gracia, atento a tus gritos de súplica; en cuanto lo oiga, te responderá."
,"20":"Después de haberos dado el Señor,el pan de la angustia,y el agua de la aflicción, tu maestro no se esconderá más, sino que tus ojos le verán,"
,"21":"y tus oídos oirán resonar detrás de ti estas palabras: Éste es el camino, seguidlo, ya estéis a la derecha o a la izquierda."
,"22":"Entonces tendrás como profanos,los ídolos recubiertos de plata,y las imágenes revestidas de oro, y los tirarás como objeto inmundo, diciendo: ¡Fuera de aquí!"
,"23":"Él te dará la lluvia para la simiente,que siembres en tu tierra; el pan, producto de tu campo, será pingüe y enjundioso; y tu ganado pastará aquel día,en amplios pastizales."
,"24":"Los bueyes y los asnos,que trabajan la tierra,comerán pienso salado, aventado con horca y bieldo."
,"25":"En todo monte alto,y en toda colina elevada habrá arroyos,y corrientes de agua el día de la gran matanza, cuando caigan las torres."
,"26":"Entonces la luz de la luna,será como la luz del sol, y la luz del sol será,siete veces más fuerte, como la luz de siete días, el día en que el Señor,vende la herida de su pueblo,y cure la llaga de sus golpes."
,"27":"Mirad, el nombre del Señor viene de lejos, abrasa su cólera, oprime la nube de su humo. Sus labios rebosan de furor, y su lengua es un fuego que devora."
,"28":"Su soplo es cual corriente desbordada, que llega hasta el cuello, para cribar a las naciones con criba destructora,y poner un bocado extraviador,en las quijadas de los pueblos."
,"29":"Vosotros entonces entonaréis cantares,como en una noche de fiesta, con la alegría en el corazón, como la del que anda al son de la flauta,camino del monte del Señor, de la roca de Israel."
,"30":"El Señor dejará oír su voz majestuosa,y manifestará su brazo amenazador, en el ardor de su ira, en la llama de un fuego devorador, en una tempestad de lluvia y de granizo."
,"31":"Pues a la voz del Señor, Asiria será quebrada, golpeada por la vara;"
,"32":"y cada golpe de la vara de castigo,se lo infligirá el Señor,entre tamboriles, cítaras y danzas."
,"33":"Pues desde hace tiempo,está dispuesta en Tofet, preparada también para Moloc, una fosa honda y ancha, llena de paja y leña; el soplo del Señor, como un río de azufre, la prenderá."
}`)
	CurrentBook.AddChapter(31, `{
"1":"¡Ay de los que bajan a Egipto,en busca de ayuda!; de los que confían en caballos,y ponen su esperanza en el número de sus carros,y en la fuerza de sus jinetes, pero no han puesto sus ojos en el Santo de Israel,ni han consultado al Señor."
,"2":"También él es diestro en atraer desdichas, y no ha cambiado su palabra. Se levantará contra la casa de los malvados,y contra el auxilio de los malhechores."
,"3":"El egipcio es un hombre, y no un dios; y sus caballos son carne, no espíritu. El Señor extenderá su mano, y se tambaleará el protector; caerá el protegido y todos a la vez perecerán."
,"4":"Esto me ha dicho el Señor: Como el león o el cachorro ruge sobre su presa, y al acosarle el tropel de los pastores,no se asusta de sus gritos,ni se acobarda por su número, así el Señor todopoderoso bajará a pelear,en el monte Sión y en su colina."
,"5":"Como pájaros que vuelan, así el Señor omnipotente protegerá a Jerusalén: la protegerá, la salvará, la perdonará, la liberará."
,"6":"Volved a aquel de quien tanto os habéis apartado, hijos de Israel."
,"7":"Pues aquel día todos rechazarán,los ídolos de plata y los ídolos de oro,que habéis fabricado con vuestras inicuas manos."
,"8":"Y caerá Asiria por espada no de un hombre, devorada por espada no de mortal; y si escapa de la espada, sus jóvenes soldados quedarán hechos esclavos."
,"9":"De terror se desvanecerá su roca, y sus jefes, espantados, desertarán de su bandera, dice el Señor, que en Sión tiene su fuego, y su horno en Jerusalén."
}`)
	CurrentBook.AddChapter(32, `{
"1":"He aquí que un rey reinará con justicia,y príncipes gobernarán según derecho."
,"2":"Cada uno será,como un refugio contra el viento,y un abrigo contra la tempestad; como corrientes de agua en tierra seca, como la sombra de una gran peña en tierra ardiente."
,"3":"Los ojos de los que ven,no estarán más cerrados, y los oídos de los que oyen,estarán atentos;"
,"4":"el corazón de los necios,entrará en razón, y la lengua de los tartamudos,hablará con soltura."
,"5":"No se dará ya al necio,el nombre de noble, ni el mentiroso será llamado generoso."
,"6":"Pues el necio necedades habla, y su corazón medita iniquidad,para cometer perversidades,y hablar mal del Señor, para dejar vacío el vientre del hambriento,y privar al sediento de bebida."
,"7":"También son perversas,las armas del mentiroso. Tramas inicuas urde,para perder a los humildes con mentiras, y a los pobres que reclaman su derecho."
,"8":"En cambio, el noble sólo nobleza guarda, y a nobles empresas se entrega."
,"9":"Mujeres despreocupadas, levantaos; escuchad mi voz, hijas confiadas; prestad oído a mi palabra."
,"10":"Dentro de un año y unos días temblaréis, ¡oh confiadas!, porque se habrá acabado la vendimia,y no habrá más recolección."
,"11":"Temblad, despreocupadas; estremeceos, confiadas; despojaos, desnudaos, ceñíos la cintura,"
,"12":"golpeaos el pecho,por los campos risueños, por las fértiles viñas,"
,"13":"por el terruño de mi pueblo, donde brotan abrojos y espinas; por todas las casas jubilosas de la ciudad alegre."
,"14":"Pues el palacio está desierto, el bullicio de la ciudad ha enmudecido, el Ofel y la torre de guardia,se han convertido para siempre en cavernas, en solaz de los asnos salvajes,y pasto de los rebaños."
,"15":"Hasta que sobre nosotros,se derrame el espíritu venido de lo alto: entonces el desierto se trocará en vergel,y el vergel se cambiará en selva."
,"16":"En el desierto morará el derecho, y la justicia habitará en el vergel."
,"17":"De la justicia brotará la paz, y del derecho, la calma y la seguridad por siempre."
,"18":"Mi pueblo vivirá en mansión de paz, en moradas seguras, en apacibles lugares de reposo."
,"19":"(Como granizo, el bosque se derrumbará, y la ciudad se hundirá totalmente)."
,"20":"Felices vosotros, que entonces sembraréis,junto a todas las aguas, dejando suelto al buey y al asno."
}`)
	CurrentBook.AddChapter(33, `{
"1":"¡Ay de ti, devastador, que no has sido devastado; ay de ti, saqueador, que aún no has sido saqueado!,Cuando termines de devastar, serás tú devastado; cuando termines de saquear, serás saqueado."
,"2":"¡Señor, ten piedad de nosotros, que esperamos en ti!,Sé nuestra fuerza a la mañana, nuestra salud en tiempo de aflicción."
,"3":"A la voz de tu amenaza huyen los pueblos; al levantarte tú, se dispersan las naciones."
,"4":"Se hace botín como lo hacen los grillos, saltan sobre él como saltan las langostas."
,"5":"Excelso es el Señor; en las alturas mora, y llena a Sión de derecho y justicia."
,"6":"Tu permanencia es sólida. Riquezas salvadoras son sabiduría y ciencia; el temor del Señor será tu tesoro."
,"7":"Mirad, los héroes gritan fuera, los mensajeros de paz lloran amargamente."
,"8":"Desiertos están los caminos, ya no pasan caminantes; se ha roto la alianza,y se han despreciado los testimonios; no se hace caso de nadie."
,"9":"La tierra está de luto, languidece; avergonzado el Líbano, se amustia; el Sarón se parece a nuestra estepa, el Basán y el Carmelo están pelados."
,"10":"'Ahora me alzaré yo, dice el Señor; ahora surgiré y me erguiré."
,"11":"Heno habéis concebido, paja daréis a luz; mi soplo es un fuego que os devora."
,"12":"Los pueblos quedarán hechos cenizas,como espinos cortados, abrasados por el fuego."
,"13":"Los que estáis lejos, oíd lo que yo hago; los que estáis cerca, conoced mi poder'."
,"14":"Se estremecen en Sión los pecadores, el terror invade a los criminales. ¿Quién de nosotros podrá resistir,ante el fuego abrasador; quién resistirá estas llamas eternas?"
,"15":"El que camina en la justicia,y habla rectamente, el que rechaza una ganancia,arrancada a la fuerza, el que sacude su mano,para no aceptar soborno, tapa sus oídos para no oír intrigas de sangre,y cierra sus ojos para no ver el mal:"
,"16":"ése morará en lugar excelso, ciudadela escarpada será su refugio, tendrá pan y no le faltará agua."
,"17":"Tus ojos contemplarán,al rey en su belleza, verán un inmenso país."
,"18":"Tu corazón recordará los días de terror: '¿Dónde está el que hacía cuentas, dónde el que pesaba el dinero, dónde el que contaba las torres?'."
,"19":"Al pueblo insolente no le verás más; al pueblo de lengua oscura, incomprensible, de lenguaje impenetrable, ininteligible."
,"20":"Contempla a Sión, la ciudad de nuestras fiestas; tus ojos verán a Jerusalén, como mansión segura, tienda que no se arranca; no se moverán jamás sus estacas, ni se romperá ninguna de sus cuerdas."
,"21":"Porque el Señor está aquí,para nosotros en su gloria, junto a ríos y canales anchurosos, por donde no pasa ningún barco de remos, ni circula ninguna nave poderosa;"
,"22":"se han aflojado sus amarras, no sostienen ya el mástil, ni ondean las enseñas."
,"23":"Pues el Señor es nuestro juez, nuestro caudillo; el Señor es nuestro rey,y nuestro salvador. Entonces se repartirá un enorme botín, y hasta los cojos se darán al saqueo."
,"24":"No habrá habitante que diga: 'Estoy enfermo'; y el pueblo que vive en Jerusalén,será perdonado de sus culpas."
}`)
	CurrentBook.AddChapter(34, `{
"1":"¡Acercaos, naciones, para oír, estad atentos, pueblos; escucha, tierra, y cuanto encierras, y tú, universo, con todo tu producto!"
,"2":"Pues el Señor está irritado,contra todas las naciones, enfurecido contra todo su ejército. Los ha condenado al exterminio, los ha entregado a la matanza."
,"3":"Los muertos son tirados a la calle, el hedor de sus cadáveres se expande, la sangre cunde de los montes."
,"4":"Todo el ejército de los cielos se disuelve, los cielos se enrollan como un libro, y todo su ejército se amustia, como se amustia el follaje de la vid, como las hojas mustias de la higuera."
,"5":"Pues en los cielos se embriaga mi espada; y ya se abalanza sobre Edón, sobre el pueblo que he entregado al castigo."
,"6":"La espada del Señor está llena de sangre, empapada de grasa, de sangre de corderos y de machos cabríos, de grasa de riñones de carneros. Pues el Señor va a hacer un sacrificio en Bosra, una gran matanza en el país de Edón."
,"7":"Caen con ellos los búfalos, los bueyes junto con los toros; su tierra está borracha de sangre, su suelo empapado de grasa,"
,"8":"porque es el día de la venganza del Señor, el año de la revancha para la causa de Sión."
,"9":"Sus torrentes se transforman en pez, y su tierra en azufre; su país queda hecho un brasero de pez;"
,"10":"ni de día ni de noche se apaga, su humo sube sin cesar, de edad en edad quedará desierto, y nadie más pasará por allí."
,"11":"Será morada de pelícanos y erizos, mansión de cuervos y lechuzas; el Señor tirará sobre ella,la cuerda del caos y la plomada del vacío."
,"12":"Allí morarán los sátiros, y no existirán más sus nobles; no será proclamado ningún rey, y todos sus jefes desaparecerán."
,"13":"Espinas crecerán en sus palacios, cardos y abrojos en sus fortalezas, será una guarida de chacales, morada de avestruces."
,"14":"Gatos salvajes y hienas se darán allí cita, y los sátiros se reunirán; también allí se tumbará Lilit, y encontrará su lugar de reposo."
,"15":"Allí anidará la víbora, allí pondrá, incubará y empollará sus huevos; allí también se juntarán los buitres, se encontrarán unos con otros."
,"16":"Buscad en el libro del Señor,y leed: no falta ni uno; ninguno echa de menos a su compañero, pues la boca del Señor lo ha ordenado,y su soplo los ha reunido."
,"17":"Él mismo les ha echado la suerte, su mano les ha repartido la tierra,con la cuerda de medir; por siempre la poseerán, en ella habitarán de generación en generación."
}`)
	CurrentBook.AddChapter(35, `{
"1":"Que se alegren el desierto,y la tierra seca, que se regocije la estepa y que florezca,"
,"2":"que dé flores como el narciso, que salte de alegría. Pues se le ha dado la gloria del Líbano, el esplendor del Carmelo y de Sarón; y se verá la gloria del Señor, el esplendor de nuestro Dios."
,"3":"¡Fortaleced las manos lánguidas, afirmad las rodillas vacilantes!"
,"4":"Decid a los pusilánimes: ¡Ánimo, no temáis!,Mirad, es vuestro Dios; ya viene la venganza, la revancha de Dios; viene él mismo a salvaros."
,"5":"Entonces se abrirán los ojos de los ciegos, y los oídos de los sordos se abrirán."
,"6":"Saltará el cojo como un ciervo, la lengua del mudo gritará de júbilo, porque en el desierto,brotarán corrientes de agua, y torrentes en la estepa;"
,"7":"la tierra ardiente se trocará en estanque, el suelo sediento en hontanar de aguas; y el cubil donde yacían los chacales,se volverá verdor de cañas y de juncos."
,"8":"Habrá allí un camino allanado, se le llamará la vía santa; ningún impuro pasará por él, ni a él irán a parar los insensatos."
,"9":"Ya no habrá allí león, ni bestia feroz pondrá los pies; sólo los redimidos caminarán por él."
,"10":"Por él volverán los liberados del Señor, llegarán a Sión entre gritos de júbilo, una alegría eterna transformará su rostro; júbilo y alborozo les acompañarán, pena y llanto habrán huido."
}`)
	CurrentBook.AddChapter(36, `{
"1":"El año catorce del rey Ezequías, Senaquerib, rey de Asiria, subió contra todas las ciudades fortificadas de Judá y las tomó todas."
,"2":"Desde Laquis, el rey de Asiria envió hacia el rey Ezequías, en Jerusalén, al general, con gran fuerza militar. Se apostó éste cerca del canal de la alberca superior, junto al camino del Campo del Batanero."
,"3":"A su encuentro salieron el mayordomo de palacio, Eliaquín, hijo de Jelcías; el secretario Sebná y el heraldo Yoaj, hijo de Asaf."
,"4":"El general les dijo: Decid a Ezequías: 'Esto dice el gran rey, el rey de Asiria: ¿Qué esperanza es esa que mantienes?"
,"5":"¿Crees acaso que la palabrería vale como consejo y fuerza para hacer la guerra? ¿En quién te apoyas para rebelarte contra mí?"
,"6":"¡Ah, sí, en Egipto confías, en esa caña rota que se clava y punza la mano de quien se apoya en ella! ¡Tal es el Faraón, rey de Egipto, para todos los que ponen en él su confianza!"
,"7":"Acaso me diréis: Nosotros confiamos en el Señor, nuestro Dios; pero ¿no es ése precisamente el Dios cuyas colinas y cuyos altares suprimió Ezequías, ordenando a Judá y a Jerusalén: Sólo ante este altar os debéis prosternar?"
,"8":"Ahora, pues, haz una apuesta con mi señor, el rey de Asiria: yo te daré dos mil caballos si logras encontrar otros tantos jinetes."
,"9":"¿Cómo vas a hacer retroceder a uno solo de los más ínfimos servidores de mi señor? Pero tú te fías de Egipto para conseguir carros y jinetes."
,"10":"Y ¿crees que yo he subido a devastar este país sin el permiso del Señor? Es el Señor quien me ha dicho: Sube a ese país y devástalo'."
,"11":"Eliaquín, Sebná y Yoaj respondieron al general: 'Habla, por favor, en arameo a tus siervos, porque nosotros lo entendemos; no nos hables en judío a oídos del pueblo que está tras la muralla'."
,"12":"Pero el general contestó: '¿Es que mi señor me ha enviado a comunicar esto a tu señor y a ti, y no más bien a los hombres que están tras la muralla y que con vosotros están condenados a comer sus excrementos y a beber sus orines?'."
,"13":"Entonces el general se adelantó y dijo en alta voz, en judío: 'Escuchad las palabras del gran rey de Asiria."
,"14":"Esto dice el rey: ¡No os dejéis engañar por Ezequías, que no os podrá salvar!"
,"15":"No os infunda Ezequías confianza en el Señor, al deciros: El Señor nos librará sin duda alguna; esta ciudad no caerá en manos del rey de Asiria:"
,"16":"No escuchéis a Ezequías, pues esto dice el rey de Asiria: Haced la paz conmigo, venid a mí y cada uno de vosotros comerá el fruto de su viña y de su higuera; cada uno beberá el agua de su pozo,"
,"17":"hasta que yo venga y os lleve conmigo a un país como el vuestro, país de grano y mosto, país de pan y de viñas."
,"18":"No os engañe Ezequías diciendo: El Señor nos librará. ¿Han librado acaso los dioses de los pueblos a su respectivo país de caer en manos del rey de Asiria?"
,"19":"¿Dónde están los dioses de Sefarváyim? ¿Dónde los del país de Samaría? ¿Han librado a Samaría de mis manos?"
,"20":"¿Cuál de todos los dioses de esos países ha salvado a su país de mis manos, para que el Señor pueda también salvar de mis manos a Jerusalén?'."
,"21":"Ellos guardaron silencio y no le respondieron nada, porque ésta era la orden del rey: 'No le contestéis'."
,"22":"Y el mayordomo del palacio, Eliaquín, hijo de Jelcías, el secretario Sebná y el heraldo Yoaj, hijo de Asaf, volvieron, rasgados los vestidos, donde Ezequías y le dieron cuenta de las palabras del general."
}`)
	CurrentBook.AddChapter(37, `{
"1":"Al oírlos, el rey Ezequías se rasgó las vestiduras, se vistió de saco y entró en el templo del Señor."
,"2":"Luego mandó al mayordomo de palacio Eliaquín, al secretario Sebná y a los ancianos de los sacerdotes, vestidos de saco, donde el profeta Isaías, hijo de Amós."
,"3":"Ellos le dijeron: 'Esto dice Ezequías: Día de angustia, de castigo y oprobio es este día; los niños están a punto de nacer, pero falta la fuerza para darlos a luz."
,"4":"El Señor, tu Dios, habrá oído las palabras del general que el rey de Asiria, su señor, mandó a insultar al Dios vivo, y el Señor, tu Dios, lo castigará. Eleva, pues, una oración por el resto que aún subsiste'."
,"5":"Cuando los servidores del rey Ezequías llegaron con esta embajada a Isaías,"
,"6":"el profeta les dijo: 'Decid a vuestro amo: Esto dice el Señor: No te asustes por las palabras que has oído, con las que los esbirros del rey de Asiria me han injuriado."
,"7":"Yo le infundiré un espíritu tal que, al oír cierta noticia, se volverá a su país, y allí yo lo haré caer a espada'."
,"8":"El general regresó entonces y fue a encontrarse con el rey de Asiria que estaba atacando a Libná, pues había sabido que el rey se había retirado de Laquis,"
,"9":"al recibir esta noticia sobre Taraca, rey de Etiopía: 'Ha salido a luchar contra ti'. Senaquerib, al saberlo, envió otros mensajeros a Ezequías con este encargo: "
,"10":"'Diréis a Ezequías, rey de Judá: No te engañe tu Dios en quien confías, diciéndote: Jerusalén no caerá en manos del rey de Asiria."
,"11":"Sabes muy bien lo que los reyes de Asiria han hecho con todos los países: entregarlos al exterminio. ¿Y tú te vas a librar?"
,"12":"¿Pudieron acaso los dioses salvar a aquellas naciones aniquiladas por mis padres: a Gozán, Jarán, Résef y los edenitas de Telasar?"
,"13":"¿Dónde está el rey de Jamat, el rey de Arpad, el rey de Sefarváyim, de Hena y de Iva?'."
,"14":"Ezequías tomó la carta de mano de los mensajeros y, después de haberla leído, subió al templo del Señor y la desplegó ante el Señor."
,"15":"Luego, Ezequías dirigió al Señor esta oración:"
,"16":"'Señor todopoderoso, Dios de Israel, entronizado sobre los querubines; tú eres el único Dios de todos los reinos de la tierra; tú eres el creador del cielo y de la tierra."
,"17":"Inclina, Señor, tu oído y escucha; abre, Señor, tus ojos y mira; escucha las palabras de Senaquerib, que ha mandado insultar al Dios vivo."
,"18":"Es cierto, Señor: los reyes de Asiria han asolado a todas las naciones y sus territorios;"
,"19":"han arrojado al fuego a sus dioses, porque no eran dioses, sino obras de manos humanas, madera y piedra; por esto han podido destruirlos."
,"20":"Pero ahora, Señor, Dios nuestro, líbranos de sus manos, a fin de que todos los reinos de la tierra sepan que tú eres el único Dios'."
,"21":"Entonces Isaías, hijo de Amós, mandó a decir a Ezequías: Esto dice el Señor, Dios de Israel: He oído la oración que me has hecho sobre Senaquerib, rey de Asiria;"
,"22":"y ésta es la palabra que el Señor ha pronunciado contra él: Te desprecia, hace burla de ti la virgen de Sión; a tus espaldas menea la cabeza la hija de Jerusalén."
,"23":"¿A quién has injuriado y ultrajado?,¿Contra quién has levantado la voz,y alzado altivamente tus miradas?,¡Contra el Santo de Israel!"
,"24":"Por medio de tus esbirros,has insultado al Señor, has dicho: Con mis innumerables carros,he subido a la cima de los montes, hasta las cumbres últimas del Líbano; he talado sus altísimos cedros,y sus más imponentes cipreses; he llegado hasta sus últimos rincones, hasta la espesura de su bosque."
,"25":"Yo mismo he excavado,y he bebido aguas extranjeras; he secado con las plantas de mis pies,todos los Nilos de Egipto."
,"26":"¿Lo oyes bien?,Desde hace mucho he preparado esto; desde tiempos lejanos lo he trazado, y ahora lo ejecuto: tú tenías que convertir las ciudades fortificadas,en un montón de ruinas."
,"27":"Sus habitantes, impotentes, espantados y confusos, eran como la hierba del campo, como el verdor del césped, como los brotes de los tejados, agostados por el viento del este."
,"28":"Yo sé cuándo tú te levantas y te sientas; salgas o entres, yo lo sé."
,"29":"Por haberte envalentonado contra mí, pues tu insolencia y tu furor contra mí,han llegado a mis oídos, voy a poner mi anillo en tu nariz,y mi freno en tus labios, para hacerte volver por el camino,por donde has venido."
,"30":"Y esto te servirá de señal: Se comerá este año el grano caído,y al año siguiente lo que brote sin sembrar; pero al tercer año podréis sembrar y cosechar, plantar viñas y comer su fruto."
,"31":"El resto que sobrevivirá de la casa de Judá,volverá a echar raíces por abajo,y a llevar fruto por arriba,"
,"32":"pues de Jerusalén saldrá un resto, y del monte Sión un grupo de supervivientes. El celo del Señor todopoderoso lo hará."
,"33":"Por eso, esto dice el Señor sobre el rey de Asiria: No entrará en esta ciudad, no disparará una flecha contra ella, no le opondrá escudos, ni la cercará de baluartes."
,"34":"Por el camino que le trajo se volverá, y no entrará en esta ciudad, dice el Señor."
,"35":"Yo defenderé esta ciudad y la salvaré, en atención a mí y a mi siervo David."
,"36":"Aquella misma noche el ángel del Señor salió e hirió en el campamento asirio a ciento ochenta y cinco mil hombres. Por la mañana, al despertar, no se veía más que cadáveres."
,"37":"Entonces Senaquerib, rey de Asiria, levantó el campamento y se marchó y, de regreso, se quedó en Nínive."
,"38":"Y un día, mientras estaba adorando en el templo de Misroc, su dios, sus hijos Adramélec y Saréser le mataron con la espada. Huyeron éstos después al país de Ararat, y Asaradón, hijo suyo, le sucedió en el trono."
}`)
	CurrentBook.AddChapter(38, `{
"1":"Por entonces cayó mortalmente enfermo Ezequías. El profeta Isaías, hijo de Amós, vino a decirle: 'Esto dice el Señor: Pon en orden las cosas de tu casa, porque vas a morir y no sanarás'."
,"2":"Entonces Ezequías se volvió contra la pared y oró así al Señor:"
,"3":"'Señor, acuérdate, por favor, de que he caminado fielmente en tu presencia con corazón honrado, haciendo lo que es recto a tus ojos'. Y Ezequías rompió a llorar copiosamente."
,"4":"Entonces el Señor dirigió la palabra a Isaías ordenándole:"
,"5":"'Vete a decir a Ezequías. Esto dice el Señor, Dios de tu padre David: He escuchado tu oración, he visto tus lágrimas y te voy a curar. Dentro de tres días podrás subir al templo del Señor. Y te daré quince años más de vida."
,"6":"Te libraré de la mano del rey de Asiria y protegeré esta ciudad'."
,"21":"Después Isaías dijo: 'Tomad una torta de higos, aplicadla a la llaga y sanará'."
,"22":"Y Ezequías preguntó: '¿Por qué señal conoceré que he de subir de nuevo al templo del Señor?'."
,"7":"Isaías respondió: 'Ésta será para ti de parte del Señor la señal de que él cumplirá su palabra:"
,"8":"Voy a hacer retroceder diez grados la sombra que el sol ha descendido ya en el reloj de Acaz'. Y el sol retrocedió diez grados de los que ya había descendido."
,"9":"Cántico de Ezequías, rey de Judá, con motivo de la curación de su enfermedad."
,"10":"Yo decía: A la mitad de mis días,tengo que ir a las puertas del abismo; seré privado del resto de mis años."
,"11":"Y decía: Ya no veré al Señor,en la tierra de los vivos; no veré a nadie más de los habitantes de la tierra."
,"12":"Mi morada es arrancada, lejos de mí arrojada,como tienda de pastores. Como un tejedor enrollas tú mi vida, cortando la trama. Día y noche me oprimes,"
,"13":"hasta la mañana estoy gritando; como un león trituras todos mis huesos, día y noche me oprimes."
,"14":"Pío como la golondrina, gimo como la paloma. Se consumen mis ojos de mirar a lo alto. Señor, en angustia estoy; sé tú mi valedor."
,"15":"¿Qué diré? ¿De qué le voy a hablar?,Es él quien actúa. Terminaré el curso de mis años, pasada la amargura de mi alma."
,"16":"Señor, por ti vive mi corazón, vive mi espíritu; dame la salud, devuélveme la vida."
,"17":"Oh, sí, en salud se cambia mi amargura. Tú has salvado mi vida,de la fosa vacía, te has echado a las espaldas,todos mis pecados."
,"18":"Porque el abismo no te alaba,ni te ensalza la muerte; no esperan los que bajan a la fosa tu fidelidad."
,"19":"El que vive, el que vive, te alaba como yo en este día. El padre da a conocer a sus hijos tu fidelidad."
,"20":"Señor, puesto que me has salvado, haremos resonar nuestros instrumentos,todos los días de nuestra vida,en el templo del Señor."
}`)
	CurrentBook.AddChapter(39, `{
"1":"En aquel tiempo, Merodac Baladán, hijo de Baladán, rey de Babilonia, mandó cartas y un regalo a Ezequías al enterarse de su enfermedad y de su curación."
,"2":"Ezequías se alegró mucho y enseñó a los mensajeros su tesoro, la plata, el oro, los aromas, el aceite exquisito, así como su arsenal y lo que había en sus almacenes; nada quedó que Ezequías no les enseñara en su palacio y en sus posesiones."
,"3":"Entonces el profeta Isaías fue a decir al rey Ezequías: '¿Qué te han dicho esos hombres? ¿De dónde han venido?'. Ezequías respondió: 'Han venido de un país lejano, de Babilonia'."
,"4":"Isaías replicó: '¿Qué han visto en tu palacio?'. Ezequías respondió: 'Han visto todo lo que hay en mi palacio; no ha quedado nada en mis almacenes que no haya enseñado'."
,"5":"Isaías dijo entonces a Ezequías: 'Escucha la palabra del Señor todopoderoso."
,"6":"Vendrán días en que todo lo que hay en tu palacio y lo que han atesorado tus padres hasta el día de hoy será llevado a Babilonia; nada quedará -dice el Señor-."
,"7":"Y a los hijos salidos de ti, los que tú has engendrado, los llevarán a Babilonia para que sirvan como criados en el palacio del rey'."
,"8":"Ezequías dijo a Isaías: '¡Bien está la palabra del Señor que has pronunciado!'. Pues pensaba: 'En mi vida por lo menos habrá paz y seguridad'."
}`)
	CurrentBook.AddChapter(40, `{
"1":"Consolad, consolad a mi pueblo, dice vuestro Dios."
,"2":"Hablad al corazón de Jerusalén,y gritadle que se ha cumplido su servicio, que está perdonado su pecado, que ha recibido de la mano del Señor,el doble de castigo por todos sus pecados."
,"3":"Una voz grita: Preparad en el desierto,para el Señor un camino, allanad en la estepa una senda,para nuestro Dios."
,"4":"Que los valles se eleven, que las montañas y colinas se abajen, que los caminos tortuosos se hagan rectos,y los escabrosos llanos."
,"5":"La gloria del Señor se manifestará,y todo mortal la verá, porque la boca del Señor ha hablado."
,"6":"Una voz manda: ¡Grita!,Yo digo: ¿Qué he de gritar?,Todo mortal es hierba, toda su gloria como flor del campo."
,"7":"La hierba se seca, la flor se marchita, cuando el soplo del Señor le llega. ¡Sí, el pueblo es la hierba!"
,"8":"La hierba se seca, la flor se marchita, pero la palabra de nuestro Dios,permanece por siempre."
,"9":"Sube a un monte alto, mensajero de albricias de Sión, haz resonar fuertemente tu voz, mensajero de albricias de Jerusalén. Hazla resonar sin miedo: di a las ciudades de Judá: ¡Aquí está vuestro Dios!"
,"10":"Aquí el Señor Dios, que viene con potencia; su brazo lo somete todo. Viene con él el precio de su victoria, y sus trofeos le preceden."
,"11":"Como un pastor apacienta su rebaño, en su brazo recoge a los corderos, en su seno los lleva y conduce,al reposo a las paridas."
,"12":"¿Quién ha medido las aguas,con el cuenco de sus manos,y ha determinado con el palmo,la medida del cielo?,¿Quién ha medido toda la tierra con el metro, en la balanza ha pesado los montes,y en los platillos las colinas?"
,"13":"¿Quién ha orientado el espíritu del Señor,y qué consejero le ha instruido?"
,"14":"¿De quién tomó consejo para juzgar, para conocer la senda de la justicia, para aprender la ciencia,e instruirse en los caminos de la sabiduría?"
,"15":"Las naciones son como una gota en un cubo, como un grano de arena en la balanza; las islas pesan como tenue polvo."
,"16":"No es suficiente el Líbano,para procurar leña, ni bastan sus animales,para el holocausto."
,"17":"Nada son todos los pueblos ante él, los considera como el vacío y la nada."
,"18":"¿Con quién se puede comparar a Dios, dónde encontraréis su semejante?"
,"19":"El fundidor funde el ídolo, y el orfebre lo recubre de oro,y le suelda cadenas de plata."
,"20":"Se toma madera incorruptible,y se busca un hábil escultor,para erigir una estatua que no se tambalee."
,"21":"¿No lo sabéis? ¿No lo habéis oído?,¿No se os ha manifestado desde el principio?,¿No lo habéis comprendido desde que se fundó la tierra?"
,"22":"Él se sienta sobre el globo de la tierra, cuyos habitantes le parecen saltamontes; él despliega los cielos como tenue velo,y los extiende como una tienda para vivir en ella;"
,"23":"reduce a nada a los que gobiernan,y aniquila a los jueces de la tierra."
,"24":"Apenas plantados, apenas sembrados, apenas arraigado en la tierra su brote, sopla sobre ellos y se secan, y un torbellino se los lleva como paja."
,"25":"¿Con quién, pues, me vais a comparar?,¿Quién hay como yo?, dice el Santo."
,"26":"Alzad los ojos a lo alto y mirad: ¿Quién ha creado todos estos astros, sino el que despliega en orden sus mesnadas,y llama a cada uno por su nombre?,Tanta es su fuerza, tan grande su poder,que ninguno falta a su llamada."
,"27":"¿Por qué dices, Jacob, y afirmas tú, Israel: Mi suerte está oculta al Señor, a Dios se le pasa por alto mi derecho?"
,"28":"¿No lo sabes? ¿No lo has oído?,El Señor es un Dios eterno, creador de los confines de la tierra. No se cansa ni se fatiga, su inteligencia es insondable."
,"29":"Él reanima al cansado y reconforta al débil."
,"30":"Podrán los jóvenes cansarse y fatigarse, podrán tambalearse los muchachos;"
,"31":"pero los que esperan al Señor,renuevan sus fuerzas, remontan el vuelo como águilas, corren sin fatigarse y caminan sin cansarse."
}`)
	CurrentBook.AddChapter(41, `{
"1":"Islas, guardad silencio ante mí; renovad, pueblos, vuestras fuerzas. Adelantaos para hablar, comparezcamos juntos en juicio."
,"2":"¿Quién ha suscitado del Oriente,a aquel que apela a la justicia a cada paso?,¿Quién le entrega las naciones,y le somete los reyes?,Su espada los reduce a polvo, su arco los dispersa como paja."
,"3":"Él los persigue, y sigue tranquilo,por caminos que sus pies no pisaron."
,"4":"¿Quién ha hecho esta gesta?,El que llama desde el principio a las generaciones. Yo, el Señor, que soy el primero,y estaré también con los últimos."
,"5":"Las islas lo ven y se estremecen, tiemblan los confines de la tierra, se acercan y allí están."
,"6":"Cada cual anima a su vecino, y se dicen unos a otros: ¡Ánimo!"
,"7":"El fundidor anima al orfebre, el que pule con el martillo,al que golpea el yunque; dice de la soldadura: ¡Está bien!, y sujeta el ídolo con clavos,para que no se mueva."
,"8":"Pero tú, Israel, mi siervo, Jacob, a quien yo elegí, raza de Abrahán, mi amigo,"
,"9":"tú, a quien yo tomé de los confines de la tierra, a quien llamé de remotas regiones, a quien dije: Tú, mi siervo, yo te he elegido,y no te he desechado;"
,"10":"no temas, porque yo estoy contigo; no te asustes, pues yo soy tu Dios. Yo te doy fuerza, soy tu auxilio,y te sostengo con mi diestra victoriosa."
,"11":"Sí, serán avergonzados, humillados,todos los que se envalentonan contra ti, serán aniquilados,y perecerán los que riñen contigo."
,"12":"Buscarás, sin encontrarlos, a los que te odian; serán aniquilados, reducidos a la nada, los que te hacen la guerra."
,"13":"Pues yo, el Señor, tu Dios, te cojo de la diestra y te digo: No temas, que yo vengo a ayudarte."
,"14":"No temas, gusanillo de Jacob, larva insignificante de Israel; ya vengo yo en tu ayuda, dice el Señor: tu redentor es el Santo de Israel."
,"15":"Mira, yo te convierto en trillo nuevo, de doble hilera de dientes; trillarás los montes, los pulverizarás, reducirás a paja las colinas."
,"16":"Las aventarás y el viento se las llevará, las esparcirá el torbellino; mas tú te regocijarás en el Señor, en el Santo de Israel te gloriarás."
,"17":"Los humillados y los pobres buscan agua y no la hay; su lengua de sed está reseca. Yo, el Dios de Israel, no los abandonaré."
,"18":"Sobre cumbres peladas haré brotar ríos, y fuentes en medio de los valles. Transformaré el desierto en un estanque, la tierra seca en manantiales."
,"19":"Pondré en el desierto cedros, acacias, mirtos y olivares; en la estepa plantaré cipreses, olmos y terebintos juntamente,"
,"20":"para que vean y sepan, consideren y conozcan todos,que esto lo ha hecho la mano del Señor,y lo ha creado el Santo de Israel."
,"21":"Presentad vuestra causa, dice el Señor; aportad vuestras pruebas, dice el rey de Jacob."
,"22":"¡Adelántense y nos anuncien,lo que ha de suceder!,¿Cuáles eran vuestras anteriores profecías?,Decidlas y prestaremos atención. O bien anunciad lo por venir, conoceremos su desenlace."
,"23":"Anunciad lo que sucederá en el futuro, para que sepamos si sois dioses. Haced algo por lo menos, para que, sorprendidos, lo veamos."
,"24":"Pero no, que no sois nada; nada son vuestras obras, y aborrecible quien os elige."
,"25":"Yo lo he suscitado del norte y ya viene, del sol levante lo he llamado por su nombre; ha pisoteado como barro a los sátrapas, como un alfarero pisa la arcilla."
,"26":"¿Quién lo había predicho desde antiguo,para que lo supiéramos de antemano,para que se pueda decir: Justo?,No, nadie lo ha predicho, nadie lo ha proclamado; no, ninguno ha oído vuestras palabras."
,"27":"Yo fui el primero que lo anuncié en Sión,y envié a Jerusalén un mensaje de albricias."
,"28":"Miré, y no había nadie; entre ellos ningún consejero,a quien pudiera interrogar,y que me respondiese."
,"29":"Todos juntos son nada, nulidad son sus obras, aire y vacío sus ídolos."
}`)
	CurrentBook.AddChapter(42, `{
"1":"Aquí está mi siervo a quien protejo; mi elegido, en quien mi alma se complace. He puesto en él mi espíritu, para que traiga la justicia a las naciones."
,"2":"No gritará, no alzará el tono, no hará oír por las calles su voz."
,"3":"No romperá la caña cascada, ni apagará la mecha humeante. Traerá con toda seguridad la justicia."
,"4":"No desistirá, no desmayará,hasta que implante en la tierra,la justicia y sus leyes, que las islas esperan."
,"5":"Esto dice el Señor, Dios, el que creó los cielos y los desplegó, el que asentó la tierra y sus productos, el que da aliento al pueblo que la habita,y soplo a los seres que se mueven en ella:"
,"6":"Yo, el Señor, te he llamado para la justicia, te he tomado de la mano y te he formado, te he puesto como alianza del pueblo,y luz de las naciones,"
,"7":"para abrir los ojos a los ciegos, para sacar a los presos de la cárcel, del calabozo a los que viven en tinieblas."
,"8":"Yo soy el Señor, éste es mi nombre; no cederé mi gloria a ningún otro, ni mi honor a los ídolos."
,"9":"Las primeras predicciones se han cumplido, y anuncio nuevas cosas; antes que surjan os las hago saber."
,"10":"Cantad al Señor un canto nuevo, su alabanza desde los extremos de la tierra; le ensalce el mar y cuanto abarca, las islas con todos sus habitantes."
,"11":"Alcen su voz el desierto y sus ciudades, las aldeas en que habita Quedar; aclamen los habitantes de Petra, desde lo alto de los montes lancen gritos."
,"12":"¡Den gloria al Señor, hasta en las islas pregonen su alabanza!"
,"13":"El Señor avanza como un héroe, como un guerrero excita su valor; lanza el grito de guerra, el alarido, marcha poderoso contra sus enemigos."
,"14":"He estado en silencio por mucho tiempo, me he callado, me he contenido; ya gimo como mujer en parto, suspiro y jadeo."
,"15":"Voy a secar montes y colinas, agostaré todo su verdor; trocaré los ríos en tierra seca,y secaré los pantanos."
,"16":"Guiaré a los ciegos,por caminos que no conocen, por senderos ignorados los haré caminar; ante ellos cambiaré las tinieblas en luz, y en llano el terreno pedregoso. Todo esto es lo que voy a hacer,y lo haré sin falta."
,"17":"Se darán a la fuga, cubiertos de vergüenza, los que confían en sus ídolos, los que dicen a las imágenes fundidas: ¡Vosotros sois nuestros dioses!"
,"18":"¡Sordos, oíd!,¡Ciegos, abrid vuestros ojos para ver!"
,"19":"¿Quién está ciego, sino mi siervo?,¿Quién sordo como el mensajero que yo envío?,¿Quién está ciego como mi enviado,y sordo como el siervo del Señor?"
,"20":"¡Has visto muchas cosas, sin enterarte; tienes abiertos los oídos, mas no oyes!"
,"21":"El Señor quiere, por amor a su justicia, engrandecer y magnificar la ley."
,"22":"Pero éste es un pueblo saqueado y despojado; todos están presos en cavernas, en calabozos encerrados. Botín se han vuelto, y no hay quien los libre; saqueo, y nadie dice: ¡Restituye!"
,"23":"¿Quién de vosotros presta oído a esto, está atento y lo guarda para el porvenir?"
,"24":"¿Quién ha entregado a Jacob al saqueo, y a Israel a los depredadores?,¿No ha sido el Señor, contra quien pecamos, cuyos caminos no quisimos seguir, ni escuchamos su ley?"
,"25":"Por eso derramó sobre él el ardor de su cólera,y los horrores de la guerra. ¡Rodeado de llamas, no ha entendido; abrasado, no ha prestado atención!"
}`)
	CurrentBook.AddChapter(43, `{
"1":"Pero ahora esto dice el Señor, tu creador, Jacob, aquel que te formó, Israel: No temas, pues yo te he redimido, te he llamado por tu nombre; mío eres."
,"2":"Si pasas por las aguas, yo estaré contigo; si por ríos, no te ahogarás. Si caminas por el fuego, no te quemarás, y las llamas no te abrasarán."
,"3":"Porque yo soy el Señor, tu Dios, el Santo de Israel, tu salvador. Como precio de tu rescate,entrego a Egipto, Etiopía y Sabá a cambio tuyo."
,"4":"Porque mucho vales a mis ojos, eres precioso y yo te amo. Por eso a cambio tuyo entrego hombres y pueblos,por el rescate de tu vida."
,"5":"No temas, porque yo estoy contigo. Desde oriente haré venir a tu raza, y desde occidente te recogeré."
,"6":"Diré al norte: ¡Restituye!, y al sur: ¡No los retengas!,Devuelve a mis hijos de allá lejos,y a mis hijas de los confines de la tierra,"
,"7":"a todos aquellos que llevan mi nombre, a quienes yo crié para mi gloria, a quienes formé y preparé."
,"8":"Traed al pueblo ciego, aunque tiene ojos; a los sordos, aunque tienen oídos."
,"9":"Congréguense todas las naciones, reúnanse los pueblos. ¿Quién, entre ellos, puede anunciar esto,y lo ha proclamado desde antiguo?,Presenten sus testigos para justificarse, déjense oír para que digamos: ¡Es verdad!"
,"10":"Vosotros sois mis testigos -dice el Señor-,y mis siervos, a quienes yo he elegido, para que me conozcáis y creáis en mí,y comprendáis que soy yo; antes de mí no existió ningún dios, y ningún otro existirá después."
,"11":"Yo, yo soy el Señor; fuera de mí no hay salvador."
,"12":"Yo lo anuncié y lo proclamé, yo los salvé; yo, y no un extraño entre vosotros. Vosotros sois mis testigos -dice el Señor-,y yo soy Dios;"
,"13":"desde la eternidad lo soy; nadie se puede librar de mi mano, yo actúo sin que nadie lo impida."
,"14":"Esto dice el Señor, vuestro redentor, el Santo de Israel: Por amor vuestro envió gente a Babilonia,a arrancar los cerrojos de las prisiones, y los caldeos prorrumpirán en llanto."
,"15":"Yo, el Señor, vuestro santo, el creador de Israel, vuestro rey."
,"16":"Esto dice el Señor, el que abrió en el mar un camino, un sendero en las caudalosas aguas;"
,"17":"el que hizo avanzar carros y caballos,y un imponente ejército: ahora yacen tendidos para no alzarse más, se apagaron como una mecha que se extingue."
,"18":"¡No os acordéis de antaño, de lo pasado no os cuidéis!"
,"19":"Mirad, yo voy a hacer una cosa nueva; ya despunta, ¿no lo notáis?,Sí, en el desierto abriré un camino, y ríos en la tierra seca."
,"20":"Las bestias del campo me glorificarán, los chacales y las avestruces, porque yo daré agua en el desierto, y ríos en la tierra seca, para abrevar a mi pueblo, a mi elegido."
,"21":"El pueblo que yo he formado celebrará mi gloria."
,"22":"Mas tú, Jacob, no me has invocado; tú, Israel, no te has inquietado por mí."
,"23":"No me has ofrecido corderos en holocausto, ni me has honrado con tus sacrificios. Yo no te forcé a hacerme ofrendas, no he insistido en que me ofrecieras incienso."
,"24":"No has comprado por dinero,caña aromática para mí, ni me has saciado con la grasa de tus sacrificios; sólo con tus pecados me has oprimido, me has agobiado con tus iniquidades."
,"25":"Soy yo, soy yo, quien tengo que borrar tus faltas,y no acordarme de tus pecados."
,"26":"Recuerda bien: discutiremos juntos, haz tus cuentas para justificarte."
,"27":"Ya pecó tu primer padre, y tus mediadores se han rebelado contra mí;"
,"28":"tus jefes han profanado el santuario, por eso he entregado a Jaco al exterminio, y a Israel a los ultrajes."
}`)
	CurrentBook.AddChapter(44, `{
"1":"Pero ahora escucha, Jacob, siervo mío, Israel a quien yo elegí."
,"2":"Esto dice el Señor, el que te ha hecho, el que te formó desde el seno materno y te socorre: No temas, siervo mío Jacob, Israel a quien yo he elegido,"
,"3":"porque yo derramaré agua en el suelo sediento, y torrentes en la tierra reseca: infundiré mi espíritu en tu raza,y mi bendición en tu posteridad."
,"4":"Brotarán como la hierba entre agua, como los álamos junto a las corrientes."
,"5":"Uno dirá: Yo soy del Señor; otro se llamará con el nombre de Jacob; otro escribirá en su mano: Del Señor, y con el nombre de Israel será llamado."
,"6":"Esto dice el Señor, rey de Israel, su redentor, el Señor omnipotente. Yo soy el primero y el último, no hay otro dios fuera de mí."
,"7":"¿Quién como yo? ¡Preséntese y hable, que lo anuncie y lo pruebe ante mí!,¿Quién manifestó desde el principio el porvenir, y nos hizo saber lo que iba a suceder?"
,"8":"No os asustéis, no temáis. ¿No os lo di a conocer y os lo anuncié yo hace mucho?,Vosotros sois testigos: ¿Hay dios fuera de mí o raza alguna?,¡Yo no lo conozco!"
,"9":"Los escultores de ídolos, todos juntos, no son nada; sus obras, que tanto aprecian, no sirven para nada. Sus testigos no ven nada, ni se enteran de nada. Por eso serán avergonzados."
,"10":"El que esculpe un dios, funde una estatua, que no le sirve de nada."
,"11":"Todos los fieles de esta estatua quedarán en ridículo; sus artífices quedarán cubiertos de vergüenza."
,"12":"El forjador trabaja al fuego y da forma a su obra a martillazos; la trabaja a fuerza de brazos; siente hambre, está agotado; no bebe agua, está extenuado."
,"13":"El que trabaja la madera tira la cuerda de medir, diseña el ídolo a lápiz, lo trabaja a la azuela, sigue el diseño con el compás y lo modela semejante a una figura humana, conforme a las facciones de un hombre, para que habite en un templo."
,"14":"Corta cedros o escoge un ciprés o una encina, ya crecidos entre los árboles del bosque, o bien algún cedro plantado por él y que la lluvia ha hecho crecer."
,"15":"Todo esto lo emplea el hombre para hacer fuego y le sirve para calentarse; lo enciende también para cocer el pan. Y con esto mismo se fabrica además un dios para prosternarse ante él, se hace un ídolo para adorarlo."
,"16":"Con la mitad hace el fuego; y sobre las brasas asa carne, la come y queda satisfecho. También se calienta y dice: '¡Ah, ya me caliento y siento el fuego!'."
,"17":"Y con lo restante se hace su dios, su ídolo, ante el cual se prosterna y se inclina y al que suplica diciendo: '¡Sálvame, pues tú eres mi dios!'."
,"18":"No saben ni entienden nada; sus ojos están cerrados a toda visión y su corazón a toda inteligencia."
,"19":"No reflexionan, no tienen sentido ni inteligencia para decirse: 'He quemado al fuego la mitad de la madera; sobre sus brasas he cocido el pan, he asado carne y la he comido; ¡y con el resto voy a hacer algo detestable; voy a postrarme ante un pedazo de madera!'."
,"20":"El que se alimenta de ceniza, engañando el corazón, está perdido. No salvará su vida, y no dirá jamás: '¿No es un engaño lo que tengo en mi diestra?'."
,"21":"Recuerda esto, Jacob, y tú, Israel, que eres mi siervo. Yo te he formado, siervo mío eres, Israel; no te olvidaré."
,"22":"He disipado como una nube tus delitos,y como nublado tus pecados; vuélvete a mí, pues yo te he redimido."
,"23":"Gritad de gozo, cielos, porque el Señor lo ha hecho; alegraos, honduras de la tierra; lanzad gritos de júbilo, montañas, y tú, bosque, con todos tus árboles, porque el Señor ha redimido a Jacob,y ha manifestado su gloria en Israel."
,"24":"Esto dice el Señor tu redentor, el que te formó desde el seno materno: Yo soy el Señor, el que lo ha hecho todo; el que despliega, él solo, los cielos; el que afirma la tierra sin ayuda alguna;"
,"25":"el que desbarata los presagios de los charlatanes,y vuelve insensatos a los adivinos; el que obliga a retirarse a los sabios,y reduce a necedad su saber;"
,"26":"el que confirma la palabra de sus servidores,y cumple el consejo de sus enviados; el que dice a Jerusalén: Serás habitada, y a las ciudades de Judá: Seréis reconstruidas; yo realzaré sus ruinas;"
,"27":"el que dice al océano: ¡Sécate!, yo haré que se sequen tus corrientes;"
,"28":"el que dice a Ciro: ¡Mi pastor eres, todos mis deseos cumplirás!; el que dice a Jerusalén: Serás reedificada, y al templo: Serás reconstruido."
}`)
	CurrentBook.AddChapter(45, `{
"1":"Esto dice el Señor a Ciro, su ungido, a quien yo tomé de la mano,para someter a las naciones,y desatar las cinturas de los reyes; para abrir puertas ante él,sin dejar que se cierren:"
,"2":"Yo marcharé delante de ti, allanando las alturas; destrozaré las puertas de bronce, haré pedazos los barrotes de hierro."
,"3":"Te daré los tesoros secretos, las riquezas escondidas para que sepas,que yo soy el Señor, el Dios de Israel, que te ha llamado por tu nombre."
,"4":"Por amor de mi siervo Jacob y de Israel, mi elegido, te he llamado por tu nombre, renombre te he dado antes que me conocieras."
,"5":"Yo soy el Señor, no hay ningún otro: no existe dios fuera de mí. Yo te he ceñido antes de que me conocieses,"
,"6":"para que se sepa desde el levante hasta el poniente,que no hay nadie fuera de mí. Yo, el Señor, y ningún otro."
,"7":"Yo formo la luz y creo las tinieblas; doy la dicha y produzco la desgracia; soy yo, el Señor, quien hace todo esto."
,"8":"¡Derramad, cielos, el rocío, y lluevan las nubes la victoria!,Ábrase la tierra y produzca la salvación; brote también la justicia: yo, el Señor, lo he creado."
,"9":"¡Ay de aquel que litiga con su creador, siendo sólo un tiesto de barro!,¿Dice acaso la arcilla a su alfarero: Qué haces?,Le dice su obra: ¿No tienes manos?"
,"10":"¡Ay de quien dice a un padre: ¿Qué es lo que engendras?, y a una mujer: ¿Qué das a luz?!"
,"11":"Esto dice el Señor, el Santo de Israel, su creador: ¿Me vais a interrogar sobre mis hijos,y a darme órdenes sobre la obra de mis manos?"
,"12":"Soy yo quien ha hecho la tierra, y en ella he creado al hombre; yo mismo con mis manos he extendido los cielos, y a todo su ejército doy órdenes."
,"13":"Yo le he suscitado para la victoria, y he allanado todos sus caminos; él reconstruirá mi ciudad,y repatriará a mis deportados sin precio,ni soborno -dice el Señor todopoderoso-."
,"14":"Esto dice el Señor: Las riquezas de Egipto,y las ganancias de Etiopía y los sabeos, de elevada estatura, pasarán a ti y serán tuyos, te seguirán encadenados, ante ti se postrarán y te suplicarán: Sólo en ti se encuentra Dios; no hay nadie más, no hay otro dios."
,"15":"Sí, en ti hay un Dios escondido, el Dios de Israel, el salvador."
,"16":"Confusos y corridos están todos tus rivales, avergonzados se van los autores de ídolos."
,"17":"Israel ha sido salvado por el Señor, salvado para siempre; no seréis avergonzados ni humillados,por los siglos de los siglos."
,"18":"Esto dice el Señor, el que creó los cielos, el que es Dios, el que formó la tierra y la creó, el que la estableció y no la creó vacía, sino que la formó para ser habitada; yo, el Señor, y nadie más:"
,"19":"No he hablado en secreto, en un rincón tenebroso de la tierra; no he dicho a la raza de Jacob: ¡Buscadme en el vacío!,Yo, el Señor, predico la justicia y anuncio el derecho."
,"20":"¡Reuníos y venid, acercaos todos juntos, supervivientes de las naciones!,Insensatos son los que pasean un ídolo de madera,y suplican a un dios que no puede salvar."
,"21":"Hablad, exponed vuestras pruebas, deliberad unos con otros. ¿Quién ha manifestado esto desde antiguo?,¿No fui yo, el Señor?,No hay otro dios más que yo. Dios justo y salvador, no existe otro fuera de mí."
,"22":"Volveos a mí y os salvaréis, confines todos de la tierra, porque yo soy Dios y nadie más."
,"23":"Por mí mismo lo juro; de mi boca sale la verdad, una palabra irrevocable: Ante mí se doblará toda rodilla, toda lengua jurará por mí,"
,"24":"diciendo: ¡Sólo en el Señor está la salvación!,A él vendrán avergonzados,todos los que se enfurecían contra él."
,"25":"Gracias al Señor,toda la raza de Israel obtendrá la justicia,y saltará de gozo."
}`)
	CurrentBook.AddChapter(46, `{
"1":"Bel vacila, Nebo se desploma; sus ídolos son carga de animales y bestias, llevados como fardos sobre bestias extenuadas."
,"2":"Han vacilado, se han desplomado a una, no pueden liberar a los que los llevan, pues ellos mismos van al cautiverio."
,"3":"Escuchadme, casa de Jacob, y todo el resto de la casa de Israel, que habéis sido llevados por mí,desde el vientre, sostenidos desde el seno materno."
,"4":"Hasta vuestra ancianidad yo seré el mismo, os sostendré hasta vuestra vejez. Lo he hecho hasta aquí, os he llevado, y os sostendré, os salvaré."
,"5":"¿A quién me vais a asemejar y comparar, dónde me encontraréis igual o parecido?"
,"6":"Sopesan ellos el oro de su bolsa, y la plata en la balanza; pagan a un orfebre para que les haga un dios, al cual, postrados, adoran."
,"7":"Lo cargan a hombros, lo llevan, lo ponen en su sitio, y allí se está quieto. No se mueve de su sitio. A gritos le invocan y no responde, a nadie salva de la angustia."
,"8":"Recordad esto y entendedlo bien; entrad en razón, pecadores."
,"9":"Acordaos de lo pasado desde antiguo, que yo soy Dios y no existe ningún otro dios,y nadie igual a mí."
,"10":"Desde el principio anuncio yo el fin, y de antemano lo que aún no ha sucedido; yo digo: Mi decisión se cumple, y todo lo que me place lo ejecuto."
,"11":"Del oriente llamo al águila; de un lejano país, al hombre que he designado. Como lo digo lo hago, como lo planeo lo ejecuto."
,"12":"Escuchadme los de corazón indómito, los que estáis lejos de la justicia."
,"13":"Próxima está mi justicia, no está lejos, mi salvación no tardará. Daré mi salvación a Sión y mi gloria a Israel."
}`)
	CurrentBook.AddChapter(47, `{
"1":"¡Baja, siéntate en el polvo, virgen, hija de Babilonia!,Siéntate en tierra, destronada, hija de los caldeos. Pues no se te llamará más la dulce, la exquisita."
,"2":"Toma la muela y muele la harina; quítate el velo, levántate el vestido, descubre tus piernas, vadea los arroyos."
,"3":"Descubre tu desnudez, que se vea tu vergüenza. Voy a vengarme yo, sin que nadie me resista"
,"4":"-dice nuestro redentor-, cuyo nombre es el Señor todopoderoso, el Santo de Israel. "
,"5":"Siéntate en silencio, escóndete en la sombra, hija de los caldeos, pues no se te volverá a llamar señora de los reinos."
,"6":"Yo, irritado contra mi pueblo, dejé profanar mi heredad, la abandoné en tus manos; pero tú no tuviste compasión; sobre el anciano cargaste tu pesado yugo."
,"7":"Decías: Seré soberana para siempre, perpetuamente lo seré; mas no reflexionaste en esto, ni pensaste en su fin."
,"8":"Escucha, pues, ahora, voluptuosa, tú que te sientes segura y dices en tu corazón: Yo y nadie fuera de mí; no quedaré viuda, ni perderé a mis hijos."
,"9":"Las dos cosas te sobrevendrán de repente, en un día; orfandad y viudez a la vez caerán sobre ti, a pesar de tus numerosos sortilegios,y del poder de tus muchos encantamientos."
,"10":"Te sentías segura en tu maldad; pensabas: No hay quien me vea. Tu sabiduría y tu ciencia te han perdido. Pensabas en tu corazón: Yo, y nadie más fuera de mí."
,"11":"Pero un desastre te alcanzará, que no podrás conjurar; una calamidad caerá sobre ti, que no podrás evitar; la ruina te llegará de repente sin darte cuenta."
,"12":"Quédate, pues, con tus encantamientos y con tus numerosos sortilegios, en los que te has afanado desde tu juventud. ¡Quizás puedas sacar algún provecho!,¡Tal vez puedas con ellos dar miedo!"
,"13":"Estás cansada de tantos consejeros. ¡Levántense, pues, y sálvense los que miden el cielo, los que observan las estrellas,y anuncian para cada mes lo que va a suceder!"
,"14":"¡Serán todos como paja que devorará el fuego!,No podrán salvar su vida del asalto de las llamas. No son siquiera brasas para cocer el pan, ni hogar para sentarse en torno a él."
,"15":"Así te resultarán tus encantadores, por lo que te afanaste desde tu juventud. Se irá cada uno por u lado, sin poderte salvar."
}`)
	CurrentBook.AddChapter(48, `{
"1":"Escucha esto, casa de Jacob, los que lleváis el nombre de Israel, los salidos de la simiente de Judá, que juráis por el nombre del Señor,y celebráis al Dios de Israel, mas sin verdad ni justicia."
,"2":"Pues lleváis el nombre de la ciudad santa,y os apoyáis en el Dios de Israel, cuyo nombre es el Señor todopoderoso."
,"3":"Las cosas pasadas las anuncié yo mucho antes, de mi boca salieron y las proclamé; de pronto he actuado, y se han verificado."
,"4":"Porque sabía que tú eres obstinado, que es una barra de hierro tu cerviz y de bronce tu frente,"
,"5":"por eso te lo anuncié desde hace mucho; antes que sucediese te lo proclamé, para que no dijeses: Lo ha hecho un ídolo; mi estatua, mi bronce fundido lo ha ordenado."
,"6":"Lo has oído, has visto todo esto, ¿no lo vas a admitir?,Ahora te anuncio cosas nuevas, ocultas y desconocidas;"
,"7":"acaban de ser creadas ahora mismo, sin que antes las hubieras oído, para que no puedas decir: Ya lo sabía."
,"8":"No lo has oído, ni lo conocías, tu oído aún no se había abierto, pues yo sabía que eres pérfido,y que te llamas rebelde desde el vientre de tu madre."
,"9":"Por amor de mi nombre contenía mi cólera, por mi honor me frenaba para no exterminarte."
,"10":"Mira, te he pasado por el fuego como la plata, te he probado en el horno de la tribulación."
,"11":"Por mí, sólo por mí lo haré; ¿voy a dejar profanar mi nombre?,No cederé mi gloria a ningún otro."
,"12":"Escúchame, Jacob, y tú, Israel, a quien yo he llamado: Yo, soy yo el primero, y soy también el último."
,"13":"Fue mi mano la que fundó la tierra, y mi diestra la que desplegó los cielos; los llamo yo, y todos a una se presentan."
,"14":"Congregaos vosotros todos y escuchad: ¿Quién de entre ellos anunció estas cosas?,Mi amigo cumplirá mis deseos contra Babilonia,y la raza de los caldeos."
,"15":"Yo mismo, yo mismo he hablado y le he llamado, le he traído para que lleve a cabo su designio."
,"16":"Acercaos a mí y escuchad esto: No he hablado en secreto desde el principio, desde que esto ha sucedido estoy yo allí. Y ahora el Señor Dios me ha enviado con su espíritu."
,"17":"Esto dice el Señor, tu redentor, el Santo de Israel: Yo soy el Señor, tu Dios, el que te enseña lo que te da éxito,y te indica el camino que debes seguir."
,"18":"¡Oh, si hubieras obedecido a mis mandamientos!,Tu paz sería como un río,y tu justicia como las olas del mar."
,"19":"Como la arena sería tu descendencia, como sus granos el fruto de tus entrañas. Tu nombre no hubiera sido jamás borrado,y extirpado de mi presencia."
,"20":"¡Salid de Babilonia, huid de los caldeos!,Con gritos de júbilo anunciad y proclamad esto, publicadlo hasta los confines de la tierra. Decid: El Señor ha redimido a su siervo Jacob."
,"21":"No han padecido sed,los que él ha guiado a través del desierto; agua de la roca ha hecho brotar para ellos, ha rajado la peña y ha manado agua."
,"22":"No hay paz para los malhechores,-dice el Señor-."
}`)
	CurrentBook.AddChapter(49, `{
"1":"Escuchadme, islas; prestad atención, pueblos lejanos: El Señor me ha llamado desde el vientre de mi madre, desde el seno ha pronunciado mi nombre."
,"2":"Hizo de mi boca una espada afilada, con la sombra de su mano me guardó; hizo de mí una flecha aguzada, en su aljaba me escondió."
,"3":"Y me dijo: Tú eres mi siervo, Israel, en quien me glorificaré."
,"4":"Yo decía: En vano me he afanado, para nada he gastado mis fuerzas. Pero mi derecho está en las manos del Señor, mi recompensa en mi Dios."
,"5":"Y ahora ha hablado el Señor, que desde el seno me formó para ser siervo suyo, para hacer que Jacob vuelva a él,y reunir con él a Israel,-pues glorioso era yo a los ojos del Señor,y mi Dios era mi fortaleza-;"
,"6":"y dice: Poca cosa es que seas mi siervo,para restablecer las tribus de Jacob,y traer de nuevo a los supervivientes de Israel. Yo te he puesto como luz de las gentes, para que llegue mi salvación hasta los extremos de la tierra."
,"7":"Esto dice el Señor, el redentor, el Santo de Israel, al despreciado, al aborrecido de las gentes, al esclavo de los tiranos: Los reyes, al verte, se levantarán, los príncipes se inclinarán,por causa del Señor, que es leal, del Santo de Israel, que te ha elegido."
,"8":"Esto dice el Señor: En el tiempo de la gracia te he atendido, el día de la salvación te he ayudado, te he formado y te he puesto,como alianza del pueblo para reconstruir el país, para repartir heredades devastadas"
,"9":"y decir a los prisioneros: ¡salid!, a los que están en las tinieblas: ¡mostraos!,A lo largo de todos los caminos se apacentarán; en todas las alturas peladas tendrán pastos."
,"10":"No padecerán hambre ni sed, no les alcanzará ni el viento árido ni el sol, porque el que se apiada de ellos,los guiará y los conducirá a manantiales de agua."
,"11":"Convertiré en caminos todas las montañas, y las calzadas se allanarán."
,"12":"Unos vienen de lejos, otros del norte y del oeste, otros del país de Asuán."
,"13":"Cielos, gritad de gozo; alégrate, tierra; montes, saltad de júbilo, pues el Señor ha consolado a su pueblo, se ha compadecido de los desgraciados."
,"14":"Sión decía: El Señor me ha abandonado, el Señor se ha olvidado de mí."
,"15":"¿Puede acaso una mujer olvidarse del niño que cría, no tener compasión del hijo de sus entrañas?,Pues aunque ella lo olvidara, yo no me olvidaría de ti."
,"16":"Mira, en la palma de mis manos,te llevo grabado, tus muros están sin cesar ante mí."
,"17":"Tus constructores se dan prisa, y se van los que te destruyeron y te arrasaron."
,"18":"Alza en torno tus ojos y mira; todos se reúnen para venir a ti. Por mi vida -dice el Señor-,que todos ellos serán joyas de tu adorno,y los ceñirás como una novia."
,"19":"Pues tus escombros y tus ruinas,y tu tierra devastada serán ahora demasiado estrechos,para tus habitantes; tus destructores, en cambio, estarán lejos."
,"20":"De nuevo te dirán al oído tus hijos, que creías perdidos: Este lugar es muy estrecho para mí, hazme sitio donde pueda habitar."
,"21":"Entonces dirás en tu corazón: ¿Quién me ha engendrado a éstos?,Yo estaba sin hijos y estéril, desterrada y desechada; a éstos, ¿quién me los ha criado?,Sí, sola había quedado; éstos, ¿de dónde vienen?"
,"22":"Esto dice el Señor Dios: Yo alzaré mi mano hacia las naciones, y hacia los pueblos levantaré mi enseña; ellos traerán a tus hijos en el regazo,y llevarán a hombros a tus hijas."
,"23":"Reyes tendrán por ayos y princesas por nodrizas; rostro en tierra se prosternarán ante ti,y lamerán el polvo de tus pies. Y sabrás que yo soy el Señor, que los que en mí esperan jamás son defraudados."
,"24":"¿Puede arrebatársele el botín a un guerrero, o escapársele a un valiente sus cautivos?"
,"25":"Esto dice el Señor: Se le podrá arrancar a un valiente sus cautivos, a un guerrero se le podrá escapar la presa; mas con tus adversarios pelearé yo y salvaré a tus hijos."
,"26":"A tus opresores haré comer su propia carne, de su misma sangre se embriagarán,como de vino nuevo. Y todo mortal sabrá que yo, el Señor, soy tu salvador y tu redentor, el fuerte de Jacob."
}`)
	CurrentBook.AddChapter(50, `{
"1":"Esto dice el Señor: ¿Dónde está el acta de divorcio,por la que yo he despedido a vuestra madre?,O ¿cuál es mi acreedor,a quien yo os haya vendido?,Por vuestras culpas fuisteis vendidos, por vuestros pecados fue despedida vuestra madre."
,"2":"¿Por qué, cuando vine, no encontré a nadie, y cuando llamé, nadie respondió?,¿Sería acaso mi brazo demasiado corto para libertar,o me faltaría fuerza para salvar?,Con una amenaza seco yo el mar, convierto los ríos en desierto; y sus peces, por falta de agua, se amustian y mueren de sed."
,"3":"Yo visto el cielo de negro,y le recubro de sayal."
,"4":"El Señor Dios me ha dado una lengua de experto,para que yo sepa responder al cansado. Cada mañana me despierta el oído,para escuchar como un discípulo."
,"5":"El Señor Dios me ha abierto el oído,y yo no he resistido, no me he echado atrás."
,"6":"He ofrecido mi espalda a los que me golpeaban, mis mejillas a quienes me mesaban la barba; no he hurtado mi rostro a la afrenta y a los salivazos."
,"7":"El Señor Dios viene en mi ayuda; por eso soporto la ignominia, por eso he hecho mi rostro como pedernal,y sé que no quedaré defraudado."
,"8":"Próximo está el que me hace justicia, ¿quién puede litigar conmigo?,¡Comparezcamos juntos!,¿Quién es mi demandante?,¡Preséntese ante mí!"
,"9":"Si el Señor Dios me ayuda, ¿quién puede condenarme?,Todos se gastarán como un vestido, la polilla los consumirá."
,"10":"El que de vosotros tema al Señor,y escuche la voz de su siervo, el que camine en tinieblas, sin ver ninguna claridad, confíe en el nombre del Señor,y apóyese en su Dios."
,"11":"Pero todos vosotros que prendéis fuego,y atizáis brasas caed en las llamas de vuestro fuego, en las brasas que atizáis. Mi mano os tratará así, os hundiréis en los tormentos."
}`)
	CurrentBook.AddChapter(51, `{
"1":"Escuchadme, vosotros, los que vais en pos de la justicia, los que buscáis al Señor; mirad la roca de la que fuisteis tallados, la cavidad de la que fuisteis extraídos."
,"2":"Mirad a Abrahán, vuestro padre, y a Sara, que os dio a luz. Él estaba solo cuando lo llamé; pero lo bendije y lo multipliqué."
,"3":"Sí, el Señor se compadece de Sión, se compadece de todas sus ruinas; convertirá su desierto en un edén, y su tierra seca en el jardín del Señor. Gritos de gozo y júbilo se oirán en ella, acción de gracias al son de la música."
,"4":"Estad atentos, pueblos; naciones, prestadme oídos, porque de mí viene la ley, y mi derecho será la luz de los pueblos."
,"5":"Haré que llegue de repente mi justicia, mi salvación surgirá como la luz. Mi brazo va a juzgar a los pueblos. En mí esperan las islas, y en mi brazo confían."
,"6":"Alzad al cielo vuestros ojos, y mirad abajo, hacia la tierra; los cielos se dispersarán como humo, la tierra se gastará como un vestido,y sus habitantes morirán como mosquitos; pero mi salvación durará eternamente,y mi justicia no tendrá fin."
,"7":"Escuchadme los que conocéis la justicia, pueblo que llevas en tu corazón mi ley; no temáis el insulto de los hombres, no te acobarden sus ultrajes,"
,"8":"porque el gusano los devorará como a un vestido, y como lana los consumirá la polilla; pero mi justicia durará eternamente, y mi salvación de generación en generación."
,"9":"¡Despierta, despierta; vístete de fuerza, brazo del Señor; despierta como antaño en los días,de las generaciones antiguas!,¿No eres tú el que partió en dos a Rahab,y traspasó al dragón?"
,"10":"¿No eres tú el que secó el mar, las aguas del océano; el que convirtió en camino el fondo del mar,para que pasaran los libertados?"
,"11":"Así volverán los liberados del Señor, llegarán a Sión entre gritos de júbilo; dicha eterna coronará su cabeza; alegría y dicha los acompañarán,y huirán las penas y suspiros."
,"12":"Yo, yo soy tu consolador. ¿Quién eres tú para temer a un hombre mortal, a un hijo de Adán, condenado a la suerte del heno?"
,"13":"¿Vas a olvidar al Señor tu creador, que desplegó los cielos y fundó la tierra, para temblar sin cesar todo el día,ante la furia del opresor, que se dispone a perderte?,Pero, ¿dónde está la furia del opresor?"
,"14":"Muy pronto el cautivo será puesto en libertad; no morirá en la fosa, ni faltará el pan."
,"15":"Yo soy el Señor, el que agita el mar,y hace bramar sus olas. Señor todopoderoso es mi nombre."
,"16":"He puesto mis palabras en tu boca,y te he ocultado con la sombra de mi mano, al desplegar los cielos y fundar la tierra,y decir a Sión: 'Mi pueblo res tú'."
,"17":"Despierta, despierta, levántate, Jerusalén; tú que has bebido de la mano del Señor la copa de su cólera; el cáliz del vértigo lo has bebido hasta las heces."
,"18":"No hay nadie que la guíe,entre los hijos que ha dado a luz, nadie que la tome de la mano,entre todos los hijos que ha criado."
,"19":"Estas dos desgracias te han alcanzado,-¿quién se lamentará por ti?-, saqueo y ruina, hambre y espada; ¿quién te consolará?"
,"20":"Tus hijos yacen extenuados,por todas las esquinas de las calles, como una gacela en la red, llenos de la furia del Señor, de las amenazas de tu Dios."
,"21":"Por eso, escucha esto, desdichada, borracha, pero no de vino."
,"22":"Esto dice el Señor Dios, tu Dios, que defiende la causa de su pueblo: Mira, yo quito de tu mano,la copa del vértigo, el cáliz de mi cólera; no volverás a beber más de él."
,"23":"Y lo pondré en la mano de tus opresores, de los que te decían: ¡Agáchate para que pasemos por encima!, y tú hiciste de tu espalda un suelo, un camino para los viandantes."
}`)
	CurrentBook.AddChapter(52, `{
"1":"Despierta, despierta, vístete de tu fuerza, Sión; ponte tus vestidos más espléndidos, Jerusalén, ciudad santa. Pues ya no volverá a entrar en ti,el incircunciso ni el impuro."
,"2":"Sacúdete el polvo, levántate, Jerusalén cautiva. Saca tu cuello de sus coyundas, hija de Sión, cautiva."
,"3":"Esto dice el Señor: 'Gratis habéis sido vendidos, y también sin pagar seréis rescatados'."
,"4":"Sí, esto dice el Señor Dios: 'Mi pueblo bajó primero a Egipto,para establecerse allí, y más tarde lo oprimió Asiria violentamente."
,"5":"Y ahora, ¿qué hago yo aquí?,-dice el Señor-. Mi pueblo ha sido hecho esclavo sin motivo; sus dominadores lanzan gritos de triunfo,-dice el Señor-,y sin cesar, todos los días, es blasfemado mi nombre."
,"6":"Por eso mi pueblo va a conocer mi nombre, y aquel día sabrá que soy yo quien dice: ¡Aquí estoy!'."
,"7":"¡Oh, qué bellos son por los montes,los pies del mensajero de albricias, que anuncia la paz, que trae la dicha, que anuncia la salvación,y dice a Sión: ¡Tu Dios reina!"
,"8":"¡Escucha! Tus centinelas alzan la voz, gritan de júbilo a la vez, porque ven cara a cara al Señor, que regresa a Sión."
,"9":"Estallad a una en gritos de alegría, ruinas de Jerusalén, porque el Señor consuela a su pueblo,y rescata a Jerusalén."
,"10":"El Señor desnuda su brazo santo,ante los ojos de todos los pueblos, y todos los confines de la tierra,verán la salvación de nuestro Dios."
,"11":"¡Fuera, fuera, salid de allí; no toquéis nada impuro, salid de en medio de ella, purificaos los que lleváis los vasos del Señor!"
,"12":"No saldréis a la desbandada, no partiréis como huidos, porque delante de vosotros marchará el Señor,y a vuestra retaguardia el Dios de Israel."
,"13":"He aquí que mi siervo prosperará, se elevará, crecerá y será magnífico."
,"14":"Y si muchos se habían horrorizado al verlo,-tan desfigurado estaba su semblante,que no tenía ya aspecto de hombre-,"
,"15":"muchos pueblos se llenarán de asombro; a su vista los reyes cerrarán la boca, porque verán un suceso no contado jamás,y contemplarán algo inaudito."
}`)
	CurrentBook.AddChapter(53, `{
"1":"¿Quién creerá lo que oímos decir?,¿A quién se ha manifestado el poder del Señor?"
,"2":"Creció ante él como un pimpollo, como raíz en tierra seca. Sin gracia ni belleza para atraer la mirada, sin aspecto digno de complacencia."
,"3":"Despreciado, desecho de la humanidad, hombre de dolores, avezado al sufrimiento, como uno ante el cual se oculta el rostro, era despreciado y desestimado."
,"4":"Con todo, eran nuestros sufrimientos los que llevaba, nuestros dolores los que le pesaban, mientras nosotros le creíamos azotado, herido por Dios y humillado."
,"5":"Ha sido traspasado por nuestros pecados, triturado por nuestras iniquidades; el castigo, precio de nuestra paz, cae sobre él, y a causa de sus llagas hemos sido curados."
,"6":"Todos nosotros, como ovejas, andábamos errantes; cada cual siguiendo su propio camino. Y el Señor ha hecho recaer sobre él,la perversidad de todos nosotros."
,"7":"Era maltratado, y no se resistía ni abría su boca; como cordero llevado al matadero, como oveja ante sus esquiladores, no abría la boca."
,"8":"Con violencia e injusticia fue apresado; de su causa, ¿quién se cuida?,Fue arrancado de la tierra de los vivos, herido de muerte por los pecados de mi pueblo."
,"9":"Se le preparó una tumba entre los criminales, en su muerte se le juntó con malhechores, siendo así que él jamás cometió injusticia,ni hubo engaño en su boca."
,"10":"Pero el Señor quiso destrozarlo con padecimientos. Si él ofrece su vida por el pecado, verá descendencia, prolongará sus días, y la voluntad del Señor se cumplirá gracias a él."
,"11":"Después de las penas de su alma, verá la luz y quedará colmado. Por sus sufrimientos mi siervo justificará a muchos,y cargará sobre sí las iniquidades de ellos."
,"12":"Por eso le daré en herencia multitudes, y gente innumerable recibirá como botín, pues se entregó indefenso a la muerte,y fue contado entre los malhechores, él, que llevaba los pecados de muchos,e intercedía por los malhechores."
}`)
	CurrentBook.AddChapter(54, `{
"1":"Grita de alegría, estéril, que no has dado a luz, prorrumpe en gritos de gozo y algazara, tú que no has estado de parto. Pues son más numerosos los hijos de la abandonada,que los hijos de la casada -dice el Señor-."
,"2":"Ensancha el espacio de tu tienda, despliega tus toldos sin reparo, alarga tus cuerdas, asegura tus estacas."
,"3":"Pues te ensancharás a derecha e izquierda, tu raza poseerá naciones y poblará ciudades asoladas."
,"4":"No temas, pues no tendrás ya que avergonzarte; no te sonrojes, pues no serás ya confundida; olvidarás la afrenta de tu juventud,y no te acordarás del oprobio de tu viudez."
,"5":"Pues tu esposo será tu creador, cuyo nombre es Señor todopoderoso; tu redentor, el Santo de Israel, que se llama Dios de toda la tierra."
,"6":"Sí, como a una mujer abandonada,y desolada te ha requerido el Señor. A la esposa tomada en la juventud, ¿se la puede rechazar? -dice tu Dios-."
,"7":"Sólo por un momento te había abandonado, pero con inmensa piedad te recojo de nuevo."
,"8":"En un rapto de mi cólera,oculté de ti mi rostro un instante, mas con eterna bondad de ti me apiado,-dice tu redentor, el Señor-."
,"9":"Me pasa como en los días de Noé, cuando juré que las aguas de Noé,no volverían a anegar la tierra: así ahora juro no irritarme más contra ti, no volverte a amenazar."
,"10":"Vacilarán los montes, las colinas se conmoverán; pero mi bondad hacia ti no desaparecerá,ni vacilará mi alianza de paz -dice el Señor-, el que de ti se compadece."
,"11":"Oh desdichada, sacudida por la tempestad, desconsolada; yo asentaré tus piedras sobre malaquita,y tus cimientos sobre zafiros;"
,"12":"haré de rubíes tus almenas, tus puertas de cristal, y todo tu recinto de piedras preciosas."
,"13":"Tus hijos serán todos discípulos del Señor, grande será la dicha de tus hijos."
,"14":"Serás fundada en la justicia, y estarás a salvo de la opresión, pues nada temerás; a salvo de la destrucción, que nunca más te alcanzará."
,"15":"Si te atacan, no vendrá de mí; el que pelee contigo, ante ti caerá."
,"16":"Pues yo he creado al herrero, que sopla el fuego de las brasas, y con su trabajo las armas produce; mas también al destructor para aniquilarlas."
,"17":"Ningún arma forjada,contra ti dará resultado; a toda lengua que te acuse,la convencerás de culpabilidad. Ésta es la heredad de los hijos del Señor, la justicia que yo les aseguro -dice el Señor-."
}`)
	CurrentBook.AddChapter(55, `{
"1":"¡Oh, todos los que estáis sedientos, id por agua, aunque no tengáis dinero!,Venid, comprad grano y comed, sin dinero y sin pagar, vino y leche."
,"2":"¿Por qué gastáis vuestro dinero,en lo que no es pan, y vuestro salario en lo que no llena?,Escuchadme bien, y comeréis cosas buenas; y os deleitaréis con manjares exquisitos."
,"3":"Prestad oído y venid a mí; escuchad y vivirá vuestra alma. Haré con vosotros un pacto eterno, según la fiel promesa que hice a David."
,"4":"Yo le he puesto como testigo para los pueblos, caudillo y señor de las naciones."
,"5":"Mira, a pueblos que no conocías llamarás,y naciones desconocidas correrán hacia ti, por el Señor, tu Dios, y por el Santo de Israel, que te glorifica."
,"6":"Buscad al Señor mientras puede ser hallado; clamad a él mientras está cerca."
,"7":"Deje el malvado su camino, y el malhechor sus pensamientos; conviértase al Señor, que tendrá piedad de él; a nuestro Dios, que es generoso en el perdón."
,"8":"Porque mis pensamientos no son vuestros pensamientos, ni vuestros caminos mis caminos -dice el Señor-."
,"9":"Como se alza el cielo,por encima de la tierra,se elevan mis caminos,sobre vuestros caminos,y mis pensamientos,sobre vuestros pensamientos."
,"10":"Como la lluvia y la nieve descienden del cielo,y no vuelven allá sin empapar la tierra, sin fecundarla y hacerla germinar,para que dé sementera al sembrador,y pan para comer,"
,"11":"así la palabra que sale de mi boca,no vuelve a mí sin resultado, sin haber hecho lo que yo quería,y haber llevado a cabo su misión."
,"12":"Sí, partiréis con alegría,y en paz seréis llevados; montes y colinas prorrumpirán ante vosotros,en gritos de alegría, y todos los árboles del campo aplaudirán."
,"13":"En lugar de zarzas crecerán cipreses, y en vez de ortigas nacerán mirtos. Y esto dará al Señor renombre, una señal eterna e imborrable."
}`)
	CurrentBook.AddChapter(56, `{
"1":"Esto dice el Señor: Guardad el derecho, practicad la justicia, porque mi salvación está para llegar,y mi justicia para manifestarse."
,"2":"Feliz el hombre que esto hace,y el hijo de Adán que se atiene a ello, que observa el sábado sin profanarlo,y guarda sus manos limpias de todo mal."
,"3":"El extranjero que se entrega al Señor no diga: ¡Sin duda el Señor me excluirá de su pueblo!,Ni diga el eunuco: 'Yo no soy más que un árbol seco'."
,"4":"Porque esto dice el Señor: A los eunucos que guardan mis sábados, hacen lo que me agrada,y se mantienen en mi alianza,"
,"5":"yo les daré en mi casa, entre mis muros, un memorial y un nombre mejor que hijos e hijas; un nombre eterno les daré, que nunca más se borrará."
,"6":"Y a los extranjeros,que se entregan al Señor para venerarlo, amar su nombre y ser sus siervos; que guardan el sábado sin profanarlo, que se mantienen en mi alianza,"
,"7":"los llevaré a mi monte santo,y les daré alegría en mi casa de oración. Sus holocaustos y sus sacrificios,serán aceptos en mi altar, pues mi casa se llamará casa de oración,para todos los pueblos."
,"8":"Esto dice el Señor Dios, que reúne a los dispersos de Israel: Todavía juntaré otros a los que están ya reunidos."
,"9":"Bestias todas del campo, venid a comer, bestias todas del bosque."
,"10":"Nuestros guardianes están todos ciegos, no comprenden nada; son todos perros mudos, que no saben ladrar; siempre tumbados, sólo dormir les gusta."
,"11":"Son perros voraces, insaciables; pastores que no saben comprender; cada cual sigue su camino, y buscan todos su interés."
,"12":"Venid, voy a buscar vino, nos alegraremos con licores; y mañana será como hoy y mucho mejor."
}`)
	CurrentBook.AddChapter(57, `{
"1":"Perece el justo, y nadie se preocupa por ello. Los hombres piadosos son arrebatados, y nadie advierte que a causa del mal,es arrebatado el justo"
,"2":"para entrar en la paz. En su lecho reposan,los que han caminado rectamente."
,"3":"Mas vosotros acercaos, hijos de hechicera, raza de adúltera y prostituta."
,"4":"¿De quién os burláis?,¿Contra quién abrís la boca,y a quién sacáis la lengua?,¿No sois vosotros los hijos del pecado, la raza de la mentira?"
,"5":"Vosotros los que os enceláis,junto a los terebintos, bajo todo árbol frondoso, inmolando niños en los torrentes, en las grietas de las rocas."
,"6":"Las piedras pulidas del torrente son tu heredad, ellas, ellas tu suerte. A ellas haces tus ofrendas de vino,y presentas tus ofrendas; ¿voy a calmarme yo con eso?"
,"7":"En un monte alto, empinado, has puesto tu lecho, y allí subes a ofrecer sacrificios."
,"8":"Tras de la puerta y las jambas,has colocado tu símbolo. Sí, te desnudaste, y no conmigo; subes a tu lecho y lo ensanchas; has pactado con los que te gustaba acostarte. Has prodigado tus prostituciones con ellos, contemplando la estela."
,"9":"Te has ungido con óleo en honor de Moloc, has prodigado tus perfumes; has enviado a tus mensajeros a lo lejos, los has hecho bajar hasta el abismo."
,"10":"Del largo camino estás cansada, y no dices: Me vuelvo atrás. Has reanudado el vigor de tus fuerzas, por eso no estás exhausta."
,"11":"¿De quién tienes miedo, a quién temes, para haber renegado así de mí, sin acordarte más de mí, ni llevarme en tu corazón?,Yo me callaba, cerraba los ojos; por eso no temías."
,"12":"Pero yo pondré al descubierto,tu justicia y tus obras inútiles."
,"13":"Aunque grites, ¿te podrán salvar tus ídolos?,A todos ellos se los llevará el viento, un soplo los arrebatará. Mas quien confía en mí heredará la tierra,y poseerá mi santo monte."
,"14":"Y se dirá: ¡Allanad, allanad, despejad el camino, quitad todo tropiezo de la ruta de mi pueblo!"
,"15":"Pues esto dice el altísimo, el excelso, el que habita una morada eterna,y cuyo nombre es santo: Yo habito en una morada excelsa y santa, pero también estoy con el hombre arrepentido y humilde, para reanimar el espíritu de los humildes, para reconfortar el corazón afligido."
,"16":"Porque no quiero discutir eternamente,y estar por siempre airado, pues ante mí sucumbiría el espíritu,y las almas que yo he creado."
,"17":"Por su grave perversidad me he irritado; lo herí y me oculté en mi enojo. Él se iba rebelde, por el camino de su corazón."
,"18":"Yo he visto sus caminos, pero le curaré y le aliviaré; le colmaré de consuelos a él,y a los que lloran;"
,"19":"haré brotar la alabanza en sus labios. ¡Paz al que está lejos, paz al que está cerca -dice el Señor-; yo le curaré!"
,"20":"Pero los malhechores son como el mar agitado, que no puede apaciguarse, cuyas aguas remueven fango y cieno."
,"21":"No hay paz -dice mi Dios- para los malhechores."
}`)
	CurrentBook.AddChapter(58, `{
"1":"Clama a voz en grito sin reparo, alza tu voz como la corneta. Anuncia a mi pueblo sus injusticias, a la casa de Jacob sus pecados."
,"2":"Me buscan ellos día tras día, se afanan por saber mis caminos, como un pueblo que practicara la justicia,y no se apartara del derecho de su Dios; me interrogan sobre las leyes justas, desean la cercanía de Dios:"
,"3":"¿Por qué vamos a ayunar si tú no lo ves, por qué mortificarnos si tú no te enteras?,Mirad, el día de ayuno andáis de negocios,y oprimís a todos vuestros jornaleros."
,"4":"Ayunáis, sí, entre disputa y riña, golpeando inicuamente con el puño. No, no ayunéis como ahora,haciendo oír allá arriba vuestra voz."
,"5":"¿Es éste acaso el ayuno que me agrada, el día en que el hombre se mortifica?,¿Doblar como un junco la cabeza, acostarse en el saco y la ceniza?,¿A eso llamas ayuno, día agradable al Señor?"
,"6":"¿No sabéis cuál es el ayuno que me agrada?,Abrir las prisiones injustas, soltar las coyundas del yugo, dejar libres a los oprimidos, romper todos los yugos;"
,"7":"repartir tu pan con el hambriento, hospedar a los pobres sin techo, vestir al que veas desnudo,y no eludir al que es tu propia carne."
,"8":"Entonces surgirá tu luz como la aurora,y tus heridas curarán en seguida; tu justicia marchará ante ti,y tras de ti la gloria del Señor."
,"9":"Entonces, si clamas, el Señor responderá a tus gritos; dirá: ¡Aquí estoy!,Si apartas el yugo de tu lado, el gesto amenazante y la mala idea,"
,"10":"si das al hambriento tu pan,y sacias el apetito del oprimido, brillará en las tinieblas tu luz, y tus sombras se harán un mediodía."
,"11":"El Señor será tu guía siempre, en los desiertos saciará tu hambre, a tus huesos infundirá vigor, y tú serás como un huerto regado, cual manantial de agua, de caudal inagotable."
,"12":"Reedificarás las viejas ruinas, construirás sobre cimientos de pasadas edades; serás llamado tapiador de brechas, restaurador de moradas en ruinas."
,"13":"Si te guardas de profanar el sábado, de tratar tus asuntos en mi día santo; si llamas al sábado delicia, glorioso al día consagrado al Señor; si lo glorificas evitando los viajes, no tratando negocios ni arreglando asuntos,"
,"14":"entonces encontrarás en el Señor tus delicias; yo te subiré triunfante a las alturas del país,y te alimentaré de la heredad de tu padre Jacob. Ha hablado la boca del Señor."
}`)
	CurrentBook.AddChapter(59, `{
"1":"No, la mano del Señor,no es demasiado corta para salvar, ni su oído tan duro como para no oír;"
,"2":"pero vuestras perversidades,han abierto un abismo entre vosotros y vuestro Dios; vuestros pecados han hecho,que oculte su rostro para no escucharos."
,"3":"Porque vuestras manos están manchadas de sangre, y vuestros dedos de perversidad; vuestros labios dicen mentira, vuestras lenguas murmuran falsedad."
,"4":"Ninguno acusa con justicia, nadie litiga con honradez; se confía en la nada, se habla falsedad, maldad se concibe,y se engendra desgracia."
,"5":"Incuban huevos de víbora, telas de araña tejen; y el que come sus huevos muere, y si se aplastan salen viboreznos."
,"6":"Sus telas no sirven para vestirse, ni sus tejidos valen para cubrirse. Sus acciones son acciones criminales, sólo violencia hay en sus manos."
,"7":"Sus pies corren hacia el crimen,y se apresuran a derramar sangre inocente; sus planes son criminales; sólo devastación y ruina por donde pasan."
,"8":"No conocen la senda de la paz, no hay justicia en su camino; sólo se abren senderos tortuosos, e ignora la paz quien por ellos camina."
,"9":"Por eso el derecho sigue lejos de nosotros,y no nos alcanza la justicia. Esperamos la luz, y no hay más que tinieblas; la claridad, y andamos en la oscuridad."
,"10":"Como ciegos palpamos las paredes, como sin ojos andamos a tientas; tropezamos a mediodía como en el crepúsculo, en tinieblas habitamos como los muertos."
,"11":"Gruñimos todos como osos, gemimos como palomas, esperamos el derecho, pero ¡nada!; la justicia, y sigue lejos de nosotros."
,"12":"Pues son muchos nuestros delitos ante ti, y nuestras iniquidades contra nosotros testifican; sí, presentes tenemos nuestros crímenes,y reconocemos nuestras perversidades:"
,"13":"ser unos traidores, olvidarnos del Señor, apostatar de nuestro Dios, hablar de opresión y de rebelión, tramar planes para engañar a los demás."
,"14":"Se ha desechado el derecho, y la justicia sigue al margen, pues la verdad tropieza en la misma plaza pública, y la honradez no tiene entrada."
,"15":"Ausente está la lealtad, y el que evita el mal es expoliado. El Señor se ha indignado,al ver que no hay justicia."
,"16":"Ha visto que no hay nadie,y se ha extrañado de que nadie intervenga. Entonces su brazo le ayudó,y su justicia le sostuvo."
,"17":"Se revistió de justicia como de una coraza, y puso en su cabeza el yelmo de la salvación; se vistió la venganza como una túnica,y se envolvió en la indignación como en un manto."
,"18":"A cada cual va a pagar,con arreglo a sus obras; cólera a sus adversarios, represalia a sus enemigos. A las islas también dará su pago."
,"19":"En occidente se temerá el nombre del Señor, y en oriente su gloria; porque vendrá como un torrente impetuoso, empujado por el soplo del Señor."
,"20":"Pero como libertador vendrá para Sión,y para los convertidos,de su pecado en Jacob -dice el Señor-."
,"21":"En cuanto a mí, éste es mi pacto con ellos, dice el Señor: Mi espíritu, que reposa en ti, y mis palabras, que he puesto en tu boca, no faltarán de tu boca, ni de la boca de tus descendientes, ni de la boca de los descendientes de tus descendientes -dice el Señor- desde ahora y por siempre."
}`)
	CurrentBook.AddChapter(60, `{
"1":"Levántate, resplandece, porque llega tu luz,y la gloria del Señor despunta sobre ti,"
,"2":"mientras las tinieblas envuelven la tierra,y la oscuridad cubre los pueblos. Sobre ti se levanta el Señor,y su gloria aparece sobre ti."
,"3":"Las naciones caminarán a tu luz, y los reyes al resplandor de tu aurora."
,"4":"Alza en torno los ojos y contempla; todos se reúnen y vienen a ti, tus hijos llegan de lejos,y tus hijas son traídas en brazos."
,"5":"Al verlo te pondrás radiante, tu corazón se henchirá de emoción, porque a ti afluirán los tesoros del mar, las riquezas de las naciones llegarán a ti."
,"6":"Multitud de camellos te cubrirá, dromedarios de Madián y de Efá; todos vendrán de Sabá, trayendo oro e incienso,y cantando las glorias del Señor."
,"7":"Todos los rebaños de Quedar,se apiñarán junto a ti, los carneros de Nebayot,estarán a tu servicio; subirán a mi altar como ofrenda agradable, para engalanar el templo de mi gloria."
,"8":"¿Quiénes son esos que vuelan como una nube, como palomas a su palomar?"
,"9":"Sí, los barcos para mí se congregan, y al frente de ellos los navíos de Tarsis, para traer de lejos a tus hijos, con su plata y su oro, por el nombre del Señor tu Dios, por el Santo de Israel, esplendor tuyo."
,"10":"Hijos de extranjeros reconstruirán tus muros, y sus reyes serán tus servidores; pues si en mi ira te aplasté, en mi clemencia me he apiadado de ti."
,"11":"Tus puertas estarán abiertas siempre, no se cerrarán ni de día ni de noche, para que lleguen las riquezas de las naciones,traídas por sus reyes."
,"12":"Pues la nación y el reino,que no te sirvan perecerán, y las naciones serán exterminadas."
,"13":"A ti vendrá la gloria del Líbano, con el ciprés, el olmo y el abeto,para adornar el lugar de mi santuario,y honrar el lugar donde resido."
,"14":"Encorvados vendrán a ti,los hijos de tus opresores, a tus pies se prosternarán,todos los que te ultrajan y te llamarán: Ciudad del Señor, Sión del Santo de Israel."
,"15":"No serás ya la abandonada, la maldecida de los viandantes; yo haré de ti una gloria eterna, una delicia de todas las generaciones."
,"16":"Y mamarás la leche de los pueblos, las riquezas de los reyes chuparás; y sabrás que yo, el Señor, soy tu salvador, tu libertador, el fuerte de Jacob."
,"17":"En lugar de bronce traeré oro, en vez de hierro traeré plata, bronce en vez de madera, y en vez de piedra, hierro. La paz te pondré por magistrado, y por soberano tuyo la justicia."
,"18":"No se oirá hablar más de violencia en tu país, ni de opresión y ruina en tus confines; a tus muros llamarás salvación, a tus puertas alabanza."
,"19":"Ya no será tu luz el sol durante el día, ni la claridad de la luna te alumbrará, pues el Señor será tu luz eterna, y tu Dios, tu esplendor."
,"20":"No se pondrá jamás tu sol, ni menguará tu luna, porque el Señor será tu luz eterna, cumplidos ya los días de tu duelo."
,"21":"Tu pueblo será un pueblo de justos, para siempre poseerás la tierra, renuevo de la plantación del Señor, obra de mis manos, hecha para resplandecer."
,"22":"El más pequeño en ti se hará un millar, el menor una nación potente. Yo, el Señor, lo he dicho: a su tiempo lo cumpliré deprisa."
}`)
	CurrentBook.AddChapter(61, `{
"1":"El espíritu del Señor Dios está en mí, porque el Señor me ha ungido. Me ha enviado a llevar,la buena nueva a los pobres, a curar los corazones oprimidos, a anunciar la libertad a los cautivos, la liberación a los presos;"
,"2":"a proclamar un año de gracia del Señor, un día de venganza para nuestro Dios. A consolar a todos los afligidos,"
,"3":"a dar a todos los afligidos de Sión,una diadema en lugar de ceniza, perfume de alegría,en lugar del vestido de luto, alabanza en lugar de espíritu abatido. Se les llamará encinas de justicia, plantación del Señor para su gloria."
,"4":"Ellos reconstruirán las viejas ruinas, levantarán de nuevo los edificios caídos del pasado, restaurarán las ciudades demolidas, las ruinas de pasadas edades."
,"5":"Extranjeros vendrán a apacentar vuestros rebaños, extraños serán vuestros labradores y vendimiadores."
,"6":"Y vosotros seréis llamados sacerdotes del Señor, ministros de nuestro Dios se os denominará. Comeréis las riquezas de los pueblos,y os adornaréis con su magnificencia."
,"7":"Por haber sido doblada su vergüenza,y haber sido su porción la ignominia y el desprecio, por eso poseerán el doble en su país, y su alegría será eterna."
,"8":"Pues yo, el Señor, amo la justicia,y odio la rapiña y el crimen. Fielmente les daré su recompensa,y haré con ellos un pacto eterno."
,"9":"Su raza será renombrada entre las naciones,y sus vástagos en medio de los pueblos. Todos cuantos los vean reconocerán,que son la raza bendita del Señor."
,"10":"Yo salto de gozo con el Señor, mi alma se entusiasma con mi Dios, porque me ha puesto los vestidos de la salvación, me ha envuelto en el manto de la justicia, como un recién casado se ciñe la diadema,o una novia se adorna con sus joyas."
,"11":"Pues como la tierra echa sus brotes, como un huerto hace brotar lo sembrado, así el Señor Dios hará germinar,la justicia y la alabanza ante todas las naciones."
}`)
	CurrentBook.AddChapter(62, `{
"1":"Por amor de Sión no me he de callar, no descansaré por Jerusalén, hasta que no despunte como la aurora su justicia,y flamee su salvación como una antorcha."
,"2":"Verán tu justicia las naciones,y todos los reyes tu gloria. Se te llamará con un nombre nuevo, acuñado por la boca del Señor."
,"3":"Serás una corona preciosa en manos del Señor, una diadema real en la palma de tu Dios."
,"4":"No se te llamará más la abandonada, ni tu tierra será dicha desierta, sino que se te llamará mi complacencia, y a tu tierra desposada, porque en ti se complace el Señor, y tu tierra tendrá un esposo."
,"5":"Como un joven se casa con su novia, así tu constructor se casará contigo; y como el esposo se recrea en la esposa, así tu Dios se recreará en ti."
,"6":"Sobre tus murallas, Jerusalén, he apostado centinelas, para que ni de día ni de noche se callen nunca. Vosotros, los que rendís memoria al Señor, no os concedáis reposo."
,"7":"No le deis tregua a él, hasta que restablezca a Jerusalén,y la constituya como gloria,en medio de la tierra."
,"8":"El Señor lo ha jurado por su diestra, por su potente brazo: No daré más tu grano,como alimento a tus enemigos, ni extranjeros beberán más tu vino,por el que te afanaste,"
,"9":"sino que comerán lo que cosechen,y alabarán al Señor, y los vendimiadores beberán,en el atrio de mi santuario."
,"10":"Pasad, pasad por las puertas, abrid camino al pueblo, allanad, allanad la calzada, retirad las piedras; izad para los pueblos la bandera."
,"11":"He aquí lo que el Señor pregona,hasta el extremo de la tierra: Decid a la hija de Sión: Mira, ya viene tu salvador, vienen con él su recompensa,y sus trofeos le preceden."
,"12":"'Pueblo santo' se les llamará, 'redimidos del Señor'. Y a ti se te llamará buscada, 'ciudad no abandonada'."
}`)
	CurrentBook.AddChapter(63, `{
"1":"¿Quién es éste que llega de Edón, de Bosra, con vestidos de púrpura; que, espléndido en su aderezo, avanza majestuoso en la plenitud de su fuerza?,Soy yo, el que profeso la justicia,y soy grande en salvar."
,"2":"¿Por qué es rojo tu vestido,y tus ropas como las del que pisa en el lagar?"
,"3":"En el lagar he pisado yo solo, nadie del pueblo estaba conmigo. Sí, en mi cólera los he pisado, los he pisoteado en mi furor; y su jugo ha salpicado mis ropas,y he manchado todos mis vestidos."
,"4":"Pues un día de venganza abrigaba en mi corazón,y el año de mi redención había llegado."
,"5":"Miré a mi alrededor, y no había ayuda; me sorprendí al no encontrar apoyo. Entonces mi brazo me salvó,y mi furor me sostuvo."
,"6":"Pisoteé a los pueblos en mi ira, los aplasté en mi furor,y derramé por la tierra su jugo."
,"7":"Recordaré los beneficios del Señor, las alabanzas del Señor, todo lo que el Señor ha hecho con nosotros, su gran bondad con la casa de Israel; todo lo que, en su misericordia, ha hecho con nosotros, y la multitud de sus beneficios."
,"8":"Él había dicho: Realmente son mi pueblo, hijos que no serán traidores. Y fue su salvador"
,"9":"en todas sus angustias. No un mensajero o un delegado suyo; él mismo fue quien los salvó. En su amor, en su piedad, él mismo los rescató, los sostuvo,y los llevó todos los días en el pasado."
,"10":"Pero ellos se rebelaron contra él,y afligieron su santo espíritu. Entonces él se hizo su enemigo, y peleó contra ellos."
,"11":"Ellos se acordaron de los días de antaño, de su siervo Moisés. ¿Dónde está aquel que sacó del mar,al pastor de su rebaño?,¿Dónde el que puso dentro de él,su santo espíritu?;"
,"12":"¿el que al lado de Moisés,hizo marchar su brazo glorioso, y dividió las aguas ante ellos,logrando así un eterno renombre?;"
,"13":"¿el que los hizo pasar por el fondo del mar, como un caballo en la estepa sin tropiezo?"
,"14":"Como ganado que baja a la llanura, el espíritu del Señor los guiaba al descanso; así llevaste a tu pueblo,para ganarte renombre glorioso."
,"15":"Mira desde el cielo y contempla, desde tu morada santa y gloriosa. ¿Dónde está tu celo y tu poder, la conmoción de tus entrañas?,¡Ah, no reprimas tu piedad,"
,"16":"porque tú eres nuestro padre!,Pues Abrahán no nos conoce, ni Israel se acuerda de nosotros. Tú, Señor, eres nuestro padre; nuestro libertador es tu nombre desde antiguo."
,"17":"¿Por qué, Señor, nos haces andar errantes,lejos de tus caminos,y endureces nuestro corazón,para que no te temamos?,¡Oh, vuelve, por amor de tus siervos,y de las tribus de tu heredad!"
,"18":"¿Por qué han invadido los tiranos tu templo, y nuestros agresores han pisoteado tu santuario?"
,"19":"Somos desde hace tiempo gentes que tú no riges,y que no llevan ya tu nombre. ¡Oh, si tú rasgases los cielos,y bajases haciendo estremecer,con tu presencia a las montañas,"
}`)
	CurrentBook.AddChapter(64, `{
"1":"como el fuego inflama las ramas secas, como el fuego hace hervir el agua, para manifestar tu nombre a tus enemigos,y hacer temblar a las naciones ante ti,"
,"2":"realizando maravillas inesperadas"
,"3":"de las que nadie jamás había sabido!,Ni oído alguno oyó, ni ojo alguno vio jamás, fuera de ti, un Dios que hiciera tanto,con quien confía en él."
,"4":"Tú sales a recibir a los que practican la justicia,y tienen en la mente tus caminos. Te has irritado, sí, porque pecamos; contra ti, desde antiguo, hemos sido rebeldes."
,"5":"Todos nosotros éramos inmundicias, y todas nuestras obras buenas,como un lienzo manchado. Todos hemos caído como hojas, y nuestras iniquidades nos barren como el viento."
,"6":"No hubo nadie que invocara tu nombre, que despertara para apoyarse en ti, pues tú habías escondido tu rostro de nosotros,y nos habías dejado a merced de nuestras iniquidades."
,"7":"Y sin embargo, Señor, tú eres nuestro padre; nosotros somos la arcilla y tú nuestro alfarero, todos somos obra de tus manos."
,"8":"No te irrites sin medida, Señor, no recuerdes siempre nuestras culpas. Pues, mira, tu pueblo somos todos nosotros."
,"9":"Tus santas ciudades han quedado hechas un desierto; Sión está desierta, Jerusalén es una desolación."
,"10":"Nuestro templo santo y glorioso, donde te alabaron nuestros padres, ha sido devorado por el fuego, y todo lo que hacía nuestras delicias está en ruinas."
,"11":"¿Vas a ser insensible a todo esto, Señor, seguirás aún callado para humillarnos sin medida?"
}`)
	CurrentBook.AddChapter(65, `{
"1":"Me he dejado consultar,por los que no me preguntaban, me he dejado encontrar,por los que no me buscaban. Decía: Aquí estoy, aquí estoy, a una nación que no invocaba mi nombre."
,"2":"He tendido sin cesar mis manos,hacia un pueblo rebelde, que caminaba por el mal camino,tras sus propios caprichos;"
,"3":"a un pueblo que me provocaba,a la cara continuamente, sacrificando en los huertos, quemando incienso en ladrillos,"
,"4":"habitando en sepulcros, pasando la noche en rincones secretos, comiendo carne de cerdo, echando en sus platos carne inmunda"
,"5":"y diciendo: ¡Quédate ahí, no te me acerques, porque te santificaría!,Todos ellos son humo en mi nariz, fuego que arde sin cesar."
,"6":"He aquí lo que delante de mí tengo escrito: No he de callar hasta no haber pedido cuentas"
,"7":"de sus crímenes y los de sus padres,juntamente -dice el Señor-, los que quemaron incienso en los montes,y en las colinas me ultrajaron. Mediré bien su merecido,y se lo echaré en su corazón."
,"8":"Esto dice el Señor: Cuando se encuentra zumo,en un racimo se dice: No lo destruyas, porque es una bendición. Así haré yo por amor de mis siervos: no lo destruiré todo."
,"9":"Haré salir descendencia de Jacob, y de Judá un heredero de mis montes. Sí, mis elegidos los heredarán, mis siervos morarán allí."
,"10":"El Sarón se hará una dehesa de rebaños,y el valle de Acor un pastizal de vacas,para un pueblo que me habrá buscado."
,"11":"Pero a vosotros, que abandonasteis al Señor, que os olvidasteis de mi santo monte, que preparasteis una mesa para Gad,y llenasteis una copa para Mení,"
,"12":"yo os destino a la espada, y todos sucumbiréis en la matanza; porque llamé y no respondisteis, hablé y no escuchasteis, hicisteis lo que es malo a mis ojos,y elegisteis lo que a mí no me agrada."
,"13":"Por eso, esto dice el Señor Dios: Mis siervos comerán, mientras vosotros padeceréis hambre; mis siervos beberán, mientras vosotros padeceréis sed; mis siervos se alegrarán, mientras vosotros sufriréis vergüenza;"
,"14":"mis siervos cantarán con corazón jubiloso, mientras vosotros gemiréis con el corazón afligido, y aullaréis, oprimidos en vuestro espíritu."
,"15":"Dejaréis vuestro nombre,para que sirva de juramento a mis elegidos: ¡El Señor Dios te haga morir!,Pero a mis siervos se les dará otro nombre."
,"16":"El que sea bendecido en el país, será bendecido por el Dios de la lealtad; y el que jure en el país, jurará por el Dios de la lealtad; pues los males pasados quedarán olvidados, ocultos a mis ojos."
,"17":"Porque yo voy a crear,un cielo nuevo y una tierra nueva, y no se volverá a recordar el pasado, ni vendrá siquiera a las mentes."
,"18":"Y habrá alegría y algazara eterna,por lo que yo voy a crear. Pues yo voy a crear para Jerusalén alegría, y para su pueblo regocijo."
,"19":"Sí; me alegraré en Jerusalén, me regocijaré en mi pueblo, y ya nunca se oirá en ella,voz de llanto ni grito de lamento."
,"20":"Ya no habrá allí recién nacido,que viva sólo pocos días, ni anciano que no culmine sus años, sino que morir a los cien años,será morir joven,y no llegar a los cien años,será señal de maldición."
,"21":"Harán entonces casas y habitarán en ellas, plantarán viñas y comerán sus frutos."
,"22":"No construirán para que lo habite otro, no plantarán para que otro lo coma; porque como la duración de los árboles,serán los días de mi pueblo, y mi elegidos disfrutarán de la obra de sus manos."
,"23":"No se afanarán en vano, ni engendrarán hijos destinados a la muerte, porque serán una raza bendita del Señor, y con ellos su estirpe."
,"24":"Incluso antes de que llamen yo responderé, y estando aún hablando serán escuchados."
,"25":"El lobo y el cordero pastarán juntos, el león comerá paja,como el buey y la serpiente,se alimentará de polvo. No se hará ya más mal ni daño,en todo mi santo monte -dice el Señor-."
}`)
	CurrentBook.AddChapter(66, `{
"1":"Esto dice el Señor: El cielo es mi trono,y la tierra el escabel de mis pies. ¿Qué casa podríais construirme, y qué lugar para reposo mío?"
,"2":"Todo esto lo ha hecho mi mano, y mío es todo ello -dice el Señor-. Pero aquel en quien fijo yo mis ojos es el humilde, el de contrito corazón, que tiembla a mi palabra."
,"3":"Se sacrifica un toro, se mata a un hombre, se inmola una oveja, se estrangula un perro; se ofrece sangre de cerdo, se quema incienso adorando a un ídolo. Como ellos gustan de seguir sus caminos,y su alma se complace en sus horrores,"
,"4":"así yo también me recrearé en su desgracia,y haré recaer sobre ellos lo que temen; porque he llamado y nadie ha respondido, he hablado y no han escuchado. Han hecho lo que es malo a mis ojos, han elegido lo que a mí no me agrada."
,"5":"Escuchad la palabra del Señor,los que tembláis a su palabra: Han dicho vuestros hermanos que os odian, que os aborrecen a causa de mi nombre. ¡Que el Señor manifieste su gloria,para que podamos ver vuestra alegría!,Pero ellos serán avergonzados."
,"6":"Oigo un tumulto que sale de la ciudad, una voz que sale del templo: Es la voz del Señor, que da su merecido a sus enemigos."
,"7":"Antes de estar de parto ha dado a luz, antes de salir los dolores ha tenido un varón."
,"8":"¿Quién vio jamás cosa igual?,¿Quién vio una cosa semejante?,¿Se puede dar a luz a un país en sólo un día?,¿Un pueblo puede ser alumbrado de una vez?,Pues apenas sentidos los dolores, Sión ha dado a luz a sus hijos."
,"9":"¿Iba yo a abrir el seno,para no hacer nacer? -dice el Señor-. O yo, que hago nacer, ¿lo iba a cerrar? -dice tu Dios-."
,"10":"Alegraos con Jerusalén, regocijaos por ella,todos los que su duelo soportáis,"
,"11":"a fin de que maméis,y os saciéis de su seno de consuelo, a fin de que saboreéis,y os recreéis en sus pechos de gloria."
,"12":"Pues esto dice el Señor: Yo haré correr por ella como un río la paz, y como un torrente desbordado la gloria de las naciones. Sus lactantes serán llevados en brazos,y acariciados sobre las rodillas."
,"13":"Como a un hijo a quien consuela su madre, así yo os consolaré a vosotros; por Jerusalén seréis consolados."
,"14":"Cuando veáis esto, vuestro corazón se alegrará,y vuestros huesos reverdecerán como la hierba. Sí, la mano del Señor se dará a conocer a sus siervos,y su cólera a sus enemigos."
,"15":"Pues el Señor viene entre fuego, sus carros como torbellino, para desfogar su cólera en incendio,y sus amenazas en ardientes llamas."
,"16":"Porque el Señor va a juzgar con fuego,y con espada a todos los mortales. Muchas serán las víctimas del Señor."
,"17":"Los que se santifican y purifican,para ir a los huertos detrás de alguien,que va en medio, que comen carne de cerdo, de reptiles o ratones, perecerán a una con sus obras y sus proyectos, dice el Señor."
,"18":"Yo vendré a reunir a los pueblos de todas las lenguas, que llegarán y verán mi gloria."
,"19":"Les daré una señal y mandaré a algunos de sus supervivientes a los pueblos de Tarsis, Etiopía, Libia, Mosoc, Ros, Tubal y Yaván; a las islas lejanas, que no han oído hablar de mí ni han visto mi gloria. Ellos publicarán mi gloria entre los pueblos."
,"20":"Y traerán de todos los pueblos, como ofrenda al Señor, a todos vuestros hermanos -a caballo, en carros, en literas, a lomos de mulos o de dromedarios- a mi santo monte, Jerusalén -dice el Señor-, de igual modo que los israelitas traen la ofrenda en vasos puros al templo del Señor."
,"21":"Y de entre ellos tomaré también para mí sacerdotes y levitas -dice el Señor-."
,"22":"Porque, lo mismo que el cielo nuevo y la nueva tierra,que yo creo subsisten ante mí -dice el Señor-, así subsistirán vuestra raza y vuestro nombre."
,"23":"Cada luna nueva y cada sábado,vendrá todo el mundo a prosternarse ante mí -dice el Señor-."
,"24":"Y al salir verán los cadáveres de los hombres,que se rebelaron contra mí. Su gusano no morirá ni se extinguirá su fuego,y serán un horror para todo el mundo."
}`)

}
func ES_LSB_LoadVMLMChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"¡Ay, cómo está postrada,en soledad la ciudad tan populosa!,Como una viuda se ha quedado,la grande entre las naciones. La señora entre las provincias,ha sido esclavizada."
,"2":"Llora a raudales en la noche,y las lágrimas surcan sus mejillas. Nadie hay que la consuele,entre todos sus amantes; la han traicionado todos sus aliados, se le han vuelto enemigos."
,"3":"Judá está desterrada en la miseria,y en dura esclavitud; habita en medio de las gentes,y no encuentra descanso; la acosan todos sus perseguidores,entre las angosturas."
,"4":"Los caminos de Sión están en duelo, pues nadie ya viene a sus fiestas; todas sus puertas asoladas, gimiendo sus sacerdotes, sus doncellas en pena, toda, ay, repleta de amargura."
,"5":"Sus adversarios prevalecen, sus enemigos son felices; porque el Señor la ha afligido,por sus muchos pecados; sus niños han marchado al destierro,delante del perseguidor."
,"6":"Ha desaparecido de Sión,todo su esplendor; sus jefes parecían ciervos,que no encuentran pasto: iban caminando sin fuerzas,delante del perseguidor."
,"7":"Jerusalén se acuerda,de sus días de miseria y de aflicción; cuando caía su pueblo,en manos del enemigo,sin que ninguno le ayudara; sus adversarios la miraban,y se reían de su ruina."
,"8":"Mucho ha pecado Jerusalén, se ha vuelto objeto de horror; todos los que la honraban la desprecian, porque han visto su desnudez. Ella también gime,y se vuelve de espaldas."
,"9":"¡Hasta en sus ropas hay inmundicia!,No pensaba en este fin; se hundió estruendosamente,¡y nadie la consuela!,Mira, Señor, su aflicción, que el enemigo triunfa."
,"10":"El opresor ha alargado su mano,a todos sus tesoros; ella ha visto a los gentiles,penetrar en su santuario, a quienes tú habías prohibido,entrar en tu comunidad."
,"11":"Todo su pueblo suspira,buscando pan; dan sus joyas a cambio de comida, por sustentar la vida. '¡Mira, Señor, y observa qué envilecida estoy!'."
,"12":"Vosotros todos, los que pasáis por el camino,mirad y ved si hay dolor,como el dolor que me atormenta, con el que el Señor me ha herido,el día del fuego de su cólera."
,"13":"Desde lo alto lanzó un fuego, lo ha vertido en mis huesos; tendió una red ante mis pies,y me ha hecho caer; me ha dejado desolada, todo el día sufriendo."
,"14":"Ha uncido mis pecados sobre mí, su mano los ha entrelazado. Sobre mi cuello,el yugo me quebranta las fuerzas. El Señor me ha entregado en sus manos,y no puedo levantarme."
,"15":"El Señor despreció a todos mis valientes,de en medio de mi seno; convocó contra mí una asamblea, para extirpar a mis mejores; ha estrujado el Señor en lagar,a la virgen hija de Judá."
,"16":"Por todo estoy llorando, se derriten en lágrimas mis ojos, porque está lejos de mí el consolador, que me devuelva la vida. Mis hijos están desolados, porque ha triunfado el enemigo."
,"17":"Sión alarga sus manos, mas no hay quien la consuele. El Señor ha suscitado contra Jacob,por todas partes enemigos; Jerusalén se ha convertido,en objeto de horror entre los pueblos."
,"18":"Pero el Señor es muy justo, porque yo me rebelé contra sus leyes. ¡Oh, escuchad, pueblos todos, y mirad mi dolor; mis doncellas y mis jóvenes,han marchado al destierro!"
,"19":"He llamado a mis amantes, pero me han traicionado. Mis sacerdotes y mis ancianos,han muerto en la ciudad, mientras buscaban alimento,que reanimara su vida."
,"20":"¡Mira, Señor, en qué angustia me encuentro!,Mis entrañas se estremecen, mi corazón se consume en mi interior, pues he sido muy rebelde. Fuera la espada hacía estragos, y dentro la muerte."
,"21":"Escucha mi gemido: ¡no hay quien me consuele!,Todos mis enemigos se alegran de mi ruina, de que tú lo hayas hecho. ¡Haz que llegue el día,que habías anunciado, para que sean como yo!"
,"22":"¡Llegue ante ti toda su iniquidad; y trátalos como a mí me has tratado,por todos mis pecados!,Pues son muchos mis gemidos,y desfallece mi corazón."
}`)
	CurrentBook.AddChapter(2, `{
"1":"¡Ay, cómo el Señor en su ira,ha cubierto de sombras,a la hija de Sión!,Ha precipitado del cielo a la tierra,la gloria de Israel: ¡No quiere acordarse del estrado de sus pies, en el día de su ira!"
,"2":"El Señor ha destruido sin piedad,todas las moradas de Jacob; ha derribado en su furor,las fortalezas de la hija de Judá; ha postrado en tierra, ha profanado a su rey y a sus príncipes."
,"3":"Ha despedazado en el ardor de su ira,todo el poder de Israel; ha retirado atrás su diestra, al acercarse al enemigo; ha encendido contra Jacob,un fuego que todo lo devora."
,"4":"Ha tensado su arco, cual si fuese enemigo, ha reforzado su diestra, como un adversario ha destrozado,todo lo que era agradable a la vista; sobre las tiendas de Sión,ha derramado su furor como fuego."
,"5":"El Señor ha actuado como enemigo, ha devastado a Israel; ha destruido todos sus palacios, ha arrasado sus fortalezas, ha multiplicado en la hija de Judá,gemidos y gemidos."
,"6":"Ha destrozado su recinto,semejante a un jardín, ha derruido el lugar de su reunión. El Señor ha hecho olvidar en Sión,fiestas y sábados; ha desechado, en el ardor de su ira, a rey y sacerdotes."
,"7":"El Señor ha rechazado su altar, ha aborrecido su santuario; ha entregado en manos del enemigo,las defensas de sus palacios; ¡gritos se dieron en el templo del Señor, como en día de fiesta!"
,"8":"El Señor ha decidido derruir,la muralla de la hija de Sión; ha tirado la cuerda, sin recoger la mano, hasta no haberlo destruido todo; ha puesto en luto muro y antemural, que juntos se derrumban."
,"9":"Yacen sus puertas hundidas en la tierra; él quebró sus barrotes. Su rey y sus príncipes,están entre las gentes; ¡ya no hay ley!,Y tampoco sus profetas,tienen visiones del Señor."
,"10":"En tierra están sentados,y enmudecen los ancianos de la hija de Sión; han esparcido ceniza en su cabeza, se han vestido de sayal; doblegan su cabeza,hasta la tierra,las doncellas de Jerusalén."
,"11":"Mis ojos están en lágrimas sumidos, mis entrañas se estremecen; mi hiel por tierra derramada, por la caída de la hija de mi pueblo, cuando desfallecían niños y lactantes,en las plazas de la ciudad."
,"12":"Decían a sus madres: '¿Dónde está el pan y el vino?', mientras caían como heridos,en las plazas de la ciudad,y exhalaban su espíritu,en el regazo de sus madres."
,"13":"¿A quién te compararé?,¿A quién te haré semejante, oh hija de Jerusalén?,¿Quién te podrá salvar y confortar, oh virgen, hija de Sión?,Grande como el mar es tu ruina, ¿quién te podrá curar?"
,"14":"Tus profetas tuvieron para ti,visiones de mentira y engaño. No te desvelaron tu perversidad, para alejar tu destierro de ti; te anunciaron visiones de engaño, de mentira y perversión."
,"15":"Al verte se frotan las manos,todos los transeúntes; silban y menean la cabeza,ante la hija de Jerusalén, diciendo: '¿Es ésta la ciudad más hermosa, la delicia de toda la tierra?'."
,"16":"Abren su boca contra ti,todos tus enemigos, silban, rechinan sus dientes, dicen: '¡La hemos tragado!,Éste es el día que esperábamos, ¡ya lo tocamos, ya lo vemos!'."
,"17":"El Señor ha realizado,lo que había decidido, ha cumplido su palabra,pronunciada desde antiguo; ha destruido sin piedad, ha hecho que se ría de ti tu adversario, ha acrecentado el poder de tu enemigo."
,"18":"¡Grita por ti al Señor, oh virgen, hija de Sión; deja correr como un torrente,tu llanto de día y de noche; no te des tregua a ti misma, ni descanse la pupila de tus ojos!"
,"19":"¡Arriba! Lanza gritos en la noche, a cada relevo de la guardia; derrama, como agua, tu corazón,delante del Señor; alza tus manos a él por tus pequeños, que desfallecen de hambre,en las esquinas de las calles."
,"20":"Mira, Señor, y considera: ¿a quién has tratado alguna vez así?,¡Ay! ¡Las madres han comido a sus vástagos, a los hijos de sus caricias!,¡Fueron asesinados,en el santuario del Señor,sacerdote y profeta!"
,"21":"Por tierra yacían en las calles,niños y ancianos; mis doncellas y mis jóvenes,cayeron a cuchillo; ¡has sembrado muerte,en el día de tu ira, has degollado sin compasión!"
,"22":"Has convocado,como en un día de fiesta,el terror por todas partes; no ha habido, en el día de tu ira, escapado ni superviviente. Los que yo había criado y educado, mi enemigo los exterminó."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Yo soy el hombre que ha sufrido,la miseria bajo el azote de su furor."
,"2":"Él me ha llevado, me ha hecho caminar en tinieblas, sin luz."
,"3":"Sólo contra mí vuelve él,y revuelve su mano todo el día."
,"4":"Ha consumido mi carne y mi piel,y ha roto mis huesos."
,"5":"Ha levantado en torno a mí,un cerco de veneno y de amargura."
,"6":"Me ha hecho habitar en lugares tenebrosos, como los muertos de antaño."
,"7":"Me ha cerrado en un cerco sin salida, ha hecho pesadas mis cadenas."
,"8":"Aunque grito e imploro, rechaza mi plegaria."
,"9":"Ha cortado mis caminos,con piedras sillares, ha cerrado mis senderos."
,"10":"Ha sido para mí oso que acecha, león en escondite."
,"11":"Ha desviado mi camino, me ha destrozado; me ha dejado hecho una ruina."
,"12":"Ha tensado su arco,y me ha apuntado como blanco de sus flechas."
,"13":"Ha clavado sus flechas en mis lomos, las flechas de su aljaba."
,"14":"Me ha hecho la irrisión de mi pueblo, copla suya todo el día."
,"15":"Me ha hartado de amargura, me ha abrevado con ajenjo."
,"16":"Me ha roto los dientes con guijarro, me ha alimentado de ceniza."
,"17":"Me ha quitado la paz del alma, ya no sé qué es la dicha."
,"18":"Y he dicho: ¡Adiós mi ilusión, lo que esperaba del Señor!"
,"19":"Recordar mi miseria y mi angustia,es hiel y veneno."
,"20":"Pero yo lo recuerdo, lo recuerdo y me quedo abrumado."
,"21":"He aquí lo que sugeriré a mi corazón,para cobrar confianza:"
,"22":"Las bondades del Señor,no se han acabado, ni se han agotado sus misericordias."
,"23":"Nuevas son cada mañana, grande es su fidelidad."
,"24":"'¡Mi porción es el Señor!', yo me digo; por eso en él espero."
,"25":"El Señor es bueno,para el que en él confía, para el alma que lo busca."
,"26":"Bueno es esperar en silencio,el socorro del Señor."
,"27":"Bueno es para el hombre,soportar el yugo desde su juventud."
,"28":"Siéntese solitario, en silencio, si el Señor se lo impone;"
,"29":"reduzca su boca al polvo, pues quizá haya aún esperanza;"
,"30":"ofrezca la mejilla a quien le hiere,y se sacie de ultrajes."
,"31":"Pues el Señor no rechaza para siempre."
,"32":"Y cuando castiga, tiene aún compasión, según su gran bondad."
,"33":"Pues no se complace,en castigar y afligir a los humanos."
,"34":"Cuando se aplasta debajo de los pies,a todos los prisioneros de un país,"
,"35":"cuando se quebranta el derecho,de un hombre bajo los ojos del altísimo,"
,"36":"cuando se tuerce la justicia en el proceso, ¿no lo ve el Señor?"
,"37":"¿Quién dijo algo y quedó hecho?,¿No es el Señor el que decide?"
,"38":"¿No vienen de la boca del altísimo,los males y los bienes?"
,"39":"¿Por qué el mortal se queja,si sigue viviendo de sus pecados?"
,"40":"Veamos nuestra conducta, examinémosla y volvamos al Señor."
,"41":"Levantemos el corazón en nuestras manos,al Dios que está en los cielos."
,"42":"Nosotros pecamos y fuimos rebeldes; ¡tú nos has perdonado!"
,"43":"Te has cargado de ira,y nos has perseguido, has matado sin piedad."
,"44":"Te has envuelto en una nube, para que no pasara la oración."
,"45":"Basura y escarnio nos has hecho,en medio de los pueblos."
,"46":"Contra nosotros han abierto su boca,todos nuestros enemigos."
,"47":"Espanto y fosa han sido nuestra suerte, exterminio y ruina."
,"48":"Arroyos de lágrimas,fluyen de mis ojos,por la ruina de la hija de mi pueblo."
,"49":"Mis ojos lloran sin cesar,y no tendrán descanso,"
,"50":"hasta que mire y vea,el Señor desde los cielos."
,"51":"Me duelen mis ojos,ante el espectáculo,de todas las hijas de mi ciudad."
,"52":"Me dieron caza como a un pájaro,los que me odian sin razón."
,"53":"Precipitaron mi vida en una fosa, y tiraron piedras sobre mí."
,"54":"Las aguas me cubrieron la cabeza,y dije: '¡Estoy perdido!'."
,"55":"Invoqué tu nombre, Señor, desde la hondura de la fosa."
,"56":"Mi grito oíste: 'No cierres tu oído a mi oración'."
,"57":"Te acercaste el día en que te llamaba, me dijiste: '¡No temas!'."
,"58":"Tú has defendido mi causa,y has salvado mi vida."
,"59":"Has visto, Señor, la injusticia que sufría; ¡hazme tú justicia!"
,"60":"Has visto todas sus venganzas, todas sus maquinaciones contra mí."
,"61":"Has oído sus insultos, Señor, todas sus maquinaciones contra mí,"
,"62":"los planes que cuchichean mis adversarios, contra mí todo el día."
,"63":"Se sienten o se levanten, fíjate, yo soy copla suya."
,"64":"Dales su merecido, Señor, según la obra de sus manos."
,"65":"Obceca su mente, ¡tu maldición sobre ellos!"
,"66":"¡Persíguelos con ira, extermínalos, bajo tu cielo!"
}`)
	CurrentBook.AddChapter(4, `{
"1":"¡Ay, cómo se ha deslucido el oro, se ha alterado el oro tan fino!,¡Están esparcidas las piedras sagradas,por las esquinas de todas las calles!"
,"2":"Los hijos de Sión, preciosos, estimados como el oro fino, ¡ay, son tratados como vasos de arcilla, obra de manos de alfarero!"
,"3":"Hasta los chacales presentan las ubres, dan de mamar a sus cachorros; las hijas de mi pueblo se han hecho crueles,como las avestruces del desierto."
,"4":"De sed, la lengua de los niños de pecho,se pega al paladar; los pequeños piden pan, no hay quien se lo dé."
,"5":"Los que comían manjares exquisitos,se mueren de hambre por las calles; los que se criaban entre púrpura,yacen ahora en la basura."
,"6":"La perversidad de la hija de mi pueblo,es más grande que el pecado de Sodoma, que fue arrasada en un instante,sin que interviniera mano alguna contra ella."
,"7":"Más que la nieve sus príncipes brillaban, eran más blancos que la leche; más rojo que el coral era su cuerpo, su aspecto era de zafiro."
,"8":"Su rostro ahora es más oscuro que negrura, no se les reconoce por las calles; su piel está pegada a los huesos, seca como madera."
,"9":"Más afortunados fueron los pasados a cuchillo,que los muertos de hambre, que caen extenuados por falta de los frutos del campo."
,"10":"Las mismas manos de tiernas mujeres,cocieron a sus hijos: ellos les sirvieron de comida,en la ruina de la hija de mi pueblo."
,"11":"El Señor ha desahogado su furor, el ardor de su ira ha descargado; un fuego ha encendido en Sión, que la ha devorado hasta sus cimientos."
,"12":"No creían los reyes de la tierra, todos los habitantes del mundo, que el opresor y el enemigo atravesaría las puertas de Jerusalén."
,"13":"Fue por los pecados de sus profetas, por las iniquidades de sus sacerdotes, que en medio de ella derramaban la sangre de los justos."
,"14":"Vagaban por las calles como ciegos, tan manchados de sangre que,ni se podían tocar sus vestiduras."
,"15":"'¡Apartaos! ¡Un impuro!', les gritaban. '¡Apartaos! ¡No tocar!'. Cuando huían errantes entre las naciones, se decía: '¡No pueden quedarse entre nosotros!'."
,"16":"El rostro del Señor los dispersó, no volverá a mirarlos. No hubo respeto para los sacerdotes, ni se tuvo piedad de los ancianos."
,"17":"Sin tregua se consumían nuestros ojos, esperando socorros en vano. Desde las atalayas oteábamos a un país,que no nos podía salvar."
,"18":"Se espiaban nuestros pasos, se nos cerraban nuestras plazas. Llegaba nuestro fin, cumplidos nuestros días; sí, llegaba nuestro fin."
,"19":"Nuestros perseguidores eran más veloces,que las águilas del cielo; por los montes nos acosaban, en el desierto nos tendían emboscadas."
,"20":"El aire de nuestro aliento, el ungido del Señor, quedó preso en sus fosas; aquel que decíamos: '¡A su sombra viviremos en medio de las gentes!'."
,"21":"¡Regocíjate, salta de gozo, hija de Edón, que moras en la tierra de Us!,También a ti te llegará tu copa. ¡Te emborracharás y te desnudarás!"
,"22":"Tu castigo ha terminado, oh hija de Sión, no volverá él a desterrarte. ¡Pero castigará tu iniquidad, hija de Edón, pondrá al desnudo tus pecados!"
}`)
	CurrentBook.AddChapter(5, `{
"1":"¡Acuérdate, Señor, de lo que nos ha sobrevenido, mira y considera nuestra afrenta!"
,"2":"Nuestra heredad ha pasado a extranjeros, nuestras casas a extraños."
,"3":"Huérfanos, sin padre hemos quedado; son nuestras madres como viudas."
,"4":"A precio de plata bebemos nuestra agua, tenemos que pagar nuestra leña."
,"5":"El yugo a nuestro cuello, estamos oprimidos, extenuados, y no se nos da respiro."
,"6":"Hacia Egipto tendemos la mano, hacia Asiria en busca de pan."
,"7":"Nuestros padres pecaron, ya no existen, y nosotros cargamos con sus iniquidades."
,"8":"Esclavos mandan en nosotros,y nadie nos libra de su mano."
,"9":"Arriesgando la vida nos buscamos el pan, ante la espada del desierto."
,"10":"Nuestra piel abrasa como un horno, por el ardor del hambre."
,"11":"Han violado en Sión a las mujeres, a las doncellas en las ciudades de Judá."
,"12":"Los príncipes fueron colgados por sus manos,y el rostro de los ancianos no ha sido respetado."
,"13":"Los muchachos han tirado de la muela del molino, bajo la carga de la leña se han doblado los niños."
,"14":"Los ancianos han dejado de acudir a la puerta, han dejado sus músicas los jóvenes."
,"15":"Se ha acabado la alegría de nuestro corazón, en duelo se ha convertido nuestra danza."
,"16":"Ha caído de nuestra cabeza la corona. ¡Ay de nosotros, que hemos pecado!"
,"17":"Por eso ha enfermado nuestro corazón, y nuestros ojos se oscurecen:"
,"18":"por el monte Sión, que está desolado, y en el que merodean los chacales."
,"19":"Mas tú, Señor, por siempre permaneces; tu trono, de generación en generación."
,"20":"¿Por qué nos vas a olvidar para siempre, por qué abandonarnos por tanto tiempo?"
,"21":"¡Reclámanos a ti, Señor, y volveremos; renueva nuestros días como antaño,"
,"22":"si no nos has rechazado del todo, si no estás irritado contra nosotros sin medida!"
}`)

}
func ES_LSB_LoadVNABChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Visión de Abdías,Esto dice el Señor sobre Edón: Hemos oído un mensaje del Señor, un heraldo ha sido enviado a decir a las naciones: '¡En pie, levantémonos y hagámosle la guerra!'"
,"2":"Mira, te voy a hacer la nación más pequeña y despreciable."
,"3":"La soberbia de tu corazón te ha engañado, tú que habitas en las cavernas de las rocas, que pones en las alturas tu morada, y piensas: '¿Quién me hará caer a tierra?'."
,"4":"Aunque te elevaras como el águila,y pusieras tu nido en las estrellas, de allí te haré caer, dice el Señor."
,"5":"Si vinieran a ti ladrones o salteadores durante la noche, ¿no robarían todo lo que pudieran?,Si vinieran a ti vendimiadores, ¿te dejarían otra cosa que lo que queda de rebusco?"
,"6":"¡Cómo ha sido saqueado Esaú, escudriñados sus tesoros ocultos!"
,"7":"Te han echado de tu tierra, se han burlado de ti todos tus aliados, te han engañado tus amigos. Los mismos que comen a tu mesa,han tendido lazos a tus pies: 'Ha perdido la razón'."
,"8":"Aquel día -dice el Señor- eliminaré de Edón,los sabios y la inteligencia de los montes de Esaú."
,"9":"Tus guerreros tendrán miedo, Temán, de suerte que no quedará un solo hombre en el monte de Esaú."
,"10":"Por las matanzas, por las injusticias cometidas,contra tu hermano Jacob, quedarás cubierto de vergüenza,y serás exterminado para siempre."
,"11":"El día que estabas frente a él, cuando los extranjeros llevaban prisionero a su ejército,y los extranjeros entraban por sus puertas,y echaban suertes sobre Jerusalén, tú también eras como uno de ellos."
,"12":"No te alegres del castigo de tu hermano el día de su desastre; no te alegres de la desgracia de los judíos el día de su perdición; no te burles de ellos el día de su angustia;"
,"13":"no entres en la ciudad de mi pueblo el día de su ruina; no te alegres también tú de su desgracia el día de su ruina, ni eches mano a su riqueza el día de su ruina."
,"14":"No te plantes en las encrucijadas,para matar a los que huyen; no entregues a sus supervivientes el día de la angustia."
,"15":"Porque está cerca el día del Señor para todas las naciones. Como tú has hecho, así te harán a ti; tus acciones recaerán sobre tu cabeza."
,"16":"Sí, como vosotros bebisteis en mi monte santo, así beberán siempre todas las naciones; beberán, consumirán y serán luego como si jamás hubiesen sido."
,"17":"Pero en el monte Sión se refugiarán los supervivientes,-y será un lugar santo-, y la casa de Jacob recobrará todos sus dominios."
,"18":"Las gentes de Jacob serán fuego, las de José una llama, y los de Esaú paja, que será devorada por el fuego y la llama. No quedará un superviviente de Esaú. El Señor lo ha dicho."
,"19":"Ocuparán el Negueb, la montaña de Esaú, la llanura, el país de los filisteos, el territorio de Efraín y de Samaría, Benjamín y Galaad."
,"20":"Los desterrados de este ejército, los israelitas, ocuparán Canaán hasta Sarepta, y los desterrados de Jerusalén que están en Sefarad,ocuparán las ciudades del Negueb."
,"21":"Y subirán victoriosos al monte Sión,para juzgar a la montaña de Esaú, y el reino será del Señor."
}`)

}
func ES_LSB_LoadVNAGChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"El año segundo del rey Darío, en el mes sexto, el día primero del mes, fue dirigida esta palabra del Señor, por medio del profeta Ageo, a Zorobabel, hijo de Sealtiel, gobernador de Judá, y a Josué, hijo de Yehosadac, sumo sacerdote, en estos términos:"
,"2":"Esto dice el Señor todopoderoso: 'Este pueblo dice: ¡Todavía no ha llegado el tiempo de edificar el templo del Señor!'."
,"3":"Y fue dirigida esta palabra del Señor por medio del profeta Ageo:"
,"4":"'¿Ha llegado para vosotros el tiempo de habitar en casas confortables, mientras esta casa está devastada?"
,"5":"Ahora, esto dice el Señor todopoderoso: Reflexionad sobre lo que os pasa:"
,"6":"Sembráis mucho y recogéis poco, coméis y no os saciáis, bebéis y no os hartáis, os vestís y no os calentáis, y el que se contrata de jornalero guarda su jornal en bolso roto."
,"7":"Sí, esto dice el Señor todopoderoso: Reflexionad sobre lo que os pasa."
,"8":"Subid al monte para traer madera y reconstruid la casa; yo me complaceré en ella, y en ella pondré mi gloria, dice el Señor."
,"9":"Esperabais mucho, y resultó poco; lo llevasteis a casa, y yo os lo he dispersado con mi soplo. ¿Por qué?, palabra del Señor todopoderoso. Porque mi casa está en ruinas, mientras cada uno de vosotros sólo se preocupa de su propia casa."
,"10":"Por eso los cielos os negaron la lluvia, y la tierra no ha dado su fruto."
,"11":"Y he mandado la sequía sobre la tierra, sobre los montes, sobre el trigo y sobre el vino, sobre el aceite y sobre cuanto produce la tierra, sobre los hombres y sobre los ganados, y sobre todo el trabajo de vuestras manos'."
,"12":"Entonces Zorobabel, hijo de Sealtiel; Josué, hijo de Yehosadac, sumo sacerdote, y todo el resto del pueblo escucharon la voz del Señor, su Dios, y las palabras de Ageo, el profeta, según la misión que el Señor le había encomendado, y el pueblo se llenó de temor ante el Señor."
,"13":"Y Ageo, enviado del Señor, dirigió al pueblo este mensaje del Señor: 'Yo estoy con vosotros, palabra del Señor'."
,"14":"Y el Señor levantó el ánimo de Zorobabel, hijo de Sealtiel, gobernador de Judá; de Josué, hijo de Yehosadac, sumo sacerdote, y de todo el resto del pueblo, de tal manera que fueron y se pusieron a la obra en el templo del Señor todopoderoso, su Dios."
,"15":"Era el día veinticuatro del mes sexto."
}`)
	CurrentBook.AddChapter(2, `{
"1":"en el mes séptimo, el día veinticuatro del mes, llegó esta palabra del Señor por medio del profeta Ageo:"
,"2":"'Di a Zorobabel, hijo de Sealtiel, gobernador de Judá; a Josué, hijo de Yehosadac, sumo sacerdote, y al resto del pueblo lo siguiente:"
,"3":"¿Quién queda de entre vosotros que haya visto esta casa en su esplendor primero? ¿Y cómo la veis ahora? ¿No es como nada ante vuestros ojos?"
,"4":"Pero ahora, ten ánimo, Zorobabel, dice el Señor; ten ánimo, Josué, hijo de Yehosadac, sumo sacerdote; ten ánimo, pueblo todo de la tierra, dice el Señor. Trabajad, porque yo estoy con vosotros, palabra del Señor todopoderoso."
,"5":"Empeñé mi palabra al sacaros de Egipto, y mi Espíritu estará en medio de vosotros; no temáis."
,"6":"Porque esto dice el Señor todopoderoso: Dentro de poco conmoveré los cielos y la tierra, el mar y el desierto."
,"7":"Haré temblar a todas las naciones para que traigan los tesoros de todas las gentes, y colmaré de gloria esta casa, dice el Señor todopoderoso."
,"8":"Mía es la plata y mío es el oro, dice el Señor todopoderoso."
,"9":"La gloria de esta casa última será mayor que la de la primera, dice el Señor todopoderoso; y en este lugar daré la paz, dice el Señor todopoderoso'."
,"10":"El día veinticuatro del mes noveno, del año segundo de Darío, fue dirigida al profeta Ageo esta palabra del Señor:"
,"11":"'Esto dice el Señor todopoderoso: Haz esta consulta a los sacerdotes:"
,"12":"Si uno lleva carne santificada en la parte extrema de su vestido y toca con su vestido pan, alimentos cocidos, vino, aceite o cualquier clase de alimentos, ¿será esto santificado?'. Los sacerdotes respondieron: 'No'."
,"13":"Ageo prosiguió: 'Si uno, impuro por el contacto con un cadáver, toca cualquiera de estas cosas, ¿serían impuras?'. Los sacerdotes respondieron: 'Sí'."
,"14":"Entonces Ageo dijo: 'Esto le pasa a este pueblo, a esta nación delante de mí, palabra del Señor; esto le pasa a todo lo que hacen: todo lo que allí ofrecen es impuro."
,"15":"Y ahora estad atentos desde hoy en adelante. Antes de poner una piedra sobre otra en el templo del Señor,"
,"16":"¿cuál era vuestra situación? Veníais a un muelo de trigo de veinte medidas, y sólo había diez; veníais al lagar para sacar cincuenta, y sólo había veinte."
,"17":"Yo herí con tizón, añublo y granizo todas vuestras labores, y sin embargo no volvisteis a mí, palabra del Señor."
,"18":"Estad, pues, atentos de ahora en adelante -a partir del veinticuatro del mes noveno-; desde el día en que se pusieron los cimientos del templo del Señor, estad atentos:"
,"19":"a ver si sigue faltando el grano en el granero, y si la vid, la higuera, el granado y el olivo no llevan fruto. Porque a partir de hoy yo os doy la bendición'."
,"20":"El mismo día veinticuatro fue dirigida a Ageo por segunda vez esta palabra del Señor:"
,"21":"'Di a Zorobabel, gobernador de Judá: Yo conmoveré los cielos y la tierra."
,"22":"Cambiaré los tronos de los reinos y destruiré el poder de los reyes de las naciones. Volcaré los carros de guerra y a sus conductores; caballos y jinetes caerán cada uno por la espada de su hermano."
,"23":"En aquel día, palabra del Señor todopoderoso, te tomaré a ti, Zorobabel, hijo de Sealtiel, mi siervo, dice el Señor, y haré de ti como un anillo de sellar; porque yo te he elegido, dice el Señor todopoderoso'."
}`)

}
func ES_LSB_LoadVNAMChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Mensaje de Amós, uno de los pastores de Técoa. Visión que tuvo acerca de Israel en los días de Ozías, rey de Judá, y en los días de Jeroboán, hijo de Joás, rey de Israel, dos años antes del terremoto."
,"2":"Dijo: El Señor ruge desde Sión,y hace oír su voz desde Jerusalén; los pastizales de los pastores están de luto,y la cumbre del Carmelo se seca."
,"3":"Esto dice el Señor: Por tres crímenes de Damasco,y por cuatro no le perdonaré; por haber aplastado a Galaad con trillos de hierro "
,"4":"prenderé fuego a la casa de Jazael,y devorará los palacios de Ben Hadad; "
,"5":"romperé el cerrojo de Damasco, exterminaré al que se sienta en el trono de Bicat Aven,y al que tiene el cetro de Bet Edén, y el pueblo asirio será desterrado a Quir, dice el Señor."
,"6":"Esto dice el Señor: Por tres crímenes de Gaza,y por cuatro no le perdonaré; por haber llevado cautiva a la población entera,para venderla a Edón, "
,"7":"prenderé fuego a los muros de Gaza, y devorará sus palacios; "
,"8":"exterminaré al que se sienta en el trono de Asdod,y al que tiene el cetro de Ascalón; volveré mi mano contra Ecrón, y el resto de los filisteos perecerá, dice el Señor."
,"9":"Esto dice el Señor: Por tres crímenes de Tiro,y por cuatro no le perdonaré; por haber vendido la población entera cautiva a Edón,sin respetar el pacto entre hermanos, "
,"10":"prenderé fuego a los muros de Tiro,y devorará sus palacios."
,"11":"Esto dice el Señor: Por tres crímenes de Edón,y por cuatro no le perdonaré; por haber perseguido a espada a su hermano,y haber olvidado la misericordia; por haberse ensañado en su ira,y haber guardado hasta el fin su rencor, "
,"12":"prenderé fuego a Temán,y devorará los palacios de Bosra."
,"13":"Esto dice el Señor: Por tres crímenes de los amonitas,y por cuatro no le perdonaré; por haber abierto en canal a las mujeres encinta de Galaad,para dilatar sus fronteras, "
,"14":"prenderé fuego a los muros de Rabbá,y devorará sus palacios entre el clamor de un día de batalla,y el torbellino de un día de huracán. "
,"15":"Su rey marchará al destierro, y con él sus príncipes, dice el Señor."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Esto dice el Señor: Por tres crímenes de Moab,y por cuatro no le perdonaré; por haber quemado los huesos del rey de Edón hasta calcinarlos,"
,"2":"enviaré fuego contra Moab, que devorará los palacios de Queriot, y Moab morirá en el fragor entre el clamor bélico,y el sonido de la trompeta; "
,"3":"le quitaré al rey,y mataré a todos sus príncipes con él, dice el Señor."
,"4":"Esto dice el Señor: Por tres crímenes de Judá,y por cuatro no le perdonaré; por haber despreciado la ley del Señor,y no haber guardado sus decretos, extraviándose por caminos falsos,que recorrieron ya sus padres,"
,"5":"prenderé fuego a Judá, que devorará los palacios de Jerusalén."
,"6":"Esto dice el Señor: Por tres crímenes de Israel,y por cuatro no le perdonaré; porque ha vendido al inocente por dinero,y al pobre por un par de sandalias; "
,"7":"porque aplastan contra el polvo de la tierra,la cabeza de los necesitados,y no hacen justicia a los pobres; porque hijo y padre se acuestan con la misma mujer, profanando mi santo nombre; "
,"8":"porque se acuestan junto a cualquier altar,sobre ropas tomadas en prenda, y en la casa de su Dios beben el vino de las multas."
,"9":"Y, sin embargo, yo exterminé delante de ellos,al amorreo, alto como los cedros y fuerte como las encinas; destruí su fruto por arriba y por abajo sus raíces."
,"10":"Yo os saqué de Egipto,y os conduje por el desierto durante cuarenta años,para que tomarais posesión de la tierra del amorreo."
,"11":"Suscité profetas entre vuestros hijos, y nazireos entre vuestros jóvenes. ¿No es así, israelitas? dice el Señor."
,"12":"Pero vosotros hicisteis beber vino a los nazireos,y os impusisteis a los profetas diciendo: 'No profeticéis'."
,"13":"Pues ahora yo haré que se atasquen vuestros pies,como se atasca un carro cargado de mies."
,"14":"El veloz no podrá huir, el fuerte no tendrá fuerzas,y el valiente no salvará su vida; "
,"15":"el que maneja el arco no resistirá, el veloz no escapará y el jinete no salvará su vida;"
,"16":"el más valiente entre los valientes,huirá desnudo aquel día, dice el Señor."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Escuchad esta palabra que el Señor dirige contra vosotros, israelitas, contra toda la familia que saqué de Egipto: "
,"2":"Sólo a vosotros escogí entre todas las familias de la tierra; por eso os pediré cuentas de todas vuestras iniquidades. "
,"3":"¿Es que pueden caminar dos juntos,si antes no se han puesto de acuerdo? "
,"4":"¿Rugirá el león en la selva sin que haya presa?,¿Dejará el leoncillo oír su voz desde su cubil,si no ha agarrado nada? "
,"5":"¿Se lanzará el pájaro a tierra,si no hubiere cebo para él?,¿Se levantará el lazo del suelo,sin que haya cazado algo? "
,"6":"¿Sonará la trompeta en la ciudad,sin que el pueblo se alarme?,¿Sucederá en la ciudad una desgracia,sin que el Señor la haya causado? "
,"7":"Porque el Señor Dios no hace nada,sin que manifieste su plan a sus siervos los profetas."
,"8":"El león ruge; ¿quién no temerá?,El Señor Dios habla; ¿quién no profetizará?"
,"9":"Proclamadlo en los palacios de Asdod,y en los palacios de Egipto; decid: 'Reuníos sobre los montes de Samaría, y ved los desórdenes que hay en ella,y la violencia que reina allí'."
,"10":"No saben obrar con rectitud, dice el Señor; acumulan la violencia y la opresión en sus palacios."
,"11":"Por eso, esto dice el Señor: 'El enemigo sitiará el país y te quitará tu poder; serán saqueados tus palacios'."
,"12":"Esto dice el Señor: 'Como el pastor salva de la boca del león dos patas,o la punta de una oreja, así serán salvados los israelitas, los instalados en Samaría, que se recuestan en divanes lujosos y en camas confortables'."
,"13":"Escuchad y testificad contra la casa de Jacob, dice el Señor, Dios todopoderoso."
,"14":"Porque el día en que castigue los crímenes de Israel, castigaré los altares de Betel, serán rotos los cuernos del altar y caerán por tierra."
,"15":"Derribaré las casas de invierno, las casas de verano; desaparecerán los palacios de marfil, y las casas nobles serán destruidas, dice el Señor."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Escuchad esta palabra, vacas de Basán, que vivís en la montaña de Samaría; las que oprimís a los débiles, maltratáis a los pobres,y decís a vuestros maridos: 'Traed y bebamos'."
,"2":"El Señor Dios ha jurado por su santidad: Vendrán días sobre vosotras en que os levantarán con anzuelos,y a vuestra descendencia con arpones de pesca;"
,"3":"saldréis por las brechas de una en una,y seréis empujadas hacia el Hermón, dice el Señor."
,"4":"Id a Betel y pecad; a Guilgal y pecad más aún; por las mañanas ofreced vuestros sacrificios, y cada tres días vuestro diezmo;"
,"5":"quemad panes sin levadura en acción de gracias; pregonad vuestras ofrendas voluntarias, pregonadlas, israelitas, pues eso es lo que os gusta, dice el Señor."
,"6":"Yo no os dejé nada que llevar a la boca,en todas vuestras ciudades, os dejé sin pan en todos vuestros lugares, ¡y no habéis vuelto a mí!, dice el Señor. "
,"7":"También os negué la lluvia los tres meses antes de la siega, e hice llover sobre una ciudad y sobre otra no; en un campo llovió y otro campo se secó por falta de lluvia."
,"8":"Dos o tres ciudades iban corriendo a otra para beber agua, y no apagaban la sed; ¡y no habéis vuelto a mí!, dice el Señor. "
,"9":"Herí con tizón y añublo vuestros jardines y vuestras viñas; vuestras higueras y vuestros olivos los devoró la langosta, ¡y no habéis vuelto a mí!, dice el Señor."
,"10":"Envié contra vosotros una peste como la de Egipto, maté a espada a vuestra juventud,e hice subir el mal olor de vuestros campamentos,hasta vuestras narices; ¡y no habéis vuelto a mí!, dice el Señor."
,"11":"Causé entre vosotros desastres,como los causó el Señor en Sodoma y Gomorra, y fuisteis como un tizón salvado de un incendio; ¡y no habéis vuelto a mí!, dice el Señor."
,"12":"Por eso, te voy a tratar así, Israel; y porque te voy a tratar así, dispónte a comparecer ante tu Dios."
,"13":"Porque el que hizo las montañas y creó el viento, el que descubre al hombre sus pensamientos, el que hace la aurora y las tinieblas,y camina sobre las cumbres de la tierra,se llama el Señor, Dios omnipotente."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Escuchad esta palabra que pronuncio contra vosotros, un canto fúnebre, ¡oh casas de Israel! "
,"2":"La virgen de Israel cayó por tierra,y no hay quien la levante. "
,"3":"Porque esto dice el Señor, Dios: El pueblo que salía a la guerra con mil se quedará con cien; y el que salía con cien se quedará con diez."
,"4":"Esto dice el Señor a la casa de Israel: Buscadme y viviréis. "
,"5":"No busquéis a Betel, no vayáis a Guilgal, no paséis a Bersebá; porque Guilgal irá ciertamente al destierro, y Betel será aniquilada. "
,"6":"Buscad al Señor y viviréis, no sea que invada como el fuego la casa de José y devore a Betel, sin que haya quien la apague."
,"8":"Él ha hecho las Pléyades y el Orión, cambia en aurora las tinieblas y el día lo oscurece en noche; él llama a las aguas del mar,y las vierte sobre la superficie de la tierra; su nombre es el Señor. "
,"9":"Él trae la ruina sobre el hombre fuerte,y hace venir la destrucción sobre la fortaleza."
,"7":"¡Ay de los que convierten el derecho en ajenjo,y echan por tierra la justicia!"
,"10":"Odian al que llama al orden al tribunal, y aborrecen al que testifica la verdad."
,"11":"Pues bien, porque oprimís al pobre,y le imponéis tributo del grano, casas de piedra labradas habéis construido, pero no las habitaréis; habéis plantado viñas deliciosas, pero no beberéis su vino."
,"12":"Porque sé que son muchos vuestros crímenes,y enormes vuestras injusticias. Opresores del justo, os dejáis sobornar con dádivas,y atropelláis al pobre en el tribunal."
,"13":"Por eso el prudente calla en este tiempo, porque es tiempo de desgracia."
,"14":"Buscad el bien y no el mal, a fin de que viváis; así el Señor Dios omnipotente estará con vosotros, como decís."
,"15":"Odiad el mal y amad el bien, restableced la justicia en los tribunales, y quizá el Señor Dios omnipotente se apiade del resto de José."
,"16":"Por tanto, esto dice el Señor, Dios omnipotente: 'En todas las plazas habrá lamentos,y en todas las calles dirán: ¡Ay, ay! Y convocarán al campesino al duelo,y a lamentaciones a los expertos en ellas."
,"17":"En todas las viñas habrá lamentos,cuando yo pase en medio de ti', dice el Señor."
,"18":"¡Ay de los que ansían el día del Señor!,¿De qué os servirá el día del Señor?,Será tinieblas y no luz. "
,"19":"Como el hombre que huye del león, y le acosa un oso; entra en casa, pone su mano sobre la pared,y le muerde una serpiente."
,"20":"¿No es tiniebla el día del Señor y no luz; oscuridad en la cual no hay resplandor?"
,"21":"Odio, aborrezco vuestras fiestas, no me agradan vuestras solemnidades."
,"22":"Si me ofrecéis holocaustos y ofrendas, no los aceptaré; no me digno mirar el sacrificio de vuestros novillos cebados. "
,"23":"Aparta de mí el ruido de tus canciones; no quiero oír el sonido de la lira."
,"24":"Quiero que el derecho fluya como el agua, y la justicia como torrente perenne."
,"25":"¿Acaso ofrecisteis sacrificios,y ofrendas en el desierto durante cuarenta años?"
,"26":"Pero llevaréis a Sacut, vuestro rey, y a Keván, vuestro dios, vuestros ídolos, que os habéis fabricado,"
,"27":"pues yo os desterraré más allá de Damasco, dice el Señor, Dios omnipotente."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Ay de los que ponen su seguridad en Sión,y de los que confían en el monte de Samaría, los que se consideran los jefes del primero de los pueblos,y a los cuales viene la casa de Israel."
,"2":"Pasad a Calne y mirad; id desde allí a Jamat la grande, y bajad a Gat de los filisteos. ¿Sois vosotros acaso mejores que estos reinos,o es mayor vuestro territorio que el suyo?"
,"3":"Los que pensáis alejar el día de la desgracia,y aceleráis el reino de la violencia."
,"4":"Los que duermen sobre lechos de marfil, se recuestan sobre divanes, comen corderos del rebaño y terneros del establo."
,"5":"Los que cantan a gritos al son del arpa,y se inventan, como David, instrumentos de música;"
,"6":"los que beben el vino en ánforas,y se ungen con el perfume más fino, pero no se preocupan de la ruina de José."
,"7":"Por eso ahora irán desterrados a la cabeza de los cautivos,y cesará el júbilo de los sibaritas."
,"8":"El Señor Dios ha jurado por sí mismo, palabra del Señor, Dios omnipotente: Yo detesto la soberbia de Jacob y odio sus palacios; entregaré la ciudad y cuanto hay en ella;"
,"9":"y si quedan diez hombres en una casa, todos morirán."
,"10":"El pariente que saque los cadáveres de la casa,dirá al que está dentro de ella: '¿Hay alguno contigo?'. Responderá: 'Ninguno'. Él dirá: '¡Silencio!'. No pronunciemos el nombre del Señor."
,"11":"Pues el Señor lo ordena, y, a un golpe, la casa grande se desploma,y la pequeña se hunde."
,"12":"¿Acaso los caballos corren por la roca,o se ara con buey el mar?,Pues vosotros habéis convertido el derecho en veneno, y el fruto de la injusticia en ajenjo."
,"13":"Os regocijáis por nada, y decís: '¿No hemos tomado con nuestra fuerza a Carnáyim?'."
,"14":"Porque yo suscitaré contra vosotros, casa de Israel -oráculo del Señor, Dios omnipotente-, una nación que os oprimirá,desde la entrada de Jamat hasta el torrente de la Arabá."
}`)
	CurrentBook.AddChapter(7, `{
"1":"El Señor Dios me hizo ver esto: Él producía langostas al comenzar a crecer el heno tardío, el heno después de la corta del rey."
,"2":"Terminaban ellas de comer la hierba de la tierra, cuando yo dije: '¡Señor Dios, perdona, te ruego!,¿Cómo podrá subsistir Jacob, siendo tan pequeño?'."
,"3":"Por esto el Señor se arrepintió,y dijo: 'No sucederá'."
,"4":"El Señor me hizo ver esto: Él suscitaba una llama de fuego que devoraba el gran abismo,e iba a devorar la porción del Señor."
,"5":"Y dije: 'Señor Dios, cesa, por favor. ¿Cómo podrá subsistir Jacob, siendo tan pequeño?'."
,"6":"Por esto el Señor se arrepintió,y dijo: 'No sucederá'."
,"7":"El Señor me hizo ver esto: El Señor Dios estaba sobre un muro vertical, y en su mano tenía una plomada."
,"8":"El Señor me dijo: '¿Qué ves, Amós?'. Respondí: 'Una plomada'. Y el Señor me dijo: 'Pongo la plomada en medio de mi pueblo Israel, y no le perdonaré por más tiempo. "
,"9":"Serán devastadas las colinas de Isaac, los santuarios de Israel serán destruidos,y me alzaré con la espada contra la casa de Jeroboán'."
,"10":"Amasías, sacerdote de Betel, mandó a decir a Jeroboán, rey de Israel: 'Amós conspira contra ti en medio de la casa de Israel; la tierra no puede soportar todas sus palabras."
,"11":"Amós ha dicho: Jeroboán morirá a espada,e Israel será llevado cautivo lejos de su tierra'."
,"12":"Amasías dijo a Amós: 'Vidente, vete, retírate a la tierra de Judá; come allí el pan y allí profetiza."
,"13":"Pero en Betel no continúes profetizando, porque es santuario del rey y templo del reino'."
,"14":"Entonces Amós dijo a Amasías: 'Yo no soy profeta ni hijo de profeta; yo soy boyero y descortezador de sicómoros."
,"15":"El Señor me tomó de detrás del rebaño, diciéndome: Vete, profetiza a mi pueblo Israel."
,"16":"Y ahora escucha la palabra del Señor. Tú dices: No profetices contra Israel, y no vaticines contra la casa de Isaac."
,"17":"Pues bien, esto dice el Señor: Tu mujer se prostituirá en la ciudad, tus hijos e hijas caerán a espada, tu tierra será repartida a cordel, tú morirás en tierra impura,e Israel será llevado cautivo lejos de su tierra'."
}`)
	CurrentBook.AddChapter(8, `{
"1":"El Señor Dios me hizo ver esto: Una canasta de frutas maduras."
,"2":"Y me dijo: '¿Qué ves, Amós?'. Yo contesté: 'Una canasta de frutas maduras'. El Señor me dijo: 'Viene el fin sobre mi pueblo Israel; no le perdonaré más tiempo'."
,"3":"En aquel día los cánticos del templo,se convertirán en aullidos, -dice el Señor, Dios-. Serán muchos los cadáveres; silenciosamente se los arrojará en cualquier lugar."
,"4":"Escuchad esto, los que aplastáis al pobre,e intentáis exterminar a los necesitados,"
,"5":"vosotros, que decís: '¿Cuándo pasará la luna nueva, para que podamos vender el trigo, y el sábado, para que despachemos el grano?,Disminuiremos la medida y aumentaremos el precio, falsearemos las balanzas para engañar; "
,"6":"compraremos al pobre por dinero,y al miserable por un par de sandalias; venderemos el salvado del trigo'."
,"7":"El Señor lo ha jurado por el orgullo de Jacob: Jamás me olvidaré de ninguna de vuestras obras."
,"8":"A causa de esto, ¿no se estremecerá la tierra,y harán duelo cuantos en ella habitan?,¿No crecerá toda ella como el Nilo,y menguará como el río de Egipto?"
,"9":"En aquel día, dice el Señor Dios, haré ponerse el sol al mediodía,y en pleno día oscureceré la tierra."
,"10":"Cambiaré en duelo vuestras fiestas,y en lamentos todos vuestros cánticos; cubriré de saco todos vuestros lomos,y toda cabeza de calvicie; haré de este duelo un duelo de hijo único, y su final será como día de amargura."
,"11":"Vienen días, dice el Señor Dios, en que enviaré el hambre al país; no hambre de pan, no sed de agua, sino de oír la palabra del Señor."
,"12":"Y andarán errantes de mar a mar, y del norte al este, buscando la palabra del Señor, y no la encontrarán."
,"13":"En aquel día desfallecerán de sed las bellas muchachas,y los jóvenes apuestos."
,"14":"Los que juran por el pecado de Samaría, los que dicen: '¡Vive tu Dios, Dan!',y '¡Vive el camino de Berseba!',caerán y no se levantarán más."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Vi al Señor de pie junto al altar, y dijo: 'Golpea los capiteles,y que tiemblen los umbrales; destroza a los que van en cabeza; a los que siguen yo los mataré a espada; nadie podrá huir, y ningún fugitivo se salvará."
,"2":"Si se ocultan en el abismo, de allí los sacará mi mano; si suben hasta el cielo, de allí los haré bajar; "
,"3":"si se esconden en la cima del Carmelo, allí los buscaré,y los mataré; si se ocultan a mis ojos en el fondo del mar, allí mandaré a la serpiente que los muerda;"
,"4":"si van cautivos delante de sus enemigos, ordenaré a la espada que los mate; yo pondré mis ojos sobre ellos,para su mal y no para su bien."
,"5":"El Señor, Dios todopoderoso...  el que toca la tierra y se funde, y se entristecen todos sus habitantes; crece toda ella como el Nilo,y mengua como el río de Egipto."
,"6":"El que edifica en el cielo su trono, y asienta sobre la tierra la bóveda celeste; el que llama a las aguas del mar,y las vierte sobre la superficie de la tierra, su nombre es el Señor."
,"7":"¿No sois para mí como etíopes, israelitas?, dice el Señor. ¿No saqué a Israel de Egipto, a los filisteos de Creta y a los sirios de Quir?"
,"8":"Los ojos del Señor Dios están sobre el reino pecador, y lo aniquilaré sobre la superficie de la tierra; sin embargo, no exterminaré completamente a la casa de Jacob, dice el Señor."
,"9":"Voy a dar órdenes de zarandear a la casa de Israel,por todas las naciones como se zarandea en el cedazo, y ni una piedrecita caerá a tierra."
,"10":"A espada morirán todos los pecadores de mi pueblo, los que dicen: 'No se acercará a nosotros,ni nos alcanzará la desgracia'."
,"11":"En aquel día levantaré la choza caída de David, repararé sus brechas, reedificaré sus ruinas,y la reconstruiré como en otros tiempos,"
,"12":"para que reconquisten el resto de Edón y todas las naciones,sobre las que se invoca mi nombre, dice el Señor, que hace esto."
,"13":"Vienen días, dice el Señor, en los cuales el que siega irá detrás del que ara, el que pisa la uva seguirá al que esparce la semilla, los montes chorrearán mosto,y todos los collados se derretirán."
,"14":"Yo reconduciré el resto de mi pueblo, Israel, y reconstruirán las ciudades derruidas,y las habitarán, plantarán viñas,y beberán su vino, harán huertos y comerán sus frutos."
,"15":"Los plantaré en su tierra,y no serán más arrancados de su tierra, la que yo les he dado, dice el Señor, tu Dios."
}`)

}
func ES_LSB_LoadVNHAChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Oráculo que tuvo en visión el profeta Habacuc."
,"2":"¿Hasta cuándo, Señor, pediré auxilio sin que tú escuches?,Yo te grito: '¡Violencia!', y tú no salvas."
,"3":"¿Por qué me haces ver tantas injusticias,y tú aceptas el espectáculo de la opresión?,Ante mí no hay más que robos y violencia, por todas partes hay querellas y discordias."
,"4":"La ley no se aplica, no triunfa la justicia. El malvado cerca al justo, y el derecho es conculcado."
,"5":"Mirad a las gentes y observad; quedaréis maravillados y asombrados, pues va a realizarse en vuestros días,una obra que no creeríais si alguno os la contara."
,"6":"Voy a poner en pie de guerra a los caldeos, ese pueblo cruel e impetuoso, que recorre la anchura de la tierra,para apoderarse de moradas ajenas."
,"7":"Es espantoso y terrible; su fuerza y su derecho es su grandeza."
,"8":"Más veloces que leopardos sus caballos, más feroces que lobos nocturnos; sus jinetes llegan al galope, vienen volando de lejos sus jinetes, como águila que cae en picado sobre la presa."
,"9":"Todos vienen para saquear; el ardor de su cara es como el viento del este, amontonan cautivos como arena."
,"10":"Esa gente se ríe de los reyes, y se burla de los príncipes; las fortalezas son para ellos como un juego, levantan terraplenes y las toman."
,"11":"Luego cambia el viento y desaparecen; criminales, cuya fuerza es su dios."
,"12":"¿No eres tú el Señor desde el principio, mi Dios, mi santo?,Tú eres inmortal. Señor, tú los has puesto para ejercer el derecho, los has establecido para hacer justicia."
,"13":"Tus ojos son demasiado puros para mirar el mal; tú no puedes aceptar el espectáculo de la opresión; ¿por qué aceptas entonces el espectáculo de los criminales, por qué guardas silencio,cuando un criminal devora a uno más justo que él?"
,"14":"Tú tratas a los hombres,como a los peces del mar, como a los reptiles que no tienen amo."
,"15":"Él los saca a todos con el anzuelo, los atrae en su red, los recoge en el copo,y de ello se alegra y regocija."
,"16":"Por eso ofrece sacrificios a su red,e incienso a su copo: porque gracias a ellos su pesca es abundante, y suculenta su comida."
,"17":"¿Seguirán los caldeos vaciando sus redes, asesinando sin piedad a los pueblos?"
}`)
	CurrentBook.AddChapter(2, `{
"1":"Yo estaré en mi puesto de guardia, me situaré en la torre, y estaré alerta para ver lo que él me dice, lo que responde a mi lamento."
,"2":"Y el Señor me respondió: 'Escribe la visión, grábala en tablillas, para que pueda leerse con facilidad;"
,"3":"pues es aún una visión para una fecha fija, llegará a su término y no fallará; si tarda, espérala, pues llegará en el momento preciso'."
,"4":"El que no es justo sucumbirá, pero el justo por su fidelidad vivirá."
,"5":"El vino es ciertamente traicionero; así el hombre soberbio no resiste en pie; el que ensancha como el abismo sus fauces,y es insaciable como la muerte,querría adueñarse de todas las naciones, tener a todos los pueblos bajo su dominio."
,"6":"Pero todos éstos se burlarán de él,diciéndole con mordaz ironía: ¡Ay de quien multiplica lo que no es suyo,-¿hasta cuándo?-, y se carga de un montón de prendas!"
,"7":"Tus acreedores llegarán de repente, tus exactores se despertarán,y tú pasarás a ser su presa."
,"8":"Porque has saqueado a muchos pueblos, los que queden de esos pueblos te saquearán a ti, por la sangre humana derramada,y la violencia hecha al país, a la ciudad y a todos sus habitantes."
,"9":"¡Ay de quien llena la casa de ganancias injustas,para poner su nido en alto,y escapar a la garra del mal!"
,"10":"Has preparado la deshonra de tu casa; aniquilando a muchos pueblos, has atentado contra tu propia vida."
,"11":"Sí, las piedras de los muros gritarán,y las vigas del maderamen responderán."
,"12":"¡Ay de quien edifica una ciudad sobre la sangre,y funda una ciudad sobre el crimen!"
,"13":"¿Es que no depende del Señor omnipotente,que los pueblos trabajen para el fuego,y las naciones se afanen para nada?"
,"14":"Pues la tierra se llenará del conocimiento,de la gloria del Señor como las aguas llenan el mar."
,"15":"¡Ay del que da de beber a su prójimo,y le echa veneno hasta embriagarle para contemplar su desnudez!"
,"16":"¡Te has saciado de infamia, no de gloria!,¡Bebe tú también y muestra tu prepucio!,A ti pasa la copa de la diestra del Señor, y después de la gloria viene la vergüenza."
,"17":"Pues la violencia hecha en el Líbano te cubrirá,y las matanzas de los animales te aterrarán,por la sangre humana derramada,y la violencia hecha al país, a la ciudad y a todos sus habitantes."
,"18":"¿De qué sirve una escultura esculpida por el artista, una imagen fundida, oráculo engañoso, para que el que lo ha hecho,ponga en ellos su confianza, fabricando ídolos mudos?"
,"19":"¡Ay de quien dice al leño: 'Despierta'!; a la piedra muda: '¡Levántate!'. ¡Éste es el oráculo!,Sí, cubierta está de oro y plata, pero no tiene soplo alguno de vida."
,"20":"El Señor, en cambio, está en su santo templo; silencio ante él, tierra entera."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Oración del profeta Habacuc. En el tono de las lamentaciones."
,"2":"¡Señor, he conocido tu fama; Señor, tengo un gran respeto por tu obra!,¡Hazla revivir en nuestro tiempo, en nuestro tiempo dala a conocer,y en la ira acuérdate de compadecerte!"
,"3":"Dios viene de Temán, el santo del monte Farán; su majestad cubre los cielos,y de su gloria está llena la tierra."
,"4":"Su esplendor es semejante al día, rayos saltan de sus propias manos, allí se oculta su poder."
,"5":"Delante de él camina la peste, la fiebre sigue tras sus pasos."
,"6":"Se alza él, y hace temblar la tierra; mira, y las naciones se estremecen; los montes eternos se dislocan, los collados antiguos se deshacen, pero sus caminos son eternos."
,"7":"Veo en angustias las tiendas de Cusán, estremecidos los pabellones de Madián."
,"8":"¿Es que te has enfurecido, Señor, contra los ríos; es que te has irritado contra el mar, para que montes en tus caballos,y en tus carros victoriosos?"
,"9":"Tú preparas tu arco, llenas de flechas la aljaba. Tú surcas la tierra de torrentes."
,"10":"Te ven los montes y tiemblan, un diluvio de agua irrumpe, el abismo deja oír su voz, levanta a lo alto sus manos."
,"11":"El sol y la luna permanecen,en su morada a la luz de las flechas, a los fulgores de tu lanza."
,"12":"Con tu furor pisas la tierra, aplastas con tu ira a las naciones."
,"13":"Sales a salvar a tu pueblo, a salvar a tu ungido. Tú destruyes la casa del malvado, pones al desnudo sus cimientos,hasta la roca."
,"14":"Traspasas con tus dardos la cabeza,de sus guerreros, que se lanzan como un turbión,y se dispersan entre algazara, como si fuesen a devorar,al pobre en su cubil."
,"15":"Tú lanzas tus caballos en el mar, en el oleaje de las inmensas aguas."
,"16":"He oído, y estoy profundamente,conmovido; a tu voz tiemblan mis labios; estoy completamente descompuesto, mis pasos vacilan al andar. Tranquilo espero el día de la angustia, que ha de caer sobre el pueblo,que nos asalta."
,"17":"Pues la higuera no volverá a echar brotes, ni habrá más frutos en las viñas; los campos no darán nada que comer, faltará la oveja en el aprisco,y en los establos no habrá vacas."
,"18":"Pero yo me alegraré en el Señor; me gozaré en Dios, mi salvador."
,"19":"El Señor es mi Señor, él es mi fuerza; él hace mis pies,como los de las ciervas,y me hace caminar por las alturas."
}`)

}
func ES_LSB_LoadVNILChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Palabra del Señor que fue dirigida a Joel, hijo de Petuel."
,"2":"Oíd esto, ancianos; escuchad, habitantes todos del país. ¿Ha sucedido algo semejante en vuestros días,o en los días de vuestros padres?"
,"3":"Contádselo a vuestros hijos, y vuestros hijos a sus hijos,y sus hijos a la generación futura. "
,"4":"Lo que dejó el saltamontes lo devoró la langosta, lo que dejó la langosta lo devoró el cigarrón, lo que dejó el cigarrón lo devoró la caballeta. "
,"5":"¡Despertaos, borrachos, y llorad; gemid, bebedores de vino, por el vino,que se os ha quitado de la boca! "
,"6":"Porque un pueblo ataca a mi país, poderoso e innumerable; dientes de león son sus dientes, y tiene muelas de leona. "
,"7":"Ha devastado mi viñedo, ha destrozado mis higueras; lo ha pelado todo, lo ha tirado por tierra,y sus ramas han quedado blancas. "
,"8":"¡Laméntate como una virgen vestida de luto,por el esposo de su juventud!"
,"9":"Sacrificio y ofrenda han desaparecido de la casa del Señor. Los sacerdotes, ministros del Señor, hacen duelo."
,"10":"Devastado está el campo, en duelo está la tierra, el trigo ha sido asolado, ha faltado el mosto,y se ha agotado el aceite. "
,"11":"Consternaos, campesinos; lamentaos, viñadores, por el trigo y la cebada; perdida está la cosecha del campo. "
,"12":"Se ha secado el viñedo, se ha agostado la higuera, el granado, la palmera, el manzano, todos los árboles del campo están secos. ¡Ha desaparecido la alegría entre los hombres!"
,"13":"Vestíos de luto; lamentaos, sacerdotes; lanzad gritos, ministros del altar; venid, pasad la noche en sacos, ministros de mi Dios, porque la casa de vuestro Dios,se ha quedado sin sacrificio y sin ofrenda. "
,"14":"Promulgad un ayuno, convocad una asamblea, reuníos, ancianos, y vosotros todos, habitantes del país, en la casa del Señor, Dios vuestro; aclamad al Señor:"
,"15":"¡Ay, qué día; cercano está el día del Señor; que viene como devastación del todopoderoso!"
,"16":"¿No veis cómo falta la comida, la alegría,y el júbilo de la casa de nuestro Dios?"
,"17":"Se ha podrido la semilla en los surcos, los silos están en ruinas y los graneros vacíos, pues no ha habido cosecha."
,"18":"¡Cómo gime el ganado, cómo vagan sin rumbo,los rebaños de vacas porque no tienen pastos!,Hasta los rebaños de ovejas perecen."
,"19":"A ti clamo, Señor, porque el fuego ha devorado,los pastizales del desierto, la llama ha consumido todos los árboles del campo."
,"20":"Hasta las bestias salvajes se vuelven hacia ti, porque se han secado las corrientes de agua,y el fuego ha devorado los pastizales del desierto."
}`)
	CurrentBook.AddChapter(2, `{
"1":"¡Tocad la trompeta en Sión, dad la alarma sobre mi monte santo; tiemblen todos los habitantes del país, porque llega el día del Señor, porque está cerca! "
,"2":"¡Día de oscuridad y de tiniebla, día de nubes y de niebla espesa!,Como de monte en monte va la aurora; avanza un pueblo numeroso y fuerte, como jamás ha existido,y como no habrá más en los años lejanos. "
,"3":"Ante él devora un fuego, detrás de él una llama abrasa. Si antes de su llegada era el país un jardín del Edén, después que pase será un desierto desolado; nada escapará a su furor. "
,"4":"Aspecto de corceles es su aspecto; como jinetes, así corren. "
,"5":"Como un estrépito de carros que saltan,sobre las cimas de los montes, como el crujir de la llama que devora el rastrojo: un pueblo poderoso puesto en orden de batalla. "
,"6":"Ante él se estremecen los pueblos, todos los rostros palidecen. "
,"7":"Corren como valientes, como guerreros escalan las murallas; cada uno marcha por su camino, no se desvían de su ruta. "
,"8":"Nadie tropieza con su vecino, cada cual va por su calzada; pasan a través de los dardos sin romper las filas. "
,"9":"Se precipitan sobre la ciudad, corren por la muralla; escalan las casas, por las ventanas entran como los ladrones."
,"10":"Ante ellos tiembla la tierra, se estremecen los cielos; el sol y la luna se oscurecen y las estrellas pierden su brillo."
,"11":"El Señor da la voz al frente de sus tropas. Sí, innumerable es su ejército, poderoso el ejecutor de su palabra; sí, grande es el día del Señor, muy terrible; ¿quién podrá soportarlo?"
,"12":"Y ahora -dice el Señor- volved a mí,de todo corazón con ayunos, llantos y lamentos; "
,"13":"desgarrad vuestro corazón, no vuestros vestidos; volved al Señor, vuestro Dios, porque él es clemente y misericordioso, lento a la ira, lleno de lealtad y no le gusta hacer daño."
,"14":"¡Quién sabe si cambiará de idea,y dejará tras de sí una bendición, ofrendas para el Señor, vuestro Dios! "
,"15":"¡Tocad la trompeta en Sión, proclamad un ayuno sagrado, convocad una asamblea, "
,"16":"reunid al pueblo, congregad a la comunidad, juntad a los ancianos, traed también a los pequeños y a los niños de pecho!,Deje el esposo su alcoba y la esposa su tálamo."
,"17":"Que entre el vestíbulo y el altar,lloren los sacerdotes, ministros del Señor, y digan: 'Perdona a tu pueblo, Señor, y no entregues tu heredad al oprobio, a la burla de las gentes. ¿Por qué se ha de decir entre los pueblos: Dónde está su Dios?'."
,"18":"El Señor se mostró celoso de su tierra,y perdonó a su pueblo."
,"19":"Respondió a su pueblo: 'Yo os mandaré vino, trigo y aceite; os hartaréis de ello, y no haré más de vosotros la burla de las gentes. "
,"20":"El azote que viene del norte lo alejaré de vosotros,y lo guiaré hacia una tierra árida y desolada: su vanguardia hacia el mar oriental, y hacia el mar occidental su retaguardia. Y subirá su mal olor y subirá su fetidez; sí, él ha hecho grandes cosas'."
,"21":"No temas tierra, alégrate y regocíjate, pues el Señor ha hecho grandes cosas."
,"22":"No temáis, bestias del campo, pues ya reverdecen los pastizales del desierto, los árboles producen su fruto, la higuera y la vid dan su riqueza. "
,"23":"Y vosotros, gentes de Sión, alegraos y regocijaos en el Señor, vuestro Dios, porque él os da la lluvia de otoño con justa medida, hace caer sobre vosotros la lluvia de otoño,y la de primavera como anteriormente. "
,"24":"Las eras se llenarán de trigo,y los lagares rebosarán de vino y de aceite."
,"25":"Yo os compensaré de los años,en que os devoraron el saltamontes, la langosta, el cigarrón y la caballeta, mi gran ejército que envié contra vosotros."
,"26":"Comeréis hasta hartaros, y alabaréis el nombre del Señor, vuestro Dios, que ha obrado con vosotros maravillas. Nunca más mi pueblo será cubierto de vergüenza."
,"27":"Sabréis que en medio de Israel estoy yo; que yo, el Señor, soy vuestro Dios y no hay otro. Nunca más mi pueblo será cubierto de vergüenza."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Después de esto yo derramaré mi espíritu,sobre todos los hombres. Vuestros hijos y vuestras hijas profetizarán, vuestros ancianos tendrán sueños, y vuestros jóvenes, visiones. "
,"2":"Hasta en los esclavos y las esclavas,derramaré mi espíritu aquellos días."
,"3":"Haré aparecer señales en el cielo y en la tierra: sangre, fuego y columnas de humo. "
,"4":"El sol se cambiará en tinieblas, y la luna en sangre, antes que venga el día del Señor, grande y glorioso."
,"5":"Pero el que invoque el nombre del Señor se salvará; porque en el monte Sión y en Jerusalén estará el grupo de salvados, como ha dicho el Señor, y entre los supervivientes estarán los que llame el Señor."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Porque en aquel tiempo, cuando yo restaure Judá y Jerusalén,"
,"2":"reuniré a todas las naciones y las haré bajar al valle de Josafat, y allí las juzgaré por lo que hicieron con mi pueblo Israel, a quien dispersaron entre las gentes, y con mi tierra, que se repartieron."
,"3":"Porque echaron suertes sobre mi pueblo, cambiaron al muchacho por una prostituta, vendieron a sus hijas por vino y se dieron a beber."
,"4":"Y vosotros, ¿qué tenéis que ver conmigo, Tiro, Sidón y regiones todas de Filistea? ¿Me vais a pedir cuentas acaso de mi proceder? ¿Queréis vengaros de mí? Entonces rápidamente haré recaer la venganza sobre vuestra cabeza:"
,"5":"vosotros, que robasteis mi plata y mi oro; que llevasteis mis más preciados tesoros a vuestros palacios;"
,"6":"que vendisteis a los habitantes de Judá y de Jerusalén a los griegos, alejándolos de su país."
,"7":"Mirad, yo los reclamaré del lugar en que los vendisteis y haré recaer vuestros delitos sobre vuestra cabeza."
,"8":"Daré vuestros hijos y vuestras hijas a los habitantes de Judá, y ellos los venderán al lejano pueblo de los sabeos. Lo ha dicho el Señor."
,"9":"Publicad esto entre las naciones. Declarad la guerra santa, llamad a los valientes; que vengan, que salgan todos los guerreros;"
,"10":"haced espadas de vuestras azadas,y lanzas de vuestras podaderas. Que el cobarde diga: '¡Soy un valiente!'."
,"11":"Aprisa; venid todos vosotros, pueblos circundantes, y reuníos allá. Señor, haz bajar a tus valientes. "
,"12":"Que se pongan en marcha las naciones,camino del valle de Josafat. Allí me sentaré yo para juzgar a todos los pueblos circundantes."
,"13":"Meted la hoz, porque la mies está madura; venid, pisad, porque el lagar está lleno, las cubas rebosan, ¡tan grande es su maldad!"
,"14":"¡Multitudes y multitudes en el valle de la Decisión!,Porque está cerca el día del Señor en el valle de la Decisión."
,"15":"El sol y la luna se oscurecen, las estrellas pierden su brillo. "
,"16":"El Señor ruge desde Sión, hace oír su voz desde Jerusalén, y el cielo y la tierra se estremecen. Pero el Señor será un refugio para su pueblo, una fortaleza para los israelitas. "
,"17":"Entonces sabréis que yo soy el Señor vuestro Dios, que habito en Sión, mi monte santo. Jerusalén será un lugar santo; no pasarán más por allí los extranjeros."
,"18":"Aquel día los montes destilarán vino nuevo, las colinas manarán leche, y por todos los ríos de Judá correrán las aguas. De la casa del Señor saldrá una fuente,que regará el valle de las Acacias. "
,"19":"Egipto quedará hecho un desierto, Edón una estepa desolada por la violencia,hecha a los habitantes de Judá, por haber derramado sangre inocente en su propia tierra."
,"20":"Pero Judá será habitada para siempre, y Jerusalén de edad en edad."
,"21":"Yo vengaré su sangre, no la dejaré impune, y el Señor habitará en Sión."
}`)

}
func ES_LSB_LoadVNINChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"El Señor dijo a Jonás, hijo de Amitay:"
,"2":"'Levántate, vete a Nínive, la gran ciudad, y anúnciales que su maldad ha llegado hasta mí'."
,"3":"Jonás partió, pero para huir a Tarsis, lejos del Señor. Llegó a Jafa, donde encontró una nave que se dirigía a Tarsis; pagó su pasaje y se embarcó para ir con ellos a Tarsis, huyendo de la presencia del Señor."
,"4":"Pero el Señor desencadenó un fuerte viento sobre el mar, y hubo una borrasca tan violenta que parecía que la nave iba a hacerse pedazos."
,"5":"Los marineros, aterrados, comenzaron a invocar cada uno a su dios; luego echaron al mar la carga para aligerar el peso. Jonás, mientras tanto, que había bajado al fondo de la nave, se había acostado y dormía profundamente."
,"6":"El capitán se acercó a él y le dijo: '¿Qué haces aquí durmiendo? Levántate e invoca a tu Dios; a lo mejor ese Dios se preocupa de nosotros y no pereceremos'."
,"7":"Luego los marineros se dijeron unos a otros: 'Echemos suertes para saber quién es la causa de esta desgracia'. Echaron suertes, y la suerte cayó en Jonás."
,"8":"Entonces le dijeron: 'Dinos el motivo de esta desventura. ¿Cuál es tu profesión? ¿De dónde vienes? ¿Cuál es tu país? ¿De qué pueblo eres?'."
,"9":"Él respondió: 'Soy hebreo y adoro al Señor, Dios del cielo, que hizo el mar y la tierra'."
,"10":"Aquellos hombres, llenos de miedo, le dijeron: '¿Por qué has hecho esto?'. (Por lo que había dicho sabían que huía de la presencia del Señor)."
,"11":"Luego le dijeron: '¿Qué tenemos que hacer contigo para que el mar se calme?', pues el mar se embravecía cada vez más."
,"12":"Respondió: 'Agarradme y tiradme al mar, y éste se calmará, porque sé bien que por culpa mía os ha sobrevenido esta borrasca'."
,"13":"Los hombres trataron de alcanzar la costa a remo, pero en vano, porque el mar seguía encrespándose contra ellos."
,"14":"Entonces clamaron al Señor y dijeron: 'Señor, no nos hagas perecer por la vida de este hombre ni nos hagas responsables de sangre inocente, ya que tú, Señor, puedes hacer lo que quieras'."
,"15":"Luego agarraron a Jonás y lo tiraron al mar, y el mar se calmó."
,"16":"Entonces aquellos hombres cobraron un gran respeto al Señor, le ofrecieron un sacrificio y le hicieron promesas."
}`)
	CurrentBook.AddChapter(2, `{
"1":"El Señor hizo que un gran pez tragase a Jonás, y Jonás estuvo en el vientre del pez tres días y tres noches."
,"2":"Desde el vientre del pez Jonás oró al Señor así:"
,"3":"'Clamé al Señor en mi angustia, y él me atendió; desde el vientre del abismo grité, tú escuchaste mi voz."
,"4":"Tú me arrojaste en el abismo, en el fondo del mar, y las olas me envolvieron; todo tu oleaje, todas tus ondas han pasado sobre mí."
,"5":"Yo dije: ¡Soy rechazado lejos de tus ojos! ¿Cómo podré volver a contemplar tu santo templo?"
,"6":"Las aguas me envolvían hasta ahogarme, el abismo se cerraba sobre mí, las algas enredaban mi cabeza."
,"7":"Bajaba hasta las raíces de los montes. Yo ya me veía su eterno prisionero; pero tú, Señor, Dios mío, me salvaste de la muerte."
,"8":"En la angustia de mi alma me acordé del Señor, y mi oración llegó hasta ti, hasta tu santo templo."
,"9":"Los que adoran vanos ídolos dejan de ser leales."
,"10":"Pero yo, en acción de gracias, te ofreceré sacrificios y cumpliré las promesas que te hice. La salvación viene del Señor'."
,"11":"El Señor dio orden al pez, el cual vomitó a Jonás en la playa."
}`)
	CurrentBook.AddChapter(3, `{
"1":"De nuevo el Señor dijo a Jonás:"
,"2":"'Levántate, vete a Nínive, la gran ciudad, a predicar lo que yo te diga'."
,"3":"Jonás se puso en marcha y se dirigió a Nínive, conforme a la orden del Señor. Nínive era una ciudad extraordinariamente grande; para recorrerla hacían falta tres días."
,"4":"Jonás entró en la ciudad, caminando durante una jornada y predicando así: 'Dentro de cuarenta días Nínive será destruida'."
,"5":"Los ninivitas creyeron a Dios y ordenaron un ayuno; se vistieron de saco chicos y grandes."
,"6":"El rey de Nínive, al enterarse, se levantó de su trono, se quitó el manto, se vistió de saco y se sentó en el suelo."
,"7":"Y por orden del rey y de sus magnates se publicó en Nínive este bando: 'Hombres y bestias, ganado mayor y menor no probarán bocado, no pastarán, ni beberán agua."
,"8":"Que se cubran de saco los hombres y los animales, y que invoquen a Dios con fuerza; que cada uno se convierta de su mala conducta y de la violencia de sus manos."
,"9":"A lo mejor Dios cambia de parecer, se aplaca el ardor de su ira y no perecemos'."
,"10":"Al ver Dios lo que hacían y cómo se habían convertido de su mala conducta, tuvo compasión de ellos y no llevó a cabo el mal con el que los había amenazado."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Esto le sentó mal a Jonás; se enfadó mucho"
,"2":"y se encaró así con el Señor: 'Ah, Señor, ¿no lo decía yo ya cuando estaba todavía en mi tierra? ¿Y no fue por esto por lo que me apresuré a ir a Tarsis? Yo sabía que tú eres un Dios clemente, misericordioso y paciente, lleno de compasión y pronto a arrepentirte de las amenazas."
,"3":"Ahora, Señor, te suplico que me quites la vida, porque mejor es para mí morir que vivir'."
,"4":"El Señor le dijo: '¿Piensas que tienes razón al enfadarte?'."
,"5":"Jonás salió de la ciudad y se estableció al oriente de la misma, donde se hizo una cabaña y se sentó a su sombra hasta ver qué sucedía a la ciudad."
,"6":"El Señor hizo brotar una planta de ricino, que creció sobre Jonás para dar sombra a su cabeza y librarle así de una insolación. Jonás experimentó gran alegría por aquel ricino."
,"7":"Pero al día siguiente, al rayar el alba, el Señor mandó un gusano que picó el ricino, el cual se secó."
,"8":"Al salir el sol, Dios mandó un viento sofocante del este, y el sol abrasador caía sobre la cabeza de Jonás, el cual, a punto de desvanecerse, se deseaba la muerte y decía: 'Más vale morir que vivir'."
,"9":"Pero Dios dijo a Jonás: '¿Piensas que tienes razón al enfadarte por este ricino?'. Él respondió: 'Sí, tengo razón de enfadarme hasta la muerte'."
,"10":"El Señor le dijo: 'Tú te enfadas por un ricino que no te ha costado fatiga alguna, que no has hecho tú crecer, que en una noche ha nacido y en una noche ha muerto,"
,"11":"¿y no voy a tener yo compasión de Nínive, en la que hay más de ciento veinte mil personas que no saben distinguir su derecha de su izquierda, y una gran cantidad de animales?'."
}`)

}
func ES_LSB_LoadVNMIChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Palabra del Señor dirigida a Miqueas, de Moréset, en tiempo de Jotán, Acaz y Ezequías, reyes de Judá. Sus visiones sobre Samaría y Jerusalén."
,"2":"Escuchad, pueblos todos, presta oído, tierra y todo cuanto te llena; el Señor va a testificar contra vosotros, el Señor desde su santo templo."
,"3":"Ved que el Señor sale de su morada, baja y camina sobre las cumbres de la tierra."
,"4":"Bajo sus pasos los montes se derriten, se disuelven los valles como la cera al fuego, como aguas precipitadas en una pendiente."
,"5":"Todo esto por la rebeldía de Jacob, por los pecados de la casa de Israel. ¿Cuál es la rebeldía de Jacob? ¿No es acaso Samaría?,¿Cuál es el pecado de Judá? ¿No es acaso Jerusalén?"
,"6":"Haré de Samaría un montón de piedras en el campo, un lugar para plantar viñas. Haré rodar sus piedras en el valle, pondré al desnudo sus cimientos."
,"7":"Todos sus ídolos serán despedazados, todos sus salarios de prostitución quemados al fuego, todos sus ídolos los dejaré deshechos; han sido amasados con salario de prostituta, y en salario de prostituta se convertirán."
,"8":"Por eso me lamentaré y gritaré, andaré descalzo y desnudo, lanzaré aullidos como los chacales, y lamentos como las avestruces."
,"9":"Porque su herida es incurable, hasta Judá ha llegado; ha herido hasta la capital de mi pueblo, hasta Jerusalén."
,"10":"No lo contéis en Gat, no lloréis en Aco, en Bet Leafrá revolveos en el polvo."
,"11":"Tocad el cuerno, habitantes de Safir; no han salido de sus muros los habitantes de Saanán. Bet-ha-Esel ha sido destruida desde sus cimientos, desde sus firmes bases."
,"12":"¿Cómo podrá esperar el bien la que habita en Marot?,Porque ha llegado la desgracia de parte del Señor,a las puertas de Jerusalén."
,"13":"Unce al carro los corceles, tú que habitas en Laquis, origen de los pecados de la hija de Sión, porque en ti se han encontrado las rebeliones de Israel."
,"14":"Por eso habrás de renunciar a Moréset-Gat; Bet-Aczib será una desilusión para los reyes de Israel."
,"15":"También a vosotros os traeré un conquistador, habitantes de Maresá. Hasta Adulán llegará la gloria de Israel."
,"16":"Arráncate el cabello, rasúrate por tus hijos queridos, ensancha tu calva como la del buitre, porque han sido desterrados lejos de ti."
}`)
	CurrentBook.AddChapter(2, `{
"1":"¡Ay de aquellos que planifican injusticias, preparan el mal en sus lechos,y lo llevan a cabo apenas despunta la mañana,porque tienen el poder en sus manos!"
,"2":"Codician campos y los roban, casas y se apoderan de ellas; hacen violencia al hombre y a su casa, al dueño y a su propiedad."
,"3":"Por eso dice el Señor: 'Yo también planifico una desgracia contra esta ralea, de la que no podréis librar vuestro cuello. No andaréis más con la cabeza erguida, porque será un tiempo de desgracia'."
,"4":"Aquel día se contará sobre vosotros un proverbio, se cantará una elegía,y se dirá: '¡Estamos totalmente arruinados!,Se ha vendido la porción de mi pueblo, y nadie ya la restituye. ¡Entre los apóstatas se reparten nuestros campos!'."
,"5":"Por eso no habrá en ti ninguno,que mida con la cuerda las porciones en la comunidad del Señor."
,"6":"'¡No profeticéis, dicen ellos, no profeticéis tales cosas; la desgracia no nos alcanzará!"
,"7":"¿Es que será maldita la casa de Jacob?,¿Es que se ha terminado la paciencia del Señor?,¿Así es como él se comporta?,¿No son sus palabras benignas para el que practica la justicia?'."
,"8":"Pero vosotros estáis contra mi pueblo, como enemigos os habéis levantado; a los pacíficos les quitáis el manto, a los que caminan confiados los tratáis como enemigos de guerra."
,"9":"A las mujeres de mi pueblo,las echáis de las casas que amaban, y quitáis para siempre a sus hijos,el honor que yo les he dado."
,"10":"Levantaos, marchad, no es hora de reposo. Por vuestra inmundicia provocáis la destrucción, y la destrucción será irreparable."
,"11":"Si hubiera un hombre que persiguiera el viento,y fraguara esta mentira: 'Yo te profetizo vino y licor', éste sería el profeta digno de este pueblo."
,"12":"Yo te reuniré, Jacob, todo entero, reuniré el resto de Israel; los reuniré como rebaño en el aprisco, como rebaño en la pradera, y no tendrán miedo de nadie."
,"13":"El que los guía irá a la cabeza, abrirá el camino y pasarán por la puerta de salida; su rey irá el primero, y el Señor a su cabeza."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Escuchad, jefes de Jacob, magistrados de la casa de Israel. ¿No es cosa vuestra conocer el derecho?"
,"2":"Pero vosotros odiáis el bien y amáis el mal, arrancáis la piel del cuerpo y la carne de los huesos."
,"3":"Vosotros devoráis la carne de mi pueblo, desolláis su piel, quebrantáis sus huesos, le hacéis trozos como carne en la olla, como carne en una caldera."
,"4":"Y luego clamarán al Señor, pero él no les responderá; les ocultará su rostro en aquel tiempo,por los crímenes que cometieron."
,"5":"Esto dice el Señor sobre los profetas,que engañan a mi pueblo; cuando tienen algo que masticar entre sus dientes, entonces gritan: '¡Paz!', pero a quien no les pone nada en la boca,le declaran la guerra."
,"6":"Por eso tendréis noche en lugar de visión, tinieblas en lugar de adivinación; se pondrá el sol sobre estos profetas, y sobre ellos el día se hará oscuro."
,"7":"Tales videntes quedarán avergonzados, llenos de confusión los adivinos, y todos se taparán la barba por falta de respuesta de Dios."
,"8":"Yo, en cambio, estoy lleno de fuerza, gracias al espíritu del Señor, de justicia y de fortaleza, para anunciar a Jacob su delito y a Israel su pecado."
,"9":"Escuchad esto, jefes de la casa de Jacob, y vosotros, jueces de la casa de Israel, que despreciáis la justicia y torcéis el derecho,"
,"10":"que edificáis a Sión con sangre,y a Jerusalén con injusticia."
,"11":"Sus jueces juzgan por soborno, sus sacerdotes enseñan por salario, sus profetas profetizan por dinero,y luego se apoyan en el Señor diciendo: '¿Es que no está el Señor en medio de nosotros?,¡Ninguna desgracia nos alcanzará!'."
,"12":"Por eso, por culpa vuestra, Sión será arada como un campo, Jerusalén se volverá un montón de ruinas, el monte del templo un cúmulo de maleza."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Y sucederá en el futuro que el monte del templo del Señor,será asentado en la cima de los montes,y se alzará sobre las colinas. A él afluirán los pueblos,"
,"2":"acudirán numerosas naciones,y dirán: 'Venid, subamos al monte del Señor, al templo del Dios de Jacob; él nos enseñará sus caminos, y nosotros seguiremos sus senderos'. Pues la ley saldrá de Sión, y la palabra de Dios de Jerusalén."
,"3":"Él será árbitro entre pueblos numerosos, y juzgará a naciones poderosas y lejanas; ellas cambiarán sus espadas en azadas y sus lanzas en podaderas; no empuñará más la espada pueblo contra pueblo,ni se adiestrarán más en la guerra."
,"4":"Cada cual se sentará bajo su parra, a la sombra de su higuera, y ninguno vendrá a turbar su paz; lo ha dicho el Señor omnipotente."
,"5":"Porque todos los pueblos caminan cada uno en nombre de su dios; pero nosotros caminaremos en el nombre del Señor, nuestro Dios, para siempre jamás."
,"6":"Aquel día -dice el Señor- yo reuniré a las ovejas cojas, recogeré a las extraviadas y a las que yo había maltratado."
,"7":"De las cojas haré un resto, de las alejadas una nación poderosa. Entonces el Señor reinará sobre ellos,en el monte Sión desde ahora y por siempre."
,"8":"Y tú, Torre del Rebaño, Fortaleza de la hija de Sión, a ti vendrá el antiguo poder, el reino de la hija de Jerusalén."
,"9":"Y ahora, ¿por qué das esos gritos?,¿Es que no tienes rey?,¿Ha muerto tu consejero, para que el dolor te agobie,como a mujer en parto?"
,"10":"Retuércete de dolor y gime, hija de Sión, como mujer en parto, porque ahora saldrás de la ciudad; irás a vivir en el campo, llegarás hasta Babilonia,y allí serás salvada de la mano de tus enemigos."
,"11":"Ahora se han juntado contra ti numerosas naciones. Ellas dicen: 'Que sea profanada para que nuestros ojos,puedan contemplar la ruina de Sión'."
,"12":"Pero ellos no conocen los caminos del Señor, no comprenden sus designios: los ha reunido como gavillas en la era."
,"13":"Levántate y trilla, hija de Sión. Yo haré tus cuernos de hierro y de bronce tus pezuñas; triturarás a numerosos pueblos, consagrarás su botín al Señor, y sus riquezas al dueño de toda la tierra."
,"14":"Y ahora prepara tu defensa, hija guerrera; nos cercan con trincheras, con vara hieren la mejilla del juez de Israel."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Y tú, Belén Éfrata, la más pequeña entre los clanes de Judá, de ti me saldrá el que ha de reinar en Israel. Sus orígenes vienen de antiguo, de tiempos remotos."
,"2":"Por eso el Señor los abandonará hasta el tiempo,en que dé a luz la que ha de dar a luz. Entonces el resto de sus hermanos,volverá a los hijos de Israel."
,"3":"Él se alzará y pastoreará el rebaño con la fortaleza del Señor, con la majestad del nombre del Señor su Dios. Vivirán tranquilos, porque entonces extenderá él,su poder hasta los confines de la tierra."
,"4":"Él mismo será la paz. Cuando el asirio invada nuestra tierra,y ponga el pie en nuestros palacios, enviaremos contra él siete pastores y ocho jefes del pueblo. "
,"5":"Ellos pastorearán a Asiria con la espada,y el país de Nemrod con el acero. Ellos nos librarán del asirio,cuando invada nuestra tierra,y ponga el pie en nuestro suelo."
,"6":"Y el resto de Jacob será, en medio de la multitud de los pueblos, como rocío que viene del Señor, como lluvia sobre la hierba, que no aguarda a los hombres,ni espera nada de los mortales."
,"7":"Entonces el resto de Jacob será entre las naciones, en medio de la multitud de los pueblos, como el león entre las fieras de la selva, como el leoncillo entre los rebaños de ganado menor, que pasa, pisotea y arrebata,sin que nadie pueda arrancar su presa."
,"8":"Tu mano se alzará contra tus adversarios, y todos tus enemigos serán exterminados."
,"9":"Aquel día -dice el Señor-, yo quitaré de en medio de ti tus caballos,y destruiré tus carros;"
,"10":"arrasaré las ciudades de tu país,y destruiré todas tus fortalezas;"
,"11":"quitaré de tu mano las hechicerías,y no tendrás más adivinos."
,"12":"Haré desaparecer de en medio de ti tus ídolos y tus estelas, y no adorarás más la obra de tus manos."
,"13":"Arrancaré de en medio de ti tus cipos sagrados,y destruiré por completo tus ciudades."
,"14":"Sí, con ira y con furor me vengaré,de todas las naciones que no han obedecido."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Escuchad ahora lo que dice el Señor: '¡Levántate, pleitea ante las montañas,y oigan las colinas tu voz!'."
,"2":"Escuchad, montes, el pleito del Señor, prestad oído, cimientos de la tierra, pues el Señor pleitea con su pueblo, entra en juicio contra Israel."
,"3":"'Pueblo mío, ¿qué te he hecho?,¿En qué te he molestado? Respóndeme."
,"4":"Yo te saqué de Egipto, de la casa de esclavitud,te rescaté y mandé a tu frente a Moisés, Aarón y María."
,"5":"Pueblo mío, recuerda lo que tramaba contra ti,Balac, rey de Moab, y lo que contestó Balaán, hijo de Beor. Acuérdate de Sitín y de Guilgal, para que conozcas las obras justas del Señor'."
,"6":"¿Con qué me presentaré al Señor, me postraré ante el Dios del cielo?,¿Me presentaré con holocaustos, con terneros primales?"
,"7":"¿Aceptará el Señor miles de carneros,y millones de ríos de aceite?,¿Ofreceré mi primogénito por mi delito, el fruto de mis entrañas por mi propio pecado?"
,"8":"Se te ha dado a conocer, oh hombre, lo que es bueno, lo que el Señor exige de ti. Es esto: practicar la justicia, amar la misericordia y caminar humildemente con tu Dios."
,"9":"La voz del Señor grita a la ciudad: 'Escuchad, tribu y asamblea de la ciudad."
,"10":"¿Es que puedo tolerar la casa del malvado,con riquezas injustamente adquiridas,y una medida escasa e indignante?"
,"11":"¿Es que voy a tener por justa la balanza injusta,y la bolsa de pesas falsas?"
,"12":"Sus ricos están llenos de injusticia, sus habitantes hablan falsedad, en su boca hay una lengua engañadora."
,"13":"Por eso voy a castigarte, a destruirte por tus crímenes."
,"14":"Comerás, pero no quedarás satisfecho; el hambre por dentro te devorará. Lo que pongas aparte no podrás conservarlo, y lo que conserves yo lo entregaré a la espada."
,"15":"Sembrarás pero no segarás, pisarás la aceituna pero no te ungirás de aceite, pisarás la uva pero no beberás vino."
,"16":"Has observado las leyes de Omrí, las prácticas de la casa de Ajab, te has portado como ellos. Yo haré de ti un ejemplo de terror, y de tus habitantes un objeto de burla. ¡Vosotros sufriréis el oprobio de los pueblos!'."
}`)
	CurrentBook.AddChapter(7, `{
"1":"¡Ay de mí, que soy como un espigador en verano, como un rebuscador tras la vendimia!,No hay un racimo que comer, ni un higo temprano que apetezco tanto."
,"2":"La lealtad ha desaparecido del país, no queda un hombre justo. Todos acechan para verter sangre; el hermano a su hermano para ponerle trampas."
,"3":"Sólo emplean las manos para hacer el mal: los funcionarios exigen recompensas, los jueces se dejan sobornar por regalos, los poderosos manifiestan sus ambiciones."
,"4":"Entre ellos el mejor es como una zarza, el más justo como cerca de espinos. El día anunciado por el centinela llega, el día de ajustar cuentas; entonces reinará la confusión."
,"5":"No os fiéis del compañero, no confiéis en el amigo; ten cuidado con lo que dices,delante de la que se acuesta entre tus brazos."
,"6":"Porque el hijo insulta al padre, la hija se alza contra su madre, la nuera contra su suegra, y los enemigos del hombre son sus mismos familiares."
,"7":"Pero yo clavo mis ojos en el Señor; yo espero en Dios, mi salvador; mi Dios me escuchará."
,"8":"No te alegres de mi suerte, enemiga mía; porque si he caído me levantaré, y si estoy en tinieblas el Señor será mi luz."
,"9":"Soportaré la ira del Señor, ya que he pecado contra él, hasta que él juzgue mi causa,y establezca mi derecho. Él me sacará a la luz, y yo contemplaré su justicia."
,"10":"Vendrá entonces mi enemiga, cubierta de vergüenza; ella que me decía: '¿Dónde está el Señor, tu Dios?'. Mis ojos se saciarán de mirarla,cuando sea pisoteada como el lodo de las calles."
,"11":"Ya llega el día en que serán reedificados tus muros; aquel día serán dilatadas tus fronteras."
,"12":"Entonces llegarán hacia ti desde Asiria hasta Egipto,y desde Egipto hasta el río, desde un mar a otro mar,y desde un monte a otro monte."
,"13":"Y la tierra quedará hecha un desierto,por la mala conducta de sus habitantes."
,"14":"Apacienta a tu pueblo con tu cayado, el rebaño de tu herencia, que anda solitario en el bosque en medio de un campo feraz. Que pasten como antaño en Basán y en Galaad."
,"15":"Y como cuando los sacaste de Egipto, haznos ver tus prodigios."
,"16":"Las naciones lo verán,y quedarán cubiertas de vergüenza, a pesar de todo su poder; pondrán la mano en la boca, y sus oídos quedarán sordos."
,"17":"Lamerán el polvo como la serpiente, como los reptiles de la tierra. Saldrán de sus guaridas aterrados, avanzarán temblando hacia el Señor, Dios nuestro, y tendrán miedo de ti."
,"18":"¿Qué Dios hay como tú, que quite el pecado,y perdone la culpa al resto de tu herencia?,No mantendrá su cólera por siempre, porque ama la misericordia."
,"19":"Volverá a compadecerse de nosotros, pisoteará nuestros pecados, arrojará nuestras culpas al fondo del mar."
,"20":"Concede a Jacob tu fidelidad, tu misericordia a Abrahán, como juraste a nuestros padres desde los días de antaño."
}`)

}
func ES_LSB_LoadVNMLChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Oráculo. Palabra del Señor dirigida a Israel por medio de Malaquías:"
,"2":"'Yo os amo', dice el Señor; y vosotros decís: '¿Cómo que nos amas?'. '¿No era acaso Esaú hermano de Jacob? -dice el Señor-. Sin embargo, yo amé a Jacob"
,"3":"y odié a Esaú. Por eso arrasé su territorio y lo dejé hecho un desierto'."
,"4":"Si Edón dice: 'Hemos sido destruidos, pero reconstruiremos nuestras ruinas', esto dice el Señor todopoderoso: 'Ellos edificarán, pero yo destruiré; serán llamados Tierra malvada, pueblo contra el que el Señor está eternamente indignado."
,"5":"Veréis esto con vuestros propios ojos y diréis: ¡Grande es el Señor hasta fuera del territorio de Israel!'."
,"6":"El hijo honra a su padre, el siervo honra a su señor. Pues si yo soy padre, ¿dónde está el honor que me pertenece? Y si soy señor, ¿dónde el respeto que se me debe?, dice el Señor todopoderoso justamente a vosotros, sacerdotes, que mientras despreciáis mi nombre, todavía decís: ¿En qué hemos despreciado tu nombre?"
,"7":"Cuando traéis a mi altar alimentos impuros. Y todavía decís: '¿Cómo lo hacemos impuro?'."
,"8":"Cuando afirmáis que la mesa del Señor no tiene ninguna importancia; que no es nada malo ofrecer en sacrificio una res ciega, coja o enferma. ¡Ofrécesela, pues, a tu gobernador, a ver si la acepta y te recibe bien! -dice el Señor todopoderoso-."
,"9":"Y ahora, implorad a Dios, para que tenga compasión de vosotros; pero si hacéis esas cosas, ¿cómo os va a recibir bien? -dice el Señor todopoderoso-."
,"10":"¡Ojalá uno de vosotros cerrara las puertas del templo, para que no se encienda más inútilmente mi altar! No, no estoy contento con vosotros -dice el Señor todopoderoso- y no me agradan las ofrendas de vuestras manos."
,"11":"Porque desde oriente a occidente mi nombre es grande entre las naciones, y en todo lugar se ofrece a mi nombre un sacrificio de incienso y una ofrenda pura. Porque mi nombre es grande entre las naciones -dice el Señor todopoderoso-,"
,"12":"mientras que vosotros lo profanáis cuando decís: La mesa del Señor es impura, y los alimentos que se ponen en ella son despreciables."
,"13":"Andáis diciendo: '¡Qué aburrimiento!', y me despreciáis -dice el Señor todopoderoso- trayendo la res robada, coja y enferma, y presentándomela como ofrenda. ¿Es que puedo yo aceptarla de vuestras manos? -dice el Señor todopoderoso-."
,"14":"¡Maldito el tramposo que, teniendo en su rebaño un macho perfecto, hace una promesa y ofrece al Señor en sacrificio otro defectuoso! Yo soy un gran rey -dice el Señor todopoderoso-, y mi nombre es temible entre las naciones."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Ahora, esta amonestación se dirige a vosotros, sacerdotes."
,"2":"Si no escucháis ni os preocupáis de glorificar mi nombre -dice el Señor todopoderoso-, yo mandaré contra vosotros la maldición; maldeciré vuestras bendiciones; incluso las he maldecido ya, porque no hay entre vosotros quien tome esto en consideración."
,"3":"Mirad, yo romperé vuestro brazo, os echaré estiércol a la cara, el estiércol de vuestras fiestas, y se barrerá con él."
,"4":"Así sabréis que he sido yo el que os ha dirigido esta amonestación, para que mi alianza con Leví sea firme -dice el Señor todopoderoso-."
,"5":"Mi pacto con él era de vida y paz, y se las concedí; era también de amor, y él me respetó y reverenció mi nombre."
,"6":"Tenía en su boca la verdadera doctrina, y en sus labios no se encontró falsedad alguna, sino que se portaba conmigo con integridad y rectitud, y a muchos otros apartó del mal camino."
,"7":"Pues los labios del sacerdote deben guardar la ciencia, y de su boca se viene a buscar la enseñanza, porque él es el mensajero del Señor todopoderoso."
,"8":"Pero vosotros os habéis apartado del camino, habéis servido de tropiezo a muchos en la ley y habéis quebrantado la alianza de Leví -dice el Señor todopoderoso-."
,"9":"Por eso también yo os he hecho despreciables y viles ante todo el pueblo, de la misma manera que vosotros no habéis guardado mi camino, sino que habéis dado pruebas de parcialidad en vuestras decisiones."
,"10":"¿No tenemos todos un mismo padre? ¿No nos ha creado un único Dios? Entonces, ¿por qué estamos unos contra otros, profanando el pacto de nuestros padres?"
,"11":"Judá ha cometido una traición; en Israel y en Jerusalén se cometen acciones horribles. Judá ha profanado el santuario querido del Señor al casarse con la hija de un dios extranjero."
,"12":"¡Al hombre que procede de tal manera, sea el que sea, que el Señor lo extermine de las tiendas de Jacob y del número de aquellos que presentan ofrendas al Señor todopoderoso!"
,"13":"Otra cosa hacéis también vosotros: cubrís de lágrimas, de llantos y gemidos el altar del Señor porque él no acepta ya vuestras ofrendas ni recibe con agrado lo que presentan vuestras manos."
,"14":"Y decís: '¿Por qué?'. Porque el Señor es testigo entre ti y la esposa de tu juventud, a la que tú fuiste infiel, siendo así que ella era tu compañera, tu elegida."
,"15":"¿No ha hecho el Señor un ser único, carne animada de vida? Y este ser único, ¿qué busca? Una descendencia divina. Respetad vuestras vidas y no seáis infieles a la esposa de vuestra juventud."
,"16":"Pues el que se divorcia de su mujer porque la odia -dice el Señor, Dios de Israel- cubre de violencia su vestido -dice el Señor todopoderoso-. Respetad vuestras vidas y no seáis infieles."
,"17":"Vosotros cansáis al Señor con vuestras palabras, y sin embargo decís: '¿En qué le hemos cansado?'. Con esto afirmáis: 'Todo el que hace el mal es bien visto por el Señor y él lo acepta complacido', o '¿dónde está el Dios de la justicia?'."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Yo enviaré mi mensajero a reparar el camino delante de mí; pronto vendrá a su templo el Señor, a quien vosotros buscáis; el ángel de la alianza, por quien tanto suspiráis, ya está para llegar -dice el Señor todopoderoso-."
,"2":"¿Quién podrá soportar el día de su venida? ¿Quién subsistirá cuando aparezca? Será como el fuego del fundidor y como la lejía de las lavanderas."
,"3":"Se sentará para fundir y refinar la plata. Purificará a los hijos de Leví, los refinará como el oro y la plata, a fin de que puedan presentar al Señor una ofrenda conforme a justicia."
,"4":"Entonces la ofrenda de Judá y de Jerusalén será agradable al Señor como en los tiempos antiguos, como en los años primeros."
,"5":"Yo vendré a juzgaros; seré testigo acusador contra los hechiceros, contra los adúlteros y los perjuros, contra los que explotan al jornalero, a la viuda y al huérfano y violan el derecho del extranjero sin ningún temor de mí -dice el Señor todopoderoso-."
,"6":"Pues yo, el Señor, no cambio; y vosotros no dejáis de ser hijos de Jacob."
,"7":"Desde los días de vuestros padres os habéis apartado de mis mandamientos y no los habéis observado. Volved a mí, y yo volveré a vosotros -dice el Señor todopoderoso- Pero vosotros decís: '¿En qué tenemos que volver?'."
,"8":"¿Puede un hombre engañar a Dios? Sí, vosotros me engañáis y andáis diciendo: '¿En qué te hemos engañado?'. En los diezmos y en los tributos sagrados."
,"9":"Ya estáis bajo la maldición, pues me engañáis vosotros, toda la nación entera."
,"10":"Llevad íntegro el diezmo al tesoro para que haya alimento en mi casa; y ponedme así a prueba -dice el Señor todopoderoso-, a ver si no os abro las esclusas del cielo y derramo sobre vosotros las bendiciones sobreabundantemente."
,"11":"Alejaré de vosotros la voraz langosta para que no os destruya los frutos del suelo y no sea estéril la viña en el campo -dice el Señor todopoderoso-."
,"12":"Todas las gentes os felicitarán, porque seréis una tierra deliciosa -dice el Señor todopoderoso-."
,"13":"Vuestras palabras me parecen muy duras -dice el Señor-, pero vosotros decís: '¿Qué hemos dicho contra ti?'."
,"14":"Habéis dicho: 'Es inútil servir a Dios; ¿qué hemos ganado con guardar sus mandamientos o con andar en duelo ante el Señor todopoderoso?"
,"15":"Por eso llamamos felices a los orgullosos, que, aun haciendo el mal, progresan, provocan a Dios y quedan sin castigo'."
,"16":"Así hablaban entre sí los que temen a Dios. Pero el Señor puso atención y escuchó, y se escribió ante él un libro en el que están registrados los que le temen y respetan su nombre."
,"17":"Ellos constituirán -dice el Señor todopoderoso- mi propiedad en el día aquel que yo preparo; sí, los perdonaré como un hombre perdona a su hijo que le sirve."
,"18":"Entonces vosotros volveréis a ver la diferencia que hay entre el justo y el injusto, entre quien sirve al Señor y quien no le sirve."
,"19":"Pues ya está para llegar aquel día, abrasador como un horno; entonces todos los soberbios y los que cometen injusticias serán como la paja; el día que viene los consumirá hasta no dejar de ellos ni raíz ni ramaje."
,"20":"En cambio, para vosotros, los que respetáis mi nombre, brillará el sol de justicia con la salvación en sus rayos, y vosotros saldréis y brincaréis como becerros fuera del establo."
,"21":"Pisotearéis a todos los que cometen injusticias, porque serán como ceniza bajo la planta de vuestros pies el día que yo preparo -dice el Señor todopoderoso-."
,"22":"Recordad la ley de Moisés, mi siervo, a quien yo di en el Horeb mandamientos y normas para todo Israel."
,"23":"Yo os enviaré al profeta Elías antes de que llegue el día grande y terrible del Señor."
,"24":"Él hará volver el corazón de los padres a los hijos y el corazón de los hijos a los padres, para que cuando yo venga no tenga que exterminar la tierra."
}`)

}
func ES_LSB_LoadVNNHChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Oráculo sobre mínive. Libro de la visión de Nahún de ëlcos."
,"2":"El Señor es Dios celoso y vengador; el Señor se venga y se arma de ira, se venga el Señor de sus adversarios,y se enfurece contra sus enemigos."
,"3":"El Señor es paciente, pero de gran poder, y no deja pasar nada. El Señor camina en la tempestad y en el huracán, y las nubes son el polvo de sus pies."
,"4":"Grita contra el mar y el mar se seca, y agota todos los ríos. El Basán y el Carmelo se marchitan, y el verdor del Líbano se amustia."
,"5":"Los montes tiemblan ante él,y las colinas se estremecen; ante él se disuelve la tierra, el mundo y los que en él habitan."
,"6":"Ante su ira, ¿quién podrá resistir?,¿Quién se mantendrá cuando su cólera se inflama?,Su furor se derrama como fuego, y las rocas se funden ante él."
,"7":"El Señor es bueno, un refugio en el día de la angustia; él cuida de los que a él se acogen"
,"8":"cuando pasa la inundación; pero extermina a quien se alza contra él, hasta en las tinieblas perseguirá a sus enemigos."
,"9":"¿Qué tramáis contra el Señor?,Él va a hacer tabla rasa de todo; la desgracia no aparecerá dos veces,"
,"10":"porque ellos son como espinos enmarañados; como borrachos en su borrachera, como paja seca serán enteramente consumidos."
,"11":"De ti ha salido el que trama el mal contra el Señor,y urde planes perversos."
,"12":"Esto dice el Señor: 'Aunque sean robustos y numerosos, serán cortados y desaparecerán. Si te he humillado, no volveré a humillarte."
,"13":"Ahora quebraré su yugo de tu cuello, y romperé tus cadenas'."
,"14":"El Señor decreta contra ti: 'No se propagará tu nombre más; exterminaré del templo de tus dioses estatuas e ídolos fundidos, y haré de tu sepulcro un lugar de ignominia'."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Mirad, ya viene por los montes,el mensajero de la buena nueva, el que anuncia la paz. Celebra tus fiestas, Judá, cumple tus promesas; porque el ser infernal no volverá a pasar por ti, ha sido exterminado por completo."
,"2":"El destructor avanza contra ti; ponte en guardia en la fortaleza, vigila el camino, cíñete los lomos, concentra todas tus fuerzas,"
,"3":"pues el Señor restablece la viña de Jacob,y la viña de Israel; los ladrones la habían despojado, habían destruido sus sarmientos."
,"4":"El escudo de sus guerreros es rojo, sus soldados visten de escarlata; brilla en los carros el acero,cuando se alinean para la batalla y se agitan las lanzas."
,"5":"Los carros desenfrenados corren por las calles, se precipitan por las plazas; semejantes a antorchas encendidas, se lanzan como relámpagos."
,"6":"Se da la llamada a sus héroes; en su carrera chocan; corren hacia la muralla donde está el parapeto."
,"7":"Se abren las puertas que dan al río, y en el palacio cunde el pánico."
,"8":"Llevan cautiva a la reina con sus damas, que gimen como palomas y se golpean el pecho."
,"9":"Nínive es como una alberca, cuyas aguas se van. 'Deteneos, deteneos'. Pero nadie se vuelve."
,"10":"Robad la plata, robad el oro. ¡Son innumerables las reservas, verdaderos montones de objetos preciosos!"
,"11":"¡Devastación, saqueo, destrucción, corazones presa de terror, temblor de rodillas, lomos estremecidos, rostros desencajados!"
,"12":"¿Dónde está la guarida de los leones,y el cubil de los leoncillos?,¿Dónde iba el león y sus cachorros,sin que nadie le inquietase?"
,"13":"El león desgarraba la presa para sus cachorros, la estrangulaba para sus leonas, llenaba de botín su escondrijo y de rapiñas su cubil."
,"14":"'Pero aquí estoy contra ti,-dice el Señor omnipotente-; reduciré a humo tus carros, la espada devorará a tus leoncillos; arrancaré de la tierra tus presas,y no se oirá más la voz de tus mensajeros'."
}`)
	CurrentBook.AddChapter(3, `{
"1":"¡Ay de ti, ciudad sanguinaria, toda llena de mentira,y de violencia y de robos continuos!"
,"2":"Escuchad: chasquidos de látigos, estrépito de ruedas, galopar de caballos, saltar de carros,"
,"3":"rumor de caballería que avanza, espadas que flamean, lanzas fulgurantes, multitud de heridos, montones de muertos, cadáveres sin cuento,en los que al andar se tropieza:"
,"4":"ése es el fruto de todos los escándalos de la prostituta, de la bella graciosa y hábil encantadora, que esclavizaba a las naciones con sus seducciones,y a los pueblos con sus hechizos:"
,"5":"Aquí estoy contra ti -dice el Señor omnipotente-; yo alzaré tus faldas hasta tu cara,y mostraré a las naciones tu desnudez, a los reinos tu vergüenza."
,"6":"Arrojaré suciedad contra ti, te cubriré de infamia,y te expondré a la pública vergüenza."
,"7":"Todo el que te vea huirá de ti y dirá: Nínive ha sido destruida. ¿Quién tendrá piedad de ella?,¿Dónde podré buscarte algún consolador?"
,"8":"¿Eres acaso tú mejor que No-Amón, asentada junto al río, rodeada de agua, cuya defensa era el mar y sus muros las aguas?"
,"9":"Etiopía y Egipto eran su fuerza, que no tenía límites; Lidia y Libia sus auxiliares."
,"10":"Con todo, también ella fue al destierro prisionera, también sus niños fueron estrellados,en las esquinas de todas las calles; sobre sus nobles se echaron suertes, y todos sus grandes fueron metidos en los cepos."
,"11":"También tú serás cercada y dominada, también tú buscarás un refugio contra el enemigo."
,"12":"Todas tus fortalezas son como higueras cargadas de brevas: una sacudida, y caen en la boca de quien quiere comerlas."
,"13":"Ése es tu ejército: como mujeres en medio de ti; las puertas de tu país se abren francas ante el enemigo, el fuego devora tus cerrojos."
,"14":"Haz provisión de agua para el asedio, restaura tus fortalezas, toma el molde para hacer ladrillos."
,"15":"Entonces el fuego te consumirá, te exterminará la espada, te devorará como la langosta. Multiplícate como la langosta, multiplícate como el grillo."
,"16":"Multiplica tus mercaderes,más que las estrellas del cielo; los grillos alzan el vuelo y se van."
,"17":"Tus guardianes son como las langostas; tus funcionarios como enjambres de insectos, que se posan en las tapias en los días de frío. Sale el sol y levantan el vuelo,sin que se sepa dónde han ido."
,"18":"¿Dónde están tus pastores?,Muertos están, oh rey de Asiria; tus héroes están adormecidos, tu pueblo disperso por los montes, y no hay quien los reúna."
,"19":"No hay remedio para tu herida, tu llaga es incurable; los que lo saben baten palmas por tu ruina; pues ¿sobre quién no descargó sin cesar tu crueldad?"
}`)

}
func ES_LSB_LoadVNOSChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Palabra del Señor que fue dirigida a Oseas, hijo de Beerí, en tiempo de Ozías, Yotán, Acaz y Ezequías, reyes de Judá, en los días de Joás, rey de Israel."
,"2":"Así comienzan las palabras que el Señor dijo a Oseas: 'Anda, toma por mujer una prostituta y engendra hijos de prostitución, porque el país no hace más que prostituirse, alejándose del Señor'."
,"3":"Él fue y tomó a Gomer, hija de Diblaín, la cual concibió y le dio a luz un hijo."
,"4":"El Señor le dijo: 'Ponle el nombre de Yezrael, porque dentro de poco haré pagar a la casa de Jehú la sangre derramada en Yezrael y pondré fin al reino de la casa de Israel."
,"5":"Aquel día quebraré el arco de Israel en el valle de Yezrael'."
,"6":"Ella concibió de nuevo y dio a luz una hija. Y el Señor dijo a Oseas: 'Ponle el nombre de 'No-compadecida', porque yo no he de compadecerme más de la casa de Israel y me olvidaré completamente de ellos."
,"7":"Me compadeceré, en cambio, de la casa de Judá; los salvaré por medio del Señor, su Dios, y no por medio de arco, espada o lanza, o con caballos y jinetes'."
,"8":"Después de destetar a 'No-compadecida', concibió otra vez y dio a luz un hijo."
,"9":"Y el Señor le dijo: 'Ponle el nombre de 'No-mipueblo', porque vosotros no sois ya mi pueblo ni yo soy vuestro Dios'."
}`)
	CurrentBook.AddChapter(2, `{
"1":"El número de los israelitas será como la arena del mar, que no se puede medir ni calcular. Y en aquella época, en lugar de decirles: 'No-mi-pueblo', se les dirá: 'Hijos-de-Dios-vivo'."
,"2":"Los judíos y los israelitas se congregarán juntos, tendrán un solo jefe y abundarán sobre el país, porque es grande el día de Yezrael."
,"3":"Diréis a vuestros hermanos: 'Mi-pueblo', y a vuestras hermanas: 'Compadecida'. "
,"4":"¡Acusad a vuestra madre, acusadla!,Porque ella no es mi esposa, ni yo soy su marido. Que aleje de su rostro sus prostituciones,y sus fornicaciones de su seno. "
,"5":"De lo contrario, la dejaré desnuda, como el día en que nació; la dejaré como un desierto, la reduciré a tierra seca,y la haré morir de sed. "
,"6":"No amaré más a sus hijos, porque son hijos de prostitución. "
,"7":"Su madre se ha prostituido, se ha deshonrado la que los dio a luz. Ella decía: 'Iré tras mis amantes, que me dan mi pan y mi agua, mi lana y mi lino, mi aceite y mi bebida'. "
,"8":"Por eso voy a cerrar su camino con espinos, voy a cercarla con una valla,para que no encuentre más sus senderos; "
,"9":"irá en busca de sus amantes, pero no los alcanzará; los buscará, pero no podrá encontrarlos, y tendrá que decir: 'Volveré a mi primer marido, porque entonces me iba mejor que ahora'. "
,"10":"No reconoció que era yo quien le daba el trigo, el vino y el aceite; quien prodigaba la plata y el oro,que ellos emplearon para los baales. "
,"11":"Por eso volveré a tomar mi trigo a su tiempo,y mi vino a su estación, y recobraré mi lana y mi lino con que ella cubría su desnudez."
,"12":"Descubriré su vergüenza a los ojos de sus amantes, y nadie la salvará de mi mano."
,"13":"Haré cesar todo su regocijo, sus fiestas, sus novilunios, sus sábados y todas sus solemnidades."
,"14":"Devastaré su viñedo y su higuera, de los que decía: 'Ésta es la paga que me han dado mis amantes': las reduciré a jaral que pastarán las bestias salvajes."
,"15":"Le haré rendir cuentas de sus fiestas en honor de los baales, a quienes quemaba incienso ataviada,de anillos y collares para correr tras sus amantes, olvidándose de mí -dice el Señor-."
,"16":"Pero yo la atraeré y la guiaré al desierto, donde hablaré a su corazón. "
,"17":"Luego le restituiré sus viñas; haré del valle de Acor una puerta de esperanza, y ella me responderá como en los días de su juventud, como en el día en que salió de Egipto."
,"18":"Sí, aquel día -dice el Señor- ella me llamará: 'Marido mío', y no me llamará más: 'Baal mío'. "
,"19":"Yo quitaré de su boca los nombres de los baales, y ella no los volverá a pronunciar."
,"20":"Aquel día haré en su favor un pacto,con las bestias salvajes, con las aves del cielo y con los reptiles de la tierra; romperé en el país arco, espada y lanza,y haré que duerman tranquilos. "
,"21":"Entonces me casaré contigo para siempre, me casaré contigo en la justicia y el derecho, en la ternura y el amor; "
,"22":"me casaré contigo en la fidelidad, y tú conocerás al Señor. "
,"23":"Aquel día -dice el Señor- yo responderé a los cielos, y ellos responderán a la tierra;"
,"24":"la tierra responderá al trigo, al vino y al aceite, y ellos responderán a Yezrael. "
,"25":"Yo la sembraré para mí en el país, me compadeceré de 'No-compadecida',y diré a 'No-mi-pueblo': 'Tú eres mi pueblo', y él dirá: 'Dios mío'."
}`)
	CurrentBook.AddChapter(3, `{
"1":"El Señor me dijo: 'Vete otra vez, ama a una mujer amada por su marido y adúltera, como el Señor ama a los israelitas mientras ellos se vuelven a otros dioses y gustan de las tortas de uva'."
,"2":"Yo la compré por quince monedas de plata y seiscientos setenta y cinco kilos de cebada."
,"3":"Y le dije: 'Tienes que estar conmigo mucho tiempo sin prostituirte ni entregarte a ningún hombre, y yo haré lo mismo contigo'."
,"4":"Porque los israelitas permanecerán mucho tiempo sin rey, sin príncipe, sin sacrificios, sin estelas, sin efod y sin ídolos familiares."
,"5":"Después los israelitas volverán a buscar al Señor, su Dios, y a David, su rey, y acudirán con temor al Señor y a sus bienes en el tiempo futuro."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Israelitas, escuchad la palabra del Señor: El Señor ha entablado un pleito con los habitantes del país. No existe ya fidelidad ni amor del prójimo, ni conocimiento de Dios en el país, "
,"2":"sino juramentos falsos, mentiras, homicidios y robos, adulterios, violencias y sangre que provoca sangre."
,"3":"Por eso el país está de luto,y todos sus habitantes desfallecen; hasta las bestias de los campos, las aves del cielo y los peces del mar desaparecen."
,"4":"Sin embargo, que nadie acuse ni reproche a otro, pues sólo contra ti, sacerdote, he entablado mi pleito."
,"5":"Tú tropiezas de día, y el profeta tropieza contigo de noche; yo reduciré al silencio a tu madre."
,"6":"Mi pueblo será reducido al silencio por falta de ciencia; tú has rechazado el saber, y yo te rechazaré a ti de mi sacerdocio; has olvidado la ley de tu Dios, también yo me olvidaré de tus hijos."
,"7":"Cuantos más eran, más han pecado contra mí,y han cambiado su gloria por la ignominia."
,"8":"Se alimentan del pecado de mi pueblo, están hambrientos de su iniquidad. "
,"9":"Pero tanto al pueblo como al sacerdote,les haré rendir cuentas de su conducta,y pagarán según sus obras. "
,"10":"Comerán, pero no se saciarán; fornicarán, pero no engendrarán, porque han abandonado al Señor "
,"11":"para entregarse a la prostitución. El vino y el mosto hacen perder el seso."
,"12":"Mi pueblo consulta a su trozo de leño, y su bastón le da respuestas,porque un espíritu de prostitución le ha seducido: adoran a los ídolos y abandonan a su Dios. "
,"13":"Sobre las cimas de los montes ofrecen sacrificios; en las colinas queman incienso,bajo la encina, el chopo o el terebinto: ¡tan agradable es su sombra!,Así se prostituyen vuestras hijas, y vuestras nueras cometen adulterio. "
,"14":"No castigaré a vuestras hijas porque se prostituyan, ni a vuestras nueras porque cometan adulterio, puesto que ellos también se van con prostitutas,y con las prostitutas sagradas ofrecen sacrificios. Así el pueblo ignorante se prepara a la ruina. "
,"15":"Si tú, Israel, te prostituyes, que al menos Judá no se haga culpable. Por tanto, no vayáis a Guilgal, no subáis a Bet-Avén, no juréis más así: 'Vive Dios'. "
,"16":"Porque Israel se ha torcido como novilla indómita; ¿cómo los va a apacentar el Señor,como a un cordero en ancha pradera?"
,"17":"Efraín se ha asociado con los ídolos: ¡Déjale!"
,"18":"Cuando terminan sus borracheras, comienzan sus prostituciones; cambian la gloria por la ignominia."
,"19":"El viento los envolverá en sus alas,y se avergonzarán de sus altares."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Escuchad esto, sacerdotes; atiende, casa de Israel; casa real, prestad oído, porque se hace justicia contra vosotros. Vosotros os habéis hecho un lazo en Mispá,y una red tendida en el monte Tabor,"
,"2":"una fosa profunda excavada en Sitín, pero les castigaré a todos ellos."
,"3":"Conozco bien a Efraín, e Israel no se me oculta. Sí, te has prostituido, Efraín; se ha contaminado Israel."
,"4":"Sus acciones no les permiten volver a su Dios, pues un espíritu de prostitución hay dentro de ellos,y no conocen al Señor. "
,"5":"La arrogancia de Israel testifica contra él, la iniquidad de Efraín le hace vacilar, y Judá caerá también con ellos."
,"6":"Con sus ovejas y sus vacas van en busca del Señor, mas no lo encuentran: se aparta de ellos."
,"7":"Han traicionado al Señor, han engendrado hijos bastardos; pero un conquistador los devorará a ellos y a sus campos."
,"8":"Tocad el cuerno en Guibeá, la trompeta en Ramá; dad la alarma en Bet-Avén; y tú, alerta, Benjamín."
,"9":"Efraín será una ruina el día del castigo: para las tribus de Israel hago saber lo irreparable."
,"10":"Los jefes de Judá se han vuelto como los que desplazan,los linderos, y sobre ellos derramaré a raudales mi furor."
,"11":"Efraín está oprimido, el derecho violado, porque se complace en correr tras la nada."
,"12":"Yo seré como polilla para Efraín, como carcoma para la casa de Judá."
,"13":"Efraín ha visto su enfermedad y Judá su llaga. Efraín ha acudido a Asiria,y ha enviado mensajeros al gran rey; pero éste no podrá sanaros, ni curará vuestra llaga."
,"14":"Porque yo soy como un león para Efraín, como un leoncillo para la casa de Judá. Yo, yo mismo hago presa y me voy; me la llevo y nadie me la arranca."
,"15":"Sí, volveré a mi lugar hasta que se sientan culpables,y busquen mi rostro. En su angustia me buscarán."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Venid, volvamos al Señor: él ha desgarrado, él nos curará; él ha herido, él nos vendará. "
,"2":"En dos días nos dará la vida, al tercero nos levantará,y en su presencia viviremos."
,"3":"Esforcémonos en conocer al Señor. Es cierta como la aurora su venida: vendrá a nosotros como viene la lluvia, como la lluvia de primavera que fecunda la tierra. "
,"4":"¿Cómo he de tratarte, Efraín?,¿Cómo he de tratarte, Judá?,Vuestro amor es como nubecilla matinal, como el rocío que se esfuma presto. "
,"5":"Por eso te hice pedazos; por medio de los profetas, te he matado con las palabras de mi boca, y mi justicia brota como la luz. "
,"6":"Porque yo quiero amor, no sacrificios; conocimiento de Dios, y no holocaustos."
,"7":"Pero ellos en Adán han violado la alianza, allí me han traicionado."
,"8":"Galaad es ciudad de malhechores, llena de huellas de sangre. "
,"9":"Los sacerdotes, como bandidos al acecho, asaltan por el camino de Siquén, asesinan y cometen atentados."
,"10":"He visto cosas horribles en la casa de Israel: allí Efraín se prostituye, Israel se contamina. "
,"11":"También para ti, Judá, hay preparada una cosecha,cuando cambie la suerte de mi pueblo."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Cuando yo quiero sanar a Israel, se descubre la iniquidad de Efraín,y el crimen de Samaría, porque se practica la estafa, el ladrón penetra en las casas,y afuera saquean los bandidos. "
,"2":"No piensan en su corazón que yo llevo cuenta,de todas sus maldades. Ahora les acorralan sus obras, ante mi rostro están presentes. "
,"3":"Con su malicia divierten al rey, y con su perfidia a los príncipes."
,"4":"Todos ellos son adúlteros, queman como horno encendido, aunque el hornero deje de atizar el fuego,desde que prepara la masa hasta que fermenta."
,"5":"En el día de nuestro rey los jefes,se aturdieron con el vapor del vino, y él tendió la mano a los criminales. "
,"6":"Su corazón se abrasa como un horno,en las tramas que urde. Toda la noche dormita su cólera,y a la mañana quema como fuego ardiente. "
,"7":"Todos están calientes como un horno, y devoran a sus gobernantes. Así han caído todos sus soberanos, y nadie entre ellos trata de recurrir a mí."
,"8":"Efraín se mezcla con las gentes vecinas, se ha hecho como una torta a la que no se dio la vuelta."
,"9":"Los extranjeros devoran su fuerza,sin que él se dé cuenta; se ha llenado de canas, pero él no lo ha notado. "
,"10":"La arrogancia de Israel testifica contra él, pero no vuelven al Señor, su Dios; a pesar de ello, no le buscan. "
,"11":"Efraín es como una ingenua paloma,falta de inteligencia; llaman a Egipto, acuden a Asiria."
,"12":"Mientras ellos vayan extenderé mis redes sobre ellos, y los haré caer como aves del cielo; los atraparé en cuanto oiga la bandada."
,"13":"¡Ay de ellos, que se han apartado de mí!,Asolados serán, porque se han rebelado contra mí. Cuando yo los quería salvar, proferían mentiras contra mí. "
,"14":"Y no claman a mí en su corazón,cuando se lamentan en sus camas; se preocupan del trigo y del vino,y se rebelan contra mí."
,"15":"Yo adiestré, fortifiqué su brazo; pero ellos maquinan males contra mí. "
,"16":"Se han vuelto a Baal, se han hecho como un arco engañoso. A espada sus príncipes caerán por la ira de su lengua, y en Egipto se hará burla de ellos."
}`)
	CurrentBook.AddChapter(8, `{
"1":"¡Emboca la trompeta!,Hay un águila sobre la casa del Señor, porque han violado mi alianza, han quebrantado mi ley."
,"2":"Ellos me gritan: '¡Dios mío, los de Israel te conocemos!'. "
,"3":"Pero Israel ha rechazado el bien, y el enemigo lo persigue."
,"4":"Han establecido reyes sin contar conmigo; han nombrado jefes sin mi aprobación. Con su plata y su oro se han hecho ídolos,para su propia ruina."
,"5":"Me repugna tu becerro, Samaría; mi cólera se enciende contra él. ¿Hasta cuándo seguirán sin purificarse?"
,"6":"De Israel procede, un artista lo ha fabricado; no, no es Dios. Pero el becerro de Samaría quedará hecho astillas."
,"7":"Siembran viento, recogerán tempestad; su grano no dará mies, ni la espiga dará harina; y si la da, los extranjeros la devorarán."
,"8":"Israel está engullido; vedlo ya entre las naciones como vasija de desecho. "
,"9":"Porque han acudido a Asiria, que es un asno salvaje solitario. Efraín se ha comprado amantes. "
,"10":"Aunque reparta regalos entre las naciones, ahora yo los voy a dispersar, y pronto dejarán de surgir reyes y príncipes."
,"11":"Efraín ha multiplicado los altares, que no le han servido más que para pecar."
,"12":"Aunque haya escrito para él mis leyes a millares, las considera como las de un extraño."
,"13":"Aman los sacrificios; ¡pues que los ofrezcan! Aman la carne; ¡que la coman! El Señor no se complace en ellos; ahora recordará su iniquidad, castigará su pecado,y ellos volverán a Egipto."
,"14":"Israel, olvidando a su hacedor, se ha edificado palacios, y Judá ha multiplicado las ciudades fuertes. Pero yo prenderé fuego a sus ciudades, que devorará sus palacios."
}`)
	CurrentBook.AddChapter(9, `{
"1":"No te alegres, Israel, no te regocijes como los gentiles, pues tú te has prostituido abandonando a tu Dios; has amado el salario de la prostitución,en todas las eras de grano."
,"2":"Pero la era y el lagar no saciarán, y el vino nuevo defraudará su esperanza."
,"3":"No permanecerán más en la tierra del Señor; Efraín regresará a Egipto, y en Asiria comerán manjares impuros."
,"4":"No harán al Señor más ofrendas de vino,ni ofrecerán sus víctimas; como pan de duelo será su alimento; cuantos lo coman se contaminarán. Su pan será sólo para ellos, no entrará en la casa del Señor."
,"5":"¿Qué haréis el día de la solemnidad, el día de la fiesta del Señor?"
,"6":"Han escapado de la destrucción: Egipto los recogerá, Menfis los sepultará, sus tesoros de plata se llenarán de ortigas,y en sus tiendas crecerán los cardos."
,"7":"Ha llegado la hora del castigo, ha llegado la hora de la paga merecida; que lo sea Israel: el profeta es un necio, un loco el hombre inspirado, por tu gran crimen, por tu gran rebelión."
,"8":"Efraín espía en la tienda del profeta, le tiende lazos en todos sus caminos, le persigue hasta en la casa de Dios."
,"9":"Están profundamente corrompidos, como en los días de Guibeá; pero el Señor recordará su crimen,y castigará sus pecados."
,"10":"Como uva en el desierto encontré yo a Israel, como breva de higuera vi a vuestros padres. Pero al llegar a Baal Fegor se consagraron a la infamia, y se hicieron despreciables como el objeto de su amor."
,"11":"La gloria de Efraín se va volando como un pájaro; no hay ya nacimiento, embarazo o concepción."
,"12":"Aunque criasen hijos, se los quitaré antes de que se hagan hombres. ¡Ay de aquellos de los que yo me aparto!"
,"13":"Efraín, según veo, ha hecho de sus hijos una presa, y los entrega a la matanza."
,"14":"Dales, Señor... ¿Qué les darás?,Dales un seno estéril y unos pechos resecos."
,"15":"Toda su perversidad se manifestó en Guilgal; sí, allí les cobré odio. Por la crueldad de sus acciones, los echaré de mi casa; ya no he de amarlos más; todos sus jefes son rebeldes."
,"16":"Efraín ha sido herido; su raíz está seca, ya no dará más fruto. Aunque den a luz, yo haré morir el fruto amado de su seno."
,"17":"Mi Dios los rechazará, porque no le han escuchado, y andarán errantes entre las naciones."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Israel es una vid frondosa de generoso fruto; cuanto más abundaba su fruto, más multiplicaba sus altares; cuanto más producía la tierra, más hermosas hacía las estelas."
,"2":"Su corazón es falso, pero ahora lo pagarán; él demolerá sus altares, destruirá sus estelas."
,"3":"Sí, dirán ahora: 'Ya no tenemos rey, porque no hemos temido al Señor. Y el rey, ¿qué puede hacer por nosotros?'."
,"4":"Palabras y palabras, vanos juramentos, pactos que hacen; la justicia brota como planta venenosa en los surcos del campo."
,"5":"Los habitantes de Samaría temen por el becerro de Bet-Avén; sí, su pueblo está de luto por él, y por él sus sacerdotes se lamentan,porque su gloria ha desaparecido."
,"6":"Él también será llevado a Asiria,como presente para el gran rey; Efraín recogerá vergüenza, e Israel se cubrirá de confusión por su ídolo."
,"7":"¡Ha desaparecido Samaría!,Su rey es como espuma sobre el agua."
,"8":"Los santuarios de las colinas del crimen serán destruidos, los pecados de Israel; espigas y abrojos crecerán en sus altares. Dirán a los montes: '¡Cubridnos!', y a las colinas: '¡Caed sobre nosotros!'."
,"9":"Desde los días de Guibeá has pecado, Israel. ¡No han cambiado!,¿No alcanzará la guerra en Guibeá a estos malvados?"
,"10":"Voy a castigarlos. Los pueblos se reunirán contra ellos,cuando yo los castigue por su doble crimen."
,"11":"Efraín es una novilla doméstica,que gusta de la trilla en la era. Yo pondré el yugo sobre su hermoso cuello, y la unciré al carro; Israel tendrá que arar, y Jacob rastrillar."
,"12":"Sembrad simiente de justicia, recoged cosecha de amor, cultivad vuestro barbecho: ya es tiempo de buscar al Señor para que venga,y os enseñe la justicia."
,"13":"¿Por qué habéis arado la crueldad, habéis cosechado el crimen,y habéis comido el fruto de la estafa?,Por haber confiado en tus carros, en la multitud de tus guerreros, "
,"14":"surgirá la confusión en tu pueblo: todas tus fortalezas serán destruidas, como Salmán arrasó a Bet Arbel el día de la batalla, cuando la madre fue estrellada sobre sus propios hijos."
,"15":"Así haré con vosotros, casa de Israel, por vuestra increíble maldad."
,"16":"Al amanecer, el rey de Israel desaparecerá para siempre."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Cuando Israel era niño, yo le amaba, y de Egipto llamé a mi hijo."
,"2":"Cuanto más los llamaba, más se alejaban de mí. Ofrecían sacrificios a los baales,y quemaban incienso a los ídolos."
,"3":"Y yo enseñaba a Efraín a caminar, lo llevaba en brazos; pero no han comprendido que yo cuidaba de ellos."
,"4":"Con cuerdas de cariño los atraía, con lazos de amor; fui para él como quien alza a un niño sobre su propio cuello,y se inclina hacia él para darle de comer."
,"5":"Se volverán a Egipto, pero asirio será su rey,porque no han querido convertirse."
,"6":"En sus ciudades hará estragos la espada, exterminará a los profetas, los devorará por sus malos consejos."
,"7":"Mi pueblo se inclina a la apostasía; gritan a lo alto, pero nadie los levanta."
,"8":"¿Cómo voy a abandonarte, Efraín; cómo voy a traicionarte, Israel?,¿Es que voy a tratarte como a Admá, y dejarte igual que a Seboín?,Mi corazón se revuelve dentro de mí, y todas mis entrañas se estremecen."
,"9":"No actuaré según el ardor de mi ira, no destruiré más a Efraín, porque yo soy Dios, no un hombre; en medio de ti yo soy el Santo, y no me gusta destruir."
,"10":"Irán detrás del Señor, y él rugirá como un león; cuando él ruja, acudirán sus hijos de occidente."
,"11":"Acudirán desde Egipto como un pájaro, como paloma desde el país de Asiria, y yo les haré habitar en sus casas -dice el Señor-."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Efraín me rodea de mentiras, y la casa de Israel de engaños; Judá sigue con Dios y es fiel al Santo."
,"2":"Efraín se apacienta de viento,y anda sin cesar tras el viento del este; multiplica mentiras y violencias, hace un pacto con Asiria y lleva aceite a Egipto."
,"3":"El Señor se querella contra Judá, y va a castigar a Jacob con arreglo a su conducta; le va a dar la paga que merecen sus acciones."
,"4":"Desde el seno materno agarró del talón a su hermano, y de adulto peleó con Dios."
,"5":"Luchó con el ángel y lo venció, lloró y le imploró misericordia. Lo encontró en Betel, y allí habló con él."
,"6":"El Señor, Dios todopoderoso; el Señor es su nombre."
,"7":"Tú conviértete a tu Dios, practica la lealtad y la justicia, y espera en tu Dios siempre."
,"8":"Canaán tiene en su mano una balanza falsa, es amigo del fraude."
,"9":"Efraín ha dicho: Sí, me he enriquecido, me he hecho una fortuna. Pero todas sus ganancias no podrán compensar,los crímenes que haya cometido."
,"10":"Yo, el Señor, soy tu Dios desde el país de Egipto; te haré habitar de nuevo en tiendas, como en los días de nuestro encuentro."
,"11":"He hablado a los profetas, he multiplicado las visiones, y por medio de los profetas he hablado en parábolas."
,"12":"Galaad es sólo mentira. En Guilgal inmolan toros; por eso sus altares serán reducidos,a montones de piedras sobre los surcos de los campos."
,"13":"Jacob huyó a las llanuras de Siria, Israel sirvió por una mujer, por una mujer guardó rebaños."
,"14":"Pero por medio de un profeta,el Señor sacó a Israel de Egipto, y por un profeta lo ha guardado."
,"15":"Efraín ha sido para el Señor motivo de amarga pena; el Señor hará recaer sobre él la sangre derramada, el Señor le devolverá su propio ultraje."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Cuando Efraín hablaba, infundía terror en Israel; pero luego se hizo culpable con Baal, y pereció."
,"2":"Todavía continúan pecando; imágenes fundidas se han hecho con su plata, figuras de ídolos de su invención, obras todas de artesanos. Hablan con ellas, ofrecen sacrificios,y envían besos a becerros."
,"3":"Por eso serán cual nubecilla matinal, como el rocío que se esfuma presto, cual la paja aventada en la era, como el humo que sale por la ventana."
,"4":"Sin embargo, yo, el Señor, soy tu Dios desde el país de Egipto; no conoces otro Dios más que yo, no hay salvador fuera de mí."
,"5":"Yo en el desierto te cuidé, en la tierra de la sequedad."
,"6":"Yo los apacenté y se saciaron; y, una vez saciados, su corazón se envaneció,y de mí se olvidaron."
,"7":"Pues bien, seré para ellos cual león, como leopardo en el camino al acecho."
,"8":"Caeré sobre ellos como una osa privada de sus cachorros; desgarraré su corazón, los devoraré como un león, y las fieras del campo los harán pedazos."
,"9":"Voy a destruirte, Israel; ¿quién vendrá en tu socorro? "
,"10":"¿Dónde está ahora tu rey para que te salve?,¿Dónde tus jueces para que te protejan?,Porque tú decías: 'Dame rey y príncipes'."
,"11":"Un rey en mi cólera te he dado, y en mi furor te lo vuelvo a quitar."
,"12":"La culpa de Efraín está cerrada en lugar seguro, su pecado está bien guardado."
,"13":"Dolores de parturienta le sobrevendrán; pero él es un hijo insensato, que no se presenta a su hora para salir del seno."
,"14":"¿Pero yo los libraré del poder del abismo; los salvaré del poder de la muerte?,¿Dónde están, muerte, tus estragos?,¿Dónde están, abismo, tus azotes?,La compasión desaparece de mi vista."
,"15":"Efraín es fecundo entre las cañas; pero llegará el solano, el viento del Señor se alzará del desierto, secará sus manantiales, agotará sus fuentes,y se llevará todos sus tesoros, sus objetos preciosos."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Samaría será castigada,porque se ha rebelado contra su Dios. Caerán a espada, sus niños serán estrellados,y reventadas sus mujeres encinta."
,"2":"Israel, vuelve al Señor, tu Dios, porque por tu culpa te ha hecho caer."
,"3":"Buscad palabras y volved al Señor. Decidle: Perdona todas nuestras culpas,para que recobremos la felicidad,y te ofrezcamos en sacrificio palabras de alabanza."
,"4":"Asiria no nos puede salvar; no montaremos ya en los caballos, y no diremos más 'dios nuestro' a la obra de nuestras manos, pues en ti encuentra compasión el huérfano."
,"5":"Yo los curaré de su apostasía, los amaré de todo corazón, pues mi ira se ha apartado ya de ellos."
,"6":"Seré como el rocío para Israel; él florecerá como el lirio,y echará sus raíces como el olmo."
,"7":"Sus ramas se extenderán lejos, hermosas como el ramaje del olivo, y su fragancia será como la del Líbano."
,"8":"Volverán a sentarse en mi sombra; cultivarán el trigo, florecerán como la viña,y su renombre será como el del vino del Líbano."
,"9":"Efraín...  ¿qué tengo yo que ver con los ídolos?,Yo lo atenderé y lo protegeré. Yo soy como un pino siempre verde; de mí procede todo fruto."
,"10":"Que el sabio comprenda estas cosas, que el inteligente las entienda, porque los caminos del Señor son rectos; por ellos caminarán los justos, mas los injustos tropezarán en ellos."
}`)

}
func ES_LSB_LoadVNSOChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Palabra del Señor dirigida a Sofonías, hijo de Cusí, hijo de Guedalías, hijo de Amarías, hijo de Ezequías, en tiempo de Josías, hijo de Amón, rey de Judá."
,"2":"Voy a borrarlo todo de la superficie de la tierra,-dice el Señor-."
,"3":"Extirparé hombres y ganados, aves del cielo y peces del mar; haré caer a los malvados, exterminaré a los hombres de la superficie de la tierra,-dice el Señor-."
,"4":"Extenderé mi mano contra Judá,y contra todos los habitantes de Jerusalén, y exterminaré de este lugar los restos de Baal, los nombres de sus ministros y de sus sacerdotes,"
,"5":"los que se prosternan en los terrados,ante los astros del cielo; los que se prosternan ante el Señor y juran por Milcón;"
,"6":"los que se apartan del Señor,y no le buscan ni se preocupan de él."
,"7":"Silencio ante el Señor Dios, porque su día está cercano; porque el Señor ha preparado un sacrificio, ha consagrado a sus invitados."
,"8":"En el día del sacrificio del Señor,intervendré contra los ministros, contra los príncipes,y contra todos los que se visten a la moda extranjera;"
,"9":"contra los que saltan sobre los umbrales,y llenan la casa de su Señor de violencia y de fraude."
,"10":"Aquel día -dice el Señor- se darán gritos,en la puerta del Pescado, lamentos desde la ciudad nueva,y una gran sacudida desde las colinas."
,"11":"¡Gemid, habitantes del Mortero!, pues todos los mercaderes han perecido, los que trafican con dinero han sido aniquilados."
,"12":"En aquel tiempo yo registraré a Jerusalén con linterna, y castigaré a los hombres,que se sientan en sus heces y dicen: 'El Señor no hace nada, ni bien ni mal'."
,"13":"Sus riquezas serán saqueadas, sus casas derribadas; si construyeron casas, no las habitarán; si plantaron viñas, no beberán su vino."
,"14":"Cerca está el gran día del Señor, está cerca y llega velozmente. ¡Ya se oye el ruido del día del Señor, y hasta el valiente dará gritos de espanto!"
,"15":"Día de ira será el día aquel, día de tribulación y de angustia, día de calamidad y de miseria, día de tinieblas y de oscuridad, día de nubes y espesos nubarrones,"
,"16":"día de trompetas y de alarmas,contra las ciudades fortificadas y los altos torreones."
,"17":"Yo infundiré angustias a los hombres, y ellos caminarán como ciegos, porque han pecado contra el Señor; su sangre será derramada como polvo, y su carne tirada como excremento."
,"18":"Ni la plata ni el oro que poseen podrán salvarlos. En el día de la ira del Señor,la tierra entera será devorada por el fuego de su celo, pues él destruirá y exterminará de improviso,a todos los habitantes de la tierra."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Reuníos y juntaos, oh pueblo indigno,"
,"2":"antes que el decreto se cumpla,y paséis aquel día como paja, antes que caiga sobre vosotros,el furor de la ira del Señor, antes que os sobrevenga el día de la ira del Señor."
,"3":"Buscad al Señor vosotros todos, humildes de la tierra, que habéis puesto en práctica sus preceptos; buscad la justicia, buscad la humildad; quizá podáis quedar seguros el día de la ira del Señor."
,"4":"Gaza será abandonada, Ascalón arrasada, Asdod será desterrada en pleno mediodía,y Ecrón arrancada de raíz."
,"5":"¡Ay de vosotros, que habitáis el litoral, nación de los quereteos!,La palabra del Señor es contra vosotros, Canaán, tierra de filisteos: Yo te dejaré sin un solo habitante,"
,"6":"y serás reducida a pastizales, a lugar para pastores, a apriscos para el ganado."
,"7":"Y el litoral será para el resto de la casa de Judá: allí apacentarán el ganado, y por la tarde reposarán en la casa de Ascalón, porque el Señor, su Dios, les visitará,y los hará volver de su destierro."
,"8":"He oído las injurias de Moab,y los ultrajes de los hijos de Amón, que insultaron a mi pueblo,y se engrandecieron a costa de su territorio."
,"9":"Por eso, ¡por mi vida!, dice el Señor omnipotente, Dios de Israel, que Moab será como Sodoma, y los hijos de Amón como Gomorra: campos de cardos, montón de sal, desolación eterna. Los supervivientes de mi pueblo los saquearán, los que queden de mi nación los heredarán."
,"10":"Esto será el precio de su orgullo,por haber insultado al pueblo del Señor omnipotente,y haberse engrandecido a su costa."
,"11":"El Señor será terrible contra ellos. Aniquilará a todos los dioses de la tierra; se prosternarán ante él, cada uno en su país, todas las islas de las naciones."
,"12":"También vosotros, etíopes, caeréis bajo mi espada."
,"13":"Él extenderá su mano contra el norte, y destruirá a Asiria, dejará a Nínive como una desolación, árida como el desierto."
,"14":"En medio de ella se tumbarán los rebaños,y todos los animales del campo; hasta el pelícano y el erizo,pasarán la noche en sus capiteles. El búho ululará en las ventanas,y el cuervo graznará en los umbrales, porque quedó desnudo el artesonado de cedro."
,"15":"Ésta es la ciudad alegre que vivía confiada,y decía en su corazón: '¡Yo, y sólo yo!'. ¡Cómo ha quedado desolada!,¡Una guarida de fieras!,Todo el que pasa junto a ella silba y agita la mano."
}`)
	CurrentBook.AddChapter(3, `{
"1":"¡Ay de la rebelde y contaminada, la ciudad opresora!"
,"2":"No ha escuchado la voz, no ha aprendido la lección, no ha puesto su confianza en el Señor, no ha acudido a su Dios."
,"3":"Sus jefes son, en medio de ella, como leones rugientes; sus jueces, como lobos nocturnos,que no dejan nada para la mañana."
,"4":"Sus profetas son fanfarrones e impostores, sus sacerdotes profanan las cosas santas y violan la ley."
,"5":"El Señor es justo en medio de ella, no hace nada injusto; cada mañana dicta su sentencia, nunca falta al alba; pero el malvado no conoce la vergüenza."
,"6":"'Yo he exterminado a las naciones, han sido derruidas sus fortalezas, he asolado sus calles sin dejar transeúntes, han sido devastadas sus ciudades; no queda un hombre, ni un solo habitante'."
,"7":"Y me decía: 'Al menos tú me respetarás, aprenderás la lección y tu morada no será destruida'. Pero cada vez que le les he pedido cuentas,se han apresurado a corromper aún más todas sus acciones."
,"8":"Por eso, espérame -dice el Señor-,el día en que me levante como testigo de cargo. Porque he decidido reunir a las gentes, congregar a los reinos, para derramar sobre ellos mi ira, todo el furor de mi cólera; por el fuego de mi celo será devorada toda la tierra."
,"9":"Yo daré entonces a los pueblos labios puros,para que invoquen todos el nombre del Señor,y le sirvan de común acuerdo."
,"10":"Desde allende los ríos de Etiopía vendrán mis adoradores, y mis hijos dispersos me traerán sus ofrendas."
,"11":"Aquel día no tendrás que avergonzarte de los crímenes,con los que te rebelaste contra mí; porque entonces yo quitaré de en medio de ti,a tus orgullosos fanfarrones,y dejarás de presumir de mi santo monte."
,"12":"Yo dejaré en medio de ti un pueblo humilde y pobre, que esperará en el nombre del Señor,"
,"13":"el resto de Israel, que no cometerá injusticias, ni dirá mentiras, ni tendrá en su boca lengua falsa; pastarán y reposarán sin que nadie les inquiete."
,"14":"¡Canta himnos, hija de Sión, alégrate, Israel, regocíjate y goza de todo corazón, hija de Jerusalén!"
,"15":"El Señor ha retirado la sentencia que pesaba contra ti, ha alejado a tus enemigos; el Señor, rey de Israel, está en medio de ti; no tienes que temer ya ningún mal."
,"16":"Aquel día se dirá a Jerusalén: No temas, Sión, no decaigan tus manos."
,"17":"El Señor tu Dios está en medio de ti, ¡poderoso salvador! Estará lleno de gozo por ti, con su amor te dará nueva vida, bailará y gritará de alegría por ti"
,"18":"como en los días de fiesta. Apartaré de ti la desgracia,y la vergüenza que pesa sobre ti."
,"19":"En aquel tiempo exterminaré a todos tus opresores; salvaré a las cojas, recogeré a las extraviadas, y haré de ellas un objeto de gloria,y renombre en todos los países donde fueron despreciadas."
,"20":"En aquel tiempo os traeré, en aquel tiempo os congregaré. Os daré gloria y renombre,entre todos los pueblos de la tierra, cuando lleve a cabo vuestra restauración,a vuestros propios ojos -dice el Señor-."
}`)

}
func ES_LSB_LoadVNZAChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"El mes octavo del año segundo de Darío fue dirigida esta palabra del Señor al profeta Zacarías, hijo de Berequías, hijo de Idó:"
,"2":"'El Señor se irritó grandemente con vuestros padres."
,"3":"Les dirás: Volved a mí, palabra del Señor todopoderoso, y yo me volveré a vosotros, dice el Señor todopoderoso."
,"4":"No seáis como vuestros padres, a quienes predicaron los profetas del pasado. Esto dice el Señor todopoderoso: Convertíos de vuestra mala conducta y de vuestras malas acciones. Pero no les escucharon ni me hicieron caso a mí, palabra del Señor."
,"5":"¿Dónde están vuestros padres? Y los profetas, ¿vivirán siempre?"
,"6":"Pero mis palabras y los preceptos que mandé a mis siervos los profetas, ¿no llegaron a vuestros padres? Entonces se convirtieron y dijeron: El Señor había pensado tratarnos según nuestra conducta y nuestras acciones, y así nos ha tratado'."
,"7":"El día veinticuatro del mes once, el mes de sebat, fue dirigida esta palabra del Señor al profeta Zacarías, hijo de Berequías, hijo de Idó:"
,"8":"'Tuve un sueño durante la noche. Vi un jinete sobre un caballo rojo, que estaba entre los mirtos que había en un valle profundo; detrás de él había caballos rojos, alazanes, negros y blancos."
,"9":"Y pregunté: ¿Quiénes son, Señor? Y el ángel que hablaba conmigo me contestó: Yo te explicaré lo que éstos representan."
,"10":"Y el hombre que estaba entre los mirtos dijo: Éstos son los que envió el Señor para recorrer la tierra."
,"11":"Entonces se dirigieron al ángel del Señor que estaba entre los mirtos, y le dijeron: Hemos recorrido la tierra, y toda ella está tranquila y en paz."
,"12":"Entonces el ángel del Señor continuó: Señor todopoderoso, ¿cuándo te compadecerás de Jerusalén y de las ciudades de Judá, contra las cuales estás tan indignado hace ya setenta años?"
,"13":"Y el Señor dio al ángel que hablaba conmigo buenas palabras, palabras de consuelo."
,"14":"Después el ángel que hablaba conmigo me dijo: Grita: Esto dice el Señor todopoderoso: Siento ardientes celos por Jerusalén y por Sión,"
,"15":"y estoy muy indignado contra las gentes que viven despreocupadamente; yo estaba un poco indignado, pero ellos han aumentado su maldad."
,"16":"Por tanto, esto dice el Señor: Me compadezco de nuevo de Jerusalén; mi casa será edificada en ella, palabra del Señor todopoderoso, y la plomada será tendida sobre Jerusalén."
,"17":"Grita de nuevo y di: Esto dice el Señor todopoderoso: De nuevo abundarán en bienes mis ciudades; el Señor se compadecerá nuevamente de Sión y elegirá a Jerusalén'."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Después levanté mis ojos y tuve una visión. Vi cuatro cuernos."
,"2":"Y pregunté al ángel que hablaba conmigo: '¿Qué son estos cuernos? Y me contestó: Éstos son los cuernos que dispersaron a Judá, Israel y Jerusalén."
,"3":"Después el Señor me hizo ver cuatro herreros."
,"4":"Y pregunté: ¿Qué vienen a hacer éstos aquí? Y me contestó: Aquellos cuernos son los que subyugaron a Judá, de tal manera que nadie levantó su cabeza; estos herreros vinieron a hacerles temblar de espanto, a derribar los cuernos de las gentes que levantaron su poder contra la tierra de Judá para dispersarla'."
,"5":"Entonces levanté mis ojos y tuve una visión. Vi a un hombre que tenía en su mano una cinta de medir."
,"6":"Yo le dije: '¿Dónde vas? Y me contestó: A medir a Jerusalén para ver cuál es su anchura y su longitud."
,"7":"Entonces el ángel que hablaba conmigo se quedó parado, y otro ángel se le adelantó"
,"8":"y le dijo: Corre y di a este joven: Jerusalén será una ciudad abierta a causa de la cantidad de hombres y animales que habrá en ella."
,"9":"Yo mismo seré para ella, palabra del Señor, un muro de fuego en su alrededor, y en medio de ella yo seré su gloria'."
,"10":"¡Hala! ¡Hala! Huid de la tierra del norte, palabra del Señor, pues os dispersé, por los cuatro puntos cardinales, palabra del Señor."
,"11":"¡Hala! Sálvate, Sión, tú que habitas en Babilonia."
,"12":"Porque esto dice el Señor omnipotente,-el que me ha enviado con autoridad-,a propósito de las naciones que os han saqueado: el que os toca a vosotros, toca la pupila de mis ojos."
,"13":"Yo levantaré mi mano contra ellas, y serán presa de los que eran sus esclavos. Entonces sabréis que el Señor omnipotente me ha enviado."
,"14":"Canta y alégrate, hija de Sión, porque yo vengo a habitar en medio de ti, palabra del Señor."
,"15":"En aquel día muchos pueblos se unirán al Señor. Ellos serán también mi propio pueblo, yo habitaré en medio de ti,y tú reconocerás que el Señor omnipotente me ha enviado a ti. "
,"16":"El Señor poseerá a Judá,como su heredad en la tierra santa, y elegirá de nuevo a Jerusalén."
,"17":"Que todo el mundo calle ante el Señor, porque se levanta de su santa morada."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Luego el Señor me hizo ver a Josué, el sumo sacerdote, que estaba delante del ángel del Señor, mientras que Satán estaba a la derecha para acusarle."
,"2":"El ángel del Señor dijo a Satán: 'Que el Señor te reprima, Satán; que el Señor, que eligió a Jerusalén, te reprima. ¿No es éste como un tizón sacado del fuego?"
,"3":"Josué estaba vestido con ropas sucias y de pie delante del ángel."
,"4":"El ángel tomó la palabra y dijo a los que estaban delante: Quitadle de encima esas ropas sucias. Después dijo a Josué: Mira, he quitado de encima de ti tus pecados y te he vestido con vestidos preciosos."
,"5":"Y añadió: Poned sobre su cabeza un turbante limpio. Pusieron sobre su cabeza un turbante limpio y le vistieron en presencia del ángel del Señor."
,"6":"Entonces el ángel del Señor declaró a Josué:"
,"7":"Esto dice el Señor todopoderoso: Si sigues mis caminos y guardas mis mandamientos, tú gobernarás mi casa, serás guardián de mis atrios y te haré llegar al rango de estos que están aquí."
,"8":"Escucha, pues, Josué, sumo sacerdote, tú y tus compañeros que se sientan delante de ti, porque vosotros sois hombres de presagio: Yo voy a hacer venir a mi siervo Germen."
,"9":"Pues ahí está la piedra que he puesto ante Josué: sobre esta única piedra hay siete ojos; yo mismo grabaré su inscripción, palabra del Señor todopoderoso, y borraré el pecado de la tierra en un solo día."
,"10":"En aquel día, palabra del Señor todopoderoso, os invitaréis mutuamente los unos a los otros a la sombra de la parra y de la higuera'."
}`)
	CurrentBook.AddChapter(4, `{
"1":"El ángel que hablaba conmigo volvió y me despertó como a uno que le despiertan de un sueño."
,"2":"Y me dijo: '¿Qué ves? Yo contesté: Veo un candelabro todo de oro con su aceitera en la parte superior; en él hay siete lámparas y siete tubos por los que les llega el aceite."
,"3":"Junto a él hay dos olivos, uno a su derecha y otro a su izquierda."
,"4":"Pregunté al ángel que hablaba conmigo: ¿Qué significa esto, señor?"
,"5":"El ángel que me hablaba me dijo: ¿No sabes qué significan estas cosas? Yo respondí: No, señor."
,"6a":"Entonces me dijo:"
,"10b":"Estos siete son los ojos del Señor que recorren toda la tierra."
,"11":"Volví a hablar y pregunté: ¿Qué significan aquellos dos olivos que hay a la derecha y a la izquierda del candelabro?"
,"12":"Y le pregunté por segunda vez: ¿Qué significan las dos ramas de olivo que por medio de los tubos de oro vacían el aceite en las lámparas de oro?"
,"13":"Él me respondió: ¿No sabes qué significa esto? Yo dije: No, señor."
,"14":"Él prosiguió: Éstos son los dos ungidos que están ante el Señor de toda la tierra'."
,"6":"Ésta es la palabra del Señor sobre Zorobabel: 'No por el poder de las armas ni por la violencia, sino por mi espíritu, palabra del Señor todopoderoso."
,"7":"¿Quién eres tú, monte grande? Ante Zorobabel, como una llanura; él sacará la piedra clave entre gritos de júbilo: ¡Qué hermosa es! ¡Qué hermosa es!"
,"8":"Y el Señor me dijo:"
,"9":"Zorobabel puso los cimientos en esta casa, y él mismo terminará la obra. Entonces reconoceréis que el Señor me ha enviado a vosotros."
,"10a":"Porque los que no hacían caso en los primeros días se alegrarán y verán la plomada en manos de Zorobabel'."
}`)
	CurrentBook.AddChapter(5, `{
"1":"De nuevo levanté mis ojos y tuve una visión. Vi un libro que volaba."
,"2":"El ángel me preguntó: '¿Qué ves? Yo respondí: Veo un libro que vuela; tiene diez metros de largo y cinco de ancho."
,"3":"Entonces me dijo: Ésta es la maldición que se extiende sobre toda la tierra. En una cara del libro está escrito: Todo ladrón será eliminado, y en la otra: Todo el que jura en falso será eliminado."
,"4":"Yo lanzo la maldición, palabra del Señor todopoderoso, para que vaya a casa del ladrón y a casa del que jura en falso, permanezca en medio de su casa y consuma sus maderas y sus piedras'."
,"5":"El ángel que hablaba conmigo vino y me dijo: 'Levanta tus ojos y mira qué es aquello que aparece allí."
,"6":"Y pregunté: ¿Qué es? Él respondió: Es una medida de cuarenta y cinco litros. Y añadió: Éste es el pecado en toda la tierra."
,"7":"Entonces se levantó la tapa de plomo, y vi una mujer sentada dentro de la medida."
,"8":"Él me dijo: Éste es el pecado, y la metió dentro de la medida y la cerró con la tapa de plomo."
,"9":"Levanté mis ojos y tuve otra visión. Vi dos mujeres. El viento soplaba en sus alas; sus alas eran como alas de cigüeña, y levantaron la medida entre la tierra y el cielo."
,"10":"Entonces pregunté al ángel que hablaba conmigo: ¿Dónde llevan la medida?"
,"11":"Y me contestó: A la tierra de Senaar, para edificarle un templo y prepararle un pedestal para colocarla sobre él'."
}`)
	CurrentBook.AddChapter(6, `{
"1":"De nuevo levanté mis ojos y tuve una visión. Vi cuatro carros que salían de entre dos montes; los montes eran de bronce."
,"2":"El primer carro estaba tirado por caballos rojos, el segundo por caballos negros,"
,"3":"el tercero por caballos blancos y el cuarto por caballos rojizos."
,"4":"Entonces pregunté al ángel que hablaba conmigo: '¿Qué significan éstos, señor?"
,"5":"El ángel me respondió: Son los cuatro vientos del cielo, que salen de la presencia del Señor de toda la tierra."
,"6":"Los carros tirados por caballos rojos salen para el este, los negros para el norte, los blancos para el oeste y los rojizos para el sur."
,"7":"Los rojizos salieron impacientes para recorrer la tierra. Entonces el Señor les ordenó: Id, recorred la tierra. Y ellos recorrieron la tierra."
,"8":"Él me llamó y me dijo: Mira, los que salen para la tierra del norte llevan el espíritu del Señor a la tierra del norte'."
,"9":"El Señor me dirigió esta palabra:"
,"10":"'Haz una colecta entre los desterrados: Jelday, Tobías y Yedayas, y vete a casa de Josías, hijo de Sofonías, que ha venido de Babilonia."
,"11":"Toma la plata y el oro, haz una corona y ponla en la cabeza de Josué, hijo de Yehosadac, el sumo sacerdote."
,"12":"Y dile: Esto dice el Señor todopoderoso: He aquí un hombre cuyo nombre es Germen; bajo sus pasos todo germinará."
,"13":"Él construirá el templo del Señor, será revestido de majestad y se sentará en el trono para gobernar. Tendrá un sacerdote a su derecha y habrá perfecto acuerdo entre los dos."
,"14":"La corona quedará en el templo del Señor como recuerdo para Jelday, Tobías, Yedayas y Josías, el hijo de Sofonías."
,"15":"Los que están lejos vendrán y trabajarán en la construcción del templo del Señor. Así reconoceréis que el Señor todopoderoso me ha enviado a vosotros. Esto ocurrirá si obedecéis la palabra del Señor, vuestro Dios'."
}`)
	CurrentBook.AddChapter(7, `{
"1":"El año cuarto del rey Darío, el día cuatro del mes noveno, el mes de quisléu, la palabra del Señor fue dirigida a Zacarías."
,"2":"Betel-Sareser, gran oficial del rey, y sus gentes enviaron una delegación para implorar la gracia del Señor"
,"3":"y para preguntar a los sacerdotes del templo del Señor todopoderoso y a los profetas lo siguiente: '¿Debo continuar guardando luto y ayunando el mes quinto como lo vengo haciendo tantos años?'."
,"4":"Entonces me fue dirigida esta palabra del Señor todopoderoso:"
,"5":"'Di a todo el pueblo de la tierra y a los sacerdotes: Cuando ayunabais y guardabais luto el quinto y el séptimo mes, ¿ayunabais por amor mío?"
,"6":"Y cuando comíais y bebíais, ¿no lo hacíais por vosotros?"
,"7":"¿No conocéis las palabras que anunció el Señor por medio de los profetas de entonces, cuando Jerusalén estaba habitada, con sus ciudades de alrededor, y el Negueb y la Llanura estaban poblados?'."
,"8":"El Señor dirigió a Zacarías esta palabra:"
,"9":"'Esto dice el Señor todopoderoso: Practicad la justicia y la fidelidad, ejerced la piedad y la misericordia cada uno con su hermano."
,"10":"No explotéis a la viuda y al huérfano, al emigrante y al pobre, y nadie piense en hacer mal a su hermano."
,"11":"Pero ellos no quisieron atender, volvieron la espalda y se hicieron los sordos."
,"12":"Endurecieron su corazón como el diamante para no escuchar la enseñanza y las palabras que el Señor todopoderoso inspiró a los profetas pasados. Entonces el Señor todopoderoso se irritó muchísimo."
,"13":"Y sucedió que, así como él los llamaba y no quisieron escuchar, así también ellos clamaron y yo no los escuché, dice el Señor todopoderoso."
,"14":"Los dispersé entre los pueblos a quienes no conocían, y la tierra quedó desolada después de su partida, de tal manera que nadie pasaba por ella. La tierra de delicias quedó convertida en desierto'."
}`)
	CurrentBook.AddChapter(8, `{
"1":"El Señor todopoderoso me dirigió esta palabra: Esto dice el Señor todopoderoso:"
,"2":"'Estoy enamorado de Sión,con un amor lleno de celos, y una gran cólera se enciende en mí a favor suyo'."
,"3":"Esto dice el Señor omnipotente: 'Vuelvo a Sión y habitaré en Jerusalén. Jerusalén será llamada de nuevo ciudad fiel, y la montaña del Señor omnipotente, montaña santa'."
,"4":"Esto dice el Señor omnipotente: 'Ancianos y ancianas se sentarán todavía,en las plazas de Jerusalén; tendrán un bastón en su mano,a causa de sus muchos años,"
,"5":"y las calles de la ciudad estarán llenas de niños y niñas,que jugarán en sus plazas'."
,"6":"Esto dice el Señor omnipotente: 'Si el resto de este pueblo juzga que esto es imposible, ¿lo tendré yo que juzgar también como imposible?', palabra del Señor omnipotente."
,"7":"Esto dice el Señor omnipotente: 'Libraré a mi pueblo del país de oriente,y del país de occidente;"
,"8":"yo los traeré para que habiten en Jerusalén. Ellos serán mi pueblo, y yo seré su Dios en la fidelidad y en la justicia'."
,"9":"Esto dice el Señor todopoderoso: 'Cobrad ánimo los que oís en estos días estas palabras de la boca de los profetas, desde el día en que fueron echados los cimientos del templo del Señor todopoderoso para reconstruir el santuario."
,"10":"Porque antes de estos días no había salario para el hombre, los animales no pillaban nada, no había seguridad de movimientos para nadie de cara al agresor. Yo mismo había enzarzado a los hombres unos contra otros."
,"11":"Pero ahora no seré como antes para con el resto de este pueblo, palabra del Señor todopoderoso."
,"12":"Pues yo sembraré la paz; la viña dará su fruto, la tierra dará sus productos y el cielo enviará su rocío. Yo daré todo esto en posesión al resto de este pueblo."
,"13":"Y así como antes erais maldecidos por las gentes, casa de Judá y casa de Israel, así ahora os libraré y seréis bendecidos. No temáis y cobrad ánimo'."
,"14":"Esto dice el Señor todopoderoso: 'Como decidí castigaros porque vuestros padres me habían irritado, dice el Señor todopoderoso, y no me compadecí, "
,"15":"así vuelvo a pensar en estos días en bendecir a Jerusalén y a la casa de Judá. No temáis."
,"16":"Éstas son las palabras que debéis practicar: Decíos mutuamente la verdad, administrad en vuestras puertas una justicia que engendre la paz,"
,"17":"no penséis en hacer mal el uno al otro, no seáis partidarios del juramento falso. Porque yo detesto todas estas cosas, palabra del Señor'."
,"18":"El Señor todopoderoso me dirigió esta palabra:"
,"19":"Esto dice el Señor todopoderoso: 'El ayuno del cuarto, quinto, séptimo y décimo mes se convertirá para la casa de Judá en júbilo y alegría y en alegres fiestas; pero amad la lealtad y la paz'."
,"20":"Esto dice el Señor todopoderoso: 'Vendrán pueblos y habitantes de ciudades populosas."
,"21":"Los habitantes de una ciudad irán a otra diciendo: Vamos a apaciguar al Señor, a buscar al Señor todopoderoso. Yo también voy."
,"22":"Y muchos pueblos y naciones poderosas vendrán a Jerusalén a buscar al Señor todopoderoso y a apaciguar al Señor'."
,"23":"Esto dice el Señor todopoderoso: 'En aquellos días diez hombres de todas las lenguas del mundo agarrarán a un judío de la orla de su vestido y le dirán: Dejadnos ir con vosotros, pues hemos oído que Dios está con vosotros'."
}`)
	CurrentBook.AddChapter(9, `{
"1":"La palabra del Señor ha pasado por el país de Jadrac,y se ha parado en Damasco, pues al Señor pertenecen las ciudades de Siria, así como todas las tribus de Israel."
,"2":"Y también Jamat, su vecina, Tiro y Sidón, tan sabias ellas."
,"3":"Tiro construyó una fortaleza, amontonó plata como polvo y oro,como el polvo de las plazas."
,"4":"Pero el Señor se apoderará de todo, arrojará al mar todas sus riquezas,y será devorada por el fuego."
,"5":"Ascalón, al verlo, se estremecerá; y Gaza temblará de miedo; Ecrón estará consternada al ver destruida su esperanza; desaparecerá el rey de Gaza,y Ascalón no volverá a ser habitada."
,"6":"En Asdod habitará gente bastarda, y destruiré la soberbia de los filisteos."
,"7":"Quitaré de su boca la sangre, y de entre sus dientes las comidas prohibidas. Ellos serán también como un resto para nuestro Dios, y como una familia en Judá. Ecrón será como el jebuseo."
,"8":"Me colocaré junto a mi casa,como un guardián contra los que van y vienen. No volverá a pasar por ella el opresor, pues ahora yo vigilo con mis propios ojos."
,"9":"Salta de júbilo, hija de Sión; alégrate, hija de Jerusalén, porque tu rey viene a ti: justo y victorioso, humilde y montado en un asno, joven cría de una asna."
,"10":"Hará que desaparezcan los carros de guerra de Efraín,y los caballos de Jerusalén, y desaparecerá el arco de guerra. Él anunciará la paz a las naciones,y dominará de mar a mar,y desde el río hasta los confines de la tierra."
,"11":"En cuanto a ti, por la sangre de la alianza hecha contigo, sacaré a tus presos de la fosa, en la que no hay agua."
,"12":"Volved a la plaza fuerte, prisioneros llenos de esperanza. Hoy mismo lo proclamo: te voy a restituir el doble."
,"13":"Porque yo tenso mi arco, Judá, y pondré como flecha a Efraín. Blandiré a tus hijos, Sión (contra tus hijos, Yaván), y te haré como la espada de un héroe."
,"14":"El Señor aparecerá sobre ellos, y lanzará sus flechas como rayos. El Señor tocará la trompeta,y marchará en los torbellinos del sur."
,"15":"El Señor todopoderoso los protegerá. Ellos pisarán con sus pies las piedras de la honda, beberán su sangre como el vino, se saciarán como los cuernos del altar."
,"16":"El Señor, su Dios, los salvará en aquel día, apacentará a su pueblo como un rebaño, como piedras de diadema brillarán en su tierra."
,"17":"¡Qué felicidad! ¡Qué belleza!,El trigo dará vigor a los jóvenes, y el mosto a las jóvenes."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Pedid al Señor la lluvia en la primavera. El Señor es quien forma los relámpagos,y envía lluvia abundante. Él da el pan al hombre y la hierba al ganado."
,"2":"Pues los ídolos dan respuestas vanas, los adivinos anuncian mentiras, cuentan sueños fantásticos,y dan consolaciones ilusorias. Por eso el pueblo anda errante,y perdido como un rebaño sin pastor."
,"3":"Mi ira se ha encendido contra los pastores, castigaré a los machos cabríos. Sí, el Señor todopoderoso visitará su rebaño,-la casa de Judá-,y le hará como un caballo brioso en la batalla."
,"4":"De Judá saldrá la piedra angular, la estaca de la tienda, el arco de guerra, de él saldrán todos los jefes."
,"5":"Serán como héroes en la batalla,que pisan el polvo de las calles; pelearán porque el Señor está con ellos, y los jinetes serán cubiertos de vergüenza."
,"6":"Y haré fuerte a la casa de Judá,y victoriosa a la casa de José. Les haré retornar a la patria, siento compasión por ellos; serán como si no los hubiese nunca rechazado."
,"7":"Efraín será como un héroe, se alegrará su corazón como por el vino; sus hijos, al verlos, se llenarán de alegría, y su corazón se regocijará en el Señor."
,"8":"Daré un silbido y los reuniré,porque yo los he rescatado,y los haré tan numerosos como antes."
,"9":"Yo los he dispersado entre los pueblos, y a lo lejos se acordarán de mí; allí crecerán sus hijos y retornarán."
,"10":"Los haré volver de Egipto, y los reuniré de Asiria; los traeré a la tierra de Galaad y al Líbano, y no habrá bastante sitio para ellos."
,"11":"Atravesarán el mar de Egipto,-él herirá las olas del mar-, se secarán las profundidades del Nilo. El orgullo de Asiria será humillado, y el cetro de Egipto será quitado."
,"12":"Pondrán su fuerza en el Señor,y marcharán seguros en su nombre, dice el Señor."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Abre tus puertas, Líbano, y que el fuego devore tus cedros."
,"2":"Gime de dolor, ciprés, porque ha caído el cedro, porque los poderosos han sido derribados. Gemid, encinas de Basán, pues fue talada la selva impenetrable."
,"3":"Escuchad el gemido de los pastores, porque los espléndidos pastos han sido abrasados; se oye el rugido de los leones, porque el esplendor del Jordán ha sido devastado."
,"4":"Esto dice el Señor todopoderoso: Apacienta las ovejas para el matadero."
,"5":"Sus compradores las mataban sin incurrir en sanción, y sus vendedores dicen: 'Bendito sea el Señor; me voy a hacer rico'. Y sus pastores no tienen compasión de ellas."
,"6":"Pues no volveré yo a tener compasión de los habitantes de la tierra, palabra del Señor. Voy a entregar a cada hombre en manos de su prójimo y en manos de su rey. Ellos devastarán la tierra, y yo no los libraré de sus manos."
,"7":"Entonces me puse a apacentar las ovejas del matadero por cuenta de los tratantes. Tomé dos cayados; a uno le puse por nombre Benevolencia y al otro le llamé Unión, y me puse a apacentar las ovejas."
,"8":"En un mes rechacé a tres pastores. Llegué a asquearme de las ovejas, y también ellas se cansaron de mí."
,"9":"Y dije: No os apacentaré más; la que haya de morir muera, y la que haya de perecer perezca, y las que queden que se coman unas a otras."
,"10":"Después tomé el cayado Benevolencia y lo rompí, para romper el pacto que el Señor había hecho con todos los pueblos."
,"11":"Y los tratantes que me vigilaban reconocieron que ésta era la palabra del Señor."
,"12":"Después les dije: Si os parece bien, dadme mi salario; y si no, dejadlo. Y me pagaron treinta monedas de plata."
,"13":"Y el Señor me dijo: Echa al tesoro ese magnífico precio en que me han tasado. Yo tomé treinta monedas de plata y las eché en el tesoro del templo del Señor. "
,"14":"A continuación rompí el segundo cayado, Unión, para romper la hermandad entre Judá e Israel."
,"15":"Y el Señor me dijo: Toma otra vez el ajuar de un pastor insensato."
,"16":"Porque voy a poner en este país a un pastor insensato, que no se preocupará de la oveja perdida, ni buscará la que anda descarriada, ni curará a la herida, ni alimentará a las sanas; sino que comerá la carne de las más gordas y no dejará ni las pezuñas."
,"17":"¡Ay del pastor infiel que abandona las ovejas!,¡Que la espada venga sobre su brazo y sobre su ojo derecho!,¡Que su brazo se seque,y que su ojo derecho quede completamente ciego!"
}`)
	CurrentBook.AddChapter(12, `{
"1":"Palabra del Señor sobre Israel. Palabra del Señor, el que extendió los cielos, puso los cimientos sobre la tierra y ha formado el espíritu en el interior del hombre."
,"2":"Yo haré de Jerusalén una copa llena de licor embriagante para todos los pueblos de alrededor. También Judá estará en el asedio de Jerusalén."
,"3":"Aquel día haré yo de Jerusalén una piedra muy pesada para todos los pueblos; todos los que intenten levantarla serán gravemente heridos. Todos los habitantes de la tierra se juntarán contra ella."
,"4":"En aquel día, palabra del Señor, heriré de espanto a los caballos, y a sus jinetes de locura. Yo miraré por Judá, pero heriré de ceguera a todos los caballos de las naciones."
,"5":"Entonces los jefes de Judá se dirán: 'Los habitantes de Jerusalén tienen su fuerza en el Señor todopoderoso, su Dios'."
,"6":"En aquel día yo haré de los jefes de Judá como una olla puesta sobre fuego de leña y como hachas encendidas en un manojo; ellos devorarán a derecha y a izquierda a todos los pueblos de alrededor, y Jerusalén será de nuevo habitada en su lugar."
,"7":"En aquel día el Señor protegerá en primer lugar todas las tiendas de Judá para que no supere el esplendor de la casa de David, y la gloria de los habitantes de Jerusalén a la de Judá."
,"8":"En aquel día el Señor manifestará su protección a los habitantes de Jerusalén, y ocurrirá que los que se tambalean de entre ellos serán como David, y la casa de David será como Dios, como un ángel del Señor a su vista."
,"9":"En aquel día yo me pondré a aniquilar a todos los pueblos que vinieron contra Jerusalén."
,"10":"Pero entonces infundiré sobre la casa de David y sobre los habitantes de Jerusalén un espíritu de buena voluntad y de súplica. Volverán sus ojos hacia el que traspasaron con la espada y harán luto por él como por un hijo único. Y llorarán por Jerusalén como se llora por el primogénito."
,"11":"En aquel día será tan grande el llanto sobre Jerusalén como el llanto de Hadad-Rimón en la llanura de Meguido."
,"12":"Se hará duelo en todo el país, familia por familia; la familia de la casa de David por sí, y sus mujeres aparte; la familia de la casa de Natán por sí, y sus mujeres aparte;"
,"13":"la familia de la casa de Leví por sí, y sus mujeres aparte; la familia de Semeí por sí, y sus mujeres aparte;"
,"14":"todas las familias restantes, cada una por sí, y sus mujeres aparte."
}`)
	CurrentBook.AddChapter(13, `{
"1":"En aquel día brotará un manantial para la casa de David y los habitantes de Jerusalén, para lavar los pecados e impurezas."
,"2":"En aquel día, palabra del Señor todopoderoso, extirparé de la tierra los nombres de los ídolos, y no se acordarán más de ellos; también haré desaparecer de la tierra los profetas y el espíritu de impureza."
,"3":"Y si alguno vuelve a profetizar, su propio padre y su propia madre le dirán: 'Tú no debes vivir, pues has dicho mentira en nombre del Señor'. Y mientras esté profetizando, sus mismos padres lo atravesarán."
,"4":"En aquel día cada profeta se avergonzará de su visión mientras profetiza, y no se vestirá más con su manto de pelo para engañar."
,"5":"Cada uno dirá: 'Yo no soy profeta; soy labrador, el campo es mi ocupación desde mi juventud'."
,"6":"Y si alguno le pregunta: '¿Qué cicatrices son esas que hay en tus manos?', él responderá: 'Las que me hicieron en casa de mis amantes'."
,"7":"Espada, despiértate contra mi pastor y contra el hombre de mi compañía, palabra del Señor omnipotente. Hiere al pastor y las ovejas se dispersarán, yo volveré mis manos aún contra los más débiles."
,"8":"Entonces en todo el país -palabra del Señor-,dos terceras partes perecerán, y quedará la otra tercera parte."
,"9":"Y haré pasar por el fuego a esta tercera parte: la purificaré como se purifica la plata, y la probaré como se prueba el oro. Él invocará mi nombre, y yo le escucharé; yo diré: 'Éste es mi pueblo', y él dirá: 'El Señor es mi Dios'."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Ya viene el día del Señor, en que se repartirán el botín en medio de ti."
,"2":"El Señor reunirá a todas las naciones para luchar contra Jerusalén. La ciudad será tomada, las casas serán saqueadas y las mujeres violadas. La mitad de la ciudad saldrá para el destierro, pero el resto del pueblo no será exterminado de la ciudad."
,"3":"Después el Señor saldrá a campaña y peleará contra esas naciones como cuando luchaba el día de la batalla."
,"4":"Pondrá su pie en el monte de los Olivos, que está delante de Jerusalén, al oriente. El monte de los Olivos se dividirá en su punto medio en dirección este-oeste, dejando en el medio un gran valle; una mitad del monte se apartará hacia el norte, y la otra mitad hacia el sur."
,"5":"Y se allanará el valle del Hinón, se allanará como se allanó a causa del terremoto en los días de Ozías, rey de Judá. Y vendrá el Señor, tu Dios, acompañado de todos sus santos."
,"6":"En aquel día no habrá ni frío ni hielo."
,"7":"Será un día único, solamente conocido por el Señor, sin cambio de día y noche, pues al tiempo de la noche habrá luz."
,"8":"En aquel día brotarán aguas vivas de Jerusalén, la mitad de ellas hacia el mar oriental y la otra mitad hacia el mar occidental; correrán en verano y en invierno."
,"9":"Y el Señor reinará sobre toda la tierra. En aquel día el Señor será único, y único será su nombre."
,"10":"Todo el país se convertirá en llanura, desde Guibeá hasta Rimón en el Negueb. Jerusalén será elevada, pero en su mismo sitio, desde la puerta de Benjamín hasta el lugar de la puerta Primera, es decir, hasta la puerta del Ángulo, y desde la torre de Jananel hasta los lagares del rey."
,"11":"Jerusalén será habitada, no será más destruida y sus habitantes vivirán seguros."
,"12":"Ésta será la plaga con la que el Señor castigará a todos los pueblos que lucharon contra Jerusalén: se les pudrirán sus carnes estando aún en pie, sus ojos se pudrirán en sus órbitas, su lengua se pudrirá en su boca."
,"13":"En aquel día el Señor provocará un gran pánico entre ellos; cada uno echará mano al otro, y lucharán cuerpo a cuerpo."
,"14":"También Judá luchará con Jerusalén. Las riquezas de todos los pueblos de alrededor serán reunidas: oro, plata y vestidos en gran cantidad."
,"15":"Así será también la plaga de los caballos, mulos, camellos y asnos, y de todas las bestias que haya en aquellos campos."
,"16":"Todos los supervivientes de todos los pueblos que vinieron a luchar contra Jerusalén irán año tras año a adorar al rey, al Señor todopoderoso, y a celebrar la fiesta de los tabernáculos."
,"17":"Para las familias de la tierra que no vayan a Jerusalén a adorar al rey, el Señor todopoderoso, no habrá lluvia."
,"18":"Y si la familia de Egipto no quiere venir, también sobre ella vendrá la plaga con la que el Señor castigará a las naciones que no vayan a celebrar la fiesta de los tabernáculos."
,"19":"Éste será el castigo de Egipto y el castigo de todas las naciones que no vayan a celebrar la fiesta de los tabernáculos."
,"20":"En aquel día estará escrito sobre todas las campanillas de los caballos: 'Consagrado al Señor', y las ollas en el templo del Señor serán como los aspersorios delante del altar."
,"21":"Todas las ollas en Jerusalén y en Judá serán consagradas al Señor todopoderoso; vendrán todos los que ofrezcan sacrificios, las tomarán y se servirán de ellas para cocer, y no habrá ya mercaderes en el templo del Señor todopoderoso en aquel día."
}`)

}
func ES_LSB_LoadVPDTChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Éstas son las palabras que Moisés dirigió a todo Israel cuando todavía estaba al otro lado del Jordán, en el desierto, en la Arabá, que está frente a Suf, entre Parán, Tofel, Labán, Jaserot y Di Zahab."
,"2":"Desde el Horeb a Cades Barne, por los montes de Seír, hay once días de camino."
,"3":"El primer día del undécimo mes del año cuarenta, Moisés dijo a los israelitas lo que el Señor le había ordenado,"
,"4":"después de haber derrotado a Sijón, rey de los amorreos, que vivía en Jesbón, y a Og, rey de Basán, que vivía en Astarot y Edreí."
,"5":"Al otro lado del Jordán, en tierras de Moab, empezó Moisés a promulgar esta ley:"
,"6":"'El Señor, nuestro Dios, nos dijo en el Horeb: Ya habéis estado bastante tiempo en este monte."
,"7":"Levantad el campamento y dirigíos a la montaña de los amorreos y a todas sus regiones vecinas: la Arabá, la montaña, la Sefela, el Negueb, el litoral, la tierra de los cananeos, el Líbano, hasta el río grande, el Éufrates."
,"8":"Éstos son los dominios que yo pongo en vuestras manos. Entrad y tomad posesión de esta tierra que el Señor juró dar a vuestros padres, a Abrahán, Isaac y Jacob, a ellos y a sus descendientes."
,"9":"Entonces os dije: Yo solo no puedo llevar todo vuestro peso;"
,"10":"el Señor, vuestro Dios, os ha multiplicado de tal manera que hoy sois tan numerosos como las estrellas del cielo."
,"11":"El Señor, el Dios de vuestros padres, os multiplique mil veces más y os bendiga según su promesa."
,"12":"Pero ¿cómo puedo yo solo soportar vuestro peso, vuestras cargas y vuestros pleitos?"
,"13":"Elegíos entre vuestras tribus hombres sabios, prudentes, probados, y yo los constituiré vuestros jefes."
,"14":"Vosotros respondisteis: Nos parece bien lo que dices."
,"15":"Yo tomé entonces vuestros jefes de tribu, hombres sabios y probados, y os los di por jefes: jefes de millar, de centena, cincuentena y decena, y oficiales para vuestras tribus."
,"16":"Al mismo tiempo di esta orden a vuestros jueces: Atended a vuestros hermanos y haced justicia en sus diferencias mutuas o con extranjeros."
,"17":"No tengáis en cuenta en vuestros juicios la apariencia de la persona; oíd a los pequeños lo mismo que a los grandes sin temor a nadie, pues el juicio pertenece a Dios. Y si os encontráis con alguna causa difícil, traedla a mí para que yo la resuelva."
,"18":"Yo os ordené entonces todo lo que debíais hacer."
,"19":"Salimos del Horeb, recorrimos todo el vasto y temible desierto que habéis visto, camino de la montaña de los amorreos, según nos había ordenado el Señor, nuestro Dios, y llegamos a Cades Barne'."
,"20":"'Allí os dije: Ya habéis llegado a la montaña de los amorreos, que el Señor, nuestro Dios, nos da."
,"21":"El Señor, tu Dios, pone en tus manos esta tierra; sube y toma posesión de ella, como te ha dicho el Señor, Dios de tus padres. No temas ni te acobardes."
,"22":"Y vinisteis todos a decirme: Enviemos por delante hombres que exploren la tierra y nos informen sobre el camino que debemos seguir y las ciudades a las que podemos llegar."
,"23":"Me pareció bien vuestra propuesta y elegí doce hombres de entre vosotros, uno por tribu."
,"24":"Dieron media vuelta, subieron la montaña y se internaron hasta el valle de Escol, que exploraron."
,"25":"Tomaron frutos de la tierra, nos los trajeron y nos hicieron este informe: Es una buena tierra la que nos da el Señor, nuestro Dios."
,"26":"Pero vosotros no quisisteis subir y fuisteis rebeldes a las órdenes del Señor, vuestro Dios."
,"27":"Y os pusisteis a murmurar así en vuestras tiendas: Porque nos odia, el Señor nos ha hecho salir de Egipto, para entregarnos en poder de los amorreos y hacernos morir en sus manos."
,"28":"¿Dónde vamos a ir? Nuestros hermanos nos han desanimado al decirnos: Son más numerosos y más fuertes que nosotros; las ciudades son grandes, y sus murallas llegan hasta el cielo. Hemos visto entre ellos incluso descendientes de Anac."
,"29":"Yo os dije: No os asustéis ni les tengáis miedo."
,"30":"El Señor, vuestro Dios, que va delante de vosotros, combatirá en favor vuestro, lo mismo que le habéis visto hacer en Egipto"
,"31":"y en el desierto, donde el Señor, tu Dios, te sostenía, como un padre sostiene a su hijo, durante todo el camino recorrido hasta llegar aquí."
,"32":"Sin embargo, ninguno de vosotros confió en el Señor, vuestro Dios,"
,"33":"el cual iba delante de vosotros para buscaros lugares en que acampar. De noche os señalaba el camino con fuego y de día con una nube'."
,"34":"'El Señor oyó vuestras palabras, montó en cólera e hizo este juramento:"
,"35":"Ni un solo hombre de esta generación perversa verá esta buena tierra que yo juré dar a vuestros padres,"
,"36":"excepto Caleb, hijo de Jefoné. Éste la verá, y yo le daré a él y a sus hijos la tierra que ha pisado, porque ha seguido fielmente al Señor."
,"37":"Por culpa vuestra, el Señor se irritó incluso contra mí, y me dijo: Tampoco tú entrarás en ella."
,"38":"Será tu lugarteniente Josué, hijo de Nun, quien entrará. Infúndele fuerzas, pues será él quien habrá de poner a Israel en posesión de la tierra."
,"39":"Y vuestros niños, los mismos que vosotros creíais presa de los enemigos, vuestros hijos que todavía no tienen uso de razón, éstos serán los que han de entrar. A ellos se la daré en propiedad."
,"40":"Vosotros volveos y partid hacia el desierto, camino del mar Rojo."
,"41":"Entonces me respondisteis: Hemos pecado contra el Señor, nuestro Dios. Iremos y combatiremos como el Señor, nuestro Dios, nos ha mandado. Tomasteis cada uno vuestras armas y os dispusisteis a subir a la montaña."
,"42":"Pero el Señor me dijo: Diles: No subáis ni combatáis, para que no os veáis derrotados por vuestros enemigos, pues yo no estoy con vosotros."
,"43":"Os lo dije, pero no me escuchasteis; os rebelasteis incluso contra la palabra del Señor, y con aires de grandeza subisteis a la montaña."
,"44":"Los amorreos, que vivían en la montaña, salieron a vuestro encuentro; os persiguieron como hacen las avispas, y os derrotaron en Seír hasta Jormá."
,"45":"Al regreso llorasteis ante el Señor, pero el Señor no escuchó vuestro lamento ni os prestó atención."
,"46":"Y os visteis obligados a permanecer tanto tiempo en Cades'."
}`)
	CurrentBook.AddChapter(2, `{
"1":"'De allí partimos por el desierto camino del mar Rojo, como el Señor me lo había ordenado. Durante largo tiempo estuvimos dando vueltas en torno a la montaña de Seír."
,"2":"El Señor me dijo:"
,"3":"Ya habéis dado bastantes vueltas a esta montaña. Tomad la dirección del norte."
,"4":"Da esta orden al pueblo: Vais a pasar a través del territorio de vuestros hermanos, los hijos de Esaú, que habitan en Seír. Os tendrán miedo; pero tened cuidado;"
,"5":"no los provoquéis, pues yo no os daré nada de su tierra, ni siquiera lo que ocupa la planta de un pie. La montaña de Seír la he dado yo en posesión a Esaú."
,"6":"Pagaréis incluso a precio de plata los alimentos que toméis y el agua que bebáis."
,"7":"El Señor, tu Dios, te ha bendecido en todas tus empresas. Él ha velado tu peregrinación a través de este vasto desierto. Cuarenta años hace ya que te acompaña el Señor, tu Dios, sin que te falte nada."
,"8":"Pasamos, pues, al lado de nuestros hermanos, los hijos de Esaú, que viven en Seír, camino de la Arabá, de Elat y de Asiongaber. Luego, dando la vuelta, tomamos el camino del desierto de Moab."
,"9":"El Señor me dijo: No ataques a Moab ni los provoques al combate, pues nada te daré de su tierra. Ha sido a los hijos de Lot a quienes yo he dado Ar en posesión. ("
,"10":"Antiguamente vivían allí los emitas, pueblo grande, numeroso y de alta estatura, como los anaquitas."
,"11":"Lo mismo que los anaquitas, eran tenidos por refaítas, pero los moabitas los llamaban emitas."
,"12":"También en Seír vivían antiguamente los hurritas, que se vieron desposeídos y exterminados por los hijos de Esaú, los cuales se establecieron en su lugar, de la misma manera que hizo Israel con la tierra que el Señor le dio en posesión)."
,"13":"Ahora levantaos y atravesad el torrente Zared. Y cruzamos el torrente Zared'."
,"14":"'Desde Cades Barne al torrente Zared, vuestro viaje duró treinta y ocho años, lo suficiente para que desapareciera de en medio del campamento toda la generación en edad de guerra, tal como el Señor lo había jurado."
,"15":"La mano del Señor cayó sobre ellos en el campamento hasta que murieron todos."
,"16":"Cuando la muerte hizo desaparecer de en medio del pueblo todos los hombres de guerra,"
,"17":"el Señor nos dijo:"
,"18":"Estás a punto de cruzar Ar, la tierra de Moab,"
,"19":"y te vas a encontrar con los amonitas. No los ataques ni los provoques al combate, pues no te daré nada de los hijos de Amón. Ha sido a los hijos de Lot a quienes yo la he dado en posesión. ("
,"20":"También era considerada como tierra de los refaítas. Allí vivieron en otro tiempo los refaítas, y los amonitas los llamaban zanzumitas,"
,"21":"nación grande, numerosa y de alta estatura, como los anaquitas. El Señor los destruyó ante los amonitas, que los echaron y se establecieron en su lugar;"
,"22":"lo mismo hizo con los hijos de Esaú, que vivían en Seír: El Señor exterminó a los hurritas, y ellos los echaron y se establecieron en su lugar hasta el día de hoy."
,"23":"También los heveos, que habitaban en aldeas hasta Gaza, se vieron destruidos por los caftoritas, venidos de Caftor, los cuales se establecieron en su lugar)."
,"24":"Levantaos, partid y pasad el torrente del Arnón. Yo entrego en tus manos a Sijón, rey de Jesbón, el amorreo, y a su país."
,"25":"Desde hoy empiezo a difundir el terror y el miedo hacia ti entre los pueblos que hay bajo el cielo: todo el que oiga el ruido de tus pasos será presa de terror y de angustia."
,"26":"Desde el desierto de Quedemot envié mensajeros a Sijón, rey de Jesbón, para hacerle estas proposiciones de paz:"
,"27":"Tengo intención de atravesar tu territorio; pero mi camino será directo, sin desviarme ni a la derecha ni a la izquierda."
,"28":"A precio de plata me venderás los víveres que coma, y por dinero me darás el agua que beba. Permíteme sólo pasar a pie,"
,"29":"como ya me lo han permitido los hijos de Esaú que viven en Seír, y los moabitas que viven en Ar, hasta que a través del Jordán llegue a la tierra que el Señor, nuestro Dios, nos da."
,"30":"Pero Sijón, rey de Jesbón, no nos permitió pasar por sus dominios, pues el Señor, tu Dios, había hecho inflexible su espíritu y había endurecido su corazón, con el fin de ponerlo en tus manos, como aún lo está hoy."
,"31":"El Señor me dijo: He empezado a entregarte a Sijón y a su país. Comienza la conquista y aduéñate de su territorio."
,"32":"Sijón salió a nuestro encuentro con toda su gente para darnos batalla en Yahsá."
,"33":"El Señor, nuestro Dios, lo puso en nuestras manos, y lo derrotamos a él, a sus hijos y a todo el pueblo."
,"34":"Nos adueñamos de todas sus ciudades y las consagramos al exterminio: matamos hombres, mujeres y niños, sin dejar uno vivo."
,"35":"Solamente nos quedamos los ganados y el botín de las ciudades conquistadas."
,"36":"Desde Aroer, que está al borde del río Arnón, la ciudad que está en el valle, hasta Galaad, no hubo para nosotros ciudad inexpugnable. El Señor, nuestro Dios, las puso todas en nuestras manos."
,"37":"Solamente te quedó sin conquistar la tierra de los amonitas, la región del torrente Yaboc, las ciudades de la montaña y todo lo que te había prohibido el Señor, nuestro Dios'."
}`)
	CurrentBook.AddChapter(3, `{
"1":"'Partimos y subimos camino de Basán. Og, rey de Basán, nos salió al encuentro con toda su gente para darnos batalla en Edreí."
,"2":"El Señor me dijo: No lo temas, pues yo lo he puesto en tus manos a él, a su pueblo y a su país. Haz con él lo que hiciste con Sijón, rey de los amorreos, que habitaba en Jesbón."
,"3":"El Señor, nuestro Dios, puso también en nuestras manos a Og, rey de Basán, y a todo su pueblo, y le derrotamos sin dejar ni un superviviente."
,"4":"Nos adueñamos de todas sus ciudades, sin dejar una sola: sesenta ciudades, toda la confederación de Argob, capital de Og, en Basán,"
,"5":"ciudades todas fortificadas con altas murallas, con puertas y barras, sin contar muchas ciudades que no tenían murallas."
,"6":"Las consagramos al exterminio, como habíamos hecho con Sijón, rey de Jesbón, sacrificando ciudades, hombres, mujeres y niños;"
,"7":"pero nos quedamos con los ganados y el botín de las ciudades."
,"8":"De esta manera conquistamos a los dos reyes amorreos toda la Transjordania, desde el torrente Arnón hasta el monte Hermón. ("
,"9":"Los sidonios al Hermón le llaman Sarión, y los amorreos Senir)."
,"10":"Todas las ciudades de la meseta, todo Galaad y todo Basán hasta Salcá y Edreí, capitales de Og en Basán. ("
,"11":"Og, rey de Basán, era el último sobreviviente de los refaítas: su cama era de hierro, y medía cuatro metros y medio de largo por dos de ancho, como puede verse todavía en Rabat de los amonitas)'."
,"12":"'Tomamos entonces posesión de esta tierra. A las tribus de Rubén y de Gad les di el territorio que va desde Aroer, al borde del río Arnón, hasta la mitad de la montaña de Galaad con sus ciudades."
,"13":"A media tribu de Manasés le di el resto de Galaad y toda la parte de Basán perteneciente al reino de Og. (Toda la confederación de Argob, todo el Basán, es lo que se llama la tierra de los refaítas."
,"14":"Yaír, hijo de Manasés, se adueñó de toda la confederación de Argob hasta la frontera de los guesuritas y de los maacatitas, y dio su nombre a estas aldeas de Basán, las cuales hasta hoy se siguen llamando Aduares de Yaír)."
,"15":"A Maquir le di Galaad."
,"16":"A los rubenitas y a los gaditas les di desde Galaad, por un lado, hasta el río Arnón, que hacía de frontera; y, por otro, hasta el río Yaboc, frontera de los amonitas."
,"17":"La Arabá y el Jordán servían de frontera desde Genesaret hasta el mar de la Arabá o el mar Muerto, al pie de las faldas del Pisga, que se alza al oriente."
,"18":"Entonces os di esta orden: El Señor, vuestro Dios, os ha dado en propiedad esta tierra. Que los hombres fuertes que hay entre vosotros tomen las armas y marchen al frente de sus hermanos, los israelitas;"
,"19":"solamente vuestras mujeres, vuestros niños y vuestros ganados -ya sé que vuestros rebaños son numerosos- se quedarán en las ciudades que os he dado"
,"20":"hasta que el Señor haya establecido a vuestros hermanos, como lo ha hecho con vosotros, y tomen también ellos posesión de las tierras que el Señor, vuestro Dios, les da al otro lado del Jordán. Después volveréis cada uno a la heredad que os he dado'."
,"21":"'Entonces di esta orden a Josué: Con tus ojos has visto todo lo que el Señor, vuestro Dios, ha hecho con esos dos reyes. Así hará también el Señor con todos los reinos por los que vas a pasar."
,"22":"No los temas, pues el Señor, vuestro Dios, combate por vosotros."
,"23":"Yo invoqué entonces al Señor diciendo:"
,"24":"¡Señor, Señor! Tú has comenzado a mostrar a tu siervo la grandeza y el poder de tu brazo, pues ¿qué Dios hay en los cielos o en la tierra que iguale tus obras y tus hazañas?"
,"25":"Permíteme cruzar, para ver la excelente tierra del lado de allá del Jordán, esa hermosa montaña y el Líbano."
,"26":"Pero el Señor se irritó contra mí, y por vuestra culpa no me escuchó. Me dijo: ¡Basta ya, no me hables más!"
,"27":"Sube a la cima del Pisga, y desde allí mira al norte, al sur, al este y al oeste; y conténtate con mirar, pues no pasarás el Jordán."
,"28":"Da instrucciones a Josué, dale ánimo y valor, pues es él quien pasará a la cabeza del pueblo para poner en sus manos la tierra que ves'."
,"29":"Y nos quedamos en el valle, muy cerca de Bet Fegor."
}`)
	CurrentBook.AddChapter(4, `{
"1":"'Y ahora, Israel, escucha las leyes y prescripciones que te voy a enseñar y ponlas en práctica, para que tengáis vida y entréis a tomar posesión de la tierra que os da el Señor, el Dios de vuestros padres."
,"2":"No añadiréis ni suprimiréis nada de las prescripciones que os doy, sino que guardaréis los mandamientos del Señor, vuestro Dios, tal como yo os los prescribo hoy."
,"3":"Con vuestros ojos habéis visto lo que hizo el Señor con Baal Fegor: el Señor exterminó de en medio de vosotros a todos los que se fueron detrás de Baal Fegor."
,"4":"En cambio, todos los que fuisteis fieles al Señor vivís hasta el día de hoy."
,"5":"Os he enseñado las leyes y los mandamientos que el Señor, mi Dios, me ordenó, para que los pongáis en práctica en la tierra que vais a tomar en posesión."
,"6":"Guardadlos y ponedlos por obra, pues ello os hará sabios y sensatos ante los pueblos. Cuando éstos tengan conocimiento de todas estas leyes exclamarán: No hay más que un pueblo sabio y sensato, que es esta gran nación."
,"7":"En efecto, ¿qué nación hay tan grande que tenga dioses tan cercanos a ella como lo está de nosotros el Señor, nuestro Dios, siempre que le invocamos?"
,"8":"¿Qué nación hay tan grande que tenga leyes y mandamientos tan justos como esta ley que yo os propongo hoy?"
,"9":"Pon atención, y no te olvides de lo que has visto con tus ojos ni lo dejes escapar nunca de tu corazón. Antes bien, enséñaselo a tus hijos y a tus nietos."
,"10":"Recuerda el día que estabas en presencia del Señor, tu Dios, en el Horeb, cuando el Señor me dijo: Reúne al pueblo en torno mío para que yo le haga oír mis palabras y sepan temerme todos los días de su vida sobre la tierra, y enseñen a hacer otro tanto a sus hijos."
,"11":"Vosotros os acercasteis y estuvisteis en la falda del monte mientras éste ardía en llamas que llegaban hasta el corazón del cielo: tiniebla, nube y oscuridad."
,"12":"Entonces el Señor os habló de en medio del fuego. Vosotros oíais el rumor de las palabras, pero no veíais figura alguna; solamente oíais una voz."
,"13":"El Señor os promulgó su alianza y os mandó ponerla en práctica; eran los diez mandamientos que escribió sobre dos tablas de piedra."
,"14":"Al mismo tiempo me ordenó a mí que os enseñase las leyes y mandamientos que debíais guardar en la tierra que ibais a tomar en posesión'."
,"15":"'¡Tened cuidado! El día que os habló el Señor desde el fuego en el Horeb no visteis figura alguna;"
,"16":"no vayáis a prevaricar haciéndoos imágenes talladas de cualquier forma que sean: de hombre o de mujer,"
,"17":"de animales o de aves,"
,"18":"de reptiles o peces."
,"19":"Cuando mires al cielo y veas el sol, la luna, las estrellas y todos los astros del firmamento, no te dejes seducir hasta postrarte ante ellos para rendirles adoración. El Señor, tu Dios, los ha dado en suerte a todos los pueblos que hay bajo los cielos."
,"20":"A vosotros, sin embargo, os tomó el Señor y os sacó del horno de Egipto para que fueseis el pueblo de su herencia hasta hoy."
,"21":"El Señor se irritó contra mí por culpa vuestra y me juró que no pasaría el Jordán ni entraría en la tierra buena que el Señor, tu Dios, te da en herencia."
,"22":"Sí, moriré en esta tierra sin pasar el Jordán. Vosotros, en cambio, pasaréis y tomaréis posesión de esta tierra buena."
,"23":"Guardaos, pues, de olvidar la alianza que el Señor, vuestro Dios, ha hecho con vosotros y no os hagáis esculturas o imágenes talladas de todo lo que el Señor, tu Dios, te ha prohibido,"
,"24":"porque el Señor, tu Dios, es fuego abrasador, Dios celoso."
,"25":"Cuando tengáis hijos y nietos y llevéis mucho tiempo en la tierra, si caéis en la prevaricación y os hacéis imágenes talladas de cualquier cosa, haciendo lo que el Señor prohíbe,"
,"26":"desapareceréis de la tierra que vais a ocupar pasando el Jordán. No alargaréis en ella vuestros días; seréis enteramente destruidos. ¡Yo pongo hoy por testigos a los cielos y la tierra!"
,"27":"El Señor os dispersará entre los pueblos, y sólo quedará de vosotros un pequeño número en medio de las naciones entre las que el Señor os arrojará."
,"28":"Allí serviréis a sus dioses, hechos por mano de hombre, de madera y de piedra, incapaces de ver y entender, de comer y sentir."
,"29":"Allí buscarás al Señor, tu Dios, y le hallarás si le buscas con todo tu corazón y con toda tu alma."
,"30":"Cuando te hayan sobrevenido estas cosas en los últimos días, te convertirás al Señor en tu angustia y escucharás su voz,"
,"31":"pues el Señor, tu Dios, es Dios misericordioso, que no te abandonará, ni te aniquilará, ni se olvidará de la alianza que juró a tus padres'."
,"32":"'Pregunta a los tiempos pasados que te han precedido desde el día en que Dios creó al hombre sobre la tierra. ¿Desde uno a otro extremo del cielo se ha visto jamás cosa tan grande o se ha oído cosa semejante?"
,"33":"¿Hay pueblo que haya oído la voz de su Dios hablar en medio del fuego, como la has oído tú, y quede todavía con vida?"
,"34":"¿Ha habido un dios que haya ido a buscar una nación en medio de otra a fuerza de tantas pruebas, milagros y prodigios, de violencia, con mano fuerte y brazo poderoso, en medio de tremendas hazañas, como las hizo el Señor, vuestro Dios, por vosotros en Egipto, como todos habéis visto?"
,"35":"Te ha hecho ver todo esto para que sepas que el Señor es el verdadero Dios y que no hay otro."
,"36":"Desde el cielo te habló para enseñarte, y sobre la tierra te ha hecho ver su gran fuego y, de en medio del fuego, has oído sus palabras."
,"37":"Porque amó a tus padres, eligió a su descendencia después de ellos, te sacó de Egipto con su asistencia y su poder,"
,"38":"expulsó delante de ti pueblos más numerosos y más fuertes que tú para hacerte entrar en su tierra y dártela en propiedad, como hoy lo ves."
,"39":"Reconócelo y medítalo en tu corazón: el Señor es Dios allá arriba en los cielos y aquí abajo en la tierra; es él, y no hay otro."
,"40":"Guarda sus leyes y mandamientos, que yo te prescribo hoy, para que seas feliz tú y tus hijos después de ti y vivas largos años en la tierra que te da el Señor, tu Dios'."
,"41":"Moisés eligió entonces tres ciudades de la región al oriente del Jordán,"
,"42":"donde pudiera encontrar refugio el homicida que hubiera matado involuntariamente a su prójimo sin haber existido enemistad previa entre ellos; refugiándose en una de estas ciudades, podrá salvar su vida:"
,"43":"para los rubenitas, Beser, en el desierto, en la meseta; para los gaditas, Ramot, en Galaad; y para los manasitas, Golán, en Basán."
,"44":"Ésta es la ley que Moisés presentó a los israelitas."
,"45":"Éstos son los estatutos, leyes y mandamientos que Moisés expuso a los israelitas a su salida de Egipto,"
,"46":"al otro lado del Jordán, en el valle que hay frente a Bet Fegor, en la tierra de Sijón, rey de los amorreos, que vivía en Jesbón y había sido derrotado por Moisés y los israelitas a su salida de Egipto,"
,"47":"los cuales se apoderaron de su tierra. También se adueñaron de la tierra de Og, rey de Basán -ambos reyes de los amorreos al otro lado del Jordán, al oriente,"
,"48":"desde Aroer, al borde del río Arnón, hasta el monte Sirión, que es el Hermón-,"
,"49":"y de toda la meseta transjordánica, al oriente, hasta el mar de la Arabá, en la falda del Pisga."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Moisés convocó a todo Israel y les dijo: 'Escucha, Israel, las leyes y mandamientos que hoy proclamo ante vuestros oídos. Apréndelos bien y cuida de ponerlos en práctica."
,"2":"El Señor, nuestro Dios, hizo con nosotros alianza en el Horeb."
,"3":"No hizo el Señor esta alianza con nuestros padres; la hizo con nosotros, los mismos que todavía hoy vivimos aquí."
,"4":"El Señor nos habló cara a cara sobre la montaña desde fuego."
,"5":"Yo estaba entonces entre el Señor y vosotros como mediador de las palabras del Señor, pues vosotros no habíais subido a la montaña por miedo al fuego. Él dijo:"
,"6":"Yo soy el Señor, tu Dios, que te ha sacado de Egipto, de la casa de la esclavitud."
,"7":"Yo seré tu único Dios."
,"8":"No harás ídolos ni imagen tallada alguna de cuanto hay arriba en los cielos, abajo en la tierra o en las aguas subterráneas."
,"9":"No te postrarás ante ellas ni les darás culto, pues yo, el Señor, tu Dios, soy un Dios celoso, que castigo las faltas de los padres en los hijos hasta la tercera y cuarta generación de los que me odian,"
,"10":"y hago misericordia por mil generaciones a los que me aman y guardan mis mandamientos."
,"11":"No pronunciarás el nombre del Señor en falso, pues el Señor no perdona a quien pronuncia su nombre en falso."
,"12":"Guarda y santifica el día del sábado, como te ha mandado el Señor, tu Dios."
,"13":"Seis días trabajarás y harás tus obras."
,"14":"Pero el séptimo es descanso para el Señor, tu Dios: no harás en él trabajo alguno, ni tú, ni tu hijo, ni tu hija, ni tu siervo, ni tu sierva, ni tu buey, ni tu asno, ni ninguna de tus bestias, ni el extranjero residente; de esta manera podrán descansar tu siervo y tu sierva lo mismo que tú."
,"15":"Acuérdate de que tú fuiste siervo también en Egipto y de que el Señor, tu Dios, te sacó de allí con mano fuerte y brazo poderoso. Por eso el Señor, tu Dios, te manda guardar el sábado."
,"16":"Honra a tu padre y a tu madre, como te lo ha ordenado el Señor, tu Dios; vivirás largos años y serás feliz en la tierra que te da el Señor, tu Dios."
,"17":"No matarás."
,"18":"No cometerás adulterio."
,"19":"No robarás."
,"20":"No pronunciarás falso testimonio contra tu prójimo."
,"21":"No desearás a la mujer de tu prójimo, ni tampoco sus cosas: casas, campo, siervo o sierva, buey o asno, ni nada de cuanto a tu prójimo pertenece'."
,"22":"Éstas son las palabras que el Señor dirigió a toda vuestra comunidad sobre la montaña, en medio de fuego, de nube y de tinieblas, con fuerte voz, sin añadir más. Las escribió sobre dos tablas de piedra, que me entregó."
,"23":"Cuando oísteis su voz en medio de las tinieblas mientras la montaña se abrasaba en llamas, todos vosotros, jefes de tribu y ancianos, os acercasteis a mí"
,"24":"para decirme: Hemos visto al Señor, nuestro Dios, su gloria y su grandeza, y hemos oído su voz en medio del fuego. Hoy hemos comprobado que Dios puede hablar al hombre y quedar éste con vida."
,"25":"¿Por qué, pues, morir devorados por ese gran fuego, si seguimos oyendo la voz del Señor, nuestro Dios?"
,"26":"Porque de todo ser viviente, ¿quién hay como nosotros que haya oído la voz del Dios vivo hablar de en medio del fuego y haya quedado con vida?"
,"27":"Acércate tú, oye lo que te diga el Señor, nuestro Dios, y dinos luego lo que él te haya dicho; nosotros lo escucharemos y lo pondremos en práctica."
,"28":"El Señor escuchó vuestras palabras cuando me hablabais, y me dijo: He oído las palabras de este pueblo. Todo lo que te ha dicho está bien."
,"29":"¡Oh, si tuvieran siempre ese mismo corazón, siempre me temerían, guardarían mis mandamientos y serían felices ellos y sus hijos!"
,"30":"Ve y diles: Volveos a vuestras tiendas."
,"31":"Pero tú quédate aquí, junto a mí, pues te quiero comunicar todas las leyes, mandamientos y preceptos que les has de enseñar para que los pongan en práctica en la tierra que les voy a dar."
,"32":"Poned atención y haced lo que el Señor os manda. No os desviéis a derecha ni a izquierda."
,"33":"Seguid en todo el camino que os ha mandado el Señor, vuestro Dios; de esta manera viviréis y seréis felices y serán largos vuestros días en la tierra que vais a poseer."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Éstas son las leyes, mandamientos y preceptos que el Señor, vuestro Dios, me mandó enseñaros para que los pongáis en práctica en la tierra en la que vais a entrar y a poseerla;"
,"2":"para que temas al Señor, tu Dios, tú y tus hijos y tus nietos, guardando todos los días de tu vida todas las leyes y mandamientos que yo te impongo hoy, y de esta manera viváis largos años."
,"3":"Escúchalos, Israel, y procura practicarlos, para que seas dichoso y te multipliques según la promesa del Señor, el Dios de tus padres, en esta tierra que mana leche y miel."
,"4":"Escucha, Israel: El Señor, nuestro Dios, es el único Señor."
,"5":"Ama al Señor, tu Dios, con todo tu corazón, con toda tu alma y con todas tus fuerzas."
,"6":"Graba sobre tu corazón las palabras que yo te dicto hoy."
,"7":"Incúlcaselas a tus hijos y repíteselas cuando estés en casa, lo mismo que cuando estés de viaje, acostado o levantado."
,"8":"Átatelas a las manos para que te sirvan de señal, póntelas en la frente entre los ojos."
,"9":"Escríbelas en los postes de tu casa y en tus puertas."
,"10":"Cuando el Señor, tu Dios, te haya conducido a la tierra que juró dar a tus padres, Abrahán, Isaac y Jacob, y te haya entregado en propiedad las grandes y prósperas ciudades que tú no levantaste,"
,"11":"las casas llenas de toda suerte de bienes que tú no llenaste, las cisternas que tú no excavaste, las viñas y olivares que tú no plantaste, cuando hayas comido hasta saciarte,"
,"12":"no te olvides del Señor que te sacó de Egipto, de la casa de la esclavitud."
,"13":"Teme al Señor, tu Dios, sírvele a él y jura en su nombre."
,"14":"No te vayas tras otros dioses, tras los dioses de las naciones que te rodean,"
,"15":"pues el Señor, tu Dios, que está en medio de ti, es un Dios celoso, y la ira del Señor, tu Dios, se encendería contra ti y te haría desaparecer sobre la tierra."
,"16":"No tentéis al Señor, vuestro Dios, como lo hicisteis en Masá."
,"17":"Guardad con gran cuidado los mandamientos del Señor, vuestro Dios, los preceptos y las leyes que él os da."
,"18":"Haz lo que es justo y bueno a los ojos del Señor, para que seas dichoso y entres a tomar posesión de la hermosa tierra que el Señor prometió con juramento a tus padres,"
,"19":"cuando eche delante de ti a todos tus enemigos, como él lo ha dicho."
,"20":"Cuando un día tu hijo te pregunte: ¿Qué son estos mandamientos, estas leyes y preceptos que nos ha prescrito el Señor?,"
,"21":"tú responderás a tu hijo: Nosotros éramos esclavos del Faraón en Egipto, y el Señor nos liberó con su mano poderosa."
,"22":"El Señor hizo ante nuestros ojos milagros y prodigios grandes y terribles contra Egipto, el Faraón y toda su casa,"
,"23":"y a nosotros nos sacó de allí para llevarnos a la tierra que había jurado dar a nuestros padres."
,"24":"Y el Señor nos ha ordenado poner en práctica todas estas leyes y temer al Señor, nuestro Dios, para que seamos dichosos y vivamos, como nos ha concedido hasta ahora."
,"25":"Ésta será nuestra justicia: guardar y poner en práctica íntegramente estos mandamientos en presencia del Señor, nuestro Dios, como él nos lo ha ordenado."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Cuando el Señor, tu Dios, te haya introducido en la tierra que vas a poseer, pueblos numerosos caerán ante ti: los hititas, los guirgaseos, los amorreos, los cananeos, los fereceos, los heveos y los jebuseos, siete pueblos más poderosos y más potentes que tú."
,"2":"Cuando te los haya entregado y tú los hayas derrotado, los entregarás al exterminio; no harás pactos ni tendrás compasión con ellos."
,"3":"No contraigas parentesco con ellos: no des tus hijas a sus hijos ni tomes las suyas para los tuyos,"
,"4":"pues ellas desviarían a tus hijos de su fidelidad y los arrastrarían a servir a otros dioses, y la ira de Dios se encendería contra vosotros y os destruiría bien pronto."
,"5":"Ésta será vuestra conducta con ellos: derribaréis sus altares, romperéis sus estelas, abatiréis sus cipos y quemaréis sus ídolos."
,"6":"Porque tú eres un pueblo consagrado al Señor, tu Dios. El Señor, tu Dios, te ha elegido para pueblo suyo entre todos los pueblos que hay sobre la tierra."
,"7":"El Señor se fijó en vosotros y os eligió, no por ser el pueblo más numeroso entre todos los pueblos, ya que sois el más pequeño de todos."
,"8":"Porque el Señor os amó y porque ha querido cumplir el juramento hecho a vuestros padres, os ha sacado de Egipto con mano poderosa y os ha librado de la casa de la esclavitud, de la mano del Faraón, rey de Egipto."
,"9":"Reconoce, por tanto, que el Señor, tu Dios, es el verdadero Dios, el Dios fiel, que guarda la alianza y la misericordia hasta mil generaciones a los que lo aman y cumplen sus mandamientos,"
,"10":"y que castiga en su propia persona a los que lo odian. Hace perecer sin tardanza a quien le odia, y lo hiere con castigo personal."
,"11":"Guarda, por tanto, tú sus mandamientos, sus leyes y estatutos que hoy te prescribo, poniéndolos en práctica."
,"12":"Por haber escuchado estos mandamientos, haberlos guardado y puesto en práctica, el Señor, tu Dios, mantendrá contigo la alianza y la misericordia que juró a tus padres."
,"13":"Te amará, te bendecirá, te multiplicará: bendecirá el fruto de tus entrañas y el fruto de tu suelo, tu trigo, tu mosto, tu aceite, las crías de tus vacas y las de tus ovejas, en favor tuyo."
,"14":"Serás bendecido sobre todos los pueblos. No habrá en ti ni en tus ganados macho ni hembra estéril."
,"15":"El Señor alejará de ti toda enfermedad y no te enviará ninguna de las malignas plagas de Egipto, que tú bien conoces, sino que las descargará sobre tus enemigos."
,"16":"Destruye todos los pueblos que el Señor, tu Dios, va a poner en tus manos; no se apiaden de ellos tus ojos ni des culto a sus dioses, pues eso sería tu ruina."
,"17":"Si se te ocurriera pensar: ¿Cómo voy a poder expulsar a estas naciones, que son más numerosas que yo?,"
,"18":"no las temas; acuérdate de lo que el Señor, tu Dios, hizo con el Faraón y con todo Egipto;"
,"19":"recuerda las grandes pruebas que vieron tus ojos, los milagros y prodigios, la mano fuerte y el brazo poderoso con los que el Señor, tu Dios, te sacó. Así hará también el Señor, tu Dios, con todos los pueblos que temes."
,"20":"Más aún, el Señor, tu Dios, enviará tábanos contra ellos hasta hacer perecer a los sobrevivientes o a los que se hubieran escondido."
,"21":"No tiembles ante ellos, pues está contigo el Señor, tu Dios, el Dios grande y terrible."
,"22":"El Señor, tu Dios, irá destruyendo estas naciones delante de ti poco a poco. No podrás exterminarlas en un día, no sea que las fieras del campo se multipliquen contra ti."
,"23":"El Señor, tu Dios, te las entregará, y las llenará de gran turbación hasta su total extinción."
,"24":"Entregará en tu mano sus leyes y harás desaparecer sus nombres de debajo de los cielos; los destruirás, ninguno podrá resistir delante de ti."
,"25":"Quemarás las imágenes talladas de sus dioses, sin codiciar el oro ni la plata que los recubre. Si te apropias de ello, caerías en la trampa, pues es cosa abominable a los ojos del Señor, tu Dios."
,"26":"No metas en tu casa tal cosa, pues serías, como ella, consagrado al exterminio. Las tendrás por inmundas y abominables, como cosas prohibidas y consagradas al exterminio."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Guardad con cuidado y poned en práctica todos los mandamientos que hoy os prescribo para que viváis, os multipliquéis y entréis a poseer la tierra que el Señor juró a vuestros padres."
,"2":"Acuérdate del camino que el Señor te ha hecho andar durante cuarenta años a través del desierto con el fin de humillarte, probarte y conocer los sentimientos de tu corazón y ver si guardabas o no sus mandamientos."
,"3":"Te ha humillado y te ha hecho sentir hambre para alimentarte luego con el maná, desconocido de tus mayores; para que aprendieras que no sólo de pan vive el hombre, sino de todo lo que sale de la boca del Señor."
,"4":"No se gastaron tus vestidos ni se hincharon tus pies durante esos cuarenta años."
,"5":"Reconoce en tu corazón que el Señor, tu Dios, te corrige como un padre lo hace con su hijo."
,"6":"Guarda los mandamientos del Señor, tu Dios; sigue sus caminos y respétale."
,"7":"El Señor, tu Dios, te va a introducir en una tierra buena; tierra de torrentes, de fuentes, de aguas profundas, que brotan en el fondo de los valles y sobre los montes;"
,"8":"tierra de trigo y cebada, de viñas, higos y granados; tierra de olivos, aceite y miel;"
,"9":"tierra que te dará el pan en abundancia sin carecer de nada; tierra donde las piedras son de hierro y de cuyas montañas sale el bronce."
,"10":"Comerás hasta saciarte y bendecirás al Señor, tu Dios, en la buena tierra que te da."
,"11":"Guárdate bien de olvidarte del Señor, tu Dios, descuidando sus mandamientos, sus leyes y sus preceptos, que yo te prescribo hoy."
,"12":"Cuando hayas comido hasta saciarte y hayas construido hermosas casas;"
,"13":"cuando hayas visto multiplicarse tus bueyes y tus ovejas, tu plata, tu oro y todos tus bienes,"
,"14":"no te ensoberbezcas en tu corazón ni te olvides del Señor, tu Dios, que te ha sacado de Egipto, de la casa de la esclavitud;"
,"15":"que te ha conducido a través de vasto y horrible desierto, de serpientes venenosas, de escorpiones, tierra de sed y sin agua; que hizo brotar para ti agua de la roca más dura"
,"16":"y te ha alimentado en el desierto con el maná, desconocido para tus mayores, con el fin de humillarte y probarte para prepararte un futuro dichoso."
,"17":"Guárdate de decir en tu corazón: Mi fuerza y el poder de mis manos han hecho todo esto."
,"18":"Acuérdate del Señor, tu Dios: es él quien te ha dado esta fuerza y te ha procurado este poder, cumpliendo así hasta el día de hoy la alianza que hizo con tus padres."
,"19":"Pero si te olvidas del Señor, tu Dios, para irte tras otros dioses, dándoles culto y postrándote ante ellos, yo os aseguro que seréis completamente destruidos."
,"20":"Como las naciones que el Señor destruye a vuestro paso, así seréis destruidos vosotros por no haber escuchado la voz del Señor, vuestro Dios."
}`)
	CurrentBook.AddChapter(9, `{
"1":"¡Escucha, Israel! Estás a punto de cruzar el Jordán para ir a la conquista de naciones más numerosas y más fuertes que tú; de grandes ciudades, cuyas murallas se levantan hasta el cielo."
,"2":"Se trata de un pueblo numeroso, de estatura gigantesca, descendiente de los anaquitas, que tú ya conoces y de los cuales has oído decir: ¿Quién podrá mantenerse firme ante los hijos de Anac?"
,"3":"Reconoce desde ahora mismo que es el Señor, tu Dios, quien va delante de ti como fuego devorador, que los destruirá. Él los derrotará delante de ti, y tú los desalojarás y los aniquilarás rápidamente, según la promesa del Señor."
,"4":"Cuando el Señor, tu Dios, los haya echado lejos de ti, no digas en tu corazón: Por mi justicia me ha dado el Señor la posesión de esta tierra, siendo así que es por su injusticia por lo que el Señor echa a esas naciones lejos de ti."
,"5":"No por tu justicia ni por la rectitud de tu corazón vas a entrar en posesión de la tierra, sino por la injusticia de esas naciones las echa el Señor lejos de ti; y también para cumplir el juramento hecho a vuestros padres Abrahán, Isaac y Jacob."
,"6":"Reconoce que el Señor, tu Dios, no te da la posesión de esa buena tierra debido a tu justicia, pues no eres más que un pueblo de cabeza dura."
,"7":"Acuérdate no lo olvides: tú irritaste al Señor, tu Dios, en el desierto; desde el día en que saliste de Egipto hasta el día de vuestra entrada en este lugar habéis sido rebeldes al Señor."
,"8":"Ya en el Horeb provocasteis la ira del Señor, que montó en cólera contra vosotros hasta querer destruiros."
,"9":"Cuando subí yo a la montaña para recibir las tablas de piedra, las tablas de la alianza que el Señor hacía con vosotros, permanecí sobre la cima cuarenta días y cuarenta noches sin comer ni beber."
,"10":"Y el Señor me dio las dos tablas de piedra, escritas por el dedo de Dios, las cuales respondían exactamente a los mandamientos que el Señor os había anunciado en la montaña, en medio del fuego, el día de la asamblea."
,"11":"Al cabo de cuarenta días y cuarenta noches, el Señor me dio las dos tablas de piedra, las tablas de la alianza,"
,"12":"y me dijo: Levántate y baja rápido de aquí, porque tu pueblo, el que has sacado de Egipto, ha prevaricado: pronto se ha desviado del camino que yo le ordené y se han hecho una imagen de metal fundido."
,"13":"Y continuó: Ya he visto a este pueblo: es un pueblo de cabeza dura;"
,"14":"déjame que lo destruya y borre su nombre de la tierra, y te daré una nación más fuerte y más numerosa que ese pueblo."
,"15":"Yo bajé de la montaña, que estaba en llamas, trayendo en mis manos las dos tablas de la alianza."
,"16":"Cuando vi que habíais pecado contra el Señor, vuestro Dios, y que os habíais hecho un becerro de metal fundido, apartándoos bien pronto del camino que os había señalado el Señor,"
,"17":"tiré las tablas que traía en las manos y las hice pedazos ante vuestros ojos."
,"18":"Me postré luego en presencia del Señor. Como la primera vez, estuve durante cuarenta días sin comer ni beber por causa del pecado que vosotros habíais cometido haciendo lo que es malo a los ojos del Señor hasta el punto de irritarle;"
,"19":"pues yo tenía miedo de la ira y el furor con que estaba irritado el Señor contra vosotros hasta el extremo de querer destruiros. Esta vez todavía me escuchó el Señor."
,"20":"También contra Aarón se irritó fuertemente el Señor y quería destruirlo. Yo intercedí también en favor de Aarón."
,"21":"Tomé entonces el becerro que os habíais hecho, que era causa de vuestro pecado, lo eché al fuego y, moliéndolo bien hasta reducirlo a polvo, lo tiré al agua del torrente que bajaba de la montaña."
,"22":"En Taberá, en Masá y en Quibrot Hataavá provocasteis también la ira del Señor."
,"23":"Y cuando el Señor os mandó salir de Cades Barne diciéndoos que subierais a tomar posesión de la tierra que os daba, fuisteis rebeldes a la voz del Señor, vuestro Dios, no le creísteis ni escuchasteis su palabra."
,"24":"Habéis sido rebeldes al Señor desde el día mismo en que os conoció."
,"25":"Yo me postré ante el Señor y así permanecí los cuarenta días y las cuarenta noches, pues el Señor pensaba destruiros."
,"26":"Intercedí ante el Señor y le dije: Señor, Señor, no destruyas a tu pueblo, a tu heredad, que tú has rescatado en tu grandeza y que has sacado de Egipto con tu mano poderosa."
,"27":"Acuérdate de tus siervos Abrahán, Isaac y Jacob. No te fijes en la terquedad de este pueblo, en su crimen y en su pecado,"
,"28":"no sea que digan en la tierra de la que nos has sacado: El Señor no ha sido capaz de llevarlos hasta la tierra que les había prometido. Los ha hecho salir de aquí por odio, para hacerles morir en el desierto."
,"29":"Pero son tu pueblo, tu heredad, que rescataste con tu mano fuerte y tu brazo poderoso."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Entonces el Señor me dijo: Talla dos tablas de piedra como las primeras, tráemelas a la montaña y hazte un arca de madera."
,"2":"Yo escribiré sobre las tablas las palabras escritas sobre las primeras, que tú rompiste, y luego las guardarás en el arca."
,"3":"Hice, pues, un arca de madera de acacia, tallé dos tablas de piedra como las primeras y subí con ellas a la montaña."
,"4":"Como la primera vez, el Señor escribió sobre las tablas los diez mandamientos que él os había dictado sobre la montaña en medio del fuego, el día de la asamblea, y me las dio."
,"5":"Yo bajé del monte, coloqué las tablas en el arca que había hecho, y allí quedaron depositadas, como el Señor me había ordenado."
,"6":"Los israelitas partieron de los pozos de Bené Yaacán para Moserá. Allí murió Aarón y allí fue enterrado. Eleazar, su hijo, le sucedió en el sacerdocio."
,"7":"De allí partieron para Gudgod, y de Gudgod para Yotbá, región rica en aguas."
,"8":"El Señor puso entonces aparte la tribu de Leví, destinándola a llevar el arca de la alianza del Señor, a estar en su presencia, darle culto y bendecir en su nombre, como siguen haciendo hasta hoy."
,"9":"Por eso Leví no tiene parte ni heredad entre sus hermanos: el Señor es su heredad, como el Señor mismo le dijo."
,"10":"Yo estuve en la montaña, como la primera vez, cuarenta días y cuarenta noches. El Señor me escuchó todavía esta vez y renunció a vuestra destrucción."
,"11":"Pero me dijo: Anda y ponte a la cabeza del pueblo para que entren a tomar posesión de la tierra que les voy a dar, como prometí a sus padres."
,"12":"Y ahora, Israel, ¿qué es lo que te pide el Señor, tu Dios? Que respetes al Señor, tu Dios; que sigas sus caminos, que le sirvas y que le ames con todo tu corazón y con toda tu alma;"
,"13":"que guardes sus mandamientos y sus leyes, que hoy te prescribo yo, para que seas feliz."
,"14":"Mira; del Señor, tu Dios, son los cielos, aun los más altos, la tierra y todo lo que hay en ella."
,"15":"Sin embargo, sólo se unió con tus padres, y esto por amor; y después de ellos eligió a sus descendientes, vosotros mismos, entre todas las naciones, hasta el día de hoy."
,"16":"Circuncidad vuestro corazón y no sigáis más con vuestra cabeza dura,"
,"17":"pues el Señor, vuestro Dios, es el Dios de los dioses y Señor de los señores, el Dios grande, fuerte y temible, que no admite acepción de personas ni se deja comprar con regalos."
,"18":"Hace justicia al huérfano y a la viuda, ama al emigrante suministrándole pan y vestido."
,"19":"Amad también vosotros al emigrante, ya que emigrantes fuisteis en Egipto."
,"20":"Respeta al Señor, tu Dios; sírvele, vive unido a él y jura por su nombre."
,"21":"Él es tu gloria y tu Dios, que ha hecho por ti cosas grandes y hazañas tremendas, que tus mismos ojos han visto."
,"22":"Tus padres bajaron a Egipto en número de 70 personas, y ahora el Señor, tu Dios, te ha hecho numeroso como las estrellas del cielo."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Ama al Señor, tu Dios, y cumple siempre lo que te ha ordenado: sus leyes, sus preceptos, sus mandamientos."
,"2":"Reconocedlo hoy -no se trata de vuestros hijos, que ni han conocido ni han visto-, reconoced las lecciones del Señor, vuestro Dios, la grandeza y la fuerza de su brazo poderoso,"
,"3":"los milagros y prodigios que obró en Egipto contra el Faraón y toda su tierra;"
,"4":"lo que hizo con el ejército egipcio, con sus caballos y sus carros, que sepultó bajo las aguas del mar Rojo cuando os perseguían y lo destruyó hasta el día de hoy;"
,"5":"todo lo que ha hecho por vosotros en el desierto hasta que habéis llegado a este lugar;"
,"6":"lo que hizo con Datán y Abirán, hijos de Eliab el rubenita, cuando se abrió la tierra y se los tragó con sus familias, sus tiendas y toda su dependencia a la vista de todo Israel."
,"7":"Vosotros mismos, con vuestros ojos, habéis visto toda la grandiosa obra del Señor."
,"8":"Guardad, pues, todos sus mandamientos que hoy os prescribo yo, para que seáis fuertes y conquistéis la tierra de la que vais a tomar posesión,"
,"9":"para que se alarguen vuestros días sobre la tierra que el Señor prometió con juramento a vuestros padres y a su descendencia, tierra que mana leche y miel."
,"10":"Porque la tierra en que vais a entrar para poseerla no es como la tierra de Egipto de la que habéis salido, donde echabas la semilla y la regabas con tu pie, como se riega una huerta."
,"11":"La tierra en que vais a entrar para poseerla es una tierra de montes y de valles, que riega la lluvia del cielo."
,"12":"Esta tierra depende del cuidado del Señor; sobre ella tiene fijos sus ojos el Señor desde el comienzo del año hasta el final."
,"13":"Si cumplís los mandamientos que yo os prescribo hoy, amando al Señor vuestro Dios y sirviéndole con todo vuestro corazón y toda vuestra alma,"
,"14":"yo daré a vuestra tierra la lluvia a su tiempo, lluvia de otoño y primavera, y tú podrás cosechar tu trigo, tu mosto y tu aceite;"
,"15":"yo daré a tus ganados hierba en los campos, y tú comerás hasta saciarte."
,"16":"Tened cuidado que no sea seducido vuestro corazón, y prevaricando sirváis a otros dioses rindiéndoles adoración,"
,"17":"pues la ira del Señor se encendería contra vosotros, cerraría los cielos y no habría más lluvia; la tierra no daría sus frutos y vosotros pereceríais bien pronto en esa buena tierra que el Señor os da."
,"18":"Grabad en vuestro corazón y en vuestra alma estas palabras que hoy os digo, atadlas a vuestras manos como señal y ponedlas como frontal entre vuestros ojos."
,"19":"Enseñádselas a vuestros hijos y repetídselas sin cesar: lo mismo cuando estéis sentados en casa que cuando vayáis de viaje, lo mismo cuando estés acostado que cuando estés levantado y de pie."
,"20":"Escríbelas en los postes de tu casa y sobre tus puertas,"
,"21":"para que viváis largos días, vosotros y vuestros hijos, en la tierra que el Señor juró dar a vuestros padres; tan largos como los días de los cielos sobre la tierra."
,"22":"Si guardáis y ponéis por obra todos los mandamientos que yo os doy, amando a vuestro Dios y siguiendo siempre sus caminos sin apartaros de él,"
,"23":"el Señor echará lejos de vosotros estas naciones y las conquistaréis a pesar de ser más potentes y numerosas que vosotros."
,"24":"Todo lo que pise la planta de vuestros pies será vuestro, y vuestras fronteras se extenderán desde el desierto al Líbano, desde el río Éufrates al mar Mediterráneo."
,"25":"Nadie podrá resistirse ante vosotros. El Señor, vuestro Dios, sembrará el pánico y el temor delante de vosotros sobre toda la tierra donde pongáis vuestro pie, como él mismo ha dicho."
,"26":"Mirad: yo os pongo hoy delante bendición y maldición."
,"27":"Bendición, si obedecéis los mandamientos del Señor, vuestro Dios, que yo os prescribo hoy;"
,"28":"maldición, si no obedecéis los mandamientos del Señor, vuestro Dios, si os apartáis del camino que yo os he enseñado y os vais tras los dioses que no habéis conocido."
,"29":"Cuando el Señor, tu Dios, te haya llevado a la tierra donde vas a entrar para tomar posesión de ella, colocarás la bendición sobre el monte Garizín y la maldición sobre el monte Ebal."
,"30":"Estos montes se encuentran al otro lado del Jordán, detrás del camino del occidente, en la tierra de los cananeos que viven en la Arabá, frente a Guilgal, junto a la encina de Moré."
,"31":"Vais a cruzar el Jordán para tomar posesión de la tierra que el Señor, vuestro Dios, os da. La poseeréis, la habitaréis,"
,"32":"guardaréis y pondréis en práctica todos los mandamientos y prescripciones que hoy os propongo."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Éstas son las leyes que guardaréis y pondréis por obra en la tierra que el Señor, el Dios de nuestros padres, os da en posesión todos los días que viváis en ella."
,"2":"Destruiréis totalmente todos los lugares donde las naciones que vais a desalojar han dado culto a sus dioses; sobre las montañas, sobre los collados y bajo todo árbol frondoso:"
,"3":"destruiréis sus altares, romperéis sus estelas, quemaréis sus cipos sagrados, haréis pedazos las imágenes talladas de sus dioses y sus nombres de esos lugares."
,"4":"No haréis así con el Señor, vuestro Dios,"
,"5":"sino que vendréis a buscarle al lugar elegido por él entre todas las tribus, para poner allí su nombre y habitar en él;"
,"6":"allí llevaréis vuestros holocaustos y sacrificios, vuestros diezmos y contribuciones, vuestros votos y vuestras ofrendas voluntarias, los primogénitos de vuestro ganado mayor y menor."
,"7":"Allí comeréis en presencia del Señor y os alegraréis por todas las empresas de vuestras manos en las que el Señor, vuestro Dios, os haya bendecido."
,"8":"No será como hoy aquí, donde cada uno hace lo que le parece bien,"
,"9":"ya que todavía no habéis entrado en el lugar tranquilo que el Señor, tu Dios, te va a dar en posesión."
,"10":"Pero cuando crucéis el Jordán y viváis en la tierra que el Señor, vuestro Dios, os da en posesión, allí estaréis defendidos de todos los enemigos que os rodean, viviréis en seguridad"
,"11":"y llevaréis al lugar que el Señor, vuestro Dios, haya elegido para hacer habitar en él su nombre, todo lo que yo os prescribo: vuestros holocaustos y vuestros sacrificios, vuestros diezmos y vuestras contribuciones y todas las cosas selectas que hayáis prometido al Señor."
,"12":"Allí os regocijaréis en presencia del Señor, vuestro Dios, vosotros, vuestros hijos e hijas, vuestros siervos y siervas y el levita que habita entre vosotros, ya que él no tiene parte ni herencia con vosotros."
,"13":"Guárdate de ofrecer holocaustos en cualquier lugar sagrado que veas."
,"14":"Solamente en el lugar elegido por el Señor, tu Dios, en una de las tribus, podrás ofrecer tus holocaustos y hacer allí todo lo que yo te ordeno."
,"15":"Siempre que quieras podrás matar animales y comer su carne en todas tus ciudades, en la medida que te haya bendecido el Señor, tu Dios; y podrán comerla el puro y el impuro, como si se tratase de la gacela o del ciervo."
,"16":"Pero no comeréis la sangre, sino que la derramaréis en la tierra como el agua."
,"17":"No podrás comer en tu residencia los diezmos de tu trigo, de tu mosto y de tu aceite, ni los primogénitos de tus vacas y tus ovejas, ni tus votos u ofrendas voluntarias,"
,"18":"sino que lo comerás en presencia del Señor, tu Dios, en el lugar escogido por él, tú, tu hijo y tu hija, tu siervo y tu sierva y el levita que habita contigo. Allí te regocijarás ante el Señor, tu Dios, por el éxito de tus empresas."
,"19":"Cuida de no abandonar al levita todo el tiempo que vivas en tu tierra."
,"20":"Cuando el Señor, tu Dios, haya ensanchado tus fronteras tal como lo ha prometido, y tú digas: Yo quisiera comer carne, porque sientes deseo de ella, podrás comer toda la carne que quieras."
,"21":"Si el lugar elegido por el Señor, tu Dios, para hacer habitar allí su nombre se encuentra distante, podrás matar del ganado mayor o menor que el Señor te haya dado, según lo que te he prescrito, y comer dentro de tu residencia lo que te apetezca."
,"22":"Lo comerás como se come la gacela o el ciervo; podrán comerla el puro y el impuro."
,"23":"Ten solamente buen cuidado de no comer la sangre, porque la sangre es la vida, y no debes comer la vida con la carne."
,"24":"No la comerás, la derramarás en la tierra como el agua."
,"25":"No la comerás, para que seáis felices tú y tus hijos después de ti por haber hecho lo que es justo a los ojos del Señor."
,"26":"Las cosas que hayas consagrado y las promesas que hayas hecho, las llevarás al lugar elegido por el Señor."
,"27":"Allí ofrecerás el holocausto sobre el altar del Señor, tu Dios. En los sacrificios, la sangre será derramada sobre el altar del Señor, tu Dios, y la carne la podrás comer."
,"28":"Escucha y cumple todas estas prescripciones que te doy, para que seas feliz siempre tú y tus hijos después de ti, haciendo lo que es justo a los ojos del Señor, tu Dios."
,"29":"Cuando el Señor, tu Dios, haya exterminado las naciones que tú vas a desalojar, cuando las hayas echado y tú vivas en sus dominios,"
,"30":"no caigas en la trampa, no sigas sus caminos ni te preocupes de sus dioses diciendo: ¿Cómo daban culto estos pueblos a sus dioses?, pues así quiero darlo yo también."
,"31":"No te conduzcas así con el Señor, tu Dios, pues nada hay más odioso y aborrecible a los ojos del Señor que lo que hacían éstos por sus dioses, llegando incluso a sacrificarles en el fuego a sus propios hijos."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Guardad y poned por obra todo lo que yo os ordeno, sin añadir ni quitar nada."
,"2":"Si aparece entre vosotros un profeta o un soñador, si te propone una señal o un prodigio,"
,"3":"y éstos se cumplen, pero luego te dice: Vamos tras otros dioses que tú conoces, y démosles culto,"
,"4":"no escuches las palabras de tal profeta ni los sueños de tal soñador. El Señor, vuestro Dios, quiere probaros para ver si realmente le amáis con todo vuestro corazón y con toda vuestra alma."
,"5":"Seguiréis al Señor y le respetaréis, guardaréis sus mandamientos y obedeceréis su voz, le serviréis y viviréis unidos a él."
,"6":"El profeta y el soñador deberán morir, pues han predicado la rebelión contra el Señor, vuestro Dios, que os sacó de Egipto y os libertó de la casa de la esclavitud, queriendo apartaros del camino por donde el Señor, tu Dios, os ha mandado ir. Así harás desaparecer el mal de en medio de ti."
,"7":"Si tu hermano, tu padre o tu madre, tu hijo o tu hija, la esposa que descansa en tu regazo o tu amigo, que es otro tú, te incita en secreto a servir a otros dioses desconocidos para tus padres o para ti"
,"8":"de entre los dioses de los pueblos próximos o lejanos que os rodean de uno a otro extremo de la tierra,"
,"9":"no le hagas caso ni le escuches, no tengas piedad de él, no le perdones ni encubras su falta."
,"10":"Es reo de muerte, y tu mano sea la primera sobre él, continuando la mano de todo el pueblo su ejecución."
,"11":"Le matarás a pedradas, pues ha querido apartarte del Señor, tu Dios, que te sacó de Egipto, de la casa de la esclavitud."
,"12":"Al saberlo, todo Israel será presa del temor y dejarán de practicar tal perversidad."
,"13":"Si oyes decir que en una de las ciudades que el Señor te ha dado para habitar en ellas,"
,"14":"hombres malvados inducen a sus conciudadanos a servir a otros dioses desconocidos para vosotros,"
,"15":"examinarás el caso, preguntarás e investigarás bien el asunto. Si se confirma el rumor y se prueba que tal perversidad se ha cometido en medio de ti,"
,"16":"pasarás al filo de la espada a todos los habitantes de aquella ciudad, la darás al exterminio a ella y a todo lo que hay en ella."
,"17":"Amontonarás todo el botín en la plaza pública e incendiarás la ciudad con todo su botín como ofrenda en honor del Señor, tu Dios. Quedará convertida en un montón de ruinas, que nunca se reedificará."
,"18":"De lo que se ha destinado al exterminio no guardarás nada para ti, para que se aplaque el furor de la ira del Señor, tenga compasión de ti y te haga crecer en número tal como se lo prometió a tus padres,"
,"19":"con tal que tú escuches la voz del Señor, tu Dios, guardes todos sus mandamientos, que hoy te prescribo, y hagas lo que es recto a los ojos del Señor, tu Dios."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Vosotros sois los hijos del Señor, vuestro Dios. No os haréis cortaduras ni os raparéis el pelo de la frente por un muerto."
,"2":"Porque tú eres un pueblo consagrado al Señor, tu Dios, y el Señor te ha elegido para ser su pueblo entre todos los pueblos de la tierra."
,"3":"No comeréis nada impuro."
,"4":"Éstos son los animales que podéis comer: el buey, la oveja, la cabra,"
,"5":"el ciervo, la gacela, el corzo, la cabra montés, el antílope, el búfalo, la gamuza,"
,"6":"todos los rumiantes que tengan la pezuña partida."
,"7":"Pero no comeréis los siguientes, aunque sean rumiantes y tengan la pezuña partida: el camello, la liebre y el tejón, porque son rumiantes pero no tienen la pezuña partida; debéis tenerlos por impuros."
,"8":"De la misma manera el cerdo, que tiene la pezuña partida, pero no es rumiante: debéis tenerlo por impuro. No comeréis sus carnes ni tocaréis sus cadáveres."
,"9":"De los anmales acuáticos podréis comer los que tienen aletas y escamas,"
,"10":"pero los que no las tienen, no los comáis; son impuros."
,"11":"Podréis comer toda ave pura."
,"12":"Éstas son las que no podéis comer: el águila, el quebrantahuesos, el buitre,"
,"13":"el milano, el halcón en todas sus especies,"
,"14":"todas las especies de cuervos,"
,"15":"el avestruz, el mochuelo, la lechuza,"
,"16":"el ibis, el búho, el pelícano,"
,"17":"la cerceta, el mergo, la cigüeña,"
,"18":"todas las especies de garza, la abubilla y el murciélago."
,"19":"Tendréis también por impuro cualquier clase de insecto alado, y no lo comeréis."
,"20":"Comeréis toda clase de aves puras."
,"21":"No comeréis ningún animal muerto. Lo darás al extranjero residente o lo venderás al extranjero de fuera. Tú eres un pueblo consagrado al Señor, tu Dios. No cocerás el cabrito en la leche de su madre."
,"22":"Cada año apartarás la décima parte del producto de tus campos,"
,"23":"y en presencia del Señor, en el lugar elegido por él para hacer habitar en él su nombre, allí comerás el diezmo de tu trigo, de tu mosto, de tu aceite y los primogénitos de tu ganado mayor o menor, para que aprendas a respetar al Señor, tu Dios, en todo momento."
,"24":"Si el camino fuera largo para poder llevarlos allá; si una gran distancia te separa del lugar que el Señor, tu Dios, haya elegido para hacer habitar en él su nombre, cuando el Señor, tu Dios, te haya bendecido,"
,"25":"lo convertirás en dinero y, tomándolo en tu mano, irás al lugar elegido por el Señor, tu Dios."
,"26":"Allí adquirirás con ello lo que quieras: bueyes, ovejas, vino y otra bebida fermentada; en una palabra, lo que quieras; lo comerás allí en presencia del Señor, tu Dios, y te regocijarás tú y tu familia."
,"27":"No olvides al levita que vive en tu ciudad, pues él no tiene parte ni herencia como tú."
,"28":"Cada tres años separarás la décima parte de los productos de este tercer año y lo depositarás a las puertas de tu ciudad."
,"29":"Allí vendrá el levita, que no tiene parte ni herencia como tú; el inmigrante, el huérfano y la viuda de tu ciudad, y comerán hasta saciarse. Así el Señor, tu Dios, te bendecirá en todas tus empresas."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Cada siete años perdonarás todo lo que te deban."
,"2":"Este perdón consistirá en lo siguiente: todo acreedor perdonará a su prójimo todo lo que le haya prestado; no lo exigirá ya más de su prójimo, es decir, de su hermano, una vez proclamado el perdón del Señor."
,"3":"Podrás exigirlo del extranjero, pero no de tu hermano, al que se lo perdonarás."
,"4":"Así no habrá pobres junto a ti, pues el Señor te dará la bendición en la tierra que te da en herencia,"
,"5":"con la condición de que escuches su voz y pongas por obra cuidadosamente todos los mandamientos que hoy te doy yo."
,"6":"Si el Señor, tu Dios, te bendice tal como lo ha prometido, prestarás a muchas naciones sin necesidad de tomar de ellas prestado. Dominarás a muchos pueblos, y ellos no te dominarán."
,"7":"Si hay en medio de ti un necesitado, uno de tus hermanos, en una de las ciudades de la tierra que el Señor, tu Dios, te da, no endurecerás tu corazón ni cerrarás la mano a tu hermano pobre,"
,"8":"sino que le abrirás tu mano y le prestarás todo lo que le haga falta."
,"9":"No te dejes llevar de este pensamiento egoísta: Ya está cercano el año séptimo, el año del perdón y, si poniendo mala cara a tu hermano necesitado, no le das nada, podría apelar al Señor contra ti, y te harías reo de pecado."
,"10":"Debes darle, y darle con alegría; y el Señor, tu Dios, te bendecirá en todas tus obras y en todas tus empresas."
,"11":"Nunca faltarán pobres en la tierra; por eso te digo: Abre tu mano a tu hermano, al humillado y al pobre de tu tierra."
,"12":"Si un hermano tuyo, hebreo o hebrea, se vende a ti, te servirá seis años. El séptimo le dejarás libe;"
,"13":"y, al darle la libertad, no le despedirás con las manos vacías,"
,"14":"sino que le darás a título de regalo algo de tu ganado, de tu era o de tu lagar, haciéndole partícipe en los bienes con que el Señor, tu Dios, te bendice a ti."
,"15":"Recuerda que fuiste esclavo en Egipto y que el Señor, tu Dios, te dio la libertad. Por eso te ordeno esto hoy."
,"16":"Si tu esclavo te dice: No quiero salir de junto a ti, por razón de su amor hacia tu casa, y se encuentra contento contigo,"
,"17":"entonces, tomando un punzón, le harás un agujero en la oreja a la puerta y será esclavo tuyo para siempre. Si se trata de una esclava, harás lo mismo."
,"18":"No te pese darle la libertad, pues sus seis años de servicio te han valido ya el doble del salario de un jornalero, y el Señor, tu Dios, te bendecirá en todo lo que hagas."
,"19":"Todo primogénito macho de tu ganado mayor o menor lo consagrarás al Señor, tu Dios. No trabajarás con los primogénitos de tus vacas ni esquilarás los primogénitos de tus ovejas,"
,"20":"sino que los comerás cada año, tú y tu familia, en presencia del Señor, tu Dios, en el lugar elegido por él."
,"21":"Si es defectuoso, si es cojo o ciego o con otro defecto, no lo ofrecerás en sacrificio al Señor, tu Dios."
,"22":"Lo comerás en tu ciudad, como se come la gacela o el ciervo; lo podrán comer el puro y el impuro."
,"23":"Pero la sangre no la comerás: la derramarás por tierra, como se derrama el agua."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Cuida de observar el mes de abib y de celebrar en él la pascua del Señor, tu Dios, pues fue en el mes de abib, de noche, cuando el Señor, tu Dios, te sacó de Egipto."
,"2":"Inmolarás como víctima pascual al Señor, tu Dios, ganado mayor y menor en el lugar elegido por él, para hacer habitar allí su nombre."
,"3":"No comerás con la víctima pan fermentado, sino que comerás durante siete días pan sin levadura -el pan de la aflicción-, pues fue a toda prisa como saliste de Egipto; así recordarás todos los días de tu vida tu salida de Egipto."
,"4":"No se verá levadura esos siete días entre vosotros, en todo vuestro territorio; y de la carne de la víctima inmolada por la tarde no se reserve nada para la noche hasta la mañana siguiente."
,"5":"No podrás inmolar la pascua en cualquiera de las ciudades que te haya dado el Señor, tu Dios,"
,"6":"sino solamente en el lugar elegido por él para hacer habitar en él su nombre inmolarás la pascua; y lo harás al atardecer, al ponerse el sol, a la hora de tu salida de Egipto."
,"7":"La cocerás y la comerás en el lugar elegido por el Señor, tu Dios; y a la mañana siguiente volverás a tus tiendas."
,"8":"Durante seis días comerás pan sin levadura; el séptimo día habrá asamblea solemne en honor del Señor, tu Dios, y no harás trabajo alguno en él."
,"9":"Contarás siete semanas, a partir del día en que comienza la siega."
,"10":"Entonces celebrarás la fiesta de las semanas en honor del Señor, tu Dios, y presentarás ofrendas voluntarias en proporción de los bienes con que el Señor, tu Dios, te haya bendecido."
,"11":"En presencia del Señor, tu Dios, en el lugar elegido por él para hacer habitar su nombre, allí te regocijarás tú, tu hijo y tu hija, tu siervo y tu sierva, el levita, el extranjero, el huérfano y la viuda que viven en tu ciudad."
,"12":"Acuérdate que fuiste esclavo en Egipto y pon en práctica cuidadosamente estos mandamientos."
,"13":"Celebrarás la fiesta de los tabernáculos durante siete días, una vez recogidos los frutos de tu era y de tu lagar."
,"14":"Te regocijarás en tu fiesta tú, tu hijo y tu hija, tu siervo y tu sierva, el levita y el extranjero, el huérfano y la viuda que viven en tus ciudades."
,"15":"Durante siete días celebrarás la fiesta en honor del Señor, tu Dios, en el lugar elegido por él, pues el Señor te bendecirá en todas tus cosechas y en todos tus trabajos y serás enteramente feliz."
,"16":"Todos los varones deberán presentarse tres veces al año ante el Señor, tu Dios, en el lugar elegido por él: en la fiesta de los panes sin levadura, en la fiesta de las semanas y en la fiesta de los tabernáculos. Nadie se presentará con las manos vacías ante el Señor,"
,"17":"sino que cada cual hará sus ofrendas en proporción de los bienes con que el Señor, tu Dios, te haya bendecido."
,"18":"Te constituirás jueces y escribas en todas las ciudades que el Señor, tu Dios, te da, tribu por tribu, para que juzguen al pueblo con toda justicia."
,"19":"No violentes el derecho, no hagas acepción de personas, no aceptes regalos, porque los regalos ciegan los ojos de los sabios y corrompen las sentencias de los justos."
,"20":"Sigue estrictamente la justicia, para que vivas y goces de la tierra que el Señor, tu Dios, está para darte en posesión."
,"21":"No plantes cipos sagrados, de cualquier madera que sean, junto al altar que construirá para ti el Señor, tu Dios;"
,"22":"ni levantes estelas, pues el Señor, tu Dios, las aborrece."
}`)
	CurrentBook.AddChapter(17, `{
"1":"No ofrecerás como sacrificio al Señor, tu Dios, animal, mayor o menor, que tenga una falta o defecto cualquiera, pues es aborrecible a sus ojos."
,"2":"Si en medio de ti, en alguna de las ciudades que el Señor, tu Dios, te va a dar, hay un hombre o una mujer que hace lo que desagrada al Señor, tu Dios, quebrantando su alianza,"
,"3":"adorando a otros dioses para darles culto y postrándose ante ellos, ante el sol, la luna o cualquier otro astro del ejército de los cielos, cosa que yo he prohibido,"
,"4":"y esto llega a tu conocimiento, harás una escrupulosa investigación, y si el rumor se confirma y el hecho es verdadero, si se cometió en Israel tal abominación,"
,"5":"llevarás a las puertas de la ciudad al hombre o a la mujer que haya cometido tal delito y los matarás a pedradas."
,"6":"No se podrá ejecutar al reo de muerte más que por la declaración de dos o tres testigos; nadie será condenado a muerte por la declaración de un solo testigo."
,"7":"Los testigos pondrán los primeros sus manos sobre el condenado para hacerle morir, y seguirá luego el pueblo. De esta manera extirparás el mal de en medio de ti."
,"8":"Si te encuentras en tu ciudad con una causa difícil, de homicidio, peleas, lesiones u otro litigio cualquiera, irás al lugar elegido por el Señor, tu Dios,"
,"9":"y te presentarás a los sacerdotes levitas y al juez en funciones, y los consultarás para que ellos dicten la sentencia."
,"10":"Acatarás la sentencia recibida y cuidarás de ajustarte en todo a las instrucciones que te hayan dado."
,"11":"Seguirás puntualmente la ley que te hayan enseñado y la sentencia que hayan pronunciado, sin apartarte a derecha o a izquierda de lo que te hayan dicho."
,"12":"El que actúe con arrogancia y no obedezca ni al sacerdote que está allí para servir al Señor, tu Dios, ni al juez, será condenado a muerte. Así extirparás el mal en Israel."
,"13":"El pueblo, al saberlo, temerá y dejará de actuar con arrogancia."
,"14":"Cuando hayas entrado en la tierra que el Señor, tu Dios, te da, te hayas posesionado de ella y vivas en ella, si quieres tener un rey como lo tienen todos los pueblos de alrededor,"
,"15":"pondrás por rey a uno de tus hermanos elegido por el Señor; no pondrás por rey a un extranjero, uno que no sea tu hermano."
,"16":"Pero ese rey no debe tener muchos caballos ni enviar de nuevo gente a Egipto para aumentar su caballería, pues el Señor, tu Dios, ha dicho: No volváis nunca jamás por ese camino."
,"17":"No debe tener muchas mujeres, para que no se desvíe su corazón, ni grandes cantidades de oro o plata."
,"18":"Cuando suba al trono deberá escribir en un rollo, para uso propio, una copia de esta ley, según el ejemplar que está en poder de los sacerdotes levitas."
,"19":"La tendrá consigo y la leerá todos los días de su vida, para que aprenda a respetar a su Dios, guardando todas sus palabras y poniendo en práctica todas sus prescripciones,"
,"20":"para que no se crea superior a sus hermanos y no se desvíe de ella ni a derecha ni a izquierda, y de esta manera prolongue los días de su reinado, él y sus hijos, sobre el trono de Israel."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Los sacerdotes levitas, toda la tribu de Leví, no tendrán parte ni heredad como los demás israelitas; vivirán de las carnes de los sacrificios y del patrimonio del Señor."
,"2":"No tendrán heredad como sus hermanos. El Señor es su heredad, como él lo ha dicho."
,"3":"Éstos son los derechos de los sacerdotes sobre el pueblo, sobre los que ofrecen un sacrificio de ganado mayor o menor: se dará al sacerdote la pierna, la mandíbula y el cuajar,"
,"4":"las primicias de tu trigo, de tu mosto y de tu aceite y las del esquileo de tus ovejas."
,"5":"Porque a él le ha elegido el Señor, tu Dios, entre todas tus tribus para estar en su presencia, hacer el servicio divino y dar la bendición en su nombre, él y sus hijos eternamente."
,"6":"Si un levita sale de alguna de tus ciudades, de cualquier punto de Israel, donde vivía, para venir con todo el deseo de su alma al lugar elegido por el Señor,"
,"7":"podrá ejercer su ministerio en nombre del Señor, su Dios, como todos sus hermanos levitas que están allí al servicio del Señor,"
,"8":"y comerá una porción igual a la suya, aparte de su patrimonio personal."
,"9":"Cuando hayas entrado en la tierra que el Señor, tu Dios, te da, no imites las prácticas horrendas de aquellos pueblos."
,"10":"No haya en medio de ti quien queme en sacrificio a su hijo o a su hija, ni quien practique la adivinación, el sortilegio, la superstición,"
,"11":"el encantamiento, ni quien consulte a los adivinos y a los que invocan a los espíritus, ni quien interrogue a los muertos."
,"12":"Pues todo ello es abominable a los ojos del Señor, tu Dios; y precisamente por estas prácticas horrendas es por lo que el Señor, tu Dios, echa lejos de ti a estas naciones."
,"13":"Sé perfecto ante el Señor, tu Dios."
,"14":"Esas gentes que vas a desposeer escuchan a hechiceros y adivinos; pero a ti nada de esto te permite el Señor, tu Dios."
,"15":"El Señor, tu Dios, suscitará de en medio de ti, entre tus hermanos, un profeta como yo, al que debéis obedecer."
,"16":"Es precisamente lo que tú pediste al Señor, tu Dios, en el Horeb, el día de la asamblea, cuando dijiste: No queremos oír más la voz del Señor, ni ver ese gran fuego para no morir,"
,"17":"y el Señor me dijo: Dicen bien."
,"18":"Yo les suscitaré de en medio de sus hermanos un profeta como tú; pondré mis palabras en su boca, y él les dirá todo lo que yo le mande."
,"19":"Al que no escuche las palabras que él dirá en mi nombre, yo mismo le pediré cuentas."
,"20":"Pero el profeta que tenga la osadía de anunciar en mi nombre lo que yo no le haya ordenado decir o hable en nombre de otros dioses, ese profeta morirá."
,"21":"Y si piensas: ¿Cómo puedo conocer yo la palabra que no ha dicho el Señor?"
,"22":"Si ese profeta ha hablado en nombre del Señor y su palabra no tiene efecto ni se cumple, entonces es cosa que no ha dicho el Señor. El profeta ha hablado por arrogancia; no lo temas."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Cuando el Señor, tu Dios, haya exterminado las naciones cuyas tierras te da en posesión y vivas en sus ciudades y en sus casas,"
,"2":"pondrás aparte tres ciudades del país que el Señor, tu Dios, te da en posesión."
,"3":"Allanarás los caminos de acceso y dividirás en tres sectores el territorio que el Señor, tu Dios, te da en heredad, con el fin de que todo homicida pueda encontrar refugio en estas ciudades."
,"4":"El homicida puede refugiarse allí y salvar su vida si mató a su prójimo sin querer, sin haber sido anteriormente enemigo suyo."
,"5":"Por ejemplo, si uno va con otro a cortar leña al bosque y, mientras maneja con fuerza el hacha para derribar el árbol, ésta salta del mango y, alcanzando al compañero, le mata, aquél puede refugiarse en una de estas ciudades y salvar la vida;"
,"6":"de lo contrario, el vengador del homicida lo perseguirá y, si el camino fuese largo, lo alcanzaría y le daría muerte. Y, sin embargo, ese hombre no merecía la muerte, pues nunca había odiado a su víctima."
,"7":"Por eso te doy esta orden: Pon aparte tres ciudades."
,"8":"Si el Señor, tu Dios, ensancha tus fronteras, y te da toda la tierra, tal como lo prometió a tus padres -"
,"9":"a condición, desde luego, que guardes y pongas por obra todos estos mandamientos que yo te doy hoy, amando a tu Dios y siguiendo sus caminos-, entonces, a aquellas tres ciudades añadirás otras tres más."
,"10":"De esta manera no se derramará sangre inocente dentro de la tierra que el Señor, tu Dios, está para darte en posesión; de lo contrario, la sangre caería sobre ti."
,"11":"En cambio, si un hombre que odia a su prójimo le prepara una emboscada, se arroja sobre él, le hiere mortalmente y luego se refugia en una de estas ciudades,"
,"12":"los ancianos de su ciudad le mandarán prender y le entregarán en manos del vengador de sangre, para que lo mate."
,"13":"No tendrá piedad de él. Alejarás de Israel todo derramamiento de sangre inocente, y serás feliz."
,"14":"No desplazarás los límites de tu prójimo, puestos por tus antepasados para limitar tu herencia en la tierra que el Señor, tu Dios, está para darte."
,"15":"Un solo testigo no basta para probar la culpabilidad de un hombre en cualquier clase de falta o delito que sea. La sentencia se apoyará en la declaración de dos o tres testigos, cualquiera que sea el delito."
,"16":"Si un testigo falso se levanta contra un hombre para acusarle de rebelión,"
,"17":"los dos interesados en la causa se presentarán ante el Señor, ante los sacerdotes y jueces en funciones en ese momento;"
,"18":"ellos, si, después de una buena investigación, averiguan que el testigo había declarado en falso contra su hermano,"
,"19":"harán con él lo mismo que él pensaba hacer con su hermano. Así extirparás el mal de en medio de ti."
,"20":"Los demás, al saberlo, temerán y no volverán a cometer tal villanía."
,"21":"No tendrás compasión: vida por vida, ojo por ojo, diente por diente, mano por mano, pie por pie."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Cuando salgas a hacer la guerra contra tus enemigos y veas los caballos y los carros de un pueblo más numeroso que tú, no tengas miedo de ello, pues el Señor, tu Dios, está contigo, el mismo que te sacó de Egipto."
,"2":"Cuando vayáis a entrar en el combate, se adelantará el sacerdote y hablará al ejército"
,"3":"diciendo: ¡Escucha, Israel! Hoy mismo vais a dar la batalla contra vuestros enemigos. No desfallezca vuestro corazón. No temáis, no tembléis ni os asustéis ante ellos,"
,"4":"pues el Señor, vuestro Dios, va delante de vosotros para combatir con vosotros contra vuestros enemigos y daros la victoria."
,"5":"Luego hablarán al pueblo los escribas, diciendo: ¿Hay alguno que tenga edificada una casa nueva y no la haya estrenado todavía? Que se vuelva a su casa, no sea que muera en el combate y sea otro quien la estrene."
,"6":"¿Hay alguno que tenga plantada una viña y no la haya vendimiado todavía? Que se vuelva a su casa, no sea que muera en el combate y sea otro quien recoja sus frutos."
,"7":"¿Hay alguno que tenga compromiso de matrimonio y todavía no se haya casado? Que se vuelva a su casa, no sea que muera en el combate y se case otro con su prometida."
,"8":"Los jefes seguirán diciendo a la tropa: ¿Hay alguien que tenga miedo y se acobarde? Que se vuelva a su casa para que no contagie la cobardía a sus hermanos."
,"9":"Una vez que los escribas hayan terminado de hablar al pueblo, se pondrán al frente los jefes de tropa."
,"10":"Cuando te acerques a una ciudad para atacarla, le brindarás primero la paz."
,"11":"Si la acepta y te abre sus puertas, todos los habitantes que haya en ella te servirán como esclavos en trabajos forzados."
,"12":"Si rechaza la paz y te declara la guerra, la atacarás."
,"13":"El Señor, tu Dios, te la pondrá en tus manos, y pasarás al filo de la espada a todos sus varones."
,"14":"Las mujeres, los niños, los ganados y lo que haya en la ciudad, lo tomarás contigo y disfrutarás del botín que el Señor, tu Dios, te haya dado."
,"15":"Eso mismo harás con todas las ciudades que están muy distantes y no pertenecen a estas naciones."
,"16":"En las ciudades de estas naciones que el Señor, tu Dios, te da como heredad, no dejarás nada con vida."
,"17":"Los darás a todos al exterminio, a hititas, amorreos, cananeos, fereceos, heveos o jebuseos, tal como el Señor, tu Dios, te ha ordenado,"
,"18":"para que no aprendas a imitar las cosas horribles que ellos hacen con sus dioses y no peques contra el Señor, tu Dios."
,"19":"Si para conquistar una ciudad te ves obligado a sitiarla por largo tiempo, no destruyas los árboles a golpe de hacha. Come sus frutos, pero no los tales. ¿Es que son hombres los árboles del campo para que los asedies?"
,"20":"Solamente podrás destruir y talar los árboles que no dan fruto y servirte de ellos en el asedio contra las ciudades que están en guerra contigo hasta que caigan en tu poder."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Si en la tierra que el Señor, tu Dios, te va a dar en posesión se encuentra un muerto tirado en el campo sin que se sepa quién lo mató,"
,"2":"irán los ancianos y los jueces y medirán las distancias entre la víctima y las ciudades de alrededor"
,"3":"para localizar la más cercana. Entonces los ancianos de esta ciudad tomarán una becerra que no haya trabajado todavía ni haya sido uncida al yugo,"
,"4":"la llevarán junto a un arroyo que siempre lleve agua, un lugar que nunca haya sido labrado ni sembrado, y allí la degollarán."
,"5":"Intervendrán después los sacerdotes levitas, ya que a ellos los eligió el Señor, tu Dios, para que le sirvan y bendigan en su nombre, y suya es también la decisión en caso de litigios y lesiones."
,"6":"Y todos los ancianos de la ciudad más cercana a la víctima lavarán sus manos sobre la becerra degollada en el valle,"
,"7":"y dirán en alta voz: Nuestras manos no han derramado esta sangre ni lo han visto nuestros ojos."
,"8":"Oh, Señor, perdona a tu pueblo Israel, al que rescataste, y no permitas que en medio de Israel, tu pueblo, se derrame sangre inocente; así se verán libres de la venganza de la sangre."
,"9":"Así también terminarás con el derramamiento de sangre inocente, haciendo lo que es recto a los ojos del Señor."
,"10":"Cuando salgas a la guerra contra tus enemigos, y el Señor, tu Dios, los haya entregado en tus manos y tú los hayas hecho prisioneros,"
,"11":"si entre ellos ves una mujer hermosa y te enamoras de ella, podrás casarte con ella"
,"12":"y llevarla a tu casa. Se rapará la cabeza, se cortará las uñas,"
,"13":"se quitará el vestido que llevaba cuando fue hecha prisionera, se quedará en tu casa y llorará a sus padres durante un mes; luego podrás acercarte a ella; tú serás su marido y ella tu mujer."
,"14":"Si deja de gustarte, le darás la libertad, sin venderla por dinero ni maltratarla, ya que la has poseído."
,"15":"Si un hombre tiene dos mujeres y quiere a una y a la otra no, si las dos le dan hijos y el primogénito es de la que no quiere,"
,"16":"el día que reparta los bienes a sus hijos no podrá tratar como primogénito al hijo de la mujer que quiere con detrimento del hijo de la que no quiere, que es el verdadero primogénito,"
,"17":"sino que reconocerá como primogénito al hijo de la que no quiere, asignándole dos partes, porque este hijo es las primicias de su virilidad y suyo es el derecho de primogenitura."
,"18":"Si uno tiene un hijo indócil y rebelde, que no obedece a sus padres ni a fuerza de castigos,"
,"19":"los padres lo llevarán a los ancianos a las puertas de la ciudad"
,"20":"y les dirán: Este hijo nuestro es indócil y rebelde, no nos hace caso; es un libertino y un borracho."
,"21":"Entonces todos sus conciudadanos lo matarán a pedradas. Así extirparás la maldad de en medio de ti, y todo Israel, al saberlo, cobrará miedo."
,"22":"Si un condenado a muerte es ejecutado colgándolo de un árbol"
,"23":"su cadáver no podrá quedar allí durante la noche, sino que lo enterrarás el mismo día, pues el que muere colgado de un árbol es maldito de Dios, y tú no debes manchar la tierra que el Señor, tu Dios, te da en heredad."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Si ves el buey o la oveja de tu prójimo que se han extraviado, no te desentiendas de ellos; llévaselos a tu hermano."
,"2":"Si tu hermano no es de tu ciudad ni lo conoces, encierra el animal en tu casa y tenlo allí hasta que tu hermano venga a buscarlo, y entonces se lo entregarás."
,"3":"Lo mismo harás con su asno, con su manto y con todo objeto perdido por tu hermano que tú encuentres. No debes desentenderte de ellos."
,"4":"Si ves el asno de tu hermano o su buey caídos en el camino, no te desentiendas; ayúdale a levantarlos."
,"5":"La mujer no llevará vestidos de hombre y el hombre no llevará vestidos de mujer, pues son cosas aborrecibles a los ojos del Señor, tu Dios."
,"6":"Si, de camino, encuentras en un árbol o en el suelo un nido de pájaros con pollos o con huevos y la madre echada sobre ellos, no tomes a la madre con los pollos;"
,"7":"deja volar a la madre y quédate sólo con los pollos. Así te irá bien y tendrás una vida larga."
,"8":"Cuando construyas una casa, pondrás una baranda alrededor de la azotea. Así tu casa no será responsable de sangre si alguien se cae de ella."
,"9":"No siembres en tu viña más de una clase de simiente, no sea que todo sea declarado sagrado, lo que sembraste y la cosecha de la viña."
,"10":"No ares con un buey y un asno uncidos juntos."
,"11":"No lleves vestido tejido con un hilo de lana y otro de lino."
,"12":"Te harás borlas para las cuatro puntas del manto con que te cubras."
,"13":"Si un hombre se casa con una mujer y, después de cohabitar con ella, le pierde el cariño,"
,"14":"le imputa falsos delitos y la difama diciendo: Me casé con esta mujer, pero cuando me uní a ella no la encontré virgen,"
,"15":"los padres de la joven tomarán las pruebas de la virginidad y las presentarán a los ancianos en las puertas de la ciudad."
,"16":"El padre de la joven dirá a los ancianos: Yo había dado a mi hija por mujer a este hombre, que la ha aborrecido"
,"17":"tanto que le hace acusaciones deshonrosas, diciendo: No he encontrado virgen a tu hija. Pero ahí están las pruebas de la virginidad. Y extenderá la sábana ante los ancianos de la ciudad."
,"18":"Entonces los ancianos tomarán al hombre y lo castigarán,"
,"19":"condenándolo a pagar cien monedas de plata como reparación al padre de la joven, puesto que este hombre ha difamado a una virgen de Israel. Ella continuará siendo su mujer, y no podrá divorciarse de ella en toda su vida."
,"20":"Pero si la acusación es verdadera y no se han encontrado en la joven las pruebas de la virginidad,"
,"21":"la sacarán fuera de la casa de su padre y toda la ciudad la matará a pedradas, por haber cometido una acción infame en Israel prostituyendo la casa de su padre. Así extirparás la maldad de en medio de ti."
,"22":"Si un hombre es sorprendido acostado con una mujer casada, los dos serán condenados a muerte. Así extirparás la maldad de en medio de ti."
,"23":"Si uno encuentra en la ciudad a una joven virgen prometida de otro y se acuesta con ella,"
,"24":"los dos serán sacados a las puertas de la ciudad y matados a pedradas: la joven por no haber pedido socorro estando en la ciudad, y el hombre por haber deshonrado a la mujer de su prójimo."
,"25":"Pero si fue en el campo donde el hombre la encontró, acostándose con ella, morirá solamente el hombre;"
,"26":"a la mujer no le harás nada, pues no ha cometido culpa que merezca la muerte. Es un caso semejante al del hombre que se lanza sobre otro y le mata."
,"27":"Al ser sorprendida en el campo, la joven pudo pedir socorro, pero no había nadie que pudiera ir en su auxilio."
,"28":"Si un hombre encuentra a una joven virgen y sin compromiso de matrimonio, y la obliga a acostarse con él y son sorprendidos,"
,"29":"el hombre debe pagar al padre de la joven cincuenta monedas de plata, se casará con ella por haberla deshonrado y no podrá divorciarse de ella en toda su vida."
}`)
	CurrentBook.AddChapter(23, `{
"1":"Nadie tomará la mujer de su padre ni tendrá relaciones sexuales con ella."
,"2":"No será admitido en la asamblea del Señor el que tenga testículos aplastados o el pene amputado;"
,"3":"ni el mestizo ni sus descendientes, aun de la décima generación;"
,"4":"ni el amonita, ni el moabita, ni sus descendientes, aun de la décima generación, y esto para siempre,"
,"5":"pues no os salieron a recibir con pan y agua en vuestro viaje cuando veníais de Egipto, sino que llamaron a Balaán, hijo de Beor, desde Petor, en Mesopotamia, y le pagaron para que te maldijese."
,"6":"Pero el Señor, tu Dios, no escuchó a Balaán, e incluso cambió la maldición en bendición en favor tuyo; porque el Señor, tu Dios, te ama."
,"7":"No buscarás su prosperidad ni su bienestar jamás, en todos los días de tu vida."
,"8":"No desprecies al edomita, pues es tu hermano; ni al egipcio, pues fuiste huésped en su tierra;"
,"9":"sus hijos, a partir de la tercera generación, podrán ser admitidos en la asamblea del Señor."
,"10":"Cuando salgas a la guerra contra tus enemigos, guárdate de toda clase de maldad."
,"11":"Si alguno queda impuro por polución nocturna, salga del campo y no vuelva a entrar;"
,"12":"al atardecer se lavará y, al ponerse el sol, podrá entrar de nuevo en el campamento."
,"13":"Tendrás también un lugar fuera del campamento para hacer allí tus necesidades."
,"14":"Llevarás en tu equipaje una paleta, con la cual harás un hoyo en la tierra, y luego lo taparás, después de haber hecho en él tus necesidades."
,"15":"El Señor, tu Dios, está en medio de tu campamento para protegerte y librarte de tus enemigos. Por tanto, tu campamento debe ser santo, para que el Señor no vea indecencias en medio de él y no se aparte de ti."
,"16":"Si un esclavo se escapa y se refugia en tu casa, no lo entregarás a su amo."
,"17":"Se quedará contigo, entre los tuyos, en el lugar que él elija y en la ciudad que más le guste; no le molestarás."
,"18":"Ningún hombre ni ninguna mujer israelita practicarán la prostitución sagrada."
,"19":"No lleves a la casa del Señor, tu Dios, el dinero adquirido por esa prostitución para pagar el voto que hayas hecho, pues eso es aborrecible a los ojos del Señor, tu Dios."
,"20":"No exijas interés alguno de tus hermanos ni por dinero, ni por víveres, ni por ninguna otra cosa que se suele prestar a interés."
,"21":"Puedes exigírselo al extranjero, pero no a tu hermano, para que el Señor, tu Dios, te bendiga en todas tus empresas en la tierra que estás a punto de entrar a poseer."
,"22":"Cuando hayas hecho un voto al Señor, tu Dios, no tardes en cumplirlo, porque él te pedirá cuenta, y te harás reo de pecado."
,"23":"Si no haces ningún voto, no pecas;"
,"24":"pero si haces libremente un voto al Señor, tu Dios, debes cumplirlo."
,"25":"Cuando entres en la viña de tu prójimo podrás comer uvas hasta hartarte, pero no guardarlas en tu cesta."
,"26":"Cuando entres en la mies de tu prójimo podrás tomar espigas con la mano, pero no meter la hoz en la mies de tu prójimo."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Si un hombre se casa con una mujer y luego no le gusta por haber encontrado en ella algo indecente, le dará por escrito un certificado de divorcio y la echará de casa."
,"2":"Una vez fuera de casa, esta mujer puede casarse con otro."
,"3":"Si también el segundo marido la aborrece, le da el certificado de divorcio y la echa de casa, o si este segundo marido se muere,"
,"4":"el primer marido no podrá volver a casarse con ella, pues se ha vuelto impura; sería una cosa horrenda ante el Señor, y tú no debes manchar con pecados la tierra que el Señor, tu Dios, te da en heredad."
,"5":"Si un hombre está recién casado, no irá a la guerra ni se le hará cumplir otra clase de servicios; quedará libre en su casa durante un año para contentar a su mujer."
,"6":"Nadie tomará en prenda las dos piezas de su molino, ni siquiera la piedra superior, pues sería tomar en prenda la vida."
,"7":"Si se descubre que alguien ha secuestrado a un hermano suyo israelita para emplearlo como esclavo o para venderlo, el secuestrador será condenado a muerte. Así extirparás la maldad de en medio de ti."
,"8":"En caso de lepra, observad con exactitud y poned en práctica todo lo que os han enseñado los sacerdotes levitas. Procurad cumplir todo lo que yo les he ordenado."
,"9":"Recuerda lo que el Señor, tu Dios, hizo con María durante el viaje después de la salida de Egipto."
,"10":"Si haces algún préstamo al prójimo, no entres en su casa para elegir la prenda, cualquiera que sea,"
,"11":"sino que esperarás fuera a que el deudor te saque la prenda."
,"12":"Si éste fuere pobre, no retendrás contigo la prenda ni siquiera una noche,"
,"13":"sino que se la devolverás a la puesta del sol para que él, al acostarse, pueda arroparse con su manto y te bendiga. Ésta será una buena acción a los ojos del Señor, tu Dios."
,"14":"No explotes al pobre y al indigente, ya sea uno de tus hermanos o uno de los extranjeros que viven en tus ciudades."
,"15":"Págale cada día su salario, antes de ponerse el sol, pues es pobre y espera impacientemente su jornal. De lo contrario, apelará al Señor, y tú serás culpable."
,"16":"Los padres no morirán por culpa de sus hijos, ni los hijos por la de sus padres; cada uno morirá por su propio pecado."
,"17":"No violes el derecho del emigrante, ni el del huérfano, ni tomes en prenda los vestidos de la viuda."
,"18":"Recuerda que fuiste esclavo en Egipto y que el Señor, tu Dios, te dio la libertad. Por eso te ordeno que cumplas esta ley."
,"19":"Cuando hagas la recolección en tu campo, si olvidas en él una gavilla, no vuelvas a buscarla. Déjala para el emigrante, el huérfano y la viuda, para que el Señor, tu Dios, te bendiga en todas tus empresas."
,"20":"Cuando sacudas tus olivos, no vuelvas al rebusco de aceitunas; déjalas para el emigrante, el huérfano o la viuda."
,"21":"Cuando vendimies tu viña, no vuelvas a la rebusca; déjalo para el emigrante, el huérfano y la viuda."
,"22":"Acuérdate que fuiste esclavo en Egipto. Por eso te ordeno que cumplas esta ley."
}`)
	CurrentBook.AddChapter(25, `{
"1":"Si dos hombres tienen un pleito, se presentarán al tribunal, que decidirá sobre ellos: se absolverá al justo y se condenará al culpable."
,"2":"Si el culpable merece ser azotado, el juez le obligará a echarse en tierra y le hará azotar en su presencia con un determinado número de golpes proporcionado a su delito."
,"3":"Podrá darle hasta cuarenta golpes, pero no más, para que no sufra un castigo demasiado duro y se sienta humillado ante vosotros."
,"4":"No pongas bozal al buey mientras está trillando."
,"5":"Si dos hermanos viven juntos y uno de ellos muere sin hijos, la viuda no se casará con un extraño. Su cuñado se casará con ella, cumpliendo sus deberes de cuñado;"
,"6":"y el primogénito que ella dé a luz llevará el nombre del hermano muerto, para que su memoria no desaparezca de Israel."
,"7":"Pero si el hermano no quiere casarse con su cuñada, ésta se presentará en las puertas de la ciudad a los ancianos y les dirá: Mi cuñado no quiere mantener vivo en Israel el nombre de su hermano; no quiere cumplir conmigo sus deberes de cuñado."
,"8":"Los ancianos de la ciudad lo llamarán y le hablarán. Si persiste en su negativa, diciendo: No quiero casarme con ella,"
,"9":"la cuñada se acercará a él y, en presencia de los ancianos, le quitará la sandalia del pie, y escupiéndole en la cara, dirá: Esto se hace con el hombre que no quiere dar descendencia a su hermano."
,"10":"Y su casa será llamada en Israel la casa del descalzo."
,"11":"Cuando dos hermanos se están pegando, si se acerca la mujer de uno de ellos y, para librar a su marido de las manos del que le golpea, agarra a éste por sus partes,"
,"12":"le cortarás la mano sin compasión alguna."
,"13":"No tendrás en tu saco dos pesos, uno grande y otro pequeño."
,"14":"No habrá en tu casa dos medidas, una grande y otra pequeña."
,"15":"Tendrás pesos exactos y cabales; y lo mismo serán tus medidas, para que sean largos tus días sobre la tierra que el Señor, tu Dios, te da."
,"16":"Porque el Señor, tu Dios, odia a quien hace tales cosas y practica el fraude."
,"17":"Recuerda lo que te hizo Amalec cuando estabais en camino después de la salida de Egipto:"
,"18":"cómo sin temer a Dios te asaltó en el camino e hirió por la espalda a los que estaban débiles y se habían quedado rezagados, cuando ibas cansado y extenuado."
,"19":"Por eso, cuando el Señor, tu Dios, te haya puesto a seguro de todos tus enemigos que te rodean, en la tierra que está para darte en heredad, borrarás el recuerdo de Amalec de debajo del cielo. No lo olvides."
}`)
	CurrentBook.AddChapter(26, `{
"1":"Cuando hayas entrado en la tierra que el Señor, tu Dios, te da en herencia, la hayas conquistado y te hayas establecido en ella,"
,"2":"tomarás las primicias de todos los frutos del suelo que hayas hecho germinar en la tierra que el Señor, tu Dios, te da, las pondrás en una cesta e irás con ella al lugar elegido por el Señor, tu Dios, para hacer habitar en él su nombre."
,"3":"Te presentarás al sacerdote en funciones y le dirás: Yo declaro hoy en presencia del Señor, mi Dios, haber entrado ya en la tierra que el Señor había jurado a nuestros padres que nos daría."
,"4":"El sacerdote recibirá la cesta de tus manos y la pondrá delante del altar del Señor, tu Dios."
,"5":"Tomarás de nuevo la palabra y dirás ante el Señor, tu Dios: Mi padre era un arameo errante, que bajó a Egipto. Allí se quedó con unas pocas personas más; pero pronto se convirtió en una nación grande, fuerte y numerosa."
,"6":"Los egipcios nos maltrataron, nos oprimieron y nos impusieron una cruel esclavitud."
,"7":"Pero nosotros clamamos al Señor, Dios de nuestros padres, que escuchó nuestra plegaria, volvió su rostro hacia nuestra miseria, nuestros trabajos y nuestra opresión,"
,"8":"nos sacó de Egipto con mano poderosa y brazo fuerte en medio de gran terror, prodigios y portentos,"
,"9":"nos trajo hasta aquí y nos dio esta tierra que mana leche y miel."
,"10":"Y ahora aquí traigo las primicias de los frutos de la tierra que el Señor me ha dado. Las dejarás delante del altar del Señor, tu Dios, y te postrarás en su presencia. "
,"11":"Luego te regocijarás con todos los bienes con que te regala el Señor, tú y tu casa, tú y tu levita y el extranjero residente."
,"12":"El año tercero, el año del diezmo, cuando hayas terminado de separar la décima parte de todos tus frutos y se los hayas dado al levita, al emigrante, a la viuda, al huérfano, para que puedan comer en tus ciudades todo lo que quieran,"
,"13":"entonces ante el Señor, tu Dios, dirás: He apartado de mi casa lo consagrado y se lo he dado al levita, al emigrante, al huérfano, a la viuda, en plena conformidad con lo que tú me has mandado, sin traspasar ni olvidar tus mandatos."
,"14":"Nada de ello he comido estando de luto, nada he consumido en estado de impureza, ni lo he ofrecido a un muerto. He obedecido al Señor, mi Dios, y he cumplido todo lo que me has ordenado."
,"15":"Mira desde tu santa morada, desde los cielos, y bendice a tu pueblo y a la tierra que nos has dado, como habías jurado a nuestros padres, tierra que mana leche y miel."
,"16":"Hoy te manda el Señor, tu Dios, poner por obra estos preceptos y mandatos. Guárdalos y ponlos en práctica con todo tu corazón y toda tu alma."
,"17":"Hoy has comprometido al Señor para que sea tu Dios, a condición de seguir sus caminos, guardar sus mandamientos, leyes y preceptos y obedecer su voz."
,"18":"Y el Señor te ha comprometido a ti para que seas su pueblo propio, como te ha dicho, a condición de que observes sus mandamientos."
,"19":"Él te elevará sobre todas las naciones -como ya lo ha hecho- en gloria, fama y honor, y serás un pueblo consagrado al Señor, tu Dios, como él te lo ha dicho'."
}`)
	CurrentBook.AddChapter(27, `{
"1":"Moisés y los ancianos dieron esta orden al pueblo: 'Observad todos estos mandamientos que hoy os prescribo."
,"2":"El día que paséis el Jordán para entrar en la tierra que el Señor, tu Dios, te da, levantarás grandes piedras, las revocarás de cal"
,"3":"y escribirás en ellas todas las palabras de esta ley cuando hayas cruzado para entrar en la tierra que el Señor, tu Dios, te da, tierra que mana leche y miel, como te lo ha prometido el Señor, el Dios de tus padres."
,"4":"Cuando hayáis pasado el Jordán, levantaréis estas piedras sobre el monte Ebal, como os lo mando hoy, y las revocaréis con cal."
,"5":"Alzarás allí al Señor, tu Dios, un altar de piedras,"
,"6":"que no hayan sido labradas, y sobre él ofrecerás holocaustos al Señor, tu Dios;"
,"7":"ofrecerás sacrificios de reconciliación y allí comerás y te regocijarás ante el Señor, tu Dios."
,"8":"Sobre las piedras escribirás con caracteres bien claros todas las palabras de esta ley'."
,"9":"Después Moisés y los sacerdotes levitas dijeron a todo Israel: 'Guarda silencio y escucha, Israel. Hoy te has convertido en el pueblo del Señor, tu Dios."
,"10":"Obedecerás al Señor, tu Dios, y pondrás en práctica los mandamientos y las leyes que yo te prescribo hoy'."
,"11":"En aquel día Moisés dio esta orden al pueblo:"
,"12":"Cuando hayáis pasado el Jordán, se pondrán en el monte Garizín las tribus de Simeón, Leví, Judá, Isacar, José y Benjamín para pronunciar la bendición al pueblo."
,"13":"Las de Rubén, Gad, Aser, Zabulón, Dan y Neftalí se pondrán en el monte Ebal para pronunciar la maldición al pueblo."
,"14":"Tomarán la palabra los levitas y, solemnemente, en alta voz, dirán a todos los hombres de Israel:"
,"15":"¡Maldito el hombre que haga un ídolo tallado o fundido, cosa horrible para el Señor, obra de artífice, y lo ponga en lugar oculto! Y todo el pueblo responderá: ¡Amén!"
,"16":"¡Maldito el que desprecie a su padre y a su madre! Y todo el pueblo responderá: ¡Amén!"
,"17":"¡Maldito el que corra los límites de la heredad del prójimo! Y todo el pueblo responderá: ¡Amén!"
,"18":"¡Maldito el que desoriente al ciego en su camino! Y todo el pueblo responderá: ¡Amén!"
,"19":"¡Maldito el que viole el derecho del emigrante, del huérfano y la viuda! Y todo el pueblo responderá: ¡Amén!"
,"20":"¡Maldito el que peque con la mujer de su padre y atente contra el derecho de su padre! Y todo el pueblo responderá: ¡Amén!"
,"21":"¡Maldito el que peque con una bestia cualquiera! Y todo el pueblo responderá: ¡Amén!"
,"22":"¡Maldito el que peque con su hermana, hija de su padre o de su madre! Y todo el pueblo responderá: ¡Amén!"
,"23":"¡Maldito el que peque con su suegra! Y todo el pueblo responderá: ¡Amén!"
,"24":"¡Maldito el que mate a traición a su prójimo! Y todo el pueblo responderá: ¡Amén!"
,"25":"¡Maldito el mercenario que mate por dinero a un inocente! Y todo el pueblo responderá: ¡Amén!"
,"26":"¡Maldito el que no se atenga a las palabras de esta ley y no las ponga en práctica! Y todo el pueblo responderá: ¡Amén!"
}`)
	CurrentBook.AddChapter(28, `{
"1":"Pero si obedeces al Señor, tu Dios, guardando y poniendo por obra todos estos mandamientos que hoy te prescribo, el Señor, tu Dios, te elevará sobre todas las naciones de la tierra."
,"2":"Vendrán sobre ti y te alcanzarán las bendiciones siguientes por haber obedecido al Señor, tu Dios."
,"3":"Serás bendito en la ciudad y bendito en el campo."
,"4":"Bendito será el fruto de tus entrañas, el producto de tu suelo y los partos de tus vacas y rebaños."
,"5":"Bendita será tu canasta y tu artesa."
,"6":"Bendito serás en tus idas y venidas."
,"7":"El Señor pondrá en fuga delante de ti a todos los enemigos que se alcen contra ti."
,"8":"El Señor mandará la bendición para que te acompañe en tus graneros y en todas tus empresas. Te bendecirá en la tierra que el Señor, tu Dios, te da."
,"9":"Si guardas sus mandamientos y sigues sus caminos, el Señor, tu Dios, te consagrará como pueblo suyo, según te lo ha jurado,"
,"10":"y todos los pueblos de la tierra verán que el nombre del Señor está sobre ti, y te temerán."
,"11":"El Señor, tu Dios, te hará abundar en bienes: en el fruto de tus entrañas, en el fruto de tus ganados y en el producto de la tierra, de esta tierra que a tus padres juró darte."
,"12":"El Señor abrirá para ti su maravilloso tesoro, los cielos, para dar a su tiempo la lluvia a tu tierra y bendecir las obras de tus manos. Prestarás a muchas gentes y de nadie tomarás prestado."
,"13":"El Señor te pondrá a la cabeza y no a la cola, estarás siempre arriba y nunca abajo, si escuchas sus mandamientos que yo te prescribo hoy y los pones en práctica"
,"14":"sin desviarte ni a la derecha ni a la izquierda para ir tras otros dioses y darles culto."
,"15":"Pero si no obedeces al Señor, tu Dios, y no pones en práctica todos sus mandamientos y todas sus leyes que yo te prescribo hoy, vendrán sobre ti y te alcanzarán las maldiciones siguientes:"
,"16":"Maldito serás en la ciudad y maldito en el campo."
,"17":"Maldita será tu canasta y tu artesa."
,"18":"Maldito será el fruto de tus entrañas y el producto de tu tierra; malditos los partos de tus vacas y las crías de tus ovejas."
,"19":"Maldito serás tú en tus idas y venidas."
,"20":"El Señor mandará contra ti maldición, angustia y pánico en todas tus empresas, y en poco tiempo serás totalmente destruido por haberlo abandonado con tus malas acciones."
,"21":"El Señor hará que la peste se pegue a ti hasta que te consuma en la tierra que vas a ocupar;"
,"22":"te herirá de agotamiento, fiebre, inflamación, calor sofocante, sequía, herrumbre y tizón, que te perseguirán hasta destruirte."
,"23":"El cielo que está sobre ti será de bronce, y la tierra que pisan tus pies será de hierro."
,"24":"El Señor enviará lluvia sobre tu tierra; pero lluvia de arena y de polvo, que caerán del cielo sobre ti hasta que seas aniquilado."
,"25":"El Señor hará que seas derrotado por tus enemigos; saldrás a su encuentro por un camino, y por siete caminos huirás y serás el espanto de todos los reinos de la tierra."
,"26":"Tu cadáver será pasto de las aves del cielo y de todas las bestias de la tierra, sin que nadie las espante."
,"27":"El Señor te herirá con las plagas de Egipto, con tumores, sarna y tiña, de lo que no podrás curar."
,"28":"El Señor te herirá de locura, ceguera y delirio,"
,"29":"de suerte que en pleno día andarás a tientas, como anda el ciego en las tinieblas, y no tendrás éxito en ninguna de tus empresas, sino que te verás siempre oprimido y despojado, sin que nadie te socorra."
,"30":"Te casarás con una mujer, y otro la poseerá; construirás una casa, y no la habitarás; plantarás una viña, y no la vendimiarás."
,"31":"Tu buey será degollado ante tus propios ojos, y no lo podrás comer; te quitarán tu asno, y no te lo devolverán; tus enemigos se llevarán tus ovejas, y nadie te socorrerá."
,"32":"Tus hijos y tus hijas serán entregados a pueblos extranjeros; tus ojos se consumirán mirando cada día hacia el lugar de su destierro, pero tus manos nada podrán hacer."
,"33":"Un pueblo desconocido para ti comerá las cosechas de tu tierra y el fruto de todas tus fatigas, mientras tú serás siempre oprimido y aplastado."
,"34":"A la vista de tales cosas, te volverás loco."
,"35":"El Señor te herirá de úlcera maligna en tus rodillas y en tus muslos, desde la planta del pie hasta la coronilla de la cabeza, y no podrás curar."
,"36":"El Señor te hará ir a ti y al rey que hayas constituido sobre ti a una nación desconocida para ti y para tus padres, y allí servirás a dioses extranjeros, hechos de leño y de piedra,"
,"37":"hasta llegar a ser el estupor, el ludibrio y la irrisión de todos los pueblos donde el Señor te lleve."
,"38":"Sembrarás mucho, pero cosecharás poco, porque la langosta lo devorará."
,"39":"Plantarás viñas y las cultivarás, pero no beberás su vino ni las vendimiarás, pues el gusano las roerá."
,"40":"Tendrás olivos en todo tu territorio; pero no te ungirás con su aceite, porque las aceitunas se caerán."
,"41":"Tendrás hijos e hijas; pero no te pertenecerán, pues serán llevados al cautiverio."
,"42":"Todos tus árboles y los frutos de tu tierra serán devorados por la langosta."
,"43":"El extranjero que vive en tu tierra subirá cada vez más, y tú bajarás cada día más;"
,"44":"te prestará a ti, y tú no le prestarás a él; él será la cabeza, y tú la cola."
,"45":"Todas estas maldiciones vendrán sobre ti, te perseguirán y te alcanzarán hasta destruirte por no haber obedecido al Señor, tu Dios, observando los mandamientos y leyes que él te ha prescrito."
,"46":"Estas cosas serán señal y prodigio contra ti y tu descendencia para siempre."
,"47":"Por no haber servido al Señor, tu Dios, con gozo y alegría en la abundancia de bienes,"
,"48":"tendrás que servir a los enemigos que el Señor mandará contra ti; sufrirás hambre, sed, falta de ropa, miseria total. Cargarán sobre tu cuello yugo de hierro hasta destruirte."
,"49":"El Señor hará venir contra ti un pueblo lejano, desde los confines de la tierra, veloz como el águila, de lengua desconocida para ti;"
,"50":"gente de aspecto feroz, que no tendrá miramientos con el anciano, ni piedad con el niño."
,"51":"Comerán las crías de tus ganados y los frutos de tu tierra hasta arruinarte; no te dejarán nada, ni trigo, ni mosto, ni aceite, ni las crías de tus vacas, ni los corderos de tus ovejas, hasta exterminarte."
,"52":"Este pueblo pondrá incluso asedio a todas tus ciudades en la tierra que el Señor, tu Dios, te da, hasta que se derrumben las más altas y fuertes murallas, en las que habías puesto tu confianza."
,"53":"En medio del asedio y de la angustia a que te habrá reducido el enemigo, tú comerás el fruto de tus entrañas, la carne de tus hijos y tus hijas, que el Señor, tu Dios, te haya dado."
,"54":"El hombre más delicado y refinado entre vosotros mirará con malos ojos a su hermano, a la esposa de su corazón y a los hijos que todavía le quedan,"
,"55":"al no querer compartir con ellos la carne de sus hijos, que se comerá él solo, por no quedarle otra cosa en medio del asedio y de la angustia a que te habrá reducido tu enemigo en todas tus ciudades."
,"56":"La mujer más delicada y refinada entre vosotros, que por su delicadeza apenas se atrevía a pisar la tierra con la planta de sus pies, mirará con malos ojos al marido de su corazón y a sus hijos"
,"57":"y se alejará de ellos para comer a escondidas la placenta que saldrá de su seno y al hijo que acabará de dar a luz en medio de tanta privación, a causa del asedio y la angustia a que te habrá reducido tu enemigo en todas tus ciudades."
,"58":"Si no pones en práctica todas las palabras de esta ley, escrita en este libro; si no respetas este glorioso e imponente nombre del Señor, tu Dios,"
,"59":"él enviará sobre ti y tus descendientes plagas terribles, grandes y continuas calamidades."
,"60":"Desencadenará sobre ti todas las plagas de Egipto, que tanto miedo te infundían, y se pegarán a ti."
,"61":"Más aún; el Señor enviará sobre ti, hasta que seas exterminado, toda clase de enfermedades y calamidades que no están escritas en el libro de la ley."
,"62":"Quedaréis muy pocos, vosotros que erais numerosos como las estrellas del cielo, por no haber obedecido al Señor, tu Dios."
,"63":"Así como el Señor se gozaba en haceros felices y en multiplicaros, así se gozará ahora en perderos y destruiros. Seréis exterminados de la tierra que vais a ocupar."
,"64":"El Señor te dispersará entre todos los pueblos, de uno a otro extremo de la tierra, y allí serviréis a otros dioses de madera y de piedra desconocidos de ti y de tus padres."
,"65":"No encontrarás la paz entre esas naciones ni habrá descanso para la planta de tus pies, sino que el Señor te dará un corazón asustado, ojos apagados y ánimo abatido."
,"66":"Tu vida estará siempre en peligro, estarás amedrentado día y noche y no tendrás seguridad."
,"67":"Por la mañana dirás: ¡Ojalá que ya fuera de noche! Y por la tarde dirás: ¡Ojalá que ya fuera de día!, por el pavor que se habrá apoderado de tu corazón y por las cosas que verán tus ojos."
,"68":"El Señor te llevará de nuevo a Egipto por el camino del que yo te había dicho: No lo volverás a ver más. Allí os ofreceréis a vuestros enemigos en venta como esclavos y no encontraréis comprador."
,"69":"Éstos son los términos de la alianza que el Señor mandó hacer a Moisés con los israelitas en Moab, aparte de la alianza que hizo con ellos en el Horeb."
}`)
	CurrentBook.AddChapter(29, `{
"1":"Moisés convocó a todo Israel y le dijo: Habéis visto lo que el Señor hizo en Egipto al Faraón, a sus funcionarios y a todo el país;"
,"2":"sois testigos de aquellas terribles pruebas, de aquellos grandes milagros y prodigios."
,"3":"Pero hasta la fecha, el Señor no os ha dado inteligencia para entender, ojos para ver y oídos para escuchar."
,"4":"Durante cuarenta años os he hecho caminar por el desierto, sin que se os hayan gastado los vestidos y el calzado."
,"5":"No habéis comido pan ni bebido vino ni licor, para que reconozcáis que yo soy el Señor, vuestro Dios."
,"6":"Al llegar a este lugar, Sijón, rey de Jesbón, y Og, rey de Basán, salieron en armas contra nosotros, pero los derrotamos,"
,"7":"conquistamos sus tierras y las dimos en heredad a los rubenitas, a los gaditas y a media tribu de Manasés."
,"8":"Por tanto, guardad las palabras de esta alianza y ponedlas en práctica para que tengáis éxito en todas vuestras empresas."
,"9":"Hoy habéis comparecido todos ante el Señor, vuestro Dios: vuestros jefes de tribu, ancianos, escribas, todos los hombres de Israel,"
,"10":"vuestros niños, mujeres y el extranjero que vive contigo en tu campamento, desde el leñador al aguador,"
,"11":"con el fin de comprometerse, bajo juramento, en la alianza que el Señor, tu Dios, hace hoy contigo;"
,"12":"a ti te constituye hoy en pueblo suyo y él se constituye para ti en tu Dios, según se lo prometió y juró a tus padres, Abrahán, Isaac y Jacob."
,"13":"Pero no sólo con vosotros hago yo hoy esta alianza y este juramento;"
,"14":"lo hago tanto con los que están hoy aquí presentes ante el Señor, nuestro Dios, como con los que están ausentes."
,"15":"Vosotros sabéis cómo vivimos en Egipto y cómo hemos cruzado a través de las naciones por las que hemos pasado."
,"16":"Ya habéis visto sus horrorosos y vergonzosos ídolos de madera, piedra, plata y oro."
,"17":"Que no haya entre vosotros ni hombre ni mujer ni familia ni tribu que aparte hoy su corazón del Señor, nuestro Dios, para ir a servir a los dioses de esas naciones; que ninguno de vosotros sea como una planta amarga y venenosa."
,"18":"Si alguno, después de haber oído las palabras de este juramento, se hace ilusiones y dice: Todo me saldrá bien, aunque haga lo que me dé la gana, pues la abundancia de agua apaga la sed,"
,"19":"el Señor no le perdonará, sino que la ira y la indignación del Señor se encenderán contra él, y todas las maldiciones escritas en este libro caerán sobre él hasta borrar su nombre de debajo de los cielos."
,"20":"El Señor lo separará de las tribus de Israel para su perdición, según las maldiciones de la alianza escritas en este libro de la ley."
,"21":"Las generaciones futuras, los hijos que después de vosotros nacerán, el extranjero venido de tierras lejanas, a la vista de las plagas y las enfermedades que el Señor enviará sobre esta tierra, gritarán:"
,"22":"Azufre, sal, tierra quemada, eso es toda su tierra. No se podrá sembrar, nada en ella germinará, ni siquiera una hierba crecerá en ella; la catástrofe será semejante a la de Sodoma, Gomorra, Adamá y Seboyín, que el Señor destruyó llevado de su ira y su furor."
,"23":"Y todas las naciones se preguntarán: ¿Por qué el Señor ha tratado así a esta tierra? ¿Por qué se encendió tanto su furor?"
,"24":"Y les contestarán: Porque han abandonado la alianza del Señor, el Dios de sus padres, la alianza que hizo con ellos después de haberlos sacado de Egipto;"
,"25":"porque se han ido a servir a dioses extranjeros y les han tributado culto; dioses desconocidos para ellos, que no formaban parte de su herencia."
,"26":"Por eso la ira del Señor se encendió contra esta tierra hasta hacer venir sobre ella todas las maldiciones escritas en este libro."
,"27":"El Señor los ha arrancado de su tierra con ira, furor y gran indignación, y los ha arrojado a otras tierras hasta hoy."
,"28":"Las cosas ocultas pertenecen al Señor, nuestro Dios, pero las reveladas son para nosotros y nuestros hijos eternamente, para que pongamos en práctica todas las palabras de esta ley."
}`)
	CurrentBook.AddChapter(30, `{
"1":"Cuando se hayan cumplido en ti todas estas palabras, la bendición y la maldición que he puesto delante de ti, y las hayas meditado en tu corazón en medio de las naciones donde te habrá arrojado el Señor, tu Dios,"
,"2":"si de nuevo te vuelves hacia él y le obedeces, tú y tus hijos, con todo tu corazón y toda tu alma, según todo lo que yo te mando hoy,"
,"3":"él cambiará tu suerte, tendrá misericordia de ti y te reunirá de nuevo de todos los pueblos, en medio de los cuales te había arrojado."
,"4":"Aunque tus desterrados estuvieran en el confín del cielo, de allí iría a buscarte"
,"5":"para llevarte de nuevo a la tierra que poseyeron tus padres, darte posesión de ella, hacerte feliz y más numeroso todavía que ellos."
,"6":"El Señor, tu Dios, circuncidará tu corazón y el de tus descendientes para que le ames con todo tu corazón y toda tu alma, y así vivas."
,"7":"El Señor, tu Dios, hará recaer todas estas maldiciones sobre tus enemigos y sobre los que te hayan odiado y perseguido."
,"8":"Volverás a obedecer al Señor y pondrás en práctica todos estos mandamientos que hoy te prescribo,"
,"9":"y él te hará prosperar en todas tus empresas, en el fruto de tus entrañas, en el fruto de tus ganados y en el producto de tu tierra. El Señor se complacerá de nuevo en tu prosperidad, como se había complacido en la de tus padres,"
,"10":"si le obedeces, observas sus mandamientos y preceptos escritos en el libro de esta ley, y si te vuelves a él con todo tu corazón y toda tu alma."
,"11":"Pues esta ley que yo te prescribo hoy no es superior a tus fuerzas, ni está fuera de tu alcance."
,"12":"No está en los cielos, para que digas: ¿Quién subirá por nosotros a los cielos a buscarla para que nos la dé a conocer y la pongamos en práctica?"
,"13":"Ni tampoco se encuentra más allá de los mares, para que tengas que decir: ¿Quién pasará por nosotros al otro lado de los mares a buscarla para que nos la dé a conocer y la pongamos en práctica?"
,"14":"Pues la palabra está muy cerca de ti; está en tu boca, en tu corazón, para que la pongas en práctica."
,"15":"Mira, yo pongo hoy delante de ti la vida y la felicidad, la muerte y la desgracia."
,"16":"Si obedeces los mandamientos del Señor, tu Dios, que yo te prescribo hoy; si le amas, si sigues sus caminos, si guardas sus mandamientos, sus leyes y sus preceptos, vivirás y te multiplicarás y él te bendecirá en la tierra que vas a ocupar."
,"17":"Pero si tu corazón se desvía, si no obedeces y te dejas arrastrar postrándote ante otros dioses y dándoles culto,"
,"18":"yo os declaro hoy formalmente que moriréis sin remedio y no viviréis largo tiempo en la tierra que vais a conquistar una vez cruzado el Jordán."
,"19":"Yo pongo hoy por testigos al cielo y la tierra; pongo delante de ti la vida y la muerte, la bendición y la maldición. Elige la vida, para que vivas tú y tu descendencia,"
,"20":"amando al Señor, tu Dios, obedeciéndole y estando unido a él. Ahí está tu vida y tu supervivencia en la tierra que el Señor juró dar a tus padres Abrahán, Isaac y Jacob."
}`)
	CurrentBook.AddChapter(31, `{
"1":"Moisés dirigió todavía estas palabras a todo Israel:"
,"2":"'Yo tengo ciento veinte años, ya no puedo andar de un lado para otro; además, el Señor me ha dicho que no cruzaré el Jordán."
,"3":"Es el Señor, tu Dios, quien lo pasará delante de ti; es él quien destruirá estas naciones para que tú ocupes su territorio. Será Josué el que irá a tu cabeza, como te ha dicho el Señor."
,"4":"El Señor hará con ellas lo que hizo con Sijón y con Og, reyes de los amorreos, y con sus países, los cuales destruyó."
,"5":"El Señor los entregará en vuestras manos y haréis con ellos lo que yo os he mandado."
,"6":"Sed fuertes y tened ánimo; no las temáis ni os asustéis, pues el Señor, tu Dios, va contigo; él no te dejará ni te abandonará'."
,"7":"Luego Moisés llamó a Josué y le dijo en presencia de todo Israel: 'Sé fuerte y ten ánimo, pues tú debes llevar a este pueblo a la tierra que el Señor juró dar a sus padres; eres tú quien le dará posesión de ella."
,"8":"El Señor irá delante de ti; él estará contigo, no te dejará ni te abandonará; no temas ni te desanimes'."
,"9":"Moisés escribió luego esta ley y la entregó a los sacerdotes levitas, que llevaban el arca de la alianza del Señor, y a todos los ancianos de Israel."
,"10":"Y les dio esta orden: 'Cada siete años, al llegar el año del perdón, en la fiesta de los tabernáculos,"
,"11":"cuando todo Israel venga a comparecer ante el Señor, tu Dios, en el lugar elegido por él, leerás esta ley a todo el pueblo."
,"12":"Reúne al pueblo, a hombres, mujeres, niños y al extranjero residente, para que la oigan y aprendan a respetar al Señor, tu Dios, y procuren poner en práctica todas las disposiciones de esta ley."
,"13":"Deben oírla especialmente vuestros hijos, que no la conocen todavía, para que aprendan a respetar al Señor, vuestro Dios, todos los días que viváis en la tierra que vais a ocupar una vez cruzado el Jordán'."
,"14":"El Señor dijo a Moisés: 'Se avecina el día de tu muerte. Llama a Josué, y presentaos ante la tienda de la reunión para que yo le dé mis órdenes'. Moisés y Josué se presentaron ante la tienda de la reunión."
,"15":"Y el Señor se apareció en la tienda en una columna de nube, que se detuvo a la entrada de la tienda."
,"16":"El Señor dijo a Moisés: 'Mira, ya vas a descansar con tus padres. Este pueblo se va a prostituir ante dioses extranjeros, los de la tierra que va a ocupar. Me abandonará y violará la alianza que he hecho con él."
,"17":"Pero aquel día montaré en cólera contra él, lo abandonaré y me esconderé de él. Un cúmulo de males y desgracias lo asaltará para devorarlo. Entonces dirá: Mi Dios ya no está conmigo; por eso me ocurren estas desgracias."
,"18":"Sí, aquel día me apartaré todavía más de ellos por tanto mal como habrán hecho yéndose tras otros dioses."
,"19":"Escribid este cántico y enseñádselo a los israelitas, para que lo canten y me sirva a mí de testimonio contra ellos."
,"20":"Cuando los haya llevado a la tierra que prometí con juramento a sus padres, tierra que mana leche y miel; cuando hayan comido hasta saciarse y hayan engordado, luego se irán tras otros dioses, a los que servirán despreciándome a mí y violando mi alianza."
,"21":"Pero cuando caigan sobre ellos innumerables sufrimientos y desgracias, este cántico servirá de testimonio contra ellos, pues sus descendientes no lo habrán olvidado. Yo conozco las malas inclinaciones que ya hoy tiene, aun antes de entrar en la tierra que les prometí con juramento'."
,"22":"Moisés escribió aquel día el cántico y se lo enseñó a los israelitas."
,"23":"Y el Señor dio estas órdenes a Josué, hijo de Nun: 'Sé fuerte y ten ánimo, pues tú eres quien debe llevar a los israelitas a la tierra que les he prometido; yo estaré contigo'."
,"24":"Cuando Moisés terminó de escribir en un libro las prescripciones de esta ley,"
,"25":"dio estas órdenes a los levitas que llevaban el arca de la alianza del Señor:"
,"26":"'Tomad este libro de la ley y ponedlo al lado del arca de la alianza del Señor, vuestro Dios; que esté allí como testimonio contra ti,"
,"27":"porque yo sé que eres un pueblo rebelde y de cabeza dura. Si hoy, cuando yo estoy todavía en medio de vosotros, sois rebeldes al Señor, cuánto más lo seréis después de mi muerte."
,"28":"Reunid junto a mí a todos los ancianos y jefes de vuestras tribus para que yo les recite estas palabras y ponga al cielo y a la tierra contra ellos."
,"29":"Pues estoy seguro que después de mi muerte os pervertiréis y os alejaréis del camino que yo os tengo prescrito, y que la desgracia os alcanzará en el futuro por haber hecho lo malo a los ojos del Señor, irritándole con vuestra conducta'."
,"30":"Y Moisés pronunció este cántico desde el principio hasta el fin en presencia de toda la asamblea de Israel."
}`)
	CurrentBook.AddChapter(32, `{
"1":"'Escuchad, cielos, que voy a hablar. Oye, tierra, las palabras de mi boca."
,"2":"Descienda como la lluvia mi enseñanza, caiga como el rocío mi cantar, como llovizna sobre el césped, como chubasco sobre el verde."
,"3":"Voy a invocar el nombre del Señor; dad gloria a nuestro Dios."
,"4":"Él es la roca, sus obras son perfectas, todos sus caminos son la justicia misma; el Dios fiel, en él no hay maldad; es justo y recto."
,"5":"Le han traicionado los hijos degenerados, generación malvada y pervertida."
,"6":"¿Así pagáis al Señor, pueblo insensato y necio?,¿No es él tu padre y tu creador?,¿No es él el que te hizo y te constituyó?"
,"7":"Recuerda los tiempos pasados, considera los años de edad en edad. Pregunta a tu padre, que te lo cuente; a tus ancianos, que te lo digan."
,"8":"Cuando el altísimo distribuyó,su herencia entre los pueblos, cuando dividió a los hombres, estableció las fronteras de los pueblos,según el número de los hijos de Israel."
,"9":"La porción del Señor fue su pueblo; Jacob, la parte de su herencia."
,"10":"Encontró a su pueblo en el desierto, en la soledad rugiente de la desolación. Lo abrazó y se cuidó de él; lo guardó como la niña de sus ojos."
,"11":"Como el águila, que incita a su nidada,revoloteando sobre sus polluelos, así desplegó él sus alas y los tomó, los llevó sobre sus plumas."
,"12":"El Señor solo lo guiaba, no había con él dios extranjero."
,"13":"Le hizo cabalgar sobre las alturas de la tierra, lo alimentó con los productos de los campos, le dio a gustar miel de las peñas, aceite de la dura roca."
,"14":"Cuajada de vacas y leche de ovejas,con grasa de corderos y carneros, toros de Basán y machos cabríos, flor de harina de trigo en abundancia; bebiste el vino, la sangre de las uvas."
,"15":"Engordó Jesurún y tiró coces -estabas gordo y corpulento-; volvió las espaldas a Dios, su creador, y despreció la roca de su salvación."
,"16":"Lo provocaron con dioses extranjeros, lo irritaron con acciones horribles."
,"17":"Sacrificaron a demonios y no a Dios, a dioses desconocidos para ellos; dioses nuevos, recién llegados, jamás venerados por sus padres."
,"18":"Te olvidaste de la roca,que te engendró, ya no te acuerdas del Dios que te dio a luz."
,"19":"Lo vio el Señor y se irritó, disgustado por sus hijos y sus hijas,"
,"20":"y dijo: Voy a volverles las espaldas y veremos qué pasa en adelante, pues es una generación pervertida, hijos desleales."
,"21":"Me dan celos con un dios que no es dios, me irritan con dioses ilusorios; pues yo les daré celos con un pueblo que no es pueblo,y los irritaré con una nación fatua."
,"22":"Se ha encendido el fuego de mi ira,y quemará hasta lo profundo del abismo; devorará la tierra y sus productos,y abrasará los cimientos de los montes."
,"23":"Amontonaré calamidades sobre ellos, agotaré contra ellos mis saetas."
,"24":"Quedarán extenuados por el hambre, consumidos por la fiebre y por la peste. Enviaré contra ellos fieras salvajes y serpientes venenosas."
,"25":"Fuera herirá la espada; dentro, el espanto. Morirán el muchacho y la muchacha, el niño de pecho y el anciano encanecido."
,"26":"Yo hubiera querido reducirlos a polvo, borrar de entre los hombres su memoria;"
,"27":"pero pensé en la arrogancia,de los enemigos, en la falsa interpretación,que ellos harían: Ha sido nuestra mano poderosa, y no el Señor, la que hizo todo esto."
,"28":"Es una nación que ha perdido la cabeza,y no tiene entendimiento."
,"29":"Si fueran sabios lo comprenderían,y sabrían intuir lo que les espera."
,"30":"¿Cómo puede uno solo perseguir a mil,y dos poner en fuga a diez mil, sino porque su roca los ha vendido,y el Señor los ha entregado?"
,"31":"Pero su roca no es como nuestra roca, lo saben bien nuestros mismos enemigos;"
,"32":"su cepa viene de la viña de Sodoma, sus sarmientos de los campos de Gomorra, sus uvas son uvas venenosas, y amargos sus racimos."
,"33":"Su vino es vino de serpiente, veneno mortal de víbora."
,"34":"Todo esto lo tengo yo conmigo,como una joya encerrada en mis tesoros"
,"35":"para el día de la venganza y el desquite, para el tiempo en que sus pies tropezarán. Está cerca el día de su ruina, se precipita su destino."
,"36":"El Señor saldrá en defensa de su pueblo, tendrá misericordia de sus siervos, cuando vea que se agotan sus fuerzas,y que no queda entre ellos ni esclavo ni libre."
,"37":"Entonces les dirá: ¿Dónde están sus dioses, la roca en que buscaban su refugio,"
,"38":"ante los que comían,la grasa de sus víctimas,y bebían el vino de sus ofrendas?,¡Que se levanten y os socorran, que sean para vosotros un refugio!"
,"39":"Ved ahora que soy yo, que soy el único, y que no hay Dios alguno más que yo. Soy yo el dueño de la muerte y de la vida. Yo hiero y yo curo. No hay nadie que se libre de mi mano."
,"40":"Yo alzo al cielo mi mano y juro: tan verdad como que vivo eternamente,"
,"41":"cuando afile mi espada fulgurante,y empiece a hacer justicia, tomaré venganza de mis enemigos,y daré su merecido a los que me odian."
,"42":"Emborracharé de sangre mis flechas,y mi espada se hartará de carne; sangre de heridos y cautivos, cabezas de jefes enemigos."
,"43":"¡Alegraos, naciones, con el pueblo de Dios!,Porque va a vengar la sangre de sus siervos, a dar su merecido a los adversarios,y a perdonar a su tierra y a su pueblo'."
,"44":"Moisés, acompañado de Josué, hijo de Nun pronunció este cántico desde el principio hasta el fin."
,"45":"Después dijo a los israelitas:"
,"46":"'Grabad en vuestro corazón todas las palabras que hoy pongo como testigo contra vosotros y enseñádselas a vuestros hijos para que pongan en práctica todas las disposiciones de esta ley."
,"47":"No es cosa sin importancia para vosotros, puesto que la ley es vuestra vida, y por ella prolongaréis vuestros días sobre la tierra que vais a poseer una vez cruzado el Jordán'."
,"48":"Aquel mismo día el Señor dijo a Moisés:"
,"49":"'Sube al monte Nebo, sobre la cima de la cadena de montañas de Abarín, en tierra de Moab, enfrente de Jericó, y contempla la tierra de Canaán, que voy a dar en propiedad a los israelitas."
,"50":"Una vez que subas a la montaña, morirás e irás a reunirte con tus padres, como Aarón, tu hermano, murió en Hor de la Montaña y fue a reunirse con los suyos."
,"51":"Por haberme sido infiel en medio de los israelitas en las aguas de Meribá, en Cades, en el desierto de Sin; por no haber reconocido mi santidad en medio de los israelitas,"
,"52":"por eso verás solamente de lejos la tierra, pero no entrarás en ella, en esa tierra que yo doy a los israelitas'."
}`)
	CurrentBook.AddChapter(33, `{
"1":"Ésta es la bendición que Moisés, hombre de Dios, pronunció sobre los israelitas antes de morir."
,"2":"Dijo: 'El Señor vino del Sinaí, salió para ellos de Seír, resplandeció desde la montaña de Farán, salió para ellos de los campos de Cades, rayos de luz salían de su diestra."
,"3":"Tú amas a los pueblos, todos los santos están en tu mano. Ellos se postraban a tus pies,y marchaban a tus órdenes."
,"4":"Moisés nos ha prescrito una ley, heredad de la asamblea de Jacob."
,"5":"Hubo un rey en Jesurún, cuando estuvieron juntas,las tribus de Israel."
,"6":"Viva Rubén y no se extinga, por más que sea pequeño su número."
,"7":"De Judá dijo: Escucha, Señor, la voz de Judá, y haz que se reúna con su pueblo,Defiende con tu brazo su derecho, sé su ayuda contra sus enemigos."
,"8":"De Leví dijo: Da a Leví tus urim,y tus tummim a la tribu favorita, a la que probaste en Masá, con la que reñiste,en las aguas de Meribá."
,"9":"El que dijo a su padre y a su madre: No los he visto. El que no reconoció a sus hermanos,e ignoró a sus hijos. Sí, han guardado tu palabra, han observado tu alianza."
,"10":"Enseñaron tus preceptos a Jacob,y tu ley a Israel. Hacen subir el incienso,hasta tu rostro,y ponen los holocaustos,sobre tu altar."
,"11":"Bendice sus esfuerzos, Señor, y acepta la obra de sus manos. Parte los lomos de sus adversarios, y los que le odian que no se levanten."
,"12":"De Benjamín dijo: Amado del Señor, reposa en seguridad. El altísimo le protege cada día,y él vive entre sus hombros."
,"13":"De José dijo: Sea su tierra bendita del Señor,con los rocíos del cielo en lo alto, y abajo con las aguas del abismo,"
,"14":"con lo mejor que hace crecer el sol, con los frutos que hace brotar la luna,"
,"15":"con las primicias de las viejas montañas, con lo mejor de los collados eternos,"
,"16":"con lo mejor de la tierra,y su abundancia, gracioso don del que se apareció en la zarza; descienda todo esto,sobre la cabeza de José, el escogido entre sus hermanos."
,"17":"Primogénito del toro, a él la gloria; sus cuernos son cuernos de búfalo, con los que hiere a los pueblos,hasta los últimos confines de la tierra. Tales son las miríadas de Efraín, las miríadas de Manasés."
,"18":"De Zabulón dijo: ¡Suerte, Zabulón, en tus salidas, y tú, Isacar, en tus tiendas!"
,"19":"Invitarán a los pueblos,a subir a la montaña,para ofrecer sacrificios legítimos; gozarán de la riqueza de los mares,y de los tesoros escondidos,en las playas."
,"20":"De Gad dijo: ¡Bendito el que ensanchó a Gad!,Reposa como leona, desgarra brazo, rostro y cabeza."
,"21":"Gad escogió la mejor parte, la tierra reservada al capitán; puso en práctica la justicia del Señor,y sus decisiones sobre Israel."
,"22":"De Dan dijo: Dan, cachorro de león, que salta de Basán."
,"23":"De Neftalí dijo: Neftalí, colmado de favores, lleno de la bendición del Señor, el mar y el mediodía,son sus dominios."
,"24":"De Aser dijo: ¡Bendito sea Aser,entre todos los hijos de Jacob!,¡Sea privilegiado entre sus hermanos, en el aceite bañe sus pies!"
,"25":"¡De hierro y bronce,sean tus cerrojos, y la seguridad te acompañe,toda la vida!"
,"26":"No hay igual al Dios de Jesurún; cabalga sobre los cielos,para venir en tu ayuda,y avanza majestuoso sobre las nubes."
,"27":"El Dios de otro tiempo,es tu refugio, y tu sostén sus brazos eternos. Expulsa delante de ti al enemigo, y a ti te dice: Destrúyelo."
,"28":"Israel vive en seguridad, la fuente de Jacob vive apartada,en una tierra de trigo y mosto, que el cielo mismo riega,con su rocío."
,"29":"¡Dichoso tú, Israel!,¿Quién como tú, pueblo vencedor?,Dios es el escudo que te protege, la espada en marcha,que te conduce al triunfo. Te adularán tus enemigos,para corromperte, pero tú aplastarás su orgullo'."
}`)
	CurrentBook.AddChapter(34, `{
"1":"Moisés subió de los llanos de Moab al monte Nebo, a la cima del Pisga, enfrente de Jericó. Y el Señor le mostró toda la tierra: desde Galaad hasta Dan,"
,"2":"todo Neftalí, la tierra de Efraín y Manasés, toda la tierra de Judá hasta el mar Mediterráneo,"
,"3":"el Negueb, el distrito del valle de Jericó, la ciudad de las palmeras, hasta Soar."
,"4":"Y le dijo: 'Ésta es la tierra que yo juré a Abrahán, Isaac y Jacob en estos términos: Se la daré a tu descendencia. Te la hago ver con tus ojos, pero no entrarás en ella'."
,"5":"Moisés, siervo de Dios, murió allí, en la tierra de Moab, como lo había dispuesto el Señor."
,"6":"El Señor lo enterró en el valle, en la tierra de Moab, enfrente de Bet Fegor, y nadie hasta hoy conoce su tumba."
,"7":"Moisés tenía ciento veinte años cuando murió. No se habían apagado sus ojos ni se había debilitado su vigor."
,"8":"Los israelitas lloraron a Moisés treinta días en los llanos de Moab, cumpliéndose así los días del llanto por el luto de Moisés."
,"9":"Josué, hijo de Nun, estaba lleno del espíritu de sabiduría, porque Moisés le había impuesto las manos. A él obedecieron los israelitas, como lo había ordenado Moisés."
,"10":"No ha vuelto a aparecer en Israel un profeta como Moisés, con el cual el Señor trataba cara a cara;"
,"11":"ni por los milagros y prodigios que el Señor le mandó hacer en Egipto contra el Faraón, sus funcionarios y todo su territorio,"
,"12":"ni por su mano poderosa y las grandes hazañas que realizó a los ojos de todo Israel."
}`)

}
func ES_LSB_LoadVPEXChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Éstos son los nombres de los israelitas que bajaron a Egipto con Jacob, cada uno con su familia."
,"2":"Rubén, Simeón, Leví, Judá,"
,"3":"Isacar, Zabulón y Benjamín,"
,"4":"Dan y Neftalí, Gad y Aser."
,"5":"Todas las personas nacidas de Jacob fueron setenta. José estaba ya en Egipto."
,"6":"Murió José, así como sus hermanos y toda aquella generación."
,"7":"Los israelitas, muy fecundos, se multiplicaron sobremanera, aumentando progresivamente y llegando a ser tan numerosos que llenaron toda aquella región."
,"8":"Surgió en Egipto un nuevo rey que no había conocido a José, y dijo a su pueblo:"
,"9":"'El pueblo israelita es más numeroso y potente que nosotros."
,"10":"Obremos cautamente con él para que no siga multiplicándose, no vaya a suceder que venga una guerra, se unan con nuestros enemigos, luchen contra nosotros y logren salir del país'."
,"11":"Pusieron al frente de ellos capataces que los oprimiesen con trabajos forzados en la edificación de Pitón y Rameses, ciudades almacenes del Faraón."
,"12":"Pero cuanto más los oprimían, más se multiplicaban y crecían; los egipcios llegaron a odiar a los israelitas."
,"13":"Los redujeron a la condición de esclavos, tratándolos duramente"
,"14":"y amargando su vida con trabajos forzados: en la fabricación de mortero y ladrillos y en las diversas faenas del campo, trabajos a los que los sometían con dureza."
,"15":"El rey de Egipto dijo a Sifrá y Fuá, parteras de las hebreas:"
,"16":"'Cuando asistáis en un parto a las hebreas, mirad el sexo; si es niño, matadlo; si es niña, dejadla vivir'."
,"17":"Pero las parteras temieron a Dios y no hicieron lo que les había mandado el rey de Egipto, sino que dejaban vivir también a los niños."
,"18":"Entonces el rey de Egipto mandó llamar a las parteras y les dijo: '¿Por qué habéis obrado así y habéis dejado vivir a los niños?'."
,"19":"Las parteras respondieron al Faraón: 'Las mujeres hebreas no son como las egipcias; son robustas, y antes que la partera llegue, ya han dado a luz'."
,"20":"Dios favoreció a las parteras, y el pueblo siguió multiplicándose, llegando a ser muy poderoso."
,"21":"Por haber temido a Dios las parteras, él bendijo sus casas."
,"22":"Entonces el Faraón dio esta orden a todo el pueblo: 'Echad al río a todo varón que nazca, pero dejad vivir a las niñas'."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Un hombre de la casa de Leví se casó con la hija de otro levita."
,"2":"La mujer concibió y dio a luz un hijo, y al ver que era muy hermoso, lo tuvo escondido por espacio de tres meses."
,"3":"Como ya no podía ocultarlo más, tomó una cestita de papiro, la calafateó con betún y pez, puso en ella al niño y la dejó entre los juncos de la orilla del río."
,"4":"La hermana del pequeño se quedó a poca distancia para ver lo que pasaba."
,"5":"La hija del Faraón bajó a bañarse al río mientras sus doncellas paseaban por la orilla. Al ver la cesta en medio de los juncos, mandó a una de sus doncellas a recogerla."
,"6":"La abrió y vio al niño, que estaba llorando. Compadecida de él, dijo: 'Éste es un hijo de los hebreos'."
,"7":"La hermana del pequeño dijo a la hija del Faraón: '¿Quieres que vaya a buscarte, entre los hebreos, una nodriza que te críe este niño?'."
,"8":"La hija del Faraón dijo: 'Anda'. Y la joven fue a llamar a la madre del niño. "
,"9":"La hija del Faraón le dijo: 'Toma este niño y críamelo; yo te lo pagaré'. La mujer tomó al niño y lo crió."
,"10":"Cuando se hizo grandecito se lo llevó a la hija del Faraón, que lo adoptó como hijo y le puso el nombre de Moisés, diciendo: 'Lo he sacado de las aguas'."
,"11":"Por aquellos días, Moisés, ya mayor, fue donde estaban sus hermanos. Vio sus duros trabajos y observó cómo un egipcio maltrataba a uno de sus hermanos, a un hebreo."
,"12":"Miró a su alrededor, vio que no había nadie, mató al egipcio y lo enterró entre la arena."
,"13":"Salió también al día siguiente. Vio a dos hebreos riñendo, y dijo al agresor: '¿Por qué golpeas a tu prójimo?'."
,"14":"Él respondió: '¿Quién te ha constituido jefe y juez sobre nosotros? ¿Piensas matarme como mataste al egipcio?'. Moisés temió y dijo: 'La cosa se sabe'."
,"15":"El Faraón se había también enterado de lo sucedido y trataba de matar a Moisés. Moisés huyó del Faraón y se detuvo en la tierra de Madián, sentándose junto a un pozo. "
,"16":"El sacerdote de Madián tenía siete hijas. Vinieron éstas a sacar agua, y cuando estaban llenando los abrevaderos para dar de beber al rebaño de su padre,"
,"17":"llegaron unos pastores y las echaron de allí. Entonces Moisés se levantó, salió en defensa de las jóvenes y abrevó su rebaño."
,"18":"Al volver a casa, Ragüel, su padre, les preguntó: '¿Cómo volvéis hoy tan pronto?'."
,"19":"Respondieron: 'Un egipcio nos defendió de los pastores, y hasta él mismo se puso a sacar agua y abrevó el rebaño'."
,"20":"Él les dijo: '¿Dónde está? ¿Por qué habéis dejado allí a ese hombre? Llamadle para que coma algo'."
,"21":"Moisés aceptó quedarse a vivir en casa de aquel hombre, que le dio a su hija Séfora por mujer."
,"22":"Ésta dio a luz un hijo, a quien él puso por nombre Guersón, pues se dijo: 'Yo soy un emigrante en tierra extranjera'."
,"23":"Entretanto, y después de mucho tiempo, murió el rey de Egipto. Los israelitas, que seguían gimiendo bajo la dura esclavitud, clamaron, y su clamor, provocado por la esclavitud, subió hasta Dios."
,"24":"Dios oyó su gemido y se acordó de su pacto con Abrahán, Isaac y Jacob."
,"25":"Dios miró a los israelitas y los atendió."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Moisés era el pastor del ganado de Jetró, su suegro, sacerdote de Madián. Llevó el ganado más allá del desierto y llegó al monte de Dios, el Horeb."
,"2":"Allí se le apareció el ángel del Señor en llama de fuego, en medio de una zarza. Miró, y vio que la zarza ardía sin consumirse."
,"3":"Moisés se dijo: 'Voy a acercarme a ver esta gran visión; por qué la zarza no se consume'. "
,"4":"El Señor vio que se acercaba para mirar y lo llamó desde la zarza: '¡Moisés! ¡Moisés!'. Y él respondió: 'Aquí estoy'."
,"5":"Dios le dijo: 'No te acerques. Descálzate, porque el lugar en que estás es tierra santa'."
,"6":"Y añadió: 'Yo soy el Dios de tu padre, el Dios de Abrahán, el Dios de Isaac y el Dios de Jacob'. Moisés se tapó la cara, porque temía ver a Dios."
,"7":"El Señor continuó: 'He visto la opresión de mi pueblo en Egipto, he oído el clamor que le arranca su opresión y conozco sus angustias."
,"8":"Voy a bajar a liberarlo de la mano de los egipcios, sacarlo de aquella tierra y llevarlo a una tierra buena y espaciosa, a una tierra que mana leche y miel, a la tierra del cananeo, del hitita, del amorreo, del fereceo, del heveo y del jebuseo."
,"9":"El clamor de los israelitas ha llegado hasta mí. He visto también la opresión con que los egipcios los tiranizan."
,"10":"Anda; yo te envío al Faraón para que saques de Egipto a mi pueblo, a los israelitas."
,"11":"Moisés dijo al Señor: '¿Quién soy yo para ir al Faraón y sacar de Egipto a los israelitas?'."
,"12":"Dios le dijo: 'Yo estaré contigo, y ésta será la señal de que yo te he enviado: cuando hayas sacado al pueblo de Egipto, adoraréis a Dios sobre este monte'."
,"13":"Moisés dijo a Dios: 'Bien, yo me presentaré a los israelitas y les diré: El Dios de nuestros padres me ha enviado a vosotros. Pero si ellos me preguntan: ¿Cuál es su nombre?, ¿qué les responderé?'."
,"14":"Dios dijo a Moisés: 'Yo soy el que soy. Así responderás a los israelitas: Yo soy me ha enviado a vosotros'."
,"15":"Y continuó: 'Dirás así a los israelitas: El Señor, Dios de vuestros padres, el Dios de Abrahán, el Dios de Isaac, el Dios de Jacob, me ha enviado a vosotros. Éste es mi nombre para siempre, éste mi recuerdo por todos los siglos'."
,"16":"'Anda, reúne a los ancianos de Israel y diles: El Señor, Dios de vuestros padres, el Dios de Abrahán, de Isaac y de Jacob, se me ha aparecido y me ha dicho: Os he visitado y he visto lo que se os hace en Egipto."
,"17":"He determinado sacaros de la opresión de Egipto a la tierra del cananeo, del hitita, del amorreo, del fereceo, del heveo y del jebuseo; tierra que mana leche y miel."
,"18":"Ellos escucharán tu voz. Tú con los ancianos de Israel irás al rey de Egipto y le diréis: El Señor, Dios de los hebreos, se nos ha aparecido; déjanos ir a tres días de camino por el desierto para ofrecer sacrificios al Señor nuestro Dios."
,"19":"Yo sé bien que el rey de Egipto no os dejará ir a no ser a la fuerza."
,"20":"Pero yo extenderé mi mano y castigaré a Egipto con todos mis prodigios, que haré en medio de ellos; después de lo cual, os dejará salir."
,"21":"Yo haré que este pueblo halle gracia a los ojos de los egipcios para que, cuando salgáis, no lo hagáis con las manos vacías,"
,"22":"sino que cada una de las mujeres pedirá a su vecina y a su coinquilina objetos de plata y oro y vestidos que pondréis a vuestros hijos y a vuestras hijas; y despojaréis así a los egipcios'."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Moisés respondió: 'No me creerán ni escucharán mi voz, sino que dirán: No se te ha aparecido el Señor'."
,"2":"El Señor le dijo: '¿Qué tienes en tu mano?'. Él respondió: 'Un bastón'."
,"3":"El Señor le dijo: 'Tíralo a tierra'. Él lo tiró y se convirtió en serpiente. Al verlo Moisés huyó."
,"4":"El Señor dijo a Moisés: 'Alarga tu mano y tómala por la cola'. Él alargó su mano, la tomó y volvió a ser bastón en su mano."
,"5":"'Esto es para que crean que se te ha aparecido el Señor, Dios de tus padres, Dios de Abrahán, de Isaac y de Jacob'."
,"6":"El Señor prosiguió: 'Mete tu mano en el pecho'. Él la metió y, cuando la sacó, estaba cubierta de lepra, color de nieve."
,"7":"Luego le dijo: 'Vuelve a meter tu mano en el pecho'. Volvió a meterla y, al sacarla, estaba de nuevo normal."
,"8":"'Si no te creen ni te hacen caso por el primer prodigio, te creerán por el segundo;"
,"9":"y si no te creen ni te hacen caso por ninguno de los dos, toma agua del río y derrámala sobre el suelo; el agua así derramada en el suelo se volverá sangre'."
,"10":"Moisés dijo al Señor: 'Señor, yo no tengo facilidad de palabra, ni anteriormente, ni desde que hablas a tu siervo; soy tardo en el hablar y torpe de lengua'."
,"11":"Y el Señor le dijo: '¿Quién ha dado al hombre la boca y quién le hace sordo y mudo, vidente y ciego? ¿No soy acaso yo, el Señor?"
,"12":"Anda, yo estaré en tu boca y te enseñaré lo que has de decir'."
,"13":"Y él dijo: 'Ay, Señor; envía al que quieras enviar'."
,"14":"El Señor se encendió en cólera contra Moisés y dijo: '¿No está Aarón, el levita, tu hermano? Sé que él tiene facilidad de palabra. Mira, va a salir a tu encuentro, y al verte se alegrará."
,"15":"Tú le hablarás a él y pondrás las palabras en su boca; yo estaré en tu boca y en la suya y os enseñaré lo que habéis de hacer."
,"16":"Él hablará por ti al pueblo; él será para ti la boca, y tú serás para él un dios."
,"17":"Toma el bastón con el que realizarás los prodigios'."
,"18":"Moisés volvió a casa de Jetró, su suegro, y le dijo: 'Déjame marchar y volver a mis hermanos, que están en Egipto, para ver si todavía están vivos'. Jetró le dijo: 'Vete en paz'."
,"19":"El Señor había dicho a Moisés en Madián: 'Anda, vuelve a Egipto, porque han muerto todos los que querían matarte'."
,"20":"Moisés tomó a su mujer y a sus hijos, los montó en un asno y se fue a Egipto, llevando en su mano el bastón de Dios."
,"21":"El Señor le dijo: 'En el camino hacia Egipto recuerda los prodigios que he puesto en tu mano y que tienes que hacer delante del Faraón. Yo endureceré su corazón de modo que no dejará salir al pueblo."
,"22":"Tú dirás al Faraón: Esto dice el Señor: Israel es mi hijo primogénito."
,"23":"Te digo que dejes salir a mi hijo para que me sirva; si no le dejas salir, yo mataré a tu hijo primogénito'."
,"24":"Por el camino, donde Moisés pasaba la noche, el Señor se le presentó para darle muerte."
,"25":"Entonces Séfora, tomando un pedernal afilado, cortó el prepucio de su hijo y lo arrojó a sus pies diciendo: 'Esposo de sangre eres para mí'."
,"26":"Y el Señor le dejó, al decir ella 'Esposo de sangre', en razón de la circuncisión."
,"27":"El Señor dijo a Aarón: 'Sal al encuentro de Moisés en el desierto'. Fue y, cuando lo encontró en el monte de Dios, lo besó."
,"28":"Moisés contó a Aarón todo lo que le había dicho el Señor al encomendarle la misión y todos los prodigios que le había ordenado."
,"29":"Moisés y Aarón partieron y reunieron a todos los ancianos de los israelitas."
,"30":"Aarón les refirió todo lo que el Señor había dicho a Moisés e hizo prodigios en presencia del pueblo."
,"31":"El pueblo creyó, y comprendiendo que el Señor había visitado a los israelitas y había visto su opresión, se postraron y adoraron."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Después de esto, Moisés y Aarón se presentaron ante el Faraón y le dijeron: 'Esto dice el Señor, Dios de Israel: Deja ir a mi pueblo para que celebre una fiesta en el desierto'."
,"2":"El Faraón dijo: '¿Quién es el Señor para que yo obedezca su voz y deje ir a Israel? No conozco al Señor y no dejaré ir a Israel'."
,"3":"Ellos le dijeron: 'El Dios de los hebreos se nos ha aparecido. Deja que vayamos al desierto, a tres jornadas de camino, para ofrecer sacrificios al Señor, nuestro Dios, no sea que nos castigue con peste o espada'."
,"4":"Pero el rey de Egipto les dijo: '¿Por qué, Moisés y Aarón, revolucionáis al pueblo en sus trabajos? Id a vuestras obligaciones'."
,"5":"Y añadió: 'Ahora que el pueblo de la tierra es numeroso, ¿vosotros queréis que dejen su trabajo?'."
,"6":"Aquel mismo día el Faraón dio esta orden a los capataces e inspectores del pueblo:"
,"7":"'No volváis a darle paja al pueblo para fabricar los ladrillos, como hasta ahora; que vayan ellos mismos a recogerla."
,"8":"Más aún, exigidles la misma cantidad de ladrillos que antes, sin perdonarles ni uno, pues son unos holgazanes. Por eso dicen: Déjanos ir a ofrecer sacrificios a nuestro Dios."
,"9":"Cargadlos de trabajo para que estén ocupados y no den oídos a esos embustes'."
,"10":"Los capataces e inspectores se presentaron al pueblo y le dijeron: 'El Faraón dice así: En adelante no os daré paja."
,"11":"Id vosotros a recogerla donde la encontréis. Pero no se os disminuirá en nada la tarea impuesta'."
,"12":"El pueblo, entonces, se dispersó por todo Egipto en busca de paja."
,"13":"Los capataces apretaban diciendo: 'Haced vuestro trabajo, según la tarea diaria, como cuando se os daba la paja'."
,"14":"Los inspectores israelitas, que habían sido puestos sobre ellos por los capataces del Faraón, fueron castigados; les decían: '¿Por qué ni ayer ni hoy habéis completado la tarea de ladrillos como antes?'. "
,"15":"Los inspectores de los israelitas fueron a quejarse al Faraón, y le dijeron: '¿Por qué tratas así a tus siervos?"
,"16":"No se da paja a tus siervos y, con todo, se nos dice: Haced los ladrillos. Tus siervos son azotados, y la culpa es de tu pueblo'."
,"17":"El Faraón replicó: 'Sois unos holgazanes, auténticos holgazanes, y por eso decís: Vayamos y ofrezcamos sacrificios al Señor."
,"18":"Ahora id a trabajar. No se os dará paja y habéis de hacer la misma cantidad de ladrillos'."
,"19":"Los inspectores de los israelitas se vieron en un aprieto porque se les dijo: 'No se disminuirá nada de vuestra tarea diaria de ladrillos'."
,"20":"Al salir de la casa del Faraón se encontraron con Moisés y Aarón, que les esperaban,"
,"21":"y les dijeron: 'Que el Señor os vea y os juzgue, pues sois la causa de que el Faraón y sus siervos nos miren mal, y habéis puesto la espada en sus manos para que nos maten'."
,"22":"Moisés se dirigió al Señor diciendo: 'Señor, ¿por qué maltratas a este pueblo? ¿Por qué me has enviado?"
,"23":"¿Por qué desde que fui al Faraón para hablarle en tu nombre trata él tan mal a este pueblo, y tú no haces nada para liberarlo?'."
}`)
	CurrentBook.AddChapter(6, `{
"1":"El Señor dijo a Moisés: 'Ahora vas a ver lo que voy a hacer al Faraón: por la fuerza los dejará marchar; por la fuerza, él mismo los echará de su país'."
,"2":"Dios dijo a Moisés: 'Yo soy el Señor;"
,"3":"yo me aparecí a Abrahán, a Isaac y Jacob, como todopoderoso, pero no me di a conocer a ellos bajo mi nombre de Señor."
,"4":"Hice con ellos mi pacto: darles la tierra de Canaán, la tierra de sus emigraciones, donde vivieron como extranjeros."
,"5":"He oído ahora el clamor de los israelitas, a quienes los egipcios tienen esclavizados, y me he acordado de mi pacto."
,"6":"Di a los israelitas: Yo soy el Señor; yo os libertaré de la opresión de los egipcios; os libraré de su esclavitud y os rescataré con gran poder y haciendo justicia."
,"7":"Yo os haré mi pueblo, seré vuestro Dios y vosotros conoceréis que yo soy el Señor, vuestro Dios, el que os libró de la esclavitud egipcia."
,"8":"Os llevaré al país que juré dar a Abrahán, a Isaac y a Jacob, y os lo daré en posesión. Yo, el Señor'."
,"9":"Así habló Moisés a los israelitas, pero ellos no lo escucharon por el desaliento que les causaba su dura esclavitud."
,"10":"El Señor dijo a Moisés:"
,"11":"'Anda, di al Faraón, rey de Egipto, que deje salir de su país a los israelitas'."
,"12":"Moisés le respondió: 'Los israelitas no me han escuchado; ¿cómo va a escucharme el Faraón, a mí que soy tan torpe de palabra?'."
,"13":"El Señor habló a Moisés y Aarón y les dio órdenes para los israelitas y para el Faraón, rey de Egipto, a fin de sacar de Egipto a los israelitas."
,"14":"Éstas son sus cabezas de familia. Hijos de Rubén, primogénito de Israel: Henoc, Falú, Jesrón y Carmí. Tales son las familias de Rubén."
,"15":"Hijos de Simeón: Yemuel, Yamín, Ohad, Yaquín, Sójar y Saúl, hijos de la cananea. Tales son las familias de Simeón."
,"16":"Éstos son los nombres de los hijos de Leví con sus familias: Guersón, Quehat y Merarí. Leví vivió ciento treinta y siete años."
,"17":"Hijos de Guersón: Libní y Semeí con sus familias."
,"18":"Hijos de Quehat: Amrán, Yishar, Hebrón y Uziel. Quehat vivió ciento treinta y tres años."
,"19":"Hijos de Merarí: Majlí y Musí. Tales son las familias de los levitas según sus generaciones."
,"20":"Amrán se casó con Yakébet, su tía, de la que tuvo a Aarón y a Moisés. Amrán vivió ciento treinta y siete años."
,"21":"Hijos de Yishar: Coré, Néfeg y Zicrí."
,"22":"Los de Uziel: Misael, Elsafán y Sitrí."
,"23":"Aarón se casó con Isabel, hija de Aminadab, hermana de Najsón, de la que tuvo a Nadab, Abihú, Eleazar e Itamar."
,"24":"Hijos de Coré: Asir, Elcaná y Abiasaf. Tales son las familias de los coreítas."
,"25":"Eleazar, hijo de Aarón, se casó con una de las hijas de Futiel, de la que tuvo a Fineés. Tales son los jefes de las familias de los levitas según sus diversas ramas."
,"26":"Éstos son aquel Aarón y aquel Moisés a quienes dijo el Señor: 'Sacad de Egipto a los israelitas por escuadras'; "
,"27":"ellos, los que hablaron al Faraón, rey de Egipto, para sacar de Egipto a los israelitas: Moisés y Aarón."
,"28":"Cuando el Señor habló a Moisés en Egipto,"
,"29":"le dijo: 'Yo soy el Señor. Di al Faraón, rey de Egipto, todo lo que voy a decirte'."
,"30":"Y Moisés dijo ante el Señor: 'Yo soy torpe de palabra, ¿cómo me va a escuchar el Faraón?'."
}`)
	CurrentBook.AddChapter(7, `{
"1":"El Señor dijo a Moisés: 'Mira, yo te hago como un dios para el Faraón; y tu hermano Aarón será tu profeta."
,"2":"Tú dirás lo que yo te ordene, y Aarón, tu hermano, hablará al Faraón para que deje salir de su país a los israelitas."
,"3":"Pero yo endureceré el corazón del Faraón y multiplicaré en Egipto mis señales y prodigios."
,"4":"El Faraón no os escuchará. Pero yo pondré mi mano sobre Egipto y sacaré de aquí a mis ejércitos, a mi pueblo, los israelitas, haciendo justicia."
,"5":"Y los egipcios conocerán que yo soy el Señor, cuando haya extendido mi mano contra Egipto y haya sacado a los israelitas de en medio de ellos'."
,"6":"Moisés y Aarón hicieron exactamente como el Señor les había mandado."
,"7":"Moisés tenía ochenta años y Aarón ochenta y tres cuando hablaron al Faraón."
,"8":"El Señor dijo a Moisés y Aarón:"
,"9":"'Cuando os hable el Faraón y os diga: Haced algún prodigio, tú dirás a Aarón: Toma tu bastón y échalo delante del Faraón. El bastón se convertirá en serpiente'."
,"10":"Moisés y Aarón fueron ante el Faraón e hicieron como el Señor les había ordenado. Aarón tiró su bastón delante del Faraón y de sus siervos, y se convirtió en serpiente."
,"11":"El Faraón llamó a los sabios y encantadores, y ellos, los magos de Egipto, hicieron otro tanto con sus encantamientos."
,"12":"Tiró cada uno su bastón, y se convirtieron en serpientes; pero el bastón de Aarón se tragó a los otros bastones."
,"13":"El corazón del Faraón se endureció y no les escuchó, tal y como había dicho el Señor."
,"14":"El Señor dijo a Moisés: 'El corazón del Faraón se ha endurecido y se niega a dejar salir al pueblo."
,"15":"Preséntate al Faraón de mañana; cuando salga del baño, te haces el encontradizo con él a la orilla del río teniendo en la mano el bastón que se convirtió en serpiente,"
,"16":"y le dirás: El Señor, Dios de los hebreos, me ha enviado para decirte: Deja ir a mi pueblo para que me sirva en el desierto, pero hasta ahora no has querido escuchar. Ahora dice el Señor:"
,"17":"Para que sepas que soy yo el Señor, voy a golpear con el bastón que tengo en la mano las aguas del río y se convertirán en sangre."
,"18":"Los peces del río morirán, el río apestará y los egipcios no podrán beber más su agua'."
,"19":"El Señor dijo a Moisés: 'Di a Aarón: Toma tu bastón y extiende tu mano sobre las aguas de los egipcios: ríos, canales, estanques y depósitos de aguas, y se convertirán en sangre. Habrá sangre en todo el país de Egipto, hasta en las vasijas, tanto en las de madera como en las de piedra'."
,"20":"Moisés y Aarón hicieron como el Señor había ordenado; Aarón levantó el bastón, golpeó las aguas del río a la vista del Faraón y sus siervos, y las aguas se convirtieron en sangre."
,"21":"Los peces del río murieron, el río apestaba y los egipcios no podían beber de él, y hubo sangre en todo Egipto."
,"22":"Pero los magos de Egipto hicieron lo mismo con sus encantamientos. Y el corazón del Faraón se endureció y no los escuchó, como había dicho el Señor."
,"23":"El Faraón se volvió y entró en su casa sin hacer caso."
,"24":"Todos los egipcios excavaron en las orillas del río en busca de agua potable, pues no podían beber las del río."
,"25":"Y así transcurrieron siete días desde que el Señor golpeó el río."
,"26":"El Señor dijo a Moisés: 'Preséntate al Faraón y dile: Esto dice el Señor: Deja salir a mi pueblo para que me sirva."
,"27":"Si no los dejas salir, infestaré de ranas a toda tu tierra."
,"28":"El río bullirá de ranas, que subirán y penetrarán en tu casa, en tu dormitorio, en tu lecho, en la casa de tus servidores y de tu pueblo, en tus hornos y en tus artesas."
,"29":"Contra ti, contra tu pueblo y contra todos tus servidores subirán las ranas'."
}`)
	CurrentBook.AddChapter(8, `{
"1":"El Señor dijo a Moisés: 'Di a Aarón: Extiende tu mano con tu bastón sobre los ríos, canales y estanques y haz subir las ranas por todo el territorio egipcio'."
,"2":"Aarón extendió su mano sobre las aguas de Egipto, y las ranas subieron y cubrieron todo Egipto."
,"3":"Pero los magos hicieron lo mismo con sus encantamientos. Hicieron subir las ranas sobre todo Egipto."
,"4":"El Faraón llamó a Moisés y a Aarón y les dijo: 'Rogad al Señor que aleje las ranas de mí y de mi pueblo, y yo dejaré ir al pueblo para que ofrezca sacrificios al Señor'."
,"5":"Moisés dijo al Faraón: 'Dime cuándo he de rogar por ti, por tus servidores y por todo tu pueblo para que el Señor aleje de ti y de tu pueblo las ranas y se queden sólo en el río'."
,"6":"Él respondió: 'Mañana'. Y Moisés añadió: 'Así se hará, para que sepas que no hay otro como el Señor, nuestro Dios."
,"7":"Las ranas se alejarán de ti y de tus casas, de tus servidores y de todo el pueblo; solamente quedarán en el río'."
,"8":"Moisés y Aarón salieron de la presencia del Faraón. Moisés suplicó al Señor en razón de la promesa hecha al Faraón respecto a las ranas."
,"9":"El Señor hizo según la palabra de Moisés: las ranas murieron en las casas, en los establos y en los campos."
,"10":"Las reunieron en grandes montones, y la tierra quedó apestada."
,"11":"Pero el Faraón, viendo que se le daba respiro, endureció su corazón y no les escuchó, como había dicho el Señor."
,"12":"El Señor dijo a Moisés: 'Di a Aarón: Extiende tu bastón y golpea el polvo de la tierra para que se convierta en mosquitos en todo el país de Egipto'."
,"13":"Así lo hicieron. Aarón extendió su mano con su bastón, golpeó el polvo de la tierra, y enjambres de mosquitos se echaron sobre hombres y animales; todo el polvo de la tierra se convirtió en mosquitos en todo Egipto."
,"14":"Los magos intentaron hacer lo mismo con sus encantamientos, pero no lo lograron. Y los mosquitos se cebaron en los hombres y en los animales."
,"15":"Los magos dijeron al Faraón: '¡Aquí está el dedo de Dios!'. Pero el corazón del Faraón se endureció y no les escuchó, como había dicho el Señor."
,"16":"El Señor dijo a Moisés: 'Levántate temprano mañana; preséntate al Faraón a la hora de ir al baño, y dile: Esto dice el Señor: Deja salir a mi pueblo para que me sirva."
,"17":"Si no le dejas salir, yo enviaré sobre ti y tus servidores, sobre tu pueblo y sobre tus casas, tábanos que llenarán las casas de los egipcios y el suelo que pisan."
,"18":"Pero exceptuaré la región de Gosen, donde habita mi pueblo; allí no habrá tábanos, para que sepas que yo, el Señor, estoy en medio del país."
,"19":"Haré distinción entre mi pueblo y el tuyo. Mañana será este prodigio'."
,"20":"El Señor lo hizo así, y enjambres de tábanos invadieron la casa del Faraón y las de sus servidores; en todo Egipto la tierra quedó infestada de tábanos."
,"21":"El Faraón llamó a Moisés y a Aarón y les dijo: 'Id y ofreced sacrificios a vuestro Dios en este país'."
,"22":"Moisés dijo: 'No puede ser, pues ofreceríamos al Señor, nuestro Dios, sacrificios que los egipcios detestan. Si ofrecemos ante sus ojos sacrificios que ellos detestan, nos apedrearán."
,"23":"Tenemos que ir por el desierto tres jornadas de camino para ofrecer sacrificios al Señor, nuestro Dios, según él nos diga'."
,"24":"El Faraón dijo: 'Bien, os dejaré ir al desierto a ofrecer sacrificios a vuestro Dios, pero con la condición de que no os alejéis demasiado. ¡Rezad por mí!'."
,"25":"Moisés dijo: 'Al salir de tu casa rezaré por ti al Señor, y mañana se alejarán los tábanos de ti, de tus servidores y de tu pueblo; pero que el Faraón no nos engañe una vez más y deje ir al pueblo para ofrecer sacrificios al Señor'."
,"26":"Moisés salió de la presencia del Faraón y rezó al Señor."
,"27":"El Señor hizo según la palabra de Moisés, y se alejaron los tábanos del Faraón, de sus servidores y de su pueblo. No quedó ni siquiera uno."
,"28":"Pero el Faraón endureció su corazón también esta vez y no dejó salir al pueblo."
}`)
	CurrentBook.AddChapter(9, `{
"1":"El Señor dijo a Moisés: 'Preséntate al Faraón y dile: Esto dice el Señor, Dios de los hebreos: Deja salir a mi pueblo para que me sirva."
,"2":"Porque si no le dejas salir y te empeñas en retenerlo,"
,"3":"la mano del Señor caerá sobre tu ganado, que anda por el campo: una peste gravísima sobre caballos, asnos, camellos, bueyes y ovejas."
,"4":"Pero el Señor hará distinción entre el ganado de los israelitas y el de los egipcios; de todo lo que pertenece a los israelitas nada perecerá'."
,"5":"El Señor fijó un término diciendo: 'Mañana hará el Señor esto en el país'."
,"6":"Al día siguiente lo llevó a cabo: todo el ganado de los egipcios murió, pero el de los israelitas no murió ni uno siquiera."
,"7":"El Faraón mandó a ver, y del ganado de los israelitas no había muerto ni uno solo. Pero el corazón del Faraón siguió endurecido y no dejó salir al pueblo."
,"8":"El Señor dijo a Moisés y a Aarón: 'Tomad un puñado de ceniza de horno y que Moisés la tire al aire en presencia del Faraón. "
,"9":"Se convertirá en polvo menudo en todo el país de Egipto y producirá úlceras y tumores en hombres y animales'."
,"10":"Tomaron ceniza de horno y, presentándose ante el Faraón, Moisés la esparció por el aire y produjo úlceras y tumores en hombres y animales."
,"11":"Los magos no pudieron continuar delante de Moisés debido a las úlceras que aparecieron en ellos, igual que en todos los egipcios."
,"12":"Pero el Señor endureció el corazón del Faraón, que no dejó salir al pueblo, como había dicho el Señor."
,"13":"El Señor dijo a Moisés: 'Levántate mañana temprano, preséntate al Faraón y dile: Esto dice el Señor, Dios de los hebreos: Deja ir a mi pueblo para que me sirva."
,"14":"Esta vez voy a desencadenar todas mis plagas contra ti y contra tus servidores y contra tu pueblo, para que sepas que no hay otro como yo en toda la tierra."
,"15":"Porque si yo hubiera extendido mi mano hiriéndote a ti y a tu pueblo con la peste, habríais desaparecido de la tierra."
,"16":"Pero precisamente por esto te he conservado la vida, para demostrarte mi poder y para que mi nombre sea publicado por toda la tierra."
,"17":"¿Tú te atreves a levantarte contra mi pueblo para no dejarle partir?"
,"18":"Pues bien, yo haré llover mañana, a esta hora, una granizada tan fuerte como no la ha habido en Egipto desde el día en que fue fundado hasta el presente."
,"19":"Manda poner a salvo tu ganado y cuanto tienes en el campo. Todo hombre y todo animal que se encuentre en el campo y no esté cobijado bajo techo, será alcanzado por la granizada y morirá'."
,"20":"Los servidores del Faraón que temieron la palabra del Señor mandaron refugiar en las casas a siervos y ganados."
,"21":"Pero los que no hicieron caso de la palabra del Señor dejaron sus siervos y ganados en el campo."
,"22":"El Señor dijo a Moisés: 'Extiende tu mano hacia el cielo para que caiga granizo en todo el país sobre hombres y animales y sobre toda la hierba del campo'."
,"23":"Moisés extendió su bastón hacia el cielo, y el Señor mandó truenos y granizo con fuego, que se precipitaba sobre la tierra; el Señor hizo caer granizo sobre Egipto."
,"24":"Cayeron rayos y granizo con tanta fuerza como Egipto no había visto jamás desde que se constituyó en nación."
,"25":"El granizo machacó en Egipto todo cuanto se encontraba en el campo: hombres y animales. Machacó también las hierbas y desgajó los árboles."
,"26":"Solamente en la región de Gosen, donde habitaban los israelitas, no cayó granizo."
,"27":"El Faraón mandó llamar a Moisés y Aarón y les dijo: 'Esta vez he pecado. El Señor es justo, y yo y mi pueblo, culpables."
,"28":"Rezad al Señor; cesen los truenos y el granizo; yo os dejaré partir, y ya no os quedaréis aquí'."
,"29":"Moisés respondió: 'En cuanto salga de la ciudad levantaré al Señor mis manos, cesarán los truenos y no habrá más granizo, para que sepas que la tierra es del Señor."
,"30":"Pero yo sé bien que ni tú ni tus servidores teméis todavía al Señor, Dios'."
,"31":"El lino y la cebada quedaron destrozados, pues la cebada estaba ya espigada y el lino en flor."
,"32":"En cambio, el trigo y el centeno no, por ser tardíos."
,"33":"Salió Moisés de la presencia del Faraón, fuera de la ciudad, y extendió sus manos al Señor. Los truenos y el granizo cesaron y no hubo más lluvias sobre la tierra."
,"34":"El Faraón, viendo que habían cesado la lluvia y el granizo, perseveró en su pecado, endureciendo su corazón él y sus servidores."
,"35":"El corazón del Faraón se endureció y no dejó salir a los israelitas, como el Señor había dicho por medio de Moisés."
}`)
	CurrentBook.AddChapter(10, `{
"1":"El Señor dijo a Moisés: 'Preséntate al Faraón, porque yo he endurecido su corazón y el de sus servidores para realizar en medio de ellos mis prodigios,"
,"2":"para que cuentes a tus hijos y a tus nietos cómo traté yo a los egipcios y los prodigios que hice en medio de ellos, y sepáis que yo soy el Señor'."
,"3":"Moisés y Aarón se presentaron al Faraón, y le dijeron: 'Esto dice el Señor, Dios de los hebreos: ¿Hasta cuándo te negarás a humillarte delante de mí? Deja salir a mi pueblo para que me sirva."
,"4":"Porque si no lo dejas salir, traeré mañana sobre tus tierras la langosta,"
,"5":"que cubrirá la faz de la tierra y devorará lo que quedó salvo del granizo. Devorará todo árbol que crece en vuestros campos."
,"6":"Invadirá tus casas, las de tus servidores y las de todos los egipcios, como nunca vieron tus padres, ni tus abuelos, desde que aparecieron en la tierra hasta hoy'. Moisés se retiró y salió de la casa del Faraón."
,"7":"Los servidores del Faraón le dijeron: '¿Hasta cuándo va a ser este hombre nuestra ruina? Deja marchar a esa gente para que ofrezca sacrificios al Señor, su Dios. ¿No te das todavía cuenta de que Egipto camina hacia la ruina?'."
,"8":"Hicieron venir a Moisés y Aarón ante el Faraón, que les dijo: 'Id a servir al Señor, vuestro Dios. Pero ¿quiénes sois los que habéis de ir?"
,"9":"Moisés respondió: 'Hemos de ir todos, con nuestros jóvenes y nuestros ancianos, nuestros hijos y nuestras hijas, nuestras ovejas y nuestras vacas, porque para nosotros es una fiesta del Señor'."
,"10":"Él les dijo: 'Que el Señor esté con vosotros como yo os dejo marchar a vosotros y a vuestras familias. Tenéis malas intenciones."
,"11":"Así no puede ser. Id los hombres a ofrecer sacrificios al Señor, pues eso es lo que pedisteis'. Y los echaron de la presencia del Faraón."
,"12":"El Señor dijo a Moisés: 'Extiende tu mano sobre Egipto para que venga sobre él la langosta y devore todo lo que dejó el granizo'."
,"13":"Moisés extendió su bastón sobre Egipto, y el Señor hizo soplar sobre él el viento del este todo aquel día y aquella noche. Al amanecer, el viento del este había traído la langosta,"
,"14":"que subió por todo Egipto posándose en todo su territorio en cantidad inmensa, como no la hubo antes ni la habrá después."
,"15":"Cubrió todo Egipto, que quedó oscurecido. Devoró toda la hierba de la tierra y todos los frutos de los árboles que había dejado el granizo; no quedó nada de verde ni en los árboles, ni en la hierba del campo, en todo Egipto."
,"16":"El Faraón llamó a toda prisa a Moisés y a Aarón y les dijo: 'He pecado contra el Señor, vuestro Dios, y contra vosotros."
,"17":"Perdonad por esta vez mi pecado. Rezad al Señor, vuestro Dios, para que aleje de mí esta muerte'."
,"18":"Moisés salió de la casa del Faraón y rezó al Señor."
,"19":"Y el Señor cambió el viento y le hizo soplar muy fuerte del oeste; barrió la langosta y la arrojó al mar Rojo. Ni una sola quedó en todo el territorio de Egipto."
,"20":"Pero el Señor endureció el corazón del Faraón, que no dejó salir a los israelitas."
,"21":"El Señor dijo a Moisés: 'Alza tu mano hacia el cielo para que vengan sobre Egipto tinieblas tan espesas que se las pueda palpar'."
,"22":"Moisés alzó su mano hacia el cielo, y hubo espesas tinieblas tres días y tres noches por todo Egipto."
,"23":"No se veían unos a otros; durante tres días nadie se movió de su lugar. Pero los israelitas tuvieron luz en la región donde vivían."
,"24":"El Faraón llamó a Moisés y le dijo: 'Id a servir al Señor: dejad aquí vuestras ovejas y vuestras vacas; también vuestros niños podrán ir con vosotros'."
,"25":"Moisés respondió: 'Tú mismo nos has de dar las víctimas para los sacrificios y holocaustos que ofreceremos al Señor, nuestro Dios."
,"26":"Tenemos que llevar también nuestro ganado; no ha de quedar ni una res, porque hemos de tomar de él para ofrecerlo al Señor, nuestro Dios, y no sabemos qué hemos de ofrecer al Señor hasta que lleguemos allá'."
,"27":"Pero el Señor endureció el corazón del Faraón, que no quiso dejarlos ir."
,"28":"El Faraón le dijo: 'Retírate de aquí y guárdate bien de presentarte de nuevo ante mí, porque el día que vuelvas, morirás'."
,"29":"Moisés dijo: 'Has dicho bien; no volveré a presentarme ante ti'."
}`)
	CurrentBook.AddChapter(11, `{
"1":"El Señor dijo a Moisés: 'Sólo una plaga más voy a traer sobre el Faraón y sobre Egipto; después de ella, no sólo os dejará marchar, sino que os echará de aquí."
,"2":"Por tanto, ordena al pueblo que cada uno, hombre o mujer, pida a sus amigos y a sus amigas objetos de plata y oro'."
,"3":"Y el Señor concedió al pueblo el favor de los egipcios; hasta el mismo Moisés era considerado por los servidores del Faraón y por el pueblo."
,"4":"Moisés dijo: 'Esto dice el Señor: A eso de la medianoche saldré por Egipto,"
,"5":"y morirá todo primogénito en Egipto, desde el primogénito del Faraón, que se sienta en su trono, hasta el primogénito de la esclava, que trabaja en el molino, y todo primogénito de los animales."
,"6":"En todo Egipto se oirá un clamor inmenso, como no lo hubo antes ni lo habrá después."
,"7":"Pero entre los israelitas, desde el hombre al animal, ni siquiera ladrará un perro, para que sepáis la diferencia que hace el Señor entre los egipcios y los israelitas."
,"8":"Entonces todos estos servidores tuyos vendrán a mí y se prosternarán ante mí diciéndome: Sal tú y todo el pueblo, que está a tu cargo. Después partiré yo'. Y salió irritado de la casa del Faraón."
,"9":"El Señor había dicho a Moisés: 'El Faraón no os escuchará, para que yo multiplique mis prodigios en Egipto'."
,"10":"Y Moisés y Aarón habían realizado todos estos prodigios en presencia del Faraón. Pero el Señor endureció el corazón del Faraón, que no dejó salir de su país a los israelitas."
}`)
	CurrentBook.AddChapter(12, `{
"1":"El Señor dijo a Moisés y a Aarón en Egipto:"
,"2":"'Este mes será para vosotros el principal, el primero de los meses del año."
,"3":"Decid a toda la comunidad de Israel: El día diez de este mes cada uno se procure un cordero por familia, un cordero por casa."
,"4":"Si la familia es demasiado pequeña para consumir el cordero entero, se pondrá de acuerdo con su vecino, el más próximo a su casa, según el número de personas y en razón de la porción de cordero que cada cual puede comer."
,"5":"El cordero ha de ser sin defecto, macho, de un año; podrá ser cordero o cabrito."
,"6":"Lo guardaréis hasta el día catorce de este mes; entonces todo Israel lo inmolará entre dos luces."
,"7":"Con un poco de la sangre se untarán las jambas y el dintel de las casas en que se ha de comer."
,"8":"Esa misma noche comeréis la carne asada al fuego, con panes sin levadura y hierbas amargas."
,"9":"No comeréis nada crudo ni cocido en agua; todo ha de ser asado al fuego: cabeza, patas y entrañas."
,"10":"No dejaréis nada de él para la mañana siguiente; si queda algo, lo quemáis."
,"11":"Lo comeréis así: ceñidos los lomos, calzados los pies, báculo en mano. Lo comeréis de prisa, porque es la pascua del Señor."
,"12":"Esa noche pasaré yo por el territorio de Egipto y mataré a todos los primogénitos de Egipto, tanto de los hombres como de los animales. Haré justicia de todos los dioses de Egipto. ¡Yo, el Señor!"
,"13":"La sangre servirá de señal en las casas donde estéis; al ver la sangre, pasaré de largo y no habrá entre vosotros plaga exterminadora cuando yo hiera a Egipto."
,"14":"Este día será memorable para vosotros y lo celebraréis como fiesta del Señor, como institución perpetua de generación en generación."
,"15":"Durante siete días comeréis panes sin levadura; desde el primer día quitaréis la levadura de vuestras casas, porque el que en estos días coma pan fermentado será extirpado de Israel."
,"16":"El día primero y el día séptimo tendréis asamblea santa. En ellos no haréis trabajo alguno. Solamente podréis preparar la comida que vayáis a tomar."
,"17":"Guardaréis, pues, la fiesta de los panes sin levadura, porque en ese día saqué vuestros ejércitos de Egipto. Guardaréis ese día de generación en generación como institución perpetua."
,"18":"El día catorce del primer mes, por la tarde, comeréis los panes sin levadura hasta el veintiuno por la tarde."
,"19":"Durante siete días no habrá levadura en vuestras casas, porque el que coma algo fermentado será extirpado de la comunidad de Israel, sea extranjero o indígena."
,"20":"No comeréis nada fermentado; en todas vuestras casas comeréis panes sin levadura'."
,"21":"Moisés convocó a todos los ancianos de Israel y les dijo: 'Id, tomad una res del rebaño por familia e inmolad la pascua."
,"22":"Tomad un manojo de hisopo, mojadlo en la sangre recogida en una cubetilla, untad con ella el dintel y las jambas y que nadie salga de su casa hasta la mañana siguiente."
,"23":"El Señor pasará para castigar a los egipcios y, al ver la sangre en el dintel y en las dos jambas, pasará de largo; no permitirá al exterminador entrar en vuestras casas para herir."
,"24":"Observaréis esto como institución perpetua para vosotros y vuestros hijos."
,"25":"Cuando hayáis entrado en la tierra que el Señor os va a dar, como ha prometido, observaréis este rito."
,"26":"Y si vuestros hijos os preguntan: ¿Qué rito es éste?,"
,"27":"responderéis: Es el sacrificio de la pascua del Señor, el cual pasó de largo por las casas de los israelitas en Egipto, cuando hirió a los egipcios y preservó nuestras casas'. El pueblo se postró y adoró."
,"28":"Y los israelitas fueron e hicieron lo que el Señor había mandado a Moisés y a Aarón."
,"29":"A medianoche el Señor mató a todos los primogénitos de Egipto, desde el primogénito del Faraón, su sucesor en el trono, hasta el primogénito del esclavo, recluido en la cárcel, y a todos los primogénitos de los animales."
,"30":"El Faraón se levantó de noche, él, todos sus servidores y todos los egipcios, y hubo llanto general en Egipto, porque no había casa donde no hubiera un muerto."
,"31":"El Faraón mandó llamar a Moisés y a Aarón, todavía de noche, y les dijo: 'Pronto, salid de en medio de nosotros; vosotros y todos los israelitas, id a servir al Señor como habéis dicho."
,"32":"Llevad vuestro ganado mayor y menor, como queréis, y partid; bendecidme también a mí'."
,"33":"Los egipcios instaban al pueblo a salir cuanto antes del país, porque decían: 'Vamos a morir todos'."
,"34":"El pueblo se cargó a la espalda las artesas, envueltas en los mantos, con la masa antes que fermentara."
,"35":"Los israelitas hicieron lo que les había mandado Moisés, y pidieron a los egipcios vestidos y objetos de plata y oro."
,"36":"El Señor concedió al pueblo el favor de los egipcios, que de buen grado accedieron a su petición; así despojaron a los egipcios."
,"37":"Los israelitas partieron de Rameses hacia Sucot en número de unos seiscientos mil adultos de a pie, además de los niños."
,"38":"Partió también con ellos una gran muchedumbre de gentes, y ovejas y bueyes en gran cantidad."
,"39":"Cocieron panes sin levadura de la masa sacada de Egipto, que no había podido fermentar; por la prisa que les metieron para salir, no pudieron preparar nada para comer."
,"40":"La estancia de los israelitas en Egipto duró cuatrocientos treinta años."
,"41":"El mismo día en que se cumplieron los cuatrocientos treinta años, todos los ejércitos del Señor salieron de Egipto."
,"42":"Noche de vela fue aquella para el Señor, cuando los sacó de Egipto. Ésta debe ser una noche de vela en honor del Señor para los israelitas en sus generaciones."
,"43":"El Señor dijo a Moisés y a Aarón: 'Ésta es la ley de la pascua: ningún extranjero podrá comerla. "
,"44":"El siervo, comprado con dinero, ha de ser circuncidado; entonces podrá comerla."
,"45":"El huésped y el mercenario no podrán comerla."
,"46":"Se comerá toda en la misma casa; de sus carnes no sacaréis nada fuera de ella, ni romperéis ninguno de sus huesos."
,"47":"Toda la comunidad de Israel celebrará la pascua."
,"48":"Si alguno de los extranjeros que habitan junto a ti quiere celebrar la pascua, tendrán que circuncidarse todos sus varones, y entonces se le admitirá, como si fuera un indígena; pero ningún incircunciso podrá comerla."
,"49":"La misma ley regirá para el indígena y para el extranjero que habita en medio de vosotros'."
,"50":"Los israelitas lo hicieron así, exactamente como el Señor había ordenado a Moisés y a Aarón."
,"51":"Aquel mismo día el Señor sacó a los israelitas del país de Egipto por escuadras."
}`)
	CurrentBook.AddChapter(13, `{
"1":"El Señor dijo a Moisés:"
,"2":"'Conságrame todos los primogénitos de los israelitas, tanto de los hombres como de los animales. Son míos'."
,"3":"Y Moisés dijo al pueblo: 'Recordad siempre este día, en el cual salisteis de Egipto, de la casa de la esclavitud, porque el Señor os ha sacado con mano fuerte. Por ello no habréis de comer nada fermentado'."
,"4":"'Hoy salís de Egipto, en el mes de Abib."
,"5":"Cuando el Señor te haya introducido en la tierra del cananeo, del hitita, del amorreo, del heveo y del jebuseo, la que juró dar a tus padres, tierra que mana leche y miel, observarás este rito en este mismo mes."
,"6":"Durante siete días comerás panes sin levadura; el séptimo será día de fiesta en honor del Señor."
,"7":"Durante los siete días comerás panes sin levadura; no se verá nada fermentado ni levadura en todo tu territorio."
,"8":"Ese día dirás a tus hijos: Esto es en memoria de lo que por mí hizo el Señor cuando salí de Egipto."
,"9":"Este rito será para ti como una señal en tu mano, como recuerdo ante tus ojos, para que tengas en tu boca la ley del Señor, porque el Señor te sacó de Egipto con mano fuerte."
,"10":"Observarás este mandato en el tiempo establecido, de año en año'."
,"11":"'Cuando el Señor te haya llevado a la tierra del cananeo, como te ha jurado a ti y a tus padres, y te la haya dado,"
,"12":"reservarás para el Señor todo primogénito; los machos del primer parto de tus animales serán del Señor."
,"13":"Pero rescatarás todo primogénito del hombre entre tus hijos."
,"14":"Y cuando tu hijo te pregunte mañana: ¿Qué es esto?, tú le dirás: El Señor nos sacó con mano fuerte de Egipto, de la casa de la esclavitud."
,"15":"Como el Faraón se obstinó en no dejarnos salir, el Señor mató a todos los primogénitos de Egipto, desde el primogénito del hombre hasta el del animal. Por eso yo sacrifico al Señor todo primogénito de mis hijos."
,"16":"Este rito será para ti como una señal en la mano, como recuerdo ante tus ojos; porque el Señor te sacó de Egipto con mano fuerte'."
,"17":"Cuando el Faraón dejó marchar al pueblo, Dios no los llevó por el camino de la región de los filisteos, aunque era más corto, pues se dijo: 'No sea que se arrepienta al verse atacado y vuelva a Egipto'."
,"18":"Dios hizo dar un rodeo al pueblo, llevándolo por el camino del desierto hacia el mar Rojo."
,"19":"Moisés llevó consigo los huesos de José, porque éste había hecho jurar a los israelitas: 'Dios os visitará; entonces vosotros llevaréis de aquí mis huesos'."
,"20":"Partieron de Sucot, y acamparon en Etán, en el margen del desierto."
,"21":"El Señor iba delante, de día en columna de nube para marcarles el camino, y en columna de fuego de noche para alumbrarles; así podían caminar tanto de día como de noche."
,"22":"La columna de nube no se apartó del pueblo de día, ni de noche la de fuego."
}`)
	CurrentBook.AddChapter(14, `{
"1":"El Señor dijo a Moisés:"
,"2":"'Di a los israelitas que cambien de rumbo y vayan a acampar en Pi Hajirot, entre Migdal y el mar, frente a Baal Sefón. Acamparéis frente a Baal Sefón, a lo largo del mar."
,"3":"El Faraón pensará que los israelitas andan perdidos por la tierra, y que el desierto les ha cerrado el paso."
,"4":"Yo endureceré el corazón del Faraón, y os perseguirá; yo seré glorificado a costa del Faraón y de todo su ejército; los egipcios reconocerán que yo soy el Señor'. Y así lo hicieron."
,"5":"Cuando contaron al rey de Egipto que el pueblo había huido, el Faraón y sus servidores cambiaron de idea acerca del pueblo y dijeron: '¿Qué es lo que hemos hecho dejando salir a Israel y quedándonos así sin sus servicios?'."
,"6":"Mandó uncir sus carros y tomó consigo su gente."
,"7":"Tomó seiscientos carros escogidos y todos los carros de los egipcios con sus respectivos capitanes."
,"8":"El Señor endureció el corazón del Faraón, rey de Egipto, que persiguió a los israelitas que habían partido con la frente alta."
,"9":"Los egipcios, los caballos y los carros del Faraón, sus caballeros y su ejército los siguieron y les dieron alcance en el lugar donde estaban acampados a lo largo del mar, junto a Pi Hajirot, frente a Baal Sefón."
,"10":"Cuando el Faraón estaba cerca, los israelitas alzaron los ojos y vieron que los egipcios seguían tras ellos. Llenos de terror clamaron al Señor"
,"11":"y dijeron a Moisés: '¿Es que no había sepulcros en Egipto, que nos has traído al desierto a morir? ¿Qué nos has hecho con sacarnos de Egipto?"
,"12":"¿No te decíamos en Egipto: No te preocupes de nosotros, pues queremos servir a los egipcios? Porque ¿no es, acaso, mejor servir a los egipcios que morir en el desierto?'."
,"13":"Moisés dijo al pueblo: 'No temáis, estad tranquilos y veréis la victoria que hoy os dará el Señor; porque a estos egipcios que ahora veis, ya nunca los volveréis a ver."
,"14":"El Señor combatirá por vosotros sin que vosotros os tengáis que molestar'."
,"15":"El Señor dijo a Moisés: '¿Por qué clamas a mí? Di a los israelitas que sigan adelante."
,"16":"Tú alza tu bastón, extiende la mano sobre el mar y divídelo para que los israelitas pasen por medio del mar en seco."
,"17":"Yo endureceré el corazón de los egipcios y seguirán tras ellos por el mar; así seré glorificado a costa del Faraón y de todo su ejército, de sus carros y de sus caballeros."
,"18":"Los egipcios conocerán que yo soy el Señor cuando yo sea glorificado a costa del Faraón, de sus carros y de sus caballeros'."
,"19":"Entonces el ángel de Dios, que iba delante de las huestes de Israel, se puso en marcha y se colocó detrás de ellos. Se puso igualmente en marcha la columna de nube, que también fue a situarse detrás de ellos,"
,"20":"interponiéndose entre el campo de los egipcios y el campo de Israel. Para unos la nube era oscura, mientras que para otros alumbraba la noche, de suerte que no pudieron acercarse unos a otros durante toda la noche."
,"21":"Moisés extendió después su mano sobre el mar, y el Señor, por medio de un recio viento del este, empujó el mar, dejándolo seco y dividiendo las aguas."
,"22":"Los israelitas entraron en medio del mar sin mojarse, mientras las aguas formaban como una muralla a ambos lados."
,"23":"Los egipcios se lanzaron tras ellos; toda la caballería del Faraón, sus carros y caballeros entraron tras ellos en medio del mar."
,"24":"Antes de la madrugada, el Señor miró desde la columna de fuego y de nube a las huestes egipcias y las desbarató."
,"25":"Frenó las ruedas de los carros, haciéndolos avanzar pesadamente. Los egipcios se dijeron: 'Huyamos de los israelitas, porque el Señor combate por ellos contra los egipcios'."
,"26":"Y el Señor dijo a Moisés: 'Extiende tu mano sobre el mar para que las aguas se vuelquen sobre los egipcios, sobre sus carros y caballeros'."
,"27":"Moisés extendió su mano sobre el mar, y al amanecer volvió el mar a su estado normal, mientras los egipcios en su huida topaban con él. Así precipitó el Señor a los egipcios en medio del mar. "
,"28":"Las aguas, al juntarse, cubrieron carros y caballeros y a todo el ejército del Faraón, que había entrado en persecución de los israelitas. No escapó ni uno solo."
,"29":"Pero los israelitas pasaron sin mojarse por medio del mar, formando para ellos las aguas como una muralla a ambos lados."
,"30":"Así salvó el Señor aquel día a Israel de mano de los egipcios, e Israel vio a los egipcios muertos en la orilla del mar."
,"31":"Israel vio el prodigio que el Señor había obrado contra los egipcios, temió al Señor y creyó en él y en Moisés, su siervo."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Entonces Moisés y los israelitas cantaron al Señor este cántico: 'Cantaré al Señor que,tan maravillosamente ha triunfado, caballo y caballero precipitó,en el mar."
,"2":"Mi fortaleza y mi cántico es el Señor, él fue mi salvación; él es mi Dios, yo le alabaré; el Dios de mi padre, lo ensalzaré."
,"3":"El Señor es un fuerte guerrero; su nombre es el Señor."
,"4":"Los carros del Faraón,y su ejército precipitó en el mar; la flor de sus guerreros,se la tragó el mar Rojo."
,"5":"Los abismos los cubrieron; cayeron como piedras,en lo profundo."
,"6":"Tu diestra, Señor, gloriosa,en la potencia; tu diestra, Señor, abate al enemigo."
,"7":"En tu sublime majestad,abates a tus adversarios; desatas tu furor, que cual paja los devora."
,"8":"Al soplo de tu cólera,se agolparon las aguas, se irguieron cual pilares,las corrientes; se cuajaron los abismos,en medio de la mar."
,"9":"Dijo el enemigo: 'Los perseguiré, les daré alcance, repartiré el botín, mi codicia será saciada, desenvainaré mi espada, mi mano los exterminará'."
,"10":"Soplaste con tu aliento, y los cubrió la mar; se hundieron como plomo,en las impetuosas aguas."
,"11":"¿Quién igual a ti, Señor, entre los dioses?,¿Quién igual a ti, sublime,en sabiduría, tremendo en gloria, autor de maravillas?"
,"12":"Desplegaste tu mano, la tierra los tragó."
,"13":"Guiaste en tu bondad al pueblo que salvaste; lo llevaste con tu poder,a tu santa mansión."
,"14":"Al oírlo temblaron los pueblos; se apoderó de los filisteos el terror."
,"15":"Se estremecieron entonces,los príncipes de Edón; presa fueron del terror,los fuertes de Moab; sintiéronse abatidos,todos los habitantes de Canaán."
,"16":"Temblor y espanto les asaltan; por la fuerza de tu brazo,enmudecen como piedra. Hasta que tu pueblo, oh Señor, haya pasado; hasta que haya pasado,este pueblo que adquiriste."
,"17":"Tú los guías y los plantas,en el monte de tu heredad, en el lugar de tu mansión que,has preparado, en el santuario que tus manos, oh Señor, han levantado."
,"18":"¡Reina, Señor, por siempre jamás!'."
,"19":"Cuando los caballos del Faraón, con carros y caballeros, penetraron en el mar, el Señor lanzó sobre ellos las aguas del mar, mientras los israelitas pasaron a pie enjuto por medio del mar."
,"20":"María, la profetisa, hermana de Aarón, tomó en sus manos un tamboril, y las mujeres salieron tras ella con tamboriles y bailando."
,"21":"Y María les respondía: 'Cantad al Señor, que se cubrió de gloria: ¡Caballo y caballero precipitó en el mar!'."
,"22":"Moisés hizo partir a los israelitas del mar Rojo. Avanzaron hacia el desierto de Sur y caminaron tres días sin encontrar agua."
,"23":"Llegaron a Mará y no pudieron beber sus aguas, porque eran amargas. Por eso se les puso el nombre de 'Mará'."
,"24":"Entonces el pueblo murmuró contra Moisés diciendo: '¿Qué beberemos?'."
,"25":"Moisés clamó al Señor. Él le señaló un madero; Moisés lo echó en las aguas, y las aguas se volvieron dulces. Allí el Señor dio al pueblo leyes y estatutos y lo sometió a prueba. "
,"26":"Les dijo: 'Si verdaderamente escuchas la voz del Señor, tu Dios, y haces lo que es recto a sus ojos, prestas oído a sus mandatos y observas todos sus estatutos, no enviaré sobre ti ninguna de las plagas con que castigué a los egipcios, porque yo soy el Señor, tu salvador'."
,"27":"Llegaron a Elín, donde había doce fuentes de agua y setenta palmeras; allí junto a las aguas fijaron su campamento."
}`)
	CurrentBook.AddChapter(16, `{
"1":"La comunidad de Israel partió de Elín y llegaron al desierto de Sin, entre Elín y Sinaí, el día quince del segundo mes después de la salida de Egipto."
,"2":"Toda la comunidad de Israel murmuró contra Moisés y Aarón en el desierto"
,"3":"diciendo: '¡Ojalá hubiéramos muerto por mano del Señor en Egipto, cuando nos sentábamos junto a las ollas de carne y comíamos pan hasta saciarnos! Vosotros, en cambio, nos habéis traído a este desierto para hacer morir de hambre a toda esta muchedumbre'."
,"4":"El Señor dijo a Moisés: 'Mira, voy a hacer llover pan del cielo para vosotros. El pueblo saldrá todos los días a recoger la ración diaria, a fin de probarle si camina según mi ley o no."
,"5":"Pero el día sexto, que preparen para llevar el doble de lo que acostumbran a recoger cada día'."
,"6":"Moisés y Aarón dijeron a los israelitas: 'Por la tarde conoceréis que ha sido el Señor quien os ha sacado de Egipto, y"
,"7":"por la mañana veréis la gloria del Señor, porque él ha oído vuestras murmuraciones contra el Señor. ¿Qué somos nosotros para que murmuréis contra nosotros?'."
,"8":"Y añadió: 'Esta tarde os dará el Señor carne para comer, y mañana por la mañana pan hasta saciaros, porque ha oído vuestras murmuraciones contra él. Pero nosotros ¿qué somos? No van contra nosotros vuestras murmuraciones, pero sí contra el Señor'."
,"9":"Moisés dijo a Aarón: 'Di a toda la comunidad de los israelitas: Acercaos al Señor, porque él ha oído vuestras murmuraciones'."
,"10":"Mientras Aarón estaba hablando, miraron hacia el desierto, y vieron aparecer la gloria del Señor en la nube."
,"11":"El Señor dijo a Moisés:"
,"12":"'He oído las murmuraciones de los israelitas. Diles: a la tarde comeréis carne, y a la mañana os saciaréis de pan; así conoceréis que yo soy el Señor, vuestro Dios'."
,"13":"Por la tarde salieron tantas codornices que cubrieron el campamento, y por la mañana había en torno a él una capa de rocío."
,"14":"Cuando se evaporó el rocío, apareció sobre la superficie del desierto una cosa menuda, granulada, fina, como escarcha sobre la tierra."
,"15":"Los israelitas, al verla, se dijeron unos a otros: 'man hu'=¿qué es esto?', pues no sabían lo que era. Moisés les dijo: 'Éste es el pan que os da el Señor para comer."
,"16":"Esto es lo que el Señor os ha mandado. Recoja cada uno según lo que pueda comer, dos litros por cabeza, según el número de vuestras personas. Cada uno recoja para cuantos viven en su tienda'."
,"17":"Y los israelitas lo hicieron así, recogiendo unos más, otros menos."
,"18":"Al medirlo luego, vieron que el que había recogido de más no tenía nada de más, y el que menos, no tenía nada de menos, sino que cada uno tenía lo que necesitaba para su consumo."
,"19":"Moisés les dijo: 'Nadie guarde para mañana'."
,"20":"Mas no le obedecieron, y algunos guardaron para el día siguiente; pero se llenó de gusanos y se pudrió, por lo cual Moisés se irritó contra ellos."
,"21":"Lo recogían cada mañana, cada uno en razón de su propio consumo. Cuando calentaba el sol, se derretía."
,"22":"El día sexto recogieron doble cantidad, cuatro litros por cabeza. Y los principales de la comunidad vinieron a informar a Moisés."
,"23":"Éste les dijo: 'Esto es lo que ha dispuesto el Señor: mañana es día de reposo, el sábado consagrado al Señor. Todo lo que tengáis que cocer, cocedlo, y todo lo que tengáis que hervir, hervidlo hoy, y guardad para mañana lo que sobre'."
,"24":"Lo guardaron hasta la mañana siguiente, como había ordenado Moisés, y no se estropeó ni se encontró en ello gusano alguno."
,"25":"Moisés dijo: 'Comedlo hoy, porque es día de descanso sagrado en honor del Señor. Hoy no lo habrá en el campo."
,"26":"Lo recogeréis seis días; pero en el séptimo día -sábado- no lo habrá'."
,"27":"No obstante, algunos del pueblo salieron a recogerlo, pero no lo encontraron."
,"28":"El Señor dijo a Moisés: '¿Hasta cuándo os resistiréis a observar mis mandatos y mis leyes?"
,"29":"Grabad bien en vuestras mentes que el Señor os ha dado el descanso del sábado; por ello el día sexto os da pan para dos días. Quédese cada uno en su puesto, y que el séptimo día nadie salga de él'."
,"30":"Y el pueblo descansó el séptimo día."
,"31":"Los israelitas llamaron a este alimento maná. Era parecido a la semilla del cilantro, blanco, y su sabor como torta de miel."
,"32":"Moisés dijo: 'Esto es lo que manda el Señor: Tomad dos litros y conservadlo para que vuestros descendientes vean el pan con que os he alimentado en el desierto, cuando os saqué de Egipto'."
,"33":"Moisés dijo a Aarón: 'Toma un vaso, echa en él dos litros de maná y ponlo ante el Señor, a fin de conservarlo para nuestros descendientes'."
,"34":"Aarón lo puso ante el testimonio para conservarlo, como había mandado el Señor."
,"35":"Los israelitas comieron el maná durante cuarenta años, hasta que llegaron a tierra habitada. Lo comieron hasta que llegaron a los confines de la tierra de Canaán."
}`)
	CurrentBook.AddChapter(17, `{
"1":"La comunidad de los israelitas partió del desierto de Sin por etapas, según les ordenaba el Señor, y acamparon en Rafidín, donde el pueblo no encontró agua para beber."
,"2":"El pueblo se querelló contra Moisés diciendo: 'Danos agua para beber'. Y Moisés les dijo: '¿Por qué os querelláis conmigo? ¿Por qué tentáis al Señor?'."
,"3":"Pero el pueblo, sediento, seguía murmurando contra Moisés diciendo: '¿Por qué nos has sacado de Egipto para hacernos morir de sed a nosotros, a nuestros hijos y a nuestros ganados?'."
,"4":"Moisés llamó al Señor: '¿Qué haré con este pueblo? Un poco más y me apedrean'."
,"5":"Y el Señor dijo a Moisés: 'Pasa delante del pueblo, toma contigo algunos ancianos de Israel, lleva en la mano el bastón con el que golpeaste el Nilo, y vete."
,"6":"Yo estaré delante de ti, allí, en la roca de Horeb. Tú golpearás la roca, que manará agua, y el pueblo beberá'. Así lo hizo Moisés en presencia de los ancianos de Israel."
,"7":"Y dio a aquel lugar el nombre de 'Masá' y 'Meribá' -prueba y querella- por la querella de los israelitas y porque pusieron a prueba al Señor diciendo: '¿Está el Señor en medio de nosotros o no?'."
,"8":"Amalec vino a Rafidín y atacó a los israelitas."
,"9":"Moisés dijo a Josué: 'Escoge hombres y sal a luchar contra Amalec. Yo estaré en la cima de la colina teniendo en la mano el bastón de Dios'."
,"10":"Josué hizo como le había ordenado Moisés, y luchó contra Amalec. Moisés, Aarón y Jur subieron a la cima de la colina."
,"11":"Cuando Moisés tenía sus brazos alzados vencía Israel, y cuando los bajaba vencía Amalec."
,"12":"Como se le cansaban los brazos a Moisés, tomaron una piedra y se la pusieron debajo. Él se sentó encima, y Aarón y Jur le sostenían los brazos, uno a cada lado. De este modo los brazos de Moisés se sostuvieron en alto hasta la puesta del sol."
,"13":"Josué derrotó a Amalec y a su ejército a filo de espada."
,"14":"El Señor dijo a Moisés: 'Pon esto por escrito, para recuerdo, en un libro, y asegura a Josué que yo borraré por completo la memoria de Amalec de debajo del cielo'."
,"15":"Moisés levantó un altar y le dio el nombre de 'El Señor, mi estandarte',"
,"16":"porque dijo: 'Una mano se alzó contra el trono del Señor; habrá guerra contra Amalec de generación en generación'."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Jetró, sacerdote de Madián, suegro de Moisés, oyó todo lo que había hecho Dios en favor de Moisés e Israel, su pueblo: cómo el Señor había sacado a Israel de Egipto."
,"2":"Jetró, suegro de Moisés, tomó a Séfora, mujer de Moisés, a la que éste había despedido antes,"
,"3":"y a sus dos hijos, uno de nombre Guersón, porque Moisés había dicho: 'He sido un extranjero en país extranjero',"
,"4":"y el otro Eliezer, porque había dicho: 'El Dios de mi padre ha sido mi ayuda y me ha librado de la espada del Faraón'."
,"5":"Jetró, suegro de Moisés, con los hijos y la mujer de éste, se llegó hasta el desierto, donde estaba acampado, al monte de Dios,"
,"6":"y le mandó a decir: 'Yo, tu suegro Jetró, he venido a verte con tu mujer y tus dos hijos'."
,"7":"Moisés salió al encuentro de su suegro, se inclinó ante él y lo besó, se saludaron y entraron en la tienda."
,"8":"Moisés contó a su suegro todo lo que había hecho el Señor al Faraón y a los egipcios por amor a Israel, todos los contratiempos que habían tenido a lo largo del camino y cómo les había librado de ellos."
,"9":"Jetró se alegró de todo el bien que el Señor había hecho a Israel, salvándole de la mano de los egipcios,"
,"10":"y dijo: '¡Bendito sea el Señor, que os ha librado de la mano de los egipcios y del Faraón! Él ha librado a este pueblo de la mano de los egipcios."
,"11":"Ahora reconozco que el Señor es más fuerte que todos los dioses, porque ha castigado a los egipcios, que tiranizaban a Israel'."
,"12":"Luego Jetró, suegro de Moisés, ofreció holocaustos y sacrificios al Señor. Y Aarón y todos los ancianos de Israel comieron con el suegro de Moisés en presencia del Señor."
,"13":"Al día siguiente Moisés se sentó a administrar justicia al pueblo, el cual estuvo ante él de la mañana a la tarde."
,"14":"Jetró, viendo todo lo que Moisés hacía con el pueblo, dijo: '¿Qué es esto que haces con el pueblo? ¿Por qué te sientas tú solo a administrar justicia y todo el pueblo está delante de ti de la mañana a la tarde?'."
,"15":"Moisés le respondió: 'Porque el pueblo viene a mí para consultar a Dios."
,"16":"Cuando tienen pleitos vienen a mí, y yo juzgo entre el uno y el otro, y les doy a conocer los mandatos y las leyes de Dios'."
,"17":"El suegro le dijo: 'No está bien lo que haces."
,"18":"Te agotarás tú y el pueblo que está contigo, porque es una carga demasiado pesada para ti. Ese cometido no puedes hacerlo tú solo."
,"19":"Escúchame. Voy a darte un consejo, y que Dios esté contigo. Sé tú ante Dios el representante del pueblo y llévale a él las causas."
,"20":"Instrúyelos en los mandatos y leyes y enséñales el camino que han de seguir y lo que han de hacer."
,"21":"Pero escógete de entre el pueblo hombres capaces, temerosos de Dios, hombres íntegros, libres de la avaricia, y constitúyelos sobre el pueblo como jefes de millar, de centena, de cincuentena y de decena;"
,"22":"que ellos administren justicia al pueblo permanentemente. Que a ti te lleven únicamente los asuntos más importantes; los de poca monta, que los juzguen ellos. Así aligerarás tu carga, y ellos la compartirán contigo."
,"23":"Si lo haces así, Dios te dará sus órdenes, tú podrás resistir, y todo este pueblo regresará en paz a su lugar'."
,"24":"Moisés escuchó a su suegro e hizo lo que él le había aconsejado."
,"25":"Moisés escogió de entre todo Israel hombres de valía y los puso al frente del pueblo como jefes de millar, de centena, de cincuentena y de decena."
,"26":"Ellos administraban justicia al pueblo permanentemente. Las cuestiones más difíciles se las llevaban a Moisés, y las de menor importancia las resolvían ellos."
,"27":"Moisés despidió a su suegro, que se volvió a su tierra."
}`)
	CurrentBook.AddChapter(19, `{
"1":"A los tres meses de la salida de Egipto, los israelitas llegaron al desierto de Sinaí."
,"2":"Partieron de Rafidín y llegaron al desierto de Sinaí, donde acamparon. Israel acampó frente a la montaña."
,"3":"Moisés subió hacia Dios, y el Señor le llamó desde la montaña diciendo: 'Di a la casa de Jacob y a todos los israelitas:"
,"4":"Habéis visto cómo he tratado a los egipcios y cómo os he llevado sobre alas de águila y os he traído hasta mí."
,"5":"Si escucháis atentamente mi voz y guardáis mi alianza, vosotros seréis mi especial propiedad entre todos los pueblos; porque mía es toda la tierra;"
,"6":"vosotros seréis un reino de sacerdotes, un pueblo santo. Esto es lo que tienes que decir a los israelitas'."
,"7":"Moisés vino, llamó a los ancianos del pueblo y les expuso todas estas cosas que el Señor le había ordenado."
,"8":"Y todo el pueblo, a una, respondió: 'Nosotros haremos todo lo que el Señor ha dicho'. Moisés refirió al Señor las palabras del pueblo."
,"9":"Y el Señor dijo a Moisés: 'Yo llegaré hasta ti en una nube espesa, para que el pueblo oiga cuando yo hable contigo y tenga siempre fe en ti'. Y Moisés refirió al Señor las palabras del pueblo."
,"10":"El Señor dijo a Moisés: 'Vete donde el pueblo y santifícalo hoy y mañana; que laven sus vestidos y"
,"11":"que estén así preparados para pasado mañana, pues pasado mañana el Señor bajará al monte Sinaí a la vista de todo el pueblo."
,"12":"Señalarás al pueblo un límite alrededor diciendo: Guardaos de subir a la montaña y de tocar su falda. El que toque el monte será condenado a muerte."
,"13":"Pero nadie le pondrá la mano encima: será matado a pedradas o a flechazos. Hombre o animal, no quedará con vida. Sólo cuando suene el cuerno podrán subir al monte'."
,"14":"Moisés bajó de la montaña, santificó al pueblo, y ellos lavaron sus vestidos."
,"15":"Y dijo al pueblo: 'Estad preparados para pasado mañana; que nadie toque mujer'."
,"16":"Al tercer día, a eso del amanecer, hubo truenos y relámpagos, una espesa nube sobre la montaña y un sonido muy fuerte de trompeta; todo el pueblo, que estaba en el campamento, temblaba."
,"17":"Moisés hizo salir al pueblo del campamento al encuentro de Dios, y se detuvieron al pie de la montaña."
,"18":"Toda la montaña del Sinaí humeaba, porque sobre ella había descendido el Señor en medio de fuego. El humo subía como de un horno, y toda la montaña se estremecía fuertemente."
,"19":"El sonido de la trompeta se iba haciendo cada vez más fuerte. Moisés hablaba, y Dios le respondía con el trueno."
,"20":"El Señor bajó a la cima del monte Sinaí, llamó a Moisés a la cima, y Moisés subió."
,"21":"El Señor dijo a Moisés: 'Baja y advierte al pueblo que no traspase el límite para ver al Señor, porque muchos morirían."
,"22":"Que se santifiquen también los sacerdotes que se acercan al Señor, para que el Señor no arremeta contra ellos'."
,"23":"Moisés dijo al Señor: 'El pueblo no puede subir a la montaña, pues se lo has prohibido ordenando poner un límite y declararla sagrada'."
,"24":"Y el Señor dijo a Moisés: 'Baja de nuevo y sube luego con Aarón; pero que los sacerdotes y el pueblo no traspasen el límite para subir hacia el Señor, pues arremetería contra ellos'."
,"25":"Moisés bajó hasta el pueblo y les dijo todo esto."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Dios pronunció todas estas palabras:"
,"2":"'Yo soy el Señor, tu Dios, el que te sacó de Egipto, de la casa de la esclavitud."
,"3":"No tendrás otro Dios fuera de mí."
,"4":"No te harás escultura ni imagen alguna de lo que hay arriba en el cielo, o aquí abajo en la tierra o en el agua bajo tierra."
,"5":"No te postrarás ante ella ni le darás culto, porque yo, el Señor, tu Dios, soy un Dios celoso, que castigo la iniquidad del padre en los hijos hasta la tercera y cuarta generación de los que me aborrecen,"
,"6":"pero demuestro mi fidelidad por mil generaciones a todos los que me aman y guardan mis mandamientos."
,"7":"No tomarás el nombre del Señor en vano, porque el Señor no dejará sin castigo al que toma su nombre en vano."
,"8":"Acuérdate del día del sábado para santificarlo."
,"9":"Seis días trabajarás y en ellos harás todas tus faenas;"
,"10":"pero el séptimo día es día de descanso en honor del Señor, tu Dios. No harás en él trabajo alguno ni tú, ni tu hijo, ni tu hija, ni tu siervo, ni tu sierva, ni tu ganado, ni el extranjero que habita contigo."
,"11":"Porque en seis días hizo el Señor los cielos y la tierra, el mar y cuanto hay en ellos, y el séptimo descansó. Por ello bendijo el Señor el día del sábado y lo santificó."
,"12":"Honra a tu padre y a tu madre para que tus días se alarguen sobre la tierra que el Señor, tu Dios, te da."
,"13":"No matarás."
,"14":"No cometerás adulterio."
,"15":"No robarás."
,"16":"No darás falso testimonio contra tu prójimo."
,"17":"No desearás la casa de tu prójimo, ni su mujer, ni su siervo, ni su sierva, ni su buey, ni su asno, ni cosa alguna que a él le pertenezca'."
,"18":"Todo el pueblo distinguía los truenos y los relámpagos, el sonido de la trompeta y el humear de la montaña. El pueblo, al ver esto, temblaba y se mantenía a distancia."
,"19":"Y dijeron a Moisés: 'Háblanos tú y te escucharemos; pero que no nos hable el Señor, para que no muramos'."
,"20":"Moisés dijo al pueblo: 'No temáis, que el Señor ha venido sólo para probaros y para que su temor esté siempre en vosotros y no pequéis'."
,"21":"El pueblo se mantuvo a distancia, mientras Moisés se aproximó a la nube donde estaba el Señor."
,"22":"El Señor dijo a Moisés: 'Di a los israelitas: Vosotros habéis visto que os he hablado desde el cielo."
,"23":"No hagáis junto a mí dioses de plata ni de oro."
,"24":"Me levantarás un altar de tierra y en él me ofrecerás tus holocaustos, tus sacrificios de reconciliación, tus ovejas y tus bueyes. En cualquier lugar en que yo quiera hacer mi nombre memorable vendré a ti y te bendeciré."
,"25":"Si me levantas altar de piedras, no sea con piedras labradas, porque al trabajarlas con tus herramientas las habrás profanado."
,"26":"Ni subirás por gradas a mi altar, para que no se descubra allí tu desnudez."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Éstas son las leyes de justicia que les promulgarás:"
,"2":"Si compras un esclavo hebreo, te servirá por seis años, pero el séptimo quedará libre sin pagar nada."
,"3":"Si entró solo, solo saldrá; si tenía mujer, ésta saldrá con él."
,"4":"Si su amo le dio mujer y ésta le dio hijos o hijas, la mujer con los hijos será de su amo y él se irá solo."
,"5":"Pero si el esclavo dice: Yo quiero a mi amo, a mi mujer y a mis hijos; no quiero salir libre,"
,"6":"el amo lo hará comparecer ante el Señor, lo acercará a la puerta de la casa o a la jamba y le perforará la oreja con un punzón; será su esclavo para siempre."
,"7":"Si uno vende a su hija por esclava, ésta no saldrá de casa, como salen los esclavos."
,"8":"Si no agrada a su amo y no la toma por esposa, éste permitirá que sea rescatada; pero no la puede vender a gente extraña por no haberle mantenido la promesa."
,"9":"Pero si la destina para su hijo, la tratará según los derechos de los hijos."
,"10":"Si toma para él otra mujer, no negará a la esclava su alimento, vestido y lecho."
,"11":"Y si no hace ninguna de estas tres cosas, la esclava podrá irse sin rescate, sin pagar nada."
,"12":"El que hiere de muerte a un hombre, será condenado a muerte."
,"13":"Pero si no lo ha hecho queriendo, sino porque Dios se lo puso en sus manos, yo le señalaré un lugar donde pueda refugiarse."
,"14":"Si un hombre se irrita contra su prójimo y lo mata con premeditación, será arrancado incluso de mi altar para hacerlo morir."
,"15":"El que hiera a su padre o a su madre, será condenado a muerte."
,"16":"El que robe una persona, la haya vendido o la retenga todavía consigo, morirá."
,"17":"Quien maldiga a su propio padre o a su propia madre, será condenado a muerte."
,"18":"Si riñen dos hombres y uno hiere al otro con una piedra o con el puño, y éste no muere pero debe guardar cama,"
,"19":"si luego se levanta y puede salir fuera apoyado en su bastón, el que le ha herido será absuelto, pero le indemnizará por el tiempo que ha estado en cama y por lo que haya gastado en la cura."
,"20":"Si uno mata a palos a su esclavo o a su esclava, será severamente castigado."
,"21":"Pero si sobreviviere un día o dos, no, porque es propiedad suya."
,"22":"Si unos hombres se pelean y golpean a una mujer encinta haciéndola abortar, pero sin ningún daño especial, el que la ha golpeado será multado con la cantidad que el marido de la mujer pida y decidan los jueces."
,"23":"Pero si se sigue un daño, lo pagarás: vida por vida,"
,"24":"ojo por ojo, diente por diente, mano por mano, pie por pie,"
,"25":"quemadura por quemadura, herida por herida, golpe por golpe."
,"26":"Si uno salta de un golpe un ojo a su esclavo o a su esclava, le dará la libertad en compensación del ojo perdido."
,"27":"Si le rompe un diente le dará la libertad en compensación del diente perdido."
,"28":"Si un buey acornea a un hombre o a una mujer y mueren, el buey será sacrificado y su carne no se podrá comer, pero su amo será absuelto."
,"29":"Pero si ya antes el buey acorneaba, y el amo, sabiéndolo, no lo encerró, y el buey mata a un hombre o a una mujer, el buey será matado a pedradas, lo mismo que el dueño."
,"30":"Pero si en lugar de la muerte le impusieran un precio como rescate, pagará por el rescate de su vida la cantidad que le fuere impuesta."
,"31":"Si el buey acornea a un niño o a una niña, le será también aplicada esta ley."
,"32":"Si el buey acornea a un esclavo o a una esclava, el amo del buey pagará treinta monedas de plata al dueño del esclavo o de la esclava, y el buey será matado a pedradas."
,"33":"Si uno deja una cisterna abierta, o la cava y no la cubre, y un buey o un asno cae dentro,"
,"34":"el dueño de la cisterna reparará los daños, pagará en dinero al dueño del buey o del asno, y el animal muerto será suyo."
,"35":"Si el buey de uno acornea al buey de otro y éste muere, venderán el buey vivo, partiéndose el importe, y se repartirán igualmente el buey muerto."
,"36":"Pero si era notorio que ya el buey solía acornear, restituirá buey por buey y el buey muerto será suyo."
,"37":"Si alguno roba un buey o una oveja y los mata o vende, restituirá cinco bueyes por cada buey y cuatro ovejas por cada oveja."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Si el ladrón, sorprendido en el acto de abrir brecha, es herido y muere, no habrá en ello delito de sangre;"
,"2":"pero si el sol había ya salido, sí lo habrá. El ladrón restituirá; y si no tiene con qué, será vendido para pagar lo robado."
,"3":"Si se le encuentra vivo en casa lo robado, buey, asno o cordero, restituirá el doble."
,"4":"Si uno deja pastar su ganado en el campo o en la viña de otro, resarcirá el daño con lo mejor de su campo o de su viña."
,"5":"Si se propaga un incendio por la maleza y se queman mieses, las gavillas o el mismo campo, el que causó el fuego pagará lo quemado."
,"6":"Si uno da a otro dinero o utensilios para que los guarde y éstos son robados de su casa, si se encuentra al ladrón, restituirá el doble."
,"7":"Pero si no se lo encuentra, el dueño de la casa comparecerá ante Dios y jurará que no ha puesto la mano en las cosas de su prójimo."
,"8":"En toda apropiación indebida, sea de buey, de asno, de oveja, de vestido o de cualquier cosa desaparecida, si alguien lo reclama como suyo, la causa de las dos partes se llevará ante Dios. Aquel a quien Dios condene, restituirá el doble a su prójimo."
,"9":"Si uno da a otro en custodia un asno, un buey, una oveja o cualquier otro animal, y ese animal muere, se daña o es robado sin que nadie lo vea,"
,"10":"el juramento del Señor decidirá entre las dos partes; si no ha puesto la mano sobre los bienes de su prójimo, el dueño del animal aceptará el juramento y el otro no pagará nada."
,"11":"Pero si el animal ha sido robado en su casa, se lo pagará a su dueño."
,"12":"Si el animal hubiese sido despedazado, lo traerá para testimonio, pero no pagará nada por el animal despedazado."
,"13":"Si uno pide prestado un animal de otro y se daña o muere en ausencia del dueño, deberá pagarlo."
,"14":"Pero si su dueño está presente, no lo pagará. Si era alquilado, pagará el precio del alquiler."
,"15":"Si uno seduce a una joven soltera y tiene con ella relación carnal, pagará su dote y la tomará por esposa."
,"16":"Pero si su padre no quiere dársela, pagará en dinero la dote acostumbrada."
,"17":"No dejarás con vida a la hechicera."
,"18":"El reo de bestialidad será condenado a muerte."
,"19":"El que ofrezca sacrificios a otros dioses, fuera del Señor, será condenado a muerte."
,"20":"No explotarás ni oprimirás al extranjero, porque también vosotros fuisteis extranjeros en Egipto."
,"21":"No maltratarás a la viuda ni al huérfano."
,"22":"Si maltratas, él clamará a mí y yo escucharé su clamor;"
,"23":"mi ira se encenderá y os mataré a filo de espada; vuestras mujeres serán viudas y huérfanos vuestros hijos."
,"24":"Si prestas dinero a alguno de mi pueblo, al pobre, vecino tuyo, no serás usurero con él, exigiéndole intereses."
,"25":"Si tomas en prenda el manto de tu prójimo, se lo devolverás antes de la puesta del sol,"
,"26":"porque ése es su único abrigo con que cubre su cuerpo. Si no, ¿con qué va a dormir? Si recurre a mí, yo le escucharé, porque soy misericordioso."
,"27":"No blasfemarás contra Dios ni maldecirás al jefe de tu pueblo."
,"28":"No serás remiso en hacerme la ofrenda de tus mieses y tu vino. Me darás el primogénito de tus hijos."
,"29":"Harás lo mismo con el primogénito de tus vacas y de tus ovejas. Siete días permanecerá con su madre, y al octavo me lo darás."
,"30":"Vosotros seréis para mí un pueblo santo. No comeréis carne de animal despedazado en el campo; se la echaréis a los perros."
}`)
	CurrentBook.AddChapter(23, `{
"1":"No corras rumores falsos; no apoyes al que sostiene una causa injusta, dando falso testimonio."
,"2":"No vayas tras la multitud para hacer el mal ni declares en un pleito inclinándote a la mayoría, violando la justicia."
,"3":"Tampoco favorecerás al débil en su pleito."
,"4":"Si encuentras el buey de tu enemigo o su asno perdido, llévaselo."
,"5":"Si ves el asno del que te odia caído bajo el peso de su carga, no le abandones; ayúdale a levantarlo."
,"6":"No violarás el derecho del pobre en sus causas."
,"7":"No intervengas en causas injustas y no hagas morir al inocente y al justo, porque yo no absolveré al malvado."
,"8":"No aceptarás regalos, porque el regalo ciega incluso a los que tienen la vista clara y pervierte las palabras de los justos."
,"9":"No explotarás al emigrante, porque vosotros conocéis la vida del emigrante, pues lo fuisteis en Egipto."
,"10":"Durante seis años sembrarás tu tierra y recogerás su fruto."
,"11":"Pero el séptimo la dejarás descansar, sin cultivarla, para que coman los pobres de su fruto, y lo que quede lo coman las bestias del campo. Lo mismo harás con tu viña y tu olivar."
,"12":"Seis días trabajarás, pero el séptimo descansarás, para que descansen también tu buey y tu asno y tengan un respiro el hijo de tu esclava y el emigrante."
,"13":"Guardad todo lo que os he dicho. No invocarás el nombre de otros dioses; ni se oiga siquiera de tu boca."
,"14":"Tres veces al año celebrarás fiesta solemne en mi honor."
,"15":"Guardarás la fiesta de los panes sin levadura. Durante siete días comerás panes sin levadura, como yo te mandé, en el tiempo señalado del mes de abib, porque en él salisteis de Egipto. Nadie se presente a mí con las manos vacías."
,"16":"Guardarás también la fiesta de la siega, de las primicias de tus trabajos, de lo que hayas sembrado en el campo. Y la fiesta de la recolección, al terminar el año, cuando recojas de los campos el fruto de tus fatigas."
,"17":"Tres veces al año comparecerá todo varón ante el Señor, tu Dios."
,"18":"Cuando me sacrifiques una víctima, no me ofrecerás su sangre con pan fermentado, ni guardarás para el día siguiente."
,"19":"Llevarás a la casa del Señor, tu Dios, las primicias de los frutos de tu tierra. No cocerás el cabrito en la leche de su madre."
,"20":"Yo enviaré un ángel delante de ti, para que te cuide en el camino y te lleve a la tierra que yo te he preparado."
,"21":"Respeta su presencia y escucha su voz; no te rebeles contra él, porque no perdonará vuestra infidelidad, pues mi nombre está en él."
,"22":"Si obedeces su voz y haces cuanto yo te diga, seré enemigo de tus enemigos y adversario de tus adversarios;"
,"23":"porque mi ángel irá delante de ti y te llevará a la tierra de los amorreos, hititas, fereceos, cananeos, heveos y jebuseos: yo los exterminaré."
,"24":"No adorarás a sus dioses, ni los servirás. No imitarás sus obras, sino que las destruirás por completo y destrozarás sus estelas."
,"25":"Si servís al Señor, vuestro Dios, él bendecirá tu pan y tu agua; y yo alejaré de ti toda enfermedad."
,"26":"En tu tierra no habrá mujer que aborte, ni mujer estéril: colmaré el número de tus días."
,"27":"Mi temor irá delante de ti, sembraré pánico en todo pueblo donde tú entres y haré que todos tus enemigos huyan ante ti."
,"28":"Mandaré delante de ti tábanos que pondrán en fuga ante ti a los heveos, a los cananeos y a los hititas."
,"29":"No los echaré de tu presencia en un solo año, para que no se quede la tierra desierta y se multipliquen contra ti las fieras salvajes,"
,"30":"sino que los iré echando poco a poco de tu presencia a medida que vayas creciendo y vayas poseyendo la tierra."
,"31":"Estableceré los confines de tu territorio desde el mar Rojo hasta el mar de los filisteos, desde el desierto hasta el río; pondré en vuestras manos a los habitantes del país, y tú los echarás de tu presencia."
,"32":"No harás pactos con ellos ni con sus dioses."
,"33":"No los dejarás habitar en tu tierra, para que no te inciten a pecar contra mí sirviendo a sus dioses, lo cual sería la ruina para ti'."
}`)
	CurrentBook.AddChapter(24, `{
"1":"El Señor dijo a Moisés: 'Sube hasta el Señor, tú, Aarón, Nadab, Abihú y setenta ancianos de Israel; os postraréis a distancia."
,"2":"Sólo Moisés se acercará al Señor; los otros no se aproximarán; el pueblo no subirá con él'."
,"3":"Moisés vino y comunicó al pueblo todas las palabras del Señor y todas sus leyes relativas a la administración de la justicia. Y todo el pueblo respondió a una voz: 'Nosotros cumpliremos todo cuanto ha dicho el Señor'."
,"4":"Moisés escribió todas las palabras del Señor, se levantó de madrugada y edificó un altar al pie de la montaña y doce estelas por las doce tribus de Israel."
,"5":"Mandó a algunos jóvenes israelitas a ofrecer holocaustos e inmolar novillos como sacrificios de reconciliación en honor del Señor."
,"6":"Después tomó la mitad de la sangre y la puso en vasijas, y la otra mitad la derramó sobre el altar."
,"7":"Tomó luego el libro de la alianza y lo leyó en presencia del pueblo, el cual dijo: 'Cumpliremos todo lo que ha dicho el Señor y obedeceremos'."
,"8":"Moisés tomó la sangre y la derramó sobre el pueblo diciendo: 'Ésta es la sangre de la alianza que el Señor ha hecho con vosotros mediante todas estas palabras'."
,"9":"Moisés, Aarón, Nadab, Abihú y setenta ancianos de Israel subieron"
,"10":"y vieron al Dios de Israel. Bajo sus pies había como un pavimento de zafiro, semejante en claridad al mismo cielo."
,"11":"No extendió su mano contra aquellos elegidos de Israel; y ellos vieron a Dios, comieron y bebieron."
,"12":"El Señor dijo a Moisés: 'Sube a la montaña y estate allí. Yo te daré unas tablas de piedra con la ley y los mandamientos que he escrito para instruirlos'."
,"13":"Moisés se levantó con Josué, su ministro, y antes de subir a la montaña"
,"14":"dijo a los ancianos: 'Esperadnos aquí hasta que volvamos. Quedan con vosotros Aarón y Jur; el que tenga algún asunto, que recurra a ellos'."
,"15":"Moisés subió a la montaña, y la nube le cubrió durante seis días."
,"16":"La gloria del Señor se había posado sobre la montaña, y la nube la cubrió durante seis días. Al séptimo día, el Señor llamó a Moisés desde la nube."
,"17":"Y la gloria del Señor aparecía a la vista de los israelitas como un fuego devorador sobre la cima de la montaña."
,"18":"Moisés penetró en la nube y subió a la montaña, en la que permaneció cuarenta días y cuarenta noches."
}`)
	CurrentBook.AddChapter(25, `{
"1":"El Señor dijo a Moisés:"
,"2":"'Di a los israelitas que me ofrezcan tributos. Vosotros los recogeréis de todo aquel que los entregue de todo corazón."
,"3":"Éstos serán los tributos que podréis recoger: oro, plata y bronce;"
,"4":"púrpura violeta, púrpura escarlata y carmesí; lino fino y pelo de cabra;"
,"5":"pieles de carnero teñidas en rojo, pieles de tejón y maderas de acacia;"
,"6":"aceite para las lámparas; aromas para el óleo de la unción y para el incienso perfumado;"
,"7":"piedras de ónice y piedras de engaste para el efod y el pectoral."
,"8":"Me harán un santuario y habitaré en medio de ellos."
,"9":"Todo lo haréis conforme al modelo del tabernáculo y de sus utensilios, que yo os mostraré'."
,"10":"'Haz un arca de madera de un metro y veinticinco centímetros de larga, setenta y cinco centímetros de ancha y setenta y cinco de alta."
,"11":"La recubrirás de oro puro por dentro y por fuera, y con una moldura de oro todo alrededor."
,"12":"Fundirás para ella cuatro anillos de oro y los pondrás en sus cuatro esquinas, dos a cada lado."
,"13":"Harás unas barras de madera de acacia, que recubrirás de oro,"
,"14":"y las pasarás por los anillos de los lados del arca para llevarla por medio de ellas."
,"15":"Las barras estarán siempre en los anillos y no se sacarán de ellos."
,"16":"Dentro del arca pondrás el testimonio que yo te daré'."
,"17":"'Harás también un propiciatorio de oro puro de un metro y veinticinco centímetros de largo y medio metro de ancho."
,"18":"Harás dos querubines de oro, de oro batido, a los dos extremos del propiciatorio,"
,"19":"uno a cada lado y formando un solo cuerpo con él."
,"20":"Los querubines tendrán sus alas extendidas hacia arriba cubriendo con ellas el propiciatorio, estando sus rostros uno frente al otro y mirando hacia el propiciatorio."
,"21":"Pondrás el propiciatorio sobre el arca, y dentro de ésta el testimonio que yo te daré."
,"22":"Aquí vendré yo a encontrarme contigo, y desde encima del propiciatorio, entre los dos querubines que están sobre el arca del testimonio, te comunicaré todo lo que te ordene respecto a los israelitas'."
,"23":"'Harás una mesa de madera de acacia de un metro de larga, medio metro de ancha y setenta y cinco centímetros de alta."
,"24":"La recubrirás de oro puro, y pondrás una moldura de oro todo alrededor."
,"25":"La rodearás con un reborde de veinticinco centímetros de ancho con una moldura de oro."
,"26":"Harás también cuatro anillos de oro, y los pondrás en los cuatro ángulos de sus cuatro pies."
,"27":"Los anillos estarán por debajo de la moldura para pasar por ellos las barras con que ha de ser llevada."
,"28":"Las barras para llevar la mesa las harás de madera de acacia, que recubrirás de oro."
,"29":"Harás también para ella platos, cucharas, copas y tazas para las ofrendas de líquidos; todo de oro puro."
,"30":"Sobre la mesa pondrás los panes de la proposición, para que estén continuamente en mi presencia'."
,"31":"'Harás, además, un candelabro de oro puro forjado; su base, fuste, copas, cálices y pétalos harán un solo cuerpo."
,"32":"Seis brazos saldrán de sus lados, tres de uno y tres de otro."
,"33":"Cada brazo tendrá tres copas en forma de flor de almendro con su cáliz y pétalos; los seis brazos, que arrancan del fuste del candelabro, serán iguales."
,"34":"El fuste del candelabro tendrá cuatro copas en forma de flor de almendro con su cáliz y pétalos."
,"35":"Cada una de las tres parejas de brazos tendrá un cáliz en su parte inferior; los seis exactamente igual."
,"36":"Este conjunto de cálices y brazos formará una sola pieza con el candelabro. Todo será de oro puro trabajado a cincel."
,"37":"Harás también para él siete lámparas, que pondrás sobre el candelabro de forma que alumbren hacia adelante,"
,"38":"con sus despabiladeras y platillos, todo de oro puro."
,"39":"Emplearás treinta y tres kilos de oro puro para hacer el candelabro y todos sus utensilios."
,"40":"Lo harás según el modelo que te he mostrado en la montaña'."
}`)
	CurrentBook.AddChapter(26, `{
"1":"'Harás el tabernáculo con diez cortinas de lino fino trenzado con púrpura violeta, escarlata y carmesí, y con querubines artísticamente bordados."
,"2":"Todas las cortinas tendrán la misma medida: doce metros y medio de largo por dos de ancho."
,"3":"Las unirás de cinco en cinco."
,"4":"Pondrás lazos de púrpura violeta en el borde de la cortina que termina cada uno de los dos conjuntos."
,"5":"Harás cincuenta lazos en el borde de los dos conjuntos, de modo que se correspondan entre sí."
,"6":"Harás cincuenta broches de oro, con los cuales unirás una cortina con otra, de modo que el tabernáculo forme un solo cuerpo."
,"7":"Harás once cortinas de pelo de cabra para cubrir, a modo de tienda, el tabernáculo;"
,"8":"todas las cortinas tendrán la misma medida: quince metros de largo por dos de ancho."
,"9":"Las unirás en dos conjuntos, el primero de cinco y el segundo de seis, de modo que la sexta cubra la parte anterior de la tienda."
,"10":"Harás cincuenta lazos en el borde de la última cortina de cada conjunto,"
,"11":"y cincuenta broches de bronce, por los que harás pasar los lazos, uniendo la tienda de modo que todo ello forme un solo cuerpo."
,"12":"Como las cortinas de la tienda son más largas, la mitad de la cortina sobrante colgará en la parte posterior del tabernáculo."
,"13":"El medio metro que sobra a uno y otro lado, a lo largo de la tienda, se extenderá sobre los dos lados del tabernáculo para cubrirlo."
,"14":"Harás a la tienda una cubierta de pieles de carnero teñidas en rojo, y sobre ésta otra de pieles de tejón."
,"15":"Harás para el tabernáculo unos tablones de madera de acacia, y los colocarás bien derechos."
,"16":"Serán de cinco metros de largo por setenta y cinco centímetros de ancho."
,"17":"Cada tablón llevará dos espigas, para que queden ensamblados unos con otros: todos los tablones serán iguales."
,"18":"Los dispondrás así: veinte en el lado sur,"
,"19":"bajo los que pondrás cuarenta basas de plata, dos debajo de cada tablón para cada espiga."
,"20":"Otros veinte en el lado norte"
,"21":"con sus respectivas cuarenta basas de plata, dos debajo de cada tablón."
,"22":"Seis en el lado oeste,"
,"23":"y otros dos en los ángulos posteriores del tabernáculo,"
,"24":"unidos de abajo arriba, formando cada dos un tabique angular."
,"25":"Serán, pues, ocho tablones con sus dieciséis basas de plata, dos debajo de cada uno."
,"26":"Harás travesaños de madera de acacia, cinco para los tablones de un lado del tabernáculo,"
,"27":"cinco para los del otro y otros cinco para los tablones del lado que da al oeste."
,"28":"El travesaño central, que pasará por en medio de los tablones, correrá de un extremo a otro."
,"29":"Todos estos tablones los recubrirás de oro; los anillos por donde ellos han de pasar serán también de oro."
,"30":"Construirás el tabernáculo conforme al modelo que se te ha mostrado en la montaña'."
,"31":"'Harás un velo de lino fino, trenzado con púrpura violeta, escarlata y carmesí; todo ello con querubines artísticamente bordados."
,"32":"Lo sostendrás por medio de cuatro columnas de acacia recubiertas de oro, con sus garfios de oro, apoyadas en cuatro basas de plata."
,"33":"Colgarás el velo de los garfios y allí, detrás del velo, pondrás el arca del testimonio. El velo servirá para separar el lugar santo del lugar santísimo. "
,"34":"Pondrás el propiciatorio sobre el arca del testimonio en el lugar santísimo."
,"35":"La mesa la pondrás fuera del velo, al lado septentrional, y el candelabro frente a ella en el lado norte del tabernáculo."
,"36":"Harás para la entrada de la tienda un velo de lino fino, trenzado con púrpura violeta, escarlata y carmesí; todo ello artísticamente recamado."
,"37":"Para este velo harás cinco columnas de acacia, que recubrirás de oro, con sus garfios también de oro, y que apoyarás en cinco basas de bronce'."
}`)
	CurrentBook.AddChapter(27, `{
"1":"'Harás un altar de madera de acacia, cuadrado, de dos metros y medio de largo, por dos y medio de ancho y uno y medio de alto."
,"2":"En cada uno de sus cuatro ángulos pondrás un cuerno recubierto de bronce, formando un solo cuerpo."
,"3":"Harás calderos para recoger las cenizas, paletas, aspersorios, tenaza y braseros; todo de bronce."
,"4":"Harás también para el altar un enrejado de bronce en forma de red, y en sus cuatro ángulos pondrás cuatro anillos de bronce."
,"5":"Lo pondrás en el reborde del altar, por debajo, de modo que la red llegue a la mitad del altar."
,"6":"Y harás para el altar barras de madera de acacia, que recubrirás de bronce."
,"7":"Éstas se pasarán por los anillos, corriendo a lo largo de los dos lados del altar, cuando haya de ser transportado."
,"8":"Lo harás hueco, de tablas, conforme se te ha mostrado en la montaña'."
,"9":"'Harás el atrio del tabernáculo; al lado sur llevará cincuenta metros de cortinas de lino trenzado,"
,"10":"y veinte columnas con sus respectivas basas de bronce. Los garfios de las columnas y sus anillos serán de plata."
,"11":"En el lado norte llevará cincuenta metros de cortinas y veinte columnas con sus respectivas basas de bronce. Los garfios y los anillos de las columnas serán de plata."
,"12":"En el lado oeste llevará veinticinco metros de cortinas y diez columnas con sus respectivas basas."
,"13":"El atrio, en el lado este, tendrá veinticinco metros de largo,"
,"14":"llevará siete metros y medio de cortinas con sus tres columnas y sus tres basas"
,"15":"en cada uno de sus dos lados."
,"16":"A la entrada del atrio habrá una cortina de diez metros de púrpura violeta, escarlata y carmesí, de lino fino torzal artísticamente recamado, y cuatro columnas con sus respectivas basas."
,"17":"Todas las cortinas en torno al atrio estarán rodeadas por arillos de plata; los garfios serán de plata y las basas de bronce."
,"18":"El atrio tendrá cincuenta metros de largo, veinticinco de ancho por cada lado y dos y medio de alto; todo ello de lino fino trenzado, menos las basas, que serán de bronce."
,"19":"Todos los utensilios del tabernáculo para todos sus servicios, las estaquillas y las estacas del atrio serán de bronce."
,"20":"Ordena a los israelitas que traigan aceite puro de oliva para el alumbrado continuo de las lámparas del candelabro."
,"21":"Aarón y sus hijos las mantendrán encendidas de la noche a la mañana delante del Señor, en la tienda de la reunión, en la parte de acá del velo que está delante del testimonio: ley perpetua para los israelitas en todas sus generaciones'."
}`)
	CurrentBook.AddChapter(28, `{
"1":"'Haz venir junto a ti, de en medio de los israelitas, a Aarón, tu hermano, y a sus hijos con él para que sean mis sacerdotes; Aarón, Nadab, Abihú, Eleazar e Itamar, hijos de Aarón."
,"2":"Harás para Aarón, tu hermano, vestiduras sagradas que le den gloria y majestad."
,"3":"Hablarás con hombres expertos, a quienes yo he dotado de genio artístico, para que confeccionen las vestiduras de Aarón, a fin de consagrarle para que sea mi sacerdote."
,"4":"Éstas son las vestiduras que han de preparar: un pectoral y un efod, un manto, una túnica a cuadros, una tiara y un cinturón. Harán las vestiduras sagradas para Aarón y para sus hijos a fin de que me sirvan como sacerdotes."
,"5":"Emplearán oro, púrpura violeta, escarlata y carmesí, y lino fino'."
,"6":"'El efod lo harán de oro, púrpura violeta, escarlata y carmesí, y lino fino trenzado, artísticamente recamado."
,"7":"Llevará dos hombreras de acoplamiento, con las cuales quedarán sujetas las dos puntas del efod."
,"8":"El cinturón, para sujetarlo por encima formando una sola pieza con él, será del mismo trabajo: oro, púrpura violeta, escarlata y carmesí, y lino fino trenzado."
,"9":"Tomarás dos piedras de ónice, en las que grabarás los nombres de los israelitas."
,"10":"Seis nombres en cada una por orden de nacimiento."
,"11":"Grabarás en ellas los nombres de los israelitas, como lo hace un lapidario, como se graban los sellos, y las encajarás en engarces de oro."
,"12":"Pondrás las dos piedras sobre las hombreras, como piedras de recuerdo para los israelitas. Así Aarón llevará sus nombres sobre sus hombros, ante el Señor, para recordarlos."
,"13":"Harás engarces de oro y dos cadenillas de oro puro,"
,"14":"entrelazadas a modo de cordón, y las fijarás a los engarces'."
,"15":"'Harás el pectoral del juicio, artísticamente recamado, a la manera del efod: de oro, púrpura violeta, escarlata y carmesí, y de lino trenzado."
,"16":"Será cuadrado y doble, de veintidós centímetros de lado."
,"17":"Engastarás en él piedras preciosas en cuatro filas: en la primera, un sardonio, un topacio y una esmeralda;"
,"18":"en la segunda, un rubí, un zafiro y un diamante;"
,"19":"en la tercera, un jacinto, una ágata y una amatista;"
,"20":"en la cuarta, un crisólito, un ónice y un jaspe. Todas ellas encajadas en engarces de oro."
,"21":"Éstas piedras serán doce, según los nombres de las tribus de Israel; estarán grabadas como los sellos, cada uno con su nombre, según las doce tribus."
,"22":"Harás al pectoral cadenillas entrelazadas a modo de cordón, de oro puro,"
,"23":"y dos anillos de oro, que pondrás en los dos extremos del pectoral."
,"24":"Por ellos pasarán las dos cadenillas de oro en los extremos del pectoral."
,"25":"Fijarás las dos puntas de los cordones a los dos engarces del pectoral y las engancharás a las hombreras del efod en su parte delantera."
,"26":"Harás dos anillos de oro, que pondrás en las dos puntas inferiores del pectoral, en el borde interior que queda junto al efod."
,"27":"Harás otros dos anillos de oro, que fijarás a las dos hombreras del efod en su parte inferior delantera, a ras de la juntura, por encima del cinturón del efod."
,"28":"Se unirá el pectoral, por sus anillos, a los anillos del efod, por un cordón de púrpura violeta, para que el pectoral quede sujeto por encima del cinturón del efod y no pueda desprenderse de él."
,"29":"De este modo, cuando entre Aarón en el santuario, llevará los nombres de las tribus de Israel en el pectoral del juicio, sobre su corazón, para recuerdo perpetuo ante el Señor."
,"30":"Y en el pectoral del juicio pondrás los 'urim' y los 'tummim' para que estén sobre el corazón de Aarón cuando entre a la presencia del Señor, llevando continuamente sobre el corazón, ante el Señor, el juicio de los israelitas'."
,"31":"'Harás el manto del efod todo de púrpura violeta."
,"32":"En medio de él habrá una abertura para la cabeza, como la abertura de una coraza, con un dobladillo de fino tejido todo alrededor para que no se deshilache."
,"33":"En su vuelo inferior pondrás granadas de púrpura violeta, púrpura escarlata y carmesí y, entre ellas, todo alrededor, campanillas de oro."
,"34":"Una campanilla de oro y una granada, una campanilla de oro y una granada, y así sucesivamente en la orla del manto, todo alrededor."
,"35":"Lo llevará Aarón al oficiar, para que se oiga el sonido cuando entre y salga del santuario del Señor, y no muera."
,"36":"Harás una lámina de oro puro, sobre la cual grabarás como se graban los sellos: 'Consagrado al Señor'."
,"37":"La sujetarás con un cordón de púrpura violeta, de modo que caiga sobre la tiara en su parte anterior."
,"38":"Estará sobre la frente de Aarón, que cargará con los pecados cometidos por los israelitas al hacer sus ofrendas santas. Estará continuamente sobre la frente de Aarón para que el Señor acepte sus ofrendas."
,"39":"Tejerás a cuadros la túnica, de lino; de lino harás también la tiara y el cinturón artísticamente recamado."
,"40":"Para los hijos de Aarón harás túnicas, cinturones y tiaras que les den gloria y majestad."
,"41":"Se los vestirás a Aarón y a sus hijos; y los ungirás, los investirás, los consagrarás y serán mis sacerdotes."
,"42":"Les harás, además, calzones de lino para cubrir su desnudez; llegarán desde la cintura hasta los muslos."
,"43":"Aarón y sus hijos los llevarán puestos cuando entren en la tienda de la reunión y cuando se acerquen al altar a oficiar en el santuario, para que no incurran en pecado y mueran. Ley perpetua para Aarón y para toda su descendencia'."
}`)
	CurrentBook.AddChapter(29, `{
"1":"'Esto es lo que has de hacer para consagrarlos a mi servicio como sacerdotes. Tomas un becerro y dos carneros sin defecto,"
,"2":"panes sin levadura, tortas sin levadura, amasadas con aceite, y hojaldres sin levadura, untados en aceite. Todo ello preparado con flor de harina de trigo."
,"3":"Lo pones todo junto, en el mismo canastillo, y lo presentas junto con el becerro y los dos carneros."
,"4":"Haces avanzar a Aarón y a sus hijos hasta la puerta de la tienda de la reunión, y los lavas con agua."
,"5":"Tomas las vestiduras y pones a Aarón la túnica, el manto, el efod y el pectoral, y le ciñes con el cinturón del efod."
,"6":"Le pones la tiara en la cabeza, y sobre la tiara la lámina santa."
,"7":"Tomas el óleo de la unción y lo unges derramándolo sobre su cabeza."
,"8":"Del mismo modo haces venir a sus hijos y los revistes con las túnicas;"
,"9":"ciñes la cintura a Aarón y a sus hijos y les pones las tiaras, con lo cual el sacerdocio les pertenecerá en propiedad. Ésta es la ley perpetua. De este modo consagrarás a Aarón y a sus hijos."
,"10":"Después llevas el becerro hasta la tienda de la reunión, y Aarón y sus hijos pondrán sus manos sobre su cabeza."
,"11":"Inmolas el becerro ante el Señor, a la entrada de la tienda de la reunión."
,"12":"Tomas parte de la sangre del becerro, y con el dedo untarás con ella los cuernos del altar, derramando la restante al pie del altar."
,"13":"Tomas todo el sebo que cubre las entrañas, la redecilla del hígado, los dos riñones y el sebo que los envuelve, y lo quemas sobre el altar."
,"14":"Pero la carne del becerro, su piel y su excremento lo quemas fuera del campamento. Este rito es un sacrificio por el pecado."
,"15":"Tomas después uno de los carneros, y Aarón y sus hijos pondrán sus manos sobre su cabeza."
,"16":"Inmolas el carnero, tomas su sangre y con ella rocías el altar todo alrededor."
,"17":"Descuartizas el carnero, lavas sus entrañas y sus patas, que colocarás sobre sus cuartos y cabeza,"
,"18":"y lo quemas todo sobre el altar. Es un holocausto en honor del Señor, un olor agradable, un sacrificio de fuego en honor del Señor."
,"19":"Tomas el segundo carnero, y Aarón y sus hijos pondrán sus manos sobre su cabeza."
,"20":"Luego lo inmolas, tomas de su sangre y untas con ella la ternilla de la oreja derecha de Aarón y de sus hijos, y el dedo pulgar de sus manos derechas y el de sus pies derechos, y rocías el altar todo alrededor."
,"21":"Tomas sangre de sobre el altar y óleo de la unción y asperjas a Aarón y a sus hijos y sus respectivas vestiduras. Así quedarán consagrados Aarón y sus hijos con sus vestiduras."
,"22":"Tomas después el sebo del carnero, esto es, el rabo y el sebo que recubre las entrañas, la redecilla del hígado y los dos riñones con el sebo que hay sobre ellos, junto con la pierna derecha, porque es carnero de consagración."
,"23":"Del canastillo de los panes sin levadura, que está ante el Señor, un pan, una torta amasada en aceite y un pastelillo."
,"24":"Lo pones todo en las manos de Aarón y de sus hijos, para que hagan la ceremonia del balanceo delante del Señor."
,"25":"Lo recoges luego de sus manos y lo quemas sobre el altar, sobre el holocausto, en olor agradable ante el Señor. Es un sacrificio de fuego en honor del Señor."
,"26":"Tomas el pecho del carnero de investidura, perteneciente a Aarón, y haces la ceremonia del balanceo ante el Señor. Ello será tu porción."
,"27":"De este modo consagrarás el pecho de balanceo y el muslo de elevación, esto es, lo balanceado y elevado del carnero de consagración, reservado a Aarón y a sus hijos."
,"28":"Ésta será la porción de Aarón y de sus hijos, en derecho perpetuo, por parte de los israelitas, porque es un tributo y será un tributo de los israelitas tomado de sus sacrificios de reconciliación; esto será un tributo para el Señor."
,"29":"Las vestiduras de Aarón pasarán a sus hijos, para que sean consagrados y ungidos con ellas."
,"30":"Siete días las llevará el hijo que le suceda como sacerdote y entre en la tienda de la reunión para oficiar en el santuario."
,"31":"Tomas el carnero de investidura y cueces su carne en el lugar santo."
,"32":"Aarón y sus hijos comerán la carne del carnero y los panes del canastillo a la entrada de la tienda de la reunión."
,"33":"Comerás lo que ha servido para su expiación al investirlos y consagrarlos. Pero ningún otro comerá de ello, porque es cosa santa."
,"34":"Si queda para el día siguiente algo de carne del sacrificio de investidura o de los panes, lo quemas en el fuego; no se comerá, porque es cosa santa."
,"35":"Así has de cumplir todo cuanto te he mandado respecto a Aarón y a sus hijos. Los consagrarás durante siete días,"
,"36":"y en cada uno inmolarás el becerro en sacrificio de expiación por el pecado; purificarás el altar por medio de este sacrificio de expiación, y después lo ungirás para consagrarlo."
,"37":"Durante siete días expiarás el altar y lo consagrarás; todo lo que toque el altar quedará santificado."
,"38":"'Esto es lo que ofrecerás sobre el altar: dos corderos de un año, cada día y de modo perpetuo."
,"39":"Ofreces uno por la mañana y otro por la tarde."
,"40":"Con el de la mañana ofrecerás cuatro kilos y medio de flor de harina amasada con dos litros de aceite puro de oliva y una libación de dos litros de vino."
,"41":"Por la tarde, entre dos luces, ofrecerás el segundo cordero con la misma ofrenda y libación que a la mañana, en sacrificio de olor agradable, sacrificio de fuego en honor del Señor,"
,"42":"holocausto perpetuo por todas vuestras generaciones, a la entrada de la tienda de la reunión, ante el Señor, allí donde yo me encontraré con vosotros para hablarte."
,"43":"En este lugar yo me encontraré con los israelitas, y quedará santificado por mi gloria."
,"44":"Yo consagraré la tienda de la reunión y el altar; consagraré a Aarón y a sus hijos para que me sirvan como sacerdotes."
,"45":"Habitaré en medio de los israelitas y seré su Dios."
,"46":"Ellos conocerán que yo, el Señor, soy su Dios, que los saqué de Egipto para habitar en medio de ellos; yo, el Señor, su Dios'."
}`)
	CurrentBook.AddChapter(30, `{
"1":"'Harás también un altar para quemar en él el incienso. Lo harás de madera de acacia."
,"2":"Será de medio metro de largo por medio de ancho, o sea cuadrado, y un metro de alto. Sus cuernos formarán un solo cuerpo con el altar."
,"3":"Lo recubrirás de oro puro: su mesa, sus lados todo alrededor y sus cuernos. Alrededor de él harás una moldura de oro."
,"4":"Le harás dos anillos de oro por debajo de la moldura, a sus dos flancos, para pasar por ellos las barras con que será transportado."
,"5":"Éstas las harás de madera de acacia, que recubrirás de oro."
,"6":"Pondrás el altar delante del velo que oculta el arca del testimonio, frente al propiciatorio que está sobre el testimonio, donde yo me encontraré contigo."
,"7":"En él quemará Aarón el incienso; lo quemará todas las mañanas al preparar las lámparas,"
,"8":"y todas las tardes al ponerlas sobre el candelabro, como perfume diario ante el Señor, de generación en generación."
,"9":"No me ofrecerás sobre él perfume profano, ni holocausto, ni ofrendas de vino derramado."
,"10":"Sobre sus cuernos Aarón hará el rito de absolución una vez al año; con la sangre del sacrificio del gran perdón hará el rito de absolución. Y así de generación en generación. Este altar será santísimo para el Señor'."
,"11":"El Señor dijo a Moisés:"
,"12":"'Cuando cuentes a los israelitas para hacer su censo, cada uno de los sujetos a él ofrecerá al Señor un rescate por su persona en el momento de hacer el censo, para que no venga sobre ellos plaga alguna durante el censo."
,"13":"Esto es lo que ofrecerá todo sujeto a censo: cinco gramos de plata, según el peso del santuario, como tributo al Señor."
,"14":"Todos los censados de veinte años para arriba darán este tributo al Señor."
,"15":"Ni el rico pagará más ni el pobre menos al pagar el tributo al Señor en rescate de vuestras vidas."
,"16":"Tomarás el dinero del rescate de los israelitas y lo emplearás en servicio de la tienda de la reunión, para que les sirva como recuerdo ante el Señor del rescate de sus vidas'."
,"17":"El Señor dijo a Moisés:"
,"18":"'Harás una pila de bronce, con su pie también de bronce, para las abluciones. La pondrás entre la tienda de la reunión y el altar, y la llenarás de agua,"
,"19":"con la cual Aarón y sus hijos se lavarán las manos y los pies."
,"20":"Se lavarán cuando entren en la tienda de la reunión y cuando se acerquen al altar para ejercer sus funciones, para quemar víctimas en honor del Señor, a fin de que no mueran."
,"21":"Se lavarán las manos y los pies, y no morirán. Esto será una ley perpetua para ellos, Aarón y sus hijos, de generación en generación'."
,"22":"El Señor dijo a Moisés:"
,"23":"'Procúrate aromas: seis kilos de mirra pura; la mitad, o sea tres, de cinamomo aromático, y otros tres de caña aromática;"
,"24":"seis kilos de casia, según el peso del santuario, y cuatro litros y medio de aceite de oliva."
,"25":"Con todo ello harás el óleo para la unción sagrada, un perfume aromático, trabajo de perfumista. Será el óleo para la unción sagrada."
,"26":"Con él ungirás la tienda de la reunión y el arca del testimonio,"
,"27":"la mesa con todos sus utensilios, el candelabro con todos sus utensilios, el altar de los perfumes,"
,"28":"el altar de los holocaustos con todo su instrumental y la pila con su pie."
,"29":"Santificadas así todas las cosas, serán santísimas, y todo cuanto las toque quedará santificado."
,"30":"Con él ungirás a Aarón y a sus hijos y los consagrarás para que me sirvan como sacerdotes."
,"31":"Y dirás a los israelitas: Así será el óleo de la unción sagrada para mí, de generación en generación."
,"32":"No será derramado sobre el cuerpo de hombre alguno ni copiaréis su receta; será cosa sagrada y como tal lo trataréis."
,"33":"El que componga otro según esta receta o lo derrame sobre persona profana, será extirpado de su pueblo'."
,"34":"El Señor dijo a Moisés: 'Procúrate aromas: resina, ámbar, gálbano perfumado e incienso puro, en partes iguales."
,"35":"Harás con ellos un incienso perfumado, trabajo de perfumista, salado, puro y santo."
,"36":"Pulverizarás una parte y lo pondrás delante del testimonio, en la tienda de la reunión, donde yo me encontraré contigo. Será para vosotros cosa santísima."
,"37":"No haréis para vosotros un perfume semejante a éste; será para vosotros cosa consagrada al Señor."
,"38":"El que haga otro según esta receta para perfumarse será extirpado de su pueblo'."
}`)
	CurrentBook.AddChapter(31, `{
"1":"El Señor dijo a Moisés:"
,"2":"'Mira, he llamado por su nombre a Besalel, hijo de Urí, hijo de Jur, de la tribu de Judá."
,"3":"Le he llenado del espíritu de Dios, de sabiduría, inteligencia y habilidad para toda suerte de trabajos,"
,"4":"para hacer proyectos y realizarlos en oro, plata y bronce,"
,"5":"para tallar piedras de engaste, para trabajar la madera y para llevar a cabo toda clase de trabajos."
,"6":"Le he dado por compañero a Oholiab, hijo de Ajisamac, de la tribu de Dan. Y a todos los hábiles les he infundido más habilidad para hacer todo lo que te he ordenado:"
,"7":"la tienda de la reunión, el arca del testimonio, el propiciatorio que está sobre ella y todos los utensilios del tabernáculo:"
,"8":"la mesa y sus utensilios, el candelabro de oro puro y todos sus utensilios, el altar de los perfumes,"
,"9":"el altar de los holocaustos y todos sus utensilios, la pila con su pie,"
,"10":"las vestiduras sagradas para Aarón y para sus hijos en orden a las funciones sacerdotales,"
,"11":"el óleo de la unción y el perfume aromático para el santuario. Todo esto lo han de hacer conforme yo te he mandado'."
,"12":"El Señor dijo a Moisés:"
,"13":"'Di a los israelitas: Guardaréis mis sábados, porque eso es una señal establecida entre mí y vosotros por todas vuestras generaciones, para que sepáis que yo soy el Señor, que os santifica."
,"14":"Guardaréis el sábado, porque es una cosa santa. Todo el que lo profane será castigado con la muerte, porque todo el que en él trabaje será extirpado de su pueblo."
,"15":"Durante seis días se puede trabajar, pero el séptimo será día de descanso absoluto, consagrado al Señor."
,"16":"Los israelitas guardarán el sábado, de generación en generación, como alianza perpetua."
,"17":"Será entre mí y los israelitas una señal perpetua, porque en seis días hizo el Señor el cielo y la tierra, y el séptimo cesó y descansó'."
,"18":"Cuando el Señor terminó de hablar a Moisés en la montaña del Sinaí, le dio las dos tablas de la ley, tablas de piedra, escritas por el dedo de Dios."
}`)
	CurrentBook.AddChapter(32, `{
"1":"El pueblo, viendo que Moisés tardaba en bajar de la montaña, se reunió en torno a Aarón y le dijo: 'Anda, haznos un Dios que vaya delante de nosotros, porque ese Moisés, el hombre que nos ha sacado de Egipto, no sabemos qué ha sido de él'."
,"2":"Aarón les respondió: 'Recoged los pendientes de oro que vuestras mujeres, vuestros hijos y vuestras hijas llevan en las orejas, y traédmelos'."
,"3":"Todo el pueblo se desprendió de los pendientes que llevaba en las orejas y se los llevó a Aarón."
,"4":"Éste los tomó en sus manos, los fundió, los trabajó a cincel e hizo un becerro. Ellos dijeron: 'Israel, ahí tienes a tu Dios, el que te sacó de Egipto'."
,"5":"Aarón, al ver esto, edificó un altar ante el becerro y anunció: 'Mañana, fiesta en honor del Señor'."
,"6":"Al día siguiente se levantaron temprano y ofrecieron holocaustos y sacrificios de reconciliación. El pueblo se sentó a comer y beber y se levantaron después para divertirse."
,"7":"El Señor dijo a Moisés: 'Anda, baja, porque tu pueblo, al que has sacado de Egipto, se ha pervertido."
,"8":"Bien pronto se han apartado del camino que yo les había trazado; han hecho un becerro fundido y lo han adorado; le han ofrecido sacrificios y han dicho: Israel, éste es tu Dios, el que te sacó de Egipto'."
,"9":"El Señor añadió a Moisés: 'Ya veo lo que es este pueblo, un pueblo de cabeza dura."
,"10":"Déjame que se encienda mi ira contra ellos y los aniquile, mientras que de ti haré un gran pueblo'."
,"11":"Moisés aplacó al Señor, su Dios, diciendo: '¿Por qué, oh Señor, se ha de encender tu ira contra tu pueblo, al que sacaste de Egipto con gran fuerza y con mano poderosa?"
,"12":"¿Por qué van a poder decir los egipcios: Con muy mala intención los hizo salir, para hacerlos perecer en las montañas y exterminarlos de la superficie de la tierra? Aplaca tu ira y arrepiéntete de la amenaza contra tu pueblo."
,"13":"Acuérdate de Abrahán, de Isaac y de Jacob, tus siervos, a quienes juraste por ti mismo diciendo: Yo multiplicaré vuestra descendencia como las estrellas del cielo y toda esta tierra, de que os he hablado, se la daré a vuestra descendencia en posesión perpetua'."
,"14":"Y el Señor se retractó del mal que había dicho que iba a hacer a su pueblo."
,"15":"Moisés volvió y bajó de la montaña con las dos tablas de la ley en sus manos, escritas por los dos lados, en sus dos caras."
,"16":"Las tablas eran obra del Señor, y la escritura, escritura del Señor grabada en las tablas."
,"17":"Josué oyó el fuerte griterío del pueblo y dijo a Moisés: 'Grito de guerra hay en el campamento'."
,"18":"Moisés respondió: 'No es griterío de victoria, ni griterío de derrota; es griterío de canto'."
,"19":"Al acercarse al campamento y ver el becerro y las danzas, enfurecido, tiró las tablas y las rompió al pie de la montaña."
,"20":"Tomó el becerro que habían hecho, lo quemó y lo trituró hasta reducirlo a polvo, esparciéndolo en agua, que hizo beber a los israelitas."
,"21":"Moisés dijo a Aarón: '¿Qué te ha hecho este pueblo para que hayas acarreado sobre él tan gran pecado?'."
,"22":"Aarón respondió: 'No se encienda la ira de mi señor. Tú mismo sabes que este pueblo es muy inclinado al mal."
,"23":"Me dijeron: Haznos un Dios que vaya delante de nosotros, porque ese Moisés, que nos ha sacado de la tierra de Egipto, no sabemos qué ha sido de él."
,"24":"Yo les he dicho: El que tenga oro, que se desprenda de él. Me lo han dado, lo eché en el fuego y ha salido este becerro'."
,"25":"Moisés, al ver que el pueblo andaba sin freno, y que Aarón lo había abandonado hasta hacerlo la irrisión de sus enemigos,"
,"26":"se plantó en la puerta del campamento y dijo: 'Los partidarios del Señor, que vengan conmigo'. Y se reunieron en torno a él todos los hijos de Leví."
,"27":"Les dijo: 'Cíñase cada uno la propia espada al muslo. Recorred el campamento de una punta a otra y matad cada uno a su hermano, a su amigo, a su pariente'."
,"28":"Los levitas cumplieron la orden de Moisés, y aquel día cayeron unos tres mil hombres del pueblo."
,"29":"Moisés dijo: 'Recibid hoy la investidura de parte del Señor, cada uno al precio de su hijo y de su hermano, y que él os dé hoy la bendición'."
,"30":"Al día siguiente, Moisés dijo al pueblo: 'Habéis cometido un gran pecado. Sin embargo, yo voy a subir al Señor; quizá alcance perdón para vuestro pecado'."
,"31":"Moisés volvió al Señor y dijo: '¡Ay! Este pueblo ha cometido un gran pecado. Se han fabricado un dios de oro."
,"32":"¡Si tú quisieras, a pesar de todo, perdonar su pecado! Si no, bórrame del libro que has escrito'."
,"33":"El Señor dijo a Moisés: 'Al que ha pecado contra mí le borraré de mi libro."
,"34":"Ahora anda, conduce al pueblo al lugar que te he ordenado. Mi ángel irá delante de ti. Pero en el día de mi visita los castigaré por su pecado'."
,"35":"Y el Señor castigó al pueblo por el becerro de oro fabricado por Aarón."
}`)
	CurrentBook.AddChapter(33, `{
"1":"El Señor dijo a Moisés: 'Anda, sube de aquí, tú y el pueblo que has sacado de Egipto, a la tierra que juré dar a Abrahán, Isaac y Jacob, diciendo: Se la daré a tu descendencia."
,"2":"Yo enviaré un ángel delante de ti y echaré al cananeo, al amorreo, al hitita, al fereceo, al heveo y al jebuseo;"
,"3":"sube a la tierra que mana leche y miel; pero yo no subiré en medio de ti, porque eres un pueblo de cabeza dura, y yo te aniquilaría por el camino'."
,"4":"El pueblo oyó estas duras palabras e hizo duelo; nadie se vistió de gala."
,"5":"El Señor dijo a Moisés: 'Di a los israelitas: Vosotros sois un pueblo de cabeza dura; si por un solo momento subiese en medio de vosotros, os aniquilaría. Quítate, pues, tus galas, que yo sabré cómo he de tratarte'."
,"6":"Los israelitas se despojaron de sus galas a partir del monte Horeb."
,"7":"Moisés tomó la tienda y la plantó fuera del campamento, a cierta distancia, y la llamó 'tienda de la reunión'. Todo el que quería dirigirse al Señor, salía a la tienda de la reunión, emplazada fuera del campamento."
,"8":"Cada vez que Moisés se dirigía a la tienda, todo el pueblo se levantaba y se quedaba de pie a la entrada de su tienda, siguiendo con la vista a Moisés hasta que éste entraba en la tienda."
,"9":"Cuando Moisés entraba en la tienda, la columna de nube bajaba y se paraba a la entrada de la tienda, y el Señor hablaba con Moisés."
,"10":"El pueblo, al ver la columna de nube a la entrada de la tienda, se levantaba y se prosternaba, cada uno a la puerta de su tienda."
,"11":"El Señor hablaba a Moisés cara a cara, como se habla entre amigos. Luego Moisés volvía al campamento; pero Josué, su ministro, hijo de Nun, joven todavía, no se apartaba de la tienda."
,"12":"Moisés dijo al Señor: 'Bien, tú me dices: Conduce a este pueblo, pero no me has dado a conocer a quién mandarás conmigo. Y, no obstante, me has dicho: Yo te conozco por tu nombre, tú has hallado gracia a mis ojos."
,"13":"Pero si de verdad he hallado gracia a tus ojos, dame a conocer tu camino, para que yo te conozca; así hallaré gracia a tus ojos. Considera que este pueblo es tu pueblo'."
,"14":"El Señor respondió: 'Yo mismo iré contigo y te daré descanso'."
,"15":"Moisés dijo: 'Si no vienes tú mismo en persona, no nos hagas partir de aquí."
,"16":"¿Cómo ha de conocerse que tu pueblo y yo hemos hallado gracia a tus ojos? Solamente si tú vienes con nosotros y haces que tu pueblo y yo seamos una nación distinta entre todos los pueblos de la tierra'."
,"17":"El Señor dijo a Moisés: 'También haré eso que acabas de decir, porque has hallado gracia a mis ojos y porque te conozco por tu nombre'."
,"18":"Moisés dijo: 'Concédeme ver tu gloria'."
,"19":"Él dijo: 'Yo haré pasar delante de ti toda mi grandeza y proclamaré ante ti el nombre de El Señor, pues yo hago gracia a quien quiero y tengo misericordia con quien quiero'."
,"20":"Y añadió: 'Pero mi rostro no puedes verlo. Nadie puede verme y quedar con vida'."
,"21":"Siguió: 'Aquí hay un lugar junto a mí; ponte sobre la roca."
,"22":"Cuando esté mi gloria al pasar, te meteré en la hendidura de la roca y te cubriré con mi mano hasta que yo haya pasado."
,"23":"Luego retiraré mi mano y me verás de espaldas, mas mi rostro no puede verse'."
}`)
	CurrentBook.AddChapter(34, `{
"1":"El Señor dijo a Moisés: 'Prepárate dos tablas de piedra, como las primeras que tú rompiste; voy a escribir en ellas las palabras de las otras."
,"2":"Procura estar listo para mañana; sube de madrugada a la montaña del Sinaí y allí, en su cumbre, preséntate a mí."
,"3":"Que nadie suba contigo, ni se vea a nadie en toda la montaña, ni siquiera ovejas o bueyes pastando'."
,"4":"Moisés se hizo con dos tablas como las primeras, se levantó de madrugada y subió a la montaña del Sinaí, como se lo había mandado el Señor, llevando consigo las dos tablas de piedra."
,"5":"El Señor bajó en la nube y se paró junto a él, y Moisés proclamó el nombre de El Señor."
,"6":"El Señor pasó delante de él y proclamó: 'El Señor, el Señor, Dios clemente y misericordioso, tardo para la ira y lleno de lealtad y fidelidad,"
,"7":"que conserva su fidelidad a mil generaciones y perdona la iniquidad, la infidelidad y el pecado, pero que nada deja impune, castigando la maldad de los padres en los hijos y en los nietos, hasta la tercera y cuarta generación'."
,"8":"Moisés se echó al instante en tierra y, adorando, dijo:"
,"9":"'Si de verdad he hallado gracia a tus ojos, Señor, que el Señor marche en medio de nosotros; porque éste es un pueblo de cabeza dura; pero tú perdona nuestra iniquidad y nuestro pecado y tómanos por tu heredad'."
,"10":"El Señor respondió: 'Mira, yo establezco una alianza; voy a hacer a la vista de todo el pueblo maravillas como no se han hecho nunca en toda la tierra, ni entre nación alguna; todo el pueblo, en medio del cual estás, verá la obra del Señor, porque es tremendo lo que yo voy a hacer contigo."
,"11":"Mira bien lo que hoy te mando: voy a echar delante de ti al amorreo, al cananeo, al hitita, al fereceo, al heveo y al jebuseo."
,"12":"No hagas pacto alguno con los habitantes de la tierra en la que vas a entrar, para que no te hagan caer en sus redes."
,"13":"Antes bien, destruid sus altares, romped sus estelas, destrozad sus cipos."
,"14":"No adorarás a otro Dios, porque el nombre del Señor es Celoso y él es un Dios celoso."
,"15":"No harás pacto alguno con los habitantes de la tierra, no sea que ellos, al prostituirse ante sus dioses para ofrecerles sacrificios, te inviten y comas de sus sacrificios."
,"16":"No tomarás de entre sus hijas mujeres para tus hijos, pues ellas se prostituirán ante sus dioses y arrastrarán a tus hijos a prostituirse también ante ellos."
,"17":"No te fabricarás dios alguno de metal fundido."
,"18":"Guardarás la fiesta de los panes sin levadura. Siete días comerás panes sin levadura, como te he mandado, en el tiempo prefijado del mes de abib, porque en el mes de abib saliste de Egipto."
,"19":"Todo primogénito me pertenece, y también todo primer nacido macho de tus ganados, ovejas o vacas."
,"20":"El primogénito del asno lo rescatarás con un cordero; y si no lo rescatas, lo desnucarás. Rescatarás todo primogénito entre tus hijos, y nadie se presentará ante mí con las manos vacías."
,"21":"Seis días trabajarás y en el séptimo descansarás; descansarás incluso en tiempo de la labranza y de la siega."
,"22":"Guardarás la fiesta de las semanas, la de las primicias de la siega del trigo y la fiesta de la recolección al terminar el año."
,"23":"Tres veces al año todo varón se presentará ante el Señor, Dios de Israel."
,"24":"Yo echaré a las naciones delante de ti, ensancharé tus fronteras y nadie codiciará tu tierra cuando subas a presentarte ante el Señor, tu Dios, tres veces al año."
,"25":"No ofrecerás con pan fermentado la sangre de mi sacrificio, ni permanecerá hasta la mañana siguiente la víctima de la fiesta de la pascua."
,"26":"Llevarás a la casa del Señor, tu Dios, lo más florido de las primicias de tu tierra. No cocerás un cabrito en la leche de su madre'."
,"27":"El Señor dijo a Moisés: 'Escribe estas palabras, porque en base a ellas yo hago alianza contigo y con Israel'."
,"28":"Moisés estuvo arriba con el Señor cuarenta días y cuarenta noches, sin comer ni beber. Y el Señor escribió en las tablas las palabras de la alianza, las diez palabras."
,"29":"Cuando Moisés bajó de la montaña del Sinaí trayendo en sus manos las dos tablas de la ley, no sabía que la tez de su cara se había vuelto radiante durante sus conversaciones con el Señor."
,"30":"Aarón y todos los israelitas, al ver a Moisés, notaron que su rostro resplandecía, y no se atrevieron a acercarse a él."
,"31":"Moisés los llamó; Aarón y los jefes de la comunidad se acercaron a él, y Moisés les habló."
,"32":"Después se acercaron a él todos los israelitas, y Moisés les ordenó todo lo que le había dicho el Señor en la montaña del Sinaí."
,"33":"Y cuando terminó de hablar con ellos, se puso un velo en la cara."
,"34":"Cada vez que Moisés entraba en la presencia del Señor para hablar con él, se quitaba el velo hasta que salía y, una vez afuera, comunicaba a los israelitas todo lo que se le había ordenado."
,"35":"Los israelitas dirigían su mirada a la cara de Moisés y veían su piel radiante. Y Moisés volvía a poner el velo en su cara hasta que entraba de nuevo a hablar con el Señor."
}`)
	CurrentBook.AddChapter(35, `{
"1":"Moisés reunió a toda la asamblea de los israelitas y les dijo: 'Éstas son las órdenes del Señor:"
,"2":"Seis días se trabajará, pero el séptimo será para vosotros un día sagrado, el sábado, descanso absoluto en honor del Señor. Todo el que trabaje en ese día, será condenado a muerte."
,"3":"No encenderéis fuego en vuestras casas el día del sábado'."
,"4":"Moisés dijo a toda la asamblea de los israelitas: 'Éstas son las órdenes del Señor:"
,"5":"Ofreced de vuestros bienes un tributo al Señor. Todo corazón generoso ofrecerá un tributo al Señor: oro, plata y bronce,"
,"6":"púrpura violeta, escarlata y carmesí, lino fino y pelo de cabra,"
,"7":"pieles de carnero teñidas en rojo, pieles de tejón y madera de acacia,"
,"8":"aceite para el candelabro, aromas para el óleo de la unción y el incienso perfumado,"
,"9":"piedras de ónice y de engaste para el efod y el pectoral."
,"10":"Que los hombres habilidosos acudan para ejecutar todo lo que el Señor ha ordenado:"
,"11":"el tabernáculo, su tienda y su cubierta, sus anillos y sus tablones, sus barras, sus columnas y sus lazos,"
,"12":"el arca y sus barras, el propiciatorio y el velo de separación,"
,"13":"la mesa con sus barras y todos sus utensilios y los panes de la proposición,"
,"14":"el candelabro con sus utensilios, sus lámparas y el aceite;"
,"15":"el altar de los perfumes y sus barras; el óleo de la unción y el incienso perfumado y la cortina de entrada al tabernáculo;"
,"16":"el altar de los holocaustos y su enrejado de bronce, sus barras y todo su instrumental, y la pila con su pie;"
,"17":"las cortinas del atrio, sus columnas y sus basas y la cortina de entrada al atrio;"
,"18":"las estacas del tabernáculo y del atrio con sus cuerdas;"
,"19":"las vestiduras preciosas para el servicio del santuario, las vestiduras sagradas para el sacerdote Aarón y las vestiduras de sus hijos para los ministerios sacerdotales'."
,"20":"Toda la asamblea de los israelitas se retiró de la presencia de Moisés."
,"21":"Y todos los voluntarios, todos los de corazón generoso, vinieron con sus tributos al Señor, para la obra de la tienda de la reunión, para todo su servicio y para las vestiduras sagradas."
,"22":"Vinieron hombres y mujeres. Todos los generosos de corazón trajeron arillos y pendientes, anillos y cadenillas, brazaletes y toda clase de objetos de oro. Cada uno presentó al Señor una ofrenda de oro."
,"23":"Todos los que tenían púrpura violeta, escarlata y carmesí, lino, pelo de cabra, pieles de cordero teñidas en rojo y pieles de tejón, las trajeron."
,"24":"El que podía ofrecer tributo de plata o bronce, lo trajo como tributo al Señor; y quien tenía madera de acacia, útil para cualquier trabajo, la trajo también."
,"25":"Toda mujer habilidosa hilaba con sus manos y traía sus hilados de púrpura violeta, escarlata y carmesí y lino fino."
,"26":"Todas las mujeres que sabían hilar, hilaron los pelos de cabra."
,"27":"Los jefes del pueblo trajeron las piedras de ónice y de engaste para el efod y el pectoral;"
,"28":"los aromas y el aceite para el candelabro, para el óleo de la unción y para el perfume aromático."
,"29":"De este modo todos los hombres y mujeres que se sintieron generosos en contribuir a las obras que el Señor había mandado hacer a Moisés trajeron sus ofrendas voluntarias al Señor."
,"30":"Moisés dijo a los israelitas: 'Mirad, el Señor ha llamado por su nombre a Besalel, hijo de Urí, hijo de Jur, de la tribu de Judá,"
,"31":"y le ha llenado del espíritu de Dios, de sabiduría, inteligencia y habilidad para toda suerte de trabajos;"
,"32":"para hacer proyectos y realizarlos en oro, plata y bronce,"
,"33":"para grabar piedras de engaste, para tallar la madera y para llevar a cabo toda clase de trabajos."
,"34":"Ha dado también el don de enseñanza a él y a Oholiab, hijo de Ajisamac, de la tribu de Dan."
,"35":"Los ha llenado de habilidad para ejecutar toda obra de engaste, de ebanistería, recamado y tejido en púrpura violeta, escarlata y carmesí, y lino para proyectar y realizar toda clase de trabajos."
}`)
	CurrentBook.AddChapter(36, `{
"1":"Besalel, Oholiab y todos los hombres expertos, en los que el Señor ha puesto habilidad e inteligencia para toda clase de trabajos, ejecutarán toda la obra del santuario, según lo ha ordenado el Señor'."
,"2":"Moisés llamó a Besalel, a Oholiab y a todos los hombres que el Señor había dotado de sabiduría y se habían ofrecido voluntariamente a colaborar en la obra."
,"3":"Recibieron de manos de Moisés todas las ofrendas que los israelitas habían traído para la construcción del santuario. Los israelitas seguían llevando espontáneamente sus ofrendas todas las mañanas; "
,"4":"tanto que los artífices que llevaban a cabo la obra del santuario, interrumpiendo su tarea, se presentaron a Moisés y le dijeron:"
,"5":"'El pueblo trae mucho más de lo que es preciso para la realización de la obra que el Señor ha mandado hacer'."
,"6":"Entonces Moisés dispuso que se corriera esta orden por el campamento: 'Nadie traiga más ofrendas para el santuario'. Así se impidió al pueblo hacer nuevas aportaciones,"
,"7":"porque tenían ya material suficiente, y aun sobrante, para la obra que había de hacerse."
,"8":"Los más hábiles entre los participantes en la obra fabricaron el tabernáculo con diez cortinas de lino fino trenzado con púrpura violeta, escarlata y carmesí, artísticamente recamado, con figuras de querubines."
,"9":"Cada cortina medía doce metros y medio de largo por dos de ancho. La misma medida para todas."
,"10":"Juntaron las cortinas una con otra en dos conjuntos de a cinco."
,"11":"Pusieron los lazos color violeta en el borde de las dos cortinas que terminaban cada uno de los dos conjuntos."
,"12":"Cincuenta lazos en cada una, correspondiéndose los lazos entre sí."
,"13":"Hicieron cincuenta corchetes de oro, y con ellos unieron las cortinas entre sí, de modo que el tabernáculo formaba un solo cuerpo."
,"14":"Hicieron once cortinas de pelo de cabra, a modo de tienda sobre el tabernáculo;"
,"15":"cada cortina medía quince metros de largo por dos de ancho. La misma medida para las once."
,"16":"Y las unieron en dos conjuntos, el primero de cinco y el segundo de seis."
,"17":"Pusieron cincuenta lazos en el borde de cada una de las dos cortinas que terminaban ambos conjuntos."
,"18":"Hicieron cincuenta garfios de bronce, con los que juntaron la tienda formando un solo cuerpo."
,"19":"Hicieron para la tienda una cubierta de pieles de carnero teñidas en rojo, y sobre ella otra de pieles de tejón."
,"20":"Hicieron para el tabernáculo los tablones de madera de acacia puestos de pie."
,"21":"Cada uno de cinco metros de largo por setenta y cinco centímetros de ancho."
,"22":"Cada tablón, con dos espigas unidas entre sí; así se hicieron todos los tablones del tabernáculo."
,"23":"Los colocaron así: veinte para el lado sur;"
,"24":"y debajo de ellos pusieron cuarenta basas de plata, dos debajo de cada uno, para sus espigas."
,"25":"Otros veinte para el lado norte,"
,"26":"con sus cuarenta basas de plata, dos debajo de cada uno."
,"27":"En el fondo del tabernáculo, en su parte oeste, seis tablones,"
,"28":"más otros dos para los ángulos de atrás."
,"29":"Éstos eran dobles de abajo arriba hasta el primer anillo. Así dos tablones para los ángulos."
,"30":"Eran en total ocho tablones con dieciséis basas de plata, dos debajo de cada tablón."
,"31":"Hicieron también travesaños de madera de acacia, cinco para los tablones de uno de los lados del tabernáculo,"
,"32":"cinco para los del otro y otros cinco para los del fondo, en la parte oeste,"
,"33":"y el travesaño de en medio, que pasaba a la mitad de la altura de los tablones de un extremo a otro."
,"34":"Recubrieron los tablones de oro, hicieron también de oro sus anillos para pasar por ellos las barras, asimismo recubiertas de oro."
,"35":"Hicieron el velo de lino fino trenzado, artísticamente recamado, de púrpura violeta, escarlata y carmesí, con figuras de querubines."
,"36":"Hicieron para él cuatro columnas de acacia con sus garfios de oro. Las recubrieron de oro y fundieron para ellas cuatro basas de plata."
,"37":"Hicieron para la entrada de la tienda una cortina de lino fino trenzado, artísticamente recamada, de púrpura violeta, escarlata y carmesí."
,"38":"Llevaba cinco columnas con sus respectivos garfios y con sus capiteles y anillos recubiertos de oro. Sus cinco basas estaban recubiertas de bronce."
}`)
	CurrentBook.AddChapter(37, `{
"1":"Besalel hizo el arca de madera de acacia, de un metro y veinticinco centímetros de largo por setenta y cinco centímetros de ancho y setenta y cinco de alto."
,"2":"La recubrió de oro puro por dentro y por fuera, y le hizo una moldura."
,"3":"Fundió para ella cuatro anillos de oro para sus cuatro pies, dos a un lado y dos a otro."
,"4":"Hizo las barras de madera de acacia, las recubrió de oro"
,"5":"y las pasó por los anillos de los lados del arca para poder llevarla."
,"6":"Hizo el propiciatorio de oro puro, de un metro y veinticinco centímetros de largo por setenta y cinco centímetros de ancho."
,"7":"Los dos querubines, de oro batido, los puso en los dos extremos del propiciatorio,"
,"8":"uno en cada extremo, formando un solo cuerpo con él"
,"9":"con las alas extendidas hacia arriba, cubriendo con ellas el propiciatorio, y sus rostros uno frente al otro, mirando al propiciatorio."
,"10":"Hizo la mesa de madera de acacia, de un metro de larga por medio de ancha y setenta y cinco centímetros de alta."
,"11":"La recubrió de oro y le hizo una moldura de oro todo alrededor."
,"12":"Añadió también en su alrededor un travesaño de oro de veinticinco centímetros de ancho con una moldura de oro."
,"13":"Fundió para ella cuatro anillos de oro, que colocó en las esquinas de las cuatro patas."
,"14":"Estos anillos, por donde pasaban las barras para transportarla, estaban junto al travesaño."
,"15":"Las barras para llevarla las hizo de madera de acacia y las recubrió de oro."
,"16":"Hizo la vajilla de la mesa, platos, cucharas, copas y tazas para las libaciones, todo ello de oro puro."
,"17":"Hizo el candelabro de oro puro forjado; su base, fuste, copas, cálices y pétalos hacían un solo cuerpo."
,"18":"Seis brazos salían de sus lados, tres de uno y tres de otro."
,"19":"Cada brazo tenía tres copas en forma de flor de almendro, con su cáliz y pétalos; los seis brazos, que arrancaban del fuste del candelabro, eran iguales."
,"20":"El fuste del candelabro tenía cuatro copas en forma de flor de almendro con su cáliz y pétalos;"
,"21":"cada una de las tres parejas de brazos tenía un cáliz en su parte inferior; los seis exactamente igual."
,"22":"Los cálices y los brazos hacían un solo cuerpo con el candelabro, y todo el conjunto era de oro puro forjado."
,"23":"Hizo las siete lámparas con sus despabiladeras y sus platillos de oro puro."
,"24":"Empleó treinta y tres kilos de oro puro para hacer el candelabro y sus utensilios."
,"25":"Hizo el altar de los perfumes de madera de acacia, de medio metro de largo por medio de ancho, o sea, cuadrado, y un metro de alto. Sus cuernos formaban un solo cuerpo en el altar."
,"26":"Recubrió de oro puro su mesa, sus lados todo alrededor y sus cuernos. Le hizo alrededor una moldura de oro"
,"27":"y, por debajo de ella, a sus dos flancos, le hizo dos anillos de oro por donde se pasaban las barras para transportarlo."
,"28":"Éstas las hizo de madera de acacia y las recubrió de oro."
,"29":"Hizo luego el óleo de la unción y el incienso perfumado, trabajo de perfumista."
}`)
	CurrentBook.AddChapter(38, `{
"1":"Hizo el altar de los holocaustos de madera de acacia, cuadrado, de dos metros y medio de largo por dos y medio de ancho y uno y medio de alto."
,"2":"Le puso cuernos a sus cuatro lados, formando un solo cuerpo, y lo recubrió de bronce."
,"3":"Hizo también todos sus utensilios, calderos, paletas, aspersorios, tenazas y braseros, todo de bronce."
,"4":"Le hizo, además, un enrejado de bronce en forma de red por debajo del reborde, desde abajo hasta la mitad del altar."
,"5":"Fundió cuatro anillos para las cuatro aristas del enrejado de bronce para pasar por ellos las barras."
,"6":"Éstas las hizo de madera de acacia y las recubrió de oro,"
,"7":"y las pasó por los anillos de los cuatro ángulos del altar para llevarlo con ellas. El altar lo hizo hueco, de tablas."
,"8":"Hizo de bronce la pila y su pie, con los espejos de las mujeres que velaban a la entrada de la tienda de la reunión."
,"9":"Hizo el atrio. En el lado sur llevaba cincuenta metros de cortinas de lino fino trenzado"
,"10":"y veinte columnas con sus respectivas basas de bronce. Los garfios de las columnas y sus anillos eran de plata."
,"11":"En el lado norte llevaba cincuenta metros de cortinas y veinte columnas con sus respectivas basas de bronce. Los garfios de las columnas y sus anillos eran de plata."
,"12":"En el lado oeste llevaba veinticinco metros de cortinas y diez columnas con sus respectivas basas. Los garfios de las columnas y sus anillos eran de plata."
,"13":"En el lado este llevaba veinticinco metros de cortinas;"
,"14":"siete metros y medio de cortinas con sus tres columnas y sus tres basas,"
,"15":"en cada uno de sus dos lados."
,"16":"Todas las cortinas del atrio, en todos sus lados, eran de lino fino trenzado;"
,"17":"las basas para las columnas eran de bronce; sus garfios y sus anillos y la moldura de sus capiteles, de plata. Todas las columnas del atrio llevaban anillos de plata."
,"18":"En la entrada del atrio había una cortina en púrpura violeta, escarlata y carmesí, de lino fino trenzado, artísticamente recamado, de diez metros de larga por dos y medio de alta, igual que las cortinas del atrio."
,"19":"Sus cuatro columnas y sus cuatro basas eran de bronce; y los garfios, el revestimiento de sus capiteles y los anillos, de plata."
,"20":"Todas las estacas del tabernáculo y del recinto del atrio eran de bronce."
,"21":"Ésta es la suma de lo empleado para el tabernáculo; el tabernáculo del testimonio, llevado a cabo por los levitas por orden de Moisés y bajo la dirección de Itamar, hijo de Aarón, el sacerdote."
,"22":"Besalel, hijo de Urí, hijo de Jur, de la tribu de Judá, hizo todo lo que el Señor había ordenado a Moisés,"
,"23":"juntamente con Oholiab, hijo de Ajisamac, de la tribu de Dan, herrero, diseñador y bordador de púrpura violeta, escarlata y carmesí, y lino."
,"24":"Todo el oro empleado en la obra para la construcción del santuario, procedente de las ofrendas, fue de unos mil ciento cincuenta y cinco kilos, según el peso del santuario."
,"25":"La plata recogida en el censo de la comunidad sumó unos tres mil seiscientos veinte kilos, según el peso del santuario."
,"26":"Seis gramos por cabeza, según el peso del santuario, para los sujetos al censo, de veinte años para arriba, que sumaban seiscientos tres mil quinientos cincuenta."
,"27":"Unos tres mil cuatrocientos cincuenta kilos de plata se gastaron en la fundición de las basas del santuario y de la cortina, cien basas, a treinta y cuatro kilos y medio por basa."
,"28":"Con el resto se hicieron los garfios de las columnas, se recubrieron de oro sus capiteles y se las rodeó de anillos."
,"29":"El bronce de las ofrendas ascendió a unos dos mil cuatrocientos treinta kilos."
,"30":"Con ellos se hicieron las basas de la entrada de la tienda de la reunión, el altar de bronce con su enrejado y todos sus utensilios,"
,"31":"las basas del recinto del atrio, las de la puerta del atrio y todas las estacas del tabernáculo y del recinto del atrio."
}`)
	CurrentBook.AddChapter(39, `{
"1":"De púrpura violeta, escarlata y carmesí confeccionaron las vestiduras preciosas para el servicio del santuario y las vestiduras sagradas de Aarón, según el Señor había ordenado a Moisés."
,"2":"Hicieron el efod de oro y de lino fino trenzado, en púrpura violeta, escarlata y carmesí."
,"3":"Machacaron el oro, haciéndolo láminas, que cortaron en hilos para entrelazarlos, en púrpura violeta, escarlata y carmesí, y lino fino trenzado, artísticamente recamado."
,"4":"Le hicieron las hombreras de acoplamiento, con las cuales quedaban sujetas las dos puntas del efod,"
,"5":"y el cinturón para sujetarlo por encima, formando una sola pieza con él, del mismo trabajo: oro, púrpura violeta, escarlata y carmesí, y lino fino trenzado, como el Señor había mandado a Moisés."
,"6":"Tallaron las piedras de ónice, encajadas en engarces de oro, y en ellas grabaron los nombres de los israelitas, al modo como se graban los sellos,"
,"7":"y las pusieron sobre las hombreras del efod, como recuerdo para los israelitas, como el Señor había ordenado a Moisés."
,"8":"Hicieron el pectoral de la misma manera que el efod, de oro y lino fino trenzado, artísticamente recamado en púrpura violeta, escarlata y carmesí."
,"9":"Era cuadrado y doble, de veintidós centímetros de lado."
,"10":"Engastaron en él cuatro filas de piedras: en la primera fila, un sardonio, un topacio y una esmeralda;"
,"11":"en la segunda, un rubí, un zafiro y un diamante;"
,"12":"en la tercera, un jacinto, una ágata y una amatista;"
,"13":"en la cuarta, un crisólito, un ónice y un jaspe. Todas ellas encajadas en engarces de oro."
,"14":"Las piedras eran doce, según los nombres de las doce tribus de Israel, grabadas al modo como se graban los sellos, cada una con su nombre, según las doce tribus."
,"15":"Hicieron cadenillas entrelazadas a modo de cordón, de oro puro,"
,"16":"dos engarces de oro y dos anillos de oro, que pusieron en los dos extremos del pectoral."
,"17":"Pasaron las dos cadenillas por los dos anillos en los dos extremos del pectoral,"
,"18":"y sus dos puntas las fijaron en los dos engarces de las hombreras del efod, en su parte delantera."
,"19":"Hicieron otros dos anillos de oro, que pusieron en las dos puntas inferiores del pectoral, en el borde interior que queda junto al efod."
,"20":"Y otros dos anillos más, de oro, que colocaron en las hombreras del efod en su parte inferior delantera, a ras de la juntura, por encima del cinturón del efod."
,"21":"Sujetaron el pectoral, uniendo sus anillos a los anillos del efod con un cordón de púrpura violeta para que quedase sujeto por encima del cinturón del efod y no se desprendiese de él, como el Señor había mandado a Moisés."
,"22":"Hicieron el manto del efod todo de púrpura violeta,"
,"23":"con una abertura en medio como la de una coraza, con un dobladillo de fino tejido para que no se deshilachase."
,"24":"Adornaron el vuelo inferior con granadas de lino fino trenzado, en púrpura violeta, escarlata y carmesí."
,"25":"Y alternando con ellas, todo alrededor, campanillas de oro,"
,"26":"una campanilla y una granada, y así sucesivamente, en la orla del manto, para oficiar, como el Señor había ordenado a Moisés."
,"27":"Para Aarón y sus hijos hicieron las túnicas de lino fino,"
,"28":"la tiara, los adornos de los turbantes, los calzones y"
,"29":"el cinturón, también de lino fino, artísticamente recamado en púrpura violeta, escarlata y carmesí, como el Señor había mandado a Moisés."
,"30":"Hicieron de oro puro la lámina de la santa diadema; grabaron en ella, como se graban los sellos: 'Consagrado al Señor',"
,"31":"y la sujetaron, con un cordón de púrpura violeta, en lo alto, sobre la tiara, como el Señor había mandado a Moisés."
,"32":"Así se llevó a cabo toda la obra del santuario, o sea, la tienda de la reunión. Los israelitas habían ejecutado todo lo que el Señor había mandado a Moisés."
,"33":"Entonces presentaron a Moisés el tabernáculo, la tienda y todos sus utensilios: los garfios, las barras, los travesaños, las columnas, las basas,"
,"34":"la cubierta de pieles de carnero teñidas en rojo, la cubierta de pieles de tejón y el velo de separación;"
,"35":"el arca del testimonio con sus barras y el propiciatorio;"
,"36":"la mesa con toda su vajilla y los panes de la proposición;"
,"37":"el candelabro de oro con sus lámparas ordenadamente dispuestas y todos sus utensilios y aceite para las lámparas;"
,"38":"el altar de oro; el óleo de la unción, el incienso perfumado y la cortina para la entrada del tabernáculo;"
,"39":"el altar de bronce con su enrejado también de bronce, sus barras y todo su instrumental, y la pila con su pie;"
,"40":"las cortinas del atrio, sus columnas y sus basas; la cortina de la entrada del atrio, sus cuerdas y sus estacas y todos los utensilios del servicio del tabernáculo para la tienda de la reunión;"
,"41":"las vestiduras preciosas para el ministerio en el lugar sagrado y las vestiduras sagradas de Aarón y de sus hijos para ejercer el sacerdocio."
,"42":"Los israelitas habían ejecutado todos los trabajos tal y como el Señor había mandado a Moisés."
,"43":"Éste examinó después toda la obra, y constató que los israelitas la habían ejecutado como el Señor se lo había mandado; y Moisés los bendijo."
}`)
	CurrentBook.AddChapter(40, `{
"1":"El Señor habló a Moisés así:"
,"2":"'El día primero del primer mes levantarás el tabernáculo de la tienda de la reunión"
,"3":"y pondrás en él el arca del testimonio, que cubrirás con el velo."
,"4":"Pondrás en él la mesa, sobre la que ordenarás su menaje; llevarás también el candelabro y pondrás en él las lámparas."
,"5":"Pondrás el altar de oro para el perfume delante del arca del testimonio y colgarás la cortina de la entrada del tabernáculo."
,"6":"Pondrás el altar de los holocaustos delante del tabernáculo de la tienda de la reunión."
,"7":"Pondrás la pila entre la tienda de la reunión y el altar y echarás agua en ella."
,"8":"Levantarás el atrio en derredor y colgarás la cortina de la entrada del atrio."
,"9":"Tomarás el óleo de la unción y ungirás el tabernáculo y todo lo que hay en él; lo consagrarás y será el altar santísimo."
,"10":"Ungirás también el altar de los holocaustos con todo su instrumental, lo consagrarás y será altar santísimo."
,"11":"Ungirás asimismo la pila con su pie y la consagrarás."
,"12":"Después harás venir a Aarón y a sus hijos ante la puerta de la tienda de la reunión y los lavarás con agua."
,"13":"Revestirás a Aarón con las vestiduras sagradas, le ungirás y le consagrarás para que ejerza el sacerdocio en mi servicio."
,"14":"Harás que se acerquen sus hijos y los revestirás con sus túnicas."
,"15":"Luego los ungirás, como has ungido a su padre, para que ejerzan el sacerdocio en mi servicio. Y su unción les conferirá el sacerdocio perpetuamente por todas sus generaciones'."
,"16":"Y Moisés lo llevó todo a cabo; como se lo había mandado el Señor, así lo hizo."
,"17":"El día uno del primer mes del año segundo quedó levantado el tabernáculo;"
,"18":"lo instaló Moisés poniendo los tablones, las barras, los travesaños, y levantó las columnas."
,"19":"Desplegó la tienda sobre el tabernáculo y puso sobre ella la cubierta, como el Señor le había mandado."
,"20":"Tomó el testimonio, y lo metió dentro del arca, a la que acomodó sus barras, y encima de ella colocó el propiciatorio."
,"21":"Llevó el arca al tabernáculo y colgó el velo de separación, ocultando el arca del testimonio, como el Señor se lo había mandado."
,"22":"Puso la mesa en la tienda de la reunión, al lado norte del tabernáculo, por fuera del velo,"
,"23":"y colocó ordenadamente sobre ella los panes de la proposición ante la presencia del Señor, como el Señor le había mandado a Moisés."
,"24":"Puso el candelabro en la tienda de la reunión, frente a la mesa, al lado sur del tabernáculo,"
,"25":"y colocó en él las lámparas, como el Señor le había mandado."
,"26":"Puso el altar de oro en la tienda de la reunión delante del velo"
,"27":"y quemó en él el incienso perfumado, como el Señor le había mandado."
,"28":"Colgó la cortina de la entrada del tabernáculo."
,"29":"Puso el altar de los holocaustos a la entrada del tabernáculo de la tienda de la reunión y en él ofreció el holocausto y la ofrenda, como el Señor le había mandado."
,"30":"Puso la pila entre la tienda de la reunión y el altar, echó agua en ella para lavarse"
,"31":"y en ella se lavaron manos y pies Moisés, Aarón y sus hijos."
,"32":"Cada vez que entraban en la tienda de la reunión y se acercaban al altar, se lavaban, como el Señor había mandado a Moisés."
,"33":"Levantó finalmente el atrio en torno al tabernáculo y al altar y colgó la cortina de la entrada del atrio. Así completó Moisés toda la obra."
,"34":"Entonces la nube cubrió la tienda de la reunión, y la gloria del Señor llenó el tabernáculo."
,"35":"Moisés no podía entrar en la tienda de la reunión, porque la nube se había posado encima y la gloria del Señor llenaba el tabernáculo."
,"36":"Cuando la nube se alzaba del tabernáculo, los israelitas emprendían la marcha para cubrir cada una de las etapas de su viaje."
,"37":"Si la nube no se alzaba, no se ponían en marcha hasta que se alzase."
,"38":"La nube del Señor se posaba de día sobre el tabernáculo, y durante la noche brillaba como fuego a la vista de toda la casa de Israel en todas las etapas del viaje."
}`)

}
func ES_LSB_LoadVPGNChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Al principio Dios creó el cielo y la tierra."
,"2":"La tierra era soledad y caos, y las tinieblas cubrían el abismo; y el espíritu de Dios aleteaba sobre las aguas."
,"3":"Dios dijo: 'Haya luz', y hubo luz."
,"4":"Vio Dios que la luz era buena, y la separó de las tinieblas;"
,"5":"y llamó a la luz día, y a las tinieblas noche. Hubo así tarde y mañana: día primero."
,"6":"Y Dios dijo: 'Haya un firmamento entre las aguas, que separe las unas de las otras'; y así fue:"
,"7":"Dios hizo el firmamento, separando por medio de él las aguas que hay debajo de las que hay sobre él."
,"8":"Dios llamó al firmamento cielo. Hubo tarde y mañana: día segundo."
,"9":"Dios dijo: 'Reúnanse en un solo lugar las aguas inferiores y aparezca lo seco'; y así fue."
,"10":"Dios llamó a lo seco tierra, y a la masa de las aguas llamó mares. Vio Dios que esto estaba bien."
,"11":"Dios dijo: 'Produzca la tierra vegetación: plantas con semilla de su especie y árboles frutales que den sobre la tierra frutos que contengan la semilla de su especie'; y así fue."
,"12":"La tierra produjo vegetación: plantas con semilla de su especie y árboles frutales que contienen la semilla propia de su especie. Vio Dios que esto estaba bien."
,"13":"Hubo tarde y mañana: día tercero."
,"14":"Dios dijo: 'Haya lumbreras en el firmamento que separen el día de la noche, sirvan de signos para distinguir las estaciones, los días y los años,"
,"15":"y luzcan en el firmamento del cielo para iluminar la tierra'. Y así fue:"
,"16":"Dios hizo dos lumbreras grandes, la mayor para gobierno del día, y la menor para gobierno de la noche, y las estrellas."
,"17":"Dios las puso en el firmamento del cielo para iluminar la tierra,"
,"18":"regular el día y la noche y separar la luz de las tinieblas. Vio Dios que esto estaba bien."
,"19":"Hubo tarde y mañana: día cuarto."
,"20":"Dios dijo: 'Pulule en las aguas un hormigueo de seres vivientes y revoloteen las aves por encima de la tierra y cara al firmamento del cielo'."
,"21":"Dios creó los grandes monstruos marinos, todos los seres vivientes que se mueven y pululan en las aguas según su especie, y el mundo volátil según su especie. Vio Dios que esto estaba bien."
,"22":"Dios los bendijo diciendo: 'Sed fecundos, multiplicaos y llenad las aguas del mar, y multiplíquense las aves sobre la tierra'."
,"23":"Hubo tarde y mañana: día quinto."
,"24":"Dios dijo: 'Produzca la tierra animales vivientes según su especie: ganados, reptiles y bestias salvajes según su especie'. Y así fue."
,"25":"Dios hizo las bestias de la tierra, los ganados y los reptiles campestres, cada uno según su especie. Vio Dios que esto estaba bien."
,"26":"Dios dijo: 'Hagamos al hombre a nuestra imagen y semejanza. Domine sobre los peces del mar, las aves del cielo, los ganados, las fieras campestres y los reptiles de la tierra'."
,"27":"Dios creó al hombre a su imagen, a imagen de Dios los creó, macho y hembra los creó."
,"28":"Dios los bendijo y les dijo: 'Sed fecundos y multiplicaos, poblad la tierra y sometedla; dominad sobre los peces del mar, las aves del cielo y cuantos animales se mueven sobre la tierra'."
,"29":"Y añadió: 'Yo os doy toda planta sementífera que hay sobre la superficie de la tierra y todo árbol que da fruto conteniendo simiente en sí. Ello será vuestra comida."
,"30":"A todos los animales del campo, a las aves del cielo y a todos los reptiles de la tierra, a todo ser viviente, yo doy para comida todo herbaje verde'. Y así fue."
,"31":"Vio Dios todo lo que había hecho, y he aquí que todo estaba muy bien. Hubo tarde y mañana: día sexto."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Así fueron acabados el cielo y la tierra y todos sus elementos."
,"2":"Dios dio por terminada su obra el séptimo día, y en este día descansó de toda su obra."
,"3":"Dios bendijo el día séptimo y lo santificó, porque en él había descansado de toda la obra de su actividad creadora."
,"4":"Tal fue el origen del cielo y de la tierra cuando fueron creados. Cuando el Señor hizo el cielo, "
,"5":"no había todavía arbusto alguno del campo sobre la tierra, ni había germinado hierba alguna, porque el Señor Dios no había hecho todavía llover sobre la tierra, ni había hombre que cultivase el suelo."
,"6":"Pero un manantial brotaba de la tierra y regaba toda la superficie del suelo."
,"7":"El Señor Dios formó al hombre del polvo de la tierra, le insufló en sus narices un hálito de vida y así el hombre llegó a ser un ser viviente."
,"8":"El Señor Dios plantó un jardín en Edén, al oriente, y en él puso al hombre que había formado."
,"9":"El Señor Dios hizo germinar del suelo toda clase de árboles agradables a la vista y apetitosos para comer, el árbol de la vida, en medio del jardín, y el árbol de la ciencia del bien y del mal."
,"10":"Un río salía de Edén para regar el jardín, y de allí se dividía en cuatro brazos."
,"11":"El primero se llama Pisón, y es el que rodea toda la tierra de Javilá, donde hay oro;"
,"12":"el oro de este país es puro; en él hay también bedelio y ágata."
,"13":"El segundo, de nombre Guijón, circunda toda la tierra de Cus."
,"14":"El tercero, de nombre Tigris, discurre al oriente de Asiria. El cuarto es el Éufrates."
,"15":"El Señor Dios tomó al hombre y le puso en el jardín de Edén para que lo cultivase y lo guardase."
,"16":"El Señor Dios dio al hombre este mandato: 'Puedes comer de todos los árboles del jardín;"
,"17":"pero del árbol de la ciencia del bien y del mal no comerás, porque el día en que comas, ciertamente morirás'."
,"18":"El Señor Dios dijo: 'No es bueno que el hombre esté solo; le daré una ayuda apropiada'."
,"19":"El Señor Dios formó de la tierra todos los animales del campo y todas las aves del cielo y los llevó ante el hombre para ver cómo los llamaba, ya que el nombre que él les diera, ése sería su nombre."
,"20":"El hombre impuso nombre a todos los ganados, a todas las aves del cielo y a todas las bestias del campo; pero para sí mismo no encontró una ayuda apropiada."
,"21":"Entonces el Señor Dios hizo caer sobre el hombre un sueño profundo, y mientras dormía le quitó una de sus costillas, poniendo carne en su lugar."
,"22":"De la costilla tomada del hombre, el Señor Dios formó a la mujer y se la presentó al hombre,"
,"23":"el cual exclamó: 'Ésta sí que es hueso de mis huesos y carne de mi carne; ésta será llamada hembra porque ha sido tomada del hombre'."
,"24":"Por eso el hombre deja a su padre y a su madre y se une a su mujer, y son los dos una sola carne."
,"25":"Los dos estaban desnudos, el hombre y su mujer, sin avergonzarse uno del otro."
}`)
	CurrentBook.AddChapter(3, `{
"1":"La serpiente era el más astuto de todos los animales del campo que el Señor Dios había hecho. Y dijo a la mujer: '¿Es cierto que os ha dicho Dios: No comáis de ningún árbol del jardín?'."
,"2":"La mujer respondió a la serpiente: 'Nosotros podemos comer del fruto de los árboles del jardín."
,"3":"Sólo del fruto del árbol que está en medio del jardín nos ha dicho Dios: No comáis de él, ni lo toquéis siquiera, bajo pena de muerte'."
,"4":"Entonces la serpiente dijo a la mujer: '¡No, no moriréis!"
,"5":"Antes bien, Dios sabe que en el momento en que comáis se abrirán vuestros ojos y seréis como dioses, conocedores del bien y del mal'."
,"6":"La mujer vio que el árbol era apetitoso para comer, agradable a la vista y deseable para adquirir sabiduría. Tomó, pues, de su fruto y comió; dio también de él a su marido, que estaba junto a ella, y él también comió."
,"7":"Entonces se abrieron sus ojos, y se dieron cuenta de que estaban desnudos; cosieron unas hojas de higuera y se hicieron unos taparrabos."
,"8":"Oyeron después los pasos del Señor Dios, que se paseaba por el jardín a la brisa de la tarde, y el hombre y su mujer se escondieron de su vista entre los árboles del jardín."
,"9":"Pero el Señor Dios llamó al hombre y le dijo: '¿Dónde estás?'."
,"10":"Y éste respondió: 'Oí tus pasos por el jardín, me entró miedo porque estaba desnudo, y me escondí'."
,"11":"El Señor Dios prosiguió: '¿Quién te ha hecho saber que estabas desnudo? ¿No habrás comido del árbol del que te prohibí comer?'."
,"12":"El hombre respondió: 'La mujer que me diste por compañera me dio del árbol y comí'."
,"13":"El Señor Dios dijo a la mujer: '¿Qué es lo que has hecho?'. Y la mujer respondió: 'La serpiente me engañó y comí'."
,"14":"El Señor Dios dijo a la serpiente: 'Por haber hecho esto, maldita seas entre todos los ganados,y entre todas las bestias del campo. Te arrastrarás sobre tu vientre,y comerás del polvo de la tierra,todos los días de tu vida."
,"15":"Yo pongo enemistad entre ti,y la mujer, entre tu linaje y el suyo; él te aplastará la cabeza,y tú sólo tocarás su calcañal'."
,"16":"A la mujer le dijo: 'Multiplicaré los trabajos de tus preñeces. Con dolor parirás a tus hijos; tu deseo te arrastrará hacia tu marido, que te dominará'."
,"17":"Al hombre le dijo: 'Por haber hecho caso a tu mujer,y por haber comido,del árbol prohibido, maldita sea la tierra por tu culpa. Con trabajo sacarás de ella,tu alimento todo el tiempo de tu vida."
,"18":"Ella te dará espinas y cardos, y comerás la hierba de los campos."
,"19":"Con el sudor de tu frente,comerás el pan,hasta que vuelvas a la tierra, pues de ella fuiste sacado; porque polvo eres,y en polvo te has de convertir'."
,"20":"El hombre llamó Eva a su mujer, porque ella fue la madre de todos los vivientes."
,"21":"El Señor Dios hizo al hombre y a su mujer unas túnicas de piel y los vistió."
,"22":"Después dijo: '¡He ahí al hombre, que ha llegado a ser como uno de nosotros por el conocimiento del bien y del mal! ¡No vaya ahora a tender su mano y tome del árbol de la vida, y comiendo de él viva para siempre!'."
,"23":"El Señor Dios lo expulsó del jardín de Edén para que trabajase la tierra de la que había sido sacado."
,"24":"Expulsó al hombre, y puso delante del jardín de Edén los querubines y la llama de la espada flameante para guardar el camino del árbol de la vida."
}`)
	CurrentBook.AddChapter(4, `{
"1":"El hombre tuvo relaciones con su mujer, Eva, la cual concibió, dio a luz a Caín y dijo: 'He tenido un hombre gracias al Señor'."
,"2":"Tuvo después a su hermano Abel. Abel fue pastor, y Caín agricultor."
,"3":"Pasado algún tiempo, Caín presentó al Señor una ofrenda de los frutos de la tierra."
,"4":"También Abel le ofreció los primogénitos más selectos de su rebaño. El Señor miró complacido a Abel y su ofrenda,"
,"5":"pero vio con desagrado a Caín y su ofrenda. Caín entonces se encolerizó y su rostro se descompuso."
,"6":"El Señor le dijo: '¿Por qué te encolerizas, te muestras malhumorado y vas con la cabeza baja?"
,"7":"Si obraras bien, ¿no alzarías la cabeza?; en cambio, si obras mal, el pecado está a las puertas de tu casa y te acosa sin que puedas contenerlo'."
,"8":"Caín dijo a su hermano Abel: 'Vamos al campo'. Cuando se encontraron en el campo, Caín atacó a su hermano Abel y le mató."
,"9":"El Señor preguntó a Caín: '¿Dónde está tu hermano?', y él respondió: 'No lo sé. ¿Es que soy yo el guardián de mi hermano?'."
,"10":"El Señor le dijo: '¿Qué has hecho? La voz de la sangre de tu hermano grita de la tierra hasta mí."
,"11":"Por tanto, maldito seas lejos de la tierra que ha abierto sus fauces para empaparse con la sangre de tu hermano derramada por ti."
,"12":"Cuando cultives la tierra, no te dará ya sus frutos. Andarás errante y vagabundo sobre la tierra'."
,"13":"Caín dijo al Señor: 'Mi iniquidad es tan grande que no puedo soportarla."
,"14":"Tú me echas de aquí y tengo que ocultarme a tu mirada; errante y vagabundo andaré sobre la tierra, y cualquiera que me encuentre me matará'."
,"15":"El Señor le dijo: 'No será así; si alguien mata a Caín, lo pagará siete veces'. Y el Señor puso una señal a Caín para que si alguien lo encontraba, no lo matara."
,"16":"Caín se alejó de la presencia del Señor y habitó en el país de Nod, al oriente de Edén."
,"17":"Caín tuvo relaciones con su mujer, la cual concibió y dio a luz a Henoc. Más tarde se puso a construir una ciudad, a la que dio el nombre de su hijo Henoc."
,"18":"A Henoc le nació Irad, y éste engendró a Mejuyael. Mejuyael engendró a Metusael, y éste a Lamec."
,"19":"Lamec tuvo dos mujeres, una se llamaba Ada y la otra Sila."
,"20":"Ada dio a luz a Yabal, el antepasado de los que habitan en tiendas y crían ganado."
,"21":"El nombre de su hermano fue Yubal, el antepasado de los que tocan la cítara y la flauta."
,"22":"Sila, por su parte, parió a Tubalcaín, forjador de todo género de instrumentos de bronce y de hierro. Hermana de Tubalcaín fue Naamá."
,"23":"Lamec dijo a sus mujeres: 'Ada y Sila, escuchadme; mujeres de Lamec, prestad oído a mis palabras: Por una herida maté a un hombre, y a un joven por una contusión."
,"24":"Caín será vengado siete veces; Lamec lo será setenta y siete'."
,"25":"Adán tuvo de nuevo relaciones con su mujer, y ésta dio a luz un hijo, a quien puso por nombre Set, 'porque Dios, dijo, me ha dado otro descendiente en lugar de Abel, al que mató Caín'."
,"26":"Set engendró también un hijo, al que puso el nombre de Enós. Entonces comenzó a invocarse el nombre del Señor."
}`)
	CurrentBook.AddChapter(5, `{
"1":"He aquí la lista de los descendientes de Adán. Cuando Dios creó al hombre lo hizo a imagen de Dios."
,"2":"Los creó macho y hembra, los bendijo y les puso el nombre de 'hombre' el día de su creación."
,"3":"Adán, a la edad de ciento treinta años, engendró un hijo a su imagen, según su semejanza, y le llamó Set."
,"4":"Después de engendrar a Set vivió todavía Adán ochocientos años, y engendró hijos e hijas."
,"5":"Adán vivió en total novecientos treinta años, y murió."
,"6":"Set, a la edad de ciento cinco años, engendró a Enós;"
,"7":"y después de haber engendrado a Enós, vivió todavía ochocientos siete años, y engendró hijos e hijas."
,"8":"Set vivió en total novecientos doce años, y murió."
,"9":"Enós, a la edad de noventa años, engendró a Quenán;"
,"10":"y después de haber engendrado a Quenán, vivió todavía ochocientos quince años, y engendró hijos e hijas."
,"11":"Enós vivió en total novecientos cinco años, y murió."
,"12":"Quenán, a la edad de setenta años, engendró a Mahalalel;"
,"13":"y después de haber engendrado a Mahalalel, vivió todavía ochocientos cuarenta años, y engendró hijos e hijas."
,"14":"Quenán vivió en total novecientos diez años, y murió."
,"15":"Mahalalel, a la edad de sesenta y cinco años, engendró a Yéred;"
,"16":"y después de haber engendrado a Yéred, vivió todavía ochocientos treinta años, y engendró hijos e hijas."
,"17":"Mahalalel vivió en total ochocientos noventa y cinco años, y murió."
,"18":"Yéred, a la edad de ciento sesenta y dos años, engendró a Henoc;"
,"19":"y después de haber engendrado a Henoc, vivió todavía ochocientos años, y engendró hijos e hijas."
,"20":"Yéred vivió en total novecientos sesenta y dos años, y murió."
,"21":"Henoc, a la edad de sesenta y cinco años, engendró a Matusalén;"
,"22":"y después de haber engendrado a Matusalén, siguió los caminos de Dios trescientos años, y engendró hijos e hijas."
,"23":"Henoc vivió en total trescientos sesenta y cinco años,"
,"24":"y siguió los caminos de Dios; después no fue visto más, porque Dios se lo llevó."
,"25":"Matusalén, a la edad de ciento ochenta y siete años, engendró a Lamec;"
,"26":"y después de haber engendrado a Lamec, vivió todavía setecientos ochenta y dos años, y engendró hijos e hijas."
,"27":"Matusalén vivió en total novecientos sesenta y nueve años, y murió."
,"28":"Lamec, a la edad de ciento ochenta y dos años, tuvo un hijo,"
,"29":"al que llamó Noé, diciendo: 'Él nos consolará en nuestro trabajo y en la fatiga que impone a nuestras manos la tierra maldecida por el Señor'."
,"30":"Lamec, después de haber engendrado a Noé, vivió todavía quinientos noventa y cinco años, y engendró hijos e hijas."
,"31":"Lamec vivió en total setecientos setenta y siete años, y murió."
,"32":"Noé, a la edad de quinientos años, engendró a Sem, Cam y Jafet."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Cuando los hombres comenzaron a multiplicarse sobre la tierra y les nacieron hijas,"
,"2":"los hijos de Dios vieron que las hijas de los hombres eran hermosas, y tomaron por esposas las que más les gustaron."
,"3":"El Señor dijo: 'Mi espíritu no permanecerá por siempre en el hombre, porque es de carne. Sus días serán ciento veinte años'."
,"4":"En aquel entonces había gigantes en la tierra (y también después), cuando los hijos de Dios se unieron a las hijas de los hombres, y ellas les daban hijos. Éstos son los héroes de antaño, hombres famosos."
,"5":"Al ver el Señor que la maldad de los hombres sobre la tierra era muy grande y que siempre estaban pensando en hacer el mal,"
,"6":"se arrepintió de haber creado al hombre sobre la tierra, y con gran dolor"
,"7":"dijo: 'Exterminaré de la superficie de la tierra al hombre que he creado, hombres y animales, reptiles y aves del cielo, todo lo exterminaré, pues me pesa haberlos hecho'."
,"8":"Pero Noé encontró gracia a los ojos del Señor."
,"9":"Ésta es la historia de Noé: Noé era un hombre justo, íntegro, y entre sus compañeros seguía los caminos de Dios."
,"10":"Engendró tres hijos: Sem, Cam y Jafet."
,"11":"La tierra estaba corrompida delante de Dios y toda ella llena de violencia."
,"12":"Dios miró a la tierra, y vio que estaba corrompida, porque todo mortal había corrompido su camino sobre ella."
,"13":"Dios dijo a Noé: 'He decidido acabar con todo ser viviente, porque la tierra está llena de violencia por culpa de los hombres. Voy a exterminarlos a todos ellos juntamente con la tierra."
,"14":"Hazte un arca de maderas resinosas, divídela en compartimientos y calafatéala con pez por dentro y por fuera."
,"15":"Éstas serán sus dimensiones: ciento cincuenta metros de largo, veinticinco de ancho y quince de alto."
,"16":"Harás arriba un tragaluz, a medio metro del remate. A un lado harás la puerta, y en el arca harás tres pisos."
,"17":"Yo voy a enviar sobre la tierra un diluvio de aguas para destruir a todo ser viviente que hay bajo el cielo. Todo cuanto hay sobre la tierra morirá."
,"18":"Contigo, en cambio, estableceré un pacto: Entrarás en el arca tú y tu mujer, tus hijos y sus mujeres."
,"19":"De todos los seres vivientes meterás contigo en el arca una pareja de cada especie, macho y hembra, para que sobrevivan contigo."
,"20":"De cada especie de aves, de animales y de reptiles entrará contigo una pareja, para salvaguardar la vida."
,"21":"Y, por tu parte, procúrate todo aquello que pueda serviros de alimento tanto a ti como a ellos'."
,"22":"Noé lo hizo así, exactamente como Dios le había mandado."
}`)
	CurrentBook.AddChapter(7, `{
"1":"El Señor dijo a Noé: 'Entra en el arca tú con toda tu familia, porque tú eres el único hombre justo que he encontrado en esta generación."
,"2":"De todos los animales puros toma siete parejas, machos y hembras, y de los impuros toma sólo una pareja, macho y hembra;"
,"3":"de las aves del cielo, siete parejas, con el fin de conservar la especie sobre la tierra."
,"4":"Porque dentro de siete días haré llover sobre la tierra por espacio de cuarenta días y cuarenta noches y exterminaré sobre ella todos los seres que he hecho'."
,"5":"Noé hizo todo cuanto Dios le había mandado."
,"6":"Noé tenía seiscientos años cuando vino el diluvio sobre la tierra."
,"7":"Noé, con su mujer, sus hijos y las mujeres de sus hijos, entró en el arca para librarse de las aguas del diluvio."
,"8":"Los animales puros e impuros, las aves y los reptiles,"
,"9":"entraron con Noé en el arca por parejas, como había ordenado Dios."
,"10":"Pasados los siete días, las aguas del diluvio cayeron sobre la tierra."
,"11":"Era el año seiscientos de la vida de Noé, el día diecisiete del mes segundo, cuando irrumpieron todas las fuentes del abismo y se abrieron las compuertas del cielo."
,"12":"Y la lluvia cayó sobre la tierra por espacio de cuarenta días y cuarenta noches."
,"13":"Aquel mismo día, Noé entró en el arca con sus hijos Sem, Cam y Jafet, con su mujer y las mujeres de sus tres hijos."
,"14":"Y con ellos, todas las especies de bestias salvajes, ganados, reptiles y aves."
,"15":"Después de Noé, entró en el arca una pareja de todo ser viviente,"
,"16":"un macho y una hembra de cada especie, tal y como se lo había ordenado Dios. Y el Señor cerró la puerta detrás de Noé."
,"17":"El diluvio duró cuarenta días sobre la tierra; las aguas, siempre en crecida, levantaron en alto el arca, que flotaba sobre las aguas."
,"18":"Las aguas crecieron y aumentaron sobre la tierra, mientras el arca continuaba flotando sobre su superficie."
,"19":"Tanto crecieron las aguas sobre la tierra, que llegaron a cubrir todos los montes más altos que hay bajo el cielo."
,"20":"Las aguas subieron siete metros y medio por encima de los montes más altos."
,"21":"Perecieron todos los seres vivientes que se mueven en la tierra, aves, ganados, bestias salvajes y toda la humanidad;"
,"22":"todo lo que tiene hálito de vida en sus narices, todo lo que habita la tierra seca, todo pereció."
,"23":"Todos los seres vivientes sobre la superficie de la tierra fueron exterminados; hombres y bestias salvajes, reptiles y aves del cielo desaparecieron de la tierra. Únicamente quedó Noé y los que estaban con él en el arca."
,"24":"La inundación de las aguas sobre la tierra duró ciento cincuenta días."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Dios se acordó de Noé y de todas las bestias y ganados que estaban con él en el arca. Hizo pasar un viento sobre la tierra, y bajaron las aguas."
,"2":"Se cerraron las fuentes del abismo y las compuertas del cielo, y cesó de caer lluvia."
,"3":"Las aguas fueron retirándose gradualmente de la tierra; al cabo de ciento cincuenta días comenzaron a bajar,"
,"4":"y el día diecisiete del séptimo mes el arca quedó anclada sobre los montes de Ararat."
,"5":"Las aguas siguieron bajando hasta el mes décimo, y el primer día de este mes aparecieron las cimas de los montes."
,"6":"Al cabo de cuarenta días, Noé abrió la ventana que había hecho en el arca"
,"7":"y soltó un cuervo, el cual estuvo volando, yendo y viniendo, hasta que se secaron las aguas sobre la tierra."
,"8":"Después soltó una paloma, para ver si se habían secado las aguas sobre la superficie de la tierra."
,"9":"La paloma, no encontrando dónde posarse, volvió de nuevo al arca, porque las aguas cubrían la superficie de toda la tierra. Noé sacó la mano, la agarró y la metió en el arca."
,"10":"Esperó siete días más, y de nuevo soltó la paloma fuera del arca."
,"11":"Y por la tarde volvió, trayendo en su pico una rama de olivo. Así conoció Noé que las aguas no cubrían ya la superficie de la tierra."
,"12":"Esperó otros siete días, y de nuevo soltó la paloma, que ya no volvió más."
,"13":"El año seiscientos uno de la vida de Noé, el día uno del primer mes, se secaron las aguas sobre la superficie de la tierra. Noé levantó la cubierta del arca, miró y vio que la superficie de la tierra estaba seca."
,"14":"El día veintisiete del segundo mes la tierra estaba completamente seca."
,"15":"Dios habló a Noé y le dijo:"
,"16":"'Sal del arca tú, tu mujer, tus hijos y tus nueras."
,"17":"Saca también todos los animales que están contigo: aves, ganados y reptiles: que llenen la tierra, que crezcan y que se multipliquen sobre ella'."
,"18":"Salió, pues, Noé con sus hijos, su mujer y sus nueras."
,"19":"Y todas las bestias salvajes, los ganados, las aves y los reptiles salieron también del arca por especies."
,"20":"Noé levantó un altar al Señor y, tomando de todos los animales puros y de todas las aves puras, ofreció holocaustos sobre él."
,"21":"El Señor aspiró el perfume agradable, y se dijo: 'No maldeciré más la tierra por causa del hombre, porque los impulsos del corazón del hombre tienden al mal desde su adolescencia; jamás volveré a castigar a los seres vivientes como acabo de hacerlo."
,"22":"Mientras dure la tierra, sementera y cosecha, frío y calor, verano e invierno, día y noche,no cesarán más'."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Dios bendijo a Noé y a sus hijos, y les dijo: 'Sed fecundos, multiplicaos y llenad la tierra."
,"2":"Todos los animales de la tierra os temerán y os respetarán; las aves del cielo, todo lo que se mueve sobre la tierra y todos los peces del mar están en vuestras manos."
,"3":"Todo cuanto se mueve y tiene vida os servirá de alimento. Yo os lo doy, como antes os di las verduras."
,"4":"Sólo una cosa no debéis comer: carne que tenga aún dentro su vida, esto es, su sangre."
,"5":"Yo pediré cuenta estrecha de la sangre de cada uno de vosotros; se la pediré a los animales y al hombre: a cada uno le pediré cuenta de la vida de su hermano."
,"6":"Quien derrame sangre de hombre,verá la suya derramada por el hombre, porque Dios,ha hecho al hombre a su imagen."
,"7":"Vosotros sed fecundos, multiplicaos, llenad la tierra,y dominadla'."
,"8":"Dios dijo a Noé y a sus hijos:"
,"9":"'Yo establezco mi pacto con vosotros, con vuestros descendientes después de vosotros"
,"10":"y con todos los seres vivientes que hay entre vosotros: aves, ganados, bestias del campo, todos los animales que salieron con vosotros del arca."
,"11":"Éste es mi pacto con vosotros: Ningún ser viviente volverá a ser exterminado por las aguas del diluvio, ni volverá a haber diluvio que arrase la tierra'."
,"12":"Y añadió: 'Ésta será la señal del pacto que pongo entre mí y vosotros y todos los seres vivientes que hay entre vosotros, por todas las generaciones futuras."
,"13":"Yo pongo mi arco iris en las nubes, y él será la señal de la alianza entre mí y la tierra."
,"14":"Cuando cubra de nubes la tierra, aparecerá el arco iris,"
,"15":"me acordaré de mi alianza con vosotros y con todos los vivientes de la tierra, y las aguas no volverán a ser un diluvio que arrase la tierra."
,"16":"El arco iris aparecerá en las nubes, y yo, al verlo, me acordaré de mi pacto perpetuo entre Dios y todos los seres vivientes de la tierra'."
,"17":"Dios dijo a Noé: 'Tal es la señal del pacto que acabo de establecer entre mí y todos los seres vivientes de la tierra'."
,"18":"Los hijos de Noé salidos del arca fueron Sem, Cam y Jafet. Cam es el padre de Canaán."
,"19":"Estos tres eran los hijos de Noé, y por ellos fue poblada toda la tierra."
,"20":"Noé fue agricultor y plantó una viña."
,"21":"Bebió de su vino, se emborrachó y se quedó desnudo en el interior de la tienda."
,"22":"Cam, padre de Canaán, vio la desnudez de su padre y corrió afuera a decírselo a sus hermanos."
,"23":"Sem y Jafet tomaron un manto, se lo echaron sobre la espalda y, yendo hacia atrás, vuelto el rostro, cubrieron, sin verla, la desnudez de su padre."
,"24":"Cuando Noé despertó de su borrachera, se enteró de lo que había hecho su hijo menor,"
,"25":"y dijo: '¡Maldito sea Canaán! Sea el último de los esclavos de sus hermanos'."
,"26":"Y añadió: '¡Bendito sea el Señor, Dios de Sem! ¡Que Canaán sea su esclavo!"
,"27":"¡Haga Dios que se propague Jafet, que habite en la tienda de Sem y que Canaán sea su esclavo!'."
,"28":"Noé vivió trescientos cincuenta años después del diluvio."
,"29":"El total de sus días fue de novecientos cincuenta años, y murió."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Ésta es la descendencia de los hijos de Noé: Sem, Cam y Jafet, a quienes nacieron hijos después del diluvio."
,"2":"Hijos de Jafet: Gómer, Magog, Maday, Yaván, Tubal, Mésec y Tirás."
,"3":"Hijos de Gómer: Asquenaz, Rifat y Togarma."
,"4":"Hijos de Yaván: Elisá y Tarsis, chipriotas y rodenses."
,"5":"A partir de éstos se hizo la repartición de las naciones en las islas: cada uno con su tierra según su lengua y su nación, según su familia."
,"6":"Hijos de Cam: Etiopía, Egipto, Put y Canaán."
,"7":"Hijos de Etiopía: Sebá, Javilá, Sabtá, Ramá y Sabtecá. Hijos de Ramá: Sebá y Dedán."
,"8":"Etiopía engendró a Nemrod, que fue el primer héroe sobre la tierra,"
,"9":"un cazador valiente delante del Señor; de ahí el proverbio: 'Cazador valeroso delante del Señor como Nemrod'."
,"10":"Los comienzos de su imperio fueron: Babel, Erec, Acad y Calno, en tierra de Senaar."
,"11":"De esta región salió Asur, que edificó Nínive, Rejobot-Ir, Calaj"
,"12":"y Resen, entre Nínive y Calaj. Ésta fue la ciudad más grande."
,"13":"Egipto engendró a los lidios, los anamitas, los lehabitas, los naftujitas,"
,"14":"los patrositas, los caslujitas y los cretenses, de los que salieron los filisteos."
,"15":"Canaán engendró a Sidón, su primogénito; luego a Het,"
,"16":"y a los jebuseos, amorreos, guirgaseos,"
,"17":"heveos, arquitas, sinitas,"
,"18":"arvadeos, semareos y jamateos. Los cananeos se dispersaron;"
,"19":"su territorio se extendió desde Sidón, en dirección de Guerar, hasta Gaza; luego en dirección de Sodoma, Gomorra, Adama y Seboín, hasta Lesa."
,"20":"Tales fueron los hijos de Cam según sus clanes, lenguas, países y naciones."
,"21":"Sem, padre de Héber y hermano mayor de Jafet, tuvo hijos."
,"22":"Fueron éstos: Elán, Asur, Arfaxad, Lidia y Arán."
,"23":"Hijos de Arán: Us, Jul, Guéter y Mésec."
,"24":"Arfaxad engendró a Sélaj, y Sélaj a Héber."
,"25":"A Héber le nacieron dos hijos; el primero se llamó Péleg, porque en su tiempo fue dividida la tierra; su hermano se llamó Yoctán;"
,"26":"Yoctán engendró a Almodad, Sélef, Jasarmávet, Yéraj,"
,"27":"Hadorán, Uzal, Diclá,"
,"28":"Ebal, Abimael, Sebá,"
,"29":"Ofir, Javilá y Yobab. Todos éstos son los hijos de Yoctán."
,"30":"La región donde ellos habitaron va desde Mesa, en dirección de Sefar, hasta las montañas orientales."
,"31":"Éstos fueron los hijos de Sem según sus familias, lenguas, países y naciones."
,"32":"Tales fueron las familias de los hijos de Noé según sus generaciones y naciones. A partir de ellos se hizo la repartición de las naciones sobre la tierra después del diluvio."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Toda la tierra hablaba una misma lengua y usaba las mismas palabras."
,"2":"Los hombres, al emigrar de oriente, encontraron una llanura en el país de Senaar y se establecieron allí."
,"3":"Y se dijeron unos a otros: 'Ea, hagamos ladrillos y cozámoslos al fuego'. Se sirvieron de los ladrillos en lugar de piedras, y de betún en lugar de argamasa."
,"4":"Luego dijeron: 'Ea, edifiquemos una ciudad y una torre cuya cúspide llegue hasta el cielo. Hagámonos famosos y no andemos más dispersos por la tierra'."
,"5":"El Señor descendió para ver la ciudad y la torre que los hombres estaban levantando, y"
,"6":"dijo: 'He aquí que todos forman un solo pueblo y hablan una misma lengua, y éste es sólo el principio de sus empresas. Nada les impedirá llevar a cabo todo lo que se propongan."
,"7":"Pues bien, descendamos y confundamos su lenguaje para que no se entiendan los unos a los otros'."
,"8":"Así el Señor los dispersó de allí por toda la tierra y dejaron de construir la ciudad."
,"9":"Por eso se la llamó Babel, porque allí confundió el Señor la lengua de todos los habitantes de la tierra y los dispersó por toda su superficie."
,"10":"He aquí la descendencia de Sem: Sem, a la edad de cien años, engendró a Arfaxad dos años después del diluvio."
,"11":"Después del nacimiento de Arfaxad, Sem vivió quinientos años, y engendró hijos e hijas."
,"12":"Arfaxad, a la edad de treinta y cinco, engendró a Sélaj."
,"13":"Después del nacimiento de Sélaj, Arfaxad vivió trescientos años, y engendró hijos e hijas."
,"14":"Sélaj, a la edad de treinta años, engendró a Héber."
,"15":"Después del nacimiento de Héber, Sélaj vivió cuatrocientos años, y engendró hijos e hijas."
,"16":"Héber, a la edad de treinta y cuatro años, engendró a Péleg."
,"17":"Después del nacimiento de Péleg, Héber vivió cuatrocientos treinta años, y engendró hijos e hijas."
,"18":"Péleg, a la edad de treinta años, engendró a Reú."
,"19":"Después del nacimiento de Reú, Péleg vivió doscientos nueve años, y engendró hijos e hijas."
,"20":"Reú, a la edad de treinta y dos años, engendró a Sarug."
,"21":"Después del nacimiento de Sarug, Reú vivió doscientos siete años, y engendró hijos e hijas."
,"22":"Sarug, a la edad de treinta años, engendró a Najor."
,"23":"Después del nacimiento de Najor, Sarug vivió doscientos años, y engendró hijos e hijas."
,"24":"Najor, a la edad de veintinueve años, engendró a Téraj."
,"25":"Después del nacimiento de Téraj, Najor vivió ciento diecinueve años, y engendró hijos e hijas."
,"26":"Téraj, a la edad de setenta años, engendró a Abrán, a Najor y a Harán."
,"27":"Ésta es la descendencia de Téraj: Téraj engendró a Abrán, Najor y Harán. Harán engendró a Lot,"
,"28":"y murió en vida de su padre Téraj, en su país natal, Ur de los caldeos."
,"29":"Abrán y Najor se casaron. La mujer de Abrán se llamaba Saray, y la de Najor Milcá, hija de Harán, padre de Milcá y de Yiscá."
,"30":"Saray era estéril y no tenía hijos."
,"31":"Téraj tomó a su hijo Abrán, a su nieto Lot y a Saray su nuera, mujer de Abrán, y los hizo salir de Ur de los caldeos para ir al país de Canaán; pero al llegar a Jarán se quedaron allí."
,"32":"Téraj vivió doscientos cinco años, y murió en Jarán."
}`)
	CurrentBook.AddChapter(12, `{
"1":"El Señor dijo a Abrán: 'Sal de tu tierra, de tu patria y de la casa de tu padre, y vete al país que yo te indicaré."
,"2":"Yo haré de ti un gran pueblo; te bendeciré y engrandeceré tu nombre. Tú serás una bendición:"
,"3":"Yo bendeciré a los que te bendigan y maldeciré a los que te maldigan. Por ti serán bendecidas todas las comunidades de la tierra'."
,"4":"Abrán partió, como le había dicho el Señor, y Lot se fue con él. Abrán tenía setenta y cinco años cuando salió de Jarán."
,"5":"Tomó consigo a Saray, su mujer, y a Lot, su sobrino, con todas las cosas que poseía y los esclavos adquiridos en Jarán. Y se pusieron en camino hacia la tierra de Canaán. Llegaron a Canaán, y"
,"6":"Abrán atravesó el país hasta el lugar de Siquén, hasta la encina de Moré. Los cananeos habitaban entonces en el país."
,"7":"El Señor se apareció a Abrán y le dijo: 'Yo daré esta tierra a tu descendencia'. Y Abrán levantó allí un altar al Señor, que se le había aparecido."
,"8":"De allí se trasladó a la montaña situada al oriente de Betel y allí plantó su tienda, con Betel al oeste y Ay al este. Aquí levantó al Señor un altar e invocó su nombre."
,"9":"Después Abrán partió en dirección al Negueb."
,"10":"Hubo un hambre en aquel país, y Abrán bajó a Egipto para estarse allí porque el hambre se había agravado en el país."
,"11":"Al llegar a Egipto dijo a Saray, su mujer: 'Mira, tú eres una mujer muy hermosa."
,"12":"Tan pronto como te vean los egipcios, dirán: Es su mujer; a mí me matarán y a ti te dejarán con vida."
,"13":"Por favor, di que eres mi hermana, para que se me trate bien gracias a ti, y en atención a ti respeten mi vida'."
,"14":"Efectivamente, cuando Abrán llegó a Egipto, los egipcios vieron que la mujer era muy hermosa."
,"15":"Los oficiales del Faraón que la vieron se la elogiaron mucho al Faraón, y la mujer fue llevada a su palacio."
,"16":"En atención a ella, el Faraón trató bien a Abrán, que recibió ovejas, bueyes y asnos, siervos y siervas, camellos y asnas."
,"17":"Pero el Señor castigó con grandes plagas al Faraón y a su casa por lo de Saray, la mujer de Abrán."
,"18":"El Faraón mandó llamar a Abrán y le dijo: '¿Qué es lo que me has hecho? ¿Por qué no me has dicho que era tu mujer?"
,"19":"¿Por qué me dijiste que era tu hermana, dando lugar a que yo la tomase por mujer? Ahí tienes a tu mujer, tómala y vete'."
,"20":"Y el Faraón dio órdenes a sus hombres, que lo condujeron a la frontera, y con él a su mujer y todo cuanto poseía."
}`)
	CurrentBook.AddChapter(13, `{
"1":"De Egipto Abrán subió al Negueb con su mujer, con todo cuanto poseía y con Lot."
,"2":"Abrán se había hecho muy rico en ganados, plata y oro."
,"3":"Del Negueb, y por etapas, llegó hasta Betel, el lugar donde había plantado antes su tienda, entre Betel y Ay,"
,"4":"donde anteriormente había levantado un altar y había invocado el nombre del Señor."
,"5":"Lot, que acompañaba a Abrán, tenía también rebaños, ganados y tiendas."
,"6":"El país era insuficiente para poder estar los dos allí; tenían demasiados bienes para poder habitar juntos."
,"7":"Surgieron discordias entre los pastores de Abrán y los de Lot. (Cananeos y fereceos habitaban entonces en aquel país)."
,"8":"Abrán dijo a Lot: 'Que no haya discordias entre tú y yo, ni entre mis pastores y los tuyos, porque somos hermanos."
,"9":"¿No tienes toda la tierra ante ti? Sepárate de mí. Si tú vas hacia la izquierda, yo iré hacia la derecha; y si tú tomas la derecha, yo iré hacia la izquierda'."
,"10":"Lot alzó sus ojos y vio toda la llanura del Jordán enteramente regada -esto era antes de que el Señor destruyera Sodoma y Gomorra-, y aquella llanura hasta Soar era como el jardín del Señor y como el país de Egipto."
,"11":"Lot escogió para sí toda la vega del Jordán y se marchó hacia oriente. Así se separaron el uno del otro."
,"12":"Abrán se estableció en la tierra de Canaán y Lot en las ciudades de la vega, llegando con sus tiendas hasta Sodoma."
,"13":"Los habitantes de Sodoma eran unos malvados y grandes pecadores contra el Señor."
,"14":"El Señor dijo a Abrán después que Lot se había separado de él: 'Alza tus ojos y desde el lugar donde estás mira al norte y al sur, al este y al oeste."
,"15":"Toda la tierra que ves te la daré a ti y a tu descendencia para siempre."
,"16":"Multiplicaré tu descendencia como el polvo de la tierra; si hay quien pueda contar el polvo de la tierra, ése podrá contar tu descendencia."
,"17":"Levántate, recorre el país a lo largo y a lo ancho, porque a ti te lo voy a dar'."
,"18":"Abrán levantó sus tiendas y se fue a habitar al encinar de Mambré, cerca de Hebrón, y allí levantó un altar al Señor."
}`)
	CurrentBook.AddChapter(14, `{
"1":"En aquel tiempo, Amrafel, rey de Senaar; Arioc, rey de Elasar; Codorlaomer, rey de Elán, y Tidal, rey de Goyín,"
,"2":"declararon la guerra a Berá, rey de Sodoma; a Birsa, rey de Gomorra; a Sinab, rey de Admá; a Seméber, rey de Seboín; y al rey de Bela, o sea, de Soar."
,"3":"Éstos se reunieron en el valle de Sidín, o sea, el mar de la Sal."
,"4":"Habían estado sometidos doce años a Codorlaomer, pero en el trece se sublevaron."
,"5":"En el año catorce, Codorlaomer y sus reyes aliados vinieron y derrotaron a los refaítas en Astarot Carnáyim, a los zuzíes en Ham, a los emíes en el valle de Quiriatáyim"
,"6":"y a los hurritas en las montañas de Seir hasta El-Farán, que está junto al desierto."
,"7":"Después llegaron a la fuente de la justicia, o sea Cades, y ocuparon todo el territorio de los amalecitas y el de los amorreos, que habitaban en Jasesón Tamar."
,"8":"Entonces, el rey de Sodoma, el de Gomorra, el de Admá, el de Seboín y el de Bela, o sea, de Soar, les salieron al encuentro y presentaron batalla contra ellos en el valle de Sidín:"
,"9":"contra Codorlaomer, rey de Elán; Tidal, rey de Goyín; Amrafel, rey de Senaar, y Arioc, rey de Elasar; cuatro reyes contra cinco."
,"10":"El valle de Sidín estaba lleno de pozos de betún. Los reyes de Sodoma y Gomorra se dieron a la fuga y cayeron allí muchos, y los que pudieron salvarse huyeron a los montes."
,"11":"Los vencedores saquearon todos los bienes de Sodoma y de Gomorra y todas sus posesiones, y se fueron."
,"12":"Se llevaron también a Lot, sobrino de Abrán, que habitaba en Sodoma, con todos sus bienes."
,"13":"Uno de los fugitivos vino a informar a Abrán, el hebreo, que habitaba en el encinar de Mambré, el amorreo, hermano de Escol y Aner, aliados de Abrán."
,"14":"En cuanto Abrán se enteró de que su sobrino había sido hecho prisionero, armó a trescientos dieciocho de sus hombres más valientes nacidos en su casa y se lanzó en su persecución hasta Dan."
,"15":"Repartió sus hombres para asaltar de noche a los enemigos; los derrotó y los persiguió hasta Joba, que está al norte de Damasco."
,"16":"Reconquistó todo el botín y también a Lot, su sobrino, con todos sus bienes, mujeres y gente."
,"17":"Cuando Abrán volvía de derrotar a Codorlaomer y a los reyes que estaban con él, le salió al encuentro el rey de Sodoma en el valle de Savé, o sea, el valle del Rey."
,"18":"Melquisedec, rey de Salén, sacó pan y vino; era él sacerdote del Dios altísimo, y"
,"19":"bendijo a Abrán diciendo: 'Bendito seas, Abrán del Dios altísimo, que creó el cielo y la tierra, y "
,"20":"bendito sea el Dios altísimo, que ha puesto en tus manos a tus enemigos'. Y Abrán le dio el diez por ciento de todo."
,"21":"El rey de Sodoma dijo a Abrán: 'Devuélveme las personas, y toma para ti los bienes'."
,"22":"Abrán le respondió: 'Juro, mano en alto, al Señor que creó el cielo y la tierra: Yo no tomaré nada de lo que es tuyo,"
,"23":"ni siquiera un hilo, ni una correa de tu zapato. Así no podrás decir: Yo he enriquecido a Abrán."
,"24":"Para mí, nada; solamente lo que han comido mis mozos y la parte que corresponde a los hombres que han venido conmigo, Aner, Escol y Mambré; éstos recibirán su parte'."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Después de todo esto, la palabra del Señor fue dirigida a Abrán en una visión. Dijo: 'No temas, Abrán, yo soy tu escudo. Tu recompensa será muy grande'."
,"2":"Abrán respondió: 'Señor Dios, ¿qué me vas a dar? Yo estoy ya para morir sin hijos, y el heredero de mi casa será ese Eliezer de Damasco."
,"3":"No me has dado descendencia, y uno de mis criados será mi heredero'."
,"4":"Entonces el Señor le dirigió la palabra y le dijo: 'No, no será ése tu heredero, sino uno salido de tus entrañas'. "
,"5":"Después le llevó fuera y le dijo: 'Levanta tus ojos al cielo y cuenta, si puedes, las estrellas'; y añadió: 'Así será tu descendencia'."
,"6":"Abrán creyó al Señor, y el Señor le consideró como un hombre justo."
,"7":"Y le dijo: 'Yo soy el Señor que te sacó de Ur de los caldeos para darte esta tierra en posesión'."
,"8":"Abrán le preguntó: 'Señor Dios, ¿cómo sabré yo que la poseeré?'."
,"9":"El Señor le dijo: 'Tráeme una ternera de tres años, una cabra de tres años, un carnero de tres años, una tórtola y una paloma'."
,"10":"Él trajo todos estos animales, los partió por la mitad y puso una mitad frente a la otra; pero las aves no las partió."
,"11":"Las aves rapaces revoloteaban sobre los cadáveres, pero Abrán las espantaba."
,"12":"Cuando el sol estaba ya para ponerse, cayó sobre Abrán un sueño profundo y le envolvió una oscuridad terrorífica."
,"13":"El Señor le dijo: 'Has de saber que tus descendientes vivirán como extranjeros en tierra extraña, en la que serán esclavos y estarán oprimidos durante cuatrocientos años;"
,"14":"pero yo juzgaré al pueblo al que habrán estado sometidos, y saldrán de él con muchos bienes."
,"15":"Tú te reunirás en paz con tus padres y serás sepultado en una feliz ancianidad."
,"16":"Tus descendientes volverán acá a la cuarta generación, pues hasta entonces no se colmará la maldad de los amorreos'."
,"17":"Cuando se puso el sol, apareció entre densísimas tinieblas una hornilla humeante y una llama de fuego, que pasó por entre los animales partidos."
,"18":"Aquel día el Señor hizo un pacto con Abrán en estos términos: 'A tu descendencia doy esta tierra, desde el torrente de Egipto hasta el gran río, el Éufrates: "
,"19":"los quenitas, quenizitas, cadmonitas,"
,"20":"hititas, fereceos, refaítas,"
,"21":"amorreos, cananeos, guirgaseos y jebuseos'."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Saray, la mujer de Abrán, no le había dado hijos; pero ella tenía una esclava egipcia de nombre Agar."
,"2":"Saray dijo a Abrán: 'Mira, el Señor me ha hecho estéril; llévate a mi esclava. Quizá yo pueda tener hijos por ella'. Abrán escuchó a Saray."
,"3":"Diez años después de haberse establecido Abrán en el país de Canaán, Saray tomó a Agar, su esclava egipcia, y se la dio por mujer a Abrán, su marido."
,"4":"Abrán tuvo relaciones con Agar, la cual concibió; y cuando se vio encinta, miraba con desprecio a su señora."
,"5":"Saray dijo a Abrán: 'Tú eres el responsable de la afrenta que me hace. Yo puse a mi esclava entre tus brazos, y ella, al verse embarazada, me mira con desprecio. ¡Que el Señor juzgue entre nosotros!'."
,"6":"Abrán respondió a Saray: 'Mira, tu esclava está en tus manos; haz con ella lo que mejor te parezca'. Saray la maltrató, y ella se escapó."
,"7":"El ángel del Señor la encontró en el desierto junto a un manantial de agua, la fuente que está en el camino de Sur,"
,"8":"y le dijo: 'Agar, esclava de Saray, ¿de dónde vienes y adónde vas?'. Ella respondió: 'Huyo de la presencia de Saray, mi señora'."
,"9":"El ángel del Señor le dijo: 'Vuélvete a tu señora y ponte a sus órdenes'."
,"10":"Y añadió: 'Multiplicaré tanto tu descendencia que no se la podrá contar'."
,"11":"Añadió: 'Tú estás encinta y darás a luz un hijo y le llamarás Ismael, porque el Señor ha escuchado tu aflicción."
,"12":"Será un potro salvaje; su mano será contra todos y la de todos contra él. Vivirá en contra de todos sus hermanos'."
,"13":"Agar dio al Señor, que le había hablado, un nombre, diciendo: 'Tú eres El Roí. He visto aquí al que me ve'. "
,"14":"Por esto aquel pozo se llama 'pozo de Lajay Roí'; está entre Cades y Béred."
,"15":"Agar dio un hijo a Abrán, y Abrán le llamó Ismael."
,"16":"Abrán tenía ochenta y seis años cuando Agar le dio a Ismael."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Abrán tenía noventa y nueve años cuando se le apareció el Señor y le dijo: 'Yo soy Dios todopoderoso; procede según mi voluntad y sé perfecto."
,"2":"Yo estableceré un pacto contigo: te multiplicaré inmensamente'."
,"3":"Abrán se postró rostro en tierra, y Dios continuó diciendo:"
,"4":"'Éste es mi pacto contigo: Tú llegarás a ser padre de una multitud de pueblos."
,"5":"No te llamarás Abrán, sino Abrahán, porque yo te constituyo padre de una multitud de pueblos."
,"6":"Te multiplicaré inmensamente: yo haré que de ti salgan pueblos y nazcan reyes."
,"7":"Yo establezco mi pacto contigo y con tu descendencia después de ti de generación en generación. Un pacto perpetuo. Yo seré tu Dios y el de tu descendencia después de ti."
,"8":"Yo te daré a ti y a tu descendencia después de ti en posesión perpetua la tierra en la que habitas ahora como extranjero, toda la tierra de Canaán. Yo seré vuestro Dios'."
,"9":"Dios dijo a Abrahán: 'Guardaréis mi pacto tú y tu descendencia después de ti."
,"10":"Éste es el pacto que guardaréis entre yo y vosotros, y tu descendencia después de ti: Todos los varones serán circuncidados."
,"11":"Circuncidaréis vuestro prepucio, y ésta será la señal del pacto entre yo y vosotros."
,"12":"A los ocho días de su nacimiento serán circuncidados todos los varones de cada generación, así como los esclavos nacidos en la casa o comprados por dinero a cualquier extranjero que no sea de tu raza."
,"13":"El esclavo nacido en la casa o comprado con dinero deberá ser circuncidado. Así mi pacto será en vuestra carne un pacto perpetuo."
,"14":"El varón incircunciso, al que no le haya sido cortada la carne de su prepucio, será borrado de su pueblo; ha violado mi pacto'."
,"15":"Dijo Dios a Abrahán: 'Saray, tu mujer, no se llamará más Saray; su nombre será Sara."
,"16":"Yo la bendeciré y te haré tener de ella un hijo. Yo la bendeciré, y de ella nacerán pueblos y saldrán reyes'."
,"17":"Abrahán cayó rostro en tierra y se puso a reír diciéndose a sí mismo: '¿A un hombre de cien años le podrá nacer un hijo, y Sara a los noventa años podrá ser madre?'."
,"18":"Abrahán dijo a Dios: '¡Me conformo con que conserves vivo a Ismael!'."
,"19":"Y Dios le dijo: 'Ciertamente Sara, tu mujer, te dará un hijo, y tú le llamarás Isaac. Yo estableceré con él mi pacto, como un pacto perpetuo para su descendencia después de él."
,"20":"En cuanto a Ismael, también te he escuchado. Yo le bendigo: Le haré fecundo y le multiplicaré inmensamente, engendrará doce príncipes, y yo haré de él un gran pueblo."
,"21":"Estableceré mi pacto con Isaac, el hijo que te dará Sara el año próximo por este tiempo'."
,"22":"Cuando Dios terminó de hablar con Abrahán, se marchó."
,"23":"Abrahán tomó a Ismael, su hijo; a todos los esclavos nacidos en su casa, a los comprados con su dinero; a todos los varones que había en su casa, y aquel mismo día circuncidó la carne de su prepucio, como Dios le había ordenado."
,"24":"Abrahán tenía noventa y nueve años cuando circuncidó la carne de su prepucio,"
,"25":"e Ismael, su hijo, trece cuando fue circuncidado."
,"26":"En aquel mismo día fueron circuncidados Abrahán y su hijo,"
,"27":"y todos los varones de su casa, los nacidos en ella y los comprados por dinero al extranjero. Todos fueron circuncidados con él."
}`)
	CurrentBook.AddChapter(18, `{
"1":"El Señor se apareció a Abrahán junto al encinar de Mambré, cuando estaba sentado ante su tienda en pleno calor del día."
,"2":"Alzó los ojos y vio a tres hombres de pie delante de él. Al verlos, corrió a su encuentro desde la puerta de la tienda,"
,"3":"se postró en tierra y dijo: 'Mi Señor, por favor; si he hallado gracia a tus ojos, no pases sin detenerte con tu siervo."
,"4":"Os traeremos agua, os lavaréis los pies y reposaréis a la sombra de este árbol."
,"5":"Yo voy a buscar un bocado de pan, y así os repondréis antes de pasar adelante, ya que habéis pasado cerca de vuestro siervo'. Ellos respondieron: 'Haz como has dicho'."
,"6":"Abrahán fue deprisa a la tienda de Sara, y le dijo: 'Toma en seguida tres medidas de harina, amásala y haz panecillos'."
,"7":"Entretanto él corrió al establo, tomó un becerro tierno y cebado y se lo dio a su siervo, que a toda prisa se puso a prepararlo."
,"8":"Tomó después manteca y leche y el becerro ya aderezado, y se lo presentó a ellos. Él se quedó de pie junto a ellos, bajo el árbol, mientras comían."
,"9":"Ellos le preguntaron: '¿Dónde está Sara, tu mujer?'. Él respondió: 'Está en la tienda'."
,"10":"Uno de ellos prosiguió: 'Dentro de un año volveré. Para entonces, tu mujer, Sara, habrá tenido un hijo'. Sara escuchaba a la entrada de la tienda, detrás del que hablaba."
,"11":"Abrahán y Sara eran viejos, muy entrados en años, y Sara ya no tenía el período de las mujeres."
,"12":"Sara se echó a reír, pensando para sí: '¿Después de haber envejecido he de conocer el placer, siendo también mi marido viejo?'."
,"13":"Pero el Señor dijo a Abrahán: 'Por qué se ha reído Sara diciéndose: ¿Podrá ser verdad que voy a ser madre siendo tan vieja?"
,"14":"¿Hay algo difícil para el Señor? De aquí a un año volveré, y Sara tendrá un hijo'."
,"15":"Sara lo negó diciendo: 'Yo no me he reído', pues tuvo miedo; pero él dijo: 'Sí, tú te has reído'."
,"16":"Aquellos hombres se levantaron y se fueron en dirección a Sodoma. Abrahán iba con ellos."
,"17":"El Señor se decía: '¿Ocultaré yo a Abrahán lo que voy a hacer,"
,"18":"cuando ha de convertirse en un pueblo grande y fuerte y cuando en él serán bendecidas todas las naciones de la tierra?"
,"19":"No; le pondré al corriente para que ordene a sus hijos y a su casa, después de él, que observen la ley del Señor, practicando la justicia y el derecho, de modo que el Señor cumpla en Abrahán cuanto ha prometido acerca de él'."
,"20":"El Señor dijo: 'Las quejas contra Sodoma y Gomorra son muy grandes, y su pecado, muy grave."
,"21":"Voy a bajar a ver si realmente han obrado o no según las quejas que han llegado hasta mí; lo voy a comprobar'."
,"22":"Los hombres se dirigieron hacia Sodoma. Abrahán estaba todavía delante del Señor."
,"23":"Se le acercó y le dijo: '¿Vas a destruir al justo juntamente con el pecador?"
,"24":"Quizá haya cincuenta justos en la ciudad. ¿Vas a destruir la ciudad? ¿No la perdonarás en consideración a los cincuenta justos que hay en ella?"
,"25":"¡Lejos de ti hacer tal cosa! ¡Hacer morir al justo con el pecador, tratarle como al culpable! ¡Nunca hagas eso! ¿El juez de toda la tierra no hará justicia?'."
,"26":"El Señor respondió: 'Si encuentro en Sodoma cincuenta justos dentro de la ciudad, perdonaré a toda la ciudad en consideración a ellos'."
,"27":"Abrahán replicó: 'Soy en verdad muy atrevido insistiendo ante mi Dios, yo, que soy polvo y ceniza."
,"28":"A lo mejor faltan cinco para los cincuenta justos; ¿destruirás por esos cinco toda la ciudad?'. Y él respondió: 'No, no la destruiré si encuentro cuarenta y cinco justos'."
,"29":"Abrahán continuó todavía: 'A lo mejor no hay más que cuarenta'. Y él respondió: 'No lo haré por esos cuarenta'."
,"30":"Abrahán insistió: 'No se irrite mi Señor si sigo hablando. A lo mejor sólo hay treinta'. Y el Señor respondió: 'No lo haré si encuentro treinta'."
,"31":"Abrahán dijo: 'Soy muy atrevido insistiendo ante mi Señor: A lo mejor sólo hay veinte'. Y respondió: 'No la destruiré en consideración a esos veinte'."
,"32":"Abrahán volvió a decir: 'No se irrite mi Señor. Voy a hablar por última vez. A lo mejor sólo hay diez'. Y el Señor respondió: 'No la destruiré en consideración a esos diez'."
,"33":"En cuanto terminó de hablar con Abrahán, el Señor se fue y Abrahán volvió a su lugar."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Cuando los dos ángeles llegaron a Sodoma, al atardecer, Lot estaba sentado a la puerta de la ciudad. Al verlos se levantó, fue a su encuentro, se postró rostro en tierra"
,"2":"y les dijo: 'Por favor, señores, venid a casa de vuestro siervo y pasad allí la noche; lavaos los pies, y mañana por la mañana seguiréis vuestro camino'. Ellos le respondieron: 'No; pasaremos la noche en la plaza'."
,"3":"Pero él insistió tanto que se fueron con él y se hospedaron en su casa. Les preparó comida, coció panes sin levadura y comieron."
,"4":"No se habían acostado todavía, cuando los hombres de la ciudad, los sodomitas, jóvenes y ancianos, todo el pueblo sin excepción, cercaron la casa."
,"5":"Llamaron a Lot y le dijeron: '¿Dónde están esos hombres que han venido a tu casa esta noche? Sácanoslos para que abusemos de ellos'."
,"6":"Lot salió, cerró la puerta y"
,"7":"les dijo: 'Hermanos míos, os suplico que no cometáis tal maldad."
,"8":"Escuchad: Yo tengo dos hijas vírgenes; os las voy a sacar fuera, y haced con ellas lo que queráis; pero no hagáis nada a estos hombres, puesto que han entrado a la sombra de mi tejado'."
,"9":"Ellos le respondieron: '¡Quítate de ahí!'. Y se decían: 'Éste vino aquí como emigrante, y quiere constituirse en juez; haremos contigo peor que con ellos'. Le empujaron violentamente y trataron de romper la puerta. "
,"10":"Pero los dos hombres sacaron su brazo, metieron a Lot con ellos en casa y cerraron la puerta;"
,"11":"y dejaron ciegos a los hombres que estaban ante la puerta, desde el más joven hasta el más anciano, de tal modo que no pudieron encontrar la puerta."
,"12":"Los dos hombres dijeron a Lot: '¿Quién hay aquí todavía de los tuyos? Yernos, hijos e hijas y todos los tuyos que estén en la ciudad, sácalos de este lugar,"
,"13":"pues hemos venido aquí para destruir este lugar porque las quejas contra él ante el Señor son muy grandes, y el Señor nos ha enviado para destruirlo'."
,"14":"Lot fue a hablar con sus futuros yernos, los que se iban a casar con sus hijas, y les dijo: 'Levantaos y salid de este lugar porque el Señor va a destruirlo'. Pero ellos creían que estaba bromeando."
,"15":"Al despuntar el alba, los ángeles instaban a Lot diciéndole: 'Levántate, toma contigo a tu mujer y a tus dos hijas que se encuentran aquí, no sea que perezcas por culpa de la ciudad'. "
,"16":"Como él no se decidía, aquellos hombres los agarraron de la mano, a él, a su mujer y a sus hijas, porque el Señor se había compadecido de ellos, y los sacaron fuera de la ciudad."
,"17":"Cuando ya estaban fuera, uno de los ángeles le dijo: 'Ponte a salvo; no mires hacia atrás ni te detengas en toda la vega; huye a la montaña para que no perezcas'."
,"18":"Lot respondió: '¡Oh, no, Señor mío!"
,"19":"Tu siervo ha hallado gracia a tus ojos y has mostrado gran misericordia para conmigo conservándome la vida. Pero yo no puedo llegar a la montaña sin que antes me alcance el castigo y muera."
,"20":"Mira, ahí cerca está esa ciudad donde me podría refugiar. Y es insignificante. Permíteme que me refugie en ella y salve mi vida'."
,"21":"Él respondió: 'Te voy a hacer ese favor; no destruiré la ciudad de que me has hablado."
,"22":"¡Pronto! Escápate allá, porque yo no podré hacer nada hasta que tú no hayas llegado'. Por eso aquella ciudad se llama Soar."
,"23":"Lot llegó a Soar al salir el sol."
,"24":"Entonces el Señor hizo llover sobre Sodoma y Gomorra azufre y fuego del Señor desde el cielo."
,"25":"Y destruyó estas ciudades y toda la vega, todos los habitantes de las ciudades y toda la vegetación del suelo."
,"26":"La mujer de Lot miró hacia atrás y se convirtió en una estatua de sal."
,"27":"Abrahán se levantó muy de mañana y se encaminó al lugar donde había estado con el Señor."
,"28":"Volvió la vista hacia Sodoma y Gomorra y hacia toda la vega, y vio cómo de la vega subía humo como el de un horno."
,"29":"Cuando Dios destruyó las ciudades de la llanura, se acordó de Abrahán y salvó a Lot de la catástrofe, mientras destruía las ciudades donde éste había vivido."
,"30":"Lot subió de Soar y se estableció en la montaña, y con él también sus dos hijas, porque tuvo miedo de quedarse en Soar; se instaló en una cueva con sus dos hijas."
,"31":"La mayor dijo a la menor: 'Nuestro padre es viejo y no queda varón en la región que pueda juntarse con nosotras como hace todo el mundo."
,"32":"Emborrachemos a nuestro padre y acostémonos con él, y así tendremos descendencia de nuestro padre'."
,"33":"Aquella misma noche emborracharon a su padre, y fue la mayor y se acostó con él sin que éste se diera cuenta de que ella se acostaba y se levantaba."
,"34":"Al día siguiente, la mayor dijo a la menor: 'La noche pasada dormí yo con mi padre; emborrachémosle también esta noche y te acuestas tú con él, y así tendremos descendencia de nuestro padre'."
,"35":"Aquella noche emborracharon también a su padre, y la menor se acostó con él; y tampoco se dio cuenta de que ella se acostaba y se levantaba."
,"36":"De este modo las dos hijas de Lot quedaron encinta de su padre."
,"37":"La mayor tuvo un hijo, y le llamó Moab; es el padre de los actuales moabitas."
,"38":"También la menor tuvo un hijo, y le llamó Ben Ammí; es el padre de los actuales amonitas."
}`)
	CurrentBook.AddChapter(20, `{
"1":"De allí Abrahán partió hacia el Negueb, y se detuvo entre Cades y Sur; después se instaló en Guerar."
,"2":"Abrahán decía que Sara, su mujer, era su hermana. Y Abimelec, rey de Guerar, mandó que le trajeran a Sara."
,"3":"Pero Dios visitó a Abimelec en sueños, de noche, y le dijo: 'Vas a morir a causa de la mujer que has tomado, porque es una mujer casada'."
,"4":"Abimelec, que todavía no la había tocado, dijo: 'Señor, ¿matarás también a un inocente?"
,"5":"¿No me dijo él que era su hermana y ella que él era su hermano? Yo hice esto con buena conciencia y manos puras'."
,"6":"Dios le respondió: 'Sí, sé que has hecho esto con buena conciencia; por eso te he impedido pecar contra mí y no te he dejado tocarla."
,"7":"Ahora, devuélvesela a ese hombre. Él es profeta, e intercederá por ti para que vivas. Pero si no la devuelves, tú y todos los tuyos moriréis'."
,"8":"Abimelec se levantó de madrugada y llamó a todos sus servidores. Les refirió todo lo ocurrido, y aquellos hombres se llenaron de miedo."
,"9":"Después mandó llamar a Abrahán y le dijo: '¿Qué nos has hecho? ¿En qué te he ofendido para que nos hayas expuesto, a mí y a mi reino, a cometer un pecado tan grave? Tú has hecho conmigo lo que no se debe hacer'."
,"10":"Y añadió: '¿Qué pretendías al obrar así?'."
,"11":"Abrahán respondió: 'Yo me dije: Seguramente no hay temor de Dios en esta tierra y me matarán a causa de mi mujer."
,"12":"Además, es verdad que ella también es mi hermana, hija de mi padre, pero no de mi madre, y ahora es mi mujer."
,"13":"Cuando Dios me hizo salir lejos de la casa de mi padre, yo le dije a ella: Tienes que hacerme este favor: dondequiera que vayamos, di que yo soy tu hermano'."
,"14":"Abimelec tomó ovejas y vacas, siervos y siervas y se los dio a Abrahán; le devolvió también a Sara, su mujer,"
,"15":"y le dijo: 'Tienes delante de ti mi territorio; habita donde quieras'. "
,"16":"A Sara le dijo: 'Mira, yo he dado mil monedas de plata a tu hermano; esto será para ti como una venda sobre los ojos de todos los que están contigo y ante cualquiera, y tú serás enteramente justificada'."
,"17":"Abrahán rezó a Dios, y Dios curó a Abimelec, a su mujer y a sus siervos para que de nuevo pudieran tener hijos;"
,"18":"pues el Señor había hecho estéril el seno de todas las mujeres en la casa de Abimelec por lo de Sara, mujer de Abrahán."
}`)
	CurrentBook.AddChapter(21, `{
"1":"El Señor visitó a Sara como había dicho, y cumplió en ella cuanto había anunciado."
,"2":"Sara concibió y dio un hijo a Abrahán ya en su vejez, en el tiempo predicho por Dios."
,"3":"Y Abrahán puso el nombre de Isaac al hijo que le había nacido, que le había dado Sara."
,"4":"Abrahán circuncidó a Isaac, su hijo, a los ocho días, como Dios le había mandado."
,"5":"Abrahán tenía cien años cuando le nació su hijo Isaac."
,"6":"Sara dijo: 'Dios me ha hecho reír, y todos los que se enteren se reirán conmigo'."
,"7":"Y añadió: '¿Quién iba a decir a Abrahán que Sara amamantaría hijos? Pues le he dado un hijo en su vejez'."
,"8":"El niño creció y fue destetado. Abrahán hizo una gran fiesta el día que fue destetado Isaac."
,"9":"Un día Sara vio que el hijo que Abrahán había tenido de Agar, la egipcia, estaba jugando con Isaac,"
,"10":"y dijo a Abrahán: 'Echa a esa esclava y a su hijo, pues el hijo de esa esclava no va a heredar con mi hijo Isaac'."
,"11":"Muy duro se le hacía esto a Abrahán, pues se trataba de su hijo."
,"12":"Pero Dios le dijo: 'No te dé pena por el muchacho ni por tu esclava. Haz lo que te dice Sara, porque la descendencia que lleve tu nombre saldrá de Isaac."
,"13":"Del hijo de la esclava haré también un gran pueblo, porque es de tu raza'."
,"14":"Abrahán se levantó muy de mañana, tomó pan y un odre de agua y se lo dio a Agar; puso el niño sobre su hombro, y la despidió. Ella se fue y anduvo errante por el desierto de Berseba."
,"15":"Cuando se agotó el agua del odre, dejó al niño bajo un matorral"
,"16":"y se sentó enfrente, a la distancia de un tiro de arco, diciéndose: 'No puedo ver morir al niño'. Y se sentó enfrente. El niño se puso a llorar a gritos."
,"17":"Dios oyó los gritos del niño, y el ángel de Dios llamó desde el cielo a Agar y le dijo: '¿Qué te pasa, Agar? No temas, porque Dios ha oído los gritos del pequeño desde el lugar en que está."
,"18":"Levántate, coge al niño y tómalo de la mano, porque de él haré yo un gran pueblo'."
,"19":"Dios abrió los ojos a Agar, que vio un pozo de agua. Se fue a llenar el odre y dio de beber al niño."
,"20":"Y Dios estuvo con el niño, el cual creció, habitó en el desierto y llegó a ser un gran tirador de arco."
,"21":"Habitó en el desierto de Farán, y su madre le escogió para esposa una mujer egipcia."
,"22":"Por aquel tiempo Abimelec, acompañado por Picol, jefe de su ejército, fue a decir a Abrahán: 'Dios está contigo en todo lo que haces. "
,"23":"Júrame aquí, por Dios, que no me engañarás a mí, ni a mis hijos, ni a mis parientes, sino que tendrás conmigo y con el país que te hospedó la misma benevolencia que yo he tenido contigo'."
,"24":"Abrahán respondió: 'Sí, lo juro'."
,"25":"Pero Abrahán tuvo que llamar la atención a Abimelec porque sus criados se habían apoderado con violencia de un pozo."
,"26":"Abimelec dijo: 'No sé quién ha podido hacerlo; tú no me lo habías dicho, ni yo me había enterado hasta hoy'."
,"27":"Abrahán tomó ovejas y vacas y se las dio a Abimelec, y los dos hicieron un pacto."
,"28":"Luego apartó siete corderas del rebaño,"
,"29":"y Abimelec le preguntó: '¿Qué significan estas siete corderas que has apartado?'."
,"30":"Abrahán respondió: 'Tú aceptarás estas siete corderas de mi mano para que sean un testimonio de que yo he cavado este pozo'."
,"31":"Por esto se llamó a este lugar Berseba, porque allí juraron los dos."
,"32":"Después que hicieron el pacto en Berseba, Abimelec y Picol, jefe de su ejército, regresaron al país de los filisteos."
,"33":"Abrahán plantó en Berseba un tamarisco e invocó allí al Señor, Dios de la eternidad."
,"34":"Abrahán permaneció largo tiempo en tierra de los filisteos."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Después de esto, Dios quiso probar a Abrahán, y le llamó: '¡Abrahán! ¡Abrahán!'. Éste respondió: 'Aquí estoy'. Y Dios le dijo:"
,"2":"'Toma ahora a tu hijo, al que tanto amas, Isaac, vete al país de Moria, y ofrécemelo allí en holocausto en un monte que yo te indicaré'."
,"3":"Abrahán se levantó de madrugada, aparejó su asno, tomó consigo dos criados y a su hijo Isaac, partió la leña para el holocausto y se encaminó hacia el lugar que Dios le había dicho."
,"4":"Al tercer día, Abrahán alzó los ojos y alcanzó a ver de lejos el lugar;"
,"5":"y dijo a sus criados: 'Quedaos aquí con el asno mientras el muchacho y yo subimos arriba; adoraremos a Dios, y después volveremos con vosotros'."
,"6":"Abrahán tomó la leña del holocausto y la puso sobre el hombro de su hijo Isaac. Después tomó en su mano el fuego y el cuchillo, y se fueron los dos juntos."
,"7":"Isaac dijo a su padre: '¡Padre!'. Él respondió: '¿Qué quieres, hijo mío?'. Isaac dijo: 'Llevamos el fuego y la leña; pero ¿dónde está el cordero para el holocausto?'."
,"8":"Abrahán respondió: 'Dios se proveerá del cordero para el holocausto, hijo mío'. Y continuaron juntos el camino."
,"9":"Cuando llegaron al lugar que Dios le había indicado, Abrahán levantó un altar; preparó la leña, ató a su hijo Isaac y lo puso sobre el altar encima de la leña."
,"10":"Luego tomó el cuchillo para sacrificar a su hijo."
,"11":"Entonces el ángel del Señor le llamó desde el cielo y le dijo: '¡Abrahán! ¡Abrahán!'. Éste respondió: 'Aquí estoy'. "
,"12":"Y el ángel le dijo: 'No lleves tu mano sobre el muchacho, ni le hagas mal alguno. Ya veo que temes a Dios, porque no me has negado a tu hijo, tu hijo único'."
,"13":"Abrahán alzó los ojos y vio a sus espaldas un carnero enredado por los cuernos en un matorral. Tomó el carnero y lo ofreció en holocausto en lugar de su hijo."
,"14":"Abrahán puso a aquel lugar el nombre de 'El Señor provee', y por eso todavía hoy se dice 'El monte del Señor provee'."
,"15":"El ángel del Señor llamó por segunda vez a Abrahán,"
,"16":"y le dijo: 'Juro por mí mismo, palabra del Señor, que, por haber hecho esto y no haberme negado tu hijo único, "
,"17":"te colmaré de bendiciones y multiplicaré tanto tu descendencia, que será como las estrellas del cielo y como la arena que hay a la otra orilla del mar, y tu descendencia ocupará la puerta de sus enemigos."
,"18":"Por tu descendencia serán benditas todas las naciones de la tierra, porque obedeciste mi voz'."
,"19":"Abrahán volvió donde sus criados y partieron juntos hacia Berseba, donde Abrahán se quedó a vivir."
,"20":"Después de todo esto se enteró de que su hermano Najor había tenido hijos de Milcá:"
,"21":"Us, el primogénito; Buz, su hermano; Camuel, padre de Arán;"
,"22":"Quésed, Jazó, Pildás, Yidlaf y Betuel."
,"23":"Betuel fue el padre de Rebeca. Estos ocho hijos le dio Milcá a Najor."
,"24":"Y también su concubina, de nombre Rauma, le dio a Tébaj, Gajan, Tajas y Maacá."
}`)
	CurrentBook.AddChapter(23, `{
"1":"Sara vivió ciento veintisiete años."
,"2":"Sara murió en Quiriat Arbá, o sea Hebrón, en tierra de Canaán. Abrahán vino a llorar a Sara y a hacer duelo por ella."
,"3":"Y cuando se levantó de junto a su difunta, habló así a los hititas:"
,"4":"'Yo soy extranjero y emigrante entre vosotros; dadme una sepultura en propiedad para enterrar a mi difunta'."
,"5":"Los hititas le respondieron:"
,"6":"'Escúchanos, señor; tú eres entre nosotros un príncipe de Dios; sepulta a tu difunta en la mejor de nuestras tumbas. Ninguno te negará la suya para que puedas enterrar a tu difunta'."
,"7":"Abrahán se levantó e hizo una reverencia a las gentes del país, los hititas,"
,"8":"y les habló de esta manera: 'Si estáis de acuerdo en que yo sepulte a mi difunta, escuchadme: interceded por mí ante Efrón, el hijo de Sójar, "
,"9":"para que me ceda por su justo precio y como propiedad funeraria entre vosotros su cueva de Macpela, la que se encuentra al final de su campo'."
,"10":"Efrón, que estaba entre los hititas, respondió a Abrahán en presencia de los hititas y ante todos los que entraban por la puerta de la ciudad:"
,"11":"'No, señor; escúchame: yo te doy el campo y la cueva que hay en él; delante de los hijos de mi pueblo te lo doy; sepulta a tu difunta'."
,"12":"Entonces Abrahán se inclinó ante el pueblo del país,"
,"13":"y habló así a Efrón en presencia del pueblo: 'Escúchame, por favor; yo te doy el precio del campo; tómalo de mi mano y sepultaré en él a mi difunta'. "
,"14":"Efrón respondió a Abrahán:"
,"15":"'Señor, escúchame; una tierra de cuatrocientas monedas de plata, ¿qué es para ti ni para mí?'."
,"16":"Abrahán se puso de acuerdo con Efrón y le pagó el precio que le había pedido en presencia de los hititas: cuatrocientas piezas de plata de moneda corriente en el mercado."
,"17":"De este modo el campo de Efrón, que estaba en Macpela, enfrente de Mambré, el campo y la cueva que había en él y todos los árboles de su término,"
,"18":"pasaron a ser propiedad de Abrahán en presencia de todos los hititas y de todos los que entraban por la puerta de la ciudad."
,"19":"Después Abrahán enterró a Sara en la cueva del campo de Macpela, enfrente de Mambré, en tierra de Canaán."
,"20":"Así el campo y la cueva que hay en él fueron adquiridos por Abrahán de los hititas, como propiedad funeraria."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Abrahán era ya muy viejo, y el Señor le había bendecido en todo."
,"2":"Abrahán dijo al criado más antiguo de su casa, que llevaba la administración de todos sus bienes: 'Pon tu mano bajo mi muslo."
,"3":"Quiero que me jures por el Señor, Dios del cielo y de la tierra, que no tomarás para mi hijo una mujer de entre las hijas de los cananeos entre las cuales habito,"
,"4":"sino que irás a mi tierra, adonde están los míos, a tomar una mujer para mi hijo Isaac'."
,"5":"El criado le respondió: 'Y si la mujer no quiere venir conmigo a esta tierra, ¿he de llevar a tu hijo a la tierra de donde saliste?'."
,"6":"Abrahán respondió: 'Guárdate de llevar a mi hijo allá."
,"7":"El Señor, Dios del cielo y de la tierra, que me sacó de la casa de mi padre y de la tierra de mi familia, que me habló y me juró diciéndome: Yo daré esta tierra a tu descendencia, él enviará su ángel delante de ti, para que tomes de allí mujer para mi hijo."
,"8":"Y si la mujer no quiere venir contigo, quedarás libre de este juramento que me haces, pero de ningún modo lleves allí a mi hijo'."
,"9":"El criado puso su mano debajo del muslo de Abrahán, su señor, y se lo juró."
,"10":"El criado tomó diez camellos de los de su señor y partió llevando consigo toda clase de regalos de su señor. Puesto en camino, llegó a Arán Naharáyim, la ciudad de Najor."
,"11":"Hizo arrodillar a los camellos en las afueras de la ciudad junto al pozo a la hora de la tarde en que las mozas salen por agua,"
,"12":"y dijo: 'Señor, Dios de mi amo Abrahán, haz que tenga hoy un buen encuentro y muestra tu amistad con mi amo Abrahán."
,"13":"Yo me quedaré junto a esta fuente mientras las hijas de la ciudad salen por agua."
,"14":"La joven a quien yo diga: Baja tu cántaro para que beba yo, y que me responda: Bebe, y voy a dar también de beber a tus camellos, ésa será la que tú has destinado a tu siervo Isaac; en esto conoceré que has mostrado tu amistad con mi amo Abrahán'."
,"15":"No había acabado de hablar, cuando Rebeca, hija de Betuel, hijo de Milcá y mujer de Najor, hermano de Abrahán, salía con su cántaro al hombro."
,"16":"La joven era muy bella y virgen; ningún varón la había tocado. Bajó a la fuente, llenó el cántaro e iba ya a subir,"
,"17":"cuando el criado corrió a su encuentro, y le dijo: 'Por favor, dame de beber un poco de agua de tu cántaro'. "
,"18":"Ella respondió: 'Bebe, señor'; e inclinando en seguida el cántaro sobre su brazo, le dio de beber."
,"19":"Cuando acabó de beber le dijo: 'También sacaré agua para tus camellos hasta que se harten'. "
,"20":"Rápidamente vació su cántaro en la pila, corrió de nuevo a sacar agua y trajo para todos los camellos."
,"21":"Entre tanto, el hombre la contemplaba en silencio, preguntándose si el Señor habría dado o no éxito a su viaje."
,"22":"Cuando los camellos acabaron de beber, el criado tomó un anillo de oro de seis gramos de peso y se lo puso a ella en las narices; y luego, en sus brazos, dos brazaletes también de oro, de ciento veinte gramos de peso. Y le dijo:"
,"23":"'¿De quién eres hija? Dime, por favor, ¿habrá sitio en la casa de tu padre para pasar yo allí la noche?'."
,"24":"Ella respondió: 'Soy hija de Betuel, el hijo que Milcá dio a Najor'."
,"25":"Y añadió: 'Nosotros tenemos paja y heno en abundancia y sitio para hospedarte'."
,"26":"Entonces el criado, postrándose en tierra, adoró al Señor"
,"27":"diciendo: 'Bendito sea el Señor, Dios de mi amo Abrahán, que no ha dejado de mostrar su amistad y bondad para con mi señor y a mí me ha encaminado a la casa de los hermanos de mi amo'."
,"28":"La joven corrió a casa de su madre y contó todo lo sucedido."
,"29":"Rebeca tenía un hermano de nombre Labán, el cual salió aprisa al encuentro del criado junto a la fuente."
,"30":"Al ver el anillo y los brazaletes que llevaba su hermana y al oírla contar todo lo que aquel hombre le había dicho, fue hasta él, pues estaba todavía con los camellos junto a la fuente,"
,"31":"y le dijo: 'Ven, bendito del Señor, ¿por qué has de quedarte afuera? Tengo ya dispuesta la casa y el lugar para los camellos'."
,"32":"El hombre fue a la casa. Labán desaparejó los camellos y les dio paja y forraje; a él y a sus acompañantes les trajo agua para que se lavaran los pies."
,"33":"Después le trajeron comida; pero él dijo: 'No comeré hasta haber dicho lo que tengo que decir'. Labán respondió: 'Habla'."
,"34":"Él prosiguió: 'Yo soy criado de Abrahán."
,"35":"El Señor ha colmado de bendiciones a mi amo y le ha enriquecido mucho; le ha dado ovejas y vacas, plata y oro, criados y criadas, camellos y asnos."
,"36":"Sara, mujer de mi amo, le dio un hijo a su vejez, al que ha dado todo cuanto posee."
,"37":"Mi amo me hizo prestar este juramento: No tomarás mujer para mi hijo de entre las hijas de los cananeos, en cuya tierra habito,"
,"38":"sino que irás a la casa de mi padre, a mi familia, y de allí tomarás mujer para mi hijo."
,"39":"Yo le dije a mi amo: ¿Y si la mujer no quiere venir conmigo?"
,"40":"Él me respondió: El Señor, en cuya presencia he caminado siempre, enviará su ángel contigo y dará éxito a tu viaje. Tú tomarás para mi hijo una mujer de mi familia y de la casa de mi padre."
,"41":"Quedarás libre del juramento que me haces solamente cuando hayas llegado a mi familia y no te la hayan querido dar."
,"42":"Hoy llegué a la fuente y dije: Señor, Dios de mi amo Abrahán, lleva a feliz éxito el viaje que he emprendido;"
,"43":"yo me quedaré aquí junto a la fuente; la joven que salga por agua, a la que yo diga: Dame de beber de tu cántaro"
,"44":"y me responda: Bebe y sacaré también para tus camellos, sea la mujer destinada por el Señor para el hijo de mi amo."
,"45":"No había acabado yo de hablar, y he aquí que salía Rebeca con su cántaro al hombro; bajó a la fuente y sacó agua. Yo le dije: Dame de beber."
,"46":"Y, aprisa, bajó ella el cántaro de su hombro y dijo: Bebe, y daré también agua a tus camellos. Yo bebí, y ella dio también agua a mis camellos."
,"47":"Entonces le pregunté: ¿De quién eres hija? Y ella me respondió: Soy hija de Betuel, el hijo que Milcá dio a Najor. Entonces le puse el anillo en la nariz y los brazaletes en los brazos."
,"48":"Me incliné después profundamente y adoré y bendije al Señor, Dios de mi amo Abrahán, que me había guiado por el recto camino para tomar para el hijo de mi amo a la hija de su hermano."
,"49":"Ahora, si queréis mostrar amistad y lealtad hacia mi amo, decídmelo; y si no, decídmelo también, para saber a qué atenerme'."
,"50":"Labán y Betuel tomaron la palabra y dijeron: 'La cosa procede del Señor; nosotros no podemos decir ni que sí ni que no."
,"51":"Ahí está Rebeca delante de ti, tómala y vete; que sea la mujer del hijo de tu amo, como ha dicho el Señor'."
,"52":"Al oír estas palabras, el criado de Abrahán se postró en tierra ante el Señor."
,"53":"Sacó joyas de plata y oro y vestidos, y se lo dio a Rebeca. Hizo también ricos presentes a su hermano y a su madre."
,"54":"Comieron y bebieron él y sus acompañantes, y pasaron allí la noche. A la mañana siguiente, cuando se levantaron, él dijo: 'Dejadme volver a mi amo'. "
,"55":"Pero el hermano y la madre de Rebeca le dijeron: 'Que se quede la joven todavía algunos días con nosotros, y después irá'."
,"56":"Y él les contestó: 'Puesto que el Señor ha dado éxito a mi viaje, no me entretengáis; dejadme partir para volver a mi señor'."
,"57":"Y ellos le dijeron: 'Llamemos a la joven, y que ella decida'."
,"58":"Llamaron a Rebeca y le dijeron: '¿Quieres irte con este hombre?'. Ella respondió: 'Sí'. "
,"59":"Y ellos dejaron partir a su hermana Rebeca, a su nodriza, al criado de Abrahán y a sus hombres."
,"60":"Y bendijeron a Rebeca diciendo: 'Tú eres nuestra hermana; ¡crece en millares de millares!,¡Que tu descendencia ocupe la puerta,de sus enemigos!'."
,"61":"Rebeca y sus siervas se levantaron, montaron sobre los camellos y siguieron a aquel hombre. Y el criado, llevando consigo a Rebeca, se fue."
,"62":"Isaac, mientras tanto, se había trasladado del pozo de Lajay-Roí y estaba viviendo en el Negueb."
,"63":"Una tarde salió a dar un paseo por el campo y, levantando los ojos, vio que se acercaban unos camellos."
,"64":"También Rebeca levantó los ojos y vio a Isaac. Bajó del camello"
,"65":"y dijo al criado: '¿Quién es aquel hombre que viene por el campo hacia nosotros?'. El criado respondió: 'Es mi amo'. Ella entonces tomó el velo y se cubrió."
,"66":"El criado contó a Isaac todo lo que había hecho."
,"67":"Isaac introdujo a Rebeca en la tienda de Sara, la tomó y fue su mujer. La amó, y se consoló de la muerte de su madre."
}`)
	CurrentBook.AddChapter(25, `{
"1":"Abrahán tomó después otra mujer, llamada Queturá,"
,"2":"de la que tuvo a Zimrán, Yocsán, Medán, Madián, Yisbac y Súaj."
,"3":"Yocsán engendró a Sebá y Dedán. Los hijos de Dedán fueron los asuritas, los letusitas y los leumitas."
,"4":"Los hijos de Madián fueron Efá, Éfer, Henoc, Abidá y Eldaá. Todos éstos fueron los hijos de Queturá."
,"5":"Pero Abrahán dio todos sus bienes a Isaac."
,"6":"A los hijos de sus concubinas les hizo donaciones y, antes de morir, los envió lejos de Isaac, su hijo, hacia levante."
,"7":"Abrahán vivió ciento setenta y cinco años."
,"8":"Murió en buena vejez, anciano, lleno de días, y fue a reunirse con sus antepasados."
,"9":"Sus hijos, Isaac e Ismael, lo enterraron en la cueva de Macpela, en el campo de Efrón, hijo de Sojar, el hitita, enfrente de Mambré."
,"10":"Es el campo que compró a los hititas. En él fueron enterrados Abrahán y Sara, su mujer."
,"11":"Después de la muerte de Abrahán, Dios bendijo a Isaac, su hijo, que se quedó a vivir junto al pozo de Lajay-Roí."
,"12":"Éstos son los descendientes de Ismael, hijo de Abrahán, el que le dio Agar, la egipcia, esclava de Sara,"
,"13":"por nombres y familias: el primogénito de Ismael fue Nabayot; después Quedar, Adbeel, Mibsán,"
,"14":"Mismá, Dumá, Masá,"
,"15":"Jadad, Temá, Yetur, Nafís y Quedma."
,"16":"Tales son los hijos de Ismael, y tales sus nombres según sus poblados y campamentos: doce jefes de tribus."
,"17":"Ismael vivió ciento treinta y siete años. Murió, y fue a reunirse con sus padres."
,"18":"Sus hijos habitaron desde Javilá hasta Sur, enfrente de Egipto, según se va a Asiria. Él se estableció enfrente de todos sus hermanos."
,"19":"Historia de Isaac, hijo de Abrahán: Abrahán engendró a Isaac, "
,"20":"el cual, a la edad de cuarenta años, se casó con Rebeca, hija de Betuel, el arameo de Padán Arán, y hermana de Labán."
,"21":"Isaac rezó al Señor por su mujer, que era estéril. El Señor le escuchó, y Rebeca quedó encinta."
,"22":"Los niños se chocaban en su seno, y ella dijo: 'Si es así, ¿qué será de mí?'. Y fue a consultar al Señor."
,"23":"El Señor le respondió: 'Dos naciones hay en tu seno, dos pueblos se separarán desde tus entrañas; uno será más fuerte que el otro, y el mayor servirá al menor'."
,"24":"A la hora del parto, se encontraron gemelos en su seno."
,"25":"Salió el primero, rubio y todo él velludo como una pelliza, y le llamaron Esaú."
,"26":"En seguida salió su hermano, con la mano agarrada al talón de Esaú, y le llamaron Jacob. Isaac tenía sesenta años cuando Rebeca los dio a luz."
,"27":"Los niños crecieron; Esaú llegó a ser un diestro cazador y hombre de campo, mientras que Jacob era hombre tranquilo y amante de la tierra."
,"28":"Isaac prefería a Esaú, porque la caza era plato de su gusto, mientras que Rebeca prefería a Jacob."
,"29":"Un día Jacob se había preparado un potaje, y Esaú volvía del campo; estaba agotado, y"
,"30":"dijo a Jacob: 'Déjame comer eso rojo que tienes ahí, pues estoy agotado'. (Por esto se le llamó Edón)."
,"31":"Jacob le respondió: 'Véndeme ahora mismo tu primogenitura'."
,"32":"Y Esaú respondió: 'Estoy que me muero, ¿de qué me sirve la primogenitura?'."
,"33":"Jacob insistió: 'Júramelo antes'. Él se lo juró, y vendió a Jacob su primogenitura. "
,"34":"Entonces Jacob le dio pan y el potaje de lentejas; él comió y bebió, se levantó y se fue. Así menospreció Esaú su primogenitura."
}`)
	CurrentBook.AddChapter(26, `{
"1":"Hubo hambre en el país (otra distinta de la que hubo en tiempo de Abrahán), e Isaac se fue a Guerar con Abimelec, rey de los filisteos."
,"2":"Allí se le apareció el Señor y le dijo: 'No bajes a Egipto; quédate en el país que yo te diré."
,"3":"Reside en ese país, y yo estaré contigo y te bendeciré; porque a ti y a tu descendencia os daré esta tierra cumpliendo el juramento que hice a tu padre Abrahán."
,"4":"Multiplicaré tu descendencia como las estrellas del cielo y le daré todas estas tierras, y en tu descendencia serán benditas todas las naciones de la tierra;"
,"5":"porque Abrahán me obedeció y guardó mis preceptos y mandamientos, mis estatutos y mis leyes'."
,"6":"Isaac se estableció en Guerar."
,"7":"Las gentes del lugar le preguntaban si Rebeca era su mujer, y él respondía que era su hermana, pues tenía miedo de decir que era su mujer; porque como Rebeca era muy bella, pensaba que aquellos hombres podían matarle."
,"8":"Cuando ya llevaba algún tiempo entre ellos, un día Abimelec, rey de los filisteos, mirando por una ventana, vio que Isaac acariciaba a Rebeca, su mujer."
,"9":"Entonces Abimelec mandó llamar a Isaac y le dijo: 'Ésta es sin duda tu mujer. ¿Por qué dijiste que era tu hermana?'. Isaac respondió: 'Porque pensé que a lo mejor me matarían por causa de ella'."
,"10":"Y Abimelec añadió: '¿Por qué nos has hecho esto? Cualquiera habría podido acostarse con tu mujer, y habrías traído sobre nosotros un pecado'."
,"11":"Entonces Abimelec dio esta orden al pueblo: 'El que toque a este hombre o a su mujer será castigado con la muerte'."
,"12":"Isaac sembró la tierra donde estaba, y aquel año recolectó cien veces más. ¡Tanto le bendijo el Señor!"
,"13":"Se enriqueció y se fue enriqueciendo más y más, hasta llegar a ser riquísimo."
,"14":"Poseía rebaños de ovejas y vacas y numerosa servidumbre. Los filisteos comenzaron a tenerle envidia, "
,"15":"por lo que cegaron y llenaron de tierra los pozos que los criados de su padre habían abierto en tiempos de Abrahán."
,"16":"Abimelec dijo a Isaac: 'Vete de aquí, porque has llegado a ser más poderoso que nosotros'."
,"17":"Isaac se fue de allí y plantó sus tiendas en el valle de Guerar."
,"18":"Abrió de nuevo los pozos que habían sido abiertos en tiempos de su padre Abrahán y que los filisteos, después de la muerte de Abrahán, habían cegado, y les dio los mismos nombres con que los había llamado su padre."
,"19":"Los criados de Isaac excavaron en el valle y encontraron en él un pozo de agua corriente."
,"20":"Los pastores de Guerar riñeron con los de Isaac diciendo: 'Este pozo es nuestro'. Él llamó a este pozo Éseq, porque había habido riña por él."
,"21":"Cavaron de nuevo otro pozo, y también por éste riñeron, por lo que Isaac llamó a este pozo Sitná."
,"22":"Se fue de allí y cavó otro pozo, por el que ya no hubo riña; y le llamó Rejobot, porque dijo: 'Finalmente el Señor nos ha dado campo libre para que prosperemos en esta tierra'."
,"23":"De allí subió a Berseba."
,"24":"Y aquella misma noche se le apareció el Señor y le dijo: 'Yo soy el Dios de tu padre Abrahán. No temas, porque yo estoy contigo. Te bendeciré, y multiplicaré tu descendencia por amor de Abrahán, mi siervo'."
,"25":"Levantó un altar en aquel lugar e invocó el nombre del Señor. Plantó allí sus tiendas, y sus criados abrieron un pozo."
,"26":"Abimelec vino a verle desde Guerar, acompañado de Ajuzat, su consejero, y de Picol, jefe de su ejército."
,"27":"Isaac les preguntó: '¿Por qué habéis venido a verme vosotros, que me odiáis y que me habéis echado de vuestro país?'. "
,"28":"Ellos respondieron: 'Hemos visto claramente que el Señor está contigo y hemos dicho: Haya un juramento entre ti y nosotros y hagamos un pacto contigo."
,"29":"Jura que no nos harás daño, como nosotros no te hemos tocado y no te hemos hecho sino bien dejándote ir en paz. Tú eres ahora el bendito del Señor'."
,"30":"Isaac les dio un banquete, y comieron y bebieron."
,"31":"A la mañana siguiente se levantaron de madrugada y se prestaron juramento mutuamente. Isaac los despidió, y ellos se fueron en paz."
,"32":"Aquel mismo día vinieron sus siervos y le comunicaron lo del pozo que habían abierto; le dijeron: 'Hemos encontrado agua';"
,"33":"y él llamó a aquel pozo Seba. Por esto la ciudad lleva hoy el nombre de Berseba."
,"34":"Esaú, a la edad de cuarenta años, se casó con Judit, hija del hitita Beeri, y con Basmat, hija del hitita Elón."
,"35":"Estas mujeres amargaron la vida a Isaac y a Rebeca."
}`)
	CurrentBook.AddChapter(27, `{
"1":"Isaac era ya viejo y se había quedado ciego. Llamó a su hijo mayor, Esaú, y le dijo: '¡Hijo mío!'. 'Aquí estoy', respondió él."
,"2":"'Como ves, continuó Isaac, yo soy viejo y no sé cuándo moriré."
,"3":"Toma tu aljaba y tu arco, sal al campo y tráeme algo de caza."
,"4":"Prepárame un guisado como a mí me gusta y tráemelo para que coma y te bendiga antes de morir'."
,"5":"Rebeca había estado escuchando lo que Isaac decía a su hijo Esaú; y, tan pronto como éste se fue al campo en busca de caza para su padre,"
,"6":"llamó a su hijo Jacob y le dijo: 'Acabo de oír a tu padre decir a tu hermano:"
,"7":"Tráeme caza y prepárame un guisado, para que coma y te bendiga delante del Señor antes de morir."
,"8":"Hijo mío, escúchame y haz lo que te mando."
,"9":"Vete al rebaño y tráeme dos cabritos. Yo prepararé a tu padre un guisado como a él le gusta,"
,"10":"y tú se lo llevarás a tu padre para que lo coma y después te bendiga antes de morir'."
,"11":"Jacob respondió a Rebeca, su madre: 'Tú sabes que mi hermano Esaú es hombre velludo y yo lampiño;"
,"12":"si mi padre me palpa, se dará cuenta de que le estoy engañando, y yo atraería sobre mí una maldición en lugar de la bendición'."
,"13":"Su madre le respondió: 'Tu maldición, hijo mío, caiga sobre mí. Tú obedéceme; ve y tráeme los cabritos'."
,"14":"Él fue a buscar los cabritos y se los trajo a su madre, que preparó el guiso como a su padre le gustaba."
,"15":"Tomó después Rebeca vestidos de Esaú, su hijo mayor, los más bonitos que tenía en casa, y se los puso a Jacob, su hijo menor."
,"16":"Con las pieles de los cabritos cubrió sus manos y la parte lisa de su cuello,"
,"17":"y puso en las manos de Jacob el guiso que ella había preparado y el pan."
,"18":"Jacob se acercó a su padre y le dijo: '¡Padre!'. 'Aquí estoy, respondió él. ¿Quién eres, hijo mío?'."
,"19":"Y Jacob dijo a su padre: 'Soy Esaú, tu primogénito. He hecho lo que me mandaste; levántate y come de la caza, para que después me bendigas'. "
,"20":"Isaac dijo a su hijo: '¿Cómo la has encontrado tan pronto, hijo mío?'. Él respondió: 'Porque el Señor, tu Dios, me la ha puesto en las manos'."
,"21":"Isaac dijo a Jacob: 'Acércate, hijo mío, para que yo te palpe, a ver si eres mi hijo Esaú o no'."
,"22":"Jacob se acercó a su padre Isaac, el cual, después de haberle palpado, dijo: 'La voz es la voz de Jacob, pero las manos son las manos de Esaú'."
,"23":"Y no le reconoció porque las manos eran velludas como las de su hermano Esaú, y se dispuso a bendecirle."
,"24":"Pero todavía insistió: '¿Eres tú de verdad mi hijo Esaú?'. Y respondió: 'Sí, yo soy'. "
,"25":"Entonces le dijo: 'Acércame la caza para que coma y después te bendiga'. Jacob se la acercó y comió; le trajo también vino y bebió."
,"26":"Después Isaac, su padre, le dijo: 'Ahora acércate y bésame, hijo mío'."
,"27":"Él se acercó y lo besó. Y cuando Isaac sintió la fragancia de sus vestidos le bendijo así: 'Oh, el olor de mi hijo es como el olor de un campo fértil que el Señor ha bendecido."
,"28":"Dios te dé el rocío del cielo y la fertilidad de la tierra y abundancia de trigo y mosto."
,"29":"Que los pueblos te sirvan y las naciones se inclinen ante ti. Sé señor de tus hermanos e inclínense ante ti los hijos de tu madre. Maldito sea el que te maldiga y bendito el que te bendiga'."
,"30":"Tan pronto como Isaac acabó de bendecir a Jacob y éste salió de su presencia, volvió de la caza su hermano Esaú."
,"31":"Preparó también él un guisado, se lo llevó a su padre y le dijo: 'Levántese mi padre y coma de la caza de su hijo para que me bendiga'. "
,"32":"Isaac le dijo: '¿Quién eres tú?'. Él respondió: 'Yo soy Esaú, tu hijo primogénito'."
,"33":"Isaac sintió un fuerte estremecimiento y dijo: '¿Pues quién ha sido el que me ha traído la caza? Yo he comido de ella antes de que tú vinieras, y lo he bendecido, y ¡bendito será!'."
,"34":"Cuando Esaú oyó las palabras de su padre gritó con gran fuerza su amargura, y dijo a su padre: 'Bendíceme también a mí, padre mío'. "
,"35":"Pero éste respondió: 'Tu hermano ha venido con engaño y se ha llevado tu bendición'."
,"36":"Esaú continuó: 'No por nada se llama Jacob; ya me ha suplantado dos veces. Se alzó con mi primogenitura, y ahora se ha llevado mi bendición'. Y añadió: '¿No tienes ya bendición para mí?'."
,"37":"Isaac le respondió: 'Yo le he constituido señor tuyo y le he dado por siervos a todos sus hermanos; le he provisto de trigo y de vino, ¿qué puedo hacer ahora por ti, hijo mío?'."
,"38":"Esaú dijo a su padre: '¿No tienes más que una sola bendición? Bendíceme también a mí, padre mío'. Y alzó la voz y lloró."
,"39":"Entonces su padre tomó la palabra y dijo: 'Lejos de tu tierra será tu residencia, lejos del rocío del cielo."
,"40":"Vivirás de tu espada y servirás a tu hermano; pero cuando te subleves sacudirás su yugo de tu cuello'."
,"41":"Desde entonces Esaú aborreció a Jacob por la bendición con que su padre le había bendecido, y se dijo: 'Están próximos los días en que se hará el duelo por mi padre; entonces mataré a mi hermano Jacob'."
,"42":"Le contaron a Rebeca las palabras de su hijo mayor. Ella mandó llamar a Jacob, su hijo menor, y le dijo: 'Mira, Esaú, tu hermano, quiere vengarse de ti matándote. "
,"43":"Por tanto, hijo mío, obedéceme; huye rápidamente a casa de mi hermano Labán, a Jarán."
,"44":"Quédate con él por algún tiempo, hasta que la ira de tu hermano contra ti se haya aplacado"
,"45":"y se olvide de lo que le has hecho. Entonces yo mandaré a buscarte. ¿Por qué tendría yo que perder a los dos hijos en un mismo día?'."
,"46":"Después dijo a Isaac: 'Estoy asqueada de la vida, a causa de estas hititas. Si Jacob se casa con una hitita como éstas, ¿qué me importa la vida?'."
}`)
	CurrentBook.AddChapter(28, `{
"1":"Isaac llamó a Jacob, le bendijo y le dio esta orden: 'No te cases con una cananea."
,"2":"Anda, vete a Padán Arán a casa de Betuel, padre de tu madre, y cásate con una de las hijas de Labán, hermano de tu madre."
,"3":"Que el Dios todopoderoso te bendiga y te haga tan fecundo y numeroso que llegues a ser una comunidad de pueblos."
,"4":"Que él te dé la bendición de Abrahán, a ti y a tus descendientes contigo, para que poseas la tierra en que resides, la que Dios dio a Abrahán'."
,"5":"Así despidió Isaac a Jacob, y éste se fue a Padán Arán, a casa de Labán, hijo de Betuel, el arameo, y hermano de Rebeca, madre de Esaú y Jacob."
,"6":"Esaú vio que Isaac había bendecido a Jacob y le había enviado a Padán Arán para que se casara allí, y que al bendecirle le había dado esta orden: 'No te cases con una cananea';"
,"7":"y que Jacob, obedeciendo a su padre y a su madre, había partido para Padán Arán."
,"8":"Esaú comprendió que las cananeas eran mal vistas por su padre Isaac;"
,"9":"se fue donde Ismael y, además de las que ya tenía, tomó por mujer a Majalat, hija de Ismael, el hijo de Abrahán, hermana de Nebayot."
,"10":"Jacob salió de Berseba con dirección a Jarán."
,"11":"Llegó a cierto lugar y se dispuso a pasar allí la noche, porque el sol ya se había puesto. Tomó una piedra, la puso por cabecera y se acostó."
,"12":"Tuvo un sueño. Veía una escalera que, apoyándose en la tierra, tocaba con su cima en el cielo, y por la que subían y bajaban los ángeles del Señor."
,"13":"Arriba estaba el Señor, el cual dijo: 'Yo soy el Señor, el Dios de Abrahán, tu antepasado, y el Dios de Isaac. Yo te daré a ti y a tu descendencia la tierra en que descansas."
,"14":"Tu descendencia será como el polvo de la tierra; te extenderás a oriente y a occidente, al norte y al sur. Por ti y por tu descendencia serán bendecidas todas las naciones de la tierra."
,"15":"Yo estoy contigo. Te guardaré dondequiera que vayas y te volveré a esta tierra, porque no te abandonaré hasta que no haya cumplido lo que te he prometido'."
,"16":"Jacob se despertó de su sueño y dijo: 'Ciertamente el Señor está en este lugar y yo no lo sabía'."
,"17":"Tuvo miedo y dijo: '¡Qué terrible es este lugar! ¡Nada menos que la casa de Dios y la puerta del cielo'."
,"18":"Se levantó muy de mañana, tomó la piedra que había puesto por cabecera, la levantó a modo de estela y derramó aceite sobre ella."
,"19":"Y dio a este lugar el nombre de Betel; antes se llamaba Luz."
,"20":"Jacob hizo esta promesa: 'Si Dios está conmigo, me protege en este viaje que estoy haciendo y me da pan para comer, vestidos para cubrirme"
,"21":"y puedo volver sano y salvo a la casa de mi padre, entonces el Señor será mi Dios"
,"22":"y esta piedra que he levantado a modo de estela será un santuario; de todo lo que me des te devolveré puntualmente la décima parte'."
}`)
	CurrentBook.AddChapter(29, `{
"1":"Jacob se puso de nuevo en camino y llegó a la tierra de los orientales."
,"2":"Miró y vio un pozo en medio del campo, junto al cual sesteaban tres rebaños de ovejas, porque en él solían abrevar los ganados; pero en la boca del pozo había una piedra muy grande."
,"3":"Por eso los pastores juntaban primero todos sus rebaños, luego quitaban la piedra y, una vez abrevado el ganado, la volvían a su sitio."
,"4":"Jacob les dijo: 'Hermanos míos, ¿de dónde sois?'. Respondieron: 'Somos de Jarán'. "
,"5":"Les dijo: '¿Conocéis a Labán, hijo de Najor?'. Respondieron: 'Sí, le conocemos'. "
,"6":"Y él les dijo: '¿Está bien?'. Respondieron: 'Sí. Ésa que viene con las ovejas es su hija Raquel'. "
,"7":"Él les dijo: 'Todavía es muy de día, y no es hora de retirar el ganado; abrevad las ovejas y llevadlas a pastar'. Ellos respondieron:"
,"8":"'No podemos hacerlo hasta que se hayan reunido todos los rebaños y sea removida la piedra; solamente entonces podremos abrevar las ovejas'."
,"9":"Estaba todavía hablando con ellos cuando llegó Raquel con las ovejas de su padre, pues era pastora."
,"10":"Jacob, al ver a Raquel, hija de Labán, su tío, con las ovejas de Labán, hermano de su madre, se acercó, quitó la piedra de la boca del pozo y abrevó las ovejas de su tío Labán."
,"11":"Después besó a Raquel y rompió a llorar."
,"12":"Declaró luego a Raquel que él era sobrino de su padre, ya que era hijo de Rebeca, y ella corrió a contárselo a su padre."
,"13":"Cuando Labán oyó que había llegado su sobrino Jacob, corrió a su encuentro, lo abrazó, lo besó y lo llevó a su casa. Jacob contó a Labán todo lo sucedido."
,"14":"Labán le dijo: '¡En verdad, tú eres hueso mío y carne mía!'. Y Jacob se quedó con él. Pasado un mes, "
,"15":"Labán dijo a Jacob: '¿Por ser sobrino mío, me vas a servir de balde? Dime cuál ha de ser tu salario'."
,"16":"Labán tenía dos hijas. La mayor se llamaba Lía y la menor Raquel."
,"17":"Lía tenía los ojos tiernos, mientras que Raquel era guapa y de lindo semblante."
,"18":"Jacob amaba a Raquel, y dijo: 'Te serviré siete años a cambio de Raquel, tu hija menor'."
,"19":"Y Labán respondió: 'Más vale dártela a ti que no a un extraño; quédate conmigo'."
,"20":"Y Jacob sirvió siete años por Raquel, que le parecieron unos días; tan grande era el amor que le tenía."
,"21":"Después dijo a Labán: 'Dame mi mujer, porque mi tiempo se ha cumplido, para que viva con ella'."
,"22":"Labán invitó a todas las gentes del lugar y dio un gran banquete."
,"23":"Por la noche tomó a su hija Lía y se la trajo a Jacob, que se unió a ella."
,"24":"Labán dio a su hija Lía, por esclava, a su propia esclava Zilpa."
,"25":"A la mañana siguiente Jacob se dio cuenta que era Lía, y dijo a Labán: '¿Qué es lo que me has hecho? ¿No te he servido yo por Raquel? ¿Por qué me has engañado?'."
,"26":"Y Labán respondió: 'En nuestra tierra no es costumbre dar la menor antes que la mayor."
,"27":"Acaba la semana de bodas con ésta y se te dará también la otra por el servicio que has de prestarme por otros siete años'."
,"28":"Jacob lo hizo así. Terminó la semana de bodas con la primera, y Labán le dio también por mujer a su hija Raquel,"
,"29":"a la que dio por esclava su propia esclava Bihlá."
,"30":"Jacob se unió también a Raquel, y la amó más que a Lía, y sirvió en casa de su tío siete años más."
,"31":"El Señor vio que Lía era despreciada y la hizo fecunda, mientras que Raquel era estéril."
,"32":"Lía concibió y dio a luz un hijo, al que llamó Rubén, pues dijo: 'El Señor ha visto mi humillación; ahora mi marido me amará'."
,"33":"Concibió de nuevo y dio a luz otro hijo, diciendo: 'El Señor ha visto que era despreciada y me ha dado también este hijo'. Y le llamó Simeón."
,"34":"Concibió otra vez, dio a luz un tercer hijo, y dijo: 'Ahora sí que se aficionará a mí mi marido, porque le he dado tres hijos'. Por ello le puso el nombre de Leví."
,"35":"Volvió a concebir y dio a luz un cuarto hijo, y dijo: 'Esta vez alabaré al Señor'. Por eso le llamó Judá. Después dejó de tener hijos."
}`)
	CurrentBook.AddChapter(30, `{
"1":"Viendo Raquel que no daba hijos a Jacob, tuvo envidia de su hermana y dijo a Jacob: 'Dame hijos, si no me muero'."
,"2":"Jacob se irritó contra ella y dijo: '¿Soy yo acaso igual a Dios, que te ha negado la fecundidad?'."
,"3":"Y ella respondió: 'Ahí tienes a mi esclava Bihlá, llégate a ella. Ella dará a luz sobre mis rodillas, y así yo también tendré hijos por medio de ella'."
,"4":"Le dio por mujer a su esclava Bihlá, y Jacob se unió a ella."
,"5":"Bilhá concibió y dio a Jacob un hijo."
,"6":"Raquel dijo: 'Dios me ha hecho justicia y ha escuchado mi voz dándome un hijo'. Por eso le puso el nombre de Dan."
,"7":"Bihlá, esclava de Raquel, concibió otra vez y dio un segundo hijo a Jacob."
,"8":"Y Raquel dijo: 'Luchas ingentes he sostenido contra mi hermana, pero he vencido'. Por eso le puso por nombre Neftalí."
,"9":"Entonces Lía, viendo que había dejado de tener hijos, tomó a Zilpa, su esclava, y se la dio a Jacob por mujer."
,"10":"Y Zilpa, esclava de Lía, dio un hijo a Jacob."
,"11":"Lía dijo: '¡Qué ventura!', y le puso por nombre Gad. "
,"12":"Zilpa, esclava de Lía, dio un segundo hijo a Jacob,"
,"13":"y Lía dijo: '¡Para dicha mía!, porque las mujeres me dirán dichosa'. Y le llamó Aser."
,"14":"Rubén, al tiempo de la siega de los trigos, fue por los campos y encontró mandrágoras, y se las trajo a su madre Lía. Y Raquel dijo a Lía: 'Dame, por favor, las mandrágoras de tu hijo'."
,"15":"Y ella contestó: '¿Te parece poco haberme quitado a mi marido, que me quieres quitar también las mandrágoras de mi hijo?'. Entonces Raquel dijo: 'Pues bien, que Jacob duerma contigo esta noche a cambio de las mandrágoras de tu hijo'."
,"16":"A la tarde, cuando Jacob volvía del campo, salió Lía a su encuentro y le dijo: 'Tienes que dormir conmigo, porque te he alquilado por las mandrágoras de mi hijo'. Y él durmió con ella aquella noche."
,"17":"Dios escuchó a Lía, que concibió y dio a Jacob el quinto hijo,"
,"18":"y dijo: 'Dios me ha dado mi recompensa por haber dado mi esclava a mi marido'. Y le llamó Isacar."
,"19":"Otra vez concibió Lía y dio a Jacob el sexto hijo."
,"20":"Y dijo: 'Dios me ha hecho un buen regalo. Esta vez sí que se quedará conmigo mi marido, porque le he dado seis hijos'. Y le llamó Zabulón."
,"21":"Después dio a luz una hija y la llamó Dina."
,"22":"Dios se acordó también de Raquel, la escuchó y la hizo fecunda."
,"23":"Concibió, pues, y dio a luz un hijo, y dijo: 'Dios me ha quitado la afrenta',"
,"24":"y le llamó José, diciendo: 'Que el Señor me dé todavía otro hijo'."
,"25":"Cuando Raquel dio a luz a José, Jacob dijo a Labán: 'Déjame volver a mi lugar natal, a mi tierra."
,"26":"Dame mis hijos y mis mujeres, por las que te he servido, y me iré. Bien sabes tú el servicio que te he prestado'."
,"27":"Labán le dijo: '¡Si he hallado gracia a tus ojos, quédate! He adivinado que el Señor me ha bendecido gracias a ti'."
,"28":"Y añadió: 'Fija tú el salario que debo darte'."
,"29":"Jacob respondió: 'Tú sabes cómo te he servido y lo que, gracias a mí, ha llegado a ser tu ganado."
,"30":"Poco, realmente, era lo que tenías antes de mi venida, mientras que ahora ha aumentado grandemente bajo mi dirección y el Señor te ha bendecido. Pero ¿cuándo podré hacer yo también algo por mi casa?'."
,"31":"Labán respondió: '¿Qué he de darte?'. Y Jacob le dijo: 'No tendrás que darme nada. Si haces lo que voy a proponerte, volveré a apacentar tus ovejas. "
,"32":"Yo pasaré hoy en medio de tus rebaños y pondré aparte todas las ovejas negras y todas las cabras manchadas. Esas reses serán mi salario."
,"33":"Mi honradez testimoniará por mí después; cuando vengas a verificar mi salario, toda res que no sea manchada entre las cabras y negra entre las ovejas, que sea un robo por mi parte'."
,"34":"Labán dijo: 'Bien; que sea así, como tú has dicho'. "
,"35":"Y aquel mismo día Labán separó los machos cabríos manchados, todas las cabras manchadas, toda res con manchas blancas y todas las ovejas negras, y se las entregó a sus hijos,"
,"36":"y se separó de Jacob a una distancia de tres días de camino. Jacob siguió apacentando el resto de los rebaños de Labán."
,"37":"Buscó varas verdes de álamo, almendro y plátano, las descortezó e hizo en ellas franjas blancas, dejando así al descubierto lo blanco de las varas."
,"38":"Colocó luego las varas, así descortezadas, unas frente a otras en las pilas y abrevaderos adonde iban a beber los ganados, los cuales se encelaban al ir a beber."
,"39":"Y así, apareándose delante de las varas, engendraban y parían crías rayadas o manchadas."
,"40":"Jacob puso aparte las ovejas y las apareó con machos negros o manchados del rebaño de Labán; de este modo se hizo un rebaño propio separándolo del rebaño de Labán."
,"41":"Cuando las reses robustas se encelaban, Jacob ponía las varas delante de ellas, para que se apareasen a vista de las varas."
,"42":"Pero ante las débiles no las ponía. Y así las crías débiles eran para Labán y las robustas para Jacob."
,"43":"De este modo se enriqueció enormemente y tuvo numerosos rebaños, esclavos y esclavas, camellos y asnos."
}`)
	CurrentBook.AddChapter(31, `{
"1":"Después oyó que los hijos de Labán andaban diciendo: 'Jacob se ha apoderado de lo que es de nuestro padre; a expensas de nuestro padre ha hecho toda esta riqueza'."
,"2":"Se dio también cuenta de que Labán no le miraba ya como antes."
,"3":"El Señor dijo a Jacob: 'Vuelve a la tierra de tus padres, a tu familia, y yo estaré contigo'."
,"4":"Jacob mandó llamar a Raquel y a Lía al campo donde estaba el rebaño,"
,"5":"y les dijo: 'Veo que vuestro padre ya no me mira como antes, pero el Dios de mi padre ha estado conmigo. "
,"6":"Bien sabéis que he servido a vuestro padre con todas mis fuerzas;"
,"7":"él, en cambio, me ha engañado y me ha mudado el salario diez veces, aunque Dios no le ha permitido hacerme mal."
,"8":"Si él decía: Las reses manchadas serán tu salario, todas las ovejas del rebaño parían corderos manchados; si decía: Las reses rayadas serán tu salario, todas las ovejas parían corderos rayados."
,"9":"Así ha quitado Dios el ganado a vuestro padre y me lo ha dado a mí."
,"10":"Sucedió que al tiempo en que las ovejas se encelaban, yo levanté los ojos y vi en sueños que los machos que cubrían a las ovejas eran todos manchados y rayados."
,"11":"Y el ángel del Señor me dijo en sueños: Jacob. Yo le dije: Aquí estoy."
,"12":"Y él me dijo: Levanta los ojos y verás cómo todos los machos que cubren a las ovejas son manchados y rayados, porque he visto todo lo que te ha hecho Labán."
,"13":"Yo soy el Dios de Betel, en donde tú ungiste aquella estela y donde hiciste la promesa. Ahora levántate, sal de esta tierra y vuelve a tu patria'."
,"14":"Raquel y Lía le respondieron: '¿Tenemos acaso nosotras parte o herencia en la casa de nuestro padre?"
,"15":"¿No nos ha tratado como extrañas vendiéndonos y comiéndose nuestro precio?"
,"16":"Por tanto, toda la riqueza que Dios ha quitado a nuestro padre es nuestra y de nuestros hijos; así que haz todo lo que Dios te ha dicho'."
,"17":"Jacob se levantó, montó a sus hijos y a sus mujeres en camellos"
,"18":"y, con todo su ganado y todo lo que había adquirido en Padán Arán, se puso en camino hacia Isaac, su padre, a la tierra de Canaán."
,"19":"Mientras Labán se había ido al esquileo de sus ovejas, Raquel robó los ídolos familiares a su padre."
,"20":"Jacob engañó a Labán, el arameo, no descubriéndole su intención de huir."
,"21":"Huyó con todo lo que tenía, atravesó el río y partió en dirección a los montes de Galaad."
,"22":"Al tercer día Labán se enteró de que Jacob había huido"
,"23":"y, tomando consigo a sus hermanos, le persiguió por espacio de siete días, hasta darle alcance en los montes de Galaad."
,"24":"Dios se apareció en sueños de noche a Labán, el arameo, y le dijo: 'Guárdate de hablar a Jacob, ni bien ni mal'. "
,"25":"Labán alcanzó a Jacob, que había plantado sus tiendas en el monte; Labán también plantó las suyas en el mismo monte de Galaad."
,"26":"Labán dijo a Jacob: '¿Qué es lo que has hecho? Me has engañado y te has llevado a mis hijas como si fueran prisioneras de guerra."
,"27":"¿Por qué has huido en secreto, con engaño y sin avisarme? Yo te habría despedido con alegría y con cánticos al son de tambores y vihuelas."
,"28":"Y tú ni siquiera me has permitido besar a mis hijas y a mis nietos. Has obrado como un insensato."
,"29":"Podría ahora hacerte mal; pero el Dios de tu padre me ha dicho la noche pasada: Guárdate de hablar a Jacob, ni bien ni mal."
,"30":"Y ya que te vas porque tienes gran deseo de ver de nuevo la casa de tu padre, ¿por qué me has robado a mis dioses?'."
,"31":"Jacob respondió: 'Tuve miedo; pensaba que ibas a quitarme por la fuerza a tus hijas."
,"32":"¡Pero aquel en cuyo poder encuentres tus dioses, no vivirá! Delante de nuestros hermanos reconoce lo que yo tuviera tuyo y llévatelo'. Jacob no sabía que los había robado Raquel."
,"33":"Labán entró en la tienda de Jacob, en la de Lía y en las de las esclavas, pero no encontró nada. Pasó luego a la de Raquel;"
,"34":"pero ésta había tomado los ídolos y los había escondido debajo de la albarda del camello, sentándose encima de ellos. Labán rebuscó por toda la tienda, pero no los encontró."
,"35":"Raquel le dijo: 'No se enfade mi señor si no puedo levantarme ante él, pues tengo lo que es habitual en las mujeres'. Así él buscó y rebuscó, pero no pudo encontrar sus ídolos."
,"36":"Entonces Jacob se acaloró contra Labán y le habló en estos términos: '¿Qué delito o qué culpa he cometido para que me persigas de este modo?"
,"37":"Has registrado todos mis enseres, y ¿qué has encontrado de las cosas de tu casa? Ponlo aquí delante de nuestros hermanos y que ellos juzguen entre nosotros dos."
,"38":"He estado veinte años contigo y nunca tus ovejas ni tus cabras han abortado. Jamás he comido un carnero de tus rebaños."
,"39":"Nunca te he traído los animales desgarrados por las fieras; yo pagaba el daño de mi bolsillo; lo robado, tanto de noche como de día, tú me lo reclamabas."
,"40":"De día me consumía el calor y de noche el frío, mientras el sueño huía de mis ojos."
,"41":"Así he estado veinte años en tu casa; catorce te he servido por tus hijas y seis por tu ganado, y tú me has mudado el salario diez veces."
,"42":"Si el Dios de mi padre, el Dios de Abrahán, el Terror de Isaac, no hubiera estado conmigo, tú me habrías enviado con las manos vacías. Dios vio mi dolor y el trabajo de mis manos, y ayer por la noche sentenció'."
,"43":"Labán respondió a Jacob: 'Estas mujeres son mis hijas, estos muchachos mis nietos, estas ovejas mis ovejas y todo lo que ves es mío. ¿Qué podría hacer yo hoy a estas hijas mías y a los hijos que ellas han engendrado?"
,"44":"Venga, hagamos un pacto entre nosotros y quede como testimonio entre los dos'."
,"45":"Jacob tomó una piedra, la levantó a modo de estela"
,"46":"y dijo a su gente: 'Recoged piedras'. Ellos recogieron piedras e hicieron un montón, y allí, sobre el montón, comieron. "
,"47":"Y Labán lo llamó Yegar Sahadutá, mientras que Jacob lo llamó Galaad."
,"48":"Labán añadió: 'Este montón sea hoy testimonio entre tú y yo'. Por eso se le llamó Galaad "
,"49":"y también Mispá, porque añadió: 'Que el Señor vigile entre tú y yo cuando no nos veamos ya el uno al otro."
,"50":"Si maltratas a mis hijas o tomas otras mujeres además de ellas, aunque nadie lo vea, Dios será testigo entre nosotros dos'."
,"51":"Y añadió: 'Aquí están este montón de piedras y esta estela que he levantado entre los dos."
,"52":"Este montón de piedras y esta estela son testigos de que yo no los traspasaré en tu dirección ni tú en la mía para hacernos daño."
,"53":"Que el Dios de Abrahán y el Dios de Najor -el Dios de sus padres- hagan valer el derecho entre nosotros'. Entonces Jacob juró por el Terror de Isaac, su padre."
,"54":"Jacob ofreció un sacrificio sobre el monte e invitó a su gente a comer; comieron y pasaron la noche en el monte."
}`)
	CurrentBook.AddChapter(32, `{
"1":"Labán se levantó de madrugada, besó a sus nietos y a sus hijas, los bendijo y regresó a su lugar."
,"2":"Cuando Jacob continuaba su camino, le salieron al encuentro unos ángeles de Dios."
,"3":"Al verlos, exclamó: 'Éste es el campo de Dios', y llamó a aquel lugar Majanáyim."
,"4":"Jacob envió por delante mensajeros a su hermano Esaú, al país de Seír, en los campos de Edón."
,"5":"Y les dio esta orden: 'Así hablaréis a mi señor, Esaú. Éste es el mensaje de tu esclavo Jacob: He vivido en casa de Labán y he estado con él hasta ahora."
,"6":"Tengo vacas, asnos y ovejas, esclavos y esclavas, y he querido decírselo a mi señor para hallar gracia a sus ojos'."
,"7":"Los mensajeros volvieron a Jacob diciendo: 'Hemos ido a tu hermano, y él mismo viene a tu encuentro con cuatrocientos hombres'."
,"8":"Jacob tuvo gran temor y se llenó de angustia. Dividió en dos campamentos a la gente que estaba con él y también las ovejas, las vacas y los camellos."
,"9":"Pues se dijo: 'Si Esaú alcanza el primer grupo y lo ataca, el otro que queda podrá salvarse'."
,"10":"Luego exclamó: 'Dios de mi padre Abrahán, Dios de mi padre Isaac, Señor, que me dijiste: Vuelve a tu tierra y a tu familia y yo te haré el bien,"
,"11":"yo no soy digno de todos tus favores y de todo el bien que has hecho a tu siervo, pues pasé este Jordán sólo con mi bastón y ahora puedo formar dos campamentos."
,"12":"Líbrame de la mano de mi hermano, de la mano de Esaú, porque yo temo que venga y mate a la madre y a los hijos juntamente."
,"13":"Tú me has dicho: Yo te haré el bien y haré tu descendencia como la arena del mar, tan numerosa que no se puede contar'."
,"14":"Y pasó allí aquella noche. Después tomó de lo que traía para hacer un regalo a su hermano Esaú: "
,"15":"doscientas cabras y veinte machos cabríos, doscientas ovejas y veinte carneros,"
,"16":"cuarenta camellas paridas con sus crías, cuarenta vacas y diez novillos, veinte asnas y diez asnos."
,"17":"Dio a sus esclavos las manadas por separado y les dijo: 'Id delante de mí, dejando un espacio entre manada y manada'."
,"18":"Y al primero le dio esta orden: 'Cuando te encuentre mi hermano Esaú y te pregunte: ¿De quién eres, adónde vas y de quién es el ganado que va delante?,"
,"19":"le responderás: Es de tu siervo Jacob; un regalo que envía a mi señor, Esaú, y él mismo viene también detrás de nosotros'."
,"20":"Dio la misma orden al segundo y al tercero y a todos los que iban detrás del ganado: 'Así habéis de hablar a Esaú cuando lo encontréis;"
,"21":"y diréis también: tu siervo Jacob viene detrás de nosotros'. Pues se había dicho a sí mismo: 'Primero le apaciguaré con el regalo que le mando, después me presentaré a él, y espero que me haga buena acogida'. "
,"22":"Mandó por delante los regalos y él pasó la noche en el campamento."
,"23":"Durante la noche se levantó, tomó a sus dos mujeres, a sus dos esclavas y a sus once hijos y pasó el vado de Yaboc."
,"24":"Los tomó y los hizo pasar el vado, y pasó también todo lo que tenía consigo."
,"25":"Jacob se quedó solo, y un hombre estuvo luchando con él hasta despuntar el alba."
,"26":"El hombre, viendo que no le podía, le dio un golpe en la articulación del muslo y se la descoyuntó durante la lucha con él."
,"27":"El hombre dijo a Jacob: 'Suéltame, que ya raya el alba'; Jacob respondió: 'No te soltaré si antes no me bendices'. "
,"28":"Él le preguntó: '¿Cómo te llamas?'. Contestó: 'Jacob'."
,"29":"Y el hombre añadió: 'Tu nombre no será ya Jacob, sino Israel, porque te has peleado con Dios y con los hombres y has vencido'."
,"30":"Jacob le preguntó: 'Por favor, ¿cómo te llamas?'. Él respondió: '¿Por qué quieres saber cómo me llamo?'. Y allí mismo le bendijo."
,"31":"Jacob llamó a aquel lugar Penuel, diciendo: 'He visto a Dios cara a cara y he quedado con vida'."
,"32":"Salía el sol cuando pasó por Penuel, e iba cojeando del muslo."
,"33":"Ésta es la razón por la que los israelitas, aún hoy, no comen el nervio ciático, que está en la articulación del muslo, porque el ángel dio un golpe a Jacob en la articulación del muslo, en el nervio ciático."
}`)
	CurrentBook.AddChapter(33, `{
"1":"Jacob alzó los ojos y vio que venía Esaú con cuatrocientos hombres. Repartió los niños entre Lía y Raquel y las dos esclavas."
,"2":"Puso en primera fila a las dos esclavas con sus hijos. Luego a Lía con sus hijos, y en último lugar a Raquel con José."
,"3":"Él pasó delante de ellos y se postró siete veces en tierra antes de acercarse a su hermano."
,"4":"Esaú corrió a su encuentro, lo abrazó, se echó a su cuello y lo besó, y los dos se echaron a llorar."
,"5":"Luego Esaú alzó los ojos, y al ver a las mujeres y a los niños preguntó: '¿Quiénes son esos que traes contigo?'. Jacob respondió: 'Son los hijos que Dios ha dado a tu siervo'."
,"6":"Se acercaron las esclavas con sus hijos y se postraron en tierra;"
,"7":"lo mismo hizo Lía con sus hijos y, en último lugar, Raquel con José."
,"8":"Esaú preguntó: '¿Qué significa todo ese ganado que he encontrado?'. Jacob respondió: 'Es para hallar gracia a los ojos de mi señor'."
,"9":"Esaú dijo: 'Yo tengo bastante, hermano mío; que lo tuyo sea para ti'."
,"10":"Jacob continuó: 'No, por favor, si he hallado gracia a tus ojos, acepta de mi mano ese regalo, porque me he presentado a ti como uno se presenta ante Dios y tú me has recibido bien."
,"11":"Acepta, pues, el regalo que te traigo, porque Dios me ha favorecido y tengo abundancia de todo'. Y tanto porfió que Esaú aceptó."
,"12":"Esaú dijo: 'Pongámonos en marcha, yo iré junto a ti'."
,"13":"Jacob le respondió: 'Mi señor sabe que los niños son de tierna edad y que yo tengo que ocuparme de las ovejas y las vacas paridas; si las fuerzo a caminar, en un solo día morirá todo el rebaño."
,"14":"Vaya, pues, mi señor delante de su siervo y yo iré poco a poco, al paso de las ovejas que van delante de mí y al paso de los niños, hasta alcanzar a mi señor en Seír'."
,"15":"Esaú dijo: 'Por lo menos voy a dejar contigo algunos de mis hombres'. Jacob respondió: '¿Y para qué? ¡Basta que yo haya hallado gracia a los ojos de mi señor!'."
,"16":"Aquel mismo día Esaú volvió por su camino a Seír,"
,"17":"mientras Jacob se dirigió en sentido opuesto hacia Sucot, y construyó una casa para sí y cabañas para el ganado. Por eso aquel lugar fue llamado Sucot."
,"18":"Jacob, de vuelta de la llanura de Padán Arán, llegó sano y salvo a la ciudad de Siquén, en tierra de Canaán, y acampó delante de ella."
,"19":"Compró después a los hijos de Jamor, padre de Siquén, por cien monedas de plata, el trozo de campo donde había levantado su tienda,"
,"20":"y levantó allí un altar que llamó 'Él', Dios de Israel."
}`)
	CurrentBook.AddChapter(34, `{
"1":"Dina, la hija que Lía dio a Jacob, salió a ver a las mujeres del país."
,"2":"Siquén, hijo de Jamor, el príncipe de aquella tierra, la vio, la raptó, la violó y durmió con ella."
,"3":"Se quedó prendado de Dina, la hija de Jacob, la amó y le habló tiernamente al corazón."
,"4":"Siquén dijo a su padre, Jamor: 'Tómame esta joven para mujer'."
,"5":"Jacob se enteró de que Siquén había deshonrado a Dina; pero como sus hijos estaban en el campo con el ganado, se calló hasta que ellos regresaron."
,"6":"Jamor, padre de Siquén, fue a hablar con Jacob."
,"7":"Cuando los hijos de Jacob, a su vuelta del campo, se enteraron de lo ocurrido, se indignaron y se llenaron de ira por la infamia que había cometido Siquén acostándose con la hija de Jacob. '¡Eso no se hace!'."
,"8":"Jamor les habló así: 'Mi hijo Siquén ama de corazón a vuestra hija; dádsela por mujer;"
,"9":"emparentad con nosotros, dadnos vuestras hijas y tomad vosotros las nuestras;"
,"10":"quedaos con nosotros y tendréis el país a vuestra disposición; quedaos a vivir en él, moveos con plena libertad y adquirid propiedades'."
,"11":"Siquén dijo al padre de Dina y a sus hermanos: 'Halle yo gracia a vuestros ojos y os daré lo que me pidáis."
,"12":"Imponedme una dote alta y grandes regalos; os daré lo que me digáis, pero dadme la joven por mujer'."
,"13":"Los hijos de Jacob respondieron a Siquén y a Jamor, su padre, con engaño, por haber deshonrado a su hermana Dina."
,"14":"Les dijeron: 'Nosotros no podemos hacer cosa semejante: dar nuestra hermana a un hombre incircunciso, pues eso sería para nosotros un oprobio."
,"15":"Accederemos a ello con la condición de que seáis como nosotros, circuncidando a todos vuestros varones."
,"16":"Sólo entonces os daremos nuestras hijas y tomaremos para nosotros las vuestras; viviremos con vosotros y formaremos un solo pueblo."
,"17":"Pero si no os avenís a ello y no queréis circuncidaros, tomaremos a nuestra hija y nos iremos'."
,"18":"Parecieron bien estas palabras a Jamor y a Siquén, su hijo."
,"19":"El mozo no titubeó en hacerlo, porque estaba enamorado de la hija de Jacob, y era el más considerado de la casa de su padre."
,"20":"Entonces Jamor y su hijo Siquén fueron a la puerta de la ciudad y hablaron así a sus ciudadanos."
,"21":"'Estos hombres son gente de paz; que se queden a vivir con nosotros en el país y que se muevan en él con plena libertad, pues hay por todas partes espacio suficiente para ellos. Nosotros tomaremos a sus hijas por mujeres y a ellos les daremos las nuestras."
,"22":"Pero estos hombres se avienen a vivir con nosotros, para formar un solo pueblo, con la condición de que todos nuestros varones se circunciden como lo están ellos."
,"23":"Sus rebaños, su hacienda, su ganado serán nuestros. Demos nuestro consentimiento y se quedarán a vivir con nosotros'."
,"24":"Todos los que pasaban por las puertas de su ciudad escucharon a Jamor y a su hijo Siquén, y todos los varones fueron circuncidados."
,"25":"Al tercer día, cuando el dolor era más fuerte, dos de los hijos de Jacob, Simeón y Leví, hermanos de Dina, tomaron cada uno su espada, entraron a mansalva en la ciudad y mataron a todos los varones."
,"26":"Pasaron por la espada a Jamor y a su hijo Siquén, recogieron a Dina de la casa de Siquén y se marcharon."
,"27":"Los hijos de Jacob acometieron a todos los heridos y saquearon la ciudad por haber deshonrado a su hermana."
,"28":"Se apoderaron de sus ovejas, vacas y asnos, de todo cuanto había en la ciudad y en el campo y de todos sus bienes;"
,"29":"se llevaron prisioneros a todos los niños y a las mujeres y saquearon lo que había en las casas."
,"30":"Jacob dijo a Simeón y Leví: 'Me habéis puesto en gran aprieto, haciéndome odioso a los hombres de esta tierra, a los cananeos y a los fereceos. Yo cuento con pocos hombres; ellos se unirán, me vencerán y seré aniquilado yo con toda mi casa'."
,"31":"Ellos le respondieron: '¿Y había de ser nuestra hermana tratada como una prostituta?'."
}`)
	CurrentBook.AddChapter(35, `{
"1":"Dios dijo a Jacob: 'Levántate, vete a vivir a Betel y levanta allí un altar al Dios que se te apareció cuando huías de la presencia de tu hermano Esaú'."
,"2":"Jacob dijo a su familia y a todos los que estaban con él: 'Tirad los dioses extranjeros que hay en medio de vosotros, purificaos y cambiad vuestros vestidos."
,"3":"Levantémonos y subamos a Betel. Allí levantaré yo un altar al Dios que me escuchó en el día de mi angustia y me ha asistido en mi viaje'."
,"4":"Ellos dieron a Jacob todos los dioses extranjeros que poseían y los anillos que llevaban en las orejas, y Jacob los enterró bajo la encina que hay cerca de Siquén."
,"5":"Levantaron el campamento, y un terror divino cayó sobre las ciudades de los alrededores, por lo que nadie persiguió a los hijos de Jacob."
,"6":"Llegó Jacob a Luz, en tierra de Canaán, o sea a Betel, él y toda la gente que estaba con él."
,"7":"Levantó allí un altar y llamó al lugar Betel, porque allí se le había aparecido Dios cuando huía de su hermano."
,"8":"Débora, la nodriza de Rebeca, murió y fue enterrada pendiente abajo de Betel, bajo una encina, que fue llamada 'la encina del llanto'."
,"9":"Dios se apareció de nuevo a Jacob, a su vuelta de Padán Arán, y le bendijo"
,"10":"diciendo: 'Tu nombre es Jacob, pero ya no te llamarás Jacob; tu nombre será Israel'. Y le llamó Israel."
,"11":"Y Dios le dijo: 'Yo soy el Dios todopoderoso; sé fecundo y multiplícate. Un pueblo, un conjunto de naciones procederá de ti, y reyes saldrán de tus lomos."
,"12":"La tierra que di a Abrahán y a Isaac, te la doy a ti y a tu descendencia'."
,"13":"Y Dios se alejó del lugar donde había hablado con él."
,"14":"Jacob levantó una estela en el lugar en que Dios le había hablado; una estela de piedra, sobre la que vertió vino y aceite."
,"15":"Y llamó Betel al lugar donde Dios le había hablado."
,"16":"Partieron de Betel y, cuando quedaba un buen trecho de camino para llegar a Éfrata, Raquel se puso de parto, un parto muy penoso."
,"17":"Y entre las angustias del parto, la partera le dijo: 'No temas, que también esta vez tendrás un hijo'."
,"18":"En el momento de entregar el alma, pues ella murió, le llamó Benoní; pero su padre le llamó Benjamín."
,"19":"Murió Raquel y fue sepultada en el camino de Éfrata, o sea, de Belén."
,"20":"Jacob levantó una estela sobre su tumba, la estela de la tumba de Raquel, que aún existe hoy."
,"21":"Jacob partió y plantó sus tiendas a la otra parte de Migdal-Éder."
,"22":"Y mientras vivía en esta tierra, Rubén fue y se acostó con Bihlá, la concubina de su padre, de lo cual se enteró Israel. Los hijos de Israel fueron doce. "
,"23":"Hijos de Lía: Rubén, el primogénito de Israel; Simeón, Leví, Judá, Isacar y Zabulón."
,"24":"Hijos de Raquel: José y Benjamín."
,"25":"Hijos de Bihlá, la sierva de Raquel: Dan y Neftalí."
,"26":"Hijos de Zilpa, la sierva de Lía: Gad y Aser. Éstos fueron los hijos que le nacieron a Israel en Padán Arán."
,"27":"Jacob llegó a casa de Isaac, su padre, en Mambré, a la ciudad de Arba, o sea Hebrón, donde habitaron Abrahán e Isaac."
,"28":"Isaac vivió ciento ochenta años,"
,"29":"y expiró. Murió y se reunió con los suyos, anciano y lleno de días. Sus hijos Esaú y Jacob lo sepultaron."
}`)
	CurrentBook.AddChapter(36, `{
"1":"Ésta es la genealogía de Esaú, o sea, Edón."
,"2":"Esaú se casó con mujeres cananeas: Adá, hija del hitita Elón; Olibamá, hija de Aná, hijo del hitita Sibeón;"
,"3":"Basemat, hija de Ismael y hermana de Nebayot."
,"4":"Adá le dio a Elifaz; Basemat a Reuel,"
,"5":"y Olibamá a Yeús, Yalán y Coré. Éstos fueron los hijos de Esaú, que le nacieron en tierra de Canaán."
,"6":"Esaú tomó después a sus mujeres y a sus hijos e hijas y a todas las personas de su casa, todo su ganado y todos los bienes adquiridos por él en el país de Canaán, y se fue a otro país lejos de Jacob, su hermano,"
,"7":"porque tenían muchos bienes y no podían estar juntos; la tierra en que habitaban no era suficiente para ellos, porque tenían muchos ganados."
,"8":"Esaú se estableció en la montaña de Seír. Esaú es Edón."
,"9":"Ésta es la genealogía de Esaú, padre de los edomitas en la montaña de Seír."
,"10":"Nombres de los hijos de Esaú: Elifaz, hijo de Adá, mujer de Esaú, y Reuel, hijo de Basemat, mujer de Esaú."
,"11":"Hijos de Elifaz: Temán, Omar, Sefó, Gatán y Quenaz."
,"12":"Timná era una concubina de Elifaz, y le dio a Amalec. Tales fueron los hijos de Adá, mujer de Esaú."
,"13":"Hijos de Reuel: Nájat, Zéraj, Samá y Mizá."
,"14":"Tales fueron los hijos de Basemat, mujer de Esaú. Hijos de Olibamá, hija de Aná, hijo de Sibeón, mujer de Esaú: Yeús, Yalán y Coré."
,"15":"Éstos son los jefes de tribu de los hijos de Esaú: hijos de Elifaz, primogénito de Esaú: Temán, Omar, Sefí, Quenaz,"
,"16":"Coré, Gatán, Amalec. Tales fueron los jefes de Elifaz en la tierra de Edón, los hijos de Adá."
,"17":"Hijos de Reuel, hijo de Esaú: Nájat, Zéraj, Samá y Mizá. Tales fueron los jefes de tribu, hijos de Reuel, en el país de Edón; son los hijos de Basemat, mujer de Esaú."
,"18":"Hijos de Olibamá, mujer de Esaú: Yeús, Yalán, Coré. Tales fueron los jefes de tribu, hijos de Olibamá, hija de Aná y mujer de Esaú."
,"19":"Tales fueron los hijos de Esaú, y tales sus jefes de tribu: él es Edón."
,"20":"Hijos de Seír, el hurrita, que habitaba la región: Lotán, Sobal, Sibeón, Aná,"
,"21":"Disón, Éser y Disán. Tales fueron los jefes de tribu de los hurritas, hijos de Seír, en el país de Edón."
,"22":"Hijos de Lotán: Jorí y Hemán; y Timná, hermana de Lotán."
,"23":"Hijos de Sobal: Albán, Manájat, Ebal, Sefí y Onán."
,"24":"Hijos de Sibeón: Ayá y Aná. Este Aná es el que encontró en el desierto los manantiales de agua caliente mientras apacentaba el ganado de Sibeón, su padre."
,"25":"Hijos de Aná: Disón y Olibamá, hija de Aná."
,"26":"Hijos de Disón: Jamrán, Esbán, Yitrán, Querán."
,"27":"Hijos de Éser: Bilhán Zaaván y Yaacán."
,"28":"Hijos de Disán: Us y Arán."
,"29":"Jefes de tribu de los hurritas: Lotán, Sobal, Sibeón,"
,"30":"Aná, Disán, Éser, Disón. Tales fueron los jefes de tribu de los hurritas, cada uno de su tribu en las tierras de Edón."
,"31":"Éstos son los reyes que reinaron en el país de Edón antes de que sobre los israelitas reinara rey alguno."
,"32":"Bela, hijo de Beor, reinó en Edón; el nombre de su capital era Dinhabá."
,"33":"Murió Bela y le sucedió Yobab, hijo de Zéraj de Bosra."
,"34":"Murió Yobab y le sucedió Jusán, del país de Temán."
,"35":"Murió Jusán y le sucedió Hadad, hijo de Bedad, que derrotó a Madián en los campos de Moab; el nombre de su ciudad era Avit."
,"36":"Murió Hadad y le sucedió Samlá, de Masrecá."
,"37":"Murió Samlá, y le sucedió Saúl, natural de Rejobot del Río."
,"38":"Murió Saúl y le sucedió Baal Janán, hijo de Acbor."
,"39":"Murió Baal Janán, hijo de Acbor, y le sucedió Hadar; su capital se llamaba Pau, y su mujer Mehetabel, hija de Matred, hijo de Mezahab."
,"40":"Éstos son los nombres de los jefes de tribu de Esaú según sus tribus, lugares y nombres: Timná, Alvá, Yetet,"
,"41":"Olibamá, Elá, Finón,"
,"42":"Quenaz, Temán, Mibsar,"
,"43":"Magdiel, Irán. Tales fueron los jefes de tribu de Edón por lugares en el país ocupado por ellos. Éste es Esaú, padre de Edón."
}`)
	CurrentBook.AddChapter(37, `{
"1":"Jacob se estableció en la tierra adonde había emigrado su padre, la tierra de Canaán."
,"2":"Sigue la historia de Jacob. José tenía diecisiete años cuando iba a apacentar el rebaño con sus hermanos, los hijos de Bihl y de Zilpa, mujeres de su padre. Y José contó a su padre la mala fama que tenían sus hermanos. "
,"3":"Israel amaba a José más que a todos sus hijos, porque era el hijo de su ancianidad, y le hizo una túnica con mangas largas."
,"4":"Sus hermanos vieron que su padre lo amaba más que a todos ellos, y le cobraron tal odio que no podían hablarle con cariño."
,"5":"José tuvo un sueño y se lo contó a sus hermanos."
,"6":"Les dijo: 'Escuchad el sueño que he tenido: "
,"7":"estábamos atando gavillas en el campo, y en esto que mi gavilla se levanta y se queda derecha, mientras que las vuestras se ponen alrededor y se inclinan ante la mía'."
,"8":"Sus hermanos respondieron: '¿Es que vas a ser tú rey y señor nuestro?'. Y le odiaban todavía más por sus sueños y por sus palabras."
,"9":"José tuvo otro sueño, que contó también a sus hermanos: 'He tenido otro sueño: me parecía que el sol, la luna y once estrellas se postraban ante mí'."
,"10":"Se lo contó a su padre y a sus hermanos, y su padre le reprendió, diciéndole: '¿Qué sueño es ése que has tenido? ¿Es que tenemos que postrarnos ante ti, yo, tu madre y tus hermanos?'."
,"11":"Sus hermanos le tenían envidia, mientras que su padre daba vueltas al asunto."
,"12":"Sus hermanos habían ido a pastorear las ovejas de su padre a Siquén."
,"13":"Israel dijo a José: 'Tus hermanos están pastoreando las ovejas en Siquén; ven, que quiero que vayas donde ellos'. Él respondió: 'Aquí me tienes'. "
,"14":"Y le dijo: 'Anda, vete a ver cómo están tus hermanos y el rebaño, y tráeme noticias'. Lo envió al valle de Hebrón, y José llegó a Siquén."
,"15":"Un hombre le encontró andando de un lado a otro por el campo y le preguntó: '¿Qué buscas?'."
,"16":"Él respondió: 'Busco a mis hermanos. Dime dónde están'."
,"17":"Y aquel hombre le dijo: 'Ya se han ido de aquí. Les oí decir: ¡Vámonos a Dotán!'. José partió en busca de sus hermanos y los encontró en Dotán."
,"18":"Al verlo venir desde lejos, antes de que llegara hasta ellos, conspiraron contra él para darle muerte."
,"19":"Se dijeron unos a otros: 'Ahí viene el soñador."
,"20":"Vamos a matarlo: lo echamos en una cisterna y luego decimos que una bestia feroz lo devoró. Veremos en qué paran sus sueños'."
,"21":"Al oír esto, Rubén quiso salvarle de sus manos, y dijo: '¡Matarle, no!'."
,"22":"Y añadió: 'No derraméis sangre; echadlo a esa cisterna solitaria, pero no pongáis las manos en él'. Era para librarlo de sus manos y devolverlo luego a su padre."
,"23":"Cuando José llegó junto a sus hermanos, le quitaron la túnica, la túnica de mangas largas que llevaba,"
,"24":"lo agarraron y lo echaron en una cisterna vacía, sin agua."
,"25":"Y se pusieron a comer. Alzando los ojos, divisaron una caravana de ismaelitas que venían de Galaad. Sus camellos iban cargados de aromas, bálsamo y mirra, que llevaban a Egipto."
,"26":"Judá dijo a sus hermanos: '¿Qué sacamos con matar a nuestro hermano y ocultar su sangre?"
,"27":"Vamos a vendérselo a los ismaelitas, y no pongamos nuestras manos en él; es nuestro hermano, es nuestra misma carne'. Sus hermanos le hicieron caso."
,"28":"Al pasar los mercaderes madianitas, ellos sacaron a José de la cisterna. Vendieron a José a los ismaelitas por veinte monedas de plata, y éstos se lo llevaron a Egipto."
,"29":"Rubén volvió a la cisterna, y José ya no estaba allí. Rasgó sus vestiduras,"
,"30":"regresó adonde sus hermanos y dijo: '¡El muchacho no está allí! ¿Adónde iré yo?'."
,"31":"Ellos tomaron la túnica de José, degollaron un cabrito y tiñeron la túnica con la sangre."
,"32":"Y mandaron a su padre la túnica de mangas largas con estas palabras: 'Esto es lo que hemos encontrado; mira a ver si es o no la túnica de tu hijo'."
,"33":"Él la reconoció y dijo: '¡Es la túnica de mi hijo! Una bestia feroz lo ha devorado; José ha sido despedazado'."
,"34":"Jacob rasgó sus vestiduras, se puso un saco a la cintura y guardó luto por su hijo durante muchos días."
,"35":"Sus hijos y sus hijas fueron todos a consolarle, pero él rechazó todo consuelo y dijo: 'Quiero bajar de luto a la tumba con mi hijo'. Y su padre lo lloró."
,"36":"Entretanto los madianitas lo habían vendido en Egipto a Putifar, eunuco del Faraón y capitán de la guardia."
}`)
	CurrentBook.AddChapter(38, `{
"1":"Por entonces Judá se separó de sus hermanos y se fue a casa de un adulamita, llamado Jirá."
,"2":"Allí vio a la hija de un cananeo llamado Súa, la tomó por mujer y vivió con ella."
,"3":"Ésta concibió y dio a luz un hijo, al que llamó Er."
,"4":"Concibió de nuevo y dio a luz otro hijo, al que llamó Onán."
,"5":"Volvió a concebir y dio a luz un tercer hijo, al que llamó Selá. Estaba en Quezib cuando dio a luz."
,"6":"Judá tomó una mujer para su primogénito, Er. Se llamaba Tamar."
,"7":"Pero Er, primogénito de Judá, desagradó al Señor, que le quitó la vida."
,"8":"Judá dijo a Onán: 'Cásate con la viuda de tu hermano, cumpliendo con ella tu deber de cuñado, y suscita descendencia a tu hermano'."
,"9":"Onán sabía que los hijos no serían suyos, y cada vez que se unía a la viuda de su hermano derramaba en tierra el semen para no dar hijos a su hermano."
,"10":"Desagradó al Señor lo que hacía, y le hizo morir."
,"11":"Entonces Judá dijo a su nuera: 'Vuelve como viuda a la casa de tu padre, hasta que se haga mayor mi hijo Selá'. Él se decía: 'No sea que muera también él como sus hermanos'. Tamar volvió a casa de su padre."
,"12":"Fueron pasando los días, y la hija de Súa, la mujer de Judá, murió. Cuando terminó el duelo por ella, Judá subió con su amigo Jirá, el adulamita, al esquileo de su ganado a Timná."
,"13":"Y se lo fueron a decir a Tamar: 'Tu suegro sube a Timná al esquileo de las ovejas'."
,"14":"Entonces ella se quitó sus vestidos de viuda, se cubrió con un velo y, disfrazada, se sentó a la entrada de Enáyim, junto al camino de Timná, pues veía que Selá había crecido y no se había casado con ella."
,"15":"Judá la vio y la tomó por una prostituta, pues había cubierto su rostro."
,"16":"Se apartó del camino hacia ella y le dijo: 'Déjame hacer el amor contigo'. No sabía que era su nuera. Ella le respondió: '¿Qué me vas a dar por hacer el amor conmigo?'."
,"17":"Y él le dijo: 'Te mandaré un cabrito del rebaño'. Pero ella repuso: 'Bien, pero me has de dar una prenda hasta que lo mandes'."
,"18":"Él preguntó: '¿Qué prenda quieres?'. Y ella respondió: 'Tu sello, el cordón del que cuelga y el bastón que llevas en la mano'. Él se los dio, hizo el amor con ella y la dejó embarazada."
,"19":"Luego ella se levantó y se fue. Se quitó el velo y volvió a ponerse la ropa de viuda."
,"20":"Judá mandó el cabrito por medio de su amigo el adulamita, para recoger las prendas de mano de la mujer, pero éste no la encontró."
,"21":"Preguntó a las gentes del lugar: '¿Dónde está la prostituta que estaba en Enáyim junto al camino?'. Y ellos le respondieron: 'Jamás hubo aquí ninguna prostituta'. "
,"22":"Él volvió y le dijo a Judá: 'No la he encontrado, e incluso las gentes del lugar me han dicho que nunca ha habido allí prostituta alguna'."
,"23":"Judá repuso: 'Que se quede con ello, para que no se burle de nosotros. Yo le he mandado el cabrito y tú no la has encontrado'. "
,"24":"Unos tres meses después le contaron a Judá: 'Tu nuera Tamar se ha prostituido y ha quedado encinta'. Judá dijo: 'Que sea sacada y quemada'."
,"25":"Cuando ya la iban a sacar, mandó a decir a su suegro: 'Yo he quedado encinta del hombre a quien pertenece todo esto. Mira, por favor, de quién son este sello, este cordón y este bastón'. "
,"26":"Judá los examinó y dijo: 'Ella es más justa que yo, porque yo no le he dado por esposo a mi hijo Selá'. Y ya no volvió a tener relaciones con ella."
,"27":"Cuando llegó el tiempo del parto, resultó que había gemelos en su vientre."
,"28":"Y mientras los daba a luz, uno de ellos sacó la mano, y la partera la agarró y ató a ella un hilo de grana, diciendo: 'Éste salió el primero'."
,"29":"Pero sucedió que retiró la mano, y fue su hermano el que salió el primero. Ella dijo: '¡Vaya brecha que te has abierto!'. Y lo llamó Fares."
,"30":"Después salió el otro, que tenía en la mano el hilo de grana, y lo llamó Zéraj."
}`)
	CurrentBook.AddChapter(39, `{
"1":"José había sido llevado a Egipto. Putifar, egipcio, eunuco del Faraón y capitán de la guardia, se lo compró a los ismaelitas que lo habían llevado allí."
,"2":"El Señor estaba con José y todo le salía bien; y se quedó en la casa de su dueño, el egipcio."
,"3":"Su dueño vio que el Señor estaba con él y que hacía prosperar en sus manos todo cuanto él emprendía;"
,"4":"José halló gracia a sus ojos, y así fue incorporado al servicio de su dueño, quien le hizo mayordomo de su casa, confiándole todo cuanto tenía."
,"5":"Desde el momento en que le puso al frente de su casa y de todo cuanto tenía, el Señor bendijo la casa del egipcio en consideración a José. La bendición del Señor alcanzó a todo cuanto poseía, tanto en la casa como en el campo."
,"6":"Entonces dejó en las manos de José todo cuanto poseía; con él no tenía que preocuparse de nada, a no ser del alimento que tomaba. José era guapo y esbelto. "
,"7":"La mujer de su dueño puso sus ojos en él y le dijo: 'Acuéstate conmigo'."
,"8":"Pero José se negó y le dijo: 'Conmigo mi señor no se preocupa de lo que pasa en la casa y me ha confiado todo lo que tiene."
,"9":"Ni él es más poderoso que yo en esta casa. Nada me ha prohibido más que a ti, puesto que tú eres su mujer. ¿Cómo podría yo cometer un mal tan grande y pecar contra Dios?'."
,"10":"Y por más que ella insistía todos los días, José no consintió en acostarse con ella para entregarse a ella."
,"11":"Un día entró José en la casa para sus quehaceres, y no había entonces en la casa ningún criado."
,"12":"Ella le agarró por sus vestidos y le dijo: 'Acuéstate conmigo'. Pero él, dejando sus vestidos entre sus manos, huyó y salió afuera."
,"13":"Ella, viendo que había dejado el manto entre sus manos y que había salido fuera,"
,"14":"llamó a sus criados y les dijo: 'Mirad, nos ha traído un hebreo para abusar de nosotros. Se acercó a mí para acostarse conmigo, pero yo me puse a gritar"
,"15":"y él, al oír mis gritos, dejó su manto en mis manos y huyó'."
,"16":"Ella puso junto a sí el manto hasta que su marido volviera a casa."
,"17":"Entonces repitió lo mismo a su marido: 'El hebreo que tú nos has traído se me acercó para abusar de mí,"
,"18":"pero, al ver que yo me puse a gritar, dejó su manto junto a mí y huyó'."
,"19":"El marido, al oír lo que le decía su mujer sobre el comportamiento de su esclavo con ella, se enfureció,"
,"20":"mandó a prenderlo y lo metió en la cárcel donde estaban los presos del rey. Así José fue a parar a la cárcel."
,"21":"Pero el Señor estaba con José e hizo que hallara favor y gracia a los ojos del jefe de la prisión."
,"22":"Éste confió a José todos los presos de la cárcel. Todo cuanto allí se hacía, se hacía por él."
,"23":"El jefe de la prisión no se preocupaba de lo que había encomendado a José, porque el Señor estaba con él, y todo lo que emprendía le salía bien."
}`)
	CurrentBook.AddChapter(40, `{
"1":"Después de todo esto, el copero del rey de Egipto y su panadero cometieron una culpa contra su señor, el rey de Egipto."
,"2":"El Faraón se irritó contra sus dos oficiales, el primer copero y el primer panadero,"
,"3":"y los encarceló en casa del capitán de la guardia, en la cárcel donde José estaba detenido."
,"4":"El capitán de la guardia los confió al cuidado de José, que les servía. Y así estuvieron cierto tiempo en la cárcel."
,"5":"Pues bien, una misma noche los dos, el copero y el panadero, tuvieron cada uno un sueño con su propio significado para cada uno."
,"6":"Cuando a la mañana siguiente José fue a buscarlos, se dio cuenta de que estaban tristes;"
,"7":"les preguntó a los dos oficiales del Faraón, que estaban con él en prisión en la casa de su señor: '¿Por qué tenéis hoy esa cara tan triste?'."
,"8":"Ellos le respondieron: 'Hemos tenido un sueño y no hay quien nos lo interprete'. José les dijo: 'Es Dios quien da la interpretación; no obstante, contádmelo a mí'."
,"9":"El primer copero contó a José el sueño que había tenido: 'Yo he soñado que tenía delante de mí una vid"
,"10":"con tres sarmientos; la vid, apenas abierta, floreció y las uvas maduraron en los racimos."
,"11":"Yo tenía en la mano la copa del Faraón, tomé los racimos, los exprimí en la copa del Faraón y se los puse en su mano'."
,"12":"José le dijo: 'Esto es lo que significa: los tres sarmientos son tres días;"
,"13":"al cabo de tres días el Faraón te pondrá en libertad y te repondrá en tu cargo; volverás a poner la copa del Faraón en su mano, como solías hacerlo cuando eras su copero."
,"14":"Acuérdate de mí cuando te llegue ese día; sé bueno conmigo y háblale al Faraón de mí para que me saque de esta cárcel."
,"15":"Pues la verdad es que fui arrebatado del país de los hebreos y aquí tampoco he hecho nada para que se me meta en la cárcel'."
,"16":"El primer panadero vio que había sido una interpretación favorable y dijo a José: 'Yo he soñado que llevaba tres canastillos de dulces sobre mi cabeza."
,"17":"En el canastillo de encima había de todo lo que come el Faraón en cosa de repostería, pero los pájaros se lo comían'."
,"18":"José le respondió: 'Esto es lo que significa: los tres canastillos son tres días;"
,"19":"dentro de tres días el Faraón te cortará la cabeza, te colgará de una horca y los pájaros comerán tu carne'."
,"20":"En efecto, al tercer día, que era su cumpleaños, el Faraón dio un banquete a todos sus servidores, y entre todos se acordó del primer copero y del primer panadero."
,"21":"Repuso al primer copero en su cargo de presentar la copa al Faraón,"
,"22":"mientras que al primer panadero lo ahorcó, como había dicho José."
,"23":"Pero el primer copero no se volvió a acordar de José, sino que se olvidó de él."
}`)
	CurrentBook.AddChapter(41, `{
"1":"Dos años después, el Faraón tuvo este sueño: Estaba junto al Nilo,"
,"2":"y del Nilo subían siete hermosas y gordas vacas, que se pusieron a pastar entre los juncos de la orilla."
,"3":"Detrás de ellas subieron del Nilo otras siete vacas escuálidas y flacas, que se pusieron junto a las primeras en la ribera del Nilo."
,"4":"Las siete vacas escuálidas y flacas devoraron a las siete hermosas y gordas. Entonces el Faraón se despertó."
,"5":"Volvió a quedarse dormido y tuvo otro sueño: siete espigas granadas y lozanas salían de una sola caña;"
,"6":"y otras siete, raquíticas y quemadas por el viento del este, brotaban después de ellas."
,"7":"Y las siete espigas raquíticas devoraron a las siete espigas granadas y lozanas. El Faraón despertó y se dio cuenta de que era un sueño."
,"8":"A la mañana siguiente el Faraón, muy turbado, mandó llamar a todos los adivinos y a todos los sabios de Egipto y les contó su sueño, pero nadie pudo explicárselo."
,"9":"Entonces el primer copero se dirigió al Faraón y le dijo: 'Ahora me acuerdo de mi falta."
,"10":"Irritado el Faraón contra sus servidores, nos había metido en la cárcel, en casa del capitán de la guardia, a mí y al primer panadero."
,"11":"La misma noche tuvimos los dos un sueño cada uno con su propio significado."
,"12":"Había allí, con nosotros, un joven hebreo, esclavo del capitán de la guardia. Nosotros le contamos nuestros sueños, y él nos dio a cada uno la interpretación de su sueño."
,"13":"Y todo sucedió como él lo había interpretado: yo fui repuesto en mi cargo y el otro fue ahorcado'."
,"14":"El Faraón mandó llamar a José. Lo sacaron a toda prisa de la cárcel, lo afeitaron, le cambiaron de vestidos y lo presentaron al Faraón."
,"15":"El Faraón dijo a José: 'He tenido un sueño y nadie ha podido interpretarlo. Pero he oído decir de ti que te basta oír un sueño para interpretarlo'."
,"16":"José respondió: 'Yo no soy nada; es Dios quien dará al Faraón respuesta favorable'."
,"17":"El Faraón le dijo: 'En mi sueño me parecía estar junto al río, "
,"18":"y he aquí que del Nilo subían siete hermosas y gordas vacas que se pusieron a pastar entre los juncos."
,"19":"Detrás de ellas subieron otras siete vacas escuálidas y flacas, tan raquíticas que no he visto otras semejantes en todo Egipto."
,"20":"Y las siete vacas escuálidas y flacas devoraron a las siete vacas gordas."
,"21":"Después de habérselas tragado no se conocía que se las hubieran tragado, porque su aspecto era tan raquítico como antes. Entonces me desperté."
,"22":"Después tuve otro sueño: de una misma caña salían siete espigas granadas y lozanas."
,"23":"Después de ellas brotaron otras siete espigas marchitas, raquíticas y quemadas por el viento del este."
,"24":"Las siete espigas raquíticas devoraron a las siete lozanas. He contado todo esto a los adivinos y nadie me lo ha podido interpretar'."
,"25":"José dijo al Faraón: 'El sueño del Faraón es uno solo: Dios ha mostrado al Faraón lo que él va a hacer."
,"26":"Las siete vacas hermosas y las siete espigas lozanas significan siete años. El sueño es uno mismo."
,"27":"Las siete vacas escuálidas y flacas, que salieron tras las otras, y las siete espigas raquíticas y quemadas por el viento del este, quieren decir que habrá siete años de hambre."
,"28":"Esto es lo que yo digo al Faraón: Dios ha mostrado al Faraón lo que él va a hacer."
,"29":"Van a venir siete años en que habrá abundancia en todo Egipto."
,"30":"Luego vendrán siete años de hambre que harán olvidar toda la abundancia de Egipto; el hambre consumirá el país."
,"31":"La abundancia anterior se olvidará a causa del hambre que sobrevendrá, que será muy dura."
,"32":"Y el repetirse dos veces el sueño del Faraón significa que la cosa está firmemente decidida por Dios y que está a punto de realizarla."
,"33":"Procúrese el Faraón un hombre inteligente y sabio y póngalo al frente de Egipto."
,"34":"Nombre también el Faraón intendentes para todo el país, que recauden la quinta parte de la cosecha de Egipto durante los siete años de abundancia,"
,"35":"recojan todos los víveres de estos años buenos que vienen, almacenen el trigo bajo la autoridad del Faraón, depositen los víveres en las ciudades y los guarden en ellas."
,"36":"Estos víveres servirán al país de reserva para los siete años de hambre que vendrán en Egipto, y así el país no morirá de hambre'."
,"37":"Esta propuesta pareció bien al Faraón y a todos sus servidores."
,"38":"Y el Faraón les dijo: '¿Encontraremos un hombre en quien esté el espíritu de Dios como en éste?'."
,"39":"El Faraón dijo a José: 'Puesto que Dios te ha hecho saber todo esto, no hay hombre tan inteligente y sabio como tú;"
,"40":"tú serás quien gobierne mi casa, y todo mi pueblo te obedecerá. Sólo en el trono seré mayor que tú'."
,"41":"Y añadió: 'Yo te constituyo sobre todo Egipto'."
,"42":"El Faraón se quitó el anillo de su mano y lo puso en la de José; hizo que le vistieran ropas de lino finísimo y puso en su cuello el collar de oro."
,"43":"Le hizo montar sobre el segundo de sus carros y ordenó que se gritara ante él: '¡Atención!'. Así fue constituido sobre todo Egipto. "
,"44":"Dijo el Faraón a José: 'Yo soy el Faraón, pero sin tu permiso nadie levantará la mano ni el dedo meñique en todo Egipto'. "
,"45":"El Faraón impuso a José el nombre de Zafnat Panéaj y le dio por mujer a Asenat, hija de Putifar, sacerdote de On. José recorrió todo Egipto."
,"46":"Tenía José treinta años cuando se presentó ante el Faraón, rey de Egipto. Salió de su presencia y recorrió toda la tierra de Egipto."
,"47":"Durante los siete años de abundancia la tierra produjo muchísimo."
,"48":"José recogió todos los víveres de los siete años en que hubo abundancia en Egipto y los depositó en las ciudades, almacenando en cada una los víveres de la campiña circundante."
,"49":"Y almacenó trigo como la arena del mar, en tal cantidad que se desistió de contarlo, porque sobrepasaba toda medida."
,"50":"Antes de que llegase el primer año de hambre le nacieron a José dos hijos de Asenat, hija de Putifar, sacerdote de On."
,"51":"José dio al primero el nombre de Manasés, 'porque Dios, dijo, me ha hecho olvidar toda mi pena y toda la familia de mi padre'. "
,"52":"Al segundo le llamó Efraín, diciendo: 'Dios me ha hecho fecundo en el país de mi aflicción'."
,"53":"Al cabo de los siete años de abundancia en el país de Egipto,"
,"54":"comenzaron a venir los siete años de hambre, como José había dicho. Hubo hambre en todos los países, pero en Egipto había pan."
,"55":"Cuando se sintió el hambre en Egipto, el pueblo clamó al Faraón pidiendo pan. Y el Faraón dijo a todos los egipcios: 'Id a José y haced lo que él os diga'."
,"56":"José, viendo que el hambre se había extendido por todo el país, abrió los graneros y vendía a los egipcios; el hambre se iba agravando más y más en Egipto."
,"57":"De todos los países venían a Egipto a comprar trigo a José, porque el hambre se había endurecido por toda la tierra."
}`)
	CurrentBook.AddChapter(42, `{
"1":"Jacob, viendo que en Egipto había grano en venta, dijo a sus hijos: '¿Por qué os estáis mirando unos a otros?"
,"2":"Me he enterado de que en Egipto hay grano en venta; bajad allá y comprad para nuestra subsistencia y para que no muramos'."
,"3":"Diez de los hermanos de José bajaron a Egipto a comprar grano."
,"4":"Pero Jacob no dejó ir con sus hermanos a Benjamín, el hermano de José: 'No vaya a sucederle, se decía, alguna desgracia'."
,"5":"Los hijos de Israel fueron con otros a comprar grano porque había hambre en la tierra de Canaán."
,"6":"José era el señor del país y vendía el grano a todo el mundo. Los hermanos de José llegaron y se postraron ante él rostro en tierra."
,"7":"José nada más ver a sus hermanos los reconoció, pero fingió no conocerlos y los trató duramente. Les dijo: '¿De dónde venís?'. Ellos respondieron: 'De la tierra de Canaán a comprar víveres'."
,"8":"José reconoció a sus hermanos, pero ellos no le reconocieron."
,"9":"Entonces se acordó de los sueños que había tenido referente a ellos, y les dijo: 'Vosotros sois espías; habéis venido para ver los puntos débiles del país'."
,"10":"Ellos respondieron: '¡No, señor! Tus siervos han venido a comprar víveres."
,"11":"Todos nosotros somos hijos de un mismo padre, somos hombres de bien, tus siervos no son espías'."
,"12":"Pero él les dijo: 'No, habéis venido para ver los puntos débiles del país'."
,"13":"Ellos respondieron: 'Tus siervos somos doce hermanos, todos hijos de un mismo padre en la tierra de Canaán; el más joven se ha quedado con nuestro padre y el otro no vive ya'."
,"14":"José replicó: 'Es como os he dicho: sois espías."
,"15":"Os voy a someter a esta prueba. ¡Vive el Faraón, que no saldréis de aquí hasta que venga vuestro hermano menor!"
,"16":"Enviad uno de vosotros a buscar a vuestro hermano y los demás quedad prisioneros. Así se comprobarán vuestras palabras, y se verá si decís o no verdad. Si no, ¡vive el Faraón, que sois espías!'."
,"17":"Y los metió a todos en la cárcel por tres días."
,"18":"Al tercer día José les dijo: 'Haced esto para salvar la vida, porque yo temo a Dios:"
,"19":"si sois hombres sinceros, que uno de vosotros quede preso, y los demás partid y llevad el grano para remediar el hambre de vuestra familia."
,"20":"Pero habéis de traerme a vuestro hermano menor. Así serán verificadas vuestras palabras y no moriréis'. Ellos lo hicieron así."
,"21":"Y se decían unos a otros: 'Verdaderamente estamos pagando lo que hicimos con nuestro hermano. Lleno de angustia nos pedía clemencia, y no le hicimos caso. Por eso nos ha venido esta desgracia'."
,"22":"Rubén les respondió: 'Ya os dije yo que no hicierais ningún mal al muchacho, pero no me escuchasteis. Ahora se nos pide cuentas de su sangre'."
,"23":"Ellos no sabían que José les entendía, porque entre él y ellos había un intérprete."
,"24":"Entonces se retiró y lloró. Después volvió y les habló; y tomó a Simeón y, en su presencia, mandó que lo metieran en la cárcel."
,"25":"José mandó que les llenaran los sacos de trigo, que les metieran el dinero de cada uno en su saco y que les dieran provisiones para el viaje. Y así se hizo."
,"26":"Ellos cargaron el trigo sobre sus asnos y se marcharon."
,"27":"Al acampar por la noche, uno de ellos abrió su saco para dar de comer a su asno y vio que su dinero estaba en la boca del saco,"
,"28":"y dijo a sus hermanos: 'Me han devuelto mi dinero: está aquí en mi saco'. Con el corazón sobresaltado y temblando se decían unos a otros: '¿Qué es lo que Dios nos ha hecho?'."
,"29":"Llegaron donde su padre Jacob, en la tierra de Canaán, y le contaron todo lo que les había ocurrido:"
,"30":"'El hombre que es señor del país nos habló duramente y nos tomó por espías contra el país."
,"31":"Nosotros le dijimos: Somos gente de bien, no somos espías."
,"32":"Somos doce hermanos hijos de un mismo padre; uno ya no vive y el menor se ha quedado con nuestro padre en la tierra de Canaán."
,"33":"Pero aquel hombre, señor del país, nos respondió: De este modo sabré si sois sinceros: dejad conmigo aquí uno de vuestros hermanos, tomad lo necesario para vuestras familias hambrientas y partid."
,"34":"Pero a la vuelta traedme a vuestro hermano menor; así sabré que no sois espías, sino hombres de bien. Luego devolveré a vuestro hermano y podréis comerciar en este país'."
,"35":"Cuando vaciaron los sacos, cada uno encontró en su saco la bolsa del dinero. Al verlas, su padre y ellos se echaron a temblar."
,"36":"Jacob les dijo: 'Me vais a dejar sin hijos. José desapareció, Simeón también, ¿y queréis llevarme a Benjamín? ¡Todo está contra mí!'."
,"37":"Rubén dijo a su padre: 'Haz morir a mis dos hijos, si no te lo devuelvo; entrégamelo, y yo te lo devolveré'."
,"38":"Pero él repuso: 'Mi hijo no bajará con vosotros; su hermano ha muerto y ha quedado sólo él; si le sucede alguna desgracia en el viaje que vais a emprender, del dolor haríais bajar mis canas a la tumba'."
}`)
	CurrentBook.AddChapter(43, `{
"1":"El hambre arreciaba en el país."
,"2":"Cuando consumieron las provisiones que habían traído de Egipto, su padre les dijo: 'Volved a comprar más víveres'."
,"3":"Judá le dijo: 'Aquel hombre nos advirtió expresamente que no seríamos admitidos de nuevo en su presencia sin nuestro hermano menor."
,"4":"Si estás dispuesto a dejar venir a nuestro hermano con nosotros, bajaremos a comprar alimentos;"
,"5":"pero si no le dejas venir, no bajaremos porque aquel hombre nos dijo expresamente que no seríamos admitidos de nuevo en su presencia sin nuestro hermano menor'."
,"6":"Israel dijo: '¿Por qué me habéis hecho este mal diciendo a aquel hombre que teníais otro hermano?'."
,"7":"Ellos respondieron: 'Aquel hombre nos preguntó expresamente por nuestra familia, diciendo: ¿Vive todavía vuestro padre? ¿Tenéis más hermanos? Y nosotros contestamos a sus preguntas. ¿Cómo íbamos a suponer que nos iba a decir que lleváramos a nuestro hermano?'. "
,"8":"Entonces Judá dijo a su padre, Israel: 'Deja venir conmigo al muchacho; salgamos inmediatamente, si queremos vivir y no morir nosotros, tú y nuestros hijos."
,"9":"Yo salgo fiador de él; a mí me pedirás cuenta. Si no te lo devuelvo, si no te lo traigo, yo seré culpable ante ti toda mi vida."
,"10":"Si no nos hubiéramos detenido, ya estaríamos de regreso'."
,"11":"Israel, su padre, les dijo: 'Ya que así tiene que ser, hacedlo; tomad en vuestro equipaje de lo mejor de la tierra y llevádselo a aquel hombre como regalo: bálsamo y miel, aromas y mirra, nueces y almendras."
,"12":"Tomad doble cantidad de dinero y restituid el que os fue devuelto en la boca de los sacos; quizá fue una equivocación."
,"13":"Llevad también a vuestro hermano. Andad, volved donde aquel hombre."
,"14":"Que el Dios todopoderoso haga que aquel hombre sea benévolo con vosotros y os deje traer libre al otro hermano vuestro y a Benjamín. En cuanto a mí, si he de verme privado de mis hijos, que así sea'."
,"15":"Tomaron los regalos, doble cantidad de dinero y a Benjamín, y se pusieron en camino. Llegaron a Egipto y se presentaron a José."
,"16":"Cuando José vio a Benjamín con ellos, dijo a su mayordomo: 'Lleva a estos hombres a casa, mata un animal y aderézalo, porque comerán conmigo al mediodía'. "
,"17":"El mayordomo hizo lo que le dijo José y los llevó a la casa de José."
,"18":"Ellos, al ver que los llevaban a casa de José, se llenaron de miedo y se decían: 'Nos han traído aquí por lo del dinero que nos fue devuelto en nuestros sacos. Nos han traído aquí con nuestros asnos para acusarnos, torturarnos y tomarnos como esclavos'."
,"19":"Se acercaron al mayordomo de José y le hablaron así a la entrada de la casa."
,"20":"'Perdón, señor, nosotros vinimos la otra vez a comprar víveres."
,"21":"Ahora bien, al acampar por la noche y abrir nuestros sacos, cada uno encontró su dinero en la boca de su saco. Pero ahora lo traemos con nosotros."
,"22":"Traemos también más dinero para pagar los víveres. Nosotros no sabemos quién puso nuestro dinero en los sacos'."
,"23":"Y él les dijo: 'Estad tranquilos, no temáis. Fue vuestro Dios y el Dios de vuestro padre el que puso un tesoro en vuestros sacos; yo recibí vuestro dinero'. Y les sacó a Simeón."
,"24":"Después los introdujo en la casa de José, les llevó agua para que se lavaran los pies y dio forraje a sus asnos."
,"25":"Ellos prepararon el regalo esperando que José llegara al mediodía, pues habían oído que iban a comer allí."
,"26":"Cuando José entró en la casa, le ofrecieron el regalo que tenían consigo y se postraron en tierra."
,"27":"Él les preguntó: '¿Qué tal estáis? ¿Cómo está vuestro padre, del que me hablasteis? ¿Vive todavía?'."
,"28":"Ellos respondieron: 'Tu siervo, nuestro padre, todavía vive y está bien'. Se inclinaron y le hicieron reverencia."
,"29":"José alzó los ojos y vio a Benjamín, su hermano materno, y preguntó: '¿Es éste vuestro hermano menor, del que me hablasteis?'. Y a él le dijo: 'Dios te guarde, hijo mío'."
,"30":"José salió apresuradamente porque estaba muy emocionado a la vista de su hermano y se le saltaban las lágrimas. Entró en su habitación y se puso a llorar."
,"31":"Se lavó la cara y, dominándose, dijo: 'Servid la comida'."
,"32":"Sirvieron a José aparte, aparte a sus hermanos y aparte también a los egipcios que comían con él, porque los egipcios no pueden comer con los hebreos, por ser cosa prohibida para ellos."
,"33":"Les sentaron frente a José, cada uno en su puesto, del mayor al menor, y se miraban asombrados unos a otros."
,"34":"Él les mandaba desde su mesa las porciones, y la porción de Benjamín era cinco veces mayor que la de todos los otros. Así bebieron y se alegraron en su compañía."
}`)
	CurrentBook.AddChapter(44, `{
"1":"José ordenó a su mayordomo: 'Llena de víveres los sacos de estos hombres hasta arriba y pon el dinero de cada uno en la boca del saco."
,"2":"Pon mi copa de plata en la boca del saco del más joven, junto con el dinero de su grano'. Y él lo hizo así."
,"3":"Al venir el día, se despidieron y se fueron con sus asnos."
,"4":"Apenas habían salido de la ciudad, de la que no estaban lejos, cuando José dijo a su mayordomo: 'Levántate, sigue a esos hombres, dales alcance y diles: ¿Por qué habéis devuelto mal por bien?"
,"5":"¿No es ésa la copa que sirve a mi señor para beber y adivinar? Os habéis portado muy mal'."
,"6":"Él les dio alcance y les habló de este modo."
,"7":"Pero ellos respondieron: '¿Por qué nos habla así, señor? ¡Lejos de tus siervos hacer cosa semejante!"
,"8":"Ya ves que el dinero que encontramos en la boca de los sacos te lo hemos traído desde la tierra de Canaán; ¿cómo podríamos haber robado plata u oro de la casa de tu señor?"
,"9":"Aquel de tus siervos en cuyo poder se encuentre la copa, que muera; y nosotros mismos quedaremos como esclavos de tu señor'."
,"10":"Él dijo: 'Bien, sea como decís: aquel en cuyo poder encuentre la copa será mi esclavo, pero todos los demás podréis marchar'."
,"11":"Ellos descargaron aprisa los sacos y cada uno abrió el suyo."
,"12":"Él los registró empezando por el mayor y terminando por el menor, y la copa fue encontrada en el saco de Benjamín."
,"13":"Ellos se rasgaron sus vestidos, volvieron a cargar sus sacos, cada uno el suyo, y regresaron a la ciudad."
,"14":"Cuando Judá y sus hermanos llegaron a la casa de José, éste estaba todavía allí. Ellos se postraron ante él,"
,"15":"y José les preguntó: '¿Qué es lo que habéis hecho? ¿No sabíais que un hombre como yo sabe adivinar?'."
,"16":"Y Judá respondió: '¿Qué diremos a mi señor y cómo podremos justificarnos? Ha sido Dios quien ha descubierto la maldad de tus siervos. Aquí nos tienes como esclavos tuyos, tanto nosotros como aquel en cuyo poder fue encontrada la copa'."
,"17":"Él respondió: '¡Lejos de mí hacer eso! El hombre en cuyo poder ha sido encontrada la copa, ése será mi esclavo; los demás volved en paz a vuestro padre'."
,"18":"Judá se acercó a él y le dijo: 'Perdón, señor. Permite a tu siervo dirigir una palabra a mi señor, sin que por eso se irrite contra él, porque tú eres en verdad como el Faraón."
,"19":"Mi señor preguntó a sus siervos: ¿Tenéis todavía padre o algún hermano?"
,"20":"Nosotros respondimos a mi señor: tenemos un padre ya anciano y un hermano que le nació en su vejez; un hermano suyo ha muerto, por lo que le quedó él solo de aquella mujer, y su padre le quiere mucho."
,"21":"Tú dijiste a tus siervos: Traédmelo para que lo vea."
,"22":"Nosotros respondimos a mi señor: El joven no puede dejar a su padre; si le deja, su padre morirá."
,"23":"Tú insististe: Si vuestro hermano menor no baja con vosotros, no seréis admitidos más en mi presencia."
,"24":"Cuando volvimos a tu siervo, nuestro padre, le contamos lo que nos había dicho mi señor."
,"25":"Y cuando nuestro padre nos dijo: Volved a comprar alimentos, le respondimos:"
,"26":"No podemos bajar si no viene con nosotros nuestro hermano menor, porque no seremos recibidos por aquel hombre si nuestro hermano menor no va con nosotros."
,"27":"Tu siervo, mi padre, nos dijo: Sabéis que mi mujer no me ha dado más que dos hijos."
,"28":"Uno salió cuando estaba conmigo y seguramente fue despedazado, pues ya no lo he vuelto a ver;"
,"29":"si os lleváis también a éste de mi lado y le sucede alguna desgracia, del dolor haríais bajar mis canas a la tumba."
,"30":"Si yo ahora vuelvo a tu siervo, mi padre, y no va con nosotros el muchacho, al que quiere con toda su alma,"
,"31":"cuando vea que no va con nosotros, morirá, y tus siervos harán que las canas de tu siervo, nuestro padre, bajen, de dolor, a la tumba."
,"32":"Tu siervo salió fiador del joven ante mi padre, diciendo: Si no te lo devuelvo, seré culpable ante mi padre toda mi vida."
,"33":"Te suplico que quede tu siervo como esclavo de mi señor en lugar del muchacho y que éste vuelva con mis hermanos."
,"34":"¡Cómo podría yo volver a mi padre sin el muchacho! ¡Yo no puedo ver la desgracia que afligiría a mi padre!'."
}`)
	CurrentBook.AddChapter(45, `{
"1":"José no podía ya contenerse delante de todos los presentes y gritó: 'Salid todos de mi presencia'. Y no quedó nadie con él cuando se dio a conocer a sus hermanos."
,"2":"Entonces rompió a llorar a voz en grito, de modo que lo oyeron los egipcios, y la noticia llegó a casa del Faraón."
,"3":"José dijo a sus hermanos: 'Yo soy José. ¿Vive todavía mi padre?'. Sus hermanos no pudieron responderle, de tan asustados que estaban ante él."
,"4":"Entonces él les dijo: 'Acercaos a mí'. Y ellos se acercaron. Él dijo: 'Yo soy José, vuestro hermano, el que vendisteis para Egipto."
,"5":"Pero ahora no estéis apenados ni os pese el haberme vendido aquí, pues fue Dios quien me envió delante de vosotros para salvar vuestras vidas."
,"6":"Ya van dos años de hambre sobre la tierra, y aún quedan otros cinco sin labranza ni siega."
,"7":"Dios me ha enviado delante de vosotros para asegurar vuestra supervivencia en el país y salvar la vida de muchos de vosotros."
,"8":"No fuisteis vosotros los que me enviasteis aquí, sino Dios. Él me ha hecho padre del Faraón y señor de toda su casa, gobernador de todo el país de Egipto."
,"9":"Subid aprisa a mi padre y decidle: Esto dice tu hijo José: Dios me ha constituido señor de todo Egipto, baja hasta mí sin tardar."
,"10":"Habitarás en la región de Gosen y estarás cerca de mí tú, tus hijos y tus nietos, tus rebaños, tus ganados y todo cuanto tienes."
,"11":"Allí yo cuidaré de tu subsistencia, para que no perezcas de miseria tú y tu familia y todos los tuyos, porque todavía habrá cinco años de hambre."
,"12":"Vosotros y mi hermano Benjamín veis con vuestros propios ojos que es mi boca la que os habla."
,"13":"Contad a mi padre lo importante que soy en Egipto y todo lo que habéis visto; daos prisa en traer aquí a mi padre'."
,"14":"Se abrazó al cuello de Benjamín y se echó a llorar, y Benjamín también lloró abrazado a él."
,"15":"Luego besó a todos sus hermanos entre lágrimas. Después de esto sus hermanos quedaron hablando con él."
,"16":"Llegó a casa del Faraón la noticia de que habían venido los hermanos de José, y el Faraón y sus servidores se alegraron."
,"17":"El Faraón dijo a José: 'Di a tus hermanos: Haced lo siguiente: cargad vuestros asnos y volved a la tierra de Canaán."
,"18":"Tomad a vuestro padre y a vuestras familias y volved acá. Yo os daré lo mejor de la tierra de Egipto y disfrutaréis de lo mejor de ella."
,"19":"Tú tienes autoridad para ordenar: Haced esto: tomad de la tierra de Egipto carros para vuestros niños y mujeres, tomad a vuestro padre y venid."
,"20":"No os duela dejar vuestras casas, porque lo mejor de la tierra de Egipto será para vosotros'."
,"21":"Así lo hicieron los hijos de Israel. José les proporcionó carros conforme a la orden del Faraón y les proveyó de víveres para el camino."
,"22":"Dio un traje nuevo a cada uno, pero a Benjamín le dio trescientas monedas de plata y cinco trajes nuevos."
,"23":"Envió a su padre diez asnos cargados con lo mejor de la tierra de Egipto y diez asnas cargadas de trigo, pan y comida para el camino."
,"24":"Se despidió de sus hermanos y les dijo: 'No discutáis por el camino'."
,"25":"Ellos subieron de Egipto y llegaron a Canaán, donde su padre, Jacob,"
,"26":"y le dieron la noticia: 'José vive todavía y es señor de todo Egipto'."
,"27":"Pero él no se inmutó, porque no les creía. Cuando ellos le contaron todo lo que José les había dicho y cuando vio los carros que José enviaba para llevarlo, el espíritu de Jacob, su padre, reaccionó."
,"28":"Israel dijo: 'Sí, José, mi hijo, está vivo todavía. Iré y lo veré antes de morir'."
}`)
	CurrentBook.AddChapter(46, `{
"1":"Israel partió con todo lo que tenía. Al llegar a Berseba, ofreció sacrificios al Dios de su padre Isaac."
,"2":"Y Dios habló a Israel en una visión nocturna: '¡Jacob! ¡Jacob!'. Él respondió: 'Aquí estoy'."
,"3":"Dios continuó: 'Yo soy Dios, el Dios de tu padre. No temas bajar a Egipto, porque allí yo haré de ti un gran pueblo."
,"4":"Bajaré contigo a Egipto y te haré subir de allí. José te cerrará los ojos'."
,"5":"Jacob partió de Berseba. Los hijos de Israel hicieron subir a Jacob, su padre, a sus niños y a sus mujeres a los carros enviados por el Faraón para llevarlos."
,"6":"Llevaron también consigo sus ganados y cuanto habían adquirido en la tierra de Canaán. Jacob emigró a Egipto con todos sus descendientes,"
,"7":"hijos y nietos, hijas y nietas; todos sus descendientes los llevó consigo a Egipto."
,"8":"Éstos son los nombres de los hijos de Israel que llegaron a Egipto: Jacob y sus hijos; el primogénito de Jacob, Rubén."
,"9":"Hijos de Rubén: Henoc, Falú, Jesrón y Carmí."
,"10":"Hijos de Simeón: Yemuel, Yamín, Ohad, Yaquín, Sójar y Saúl, hijo de la cananea."
,"11":"Hijos de Leví: Guersón, Quehat y Merarí."
,"12":"Hijos de Judá: Er, Onán, Selá, Fares y Zéraj; pero Er y Onán habían muerto en la tierra de Canaán."
,"13":"Hijos de Isacar: Tolá, Puvá, Yasub y Simrón."
,"14":"Hijos de Zabulón: Séred, Elón y Yajleel."
,"15":"Éstos son los hijos que Lía dio a Jacob en Padán Arán, con su hija Dina. En total, entre hijos e hijas, treinta y tres personas."
,"16":"Hijos de Gad: Sefión, Jaguí, Suní, Esbón, Erí, Arodí y Arelí."
,"17":"Hijos de Aser: Yimná, Yisvá, Yisví, Beriá y Séraj, su hermana. Hijos de Beriá eran Jéber y Melquiel."
,"18":"Éstos son los hijos de Zilpa, la esclava que dio Labán a su hija Lía, y que ella dio a Jacob. Dieciséis personas."
,"19":"Hijos de Raquel, la mujer de Jacob: José y Benjamín."
,"20":"A José le nacieron en Egipto, de Asenat, hija de Putifar, sacerdote de On, Manasés y Efraín."
,"21":"Hijos de Benjamín: Bela, Béker, Asbel. Hijos de Bela: Guerá, Naamán, Ejí, Ros, Mupín, Yupín y Ared."
,"22":"Éstos fueron los hijos de Raquel y Jacob; en total, catorce personas."
,"23":"Hijos de Dan: Jusín."
,"24":"Hijos de Neftalí: Yajseel, Guní, Yéser y Silén."
,"25":"Éstos son los hijos de Jacob y Bihlá, la que Labán dio a su hija Raquel. En total, siete personas."
,"26":"Todas las personas de la familia de Jacob, que emigraron con él a Egipto, sin contar a sus nueras, eran en total sesenta y seis."
,"27":"Los hijos de José que le nacieron en Egipto, dos. En total, las personas de la casa de Jacob que vinieron a Egipto eran setenta."
,"28":"Israel envió por delante a Judá al encuentro de José, para comunicarle que viniera a verle a Gosen. Ellos llegaron a la región de Gosen."
,"29":"José hizo enganchar su carro y salió al encuentro de su padre, Israel, a Gosen. Al verlo, se echó a su cuello y lloró largamente abrazado a él."
,"30":"Israel dijo a José: 'Ahora puedo ya morir porque he visto tu rostro y estás todavía vivo'."
,"31":"José dijo a sus hermanos: 'Voy a comunicárselo al Faraón y a decirle: Mis hermanos y la familia de mi padre, que estaban en Canaán, han venido aquí."
,"32":"Son pastores y poseen ganados; han traído consigo sus ovejas, sus vacas y todo cuanto tenían."
,"33":"Cuando el Faraón os llame y os diga: ¿Cuál es vuestro oficio?,"
,"34":"responderéis: Tus siervos se han ocupado de ganado desde su juventud hasta ahora, como antes nuestros padres. Así podréis quedaros a vivir en la región de Gosen, porque los egipcios detestan a los pastores'."
}`)
	CurrentBook.AddChapter(47, `{
"1":"José fue a comunicárselo al Faraón: 'Mi padre y mis hermanos han venido de Canaán con sus rebaños y ganados y con todo cuanto tienen y están ya en la región de Gosen'."
,"2":"José había llevado consigo a cinco de sus hermanos y se los presentó al Faraón,"
,"3":"que les preguntó: '¿Cuál es vuestro oficio?'. Ellos respondieron: 'Tus siervos son pastores, como lo fueron nuestros padres'."
,"4":"Y añadieron: 'Hemos venido a habitar en este país porque en Canaán no hay pastos para los ganados de tus siervos y el hambre se ha agravado; permite que tus siervos habiten en la región de Gosen'."
,"5":"El Faraón dijo a José: 'Tu padre y tus hermanos han venido junto a ti;"
,"6":"todo Egipto está a tu disposición. Instala a tu padre y a tus hermanos en lo mejor del país; que se queden en la región de Gosen y, si sabes que entre ellos hay hombres de valía, ponlos de mayorales de mis ganados'."
,"7":"José trajo a su padre Jacob y se lo presentó al Faraón. Y Jacob bendijo al Faraón,"
,"8":"quien le preguntó: '¿Cuántos años tienes?'."
,"9":"Jacob le respondió: 'Los años de mi peregrinar son ciento treinta. Pocos e infelices han sido los años de mi vida, y no alcanzaré los años de vida de mis padres durante su peregrinación'."
,"10":"Jacob bendijo de nuevo al Faraón y se retiró de su presencia."
,"11":"José instaló a su padre y a sus hermanos, y les dio propiedades en Egipto, en lo mejor del país, en el distrito de Rameses, como había ordenado el Faraón."
,"12":"José proveyó de alimentos a su padre, a sus hermanos y a toda su familia, según el número de hijos."
,"13":"Por entonces no había pan en el país, pues el hambre se había agravado en extremo. Egipto y Canaán desfallecían de hambre."
,"14":"José iba reuniendo todo el dinero que había en Egipto y Canaán a cambio del grano que le compraban, y lo iba depositando en la casa del Faraón."
,"15":"En Egipto y Canaán se acabó el dinero. Todos los egipcios se llegaron a José diciéndole: 'Danos pan; ¿es que vamos a morir ante tus ojos porque no tenemos ya dinero?'."
,"16":"José les respondió: 'Dadme vuestros ganados, si se os ha acabado ya el dinero, y a cambio os daré trigo'."
,"17":"Ellos trajeron a José sus ganados, y les dio alimentos a cambio de caballos, ovejas, bueyes y asnos... Así todo aquel año les proveyó de pan a cambio de ganados."
,"18":"Pasado aquel año, volvieron al año siguiente y le dijeron: 'No podemos ocultar a nuestro señor que se nos ha acabado el dinero; también el ganado es ya de nuestro señor y ahora no nos queda para nuestro señor sino nuestro cuerpo y nuestras tierras."
,"19":"¿Por qué habremos de perecer ante tus ojos nosotros y nuestras tierras? Cómpranos a nosotros y a nuestras tierras a cambio de pan. Seremos esclavos del Faraón nosotros y nuestras tierras, pero danos simiente para que podamos vivir y no muramos y para que nuestras tierras no queden desoladas'."
,"20":"José compró así en nombre del Faraón todas las tierras de Egipto, pues los egipcios, oprimidos por el hambre, le vendieron cada uno sus fincas."
,"21":"De este modo adquirió José para el Faraón toda la tierra de Egipto, reduciendo a esclavitud a todo el pueblo del uno al otro confín de Egipto."
,"22":"Solamente dejó de comprar las tierras de los sacerdotes, porque ellos tenían una asignación del Faraón y vivían del rédito que éste les daba; por eso no vendieron sus tierras."
,"23":"José dijo al pueblo: 'Os he comprado a vosotros y a vuestras tierras para el Faraón; pero ahora aquí tenéis simiente, sembrad las tierras."
,"24":"De la cosecha daréis la quinta parte al Faraón, y las otras cuatro partes serán vuestras para la siembra de los campos y para vuestro consumo y el de vuestras familias'."
,"25":"Ellos respondieron: 'Tú nos has salvado la vida; hallemos ahora gracia a los ojos de nuestro señor y seremos siervos del Faraón'."
,"26":"José puso esta ley, todavía en vigor hoy en Egipto: dar al Faraón la quinta parte; sólo las tierras de los sacerdotes no pasarán a ser propiedad del Faraón."
,"27":"Los israelitas se establecieron en Egipto en la región de Gosen, se posesionaron de ella y crecieron y se multiplicaron en gran manera."
,"28":"Jacob vivió diecisiete años en Egipto; en total, los años de su vida fueron ciento cuarenta y siete."
,"29":"Cuando se acercaba ya para Jacob el día de su muerte, mandó llamar a su hijo José y le dijo: 'Si he hallado gracia a tus ojos, pon tu mano debajo de mi muslo en señal de juramento, y prométeme que serás bueno y fiel conmigo; no me entierres en Egipto."
,"30":"Cuando me duerma con mis padres, sácame de Egipto y entiérrame en su sepultura'. José respondió: 'Haré como tú dices'. "
,"31":"Jacob añadió: 'Júramelo', y José se lo juró. E Israel se inclinó sobre la cabecera de la cama."
}`)
	CurrentBook.AddChapter(48, `{
"1":"Después de esto dijeron a José: 'Tu padre está enfermo'. Él tomó consigo a sus dos hijos, Manasés y Efraín."
,"2":"Le anunciaron a Jacob: 'Mira, tu hijo José viene a verte'. Israel hizo un esfuerzo y se sentó en la cama."
,"3":"Jacob dijo a José: 'El Dios todopoderoso se me apareció en Luz, en el país de Canaán, me bendijo y me dijo:"
,"4":"Yo te haré fecundo y numeroso y haré que llegues a ser una comunidad de pueblos; esta tierra se la daré en posesión perpetua a tu descendencia."
,"5":"Tus dos hijos, Manasés y Efraín, que te nacieron en el país de Egipto antes de que yo viniese aquí contigo, son míos: Efraín y Manasés serán míos como Rubén y Simeón."
,"6":"Los que engendres después de ellos serán tuyos, y recibirán la herencia en nombre de sus hermanos."
,"7":"Cuando yo volvía de Padán Arán perdí a Raquel, tu madre, en el camino a través de Canaán, no lejos de Éfrata, y la sepulté en el camino de Éfrata, o sea Belén'."
,"8":"Israel vio a los dos hijos de José y preguntó: '¿Quiénes son éstos?'."
,"9":"José respondió a su padre: 'Son mis hijos, los que Dios me ha dado aquí'. Jacob dijo: 'Acércamelos, que quiero bendecirlos'."
,"10":"Los ojos de Israel estaban tan achacosos por la vejez que apenas podían ver. José se los acercó, y él los abrazó y los besó."
,"11":"Israel dijo a José: 'No pensaba ya ver tu rostro, y Dios me ha dado ver también a tu descendencia'."
,"12":"José los retiró de las rodillas de su padre y se inclinó hasta el suelo."
,"13":"José tomó a ambos, a Efraín con su derecha a la izquierda de Israel y a Manasés con su izquierda a la derecha de Israel, y así se acercó hasta él."
,"14":"Israel extendió su mano derecha y la puso sobre la cabeza de Efraín, que era el menor, y su izquierda sobre la cabeza de Manasés, cruzando de intento las manos, a pesar de que Manasés era el mayor."
,"15":"Y bendijo a José diciendo: 'El Dios en cuya presencia anduvieron mis padres Abrahán e Isaac, el Dios que me ha guiado desde mi nacimiento hasta hoy,"
,"16":"el ángel que me ha librado de todo mal, bendiga a estos muchachos y por ellos se difunda mi nombre y el nombre de mis padres Abrahán e Isaac; que crezcan y se multipliquen sobre la tierra'."
,"17":"José, viendo que su padre tenía su mano derecha sobre la cabeza de Efraín, se disgustó y tomó la mano de su padre para mudarla de la cabeza de Efraín a la de Manasés."
,"18":"Y le dijo: 'Así no, padre, porque el mayor es éste; pon tu mano derecha sobre su cabeza'."
,"19":"Pero su padre se opuso y dijo: 'Lo sé, hijo mío, lo sé. También él llegará a ser un pueblo y será también grande, pero su hermano menor será más grande que él y su posteridad será una muchedumbre de pueblos'."
,"20":"Aquel día Israel los bendijo diciendo: 'Por vosotros Israel bendecirá así: Que Dios os haga como a Efraín y Manasés'. Y puso a Efraín delante de Manasés."
,"21":"Israel dijo a José: 'Yo me voy a morir; pero Dios estará con vosotros y os llevará de nuevo a la tierra de vuestros padres."
,"22":"A ti te doy Siquén, con preferencia a tus hermanos, la que conquisté a los amorreos con mi espada y mi arco'."
}`)
	CurrentBook.AddChapter(49, `{
"1":"Jacob llamó a sus hijos y les dijo: 'Reuníos, que os voy a decir lo que será de vosotros en los días venideros."
,"2":"Reuníos y oíd, hijos de Jacob; prestad oídos a Israel, vuestro padre."
,"3":"Rubén, tú eres mi primogénito, mi fuerza y la primicia de mi virilidad, el primero en arrogancia,y el primero en poder."
,"4":"Impetuoso como las aguas, no serás el primero,porque subiste al lecho de tu padre,y profanaste mi cama."
,"5":"Simeón y Leví son hermanos; armas de violencia son sus armas."
,"6":"No quiero asistir a sus consejos, no quiero participar en su asamblea, porque en su furor mataron hombres,y a su antojo desjarretaron toros."
,"7":"Maldito su furor, tan violento, y su cólera, tan cruel. Los repartiré en Jacob, los dispersaré en Israel."
,"8":"A ti, Judá, te alabarán tus hermanos; tu mano, sobre la cerviz,de tus enemigos; los hijos de tu padre,se inclinarán ante ti."
,"9":"Cachorro de león es Judá, de hacer presa subes, hijo mío. Se encorva, se echa como un león, como leona; ¿quién podrá levantarlo?"
,"10":"El cetro no será arrebatado de Judá, ni el bastón de mando de entre,sus pies hasta que venga aquel,a quien pertenece,y a quien los pueblos obedecerán."
,"11":"Él ata a la vid su pollino,y a la cepa el hijo de su asna. Él lava en el vino su vestido,y en sangre de uvas su manto."
,"12":"Sus ojos, bermejos del vino, y sus dientes, blancos de la leche."
,"13":"Zabulón habitará a lo largo del mar, en los puertos donde atracan las naves,con su flanco vuelto hacia Sidón."
,"14":"Isacar es un asno robusto,echado entre dos empalizadas."
,"15":"Vio que el reposo era bueno,y la tierra agradable; inclinará su hombro a la carga,y será sujeto a tributo."
,"16":"Dan juzgará a su pueblo,como una más de las tribus de Israel."
,"17":"Dan será serpiente en el camino, como víbora junto al sendero, que muerde los talones del caballo,y hace caer por detrás al jinete."
,"18":"Tu salvación espero, ¡oh, Señor!"
,"19":"Gad, una tropa de bandidos,le acomete, pero él los ataca por la espalda."
,"20":"Aser abunda en pan exquisito, manjar de reyes proporciona."
,"21":"Neftalí es una cierva suelta, que tiene preciosos cervatillos."
,"22":"Ramo de vid fecunda es José, ramo de vid frondosa junto,a la fuente, cuyos vástagos,se extienden sobre el muro."
,"23":"Le han provocado, le han disparado,flechas, le han hostigado los arqueros;"
,"24":"pero su arco permanece firme,y ágiles sus brazos gracias a las manos,del Fuerte de Jacob, gracias al nombre del Pastor, la Roca de Israel."
,"25":"El Dios de tu padre te ayuda, el todopoderoso te bendice: bendiciones que bajan del cielo, bendiciones que suben del abismo, bendiciones de pechos y seno,"
,"26":"bendiciones de espigas y frutos, bendiciones de los montes antiguos, delicias de los collados eternos; caigan sobre la cabeza de José, sobre el elegido entre sus hermanos."
,"27":"Benjamín es lobo rapaz, que a la mañana devora la presa,y a la tarde reparte los despojos'."
,"28":"Todos éstos son las doce tribus de Israel, y esto lo que su padre les dijo cuando los bendijo a cada uno con su propia bendición."
,"29":"Después les dio estas órdenes: 'Yo voy a reunirme con mi pueblo; sepultadme con mis padres en la gruta que está en el campo de Efrón, el hitita,"
,"30":"esto es, en la caverna de Macpela, frente a Mambré en Canaán, la que compró Abrahán con el campo de Efrón, el hitita, como propiedad funeraria."
,"31":"Allí fueron sepultados Abrahán y su mujer, Sara; allí también Isaac y Rebeca, su mujer; allí también he sepultado yo a Lía."
,"32":"El campo y su caverna los compró Abrahán a los hititas'."
,"33":"Cuando acabó de dar estas órdenes a sus hijos, recogió sus pies en la cama, entregó su espíritu y se reunió con los suyos."
}`)
	CurrentBook.AddChapter(50, `{
"1":"José se echó sobre el rostro de su padre, llorando y besándole."
,"2":"Luego mandó a los médicos que estaban a sus órdenes que embalsamaran a su padre."
,"3":"Emplearon en ello cuarenta días, porque ése era el tiempo requerido para embalsamar. Los egipcios lo lloraron por espacio de setenta días."
,"4":"Pasados los días de luto, José habló así a la corte del Faraón: 'Si he hallado gracia a vuestros ojos, hablad al Faraón y decidle: "
,"5":"Mi padre me hizo jurar diciéndome: Yo voy a morir, sepúltame en el sepulcro que hice para mí en el país de Canaán. Permíteme que vaya a sepultar a mi padre y luego volveré'."
,"6":"El Faraón respondió: 'Anda y sepulta a tu padre, como él te hizo jurar'."
,"7":"José subió a sepultar a su padre, y con él subieron todos los siervos del Faraón, los ancianos de su corte, todos los ancianos de Egipto"
,"8":"y toda la familia de su padre; solamente dejaron en la región de Gosen a sus niños y a sus rebaños y ganados."
,"9":"Subieron también con él carros y caballeros, de modo que el cortejo fue imponente."
,"10":"Cuando llegaron a la era de Atad, al otro lado del Jordán, hicieron grandes y solemnes funerales; y José guardó por su padre un luto de siete días."
,"11":"Cuando los cananeos que habitaban en aquella región vieron aquel luto en la era de Atad se dijeron: 'Éste es gran luto para los egipcios'. Por eso pusieron el nombre de 'Luto de Egipto' a la era que está al otro lado del Jordán."
,"12":"Los hijos de Jacob hicieron con él como les había ordenado."
,"13":"Lo llevaron a Canaán y lo sepultaron en la caverna del campo de Macpela, comprada por Abrahán para sepultura de los suyos a Efrón, el hitita, enfrente de Mambré."
,"14":"José, después de haber sepultado a su padre, volvió a Egipto con sus hermanos y con todos los que le habían acompañado a sepultar a su padre."
,"15":"Al ver los hermanos de José que su padre había muerto, se decían: 'A lo mejor ahora José nos aborrece y se cobra todo el mal que le hicimos'."
,"16":"Y mandaron a decir a José: 'Tu padre, antes de morir, ordenó esto:"
,"17":"Diréis a José: Perdona el delito y el pecado de tus hermanos, el mal que te hicieron; perdona el delito de los siervos del Dios de tu padre'. José, al oírlo, se echó a llorar."
,"18":"Luego llegaron sus mismos hermanos, se postraron ante él y le dijeron: 'Aquí nos tienes como esclavos tuyos'."
,"19":"Pero José les dijo: 'No temáis, ¿estoy yo acaso en lugar de Dios?"
,"20":"Ciertamente vosotros os portasteis mal conmigo, pero Dios lo cambió en bien, para hacer lo que hoy estamos viendo, para mantener en vida a un gran pueblo."
,"21":"Por tanto, no temáis; yo os mantendré a vosotros y a vuestros hijos'. De esta manera los consoló hablándoles a su corazón."
,"22":"José habitó en Egipto, él y la familia de su padre; vivió ciento diez años."
,"23":"José vio a los hijos de Efraín hasta la tercera generación. También recibió sobre sus rodillas, al nacer, a los hijos de Maquir, hijo de Manasés."
,"24":"Luego dijo a sus hermanos: 'Yo voy a morir, pero Dios vendrá ciertamente en vuestra ayuda y os hará subir de esta tierra a la tierra que él prometió a Abrahán, Isaac y Jacob'."
,"25":"José hizo jurar a los hijos de Israel así: 'Ya que Dios vendrá ciertamente en vuestra ayuda, llevaréis de aquí mis huesos'."
,"26":"José murió a los ciento diez años, lo embalsamaron y lo pusieron en un sarcófago en Egipto."
}`)

}
func ES_LSB_LoadVPLVChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"El Señor llamó a Moisés y le habló desde la tienda de la reunión:"
,"2":"'Di a los israelitas: Cuando alguno de vosotros quiera hacer una ofrenda al Señor, podrá hacerla en animales, ganado mayor o menor."
,"3":"Si su ofrenda es un holocausto de ganado mayor, ofrecerá un macho sin defecto, el cual debe ser presentado en la puerta de la tienda de la reunión, para que el Señor lo acepte."
,"4":"Pondrá su mano sobre la cabeza de la víctima, para que sea aceptada como expiación en favor suyo."
,"5":"Inmolará la res delante del Señor, y los hijos de Aarón, los sacerdotes, ofrecerán la sangre, derramándola en torno del altar que se encuentra a la entrada de la tienda de la reunión."
,"6":"Degollará luego la víctima, la descuartizará,"
,"7":"y los hijos de Aarón, los sacerdotes, pondrán fuego sobre el altar, dispondrán leña sobre el fuego"
,"8":"y acomodarán los trozos, con la cabeza y las grasas, encima de la leña colocada sobre el fuego del altar."
,"9":"Lavará con agua las entrañas y las patas, y el sacerdote lo quemará todo sobre el altar: es un holocausto, una ofrenda quemada, un perfume agradable al Señor."
,"10":"Si su ofrenda es un holocausto de ganado menor, ovejas o cabras, ofrecerá un macho sin defecto."
,"11":"Lo inmolará al lado norte del altar delante del Señor, y los hijos de Aarón, los sacerdotes, derramarán la sangre en torno del altar."
,"12":"Lo descuartizará, y el sacerdote dispondrá los trozos, con la cabeza y las grasas, sobre la leña colocada encima del fuego del altar."
,"13":"Lavará con agua las entrañas y las patas, y el sacerdote lo quemará todo sobre el altar: es un holocausto, una ofrenda quemada, un perfume agradable al Señor."
,"14":"Si su ofrenda al Señor es un holocausto de aves, ofrecerá tórtolas o pichones."
,"15":"El sacerdote presentará la víctima en el altar, le arrancará la cabeza, que quemará sobre el altar, y exprimirá su sangre sobre la pared del altar;"
,"16":"le quitará el papo y las plumas, y lo arrojará al lado este del altar, en el lugar de las cenizas."
,"17":"Partirá el animal en dos mitades, un ala por cada lado, sin separarlas totalmente, y el sacerdote lo quemará sobre la leña que arde encima del fuego que está sobre el altar: es un holocausto, una ofrenda quemada, un perfume agradable al Señor."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Cuando alguien quiera hacer una ofrenda al Señor, será de flor de harina, sobre la cual derramará aceite y pondrá incienso."
,"2":"La presentará a los hijos de Aarón, los sacerdotes; tomará un puñado de flor de harina con aceite y todo el incienso, y el sacerdote lo quemará sobre el altar como memorial. Es una ofrenda quemada, un perfume agradable al Señor."
,"3":"El resto de la ofrenda será para Aarón y sus hijos, como parte santa de la ofrenda quemada en honor del Señor."
,"4":"Cuando quieras hacer una ofrenda de pasta cocida en el horno, será de flor de harina en forma de hogazas, sin levadura, amasadas en aceite, u hojaldres sin levadura empapados en aceite."
,"5":"Si tu ofrenda está asada en la plancha, será de flor de harina amasada con aceite, sin levadura."
,"6":"La dividirás en trozos y derramarás aceite encima: es una ofrenda."
,"7":"Si tu ofrenda está frita en la sartén, será de flor de harina preparada con aceite."
,"8":"Llevarás la ofrenda preparada de esta manera al Señor: la presentarás al sacerdote, que la acercará al altar."
,"9":"El sacerdote separará de la ofrenda una parte como memorial y lo quemará sobre el altar. Es una ofrenda quemada, un perfume agradable al Señor."
,"10":"El resto de la ofrenda será para Aarón y sus hijos, como parte santa de la ofrenda quemada en honor del Señor."
,"11":"Ninguna ofrenda que hagáis al Señor deberá estar preparada con levadura, pues ni el fermento ni la miel pueden ser quemados en honor del Señor."
,"12":"Éstos pueden ser presentados al Señor como ofrenda de primicias, pero nunca podrán subir al altar como perfume agradable al Señor."
,"13":"Echarás sal en todas las oblaciones que ofrezcas; no dejarás nunca de echar en la ofrenda la sal de la alianza con tu Dios; todas tus ofrendas llevarán sal."
,"14":"Si haces al Señor una ofrenda de primicias, será de espigas tostadas al fuego o una pasta de granos triturados;"
,"15":"sobre ellas derramarás el aceite y pondrás el incienso: es una ofrenda."
,"16":"Como memorial, el sacerdote quemará una parte de los granos triturados, el aceite con todo el incienso. Es una ofrenda quemada en honor del Señor."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Cuando alguien quiera ofrecer un sacrificio de reconciliación, si se trata de ganado mayor, ofrecerá delante del Señor una res sin defecto, macho o hembra."
,"2":"Pondrá la mano sobre la cabeza de la víctima y la inmolará a la entrada de la tienda de la reunión. Los hijos de Aarón, los sacerdotes, derramarán la sangre en torno al altar."
,"3":"De este sacrificio de reconciliación ofrecerá al Señor, como ofrenda quemada, la grasa que recubre las entrañas y la que hay sobre ellas;"
,"4":"los dos riñones con la grasa que los envuelve, la grasa que envuelve los lomos y la sabanilla que habrá separado del hígado y los dos riñones."
,"5":"Los hijos de Aarón lo quemarán en el altar encima del holocausto colocado sobre la leña que arde sobre el fuego. Es una ofrenda quemada, un perfume agradable al Señor."
,"6":"Cuando su ofrenda al Señor sea un sacrificio de reconciliación, si se trata de ganado menor, ofrecerá una res sin defecto, macho o hembra."
,"7":"Si su ofrenda es un cordero, lo presentará delante del Señor,"
,"8":"pondrá la mano sobre la cabeza de la víctima, la inmolará delante de la tienda de la reunión y los hijos de Aarón derramarán la sangre en torno del altar."
,"9":"De este sacrificio de reconciliación ofrecerá al Señor, como ofrenda quemada, las grasas: la cola entera cortada desde la rabadilla, la grasa que recubre las entrañas y la que hay sobre ellas;"
,"10":"los dos riñones, con la grasa que los envuelve, y la que envuelve los lomos y la sabanilla que habrá separado del hígado y de los riñones."
,"11":"El sacerdote lo quemará sobre el altar. Es un alimento quemado en honor del Señor."
,"12":"Si su ofrenda es una cabra, la ofrecerá delante del Señor,"
,"13":"pondrá la mano sobre su cabeza, la inmolará delante de la tienda de la reunión y los hijos de Aarón derramarán la sangre en torno del altar."
,"14":"De ella presentará, para ofrenda quemada en honor del Señor, la grasa que recubre las entrañas y la que hay sobre ellas;"
,"15":"los dos riñones, con la grasa que los envuelve; la grasa que envuelve los lomos y la sabanilla que habrá separado del hígado y los riñones."
,"16":"El sacerdote lo quemará sobre el altar. Es un alimento quemado, un perfume agradable. Las grasas pertenecen en su totalidad al Señor."
,"17":"Ésta será ley perpetua para todas vuestras generaciones dondequiera que habitéis: nunca comeréis ni las grasas ni la sangre'."
}`)
	CurrentBook.AddChapter(4, `{
"1":"El Señor habló a Moisés:"
,"2":"'Di a los israelitas: Si alguien peca involuntariamente contra alguno de los mandamientos del Señor haciendo lo que está prohibido, se hará lo siguiente:"
,"3":"Si el que peca es el sacerdote consagrado por la unción, haciendo así culpable a todo el pueblo, ofrecerá al Señor por el pecado cometido un novillo sin defecto como sacrificio por el pecado."
,"4":"Llevará el novillo delante del Señor a la entrada de la tienda de la reunión, le pondrá la mano sobre la cabeza y lo inmolará delante del Señor."
,"5":"El sacerdote consagrado por la unción tomará parte de la sangre del novillo, la llevará a la tienda de la reunión,"
,"6":"mojará el dedo en la sangre y hará siete aspersiones hacia el velo del santuario delante del Señor;"
,"7":"pondrá parte de ella sobre los cuernos del altar de los perfumes, que está delante del Señor en la tienda de la reunión, y derramará toda la sangre restante del novillo al pie del altar de los holocaustos, que se encuentra a la entrada de la tienda de la reunión."
,"8":"Tomará todas las grasas del novillo del sacrificio, la grasa que recubre las entrañas y la que hay sobre ellas;"
,"9":"los riñones con la grasa que los envuelve, y la que envuelve los lomos y la sabanilla que habrá separado del hígado y los riñones,"
,"10":"de la misma manera que fue tomada en el novillo del sacrificio de reconciliación, y el sacerdote lo quemará sobre el altar de los holocaustos."
,"11":"La piel del novillo y toda su carne, la cabeza y las patas, las entrañas y los excrementos,"
,"12":"todo lo que queda del novillo, será llevado fuera del campamento a un lugar puro, donde se tiran las cenizas, y allí será quemado sobre la leña; será quemado en el lugar donde se tiran las cenizas."
,"13":"Si ha sido toda la comunidad de Israel la que ha pecado por inadvertencia y la que se ha hecho culpable traspasando, sin darse cuenta, algo de lo prohibido por la ley del Señor,"
,"14":"cuando sea descubierto el pecado cometido, la comunidad ofrecerá un novillo en sacrificio por el pecado, lo llevarán delante de la tienda de la reunión,"
,"15":"los ancianos de la comunidad pondrán sus manos sobre la cabeza del novillo delante del Señor, y el novillo será inmolado delante del Señor."
,"16":"El sacerdote consagrado por la unción llevará parte de la sangre del novillo a la tienda de la reunión,"
,"17":"mojará el dedo en la sangre y hará siete aspersiones hacia el velo del santuario delante del Señor;"
,"18":"pondrá parte de ella sobre los cuernos del altar que se encuentra delante del Señor en la tienda de la reunión, y derramará toda la sangre restante al pie del altar de los holocaustos, que está a la entrada de la tienda de la reunión."
,"19":"Tomará todas las grasas del novillo y las quemará sobre el altar;"
,"20":"hará con este novillo lo mismo que hizo con el ofrecido en sacrificio por el pecado; así hará con él. El sacerdote hará el rito de absolución sobre la comunidad, y a ésta le será perdonado el pecado."
,"21":"El novillo será llevado fuera del campo, y será quemado en la misma manera que lo había sido el anterior: tal es el sacrificio por el pecado de la comunidad."
,"22":"Si peca por inadvertencia un jefe y se hace culpable obrando contra alguna de las prohibiciones del Señor, su Dios,"
,"23":"cuando le hayan hecho caer en la cuenta del pecado cometido, presentará como ofrenda un macho cabrío sin defecto."
,"24":"Pondrá su mano sobre la cabeza del macho cabrío y lo inmolará en el lugar donde se inmolan los holocaustos delante del Señor. Es un sacrificio por el pecado."
,"25":"El sacerdote tomará con su dedo de la sangre de la víctima, untará con ella los cuernos del altar de los holocaustos y derramará toda la sangre restante al pie del mismo altar."
,"26":"Luego quemará todas las grasas sobre el altar, como había hecho con las grasas del sacrificio de reconciliación. El sacerdote hará el rito de absolución por el jefe, a quien se le perdonará el pecado."
,"27":"Si es un hombre del pueblo el que peca por inadvertencia y quien se hace culpable obrando contra alguna de las prohibiciones del Señor,"
,"28":"cuando haya caído en la cuenta del pecado cometido, presentará como ofrenda por su transgresión una cabra sin defecto."
,"29":"Pondrá su mano sobre la cabeza de la víctima y la inmolará en el lugar donde se inmolan los holocaustos."
,"30":"El sacerdote tomará con su dedo de la sangre, untará con ella los cuernos del altar de los holocaustos y derramará toda la sangre restante al pie del altar."
,"31":"Arrancará luego todas las grasas, como se arrancan en el sacrificio de reconciliación, y el sacerdote las quemará sobre el altar en perfume agradable al Señor. El sacerdote hará el rito de absolución sobre este hombre, que alcanzará el perdón por su pecado."
,"32":"Si quiere ofrecer un cordero como sacrificio por el pecado, presentará una hembra sin defecto."
,"33":"Pondrá su mano sobre la cabeza de la víctima y la inmolará en sacrificio por el pecado en el lugar donde se inmolan los holocaustos."
,"34":"El sacerdote tomará con el dedo de la sangre del sacrificio por el pecado, untará con ella los cuernos del altar de los holocaustos y derramará toda la sangre restante al pie del altar."
,"35":"Arrancará luego todas las grasas, como se arrancan en el cordero del sacrificio de reconciliación, y el sacerdote las quemará en el altar sobre las ofrendas quemadas en honor del Señor. El sacerdote hará el rito de absolución sobre este hombre, que alcanzará el perdón de su pecado."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Si alguno es citado a declarar como testigo sobre algo que ha visto u oído y se niega a declarar, peca y debe cargar con su culpa;"
,"2":"si alguno contrae impureza tocando, aun sin darse cuenta, cualquier cosa impura: el cadáver de una bestia impura, de un animal impuro o de un reptil impuro, será culpable;"
,"3":"si toca sin darse cuenta cualquier impureza humana cuyo contacto le hace impuro, al darse cuenta de ello será culpable;"
,"4":"si uno hace a la ligera un juramento de hacer algo bueno o malo -uno de esos juramentos que se hacen sin pensar-, al darse cuenta será culpable;"
,"5":"si de cualquiera de estas maneras se ha hecho culpable, confesará su culpa"
,"6":"y presentará al Señor, en calidad de reparación por el pecado cometido, una hembra de ganado menor, oveja o cabra, en sacrificio por el pecado. El sacerdote hará sobre él el rito de absolución y se verá libre de su pecado."
,"7":"Si no está en su mano ofrecer ganado menor, presentará al Señor, como reparación por el pecado cometido, dos tórtolas o dos pichones, uno como sacrificio por el pecado y otro en holocausto."
,"8":"Los presentará al sacerdote, que ofrecerá primero el del sacrificio por el pecado; desgarrará la cabeza de la víctima junto a la nuca, sin separarla totalmente;"
,"9":"con parte de su sangre rociará la pared del altar, y el resto lo exprimirá al pie de éste: es un sacrificio por el pecado."
,"10":"En cuanto al segundo, lo ofrecerá en holocausto según el ritual. El sacerdote hará sobre el interesado el rito de expiación por el pecado cometido, y éste le será perdonado."
,"11":"Si sus posibilidades no llegan tampoco al par de tórtolas o de pichones, presentará como ofrenda por su pecado cuatro kilos y medio de flor de harina sin mezclar aceite ni poner incienso, pues es un sacrificio por el pecado."
,"12":"Lo presentará al sacerdote, que tomará un puñado como memorial y lo quemará en el altar sobre las ofrendas quemadas en honor del Señor. Es un sacrificio por el pecado."
,"13":"El sacerdote hará sobre él el rito de absolución por el pecado cometido en una de las materias dichas, y éste le será perdonado. El sacerdote tendrá en este caso los mismos derechos que en el caso de las ofrendas'."
,"14":"El Señor dijo a Moisés:"
,"15":"'Si un individuo comete un sacrificio pecando por inadvertencia contra los derechos sagrados del Señor, presentará al Señor, como sacrificio de reparación, un carnero del ganado sin defecto, valorado y calculado en plata, según la tasa oficial del templo."
,"16":"Debe restituir lo defraudado más un veinte por ciento, que entregará al sacerdote. El sacerdote hará sobre él el rito de absolución con el carnero de la reparación por el pecado, y se le perdonará."
,"17":"Si uno falta haciendo por inadvertencia lo prohibido por la ley del Señor, se hace culpable; su culpa pesa sobre él,"
,"18":"y deberá presentar al sacerdote como sacrificio de reparación un carnero del ganado sin defecto, según tu estimación. El sacerdote hará sobre él el rito de absolución por la culpa cometida sin darse cuenta, y ésta se le perdonará:"
,"19":"es un sacrificio de reparación, porque este hombre era realmente culpable delante del Señor'."
,"20":"El Señor dijo a Moisés:"
,"21":"'Si uno peca o comete un sacrilegio contra el Señor negando a su prójimo un depósito, o una prenda, o una cosa robada, o le defrauda,"
,"22":"o encuentra cosas perdidas y las niega, o si jura en falso en alguna de aquellas cosas en que suele pecar el hombre;"
,"23":"en una palabra, si peca y se hace culpable, restituirá cuanto haya robado o defraudado, el depósito que le ha sido confiado, las cosas que ha encontrado"
,"24":"y lo que haya obtenido por el juramento falso; lo restituirá íntegramente a su propietario el día de la reparación más un veinte por ciento."
,"25":"Como sacrificio de reparación ofrecerá al Señor un carnero del ganado sin defecto, según tu estimación, y lo presentará al sacerdote para el sacrificio de reparación."
,"26":"El sacerdote hará sobre él el rito de absolución delante del Señor, y le será perdonada cualquier culpabilidad que haya contraído'."
}`)
	CurrentBook.AddChapter(6, `{
"1":"El Señor dijo a Moisés:"
,"2":"'Da estas prescripciones a Aarón y a sus hijos: Éste será el ritual del holocausto: el holocausto arderá sobre el brasero del altar toda la noche hasta la mañana, para que el fuego lo consuma: "
,"3":"el sacerdote, revestido de la túnica y los calzones de lino, quitará la ceniza del fuego que ha consumido el holocausto sobre el altar y la pondrá a un lado del altar."
,"4":"Se cambiará luego las vestiduras y llevará la ceniza fuera del campamento a un lugar puro."
,"5":"El fuego permanecerá siempre encendido sobre el altar, sin apagarse nunca. El sacerdote añadirá cada mañana nueva leña, pondrá encima el holocausto y quemará las grasas de los sacrificios de reconciliación."
,"6":"El fuego debe permanecer siempre encendido sobre el altar, sin apagarse nunca'."
,"7":"'Éste será el ritual de la ofrenda: los hijos de Aarón la presentarán al Señor delante del altar."
,"8":"Uno de ellos tomará un puñado de flor de harina, con el aceite correspondiente y con todo el incienso, y lo quemará sobre el altar: memorial y perfume agradable al Señor."
,"9":"Aarón y sus hijos comerán lo restante en forma de panes sin levadura en lugar sagrado dentro del atrio de la tienda de la reunión."
,"10":"No será cocido con levadura. Se lo doy a ellos como parte de las ofrendas quemadas en mi honor: es una porción sacrosanta, como parte que queda del sacrificio por el pecado y del sacrificio de reparación."
,"11":"Todos los varones entre los hijos de Aarón lo podrán comer: es ley perpetua para vuestras generaciones. Todo el que lo toque quedará consagrado'."
,"12":"El Señor dijo a Moisés:"
,"13":"'Ésta será la ofrenda que Aarón y sus hijos harán al Señor el día de su consagración: cuatro kilos y medio de flor de harina como ofrenda perpetua, mitad por la mañana y mitad por la tarde."
,"14":"Será preparada a la plancha y mezclada con aceite; la presentarás en trozos como ofrenda de perfume agradable al Señor."
,"15":"Esta ofrenda será presentada por el sacerdote que sea consagrado entre los descendientes de Aarón. Es derecho perpetuo del Señor; será totalmente quemada."
,"16":"Toda ofrenda de sacerdote será totalmente quemada; no se comerá nada'."
,"17":"El Señor habló a Moisés:"
,"18":"'Di a Aarón y a sus hijos: Éste será el ritual del sacrificio por el pecado: la víctima será inmolada delante del Señor en el lugar donde se inmolan los holocaustos: es una cosa santísima."
,"19":"La comerá el sacerdote que la ha sacrificado; la comerá en lugar sagrado dentro del atrio de la tienda de la reunión."
,"20":"Todo cuanto toque la carne quedará consagrado. Si la sangre salpicare alguna vestidura, ésta será lavada en lugar sagrado."
,"21":"Si la vasija donde ha sido cocida es de barro, se romperá; y si es de bronce, será fregada y lavada con agua."
,"22":"Sólo podrán comerla los sacerdotes: es cosa santísima."
,"23":"No se podrá comer ninguna víctima de un sacrificio por el pecado, cuya sangre haya entrado en la tienda de la reunión para hacer el rito de absolución en el santuario: será quemada en el fuego'."
}`)
	CurrentBook.AddChapter(7, `{
"1":"'Éste será el ritual del sacrificio de reparación. Es cosa santísima."
,"2":"La víctima será inmolada en el lugar donde se inmolan los holocaustos, y la sangre será derramada en torno del altar."
,"3":"Serán ofrecidas todas sus grasas: la cola, la grasa que recubre las entrañas,"
,"4":"los dos riñones, con la grasa que los envuelve y la que envuelve los lomos y la sabanilla que habrá separado del hígado y de los riñones."
,"5":"El sacerdote lo quemará sobre el altar: es una ofrenda quemada en honor del Señor. Es un sacrificio de reparación."
,"6":"Todos los sacerdotes podrán comer de él, pero en lugar sagrado, pues es cosa santísima'."
,"7":"'En el sacrificio por el pecado y en el de reparación, la ley es la misma: la víctima será del sacerdote que haya hecho el rito de absolución."
,"8":"La piel de la víctima presentada por un hombre para ser ofrecida en holocausto será del sacerdote que la ofrezca."
,"9":"Toda ofrenda preparada al horno, a la plancha o en la sartén, será también del sacerdote que la ofrezca."
,"10":"Pero toda ofrenda, amasada en aceite o seca, será por igual para todos los hijos de Aarón'."
,"11":"'Éste será el ritual del sacrificio de reconciliación que se ofrecerá al Señor:"
,"12":"si el sacrificio es de acción de gracias, se ofrecerán también hogazas sin levadura, amasadas con aceite, hojaldres sin levadura empapados en aceite, y flor de harina mezclada en forma de tortas amasadas en aceite."
,"13":"Añadirá esta ofrenda a las hogazas de pan fermentado y al sacrificio de reconciliación ofrecido en acción de gracias."
,"14":"De cada ofrenda se reservará una porción como tributo al Señor, la cual será para el sacerdote que haya derramado la sangre del sacrificio de reconciliación."
,"15":"La carne del sacrificio de reconciliación ofrecido en acción de gracias deberá comerse el día mismo en que se ofrece, sin dejar nada para el día siguiente'."
,"16":"'Si la víctima es ofrecida en cumplimiento de un voto o como ofrenda voluntaria, se comerá también el mismo día; pero las sobras podrán comerse al día siguiente."
,"17":"Si queda algo para el día tercero, será quemado en el fuego."
,"18":"Si se come al tercer día la carne del sacrificio de reconciliación, el oferente no será grato; su ofrenda no será tenida en cuenta, y el que haya comido de ella llevará el peso de su falta."
,"19":"La carne que haya tocado algo impuro, cualquier cosa que sea, no se podrá comer; deberá ser quemada. Cualquiera que esté puro podrá comer la carne;"
,"20":"pero si alguno en estado de impureza come la carne del sacrificio de reconciliación ofrecido al Señor, será extirpado de su pueblo."
,"21":"El que después de haber tocado una impureza de hombre o animal o cualquier otra cosa impura coma de la carne del sacrificio de reconciliación ofrecido al Señor, será extirpado de su pueblo'."
,"22":"El Señor habló a Moisés:"
,"23":"'Di a los israelitas: No comeréis grasa alguna, ni de buey ni de oveja ni de cabra."
,"24":"Las grasas de un animal muerto o destrozado podréis emplearlas para cualquier uso, pero nunca comerlas."
,"25":"El que coma las grasas de los animales que se presentan al Señor como ofrendas quemadas, será extirpado de su pueblo."
,"26":"Dondequiera que habitéis, no comeréis sangre alguna, ni de ave ni de bestia."
,"27":"El que coma cualquier clase de sangre será extirpado de su pueblo'."
,"28":"El Señor habló a Moisés:"
,"29":"'Di a los israelitas: El que ofrezca al Señor un sacrificio de reconciliación, presentará al Señor como ofrenda una parte de su sacrificio."
,"30":"Presentará con sus propias manos la ofrenda que ha de ser quemada, a saber, las grasas y el pecho, para ofrecerlo con el rito de presentación delante del Señor."
,"31":"El sacerdote quemará las grasas sobre el altar, y el pecho será para Aarón y sus hijos."
,"32":"Daréis al sacerdote la pierna derecha, como tributo sobre vuestros sacrificios de reconciliación,"
,"33":"la cual pertenecerá al hijo de Aarón que haya ofrecido las grasas y la sangre del sacrificio de reconciliación,"
,"34":"puesto que el pecho de la presentación y la pierna reservada, que yo retengo para mí en los sacrificios de reconciliación de los hijos de Israel, se lo doy al sacerdote Aarón y a sus hijos: es ley perpetua para todas las generaciones'."
,"35":"Ésa es la parte de Aarón y la de sus hijos sobre las ofrendas quemadas en honor del Señor, a partir del día en que el Señor los consagró como sacerdotes suyos."
,"36":"Esto es lo que el Señor exigió de los israelitas en favor de los sacerdotes desde el día de su consagración: es ley perpetua para todas las generaciones."
,"37":"Éste es el ritual del holocausto, de la ofrenda, del sacrificio por el pecado, del sacrificio de reparación, de la consagración y del sacrificio de reconciliación."
,"38":"Así se lo prescribió el Señor a Moisés en el monte Sinaí el día que ordenó a los israelitas en el desierto del Sinaí presentar sus ofrendas al Señor."
}`)
	CurrentBook.AddChapter(8, `{
"1":"El Señor dijo a Moisés:"
,"2":"'Toma a Aarón, con sus hijos, las vestiduras, el óleo de la unción, el novillo para el sacrificio por el pecado, los dos carneros y la cesta de panes sin levadura,"
,"3":"y convoca a toda la comunidad a la entrada de la tienda de la reunión'."
,"4":"Moisés hizo según le había ordenado el Señor y, reunida toda la comunidad a la entrada de la tienda de la reunión,"
,"5":"les dijo: 'Esto es lo que el Señor manda hacer'."
,"6":"Hizo que se acercaran Aarón y sus hijos, y los lavó con agua."
,"7":"Vistió a Aarón la túnica, le ciñó el cinturón, le puso el manto y encima le colocó el efod y se lo ajustó atándolo con la cinta del efod."
,"8":"Le puso el pectoral con los urim y los tummim,"
,"9":"colocó sobre su cabeza el turbante y sobre éste, en la parte anterior, la lámina de oro, la diadema sagrada, como el Señor había ordenado a Moisés."
,"10":"Moisés tomó el óleo de la unción y ungió y consagró la morada y todo lo que había en ella."
,"11":"Hizo luego siete aspersiones sobre el altar, lo ungió y lo consagró con todos sus utensilios, la pila y su base."
,"12":"Derramó el óleo de la unción sobre la cabeza de Aarón, lo ungió y lo consagró."
,"13":"Hizo que se acercaran los hijos de Aarón, les vistió las túnicas, les ciñó los cinturones y les puso los turbantes, como el Señor había ordenado a Moisés."
,"14":"Hizo que llevaran el novillo para el sacrificio por el pecado, y Aarón y sus hijos pusieron las manos sobre su cabeza."
,"15":"Moisés lo inmoló y, mojando sus dedos en la sangre, untó con ella los cuernos del altar todo alrededor y lo purificó. Luego derramó la sangre al pie del altar y lo consagró haciendo sobre él el rito de absolución."
,"16":"Tomó todas las grasas que envuelven las entrañas, la sabanilla que recubre el hígado y los dos riñones con sus grasas, y los quemó sobre el altar."
,"17":"Lo que quedaba del novillo: la piel, la carne y los excrementos, lo quemó fuera del campamento, como el Señor había ordenado a Moisés."
,"18":"Hizo que trajeran el carnero del holocausto, y Aarón y sus hijos pusieron las manos sobre su cabeza."
,"19":"Moisés lo inmoló y derramó su sangre en torno al altar."
,"20":"Lo descuartizó y quemó la cabeza, los trozos y las grasas."
,"21":"Lavó con agua las entrañas y las patas, y quemó todo el carnero sobre el altar. Era un holocausto, un perfume agradable, una ofrenda quemada en honor del Señor, como el Señor había ordenado a Moisés."
,"22":"Hizo que trajeran el segundo carnero, el de la consagración, y Aarón y sus hijos le pusieron las manos sobre la cabeza."
,"23":"Moisés lo inmoló y, tomando parte de su sangre, ungió con ella el lóbulo de la oreja derecha de Aarón, el dedo pulgar de su mano derecha y el dedo gordo de su pie derecho."
,"24":"Hizo acercarse a los hijos de Aarón, y ungió con la sangre el lóbulo de su oreja derecha, el pulgar de su mano derecha y el dedo gordo de su pie derecho. La sangre restante la derramó en torno del altar."
,"25":"Tomó las grasas, la cola, todas las grasas que envuelven las entrañas, la sabanilla que recubre el hígado, los dos riñones, juntamente con sus grasas, y la pierna derecha;"
,"26":"de la cesta de los panes sin levadura, que estaba delante del Señor, tomó una torta sin levadura, una torta amasada con aceite, y un hojaldre, y los puso sobre las grasas y la pierna derecha."
,"27":"Lo puso todo ello en las manos de Aarón y en las de sus hijos e hizo el rito de presentación delante del Señor."
,"28":"Lo tomó de nuevo Moisés en sus manos, y lo quemó en el altar sobre el holocausto: era el sacrificio de consagración, perfume agradable, ofrenda quemada en honor del Señor."
,"29":"Tomó después el pecho del carnero e hizo el rito de presentación delante del Señor: ésta era la parte del carnero de consagración que pertenecía a Moisés, como el Señor le había ordenado."
,"30":"Finalmente, Moisés tomó el óleo de la unción y sangre de la que había sobre el altar, y roció a Aarón y sus vestiduras, a los hijos de Aarón y sus vestiduras, y así los consagró."
,"31":"Moisés dijo a Aarón y a sus hijos: 'Coced la carne a la puerta de la tienda de la reunión y comedla allí con el pan que hay en la cesta de la consagración, como yo he ordenado, diciendo: Aarón y sus hijos lo comerán."
,"32":"Las sobras de la carne y del pan las quemaréis."
,"33":"Durante siete días no saldréis de la entrada de la tienda de la reunión hasta que se cumplan los días de vuestra consagración, que son siete."
,"34":"El Señor ha ordenado que, al hacer sobre vosotros el rito de absolución, hagáis lo que se ha hecho hoy."
,"35":"Permaneceréis siete días y siete noches a la entrada de la tienda de la reunión. Cumplid la orden del Señor, y no moriréis. Ésta es la orden que yo he recibido'."
,"36":"Aarón y sus hijos cumplieron todo lo que el Señor había ordenado a Moisés."
}`)
	CurrentBook.AddChapter(9, `{
"1":"El día octavo Moisés llamó a Aarón, y a sus hijos y a los ancianos de Israel,"
,"2":"y dijo a Aarón: 'Toma un becerro para el sacrificio por el pecado y un carnero para el holocausto, los dos sin defecto, y preséntalos delante del Señor."
,"3":"Y dirás a los israelitas: Tomad un macho cabrío para el sacrificio por el pecado, un becerro y un cordero primales y sin defecto para el holocausto;"
,"4":"y un toro y un carnero para el sacrificio de reconciliación, para inmolarlos delante del Señor, y una ofrenda amasada con aceite, porque el Señor se os va a aparecer hoy'."
,"5":"Llevaron ante la tienda de la reunión todo lo que Moisés había mandado, y toda la comunidad se acercó y estuvo delante del Señor."
,"6":"Moisés dijo: 'Esto es lo que el Señor ha mandado para que se os aparezca su gloria'."
,"7":"Moisés dijo a Aarón: 'Acércate al altar, ofrece tu sacrificio por el pecado y tu holocausto para hacer el rito de absolución por ti y por tus familias; presenta la ofrenda del pueblo para hacer sobre ellos el rito de absolución, como lo ha ordenado el Señor'."
,"8":"Aarón se acercó al altar e inmoló el becerro en sacrificio por su propio pecado."
,"9":"Sus hijos le presentaron la sangre, y él, mojando su dedo, untó con ella los cuernos del altar, derramando la restante al pie del mismo."
,"10":"Quemó luego sobre el altar las grasas de la víctima, los riñones y la sabanilla del hígado, como el Señor había ordenado a Moisés;"
,"11":"la carne y la piel las quemó fuera del campamento."
,"12":"Aarón inmoló a continuación el holocausto, sus hijos le presentaron la sangre y él la derramó en torno del altar."
,"13":"Le acercaron, descuartizada, la víctima del holocausto, con la cabeza, y él lo quemó sobre el altar."
,"14":"Lavó las entrañas y las patas, y las puso a arder en el altar sobre el holocausto."
,"15":"Presentó luego la ofrenda del pueblo: tomó el macho cabrío del sacrificio por el pecado del pueblo y lo inmoló en sacrificio por el pecado, como había hecho con el becerro."
,"16":"Después ofreció el holocausto, según la orden establecida."
,"17":"Presentó también la ofrenda, de la que tomó un puñado y lo quemó sobre el altar, además del holocausto de la mañana."
,"18":"Finalmente, inmoló el toro y el carnero ofrecidos por el pueblo en sacrificio de reconciliación; sus hijos le presentaron la sangre, y él la derramó en torno del altar."
,"19":"Las grasas del toro y del carnero, la cola, la grasa que cubre las entrañas, los riñones y la sabanilla del hígado,"
,"20":"todo ello lo puso junto a la grasa de los pechos y lo quemó sobre el altar."
,"21":"Aarón ofreció los pechos y la pierna derecha con el rito de presentación delante del Señor, como Moisés le había ordenado."
,"22":"Aarón levantó las manos y bendijo al pueblo; después de haber ofrecido el sacrificio por el pecado, el holocausto y el sacrificio de reconciliación, bajó."
,"23":"Moisés y Aarón entraron en la tienda de la reunión; después salieron y bendijeron al pueblo. La gloria del Señor se apareció a todo el pueblo:"
,"24":"una llama que salía de la presencia del Señor consumió el holocausto y las grasas sobre el altar. Ante esta visión, todo el pueblo lanzó gritos de alegría y cayeron rostro en tierra."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Los hijos de Aarón, Nadab y Abihú, tomaron cada uno su incensario, pusieron fuego en él, echaron encima el incienso y ofrecieron ante el Señor un fuego profano que él no les había ordenado."
,"2":"Salió entonces de la presencia del Señor un fuego que los abrasó. Así murieron en presencia del Señor."
,"3":"Moisés dijo a Aarón: 'Esto era lo que había declarado el Señor cuando dijo: A los que se acercan a mí mostraré mi santidad, y al pueblo entero mostraré mi gloria'. Aarón se calló."
,"4":"Moisés llamó a Misael y Elsafán, hijos de Uziel, tío de Aarón, y les dijo: 'Venid y llevad a vuestros hermanos lejos del santuario, fuera del campamento'."
,"5":"Se acercaron, y los llevaron con sus túnicas fuera del campamento, como había dicho Moisés."
,"6":"Moisés dijo a Aarón, a Eleazar e Itamar, hijos de Aarón: 'No os despelucéis ni rasguéis vuestras vestiduras; así no moriréis ni se encenderá la ira divina contra toda la comunidad; vuestros hermanos, toda la casa de Israel, son los que deben llorar a los que el Señor ha destruido por el fuego."
,"7":"No salgáis de la entrada de la tienda de la reunión, no sea que muráis, pues lleváis sobre vosotros el óleo de la unción del Señor'. Ellos hicieron lo que Moisés había dicho."
,"8":"El Señor dijo a Aarón:"
,"9":"'Cuando tengáis que entrar en la tienda de la reunión, no beberéis vino o bebida embriagante ni tú ni tus hijos, y no moriréis. Es ley perpetua para vuestras generaciones,"
,"10":"a fin de que sepáis distinguir entre lo sagrado y lo profano, lo puro y lo impuro,"
,"11":"y podáis enseñar a los israelitas todos los preceptos que el Señor les ha dado por medio de Moisés'."
,"12":"Moisés dijo a Aarón y a sus hijos supervivientes, Eleazar e Itamar: 'Tomad las sobras de la ofrenda quemada en honor del Señor y comedlas sin levadura junto al altar, pues es cosa santísima."
,"13":"Las comeréis en lugar sagrado, porque es porción reservada para ti y tus hijos de las ofrendas quemadas en honor del Señor. Ésta es la orden que yo he recibido."
,"14":"Tú, tus hijos y tus hijas comeréis en lugar santo el pecho del rito de presentación y la pierna del tributo, porque ésa es la parte que os pertenece de los sacrificios de reconciliación de los israelitas."
,"15":"La pierna del tributo y el pecho del rito de presentación serán llevados junto con las grasas que han de ser quemadas, para hacer con ello el gesto de presentación delante del Señor, y luego serán para ti y tus hijos por derecho perpetuo, como lo ha ordenado el Señor'."
,"16":"Moisés buscó y rebuscó entonces el macho cabrío del sacrificio por el pecado, y resultó que había sido quemado. Se indignó con Eleazar e Itamar, hijos de Aarón, y les dijo:"
,"17":"'¿Por qué no habéis comido en lugar santo la víctima del sacrificio por el pecado? Es cosa santísima, que se os ha dado para borrar las culpas de la comunidad, haciendo sobre ella el rito de absolución en presencia del Señor."
,"18":"Puesto que su sangre no fue introducida dentro del santuario, debíais haber comido la carne en ese lugar santo, como yo había ordenado'."
,"19":"Aarón dijo a Moisés: 'Mira, ellos han ofrecido hoy el sacrificio por el pecado y el holocausto ante el Señor, y luego me sucedió lo que tú sabes. Si yo hubiera comido hoy de la víctima por el pecado, ¿hubiera agradado al Señor?'."
,"20":"Moisés quedó satisfecho con la respuesta."
}`)
	CurrentBook.AddChapter(11, `{
"1":"El Señor dijo a Moisés y a Aarón:"
,"2":"'Decid a los israelitas: Éstos son los animales comestibles: animales terrestres:"
,"3":"los rumiantes de pezuña partida."
,"4":"Tendréis por impuros y no comeréis los siguientes: el camello, rumiante, pero no de pezuña partida;"
,"5":"el conejo, rumiante, pero no de pezuña partida;"
,"6":"la liebre, rumiante, pero no es de pezuña partida;"
,"7":"el cerdo, de pezuña partida, pero no rumiante."
,"8":"No comeréis sus carnes ni tocaréis sus cadáveres; los tendréis por impuros."
,"9":"Animales acuáticos: podréis comer todos los que tienen aletas o escamas, sean de mar o de río."
,"10":"Todos los animales acuáticos, de mar o de río, serán impuros para vosotros si no tienen aletas o escamas."
,"11":"Los consideraréis impuros, no comeréis su carne y tendréis por inmundos sus cadáveres."
,"12":"Tendréis por impuro todo animal acuático que no tenga aletas o escamas."
,"13":"Entre las aves tendréis por inmundas, y no las comeréis, las siguientes: el águila, el quebrantahuesos, el águila marina,"
,"14":"el milano, todas las especies del buitre"
,"15":"y del cuervo,"
,"16":"el avestruz, la lechuza, la gaviota, todas las especies del gavilán,"
,"17":"el búho, el mergo, el ibis,"
,"18":"el cisne, el pelícano, el calamón,"
,"19":"la garza, todas las especies de cigüeña, la abubilla y el murciélago."
,"20":"Todo insecto alado que anda sobre cuatro patas lo tendréis por impuro."
,"21":"Entre éstos, podréis comer solamente aquellos cuyas patas les permitan saltar sobre la tierra."
,"22":"Son éstos: todas las especies de langostas, saltamontes, caballetas y grillos."
,"23":"Los demás insectos alados y de cuatro patas los tendréis por impuros."
,"24":"El solo contacto con los animales impuros os contaminará; el que toque sus cadáveres quedará impuro hasta la tarde;"
,"25":"el que los transporte deberá lavar sus vestiduras y quedará impuro hasta la tarde."
,"26":"Todo animal que no sea rumiante ni de pezuña partida será impuro para vosotros; el que lo toque quedará impuro."
,"27":"Todo cuadrúpedo que ande sobre la planta de los pies será impuro para vosotros; el que toque su cadáver quedará impuro hasta la tarde,"
,"28":"y el que lo transporte deberá lavar sus vestiduras y quedará impuro hasta la tarde. Tendréis por impuros estos animales."
,"29":"Entre los reptiles tendréis por impuros los siguientes: la comadreja, el ratón y la tortuga en todas sus especies;"
,"30":"el musgaño, el camaleón, la salamandra, el lagarto y el topo."
,"31":"Éstos son los reptiles que tendréis por impuros: el que toque sus cadáveres queda impuro hasta la tarde."
,"32":"También quedará impura cualquier cosa sobre la que caiga el cadáver de estos animales, ya sea un objeto de madera, un vestido, una piel o un saco, es decir, una cosa que sirva para algo: deberá ser lavado con agua y quedará impuro hasta la tarde; entonces será puro."
,"33":"Si alguno de estos animales cae muerto dentro de una vasija de barro, lo que hay en ella quedará impuro y la vasija deberá romperse."
,"34":"Cualquier alimento preparado con el agua que había dentro quedará impuro; igualmente toda bebida tomada en tales recipientes quedará impura."
,"35":"Cualquier objeto sobre el que caigan los cadáveres de estos animales quedará impuro; horno y hornillo serán destruidos, porque son impuros, y como tales deben ser tratados."
,"36":"Sin embargo, las fuentes, las cisternas y los embalses de agua permanecerán puros; pero el que toque el cuerpo muerto será impuro."
,"37":"Si uno de estos cadáveres cae sobre semilla destinada a la siembra, la semilla seguirá siendo pura;"
,"38":"pero cuando la semilla ha sido humedecida con agua, si cae encima uno de estos cadáveres será impura."
,"39":"Si se muere uno de los animales que os sirven de alimento, quien toque el cadáver quedará impuro hasta la tarde;"
,"40":"quien coma la carne, lavará sus vestidos y quedará impuro hasta la tarde."
,"41":"Todos los reptiles son repugnantes, y no los comeréis."
,"42":"No comeréis ningún reptil; ni los que se arrastren sobre su vientre, ni los que caminen sobre sus cuatro o más patas, pues son cosa repugnante."
,"43":"No os hagáis repugnantes vosotros a causa de estos reptiles ni os contaminéis con ellos, pues seríais igualmente impuros."
,"44":"Yo soy el Señor, vuestro Dios; vosotros debéis santificaros y ser santos, porque yo soy santo; no os contaminéis con esos bichos que se arrastran por el suelo."
,"45":"Yo soy el Señor, que os he sacado de Egipto para ser vuestro Dios; vosotros seréis santos, porque yo soy santo."
,"46":"Ésta es la ley sobre los animales terrestres, las aves, los animales acuáticos y los reptiles,"
,"47":"para que sepáis distinguir entre puro e impuro, entre los animales comestibles y los no comestibles'."
}`)
	CurrentBook.AddChapter(12, `{
"1":"El Señor habló a Moisés:"
,"2":"'Di a los israelitas: Cuando una mujer encinta dé a luz un varón, será impura durante siete días, impura como en el tiempo de su menstruación."
,"3":"A los ocho días el niño será circuncidado,"
,"4":"pero la madre continuará retirada durante treinta y tres días más purificando su sangre; no tocará nada consagrado, ni irá al santuario hasta que se haya cumplido el tiempo de su purificación."
,"5":"Si da a luz una hembra, será impura durante dos semanas, como en su menstruación, y permanecerá retirada sesenta y seis días más purificando la sangre."
,"6":"Cumplidos los días de su purificación, ya sea de varón o de hembra, presentará ante el sacerdote, a la entrada de la tienda de la reunión, un cordero primal como holocausto y un pichón o una tórtola en sacrificio por el pecado."
,"7":"El sacerdote los ofrecerá ante el Señor, hará sobre ella el rito de absolución y quedará purificada de su flujo de sangre. Ésta es la ley para la mujer que da a luz un niño o una niña."
,"8":"Si sus posibilidades no llegan a un cordero, presentará dos tórtolas o dos pichones, uno como holocausto y otro en sacrificio por el pecado. El sacerdote hará sobre ella el rito de absolución y quedará purificada'."
}`)
	CurrentBook.AddChapter(13, `{
"1":"El Señor dijo a Moisés y a Aarón:"
,"2":"'Cuando alguno tenga sobre la piel una inflamación, una pústula o una mancha reluciente, síntoma de lepra, será llevado al sacerdote Aarón o a uno de sus hijos sacerdotes."
,"3":"El sacerdote examinará la llaga de la piel: si los pelos de la parte afectada se han vuelto blancos y la llaga es más profunda que el resto de la piel, es llaga de lepra. Una vez examinado, el sacerdote lo declarará impuro."
,"4":"Si la mancha reluciente es blanca, pero no está más profunda que el resto de la piel ni el pelo se ha vuelto blanco, el sacerdote aislará al enfermo durante siete días."
,"5":"El séptimo día lo examinará: si constata que la llaga sigue en su estado sin extenderse en la piel, lo tendrá aislado siete días más."
,"6":"Al séptimo día lo volverá a examinar; si ve que la llaga ha perdido brillo y no se ha extendido por la piel, el sacerdote lo declarará puro: se trata de una pústula. Lavará sus vestidos y quedará puro."
,"7":"Si, después de haber sido examinado y declarado puro, la pústula se extiende sobre la piel del enfermo, se presentará de nuevo al sacerdote;"
,"8":"lo examinará, y, una vez que haya constatado el crecimiento de la pústula, lo declarará impuro, pues se trata de lepra."
,"9":"Si uno tiene llagas de lepra, será llevado al sacerdote."
,"10":"El sacerdote lo examinará: si hay una inflamación blanca, el pelo se ha vuelto blanco y se ve la carne viva en la inflamación,"
,"11":"se trata de lepra crónica en la piel. El sacerdote lo declarará impuro sin necesidad de aislarlo, porque sin duda alguna es impuro."
,"12":"Si la lepra se propaga por la piel y la recubre entera, de la cabeza a los pies, todo cuanto aparece a la vista del sacerdote,"
,"13":"éste examinará al enfermo, y si ve que la lepra cubre todo su cuerpo, lo declarará puro, pues, una vez que se ha vuelto todo blanco, es puro."
,"14":"Pero tan pronto como aparezca sobre él una llaga, será impuro."
,"15":"El sacerdote examinará la llaga y lo declarará impuro, pues la llaga es cosa impura: es lepra."
,"16":"Pero si la llaga cambia de nuevo y se pone blanca, se presentará al sacerdote."
,"17":"Éste lo examinará y, si se ha vuelto blanca, lo declarará puro, porque lo es'."
,"18":"'Si uno ha tenido sobre su piel una úlcera y ésta ha cicatrizado,"
,"19":"pero queda una inflamación blanquecina o una mancha de un blanco rosáceo, deberá presentarse al sacerdote."
,"20":"El sacerdote lo examinará: si la mancha está más hundida que la piel y el pelo se ha vuelto blanco, lo declarará impuro: es lepra que brota en la úlcera cicatrizada."
,"21":"Si la parte afectada no tiene el pelo blanco, ni la piel hundida y la mancha ha ido desapareciendo, aislará durante siete días al enfermo."
,"22":"Si la mancha sigue extendiéndose por la piel, lo declarará impuro: es lepra."
,"23":"Pero si la mancha sigue en el mismo sitio sin extenderse, es la cicatriz de la úlcera; el sacerdote lo declarará puro'."
,"24":"'Si uno ha sufrido una quemadura en su piel, y en la cicatriz de la quemadura hay una mancha de un blanco rosáceo o sólo blanca,"
,"25":"el sacerdote la examinará; si ve el pelo blanco y la piel hundida, es lepra que brota en la quemadura. El sacerdote lo declarará impuro, pues es lepra."
,"26":"Si el sacerdote no ve el pelo blanco ni la piel hundida, lo aislará durante siete días,"
,"27":"y al séptimo día lo examinará; si la mancha se ha extendido por la piel, lo declarará impuro, pues es lepra."
,"28":"Pero si la mancha sigue en el mismo sitio sin extenderse y ha perdido su color, es simplemente la inflamación de la quemadura. El sacerdote lo declarará puro, porque se trata de la cicatriz de la quemadura'."
,"29":"'Si un hombre o una mujer tienen una llaga en la cabeza o en la barba,"
,"30":"el sacerdote examinará la llaga; si la llaga está más hundida que la piel y el pelo se ha vuelto amarillento y ralo, declarará impuro al enfermo: es tiña, la lepra de la cabeza y de la barba."
,"31":"Si en el reconocimiento de la llaga tiñosa el sacerdote no ve la piel hundida ni el pelo amarillento, aislará al enfermo durante siete días,"
,"32":"y al séptimo día examinará la llaga; si la tiña no se ha extendido, el pelo no se ha vuelto amarillento y la piel no se ha hundido,"
,"33":"el enfermo se rasurará, excepción hecha de las partes afectadas por la tiña, y el sacerdote lo aislará durante otros siete días,"
,"34":"al cabo de los cuales volverá a examinar la tiña; si no se ha extendido por la piel ni se ha hundido en ella, declarará puro al enfermo."
,"35":"Si, después de haber sido declarado puro, la tiña se extiende por la piel,"
,"36":"el sacerdote lo examinará; si la tiña se ha extendido por la piel, no tiene ya necesidad de examinar si el pelo se ha vuelto amarillento: el enfermo es impuro."
,"37":"Pero si la tiña se ha detenido y aparece pelo negro, la tiña está curada; es puro, y así lo declarará el sacerdote."
,"38":"Si un hombre o una mujer tienen en la piel manchas relucientes y blancas,"
,"39":"el sacerdote las examinará; si las manchas que hay sobre la piel son de un color blancuzco, se trata de eczema que ha brotado en la piel; el enfermo es puro'."
,"40":"'Si a uno se le cae el pelo de la cabeza, se trata simplemente de calvicie, y es puro."
,"41":"Si se le cae el pelo de las sienes y toda la frente se le queda calva, es puro."
,"42":"Pero si en la parte calva de la cabeza aparece una llaga de un blanco rosáceo, es lepra que brota de la calvicie."
,"43":"El sacerdote la examinará; si la inflamación de la llaga es de un color blanco rosáceo, como el de la lepra de la piel,"
,"44":"ese hombre es un leproso e impuro. El sacerdote lo declarará impuro, pues lleva la llaga de la lepra en su cabeza."
,"45":"El leproso andará harapiento, despeinado, la cara medio tapada y gritando: ¡Impuro, impuro!"
,"46":"Mientras le dure la lepra, será impuro y, siendo impuro, vivirá aislado, fuera del campamento'."
,"47":"'Si aparece una mancha de lepra en un vestido, de lana o lino,"
,"48":"de tela o de punto, o de cuero, o en un objeto cualquiera de cuero,"
,"49":"si la mancha es de un color verdoso o rojizo, es un caso de lepra que debe ser mostrado al sacerdote."
,"50":"El sacerdote la examinará y aislará el objeto durante siete días."
,"51":"Si al séptimo día ve que se ha extendido por el vestido, es un caso de lepra contagiosa; el objeto es impuro."
,"52":"El vestido, de cualquier clase que sea, afectado por la lepra, deberá ser quemado por el fuego, porque es lepra contagiosa."
,"53":"Si el sacerdote ve que la lepra no se ha extendido por el vestido,"
,"54":"mandará lavar el objeto infectado y lo aislará otros siete días."
,"55":"Si, después de lavado, el sacerdote ve que la mancha no ha cambiado de aspecto, aunque no se haya extendido más, el objeto es impuro; será echado al fuego, porque está infectado por el derecho y por el revés."
,"56":"Pero si el sacerdote ve que la mancha ha perdido color, después de lavarla, arrancará del vestido la parte manchada."
,"57":"Si la mancha vuelve a aparecer en el vestido, se trata de una lepra activa; el objeto infectado será echado al fuego."
,"58":"Pero si después de lavado, la mancha ha desaparecido del vestido, será lavado otra vez y quedará puro."
,"59":"Tal es la ley para los casos de lepra en un vestido, de lana o de lino, de tela o de punto, o en cualquier objeto de cuero, cuando se trata de declararlos puros o impuros'."
}`)
	CurrentBook.AddChapter(14, `{
"1":"El Señor dijo a Moisés:"
,"2":"'Éste es el ritual para la purificación de un leproso: será llevado al sacerdote,"
,"3":"el cual le saldrá al encuentro fuera del campamento para reconocerlo; si el leproso está curado de su lepra,"
,"4":"mandará traer para el que se va a purificar dos aves puras y vivas, madera de cedro, una cinta de lana escarlata y un hisopo."
,"5":"El sacerdote mandará degollar una de las aves sobre una vasija de tierra cocida llena de agua corriente."
,"6":"Tomará luego el ave viva, el cedro, la cinta de lana escarlata y el hisopo (incluida el ave viva) y los mojará en la sangre del ave degollada sobre el agua corriente."
,"7":"Asperjará entonces siete veces al hombre que quiere ser purificado de la lepra y, una vez que lo haya declarado puro, dejará suelta en el campo el ave viva."
,"8":"El leproso así purificado lavará sus vestidos, se cortará todo el pelo, se bañará con agua y será puro. Después entrará de nuevo en el campamento, pero tardará siete días en entrar en su tienda."
,"9":"El día séptimo se cortará de nuevo pelos, cabello, barba y cejas; se cortará todos los pelos. Lavará sus vestidos, bañará con agua su cuerpo y será puro."
,"10":"El día octavo tomará dos corderos sin defecto, una cordera de un año sin defecto, trece kilos de flor de harina amasada con aceite para la ofrenda y medio litro de aceite."
,"11":"El sacerdote que hace el rito de la purificación pondrá al que se va a purificar, juntamente con sus ofrendas, a la entrada de la tienda de la reunión delante del Señor;"
,"12":"tomará uno de los corderos y lo ofrecerá como sacrificio de reparación con el medio litro de aceite, y hará con ellos el rito de presentación delante del Señor."
,"13":"Inmolará el cordero en el lugar del santuario donde se inmolan las víctimas por el pecado y el holocausto, pues tanto el sacrificio por el pecado como el de reparación pertenecen al sacerdote como cosa santísima."
,"14":"El sacerdote tomará de la sangre del sacrificio de reparación y ungirá con ella el lóbulo de la oreja derecha del que se purifica, el pulgar de su mano derecha y el dedo gordo de su pie derecho."
,"15":"Tomará luego el medio litro de aceite, echará un poco en la palma de la mano izquierda,"
,"16":"mojará el índice de la mano derecha en el aceite que tiene en la palma de su mano izquierda y hará con él siete aspersiones delante del Señor."
,"17":"Con aceite del que le queda en la palma de la mano ungirá el lóbulo de la oreja derecha del que se purifica, el pulgar de su mano derecha y el dedo gordo de su pie derecho, encima de la sangre de la víctima de reparación."
,"18":"El aceite que le queda en la palma de la mano lo verterá sobre la cabeza del que se está purificando. De esta manera el sacerdote habrá cumplido sobre él el rito de absolución delante del Señor."
,"19":"El sacerdote ofrecerá entonces el sacrificio por el pecado y hará el rito de absolución sobre el que se está purificando de su impureza. A continuación inmolará el holocausto"
,"20":"y ofrecerá sobre el altar el holocausto y la ofrenda. El sacerdote hará sobre él el rito de absolución y quedará puro."
,"21":"Si es pobre y no puede procurarse las víctimas ordinarias, tomará un solo cordero como sacrificio de reparación para el rito de presentación y para hacer sobre él el rito de absolución; cuatro kilos y medio de flor de harina amasada con aceite para ofrenda; medio litro de aceite;"
,"22":"dos tórtolas o dos pichones, según sus posibilidades, uno para el sacrificio por el pecado y otro para el holocausto."
,"23":"Lo presentará al sacerdote el día octavo para su purificación a la entrada de la tienda de la reunión delante del Señor."
,"24":"El sacerdote tomará el cordero del sacrificio de reparación y el medio litro de aceite y los ofrecerá al Señor con el rito de presentación."
,"25":"Inmolará el cordero del sacrificio de reparación, tomará un poco de sangre y ungirá con ella el lóbulo de la oreja derecha, el pulgar de la mano derecha y el dedo gordo del pie derecho del que se está purificando."
,"26":"Echará luego aceite en la palma de su mano izquierda,"
,"27":"mojará el índice de la mano derecha en el aceite que tiene en la palma de su mano izquierda y hará con él siete aspersiones delante del Señor."
,"28":"Con aceite del que le queda en la palma de la mano izquierda le untará el lóbulo de la oreja derecha, el pulgar de la mano derecha y el dedo gordo del pie derecho en el mismo lugar en que puso la sangre del sacrificio de reparación."
,"29":"El aceite que le queda en la palma de la mano lo verterá sobre la cabeza del que se está purificando, haciendo sobre él el rito de absolución delante del Señor."
,"30":"De los dos pichones o de las dos tórtolas, según hayan sido sus posibilidades,"
,"31":"ofrecerá el uno como sacrificio por el pecado y el otro en holocausto, acompañado de ofrenda. El sacerdote hará sobre él el rito de absolución delante del Señor."
,"32":"Ésta es la ley para la purificación del leproso que no puede presentar las víctimas ordinarias'."
,"33":"El Señor dijo a Moisés y a Aarón:"
,"34":"'Cuando hayáis entrado en la tierra de Canaán que os doy en propiedad, si yo infecto de lepra alguna casa de la tierra que vais a ocupar,"
,"35":"su dueño se presentará al sacerdote y le dirá: Me parece que en mi casa hay lepra."
,"36":"El sacerdote dará orden de desalojar la casa antes de que él vaya a examinar la mancha de lepra, con el fin de que no contraigan impureza los objetos que haya en ella. Después, el sacerdote entrará a examinar la casa;"
,"37":"si observa cavidades verdosas o rojizas hundidas en los muros,"
,"38":"saldrá fuera, a la puerta de la casa, y la cerrará durante siete días."
,"39":"Al séptimo día volverá para examinarla de nuevo; si la mancha se ha corrido por las paredes de la casa,"
,"40":"dará orden de arrancar las piedras manchadas y de tirarlas fuera de la ciudad, en un lugar impuro."
,"41":"Mandará raspar las paredes interiores de la casa y tirar las raspaduras en un lugar impuro, fuera de la ciudad."
,"42":"Se tomarán otras piedras para reemplazar las primeras, y masa nueva para revocar la casa."
,"43":"Si la mancha reaparece de nuevo, una vez cambiadas las piedras después de haber raspado y revocado la casa,"
,"44":"el sacerdote entrará a examinarla; si la mancha se ha extendido por la casa, se trata de lepra contagiosa; la casa es impura."
,"45":"Será derribada, y las piedras, la madera y los escombros serán tirados en un lugar impuro, fuera de la ciudad."
,"46":"El que entre en la casa durante el tiempo que esté cerrada, será impuro hasta la tarde."
,"47":"El que duerma o coma en ella, lavará sus vestidos."
,"48":"Si el sacerdote comprueba que la mancha no se ha corrido en la casa después de revocada, la declarará pura, pues la mancha ha desaparecido."
,"49":"Para purificar la casa tomará dos aves, madera de cedro, una cinta de lana escarlata y un hisopo."
,"50":"Inmolará una de las aves en una vasija de tierra cocida llena de agua corriente."
,"51":"Tomará la madera de cedro, el hisopo, la cinta de lana escarlata y el ave viva, lo mojará todo en la sangre del ave inmolada sobre el agua corriente y hará siete aspersiones sobre la casa."
,"52":"Así purificará la casa mediante la sangre del ave, el agua corriente, el ave viva, la madera de cedro, el hisopo y la cinta de lana escarlata,"
,"53":"y pondrá en libertad el ave viva fuera de la ciudad, en el campo. Hará el rito de absolución sobre la casa, y quedará purificada'."
,"54":"Tales son las instrucciones en todos los casos de lepra o tiña,"
,"55":"la lepra de los vestidos y de las casas,"
,"56":"inflamaciones, pústulas o manchas relucientes,"
,"57":"para poder distinguir cuándo una cosa es pura y cuándo impura. Tales son las instrucciones acerca de la lepra."
}`)
	CurrentBook.AddChapter(15, `{
"1":"El Señor habló a Moisés y a Aarón:"
,"2":"'Decid a los israelitas: El que padezca derrame de semen en sus órganos será impuro."
,"3":"Su impureza radica en el derrame de semen; tanto si sus órganos dejan salir el semen como si lo retienen, es impuro."
,"4":"El lecho en que se acueste el que sufre el derrame será impuro, e igualmente todo mueble donde se siente."
,"5":"El que toque su lecho, lavará los vestidos, se bañará y será impuro hasta la tarde."
,"6":"El que se siente en un mueble en el que estuvo sentado aquél, lavará sus vestidos, se bañará y será impuro hasta la tarde."
,"7":"El que toque al que padece derrame, lavará sus vestidos, se bañará y será impuro hasta la tarde."
,"8":"Si el que padece derrames escupe sobre un hombre puro, éste lavará sus vestidos, se bañará y será impuro hasta la tarde."
,"9":"Toda silla sobre la que haya viajado el paciente será impura."
,"10":"El que toque un objeto cualquiera que haya estado debajo del paciente, será impuro hasta la tarde, y el que lo transporte, lavará sus vestidos, se bañará y será impuro hasta la tarde."
,"11":"Todo aquel a quien toque el paciente, sin haberse lavado previamente las manos, lavará sus vestidos, se bañará y será inmundo hasta la tarde."
,"12":"Toda vasija de barro que toque el paciente será rota, y todo recipiente de madera será lavado."
,"13":"Cuando el paciente esté curado de su derrame, contará siete días para su purificación; lavará sus vestidos, bañará su cuerpo en agua corriente y será puro."
,"14":"Al octavo día tomará dos tórtolas o dos pichones, se presentará con ellos ante el Señor, a la entrada de la tienda de la reunión, y los entregará al sacerdote,"
,"15":"que los ofrecerá, uno en sacrificio por el pecado y otro en holocausto. El sacerdote hará sobre él, delante del Señor, el rito de absolución por su derrame."
,"16":"Cuando un hombre haya tenido un derrame de semen, lavará con agua todo su cuerpo y será impuro hasta la tarde."
,"17":"Cualquier vestido de paño o cuero en que caiga parte del semen será lavado con agua y quedará impuro hasta la tarde."
,"18":"Cuando un hombre y una mujer se acuesten juntos y tengan relaciones sexuales, los dos se lavarán con agua y serán impuros hasta la tarde'."
,"19":"'Cuando una mujer tenga su período normal de menstruación, será considerada impura durante siete días. El que la toque será impuro hasta la tarde."
,"20":"Todo aquello sobre lo que duerma o se siente durante su impureza será impuro."
,"21":"El que toque su lecho, lavará sus vestidos, se bañará con agua y será impuro hasta la tarde."
,"22":"El que toque un mueble en el que ella se haya sentado, lavará sus vestidos, se bañará y será impuro hasta la tarde."
,"23":"El que toque lo que está sobre su lecho o sobre su asiento será impuro hasta la tarde."
,"24":"Si un hombre se acuesta con ella, contrae la impureza de su menstruación y será impuro durante siete días; todo lecho sobre el que duerma será impuro."
,"25":"Cuando una mujer tenga hemorragias fuera de su período normal de menstruación o cuando su menstruación le dure más de lo normal, será impura mientras le dure la hemorragia, con la misma impureza del período de menstruación."
,"26":"El lecho sobre el que haya dormido durante el tiempo de su hemorragia será para ella como el lecho de los días de su menstruación, y todo mueble sobre el que se haya sentado será impuro, como si se tratara de la impureza de su menstruación."
,"27":"El que los toque será impuro, lavará sus vestidos, se bañará y será impuro hasta la tarde."
,"28":"Cuando esté curada de su hemorragia, contará siete días, pasados los cuales será pura."
,"29":"Al octavo día tomará dos tórtolas o dos pichones y los presentará al sacerdote a la entrada de la tienda de la reunión."
,"30":"El sacerdote los ofrecerá, uno en sacrificio por el pecado y otro en holocausto. Hará sobre ella, delante del Señor, el rito de absolución por la impureza de su hemorragia."
,"31":"Así, pues, enseñaréis a los israelitas a purificarse de sus inmundicias, para que no mueran contaminando con ellas mi morada, que está en medio de ellos."
,"32":"Éstas son las instrucciones acerca del que padece derrame o contrae impureza por pérdida de semen,"
,"33":"acerca de la mujer durante su período de menstruación y de la que sufre desajustes en su menstruación, acerca de los hombres o mujeres que tengan derrames y de los hombres que se acuesten con una mujer durante su menstruación'."
}`)
	CurrentBook.AddChapter(16, `{
"1":"El Señor se dirigió a Moisés después de la muerte de los hijos de Aarón, que murieron por haberse acercado demasiado al Señor,"
,"2":"y le dijo: 'Di a tu hermano Aarón que no podrá entrar nunca en el santuario, en el recinto que hay detrás del velo, en presencia del propiciatorio que está sobre el arca, no sea que muera cuando yo aparezca sobre el propiciatorio en una nube."
,"3":"Éste es el rito que seguirá Aarón para entrar en el santuario: tomará un novillo para el sacrificio por el pecado y un carnero para el holocausto;"
,"4":"se vestirá la túnica de lino consagrada, se pondrá el calzón de lino, se ceñirá con cinturón de lino y cubrirá su cabeza con turbante de lino. Tales son las vestiduras sagradas que se pondrá después de haberse lavado con agua."
,"5":"Recibirá de la comunidad de los israelitas dos machos cabríos para el sacrificio por el pecado y un carnero para el holocausto."
,"6":"Una vez que Aarón haya ofrecido su novillo en sacrificio por el propio pecado y haya hecho el rito de absolución por él y por su casa,"
,"7":"tomará los dos machos cabríos, los presentará delante del Señor a la puerta de la tienda de la reunión"
,"8":"y echará sobre ellos las suertes: una para el Señor y otra para Azazel."
,"9":"Aarón presentará el macho cabrío sobre el que haya caído la suerte del Señor y lo ofrecerá en sacrificio por el pecado."
,"10":"El macho cabrío sobre el que haya caído la suerte de Azazel será presentado vivo delante del Señor, para hacer sobre él el rito de absolución y mandarlo al desierto, donde está Azazel."
,"11":"Aarón ofrecerá en sacrificio por el propio pecado su novillo, hará el rito de absolución por sí mismo y por su casa e inmolará el novillo en sacrificio por el propio pecado."
,"12":"Tomará del altar que está delante del Señor un incensario lleno de carbones encendidos y dos puñados de incienso aromático molido para llevarlo todo detrás del velo."
,"13":"Echará el incienso sobre el fuego delante del Señor, de manera que la nube de incienso cubra el propiciatorio que está sobre el testimonio y no muera."
,"14":"Tomará luego la sangre del novillo, asperjará con el dedo el lado oriental del propiciatorio; hará siete aspersiones de sangre con el dedo delante del propiciatorio."
,"15":"Inmolará entonces el macho cabrío destinado para el sacrificio por el pecado del pueblo, llevará su sangre detrás del velo y hará con ella lo mismo que hizo con la sangre del novillo, rociándola sobre el propiciatorio y delante de él:"
,"16":"hará el rito de absolución sobre el santuario por las impurezas de los israelitas, por todas sus transgresiones y pecados. Lo mismo hará sobre la tienda de la reunión, que se encuentra entre ellos en medio de sus impurezas."
,"17":"No habrá nadie en la tienda de la reunión durante todo el tiempo que dura el rito de absolución en el santuario, desde que entra el sumo sacerdote hasta que sale: hará el rito de absolución por sí mismo, por su casa y por toda la comunidad de Israel."
,"18":"Una vez fuera, irá al altar que está delante del Señor y hará sobre él el rito de absolución; tomará sangre del novillo y del macho cabrío, untará con ella los cuernos del altar todo alrededor"
,"19":"y la rociará con el dedo por siete veces sobre el altar, purificándolo y santificándolo de las impurezas de los israelitas."
,"20":"Cuando haya terminado de hacer el rito de absolución por el santuario, la tienda de la reunión y el altar, presentará el macho cabrío vivo,"
,"21":"pondrá las dos manos sobre su cabeza, confesará sobre él todas las faltas de los israelitas, todas sus transgresiones, todos sus pecados y, una vez cargados sobre la cabeza del macho, lo mandará al desierto por medio de un hombre designado para ello;"
,"22":"el macho cabrío llevará sobre sí todas sus iniquidades a tierra desierta. El macho cabrío será abandonado en el desierto."
,"23":"Aarón entrará en la tienda de la reunión, se despojará de las vestiduras de lino que se había puesto para entrar en el santuario, las dejará allí,"
,"24":"se lavará el cuerpo con agua en lugar sagrado, se revestirá de nuevo y saldrá para ofrecer su holocausto y el del pueblo, para hacer el rito de absolución por sí mismo y por el pueblo,"
,"25":"para quemar las grasas de la víctima por el pecado sobre el altar."
,"26":"El que fue a soltar el macho cabrío de Azazel lavará sus vestidos, se bañará y después podrá entrar en el campamento."
,"27":"El novillo y el macho cabrío ofrecidos en sacrificio por el pecado, cuya sangre fue introducida en el santuario para hacer el rito de absolución, serán llevados fuera del campamento, con el fin de que sus pieles, carnes y excrementos sean quemados."
,"28":"El que los queme lavará sus vestidos, se bañará y después podrá entrar en el campamento."
,"29":"Ésta será para vosotros ley perpetua: el séptimo mes, el día diez del mes, ayunaréis y no haréis trabajo alguno, tanto el indígena como el extranjero residente en medio de vosotros."
,"30":"Es, en efecto, el día en que se hará el rito de absolución sobre vosotros para purificaros; seréis purificados de todos vuestros pecados delante del Señor."
,"31":"Será para vosotros día de descanso sabático y día de ayuno. Es ley perpetua."
,"32":"El rito de absolución lo hará el sacerdote que haya sido ungido y consagrado para el ejercicio sacerdotal en lugar de su padre; vestirá las vestiduras de lino, las vestiduras sagradas."
,"33":"Hará el rito de absolución por el santuario, la tienda de la reunión, el altar, los sacerdotes y toda la comunidad de Israel."
,"34":"Será para vosotros ley perpetua; una vez al año se hará sobre los israelitas el rito de absolución por todos sus pecados'. Se hizo lo que el Señor había ordenado a Moisés."
}`)
	CurrentBook.AddChapter(17, `{
"1":"El Señor habló a Moisés:"
,"2":"'Di a Aarón, a sus hijos y a todos los israelitas: Esto manda el Señor:"
,"3":"Si un israelita mata un toro, un cordero o una cabra, dentro o fuera del campamento,"
,"4":"y lo lleva a la entrada de la tienda de la reunión para presentarlos como ofrenda al Señor ante su santuario, se hace responsable de la sangre derramada y será extirpado de en medio de su pueblo."
,"5":"Es para que los israelitas presenten al sacerdote, delante del Señor, a la entrada de la tienda de la reunión, las víctimas que querrían inmolar en el campo, para ofrecerlas al Señor como sacrificio de reconciliación."
,"6":"El sacerdote derramará la sangre sobre el altar del Señor a la entrada de la tienda de la reunión y quemará las grasas en perfume agradable al Señor."
,"7":"No ofrecerá más sus sacrificios a los sátiros, ante los que solían prostituirse; ésta será ley perpetua para ellos y para sus descendientes."
,"8":"Diles: Cualquier israelita o extranjero residente en medio de vosotros que ofrezca un holocausto o un sacrificio"
,"9":"sin llevarlos a la entrada de la tienda de la reunión para ofrecerlos al Señor, será extirpado de su pueblo."
,"10":"Cualquier israelita o extranjero residente que coma la sangre, cualquiera que sea, será objeto de mi aborrecimiento; yo me volveré contra él y lo extirparé de su pueblo,"
,"11":"porque la sangre es la vida de la carne, y yo os he dado la sangre para que hagáis sobre el altar el rito de absolución por vuestras vidas, pues la sangre es la que paga el rescate por la vida."
,"12":"Por eso he dicho a los israelitas: Ni vosotros ni el extranjero residente comeréis sangre."
,"13":"Si un israelita o un extranjero residente caza un animal o un ave cuyas carnes se pueden comer, verterá la sangre y la cubrirá con la tierra,"
,"14":"porque la sangre es la vida de todo ser viviente. Por eso he dicho yo a los israelitas: No comeréis la sangre de ningún animal, porque la sangre es la vida de todo ser viviente; quien comiere de ella será extirpado."
,"15":"El indígena o extranjero residente que comiere carne muerta o destrozada por las fieras, lavará sus vestidos, se bañará y será impuro hasta la tarde; entonces será puro."
,"16":"Si no lava sus vestidos ni se baña, cargará con su falta'."
}`)
	CurrentBook.AddChapter(18, `{
"1":"El Señor habló a Moisés:"
,"2":"'Di a los israelitas: Yo soy el Señor, vuestro Dios."
,"3":"No haréis lo que se hace en Egipto, donde habéis vivido, ni haréis lo que se hace en Canaán, adonde os llevo; no seguiréis sus costumbres."
,"4":"Practicaréis mis mandamientos y cumpliréis mis leyes; os conduciréis de acuerdo con ellas: yo, el Señor, vuestro Dios."
,"5":"Observaréis mis preceptos y mis leyes, pues el que los cumpla encontrará la vida en ellos: yo, el Señor."
,"6":"Ninguno de vosotros se acercará a mujer de su propia familia para tener relaciones sexuales con ella: yo, el Señor."
,"7":"No tendrás relaciones sexuales con tu madre, pues es de tu padre y, además, es tu madre; no debes hacerlo;"
,"8":"no las tendrás tampoco con la concubina de tu padre, pues es la misma carne de tu padre;"
,"9":"ni con tu hermana, por parte de padre o de madre, nacida en casa o fuera de ella;"
,"10":"ni con tus nietas, pues son tu propia carne;"
,"11":"ni con tu hermana por parte de padre, pues es tu hermana;"
,"12":"ni con tu tía paterna, pues es de la misma sangre de tu padre;"
,"13":"ni con tu tía materna, pues es de la sangre de tu madre;"
,"14":"ni con la mujer de tu tío paterno, deshonrando así a tu tío, pues es tu tía;"
,"15":"ni con tu nuera, pues es la mujer de tu hijo;"
,"16":"ni con tu cuñada, pues es carne de tu hermano;"
,"17":"ni con una mujer a la vez que con su hija o su nieta, ésa sería una acción infame, pues son de la misma sangre;"
,"18":"no tomarás por mujer a la hermana de tu esposa, ni tendrás relaciones sexuales con ella mientras tu esposa viva, pues crearías rivalidades entre ellas."
,"19":"No tendrás relaciones sexuales con una mujer durante el período de su menstruación."
,"20":"No te acostarás con la mujer de tu prójimo; te quedarías impuro."
,"21":"No darás a tus hijos para ser pasados por el fuego en honor de Moloc profanando el nombre de Dios: yo, el Señor."
,"22":"No te acostarás con un hombre como se hace con una mujer; es una acción infame."
,"23":"No harás actos sexuales con ningún animal, te quedarías impuro; tampoco la mujer debe hacer actos sexuales con un animal para aparearse con él; eso es una infamia."
,"24":"No os manchéis con ninguna de estas prácticas, como se han manchado las naciones que yo echo delante de vosotros."
,"25":"La tierra se ha contaminado; yo he castigado su iniquidad, y la tierra vomitará sus habitantes."
,"26":"Guardad mis leyes y mis mandamientos, no cometáis ninguna de estas infamias, ni el indígena, ni el extranjero residente."
,"27":"Todas estas infamias las cometieron los habitantes que os precedieron en esta tierra, y la tierra quedó impura."
,"28":"Que no os veáis vomitados por la tierra al sentirse impura por vosotros, como fueron vomitados los pueblos que os precedieron en ella."
,"29":"Todos los que cometan alguna de estas infamias serán extirpados de su pueblo."
,"30":"Guardad mis mandamientos y no sigáis las costumbres infames que se practicaban antes de vosotros, si no queréis quedar impuros con ellas: yo, el Señor, vuestro Dios'."
}`)
	CurrentBook.AddChapter(19, `{
"1":"El Señor habló a Moisés:"
,"2":"'Di a toda la comunidad de los israelitas: Sed santos, porque yo, el Señor, vuestro Dios, soy santo."
,"3":"Respetad a vuestros padres y guardad mis sábados: yo, el Señor, vuestro Dios."
,"4":"No os vayáis tras los ídolos, y no os hagáis dioses de metal fundido: yo, el Señor, vuestro Dios."
,"5":"Cuando hagáis al Señor un sacrificio de reconciliación, ofrecedlo de manera que Dios os lo acepte."
,"6":"Comeréis la víctima el mismo día del sacrificio o al día siguiente, y lo que quede para el tercer día será quemado."
,"7":"Si se come de ella el día tercero, estando ya corrompida, Dios no la aceptará;"
,"8":"el que la coma cargará con su falta, por haber profanado lo consagrado al Señor, y será extirpado de su pueblo."
,"9":"Cuando hagáis la recolección de vuestras tierras no segaréis hasta la misma orilla del campo. No recogerás las espigas caídas,"
,"10":"no harás el rebusco en tus viñas ni prestarás atención a la fruta caída de tu huerta; lo dejarás para el pobre y el extranjero: yo, el Señor, vuestro Dios."
,"11":"No robaréis, no mentiréis ni os engañaréis unos a otros."
,"12":"No juréis en falso por mi nombre, pues sería profanar el nombre de Dios: yo, el Señor."
,"13":"No oprimas ni explotes a tu prójimo; no retengas el salario del jornalero hasta la mañana siguiente."
,"14":"No insultarás al sordo ni pondrás tropiezos delante del ciego. Temerás a tu Dios: yo, el Señor."
,"15":"No haréis injusticias en los juicios; ni beneficiarás al débil ni favorecerás al poderoso: juzgarás con justicia a tu prójimo."
,"16":"No andarás difamando a los tuyos ni pondrás en peligro la vida del prójimo con falsas acusaciones: yo, el Señor."
,"17":"No guardarás odio a tu hermano, antes bien lo corregirás para no hacerte cómplice de su pecado."
,"18":"No serás vengativo ni guardarás rencor hacia tus conciudadanos. Amarás a tu prójimo como a ti mismo: yo, el Señor."
,"19":"Observad las leyes. No cruzarás en tu ganado las bestias de diversa especie, ni sembrarás en tu campo dos especies de grano diferentes ni llevarás sobre ti un vestido con dos clases de tejido."
,"20":"Si uno se acuesta con una mujer que pertenece a otro como esclava y concubina sin que haya sido rescatada ni puesta en libertad, será castigado; pero no con la muerte, pues la mujer no era libre."
,"21":"Ofrecerá al Señor a la entrada de la tienda de la reunión un carnero en sacrificio por el pecado."
,"22":"El sacerdote hará sobre él el rito de absolución delante del Señor, y el pecado cometido le será perdonado."
,"23":"Cuando hayáis entrado en la tierra y hayáis plantado árboles frutales de cualquier clase que sean, consideraréis sus frutos como si fueran incircuncisos; durante tres años los tendréis por incircuncisos y no los comeréis."
,"24":"El cuarto año todos sus frutos serán consagrados en una fiesta homenaje al Señor."
,"25":"A partir del quinto año podréis comer los frutos. Así el árbol os dará más. Yo, el Señor, vuestro Dios."
,"26":"No comeréis nada que tenga sangre; no practicaréis la adivinación ni la magia."
,"27":"No os cortaréis en redondo el pelo de vuestra cabeza ni os afeitaréis los bordes de la barba."
,"28":"No os haréis cortes en la carne por un muerto ni os haréis tatuajes: yo, el Señor."
,"29":"No deshonrarás a tu hija prostituyéndola; de esta manera la tierra no se prostituirá ni se llenará de inmoralidades."
,"30":"Guardaréis mis sábados y respetaréis mi santuario: yo, el Señor."
,"31":"No consultaréis a los nigromantes ni recurriréis a los adivinos, si no queréis quedar impuros: yo, el Señor, vuestro Dios."
,"32":"Ponte en pie ante el hombre de canas, honra al anciano y teme a Dios: yo, el Señor."
,"33":"Si un extranjero se establece en vuestra tierra, en medio de vosotros, no lo molestaréis;"
,"34":"será para vosotros como un compatriota más, y lo amarás como a ti mismo, pues también vosotros fuisteis extranjeros en Egipto: yo, el Señor, vuestro Dios."
,"35":"No haréis injusticias en los juicios ni cometeréis fraude en pesos y medidas."
,"36":"Tened balanzas justas, pesos justos y sean exactos el peso y la medida: yo, el Señor, vuestro Dios, que os he sacado de Egipto."
,"37":"Guardad todas mis leyes y preceptos y ponedlos en práctica: yo, el Señor'."
}`)
	CurrentBook.AddChapter(20, `{
"1":"El Señor habló a Moisés:"
,"2":"'Di a los israelitas: Cualquier israelita o extranjero residente que entregue alguno de sus hijos a Moloc, será castigado con la muerte: el pueblo lo matará a pedradas."
,"3":"Yo me volveré contra ese hombre y lo extirparé de en medio de su pueblo, por haber entregado un hijo suyo a Moloc manchando mi santuario y profanando mi santo nombre."
,"4":"Si el pueblo se desentiende de ese hombre y no le mata,"
,"5":"yo mismo me volveré contra él y su familia; lo extirparé de en medio del pueblo a él y a cuantos después de él vayan a prostituirse con Moloc."
,"6":"Si alguno acude a los nigromantes y recurre a los adivinos prostituyéndose con ellos, yo me volveré contra él y lo extirparé de su pueblo."
,"7":"Santificaos y sed santos, porque yo soy el Señor, vuestro Dios."
,"8":"Guardad mis mandamientos y ponedlos en práctica, pues yo soy el Señor, que os santifica'."
,"9":"'El que maldiga a su padre o a su madre, será castigado con la muerte; ha maldecido a su padre o a su madre, caiga su sangre sobre él."
,"10":"En cuanto al hombre que comete adulterio con una mujer casada: el hombre que comete adulterio con la mujer de su prójimo, será castigado con la muerte, él y la mujer."
,"11":"El hombre que se acuesta con la mujer de su padre, deshonra a su propio padre; los dos serán castigados con la muerte; caiga su sangre sobre ellos."
,"12":"Si uno se acuesta con la nuera, los dos serán castigados con la muerte, se han manchado; caiga su sangre sobre ellos."
,"13":"Si un hombre se acuesta con otro hombre como se hace con una mujer, los dos cometen una infamia y serán castigados con la muerte; caiga su sangre sobre ellos."
,"14":"Si uno toma por esposas madre e hija, comete un incesto; serán quemados él y ellas para que no haya entre vosotros semejante crimen."
,"15":"Si uno hace actos sexuales con un animal, será castigado con la muerte; también hay que matar al animal."
,"16":"Si una mujer hace actos sexuales con un animal para aparearse con él, los dos deben ser matados, la mujer y el animal; caiga su sangre sobre ellos."
,"17":"Si uno toma por esposa a su hermana, por parte de padre o de madre, y tienen relaciones sexuales, es una ignominia; los dos serán matados a la vista de todo el pueblo; por haber tenido relaciones sexuales con su propia hermana cargará con su culpa."
,"18":"Si uno se acuesta con una mujer durante el período de su menstruación y tiene relaciones sexuales con ella, descubre la sangre de la mujer en su fuente y la mujer descubre la fuente de su propia sangre; los dos serán extirpados de en medio de su pueblo."
,"19":"No tendrás relaciones sexuales con tu tía paterna o materna, pues es tenerlas con alguien de la propia sangre, y los dos cargarán con su culpa."
,"20":"Si uno se acuesta con la mujer de su tío, deshonra a su propio tío; los dos cargarán con su culpa y morirán sin descendencia."
,"21":"El que toma por esposa a la mujer de su hermano comete una impureza; ha deshonrado a su hermano; no tendrán hijos'."
,"22":"'Guardad todas mis leyes, todas mis prescripciones y ponedlas en práctica, de manera que no os veáis vomitados por la tierra a la que yo os llevo para que habitéis en ella."
,"23":"No imitéis las costumbres de las gentes que yo echo delante de vosotros, las cuales han practicado todas estas iniquidades y se han hecho objeto de mi aborrecimiento."
,"24":"De nuevo os digo: Tomaréis posesión de su tierra, yo mismo os la doy en propiedad; es una tierra que mana leche y miel: yo, el Señor, Dios vuestro, que os he separado de las gentes."
,"25":"Separad también vosotros los animales puros de los impuros, las aves puras de las impuras, y no os contaminéis con animal alguno, ave o reptil que se arrastra sobre la tierra, animales que yo os he señalado como impuros."
,"26":"Sed para mí santos, porque santo soy yo, el Señor, que os he separado de las gentes para que seáis míos."
,"27":"Todo hombre o mujer que se dedique a la nigromancia o a la adivinación será matado a pedradas; caiga su sangre sobre ellos'."
}`)
	CurrentBook.AddChapter(21, `{
"1":"El Señor habló a Moisés: 'Di a los sacerdotes, hijos de Aarón: Ningún sacerdote contraiga impureza por el cadáver de un pariente,"
,"2":"a no ser por un pariente cercano: madre, padre, hijo, hija, hermano"
,"3":"o hermana soltera, que aún vive con él porque no se ha casado; por ellos podrá hacerse impuro."
,"4":"No debe hacerse impuro ni mancharse por una pariente casada."
,"5":"No se raparán la cabeza, no rasurarán los bordes de su barba ni se harán cortes en su cuerpo."
,"6":"Estarán consagrados a su Dios y no profanarán su nombre, pues son ellos los que presentan las ofrendas al Señor, alimento de su Dios; estarán en estado de santidad."
,"7":"No tomarán por esposa una mujer prostituta, violada o divorciada, pues el sacerdote está consagrado a su Dios."
,"8":"Le tendrás por santo, pues él es quien ofrece el alimento a tu Dios; tenle por santo, porque santo soy yo, que os santifico."
,"9":"Si la hija de un sacerdote se deshonra y se hace prostituta, deshonra también a su padre; será quemada viva'."
,"10":"'En cuanto al sumo sacerdote, el mayor entre sus hermanos, sobre cuya cabeza fue derramado el óleo de la unción, a quien le fue conferido el poder de llevar las vestiduras sagradas, no irá despeinado ni harapiento,"
,"11":"no se acercará a ningún cadáver; ni siquiera por su padre o por su madre debe hacerse impuro."
,"12":"No se saldrá del lugar santo para no profanar el santuario de su Dios, pues lleva sobre sí la corona del óleo de la unción de su Dios: yo, el Señor."
,"13":"Tomará para esposa mujer virgen."
,"14":"No tomará ni viuda ni divorciada, ni violada ni prostituta; una virgen de su pueblo será su mujer."
,"15":"De esta manera no profanará entre los suyos su descendencia, pues yo soy el Señor, que lo santifica'."
,"16":"El Señor habló a Moisés:"
,"17":"'Di a Aarón: Ninguno de tu estirpe, de cualquiera generación que sea, que tenga un defecto corporal se acercará a ofrecer el alimento a su Dios."
,"18":"No se acercará ningún defectuoso, sea ciego o cojo, mutilado o deforme,"
,"19":"lisiado de pies o manos,"
,"20":"jorobado o enano, bisojo o sarnoso, tiñoso o herniado."
,"21":"Ningún descendiente del sacerdote Aarón que tenga algún defecto podrá acercar las ofrendas al Señor; tiene un defecto, y por tanto no se acercará a ofrecer el alimento de su Dios."
,"22":"Podrá comer el alimento de su Dios, a saber, las ofrendas santas y santísimas;"
,"23":"pero no podrá pasar detrás del velo ni acercarse al altar, pues tiene un defecto y no debe profanar mi santuario: yo, el Señor, que los santifico'."
,"24":"Así habló Moisés a Aarón, a sus hijos y a todos los israelitas."
}`)
	CurrentBook.AddChapter(22, `{
"1":"El Señor habló a Moisés:"
,"2":"'Di a Aarón y a sus hijos que se santifiquen con las cosas santas de los israelitas y no profanen mi santo nombre: yo, el Señor."
,"3":"Diles: Cualquier descendiente que se acerque en estado de impureza a las ofrendas santas consagradas al Señor por los israelitas, será extirpado de mi presencia: yo, el Señor."
,"4":"Ningún descendiente de Aarón que tenga lepra o derrame de semen podrá comer de las cosas santas antes de su purificación. El que haya tocado un objeto contaminado por contacto con un cadáver, el que haya tenido derrame de semen,"
,"5":"el que haya tocado animal u hombre impuros contrayendo su misma impureza,"
,"6":"el que haya tenido alguno de estos contactos, será impuro hasta la tarde; no podrá comer de las cosas santas si primero no ha lavado su cuerpo con agua."
,"7":"Después de la puesta del sol será puro y podrá comer de las cosas consagradas, porque son su comida."
,"8":"No comerá carne de bestia muerta o despedazada por una fiera, pues contraería impureza: yo, el Señor."
,"9":"Que guarden todas mis prescripciones, no sea que por alguna de ellas incurran en culpa y tengan que morir por haberlas profanado: yo, el Señor, que los santifico'."
,"10":"'Ningún laico comerá las cosas santas; ni el huésped del sacerdote ni el siervo mercenario comerán las cosas santas."
,"11":"En cambio, podrá comerlas el siervo comprado con dinero por el sacerdote, exactamente como el que ha nacido en casa, pues los dos comen su propio alimento."
,"12":"La hija de un sacerdote casada con un extraño no podrá comer las cosas santas;"
,"13":"pero si es viuda o divorciada y no tiene hijos y vuelve a casa de su padre como estaba durante la juventud, podrá comer el alimento de su padre. Pero ningún extraño lo podrá comer."
,"14":"Si uno come por inadvertencia una cosa santa, restituirá al sacerdote su valor, más una quinta parte."
,"15":"Los laicos no profanarán las cosas santas que hayan ofrecido los israelitas al Señor."
,"16":"De otra manera, cargarían sobre ellos una falta que exigiría reparación, pues yo soy el Señor, que santifico sus ofrendas'."
,"17":"El Señor habló a Moisés:"
,"18":"'Di a Aarón, a sus hijos y a todos los israelitas: Cuando un israelita o extranjero residente quiera hacer una ofrenda voluntaria,"
,"19":"para que sea aceptada deberá presentar un animal macho sin defecto, vacuno, ovino o caprino."
,"20":"No ofreceréis animal defectuoso, pues no sería aceptado."
,"21":"De la misma manera, si uno ofrece al Señor ganado mayor o menor en sacrificio de reconciliación, sea en cumplimiento de un voto, sea como ofrenda voluntaria, la víctima, para que sea aceptada, ha de ser perfecta y sin defecto."
,"22":"Nunca ofreceréis al Señor animal ciego, cojo o mutilado, ulcerado, sarnoso o herpético, como ofrendas para ser quemadas sobre el altar en honor del Señor."
,"23":"Podrás presentar en calidad de ofrenda voluntaria ganado mayor o menor con miembros atrofiados o deformes, pero tales víctimas no serían aceptadas en cumplimiento de un voto."
,"24":"No ofreceréis al Señor animal que tenga los testículos aplastados, hundidos, cortados o arrancados; tales ofrendas no las haréis en vuestra tierra,"
,"25":"ni las aceptaréis tampoco de manos de un extranjero para ofrecerlas en alimento a vuestro Dios, pues están deformes y taradas y no serían aceptadas'."
,"26":"El Señor habló a Moisés:"
,"27":"'Cuando nace un becerro, un cordero o un cabrito, estarán siete días con su madre; a partir del día octavo podrán ser aceptados como ofrendas quemadas en honor del Señor."
,"28":"No inmolaréis en el mismo día ganado mayor o menor con sus crías."
,"29":"Cuando ofrezcáis al Señor un sacrificio de acción de gracias, lo haréis de manera que sea aceptado;"
,"30":"la víctima será comida el mismo día sin dejar nada para el día siguiente: yo, el Señor."
,"31":"Guardad mis mandamientos y ponedlos en práctica: yo, el Señor."
,"32":"No profanaréis mi santo nombre, para que sea yo santificado en medio de los israelitas: yo, el Señor, que os santifico."
,"33":"Yo os he sacado de Egipto para ser vuestro Dios: yo, el Señor'."
}`)
	CurrentBook.AddChapter(23, `{
"1":"El Señor habló a Moisés: 'Di a los israelitas:"
,"2":"Éstas son mis fiestas, las fiestas del Señor, las asambleas santas a las cuales convocaréis a los israelitas:"
,"3":"Durante seis días trabajaréis, pero el séptimo es sábado, día de descanso absoluto y de asamblea santa; no haréis en él trabajo alguno. Dondequiera que viváis, es día de descanso dedicado al Señor'."
,"4":"'Éstas son las fiestas del Señor, las asambleas santas, a las que convocaréis a los israelitas en las fechas establecidas."
,"5":"El día catorce del primer mes, al atardecer, es la pascua del Señor,"
,"6":"y el día quince del mismo mes es la fiesta de los panes sin levadura del Señor: durante siete días comeréis pan sin levadura."
,"7":"El primer día tendréis asamblea santa; no haréis trabajo alguno."
,"8":"Los siete días presentaréis al Señor ofrendas quemadas. El día séptimo será día de asamblea santa y no haréis en él trabajo alguno'."
,"9":"El Señor habló a Moisés:"
,"10":"'Di a los israelitas: Cuando hayáis entrado en la tierra que os doy y hagáis la recolección, llevaréis al sacerdote la primera gavilla de vuestra cosecha."
,"11":"El sacerdote la ofrecerá al Señor haciendo el rito de presentación para que sea aceptada: la ofrecerá el día siguiente del sábado,"
,"12":"y el día que hayáis presentado la gavilla presentaréis, como holocausto en honor del Señor, un cordero de un año sin defecto;"
,"13":"presentaréis también ocho kilos de flor de harina amasada en aceite como ofrenda quemada, perfume agradable al Señor; y como libación, dos litros de vino."
,"14":"No comeréis pan, espigas tostadas o granos triturados hasta ese día, en que presentéis la ofrenda a vuestro Dios. Es ley perpetua para vuestras generaciones dondequiera que viváis'."
,"15":"'A partir del día después del sábado, a saber, del día en que hayáis ofrecido la gavilla con el rito de presentación, contaréis siete semanas completas."
,"16":"Contaréis cincuenta días hasta el día siguiente al séptimo sábado, y entonces presentaréis al Señor una ofrenda de granos nuevos."
,"17":"Llevaréis de vuestra casa, para ofrecerlos con el rito de presentación, dos panes de ocho kilos de flor de harina cocidos con levadura. Son las primicias para el Señor."
,"18":"Junto con el pan, ofreceréis en holocausto al Señor siete corderos de un año sin defecto, un novillo y dos carneros con la ofrenda y las libaciones: es una ofrenda quemada, un perfume agradable en honor del Señor."
,"19":"Inmolaréis, además, un macho cabrío en sacrificio por el pecado, y dos corderos de un año en sacrificio de reconciliación."
,"20":"El sacerdote los ofrecerá con el rito de presentación delante del Señor, junto con el pan de las primicias. Los panes y los dos corderos son cosas consagradas al Señor y pertenecen al sacerdote."
,"21":"Aquel mismo día celebraréis asamblea santa y no haréis trabajo alguno. Es ley perpetua para vuestras generaciones dondequiera que viváis."
,"22":"Cuando hagáis la recolección de vuestros campos, no los segarás hasta la misma orilla, ni recogerás las espigas caídas; lo dejarás para el pobre y el extranjero: yo, el Señor, vuestro Dios'."
,"23":"El Señor habló a Moisés:"
,"24":"'Di a los israelitas: el día primero del séptimo mes será para vosotros día de descanso y de asamblea santa, convocada a son de trompeta."
,"25":"No haréis trabajo alguno y presentaréis una ofrenda quemada en honor del Señor'."
,"26":"El Señor habló a Moisés:"
,"27":"'El diez del mismo mes séptimo es el día del perdón; celebraréis asamblea santa y presentaréis una ofrenda quemada en honor del Señor."
,"28":"En ese día no haréis trabajo alguno, pues es el día del perdón, en que debe hacerse sobre vosotros el rito de absolución delante del Señor, vuestro Dios."
,"29":"El que no ayune ese día será extirpado de su pueblo."
,"30":"Igualmente, al que ese día haga algún trabajo, yo lo extirparé de su pueblo."
,"31":"No haréis trabajo alguno. Es ley perpetua para vuestras generaciones dondequiera que viváis."
,"32":"Será para vosotros día de descanso absoluto y dedicado al ayuno desde la tarde del día nueve hasta la tarde del día siguiente'."
,"33":"El Señor habló a Moisés:"
,"34":"'Di a los israelitas: El quince de este mes séptimo se celebrará durante siete días la fiesta de los tabernáculos en honor del Señor."
,"35":"El primer día es día de asamblea santa; no haréis en él trabajo alguno."
,"36":"Los siete días presentaréis ofrendas quemadas en honor del Señor; el día octavo celebraréis asamblea santa y presentaréis una ofrenda quemada en honor del Señor: es día de asamblea; no haréis en él trabajo alguno."
,"37":"Éstas son las fiestas del Señor, en las que celebraréis asambleas santas y presentaréis al Señor ofrendas quemadas, holocaustos, sacrificios de reconciliación, ofrendas y libaciones, según el ritual propio de cada día,"
,"38":"aparte de los sábados del Señor y de las ofrendas que hagáis al Señor en cumplimiento de una promesa o espontáneamente."
,"39":"El día quince del séptimo mes, cuando hayáis hecho la recolección de los frutos de la tierra, celebraréis la fiesta del Señor durante siete días; el día primero y el octavo serán días de descanso absoluto."
,"40":"El primer día tomaréis los mejores frutos, ramos de palmera, ramas de árboles frondosos, sauces de las riberas, y os regocijaréis durante siete días en presencia del Señor, vuestro Dios."
,"41":"Celebraréis la fiesta en honor del Señor durante siete días, año tras año. Es ley perpetua para vuestras sucesivas generaciones. Celebraréis esta fiesta en el séptimo mes;"
,"42":"durante los siete días viviréis en tiendas. Todos los israelitas vivirán en tiendas,"
,"43":"para que vuestros descendientes sepan que yo hice vivir en tiendas a los israelitas cuando los saqué de Egipto: yo, el Señor, vuestro Dios'."
,"44":"Así promulgó Moisés las fiestas del Señor a los israelitas."
}`)
	CurrentBook.AddChapter(24, `{
"1":"El Señor dijo a Moisés:"
,"2":"'Ordena a los israelitas que traigan aceite puro de olivas molidas, para alimentar permanentemente las lámparas."
,"3":"Aarón se encargará de arreglarlas para que ardan sin cesar día y noche en presencia del Señor, delante del velo del testimonio, en la tienda de la reunión. Es ley perpetua para vuestras sucesivas generaciones:"
,"4":"Aarón dispondrá las lámparas en el candelabro de oro puro para que ardan continuamente en presencia del Señor'."
,"5":"'Tomarás flor de harina, cocerás con ella doce panes de ocho kilos cada uno,"
,"6":"y los colocarás en dos hileras, seis panes en cada hilera, sobre la mesa pura delante del Señor."
,"7":"Pondrás incienso puro sobre cada una de las hileras; servirá de memorial en lugar del pan; será una ofrenda quemada en honor del Señor."
,"8":"Los panes serán renovados todos los sábados, sin dejar ninguno, en señal de pacto perpetuo por parte de los israelitas."
,"9":"Los panes serán para Aarón y sus hijos, que los comerán en lugar santo, porque son cosa santísima que les pertenece entre las ofrendas quemadas en honor del Señor. Es ley perpetua'."
,"10":"Un hombre, hijo de madre israelita y de padre egipcio, riñó un día en el campamento con un israelita."
,"11":"Blasfemó y maldijo el nombre del Señor. Su madre se llamaba Selomit, hija de Dibrí, de la tribu de Dan."
,"12":"Lo llevaron a Moisés y lo arrestaron hasta que se recibiera orden del Señor sobre lo que debía hacerse con él."
,"13":"El Señor dijo a Moisés:"
,"14":"'Saca del campamento al blasfemo, pongan sobre su cabeza las manos todos los que han oído la blasfemia, y sea matado a pedradas por toda la comunidad."
,"15":"Y dirás a los israelitas: El que maldiga a su Dios cargará con su pecado,"
,"16":"y el que blasfeme el nombre del Señor será castigado con la muerte; toda la comunidad lo apedreará. El que blasfeme el nombre del Señor morirá, tanto el extranjero como el indígena."
,"17":"El que hiera a otro mortalmente, sea quien sea, morirá irremisiblemente."
,"18":"El que hiera a una bestia mortalmente, la restituirá: animal por animal."
,"19":"El que maltrate a su prójimo será tratado de la misma manera;"
,"20":"fractura por fractura, ojo por ojo y diente por diente, es decir, recibirá lo mismo que él ha hecho al prójimo."
,"21":"El que mate una bestia, la pagará; y el que mate a un hombre, morirá."
,"22":"La misma justicia usaréis con el extranjero y con el indígena: yo, el Señor, vuestro Dios'."
,"23":"Moisés se lo comunicó a los israelitas, los cuales llevaron al blasfemo fuera del campamento y lo mataron a pedradas; hicieron como el Señor había mandado a Moisés."
}`)
	CurrentBook.AddChapter(25, `{
"1":"El Señor habló a Moisés en el monte Sinaí así:"
,"2":"'Di a los israelitas: Cuando hayáis entrado en la tierra que os voy a dar, la tierra gozará del descanso sabático en honor del Señor."
,"3":"Durante seis años sembrarás tu campo, podarás tu viña y vendimiarás sus frutos;"
,"4":"pero el séptimo año será año sabático para la tierra, en honor del Señor; no sembrarás tu campo, no podarás tu viña,"
,"5":"no segarás las mieses que hayan crecido espontáneamente ni vendimiarás tus viñas no cultivadas: será un año de descanso absoluto para la tierra."
,"6":"Lo que produzca la tierra durante su descanso os servirá de comida a ti, a tu siervo y a tu sierva, a tu jornalero y al extranjero residente, a los que viven contigo."
,"7":"Los productos de la tierra servirán igualmente de comida a tus ganados y a las bestias salvajes'."
,"8":"'Contarás siete semanas de años, o sea, siete por siete, cuarenta y nueve años."
,"9":"El día diez del mes séptimo, el día del perdón, harás que resuene la trompeta por todo el país."
,"10":"Declararéis santo el año cincuenta y proclamaréis la liberación a todos los habitantes de la tierra. Será para vosotros año jubilar; cada uno de vosotros recobrará su propiedad y retornará a su familia."
,"11":"El año cincuenta será para vosotros año jubilar; no sembraréis, no segaréis las mieses crecidas espontáneamente ni vendimiaréis las viñas no cultivadas,"
,"12":"pues es año jubilar, que será santo para vosotros; en él comeréis los frutos espontáneos de los campos."
,"13":"En el año jubilar volverá cada uno a sus propiedades."
,"14":"Cuando vendáis o compréis alguna cosa a vuestro prójimo, nadie engañe a su hermano."
,"15":"Comprarás a tu prójimo en proporción al número de años transcurridos después del jubileo, y en razón de los años de cosecha que le quedan te fijará él el precio de venta;"
,"16":"cuantos más años queden, más le pagarás; cuantos menos queden, menos le pagarás, porque es un determinado número de cosechas lo que te vende."
,"17":"Nadie engañe a su prójimo. Temed a vuestro Dios: yo, el Señor, vuestro Dios."
,"18":"Obedeceréis mis leyes, observaréis mis preceptos poniéndolos en práctica y habitaréis seguros en la tierra."
,"19":"La tierra dará sus frutos, comeréis de ellos a saciedad y habitaréis seguros en ella."
,"20":"Si preguntáis: ¿Qué comeremos el séptimo año sin haber sembrado ni segado nuestras mieses?"
,"21":"Yo os enviaré mi bendición el sexto año, de suerte que la tierra produzca frutos para tres años."
,"22":"Cuando vayáis a sembrar en el año octavo, tendréis todavía reservas de la cosecha anterior; hasta el año noveno en que llegue la nueva cosecha, tendréis reservas de la vieja'."
,"23":"'Las tierras no se podrán vender a perpetuidad y sin limitación, porque la tierra es mía y vosotros sois en lo mío extranjeros residentes."
,"24":"Por tanto, en todo el territorio que ocupáis, las tierras conservarán el derecho de rescate."
,"25":"Si tu hermano empobrece y tiene que vender su propiedad, su pariente más cercano, sobre el que recae el derecho de rescate, podrá venir a rescatar lo vendido por su hermano."
,"26":"El que no tuviere rescatador, podrá él mismo, cuando haya encontrado con qué hacer el rescate,"
,"27":"rescatar la propiedad descontando los años desde la venta y abonando al comprador los años que queden hasta el vencimiento de la misma."
,"28":"Si no encuentra con qué hacer el rescate, la propiedad vendida quedará en poder del comprador hasta el año del jubileo; entonces el vendedor entrará de nuevo en su posesión."
,"29":"Si uno vende una casa en una ciudad amurallada, tendrá derecho de rescate durante un año a partir de la venta; su derecho de rescate dura un año."
,"30":"Si no se ha hecho el rescate dentro del año, esta casa, enclavada dentro de una ciudad amurallada, será para siempre del comprador y de sus descendientes; no perderán la propiedad ni siquiera el año del jubileo."
,"31":"Las casas del pueblo no amurallado serán consideradas como propiedades rústicas; gozarán del derecho de rescate y quedarán libres el año del jubileo."
,"32":"En cuanto a las ciudades de los levitas y las casas que éstos poseen en ellas, conservan siempre el derecho de rescate."
,"33":"Cuando la casa de un levita no es rescatada, si ha sido vendida en una de las ciudades de su propiedad, saldrá libre en el jubileo porque las casas de las ciudades levíticas son propiedad suya en medio de los israelitas."
,"34":"Igualmente los campos anejos a sus ciudades no podrán ser vendidos, porque son propiedad suya a perpetuidad."
,"35":"Si un hermano tuyo ha contraído una deuda contigo y no tiene con qué pagar, lo sostendrás a título de huésped o inquilino, de manera que pueda vivir contigo."
,"36":"No le exigirás prestación personal ni intereses; antes bien, temerás a tu Dios y permitirás a tu hermano vivir contigo."
,"37":"No le prestarás dinero a interés ni le darás víveres a usura:"
,"38":"yo, el Señor, vuestro Dios, que os saqué de Egipto para daros la tierra de Canaán y ser vuestro Dios."
,"39":"Si un hermano tuyo ha contraído una deuda contigo y se vende a ti, no le tratarás como esclavo;"
,"40":"será para ti como un jornalero o un huésped, y estará a tu servicio hasta el año jubilar."
,"41":"Entonces saldrá de tu casa él y sus hijos; volverá a su familia y recobrará de nuevo la propiedad de sus padres."
,"42":"Porque son siervos míos que yo saqué de Egipto, y no deben ser vendidos como se vende un esclavo."
,"43":"No ejercerás tu dominio sobre él arbitrariamente, sino que temerás a tu Dios."
,"44":"Compraréis esclavos de las naciones vecinas; en éstas podréis adquirir esclavos y esclavas."
,"45":"Podréis adquirirlos también entre los extranjeros que viven en medio de vosotros, entre sus familias y entre los hijos que hayan tenido en vuestra tierra; éstos serán vuestra propiedad"
,"46":"y los podréis dejar en herencia a vuestros hijos, después de vosotros, para que los posean a título de propiedad perpetua como esclavos vuestros. En cuanto a vuestros hermanos, los israelitas, ninguno tratará con dureza a los demás."
,"47":"Si el huésped o extranjero residente en medio de ti se enriquece, y un hermano tuyo empobrece contrayendo deuda con aquél y se ve obligado a venderse al huésped o al extranjero o a un descendiente de su familia,"
,"48":"gozará del derecho de rescate una vez vendido; uno de sus hermanos,"
,"49":"su tío, su primo o un pariente cercano, lo podrá rescatar; y si llega a tener medios, puede rescatarse a sí mismo."
,"50":"Contará, de acuerdo con el comprador, los años que median entre la venta y el año jubilar y, de acuerdo con el número de éstos, se computará el precio de venta, valorando su tiempo de servicio como el de un jornalero."
,"51":"Si faltan todavía muchos años, pagará su rescate teniendo en cuenta el número de éstos y el precio que recibió por venderse."
,"52":"Si quedan pocos años para el jubileo, de acuerdo con ellos calculará y pagará su rescate."
,"53":"Será considerado como un jornalero que se ajusta por año de trabajo. No permitirás que se le trate con dureza delante de tus ojos."
,"54":"Si no hubiera sido rescatado de ninguna de estas maneras, saldrá libre el año del jubileo junto con sus hijos."
,"55":"Porque los israelitas me pertenecen como siervos; son mis siervos que yo saqué de Egipto: yo, el Señor, vuestro Dios'."
}`)
	CurrentBook.AddChapter(26, `{
"1":"'No os hagáis ídolos, no os alcéis estatuas o estelas ni pongáis en vuestra tierra piedras esculpidas para postraros ante ellas, porque yo soy el Señor, vuestro Dios."
,"2":"Guardaréis mis sábados y veneraréis mi santuario: yo, el Señor."
,"3":"Si seguís mis leyes y guardáis mis mandamientos poniéndolos en práctica,"
,"4":"os daré a su debido tiempo la lluvia necesaria, la tierra producirá sus frutos, los árboles de los campos darán los suyos;"
,"5":"la trilla se prolongará hasta la vendimia y la vendimia hasta la siembra; comeréis vuestro pan a saciedad y viviréis seguros en vuestra tierra."
,"6":"Habrá paz en el país y nadie turbará vuestro sueño. Haré desaparecer de en medio de vosotros a los animales dañinos, y la espada enemiga no pasará vuestras fronteras."
,"7":"Perseguiréis a vuestros enemigos, y éstos caerán a espada ante vosotros."
,"8":"Cinco de los vuestros perseguirán a ciento, ciento pondrán en fuga a diez mil y vuestros enemigos caerán a espada ante vosotros."
,"9":"Yo me volveré hacia vosotros, os haré crecer y multiplicaros y mantendré mi alianza con vosotros."
,"10":"Comeréis de lo almacenado, e incluso os veréis obligados a sacarlo de vuestros graneros para hacer sitio a lo nuevo."
,"11":"Estableceré mi morada en medio de vosotros y nunca os aborreceré."
,"12":"Marcharé en medio de vosotros, seré vuestro Dios y vosotros seréis mi pueblo."
,"13":"Yo, el Señor, vuestro Dios, que os saqué de Egipto para que no fueseis esclavos allí, rompí las coyundas de vuestro yugo y os hice salir con la cabeza erguida'."
,"14":"'Pero si no me obedecéis y no ponéis en práctica todos mis mandamientos;"
,"15":"si despreciáis mis leyes, desdeñáis mis prescripciones, no ponéis por obra mis mandatos y rompéis mi alianza,"
,"16":"yo me portaré con vosotros de la misma manera; haré venir sobre vosotros el espanto, epidemia y fiebre, enfermedades de los ojos y agotamiento de la vida. Sembraréis en vano, pues los enemigos comerán el fruto de vuestras semillas."
,"17":"Me volveré contra vosotros, y seréis vencidos por vuestros enemigos; éstos os dominarán, y huiréis aunque nadie os persiga."
,"18":"Si todavía no me obedecéis, multiplicaré por siete mis castigos por vuestros pecados;"
,"19":"haré pedazos vuestra fuerza orgullosa, haré vuestro cielo duro como el hierro y vuestra tierra dura como el bronce."
,"20":"Se empleará en vano vuestra fuerza, pues la tierra no producirá nada y los árboles del campo no darán sus frutos."
,"21":"Si todavía seguís obstinados contra mí y no me queréis obedecer, multiplicaré siete veces más mis castigos por vuestros pecados;"
,"22":"enviaré contra vosotros fieras salvajes, que devorarán a vuestros hijos, destrozarán vuestros ganados y os diezmarán hasta el punto de quedar desiertos vuestros caminos."
,"23":"Si a pesar de ello no os corregís y seguís obstinados contra mí,"
,"24":"yo me obstinaré también contra vosotros y multiplicaré de nuevo por siete mis castigos por vuestros pecados;"
,"25":"haré venir contra vosotros la espada, que vengará la alianza. Os refugiaréis en vuestras ciudades, pero yo haré caer sobre vosotros la peste y seréis entregados en manos del enemigo."
,"26":"Cuando yo retire el sustento de pan, diez mujeres bastarán para cocer el pan en un solo horno y os lo darán tasado, de manera que comeréis y no quedaréis satisfechos."
,"27":"Si a pesar de esto no me obedecéis y seguís todavía obstinados contra mí,"
,"28":"yo me obstinaré con furor contra vosotros y multiplicaré por siete una vez más mis castigos por vuestros pecados."
,"29":"Os comeréis a vuestros hijos y a vuestras hijas."
,"30":"Destruiré vuestras colinas idolátricas, destrozaré los altares de vuestros perfumes, amontonaré vuestros cadáveres sobre los cadáveres de vuestros ídolos y os aborreceré."
,"31":"Convertiré en desiertos vuestras ciudades, devastaré vuestros santuarios y no aspiraré más el aroma de vuestros sacrificios."
,"32":"Yo mismo arrasaré la tierra, y hasta vuestros enemigos se quedarán estupefactos cuando vengan a habitarla."
,"33":"A vosotros os dispersaré entre las naciones y os perseguiré con la espada desenvainada. Vuestra tierra será una desolación y vuestras ciudades un montón de ruinas."
,"34":"Entonces la tierra disfrutará de sus descansos sabáticos mientras dure su desolación y vosotros estéis en tierra de vuestros enemigos. Entonces podrá la tierra descansar y recuperar sus sábados."
,"35":"Durante todo el tiempo de su desolación tendrá el descanso que no tuvo en los días de sábado, cuando vosotros vivíais en ella."
,"36":"A vuestros supervivientes les infundiré tal espanto en sus corazones cuando se encuentren en la tierra de sus enemigos, que el movimiento de una hoja los espantará, los hará huir, como se huye delante de la espada, y caerán sin que nadie los persiga."
,"37":"Tropezarán y caerán unos sobre otros, como cuando se huye delante de la espada, sin que sean en realidad perseguidos. No podréis resistir ante vuestros enemigos,"
,"38":"pereceréis entre las naciones y el país de vuestros enemigos acabará con vosotros."
,"39":"Los supervivientes perecerán en tierra enemiga a causa de las propias iniquidades y las de sus padres."
,"40":"Reconocerán sus iniquidades y las de sus padres, las infidelidades contra mí y la oposición que me hicieron,"
,"41":"por lo que yo también me opuse a ellos y los llevé a tierra enemiga. Entonces humillarán su corazón incircunciso y el castigo quedará satisfecho."
,"42":"Yo me acordaré de mi pacto con Jacob, de mi pacto con Isaac, de mi pacto con Abrahán; me acordaré de la tierra."
,"43":"Cuando ellos hayan abandonado la tierra, ésta disfrutará de sus sábados durante el tiempo de su desolación; ellos sufrirán su castigo por haber despreciado mis mandamientos y haber aborrecido mis leyes."
,"44":"A pesar de todo, cuando estén en la tierra de sus enemigos, yo no los rechazaré ni los aborreceré hasta el punto de aniquilarlos y romper mi alianza con ellos, porque yo soy el Señor, su Dios."
,"45":"Me acordaré, en favor suyo, de la alianza que hice con sus antepasados, cuando los saqué de Egipto a los ojos de las naciones para ser su Dios: yo, el Señor'."
,"46":"Éstos son los mandamientos, prescripciones y leyes que estableció el Señor entre él y los israelitas en el monte Sinaí por medio de Moisés."
}`)
	CurrentBook.AddChapter(27, `{
"1":"El Señor habló a Moisés:"
,"2":"'Di a los israelitas: Si alguno quiere pagar un voto que haya hecho al Señor por el valor de una persona, su valoración será la siguiente:"
,"3":"el hombre entre veinte y sesenta años, seiscientos gramos de plata, según el peso del santuario;"
,"4":"la mujer, trescientos setenta gramos;"
,"5":"el joven entre los cinco y los veinte años, doscientos cuarenta gramos, y la joven de la misma edad, ciento veinte gramos;"
,"6":"el niño entre un mes y cinco años, sesenta gramos, y la niña, treinta y seis gramos de plata;"
,"7":"de sesenta años para arriba, el hombre ciento ochenta gramos, y la mujer ciento veinte gramos."
,"8":"Si el que hizo el voto es tan pobre que no puede pagar la suma, se presentará al sacerdote, que hará una estimación proporcionada a las posibilidades del interesado'."
,"9":"'Si el voto se refiere a animales que pueden ser presentados como ofrenda al Señor, entonces todo animal ofrecido en voto al Señor es sagrado;"
,"10":"no se podrá cambiar o reemplazar ni uno bueno por uno malo ni uno malo por otro bueno; si un animal es cambiado por otro, los dos se hacen sagrados."
,"11":"Si se trata de animales impuros, que no pueden ser presentados como ofrenda al Señor, cualquiera que sea el animal, será llevado al sacerdote,"
,"12":"que hará la estimación, según sea bueno o malo; habrá que atenerse a la estimación del sacerdote;"
,"13":"si lo quiere rescatar, se añadirá una quinta parte más al valor estimado'."
,"14":"'Si uno consagra su casa al Señor, el sacerdote hará la estimación de ésta, según sea de mucho o poco valor; y habrá que atenerse a la estimación del sacerdote;"
,"15":"pero si quiere rescatar la casa, añadirá una quinta parte más al valor estimado, y la recuperará'."
,"16":"'Si uno consagra al Señor alguna de las tierras de su patrimonio, la valoración será proporcional a su producción, a razón de seiscientos gramos de plata por cuatrocientos cincuenta kilos de cebada."
,"17":"Si consagra el campo durante el año jubilar, se atendrá a esta valoración;"
,"18":"pero si lo consagra después del jubileo, el sacerdote hará su valoración según el número de años que queden hasta el año jubilar, con la correspondiente reducción."
,"19":"Si quiere rescatar el campo, añadirá una quinta parte más al valor estimado, y lo recuperará."
,"20":"Si no lo rescata y lo vende a otro, se pierde el derecho de rescate;"
,"21":"cuando quede libre en el año del jubileo, será consagrado al Señor como campo votivo y pasará a ser propiedad del sacerdote."
,"22":"Si uno consagra al Señor un campo comprado por él, que no forma parte de su patrimonio,"
,"23":"el sacerdote calculará el precio de estimación por los años que falten hasta el jubileo, y el hombre pagará aquel mismo día el precio fijado a título de cosa consagrada al Señor."
,"24":"El año del jubileo, el campo volverá a su vendedor inicial, al cual pertenecía como heredad de la tierra."
,"25":"Toda valoración será hecha según el peso del santuario, que es de doce gramos cada unidad'."
,"26":"'Nadie podrá consagrar los primogénitos de su ganado, pues por derecho pertenecen ya al Señor; sea ganado mayor o menor, sus primogénitos son del Señor."
,"27":"Pero si se trata de animales impuros, serán rescatados al precio que se valoren, más una quinta parte; si no fuera rescatado, será vendido al precio que se haya valorado."
,"28":"Ninguna cosa de su propiedad -hombres, animales o campos de propiedad hereditaria- que uno consagre al Señor podrá ser vendida o rescatada. Lo que se consagra al Señor es cosa santísima y pertenece al Señor."
,"29":"Ninguna persona consagrada al Señor podrá ser rescatada; tendrá que morir."
,"30":"La décima parte de los productos de la tierra, tanto de los productos del campo como de los frutos de los árboles, pertenece al Señor; es cosa consagrada al Señor."
,"31":"Si uno quiere rescatar algo de esa décima parte, añadirá una quinta parte más de su valor."
,"32":"Uno de cada diez animales del ganado mayor y menor será consagrado al Señor."
,"33":"No se escogerá entre lo bueno o lo malo, ni se podrá cambiar uno por otro; si se cambia, tanto el primer animal como el animal dado a cambio quedarán consagrados sin posibilidad de rescate'."
,"34":"Éstos son los mandamientos que el Señor dio a los israelitas en el monte Sinaí por medio de Moisés."
}`)

}
func ES_LSB_LoadVPNMChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"El día uno del segundo mes del segundo año de la salida de Egipto, en el desierto del Sinaí, en la tienda de la reunión, el Señor dijo a Moisés:"
,"2":"'Haz un censo general de toda la comunidad israelita por clanes y por familias, anotando uno a uno los nombres de todos los varones."
,"3":"Entre los mayores de veinte años registraréis tú y Aarón, por escuadras, a todos los aptos para la guerra en Israel."
,"4":"Os ayudará en este trabajo un hombre por cada tribu, jefe de familia."
,"5":"Éstos son los nombres de los que os han de ayudar: Por Rubén: Elisur, hijo de Sedeur."
,"6":"Por Simeón: Selumiel, hijo de Surisaday."
,"7":"Por Judá: Nasón, hijo de Aminadab."
,"8":"Por Isacar: Natanael, hijo de Suar."
,"9":"Por Zabulón: Eliab, hijo de Jelón."
,"10":"Por los hijos de José: por Efraín: Elisamá, hijo de Amihud. Por Manasés: Gamaliel, hijo de Pedasur."
,"11":"Por Benjamín: Abidán, hijo de Gedeoní."
,"12":"Por Dan: Ajiezer, hijo de Amisaday."
,"13":"Por Aser: Pagiel, hijo de Ocrán."
,"14":"Por Gad: Eliasaf, hijo de Deuel."
,"15":"Por Neftalí: Ajirá, hijo de Enán'."
,"16":"Éstos eran los delegados de la comunidad, los responsables de sus tribus, jefes de millar en Israel."
,"17":"Moisés y Aarón tomaron consigo a estos hombres que habían sido designados personalmente,"
,"18":"reunieron a toda la comunidad el día primero del segundo mes e hicieron el censo por clanes y familias, registrando a todos los varones de veinte años para arriba uno por uno."
,"19":"Tal como el Señor había ordenado a Moisés, así se hizo el censo en el desierto del Sinaí."
,"20":"Hecho el censo de la tribu de Rubén, primogénito de Israel, por clanes y familias, y registrados uno por uno, según sus nombres, todos los varones de veinte años para arriba, aptos para la guerra,"
,"21":"se registraron 46.500."
,"22":"De la tribu de Simeón,"
,"23":"se registraron 59.300."
,"24":"De la tribu de Gad,"
,"25":"se registraron 45.650."
,"26":"De la tribu de Judá,"
,"27":"se registraron 74.600."
,"28":"De la tribu de Isacar,"
,"29":"se registraron 54.400."
,"30":"De la tribu de Zabulón,"
,"31":"se registraron 57.400."
,"32":"De la tribu de José, por Efraín,"
,"33":"se registraron 40.500."
,"34":"De la tribu de José, por Manasés,"
,"35":"se registraron 32.200."
,"36":"De la tribu de Benjamín,"
,"37":"se registraron 35.400."
,"38":"De la tribu de Dan,"
,"39":"se registraron 62.700."
,"40":"De la tribu de Aser,"
,"41":"se registraron 41.500."
,"42":"De la tribu de Neftalí,"
,"43":"se registraron 53.400."
,"44":"Éste es el total registrado por Moisés, Aarón y los doce jefes de Israel, uno por cada tribu."
,"45":"Según este censo, hecho por familias, todos los israelitas de veinte años para arriba aptos para la guerra"
,"46":"resultaron ser 603.550 hombres."
,"47":"Los levitas no fueron registrados con los demás."
,"48":"El Señor dijo a Moisés:"
,"49":"'Sólo excluirás del censo a la tribu de Leví; no los contarás entre los israelitas,"
,"50":"sino que a los levitas les encargarás el servicio de la tienda de la alianza, de todo su mobiliario y de todo cuanto le pertenece: llevarán la tienda y su mobiliario, estarán dedicados a su servicio y acamparán a su alrededor."
,"51":"Cuando la tienda deba ser trasladada, los levitas la desmontarán; y cuando deba pararse, la instalarán ellos también. El laico que se acerque a la tienda morirá."
,"52":"Los israelitas plantarán sus tiendas cada uno en su campo, bajo el propio estandarte, por orden de escuadras."
,"53":"Pero los levitas acamparán alrededor de la tienda de la alianza para que la cólera no estalle contra la comunidad israelita'."
,"54":"Los israelitas hicieron todo exactamente como el Señor había ordenado a Moisés."
}`)
	CurrentBook.AddChapter(2, `{
"1":"El Señor dijo a Moisés y Aarón:"
,"2":"'Los israelitas acamparán cada uno junto a su bandera, bajo las enseñas de sus familias, alrededor de la tienda de la reunión, a cierta distancia."
,"3":"Al este, los que están agrupados bajo la bandera de Judá. Su jefe será Nasón, hijo de Aminadab;"
,"4":"su ejército cuenta con 74.600 hombres según el censo."
,"5":"Cerca de Judá acamparán: la tribu de Isacar. Su jefe será Natanael, hijo de Suar;"
,"6":"su ejército cuenta con 54.400 hombres según el censo."
,"7":"La tribu de Zabulón. Su jefe será Eliab, hijo de Jelón;"
,"8":"su ejército cuenta con 57.400 hombres según el censo."
,"9":"El total del campamento de Judá, dividido por escuadras, es de 186.400 hombres. Serán los primeros que se pongan en marcha."
,"10":"Al sur acamparán los que están agrupados bajo la bandera de Rubén. El jefe de los hijos de Rubén será Elisur, hijo de Sedeur;"
,"11":"su ejército cuenta con 46.500 hombres según el censo."
,"12":"Cerca de Rubén acamparán: la tribu de Simeón. Su jefe será Selumiel, hijo de Surisaday;"
,"13":"su ejército cuenta con 59.300 hombres según el censo."
,"14":"La tribu de Gad. Su jefe será Eliasaf, hijo de Deuel;"
,"15":"su ejército cuenta con 45.650 hombres según el censo."
,"16":"El total del campamento de Rubén, dividido por escuadras, es de 151.450 hombres. Se pondrán en marcha los segundos."
,"17":"Entonces partirá la tienda de la reunión, ya que el campo de los levitas se encuentra en medio de los demás campamentos. Seguirán en la marcha el orden de acampamiento, cada uno bajo su bandera."
,"18":"Al oeste acamparán los que están agrupados bajo la bandera de Efraín. El jefe de los hijos de Efraín será Elisamá, hijo de Amihud;"
,"19":"su ejército cuenta con 40.500 hombres según el censo."
,"20":"Cerca de Efraín acamparán: la tribu de Manasés. Su jefe será Gamaliel, hijo de Pedasur;"
,"21":"su ejército cuenta con 32.200 hombres según el censo."
,"22":"La tribu de Benjamín. Su jefe será Abidán, hijo de Gedeoní,"
,"23":"y su ejército cuenta con 35.400 hombres según el censo."
,"24":"El total del campamento de Efraín, dividido por escuadras, es de 108.100 hombres. Se pondrán en marcha los terceros."
,"25":"Al norte acamparán los que están agrupados bajo la bandera de Dan. Su jefe será Ajiezer, hijo de Amisaday;"
,"26":"su ejército cuenta con 62.700 hombres según el censo."
,"27":"Cerca de Dan acamparán: la tribu de Aser. Su jefe será Pagiel, hijo de Ocrán;"
,"28":"su ejército cuenta con 41.500 hombres según el censo."
,"29":"La tribu de Neftalí. Su jefe será Ajirá, hijo de Enán;"
,"30":"su ejército cuenta con 53.400 hombres según el censo."
,"31":"El total del campamento de Dan es de 157.600 hombres. Se pondrán en marcha los últimos tras sus banderas."
,"32":"Éste es el censo de los israelitas por familias. El total de todos los hombres registrados, repartidos en varios campamentos, según sus cuerpos de ejército, fue de 603.550."
,"33":"Tal como el Señor había ordenado a Moisés, los levitas no fueron contados en el censo con los demás."
,"34":"Los israelitas hicieron todo exactamente como el Señor había ordenado a Moisés. Acampaban por banderas y se ponían en marcha por clanes y familias."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Éstos son los descendientes de Aarón y de Moisés por el tiempo en que el Señor habló a Moisés en el monte Sinaí."
,"2":"Hijos de Aarón: Nadab, el primogénito, y luego Abihú, Eleazar e Itamar."
,"3":"Tales son los nombres de los hijos de Aarón, sacerdotes ungidos y consagrados para ejercer el sacerdocio."
,"4":"Nadab y Abihú murieron en presencia del Señor, en el desierto del Sinaí, cuando intentaron ofrecerle fuego profano. No tuvieron hijos. Entonces Eleazar e Itamar ejercieron el sacerdocio en vida de su padre Aarón."
,"5":"El Señor dijo a Moisés:"
,"6":"'Llama a la tribu de Leví para que asista al sacerdote Aarón y se ponga a su servicio."
,"7":"Estarán a su servicio y al servicio de toda la comunidad, delante de la tienda de la reunión, y se encargarán del servicio de la tienda."
,"8":"Se cuidarán de todo el mobiliario de la tienda de la reunión y estarán al servicio de los israelitas en todo lo que se refiere a la tienda."
,"9":"Aparta a los levitas y dáselos a Aarón y a sus hijos para que les pertenezcan como donados de parte de los israelitas."
,"10":"A Aarón y a sus hijos les asignarás las funciones del sacerdocio, y cualquier extraño que se entrometa será castigado con la muerte'."
,"11":"El Señor dijo a Moisés:"
,"12":"'Ya ves que he elegido a los levitas de entre los israelitas en sustitución de todos los primogénitos, de todos los que abren el seno materno; los levitas son, pues, míos,"
,"13":"ya que mío es todo primogénito. El día en que hice morir a todos los primogénitos de Egipto consagré para mí a todos los primogénitos de Israel, tanto de hombres como de animales. Son míos. Yo, el Señor'."
,"14":"El Señor dijo a Moisés en el desierto del Sinaí:"
,"15":"'Haz el censo de los hijos de Leví, por familias y clanes, contando todos los varones que tengan más de un mes'."
,"16":"Moisés lo hizo como el Señor le había mandado."
,"17":"Los hijos de Leví: Guersón, Quehat y Merarí."
,"18":"Hijos de Guersón por clanes: Libní y Semeí;"
,"19":"hijos de Quehat por clanes: Amrán, Yishar, Hebrón y Uziel;"
,"20":"hijos de Merarí por clanes: Majlí y Musí. Tales son los clanes de Leví por familias."
,"21":"Clanes de Guersón: el clan de Libní y el de Semeí."
,"22":"El número total de varones registrados mayores de un mes fue de 7.500."
,"23":"Los clanes guersonitas acampaban detrás de la tienda, al oeste."
,"24":"El jefe de la casa de Guersón era Eliasaf, hijo de Lael."
,"25":"El oficio de los hijos de Guersón, con relación a la tienda de la reunión, era cuidar de la morada, de la tienda y su cubierta, de la portezuela de la entrada,"
,"26":"de las cortinas del atrio, de la portezuela de entrada al atrio, que rodea la morada y el altar, y de las cuerdas necesarias para todo el servicio."
,"27":"Clanes de Quehat: el clan de Amrán, el de Yishar, el de Hebrón y el de Uziel."
,"28":"El número total de varones registrados mayores de un mes fue de 8.300. Éstos estaban encargados del santuario."
,"29":"Los clanes quehatitas acampaban del lado sur de la tienda."
,"30":"El jefe de la casa de los clanes quehatitas era Elisafán, hijo de Uziel."
,"31":"Tenían a su cargo el arca, la mesa, el candelabro, los altares, los objetos sagrados para el culto, la cortina y todo su servicio."
,"32":"El primero entre los jefes de Leví era Eleazar, hijo de Aarón, sacerdote. Ejercía la superintendencia sobre los adscritos al servicio del santuario."
,"33":"Clanes de Merarí: el clan de Majlí y el de Musí."
,"34":"El número total de varones registrados mayores de un mes fue de 6.200."
,"35":"El jefe de la casa de los clanes meraritas era Suriel, hijo de Abijail. Acampaban al lado norte de la tienda."
,"36":"Los hijos de Merarí estaban encargados de los tablones de la tienda, de sus barras, columnas, basas, de todos sus accesorios con todo su servicio,"
,"37":"así como de las columnas que rodeaban el atrio, sus basas, clavos y cuerdas."
,"38":"Delante de la tienda de la reunión, al lado este, acampaban Moisés, Aarón y sus hijos, que tenían cuidado del santuario en nombre de los israelitas. Todo extraño que se acercaba era castigado con la muerte."
,"39":"El censo total de levitas registrados por Moisés, según la orden del Señor, contando por familias todos los varones mayores de un mes, fue de 22.000."
,"40":"El Señor dijo a Moisés: 'Haz el censo de todos los primogénitos varones de los israelitas mayores de un mes y registra sus nombres;"
,"41":"reservarás para mí los levitas, en sustitución de todos los primogénitos de los israelitas, y el ganado de los levitas, en sustitución de los primogénitos del ganado de los israelitas. Yo, el Señor'."
,"42":"Moisés hizo el censo de todos los primogénitos de los israelitas según la orden que le había dado el Señor."
,"43":"El total de primogénitos varones registrados por sus nombres, mayores de un mes, fue de 22.273."
,"44":"El Señor dijo a Moisés:"
,"45":"'Resérvame a los levitas en sustitución de todos los primogénitos de los israelitas, y el ganado de los levitas en sustitución de los primogénitos de sus ganados. Los levitas serán míos. Yo, el Señor."
,"46":"Por el rescate de los 273 primogénitos de los israelitas, que sobrepasan el número de levitas,"
,"47":"tomarás cinco monedas de plata por cabeza, según la unidad oficial del santuario, que es de doce gramos."
,"48":"Darás el dinero a Aarón y a sus hijos como rescate de los que sobrepasan el número de los levitas'."
,"49":"Moisés tomó el dinero de los primogénitos de los israelitas que sobrepasaban el número de los levitas."
,"50":"Tomó el dinero de los primogénitos de los israelitas, 1.365 monedas de plata conforme al peso oficial del santuario."
,"51":"Moisés entregó el dinero del rescate a Aarón y a sus hijos, tal como el Señor le había ordenado."
}`)
	CurrentBook.AddChapter(4, `{
"1":"El Señor dijo a Moisés y Aarón:"
,"2":"'Haz el censo de los levitas descendientes de Quehat por clanes y familias,"
,"3":"de treinta a cincuenta años, aptos para hacer su servicio en la tienda de la reunión."
,"4":"El servicio de los descendientes de Quehat en la tienda de la reunión será cuidar de las cosas más santas."
,"5":"Cuando haya que levantar el campamento, Aarón y sus hijos desmontarán el velo y cubrirán con él el arca de la alianza."
,"6":"Pondrán encima una cubierta de pieles de tejón curtidas, sobre la que extenderán a su vez una tela morada, y luego colocarán las barras para transportarla."
,"7":"Extenderán una tela morada sobre la mesa de los panes de la proposición, sobre la que pondrán los platos, las copas, las cazoletas y los vasos de las libaciones. El pan de la ofrenda perpetua estará también allí."
,"8":"Extenderán encima una tela de carmesí, que recubrirán con una funda de pieles de tejón. Y luego colocarán las barras de la mesa."
,"9":"Tomarán una tela morada, con la que cubrirán el candelabro, sus lámparas, despabiladeras, ceniceros y aceiteras para alimentarlo."
,"10":"Lo meterán todo con sus accesorios en una funda de pieles de tejón y lo colocarán sobre unas parihuelas."
,"11":"Extenderán una tela morada sobre el altar de oro y, después de recubrirlo todo con pieles de tejón, le pondrán las barras."
,"12":"Tomarán todos los objetos usados en el servicio del santuario y los pondrán sobre una tela morada; los recubrirán con pieles de tejón y los colocarán sobre unas parihuelas."
,"13":"Quitarán las cenizas del altar y lo recubrirán con un paño de púrpura escarlata,"
,"14":"sobre el que pondrán todos los utensilios de su servicio; los braseros, los tenedores, las paletas y las bandejas, todos los utensilios del altar, y lo cubrirán con pieles de tejón y le pondrán las barras."
,"15":"Cuando Aarón y sus hijos hayan acabado de cubrir el santuario y todo su mobiliario, en el momento de levantar el campamento vendrán los descendientes de Quehat para llevarlos, pero sin tocar las cosas sagradas, no sea que mueran. Éste es el oficio de los descendientes de Quehat en la tienda de la reunión."
,"16":"Eleazar, hijo de Aarón, sacerdote, tendrá el encargo del aceite del candelabro, del perfume aromático, de la ofrenda perpetua y del aceite de la unción. Deberá, además, vigilar sobre toda la tienda y lo que hay en ella: las cosas sagradas y sus utensilios'."
,"17":"El Señor dijo a Moisés y Aarón:"
,"18":"'No permitáis que desaparezcan del número de levitas la tribu y los clanes de Quehat."
,"19":"Haced lo posible para que vivan y no mueran acercándose a las cosas santas; sean Aarón y sus hijos los que entren para designar a cada uno su servicio y su cargo."
,"20":"Ellos, que no entren ni siquiera para ver un solo instante las cosas santas, no sea que mueran'."
,"21":"El Señor dijo a Moisés:"
,"22":"'Haz también el censo de los descendientes de Guersón por familias y clanes;"
,"23":"registrarás todos los hombres de treinta a cincuenta años, aptos para hacer su servicio en la tienda de la reunión."
,"24":"Éste es el servicio que habrán de hacer los clanes guersonitas, sus funciones y sus cargos:"
,"25":"llevarán las cortinas de la morada, la tienda de la reunión con su cubierta y la cubierta de pieles de tejón que la recubre;"
,"26":"las cortinas del atrio, la portezuela de entrada del atrio que rodea la tienda y el altar, las cuerdas y todos los accesorios necesarios para su servicio. Y harán con ellos todo lo que sea necesario."
,"27":"Este servicio de los descendientes de Guersón, sus funciones y sus cargos, se llevará a cabo bajo las órdenes de Aarón y de sus hijos; vosotros debéis vigilar el cumplimiento de sus obligaciones."
,"28":"Éste será el servicio de los clanes guersonitas en la tienda de la reunión. Su ministerio estará bajo la vigilancia del sacerdote Itamar, hijo de Aarón'."
,"29":"'Haz el censo de los hijos de Merarí por clanes y familias."
,"30":"Registrarás todos los hombres de treinta a cincuenta años, aptos para hacer su servicio en la tienda de la reunión."
,"31":"Esto es lo que han de cuidar y transportar en la tienda de la reunión: los tablones de la tienda, sus travesaños, columnas y basas,"
,"32":"las columnas que rodean el atrio, sus basas, estacas y cuerdas, todos sus utensilios y su servicio. Les indicaréis concretamente con su nombre todos los objetos que pasan a su cuidado."
,"33":"Éste es el servicio de los clanes meraritas. En todo su servicio en la tienda de la reunión dependerán del sacerdote Itamar, hijo de Aarón'."
,"34":"Moisés, Aarón y los jefes de la comunidad hicieron el censo de los descendientes de Quehat por clanes y familias,"
,"35":"de treinta a cincuenta años, aptos para hacer el servicio en la tienda de la reunión."
,"36":"Los registrados por clanes fueron 2.750."
,"37":"Éste fue el número de los descendientes de Quehat aptos para prestar su servicio en la tienda de la reunión, según el censo hecho por Moisés y Aarón por orden del Señor."
,"38":"Se hizo el censo de los descendientes de Guersón por clanes y familias,"
,"39":"de treinta a cincuenta años, aptos para hacer su servicio en la tienda de la reunión;"
,"40":"los registrados por clanes y familias fueron 2.630."
,"41":"Éste fue el número de los descendientes de Guersón aptos para prestar su servicio en la tienda de la reunión, según el censo hecho por Moisés y Aarón por orden del Señor."
,"42":"Se hizo el censo de los descendientes de Merarí por clanes y familias,"
,"43":"de treinta a cincuenta años, aptos para prestar su servicio en la tienda de la reunión;"
,"44":"los registrados por clanes fueron 3.200."
,"45":"Éste fue el total de los clanes meraritas según el censo hecho por Moisés y Aarón por orden del Señor."
,"46":"Todos los registrados en el censo que Moisés, Aarón y los jefes de Israel hicieron de los levitas por clanes y familias,"
,"47":"desde los treinta a los cincuenta años, aptos para hacer su servicio en la tienda de la reunión,"
,"48":"dieron un total de 8.580."
,"49":"Este censo se hizo por orden del Señor y bajo la dirección de Moisés, asignando a la vez a cada uno el respectivo servicio y cargo, tal y como el Señor había ordenado a Moisés."
}`)
	CurrentBook.AddChapter(5, `{
"1":"El Señor dijo a Moisés:"
,"2":"'Ordena a los israelitas que saquen del campamento a los leprosos, a los que padecen blenorragia, a los impuros por contacto con cadáveres;"
,"3":"que los saquen a todos, hombres o mujeres, sin distinción, para que no contaminen su campamento donde yo vivo en medio de ellos'."
,"4":"Los israelitas lo hicieron así y los sacaron fuera del campamento, tal y como el Señor había ordenado a Moisés."
,"5":"El Señor habló a Moisés: 'Di a los israelitas:"
,"6":"Si un hombre o una mujer causa un perjuicio a otro, ofendiendo así al Señor, esa persona es culpable;"
,"7":"confesará su pecado y resarcirá a la persona perjudicada el daño causado, más una quinta parte."
,"8":"Si la persona perjudicada ha muerto y no deja pariente alguno a quien se pueda restituir, la restitución será para el Señor y en beneficio del sacerdote, además del carnero por el pecado mediante el cual se hará el rito de absolución sobre el culpable."
,"9":"Todo tributo y ofrenda que los israelitas presenten al sacerdote, son del sacerdote;"
,"10":"lo que uno da al sacerdote, es del sacerdote'."
,"11":"El Señor habló a Moisés:"
,"12":"'Di a los israelitas: Si la mujer se desvía de su marido y le es infiel,"
,"13":"teniendo relaciones sexuales con otro sin saberlo el marido, es decir, si se ha deshonrado en secreto, sin que haya testigos contra ella y sin que haya sido sorprendida en el acto;"
,"14":"si el marido sospecha algo y llega a sentir celos por ella, se haya o no deshonrado en realidad,"
,"15":"la llevará al sacerdote y presentará por ella como ofrenda cuatro kilos y medio de harina de cebada, sin derramar aceite sobre ella ni poner encima incienso, porque es ofrenda de celos, ofrenda de denuncia de una falta."
,"16":"El sacerdote llamará a la mujer y la pondrá en presencia del Señor."
,"17":"Echará agua bendita en una vasija de barro, y tomando un poco de tierra del suelo de la tienda, la mezclará con el agua."
,"18":"Pondrá a la mujer en presencia del Señor, le descubrirá la cabeza y le pondrá en las manos la ofrenda conmemorativa, es decir, la ofrenda de celos, mientras él tiene en su mano el agua amarga de la maldición."
,"19":"Tomará juramento a la mujer y le dirá: Si no has dormido con otro hombre, no te has desviado ni te has deshonrado siendo infiel a tu marido, que no te pase nada al beber esta agua amarga de la maldición."
,"20":"Pero si has sido infiel a tu marido y te has deshonrado; si otros, que no eran tu marido, se han acostado contigo"
,"21":"(el sacerdote tomará juramento a la mujer diciendo): Que el Señor te haga objeto de maldición en medio de tu pueblo, que se malogre tu criatura y que se te hinche tu vientre."
,"22":"Entre esta agua de maldición en tus entrañas hasta que se hinche tu vientre y malogre tu criatura. La mujer contestará: ¡Que así sea!"
,"23":"El sacerdote pondrá por escrito estas maldiciones y las disolverá en el agua amarga."
,"24":"Hará beber a la mujer el agua amarga de la maldición hasta que penetre en ella y le produzca amargura."
,"25":"Tomará después de mano de la mujer la ofrenda de celos, la presentará al Señor y la depositará sobre el altar;"
,"26":"tomará de ella un puñado, como memorial, y lo quemará sobre el altar. Hará beber luego el agua a la mujer."
,"27":"Cuando haya bebido el agua, si realmente se ha deshonrado engañando a su marido, el agua de la maldición entrará en ella y le producirá amargura, su vientre se hinchará, su criatura se malogrará y vendrá a ser objeto de maldición en medio de su pueblo."
,"28":"Si, por el contrario, no se deshonró y se conserva pura, no le pasará nada y será fecunda."
,"29":"Éste es el ritual para casos de celos: cuando una mujer haya sido infiel a su marido y se haya deshonrado,"
,"30":"o cuando el marido se haya puesto celoso y sienta celos por su mujer, el marido hará comparecer a su mujer en presencia del Señor, y el sacerdote hará con ella todo este rito."
,"31":"El marido quedará libre de culpa y la mujer cargará con su pecado'."
}`)
	CurrentBook.AddChapter(6, `{
"1":"El Señor habló a Moisés:"
,"2":"'Di a los israelitas: Si un hombre o una mujer hace el voto de nazireato, por el cual queda consagrado al Señor,"
,"3":"se abstendrá de vino y bebidas fermentadas, vinagre de vino y otros licores; no beberá zumo de uva, ni comerá uvas ni pasas."
,"4":"Durante todo el tiempo de su nazireato no tomará producto alguno de la vid, desde la piel hasta los granos de la uva."
,"5":"Durante todo el tiempo de su nazireato no pasará la navaja por su cabeza; hasta que se cumpla el tiempo de su voto al Señor está consagrado y dejará crecer libremente su cabellera."
,"6":"Durante todo el tiempo de su consagración al Señor no se acercará a ningún cadáver;"
,"7":"no se contaminará ni con el cadáver de su padre, ni de su madre, ni de su hermano, ni de su hermana, puesto que lleva sobre sí la consagración a su Dios."
,"8":"Todo el tiempo de su nazireato está consagrado al Señor."
,"9":"Si alguno muere de repente junto a él, contaminándole su cabellera consagrada, deberá afeitarse la cabeza el día de su purificación; se la afeitará el séptimo día,"
,"10":"y el día octavo presentará al sacerdote dos tórtolas o dos pichones a la entrada de la tienda de la reunión."
,"11":"El sacerdote ofrecerá uno de ellos en sacrificio por el pecado, y otro en holocausto; a continuación hará sobre este hombre el rito de absolución del pecado cometido al tocar el cadáver. El mismo día el nazireo consagrará su cabeza al Señor."
,"12":"Comenzará de nuevo el tiempo de su nazireato y ofrecerá un cordero de un año en sacrificio por el pecado; no contará el tiempo pasado, por haber sido profanado su nazireato."
,"13":"Éste será el ritual del nazireo: el día en que se cumpla el tiempo de su nazireato, el sacerdote lo llevará a la entrada de la tienda de la reunión"
,"14":"para hacer su ofrenda al Señor: un cordero de un año, sin defecto, para el holocausto; una cordera de un año, para el sacrificio por el pecado; un carnero, sin defecto, para el sacrificio de reconciliación,"
,"15":"y una cesta de panes sin levadura, de tortas de flor de harina amasada con aceite, para la ofrenda y la libación."
,"16":"El sacerdote lo presentará todo al Señor y ofrecerá el sacrificio por el pecado y el holocausto;"
,"17":"ofrecerá el carnero como sacrificio de reconciliación, junto con el cestillo de los panes sin levadura; hará también la ofrenda y la libación requeridas."
,"18":"El nazireo se afeitará su cabeza consagrada a la entrada de la tienda de la reunión, y tomando los cabellos de su cabeza consagrada, los echará al fuego que arde bajo el sacrificio de reconciliación."
,"19":"El sacerdote tomará la pierna, ya cocida, del carnero, un pan sin levadura de la cesta, una torta sin levadura, y se los pondrá en las manos al nazireo, una vez que se haya afeitado su cabeza consagrada."
,"20":"El sacerdote hará el rito de presentación al Señor. El pecho de la ofrenda presentada y la pierna del tributo constituyen la porción sagrada reservada al sacerdote. Después de esto, el nazireo podrá beber vino."
,"21":"Ésta es la ley del nazireo. Si además de su cabellera el nazireo ha hecho voto de una ofrenda personal al Señor (sin contar otras posibles ofrendas), cumplirá el voto hecho, además de lo que la ley tiene ya previsto para su cabellera'."
,"22":"El Señor habló a Moisés:"
,"23":"'Di a Aarón y a sus hijos: Así bendeciréis a los israelitas:"
,"24":"Que el Señor te bendiga y te guarde."
,"25":"Que el Señor haga resplandecer su rostro sobre ti y te conceda su gracia."
,"26":"Que el Señor vuelva hacia ti su rostro y te conceda la paz."
,"27":"Así invocarán mi nombre los israelitas y yo los bendeciré'."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Cuando Moisés acabó de levantar la tienda, la ungió con aceite y la consagró con todo su mobiliario, el altar y todos sus accesorios;"
,"2":"los jefes de Israel, cabezas de las tribus, que habían dirigido el censo, hicieron una ofrenda"
,"3":"y la llevaron delante del Señor: seis carros cubiertos y doce bueyes, un carro por cada dos y un buey por cada uno de los príncipes, y la ofrecieron delante de la tienda."
,"4":"El Señor dijo a Moisés:"
,"5":"'Tómalos de su mano y destínalos al servicio de la tienda de la reunión; se los darás a los hijos de Leví para que los usen, cada uno según sus funciones'."
,"6":"Moisés tomó los carros y los bueyes y los entregó a los levitas;"
,"7":"dio dos carros y cuatro bueyes a los hijos de Guersón, según sus funciones;"
,"8":"cuatro carros y ocho bueyes a los hijos de Merarí, según su oficio, bajo la vigilancia del sacerdote Itamar, hijo de Aarón."
,"9":"No dio ninguno a los hijos de Quehat, porque éstos estaban al servicio de las cosas santas y debían llevarlas sobre los hombros."
,"10":"Los jefes hicieron su ofrenda por la dedicación del altar el día de su unción y la presentaron ante el altar."
,"11":"El Señor dijo a Moisés: 'Estos jefes presentarán su ofrenda por la dedicación del altar, uno cada día'."
,"12":"El primer día presentó su ofrenda Nasón, hijo de Aminadab, de la tribu de Judá."
,"13":"Su ofrenda era una bandeja de plata de kilo y medio de peso; un jarrón de plata de ochocientos cincuenta gramos según el peso del santuario, ambos llenos de flor de harina amasada con aceite, para la oblación;"
,"14":"un vaso de oro de ciento veinte gramos de peso lleno de perfume;"
,"15":"un novillo, un carnero, un cordero de un año, para el holocausto;"
,"16":"un macho cabrío, para el sacrificio por el pecado;"
,"17":"dos bueyes, cinco carneros, cinco machos cabríos y cinco corderos de un año, para el sacrificio de reconciliación. Ésta fue la ofrenda de Nasón, hijo de Aminadab."
,"18":"El segundo día hizo su ofrenda Natanael, hijo de Suar, jefe de Isacar."
,"19":"Ofreció una bandeja de plata de kilo y medio de peso; un jarrón de plata de ochocientos cincuenta gramos según el peso del santuario, ambos llenos de flor de harina amasada con aceite, para la ofrenda;"
,"20":"un vaso de oro de ciento veinte gramos de peso, lleno de perfume;"
,"21":"un novillo, un carnero, un cordero de un año, para el holocausto;"
,"22":"un macho cabrío, para el sacrificio por el pecado;"
,"23":"dos bueyes, cinco carneros, cinco machos cabríos y cinco corderos de un año, para el sacrificio de reconciliación. Ésta fue la ofrenda de Natanael, hijo de Suar."
,"24":"El tercer día hizo su ofrenda Eliab, hijo de Jelón, jefe de los hijos de Zabulón."
,"25":"Ofreció una bandeja de plata de kilo y medio de peso; un jarrón de plata de ochocientos cincuenta gramos según el peso del santuario, ambos llenos de flor de harina amasada con aceite, para la ofrenda;"
,"26":"un vaso de oro de ciento veinte gramos de peso, lleno de perfume;"
,"27":"un novillo, un carnero, un cordero de un año, para el holocausto;"
,"28":"un macho cabrío, para el sacrificio por el pecado;"
,"29":"dos bueyes, cinco carneros, cinco machos cabríos, cinco corderos de un año, para el sacrificio de reconciliación. Ésta fue la ofrenda de Eliab, hijo de Jelón."
,"30":"El cuarto día hizo su ofrenda Elisur, hijo de Sedeur, jefe de los hijos de Rubén."
,"31":"Ofreció una bandeja de plata de kilo y medio de peso; un jarrón de plata de ochocientos cincuenta gramos según el peso del santuario, ambos llenos de flor de harina amasada con aceite, para la ofrenda;"
,"32":"un vaso de oro de ciento veinte gramos de peso, lleno de perfume;"
,"33":"un novillo, un carnero, un cordero de un año, para el holocausto;"
,"34":"un macho cabrío, para el sacrificio por el pecado;"
,"35":"dos bueyes, cinco carneros, cinco machos cabríos, cinco corderos de un año, para el sacrificio de reconciliación. Ésta fue la ofrenda de Elisur, hijo de Sedeur."
,"36":"El quinto día hizo su ofrenda Selumiel, hijo de Surisaday, jefe de los hijos de Simeón."
,"37":"Ofreció una bandeja de plata de kilo y medio de peso; un jarrón de plata de ochocientos cincuenta gramos según el peso del santuario, ambos llenos de flor de harina amasada con aceite, para la ofrenda;"
,"38":"un vaso de oro de ciento veinte gramos de peso, lleno de perfume;"
,"39":"un novillo, un carnero, un cordero de un año, para el holocausto;"
,"40":"un macho cabrío, para el sacrificio por el pecado;"
,"41":"dos bueyes, cinco carneros, cinco machos cabríos, cinco corderos de un año, para el sacrificio de reconciliación. Ésta fue la ofrenda de Selumiel, hijo de Surisaday."
,"42":"El sexto día hizo su ofrenda Eliasaf, hijo de Deuel, jefe de los hijos de Gad."
,"43":"Ofreció una bandeja de plata de kilo y medio de peso; un jarrón de plata de ochocientos cincuenta gramos según el peso del santuario, ambos llenos de flor de harina amasada con aceite, para la ofrenda;"
,"44":"un vaso de oro de ciento veinte gramos de peso, lleno de perfume;"
,"45":"un novillo, un carnero, un cordero de un año, para el holocausto;"
,"46":"un macho cabrío, para el sacrificio por el pecado;"
,"47":"dos bueyes, cinco carneros, cinco machos cabríos, cinco corderos de un año, para el sacrificio de reconciliación. Ésta fue la ofrenda de Eliasaf, hijo de Deuel."
,"48":"El séptimo día hizo su ofrenda Elisamá, hijo de Amihud, jefe de los hijos de Efraín."
,"49":"Ofreció una bandeja de plata de kilo y medio de peso; un jarrón de plata de ochocientos cincuenta gramos según el peso del santuario, ambos llenos de flor de harina amasada con aceite, para la ofrenda;"
,"50":"un vaso de oro de ciento veinte gramos de peso, lleno de perfume;"
,"51":"un novillo, un carnero, un cordero de un año, para el holocausto;"
,"52":"un macho cabrío, para el sacrificio por el pecado;"
,"53":"dos bueyes, cinco carneros, cinco machos cabríos, cinco corderos de un año, para el sacrificio de reconciliación. Ésta fue la ofrenda de Elisamá, hijo de Amihud."
,"54":"El octavo día hizo su ofrenda Gamaliel, hijo de Pedasur, jefe de los hijos de Manasés."
,"55":"Ofreció una bandeja de plata de kilo y medio de peso; un jarrón de plata de ochocientos cincuenta gramos según el peso del santuario, ambos llenos de flor de harina amasada con aceite, para la ofrenda;"
,"56":"un vaso de oro de ciento veinte gramos de peso;"
,"57":"un novillo, un carnero, un cordero de un año, para el holocausto;"
,"58":"un macho cabrío, para el sacrificio por el pecado;"
,"59":"dos bueyes, cinco carneros, cinco machos cabríos, cinco corderos de un año, para el sacrificio de reconciliación. Ésta fue la ofrenda de Gamaliel, hijo de Pedasur."
,"60":"El noveno día hizo su ofrenda Abidán, hijo de Gedeoní, jefe de los hijos de Benjamín."
,"61":"Ofreció una bandeja de plata de kilo y medio de peso; un jarrón de plata de ochocientos cincuenta gramos según el peso del santuario, ambos llenos de flor de harina amasada con aceite, para la ofrenda;"
,"62":"un vaso de oro de ciento veinte gramos de peso, lleno de perfume;"
,"63":"un novillo, un carnero, un cordero de un año, para el holocausto;"
,"64":"un macho cabrío, para el sacrificio por el pecado;"
,"65":"dos bueyes, cinco carneros, cinco machos cabríos, cinco corderos de un año, para el sacrificio de reconciliación. Ésta fue la ofrenda de Abidán, hijo de Gedeoní."
,"66":"El décimo día hizo su ofrenda Ajiezer, hijo de Amisaday, jefe de los hijos de Dan."
,"67":"Ofreció una bandeja de plata de kilo y medio de peso; un jarrón de plata de ochocientos cincuenta gramos según el peso del santuario, ambos llenos de flor de harina amasada con aceite, para la ofrenda;"
,"68":"un vaso de oro de ciento veinte gramos de peso, lleno de perfume;"
,"69":"un novillo, un carnero, un cordero de un año, para el holocausto;"
,"70":"un macho cabrío, para el sacrificio por el pecado;"
,"71":"dos bueyes, cinco carneros, cinco machos cabríos, cinco corderos de un año, para el sacrificio de reconciliación. Ésta fue la ofrenda de Ajiezer, hijo de Amisaday."
,"72":"El undécimo día hizo su ofrenda Pagiel, hijo de Ocrán, jefe de los hijos de Aser."
,"73":"Ofreció una bandeja de plata de kilo y medio de peso; un jarrón de plata de ochocientos cincuenta gramos según el peso del santuario, ambos llenos de flor de harina amasada con aceite, para la ofrenda;"
,"74":"un vaso de oro de ciento veinte gramos de peso, lleno de perfume;"
,"75":"un novillo, un carnero, un cordero de un año, para el holocausto;"
,"76":"un macho cabrío, para el sacrificio por el pecado;"
,"77":"dos bueyes, cinco carneros, cinco machos cabríos, cinco corderos de un año, para el sacrificio de reconciliación. Ésta fue la ofrenda de Pagiel, hijo de Ocrán."
,"78":"El duodécimo día hizo su ofrenda Ajirá, hijo de Enán, jefe de los hijos de Neftalí."
,"79":"Ofreció una bandeja de plata de kilo y medio de peso; un jarrón de plata de ochocientos cincuenta gramos según el peso del santuario, ambos llenos de flor de harina amasada con aceite, para la ofrenda;"
,"80":"un vaso de oro de ciento veinte gramos de peso, lleno de perfume;"
,"81":"un novillo, un carnero, un cordero de un año, para el holocausto;"
,"82":"un macho cabrío, para el sacrificio por el pecado;"
,"83":"dos bueyes, cinco carneros, cinco machos cabríos, cinco corderos de un año, para el sacrificio de reconciliación. Ésta fue la ofrenda de Ajirá, hijo de Enán."
,"84":"Éstas fueron las ofrendas de los jefes de Israel para la consagración del altar el día de su unción: doce bandejas de plata, doce jarrones de plata, doce vasos de oro;"
,"85":"las bandejas, de kilo y medio de peso cada una, y los jarrones, de ochocientos cincuenta gramos cada uno; el peso total de los objetos de plata era de unos veintiocho kilos según el peso del santuario;"
,"86":"doce vasos de oro, llenos de perfume, de ciento veinte gramos de peso cada uno según el peso del santuario dan un total de mil cuatrocientos cuarenta gramos de oro."
,"87":"Total de los animales para el holocausto: doce novillos, doce carneros, doce corderos de un año, con sus ofrendas; doce machos cabríos, para el sacrificio por el pecado;"
,"88":"total de animales para el sacrificio de reconciliación: veinticuatro bueyes, sesenta carneros, sesenta machos cabríos y sesenta corderos de un año. Éstas fueron las ofrendas para la consagración del altar cuando fue ungido."
,"89":"Cuando Moisés entraba en la tienda de la reunión para hablar con el Señor, oía la voz que le hablaba desde lo alto del propiciatorio, que está sobre el arca de la alianza, entre los querubines. Así le hablaba el Señor."
}`)
	CurrentBook.AddChapter(8, `{
"1":"El Señor habló a Moisés:"
,"2":"'Di a Aarón: Cuando pongas las lámparas en el candelabro, las dispondrás de manera que las siete lámparas alumbren hacia adelante'."
,"3":"Así lo hizo Aarón: puso las lámparas en la parte anterior del candelabro, como el Señor había ordenado a Moisés."
,"4":"El candelabro era de oro trabajado a cincel, tanto el pie como los brazos, todo de oro trabajado a cincel. Moisés había ordenado hacerlo conforme al modelo que el Señor le había mostrado."
,"5":"El Señor dijo a Moisés:"
,"6":"'Separa a los levitas de los demás israelitas y purifícalos."
,"7":"Procederás de esta manera: los rociarás con agua de la purificación; ellos se afeitarán todo su cuerpo, lavarán sus vestidos y se purificarán."
,"8":"Tomarán luego un novillo con la ofrenda correspondiente de flor de harina amasada con aceite, y tú tomarás otro para el sacrificio por el pecado."
,"9":"Ordena que se acerquen los levitas a la tienda de la reunión, y convoca toda la comunidad de los israelitas."
,"10":"Cuando los levitas se hayan acercado ante el Señor, los israelitas pondrán las manos sobre ellos."
,"11":"Aarón, en nombre de los israelitas, ofrecerá los levitas al Señor haciendo el rito de presentación, para que entren al servicio del Señor."
,"12":"Los levitas pondrán a continuación sus manos sobre la cabeza de los novillos, y tú los ofrecerás al Señor, uno en sacrificio por el pecado y otro en holocausto. Así cumplirás sobre los levitas el rito de absolución."
,"13":"Pondrás a los levitas delante de Aarón y sus hijos, y los ofrecerás al Señor haciendo el rito de presentación."
,"14":"De esta manera separarás a los levitas de los demás israelitas para que sean míos"
,"15":"y entren a servir en la tienda de la reunión. Los purificarás y los ofrecerás con el rito de presentación, "
,"16":"porque son míos; me han sido dados a mí por los israelitas en sustitución de los que abren el seno materno, es decir, de todos los primogénitos de los israelitas: yo los he tomado para mí."
,"17":"Todos los primogénitos israelitas son míos, tanto hombres como animales; los reservé yo para mí el día en que herí a todos los primogénitos de Egipto;"
,"18":"pero he elegido a los levitas en sustitución de todos los primogénitos israelitas"
,"19":"y los he puesto a las órdenes de Aarón y sus hijos, como personas donadas a ellos de entre los israelitas, para que hagan el servicio de los israelitas en la tienda de la reunión, y hagan sobre ellos el rito de absolución y no sean castigados por acercarse al santuario'."
,"20":"Moisés, Aarón y toda la comunidad de los israelitas hicieron con los levitas todo lo que el Señor había mandado a Moisés."
,"21":"Los levitas se purificaron, lavaron sus vestidos, y Aarón los ofreció al Señor con el rito de presentación e hizo sobre ellos el rito de absolución para purificarlos."
,"22":"Los levitas fueron entonces admitidos en el servicio de la tienda de la reunión en presencia de Aarón y sus hijos. Se hizo con los levitas tal y como el Señor había ordenado a Moisés."
,"23":"El Señor dijo a Moisés:"
,"24":"'Los levitas, a partir de los veinticinco años, entrarán a prestar su servicio en la tienda de la reunión."
,"25":"Cuando lleguen a los cincuenta, cesarán en sus funciones, no servirán más;"
,"26":"ayudarán a sus hermanos en la guarda de la tienda de la reunión, pero no prestarán su servicio. Así has de proceder en lo que se refiere a los servicios de los levitas'."
}`)
	CurrentBook.AddChapter(9, `{
"1":"El Señor dijo a Moisés en el desierto del Sinaí el primer mes del año segundo de la salida de Egipto:"
,"2":"'Los israelitas celebrarán la pascua a su debido tiempo."
,"3":"La celebrarán el día catorce de este mes, conforme a las leyes y a los ritos que a ella se refieren'."
,"4":"Moisés ordenó a los israelitas que celebrasen la pascua;"
,"5":"la celebraron en el desierto del Sinaí el primer mes, el día catorce del mes, al atardecer. Los israelitas se ajustaron en todo a lo que el Señor había ordenado a Moisés."
,"6":"Pero había algunos que, encontrándose en estado de impureza por contactos con cadáveres, no pudieron celebrar la pascua ese día. Éstos se presentaron ese mismo día a Moisés y Aarón"
,"7":"y les dijeron: 'Estamos impuros por haber tocado un cadáver; ¿por qué no vamos a presentar la ofrenda al Señor con los demás israelitas?'."
,"8":"Moisés les respondió: 'Esperad y veré lo que dispone el Señor respecto de vosotros'."
,"9":"El Señor habló a Moisés:"
,"10":"'Di a los israelitas: Si alguno entre vosotros o vuestros descendientes se encuentra impuro por haber tocado un cadáver, o se encuentra lejos en un viaje, celebrará la pascua del Señor."
,"11":"La celebrará en el segundo mes, el día catorce, al atardecer. La comerán con pan sin levadura y hierbas amargas;"
,"12":"no dejarán nada para la mañana siguiente ni romperán ninguno de sus huesos; se ajustarán en todo al rito pascual."
,"13":"Si alguno, estando limpio y no de viaje, deja de celebrarla, será extirpado de su pueblo por no haber ofrecido a su tiempo la ofrenda al Señor, y cargará con su pecado."
,"14":"Si los extranjeros residentes quieren celebrar la pascua en honor del Señor, se ajustarán en todo a la ley y rito pascual. No habrá entre vosotros más que una ley, la misma para extranjeros y nativos'."
,"15":"El día en que fue levantada la morada, la nube cubrió la morada, la tienda del testimonio, y desde la tarde a la mañana estuvo sobre la morada en forma de fuego."
,"16":"La nube la cubría constantemente, tomando por la noche la apariencia de fuego."
,"17":"Cuando la nube se alzaba de la tienda, los israelitas se ponían en marcha, y en el lugar donde se posaba la nube, allí acampaban."
,"18":"Los israelitas se ponían en marcha por orden del Señor y por orden del Señor acampaban; y permanecían acampados todo el tiempo que la nube se posaba sobre la tienda."
,"19":"Cuando la nube permanecía posada sobre la tienda muchos días, los israelitas rendían su servicio al Señor y no levantaban el campamento;"
,"20":"pero si la nube permanecía pocos días sobre la tienda, entonces acampaban por orden del Señor y por orden suya levantaban el campamento."
,"21":"Cuando la nube se detenía de la tarde a la mañana, y a la mañana se alzaba, entonces partían."
,"22":"Fuesen dos días, un mes o un año, mientras la nube se posaba sobre la tienda, los israelitas seguían acampados y no se movían; pero cuando se alzaba, partían."
,"23":"A la orden del Señor acampaban, y a la orden del Señor partían. Y rendían su servicio al Señor, conforme el Señor había ordenado a Moisés."
}`)
	CurrentBook.AddChapter(10, `{
"1":"El Señor dijo a Moisés:"
,"2":"'Hazte dos trompetas de plata trabajada a cincel, que te sirvan para convocar a la comunidad y dar la orden de partida a los campamentos."
,"3":"Al toque de las dos trompetas, toda la comunidad se reunirá contigo a la puerta de la tienda de la reunión."
,"4":"Al toque de una sola, se reunirán contigo los responsables, jefes de millar de Israel."
,"5":"A un toque vibrante, levantarán su campamento los acampados al este."
,"6":"A un segundo toque vibrante, levantarán su campamento los acampados al sur. Estos toques vibrantes son para ponerse en marcha."
,"7":"Para reunir la asamblea se dará un toque normal, no vibrante."
,"8":"Los encargados de tocar las trompetas serán los descendientes de Aarón, los sacerdotes. Es ley perpetua para vosotros y vuestros descendientes."
,"9":"Cuando un enemigo os ataque en vuestro propio terreno y tengáis que salir a la guerra, las trompetas darán toques vibrantes: el Señor se acordará de vosotros y os veréis libres de vuestros enemigos."
,"10":"En vuestras fiestas, solemnidades y novilunios tocaréis las trompetas anunciando vuestros holocaustos y sacrificios de reconciliación; y vuestro Dios se acordará de vosotros. Yo, el Señor, vuestro Dios'."
,"11":"El día veinte del segundo mes del año segundo, la nube se levantó de sobre la tienda del testimonio,"
,"12":"y los israelitas partieron, en orden de marcha, del desierto del Sinaí, y la nube se detuvo en el desierto de Farán."
,"13":"Ésta fue la primera marcha bajo la orden del Señor dada por medio de Moisés."
,"14":"Partió en cabeza la bandera de Judá, por escuadras. Jefe de las escuadras era Nasón, hijo de Aminadab."
,"15":"Jefe de las escuadras de la tribu de Isacar era Natanael, hijo de Suar,"
,"16":"y jefe de las escuadras de la tribu de Zabulón, Eliab, hijo de Jelón."
,"17":"Desmontada la tienda, se pusieron en marcha los descendientes de Guersón y Merarí, que eran los encargados de transportarla."
,"18":"A continuación partió la bandera de Rubén, por escuadras; era jefe Elisur, hijo de Sedeur."
,"19":"El jefe de las escuadras de la tribu de Simeón era Selumiel, hijo de Surisaday."
,"20":"Eliasab, hijo de Deuel, era el jefe de las escuadras de la tribu de Gad."
,"21":"Luego partieron los quehatitas, que llevaban los objetos sagrados. (Antes de su llegada debía estar levantada la tienda)."
,"22":"Partió después la bandera de Efraín, por escuadras. Jefe de las escuadras de Efraín era Elisamá, hijo de Amihud."
,"23":"Gamaliel, hijo de Pedasur, era el jefe de las escuadras de la tribu de Manasés,"
,"24":"y Abidán, hijo de Gedeoní, lo era de las escuadras de la tribu de Benjamín."
,"25":"Finalmente partió, a la retaguardia de todos los demás, la bandera de Dan, por escuadras. A la cabeza de las escuadras de Dan iba Ajiezer, hijo de Amisaday."
,"26":"A la cabeza de las escuadras de la tribu de Aser iba Pagiel, hijo de Ocrán;"
,"27":"Ajirá, hijo de Enán, iba a la cabeza de las escuadras de la tribu de Neftalí."
,"28":"Éste era el orden por escuadras cuando los israelitas se ponían en marcha."
,"29":"Moisés dijo a Jobab, hijo de su suegro Ragüel, el madianita: 'Nosotros partimos hacia la tierra que el Señor ha prometido darnos. Vente con nosotros y te trataremos bien, porque el Señor ha prometido favorecer a Israel'."
,"30":"Él respondió: 'No; yo me iré a mi tierra y a mi parentela'."
,"31":"Moisés insistió: 'No nos dejes, pues tú conoces bien los lugares donde podremos acampar en el desierto y podrás ser nuestro guía."
,"32":"Si vienes con nosotros, te haremos partícipe de todos los favores que nos haga el Señor'."
,"33":"Partieron de la montaña del Señor e hicieron tres días de camino. El arca de la alianza del Señor iba delante, buscando un sitio donde acampar."
,"34":"La nube del Señor los acompañaba de día desde que levantaron el campamento."
,"35":"Cuando el arca se ponía en marcha, Moisés decía: '¡Levántate, Señor, y sean dispersados tus enemigos; huyan ante ti los que te odian!'."
,"36":"Cuando se paraba, decía: '¡Descansa, Señor, entre los incontables ejércitos de Israel!'."
}`)
	CurrentBook.AddChapter(11, `{
"1":"El pueblo se quejó al Señor de sus desgracias. El Señor lo oyó, montó en cólera y mandó contra ellos un fuego, que devoró uno de los flancos del campamento."
,"2":"El pueblo llamó a gritos a Moisés, el cual intercedió por ellos ante el Señor y el fuego se apagó."
,"3":"Llamaron a aquel lugar Taberá, porque allí se había encendido contra ellos el fuego del Señor."
,"4":"La gente que se les había unido tenía tanta hambre que los mismos israelitas, contagiados, se pusieron a llorar, gritando: '¡Quién nos diera carne que comer!"
,"5":"Nos acordamos del pescado que comíamos en Egipto de balde, de los pepinos, de los melones, de los puerros, de las cebollas, de los ajos."
,"6":"Ahora nos morimos de hambre y no vemos más que maná'."
,"7":"El maná era parecido a la semilla del cilantro, y su color era como de bedelio."
,"8":"El pueblo se dispersaba para recogerlo, lo molían en molinos o lo machacaban en el almirez, lo cocían en una caldera y hacían tortas, que tenían el sabor de la pasta amasada con aceite."
,"9":"Cuando el rocío caía sobre el campo por la noche, caía también el maná."
,"10":"Moisés oyó al pueblo que lloraba, dividido por familias, cada una a la puerta de su tienda. El Señor montó en cólera, y Moisés, muy disgustado,"
,"11":"dijo al Señor: '¿Por qué tratas tan mal a tu siervo? ¿Por qué no he hallado yo gracia a tus ojos, sino que has cargado sobre mí el peso de todo este pueblo?"
,"12":"¿Acaso lo he concebido yo o lo he dado a luz para que me digas: Llévalo en tu regazo, como lleva la nodriza al niño a quien da de mamar, hasta la tierra que juraste dar a sus padres?"
,"13":"¿Dónde encontraré yo carne para dar a todo este pueblo que llora a mi lado gritando: Danos carne para comer?"
,"14":"Yo solo no puedo soportar a este pueblo; pesa demasiado."
,"15":"¡Si me vas a tratar así, prefiero la muerte! ¡Si he hallado gracia a tus ojos, haz que termine mi aflicción!'."
,"16":"El Señor dijo a Moisés: 'Reúneme a setenta de los ancianos de Israel, de los que te conste que son realmente ancianos del pueblo y escribas. Llévalos a la tienda de la reunión, y que esperen allí contigo."
,"17":"Yo bajaré, hablaré contigo y tomaré una parte del espíritu que tú tienes y se la daré a ellos para que compartan contigo el peso de este pueblo y no lo lleves tú solo."
,"18":"Dirás al pueblo: Santificaos para mañana y comeréis carne, ya que os habéis quejado a los oídos del Señor, diciendo: ¡Quién nos diera carne para comer! ¡Estábamos mejor en Egipto! Pues bien, el Señor os dará carne para comer."
,"19":"Más aún, no la comeréis un día, ni dos, ni cinco, ni diez, ni veinte,"
,"20":"sino un mes entero; hasta que se os salga por las narices y os produzca asco, pues habéis despreciado al Señor, que está en medio de vosotros, y habéis llorado en su presencia diciendo: ¿Por qué hemos salido de Egipto?'."
,"21":"Moisés respondió: '¿Seiscientos mil hombres de a pie cuenta el pueblo en medio del cual me encuentro, y tú dices: Yo les daré a comer carne durante un mes entero?"
,"22":"¿Sería suficiente todo el ganado mayor y menor? ¿Bastarían todos los peces del mar?'."
,"23":"El Señor replicó a Moisés: '¿Es que es tan pequeño mi poder? Ahora verás si se cumple o no mi palabra'."
,"24":"Moisés salió fuera y comunicó al pueblo las palabras del Señor. Reunió a los setenta ancianos del pueblo y los puso alrededor de la tienda."
,"25":"El Señor bajó en la nube y habló a Moisés. Tomó una parte del espíritu que tenía Moisés y se la dio a los setenta ancianos. Cuando el espíritu se posó sobre ellos se pusieron a profetizar, pero no continuaron."
,"26":"Dos de ellos habían permanecido en el campamento: uno se llamaba Eldad y otro Medad. También sobre ellos se posó el espíritu, ya que pertenecían a los elegidos, aunque no se habían presentado en la tienda, y se pusieron a profetizar en el campamento."
,"27":"Un mozo fue corriendo a decir a Moisés: 'Eldad y Medad están profetizando en el campamento'."
,"28":"Josué, hijo de Nun, que desde su juventud había servido a Moisés, dijo: 'Señor mío Moisés, prohíbeselo'."
,"29":"Moisés le respondió: '¿Tienes celos de mí? ¡Ojalá que todo el pueblo del Señor profetizara y el Señor les diera su espíritu!'."
,"30":"Moisés se volvió al campamento con los ancianos de Israel."
,"31":"El Señor levantó un viento que soplaba del mar y que trajo bandadas de codornices, que cayeron sobre el campamento; cubrían el espacio de una jornada de camino de uno y otro lado del campamento, y tenían el espesor de un metro sobre el suelo."
,"32":"El pueblo estuvo recogiendo codornices todo el día, toda la noche y todo el día siguiente; el que menos, recogió diez montones, y las pusieron a secar en los alrededores del campamento."
,"33":"Todavía tenían la carne entre los dientes, sin haberla aún acabado, cuando el Señor montó en cólera contra el pueblo y lo hirió con una gran plaga."
,"34":"Por eso se llamó aquel lugar Quibrot Hattaatavá, pues allí quedó sepultado el pueblo glotón."
,"35":"De Quibrot Hattaatavá partió el pueblo para Jaserot, donde acamparon."
}`)
	CurrentBook.AddChapter(12, `{
"1":"María y Aarón murmuraban contra Moisés por la mujer cusita que había tomado por esposa."
,"2":"Decían: '¿Es que el Señor ha hablado sólo con Moisés? ¿No ha hablado también con nosotros?'. El Señor lo oyó."
,"3":"Moisés era humilde, el hombre más humilde de este mundo."
,"4":"El Señor dijo a Moisés, Aarón y María: 'Id los tres a la tienda de la reunión'; y así lo hicieron."
,"5":"El Señor bajó en la columna de nube y se paró a la entrada de la tienda. Llamó a Aarón y a María, y los dos se acercaron."
,"6":"El Señor les dijo: 'Escuchad mis palabras: Cuando hay entre vosotros un profeta del Señor, yo me doy a conocer a él en visión y le hablo en sueños."
,"7":"Pero no hago así con mi siervo Moisés, que es en toda mi casa el hombre de confianza."
,"8":"Yo le hablo cara a cara y a las claras, no en enigmas, y él contempla la figura del Señor. ¿Por qué os habéis atrevido a hablar contra mi siervo Moisés?'."
,"9":"Dios montó en cólera contra ellos, y se fue."
,"10":"Tan pronto como desapareció la nube de la tienda, María apareció cubierta de lepra, blanca como la nieve. Aarón se volvió a mirarla, y la vio cubierta de lepra."
,"11":"Aarón dijo a Moisés: '¡Por favor, mi señor! No cargues sobre nosotros el peso del pecado que neciamente hemos cometido, del cual somos culpables."
,"12":"¡No sea ella como un aborto que sale ya medio consumido del vientre de su madre!'."
,"13":"Moisés suplicó al Señor: 'Cúrala, oh Dios, por favor'."
,"14":"El Señor respondió: 'Si su padre le hubiera escupido en el rostro, ¿no estaría ella cubierta de vergüenza durante siete días? Por tanto, que la echen fuera del campamento durante siete días, y luego podrá volver a él'."
,"15":"María fue echada del campamento durante siete días. Cuando María volvió,"
,"16":"el pueblo salió de Jaserot y fue a acampar al desierto de Farán."
}`)
	CurrentBook.AddChapter(13, `{
"1":"El Señor dijo a Moisés:"
,"2":"'Envía algunos hombres a explorar la tierra de Canaán que voy a dar a los israelitas: envía de cada tribu a uno que sea responsable'."
,"3":"Moisés los envió desde el desierto de Farán tal como el Señor le había ordenado. Todos ellos eran jefes entre los israelitas."
,"4":"Éstos eran sus nombres: de la tribu de Rubén, Samúa, hijo de Zacur;"
,"5":"de la tribu de Simeón, Safat, hijo de Jorí;"
,"6":"de la tribu de Judá, Caleb, hijo de Jefoné;"
,"7":"de la tribu de Isacar, Yigal, hijo de José;"
,"8":"de la tribu de Efraín, Osea, hijo de Nun;"
,"9":"de la tribu de Benjamín, Palti, hijo de Rafú;"
,"10":"de la tribu de Zabulón, Gadiel, hijo de Sodí;"
,"11":"de la tribu de José, de Manasés, Gadí, hijo de Susí;"
,"12":"de la tribu de Dan, Amiel, hijo de Guemalí;"
,"13":"de la tribu de Aser, Setur, hijo de Miguel;"
,"14":"de la tribu de Neftalí, Najbí, hijo de Vafsí;"
,"15":"de la tribu de Gad, Gueuel, hijo de Maquí."
,"16":"Éstos son los nombres de los exploradores que Moisés envió a reconocer la tierra. Moisés dio a Osea, hijo de Nun, el nombre de Josué."
,"17":"Moisés los envió a reconocer la tierra de Canaán, y les dijo: 'Subid al Negueb; subid luego a la montaña"
,"18":"y observad cómo es la tierra; qué pueblo la habita, si es fuerte o débil, numeroso o reducido;"
,"19":"cómo es la tierra habitada, buena o mala; cómo están sus ciudades, abiertas o amuralladas;"
,"20":"cómo es el suelo, fértil o pobre, con árboles o sin ellos. Sed valientes y traed algunos frutos de la tierra'. Era el tiempo en que empezaban a madurar las uvas."
,"21":"Fueron y exploraron toda la tierra desde el desierto de Sin hasta el Rejob, junto a la entrada de Jamat."
,"22":"Subieron por el Negueb y llegaron a Hebrón, donde estaban Ajimán, Sesay y Tomay, hijos de Anac (Hebrón fue fundada siete años antes que Tanis de Egipto)."
,"23":"Llegaron hasta el valle de Escol, donde cortaron un sarmiento con un racimo de uvas, lo colgaron de un palo y se lo llevaron entre dos. Recogieron también granadas e higos."
,"24":"Este sitio recibió el nombre de Valle del Racimo, porque allí habían cortado el racimo los israelitas."
,"25":"A los cuarenta días volvieron de explorar la tierra."
,"26":"Se presentaron a Moisés, a Aarón y a toda la comunidad de los israelitas en el desierto de Farán, en Cades; les informaron detalladamente de todo, y les mostraron los productos de la tierra."
,"27":"Ésta fue la información: 'Fuimos a la tierra a la que nos enviasteis. En verdad mana leche y miel; ved sus frutos."
,"28":"Pero el pueblo que la habita es potente, y las ciudades son fuertes y grandes; hemos visto incluso descendientes de Anac."
,"29":"Los amalecitas ocupan la región del Negueb; los hititas, jebuseos, amorreos, la parte montañosa; los cananeos, las costas del mar y las riberas del Jordán'."
,"30":"Caleb hizo callar al pueblo, que se oponía a Moisés, y dijo: 'Subiremos y la conquistaremos, pues somos capaces de ello'."
,"31":"Pero los que habían subido con él decían: 'No podemos subir contra ese pueblo, pues es más fuerte que nosotros'."
,"32":"Y desacreditaban entre los israelitas la tierra que habían explorado, diciendo: 'La tierra que hemos recorrido y explorado es una tierra que devora a sus habitantes. Los hombres que hemos visto son de gran estatura."
,"33":"Hemos visto hasta gigantes, hijos de Anac; ante ellos, nosotros parecíamos langostas, y esa impresión tenían también ellos'."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Entonces toda la comunidad empezó a gritar, el pueblo se pasó la noche llorando"
,"2":"y todos los israelitas murmuraban contra Moisés y Aarón. La comunidad entera decía: '¡Ojalá hubiéramos muerto en Egipto! ¿Por qué no moriremos en este desierto?"
,"3":"¿Por qué nos lleva el Señor a esa tierra a morir bajo la espada y entregar nuestras mujeres y nuestros hijos como botín de guerra? ¿No sería mejor volver a Egipto?'."
,"4":"Unos a otros se decían: '¡Elijamos un jefe y volvámonos a Egipto!'."
,"5":"Moisés y Aarón se postraron en tierra delante de toda la comunidad israelita."
,"6":"Y Josué, hijo de Nun, y Caleb, hijo de Jefoné, que habían estado entre los exploradores de la tierra, se rasgaron las vestiduras"
,"7":"y gritaron a toda la comunidad: 'La tierra que hemos recorrido y explorado es una tierra buena; más aún, muy buena."
,"8":"Si el Señor nos favorece, nos hará entrar en ella y nos la dará. Es una tierra que mana leche y miel."
,"9":"No os rebeléis contra el Señor ni tengáis miedo de la gente de esa tierra, pues nos los comeremos como un bocado de pan. Ellos se han quedado sin defensa, y con nosotros está el Señor; no les tengáis miedo'."
,"10":"Toda la comunidad hablaba de apedrearlos, cuando la gloria del Señor apareció en la tienda de la reunión ante todos los israelitas."
,"11":"El Señor dijo a Moisés: '¿Hasta cuándo me despreciará este pueblo? ¿Hasta cuándo me negará la fe, después de todos los prodigios que en medio de ellos he hecho?"
,"12":"Lo heriré de peste y lo destruiré; a ti te haré cabeza de una nación más grande y poderosa que ellos'."
,"13":"Moisés dijo al Señor: 'Pero lo sabrán los egipcios, puesto que con tu poder sacaste a este pueblo de en medio de ellos,"
,"14":"y lo pondrán en conocimiento de los habitantes de esta tierra. Saben que tú, oh Señor, estás en medio de tu pueblo, que te dejas ver cara a cara, que tu nube se posa sobre ellos, que vas delante de ellos de día en columna de nube y de noche en columna de fuego."
,"15":"Si destruyes a este pueblo como a un solo hombre, las naciones que han oído hablar de ti dirán:"
,"16":"El Señor no ha podido llevar a este pueblo a la tierra que le había prometido con juramento; por eso lo ha aniquilado en el desierto."
,"17":"Por tanto, Señor, demuestra tu poder, como tú mismo dijiste:"
,"18":"Yo soy el Señor, lento para la cólera y rico en misericordia, que perdona la iniquidad y la rebeldía, pero que nada deja impune, pues castiga en los hijos el pecado de los padres hasta la tercera generación."
,"19":"Perdona, pues, el pecado de este pueblo según tu gran misericordia, como desde Egipto hasta aquí lo has perdonado'."
,"20":"El Señor dijo: 'Los voy a perdonar como tú dices;"
,"21":"pero ¡por mi vida y por mi gloria, que llena toda la tierra!,"
,"22":"que todos los que han visto mi gloria y los prodigios que he hecho en Egipto y en el desierto, los que me han puesto a prueba por diez veces y no me han obedecido,"
,"23":"no verán la tierra que yo prometí con juramento a sus padres. Ninguno de los que me desprecian la verá."
,"24":"Pero a mi siervo Caleb, que está animado de otro espíritu y me ha obedecido fielmente, lo llevaré a la tierra en la que ha estado, y su descendencia la poseerá. (Los amalecitas y los cananeos habitaban entonces la llanura)."
,"25":"Volveos mañana mismo y partid por el desierto camino del mar Rojo'."
,"26":"El Señor dijo a Moisés y Aarón:"
,"27":"'¿Hasta cuándo habré de soportar a esta comunidad perversa que murmura contra mí? He oído las murmuraciones de los israelitas contra mí."
,"28":"Diles: Por mi vida, palabra del Señor, que os trataré según las mismas palabras que yo os he oído;"
,"29":"en este desierto quedarán vuestros cadáveres, los de todos los que fuisteis alistados de veinte años para arriba y habéis murmurado contra mí."
,"30":"Os juro que no entraréis en la tierra en la que, mano en alto, había jurado estableceros, excepto Caleb, hijo de Jefoné, y Josué, hijo de Nun."
,"31":"Entrarán vuestros hijos, de los que habíais dicho que iban a ser presa del enemigo; ellos conocerán la tierra que vosotros habéis despreciado."
,"32":"Vosotros, no; vuestros cadáveres quedarán en este desierto."
,"33":"Vuestros hijos andarán por el desierto durante cuarenta años, llevando sobre sí vuestras rebeldías, hasta que vuestros cadáveres se consuman en el desierto."
,"34":"Durante cuarenta años sufriréis el peso de vuestra iniquidad, correspondiente a los cuarenta días que empleasteis en la exploración de la tierra: un año por día. Entonces sabréis lo que significa haberos alejado de mí."
,"35":"Yo, el Señor, lo he dicho. Así trataré yo a esta comunidad perversa que se ha confabulado contra mí. En este desierto se consumirán, en él morirán'."
,"36":"Los hombres enviados por Moisés a explorar la tierra, que a su vuelta habían provocado la murmuración de toda la comunidad contra él desacreditando la tierra,"
,"37":"esos hombres que habían difamado la tierra, fueron heridos de muerte delante del Señor."
,"38":"Solamente Josué, hijo de Nun, y Caleb, hijo de Jefoné, quedaron con vida entre los hombres que habían ido a explorar la tierra."
,"39":"Moisés contó todo esto a los israelitas, y el pueblo hizo grandes manifestaciones de duelo."
,"40":"Se levantaron muy de mañana para subir a la cima de la montaña, diciendo: 'Vamos a subir a la tierra de que nos habló el Señor, pues hemos pecado'."
,"41":"Moisés les dijo: '¿Por qué queréis quebrantar la orden del Señor? Eso no puede saliros bien."
,"42":"No subáis, pues el Señor no os acompaña y seríais derrotados por vuestros enemigos."
,"43":"Los amalecitas y los cananeos están ahí, enfrente de vosotros, y caeréis bajo sus espadas, puesto que os habéis alejado del Señor; él no estará con vosotros'."
,"44":"Sin embargo, se obstinaron en subir a la cima de la montaña; pero el arca de la alianza del Señor y Moisés no se movieron de en medio del campamento."
,"45":"Cayeron sobre ellos los amalecitas y los cananeos, que habitaban aquellos montes, los derrotaron y los persiguieron hasta Jormá."
}`)
	CurrentBook.AddChapter(15, `{
"1":"El Señor habló a Moisés:"
,"2":"'Di a los israelitas: Cuando hayáis entrado en la tierra que os voy a dar para que viváis en ella"
,"3":"y hagáis una ofrenda al Señor de ganado mayor o menor como holocausto o sacrificio, en cumplimiento de un voto, o como ofrenda espontánea o con ocasión de una fiesta, ofrenda de olor agradable al Señor,"
,"4":"el oferente presentará como ofrenda personal al Señor una oblación de cuatro kilos y medio de flor de harina amasada con dos litros de aceite."
,"5":"Añadirás una ofrenda de vino, a razón de dos litros por cordero, además del holocausto y el sacrificio."
,"6":"Por un carnero ofrecerás nueve kilos de flor de harina amasada con dos litros y medio de aceite,"
,"7":"y dos litros y medio de vino como ofrenda de olor agradable al Señor."
,"8":"Si ofreces un toro, como holocausto, en cumplimiento de un voto o como sacrificio de reconciliación,"
,"9":"se añadirán trece kilos y medio de flor de harina amasada con cuatro litros de aceite,"
,"10":"y cuatro litros de vino, como ofrenda quemada de olor agradable al Señor."
,"11":"Así se hará por cada toro, carnero, cordero o cabrito."
,"12":"Según el número de animales que ofrezcáis, así haréis con cada uno de ellos."
,"13":"Así lo harán todos los indígenas cuando hagan una ofrenda quemada de olor agradable al Señor."
,"14":"Si un extranjero residente o de paso presenta una ofrenda quemada de olor agradable al Señor, hará lo mismo que vosotros."
,"15":"Habrá una sola ley para toda la comunidad, la misma para vosotros y para el extranjero, y se perpetuará de generación en generación; ante el Señor, vosotros y los extranjeros residentes seréis iguales."
,"16":"La misma ley y el mismo derecho tendréis vosotros y el extranjero residente'."
,"17":"El Señor habló a Moisés:"
,"18":"'Di a los israelitas: Cuando hayáis entrado en la tierra a la que os llevo,"
,"19":"cuando comáis el pan de esa tierra, reservaréis una parte como ofrenda al Señor."
,"20":"Ofreceréis los primeros granos de la era y un pan amasado con la primera harina."
,"21":"Lo haréis vosotros y vuestros descendientes."
,"22":"'Si por inadvertencia dejáis de cumplir alguno de estos mandamientos que el Señor os ha dado por medio de Moisés,"
,"23":"desde el primer día en adelante, de generación en generación, haréis lo siguiente:"
,"24":"Si el pecado por inadvertencia ha sido cometido por toda la comunidad, la comunidad entera ofrecerá un toro en holocausto de olor agradable al Señor con la ofrenda correspondiente de pan y de vino, según costumbre, y un macho cabrío por el pecado."
,"25":"El sacerdote hará el rito de absolución sobre toda la comunidad israelita y les será perdonado, puesto que ha sido un pecado por inadvertencia, y ellos han presentado la ofrenda y el sacrificio por su pecado de inadvertencia;"
,"26":"se perdonará a toda la comunidad israelita y a los extranjeros residentes, ya que el pueblo entero ha pecado por inadvertencia."
,"27":"Si el pecado por inadvertencia ha sido cometido por una sola persona, ésta ofrecerá como sacrificio por el pecado una cabrita de un año."
,"28":"El sacerdote hará delante del Señor el rito de absolución sobre la persona que ha pecado por inadvertencia, y el pecado le será perdonado."
,"29":"Para los pecados por inadvertencia habrá una sola ley, la misma para el indígena y para el extranjero residente."
,"30":"Pero el que obra deliberadamente, indígena o extranjero, ofende al Señor; en este caso será extirpado del pueblo"
,"31":"por haber menospreciado la palabra del Señor y haber traspasado su ley. Será extirpado y cargará con su pecado'."
,"32":"Cuando los israelitas estaban en el desierto, sorprendieron a un hombre recogiendo leña en sábado."
,"33":"Los que le sorprendieron, lo llevaron ante Moisés, Aarón y toda la comunidad,"
,"34":"y lo pusieron bajo vigilancia, pues no se había determinado todavía qué debía hacerse con él."
,"35":"El Señor dijo a Moisés: 'Este hombre debe ser condenado a muerte; toda la comunidad lo matará a pedradas fuera del campamento'."
,"36":"La comunidad lo sacó fuera del campamento y lo mató a pedradas, tal y como el Señor había ordenado a Moisés."
,"37":"El Señor dijo a Moisés:"
,"38":"'Ordena a los israelitas que de generación en generación se hagan flecos en los bordes de sus mantos y aten los flecos de cada borde con un cordón de color morado."
,"39":"Esto os servirá para recordar, al mirarlos, los mandamientos del Señor y os ayudará a ponerlos en práctica sin que sigáis los deseos de vuestro corazón y de vuestros ojos, que os han arrastrado a la infidelidad."
,"40":"De esta manera recordaréis los mandamientos del Señor, los pondréis en práctica y estaréis consagrados a vuestro Dios."
,"41":"Yo soy el Señor, vuestro Dios, que os ha sacado de Egipto para ser vuestro Dios. Yo, el Señor, vuestro Dios'."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Coré, hijo de Yisar, hijo de Quehat, hijo de Leví; Datán y Abirán, hijos de Eliab y On, hijo de Pélet, de los descendientes de Rubén,"
,"2":"se levantaron contra Moisés, junto con 250 israelitas, entre los jefes de la comunidad, miembros del consejo, personas distinguidas."
,"3":"Se amotinaron contra Moisés y Aarón y les dijeron: '¡Esto ya es demasiado! Si todos los miembros de la comunidad son santos y el Señor está en medio de ellos, ¿por qué os levantáis vosotros por encima de toda la asamblea del Señor?'."
,"4":"Cuando Moisés oyó esto, se postró rostro en tierra."
,"5":"Luego dijo a Coré y a todos sus secuaces: 'Mañana dará a conocer el Señor quién le pertenece y quién le está consagrado, y lo acercará a él; aquellos a quienes mande acercarse, ésos serán los elegidos."
,"6":"Haced esto: Coré y todos sus secuaces, tomad los incensarios,"
,"7":"poned mañana fuego en ellos, y sobre el fuego, incienso ante el Señor; aquel a quien elija el Señor, ése será consagrado. ¡Y basta ya, hijos de Leví!'."
,"8":"Moisés dijo a Coré: 'Escuchad, hijos de Leví:"
,"9":"¿os parece poco que el Dios de Israel os haya separado del resto del pueblo para teneros a su lado y hacer el servicio en la tienda del Señor, y os haya escogido entre la comunidad como ministros suyos?"
,"10":"El Señor te ha llamado a su lado a ti y a todos tus hermanos los levitas, ¿y ahora ambicionáis también el sacerdocio?"
,"11":"Tú y tus secuaces os habéis rebelado contra el Señor. ¿Quién es Aarón para que habléis mal de él?'."
,"12":"Moisés mandó llamar a Datán y Abirán, hijos de Eliab, pero ellos respondieron: 'No queremos ir."
,"13":"¿No es bastante que nos hayas sacado de una tierra que mana leche y miel y nos hayas traído a este desierto de muerte, para que quieras todavía seguir tiranizándonos?"
,"14":"¡No es una tierra que mana leche y miel donde nos has traído! ¡No nos has dado en posesión ni campos ni viñas! ¿Crees que están ciegas estas gentes? ¡No, no iremos!'."
,"15":"Moisés, preso de gran indignación, dijo al Señor: 'No hagas caso de su ofrenda. Ni un asno he tomado yo de ellos; a ninguno de ellos he perjudicado'."
,"16":"Moisés dijo a Coré: 'Tú y tus secuaces y Aarón, presentaos mañana ante el Señor."
,"17":"Tomad cada uno vuestro incensario, poned en él el incienso y llegaos ante el Señor con vuestro incensario: 250 incensarios. Tú y Aarón, llegaos también con vuestro incensario'."
,"18":"Cada uno tomó su incensario, puso fuego y colocó encima el incienso, y se presentaron a la entrada de la tienda de la reunión, juntamente con Moisés y Aarón."
,"19":"Cuando Coré hubo reunido frente a Moisés y Aarón toda la comunidad a la entrada de la tienda de la reunión, la gloria del Señor se apareció a toda la comunidad."
,"20":"El Señor dijo a Moisés y Aarón:"
,"21":"'Separaos de esta comunidad, pues quiero aniquilarla en un instante'."
,"22":"Cayeron sobre sus rostros y dijeron: '¡Oh, Dios, Dios del espíritu de todo viviente! ¿Ha pecado uno solo, y tú te irritas contra toda la comunidad?'."
,"23":"El Señor habló a Moisés:"
,"24":"'Di a la comunidad: Separaos de la tienda de Coré, Datán y Abirán'."
,"25":"Moisés se levantó, se acercó a Datán y Abirán, seguido por los ancianos de Israel,"
,"26":"y dijo a la comunidad: 'Alejaos de las tiendas de estos malvados; no toquéis nada de cuanto les pertenece, no sea que perezcáis envueltos por sus pecados'."
,"27":"Se alejaron de la tienda de Coré, Datán y Abirán. Datán y Abirán habían salido, y estaban a la entrada de sus tiendas con sus mujeres, sus hijos y sus pequeños. "
,"28":"Moisés dijo: 'En esto conoceréis que es el Señor quien me ha enviado para realizar todo lo que he hecho, y que no he obrado en mi propio nombre:"
,"29":"si estas gentes mueren de muerte natural, alcanzados por la sentencia común a todos los hombres, es que no me ha enviado el Señor;"
,"30":"pero si el Señor hace algo insólito, si la tierra abre sus fauces y los traga con todo cuanto les pertenece, si bajan vivos al abismo, entonces conoceréis que estas gentes se han burlado del Señor'."
,"31":"Apenas había acabado de hablar, el suelo se abrió bajo sus pies,"
,"32":"la tierra abrió su boca y se los tragó a ellos y a sus familias, así como a todos los hombres de Coré y todos sus bienes."
,"33":"Bajaron vivos al abismo, ellos y todos sus bienes; la tierra se cerró sobre ellos y desaparecieron de en medio de la asamblea."
,"34":"Al oír sus gritos, todos los israelitas que se encontraban en los alrededores huyeron, pues decían: 'No sea que la tierra nos trague también a nosotros'."
,"35":"Un fuego que salía del Señor devoró a los 250 hombres que ofrecían el incienso."
}`)
	CurrentBook.AddChapter(17, `{
"1":"El Señor dijo a Moisés:"
,"2":"'Ordena a Eleazar, hijo de Aarón sacerdote, que saque del fuego los incensarios, pues están santificados, y que tire las brasas que haya en ellos."
,"3":"Los incensarios de estos hombres que pecaron para su propio daño serán transformados en láminas para revestir el altar, pues fueron presentados al Señor y quedaron santificados; servirán de recuerdo para los israelitas'."
,"4":"Tomó Eleazar los incensarios de bronce que habían presentado los abrasados por el fuego y los transformó en láminas para el altar."
,"5":"Éstas recuerdan a los israelitas que ningún laico ajeno a la descendencia de Aarón puede acercarse a ofrecer incienso delante del Señor, si no quiere seguir la suerte de Coré y sus secuaces, tal como el Señor había ordenado por medio de Moisés."
,"6":"Al día siguiente toda la comunidad israelita murmuraba contra Moisés y Aarón: 'Vosotros habéis aniquilado el pueblo del Señor'."
,"7":"La comunidad se amotinó contra Moisés y Aarón, y ellos se fueron a la tienda de la reunión. La nube la cubrió y apareció la gloria del Señor."
,"8":"Moisés y Aarón entraron en la tienda de la reunión,"
,"9":"y el Señor dijo a Moisés:"
,"10":"'Alejaos de esta comunidad, pues la voy a destruir en un instante'. Ellos cayeron rostro en tierra."
,"11":"Moisés dijo a Aarón: 'Toma el incensario, pon en él fuego del altar, coloca encima el incienso, acércate sin perder tiempo a la comunidad y haz sobre ella el rito de absolución, pues se ha encendido la cólera del Señor y ha comenzado la mortandad'."
,"12":"Aarón tomó el incensario, como había dicho Moisés, y corrió hacia la asamblea. La mortandad ya había empezado a hacer estragos en el pueblo. Puso el incienso, hizo el rito de absolución sobre el pueblo,"
,"13":"se colocó entre los vivos y los muertos, y cesó la mortandad."
,"14":"Las víctimas se elevaron a 14.700, sin contar los que habían muerto a causa de Coré."
,"15":"Aarón volvió junto a Moisés a la tienda de la reunión; la mortandad se había detenido."
,"16":"El Señor dijo a Moisés:"
,"17":"'Ordena a los israelitas que cada jefe de tribu te traiga una vara, es decir, doce varas. Escribe los nombres de los jefes en sus respectivas varas."
,"18":"En la vara de Leví escribirás el nombre de Aarón, pues habrá una vara por cada jefe de tribu."
,"19":"Las depositarás luego en la tienda de la reunión, delante del testimonio, donde yo me comunico contigo."
,"20":"El hombre cuya vara florezca, ése es mi elegido; así los israelitas no hablarán ya mal de vosotros delante de mí'."
,"21":"Moisés se lo ordenó a los israelitas, y todos sus jefes trajeron cada uno su vara: doce varas. En medio de todas estaba la de Aarón."
,"22":"Moisés las puso delante del Señor en la tienda del testimonio."
,"23":"Al día siguiente, cuando Moisés vino a la tienda del testimonio, la vara de Aarón, la de la casa de Leví, había echado brotes, yemas, flores y almendras."
,"24":"Moisés retiró todas las varas de la presencia del Señor y las mostró a todos los israelitas. Éstos constataron lo ocurrido, y cada uno tomó su vara."
,"25":"El Señor dijo a Moisés: 'Vuelve a poner la vara de Aarón delante del testimonio y consérvala como señal para los hijos rebeldes, para que cesen sus quejas contra mí y no mueran'."
,"26":"Moisés lo hizo así; hizo lo que el Señor le había mandado."
,"27":"Los israelitas dijeron a Moisés: '¡Estamos perdidos! ¡Muertos somos! ¡Muertos todos!"
,"28":"Cualquiera que se acerque a la morada del Señor, morirá. ¿Vamos a morir todos?'."
}`)
	CurrentBook.AddChapter(18, `{
"1":"El Señor dijo a Aarón: 'Tú, tus hijos y la casa de tu padre llevaréis la responsabilidad del santuario. Tú y tus hijos llevaréis la responsabilidad del sacerdocio."
,"2":"Tendrás también contigo a tus hermanos de la rama de Leví, la tribu de tu padre. Admítelos contigo en el servicio del santuario como adjuntos. Te servirán a ti y a tus hijos cuando estéis en la tienda del testimonio."
,"3":"Estarán a tu servicio y al servicio de toda la tienda; pero no se acercarán a los objetos santos del santuario ni al altar, pues moriríais ellos y vosotros."
,"4":"Serán tus ayudantes y tendrán a su cuidado la tienda de la reunión con todos sus servicios; ningún extraño se acercará a vosotros."
,"5":"Tendréis cuidado del santuario y del altar, para que no se encienda ya más la cólera contra los israelitas."
,"6":"Yo he escogido a vuestros hermanos los levitas entre los israelitas; son vuestro don, han sido donados al Señor para hacer el servicio de la tienda de la reunión."
,"7":"Tú y tus hijos ejerceréis vuestras funciones sacerdotales en todo lo que se refiere al altar y a cuanto hay detrás del velo; sois vosotros los que habéis de hacer este servicio. Os he dado el ministerio del sacerdocio como un don; el extraño que se acerque morirá'."
,"8":"El Señor dijo a Aarón: 'Te confío la guarda de mis ofrendas. Todas las cosas consagradas a mí por los israelitas os las asigno a ti y a tus hijos como herencia por estatuto eterno."
,"9":"Esto es lo que te corresponderá de las cosas consagradas, no consumidas por el fuego: todas las ofrendas que me hagan los israelitas, las ofrendas de harina, los sacrificios por el pecado y los sacrificios de reconciliación; estas cosas consagradas son para ti y tus hijos."
,"10":"Os alimentaréis de cosas consagradas. Todo varón podrá comer de ellas. Serán para ti cosas santas."
,"11":"Te pertenecerá también lo que se reserva de las ofrendas de los israelitas que han sido hechas con el rito de presentación; te lo doy a ti y a tus hijos por estatuto perpetuo. Podrán comer todos los de tu casa siempre que estén puros."
,"12":"Todo lo mejor del aceite, del mosto y del trigo; estas primicias que ellos ofrecen al Señor, te las doy."
,"13":"Las primicias, que habrán de traer al Señor de todos los productos de su tierra, serán tuyas; todos los de tu casa podrán comer de ellas con tal que estén puros."
,"14":"Todo lo que Israel ofrezca al Señor te pertenecerá."
,"15":"El primogénito de toda especie, tanto de hombres como de animales, que se ofrece al Señor, será tuyo. Pero pedirás un rescate por los primogénitos de los hombres y de los animales impuros."
,"16":"El rescate se hará al mes de nacer, a razón de cinco monedas de plata según la unidad del santuario, que es de doce gramos."
,"17":"No aceptarás rescate por los primogénitos de las vacas, ovejas y cabras. Éstas son cosas santas; verterás su sangre sobre el altar, quemarás las grasas como ofrenda quemada de olor agradable al Señor,"
,"18":"y su carne será para ti lo mismo que el pecho ofrecido con rito de presentación y la pierna derecha."
,"19":"Todo lo que los israelitas ofrezcan al Señor, te lo doy a ti, a tus hijos e hijas por estatuto perpetuo. Alianza de sal eterna es ésta en presencia del Señor para ti y para toda tu descendencia'."
,"20":"El Señor dijo a Aarón: 'Tú no tendrás herencia en su tierra, no habrá parte para ti en medio de ellos. Yo mismo seré tu herencia y tu parte en medio de los israelitas."
,"21":"Yo doy como herencia a los hijos de Leví todos los diezmos de Israel en compensación de los servicios que prestan en la tienda de la reunión."
,"22":"De esta manera los israelitas no tendrán necesidad de acercarse a la tienda de la reunión, no se harán reos de pecado y no morirán."
,"23":"Serán los levitas los encargados del servicio en la tienda de la reunión; ellos tendrán toda la responsabilidad. Es ésta ley perpetua para todas las generaciones: los levitas no tendrán heredad en medio de los israelitas,"
,"24":"pues yo les doy como heredad los diezmos que los israelitas han de entregar al Señor. Por eso les digo: No tendréis heredad en medio de Israel'."
,"25":"El señor habló a Moisés:"
,"26":"'Di a los levitas: Cuando recibáis de los israelitas los diezmos de sus bienes, que yo os doy por herencia, también vosotros presentaréis al Señor en ofrenda una décima parte de los diezmos,"
,"27":"y esta ofrenda os será considerada como si fuera el trigo de la era o el mosto del lagar."
,"28":"Así también vosotros haréis al Señor una ofrenda de todos los diezmos que recibáis de los israelitas. Esta ofrenda, reservada al Señor, la entregaréis al sacerdote Aarón."
,"29":"De todos los dones que recibáis reservaréis la ofrenda al Señor: haréis esta reserva sagrada entre los dones mejores."
,"30":"Dirás a los levitas: Lo mejor que habéis reservado de entre vuestros diezmos os será considerado a vosotros, levitas, como el diezmo sobre el fruto de la era y el producto del lagar."
,"31":"Lo podréis comer en cualquier lugar, vosotros y los vuestros: es el salario por vuestro servicio en la tienda de la reunión."
,"32":"Una vez ofrecido lo mejor de vuestros diezmos, no incurriréis ya en culpa ni profanaréis las cosas consagradas por los israelitas, y no moriréis'."
}`)
	CurrentBook.AddChapter(19, `{
"1":"El Señor dijo a Moisés y Aarón:"
,"2":"'Ésta es la ley que ha dado el Señor: Di a los israelitas que traigan una novilla roja perfecta, sin defecto, que nunca haya llevado el yugo."
,"3":"La entregaréis al sacerdote Eleazar, que la sacará fuera del campamento y la hará inmolar en su presencia."
,"4":"El sacerdote Eleazar tomará con su dedo de la sangre y rociará con ella siete veces hacia el frente de la tienda de la reunión."
,"5":"Hará quemar la novilla en su presencia; será quemada piel, carne, sangre y excrementos."
,"6":"El sacerdote tomará madera de cedro, hisopo y púrpura, y lo echará en medio del fuego donde se quema la novilla."
,"7":"El sacerdote lavará luego sus vestidos y su cuerpo con agua, y después entrará en el campamento, pero será impuro hasta la tarde."
,"8":"El que haya quemado la novilla lavará también sus vestidos y su cuerpo con agua, y será impuro hasta la tarde."
,"9":"Un hombre en estado de pureza recogerá las cenizas de la novilla y las depositará fuera del campamento, en un lugar puro, donde serán conservadas para hacer el agua de purificación en la comunidad de los israelitas: es un sacrificio por el pecado."
,"10":"El que haya recogido las cenizas de la novilla limpiará sus vestidos y será impuro hasta la tarde. Es ley perpetua para los israelitas y los extranjeros residentes'."
,"11":"'El que toque un cadáver, de cualquier persona, quedará impuro durante siete días."
,"12":"Se purificará con estas aguas el tercero y séptimo día, y será puro; pero si no se purifica el tercero y séptimo día, no será puro."
,"13":"El que ha tocado el cadáver de una persona y no se purifica, contaminará la morada del Señor. Este hombre será extirpado de Israel, pues las aguas de purificación no han corrido sobre él; es impuro, su impureza reside en él."
,"14":"Ésta es la ley para el caso de un hombre que muere en una tienda: el que entre en la tienda y los que en ella se encuentren, quedarán impuros durante siete días."
,"15":"Igualmente quedarán impuras todas las vasijas que estén sin tapar."
,"16":"El que toque en el campo un hombre muerto por la espada o un muerto cualquiera, o huesos humanos, quedará impuro durante siete días."
,"17":"En tales casos de impureza tomarán de la ceniza de la novilla quemada en sacrificio por el pecado, echarán sobre ella un vaso de agua corriente;"
,"18":"uno que esté puro tomará el hisopo, lo mojará en agua y rociará la tienda, todos los muebles y todas las personas que estuvieran en ella y al que haya tocado huesos humanos, a un asesinado, a un muerto o un sepulcro."
,"19":"El hombre puro rociará al impuro el tercero y séptimo día, limpiará sus vestidos, se lavará y a la tarde será puro."
,"20":"El hombre impuro que no se purifique será extirpado de la comunidad, pues contaminaría el santuario del Señor. No ha sido rociado con el agua de purificación; es impuro."
,"21":"Es ley perpetua para ellos. El que rocía a otro con el agua de purificación lavará sus vestidos, y el que toque el agua de purificación quedará impuro hasta la tarde."
,"22":"Todo lo que toque el impuro quedará impuro, y el que toque al impuro quedará también impuro hasta la tarde'."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Los israelitas, toda la comunidad, llegaron al desierto de Sin el primer mes. El pueblo acampó en Cades. Allí murió María y allí fue sepultada."
,"2":"No había agua para la comunidad, y ésta se amotinó contra Moisés y Aarón."
,"3":"El pueblo se quejaba contra Moisés, diciendo: '¡Ojalá hubiéramos muerto como murieron nuestros hermanos delante del Señor!"
,"4":"¿Por qué habéis traído al pueblo del Señor a este desierto, para que muramos nosotros y nuestros ganados?"
,"5":"¿Para qué nos sacasteis de Egipto y nos trajisteis a este lugar maldito? Un lugar en el que no se puede sembrar nada, que no tiene viñas, ni higueras, ni granados, y donde ni siquiera hay agua para beber'."
,"6":"Moisés y Aarón se apartaron de la comunidad hacia la entrada de la tienda, y se les apareció la gloria del Señor."
,"7":"El Señor dijo a Moisés:"
,"8":"'Toma el bastón y reúne a la multitud tú y tu hermano Aarón; delante de todos ordena a la roca que les dé agua, y de la roca brotará agua para dar de beber a la multitud y a sus ganados'."
,"9":"Moisés tomó el bastón que estaba delante del Señor, como se le había ordenado,"
,"10":"y Moisés y Aarón convocaron a la multitud delante de la roca. Moisés les dijo: '¡Oíd, rebeldes! ¿Podremos nosotros hacer brotar agua de esta roca?'."
,"11":"Y alzando el brazo hirió por dos veces la roca con el bastón, y brotaron de ella aguas en abundancia; bebió la multitud y sus ganados."
,"12":"El Señor dijo a Moisés y Aarón: 'Por no haber creído en mí, manifestando mi santidad delante de los israelitas, no llevaréis vosotros a este pueblo a la tierra que yo les doy'."
,"13":"Éstas son las aguas de Meribá, donde los israelitas se quejaron contra el Señor, que les dio una prueba de su santidad."
,"14":"Moisés envió mensajeros desde Cades: 'Al rey de Edón. Esto dice tu hermano Israel: Tú conoces toda nuestra historia."
,"15":"Nuestros padres bajaron a Egipto, donde hemos estado largo tiempo, nosotros y nuestros padres, sufriendo malos tratos por parte de los egipcios."
,"16":"Clamamos al Señor, que oyó nuestra voz y envió un ángel, que nos sacó de Egipto. Y aquí estamos ahora en Cades, ciudad que se encuentra en los confines de tus dominios."
,"17":"Queremos cruzar, por favor, tu territorio. No atravesaremos tus sembrados, ni beberemos el agua de tus pozos; iremos por el camino real, sin desviarnos ni a derecha ni a izquierda, hasta que salgamos de tus confines'."
,"18":"Edón le respondió: 'No pases por mi territorio, si no quieres que salga con las armas a tu encuentro'."
,"19":"Los israelitas le contestaron: 'Subiremos por el camino trillado y, si bebemos de tus aguas, nosotros o nuestros ganados, te daremos el precio de ellas. Es cosa de nada: simplemente pasar a pie'."
,"20":"Pero él contestó: 'No pasarás'. Y Edón le salió al encuentro con mucha gente fuertemente armada."
,"21":"Como Edón les negó el paso, los israelitas se fueron por otro camino."
,"22":"La comunidad israelita partió de Cades y llegó a Hor de la Montaña."
,"23":"El Señor dijo a Moisés y a Aarón en Hor de la Montaña, que está en los confines de la tierra de Edón:"
,"24":"'Aarón va a morir, pues no puede entrar en la tierra que yo he dado a los israelitas, porque os rebelasteis contra mí en las aguas de Meribá."
,"25":"Toma a Aarón y a su hijo Eleazar y hazles subir a Hor de la Montaña."
,"26":"Despoja a Aarón de sus vestidos y pónselos a su hijo Eleazar. Y Aarón morirá allí'."
,"27":"Moisés hizo lo que el Señor le había mandado. Subieron a Hor de la Montaña a la vista de toda la comunidad."
,"28":"Moisés quitó los vestidos a Aarón y se los puso a su hijo Eleazar. Aarón murió allí, en la cima del monte. Moisés y Eleazar bajaron del monte."
,"29":"Toda la comunidad vio que Aarón había expirado, y toda la casa de Israel lloró a Aarón durante tres días."
}`)
	CurrentBook.AddChapter(21, `{
"1":"El rey de Arad, cananeo, que habitaba en el Negueb, al enterarse de que Israel venía por el camino de Atarín, lo atacó e hizo algunos prisioneros."
,"2":"Israel hizo este voto al Señor: 'Si entregas a este pueblo en mis manos, yo destruiré por completo sus ciudades'."
,"3":"El Señor los atendió, y entregó a los cananeos en manos de Israel, que los destruyó a ellos y sus ciudades. Por lo cual fue llamado aquel lugar Jormá."
,"4":"Partieron de Hor de la Montaña camino del mar Rojo, para rodear la tierra de Edón. En el camino empezó a impacientarse el pueblo,"
,"5":"que murmuraba contra el Señor y Moisés, diciendo: '¿Por qué nos sacasteis de Egipto, para hacernos morir en el desierto? No hay pan ni agua, y estamos ya hartos de esta comida miserable'."
,"6":"El Señor envió entonces contra el pueblo serpientes venenosas, que los mordían y hacían morir a muchos israelitas."
,"7":"El pueblo fue a decir a Moisés: 'Hemos pecado murmurando contra el Señor y contra ti. Pide al Señor que aleje de nosotros las serpientes'. Moisés intercedió por el pueblo."
,"8":"El Señor dijo a Moisés: 'Hazte una serpiente de bronce, ponla sobre un asta; los que hayan sido mordidos, al mirarla, sanarán'."
,"9":"Moisés hizo una serpiente de bronce y la puso sobre un asta; cuando alguno era mordido por una serpiente, miraba a la serpiente de bronce y quedaba curado."
,"10":"Los israelitas partieron y acamparon en Obot."
,"11":"Partieron de Obot y acamparon en Iyyé Haabarín, en el desierto al este de Moab."
,"12":"De allí fueron a acampar en el valle de Zared, y"
,"13":"de allí fueron al otro lado del Arnón... Este río salía, en el desierto, de los confines de los amorreos, y servía de frontera entre Moab y los amorreos. "
,"14":"Por eso se dice en el Libro de las guerras del Señor: '... Vaheb en Sufá y el valle del Arnón,"
,"15":"y la pendiente de los valles que se inclinan hacia la ciudad de Ar y se apoya en la frontera de Moab'."
,"16":"De allí fueron a Beer. Éste es el pozo del que el Señor había dicho a Moisés: 'Reúne al pueblo, y yo le daré agua'."
,"17":"Entonces cantó Israel este canto: 'Sube, pozo, ¡Cantadle!"
,"18":"Pozo cavado por los príncipes, abierto por los nobles del pueblo, con el cetro, con sus bastones'. De Beer fueron a Mataná; "
,"19":"de Mataná a Najaliel, de Najaliel a Bamot,"
,"20":"de Bamot al valle que se abre en la meseta de Moab hacia la cima del Pisga, que confina con el desierto y lo domina."
,"21":"Israel envió mensajeros a decir a Sijón, rey de los amorreos:"
,"22":"'Yo quiero cruzar tu tierra. No iremos ni por los campos ni por las viñas, ni beberemos el agua de los pozos. Seguiremos el camino real hasta que hayamos salido de tus fronteras'."
,"23":"Pero no dejó a Israel cruzar su territorio. Reunió a todo su pueblo, salió al encuentro de Israel en el desierto, alcanzándolo en Yahás, donde le dio batalla."
,"24":"Israel lo derrotó al filo de la espada, y conquistó su territorio desde el Arnón hasta el Yaboc, hasta los amonitas, pues Yahás estaba en la frontera de los amonitas."
,"25":"Israel se apoderó de todas estas ciudades de los amorreos, Jesbón y todas las ciudades de su jurisdicción,"
,"26":"pues Jesbón era la residencia de Sijón, rey de los amorreos. Éste había hecho anteriormente la guerra al rey de Moab y le había arrebatado todo el territorio hasta el Arnón."
,"27":"Por eso dicen los trovadores: 'Id a Jesbón; reedificad,y fortificad la capital de Sijón;"
,"28":"ha salido un fuego de Jesbón,y una llama de la ciudad de Sijón: ha devorado a Ar de Moab, ha consumido las alturas del Arnón."
,"29":"¡Ay de ti, Moab!,¡Estás perdido, pueblo de Camós!,Ha abandonado sus hijos a la fuga, y sus hijas a la esclavitud, a manos de Sijón, rey de los amorreos."
,"30":"Jesbón ha exterminado,los niños hasta Dibón, las mujeres hasta Nófaj, los hombres hasta Mádaba'."
,"31":"Israel se estableció en la tierra,de los amorreos."
,"32":"Moisés mandó a explorar a Yazer, la tomaron junto con las ciudades de su jurisdicción y expulsaron a los amorreos que habitaban allí."
,"33":"Cambiaron de dirección, y subieron camino de Basán. Og, rey de Basán, les salió al encuentro con todo su pueblo y les presentó batalla en Edreí."
,"34":"El Señor dijo a Moisés: 'No le temas, pues lo he entregado en tus manos, a él, a su pueblo y su territorio. Trátale como trataste a Sijón, rey de los amorreos, que habitaba en Jesbón'."
,"35":"Le derrotaron a él, a sus hijos y a todo su pueblo sin dejar escapar a nadie, y se apoderaron de su territorio."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Los israelitas fueron a acampar a los llanos de Moab, al otro lado del Jordán, a la altura de Jericó."
,"2":"Balac, hijo de Sipor, vio todo lo que Israel había hecho con los amorreos,"
,"3":"y Moab tembló de miedo ante aquel pueblo tan numeroso."
,"4":"Moab dijo a los ancianos de Madián: 'Esta muchedumbre va a devorar ahora nuestros contornos como devora un buey la hierba del campo'. Era entonces rey de Moab Balac, hijo de Sipor,"
,"5":"el cual envió mensajeros a Petor, junto al río Éufrates, en tierra de los amonitas, que fueron a buscar a Balaán, hijo de Beor, diciendo: 'Ha salido de Egipto un pueblo que cubre toda la tierra y está ya cerca de mí."
,"6":"Ven, por favor, y maldice a este pueblo, que es más numeroso que yo; a ver si podemos derrotarlo y expulsarlo, pues yo sé que es bendito aquel a quien tú bendices y maldito aquel a quien tú maldices'."
,"7":"Los ancianos de Moab y de Madián partieron llevando consigo el precio del agüero. Llegaron a Balaán y le comunicaron las palabras de Balac."
,"8":"Él les dijo: 'Pasad aquí la noche, y yo os responderé según lo que me diga el Señor'. Los príncipes de Moab se quedaron con Balaán."
,"9":"Dios se apareció a Balaán, y le dijo: '¿Quiénes son estos hombres que están contigo?'."
,"10":"Balaán respondió a Dios: 'Balac, hijo de Sipor, rey de Moab, los ha enviado a decirme:"
,"11":"Ha salido de Egipto un pueblo que cubre toda la tierra. Ven, por favor, a maldecirlo para ver si puedo derrotarlo y expulsarlo'."
,"12":"Dios dijo a Balaán: 'Tú no irás con ellos ni maldecirás a ese pueblo, que es bendito'."
,"13":"Balaán se levantó de mañana y dijo a los jefes que había enviado Balac: 'Partid para vuestra tierra, pues el Señor no me deja ir con vosotros'."
,"14":"Los jefes de Moab se levantaron, volvieron a Balac y le dijeron: 'Balaán se ha negado a venir con nosotros'."
,"15":"Balac envió otros jefes, pero más numerosos y más respetables que los primeros."
,"16":"Se llegaron a Balaán y le dijeron: 'Esto dice Balac, hijo de Sipor: No te niegues, por favor, a venir hasta mí,"
,"17":"pues te colmaré de honores y haré lo que me digas. Ven y maldice a este pueblo'."
,"18":"Balaán les respondió: 'Aunque Balac me diera su casa llena de plata y oro, yo no podría traspasar las órdenes del Señor, mi Dios, en cosa alguna, grande o pequeña;"
,"19":"pero pasad aquí también vosotros esta noche para saber lo que vuelve a decirme el Señor'."
,"20":"Dios se apareció a Balaán durante la noche y le dijo: '¿No han venido estas gentes a llamarte? Levántate y vete con ellos, pero no hagas más que lo que yo te diga'."
,"21":"Balaán se levantó de mañana, aparejó su burra y se fue con los jefes de Moab."
,"22":"Su partida encendió la cólera del Señor; y el ángel del Señor se puso delante de él, en el camino, para cerrarle el paso. Montaba Balaán su burra, y le acompañaban dos de sus criados."
,"23":"La burra, al ver al ángel del Señor apostado en el camino con la espada desenvainada en la mano, se salió del camino y tiró por el campo. Balaán le pegaba para hacerla volver al camino."
,"24":"El ángel del Señor se cruzó entonces en un camino estrecho, en medio de las viñas, con pared a un lado y a otro."
,"25":"La burra, al ver al ángel del Señor, pasó rozando la pared y pillando contra ella el pie de Balaán, el cual se puso a pegarle de nuevo."
,"26":"El ángel del Señor se adelantó y se puso otra vez en un lugar tan estrecho que no había espacio para pasar ni por un lado ni por otro."
,"27":"Cuando el asna vio al ángel del Señor, se tumbó debajo de Balaán, el cual, enfurecido, le pegaba con el palo."
,"28":"Entonces el Señor abrió la boca de la burra, que dijo a Balaán: '¿Qué te he hecho yo para que me hayas pegado por tres veces?'."
,"29":"Balaán respondió a la burra: 'Porque te burlas de mí. Si tuviera a mano una espada, ahora mismo te mataba'."
,"30":"La burra dijo a Balaán: '¿No soy tu burra, que te ha servido siempre de cabalgadura hasta hoy? ¿Te he hecho yo nunca cosa semejante?'. Él respondió: 'No'."
,"31":"El Señor abrió los ojos de Balaán y vio al ángel del Señor apostado en el camino con la espada desenvainada en la mano. Balaán se inclinó y se postró en tierra."
,"32":"El ángel del Señor le dijo: '¿Por qué has pegado a tu burra por tres veces? Era yo quien te cerraba el paso, pues me disgusta tu viaje."
,"33":"La burra me ha visto y por tres veces se ha apartado de mí. Gracias que se ha apartado, pues de otra manera te hubiera yo matado a ti, dejándola a ella con vida'."
,"34":"Balaán respondió al ángel del Señor: '¡He pecado! Yo no sabía que eras tú quien me cerraba el paso. Si la cosa te desagrada, ahora mismo me vuelvo'."
,"35":"El ángel del Señor dijo a Balaán: 'Vete con esos hombres, pero di solamente lo que yo te mande decir'. Y Balaán continuó con los jefes de Balac."
,"36":"Balac supo que llegaba Balaán y salió a su encuentro hacia Ir Moab, en la frontera del Arnón, al final de la frontera."
,"37":"Balac dijo a Balaán: '¿No envié yo mensajeros a llamarte? ¿Por qué no viniste? ¿Creías que no podía yo tratarte con el debido honor?'."
,"38":"Balaán dijo a Balac: 'Aquí me tienes junto a ti. ¿Podría yo ahora decir algo por mí mismo? La palabra que Dios me ponga en boca, ésa diré'."
,"39":"Balaán se fue con Balac y llegaron a Quiriat Jusot."
,"40":"Balac inmoló ganado mayor y menor, y lo envió a Balaán y a los jefes que le acompañaban."
,"41":"A la mañana siguiente, Balac tomó a Balaán y le hizo subir a Bamot Baal, desde donde se veía un ala del pueblo."
}`)
	CurrentBook.AddChapter(23, `{
"1":"Balaán dijo a Balac: 'Levántame aquí siete altares y prepárame siete novillos y siete carneros'."
,"2":"Balac hizo como le había dicho Balaán, y ambos ofrecieron un novillo y un carnero en cada uno de los altares."
,"3":"Balaán dijo a Balac: 'Quédate aquí, junto a tu holocausto, mientras yo voy a ver si el Señor sale a mi encuentro; lo que me dé a conocer, eso te diré'. Se fue hacia un monte desnudo,"
,"4":"y Dios se le apareció. Balaán le dijo: 'He dispuesto los siete altares y he ofrecido en cada uno de ellos un novillo y un carnero'."
,"5":"Entonces el Señor puso su palabra en boca de Balaán, y le dijo: 'Vuelve donde Balac y dile esto'."
,"6":"Balaán se volvió y encontró a Balac junto a su holocausto con todos los jefes de Moab."
,"7":"Balaán pronunció esta profecía: 'Balac me hace venir de Asiria, el rey de Moab, de los montes del este: Ven, maldíceme a Jacob, ven, amenaza a Israel."
,"8":"¿Cómo podría yo maldecir, cuando Dios no maldice?,¿Cómo podría yo amenazar, cuando Dios no amenaza?"
,"9":"Sí, desde la cima de la roca lo veo, desde lo alto de las colinas,lo contemplo. Es un pueblo que vive aparte, que no se cuenta entre las naciones."
,"10":"¿Quién podría contar el polvo,de Jacob?,¿Quién sería capaz de enumerar,las miríadas de Israel?,¡Tenga yo la muerte de los justos!,¡Sea mi final como el suyo!'."
,"11":"Balac dijo a Balaán: '¿Qué me has hecho? ¡Te había llamado para maldecir a mis enemigos, y los has bendecido!'."
,"12":"Balaán respondió: '¿No debo yo decir lo que el Señor pone en mis labios?'."
,"13":"Balac le contestó: 'Ven conmigo a otro sitio. Desde aquí no ves más que uno de los extremos del pueblo, no lo puedes ver entero. Maldícemelo desde allí'."
,"14":"Le llevó al campo de los Centinelas, hacia la cima del Pisga. Levantó siete altares e inmoló en cada uno un novillo y un carnero."
,"15":"Balaán dijo a Balac: 'Estáte aquí, junto a tu holocausto, mientras yo voy allá al encuentro'."
,"16":"Dios salió al encuentro de Balaán, le puso su palabra en la boca, y le dijo: 'Vuelve donde Balac y dile esto'."
,"17":"Fue donde Balac, y lo encontró junto a su holocausto con todos los jefes de Moab. '¿Qué te ha dicho el Señor?', le preguntó Balac."
,"18":"Balaán pronunció esta profecía: 'Levántate, Balac, y escucha; pon atención, hijo de Sipor."
,"19":"No es Dios un hombre,para que mienta, ni un ser humano,para que cambie de opinión. ¿Dice él y no hace?,¿Habla y no cumple?"
,"20":"Yo tengo orden de bendecir; bendeciré y no me volveré atrás."
,"21":"No veo iniquidad en Jacob, ni crimen alguno en Israel; el Señor, su Dios, está con él, y en él resuena la aclamación real."
,"22":"El Dios que lo sacó de Egipto,tiene para él la fuerza del búfalo."
,"23":"No valen presagios contra Jacob, ni sortilegios contra Israel. A su tiempo se dirá a Jacob, a Israel lo que Dios ha hecho."
,"24":"Este pueblo se alza como leona, se yergue como un león; no se acuesta,sin haber devorado su presa, sin haber bebido,la sangre de sus víctimas'."
,"25":"Balac dijo a Balaán: 'Si no puedes maldecírmelo, al menos no lo bendigas'."
,"26":"Balaán respondió a Balac: '¿No dije que haría lo que me dijera el Señor?'."
,"27":"Balac dijo a Balaán: 'Ven, que te llevo a otro sitio, a ver si finalmente Dios cree oportuno que me lo maldigas desde allí'."
,"28":"Balac llevó a Balaán a la cima del Fegor, que mira al desierto."
,"29":"Balaán dijo a Balac: 'Levántame aquí siete altares y prepárame aquí siete novillos y siete carneros'."
,"30":"Balac hizo como le había mandado Balaán e inmoló un novillo y un carnero en cada altar."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Balaán vio que el Señor se complacía en bendecir a Israel, y no fue ya como las otras veces en busca de presagios, sino que se volvió de cara al desierto."
,"2":"Levantó los ojos y vio a Israel acampado por tribus; el espíritu del Señor vino sobre él,"
,"3":"y pronunció esta profecía: 'Oráculo de Balaán, hijo de Beor, oráculo del hombre de mirada,penetrante;"
,"4":"oráculo del que oye la palabra de Dios. Ve lo que el todopoderoso le hace ver, cae en éxtasis y se abren sus ojos."
,"5":"¡Qué bellas son tus tiendas, Jacob; qué bellas tus moradas, Israel!"
,"6":"Como valles que se alargan, como jardines al borde de un río, como áloes plantados por el Señor, como cedros a la orilla del agua."
,"7":"El agua desborda de los cubos, sus sembrados son,abundantemente regados. Su rey es más fuerte que Agag, su reino crece en poderío."
,"8":"El Dios que lo sacó de Egipto,tiene para él la fuerza del búfalo. Devora las naciones enemigas. tritura sus huesos, las traspasa con sus saetas."
,"9":"Se agazapa, se echa como un león, como una leona. ¿Quién lo levantará?,¡Bendito sea el que te bendiga, y maldito el que te maldiga!'."
,"10":"Balac se enfureció contra Balaán y, dando palmadas, le dijo: 'Te había llamado para maldecir a mis enemigos y los has bendecido ya por tres veces."
,"11":"Lárgate a tu casa. Yo te había prometido grandes honores, pero el Señor te ha privado de ellos'."
,"12":"Balaán respondió a Balac: '¿No había dicho yo a tus mensajeros"
,"13":"que, aunque me dieras tu casa llena de oro y plata, yo no podría traspasar las órdenes del Señor ni hacer por propia iniciativa cosa alguna, buena o mala, sino que diría fielmente lo que dijera el Señor?"
,"14":"Ahora que me marcho con los míos, ven que te anuncie lo que este pueblo hará a tu pueblo en el futuro'."
,"15":"Y pronunció esta profecía: 'Oráculo de Balaán, hijo de Beor, oráculo del hombre de mirada,penetrante;"
,"16":"oráculo del que oye,las palabras de Dios, del que conoce la ciencia del altísimo, del que ve lo que el todopoderoso,le hace ver, cae en éxtasis y se abren sus ojos."
,"17":"Lo veo, pero no ahora; lo contemplo, pero no de cerca: una estrella se destaca de Jacob, surge un cetro de Israel. Aplasta las sienes de Moab,y el cráneo de los hijos de Set."
,"18":"Edón pasa a ser suyo. Seír pasa a ser su posesión. Israel despliega su poder."
,"19":"De Jacob saldrá un dominador,que acabará con los que queden,en la ciudad'."
,"20":"Balaán vio a Amalec y continuó,su profecía: 'Amalec: primicia de las naciones, pero su posteridad,perecerá para siempre'."
,"21":"Vio a los quenitas, y prosiguió: 'Tu mirada fue firme, Caín, y tu nido colgado en las rocas;"
,"22":"pero tu nido será pasto de las llamas,y Asiria te hará prisionero'."
,"23":"Y continuó así: '¡Ay! ¿Quién podrá vivir,cuando Dios haga estas cosas?"
,"24":"Naves de la parte de Kittim, oprimen a Asiria, oprimen a Eber; también ellos,perecerán para siempre'."
,"25":"Balaán se levantó y se fue a su tierra, mientras Balac se volvió también por su camino."
}`)
	CurrentBook.AddChapter(25, `{
"1":"Israel se estableció en Sitín, y el pueblo se dio al desenfreno con las mujeres moabitas."
,"2":"Ellas les invitaban a los sacrificios de sus dioses, y el pueblo comía y se prosternaba ante ellos."
,"3":"Israel dio culto a Baal Fegor, y la ira del Señor se encendió contra él."
,"4":"El Señor dijo a Moisés: 'Reúne a los jefes del pueblo y cuélgalos ante el Señor, a la luz del sol, para que se aparte de Israel la cólera encendida del Señor'."
,"5":"Moisés dijo a los jueces de Israel: 'Matad a todos los que hayan dado culto a Baal Fegor'."
,"6":"Un israelita llevó a su casa a una madianita a la vista de Moisés y de toda la comunidad, mientras estaban todos llorando a la entrada de la tienda de la reunión."
,"7":"Fineés, hijo de Eleazar y nieto del sacerdote Aarón, lo vio, se levantó en medio de la comunidad, tomó una lanza,"
,"8":"siguió al israelita hasta la alcoba y allí los traspasó a los dos en pleno vientre, al israelita y a la mujer. Y cesó el azote que pesaba sobre los israelitas;"
,"9":"habían muerto para entonces 24.000."
,"10":"El Señor dijo a Moisés:"
,"11":"'Fineés, hijo de Eleazar y nieto del sacerdote Aarón, ha apartado mi cólera de los israelitas, pues ha estado movido por mi mismo celo en medio de ellos. Por eso no he aniquilado yo en mi furor a los israelitas."
,"12":"Hazle saber que yo hago con él un pacto de paz."
,"13":"Será para él y para su descendencia un pacto que le asegurará el sacerdocio eternamente por haber sido celador de su Dios y haber obtenido el perdón para los israelitas."
,"14":"El israelita que había muerto junto con la madianita se llamaba Zimrí, hijo de Salú, y era jefe de una de las familias de Simeón."
,"15":"La mujer madianita que había muerto se llamaba Cozbí, hija de Sur, jefe de clan de una de las familias de Madián."
,"16":"El Señor dijo a Moisés:"
,"17":"'Atacad a los madianitas y derrotadlos,"
,"18":"pues os han tratado como enemigos seduciéndoos con sus malas artes en el caso de Fegor y de Cozbí, hermana de los madianitas e hija de uno de sus jefes, la que murió el día del azote sobrevenido con ocasión de lo de Fegor'."
}`)
	CurrentBook.AddChapter(26, `{
"1":"Después del azote, el Señor dijo a Moisés y al sacerdote Eleazar, hijo de Aarón:"
,"2":"'Haced el censo de toda la comunidad de los israelitas, por familias, de veinte años para arriba, aptos para la guerra'."
,"3":"Moisés y el sacerdote Eleazar les hablaron en los Llanos de Moab, cerca del Jordán, a la altura de Jericó, diciendo:"
,"4":"'Hagamos el censo de los hombres de veinte años para arriba', tal como el Señor había ordenado a Moisés. Éstos eran los israelitas que salieron de Egipto: "
,"5":"Rubén, primogénito de Israel. Hijos de Rubén: de Henoc, el clan henoquita; de Falú, el clan faluita;"
,"6":"de Jesrón, el clan jesronita; de Carmí, el clan carmita."
,"7":"Éstos eran los clanes rubenitas. Se registraron 43.730."
,"8":"Hijos de Falú: Eliab."
,"9":"Hijos de Eliab: Nemuel, Datán y Abirán. Datán y Abirán fueron hombres distinguidos de la comunidad, que se sublevaron contra Moisés y Aarón; eran del partido de Coré cuando éste se levantó contra el Señor,"
,"10":"cuando la tierra abrió sus fauces y se los tragó con Coré; perecieron al mismo tiempo sus secuaces, cuando el fuego devoró a los 250 hombres, para que sirviesen de escarmiento."
,"11":"Los hijos de Coré no murieron."
,"12":"Hijos de Simeón por clanes: de Nemuel, el clan nemuelita; de Yamín, el clan yaminita; de Yaquín, el clan yaquinita;"
,"13":"de Zéraj, el clan zerajita; de Saúl, el clan saulita."
,"14":"Tales eran los clanes simeonitas. Se registraron 22.200."
,"15":"Hijos de Gad, por clanes: de Safón, el clan safonita; de Jaguí, el clan jaguita; de Suní, el clan sunita;"
,"16":"de Ozní, el clan oznita; de Erí, el clan erita;"
,"17":"de Arod, el clan arodita; de Arelí, el clan arelita."
,"18":"Tales eran los clanes de los hijos de Gad. Se registraron 40.500."
,"19":"Hijos de Judá: Er y Onán, que murieron en la tierra de Canaán."
,"20":"Hijos de Judá, por clanes: de Selá, el clan selaíta; de Fares, el clan faresita; de Zéraj, el clan zerajita."
,"21":"Los hijos de Fares fueron: de Jesrón, el clan jesronita; de Jamul, el clan jamulita."
,"22":"Tales eran los clanes de Judá. Se registraron 76.500."
,"23":"Hijos de Isacar, por clanes: de Tolá, el clan tolaíta; de Puvá, el clan puvaíta;"
,"24":"de Yasub, el clan yasubita; de Simrón, el clan simronita."
,"25":"Tales eran los clanes de Isacar. Se registraron 64.300."
,"26":"Hijos de Zabulón, por clanes: de Séred, el clan seredita; de Elón, el clan elonita; de Yajleel, el clan yajleelita."
,"27":"Tales eran los clanes de Zabulón. Se registraron 60.500."
,"28":"Hijos de José, por clanes: Manasés y Efraín."
,"29":"Hijos de Manasés: de Maquir, el clan maquirita; Maquir engendró a Galaad; de Galaad, el clan galaadita."
,"30":"Éstos son los hijos de Galaad: de Yéser, el clan yeserita; de Jélec, el clan jelequita;"
,"31":"de Asriel, el clan asrielita; de Siquén, el clan siquenita;"
,"32":"de Semidá, el clan semidita; de Jéfer, el clan jeferita;"
,"33":"Selofjad, hijo de Jéfer, no tuvo hijos, sino hijas; éstos son sus nombres: Majlá, Noá, Joglá, Milcá y Tirsá."
,"34":"Tales eran los clanes de Manasés. Se registraron 52.700."
,"35":"Hijos de Efraín, por clanes: de Sutálaj, el clan sutalajita; de Béquer, el clan bequerita; de Taján, el clan tajanita."
,"36":"Hijos de Sutálaj: de Erán, el clan eranita."
,"37":"Tales eran los clanes de Efraín. Se registraron 32.500. Tales eran los hijos de José, por clanes."
,"38":"Hijos de Benjamín, por clanes: de Bela, el clan belaíta; de Asbel, el clan asbelita; de Ajirán, el clan ajiranita;"
,"39":"de Sufán, el clan sufanita; de Jufán, el clan jufanita."
,"40":"Hijos de Bela fueron Ard y Naamán: de Ard, el clan ardita; de Naamán, el clan naamanita."
,"41":"Tales eran los clanes de Benjamín. Se registraron 45.600."
,"42":"Hijos de Dan, por clanes: de Suján, el clan sujanita. Tales eran los clanes de Dan."
,"43":"De los clanes sujanitas se registraron 64.400."
,"44":"Hijos de Aser, por clanes: de Yimná, el clan yimnaíta; de Yisví, el clan yisvita; de Beriá, el clan beriaíta."
,"45":"Hijos de Beriá: de Jéber, el clan jeberita; de Malquiel, el clan malquielita."
,"46":"La hija de Aser se llamaba Sáraj."
,"47":"Tales eran los clanes de Aser. Se registraron 53.400."
,"48":"Hijos de Neftalí, por clanes: de Yajseel, el clan yajseelita; de Guní, el clan gunita;"
,"49":"de Yéser, el clan yeserita; de Silén, el clan silenita."
,"50":"Tales eran los clanes de Neftalí. Se registraron 45.400."
,"51":"El número total de los israelitas registrados fue 601.730."
,"52":"El Señor dijo a Moisés:"
,"53":"'Entre éstos se distribuirá la tierra como herencia, según el número de los inscritos."
,"54":"A los más numerosos les darás una porción mayor; a los menos numerosos, una parte más pequeña: a cada uno, su herencia según el número de hombres."
,"55":"Sin embargo, la partición de la tierra se hará por suertes. Se hará la repartición según los nombres de las tribus patriarcales;"
,"56":"la herencia de cada tribu se repartirá por suertes, teniendo en cuenta el número mayor y menor."
,"57":"Clanes de los levitas registrados: de Guersón, el clan guersonita; de Quehat, el clan quehatita; de Merarí, el clan merarita."
,"58":"Clanes levitas: el clan libnita, el hebronita, el majlita, el musita, el coreíta. Quehat engendró a Amrán."
,"59":"Amrán se casó con Yoquébed, hija de Leví, nacida en Egipto, de la que tuvo tres hijos: Aarón, Moisés y María."
,"60":"Aarón engendró a Nadab, Abihú, Eleazar e Itamar."
,"61":"Nadab y Abihú murieron cuando ofrecían ante el Señor un fuego profano."
,"62":"Todos los varones registrados mayores de un mes fueron 23.000. No habían sido registrados entre los israelitas, pues no habían recibido herencia con ellos."
,"63":"Éste es el censo de los israelitas que hicieron Moisés y el sacerdote Eleazar, en los Llanos de Moab, cerca del Jordán, a la altura de Jericó."
,"64":"Ninguno de éstos era el censo que hicieron Moisés y Aarón en el desierto del Sinaí,"
,"65":"pues el Señor había dicho: 'Éstos morirán en el desierto y no quedará ninguno, excepto Caleb, hijo de Jefoné, y Josué, hijo de Nun'."
}`)
	CurrentBook.AddChapter(27, `{
"1":"Se acercaron entonces las hijas de Selofjad, hijo de Jéfer, hijo de Galaad, hijo de Maquir, hijo de Manasés, de uno de los clanes de Manasés, hijo de José. Se llamaban: Majlá, Noá, Joglá, Milcá y Tirsá."
,"2":"Se presentaron ante Moisés, al sacerdote Eleazar, a los jefes y a toda la comunidad a la entrada de la tienda de la reunión, y"
,"3":"dijeron: 'Nuestro padre murió en el desierto, pero no era del partido que se formó contra el Señor, de la facción de Coré. Murió por su propio pecado y sin dejar hijos varones."
,"4":"¿Por qué va a ser borrado el nombre de nuestro padre de en medio de su clan por no haber dejado hijos varones? Dadnos a nosotras una propiedad como a los hermanos de nuestro padre'."
,"5":"Moisés llevó el caso delante del Señor,"
,"6":"y el Señor dijo a Moisés:"
,"7":"'Las hijas de Selofjad tienen razón. Les darás, pues, una propiedad en herencia, como a los hermanos de su padre, y harás pasar a ellas la herencia de su padre."
,"8":"Y dirás a los israelitas: Si un hombre muere sin haber dejado hijos, haréis pasar la herencia a su hija."
,"9":"Si no tiene hijas, pasará la herencia a sus hermanos."
,"10":"Si no tiene hermanos, daréis la herencia a los hermanos de su padre."
,"11":"Si su padre no tiene hermanos, daréis su herencia al pariente más cercano del clan, el cual tomará posesión de ella. Ésta será para los hijos de Israel una regla de derecho, tal como el Señor ordenó a Moisés'."
,"12":"El Señor dijo a Moisés: 'Sube a este monte de los Abarín y contempla la tierra que voy a dar a los israelitas."
,"13":"Cuando la hayas contemplado, irás a reunirte con los tuyos, como Aarón, tu hermano,"
,"14":"pues fuisteis rebeldes en el desierto de Sin, cuando la comunidad se querelló conmigo, cuando yo os mandé manifestar ante ella mi santidad mediante las aguas'. (Éstas son las aguas de Meribá, de Cades, en el desierto de Sin)."
,"15":"Moisés dijo al Señor:"
,"16":"'¡Que el Señor, el Dios de los espíritus que dan vida a todo ser viviente, establezca sobre esta comunidad un hombre"
,"17":"que vaya y venga al frente de ellos, que los haga entrar y salir, para que la comunidad del Señor no sea como rebaño sin pastor!'."
,"18":"El Señor respondió a Moisés: 'Toma a Josué, hijo de Nun, sobre quien reside el espíritu, y pon tu mano sobre él."
,"19":"Preséntalo luego al sacerdote Eleazar y a toda la comunidad, y en su presencia le darás órdenes"
,"20":"y le transmitirás parte de tu autoridad, para que le preste obediencia toda la comunidad israelita."
,"21":"Se presentará delante del sacerdote Eleazar, que consultará por él al Señor, por medio del urim. A sus órdenes saldrán y entrarán con él todos los israelitas, toda la comunidad'."
,"22":"Moisés hizo lo que le había ordenado el Señor. Tomó a Josué, le hizo presentarse ante el sacerdote Eleazar y ante toda la comunidad,"
,"23":"le impuso las manos y le dio el cargo, tal como el Señor le había ordenado por medio de Moisés."
}`)
	CurrentBook.AddChapter(28, `{
"1":"El Señor dijo a Moisés:"
,"2":"'Ordena a los israelitas: Presentadme a su debido tiempo mis ofrendas, mis alimentos, sacrificios quemados de olor agradable para mí."
,"3":"Les dirás: Éstas son las ofrendas quemadas en honor del Señor. Diariamente, dos corderos de un año, sin defecto, como holocausto perpetuo. "
,"4":"Uno por la mañana y el otro por la tarde, entre dos luces, y"
,"5":"una ofrenda de cuatro kilos y medio de flor de harina, amasada con dos litros de aceite puro de oliva."
,"6":"Es el holocausto perpetuo que se ofrecía ya en el monte Sinaí, ofrenda quemada de olor agradable en honor del Señor."
,"7":"La ofrenda de vino será de dos litros por cada cordero. La ofrenda del vino la harás en el santuario en honor del Señor."
,"8":"El segundo cordero lo ofrecerás entre dos luces; lo harás con las mismas ofrendas de pan y de vino de la mañana, como sacrificio quemado, de olor agradable, en honor del Señor'."
,"9":"'El sábado, dos corderos de un año sin defecto, una ofrenda de nueve kilos de flor de harina amasada con aceite y su correspondiente ofrenda de vino."
,"10":"Éste es el holocausto propio del sábado, con su correspondiente ofrenda de vino, además del holocausto diario'."
,"11":"'El primer día de cada mes ofreceréis como holocausto al Señor dos novillos, un carnero y siete corderos de un año, sin defecto;"
,"12":"y por cada novillo, una ofrenda de trece kilos y medio de flor de harina amasada con aceite; por el carnero, nueve kilos de flor de harina amasada con aceite,"
,"13":"y por cada uno de los corderos, cuatro kilos y medio de flor de harina amasada con aceite. Es holocausto de suave olor, ofrenda quemada en honor del Señor."
,"14":"Las correspondientes ofrendas de vino serán de cuatro litros por novillo, de dos litros y medio por carnero y de dos litros por cordero. Éste es el holocausto para todos los meses del año."
,"15":"Además del holocausto diario y su correspondiente ofrenda de vino, será ofrecido al Señor un macho cabrío en sacrificio por el pecado'."
,"16":"'El día catorce del primer mes es la pascua del Señor,"
,"17":"y el día quince de este mes es día de fiesta. Durante siete días se comerá pan sin levadura."
,"18":"El primer día habrá asamblea santa; no haréis ningún trabajo."
,"19":"Ofreceréis al Señor en holocausto dos novillos, un carnero y siete corderos de un año, sin defecto,"
,"20":"y la ofrenda de flor de harina amasada con aceite: trece kilos y medio por novillo, nueve kilos y medio por carnero"
,"21":"y cuatro kilos y medio por cordero."
,"22":"Ofreceréis también un macho cabrío en sacrificio por el pecado para hacer sobre vosotros el rito de absolución."
,"23":"Ofreceréis todo esto, además del holocausto que se ofrece diariamente por la mañana."
,"24":"Lo haréis diariamente durante siete días. Es un alimento, un sacrificio de olor agradable quemado en honor del Señor, además del holocausto diario y su correspondiente ofrenda de vino."
,"25":"El séptimo día tendréis asamblea santa; no haréis ningún trabajo'."
,"26":"'El día de las primicias, cuando vayáis a presentar al Señor la ofrenda de los frutos nuevos en vuestra fiesta de las semanas, tendréis asamblea santa; no haréis ningún trabajo."
,"27":"Presentaréis al Señor un holocausto de olor agradable, dos novillos, un carnero y siete corderos de un año,"
,"28":"y una ofrenda de flor de harina amasada con aceite: trece kilos y medio por novillo,"
,"29":"nueve kilos por carnero y cuatro kilos y medio por cordero."
,"30":"Ofreceréis también un macho cabrío en sacrificio por el pecado para hacer sobre vosotros el rito de absolución."
,"31":"Todo esto, además del holocausto diario y su correspondiente ofrenda de vino'."
}`)
	CurrentBook.AddChapter(29, `{
"1":"'El primer día del séptimo mes tendréis asamblea santa; no haréis ningún trabajo. Será para vosotros éste el día de las aclamaciones."
,"2":"Presentaréis al Señor un holocausto de olor agradable: un novillo, un carnero y siete corderos de un año, sin defecto,"
,"3":"y una ofrenda de flor de harina amasada con aceite: trece kilos y medio por novillo, nueve kilos por carnero"
,"4":"y cuatro kilos y medio por cordero."
,"5":"Ofreceréis también un macho cabrío en sacrificio por el pecado para hacer sobre vosotros el rito de absolución."
,"6":"Todo esto, además del holocausto diario, con sus correspondientes ofrendas de pan y de vino, según lo prescrito. Es una ofrenda de olor agradable quemada en honor del Señor."
,"7":"El diez del mismo séptimo mes tendréis asamblea santa; ayunaréis y no haréis ningún trabajo."
,"8":"Ofreceréis un holocausto de olor agradable al Señor: un novillo, un carnero y siete corderos de un año, sin defecto,"
,"9":"y la correspondiente ofrenda de flor de harina amasada con aceite: trece kilos y medio por novillo, nueve kilos por carnero"
,"10":"y cuatro kilos y medio por cordero;"
,"11":"y un macho cabrío en sacrificio por el pecado. Todo esto, además del sacrificio por el pecado del día del perdón y del holocausto diario, con sus correspondientes ofrendas de pan y de vino."
,"12":"El día quince del séptimo mes tendréis asamblea santa y no haréis en él ningún trabajo. Celebraréis fiesta en honor del Señor durante siete días."
,"13":"Ofreceréis en holocausto de olor agradable al Señor catorce corderos de un año, sin defecto,"
,"14":"y la correspondiente ofrenda de flor de harina amasada con aceite: trece kilos y medio por novillo, nueve kilos por carnero"
,"15":"y cuatro kilos y medio por cordero."
,"16":"Y un macho cabrío en sacrificio por el pecado; todo esto, además del holocausto diario, con sus correspondientes ofrendas de pan y de vino."
,"17":"El segundo día ofreceréis doce novillos, dos carneros y catorce corderos de un año, sin defecto,"
,"18":"con las ofrendas correspondientes de pan y de vino, según el número de novillos, carneros y corderos;"
,"19":"y un macho cabrío por el pecado, además del holocausto diario, con sus correspondientes ofrendas de pan y de vino."
,"20":"El tercer día ofreceréis once novillos, dos carneros y catorce corderos de un año, sin defecto,"
,"21":"con las ofrendas correspondientes de pan y de vino, según el número de novillos, carneros y corderos;"
,"22":"y un macho cabrío para el sacrificio por el pecado, además del holocausto diario, con sus correspondientes ofrendas de pan y de vino."
,"23":"El cuarto día ofreceréis diez novillos, dos carneros y catorce corderos de un año, sin defecto,"
,"24":"con las correspondientes ofrendas de pan y vino, según el número de novillos, carneros y corderos;"
,"25":"y un macho cabrío para el sacrificio por el pecado, además del holocausto diario, con sus correspondientes ofrendas de pan y de vino."
,"26":"El quinto día ofreceréis nueve novillos, dos carneros y catorce corderos de un año, sin defecto,"
,"27":"con las correspondientes ofrendas de pan y de vino, según el número de novillos, carneros y corderos;"
,"28":"y un macho cabrío para el sacrificio por el pecado, además del holocausto diario, con sus correspondientes ofrendas de pan y de vino."
,"29":"El sexto día ofreceréis ocho novillos, dos carneros y catorce corderos de un año, sin defecto,"
,"30":"con las correspondientes ofrendas de pan y de vino, según el número de novillos, carneros y corderos;"
,"31":"y un macho cabrío para el sacrificio por el pecado, además del holocausto diario, con sus correspondientes ofrendas de pan y de vino."
,"32":"El séptimo día ofreceréis siete novillos, dos carneros y catorce corderos de un año, sin defecto,"
,"33":"con las correspondientes ofrendas de pan y de vino, según el número de novillos, carneros y corderos;"
,"34":"y un macho cabrío para el sacrificio por el pecado, además del holocausto diario, con sus correspondientes ofrendas de pan y de vino."
,"35":"El día octavo tendréis consejo, y no haréis en él ningún trabajo."
,"36":"Ofreceréis en holocausto de olor agradable al Señor un novillo, un carnero y siete corderos de un año, sin defecto,"
,"37":"con las correspondientes ofrendas de pan y de vino, según el número de novillos, carneros y corderos;"
,"38":"y un macho cabrío en sacrificio por el pecado, además del holocausto diario, con sus correspondientes ofrendas de pan y de vino."
,"39":"Esto es lo que ofreceréis al Señor en vuestras fiestas, además de vuestras ofrendas votivas o espontáneas, de vuestros holocaustos, ofrendas de pan y de vino y sacrificios de reconciliación'."
}`)
	CurrentBook.AddChapter(30, `{
"1":"Moisés dijo a los israelitas todo lo que el Señor le había ordenado."
,"2":"Dijo a los jefes de tribu de Israel: 'Esto manda el Señor:"
,"3":"Si un hombre hace un voto al Señor o se obliga con juramento a alguna cosa, no faltará a su palabra; todo lo que haya salido de su boca, lo cumplirá."
,"4":"Cuando una mujer, joven todavía, que habita en casa de su padre, hace un voto al Señor o se compromete formalmente con juramento,"
,"5":"si el padre, al conocer el voto o la obligación contraída, no dice nada, todos sus votos son válidos, lo mismo que todas las obligaciones que haya contraído."
,"6":"Pero si el padre, al tener conocimiento de ello, lo desaprueba, entonces todos sus votos y todas las obligaciones contraídas son nulos, y el Señor la perdonará, pues ha sido su padre quien se ha opuesto."
,"7":"Si se casa estando todavía ligada por algún voto o compromiso contraído a la ligera,"
,"8":"si al saberlo su marido se calla y no le dice nada el día en que se entera, sus votos y los compromisos contraídos son válidos."
,"9":"Pero si el marido, al saberlo, lo desaprueba, anula el voto que hizo y el compromiso contraído a la ligera. El Señor la perdonará."
,"10":"El voto de una viuda o de una divorciada y todos los compromisos por ellas contraídos son válidos."
,"11":"Si una mujer hace un voto o se compromete a algo con juramento estando ya en casa de su marido,"
,"12":"si el marido, al saberlo, no le dice nada ni lo desaprueba, todos sus votos serán válidos, así como las obligaciones contraídas."
,"13":"Pero si su marido, al saberlo, los anula el día en que lo ha sabido, todo lo que salió de sus labios, votos y obligaciones, quedan sin valor; su marido los ha anulado y el Señor la perdonará."
,"14":"El marido puede anular o ratificar cualquier voto o juramento con que ella se obligue."
,"15":"Pero si el marido, día tras día, se calla, ratifica todos sus votos y todos los compromisos por ella contraídos, pues no le dijo nada el día que los conoció."
,"16":"Si los anula algún tiempo después de haberlos conocido, sobre él pesará la falta de su mujer'."
,"17":"Éstas son las leyes que el Señor dio a Moisés en lo que se refiere a las relaciones entre marido y mujer y entre padre e hija, cuando ésta es todavía joven y habita en casa de su padre."
}`)
	CurrentBook.AddChapter(31, `{
"1":"El Señor dijo a Moisés:"
,"2":"'Véngate de los madianitas en nombre de los israelitas, y después morirás'."
,"3":"Moisés dijo a su pueblo: 'Armaos algunos de vosotros para la guerra del Señor contra Madián, para hacer pesar sobre Madián la venganza del Señor."
,"4":"Pondréis en pie de guerra mil hombres por cada una de las tribus de Israel'."
,"5":"Se reclutaron entre los millares de Israel mil hombres por cada tribu, es decir, doce mil hombres en pie de guerra."
,"6":"Moisés envió al combate aquellos mil hombres por tribu, y con ellos mandó a Fineés, hijo del sacerdote Eleazar, el cual llevaba los objetos sagrados y las trompetas para dar las señales de la guerra."
,"7":"Presentaron batalla contra Madián, como el Señor había ordenado a Moisés, y mataron a todos los varones."
,"8":"Mataron además a los reyes de Madián, Eví, Requen, Sur, Jur y Reba, cinco reyes de Madián. Pasaron también al filo de la espada a Balaán, hijo de Beor."
,"9":"Los israelitas se llevaron prisioneras a las mujeres de los madianitas con sus niños; saquearon todos sus ganados, rebaños y riquezas."
,"10":"Incendiaron todas las ciudades habitadas y todos sus campamentos."
,"11":"Todo su botín, todo cuanto habían capturado, hombres y ganados, se lo"
,"12":"llevaron a Moisés, al sacerdote Eleazar y a toda la comunidad israelita, que estaban acampados en los Llanos de Moab, junto al Jordán, a la altura de Jericó."
,"13":"Moisés, el sacerdote Eleazar y todos los jefes de la comunidad les salieron al encuentro fuera del campamento."
,"14":"Pero Moisés se enfureció contra los comandantes del ejército, jefes de millares y centurias que venían del combate."
,"15":"Les dijo: '¿Por qué habéis dejado con vida a las mujeres?"
,"16":"Fueron ellas, precisamente, las que por consejo de Balaán sedujeron a los israelitas, apartándolos del Señor en el caso de Fegor, lo cual dio ocasión al azote que pesó sobre la comunidad de Israel."
,"17":"Matad, pues, a todos los niños varones y a todas las mujeres que han conocido lecho de varón,"
,"18":"y dejad con vida a las jóvenes que no lo han conocido."
,"19":"Vosotros, permaneced durante siete días fuera del campamento, y el que entre vosotros o vuestros prisioneros haya matado a alguien o haya tocado un cadáver, purifíquese el tercero y séptimo día."
,"20":"Purificad también todos vuestros vestidos, todo objeto de cuero o hecho de pelo de cabra y todo utensilio de madera'."
,"21":"El sacerdote Eleazar dijo a los combatientes que volvían de la campaña: 'Ésta es una ley que el Señor dio a Moisés:"
,"22":"El oro, la plata, el bronce, el hierro, el estaño y el plomo,"
,"23":"todo lo que puede resistir el fuego, pasadlo por el fuego, y será puro después de haber sido lavado también con el agua de purificación. Lo que no resista al fuego, lavadlo con agua."
,"24":"El séptimo día lavad vuestros vestidos, y quedaréis puros. Luego podréis entrar en el campamento'."
,"25":"El Señor dijo a Moisés:"
,"26":"'Tú, el sacerdote Eleazar y los cabezas de familia de la comunidad contad lo capturado, en hombres y ganados,"
,"27":"y repartidlo, mitad y mitad, entre los combatientes que han ido a la guerra y el resto de la comunidad."
,"28":"De la mitad correspondiente a los combatientes, reserva como tributo al Señor el uno por quinientos en hombres, bueyes, asnos y ovejas;"
,"29":"lo tomarás y lo entregarás al sacerdote Eleazar, como tributo reservado al Señor."
,"30":"De la mitad correspondiente a los israelitas tomarás el uno por cincuenta en hombres, bueyes, asnos, ovejas y animales de toda clase, y se lo darás a los levitas que cuidan de la morada del Señor'."
,"31":"Moisés y el sacerdote Eleazar hicieron lo que el Señor había ordenado a Moisés."
,"32":"El botín capturado, sin contar lo que los soldados recogieron por su parte, sumaba 675.000 cabezas de ganado menor,"
,"33":"72.000 cabezas de ganado mayor,"
,"34":"61.000 asnos;"
,"35":"y en efectivo humano, de mujeres que no habían compartido lecho de varón, 32.000 personas en total."
,"36":"La mitad correspondiente a los que habían hecho la campaña fue de 337.500 cabezas de ganado menor,"
,"37":"de las cuales 675 se reservaron como tributo al Señor;"
,"38":"36.000 cabezas de ganado mayor, de las cuales 72 se reservaron al Señor;"
,"39":"30.500 asnos, de los cuales 61 se reservaron al Señor,"
,"40":"y 16.000 personas, de las cuales 32 quedaron para el Señor."
,"41":"Moisés entregó al sacerdote Eleazar el tributo reservado para el Señor, tal como el Señor había ordenado a Moisés."
,"42":"La mitad correspondiente a los israelitas, que Moisés había separado de la de los combatientes,"
,"43":"esta mitad, que tocó a la comunidad, fue de 337.500 cabezas de ganado menor,"
,"44":"36.000 cabezas de ganado mayor,"
,"45":"30.500 asnos"
,"46":"y 16.000 personas."
,"47":"De esta mitad correspondiente a los israelitas, Moisés tomó el uno por cincuenta en hombres y animales, y se lo entregó a los levitas que se cuidaban del servicio en la morada del Señor, tal como el Señor había ordenado a Moisés."
,"48":"Los comandantes de la expedición, jefes de millar y jefes de centuria se presentaron a Moisés"
,"49":"para decirle: 'Tus siervos han hecho el recuento de los hombres de guerra que han estado a nuestras órdenes, y no falta ninguno."
,"50":"Traemos, pues, como ofrenda al Señor los objetos de oro, brazaletes, cadenas, anillos, pendientes y collares que cada uno ha encontrado, para hacer el rito de absolución sobre nosotros delante del Señor'."
,"51":"Moisés y el sacerdote Eleazar recibieron de sus manos el oro y todas las alhajas."
,"52":"El oro presentado al Señor por los jefes de millar y de centuria dio un total de doscientos kilos."
,"53":"Los combatientes se reservaron cada uno su botín."
,"54":"Moisés y el sacerdote Eleazar recibieron el oro de los jefes de millar y de centuria y lo llevaron a la tienda de la reunión para que sirviera a los israelitas de memorial ante el Señor."
}`)
	CurrentBook.AddChapter(32, `{
"1":"Los hijos de Rubén y los hijos de Gad tenían grandes y numerosos rebaños. Cuando vieron que la tierra de Yazer y la de Galaad eran lugares muy aptos para la ganadería,"
,"2":"los hijos de Rubén y los hijos de Gad vinieron a Moisés, al sacerdote Eleazar y a los jefes de la comunidad, y les dijeron:"
,"3":"'Atarot, Dibón, Yazer, Nimrá, Jesbón, Elalé, Sebán, Nebo y Meón,"
,"4":"esta tierra que el Señor ha conquistado para los israelitas, es apropiada para la ganadería, y tus siervos son gente ganadera."
,"5":"Si tus siervos han hallado gracia a tus ojos, danos en propiedad esta tierra y no nos hagas pasar el Jordán'."
,"6":"Moisés les respondió: 'Mientras vuestros hermanos van al combate, ¿vosotros vais a quedaros aquí?"
,"7":"¿Por qué desanimáis a los israelitas para que no pasen a la tierra que el Señor les da?"
,"8":"Así hicieron ya vuestros padres, cuando yo los envié a Cades a explorar la tierra."
,"9":"Subieron hasta el valle de Escol y, después de haber visto la tierra, desanimaron a los israelitas para que no fuesen a la tierra que el Señor les daba."
,"10":"De suerte que aquel día el Señor montó en cólera e hizo este juramento:"
,"11":"Los hombres que han salido de Egipto de veinte años para arriba no verán la tierra que con juramento prometí yo a Abrahán, Isaac y Jacob, porque no me han seguido con fidelidad, a"
,"12":"excepción de Caleb, hijo de Jefoné, el quenizita, y Josué, hijo de Nun, que han seguido los caminos del Señor sin desfallecer."
,"13":"El Señor montó en cólera contra los israelitas y los hizo vagar durante cuarenta años por el desierto, hasta que desapareció enteramente aquella generación que había contrariado al Señor."
,"14":"Y vosotros queréis seguir las huellas de vuestros padres, como engendro de raza pecadora, y encender todavía más la cólera del Señor contra Israel."
,"15":"Porque si os negáis a seguirlo, él continuará manteniendo a Israel en el desierto y seréis causa de la ruina total del pueblo'."
,"16":"Entonces se acercaron a Moisés y le dijeron: 'Nosotros levantaremos aquí apriscos para nuestros ganados y ciudades para nuestras familias."
,"17":"Pero, al mismo tiempo, tomaremos también las armas e iremos delante de los israelitas hasta que los hayamos introducido en el lugar a ellos destinado. Nuestras familias quedarán en ciudades amuralladas, defendidas de los habitantes de esta tierra."
,"18":"No volveremos a nuestras tierras hasta que los israelitas hayan tomado posesión de la heredad, cada uno de la suya."
,"19":"Más aún; no queremos heredad alguna al otro lado del Jordán, ni más allá, puesto que nuestra heredad estará de este lado del Jordán, en la parte oriental'."
,"20":"Moisés les dijo: 'Si cumplís vuestra palabra, si estáis prontos al combate a las órdenes del Señor"
,"21":"y si todos vuestros hombres de guerra pasan el Jordán a las órdenes del Señor hasta que hayan echado de su presencia todos sus enemigos,"
,"22":"entonces, una vez sometida la tierra al Señor, podréis volver y quedaréis exonerados ante el Señor y ante Israel, y este territorio será vuestra propiedad en presencia del Señor."
,"23":"Pero si no obráis así, pecaréis contra el Señor, y sabed que vuestro pecado pesará sobre vosotros."
,"24":"Construid ciudades para vuestras familias y apriscos para vuestros ganados, pero cumplid lo que habéis prometido'."
,"25":"Los hijos de Gad y los hijos de Rubén dijeron a Moisés: 'Tus siervos harán cuanto mi señor les manda."
,"26":"Nuestros niños, nuestras mujeres, nuestros rebaños y todos nuestros ganados quedarán aquí, en las ciudades de Galaad;"
,"27":"pero tus siervos, aptos para la guerra, irán a las órdenes del Señor para combatir tal como nos lo has mandado'."
,"28":"Entonces Moisés dio estas órdenes al sacerdote Eleazar, a Josué, hijo de Nun, y a los cabezas de familia de las tribus de Israel:"
,"29":"'Si los hijos de Gad y los hijos de Rubén, aptos para la guerra, pasan con vosotros el Jordán para combatir a las órdenes del Señor, una vez conquistada la tierra les daréis como herencia la tierra de Galaad."
,"30":"Pero si no pasan con vosotros armados, se establecerán en medio de vosotros en la tierra de Canaán'."
,"31":"Los hijos de Gad y los hijos de Rubén respondieron: 'Haremos lo que el Señor ha dicho a tus siervos."
,"32":"Pasaremos armados a las órdenes del Señor a la tierra de Canaán, pero danos posesión de nuestra herencia a este lado del Jordán'."
,"33":"Moisés dio a los hijos de Gad, a los hijos de Rubén y a media tribu de Manasés, hijo de José, el reino de Sijón, rey de los amorreos; el reino de Og, rey de Basán; la tierra con sus ciudades y las ciudades fronterizas."
,"34":"Los hijos de Gad edificaron Dibón, Atarot, Aroer,"
,"35":"Atarot-Sofán, Yazer, Yogbohá,"
,"36":"Bet-Nimrá y Bet-Harán, ciudades fuertes, y levantaron apriscos para sus ganados."
,"37":"Los hijos de Rubén edificaron Jesbón, Elalé, Quiriat, Yerín,"
,"38":"Nebo y Baal Meón, cuyos nombres fueron cambiados, y Sibmá. Dieron nuevos nombres a las ciudades que habían edificado."
,"39":"Los hijos de Maquir, hijo de Manasés, marcharon contra Galaad, la conquistaron y expulsaron a los amorreos que se encontraban allí."
,"40":"Moisés dio Galaad a Maquir, hijo de Manasés, que se estableció allí."
,"41":"Yaír, hijo de Manasés, marchó también y se apoderó de sus aduares, y los llamó Aduares de Yaír."
,"42":"Nóbaj se apoderó de Quenat y de las ciudades de su jurisdicción, y la llamó con su propio nombre, Nóbaj."
}`)
	CurrentBook.AddChapter(33, `{
"1":"Éstas son las etapas de los israelitas cuando salieron por escuadras de Egipto, acaudillados por Moisés y Aarón."
,"2":"Moisés consignó por escrito el punto de partida de sus etapas realizadas por orden del Señor. Son éstas:"
,"3":"Partieron de Rameses el día quince del primer mes. Al día siguiente de la pascua, los israelitas salieron con gran poder, a la vista de todo Egipto."
,"4":"Los egipcios estaban sepultando a todos los que el Señor había hecho morir, a todos los primogénitos. El Señor había hecho justicia contra sus dioses."
,"5":"Los israelitas partieron de Rameses y acamparon en Sucot."
,"6":"Parieron de Sucot y acamparon en Etán, que está en los confines del desierto."
,"7":"Partieron de Etán y se volvieron hacia Pi Hajirot, que está enfrente de Baal Sefón, y acamparon frente a Migdol."
,"8":"Partieron de Pi Hajirot, pasaron por medio del mar hacia el desierto y, después de tres días de camino en el desierto de Etán, acamparon en Mará."
,"9":"Partieron de Mará y llegaron a Elín, donde había doce fuentes y setenta palmeras; allí acamparon."
,"10":"Partieron de Elín y acamparon junto al mar Rojo."
,"11":"Partieron del mar Rojo y acamparon en el desierto de Sin."
,"12":"Partieron del desierto de Sin y acamparon en Dofca."
,"13":"Partieron de Dofca y acamparon en Alús."
,"14":"Partieron de Alús y acamparon en Rafidín, donde el pueblo no encontró agua para beber."
,"15":"Partieron de Rafidín y acamparon en el desierto del Sinaí."
,"16":"Partieron del desierto del Sinaí y acamparon en Quibrot Hattaavá."
,"17":"Partieron de Quibrot Hattaavá y acamparon en Jaserot."
,"18":"Partieron de Jaserot y acamparon en Ritmá."
,"19":"Partieron de Ritmá y acamparon en Rimón Peres."
,"20":"Partieron de Rimón Peres y acamparon en Libná."
,"21":"Partieron de Libná y acamparon en Risá."
,"22":"Partieron de Risá y acamparon en Quehelatá."
,"23":"Partieron de Quehelatá y acamparon en el monte Séfer."
,"24":"Partieron del monte Séfer y acamparon en Jaradá."
,"25":"Partieron de Jaradá y acamparon en Maquelot."
,"26":"Partieron de Maquelot y acamparon en Tájat."
,"27":"Partieron de Tájat y acamparon en Táraj."
,"28":"Partieron de Táraj y acamparon en Mitcá."
,"29":"Partieron de Mitcá y acamparon en Jasmoná."
,"30":"Partieron de Jasmoná y acamparon en Moserot."
,"31":"Partieron de Moserot y acamparon en Bene Yaacán."
,"32":"Partieron de Bene Yaacán y acamparon en Jor Haguidgad."
,"33":"Partieron de Jor Haguidgad y acamparon en Yotbatá."
,"34":"Partieron de Yotbatá y acamparon en Abrona."
,"35":"Partieron de Abrona y acamparon en Asiongaber."
,"36":"Partieron de Asiongaber y acamparon en el desierto de Sin, que es Cades."
,"37":"Partieron de Cades y acamparon en Hor de la Montaña, en los confines de la tierra de Edón."
,"38":"Aarón, sacerdote, subió a Hor de la Montaña por orden del Señor, y allí murió en el año cuarenta de la salida de los israelitas de Egipto, el día primero del quinto mes."
,"39":"Aarón tenía ciento veintitrés años cuando murió en la cima de Hor de la Montaña."
,"40":"El rey de Arad, un cananeo que habitaba el Negueb, en la tierra de Canaán, tuvo conocimiento de la llegada de los israelitas."
,"41":"Partieron de Hor de la Montaña y acamparon en Salmoná."
,"42":"Partieron de Salmoná y acamparon en Punón."
,"43":"Partieron de Punón y acamparon en Obot."
,"44":"Partieron de Obot y acamparon en Iyyé Haabarín, en los confines de Moab."
,"45":"Partieron de Iyyé Haabarín y acamparon en Dibón Gad."
,"46":"Partieron de Dibón Gad y acamparon en Almón Diblatáyim."
,"47":"Partieron de Almón Diblatáyim y acamparon en los montes Abarín frente a Nebo."
,"48":"Partieron de los montes Abarín y acamparon en los Llanos de Moab, junto al Jordán, a la altura de Jericó;"
,"49":"acamparon a lo largo del Jordán, desde Bet Hayesimot hasta Abel Hassitín, en los Llanos de Moab."
,"50":"En los Llanos de Moab, junto al Jordán, a la altura de Jericó, el Señor dijo a Moisés:"
,"51":"'Di a los israelitas:"
,"52":"Cuando hayáis pasado el Jordán hacia la tierra de Canaán, echaréis lejos de vosotros a todos los habitantes de la tierra, destruiréis todas sus estatuas de piedra e imágenes de metal fundido y destruiréis todas sus colinas sagradas."
,"53":"Tomaréis posesión de esta tierra y moraréis en ella, pues yo os la doy en posesión."
,"54":"La distribuiréis por suertes entre vuestros clanes; según éstos sean más o menos numerosos, les daréis una heredad grande o pequeña. La que caiga en suerte a cada uno, ésa será su heredad, y haréis la partición según las tribus patriarcales."
,"55":"Pero si no echáis lejos de vosotros a los habitantes de la tierra, los que hayáis dejado en medio de vosotros vendrán a ser espinas en vuestros ojos y zarzas en vuestros costados; os molestarán en la tierra que vais a habitar,"
,"56":"y os trataré a vosotros como había pensado tratarlos a ellos'."
}`)
	CurrentBook.AddChapter(34, `{
"1":"El Señor dijo a Moisés:"
,"2":"'Ordena a los israelitas: Cuando entréis en la tierra de Canaán, el territorio de vuestra heredad será el siguiente: la tierra de Canaán según sus fronteras."
,"3":"La región meridional de vuestra heredad empezará en el desierto de Sin, que confina con Edón. Vuestra frontera meridional, por la parte oriental, arrancará del extremo del mar Muerto."
,"4":"Luego torcerá hacia el sur en dirección de la Subida de los Escorpiones, pasará por Sin para morir al sur, en Cades Barne. Continuará por Jasar Adar y pasará por Asemón."
,"5":"Partiendo de Asemón, la frontera torcerá hacia el torrente de Egipto y morirá en el mar."
,"6":"Como frontera occidental tendréis el mar Mediterráneo."
,"7":"La frontera norte será ésta: trazaréis una línea desde el mar Mediterráneo hasta Hor de la Montaña;"
,"8":"de Hor de la Montaña trazaréis otra línea hasta la entrada de Jamat, que irá a morir en Sedadá."
,"9":"Continuará por Zefrón para terminar en Enán. Ésta será vuestra frontera norte."
,"10":"Vuestra frontera oriental irá de Jasar Enán a Sefán."
,"11":"Descenderá de Sefán a Rebla, al este de Ayín, y continuará bajando hasta la ribera oriental del lago de Genesaret."
,"12":"La frontera seguirá entonces el río Jordán hasta llegar al mar Muerto. Ésta será vuestra tierra y las fronteras que la rodearán'."
,"13":"Moisés dio esta orden a los israelitas: 'Ésta es la tierra que os dividiréis por suertes y que el Señor ha ordenado dar a las nueve tribus y media,"
,"14":"pues la tribu de los hijos de Rubén y la tribu de los hijos de Gad con sus casas patriarcales han recibido ya su herencia. Media tribu de Manasés ha recibido también la suya."
,"15":"Estas dos tribus y media han recibido su herencia al oriente del Jordán, frente a Jericó'."
,"16":"El Señor dijo a Moisés:"
,"17":"'Éstos son los nombres de los que os repartirán la tierra: el sacerdote Eleazar y Josué, hijo de Nun."
,"18":"Elegiréis también un jefe de cada tribu para la distribución de la tierra."
,"19":"Éstos son sus nombres: por la tribu de Judá, Caleb, hijo de Jefoné;"
,"20":"por la tribu de los hijos de Simeón, Samuel, hijo de Amihud;"
,"21":"por la tribu de Benjamín, Elidad, hijo de Caselón;"
,"22":"por la tribu de los hijos de Dan, el jefe Boquí, hijo de Yoglí;"
,"23":"por los hijos de José: por la tribu de los hijos de Manasés, el jefe Janiel, hijo de Efod;"
,"24":"por la tribu de los hijos de Efraín, el jefe Camuel, hijo de Seftán;"
,"25":"por la tribu de los hijos de Zabulón, el jefe Elisafán, hijo de Parnac;"
,"26":"por la tribu de los hijos de Isacar, el jefe Patiel, hijo de Azán;"
,"27":"por la tribu de los hijos de Aser, el jefe Ajihud, hijo de Salomí;"
,"28":"por la tribu de los hijos de Neftalí, el jefe Pedael, hijo de Amihud."
,"29":"Éstos son a quienes el Señor manda distribuir la tierra de Canaán entre los israelitas'."
}`)
	CurrentBook.AddChapter(35, `{
"1":"El Señor dijo a Moisés en los Llanos de Moab, junto al Jordán:"
,"2":"'Ordena a los israelitas que de las posesiones de su propiedad cedan a los levitas ciudades en las que puedan habitar y pastos en sus contornos."
,"3":"Tendrán así ciudades para habitar y pastos para sus animales, ganados y toda clase de bestias."
,"4":"Los pastos que daréis a los levitas en torno a las ciudades se extenderán quinientos metros a la redonda, a partir de las murallas."
,"5":"Mediréis fuera de la ciudad mil metros al este, mil al sur, mil al oeste y mil al norte, quedando en medio la ciudad. Ésta será la superficie de pastos en torno a las ciudades."
,"6":"Las ciudades que deis a los levitas serán seis ciudades de refugio, cedidas por vosotros para que en ellas encuentre asilo el homicida, y otras cuarenta y dos ciudades más,"
,"7":"es decir, cuarenta y ocho ciudades con sus respectivos términos."
,"8":"Estas ciudades se tomarán de la heredad de los israelitas, en mayor número del que más tenga y en menor del que tenga menos; la cesión de ciudades a los levitas será proporcional a la herencia que cada uno haya recibido'."
,"9":"El Señor dijo a Moisés:"
,"10":"'Di a los israelitas: Cuando hayáis pasado el Jordán hacia la tierra de Canaán"
,"11":"encontraréis ciudades que serán para vosotros ciudades de refugio, donde hallará asilo el homicida que haya matado a alguno involuntariamente."
,"12":"Estas ciudades os servirán de asilo contra el vengador de sangre, para que no sea matado el homicida antes de comparecer en juicio ante la comunidad."
,"13":"Serán seis estas ciudades de refugio."
,"14":"Tres al oriente del Jordán y tres en Canaán."
,"15":"Estas seis ciudades servirán de refugio para los israelitas y para los extranjeros residentes o de paso; en ellas se podrá refugiar el que haya matado a alguno involuntariamente."
,"16":"Pero si lo ha herido con un objeto de hierro y se sigue la muerte, es homicida, y el homicida debe morir."
,"17":"Si lo hirió con una piedra capaz de causar la muerte, y la muerte se sigue, es homicida, y el homicida será castigado con la muerte."
,"18":"Si lo hirió con un palo capaz de producirle la muerte, y la muerte se sigue, es un homicida, y el homicida será castigado con la muerte."
,"19":"Es el vengador de sangre quien matará al homicida; cuando lo encuentre lo matará."
,"20":"Si lo derribó por odio o arrojó alguna cosa contra él intencionadamente, y se sigue la muerte;"
,"21":"o si por enemistad lo golpea a puñetazos y se sigue la muerte, el culpable debe morir. Es un homicida, y el vengador de sangre lo matará cuando lo encuentre."
,"22":"Pero si lo derriba sin querer, sin odio, o arroja contra él alguna cosa sin querer;"
,"23":"si le tira una piedra capaz de producirle la muerte, sin verlo, y la muerte se sigue, sin que fuera su enemigo ni quisiera hacerle daño alguno,"
,"24":"juzgará la comunidad, según estas reglas, entre el que ha herido y el vengador de sangre,"
,"25":"salvando al homicida de las manos del vengador de sangre; lo volverá a la ciudad de refugio donde había huido, y allí se quedará hasta la muerte del sumo sacerdote ungido con el óleo santo."
,"26":"Si el homicida sale del territorio de la ciudad de asilo donde está refugiado"
,"27":"y el vengador de sangre lo encuentra fuera del territorio de su ciudad de refugio, podrá matarlo sin ninguna responsabilidad,"
,"28":"porque el homicida debe permanecer en su ciudad de refugio hasta la muerte del sumo sacerdote. Solamente después de la muerte del sumo sacerdote podrá volver a la tierra donde tiene su heredad."
,"29":"Estas disposiciones serán norma de justicia para vosotros y para vuestros descendientes, dondequiera que viváis."
,"30":"En casos de homicidio se condenará a muerte al homicida después que hayan declarado los testigos; pero el testimonio de un solo testigo no basta para condenar a muerte a una persona."
,"31":"No aceptaréis rescate por la vida de un homicida reo de muerte: debe morir."
,"32":"Tampoco aceptaréis rescate para dejar salir al refugiado de su ciudad de refugio y que habite en su tierra antes de la muerte del sumo sacerdote."
,"33":"No profanaréis la tierra que habitáis, porque la sangre profana la tierra, y la tierra no puede ser purificada de la sangre vertida sobre ella, sino con la sangre del que la ha vertido."
,"34":"No profanéis la tierra que habitáis, en medio de la cual habito yo también, pues yo soy el Señor, que habito en medio de los israelitas'."
}`)
	CurrentBook.AddChapter(36, `{
"1":"Los cabezas de familia de los clanes de Galaad, hijo de Maquir, hijo de Manasés, uno de los clanes de la casa de José, fueron a ver a Moisés y a los jefes de familia israelitas,"
,"2":"y dijeron: 'El Señor ha ordenado a mi señor que reparta la tierra a los israelitas echando suertes y que la heredad de Selofjad, nuestro hermano, se la diera a sus hijas."
,"3":"Si ellas se casan con alguno de otras tribus de Israel, su heredad será sustraída de la heredad de nuestros padres para ir a aumentar la parte de la tribu a la que ellas van a pertenecer, mientras será reducida la parte que a nosotros ha caído en suerte."
,"4":"Incluso cuando llegue el jubileo para los israelitas, la heredad de estas mujeres quedará añadida a la heredad de la tribu a la que pertenezcan y, por tanto, sustraída de la heredad de nuestra tribu'."
,"5":"Entonces Moisés dio estas prescripciones a los israelitas, por orden del Señor: 'La tribu de los hijos de José tiene razón."
,"6":"El Señor permite que las hijas de Selofjad se casen con quien quieran, siempre que sea dentro de uno de los clanes pertenecientes a la tribu de su padre."
,"7":"La heredad de los israelitas no pasará de tribu en tribu; los israelitas quedarán vinculados cada uno a la heredad de su tribu paterna."
,"8":"La mujer que posea herencia en alguna de las tribus de los israelitas deberá casarse con alguno de su propia tribu, para que los israelitas conserven cada uno la heredad de sus padres."
,"9":"Las herencias no podrán pasar de una tribu a otra; cada una de las tribus de los israelitas permanecerá vinculada a su heredad'."
,"10":"Las hijas de Selofjad hicieron lo que el Señor había ordenado a Moisés:"
,"11":"Majlá, Tirsá, Joglá, Miclá y Noá se casaron con hijos de sus tíos paternos,"
,"12":"descendientes de Manasés, hijo de José; así su heredad quedó en la tribu de su clan paterno."
,"13":"Éstos son los mandamientos y leyes que el Señor dio a los israelitas por medio de Moisés en los Llanos de Moab, junto al Jordán, a la altura de Jericó."
}`)

}
func ES_LSB_LoadVSCCChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"El poema más bello, de Salomón."
,"2":"Ella: ¡Que me bese con los besos de su boca!"
,"3":"Más dulces que el vino tus amores son, suave es el olor de tus perfumes. Tu nombre es un perfume refinado; por eso las jóvenes se enamoran de ti."
,"4":"Arrástrame tras de ti: ¡corramos!,El rey me ha llevado a sus estancias. Seamos felices y gocemos contigo. Celebremos tus amores más que el vino. ¡Con cuánta razón se enamoran de ti!"
,"5":"Morena soy, pero hermosa, hijas de Jerusalén, como las tiendas de Quedar, como los pabellones de Salomón."
,"6":"No os fijéis en que soy morena; es que el sol me ha bronceado. Los hijos de mi madre, airados contra mí, me pusieron a guardar sus viñas; y mi viña, la mía, no la guardé."
,"7":"Dime tú, amor de mi vida, dónde estás descansando, dónde llevas el ganado a mediodía, para que yo no ande perdida,por los rebaños de tus compañeros."
,"8":"Coro: Si no lo sabes, tú, la más bella de las mujeres, sigue el rastro de las ovejas,y lleva a pastar tus cabritos,junto a las chozas de los pastores."
,"9":"Él: A las yeguas de la carroza del Faraón,yo te comparo, amor mío."
,"10":"Bellas son tus mejillas entre los pendientes,y tu cuello entre los collares."
,"11":"Pendientes de oro haremos para ti,con lóbulos de plata."
,"12":"Ella: Mientras el rey se halla en su diván, mi nardo exhala su perfume."
,"13":"Bolsita de mirra es mi amor para mí, que reposa entre mis pechos."
,"14":"Ramo de ciprés es mi amor para mí,en las viñas de Engadí."
,"15":"Él: ¡Qué hermosa eres, amor mío, qué hermosa eres!,Tus ojos son como palomas..."
,"16":"Ella: ¡Qué hermoso eres, amor mío, qué delicioso!,Todo verdor es nuestro lecho."
,"17":"Vigas de nuestra casa son los cedros; cipreses, los artesonados."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Yo soy el narciso de Sarón, el lirio de los valles."
,"2":"Como el lirio entre cardos, así es mi amada entre las jóvenes."
,"3":"Ella: Como manzano entre árboles silvestres, así es mi amado entre los jóvenes. A su sombra apetecida estoy sentada, y su fruto me es dulce al paladar."
,"4":"Me ha llevado a su bodega, y su insignia sobre mí es el amor."
,"5":"Confortadme con pasteles de uvas, reanimadme con manzanas, porque enferma estoy de amor."
,"6":"Su izquierda está bajo mi cabeza, y su diestra me tiene abrazada."
,"7":"Él: Yo os conjuro, hijas de Jerusalén, por las gacelas y las ciervas del campo, no despertéis, no turbéis a mi amor,hasta cuando ella quiera."
,"8":"Ella: ¡Una voz!... ¡Es mi amor!,He aquí que ya llega saltando por los montes, brincando por los collados."
,"9":"Semejante es mi amor a una gacela, a un ágil cervatillo. Vedlo ya aquí apostado detrás de nuestra cerca. Mira por las ventanas, espía por las celosías."
,"10":"Mi amor canta y me dice: Él: '¡Levántate, amor mío; hermosa mía, ven!"
,"11":"Porque, mira, ha pasado el invierno, ha cesado la lluvia y ya se ha ido."
,"12":"Han nacido las flores en la tierra, ha llegado el tiempo de la poda; ya la voz de la tórtola se siente en nuestra tierra."
,"13":"La higuera echa las yemas de sus higos, las viñas en flor exhalan su perfume. ¡Levántate, amor mío; hermosa mía, ven!"
,"14":"Paloma mía, en las grietas de las peñas, en escarpados escondrijos, muéstrame tu rostro, déjame oír tu voz, porque tu voz es dulce,y tu rostro encantador'."
,"15":"'Cazadnos las raposas, las raposas pequeñas, que estropean la viña, pues nuestras viñas están en flor'."
,"16":"Ella: Mi amado es mío y yo soy suya. Él apacienta su rebaño entre los lirios."
,"17":"Mientras sopla la brisa del día,y las sombras se desvanecen, vuelve, amor mío; sé como la gacela o el joven cervatillo,en los montes perfumados."
}`)
	CurrentBook.AddChapter(3, `{
"1":"En mi lecho, por la noche, busqué al amor de mi vida; lo busqué, pero no lo encontré."
,"2":"Me levantaré, recorreré la ciudad; por las calles y las plazas buscaré al amor de mi vida... Lo busqué, pero no lo encontré."
,"3":"Me encontraron los centinelas, los que hacen la ronda por la ciudad: '¿Habéis visto al amor de mi vida?'."
,"4":"Apenas los había pasado,cuando encontré al amor de mi vida. Lo abracé y no lo he de soltar,hasta que no lo haga entrar en la casa de mi madre, en la alcoba de la que me engendró."
,"5":"Él: Yo os conjuro, hijas de Jerusalén, por las gacelas y las ciervas del campo, no despertéis ni turbéis a mi amor,hasta cuando ella quiera."
,"6":"Coro: ¿Qué es eso que sube del desierto,como columna de humo, perfume de mirra y de incienso,y de todo aroma de perfumes?"
,"7":"Ella: Es la litera de Salomón: sesenta próceres la escoltan, son la flor de Israel. Todos expertos en la espada, veteranos de la guerra; cada uno lleva su espada al flanco, en previsión de sorpresas nocturnas."
,"8":"El rey Salomón se ha hecho,un trono de madera del Líbano."
,"9":"Ha puesto de plata sus columnas, de oro su dosel, de púrpura el asiento, todo por dentro recamado con amor,por las hijas de Jerusalén."
,"10":"Salid a contemplar, hijas de Sión, al rey Salomón, con la diadema con que lo coronó su madre,el día de sus bodas, el día de las delicias de su corazón."
}`)
	CurrentBook.AddChapter(4, `{
"1":"¡Qué hermosa eres, amor mío, qué hermosa eres!,Tus ojos, de paloma, a través de tu velo. Tu melena, cual rebaño de cabras ondulante,por las pendientes de Galaad."
,"2":"Tus dientes, cual rebaño de ovejas esquiladas,que regresa del baño, cada una con crías mellizas, y ninguna privada de ellas."
,"3":"Como cinta de escarlata tus labios, tu boca encantadora. Tus mejillas, mitades de granada,a través de tu velo."
,"4":"Como torre de David tu cuello, edificada como fortaleza; mil escudos de ella penden, todos los paveses de los héroes."
,"5":"Tus pechos, como dos crías mellizas de gacela,que pacen entre lirios."
,"6":"Mientras sopla la brisa del día,y las sombras se desvanecen, iré al monte de la mirra, a la colina del incienso."
,"7":"¡Toda hermosa eres, amor mío, no hay tacha alguna en ti!"
,"8":"Ven del Líbano, novia; ven del Líbano, entra. Mira desde la cima del Amaná, desde las crestas del Senir y del Hermón, desde las guaridas de leones, desde los riscos de leopardos."
,"9":"Me robaste el corazón, hermana mía, novia mía, me robaste el corazón,con una mirada de tus ojos, con una perla del collar."
,"10":"¡Qué delicioso es tu amor, hermana mía, novia mía, qué delicioso tu amor, más que el vino!,¡Y el olor de tus perfumes,más que todos los aromas!"
,"11":"Miel virgen destilan tus labios, novia mía: leche y miel hay bajo tu lengua; y el aroma de tus vestidos, como el aroma del Líbano."
,"12":"Jardín cerrado eres, hermana mía, novia mía, un manantial cerrado, una fuente sellada."
,"13":"Un vergel de granados tus brotes, con los más exquisitos productos:"
,"14":"nardo y azafrán, canela y cinamomo, con toda clase de árboles de incienso, mirra y áloe con los bálsamos más finos."
,"15":"Ella: Yo soy una fuente de jardines, manantial de aguas vivas, arroyos que del Líbano fluyen."
,"16":"Levántate, Aquilón; Austro, ven; soplad en mi jardín y exhale sus aromas. ¡Entre mi amor en su vergel,y coma sus frutos exquisitos!"
}`)
	CurrentBook.AddChapter(5, `{
"1":"He entrado en mi jardín, hermana mía, novia mía, he recogido mi bálsamo y mi mirra, he comido mi miel y mi panal, he bebido mi vino y mi leche. Coro: ¡Comed, amigos, y bebed, embriagaos, compañeros!"
,"2":"Ella: Yo dormía, pero mi corazón velaba... ¡Una voz!,Mi amor me llama: ' breme, hermana mía, amiga mía, paloma mía, mi perfecta; mi cabeza está cubierta de rocío; mis bucles, del relente de la noche...'."
,"3":"'Me he quitado ya mi túnica; ¿he de ponérmela otra vez?,Me he lavado los pies; ¿los volveré a manchar?'."
,"4":"Mi amor metió la mano,por el cerrojo de la puerta; al oírlo, mis entrañas retozaron."
,"5":"Me levanté para abrir a mi amor, y mis manos destilaron mirra, mirra fluida mis dedos,en la manilla de la cerradura."
,"6":"Abrí a mi amor, pero mi amor se había ido. Se me fue el alma tras de él. Lo busqué y no lo encontré, lo llamé y no me respondió."
,"7":"Los centinelas me encontraron, los que hacen la ronda en la ciudad; me golpearon, me hirieron, me arrancaron el velo los guardias de los muros."
,"8":"Yo os conjuro, hijas de Jerusalén, si encontráis a mi amor, ¿qué le vais a decir? Que enferma estoy de amor."
,"9":"Coro: ¿Qué distingue a tu amado de los otros, tú, la más bella de las mujeres?,¿Qué distingue a tu amor de los otros, para que así nos conjures?"
,"10":"Ella: Mi amado es radiante y rubio, distinguido entre millares."
,"11":"Su cabeza es oro, oro puro; sus guedejas, racimos de palmeras, negras igual que el cuervo."
,"12":"Sus ojos son como palomas,junto a las aguas del arroyo, bañadas en leche, posadas en la orilla."
,"13":"Eras de bálsamo sus mejillas, macizos de perfumes. Sus labios son lirios,que destilan mirra virgen."
,"14":"Sus brazos, barras de oro, engastadas con piedras de Tarsis; su vientre, una masa de marfil,guarnecida de zafiros."
,"15":"Sus piernas son columnas de alabastro,sobre pedestales de oro puro. Su aspecto es como el del Líbano, imponente cual los cedros."
,"16":"Su boca es colmo de dulzura, todo en él es delicia. Así es mi amor, así mi amigo, hijas de Jerusalén."
}`)
	CurrentBook.AddChapter(6, `{
"1":"¿Dónde se fue tu amor, tú, la más bella de las mujeres?,¿Adónde se dirigió tu amor, para que contigo lo busquemos?"
,"2":"Ella: Mi amor ha bajado a su jardín, a las eras del bálsamo, a apacentar su rebaño en los jardines, a recoger lirios."
,"3":"Yo soy de mi amor y mi amor es mío. Él apacienta su rebaño entre los lirios."
,"4":"Él: Hermosa eres, amiga mía, como Tirsá, deliciosa como Jerusalén, imponente como ejército formado. "
,"5":"Retira de mí tus ojos porque me arrebatan. Tu melena es un rebaño de cabras,ondulante por las pendientes de Galaad."
,"6":"Tus dientes, como un rebaño de ovejas,que regresan del baño, cada una con crías mellizas, y ninguna privada de ellas."
,"7":"Tus mejillas, mitades de granada,a través de tu velo."
,"8":"Sesenta son las reinas, ochenta las concubinas, y las doncellas son sin número."
,"9":"nica es mi paloma, única mi perfecta; ella, la única de su madre, la preferida de la que le dio a luz. Las doncellas la han visto,y la han felicitado, reinas y concubinas la han bendecido: Ellas:"
,"10":"'¿Quién es ésta que avanza cual la aurora, bella como la luna, distinguida como el sol, imponente como ejército formado?'."
,"11":"Ella: He bajado al nogueral,para ver la floración del valle, para ver los brotes de la vid,y si florecen los granados..."
,"12":"Sin darme cuenta, mi deseo me llevaba en los carros de mi pueblo, con mi príncipe."
}`)
	CurrentBook.AddChapter(7, `{
"1":"¡Vuelve, vuelve, sulamita; vuelve, vuelve, para que te miremos!,Él: ¿Qué miraréis en la sulamita, en la danza a dos coros?"
,"2":"Coro: ¡Qué bellos son tus pies,en las sandalias, hija de príncipe!,Como collares las curvas de tus caderas, obra de las manos de un artista."
,"3":"Tu ombligo es un ánfora redonda, donde no falta vino aromático. Tu vientre, un cúmulo de trigo, rodeado de lirios."
,"4":"Tus pechos son como dos crías mellizas de gacela."
,"5":"Tu cuello, una torre de marfil. Tus ojos, como las piscinas de Jesbón,junto a las puertas de Bat-Rabín. Tu nariz, como la torre del Líbano, vigía que mira hacia Damasco."
,"6":"Tu cabeza sobre ti como el Carmelo, y la melena de tu cabeza cual la púrpura: un rey en tus rizos está preso."
,"7":"Él: ¡Qué hermosa eres, qué encantadora, oh amor mío, en tus delicias!"
,"8":"Tu talle semeja a la palmera; tus pechos, a sus racimos."
,"9":"Me digo: 'Voy a subir a la palmera; tomaré sus racimos. ¡Séanme tus pechos como racimos de uvas, y tu aliento como perfume de manzanas!"
,"10":"Tu boca como vino exquisito, que fluye suavemente hacia mi amor, deslizándose entre los labios que se adormecen'."
,"11":"Ella: Yo soy de mi amor,y su deseo tiende hacia mí."
,"12":"Ven, amor mío, salgamos a la campiña. Pasaremos la noche en las aldeas,"
,"13":"y de mañana iremos a las viñas: veremos si la vid echa sus brotes, si se abren las flores,y si florecen los granados. Allí te entregaré yo mis amores."
,"14":"Las mandrágoras exhalan su perfume. A nuestra puerta están todos los frutos exquisitos; los nuevos igual que los añejos, oh amor mío, los he guardado para ti."
}`)
	CurrentBook.AddChapter(8, `{
"1":"¡Ah, si tú fueras hermano mío, amamantado a los pechos de mi madre!,Al encontrarte en la calle te besaría,y ninguno me podría despreciar."
,"2":"Te llevaría a la casa de mi madre, a la alcoba de la que me dio a luz; te daría a beber vino aromático, mosto de mis granadas."
,"3":"Su izquierda está bajo mi cabeza,y su diestra me tiene abrazada."
,"4":"Él: Yo os conjuro, hijas de Jerusalén, no despertéis ni turbéis a mi amor,hasta cuando ella quiera."
,"5":"Coro: ¿Quién es ésta que sube del desierto,apoyada en su amor?,Él: Te he despertado debajo del manzano, allí donde te concibió tu madre, allí donde te concibió la que te dio a luz."
,"6":"Ella: Ponme como sello sobre tu corazón, como sello sobre tu brazo; porque es fuerte el amor como la muerte; inflexibles, como el infierno, son los celos. Flechas de fuego son sus flechas, llamas divinas son sus llamas."
,"7":"Aguas inmensas no podrían apagar el amor, ni los ríos ahogarlo. Quien ofreciera toda la hacienda de su casa,a cambio del amor sería despreciado. Los Hermanos:"
,"8":"Tenemos una hermana pequeñita, no tiene pechos todavía. ¿Qué hemos de hacer con nuestra hermana,el día en que se trate de su boda?"
,"9":"Si fuese un muro, levantaríamos sobre ella almenas de plata; si fuese una puerta, la guarneceríamos con tablas de cedro..."
,"10":"Ella: Yo soy un muro, mis pechos son torres. Así he sido a sus ojos como quien halla paz."
,"11":"Él: Salomón tenía una viña en Baal-Hamón, la encomendó a sus guardas. Cada uno tenía que pagarle por sus frutos,mil monedas de plata..."
,"12":"Mi propia viña ante mis ojos... ¡Las mil monedas para ti, oh Salomón, y doscientas para los guardas de su fruto!"
,"13":"Oh, tú que moras en los jardines, mis amigos prestan oído a tu voz. ¡Deja que yo la oiga!"
,"14":"Ella: ¡Huye, amor mío, sé como la gacela, como el cervatillo en los montes perfumados!"
}`)

}
func ES_LSB_LoadVSEEChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Palabras de Qohélet, hijo de David, rey de Jerusalén."
,"2":"Vanidad de vanidades, dice Qohélet. Vanidad de vanidades; todo es vanidad."
,"3":"¿Qué provecho saca el hombre de todo el trabajo con que se afana bajo el sol?"
,"4":"Una generación pasa y otra generación viene, y la tierra subsiste siempre."
,"5":"El sol sale y se pone, y se apresura a su lugar, de donde vuelve a salir."
,"6":"Sopla el viento hacia el sur, y luego gira hacia el norte; y gira, gira, y retorna sobre su recorrido el viento."
,"7":"Todos los ríos van al mar, y la mar no se llena; al lugar donde van los ríos, allí mismo vuelven a ir."
,"8":"Es indecible lo que aburren las cosas; no se sacia el ojo de ver, ni el oído se harta de oír."
,"9":"Lo que fue, eso mismo será; y lo que se hizo, eso mismo se hará; no hay nada nuevo bajo el sol."
,"10":"Si hay una cosa de la que dicen: 'Mira, esto es nuevo', esa cosa existió ya en los siglos que nos precedieron."
,"11":"No hay recuerdo de las cosas pasadas; ni de las futuras tampoco habrá recuerdo entre los que serán después."
,"12":"Yo, Qohélet, he sido rey de Israel en Jerusalén."
,"13":"Consagré mi corazón a investigar y a observar con sabiduría todo lo que se hace bajo los cielos. Es ésta una penosa ocupación, que Dios ha dado a los hijos del hombre para que trabajen en ella."
,"14":"He visto todo lo que se hace bajo el sol, y he aquí que todo es vanidad y dar caza al viento."
,"15":"Lo que es torcido no puede enderezarse; lo que falta no se puede contar."
,"16":"Yo me dije en mi corazón: 'He aquí que he adquirido una gran sabiduría, mayor que todos los que me precedieron en Jerusalén, y mi corazón posee mucha sabiduría y ciencia'."
,"17":"Me dediqué a conocer la sabiduría y la ciencia, la locura y la necedad, y comprendí que también eso es dar caza al viento."
,"18":"Porque cuanta más sabiduría, más pesadumbre; y cuanta más ciencia, más dolor."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Dije en mi corazón: '¡Ea, quiero hacerte probar la alegría; goza del placer!'; y he aquí que también eso es vanidad."
,"2":"De la risa dije: 'Locura'; y de la alegría: '¿Para qué sirve?'."
,"3":"Resolví en mi corazón regalar mi cuerpo con el vino, guiando mi corazón con la sabiduría, y entregarme a la necedad para ver dónde está la felicidad de los hombres y lo que hacen debajo de los cielos durante los días de su vida."
,"4":"Emprendí grandes obras, me construí palacios y me planté viñas;"
,"5":"me hice huertos y jardines, y planté en ellos árboles frutales de toda clase."
,"6":"Me hice estanques de agua para regar con ellos un bosque fértil."
,"7":"Compré siervos y siervas, y tuve siervos nacidos en mi casa; tuve también mucho ganado, vacas y ovejas, en mayor número que todos los que me precedieron en Jerusalén."
,"8":"Amontoné plata y oro, y tesoros de reyes y de provincias; me hice con cantores y cantoras, y lo que constituye la delicia de los hombres, princesas en cantidad."
,"9":"Y continué engrandeciéndome más que cuantos me precedieron en Jerusalén, mientras la sabiduría estaba conmigo."
,"10":"No negué a mis ojos nada de cuanto deseaban, ni privé a mi corazón de placer alguno, porque mi corazón gozó en todo mi trabajo."
,"11":"Luego reflexioné sobre todas las obras que mis manos habían hecho y sobre la fatiga que me había tomado por hacerlas, y he aquí que todo es vanidad, andar a la caza del viento, y no queda provecho alguno bajo el sol."
,"12":"Volví después mi reflexión hacia la sabiduría, la locura y la necedad. Porque, ¿qué hará el hombre que suceda al rey? Lo que ya se ha hecho."
,"13":"Veo claro que la ventaja de la sabiduría sobre la necedad es como la de la luz sobre las tinieblas."
,"14":"El sabio tiene ojos en su cabeza y el necio camina en la oscuridad. Pero también sé muy bien que ambos tienen una misma suerte."
,"15":"Me dije: 'Como la suerte del necio, así será la mía. Entonces, ¿qué provecho voy a tener en adquirir más sabiduría?'. Y dije en mi corazón que también eso es vanidad."
,"16":"Porque no hay recuerdo eterno ni del sabio ni del necio, pues en los días que siguen todos son olvidados. ¡Así es; el sabio muere como el necio!"
,"17":"Detesto la vida porque me disgusta todo lo que se hace bajo el sol, porque todo es vanidad y dar caza al viento."
,"18":"Detesto todo el trabajo que he hecho bajo el sol y que dejaré a mi sucesor."
,"19":"Quién sabe si él será sabio o necio? Y, sin embargo, dispondrá de todo mi trabajo, en el que yo empleé mi fatiga y mi sabiduría bajo el sol. También esto es vanidad."
,"20":"Cedió mi corazón al desaliento respecto a todo el trabajo en que me afané bajo el sol."
,"21":"Porque uno ha trabajado con sabiduría, ciencia y éxito, y deja su bien a otro que no ha trabajado en ello. También esto es vanidad y grave mal."
,"22":"Entonces, ¿qué provecho saca el hombre de todo su trabajo y de la fatiga de su corazón con que se afanó bajo el sol?"
,"23":"Y sus días de fatigas, y la preocupación de los negocios, y las noches de insomnio? También esto es vanidad"
,"24":"No hay más felicidad para el hombre que comer y beber y gozar él mismo del bienestar de su trabajo. Y yo considero que esto viene de la mano de Dios."
,"25":"Quién, en efecto, puede comer, o quién puede beber sin él?"
,"26":"Porque él da sabiduría, ciencia y placer al hombre que le agrada; y al malhechor le impone la carga de allegar y amontonar para dejárselo después a quien Dios quiera. También esto es vanidad y dar caza al viento."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Hay un momento para todo,y un tiempo para cada cosa bajo el cielo:"
,"2":"un tiempo para nacer y un tiempo para morir; un tiempo para plantar y un tiempo para arrancar lo plantado;"
,"3":"un tiempo para matar y un tiempo para curar; un tiempo para destruir y un tiempo para edificar;"
,"4":"un tiempo para llorar y un tiempo para reír; un tiempo para lamentarse y un tiempo para bailar;"
,"5":"un tiempo para tirar piedras y un tiempo para recogerlas; un tiempo para abrazar y un tiempo para abstenerse de abrazos; "
,"6":"un tiempo para buscar y un tiempo para perder; un tiempo para guardar y un tiempo para tirar;"
,"7":"un tiempo para rasgar y un tiempo para coser; un tiempo para callar y un tiempo para hablar;"
,"8":"un tiempo para amar y un tiempo para odiar; un tiempo para la guerra y un tiempo para la paz."
,"9":"¿Qué provecho saca el obrero de tanto trabajar?"
,"10":"He considerado la ocupación que Dios ha dado a los hombres para que en ella se afanen."
,"11":"El lo hizo todo bien y a su tiempo; pero les puso el deseo del infinito, sin que el hombre pueda llegar a descubrir las obras que Dios hace desde el principio hasta el fin."
,"12":"No hay para ellos otra felicidad que gozar y procurarse el bienestar durante su vida."
,"13":"Pero el que uno coma y beba y goce de la felicidad en todo su trabajo, eso es un don de Dios."
,"14":"Yo sé que todo lo que Dios hace subsiste para siempre; a ello nada se puede añadir ni de ello se puede quitar nada, y así hace Dios que se le tema."
,"15":"Lo que es, ya fue; lo que será, es ya, y Dios vuelve a traer lo que pasó."
,"16":"He visto más debajo del sol: en el lugar del derecho está el delito; y en el lugar de la justicia, la injusticia."
,"17":"Me dije: Dios juzgará al justo y al criminal, porque hay un tiempo para cada cosa y para cada acción aquí."
,"18":"También me dije acerca de la conducta de los hombres: es para que Dios los manifieste tales cuales son y para hacerlos ver que por sí mismos son como animales."
,"19":"Porque la suerte de los hombres y la suerte de las bestias es la misma; la muerte del uno es como la del otro; ambos tienen un mismo aliento; y la superioridad del hombre sobre la bestia es nula, porque todo es vanidad."
,"20":"Ambos van al mismo lugar; ambos vienen del polvo y ambos vuelven al polvo."
,"21":"Quién sabe si el aliento del hombre sube arriba y el de las bestias desciende bajo la tierra?"
,"22":"Sí que he visto que no hay otra felicidad para el hombre que gozarse en sus obras, porque ésta es su condición. Pues, ¿quién le llevará a gozar de lo que vendrá después?"
}`)
	CurrentBook.AddChapter(4, `{
"1":"Y he visto también todas las opresiones que se cometen bajo el sol. ¡Las lágrimas de los oprimidos sin tener quien los consuele! ¡La mano de sus opresores les hace violencia, sin encontrar quien los vengue!"
,"2":"Y felicito a los muertos porque ya están muertos, antes que a los vivos que todavía viven."
,"3":"Y más feliz que unos y otros es el que aún no ha existido y no ha visto las injusticias que se cometen bajo el sol."
,"4":"He visto que todo trabajo y toda empresa con éxito no es más que envidia de uno contra otro. También esto es vanidad y andar a caza del viento."
,"5":"El necio se cruza de brazos y come su propia carne."
,"6":"Más vale un puñado de descanso que dos puñados de fatiga y de dar caza al viento."
,"7":"He visto además otra vanidad bajo el sol."
,"8":"Hay un hombre solo y sin compañero; no tiene hijo ni hermano; y, sin embargo, nunca cesa de trabajar, y sus ojos no se hartan de riquezas. Entonces, ¿para quién trabajo yo y me privo de bienestar? También esto es vanidad y una penosa ocupación."
,"9":"Mejor es estar dos que uno solo, porque dos logran más rendimiento en su trabajo."
,"10":"En caso de caída, el uno levanta al otro; en cambio, ¡ay del solo que cae y no tiene a nadie que lo levante!"
,"11":"Igualmente, si duermen dos juntos, se calientan; pero uno solo, ¿cómo se calentará?"
,"12":"Si alguien ataca al que está solo, dos le oponen resistencia; y la cuerda de tres hilos no se rompe fácilmente."
,"13":"Más vale un muchacho pobre y sabio que un rey necio y anciano, que no sabe ya escuchar consejos."
,"14":"El muchacho puede salir de la prisión para subir al trono, aun cuando en su reino haya nacido pobre."
,"15":"Veo a todos los vivientes que caminan bajo el sol irse con el joven, el que le sucederá en su puesto."
,"16":"Era una muchedumbre sin fin la que él presidía; pero los que vengan después no estarán contentos con él. Y también esto es vanidad y dar caza al viento."
,"17":"Pon atención a tus pasos cuando vas a la casa de Dios. Acércate para escuchar: el sacrificio vale más que la ofrenda de los necios; es que no se dan cuenta de que hacen mal."
}`)
	CurrentBook.AddChapter(5, `{
"1":"No seas precipitado en tu boca, y tu corazón no se apresure a proferir una palabra delante de Dios, porque Dios está en los cielos y tú estás en la tierra; por eso sean pocas tus palabras."
,"2":"Porque de la multitud de las preocupaciones nacen los sueños, y por el exceso de palabras se dicen disparates."
,"3":"Cuando haces una promesa a Dios, no tardes en cumplirla, porque no le agradan los necios. La promesa que has hecho, cúmplela."
,"4":"Mejor es no hacer promesas que hacerlas y después no cumplirlas."
,"5":"No permitas que tu boca te haga culpable, y no digas delante de Dios que fue una inadvertencia. ¿Por qué hacer que Dios se irrite a causa de tu palabra y destruya las obras de tus manos?"
,"6":"Porque de la multitud de las preocupaciones nacen los sueños, y de la multitud de las palabras las vanidades. Así que teme a Dios."
,"7":"Si ves en la región al pobre oprimido, el derecho y la justicia violados, no te sorprendas por eso; es que sobre una autoridad hay vigilando otra autoridad, y sobre ésta hay aún otras autoridades."
,"8":"El interés del país está antes que todo; y el rey debe estar al servicio del campo."
,"9":"El que ama el dinero nunca se harta de él; y el que ama las riquezas no obtiene provecho. También esto es vanidad."
,"10":"Cuando los bienes aumentan, aumentan los parásitos; y ¿qué ventaja saca el propietario? Verlos con sus ojos."
,"11":"El sueño del trabajador es dulce, haya comido poco o mucho; pero al rico la riqueza no le deja dormir."
,"12":"Hay un mal doloroso, que he visto bajo el sol: riquezas guardadas por su dueño para su desgracia."
,"13":"Estas riquezas desaparecen en una mala circunstancia; le nace un hijo, y ya no tiene nada en su mano."
,"14":"Como salió del seno de su madre, desnudo, así se volverá, yéndose como vino; de su trabajo no se puede llevar nada consigo."
,"15":"También esto es un mal doloroso, que se vaya como ha venido; ¿qué provecho le queda de haber trabajado para el viento?"
,"16":"Además, pasó todos sus días en la oscuridad, afligido, deprimido e irritado."
,"17":"Se comprobado que lo mejor y más conveniente para el hombre es comer y beber y gozar del bienestar en todo el trabajo en que se afana bajo el sol durante los días de su vida que Dios le ha dado, porque ésta es su parte."
,"18":"Igualmente, cuando Dios da a un hombre riquezas y hacienda y le permite disfrutar de ellas, tomarse su parte y gozar de su trabajo, eso es un don de Dios."
,"19":"Entonces no tiene que pensar mucho en los días de su vida, mientras Dios llene de alegría su corazón."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Hay otro mal que observo bajo el sol y que pesa gravemente sobre los hombres:"
,"2":"un hombre a quien Dios ha dado riquezas, hacienda y honores, y a quien nada falta de cuanto pueda desear; pero Dios no le concede disfrutar de eso, sino que es un extraño quien lo disfruta. Esto es vanidad y un cruel sufrimiento."
,"3":"Un hombre que haya tenido cien hijos y haya vivido muchos años, si no se hartó de felicidad y no tuvo ni siquiera una sepultura, en este caso yo digo que el abortivo es más feliz que él."
,"4":"En las tinieblas viene y en las tinieblas se va; también su nombre queda perdido en las tinieblas."
,"5":"No vio el sol, ni conoció nada. Más descanso tiene el abortivo que ese hombre."
,"6":"Aun cuando hubiera vivido dos veces mil años,sin gustar la felicidad, ¿no van ambos al mismo lugar?"
,"7":"Todo el trabajo del hombre es para su boca; y, con todo, sus deseos nunca se sacian."
,"8":"Porque, ¿qué ventaja sobre el necio tiene el sabio?,¿Qué ventaja sobre el pobre, el que sabe comportarse en público?"
,"9":"El que los ojos vean es preferible,a que el corazón desee. También esto es vanidad y dar caza al viento. "
,"10":"Lo que existe tiene nombre; y se sabe que el hombre no puede enfrentarse con el que es más fuerte que él."
,"11":"Las muchas palabras aumentan la vanidad, pero ¿qué provecho saca el hombre?"
,"12":"Quién sabe lo que es bueno para el hombre en la vida, durante los días de su vida de vanidad, que él pasa como una sombra? ¿Quién podrá decir al hombre lo que después de él sucederá bajo el sol?"
}`)
	CurrentBook.AddChapter(7, `{
"1":"Más vale la buena fama que el perfume más fino; y el día de la muerte que el día del nacimiento."
,"2":"Mejor es ir a casa de duelo que a casa de banquete, porque aquél es el fin de todo hombre, y el vivo con eso reflexiona."
,"3":"Mejor es la tristeza que la risa, porque un rostro triste hace bien al corazón."
,"4":"El corazón del sabio está en la casa del duelo; el corazón del necio, en la casa de la alegría."
,"5":"Más vale escuchar la reprensión del sabio,que la cantinela de los necios."
,"6":"Como el crujir de las zarzas en el fuego, así es la risa de los necios. También esto es vanidad."
,"7":"Porque la opresión hace necio al sabio, y las dádivas corrompen el corazón."
,"8":"Mejor es el fin de una cosa que su principio; mejor es la paciencia que la soberbia."
,"9":"No te dejes llevar de la ira, porque la ira es propia de los necios."
,"10":"No digas: ¿Por qué los tiempos pasados fueron mejores,que los presentes?,Tal pregunta no es de sabio."
,"11":"Buena es la sabiduría, como un patrimonio, y aprovecha a los que ven el sol."
,"12":"Porque escudo es la sabiduría, y escudo es el dinero; pero la ventaja del saber,es que la sabiduría da la vida a quien la posee."
,"13":"Contempla la obra de Dios: ¿quién podrá enderezar lo que él torció?"
,"14":"En el día de la prosperidad goza de felicidad; en el día de la desgracia reflexiona. Tanto lo uno como lo otro lo ha hecho Dios para que el hombre no descubra nada del futuro."
,"15":"Estas dos cosas he visto en mis días de vanidad: justo que perece a pesar de su justicia, e injusto que prolonga sus días a pesar de su injusticia."
,"16":"No seas justo en demasía, y no seas sabio con exceso; ¿para qué destruirte? "
,"17":"No seas injusto en demasía, y no seas necio; ¿para qué morir antes de tiempo?"
,"18":"Es bueno que esto sujetes y que de aquello no retires tu mano; porque quien teme a Dios cumple lo uno y lo otro."
,"19":"La sabiduría da al sabio una fuerza mayor que la de diez gobernadores en una ciudad."
,"20":"Mo hay hombre justo en la tierra que haga el bien sin pecar nunca."
,"21":"Tampoco prestes atención a todas las cosas que se dicen, para que no tengas que oír que tu criado te maldice;"
,"22":"Porque tu corazón sabe que muchas veces tú también has maldecido a otros."
,"23":"Todas estas cosas las he examinado con sabiduría, pues dije: 'Yo quiero hacerme sabio'; pero la sabiduría quedó lejos de mí."
,"24":"Lejos quedó lo que estaba lejos, y profundo lo profundo; ¿quién lo alcanzará?"
,"25":"Todavía apliqué mi corazón a saber, examinar e investigar la sabiduría y la razón de las cosas, y a reconocer que la maldad es una insensatez, y el desvarío una locura."
,"26":"Encuentro que la mujer es más amarga que la muerte, porque ella es un lazo; su corazón es una red, y sus brazos son cadenas. Quien agrada a Dios escapa de ella, pero el pecador en ella queda preso."
,"27":"Mira, esto es lo que he comprobado, dice Qohélet, examinando una a una las cosas para encontrar la razón de ellas."
,"28":"Todavía la busco, pero no la encuentro. Un hombre entre mil, yo lo encuentro; una mujer entre todas, no la encuentro."
,"29":"Mira, sólo esto es lo que he comprobado: Dios ha hecho al hombre recto, y es él quien se busca innumerables complicaciones."
}`)
	CurrentBook.AddChapter(8, `{
"1":"¿Quién es como el sabio? ¿Quién sabe la solución de un problema? La sabiduría del hombre ilumina su rostro, y la esperanza de su semblante se cambia."
,"2":"Yo te digo: Guarda las órdenes del rey, pues así lo juraste ante Dios."
,"3":"No te apresures a alejarte de su presencia; no persistas en un asunto malo, porque él hace todo lo que quiere."
,"4":"Pues la palabra del rey es soberana, y quién puede decirle: '¿Qué haces?'."
,"5":"El que guarda sus mandatos no experimenta el infortunio, y el sabio sabe cuándo y cómo debe guardarlos."
,"6":"Porque hay un momento y un modo de hacer todas las cosas, pero lo más grave para el hombre"
,"7":"es que nadie sabe lo que sucederá; ¿quién podrá indicarle cuándo eso sucederá?"
,"8":"No tiene poder el hombre sobre su vida para retenerla, ni sobre el día de la muerte; y no hay quien se libre de este combate, ni la iniquidad salva al que la posee."
,"9":"Todo esto lo he comprobado examinando todas las cosas que se hacen bajo el sol, en el tiempo en que un hombre domina sobre otro hombre y le hace daño."
,"10":"También he visto que los criminales eran llevados a su sepultura partiendo del lugar santo, y eran honrados en la ciudad por haber obrado así. También esto es vanidad."
,"11":"Como no se ejecuta inmediatamente la sentencia contra los delitos, por eso los hombres sólo piensan en delinquir;"
,"12":"porque el delincuente comete cien delitos, y no le hacen nada; con todo, yo también sé que llega la felicidad a los que temen a Dios, porque lo temen;"
,"13":"que no tendrá la felicidad el malhechor, y no prolongará sus días más que como una sombra, porque no teme a Dios."
,"14":"Pero se da vanidad sobre la tierra, porque hay justos a quienes sucede lo que merece la conducta de los injustos, y hay injustos a quienes sucede lo que merece la conducta de los justos. Digo que también esto es vanidad."
,"15":"Así pues, alabo la alegría, porque para el hombre no hay bajo el sol otra felicidad que comer y beber y gozar. Y esto le acompaña en su trabajo en los días de su vida que le da Dios bajo el sol."
,"16":"Después de haberme aplicado a conocer la sabiduría y a examinar las ocupaciones que se desempeñan en la tierra porque los ojos del hombre ni de noche ni de día ven el sueño,"
,"17":"entonces advertí que el hombre no puede descubrir todas las obras de Dios que se realizan bajo el sol; por mucho que el hombre se fatigue buscándolas, no llega a descubrirlas. Y aunque un sabio diga que lo sabe, tampoco llega a descubrirlo."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Ciertamente he examinado todo esto, y he comprobado que los justos y los sabios y sus obras están en las manos de Dios. El hombre no conoce ni el amor ni el odio, y ambas cosas son a sus ojos"
,"2":"vanidad. Porque todos tienen una misma suerte: el justo y el injusto, el bueno y el malo, el puro y el impuro, el que ofrece sacrificios y el que no los ofrece; lo mismo el bueno que el pecador, el que jura que el que teme hacer un juramento."
,"3":"Esto es lo malo de todo lo que se hace bajo el sol: que sea una misma la suerte para todos. Y así el corazón del hombre se llena de malicia y concibe locuras durante su vida; y después... ¡con los muertos!"
,"4":"Mientras uno está vivo, tiene esperanza; porque más vale perro vivo que león muerto;"
,"5":"pues los vivos saben que han de morir, pero los muertos no saben nada y ya no reciben salario, porque su recuerdo está en el olvido."
,"6":"Sus amores, sus odios, sus envidias, todo ha perecido. Y ellos no tendrán ya parte alguna en todo lo que se hace bajo el sol."
,"7":"Anda, come tu pan con alegría,y bebe con alegre corazón tu vino, porque ya se complace Dios en tu obra."
,"8":"Lleva en todo tiempo vestidos blancos, y que el perfume no falte sobre tu cabeza."
,"9":"Goza de la vida con la mujer que amas, todos los días de tu vida de vanidad que Dios te da bajo el sol, porque ésa es tu parte en la vida y en el trabajo con que te afanas bajo el sol."
,"10":"Todo lo que esté en tu mano hacer, hazlo mientras puedas; porque no hay ni obra, ni razón, ni ciencia, ni sabiduría en el abismo al que irás a parar."
,"11":"También he visto bajo el sol que ni es de los veloces la carrera, ni de los valientes el combate, ni de los sabios el pan, ni de los inteligentes la riqueza, ni de los instruidos la estima, porque el tiempo y la mala suerte alcanzan a todos."
,"12":"El hombre no conoce su hora: como los peces que son apresados en la red fatal y como los pájaros que se enredan en el lazo, así los hombres se dejan enredar por el infortunio cuando de improviso cae sobre ellos."
,"13":"Otra cosa he visto también bajo el sol que encierra una gran enseñanza:"
,"14":"había una ciudad, pequeña, y de pocos habitantes. Un gran rey fue contra ella, la asedió y levantó a su alrededor grandes fortificaciones."
,"15":"Había en ella un hombre pobre, pero sabio, que salvó la ciudad con su sabiduría; mas nadie ha conservado el recuerdo de aquel hombre."
,"16":"Yo digo: la sabiduría vale más que la fuerza; pero la sabiduría del pobre es despreciada y sus palabras no son escuchadas."
,"17":"Las palabras dulces de los sabios son escuchadas mejor que los gritos del rey de los necios."
,"18":"Más vale la sabiduría que las armas de guerra, pero un solo error destruye mucho bien."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Una mosca muerta estropea un frasco de perfume; un poco de locura pesa más que la sabiduría y el honor."
,"2":"El espíritu del sabio va a su derecha, el del tonto a su izquierda."
,"3":"Y cuando el tonto se pone en camino, le falta la cordura y va diciendo a todo el mundo que es tonto."
,"4":"Si la ira del rey se levanta contra ti, no abandones tu puesto; ante los errores graves, hay que tomar las cosas con calma."
,"5":"Hay un mal que veo bajo el sol, como un error que proviene del soberano:"
,"6":"los necios ocupan altos cargos, mientras que los que valen están en puestos bajos."
,"7":"Veo a siervos ir a caballo, y a príncipes marchar a pie como siervos."
,"8":"El que cava una fosa cae en ella, al que destruye un muro le muerde la serpiente."
,"9":"El que labra piedras se hace mal con ellas, el que corta leña puede herirse con ella."
,"10":"Si el hacha se embota y no se la afila, hay que multiplicar los esfuerzos; pero la sabiduría procura el éxito."
,"11":"Si la serpiente muerde y no está encantada, ninguna ventaja tiene el encantador."
,"12":"Las palabras de la boca del sabio son agradables; pero los labios del tonto causan su propia ruina."
,"13":"Las primeras palabras de su boca son despropósitos, y el final de su discurso funesta locura."
,"14":"El tonto multiplica las palabras. El hombre ignora el pasado; y ¿quién puede indicarle lo que sucederá después?"
,"15":"El trabajo del tonto fatiga, porque ni siquiera sabe ir a la ciudad."
,"16":"Ay de ti, tierra, que tienes por rey un niño, y cuyos príncipes banquetean desde la mañana!"
,"17":"Dichosa tú, tierra, que tienes por rey un hijo de nobles, y cuyos príncipes comen a su tiempo para recobrar fuerzas, y no para beber!"
,"18":"Por la holgazanería se cae la techumbre, y por falta de cuidado en casa hay goteras."
,"19":"Para el placer se hacen banquetes, y el vino alegra la vida, y el dinero todo lo arregla."
,"20":"No maldigas al rey ni aun con tu pensamiento; no maldigas al rico ni aun en tu alcoba; porque las aves del cielo transportan la voz,y un ser alado lo hace saber."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Lanza tu fortuna al agua, porque mucho tiempo después la volverás a encontrar."
,"2":"Da parte a siete y aun a ocho, porque no sabes qué desgracias pueden venir sobre la tierra."
,"3":"Cuando las nubes están llenas de lluvia, sobre la tierra la vierten; y si un árbol cae al sur o al norte, el árbol queda en el lugar donde cae."
,"4":"El que observa el viento, no sembrará; y el que mira las nubes, no segará."
,"5":"Como tú no sabes por qué camino entra el espíritu en los huesos en el seno de una mujer encinta, así no conoces la obra de Dios, que hace todas las cosas."
,"6":"Por la mañana siembra tu semilla, y por la tarde no des descanso a tu mano; porque tú no sabes lo que es mejor, si esto o aquello, o si ambas cosas son igualmente buenas."
,"7":"La luz es dulce, y agrada a los ojos ver el sol."
,"8":"Y si el hombre vive muchos años, que disfrute de todos ellos y recuerde que los días de tinieblas serán numerosos; todo lo que sucede es vanidad."
,"9":"Goza, joven, de tu mocedad, y que tu corazón disfrute en los días de tu juventud. Sigue los caminos de tu corazón,y los deseos de tus ojos. Pero sabe que de todo esto Dios te pedirá cuentas."
,"10":"Aleja la tristeza de tu corazón,y aparta de tu carne el sufrimiento, porque la mocedad y la juventud son vanidad."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Y acuérdate de tu creador en los días de tu juventud, antes que vengan los días malos y que lleguen los años de los que tú dirás: 'No encuentro placer en ellos';"
,"2":"antes que se oscurezca el sol y la luz, la luna y las estrellas, y vuelvan las nubes después de la lluvia;"
,"3":"cuando tiemblen los guardianes de la casa, y se encorven los hombres fuertes, y cesen de moler las mujeres porque son demasiado pocas, y pierdan la vista las que miran por las ventanas,"
,"4":"y se cierren las puertas de la calle, y se debilite el rumor del molino, y se apague la voz del ave, y desaparezcan las canciones;"
,"5":"cuando en las alturas haya temores,y en los caminos angustias; y florezca el almendro, y se haga pesada la langosta,y no sirva para nada la alcaparra, porque el hombre se va a su morada eterna, y las plañideras recorren la calle;"
,"6":"antes que se parta el cordón de plata, y se quiebre la lámpara de oro, y se haga pedazos el cántaro en la fuente, y se rompa la polea en el pozo,"
,"7":"y que el polvo torne a la tierra como era antes, y que el espíritu vuelva a Dios, que es quien lo dio."
,"8":"Vanidad de vanidades, dice Qohélet, y todo es vanidad."
,"9":"Qohélet, además de ser un sabio, también enseñó al pueblo la ciencia; estudió, investigó y compuso muchos proverbios."
,"10":"Qohélet procuró encontrar dichos agradables y escribir rectamente sentencias verdaderas."
,"11":"Las palabras de los sabios son como aguijones, como clavos clavados por los instruidos de la asamblea. Ellas son dadas por el pastor único."
,"12":"Ir más allá de esto, evítalo, hijo mío: componer muchos libros es una cosa sin fin, y mucho estudio fatiga el cuerpo."
,"13":"Fin del discurso. Todo está dicho. Teme a Dios y guarda sus mandamientos, porque en eso consiste ser hombre."
,"14":"Dios nos pedirá cuentas de todas nuestras acciones, buenas o malas, aun de las que hayamos hecho en secreto."
}`)

}
func ES_LSB_LoadVSEIChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Toda sabiduría viene del Señor,y con él está eternamente."
,"2":"La arena de los mares, las gotas de la lluvia,y los días del pasado, ¿quién podrá contarlos?"
,"3":"La altura de los cielos, la anchura de la tierra, la profundidad del abismo y la sabiduría, ¿quién podrá medirlas? "
,"4":"Antes que todo fue creada la sabiduría, y la prudencia inteligente desde la eternidad."
,"6":"La fuente de la sabiduría, ¿a quién fue manifestada?; sus sutilezas, ¿quién las conoce?"
,"8":"Uno solo es sabio y muy temible, el que se sienta sobre su trono."
,"9":"El Señor la creó, la vio, la midió,y la derramó sobre todas sus obras,"
,"10":"sobre toda carne con generosidad, y proveyó de ella a todos los que le aman."
,"11":"El temor del Señor es gloria y honor, alegría y corona de gozo."
,"12":"El temor de Dios regocija el corazón, y da alegría, gozo y larga vida."
,"13":"Al que teme al Señor le irá bien al fin, y en el día último será bendecido."
,"14":"Principio de la sabiduría es el temor a Dios, ella fue creada con los fieles en el seno materno."
,"15":"Entre los hombres hizo su nido, fundación eterna, y se mantendrá fiel a su posteridad."
,"16":"La plenitud de la sabiduría es el temor a Dios, ella embriaga con sus frutos a los hombres."
,"17":"Toda su casa llena de tesoros, sus graneros colma de sus productos."
,"18":"La corona de la sabiduría es el temor a Dios, hace florecer la paz y la salud perfecta."
,"19":"Ella ha hecho llover la ciencia y la prudencia, y exalta la gloria de los que la poseen."
,"20":"La fuente de la sabiduría es el temor al Señor, y sus ramos son la longevidad."
,"21":"El respeto del Señor rechaza los pecados,y aparta sin cesar la cólera."
,"22":"La ira del injusto no puede justificarse, porque el peso de su ira lo lleva a la ruina."
,"23":"El hombre paciente aguanta hasta el tiempo preciso, pero al fin brota para él la alegría;"
,"24":"hasta el tiempo preciso guarda sus palabras, pero la boca de la gente proclama su prudencia."
,"25":"Entre los tesoros de la sabiduría están las máximas sabias, pero la piedad es náusea para el pecador."
,"26":"Si anhelas la sabiduría guarda los mandamientos, y el Señor te la concederá."
,"27":"Porque sabiduría e instrucción es el temor al Señor, objeto de su complacencia es la fidelidad y mansedumbre."
,"28":"No seas indócil al temor del Señor, no te acerques a él con doblez de corazón."
,"29":"No seas hipócrita delante de los hombres, pon cuidado en tu hablar."
,"30":"No te ensalces a ti mismo, no sea que caigas,y traigas la deshonra sobre ti, porque el Señor descubrirá tus secretos,y te humillará en medio de la asamblea. Porque no has practicado el temor del Señor, y tu corazón está lleno de falsedad."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Hijo, si te decides a servir al Señor, prepara tu alma para la prueba."
,"2":"Endereza tu corazón y manténte firme, en tiempo de infortunio no te inquietes."
,"3":"Pégate a él y no te alejes, para que tengas buen éxito en tus últimos días."
,"4":"Todo cuanto te sobrevenga acéptalo, y en los reveses de la prueba sé paciente."
,"5":"Porque en el fuego se prueba el oro, y los elegidos del Señor en el horno de la humillación."
,"6":"Confía en él y él te acogerá, endereza tus caminos y espera en él."
,"7":"Los que teméis al Señor esperad en su misericordia, no os desviéis para que no caigáis."
,"8":"Los que teméis al Señor confiad en él, y no os faltará la recompensa."
,"9":"Los que teméis al Señor esperad sus bienes, la alegría perpetua y la misericordia."
,"10":"Volved los ojos a las generaciones pasadas y ved. ¿Quién confió en el Señor y fue defraudado, o quién perseveró en su temor y fue abandonado, o quién lo invocó y fue despreciado?"
,"11":"Porque el Señor es compasivo y misericordioso, borra el pecado y salva en el tiempo de la tribulación."
,"12":"¡Ay de los corazones débiles y de las manos flojas, del pecador que va por doble sendero!"
,"13":"¡Ay del corazón vacilante y que no tiene fe, porque no será protegido!"
,"14":"¡Ay de vosotros los que habéis perdido la paciencia!,¿Qué haréis cuando el Señor venga a visitaros?"
,"15":"Los que temen al Señor no desobedecen sus mandatos, los que lo aman guardan sus caminos."
,"16":"Los que temen al Señor tratan de hacer lo que le agrada, los que lo aman se sacian de su ley."
,"17":"Los que temen al Señor tienen el corazón dispuesto, se humillan ante él y dicen:"
,"18":"echémonos en las manos del Señor,y no en las de los hombres, porque como es su grandeza, así es su misericordia."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Escuchad, hijos, los consejos de vuestro padre; haced lo que os digo y os salvaréis."
,"2":"Porque el Señor honra al padre en sus hijos, y confirma el derecho de la madre sobre las hijas."
,"3":"El que honra al padre repara su pecado."
,"4":"El que honra a su madre amontona tesoros."
,"5":"El que honra a su padre se alegrará en sus hijos,y será escuchado en el día de su oración."
,"6":"El que glorifica a su padre vivirá larga vida, y el que obedece al Señor complace a su madre."
,"7":"El que teme al Señor honra a su padre, sirve a sus padres como a señores."
,"8":"Honra a tu padre de palabra y de obra,para que su bendición recaiga sobre ti."
,"9":"Porque la bendición del padre afianza las casas de los hijos, pero la maldición de la madre arranca de raíz sus cimientos."
,"10":"No te gloríes en la deshonra de tu padre, pues su deshonra no es gloria para ti."
,"11":"Porque la gloria del hombre nace de la honra del padre, y una madre despreciable es deshonra de los hijos."
,"12":"Hijo, ayuda a tu padre en su vejez, y no le des disgustos durante su vida."
,"13":"Si llega a perder la razón, sé indulgente con él; no le afrentes tú que estás en pleno vigor."
,"14":"La misericordia con el padre no será olvidada, te servirá de reparación por tus pecados."
,"15":"En el día de la tribulación será recordada para tu favor; como el calor derrite el hielo, así desaparecerán tus pecados."
,"16":"El que abandona a su padre es como un blasfemo, y maldito del Señor quien irrita a su madre."
,"17":"Hijo mío, lleva tus asuntos con paciencia, y serás amado más que el hombre afable."
,"18":"Cuanto más grande seas, más te has de abajar, y hallarás gracia delante del Señor."
,"20":"Porque grande es la potencia del Señor, es glorificado por los humildes."
,"21":"Lo que sea muy difícil para ti no lo busques, y lo que está sobre tus fuerzas no lo investigues."
,"22":"Reflexiona sobre lo que te ha sido mandado, y no te preocupes por cosas ocultas."
,"23":"No te obstines en cosas que rebasan tus fuerzas, pues ya se te ha manifestado más de lo que el hombre puede abarcar."
,"24":"Porque la presunción ha perdido a muchos, y una pretensión perversa ha pervertido su inteligencia."
,"25":"(Donde faltan los ojos, falta la luz; donde falta inteligencia, no hay sabiduría)."
,"26":"Un corazón obstinado acabará mal, y quien ama el peligro en él perecerá."
,"27":"Un corazón obstinado se ve cargado de dolores, el pecador acumula pecado sobre pecado."
,"28":"No hay medicina para el mal del soberbio, porque la planta de la maldad echa raíces en él."
,"29":"El corazón inteligente medita las sentencias de los sabios, y la sabiduría desea un oído atento."
,"30":"El agua apaga la ardiente llama, y la limosna consigue el perdón de los pecados."
,"31":"Quien corresponde a los favores piensa en el futuro, y al tiempo de su caída encontrará un apoyo."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Hijo, no quites al pobre su subsistencia, no tengas esperando los ojos implorantes."
,"2":"No entristezcas al hambriento, no exasperes a nadie en su necesidad."
,"3":"No irrites al corazón exasperado, no retardes tu don al menesteroso."
,"4":"No rechaces al suplicante atribulado, no apartes tu rostro del pobre."
,"5":"No retires tus ojos del necesitado, y no des a nadie motivo para que te maldiga."
,"6":"Pues si te maldice en la amargura de su alma, su hacedor escuchará su oración."
,"7":"Hazte amar de la comunidad, y ante el jefe baja la cabeza."
,"8":"Inclina tu oído al pobre, y responde a su saludo afablemente."
,"9":"Arranca al oprimido de mano del opresor, no te acobardes al hacer justicia."
,"10":"Sé para los huérfanos un padre,y un marido para su madre; serás como hijo del altísimo, que te amará más que tu propia madre."
,"11":"La sabiduría exalta a sus hijos, y cuida de los que la buscan."
,"12":"El que la ama, ama la vida; y los que madrugan a buscarla serán colmados de alegría."
,"13":"El que la abraza heredará la gloria, y el lugar donde ella entra el Señor lo bendice."
,"14":"Los que la sirven sirven al Santo, los que la aman son amados del Señor."
,"15":"Quien la escucha juzgará rectamente, el que se llega a ella vivirá seguro."
,"16":"Quien se confía a ella la heredará, su posteridad conservará su posesión."
,"17":"Al comienzo lo llevará por caminos tortuosos,y traerá sobre él el miedo y el terror; lo atormentará con su disciplina,hasta que ella tenga confianza en él; le probará con sus preceptos."
,"18":"Pero de nuevo ella volverá derecha a él, lo alegrará y le descubrirá sus secretos."
,"19":"Mas si él se extravía lo abandonará,y lo entregará a su ruina."
,"20":"Ten en cuenta las circunstancias y guárdate del mal, y no tendrás que avergonzarte de ti mismo."
,"21":"Porque hay una vergüenza que conduce al pecado, y hay otra que es gloria y favor."
,"22":"No guardes miramientos con otros en perjuicio tuyo, no te avergüences para tu ruina."
,"23":"No dejes de hablar cuando sea necesario,"
,"24":"pues en el discurso se deja ver la sabiduría,y en la respuesta la instrucción."
,"25":"No contradigas la verdad, avergüénzate de tu ignorancia."
,"26":"No te avergüences de confesar tus pecados, ni te opongas a la corriente del río."
,"27":"No te sometas al estúpido, ni guardes miramientos con el poderoso."
,"28":"Lucha por la verdad hasta la muerte, y el Señor Dios luchará por ti."
,"29":"No seas insolente en tu lenguaje, perezoso y remiso en tus obras."
,"30":"No seas como león en tu casa, ni altanero con tus criados."
,"31":"No sea tu mano abierta para recibir,y cerrada para dar."
}`)
	CurrentBook.AddChapter(5, `{
"1":"No confíes en tus riquezas; no digas: 'Me basto a mí mismo'."
,"2":"No sigas tus impulsos y tu fuerza,yendo tras las pasiones de tu corazón."
,"3":"No digas: '¿Quién podrá dominarme?', porque de seguro el Señor te castigará."
,"4":"No digas: 'Pequé, ¿qué me ha sucedido?', porque el Señor es paciente."
,"5":"No estés tan seguro de tu perdón,que añadas pecado a pecado."
,"6":"No digas: 'Grande es su misericordia, perdonará la muchedumbre de mis pecados'. Porque, aunque es misericordioso, también se enfurece,y su furor descarga sobre los pecadores."
,"7":"Conviértete al Señor cuanto antes, no lo dejes de un día para otro. Porque de repente se desata la ira del Señor, y en el día de la venganza serás aniquilado."
,"8":"No confíes en riquezas mal adquiridas, porque de nada te aprovecharán en el día de la ira."
,"9":"No bieldes a cualquier viento,y no te vayas por cualquier sendero"
,"10":"Sé firme en tu criterio,y no tengas más que una palabra."
,"11":"Sé pronto para oír y lento en tus respuestas."
,"12":"Si tienes algo sensato, responde al prójimo; y si no, pon mano en boca."
,"13":"Gloria y deshonor es el hablador, y la lengua del hombre es su ruina."
,"14":"No seas tachado de murmurador, no tiendas lazos con tu lengua; porque si sobre el ladrón vendrá la vergüenza, una amarga pena espera al de doble corazón."
,"15":"No ofendas a nadie ni en poco ni en mucho, no te cambies de amigo en enemigo."
}`)
	CurrentBook.AddChapter(6, `{
"1":"La mala fama produce vergüenza y desprecio; así es el pecador de doble lengua."
,"2":"No te entregues a los caprichos de la pasión, pues destrozarías tu vigor como un toro."
,"3":"Devorarías tus hojas, harías caer tus frutos,y quedarías como un árbol seco."
,"4":"La pasión violenta pierde a quien la posee,y lo hace la irrisión de sus enemigos."
,"5":"Palabras dulces multiplican los amigos, la lengua afable multiplica las buenas relaciones."
,"6":"Que sean muchos tus amigos, pero uno entre mil tu consejero."
,"7":"Si tienes un amigo, comienza por probarlo, y no te confíes presto a él."
,"8":"Porque hay amigos de ocasión, que no te son fieles el día de la tribulación."
,"9":"Hay amigos que se vuelven enemigos, y descubrirán tus enredos para tu vergüenza."
,"10":"Hay amigos compañeros de mesa, pero no te son fieles en el día de la tribulación."
,"11":"Mientras van bien las cosas será otro tú,y se mostrará afable con tus servidores;"
,"12":"pero si eres humillado, se volverá contra ti,y se esconderá de tu vista."
,"13":"Apártate de tus enemigos, y ten cuidado con tus amigos."
,"14":"Un amigo fiel es escudo poderoso; el que lo encuentra halla un tesoro."
,"15":"Un amigo fiel no se paga con nada, no hay precio para él."
,"16":"Un amigo fiel es bálsamo de vida, los que temen al Señor lo encontrarán."
,"17":"El que teme a Dios cuida bien sus amistades, porque como es él así será su amigo."
,"18":"Hijo, desde tu juventud ponte a aprender, y hasta encanecer hallarás sabiduría."
,"19":"Como el que ara y el que siembra acércate a ella,y espera sus buenos frutos, pues en su cultivo trabajarás poco,y presto saborearás sus frutos."
,"20":"La sabiduría es difícil para los ignorantes,e insoportable para los insensatos."
,"21":"Como pesada piedra de prueba pesará sobre él, no tardará en arrojarla."
,"22":"Pues la sabiduría merece bien su nombre, no se manifiesta a muchos."
,"23":"Escucha, hijo, acepta mi parecer, no rechaces mi consejo."
,"24":"Mete tus pies en sus cadenas, y tu cuello en su argolla."
,"25":"Arrima tu hombro y llévala, no te molesten sus ataduras."
,"26":"Con toda tu alma vete a ella, con todas tus fuerzas guarda sus caminos."
,"27":"Rastréala y búscala; ella se te manifestará; y, una vez agarrada, no la dejes escapar."
,"28":"Porque al fin hallarás en ella tu descanso,y se cambiará para ti en alegría."
,"29":"Entonces sus grillos serán para ti fuerte protección, sus argollas glorioso vestido."
,"30":"Atavío de oro será su yugo, sus ataduras cordones de púrpura."
,"31":"Te la vestirás como túnica gloriosa, te la ceñirás como fúlgida corona."
,"32":"Si quieres, hijo, te harás sabio; si te entregas a ella con ilusión, serás avisado."
,"33":"Si te gusta escuchar, aprenderás; si sabes escuchar, serás sabio."
,"34":"Júntate con los ancianos, y si ves a un sabio, vete con él."
,"35":"Escucha de buen grado toda palabra que viene de Dios, y no dejes pasar las sentencias prudentes."
,"36":"Si ves a un hombre inteligente, vete pronto con él: que tu pie gaste los umbrales de su puerta."
,"37":"Medita los mandamientos del Señor,y aplícate sin cesar a sus preceptos. Él hará firme tu corazón,y te dará la sabiduría tan deseada."
}`)
	CurrentBook.AddChapter(7, `{
"1":"No hagas el mal, y el mal no te dominará."
,"2":"Apártate de la injusticia, y ella se alejará de ti."
,"3":"Hijo mío, no siembres en surcos de injusticia, para que no coseches de ella siete veces más."
,"4":"No pidas al Señor puesto de gobierno, ni al rey silla de honor."
,"5":"No te justifiques ante el Señor, ni te hagas el sabio ante el rey."
,"6":"No pretendas ser juez si no tienes fuerza suficiente para reprimir la injusticia, no sea que te acobardes ante el poderoso y pongas en peligro tu rectitud."
,"7":"No ofendas a la asamblea de la ciudad, ni te rebajes ante el pueblo."
,"8":"No te ates dos veces con el pecado, pues no quedarás impune ya en la primera."
,"9":"No digas: 'Dios considerará la multitud de mis ofrendas; cuando yo se las ofrezca al Dios altísimo, las recibirá'."
,"10":"No seas impaciente en tu oración,y no descuides el hacer limosna."
,"11":"No te burles del hombre que yace en amargura, porque hay uno que humilla y levanta."
,"12":"No levantes mentiras contra tu hermano, ni lo hagas tampoco con tu amigo."
,"13":"Guárdate de decir mentira alguna, porque no puede resultar nada bueno."
,"14":"No seas hablador en la asamblea de ancianos,y no repitas palabras en tu oración."
,"15":"No aborrezcas la labor por fatigosa, ni el trabajo del campo por el altísimo instituido."
,"16":"No te cuentes entre el número de los pecadores, recuerda que la cólera no tardará."
,"17":"Humíllate profundamente, porque el fuego y los gusanos son el castigo del malvado."
,"18":"No cambies un amigo por dinero, ni un hermano auténtico por el oro de Ofir."
,"19":"No menosprecies una mujer discreta y buena, porque su gracia está por encima del oro."
,"20":"No maltrates al siervo fiel en el trabajo, ni al jornalero que se sacrifica."
,"21":"Ama como a ti mismo al siervo discreto, y no le niegues la libertad."
,"22":"¿Tienes ganados? Cuida de ellos; y, si te son útiles, guárdalos."
,"23":"¿Tienes hijos? Edúcalos,y doblega desde su juventud su cuello."
,"24":"¿Tienes hijas? Vigila su cuerpo, y no les muestres rostro muy sonriente."
,"25":"Casa a tu hija y habrás hecho una gran obra; pero dala a un varón prudente."
,"26":"¿Tienes una mujer según tu corazón?,No la rechaces; pero si no la amas, no te confíes a ella."
,"27":"Honra a tu padre con todo tu corazón, y no olvides los dolores de tu madre."
,"28":"Acuérdate que fuiste engendrado por ellos; ¿cómo podrás pagarles lo que hicieron por ti?"
,"29":"Con todo tu corazón teme al Señor,y venera a sus sacerdotes."
,"30":"Ama con todas tus fuerzas al Señor,y no abandones a sus ministros."
,"31":"Teme al Señor y honra al sacerdote, y dale su parte como te fue prescrito: las primicias, sacrificio de reparación, el lomo reservado, el sacrificio de consagración,y las primicias de las cosas santas."
,"32":"Alarga al pobre tu mano,para que seas plenamente bendecido."
,"33":"La gracia de tu dádiva alcance a todos los vivientes, y al muerto no le niegues tu caridad."
,"34":"No te alejes de los que lloran,y aflígete con los afligidos."
,"35":"No rehúyas visitar a los enfermos, pues si los visitas ellos te lo agradecerán."
,"36":"En todas tus obras acuérdate del final, y no pecarás jamás."
}`)
	CurrentBook.AddChapter(8, `{
"1":"No luches con el poderoso, no sea que caigas en sus manos."
,"2":"No te querelles contra un rico, no sea que pese más que tú; pues el oro perdió a muchos,y torció el corazón de los reyes."
,"3":"No discutas con hombre charlatán; sería echar leña al fuego."
,"4":"No andes bromeando con el ineducado, para que no sean insultados tus progenitores."
,"5":"No avergüences al que se convierte de su pecado; acuérdate de que todos somos pecadores."
,"6":"No desprecies al anciano, porque también nosotros nos haremos viejos."
,"7":"No te alegres de la muerte de nadie; recuerda que todos moriremos."
,"8":"No desprecies los discursos de los sabios,y vuelve con frecuencia a sus máximas, porque de ellos aprenderás la instrucción,y el saber comportarte ante los grandes."
,"9":"No desprecies la tradición de los ancianos, pues la aprendieron de sus padres; porque de ellos aprenderás prudencia,y a responder bien cuando haga falta."
,"10":"No atices el fuego del pecador, para que no seas abrasado por sus llamas."
,"11":"No retrocedas ante el insolente, para que no ponga una emboscada a tus palabras."
,"12":"No prestes a hombre más fuerte que tú; si prestaste, dalo por perdido."
,"13":"No salgas fiador más allá de tus posibilidades; si saliste, date por deudor."
,"14":"No entables juicio contra un juez, porque fallarán a su favor."
,"15":"No te pongas en camino con el temerario,para que no se imponga a ti; porque él obrará según su capricho, y su locura te perderá con él."
,"16":"No discutas con un hombre violento,y no atravieses con él lugar desierto, porque nada cuenta la sangre a sus ojos, y donde no tengas quien te socorra se arrojará sobre ti."
,"17":"No tengas confidencias con el tonto, porque no podrá guardar tu secreto."
,"18":"Ante un extraño no hagas cosa que deba quedar en secreto, porque no sabes lo que resultará."
,"19":"No descubras tu corazón a cualquiera, si no quieres perder la felicidad."
}`)
	CurrentBook.AddChapter(9, `{
"1":"No seas celoso de la mujer que amas,si no la quieres inducir a que obre mal contra ti."
,"2":"No entregues tu voluntad a una mujer, para que no te llegue a dominar."
,"3":"No te vayas con una prostituta, para que no caigas en sus lazos."
,"4":"No te entretengas con una cupletista, para que no quedes prisionero de sus encantos."
,"5":"No fijes tu atención en mujer virgen, no sea que sufras por su causa."
,"6":"No te entregues a una prostituta, para no arruinar tu patrimonio."
,"7":"No pasees tus ojos por las calles de la ciudad, ni andes dando vueltas por sus calles desiertas."
,"8":"Aparta tus ojos de la mujer bonita,y no te fijes en belleza ajena. Por la hermosura de la mujer muchos se extraviaron, y con ella la pasión se inflama como un fuego."
,"9":"No te sientes jamás junto a mujer casada, ni te pongas a la mesa con ella a beber vino, no sea que se incline hacia ella tu corazón, y por tu pasión te lleve a la ruina."
,"10":"No abandones al viejo amigo, porque el nuevo no valdrá lo que él. Vino nuevo es el amigo nuevo, cuando se haga viejo lo beberás con placer."
,"11":"No envidies la gloria del pecador, porque no sabes cuál será su fin."
,"12":"No tengas envidia del éxito de los malvados; piensa que cuando mueran serán castigados."
,"13":"Aléjate del hombre que tiene poder de matar, y no tendrás que temer la muerte; pero si te acercas a él, no cometas falta, para que no te quite la vida. Ten presente que caminas en medio de lazos,y marchas sobre la muralla de la ciudad."
,"14":"Siempre que puedas busca a tu prójimo,y aconséjate de los sabios."
,"15":"Trata con los inteligentes,y reflexiona siempre sobre la ley del altísimo."
,"16":"Los hombres justos sean tus comensales, y en el temor del Señor esté tu gloria."
,"17":"La mano del artífice se alaba por su obra, la sabiduría del jefe del pueblo por sus discursos."
,"18":"El hombre locuaz es de temer en la ciudad, el que habla sin ton ni son se hace odioso."
}`)
	CurrentBook.AddChapter(10, `{
"1":"El juez sabio instruye a su pueblo, y el mandato del inteligente está bien ordenado."
,"2":"Según el gobernante de la ciudad, así sus subordinados; y según el que rige la ciudad, así sus habitantes."
,"3":"El rey ignorante es la ruina de su pueblo, una ciudad prospera con la inteligencia de sus jefes."
,"4":"En manos del Señor está el gobierno de la tierra, él suscita en cada momento el jefe oportuno."
,"5":"En manos de Dios está el éxito del hombre, él da al soberano su gloria."
,"6":"No guardes rencor al prójimo por ninguna injusticia, ni hagas nada movido de la pasión."
,"7":"La soberbia es odiosa delante del Señor y de los hombres, para los dos la injusticia es un delito."
,"8":"El imperio pasa de unas naciones a otras,a causa de la injusticia, el orgullo y la avaricia."
,"9":"¿De qué se ensoberbecerá el polvo y la ceniza, si ya en vida sus intestinos están llenos de podredumbre?"
,"10":"Una larga enfermedad se burla del médico; hoy es el rey, y mañana está muerto."
,"11":"Al morir el hombre, recibe en herencia reptiles, bichos y gusanos."
,"12":"El principio de la soberbia es apartarse del Señor,y tener alejado el corazón de su hacedor."
,"13":"Porque el principio de la soberbia es el pecado, el poseído por ella hace llover las calamidades. Por eso el Señor envió extraños castigos,y los redujo a la nada."
,"14":"El Señor arranca de raíz el trono de los potentes,y hace sentar en su lugar a los mansos."
,"15":"El Señor arrancó las raíces de las gentes,y plantó en su lugar a los humildes."
,"16":"El Señor asoló el territorio de las gentes,y las destruyó hasta los fundamentos de la tierra."
,"17":"Arrancó y aniquiló a algunos, e hizo desaparecer hasta su memoria de la tierra."
,"18":"No se creó el orgullo para el hombre, ni la ira furiosa para el nacido de mujer."
,"19":"¿Qué raza es digna de honor? La humana. ¿Qué raza es digna de honor? Los que temen al Señor. ¿Qué raza es despreciable? La raza humana. ¿Qué raza es despreciable? Los que violan los mandamientos."
,"20":"Entre sus hermanos es digno de honor su jefe, y ante Dios son dignos de honor los que lo temen."
,"22":"Rico, noble o pobre, su gloria está en el temor del Señor."
,"23":"No es justo despreciar al pobre inteligente, ni conviene honrar al pecador."
,"24":"El grande, el juez y el poderoso son dignos de honor, pero ninguno de ellos es más grande que el que teme al Señor. "
,"25":"Al siervo sabio le servirán los libres, el varón sabio no se queja."
,"26":"No te la des de sabio en tu trabajo, y no te gloríes en tiempo de necesidad."
,"27":"Más vale el que trabaja y tiene de todo,que el que es presumido y carece de pan."
,"28":"Hijo mío, honra a tu alma con la humildad,y apréciala en su justo valor."
,"29":"¿Quién justificará al que peca contra su alma?,¿Y quién honrará a quien a sí mismo se deshonra?"
,"30":"Al pobre se le respeta por su inteligencia, y al rico por su riqueza."
,"31":"El que es honrado en la pobreza, ¡cuánto más lo será en la riqueza!,Y el que es despreciado en la riqueza, ¡cuánto más en la pobreza!"
}`)
	CurrentBook.AddChapter(11, `{
"1":"La sabiduría del humilde le hace erguir su cabeza,y le da asiento en medio de los grandes."
,"2":"No alabes al hombre por su hermosura, ni desprecies a nadie por su aspecto."
,"3":"Pequeña es la abeja entre los volátiles, pero su fruto es el más dulce."
,"4":"No te envanezcas de los vestidos que llevas, ni te engrías en el día de tu gloria; porque las obras del Señor son admirables, pero ocultas a los hombres."
,"5":"Muchos reyes acabaron sentándose en el polvo, y el que menos se pensaba ciñó la corona."
,"6":"Muchos potentados fueron humillados en extremo, y hombres ilustres fueron entregados en manos de otros."
,"7":"No censures antes de tener pruebas; investiga primero, y después corrige."
,"8":"Antes de escuchar no respondas, y no interrumpas al que habla."
,"9":"No te metas en lo que no te importa, y en las querellas de los pecadores no te mezcles."
,"10":"Hijo, no emprendas muchos negocios; que, si los multiplicas, sufrirás las consecuencias."
,"11":"Aunque los persigas, no los alcanzarás; y aunque huyas, no podrás escapar de ellos. Hay quien trabaja, se fatiga y corre, y con todo queda más atrás."
,"12":"Hay quien es débil y necesita ayuda, falto de fuerza y sobrado de pobreza; pero el Señor lo mira con bondad, lo alza de su miseria"
,"13":"y levanta su cabeza para admiración de todos."
,"14":"Bienes y males, vida y muerte, pobreza y riqueza vienen del Señor."
,"15":"Sabiduría, prudencia y sensatez proceden del Señor, castigo y camino recto proceden del Señor."
,"16":"La ignorancia y la oscuridad se crearon para los criminales, y el mal acompaña a los malvados."
,"17":"Los dones del Señor acompañan a los piadosos,y su benevolencia asegura su prosperidad para siempre."
,"18":"Hay quien se enriquece a fuerza de afán y de avaricia, y ésta es su recompensa."
,"19":"Cuando dice: 'Hallé descanso, ahora comeré de mis bienes', no sabe cuánto va a durar esto, pues tiene que dejar a otros sus riquezas y morir."
,"20":"Cumple con tu trabajo, conságrate a él y hazte viejo en su desempeño."
,"21":"No admires las obras del pecador; confía en el Señor y permanece en tu oficio. Porque es fácil cosa a Dios,hacer rico al pobre en un instante."
,"22":"La bendición del Señor es la recompensa del piadoso; en un momento hace florecer su bendición."
,"23":"No digas: '¿Qué necesito,y qué falta tengo ya de nada?'."
,"24":"No digas: 'Estoy satisfecho; ¿qué mal podrá venir sobre mí?'."
,"25":"En el día de los bienes se olvidan los males, y en el día de los males no se recuerdan los bienes."
,"26":"Pero es fácil al Señor en el día de la muerte,dar a cada uno lo suyo."
,"27":"La aflicción de una hora hace olvidar el placer, el fin del hombre manifiesta sus obras."
,"28":"Antes de la muerte no alabes a nadie, porque el hombre será reconocido por su fin."
,"29":"No admitas a cualquiera en tu casa, que son muchas las asechanzas de la intriga."
,"30":"Como perdiz de reclamo en la jaula es el corazón del orgulloso, como un espía vigila tu caída."
,"31":"Porque él acecha para cambiar el bien en mal, y en las cosas dignas de alabanza ha de encontrar censura."
,"32":"Una chispa enciende las brasas, las trampas del criminal hacen correr la sangre."
,"33":"Guárdate del malvado que maquina el mal, no sea que te acarree deshonra eterna."
,"34":"Admite en tu casa a un extraño, y te la revolverá y te pondrá a mal con los tuyos."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Si haces el bien, mira a quién lo haces, y tus favores no habrán sido perdidos."
,"2":"Haz bien al hombre bueno, y tendrás recompensa; si no de él, al menos del altísimo."
,"3":"No prosperará el que incita al mal,y no ejercita la caridad."
,"4":"Da al justo, y no acojas al pecador."
,"5":"Haz el bien al humilde, y no des al malvado; niégale su pan y no se lo des, porque se tornará más fuerte que tú,y te pagaría con doble mal todo el bien que le hagas."
,"6":"Porque también el altísimo odia a los pecadores,y castiga a los criminales."
,"7":"Da al bueno, y no ayudes al malvado."
,"8":"No se puede conocer al amigo en la prosperidad, ni en la adversidad se puede esconder al enemigo."
,"9":"En la prosperidad de uno sus enemigos se entristecen, pero en su desgracia aun el amigo lo abandona."
,"10":"No confíes en tu enemigo jamás, porque su maldad es como el bronce que se oxida."
,"11":"Aunque se muestre humilde y obsequioso, ponte sobre aviso y guárdate de él. Haz con él como quien limpia un espejo,y verás que no estaba todavía totalmente oxidado."
,"12":"No lo pongas junto a ti, no sea que te derribe y ocupe tu puesto. No lo sientes a tu derecha, no sea que te quite la silla; entonces comprenderías mis consejos,y te lamentarías al recordar mis advertencias."
,"13":"¿Quién se compadecerá del encantador mordido por la serpiente,y del que anda con fieras?"
,"14":"Así es quien se acompaña del delincuente,y se mezcla en sus delitos."
,"15":"Mientras te mantengas en pie, no te traicionará; pero si te ve vacilar, no se refrenará más."
,"16":"El enemigo habla con halago, pero en su corazón maquina arrojarte en la fosa. El enemigo tiene lágrimas en sus ojos, pero si llega la ocasión no se saciará de sangre."
,"17":"Sacudirá la cabeza, batirá palmas, y murmurando entre dientes cambiará el semblante."
}`)
	CurrentBook.AddChapter(13, `{
"1":"El que toca la pez se mancha, y el que trata con el soberbio viene a parecerse a él."
,"2":"No tomes peso superior a tus fuerzas, no trates con el más fuerte y rico que tú. ¿Cómo vamos a juntar la olla de barro con la caldera?,Ésta chocará con ella y la romperá."
,"3":"El rico comete injusticia, y encima presume; el pobre sufre una injusticia, y aún debe excusarse."
,"4":"Mientras le seas útil, se servirá de ti; pero si estás en necesidad, te abandonará."
,"5":"Si tienes algo vivirá contigo, pero te arruinará sin dolerle."
,"6":"Si tiene necesidad, te adulará, te sonreirá y te dará esperanzas; te dirá buenas palabras,y te preguntará: '¿Qué necesitas?'."
,"7":"Te avergonzará con sus invitaciones,hasta que te arruine dos o tres veces, y al fin se burlará de ti. Después de esto mirará como si no te conociese,y se burlará moviendo la cabeza."
,"8":"Guárdate de ser engañado,y humillado por su insensatez."
,"9":"Si un potentado te llama, échate atrás; así te llamará con mayor insistencia."
,"10":"Nunca te apresures, para no ser rechazado; pero no andes muy lejos, para que no seas olvidado."
,"11":"No te tomes la libertad de intimar con él,ni te fíes de su palabrería, porque con su verborrea te pondrá a prueba,y entre sonrisas te irá sonsacando."
,"12":"Es un hombre sin piedad, que no mantiene su palabra,y no te ahorrará golpes y cadenas."
,"13":"Estáte atento y guárdate mucho, porque caminas en compañía de tu propia ruina."
,"15":"Todo viviente ama a su semejante, y todo hombre a su prójimo."
,"16":"Toda carne se une según su especie, y el hombre se asocia a su semejante."
,"17":"¿Cómo se podrían juntar el lobo y el cordero?,Sería igual que unir al injusto con el justo."
,"18":"¿Qué paz podría haber entre la hiena y el perro?,¿Qué paz entre el rico y el pobre?"
,"19":"El asno salvaje es presa de los leones en el desierto; así los pobres son pasto de los ricos."
,"20":"La humildad es repulsiva para el orgulloso, y el pobre es repulsivo para el rico."
,"21":"Cuando el rico vacila es sostenido por los amigos; pero si cae el pobre, hasta de los amigos es rechazado."
,"22":"Cuando el rico tropieza, hay muchos para recibirlo en brazos; dice despropósitos, y le dan la razón. Cuando el pobre tropieza, se le carga de insultos; y si habla con sensatez, no hay sitio para él."
,"23":"Cuando el rico habla, todos callan,y ensalzan hasta las nubes su buen criterio. Cuando habla el pobre, dicen: '¿Quién es ése?', y si tropieza, ellos mismos lo tiran al suelo."
,"24":"Buena es la riqueza cuando es sin pecado, y mala la pobreza al decir del malvado."
,"25":"El corazón del hombre se refleja en su cara, lo mismo para el bien que para el mal."
,"26":"Cara alegre es señal de corazón satisfecho; cara triste es señal de preocupación y afán. La invención de proverbios es una reflexión trabajosa."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Dichoso el hombre que no peca con sus palabras,y no es atormentado por el remordimiento de los pecados."
,"2":"Dichoso el hombre al que su conciencia no lo acusa, que no pierde nunca su esperanza."
,"3":"Al corazón mezquino no le hace falta la riqueza; y el avaro, ¿para qué quiere el oro?"
,"4":"El que amontona con privaciones, para otros ahorra, y con sus bienes otros se alimentarán."
,"5":"El que es malo para sí, ¿para quién será bueno?; ni él disfruta de sus bienes."
,"6":"Nadie es más necio que el avaro aun consigo mismo, y ésta es la paga de su maldad."
,"7":"Si hace algo bueno es por descuido, y al fin se manifiesta su malicia."
,"8":"Malo es quien mira con envidia, el que vuelve el rostro y desprecia a los demás."
,"9":"El ojo del envidioso no se sacia con su parte, y la injusticia perversa seca su alma."
,"10":"El ojo del avaro envidia hasta el pan, hay penuria en su mesa."
,"11":"Hijo, en la medida de lo posible, trátate bien, y presta al Señor las ofrendas debidas."
,"12":"Hijo, recuerda que la muerte no tarda, y que no te han dicho cuándo vas a morir."
,"13":"Antes de morir haz bien al amigo,y, según tus posibilidades, extiende la mano y dale."
,"14":"No te prives de un día feliz, y no dejes pasar la parte de una satisfacción legítima."
,"15":"¿No has de dejar a otro la fortuna, y el fruto de tus fatigas a tus herederos?"
,"16":"Da, toma y regálate, porque no hay lugar para el gozo en el abismo."
,"17":"Toda carne envejece como vestido, porque es ley eterna: has de morir."
,"18":"Como las hojas verdes de un árbol frondoso, que unas caen y otras brotan, así las generaciones humanas, unas mueren y otras nacen."
,"19":"Toda obra corruptible perece, y tras ella va su autor."
,"20":"Dichoso el hombre que busca la sabiduría,y que discurre con inteligencia,"
,"21":"que medita en su corazón sobre sus caminos,y reflexiona sobre sus secretos."
,"22":"Sale en pos de ella como el cazador,y está a la espera en su camino."
,"23":"Dichoso el que se asoma por la ventana,y permanece a la escucha a sus puertas;"
,"24":"el que acampa en las cercanías de su casa, clava su estaca en sus muros,"
,"25":"planta su tienda a su lado,y habita allí en dulce morada."
,"26":"Pone a sus hijos bajo su amparo,y descansa bajo sus ramas."
,"27":"Bajo su sombra se protege del calor,y en su gloria descansa."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Así hará el que teme al Señor; el que abraza la ley alcanza la sabiduría."
,"2":"Como madre le saldrá al encuentro, y como esposa virgen lo recibirá."
,"3":"Le alimentará con pan de entendimiento,y le dará a beber agua de sabiduría."
,"4":"Se apoyará en ella y no vacilará, se confiará a ella y no fracasará."
,"5":"Lo levantará por encima de sus vecinos,y en medio de la asamblea le abrirá la boca."
,"6":"Hallará en ella gozo y corona de alegría, heredará nombre eterno."
,"7":"Los insensatos no la lograrán, los malvados no la verán."
,"8":"Está lejos del orgullo, y los mentirosos no se acuerdan de ella."
,"9":"No es propia la alabanza en boca del malvado, pues no le fue dada por Dios."
,"10":"Porque la alabanza supone la sabiduría, y el Señor es quien la concede."
,"11":"No digas: 'Fue Dios quien me empujó al delito', porque no has de hacer lo que él odia."
,"12":"No digas: 'Él me hizo errar', porque no tiene necesidad de un hombre pecador."
,"13":"El Señor odia toda abominación, y los que le temen no la aman."
,"14":"Él hizo al hombre al principio, y lo dejó en manos de su propio albedrío."
,"15":"Si tú quieres, puedes guardar los mandamientos; permanecer fiel está en tu mano."
,"16":"Él ha puesto ante ti el fuego y el agua; extiende tu mano a lo que quieras."
,"17":"Ante el hombre está la vida y la muerte; a cada uno se le dará lo que él quiera."
,"18":"Porque es grande la sabiduría del Señor; él es fuerte, poderoso y todo lo ve."
,"19":"Sus ojos miran a los que le temen, conoce todas las obras del hombre."
,"20":"A ninguno ha ordenado que sea malo, ni ha dado permiso a nadie para pecar."
}`)
	CurrentBook.AddChapter(16, `{
"1":"No desees multitud de hijos si son unos inútiles, ni te alegres de tener hijos malvados."
,"2":"Aunque sean muchos, no te goces en ellos,si no tienen el temor del Señor."
,"3":"No confíes en su vida,ni te apoyes en su número, porque es mejor uno que mil, y morir sin hijos que tenerlos malos."
,"4":"Con un solo hombre inteligente,se puebla una ciudad, mas la raza de los malvados será aniquilada."
,"5":"Muchas cosas como éstas han visto mis ojos,y cosas más graves oyeron mis oídos."
,"6":"En la asamblea de los delincuentes se encendió el fuego, en la nación rebelde se inflamó la cólera."
,"7":"No perdonó a los antiguos gigantes, que confiados en su fuerza se rebelaron."
,"8":"No se compadeció de los vecinos de Lot, de los que sintió asco a causa de su orgullo."
,"9":"No tuvo piedad de la raza maldita, que fueron exterminados por sus débitos,"
,"10":"ni de los seiscientos mil hombres,que se habían confabulado en la dureza de su corazón."
,"11":"Aunque no hubiese habido más que uno de cabeza dura, maravilla sería que hubiese quedado impune. Porque en él están la misericordia y la ira; es poderoso en perdones y fulmina su ira."
,"12":"Tan grande es su misericordia como su severidad, y juzga a todos según sus obras."
,"13":"No deja escapar al malvado con su rapiña, ni frustra la paciencia del justo."
,"14":"Dará curso libre a su piedad, cada uno recibirá según sus obras."
,"15":"El Señor endureció el corazón del faraón,que no lo quiso reconocer,para manifestar sus obras bajo el cielo."
,"16":"Todas las criaturas conocen su compasión, su luz y su alabanza son la porción de los hombres."
,"17":"No digas: 'Me esconderé del Señor; allá arriba, ¿quién se va a acordar de mí?; no seré reconocido entre tanta gente, porque ¿quién soy yo en la inmensa creación?'."
,"18":"Mira, el cielo y los cielos altísimos, el abismo y la tierra se estremecen con su visita."
,"19":"Los montes y los cimientos de la tierra,tiemblan por igual cuando él los mira."
,"20":"Pero sobre estas cosas nadie reflexiona; sus caminos, ¿quién los considera?"
,"21":"También la tempestad permanece invisible, y la mayor parte de sus obras están ocultas."
,"22":"Las obras de su justicia, ¿quién las enuncia?,¿O qué se va a esperar por esto?,Porque la recompensa está muy lejana."
,"23":"Así piensa el hombre que ha perdido el juicio; el insensato y el extraviado sólo piensan locuras."
,"24":"Escúchame, hijo, y aprende mi enseñanza; aplica tu corazón a mis palabras."
,"25":"Te expondré la instrucción con mesura, con exactitud te daré a conocer mi doctrina."
,"26":"Cuando al principio Dios creó sus obras, una vez hechas distribuyó sus partes."
,"27":"Ordenó para siempre sus obras, desde sus orígenes y por generaciones. Ni tienen hambre ni se cansan, y no cesa su actividad."
,"28":"Ninguna entorpece a la otra, jamás desobedecerán a su palabra."
,"29":"Después de esto, miró el Señor la tierra,y la llenó de sus bienes."
,"30":"Con toda clase de vivientes cubrió su superficie, y todos volverán a la tierra."
}`)
	CurrentBook.AddChapter(17, `{
"1":"El Señor creó al hombre de la tierra, y de nuevo le hará volver a ella."
,"2":"Le señaló un número preciso de días y tiempo fijo, y le dio poder sobre los seres que en ella existen."
,"3":"Los revistió de fuerza, como él mismo, y los hizo a su imagen."
,"4":"Infundió el temor a él en toda carne,para que dominase sobre las bestias y las aves."
,"6":"Les formó lengua, ojos y oídos, y les dio un corazón para pensar."
,"7":"Los llenó de ciencia e inteligencia, y les dio a conocer el bien y el mal."
,"8":"Puso su luz en sus corazones,para mostrarles la grandeza de sus obras."
,"10":"Alabarán su nombre santo,y pregonarán la grandeza de sus obras."
,"11":"Les dio además conocimientos, y en herencia les dio la ley de vida."
,"12":"Hizo con ellos un pacto eterno,y les manifestó sus decretos."
,"13":"Sus ojos vieron la grandeza de su gloria, sus oídos oyeron su voz majestuosa."
,"14":"Y les dijo: 'Guardaos de toda injusticia'; les dio mandamientos con relación al prójimo."
,"15":"Sus caminos están siempre ante él, y no se esconderán de sus ojos."
,"16":"(Sus caminos desde la niñez se inclinan al mal, no son capaces de transformar,en corazones de carne los de piedra)."
,"17":"A cada pueblo señaló un jefe, pero Israel es la porción del Señor."
,"18":"(Por ser su primogénito lo educa,y porque le dio la luz de su amor no lo abandona)."
,"19":"Todas sus obras están ante él como está el sol, sus ojos están siempre sobre su conducta."
,"20":"Sus injusticias no se le ocultan, y todos sus pecados están delante del Señor."
,"21":"(El Señor, que es bueno y conoce a su criatura, no los rechaza ni abandona, sino que los perdona)."
,"22":"La limosna del hombre está como un sello ante Dios, él tiene en cuenta un beneficio como la niña de los ojos."
,"23":"Luego se alzará para recompensarlos, pondrá sobre cada uno el pago de sus buenas obras."
,"24":"A los que se arrepienten les concede retornar, consuela a los que carecen de esperanza."
,"25":"Vuélvete al Señor y deja el pecado, suplícale y cesen tus ofensas."
,"26":"Vuélvete al altísimo, apártate de la injusticia,y aborrece lo abominable."
,"27":"Porque en el abismo, ¿quién alabará al altísimo?,Sólo los vivos pueden alabarlo."
,"28":"El que muere y deja de existir ya no puede alabar; mientras vive y está sano es cuando puede alabar al Señor."
,"29":"¡Qué grande es la misericordia del Señor,y su perdón para los que a él se convierten!"
,"30":"Ningún hombre lo puede todo, porque el ser humano no es inmortal."
,"31":"¿Qué hay más luminoso que el sol?,Pues también él se eclipsa. Quien es de carne y sangre urdirá la maldad."
,"32":"Dios vigila el ejército de los cuerpos celestes, pero los hombres son todos polvo y ceniza."
}`)
	CurrentBook.AddChapter(18, `{
"1":"El que vive eternamente creó todas las cosas a un tiempo."
,"2":"Sólo el Señor puede proclamarse justo."
,"3":"Dirige el universo con la palma de la mano, y todos cumplen sy voluntad; es rey universal y poderoso,que separa lo santo de lo profano."
,"4":"A nadie concedió pregonar sus obras; ¿quién descubrirá sus grandezas?"
,"5":"¿Quién podrá medir la fuerza de su majestad,y contar sus misericordias?"
,"6":"No se puede quitar ni añadir nada, ni es posible descubrir las maravillosas obras de Dios."
,"7":"Cuando el hombre termina, entonces está comenzando; cuando se detiene, queda desconcertado."
,"8":"¿Qué es el hombre y para qué sirve?,¿Cuál es su bien y cuál su mal?"
,"9":"La duración de la vida del hombre, como mucho es de cien años;"
,"10":"cual gota de agua del mar y grano de arena, así son sus pocos años en comparación de la eternidad."
,"11":"Por eso es tan paciente el Señor con ellos,y derrama sobre ellos su misericordia."
,"12":"Él ve y sabe que su fin es desdichado; por eso multiplica sus perdones."
,"13":"La compasión del hombre se limita a su prójimo, la del Señor envuelve a todas sus criaturas; reprende, corrige, enseña,y guía como un pastor su rebaño."
,"14":"Dichosos los que reciben su enseñanza,y son diligentes buscando sus preceptos."
,"15":"Hijo, tus favores no los acompañes de reproches, ni tus obsequios de palabras amargas."
,"16":"¿Es que el rocío no templa el ardor del sol?,Así una buena palabra es mejor que un regalo."
,"17":"Mira, ¿no vale más una palabra que un rico presente?,Pues el hombre caritativo sabe unir las dos cosas."
,"18":"El insensato insulta groseramente, el don del envidioso consume los ojos."
,"19":"Entérate antes de hablar, y cuídate antes de enfermar."
,"20":"Antes de juzgar examínate a ti mismo, y en la hora de la visita encontrarás perdón."
,"21":"Antes de caer enfermo humíllate, y cuando peques arrepiéntete."
,"22":"No dejes de cumplir a tiempo tus promesas, no esperes a hacerlo en la muerte."
,"23":"Antes de hacer una promesa piénsalo, no seas como hombre que tienta a Dios."
,"24":"Acuérdate de la cólera de los últimos días, del día de la venganza cuando Dios vuelva su rostro."
,"25":"Acuérdate del tiempo de penuria en los días de abundancia, de la pobreza y miseria en los días de riqueza."
,"26":"Como cambia el tiempo de la mañana a la tarde, así pasan veloces las cosas ante el Señor."
,"27":"El hombre sabio en todo anda prevenido, y en el día de la tentación se guarda de la caída."
,"28":"El hombre sensato conoce la sabiduría, y el que la ha encontrado la alaba."
,"29":"Los que escuchan sabias sentencias se hacen sabios, y derraman como lluvia proverbios oportunos."
,"30":"No te vayas tras tus pasiones, y refrena tus deseos."
,"31":"Si satisfaces todos tus deseos, serás la burla de tus enemigos."
,"32":"No te complazcas en una vida de placer, ni te dejes esclavizar por ella."
,"33":"No te empobrezcas banqueteando con dinero prestado,cuando nada queda en tu bolsa."
}`)
	CurrentBook.AddChapter(19, `{
"1":"El obrero bebedor nunca se hará rico; quien desprecia lo poco no tardará en caer."
,"2":"El vino y las mujeres hacen perder la cabeza a los sensatos, el que frecuenta las prostitutas pierde todo pudor."
,"3":"Larvas y gusanos serán su herencia, el hombre sin escrúpulos va a la ruina."
,"4":"El que fácilmente se confía es ligero de corazón, y el que peca se perjudica a sí mismo."
,"5":"El que se goza en lo malo será condenado;"
,"6":"el que aborrece la charlatanería escapa al mal."
,"7":"No repitas jamás una habladuría; así nadie te afrentará."
,"8":"No lo cuentes ni al amigo ni al enemigo,y, a menos que el silencio te haga culpable, no lo digas."
,"9":"Porque el que te oiga se pondrá en guardia,y, llegado el momento, te odiará."
,"10":"¿Has oído algo? Que muera contigo; no temas, que no te hará reventar."
,"11":"Al insensato eso le hace sufrir, como a la parturienta la criatura."
,"12":"Como flecha clavada en el muslo, así es la palabra secreta en las entrañas del necio."
,"13":"Interroga al amigo, quizá él no ha hecho nada; y si lo hizo, para que no lo vuelva a hacer."
,"14":"Interroga a tu amigo, quizá no ha dicho nada; y si lo ha dicho, para que no lo vuelva a decir."
,"15":"Interroga al amigo, porque muchas veces hay calumnias; no creas de ligero cualquier cosa."
,"16":"Hay quien resbala sin querer; ¿quién no peca jamás con la lengua?"
,"17":"Interroga a tu vecino antes de amenazarle, y da lugar a la ley del altísimo."
,"20":"Toda la sabiduría estriba en el temor de Dios, en toda sabiduría se da el cumplimiento de la ley."
,"22":"Pues no es sabiduría la ciencia del mal, ni prudencia el consejo de los pecadores."
,"23":"Hay una astucia aborrecible; el que carece de sabiduría es un insensato."
,"24":"Vale más poca inteligencia con temor de Dios,que con mucha traspasar la ley."
,"25":"Hay una habilidad consumada que es pura injusticia, y hay quien hace trampa para mantener su derecho."
,"26":"Hay quien camina encorvado por la pena, pero en su interior no hay más que falsedad."
,"27":"Baja la cabeza y se hace el sordo, pero donde no es observado te tomará la delantera."
,"28":"Y si por falta de medios no puede hacerte mal, en la primera ocasión te hará algún daño."
,"29":"Por su aspecto se conoce al hombre, y por su semblante al sensato."
,"30":"El vestir, el reír y su caminar,denuncian lo que es."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Hay una reprensión que es inoportuna, y hay silencios que revelan al hombre sensato."
,"2":"Mejor es reprender que guardar rencor."
,"3":"El que se confiesa culpable se libra del daño."
,"4":"Como eunuco que desea desflorar a una doncella,es el que impone la justicia por la fuerza."
,"5":"Hay quien guarda silencio y pasa por sabio, y hay quien se hace odioso por su mucha palabrería."
,"6":"Hay quien calla porque no tiene qué decir, y hay quien calla esperando su vez."
,"7":"El hombre sabio callará hasta el momento oportuno, pero el fanfarrón y el insensato no saben guardar su vez."
,"8":"El que mucho habla se hace odioso, y quien pretende imponerse es aborrecido."
,"9":"Hay éxitos que el hombre encuentra en el infortunio, y hay hallazgos imprevistos que se truecan en daño."
,"10":"Hay dones que nada aprovechan, y hay dones de los que se reporta el doble."
,"11":"Hay quien en la gloria encuentra humillación, y quien en la humillación levanta su cabeza."
,"12":"Hay quien compra muchas cosas con poco, y hay quien las paga siete veces."
,"13":"El sabio en hablar se hace amable, pero las gracias de los insensatos para nada sirven."
,"14":"El don del necio no te aprovechará, porque en vez de un ojo tiene muchos."
,"15":"Da poco y echa en cara mucho, y abre su boca como un pregonero. Hoy presta y mañana reclama. Tal hombre es aborrecible."
,"16":"Dice el tonto: 'Yo no tengo amigos, y no encuentro gratitud para mis beneficios;"
,"17":"los que comen mi pan son malas lenguas'. ¡Cuántas veces y cuántos se burlarán de él!"
,"18":"Más vale tropezar en el suelo que con la lengua; así vendrá de repente la caída de los malvados."
,"19":"Hombre sin gracia, cuento inoportuno; en boca de los imbéciles se encuentra de continuo."
,"20":"De la boca del tonto no se acepta un proverbio, porque lo dice a destiempo."
,"21":"Hay quien por pobre no puede pecar; cuando descansa tiene la conciencia tranquila."
,"22":"Hay quien por respeto humano pierde su alma, y quien la pierde en presencia de un insensato."
,"23":"Hay quien por respeto humano hace promesa a su amigo, y así se granjea un enemigo sin motivo."
,"24":"Una mentira es feo borrón en un hombre, y se encuentra con frecuencia en boca de los necios."
,"25":"Es preferible un ladrón al mentiroso, pero los dos acabarán en la ruina."
,"26":"El hábito del embustero es una deshonra, su infamia le acompañará siempre."
,"27":"El sabio se hace estimar por sus palabras, el prudente agrada a los grandes."
,"28":"El que cultiva la tierra aumentará su cosecha, el que agrada a los grandes se hace perdonar la maldad."
,"29":"Regalos y dones ciegan los ojos de los sabios, y como un bozal en la boca impiden los reproches."
,"30":"Sabiduría oculta y tesoro escondido, ¿para qué sirven uno y otro?"
,"31":"Mejor es el hombre que esconde su necedad,que el que oculta su sabiduría."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Hijo, ¿has pecado? No vuelvas a pecar, e implora el perdón de las faltas pasadas."
,"2":"Huye del pecado como de la serpiente, porque si te acercas te morderá. Dientes de león son sus dientes, que quitan la vida a los hombres."
,"3":"Toda la culpa es como espada de dos filos, no hay cura para su herida."
,"4":"Terror y violencia devastan los palacios, la casa del orgulloso será desolada."
,"5":"La súplica del pobre va de su boca al oído de Dios, y se le hará justicia rápidamente."
,"6":"El que aborrece la reprensión va tras las huellas del pecador, y el que teme al Señor se convierte de corazón."
,"7":"El charlatán es universalmente conocido, pero el sensato ya de lejos conoce sus deslices."
,"8":"El que edifica su casa con dinero ajeno,es como quien recoge piedras para su tumba."
,"9":"La reunión de malhechores es montón de estopa, la llama del fuego será su fin."
,"10":"El camino de los pecadores está bien pavimentado, desemboca en la fosa del abismo."
,"11":"El que guarda la ley es dueño de sí, la perfección del temor de Dios es la sabiduría."
,"12":"El que no tiene luces no aprende nada, pero hay saberes que engendran amargura."
,"13":"La ciencia del sabio crece como una inundación, su consejo es como fuente de vida."
,"14":"El corazón del necio es como un vaso roto; no retendrá la sabiduría."
,"15":"Si un hombre instruido escucha una palabra sabia, la alaba y añade algo; pero si la oye un necio, le desagrada,y la echa a la espalda."
,"16":"Las palabras del necio pesan como la carga al caminante, pero los labios inteligentes destilan placer."
,"17":"El parecer del hombre sensato es solicitado en la asamblea, sus palabras se meditan en el corazón."
,"18":"Como casa en ruinas es la sabiduría para el necio, la ciencia para el insensato es cosa ininteligible."
,"19":"Grillos en los pies es la instrucción para el insensato, como esposas en la mano derecha."
,"20":"El insensato se ríe estrepitosamente, pero el varón cuerdo se limita a sonreír."
,"21":"La instrucción para el juicioso es joya de oro, brazalete en su brazo derecho."
,"22":"El pie del necio se precipita en casas ajenas, pero el hombre de experiencia se conduce con discreción."
,"23":"El insensato curiosea desde la puerta el interior, el educado se queda fuera."
,"24":"Es una descortesía escuchar a la puerta, y el sensato se avergüenza de ello."
,"25":"Los labios de los necios dicen disparates, pero las palabras de la gente sensata se pesan en la balanza."
,"26":"En la boca del necio está su corazón, mas en el corazón de los sabios está su boca."
,"27":"Cuando el malvado maldice a su enemigo, se maldice a sí mismo."
,"28":"El murmurador mancha su alma,y es detestado por los vecinos."
}`)
	CurrentBook.AddChapter(22, `{
"1":"El perezoso se parece a una piedra enlodada, todos le silban por su suciedad."
,"2":"El perezoso se parece a una bola de estiércol: el que la coge se sacude la mano."
,"3":"Vergüenza del padre es haber engendrado un hijo indisciplinado; una hija así es un perjuicio mayor."
,"4":"Una hija sensata encuentra marido, la hija desvergonzada entristece a su padre."
,"5":"La atrevida abochorna a su padre y a su madre, y será despreciada por los dos."
,"6":"Una advertencia inoportuna es como música en día de luto, mas los azotes y la corrección en todo tiempo son oportunos."
,"9":"El que enseña a un necio es como el que pega un tiesto roto, como quien despierta a uno que duerme profundamente."
,"10":"El que predica a un tonto es como el que habla al que dormita. Al fin dirá: '¿De qué hablas?'."
,"11":"Llora al muerto porque perdió la luz, y llora al necio porque perdió su inteligencia. Llora menos por un muerto, porque ya descansó. Pero la vida del necio es peor que la muerte."
,"12":"El duelo por un muerto dura siete días, pero el del necio y el malvado todos los días de su vida."
,"13":"No hables demasiado con el necio,ni vayas con el insensato; guárdate de él para no tener disgustos,y no mancharte con su contacto. Apártate de él y vivirás tranquilo, y no tendrás que sufrir por su necedad."
,"14":"¿Qué hay más pesado que el plomo?,Y ¿cómo llamarle, sino necio?"
,"15":"La arena, la sal, el hierro,son cargas más ligeras que el hombre insensato."
,"16":"El maderamen bien ajustado de una edificación,no es desencajado por un terremoto; así el corazón resuelto tras madura reflexión,no vacila en ningún momento."
,"17":"El corazón apoyado sobre sabio pensamiento,es como revoque de arena sobre muro pulido."
,"18":"Empalizada en lugar alto no resiste al viento; así el corazón medroso por sus pensamientos necios,no puede resistir el temor."
,"19":"Quien se frota los ojos saca lágrimas, quien se hurga el corazón hace brotar sentimientos."
,"20":"Quien arroja una piedra a los pájaros los levanta; el que afrenta al amigo destruye la amistad."
,"21":"Aunque hayas desenvainado la espada contra el amigo, no desesperes, porque puede haber remedio."
,"22":"Si has hablado contra él, no temas, pues es posible la reconciliación. Pero ultrajar, revelar secreto y golpe a traición,son cosas que hacen huir al amigo."
,"23":"Gana la confianza del prójimo en su pobreza, para que en su prosperidad puedas tener alegría. En los días de tribulación permanece a su lado, para que en su herencia tengas tu parte."
,"24":"Antes que las llamas se ve el humo del horno, así a la sangre derramada preceden las injurias."
,"25":"Jamás me avergonzaré de proteger a un amigo, ni me ocultaré de él;"
,"26":"que si algún mal me sucede por su culpa, todos los que le oigan se apartarán de él."
,"27":"¿Quién pondrá guarda a mi boca,y sello de discreción en mis labios,para que no caiga por ellos,y no me pierda mi lengua?"
}`)
	CurrentBook.AddChapter(23, `{
"1":"Señor, padre y dueño de mi vida, no me abandones a sus halagos, no permitas que caiga por ellos."
,"2":"¿Quién aplicará el azote a mis pensamientos, y la disciplina de la sabiduría a mi corazón,sin disimular mis errores, para que no incurra en pecados?"
,"3":"No sea que se multipliquen mis errores, se acrecienten mis pecados, caiga en manos de mis adversarios,y se regocije mi enemigo a costa mía."
,"4":"Señor, padre y Dios de mi vida, no me des mirada altanera"
,"5":"y aparta de mí la avaricia."
,"6":"Que la sensualidad y la lujuria no se adueñen de mí, y no me entregues a un deseo torpe."
,"7":"Escuchad, hijos, la instrucción de mi boca; quien la guarde no será confundido."
,"8":"Por los labios queda preso el pecador, y por ellos tropiezan el malicioso y el soberbio."
,"9":"No te acostumbres a proferir juramentos, ni te habitúes a nombrar al santo."
,"10":"Porque como un esclavo siempre vigilado,no escapará a los golpes, así el que jura y nombra de continuo a Dios,no se verá libre de pecado."
,"11":"Un hombre fácil para jurar se llenará de iniquidad, y el azote no se alejará de su casa. Si peca, su pecado pesará sobre él; si obra a la ligera, pecará doblemente; si jura en vano, no estará exento de culpa, su casa se llenará de calamidades."
,"12":"Hay modos de hablar que merecen la muerte. ¡Ojalá no los haya en la casa de Jacob!,Porque todas estas cosas han de estar lejos de los piadosos, y así no se revolcarán en los pecados."
,"13":"No acostumbres tu boca a la grosería indecente, porque en ella se encuentra la palabra pecaminosa."
,"14":"Acuérdate de tu padre y de tu madre,cuando te sientes en medio de los grandes; no sea que, olvidándote de su presencia, hagas el tonto; desearías entonces no haber nacido,y maldecirías el día en que naciste."
,"15":"Un hombre acostumbrado a hablar cosas inconvenientes,jamás se corregirá."
,"16":"Dos clases de seres multiplican los pecados, y una tercera atrae la ira."
,"17":"Una pasión ardiente quema como el fuego; no se apagará hasta consumirse. El hombre sensual con su propio cuerpo,no cesará hasta que su fuego lo devore. Al lujurioso todo pan le sabe dulce, no se cansará hasta su muerte."
,"18":"El hombre infiel al lecho conyugal, que dice para sí: '¿Quién me ve?,La oscuridad me envuelve y las paredes me ocultan; ¿qué tengo que temer?,De mis pecados no se acordará el altísimo',"
,"19":"sólo teme los ojos de los hombres, pero no advierte que los ojos del Señor,son mil veces más claros que el sol, ven todos los pasos de los hombres,y penetran los rincones más secretos."
,"20":"Todas las cosas eran de él conocidas antes de ser creadas, y lo mismo las conoce una vez hechas."
,"21":"Aquel hombre será castigado en las calles de la ciudad; donde menos lo piensa, se verá sorprendido."
,"22":"Así también la esposa que abandonó a su marido,y tuvo un hijo con otro."
,"23":"Porque, primero, desobedeció la ley del altísimo; en segundo lugar, pecó contra su marido; en tercer lugar, se manchó con adulterio,dándole hijos de otro hombre."
,"24":"Esta tal será llevada a la asamblea,y se investigará sobre sus hijos."
,"25":"Sus hijos no echarán raíces, y sus ramos no darán fruto."
,"26":"Dejará un recuerdo maldito, y su deshonra no se borrará jamás."
,"27":"La posteridad conocerá,que nada hay mejor que el temor del Señor, y nada más dulce que guardar sus preceptos."
}`)
	CurrentBook.AddChapter(24, `{
"1":"La sabiduría se alaba a sí misma,y se gloría en medio de los suyos."
,"2":"En la asamblea del altísimo abre su boca,y se gloría en presencia de su corte celestial:"
,"3":"Yo salí de la boca del altísimo,y cubrí la tierra como una niebla."
,"4":"Habité en las alturas, y mi trono fue columna de nube."
,"5":"Sola recorrí el círculo celeste, y por las profundidades del abismo me paseé."
,"6":"En las olas del mar, en toda la tierra, en todo el pueblo y nación yo imperé."
,"7":"En todos ellos busqué el reposo, y en qué territorio instalarme."
,"8":"Entonces me ordenó el creador de todas las cosas, mi hacedor fijó el lugar de mi habitación, y me dijo: 'Pon tu tienda en Jacob, y en Israel ten tu heredad'."
,"9":"Desde el principio y antes de los siglos me creó, y existiré eternamente."
,"10":"En su santa tienda, en su presencia, ejercí el ministerio, y así en Sión me instalé."
,"11":"En la ciudad amada establecí mi residencia, y en Jerusalén tuve la sede de mi imperio."
,"12":"En el pueblo glorioso eché raíces, en la porción del Señor, en su heredad."
,"13":"Crecí como el cedro en el Líbano, como el ciprés en las montañas del Hermón."
,"14":"Crecí como palmera en Engadí, cual brote de rosa en Jericó; como magnífico olivo en la llanura, crecí como el plátano."
,"15":"Como el cinamomo y el espliego he dado mi aroma, como mirra escogida exhalé mi perfume; como gálbano, ónix y estacte, y como perfume de incienso en el tabernáculo."
,"16":"Yo extendí como terebinto mis ramas, y mis ramas están llenas de gracia y de majestad."
,"17":"Como vid eché hermosos sarmientos, y mis flores dan frutos de gloria y de riqueza."
,"19":"Venid a mí los que me deseáis, y saciaos de mis frutos."
,"20":"Porque mi recuerdo es más dulce que la miel, y poseerme más dulce que el panal."
,"21":"Los que me coman quedarán aún con hambre, y los que me beban quedarán de mí sedientos."
,"22":"Quien me obedece no será avergonzado, y los que me sirven no pecarán."
,"23":"Todo esto es el libro de la alianza del Dios altísimo, la ley que nos dio Moisés en heredad a la casa de Jacob."
,"25":"Inunda de sabiduría como el Pisón, como el Tigris en los días de primavera."
,"26":"Hace desbordar la inteligencia como el Éufrates, y como el Jordán en los días de la mies."
,"27":"Rebosa instrucción como el Nilo, y como el Guijón en los días de la vendimia."
,"28":"No acabó el primero de conocerla, ni el último la agotó."
,"29":"Porque sus pensamientos son más profundos que el mar, sus designios como el gran abismo."
,"30":"Yo soy como canal que sale de río, como acueducto que entra en un jardín."
,"31":"Yo dije: 'Regaré mi huerto y empaparé mis prados'. Y he aquí que mi canal se hizo un río, y el río se hizo mar."
,"32":"Haré lucir la doctrina desde la aurora, y llevaré hasta muy lejos su luz."
,"33":"Derramaré la instrucción como profecía, y la transmitiré a las futuras generaciones."
,"34":"Ved que no he trabajado para mí, sino para todos cuantos buscan la sabiduría."
}`)
	CurrentBook.AddChapter(25, `{
"1":"En tres cosas se complace mi alma, que son agradables a Dios y a los hombres: la concordia entre hermanos, la amistad entre vecinos,y marido y mujer bien avenidos."
,"2":"Tres clases de personas odia mi alma, y me indignan sobremanera: pobre soberbio, rico embustero,y viejo adúltero y necio."
,"3":"Si no has recogido en tu juventud, ¿cómo vas a encontrar en tu vejez?"
,"4":"¡Qué bien sienta el juicio a los cabellos blancos, y a los ancianos el consejo!"
,"5":"¡Qué bien sienta la sabiduría en los ancianos, y en los nobles la reflexión y el consejo!"
,"6":"La rica experiencia es la corona del anciano, y su gloria el temor del Señor."
,"7":"Nueve cosas he meditado en el corazón, que estimo dichosas, y una décima que voy a deciros. 'El hombre que se goza en sus hijos, el que contempla en vida la caída de los enemigos'."
,"8":"Feliz el que vive con mujer sensata, quien jamás se desliza con su lengua, quien no sirve a hombre inferior a él."
,"9":"Dichoso quien halla la prudencia,y quien habla a oídos que le escuchan."
,"10":"¡Qué grande es el que encuentra la sabiduría!,Pero nadie aventaja al que teme al Señor."
,"11":"El temor del Señor sobrepasa a todo. El que lo posee, ¿a quién será comparado?"
,"13":"Dame cualquier llaga, pero no llaga del corazón. Dame cualquier maldad, pero no maldad de mujer."
,"14":"Cualquier desgracia, pero no de manos de los que me aborrecen; cualquier venganza, pero no venganza de enemigo."
,"15":"No hay veneno peor que el de la serpiente, no hay cólera como la del enemigo."
,"16":"Preferiría vivir con un león y un dragón,antes que con una mujer malvada."
,"17":"La maldad de la mujer altera su semblante,y oscurece su rostro como el de un oso."
,"18":"En medio de los enemigos se sienta su marido, y sin querer suspira amargamente."
,"19":"Toda maldad es poca comparada con la de la mujer: la suerte del pecador caiga sobre ella."
,"20":"Cuesta arenosa para pies de anciano,es la mujer deslenguada para un marido pacífico."
,"21":"No te dejes seducir por la belleza de una mujer, y no la desees."
,"22":"Esclavitud, ignominia y vergüenza grande,es que la mujer mantenga a su marido."
,"23":"Corazón afligido, rostro entristecido y herida de corazón,es la mujer perversa. Manos inertes y rodillas vacilantes, tal es la mujer que no hace dichoso a su marido."
,"24":"Por la mujer comenzó el pecado, y por ella morimos todos."
,"25":"No des salida al agua, ni a la mujer mala libertad de hablar."
,"26":"Si no va como tú quieres, sepárate de ella y despídela."
}`)
	CurrentBook.AddChapter(26, `{
"1":"Dichoso el marido de una mujer buena; el número de sus días se duplicará."
,"2":"La mujer animosa es la alegría del marido, que llenará de paz sus años."
,"3":"La mujer buena es una gran herencia; será dada en dote a los que temen al Señor;"
,"4":"sea rico, sea pobre, su corazón estará alegre, con semblante siempre gozoso."
,"5":"Tres cosas me dan miedo, y una cuarta me espanta: la calumnia que va por la ciudad, un motín popular,y la falsa acusación. Las tres son peores que la muerte."
,"6":"Aflicción de corazón y duelo es la mujer celosa de otra, y azote de lengua para cuantos con ella viven."
,"7":"Yugo de bueyes mal ajustado es la mujer mala; intentar dominarla es como coger un escorpión."
,"8":"La mujer borracha es motivo de profunda irritación, no podrá ocultar su vergüenza."
,"9":"La desvergüenza de una mujer se muestra en su mirar descarado,y se reconoce en el movimiento de sus párpados."
,"10":"Con la hija desenvuelta redobla tu vigilancia; no sea que, hallando ocasión propicia, la aproveche."
,"11":"Vigila con cuidado a la de ojos atrevidos, y no te extrañes si te falta."
,"12":"Como viandante sediento abre ella su boca,y bebe de todas las aguas que encuentra; se sienta en cualquier parte,y ofrece su cuerpo a la lujuria."
,"13":"La gracia de la mujer alegra a su marido, y su saber le vigoriza los huesos."
,"14":"Don del Señor es la mujer reservada, la persona bien educada no tiene precio."
,"15":"La mujer honesta es gracia sobre gracia, la recatada es de valor inestimable."
,"16":"Como el sol que se alza en los más altos montes,es la hermosura de la mujer buena en una casa bien cuidada. "
,"17":"Como lámpara que brilla sobre candelabro santo, así es la belleza de un rostro femenino sobre cuerpo bien formado."
,"18":"Como columnas de oro sobre base de plata, así son las piernas graciosas sobre firmes talones."
,"19":"Hijo mío, conserva sana la flor de tu juventud,y no des tu vigor a extranjeras;"
,"20":"busca un lote fértil en toda la llanura,y siembra tu semilla, fiel a tu estirpe;"
,"21":"así durarán sus frutos,y madurarán con la firmeza de tu estirpe."
,"22":"Mujer que se vende vale un comino, la casada es torre de la muerte para los que la gozan;"
,"23":"mujer irreligiosa tocará en surte al inicuo, mujer religiosa al que teme al Señor;"
,"24":"mujer desvergonzada se dedica a la infamia, joven pudorosa se cohíbe incluso ante el marido;"
,"25":"la mujer impúdica es una perra, mujer pudorosa teme al Señor;"
,"26":"mujer que respeta al marido es tenida por sensata, la que lo desprecia con arrogancia es tenida por irreligiosa."
,"27":"Mujer chillona y charlatana,es corneta que toca a zafarrancho. Si el maridp es del mismo carácter,vivirá siempre en pie de guerra."
,"28":"Por dos cosas se entristece mi corazón, y una tercera excita mi cólera: un guerrero que sufre miseria, hombre de entendimiento despreciado,y quien se convierte de la rectitud al pecado; a éste el Señor le destina a la espada."
,"29":"El comerciante difícilmente resiste a la tentación, y el tendero no estará sin pecado."
}`)
	CurrentBook.AddChapter(27, `{
"1":"Por amor al lucro muchos han pecado, quien busca enriquecerse se muestra despiadado."
,"2":"Entre junturas de piedra se clava la estaca, y entre venta y compra se hinca el pecado."
,"3":"Si al temor del Señor no te atienes firmemente, pronto tu casa será destruida."
,"4":"Al zarandear la criba queda la cascarilla; así los defectos del hombre cuando reflexiona."
,"5":"El horno prueba los vasos del alfarero; la prueba del hombre está en su conversación."
,"6":"El fruto del árbol indica su cultivo, así la conversación de un hombre revela su corazón."
,"7":"Antes que haya hablado no alabes a nadie, pues ésta es la piedra de toque del hombre."
,"8":"Si persigues la justicia, la alcanzarás,y la vestirás como gloriosa túnica."
,"9":"Los pájaros se juntan con sus iguales, y la fidelidad retorna a los que la practican."
,"10":"El león acecha la presa, así el pecado a los que hacen injusticias."
,"11":"La conversación del piadoso es siempre sabiduría, pero el insensato cambia como la luna."
,"12":"Entre los insensatos aguarda la ocasión oportuna, y procura estar de continuo entre los sensatos."
,"13":"La conversación de los necios es detestable, su risa se oye en las orgías del pecado."
,"14":"La lengua del blasfemo hace erizar los cabellos; cuando riñe hay que taparse los oídos."
,"15":"La riña entre orgullosos hace correr la sangre, sus altercados no pueden oírse."
,"16":"El que descubre secretos pierde la confianza,y no encontrará amigos según su corazón."
,"17":"Ama a tu amigo y confíate a él, pero si has revelado su secreto no corras tras él."
,"18":"Porque como un hombre mata a su enemigo, así tú has destruido la amistad de tu prójimo."
,"19":"Y como quien dejó escapar el pájaro de su mano, así perdiste a tu prójimo y no le recobrarás más."
,"20":"No lo persigas, que ya está muy lejos; huye como gacela del lazo."
,"21":"Porque se puede vendar una herida y se perdona una injuria, pero descubrir un secreto no tiene remedio."
,"22":"Quien guiña el ojo maquina maldad; nadie podrá apartarle de ella."
,"23":"Ante tus ojos se hace meloso,y se admirará de tus dichos, pero por detrás torcerá la boca,y censurará tus palabras."
,"24":"Muchas cosas odio, pero ninguna tanto como a él. El Señor también lo odia."
,"25":"Quien tira una piedra al aire, la tira sobre su propia cabeza; un golpe a traición causa heridas."
,"26":"El que cava una hoya caerá en ella, y quien tiende un lazo quedará preso en él."
,"27":"Al que hace el mal le caerá encima, sin saber de dónde le viene."
,"28":"El escarnio y la injuria son las obras del orgulloso, pero la venganza como león le acecha."
,"29":"Los que se gozan de la caída del justo,quedarán presos en el lazo, el dolor los consumirá antes de su muerte."
,"30":"El rencor y la cólera son aborrecibles, el hombre pecador los guarda en su interior."
}`)
	CurrentBook.AddChapter(28, `{
"1":"El que se venga será víctima de la venganza del Señor, que le pedirá cuenta rigurosa de sus pecados."
,"2":"Perdona la injuria a tu prójimo, y entonces, si suplicas, te serán perdonados tus pecados."
,"3":"Si un hombre alimenta rencor contra otro, ¿cómo podrá pedir al Señor perdón?"
,"4":"Si no tiene misericordia de su semejante, ¿cómo podrá suplicar por sus pecados?"
,"5":"Si siendo carne guarda rencor, ¿quién le va a perdonar sus pecados?"
,"6":"Acuérdate de tu final, y deja el odio. Acuérdate de la corrupción y la muerte, y guarda los mandamientos."
,"7":"Acuérdate de los preceptos, y no odies al prójimo; acuérdate de la alianza del altísimo, y pasa por alto la ofensa."
,"8":"Aléjate de las querellas y evitarás pecados, porque el hombre iracundo las atiza."
,"9":"El pecador siembra la discordia entre los amigos, y en medio de los que viven en paz lanza su calumnia."
,"10":"El fuego arde según el combustible, y la disputa se propaga según su violencia; la ira de un hombre depende de su fuerza, y su cólera se levantará según su riqueza."
,"11":"Pendencia súbita enciende el fuego, y la riña irreflexiva hace correr la sangre."
,"12":"Si soplas sobre una brasa, se encenderá; pero si la escupes, se apagará; y, sin embargo, ambas cosas salen de tu boca."
,"13":"Maldito el murmurador y el mentiroso, porque perdió a muchos que vivían en paz."
,"14":"La lengua del calumniador ha sacudido a muchos,y los ha llevado de nación en nación; ha destruido ciudades fuertes,y derriba las naciones de los grandes."
,"15":"La lengua calumniadora ha hecho repudiar esposas ejemplares, y las privó del fruto de sus trabajos."
,"16":"El que le da oídos no vivirá tranquilo,ni disfrutará de paz."
,"17":"El latigazo produce cardenales, pero el golpe de la lengua quebranta los huesos."
,"18":"Muchos caen por la espada, pero muchos más por la lengua."
,"19":"Feliz quien está al abrigo de ella, que no es víctima de su ira, que no soporta su yugo y no se ve preso en sus cadenas,"
,"20":"porque su yugo es yugo de hierro, y sus cadenas son cadenas de bronce."
,"21":"Muerte espantosa es su muerte, es preferible el abismo."
,"22":"Jamás alcanza a los piadosos, y en su llama no se queman."
,"23":"Los que abandonan al Señor caerán en ella, los abrasará sin extinguirse. Es enviada contra ellos como un león, y como pantera los descuartizará."
,"24":"Cuida de cercar tu propiedad con espinos, guarda bajo sello tu plata y tu oro."
,"25":"Haz para tus palabras balanza y peso, y para tu boca puerta y cerrojo."
,"26":"Cuida de no deslizarte por ella, y no caigas ante quien te acecha."
}`)
	CurrentBook.AddChapter(29, `{
"1":"Quien presta al prójimo hace obra de misericordia, y quien le sostiene con su mano guarda los mandamientos."
,"2":"Presta al prójimo en su necesidad, y devuelve a tiempo lo prestado."
,"3":"Mantén tu palabra, sé fiel con él, y en todas tus necesidades hallarás lo que precisas."
,"4":"Para muchos el préstamo es una ganga, y ponen en aprieto a quien les ayudó."
,"5":"Antes de recibir besan la mano del prójimo, elogian humildes su riqueza; pero a la hora de la devolución dan largas, responden con palabras de excusa,y echan la culpa al tiempo."
,"6":"Cuando pagan, el prestamista apenas recibirá la mitad, y podrá estimarlo una suerte. Y si no puede pagar, le dejará sin su dinero,y se habrá granjeado de balde un enemigo, que le devolverá maldiciones e insultos, y en vez de honra, ultrajes."
,"7":"Por esto muchos se niegan a prestar, pues temen ser robados de balde."
,"8":"Sin embargo, sé generoso con el humilde,y no le hagas esperar tu limosna."
,"9":"Por obedecer al precepto acoge al pobre, en su indigencia no le despidas con las manos vacías."
,"10":"Consiente en perder dinero por un hermano y un amigo, no lo dejes enmohecerse debajo de una piedra."
,"11":"Dispón de tu tesoro según los preceptos del altísimo, y te aprovechará más que el oro."
,"12":"Encierra la limosna en tus graneros, y ésta te librará de toda desgracia."
,"13":"Más que fuerte escudo y poderosa lanza,luchará por ti frente al enemigo."
,"14":"El hombre bueno fía al prójimo, y el que perdió la vergüenza lo abandona."
,"15":"No olvides los beneficios de tu fiador, pues expone su vida por ti."
,"16":"El malvado dilapida los bienes del fiador, y el ingrato olvida a quien lo salvó."
,"17":"La fianza ha perdido a gentes bien situadas,y los ha zarandeado como mar tormentoso."
,"18":"Ha desterrado magnates, y los hizo peregrinar por regiones extranjeras."
,"19":"El pecador, al fiar y perseguir negocios, se enreda en pleitos."
,"20":"Socorre al prójimo según tus posibilidades, y cuida de no caer."
,"21":"Indispensables para la vida son el agua, el pan y el vestido, y una casa para abrigo de la desnudez."
,"22":"Mejor es vida pobre bajo un techo de madera,que festines espléndidos en casas extrañas."
,"23":"Conténtate con lo poco o lo mucho, y no serás reprochado como extraño."
,"24":"Penoso es tener que andar de casa en casa; donde habites no abras la boca."
,"25":"Habrás dado hospedaje y de beber sin que te lo agradezcan, y encima oirás palabras duras:"
,"26":"'Entra, forastero, prepara la mesa; si tienes algo a mano, danos de comer'."
,"27":"'Vete, forastero, deja el puesto de honor; viene mi hermano a verme, y necesito la casa'."
,"28":"Duras frases éstas para un hombre sensato: oír reproches del dueño de la casa,y ser tratado como un usurero."
}`)
	CurrentBook.AddChapter(30, `{
"1":"El que ama a su hijo no le escatimará los azotes, para que al fin pueda complacerse en él."
,"2":"El que educa bien a su hijo se gozará en él, y en medio de sus conocidos podrá enorgullecerse."
,"3":"El que instruye a su hijo será envidiado de sus enemigos, y se alegrará por ello ante sus amigos."
,"4":"Si muere su padre, como si no hubiese muerto, pues deja tras de sí un hijo que se le parece."
,"5":"Durante su vida se alegra al verlo, y a su muerte no se entristece."
,"6":"Contra sus enemigos deja un vengador, y para sus amigos quien pague los favores."
,"7":"Quien mima a su hijo tendrá después que vendarle las heridas; a cada grito suyo se estremecerán sus entrañas."
,"8":"Un caballo no domado se torna indócil, y un hijo abandonado se torna díscolo."
,"9":"Mima a tu hijo y te hará temblar, juega con él y te hará llorar."
,"10":"No te rías con él para que no te haga sufrir,y acabes rechinando los dientes."
,"11":"No le des libertad en su juventud, y no cierres los ojos a sus faltas."
,"12":"Doblega su cerviz en su juventud,y túndele las espaldas de muchacho, no sea que se vuelva díscolo y desobediente,y sufras la pena de ello."
,"13":"Corrige a tu hijo y fórmalo, no sea que su insolencia te afrente."
,"14":"Más vale pobre sano y fuerte,que rico achacoso."
,"15":"Salud y vigor valen más que todo el oro, y cuerpo robusto más que inmensa fortuna."
,"16":"No hay riqueza mejor que la salud del cuerpo, no hay felicidad superior al gozo del corazón."
,"17":"Más vale la muerte que vida amargada, y el descanso eterno que enfermedad duradera."
,"18":"Manjares derramados sobre boca cerrada, tales son las ofrendas a los ídolos."
,"19":"¿Qué le aprovecha la ofrenda al ídolo, que ni come ni huele?,Tal es el que es afligido por el Señor;"
,"20":"mira con sus ojos y suspira, como eunuco que abraza a una virgen."
,"21":"No te entregues a la tristeza, y no te abandones a cavilaciones."
,"22":"La vida del hombre es el gozo del corazón, y su alegría alarga los días."
,"23":"Recrea el ánimo, alegra el corazón,y echa de ti la tristeza, porque la tristeza ha perdido a muchos,y no hay en ella utilidad."
,"24":"La envidia y la cólera abrevian los días, y las preocupaciones acarrean una vejez prematura."
,"25":"El sueño del corazón es alegre, es mejor que deliciosos manjares, y lo que se come aprovecha."
}`)
	CurrentBook.AddChapter(31, `{
"1":"Los insomnios que acarrea la riqueza consumen el cuerpo, y la preocupación por ella ahuyenta el sueño."
,"2":"La preocupación del día impide dormir, y más que una enfermedad grave aleja el sueño."
,"3":"El rico se afana en acumular riquezas, y si descansa es para entregarse al placer."
,"4":"El pobre trabaja porque necesita vivir, y si descansa cae otra vez en la miseria."
,"5":"Quien ama el oro no escapará sin pecado, quien ama el lucro en él se extraviará."
,"6":"Muchos se perdieron por amor del oro, y dieron de bruces con su perdición."
,"7":"El oro es una trampa para cuantos se entregan a él, todos los insensatos caen en ella."
,"8":"Dichoso el rico que es hallado irreprensible,y no corre tras el oro."
,"9":"¿Quién es éste para que lo felicitemos?,Porque ha hecho entre los suyos maravillas."
,"10":"¿Quién ha sufrido esta prueba y ha sido hallado perfecto?,Éste será glorificado. ¿Quién pudo pecar y no pecó, hacer el mal y no lo hizo?"
,"11":"Su dicha se consolidará, y la comunidad pregonará sus buenas obras."
,"12":"¿Te sientas en una mesa bien surtida?,No te muestres ansioso, ni digas: ¡Cuántas cosas!"
,"13":"Recuerda que un ojo codicioso es mala cosa. ¿Qué hay peor que el ojo? Codicia cuanto ve."
,"14":"No tiendas la mano a cuanto veas,para que no tropieces con tu vecino en el plato."
,"15":"Por lo que a ti te gusta juzga del gusto de los otros, y sé discreto en todo."
,"16":"Come como hombre educado lo que te pongan, y no seas glotón, para que no te desprecien."
,"17":"Sé el primero en terminar de comer por educación, y no devores, para que no seas despreciado."
,"18":"Si te sientas entre muchos, no alargues tu mano el primero."
,"19":"Muy poco le basta al hombre bien educado, y así no se siente molesto en el lecho."
,"20":"El sueño saludable acompaña a un estómago moderado; se levanta pronto y está despejado. Insomnio, vómitos y retortijones,esperan al hombre glotón."
,"21":"Si has comido con exceso, salta, devuelve y te sentirás mejor."
,"22":"Escúchame, hijo, no me desprecies, y al fin verás que eran veraces mis palabras. Sé moderado en todas tus obras, y jamás vendrá sobre ti la enfermedad."
,"23":"Al espléndido anfitrión le elogian todos, y el testimonio de su generosidad será firme."
,"24":"Del anfitrión tacaño se murmura en la ciudad, y la fama de su tacañería se afianzará."
,"25":"Con el vino no te hagas el valiente, porque a muchos perdió el vino."
,"26":"El horno prueba el temple del acero, así el vino prueba los corazones en la contienda de fanfarrones."
,"27":"El vino da vida si se bebe con moderación. ¿Qué es la vida sin vino?,El vino ha sido creado para alegrar al hombre."
,"28":"Alegría del corazón y gozo del alma es el vino, bebido a su tiempo y con moderación."
,"29":"La borrachera excita la ira del loco para su daño, quita fuerzas y le multiplica las heridas."
,"30":"En los banquetes no provoques al vecino,ni te burles de él en su alegría; no le digas palabras injuriosas,ni lo molestes con reclamaciones de dinero."
}`)
	CurrentBook.AddChapter(32, `{
"1":"¿Te han elegido para presidir un banquete?,No presumas de ello. Pórtate como uno más de los invitados. Cuida de ellos primero, y siéntate después."
,"2":"Cuando hayas cumplido tu deber siéntate, para que goces con ellos,y seas alabado por el buen orden de todo."
,"3":"Habla, anciano, pues te corresponde; pero con discreción; y no interrumpas la música."
,"4":"Mientras actúan los músicos no te des a charlar, ni alardees de sabio a destiempo."
,"5":"Como sello de rubí engastado en oro,es la música en el banquete."
,"6":"Sello de esmeralda engastado en oro, la melodía del festín con vino selecto."
,"7":"Habla, joven, si fuere necesario; pero a lo sumo dos veces, y si se te pregunta."
,"8":"Resume el discurso, di mucho en pocas palabras; sé como quien sabe y al mismo tiempo calla."
,"9":"En medio de los grandes no trates de igualarte a ellos, cuando habla otro sé sobrio en palabras."
,"10":"El relámpago precede al trueno, y la gracia precede al modesto."
,"11":"Levántate a tiempo y no te retrases, corre a tu casa y no callejees."
,"12":"Allí diviértete y haz lo que gustes, pero no peques con palabras insolentes."
,"13":"Y después bendice a tu hacedor, al que te colmó de sus bienes."
,"14":"El que teme al Señor acepta la disciplina, y los que le buscan encuentran su favor."
,"15":"El que busca la ley se gozará en ella, pero el hipócrita en ella tropezará."
,"16":"Los que temen al Señor sabrán lo que es justo,y harán brillar como luz sus obras justas."
,"17":"El pecador rehúye la corrección,y para sus caprichos halla excusas."
,"18":"El hombre juicioso no desprecia los avisos; el orgulloso y petulante no conoce el temor."
,"19":"Sin consejo nada emprendas; así no tendrás que arrepentirte de lo hecho."
,"20":"No vayas por camino escabroso, y no chocarás en las piedras."
,"21":"No te fíes del camino llano, y guárdate de tus propios hijos."
,"22":"Con toda tu alma vigílate a ti mismo, porque esto es guardar los mandamientos."
,"23":"El que confía en la ley guarda sus preceptos, y el que confía en el Señor no será defraudado."
}`)
	CurrentBook.AddChapter(33, `{
"1":"El que teme al Señor no sufrirá daño, y aun en sus pruebas será librado."
,"2":"El sabio no desprecia la ley, pero el hipócrita será como nave en tempestad."
,"3":"El hombre sensato confía en la ley, y la ley es para él fidedigna como la respuesta del oráculo."
,"4":"Prepara el discurso, y así serás escuchado; reúne tu saber, y responde."
,"5":"El corazón del necio es como rueda de carro, y sus razonamientos como eje que gira."
,"6":"El amigo burlón es como un semental, que relincha siempre que se lo monta."
,"7":"¿Por qué un día es más largo que otro, cuando la luz todo el año procede del sol?"
,"8":"Es la sabiduría del Señor la que los diferencia, que ha diversificado las estaciones y las fiestas."
,"9":"A unos los distinguió y santificó, y a otros los hizo días ordinarios."
,"10":"Todos los hombres proceden del polvo, Adán fue creado de la tierra."
,"11":"Con su gran sabiduría el Señor los ha distinguido, ha diversificado sus destinos."
,"12":"A unos los bendijo y exaltó, a otros los santificó,y acercó a sí; a otros los maldijo, los humilló y los derribó de sus puestos."
,"13":"Como barro en manos de alfarero,todos los caminos son según su beneplácito , así los hombres en manos de su hacedor, que dará a cada uno según su voluntad."
,"14":"Enfrente del mal está el bien, enfrente de la muerte la vida; así frente al piadoso, el pecador."
,"15":"Considera así todas las obras del altísimo, todas dos a dos, una frente a otra."
,"16":"Yo he llegado el último de todos, como un rebuscador detrás de los rebuscadores."
,"17":"Con la bendición del Señor me aventajé a otros, y como vendimiador llené mi lagar."
,"18":"Ya veis que no he trabajado para mí solo, sino para todos cuantos buscan la doctrina."
,"19":"Oídme, pues, grandes del pueblo, y los que presidís la asamblea prestad oídos."
,"20":"Ni a tu hijo, ni a tu mujer, ni a tu hermano, ni a tu amigo des poder sobre ti en tu vida; ni des a otros tus riquezas, no sea que arrepentido tengas que mendigar de ellos."
,"21":"Mientras vivas y haya en ti aliento, no te dejes dominar por nadie."
,"22":"Porque más vale que tus hijos te pidan a ti,que tú tengas que depender de ellos."
,"23":"En todas tus obras sé el dueño, y no dejes que se manche tu reputación."
,"24":"En el último día de tu vida, al tiempo de morir, reparte tu herencia."
,"25":"Al asno, forraje, palo y carga; al siervo, pan, corrección y trabajo."
,"26":"Haz trabajar a tu siervo, y tendrás reposo; déjale las manos libres, y buscará la libertad."
,"27":"El yugo y las coyundas hacen bajar el cuello; y al siervo díscolo, el azote y el tormento."
,"28":"Ponle al trabajo; que no esté ocioso, porque la ociosidad enseña muchas maldades."
,"29":"Ponle en el trabajo que le convenga; y si no obedece, mételo en el cepo."
,"30":"No te excedas con nadie, y no hagas nada contrario a la justicia."
,"31":"Si tienes un esclavo, trátale como a ti mismo, pues lo has comprado a precio de sangre."
,"32":"Si tienes un esclavo, trátale como a hermano, porque necesitas de él como de ti mismo."
,"33":"Si lo maltratas, se marcha y se extravía, ¿por qué caminos lo buscarás?"
}`)
	CurrentBook.AddChapter(34, `{
"1":"Vanas y engañosas son las esperanzas del insensato; los sueños dan alas a los tontos."
,"2":"Como quien intenta apresar la sombra y perseguir el viento, así es el que se apoya en sueños."
,"3":"Como imagen en un espejo, así son los sueños; frente a un rostro, la reproducción de este rostro."
,"4":"Del impuro, ¿cómo saldrá cosa pura?; y del mentiroso, ¿qué verdad puede salir?"
,"5":"Adivinaciones, augurios y sueños son cosas vanas; puras fantasías, como las de mujer en parto."
,"6":"A no ser que sean enviados del altísimo, no hagas caso de ellos."
,"7":"Porque a muchos engañaron los sueños, y cayeron los que esperaban en ellos."
,"8":"La ley debe cumplirse sin engaño, y la sabiduría es perfecta en la boca fiel."
,"9":"Un hombre instruido conoce muchas cosas, y el muy experimentado puede enseñar."
,"10":"Quien no ha pasado pruebas poco sabe; pero quien ha viajado de acá para allá tiene rica experiencia."
,"11":"En el curso de mis viajes he visto muchas cosas, he aprendido mucho más de lo que sabría decir."
,"12":"Me he visto en peligro de muerte muchas veces, pero gracias a ello me salvé."
,"13":"El espíritu de los que temen al Señor vivirá, porque su esperanza está en aquel que salva."
,"14":"El que teme al Señor nada temerá; no se desalentará, porque él es su esperanza."
,"15":"Dichosa el alma del que teme al Señor. ¿Sobre quién se apoya? Y ¿quién es su sostén?"
,"16":"Los ojos del Señor se posan sobre quienes lo aman: poderosa protección y fuerte apoyo, abrigo contra el viento abrasador,y sombra contra el calor del mediodía, guarda contra el tropiezo y auxilio contra la caída."
,"17":"Él levanta el alma y da luz a los ojos; él da salud, vida y bendición."
,"18":"El que hace una ofrenda de lo adquirido con injusticias,hace una ofrenda defectuosa. Las ofrendas de los que practican la injusticia,no son aceptables."
,"19":"El altísimo no se complace en las ofrendas de los que practican la injusticia, ni por la multitud de los sacrificios perdona los pecados."
,"20":"Como el que inmola a un hijo ante los ojos de su padre, así es el que ofrece sacrificios de los bienes de los pobres."
,"21":"Pan escaso es la vida de los pobres; privarles de ello es como asesinar."
,"22":"Mata al prójimo quien le quita el sustento, y derrama sangre quien priva de su salario al jornalero."
,"23":"Uno construye y otro derriba, ¿qué les queda sino su fatiga?"
,"24":"Uno reza, otro maldice, ¿a quién de los dos escuchará el Señor?"
,"25":"Al que se limpia del contacto de un muerto,y de nuevo le toca, ¿de qué le sirve el haberse lavado?"
,"26":"Así el hombre que ayuna por sus pecados,y luego los vuelve a cometer; ¿quién escuchará su plegaria,y qué provecho sacará de sus penitencias?"
}`)
	CurrentBook.AddChapter(35, `{
"1":"El que guarda la ley multiplica las ofrendas, el que observa los mandamientos ofrece sacrificios de reconciliación."
,"2":"Ser agradecidos a Dios es ofrecer flor de harina, y quien hace limosna ofrece sacrificio de acción de gracias."
,"3":"Apartarse del mal es cosa agradable al Señor; alejarse de la injusticia, sacrificio expiatorio."
,"4":"No te presentes con las manos vacías ante el Señor, pues todas las cosas se deben hacer cumpliendo los mandamientos."
,"5":"La ofrenda del justo da lustre al altar, y su suave olor se eleva hasta el altísimo."
,"6":"El sacrificio del justo es aceptable, su recuerdo no será olvidado."
,"7":"Honra al Señor con ofrenda generosa, y no seas mezquino al presentar tus primicias."
,"8":"Cuando ofrezcas algo, hazlo con cara alegre,y da los diezmos con alegría."
,"9":"Da al altísimo como él te dio, con ánimo generoso según tus posibilidades."
,"10":"Porque el Señor lo paga todo,y te devolverá siete veces más."
,"11":"No intentes sobornarlo, que no recibirá tus dones; y no te confíes en ofrendas de cosas adquiridas con injusticias."
,"12":"Porque el Señor es juez, y no hay ante él acepción de personas."
,"13":"No hará acepción de personas contra el pobre, pero escuchará la súplica del oprimido."
,"14":"No desdeña la súplica del huérfano,ni la de la viuda si prodiga ante él sus quejas."
,"15":"¿No corren las lágrimas de la viuda por sus mejillas?,Y su grito, ¿no es contra quien las hace correr?"
,"16":"El que sirve al Señor como él quiere es aceptado, y su súplica llega a las nubes."
,"17":"La súplica del humilde atraviesa las nubes; no descansa hasta llegar a Dios,"
,"18":"y no se retira hasta que intervenga el altísimo, reconozca el derecho de los justos y les haga justicia."
,"19":"El Señor no tardará ni tendrá paciencia con ellos,"
,"20":"hasta que haya machacado los lomos de los hombres sin piedad,y haya tomado venganza de las gentes;"
,"21":"hasta que haya exterminado la multitud de los arrogantes,y hecho trizas el cetro de los que practican la injusticia;"
,"22":"hasta que haya devuelto a cada uno según sus obras,y retribuido las obras de los hombres según sus intenciones;"
,"23":"hasta que haya hecho justicia a su pueblo,y le haya alegrado con su misericordia."
,"24":"Oportuna es la misericordia en el tiempo de la tribulación; como nubes de agua en tiempo de sequía."
}`)
	CurrentBook.AddChapter(36, `{
"1":"Ten piedad de nosotros, oh Dios del universo, míranos y derrama tu temor sobre todas las gentes."
,"2":"Levanta tu mano contra las naciones extranjeras, para que vean tu potencia."
,"3":"De la misma manera que les mostraste tu santidad obrando contra nosotros, muéstranos a nosotros tu grandeza obrando contra ellos,"
,"4":"para que te conozcan como nosotros te conocimos, porque no hay Dios fuera de ti, Señor."
,"5":"Renueva los prodigios y repite los portentos, glorifica tu mano y tu brazo derecho."
,"6":"Despierta tu ira y derrama tu cólera, destruye al adversario, tritura al enemigo."
,"7":"Acelera el tiempo y acuérdate del juramento, y que se cuenten tus obras portentosas."
,"8":"Que tu fuego vengador devore al que intenta escapar, y los opresores de tu pueblo encuentren la destrucción."
,"9":"Tritura la cabeza de los jefes enemigos, que dicen: 'No hay nadie fuera de nosotros'."
,"10":"Reúne a todas las tribus de Jacob,y dales su heredad como al comienzo."
,"11":"Apiádate de tu pueblo, que lleva tu nombre; de Israel, a quien hiciste tu primogénito."
,"12":"Compadécete de tu ciudad santa, Jerusalén, la ciudad de tu descanso."
,"13":"Llena a Sión con la alabanza de tus maravillas, y al templo de tu gloria."
,"14":"Da testimonio a tus primeras criaturas, y cumple las promesas hechas en tu nombre."
,"15":"Premia a los que en ti esperan, para dar la razón a tus profetas."
,"16":"Escucha, Señor, la plegaria de tus siervos, por la benevolencia que tienes con tu pueblo."
,"17":"Y conocerán todos los habitantes de la tierra,que tú eres el Señor, Dios eterno."
,"18":"El estómago recibe toda clase de alimentos, pero hay unos mejores que otros."
,"19":"El paladar distingue al gustarla la carne de caza; así el corazón prudente las palabras mentirosas."
,"20":"Un corazón perverso ocasiona dolores, pero el hombre muy experimentado le da su merecido."
,"21":"La mujer acepta cualquier marido, pero hay mujeres más hermosas que otras."
,"22":"La belleza de la mujer alegra el rostro, es el deseo más fuerte del hombre."
,"23":"Si tiene además bondad y dulzura en su hablar, su marido se juzga el más feliz de los hombres."
,"24":"El que tiene una mujer tiene ya el comienzo de la fortuna, una ayuda semejante a sí y columna en que apoyarse."
,"25":"Donde falta la cerca, la posesión será robada; y donde no hay mujer, el hombre va gimiendo a la deriva."
,"26":"Porque, ¿quién se fiará de ladrón ligero, que corre de ciudad en ciudad?,Así sucede al hombre que no tiene nido,y duerme donde le sorprende la noche."
}`)
	CurrentBook.AddChapter(37, `{
"1":"Todo amigo dice: 'Soy tu amigo'; pero hay amigos que sólo son de nombre."
,"2":"¿No es una pena indecible,cuando un compañero o amigo se torna enemigo?"
,"3":"Oh perversa inclinación, ¿por qué fuiste creada,para llenar la tierra de engaños?"
,"4":"En tiempo de alegría se alegra, pero al tiempo de la aflicción se vuelve en contra."
,"5":"Hay amigo que por conservar el sustento,lucha junto al amigo frente al adversario."
,"6":"No olvides a tu amigo fiel en tu corazón, ni pierdas su memoria en medio de tus riquezas."
,"7":"Todo consejero da consejos, pero hay quien aconseja en su propio interés."
,"8":"Guárdate del consejero; mira antes de qué tiene necesidad,porque también él aconseja en provecho propio , no sea que te tienda un lazo"
,"9":"y te diga: 'Bueno es tu camino', y se ponga al acecho después,para ver lo que te sucede."
,"10":"No te aconsejes de quien te mira de reojo, y oculta tus propósitos a los que te tienen envidia."
,"11":"Con mujer no trates de su rival, ni con un cobarde de la guerra, ni con negociante sobre el cambio, ni con comprador acerca de la venta, ni con envidioso de gratitud, ni con egoísta de generosidad, ni con perezoso de trabajo alguno, ni con el obrero eventual acerca del fin de su trabajo, ni con el criado perezoso acerca de una gran tarea: en todos estos no te apoyes para buscar consejo."
,"12":"Más bien aconséjate de un hombre piadoso, de quien sabes que guarda los preceptos,y tiene un alma afín a la tuya, pues si caes se dolerá contigo."
,"13":"Sigue lo que te dicte tu corazón, porque nadie te será más fiel."
,"14":"Pues el alma del hombre suele descubrir esas cosas,mejor que siete vigías apostados en la torre del centinela."
,"15":"Además, reza al altísimo,para que él dirija tus pasos por el camino verdadero."
,"16":"El principio de toda obra es la razón, y ante toda empresa se precisa reflexión."
,"17":"La raíz de los consejos es el corazón, y de él brotan cuatro ramas:"
,"18":"el bien y el mal, la vida y la muerte; mas quien decide siempre es la lengua."
,"19":"Hay quien es sabio y maestro de muchos, pero para sí mismo es inútil."
,"20":"Hay quien es sabio en discursos, y es odiado y acabará por morir de hambre."
,"21":"Porque el Señor no le dio ninguna gracia, está desprovisto de toda sabiduría."
,"22":"Hay quien es sabio para sí mismo, y los frutos de su sabiduría,al decir de él son dignos de fe."
,"23":"El hombre sabio instruye a su pueblo, y los frutos de su inteligencia son fidedignos."
,"24":"El varón sabio está colmado de bendiciones, y le llaman bienaventurado cuantos le ven."
,"25":"La vida del hombre dura poco, mas los días de Israel son innumerables."
,"26":"El sabio en medio de su pueblo adquiere la confianza, y su nombre vivirá para siempre."
,"27":"Hijo, durante la vida pruébate a ti mismo, mira lo que es dañoso y no te lo des."
,"28":"Porque no todo conviene a todos, ni todos sienten placer en todo."
,"29":"No seas insaciable en festín suntuoso, no seas glotón al comer."
,"30":"Porque en el mucho comer anda la enfermedad, y la glotonería provoca los cólicos."
,"31":"A muchos acarreó la muerte su glotonería, mas el que se refrena prolonga sus días."
}`)
	CurrentBook.AddChapter(38, `{
"1":"Honra al médico en atención a sus servicios, porque también a él lo creó el Señor."
,"2":"Pues de Dios procede el arte de curar, y del rey recibirá regalos."
,"3":"La ciencia del médico le hace llevar la cabeza erguida,y es admirado por los poderosos."
,"4":"El Señor creó de la tierra los remedios, el hombre sensato no los desprecia."
,"5":"¿No se endulzaron las aguas con un leño,para dar a conocer su poder?"
,"6":"Él dio a los hombres la ciencia,para que se gloríe en sus maravillas."
,"7":"Con ellas el médico cura y quita el dolor, con ellas el boticario hace sus mezclas,"
,"8":"de manera que sus criaturas no perezcan,y la salud se extienda sobre la faz de la tierra."
,"9":"Hijo, en tus enfermedades no te impacientes, sino suplica al Señor y él te curará."
,"10":"Apártate del pecado, lava tus manos,y limpia tu corazón de todo pecado."
,"11":"Ofrece incienso y una ofrenda de flor de harina, y generosos sacrificios según tus medios."
,"12":"Después recurre al médico, porque también a él lo creó el Señor; y no se aparte de ti, porque necesitas de él,"
,"13":"pues hay veces que la salud depende de sus manos."
,"14":"Porque también ellos rezan a Dios,para que les conceda éxito en dar alivio y conservar la vida. "
,"15":"El que peca a los ojos de su hacedor,caerá en manos del médico."
,"16":"Hijo, llora sobre el muerto,y, como corresponde a quien sufre, entona lamentaciones, amortájale según le corresponde, y no te olvides de enterrarlo."
,"17":"Llora con amargura, suspira ardientemente, guarda luto según su condición,un día o dos para evitar la murmuración, y consuélate de tu tristeza."
,"18":"Porque de la tristeza viene la muerte, y la tristeza del corazón consume el vigor."
,"19":"Después de los funerales, pase la pena; pues una vida de aflicción es dañosa para el corazón."
,"20":"No des tu corazón a la tristeza, apártala recordando tu último fin."
,"21":"No olvides que no hay retorno; que al muerto no le aprovecha, y tú te haces daño."
,"22":"Acuérdate de su destino, pues así será el tuyo; ayer a él, hoy a ti."
,"23":"Cuando el muerto ya descansa, descanse también su memoria; y consuélate de él después de su partida."
,"24":"La sabiduría del sabio crece en las horas libres, y el que no tiene ocupaciones llegará a sabio."
,"25":"¿Cómo va a llegar a sabio el que sostiene el arado,y se gloría de blandir la aguijada, el que conduce los bueyes, se ocupa en estos trabajos,y sólo habla de novillos?"
,"26":"Su empeño lo pone en trazar surcos, y su desvelo en engordar becerros."
,"27":"E igual el obrero o artesano,que trabaja día y noche; el que graba los sellos y se esfuerza en varios diseños, que pone su atención en reproducir el modelo,y pasa sus vigilias en rematar su obra."
,"28":"E igual el herrero sentado junto al yunque, que examina el hierro bruto; el ardor del fuego enrojece su carne, y en el calor de la fragua se revuelve. El ruido del martillo ensordece sus oídos, y sus ojos están fijos en el modelo. Pone toda su atención en acabar bien su obra,y su desvelo en adornarla perfectamente."
,"29":"Lo mismo el alfarero sentado a su faena; con sus pies hace girar la rueda, preocupado sin cesar de su obra,y de finalizar la tarea fijada."
,"30":"Con sus manos modela la arcilla,y con sus pies la ablanda; pone toda su atención en perfilar el barnizado,y se desvela para limpiar el horno."
,"31":"Todos estos confían en sus manos, y cada uno es maestro en su oficio."
,"32":"Sin ellos es imposible edificar una ciudad, ni vivir o andar por ella."
,"33":"Pero no se les busca para consejeros del pueblo, ni en la asamblea destacan, ni se sientan en la silla del juez, porque no entienden de justicia y derecho."
,"34":"No manifiestan cultura ni sabiduría, ni entienden de proverbios. Pero ellos aseguran el funcionamiento del mundo,ocupados en el trabajo de su oficio."
}`)
	CurrentBook.AddChapter(39, `{
"1":"Distinto es el que se aplica,a meditar la ley del altísimo. Estudia la sabiduría de todos los antiguos,y consagra sus ocios al estudio de los profetas."
,"2":"Conserva los discursos de los hombres famosos,y penetra en las sutilezas de las parábolas."
,"3":"Investiga el sentido oculto de los proverbios,e intenta descifrar los enigmas de las parábolas."
,"4":"Ejerce su servicio entre los grandes,y se presenta ante los jefes. Viaja por tierras extranjeras,para conocer lo bueno y lo malo de los hombres."
,"5":"De mañana se vuelve al Señor, su creador, con todo su corazón, y delante del altísimo derrama su súplica; abre su boca en la oración,y pide perdón de sus pecados."
,"6":"Si el Señor, el que es grande, lo quiere, será lleno de espíritu de inteligencia; derramará las palabras de su sabiduría, y en su oración alabará al Señor."
,"7":"Poseerá la rectitud del juicio y de la ciencia,y reflexionará sobre los misterios de Dios."
,"8":"Hará brillar la doctrina recibida,y estará orgulloso de conocer la ley de la alianza del Señor. "
,"9":"Muchos alabarán su inteligencia,y nunca se le olvidará. No se borrará su memoria,y su nombre vivirá de generación en generación."
,"10":"Los pueblos hablarán de su sabiduría, y la asamblea proclamará su alabanza."
,"11":"Mientras viva, su nombre será más famoso que mil; y si muere, esto le bastará."
,"12":"Después de haber reflexionado, quiero seguir hablando, pues estoy lleno, como la luna llena."
,"13":"Escuchadme, hijos, y creced,como rosa plantada a la orilla del arroyo."
,"14":"Derramad buen olor, como incienso. Floreced como lirio, exhalad suave olor,y celebrad sus loores, bendecid al Señor por todas sus obras."
,"15":"Engrandeced su nombre, publicad sus alabanzas con cantos y con cítaras; así diréis al alabarle:"
,"16":"¡Qué hermosas son todas las obras del Señor; todas sus órdenes se cumplen a su tiempo. No hay lugar a decir: '¿Qué es esto?,¿Para qué es aquello?', porque todo ha sido creado con su fin."
,"17":"A una palabra suya las aguas se congregaron,y se formaron los depósitos de las aguas."
,"18":"Por orden suya se cumple en todo su voluntad, y no hay quien impida su obra salvadora."
,"19":"Las obras de todo viviente están en él, y nada se puede ocultar a sus ojos."
,"20":"Su mirada se extiende desde los orígenes hasta el fin de los tiempos, y nada hay extraordinario para él."
,"21":"No vale decir: '¿Qué es esto? Aquello, ¿para qué?', pues todas las cosas fueron creadas para un fin."
,"22":"Su bendición es como un río que se desborda, como un diluvio que empapa la tierra."
,"23":"Dejará sentir su ira sobre las naciones, como cambió las aguas en salitre."
,"24":"Sus caminos son rectos para los justos, para los malvados son escabrosos."
,"25":"Desde el principio creó Dios los bienes para los buenos,y los males para los pecadores."
,"26":"Las cosas indispensables para la vida del hombre son: el agua y el fuego, el hierro y la sal, la harina de trigo, la leche y la miel, el jugo de racimo, el aceite y el vestido."
,"27":"Todas estas cosas son buenas para los buenos, pero se tornan malas para los pecadores."
,"28":"Hay vientos creados para la venganza, y en su furia refuerzan su azote. A la hora de la cólera desencadenan su violencia,y aplacan la ira de su hacedor."
,"29":"Fuego y granizo, hambre y peste; todo fue creado para castigo."
,"30":"Los dientes de las fieras, los escorpiones, las víboras, la espada vengadora son para exterminio de los malvados."
,"31":"Se gozan cumpliendo su mandato, se hallan preparados para su cometido,y en su obrar no traspasan sus órdenes."
,"32":"Por eso desde el principio me convencí, reflexioné y puse por escrito:"
,"33":"'Todas las obras del Señor son buenas, y él, a su tiempo, atiende a cada necesidad."
,"34":"No sirve decir: Esto es peor que aquello, pues todo a su tiempo es reputado bueno'."
,"35":"Y ahora, de todo corazón, entonad himnos,y bendecid el nombre del Señor."
}`)
	CurrentBook.AddChapter(40, `{
"1":"Una penosa tarea se impuso a todo hombre, y un yugo pesado a los hijos de Adán, desde el día que salen del seno de su madre,hasta el día que vuelven a la madre de todos."
,"2":"El objeto de sus reflexiones y el temor de su corazón,es la espera ansiosa del día de la muerte."
,"3":"Desde el que se sienta en trono de gloria,hasta el humillado en polvo y ceniza;"
,"4":"desde el que lleva púrpura y corona,hasta el que se viste de burdo paño,están sujetos a cólera, envidia, turbación, terror, temor de la muerte, rivalidades y querellas."
,"5":"Y al tiempo del descanso en su lecho, el sueño trastorna su mente."
,"6":"Apenas ha descansado un poco o nada, lo mismo en sueño que en vigilia, se siente turbado con las visiones de su mente, como un fugitivo del frente de batalla."
,"7":"En el preciso momento de la liberación, se despierta maravillado de lo injustificado de sus temores."
,"8":"Así es con todo ser vivo, desde el hombre a la bestia; y para los pecadores, siete veces más."
,"9":"Muerte y derramamiento de sangre, querella y espada, calamidades, hambre, tribulación y plagas:"
,"10":"todas estas cosas fueron creadas para los que cometen injusticias, y por ellos sobrevino el diluvio."
,"11":"Todo lo que de la tierra proviene, a ella volverá; y lo que proviene de las aguas, al mar retornará."
,"12":"Todo soborno e injusticia serán borrados, mas la lealtad permanece para siempre."
,"13":"Las riquezas de los malvados se secarán como un torrente, como un gran trueno se pierde entre el ruido de la lluvia."
,"14":"Al abrir él sus manos se alegra, pero los pecadores irán a la ruina."
,"15":"Los retoños de los malvados no se llenan de ramas, porque sus impuras raíces están sobre suelo rocoso."
,"16":"Es como caña que crece junto a las aguas,y a la orilla de los ríos; será arrancada antes que toda hierba."
,"17":"La generosidad es como un paraíso de bendiciones, y la limosna permanece para siempre."
,"18":"La vida del libre y del trabajador es dulce, pero más que ambas cosas el que halla un tesoro."
,"19":"Los hijos y edificar una ciudad perpetúan el nombre; pero más que ambos, una mujer sin tacha."
,"20":"Vino y música alegran el corazón; pero más que ambos, el amor de la sabiduría."
,"21":"Flauta y salterio hacen agradable melodía; pero más que ambos, una lengua afable."
,"22":"Tu ojo desea gracia y belleza; pero sobre ambas está el verdor de los campos."
,"23":"Un amigo y un compañero se encuentran a su tiempo, pero sobre ambos está la mujer con marido."
,"24":"Hermanos y protectores son útiles en tiempo de aflicción, pero más que ambos libra la limosna."
,"25":"El oro y la plata dan firmeza a los pies, pero más que ambos se estima el consejo."
,"26":"Riquezas y fuerza levantan el corazón; pero más que ambos, el temor del Señor; porque con el temor del Señor nada falta, y con él no hay por qué buscar auxilio."
,"27":"El temor del Señor es como un paraíso de bendiciones, y mejor que toda gloria él protege."
,"28":"Hijo, no hagas vida de mendigo: más vale morir que mendigar."
,"29":"Hombre que mira a mesa ajena con ansia,vive una vida que no debe tenerse por vida; mancha su alma con manjares extraños. El hombre instruido y bien educado se guardará de ellos."
,"30":"En la boca del desvergonzado es dulce la mendicidad, pero es fuego que abrasa sus entrañas."
}`)
	CurrentBook.AddChapter(41, `{
"1":"¡Oh muerte, qué amargo es tu recuerdo,para el hombre que goza en paz en medio de sus bienes; para el hombre sin preocupaciones y afortunado en todo, que todavía tiene fuerzas para gozar de los placeres!"
,"2":"¡Oh muerte, bienvenida es tu sentencia,para el hombre indigente y falto de fuerzas; para el cargado de años y cuidados, que se rebela y ha perdido toda esperanza!"
,"3":"No temas la sentencia de la muerte; acuérdate de los que te precedieron y de los que te seguirán."
,"4":"Ésta es la ley que el Señor ha impuesto a todo viviente. ¿Por qué rebelarte contra la voluntad del altísimo?,Que vivas diez, cien o mil años, en el abismo nadie pregunta por la duración de tu vida."
,"5":"Los hijos de los pecadores son descendencia aborrecible, que frecuenta la morada de los malvados."
,"6":"La herencia de los hijos de los pecadores va a la ruina, y con su descendencia se perpetúa la infamia."
,"7":"Los hijos maldicen al padre malvado, pues por su causa les sobreviene la infamia."
,"8":"¡Ay de vosotros, malvados, que abandonáis la ley del altísimo!"
,"9":"Porque al nacer, nacéis para maldición; y, al morir, la maldición será vuestra herencia."
,"10":"Todo lo que viene de la tierra, a la tierra vuelve; así los malvados, de la maldición van a la ruina."
,"11":"El duelo de los hombres es por los cuerpos, pero el nombre maldito del pecador será borrado."
,"12":"Cuida de tu renombre, porque te quedará,como bien mejor que millares de preciados tesoros."
,"13":"La buena vida dura sólo cierto número de días, pero el buen nombre permanece para siempre."
,"14":"Hijos, guardad en paz mi instrucción. ¿Qué aprovecha la sabiduría oculta y el tesoro escondido?"
,"15":"Es mejor quien oculta su necedad,que quien oculta su sabiduría."
,"16":"Así pues, ruborizaos por lo que os digo, porque no es bueno guardar toda clase de vergüenza, y todo no es igualmente aprobado por todos."
,"17":"Avergonzaos de la fornicación ante un padre y una madre, y de la mentira ante un jefe y un poderoso;"
,"18":"de un delito ante el juez y el magistrado, y de la injusticia ante la asamblea y el pueblo;"
,"19":"de la injusticia ante el compañero y el amigo, y del robo ante el lugar donde vives;"
,"20":"de quebrantar la verdad de Dios y la alianza, de apoyar en la mesa el codo sobre el pan;"
,"21":"de ofender a alguno al dar o recibir, y de no contestar al que te saluda;"
,"22":"de fijar tu mirada en una mujer pública, de rechazar a un pariente;"
,"23":"de apropiarte de la parte de otro o de su regalo, y de mirar a mujer que tiene marido;"
,"24":"de tener familiaridades con criada de aquélla, y de acercarte a su lecho;"
,"25":"de palabras ofensivas a un amigo, y de echar en cara después de dar algo;"
,"26":"de divulgar lo que has oído,y de revelar secretos."
,"27":"Por todas estas cosas la vergüenza es justa,y serás bien visto por todos."
}`)
	CurrentBook.AddChapter(42, `{
"1":"Pero de estas otras cosas no habrás de avergonzarte, ni tengas respeto humano y vengas a pecar por ello:"
,"2":"De la ley del altísimo y su alianza, ni de juicio que absuelva al culpable;"
,"3":"de arreglar cuentas con el socio y compañero de viaje, o de hacer partición de herencia a los amigos;"
,"4":"de la exactitud en las balanzas y pesos, y de obtener pequeños o grandes beneficios;"
,"5":"de obtener ganancia en la venta de mercancías, de corregir severamente a tus hijos, de azotar duramente al esclavo perezoso."
,"6":"Bien está sellar la puerta donde hay mujer mala, y donde hay muchas manos pon las cosas bajo llave."
,"7":"Todo lo que deposites sea numerado y pesado, sea debidamente anotado todo lo que das o recibes."
,"8":"No te avergüences de reprender al insensato y al necio, y aun al viejo culpable de fornicación. Así te mostrarás verdaderamente instruido,y tendrás la aprobación de todos."
,"9":"Una hija es una secreta causa de cuidados para su padre, un cuidado que quita el sueño; de joven, para que no se marchite; de casada, para que no llegue a ser aborrecida;"
,"10":"cuando es virgen, para que no sea seducida,y quede encinta en la casa paterna; cuando ya tiene marido, para que no peque; y cuando está desposada, por si permanece estéril."
,"11":"Sobre la hija indócil ten estrecha vigilancia, si no quieres ser la irrisión de tus enemigos, el comentario de la ciudad y de los corrillos del pueblo, y la vergüenza ante toda la gente."
,"12":"No mires a nadie por su belleza, y no te sientes en medio de mujeres;"
,"13":"porque de los vestidos sale la polilla, y de la mujer la malicia femenina."
,"14":"Vale más maldad de un hombre que bondad de mujer; una mujer acarrea vergüenza y deshonra."
,"15":"Ahora hablaré de las obras del Señor,y pregonaré lo que he visto. Por la palabra del Señor fueron hechas las cosas, y la creación entera obedece a su voluntad."
,"16":"El sol, que da su luz, todo lo contempla; y la obra toda del Señor está llena de su gloria."
,"17":"No dio el Señor poder a sus santos,para declarar todas las maravillas,que el Señor, el creador, ha establecido firmemente,para que todo permanezca en su gloria."
,"18":"Él sondea las profundidades del abismo y del corazón,y descubre todos sus secretos; porque el altísimo posee toda ciencia,y las señales de los tiempos."
,"19":"Él anuncia lo pasado y lo venidero,y desvela las cosas ocultas."
,"20":"Ni un pensamiento se le escapa, ni una palabra hay oculta para él."
,"21":"Él ha dispuesto con orden las maravillas de su sabiduría, porque él es desde eternidad a eternidad. Nada ha sido a ellas añadido ni quitado; él no necesita consejeros."
,"22":"Cuán deseables son sus obras, aunque no se ve más que un destello."
,"23":"Todo vive y permanece para siempre, y en todo momento le obedece."
,"24":"Todas las cosas son distintas unas de otras, y nada ha hecho imperfecto."
,"25":"Una cosa hace resaltar la bondad de la otra. ¿Quién podrá saciarse de contemplar sus bellezas?"
}`)
	CurrentBook.AddChapter(43, `{
"1":"Orgullo de las alturas es el firmamento límpido, y la bóveda celeste es un espectáculo bellísimo."
,"2":"El sol, al surgir, pregona: '¡Qué admirable es la obra del altísimo!'."
,"3":"Al mediodía abrasa la tierra, y ¿quién puede resistir su ardor?"
,"4":"Se atiza el horno para las obras que requieren calor; el sol abrasa tres veces las montañas; exhalando vapores ardientes, lanzando brillantes rayos, deslumbra los ojos."
,"5":"Grande es el Señor, que lo ha creado, y cuya palabra apresura su carrera."
,"6":"También la luna, siempre fiel a su curso, regula los tiempos y es señal eterna."
,"7":"Es ella quien determina las fiestas, astro de luz que decrece después de su plenitud."
,"8":"De ella recibe el mes su nombre, crece maravillosa en sus cambios, abanderada de las huestes de la altura,que brilla en el firmamento de los cielos."
,"9":"La belleza del cielo es la gloria de sus astros, brillante ornamento en las alturas celestes."
,"10":"A una orden del Santo se mantienen en su puesto, y no desfallecen montando guardia."
,"11":"Contempla el arco iris y bendice a su hacedor: ¡qué hermoso es su esplendor!"
,"12":"Él abarca el cielo con su círculo de gloria, lo tendieron las manos del altísimo."
,"13":"Con su mandato hace caer la nieve, hace volar sus rayos justicieros."
,"14":"Para ello abre sus reservas,y hace volar las nubes como pájaros."
,"15":"Con su poder majestuoso condensa las nubes,y desmenuza las piedrecitas del granizo."
,"16a":"A su vista se estremecieron las montañas,"
,"17a":"a la voz de su trueno hace retemblar la tierra."
,"16b":"A su orden sopla el viento del sur,"
,"17b":"el huracán del norte y los ciclones."
,"18":"Hace caer la nieve como bandada de pájaros, como langostas que se posan. Los ojos se maravillan de la belleza de su blancura, el corazón se extasía al verla caer."
,"19":"Derrama sobre la tierra como sal la escarcha, que se endurece como puntas de espino."
,"20":"El frío viento del norte sopla, y el hielo se congela sobre las aguas; sobre toda agua tranquila se extiende, y como una coraza se reviste."
,"21":"Devora las montañas y abrasa el desierto, y como un fuego consume la hierba verde."
,"22":"La nube es rápido remedio de todo, y el rocío después del calor todo lo alegra."
,"23":"Con su sabiduría domó el océano,y plantó en él las islas."
,"24":"Los que navegan por el mar relatan sus peligros, y cuando los oímos nos llenamos de admiración."
,"25":"Allí no existen más que obras extraordinarias y maravillosas, mil géneros de animales y monstruos marinos."
,"26":"Por él todo concluye felizmente, por su palabra todas las cosas se ordenan."
,"27":"Muchas cosas podríamos decir y no acabaríamos. En suma: él es todo."
,"28":"Y ¿cómo hallar fuerza para glorificarle dignamente, ya que él es más grande que todas sus obras?"
,"29":"Terrible es el Señor, extraordinariamente grande, y su poder sobre toda admiración."
,"30":"Para glorificar al Señor, alabadlo cuanto podáis, porque está muy por encima de vuestras alabanzas. Y al exaltarlo, poned en ello todo empeño; no os canséis, pues nunca llegaréis al fin."
,"31":"¿Quién lo ha visto y puede describirlo?,¿Quién podrá engrandecerlo como él se merece?"
,"32":"Muchas cosas hay ocultas mayores que éstas, y pocas son las cosas que hemos visto de entre sus obras."
,"33":"Pues el Señor hizo todas las cosas, y dio la sabiduría a los piadosos."
}`)
	CurrentBook.AddChapter(44, `{
"1":"Hagamos el elogio de los hombres ilustres, de nuestros antepasados en la historia."
,"2":"El Señor les concedió muchos honores, los engrandeció desde el principio de los siglos."
,"3":"Hubo hombres que impusieron la ley en sus dominios,y fueron renombrados por su poder. Consejeros por su prudencia, que todo lo anunciaban en profecías."
,"4":"Guías de pueblos por sus consejos,y por su pericia en la sabiduría popular, sabias sus palabras en su instrucción."
,"5":"Otros buscaban melodías musicales y escribían poemas."
,"6":"Otros fueron ricos dotados de gran poder, que vivieron pacíficamente en sus moradas."
,"7":"Todos fueron honrados por sus contemporáneos,y glorificados en sus días."
,"8":"Hubo quienes dejaron un gran nombre,para que se cantasen sus alabanzas."
,"9":"Los hubo que no dejaron memoria,y perecieron como si no hubiesen existido; que pasaron como si no hubiesen nacido, y lo mismo sus hijos tras ellos."
,"10":"Pero no así los hombres de bien, cuyas buenas obras no han sido olvidadas."
,"11":"Sus bienes pasan a su descendencia,y su herencia de hijos a nietos."
,"12":"Su descendencia permanecerá fiel a la alianza, y sus hijos por amor de ellos."
,"13":"Su descendencia permanece por siempre, no desaparecerá su gloria."
,"14":"Los cuerpos fueron sepultados en paz, y su nombre vivirá por generaciones."
,"15":"Los pueblos proclaman su sabiduría, y la asamblea pregona sus alabanzas."
,"16":"Henoc fue grato a Dios, ejemplo aleccionador,para todas las generaciones."
,"17":"Noé fue hallado perfecto y justo, en el momento de la cólera aseguró la supervivencia; gracias a él, quedó sobre la tierra un resto,cuando se produjo el diluvio."
,"18":"Se estableció con él pacto eterno,de que el diluvio no exterminaría ya jamás a los vivientes."
,"19":"Abrahán fue el gran padre de una multitud de naciones, no hay nadie que le pueda igualar en gloria."
,"20":"Observó la ley del altísimo e hizo un pacto con él; en su carne estableció su pacto, y en el día de la prueba fue hallado fiel."
,"21":"Por eso Dios le prometió con juramento,que todas las naciones serían bendecidas en su descendencia,y que lo multiplicaría como el polvo de la tierra, exaltaría su linaje como las estrellas,y le daría el país en herencia,desde un mar a otro mar, desde el río hasta los extremos de la tierra."
,"22":"También a Isaac, por amor de su padre,"
,"23":"le renovó la bendición de todos los hombres; e hizo reposar sobre la cabeza de Jacob su alianza, lo confirmó en sus bendiciones, le dio el país por herencia, la dividió en porciones,y se las repartió a las doce tribus."
}`)
	CurrentBook.AddChapter(45, `{
"1":"Hizo salir de él un hombre de bien, que halló gracia a los ojos de todos, amado de Dios y de los hombres:"
,"2":"a Moisés, de bendita memoria. Lo asemejó en gloria a los santos,y lo engrandeció para terror de sus enemigos."
,"3":"Por sus palabras hizo cesar los prodigios, lo glorificó ante los reyes, le dio mandamientos para su pueblo,y le hizo ver toda su gloria."
,"4":"En fidelidad y en mansedumbre lo santificó, lo escogió de entre todos los vivientes."
,"5":"Le hizo oír su voz,y lo introdujo en la oscuridad de la nube. Cara a cara le dio sus preceptos, que son ley de vida y de ciencia, para enseñar a Jacob su alianza,y a Israel sus decretos."
,"6":"Elevó a Aarón un santo semejante a él , su hermano, de la tribu de Leví."
,"7":"Estableció con él un pacto eterno, y le dio el sacerdocio del pueblo; le honró con ricos ornamentos,y le ciñó con túnica de gloria."
,"8":"Lo revistió de honor colmado,y le adornó con espléndido ornamento: los calzones, la túnica y el efod."
,"9":"Le rodeó de granadas,y muchas campanillas de oro, para que retiñesen al caminar,y dejaran oír su tintineo en el templo, en memorial para los hijos de su pueblo."
,"10":"Le vistió con vestiduras sacras de oro, jacinto y púrpura, obra de un artista; el pectoral del juicio, el urim y el tummim, hechos de hilo carmesí, obra de artista;"
,"11":"con piedras preciosas talladas como sello, engastadas en oro, obra de joyero; para memorial, una inscripción grabada, según el número de las tribus de Israel."
,"12":"Le puso corona de oro sobre la mitra, una diadema con la inscripción de la consagración: 'Santidad'. Ornamento de honor, obra magnífica, placer de los ojos, obra de perfecta belleza."
,"13":"Nunca antes de él se había visto cosa tal, jamás un extraño las había vestido, sino sólo sus hijos y su descendencia por siempre."
,"14":"Sus sacrificios se consumían por entero, dos veces por día perpetuamente."
,"15":"Moisés lo consagró y lo ungió con óleo santo. Fue para él un pacto eterno,y para su descendencia cuanto durara el cielo, para servir al Señor, ejercer el sacerdocio,y bendecir al pueblo en su nombre."
,"16":"Lo escogió entre todos lo vivientes,para ofrecer el sacrificio al Señor; el incienso y el perfume en memorial, para hacer el rito de absolución sobre el pueblo."
,"17":"Le confió sus preceptos y le dio poder,para decidir sobre la ley y el derecho, para enseñar a Jacob sus mandamientos,e instruir a Israel en su ley."
,"18":"Se coligaron contra él extranjeros, que en el desierto le envidiaron: los hombres de Datán y Abirán,y la banda de Coré rabiosa y violenta."
,"19":"Lo vio el Señor y le desagradó, y los aniquiló con el fuego de su ira; hizo contra ellos prodigios, consumiéndolos en el fuego llameante."
,"20":"Acrecentó así la gloria de Aarón,y le asignó una heredad; le dio en porción las primicias de los frutos,y el pan en abundancia;"
,"21":"poder comer los sacrificios del Señor, que le dio a él y a su linaje."
,"22":"Pero en la tierra escogida no tuvo él herencia, ni parte en medio del pueblo, porque el Señor fue su porción y su herencia."
,"23":"Y Fineés, el hijo de Eleazar, fue el tercero en dignidad, por haber mostrado celo en el temor del Señor,y haberse mantenido firme cuando la revuelta del pueblo con noble coraje; él fue quien obtuvo así el perdón para Israel."
,"24":"Por eso se estableció con él un pacto de paz,haciéndolo jefe del santuario del pueblo, de suerte que a él y a su descendencia,pertenece la dignidad del sacerdocio por los siglos."
,"25":"También hizo Dios un pacto con David, hijo de Jesé, de la tribu de Judá. La sucesión real pasa sólo a uno de sus hijos, mientras que la herencia de Aarón pasa a toda su posteridad. "
,"26":"Dios os dé sabiduría en vuestro corazón,para juzgar con justicia a su pueblo, para que sus bondades no terminen,y su gloria perdure de generación en generación."
}`)
	CurrentBook.AddChapter(46, `{
"1":"Josué, hijo de Nun, fue guerrero valiente, sucesor de Moisés en la misión profética; él fue según su nombre,grande para salvación de los elegidos de Dios, para tomar venganza de sus enemigos,y dar posesión a Israel de su heredad."
,"2":"¡Qué magnífico era al elevar sus manos,y al blandir su espada contra las ciudades!"
,"3":"¿Qué hombre antes que él tuvo su valor?,Porque él mismo combatía las batallas del Señor."
,"4":"¿No se detuvo el sol al extender su mano, y un solo día fue como dos?"
,"5":"Invocó al altísimo y poderoso,al presionarle por todas partes sus enemigos; y el Señor, el que es grande, lo escuchó, haciendo llover piedras de granizo de gran potencia"
,"6":"que arrojó contra la nación enemiga, y en la bajada aniquiló a sus adversarios,para que conociesen la fuerza de sus ejércitos,y que contra el Señor hacían la guerra."
,"7":"Porque siguió siempre al todopoderoso, y en los días de Moisés mostró su piedad, él y Caleb, hijo de Jefoné, oponiéndose a la multitud, apartando al pueblo del pecado, reprimiendo la maligna murmuración."
,"8":"Por esto fueron solamente ellos dos salvados,de seiscientos mil hombres de a pie, para introducirlos en la heredad, en la tierra que mana leche y miel."
,"9":"El Señor concedió a Caleb el vigor, que conservó hasta su vejez, para que subiese hasta las alturas de la tierra prometida, que su descendencia obtuvo por heredad,"
,"10":"a fin de que los israelitas vieran,que es bueno caminar en pos del Señor."
,"11":"Los jueces, cada uno por su nombre, que no pervirtieron su corazón,y no se apartaron del Señor, ¡sea bendita su memoria!"
,"12":"Que sus huesos reflorezcan en sus tumbas; que sus nombres, renovados en sus hijos, sean honrados como conviene a aquellos ilustres varones."
,"13":"Samuel, amado del Señor y su profeta, estableció la monarquía,y ungió príncipes sobre su pueblo."
,"14":"Juzgó a la comunidad según la ley del Señor, y el Señor intervino en favor de Jacob."
,"15":"Por su fidelidad fue reconocido profeta, y se acreditó por sus discursos como vidente veraz."
,"16":"Invocó al Señor poderoso,cuando los enemigos le presionaban por doquier, ofreciendo un cordero lechal."
,"17":"Y el Señor tronó desde los cielos,e hizo oír su voz en medio de gran ruido."
,"18":"Destruyó a los jefes enemigos, a todos los príncipes de los filisteos."
,"19":"Antes del tiempo de su eterno reposo,rindió testimonio delante del Señor y de su ungido: 'De nadie he tomado bienes, ni siquiera unas sandalias', y nadie pudo acusarle."
,"20":"Aun después de su muerte profetizó,y anunció al rey su fin; levantó su voz profética desde la tierra,para borrar la iniquidad del pueblo."
}`)
	CurrentBook.AddChapter(47, `{
"1":"Después de él se levantó Natán,para profetizar en los días de David."
,"2":"Como se separa el sebo en el sacrificio de reconciliación, así fue David separado de los israelitas."
,"3":"Jugó con leones como con cabritillos, y con los osos como con corderos."
,"4":"En la juventud ¿no mató al gigante, y quitó el oprobio de su pueblo, cuando lanzó con su honda la piedra,y acabó con la arrogancia de Goliat?"
,"5":"Porque invocó al Señor altísimo, y éste dio fuerza a su diestra,para matar a un poderoso guerrero,y exaltar el poder de su pueblo."
,"6":"Por eso celebraban su victoria sobre los diez mil, y le alababan con las bendiciones del Señor,al ceñirle la corona de gloria;"
,"7":"porque destruyó a los enemigos de alrededor; aniquiló a los filisteos, sus adversarios, y trituró para siempre su poder."
,"8":"En todas sus obras dio gracias,al altísimo con palabras de gloria, con todo su corazón cantó himnos,y amó a su hacedor."
,"9":"Estableció instrumentos musicales delante del altar, con cuyo acompañamiento los cantos resultaban más dulces."
,"10":"Dio esplendor a las fiestas,y belleza perfecta a las solemnidades, haciendo alabar el santo nombre del Señor,y resonar el santuario desde el alba."
,"11":"El Señor perdonó sus pecados, exaltó para siempre su poder, le otorgó un pacto real,y le dio un trono de gloria en Israel."
,"12":"Le sucedió en el trono un hijo lleno de sabiduría,que, gracias a él, vivió en prosperidad:"
,"13":"Salomón, que reinó en tiempos de paz. Dios le dio paz con sus vecinos,para que levantase un templo a su nombre,y le preparase un santuario eterno."
,"14":"¡Qué sabio fuiste en tu juventud!,Como un río lleno de inteligencia."
,"15":"Tu sabiduría cubrió la tierra,y la llenaste de proverbios y enigmas."
,"16":"Tu nombre llegó hasta las islas remotas,y fuiste amado por tu paz."
,"17":"Por tus cantos, proverbios y parábolas,y por tus respuestas, fuiste la admiración del mundo."
,"18":"En el nombre del Señor Dios, que es el Dios de Israel, amontonaste oro como estaño, y como plomo multiplicaste la plata."
,"19":"Pero te diste al amor de las mujeres,y les diste poder sobre tu cuerpo."
,"20":"Pusiste un borrón sobre tu honor, deshonraste tu descendencia, atrayendo la ira sobre tus hijos, y me afligí por tu locura."
,"21":"Así tu soberanía fue dividida, y surgió de Efraín un reino rebelde."
,"22":"Pero el Señor no olvidará su promesa, ni borrará ninguna de sus palabras, ni negará la posteridad a su elegido, ni extirpará la descendencia del que fue su amado. Dio a Jacob un resto, y a David un renuevo salido de él."
,"23":"Salomón descansó con sus padres, dejando tras él uno de su linaje, Roboán, el más loco del pueblo, pobre de inteligencia, que con su decisión excitó al pueblo a la rebeldía."
,"24":"Y Jeroboán, hijo de Nabat, que hizo prevaricar a Israel,y puso a Efraín en la senda del pecado; sus pecados se multiplicaron tanto, que fueron expulsados de su tierra."
,"25":"Se entregaron a toda clase de maldades,hasta que cayó sobre ellos el castigo."
}`)
	CurrentBook.AddChapter(48, `{
"1":"El profeta Elías se alzó, como un fuego; su palabra era ardiente como una antorcha."
,"2":"Él trajo sobre ellos el hambre, y en su celo los redujo a un pequeño número."
,"3":"Con la palabra de Dios cerró los cielos, y por tres veces hizo bajar fuego."
,"4":"¡Qué admirable fuiste, Elías, en tus portentos!,¿Quién podrá presumir de parecerse a ti?"
,"5":"Tú que arrancaste un muerto de la muerte,y del abismo por la palabra del altísimo."
,"6":"Que precipitaste a reyes en la fosa,y a hombres ilustres de sus lechos."
,"7":"Que escuchaste reproches en el Sinaí,y sentencias de castigo en el Horeb."
,"8":"Que consagraste reyes que hicieran justicia,y profetas que te sucedieran."
,"9":"Que fuiste arrebatado en torbellino de fuego, en un carro tirado por caballos de fuego."
,"10":"Tú, de quien está escrito,que fuiste preparado para un determinado tiempo. Para aplacar la ira antes de estallar, para volver los corazones de los padres a los hijos,y restablecer las tribus de Jacob."
,"11":"Dichosos los que te vieron y se durmieron en el amor, porque nosotros también poseeremos la vida."
,"12":"Cuando Elías fue arrebatado en el torbellino, Eliseo fue lleno de su espíritu; en todos sus días no tembló ante ningún gobernante,y no se dejó dominar por nadie."
,"13":"Nada fue demasiado difícil para él, y hasta en su muerte profetizó su cuerpo."
,"14":"En su vida hizo milagros, y en su muerte eran maravillosas sus obras."
,"15":"A pesar de todo, el pueblo no se arrepintió,ni se apartó de sus pecados, hasta que fueron expulsados de su país,y dispersados por toda la tierra."
,"16":"Y quedó reducido al más pequeño de los pueblos, con un príncipe de la casa de David. Algunos de ellos obraron el bien; otros multiplicaron los pecados."
,"17":"Ezequías fortificó su ciudad,y metió las aguas dentro de ella. Taladró con hierro la roca,y edificó estanques para las aguas."
,"18":"En sus días subió Senaquerib,y envió a Rabsaqués, que levantó su mano contra Sión,y se mostró arrogante en su orgullo."
,"19":"Entonces temblaron sus manos y sus corazones,y sintieron dolores de parturienta."
,"20":"Invocaron a Dios misericordioso, tendiendo sus manos a él, y el Santo se apresuró a oírles desde el cielo,y los libró por manos de Isaías."
,"21":"Hirió el campamento de los asirios, y su ángel los exterminó."
,"22":"Porque Ezequías hizo lo que agrada al Señor,y siguió los pasos de su padre, David, como le había ordenado el profeta Isaías, el grande y fiel en sus visiones."
,"23":"En sus días retrocedió el sol, y él prolongó la vida al rey."
,"24":"Con grande inspiración vio el fin de los tiempos, consoló a los afligidos de Sión, anunció lo venidero hasta el fin de los tiempos,y las cosas ocultas antes que sucediesen."
}`)
	CurrentBook.AddChapter(49, `{
"1":"El recuerdo de Josías es como una mezcla de perfumes,preparada por un perfumista. En toda boca es dulce como la miel, y como música en medio de un banquete."
,"2":"Él se comportó con rectitud, intentando la conversión del pueblo, y extirpó los ídolos detestables."
,"3":"Dirigió su corazón hacia el Señor; en los días de los malvados hizo prevalecer la piedad."
,"4":"Fuera de David, Ezequías y Josías, todos multiplicaron los pecados, porque abandonaron la ley del altísimo. Los reyes de Judá desaparecieron,"
,"5":"porque dieron su poder a otros,y su gloria a nación extranjera."
,"6":"Pusieron fuego a la ciudad santa,y convirtieron en desierto sus caminos,"
,"7":"a causa de Jeremías, porque lo maltrataron, aunque él fue consagrado profeta en el seno materno,para arrancar, destruir y arruinar, como también para edificar y plantar."
,"8":"Ezequiel tuvo una visión de la gloria, que el Señor le mostró sobre un carro de querubines."
,"9":"También mencionó a Job, que anduvo siempre por los caminos de la justicia."
,"10":"En cuanto a los doce profetas, que sus huesos florezcan en su tumba, porque confortaron a Jacob,y lo liberaron con fidelidad de la esperanza."
,"11":"¿Cómo engrandeceremos a Zorobabel, que era como sello en la mano derecha?"
,"12":"Así también Jesús, hijo de Josedec, los cuales en sus días reedificaron la casa,y levantaron un santuario consagrado al Señor, destinado a una gloria eterna."
,"13":"También es grande el recuerdo de Nehemías, que nos levantó muros derruidos, puso puertas y cerrojos,y restauró nuestras moradas."
,"14":"Nadie fue creado sobre la tierra semejante a Henoc, porque también él fue arrebatado de la tierra."
,"15":"Ni hubo hombre semejante a José, jefe de sus hermanos, apoyo del pueblo, cuyos huesos fueron tratados con respeto."
,"16":"Sem y Set fueron gloriosos entre los hombres; pero por encima de todos los vivientes está Adán."
}`)
	CurrentBook.AddChapter(50, `{
"1":"Simón, hijo de Onías, el sumo sacerdote, fue el que durante su vida reparó el templo, y en sus días fue consolidado el santuario."
,"2":"Echó los fundamentos de doble altura, el alto contrafuerte del muro del templo."
,"3":"En sus días fue excavado el estanque de las aguas, estanque semejante al mar por su capacidad."
,"4":"Él se empeñó en preservar a su pueblo de la ruina, y fortificó la ciudad para caso de cerco."
,"5":"¡Qué majestuoso era cuando el pueblo lo rodeaba,al salir de entre los velos del santuario!"
,"6":"Como estrella matutina en medio de las nubes, como luna en días de plenilunio,"
,"7":"como el sol que reverbera sobre el templo del altísimo, como el arco iris brillando en nubes de gloria;"
,"8":"como rosa en días de primavera, como lirio junto al manantial,y como brote del árbol del incienso en tiempo de verano;"
,"9":"como fuego e incienso en el incensario, como vaso de oro macizo, adornado con toda clase de piedras preciosas;"
,"10":"como olivo cargado de frutos,y como ciprés que se eleva hasta las nubes."
,"11":"Cuando se ponía las vestiduras de fiesta,y se vestía con ropas suntuosas, subía al altar santo,y hacía resplandecer el ámbito del santuario."
,"12":"Cuando recibía las porciones sacrificiales de manos de los sacerdotes,en pie junto al fuego, rodeado de una corona de hermanos; y a su alrededor, como brotes de palmera,"
,"13":"todos los hijos de Aarón en su gloria, con los sacrificios del Señor en sus manos,ante toda la asamblea de Israel,"
,"14":"hasta acabar el servicio del altar,y disponer el sacrificio del altísimo omnipotente."
,"15":"Cuando él extendía su mano a la copa,y ofrecía la sangre de la uva,derramándola al pie del altar, como suave olor para el altísimo, rey del universo,"
,"16":"entonces gritaban los hijos de Aarón, tocaban las trompetas de metal bruñido, dejando oír un potente sonido, como memorial ante el altísimo."
,"17":"Entonces todo el pueblo a una,se apresuraba a postrarse en tierra,para adorar al Señor, Dios altísimo, omnipotente."
,"18":"También los cantores con sus voces le alababan, y una dulce melodía llenaba todo el templo;"
,"19":"el pueblo suplicaba al Señor altísimo, y al misericordioso dirigía sus plegarias,hasta finalizar la ceremonia,y terminar el acto de servicio cultual."
,"20":"Entonces él descendía y levantaba las manos,sobre la congregación del pueblo de Israel,para dar en voz alta la bendición del Señor,y tener el honor de pronunciar su nombre."
,"21":"Entonces, por segunda vez, se prosternaban,para recibir la bendición del altísimo."
,"22":"Ahora bendecid al Dios del universo, que hace grandes cosas por doquier, que exalta nuestros días desde el seno materno,y obra con nosotros según misericordia."
,"23":"Que él nos conceda alegre corazón,y que haga reinar la paz en nuestros días,sobre Israel y hasta la eternidad."
,"24":"Que su misericordia permanezca fielmente a nuestro lado, y en nuestros días él nos libere."
,"25":"Dos pueblos me son odiosos, y un tercero que ni siquiera es pueblo:"
,"26":"los que habitan en la montaña de Seír, los filisteos y el pueblo estúpido que mora en Siquén."
,"27":"Doctrina sabia y ciencia,consignó en este libro,Jesús, hijo de Sirá Eleazar, de Jerusalén, que derramó como lluvia la sabiduría de su corazón."
,"28":"Dichoso el hombre que en estas cosas se ejercite, pues quien las medite en su corazón se hará sabio."
,"29":"Si así lo hace, será fuerte para todo, porque la luz del Señor será su senda."
}`)
	CurrentBook.AddChapter(51, `{
"1":"Te doy gracias, Señor, rey mío, y te alabaré, Dios, mi salvador. Daré gracias a tu nombre,"
,"2":"porque tú fuiste mi protector y mi apoyo, libraste mi cuerpo de la destrucción,y del lazo de la lengua malvada, de labios que maquinan la falsedad, has sido mi apoyo delante de los que me rodeaban,y me libraste,"
,"3":"según la multitud de tu misericordia,y la grandeza de tu nombre, del rechinar de dientes prestos a devorar, de la mano de los que acechaban mi vida, de las muchas tribulaciones que padecí;"
,"4":"de la asfixia de las llamas que me rodeaban, de en medio del fuego que yo no había encendido;"
,"5":"del seno profundo del sepulcro, de la lengua impura, de palabra mentirosa,"
,"6":"calumnia de una lengua injusta contra el rey. Mi alma ha estado al borde de la muerte, mi vida había descendido casi al sepulcro."
,"7":"Me rodeaban por todas partes, pero ni uno había para ayudarme. Mis ojos buscaban un socorro humano, y no lo había."
,"8":"Entonces me acordé, Señor, de tu misericordia,y de tus obras desde la eternidad; de que salvas a los que en ti esperan,y los libras de las manos de sus enemigos;"
,"9":"elevé mi plegaria desde la tierra,y supliqué que me librases de la muerte."
,"10":"Y grité: 'Señor, mi padre eres tú; mi Dios, que no me dejará en el día de la tribulación, en el tiempo del desamparo, frente a los orgullosos. Alabaré tu nombre continuamente,y entonaré himnos de acción de gracias'."
,"11":"Mi oración fue escuchada, porque me salvaste de la destrucción,y me libraste en el momento del peligro."
,"12":"Por esto te daré gracias y te alabaré,y bendeciré el nombre del Señor."
,"13":"En mi juventud, antes de darme a viajar, busqué la sabiduría sinceramente en mi plegaria."
,"14":"En el templo la supliqué, y hasta en mi último día la buscaré."
,"15":"En su flor, como un racimo que madura, se alegró mi corazón en ella. Mi pie caminó por senda de rectitud, desde mi juventud seguí sus huellas."
,"16":"Incliné a ella mi oído y la recibí, y encontré mucha instrucción."
,"17":"Gracias a ella hice muchos progresos; daré gracias al que me ha dado la sabiduría."
,"18":"Porque me he propuesto practicarla, he buscado celosamente el bien y jamás me arrepentiré de ello."
,"19":"Mi alma ha combatido por ella, y me he esforzado en practicar la ley. Extendí mis manos hacia el cielo, y lamenté mi ignorancia sobre ella."
,"20":"Dirigí hacia ella mi alma, y en la pureza la encontré. Apliqué a ella mi corazón desde el principio; por esto jamás seré abandonado."
,"21":"Mis entrañas se conmovían buscándola; por eso hice una buena adquisición."
,"22":"El Señor me dio por recompensa una lengua, con la que le daré gracias."
,"23":"Acercaos a mí los que carecéis de instrucción,y frecuentad mi escuela."
,"24":"¿Hasta cuándo vais a carecer de estas cosas,y vuestras almas han de padecer ardiente sed de ella?"
,"25":"Abrí mi boca para hablar; compradla sin dinero."
,"26":"Inclinad vuestro cuello a su yugo, y vuestra alma reciba instrucción. Cerca está para encontrarla."
,"27":"Ved con vuestros propios ojos qué poco he trabajado yo,y cómo encontré en ella gran reposo."
,"28":"Participad en la instrucción con un alto precio,y adquiriréis por ella mucho oro."
,"29":"Que vuestra alma se regocije en la misericordia del Señor, y no os avergoncéis de alabarle."
,"30":"Haced vuestra tarea antes del tiempo fijado, y en su día él os dará la recompensa."
}`)

}
func ES_LSB_LoadVSIBChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Había en el país de Hus un hombre llamado Job, hombre perfecto, íntegro, temeroso de Dios y apartado del mal."
,"2":"Tenía siete hijos y tres hijas;"
,"3":"su hacienda era de siete mil ovejas, tres mil camellos, quinientas yuntas de bueyes y quinientas asnas, además de una servidumbre numerosa. Era, pues, el más grande de todos los orientales."
,"4":"Sus hijos solían visitarse mutuamente y celebrar banquetes, cada cual en su día, e invitaban también a sus tres hermanas a comer y beber en su compañía."
,"5":"Al terminar los días del convite, Job les mandaba llamar para purificarlos; al día siguiente, se levantaba de madrugada y ofrecía un holocausto por cada uno de ellos. Porque pensaba: 'Acaso hayan pecado mis hijos y hayan maldecido a Dios en su corazón'. Así procedía Job cada vez."
,"6":"Un día que los hijos de Dios fueron a presentarse ante el Señor, fue también entre ellos Satán."
,"7":"Y el Señor preguntó a Satán: '¿De dónde vienes?'. Satán le respondió: 'De recorrer la tierra y de pasearme por ella'."
,"8":"Y el Señor dijo a Satán: '¿Has reparado en mi siervo Job? No hay nadie en la tierra como él, hombre recto, íntegro, temeroso de Dios y apartado del mal'."
,"9":"Satán respondió: '¿Es que Job teme a Dios desinteresadamente?"
,"10":"¿No has levantado una valla en torno a él, a su casa y a sus posesiones? Has bendecido las obras de sus manos, y sus rebaños hormiguean por el país."
,"11":"Pero extiende tu mano y toca todos sus bienes. ¡Verás si no te maldice a la cara!'."
,"12":"Y el Señor dijo a Satán: 'Bien, en tus manos está toda su hacienda; cuida sólo de no descargar tu mano sobre él'. Y Satán se retiró de la presencia del Señor."
,"13":"Un día en que sus hijos y sus hijas estaban comiendo y bebiendo vino en casa del hermano mayor,"
,"14":"un mensajero llegó a casa de Job y le dijo: 'Estaban los bueyes arando y las asnas pastando a su lado, cuando cayeron sobre ellos los sabeos y se los llevaron,"
,"15":"después de haber pasado a cuchillo a tus criados. Sólo yo pude escapar para traerte la noticia'."
,"16":"Todavía estaba hablando, cuando llegó otro, que dijo: 'Cayó del cielo el fuego de Dios, que abrasó las ovejas y los pastores, y los devoró. Sólo yo pude escapar para traerte la noticia'."
,"17":"Aún estaba éste hablando, cuando llegó otro, que dijo: 'Los caldeos, divididos en tres cuadrillas, se lanzaron sobre los camellos y se los llevaron, después de haber pasado a cuchillo a tus criados. Sólo yo pude escapar para traerte la noticia'."
,"18":"Estaba todavía hablando, cuando llegó otro, que dijo: 'Mientras tus hijos y tus hijas estaban comiendo y bebiendo vino en casa de su hermano mayor,"
,"19":"se levantó un gran viento del lado del desierto, que sacudió las cuatro esquinas de la casa, y ésta se derrumbó sobre los jóvenes, que quedaron muertos. Sólo yo pude escapar para traerte la noticia'."
,"20":"Entonces Job se levantó, rasgó sus vestiduras y se rapó la cabeza. Luego cayó en tierra, adoró y dijo:"
,"21":"'Desnudo salí del vientre de mi madre, desnudo allá regresaré. El Señor me lo había dado, el Señor me lo ha quitado; sea bendito el nombre del Señor'."
,"22":"En todo esto no pecó Job ni dijo nada insensato contra Dios."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Otro día en que los ángeles fueron a presentarse ante el Señor, se presentó también entre ellos Satán."
,"2":"Y el Señor dijo a Satán: '¿De dónde vienes?'. Satán le respondió: 'De recorrer la tierra y darme una vuelta por ella'."
,"3":"Y el Señor dijo a Satán: '¿Has reparado acaso en mi siervo Job? No hay nadie en la tierra como él, hombre recto, íntegro, temeroso de Dios y apartado del mal. Aún sigue firme en su entereza; en vano me has incitado contra él para arruinarlo'."
,"4":"Satán respondió: 'Piel por piel, que todo cuanto tiene el hombre está dispuesto a darlo por su vida."
,"5":"Pero extiende tu mano y toca sus huesos y su carne. Verás si no te maldice a la cara'."
,"6":"Y el Señor dijo a Satán: 'Ahí lo tienes en tus manos; respeta, sin embargo, su vida'."
,"7":"Satán salió de la presencia del Señor e hirió a Job con una llaga maligna desde la planta de los pies hasta la coronilla de la cabeza."
,"8":"Job, con un cascote de teja para rascarse, fue a sentarse sobre las cenizas."
,"9":"Su mujer le dijo: '¿Todavía perseveras en tu rectitud? ¡Maldice a Dios y muere!'."
,"10":"Pero él respondió: 'Hablas como una mujer necia. Si se acepta de Dios el bien, ¿no se ha de aceptar el mal?'. En todo esto no pecó Job con sus labios."
,"11":"Tres amigos de Job se enteraron de toda esta desgracia que le había sobrevenido. Partieron cada uno de su lugar: Elifaz, de Temán; Bildad, de Súaj, y Sofar, de Namat, y decidieron ir juntos a compadecerle y consolarlo."
,"12":"Al levantar sus ojos desde lejos no lo reconocieron, y se pusieron a llorar a grandes voces, rasgando cada uno su manto y esparciendo polvo sobre sus cabezas."
,"13":"Luego se sentaron en el suelo junto a él, y estuvieron así siete días y siete noches sin dirigirle ninguno la palabra, porque veían que su dolor era muy grande."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Por fin Job abrió su boca y maldijo el día de su nacimiento."
,"2":"Empezó a hablar así:"
,"3":"¡Perezca el día en que nací,y la noche que se dijo: 'Ha sido concebido un hombre!'."
,"4":"Aquel día hágase tiniebla, no se acuerde de él Dios desde lo alto, ni resplandezca sobre él la luz."
,"5":"Lo reclamen la tiniebla y la sombra mortal, caiga un nublado sobre él, lo invada súbito un eclipse."
,"6":"La oscuridad se apodere de él, no se cuente entre los días del año,ni entre en la cuenta de los meses."
,"7":"Y aquella noche sea estéril, ignore los clamores de júbilo."
,"8":"La maldigan los que maldicen el día, los que suelen despertar a Leviatán."
,"9":"Se oscurezcan las estrellas de su aurora, espere la luz, y no le llegue; y no vea los párpados del alba"
,"10":"por no haberme cerrado la puerta del vientre de mi madre,para ocultar a mis ojos el dolor."
,"11":"¿Por qué no me quedé muerto desde el seno materno?,¿Por qué no expiré al salir del vientre?"
,"12":"¿Por qué me acogieron dos rodillas,y me dieron de mamar dos pechos?"
,"13":"Ahora yacería tranquilo; dormiría ya y tendría reposo"
,"14":"con los reyes y magnates de la tierra,que se edificaron mausoleos,"
,"15":"o con los príncipes que poseen oro,y tienen llenas de plata sus moradas."
,"16":"O bien, como un aborto que no cuenta, sería como los niños que no vieron la luz."
,"17":"Allí termina el furor de los malvados, allí reposan los exhaustos de fuerzas;"
,"18":"yacen tranquilos los cautivos, sin oír más los gritos del tirano."
,"19":"Allí se mezclan grandes y pequeños, y el esclavo se ve libre de su amo."
,"20":"¿Por qué da él la luz a un desgraciado, la vida a los que tienen amargada el alma;"
,"21":"a los que desean la muerte que no llega, y la buscan más que se busca un tesoro;"
,"22":"a los que se alegrarían ante la tumba,y gozarían si encontraran un sepulcro... "
,"23":"a un hombre cuyo camino se ha borrado,y a quien Dios asedia por todas partes?"
,"24":"Sí, ante mi comida rompo en llanto; como el agua se derraman mis lamentos,"
,"25":"porque me sobreviene todo lo que temo, y lo que recelo me sucede."
,"26":"No tengo calma, no tengo paz, no hallo descanso; sólo la turbación me invade."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Tomó la palabra Elifaz de Temán y dijo:"
,"2":"Si se intentara hablarte, ¿te impacientarías?,Pero ¿quién puede contener la palabra?"
,"3":"Mira, tú has instruido a otros muchos, has vigorizado las manos débiles."
,"4":"Han sostenido tus palabras al que vacilaba, has fortalecido al que doblaba la rodilla."
,"5":"Y porque ahora te llega a ti la hora, te turbas; te toca a ti, y ya estás desalentado."
,"6":"¿No te daba confianza tu piedad?,¿No era tu esperanza la perfección de tu conducta?"
,"7":"Reflexiona: ¿Qué inocente ha perecido?,¿Cuándo fueron abatidos los justos?"
,"8":"Hablo por lo que he visto. Los que labran maldad,y siembran aflicción, de ellas cosechan."
,"9":"Bajo el soplo de Dios perecen éstos, por el viento de su ira son aniquilados."
,"10":"Los rugidos del león, sus aullidos salvajes, como los dientes de los leoncillos quedan rotos."
,"11":"Perece el león por falta de presa, y los cachorros de la leona son desperdigados."
,"12":"Llegó a mí furtivamente una palabra, mi oído percibió su murmullo."
,"13":"Cuando el espíritu divaga,en las visiones de la noche, cuando el sopor a los hombres invade,"
,"14":"un estremecimiento de espanto me sacudió, que de terror hizo temblar mis huesos."
,"15":"El viento azotó mi rostro, se erizaron los pelos de mi carne."
,"16":"Alguien surgió, no reconocí su semblante; un fantasma estaba ante mis ojos; luego se dejó oír una voz queda:"
,"17":"¿Puede ante Dios ser justo el hombre?,¿Ante su hacedor es puro algún mortal?"
,"18":"En sus mismos ministros no tiene él confianza, y hasta en sus ángeles encuentra imperfección;"
,"19":"¡cuánto más en los habitantes de estas casas de arcilla, que apoyan sus cimientos en el polvo!,Se les aplasta igual que a la polilla,"
,"20":"de la mañana a la tarde quedan pulverizados, perecen para siempre sin darse cuenta nadie."
,"21":"La cuerda de su tienda es arrancada, y mueren faltos de sabiduría."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Llama, pues; ¿habrá quien te responda?,¿A cuál de los santos te vas a dirigir?"
,"2":"Realmente la rabia mata al insensato, la irritación da muerte al necio."
,"3":"Yo mismo he visto al insensato echar raíces, pero al punto su mansión quedó podrida."
,"4":"Sus hijos se ven abandonados, sin apoyo; sin defensor, pisoteados a la puerta;"
,"5":"los hambrientos su cosecha devoran,porque Dios se la arranca de los dientes, y los sedientos chupan su fortuna."
,"6":"Pues no nace del polvo la miseria, ni de la tierra la aflicción germina."
,"7":"Es el hombre quien engendra la aflicción, como el águila emprende el vuelo a las alturas."
,"8":"Yo, por mí, recurriría a Dios, y a Dios confiaría mi causa;"
,"9":"a aquel que hace cosas grandes, insondables, maravillas sin número."
,"10":"Él derrama la lluvia sobre la tierra,y envía el agua a los campos;"
,"11":"rehabilita a los hundidos, restituye a los afligidos en la dicha."
,"12":"Desbarata los pensamientos del astuto, y no logran sus manos realizar sus intrigas."
,"13":"Sorprende a los sabios en sus tramas, y el consejo de los sagaces hace inepto;"
,"14":"en pleno día se encuentran en tinieblas, a mediodía van a tientas, cual si fuese de noche."
,"15":"Arranca de sus fauces al mísero, y al pobre de las garras del violento;"
,"16":"el infeliz recobra la esperanza,y cierra su boca la injusticia."
,"17":"¡Oh, sí, feliz el hombre que por Dios es corregido,y no desperdicia la enseñanza del todopoderoso!"
,"18":"Porque él hiere y después sana la herida; llaga, y su misma mano cura."
,"19":"Seis veces te librará de la angustia, y siete el mal alejará."
,"20":"Durante el hambre te salvará de la muerte, y en la guerra del golpe de la espada."
,"21":"Del azote de la lengua estarás a cubierto, y no temerás el peligro inminente."
,"22":"Te reirás de la desolación y la escasez, y no temerás a las bestias de la tierra."
,"23":"Con las piedras del campo harás un pacto, y las bestias salvajes vivirán en paz contigo."
,"24":"Sabrás que tu tienda prospera; al revisar el ganado, nada echarás de menos."
,"25":"Verás que tu prole se acrecienta, tus vástagos como la hierba de los prados."
,"26":"Llegarás bien maduro a la tumba, como a su tiempo el grano se recoge."
,"27":"He aquí cuanto hemos observado. ¡Así es! Nosotros lo escuchamos; aprovéchate de ello."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Job respondió:"
,"2":"¡Oh, si se pesara mi tormento, si en la balanza se pusieran todos mis males juntos!"
,"3":"Más que la arena del mar pesarían; por eso mis palabras se desbocan."
,"4":"Pues las flechas del todopoderoso están en mí clavadas; mi espíritu bebe su veneno, y los terrores de Dios me turban."
,"5":"¿Rozna acaso el onagro ante la hierba verde, o muge el buey junto al forraje?"
,"6":"¿Se come lo insípido sin sal?,¿Qué gusto hay en la clara de huevo?"
,"7":"Aquello que mi alma aborrecía,se ha hecho mi comida de enfermo."
,"8":"¡Oh, si se realizara lo que pido, si Dios me concediera lo que espero,"
,"9":"si Dios se decidiera a aniquilarme, si extendiera su mano y me exterminara!"
,"10":"Tendría entonces al menos un consuelo, una efusión de gozo en mis males sin piedad; el no haber eludido los preceptos del santo."
,"11":"¿Cuál es mi fuerza para seguir esperando?,¿Cuál mi destino para seguir viviendo?"
,"12":"¿Es acaso mi fuerza la fuerza de la roca?,¿Es mi carne de bronce?"
,"13":"¡Oh, ya no encuentro apoyo alguno en mí, me he quedado sin ninguna ayuda!"
,"14":"El que niega la compasión al prójimo,desecha el temor del todopoderoso."
,"15":"Me han engañado mis hermanos,lo mismo que un torrente, como arroyos de aguas pasajeras;"
,"16":"turbios de agua de hielo, por ellos baja oculta la nieve derretida;"
,"17":"pero al llegar el calor se desvanecen, bajo el ardor se evaporan en su lecho."
,"18":"Las caravanas se desvían de su ruta, se adentran en el desierto y se extravían."
,"19":"Las caravanas de Temán fijan allá sus ojos, en ellos esperan los convoyes de Sabá."
,"20":"Pero se ve frustrada su esperanza, al llegar junto a ellos quedan confundidos."
,"21":"Así habéis quedado ahora vosotros frente a mí; al verme, espantados, os escandalizáis."
,"22":"¿Acaso os he dicho: 'Hacedme tal favor, dadme un regalo de vuestra hacienda, "
,"23":"libradme de la mano de un rival, salvadme de las garras de un tirano?'."
,"24":"Instruidme, pues, y callaré; indicadme en qué he errado."
,"25":"Se admiten con gusto las palabras imparciales; pero ¿para qué sirven vuestras críticas?"
,"26":"¿Pensáis acaso refutar palabras, dichos de un desesperado,que son tan sólo viento?"
,"27":"¡Vosotros llegaríais a lanzaros sobre el huérfano, a explotar a vuestro mismo amigo!"
,"28":"Pero ahora, por favor, dignaos mirarme, no he de mentiros a la cara."
,"29":"¡Volved, no seáis injustos!,¡Volved, que mi justicia aún sigue en pie!"
,"30":"¿Hay acaso en mi lengua falsedad?,Mi paladar, ¿ya no distingue lo que es malo?"
}`)
	CurrentBook.AddChapter(7, `{
"1":"¿No es un servicio la vida del hombre en la tierra?,¿No son sus días, días de jornalero?"
,"2":"Como el esclavo suspira por la sombra, como obrero que espera su salario,"
,"3":"así meses de aflicción me han caído en herencia, me han tocado noches de dolor."
,"4":"Al acostarme, digo: '¿Cuándo llegará el día?'. Y al levantarme: '¿Cuándo será de noche?'. Y, presa de zozobras, doy vueltas hasta el crepúsculo."
,"5":"Mi carne está cubierta de gusanos,y de costras terrosas, se agrieta,y se cae a pedazos mi piel."
,"6":"Mis días huyen más raudos que la lanzadera; se esfuman sin ninguna esperanza."
,"7":"Recuerda que mi vida es un soplo, que mis huesos no volverán a ver la dicha."
,"8":"No me distinguirá ya el ojo que me mira, posarás en mí tus ojos y ya no existiré."
,"9":"La nube se disipa y pasa; así el que baja al abismo ya no vuelve más."
,"10":"No regresa ya a su morada, su casa no le vuelve a ver."
,"11":"Por eso no cerraré mi boca, voy a quejarme en la amargura de mi alma."
,"12":"¿Soy yo el monstruo marino, para que pongas guardia en torno a mí?"
,"13":"Si digo: 'Mi lecho me consolará, mi cama aliviará mi sufrimiento',"
,"14":"entonces con sueños tú me espantas, con visiones me aterras."
,"15":"¡Ay! Preferiría mi alma el estrangulamiento, la muerte a estos dolores."
,"16":"Me estoy disolviendo, no viviré para siempre; déjame, pues mis días son un soplo."
,"17":"¿Qué es el hombre para que de él así te ocupes, para que pongas en él tu pensamiento,"
,"18":"para que le visites todas las mañanas,y a cada instante le sometas a pruebas?"
,"19":"¿Hasta cuándo seguirás vigilándome?,¿No me dejarás ni tragar la saliva?"
,"20":"Si he pecado, ¿qué te he hecho a ti con ello, oh guardián de los hombres?,¿Por qué me has hecho blanco tuyo?,¿Por qué te causo inquietud?"
,"21":"¿Por qué mi ofensa no toleras,y no ignoras mi delito?"
,"22":"Muy pronto yaceré en el polvo; me buscarás, y ya no existiré."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Bildad, de Súaj, tomó la palabra y dijo:"
,"2":"¿Hasta cuándo seguirás hablando así,y las palabras de tu boca serán un viento desatado?"
,"3":"¿Acaso Dios tuerce el derecho, el todopoderoso pervierte la justicia?"
,"4":"Si tus hijos pecaron contra él, ya los hizo cargar con su pecado."
,"5":"Mas tú recurre a Dios, implora al todopoderoso."
,"6":"Si eres irreprochable y recto, desde ahora velará sobre ti,y restaurará tu mansión de justicia."
,"7":"Tu ayer te parecerá mezquino,a vista de la dicha que te espera."
,"8":"Pregunta a las generaciones del pasado, recurre a la experiencia de los padres,"
,"9":"pues nosotros somos de ayer y nada sabemos; una sombra son nuestros días en la tierra."
,"10":"Ellos te instruirán, te hablarán, y de su corazón sacarán estas frases:"
,"11":"¿Crece acaso el papiro fuera de las lagunas?,¿Brota el junco donde no hay agua?"
,"12":"Aún en su verdor, sin ser cortado, antes que toda otra hierba se marchita."
,"13":"Tal es la suerte de todo el que de Dios se olvida, así fenece la esperanza del malvado."
,"14":"Un hilo sólo es su confianza, una tela de araña su seguridad."
,"15":"Se apoya en su morada, que no aguanta; se agarra a ella, y no resiste."
,"16":"Exuberante bajo el sol, por encima del huerto asoman sus ramas;"
,"17":"entre un montón de piedras,se entrelazan sus raíces, su vida se agarra a las rocas."
,"18":"Mas si se le arranca de su sitio, su sitio de él reniega: 'No te he visto jamás'."
,"19":"Y cómo se pudre en el camino, mientras del suelo brotan otros."
,"20":"No, Dios no rechaza al hombre justo,ni da su mano a los malvados."
,"21":"De risa puede aún colmar tu boca,y de júbilo tus labios."
,"22":"Tus enemigos quedarán cubiertos de ignominia, y la tienda de los malvados desaparecerá."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Job respondió:"
,"2":"En verdad, bien sé yo que es así; ¿cómo frente a Dios puede tener razón el hombre?"
,"3":"Aunque tratase de pleitear con él, no tendría qué responder una vez entre mil."
,"4":"Sabio de mente y robusto de fuerza, ¿quién puede resistirle impunemente?"
,"5":"Él traslada los montes sin que se den cuenta, y los sacude en su furor."
,"6":"Desquicia la tierra de su sitio,y hace vacilar sus columnas."
,"7":"Si él lo ordena el sol no sale, y mantiene bajo sello a las estrellas."
,"8":"Él solo extiende los cielos,y camina sobre la superficie del mar."
,"9":"Él ha creado la Osa y Orión, las Pléyades,y la constelación del Sur."
,"10":"Hace cosas grandes e insondables, maravillas que contarse no pueden."
,"11":"Si pasa junto a mí, no lo veo, y se desliza imperceptible."
,"12":"Si atrapa una presa, ¿quién se lo impedirá?,¿Quién le dirá: 'Qué es lo que haces'?"
,"13":"Dios no retira su furor, bajo él se inclinan los satélites de Rahab."
,"14":"¡Cuánto menos podré yo replicarle, rebuscar mis argumentos frente a él!"
,"15":"Aunque tuviera razón no podría responderle; él es mi juez: tendría que suplicarle."
,"16":"Aunque respondiera a mi apelación, no estoy seguro de que escuchara mi voz,"
,"17":"él, que me arrolla en raudo torbellino, que multiplica sin razón mis heridas"
,"18":"y no me deja recobrar aliento, sino que me sacia de amarguras."
,"19":"¿Recurrir a la fuerza? Él es el vigoroso. ¿Al derecho? Mas ¿quién le citará?"
,"20":"Si me creo justo, puede su boca condenarme; declararme culpable, si me estimo inocente."
,"21":"Mas ¿soy inocente? No lo sé; ya me da igual la existencia."
,"22":"Pero me es todo lo mismo. Y me atrevo a decir: Él pierde por igual al justo y al culpable."
,"23":"Si un azote acarrea la muerte de improviso, él se ríe de la angustia de los inocentes."
,"24":"En un país sujeto al poder de un malvado, vela él el rostro de los que le juzgan. Si no es él, ¿quién puede ser?"
,"25":"Mis días pasan más veloces que un correo, se van sin ver la dicha;"
,"26":"se deslizan igual que canoas de junco, como el águila cae sobre la presa."
,"27":"Si digo: Voy a olvidarme de mis quejas, a mudar de semblante y ponerme alegre,"
,"28":"me invade el terror de todos mis dolores, pues sé que tú no me declaras inocente."
,"29":"Y si culpable soy, ¿para qué en vano fatigarme?"
,"30":"Aunque con agua de nieve me lavara,y mis manos limpiara con lejía,"
,"31":"tú, con todo, me hundirías en el lodo,y mis propios vestidos tendrían horror de mí."
,"32":"Pues él no es un hombre como yo,para discutir con él y comparecer juntos en juicio."
,"33":"¡Oh, si hubiera entre nosotros árbitro,que pusiera la mano entre los dos,"
,"34":"para que aparte su látigo de mí,y no me espante su terror!"
,"35":"Hablaré, sin embargo, sin temerle, ya que no soy así ante mis ojos."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Mi alma siente asco de mi vida; quiero dar libre curso a mis lamentos, derramaré la amargura de mi alma."
,"2":"Diré a Dios: ¡No me condenes!,Hazme saber de qué me acusas."
,"3":"¿Acaso vas a mostrarte violento, a despreciar la obra de tus manos,y secundar el plan de los inicuos?"
,"4":"¿Tienes ojos de carne? ¿Ves como ve un hombre?"
,"5":"¿Son tus días los días de un mortal, tus años como los días de un hombre,"
,"6":"para que andes rebuscando mis culpas, indagando mi pecado?"
,"7":"Sabes muy bien que yo no soy culpable,y que nadie me puede salvar de tus manos."
,"8":"Tus manos me han plasmado, me han formado; ¡y ahora, de pronto, me quieres destruir!"
,"9":"Recuerda que me amasaste como arcilla, y que al polvo me has de devolver."
,"10":"¿No me derramaste como leche,y me coagulaste como la cuajada?"
,"11":"De piel y de carne me vestiste, y me tejiste de huesos y de nervios."
,"12":"Vida y benevolencia me otorgaste, y tu solicitud guardó mi espíritu."
,"13":"Pero en tu corazón guardabas otras cosas, bien sé que te reservabas esto."
,"14":"Si peco, me vigilas,y no pasas por alto falta alguna."
,"15":"Si soy culpable, ¡desgraciado de mí!,Si inocente, no oso levantar la cabeza, saturado de ignominia, ebrio de aflicción."
,"16":"Si me levanto, como a un león me das caza, y vuelves a invadirme con tu espanto."
,"17":"Renuevas tus ataques, redoblas tu ira contra mí, y sin cesar me atacan tus tropas de refresco."
,"18":"Oh, ¿por qué me hiciste salir de las entrañas?,Hubiera muerto y no me hubiera visto ojo alguno."
,"19":"Sería como si no hubiera existido, llevado desde el vientre a la tumba."
,"20":"¿No son bien breves los días de mi vida?,Deja, pues, que goce un poco de consuelo"
,"21":"antes que me vaya para no volver más, a la región de las tinieblas y de negras sombras,"
,"22":"lugar de oscuridad y caos, donde la misma claridad es cual noche cerrada."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Sofar, de Namat, tomó la palabra y dijo:"
,"2":"¿Quedará sin respuesta el charlatán?,Por ser locuaz, ¿va a tener razón?"
,"3":"¿Tu palabrería hará callar a los demás?,¿Te mofarás sin que nadie te confunda?"
,"4":"Tú dices: 'Mi conducta es pura, ante tus ojos soy irreprochable'."
,"5":"Pero, ¡ay, si Dios hablase, si abriese los labios para responderte,"
,"6":"si te revelase los secretos de la sabiduría, que desbaratan toda sagacidad!,Sabrías entonces que Dios calla,incluso parte de tus pecados."
,"7":"¿Pretendes tú escrutar el misterio de Dios, igualar la perfección del todopoderoso?"
,"8":"Más alta es que los cielos; ¿qué harás tú? Más honda que el abismo, ¿qué puedes tú saber?"
,"9":"Más larga que la tierra y más ancha que el mar."
,"10":"Si él se presenta, encarcela y cita a juicio, ¿quién le hará desistir?"
,"11":"Porque él distingue a los hombres perversos,y ve la iniquidad sin esfuerzo."
,"12":"Así el insensato se hará cuerdo, cuando un asno salvaje se vuelva hombre."
,"13":"Pero si tú ordenas tu corazón,y tiendes tus manos hacia él,"
,"14":"si apartas el mal que hay en tus manos,y no albergas en tu tienda la injusticia,"
,"15":"entonces alzarás tu rostro limpio, te sentirás firme y sin temor;"
,"16":"te olvidarás entonces de la prueba, como agua pasada la recordarás."
,"17":"Más radiante que el mediodía será tu existencia, la misma oscuridad se trocará en aurora."
,"18":"Seguro vivirás, cargado de esperanza; bien protegido, habitarás tranquilo."
,"19":"Cuando te acuestes, nadie te turbará, y buscarán muchos tu favor."
,"20":"En cambio se abatirán los ojos de los malvados, les fallará todo refugio; su esperanza será su postrer aliento."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Job respondió:"
,"2":"Ciertamente vosotros sois el pueblo, con vosotros la sabiduría morirá."
,"3":"Mas yo también sé pensar como vosotros; en nada me aventajáis. Pero ¿quién jamás ha alcanzado tales cosas?"
,"4":"Se hace burla del amigo, del que invoca a Dios,para pedir respuesta. ¡Ludibrio es el justo íntegro!"
,"5":"'¡A la desgracia el desprecio!,-opina el que es feliz-. ¡Un golpe más a quien vacila!'."
,"6":"¡En cambio, están tranquilas las tiendas de los saqueadores, plena seguridad para los que provocan a Dios,y creen meterlo en su puño!"
,"7":"Pero pregunta a las bestias, y te instruirán; a las aves del cielo, que te informarán;"
,"8":"te aleccionarán los reptiles de la tierra, te enseñarán los peces de los mares."
,"9":"Pues de todos éstos, ¿quién ignora que la mano de Dios lo ha hecho todo?"
,"10":"En sus manos está el alma de todo ser viviente,y el espíritu de toda carne de hombre."
,"11":"¿No es el oído el que aprecia las palabras, como el paladar saborea los manjares?"
,"12":"De los ancianos, el saber; de la longevidad, la inteligencia."
,"13":"Pero en él sabiduría y poder, suyos la inteligencia y el consejo."
,"14":"Si él destruye, nadie podrá reconstruir; si encierra a alguno, nadie le abrirá."
,"15":"Si retiene las aguas, viene la sequía; si las suelta, arrasan la tierra."
,"16":"En él la fuerza y la sabiduría, suyos el seductor y el seducido."
,"17":"Él hace estúpidos a los consejeros,y a los jueces priva de sentido."
,"18":"Despoja a los reyes de su banda,y les ciñe a los lomos una soga."
,"19":"Hace andar descalzos a los sacerdotes, y abate a los que están seguros."
,"20":"Quita la palabra a los más hábiles,y priva de juicio a los ancianos."
,"21":"Sobre los nobles vierte el menosprecio,y suelta la correa de los fuertes."
,"22":"Arranca a las tinieblas sus secretos,y saca a la luz la negra sombra."
,"23":"Levanta a las naciones y las hunde, agranda a los pueblos y los aniquila."
,"24":"Quita el sentido a los jueces de la tierra, los hace vagar por un desierto sin caminos,"
,"25":"andar a tientas en tinieblas, sin luz, y tambalearse lo mismo que un borracho."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Sí, mis ojos han visto todo esto, mis oídos lo han escuchado y comprendido."
,"2":"Lo sé tan bien como vosotros; en nada me aventajáis."
,"3":"Pero quiero hablar con el todopoderoso, quiero discutir con Dios."
,"4":"Vosotros no sois más que charlatanes, médicos de quimeras todos juntos."
,"5":"¡Oh, si os hubierais callado, la única ciencia que os conviene!"
,"6":"Pero escuchad mis cargos, por favor, atended a la defensa de mis labios."
,"7":"¿Creéis defender a Dios con palabras inicuas,y su causa con razones mentirosas?"
,"8":"¿Creéis favorecerle al ser parciales?,¿En defensa de Dios discutís?"
,"9":"¿Qué tal si él os sondease?,¿Le engañaríais como se engaña a un hombre?"
,"10":"Os castigaría severamente por vuestra tácita parcialidad."
,"11":"¿Su majestad no os estremece?,¿No os invade su terror?"
,"12":"Vuestros argumentos son pruebas de ceniza, réplicas de barro vuestras réplicas."
,"13":"¡Guardad silencio! Pues yo voy a hablar, venga sobre mí lo que viniere."
,"14":"Tomo mi carne entre mis dientes, pongo mi alma en mis manos."
,"15":"Él me puede matar; no tengo otra esperanza,que defender en su presencia mi conducta."
,"16":"Y esto mismo es ya una señal de absolución, pues un malvado no osa comparecer ante su faz."
,"17":"Escuchad, escuchad mis palabras; prestad oídos a mis razones."
,"18":"Mirad, voy a proceder a mi defensa, porque sé que estoy en mi derecho."
,"19":"¿Quién es el que pretende pleitear conmigo?,Porque me callaré, dispuesto a morir."
,"20":"Sólo dos cosas te pido que me ahorres, y no esquivaré entonces tu presencia."
,"21":"Retira de mí tu mano y ya no me espante tu terror."
,"22":"Luego interrógame, y yo responderé; o bien hablaré yo, y tú responderás."
,"23":"¿Cuántos son mis pecados y mis culpas?,Hazme saber mi ofensa y mi pecado."
,"24":"¿Por qué ocultas tu rostro,y me tienes por enemigo tuyo?"
,"25":"¿Quieres asustar a una hoja estremecida,o perseguir a una paja seca?"
,"26":"Pues dictas contra mí amargos fallos,y me imputas la falta de mi mocedad;"
,"27":"metes mis pies en cepos, vigilas todos mis caminos,y escrutas todas las huellas de mis pasos,"
,"28":"mientras yo me deshago como un leño carcomido, como un vestido apolillado."
}`)
	CurrentBook.AddChapter(14, `{
"1":"El hombre, nacido de mujer,corto es de días y harto de miserias;"
,"2":"como la flor brota y se marchita luego, y huye como una sombra sin pararse."
,"3":"¡Y sobre un ser como éste posas tú los ojos, y le citas a juicio ante ti!"
,"4":"¿Quién puede sacar lo puro de lo impuro? Nadie."
,"5":"Puesto que están contados ya sus días, si por ti está fijada la cuenta de sus meses, si has señalado un límite que no podrá cruzar,"
,"6":"aparta de él tus ojos, déjale, como un mercenario, que acabe su jornada."
,"7":"Una esperanza hay para el árbol: si es cortado, aún puede germinar, y sus renuevos no dejan de crecer."
,"8":"Aunque haya envejecido su raíz en la tierra,y en el suelo haya muerto su tronco,"
,"9":"en cuanto siente el agua reverdece,y echa ramas como una planta joven."
,"10":"Pero si el humano muere, todo acaba; al expirar el hombre, ¿qué es de él?"
,"11":"Podrán agotarse las aguas de los mares, secarse los ríos y desaparecer;"
,"12":"que el hombre que yace no se alzará ya más; se desharán los cielos y no despertará; no surgirá más de su sueño."
,"13":"¡Oh, si tú me escondieses en el abismo,y me guardaras hasta que pase tu ira; si una tregua me dieras para acordarte de mí luego"
,"14":"-si después de muerto se puede revivir-, todos los días de mi milicia esperaría,hasta que llegase mi relevo!"
,"15":"Me llamarías, y yo respondería; querrías volver a ver la obra de tus manos."
,"16":"En lugar de vigilar mis pasos, como ahora, no te cuidarías más de mis pecados."
,"17":"En un saco sellado estaría mi delito, y blanquearías mi falta."
,"18":"Mas como un monte llega a derrumbarse,y una roca cambia de lugar;"
,"19":"como el agua va desgastando las piedras,y la crecida arrastra la superficie de la tierra, así destruyes tú la esperanza del hombre."
,"20":"Para siempre le aplastas y él se va; desfiguras su rostro y luego le expulsas."
,"21":"¿Serán honrados sus hijos? No lo sabe. ¿Serán despreciados? No se entera."
,"22":"Tan sólo conoce el dolor de su carne, sólo de su vida se lamenta."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Elifaz, de Temán, tomó la palabra y dijo:"
,"2":"¿Responde un sabio con razones huecas?,¿Llena su pecho de viento solano?"
,"3":"¿Con palabras vanas se defiende?,¿Con discursos sin peso?"
,"4":"Pero tú incluso destruyes la piedad,y suprimes la meditación ante Dios."
,"5":"La iniquidad inspira tus palabras,y adoptas el lenguaje de los cínicos."
,"6":"Tu propia boca te condena, no yo; tus mismos labios atestiguan contra ti."
,"7":"¿Naciste tú el primero de los hombres?,¿Viste la luz antes que las colinas?"
,"8":"¿Has asistido al consejo de Dios?,¿Has acaparado la sabiduría?"
,"9":"¿Qué sabes tú que nosotros no sepamos?,¿Qué comprendes que nosotros no entendamos?"
,"10":"También entre nosotros los hay con canas,y más cargados de días que tu padre."
,"11":"¿Es que tienes en poco los consuelos de Dios,y una palabra dicha con dulzura?"
,"12":"¡Cómo te arrebata la pasión, qué torcida es tu mirada,"
,"13":"cuando revuelves contra Dios tu furia,al proferir tales palabras!"
,"14":"¿Cómo puede ser puro un hombre?,¿Cómo puede ser justo el nacido de mujer?"
,"15":"Si ni en sus santos tiene Dios confianza, si ni los cielos son puros a sus ojos,"
,"16":"¡cuánto menos un ser abominable y corrompido, el hombre, que bebe como agua la iniquidad!"
,"17":"Yo te instruiré, escúchame; te comunicaré lo que he visto,"
,"18":"lo que enseñan los sabios, lo que no les han ocultado sus padres,"
,"19":"a los cuales sólo fue entregada esta tierra, sin que se mezclara extranjero entre ellos."
,"20":"Todos sus días vive el malvado en angustia, y el tirano por el número de años,que se le han fijado."
,"21":"Grito de espanto resuena en sus oídos; mientras vive en paz, el azote lo sorprende."
,"22":"No espera escapar a las tinieblas, se siente destinado a la espada."
,"23":"Designado como pasto de buitres, sabe que el día tenebroso está encima."
,"24":"Le estremecen la angustia y la ansiedad, le invaden como un rey pronto al asalto."
,"25":"Porque extendía contra Dios su mano, pretendía retar al todopoderoso,"
,"26":"embestía contra él, erguida la cabeza, protegido detrás de un escudo macizo."
,"27":"Porque su rostro estaba cubierto de grosura, cargadas de sebo sus ijadas;"
,"28":"por eso habitará ciudades destruidas, casas donde ya nadie vive, destinadas a ser montón de ruinas."
,"29":"No se enriquecerá, no se mantendrá su fortuna, ni su hacienda echará ya raíces en la tierra."
,"30":"No escapará de las tinieblas: agostará la llama sus renuevos, y su fruto será sacudido por el viento."
,"31":"No confíe en su estatura, pues vacía será su recompensa."
,"32":"Se marchitará antes de tiempo su ramaje, y sus ramas no reverdecerán."
,"33":"Dejará caer, como la viña, sus agraces; como un olivo tirará su flor."
,"34":"Porque la estirpe del malvado será estéril, y el fuego devorará la tienda del soborno."
,"35":"El que concibe el mal engendra angustia,y lleva en su vientre un fruto de aborto."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Job respondió:"
,"2":"He oído muchas cosas como éstas. ¡Consoladores molestos sois vosotros!"
,"3":"¿No acabarán esas palabras vanas?,¿Qué es lo que te duele para que así respondas?"
,"4":"También yo podría hablar como vosotros,si me encontrara en vuestro lugar: sabría fascinaros con discursos, meneando contra vosotros mi cabeza."
,"5":"Podría confortaros con mi boca, no ahorraría el consuelo de mis labios."
,"6":"Pero aunque hable, no cesa mi dolor; y si callo, ¿acaso se me calma?"
,"7":"Ahora estoy abrumado por el tedio, porque toda una chusma me acorrala,"
,"8":"se alza contra mí como testigo adverso, me replica a la cara con calumnias."
,"9":"Su furia me desgarra y me persigue, rechinando sus dientes contra mí. Mis adversarios aguzan contra mí sus ojos."
,"10":"Abren su boca amenazando, me afrentan golpeando mis mejillas, a una se congregan contra mí."
,"11":"Dios me ha entregado a los perversos, en manos de criminales me ha arrojado."
,"12":"Vivía yo tranquilo y él me sacudió, me agarró por la nuca para despedazarme, me ha hecho blanco suyo."
,"13":"Sus flechas me acorralan, traspasa mis entrañas sin piedad,y derrama por tierra mi hiel."
,"14":"Abre en mí brecha sobre brecha, me asalta lo mismo que un guerrero."
,"15":"Un saco ha cosido en mi piel, ha arrastrado mi frente por el polvo."
,"16":"Mi rostro está rojo de llorar, sombra de muerte pesa sobre mis párpados."
,"17":"Y, sin embargo, no hay en mis manos injusticia,y mi oración es pura."
,"18":"Oh tierra, no cubras mi sangre, y nada detenga mi lamento."
,"19":"Desde ahora ya tengo en los cielos mi testigo, en las alturas está mi defensor."
,"20":"Mi lamento es mi abogado,cuando ante Dios lágrimas vierten mis ojos."
,"21":"Defienda él el pleito entre un hombre,y Dios como entre un mortal y otro mortal."
,"22":"Pues contados están los años que me restan,y ya me adentro por el sendero sin retorno."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Mi aliento se agota y mis días se apagan, sólo me queda la tumba."
,"2":"¡Oh, sí, me abruman los burlones, y de amargura se consumen mis ojos!"
,"3":"Dígnate tú poner mi fianza junto a ti: ¿quién, si no, chocaría mi mano?"
,"4":"Pues tú has cerrado su mente a la razón; por eso no dejarás que triunfen."
,"5":"Como el que invita a sus amigos a un reparto, mientras los ojos de sus hijos languidecen,"
,"6":"yo me he vuelto el escarnio de la gente, alguien a quien en la cara se le escupe."
,"7":"Mis ojos se apagan por la pena, mis miembros se extinguen como sombras."
,"8":"Se pasman los justos al saberlo, el inocente se indigna contra el malvado."
,"9":"Pero el justo se asegura en su camino, y el de manos limpias su ánimo redobla."
,"10":"Vosotros, volved, volved todos de nuevo: no hallaré un solo sabio entre vosotros."
,"11":"Mis días han pasado, mis planes se han deshecho, han fallado las fibras de mi corazón."
,"12":"La noche dejará paso al día, se acerca ya la luz tras las tinieblas."
,"13":"Mas ¿puedo yo esperar?,El abismo es mi casa, en las tinieblas extiendo mi lecho."
,"14":"Grito al sepulcro: ¡Tú eres mi padre!, a la podre: ¡Tú mi madre y mi hermana!"
,"15":"¿Dónde está, pues, mi esperanza?,Y mi felicidad, ¿quién la verá jamás?"
,"16":"¿Bajarán conmigo hasta el abismo?,¿Reposaremos juntos en el polvo?"
}`)
	CurrentBook.AddChapter(18, `{
"1":"Bildad, de Súaj, tomó la palabra y dijo:"
,"2":"¿Cuándo pondrás fin a tus palabras?,Reflexiona, y déjanos hablar."
,"3":"¿Por qué somos tenidos como bestias,y parecemos brutos a tus ojos?"
,"4":"Tú, que desgarras tu alma con tu ira, ¿por ti la tierra va a quedar desierta, se moverán las rocas de su sitio?"
,"5":"Sin embargo, la luz del malvado ha de apagarse, no más lucirá la llama de su hogar."
,"6":"La luz se oscurecerá bajo su tienda, se extinguirá la candela que le alumbra."
,"7":"Se acortarán sus pasos firmes, su propio plan le hará caer;"
,"8":"sus pies quedarán en la red, porque camina sobre mallas;"
,"9":"un lazo su talón apresará, y el cepo se cerrará sobre él."
,"10":"Oculto en el suelo hay para él un nudo, una trampa le espera en el sendero."
,"11":"Por todas partes temores le acometen, y le siguen pisando sus talones."
,"12":"Su vigor se convierte en flaqueza, la desgracia se ciñe a su costado."
,"13":"El mal su piel devora, el primogénito de la muerte consumirá sus miembros."
,"14":"Será arrancado de su tienda, le arrastrarán hasta el rey de los terrores."
,"15":"Se instalará en su tienda Belial, se esparcirá azufre en su morada."
,"16":"Por debajo se secarán sus raíces, por arriba se marchitará su ramaje."
,"17":"Se perderá su recuerdo en el país, y fuera se borrará su nombre."
,"18":"Será arrojado de la luz a las tinieblas, será expulsado del mundo."
,"19":"No tendrá prole ni posteridad en el pueblo, ningún superviviente en sus moradas."
,"20":"De su fin se asombrará el occidente, y el oriente será presa del terror."
,"21":"Tal se hará de las casas del malvado, de la morada del que no conoce a Dios."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Job, respondió:"
,"2":"¿Hasta cuándo atormentaréis el alma mía,y con palabras me acribillaréis?"
,"3":"Ya me habéis insultado por diez veces, me habéis maltratado con descaro."
,"4":"Aunque en realidad hubiera yo faltado, sobre mí recaería mi error."
,"5":"Si de verdad pensáis triunfar de mí,imputándome mi oprobio,"
,"6":"sabed que es Dios quien me ha oprimido, el que en su red me ha apresado."
,"7":"Si grito: ¡Injuria!, no hay respuesta; pido ayuda, pero no hay justicia."
,"8":"Él me ha cerrado el camino y no puedo pasar, ha cubierto mis senderos de tinieblas."
,"9":"De mi honor me ha despojado, ha quitado la diadema de mi frente."
,"10":"Por todas partes me ha minado, y me desplomo, ha arrancado como un árbol mi esperanza."
,"11":"Ha inflado su ira contra mí, me considera su enemigo."
,"12":"En bloque sus tropas han llegado, su marcha de asalto han abierto contra mí, han puesto sitio a mi tienda."
,"13":"Mis hermanos se mantienen alejados de mí, mis amigos procuran evitarme."
,"14":"Mis parientes y deudos me han abandonado, me han olvidado las gentes de mi casa;"
,"15":"mis criados me tienen como extraño, un forastero soy ante sus ojos."
,"16":"Llamo a mi criado y no responde, con mi propia boca he de suplicarle."
,"17":"Mi aliento repele a mi mujer, fétido soy para los hijos de mis entrañas."
,"18":"Hasta los chiquillos me desprecian; si me levanto, me hacen burla."
,"19":"Tienen horror de mí todos mis íntimos, los que yo amaba se han vuelto contra mí."
,"20":"A mi piel y a mi carne se han pegado mis huesos, tan sólo escapo con la piel de mis dientes."
,"21":"¡Piedad, piedad de mí, vosotros, mis amigos, pues es la mano de Dios la que me ha herido!"
,"22":"¿Por qué me acosáis como me acosa Dios, y no os sentís aún hartos de mi carne?"
,"23":"¡Oh, si se escribieran mis palabras, si se grabaran en bronce,"
,"24":"o con punzón de hierro o estilete,para siempre en la roca se esculpieran!"
,"25":"Mas bien sé que mi defensor está vivo,y que él, el último, sobre el polvo se alzará;"
,"26":"y luego, de mi piel de nuevo revestido, desde mi carne a Dios tengo que ver."
,"27":"Aquel a quien veré ha de ser mío, no a un extraño contemplarán mis ojos; ¡y en mi interior se consumen mis entrañas!..."
,"28":"Y vosotros me decís: '¿Cómo le abatiremos?,¿Qué pretexto hallaremos contra él?'."
,"29":"Temed la espada por vosotros mismos; pues vengadora de culpas es la espada, y sabréis que hay al fin justicia."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Sofar, de Naamán, tomó la palabra y dijo:"
,"2":"Mis pensamientos me están dictando la respuesta; por eso hay en mí esta agitación."
,"3":"Una injuriosa corrección he escuchado, mas mi espíritu la réplica me inspira."
,"4":"¿No sabes tú que desde antiguo, desde que el hombre fue puesto en la tierra,"
,"5":"es breve la alegría del malvado, su gozo es sólo de un instante?"
,"6":"Aunque su altura se alzara hasta los cielos,y las nubes tocaran su cabeza,"
,"7":"como su estiércol se perderá para siempre, y los que lo veían dirán: '¿Dónde está?'."
,"8":"Volará como un sueño inaprensible, se esfumará como visión nocturna."
,"9":"El ojo que lo veía no volverá a mirarlo, ni volverá a divisarlo su morada."
,"10":"Sus hijos acabarán miserables, sus manos tendrán que devolver sus riquezas."
,"11":"Sus huesos, que rebosaban de vigor juvenil, yacerán con él en el polvo."
,"12":"Si era dulce el mal a su boca, si bajo su lengua lo escondía,"
,"13":"si allí lo guardaba sin tragarlo,y en medio del paladar lo retenía,"
,"14":"este alimento se cambiará en sus entrañas, se le dará en su interior veneno de áspid."
,"15":"Engulló riquezas: las vomitará; Dios se las arrancará de sus entrañas."
,"16":"Veneno de áspides chupó: lengua de víbora le mata."
,"17":"No verá más correr arroyos de aceite, ni torrentes de miel y de cuajada."
,"18":"El lucro de su afán no gozará, no comerá ese fruto que hacía sus delicias."
,"19":"Pues estrujó, desamparó a los pobres,y robó casas que no había construido."
,"20":"Porque su vientre no conoció reposo, con sus tesoros no se salvará."
,"21":"Porque a su voracidad nada escapó, no ha de durar su dicha."
,"22":"En el colmo de su abundancia le alcanzará la angustia, toda clase de desgracias caerá sobre él."
,"23":"Mientras su vientre está llenando, desfogará Dios contra él el ardor de su ira, hará llover sobre su carne sus saetas."
,"24":"Si escapa al arma de hierro, el arco de bronce le traspasará."
,"25":"Un dardo sale por su espalda, una punta reluciente por su hígado, los terrores en bloque caen sobre él,"
,"26":"todas las tinieblas le esperan en secreto. Un fuego no encendido por hombre devora,y consume cuanto aún queda en su tienda."
,"27":"Desvelan los cielos su delito,y la tierra se levanta contra él."
,"28":"Desaparecerá el producto de su casa,arrastrado en el día de la ira."
,"29":"Tal es la suerte que al malvado Dios reserva, la herencia que le adjudica Dios."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Job respondió:"
,"2":"Escuchad, escuchad mi palabra, sea éste al menos el consuelo que me dais."
,"3":"Permitid que yo hable; después que hable, os podéis burlar."
,"4":"¿Acaso me quejo yo de un hombre,o pierdo la paciencia sin motivo?"
,"5":"Miradme bien: quedaréis aterrados,y pondréis la mano en vuestra boca."
,"6":"Cuando pienso en ello me estremezco, un escalofrío toda mi carne recorre."
,"7":"¿Por qué viven los malvados, envejecen y sigue su vigor?"
,"8":"Su estirpe prospera en torno a ellos,y sus vástagos crecen a su vista."
,"9":"En paz sus casas, nada temen; la vara de Dios no les alcanza."
,"10":"Su toro fecunda a la primera, su vaca pare y nunca aborta."
,"11":"Dan suelta a sus niños como ovejas, sus hijos brincan retozones."
,"12":"Cantan con tímpanos y cítaras, al son de la flauta se divierten."
,"13":"Sus días transcurren felizmente, y en paz descienden al abismo."
,"14":"Y eso que a Dios decían: '¡Lejos de nosotros; no queremos conocer tus caminos!"
,"15":"¿Quién es el todopoderoso para que le sirvamos?,¿Qué ganamos con invocarle?'."
,"16":"¿No está en sus propias manos su ventura, y el consejo de los malvados no está lejos de Dios?"
,"17":"¿Cuántas veces se apaga la lámpara de los malvados, irrumpe la desgracia sobre ellos,y Dios en su ira desbarata sus bienes,"
,"18":"o el viento se los lleva como paja, o el torbellino los traga como tamo?"
,"19":"¿Dios reserva a sus hijos su castigo?,¡Páguelo él mismo, para que se dé cuenta!"
,"20":"¡Que sus propios ojos vean su ruina, que beba la furia del todopoderoso!"
,"21":"¿Qué le importa la suerte de su casa después de él, cuando se haya cumplido la cuenta de sus meses?"
,"22":"¿Puede acaso enseñarse a Dios sabiduría, a aquel que juzga a los seres más excelsos?"
,"23":"Unos mueren en plena dicha, en el colmo de la seguridad y de la paz,"
,"24":"cuando están sus ijares llenos de grosura, bien nutrido el meollo de sus huesos."
,"25":"Y otros mueren con el alma amargada, sin haber gozado de la felicidad."
,"26":"Juntos luego yacen en el polvo, y los gusanos los recubren."
,"27":"Conozco vuestros pensamientos,y las tramas con que tratáis de hundirme."
,"28":"Decís: '¿En qué ha parado la casa del poderoso?,¿En qué la tienda que habitan los malvados?'."
,"29":"¿No habéis preguntado a los viandantes?,¿No conocéis sus testimonios?"
,"30":"El malvado es respetado en el día del desastre, el día de la ira se ve libre."
,"31":"Pues, ¿quién le echa en cara su conducta,y le pide cuenta de sus obras?"
,"32":"Es conducido al cementerio, y en su mausoleo se le vela."
,"33":"Ligeros le son los temores del valle, y en torno suyo desfila todo el mundo, una turba innumerable ante él."
,"34":"¿Para qué, pues, vuestros vanos consuelos?,¡Sólo perfidia hay en vuestras respuestas!"
}`)
	CurrentBook.AddChapter(22, `{
"1":"Elifaz, de Temán, tomó la palabra y dijo:"
,"2":"¿Acaso a Dios puede un hombre ser útil?,No; sólo a sí mismo es útil el sabio."
,"3":"¿Le importa al todopoderoso que tú seas justo; gana algo si tu conducta es íntegra?"
,"4":"¿Te castiga acaso por tu piedad,y entra en juicio contigo?"
,"5":"¿No es, más bien, grande tu maldad?,¿No son incontables tus delitos?"
,"6":"Sin motivo has exigido prendas a tus hermanos, has arrancado a los desnudos sus vestidos,"
,"7":"no has dado de beber al sediento,y al hambriento has negado el pan;"
,"8":"la tierra la ha ocupado el prepotente, tu favorito se ha instalado en ella;"
,"9":"has despachado a las viudas con las manos vacías, y has quebrado los brazos de los huérfanos."
,"10":"Por todo esto te ves rodeado de lazos,y te estremece, repentino, el terror."
,"11":"Tu luz se ha hecho tiniebla y ya no ves, y te anega una avalancha de aguas."
,"12":"¿No está Dios en la cima de los cielos?,¡Mira qué alta es la cumbre de los astros!"
,"13":"Pues tú has dicho: '¿Qué es lo que sabe Dios?,¿Acaso discierne a través del nublado?"
,"14":"Las nubes son un velo que no le dejan ver, y anda por las márgenes del cielo'."
,"15":"¿Quieres, pues, seguir la antigua ruta,por la que caminaron los malvados?"
,"16":"Antes de tiempo fueron aplastados, una inundación arrasó sus cimientos."
,"17":"Decían a Dios: '¡Está lejos de nosotros!,¿Qué puede hacernos el todopoderoso?'."
,"18":"Él les llenaba sus casas de riquezas, pero estaba alejado de sus planes perversos."
,"19":"Los justos ahora ven y se recrean, y de ellos hace burla el inocente:"
,"20":"'¡Cómo han quedado en nada nuestros enemigos!,¡El fuego devora sus riquezas!'."
,"21":"Reconcíliate, pues, con él y haz la paz; así recobrarás tu ventura."
,"22":"Recibe la enseñanza de su boca, pon sus palabras en tu corazón."
,"23":"Si vuelves al todopoderoso y te humillas, si alejas de tu tienda la iniquidad,"
,"24":"si estimas el oro como polvo, como guijarros de torrente el metal de Ofir,"
,"25":"el todopoderoso será tu oro,y plata en abundancia para ti."
,"26":"Tendrás entonces en el todopoderoso tus delicias, y hacia Dios levantarás tu rostro."
,"27":"Le invocarás y él te escuchará, y podrás cumplir tus votos."
,"28":"Te lanzarás a una empresa y tendrás éxito, y en tus sendas brillará la luz."
,"29":"Al humillado podrás decir: '¡Arriba!'; y Dios salvará a quien los ojos baja."
,"30":"Él salva al inocente; tú serás salvo si tus manos son puras."
}`)
	CurrentBook.AddChapter(23, `{
"1":"Job respondió:"
,"2":"Siempre mi queja es una rebelión; su mano pesa sobre mis suspiros."
,"3":"¡Oh, si supiera yo cómo alcanzarle, cómo llegar hasta su trono!"
,"4":"Depondría delante de él mi causa, llenaría mi boca de argumentos."
,"5":"Sabría cuál era su respuesta, comprendería lo que me dijera."
,"6":"¿Acaso con alarde de fuerza disputaría conmigo?,No, sólo tendría que prestarme atención."
,"7":"Vería a un justo en quien con él disputa, y yo sería absuelto para siempre por mi juez."
,"8":"Mas si voy hasta oriente, no está allí; si a occidente, no lo diviso."
,"9":"Lo busco al norte, y no lo encuentro; y no lo veo si me vuelvo al mediodía."
,"10":"Él, sin embargo, conoce mis caminos. Póngame a prueba; saldré como oro puro."
,"11":"A sus pasos se ha adherido mi pie, he seguido sin desviarme su camino."
,"12":"No me he apartado de los preceptos de sus labios, he guardado en mi pecho la palabra de su boca."
,"13":"Pero si él decide, ¿quién le hará retractarse?,Lo que su alma traza, lleva a término."
,"14":"Así cumplirá su designio sobre mí, como tantos otros proyectos que él alberga."
,"15":"Por eso estoy ante su faz horrorizado; y cuanto más lo pienso, más me aterra."
,"16":"Dios me ha debilitado el corazón, el todopoderoso me ha llenado de espanto."
,"17":"Pues de él me esconde la faz de las tinieblas, la oscuridad cubre mi rostro."
}`)
	CurrentBook.AddChapter(24, `{
"1":"¿por qué el todopoderoso no se reserva tiempos, y los que le conocen no contemplan sus días?"
,"2":"Los criminales remueven los linderos, se llevan el rebaño robado."
,"3":"Arrebatan el asno de los huérfanos, toman en prenda al buey de la viuda."
,"4":"Expulsan a los indigentes del camino, todos los pobres del país han de esconderse."
,"5":"Otros, como asnos salvajes en el desierto, salen en busca de comida, del alimento que la estepa les da para sus crías."
,"6":"Espigan en los campos por la noche, vendimian la viña del malvado."
,"7":"Desnudos pasan la noche sin vestido, no tienen manta para el frío."
,"8":"Empapados por el aguacero de las montañas, faltos de cobijo, se pegan a la roca."
,"9":"Arrancan al huérfano del pecho, toman en prenda al lactante del pobre."
,"10":"Desnudos andan, sin vestido; hambrientos, llevando las gavillas."
,"11":"Sin muelas para exprimir el aceite, pisan los lagares y no apagan la sed."
,"12":"Desde la ciudad gimen los moribundos, el alma de los heridos grita, mas Dios no hace caso de sus quejas."
,"13":"Hay otros que reniegan de la luz, que no quieren conocer sus sendas,ni mantenerse en sus senderos."
,"14":"Antes del día se levanta el asesino, mata al mísero y al pobre, y por la noche merodea el ladrón."
,"15":"El ojo del adúltero el crepúsculo espía. Dice: '¡Nadie me verá!', y se pone una máscara en la cara."
,"16":"Por la noche perforan las casas,que de día se habían señalado,los que no quieren saber nada de la luz."
,"17":"Para todos ellos la mañana es sombra espesa, la luz del día les aterra."
,"18":"Marcha veloz al acercarse el día, su dominio es maldito en el país, no sigue ya por el camino de los altos."
,"19":"Como el calor sofocante evapora el agua de nieve, así el abismo arrebata al pecador."
,"20":"El seno que lo engendró se olvida de él, su nombre no se recuerda más; así es arrancada la injusticia como un árbol."
,"21":"Maltrató a la estéril que no tiene hijos, no hizo bien a la viuda."
,"22":"Pero aquel que hace frente con su fuerza a los tiranos surge, y el criminal desespera de la vida."
,"23":"Lo dejaba vivir con apoyo y seguridad, mas sus ojos estaban sobre sus caminos."
,"24":"Se encumbran, y en un instante ya no existen; caen y perecen como todos, son cortados como cresta de espiga."
,"25":"Si no es así, ¿quién me convencerá de mentira,y reducirá a nada mis palabras?"
}`)
	CurrentBook.AddChapter(25, `{
"1":"Bildad, de Súaj, tomó la palabra y dijo:"
,"2":"Imperio soberano tiene aquel que establece la paz en las alturas."
,"3":"¿Tienen sus tropas número?,¿Quién puede esconderse de su luz?"
,"4":"¿Cómo, pues, puede ante Dios ser justo un hombre?,¿Cómo puro el nacido de mujer?"
,"5":"Si hasta la luna está sin brillo, y las estrellas no son puras a sus ojos,"
,"6":"¡cuanto menos el hombre, este gusano, el hijo de hombre, esta larva!"
}`)
	CurrentBook.AddChapter(26, `{
"1":"Job respondió:"
,"2":"¡Oh, cuánta ayuda das al débil, cuánto socorro al de brazo inválido!"
,"3":"¡Qué bien sabes aconsejar al ignorante, qué hábil talento has demostrado!"
,"4":"Pero ¿a quién diriges tus discursos?,¿Quién empieza lo que sale de tu pecho?"
,"5":"Tiemblan los muertos bajo tierra, las aguas y sus habitantes se estremecen."
,"6":"Desnudo está el abismo ante sus ojos,y sin velos el reino de la muerte."
,"7":"Él extiende el septentrión sobre el vacío, sobre la nada suspende la tierra,"
,"8":"encierra las aguas en sus nubes, sin que bajo su peso el nublado reviente."
,"9":"Él cubre la cara de la luna llena,y despliega sobre ella su nube."
,"10":"Traza un cerco a la superficie de las aguas, al límite de la luz y las tinieblas."
,"11":"Las columnas del cielo se estremecen espantadas bajo su amenaza."
,"12":"Con su poder arranca el mar, con su inteligencia quebranta a Rahab."
,"13":"A su soplo el cielo se serena, su mano traspasa a la serpiente huidiza."
,"14":"Y esto no es más que el contorno de sus obras, pues tan sólo captamos un apagado eco. El trueno en su poder, ¿quién lo podrá alcanzar?"
}`)
	CurrentBook.AddChapter(27, `{
"1":"Job continuó su discurso y dijo:"
,"2":"¡Por el Dios vivo, que me ha quitado mi derecho; por el todopoderoso, que me amarga el alma;"
,"3":"mientras mi aliento siga en mí,y el soplo de Dios en mis narices,"
,"4":"mis labios no dirán falsedades,ni mi lengua proferirá mentira!"
,"5":"Lejos de daros la razón, hasta la muerte mantendré mi inocencia."
,"6":"Me aferraré a mi justicia y no la soltaré; mi corazón no tendrá que avergonzarse de mis días."
,"7":"¡Tenga mi enemigo la suerte del malvado, la del inicuo mi adversario!"
,"8":"¿Qué esperanza tiene el malvado cuando suplica, cuando hacia Dios levanta su alma?"
,"9":"¿Escuchará acaso Dios su grito,cuando sobre él se abate la desgracia?"
,"10":"¿Tenía él sus delicias en el todopoderoso?,¿Invocaba a Dios en todo instante?"
,"11":"Os mostraré a todos lo que hay en la mano de Dios, lo que el todopoderoso se reserva no os ocultaré."
,"12":"Y si todos vosotros lo observáis, ¿para qué esos vanos discursos en el vacío?"
,"13":"Ésta es la suerte que al criminal reserva Dios, la herencia que el violento recibe del todopoderoso:"
,"14":"Por muchos que sean sus hijos, la espada es su destino, y sus vástagos no tendrán paz."
,"15":"A los supervivientes sepultará la peste, y sus viudas no los llorarán."
,"16":"Si acumula como polvo la plata, si amontona vestidos como fango,"
,"17":"¡que los amontone!; el justo se vestirá con ellos,y el inocente heredará la plata."
,"18":"Se ha edificado una casa de araña, una choza de centinela ha construido."
,"19":"Rico se acuesta, mas por última vez; cuando abre los ojos ya no es nada."
,"20":"Lo asaltan como torrente los terrores, de noche lo arrebata el huracán."
,"21":"El viento del este se levanta y se lo lleva, un torbellino le arrastra de su sitio."
,"22":"Sin piedad por blanco se le toma, tiene que huir de las manos que amenazan."
,"23":"A su ruina la gente bate palmas, de todas partes se le silba."
}`)
	CurrentBook.AddChapter(28, `{
"1":"Hay para la plata un venero, y para el oro un lugar donde se purifica."
,"2":"Se extrae del suelo el hierro, de la piedra fundida sale el cobre."
,"3":"Un límite pone el hombre a las tinieblas, y excava hasta la hondura más recóndita,la piedra que está en la oscuridad y la negrura."
,"4":"Abren los mineros una galería lejos del poblado; cuelgan sin apoyo en sus pies, y oscilan lejos de los hombres."
,"5":"La tierra de donde sale el pan,está revuelta en sus entrañas por el fuego."
,"6":"Allí las piedras albergan el zafiro, que contiene partículas de oro."
,"7":"El ave de rapiña no conoce el camino,ni el ojo del buitre lo divisa;"
,"8":"no lo pisan las bestias feroces,ni lo atraviesa jamás el león."
,"9":"Al pedernal lleva el hombre su mano, descuaja de raíz las montañas."
,"10":"En las rocas abre galerías, su ojo busca todo lo precioso."
,"11":"Explora las fuentes de los ríos,y saca a luz lo que estaba escondido."
,"12":"Mas la sabiduría, ¿de dónde viene?,¿Cuál es el lugar de la inteligencia?"
,"13":"Ignora el hombre su camino, ni se le encuentra en la tierra de los vivos."
,"14":"Dice el abismo: 'No está en mí', y el mar: 'No está conmigo'."
,"15":"Con oro fino no se compra, ni se paga a precio de plata;"
,"16":"no se valora con el oro de Ofir, el ágata preciosa o el zafiro."
,"17":"No se le compara el oro y el cristal, ni se cambia por vasija de oro fino."
,"18":"Corales y cristal no merecen mi mención, la sabiduría vale más que las perlas."
,"19":"Nada vale a su lado el topacio de Etiopía, no se valora con el oro más puro."
,"20":"Mas la sabiduría, ¿de dónde viene?,¿Cuál es el lugar de la inteligencia?"
,"21":"Oculta está a los ojos de todos los vivientes, escondida a los pájaros del cielo."
,"22":"El infierno y la muerte confiesan: 'Con nuestros oídos oímos hablar de ella'."
,"23":"Sólo Dios conoce su camino, sólo él sabe dónde se halla,"
,"24":"porque él ve los extremos del mundo,y advierte cuanto hay bajo los cielos."
,"25":"Cuando estableció el peso del viento,y fijó a las aguas su medida;"
,"26":"cuando a la lluvia dio una ley,y un camino al relámpago y al trueno,"
,"27":"entonces la vio y la sacó a la luz, la escrutó hasta el fondo."
,"28":"Y dijo al hombre: 'Temer al Señor es la sabiduría; huir del mal, he ahí la inteligencia'."
}`)
	CurrentBook.AddChapter(29, `{
"1":"Job continuó pronunciando su discurso:"
,"2":"¡Quién me volviera a los meses de antaño, a los días en que Dios me protegía,"
,"3":"cuando su lámpara brillaba sobre mi cabeza,y a su luz caminaba en las tinieblas!"
,"4":"Como era en los días de mi otoño, cuando Dios protegía mi tienda;"
,"5":"cuando el todopoderoso estaba aún conmigo, y me rodeaban mis muchachos;"
,"6":"cuando empapaba mis pies en cuajada,y regatos de aceite la roca me vertía."
,"7":"Cuando entonces salía a la puerta de la ciudad,y mi asiento en la plaza colocaba,"
,"8":"se retiraban los jóvenes al verme, y los viejos se levantaban y quedaban en pie;"
,"9":"los notables suspendían sus palabras,y su mano ponían en la boca;"
,"10":"la voz de los jefes se apagaba,y su lengua se pegaba al paladar."
,"11":"Oído que me oía me llamaba feliz, ojo que me veía favor me dispensaba,"
,"12":"pues yo libraba al pobre que gemía, al huérfano que no tenía apoyo."
,"13":"La bendición del desgraciado caía sobre mí, y hacía exultar el corazón de la viuda."
,"14":"De justicia me había vestido y ella me cubría, la justicia era mi manto y mi turbante."
,"15":"Era yo los ojos para el ciego, para el cojo los pies;"
,"16":"era el padre de los pobres, la causa del desconocido examinaba;"
,"17":"trituraba las muelas del malvado, de entre sus dientes arrancaba la presa."
,"18":"Y me decía: 'En mi nido moriré, cargado de días, igual que la palmera."
,"19":"Mi raíz se alarga hacia las aguas, el rocío posa la noche en mi ramaje;"
,"20":"mi gloria estará siempre flamante,y en mi mano mi arco renovará su fuerza'."
,"21":"Todos me escuchaban muy atentos, en silencio, para oír mi consejo."
,"22":"A mis sentencias nadie replicaba, y sobre ellos destilaban mis palabras."
,"23":"Me esperaban como se espera la lluvia, y abrían su boca como el agua tardía."
,"24":"Si yo les sonreía, no querían creerlo; con ansia acogían el favor de mi rostro."
,"25":"Puesto en cabeza les trazaba el camino, como un rey me sentaba en medio de sus tropas; como un consolador de abatidos."
}`)
	CurrentBook.AddChapter(30, `{
"1":"Pero ahora hacen burla de mí,los que son más jóvenes que yo, cuyos padres yo no me dignaba mezclar,con los perros de mi ganado."
,"2":"Ni la fuerza de sus manos me hubiera servido. Habían perdido todo su vigor,"
,"3":"extenuados por el hambre y la miseria. Tenían que buscar la hierba seca del desierto; su madre era la desolación."
,"4":"Recogían el armuelle junto al matorral, raíces de retama era su pan."
,"5":"De en medio del pueblo eran expulsados, ahuyentados a gritos como los ladrones;"
,"6":"habitaban en los declives de los torrentes, en las cuevas y en las grietas de las peñas."
,"7":"Entre los matorrales rebuznaban, se acurrucaban bajo los espinos."
,"8":"¡Gente vil, gente innominada, expulsada de su tierra!"
,"9":"¡Y ahora vengo yo a ser la copla de ésos, el blanco de sus chismes!"
,"10":"Espantados, se mantienen a distancia; sin reparo a la cara me escupen."
,"11":"Su cuerda han aflojado y me oprimen, han roto todo freno ante mí."
,"12":"Se alza la canalla a mi derecha, persiguiendo mis pasos, preparan contra mí sus caminos siniestros."
,"13":"Mis senderos destrozan, mi ruina intentan y nada los detiene."
,"14":"Como por ancha brecha irrumpen, avanzan por entre los escombros."
,"15":"Los terrores me asaltan, como por un huracán queda barrido mi valor."
,"16":"Y ahora se derrama en mí mi alma, me han caído días de aflicción."
,"17":"De noche perfora el mal mis huesos, no descansan las llagas que me roen."
,"18":"Con violencia ha agarrado Dios mi manto, me ha aferrado como el cuello de mi túnica."
,"19":"Me ha tirado en el fango, soy como el polvo y la ceniza."
,"20":"Grito hacia ti y tú no me respondes, insisto y no me haces caso."
,"21":"Te has vuelto cruel para conmigo, con mano desplegada en mí te cebas."
,"22":"Me levantas a merced del viento, me desbaratas con la tempestad."
,"23":"¡Bien sé que a la muerte me conduces, al sitio de cita de todos los vivientes!"
,"24":"Y, con todo, ¿he vuelto yo la mano contra el pobre,cuando en su angustia clemencia suspiraba?"
,"25":"¿No he llorado con el que sufre días duros?,¿No he sentido piedad por el mendigo?"
,"26":"Esperaba el bien y vino el mal, aguardaba la luz y he aquí la oscuridad."
,"27":"Me hierven las entrañas sin descanso, ¡me han tocado días de aflicción!"
,"28":"Ando sombrío, sin recibir consuelo; me alzo entre la turba sólo para gritar."
,"29":"Me he hecho hermano de chacales,y compañero de avestruces."
,"30":"Mi piel ennegrecida se me salta, mis huesos queman por la fiebre."
,"31":"¡Mi arpa ha acompañado a los cantos de duelo, mi flauta a la voz de plañidores!"
}`)
	CurrentBook.AddChapter(31, `{
"1":"Un pacto había hecho con mis ojos,de no fijarme en ninguna doncella."
,"2":"¿Qué reparto hace Dios desde arriba?,¿Qué suerte asigna el todopoderoso desde su altura?"
,"3":"¿No es para el injusto la desgracia, y la desventura para los agentes de maldad?"
,"4":"¿No ve él acaso mis caminos,y no cuenta todos mis pasos?"
,"5":"Si he caminado con mentira, si mi pie corrió hacia la falsedad,"
,"6":"¡péseme él en balanza de justicia; reconocerá Dios mi integridad!"
,"7":"Si del camino recto se apartaron mis pasos, si mi corazón corrió tras de mis ojos,y a mis manos se pegó mancha alguna,"
,"8":"¡lo que yo siembre, otro lo coma, y sean arrancados mis retoños!"
,"9":"Si mi corazón fue seducido por mujer, si aceché a la puerta de mi prójimo,"
,"10":"¡muela para otros mi mujer,y otros se encorven sobre ella!"
,"11":"Pues una infamia hubiera sido, un crimen condenable por los jueces,"
,"12":"un fuego que devora hasta la perdición,y que habría consumido todas mis cosechas."
,"13":"Si desprecié el derecho de mi siervo,o de mi sierva en sus pleitos conmigo,"
,"14":"¿qué podría hacer cuando surgiese Dios?; cuando juzgara, ¿qué le respondería?"
,"15":"¿No los formó él, igual que a mí, en el vientre?,¿No nos plasmó uno mismo en el seno?"
,"16":"¿Fui insensible al menester del pobre?,¿Dejé desfallecer los ojos de la viuda?"
,"17":"¿Comí solo mi bocado?,¿No lo compartí con el huérfano?"
,"18":"¡Pues Dios, desde mi infancia, me crió como un padre, y desde el seno materno me guió!"
,"19":"Si vi a un indigente sin vestido, a algún pobre desnudo,"
,"20":"¿no me bendijeron sus riñones?, ¿no se calentó con el vellón de mis corderos?"
,"21":"Si contra un inocente alcé mi mano,por sentirme respaldado en la puerta,"
,"22":"¡mi espalda se separe de mi nuca,y mi brazo se desgaje del hombro!"
,"23":"Porque el terror de Dios me invadiría,y ante su majestad no podría resistir."
,"24":"¿Puse en el oro mi confianza,o dije al oro fino: 'Tú, mi seguridad'?"
,"25":"¿Me complací en la abundancia de mis bienes,porque mi mano había ganado mucho?"
,"26":"Al ver el sol brillante,y la luna que avanzaba esplendorosa,"
,"27":"¿mi corazón fue seducido en secreto?, ¿les mandé un beso con mi mano?"
,"28":"También esto hubiera sido un crimen capital, porque habría renegado del Dios supremo."
,"29":"¿Me alegré del infortunio de mi enemigo?,¿Me gocé cuando el mal le abatía?"
,"30":"¡Yo, que no permitía que mi boca pecase,deseándole la muerte con imprecaciones!"
,"31":"¿No decían las gentes de mi tienda: 'Quién no ha quedado saciado en su mesa'?"
,"32":"Jamás el forastero pasó la noche fuera, mi puerta se abría siempre al viajero."
,"33":"¿He ocultado mis faltas como un hombre, he escondido en mi seno mi pecado,"
,"34":"porque temiese el rumor de las gentes,o el desprecio de las familias me espantase, hasta quedar callado, sin salir de mi puerta?"
,"38":"Si mi tierra gritó venganza contra mí,y sus surcos lloraron juntamente;"
,"39":"si comí sus frutos sin haberlos pagado,o estrujé el alma de sus dueños,"
,"40":"¡en vez de grano broten en ella espinas, y en lugar de cebada, hierba hedionda!"
,"35":"¡Oh, si tuviese yo quien me escuchara!,¡Ésta es mi firma! ¡El todopoderoso me responda!,El libelo que escribiese mi adversario"
,"36":"lo llevaría sobre mis espaldas, lo ceñiría igual que una corona."
,"37":"De todos mis pasos le daría cuenta, me acercaría a él igual que un príncipe."
,"40":"Fin de las palabras de Job."
}`)
	CurrentBook.AddChapter(32, `{
"1":"Aquellos tres hombres dejaron de replicar a Job, porque se tenía por justo."
,"2":"Se encendió entonces la ira de Elihú, hijo de Baraquel, el buzita, de la familia de Ram. Su ira se encendió contra Job porque pretendía tener razón frente a Dios."
,"3":"Se encendió también su ira contra los tres amigos, porque no habían encontrado ya respuesta alguna, y así habían imputado el mal a Dios."
,"4":"Elihú había esperado mientras ellos hablaban, porque eran mayores que él."
,"5":"Pero cuando Elihú vio que no había ya respuesta en la boca de los tres hombres, su ira se encendió."
,"6":"Tomó, pues, la palabra Elihú, hijo de Baraquel, el buzita, y dijo: Joven de años soy, y vosotros estáis cargados de ellos; por eso no me atrevía, intimidado, a manifestar mi parecer."
,"7":"Pensaba: 'La edad sabrá hablar, los muchos años darán sabiduría'."
,"8":"Mas es un espíritu en el hombre, un soplo del todopoderoso lo que da inteligencia."
,"9":"No los cargados de años son por ello sabios, ni por ancianos comprenden lo que es justo."
,"10":"Por eso digo: escuchadme; manifestaré mi saber también yo."
,"11":"Hasta ahora vuestras palabras he esperado, he prestado oído a vuestros argumentos, y mientras buscabais las razones"
,"12":"he fijado en vosotros mi atención. Mas veo que nadie ha confundido a Job, ninguno de vosotros ha refutado sus palabras."
,"13":"No digáis, pues: 'Hemos hallado la sabiduría; es Dios, no un hombre quien nos adoctrina'."
,"14":"No diré yo palabras como ésas, no he de replicar en vuestros términos."
,"15":"Han quedado perplejos, sin respuesta, han llegado a faltarles las palabras."
,"16":"He esperado; mas puesto que ya no hablan, porque se quedan sin respuesta,"
,"17":"responderé yo a mi vez, manifestaré también yo mi saber."
,"18":"Pues estoy lleno de palabras, un espíritu dentro me estimula."
,"19":"Es en mi interior cual vino aprisionado,que hace reventar los odres nuevos."
,"20":"Hablaré, pues, para desahogarme, abriré los labios y responderé."
,"21":"No tomaré partido por ninguno, a nadie adularé,"
,"22":"pues yo no sé adular; ¡de un tajo me quitaría del medio mi hacedor!"
}`)
	CurrentBook.AddChapter(33, `{
"1":"Escucha, pues, mis razones, oh Job, y presta oído a mis palabras."
,"2":"He aquí que yo abro mi boca, en el paladar habla mi lengua."
,"3":"Mis palabras salen de un corazón íntegro, mis labios dirán la verdad pura."
,"4":"Me ha hecho el espíritu de Dios, el soplo del todopoderoso me da vida."
,"5":"Respóndeme, si puedes; ¡en guardia, disponte a tu defensa!"
,"6":"Mira, igual que tú soy ante Dios, también yo fui plasmado de la arcilla."
,"7":"Por eso mi terror no te debe espantar, ni pesará mi mano sobre ti."
,"8":"Así has dicho a mis propios oídos,-pues he escuchado el rumor de tus palabras-:"
,"9":"'Puro soy yo, sin pecado; íntegro soy, no hay culpa en mí."
,"10":"Pero él encuentra contra mí pretextos,y me tiene como su enemigo,"
,"11":"mete en cepos mis pies,y vigila todas mis pisadas'."
,"12":"Pues -te respondo- en esto te equivocas, ya que Dios es muy superior al hombre."
,"13":"¿Por qué quieres pleitear con él,porque no responde a todas tus palabras?"
,"14":"Dios habla una vez, y dos no lo repite."
,"15":"En sueños, en visiones nocturnas, cuando un letargo a los hombres,invade reclinados en su lecho,"
,"16":"entonces abre él el oído del hombre, y con apariciones le estremece;"
,"17":"para apartar al hombre de sus obras,y corregir su orgullo,"
,"18":"y así librar su alma de la fosa, y su vida del pasaje subterráneo."
,"19":"O bien le corrige por el dolor en su lecho, por el temblor continuo de sus huesos;"
,"20":"cuando le produce náuseas la comida, y su alma aborrece el manjar más exquisito;"
,"21":"cuando se consume su carne a ojos vista, y sus huesos aparecen desnudos;"
,"22":"cuando su alma se aproxima a la fosa, y su vida hacia los muertos."
,"23":"Mas si hay entonces junto a él un ángel, un mediador, uno entre mil, que enseñe al hombre su deber,"
,"24":"que tenga compasión de él,y diga: '¡Líbrale de bajar a la fosa, pues he encontrado el rescate de su alma!':"
,"25":"entonces su carne recobra un vigor de juventud, vuelve a los días de su adolescencia;"
,"26":"ruega a Dios, quien le alarga su favor, viene a ver con alegría su rostro, anuncia a los demás su justificación,"
,"27":"y ante los hombres canta así: 'Yo había pecado y violado la justicia, mas Dios no me ha tratado conforme a mi delito;"
,"28":"ha librado mi alma de la fosa,y mi vida vuelve a ver la luz'."
,"29":"Esto es todo lo que hace Dios, dos y tres veces con el hombre,"
,"30":"con el fin de arrancar su alma de la fosa,e iluminarla con la luz de los vivientes."
,"31":"Atiende, Job, escúchame, calla hasta que yo haya terminado de hablar."
,"32":"Mas si tienes algo que decir, habla, pues yo deseo darte la razón."
,"33":"Si no tienes nada, escúchame; calla, y yo te enseñaré la sabiduría."
}`)
	CurrentBook.AddChapter(34, `{
"1":"Elihú reanudó su discurso y dijo:"
,"2":"Vosotros, los sabios, escuchad mis palabras; vosotros, los doctos, prestadme oídos,"
,"3":"porque el oído discierne las palabras,como el paladar saborea los manjares."
,"4":"Debemos ponderar bien lo que es justo, examinar entre nosotros lo que es bueno."
,"5":"Job ha dicho: 'Yo soy justo, pero Dios me ha quitado mi derecho."
,"6":"Contra mi derecho estoy sufriendo; mi llaga es mortal, aunque yo no he pecado'."
,"7":"¿Qué hombre hay como Job, que bebe el sarcasmo como agua,"
,"8":"que anda en compañía de malvados,y camina con hombres criminales?"
,"9":"¿No ha dicho él: 'Nada aprovecha al hombre el buscar el agrado de Dios'?"
,"10":"Por eso, escuchadme, hombres sensatos. ¡Lejos está de Dios la iniquidad, lejos del todopoderoso la injusticia!"
,"11":"Pues él paga al hombre con arreglo a sus obras, retribuye a cada cual conforme a su conducta."
,"12":"No, Dios no hace nunca el mal, el todopoderoso no retuerce el derecho."
,"13":"¿Quién le ha dado el gobierno de la tierra?,¿Quién confió a su cuidado el universo?"
,"14":"Si él retirara hacia sí su soplo, si retrajera a sí su aliento,"
,"15":"al instante perecería toda carne,y el hombre al polvo volvería."
,"16":"Si tienes inteligencia, escucha esto; presta oídos al son de mis palabras."
,"17":"¿Puede acaso gobernar el que odia el derecho?,¿Al justo, al poderoso, vas a condenar?"
,"18":"A aquel que dice al rey: '¡Infame!'; '¡Criminales!' a los príncipes."
,"19":"Que no hace acepción de prepotentes,ni considera al rico más que al pobre, porque son todos obra de sus manos."
,"20":"En un instante mueren en medio de la noche, hiere él a los grandes y desaparecen, y depone al poderoso sin esfuerzo."
,"21":"Pues sus ojos vigilan los caminos del hombre, todos sus pasos observa."
,"22":"No hay tiniebla ni sombra mortal,donde esconderse puedan los que obran la maldad."
,"23":"Pues no puso él un plazo al hombre,para presentarse a juicio ante Dios."
,"24":"Aplasta a los grandes sin previa indagación,y pone a otros en su sitio."
,"25":"Y puesto que conoce sus acciones, de noche los derriba y son pisoteados."
,"26":"Por su crueldad los hiere, en lugar visible los castiga,"
,"27":"por haberse apartado de su seguimiento, sin querer conocer todos sus caminos,"
,"28":"hasta hacer llegar a él el lamento del mísero,y hacerle oír el grito de los desgraciados."
,"29":"Si él sigue inmóvil, ¿quién puede conmoverle?,Si retira su rostro, ¿quién puede percibirle?,Pero aún sigue vigilando sobre naciones e individuos,"
,"30":"para que no dominen los criminales, los que al pueblo encadenan."
,"31":"Si alguien dice a Dios: 'He sido seducido, no volveré a obrar mal;"
,"32":"si he pecado, instrúyeme; si he cometido injusticias, no volveré a hacerlo';"
,"33":"¿acaso, a juicio tuyo, tendría él que castigar?,Como has rechazado su sentencia, como eres tú el que aprecias, que no yo, ¡di todo lo que sabes!"
,"34":"Los hombres cuerdos me dirán, así como todo sabio que me escuche:"
,"35":"'No habla Job con criterio, les falta cordura a sus palabras."
,"36":"Job, pues, será probado a fondo,por sus respuestas dignas de un malvado;"
,"37":"pues a su pecado añade rebeldía; contra nosotros bate palmas,y multiplica sus palabras contra Dios'."
}`)
	CurrentBook.AddChapter(35, `{
"1":"Elihú continuó hablando y dijo:"
,"2":"¿Crees tal vez que afianzas tu derecho, que ante Dios afirmas tu justicia,"
,"3":"cuando dices: '¿Qué te importa?,¿Qué te hago a ti si peco?'."
,"4":"Yo te daré respuesta, y al mismo tiempo a tus amigos."
,"5":"Mira a los cielos y contempla, observa las nubes: ¡cuánto más altas son que tú!"
,"6":"Si pecas, ¿qué le haces?,Si multiplicas tus delitos, ¿en qué perjudicas?"
,"7":"Si eres justo, ¿qué le das con ello?,¿Qué recibe él de tu mano?"
,"8":"A un hombre igual que tú afecta tu maldad, a un hijo de hombre tu justicia."
,"9":"Por la abundancia de opresión se gime, contra el brazo de los grandes se pide auxilio."
,"10":"Mas no se dice: '¿Dónde está Dios mi hacedor, aquel que inspira cantos de júbilo en la noche,"
,"11":"el que nos hace más diestros,que las bestias de la tierra, más sabios que los pájaros del cielo?'."
,"12":"Entonces se grita, pero él no responde a causa del orgullo de los malos."
,"13":"Pero es vano decir que Dios no oye, que el todopoderoso de nada se da cuenta."
,"14":"Mas tú dices que Dios no oye, que una causa está ante él, y esperas siempre;"
,"15":"o bien que su ira no castiga, que no se cuida para nada de la iniquidad."
,"16":"Job, pues, abre inútilmente la boca,y sin conocimiento multiplica las palabras."
}`)
	CurrentBook.AddChapter(36, `{
"1":"Elihú prosiguió diciendo:"
,"2":"Espera un poco más, y yo te instruiré, pues todavía tengo razones en defensa de Dios."
,"3":"Traeré de muy lejos mi saber, y a mi hacedor daré razón."
,"4":"Pues, en verdad, no son mentira mis palabras, a un hombre de perfecto saber tienes delante."
,"5":"No, Dios no rechaza al hombre justo, en pleno vigor "
,"6":"no deja vivir al hombre injusto; hace a los míseros justicia,"
,"7":"y no quita a los justos su derecho. Pone a los reyes en el trono, los asienta por siempre; pero, si se engríen,"
,"8":"los ataca entonces con cadenas,y los prende en los lazos de la angustia."
,"9":"Luego les descubre sus acciones, las faltas de orgullo cometidas,"
,"10":"abre sus oídos a la reprensión, y les exhorta a apartarse del mal."
,"11":"Si escuchan y se someten, acaban sus días en ventura, y en delicias sus años."
,"12":"Si no escuchan, un golpe los abate,y mueren sin contarlo."
,"13":"Sí; los malvados de corazón, que se entregan a la ira,y no imploran ayuda cuando él los encadena,"
,"14":"mueren en plena juventud, y su vida termina como la de los disolutos."
,"15":"Mas él salva al miserable mediante la aflicción, le abre el oído por medio de la tribulación."
,"16":"A ti también te arrancará,de las fauces de la angustia, en lugar amplio te pondrá sin estrecheces, y de tu mesa desbordará la grasa."
,"17":"Pero si traspasas la medida del malvado, te aferrarán juicio y sentencia."
,"18":"Cuida de que el desdén no te conduzca al insulto, y la grandeza no te haga desviarte."
,"19":"¿Podrá librarte entonces de la angustia tu grito,y todos tus esfuerzos incesantes?"
,"20":"No andes esperando a la noche, cuando la gente sube a su lugar."
,"21":"Guárdate de inclinarte a la injusticia, pues por ella te ha probado la desgracia."
,"22":"Mira, Dios es sublime en su potencia, ¿quién es Señor como él?"
,"23":"¿Quién puede señalarle el camino a seguir,o se atreverá a decirle: 'Has hecho mal'?"
,"24":"Acuérdate de exaltar la obra suya, que con himnos han celebrado los hombres."
,"25":"Todo mortal la admira, de lejos el hombre la contempla."
,"26":"Sí; tan grande es Dios que no le comprendemos, incontable es la suma de sus años."
,"27":"Él absorbe las gotas de agua,y condensa en neblina su vapor."
,"28":"Las nubes luego la derraman, la llueven sobre los hombres a raudales."
,"29":"Por ellas sustenta él a los pueblos, les da alimentos en abundancia."
,"30":"¿Quién puede comprender el despliegue de las nubes, los fragores de su tienda?"
,"31":"Él despliega en torno a sí la nube,y cubre la cima de los montes."
,"32":"Llena sus manos de relámpagos,y les ordena herir."
,"33":"El trueno anuncia su furor, la tempestad su cólera pregona."
}`)
	CurrentBook.AddChapter(37, `{
"1":"Por eso tiembla mi corazón,y salta fuera de su sitio."
,"2":"Escuchad, escuchad el fragor de su voz, el bramido que sale de su boca."
,"3":"Su relámpago cruza todo el cielo,y llega hasta el fin de la tierra."
,"4":"Detrás de él ruge su voz, porque Dios truena con su voz soberbia, y nada puede retener sus rayos cuando su voz retumba."
,"5":"Sí; nos manifiesta Dios sus maravillas, cosas grandiosas que no comprendemos."
,"6":"Cuando dice a la nieve: 'Cae sobre la tierra', y a las lluvias: 'Caed a torrentes',"
,"7":"las manos del hombre quedan entonces inactivas, para que todos reconozcan su obra."
,"8":"Los animales huyen a sus guaridas, en sus cubiles se refugian."
,"9":"Del mediodía viene el huracán, y el frío de los vientos del norte."
,"10":"Al soplo de Dios se forma el hielo, se congela la superficie de las aguas."
,"11":"Él carga de vapor las nubes, y el nubarrón esparce sus relámpagos,"
,"12":"y éstos, dando vueltas, van circulando conforme a sus designios, ejecutando todo lo que él manda,sobre el haz del orbe terráqueo."
,"13":"Ya como castigo y maldición, ya como señal de bondad, él los envía."
,"14":"Escucha esto, Job; detente y considera los prodigios de Dios."
,"15":"¿Sabes acaso cómo Dios los dispone,y cómo hace brillar el rayo de su nube?"
,"16":"¿Sabes cómo están suspendidas las nubes, maravilla de una ciencia consumada?"
,"17":"¿Sabes por qué se calientan tus vestidos,cuando azota la tierra el viento del sur?"
,"18":"¿Extiendes con él la bóveda del cielo, sólido como espejo de metal fundido?"
,"19":"Indícanos qué le hemos de decir, pues a causa de las tinieblas no discutiremos."
,"20":"Cuando yo quiero hablar, ¿es preciso anunciárselo?,Cuando habla un hombre, ¿hay que informarle?"
,"21":"A veces no se ve la luz, oscurecida por las nubes; pero un viento sopla luego y las despeja."
,"22":"Y llega del norte un resplandor: Dios envuelto en majestad terrible."
,"23":"¡El todopoderoso! No lo podemos alcanzar; inmenso por su fuerza y rectitud, maestro de justicia, a nadie oprime."
,"24":"Por eso tienen que temerle los hombres, y él no mira a quien se cree sabio."
}`)
	CurrentBook.AddChapter(38, `{
"1":"Entonces el Señor respondió a Job desde el seno de la tempestad:"
,"2":"¿Quién es ese que enturbia mi consejo con palabras insensatas?"
,"3":"Ciñe tus lomos como un héroe; ¡yo te interrogaré y tú me instruirás!"
,"4":"¿Dónde estabas tú cuando fundaba yo la tierra?,¡Habla, si es que sabes tanto!"
,"5":"¿Sabes tú quién fijó sus dimensiones, o quién tendió la cuerda sobre ella?"
,"6":"¿En qué se apoyan sus columnas?,¿Quién asentó su piedra angular,"
,"7":"mientras a coro cantaban las estrellas del alba,y exultaban todos los hijos de Dios?"
,"8":"¿Quién encerró con doble puerta el mar, cuando salía borbotando del seno,"
,"9":"cuando una nube le puse por vestido,y el oscuro nublado por pañales;"
,"10":"cuando le fijé sus confines,y le puse en torno puertas y cerrojos,"
,"11":"y le dije: 'No pasarás de aquí, aquí se romperá la soberbia de tus olas'?"
,"12":"¿Has mandado en tu vida a la mañana, has asignado a la aurora su lugar,"
,"13":"para que aferre a la tierra por sus bordes,y de ella expulse a los malvados?"
,"14":"Ella entonces se cambia,como la arcilla de un sello, se tiñe como un vestido;"
,"15":"quita la luz a los malvados,y despedaza el brazo erguido."
,"16":"¿Has llegado hasta las fuentes de los mares, has paseado por las honduras del abismo?"
,"17":"¿Se te han abierto las puertas de la muerte?,¿Has visto las puertas de la sombra mortal?"
,"18":"¿Has medido la anchura de la tierra?,¡Habla, si sabes todo esto!"
,"19":"¿Cuál es el camino de la morada de la luz?; y las tinieblas, ¿dónde habitan,"
,"20":"para que puedas llevarlas a su sitio, guiarlas por el camino de su casa?"
,"21":"¡Tienes que saberlo, porque ya habías nacido,y es tan grande la cuenta de tus días!"
,"22":"¿Has llegado hasta los depósitos de nieve?,¿Has visitado las reservas de granizo"
,"23":"que yo guardo para el tiempo de desgracia, para los días de guerra y de combate?"
,"24":"¿Por qué lado se reparte la luz,y el viento solano se derrama por la tierra?"
,"25":"¿Quién abre un resquicio al aguacero, un camino a los giros del trueno,"
,"26":"para traer la lluvia sobre la tierra sin hombres, sobre el desierto donde no hay un alma;"
,"27":"para abrevar los desiertos y yermos,y hacer brotar en la estepa hierba verde?"
,"28":"¿Tiene padre la lluvia?,¿Quién engendra las gotas del rocío?"
,"29":"¿De qué seno sale el hielo?,Y la escarcha del cielo, ¿quién la da a luz,"
,"30":"cuando las aguas como piedras se endurecen,y el haz del abismo se congela?"
,"31":"¿Anudas tú los lazos de las Pléyades,o desatas las cuerdas de Orión?"
,"32":"¿Haces salir la Corona en su estación?,¿Guías a la Osa con sus crías?"
,"33":"¿Has enseñado las leyes a los cielos?,¿Determinas su influencia en la tierra?"
,"34":"¿Levantas tu voz hasta las nubes?,¿Te obedece la masa de las aguas?"
,"35":"¿A tus órdenes saltan los relámpagos, y te dicen: 'Aquí estamos'?"
,"36":"¿Quién infundió sabiduría a las nubes?,¿Quién dio a los meteoros inteligencia?"
,"37":"¿Quién puede contar las nubes con exactitud?,¿Quién vacía los odres de los cielos,"
,"38":"para que la tierra se funda en una masa,y los terrones se peguen entre sí?"
,"39":"¿Preparas tú la presa a la leona?,¿Sacias el hambre de los leoncillos,"
,"40":"cuando en sus guaridas se agazapan,o en los matorrales están al acecho?"
,"41":"¿Quién procura al cuervo su alimento, cuando sus crías gritan hacia Dios,y se agitan por falta de comida?"
}`)
	CurrentBook.AddChapter(39, `{
"1":"¿Conoces la época en que crían las rebecas?,¿Has observado a las ciervas en el parto?"
,"2":"¿Has contado los meses de su gestación?,¿Sabes la época en que paren?"
,"3":"Se acurrucan y paren a sus hijos, depositan su camada; "
,"4":"son vigorosas sus crías, crecen libremente en el desierto, se les van y no vuelven más a ellas."
,"5":"¿Quién dio al onagro libertad?,¿Quién soltó al asno salvaje las amarras?"
,"6":"Yo le asigné el desierto por morada, por mansión la tierra salitrosa."
,"7":"Se ríe del estrépito de la ciudad, los gritos del arriero no oye;"
,"8":"recorre las montañas de su pasto,en busca de toda hierba verde."
,"9":"¿Consentirá acaso el búfalo en servirte,y en pasar la noche en tu pesebre?"
,"10":"¿Podrás con tu coyunda atarle al surco,para que abra los campos del valle tras de ti?"
,"11":"¿Puedes fiarte de él porque sea grande su fuerza, y confiarle tus trabajos?"
,"12":"¿Estás seguro de que volverá,acarreando a tu era el grano?"
,"13":"¿Las alas del avestruz baten alegres,como las alas o las plumas de la cigüeña?"
,"14":"Abandona sus huevos en el suelo, los deja que se calienten en la arena,"
,"15":"olvidando que algún pie puede pisarlos,o aplastarlos las bestias del campo."
,"16":"Dura para las crías como si no fueran suyas, no se cuida de su inútil esfuerzo."
,"17":"Es que Dios le negó la sabiduría,y no le dotó de inteligencia."
,"18":"Pero al llegar los cazadores se remonta, y se ríe del caballo y su jinete."
,"19":"¿Das tú al caballo la fiereza?,¿Adornas su cuello de tremolante crin?"
,"20":"¿Le haces saltar como langosta, terrible en su relincho?"
,"21":"Piafa en el valle, se alboroza, con brío va al encuentro de las armas."
,"22":"Se ríe del miedo, nada lo amedrenta, ni ante la espada retrocede."
,"23":"A su flanco va resonando la aljaba, la lanza refulgente con el dardo."
,"24":"Con impaciente estrépito va sorbiendo la tierra, y no se contiene al toque del clarín."
,"25":"A cada toque del clarín grita: '¡Ah!'; olfatea de lejos la batalla, los gritos de los jefes y el estrépito."
,"26":"¿Por tu aviso acaso el halcón emprende el vuelo,y despliega sus alas hacia el sur?"
,"27":"¿Por orden tuya se remonta el águila,y pone su nido en las alturas?"
,"28":"Mora en las rocas, allí pasa la noche, en un picacho su mansión inaccesible."
,"29":"Desde allí espía su presa, sus ojos exploran a lo lejos."
,"30":"Sangre beben sus polluelos; donde hay cadáveres, allí está ella."
}`)
	CurrentBook.AddChapter(40, `{
"1":"El Señor siguió hablando a Job y le dijo:"
,"2":"¿Aún disputará el censor con el todopoderoso?,El que critica a Dios, ¿va a replicar?"
,"3":"Y Job respondió al Señor:"
,"4":"Heme aquí, mezquino soy; ¿qué puedo responderte?,¡Pongo la mano en la boca!"
,"5":"He hablado una vez...  no volveré a empezar; dos veces...  ¡ya nada añadiré!"
,"6":"El Señor respondió a Job desde el seno de la tempestad:"
,"7":"Ciñe tus lomos como un héroe: ¡yo te interrogaré y tú me instruirás!"
,"8":"¿Es que quieres anular mi derecho?,Para justificarte, ¿me vas a condenar?"
,"9":"¿Tienes un brazo tú como el de Dios?,¿Puedes tronar con voz como la suya?"
,"10":"¡Ea, adórnate de majestad y de grandeza, revístete de gloria y de esplendor!"
,"11":"¡Difunde los furores de tu ira, con una mirada abate al arrogante!"
,"12":"¡Con una mirada al soberbio derriba, aplasta a los criminales donde estén!"
,"13":"¡Tápalos juntos en el polvo, cierra su rostro en la mazmorra!"
,"14":"¡Y yo mismo te rendiré honores,por el poder triunfante de tu diestra!"
,"15":"Piensa en el hipopótamo, a quien yo he creado, como a ti; de hierba, como un buey, se alimenta."
,"16":"Mira qué fuerza hay en sus lomos, qué vigor en los músculos de su vientre."
,"17":"Yergue su cola como un cedro, los tendones de sus muslos están bien entrelazados."
,"18":"Sus huesos son tubos de bronce; sus vértebras, como barras de hierro."
,"19":"Es la obra maestra de Dios, su creador le dio una espada."
,"20":"Las montañas le ofrecen su tributo, y todas las bestias salvajes que retozan allí."
,"21":"Bajo el loto se acuesta, se esconde entre las cañas de la laguna."
,"22":"Los lotos lo recubren con su sombra, lo circundan los sauces del torrente."
,"23":"Si el río crece, no se asusta; tranquilo está, aunque le llegue al cuello."
,"24":"¿Quién podrá apresarlo por los ojos,o taladrar sus narices con punzones?"
,"25":"¿Puedes pescar con anzuelo al cocodrilo,y sujetar con un cordel su lengua?"
,"26":"¿Meterás un junco en sus narices?,¿Taladrarás con un gancho sus quijadas?"
,"27":"¿Te hará acaso largas súplicas?,¿Te dirigirá palabras dulces?"
,"28":"¿Se comprometerá en pacto contigo,a ser tu siervo para siempre?"
,"29":"¿Podrás jugar con él cual si fuera un pájaro,o le atarás para que tus niñas se diviertan?"
,"30":"¿Traficarán con él los socios del pescado, subastándole entre los revendedores?"
,"31":"¿Podrás tú taladrar sus pies con dardos, y su cabeza con arpón?"
,"32":"¡Acerca a él tu mano: al recordar la lucha, no volverás a ella!"
}`)
	CurrentBook.AddChapter(41, `{
"1":"Sí, es inútil tu esperanza, porque tan sólo el verlo aterra."
,"2":"Nadie hay tan audaz que se atreva a excitarlo. Y ¿quién puede resistirle a la cara?"
,"3":"¿Quién le desafió sin salir malparado?,¡Nadie bajo los cielos todos!"
,"4":"Y no quiero silenciar sus miembros, su fuerza, su complexión maravillosa."
,"5":"¿Quién logró abrir su túnica, penetrar por su doble dentadura?"
,"6":"¿Quién abrió las puertas de su boca?,¡Reina el terror entre sus dientes!"
,"7":"Su dorso es de hileras de escudos,cerradas con sello de piedra;"
,"8":"están apretados entre sí, y ni el aire por entre ellos pasa;"
,"9":"están fundidos uno a otro, adheridos sin dejar fisura."
,"10":"Resplandor de luz es su estornudo, sus ojos son como los párpados de la aurora."
,"11":"Salen antorchas de sus fauces, chispas de fuego saltan fuera."
,"12":"De sus narices sale humo, como de una caldera hirviente al fuego."
,"13":"Su aliento encendería carbones, pues una llama sale de sus fauces."
,"14":"En su cuello se concentra la fuerza, y ante él cunde el terror."
,"15":"Son espesas las mamellas de su carne; pegadas a él, no se desprenden."
,"16":"Su corazón es duro como piedra, duro como piedra de molino."
,"17":"Cuando él se yergue, se asustan los valientes; por la consternación quedan fuera de sí."
,"18":"La espada que lo alcanza no se clava, ni lanza, dardo o jabalina."
,"19":"Para él el hierro es paja, y el bronce, madera carcomida."
,"20":"No le pone en fuga la saeta, polvillo le resultan las piedras de la honda."
,"21":"Una paja es para él la maza, se ríe del fragor de las lanzas."
,"22":"Tiene debajo tejas puntiagudas, como un trillo pasa por el fango."
,"23":"Como una olla hace borbotar el abismo, cambia el mar en pebetero."
,"24":"Deja detrás de sí una estela esplendorosa: ¡parece el abismo una melena blanca!"
,"25":"No tiene en la tierra semejante; para no conocer el miedo ha sido hecho."
,"26":"Los más fuertes lo temen, ¡él es el rey de todas las bestias feroces!"
}`)
	CurrentBook.AddChapter(42, `{
"1":"Job respondió al Señor:"
,"2":"Reconozco que lo puedes todo; ningún proyecto te es imposible."
,"3":"¿Quién ensombrece tu designio con palabras insensatas?,He hablado sin cordura,de maravillas que no alcanzo ni comprendo."
,"4":"Escucha, déjame hablar; yo te interrogaré y tú me instruirás."
,"5":"Sólo te conocía de oídas; pero ahora, en cambio, te han visto mis ojos."
,"6":"Por eso retracto mis palabras,y en polvo y ceniza hago penitencia."
,"7":"Después de haber dirigido el Señor estas palabras a Job, dijo a Elifaz de Temán: 'Mi ira se ha encendido contra ti y contra tus dos amigos, porque no habéis hablado de mí como mi siervo Job."
,"8":"Tomad, pues, siete becerros, presentaos a mi siervo Job y ofrecedlos en holocausto por vosotros. Mi siervo Job intercederá por vosotros, y yo, por consideración a él, no os infligiré mi azote por no haber hablado rectamente de mí como mi siervo Job'."
,"9":"Entonces Elifaz, de Temán; Bildad, de Súaj, y Sofar, de Namat, se fueron a cumplir lo que les había ordenado el Señor, y el Señor tuvo consideración a Job."
,"10":"Y el Señor restituyó a Job en su antigua condición por haber intercedido en favor de sus amigos; más aún, el Señor duplicó todos los bienes que Job tenía primero."
,"11":"Todos sus hermanos, hermanas y antiguos conocidos fueron a visitarle; celebraron un banquete con él en su casa, lo compadecieron y consolaron por todo el mal que el Señor había descargado sobre él, y cada uno le regaló una moneda de plata y un anillo de oro."
,"12":"Y el Señor bendijo la nueva condición de Job más aún que la anterior: llegó a poseer catorce mil ovejas, seis mil camellos, mil yuntas de bueyes y mil asnas."
,"13":"Tuvo además catorce hijos y tres hijas."
,"14":"A una le puso el nombre de 'Paloma', a la otra el de 'Casia' y a la tercera el de 'Cuerno de afeites'."
,"15":"No había en todo aquel país mujeres tan hermosas como las hijas de Job, y su padre les dio parte en la herencia junto con sus hermanos."
,"16":"Después de todo esto vivió Job todavía hasta la edad de ciento cuarenta años, y vio a sus hijos y a sus nietos hasta la cuarta generación."
,"17":"Después Job murió anciano y colmado de días."
}`)

}
func ES_LSB_LoadVSPRChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Proverbios de Salomón, hijo de David, rey de Israel."
,"2":"Para conocer sabiduría y disciplina, para comprender discursos inteligentes,"
,"3":"para adquirir una instrucción sensata, justicia, equidad y rectitud,"
,"4":"para hacer sagaces a los jóvenes inexpertos,y darles ciencia y prudencia;"
,"5":"que el sabio escuche y aumentará su saber, y el entendido adquirirá destreza;"
,"6":"para comprender proverbios y dichos agudos, las sentencias de los sabios y sus enigmas."
,"7":"El temor del Señor es el principio de la sabiduría. Los insensatos desprecian la sabiduría y la disciplina."
,"8":"Escucha, hijo mío, la instrucción de tu padre, y no rechaces la enseñanza de tu madre,"
,"9":"porque son corona de gracia para tu cabeza,y collares para tu cuello."
,"10":"Hijo mío, si los delincuentes quieren seducirte, no consientas."
,"11":"Si te dicen: 'Ven con nosotros, acechemos para derramar sangre, tendamos a placer insidias contra el inocente;"
,"12":"como el abismo, traguémoslos vivos; enteros, como los que bajan al sepulcro;"
,"13":"encontraremos toda clase de bienes preciosos, henchiremos nuestras casas de botín,"
,"14":"correrás tu suerte con nosotros, todos nosotros tendremos bolsa común';"
,"15":"hijo mío, no los sigas en su camino, aparta tus pasos de sus sendas,"
,"16":"porque sus pies corren hacia el crimen, y se apresuran a derramar sangre;"
,"17":"porque en vano se tiende la red,ante los ojos de las aves."
,"18":"Ellos acechan para derramar su propia sangre, contra ellos mismos tienden insidias."
,"19":"Tal es el destino del que practica la rapiña; su propia avaricia lo mata."
,"20":"La sabiduría grita en las calles, en las plazas levanta su voz."
,"21":"Desde lo alto de los muros llama, a la entrada de las puertas de la ciudad pronuncia sus discursos: "
,"22":"'¿Hasta cuándo, jóvenes inexpertos, amaréis la inexperiencia, los insolentes se deleitarán en la insolencia, y los necios aborrecerán la ciencia?"
,"23":"Convertíos a mis exhortaciones; he aquí que yo derramaré sobre vosotros mi espíritu; yo os haré conocer mis palabras."
,"24":"Yo os llamé y me rechazasteis, os tendí la mano y no me hicisteis caso."
,"25":"Habéis despreciado todos mis consejos,y no habéis querido mis amonestaciones."
,"26":"También yo me reiré de vuestra desventura; me vengaré cuando llegue sobre vosotros el terror;"
,"27":"cuando el terror venga sobre vosotros como el huracán, y como un torbellino os sobrevenga la desventura; cuando la tribulación y la angustia vengan sobre vosotros. "
,"28":"Entonces ellos me llamarán y yo no responderé; me buscarán y no me encontrarán."
,"29":"Porque han aborrecido la ciencia,y no han amado el temor del Señor;"
,"30":"no han querido mis consejos, han despreciado todas mis exhortaciones,"
,"31":"comerán el fruto de sus errores,y se hartarán de sus propios consejos."
,"32":"Porque el desvío de los inexpertos los mata, y el descuido de los necios los lleva a la ruina;"
,"33":"pero quien me escucha vive en paz,y estará tranquilo sin temer ningún peligro'."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Hijo mío, si tú recibes mis palabras,y guardas dentro de ti mis mandamientos,"
,"2":"haciendo tu oído atento a la sabiduría,e inclinando tu corazón a la inteligencia;"
,"3":"si llamas a la prudencia,y levantas tu voz hacia la inteligencia;"
,"4":"si la persigues como a la plata; si excavas buscándola como un tesoro,"
,"5":"entonces comprenderás el temor del Señor,y descubrirás el conocimiento de Dios."
,"6":"Porque es el Señor el que da la sabiduría, y de su boca procede la ciencia y la sensatez."
,"7":"Él reserva su auxilio para los hombres rectos, es un escudo para los que proceden con honestidad."
,"8":"Él protege a los que practican la justicia, vigila el camino de sus fieles."
,"9":"Entonces tú comprenderás la justicia y la equidad, la rectitud y todos los caminos del bien."
,"10":"Cuando la sabiduría entre en tu corazón,y la ciencia sea dulce a tu alma,"
,"11":"la prudencia vigilará sobre ti, la inteligencia te custodiará"
,"12":"para librarte del mal camino, del hombre de perversos propósitos,"
,"13":"de los que abandonan los caminos rectos,para correr por caminos tenebrosos;"
,"14":"ésos gozan en hacer el mal, disfrutan en las peores perversidades;"
,"15":"sus senderos son tortuosos,y descaminadas sus andanzas;"
,"16":"para preservarte de la mujer ajena, de la desconocida que halaga con palabras;"
,"17":"ella ha abandonado al compañero de su juventud, se ha olvidado de la alianza de su Dios,"
,"18":"porque su casa conduce a la muerte,y sus caminos a la región de las sombras;"
,"19":"ninguno de cuantos van a ella retornan,ni encuentran los caminos de la vida."
,"20":"Por eso has de andar por la senda de los buenos; seguirás el camino de los justos."
,"21":"Porque los que practican la justicia habitarán la tierra, y los íntegros morarán en ella."
,"22":"Pero los que practican la injusticia,serán arrancados de la tierra, y los pérfidos extirpados de ella."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Hijo mío, no olvides mi enseñanza, y que tu corazón guarde mis preceptos;"
,"2":"porque te procurarán largos días, años de vida y bienestar."
,"3":"Que la bondad y la felicidad no te abandonen; átalas a tu cuello, escríbelas en la tablilla de tu corazón;"
,"4":"así encontrarás favor y éxito perfecto,a los ojos de Dios y de los hombres."
,"5":"Confía en el Señor de todo corazón,y no te apoyes sobre tu propia prudencia."
,"6":"En todos tus caminos piensa en él, y él allanará tus senderos."
,"7":"No te tengas por sabio; teme al Señor y apártate del mal;"
,"8":"esto será medicina para tu carne,y refrigerio para tus huesos."
,"9":"Honra al Señor con tus riquezas, con las primicias de todos tus frutos;"
,"10":"entonces tus graneros estarán llenos en abundancia,y tus bodegas rebosarán de vino."
,"11":"No desprecies, hijo mío, la corrección del Señor,y no te enfades por su reprensión,"
,"12":"porque el Señor reprende al que ama, como un padre al hijo querido."
,"13":"Bienaventurado el hombre que ha encontrado la sabiduría, el hombre que ha adquirido la inteligencia;"
,"14":"porque adquirirla vale más que adquirir plata, y poseerla más que poseer oro."
,"15":"Es más preciosa que las perlas, y todos los tesoros que puedas desear no la igualan."
,"16":"En su diestra tiene larga vida, y en su izquierda riquezas y honores."
,"17":"Sus caminos son caminos de delicias, y sus senderos son todos de paz."
,"18":"Es un árbol de vida para los que la abrazan, y los que la poseen son bienaventurados."
,"19":"El Señor con sabiduría ha fundado la tierra, ha establecido los cielos con inteligencia."
,"20":"Con su ciencia fueron excavados los abismos, y las nubes destilan el rocío."
,"21":"Hijo mío, guarda el consejo y la prudencia; no se aparten de tus ojos;"
,"22":"serán vida para tu alma,y adorno para tu cuello."
,"23":"Entonces andarás por tu camino con seguridad, y tu pie no tropezará."
,"24":"Si te sientas, no tendrás temor; si te acuestas, tu sueño será dulce."
,"25":"No tendrás que temer al terror repentino,ni la ruina que cae sobre los delincuentes,"
,"26":"porque el Señor será tu confianza, él preservará tu pie de toda red."
,"27":"No niegues un beneficio al que lo pida, cuando estuviere en tu poder concederlo."
,"28":"No digas a tu prójimo: 'Vuelve otra vez; mañana te daré', si está en tu poder."
,"29":"No trames mal alguno contra tu prójimo, cuando ha depositado en ti su confianza."
,"30":"No pleitees sin motivo con un hombre, si no te ha hecho mal alguno."
,"31":"No envidies al hombre desalmado,ni sigas ninguno de sus caminos;"
,"32":"porque el Señor aborrece a los perversos, mientras que con los justos se franquea."
,"33":"La maldición del Señor está en la casa del malvado, pero bendice la morada del justo."
,"34":"De los burlones se burla, y a los humildes da su gracia."
,"35":"Los sabios tienen por herencia la gloria, pero los necios reciben la ignominia."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Escuchad, hijos míos, la instrucción de un padre,y estad atentos a conocer la prudencia,"
,"2":"porque yo os doy una buena doctrina; no abandonéis mi enseñanza."
,"3":"También yo fui un hijo para mi padre, tierno y querido a los ojos de mi madre."
,"4":"Él me instruía diciéndome: 'Que tu corazón guarde mis palabras, observa mis preceptos y vivirás."
,"5":"Adquiere la sabiduría, adquiere la inteligencia, no la olvides, no te apartes de las palabras de mi boca."
,"6":"No la abandones y ella te guardará, ámala y ella te custodiará."
,"7":"Comienzo de la sabiduría: adquiere la sabiduría; cueste lo que te cueste, adquiere la inteligencia,"
,"8":"tenla en gran estima y ella te exaltará; ella será tu honor, si la abrazas."
,"9":"Sobre tu cabeza pondrá una diadema de gracia, te ceñirá una corona de gloria'."
,"10":"Escucha, hijo mío, y recibe mis palabras, y los años de tu vida se multiplicarán."
,"11":"Yo te enseño el camino de la sabiduría, te encamino por las sendas de la rectitud."
,"12":"Si caminas, no encontrarás obstáculos; y si corres, no tropezarás."
,"13":"Mantén la disciplina, no la dejes; guárdala porque ella es tu vida."
,"14":"No sigas la senda de los criminales, no vayas por el camino de los delincuentes."
,"15":"Evítalo, no vayas por él; apártate de él, y pasa de lejos."
,"16":"Porque ellos no duermen tranquilos,si no perpetran algún delito, el sueño les falta,si no arrastran a alguno a la ruina."
,"17":"Porque comen el pan del crimen,y beben el vino de la violencia."
,"18":"La senda de los justos es como la luz del alba, cuyo esplendor va creciendo hasta el pleno día."
,"19":"El camino de los delincuentes es como las tinieblas, no ven dónde van a tropezar."
,"20":"Hijo mío, presta atención a mis palabras, inclina tu oído a mis razones;"
,"21":"nunca se aparten de tus ojos; guárdalas en el fondo del corazón,"
,"22":"porque son vida para quien las posee,y dan salud a su cuerpo."
,"23":"Sobre todas las cosas, vigila tu corazón, porque de él brotan las fuentes de la vida."
,"24":"Aparta de tu boca la falsedad,y aleja de tus oídos la mentira."
,"25":"Que tus ojos miren de frente,y tu vista se dirija hacia adelante."
,"26":"Mira bien la senda de tus pasos,y todos tus caminos sean rectos."
,"27":"No te desvíes ni a derecha ni a izquierda, aleja tus pasos de la delincuencia."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Hijo mío, presta atención a mi sabiduría, inclina tu oído a mi inteligencia,"
,"2":"para conservar la prudencia y la ciencia; ellas guardarán tus labios."
,"3":"Porque los labios de la mujer extraña destilan miel, y su palabra es más suave que el aceite;"
,"4":"pero su fin es amargo como el ajenjo, agudo como espada de dos filos."
,"5":"Sus pies descienden a la muerte, sus pasos al abismo se dirigen."
,"6":"Ella no considera el camino de la vida, sus pies van errando sin que ella sepa adónde."
,"7":"Ahora, pues, hijo mío, escúchame; no te apartes de las palabras de mi boca."
,"8":"Aleja de ella tu camino,y no te acerques a la puerta de su casa,"
,"9":"para que no des a otros tu honor y tus años,a un hombre cruel;"
,"10":"para que no disfruten extraños de tu hacienda, y el fruto de tu trabajo no vaya a casa de un desconocido;"
,"11":"para que al fin no tengas que gemir, cuando tu cuerpo y tu carne estén consumidos,"
,"12":"y no digas: '¡Ay, aborrecí la disciplina,y mi corazón despreció la corrección;"
,"13":"no escuché la voz de mis educadores,ni presté oídos a los que me instruían!"
,"14":"He estado al borde de la desgracia,en medio del pueblo y de la asamblea'."
,"15":"Bebe el agua de tu propia cisterna, los raudales que brotan de tu pozo."
,"16":"¿Deben derramarse fuera tus fuentes, sobre las plazas tus arroyos?"
,"17":"Sean para ti solo, y no para extraños a la vez."
,"18":"Bendita sea tu fuente, y que te regocijes en la mujer de tu juventud:"
,"19":"cierva amable y graciosa gacela, sus encantos te embriaguen de continuo, siempre estés prendado de su amor."
,"20":"¿Por qué, hijo mío, desear a una extraña,y abrazar el seno de una desconocida?"
,"21":"Porque ante los ojos del Señor están los caminos del hombre, y él examina todos sus pasos."
,"22":"Sus propias injusticias cautivan al injusto, en los lazos de sus crímenes está prisionero."
,"23":"Él morirá por ser incorregible, su locura será su perdición."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Hijo mío, si saliste fiador por tu prójimo, si has estrechado la mano en favor de un extraño,"
,"2":"si te has ligado por las palabras de tus labios, si estás preso por tu misma boca,"
,"3":"haz, pues, esto, hijo mío, para librarte, porque has caído en las manos de tu prójimo: ve sin tardanza, e importuna a tu prójimo;"
,"4":"no des ni sueño a tus ojos, ni reposo a tus párpados;"
,"5":"líbrate, como de la red la gacela, y como el pájaro de la trampa."
,"6":"Anda a ver a la hormiga, ¡perezoso!, mira sus costumbres y hazte sabio."
,"7":"Ella, que no tiene capataz, ni jefe, ni inspector,"
,"8":"durante el verano prepara su alimento, y recoge durante la siega su comida."
,"9":"¿Hasta cuándo, perezoso, estarás acostado?,¿Cuándo te levantarás de tu sueño?"
,"10":"Un poco dormir, un poco adormecerse, un poco cruzar los brazos descansando;"
,"11":"y, como vagabundo, te viene la miseria, y la indigencia como ladrón."
,"12":"El hombre inicuo, el depravado, camina con la perversidad en la boca,"
,"13":"guiñando los ojos, arrastrando los pies, haciendo signos con los dedos,"
,"14":"tramando en su corazón malos designios, continuamente provocando peleas."
,"15":"Por eso de improviso vendrá la ruina sobre él, en un instante será destrozado y sin remedio."
,"16":"Hay seis cosas que detesta el Señor, y siete que aborrece su alma:"
,"17":"los ojos altaneros, la lengua mentirosa, las manos que derraman sangre inocente,"
,"18":"el corazón que trama designios perversos, los pies que corren presurosos al delito,"
,"19":"el falso testigo que profiere calumnias,y el que siembra discordias entre hermanos."
,"20":"Guarda, hijo mío, los preceptos de tu padre,y no rechaces la enseñanza de tu madre."
,"21":"Fíjalos constantemente en tu corazón, átalos alrededor de tu cuello."
,"22":"Cuando camines, ellos te guiarán; cuando duermas, vigilarán sobre ti, y cuando te despiertes, se entretendrán contigo."
,"23":"Porque el precepto es una lámpara; la enseñanza, una luz; la corrección y la disciplina son el camino de la vida,"
,"24":"para preservarte de la mujer adúltera, de los halagos de la mujer extraña."
,"25":"No codicies en tu corazón su hermosura,y no te dejes seducir por sus miradas."
,"26":"Porque si la prostituta busca un trozo de pan, la adúltera amenaza a una vida preciosa."
,"27":"¿Puede uno meter fuego en su seno,sin que sus vestidos se quemen?"
,"28":"¿Puede uno andar sobre brasas,sin que se le abrasen los pies?"
,"29":"Tal es el que se acerca a la mujer de su prójimo; cualquiera que la toque no quedará impune."
,"30":"No se quita el honor a un ladrón,que roba para satisfacer su apetito cuando tiene hambre."
,"31":"Pero si le pillan, tendrá que pagar el séptuplo; habrá de dar toda la hacienda de su casa."
,"32":"Mas el que viola a una mujer es un mentecato; él mismo se busca la ruina."
,"33":"Recibirá golpes e insultos, y su afrenta nunca se borrará;"
,"34":"porque los celos encienden el furor del marido, y no perdonará en el día de la venganza;"
,"35":"no le bastarán compensaciones,y no querrá nada aunque multipliques los dones."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Hijo mío, guarda mis palabras,y conserva mis mandatos."
,"2":"Guarda mis preceptos y vivirás; que sea mi enseñanza como la niña de tus ojos."
,"3":"talos a tus dedos, escríbelos en la tablilla de tu corazón."
,"4":"Di a la sabiduría: 'Tú eres mi hermana', y llama a la inteligencia tu amiga,"
,"5":"para que te guarden de la mujer ajena, de la desconocida que halaga con palabras."
,"6":"Mientras que en la ventana de mi casa,estaba yo mirando a través de las celosías,"
,"7":"entre los jóvenes faltos de experiencia,vi un muchacho desprovisto de sentido."
,"8":"Pasaba por la calle junto a la esquina de la extraña,e iba camino de su casa."
,"9":"Era al atardecer, al caer el día, al oscurecer, al hacerse de noche."
,"10":"De pronto, una mujer le sale al paso,con aire de prostituta, cubierta con un velo."
,"11":"Es apasionada y provocadora, sus pies no pueden estar en casa;"
,"12":"ya en la calle, ya en las plazas, en todas las esquinas está acechando."
,"13":"Ella le abraza y le besa, y con todo descaro le dice:"
,"14":"'Tenía que ofrecer sacrificios de reconciliación, y hoy he cumplido mi promesa;"
,"15":"por eso he salido a tu encuentro a buscarte, y te he encontrado."
,"16":"He ataviado mi lecho con tapices, con finas telas de Egipto;"
,"17":"he perfumado mi cama con mirra, áloe y cinamomo."
,"18":"Ven, embriaguémonos de amor hasta la mañana, gocemos de la alegría del placer,"
,"19":"pues mi marido no está en casa, ha salido para un largo viaje;"
,"20":"llevó consigo la bolsa del dinero, y no regresará a casa hasta la luna llena'."
,"21":"Ella le persuade a fuerza de halagos, con la seducción de sus labios le arrastra."
,"22":"Y él, infeliz, la sigue, como un buey al matadero, como un ciervo apresado en el lazo,"
,"23":"hasta que una flecha le atraviesa el hígado; como pájaro que se precipita en la red, sin saber que en ello le va la vida."
,"24":"Ahora, pues, hijo mío, escúchame, y presta atención a las palabras de mi boca:"
,"25":"Que tu corazón no se desvíe por los caminos de tal mujer, ni te pierdas por sus senderos,"
,"26":"porque a muchos ha herido de muerte,y sus víctimas son numerosas;"
,"27":"su casa es el camino del abismo, que conduce a la morada de la muerte."
}`)
	CurrentBook.AddChapter(8, `{
"1":"¿No llama la sabiduría, no levanta su voz la inteligencia?"
,"2":"En la cima de las alturas, junto a los caminos, en los cruces de las veredas se coloca;"
,"3":"junto a las puertas, a la entrada de la ciudad, en las vías de acceso da voces:"
,"4":"'A vosotros, mortales, llamo, y mi voz se dirige a los hombres."
,"5":"Jóvenes inexpertos, aprended la prudencia; y vosotros, necios, entrad en cordura."
,"6":"Oíd, porque voy a deciros cosas solemnes, y de mis labios saldrán palabras justas;"
,"7":"porque mi boca proclama la verdad,y mis labios rechazan la mentira."
,"8":"Todas las palabras de mi boca son justas; nada hay en ellas falso o tortuoso."
,"9":"Todas son francas para quien las entiende, y rectas para los que poseen la ciencia."
,"10":"Procuraos mi doctrina y no la plata, la ciencia más bien que el oro puro,"
,"11":"porque la sabiduría vale más que las perlas, y todos los objetos preciosos no la igualan."
,"12":"Yo, la sabiduría, habito con la prudencia,y poseo la ciencia y la reflexión."
,"13":"Temer al Señor es aborrecer el mal; la arrogancia y el orgullo, la mala conducta,y la boca perversa, las detesto."
,"14":"A mí me pertenece el consejo y la previsión; mía es la inteligencia, mía la fuerza."
,"15":"Por mí reinan los reyes, y los príncipes decretan la justicia;"
,"16":"por mí gobiernan los jefes, y los soberanos juzgan toda la tierra."
,"17":"Yo amo a los que me aman, y los que me buscan con diligencia me encuentran."
,"18":"Conmigo están la riqueza y la gloria, los bienes durables y la justicia."
,"19":"Mejor es mi fruta que el oro, que el oro puro; y mis productos son mejores que la plata escogida."
,"20":"Yo voy por las sendas de la justicia, por los senderos de la equidad"
,"21":"para procurar bienes a los que me aman,y henchir sus tesoros."
,"22":"El Señor me creó en el comienzo de sus obras, antes que comenzara a crearlo todo."
,"23":"Desde la eternidad fui constituida; desde el comienzo, antes del origen de la tierra."
,"24":"Cuando el abismo no existía, fui yo engendrada; cuando no había fuentes, ricas en aguas."
,"25":"Antes que los montes fueran fundados, antes de las colinas fui yo engendrada;"
,"26":"cuando aún no había hecho la tierra y los campos, ni los elementos del polvo del mundo."
,"27":"Cuando estableció los cielos, allí estaba yo; cuando trazó un círculo sobre la faz del abismo,"
,"28":"cuando condensó las nubes en lo alto, cuando fijó las fuentes del abismo,"
,"29":"cuando asignó su límite al mar,para que las aguas no salieran de sus límites, cuando echó los cimientos de la tierra,"
,"30":"yo estaba a su lado como arquitecto, y yo era cada día sus delicias, recreándome todo el tiempo en su presencia,"
,"31":"recreándome en su orbe terrestre,y encontrando mis delicias con los hijos de los hombres."
,"32":"Por tanto, hijos míos, escuchadme: dichosos los que siguen mis caminos;"
,"33":"escuchad mis avisos y seréis sensatos, no los rechacéis;"
,"34":"dichoso el hombre que me escucha,velando a mis puertas día tras día, vigilando a la entrada de mi casa."
,"35":"Porque quien me encuentra, encuentra la vida y obtiene el favor del Señor;"
,"36":"pero el que me ofende, se daña a sí mismo; todos los que me odian a mí, aman la muerte'."
}`)
	CurrentBook.AddChapter(9, `{
"1":"La sabiduría edificó su casa, labró sus siete columnas,"
,"2":"inmoló sus víctimas, preparó su vino,e igualmente aderezó su mesa."
,"3":"Envió sus criados,y proclamó sobre los puntos más altos de la ciudad:"
,"4":"'Jóvenes inexpertos, venid aquí'. A los insensatos ella les dice:"
,"5":"'Venid, comed de mi pan,y bebed del vino que yo he preparado."
,"6":"Dejad de ser imprudentes y viviréis, y caminad por la senda de la inteligencia'."
,"7":"El que corrige al escéptico se acarrea afrenta; el que reprende al malvado, ultraje."
,"8":"No reprendas al escéptico para que no te odie; reprende al sabio y te amará."
,"9":"Da al sabio, y se hará más sabio todavía; instruye al justo, y acrecerá su ciencia."
,"10":"El principio de la sabiduría es el temor del Señor; conocer al santo, ésa es la inteligencia."
,"11":"Porque por mí tus días se multiplican, y los años de tu vida se aumentan."
,"12":"Si tú eres sabio, eres sabio para tu bien; si eres escéptico, tú solo sufrirás las consecuencias."
,"13":"La señora necedad es impulsiva, mentecata e ignorante."
,"14":"Se sienta a la puerta de su casa, en una silla, en lo más alto de la ciudad"
,"15":"para invitar a los transeúntes, que van derechos por sus caminos:"
,"16":"'Jóvenes inexpertos, venid aquí'. A los insensatos ella les dice:"
,"17":"'Las aguas robadas son dulces,y el pan en secreto es sabroso'."
,"18":"Pero el hombre no sabe,que allí están las sombras de los muertos, y sus invitados en las profundidades del abismo."
}`)
	CurrentBook.AddChapter(10, `{
"1":"El hijo sabio es la alegría de su padre, y el hijo necio la tristeza de su madre."
,"2":"Tesoros mal adquiridos no aprovechan, mas la justicia libra de la muerte."
,"3":"El Señor no deja al justo sufrir hambre, pero rechaza la codicia del malvado."
,"4":"La mano perezosa empobrece, la mano diligente enriquece."
,"5":"El que recoge en verano es hombre prudente, el que duerme durante la siega es despreciable."
,"6":"La bendición del Señor sobre la cabeza del justo, la boca del malhechor oculta la violencia."
,"7":"La memoria del justo es bendecida, y el nombre del injusto es maldecido."
,"8":"El sabio de corazón acepta los preceptos, mas el insensato deslenguado corre al precipicio."
,"9":"El que camina con integridad camina seguro, pero el que mal anda mal acaba."
,"10":"El que guiña el ojo causa desventuras, quien reprende con franqueza trae la paz."
,"11":"La boca del justo es fuente de vida, pero la boca del malhechor oculta la violencia."
,"12":"El odio suscita querellas, pero el amor cubre todas las faltas."
,"13":"En los labios del inteligente se encuentra la sabiduría, en las espaldas del insensato la vara."
,"14":"Los sabios atesoran la ciencia, pero la boca del insensato es un peligro inminente."
,"15":"La hacienda del rico es su fortín, pero la indigencia del pobre es su pobreza."
,"16":"El salario del justo procura la vida, la ganancia del malvado la ruina."
,"17":"Sendero de vida es guardar la instrucción, el que desprecia la reprensión va por camino falso."
,"18":"Los labios sinceros apagan el odio, y el que difunde calumnias es un necio."
,"19":"En el mucho hablar no falta el pecado, el que frena sus labios es prudente."
,"20":"Plata pura es la lengua del justo, el corazón de los malvados bien poco vale."
,"21":"Los labios del justo alimentan a muchos, los insensatos mueren por falta de seso."
,"22":"La bendición del Señor es lo que enriquece, nuestro esfuerzo no le añade nada."
,"23":"El necio encuentra placer en cometer el crimen, el hombre sensato en adquirir sabiduría."
,"24":"Al injusto le acontece lo que teme, pero el justo obtiene lo que desea."
,"25":"Como pasa el huracán desaparece el injusto, pero el justo permanece para siempre."
,"26":"Como el vinagre a los dientes y el humo a los ojos, así es el mensajero perezoso para quien le envía."
,"27":"El temor del Señor alarga la vida, mas los años de los malos serán abreviados."
,"28":"La esperanza de los justos termina en alegría, pero la esperanza de los injustos se desvanece."
,"29":"El Señor es una muralla para el hombre de vida íntegra, pero una ruina para los criminales."
,"30":"Jamás vacilará el justo, pero los injustos no habitarán la tierra."
,"31":"La boca del justo produce la sabiduría, pero la lengua del injusto será cortada."
,"32":"Los labios del justo destilan benevolencia, la boca del injusto perversidad."
}`)
	CurrentBook.AddChapter(11, `{
"1":"El Señor reprueba la balanza falsa, pero el peso justo le agrada."
,"2":"Detrás de la soberbia vendrá la ignominia, pero con los humildes está la sabiduría."
,"3":"Los hombres rectos son guiados por su integridad, y los pérfidos son destruidos por su propia malicia."
,"4":"En el día de la ira las riquezas de nada sirven, pero la justicia libra de la muerte."
,"5":"La justicia de los hombres rectos les allana el camino, pero el injusto cae por su injusticia."
,"6":"La justicia de los hombres rectos los salva, pero los pérfidos quedan presos en su propia malicia."
,"7":"Con la muerte del injusto perece su esperanza, y la confianza de los malvados es aniquilada."
,"8":"El justo es librado de la tribulación, y en su lugar entra el malvado."
,"9":"Con su boca el injusto arruina a su prójimo, pero los justos por su saber se libran."
,"10":"Por la prosperidad de los justos se alegra la ciudad; cuando perecen los injustos, hay fiesta."
,"11":"Por la bendición de los hombres rectos se eleva una ciudad, la boca de los malvados la destruye."
,"12":"El que desprecia a su prójimo es un insensato, el hombre prudente calla."
,"13":"El chismoso descubre los secretos, pero el corazón fiel tiene oculta la cosa."
,"14":"Por falta de dirección cae un pueblo, su salvación está en un gran número de consejeros."
,"15":"Termina mal el que sale fiador de un extraño, pero el que rehúye la fianza está seguro."
,"16":"La mujer agraciada es la gloria de su marido, pero es trono de deshonra la mujer que odia la justicia. Los perezosos carecen de bienes, pero los decididos adquieren riquezas."
,"17":"El hombre generoso se hace bien a sí mismo, pero el cruel a sí mismo se perjudica."
,"18":"El injusto adquiere ganancias falsas, pero el que siembra la justicia tiene recompensa verdadera."
,"19":"El que sigue la justicia va a la vida, el que practica la injusticia va a la muerte."
,"20":"El Señor aborrece los corazones depravados, los que obran con integridad le son gratos."
,"21":"Ciertamente no quedarán impunes los injustos, mas la posteridad de los justos se salvará."
,"22":"Anillo de oro en jeta de puerco, tal es la mujer bella pero sin seso."
,"23":"El deseo de los justos es únicamente el bien, la esperanza de los injustos es la ira."
,"24":"Hay quien da libremente y sus riquezas aumentan; hay quien ahorra más de lo razonable y se empobrece."
,"25":"La persona benéfica prosperará, y el que largamente da largamente recibirá."
,"26":"El que acapara el trigo es maldecido por el pueblo, pero caen bendiciones sobre la cabeza del que lo vende."
,"27":"El que busca el bien encuentra el favor, al que busca el mal le llegará el mal."
,"28":"El que confía en sus propias riquezas caerá, los justos reverdecerán como follaje."
,"29":"El que descuida su casa heredará viento, el insensato será esclavo del sabio."
,"30":"El fruto de la justicia es un árbol de vida, y la violencia arranca las vidas."
,"31":"Si el justo recibe en la tierra su paga, cuánto más el injusto y el pecador."
}`)
	CurrentBook.AddChapter(12, `{
"1":"El que ama la instrucción ama la ciencia, el que odia la reprensión es insensato."
,"2":"El que es bueno alcanza el favor del Señor, pero él condena al hombre malicioso."
,"3":"No se afirma el hombre por la maldad, la raíz de los justos no será arrancada."
,"4":"Una mujer virtuosa es la corona de su marido, una mujer desvergonzada es como la carcoma en sus huesos."
,"5":"Los proyectos de los justos son justicia; los planes de los injustos, la falsedad."
,"6":"Las palabras de los criminales son redes sangrientas, pero los hombres rectos, con sus respuestas, se libran de ellas."
,"7":"Abatidos, los injustos no existen más, pero la casa de los justos permanece en pie."
,"8":"El hombre es estimado según su prudencia, pero el corazón perverso caerá en el desprecio."
,"9":"Más vale un hombre común que se basta a sí mismo, que el presuntuoso que carece de pan."
,"10":"El justo cuida de las necesidades de su ganado, las entrañas de los injustos son crueles."
,"11":"El que cultiva su campo se hartará de pan, el que se pierde en quimeras es un insensato."
,"12":"El malvado desea la ganancia del malvado, la raíz del justo está bien firme."
,"13":"Por las faltas de sus labios se enreda el criminal, el justo se libra de la tribulación."
,"14":"Por el fruto de su boca se sacia el hombre de bien, a cada uno le será dado según la obra de sus manos."
,"15":"El insensato juzga recto su propio camino, pero el que escucha los avisos es sabio."
,"16":"El insensato manifiesta al instante su ira, el hombre prudente sabe disimular una ofensa."
,"17":"El que dice la verdad proclama la justicia; el falso testimonio, la perfidia."
,"18":"Las palabras imprudentes hieren como una espada, la lengua de los sabios cura las heridas."
,"19":"Los labios veraces permanecen por siempre, la lengua mentirosa dura sólo un instante."
,"20":"La amargura está en el corazón de los que traman el mal, los que aconsejan la paz tienen alegría."
,"21":"Ninguna adversidad vendrá sobre el justo, mientras que los injustos estarán colmados de males."
,"22":"El Señor aborrece los labios mentirosos, y se complace en los que dicen la verdad."
,"23":"El hombre prudente oculta su ciencia, el corazón del insensato publica su necedad."
,"24":"La mano laboriosa dominará, la perezosa se hará tributaria."
,"25":"La angustia deprime el corazón del hombre, pero una buena palabra le alegra."
,"26":"El justo es guía de su compañero, el camino de los delincuentes los extravía."
,"27":"El perezoso no asa su pieza de caza, la mejor riqueza del hombre es la diligencia."
,"28":"En el sendero de la justicia está la vida, el camino tortuoso lleva a la muerte."
}`)
	CurrentBook.AddChapter(13, `{
"1":"El hijo sabio ama la disciplina, el insolente no escucha la reprensión."
,"2":"Por el fruto de su boca el hombre gusta el bien, el apetito de los traidores se nutre de violencia."
,"3":"El que vigila su boca conserva su vida, el que abre mucho sus labios se pierde."
,"4":"Desea el perezoso, pero en vano; el deseo de los diligentes será saciado."
,"5":"El justo odia las palabras mentirosas, el malvado calumnia y deshonra."
,"6":"La justicia protege el camino del hombre íntegro, el delito causa la ruina del delincuente."
,"7":"Hay quien se las da de rico y no tiene nada, hay quien se las da de pobre teniendo grandes bienes."
,"8":"Las riquezas de un hombre son el rescate de su vida, pero el pobre no tiene medios para rescatarse."
,"9":"La luz de los justos brilla alegremente, pero la lámpara de los injustos se apaga."
,"10":"El orgulloso provoca peleas, la sabiduría está con los que se dejan aconsejar."
,"11":"Riqueza adquirida de prisa se desvanece, pero el que la reúne poco a poco la aumenta."
,"12":"La esperanza diferida hace enfermar el corazón, el deseo satisfecho es un árbol de vida."
,"13":"El que desprecia la palabra se perderá, el que respeta el precepto será recompensado."
,"14":"La enseñanza del sabio es fuente de vida,para escapar de los lazos de la muerte."
,"15":"La prudencia recta concilia el favor; la conducta de los pérfidos, la perdición."
,"16":"El hombre sensato lo hace todo con reflexión, pero el necio manifiesta su insensatez."
,"17":"Un mal mensajero provoca desgracias, pero un enviado fiel es un remedio."
,"18":"Miseria y vergüenza para el que rechaza la disciplina, honor para el que acoge la corrección."
,"19":"El deseo satisfecho es dulzura para el alma, apartarse del mal es odioso para el necio."
,"20":"Anda con los sabios y te harás sabio, el que frecuenta los necios será como ellos."
,"21":"La desventura persigue al delincuente, la felicidad acompaña al justo."
,"22":"El hombre de bien deja su herencia a los hijos de sus hijos, las riquezas del injusto están reservadas para el justo."
,"23":"El campo roturado por el pobre da abundante fruto, pero hay quien perece por falta de justicia."
,"24":"El que no usa la vara odia a su hijo, pero el que le ama le prodiga la corrección."
,"25":"El justo come hasta saciar su apetito, pero el vientre del delincuente sufre hambre."
}`)
	CurrentBook.AddChapter(14, `{
"1":"La mujer sabia construye su casa, la necia con sus manos la destruye."
,"2":"El que obra con rectitud teme al Señor, el que sigue caminos torcidos le desprecia."
,"3":"La boca del insensato es la vara para su propia espalda, pero los labios de los sabios les protegen."
,"4":"Donde no hay bueyes el granero está vacío, cosecha abundante con toros robustos."
,"5":"El testigo fiel no miente, el testigo falso profiere mentiras."
,"6":"El insolente busca la sabiduría y no la encuentra, pero para el hombre inteligente la ciencia es fácil."
,"7":"Aléjate del hombre necio, pues no encontrarás en él labios de ciencia."
,"8":"La sabiduría del prudente está en conocer su camino, la insensatez de los necios en engañarse."
,"9":"El necio se burla del pecado, entre los hombres rectos está la benevolencia."
,"10":"El corazón conoce sus propias amarguras, y en su alegría no puede participar el extraño."
,"11":"La casa de los malvados será destruida, pero la casa de los hombres rectos florecerá."
,"12":"Un camino puede parecer recto a un hombre, pero, en fin de cuentas, conduce a la muerte."
,"13":"Aun en la risa encuentra el corazón sufrimiento, y la alegría acaba en duelo."
,"14":"El insensato recogerá el fruto de su conducta, el hombre de bien gozará de sus obras."
,"15":"El ingenuo cree cuanto le dicen; el prudente vigila sus pasos."
,"16":"El sabio teme y se aparta del mal, pero el insensato es insolente y se cree seguro."
,"17":"El que presto se enoja hace locuras, el hombre reflexivo mantiene la calma."
,"18":"La herencia de los imprudentes es la insensatez, la ciencia es la corona de los prudentes."
,"19":"Los malos se prosternan delante de los buenos, y los injustos ante la puerta de los justos."
,"20":"Incluso a su vecino es odioso el pobre, pero el rico tiene muchos amigos."
,"21":"El que desprecia a su prójimo comete pecado, dichoso el que tiene piedad de los pobres."
,"22":"¿Acaso no se pierden los que traman el mal?,Misericordia y verdad para los que buscan el bien."
,"23":"Todo trabajo da fruto, pero la charlatanería lleva sólo a la miseria."
,"24":"La corona de los sabios es su sabiduría, la diadema de los necios es su insensatez."
,"25":"El testigo veraz salva vidas, pero el que profiere mentiras es un impostor."
,"26":"El temor del Señor es un asilo seguro, y para sus hijos un refugio."
,"27":"El temor del Señor es fuente de vida,para escapar a los lazos de la muere."
,"28":"Un pueblo numeroso es la gloria del rey, la escasez de súbditos es la ruina del príncipe."
,"29":"El tardo a la ira es rico en inteligencia, el que cede al arrebato hace muchas locuras."
,"30":"Un corazón tranquilo es la vida del cuerpo, la envidia es la caries de los huesos."
,"31":"El que oprime al pobre ultraja a su creador, pero le honra el que tiene piedad del indigente."
,"32":"El injusto es arrastrado por su propia injusticia; pero el justo encuentra refugio en su justicia."
,"33":"En el corazón del inteligente mora la sabiduría, pero entre los necios no se deja ver."
,"34":"La justicia eleva a una nación, mas la injusticia hunde los pueblos."
,"35":"El rey concede su favor al servidor inteligente, pero su ira pierde al inepto."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Una respuesta amable calma la ira, pero una palabra áspera excita el furor."
,"2":"La lengua de los sabios derrama la ciencia, la boca de los necios profiere desatinos."
,"3":"En todo lugar están los ojos del Señor, él observa a los malos y a los buenos."
,"4":"La lengua apacible es un árbol de vida, pero su aspereza hiere el corazón."
,"5":"El insensato desprecia la instrucción paterna, pero el que escucha la corrección es prudente."
,"6":"En la casa del justo hay gran abundancia, pero las ganancias del injusto causan turbación."
,"7":"Los labios del sabio derraman ciencia, pero no así el corazón del necio."
,"8":"Dios rechaza el sacrificio de los que practican la injusticia,y se complace en la oración de los justos."
,"9":"El Señor odia la conducta perversa, y ama a quien obra con justicia."
,"10":"Una severa corrección para el que abandona el camino, el que odia la reprensión morirá."
,"11":"El abismo y el infierno están delante del Señor, cuánto más los corazones de los hombres."
,"12":"El insolente no quiere que le reprendan, por eso no va con los sabios."
,"13":"Un corazón contento alegra el semblante, un corazón triste abate el espíritu."
,"14":"Un corazón sabio cultiva la ciencia, la boca del necio se nutre de insensatez."
,"15":"Para el afligido todos los días son malos, la alegría de corazón es un festín perpetuo."
,"16":"Más vale poco con temor del Señor,que abundante tesoro con turbación."
,"17":"Más vale una ración de verduras con amor,que buey cebado con odio."
,"18":"El hombre iracundo suscita contiendas, el que es tardo para la ira apacigua la disputa."
,"19":"El camino del perezoso es como seto de espinas, el sendero de los diligentes es espacioso."
,"20":"El hijo sabio alegra a su padre, el necio desprecia a su madre."
,"21":"La insensatez agrada al falto de sentido, el hombre inteligente sigue derecho su camino."
,"22":"Los proyectos fracasan por falta de deliberación, pero con muchos consejeros se logra el éxito."
,"23":"Alegría es para el hombre la respuesta de su boca, y una palabra oportuna ¡qué agradable resulta!"
,"24":"El sabio sube por un camino de vida,que lo libra de bajar al abismo."
,"25":"El Señor derriba la casa de los soberbios,y afirma los linderos de la viuda."
,"26":"El Señor odia las intenciones perversas, las palabras benévolas le agradan."
,"27":"El ávido de ganancia perturba su casa, el que aborrece las dádivas vivirá."
,"28":"El corazón del justo medita sus respuestas, la boca del criminal profiere perversidades."
,"29":"El Señor está lejos de los criminales, pero escucha la oración de los justos."
,"30":"Una mirada benévola alegra el corazón,y una buena noticia reanima las fuerzas."
,"31":"El oído que escucha la reprensión saludable,tiene su morada entre los sabios."
,"32":"El que rechaza la corrección se desprecia a sí mismo, el que escucha la reprensión adquiere inteligencia."
,"33":"El temor del Señor es escuela de sabiduría, y la humildad precede a la gloria."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Propio es del hombre hacer planes, pero la última palabra es de Dios."
,"2":"A los ojos del hombre todos sus caminos son puros, pero el Señor juzga las intenciones."
,"3":"Encomienda al Señor tus obras, y tus proyectos tendrán éxito."
,"4":"El Señor ha hecho todas las cosas para un fin, incluso al criminal para el día del castigo."
,"5":"El Señor aborrece al arrogante, ciertamente no quedará impune."
,"6":"La bondad y la fidelidad reparan el pecado, con el temor de Dios se evita el mal."
,"7":"Cuando el Señor se complace en la conducta de un hombre, reconcilia con él incluso a sus enemigos."
,"8":"Más vale poco con justicia,que muchos ingresos con injusticia."
,"9":"El hombre traza su camino, pero el Señor dirige sus pasos."
,"10":"Los oráculos están en los labios del rey, y en el juicio su boca no yerra."
,"11":"La balanza y los platillos justos son del Señor, y obra suya son todas las pesas de la bolsa."
,"12":"El rey debe odiar la injusticia, porque el trono está establecido en la justicia."
,"13":"El rey concede su favor a los labios justos, y ama al que habla con rectitud."
,"14":"El furor del rey es mensajero de muerte, pero un hombre sabio le apacigua."
,"15":"En la serenidad del rostro del rey está la vida, y su favor es cual lluvia primaveral."
,"16":"Más vale adquirir la sabiduría que el oro, y adquirir la inteligencia es preferible a la plata."
,"17":"El camino de los hombres rectos es evitar el mal, guarda su vida el que vigila su camino."
,"18":"El preludio de la ruina es el orgullo; el preludio de la caída, el espíritu altanero."
,"19":"Más vale ser humilde de espíritu con los pequeños,que partir el botín con los soberbios."
,"20":"El que presta atención a la palabra encuentra la felicidad, y el que confía en el Señor es dichoso."
,"21":"El que es sabio de corazón será proclamado inteligente, la suavidad del lenguaje hace más eficaz la doctrina."
,"22":"El buen sentido es fuente de vida para quien lo posee, castigo de los necios es su necedad."
,"23":"El corazón del sabio hace su boca sensata, en sus labios es más persuasiva la doctrina."
,"24":"Panal de miel son las palabras amables, dulzura para el alma y medicina para el cuerpo."
,"25":"Hay caminos que parecen rectos, pero, en fin de cuentas, conducen a la muerte."
,"26":"El hambre del trabajador trabaja para él, porque la exigencia de su boca le estimula."
,"27":"El hombre inicuo es una fosa de maldad, sobre sus labios hay como fuego ardiendo."
,"28":"El hombre perverso siembra la contienda, el chismoso divide los amigos."
,"29":"El hombre violento seduce a su prójimo, lo lleva por mal camino."
,"30":"El que guiña los ojos maquina engaños, el que aprieta sus labios ya ha consumado el mal."
,"31":"Los cabellos blancos son una corona de honor, por el camino de la justicia se la encuentra."
,"32":"Más vale un hombre paciente que un héroe, más vale el que se domina a sí mismo,que el que conquista ciudades."
,"33":"El hombre echa las suertes, pero el resultado depende del Señor."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Más vale un mendrugo con paz,que una casa llena de carne con peleas."
,"2":"El siervo inteligente se impone al hijo que deshonra, y con los hermanos compartirá la herencia."
,"3":"El oro y la plata los prueba el fuego, los corazones los prueba el Señor."
,"4":"El malo presta atención a los labios mentirosos, y el mentiroso da oídos a la lengua maligna."
,"5":"El que se ríe del pobre ultraja a su creador, el que se alegra del desgraciado no quedará impune."
,"6":"La corona de los ancianos son sus nietos, la gloria de los hijos son sus padres."
,"7":"Un lenguaje distinguido no cae bien al insensato, y menos aún una lengua mentirosa al noble."
,"8":"Piedra preciosa es un presente para quien lo posee, a cualquier parte donde se dirige tiene éxito."
,"9":"El que encubre la falta cultiva la amistad, pero el que la descubre con sus palabras,divide a los amigos."
,"10":"Más impresión causa al inteligente un reproche,que cien golpes al necio."
,"11":"El pendenciero sólo busca pelea, pero un mensajero cruel será enviado contra él."
,"12":"Mejor es tropezar con una osa,a la que han arrebatado los cachorros,que con un necio en el frenesí de su insensatez."
,"13":"El que devuelve mal por bien,no alejará de su casa la desventura."
,"14":"Comenzar un pleito es abrir un dique, retírate antes de complicarte en él."
,"15":"Absolver al culpable y condenar al justo,son dos cosas que odia el Señor."
,"16":"¿Para qué sirve el dinero en manos de un necio?,¿Para adquirir la sabiduría?,Él no tiene inteligencia."
,"17":"El amigo ama en todo tiempo, es un hermano en la adversidad."
,"18":"No demuestra sensatez el que adquiere compromisos, el hombre que sale fiador de su prójimo."
,"19":"Ama los golpes el que ama las querellas, el arrogante cultiva la ruina."
,"20":"El corazón perverso no encuentra la felicidad, la lengua tortuosa cae en la desventura."
,"21":"El que engendra un necio es para su propio mal, el padre de un tonto no tendrá alegría."
,"22":"Corazón alegre, excelente remedio; un espíritu abatido seca los huesos."
,"23":"El inicuo acepta dádivas secretas,para desviar el curso de la justicia."
,"24":"El hombre inteligente tiene sus ojos puestos en la sabiduría, pero las miradas del necio se pierden en el vacío."
,"25":"Un hijo necio es el tormento de su padre,y la amargura de su madre."
,"26":"No está bien poner una multa al justo, dar golpes a los nobles rebasa la medida."
,"27":"El sabio es comedido en sus palabras, y el inteligente mantiene la calma."
,"28":"Aun el insensato, si se calla, pasa por sabio; por inteligente, si tiene los labios cerrados."
}`)
	CurrentBook.AddChapter(18, `{
"1":"El que quiere separarse busca pretextos,y contra todo consejo se irrita."
,"2":"El necio no encuentra placer en la reflexión, sino en propalar sus pensamientos."
,"3":"Cuando viene el mal, viene también el desprecio; y con el deshonor, la vergüenza."
,"4":"Aguas profundas son las palabras de un hombre; torrente que inunda, la fuente de la sabiduría."
,"5":"No es bueno tener consideración con el culpable,para perjudicar al inocente en el juicio."
,"6":"Los labios del necio provocan querellas, su boca atrae los golpes."
,"7":"La boca del necio es su ruina, sus labios son un lazo para su propia vida."
,"8":"Las palabras de los chismosos son apetitosos bocados, llegan hasta lo más hondo de las entrañas."
,"9":"El que es negligente en su trabajo,es hermano del destructor."
,"10":"El nombre del Señor es torre fuerte, en ella se refugia el justo y está seguro."
,"11":"La hacienda del rico es su fuerte ciudadela, en su pensamiento es como una muralla elevada."
,"12":"Antes de la caída se eleva el corazón del hombre, la humildad precede a la gloria."
,"13":"El que da una respuesta antes de haber escuchado,muestra su insensatez para oprobio suyo."
,"14":"El espíritu del hombre le sostiene en su enfermedad; pero al espíritu abatido, ¿quién le sostendrá?"
,"15":"El corazón inteligente adquiere la sabiduría, el oído de los sabios busca la ciencia."
,"16":"Las dádivas abren todas las puertas al hombre,y le dan acceso a la presencia de los grandes."
,"17":"El primero parece tener razón en el pleito, pero luego viene la otra parte y se la examina."
,"18":"La suerte pone fin a los litigios,y decide entre los poderosos."
,"19":"Un hermano ayudado por su hermano es una ciudad fuerte, y las querellas son como cerrojos de fortaleza."
,"20":"Del fruto de su boca llena el hombre su vientre, del producto de sus labios se sacia."
,"21":"La muerte y la vida están en poder de la lengua, los que la usan comerán de su fruto."
,"22":"El que encuentra una mujer encuentra la felicidad, es un favor que ha obtenido del Señor."
,"23":"El pobre habla suplicando, y el rico responde con dureza."
,"24":"Hay amigos que llevan a la ruina, y hay amigos más fieles que un hermano."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Más vale pobre que vive honestamente,que rico de proceder injusto."
,"2":"Actuar sin reflexionar no es bueno, actuar con muchas prisas es una equivocación."
,"3":"La insensatez del hombre tuerce su camino, y luego su corazón se irrita contra el Señor."
,"4":"La riqueza atrae un gran número de amigos, pero el pobre pierde incluso a los suyos."
,"5":"El testigo falso no quedará impune, quien profiere mentiras no escapará."
,"6":"Muchos buscan los favores del hombre generoso, y todos son amigos del que da."
,"7":"Al pobre hasta sus hermanos lo odian, con mayor razón sus amigos se alejan de él; busca las palabras y no las encuentra."
,"8":"El que adquiere inteligencia se ama a sí mismo, el que obra con inteligencia encuentra la felicidad."
,"9":"El testigo falso no quedará impune, quien profiere mentiras perecerá."
,"10":"No cuadra al necio vivir con lujo, menos aún a un esclavo gobernar a los príncipes."
,"11":"La cordura del hombre le hace ser paciente, su gloria es disimular las ofensas."
,"12":"Como rugido de león es la cólera del rey, pero su favor es como rocío sobre hierba."
,"13":"Un hijo necio es el tormento de su padre, y mujer pendenciera una gotera continua."
,"14":"Casa y hacienda son la herencia de los padres, pero una mujer inteligente es un don del Señor."
,"15":"La pereza hace caer en el sopor, la persona indolente pasará hambre."
,"16":"El que guarda el precepto a sí mismo se guarda, el que desprecia la palabra morirá."
,"17":"El que hace caridad al pobre presta al Señor, él le recompensará su obra."
,"18":"Castiga a tu hijo mientras hay esperanza, pero no te excedas hasta matarlo."
,"19":"Al hombre violento hay que castigarlo, porque si le perdonas le harás más violento."
,"20":"Escucha el consejo y acepta la corrección,para ser sabio en el futuro."
,"21":"El hombre proyecta muchos planes, pero sólo se realiza el que quiere el Señor."
,"22":"Lo que al hombre se le pide es lealtad; más vale un pobre que un mentiroso."
,"23":"El temor del Señor conduce a la vida, se vive satisfecho y sin que visite la desgracia."
,"24":"El perezoso mete su mano en el plato, y luego ni siquiera la lleva a su boca."
,"25":"Castiga al insolente y el imprudente adquirirá prudencia, reprende al inteligente y comprenderá la ciencia."
,"26":"El que maltrata al padre y echa de la casa a la madre,es un hijo infame y degenerado."
,"27":"Hijo mío, si dejas de escuchar la instrucción, te apartarás de las palabras de la ciencia."
,"28":"Un testigo perverso se burla de la justicia, la boca de los criminales desborda de iniquidad."
,"29":"Para los insolentes está listo el bastón, los golpes para las espaldas de los necios."
}`)
	CurrentBook.AddChapter(20, `{
"1":"El vino es pendenciero, los licores insolentes; el que en ellos se pierde no es sabio."
,"2":"Como rugido de león es la ira del rey, quien la excita perjudica a su propia vida."
,"3":"Es un honor para el hombre evitar las contiendas, pero todo insensato se da a la disputa."
,"4":"En invierno el perezoso no ara; en la siega busca, pero en vano."
,"5":"El consejo está en el corazón humano como agua profunda, el hombre inteligente sabe sacarlo."
,"6":"Muchos hombres se proclaman hombres de bien, pero un hombre fiel, ¿quién lo encontrará?"
,"7":"El justo procede con honestidad, ¡dichosos sus hijos después de él!"
,"8":"Un rey sentado sobre el trono del juicio,disipa con su mirada todo mal."
,"9":"¿Quién puede decir: 'Tengo el corazón puro, estoy limpio de pecado'?"
,"10":"Doble peso y doble medida, dos cosas que aborrece el Señor."
,"11":"Ya con sus actos muestra el niño,si sus obras serán puras y rectas."
,"12":"El oído que oye y el ojo que ve, uno y otro los ha hecho el Señor."
,"13":"No ames el sueño para que no te empobrezcas, abre los ojos y te hartarás de pan."
,"14":"'¡Malo, malo!', dice el comprador, pero cuando ha comprado se felicita."
,"15":"Hay oro y abundancia de perlas, pero el objeto más precioso son los labios instruidos."
,"16":"Quítale el vestido porque salió fiador por un extraño, reténlo en beneficio de los desconocidos."
,"17":"Sabroso es al hombre el pan del fraude, pero luego se halla su boca llena de cascajo."
,"18":"Da consistencia a tus proyectos con el consejo, con sabias estrategias haz la guerra."
,"19":"El chismoso revela los secretos, no tengas trato con el que habla demasiado."
,"20":"El que maldice a su padre y a su madre,verá apagarse su lámpara entre tinieblas."
,"21":"Riqueza que se adquiere muy deprisa,al final será un fracaso."
,"22":"No digas: 'Devolveré el mal'; confía en el Señor, y él te salvará."
,"23":"El Señor aborrece el doble peso, y balanza falsa no es buena."
,"24":"El Señor dirige los pasos del hombre, ¿cómo puede comprender el hombre su camino?"
,"25":"Es un lazo para el hombre hacer a la ligera una promesa,y reflexionar sólo después de haberlo prometido."
,"26":"Un rey sabio acaba con los criminales,y hace pasar sobre ellos la rueda."
,"27":"El alma del hombre es la lámpara del Señor, escudriña todos los escondrijos de las entrañas."
,"28":"La bondad y fidelidad hacen la guardia al rey, su trono está fundado en la benevolencia."
,"29":"La gloria de los jóvenes es su vigor; el ornato de los ancianos, los cabellos blancos."
,"30":"Los golpes que dejan cardenales curan la maldad, las heridas curan hasta el fondo del ser."
}`)
	CurrentBook.AddChapter(21, `{
"1":"El corazón del rey es canal de agua en manos del Señor, él lo inclina hacia donde quiere."
,"2":"A los ojos del hombre todos sus caminos son rectos, pero es el Señor quien pesa los corazones."
,"3":"Practicar la justicia y la equidad agrada al Señor,más que los sacrificios."
,"4":"Ojos altaneros, corazón soberbio; la luz de los criminales es el delito."
,"5":"Los proyectos del diligente llevan a la ganancia, los del precipitado conducen a la miseria."
,"6":"Adquirir tesoros gracias a una lengua mentirosa,es vanidad efímera de quien busca la muerte."
,"7":"La rapiña de los delincuentes les hace caer en la red, porque se niegan a practicar la justicia."
,"8":"El camino del criminal es tortuoso, la conducta del inocente es recta."
,"9":"Mejor es vivir en un rincón del desván,que en amplia casa con mujer quisquillosa."
,"10":"El malvado sólo piensa en el mal, su prójimo no encuentra piedad ante él."
,"11":"Cuando el insolente es castigado, adquiere prudencia el imprudente; cuando el sabio es instruido, es él quien adquiere ciencia."
,"12":"El justo advierte cómo la casa del injusto,precipita al injusto en la ruina."
,"13":"El que cierra su oído al grito del pobre, también él clamará y no se le responderá."
,"14":"Un regalo en secreto calma la cólera, un don oculto la violenta ira."
,"15":"Para el justo practicar la justicia es una alegría, para los que obran mal es un terror."
,"16":"El hombre que se aparta del sendero de la prudencia,tendrá su morada en la asamblea de las sombras de los muertos."
,"17":"Estará en la miseria el que ama el placer, el que ama el vino y los perfumes no se enriquecerá."
,"18":"El injusto sirve de rescate por el justo, y el pérfido por el hombre recto."
,"19":"Mejor es habitar en un país desierto,que con una mujer quisquillosa e iracunda."
,"20":"Precioso tesoro y perfume hay en la casa del sabio, mas el necio lo disipa."
,"21":"El que practica la justicia y la misericordia,encontrará vida y honor."
,"22":"El sabio asalta una ciudad de héroes,y derriba la muralla en que aquélla confía."
,"23":"El que guarda su boca y su lengua,se preserva a sí mismo de angustias."
,"24":"'Insolente' es el nombre del soberbio, del arrogante, que obra con extrema insolencia."
,"25":"Los deseos del perezoso lo matan, porque sus manos rechazan el trabajo."
,"26":"Todo el día se lo pasa deseando, pero el justo da sin cesar."
,"27":"El sacrificio del injusto es un sacrilegio, pues lo ofrece con malas intenciones."
,"28":"El falso testimonio perecerá, el que sabe escuchar podrá hablar siempre."
,"29":"El delincuente aparenta seguridad, el hombre recto está seguro de su conducta."
,"30":"Ni sabiduría, ni inteligencia, ni consejo existen ante el Señor."
,"31":"Se apareja el caballo para el día del combate, pero del Señor depende la victoria."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Buena fama es preferible a grandes riquezas, la estima vale más que la plata y el oro."
,"2":"El rico y el pobre se encuentran, el Señor ha hecho al uno y al otro."
,"3":"El prudente ve el mal y se esconde, el imprudente pasa y sufre el daño."
,"4":"El fruto de la humildad es el temor del Señor, riqueza, honor y vida."
,"5":"Espinas y lazos en el camino del perverso; el que mira por su vida se aleja de ellos."
,"6":"Enseña al niño el buen camino, y aun cuando sea viejo no se apartará de él."
,"7":"El rico domina a los pobres, el que toma prestado es esclavo del que presta."
,"8":"El que siembra injusticia cosecha desventuras, el fruto de sus fatigas se evapora."
,"9":"El hombre misericordioso será bendecido, porque da de su pan al pobre."
,"10":"Expulsa al insolente y cesará la discordia, litigios e injurias se calmarán."
,"11":"El rey ama a los puros de corazón, el que tiene la gracia en sus labios es su amigo."
,"12":"Los ojos del Señor guardan la ciencia, él confunde las palabras del mentiroso."
,"13":"El perezoso dice: '¡Hay un león fuera, yo podría ser devorado en medio de la calle!'."
,"14":"Fosa profunda es la boca de la mujer adúltera, en ella caen los que el Señor maldice."
,"15":"La necedad va ligada al corazón del niño, pero la vara de la corrección la aleja de él."
,"16":"El que oprime a un pobre le enriquece, el que da a un rico se empobrece."
,"17":"Inclina tu oído y escucha mis palabras, aplica tu corazón a comprenderlas."
,"18":"Porque te será agradable conservarlas dentro de ti,y tenerlas siempre en tus labios."
,"19":"Para que tu confianza esté en el Señor, te hago conocer hoy tu camino."
,"20":"¿No te he escrito treinta capítulos,en los que hay consejos y ciencia,"
,"21":"para que puedas conocer la verdad de lo que hablas,y sepas responder al que te pregunta?"
,"22":"No robes al pobre porque es pobre, ni oprimas al débil en el tribunal;"
,"23":"porque el Señor defiende su causa,y quitará la vida a los que los despojan."
,"24":"No tengas amistad con el hombre violento, ni vayas con el hombre iracundo,"
,"25":"para que no aprendas sus caminos,y pongas un lazo a tu vida."
,"26":"No seas de los que adquieren compromisos, de los que salen fiadores de deudas."
,"27":"Si no tienes con qué pagar, te quitarán hasta la cama en que yaces."
,"28":"No cambies los linderos antiguos,que pusieron tus padres."
,"29":"¿Ves a un hombre hábil en su profesión?,Al servicio de reyes entrará. No quedará al servicio de la gente común."
}`)
	CurrentBook.AddChapter(23, `{
"1":"Cuando te sientes a la mesa de un grande, observa bien lo que está delante de ti."
,"2":"Pon un cuchillo en tu garganta, si tienes demasiado apetito."
,"3":"No codicies sus delicados manjares; es un alimento engañoso."
,"4":"No te fatigues por enriquecerte, renuncia a la ganancia injusta."
,"5":"Si fijas en ella tus ojos, ya no está allí, porque ha echado alas, como el águila ha volado hacia el cielo."
,"6":"No comas en compañía del hombre envidioso, ni codicies sus delicados manjares."
,"7":"Porque son como una tempestad en la garganta. 'Come y bebe', te dice él, pero su corazón no está contigo. "
,"8":"Vomitarás el bocado que has tragado, echarás a perder tus palabras aduladoras."
,"9":"No hables a oídos de necio, porque despreciará la sabiduría de tus discursos."
,"10":"No cambies los linderos antiguos,y no entres en el campo de los huérfanos,"
,"11":"porque poderoso es su vengador; él defenderá su causa contra ti."
,"12":"Aplica tu corazón a la doctrina, tus oídos a las palabras sabias."
,"13":"No ahorres a tu hijo la corrección; aunque le castigues con la vara, no morirá."
,"14":"Golpéale con la vara, y librarás su alma del abismo."
,"15":"Hijo mío, si tu corazón es sabio, también mi corazón se alegrará;"
,"16":"y mis entrañas exultarán de gozo,cuando tus labios digan cosas justas."
,"17":"No tengas envidia de los pecadores; antes bien, teme siempre al Señor,"
,"18":"porque así tendrás un porvenir,y tu esperanza no se verá frustrada."
,"19":"Escucha, hijo mío, y sé sabio, dirige tu corazón por el camino recto."
,"20":"No estés entre los bebedores de vino,ni seas de los que se ceban de carne."
,"21":"Porque el bebedor y el glotón se empobrecen, y el sueño hace vestir harapos."
,"22":"Escucha a tu padre, que te ha engendrado, y no desprecies a tu madre cuando se haga anciana."
,"23":"Hazte con la verdad y no la vendas; con la sabiduría, la instrucción y la inteligencia."
,"24":"El padre del justo rebosará de alegría, y la que dio a la vida un sabio se alegrará."
,"25":"Que pueda alegrarse de ti tu padre, y gozarse la que te engendró."
,"26":"Hijo mío, dame tu corazón,y ten los ojos fijos en mis consejos."
,"27":"Porque una fosa profunda es la prostituta,y un pozo estrecho la mujer ajena."
,"28":"Sí; como el ladrón, está ella al acecho, y entre los hombres multiplica los prevaricadores."
,"29":"¿Para quién los ayes?, ¿para quién los lamentos?, ¿para quién las disputas?, ¿para quién las quejas?, ¿para quién las heridas sin motivo?, ¿para quién los ojos amoratados?"
,"30":"Para los que se entretienen con el vino, para los que andan saboreando combinados."
,"31":"No mires al vino: ¡qué color de rosa!, ¡cómo brilla en la copa!, ¡qué suavemente pasa!"
,"32":"Pero luego acaba por morder como serpiente,y pica como una víbora."
,"33":"Tus ojos verán cosas extrañas, y tu corazón hablará despropósitos."
,"34":"Serás como un hombre acostado en alta mar,o acostado en la punta de un mástil."
,"35":"'Me han pegado... ¡No me ha dolido!,Me han golpeado... ¡No lo he sentido!,¿Cuándo me despertaré...? Iré a buscar más'."
}`)
	CurrentBook.AddChapter(24, `{
"1":"No tengas envidia de los delincuentes, ni desees estar con ellos;"
,"2":"porque su corazón medita la violencia,y sus labios sólo profieren maldades."
,"3":"Con la sabiduría se edifica la casa, con la inteligencia se consolida;"
,"4":"con la ciencia se llenan los graneros,de todos los bienes preciosos y deseables."
,"5":"Más vale el sabio que el poderoso, el hombre de ciencia que el vigoroso."
,"6":"Porque con estratagema se hace la guerra, la victoria se debe a la abundancia de consejeros."
,"7":"Demasiado sublime es para el insensato la sabiduría, en público no abre la boca."
,"8":"Quien piensa sólo en hacer mal,se llama intrigante."
,"9":"El insensato sólo piensa en locuras; todo el mundo aborrece al insolente."
,"10":"Si te muestras débil en tiempo de prosperidad, en el día de la desventura tu fuerza será flaqueza."
,"11":"Libra a los que son conducidos a la muerte, a los que llevan a la ejecución sálvalos."
,"12":"Si dices: 'Pero yo no lo sabía', el que pesa los corazones bien lo sabe, y el que vigila tu vida está informado; él dará a cada uno según sus obras."
,"13":"Come miel, hijo mío, porque es bueno; un panal de miel es dulce a tu paladar."
,"14":"Así es la ciencia y la sabiduría para tu alma; si la adquieres, tienes un porvenir,y tu esperanza no será frustrada."
,"15":"No aceches, criminal, la casa del justo, ni devastes su morada;"
,"16":"porque siete veces cae el justo, mas se levanta, pero los criminales se hundirán en la ruina."
,"17":"Si tu enemigo cae no te alegres, ni se goce tu corazón de su caída;"
,"18":"no sea que lo vea el Señor y le desagrade, y aparte de él su ira."
,"19":"No te irrites a causa de los malvados, ni envidies a los perversos."
,"20":"Porque no hay porvenir para el malvado, la lámpara de los perversos se apagará."
,"21":"Hijo mío, teme al Señor y al rey, no provoques ni al uno ni al otro;"
,"22":"porque de improviso surge su venganza, y ¿quién sabe el castigo que pueden dar los dos?"
,"23":"También éstas son palabras de los sabios: Tener acepción de personas en el juicio no está bien."
,"24":"Al que dice al malhechor: 'Tú eres justo', los pueblos le maldicen, las naciones le detestan;"
,"25":"pero los que hacen justicia son aplaudidos,y la gente los llena de bendiciones."
,"26":"Da un beso en los labios,al que da una respuesta justa."
,"27":"Ordena tus asuntos de fuera, cultiva diligentemente tu campo y luego edifica tu casa."
,"28":"No des falso testimonio contra tu prójimo, ni engañes con tus labios."
,"29":"No digas: 'Como él me ha hecho, así le haré yo a él; voy a dar a ese hombre lo que se merece'."
,"30":"Pasé junto al campo del holgazán, junto a la viña del hombre insensato;"
,"31":"y he aquí que eran todo ortigas, los cardos habían cubierto el suelo,y el muro de piedras se había derrumbado."
,"32":"Vi aquello y reflexioné, y de cuanto contemplé saqué esta lección:"
,"33":"un poco dormir, un poco adormecerse, un poco cruzar los brazos descansando;"
,"34":"y, como vagabundo, te viene la miseria,y la indigencia como ladrón."
}`)
	CurrentBook.AddChapter(25, `{
"1":"También éstos son proverbios de Salomón, que transcribieron los hombres de Ezequías, rey de Judá."
,"2":"Es gloria de Dios ocultar una cosa,y gloria de los reyes escudriñarla."
,"3":"La altura de los cielos, la profundidad de la tierra,y el corazón de los reyes son cosas insondables."
,"4":"Separa la escoria de la plata, y el platero hará una copa."
,"5":"Quita al malvado de la presencia del rey, y su trono se consolidará en la justicia."
,"6":"No te pavonees delante del rey, no te pongas en el puesto de los grandes;"
,"7":"porque más vale que se te diga: 'Sube acá', que ser humillado en presencia del príncipe. Lo que han visto tus ojos"
,"8":"no te apresures a llevarlo a juicio, porque ¿qué harás tú si el prójimo atestigua en contra tuya?"
,"9":"Arregla tu pleito con el prójimo, pero no descubras el secreto de otro"
,"10":"para que no te infame el que te escuche,y tu ignominia no pueda borrarse."
,"11":"Manzanas de oro sobre una fuente de plata, tal es la palabra dicha a su debido tiempo."
,"12":"Anillo de oro y joya de oro puro, tal es una sabia represión en un oído dócil."
,"13":"El frío de la nieve en el calor de la siega, tal es un mensajero fiel para quien le envía: refresca el ánimo de su señor."
,"14":"Nubes y viento, pero sin lluvia, tal es el hombre que presume de dar, pero no da."
,"15":"Con la paciencia se consigue persuadir al juez, y la lengua dulce rompe los huesos."
,"16":"¿Has encontrado miel? Come sólo lo necesario; no sea que, harto, la vomites."
,"17":"Pon rara vez tu pie en la casa de tu vecino, no sea que se canse de ti y te aborrezca."
,"18":"Maza, espada y saeta aguda, tal es el hombre que da un falso testimonio contra su prójimo."
,"19":"Diente quebrado y pie resbaladizo, tal es el pérfido en que uno confía en el día de la desgracia; como el que se quita la ropa en un día de frío."
,"20":"Echar vinagre sobre una llaga,es cantar canciones a un corazón afligido."
,"21":"Si tu enemigo tiene hambre, dale de comer; si tiene sed, dale de beber,"
,"22":"porque así amontonas ascuas sobre su cabeza,y el Señor te recompensará."
,"23":"El viento del norte trae la lluvia; la lengua detractora, un rostro airado."
,"24":"Mejor es vivir en un rincón del desván,que en amplia casa con mujer quisquillosa."
,"25":"Agua fresca para garganta sedienta, tal es una buena noticia que viene de tierra lejana."
,"26":"Fuente turbia y manantial corrompido, tal es un justo que tiembla delante de un injusto."
,"27":"No es bueno comer demasiada miel, ni cargar de alabanzas la gloria."
,"28":"Ciudad abierta, sin muros, tal es el hombre que no tiene control de sí mismo."
}`)
	CurrentBook.AddChapter(26, `{
"1":"Como la nieve en el verano o la lluvia en la siega, así le cae la gloria al necio."
,"2":"Como un pájaro que escapa y una golondrina que vuela, así la maldición sin motivo no tiene efecto."
,"3":"El látigo para el caballo, la brida para el asno,y la vara para las espaldas de los necios."
,"4":"No respondas al necio según su insensatez, para que no te hagas semejante a él tú también."
,"5":"Responde al necio según su insensatez, para que no se tenga por sabio."
,"6":"Se corta las piernas y apura amarguras,el que envía mensajes por medio de un necio."
,"7":"El cojo no va lejos con sus piernas, así el proverbio en la boca del necio."
,"8":"Como el que mete la piedra en la honda, es el que da honor al necio."
,"9":"Como un ramo de espino en la mano de un borracho, así el proverbio en la boca del necio."
,"10":"Como un arquero que hiere a cuantos pasan, así es el que emplea a un necio y a un borracho."
,"11":"Como perro que vuelve a lo que vomitó, así el necio repite sus sandeces."
,"12":"¿Ves a un hombre que se tiene por sabio?,Más se puede esperar de un necio que de él."
,"13":"El holgazán dice: '¡Hay un león en el camino, un león en medio de la plaza!'."
,"14":"La puerta da vueltas sobre sus quicios, y sobre su lecho el holgazán."
,"15":"El holgazán mete su mano en el plato, y le fatiga aun el llevarla a su boca."
,"16":"El holgazán se imagina que es sabio, más que siete personas que responden con tino."
,"17":"Es coger a un perro por las orejas,entrometerse en pleito de otro."
,"18":"Como un loco que lanza llamas, saetas y muerte,"
,"19":"así es el que engaña a su prójimo,y luego dice: 'Lo hice en broma'."
,"20":"Por falta de leña se apaga el fuego; si no hay chismoso, se calma la contienda."
,"21":"Carbón sobre brasas y leña sobre fuego; tal es el hombre pendenciero para encender querellas."
,"22":"Las palabras del chismoso son bocados exquisitos, bajan hasta el fondo de las entrañas."
,"23":"Barniz de plata aplicado a vasija de tierra, tales son los labios dulces y el corazón malvado."
,"24":"El que odia se enmascara con sus palabras, pero en su interior aloja la perfidia;"
,"25":"si adopta un tono amistoso, no te fíes de él, porque su corazón está lleno de maldad;"
,"26":"el odio puede ocultarse bajo la simulación, pero su malicia será desenmascarada en la asamblea."
,"27":"El que cava una fosa caerá en ella, y al que rueda una piedra se le viene encima."
,"28":"La lengua mentirosa odia la verdad, y la boca aduladora causa la ruina."
}`)
	CurrentBook.AddChapter(27, `{
"1":"No presumas del día de mañana, porque no sabes lo que te puede traer un día."
,"2":"Que te alabe otro, pero no tu boca; un extraño, pero no tus labios."
,"3":"Pesada es la piedra y pesada es la arena, pero el fastidio que causa el insensato,es más pesado que ambas cosas."
,"4":"Cruel es el furor e impetuosa la ira, pero ¿quién podrá resistir ante la envidia?"
,"5":"Más vale una reprensión abierta,que un amor callado."
,"6":"Los golpes de un amigo son leales, los besos de un enemigo son falsos."
,"7":"El que está harto pisotea incluso el panal de miel, pero al que tiene hambre hasta lo amargo le es dulce."
,"8":"Cual pájaro errante lejos de su nido, tal es el hombre errante lejos de su lugar natal."
,"9":"El perfume y el incienso alegran el corazón, el consejo y la ciencia son la delicia del alma."
,"10":"No abandones a tu amigo ni al amigo de tu padre, no vayas a casa de tu hermano el día de tu desgracia. Más vale un amigo cercano que un hermano lejano."
,"11":"Hijo mío, sé sabio y alegra mi corazón,para que pueda responder al que me insulta."
,"12":"El prudente ve el mal y se esconde, mas los imprudentes pasan y sufren el castigo."
,"13":"Quítale el vestido, porque salió fiador por un extraño; reténle en beneficio de los desconocidos."
,"14":"El que en voz alta bendice a su prójimo,por la mañana temprano es exactamente igual que si lo insultara."
,"15":"Gotera constante en día de lluvia,y mujer quisquillosa son iguales."
,"16":"El que quiere frenarla quiere frenar el viento,y aferrar el aceite con la mano."
,"17":"El hierro se aguza con el hierro, y el hombre se afina al contacto con su prójimo."
,"18":"El que guarda la higuera come de su fruto, el que vigila sobre su señor recibirá honores."
,"19":"Como el rostro se refleja en el agua, así el corazón del hombre se refleja en la conciencia."
,"20":"El abismo y el infierno son insaciables, los ojos del hombre son también insaciables."
,"21":"El crisol prueba la plata y el fuego el oro, y al hombre la voz del que lo alaba."
,"22":"Aun cuando trituraras el insensato en el mortero,con el pilón de majar trigo, su necedad no se separaría de él."
,"23":"Cuida bien de tu grey, preocúpate de tus rebaños,"
,"24":"porque la riqueza no es eterna,y un tesoro no se transmite de generación en generación."
,"25":"Cuando se ha segado el heno, ha aparecido el rebrote,y se han recogido las hierbas de los montes,"
,"26":"tendrás corderos para vestirte,y cabritos para pagar las labores del campo,"
,"27":"leche de cabras en abundancia para sustentarte, para alimentar tu casa y mantener a tus criados."
}`)
	CurrentBook.AddChapter(28, `{
"1":"El criminal huye sin que nadie lo persiga, pero el justo se siente seguro como un león."
,"2":"Por los delitos de un país son muchos sus gobernantes, pero con un hombre inteligente y sabio el orden dura."
,"3":"Hombre perverso que oprime a los pobres,es lluvia devastadora que priva de pan."
,"4":"Los que abandonan la ley alaban al delincuente, mas los que observan la ley se irritan con él."
,"5":"Los delincuentes no comprenden la justicia, pero los que buscan al Señor lo comprenden todo."
,"6":"Más vale el pobre que vive honestamente,que el hombre de caminos torcidos aunque sea rico."
,"7":"El que guarda la ley es un hijo inteligente, el que frecuenta los libertinos es la vergüenza de su padre."
,"8":"El que con usura e intereses aumenta sus bienes,los acumula para el que tiene piedad de los pobres."
,"9":"El que aparta su oído para no escuchar la ley, incluso su oración es un sacrilegio."
,"10":"El que desvía a los hombres rectos por un mal camino, en su propia fosa caerá. Los hombres íntegros obtendrán la felicidad."
,"11":"El rico se tiene por sabio, pero el pobre inteligente sabe desenmascararlo."
,"12":"Cuando los justos triunfan, la fiesta es grande; cuando dominan los injustos, todo el mundo se esconde."
,"13":"El que oculta sus faltas no prosperará, el que las reconoce y las abandona obtendrá misericordia."
,"14":"Dichoso el hombre que está siempre en el temor, el que endurece su corazón caerá en la desventura."
,"15":"León rugiente y oso hambriento, tal es el príncipe que oprime a un pueblo pobre."
,"16":"Un príncipe falto de sentido multiplica las extorsiones, el que aborrece la avaricia prolongará sus días."
,"17":"Un hombre perseguido por homicidio, hasta la tumba huirá; no se le socorre."
,"18":"El que observa una conducta íntegra será salvo, el que sigue caminos tortuosos en uno caerá."
,"19":"El que cultiva su campo se hartará de pan, el que va detrás de quimeras se hartará de miseria."
,"20":"El hombre fiel tendrá abundantes bendiciones, el que se apresura a enriquecerse no estará sin culpa."
,"21":"No es bueno tener acepción de personas, por un bocado de pan el hombre peca."
,"22":"El hombre avaro corre detrás de las riquezas,y no se da cuenta de que la miseria va a caer sobre él."
,"23":"El que reprende a uno al fin,encontrará más favor,que el que le trata con lengua aduladora."
,"24":"El que roba a su padre o a su madre diciendo: 'No es pecado', ése es compañero de bandidos."
,"25":"El hombre envidioso suscita querellas, el que confía en el Señor prosperará."
,"26":"El que confía en su propio sentido es un necio, el que obra con sabiduría ése será salvo."
,"27":"El que da a los pobres no sufrirá la miseria, el que cierra sus ojos será maldito."
,"28":"Cuando los malos dominan, todo el mundo se esconde; cuando desaparecen, los justos se multiplican."
}`)
	CurrentBook.AddChapter(29, `{
"1":"El hombre que ante los reproches se hace más terco,será quebrantado de repente y sin remedio."
,"2":"Cuando los justos gobiernan, el pueblo está alegre; cuando dominan los opresores, el pueblo gime."
,"3":"El que ama la sabiduría alegra a su padre, el que frecuenta las prostitutas disipa su hacienda."
,"4":"El rey con la justicia hace prosperar el país, el que sólo exige impuestos lo lleva a la ruina."
,"5":"El hombre que adula a su prójimo,le tiende un lazo a los pies."
,"6":"En el camino del delincuente hay una trampa, el justo corre el suyo lleno de alegría."
,"7":"El justo comprende los derechos de los pobres, pero el injusto no se interesa en eso."
,"8":"Los violentos agitan la ciudad, los sabios calman la ira."
,"9":"Cuando un sabio discute con un insensato, ya se irrite éste, ya se ría, a ninguna solución llegará."
,"10":"Los hombres sanguinarios odian al hombre íntegro, los hombres rectos cuidan de su vida."
,"11":"El necio da curso libre a toda su cólera, el sabio, frenándola, la calma."
,"12":"Cuando el gobernante hace caso de las mentiras, corrompe a todos sus servidores."
,"13":"El pobre y el usurero se encuentran, ambos reciben del Señor la luz del día."
,"14":"El rey que juzga a los pobres con justicia,hace firme su trono para siempre."
,"15":"La vara y la corrección dan sabiduría, el muchacho consentido es la vergüenza de su madre."
,"16":"Cuando dominan los malhechores, se multiplica el crimen; pero los justos verán su caída."
,"17":"Corrige a tu hijo y te dará descanso, será las delicias de tu alma."
,"18":"Cuando no hay visión profética, el pueblo vive sin freno; dichosos los que observan la ley."
,"19":"No se corrige a un esclavo con palabras, porque comprende, pero no obedece."
,"20":"¿Ves a un hombre pronto para las palabras?,De un necio se puede esperar más que de él."
,"21":"El que desde la infancia trata suavemente a un esclavo, al fin será maltratado por él."
,"22":"Un hombre iracundo provoca querellas, un hombre colérico multiplica las faltas."
,"23":"El orgullo del hombre causa su humillación, pero el humilde de espíritu obtiene el honor."
,"24":"El cómplice del ladrón se odia a sí mismo, porque oye la maldición y no denuncia."
,"25":"El temer delante de los hombres es un lazo, el que confía en el Señor está seguro."
,"26":"Muchos buscan el favor del príncipe, pero el derecho de cada uno viene del Señor."
,"27":"Los hombres justos odian a los criminales,y los criminales odian a los justos."
}`)
	CurrentBook.AddChapter(30, `{
"1":"Palabras de Agur, hijo de Yaqué, de Masá. Oráculo de este hombre para Itiel y para Ucal."
,"2":"Como soy el más ignorante de los hombres,y no poseo la inteligencia humana,"
,"3":"no he aprendido la sabiduría,ni conozco la ciencia del santísimo."
,"4":"¿Quién subió a los cielos y después bajó?,¿Quién ha encerrado el viento en sus puños?,¿Quién ató las aguas en su manto?,¿Quién estableció todos los límites de la tierra?,¿Cómo se llama? ¿Cuál es el nombre de su hijo?,¿Lo sabes tú?"
,"5":"Toda palabra de Dios es acrisolada; él es un escudo para los que en él se refugian."
,"6":"No añadas nada a sus palabras,para que no te reprenda y te tenga por falsario."
,"7":"Dos cosas te pido; no me las niegues antes de que muera."
,"8":"Aleja de mí falsedad y mentira, no me des pobreza ni riqueza. Concédeme el pan necesario,"
,"9":"no sea que, saciado, reniegue de ti,y diga: '¿Quién es el Señor?'; o que, siendo pobre, robe y profane el nombre de mi Dios."
,"10":"No calumnies a un criado ante su amo, no sea que te maldiga y tengas que sufrir la pena."
,"11":"Raza que maldice a su padre,y no bendice a su madre;"
,"12":"raza que se tiene por pura, pero que no se ha lavado de sus inmundicias;"
,"13":"raza de miradas altaneras,y de párpados altivos;"
,"14":"raza cuyos dientes son espadas y cuchillos sus molares,para devorar a los humildes de la tierra,y acabar con los pobres del país."
,"15":"La sanguijuela tiene dos hijas: 'Dame, dame'. Tres cosas hay que no se hartan, y cuatro que nunca dicen: 'Basta'."
,"16":"El abismo, la matriz estéril, la tierra que el agua no puede saciar, el fuego que nunca dice: 'Basta'."
,"17":"El ojo que se burla de un padre,y que desprecia la edad de su madre, los cuervos del torrente lo sacarán,y los hijos del águila lo devorarán."
,"18":"Hay tres cosas que son misteriosas para mí, y cuatro que no comprendo:"
,"19":"el sendero del águila en los cielos, el sendero de la serpiente sobre la roca, el sendero del navío en alta mar, el sendero del hombre en la doncella."
,"20":"Tal es la conducta de la mujer adúltera: ella come, luego se limpia la boca,y dice: 'No he hecho nada malo'."
,"21":"Tres cosas hay que hacen temblar la tierra, y cuatro que no puede soportar:"
,"22":"un esclavo que llega a ser rey, un fatuo que tiene pan en abundancia,"
,"23":"una mujer aborrecida que encuentra marido,y una criada que suplanta a su señora."
,"24":"Hay cuatro seres minúsculos en la tierra, pero son sabios entre los sabios:"
,"25":"las hormigas, pueblo sin fuerza, pero que, en el verano, asegura su provisión;"
,"26":"los damanes, pueblo sin vigor, pero que se hace su cubil en las rocas;"
,"27":"las langostas, que no tienen rey, pero todas marchan en bandas ordenadas;"
,"28":"el lagarto que se agarra con la mano, pero que se encuentra en los palacios del rey."
,"29":"Hay tres seres de buen andar, y cuatro de hermosa marcha:"
,"30":"el león, el más fuerte de los animales, que no retrocede ante nada;"
,"31":"el gallo que se pasea con gallardía entre sus gallinas; el macho cabrío que va conduciendo su manada, y el rey cuando arenga a su pueblo."
,"32":"Si has sido tan necio que te has alabado y luego reflexionaste, ponte la mano en la boca;"
,"33":"porque batiendo la leche se saca la manteca, oprimiendo la nariz se saca sangre,y oprimiendo la ira se suscita la querella."
}`)
	CurrentBook.AddChapter(31, `{
"1":"Palabras de Lemuel, rey de Masá, que su madre le enseñó:"
,"2":"¡Qué, hijo mío! ¿Qué, Lemuel, mi primogénito, he de decirte? ¿Qué, hijo de mis entrañas? ¿Qué, hijo de mis promesas?"
,"3":"No des tu vigor a las mujeres, ni tus flancos a las que corrompen a los reyes."
,"4":"No está bien a los reyes, ¡oh Lemuel!, no está bien a los reyes beber vino, ni a los príncipes amar los licores."
,"5":"No sea que, bebiendo, olviden las leyes,y alteren el derecho de todos los afligidos."
,"6":"Dad los licores al que va a perecer, el vino al corazón lleno de amargura."
,"7":"Que él beba y olvide su miseria,y que no se acuerde más de sus penas."
,"8":"Abre tu boca en favor del mudo, por la causa de todos los desventurados."
,"9":"Abre tu boca, pronuncia justas sentencias,y haz justicia al desventurado y al pobre."
,"10":"Una mujer perfecta, ¿quién la encontrará?,Vale mucho más que las perlas."
,"11":"Confía en ella el corazón de su marido,y no cesa de tener ganancia."
,"12":"Ella le procura el bien,y nunca el mal todos los días de su vida."
,"13":"Busca lana y lino, y trabaja con su mano solícita."
,"14":"Es como una nave mercante,que de lejano trae sus víveres."
,"15":"Se levanta cuando todavía es de noche, distribuye la comida a su casa,y las tareas a sus criadas."
,"16":"Desea un campo y lo compra, con el fruto de sus manos planta una viña."
,"17":"Ciñe sus lomos de fortaleza,y emplea la fuerza de sus brazos."
,"18":"Constata que su industria prospera, su lámpara no se apaga por la noche."
,"19":"Echa mano a la rueca,y sus dedos giran el huso."
,"20":"Tiende su brazo al desgraciado,y alarga la mano al indigente."
,"21":"No teme la nieve para su casa, porque toda su familia lleva doble vestido."
,"22":"Ella se hace cobertores, lino fino y púrpura la visten."
,"23":"En las puertas de la ciudad su marido es estimado, cuando se sienta con los ancianos del país."
,"24":"Teje telas de lino y las vende, y procura cinturones a los mercaderes."
,"25":"Se reviste de fortaleza y de gracia, y mira gozosa el porvenir."
,"26":"Abre su boca con sabiduría, y en su lengua hay una doctrina de bondad."
,"27":"Vigila la marcha de su casa, y no come el pan de la ociosidad."
,"28":"Sus hijos se levantan para proclamarla dichosa, su marido para hacer su elogio:"
,"29":"'Muchas hijas se han mostrado virtuosas, pero tú superas a todas'."
,"30":"Engañosa es la gracia, vana la belleza; la mujer que teme al Señor, ésa debe ser alabada."
,"31":"Dadle del fruto de sus manos,y que en las puertas de la ciudad,sus obras proclamen su alabanza."
}`)

}
func ES_LSB_LoadVSPSChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Dichoso el hombre que no sigue el consejo de los injustos, ni anda por el camino de los extraviados, ni se sienta en el banco de los cínicos;"
,"2":"sino que en la ley del Señor pone su amor,y en ella medita noche y día."
,"3":"Es como un árbol a orillas del arroyo, que da el fruto a su tiempo, cuyas hojas no se marchitan nunca; en todo lo que hace sale bien."
,"4":"No así los injustos, no; son como paja que dispersa el viento."
,"5":"Los injustos no podrán resistir en el juicio,ni los descarriados en la asamblea de los justos."
,"6":"Porque el Señor cuida el camino de los justos, pero el de los injustos lleva a la ruina."
}`)
	CurrentBook.AddChapter(2, `{
"1":"¿Por qué se amotinan las naciones,y los pueblos hacen proyectos vanos?"
,"2":"Se levantan los reyes de la tierra, los príncipes conspiran contra el Señor y su mesías:"
,"3":"'¡Rompamos sus cadenas, sacudamos su yugo!'."
,"4":"El que mora en el cielo se sonríe, el Señor se burla de ellos."
,"5":"Luego les habla enfurecido, y con su ira los llena de terror:"
,"6":"'Ya tengo yo a mi rey entronizado,sobre Sión, mi monte santo'."
,"7":"Proclamaré el decreto que el Señor ha pronunciado: 'Tú eres mi hijo, yo mismo te he engendrado hoy."
,"8":"Pídeme y te daré en herencia las naciones, en propiedad los confines de la tierra."
,"9":"Los destrozarás con un cetro de hierro, los triturarás como a vasos de alfarero'."
,"10":"Ahora, pues, oh reyes, sed sensatos; dejaos corregir, oh jueces de la tierra."
,"11":"Servid al Señor con reverencia, postraos temblorosos ante él,"
,"12":"para que no se irrite y os veáis perdidos, pues su cólera se inflama en un instante. ¡Dichosos los que en él buscan refugio!"
}`)
	CurrentBook.AddChapter(3, `{
"1":"Salmo de David cuando huía de su hijo Absalón"
,"2":"Señor, cuán numerosos son mis opresores, cuántos los que se alzan contra mí,"
,"3":"cuántos los que dicen de mi vida: 'Ya ni Dios lo salva'."
,"4":"Mas tú, Señor, eres mi escudo, tú eres mi gloria, tú alzas mi cabeza."
,"5":"Mi clamor levanto hacia el Señor, y él me atiende desde su santo monte."
,"6":"Yo me acuesto, me duermo y me despierto: el Señor es mi apoyo."
,"7":"No temo a los hombres sin cuento,que por doquier se apostan contra mí."
,"8":"Levántate, Señor; sálvame, Dios mío. Tú das de bofetadas a todos mis enemigos,y rompes los dientes a los malhechores."
,"9":"En ti, Señor, está la salvación: caiga tu bendición sobre tu pueblo."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Al maestro de coro. Para instrumentos de cuerda. Salmo de David"
,"2":"Cuando te invoco, tú me atiendes, oh Dios de mi justicia, en la angustia me alivias; ten piedad, escucha mi oración."
,"3":"Vosotros, hombres, ¿hasta cuándo ultrajaréis mi honor, amaréis vanidad y buscaréis mentira?"
,"4":"Sabed que el Señor distingue al que le es fiel, el Señor me escucha cuando yo le invoco."
,"5":"Temblad, y no pequéis; meditad en silencio en vuestro lecho."
,"6":"Ofreced sacrificios de justicia,y tened confianza en el Señor."
,"7":"Muchos dicen: '¿Quién nos traerá suerte?'. ¡Mándanos, Señor, la luz de tu semblante!"
,"8":"Tú has dado a mi corazón más alegría,que la de ellos cuando cosechan trigo y vino en abundancia."
,"9":"Me acuesto en paz y en seguida me duermo, pues tú solo, Señor, me haces vivir tranquilo."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Al maestro de coro. Para flautas. Salmo de David"
,"2":"Escucha mis palabras, Señor, atiende a mi gemido,"
,"3":"oye la voz de mi lamento, Rey mío y Dios mío."
,"4":"A ti, Señor, te invoco; de mañana me escuchas, de mañana me dirijo a ti y me quedo esperando."
,"5":"Tú no eres un Dios que se complace en la injusticia, el malvado no puede ser tu huésped."
,"6":"Los soberbios no resisten delante de tus ojos, aborreces a todos los malhechores,"
,"7":"llevas a la ruina a los mentirosos, al hombre explotador y fraudulento el Señor lo detesta."
,"8":"Mas yo, por tu infinita bondad, entro en tu casa, me postro hacia tu templo con toda reverencia."
,"9":"Guíame tú, Señor, por tu justicia, frente a mis opresores, allana tus caminos ante mí."
,"10":"En su boca no hay sinceridad, su corazón está lleno de maldades; sepulcro abierto es su garganta, aunque su lengua sea melosa."
,"11":"Castígalos, oh Dios, castígalos, que caigan presos en sus propios planes; recházalos por sus crímenes sin cuento, por haberse rebelado contra ti."
,"12":"Que se alegren en cambio los que en ti confían, que siempre estén alegres, porque tú los proteges; que se gocen en ti los que aman tu nombre."
,"13":"Pues tú, Señor, bendices al que es justo, como un escudo lo protege tu favor."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Al maestro de coro. Para instrumentos de cuerda. En octava. Salmo de David"
,"2":"Señor, no me castigues cuando estés airado, no me reprendas cuando estés enfurecido;"
,"3":"ten compasión de mí, Señor; sáname, que mis huesos se dislocan."
,"4":"Yo estoy totalmente deshecho; y tú, Señor, ¿hasta cuándo?"
,"5":"Ven, Señor, y sálvame la vida, sálvame, por tu misericordia,"
,"6":"que entre los muertos no hay recuerdo de ti, en el abismo, ¿quién te puede alabar?"
,"7":"Estoy ya consumido de tanto sufrimiento; cada noche empapo yo mi almohada, inundo de lágrimas mi lecho."
,"8":"Mis ojos se consumen de dolor, se agotan entre tantos opresores."
,"9":"Lejos de mí, vosotros, agentes de maldad, pues el Señor escucha el grito de mi llanto;"
,"10":"el Señor atiende mi súplica, el Señor acoge mi oración."
,"11":"Queden mis enemigos confusos, aterrados, y huyan al instante avergonzados."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Poema que David cantó al Señor con motivo del benjaminita Cus"
,"2":"Señor, Dios mío, tú eres mi refugio, sálvame de mis perseguidores, sálvame;"
,"3":"no sea que, como leones, me desgarren, me despedacen sin que haya quien me libre."
,"4":"Señor, Dios mío, si algo de esto hice: si en mis manos existe la injusticia,"
,"5":"si he devuelto a mi amigo mal por bien, si me puse a favor del opresor injusto,"
,"6":"que el enemigo me persiga y que me alcance, que me estrelle vivo contra el suelo,y esparza mis entrañas en el polvo."
,"7":"Señor, levántate con ira, reprime la furia de mis opresores, ponte de mi parte, tú que has ordenado hacer justicia."
,"8":"Que la asamblea de los pueblos se reúna en torno a ti y presídela tú desde tu trono."
,"9":"El Señor juzga a las naciones. Júzgame, Señor, conforme a mi justicia,y según mi inocencia."
,"10":"Pon fin a la perfidia de los criminales y afianza al justo, tú que escrutas el corazón y las entrañas, el Dios que hace justicia."
,"11":"Es Dios el escudo que me cubre, el que salva los corazones rectos."
,"12":"Dios es un juez justo, un Dios que castiga el delito en todo tiempo."
,"13":"Si no se convierten, él afila su espada, tensa su arco y lo ajusta;"
,"14":"prepara armas mortíferas, dispone sus flechas incendiarias."
,"15":"Ved cómo el malvado engendra el crimen, concibe el engaño y da a luz la mentira."
,"16":"Cava una fosa bien profunda,y cae en la fosa que él mismo excavó;"
,"17":"su crimen cae sobre su cabeza,y su violencia sobre su propia cerviz."
,"18":"Alabaré al Señor por su justicia, ensalzaré el nombre del altísimo."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Al maestro de coro. Para la de Gat. Salmo de David"
,"2":"¡Oh Dios, Señor nuestro, qué admirable es tu nombre por toda la tierra, tu majestad se asienta encima de los cielos!"
,"3":"De los labios de los niños,y de los que maman te has hecho una fortaleza frente al agresor, para reducir al enemigo y al rebelde."
,"4":"Cuando veo los cielos, obra de tus manos, la luna y las estrellas que creaste,"
,"5":"¿qué es el hombre para que te acuerdes de él, el ser humano para que de él te preocupes?"
,"6":"Apenas inferior a un dios lo hiciste, lo coronaste de gloria y dignidad;"
,"7":"le diste el señorío de la obra de tus manos, bajo sus pies todo lo pusiste:"
,"8":"ovejas y bueyes, todos juntos, y hasta las bestias del campo,"
,"9":"las aves del cielo y los peces del mar, cuanto surca las sendas de las aguas."
,"10":"¡Oh Dios, Señor nuestro, qué admirable es tu nombre por toda la tierra!"
}`)
	CurrentBook.AddChapter(9, `{
"1":"Al maestro de coro. Para oboe y arpa. Salmo de David"
,"2":"Te doy gracias, Señor, de todo corazón, quiero cantar tus maravillas;"
,"3":"quiero alegrarme y recrearme en ti, ensalzar tu nombre, oh Dios altísimo."
,"4":"Mientras mis enemigos retroceden, flaquean y caen ante ti;"
,"5":"tú has defendido mi derecho,y me has hecho justicia, sentado en el tribunal, como juez justo."
,"6":"Has vencido a las gentes, destruido al malvado, has borrado su nombre para siempre;"
,"7":"acabó el enemigo en ruina eterna, has destruido sus ciudades, se perdió su recuerdo."
,"8":"Pero el Señor reina eternamente, y tiene preparado su trono para el juicio;"
,"9":"juzga al mundo con justicia, dicta sentencia a las naciones."
,"10":"El Señor es refugio para los oprimidos, su refugio en los tiempos de la angustia."
,"11":"En ti esperan los que saben tu nombre, pues no abandonas, Señor, a quien te busca."
,"12":"Cantad al Señor, que mora en Sión, publicad por los pueblos sus hazañas:"
,"13":"Él, vengador de la sangre, se acuerda de ellos, no olvida el grito de los oprimidos."
,"14":"Piedad, Señor, mira cómo me aplasta mi enemigo, sácame de las puertas de la muerte,"
,"15":"para que pueda cantar tus alabanzas a las puertas de Sión, gozoso porque me has salvado."
,"16":"Los paganos cayeron en su propia trampa, su pie quedó prendido en la red que tramaron,"
,"17":"el Señor se ha dado a conocer, ha hecho justicia, ha enredado al malvado en la obra de sus manos."
,"18":"Retornen los malvados al abismo,y todas las naciones que se olvidan de Dios."
,"19":"Que no por siempre estará el pobre en el olvido, no se pierde por siempre la esperanza del mísero."
,"20":"Levántate, Señor, que el hombre no se engría, sean las gentes juzgadas ante ti;"
,"21":"Señor, infúndeles terror, y aprendan los hombres que son seres mortales."
}`)
	CurrentBook.AddChapter(10, `{
"1":"¿Por qué te quedas lejos, Señor, y te escondes en los tiempos de la angustia?"
,"2":"Con su orgullo el criminal al infeliz oprime; ¡quede preso en la redada que le ha urdido!"
,"3":"El malvado se jacta de sus propios planes, el avaro blasfema, desprecia al Señor;"
,"4":"el malvado dice con arrogancia: '¡No hay Dios!', es todo lo que piensa."
,"5":"Su proceder prospera en todo tiempo, tus sentencias quedan muy lejos para él, se burla de todos sus rivales;"
,"6":"dice en su corazón: 'Yo no vacilo, seré siempre feliz, nunca en desgracia'."
,"7":"Su boca está llena de violencia y fraude, bajo su lengua sólo hay vejación y mentira;"
,"8":"se aposta al acecho junto a los poblados, a escondidas mata al inocente,"
,"9":"con sus ojos espía al desdichado; escondido como un león en su guarida, al acecho para atrapar al miserable, lo atrapa enredándolo en sus redes;"
,"10":"se agazapa y se encoge, el desvalido cae en sus garras."
,"11":"Dice en su corazón: 'Dios se ha olvidado, ha escondido su rostro, nada verá jamás'."
,"12":"Levántate, Señor, alza tu mano; oh Dios, no te olvides del pobre."
,"13":"¿Por qué el malvado ha de despreciar a Dios,pensando que no le pedirá cuentas?"
,"14":"Pero tú ves la pena y los lamentos, tú los miras y los tomas en tus manos; el desvalido se confía a ti, tú eres el refugio del huérfano."
,"15":"Quiebra el brazo del criminal,y del malvado, castiga su crueldad, no quede rastro."
,"16":"El Señor es rey por siempre, por los siglos; los paganos serán barridos de su tierra."
,"17":"Tú escuchas, Señor, el deseo de los pobres; su corazón confortas, les tiendes tus oídos"
,"18":"para hacer justicia al huérfano, al vejado; que el hombre, nacido de la tierra, no infunda más terror."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Al maestro de coro. De David,Yo busco mi refugio en el Señor; ¿por qué me andáis diciendo: 'Huye a los montes como un pájaro'?"
,"2":"Los asesinos tensan ya su arco, ajustan las flechas en la cuerda,para clavarlas de noche en el corazón del hombre honesto."
,"3":"Cuando están en ruina los cimientos, ¿qué podrá hacer el hombre justo?"
,"4":"El Señor está en su templo santo, el Señor tiene su trono en los cielos; sus ojos están fijos en el mundo, sus miradas exploran a los hombres."
,"5":"El Señor vigila al justo y al injusto, y odia a quien quiere la violencia;"
,"6":"hará llover brasas de fuego sobre los injustos, azufre y viento abrasador serán la porción de su copa."
,"7":"El Señor es justo y ama la justicia, los justos contemplarán su rostro."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Al maestro de coro. En octava. Salmo de David"
,"2":"Auxilio, Señor, que ya no hay hombres fieles, la lealtad ya no existe entre los hombres;"
,"3":"sólo mentiras dice el uno al otro, labios aduladores, doblez de corazón."
,"4":"Que el Señor corte el labio adulador,y la lengua arrogante"
,"5":"de todos los que dicen: 'La lengua es nuestra fuerza, los labios nuestras armas, ¿quién podrá dominarnos?'."
,"6":"'Por la opresión del débil y el gemido del pobre,ahora me levanto yo, dice el Señor, yo daré mi auxilio al que lo ansía'."
,"7":"Las palabras del Señor son palabras sinceras, plata pura refinada en el horno siete veces."
,"8":"Tú, Señor, nos guardarás de ellos, nos librarás para siempre de esa escoria;"
,"9":"por todas partes abundan los malvados, la vileza está al colmo entre los hombres."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Al maestro de coro. De David"
,"2":"¿Hasta cuándo, Señor, seguirás olvidándome?, ¿hasta cuándo me esconderás tu rostro?"
,"3":"¿Hasta cuándo tendré desazón en mi alma, y en mi corazón tristeza día y noche?,¿Hasta cuándo va a triunfar mi enemigo sobre mí?"
,"4":"Mira y escúchame, Señor, Dios mío; ilumina mis ojos, no me duerma en la muerte,"
,"5":"para que no diga mi enemigo: 'Le he vencido', ni gocen mis opresores al verme ya caído."
,"6":"Yo confío en tu amor, mi corazón se alegra por tu liberación,y cantaré al Señor por el bien que me ha hecho."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Al maestro de coro. De David,El insensato dice en su corazón: 'Dios no existe'; todos se han pervertido, todos obran mal, no hay quien obre bien."
,"2":"El Señor observa desde el cielo a los hombres, para ver si hay alguno cuerdo que busque a Dios."
,"3":"Todos están descarriados, en masa pervertidos, no hay nadie que obre bien, ni uno solo."
,"4":"¿No aprenderán los malvados,que devoran a mi pueblo como pan,y no invocan el nombre del Señor?"
,"5":"Pero a su hora temblarán de espanto, pues el Señor está con la raza de los justos;"
,"6":"se burlan de las esperanzas de los pobres, pero el Señor es su refugio."
,"7":"¡Ojalá venga de Sión la victoria de Israel!,Cuando el Señor reúna a los cautivos de su pueblo, exultará Jacob, se alegrará Israel."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Salmo de David,¿Quién podrá, Señor, hospedarse en tu casa, quién podrá morar en tu montaña santa?"
,"2":"El que vive sin tacha y practica la justicia; el que dice la verdad de corazón"
,"3":"y no habla mal de nadie con su lengua; el que no hace mal a su hermano ni difama a su vecino,"
,"4":"desprecia al criminal y honra a los que temen al Señor; el que, si jura en su perjuicio, ya no se desdice,"
,"5":"presta su dinero sin cobrar intereses,y no se deja sobornar contra el que es inocente. El que hace todo esto jamás perecerá."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Canto de David,Guárdame, Dios mío, pues me refugio en ti."
,"2":"Yo digo al Señor: 'Tú eres mi Señor, mi bien sólo está en ti'."
,"3":"Ellos, en cambio, veneran a los dioses que hay aquí en la tierra, malditos los que en ellos se complacen."
,"4":"Los que corren tras ellos aumentan sus desgracias. Yo jamás tendré parte en sus cruentos sacrificios, mis labios no pronunciarán jamás su nombre."
,"5":"Señor, tú eres mi copa y mi porción de herencia, tú eres quien mi suerte garantiza."
,"6":"Me han caído las cuerdas en la tierra más fértil, me encanta la heredad que me ha tocado."
,"7":"Yo bendigo al Señor, que me aconseja, hasta de noche mi conciencia me advierte;"
,"8":"tengo siempre al Señor en mi presencia, lo tengo a mi derecha y así nunca tropiezo."
,"9":"Por eso se alegra mi corazón, se gozan mis entrañas, todo mi ser descansa bien seguro,"
,"10":"pues tú no me entregarás a la muerte,ni dejarás que tu amigo fiel baje a la tumba."
,"11":"Me enseñarás el camino de la vida, plenitud de gozo en tu presencia, alegría perpetua a tu derecha."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Oración de David,Justicia, Señor, escúchame, atiende a mi clamor, presta oído a mi súplica, que no hay engaño en mí;"
,"2":"que en tu presencia resplandezca la justicia, que tus ojos vean en dónde está la razón."
,"3":"Explora mi corazón, vigílame de noche, pruébame en el crisol, no encontrarás en mí ningún delito;"
,"4":"mi boca no ha faltado como hacen los otros, he guardado siempre tus mandatos,"
,"5":"no he circulado nunca al margen de las leyes, mis pasos no vacilaron jamás por tus caminos."
,"6":"Yo te llamo porque tú me respondes, oh Dios mío; tiende hacia mí tu oído, escucha mis palabras."
,"7":"Despliega tu bondad, tú que salvas de sus opresores,a los que buscan refugio en tu derecha;"
,"8":"guárdame como a las pupilas de tus ojos, escóndeme a la sombra de tus alas,"
,"9":"lejos de los malvados que me oprimen, de los enemigos mortales que me cercan."
,"10":"Han endurecido sus entrañas,y sólo saben hablar con arrogancia;"
,"11":"siempre tras mis pasos, me tienen ya cercado, y sus ojos me clavan para echarme por tierra;"
,"12":"se parecen al león ávido de presa, al cachorro que acecha en su guarida."
,"13":"Levántate, Señor; sal a su encuentro, derríbalos; líbrame con tu espada del malvado."
,"14":"Que tu mano los aparte de la humanidad, fuera del mundo, que sea ésta su suerte en esta vida; cébalos, Señor, con tus reservas, que se hinchen sus hijos y haya sobras para sus pequeños."
,"15":"Yo, y esto es justicia, contemplaré tu rostro, al despertarme me saciaré de tu presencia."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Al maestro de coro. Del siervo de Dios, David, que entonó a Dios este cántico después de haber sido liberado de sus enemigos, especialmente de Saúl"
,"2":"Dijo:"
,"3":"Yo te amo, Señor, tú eres mi fuerza, mi roca, mi fortaleza, mi libertador, mi Dios, mi roca donde yo me refugio, mi escudo protector, mi salvación, mi asilo."
,"4":"¡Alabado sea Dios! Yo le invoco,y salgo victorioso de mis enemigos."
,"5":"Las olas de la muerte me envolvían, los torrentes del averno me espantaban,"
,"6":"los lazos del abismo me liaban, se tendían ante mí las trampas de la muerte."
,"7":"Clamé al Señor en mi angustia, alcé mi grito hacia mi Dios, y él escuchó mi voz desde su templo, mi grito llegó hasta sus oídos."
,"8":"Entonces se estremeció, tembló la tierra, las bases de los montes vacilaron, retemblaron al estallido de su ira;"
,"9":"una humareda subía de sus narices,y de su boca un fuego destructor, de él salían carbones encendidos."
,"10":"Inclinó los cielos y bajó; una densa nube debajo de sus pies;"
,"11":"montó sobre un querubín, emprendió el vuelo, sobre las alas del viento planeaba;"
,"12":"puso a su alrededor la oscuridad por tienda, agua tenebrosa y espesos nubarrones;"
,"13":"al resplandor de su presencia, las nubes se convirtieron en rayos y carbones encendidos;"
,"14":"el Señor tronó desde los cielos, el altísimo hizo sonar su voz;"
,"15":"lanzó sus flechas y los dispersó, fulminó sus rayos y los ahuyentó."
,"16":"Apareció el fondo de los mares, los cimientos de la tierra quedaron al desnudo, al fragor, Señor, de tu amenaza, al resollar del viento en tus narices."
,"17":"Desde arriba alargó la mano y me agarró, me sacó de las aguas caudalosas;"
,"18":"me libró de un adversario poderoso, de enemigos más potentes que yo."
,"19":"En el día de mi desgracia me asaltaron, pero el Señor se hizo mi apoyo;"
,"20":"me agarró, me puso a salvo, me libró porque me ama."
,"21":"El Señor me retribuye según mi justicia, me paga según la inocencia de mis manos;"
,"22":"porque he seguido los caminos del Señor,y no he sido nunca infiel a Dios;"
,"23":"todas sus leyes han estado ante mí,y no aparté de mí sus mandamientos,"
,"24":"fui para con él irreprochable,y estoy lejos de la injusticia."
,"25":"El Señor me retribuye según mi justicia, según la limpieza que ha visto en mis manos."
,"26":"Con el fiel tú eres fiel, con el hombre intachable, tú sin tacha;"
,"27":"con el sincero eres sincero, con el astuto procedes con astucia."
,"28":"Tú salvas al pueblo humilde,y humillas los ojos altaneros."
,"29":"Tú, Señor, eres mi lámpara; Dios mío, ilumina mis tinieblas."
,"30":"Confiado en ti corro a la lucha,y con mi Dios asalto las murallas."
,"31":"Oh Dios, su camino es perfecto, la palabra del Señor se cumple siempre, él es el escudo de los que se refugian en él."
,"32":"¿Quién es Dios fuera del Señor?,¿Quién es roca fuera de nuestro Dios?"
,"33":"El Dios que me ciñe de poder,y hace seguro mi camino,"
,"34":"que asemeja mis pies a los del ciervo,y me mantiene firme en las alturas,"
,"35":"adiestra mis manos para la lucha,y mis brazos para tensar arcos de bronce."
,"36":"Tú me das el escudo victorioso, tu diestra me sostiene, tus cuidados me hacen prosperar."
,"37":"Tú ensanchas el camino ante mis pasos,y mis pies no vacilan;"
,"38":"perseguí a mis enemigos, les di alcance, no me volví hasta acabar con ellos;"
,"39":"los derroté y no podían rehacerse, sucumbían debajo de mis pies."
,"40":"Me ceñiste de fortaleza en la batalla, aplastaste bajo mí a mis agresores;"
,"41":"me hiciste ver la espalda de mis enemigos,y exterminé a los que me odiaban."
,"42":"Gritaron, pero no hubo salvador; clamaron al Señor, pero no hubo respuesta."
,"43":"Los deshice como polvo al viento, los aplasté como el barro del camino."
,"44":"Me hiciste escapar de las sediciones de los pueblos, me pusiste a la cabeza de naciones, un pueblo que yo no conocía, ahora me sirve."
,"45":"Son todo oídos, me obedecen, los hijos de extranjeros forman mi corte;"
,"46":"los hijos de extranjeros palidecen,y abandonan temblando sus refugios."
,"47":"¡Viva el Señor, bendita sea mi roca!,¡Alabado sea Dios, el Dios de mi victoria!"
,"48":"El Dios que me concede la venganza,y sojuzga los pueblos a mis pies."
,"49":"Tú me libras de furiosos enemigos, me haces triunfar sobre mis agresores, me salvas del violento."
,"50":"Por eso, Señor, te alabaré entre las naciones, cantaré en honor de tu nombre;"
,"51":"Él da grandes victorias a su rey,y otorga su favor a su mesías, a David y a su descendencia para siempre."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Al maestro de coro. Salmo de David"
,"2":"Los cielos narran la gloria de Dios, el firmamento pregona la obra de sus manos,"
,"3":"un día comunica el pregón al otro día,y una noche transmite la noticia a la otra noche."
,"4":"No es un pregón, no son palabras, no son voces que puedan escucharse,"
,"5":"mas su sonido se extiende por la tierra entera,y hasta el confín del mundo sus palabras. Puso una tienda al sol allá en lo alto"
,"6":"y él sale como un esposo de su alcoba, como un atleta alegre que emprende una carrera."
,"7":"Sale por un lado del cielo,y tras su carrera se pone por el otro, sin que haya nada que a su calor escape."
,"8":"La ley del Señor es perfecta, portadora de vida; el testimonio del Señor es veraz, hace sabio al sencillo;"
,"9":"los preceptos del Señor son justos, reportan alegría al corazón; los mandamientos del Señor son límpidos, dan luz a los ojos;"
,"10":"el temor del Señor es puro, dura para siempre; los decretos del Señor son la verdad misma, todos ellos son justos;"
,"11":"más preciosos que el oro, más que el oro fino, más sabrosos que la miel, más que el jugo de panales."
,"12":"Por eso tu servidor se instruye en ellos, en guardarlos encuentra gran provecho."
,"13":"¿Quién reconoce sus propios errores?,Perdóname, Señor, mis pecados ocultos,"
,"14":"guarda a tu siervo del orgullo, que el orgullo no me domine nunca; así seré perfecto y libre de pecado."
,"15":"Acoge las palabras de mi boca, acepta los deseos de mi corazón, Señor, roca mía, redentor mío."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Al maestro de coro. Salmo de David"
,"2":"Que el Señor te escuche en el día de tu angustia, que te proteja el nombre del Dios de Jacob;"
,"3":"que te envíe su socorro desde su santuario, que sea desde Sión tu apoyo;"
,"4":"que se acuerde de todas tus ofrendas,y tus holocaustos acepte con agrado;"
,"5":"que te conceda todo lo que quieras,y realice todos tus proyectos."
,"6":"Entonces celebraremos tu victoria,y en nombre de Dios tremolaremos las banderas. Que el Señor te conceda todo lo que pidas."
,"7":"Ahora ya lo sé: el Señor da la victoria a su mesías, lo escucha desde los santos cielos,por las proezas victoriosas de su diestra."
,"8":"Unos confían en los carros, otros en los caballos, nosotros en el nombre del Señor, nuestro Dios;"
,"9":"ellos vacilarán, caerán, y nosotros en pie nos mantendremos."
,"10":"Señor, da la victoria al rey, escúchanos siempre que te invoquemos."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Del maestro de coro. Salmo de David"
,"2":"Señor, el rey se regocija de tu fuerza, tu victoria lo colma de alegría."
,"3":"Todo lo que te pidió le concediste; no le negaste lo que sus labios te pedían."
,"4":"Le saliste al encuentro con faustas bendiciones, le coronaste con corona de oro puro."
,"5":"Te pidió vida y tú se la concediste, una vida larga, una vida sin fin."
,"6":"Por tu victoria, grande es su fama, lo rodeas de honor y majestad."
,"7":"Le das una continua bendición, lo colmas de alegría en tu presencia."
,"8":"Sí, el rey confía en el Señor, por la gracia del altísimo es inquebrantable."
,"9":"Tu mano alcanzará a tus enemigos, tu derecha caerá sobre los que te odian."
,"10":"Los convertirás en un horno encendido el día que aparezcas, el Señor los tragará en su ira y el fuego los devorará."
,"11":"Borrarás su descendencia de la tierra, su posteridad de en medio de los hombres."
,"12":"Si quieren hacerte daño, si urden intrigas, no podrán hacer nada;"
,"13":"tú les harás volver la espalda,en cuanto vean que les apuntas con el arco."
,"14":"Levántate, Señor, con tu poder; nosotros cantamos, celebramos tu triunfo."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Al maestro de coro. Según la 'cierva de la aurora'. Salmo de David"
,"2":"Dios mío, Dios mío, ¿por qué me has abandonado?,A pesar de mis gritos, no acudes a salvarme;"
,"3":"Dios mío, de día te llamo y tú no me respondes, de noche, y tú no me haces caso;"
,"4":"pero tú eres el santo, te sientas en tu trono, oh gloria de Israel."
,"5":"En ti esperaron nuestros padres, esperaron en ti y tú los liberaste,"
,"6":"a ti clamaron y quedaron libres, esperaron en ti y no fueron defraudados."
,"7":"Mas yo soy un gusano, que no un hombre, vergüenza de los hombres, escarnio de la plebe;"
,"8":"todos los que me ven hacen burla de mí, retuercen la boca, menean la cabeza:"
,"9":"'Confió en el Señor, pues que él lo libre; que lo salve, si de verdad lo quiere'."
,"10":"Tú me sacaste del vientre de mi madre, me pusiste seguro en su regazo;"
,"11":"desde antes de nacer a ti me confiaron, desde el vientre de mi madre eres mi Dios."
,"12":"No te quedes lejos, que el peligro está encima y nadie me socorre."
,"13":"Toros innumerables me acorralan, me acosan los toros de Basán;"
,"14":"ávidos abren contra mí sus fauces, cual leones que rugen y desgarran."
,"15":"Siento que me disuelvo como el agua, todos mis huesos se dislocan, mi corazón se ha vuelto como cera, se me deshace dentro de mi pecho;"
,"16":"mi garganta está seca lo mismo que cascajo, mi lengua se me pega al paladar; me has hundido en el polvo de la muerte."
,"17":"Me rodea un montón de perros, una banda de criminales me acomete, taladran mis manos y mis pies,"
,"18":"puedo contar todos mis huesos. No me pierden de vista, me vigilan;"
,"19":"se reparten mi ropa y se sortean mi túnica."
,"20":"Mas tú, Señor, no te quedes lejos; fuerza mía, ven corriendo en mi auxilio,"
,"21":"libra mi vida de la espada, no dejes que me desgarren esos perros;"
,"22":"sálvame de las fauces del león, mi pobre vida de los cuernos del búfalo."
,"23":"Anunciaré tu nombre a mis hermanos, en plena asamblea te alabaré."
,"24":"Que lo alaben los fieles del Señor, que lo glorifique la raza de Jacob, que lo adore la raza de Israel;"
,"25":"porque no rechazó ni despreció al pobre en su miseria, ni se escondió de él; escuchó su grito de socorro."
,"26":"Yo alabaré su lealtad en la asamblea, cumpliré mis promesas delante de sus fieles."
,"27":"Los pobres comerán hasta saciarse, alabarán al Señor los que lo buscan: '¡Viva su corazón eternamente!'."
,"28":"El mundo entero recordará al Señor y al Señor volverá; lo adorarán, postrados ante él, todas las familias de los pueblos."
,"29":"Pues sólo del Señor es el imperio, él es el Señor de las naciones."
,"30":"Los nobles de la tierra le rendirán honores, ante él se inclinarán los moribundos y dejarán de ser."
,"31":"Mi descendencia servirá al Señor,y hablará de él a la generación futura,"
,"32":"contará su justicia al pueblo venidero: 'Todo fue obra del Señor'."
}`)
	CurrentBook.AddChapter(23, `{
"1":"Salmo de David,El Señor es mi pastor, nada me falta:"
,"2":"en verdes praderas me hace reposar, me conduce hacia las aguas del remanso"
,"3":"y conforta mi alma; me guía por los senderos de justicia, por amor a su nombre; "
,"4":"aunque vaya por un valle tenebroso, no tengo miedo a nada, porque tú estás conmigo, tu voz y tu cayado me sostienen."
,"5":"Me preparas una mesa ante mis enemigos, perfumas con ungüento mi cabeza,y me llenas la copa a rebosar."
,"6":"Lealtad y dicha me acompañan,todos los días de mi vida; habitaré en la casa del Señor por siempre jamás."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Salmo de David,Del Señor es la tierra y lo que en ella hay, el universo y los que en él habitan;"
,"2":"porque él echó sus cimientos,y la asentó sobre los mares y ríos."
,"3":"¿Quién podrá subir al monte del Señor?, ¿quién podrá estar en su recinto santo?"
,"4":"El hombre de manos inocentes y limpio corazón, que no entrega su alma a la mentira,y nunca jura en falso."
,"5":"Ése recibirá la bendición del Señor, y Dios, su salvador, le hará justicia."
,"6":"Tal es la raza de los que lo buscan, los que buscan el rostro del Dios de Jacob."
,"7":"¡Oh puertas, alzad vuestros dinteles, alzaos, puertas eternas, que entre el rey de la gloria!"
,"8":"¿Quién es el rey de la gloria?,El Señor, el héroe, el poderoso; el Señor, el héroe de la guerra."
,"9":"¡Oh puertas, alzad vuestros dinteles, alzaos, puertas eternas, que entre el rey de la gloria!"
,"10":"¿Quién es el rey de la gloria?,El Señor todopoderoso es el rey de la gloria."
}`)
	CurrentBook.AddChapter(25, `{
"1":"De David,A ti, Señor, levanto mi alma;"
,"2":"en ti espero, Dios mío, no quede defraudado; que no triunfen de mí mis enemigos."
,"3":"No queda defraudado el que en ti espera, que lo quede el que traiciona sin motivo."
,"4":"Muéstrame tus caminos, Señor, enséñame tus sendas;"
,"5":"guíame en tu verdad, enséñame; tú eres mi Dios y mi salvador, yo siempre espero en ti."
,"6":"Acuérdate, Señor, de tu misericordia,y tu bondad, que son eternas;"
,"7":"olvídate de los pecados de mi juventud y de mis faltas; acuérdate de mí, Señor, con misericordia y con bondad."
,"8":"El Señor es bueno y recto,y enseña el camino a los descarriados,"
,"9":"conduce en la justicia a los humildes, enseña a los humildes su camino;"
,"10":"los caminos del Señor son amor,y lealtad para quien guarda su alianza y sus preceptos."
,"11":"Por el honor de tu nombre, Señor, perdona mis culpas, por muy grandes que sean."
,"12":"¿Quién hay que sea fiel al Señor?,Él le indica el camino que debe seguir;"
,"13":"tendrá una vida feliz,y su posteridad heredará la tierra."
,"14":"El Señor se confía a sus leales,y les explica su alianza."
,"15":"Tengo mis ojos fijos en el Señor, él sacará mis pies del cepo."
,"16":"Mírame, Señor, y ten piedad de mí, pues soy un desgraciado y estoy solo;"
,"17":"quítame la angustia de mi corazón, sácame de mis tribulaciones."
,"18":"Contempla mi miseria y mi dolor, perdona todos mis pecados;"
,"19":"mira a mis enemigos, que son tantos, mira con qué violencia me persiguen."
,"20":"Guárdame, Señor, y sálvame la vida, me he refugiado en ti, no quede defraudado."
,"21":"La integridad y la rectitud me guardarán, pues en ti, Señor, he puesto mi esperanza."
,"22":"Oh Dios, rescata a Israel, líbralo de todas sus desgracias."
}`)
	CurrentBook.AddChapter(26, `{
"1":"De David,Justicia, oh Dios, que mi conducta es intachable, he confiado en el Señor sin vacilar."
,"2":"Examíname, Señor, y ponme a prueba, pasa por el crisol mi corazón y mis riñones;"
,"3":"tengo siempre tu lealtad ante mis ojos,y camino siempre en tu verdad."
,"4":"No me he reunido nunca con los impostores, ni he ido jamás con los hipócritas;"
,"5":"odio las bandas de los delincuentes, no me junto nunca con los criminales."
,"6":"Lavo mis manos en señal de inocencia, para dar vueltas en torno a tu altar"
,"7":"proclamando en tu honor mi acción de gracias,y pregonando todas tus maravillas."
,"8":"Señor, yo amo la casa donde tú resides, el lugar donde tu gloria habita."
,"9":"No unas mi suerte a la de los criminales, ni me hagas solidario con los asesinos,"
,"10":"que tienen las manos cargadas de delitos,y su derecha repleta de sobornos."
,"11":"Mi conducta, en cambio, es intachable; absuélveme, Señor, y ten piedad de mí;"
,"12":"mi pie está firme en el camino recto, en la asamblea bendeciré al Señor."
}`)
	CurrentBook.AddChapter(27, `{
"1":"De David,El Señor es mi luz y mi salvación, ¿a quién podré temer?,El Señor es la fortaleza de mi vida, ¿ante quién puedo temblar?"
,"2":"Cuando me asaltan los criminales para destrozarme, son ellos, mis opresores y enemigos, los que tropiezan y sucumben."
,"3":"Aunque un ejército acampe contra mí, mi corazón no teme; aunque una guerra estalle contra mí, estoy tranquilo."
,"4":"Una cosa pido al Señor, sólo eso busco: habitar en la casa del Señor,todos los días de mi vida,para gustar la dulzura del Señor,y contemplar la belleza de su templo."
,"5":"Él me dará cobijo el día de la desgracia, me esconderá en lo oculto de su tienda, me subirá a lo alto de la roca;"
,"6":"así mi cabeza dominará a los enemigos que me cercan, en su tienda podré ofrecer sacrificios entre aclamaciones, cantando y ensalzando al Señor."
,"7":"Escucha, Señor, mi grito suplicante, ten compasión de mí, respóndeme."
,"8":"De ti mi corazón me ha dicho: 'Busca su rostro'; es tu rostro, Señor, lo que yo busco;"
,"9":"no me ocultes tu rostro, no rechaces con cólera a tu siervo; tú eres mi auxilio, no me abandones, no me dejes, oh Dios, salvador mío."
,"10":"Mi padre y mi madre me han abandonado, y el Señor me ha recogido."
,"11":"Enséñame, Señor, tus sendas,y guíame por el camino recto, pues me están acechando;"
,"12":"no me entregues al capricho de mis perseguidores, pues se han alzado contra mí testigos falsos,que respiran violencia."
,"13":"Yo estoy seguro que he de ver los bienes del Señor,en el mundo de los vivos."
,"14":"Espera en el Señor, ten ánimo, sé fuerte, espera en el Señor."
}`)
	CurrentBook.AddChapter(28, `{
"1":"De David,A ti clamo, Señor; roca mía, no te hagas el sordo; si tú te quedas mudo, yo seré como los que bajan a la tumba."
,"2":"Escucha mi grito suplicante cuando te pido auxilio, cuando alzo mis manos hacia tu templo santo."
,"3":"No me arrebates con los malvados,y con los malhechores, que hablan de paz a los demás, y su corazón está lleno de malicia."
,"4":"Dales según sus hechos, según la maldad de sus acciones; trátalos según las obras de sus manos, págales con la misma moneda."
,"5":"No se fijan en los hechos del Señor,ni en la obra de sus manos: que él los destruya y ya no se alcen más."
,"6":"Bendito sea el Señor porque ha escuchado mi grito suplicante."
,"7":"El Señor es mi fortaleza, él es mi escudo; mi corazón confió en él, y él me socorrió; me alegro de todo corazón y le doy gracias cantando."
,"8":"El Señor es la fuerza de su pueblo, la fortaleza que salva a su mesías."
,"9":"Salva a tu pueblo, bendice tu heredad, sé tú su pastor y guíalos siempre."
}`)
	CurrentBook.AddChapter(29, `{
"1":"Salmo de David,Tributad al Señor, seres celestiales, tributad al Señor gloria y poder;"
,"2":"tributad al Señor la gloria de su nombre, adorad al Señor con esplendor sagrado."
,"3":"La voz del Señor sobre las aguas, el Dios de la gloria hace tronar, el Señor sobre las vastas aguas:"
,"4":"la voz potente del Señor, la voz majestuosa del Señor,"
,"5":"la voz del Señor que desgaja los cedros, el Señor desgaja los cedros del Líbano;"
,"6":"hace brincar como un novillo al Líbano, al Sarión como una cría de búfalo;"
,"7":"la voz del Señor que lanza rayos,"
,"8":"la voz del Señor hace temblar los desiertos, el Señor hace temblar el desierto de Cadés;"
,"9":"la voz del Señor retuerce las encinas y arrasa los bosques; en su templo todo grita: '¡Gloria!'."
,"10":"El Señor asienta su trono encima del diluvio, el Señor gobierna como rey eterno."
,"11":"El Señor da a su pueblo fortaleza, el Señor bendice a su pueblo con la paz."
}`)
	CurrentBook.AddChapter(30, `{
"1":"Salmo de David. Canción para la dedicación del templo"
,"2":"Yo te ensalzo, Señor, porque me has liberado, porque no has dejado que se rían de mí mis enemigos."
,"3":"Señor, Dios mío, te pedí que me curaras y tú me curaste."
,"4":"Señor, tú me libraste de la muerte, me sacaste de los que bajan a la tumba."
,"5":"Cantad al Señor, fieles del Señor, alabad su nombre santo;"
,"6":"su cólera dura sólo un instante,y toda la vida su favor; si al atardecer comienza el llanto, al amanecer emerge la alegría."
,"7":"Yo, seguro, me dije: 'Yo seré inquebrantable'."
,"8":"Con tu favor, Señor, has refortalecido mi montaña; pero escondiste el rostro y quedé perturbado."
,"9":"A ti, Señor, clamé, imploré compasión a mi Señor:"
,"10":"¿Qué ganas tú con que yo muera, con que baje a la tumba?,¿Es que puede alabarte el polvo o proclamar tu verdad?"
,"11":"Escúchame, Señor, y ten piedad de mí; socórreme, Señor."
,"12":"Tú has cambiado mi luto en alegría, me has trocado el sayal en un traje de fiesta,"
,"13":"para que mi corazón te cante sin cesar; Señor, Dios mío, te estaré eternamente agradecido."
}`)
	CurrentBook.AddChapter(31, `{
"1":"Al maestro de coro. Salmo de David"
,"2":"A ti, Señor, me acojo; que jamás quede yo defraudado; libérame, pues tú eres justo;"
,"3":"atiéndeme, ven corriendo a liberarme; sé tú mi roca de refugio, la fortaleza de mi salvación;"
,"4":"ya que eres tú mi roca y mi fortaleza, por el honor de tu nombre, condúceme tú y guíame;"
,"5":"sácame de la red que me han tendido, pues tú eres mi refugio."
,"6":"En tus manos encomiendo mi espíritu; tú me rescatarás, Señor, Dios verdadero."
,"7":"Aborrezco a los que adoran ídolos vanos, pero yo he puesto mi confianza en el Señor;"
,"8":"tu amor ser mi gozo y mi alegría, porque te has fijado en mi miseria,y has comprendido la angustia de mi alma;"
,"9":"no me has entregado en manos de mis enemigos,y has puesto mis pies en campo libre."
,"10":"Piedad, Señor, que estoy en gran peligro. Se consumen de tristeza mis ojos, mi alma y todas mis entrañas;"
,"11":"mi vida se consume de tristeza, los gemidos acaban con mis años; la miseria acaba con mis fuerzas, mis huesos se consumen."
,"12":"Soy la irrisión de todos mis opresores, asco de los vecinos y espanto de los que me conocen; los que me ven en la calle huyen de mí."
,"13":"Se olvidan de mí, como si ya estuviera muerto, soy un objeto de basura."
,"14":"Oigo los cuchicheos de la gente,-terror por todas partes-, se han puesto de acuerdo contra mí,y tratan de matarme."
,"15":"Pero yo confío en ti, Señor; lo confirmo: 'Tú eres mi Dios';"
,"16":"mi vida está en tus manos, líbrame de mis enemigos, de mis perseguidores;"
,"17":"mira a tu siervo con ojos de bondad,y sálvame por tu amor."
,"18":"Señor, que no me avergüence de haberte invocado; que se avergüencen los malvados,y bajen al silencio del abismo;"
,"19":"enmudezcan los labios mentirosos, que hablan al justo con insolencia, con arrogancia y con desprecio."
,"20":"Qué grande es tu bondad, Señor, la que tú reservas para tus leales,y repartes, a la vista de todos, a los que en ti confían;"
,"21":"tú los guardas al amparo de tu rostro, lejos de las intrigas de los hombres; tú los cobijas en tu tienda,lejos de las lenguas mordaces."
,"22":"Bendito sea el Señor, pues su amor me hizo un milagro en una ciudad amurallada."
,"23":"Yo decía en mi turbación: 'Estoy dejado de tus ojos'; mas tú escuchaste la voz de mi plegaria, mi grito suplicante."
,"24":"Amad al Señor todos sus fieles, el Señor guarda a los creyentes, pero paga con creces su merecido,al que procede con orgullo."
,"25":"Ánimo, sed fuertes todos los que esperáis en el Señor."
}`)
	CurrentBook.AddChapter(32, `{
"1":"Maskil de David,Dichoso aquel a quien se le ha perdonado la culpa,y se le ha cubierto su pecado,"
,"2":"dichoso aquel a quien el Señor no le tiene en cuenta su delito y no tiene dobles intenciones."
,"3":"Mientras yo no confesaba, mi cuerpo se agotaba de gemir todo el día;"
,"4":"de día y de noche tu mano pesaba sobre mí, mi savia se secaba al ardor del verano."
,"5":"Te he confesado mi pecado,y no oculté mi falta; yo dije: 'Confesaré mis faltas al Señor', y tú me has absuelto de todos mis delitos."
,"6":"Por eso los fieles te suplican el día de la desgracia, y así, aunque las aguas se desborden, no los alcanzarán."
,"7":"Tú eres mi refugio, me guardas de la angustia, me rodeas con cantos de victoria."
,"8":"Yo quiero enseñarte, indicarte el camino que tienes que seguir, quiero darte un consejo, quiero mirar por ti."
,"9":"No seas como el mulo o el caballo, seres irracionales a los que hay que domar,con las bridas y el freno; de lo contrario, no se acercan a ti."
,"10":"Muchas desgracias esperan al malvado, el Señor rodea de favores al que en él ha confiado."
,"11":"Alegraos en el Señor, justos, regocijaos, gritad de alegría todos los corazones rectos."
}`)
	CurrentBook.AddChapter(33, `{
"1":"Justos, alabad al Señor, la alabanza es propia de los rectos;"
,"2":"dad gracias al Señor con la cítara, tocad en su honor con el arpa de diez cuerdas;"
,"3":"cantadle un cantar nuevo, dad un buen concierto de instrumentos y de voces,"
,"4":"pues la palabra del Señor es eficaz, y sus obras demuestran su lealtad;"
,"5":"él ama la justicia y el derecho, la tierra está llena del amor del Señor."
,"6":"Con su palabra el Señor hizo los cielos,y con el soplo de su boca todo lo que hay en ellos."
,"7":"Él juntó entre diques las aguas de los mares,y almacenó en depósitos las aguas del abismo."
,"8":"Que tenga temor de Dios la tierra entera,y todos sus habitantes tiemblen ante él;"
,"9":"porque él lo dijo, y todo fue hecho; él lo ordenó, y todo existió."
,"10":"El Señor desbarata el plan de las naciones,y deshace los proyectos de los pueblos;"
,"11":"pero el plan del Señor subsiste eternamente, sus proyectos, por todas las edades."
,"12":"Dichosa la nación que tiene al Señor por Dios, el pueblo que él se escogió por heredad."
,"13":"El Señor se asoma desde el cielo,y contempla a todos los humanos;"
,"14":"desde el lugar de su morada observa a todos los habitantes de la tierra;"
,"15":"él formó el corazón de cada uno,y vigila todo lo que hacen."
,"16":"El rey no vence por un gran ejército, ni se salva el héroe por su gran valor;"
,"17":"vana cosa es un caballo para la victoria; a pesar de su fuerza, no puede salvar."
,"18":"Pero el Señor se cuida de sus fieles, de los que confían en su misericordia,"
,"19":"para librarlos de la muerte,y sostenerlos en tiempos de hambre."
,"20":"Nosotros esperamos al Señor, él es nuestro auxilio y nuestro escudo;"
,"21":"en él se goza nuestro corazón, en su nombre santo confiamos."
,"22":"Que tu amor, Señor, venga sobre nosotros, como lo esperamos de ti."
}`)
	CurrentBook.AddChapter(34, `{
"1":"De David, cuando se fingió demente ante Aquís y, expulsado por él, se marchó"
,"2":"Bendeciré al Señor a todas horas, su alabanza estará siempre en mi boca;"
,"3":"mi alma se gloría en el Señor, que lo oigan los pobres y se alegren;"
,"4":"alabad conmigo la grandeza del Señor, ensalcemos su nombre todos juntos."
,"5":"Busqué al Señor y él me contestó, y me libró de todos mis temores."
,"6":"Los que miran hacia él quedan radiantes,y su rostro no se sonroja más."
,"7":"Un mísero gritó: el Señor lo escuchó,y lo libró de todas sus angustias;"
,"8":"el ángel del Señor acampa en torno a sus fieles y los salva."
,"9":"Gustad y ved qué bueno es el Señor, dichoso el hombre que se refugia en él."
,"10":"Temed al Señor, vosotros, santos suyos, nada les falta a aquellos que lo temen;"
,"11":"los ricos caen en la miseria y pasan hambre, pero a los que buscan al Señor nada les falta."
,"12":"Venid, hijos, escuchadme, os voy a enseñar."
,"13":"¿Quién es el que ama la vida,y quiere vivir años felices?"
,"14":"Guarda del mal tu lengua, y tus labios de palabras mentirosas;"
,"15":"apártate del mal y haz el bien, busca la paz y corre en pos de ella."
,"16":"El Señor mira por los que practican la justicia, sus oídos atienden a sus gritos;"
,"17":"el Señor se enfrenta con los criminales,para borrar su memoria de la tierra."
,"18":"Ellos gritan, el Señor los atiende,y los libra de todas sus angustias;"
,"19":"el Señor está cerca de los atribulados, él salva a los que están hundidos."
,"20":"El hombre justo tendrá muchas contrariedades, pero de todas el Señor lo hará salir airoso;"
,"21":"él cuida de todos sus huesos, no se le romperá ni uno solo."
,"22":"La muerte del criminal será horrorosa, los que odian al justo tendrán su castigo."
,"23":"El Señor rescata la vida de sus siervos, los que en él se refugian no serán castigados."
}`)
	CurrentBook.AddChapter(35, `{
"1":"De David,Oh Señor, acusa a mis acusadores, ataca a los que me atacan;"
,"2":"toma tu escudo y tu armadura,y ven a socorrerme;"
,"3":"blande la lanza y cierra el paso a mis perseguidores; dime: 'Yo soy tu salvación'."
,"4":"Queden confundidos y deshonrados los que buscan mi vida, retrocedan cubiertos de vergüenza los que maquinan mi desgracia;"
,"5":"sean como paja al viento acosados por el ángel del Señor;"
,"6":"su camino sea oscuro y deslizante, perseguidos por el ángel del Señor."
,"7":"Pues sin motivo me han tendido su red, sin motivo han cavado una fosa para mí;"
,"8":"que les sobrevenga de improviso la ruina, que la red que ellos tendieron los atrape,y caigan en la fosa que cavaron."
,"9":"Entonces me alegraré en el Señor por haberme salvado;"
,"10":"todo mi ser dirá: 'Señor, no hay nadie como tú, que libras al pobre y al indigente de sus explotadores'."
,"11":"Testigos de cargo se presentan,y me preguntan de lo que no sé nada;"
,"12":"me devuelven mal por bien, me encuentro desolado."
,"13":"Mas yo, cuando estaban enfermos, vestía de sayal, maceraba mi cuerpo con ayunos,y estaba siempre orando interiormente."
,"14":"Como por un amigo o un hermano iba,y venía cabizbajo y triste, como el que está en luto por la propia madre."
,"15":"Mas cuando yo tropiezo se juntan y se ríen, se juntan contra mí; me golpean a traición, me laceran sin cesar,"
,"16":"me atacan y de mí se burlan, rechinando sus dientes contra mí."
,"17":"Señor, ¿hasta cuándo verás esto?,Rescata mi vida de estas fieras rugientes, mi único bien, de estos leones;"
,"18":"yo te daré gracias en la gran asamblea, te alabaré ante el pueblo entero."
,"19":"Que no se rían de mí mis crueles enemigos,ni se guiñen el ojo los que me odian sin razón;"
,"20":"no hablan nunca de paz,y levantan calumnia a los que quieren la paz;"
,"21":"abren sus fauces y dicen: 'Ja, ja, con nuestros ojos lo hemos visto'."
,"22":"Tú lo has visto, Señor, no te calles; Señor, no te alejes de mí;"
,"23":"despierta, levántate, Señor mío y Dios mío, defiende mi derecho y mi causa;"
,"24":"júzgame tú conforme a tu justicia, Señor, Dios mío, que no se rían de mí;"
,"25":"que no puedan pensar: 'Esto es lo que queríamos', que no puedan decir: 'Nos lo hemos comido'."
,"26":"Que todos a una se queden rojos de vergüenza, todos los que se alegran de mis males; que se cubran de vergüenza,y de deshonra los que se consideran superiores a mí."
,"27":"Que griten de alegría los que quieren que se me haga justicia y digan sin cesar: 'Grande es el Señor, que ha querido el bienestar de su siervo';"
,"28":"mi lengua anunciará entonces tu justicia,y proclamará tu alabanza todo el día."
}`)
	CurrentBook.AddChapter(36, `{
"1":"Al maestro de coro; del siervo del Señor. De David"
,"2":"El delito habla interiormente al criminal: 'No temo a Dios ni en su propia cara'."
,"3":"Se lisonjea de que su delito no será descubierto,ni será castigado."
,"4":"Los dichos de su boca son iniquidad y engaño, ha perdido el sentido del bien;"
,"5":"en su lecho planifica el delito; aferrado siempre al mal camino, no se aparta del mal."
,"6":"Pero tu amor, Señor, llega hasta el cielo, y tu lealtad hasta las nubes,"
,"7":"tu justicia es cual los montes más altos, tus juicios como el inmenso abismo. Tú, Señor, salvas a los hombres y a las bestias;"
,"8":"oh Dios, ¡qué precioso es tu amor!,Los hombres se cobijan a la sombra de tus alas,"
,"9":"se sacian de los ricos manjares de tu casa, en el torrente de tus delicias los abrevas."
,"10":"Pues en ti está la fuente de la vida,y en tu luz vemos la luz."
,"11":"Guarda tu amor a los que te reconocen,y haz justicia a los hombres honrados."
,"12":"No dejes que me pisotee el pie del arrogante, ni que la mano del criminal me alcance."
,"13":"Ahí están caídos los agentes del crimen, por tierra, sin poderse levantar."
}`)
	CurrentBook.AddChapter(37, `{
"1":"De David,No te irrites contra los malvados,ni tengas envidia de los criminales,"
,"2":"pues se secan pronto como el heno, como la hierba verde se marchitan."
,"3":"Confía en el Señor y haz el bien, para habitar en tu tierra y vivir tranquilo;"
,"4":"busca en el Señor tus delicias, y él te dará lo que tu corazón desea."
,"5":"Confía al Señor toda tu vida y fíate de él, que él sabrá lo que hace:"
,"6":"hará que luzca tu justicia como la aurora,y que tu derecho resplandezca como el mediodía."
,"7":"Descansa en el Señor, confía en él, no te irrites contra el que prospera,ni contra el hombre que maneja intrigas;"
,"8":"deja la ira, desiste del enfado, no te acalores, que es peor para ti;"
,"9":"pues los criminales serán exterminados, mas los que esperan en el Señor heredarán la tierra."
,"10":"Un poco nada más, y el criminal no existe; lo buscas en su sitio, y ya no está allí;"
,"11":"pero los pobres heredarán la tierra,y gozarán de una paz total."
,"12":"El criminal maquina contra el justo,y rechina los dientes contra él;"
,"13":"el Señor se ríe de él,porque ve que su día se avecina."
,"14":"El criminal saca la espada,y tensa el arco para matar al pobre,y al indigente, para dar muerte a los justos;"
,"15":"pero su espada se clavará en su corazón,y sus arcos serán hechos pedazos."
,"16":"Vale más poco con justicia,que mucha riqueza con injusticia;"
,"17":"pues los brazos de los injustos se romperán, mientras que el Señor sostiene a los justos."
,"18":"El Señor cuida de los que practican la justicia, su herencia durará eternamente;"
,"19":"no pasarán vergüenza en tiempos de desgracia, en los días de escasez no pasarán hambre."
,"20":"Los que viven de la injusticia perecerán, los enemigos del Señor pasarán como el verde de los prados, se esfumarán igual que el humo."
,"21":"El injusto pide prestado y no devuelve, mientras que el justo se compadece y da."
,"22":"Los que el Señor bendice heredarán la tierra, los que maldice serán exterminados."
,"23":"El Señor asegura los pasos del hombre,cuyo camino es de su agrado;"
,"24":"aunque tropiece, no caerá por tierra, pues el Señor le lleva de la mano."
,"25":"Fui joven y ya soy viejo; y nunca vi al justo abandonado,ni a sus hijos pidiendo limosna."
,"26":"En todo tiempo se compadece y da prestado, sus hijos son una bendición."
,"27":"Apártate del mal y haz el bien, y siempre tendrás un lugar donde vivir;"
,"28":"porque el Señor ama la justicia,y no abandona a sus fieles; los malhechores serán para siempre aniquilados,y la raza de los criminales será exterminada;"
,"29":"los justos heredarán la tierra,y habitarán en ella eternamente."
,"30":"La boca del justo habla con sabiduría,y su lengua proclama la justicia;"
,"31":"la ley de su Dios está en su corazón,y sus pasos no vacilan."
,"32":"El injusto espía al justo,y busca darle muerte;"
,"33":"pero el Señor no lo dejará en sus manos,ni permitirá que lo condenen cuando sea juzgado."
,"34":"Confía en el Señor y sigue su camino; él te ensalzará y te hará heredar la tierra, y tú verás la ruina de los malvados."
,"35":"He visto al malvado, lleno de soberbia, elevarse como un cedro frondoso;"
,"36":"pasé de nuevo, y ya no estaba; lo busqué, pero no lo encontré."
,"37":"Guarda la integridad, practica la justicia, pues para el hombre de paz hay un porvenir;"
,"38":"los malhechores serán de una vez aniquilados,y su descendencia será totalmente exterminada."
,"39":"La salvación de los justos viene del Señor, él es su fortaleza en tiempos de peligro;"
,"40":"el Señor los ayuda y los libra, los libra de los malvados,y los salva porque en él han buscado su refugio."
}`)
	CurrentBook.AddChapter(38, `{
"1":"Salmo de David. Conmemorativo"
,"2":"Señor, no me castigues cuando estés airado, no me reprendas cuando estés enfurecido;"
,"3":"pues tus flechas se han clavado en mí, ha caído sobre mí tu mano;"
,"4":"todo mi cuerpo está enfermo, debido a tu furor; no tengo hueso sano, debido a mi maldad;"
,"5":"mis delitos sobrepasan mi cabeza, me aplastan como un peso insoportable;"
,"6":"mis heridas apestan y supuran, debido a mi locura;"
,"7":"cabizbajo, totalmente abrumado, todo el día ando triste;"
,"8":"las espaldas me arden, no hay en mi cuerpo nada sano;"
,"9":"agotado, totalmente deshecho, el gemir de mi corazón se hace un rugido."
,"10":"Señor, tú conoces todos mis deseos, mis gemidos no son ningún secreto para ti;"
,"11":"el corazón me palpita, las fuerzas me abandonan, hasta la luz de mis ojos he perdido."
,"12":"Mis compañeros, mis amigos se alejan de mis llagas; hasta mis familiares se mantienen a distancia;"
,"13":"los que buscan mi vida me tienden asechanzas, los que quieren mi ruina anuncian desventuras, andan tramando engaños todo el día."
,"14":"Pero yo me hago el sordo y no oigo nada, me hago el mudo y no abro la boca;"
,"15":"me he hecho como un hombre que no oye,ni tiene réplica en sus labios."
,"16":"Pues tú eres, Señor, en quien espero, tú me responderás, Señor, Dios mío;"
,"17":"me digo: 'Que no se rían de mí, que cuando yo tropiece no se burlen de mí'."
,"18":"Ya estoy a punto de caer, el dolor no me deja ni un momento."
,"19":"Yo reconozco mis delitos, me angustian mis pecados."
,"20":"Muchos y poderosos son mis enemigos, muchos los que me odian sin motivo;"
,"21":"me devuelven mal por bien, me atacan porque siempre busco el bien."
,"22":"Señor, no me abandones; Dios mío, no te quedes lejos;"
,"23":"ven corriendo a socorrerme, Señor, salvador mío."
}`)
	CurrentBook.AddChapter(39, `{
"1":"Al maestro de coro. De Idutún. Salmo de David"
,"2":"Yo me dije: 'Voy a controlar mi vida,y a no faltar con la lengua; pondré un freno en mi boca,cuando un malhechor esté presente'."
,"3":"Enmudecí, guardé silencio; callé, pero fue en vano, pues mi dolor se hizo insoportable, mi corazón ardía dentro de mí;"
,"4":"pensando en ello, se encendió la llama, y entonces se desató mi lengua:"
,"5":"Dame, Señor, a conocer mi fin,y cuál es la medida de mis días, quiero saber lo caduco que soy."
,"6":"Como una cuarta son de largos mis días; ante ti mi vida es como nada, menos que un soplo son todos los humanos;"
,"7":"como la sombra el hombre pasa, se afana por nada, acumula riquezas sin saber para quién."
,"8":"Y ahora, Señor, ¿qué puedo yo esperar?,Mi respuesta está en ti;"
,"9":"líbrame de todas mis maldades, no me expongas a la burla de los necios."
,"10":"Cierro mi boca y no la vuelvo a abrir, pues tú eres el que actúa."
,"11":"Deja ya de golpearme, que sucumbo bajo los golpes de tu mano."
,"12":"Tú corriges al hombre castigando la falta, como una polilla corroes su tesoro, el hombre no es nada más que un soplo."
,"13":"Escucha, Señor, mi grito suplicante; presta oído a mis llantos,y no te hagas el sordo, pues yo soy un invitado tuyo; un huésped, como todos mis padres."
,"14":"Aparta tu mirada, que tenga yo un respiro,antes de que me vaya y deje de existir."
}`)
	CurrentBook.AddChapter(40, `{
"1":"Al maestro de coro. Salmo de David"
,"2":"En el Señor he puesto toda mi esperanza, él se inclinó hacia mí y escuchó mi grito;"
,"3":"me sacó de la fosa mortal, del fango cenagoso; puso mis pies sobre la roca, aseguró mis pasos;"
,"4":"puso en mi boca un cantar nuevo, una alabanza para nuestro Dios. Muchos, al verlo, temerán y confiarán en el Señor."
,"5":"Dichoso el hombre que en el Señor ha puesto su esperanza,y no se ha ido con los arrogantes,ni con los que se pierden en engaños."
,"6":"¡Qué grandes son, Señor, Dios mío, los proyectos y los milagros que hiciste por nosotros!: eres incomparable. Yo quisiera decirlos, proclamarlos; pero son tantos, que no pueden contarse."
,"7":"Tú no quieres sacrificios ni ofrendas, no pides holocaustos ni sacrificios por el pecado; en cambio, me has abierto el oído,"
,"8":"por lo que entonces dije: 'Aquí estoy, en el libro está escrito de mí:"
,"9":"Dios mío, yo quiero hacer tu voluntad, tu ley está en el fondo de mi alma'."
,"10":"Pregoné tu justicia a la gran asamblea, no he cerrado mis labios; tú lo sabes, Señor."
,"11":"No he dejado de hablar de tu justicia, he proclamado tu lealtad y tu salvación, no he ocultado tu amor,y tu fidelidad ante la gran asamblea."
,"12":"Tú, Señor, no retires de mí tu misericordia, que tu amor y tu fidelidad me guarden siempre;"
,"13":"me asaltan desgracias incontables, me asedian mis culpas y ya no puedo ver; son más que los pelos de mi cabeza, y el corazón me falla."
,"14":"Por favor, Señor, ven a socorrerme, ven corriendo a ayudarme;"
,"15":"que queden confundidos y cubiertos de vergüenza,los que tratan de quitarme la vida, que huyan afrentados los que pretenden mi ruina;"
,"16":"que queden aturdidos de vergüenza,los que me dicen: 'Ja, ja'."
,"17":"Que se alegren y se regocijen en ti todos los que te buscan; que no dejen de decir: 'Dios es grande', los que anhelan tu salvación."
,"18":"Yo soy un pobre desgraciado, pero el Señor se preocupa de mí; tú eres mi auxilio y mi libertador; Dios mío, no tardes."
}`)
	CurrentBook.AddChapter(41, `{
"1":"Al maestro de coro. Salmo de David"
,"2":"Dichoso el que se preocupa del débil,y del pobre, en el día de la desgracia el Señor lo salvará."
,"3":"El Señor lo guardará vivo y feliz sobre la tierra, y no lo entregará al capricho de sus enemigos."
,"4":"El Señor lo cuidará en su lecho de dolor, le cambiará de continuo la cama durante la enfermedad."
,"5":"Yo he dicho: 'Señor, ten piedad de mí, cúrame, pues te he ofendido'."
,"6":"Mis enemigos me auguran la desgracia: '¿Cuándo se morirá y desaparecerá su nombre?'."
,"7":"Si alguien me viene a ver, dice mentiras, se fija en los síntomas funestos, y al salir lo publica."
,"8":"Todos a una mis enemigos cuchichean contra mí, haciendo sobre mí funestas previsiones:"
,"9":"'Un mal siniestro ha caído sobre él: está acostado, no se levantará ya más'."
,"10":"Hasta mi amigo íntimo, en quien yo confiaba, el que comía mi mismo pan, ha levantado contra mí su calcañar."
,"11":"Mas tú, Señor, ten piedad de mí; levántame, que yo les daré su merecido."
,"12":"En esto conoceré que tú me amas: si mi enemigo no triunfa sobre mí."
,"13":"Tú me sostendrás, porque soy inocente, me tendrás en tu presencia eternamente."
,"14":"Bendito sea el Señor, Dios de Israel, desde siempre y por siempre. ¡Amén! ¡Amén!"
}`)
	CurrentBook.AddChapter(42, `{
"1":"Al maestro de coro. Maskil de los hijos de Coré"
,"2":"Como la cierva busca corrientes de agua, así mi alma te busca a ti, Dios mío;"
,"3":"mi alma tiene sed de Dios, del Dios viviente: ¿cuándo podré ir a ver el rostro del Señor?"
,"4":"Mis lágrimas son mi pan de día y de noche, y a lo largo del día me repiten: '¿Dónde está tu Dios?'."
,"5":"Quiero recordar aquello y desahogar mi alma; cuando entraba en la casa de Dios,como en cortejo noble, al son de gritos de alegría,y dando gracias entre la multitud en fiesta."
,"6":"¿Por qué te afliges, alma mía, por qué te quejas?,Espera en Dios, que aún he de alabarlo, salud de mi rostro, Dios mío."
,"7":"Mi alma en mi interior se aflige, por eso te recuerdo desde la región del Jordán, desde el Hermón y el monte de Misar."
,"8":"Un abismo llama a otro abismo,al fragor de tus cascadas; todas tus olas y tus crestas pasaron sobre mí."
,"9":"Señor, ejerce de día tu misericordia, y de noche te cantaré un cantar, una oración al Dios de mi vida."
,"10":"Quiero decir a Dios, mi roca: '¿Por qué me has olvidado?,¿Por qué he de andar triste, bajo la opresión de mi enemigo?'."
,"11":"Mis huesos se quebrantan, mis opresores me insultan, y me repiten a lo largo del día: '¿Dónde está tu Dios?'."
,"12":"¿Por qué te afliges, alma mía, por qué te quejas?,Espera en Dios, que aún he de alabarlo, salud de mi rostro, Dios mío."
}`)
	CurrentBook.AddChapter(43, `{
"1":"Hazme justicia, oh Dios, y defiende mi causa,contra esta mala gente, líbrame del hombre falso y criminal."
,"2":"Pues tú eres, oh Dios, mi fortaleza, ¿por qué me has rechazado?, ¿por qué he de andar yo triste, bajo la opresión de mi enemigo?"
,"3":"Envía tu luz y tu verdad; ellas me guiarán, me conducirán a tu montaña santa, a tus moradas."
,"4":"Yo llegaré hasta el altar de Dios, del Dios que es mi gozo y mi alegría; te alabaré al son de la cítara, Señor, Dios mío."
,"5":"¿Por qué te afliges, alma mía, por qué te quejas?,Espera en Dios, que aún he de alabarlo, salud de mi rostro, Dios mío."
}`)
	CurrentBook.AddChapter(44, `{
"1":"Al maestro de coro. Maskil de los hijos de Coré"
,"2":"Oh Dios, hemos oído con nuestros oídos, nos han contado nuestros padres,la obra que en sus días hiciste, en los días antiguos, con tu propia mano."
,"3":"Expulsaste naciones y los plantaste a ellos, exterminaste pueblos para hacerlos crecer."
,"4":"No fue su espada la que conquistó la tierra, ni su brazo el que los hizo vencedores; fue tu diestra y tu brazo y la luz de tu rostro, porque tú los amabas."
,"5":"Eras tú, rey mío y Dios mío, quien lograba las victorias de Jacob."
,"6":"Gracias a ti derrotábamos a nuestros enemigos, por tu nombre aplastábamos a nuestros agresores."
,"7":"No ponía en el arco yo mi confianza, ni mi espada me daba la victoria;"
,"8":"eras tú el que nos daba la victoria contra los enemigos y cubrías de vergüenza a nuestros adversarios."
,"9":"Cantábamos en todo tiempo tu alabanza,celebrando tu nombre sin cesar."
,"10":"Pero ahora nos rechazas y nos cubres de vergüenza, no sales ya con nuestras tropas;"
,"11":"nos haces retroceder ante nuestros adversarios, y nuestros enemigos nos saquean a su gusto;"
,"12":"nos entregas como ovejas para el matadero, y nos has dispersado entre los pueblos."
,"13":"Has vendido a tu pueblo a bajo precio, no has ganado nada con su venta;"
,"14":"nos has hecho la burla de nuestros convecinos, la irrisión y el escarnio de nuestros circundantes;"
,"15":"nos has hecho el chiste de las gentes, nos hacen burla las naciones."
,"16":"Todo el día tengo ante mí mi afrenta,y la vergüenza cubre mi semblante,"
,"17":"bajo los gritos de insultos y blasfemias, frente a un enemigo ávido de venganza."
,"18":"Todo esto nos llegó sin haberte olvidado, sin haber traicionado tu alianza,"
,"19":"sin haber vuelto atrás el corazón, sin haber desviado los pies de tu camino;"
,"20":"nos has aplastado en cubil de chacales,y nos has cubierto con las sombras de la muerte."
,"21":"Si hubiéramos olvidado el nombre de nuestro Dios,o alzado nuestras manos hacia un dios extranjero,"
,"22":"¿no se hubiera dado cuenta Dios, él, que del corazón conoce los secretos?"
,"23":"Por tu causa nos asesinan sin cesar, nos tratan como ovejas para el matadero."
,"24":"Despierta ya. ¿Por qué duermes, Señor?,Levántate, no nos rechaces para siempre."
,"25":"¿Por qué ocultas tu rostro,y olvidas nuestra desgracia y opresión?"
,"26":"Nuestra alma está hundida en el polvo,y nuestro vientre se arrastra por el suelo."
,"27":"Levántate, ven a socorrernos, rescátanos por tu misericordia."
}`)
	CurrentBook.AddChapter(45, `{
"1":"Al maestro de coro. Sobre 'los lirios'. Maskil de los hijos de Coré. Canto al amor"
,"2":"Mi corazón rebosa de palabras bellas, voy a recitar mis versos en honor del rey, mi lengua es como la pluma de un escritor experto."
,"3":"Eres el más hermoso de los hombres, la gracia corre por tus labios, porque Dios te ha bendecido para siempre."
,"4":"Ciñe la espada al flanco, oh poderoso, ella es tu brillo y tu esplendor;"
,"5":"avanza victorioso para defender la verdad y la justicia, y hazañas gloriosas realice tu derecha."
,"6":"Caen a tus pies los pueblos, tus flechas puntiagudas se clavan en el corazón de tus enemigos."
,"7":"Tu trono, oh Dios, dura eternamente; el cetro de tu reino es cetro de justicia."
,"8":"Amas la justicia y odias la iniquidad, por eso Dios, tu Dios, te ha ungido con óleo de alegría,con preferencia a tus compañeros."
,"9":"Mirra, áloe y acacia rezuman tus vestidos, en el salón de los marfiles música de arpas te recrea."
,"10":"Hijas de reyes hay entre tus elegidas; a tu derecha, una reina adornada con el oro más fino."
,"11":"Escucha, hija mía, atiende, mira, olvida tu pueblo y tu familia:"
,"12":"el rey se ha enamorado de tu belleza, él es tu señor, ríndele pleitesía."
,"13":"La hija de Tiro llega con presentes, los ricos del pueblo te rinden vasallaje."
,"14":"Majestuosa está en el interior la hija del rey, engalanada con tejidos de oro;"
,"15":"vestida de brocados es llevada hacia el rey, sus damas de honor la siguen y acompañan;"
,"16":"en gozoso cortejo entran en la mansión del rey."
,"17":"En lugar de tus padres tendrás hijos, a los que harás príncipes por toda la tierra."
,"18":"Yo haré que tu nombre se recuerde por todas las edades,y los pueblos te alaben por los siglos de los siglos."
}`)
	CurrentBook.AddChapter(46, `{
"1":"Al maestro de coro. Cántico de los hijos de Coré. Según: 'Las vírgenes...'"
,"2":"Dios es nuestro refugio y fortaleza, un socorro seguro en momentos de angustia;"
,"3":"por eso no tememos aunque la tierra se conmueva,y los montes se desplomen en el fondo del mar,"
,"4":"aunque sus aguas rujan y se encrespen sus olas, aunque ellas se alboroten y los montes retiemblen."
,"5":"Un río y sus canales alegran la ciudad de Dios, la más santa morada del altísimo."
,"6":"Dios está en medio de ella, no vacilará: Dios la socorrerá al despuntar la aurora."
,"7":"Bramaron las naciones, vacilaron los reinos, él levantó su voz y la tierra se deshizo."
,"8":"Con nosotros está el Señor omnipotente, el Dios de Jacob es nuestra fortaleza."
,"9":"Venid y ved las obras del Señor, sus prodigios, que llenan la tierra de estupor:"
,"10":"pone fin a la guerra hasta el confín del mundo, rompe el arco, parte la lanza y quema los escudos."
,"11":"Dejad las armas, reconoced que yo soy Dios, por encima de las naciones, por encima de la tierra."
,"12":"Con nosotros está el Señor omnipotente, el Dios de Jacob es nuestra fortaleza."
}`)
	CurrentBook.AddChapter(47, `{
"1":"Al maestro de coro. Salmo de los hijos de Coré"
,"2":"Pueblos todos, batid palmas, aclamad al Señor con gritos de alegría,"
,"3":"porque el Señor, el altísimo, es terrible, un gran rey sobre toda la tierra."
,"4":"Él somete a nuestro yugo las naciones,y pone a los pueblos bajo nuestros pies;"
,"5":"escoge para nosotros nuestra herencia, orgullo de Jacob, su preferido."
,"6":"Dios sube entre aclamaciones, el Señor, al son de trompetas."
,"7":"Cantad a Dios, cantad; cantad a nuestro rey, cantad;"
,"8":"porque el rey de toda la tierra es Dios, cantadle un buen cántico."
,"9":"Dios reina sobre las naciones, Dios se sienta en su trono sacrosanto."
,"10":"Los jefes de los pueblos se han reunido,con el pueblo del Dios de Abrahán; pues de Dios son los escudos de la tierra,y él está por encima de todo."
}`)
	CurrentBook.AddChapter(48, `{
"1":"Cántico. Salmo de los hijos de Coré"
,"2":"Grande es el Señor y digno de alabanza,en la ciudad de nuestro Dios, su monte santo."
,"3":"Hermosa altura, alegría del mundo el monte Sión, confín del norte, capital del gran rey."
,"4":"En los palacios de Sión, Dios se manifiesta como fortaleza."
,"5":"Los reyes se aliaron y avanzaron unidos contra ella;"
,"6":"pero apenas la vieron se quedaron pasmados; aterrados, se dieron a la fuga;"
,"7":"allí mismo se echaron a temblar, se retorcían de dolor como mujer en parto,"
,"8":"como el viento del este,que deshace los navíos de Tarsis."
,"9":"Lo que habíamos oído lo hemos visto,en la ciudad del Señor omnipotente, en la ciudad de nuestro Dios: Dios la ha afirmado para siempre."
,"10":"Oh Dios, nosotros revivimos tu amor,en medio de tu templo;"
,"11":"tu alabanza, como tu nombre, oh Dios, cubre la superficie de la tierra; tu diestra está llena de justicia."
,"12":"Que se alegre el monte Sión, que se regocijen las hijas de Judá,porque tú haces justicia."
,"13":"Dad vueltas a Sión, enumerad sus torres;"
,"14":"admirad sus murallas, fijaos en sus palacios, para contar a las generaciones venideras"
,"15":"que este Dios es nuestro Dios,por los siglos de los siglos. Él nos guía."
}`)
	CurrentBook.AddChapter(49, `{
"1":"Al maestro de coro. Salmo de los hijos de Coré"
,"2":"Oíd, pueblos todos; escuchad, habitantes de la tierra,"
,"3":"gente de pueblo y gente ilustre, pobres y ricos a la vez."
,"4":"Mi boca anuncia la sabiduría,y el murmullo de mi corazón la sensatez;"
,"5":"mi oído está atento a los proverbios, al son de la cítara resuelvo los enigmas."
,"6":"¿Por qué voy a temer en días aciagos, cuando me acorralan los explotadores,"
,"7":"que confían en sus riquezas,y presumen de su gran fortuna?"
,"8":"Nadie puede rescatarse a sí mismo,ni pagar a Dios por su propio rescate."
,"9":"Por costoso que sea el rescate de la vida, ella terminará para siempre jamás."
,"10":"¿Es que van a vivir indefinidamente?, ¿se van a quedar sin ver la fosa?"
,"11":"No, la verán todos: los sabios mueren, lo mismo que los necios y los tontos, y dejan para otros sus riquezas."
,"12":"Las tumbas son para siempre sus mansiones, sus moradas eternas, por más que hayan dado sus nombres a sus tierras."
,"13":"El hombre en su riqueza no comprende que es igual a las bestias que perecen."
,"14":"Tal es la suerte de los que en sí confían, el fin de los que en sus discursos se recrean:"
,"15":"como rebaños destinados al abismo,bajan derechos a la tumba; los justos triunfarán sobre ellos, se esfumará su imagen y habitarán en el abismo, lejos de sus mansiones palaciegas."
,"16":"Pero Dios rescatará mi vida, me arrancará de las fuerzas del abismo."
,"17":"No sufras cuando un hombre se hace rico,y crece la hacienda de su casa;"
,"18":"pues, cuando muera, no ha de llevarse nada, su hacienda no bajará con él."
,"19":"Aunque en vida se felicitaba: 'Te alaban porque has hecho fortuna',"
,"20":"un día llegará en que se muera,y no verá la luz nunca jamás."
,"21":"El hombre en su riqueza no comprende que es igual a las bestias que perecen."
}`)
	CurrentBook.AddChapter(50, `{
"1":"Salmo a Asaf,El Dios de los dioses, el Señor, ha hablado, ha convocado al mundo de oriente a occidente."
,"2":"Desde Sión, dechado de hermosura, Dios resplandece."
,"3":"Ya viene nuestro Dios y no se callará. Un fuego que devora lo precede, y en torno a él una borrasca brama."
,"4":"Desde lo alto convoca a los cielos,y a la tierra a presenciar el juicio de su pueblo:"
,"5":"'Reunid a mis leales, los que firmaron mi alianza ofreciendo un sacrificio'."
,"6":"Que los cielos pregonen su justicia, porque el juez es Dios mismo."
,"7":"'Escucha, pueblo mío, voy a hablarte; Israel, voy a declarar en contra tuya, yo, Dios, tu Dios."
,"8":"No te acuso por los sacrificio,ni por los holocaustos que a diario me ofreces;"
,"9":"no te pido un toro de tu casa,ni machos cabríos de tus apriscos,"
,"10":"pues mías son todas las fieras de la selva, lo mismo que los animales de los montes;"
,"11":"conozco todas las aves de los cielos, toda la fauna de la tierra es mía."
,"12":"Si tuviera hambre, no te lo diría, porque mío es el mundo y cuanto encierra."
,"13":"¿Es que voy a comer la carne de los toros,o a beber la sangre de los machos cabríos?"
,"14":"Tu ofrenda a Dios, que sea la acción de gracias, cumple tus promesas al altísimo,"
,"15":"invócame cuando estés angustiado; yo te libraré y tú deberás glorificarme'."
,"16":"Pero al delincuente Dios le dice: '¿Por qué citas mis leyes,y tienes en tu boca mi alianza,"
,"17":"tú que detestas la corrección,y rechazas mis palabras?"
,"18":"Si ves a un ladrón, te haces su cómplice, te juntas también con los adúlteros;"
,"19":"entregas tu boca al crimen,y tu lengua al engaño;"
,"20":"te sientas y calumnias a tu hermano, deshonras al hijo de tu madre."
,"21":"Tú haces todo esto, ¿y yo voy a callarme?,¿Es que te imaginas que yo soy como tú?,Te denunciaré y te lo echaré en cara."
,"22":"Entended esto bien los que olvidáis a Dios, si no queréis que os destroce,y no haya quien os salve;"
,"23":"el que me ofrece la acción de gracias, ése me honra y toma el camino,en el que encuentra la salvación de Dios'."
}`)
	CurrentBook.AddChapter(51, `{
"1":"Al maestro de coro. Salmo de David."
,"2":"Cuando el profeta Natán vino a él después de su pecado con Betsabé"
,"3":"Ten compasión de mí, oh Dios, por tu misericordia, por tu inmensa ternura borra mi iniquidad."
,"4":"Lávame más y más de mi delito y purifícame de mi pecado."
,"5":"Reconozco mi iniquidad, tengo siempre delante mi pecado."
,"6":"Contra ti, contra ti solo pequé,y he hecho lo que tú no puedes ver. Por eso tu sentencia es justa,y eres recto en el juicio."
,"7":"Ya nací en la culpa, y en el pecado me concibió mi madre."
,"8":"Tú quieres la verdad en el centro del alma,y en el centro del corazón me enseñas la sabiduría."
,"9":"Purifícame con el hisopo, y quedaré puro; lávame, y quedaré más blanco que la nieve."
,"10":"Hazme sentir gozo y alegría, y que dancen los huesos que rompiste."
,"11":"Aparta tu rostro de mis faltas, cancela mis pecados."
,"12":"Oh Dios, crea en mí un corazón puro, implanta en mis entrañas un espíritu nuevo;"
,"13":"no me rechaces lejos de tu rostro, no retires de mí tu santo espíritu;"
,"14":"dame la alegría de tu salvación,y que el espíritu generoso me mantenga firme."
,"15":"Enseñaré tus caminos a los descarriados, los pecadores volverán a ti."
,"16":"Líbrame de delitos de sangre, Señor, salvador mío, y mi lengua exaltará tu justicia."
,"17":"Señor, abre mis labios, y mi boca anunciará tu alabanza."
,"18":"Tú no quieres ofrendas ni holocaustos; si te los ofreciera, no los aceptarías."
,"19":"El sacrificio que Dios quiere es un espíritu contrito, un corazón contrito y humillado, tú, oh Dios, no lo desprecias."
,"20":"Sé propicio a Sión en tu benevolencia, reconstruye las murallas de Jerusalén."
,"21":"Entonces aceptarás los sacrificios justos,-holocaustos y ofrendas perfectas-, entonces se ofrecerán novillos en tu altar."
}`)
	CurrentBook.AddChapter(52, `{
"1":"Al maestro de coro. Maskil de David"
,"2":"Cuando el idumeo Doeg vino a anunciar a Saúl: 'David ha entrado en casa de Ajimélec'."
,"3":"¿Por qué presumes, bravucón, de tus delitos?,El amor de Dios es constante."
,"4":"Pasas el día proyectando crímenes, tu lengua es cuchilla afilada, autor de engaños;"
,"5":"prefieres el mal en vez del bien,y el engaño en vez de la justicia;"
,"6":"prefieres propósitos funestos, oh lengua engañadora."
,"7":"Por eso Dios te aplastará, te destruirá para siempre, te sacará de tu tienda, te extirpará de la tierra de los vivos."
,"8":"Los justos lo verán y temerán, se reirán de él y dirán:"
,"9":"'Mirad al bravucón que no hizo de Dios su fortaleza, que cifró su seguridad en sus muchas riquezas,y de los delitos hizo su poder'."
,"10":"Mas yo, como un olivo verde en la casa de Dios, confío constantemente en la misericordia del Señor."
,"11":"Te estaré eternamente agradecido por todo lo que has hecho, proclamaré las bondades de tu nombre delante de tus fieles."
}`)
	CurrentBook.AddChapter(53, `{
"1":"Al maestro de coro. Para la enfermedad. Maskil de David"
,"2":"El insensato dice en su corazón: 'Dios no existe'. Todos se han pervertido, todos obran mal, no hay quien obre bien."
,"3":"El Señor observa desde el cielo a los hombres, para ver si hay alguno cuerdo que busque a Dios."
,"4":"Todos están descarriados, en masa pervertidos, no hay nadie que obre bien, ni uno solo."
,"5":"¿No aprenderán los malvados,que devoran a mi pueblo como pan,y no invocan el nombre del Señor?"
,"6":"Pues tendrán que temblar de espanto, porque Dios dispersa las fuerzas del agresor, y serán derrotados porque Dios los rechaza."
,"7":"¡Ojalá venga de Sión la victoria de Israel!,Cuando el Señor reúna a los cautivos de su pueblo, exultará Jacob, se alegrará Israel."
}`)
	CurrentBook.AddChapter(54, `{
"1":"Al maestro de coro. Para instrumento de cuerda. Maskil de David."
,"2":"Cuando los cifeos vinieron a decir a Saúl que David estaba escondido entre ellos"
,"3":"Oh Dios, sálvame por tu nombre, por tu poder hazme justicia."
,"4":"Oh Dios, escucha mi oración, atiende a las palabras de mi boca;"
,"5":"pues se ha alzado contra mí una gente extraña, unos tiranos me persiguen a muerte, y para ellos Dios no cuenta nada."
,"6":"Pero Dios viene en mi auxilio, el Señor es el único apoyo de mi vida;"
,"7":"que caiga su maldad sobre los que me espían, destrúyelos, Señor, por tu fidelidad."
,"8":"Te ofreceré sacrificios de todo corazón,y ensalzaré tu nombre, Señor, porque eres bueno,"
,"9":"porque me has librado de todas mis angustias,y he visto la derrota de mis enemigos."
}`)
	CurrentBook.AddChapter(55, `{
"1":"Al maestro de coro. Para instrumentos de cuerda. Maskil de David"
,"2":"Oh Dios, escucha mi oración, no te ocultes cuando te suplico,"
,"3":"atiéndeme, respóndeme; mi lamento me angustia, me turbo "
,"4":"ante la voz de mi enemigo,y bajo la presión de un criminal, pues desencadenan desdichas contra mí,y me atacan con rabia;"
,"5":"mi corazón en mi pecho se retuerce, me asaltan los pavores de la muerte;"
,"6":"me invaden el miedo y el temblor, y el espanto me envuelve."
,"7":"Entonces me digo: ¡Quién me diera alas para volar,como el águila en busca de un refugio!"
,"8":"Sí, me iría muy lejos, para pasar la noche en el desierto,"
,"9":"a toda prisa buscaría un refugio,contra la tempestad y contra el viento."
,"10":"Dispérsalos, Señor, confúndeles las lenguas, pues he visto en la ciudad la discordia y la violencia;"
,"11":"sobre las murallas la rondan noche y día, y dentro de ella la opresión y el crimen;"
,"12":"en su interior no hay más que corrupción, sus calles están llenas de opresión y de estafa."
,"13":"Si un enemigo me ultrajara, yo lo soportaría; si un adversario se alzara contra mí, de él me escondería,"
,"14":"pero eres tú, un hombre de los míos, mi familiar, mi amigo íntimo;"
,"15":"nos intercambiábamos dulces confidencias, íbamos muy unidos a la casa de Dios."
,"16":"Que se mueran todos, que bajen vivos al abismo, pues la iniquidad se ha instalado en ellos,como en su propia casa."
,"17":"Yo invocaré a Dios, el Señor me salvará."
,"18":"Tarde, mañana y mediodía gimo y suspiro; él ha oído mis gritos,"
,"19":"me ha librado y rescatado, sano y salvo, de todos los que me atacaban, que eran muchos."
,"20":"Dios me escuchará y los humillará,el que reina eternamente, pero no tienen enmienda, pues no temen a Dios."
,"21":"Levantan la mano contra sus aliados,y rompen el pacto;"
,"22":"su boca es más dulce que la crema, pero su corazón hace la guerra; sus palabras, más suaves que el aceite, son espadas desnudas."
,"23":"Encomienda a Dios tus cuidados,y él te sostendrá, no permitirá que el hombre justo caiga."
,"24":"Tú, oh Dios, los harás bajar al fondo de la fosa; los asesinos y los estafadores no llegarán a la mitad de su existencia; pero yo espero en ti."
}`)
	CurrentBook.AddChapter(56, `{
"1":"Al maestro de coro. Según 'Paloma que viene de lejos'. Poema de David. Cuando los filisteos le apresaron en Gat"
,"2":"Piedad, Dios mío, que los hombres me acosan, todo el día me atacan y me oprimen;"
,"3":"mis enemigos me acosan sin cesar, innumerables son los que me atacan."
,"4":"Cuando estoy lleno de miedo, yo me refugio en ti."
,"5":"En Dios, cuya palabra alabo, en Dios confío y ya no tengo miedo; ¿qué podrá hacerme un hombre?"
,"6":"Se pasan el día haciéndome sufrir, sólo piensan en hacerme daño;"
,"7":"se conjuran, se esconden, vigilan mis pasos,tratando de quitarme la vida."
,"8":"Dales lo que su culpa merece, aplasta, oh Dios, en tu cólera a los pueblos."
,"9":"Tú cuentas los pasos de mi vida errante, mis lágrimas están recogidas en tu odre, todo está consignado en tu libro de notas."
,"10":"Todos mis enemigos retrocederán,el día en que yo te pida ayuda; yo sé muy bien que Dios está conmigo."
,"11":"En Dios, cuya palabra alabo,-en el Señor, cuya palabra ensalzo-,"
,"12":"en Dios confío y ya no tengo miedo; ¿qué podrá hacerme un hombre?"
,"13":"Yo mantengo, Dios mío, los votos que te hice, los cumpliré con la acción de gracias,"
,"14":"pues tú me libraste de la muerte, preservaste mis pies de la caída, para que camine en la presencia del Señor,a la luz de la vida."
}`)
	CurrentBook.AddChapter(57, `{
"1":"Al maestro de coro. Según 'No destruyas'. Poema de David, cuando huyendo de Saúl se escondió en la cueva"
,"2":"Piedad, Dios mío; ten piedad de mí, pues mi refugio lo he buscado en ti; me refugio a la sombra de tus alas,hasta que haya pasado el infortunio."
,"3":"Invoco al Dios altísimo, al Dios que tanto hace por mí."
,"4":"Desde los cielos mandará a salvarme, fustigará a mis opresores, enviará su amor y su verdad."
,"5":"Vivo en medio de leones que devoran hombres, sus dientes son lanzas y flechas; su lengua, una espada acerada."
,"6":"Álzate, oh Dios, sobre los cielos, que tu gloria domine sobre la tierra entera."
,"7":"Tendieron una red delante de mis pasos, yo bajé la cabeza; delante de mí cavaron una fosa,y cayeron dentro de ella."
,"8":"A punto está mi corazón, oh Dios, mi corazón a punto; quiero cantar un himno:"
,"9":"'Despierta, gloria mía, despertad, arpa y cítara, que voy a despertar yo a la aurora'."
,"10":"Te alabaré, Señor, ante los pueblos, a ti te cantaré entre las naciones,"
,"11":"pues grande hasta los cielos es tu amor,y grande hasta las nubes tu lealtad."
,"12":"Álzate, oh Dios, sobre los cielos, que tu gloria domine sobre la tierra entera."
}`)
	CurrentBook.AddChapter(58, `{
"1":"Al maestro de coro. Según 'No destruyas'. Poema de David"
,"2":"¿De veras, jueces, administráis justicia, juzgáis según derecho a los hombres?"
,"3":"¡No! Conscientemente cometéis injusticias, abrís camino a la violencia en el país."
,"4":"Los criminales lo son desde el vientre de su madre, los embaucadores antes de nacer ya son así;"
,"5":"están envenenados con veneno de víbora, sordos como el áspid que se tapa el oído"
,"6":"para no oír la voz de los encantadores, del mago experto en el encanto."
,"7":"Oh Dios, rompe los dientes de su boca, a estos leones rómpeles las muelas;"
,"8":"que se disuelvan como agua derramada, que se sequen como hierba que se pisa;"
,"9":"pasen como la babosa que se deshace en baba, como el abortado que nunca vio la luz."
,"10":"Antes que vuestras ollas sientan la llama de la zarza, sea verde o quemada, las barra el huracán."
,"11":"El justo se alegrará viendo la venganza, lavará sus pies en la sangre de los criminales."
,"12":"La gente dirá: 'Sí, hay premio para el justo. Sí, hay un Dios que hace justicia en la tierra'."
}`)
	CurrentBook.AddChapter(59, `{
"1":"Al maestro de coro. Según 'No destruyas'. Poema de David. Cuando Saúl mandó gente a vigilar su casa con ánimo de matarlo"
,"2":"Líbrame de mis enemigos, oh Dios mío, protégeme de mis agresores;"
,"3":"líbrame de los malhechores, sálvame de los asesinos."
,"4":"Mira que acechan a mi vida, poderosos conspiran contra mí;"
,"5":"sin culpa mía, corren y se lanzan. Despiértate, ven a mi encuentro y mira;"
,"6":"tú, Señor, Dios omnipotente, el Dios de Israel, levántate, castiga a las naciones, no tengas compasión de esos traidores."
,"7":"Regresan a la tarde, aúllan como perros, rondan por la ciudad."
,"8":"Son unas babosas y tienen espadas en los labios: 'No hay nadie que nos oiga'."
,"9":"Mas tú, Señor, te burlas de ellos, te ríes de todas las naciones."
,"10":"Hacia ti miro, oh fuerza mía, pues tú eres, oh Dios, mi fortaleza;"
,"11":"mi Dios viene a mi encuentro con su amor, me hará ver la derrota de mis enemigos."
,"12":"Mátalos, Señor, para que mi pueblo no lo olvide; hazlos con tu poder vagabundos y errantes, oh Señor, nuestro escudo."
,"13":"Las palabras de su boca no son más que pecado; que caigan presa de su propio orgullo,por sus blasfemias y falsos juramentos."
,"14":"Destrúyelos con tu furor, destrúyelos, que dejen de existir; así sabrán que Dios reina en Jacob,y hasta en los confines de la tierra."
,"15":"Regresan a la tarde, aúllan como perros, rondan por la ciudad,"
,"16":"vagan buscando qué comer, y si no logran saciarse, pasan la noche aullando."
,"17":"Yo, en cambio, cantaré tu poder, aclamaré tu amor por la mañana, pues tú has sido para mí una fortaleza, un refugio en el día de mi angustia."
,"18":"Oh fuerza mía, cantaré para ti; sí, oh Dios, mi fortaleza, Dios mío y amor mío."
}`)
	CurrentBook.AddChapter(60, `{
"1":"Al maestro de coro. Según 'Lirio de la ley'. Poema de David. Para enseñar."
,"2":"Cuando salió a luchar contra Siria de Naharayín y Siria de Sobá, y Joab, de regreso, derrotó en el valle de la Sal a Edón: doce mil hombres"
,"3":"Nos has rechazado, oh Dios, nos has deshecho, te has irritado, devuélvenos la fuerza;"
,"4":"has sacudido la tierra, la has rajado, sana sus grietas, pues se tambalea;"
,"5":"has hecho pasar por duras pruebas a tu pueblo, nos has dado a beber un vino que enloquece;"
,"6":"has dado una señal a tus leales,para que puedan escapar delante del arquero;"
,"7":"para que tus predilectos salgan libres, sálvanos con tu poder y atiéndenos."
,"8":"Dios ha hablado en su templo: 'Exultaré de gozo, repartiré a Siquén,y dividiré el valle de Sucot,"
,"9":"mío es Galaad y mío Manasés, yelmo de mi cabeza es Efraín y mi cetro Judá,"
,"10":"Moab es la vasija en que me lavo, tiro mis sandalias sobre Edón, canto victoria sobre Filistea'."
,"11":"¿Quién me conducirá a la ciudad fortificada?, ¿quién me guiará hasta Edón?"
,"12":"Tú, oh Dios, que nos has rechazado,y no sales ya con nuestras tropas."
,"13":"Ayúdanos tú contra los opresores, pues la ayuda del hombre no vale para nada."
,"14":"Con la ayuda de Dios haremos cosas grandes, él aplastará a nuestros opresores."
}`)
	CurrentBook.AddChapter(61, `{
"1":"Al maestro de coro. Para instrumentos de cuerda. De David"
,"2":"Oh Dios, escucha mi grito, atiende mi plegaria."
,"3":"Desde el fin de la tierra hacia ti,clamo cuando me falla el corazón; súbeme a la roca, que está muy alta para mí,"
,"4":"pues tú eres mi refugio, torre potente frente al enemigo."
,"5":"Ojalá pueda habitar en tu tienda eternamente,y encontrar refugio al abrigo de tus alas."
,"6":"Tú, oh Dios, has escuchado mis promesas,y me has dado la herencia de los que temen tu nombre."
,"7":"Añade días a los días del rey, sus años llenen muchas generaciones;"
,"8":"que reine siempre en presencia de Dios, que le guarden tu amor y tu fidelidad."
,"9":"Yo cantaré a tu nombre sin cesar, día tras día cumpliré mis promesas."
}`)
	CurrentBook.AddChapter(62, `{
"1":"Al maestro de coro. Según Yedutún. Salmo de David"
,"2":"Mi alma sólo descansa en Dios, mi salvación viene de él;"
,"3":"sólo él es mi roca, mi salvación, mi fortaleza; no sucumbiré."
,"4":"¿Hasta cuándo atacaréis a un hombre,solo todos a una para derribarlo,como una pared que se desploma,o una tapia a punto de caerse?"
,"5":"Desde su altura tratan de derrocarme, se complacen en la falsedad; con la boca bendicen,y con el corazón maldicen."
,"6":"Mi alma sólo descansa en Dios, mi salvación viene de él;"
,"7":"sólo él es mi roca, mi salvación, mi fortaleza; no sucumbiré."
,"8":"Mi gloria y mi salvación están en Dios, en Dios, mi roca de defensa y mi refugio."
,"9":"Confiad en él, oh pueblo, en todo tiempo; Dios es nuestro refugio."
,"10":"Los hombres del pueblo son un soplo, la gente ilustre, una mentira; cuando se los pone en la balanza, todos juntos pesan menos que un soplo."
,"11":"No esperéis nada de la violencia, no os hagáis ilusión con la rapiña; si llegáis a ser ricos, no pongáis vuestro corazón en las riquezas."
,"12":"Dios ha dicho una cosa, y luego otra; yo lo he oído;"
,"13":"esto: que el poder es de Dios; de ti, Señor, es la lealtad; y esto: que tú pagas a cada uno según sus obras."
}`)
	CurrentBook.AddChapter(63, `{
"1":"Salmo de David. Cuando estaba en el desierto de Judá"
,"2":"Oh Dios, tú eres mi Dios; desde el amanecer ya te estoy buscando, mi alma tiene sed de ti, en pos de ti mi ser entero desfallece,cual tierra de secano árida y falta de agua."
,"3":"Así en el santuario te contemplo,para ver tu gloria y tu poder."
,"4":"Tu amor vale más que la vida, mis labios te alabarán;"
,"5":"toda mi vida te bendeciré, en tu nombre levantaré mis manos;"
,"6":"me saciaré como en banquete espléndido, mi boca te alabará con labios jubilosos."
,"7":"Cuando estoy en la cama pienso en ti, en ti medito en los insomnios de la noche,"
,"8":"porque tú eres mi auxilio,y a la sombra de tus alas me recreo;"
,"9":"me abrazo a ti con toda el alma, y tu diestra me sostiene."
,"10":"Pero aquellos que sin razón buscan mi vida,caerán en lo profundo de la tierra;"
,"11":"serán pasados al filo de la espada, serán presa de chacales."
,"12":"El rey en Dios se gozará, los que juran por él se gloriarán, mientras que los mentirosos tendrán la boca bien cerrada."
}`)
	CurrentBook.AddChapter(64, `{
"1":"Al maestro de coro. Salmo de David"
,"2":"Escucha, oh Dios, la voz de mi lamento, guarda mi vida del terror del enemigo;"
,"3":"escóndeme de las bandas criminales, de las pandillas de los delincuentes."
,"4":"Afilan su lengua como espadas,y disparan como flechas palabras venenosas,"
,"5":"para herir desde el escondite al inocente, para herirlo por sorpresa y sin ser vistos."
,"6":"Se hacen fuertes en sus actos delictivos, maquinan cómo tender lazos ocultos, y dicen: 'Nadie podrá vernos'."
,"7":"Elaboran proyectos criminales, ponen a punto un plan perfecto: el hombre es insondable, su corazón es un abismo."
,"8":"Pero Dios lanza sus flechas contra ellos,y de repente brotan sus heridas;"
,"9":"sus propias palabras les harán caer, los que los vean se burlarán de ellos."
,"10":"Presos de terror, todos los hombres publican lo que Dios ha hecho, y de estos hechos sacan la lección."
,"11":"El justo se alegra en el Señor y en él espera, todos los de recto corazón se sentirán satisfechos."
}`)
	CurrentBook.AddChapter(65, `{
"1":"Al maestro de coro. Salmo de David. Cántico"
,"2":"Oh Dios, que habitas en Sión, a ti debemos alabarte, por ti hay que cumplir lo prometido;"
,"3":"hasta ti, que escuchas las plegarias, todo mortal puede llegar."
,"4":"Nuestros delitos son más fuertes que nosotros, pero tú nos los perdonas."
,"5":"Dichoso el que tú eliges,y llamas junto a ti,para que habite en tus atrios; nosotros nos saciaremos de los bienes de tu casa, de las cosas de tu santo templo."
,"6":"Tu justicia nos responde con prodigios, oh Dios, salvador nuestro, esperanza de los confines de la tierra y los mares lejanos;"
,"7":"tú, que afirmas los montes con tu fuerza,y te ciñes de bravura;"
,"8":"tú, que acallas el estruendo de los mares, el bramar de sus olas y el tumulto de los pueblos."
,"9":"Ante tus prodigios tiemblan todos los habitantes de la tierra, tú llenas de alegría las regiones de oriente y occidente."
,"10":"Tú visitas la tierra y la fecundas, la colmas de riquezas; tus ríos caudalosos van rebosando de agua."
,"11":"Tú dispones la tierra de este modo: riegas sus surcos, deshaces los terrones, la ablandas con la lluvia, bendices su semilla;"
,"12":"tú coronas el año con tus bienes, por tus senderos fluye la abundancia;"
,"13":"rezuman los pastos del desierto,y las colinas se ciñen de alegría;"
,"14":"las praderas se cuajan de rebaños,y los valles se cubren de trigales: todo canta y grita de alegría."
}`)
	CurrentBook.AddChapter(66, `{
"1":"Al maestro de coro. Cántico. Salmo,Aclamad a Dios toda la tierra,"
,"2":"cantad la gloria de su nombre, tributadle su gloriosa alabanza;"
,"3":"decid a Dios: 'Tus obras son maravillosas'. Por la grandeza de tu poder,tus enemigos ante ti se rinden;"
,"4":"toda la tierra se prosterna ante ti, canta para ti, canta a tu nombre."
,"5":"Venid y ved las proezas de Dios, las maravillas que ha hecho por los hombres."
,"6":"Él convirtió el mar en tierra firme, y el río atravesaron a pie enjuto;"
,"7":"con su poder gobierna eternamente, con sus ojos vigila a las naciones, para que no se subleven los rebeldes."
,"8":"Pueblos, bendecid a nuestro Dios, proclamad a plena voz sus alabanzas;"
,"9":"él nos conserva la vida,y no permite que tropiecen nuestros pies."
,"10":"Sí, oh Dios, tú nos pusiste a prueba, nos pasaste por el crisol, como la plata;"
,"11":"nos hiciste caer en el lazo, nos echaste a las costillas una carga pesada,"
,"12":"dejaste que cabalgaran sobre nuestras cabezas, anduvimos a través de agua y fuego, pero, al fin, nos hiciste recobrar aliento."
,"13":"Entraré con holocaustos en tu casa, cumpliré mis promesas,"
,"14":"las que mis labios formularon, las que en la angustia formuló mi boca."
,"15":"Te ofreceré pingües holocaustos, con la fragancia de carneros, te ofreceré toros y cabritos."
,"16":"Fieles del Señor, venid a escuchar, os contaré lo que él hizo por mí."
,"17":"Mi boca lo llamó y mi lengua lo ensalzó."
,"18":"Si hubiera alguna culpa en mi conciencia, el Señor no me habría escuchado;"
,"19":"pero Dios me ha escuchado, ha atendido la voz de mi plegaria."
,"20":"Bendito sea Dios, que no ha rechazado mi plegaria,ni me ha retirado su misericordia."
}`)
	CurrentBook.AddChapter(67, `{
"1":"Al maestro de coro. Para instrumentos de cuerda. Salmo"
,"2":"Que Dios tenga piedad y nos bendiga, haga brillar su rostro entre nosotros"
,"3":"para que en la tierra se conozca su camino,y su salvación en todas las naciones."
,"4":"Oh Dios, que te alaben los pueblos, que todos los pueblos te alaben."
,"5":"Que canten de alegría las naciones, pues tú juzgas al mundo con justicia,y gobiernas los pueblos de la tierra."
,"6":"Oh Dios, que te alaben los pueblos, que todos los pueblos te alaben."
,"7":"La tierra ha dado su cosecha, Dios, nuestro Dios, nos bendice."
,"8":"Que Dios nos bendiga,y que le rinda honor el mundo entero."
}`)
	CurrentBook.AddChapter(68, `{
"1":"Al maestro de coro. Salmo de David. Cántico"
,"2":"Se alza el Señor y sus enemigos se dispersan, huyen de su presencia sus contrarios."
,"3":"Como se disipa el humo, los disipas; como la cera se derrite al fuego, así caen los malvados ante Dios."
,"4":"Los justos se regocijan en la presencia del Señor, se alborozan y saltan de alegría."
,"5":"Cantad a Dios, cantad himnos a su nombre, abrid paso al que cabalga por las nubes; su nombre es 'El Señor', celebrad su presencia."
,"6":"Padre de los huérfanos, defensor de las viudas, tal es Dios en su morada santa."
,"7":"Dios da una casa a los abandonados, da a los prisioneros la libertad dichosa; sólo los rebeldes viven en su tierra abrasada."
,"8":"Oh Dios, cuando saliste al frente de tu pueblo, cuando avanzabas a través del desierto,"
,"9":"la tierra tembló, los cielos chorrearon ante Dios, el Dios del Sinaí, el Dios de Israel."
,"10":"Derramaste, oh Dios, una lluvia abundante, reanimaste tu heredad extenuada;"
,"11":"allí encontró tu pueblo una morada, la que en tu bondad, oh Dios, al pobre preparabas."
,"12":"El Señor da una orden, multitud de mensajeros la transmiten:"
,"13":"'Los reyes escapan, los ejércitos huyen, las mujeres en casa reparten el botín:"
,"14":"alas de paloma con un baño de plata, plumas refulgentes con un baño de oro, mientras vosotros en el aprisco descansáis."
,"15":"Allí el omnipotente dispersaba a los reyes,y las nieves caían en el monte Salmón."
,"16":"Montes divinos, los montes de Basán; montes encrestados, los montes de Basán."
,"17":"¿Por qué miráis celosos, oh montes encrestados, el monte en que Dios quiere morar, en el que el Señor por siempre morará?"
,"18":"Por miles y millones cuenta Dios sus carros de combate, el Señor vino en ellos del Sinaí al santuario."
,"19":"Tú subiste a la altura llevando prisioneros, recibiste tributo de hombres; los mismos rebeldes, oh Dios, se sometieron ante ti."
,"20":"Bendito sea el Señor día tras día, él cuida de nosotros, es nuestro salvador."
,"21":"Nuestro Dios es el Dios libertador, el Señor, nuestro Dios, nos libra de la muerte."
,"22":"Dios aplasta la cabeza de sus enemigos, el cráneo cabelludo de los criminales."
,"23":"El Señor dijo: 'Los sacaré de Basán, los sacaré del fondo de los mares,"
,"24":"para que puedas bañar tu pie en la sangre, y la lengua de tus perros tenga su ración del enemigo'."
,"25":"Oh Dios, se ven tus procesiones, las procesiones de mi Dios, mi rey, al santuario:"
,"26":"delante los cantores, los músicos detrás,y en medio las doncellas tocando panderetas."
,"27":"Bendecid a Dios en vuestras asambleas, bendecid al Señor en las reuniones de Israel."
,"28":"Allí va Benjamín, el pequeño, abriendo marcha, los jefes de Judá, de Zabulón, de Neftalí."
,"29":"Oh Dios, despliega tu poder, confirma, oh Dios, lo que has hecho por nosotros."
,"30":"Que en tu santuario, en lo alto de Jerusalén, te ofrezcan presentes los monarcas."
,"31":"Amenaza a la bestia de los cañaverales, a la manada de toros dominadores de los pueblos; que vengan a rendirse con lingotes de plata; dispersa a las naciones que se complacen en la guerra."
,"32":"De Egipto vendrán los poderosos, Etiopía alzará sus manos hacia Dios."
,"33":"Reinos de la tierra, cantad para el Señor, alabad al Señor,"
,"34":"al que cabalga por encima de los cielos eternos; ya levanta su voz, su voz potente:"
,"35":"'Reconoced el poderío de Dios, su majestad sobre Israel, su potencia en las nubes'."
,"36":"Dios es imponente desde su santuario. Es el Dios de Israel que da a su pueblo fuerza y poderío. Bendito sea Dios."
}`)
	CurrentBook.AddChapter(69, `{
"1":"Al maestro de coro. Según 'Lirio'. De David"
,"2":"Sálvame, Dios mío, que las aguas me llegan hasta el cuello;"
,"3":"me hundo en cenagal sin fondo,y no puedo hacer pie; he llegado hasta el fondo del agua,y me arrastra la corriente."
,"4":"Estoy extenuado de gritar,y totalmente ronco, mis ojos se han consumido de esperar a mi Dios."
,"5":"Son más numerosos que los pelos de mi cabeza,los que me odian sin motivo, más fuertes que mis huesos,los que me atacan sin razón. Lo que no he robado, ¿tendré que devolver?"
,"6":"Oh Dios, tú sabes mi locura, no se te ocultan mis delitos;"
,"7":"Señor omnipotente, que yo no sea la vergüenza,de los que en ti confían, que no sea el deshonor,de los que a ti te buscan, oh Dios de Israel."
,"8":"Por ti soporto los insultos,y mi rostro se cubre de vergüenza,"
,"9":"pues soy como un extranjero para mis hermanos, como un extraño para los hijos de mi madre."
,"10":"El celo de tu casa me devora, las ofensas que te hacen recaen sobre mí."
,"11":"Cuando me ven llorando y ayunando, se burlan de mí;"
,"12":"cuando me visto de sayal, soy el hazmerreír de todos ellos;"
,"13":"sentados a la puerta me critican, hasta soy la canción de los borrachos."
,"14":"Pero yo, Señor, te elevo mi plegaria, ésta es la hora en que me debes ser propicio; escúchame, Dios mío, por tu inmensa bondad, pues tú eres la verdadera salvación."
,"15":"Sácame del cenagal, que no me hunda; líbrame de mis enemigos, de las aguas profundas;"
,"16":"que no me arrastre la corriente de las aguas, que el remolino no me trague,ni cierre tras mí su boca el pozo."
,"17":"Respóndeme, Señor, pues tú eres todo bondad y amor, con tu inmensa piedad vuelve hacia mí tus ojos;"
,"18":"no retires el rostro de tu siervo, estoy muy angustiado, respóndeme deprisa."
,"19":"Ven junto a mí, defiéndeme, líbrame de mis enemigos."
,"20":"Tú conoces mi afrenta, mi ignominia y mi vergüenza; todos mis opresores están ante tu vista."
,"21":"El ultraje quebró mi corazón, estoy perdido, esperé compasión, pero fue en vano, consoladores, y no encontré ni uno."
,"22":"Pusieron veneno en mi comida, cuando tenía sed me dieron a beber vinagre."
,"23":"Que su mesa se convierta en un lazo para ellos,y en una trampa para sus amigos;"
,"24":"que se queden para siempre ciegos, que para siempre se doblen sus riñones."
,"25":"Descarga tu ira sobre ellos, que los alcance el fuego de tu cólera;"
,"26":"que sus tierras se vuelvan un desierto, que en sus tiendas no haya quien habite;"
,"27":"porque han perseguido al que tú heriste,y han aumentado los sufrimientos de tus víctimas."
,"28":"Impútales delito tras delito, que no alcancen tu perdón;"
,"29":"bórralos del libro de la vida, no los inscribas con los justos."
,"30":"Yo soy un desgraciado y un enfermo, ayúdame, Dios mío, y sálvame."
,"31":"Alabaré el nombre de Dios con cánticos, lo ensalzaré con acciones de gracias;"
,"32":"esto le agradará a Dios más que un toro, más que un novillo con cuernos y pezuñas."
,"33":"Los humildes, al verlo, se regocijarán, y los que buscan a Dios cobrarán ánimo."
,"34":"Porque Dios escucha a los pobres,y no rechaza a sus presos."
,"35":"Que lo alaben los cielos y la tierra, el mar y cuanto en él se mueve."
,"36":"Porque Dios salvará a Sión, reconstruirá las ciudades de Judá, habitarán en ellas y las poseerán."
,"37":"Las heredará la estirpe de sus siervos, y los que aman su nombre vivirán en ellas."
}`)
	CurrentBook.AddChapter(70, `{
"1":"Al maestro de coro. De David. En memoria"
,"2":"Oh Dios, ven a librarme; Señor, ven corriendo a ayudarme;"
,"3":"que queden cubiertos de vergüenza,los que buscan mi muerte, que retrocedan afrentados,los que quieren mi ruina;"
,"4":"que vuelvan atrás avergonzados,los que de mí se burlan."
,"5":"Que se alegren y se regocijen en ti,todos los que te buscan; repitan siempre: 'Dios es grande',los que desean tu salvación."
,"6":"Yo soy un pobre y desgraciado, Señor, socórreme; tú eres mi ayuda y mi liberador, Señor, no tardes."
}`)
	CurrentBook.AddChapter(71, `{
"1":"A ti, Señor, me acojo: que jamás quede yo defraudado;"
,"2":"libérame, sálvame, pues tú eres justo; atiéndeme, ven corriendo a liberarme;"
,"3":"sé tú mi roca de refugio, la fortaleza de mi salvación; sí, tú eres mi roca y mi fortaleza."
,"4":"Dios mío, líbrame de la mano del malvado, de las garras del criminal y del violento;"
,"5":"pues tú eres mi esperanza, Señor, mi confianza desde mi juventud, oh Dios."
,"6":"Desde el seno materno me he apoyado en ti, tú eres mi protector desde el vientre de mi madre; en ti he esperado siempre."
,"7":"He sido un prodigio para muchos, pues tú has sido mi refugio seguro."
,"8":"Mi boca está llena todo el día de tu alabanza y de tu gloria."
,"9":"No me rechaces ahora que soy viejo, no me abandones cuando me faltan ya las fuerzas."
,"10":"Mis enemigos conspiran contra mí, los que buscan mi vida están de acuerdo;"
,"11":"dicen: 'Dios lo ha desamparado, perseguidlo, apresadlo, pues no hay quien lo defienda'."
,"12":"Oh Dios, no te quedes lejos; Dios mío, ven corriendo a socorrerme."
,"13":"Que caigan en la ruina avergonzados,los que buscan mi vida, que se cubran de infamia y deshonor,los que buscan mi desgracia."
,"14":"Mas yo no dejaré nunca de esperar, y aumentaré todavía tus alabanzas;"
,"15":"me paso todo el día publicando tus actos de liberación,y de justicia, aunque para mí son incalculables."
,"16":"Proclamaré las proezas del Señor, anunciaré que sólo tú eres justo."
,"17":"Oh Dios, desde mi juventud me has instruido, he anunciado hasta aquí tus maravillas;"
,"18":"ahora que estoy viejo y encanecido, oh Dios, no me abandones, para que pueda anunciar a esta generación,las obras de tu brazo, y tu poder a las edades venideras."
,"19":"Tu justicia, oh Dios, llega hasta las nubes; tú has hecho grandes cosas; oh Dios, ¿quién hay como tú?"
,"20":"Tú que me has hecho pasar tantas desgracias, tantos males, dame vida de nuevo, hazme salir de nuevo de los abismos de la tierra;"
,"21":"realza mi dignidad, confórtame de nuevo."
,"22":"Yo te ensalzaré con el arpa por tu fidelidad, Dios mío, y con la cítara tocaré para ti, oh Santo de Israel;"
,"23":"tocaré para ti, mis labios cantarán alegres,porque tú has rescatado mi vida;"
,"24":"mi lengua publicará todo el día tu justicia, pues han quedado avergonzados,y humillados los que buscaban mi desgracia."
}`)
	CurrentBook.AddChapter(72, `{
"1":"De Salomón,Oh Dios, haz que el rey ejerza tu justicia, que el descendiente real ejerza tu derecho;"
,"2":"que gobierne a tu pueblo con justicia,y juzgue a tus oprimidos según derecho."
,"3":"Gracias a la justicia, y,los montes y colinas traerán al pueblo la prosperidad."
,"4":"Que haga justicia a los oprimidos, que sea la salvación de los pobres, que aplaste a los explotadores."
,"5":"Que tenga temor de ti mientras la luna,y el sol brillen hasta el fin de los siglos;"
,"6":"que descienda como la lluvia en el retoño, como rocío que humedece la tierra."
,"7":"En sus días triunfará la justicia,y habrá una paz firme hasta que falte la luna;"
,"8":"dominará de mar a mar, desde el río hasta los límites del mundo;"
,"9":"ante él se rendirán sus enemigos, sus adversarios lamerán el polvo;"
,"10":"los reyes de Tarsis y las islas le traerán presentes, los reyes de Arabia y de Sabá le pagarán tributo;"
,"11":"ante él se rendirán todos los reyes, le servirán todas las naciones;"
,"12":"él liberará al pobre que suplica, al miserable que no tiene apoyo alguno;"
,"13":"se cuidará del débil y del pobre; a los pobres les salvará la vida;"
,"14":"él los defenderá contra la explotación y la violencia, su sangre tendrá un gran precio ante sus ojos."
,"15":"¡Viva el rey! Le traerán oro de Arabia, se rezará por él constantemente, se le estará bendiciendo todo el día."
,"16":"Habrá abundancia de trigo en el país, hasta en la cima de los montes ondearán las espigas como en el Líbano, florecerán como la hierba de los campos."
,"17":"Que eternice su nombre, que propague su nombre bajo el sol; para que en él sean bendecidas todas las razas de la tierra,y todas las naciones lo proclamen dichosas."
,"18":"Bendito sea el Señor, Dios de Israel, el único que hace maravillas;"
,"19":"bendito sea su nombre glorioso para siempre, que toda la tierra se llene de su gloria. ¡Amén! ¡Amén!"
}`)
	CurrentBook.AddChapter(73, `{
"1":"Salmo de Asaf,¡Qué bueno es Dios para el hombre recto, el Señor para los limpios de corazón!"
,"2":"A punto estuve de resbalar, por poco doy un paso en falso,"
,"3":"pues tuve envidia de los prepotentes,viendo la prosperidad de los malvados:"
,"4":"no se privan de nada hasta la muerte, sano y rollizo está su cuerpo;"
,"5":"no conocen la miseria humana, no sufren tribulaciones como los demás;"
,"6":"por eso su collar es la soberbia, la violencia su vestido;"
,"7":"los ojos se les saltan a pesar de estar tan gordos,y dejan traslucir la falsedad del corazón;"
,"8":"sonríen con malicia y hablan de explotar brutalmente, desde su altura proclaman la opresión;"
,"9":"ponen su boca en el cielo, su lengua se pasea por la tierra;"
,"10":"por eso mi pueblo va tras ellos,y beben de su agua en abundancia."
,"11":"Y dicen: '¿Cómo Dios va a saberlo?, ¿es que se va a dar cuenta el altísimo?'."
,"12":"Miradlos: éstos son los explotadores, con toda tranquilidad aumentan la fortuna."
,"13":"Luego en vano he conservado mi corazón limpio,y lavé mis manos en señal de inocencia."
,"14":"A todas horas soy apaleado, soy castigado todas las mañanas."
,"15":"Estuve por decir: 'Voy a hablar como ellos', pero hubiera traicionado la raza de tus hijos."
,"16":"Me puse a pensar para entender esto, pero me pareció muy complicado,"
,"17":"hasta que, entrando en el santuario de Dios, comprendí cuál sería su final."
,"18":"Los has puesto en lugar resbaladizo,y los empujas hacia la ruina;"
,"19":"en un momento serán destruidos, desaparecerán consumidos de espanto:"
,"20":"como en un sueño, al despertar, Señor, así, cuando despiertas, borras hasta su imagen."
,"21":"Cuando tenía amargado el corazón y mis entrañas desgarradas,"
,"22":"estúpido de mí, no comprendía nada; era como una bestia, pero estaba contigo."
,"23":"Yo estoy siempre contigo, me has agarrado de mi mano derecha;"
,"24":"con tus consejos me diriges,y me llevas hacia un final glorioso."
,"25":"¿A quién tengo yo en el cielo sino a ti?,Si estoy contigo, no me gusta ya la tierra."
,"26":"Mi cuerpo y mi corazón ya languidecen; el sostén de mi corazón, mi patrimonio, es Dios por siempre."
,"27":"Los que se alejan de ti perecerán; tú exterminas a los que te dejan y te son infieles."
,"28":"Para mí lo mejor es estar con Dios, yo he puesto mi refugio en el Señor,para poder narrar todas sus acciones."
}`)
	CurrentBook.AddChapter(74, `{
"1":"Maskil de Asaf,¿Por qué este rechazar, Señor, sin fin?, ¿por qué esta ardiente cólera,contra el rebaño de tus pastos?"
,"2":"Acuérdate del pueblo que de antiguo adquiriste, de la tribu que rescataste como herencia, del monte Sión, donde fijaste tu morada."
,"3":"Ven a ver estas ruinas sempiternas; en tu santuario todo lo ha destruido el enemigo."
,"4":"Tus enemigos han rugido en el mismo lugar de la asamblea, como signos han puesto sus banderas."
,"5":"Como el que blande y mete el hacha,en medio de un tupido bosque,"
,"6":"a mazazos y hachazos destrozaron todas las esculturas,"
,"7":"prendieron fuego a tu santuario, asolaron y profanaron la morada de tu nombre."
,"8":"En su interior decían: 'Destruyámoslo todo'. Han quemado todos los lugares de las asambleas de Dios en el país."
,"9":"No vemos ya nuestras banderas, ya no hay ningún profeta, y nadie sabe lo que esto durará."
,"10":"¿Hasta cuándo, oh Dios, seguirá blasfemando el enemigo?, ¿hasta cuándo seguirá ultrajando el opresor?"
,"11":"¿Por qué retiras tu mano poderosa,y te quedas cruzado de brazos?"
,"12":"Pero Dios es mi rey desde el principio, el que obra salvaciones en la tierra:"
,"13":"tú dividiste el mar con tu poder, rompiste en las aguas las cabezas de los monstruos;"
,"14":"tú las cabezas de Leviatán despedazaste,para hacer de ellas pasto de los monstruos marinos;"
,"15":"tú hiciste brotar manantiales y torrentes,y secaste los ríos inagotables."
,"16":"Tuyo es el día, tuya también la noche, tú la luna y el sol estableciste,"
,"17":"tú trazaste los confines de la tierra, tú formaste el invierno y el verano."
,"18":"Recuérdalo, Señor: el enemigo ha blasfemado contra ti, un pueblo de locos ha ultrajado tu nombre."
,"19":"No entregues al buitre el cuello de tu tórtola, no dejes en olvido la vida de tus pobres."
,"20":"Considera tu alianza, pues la medida se ha colmado, todos los rincones del país están llenos de violencia."
,"21":"No permitas que se humille al oprimido; que el desvalido y el pobre puedan alabarte."
,"22":"Álzate, oh Dios, y defiende tu causa, recuerda las continuas blasfemias de estos locos;"
,"23":"no olvides los gritos de tus enemigos, el alboroto de los rebeldes, que aumenta más y más."
}`)
	CurrentBook.AddChapter(75, `{
"1":"Al maestro de coro. Según 'No destruyas'. Salmo de Asaf. Cántico"
,"2":"Te damos gracias, oh Dios, te damos gracias, invocamos tu nombre y pregonamos tus proezas."
,"3":"'En la hora en que decida, juzgaré según derecho."
,"4":"Aunque la tierra tiemble con todos sus habitantes, yo mismo he asentado sus columnas."
,"5":"Digo a los arrogantes: ¡Fuera arrogancia!; y a los malvados: No levantéis la frente;"
,"6":"no levantéis tanto vuestra frente, no seáis tan altaneros al hablar'."
,"7":"Pues ni de oriente ni de occidente, ni del desierto ni de la montaña viene la salvación;"
,"8":"Dios es el que juzga: a unos humilla y a otros los ensalza."
,"9":"El Señor tiene una copa en la mano, echa en ella un vino fermentado y bien mezclado"
,"10":"y se lo hace beber hasta la última gota,a todos los malvados de la tierra."
,"11":"Yo, en cambio, siempre anunciaré y ensalzaré al Dios de Jacob."
}`)
	CurrentBook.AddChapter(76, `{
"1":"Al maestro de coro. Para instrumentos de cuerda. Salmo de Asaf. Cántico"
,"2":"Dios es bien conocido en Judá, su nombre es famoso en Israel;"
,"3":"su tienda está en Jerusalén,y su morada en Sión."
,"4":"Allí rompió el aparato de la guerra: el arco, las flechas, el escudo y la espada."
,"5":"Eres deslumbrante, poderoso, por las montañas de botín."
,"6":"Los valientes fueron despojados, durmiendo están su sueño, a todos los guerreros les fallaron los brazos."
,"7":"Ante tu amenaza, oh Dios de Jacob, carros y caballos quedaron inmóviles."
,"8":"Eres terrible: ¿quién puede resistir ante ti, bajo el estallido de tu ira?"
,"9":"Desde los cielos pronuncias la sentencia: la tierra se asusta y enmudece"
,"10":"cuando Dios se levanta para hacer justicia, para liberar a todos los oprimidos de la tierra."
,"11":"Hasta el furor del hombre te da gloria, te rodeas de los que escapan al furor."
,"12":"Haced promesas al Señor, vuestro Dios, y cumplidlas; que los pueblos de alrededor traigan ofrendas al terrible;"
,"13":"él deja sin aliento a los príncipes,y es terrible para los reyes de la tierra."
}`)
	CurrentBook.AddChapter(77, `{
"1":"Al maestro de coro. Según Yedutún. Salmo de Asaf"
,"2":"Yo llamo a Dios gritando, yo llamo a Dios, y él me escucha."
,"3":"En el día de la angustia acudo al Señor, alzo sin descanso mis manos en la noche,y no encuentro consuelo;"
,"4":"me acuerdo de Dios, y me pongo a llorar; me pongo a meditar, y me siento desfallecer;"
,"5":"no me dejas ni pegar el ojo, estoy aturdido y no sé qué decir;"
,"6":"pienso en los días de antaño, recuerdo los años de otros tiempos;"
,"7":"mi corazón se pasa las noches meditando, mi espíritu reflexiona y se pregunta:"
,"8":"¿Es que el Señor nos va a estar siempre rechazando?, ¿es que ya nunca nos va a ser propicio?"
,"9":"¿Se habrá agotado su gracia para siempre?, ¿se acabó su promesa por todas las edades?;"
,"10":"¿se habrá olvidado Dios de ser clemente?, ¿es que, encolerizado, ha cerrado ya su corazón?"
,"11":"Y digo: 'Ésta es mi pena: que ha cambiado la diestra del altísimo'."
,"12":"Recuerdo las proezas del Señor, recuerdo tus milagros de otros tiempos,"
,"13":"medito en todas tus hazañas, reflexiono en tus prodigios."
,"14":"Oh Dios, tu camino está en la santidad, ¿qué dios tan grande como nuestro Dios?"
,"15":"Tú eres el Dios que hace milagros, y has mostrado a los pueblos tu poder;"
,"16":"con tu brazo rescataste a tu pueblo, a los hijos de Jacob y José."
,"17":"Te vieron las aguas, oh Dios, te vieron las aguas y temblaron, también se estremecieron los abismos;"
,"18":"las nubes dejaron caer su lluvia, los nublados tronaron,y los rayos volaban por uno y otro lado;"
,"19":"tu trueno estalló en el torbellino, alumbraron al mundo tus relámpagos, la tierra se agitaba y retemblaba;"
,"20":"tu camino se abrió a través del mar, tu sendero por las aguas inmensas, y no quedó ni rastro de tus huellas;"
,"21":"guiaste a tu pueblo cual rebaño, por la mano de Moisés y de Aarón."
}`)
	CurrentBook.AddChapter(78, `{
"1":"Maskil de Asaf,Atiende a mi enseñanza, pueblo mío, escucha las palabras de mi boca;"
,"2":"hablaré por medio de sentencias,y evocaré los misterios del pasado."
,"3":"Lo que hemos oído y aprendido, lo que nuestros padres nos contaron,"
,"4":"no se lo ocultaremos a sus hijos; contaremos a la generación futura los títulos de gloria del Señor, su poder y las maravillas que él ha hecho."
,"5":"Él estableció un precepto en Jacob,y promulgó una ley en Israel: ordenó a nuestros padres,que enseñaran las cosas a sus hijos"
,"6":"para que la generación siguiente lo supiera, los hijos que habían de nacer, y que éstos, a su vez, se lo contaran a sus hijos"
,"7":"para que pongan en Dios su confianza, no olviden los prodigios del Señor,y guarden sus mandatos;"
,"8":"no lleguen a ser como sus padres, una generación indócil y rebelde, generación cuyo corazón no fue constante, y cuyo espíritu fue desleal para con Dios."
,"9":"Los hijos de Efraín, diestros arqueros, retrocedieron el día del combate."
,"10":"No guardaron la alianza de Dios, y se negaron a caminar según su ley."
,"11":"Habían olvidado sus prodigios, las maravillas que él les hizo ver."
,"12":"Hizo milagros a la vista de sus padres,en el país de Egipto, en la región de Tanis:"
,"13":"dividió el mar para hacerles pasar, sosteniendo las aguas como con un dique;"
,"14":"de día los guiaba con la nube,y por la noche con resplandor de fuego;"
,"15":"partió las rocas del desierto,y les dio a beber agua a raudales;"
,"16":"hizo brotar arroyos de la peña,y manar las aguas a torrentes."
,"17":"Pero ellos pecaron de nuevo contra él, se rebelaron contra el altísimo en la estepa:"
,"18":"provocaron a Dios en su interior,pidiéndole manjares a su antojo;"
,"19":"hablaron contra él y se dijeron: ¿No será Dios capaz de aderezar una mesa en el desierto?"
,"20":"Él partió la roca, saltaron las aguas y brotaron los torrentes; ¿no podrá también proporcionarle el pan,y procurar carne a su pueblo?"
,"21":"Al oírlo, el Señor se enfureció; un fuego se encendió contra Jacob, la ira se desfogó contra Israel;"
,"22":"porque no se fiaban del Señor,y no creían que él les salvaría."
,"23":"Pero a las nubes mandó desde lo alto,y abrió las compuertas de los cielos:"
,"24":"hizo llover maná para saciarlos, les regaló el trigo de los cielos;"
,"25":"cada uno comió el pan de los fuertes, les mandó comida hasta la saciedad."
,"26":"Hizo soplar de los cielos viento solano, con su poder atrajo el ábrego,"
,"27":"llovió sobre ellos carne como polvo, y aves como la arena de los mares;"
,"28":"cayeron en medio de su campo, por todo el cercado de sus tiendas."
,"29":"Comieron y bebieron hasta hartarse, y así les dio lo que querían;"
,"30":"pero aún no habían saciado su apetito, tenían todavía la comida en la boca,"
,"31":"cuando la cólera de Dios los asaltó, hizo estrago entre los más fuertes,y acabó con lo más selecto de Israel."
,"32":"A pesar de todo, volvieron a pecar,y no dieron crédito a los prodigios del Señor."
,"33":"Él consumió sus días en un soplo, sus años con muerte repentina."
,"34":"Cuando él los mataba, ellos lo buscaban, se arrepentían y volvían hacia él;"
,"35":"recordaban que Dios era su roca, que el Dios altísimo era su defensor."
,"36":"Le halagaban con su boca, pero con su lengua le mentían;"
,"37":"su corazón no estaba firmemente con él,y no eran leales a su alianza."
,"38":"Él, el misericordioso, en vez de destruirlos, perdonaba sus faltas; muchas veces su cólera contuvo,y no dejó correr todo su enojo;"
,"39":"se acordaba de que eran simples hombres, un soplo que se va y que no retorna."
,"40":"¡Cuántas veces en el desierto lo irritaron, lo provocaron en aquellas soledades!"
,"41":"Y de nuevo a tentar a Dios volvían, a irritar al santo de Israel;"
,"42":"no se acordaban de lo que había hecho su mano el día que los rescató de la opresión:"
,"43":"cuando hizo prodigios en Egipto, milagros en la región de Tanis;"
,"44":"cuando cambió en sangre el agua de los ríos,y la de sus arroyos para que no bebieran;"
,"45":"tábanos les mandó que los comieron, y ranas, que los infestaron;"
,"46":"entregó a la langosta sus cosechas, el fruto de sus sudores al pulgón;"
,"47":"arrasó con granizo sus viñedos,y con la helada sus sicómoros;"
,"48":"entregó sus ganados al pedrisco,y sus rebaños a los rayos;"
,"49":"desató sobre ellos el fuego de su cólera, furor, indignación y angustia, tropel de mensajeros de desgracias;"
,"50":"dio rienda suelta a su furor, no quiso preservarlos de la muerte,y abandonó sus vidas a la peste;"
,"51":"hirió de muerte a los primogénitos de Egipto, a las primicias de la virilidad en las tiendas de Cam;"
,"52":"a su pueblo sacó como un rebaño, como ovejas por el desierto los guió;"
,"53":"los condujo con seguridad y sin temor, mientras el mar tragó a sus enemigos;"
,"54":"los llevó a la tierra santa, al monte que su diestra conquistó;"
,"55":"echó a las naciones delante de ellos, les repartió la tierra a suertes, estableció en sus tiendas a las tribus de Israel."
,"56":"Pero ellos provocaron al altísimo, se rebelaron contra él,y no cumplieron sus mandatos:"
,"57":"se extraviaron, apostataron lo mismo que sus padres, se torcieron igual que un arco falso;"
,"58":"le indignaron con sus colinas, con sus ídolos excitaron sus celos."
,"59":"Al oírlo, el Señor se enfureció,y rechazó por completo a su pueblo,"
,"60":"abandonó la morada de Silo, la tienda en que vivía entre los hombres;"
,"61":"entregó su fuerza a la cautividad, su majestad a manos de los opresores;"
,"62":"abandonó a su pueblo a la espada, se enfureció contra su heredad;"
,"63":"un fuego devoró a la gente joven, no hubo canción nupcial para los novios;"
,"64":"sus sacerdotes cayeron a espada,y sus viudas no los lloraron."
,"65":"Se despertó el Señor como de un sueño, cual gigante vencido por el vino;"
,"66":"hirió a sus enemigos en la espalda, les infligió vergüenza eterna."
,"67":"Rechazó la tienda de José,y no quiso elegir a la tribu de Efraín;"
,"68":"escogió a la tribu de Judá, al monte de Sión, al cual amaba."
,"69":"Construyó un santuario tan alto como el cielo,y firme como la tierra que fundó por siempre."
,"70":"Eligió a David, su siervo, lo sacó de los apriscos del rebaño,"
,"71":"lo llamó de detrás de las ovejas,y lo hizo el pastor de Jacob, su pueblo, y de Israel, su heredad."
,"72":"Los apacentó con un corazón irreprochable, los guió con sus expertas manos."
}`)
	CurrentBook.AddChapter(79, `{
"1":"Salmo de Asaf,Oh, Dios, los paganos han invadido tu heredad, han profanado tu sagrado templo, han hecho de Jerusalén un montón de ruinas;"
,"2":"han dado el cadáver de tus siervos,por comida a las aves de los cielos, la carne de tus fieles a las bestias de la tierra."
,"3":"Han vertido su sangre como agua,por todo Jerusalén, y no hay quien los entierre."
,"4":"Nos hemos hecho irrisión de los vecinos, escarnio y burla de cuantos nos rodean."
,"5":"¿Hasta cuándo, Señor, tu ira, que no termina nunca; tu celo, que quema como un fuego?"
,"6":"Derrama tu furor sobre las gentes que te ignoran, sobre los reinos que no invocan tu nombre,"
,"7":"porque ellos devoraron a Jacob y devastaron su morada."
,"8":"No guardes contra nosotros culpas de antepasados, que venga rápida tu piedad sobre nosotros, pues estamos en las últimas."
,"9":"Ayúdanos, oh Dios, salvador nuestro, por la gloria de tu nombre; líbranos, perdona nuestros pecados, por el honor de tu nombre."
,"10":"¿Por qué han de decir las naciones: 'Dónde está su Dios'?; que las naciones aprendan ante nuestros ojos,que hay una venganza por la muerte de tus siervos."
,"11":"Llegue hasta ti el gemido de los prisioneros, con tu potente brazo libera a los condenados a muerte;"
,"12":"clava a nuestros vecinos siete veces en pleno corazón,el ultraje que te han hecho a ti, Señor."
,"13":"Y nosotros, tu pueblo, ovejas de tu grey, te estaremos eternamente agradecidos, de edad en edad pregonaremos tu alabanza."
}`)
	CurrentBook.AddChapter(80, `{
"1":"Al maestro de coro. Según 'Lirios son los preceptos'. Salmo de Asaf"
,"2":"Pastor de Israel, escucha, tú que guías a José como un rebaño; tú que te sientas sobre los querubines, resplandece"
,"3":"ante Efraín, Benjamín y Manasés; despierta tu poder y ven a socorrernos."
,"4":"Oh Dios, haz que seamos lo que fuimos, haz que brille tu rostro y seremos liberados."
,"5":"¿Hasta cuándo, Señor, Dios todopoderoso, te indignarás contra las oraciones de tu pueblo?"
,"6":"Les has dado a comer un pan de lágrimas, y a beber lágrimas sin cuento;"
,"7":"nos has hecho el chismorreo de los vecinos, nuestros enemigos se burlan de nosotros."
,"8":"Oh Dios, haz que seamos lo que fuimos, haz que brille tu rostro y seremos liberados."
,"9":"Arrancaste una viña de Egipto, y para trasplantarla echaste a las naciones;"
,"10":"le preparaste el suelo, echó raíces y llenó el país;"
,"11":"su sombra cubría las montañas,y sus pámpanos los cedros excelsos;"
,"12":"extendía sus sarmientos hasta el mar,y sus vástagos hasta el río."
,"13":"¿Por qué has abierto brechas en su valla,para que todo el que pase la vendimie,"
,"14":"el jabalí salvaje la devaste,y las bestias del campo la devoren?"
,"15":"Oh Dios omnipotente, vuelve ya, asómate desde el cielo y fíjate, ven a ver esta viña,"
,"16":"la viña que tu diestra plantó, el retoño que tú mismo hiciste fuerte."
,"17":"Que los que la talaron,y quemaron perezcan ante la amenaza de tu rostro."
,"18":"Pon tu mano sobre el hombre de tu diestra, sobre el hijo del hombre que tú has fortalecido,"
,"19":"y jamás volveremos a apartarnos de ti; consérvanos la vida e invocaremos tu nombre."
,"20":"Oh Dios, haz que seamos lo que fuimos, haz que brille tu rostro y seremos liberados."
}`)
	CurrentBook.AddChapter(81, `{
"1":"Al maestro de coro. Según 'la de Gat'. De Asaf"
,"2":"Aclamad al Señor, nuestra fortaleza, dad gritos de alegría ante el Dios de Jacob;"
,"3":"entonad un cántico, tocad el tamboril, la dulce cítara junto con la lira;"
,"4":"tocad la trompeta en el mes nuevo, en la luna llena, el día de nuestra fiesta."
,"5":"Ésta es una ley para Israel, un precepto del Dios de Jacob;"
,"6":"una norma que él impuso a José,cuando salió contra el país de Egipto. Oigo una lengua que no entiendo:"
,"7":"'Yo liberé sus hombros de la carga, sus manos se libraron de la espuerta."
,"8":"Gritaste en la opresión y te salvé, te respondí oculto entre los truenos, en las aguas de Meribá te puse a prueba'."
,"9":"Escucha, pueblo mío, mi advertencia; Israel, si quisieras escucharme,"
,"10":"no habría en tu casa un dios extraño, no adorarías a ningún dios extranjero."
,"11":"Yo, el Señor, soy tu Dios, que te saqué de Egipto; abre bien tu boca y yo la llenaré."
,"12":"Pero mi pueblo no escuchó mi voz, Israel no quiso saber nada de mí,"
,"13":"y yo los abandoné a su corazón endurecido,para que vivieran a su antojo."
,"14":"¡Ah!, si mi pueblo me escuchara, si Israel siguiera mis caminos,"
,"15":"en un instante humillaría a sus enemigos, volvería mi mano contra los opresores;"
,"16":"los que odian al Señor se arrastrarían ante él, éste sería su destino eterno;"
,"17":"a él lo sustentaría con la flor del trigo, lo saciaría con la miel de la roca."
}`)
	CurrentBook.AddChapter(82, `{
"1":"Salmo de Asaf,Dios se levanta en la asamblea divina, juzga en medio de los dioses."
,"2":"'¿Hasta cuándo juzgaréis injustamente, os pondréis de parte de los criminales?"
,"3":"Defended al huérfano y al pobre, haced justicia al desvalido y al humilde;"
,"4":"librad al oprimido, al indigente, sacadlos de las manos de los criminales'."
,"5":"Pero ellos no saben ni comprenden, caminan en tinieblas, vacilan todos los cimientos de la tierra."
,"6":"Yo dije: 'Sois dioses,todos vosotros, hijos del altísimo;"
,"7":"pero moriréis como todos los hombres, caeréis como un príncipe cualquiera'."
,"8":"Levántate, oh Dios, haz justicia en la tierra, pues tú imperas sobre todas las naciones."
}`)
	CurrentBook.AddChapter(83, `{
"1":"Cántico. Salmo de Asaf"
,"2":"Oh Dios, sal de tu silencio, no te quedes inmóvil y callado;"
,"3":"mira cómo tus enemigos se alborotan,y tus adversarios levantan la cabeza;"
,"4":"traman un complot contra tu pueblo, conspiran contra tus protegidos."
,"5":"Dicen: 'Venid, borrémoslos de las naciones, que no se vuelva a mencionar el nombre de Israel'."
,"6":"Como un solo hombre todos han conspirado,y se han aliado contra ti:"
,"7":"las gentes de Edón, los ismaelitas, Moab y los hijos de Agar,"
,"8":"Gebal, Ammón, Amalec, Filistea y los habitantes de Tiro;"
,"9":"hasta los asirios se han unido con ellos,y son el brazo fuerte de los hijos de Lot."
,"10":"Trátalos como a Madián y como a Sísara, como a Yabín en el torrente Quisón,"
,"11":"que fueron aniquilados en Endor, y pararon en estiércol de la tierra."
,"12":"Trata a sus jefes como a Oreb y Zeb, y a todos sus caudillos como a Zebá y Salmaná."
,"13":"Ellos habían dicho: 'Adueñémonos de los campos de Dios'."
,"14":"Oh Dios mío, hazlos polvo en remolino, como la paja al viento;"
,"15":"como el fuego que devora la selva, como la llama que abrasa las montañas,"
,"16":"persíguelos así con tu tormenta, llénalos de terror con tu huracán."
,"17":"Cubre sus rostros de vergüenza para que busquen, oh Señor, tu rostro;"
,"18":"queden avergonzados y aterrados para siempre,y perezcan con un final ignominioso,"
,"19":"para que sepan que tú eres el Señor, tú solo, el altísimo sobre toda la tierra."
}`)
	CurrentBook.AddChapter(84, `{
"1":"Al maestro de coro. Según 'la de Gat'. Salmo de los hijos de Coré"
,"2":"¡Qué hermosa es tu morada, Señor omnipotente!"
,"3":"Mi alma suspira y desfallece,por los atrios del Señor, mi corazón y mi carne se entusiasman,en busca del Dios vivo."
,"4":"Hasta el gorrión ha encontrado una casa,y la golondrina un nido donde poner sus polluelos: tus altares, Señor omnipotente, rey mío y Dios mío."
,"5":"Dichosos los que viven en tu casa,y están siempre alabándote;"
,"6":"dichoso el hombre que tiene en ti su fortaleza,y lleva en su corazón tus caminos."
,"7":"Al pasar por el valle de las balsameras, lo convertirán en manantiales, y las lluvias otoñales,lo llenarán de bendiciones."
,"8":"Marcharán con ánimo creciente, verán al Dios de los dioses en Sión."
,"9":"Señor, Dios omnipotente, escucha mi plegaria; atiéndeme, oh Dios de Jacob;"
,"10":"oh Dios, contempla nuestro escudo, fíjate en el rostro de tu ungido."
,"11":"Un día en tus atrios vale más que mil: prefiero estar en el umbral de la casa de mi Dios,a vivir en la casa del malvado."
,"12":"Dios, el Señor, es un sol y un escudo, el Señor da la gracia y la gloria; no niega bien alguno al que procede rectamente."
,"13":"Señor omnipotente, dichoso el hombre que confía en ti."
}`)
	CurrentBook.AddChapter(85, `{
"1":"Al maestro de coro. Salmo de los hijos de Coré"
,"2":"Señor, tú has sido muy bueno con tu tierra, has hecho volver a los cautivos de Jacob,"
,"3":"has perdonado las maldades de tu pueblo,y has cancelado sus delitos,"
,"4":"has puesto fin a tu furor,y has desistido de tu ardiente ira."
,"5":"Restáuranos, oh Dios, salvador nuestro, retira tu indignación contra nosotros."
,"6":"¿Vas a estar siempre irritado con nosotros?, ¿vas a alargar tu ira por todas las edades?;"
,"7":"¿no vas a devolvernos la vida,para que tu pueblo se regocije en ti?"
,"8":"Muéstranos, Señor, tu misericordia,y danos tu salvación."
,"9":"Voy a escuchar lo que Dios dice: 'El Señor anuncia la paz para su pueblo,y sus amigos, con tal que a su locura no retornen'."
,"10":"Su salvación está cerca de sus fieles, su gloria va a habitar en nuestra tierra;"
,"11":"el amor y la lealtad se darán cita, la justicia y la paz se abrazarán;"
,"12":"la tierra producirá lealtad,y la justicia mirará desde los cielos."
,"13":"El mismo Señor traerá la lluvia,y nuestra tierra dará sus cosechas."
,"14":"La justicia marchará delante de él, irá preparándole el camino."
}`)
	CurrentBook.AddChapter(86, `{
"1":"Oración de David,Escúchame, Señor, atiéndeme, pues soy pobre y desdichado;"
,"2":"guarda mi vida, pues soy tu amigo; tú eres mi Dios, salva a este siervo tuyo,que en ti espera;"
,"3":"ten piedad de mí, Señor, pues te estoy llamando a todas horas;"
,"4":"alegra el corazón de este siervo tuyo, pues hacia ti, Señor, levanto mi alma."
,"5":"Señor, tú que eres bueno y que perdonas, lleno de piedad para los que te invocan,"
,"6":"escucha mi plegaria, Señor, atiende a la voz de mi súplica;"
,"7":"en el día de mi angustia yo te llamo,porque tú siempre me escuchas."
,"8":"Entre los dioses, Señor, no hay nadie como tú,ni hay obras semejantes a las tuyas."
,"9":"Todas las naciones que tú hiciste vendrán a ti, Señor, para adorarte y glorificar tu nombre."
,"10":"Tú eres grande y haces maravillas, pues tú eres el único Dios."
,"11":"Enséñame tus caminos, Señor, para que yo camine en la verdad; haz que mi corazón reverencie tu nombre."
,"12":"Te alabaré de todo corazón, Señor, Dios mío, ensalzaré tu nombre eternamente,"
,"13":"pues tu misericordia conmigo fue muy grande, me has librado del fondo del abismo."
,"14":"Oh Dios, unos arrogantes se alzan contra mí, una banda de violentos quiere acabar conmigo, y tú les tienes sin cuidado."
,"15":"Mas tú, Señor, misericordioso y compasivo, paciente y lleno de amor y de lealtad,"
,"16":"ven conmigo, ten compasión de mí; da tu fuerza a este tu siervo, salva al hijo de tu sierva,"
,"17":"dame una prueba de tu amor, para que mis enemigos lo vean y se avergüencen, pues tú, Señor, me ayudas y consuelas."
}`)
	CurrentBook.AddChapter(87, `{
"1":"Salmo de los hijos de Coré. Cántico,El Señor fundó a Sión sobre los montes santos,"
,"2":"el Señor ama las puertas de Sión,más que todas las moradas de Jacob."
,"3":"¡Qué cosas tan hermosas se pregonan de ti, ciudad de Dios!"
,"4":"Entre los que me conocen citaré a Egipto y Babilonia, Filistea, Tiro y Etiopía: allí nacieron todos."
,"5":"Se dirá de Sión: 'Uno a uno, todos han nacido en ella, y el mismo altísimo es el que la sostiene'."
,"6":"El Señor escribirá en el registro de los pueblos: 'Éste ha nacido allí'."
,"7":"Y los que bailan cantan a coro: 'En ti están todas mis fuentes'."
}`)
	CurrentBook.AddChapter(88, `{
"1":"Cántico. Salmo de los hijos de Coré. Del maestro de coro. Para la enfermedad. Para cantar. Maskil de Hemán, el ezrajita."
,"2":"Señor, Dios, salvador mío, día y noche te estoy llamando a gritos;"
,"3":"escucha mi plegaria, atiende a mi gemido,"
,"4":"pues mi vida está llena de desgracias,y estoy al borde del abismo;"
,"5":"ya me cuentan entre los moribundos, soy un hombre acabado;"
,"6":"me han recluido entre los muertos, como los que cayeron y yacen en la tumba, de los que no te acuerdas más, que están dejados de tu mano."
,"7":"Me has puesto en lo más hondo de la fosa, en la profundidad y en las tinieblas del abismo;"
,"8":"has descargado tu ira contra mí, me has hundido bajo el peso de tus olas;"
,"9":"has alejado de mí a mis compañeros, has hecho que al verme se horroricen de mí: me encuentro encerrado y sin salida,"
,"10":"tengo los ojos consumidos de aflicción. Te estoy llamando, Señor, constantemente, con las manos alzadas hacia ti."
,"11":"¿Harás, acaso, milagros por los muertos, se levantarán las sombras para alabarte?,"
,"12":"¿se hablará en la tumba de tu misericordia,y en el abismo de tu fidelidad?,"
,"13":"¿se conocerán en las tinieblas tus milagros,y en el país del olvido tu justicia?"
,"14":"Pero yo, Señor, te pido a gritos que me ayudes, por la mañana te estoy ya suplicando:"
,"15":"¿por qué me rechazas, Señor, y me ocultas tu rostro?"
,"16":"Desde mi infancia soy un desgraciado, al borde de la muerte; he soportado tus terrores y ya no puedo más."
,"17":"Tus iras han pasado sobre mí,y tus espantos me han aniquilado;"
,"18":"me envuelven como las aguas sin cesar, se aprietan contra mí todos a una."
,"19":"Alejaste de mí a mis amigos y compañeros, ahora mi compañía es sólo la tiniebla."
}`)
	CurrentBook.AddChapter(89, `{
"1":"Maskil de Etán, el ezrajita"
,"2":"Cantaré eternamente la misericordia del Señor, publicaré tu lealtad por todas las edades,"
,"3":"porque tú has dicho: 'Mi piedad es eterna, mi lealtad está cimentada en el mismo cielo'."
,"4":"He hecho un pacto con mi elegido,y he jurado a mi siervo David:"
,"5":"'Afirmaré tu dinastía para siempre, asentaré tu trono por los siglos de los siglos'."
,"6":"Los cielos, Señor, cantan tus maravillas, y tu lealtad en la asamblea de los santos."
,"7":"Porque, ¿quién en las nubes es igual al Señor, quién es como el Señor entre los dioses?"
,"8":"Dios es temible en el consejo de los santos, grande y terrible para todo su cortejo."
,"9":"Señor omnipotente, ¿quién hay como tú?; tu poder, Señor, es tu lealtad."
,"10":"Tú dominas el mar embravecido, tú aplacas sus olas encrespadas;"
,"11":"tú atravesaste y destrozaste el cadáver de Rahab, dispersaste a tus enemigos con tu potente brazo."
,"12":"Tuyo es el cielo, tuya también la tierra, tú formaste el mundo y todo lo que contiene;"
,"13":"tú creaste el norte y el sur, el Tabor,y el Hermón se recrean en tu nombre."
,"14":"Tu brazo está lleno de poder, fuerte es tu mano, sublime tu derecha."
,"15":"La justicia y el derecho son las bases de tu trono, el amor y la lealtad son tus heraldos."
,"16":"Dichoso el pueblo que sabe aclamarte y caminar, Señor, a la luz de tu presencia;"
,"17":"que se regocija en tu nombre sin cesar,y se enorgullece de tu justicia."
,"18":"Pues tú eres el esplendor de su poder, por tu favor se agranda nuestra fuerza."
,"19":"El mismo Señor es nuestro escudo, el santo de Israel es nuestro rey."
,"20":"Antaño apareciste y hablaste así a tus fieles: 'He prestado mi ayuda a un valiente, he exaltado a un elegido de mi pueblo;"
,"21":"he encontrado a mi siervo David, y lo he consagrado con el óleo santo;"
,"22":"mi mano estará siempre con él,y mi brazo lo hará poderoso;"
,"23":"no le podrá sorprender el enemigo, y el rebelde no podrá derribarlo;"
,"24":"delante de él aplastaré a sus opresores, destrozaré a todos los que lo aborrecen."
,"25":"Mi amor y mi lealtad siempre estarán con él, en mi nombre aumentará su fuerza;"
,"26":"extenderé su mano hasta el Mediterráneo,y su derecha hasta el Éufrates."
,"27":"Él me llamará: 'Padre mío, Dios mío, mi roca salvadora';"
,"28":"yo haré de él mi primogénito, el más excelso de los reyes de la tierra."
,"29":"Yo le seré leal eternamente, firme será con él mi pacto;"
,"30":"afirmaré su dinastía para siempre,y su trono durará como los cielos."
,"31":"Si sus hijos abandonan mi ley,y no practican mi derecho,"
,"32":"si quebrantan mis mandamientos,y no guardan mis preceptos,"
,"33":"castigaré sus transgresiones con la vara,y con el látigo sus iniquidades;"
,"34":"pero yo no dejaré de amarlo,ni faltaré nunca a mi lealtad;"
,"35":"no violaré jamás mi pacto,ni faltaré a la palabra dada."
,"36":"Una vez por todas juré por mi santidad: 'nunca jamás engañaré a David;"
,"37":"su dinastía durará por siempre,y su trono durará tanto como el sol,"
,"38":"como la luna que subsiste eternamente, fiel testigo en el cielo'."
,"39":"Y, sin embargo, has rechazado,y desechado a tu ungido,y te has enfurecido contra él;"
,"40":"has roto el pacto con tu siervo, has echado por tierra y profanado su diadema;"
,"41":"has derribado todas sus murallas, has desmantelado todas sus fortalezas;"
,"42":"lo han saqueado todos los viandantes, y es el hazmerreír de sus vecinos;"
,"43":"has acrecentado el poder de su enemigo, has llenado de alegría a sus adversarios;"
,"44":"has embotado el filo de su espada,y no lo has apoyado en el combate;"
,"45":"has puesto fin a su esplendor,y has tirado su trono por los suelos;"
,"46":"has acortado los días de su juventud, lo has cubierto de vergüenza."
,"47":"¿Hasta cuándo, Señor?,¿Te ocultarás por siempre?, ¿arderá siempre tu ira como el fuego?"
,"48":"Acuérdate de que mi vida es breve, de que los hombres que creaste duran muy poco tiempo."
,"49":"¿Quién podrá vivir sin ver la muerte?, ¿quién librará su vida de las garras del abismo?"
,"50":"¿Dónde están, Señor, tus primeros amores, los que juraste a David en tu lealtad?"
,"51":"Piensa, Señor, en los ultrajes de tus siervos, esos ultrajes de las gentes que yo llevo en mi pecho."
,"52":"Tus enemigos, Señor, lo han ultrajado escupiendo,sobre los pasos de tu ungido."
,"53":"Bendito sea el Señor por siempre. Amén. Amén."
}`)
	CurrentBook.AddChapter(90, `{
"1":"Oración de Moisés, hombre de Dios,Tú has sido, Señor, nuestro refugio,por todas las edades."
,"2":"Antes que surgieran las montañas, antes que la tierra y el mundo se engendraran, desde siempre y por siempre tú eres Dios."
,"3":"Tú haces volver al polvo a los mortales, pues tú has dicho: 'Volved, hijos de Adán'."
,"4":"Mil años para ti son como el ayer que a pasó, como un turno de la vigilia de la noche."
,"5":"Los arrebatas como un sueño mañanero, son semejantes a la hierba que brota:"
,"6":"sale y florece a la mañana, y a la tarde se marchita y se seca."
,"7":"Estamos consumidos por tu ira, consternados por tu indignación."
,"8":"Has puesto nuestras faltas ante ti, nuestras culpas secretas a la luz de tu rostro,"
,"9":"bajo tu ira desaparecen nuestros días, nuestros años se acaban lo mismo que un suspiro."
,"10":"La duración de nuestra vida es de setenta años, la de los más fuertes, ochenta, pero en su mayor parte no son más que trabajos y miseria, pues pasan aprisa y nosotros volamos."
,"11":"¿Quién puede conocer la fuerza de tu ira, quién teme la violencia de tu enojo?"
,"12":"Enséñanos a contar nuestros días,para que adquiramos un corazón sabio."
,"13":"Vuelve con nosotros, Señor. ¿Hasta cuándo? Ten piedad de tus siervos."
,"14":"Llénanos de tu amor por la mañana,para que vivamos alegres,y contentos todos nuestros días,"
,"15":"convierte en alegría los días en que nos castigaste, los años en que padecimos las desgracias,"
,"16":"manifiesta tus obras a tus siervos,y tu esplendor a sus hijos."
,"17":"La bondad del Señor, nuestro Dios, esté con nosotros. Haz prosperar la acción de nuestras manos; sí, haz prosperar la acción de nuestras manos."
}`)
	CurrentBook.AddChapter(91, `{
"1":"Tú que vives bajo la protección del Dios altísimo,y moras a la sombra del Dios omnipotente,"
,"2":"di al Señor: 'Eres mi fortaleza y mi refugio, eres mi Dios, en quien confío'."
,"3":"Pues él te librará de la red del cazador, de la peste mortal;"
,"4":"te cobijará bajo sus alas,y tú te refugiarás bajo sus plumas; su lealtad será para ti escudo y armadura."
,"5":"No temerás el terror de la noche,ni la flecha que vuela por el día,"
,"6":"ni la peste que avanza en las tinieblas,ni el azote que asola al mediodía."
,"7":"Aunque a tu lado caigan mil, y diez mil a tu diestra, a ti no te alcanzarán."
,"8":"Te bastará abrir los ojos, y verás que los malvados reciben su merecido,"
,"9":"ya que has puesto tu refugio en el Señor,y tu cobijo en el altísimo."
,"10":"A ti no te alcanzará la desgracia,ni la plaga llegará a tu tienda,"
,"11":"pues él ordenó a sus santos ángeles,que te guardaran en todos tus caminos;"
,"12":"te llevarán en sus brazos,para que tu pie no tropiece en piedra alguna;"
,"13":"andarás sobre el león y la serpiente, pisarás al tigre y al dragón."
,"14":"Porque él se ha unido a mí, yo lo liberaré; lo protegeré, pues conoce mi nombre;"
,"15":"si me llama, yo le responderé, estaré con él en la desgracia, lo libraré y lo llenaré de honores;"
,"16":"le daré una larga vida, le haré gozar de mi salvación."
}`)
	CurrentBook.AddChapter(92, `{
"1":"Salmo. Cántico para el sábado"
,"2":"Es bueno dar gracias al Señor,y cantar a tu nombre, oh Dios altísimo;"
,"3":"publicar tu amor por la mañana,y tu lealtad a lo largo de la noche,"
,"4":"con el laúd y con el arpa,y al son de la cítara,"
,"5":"porque tú me alegras, Señor, con tus acciones, y ante la obra de tus manos yo grito de alegría."
,"6":"¡Qué grandes son tus obras, Señor; qué insondables tus designios!"
,"7":"Esto no lo entiende el hombre estúpido, y el insensato no comprende nada."
,"8":"Aunque broten como la hierba los malvados,y florezcan los obradores de injusticia, serán destruidos para siempre."
,"9":"Pero tú, allá en lo alto, eres el Señor eternamente."
,"10":"Todos tus enemigos serán destruidos, y los obradores de injusticia serán exterminados."
,"11":"Tú aumentas mi fuerza como la del toro,y me unges con aceite nuevo."
,"12":"Mis ojos observan a los que me espían,y mi oído oye a los malvados que se alzan contra mí."
,"13":"El justo florecerá como palmera, crecerá como cedro del Líbano;"
,"14":"plantado en la casa del Señor, florecerá en los atrios de nuestro Dios."
,"15":"En la vejez aún llevarán fruto, se mantendrán lozanos y floridos,"
,"16":"proclamando que el Señor es justo, mi roca; en él no hay nada de injusticia."
}`)
	CurrentBook.AddChapter(93, `{
"1":"El Señor es rey de majestad vestido: el Señor se ha vestido, se ha ceñido de poder. Tú afirmaste el mundo y no se moverá;"
,"2":"desde el principio tu trono está bien firme, desde siempre existes tú."
,"3":"Los ríos levantan, Señor, los ríos levantan su clamor, los ríos levantan su fragor."
,"4":"Más que el bramido de grandes oleadas, más potente que las olas del mar, es potente el Señor en sus alturas."
,"5":"Tus órdenes son firmes, oh Señor, la santidad es el patrimonio eterno de tu casa."
}`)
	CurrentBook.AddChapter(94, `{
"1":"Oh Señor, Dios justiciero, manifiéstate, Dios justiciero."
,"2":"Levántate, juez de la tierra, dales su merecido a los soberbios."
,"3":"¿Hasta cuándo, Señor, los criminales, hasta cuándo van a triunfar los criminales?"
,"4":"Estos delincuentes son unos arrogantes, unos insolentes y unos fanfarrones;"
,"5":"aplastan, Señor, a tu pueblo,y oprimen a tu heredad;"
,"6":"degüellan a la viuda y al inmigrante,y asesinan a los huérfanos."
,"7":"Y dicen: 'El Señor no ve nada, el Dios de Jacob no se da cuenta'."
,"8":"Gente estúpida entre todos, enteraos; insensatos, ¿cuándo vais a ser cuerdos?"
,"9":"El que plantó la oreja, ¿no va a oír?; el que formó los ojos, ¿no va a ver?;"
,"10":"el que acusa a los pueblos, ¿no va a castigar?; el que enseña al hombre, ¿no va a saber?"
,"11":"El Señor conoce los planes de los hombres, que son vanidad pura."
,"12":"Dichoso el hombre al que tú corriges, Señor, al que instruyes en tu ley,"
,"13":"para que esté tranquilo,en los días de infortunio,mientras se cava una fosa para los criminales."
,"14":"Pues el Señor no dejará a su pueblo,ni abandonará a su heredad;"
,"15":"en los juicios se hará justicia,y todos los corazones rectos estarán conformes."
,"16":"¿Quién defenderá mi causa contra los criminales, quién estará de mi parte contra los delincuentes?"
,"17":"Si el Señor no me hubiera ayudado, el silencio sería bien pronto mi morada."
,"18":"Cuando yo decía: 'Me voy a caer', tu amor, Señor, venía a sostenerme;"
,"19":"cuando me embargan mil preocupaciones, tú me llenas de serenidad y de consuelo."
,"20":"¿Podrá ser tu cómplice un tribunal injusto,que comete injusticias al amparo de la ley?"
,"21":"Ellos se ensañan en la vida del justo,y condenan a muerte al inocente;"
,"22":"pero el Señor es para mí la fortaleza, mi Dios es la roca donde yo me refugio."
,"23":"Él hará recaer su crimen sobre ellos, los aniquilará por su propia crueldad, los aniquilará el Señor, nuestro Dios."
}`)
	CurrentBook.AddChapter(95, `{
"1":"Venid, cantemos jubilosos al Señor, aclamemos a la roca que nos salva;"
,"2":"vayamos ante él a darle gracias,y a cantar himnos en su honor."
,"3":"Porque el Señor es el Dios grande, el rey grande sobre todos los dioses."
,"4":"Tiene en sus manos las profundidades de la tierra,y suyas son las cumbres de los montes;"
,"5":"suyo es el mar, pues él mismo lo hizo, y la tierra firme, que formaron sus manos."
,"6":"Venid a adorarlo, hinquemos las rodillas,delante del Señor, nuestro creador."
,"7":"Porque él es nuestro Dios y nosotros su pueblo, las ovejas que él guarda. Escuchad lo que dice:"
,"8":"'No endurezcáis vuestro corazón como en Meribá, como el día de Masá en el desierto,"
,"9":"cuando vuestros padres me desafiaron,y me pusieron a prueba,aunque habían visto mis obras'."
,"10":"Durante cuarenta años aquella generación me asqueó, y dije: 'Son un pueblo de corazón rebelde, no han entendido mis caminos'."
,"11":"Entonces juré en mi cólera: 'No entrarán jamás en mi descanso'."
}`)
	CurrentBook.AddChapter(96, `{
"1":"Cantad al Señor un cántico nuevo, cantad al Señor toda la tierra;"
,"2":"cantad al Señor, bendecid su nombre, proclamad día tras día su salvación;"
,"3":"publicad su gloria entre las gentes, sus portentos entre todos los pueblos."
,"4":"Grande es el Señor y digno de alabanza, más temible que todos los dioses."
,"5":"Pues los dioses de los otros pueblos no son nada, mientras que el Señor hizo los cielos;"
,"6":"su presencia está llena de esplendor y majestad, y su santuario, de potencia y hermosura."
,"7":"Familias de los pueblos, rendid ante el Señor, rendid ante el Señor la gloria y el poder,"
,"8":"rendid ante el Señor la gloria de su nombre, presentad vuestra ofrenda y entrad en sus atrios;"
,"9":"adorad al Señor con ornamentos santos, temblad delante de él, oh tierra toda."
,"10":"Decid por las naciones: 'El Señor es rey, él afirmó el mundo, y no se moverá; él juzga a los pueblos con justicia'."
,"11":"Que se alegre el cielo y goce la tierra, que retumbe el mar y todo lo que encierra,"
,"12":"que sonrían los campos con sus frutos, que griten de alegría los árboles del bosque"
,"13":"delante del Señor, porque ya viene, porque viene para gobernar la tierra, para implantar en el mundo la justicia, y entre todos los pueblos la lealtad."
}`)
	CurrentBook.AddChapter(97, `{
"1":"El Señor es rey; que se alegre la tierra,y exulten las islas incontables."
,"2":"Está rodeado de nubes y tinieblas, la justicia y el derecho son las bases de su trono."
,"3":"Delante de él avanza un fuego,que abrasa en derredor a todos sus enemigos;"
,"4":"sus relámpagos iluminan el mundo, lo ve la tierra y se estremece;"
,"5":"los montes se derriten como la cera delante del Señor, delante del Señor de todo el mundo."
,"6":"Los cielos proclaman su justicia,y todos los pueblos ven su gloria."
,"7":"Que se avergüencen los que adoran a los ídolos, los que se glorían de vanidades. Que todas las divinidades se postren ante él."
,"8":"Sión lo oye y se alegra, los pueblos de Judá se regocijan,por tus actuaciones liberadoras, Señor,"
,"9":"porque tú eres, Señor, el altísimo sobre toda la tierra, el que domina sobre todos los dioses."
,"10":"Los que amáis al Señor, detestad la injusticia; él guarda la vida de sus fieles, los libra de la mano de los opresores."
,"11":"La luz sale para los que practican la justicia,y la alegría para los corazones rectos."
,"12":"Los que practicáis la justicia, alegraos en el Señor,y bendecid su santa memoria."
}`)
	CurrentBook.AddChapter(98, `{
"1":"Salmo,Cantad al Señor un cántico nuevo, porque ha hecho maravillas; su diestra, su santo brazo, le alcanzó la victoria;"
,"2":"el Señor ha dado a conocer su victoria, ha revelado a las naciones su justicia;"
,"3":"se acordó de su amor y su lealtad,para con la casa de Israel; todos los confines de la tierra han contemplado,la victoria de nuestro Dios."
,"4":"Aclamad al Señor toda la tierra, alegraos, regocijaos, cantad,"
,"5":"cantad al Señor al son del arpa, al son del arpa y del salterio;"
,"6":"al son de los clarines y trompetas,aclamad al rey, el Señor."
,"7":"Retumbe el mar y todo lo que encierra, el mundo y todos sus habitantes;"
,"8":"que todos los ríos batan palmas,y con ellos las montañas griten de alegría"
,"9":"delante del Señor, porque ya viene,para gobernar la tierra, para implantar en el mundo la justicia,y entre todos los pueblos la lealtad."
}`)
	CurrentBook.AddChapter(99, `{
"1":"El Señor es rey, tiemblen las naciones; se sienta sobre querubines, vacile la tierra."
,"2":"El Señor es grande en Sión, domina sobre todos los pueblos."
,"3":"Alabado sea su nombre grande y terrible, Dios es santo."
,"4":"La fuerza de un rey está en amar la justicia: tú has fundado el derecho; tú ejerces en Jacob la justicia y el derecho."
,"5":"Alabad al Señor, nuestro Dios, hincaos de rodillas ante el estrado de sus pies. Dios es santo."
,"6":"Moisés y Aarón, entre sus sacerdotes, y Samuel entre los que invocaban su nombre; llamaban al Señor y él les respondía."
,"7":"Les hablaba en la columna de nube, guardaban sus preceptos,y las leyes que les había dado."
,"8":"Señor, Dios nuestro, tú los escuchabas, tú eras para ellos un Dios paciente, aunque castigabas sus delitos."
,"9":"Alabad al Señor, nuestro Dios, hincaos de rodillas ante su monte santo. El Señor, nuestro Dios, es santo."
}`)
	CurrentBook.AddChapter(100, `{
"1":"Salmo de acción de gracias,Aclamad al Señor toda la tierra,"
,"2":"servid al Señor con alegría, entrad en su presencia con gritos jubilosos."
,"3":"Reconoced que el Señor es Dios: él nos ha hecho y somos suyos, su pueblo, las ovejas que él guarda."
,"4":"Entrad en sus pórticos dándole gracias, alabadlo, bendecid su nombre:"
,"5":"porque el Señor es bueno, su amor es eterno, y su lealtad perpetua por todas las edades."
}`)
	CurrentBook.AddChapter(101, `{
"1":"Salmo de David,Voy a cantar al amor y a la justicia, voy a tocar, Señor, en honor tuyo;"
,"2":"seguiré los caminos de la justicia; ¿cuándo vendrás a mí?,En mi casa me sabré conducir con un corazón recto."
,"3":"Jamás he de proponerme ninguna cosa injusta. Detesto a los apóstatas, no quiero saber nada de ellos;"
,"4":"lejos de mí el corazón torcido, al malvado no quiero conocerlo;"
,"5":"al que difama a su prójimo en secreto lo aniquilo; al soberbio y al ambicioso no los puedo soportar;"
,"6":"escogeré a los leales del país para que vivan a mi lado; el de conducta intachable será mi servidor;"
,"7":"el estafador no se sentará nunca en mi casa, el calumniador no estará jamás en mi presencia;"
,"8":"cada mañana reduciré al silencio,a todos los bandidos del país, extirparé de la ciudad del Señor,a todos los criminales."
}`)
	CurrentBook.AddChapter(102, `{
"1":"Oración de un afligido que, en su congoja, derrama su llanto ante el Señor"
,"2":"Señor, escucha mi plegaria, llegue hasta ti mi grito;"
,"3":"no me ocultes tu rostro el día de mi angustia, atiéndeme el día que te llamo, respóndeme enseguida."
,"4":"Pues mis días se disipan como el humo, y mis huesos queman como brasas;"
,"5":"mi corazón se seca como hierba segada, y no me acuerdo de comer ni pan;"
,"6":"a fuerza de gemir sólo tengo la piel pegada al hueso."
,"7":"Soy como el búho del desierto, como la lechuza entre ruinas;"
,"8":"no duermo nada, soy como el pájaro solitario en el tejado."
,"9":"Mis enemigos me ultrajan sin cesar, me maldicen enfurecidos contra mí."
,"10":"En vez de pan como ceniza, y mezclo mi bebida con mis lágrimas."
,"11":"Por tu indignación y tu furor,me has levantado y me has tirado lejos;"
,"12":"mis días son como la sombra que declina, y me voy secando como el heno."
,"13":"Mas tú, Señor, reinas por siempre, tu memoria permanece por todas las edades."
,"14":"Levántate y ten misericordia de Sión, pues ya es hora de que tengas piedad, sí, ya ha llegado la hora."
,"15":"Porque tus siervos aman sus piedras,y sienten dolor por sus ruinas."
,"16":"Las naciones respetarán el nombre del Señor,y los reyes de la tierra tu gloria,"
,"17":"cuando el Señor reconstruya a Sión,y aparezca en su gloria,"
,"18":"cuando atienda la oración del expoliado, y no rechace sus ruegos."
,"19":"Que esto quede escrito para la edad futura, y los que luego nazcan alaben al Señor."
,"20":"El Señor se asomó desde su excelso santuario, miró desde los cielos a la tierra,"
,"21":"para escuchar el gemido de los encarcelados,y libertar a los condenados a muerte;"
,"22":"para que se pregone en Sión el nombre del Señor,y su alabanza en Jerusalén;"
,"23":"cuando se congreguen a una los pueblos,y los reyes para dar culto al Señor."
,"24":"En pleno camino ha agotado mis fuerzas, ha acortado mis días;"
,"25":"dije: 'Dios mío, no me lleves en la mitad de mi vida, pues tus años duran la eternidad'."
,"26":"Tú pusiste al principio los cimientos de la tierra, y los cielos son la obra de tus manos;"
,"27":"ellos perecerán, pero tú quedarás, todos se desgastarán como la ropa, serán como la muda que se cambia."
,"28":"Mas tú eres siempre el mismo,y tus años no terminan nunca."
,"29":"Los hijos de tus siervos tendrán una morada,y su descendencia será estable ante ti."
}`)
	CurrentBook.AddChapter(103, `{
"1":"De David,Bendice, alma mía, al Señor, y todo mi ser su santo nombre;"
,"2":"bendice, alma mía, al Señor, y no olvides sus muchos beneficios."
,"3":"Él te perdona todos tus delitos,y te cura de tus enfermedades;"
,"4":"él rescata tu vida del sepulcro,y te colma de amor y de ternura;"
,"5":"él sacia de bienes tu existencia,y te rejuvenece como el águila."
,"6":"El Señor hace justicia,y libera a todos los oprimidos;"
,"7":"él reveló sus caminos a Moisés,y sus portentos a los israelitas."
,"8":"El Señor es misericordioso y compasivo, el Señor es paciente y todo amor;"
,"9":"no está siempre acusando,ni guarda rencor eternamente;"
,"10":"no nos trata como merecen nuestras culpas,ni nos paga según nuestros delitos."
,"11":"Cuanto los cielos se alzan sobre la tierra, así es de grande su amor para los fieles;"
,"12":"cuanto dista el oriente del occidente, así aleja de nosotros nuestras culpas."
,"13":"Como se apiada un padre de sus hijos, así se apiada él de sus amigos;"
,"14":"él sabe de qué pasta estamos hechos, se acuerda de que no somos más que polvo."
,"15":"Los días del hombre son como la hierba, como la flor del campo así florece;"
,"16":"la azota el viento y deja de existir, ni se sabe siquiera dónde estaba."
,"17":"Pero el amor del Señor a sus fieles es eterno, y su justicia para todas sus generaciones,"
,"18":"para aquellos que guardan su alianza,y se acuerdan de cumplir sus mandamientos."
,"19":"El Señor en los cielos asentó su trono, y su soberanía todo lo gobierna."
,"20":"Bendecid al Señor todos sus ángeles, héroes poderosos, agentes de sus órdenes, atentos a la voz de su palabra."
,"21":"Bendecid al Señor todas sus huestes, ministros suyos, que hacéis su voluntad."
,"22":"Bendecid al Señor todas sus obras, en todos los lugares de su imperio. Bendice, alma mía, al Señor."
}`)
	CurrentBook.AddChapter(104, `{
"1":"Bendice, alma mía, al Señor. Señor, Dios mío, qué grande eres. Vestido de esplendor y majestad,"
,"2":"arropado de luz, como de un manto,despliegas los cielos lo mismo que una tienda,"
,"3":"construyes sobre las aguas tus moradas; haces tu carro de las nubes,y caminas en las alas del viento;"
,"4":"tomas por mensajeros a los vientos, a las llamas del fuego por ministros."
,"5":"Afincaste la tierra sobre sus cimientos, y será eternamente inamovible;"
,"6":"la cubriste del océano como de un vestido, las aguas cubrían las montañas;"
,"7":"ante tu amenaza emprendieron la huida, retrocedieron a la voz de tu trueno,"
,"8":"saltando por las montañas,y descendiendo por los valles, hasta el lugar que tú les asignaste."
,"9":"Les señalaste un límite, que no pueden cruzar, para que no vuelvan a cubrir la tierra."
,"10":"Haces manar las fuentes a raudales, y se deslizan entre las montañas;"
,"11":"abrevan a todas las bestias de los campos, en ellas los asnos salvajes apagan su sed;"
,"12":"junto a ellas anidan las aves de los cielos, y allí lanzan su trino entre la fronda."
,"13":"Desde tus mansiones riegas las montañas, la tierra se empapa del regalo de tu cielo;"
,"14":"haces brotar la hierba para los ganados, y las plantas que cultiva el hombre,para sacar de la tierra el pan,"
,"15":"el pan que le da fuerzas, y el vino que le alegra el corazón,y hace brillar su rostro más que el mismo aceite."
,"16":"Los árboles del Señor sacian su sed, y los cedros del Líbano que él había plantado."
,"17":"Allí anidan los pájaros, la cigüeña anida en los cipreses."
,"18":"Los altos montes son para los rebecos, y las rocas, para cobijo de tejones."
,"19":"Has hecho la luna para fijar los tiempos, y el sol, que conoce la hora de su ocaso."
,"20":"Derramas la tiniebla y cae la noche, y entonces salen todas las fieras de la selva;"
,"21":"los leoncillos rugen por la presa,y reclaman su alimento a Dios."
,"22":"Se retiran al salir el sol,y van a tumbarse en sus guaridas;"
,"23":"entonces sale el hombre a su trabajo, y está trabajando hasta la tarde."
,"24":"Qué numerosas son, Señor, tus obras; todas las has hecho con sabiduría, la tierra está llena de tus criaturas."
,"25":"Ahí está el mar, inmenso y grande, en el que se mueven un sinfín de animales grandes y pequeños; "
,"26":"por él van y vienen los navíos y Leviatán, al que hiciste para que en él jugase."
,"27":"Todos ellos esperan de ti,que les des a su tiempo su alimento;"
,"28":"tú se lo das, y ellos lo recogen; abres tu mano, y se sacian de bienes;"
,"29":"si escondes tu rostro, se acobardan; si retiras tu soplo, expiran y retornan al polvo;"
,"30":"si envías tu soplo, son creados, y renuevas la faz de la tierra."
,"31":"La gloria del Señor es eterna, el Señor se complace en sus obras."
,"32":"Cuando él mira a la tierra, ésta tiembla; toca las montañas, y echan humo."
,"33":"Toda mi vida cantaré al Señor; mientras exista, cantaré himnos a mi Dios."
,"34":"Ojalá le agrade mi poema, pues sólo en él encuentro mi alegría."
,"35":"Que los criminales sean borrados de la tierra, que dejen de existir los malhechores. Bendice, alma mía, al Señor. ¡Aleluya!"
}`)
	CurrentBook.AddChapter(105, `{
"1":"Dad gracias al Señor, invocad su nombre, publicad entre los pueblos sus proezas;"
,"2":"cantad, entonad himnos en su honor, decid a las gentes sus milagros;"
,"3":"estad orgullosos de su santo nombre, alegraos los que buscáis al Señor."
,"4":"Recurrid al Señor y a su poder, buscad siempre su rostro."
,"5":"Recordad los milagros que hizo, sus prodigios y las leyes que salieron de su boca,"
,"6":"raza de Abrahán, su siervo, hijos de Jacob, su elegido."
,"7":"El Señor es nuestro Dios, sus leyes rigen en el mundo entero."
,"8":"Él se acuerda de su alianza eternamente, de la palabra dada, por mil generaciones;"
,"9":"del pacto que firmó con Abrahán, del juramento que hizo a Isaac,"
,"10":"y que erigió en ley para Jacob, y en pacto eterno para Israel"
,"11":"cuando dijo: 'Te daré la tierra de Canaán,como la parte de tu herencia'."
,"12":"Mientras ellos eran muy pocos, un puñado tan sólo de emigrantes,"
,"13":"mientras iban y venían de nación en nación, de un reino a un pueblo diferente,"
,"14":"no permitió a nadie que los oprimiera, y por ellos castigó a los reyes:"
,"15":"'Guardaos de tocar a mis ungidos, no hagáis mal alguno a mis profetas'."
,"16":"Atrajo el hambre sobre aquella tierra, les cortó todos los alimentos;"
,"17":"delante de ellos envió a un hombre, a José, vendido como esclavo;"
,"18":"le aprisionaron los pies con los grilletes,y le echaron al cuello las cadenas"
,"19":"hasta que se cumplió lo que él había anunciado,y la palabra del Señor lo acreditó."
,"20":"El rey mandó que lo soltasen, el soberano le dio la libertad,"
,"21":"lo nombró mayordomo de su casa,y administrador de todos sus bienes,"
,"22":"para que instruyera a los nobles a su gusto,y enseñara la sabiduría a los ancianos."
,"23":"Entonces Israel entró en Egipto,y Jacob emigró al país de Cam."
,"24":"Dios hizo a su pueblo muy prolífero, y mucho más fuerte que sus opresores;"
,"25":"cambió el corazón de éstos,para que odiaran a su pueblo, y trataran a sus siervos con perfidia."
,"26":"Luego envió a Moisés, su servidor, y a Aarón, a quien había escogido."
,"27":"Ellos realizaron en Egipto sus portentos, los prodigios de Dios en el país de Cam."
,"28":"Mandó tinieblas, y tinieblas hubo, pero ellos no respetaron sus palabras;"
,"29":"cambió en sangre sus aguas, y dio muerte a sus peces;"
,"30":"infestó de ranas el país, hasta la misma alcoba del rey."
,"31":"Lo ordenó, y vinieron tábanos,y mosquitos por todo el territorio;"
,"32":"en lugar de lluvias les envió granizo,y rayos ardientes sobre todo el país;"
,"33":"arrasó sus viñedos y sus higuerales, destrozó los árboles de toda la comarca."
,"34":"Lo ordenó, y llegó la langosta,y el pulgón en inmensas cantidades,"
,"35":"que devoraron toda la hierba del país,y todos los frutos de sus campos."
,"36":"Hirió de muerte a todos los primogénitos del país, las primicias de su virilidad."
,"37":"Sacó luego a su pueblo cargado de oro y plata, ni uno sólo cayó de entre sus tribus;"
,"38":"Egipto se alegró de su partida, pues todos estaban aterrados."
,"39":"Dios desplegó una nube para cubrirlos,y un fuego para alumbrarlos por la noche."
,"40":"A petición suya, les mandó codornices,y los sació de pan del cielo;"
,"41":"partió la roca y brotó agua que bajaba,como un río por el desierto."
,"42":"Se acordó de la palabra santa,que había dado a Abrahán, su siervo,"
,"43":"y sacó a su pueblo en alegría, a sus elegidos entre gritos de júbilo."
,"44":"Les dio las tierras de otras gentes,y se posesionaron de las haciendas de otros pueblos"
,"45":"para que guarden sus decretos y observen sus leyes. Aleluya."
}`)
	CurrentBook.AddChapter(106, `{
"1":"¡Aleluya!,Dad gracias al Señor, porque es bueno, porque es eterno su amor."
,"2":"¿Quién podrá contar las proezas del Señor?, ¿quién podrá alabarlo como se merece?"
,"3":"Dichosos los que guardan el derecho,y en todo tiempo practican la justicia."
,"4":"Cuando seas propicio con tu pueblo, acuérdate de mí, Señor; cuando vengas a salvarlo, no te olvides de mí;"
,"5":"para que vea la dicha de tus elegidos, me alegre con la alegría de tu pueblo,y me enorgullezca con tu heredad."
,"6":"Hemos pecado, igual que nuestros padres, hemos sido perversos y traidores."
,"7":"Nuestros padres en Egipto no valoraron tus prodigios, no se acordaron de tu inmenso amor, se rebelaron contra el altísimo en el mar Rojo."
,"8":"Pero él los salvó por amor a su nombre, para manifestar públicamente su poder."
,"9":"Amenazó al mar Rojo, y se secó; los llevó entre las aguas,como por el desierto;"
,"10":"los salvó de las manos hostiles, los liberó de las manos enemigas;"
,"11":"las aguas cubrieron a sus perseguidores, no se salvó ni uno."
,"12":"Entonces creyeron en sus palabras,y cantaron sus alabanzas."
,"13":"Pero pronto se olvidaron de sus obras,y no supieron esperar en sus designios:"
,"14":"manifestaron en el desierto sus ansias insaciables, pusieron a prueba a Dios en aquellas soledades;"
,"15":"él les concedió todo lo que pedían, pero les envió muy poco para lo que ellos deseaban."
,"16":"En el campamento tuvieron envidia de Moisés,y de Aarón, el hombre consagrado al Señor:"
,"17":"se abrió la tierra y se tragó a Datán, y sepultó a la pandilla de Abirán;"
,"18":"un fuego devoró a su banda, una llama devoró a aquellos rebeldes."
,"19":"En Horeb se hicieron un becerro, adoraron al metal fundido,"
,"20":"y cambiaron su gloria,por la imagen de un buey que come hierba;"
,"21":"olvidaron a Dios, su libertador, al autor de prodigios en Egipto,"
,"22":"de milagros en el país de Cam, de acciones portentosas en el mar Rojo."
,"23":"Dios pensaba ya aniquilarlos; pero Moisés, su elegido, se interpuso ante él,y le hizo apartar su ira destructora."
,"24":"Despreciaron un país maravilloso, y en su palabra no tuvieron fe;"
,"25":"murmuraron dentro de sus tiendas,y no obedecieron al Señor."
,"26":"Él entonces, mano en alto, les juró que los haría caer en el desierto,"
,"27":"que dispersaría a sus descendientes,por todos los países,y los esparciría entre todos los gentiles."
,"28":"Se hicieron luego esclavos de Baal Fegor, comieron los sacrificios de los muertos;"
,"29":"así lo provocaron con sus crímenes,y descargó una plaga sobre ellos."
,"30":"Surgió entonces Fineés y ejecutó al culpable, y la plaga se detuvo:"
,"31":"esto fue tenido como una acción justa,de edad en edad y para siempre."
,"32":"Junto a las aguas de Meribá,lo irritaron de nuevo,y mal le fue a Moisés por culpa de ellos;"
,"33":"pues ellos le amargaron el espíritu,y Moisés habló sin pensar lo que decía."
,"34":"No exterminaron a los pueblos,que el Señor les había dicho;"
,"35":"se mezclaron con los paganos,y adoptaron sus costumbres;"
,"36":"adoraron a sus ídolos,y cayeron en sus trampas;"
,"37":"inmolaron a sus hijos y a sus hijas,a esos falsos dioses;"
,"38":"derramaron una sangre inocente, la sangre de sus hijos y de sus hijas, que inmolaron a los ídolos de Canaán, y el país quedó manchado con delitos de sangre;"
,"39":"así se contaminaron con sus obras,y se prostituyeron con sus malas acciones."
,"40":"El Señor se enfureció contra su pueblo,y renegó de su heredad."
,"41":"Los entregó en manos de las gentes,y fueron dominados por sus adversarios;"
,"42":"fueron aplastados por sus enemigos,y subyugados bajo su poder."
,"43":"Él los libró una y otra vez, pero ellos se obstinaban en su rebeldía,y se hundían cada vez más en sus maldades."
,"44":"Él reparó en sus tribulaciones,y escuchó sus plegarias;"
,"45":"se acordó de la alianza que había hecho con ellos, por su inmenso amor cambió de proceder:"
,"46":"hizo que sus conquistadores,los trataran con benevolencia."
,"47":"Sálvanos, Señor, Dios nuestro, reúnenos de en medio de las gentes,para que alabemos tu santo nombre,y cantemos con alegría tus alabanzas."
,"48":"Bendito sea el Señor, Dios de Israel, desde siempre y por siempre. Y que todo el pueblo diga: ¡Amén! ¡Aleluya!"
}`)
	CurrentBook.AddChapter(107, `{
"1":"Dad gracias al Señor, porque es bueno, porque es eterno su amor."
,"2":"Que lo digan los que el Señor ha liberado, los que él ha rescatado de la mano de los opresores,"
,"3":"los que ha reunido de todos los países del norte,y del sur, del este y del oeste."
,"4":"Andaban errantes por el desierto solitario,sin encontrar camino de ciudad habitada;"
,"5":"hambrientos y sedientos, su vida se agotaba."
,"6":"En su angustia gritaron al Señor, y él los libró de sus apuros."
,"7":"Los puso en el camino justo,y llegaron a ciudad habitada."
,"8":"Den gracias al Señor por su amor, por sus milagros en favor de los humanos."
,"9":"Porque él apagó la sed de los sedientos,y colmó de comida a los hambrientos."
,"10":"Habitaban en tinieblas y en la sombra mortal, prisioneros de miseria y de cadenas,"
,"11":"por haberse rebelado contra las órdenes de Dios,y haber despreciado los designios del altísimo."
,"12":"Él los sometió a trabajos durísimos, caían agotados y nadie les echaba una mano."
,"13":"En su angustia gritaron al Señor, y él los libró de sus apuros,"
,"14":"los sacó de las tinieblas y la sombra mortal,y rompió sus cadenas."
,"15":"Den gracias al Señor por su amor, por sus milagros en favor de los humanos."
,"16":"Él hizo pedazos las puertas de bronce, hizo saltar los barrotes de hierro."
,"17":"Andaban como locos en sus desvaríos, abrumados bajo el peso de sus culpas;"
,"18":"tenían asco de cualquier comida,y estaban a las puertas de la muerte."
,"19":"En su angustia gritaron al Señor, y él los sacó de sus apuros."
,"20":"Envió su palabra y los curó, los libró del sepulcro."
,"21":"Den gracias al Señor por su amor, por sus milagros en favor de los humanos;"
,"22":"ofrezcan sacrificios de alabanza,y pregonen sus obras con cantos de alegría."
,"23":"Los que a la mar se hicieron con sus naves, buscando su negocio en las aguas inmensas,"
,"24":"vieron las obras del Señor,y sus milagros en el alta mar."
,"25":"A su palabra se desató una tempestad,que levantó unas grandes olas:"
,"26":"subían a los cielos, bajaban al abismo, se vinieron abajo ante el peligro;"
,"27":"daban vueltas y se tambaleaban como los borrachos, y de nada les servía toda su pericia."
,"28":"En su angustia gritaron al Señor, y él los libró de sus apuros."
,"29":"Redujo la tempestad a suave brisa,y las olas se calmaron."
,"30":"Se llenaron de alegría al verlas ya calmadas, y él los llevó al puerto deseado."
,"31":"Den gracias al Señor por su amor, por sus milagros en favor de los humanos."
,"32":"Que lo aclamen en la asamblea del pueblo,y lo alaben en la reunión de los ancianos."
,"33":"Él convierte los ríos en desierto, las fuentes de agua en tierra seca;"
,"34":"un terreno fértil en salinas, por la maldad de sus habitantes."
,"35":"Él convierte los desiertos en lagunas,y la tierra seca en manantiales."
,"36":"Allí establece él a los hambrientos,que construyen su ciudad habitable."
,"37":"Siembran campos, plantan viñedos,y recogen sus frutos abundantes."
,"38":"Dios los bendice, ellos prosperan, y hace que se multipliquen sus ganados."
,"39":"Cuando vienen a menos y decaen a causa de la opresión, el infortunio o la desgracia,"
,"40":"Dios vierte su desprecio sobre los opresores,y los hace vagar por el desierto sin camino;"
,"41":"saca de la miseria al indigente,y multiplica como rebaños su familia."
,"42":"Los justos lo ven y se llenan de alegría,y todas las injusticias enmudecen."
,"43":"El hombre inteligente tiene en cuenta todas estas cosas,y sabe apreciar el amor del Señor."
}`)
	CurrentBook.AddChapter(108, `{
"1":"Salmo. Cántico de David"
,"2":"Dispuesto está mi corazón, Dios mío, voy a cantarte un himno, gloria mía:"
,"3":"despertad, arpa y cítara, despertaré a la aurora;"
,"4":"te daré gracias ante los pueblos, Señor, te cantaré ante las naciones,"
,"5":"pues tu amor es más grande que los cielos,y tu fidelidad alcanza hasta las nubes."
,"6":"Álzate, oh Dios, sobre los cielos, y que tu gloria se extienda sobre toda la tierra."
,"7":"Para que sean libertados tus elegidos; socórrenos con tu poder y escúchanos."
,"8":"Dios ha hablado en su santuario: 'Lleno de gozo, repartiré a Siquén, dividiré en parcelas el valle de Sucot,"
,"9":"mío es Galaad y mío Manasés, Efraín es yelmo de mi cabeza y Judá mi cetro,"
,"10":"Moab es la vasija en que me lavo, arrojo mi sandalia contra Edón, canto victoria contra Filistea'."
,"11":"¿Quién me llevará hasta una plaza fuerte?, ¿quién me conducirá hasta Edón?"
,"12":"¿No serás tú, el Dios que nos ha rechazado, el Dios que no sale ya con nuestras tropas?"
,"13":"Ven en nuestra ayuda contra el adversario, pues la ayuda del hombre no sirve para nada."
,"14":"Con la ayuda de Dios haremos maravillas,y él aplastará a nuestros enemigos."
}`)
	CurrentBook.AddChapter(109, `{
"1":"Al maestro de coro. Salmo de David,Oh Dios de mi alabanza, no estés mudo,"
,"2":"pues abren contra mí su boca malvada y mentirosa; me hablan un lenguaje de calumnias,"
,"3":"me acorralan con palabras de odio,y me atacan sin motivo;"
,"4":"en pago de mi amistad me acusan, y yo no hago más que orar;"
,"5":"me devuelven mal por bien y odio por amor."
,"6":"'Designa contra él un hombre sin entrañas, un duro acusador a su derecha;"
,"7":"cuando lo juzguen, que salga condenado, que su propia defensa lo condene;"
,"8":"que su vida sea corta y otro ocupe su cargo;"
,"9":"que se queden huérfanos sus hijos,y su mujer viuda;"
,"10":"que sus hijos sean mendigos vagabundos, expulsados de sus casas en ruinas;"
,"11":"que el acreedor se haga con todo lo que tiene, y el fruto de su trabajo se lo roben los extraños;"
,"12":"que nadie le tenga compasión, que nadie se apiade de sus huérfanos;"
,"13":"que sus descendientes sean exterminados, que en una generación sea borrado su nombre;"
,"14":"que el Señor recuerde la culpa de sus padres, que no borre nunca el pecado de su madre;"
,"15":"que estén siempre presentes al Señor,y que él borre de la tierra su memoria."
,"16":"Porque él no quiso nunca tener misericordia,y persiguió a muerte al pobre, al afligido y al humilde;"
,"17":"amó la maldición, sobre él recaiga; no quiso bendición, que de él se aleje;"
,"18":"se vista de maldición como de un manto; penetre como el agua en sus entrañas, igual que aceite dentro de sus huesos;"
,"19":"sea como vestido que lo cubra,y como cinto que lo ciña siempre'."
,"20":"Así pagará el Señor a mis acusadores, a los que levantan calumnias contra mí."
,"21":"Mas tú, Señor, obra en mi favor,por amor a tu nombre; Dios mío, por tu bondad y tu misericordia, líbrame,"
,"22":"porque yo soy un pobre desgraciado,y tengo dentro de mí el corazón deshecho;"
,"23":"voy pasando como sombra que declina, me espantan igual que a la langosta;"
,"24":"de tanto ayunar se me doblan las rodillas; falto de alimento, mi cuerpo ha enflaquecido;"
,"25":"soy el hazmerreír de todos ellos; al verme, menean la cabeza."
,"26":"Ayúdame, Señor, Dios mío, líbrame, por tu misericordia."
,"27":"Que sepan que es tu mano, que eres tú, Señor, el que lo ha hecho."
,"28":"Ellos maldicen, pero tú bendices, que ellos se avergüencen y tu siervo se alegre;"
,"29":"que mis calumniadores se vistan de ignominia, que los cubra la vergüenza como un manto."
,"30":"Yo con mi boca daré gracias al Señor, lo alabaré ante las multitudes,"
,"31":"porque él se pone a la derecha del pobre,para salvarlo de los jueces."
}`)
	CurrentBook.AddChapter(110, `{
"1":"Salmo de David,Palabra del Señor a mi Señor: 'Siéntate a mi derecha, hasta que haga de tus enemigos estrado de tus pies'."
,"2":"El Señor extenderá desde Sión el poder de tu cetro: domina sobre tus enemigos."
,"3":"Contigo el poderío el día de tu nacimiento; en las montañas santas, como el rocío, te he engendrado en el seno de la aurora."
,"4":"El Señor lo ha jurado y no se vuelve atrás: 'Tú eres sacerdote para siempre,a la manera de Melquisedec'."
,"5":"El Señor está a tu derecha, aplastará a los reyes el día de su cólera;"
,"6":"juzga a las naciones, amontona cadáveres,y tritura cabezas en el mundo entero."
,"7":"En el camino beberá del torrente, por eso levantará su cabeza."
}`)
	CurrentBook.AddChapter(111, `{
"1":"¡Aleluya!,Doy gracias al Señor de todo corazón,en la reunión de los hombres justos,y en la asamblea general."
,"2":"Grandes son las obras del Señor, dignas de estudio para los que las aman."
,"3":"Su obra resplandece de esplendor,y su justicia permanece para siempre."
,"4":"Él ha hecho memorables sus milagros, el Señor es misericordioso y lleno de ternura."
,"5":"Él da de comer a sus leales,y recuerda siempre su alianza."
,"6":"Manifiesta a su pueblo el poder de sus obras, dándole la heredad de las naciones."
,"7":"Verdad y justicia son las obras de sus manos, todos sus preceptos son estables,"
,"8":"inmutables por los siglos de los siglos, fundados en el derecho y la verdad."
,"9":"Envió a su pueblo la liberación,y estableció para siempre la alianza: santo es su nombre y venerable."
,"10":"El temor del Señor es el principio de la sabiduría, los que la practican son gente lista: su alabanza permanece eternamente."
}`)
	CurrentBook.AddChapter(112, `{
"1":"¡Aleluya!,Dichoso el hombre que teme al Señor,y ama sus mandamientos."
,"2":"Su prole será poderosa sobre la tierra, y bendita la raza de sus hombres rectos."
,"3":"En su casa habrá fortuna y bienestar, su justicia permanece para siempre."
,"4":"Una luz resplandece en las tinieblas,para los hombres justos: el piadoso, el compasivo, el justo."
,"5":"Dichoso el que se compadece y da prestado, y arregla sus asuntos con justicia."
,"6":"El hombre justo jamás vacilará, su recuerdo perdura eternamente;"
,"7":"no tiene miedo de noticias malas, su corazón está firme, confiado en el Señor;"
,"8":"está muy tranquilo y nada teme, terminará por triunfar contra sus opresores."
,"9":"Todo lo da, lo reparte entre los pobres, su justicia permanece para siempre."
,"10":"El criminal, al verlo, se enfurece, se consume de rabia, rechinando los dientes. El propósito del criminal será un fracaso."
}`)
	CurrentBook.AddChapter(113, `{
"1":"¡Aleluya!,Siervos del Señor, alabadlo, alabad el nombre del Señor."
,"2":"Bendito sea el nombre del Señor,desde ahora y por siempre;"
,"3":"desde que sale el sol hasta su ocaso, alabado sea el nombre del Señor."
,"4":"El Señor domina sobre las naciones, su gloria por encima de los cielos."
,"5":"¿Quién es como el Señor, nuestro Dios, que se sienta en lo alto,"
,"6":"y se rebaja para ver los cielos y la tierra?"
,"7":"Él levanta del polvo al indigente,y saca al pobre del estiércol,"
,"8":"para sentarlo con los príncipes, con los príncipes de su pueblo;"
,"9":"instala a la estéril en su casa, madre gozosa de toda la familia."
}`)
	CurrentBook.AddChapter(114, `{
"1":"¡Aleluya!,Cuando Israel salió de Egipto, cuando la casa de Jacob dejó un pueblo extranjero,"
,"2":"Judá llegó a ser su santuario e Israel su dominio."
,"3":"El mar, al verlo, huyó y el Jordán retrocedió;"
,"4":"los montes brincaron lo mismo que carneros, y las colinas igual que corderillos."
,"5":"¿Qué te pasa, mar, para que huyas, y a ti, Jordán, para volver atrás;"
,"6":"montes, para saltar como carneros, y colinas, como corderillos?"
,"7":"Tiembla, oh tierra, delante del Señor, delante del Dios de Jacob,"
,"8":"que convirtió la peña en un estanque,y el granito en una fuente."
}`)
	CurrentBook.AddChapter(115, `{
"1":"No a nosotros, Señor, no a nosotros, sino a tu nombre da la gloria, por tu amor y tu fidelidad."
,"2":"¿Por qué han de decir las gentes: 'En dónde está su Dios'?"
,"3":"Nuestro Dios está en los cielos, él hace todo lo que quiere."
,"4":"Sus ídolos son de oro y plata, hechura de la mano del hombre;"
,"5":"tienen boca y no hablan, tienen ojos y no ven,"
,"6":"tienen orejas y no oyen, tienen nariz, pero no huelen,"
,"7":"tienen manos y no tocan, tienen pies,y no andan, no sale una voz de su garganta."
,"8":"Los que los fabrican serán igual que ellos, y todos los que en ellos se confían."
,"9":"La casa de Israel confía en el Señor, él es su auxilio y su escudo."
,"10":"La casa de Aarón confía en el Señor, él es su auxilio y su escudo."
,"11":"Los fieles del Señor confían en el Señor, él es su auxilio y su escudo."
,"12":"El Señor se acuerda de nosotros y nos bendecirá, bendecirá a la casa de Israel, bendecirá a la casa de Aarón,"
,"13":"bendecirá a los fieles del Señor, chicos y grandes."
,"14":"Que el Señor os haga prosperar,a vosotros y a vuestros hijos;"
,"15":"que os bendiga el Señor,creador del cielo y de la tierra."
,"16":"El cielo es el cielo del Señor, y la tierra se la ha dado a los hombres."
,"17":"No son los muertos los que alaban al Señor, ni ninguno de los que bajan al silencio;"
,"18":"somos nosotros los que bendecimos al Señor,ahora y por siempre. ¡Aleluya!"
}`)
	CurrentBook.AddChapter(116, `{
"1":"¡Aleluya!,Yo amo al Señor porque escucha,el grito de mi súplica,"
,"2":"porque me presta oído siempre que lo invoco."
,"3":"Me cercaron los lazos de la muerte, me sorprendieron las redes del abismo, me hundí en la angustia y la tristeza;"
,"4":"pero invoqué el nombre del Señor: 'Anda, Señor, sálvame la vida'."
,"5":"El Señor es justo y compasivo, nuestro Dios está lleno de ternura;"
,"6":"el Señor protege a los humildes; yo estaba desvalido y me salvó."
,"7":"Alma mía, recobra ya la calma, pues el Señor te ha protegido;"
,"8":"me ha librado de la muerte, mis ojos de las lágrimas, mis pies de la caída."
,"9":"Caminaré en presencia del Señor en la tierra de los vivos."
,"10":"Nunca pierdo la fe, aun cuando digo: 'Yo soy un desgraciado'."
,"11":"En mi perturbación llegué a decir: 'Todos los hombres son unos mentirosos'."
,"12":"¿Cómo pagaré al Señor todo el bien que me ha hecho?"
,"13":"Alzaré la copa de la victoria,e invocaré el nombre del Señor;"
,"14":"cumpliré mis promesas al Señor,en presencia de todo el pueblo."
,"15":"Al Señor le cuesta mucho ver morir a sus amigos."
,"16":"Sí, Señor, yo soy tu siervo, tu siervo, el hijo de tu esclava: tú rompiste mis cadenas."
,"17":"Te ofreceré sacrificios en acción de gracias,e invocaré tu nombre, Señor;"
,"18":"cumpliré mis promesas al Señor,en presencia de todo su pueblo,"
,"19":"en los atrios de la casa del Señor, en medio de ti, Jerusalén."
}`)
	CurrentBook.AddChapter(117, `{
"1":"¡Aleluya!,Alabad al Señor, todos los pueblos, aclamadlo, todas las naciones,"
,"2":"pues su amor por nosotros es muy grande,y su lealtad dura por siempre."
}`)
	CurrentBook.AddChapter(118, `{
"1":"¡Aleluya!,Dad gracias al Señor, porque es bueno, porque es eterno su amor."
,"2":"Diga la casa de Israel: es eterno su amor."
,"3":"Diga la casa de Aarón: es eterno su amor."
,"4":"Digan los fieles del Señor: es eterno su amor."
,"5":"En mi angustia clamé al Señor, él me atendió y me dio respiro."
,"6":"El Señor está conmigo; de nada tengo miedo, ¿qué puede hacerme el hombre?"
,"7":"El Señor está conmigo, él es mi apoyo, yo veré derrotado a mi enemigo."
,"8":"Mejor es refugiarse en el Señor,que fiarse del hombre;"
,"9":"mejor es refugiarse en el Señor,que fiarse del jefe."
,"10":"Todas las naciones me cercaron, pero en el nombre del Señor las trituré;"
,"11":"me rodearon, me cercaron, pero en el nombre del Señor las trituré;"
,"12":"me cercaron como avispas, ardían como fuego de espinos, pero en el nombre del Señor las trituré."
,"13":"Me atropellaron para que cayera, pero el Señor vino en mi ayuda;"
,"14":"mi fuerza y mi grito de guerra es él, a él le debo la victoria."
,"15":"Clamor de alegría y de victoria,en la tienda de los justos: la diestra del Señor hace proezas,"
,"16":"la diestra del Señor es poderosa, la diestra del Señor hace proezas."
,"17":"No, no moriré, seguiré viviendo,para contar las obras del Señor;"
,"18":"el Señor me ha castigado duramente,pero no ha permitido que muera."
,"19":"Abridme las puertas de la justicia, que voy a entrar a dar gracias al Señor."
,"20":"Ésta es la puerta del Señor; que entren los justos."
,"21":"Te doy gracias porque me has escuchado, a ti te debo la victoria."
,"22":"La piedra que desecharon los constructores,se ha convertido en piedra angular;"
,"23":"esto ha sido obra del Señor, una maravilla a nuestros ojos."
,"24":"Éste es el día que el Señor ha hecho; sea nuestra alegría y nuestro gozo."
,"25":"Danos la victoria, dánosla, Señor; danos el triunfo, dánoslo, Señor."
,"26":"Bendito el que viene en nombre del Señor. Os bendecimos desde la casa del Señor."
,"27":"El Señor es Dios, él nos ilumina; ordenad la procesión con ramos en las manos,hasta los ángulos del altar."
,"28":"Tú eres mi Dios, yo te doy gracias; Dios mío, yo te ensalzo."
,"29":"Dad gracias al Señor, porque es bueno, porque es eterno su amor."
}`)
	CurrentBook.AddChapter(119, `{
"1":"Dichosos aquellos cuya conducta es intachable, los que caminan en la ley del Señor;"
,"2":"dichosos los que guardan sus decretos, los que lo buscan de todo corazón;"
,"3":"los que no cometen ningún crimen, los que siguen sus caminos."
,"4":"Tú has promulgado tus preceptos,para que sean estrictamente cumplidos;"
,"5":"ojalá sea firme mi conducta,en guardar tus decretos;"
,"6":"entonces no tendré vergüenza alguna,en mirar a todos tus mandamientos."
,"7":"Te daré gracias con un corazón recto, instruido por tus sentencias justas."
,"8":"Yo voy a guardar tus mandamientos, no me abandones tú del todo."
,"9":"¿Cómo un joven podrá tener una conducta pura?,Guardando tu palabra."
,"10":"Yo te busco de todo corazón, no dejes que me aparte de tus mandamientos;"
,"11":"dentro de mi corazón conservo tus órdenes,para no pecar nunca contra ti."
,"12":"Bendito seas, Señor, enséñame tus decretos;"
,"13":"mis labios han contado,todas las sentencias de tu boca;"
,"14":"yo encuentro la alegría en cumplir tus decretos,más que en todas las riquezas;"
,"15":"quiero meditar en tus preceptos,y tener los ojos fijos en tus sendas;"
,"16":"en tus decretos encuentro mis delicias, no olvido tu palabra."
,"17":"Haz bien a tu siervo para que viva,y guarde tu palabra;"
,"18":"abre mis ojos para que contemple,las maravillas de tu ley;"
,"19":"soy un caminante por el mundo: no me ocultes tus mandamientos;"
,"20":"amo con pasión tus sentencias,de cualquier momento."
,"21":"Tú amenazas al maldito soberbio, que se desvía de tus mandamientos;"
,"22":"líbrame del insulto y del desprecio, pues guardo tus decretos;"
,"23":"aunque los jefes se reúnan,y deliberen contra mí, tu siervo medita en tus decretos;"
,"24":"tus decretos hacen mis delicias, ellos son mis consejeros."
,"25":"Aquí me tienes en el polvo hundido: reanímame conforme a tu palabra."
,"26":"Te he contado mis andanzas,y tú me has escuchado: enséñame tus decretos;"
,"27":"señálame el camino de tus mandamientos,y yo meditaré en tus maravillas."
,"28":"Yo me deshago en lágrimas de pena; sosténme conforme a tu palabra."
,"29":"Aleja de mí el camino de la mentira,y dame la gracia de tu ley;"
,"30":"he elegido el camino de la verdad,y he preferido tus sentencias."
,"31":"Me he apegado a tus órdenes, que no quede defraudado, Señor;"
,"32":"corro por el camino de tus mandamientos, pues tú me agrandas el espíritu."
,"33":"Enséñame, Señor, el camino de tus decretos, pues quiero seguirlo hasta el final;"
,"34":"dame inteligencia para cumplir tu ley,y yo la guardaré de todo corazón;"
,"35":"llévame por el camino de tus mandamientos, pues en él encuentro mi felicidad;"
,"36":"inclina mi corazón hacia tus órdenes,y no hacia la ganancia;"
,"37":"aparta mis ojos de mirar vanidades,y hazme vivir en tu camino."
,"38":"Mantén a tu siervo la promesa,que nos obliga a serte fieles."
,"39":"Líbrame del oprobio que me espanta, pues tus sentencias son buenas;"
,"40":"mira cómo amo tus preceptos, haz que viva conforme a tu justicia."
,"41":"Llegue hasta mí tu amor, Señor, tu salvación conforme a tu justicia;"
,"42":"así responderé a los que me insultan, porque confío en tu palabra;"
,"43":"no quites de mi boca la palabra de verdad, pues yo confío en tus sentencias;"
,"44":"cumpliré tu ley constantemente, por siempre jamás;"
,"45":"así caminaré a mis anchas, porque busco tus preceptos;"
,"46":"hablaré de tus órdenes delante de los reyes,y no tendré vergüenza;"
,"47":"tus mandamientos son mi felicidad, los amo con pasión;"
,"48":"tiendo mis manos hacia tus mandamientos,y medito en tus decretos."
,"49":"Recuerda la palabra que me diste, en la que hiciste que pusiera mi esperanza;"
,"50":"esto ha sido mi consuelo en la miseria: tu promesa."
,"51":"Los orgullosos se han burlado bien de mí, pero yo no me he apartado de tu ley."
,"52":"Me acuerdo de tus sentencias de otro tiempo, ellas son mi consuelo."
,"53":"Me lleno de indignación ante los malhechores, que abandonan tu ley;"
,"54":"tus decretos son el objeto de mi canto,en mi mansión de peregrino;"
,"55":"por la noche, Señor, me acuerdo de tu nombre, para guardar tu ley;"
,"56":"ésta es mi tarea: observar tus preceptos."
,"57":"He dicho, Señor, que ésta es mi suerte: guardar tus palabras."
,"58":"Yo te imploro de todo corazón; ten compasión de mí conforme a tu promesa."
,"59":"Examino mi conducta,y dirijo hacia tus órdenes mis pasos;"
,"60":"me doy prisa y no pierdo un instante,en guardar tus mandamientos;"
,"61":"las redes de los malhechores me han aprisionado, pero yo no he olvidado tu ley;"
,"62":"me levanto a media noche a darte gracias,por tus sentencias justas;"
,"63":"soy amigo de todos tus amigos, que guardan tus preceptos;"
,"64":"la tierra está llena de tu amor; haz que aprenda tus decretos."
,"65":"Tú has sido muy bueno con tu siervo, Señor, conforme a tu palabra;"
,"66":"enséñame el buen sentido y el saber, pues yo tengo fe en tus mandamientos;"
,"67":"antes de que me humillaras andaba extraviado, pero ahora guardo tu palabra;"
,"68":"tú eres bueno y bienhechor, haz que aprenda tus decretos;"
,"69":"los orgullosos me acusan falsamente, yo guardo tus preceptos con todo el corazón;"
,"70":"tienen el corazón embrutecido, pero yo me deleito en tu ley;"
,"71":"fue un gran bien para mí ser humillado, para aprender tus decretos;"
,"72":"la ley de tu boca es para mí mejor,que millones de oro y plata."
,"73":"Tus manos me han hecho y me han formado; instrúyeme y aprenderé tus mandamientos."
,"74":"Tus fieles al verme se llenan de alegría, porque yo espero en el Señor."
,"75":"Yo sé, Señor, que son justas tus sentencias,y que me has humillado con razón;"
,"76":"que tu amor me consuele, conforme a la promesa que me hiciste;"
,"77":"que me alcance tu compasión y viviré, porque tu ley hace mis delicias;"
,"78":"humilla a los soberbios,que sin razón me oprimen; yo medito en tus preceptos;"
,"79":"que vuelvan conmigo tus leales, los que conocen tus órdenes;"
,"80":"que yo cumpla perfectamente tus decretos,para no tener que avergonzarme."
,"81":"Mi alma se deshace deseando que me salves, yo espero en tu palabra;"
,"82":"mis ojos se deshacen deseando tu promesa; ¿cuándo me vas a consolar?"
,"83":"Soy como un pellejo puesto al humo, pero no he olvidado tus decretos."
,"84":"¿Cuántos serán los días de tu siervo?,¿Cuándo harás justicia con los que me persiguen?"
,"85":"Los soberbios me han cavado fosas, en contra de tu ley;"
,"86":"todos tus mandamientos son verdad; me persiguen sin razón: ¡ayúdame!;"
,"87":"por poco no me han extirpado de la tierra, pero yo no he abandonado tus preceptos;"
,"88":"según tu amor dame la vida, y yo guardaré los decretos de tu boca."
,"89":"Tu palabra, Señor, permanece eternamente, más estable que los mismos cielos;"
,"90":"tu lealtad perdura por todas las edades, tú fijaste la tierra y ahí está;"
,"91":"según tus decisiones, todo subsiste hoy, pues todas las cosas están a tu servicio."
,"92":"Si tu ley no hubiera hecho mis delicias, yo hubiera perecido en la miseria;"
,"93":"jamás me olvidaré de tus preceptos, pues con ellos me has vuelto a dar la vida;"
,"94":"tuyo soy, sálvame, pues busco tus preceptos;"
,"95":"los malvados me acechan y buscan mi ruina, pero yo sigo atento a tus decretos;"
,"96":"he visto el fin de toda perfección: tus mandamientos son infinitamente amplios."
,"97":"Cuánto amo tu ley: todo el día estoy pensando en ella;"
,"98":"tu mandamiento me hace más sabio que mis enemigos, y siempre está conmigo;"
,"99":"soy más listo que todos mis maestros, porque medito en tus decretos;"
,"100":"soy más sabio que todos los ancianos, pues guardo tus preceptos;"
,"101":"he apartado mi pie de todo mal camino,con el fin de guardar tu palabra;"
,"102":"no me he apartado nunca de tus decisiones, pues tú me has instruido;"
,"103":"qué dulce a mi paladar es tu promesa: mucho más que la miel para mi boca;"
,"104":"gracias a tus preceptos soy inteligente, por eso odio todo camino de mentira."
,"105":"Tu palabra es una luz para mis pies, y una antorcha para mi camino;"
,"106":"he jurado, y cumpliré mi juramento: cumplir tus justas decisiones;"
,"107":"estoy, Señor, muy humillado; haz que siga viviendo conforme a tu palabra;"
,"108":"acepta, Señor, las ofrendas de mis labios, haz que aprenda tus sentencias;"
,"109":"estoy en peligro cada instante, pero no olvido tu ley;"
,"110":"aunque los malvados me tiendan una trampa, yo no me desvío de tus preceptos;"
,"111":"lo mío serán siempre tus órdenes, pues ellas son la alegría de mi corazón;"
,"112":"yo cumplo de corazón todos tus decretos, los cumplo siempre y con toda exactitud."
,"113":"Odio a los hipócritas y amo tu ley;"
,"114":"tú eres mi protector y mi escudo, yo espero en tu palabra;"
,"115":"alejaos de mí todos los malvados, pues quiero cumplir los mandamientos de mi Dios;"
,"116":"sosténme conforme a tu promesa y viviré, no me decepciones;"
,"117":"sé tú mi apoyo y seré salvo, no perderé nunca de vista tus decretos;"
,"118":"tú rechazas a los que descartan tus decretos, sus pensamientos no son más que mentira;"
,"119":"tienes por escoria a todos los malvados, por eso amo tus decretos;"
,"120":"ante ti se estremece mi cuerpo de terror, tengo miedo de tus decisiones."
,"121":"Yo he practicado el derecho y la justicia, no me dejes en manos de mis opresores;"
,"122":"sal tú garante de mi bienestar, que los orgullosos no me opriman;"
,"123":"mis ojos se deshacen deseando que me salves, esperando tu promesa de justicia;"
,"124":"trata a tu siervo con arreglo a tu amor, haz que aprenda tus decretos;"
,"125":"yo soy tu siervo, dame inteligencia,para que aprenda tus decretos."
,"126":"Señor, ya es hora de actuar: se ha violado tu ley;"
,"127":"por eso amo yo tus mandamientos, más que el oro fino;"
,"128":"por eso encuentro justos todos tus preceptos,y odio el camino de la falsedad."
,"129":"Tus decretos son maravillosos, por eso yo los guardo;"
,"130":"la explicación de tus palabras,ilumina la inteligencia a la gente simple;"
,"131":"yo suspiro con la boca abierta, pues estoy ansioso de tus mandamientos."
,"132":"Ven conmigo y ten piedad de mí, como haces en justicia con los que te aman;"
,"133":"afirma mis pasos conforme a tu promesa, y no dejes que me domine ninguna iniquidad;"
,"134":"líbrame de la opresión de los hombres, y guardaré tus preceptos;"
,"135":"ilumina tu rostro sobre este siervo tuyo,y haz que aprenda tus preceptos;"
,"136":"ríos de lágrimas caen de mis ojos,porque tu ley no se observa."
,"137":"Tú eres justo, Señor, y justas tus sentencias;"
,"138":"has dado tus órdenes en justicia,y en equidad perfecta."
,"139":"Mi celo me consume,cuando mis enemigos olvidan tu palabra."
,"140":"Tu promesa es a toda prueba, y tu siervo la ama."
,"141":"Aunque soy poca cosa y despreciable, no olvido tus preceptos."
,"142":"Tu justicia es la justicia definitiva, y tu ley es la verdad."
,"143":"Me aplasta la angustia y la opresión, pero tus mandamientos hacen mis delicias;"
,"144":"tus decretos son la justicia definitiva, hazme inteligente y viviré."
,"145":"Te llamo con todo el corazón; respóndeme, Señor, pues quiero guardar todos tus decretos;"
,"146":"yo te llamo; sálvame, y guardaré tus decretos."
,"147":"Me levanto al alba para pedirte ayuda, espero en tus palabras;"
,"148":"antes de la hora ya abro yo mis ojos,para meditar en tu promesa."
,"149":"Por tu amor, Señor, oye mi voz, y haz que viva conforme a tu justicia."
,"150":"Se acercan los que cruelmente me persiguen, los que están muy lejos de tu ley;"
,"151":"pero tú estás cerca, Señor, y todos tus mandamientos son la verdad misma;"
,"152":"desde hace mucho sé que tus decretos,los has establecido para siempre."
,"153":"Mira mi miseria y sálvame, pues yo no me he olvidado de tu ley;"
,"154":"defiende tú mi causa y líbrame, y haz que viva conforme a tu promesa;"
,"155":"la salvación está lejos de los opresores, pues ellos no buscan tus decretos."
,"156":"Tu amor, Señor, es infinito, haz que viva conforme a tu justicia."
,"157":"Muchos son mis perseguidores y opresores, pues ellos no buscan tus decretos;"
,"158":"no puedo soportar a los traidores, pues ellos no guardan tu palabra."
,"159":"Mira cómo amo tus preceptos, Señor; por tu amor, dame la vida."
,"160":"La esencia de tu palabra es la verdad, tus justas leyes son definitivas."
,"161":"Los poderosos me persiguen sin razón, pero mi corazón acata tu palabra."
,"162":"Yo me siento feliz con tu promesa, como el que encuentra un gran botín."
,"163":"Detesto y aborrezco la mentira, pero amo tu ley."
,"164":"Yo te alabo siete veces cada día,porque tus justas leyes son definitivas."
,"165":"Grande es la paz de los amantes de tu ley, nada los puede hacer caer."
,"166":"Señor, yo espero que me salves, pues he puesto en práctica todos tus mandamientos;"
,"167":"yo guardo todos tus decretos,y los amo ardientemente;"
,"168":"guardo tus preceptos y tus órdenes, tú conoces toda mi conducta."
,"169":"Que mi grito llegue hasta ti, Señor, por tu palabra dame inteligencia;"
,"170":"que mi súplica llegue a tu presencia, líbrame conforme a tu palabra;"
,"171":"que mis labios publiquen tu alabanza, pues tú me enseñas tus decretos;"
,"172":"que mis labios canten tu promesa, pues todos tus mandamientos son la justicia misma."
,"173":"Que tu mano venga en mi socorro, pues he preferido tus preceptos;"
,"174":"Señor, espero que me salves, pues tu ley hace mis delicias."
,"175":"Que yo pueda vivir para alabarte, que tu justicia me proteja."
,"176":"Ando errante como oveja perdida; búscame, pues no me he olvidado de tus mandamientos."
}`)
	CurrentBook.AddChapter(120, `{
"1":"Canción de las subidas,En mi angustia grité al Señor, y él me respondió:"
,"2":"'Señor, líbrame de los labios mentirosos,y de la lengua falsa'."
,"3":"¿Qué te va a dar Dios,o qué te va a añadir, oh lengua falsa?"
,"4":"Flechas afiladas de guerrero,y brasas de retama."
,"5":"¡Ay de mí, que he tenido que emigrar a Mésec, y habitar en la tienda de Cedar!"
,"6":"He vivido demasiado tiempo,con gente enemiga de la paz;"
,"7":"yo soy la paz; pero si hablo, ellos son la guerra."
}`)
	CurrentBook.AddChapter(121, `{
"1":"Canción de las subidas,Alzo mis ojos a los montes: ¿de dónde me vendrá mi auxilio?"
,"2":"El auxilio me viene del Señor, que hizo el cielo y la tierra."
,"3":"Él no permitirá que tropiece tu pie, ni que se duerma tu guardián;"
,"4":"no, no duerme ni dormita,el guardián de Israel."
,"5":"El Señor es tu guardián, el Señor es tu sombra, él está a tu derecha."
,"6":"El sol no te molestará de día, ni la luna de noche."
,"7":"El Señor te guardará de todo mal, él guardará tu vida;"
,"8":"guardará tu partida y tu regreso, desde ahora y por siempre."
}`)
	CurrentBook.AddChapter(122, `{
"1":"Canción de las subidas. De David,¡Qué alegría cuando me dijeron: 'Vamos a la casa del Señor'!"
,"2":"Ya estamos en tus puertas, oh Jerusalén:"
,"3":"Jerusalén, la bien edificada, la ciudad bien unida."
,"4":"Allí suben las tribus, las tribus del Señor, según la norma de Israel, para alabar el nombre del Señor."
,"5":"Allí están los tribunales de justicia, los tribunales de la casa de David."
,"6":"Pedid la paz para Jerusalén: 'Que vivan tranquilos tus amigos,"
,"7":"que reine la paz dentro de tus muros,y la tranquilidad en tus palacios'."
,"8":"Por mis hermanos y compañeros, diré: 'La paz esté contigo'."
,"9":"Por la casa del Señor, nuestro Dios, te deseo la felicidad."
}`)
	CurrentBook.AddChapter(123, `{
"1":"Canción de las subidas,A ti levanto mis ojos, a ti que habitas en el cielo."
,"2":"Como están los ojos del esclavo fijos en su señor, como están los ojos de la esclava fijos en su señora, así están nuestros ojos fijos en el Señor, nuestro Dios, hasta que se compadezca de nosotros."
,"3":"Ten piedad de nosotros, Señor, ten piedad de nosotros, que estamos hartos de tanto desprecio;"
,"4":"estamos hartos de las burlas de los ricos,y del desprecio de los orgullosos."
}`)
	CurrentBook.AddChapter(124, `{
"1":"Canción de las subidas. De David,Si el Señor no hubiera estado de nuestra parte,-que lo diga la casa de Israel-,"
,"2":"si el Señor no hubiera estado de nuestra parte,cuando se lanzaban los hombres contra nosotros,"
,"3":"nos habrían tragado vivos,en el fuego de su cólera;"
,"4":"nos habrían anegado las aguas, el torrente habría pasado por encima de nosotros;"
,"5":"habrían pasado sobre nosotros las olas turbulentas."
,"6":"Bendito sea el Señor, que no hizo de nosotros la presa de sus dientes:"
,"7":"como un pájaro, logramos escapar de la red de los pajareros; la red se rompió y logramos escapar."
,"8":"Nuestro auxilio está en el nombre del Señor, que hizo el cielo y la tierra."
}`)
	CurrentBook.AddChapter(125, `{
"1":"Canción de las subidas,Los que confían en el Señor,son como el monte Sión, que es inconmovible y estable para siempre."
,"2":"Jerusalén está rodeada de montes; así rodea el Señor a su pueblo,desde ahora y por siempre."
,"3":"Un cetro criminal no pesará nunca,sobre el dominio de los justos, para que los justos no tiendan sus manos hacia el crimen."
,"4":"Haz bien, Señor, a los hombres de bien, a los hombres de recto corazón,"
,"5":"pero a los desviados por senderos tortuosos,hazles correr la suerte de los criminales. Paz a Israel."
}`)
	CurrentBook.AddChapter(126, `{
"1":"Canción de las subidas,Cuando el Señor repatrió a los prisioneros de Sión, nos parecía que estábamos soñando."
,"2":"Nuestra boca se nos llenó de risa,y nuestra lengua de cantares. Entonces se decía entre las gentes: 'El Señor ha hecho por ellos grandes cosas'."
,"3":"El Señor ha hecho por nosotros grandes cosas, y estamos alegres."
,"4":"Señor, haz volver a nuestros prisioneros,como torrentes en el Negueb."
,"5":"Los que siembran con lágrimas, cosecharán entre cantares;"
,"6":"van, sí, llorando van al llevar la semilla; mas volverán, cantando volverán trayendo sus gavillas."
}`)
	CurrentBook.AddChapter(127, `{
"1":"Canción de las subidas. De Salomón,Si el Señor no construye la casa, en vano trabajan los que la construyen; si el Señor no guarda la ciudad, en vano vigila el centinela."
,"2":"De nada os sirve levantaros pronto, acostaros tarde y comer el pan ganado con sudores, cuando Dios se lo da a sus amigos aunque duerman."
,"3":"Los hijos son un regalo del Señor; el fruto de las entrañas, una recompensa."
,"4":"Como flechas en manos del guerrero, así son los hijos de la juventud;"
,"5":"dichoso el que llenó de ellos su aljaba, no será avergonzado cuando entre en pleito,con sus enemigos en la plaza."
}`)
	CurrentBook.AddChapter(128, `{
"1":"Canción de las subidas,Dichosos los que temen al Señor,y siguen sus caminos."
,"2":"Comerás del trabajo de tus manos, serás feliz y todo te irá bien."
,"3":"Tu esposa será como parra fecunda,en la intimidad de tu casa; tus hijos, como brotes de olivo,en torno a tu mesa."
,"4":"Así es bendecido el hombre que teme al Señor."
,"5":"Que el Señor te bendiga desde Sión,para que veas la prosperidad de Jerusalén,todos los días de tu vida"
,"6":"y a los hijos de tus hijos. ¡Paz a Israel!"
}`)
	CurrentBook.AddChapter(129, `{
"1":"Canción de las subidas,Mucho me han atacado desde mi juventud,-que lo diga Israel-,"
,"2":"mucho me han atacado desde mi juventud, pero no me han vencido."
,"3":"Los labradores araron sobre mis espaldas,y abrieron largos surcos,"
,"4":"pero el Señor es justo,y rompió las coyundas de los opresores."
,"5":"Que sean avergonzados,y huyan los enemigos de Sión;"
,"6":"que sean como la hierba del tejado,que se seca antes de arrancarla,"
,"7":"de la que el segador no llena su mano,ni el que agavilla hace una brazada."
,"8":"Los que pasan nos dicen: 'Que el Señor os bendiga'. Os bendecimos en el nombre del Señor."
}`)
	CurrentBook.AddChapter(130, `{
"1":"Canción de las subidas,Desde lo más profundo clamo a ti, Señor;"
,"2":"Señor, escucha mi clamor, estén tus oídos atentos al grito de mi súplica."
,"3":"Si tienes en cuenta nuestros delitos, ¿quién podrá resistir, Señor?"
,"4":"Pero en ti encontramos el perdón, por eso eres temido."
,"5":"Yo espero con toda el alma en el Señor, confío en su palabra;"
,"6":"estoy pendiente del Señor,más que los centinelas de la aurora."
,"7":"Israel está pendiente del Señor,más que los centinelas de la aurora; porque en el Señor está el amor y la liberación total:"
,"8":"él redimirá a Israel de todos sus delitos."
}`)
	CurrentBook.AddChapter(131, `{
"1":"Canción de las subidas. De David,Señor, mi corazón no es orgulloso,ni mis ojos altaneros: no voy buscando grandezas,ni cosas que me vienen anchas;"
,"2":"no, yo estoy muy tranquilo,y muy callado como un niño,en el regazo de su madre; mis deseos son parecidos a ese niño."
,"3":"Israel, espera en el Señor,desde ahora y por siempre."
}`)
	CurrentBook.AddChapter(132, `{
"1":"Canción de las subidas,Señor, acuérdate de David,y de todos sus trabajos,"
,"2":"de que hizo al Señor este juramento,y este voto al fuerte de Jacob:"
,"3":"'No entraré en mi casa, no me iré a la cama para descansar,"
,"4":"no concederé sueño a mis ojos,ni quietud a mis párpados"
,"5":"mientras no encuentre un lugar para el Señor, una morada para el fuerte de Jacob'."
,"6":"Oímos decir que estaba en Éfrata, la hemos encontrado en los campos de Yaar."
,"7":"Vamos a su morada, postrémonos ante el estrado de sus pies."
,"8":"Levántate, Señor, ven al lugar de tu reposo tú,y el arca donde reside tu poder;"
,"9":"que tus sacerdotes se revistan de justicia,y griten de júbilo tus fieles."
,"10":"Por amor a tu siervo David,no rechaces el rostro de tu consagrado."
,"11":"El Señor ha jurado a David, promesa firme de la que no se vuelve atrás: 'Pondré en tu trono a un descendiente tuyo."
,"12":"Si tus hijos guardan mi alianza,y los preceptos que voy a enseñarles, también sus hijos se sentarán siempre en tu trono'."
,"13":"Porque el Señor ha escogido a Sión, la ha elegido para su residencia:"
,"14":"'Éste será siempre mi lugar de reposo, aquí residiré, aquí me gusta estar."
,"15":"Bendeciré con generosidad sus provisiones,y a sus pobres los hartaré de pan;"
,"16":"revestiré de salvación a sus sacerdotes,y sus fieles saltarán de gozo."
,"17":"Aquí suscitaré a David un vástago,y prepararé una lámpara para mi consagrado."
,"18":"Vestiré de ignominia a sus enemigos, mientras que sobre su cabeza brillará su corona'."
}`)
	CurrentBook.AddChapter(133, `{
"1":"Canción de las subidas. De David,Ved qué hermosura y qué felicidad,el que los hermanos vivan siempre unidos."
,"2":"Es como un perfume fino en la cabeza, que baja por la barba, por la barba de Aarón, y llega hasta la orla de su manto."
,"3":"Es como el rocío del Hermón,que baja por las montañas de Sión. Allí manda el Señor la bendición, la vida para siempre."
}`)
	CurrentBook.AddChapter(134, `{
"1":"Canción de las subidas,¡Ea! Bendecid al Señor todos los siervos del Señor, los que pasáis las noches en la casa del Señor;"
,"2":"levantad vuestras manos hacia el santuario, bendecid al Señor."
,"3":"Que el Señor te bendiga desde Sión, el creador del cielo y de la tierra."
}`)
	CurrentBook.AddChapter(135, `{
"1":"Canción de las subidas,¡Aleluya!,Alabad el nombre del Señor; alabadlo, siervos del Señor,"
,"2":"que estáis en la casa del Señor, en los atrios de la casa de nuestro Dios."
,"3":"Alabad al Señor porque es bueno, cantad himnos a su nombre, porque es amable."
,"4":"Porque el Señor ha escogido a Jacob,y ha hecho de Israel su propiedad."
,"5":"Yo sé muy bien que el Señor es grande, nuestro Señor, más que todos los dioses."
,"6":"El Señor hace todo lo que quiere en el cielo,y en la tierra, en el mar y en todos los abismos."
,"7":"Hace subir las nubes desde los confines de la tierra, abre con los relámpagos la lluvia, saca de sus depósitos al viento."
,"8":"Hirió de muerte a los primogénitos de Egipto, hombres y ganados."
,"9":"Hizo en Egipto señales y prodigios,contra el Faraón y todos sus ministros."
,"10":"Desbarató a naciones poderosas, dio muerte a reyes poderosos:"
,"11":"a Sijón, rey de los amorreos; a Og, rey de Basán, y a todos los reyes de Canaán;"
,"12":"y dio sus tierras en herencia, en herencia a su pueblo, Israel."
,"13":"Señor, tu nombre dura eternamente, y tu memoria, Señor, de edad en edad."
,"14":"Porque el Señor hace justicia a su pueblo,y se compadece de sus siervos."
,"15":"Los ídolos de las gentes son plata y oro, hechura de las manos de los hombres;"
,"16":"tienen boca y no hablan, tienen ojos y no ven,"
,"17":"tienen oídos y no oyen, no hay aliento en su boca."
,"18":"Que sean como ellos los que los hicieron, los que confían en ellos."
,"19":"Casa de Israel, bendecid al Señor; casa de Aarón, bendecid al Señor;"
,"20":"casa de Leví, bendecid al Señor; fieles del Señor, bendecid al Señor."
,"21":"Bendito sea desde Sión el Señor, que habita en Jerusalén. ¡Aleluya!"
}`)
	CurrentBook.AddChapter(136, `{
"1":"Dad gracias al Señor, porque es bueno, porque es eterno su amor;"
,"2":"dad gracias al Dios de los dioses, porque es eterno su amor;"
,"3":"dad gracias al Señor de los señores, porque es eterno su amor."
,"4":"Sólo él ha hecho grandes maravillas, porque es eterno su amor."
,"5":"Él hizo los cielos con sabiduría, porque es eterno su amor."
,"6":"Él afirmó la tierra sobre las aguas, porque es eterno su amor."
,"7":"Él hizo las lumbreras grandes, porque es eterno su amor:"
,"8":"el sol para presidir el día, porque es eterno su amor;"
,"9":"la luna y las estrellas para presidir la noche, porque es eterno su amor."
,"10":"Él hirió de muerte a los primogénitos de Egipto, porque es eterno su amor:"
,"11":"sacó de allí a Israel, porque es eterno su amor;"
,"12":"con brazo extendido y mano fuerte,porque es eterno su amor."
,"13":"Él dividió en dos partes el mar Rojo, porque es eterno su amor;"
,"14":"e hizo que Israel pasara por en medio, porque es eterno su amor;"
,"15":"él hundió en el mar Rojo al Faraón y a su ejército, porque es eterno su amor."
,"16":"Él guió a su pueblo a través del desierto, porque es eterno su amor;"
,"17":"hirió de muerte a grandes reyes, porque es eterno su amor;"
,"18":"quitó la vida a reyes poderosos, porque es eterno su amor;"
,"19":"a Sijón, rey de los amorreos, porque es eterno su amor;"
,"20":"y a Og, rey de Basán, porque es eterno su amor;"
,"21":"y dio sus tierras en herencia, porque es eterno su amor;"
,"22":"en herencia a su siervo Israel, porque es eterno su amor."
,"23":"Él se acordó de nosotros en nuestra humillación, porque es eterno su amor;"
,"24":"y nos libró de nuestros enemigos, porque es eterno su amor."
,"25":"Él da de comer a todas las criaturas, porque es eterno su amor."
,"26":"Dad gracias al Dios del cielo, porque es eterno su amor."
}`)
	CurrentBook.AddChapter(137, `{
"1":"Junto a los ríos de Babilonia nos sentábamos,y llorábamos al acordarnos de Sión."
,"2":"En los sauces de al lado,teníamos colgadas nuestras cítaras."
,"3":"Allí nuestros carceleros nos pedían cánticos,y nuestros verdugos alegría: 'Cantadnos algún cántico de Sión'."
,"4":"¿Cómo íbamos a cantar un cántico del Señor,en país extranjero?"
,"5":"Jerusalén, si me olvido de ti, que mi mano derecha se me seque;"
,"6":"que mi lengua se me pegue al paladar, si no me acuerdo de ti, si no pongo a Jerusalén,por encima de mi propia alegría."
,"7":"Acuérdate, Señor, contra los edomitas, que decían el día de Jerusalén: 'Destruidla, destruidla hasta sus cimientos'."
,"8":"Babilonia, devastadora, dichoso el que te devuelva el mal que nos hiciste;"
,"9":"dichoso el que agarre a tus niños,y los estrelle contra las rocas."
}`)
	CurrentBook.AddChapter(138, `{
"1":"De David,Te doy gracias, Señor, de todo corazón, frente a los dioses cantaré para ti."
,"2":"Yo me postro hacia tu santo templo, doy gracias a tu nombre por tu amor y tu verdad, pues tus promesas superan tu renombre."
,"3":"El día que te llamé, tú me respondiste y me diste valor."
,"4":"Que te den gracias, Señor, todos los reyes de la tierra, cuando escuchen las palabras de tu boca;"
,"5":"que ensalcen los caminos del Señor: '¡Qué grande es la gloria del Señor!'."
,"6":"Aunque es excelso, el Señor se fija en el humilde, pero conoce desde lejos al soberbio."
,"7":"Cuando estoy en peligro, tú me sacas con vida; das a mis enemigos un puñetazo en las narices,y tu diestra me salva."
,"8":"El Señor lo hará todo por mí. Señor, tu amor es eterno, no abandones la obra de tus manos."
}`)
	CurrentBook.AddChapter(139, `{
"1":"Al maestro de coro. Salmo de David,Señor, tú me has examinado y me conoces;"
,"2":"sabes cuándo me acuesto y cuándo me levanto, desde lejos te das cuenta de mis pensamientos;"
,"3":"tú ves mi caminar y mi descanso, te son familiares todos mis caminos;"
,"4":"no está todavía la palabra en mi lengua y ya, Señor, tú la conoces por entero."
,"5":"Tú me envuelves por detrás y por delante, y tienes puesta tu mano sobre mí."
,"6":"Tu sabiduría es un misterio para mí, es tan sublime que no puedo comprenderla."
,"7":"¿A dónde podría ir lejos de tu espíritu, a dónde podría huir lejos de tu presencia?"
,"8":"Si subo hasta los cielos, allí te encuentras tú; si bajo a los abismos, allí estás presente;"
,"9":"si vuelo hasta el origen de la aurora, si me voy a lo último del mar,"
,"10":"también allí tu mano me retiene,y tu diestra me agarra."
,"11":"Si digo: 'Las tinieblas me envuelven,y la luz se ha hecho noche en torno a mí',"
,"12":"tampoco las tinieblas son tinieblas para ti, ante ti la noche brilla como el día."
,"13":"Porque tú formaste mis entrañas, tú me tejiste en el vientre de mi madre."
,"14":"Confieso que soy una obra prodigiosa, pues todas tus obras son maravillosas; de ello estoy bien convencido."
,"15":"Mis huesos no se te ocultaban,cuando yo era formado en el secreto, tejido en lo profundo de la tierra;"
,"16":"tú me veías cuando era tan sólo un embrión, todos mis días estaban escritos en tu libro, mis días estaban escritos y contados,antes de que ninguno de ellos existiera."
,"17":"Oh Dios, ¡qué difíciles son para mí tus pensamientos, qué grande es el número de ellos!"
,"18":"Si los cuento, son más numerosos que la arena; si logro terminar, aún estoy contigo."
,"19":"Oh Dios, ¡ojalá mataras a los criminales; aleja de mí a los asesinos!"
,"20":"Ellos dicen de ti cosas inicuas, pero en vano se levantan contra ti."
,"21":"Oh Señor, ¿no odio a los que te odian?, ¿no aborrezco a los que se rebelan contra ti?"
,"22":"Los odio con un odio implacable,y son mis propios enemigos."
,"23":"Examíname, Señor, y reconoce mi interior, explórame y conoce mis pensamientos;"
,"24":"mira si voy por mal camino,y guíame por el camino eterno."
}`)
	CurrentBook.AddChapter(140, `{
"1":"Al maestro de coro. Salmo de David"
,"2":"Líbrame, Señor, de los criminales, guárdame de los hombres que ejercen la violencia,"
,"3":"de los que en su corazón urden la maldad,y provocan peleas todos los días,"
,"4":"aguzan su lengua como las serpientes, veneno de víbora tienen en sus labios."
,"5":"Líbrame, Señor, de las manos de los criminales, guárdame de los hombres que ejercen la violencia, que proyectan mi caída;"
,"6":"los orgullosos me ponen trampas, me tienden una red,y emplazan cepos a lo largo del camino."
,"7":"Yo digo al Señor: 'Tú eres mi Dios'; escucha, Señor, la voz de mi plegaria."
,"8":"Oh Señor, Señor mío, la fuerza que me salva, tú cubres mi cabeza el día del combate."
,"9":"No consientas, Señor, el plan de los malvados, no permitas que triunfen sus proyectos contra mí."
,"10":"Los que me rodean alzan la cabeza; que los ahogue la malicia de sus labios,"
,"11":"que lluevan sobre ellos carbones encendidos, que se hundan en el abismo y ya no se levanten;"
,"12":"que no quede un calumniador en el país,y la desgracia lleve al violento a la ruina."
,"13":"Yo sé que el Señor hará justicia a los humildes,y defenderá el derecho de los pobres."
,"14":"Los que practican la justicia alabarán tu nombre, los que practican el derecho vivirán a tu lado."
}`)
	CurrentBook.AddChapter(141, `{
"1":"Salmo de David,Señor, te estoy llamando, ven corriendo, escucha mi voz cuando te llamo;"
,"2":"que mi oración sea como incienso en tu presencia, y mis manos alzadas, la ofrenda de la tarde."
,"3":"Pon, Señor, en mi boca un centinela, un guardia en la puerta de mis labios;"
,"4":"no inclines mi corazón a la maldad, a cometer delitos con los criminales; que no participe nunca en sus banquetes;"
,"5":"que me hiera un justo, que un hombre piadoso me reprenda, pero que la fragancia del criminal,jamás perfume mi cabeza; pues a sus crímenes yo opondré siempre mi oración."
,"6":"Sus jueces serán precipitados por un despeñadero, entonces comprenderán qué dulces eran mis palabras;"
,"7":"como se abren surcos en la tierra, serán esparcidos sus huesos en la boca del abismo."
,"8":"Señor, Señor, hacia ti vuelvo mis ojos, en ti me refugio, no me rechaces;"
,"9":"guárdame del lazo que me tienden,y de las insidias de los criminales;"
,"10":"los criminales caerán todos juntos en sus trampas, mientras que yo pasaré incólume."
}`)
	CurrentBook.AddChapter(142, `{
"1":"Maskil de David. Cuando estaba en la cueva. Salmo"
,"2":"Yo llamo al Señor a voz en grito, a voz en grito yo suplico al Señor;"
,"3":"ante él derramo mi lamento, ante él expongo mi angustia."
,"4":"Cuando estoy deprimido, tú sabes dónde voy. En mi camino me han escondido un lazo."
,"5":"Si miro a la derecha, nadie viene en mi ayuda; no encuentro refugio, nadie se preocupa de mí."
,"6":"Yo te grito, Señor: 'Tú eres mi refugio, tú eres todo lo que tengo en esta vida'."
,"7":"Atiende a mi clamor, pues soy un desgraciado; líbrame de mis perseguidores, que son más fuertes que yo;"
,"8":"sácame de la cárcel, y te estaré muy agradecido: los justos me rodearán cuando me otorgues tu favor."
}`)
	CurrentBook.AddChapter(143, `{
"1":"Salmo de David,Señor, escucha mi oración, presta oídos a mis súplicas; por tu fidelidad y tu justicia, respóndeme."
,"2":"No entables juicio contra mí, pues ante ti ningún viviente es justo."
,"3":"Mis enemigos me atacan,y me arrastran por el suelo, me encierran en estancias tenebrosas, como a aquellos que murieron hace tiempo."
,"4":"Se me apaga el aliento,y dentro el corazón se me consume."
,"5":"Me acuerdo de los tiempos pasados, medito en tus acciones,y reflexiono en las obras de tus manos,"
,"6":"tiendo mis manos hacia ti; sediento estoy de ti como una tierra seca."
,"7":"Date prisa, Señor, respóndeme, que me falta el aliento; no me escondas tu rostro, como a los que bajan a la tumba."
,"8":"Hazme sentir tu amor por la mañana, pues confío en ti; enséñame el camino que tengo que seguir, pues me dirijo a ti;"
,"9":"líbrame, Señor, de mis enemigos, pues me cobijo en ti;"
,"10":"enséñame a cumplir tu voluntad, pues tú eres mi Dios; tu espíritu bueno me conduzca por una tierra llana."
,"11":"Por amor a tu nombre, Señor, dame la vida; porque haces justicia, sácame de este aprieto;"
,"12":"por tu amor, aniquila a mis enemigos, destruye a mis opresores, pues yo soy tu siervo."
}`)
	CurrentBook.AddChapter(144, `{
"1":"De David,Bendito sea el Señor, mi roca, que adiestra mis manos para la batalla,y mis puños para el combate;"
,"2":"mi amor, mi fortaleza, mi ciudadela y mi libertador, el escudo con el que me protejo, el que somete a los pueblos bajo mi poder."
,"3":"Señor, ¿qué es el hombre para que te cuides de él, este mortal para que en él pienses?"
,"4":"El hombre es como un soplo, sus días como sombra que pasa."
,"5":"Señor, despliega los cielos y desciende, toca los montes para que echen humo;"
,"6":"haz estallar el rayo y dispérsalos, lanza tus saetas y destrúyelos."
,"7":"Extiende tu mano desde lo alto y sálvame, líbrame de las aguas torrenciales, de la mano de una raza extranjera,"
,"8":"cuya boca dice falsedades,y cuya diestra jura en falso."
,"9":"Oh Dios, voy a cantarte un cantar nuevo, a tocar para ti la lira de diez cuerdas."
,"10":"Tú das a los reyes la victoria, tú salvas a tu siervo David de la espada mortal."
,"11":"Sálvame y líbrame de las manos,de una raza extranjera, cuya boca dice falsedades,y cuya diestra jura en falso."
,"12":"Que nuestros hijos sean en su juventud,como plantas frondosas, y nuestras hijas como cariátides, modelos de palacios;"
,"13":"que nuestros graneros estén llenos, rebosantes de frutas de todas las especies; que nuestros rebaños se multipliquen a millares, a miles y miles por nuestras praderías;"
,"14":"que nuestros bueyes vengan bien cargados, que no haya brechas ni fugas, ni gritos de alarma en nuestras plazas."
,"15":"Dichoso el pueblo que tiene todo esto, dichoso el pueblo cuyo Dios es el Señor."
}`)
	CurrentBook.AddChapter(145, `{
"1":"Himno de David,Te ensalzaré, rey mío y Dios mío, bendeciré tu nombre por siempre jamás;"
,"2":"todos los días te bendeciré, alabaré tu nombre por siempre jamás."
,"3":"Dios es grande y digno de alabanza, no tiene medida su grandeza."
,"4":"Una generación ponderará tus obras a la otra, proclamarán tus proezas;"
,"5":"hablarán del esplendor de tu gloriosa majestad, contarán tus milagros;"
,"6":"publicarán el poder de tus prodigios,y pregonarán tus grandezas;"
,"7":"divulgarán el recuerdo de tu inmensa bondad, aclamarán tu justicia."
,"8":"El Señor es tierno y compasivo, paciente y lleno de bondad;"
,"9":"el Señor es bueno con todos, lleno de ternura con todas sus obras."
,"10":"Te alabarán, Señor, todas tus obras, y tus fieles te bendecirán;"
,"11":"anunciarán la gloria de tu reino,y hablarán de tus proezas,"
,"12":"explicando a los hombres tus proezas,y la gloria deslumbrante de tu reino."
,"13":"Tu reino es un reino eterno,y tu imperio dura por todas las edades. El Señor es fiel a su palabra, leal en todas sus acciones."
,"14":"El Señor sostiene a todos los que caen, endereza a los que están doblados."
,"15":"Los ojos de todos están fijos en ti,y tú les das a su tiempo la comida;"
,"16":"abres la mano y sacias a placer,a todos los vivientes."
,"17":"El Señor es justo en todos sus caminos, leal en todas sus acciones;"
,"18":"el Señor está cerca de los que lo invocan, de los que lo invocan con sinceridad."
,"19":"Él cumple los deseos de sus fieles, escucha su clamor y los libera;"
,"20":"el Señor guarda a todos sus amigos, y extermina a todos los malvados."
,"21":"Mi boca dirá la alabanza del Señor, todos los muertos bendecirán su santo nombre,por siempre jamás."
}`)
	CurrentBook.AddChapter(146, `{
"1":"¡Aleluya!,Alaba, alma mía, al Señor."
,"2":"Alabaré al Señor mientras viva, cantaré himnos al Señor mientras exista."
,"3":"No confiéis en los príncipes, ni en los humanos incapaces de salvar:"
,"4":"exhalan el aliento y retornan al polvo, y ese día se malogran todos sus proyectos."
,"5":"Dichoso el que tiene su ayuda en el Dios de Jacob, y su esperanza en el Señor, su Dios,"
,"6":"que hizo los cielos y la tierra, el mar,y todo lo que contienen; que guarda lealtad eternamente;"
,"7":"que hace justicia a los oprimidos,y da pan a los hambrientos. El Señor da la libertad a los presos,"
,"8":"el Señor da la vista a los ciegos, el Señor endereza a los que están doblados, el Señor ama a los que practican la justicia,"
,"9":"el Señor protege a los emigrantes, sostiene a las viudas y a los huérfanos,y tuerce el camino de los malhechores."
,"10":"El Señor reinará eternamente; él es tu Dios, Sión, por todas las edades."
}`)
	CurrentBook.AddChapter(147, `{
"1":"¡Qué bueno es cantar para el Señor!, ¡qué agradable alabar a nuestro Dios!"
,"2":"El Señor reconstruye Jerusalén,y reúne a los dispersos de Israel,"
,"3":"él cura los corazones rotos,y venda sus heridas."
,"4":"Él cuenta el número de las estrellas,y llama a cada una por su nombre."
,"5":"Nuestro Señor es grande y todopoderoso, su inteligencia es infinita."
,"6":"El Señor sostiene a los humildes,y humilla hasta el polvo a los malvados."
,"7":"Cantad al Señor la acción de gracias, tocad el arpa para nuestro Dios."
,"8":"Él cubre de nubes el cielo, prepara la lluvia para la tierra,y hace brotar hierba en los montes;"
,"9":"él da el alimento a los ganados,y a las crías del cuervo cuando chillan."
,"10":"No tiene en cuenta el brío del caballo,ni se complace en los músculos del hombre;"
,"11":"el Señor se complace en sus amigos, en aquellos que confían en su amor."
,"12":"Glorifica al Señor, Jerusalén; alaba a tu Dios, Sión."
,"13":"Él reforzó los cerrojos de tus puertas,y bendijo a tus hijos dentro de tus murallas;"
,"14":"hace reinar la paz en tus fronteras,y te sacia con la flor del trigo;"
,"15":"envía sus órdenes a la tierra,y su palabra corre velozmente;"
,"16":"manda la nieve como lana, esparce la escarcha cual ceniza;"
,"17":"arroja sus granizos como migas de pan,y con el frío las aguas se congelan;"
,"18":"envía su palabra y las derrite, hace soplar el viento,y las aguas vuelven a correr."
,"19":"Él anuncia su palabra a Jacob, sus leyes y sus decretos a Israel."
,"20":"Esto no lo ha hecho con ningún otro pueblo, no les dio a conocer sus mandamientos. ¡Aleluya!"
}`)
	CurrentBook.AddChapter(148, `{
"1":"¡Aleluya!,Alabad al Señor desde los cielos, alabadlo en las alturas;"
,"2":"alabadlo, todos sus ángeles; alabadlo, todos sus ejércitos;"
,"3":"alabadlo, sol y luna, alabadlo, todas las estrellas luminosas;"
,"4":"alabadlo, cielos de los cielos y aguas,que estáis por encima de los cielos;"
,"5":"alaben el nombre del Señor, porque él lo mandó y fueron creados;"
,"6":"él los fijó para siempre jamás, puso unas leyes que nunca cambiarán."
,"7":"Alabad al Señor desde la tierra, monstruos marinos y todos los abismos,"
,"8":"fuego y granizo, nieve y bruma, viento de tempestad que ejecuta sus órdenes,"
,"9":"montañas y todas las colinas, árboles frutales y todos los cedros,"
,"10":"bestias salvajes y todos los ganados, reptiles y pájaros que vuelan,"
,"11":"reyes del mundo y pueblos todos, príncipes y todos los jueces de la tierra,"
,"12":"jóvenes y también doncellas, los viejos a una con los niños;"
,"13":"que todos alaben el nombre del Señor, porque su nombre es sublime, sólo él; su majestad domina los cielos y la tierra."
,"14":"Él ha realzado el poder de su pueblo, orgullo para todos sus amigos, para Israel, su pueblo íntimo. ¡Aleluya!"
}`)
	CurrentBook.AddChapter(149, `{
"1":"¡Aleluya!,Cantad al Señor un cántico nuevo, cantad su alabanza en la asamblea de los fieles."
,"2":"Que Israel se regocije en su hacedor, y los hijos de Sión festejen a su rey."
,"3":"Alaben su nombre con la danza, toquen para él el tambor y la cítara,"
,"4":"porque el Señor ama a su pueblo,y corona de victoria a los humildes."
,"5":"Que los fieles se alegren de su gloria, y en sus lechos griten de alegría;"
,"6":"que ensalcen a Dios a voz en grito, teniendo empuñada la espada de dos filos"
,"7":"para tomar venganza de los pueblos,y castigar a las naciones,"
,"8":"para atar con cadenas a sus reyes,y con grillos de hierro a sus magnates,"
,"9":"para ejecutar contra ellos la sentencia escrita. Esto es un honor para todos sus amigos. ¡Aleluya!"
}`)
	CurrentBook.AddChapter(150, `{
"1":"¡Aleluya!,Alabad al Señor en su santuario, alabadlo en su majestuoso firmamento,"
,"2":"alabadlo por sus grandes hazañas, alabadlo por su inmensa grandeza,"
,"3":"alabadlo al son de las trompetas, alabadlo con la cítara y el arpa,"
,"4":"alabadlo con danzas y tambores, alabadlo con cuerdas y con flautas,"
,"5":"alabadlo con címbalos sonoros, alabadlo con címbalos vibrantes."
,"6":"Que alabe al Señor todo cuanto vive. ¡Aleluya!"
}`)

}
func ES_LSB_LoadVSSPChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Amad la justicia los que gobernáis la tierra, pensad del Señor con rectitud, buscadle con sencillez de corazón;"
,"2":"porque se deja hallar por los que no lo tientan, se manifiesta a los que de él no desconfían."
,"3":"Los pensamientos retorcidos alejan de Dios, y su poder, puesto a prueba, confunde a los imprudentes."
,"4":"Pues en el alma malévola no entra la sabiduría, ni habita en un cuerpo esclavo del pecado."
,"5":"Porque el santo espíritu que nos forma huye de la doblez, se aleja de los pensamientos insensatos,y se siente ultrajado si ocurre una injusticia."
,"6":"La sabiduría es un espíritu que ama a los hombres, pero no dejará impunes los labios blasfemos; pues Dios es testigo de sus interioridades, vigilante veraz de su corazón y oidor de su lengua."
,"7":"Porque el espíritu del Señor llena todo el orbe, y él, que todo lo abarca, todo lo conoce."
,"8":"Por eso el que diga palabras injustas,no pasará desapercibido, ni la justicia vengadora lo dejará escapar."
,"9":"Sobre las maquinaciones del malvado se hará investigación, y hasta el rumor de sus palabras llegará al Señor."
,"10":"Pues un oído celoso lo escucha todo, y no quedará oculto el rumor de sus murmuraciones."
,"11":"Guardaos, pues, de las murmuraciones vanas, preservad vuestra lengua de maledicencias, porque el dicho más secreto no deja de surtir efecto, y una boca mentirosa da muerte al alma."
,"12":"No corráis tras la muerte con los extravíos de vuestra vida, ni os atraigáis la ruina con las obras de vuestras manos."
,"13":"Que no fue Dios quien hizo la muerte, ni se goza con el exterminio de los vivientes."
,"14":"Pues todo lo creó para que perdurase, y saludables son las criaturas del mundo; no hay en ellas veneno exterminador, ni el imperio del abismo reina sobre la tierra."
,"15":"Porque la justicia es inmortal, pero la injusticia atrae la muerte."
,"16":"Los malvados llaman a la muerte con señas y palabras, la tienen por amiga y por ella perecen; con ella hacen pacto, porque merecen ser su posesión."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Dicen entre sí, calculando falsamente: 'Corta y triste es nuestra vida; para el fin del hombre no hay remedio, y no se conoce persona que se salve del abismo."
,"2":"Porque somos hijos del azar, y tras esto seremos como si no hubiésemos sido. Porque humo es la respiración de nuestras narices, y el pensamiento una centella del latido de nuestro corazón."
,"3":"Una vez extinguido, el cuerpo se torna ceniza, y el espíritu se desvanece como aire sutil."
,"4":"Nuestro nombre con el tiempo caerá en el olvido; nadie se acordará de nuestras obras. Como huella de nube pasará nuestra vida; se disipará como niebla perseguida por los rayos del sol, y por su calor abatida."
,"5":"Pues nuestra vida es el paso de una sombra, nuestro fin es sin retorno; porque se pone el sello y nadie vuelve."
,"6":"Gocemos, pues, de los bienes existentes, usemos de la creación como en la juventud, apresuradamente. "
,"7":"Llenémonos de vinos exquisitos y perfumes, y no dejemos pasar ni una flor de la primavera."
,"8":"Coronémonos de capullos de rosas antes que se marchiten."
,"9":"Que no faltemos ninguno a nuestra orgía; por todas partes dejemos señales de nuestro regocijo, pues ésta es nuestra herencia y nuestra suerte."
,"10":"Oprimamos al justo pobre, no perdonemos a la viuda,ni respetemos las añosas canas del anciano."
,"11":"Sea nuestra fuerza la norma de la justicia, porque lo débil está visto que es inútil."
,"12":"Acechemos al justo, pues nos fastidia; se opone a nuestras obras, nos echa en cara las infracciones de la ley,y nos acusa de traicionar nuestra educación."
,"13":"Presume de tener el conocimiento de Dios,y se tiene por hijo del Señor."
,"14":"Es un reproche para nuestros pensamientos, aun el verlo nos resulta molesto."
,"15":"Porque su vida no se parece en nada a la de los otros, y son muy distintos sus caminos."
,"16":"Somos para él como escoria, se aparta de nuestros caminos como si apestasen. Proclama feliz la suerte de los justos, y se gloría de tener a Dios por padre."
,"17":"Veamos la verdad de sus palabras,y probemos cuál será su fin."
,"18":"Porque si el justo realmente es hijo de Dios, él lo protegerá y lo librará de las manos de sus adversarios. "
,"19":"Probémoslo con ultrajes y tormentos, veamos su dulzura y pongamos a prueba su paciencia."
,"20":"Condenémoslo a una muerte infame, pues, según dice, habrá quien vele por él'."
,"21":"Así razonan, pero se engañan. Los ciega su maldad."
,"22":"No conocen los secretos de Dios, no esperan la recompensa de la santidad, ni creen en el premio de las almas intachables."
,"23":"Porque Dios creó al hombre para la incorrupción,y lo hizo a imagen de su propio ser."
,"24":"Mas por envidia del diablo entró la muerte en el mundo, y la experimentan los que le pertenecen."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Las almas de los justos están en las manos de Dios,y ningún tormento los alcanzará."
,"2":"A los ojos de los necios parecía que habían muerto,y su partida fue considerada como una desgracia;"
,"3":"su salida de entre nosotros, un desastre; pero ellos están en paz."
,"4":"Pues si en opinión de los hombres han sido castigados, su esperanza está rebosante de inmortalidad."
,"5":"Por una ligera pena recibirán grandes favores, porque Dios los probó y los encontró dignos de él."
,"6":"Los probó como oro en el crisol,y los aceptó como un sacrificio de holocausto."
,"7":"A la hora de su visita brillarán como chispa,que se propaga en los rastrojos."
,"8":"Juzgarán las naciones y dominarán sobre los pueblos, y el Señor reinará sobre ellos para siempre."
,"9":"Los que confían en él comprenderán la verdad,y los fieles permanecerán con él en el amor, pues para sus elegidos hay gracia y misericordia."
,"10":"Los malvados recibirán el castigo que merecen sus pensamientos,por haber despreciado al justo y apartarse del Señor."
,"11":"Desgraciado el que desprecia la sabiduría y la disciplina; vana es su esperanza, infructuoso su trabajo,e inútiles sus obras."
,"12":"Sus mujeres son insensatas, depravados sus hijos y maldita su posteridad. b) La carencia de hijos."
,"13":"Bendita la estéril sin tacha, que no conoció el lecho pecaminoso; será fecunda en la visita de las almas."
,"14":"Dichoso también el eunuco,cuyas manos no hicieron la maldad,y que no alimentó malos pensamientos contra el Señor, pues le será dado especial galardón por su fidelidad,y un puesto agradable en el templo del Señor."
,"15":"Porque glorioso es el fruto del trabajo honrado, y la raíz de la sabiduría es imperecedera."
,"16":"Los hijos de los adúlteros no prosperarán, y la descendencia de un lecho pecador desaparecerá."
,"17":"Aunque vivan muchos años serán tenidos como nada, y serán despreciados hasta el final de su vejez."
,"18":"Y si mueren temprano no tendrán esperanza,ni consuelo en el día de la sentencia, pues duro es el destino de la raza injusta."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Más vale no tener hijos y poseer la virtud, porque el recuerdo de la virtud es inmortal; Dios y los hombres la estiman igualmente."
,"2":"Presente, la imitan; ausente, suspiran por ella; en la eternidad, coronada, celebrará su triunfo, por haber vencido sin tacha en los combates."
,"3":"La turba prolífica de los malvados no prosperará; salida de retoños bastardos, no echará honda raíz ni tendrá suelo seguro."
,"4":"Aunque brotaran ramos verdes por algún tiempo, no estando ella bien afianzada en el suelo, será sacudida por el viento,y arrasada por la violencia del huracán."
,"5":"Se partirán sus ramas tiernas; su fruto inútil, verde para comerlo, no sirve para nada."
,"6":"Pues los hijos que nacen de uniones culpables,serán testigos de la maldad de sus padres cuando Dios los juzgue. c) La muerte temprana."
,"7":"Pero el justo, si muere prematuramente, descansará en paz."
,"8":"La vejez honorable no es la de largos días, ni se mide por el número de los años."
,"9":"La prudencia es la verdadera ancianidad, la vida intachable es la honrada vejez."
,"10":"Era agradable a Dios, y Dios lo amaba; vivía entre pecadores, y Dios se lo llevó."
,"11":"Se lo llevó para que la malicia no pervirtiera su mente,ni la perfidia sedujera su alma."
,"12":"La fascinación del vicio no deja ver el bien, el vértigo de la pasión pervierte el alma inocente."
,"13":"Llegado a la perfección en poco tiempo, llenó una larga vida."
,"14":"Como su alma era agradable al Señor, se apresuró a sacarlo de un medio corrompido. Las gentes lo ven, pero no lo comprenden,ni reflexionan sobre esto:"
,"15":"que para sus elegidos hay gracia y misericordia, y para sus santos protección."
,"16":"La muerte del justo condena la vida del malvado; la juventud tempranamente acabada, la larga vejez del injusto."
,"17":"Verán el fin del sabio, sin comprender los designios de Dios sobre él,ni por qué le puso el Señor en seguridad."
,"18":"Lo verán y se burlarán, pero el Señor se reirá de ellos."
,"19":"Pues, después de esto, serán un cadáver despreciable,y ludibrio para siempre entre los muertos. Porque los destrozará precipitándolos de cabeza y sin hablar; los arrancará de cuajo: serán totalmente asolados, sumergidos en la amargura y perecerá su memoria."
,"20":"Estarán espantados al rendir cuenta de sus delitos, sus crímenes se levantarán contra ellos para acusarlos."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Entonces el justo estará en pie con gran seguridad,frente a los que lo oprimieron y menospreciaron sus fatigas. "
,"2":"Temblarán con terrible espanto al verlo,salvo contra toda esperanza."
,"3":"Se dirán llenos de remordimientos,y gimiendo en el colmo de su angustia:"
,"4":"'Éste es aquel de quien nos burlábamos,y al que teníamos como objeto de irrisión. Necios nosotros, que tuvimos su vida por locura,y su fin por deshonra."
,"5":"¡Cómo fue contado entre los hijos de Dios,y participa de la suerte de los santos!"
,"6":"Nosotros perdimos el camino de la verdad, la luz de la justicia no nos alumbró,y el sol no se levantó para nosotros."
,"7":"Anduvimos hasta la saciedad,por los caminos de la injusticia y de la perdición, atravesamos desiertos intransitables; pero el camino del Señor no lo conocimos."
,"8":"¿De qué nos ha servido el orgullo?,¿De qué las riquezas de que presumíamos?"
,"9":"Todo aquello pasó como una sombra,y como un rumor fugitivo."
,"10":"Como nave que corta las aguas ondulantes, de cuyo paso es imposible encontrar rastro,ni sendero de su quilla entre las olas."
,"11":"O como ave que con su vuelo rasga la brisa, sin dejar vestigio alguno de su paso; que azota con el batir de sus alas el aire ligero,y lo corta con ímpetu veloz, abriéndose camino con sus raudas alas, y tras esto ni rastro queda de su paso."
,"12":"O como, tras una flecha lanzada hacia el blanco, el aire por ella hendido vuelve al instante a juntarse, hasta no poder ya conocerse su camino."
,"13":"Así nosotros; apenas nacidos, ya morimos sin dejar una huella de virtud,y consumidos en el vicio'."
,"14":"Pues la esperanza del malvado es como brizna que arrebata el viento, como niebla ligera en poder del huracán, como el humo disipado por el viento, como el recuerdo del huésped de un día."
,"15":"Los justos viven para siempre,y su recompensa está en el Señor; de ellos cuida el altísimo."
,"16":"Por eso alcanzarán el reino de la gloria,y la bellísima diadema de mano del Señor. Porque con la diestra los protegerá, y como un escudo los cubrirá su brazo."
,"17":"Tomará por armadura su celo vengador,y armará la creación para defensa contra los enemigos."
,"18":"Por coraza vestirá la justicia,y se pondrá por yelmo el juicio insobornable."
,"19":"Tomará por escudo su santidad invencible."
,"20":"Afilará la ira inexorable como espada, a su lado luchará el universo contra los insensatos."
,"21":"Saldrán certeras las saetas de los rayos de las nubes, como de arco bien tensado, y volarán al blanco."
,"22":"Y como por una ballesta serán lanzadas granizadas furibundas, el agua del mar se enfurecerá contra ellos,y los ríos los anegarán sin misericordia."
,"23":"Su soplo fortísimo los embestirá,y como huracán los aventará; la iniquidad hará un desierto de la tierra entera,y la maldad volcará los tronos de los poderosos."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Escuchad, pues, reyes, y entended; aprended los que regís los confines de la tierra."
,"2":"Prestad oído los que domináis a las masas, los que presumís de la multitud de vuestras gentes."
,"3":"Porque Dios os ha dado el poder y el altísimo la soberanía. Él juzgará vuestras obras y escudriñará vuestros designios. "
,"4":"Porque, ministros de su reino, no juzgasteis rectamente, no respetasteis la ley, ni actuasteis según la voluntad de Dios. "
,"5":"Terrible y repentino caerá sobre vosotros, porque se somete a juicio severo a los poderosos."
,"6":"El pequeño merece misericordia, pero a los poderosos se los examinará con rigor."
,"7":"Que el todopoderoso no se asusta de nadie, ni se inclina ante los grandes; porque él hizo al pequeño y al grande, y de todos cuida por igual."
,"8":"Pero a los poderosos una dura prueba les espera."
,"9":"A vosotros, pues, soberanos, van mis palabras, para que aprendáis sabiduría y no caigáis."
,"10":"Porque los que guardan santamente las leyes santas serán santificados; y quienes en ellas fueren instruidos encontrarán una defensa. "
,"11":"Sed ávidos, pues, de mis palabras; apetecedlas y seréis instruidos."
,"12":"Radiante e inmarcesible es la sabiduría; se deja ver fácilmente por los que la aman,y encontrar por quienes la buscan."
,"13":"Ella misma se adelanta,y se da a conocer a quienes la desean."
,"14":"El que madrugue para buscarla no se fatigará, pues la encontrará sentada a sus puertas."
,"15":"Porque pensar en ella es perfecta sabiduría, y el que se desvela por ella presto estará sin congoja."
,"16":"Pues va de un lado a otro buscando,a los que son dignos de ella,y se les aparece benigna en sus caminos, saliendo al encuentro de todos sus pensamientos."
,"17":"El principio de la sabiduría es el deseo sincero de ser instruido por ella. Querer instruirse es amarla."
,"18":"Desear ser instruido es amarla; amarla es guardar sus leyes; guardar sus leyes es asegurarse la incorrupción,"
,"19":"y la incorrupción nos acerca a Dios."
,"20":"Por tanto, el deseo de la sabiduría nos eleva al reino."
,"21":"Si, pues, os complacéis en los tronos y cetros, reyes de los pueblos, honrad la sabiduría para que reinéis eternamente."
,"22":"Os anunciaré qué es la sabiduría,y cuál es su origen y no os ocultaré sus secretos, sino que desde su primer origen la investigaré, pondré en claro su conocimiento,y no dejaré pasar en silencio la verdad."
,"23":"No caminaré jamás con la envidia destructora, porque nada tiene que ver con la sabiduría."
,"24":"La salvación del mundo está en que haya muchos sabios, un rey prudente es el bienestar de su pueblo."
,"25":"Así pues, dejaos instruir por mis palabras, y de ellas sacaréis utilidad."
}`)
	CurrentBook.AddChapter(7, `{
"1":"También yo soy hombre mortal como todos,y descendiente del primer ser formado de tierra. En el seno de mi madre fui modelado de carne;"
,"2":"durante diez meses fui consolidado con su sangre, de semen de varón y del placer que acompaña al sueño."
,"3":"Ya nacido, respiré el aire de todos; caí en la tierra que todos pisamos,y, como todos, mi primer grito fue el llanto."
,"4":"En pañales y con mimo fui criado."
,"5":"Ninguno entre los reyes tuvo otro principio al nacer."
,"6":"Una es la entrada en la vida para todos, e idéntica la salida."
,"7":"Por eso supliqué, y me fue concedida la prudencia; oré, y vino a mí el espíritu de sabiduría."
,"8":"La preferí a los cetros y a los tronos, y en su comparación tuve en nada la riqueza."
,"9":"Ni la comparé a piedra inestimable, pues todo el oro en su presencia es un poco de arena, como lodo es reputada la plata ante ella."
,"10":"La amé más que a la salud y la belleza,y preferí su posesión a la misma luz, porque su resplandor es inextinguible."
,"11":"Me vinieron con ella todos los bienes, pues ella tenía en sus manos una riqueza incalculable."
,"12":"Yo me gozo de todos estos bienes,porque es la sabiduría quien los dirige, pero ignoraba que fuese ella la madre de todos."
,"13":"Sin malicia la aprendí, sin envidia la comunico; sus riquezas no escondo."
,"14":"Porque es tesoro inagotable para los hombres, los que la poseen se atraen la amistad de Dios, recomendados por los dones de la educación."
,"15":"Que Dios me conceda hablar con inteligencia,y pensar dignamente de sus dones, porque él es la guía de la sabiduría,y quien dirige a los sabios."
,"16":"En sus manos estamos nosotros y nuestras palabras, toda la prudencia y toda la ciencia de los técnicos."
,"17":"Porque él me dio el verdadero conocimiento de las cosas,para conocer la constitución del universo, las propiedades de los elementos,"
,"18":"el principio, el fin y el medio de los tiempos, los cambios de los solsticios y la sucesión de las estaciones, "
,"19":"los ciclos del año y las posiciones de los astros,"
,"20":"la naturaleza de los animales y los instintos de las fieras, la fuerza de los vientos y los razonamientos de los hombres, las variedades de las plantas y las virtudes de las raíces. "
,"21":"Conocí todo lo oculto y todo lo visible, porque me lo enseñó la sabiduría, artífice de todo ello."
,"22":"Pues hay en ella un espíritu inteligente, santo, único, multiforme, sutil, ágil, penetrante, incontaminado, diáfano, impasible, amante de lo bueno, agudo,"
,"23":"incoercible, benéfico, amante de los hombres, estable, firme, sin preocupación, todopoderoso, que todo lo vigila y penetra en todos los espíritus inteligentes, puros y sutiles."
,"24":"La sabiduría es más movible que todo movimiento, se difunde y penetra en todo por su pureza."
,"25":"Porque es un efluvio del poder de Dios,y una efusión pura de la gloria del todopoderoso; por eso nada manchado penetra en ella."
,"26":"Es el resplandor de la luz eterna, espejo inmaculado de la actividad de Dios,y una imagen de su bondad."
,"27":"Y aunque es una, lo puede todo; sin salir de sí todo lo renueva,y en todas las edades, derramándose en almas santas, hace de ellas amigos de Dios y profetas."
,"28":"Porque Dios no ama sino al que convive con sabiduría."
,"29":"Ella es más bella que el sol,y supera las constelaciones de las estrellas."
,"30":"Porque comparada con la luz del día sale vencedora; pues a ésta sucede la noche, pero la maldad nada puede contra la sabiduría."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Se extiende poderosa de uno a otro extremo,y todo lo gobierna convenientemente."
,"2":"Yo la amé y busqué desde mi juventud, traté de hacerla mi esposa y quedé prendado de su hermosura."
,"3":"Su intimidad con Dios manifiesta su abolengo, el Señor de todas las cosas la amó."
,"4":"Ella está iniciada en la ciencia de Dios,y es directora de sus obras."
,"5":"Si la riqueza es una posesión codiciable en la vida, ¿qué más rico que la sabiduría que todo lo obra?"
,"6":"Y si la inteligencia obra, ¿quién entre los seres es más artista que ella?"
,"7":"Si uno ama la justicia, las virtudes son el fruto de su trabajo, porque enseña templanza y prudencia, justicia y fortaleza, y nada hay más útil para los hombres en la vida."
,"8":"Si es una rica experiencia lo que uno ansía, ella sabe las cosas pasadas y entrevé las venideras; conoce los artificios del lenguaje,y las soluciones de los enigmas; conoce de antemano los signos y prodigios, los momentos y los tiempos favorables."
,"9":"Resolví, por tanto, hacer de ella la compañera de mi vida, sabiendo que sería mi consejera para el bien,y mi consuelo en las tristezas y las penalidades."
,"10":"Tendré por ella gloria entre las gentes,y honor ante las naciones, aunque soy joven."
,"11":"Al hacer justicia, se reconocerá mi agudeza, y a los ojos de los poderosos causaré admiración."
,"12":"Si yo callase, aguardarán que hable; si hablo, me escucharán, y si prolongo mi discurso, pondrán el dedo sobre su boca."
,"13":"Tendré por ella la inmortalidad,y eterno recuerdo dejaré a los venideros."
,"14":"Gobernaré pueblos, y las naciones se someterán a mí."
,"15":"Al oír de mí me temerán los terribles tiranos; en medio del pueblo me muestro bueno y en la guerra valeroso. "
,"16":"Al volver a mi hogar descansaré junto a ella, porque su trato no tiene amargura, ni dolor la intimidad con ella, sino placer y gozo."
,"17":"Meditando estas cosas dentro de mí, y considerando en mi corazón que la inmortalidad está en la comunión con la sabiduría,"
,"18":"en su amistad el honesto deleite, en los trabajos de sus manos riqueza inagotable, en su trato continuo la prudencia,y buen nombre en tomar parte en sus discursos, corrí de un lado para otro buscando el modo de tomarla por esposa."
,"19":"Era yo un niño bien dotado. Me tocó en suerte un alma buena."
,"20":"O, mejor, siendo bueno, vine a un cuerpo incontaminado."
,"21":"Sabiendo que no la conseguiría si Dios no me la daba,y esto mismo era ya un acto de buen juicio: saber de quién venía este don , acudí al Señor y le supliqué, diciendo con toda mi alma:"
}`)
	CurrentBook.AddChapter(9, `{
"1":"'Dios de los padres y Señor de las misericordias, que con tu palabra hiciste todas las cosas"
,"2":"y con tu sabiduría formaste al hombre,para que dominase sobre las criaturas salidas de tus manos,"
,"3":"gobernase al mundo con santidad y justicia,y rectamente administrase justicia,"
,"4":"dame la sabiduría, que se asienta junto a tu trono, y no me excluyas del número de tus hijos."
,"5":"Porque yo soy esclavo tuyo e hijo de tu esclava, hombre débil y de corta vida, incapaz de comprender el derecho y las leyes."
,"6":"Pues aunque alguno fuese perfecto entre los hijos de los hombres, como le falte la sabiduría que de ti procede,será estimado en nada."
,"7":"Tú me preferiste para rey de tu pueblo,y juez de tus hijos y tus hijas."
,"8":"Tú me ordenaste edificar un templo en tu monte santo,y un altar en la ciudad de tu morada a imitación de la tienda santa, que tú ya habías preparado desde el principio."
,"9":"Contigo está la sabiduría, que conoce tus obras, que te asistió al hacer el mundo, y sabe lo que es agradable a tus ojos,y lo que es recto según tus mandamientos."
,"10":"Envíala desde los santos cielos,y desde el trono de tu gloria mándala, para que asistiéndome en mis trabajos,conozca lo que a ti te agrada."
,"11":"Ella que lo sabe y lo comprende todo,me guiará prudentemente en mis empresas,y me protegerá con su gloria."
,"12":"Así serán mis obras de tu agrado, yo juzgaré a tu pueblo con justicia,y seré digno del trono de mi padre."
,"13":"Pues, ¿quién podrá conocer los designios de Dios?, ¿quién acertará con lo que el Señor quiere?"
,"14":"Los pensamientos de los mortales son titubeantes, y nuestras reflexiones inseguras."
,"15":"Porque el cuerpo corruptible es un peso para el alma, y la morada terrestre oprime el espíritu pensativo."
,"16":"Pues si a duras penas conjeturamos lo que ocurre en la tierra, y con trabajo descubrimos lo que tenemos entre las manos,¿quién rastreará lo que hay en los cielos?"
,"17":"¿Quién conoció tu designio, si tú no le diste la sabiduría,y enviaste desde los cielos tu santo espíritu?"
,"18":"Así fueron rectificados los caminos de la tierra, los hombres aprendieron aquello que te agrada,y se salvaron gracias a la sabiduría."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Ella guardó al primer ser formado por Dios, padre del mundo; cuando él todavía era la única criatura, le levantó de su caída,"
,"2":"le dio fuerza para dominarlo todo."
,"3":"Pero el hombre injusto en su cólera se apartó de ella,y pereció por su saña fratricida."
,"4":"Cuando por culpa de él el agua inundó la tierra, ella le salvó de nuevo, llevando al justo a través de las aguas sobre un simple leño. "
,"5":"Cuando las naciones unánimes en su perversidad fueron confundidas, ella fue quien puso los ojos en el justo, lo conservó irreprochable ante Dios,y lo sostuvo fuerte por encima del entrañable amor a su hijo. "
,"6":"Ella, mientras eran exterminados los malvados, salvó al justo, que huía del fuego caído sobre las cinco ciudades."
,"7":"Como testigos de su maldad subsisten todavía una tierra desolada y humeante, plantas que dan frutos que no llegan a madurar,y una estatua de sal levantada en recuerdo de un alma incrédula."
,"8":"Pues por apartarse del camino de la sabiduría,no sólo se dañaron desconociendo el bien, sino que dejaron a los vivientes un recuerdo de su insensatez, para que su pecado no pudiese permanecer oculto."
,"9":"Mas la sabiduría a sus servidores los libró de sus trabajos."
,"10":"Ella guió por senderos rectos al justo, que huía de la ira de su hermano; le mostró el reino de Dios,y le dio conocimiento de las cosas santas; le hizo prosperar en sus fatigas,y multiplicó el fruto de sus trabajos;"
,"11":"le asistió contra la avaricia de sus explotadores,y lo enriqueció;"
,"12":"lo preservó de sus enemigos, y lo protegió contra los que le tendían lazos; le otorgó el galardón tras duro combate, para que conociese que la piedad es más fuerte que todas las cosas."
,"13":"No desamparó al justo que había sido vendido, y lo libró de caer en el pecado."
,"14":"Descendió con él al calabozo,y no lo abandonó entre los hierros,hasta levantarlo al cetro real,y al poder sobre sus tiranos; puso en evidencia la mentira de sus difamadores,y le dio una gloria eterna."
,"15":"Ella libró de naciones opresoras al pueblo santo,y a la estirpe irreprochable."
,"16":"Entró en el alma de un siervo del Señor,e hizo frente a reyes temibles con prodigios y señales."
,"17":"Recompensó de sus trabajos a los santos, los guió por caminos maravillosos; fue sombra para ellos durante el día,y resplandor de estrellas por la noche."
,"18":"Los hizo atravesar a pie el mar Rojo,y pasar a través de muchas aguas."
,"19":"Sumergió a sus enemigos,y los vomitó de las profundidades del abismo."
,"20":"Por esto los justos despojaron a los malvados, celebraron, Señor, tu nombre santo, y con corazón unánime alabaron tu diestra vencedora."
,"21":"Porque la sabiduría abrió la boca de los mudos,y soltó la lengua de los niños."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Les dio prosperidad en sus empresas,por mano de un santo profeta."
,"2":"Atravesaron un desierto inhabitable, y en parajes inaccesibles plantaron sus tiendas."
,"3":"Hicieron frente a los enemigos,y rechazaron a sus adversarios."
,"4":"Tuvieron sed y te invocaron; una roca escarpada les dio agua, una dura piedra remedió su sed."
,"5":"Pues lo que sirvió de castigo para sus enemigos,fue favor para ellos cuando se vieron en necesidad."
,"6":"Mientras que a los otros, en castigo de su edicto infanticida, les diste el manantial siempre corriente de un río enturbiado,con sangre mezclada de barro,"
,"7":"a los tuyos les diste, contra toda esperanza, aguas abundantes,"
,"8":"tras haberles mostrado con la sed aquella,cómo habías castigado a sus enemigos."
,"9":"Pues a través de sus pruebas, que no eran más que correcciones de misericordia, vinieron a conocer con qué tormentos fueron atormentados,los malvados juzgados sin piedad."
,"10":"Pues a los tuyos los probaste como padre que amonesta; a los otros los castigaste como rey severo que condena."
,"11":"Tanto presentes como ausentes eran igualmente atribulados."
,"12":"Porque una doble pena les alcanzó, y gimieron por el recuerdo del pasado."
,"13":"Pues cuando oyeron que sus propios castigos venían a ser favores para los otros, sintieron la mano del Señor."
,"14":"Aquel a quien ellos en otro tiempo expusieron en el agua,y luego lo rechazaron con burla, los llenó de estupor al fin de estos sucesos, al sentir una sed muy distinta de la de los justos. b) Los animales."
,"15":"Y en pago de sus locos pensamientos de injusticia, que los extraviaron hasta hacerlos adorar reptiles sin razón,y bestias despreciables, les enviaste como castigo una muchedumbre de animales irracionales,"
,"16":"para que conocieran que por lo que uno peca por eso es atormentado."
,"17":"Pues bien podía tu mano omnipotente, que creó el universo de la materia informe, enviarles manadas de osos o arrogantes leones;"
,"18":"o ferocísimas bestias desconocidas, a tal propósito creadas, que respirasen aliento inflamado, lanzando rugidos humeantes, o que relampagueasen centellas aterradoras por sus ojos; "
,"19":"bestias tales que no sólo con su maléfico contacto podían aniquilarlos, sino que con su sola vista podían hacerles perecer de terror."
,"20":"Y aun sin esto podían ser derribados de un soplo, perseguidos por la justicia y barridos por tu aliento poderoso. Pero tú lo has regulado todo con número, con peso y con medida. "
,"21":"Porque el desplegar gran poder está siempre en tu mano; y ¿quién puede resistir a tu brazo poderoso?"
,"22":"Pues el mundo entero es ante ti como un granito de arena en la balanza, y como gota de rocío mañanero que cae sobre la tierra."
,"23":"Tienes misericordia de todos porque todo lo puedes, y pasas por alto los pecados de los hombres,para llevarlos al arrepentimiento."
,"24":"Tú amas todo lo que existe,y no aborreces nada de lo que hiciste, pues si algo aborrecieras no lo hubieses creado."
,"25":"Y ¿cómo subsistiría nada si tú no lo quisieras?,O ¿cómo podría conservarse si no hubiese sido llamado por ti? "
,"26":"Pero tú perdonas a todos, porque todo es tuyo, Señor, que amas cuanto existe."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Porque tu espíritu incorruptible está en todas las cosas."
,"2":"Por eso corriges poco a poco a los que pecan,y los amonestas recordándoles su pecado,para que se aparten de la maldad y crean en ti, Señor."
,"3":"A los antiguos moradores de tu santa tierra,"
,"4":"que odiabas por sus hechos abominables, sus prácticas de magia y ritos sacrílegos,"
,"5":"matanzas crueles de niños, banquetes canibalescos de carne,y sangre humana, iniciados en sangrientas orgías,"
,"6":"a esos padres, asesinos de seres indefensos, quisiste exterminarlos por mano de nuestros padres,"
,"7":"para que recibiera una digna colonia de hijos de Dios,esta tierra para ti más querida que todas."
,"8":"Pero con éstos, hombres al fin, fuiste indulgente,y les enviaste avispas como precursoras de tu ejército, para que los exterminasen poco a poco."
,"9":"Tú hubieras podido en batalla campal entregar a los malvados en manos de los justos, o aniquilarlos de golpe con bestias feroces,o con una severa palabra."
,"10":"Pero castigándolos poco a poco les dabas lugar a arrepentirse, aunque no ignorabas que su raza era perversa,y su maldad congénita; que jamás su pensamiento mudaría."
,"11":"Era una raza maldita desde su origen, y no por temor a nadie dejabas sin castigo sus pecados."
,"12":"Porque, ¿quién osará decirte: 'Qué has hecho?'; ¿quién se opondrá a tu sentencia, quién presentará querella ante ti,por las gentes destruidas que tú mismo habías creado, o quién comparecerá ante ti como defensor de hombres injustos?"
,"13":"Pues no hay Dios fuera de ti que de todo cuide, al que tengas que probar que tú no has juzgado injustamente."
,"14":"Ni rey o tirano que pueda desafiarte defendiendo a los que tú castigas."
,"15":"Tú eres justo y gobiernas el universo con justicia, y consideras incompatible con tu poder condenar a un hombre,que no merezca ser castigado."
,"16":"Porque tu fuerza es el principio de tu justicia, y el ser tú Señor de todo te hace ser indulgente con todo."
,"17":"Sólo cuando se duda de la plenitud de tu poder,despliegas tu fuerza y confundes la osadía de los que dudan de ella."
,"18":"Pero tú, aun siendo el más fuerte, juzgas con benignidad,y nos gobiernas con mucho miramiento, porque tienes a mano el poder cuando quieres."
,"19":"Enseñaste a tu pueblo con este modelo de obrar,que el justo debe ser humano, y diste buenas esperanzas a tus hijos de que, después del pecado, das lugar al arrepentimiento."
,"20":"Porque si a los enemigos de tus hijos,y reos de muerte castigaste con tanto miramiento e indulgencia, dándoles tiempo y ocasión para que se apartasen de la maldad,"
,"21":"¡con cuánta mayor consideración castigaría a tus hijos, pues con juramentos y pactos prometiste a sus padres grandes bienes!"
,"22":"Así, para educarnos a nosotros, castigas con moderación a nuestros enemigos,para que, al juzgar a los demás, nos acordemos de tu bondad,y, al ser juzgados, esperemos misericordia."
,"23":"Por eso a los que en su locura llevaban una vida de injusticias, los atormentaste con sus propios horrores."
,"24":"Y hasta se extraviaron largamente por las sendas del error, tomando por dioses a los más viles y groseros animales, engañados como niños sin uso de razón."
,"25":"Por esto, como a niños sin juicio, les enviaste un castigo de risa."
,"26":"Mas los que no escarmentaron,con tales castigos irrisorios,habrían de experimentar un castigo digno de Dios."
,"27":"Porque al tener que sufrir y al verse castigados,por aquellos mismos seres que tenían por dioses, llegaron a reconocer por Dios verdadero,al que antes no querían conocer; por esto cayó sobre ellos la suprema condenación."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Torpes por naturaleza son todos los hombres,que han ignorado a Dios y por los bienes visibles,no lograron conocer al que existe, ni considerando sus obras reconocieron al artífice de ellas,"
,"2":"sino que tuvieron por dioses rectores del mundo al fuego, al viento, al aire ligero, a la bóveda estrellada, al agua impetuosa o a los luceros del cielo."
,"3":"Pues si, embelesados con su hermosura, los tuvieron por dioses, entiendan cuánto más hermoso es el Señor de todas estas cosas, pues el autor mismo de la belleza las creó."
,"4":"Si les llenó de asombro su poder y su energía, aprendan de ahí cuánto más poderoso es quien los formó."
,"5":"Pues por la grandeza y la hermosura de las criaturas se descubre, por analogía, a su hacedor."
,"6":"Mas, con todo, no se merecen un duro reproche, porque quizá se extravían buscando a Dios,y queriendo encontrarlo;"
,"7":"ocupándose de sus obras, las investigan,y se dejan seducir por su apariencia, pues que son tan hermosas."
,"8":"Sin embargo, ni éstos son excusables;"
,"9":"porque si tanto llegaron a saber,que acertaron a escudriñar el universo, ¿cómo no encontraron antes a su Señor?"
,"10":"Desgraciados, en cambio, y con la esperanza puesta en cosas muertas, los que llamaron dioses a obras de manos de hombre: oro y plata trabajados con arte, figuras de animales, o a una piedra inútil, obra de mano antigua."
,"11":"Supongamos que un leñador diestro sierra un árbol manejable, lo descorteza hábilmente y, empleando destreza y arte, fabrica un utensilio apto para las necesidades de la vida."
,"12":"Pero en cuanto a lo sobrante de su obra, lo emplea para preparar su comida y se harta."
,"13":"El último desperdicio que para nada sirve ya, un tronco retorcido y nudoso, lo toma y lo talla para entretener su ociosidad; y, como ensayando su pericia, lo modela, dándole forma de hombre. "
,"14":"O le da figura de un vil animal, tapa sus defectos con masilla y lo pinta de rojo."
,"15":"Le hace luego un nicho apropiado, lo coloca en el muro,y lo asegura con hierro."
,"16":"Toma precauciones para que no se caiga, pues sabe que es incapaz de valerse por sí mismo, ya que es una estatua y necesita ayuda."
,"17":"Pero luego, al pedirle por sus bienes, por casamientos y por sus hijos, no se avergüenza de hablar con un trasto sin vida. Pide la salud a una cosa que no tiene fuerza alguna,"
,"18":"pide la vida a una cosa muerta; pide socorro a lo más incapaz;"
,"19":"un viaje feliz al que no puede valerse de sus pies; ganancias, empresas y éxitos en los negocios,al que es incapaz de hacer nada con sus manos."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Otro, al hacerse a la mar y a punto de desafiar el furor de las olas, implora a un tronco más frágil aún que el barco que lo lleva."
,"2":"Porque el barco lo ideó la sed de lucro, la sabiduría fue el artífice de su construcción;"
,"3":"pero tu providencia, oh Padre, va al timón; porque hasta en el mar trazaste camino y senda segura entre las olas,"
,"4":"mostrando que puedes salvar de todo riesgo, de suerte que aun sin pericia náutica puede uno embarcarse."
,"5":"No quieres que las obras de tu sabiduría sean improductivas; por esto los hombres confían sus vidas a un frágil leño,y, atravesando las olas en una balsa, llegan sanos y salvos."
,"6":"Y ya al principio, mientras perecían los gigantes orgullosos, la esperanza del mundo refugiada en una barca pilotada por tu mano,legó al mundo semilla de una nueva generación."
,"7":"Bendito el leño que llega a ser instrumento de justicia."
,"8":"Pero maldito el ídolo hecho por mano de hombre, maldito él y su hacedor. Éste, porque lo fabricó; aquél, porque, siendo una cosa corruptible, fue llamado dios."
,"9":"Dios aborrece por igual al malvado y a su maldad;"
,"10":"la obra y el que la hace serán castigados."
,"11":"La visita divina se extenderá a los ídolos de los gentiles, porque en la creación de Dios se han convertido en algo aborrecible, en escándalo para las almas de los hombres,y en lazo para los pies de los necios."
,"12":"La idea de hacer ídolos fue el origen de la infidelidad; su invención, la corrupción de la vida;"
,"13":"que no existieron desde los orígenes, ni existirán por siempre."
,"14":"Por la vanidad de los hombres entraron en el mundo, y por esto está decretado su rápido fin."
,"15":"Afligido un padre por un luto prematuro, manda hacer una imagen del hijo tan presto arrebatado; honra hoy como a dios al ayer hombre muerto, y establece entre los suyos ritos y misterios."
,"16":"Más tarde, consolidada por el tiempo esta costumbre impía, fue observada como ley."
,"17":"Por disposición de los soberanos reciben culto las estatuas. Como los hombres no podían venerarlos porque vivían lejos, representaron su persona haciendo una imagen del rey venerado, para adular con solicitud al ausente como si estuviese presente."
,"18":"La ambición del artista empujó a extender su culto,aun a los mismos que no lo conocían."
,"19":"Porque él, deseando sin duda agradar al soberano, desplegó todo su arte para conseguir una imagen más bella que la realidad."
,"20":"Y la multitud, reducida por el encanto de la obra, tiene ahora como ser divino al que poco antes tenía como hombre."
,"21":"Esto se convirtió en lazo para los vivientes; porque los hombres, víctimas de la desgracia y de la tiranía, impusieron el nombre incomunicable a las piedras y a los leños."
,"22":"No se contentaron con errar en el conocimiento de Dios, sino que, viviendo en el vasto conflicto que engendra la ignorancia, llamaron paz a tan grandes males."
,"23":"Con sus ritos infanticidas, sus misterios ocultos,o sus locas orgías de ritos extravagantes,"
,"24":"no respetan ni las vidas ni la pureza de los matrimonios, pues se matan a traición unos a otros,o se ultrajan con adulterios."
,"25":"Por doquiera reina, en confusión, sangre y muerte, robo y engaño, corrupción e infidelidad, tumulto y perjurio,"
,"26":"confusión de los valores, olvido de los beneficios, contaminación de las almas, sexualidad invertida, trastorno de matrimonios, adulterio e impureza."
,"27":"Pues el culto de los ídolos que no son nada es principio, causa y fin de todo mal."
,"28":"Pues, o se divierten sin freno, o profetizan falsedades, o viven en la injusticia."
,"29":"Como confían en ídolos sin vida, juran en falso sin temor alguno."
,"30":"Pero un doble castigo vendrá sobre ellos, porque despreciaron a Dios, recurrieron a los ídolos,y juraron en falso despreciando la santidad."
,"31":"No es el poder de los ídolos por los que juraron, sino la justicia que actúa sobre los pecadores,la que sanciona las transgresiones de los hombres injustos."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Pero tú, oh Dios nuestro, eres benigno y fiel; eres paciente y lo gobiernas todo con misericordia."
,"2":"Aun cuando pecamos somos tuyos, reconocemos tu poder; pero no queremos pecar sabiendo que te pertenecemos."
,"3":"Conocerte a ti lleva a la justicia perfecta,y reconocer tu poder es la raíz de la inmortalidad."
,"4":"Porque ni la humana invención de un arte perverso nos engañó, ni el trabajo estéril de los pintores, figuras adornadas de variados colores,"
,"5":"cuya vista despierta en los insensatos la pasión,hasta hacerles desear la figura inanimada de una estatua sin vida."
,"6":"Amantes son del mal y dignos de tales esperanzas,los que las hacen, los que las desean y los que las veneran."
,"7":"Un alfarero, modelando laboriosamente la tierra blanda, fabrica todos los objetos de nuestro uso; pero del mismo barro fabrica los destinados a usos limpios,y los destinados a usos contrarios; todos igualmente. En cuanto al uso de cada uno, lo determina el alfarero."
,"8":"Después, dedicándose a un trabajo reprobable, del mismo barro modela un dios falso él, que hace bien poco nació de la tierra,y volverá bien pronto a ella, de donde fue sacado, cuando le pidan que restituya su vida prestada."
,"9":"Pero no le preocupa que haya de morir,ni tener una corta vida, sino que rivaliza con orfebres,y plateros, imita a los forjadores de bronce,y se gloría de ser un falsificador."
,"10":"Su corazón es ceniza, su esperanza más vil que el polvo,y su vida más despreciable que el fango"
,"11":"por no reconocer a su hacedor, que le infundió un alma activa,e inspiró en él un espíritu vital."
,"12":"Piensa, más bien, que nuestra vida es un pasatiempo,y la existencia una feria lucrativa; porque conviene, dice, sacar partido de todo, aun de lo malo."
,"13":"Pues él mejor que nadie sabe que peca,cuando fabrica de una materia terrena frágiles objetos e ídolos."
,"14":"Pero sumamente insatisfechos y más desdichados,que el alma de un niño son todos los enemigos,y los opresores de tu pueblo,"
,"15":"porque tuvieron por dioses a todos los ídolos de los gentiles, cuyos ojos no les sirven para ver, ni sus narices para respirar, ni sus oídos para oír, ni los dedos de sus manos para tocar, y cuyos pies están paralizados."
,"16":"Pues los hizo un hombre, y el que tiene el espíritu prestado los formó. Pues ningún hombre es capaz de formar un dios que sea semejante a él."
,"17":"Un mortal sólo puede producir con sus manos pecadoras una obra muerta; vale él más que los objetos que venera, ya que él goza de vida y ellos no."
,"18":"Adoran también a los más repugnantes animales, y por su estupidez aun son los peores de todos."
,"19":"Nada hay en ellos que pueda hacerlos atrayentes, como sucede a veces a la vista de los animales. Hasta fueron excluidos de la aprobación y bendición de Dios."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Por eso fueron castigados con razón por tales animales,y atormentados por una multitud de bestias."
,"2":"En vez de tal castigo favoreciste a tu pueblo; para satisfacción de su ardiente apetito, le preparaste como alimento un manjar exquisito: codornices."
,"3":"Y así aquéllos, aunque estaban ansiosos de alimento, ante el aspecto repugnante de los animales que les enviaste, perdieron las ganas de comer; mientras que tu pueblo, después de una breve privación, gustó un manjar exquisito."
,"4":"Convenía que los opresores vieran caer sobre ellos una necesidad implacable; a éstos, en cambio, bastaba con mostrarles cómo eran atormentados sus enemigos."
,"5":"Pues cuando vino sobre ellos el terrible furor de las fieras, cuando perecieron con la mordedura de serpientes venenosas, tu ira no llegó hasta el extremo."
,"6":"Con el fin de que se corrigieran, y por breve tiempo, fueron atormentados, habiendo tenido un signo de salvación,para que conservaran el recuerdo de los mandamientos de tu ley;"
,"7":"pues el que se volvía a él era salvado; no por lo que contemplaba, sino por ti, salvador de todos."
,"8":"Y así demostraste a nuestros enemigos,que eres tú el que libra de todo mal."
,"9":"Pues ellos morían por la picadura de langosta,y mosquitos sin encontrar remedio para su vida, pues merecieron ser castigados por tales bestias."
,"10":"Pero a tus hijos no les vencieron,ni los dientes de las serpientes venenosas, porque tu misericordia se interpuso y los sanó."
,"11":"Para que se acordaran de tus palabras eran mordidos e inmediatamente curados, para que no cayesen así excluidos de tu acción benéfica."
,"12":"Porque ni hierba ni emplasto los curó, sino tu palabra, Señor, que todo lo sana."
,"13":"Pues tú tienes el poder de la vida y de la muerte, que hundes hasta las puertas del abismo y haces subir de él."
,"14":"El hombre puede matar en su maldad, pero no hacer que retorne el espíritu que se fue, ni liberar al alma una vez cautiva."
,"15":"Es imposible escapar de tu mano. c) Los fenómenos meteorológicos."
,"16":"Los malvados que no quisieron conocerte,fueron azotados por tu brazo poderoso; perseguidos con extrañas lluvias, con granizadas y aguaceros para los que no había cobijo, y el fuego los devoró."
,"17":"Y lo extraño era que en el agua, donde todo se apaga, el fuego se volvía más voraz, pues la naturaleza combate por los justos."
,"18":"Unas veces la llama se debilitaba, para no consumir los animales enviados contra los malvados,y hacerles ver que era la justicia de Dios la que los perseguía."
,"19":"Otras, en cambio, aun en medio del agua, la llama ardía con más fuerza que el fuego, para destruir los frutos de una tierra injusta."
,"20":"A tu pueblo, en cambio, le diste alimento de ángeles, le procuraste desde el cielo un pan preparado,sin trabajo por su parte, capaz de dar todo placer,y acomodado al gusto de cada uno."
,"21":"Ese sustento tuyo manifestaba tu dulzura para con tus hijos, pues se acomodaba al deseo de quienes lo comían,y se transformaba a gusto de cada uno."
,"22":"Nieve y hielo resistían el fuego sin fundirse, para que conociesen cómo eran destruidos los frutos de los enemigos,por el fuego que ardía aun entre el granizo,y fulguraba en medio de las lluvias."
,"23":"En cambio, este mismo fuego se olvidaba de su propia fuerza, para que los justos se alimentaran;"
,"24":"pues la naturaleza, sometida a ti, su creador, despliega su energía para castigo de los injustos,y se mitiga para bien de los que en ti confían."
,"25":"Por esto, también entonces, amoldándose a todas las formas, estaba al servicio de tu generosidad, que alimenta a todos a gusto de los necesitados."
,"26":"Para que los hijos que tú amas, Señor, aprendiesen que no es la variedad de frutos,lo que sustenta al hombre, sino tu palabra, que conserva a los que creen en ti."
,"27":"Pues lo que no era destruido por el fuego,se derretía simplemente calentado por un tenue rayo de sol,"
,"28":"para que todos aprendieran que es necesario adelantarse al sol,para darte gracias y acudir a ti al despuntar la aurora."
,"29":"Porque la esperanza del ingrato se deshará como escarcha invernal,y se escurrirá como agua inservible."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Grandes e inescrutables son tus juicios, por eso las almas sin instrucción se extraviaron."
,"2":"Estos malvados, que habían querido oprimir al pueblo santo, yacían prisioneros de las tinieblas,y encadenados por una larga noche, encerrados bajo sus techos, excluidos de tu eterna providencia. "
,"3":"Cuando pensaban quedar ocultos con sus pecados secretos, bajo el oscuro velo del olvido, fueron ellos mismos inmersos en las tinieblas, espantados y despavoridos con fantasmas."
,"4":"Pues ni el escondrijo que los abrigaba pudo preservarlos del temor. Ruidos terroríficos resonaban a su alrededor, y sombríos fantasmas de rostros tristes se les aparecían."
,"5":"Ni el fuego más potente era capaz de dar luz, ni la llama brillante de los astros podía iluminar aquella noche horrenda."
,"6":"Sólo se les dejaba ver una hoguera, que se encendía por sí misma e infundía terror; una vez desaparecida la visión, quedaban aterrados,y les parecía más terrible aún lo que habían visto."
,"7":"Los trucos de la magia fueron un fracaso, y la ciencia de que presumían, una frustración."
,"8":"Los que prometían ahuyentar los miedos,y las perturbaciones de las almas acobardadas, ellos mismos padecían un miedo ridículo."
,"9":"Aunque no hubiera nada terrible que pudiera asustarlos, ellos, sobresaltados por el paso de los animales,y el silbido de las serpientes"
,"10":"se morían temblando de miedo, no atreviéndose ni a mirar al aire, al que de ningún modo es posible evitar."
,"11":"Pues la maldad es cobarde, y se condena por su propio testimonio; acosada por su propia conciencia, siempre se imagina lo peor,"
,"12":"porque el temor no es otra cosa que la renuncia a los auxilios de la razón;"
,"13":"cuanto menor es la confianza en los recursos interiores, mayor se juzga la ignorada causa del tormento."
,"14":"Ellos, en medio de aquella noche impotente, salida de las profundidades del impotente abismo, sumidos todos en el mismo sueño,"
,"15":"unos eran perseguidos por fantasmas monstruosos, otros desfallecían por abatimiento, porque un repentino e inesperado terror se había apoderado de ellos."
,"16":"Luego, si alguno caía, allí era encarcelado, prisionero en una cárcel sin rejas."
,"17":"Ya fuese labrador o pastor, ya fuese un obrero que trabaja en solitario, sufría, sorprendido, el castigo inevitable; pero todos estaban atados por una misma cadena de tinieblas."
,"18":"Una ráfaga de viento, el canto melodioso de los pájaros en la enramada, el rumor cadencioso de las aguas que se precipitan con fuerza, el rudo estrépito de piedras que se despeñan,"
,"19":"la carrera invisible de animales que brincan, el rugido de ferocísimas bestias, el eco repercutiendo en las concavidades de las montañas, todo los dejaba paralizados de terror."
,"20":"Mientras todo el universo era iluminado por una luz esplendorosa y se entregaba a sus trabajos libremente,"
,"21":"sólo sobre ellos se había extendido una densa noche, imagen de las tinieblas que les estaban reservadas; pero ellos eran más pesados para sí que las mismas tinieblas."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Una luz espléndida brillaba, en cambio, para tus santos. Los egipcios, que oían su voz sin ver su figura, los proclamaban dichosos, aunque primero hubiesen padecido;"
,"2":"porque no los maltrataban por los agravios recibidos, les daban gracias y les pedían perdón por su hostilidad."
,"3":"A los tuyos, por el contrario, les diste una columna llameante, guía para un camino desconocido, sol inofensivo de una gloriosa emigración."
,"4":"Pues aquéllos merecieron ser privados de la luz,y ser encerrados en tinieblas por haber tenido prisioneros a tus hijos, por quienes debía darse al mundo la luz incorruptible de la ley. e) La muerte."
,"5":"A los que habían resuelto matar a los hijos de los santos, de los que uno solo fue expuesto y se salvó, en castigo les quitaste la muchedumbre de sus hijos,y los hiciste perecer a todos juntos en un agua impetuosa."
,"6":"Aquella noche les fue de antemano anunciada a nuestros padres,para que, sabiendo con certeza a qué juramento se habían confiado, tuvieran buen ánimo;"
,"7":"tu pueblo esperaba la salvación de los justos,y la perdición de los enemigos."
,"8":"Pues con lo mismo que castigabas a los enemigos,nos glorificaste a nosotros, llamándonos a ti."
,"9":"Los hijos santos de los justos ofrecían sacrificios en secreto, y de común acuerdo establecieron el pacto divino,de que los santos compartiesen igualmente bienes y peligros, cantando antes las alabanzas de los padres."
,"10":"El grito discordante de los enemigos les hacía eco, y se extendía la triste voz de los que lloraban a los hijos muertos."
,"11":"El esclavo y el señor eran castigados con igual justicia, el plebeyo sufría igual que el rey."
,"12":"Todos sin excepción tenían muertos innumerables, heridos por un mismo género de muerte; y los vivos no bastaban para enterrarlos, ya que, en un instante, lo más noble de su linaje había sido destruido."
,"13":"Los que eran completamente incrédulos,a causa de las artes mágicas, ante la pérdida de sus primogénitos,reconocieron que este pueblo era hijo de Dios."
,"14":"Mientras un silencio apacible lo envolvía todo, en el preciso instante de la medianoche,"
,"15":"tu palabra omnipotente se lanzó desde el trono real del cielo,como guerrero despiadado en medio de la tierra entregada al exterminio,"
,"16":"y, con la aguda espada de tu decreto irrevocable, puesta en pie, todo lo llenó de muerte,y tocaba el cielo a la vez que aplastaba la tierra."
,"17":"Entonces, de repente, los atormentaban visiones y sueños terribles, y cayeron sobre ellos terrores inesperados;"
,"18":"medio muertos, tendidos por tierra acá y allá, declaraban la causa de su muerte;"
,"19":"pues los sueños terroríficos les habían advertido ya, para que no pereciesen sin conocer por qué sufrían aquellos males."
,"20":"La prueba de la muerte alcanzó también a los justos, y en el desierto se produjo una mortandad entre la multitud; pero la ira no duró mucho."
,"21":"Porque pronto un hombre irreprochable vino como adalid, empuñando las armas de su propio ministerio, la oración y el incienso expiatorio, y resistió la cólera y puso fin al azote, mostrando así que era siervo tuyo."
,"22":"Venció la revuelta no con la fuerza del cuerpo,ni con el empuje de las armas, sino que con la palabra desarmó al que los castigaba, alegando los juramentos y los pactos patriarcales."
,"23":"Cuando ya los cadáveres se amontonaban unos sobre otros, él se interpuso, aplacó la ira,y le cortó el camino hacia los vivos."
,"24":"En su vestidura talar estaba representado el mundo entero; los nombres gloriosos de los padres,estaban grabados sobre las cuatro filas de piedras preciosas, y tu majestad sobre la diadema de su cabeza."
,"25":"A la vista de estas insignias, el exterminador retrocedió asustado, pues era suficiente la simple experiencia de la ira divina."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Pero sobre los malvados descargó hasta el fin una ira despiadada, porque Dios sabía de antemano su conducta futura:"
,"2":"después de haberlos consentido marchar,y de haberlos despedido con prisas, cambiarían de opinión y los perseguirían."
,"3":"En efecto, estando celebrando todavía sus duelos funerarios,y lamentándose sobre las tumbas de los muertos, ya concibieron otra idea absurda,y se pusieron a perseguir como a fugitivos,a los que habían suplicado que se fuesen."
,"4":"Un justo destino los arrastraba a este extremo, haciéndoles olvidar el pasado, para que colmasen el castigo que faltaba a sus suplicios:"
,"5":"mientras tu pueblo realizaba un viaje maravilloso, ellos encontraron una muerte inaudita."
,"6":"Porque toda la creación, obediente a tus mandatos, tomaba nuevas formas en su misma naturaleza, para que tus hijos fuesen guardados de todo mal."
,"7":"Se vio la nube dar sombra al campamento, y surgir la tierra seca allí donde antes era agua; en el mar Rojo se abrió un camino sin tropiezos, y una llanura verdeante surgió de entre el oleaje impetuoso."
,"8":"Por allí pasó un pueblo en masa, protegido por tu mano, contemplando prodigios admirables."
,"9":"Eran apacentados como potros y triscaban como corderos, alabándote a ti, Señor, su libertador."
,"10":"Pues se acordaban todavía de lo ocurrido en su salida; cómo, en vez de producir ganados, la tierra produjo mosquitos,y, en vez de peces, el río arrojó multitud de ranas."
,"11":"Más tarde vieron un nuevo modo de nacer las aves, cuando impulsados por el apetito pidieron manjares regalados"
,"12":"y, para saciarlos, subieron del mar las codornices."
,"13":"Mientras, sobre los pecadores cayeron los castigos, no sin precederles las señales precursoras de violentos rayos; pues justamente padecían por sus maldades, por haber alimentado el odio más feroz contra los extranjeros."
,"14":"Porque algunos no acogieron a los desconocidos que llegaban, pero ellos esclavizaron a huéspedes bienhechores."
,"15":"Y no sólo esto, sino que les espera el castigo, porque recibieron con hostilidad a los extranjeros."
,"16":"Pero ellos, después de haberlos recibido con fiestas,y haberlos hecho ya partícipes de sus derechos, los maltrataron con crueles trabajos."
,"17":"Fueron también heridos de ceguera, como aquellos que a la puerta del justo, envueltos en profundas tinieblas, buscaban la entrada de su puerta."
,"18":"Los elementos se intercambiaban sus propiedades, como los instrumentos de cuerda cambian su ritmo, conservando, sin embargo, su tonalidad; lo cual se puede claramente ver con el examen cuidadoso de los hechos,"
,"19":"pues los animales terrestres se volvían acuáticos, y los que nadan se trasladaban a la tierra."
,"20":"El fuego en el agua redoblaba su propia fuerza, y el agua olvidaba su fuerza extintora."
,"21":"Las llamas, por el contrario, no consumían las carnes de endebles animales que en ellas se movían, ni se derretía aquel alimento celestial, semejante al rocío y tan frágil como él."
,"22":"De mil formas, Señor, engrandeciste a tu pueblo y lo glorificaste, y no dejaste de asistirlo en todo tiempo y lugar."
}`)

}
