package bibles

func FR_LBDCC_LoadInfo(CurrentBible *Bible) {
	CurrentBible.SetInfo("fr.lbdcc", "La Bible Des Communautés Chrétiennes")
	CurrentBible.AddBook("VPGN", "Genêse")
	CurrentBible.AddBook("VPEX", "Exode")
	CurrentBible.AddBook("VPLV", "Lévitique")
	CurrentBible.AddBook("VPNM", "Nombres")
	CurrentBible.AddBook("VPDT", "Deutéronome")
	CurrentBible.AddBook("VHIE", "Josué")
	CurrentBible.AddBook("VHID", "Juges")
	CurrentBible.AddBook("VH1S", "1 Samuel")
	CurrentBible.AddBook("VH2S", "2 Samuel")
	CurrentBible.AddBook("VH1R", "1 Rois")
	CurrentBible.AddBook("VH2R", "2 Rois")
	CurrentBible.AddBook("VH1P", "1 Chroniques")
	CurrentBible.AddBook("VH2P", "2 Chroniques")
	CurrentBible.AddBook("VHED", "Esdras")
	CurrentBible.AddBook("VHNH", "Néhémie")
	CurrentBible.AddBook("VH1M", "1 Maccabées")
	CurrentBible.AddBook("VH2M", "2 Maccabées")
	CurrentBible.AddBook("VMIS", "Isaïe")
	CurrentBible.AddBook("VMIE", "Jérémie")
	CurrentBible.AddBook("VMEZ", "Ezéquiel")
	CurrentBible.AddBook("VNOS", "Osée")
	CurrentBible.AddBook("VNIL", "Joël")
	CurrentBible.AddBook("VNAM", "Amos")
	CurrentBible.AddBook("VNAB", "Abdias")
	CurrentBible.AddBook("VNIN", "Jonas")
	CurrentBible.AddBook("VNMI", "Michée")
	CurrentBible.AddBook("VNNH", "Nahum")
	CurrentBible.AddBook("VNHA", "Habaquq")
	CurrentBible.AddBook("VNSO", "Sophonie")
	CurrentBible.AddBook("VNAG", "Aggée")
	CurrentBible.AddBook("VNZA", "Zacharie")
	CurrentBible.AddBook("VNML", "Malachie")
	CurrentBible.AddBook("VMDN", "Daniel")
	CurrentBible.AddBook("VSIB", "Job")
	CurrentBible.AddBook("VSPR", "Proverbes")
	CurrentBible.AddBook("VSEE", "L'Ecclésiaste")
	CurrentBible.AddBook("VSCC", "Le Cantique")
	CurrentBible.AddBook("VHRT", "Ruth")
	CurrentBible.AddBook("VMLM", "Lamentations")
	CurrentBible.AddBook("VHET", "Esther")
	CurrentBible.AddBook("VHTB", "Tobie")
	CurrentBible.AddBook("VHIH", "Judith")
	CurrentBible.AddBook("VMBR", "Baruch")
	CurrentBible.AddBook("VSSP", "La Sagesse")
	CurrentBible.AddBook("VSEI", "Le Siracide")
	CurrentBible.AddBook("VSPS", "Les Psaumes")
	CurrentBible.AddBook("NEMT", "Matthieu")
	CurrentBible.AddBook("NEMC", "Marc")
	CurrentBible.AddBook("NELC", "Luc")
	CurrentBible.AddBook("NEIO", "Jean")
	CurrentBible.AddBook("NTAA", "Actes")
	CurrentBible.AddBook("NPRM", "Romains")
	CurrentBible.AddBook("NP1C", "1 Corinthiens")
	CurrentBible.AddBook("NP2C", "2 Corinthiens")
	CurrentBible.AddBook("NPGA", "Galates")
	CurrentBible.AddBook("NPEP", "Ephésiens")
	CurrentBible.AddBook("NPPP", "Philippiens")
	CurrentBible.AddBook("NPCL", "Colossiens")
	CurrentBible.AddBook("NPPM", "Philémon")
	CurrentBible.AddBook("NP1E", "1 Thessaloniciens")
	CurrentBible.AddBook("NP2E", "2 Thessaloniciens")
	CurrentBible.AddBook("NP1I", "1 Timothée")
	CurrentBible.AddBook("NP2I", "2 Timothée")
	CurrentBible.AddBook("NPTT", "Tite")
	CurrentBible.AddBook("NTHB", "Hébreux")
	CurrentBible.AddBook("NCIB", "Jacques")
	CurrentBible.AddBook("NC1P", "1 Pierre")
	CurrentBible.AddBook("NC2P", "2 Pierre")
	CurrentBible.AddBook("NCID", "Jude")
	CurrentBible.AddBook("NC1I", "1 Jean")
	CurrentBible.AddBook("NC2I", "2 Jean")
	CurrentBible.AddBook("NC3I", "3 Jean")
	CurrentBible.AddBook("NTAI", "Apocalypse")
}

func FR_LBDCC_LoadBooks(CurrentBible *Bible) {
	for x := range CurrentBible.Codes {
		var cb *Book = NewBook(CurrentBible.Codes[x], CurrentBible.Names[x])
		switch CurrentBible.Codes[x] {
		case "VPGN":
			FR_LBDCC_LoadVPGNChapters(cb)
		case "VPEX":
			FR_LBDCC_LoadVPEXChapters(cb)
		case "VPLV":
			FR_LBDCC_LoadVPLVChapters(cb)
		case "VPNM":
			FR_LBDCC_LoadVPNMChapters(cb)
		case "VPDT":
			FR_LBDCC_LoadVPDTChapters(cb)
		case "VHIE":
			FR_LBDCC_LoadVHIEChapters(cb)
		case "VHID":
			FR_LBDCC_LoadVHIDChapters(cb)
		case "VH1S":
			FR_LBDCC_LoadVH1SChapters(cb)
		case "VH2S":
			FR_LBDCC_LoadVH2SChapters(cb)
		case "VH1R":
			FR_LBDCC_LoadVH1RChapters(cb)
		case "VH2R":
			FR_LBDCC_LoadVH2RChapters(cb)
		case "VH1P":
			FR_LBDCC_LoadVH1PChapters(cb)
		case "VH2P":
			FR_LBDCC_LoadVH2PChapters(cb)
		case "VHED":
			FR_LBDCC_LoadVHEDChapters(cb)
		case "VHNH":
			FR_LBDCC_LoadVHNHChapters(cb)
		case "VH1M":
			FR_LBDCC_LoadVH1MChapters(cb)
		case "VH2M":
			FR_LBDCC_LoadVH2MChapters(cb)
		case "VMIS":
			FR_LBDCC_LoadVMISChapters(cb)
		case "VMIE":
			FR_LBDCC_LoadVMIEChapters(cb)
		case "VMEZ":
			FR_LBDCC_LoadVMEZChapters(cb)
		case "VNOS":
			FR_LBDCC_LoadVNOSChapters(cb)
		case "VNIL":
			FR_LBDCC_LoadVNILChapters(cb)
		case "VNAM":
			FR_LBDCC_LoadVNAMChapters(cb)
		case "VNAB":
			FR_LBDCC_LoadVNABChapters(cb)
		case "VNIN":
			FR_LBDCC_LoadVNINChapters(cb)
		case "VNMI":
			FR_LBDCC_LoadVNMIChapters(cb)
		case "VNNH":
			FR_LBDCC_LoadVNNHChapters(cb)
		case "VNHA":
			FR_LBDCC_LoadVNHAChapters(cb)
		case "VNSO":
			FR_LBDCC_LoadVNSOChapters(cb)
		case "VNAG":
			FR_LBDCC_LoadVNAGChapters(cb)
		case "VNZA":
			FR_LBDCC_LoadVNZAChapters(cb)
		case "VNML":
			FR_LBDCC_LoadVNMLChapters(cb)
		case "VMDN":
			FR_LBDCC_LoadVMDNChapters(cb)
		case "VSIB":
			FR_LBDCC_LoadVSIBChapters(cb)
		case "VSPR":
			FR_LBDCC_LoadVSPRChapters(cb)
		case "VSEE":
			FR_LBDCC_LoadVSEEChapters(cb)
		case "VSCC":
			FR_LBDCC_LoadVSCCChapters(cb)
		case "VHRT":
			FR_LBDCC_LoadVHRTChapters(cb)
		case "VMLM":
			FR_LBDCC_LoadVMLMChapters(cb)
		case "VHET":
			FR_LBDCC_LoadVHETChapters(cb)
		case "VHTB":
			FR_LBDCC_LoadVHTBChapters(cb)
		case "VHIH":
			FR_LBDCC_LoadVHIHChapters(cb)
		case "VMBR":
			FR_LBDCC_LoadVMBRChapters(cb)
		case "VSSP":
			FR_LBDCC_LoadVSSPChapters(cb)
		case "VSEI":
			FR_LBDCC_LoadVSEIChapters(cb)
		case "VSPS":
			FR_LBDCC_LoadVSPSChapters(cb)
		case "NEMT":
			FR_LBDCC_LoadNEMTChapters(cb)
		case "NEMC":
			FR_LBDCC_LoadNEMCChapters(cb)
		case "NELC":
			FR_LBDCC_LoadNELCChapters(cb)
		case "NEIO":
			FR_LBDCC_LoadNEIOChapters(cb)
		case "NTAA":
			FR_LBDCC_LoadNTAAChapters(cb)
		case "NPRM":
			FR_LBDCC_LoadNPRMChapters(cb)
		case "NP1C":
			FR_LBDCC_LoadNP1CChapters(cb)
		case "NP2C":
			FR_LBDCC_LoadNP2CChapters(cb)
		case "NPGA":
			FR_LBDCC_LoadNPGAChapters(cb)
		case "NPEP":
			FR_LBDCC_LoadNPEPChapters(cb)
		case "NPPP":
			FR_LBDCC_LoadNPPPChapters(cb)
		case "NPCL":
			FR_LBDCC_LoadNPCLChapters(cb)
		case "NPPM":
			FR_LBDCC_LoadNPPMChapters(cb)
		case "NP1E":
			FR_LBDCC_LoadNP1EChapters(cb)
		case "NP2E":
			FR_LBDCC_LoadNP2EChapters(cb)
		case "NP1I":
			FR_LBDCC_LoadNP1IChapters(cb)
		case "NP2I":
			FR_LBDCC_LoadNP2IChapters(cb)
		case "NPTT":
			FR_LBDCC_LoadNPTTChapters(cb)
		case "NTHB":
			FR_LBDCC_LoadNTHBChapters(cb)
		case "NCIB":
			FR_LBDCC_LoadNCIBChapters(cb)
		case "NC1P":
			FR_LBDCC_LoadNC1PChapters(cb)
		case "NC2P":
			FR_LBDCC_LoadNC2PChapters(cb)
		case "NCID":
			FR_LBDCC_LoadNCIDChapters(cb)
		case "NC1I":
			FR_LBDCC_LoadNC1IChapters(cb)
		case "NC2I":
			FR_LBDCC_LoadNC2IChapters(cb)
		case "NC3I":
			FR_LBDCC_LoadNC3IChapters(cb)
		case "NTAI":
			FR_LBDCC_LoadNTAIChapters(cb)
		}
		CurrentBible.Books = append(CurrentBible.Books, *cb)
	}
}

func FR_LBDCC_LoadNC1IChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Voilà ce qui était depuis le commencement, et que nous avons entendu, et que nos yeux ont vu, et que nos mains ont palpé,- je parle du Verbe qui est la vie. "
,"2":"Car la vie s'est montrée à découvert et c'est la Vie éternelle que nous avons vue,et dont nous parlons,et que nous vous annonçons, - celle qui était auprès du Père avant de nous être montrée à découvert."
,"3":"Donc ce que nous avons vu et entendu, nous vous le faisons aussi savoir pour que vous soyez en communion avec nous,- et nous, nous sommes en communion avec le Père et avec son Fils Jésus Christ."
,"4":"Et nous vous écrivons maintenant pour que notre joie soit parfaite."
,"5":"Voici le message que nous avons reçu de lui et que nous vous annonçons: Dieu est lumière, il n'y a donc rien en lui de ténèbres."
,"6":"Si nous disions que nous sommes en communion avec lui, alors que notre vie est ténèbres, nous serions menteurs, nous ne ferions pas la vérité."
,"7":"Mais si notre vie se déroule dans la lumière, nous sommes en communion les uns avec les autres et le sang de Jésus, son Fils, nous purifie de tout péché."
,"8":"Si nous disions que nous n'avons pas de péché, ce serait nous tromper nous-mêmes: la vérité ne serait pas en nous."
,"9":"Mais si nous reconnaissons nos péchés, lui qui est fidèle et juste nous enlèvera nos péchés: il nous purifiera de tout mal."
,"10":"Si nous disions que nous n'avons pas péché, nous ferions de lui un menteur: sa parole ne serait pas en nous."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Mes petits enfants, je vous écris cela pour que vous ne péchiez pas. Mais si quelqu'un a péché, nous avons un protecteur auprès du Père: Jésus Christ, le Juste."
,"2":"Il est, lui, la victime pour nos péchés, et pas seulement pour les nôtres mais pour ceux du monde entier."
,"3":"Et voilà comment nous saurons que nous le connaissons: si nous gardons ses commandements."
,"4":"Celui qui prétend le connaître et ne garde pas ses commandements est un menteur: la vérité n'est pas chez lui."
,"5":"Mais si quelqu'un garde sa parole, c'est chez lui que l'amour de Dieu est vraiment achevé."
,"6":"Donc voilà comment nous saurons que nous sommes en lui: si quelqu'un pense qu'il demeure en lui, il lui faut vivre de la même façon que Lui a vécu."
,"7":"Mes bien-aimés, ce n'est pas un commandement nouveau que je vous écris, mais le commandement d'autrefois que vous avez depuis le début. Ce commandement d'autrefois, c'est la parole même que vous avez entendue."
,"8":"Et pourtant, c'est un commandement nouveau que je vous écris: il est vraiment neuf en lui et chez nous, et déjà les ténèbres reculent cependant que luit la vraie lumière."
,"9":"Si quelqu'un pense être dans la lumière alors qu'il a de la haine pour son frère, il n'est pas encore sorti des ténèbres."
,"10":"Celui qui aime son frère demeure dans la lumière; il ne reste rien en lui qui puisse le faire chuter."
,"11":"Par contre, celui qui a de la haine pour son frère est en ténèbres et marche dans les ténèbres. Il ne peut savoir où il va, car cette ténèbre l'a privé de la vue."
,"12":"Je vous écris ceci, mes enfants: vos péchés vous sont remis par son Nom."
,"13":"Je vous écris ceci, parents: vous connaissez celui qui est depuis le commencement. Je vous écris ceci, jeunes: vous avez vaincu le Mauvais."
,"14":"Je vous ai écrit, mes enfants, parce que vous connaissez le Père. Je vous ai écrit, parents, parce que vous connaissez celui qui est depuis le commencement. Je vous ai écrit, jeunes, parce que vous êtes forts et que la parole de Dieu demeure en vous et vous avez vaincu le Mauvais."
,"15":"N'aimez pas le monde ni ce qui est dans le monde. Si quelqu'un aime le monde, l'amour du Père n'est pas en lui. "
,"16":"Car tout ce qui est dans le monde, que ce soit le désir de la chair, ou l'avidité des yeux, ou l'arrogance des riches,- cela n'a rien à voir avec le Père, mais avec le monde."
,"17":"Et le monde passe avec sa convoitise, mais celui qui fait la volonté de Dieu demeure pour toujours."
,"18":"Mes enfants, nous sommes à la dernière heure. Vous avez entendu dire qu'un antichrist doit se présenter, et déjà nous avons beaucoup d'antichrists. D'où nous concluons que c'est déjà la dernière heure."
,"19":"Ces gens-là sont sortis d'entre nous, mais ils n'étaient pas des nôtres: s'ils étaient des nôtres, ils seraient restés avec nous. Du coup il est devenu clair que tous ne sont pas des nôtres."
,"20":"Pour vous, vous avez l'onction qui vient du Saint de sorte que tous vous avez la connaissance."
,"21":"Je vous écris, non pas parce que vous ne connaissez pas la vérité mais parce que vous la connaissez et qu'un mensonge n'a rien à voir avec la vérité."
,"22":"Et qui est le menteur? Celui qui nie que Jésus soit le Christ. Vous avez là l'antichrist, celui qui renie à la fois le Père et le Fils. "
,"23":"Car celui qui renie le Fils n'a plus le Père et celui qui reconnaît le Fils a aussi le Père."
,"24":"Pour vous, il faut que reste en vous ce que vous avez entendu dès le début. Si ce que vous avez appris dès le début reste en vous, vous restez vous aussi dans le Fils et dans le Père."
,"25":"C'est là ce que lui-même nous a promis, et c'est la vie éternelle."
,"26":"Je vous écris cela, pensant à ceux qui veulent vous égarer:"
,"27":"puisque l'onction que vous avez reçue de lui demeure en vous, vous n'avez pas besoin qu'on vienne vous enseigner. Il vous a donné l'onction et elle vous instruit de tout; elle est vérité et non mensonge. Donc, ce qu'on vous a enseigné, restez-y attachés."
,"28":"Et maintenant, mes enfants, demeurez en lui. Dans ces conditions nous serons sans crainte lorsqu'il se montrera: nous n'aurons pas à rougir lorsqu'il nous fera rendre compte."
,"29":"Vous savez qu'il est la droiture même: sachez donc que quiconque agit dans la droiture est né de lui."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Voyez quel amour nous a donné le Père: nous sommes appelés enfants de Dieu, et nous le sommes. C'est pourquoi le monde ne nous reconnaît pas: voyez que lui-même n'a pas été reconnu."
,"2":"Mes bien-aimés, nous sommes enfants de Dieu mais on ne peut pas voir encore ce que nous deviendrons. Nous savons cependant que lorsqu'il se montrera à découvert nous serons semblables à lui, parce que nous le verrons comme il est."
,"3":"Quand on attend de lui une telle chose, on veut devenir saint tout comme lui il est saint."
,"4":"Dès qu'on pèche on est en rébellion. Le péché est une rébellion."
,"5":"Mais vous savez que Lui s'est présenté pour prendre le péché sur lui, et le péché n'est pas en lui."
,"6":"Quand on demeure en lui, on ne pèche pas; celui qui vit dans le pèche ne l'a pas encore vu et reconnu."
,"7":"Mes enfants, ne vous laissez pas égarer. Celui qui fait ce qui est juste est juste, tout comme lui est juste et saint."
,"8":"Et celui qui commet le péché appartient au diable puisque le diable ne cesse de pécher depuis le commencement. Et c'est pour cela que le Fils de Dieu s'est manifesté: pour défaire les oeuvres du diable."
,"9":"Ceux qui sont nés de Dieu ne commettent pas le péché, car la semence de Dieu demeure en eux. Ils ne peuvent pas pécher du fait qu'ils sont nés de Dieu."
,"10":"C'est à cela qu'on reconnaît les enfants de Dieu et les enfants du diable: celui qui ne vit pas dans la droiture n'est pas de Dieu: c'est celui qui n'aime pas son frère."
,"11":"Il faut nous aimer les uns les autres: c'est le message que vous avez entendu dès le commencement."
,"12":"N'imitez pas Caïn qui appartenait au Mauvais et qui a tué son frère. Et pourquoi l'a-t-il tué? Parce que ses oeuvres à lui étaient mauvaises alors que son frère faisait le bien."
,"13":"Donc ne vous étonnez pas, frères, quand le monde a pour vous de la haine."
,"14":"Nous voyons que nous sommes passés de la mort à la vie parce que nous aimons nos frères; celui qui n'aime pas reste en état de mort."
,"15":"Celui qui a de la haine pour son frère est un homicide, et vous savez qu'un homicide n'a pas en lui la vie éternelle."
,"16":"Lui, il a donné sa vie pour nous, et c'est là que nous avons connu l'amour. Aussi nous-mêmes, nous devons donner notre vie pour nos frères."
,"17":"Si quelqu'un a les richesses de ce monde et ferme son coeur quand il voit son frère dans le besoin, comment direz-vous que l'amour de Dieu demeure en lui?"
,"18":"Mes enfants, n'aimons pas seulement en paroles, avec nos lèvres, mais en vérité, avec des oeuvres."
,"19":"Alors nous saurons que nous sommes de la vérité et nous pourrons tranquilliser notre coeur devant lui."
,"20":"Car si notre coeur nous accuse, nous dirons que Dieu est plus grand que notre coeur: lui connaît toutes choses."
,"21":"Frères bien-aimés, si notre coeur ne nous accuse pas, nous nous sentons sûrs de Dieu:"
,"22":"tout ce que nous pouvons lui demander, nous le recevrons de lui, du fait que nous observons ses commandements et que nous faisons ce qui lui est agréable."
,"23":"Et quel est son commandement? Que nous croyions au Nom de son Fils, Jésus Christ, et que nous nous aimions les uns les autres comme il nous en a donné l'ordre."
,"24":"Ceux qui observent ses commandements demeurent en lui et lui en eux. Oui, il demeure en nous; l'Esprit qu'il nous a donné nous le fait savoir."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Mes bien-aimés, ne croyez pas à n'importe quel esprit. Voyez donc si les esprits viennent de Dieu, car un bon nombre de faux prophètes se sont présentés dans ce bas monde."
,"2":"Comment reconnaîtrez-vous l'Esprit de Dieu? Tout esprit qui reconnaît Jésus comme le Christ venu dans la chair est de Dieu,"
,"3":"et tout esprit qui ne reconnaît pas Jésus n'est pas de Dieu. Cet esprit est celui de l'antichrist dont on vous a dit qu'il va venir: il est déjà dans le monde."
,"4":"Vous, mes enfants, vous êtes de Dieu et vous avez vaincu ces gens-là, car celui qui est en vous est plus fort que celui qui est dans le monde."
,"5":"Ils sont du monde, leur langage est celui du monde et le monde les écoute."
,"6":"Mais nous, nous sommes de Dieu. Celui qui connaît Dieu nous écoute, celui qui n'est pas de Dieu ne nous écoute pas. Voilà donc comment reconnaître l'esprit de la vérité et l'esprit de l'erreur."
,"7":"Mes bien-aimés, aimons-nous les uns les autres, car l'amour vient de Dieu. Celui qui aime est né de Dieu et connaît Dieu."
,"8":"Celui qui n'aime pas n'a pas connu Dieu, car Dieu est amour."
,"9":"Vous savez comment l'amour de Dieu nous a été révélé: Dieu nous a envoyé son Fils unique dans le monde pour que par lui nous vivions."
,"10":"Voilà comment est l'amour: ce n'est pas nous qui avons aimé Dieu, c'est lui qui nous a aimés, et il a envoyé son Fils pour qu'il soit la victime pour nos péchés."
,"11":"Mes bien-aimés, si Dieu nous a aimés de cette façon, nous aussi nous devons nous aimer les uns les autres."
,"12":"Personne n'a jamais contemplé Dieu, mais si nous nous aimons les uns les autres, Dieu demeure en nous et son amour s'épanouit au milieu de nous."
,"13":"Comment savons-nous que nous demeurons en lui et lui en nous? Parce qu'il nous a donné de son Esprit."
,"14":"Mais aussi nous avons vu et nous affirmons que le Père a envoyé son Fils pour qu'il soit le Sauveur du monde;"
,"15":"et si quelqu'un reconnaît que Jésus est le Fils de Dieu, Dieu demeure en lui et lui en Dieu."
,"16":"Nous avons connu l'amour que Dieu a pour nous et nous y avons cru. Dieu est amour et celui qui demeure dans l'amour demeure en Dieu, et Dieu en lui."
,"17":"Quand l'amour atteint en nous sa perfection, nous attendons sans crainte le jour du Jugement, parce que déjà en ce monde nous sommes comme Lui est."
,"18":"Il n'y a pas de crainte dans l'amour. L'amour parfait met dehors la crainte, car la crainte suppose le châtiment. Tant qu'on a la crainte, on n'a pas la perfection de l'amour."
,"19":"Aimons, car lui nous a aimés le premier."
,"20":"Si quelqu'un prétend aimer Dieu alors qu'il a de la haine pour son frère, c'est un menteur: si on n'aime pas son frère que l'on voit, comment va-t-on aimer Dieu qu'on ne voit pas?"
,"21":"Et nous avons reçu de lui ce commandement: celui qui aime Dieu doit aussi aimer son frère."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Quiconque croit que Jésus est le Christ, est né de Dieu. Mais aussí, si l'on aime celui qui a donné la vie, on aime celui qui est né de lui."
,"2":"Donc, quand nous aimons Dieu et faisons ce qu'il nous demande, nous savons que nous aimons aussi les enfants de Dieu."
,"3":"L'amour de Dieu consiste à observer ses commandements, et ses commandements ne sont pas pesants."
,"4":"En effet, tout ce qui est né de Dieu a la victoire sur le monde: cette victoire remportée sur le monde, c'est notre foi."
,"5":"Qui donc est vainqueur du monde, sinon celui qui croit que Jésus est le Fils de Dieu?"
,"6":"C'est lui, Jésus Christ, qui vient par l'eau et par le sang. Pas seulement par l'eau, mais par l'eau et par le sang. Et l'Esprit est là pour l'affirmer, l'Esprit qui est vérité."
,"7":"Ils sont trois à rendre témoignage:"
,"8":"l'Esprit, l'eau et le sang, et les trois se rencontrent."
,"9":"Nous recevons bien le témoignage des humains: le témoignage de Dieu a bien plus de valeur. Et voici le témoignage de Dieu: il a témoigné au sujet de son Fils."
,"10":"Celui qui croit au Fils de Dieu a donc en lui ce témoignage de Dieu. Par contre, celui qui ne croit pas fait de Dieu un menteur: il ne croit pas au témoignage que Dieu a rendu au sujet de son Fils."
,"11":"Et voici son témoignage: Dieu nous a donné la vie éternelle et cette vie se trouve dans son Fils."
,"12":"Celui qui a le Fils a la vie, celui qui n'a pas le Fils de Dieu n'a pas la vie."
,"13":"Je vous écris donc pour que vous sachiez que vous avez la vie éternelle, vous tous qui croyez au Nom du Fils de Dieu."
,"14":"Avec lui nous nous sentons très forts: nous savons qu'il nous écoute toutes les fois que nous demandons en accord avec sa propre volonté."
,"15":"Et s'il écoute tout ce que nous demandons, nous savons que déjà nous tenons ce que nous lui avons demandé."
,"16":"Si quelqu'un voit son frère dans le péché - un péché qui n'a pas amené la mort - il doit prier, et Dieu donnera vie à ce frère, puisqu'il ne s'agit pas du péché qui donne la mort. Il y a un péché qui donne la mort et je ne dis pas de prier pour ce péché. "
,"17":"Toute faute est péché, mais n'est pas pour autant le péché qui donne la mort."
,"18":"Nous savons que quand on est né de Dieu on ne reste pas dans le péché, car Celui qui est né de Dieu nous garde de pécher: le Mauvais ne peut rien contre nous."
,"19":"Et nous savons que nous sommes à Dieu, alors que le monde entier reste soumis au Mauvais."
,"20":"Nous savons aussi que le Fils de Dieu est venu pour nous ouvrir l'esprit et que nous connaissions Celui qui est vrai: nous sommes en Celui qui est vrai, dans son Fils, Jésus Christ. Lui est le vrai Dieu et il est vie éternelle."
,"21":"Mes enfants, gardez-vous des idoles."
}`)

}
func FR_LBDCC_LoadNC1PChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Lettre de Pierre, apôtre de Jésus Christ, aux émigrants dispersés dans les provinces du Pont, de Galatie, de Cappadoce, d'Asie et de Bithynie,"
,"2":"aux élus que Dieu le Père a connus d'avance et qui ont été sanctifiés par l'Esprit afin de recevoir la foi et d'être lavés par le sang de Jésus Christ. Que la grâce et la paix débordent sur vous!"
,"3":"Béni soit Dieu, le Père de Jésus Christ, notre Seigneur! Comme sa miséricorde est grande! En ressuscitant Jésus Christ d'entre les morts, il nous a donné une vie nouvelle et une vivante espérance."
,"4":"C'est à vous qu'il réservait l'héritage céleste, ce trésor qui ne se perd pas, qui ne se gâte pas, qui ne vieillit pas."
,"5":"La puissance de Dieu vous garde, par le moyen de la foi, en vue du salut qu'il est près de nous dévoiler aux derniers temps."
,"6":"C'est là votre joie, même si pour un moment vous êtes affligés de toutes sortes de calamités."
,"7":"Si l'or doit subir l'épreuve du feu (et ce n'est qu'une chose périssable), combien plus votre foi qui a beaucoup plus de valeur. Et vous en recevrez louange, gloire et honneur quand Jésus Christ se montrera à découvert."
,"8":"Sans le voir vous l'aimez, puisque dès maintenant sans le voir vous croyez en lui, et personne ne saurait exprimer cette joie si élevée"
,"9":"d'avoir déjà, car c'est le but de votre foi, le salut de vos âmes."
,"10":"Les prophètes ont parlé de cette faveur que vous deviez recevoir, ils ont voulu savoir et ils se sont posé bien des questions à propos de ce salut."
,"11":"L'esprit du Christ était en eux et déjà leur faisait connaître ce que le Messie devait souffrir et la Gloire qui lui viendrait ensuite. Mais ils se demandaient: qui sera-t-il? Quand cela sera-t-il?"
,"12":"Ils préparaient ce qui maintient les anges en admiration, et qui maintenant vous a été annoncé par vos évangélisateurs en même temps que du ciel l'Esprit Saint vous était envoyé. Et il leur a été révélé que tout cela serait, sinon pour eux, du moins pour vous."
,"13":"Donc, soyez prêts intérieurement, et restez vigilants. Mettez tous vos espoirs dans ce bien unique que vous apportera la manifestation du Christ Jésus."
,"14":"Puisque vous avez accepté la foi, ne soyez plus à la remorque de vos anciennes passions, comme au temps où vous ne saviez pas."
,"15":"Celui qui vous a appelés est Saint: vous aussi soyez saints dans toute votre façon de vivre."
,"16":"L'Ecriture l'a dit: Soyez saints car je suis Saint."
,"17":"Le Père que vous invoquez ne fera pas de favoritisme mais jugera chacun selon ses oeuvres; veillez donc sur votre conduite tout le temps que vous résidez ici-bas."
,"18":"Vous le savez: vous avez été libérés des vaines pratiques héritées de vos pères, non pas à prix d'or et d'argent ou de valeurs périssables,"
,"19":"mais grâce au sang précieux du Christ, l'Agneau sans tache ni défaut."
,"20":"Dieu pensait à lui dès la création de l'univers, mais c'est à la fin des temps qu'il l'a fait venir pour vous."
,"21":"Et grâce à lui vous avez cru au Dieu qui l'a ressuscité d'entre les morts et lui a donné la Gloire, afin que vous puissiez croire et espérer en Dieu."
,"22":"En acceptant la vérité, vous avez sanctifié vos âmes et vous êtes capables d'un amour fraternel et sincère. Aimez-vous donc réellement les uns les autres du fond du coeur"
,"23":"puisque cette fois-ci vous avez été engendrés, non d'une semence corruptible mais par la parole incorruptible du Dieu qui vit et qui demeure."
,"24":"Oui, toute chair est comme l'herbe, et sa gloire, comme l'herbe des champs. L'herbe a séché et sa fleur est tombée,"
,"25":"mais la parole du Seigneur demeure pour toujours. Et cette parole, c'est l'Evangile que vous avez reçu."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Renoncez donc à tout ce qui est méchanceté et tromperie ou qui n'est pas sincère. Laissez là l'envie et les médisances et,"
,"2":"comme des nouveau-nés, recherchez ce lait authentique de la parole. Elle vous fera grandir et vous mènera à la plénitude."
,"3":"N'avez-vous pas déjà goûté comme le Seigneur est bon?"
,"4":"Vous êtes venus à celui qui est la pierre vivante rejetée par les hommes mais précieuse pour Dieu qui l'a choisie."
,"5":"Et donc vous aussi, devenus pierres vivantes, construisez-vous comme un édifice spirituel, une race sainte de prêtres, pour offrir à Dieu par Jésus Christ les sacrifices spirituels qui lui sont agréables."
,"6":"L'Ecriture dit à ce sujet: Voici que je pose en Sion une pierre choisie, une pierre d'angle de grand prix. Quiconque s'appuie sur elle ne sera pas déçu."
,"7":"Vous serez donc à l'honneur, vous qui croyez. Par contre, pour ceux qui ne croient pas, il est la pierre rejetée par les bâtisseurs, laquelle est devenue pierre d'angle,"
,"8":"un caillou sur lequel on bute, une pierre qui fait chuter. Cette chute, c'est leur refus de croire à la parole, et pour eux c'était prévu."
,"9":"Mais vous êtes une race choisie, vous êtes une communauté de rois et de prêtres, une nation sainte, un peuple que Dieu a fait sien, afin de chanter les grandeurs de celui qui vous a appelés des ténèbres à sa merveilleuse lumière."
,"10":"Vous n'étiez pas un peuple, et vous devenez peuple de Dieu. Vous étiez ceux dont on n'a pas pitié, mais maintenant on a eu pitié de vous."
,"11":"Frères bien aimés, puisque vous êtes ici-bas des hôtes de passage, des migrants, je vous invite à vous abstenir de ces désirs charnels qui font la guerre à vos âmes."
,"12":"Votre belle conduite au milieu des païens fera que ceux qui vous accusent comme des malfaiteurs en viennent à rendre gloire à Dieu au jour de sa visite quand ils auront été témoins de vos bonnes oeuvres."
,"13":"Soumettez-vous à toute créature humaine en pensant au Seigneur. Obéissez au chef de l'Etat parce qu'il occupe le premier poste,"
,"14":"aux gouverneurs, parce qu'il les a chargés de réprimer les malfaiteurs et d'encourager ceux qui agissent bien."
,"15":"Dieu veut qu'à force de faire le bien vous fassiez taire l'ignorance des imbéciles."
,"16":"Soyez libres comme peuvent l'être des serviteurs de Dieu: la liberté n'est pas un prétexte pour mal faire."
,"17":"Respectez tout le monde et aimez ceux de votre communauté. Craignez Dieu et respectez le roi."
,"18":"Les serviteurs seront soumis et respectueux envers leurs patrons, pas seulement ceux qui sont bons et compréhensifs, mais aussi ceux qui sont désagréables."
,"19":"Oui, c'est une bonne chose d'être puni injustement quand on agit en conscience et pour Dieu."
,"20":"Quel mérite y a-t-il à accepter les coups après qu'on a fauté? Mais si vous êtes capables de souffrir après avoir bien agi, voilà qui est grand devant Dieu."
,"21":"Et c'est à cela que vous avez été appelés. Car en souffrant pour vous le Christ vous a laissé un exemple: vous devez suivre ses traces."
,"22":"Lui n'a pas fait le mal et n'a pas dit de mensonge."
,"23":"On l'insultait et il n'a pas insulté. Il n'a pas maudit quand il souffrait mais il s'en est remis à celui qui juge avec justice."
,"24":"Il a pris nos péchés sur lui-même, sur le bois de la croix, pour que nous soyons délivrés de nos péchés et que nous vivions saintement. Vous avez été guéris grâce à son supplice."
,"25":"Car vous étiez des brebis égarées, mais maintenant vous êtes revenus au berger qui veille sur vos âmes."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Dans cet esprit, que les épouses soient soumises à leurs maris. Ceux d'entre eux qui n'ont pas accueilli la foi seront gagnés par la conduite de leurs épouses mieux que par des discours."
,"2":"Il leur suffira de voir comme vous veillez à être sans reproche."
,"3":"On ne vous verra pas la parure extérieure: coiffure, robes et bijoux,"
,"4":"mais la personne intérieure, cette réalité secrète mais divine qu'est l'esprit de douceur et de paix. C'est cela qui compte au regard de Dieu. "
,"5":"Telle était autrefois la parure des saintes femmes qui mettaient en Dieu leur espérance. Et elles étaient soumises à leur mari,"
,"6":"Sara, par exemple, qui obéissait à Abraham et l'appelait 'Mon seigneur'. Vous êtes filles de Sara pour faire le bien sans que rien vous arrête."
,"7":"Que les hommes à leur tour mènent la vie commune de façon responsable. Vos compagnes sont des êtres plus faibles, évitez donc les menaces, sachant que vous partagez ensemble le don de la vie. Autrement vos prières ne seraient pas écoutées."
,"8":"Finalement, que tous vivent en bonne entente et soient unis de coeur. Aimez vos frères, pensez aux autres et soyez humbles de coeur."
,"9":"Ne rendez pas le mal pour le mal, ou l'insulte pour l'insulte. Au contraire bénissez, puisque c'est votre vocation, et vous recevrez la bénédiction:"
,"10":"Si quelqu'un aime la vie, s'il veut voir des jours heureux, que sa langue s'abstienne du mal et ses lèvres de la parole mensongère,"
,"11":"qu'il évite le mal et fasse le bien, qu'il cherche la paix et la poursuive à tout prix."
,"12":"Car le Seigneur a les yeux fixés sur les justes et il écoute leur prière, mais il tient tête à ceux qui font le mal."
,"13":"Et qui pourra vous nuire si vous êtes passionnés pour le bien?"
,"14":"Heureux serez vous quand vous aurez à souffrir pour une cause juste! N'ayez pas peur de ce qui leur fait peur et ne vous troublez pas."
,"15":"Le Christ est le Seigneur, le seul Saint que reconnaîtra votre coeur. Soyez toujours prêts à défendre l'espérance qui est en vous dès que quelqu'un vous demande vos raisons. "
,"16":"Mais faites-le toujours avec calme et respect puisque vous avez bonne conscience. Et si on vous accuse, la honte sera pour ceux qui calomnient la vie droite des chrétiens."
,"17":"Il vaut mieux souffrir pour avoir fait le bien, si telle est la volonté de Dieu, que pour avoir fait le mal."
,"18":"Le Christ est mort une seule fois pour les péchés et c'était le juste mourant pour les pécheurs, pour nous conduire à Dieu. Il a pu être mis à mort: il était chair; l'Esprit l'a rendu à la vie. "
,"19":"C'est alors qu'il est allé prêcher aux emprisonnés,"
,"20":"tous ces gens d'autrefois qui n'avaient pas voulu croire quand Dieu se montrait patient. C'était le temps de Noé qui, lui, construisait l'arche où quelques uns seulement, huit en tout, furent sauvés des eaux."
,"21":"Vous reconnaissez là le baptême qui maintenant vous sauve. Ce n'est pas le nettoyage d'une impureté corporelle, c'est une façon de demander à Dieu qu'il nous renouvelle grâce à la résurrection de Jésus Christ."
,"22":"Il est parti vers le ciel et il est à la droite de Dieu: les anges et les puissances célestes lui ont été soumis."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Voyez cette souffrance du Christ en sa chair et armez-vous de cette conviction: Celui qui a souffert dans la chair en a fini avec le péché."
,"2":"Tout le temps qui vous reste à vivre dans la chair sera pour satisfaire, non des passions humaines, mais la volonté de Dieu."
,"3":"Nous avons donné assez de temps à tout ce que veulent les païens: les excès, les passions, les beuveries, les orgies et le culte des idoles."
,"4":"Ils trouvent étrange que vous ne courriez plus avec eux à ce débordement de plaisirs, ils trouvent même à y redire."
,"5":"Mais ils devront rendre compte à celui qui bientôt jugera les vivants et les morts."
,"6":"Ce n'est pas sans raison que la bonne nouvelle a été portée aussi aux morts: comme humains, ils ont reçu une sentence de mort, mais grâce à l'Esprit ils vivront pour Dieu."
,"7":"La fin de tout est maintenant proche. Vivez comme des sages et consacrez vos soirées à la prière."
,"8":"Avant tout, ayez les uns pour les autres un amour vrai, car l'amour fait pardonner de nombreux péchés."
,"9":"Donnez-vous l'hospitalité sans récriminer."
,"10":"Chacun a reçu son propre talent: qu'il le mette au service des autres. Vous serez ainsi de bons administrateurs des dons multiples de Dieu."
,"11":"Si l'on prend la parole, que ce soient des paroles de Dieu; si on est chargé d'un service, que ce soit avec la force de Dieu. Et Dieu sera ainsi glorifié en tout dans le Christ Jésus. A lui la gloire et la puissance pour les siècles des siècles! Amen."
,"12":"Frères bien aimés, ne vous étonnez pas du feu qui a flambé au milieu de vous: qu'une telle épreuve survienne n'a rien d'étrange."
,"13":"Réjouissez-vous de communier aux souffrances du Christ: c'est ainsi que vous connaîtrez les grandes joies le jour où sa Gloire se montrera à découvert."
,"14":"Heureux êtes-vous si l'on vous traite de tous les noms à cause du Christ, car la gloire et l'Esprit de Dieu reposent sur vous."
,"15":"Il ne faudrait pas que vous soyez condamnés comme meurtriers ou voleurs ou complices de malfaiteurs."
,"16":"Mais si c'est pour être chrétiens, n'ayez pas de honte: que ce nom soit un moyen de rendre gloire à Dieu."
,"17":"Le moment est venu, et le Jugement commence par les familiers de Dieu. Si nous devons y passer les premiers, que sera-ce à la fin pour ceux qui n'ont pas cru à la Bonne Nouvelle de Dieu?"
,"18":"Si l'homme droit s'en tire tout juste, qu'en sera-t-il du pécheur et des gens sans foi?"
,"19":"Si vous souffrez parce que telle est la volonté de Dieu, persévérez dans le bien et remettez vos âmes au Créateur: lui est fidèle."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Et maintenant je m'adresse aux Anciens parmi vous. Comme vous je suis ancien et témoin des souffrances du Christ, et avec vous j'aurai part à la Gloire qui doit se manifester."
,"2":"Prenez soin du troupeau de Dieu là où vous êtes, non pas par obligation, mais de plein gré, pour Dieu. Ne soyez pas intéressés: faites-le de bon coeur."
,"3":"Ne vous posez pas en maîtres du domaine; soyez simplement les modèles du troupeau."
,"4":"Et quand le suprême Pasteur se montrera à découvert, vous recevrez dans la Gloire, la couronne qui ne se fane pas."
,"5":"Et vous, les plus jeunes, obéissez aux Anciens. Essayez de rivaliser entre vous à qui sera le plus humble, car Dieu résiste aux orgueilleux et il donne aux humbles."
,"6":"Courbez-vous donc sous la main puissante de Dieu, pour qu'il vous relève le moment venu."
,"7":"Rejetez sur lui tous vos soucis, il s'en chargera pour vous."
,"8":"Soyez sur vos gardes et restez éveillés: le diable, votre adversaire, est comme un lion rugissant, il va et vient cherchant qui dévorer."
,"9":"Restez fermes dans la foi de façon à lui résister. Vous savez que les nôtres qui vivent en ce monde sont en butte aux mêmes épreuves."
,"10":"Dieu n'est que bonté: après vous avoir appelés dans le Christ à sa gloire éternelle, il vous laisse souffrir un moment pour vous façonner, vous affermir, vous fortifier et vous donner votre place définitive."
,"11":"A lui la puissance pour les siècles des siècles! Amen."
,"12":"C'est à Silvain que j'ai fait appel pour vous écrire ces quelques lignes, car je vois en lui un frère digne de confiance. J'ai voulu vous encourager et vous redire que tout ceci est grâce de Dieu: restez fermes."
,"13":"L'Eglise qui se rassemble en cette Babylone vous salue, de même que Marc, mon fils."
,"14":"Saluez-vous les uns les autres avec le baiser de la charité."
,"15":"Paix à vous tous dans le Christ."
}`)

}
func FR_LBDCC_LoadNC2IChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Lettre de l'Ancien à la Dame élue et à ses enfants. Je les aime selon la vérité - pas seulement moi, mais tous ceux qui connaissent la vérité - "
,"2":"et grâce à cette vérité qui demeure en nous et qui sera avec nous pour toujours."
,"3":"Recevez donc de Dieu le Père et de Jésus Christ, le Fils du Père, grâce, miséricorde et paix, fruits de son amour et de sa fidélité."
,"4":"J'ai eu grand plaisir à rencontrer quelques-uns de tes enfants qui vivent dans la vérité, selon l'ordre que nous avons reçu du Père."
,"5":"Et maintenant je t'en prie, Madame - ce n'est pas un commandement nouveau que je te donne, mais celui que nous avons depuis le commencement: aimons-nous les uns les autres."
,"6":"Et l'amour, c'est de vivre d'accord avec ses commandements. Voilà le commandement que vous avez appris dès le commencement. Il faut en faire notre vie."
,"7":"Bien des charlatans sont entrés dans ce monde, des gens qui ne croient pas que Jésus est le Christ venu dans la chair. C'est là qu'on reconnaît le charlatan et l'antichrist."
,"8":"Faites attention à ne pas perdre ainsi le prix de vos travaux: vous voudrez sûrement recevoir un salaire intégral."
,"9":"Dès qu'on ne s'en tient pas à la doctrine du Christ et qu'on croit faire mieux, on n'a plus Dieu. Mais celui qui reste dans la doctrine, c'est lui qui a le Père et le Fils."
,"10":"Si quelqu'un arrive chez vous et ne tient pas cette doctrine, ne le recevez pas et ne le saluez même pas."
,"11":"Rien que de le saluer, vous deviendriez complices de ses mauvaises actions."
,"12":"Je voudrais te dire bien des choses, mais pas par lettre, avec de l'encre et du papier. Je compte bien aller chez vous et nous parlerons de vive voix de sorte que notre joie soit parfaite."
,"13":"Les enfants de ta Soeur élue te saluent."
}`)

}
func FR_LBDCC_LoadNC2PChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Lettre de Syméon Pierre, serviteur et apôtre de Jésus Christ, à ceux qui comme nous ont la chance de posséder une foi si précieuse et d'être sanctifiés par notre Dieu et Sauveur Jésus Christ."
,"2":"Que la grâce et la paix grandissent en vous, en même temps que la connaissance de Dieu et de Jésus Christ, notre Seigneur!"
,"3":"Son pouvoir divin nous a donné tout ce qui mène à la vie et à la piété. Tout d'abord la connaissance de celui qui nous a appelés par sa propre Gloire et Puissance,"
,"4":"et par elles, nous a donné ce que l'on peut offrir de plus grand et de plus précieux. Oui, par elles vous devenez participants de la nature divine et vous échappez à la corruption qui en ce monde est soeur du désir."
,"5":"Faites donc tout le nécessaire pour acquérir avec la foi la vertu, avec la vertu la connaissance,"
,"6":"avec la connaissance la maîtrise des instincts, avec la maîtrise des instincts la persévérance, avec la persévérance l'esprit religieux,"
,"7":"avec l'esprit religieux l'amour fraternel, avec l'amour fraternel l'amour pur."
,"8":"Si vous avez toutes ces vertus à un degré élevé, vous ne serez pas des inutiles, des improductifs, mais vous atteindrez la connaissance de Jésus Christ notre Seigneur."
,"9":"Par contre, si quelqu'un n'a rien de tout cela, c'est un aveugle ou un myope. Il ne sait déjà plus qu'il a été purifié de ses anciens péchés."
,"10":"Mais vous, frères, faites tout pour confirmer votre appel et votre élection. Agissez comme je dis et vous ne retomberez pas."
,"11":"C'est ainsi que vous sera généreusement donné l'accès au royaume éternel de notre Seigneur et sauveur Jésus Christ."
,"12":"Donc je ne cesserai pas de vous rappeler tout cela, bien que vous le sachiez déjà et que vous teniez fermement la vérité que vous possédez."
,"13":"Je crois bon de vous rafraîchir la mémoire tant que je vis dans la présente demeure,"
,"14":"car je sais que bientôt cette tente me sera enlevée de la façon que Jésus Christ notre Seigneur me l'a fait savoir."
,"15":"Aussi je fais tout pour qu'après mon départ vous puissiez vous rappeler ces choses."
,"16":"Quand nous vous avons instruits sur la puissance et le retour de notre Seigneur Jésus Christ, nous ne reprenions pas des fables bien tournées: nous-mêmes avons contemplé sa grandeur"
,"17":"quand il a reçu honneur et gloire de Dieu le Père. Alors, des paroles extraordinaires lui ont été adressées par la glorieuse Majesté: 'Voici mon Fils, le Bien aimé, celui en qui je me complais.'"
,"18":"Cette voix envoyée du ciel, nous l'avons entendue, car nous étions avec lui sur la sainte montagne."
,"19":"Moyennant quoi le message des prophètes a pris pour nous une force nouvelle: vous ferez bien de le regarder comme une lampe qui brille en un lieu obscur en attendant la clarté du jour, lorsque l'Etoile du matin se lèvera sur vos coeurs."
,"20":"Sachez-le bien: aucune prophétie de l'Ecriture ne peut dépendre d'une interprétation personnelle,"
,"21":"car aucune prophétie n'est venue d'une initiative humaine, mais c'est sous l'impulsion de l'Esprit Saint que les hommes de Dieu ont parlé."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Il y a eu des faux prophètes dans le peuple d'Israël, et de même il y aura parmi vous de faux enseignants. Ils introduiront des sectes néfastes, mais sans tarder ils iront à leur perte pour avoir renié le Maître qui les avait rachetés."
,"2":"Beaucoup de gens imiteront leurs vices, et par leur faute le Chemin de la vérité sera discrédité."
,"3":"Ces gens intéressés essaieront de vous avoir avec leurs boniments, mais déjà leur condamnation a été prononcée; elle ne traînera pas et leur perte les attend."
,"4":"De fait, Dieu n'a pas épargné les anges qui avaient péché. Il les a jetés dans les sombres précipices de l'enfer en attendant le jour du jugement."
,"5":"Il n'a pas épargné non plus le monde antique quand il a lâché les eaux du Déluge sur le monde des méchants. Il n'a protégé que Noé, le huitième porte-parole de la vraie droiture."
,"6":"De même il a condamné les villes de Sodome et Gomorrhe. Il les a réduites en cendres, il en a fait un exemple pour les dévoyés à venir."
,"7":"Mais il a sauvé Lot, cet homme droit qui souffrait de voir la conduite et les excès de ce peuple pervers."
,"8":"Cet homme droit vivait au milieu d'eux et, jour après jour, sa conscience droite était choquée de tout ce qu'il voyait et entendait de leurs oeuvres mauvaises."
,"9":"Le Seigneur sait donc sauver de l'épreuve ceux qui le servent, et par contre il réserve les méchants pour le jour du Jugement où il les punira."
,"10":"Il le fera tout spécialement pour certaines personnes qui obéissent aux sales désirs de leur nature et méprisent sa majesté. Ils sont si orgueilleux et téméraires qu'ils n'hésitent pas à insulter les gloires déchues,"
,"11":"alors que les anges, avec toute leur force et leur puissance, ne se permettent pas de leur lancer des insultes en présence du Seigneur."
,"12":"Ces gens-là salissent ce qu'ils ne comprennent pas. Ils sont comme des animaux sans raison qui n'existent que pour être pris et tués. Quand ils auront bien sali ce qu'ils sont incapables de comprendre, ils disparaîtront de la même façon,"
,"13":"recevant ainsi la peine due au péché. Leur bonheur, c'est le plaisir d'un jour. Hommes souillés et vicieux qui s'amusent à profiter de vous et faire bombance à vos repas!"
,"14":"Ils ne peuvent regarder une femme sans la désirer; ils n'arrêtent pas de pécher et de séduire les caractères faibles; ce sont des maudits exercés à la convoitise."
,"15":"Ils ont abandonné le droit chemin pour se mettre à l'école de Balaam, fils de Béor, qui aimait gagner de l'argent en faisant le mal."
,"16":"Et vous savez qui lui a dit en face son péché: son ânesse s'est mise à parler avec une voix humaine et elle a obligé le prophète à cesser ses folies."
,"17":"Ce sont des sources sans eau, des nuages d'ouragan emportés par le vent qui vont se perdre dans les ténèbres!"
,"18":"Leurs discours vides et prétentieux encouragent les désirs impurs de ceux qui venaient tout juste de se libérer, et ils les font retomber dans l'erreur."
,"19":"Ils leur parlent de liberté alors qu'ils sont esclaves de la corruption - car on est esclave de ce qui vous tient enchaîné."
,"20":"Alors qu'ils venaient d'échapper aux vices de ce monde grâce à la connaissance du Seigneur et Sauveur Jésus Christ, voilà qu'ils s'y replongent et se laissent dominer par eux."
,"21":"Il aurait mieux valu pour eux ne jamais connaître les chemins de la sainteté, que de la reconnaître et puis de renoncer à la sainte discipline qui leur avait été donnée."
,"22":"Pour eux vaut le proverbe qui dit: Le chien est retourné à son vomissement; et cet autre proverbe: 'A peine lavé, le cochon s'est roulé dans la boue.'"
}`)
	CurrentBook.AddChapter(3, `{
"1":"Frères bien-aimés, cette lettre est la deuxième que je vous écris. Dans les deux j'ai voulu vous rappeler la saine doctrine."
,"2":"Rappelez-vous les paroles prononcées autrefois par les saints prophètes, et la consigne de vos apôtres qui est celle de notre Seigneur et Sauveur."
,"3":"Sachez d'abord que dans les derniers jours des gens se présenteront qui se laisseront mener par leurs désirs, et se moqueront de tout."
,"4":"Ils diront: 'Qu'est devenue la promesse de sa venue? Nos pères dans la foi sont morts et tout continue comme depuis le début du monde.'"
,"5":"Ils veulent ignorer qu'il y a eu un ciel, avec une terre qui est sortie des eaux et s'est maintenue au milieu des eaux par la parole de Dieu."
,"6":"Après quoi, par la même parole, le monde d'alors a péri englouti dans les eaux."
,"7":"De même, c'est la parole de Dieu qui maintient les cieux et la terre que nous voyons, et ils finiront par le feu au jour du jugement, quand les hommes sans foi ni loi seront détruits."
,"8":"N'oubliez pas, frères bien-aimés, qu'un seul jour du Seigneur vaut mille ans et mille ans ne sont pour lui qu'un seul jour."
,"9":"Le Seigneur n'est pas en retard pour sa promesse - puisque certains parlent de retard -. C'est plutôt de la générosité à votre égard, car il ne veut pas que certains se perdent mais que tous arrivent à la conversion."
,"10":"Le jour du Seigneur viendra comme un voleur. Alors les cieux s'en iront dans un grand vacarme; tous les éléments seront fondus par la chaleur et la terre brûlera avec tout ce qui s'y trouve."
,"11":"Si tout doit disparaître ainsi, quelle devrait être votre conduite! Il vous faut une vie sainte et religieuse"
,"12":"tandis que vous attendez et désirez la venue du jour du Seigneur où les cieux se déferont dans les flammes et les éléments fondront dans la chaleur."
,"13":"Mais nous attendons, car Dieu l'a promis, des cieux nouveaux et une terre nouvelle où règnera la droiture."
,"14":"Donc, frères bien-aimés, si c'est là ce que vous attendez, faites le nécessaire pour être sans souillure ni défaut et que Dieu vous rencontre dans la paix."
,"15":"Croyez bien que si Dieu prend son temps, c'est pour vous sauver. D'ailleurs Paul, notre frère bien-aimé, vous a écrit à ce sujet avec la sagesse que Dieu lui a donnée."
,"16":"Il en parle dans toutes ses lettres. Il faut le reconnaître, elles sont parfois difficiles à comprendre et les gens sans instruction ou peu sûrs les comprennent de travers pour leur propre dommage, comme ils font avec les autres Ecritures."
,"17":"Mais vous, frères bien-aimés, vous voilà avertis. Soyez sur vos gardes de peur que les égarés ne vous entraînent à votre tour et vous fassent tomber alors que vous étiez fermes."
,"18":"Progressez dans l'amour et dans la connaissance de notre Seigneur et Sauveur Jésus Christ, à qui soit la gloire maintenant et jusqu'au jour qui n'aura pas de fin."
}`)

}
func FR_LBDCC_LoadNC3IChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Lettre de l'Ancien à notre très cher Gaïus: je l'aime selon la vérité."
,"2":"Très cher, puisque ton âme est sur la bonne voie, je souhaite que tu sois en bonne santé et que tout aille bien pour toi."
,"3":"Cela a été pour moi une vraie joie quand sont arrivés les frères qui nous ont dit la vérité à ton sujet: tu vis bien dans la vérité."
,"4":"Je n'ai pas de plus grande joie que d'apprendre que mes enfants vivent dans la vérité."
,"5":"Très cher, tu fais toujours bien quand tu te mets au service de nos frères - c'étaient pour toi des étrangers."
,"6":"Ils ont fait l'éloge de ta charité devant toute l'Eglise, et tu as bien agi quand tu les a congédiés d'une façon si digne de Dieu."
,"7":"De fait, c'est pour le Nom qu'ils étaient en mission et ils n'attendaient rien des non-chrétiens."
,"8":"Nous devons accueillir les gens comme eux si nous voulons aider la vérité."
,"9":"J'ai écrit à l'Eglise. Mais Diotréphès se sent si bien le numéro un qu'il ne tient pas compte de nous."
,"10":"Aussi, si j'y vais, je lui rappellerai sa conduite car il ne manque pas de dire du mal de nous. Et comme si cela ne suffisait pas, il ne reçoit pas les frères, et ceux qui voudraient les recevoir, il le leur défend et il les expulse de l'Eglise."
,"11":"Très cher, n'imite pas le mal mais le bien. Celui qui fait le bien est de Dieu, celui qui fait le mal n'a pas vu Dieu."
,"12":"Quant à Démétrius, tous disent du bien de lui, la Vérité aussi. Nous aussi nous faisons son éloge, et tu sais que notre témoignage est vrai."
,"13":"Je voudrais te dire bien des choses, mais pas par lettre, avec de l'encre et du papier."
,"14":"J'espère te voir bientôt et nous parlerons de vive voix."
,"15":"Paix à toi. Les amis te saluent. Salue personnellement nos amis."
}`)

}
func FR_LBDCC_LoadNCIBChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Jacques, serviteur de Dieu et du Christ Jésus, le Seigneur, salue les Douze tribus dispersées dans le monde."
,"2":"Frères, croyez que c'est pour vous une bonne fortune quand vous passez par des épreuves de toute sorte."
,"3":"Cette mise à l'épreuve de votre foi développe votre force de résistance,"
,"4":"et votre force de résistance doit atteindre un sommet si vous voulez être vous-mêmes parfaits, complets, sans rien de négatif."
,"5":"Si quelqu'un voit que la sagesse lui fait défaut, qu'il demande à Dieu et il recevra, car Dieu donne volontiers à tous, sans se faire prier."
,"6":"Mais il faut demander avec foi, sans avoir peur, car celui qui hésite est comme les vagues de la mer, livrées aux vents."
,"7":"Celui qui en est là ne doit pas croire qu'il recevra quoi que ce soit du Seigneur."
,"8":"L'homme incertain, toute son existence sera instable."
,"9":"Le frère de condition inférieure doit se réjouir quand sa situation s'améliore."
,"10":"Et le riche, de même, doit se réjouir quand il est rabaissé, car il lui faut passer comme la fleur des champs."
,"11":"Le soleil se lève et vient la chaleur, l'herbe se dessèche, sa fleur tombe et perd sa belle apparence. Le riche de même verra retomber ses affaires."
,"12":"Heureux l'homme qui a supporté l'épreuve; car celui qui en est sorti éprouvé, recevra la couronne de vie que Dieu a promise à ceux qui l'aiment."
,"13":"Il ne faut jamais dire au moment de l'épreuve: 'Dieu veut me faire tomber!' Car, si Dieu est à l'abri de tout mal, de son côté il ne cherche à faire tomber personne."
,"14":"Pour chacun la tentation vient de sa propre convoitise qui l'attire et le séduit."
,"15":"Alors la convoitise devient mère et met au monde le péché. Le péché grandit, mûrit, et la mort est son fruit."
,"16":"Donc, mes bien aimés, ne vous y trompez pas:"
,"17":"toute chose bonne qui vous est donnée, tout don parfait, vient d'en haut. Il descend d'auprès du Père, chez qui la lumière est toujours au fixe et les ombres ne passent pas."
,"18":"De propos délibéré, il nous a engendrés par la parole de vérité pour que nous soyons la fleur de toute sa création."
,"19":"Voyez, frères bien aimés: chacun doit être prêt à écouter, et ne pas parler tout de suite - et ne pas se mettre tout de suite en colère."
,"20":"Car la colère d'un homme ne fait pas la justice de Dieu."
,"21":"Remplacez donc par la douceur toutes les ordures et les excès du mal, et accueillez la parole qu'on a semée en vous, qui a le pouvoir de sauver vos âmes."
,"22":"Ne soyez pas seulement des auditeurs de la parole; passez à l'action, ou bien vous êtes dans l'illusion."
,"23":"Un auditeur de la parole qui ne passe pas à l'action est comme cet homme qui observait son visage dans un miroir; il se regardait, mais sitôt parti il ne savait plus comment il était."
,"25":"C'est le contraire pour celui qui se penche sur la loi parfaite, la loi libératrice, et qui s'y attarde, et qui passe aux oeuvres au lieu de rester un auditeur. Heureux est-il, car il l'a mise en pratique."
,"26":"Si quelqu'un se croit très religieux alors qu'il ne contrôle pas ses paroles, il se trompe lui-même et sa religion ne vaut rien."
,"27":"Voici quelle est la religion sincère et sans reproche aux yeux de Dieu notre Père: prendre soin des orphelins et des veuves en détresse et ne pas se laisser contaminer par le monde."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Frères, il ne faut plus de favoritisme si vous avez la foi du Christ glorieux, Jésus, notre Seigneur."
,"2":"Je suppose qu'un homme bien habillé entre dans votre salle et il a même une bague en or. Un pauvre entre aussi avec des habits tachés."
,"3":"Et alors tous vos regards sont pour l'homme bien habillé et vous lui dites: 'Prends donc cette bonne place.' Quant au pauvre, vous lui dites: 'Assieds-toi ici, au bas de l'estrade.'"
,"4":"Dites-moi: Vous faites bien une différence! Et vous jugez à partir de critères pitoyables"
,"5":"Ecoutez, frères bien aimés: Dieu a choisi les pauvres de ce monde, faisant d'eux les riches de la foi et les héritiers du royaume qu'il promet à ceux qui l'aiment."
,"6":"Alors, c'est vous qui méprisez le pauvre? Pourtant ce sont les riches qui vous écrasent et qui vous traînent devant les tribunaux;"
,"7":"ce sont eux qui insultent le Nom merveilleux qu'on a fait descendre sur vous."
,"8":"Vous faites bien quand vous suivez la Loi Royale selon ce qui est écrit: Tu aimeras ton prochain comme toi-même."
,"9":"Mais si vous faites des différences entre les personnes, vous commettez un péché et la Loi vous dénonce comme des coupables."
,"10":"Si on observe toute la Loi sauf un commandement où on faute, on se verra accuser par tous les autres commandements."
,"11":"Car celui qui a dit: Tu ne commettras pas d'adultère a dit aussi: Tu ne tueras pas. Et si tu tues mais ne commets pas l'adultère, c'est assez pour violer la Loi."
,"12":"Donc parlez et agissez en sachant qu'on vous jugera d'après la loi de liberté."
,"13":"Le jugement sera sans pitié pour ceux qui n'ont pas fait miséricorde, alors que la miséricorde n'a rien à craindre du jugement."
,"14":"Mes frères, si quelqu'un prétend avoir la foi, mais n'a pas les oeuvres, qu'est-ce qu'il y gagne? Cette foi va-t-elle le sauver?"
,"15":"Si un frère ou une soeur n'ont pas de vêtement, rien à manger pour aujourd'hui,"
,"16":"et vous leur dites: 'J'espère que tout ira bien pour toi, que tu auras chaud, que tu auras à manger'. Qu'est-ce qu'ils y gagnent tant que vous ne donnez pas à leur corps le nécessaire?"
,"17":"C'est pareil pour la foi. Si elle ne produit pas les oeuvres, elle meurt dans son coin."
,"18":"Il sera facile de dire à quelqu'un: 'Tu as la foi et moi les oeuvres? Montre-moi donc cette foi sans les oeuvres, et je te ferai voir ma foi à partir des oeuvres.'"
,"19":"Tu crois qu'il n'y a qu'un seul Dieu? Très bien. Mais les démons aussi croient, et ils tremblent. Faut-il te démontrer, tête sans cervelle, que la foi sans les oeuvres n'a aucun sens?"
,"21":"C'est grâce à ses oeuvres que notre père Abraham est devenu juste et saint quand il a offert son fils Isaac sur l'autel."
,"22":"Ne vois-tu pas que la foi accompagnait ses oeuvres et qu'elle est arrivée à maturité grâce aux oeuvres?"
,"23":"C'est alors que l'Ecriture a pu dire: Abraham crut à Dieu et pour cela il fut fait juste et saint et il fut appelé ami de Dieu."
,"24":"Comprenez donc qu'on est fait juste à partir des oeuvres et non à partir de la foi seule."
,"25":"Et ce fut pareil pour Rahab, la prostituée. Elle fut admise parmi les justes à cause de ses oeuvres, car elle reçut les envoyés et leur permit de retourner par un autre chemin."
,"26":"De même qu'un corps sans esprit est mort, la foi aussi est morte s'il n'y a pas les oeuvres."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Frères, ne devenez pas tous des maîtres; vous savez que cela nous vaudra un jugement plus rigoureux,"
,"2":"et tous nous avons nos chutes. Celui qui ne faute pas en paroles est un homme vraiment parfait: il sera capable de se contrôler tout entier. "
,"3":"Nous mettons un frein dans la bouche des chevaux pour qu'ils nous obéissent: avec cela nous dirigeons tout leur corps."
,"4":"Voyez aussi les bateaux: il suffit d'un modeste gouvernail pour qu'un grand bateau poussé par des vents puissants aille au gré du pilote."
,"5":"C'est pareil pour la langue. Elle est petite mais les effets en sont terribles: voyez le feu et ce qu'il est capable de brûler."
,"6":"La langue est un feu et elle est un monde d'injustice: la langue est au centre de notre organisme. Elle est capable de souiller tout le corps, et quand le feu de l'enfer s'y met, elle le communique à toute notre existence."
,"7":"Les bêtes de toute espèce, les oiseaux, les serpents et les poissons peuvent être soumis et se soumettent à la race humaine."
,"8":"Mais chez nous, personne ne peut dominer la langue. C'est un mal qu'on ne peut arrêter; elle est pleine d'un venin mortel."
,"9":"Avec elle nous bénissons notre Seigneur et Père; avec elle nous maudissons les hommes faits à l'image de Dieu."
,"10":"De la même bouche sortent la bénédiction et la malédiction. Frères, cela ne peut pas être!"
,"11":"Une source peut-elle faire jaillir le doux et l'amer?"
,"12":"Frères, le figuier ne donne pas des olives, ni la vigne des figues, et la lagune saumâtre ne donnera jamais d'eau douce."
,"13":"Te voilà donc sage et instruit? Si ta sagesse est sans prétention, on en verra les effets dans ta belle conduite."
,"14":"Mais si elle te rend amer, jaloux, prétentieux, ne te vante pas: tu parlerais contre la vérité."
,"15":"Ce genre de sagesse ne vient pas d'en haut mais de la nature, de toi-même ou du démon."
,"16":"Là où il y a rivalité et prétention, on trouve aussi de l'instabilité et bien des choses mauvaises."
,"17":"La sagesse qui vient d'en haut est d'abord sainteté. Ensuite elle est pacifique, capable de comprendre les autres et d'obéir, pleine d'indulgence et de bonnes initiatives; elle est impartiale et jamais hypocrite."
,"18":"Ceux qui travaillent pour la paix sèment dans la paix et récoltent le bien."
}`)
	CurrentBook.AddChapter(4, `{
"1":"D'où viennent vos guerres et vos conflits? D'ici-bas, bien sûr, de vos propres désirs qui mettent la guerre en vous-mêmes."
,"2":"Vous voudriez avoir et vous n'avez pas: alors vous tuez. Vous êtes jaloux et vous n'obtenez pas: alors ce ne sont que guerres et conflits. Mais si vous n'avez pas, c'est que vous ne priez pas. "
,"3":"Ou bien vous priez mais vous priez mal, et vous n'obtenez rien car vous le dépenseriez pour vos plaisirs."
,"4":"Race adultère! Ne savez-vous pas que l'amitié du monde est l'ennemie de Dieu? Qui veut être ami du monde prend parti contre Dieu."
,"5":"Ce n'est pas pour rien que l'Ecriture dit: L'esprit qui habite en nous désire et n'est jamais satisfait."
,"6":"Mais Dieu a mieux encore à nous donner, et elle dit: Dieu résiste aux orgueilleux et ses dons sont pour les humbles."
,"7":"Soumettez-vous donc à Dieu. Résistez au démon et il s'enfuira. Allez vers Dieu et il viendra à vous."
,"8":"Lavez vos mains, pécheurs, et purifiez vos coeurs, vous qui ne savez pas vous décider. Lamentez-vous et pleurez."
,"9":"Lamentez-vous au lieu de rire, car c'est le temps des larmes et non de la joie."
,"10":"Humiliez-vous devant le Seigneur et lui vous relèvera."
,"11":"Frères, ne dites pas du mal les uns des autres. Celui qui parle contre son frère et se fait le juge de son frère, parle contre la Loi et se fait juge de la Loi. Mais toi qui juges la Loi, es-tu vraiment le juge ou celui qui doit obéir à la Loi?"
,"12":"Un seul est le juge, celui qui a donné la Loi et qui a pouvoir aussi bien pour perdre que pour sauver. Mais toi qui juges le prochain, qui es-tu?"
,"13":"A vous le tour, maintenant! Vous dites: 'Aujourd'hui, demain, nous partons pour telle ville. Nous y resterons toute l'année pour notre commerce et nous ferons de l'argent.'"
,"14":"Mais vous ne savez rien du lendemain; vivrez-vous encore? Qu'êtes vous? Une vapeur qu'on voit quelques instants avant qu'elle disparaisse."
,"15":"Pourquoi ne dites-vous pas: 'Voilà ce que nous ferons si le Seigneur le veut et nous garde en vie.'"
,"16":"Mais au lieu de cela vous vous vantez: cette façon d'être sûr est toujours mauvaise."
,"17":"Celui qui sait où est le bien et ne le fait pas, n'est pas sans péché."
}`)
	CurrentBook.AddChapter(5, `{
"1":"A votre tour maintenant, vous les riches. Lamentez-vous et pleurez car vos malheurs sont près d'arriver!"
,"2":"Les vers se sont mis dans vos réserves: les vêtements sont mangés des mites,"
,"3":"même votre or et votre argent se sont rouillés. Cette rouille vous accuse et comme un feu dévore vos chairs. Oui, les derniers temps étaient déjà là et vous vouliez des richesses!"
,"4":"La paye des ouvriers qui ont moissonné vos champs, vous l'avez retenue, voilà qu'elle crie. Les clameurs de vos moissonneurs sont arrivées aux oreilles du Seigneur Sabaot."
,"5":"Vous meniez sur cette terre une vie de plaisirs et de luxe, et vous étiez bien tranquilles pendant qu'on massacrait."
,"6":"Vous condamniez les hommes justes, vous les faisiez tuer, et ils ne pouvaient rien contre vous."
,"7":"Frères, sachez attendre le jour où viendra le Seigneur. Voyez comment le cultivateur reçoit les précieux fruits de la terre: il les attend jusqu'à ce que viennent les premières et les dernières pluies."
,"8":"Vous aussi sachez attendre sans perdre coeur car la visite du Seigneur n'est plus loin."
,"9":"Ne vous plaignez pas les uns des autres car vous seriez jugés pour cela et le juge est déjà là, à la porte."
,"10":"Frères, voyez ce qu'ont souffert les prophètes qui parlaient au nom du Seigneur, voyez leur patience: qu'ils soient vos modèles."
,"11":"Nous proclamons heureux ceux qui persévèrent. On vous a parlé de la patience de Job et vous savez ce que le Seigneur a fait tout à la fin. C'est que le Seigneur est plein de tendresse et de bonté."
,"12":"Frères, quelque chose de très important: ne jurez ni par le ciel, ni par la terre ou quoi que ce soit. Mais que votre oui soit un oui et votre non un non. Autrement vous seriez en faute."
,"13":"Si l'un de vous se sent abattu, qu'il prie. Si un autre se sent en forme, qu'il chante au Seigneur."
,"14":"Si l'un de vous est malade, qu'il fasse venir les Anciens de l'Eglise. Ils prieront pour lui et lui feront l'onction d'huile au nom du Seigneur."
,"15":"Cette prière faite avec foi sauvera la personne alitée et le Seigneur la relèvera. Et si cette personne a commis quelque faute, elle lui sera pardonnée."
,"16":"Reconnaissez donc vos fautes les uns devant les autres, et priez les uns pour les autres, de façon que vous receviez la guérison. Car la prière des justes est pleine d'efficacité. "
,"17":"Elie était homme et mortel tout comme nous, mais quand il a prié pour demander qu'il n'y ait plus de pluie, la pluie a cessé durant trois années et six mois."
,"18":"Puis il a prié et le ciel a donné la pluie, la terre a refleuri et porté fruit."
,"19":"Frères, si l'un de vous s'est égaré loin de la vérité et qu'un autre le fasse revenir,"
,"20":"sachez le bien: celui qui a ramené le pécheur de son chemin trompeur a sauvé une âme de la mort, il a fait oublier beaucoup de péchés."
}`)

}
func FR_LBDCC_LoadNCIDChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Lettre de Jude, Serviteur du Christ Jésus et frère de Jacques, à vous qui avez été appelés, à vous que Dieu le Père a aimés et qui êtes sous la garde de Jésus Christ."
,"2":"Recevez en abondance la miséricorde, la paix et l'amour!"
,"3":"Frères bien-aimés, j'ai tenu absolument à vous écrire à propos du salut que tous nous attendons. Il fallait que je vous écrive pour vous encourager: luttez pour la foi que Dieu a donnée aux saints de façon définitive."
,"4":"Certains individus se sont introduits parmi vous dont la condamnation est déjà écrite. Ils se moquent de la religion; ils remplacent le don de Dieu par l'absence de morale, et renient de fait Jésus Christ, l'unique Seigneur et maître."
,"5":"Je voudrais vous rappeler ce que déjà vous savez. Le Seigneur a d'abord fait sortir son peuple d'Egypte, mais dans un deuxième temps il a fait périr ceux qui n'avaient pas eu foi."
,"6":"Il a agi de même avec les anges qui n'avaient pas fait honneur à leur propre rang et avaient abandonné leur place. Il les a enfermés et enchaînés pour toujours dans les ténèbres en attendant le grand jour du Jugement."
,"7":"Et de même pour les villes de Sodome et Gomorrhe avec leurs dépendances: car elles se livraient à la prostitution et l'homosexualité. Elles ont été condamnées et restent comme une image du feu éternel."
,"8":"Mais voilà que de la même façon ces gens-là se mettent à délirer. Ils souillent leurs corps, ils méprisent la majesté di vine, ils insultent les autorités célestes."
,"9":"Quand l'archange Michel s'opposait au diable et lui disputait le corps de Moïse, il n'osa pas pour autant lui lancer des insultes. Il lui dit seulement: 'Que le Seigneur te fasse taire!'"
,"10":"Mais eux, ils traînent dans la boue ce qu'ils ne connaissent pas. Et ce qu'ils connaissent par l'instinct naturel, comme les animaux, ils s'en servent pour leur perte."
,"11":"Malheur à eux! Ils ont pris le chemin de Caïn, ils se sont égarés comme Balaam pour une question d'argent, ils se sont révoltés pour leur perte comme Koré!"
,"12":"Ils dénaturent vos repas fraternels, car ils ne pensent qu'à leur ventre et ils se servent sans scrupules. Ce sont des nuages emportés par le vent, qui n'apportent pas la pluie; ce sont des arbres sans fruit de fin d'automne, deux fois morts avant d'être déracinés! "
,"13":"Ce sont des vagues sauvages sur la mer, qui projettent l'écume de leurs vices; ce sont des astres errants qui vont se perdre dans les ténèbres!"
,"14":"Le patriarche Hénoch, le septième après Adam, prophétisait à leur sujet quand il a dit: 'Voici que le Seigneur vient avec ses milliers de saints anges."
,"15":"Il vient pour un jugement universel; il dénoncera ceux qui se moquent du bien pour toutes les fois où ils s'en sont moqués et se sont moqués de lui, et il condamnera les pécheurs ennemis de Dieu pour toutes les insultes qu'ils ont lancées contre lui.'"
,"16":"Tous ces gens-là sont des mécontents, des gens frustrés qui se laissent mener par leurs passions. Ils parlent de façon arrogante et ils cherchent à attirer l'attention pour se faire de l'argent."
,"17":"Mais vous, frères bien-aimés, rappelez-vous ce que les apôtres de notre Seigneur Jésus Christ ont dit dans le temps."
,"18":"Ils ont dit: 'A la fin des temps on verra des gens qui se moqueront de tout; ils se laisseront mener par leurs passions sans plus s'occuper de Dieu.'"
,"19":"De fait ces gens-là créent des divisions; ils restent au niveau des choses naturelles et ils n'ont pas l'Esprit."
,"20":"Mais vous, frères bien-aimés, construisez votre vie sur la base de votre foi très sainte et priez dans l'Esprit Saint."
,"21":"Maintenez-vous dans l'amour de Dieu et accueillez la miséricorde de notre Seigneur Jésus Christ qui vous donne la vie éternelle."
,"22":"Essayez de convaincre ceux qui doutent;"
,"23":"d'autres, sauvez-les comme vous les arracheriez au feu, craignant pour vous-mêmes; pour les autres vous vous méfierez."
,"24":"Gloire à celui qui a pouvoir pour vous garder de tout péché et vous présenter joyeux et sans tache face à sa propre gloire."
,"25":"Gloire, majesté, puissance et souveraineté à lui seul, Dieu notre Sauveur, par Jésus Christ notre Seigneur, comme il était au commencement, maintenant et pour tous les siècles! Amen."
}`)

}
func FR_LBDCC_LoadNEIOChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Au commencement était le Verbe, et le Verbe était auprès de Dieu, et le Verbe était Dieu."
,"2":"Il était au commencement auprès de Dieu."
,"3":"L'univers n'a existé que par lui,et rien n'a existé sans lui. Ce qui a existé, "
,"4":"était vie grâce à lui, et pour les hommes la vie se faisait lumière."
,"5":"La lumière brille dans les ténèbres, et les ténèbres ne l'ont pas étouffée."
,"6":"Un homme est venu, envoyé par Dieu, son nom était Jean."
,"7":"Il est venu comme un témoin, pour rendre témoignage à la lumière; ainsi, par lui, tous pourraient croire."
,"8":"Il n'était pas la lumière, mais il venait pour rendre témoignage à la lumière."
,"9":"(Le Verbe) était la lumière véritable, celui qui illumine tout être humain, et il venait en ce monde."
,"10":"Il était déjà dans le monde, ce monde existait grâce à lui, et ce monde ne le connaissait pas."
,"11":"Quand il est venu chez lui, les siens ne l'ont pas accueilli."
,"12":"Mais à tous ceux qui l'ont accueilli, il a donné le pouvoir de devenir enfants de Dieu. Oui, quand ils ont cru en son Nom "
,"13":"ils sont nés, mais non pas du sang, ni d'un appel de la chair,ni de la volonté d'un homme: ils sont nés de Dieu."
,"14":"Et le Verbe s'est fait chair,et il a habité parmi nous, et nous avons vu sa gloire: la gloire que seul un Fils Unique peut recevoir du Père: en lui tout était don d'amour et vérité."
,"15":"Jean a rendu témoignage à son sujet: il a dit bien haut: 'C'est celui dont je parlais; il est venu après moi, mais déjà il me dépasse, car bien avant moi, il était.'"
,"16":"Nous avons tous reçu de sa plénitude: chaque don d'amour en préparait un autre."
,"17":"Par Moïse nous avons reçu la Loi, mais le don d'amour et la vérité sont venus par Jésus Christ."
,"18":"Personne n'a jamais vu Dieu, mais Dieu-Fils-Unique nous l'a fait connaître, lui qui est dans le sein du Père."
,"19":"Voici donc le témoignage de Jean lorsque les Juifs de Jérusalem lui envoyèrent des prêtres et des Lévites pour lui demander: 'Qui es-tu?'"
,"20":"Jean répondit sans cacher la vérité; il déclara: 'Je ne suis pas le Christ.'"
,"21":"On lui demanda: 'Qui es-tu donc? Es-tu Elie?' Il dit: 'Non.' - 'Es-tu le prophète?' Il répondit: 'Non.'"
,"22":"Les envoyés alors lui demandèrent: 'Qui es-tu donc? Nous devons donner une réponse à ceux qui nous ont envoyés. Que dis-tu de toi-même?'"
,"23":"Jean répondit: 'Je suis, comme l'a dit le prophète Isaïe, la voix qui crie dans le désert: Préparez un chemin droit pour le Seigneur.'"
,"24":"Ceux que l'on avait envoyés étaient des Pharisiens."
,"25":"Ils lui demandèrent encore: 'Pourquoi baptises-tu si tu n'es ni le Christ, ni Elie, ni le Prophète?'"
,"26":"Jean leur répondit: 'Je donne un baptême d'eau, mais au milieu de vous il y a quelqu'un que vous ne connaissez pas;"
,"27":"bien qu'il vienne après moi, je ne suis pas digne de lui enlever la chaussure.'"
,"28":"Cela se passait à Bétaraba, au-delà du Jourdain, là où Jean baptisait."
,"29":"Le lendemain, Jean voit Jésus qui vient à lui et il dit: 'Voici l'agneau de Dieu, celui qui enlève le péché du monde."
,"30":"Je parlais de lui lorsque j'ai dit: Après moi vient un homme qui déjà me dépasse, car bien avant moi il était."
,"31":"Je ne le connaissais pas, mais je suis venu avec le baptême d'eau pour qu'il puisse se manifester à Israël.'"
,"32":"Jean fit cette déclaration: 'J'ai vu l'Esprit qui descendait du ciel sur lui comme fait la colombe, et il est resté sur lui."
,"33":"Je ne le connaissais pas, mais celui qui m'a envoyé pour baptiser avec de l'eau m'a dit: Celui sur qui tu verras que l'Esprit descend et reste, c'est lui qui baptise dans l'Esprit Saint."
,"34":"Cela, je l'ai vu, et je peux déclarer que c'est lui l'Elu de Dieu.'"
,"35":"Le lendemain, Jean était là de nouveau, et deux de ses disciples étaient avec lui."
,"36":"Il fixa son regard sur Jésus qui passait et il dit: 'Voici l'agneau de Dieu.'"
,"37":"Lorsque ces deux disciples l'entendirent, ils allèrent suivre Jésus."
,"38":"Jésus se retourna et vit qu'ils le suivaient; alors il leur dit: 'Que cherchez-vous?' Ils lui dirent: 'Rabbi, (c'est-à-dire Maître) où demeures-tu?'"
,"39":"Jésus leur dit: 'Venez et vous verrez!' Ils vinrent donc pour voir où il restait, et ce jour-là ils demeurèrent avec lui. Il était environ quatre heures de l'après-midi."
,"40":"L'un de ces deux disciples qui avaient écouté Jean et avaient suivi Jésus, était André, le frère de Simon-Pierre."
,"41":"Il alla d'abord trouver son frère Simon et lui dit: 'Nous avons trouvé le Messie' (ce qui veut dire: le Christ). Et il l'amena à Jésus."
,"42":"Jésus le regarda et dit: 'Tu es Simon, fils de Jean; tu t'appelleras Kéfas' (ce qui veut dire Pierre)."
,"43":"Le lendemain, Jésus décida de partir pour la Galilée; c'est alors qu'il rencontra Philippe et lui dit: 'Suis-moi.'"
,"44":"Philippe était de Bethsaïde, la ville d'André et de Pierre."
,"45":"Philippe alla voir Nathanaël et lui dit: 'Celui dont a parlé Moïse dans la Loi, et aussi les Prophètes, nous l'avons trouvé; c'est Jésus, fils de Joseph, de Nazareth.'"
,"46":"Nathanaël lui dit alors: 'De Nazareth? Qu'est-ce qui peut en sortir de bon?' Philippe lui répondit: 'Viens et vois.'"
,"47":"Lorsque Jésus vit Nathanaël qui arrivait, il parla de lui: 'Voici un vrai Israélite: il est incapable de mentir.'"
,"48":"Nathanaël lui demanda: 'Comment me connais-tu?' Et Jésus répondit: 'Avant que Philippe ne t'appelle, quand tu étais sous le figuier, je t'ai vu.'"
,"49":"Aussitôt Nathanaël déclara: 'Maître, tu es le Fils de Dieu, tu es le Roi d'Israël!'"
,"50":"Jésus lui dit alors: 'Tu crois parce que je t'ai dit que je t'ai vu sous le figuier, mais tu verras beaucoup mieux que cela.'"
,"51":"Et Jésus ajouta: 'En vérité, en vérité, je vous le dis: vous verrez le ciel s'ouvrir, avec les anges de Dieu qui montent et descendent sur le Fils de l'Homme.'"
}`)
	CurrentBook.AddChapter(2, `{
"1":"Le troisième jour il y eut une noce à Cana en Galilée, et la mère de Jésus y était."
,"2":"Jésus aussi fut invité à la noce avec ses disciples."
,"3":"Et voilà que le vin de la noce arrive à sa fin: ils n'avaient plus de vin. La mère de Jésus lui dit: 'Ils n'ont plus de vin.'"
,"4":"Jésus lui répond: 'Femme, vas-tu te mettre dans mes affaires? Mon heure n'est pas encore venue.'"
,"5":"Mais sa mère dit aux servants: 'Faites tout ce qu'il vous dira.'"
,"6":"Il y avait là six jarres de pierre que les Juifs gardaient pour leurs purifications; elles pouvaient contenir chacune cent ou cent cinquante litres."
,"7":"Jésus leur dit: 'Remplissez ces jarres avec de l'eau.' Ils les remplirent jusqu'au bord."
,"8":"Jésus dit alors: 'Prenez maintenant et portez-en au responsable de la fête.'"
,"9":"Le responsable de la fête goûta cette eau changée en vin, mais il ne savait pas comment on avait rempli les jarres, seuls les servants qui avaient pris l'eau le savaient. Alors il dit au marié:"
,"10":"'Tout le monde sert d'abord le bon vin, et quand les gens sont gais, on donne le vin ordinaire. Mais toi, tu as gardé le bon vin jusqu'à maintenant!'"
,"11":"C'est ainsi que Jésus fit le premier de ses signes, à Cana en Galilée. Là il manifesta sa gloire et ses disciples crurent en lui."
,"12":"Après cela Jésus descendit à Capharnaüm avec sa mère, ses frères et ses disciples, mais il n'y resta que quelques jours."
,"13":"La Pâque des Juifs était proche, et Jésus monta à Jérusalem."
,"14":"Il rencontra dans le Temple les vendeurs de boeufs, de brebis et de colombes, et aussi les changeurs de monnaie assis à leurs comptoirs."
,"15":"Alors il se fit un fouet avec des cordes et il commença à les jeter tous hors du Temple avec leurs boeufs et leurs brebis. Il renversa les tables des changeurs et fit rouler leur argent par terre."
,"16":"Puis il dit aux vendeurs de colombes: 'Enlevez-moi cela d'ici et ne faites pas de la Maison de mon Père une maison de commerce.'"
,"17":"Ses disciples se rappelèrent les paroles de l'Ecriture: 'Un amour jaloux pour ta Maison me dévore.'"
,"18":"Les Juifs répliquèrent: 'De quel droit fais-tu cela, quel signe nous montres-tu?'"
,"19":"Alors Jésus répondit: 'Détruisez ce Sanctuaire, et en trois jours je le relèverai.'"
,"20":"Les Juifs lui dirent: 'Voilà quarante-six ans qu'on travaille à ce sanctuaire, et toi, tu le relèverais en trois jours?'"
,"21":"Mais le sanctuaire dont Jésus parlait, c'était son propre corps."
,"22":"C'est pourquoi, lorsqu'il se releva d'entre les morts, ses disciples se rappelèrent qu'il avait dit cela; ils crurent à l'Ecriture et à ce que Jésus avait dit."
,"23":"Beaucoup de personnes crurent au Nom de Jésus quand il était à Jérusalem pour cette fête de la Pâque, parce qu'on le voyait faire des miracles."
,"24":"Mais Jésus ne leur faisait pas confiance car il les connaissait tous."
,"25":"Il n'avait pas besoin qu'on lui recommande qui que ce soit, car il savait ce qu'il y a dans l'homme."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Il y avait chez les Pharisiens un homme nommé Nicodème, c'était un chef des Juifs."
,"2":"Il vint trouver Jésus de nuit et lui dit: 'Maître, nous savons que tu es venu de Dieu pour enseigner, car personne ne peut faire des signes comme ceux que tu fais si Dieu n'est pas avec lui.'"
,"3":"Jésus lui fit cette déclaration: 'En vérité, en vérité, je te le dis: celui qui n'est pas né d'en haut ne peut pas voir le Royaume de Dieu.'"
,"4":"Nicodème lui répondit: 'Quand l'homme est vieux, peut-il renaître? Qui retournera au sein de sa mère pour naître une seconde fois?'"
,"5":"Jésus dit alors: 'En vérité, en vérité, je te le dis: si l'on n'est pas né de l'eau et de l'Esprit, on ne peut pas entrer dans le Royaume de Dieu."
,"6":"Ce qui est né de la chair est chair, ce qui est né de l'Esprit est esprit."
,"7":"Ne t'étonne pas si je te dis que vous devez naître d'en-haut."
,"8":"Le vent souffle où il veut et tu entends sa voix, mais tu ne sais pas d'où il vient ni où il va: c'est la même chose pour celui qui est né de l'Esprit.'"
,"9":"Nicodème lui dit: 'Comment cela est-il possible?'"
,"10":"Jésus répliqua: 'Tu es maître en Israël et tu ne sais pas cela!'"
,"11":"'En vérité, en vérité, je te le dis: nous savons ce que nous disons et nous sommes témoins parce que nous avons vu; mais vous ne recevez pas notre témoignage."
,"12":"Si vous ne me croyez pas quand je vous parle de choses de la terre, comment croirez-vous lorsque je parlerai des choses du ciel?"
,"13":"Mais personne n'est monté au ciel si ce n'est le Fils de l'Homme qui, lui, est descendu du ciel."
,"14":"Rappelez-vous le serpent que Moïse a fait lever dans le désert; il faut que le Fils de l'Homme soit élevé de la même manière,"
,"15":"et alors quiconque croira en lui aura la vie éternelle."
,"16":"Oui, comme Dieu a aimé le monde! Il a donné le Fils unique pour que celui qui croit en lui ait la vie éternelle et n'aille pas à sa perte."
,"17":"Dieu a envoyé le Fils dans le monde, non pas pour juger le monde, mais pour que le monde soit sauvé grâce à lui."
,"18":"Pour celui qui croit en lui, il n'y a pas de jugement. Par contre, celui qui refuse de croire s'est déjà condamné, puisqu'il n'a pas cru dans le Nom du Fils unique de Dieu."
,"19":"Le jugement, c'est cela même: la lumière est venue dans le monde et les hommes ont choisi les ténèbres plutôt que la lumière, car ils faisaient le mal."
,"20":"Celui qui fait le mal n'aime pas la lumière, et il ne vient pas à la lumière, car alors il deviendrait clair que ses oeuvres sont mauvaises."
,"21":"Au contraire, celui qui vit dans la vérité vient à la lumière, pour qu'on voie clairement que toutes ses oeuvres ont été faites en Dieu.'"
,"22":"Après cela Jésus alla avec ses disciples à la province de Judée. Il y resta avec eux un certain temps et se mit à baptiser."
,"23":"Jean aussi baptisait à Enon près de Salim, parce que l'eau y était profonde; on y venait pour se faire baptiser."
,"24":"C'était avant que Jean ne soit mis en prison."
,"25":"Un jour les disciples de Jean eurent une discussion avec un Juif sur la façon de se purifier."
,"26":"Ils vinrent trouver Jean et lui dirent: 'Maître, celui qui était avec toi de l'autre côté du Jourdain, celui dont tu as fait l'éloge, il s'est mis à baptiser et tout le monde court vers lui!'"
,"27":"Alors Jean leur répond: 'Personne ne peut s'attribuer plus que le Ciel ne veut lui donner."
,"28":"Je ne suis pas le Messie, mais celui qu'on a envoyé devant lui: je l'ai dit et vous êtes mes témoins."
,"29":"L'épouse est pour l'époux; l'ami de l'époux se tient près de lui et fait ce qu'il lui dit. Et toute sa joie est d'entendre la voix de l'époux. Voilà pourquoi je suis pleinement heureux."
,"30":"Lui doit grandir, et je dois diminuer."
,"31":"Celui qui vient d'en-haut est au-dessus de tous. Celui qui vient de la terre sera toujours de la terre, et ce qu'il dit vient de la terre. Celui qui vient d'en-haut"
,"32":"a beau parler de ce qu'il a vu et entendu, personne ne tient compte de son témoignage."
,"33":"Pourtant, recevoir son témoignage, c'est reconnaître que Dieu est fidèle à lui-même."
,"34":"Celui que Dieu a envoyé dit les paroles de Dieu, et il donne l'Esprit sans mesure,"
,"35":"car le Père aime le Fils, il a tout mis dans ses mains."
,"36":"Celui qui refuse de croire dans le Fils ne connaîtra pas la vie: il en reste au Dieu qui condamne."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Le Seigneur sut que les Pharisiens étaient informés à son sujet; on disait qu'il faisait des disciples et baptisait plus que Jean."
,"2":"En fait, ce n'était pas Jésus qui baptisait, mais ses disciples."
,"3":"Il quitta donc la Judée et se mit en route pour la Galilée."
,"4":"Il lui fallait traverser la Samarie"
,"5":"et c'est ainsi qu'il arriva à une ville de Samarie appelée Sichar, tout près de la terre que Jacob a donnée à son fils Joseph."
,"6":"Et c'est là que se trouve le puits de Jacob. Jésus était fatigué de la marche et il s'assit sur le bord du puits. C'était l'heure de midi."
,"7":"Arrive une femme de Samarie pour puiser de l'eau. Jésus lui dit: 'Donne-moi à boire.'"
,"8":"A ce moment ses disciples étaient partis à la ville pour acheter de quoi manger."
,"9":"La Samaritaine lui répondit: 'Vous êtes Juif. Comment pouvez-vous demander à boire à une Samaritaine comme moi?' (On sait que les Juifs ne veulent pas de rapports avec les Samaritains.)"
,"10":"Jésus lui dit: 'Si tu connaissais le don de Dieu et si tu savais qui te demande à boire, c'est toi qui lui aurais demandé cette eau qui fait vivre, et il te l'aurait donnée.'"
,"11":"Elle lui dit: 'Vous n'avez pas de seau et le puits est profond. Où trouvez-vous cette eau vive?"
,"12":"Notre père Jacob nous a donné ce puits après y avoir bu lui-même avec ses fils et ses troupeaux; êtes-vous plus grand que lui?'"
,"13":"Jésus lui dit: 'Celui qui boit de cette eau aura encore soif,"
,"14":"mais celui qui boit de l'eau que je lui donnerai ne connaîtra plus jamais la soif. L'eau que je lui donnerai deviendra en lui une source intarissable de vie éternelle.'"
,"15":"La femme lui dit: 'Donnez-moi donc de cette eau; je n'aurai plus soif et je n'aurai plus à venir en chercher ici.'"
,"16":"Jésus répond: 'Va, appelle ton mari et reviens.'"
,"17":"Alors la femme lui dit: 'Je n'ai pas de mari.' Jésus lui répond: 'Tu dis que tu n'as pas de mari? Comme c'est vrai!"
,"18":"Tu as eu cinq maris et celui que tu as maintenant n'est pas ton mari. Tu as dit vrai!'"
,"19":"Alors la femme lui dit: 'Je vois que vous êtes un prophète."
,"20":"Dites-moi: nos pères ont toujours adoré sur cette montagne; pourquoi donc dites-vous que Jérusalem est le Lieu où l'on doit adorer?'"
,"21":"Jésus lui dit: 'Femme, crois-moi, l'heure vient où vous adorerez le Père. Et alors ce ne sera pas: 'sur cette montagne' ou: 'à Jérusalem'."
,"22":"Vous adorez sans avoir la connaissance, et nous, nous adorons et nous savons comment, parce que le salut vient des Juifs."
,"23":"Mais l'heure vient, et elle est déjà là, où les vrais adorateurs adoreront le Père en esprit et en vérité. Alors ils seront des adorateurs du Père comme lui-même les désire."
,"24":"Dieu est esprit; quand on adore, il faut adorer en esprit et en vérité.'"
,"25":"La femme alors lui dit: 'Je sais que bientôt sera là le Messie (c'est-à-dire le Christ). Quand il sera là, il nous dira tout.'"
,"26":"Jésus répond: 'Je le suis, moi qui te parle.'"
,"27":"A ce moment-là revinrent les disciples, et ils s'étonnaient de le voir parler avec une femme. Pourtant aucun d'entre eux n'osa lui demander: 'Que cherches-tu?' ou: 'Pourquoi lui parles-tu?'"
,"28":"Quant à la femme, elle laissa là sa cruche et s'en alla à la ville en courant. Elle dit aux gens:"
,"29":"'Venez voir quelqu'un qui m'a dit tout ce que j'ai fait! Et si c'était le Christ?'"
,"30":"Voici donc qu'ils sortent de la ville pour aller le trouver."
,"31":"Pendant ce temps les disciples lui disaient: 'Maître, mange!'"
,"32":"Il leur répondit: 'La nourriture que je dois manger, vous ne la connaissez pas.'"
,"33":"Alors ils se dirent les uns aux autres: 'Peut-être quelqu'un lui a-t-il apporté à manger?'"
,"34":"Mais Jésus leur dit: 'Ma nourriture, c'est de faire la volonté de celui qui m'a envoyé et de mener à bien son oeuvre."
,"35":"Vous avez dit, n'est-ce pas: Dans quatre mois ce sera la moisson. Alors je vous dis: Ouvrez les yeux et regardez les champs. Déjà ils blanchissent, et ce sera la moisson."
,"36":"Voici le moissonneur qui reçoit son salaire et amasse du grain pour la vie éternelle, et voilà le semeur qui se réjouit avec le moissonneur."
,"37":"On a raison de dire que l'un sème et l'autre moissonne,"
,"38":"car je vous ai envoyés moissonner là où vous n'aviez pas peiné. D'autres avaient peiné, et vous avez repris leur travail.'"
,"39":"Dans cette ville beaucoup de Samaritains crurent à cause de la femme qui affirmait: 'Il m'a dit tout ce que j'avais fait.'"
,"40":"Quand les Samaritains étaient venus trouver Jésus, ils lui avaient demandé de s'arrêter chez eux, et il y resta deux jours."
,"41":"Il y en eut beaucoup plus qui crurent à cause de sa parole;"
,"42":"et ils disaient à la femme: 'Maintenant nous croyons, non pas à cause de ce que tu as raconté, mais parce que nous l'avons écouté. Nous savons qu'il est vraiment le Sauveur du monde.'"
,"43":"Après ces deux jours, Jésus repartit pour la Galilée."
,"44":"Jésus a affirmé qu'un prophète n'est pas honoré dans son propre pays."
,"45":"Cependant, quand il se trouva en Galilée, les Galiléens lui firent bon accueil, car eux aussi étaient allés à Jérusalem pour la fête et ils avaient vu tout ce que Jésus avait fait durant cette fête."
,"46":"C'est alors que Jésus vint de nouveau à Cana de Galilée où il avait changé l'eau en vin. Il y avait à Capharnaüm un fonctionnaire du roi dont le fils était malade. "
,"47":"Quand il apprit que Jésus était retourné de Judée en Galilée, il vint le trouver et lui demanda de descendre pour guérir son fils, car il était près de mourir."
,"48":"Jésus lui dit: 'Tant que vous ne voyez pas des signes et des miracles, vous ne voulez pas croire!'"
,"49":"Le fonctionnaire lui dit: 'Venez avant que mon enfant soit mort.'"
,"50":"Jésus lui dit: 'Va, ton fils est bien vivant.',Cet homme crut à la parole que Jésus lui disait et il partit. "
,"51":"Il était déjà dans la descente quand il rencontra ses serviteurs qui venaient lui dire que son enfant vivait."
,"52":"Aussitôt il leur demanda à quelle heure il s'était trouvé mieux, et ils répondirent: 'La fièvre est tombée hier un peu après midi.'"
,"53":"Le père reconnut alors que c'était l'heure où Jésus lui avait dit: 'Ton fils est bien vivant.' Et il devint croyant, lui et toute sa famille."
,"54":"C'est là le deuxième signe miraculeux que Jésus a fait; il venait de rentrer de Judée en Galilée."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Après cela il y eut une fête des Juifs, et Jésus monta à Jérusalem."
,"2":"A Jérusalem, près de la Porte des Brebis, il y a une piscine appelée en hébreu Bétesda. Elle a cinq rangées d'arcades,"
,"3":"et sous les arcades étaient étendus une quantité de malades, avec des aveugles, des boiteux et des paralysés. (Tous attendaient que l'eau bouge,"
,"4":"car de temps en temps un ange du Seigneur descendait dans la piscine et faisait bouillonner l'eau. Lorsque l'eau avait été agitée, le premier qui descendait était guéri, quelle que soit sa maladie.)"
,"5":"Il y avait donc là un homme qui était infirme depuis trente-huit ans."
,"6":"Jésus le voit étendu. Quand il apprend que l'homme est là depuis fort longtemps, il lui dit: 'Veux-tu guérir?'"
,"7":"L'infirme lui répond: 'Vous savez, je n'ai personne pour me jeter dans la piscine aussitôt que l'eau a été agitée, et avant que j'y aille, un autre est déjà descendu.'"
,"8":"Jésus lui dit alors: 'Lève-toi, prends ton brancard et marche.'"
,"9":"Au même moment l'homme est guéri, il prend son brancard et il marche. Mais voilà que c'était un jour de sabbat. "
,"10":"Les Juifs dirent à celui qui avait été guéri: 'C'est le sabbat, tu ne peux pas transporter ton brancard.'"
,"11":"Il leur répondit: 'C'est celui qui m'a guéri qui m'a dit d'emporter mon brancard et de marcher.'"
,"12":"Ils lui demandèrent donc: 'Mais qui est cet homme qui t'a dit: Va, emporte-le?'"
,"13":"L'homme qui avait été guéri ne le savait pas, car Jésus avait disparu dans la foule."
,"14":"Plus tard cependant, Jésus le rencontre dans le Temple et lui dit: 'Te voilà guéri; ne pèche plus, car il pourrait t'arriver bien pire.'"
,"15":"L'homme alla donc dire aux Juifs que c'était Jésus qui l'avait guéri,"
,"16":"et les Juifs s'indignèrent contre Jésus parce qu'il avait fait cela le jour du sabbat."
,"17":"Mais Jésus leur dit: 'Mon Père est encore au travail, alors moi aussi je travaille.'"
,"18":"Ainsi Jésus ne se contentait pas de violer la loi du sabbat, mais encore il appelait Dieu son propre Père, se faisant ainsi l'égal de Dieu. Avec cela les Juifs avaient bien plus envie de le tuer."
,"19":"Jésus prit la parole; il leur dit: 'En vérité, en vérité, je vous le dis: le Fils ne peut rien faire de lui-même; il faut qu'il le voie faire par son Père. Si celui-ci fait quelque chose, le Fils le fait également."
,"20":"Comme le Père aime le Fils, il lui montre tout ce qu'il fait; et il lui fera voir des oeuvres bien plus importantes que ces choses-là: vous en serez tous stupéfaits."
,"21":"Vous savez que le Père réveille les morts et leur donne la vie; de la même façon le Fils donne la vie à qui il veut."
,"22":"Sachez aussi que le Père ne juge personne; mais il a donné au Fils la responsabilité de juger,"
,"23":"afin que tous respectent le Fils comme ils respectent le Père. Celui qui ne respecte pas le Fils ne respecte pas le Père qui l'a envoyé."
,"24":"En vérité, en vérité, je vous le dis: celui qui écoute mes paroles et croit en celui qui m'a envoyé, vit de vie éternelle. Il n'a plus à être jugé, car il est passé de la mort à la vie."
,"25":"En vérité, en vérité, je vous le dis: l'heure vient, et elle est déjà là, où les morts vont entendre l'appel du Fils de Dieu et ceux qui l'écouteront vivront."
,"26":"Car le Fils possède en lui-même la vie, tout comme le Père possède en lui-même la vie."
,"27":"Et le Père lui a donné le pouvoir de juger parce qu'il est un fils d'homme."
,"28":"Ne soyez pas surpris: l'heure vient, et elle est déjà là, où tous ceux qui sont dans la tombe entendront son appel."
,"29":"Et ils sortiront: pour ceux qui ont fait le bien, la résurrection sera vie, mais pour ceux qui ont fait le mal, la résurrection sera châtiment."
,"30":"Je ne peux rien faire de moimême, mais je juge selon ce que j'entends, et mon jugement est juste parce que je ne cherche pas ma volonté, mais la volonté de celui qui m'a envoyé."
,"31":"Si je me recommande moi-même, mon témoignage ne vaut pas,"
,"32":"mais c'est un autre qui me recommande et je sais que son témoignage est vrai quand il me recommande."
,"33":"De votre côté, vous avez fait demander à Jean et il a rendu témoignage à la vérité."
,"34":"Je rappelle cela pour vous-mêmes, pour que vous soyez sauvés, car personnellement je ne me fais pas recommander par un homme."
,"35":"Jean était une lampe qui brûle et illumine, et pour un moment vous vous sentiez bien avec sa lumière."
,"36":"Mais moi, j'ai une recommandation meilleure que celle de Jean: ce sont les oeuvres que mon Père m'a demandé de mener à bien. Les oeuvres que je fais parlent en ma faveur et montrent que le Père m'a envoyé. "
,"37":"Et le Père qui m'a envoyé a aussi parlé en ma faveur. Vous n'avez jamais entendu sa voix, comme vous n'avez jamais vu sa face,"
,"38":"mais même sa parole ne demeure pas en vous si vous ne croyez pas celui qu'il a envoyé."
,"39":"Cherchez dans les Ecritures, puisque vous croyez que vous y trouverez la vie éternelle: ces Ecritures, justement, parlent de moi."
,"40":"Mais vous ne voulez pas venir à moi et trouver ainsi la vie."
,"41":"Je ne cherche pas une gloire humaine."
,"42":"Mais je sais qu'il n'y a pas d'amour de Dieu en vous,"
,"43":"car je suis venu au nom de mon Père et vous ne me faites pas accueil; si un autre vient en son propre nom, vous le recevez."
,"44":"Ainsi vous faites crédit à la renommée qu'on se donne l'un à l'autre, et vous ne recherchez pas la gloire qui vient du Dieu unique: comment donc pourriez-vous croire?"
,"45":"Ne croyez pas que je serai votre accusateur auprès du Père: c'est Moïse qui vous accuse, celui en qui vous mettez vos espoirs."
,"46":"Si vous aviez foi en Moïse, vous croiriez en moi, car il a écrit sur moi."
,"47":"Mais si vous ne croyez pas ses écrits, comment croirez-vous mes paroles?"
}`)
	CurrentBook.AddChapter(6, `{
"1":"Après cela, Jésus alla sur les bords de la mer de Galilée, du côté de Tibériade."
,"2":"Une foule nombreuse le suivait, car elle voyait les signes miraculeux qu'il opérait sur les malades."
,"3":"Jésus monta sur la colline, et là il s'assit avec ses disciples."
,"4":"La Pâque, la fête des Juifs, était proche."
,"5":"Jésus, donc, leva les yeux et vit cette grande foule qui montait vers lui. Alors il dit à Philippe: 'Où allons-nous acheter des pains pour qu'ils aient à manger?'"
,"6":"Jésus disait cela pour voir comment Philippe allait réagir, car lui savait ce qu'il allait faire."
,"7":"Philippe lui répond: 'Même avec deux cents pièces d'argent, le pain ne suffirait pas pour que chacun en ait un morceau.'"
,"8":"Un des disciples de Jésus, André, le frère de Simon-Pierre, dit alors:"
,"9":"'Il y a là un garçon avec cinq pains d'orge et deux poissons: nous voilà bien pour nourrir toute cette foule!'"
,"10":"Mais Jésus dit: 'Faites asseoir tout ce monde.',Il y avait beaucoup d'herbe à cet endroit et les hommes s'assirent; ils étaient environ cinq mille."
,"11":"Jésus donc prend les pains et rend grâce, puis il en donne à ce monde qui s'est mis à l'aise, et il leur donne de même du poisson, autant qu'ils en veulent."
,"12":"Quand ils ont tous mangé à leur faim, Jésus dit à ses disciples: 'Ramassez les morceaux qui restent, il ne faut rien perdre.'"
,"13":"On les ramasse donc et on remplit douze corbeilles avec les débris des cinq pains d'orge, tout ce qu'on n'avait pas mangé."
,"14":"A la vue du signe que Jésus venait de faire, les gens commencèrent à dire: 'Cet homme est vraiment le prophète qui doit venir dans le monde!'"
,"15":"Jésus comprit qu'ils allaient l'enlever pour le proclamer roi; alors, une fois de plus, il les laissa et s'en alla tout seul dans la montagne."
,"16":"En fin de journée les disciples descendirent vers le rivage."
,"17":"Il faisait déjà nuit et Jésus n'était toujours pas là avec eux. Ils montèrent donc dans une barque, cherchant à traverser la mer en direction de Capharnaüm,"
,"18":"mais la mer était déchaînée car le vent soufflait très fort."
,"19":"Quand ils avaient déjà ramé quatre ou cinq kilomètres, ils virent Jésus qui s'approchait de la barque: il marchait sur la mer et les disciples eurent vraiment peur."
,"20":"Mais lui leur dit: 'C'est moi, ne craignez pas.'"
,"21":"Et comme ils voulaient le prendre dans la barque, au même moment la barque toucha terre à l'endroit vers lequel ils se dirigeaient."
,"22":"Le lendemain, la foule qui était restée de l'autre côté de la mer se rendit compte qu'il n'y avait pas eu d'autre barque que celle-là et que Jésus n'y était pas monté avec ses disciples: ils étaient partis seuls."
,"23":"Cependant des bateaux étaient arrivés de Tibériade près de l'endroit où l'on avait mangé le pain lorsque le Seigneur rendit grâces."
,"24":"Lorsque tous ces gens virent que Jésus n'était pas là, et ses disciples non plus, ils montèrent sur ces bateaux à la recherche de Jésus, et ils vinrent à Capharnaüm."
,"25":"A peine l'eurent-ils trouvé de l'autre côté de la mer qu'ils lui dirent: 'Rabbi, Maître, comment es-tu venu?'"
,"26":"Alors Jésus leur répond: 'En vérité, en vérité, je vous le dis: vous me cherchez, non parce que vous avez vu à travers les signes, mais parce que vous avez eu du pain et que vous avez bien mangé."
,"27":"Travaillez, non pas pour la nourriture qui disparaît, mais pour la nourriture qui demeure et qui devient vie éternelle. C'est le Fils de l'Homme qui vous la donnera; c'est lui que Dieu le Père a marqué de son sceau.'"
,"28":"Alors on lui dit: 'Pour travailler aux oeuvres de Dieu, que devons-nous faire?'"
,"29":"Et Jésus leur répond: 'L'oeuvre de Dieu, c'est que vous ayez foi en celui qu'il a envoyé.'"
,"30":"Ils lui disent: 'Que fais-tu, quel signe avons-nous vu pour que nous croyions en toi? Qu'es-tu capable de faire?"
,"31":"Nos pères ont mangé la manne dans le désert, comme dit l'Ecriture: Il leur a donné à manger le pain venu du ciel'."
,"32":"Jésus leur répond: 'En vérité, en vérité, je vous le dis: ce n'est pas Moïse qui vous a donné le pain venu du ciel; c'est mon Père qui vous donne le vrai pain descendu du ciel."
,"33":"Celui qui descend du ciel et donne la vie au monde, c'est lui le pain de Dieu.'"
,"34":"Alors les gens lui disent: 'Donnez-nous donc ce pain.'"
,"35":"Et Jésus leur répond: 'Je suis le pain de vie: celui qui vient à moi n'aura jamais faim, celui qui croit en moi n'aura plus jamais soif."
,"36":"Mais vous avez vu et vous n'avez pas cru: cela, je vous l'ai déjà dit."
,"37":"Tout ce que le Père me donne viendra à moi, et je ne rejetterai pas celui qui vient à moi."
,"38":"Car je suis descendu du ciel, non pour faire ma volonté, mais pour faire la volonté de celui qui m'envoie."
,"39":"Voici ce que veut celui qui m'a envoyé: que je ne perde rien de ce qu'il m'a donné, mais que je le ressuscite au dernier jour."
,"40":"Oui, c'est la volonté de mon Père: quiconque voit le Fils et croit en lui doit vivre de vie éternelle, et moi je le ressusciterai au dernier jour.'"
,"41":"Les Juifs commencèrent à protester parce que Jésus avait dit: 'Je suis le pain qui est descendu du ciel.'"
,"42":"Ils disaient: 'Nous connaissons son père et sa mère, n'est-ce pas? Il n'est que Jésus fils de Joseph. Et maintenant il vient nous dire qu'il est descendu du ciel!'"
,"43":"Jésus leur dit ceci: 'Ne protestez pas entre vous."
,"44":"Personne ne peut venir à moi si le Père qui m'a envoyé ne l'attire; moi, alors, je le ressusciterai au dernier jour."
,"45":"Il est écrit dans les livres des prophètes: Tous seront enseignés par Dieu. C'est ainsi que vient à moi celui qui a entendu et s'est laissé instruire par le Père."
,"46":"Car personne, bien sûr, n'a vu le Père; un seul a vu le Père, celui qui vient d'auprès de Dieu."
,"47":"En vérité, en vérité, je vous le dis: celui qui croit vit de vie éternelle.'"
,"48":"'Je suis le pain de vie."
,"49":"Vos pères ont mangé la manne dans le désert, mais ils sont morts."
,"50":"Voici maintenant le pain qui est descendu du ciel, celui qui en mange ne meurt pas."
,"51":"Je suis le pain vivant qui est descendu du ciel; si quelqu'un mange de ce pain, il vivra pour toujours. Et ce pain que je donnerai, c'est ma chair livrée pour la vie du monde.'"
,"52":"Les Juifs commencèrent à se diviser. Ils disaient: 'Cet homme va-t-il nous donner à manger de la chair?'"
,"53":"Jésus leur dit: 'En vérité, en vérité, je vous le dis: si vous ne mangez pas la chair du Fils de l'Homme et si vous ne buvez pas son sang, vous n'avez pas la vie en vous."
,"54":"Celui qui mange ma chair et boit mon sang vit de vie éternelle, et moi je le ressusciterai au dernier jour."
,"55":"Ma chair est vraiment nourriture, et mon sang est vraiment une boisson."
,"56":"Celui qui mange ma chair et boit mon sang demeure en moi et moi en lui."
,"57":"De même que je vis par le Père, car le Père qui m'a envoyé est vivant, de la même façon celui qui me mange vivra par moi."
,"58":"Voici le pain qui est descendu du ciel. Ce ne sera pas comme pour vos pères qui ont mangé, et ensuite ils sont morts: celui qui mange ce pain vivra pour toujours.'"
,"59":"Voilà ce que Jésus a dit dans la synagogue, quand il enseignait à Capharnaüm."
,"60":"Après l'avoir entendu, bon nombre de ses disciples dirent: 'Ce langage est dur à accepter, qui voudra l'écouter?'"
,"61":"Jésus savait en lui-même que ses disciples protestaient; il leur dit: 'Tout cela vous scandalise?"
,"62":"Que direz-vous lorsque vous verrez le Fils de l'Homme remonter où il était auparavant?"
,"63":"C'est l'Esprit qui fait vivre, la chair ne sert de rien; les paroles que je vous ai dites sont esprit, et elles sont vie."
,"64":"Mais certains d'entre-vous ne croient pas.',Jésus savait en effet dès le début quels étaient ceux qui ne croyaient pas, et qui allait le trahir. "
,"65":"Et il ajouta: 'Voici la raison pour laquelle je vous ai dit que personne ne peut venir à moi si cela ne lui a pas été donné par le Père.'"
,"66":"Ce jour-là beaucoup de disciples firent marche arrière et cessèrent de le suivre."
,"67":"Jésus dit alors aux Douze: 'N'allez-vous pas partir, vous aussi?'"
,"68":"Pierre lui répondit: 'Seigneur, à qui irions-nous? Tu as les paroles de la vie éternelle,"
,"69":"et nous, nous croyons et nous savons que tu es le Saint de Dieu.'"
,"70":"Jésus leur dit: 'N'est-ce pas moi qui vous ai choisis, vous, les Douze? et pourtant l'un de vous est un démon.'"
,"71":"Jésus parlait de Judas, fils de Simon Iscariote. C'est lui, l'un des Douze, qui allait livrer Jésus."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Après cela, Jésus resta en Galilée, passant d'une place à l'autre; il ne voulait pas circuler en Judée car les Juifs cherchaient à le tuer."
,"2":"La fête des Tentes, une des fêtes juives, était alors toute proche,"
,"3":"et les frères de Jésus lui dirent: 'Ne reste pas ici, monte en Judée: tes disciples là-bas ont besoin de voir les oeuvres que tu fais."
,"4":"On ne se cache pas quand on veut être connu: avec tout ce que tu fais, tu dois te montrer au monde.'"
,"5":"En réalité, ses frères non plus ne croyaient pas en lui."
,"6":"Jésus leur dit: 'L'heure pour moi n'est pas encore venue, tandis que pour vous, c'est toujours le moment favorable."
,"7":"Le monde ne peut pas vous détester, alors que moi il me déteste parce que je montre que ses oeuvres sont mauvaises."
,"8":"Vous pouvez monter pour cette fête; moi je ne monte pas pour cette fête, parce que mon heure n'est pas encore venue.'"
,"9":"Telle fut la réponse de Jésus, et il resta en Galilée."
,"10":"Mais quand ses frères étaient déjà montés pour la fête, Jésus aussi monta sans le dire, et comme en secret."
,"11":"Les Juifs le cherchaient donc au milieu de la fête et ils demandaient: 'Où est cet homme?'"
,"12":"Dans le peuple on parlait de lui à voix basse. Les uns disaient: 'C'est un homme bien.' D'autres répondaient: 'Pas du tout, il trompe le peuple.'"
,"13":"Mais personne ne parlait de lui ouvertement par peur des Juifs."
,"14":"La fête était déjà à moitié passée quand Jésus monta au Temple et commença à enseigner."
,"15":"Les Juifs en étaient tout étonnés, ils disaient: 'Cet homme connaît donc les Ecritures sans avoir eu de maître?'"
,"16":"Alors vint la réponse de Jésus: 'Ma doctrine ne vient pas de moi mais de celui qui m'a envoyé."
,"17":"Si quelqu'un veut faire ce que Lui il veut, il saura bien si ma doctrine vient de Dieu ou si je parle pour mon compte."
,"18":"Celui qui parle pour son propre compte, cherche sa propre gloire, mais si quelqu'un cherche la gloire de celui qui l'a envoyé, c'est un homme sans malice et qui dit la vérité."
,"19":"C'est bien Moïse qui vous a donné la Loi? Pourtant aucun de vous n'observe la Loi. Alors, pourquoi voulez-vous me tuer?'"
,"20":"Les Juifs lui répondent: 'Tu as un démon! Qui est-ce qui cherche à te tuer?'"
,"21":"Jésus leur dit: 'J'en suis à ma première intervention et déjà vous êtes scandalisés."
,"22":"Voyez comment Moïse vous a ordonné la circoncision (en réalité elle ne vient pas de Moïse, mais des ancêtres)-et vous faites la circoncision,même le jour du sabbat. "
,"23":"Pour ne pas désobéir à la Loi de Moïse, on donne à quelqu'un la circoncision le jour du sabbat. Alors, pourquoi me faites-vous des reproches quand je donne à quelqu'un la pleine santé le jour du sabbat?"
,"24":"Ne jugez pas selon les apparences, jugez selon la justice.'"
,"25":"Des gens de Jérusalem disaient: 'C'est donc lui l'homme qu'on voudrait tuer?"
,"26":"Et maintenant il parle ouvertement et on ne lui dit rien. Nos chefs auraient-ils vraiment reconnu qu'il est le Messie?"
,"27":"Pourtant nous savons bien d'où il est, alors que pour le Messie, personne ne sait d'où il sortira.'"
,"28":"C'est pourquoi Jésus, qui enseignait dans le Temple, éleva la voix et déclara: 'Vraiment vous me connaissez et vous savez d'où je suis! Je ne viens pas de moi-même. J'ai été envoyé par Celui qui est Vrai, par celui que vous ne connaissez pas."
,"29":"C'est lui qui m'a envoyé, et moi je le connais parce que je viens d'auprès de lui.'"
,"30":"On aurait voulu l'arrêter, mais personne ne mit la main sur lui parce que son heure n'était pas encore venue."
,"31":"Dans la foule beaucoup crurent en lui, car ils disaient: 'Quand le Christ viendra, fera-t-il davantage de miracles que cet homme?'"
,"32":"Les Pharisiens étaient au courant de tout ce qu'on disait dans le peuple à propos de Jésus. En accord avec les Pharisiens, les grands prêtres envoyèrent la police du Temple pour l'arrêter."
,"33":"Jésus dit alors: 'Je suis avec vous pour très peu de temps encore, ensuite j'irai vers celui qui m'a envoyé."
,"34":"Vous me chercherez, mais vous ne me trouverez pas, car vous ne pouvez pas venir où je suis.'"
,"35":"Aussitôt les Juifs se demandèrent: 'Où veut-il aller que nous ne puissions pas le trouver? Pense-t-il visiter ceux qui ont émigré vers le monde grec et prêcher également aux Grecs?"
,"36":"Qu'est-ce qu'il a dit là: Vous me chercherez et vous ne me trouverez pas, vous ne pouvez pas venir où je suis?'"
,"37":"C'était le dernier jour de la fête, qui est aussi le plus important. Jésus, qui s'était mis debout, éleva la voix: 'Celui qui a soif, qu'il vienne à moi! Qu'il boive,"
,"38":"celui qui croit en moi! L'Ecriture l'a dit: Des fleuves d'eau vive jailliront de son coeur.'"
,"39":"Quand Jésus disait cela, il pensait à l'Esprit que devaient recevoir ceux qui croient en lui. A ce moment-là on n'avait pas encore l'Esprit, puisque Jésus n'était pas encore entré dans sa gloire."
,"40":"Bien des gens qui avaient entendu ces paroles disaient: 'C'est sûrement lui le Prophète!'"
,"41":"D'autres disaient: 'C'est lui le Messie!' Mais certains demandaient: 'Le Messie peut-il venir de Galilée?"
,"42":"Le Messie est descendant de David: n'est-ce pas dit dans l'Ecriture? Et il doit venir de Bethléem, la ville de David.'"
,"43":"Ainsi les gens se divisaient à cause de lui."
,"44":"Certains voulaient l'arrêter, mais personne ne mit la main sur lui."
,"45":"Lorsque les policiers furent de retour chez les grands prêtres et les Pharisiens, ceux-ci leur demandèrent: 'Pourquoi ne l'avez-vous pas arrêté?'"
,"46":"Les policiers répondirent: 'Jamais un homme n'a parlé ainsi.'"
,"47":"Les Pharisiens répliquèrent: 'Vous aussi vous vous êtes laissé prendre?"
,"48":"Y a-t-il seulement un chef ou un Pharisien qui ait cru en lui?"
,"49":"Mais ce peuple qui ignore tout de la Loi, ce sont des maudits!'"
,"50":"Alors intervint Nicodème, l'un d'entre eux; c'était lui qui était venu voir Jésus au début, et il demanda:"
,"51":"'Est-ce que notre Loi condamne quelqu'un sans d'abord l'interroger pour savoir ce qu'il fait?'"
,"52":"Les autres lui dirent: 'Toi aussi tu es Galiléen? Regarde un peu, et tu verras que les prophètes n'arrivent pas de Galilée.'"
,"53":"Et c'est ainsi que chacun retourna chez soi."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Jésus était reparti vers le mont des Oliviers."
,"2":"Dès le matin à la première heure il était de nouveau au Temple; tout le peuple venait à lui, et lui s'asseyait pour les enseigner."
,"3":"C'est alors que les maîtres de la Loi et les Pharisiens lui amènent une femme surprise en adultère. Ils la placent au centre,"
,"4":"puis ils lui demandent: 'Maître, cette femme est une adultère et elle a été prise sur le fait."
,"5":"Dans la Loi, Moïse nous a ordonné de lapider les femmes qui sont dans ce cas, mais toi, qu'est-ce que tu dis?'"
,"6":"Ils parlaient de cette façon pour le mettre à l'épreuve, car ils cherchaient un motif pour l'accuser. Mais Jésus se pencha et se mit à écrire sur le sol avec son doigt."
,"7":"Comme ils insistaient avec leurs questions, Jésus se redressa et leur dit: 'Que celui d'entre vous qui n'a pas de péché lui jette la pierre le premier.'"
,"8":"Et de nouveau il se pencha et se mit à écrire sur le sol."
,"9":"Après une telle réponse, ils commencèrent à s'en aller l'un après l'autre en commençant par les plus âgés, et Jésus se retrouva seul avec la femme au centre."
,"10":"Alors il se redressa et lui dit: 'Femme, où sont-ils? Personne ne t'a condamnée?'"
,"11":"Elle répondit: 'Personne, vous voyez.' Et Jésus lui dit: 'Moi non plus, je ne te condamne pas; va et ne pèche plus.'"
,"12":"Jésus parla de nouveau à la foule, il leur dit: 'Je suis la lumière du monde. Celui qui me suit ne marchera pas dans les ténèbres: il aura la lumière qui est vie.'"
,"13":"Alors les Pharisiens lui dirent: 'Si tu te recommandes toi-même, ta recommandation ne vaut rien.'"
,"14":"Jésus leur répondit: 'Même si c'est moi qui me recommande, ma recommandation vaut, parce que je sais d'où je suis venu et où je vais. C'est vous qui ne savez pas d'où je viens et où je vais."
,"15":"Vous jugez, et c'est la chair qui parle: moi je ne juge personne."
,"16":"Mais si je juge, mon jugement vaut, parce que je ne suis pas seul: il y a moi et le Père qui m'a envoyé."
,"17":"Regardez votre Loi: il est écrit que le témoignage vaut s'il y a deux personnes."
,"18":"Je donne un témoignage sur moi-même, et le Père qui m'a envoyé me donne aussi son témoignage.'"
,"19":"Alors ils lui dirent: 'Où est ton Père?' Jésus répondit: 'Vous ne connaissez ni moi, ni mon Père. Si vous me connaissiez, vous connaîtriez aussi mon Père.'"
,"20":"Jésus fit cette déclaration dans la salle des offrandes, au temps où il enseignait dans le Temple; personne ne l'arrêta, car son heure n'était pas encore venue."
,"21":"De nouveau Jésus leur dit: 'Je m'en vais et vous me chercherez, et comme vous ne pouvez venir où je suis, vous mourrez dans votre état de péché.'"
,"22":"Les Juifs donc se demandaient: 'Il dit que nous ne pouvons pas aller là où il va: est-ce que par hasard il pense à se tuer?'"
,"23":"Mais Jésus leur dit: 'Vous êtes d'en bas et je suis d'en haut. Vous êtes de ce monde, et moi je ne suis pas de ce monde."
,"24":"Je vous ai donc dit que vous mourrez avec vos péchés: oui, si vous ne croyez pas que Je Suis, vous mourrez avec vos péchés.'"
,"25":"Alors ils lui demandèrent: 'Mais tu es qui?' Jésus leur dit: 'Exactement ce que je viens de vous dire."
,"26":"J'ai beaucoup à dire et à condamner chez vous, et ce que je dis au monde, je l'ai appris auprès de celui qui m'envoie: lui est Vrai.'"
,"27":"Les Juifs ne comprirent pas que Jésus parlait de son Père."
,"28":"Alors Jésus leur dit: 'Quand vous aurez élevé le Fils de l'Homme, vous saurez que Je Suis mais que je ne fais rien de moi-même: je dis ce que le Père m'a fait savoir."
,"29":"Celui qui m'a envoyé est avec moi; il ne me laisse jamais seul car je fais toujours ce qui lui est agréable.'"
,"30":"Voilà ce que Jésus disait, et beaucoup eurent foi en lui."
,"31":"Jésus disait donc aux Juifs qui croyaient en lui: 'Vous serez mes vrais disciples si vous persévérez dans ma parole;"
,"32":"alors vous connaîtrez la vérité et la vérité vous rendra libres.'"
,"33":"Ils lui répondirent: 'Nous sommes la race d'Abraham et nous n'avons jamais été esclaves de personne; pourquoi nous dis-tu: Vous serez libres?'"
,"34":"Jésus leur dit: 'En vérité, en vérité, je vous le dis: celui qui vit dans le péché est esclave du péché."
,"35":"Mais l'esclave ne reste pas toujours dans la maison. Celui qui est à demeure, c'est le fils."
,"36":"Donc si celui qui vous libère est le Fils, votre liberté est réelle."
,"37":"Je sais bien que vous êtes la race d'Abraham. Cependant ma doctrine ne vous touche pas et c'est pourquoi vous voulez me tuer."
,"38":"Je dis ce que j'ai vu chez le Père, et vous faites ce que vous avez appris de votre père.'"
,"39":"Les Juifs alors lui coupèrent la parole: 'Notre père est Abraham!' Jésus leur dit: 'Si vous étiez les enfants d'Abraham, vous agiriez comme Abraham a fait."
,"40":"Mais voilà quelqu'un qui vous dit la vérité, une vérité que j'ai apprise de Dieu, et vous voulez me tuer. Ce n'est pas la manière d'Abraham;"
,"41":"vous agissez comme a fait votre père.' Alors ils lui dirent: 'Nous ne sommes pas nés hors mariage, nous n'avons qu'un Père, Dieu.'"
,"42":"Jésus leur dit: 'Si Dieu était votre Père, vous m'aimeriez, puisque je suis sorti de Dieu pour venir ici. C'est lui qui m'a envoyé et je ne suis pas venu de moi-même."
,"43":"Pourquoi ne comprenez-vous pas mon langage? Parce que vous ne pouvez pas recevoir mon message."
,"44":"Vous appartenez à votre père, le diable, et vous cherchez à satisfaire les désirs de votre père. Depuis le commencement il a été homicide: c'est que la vérité n'était pas en lui et il ne s'est pas maintenu dans la vérité. Il est menteur et père du mensonge, et le mensonge lui vient tout naturellement."
,"45":"Voilà bien pourquoi vous ne me croyez pas quand je vous dis la vérité."
,"46":"Qui d'entre vous me montrera que je suis en tort? Et si je vous dis la vérité, pourquoi ne me croyez-vous pas?"
,"47":"Celui qui est de Dieu écoute les paroles de Dieu; si vous ne m'écoutez pas, c'est que vous n'êtes pas de Dieu.'"
,"48":"Aussitôt les Juifs lui dirent: 'N'avions-nous pas raison? Tu es un Samaritain, ou tu as un démon.'"
,"49":"Jésus leur répondit: 'Je n'ai pas de démon, simplement vous m'insultez parce que j'honore mon Père."
,"50":"Je n'ai pas besoin de défendre mon honneur: un autre s'en charge et fera justice."
,"51":"En vérité, en vérité, je vous le dis: si quelqu'un garde ma parole, il ne connaîtra jamais la mort.'"
,"52":"Les Juifs lui dirent: 'Maintenant nous savons que tu as un démon. Abraham est mort, et les prophètes également, et toi tu dis: Si quelqu'un garde ma parole, il ne connaîtra jamais la mort?"
,"53":"Tu es donc plus grand que notre père Abraham qui est mort, tout comme les prophètes sont morts? Pour qui te prends-tu?'"
,"54":"Jésus alors déclara: 'Si je fais mon éloge, cet éloge ne vaut rien. Mais c'est mon Père qui me glorifie, celui que vous appelez: notre Dieu."
,"55":"Vous ne le connaissez pas, alors que moi je le connais. Et si je disais que je ne le connais pas, je serais menteur comme vous. Car moi je le con nais, et je garde sa parole."
,"56":"Quant à Abraham, votre père, toute sa joie était d'attendre ma venue. Il l'a vue et il s'est réjoui.'"
,"57":"Les Juifs alors lui dirent: 'Tu n'as pas cinquante ans et tu as vu Abraham?'"
,"58":"Jésus leur répondit: 'En vérité, en vérité, je vous le dis: avant qu'Abraham ne soit venu, moi Je Suis.'"
,"59":"Sur ce, ils cherchèrent des pierres pour les lui jeter, mais Jésus se cacha et sortit du Temple."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Comme Jésus passait, il vit un homme qui était aveugle de naissance."
,"2":"Ses disciples lui demandèrent: 'Rabbi, qui a péché pour qu'il soit ainsi aveugle? Est-ce lui ou ses parents?'"
,"3":"Jésus leur dit: 'S'il est ainsi, ce n'est pas à cause d'un péché, de lui ou de ses parents, mais pour qu'une oeuvre de Dieu, et très évidente, se fasse en lui."
,"4":"Aussi longtemps qu'il fait jour, nous devons faire les oeuvres de celui qui m'a envoyé. Ensuite vient la nuit et l'on ne peut plus rien faire."
,"5":"Tant que je suis dans le monde, je suis la lumière du monde.'"
,"6":"Après avoir ainsi parlé, Jésus crache à terre et avec sa salive fait un peu de boue dont il enduit les yeux de l'aveugle."
,"7":"Puis il lui dit: 'Va te laver à la piscine de Siloé (ce nom veut dire: l'Envoyé).' L'homme y va, se lave et repart: il voyait clair."
,"8":"Les voisins et ceux qui auparavant l'ont vu mendier s'étonnent: 'Mais c'est bien celui qui s'installait ici pour mendier!'"
,"9":"Les uns disent: 'C'est lui', et d'autres: 'Non, c'est un autre qui lui ressemble.' Et lui leur dit: 'C'est bien moi.'"
,"10":"On lui demande: 'Mais comment tes yeux se sont-ils ouverts?'"
,"11":"Il répond: 'Celui qu'on appelle Jésus a fait de la boue et m'en a enduit les yeux, puis il m'a dit: Va te laver à Siloé. J'y suis allé et, aussitôt lavé, j'ai vu.'"
,"12":"Ils lui disent: 'Où est cet homme?' Il répond: 'Je ne sais pas.'"
,"13":"On amène donc aux Pharisiens l'aveugle guéri."
,"14":"Mais voilà que c'était un sabbat, et Jésus avait fait de la boue et il lui avait enduit les yeux!"
,"15":"A leur tour les Pharisiens l'interrogent: 'Comment as-tu retrouvé la vue?' Il leur répond: 'Il a mis de la boue sur mes yeux, je me suis lavé et je vois.'"
,"16":"Quelques-uns des Pharisiens disent alors: 'Cet homme-là n'est pas avec Dieu puisqu'il ne respecte pas le Sabbat.' Mais d'autres répondent: 'Un homme pécheur peut-il faire de tels signes?' Et ils sont divisés."
,"17":"Alors de nouveau on demande à l'aveugle: 'Puisqu'il t'a ouvert les yeux, que penses-tu de lui?' Et il répond: 'C'est un prophète.'"
,"18":"Les Juifs ne veulent pas croire qu'il voit après avoir été aveugle, tant qu'ils n'auront pas convoqué les parents du miraculé."
,"19":"Ils leur demandèrent: 'C'est bien votre fils? Et vous dites qu'il est né aveugle? Et alors, pourquoi voit-il maintenant?'"
,"20":"Les parents répondirent: 'Oui, c'est notre fils, et il est né aveugle."
,"21":"Mais comment voit-il maintenant, nous n'en savons rien; et qui lui a ouvert les yeux, nous n'en savons rien. Interrogez-le, c'est un adulte, il expliquera lui-même son cas.'"
,"22":"Ses parents firent cette réponse parce qu'ils avaient peur des Juifs. En effet les Juifs avaient déjà décidé d'expulser tous ceux qui reconnaîtraient Jésus comme le Messie."
,"23":"Pour cette raison les parents dirent: 'Demandez-lui, c'est un adulte.'"
,"24":"On convoque donc une deuxième fois cet aveugle et on lui dit: 'Dis toute la vérité. Nous savons que cet homme est un pécheur.'"
,"25":"Il répond: 'S'il est un pécheur, je n'en sais rien. Je ne sais qu'une chose: j'étais aveugle et maintenant je vois.'"
,"26":"Ils lui disent: 'Qu'est-ce qu'il t'a fait? Comment t'a-t-il ouvert les yeux?'"
,"27":"Et lui répond: 'Je vous l'ai déjà dit et vous ne voulez pas m'écouter. Qu'est-ce que vous voulez savoir de plus? Peut-être voulez-vous devenir ses disciples?'"
,"28":"Aussitôt ils commencent à l'insulter: 'Toi, tu es son disciple, mais nous, nous sommes les disciples de Moïse."
,"29":"Nous savons que Dieu a parlé à Moïse, mais celui-là, nous ne savons pas d'où il sort.'"
,"30":"Alors l'homme leur répond: 'C'est vraiment étonnant! Il m'a ouvert les yeux et vous ne savez pas d'où il vient?"
,"31":"Nous savons bien que Dieu n'écoute pas les pécheurs; il écoute ceux qui respectent Dieu et qui font sa volonté."
,"32":"On n'a jamais entendu dire que quelqu'un ait ouvert les yeux d'un aveugle de naissance."
,"33":"Cet homme ne pourrait rien faire s'il ne venait pas de Dieu.'"
,"34":"Les autres ripostèrent: 'Tu n'es que péché depuis ta naissance, et tu veux nous faire la leçon?' Et ils l'expulsèrent."
,"35":"Jésus apprit qu'on l'avait expulsé. Quand il le rencontra, il lui dit: 'As-tu foi dans le Fils de l'Homme?'"
,"36":"Il répondit: 'Qui est-il, Seigneur, que je croie en lui?'"
,"37":"Jésus lui dit: 'Tu le vois, c'est lui qui te parle.'"
,"38":"L'homme déclara: 'Je crois, Seigneur.' Et il se prosterna devant lui."
,"39":"Jésus dit alors: 'Je suis venu dans le monde pour une remise en cause: ceux qui ne voient pas verront, et ceux qui voient seront aveugles.'"
,"40":"Quelques Pharisiens étaient là, et ils l'entendirent. Ils lui demandèrent: 'Nous serions donc aveugles, nous aussi?'"
,"41":"Jésus leur répondit: 'Si vous étiez aveugles, vous n'auriez pas de péché. Mais vous dites que vous voyez, c'est la preuve de votre péché'."
}`)
	CurrentBook.AddChapter(10, `{
"1":"'En vérité, en vérité, je vous le dis: celui qui passe par-dessus le mur du parc à brebis au lieu d'entrer par la porte, c'est un voleur et un bandit."
,"2":"Celui qui entre par la porte, c'est le berger des brebis."
,"3":"Le portier lui ouvre et les brebis reconnaissent sa voix; il appelle ses brebis chacune par son nom, et il les fait sortir."
,"4":"Quand il a fait sortir toutes celles qui sont à lui, il marche devant elles et les brebis le suivent, car elles connaissent sa voix."
,"5":"Si c'est un autre, elles ne vont pas le suivre; bien mieux, elles s'enfuiront, parce qu'elles ne connaissent pas la voix de l'étranger.'"
,"6":"Jésus leur donna cette comparaison, mais ils ne comprirent pas ce qu'il voulait leur dire."
,"7":"Aussi de nouveau Jésus leur dit: 'En vérité, en vérité, je vous le dis: je suis la porte des brebis."
,"8":"Tous ceux qui sont venus sont des voleurs et des bandits, et les brebis ne les ont pas écoutés."
,"9":"Je suis la porte. Celui qui entrera par moi sera sauvé; il pourra entrer et sortir, il trouvera sa nourriture."
,"10":"Le voleur ne vient que pour prendre, égorger et détruire, alors que moi je suis venu pour qu'on ait la vie, la vie en plénitude."
,"11":"Je suis le bon berger. Le bon berger donne sa vie pour les brebis."
,"12":"Le salarié est tout différent du vrai berger; les brebis ne sont pas siennes, et lorsqu'il voit venir le loup, il s'enfuit laissant là les brebis; le loup s'en empare et les disperse."
,"13":"C'est qu'il est là seulement pour le salaire et les brebis ne l'intéressent pas."
,"14":"Je suis le bon berger et je connais les miens comme ils me connaissent,"
,"15":"tout comme le Père me connaît et moi je connais le Père. Et je donne ma vie pour les brebis."
,"16":"J'ai d'autres brebis qui ne sont pas dans ce parc. Celles-là aussi je dois aller les chercher et elles entendront mon appel; elles ne feront plus qu'un seul troupeau avec un seul berger."
,"17":"Le Père m'aime parce que je donne ma vie pour ensuite la reprendre."
,"18":"Personne ne me la prend: c'est moi qui la donne de moi-même. J'ai tout pouvoir pour la donner, mais aussi pour la reprendre: c'est là l'instruction que j'ai reçue de mon Père.'"
,"19":"En entendant cela, les Juifs se divisèrent de nouveau."
,"20":"Plusieurs d'entre eux disaient: 'Il a un démon, il est dérangé! Pourquoi restez-vous à l'écouter?'"
,"21":"Mais d'autres disaient: 'Quand on a un démon, on ne parle pas de cette façon. Et vous croyez qu'un démon peut ouvrir les yeux des aveugles?'"
,"22":"On eut alors à Jérusalem la fête de la Dédicace, et c'était l'hiver."
,"23":"Comme Jésus se promenait dans le Temple sous le portique de Salomon,"
,"24":"les Juifs firent cercle autour de lui. Ils lui dirent: 'Jusqu'à quand vas-tu nous tenir en suspens? Si tu es le Messie, dis-le clairement.'"
,"25":"Jésus leur répondit: 'Je vous l'ai dit et vous ne me croyez pas: les oeuvres que je fais au nom de mon Père disent clairement ce que je suis."
,"26":"Mais, comme je vous l'ai dit, vous ne croyez pas parce que vous n'êtes pas de mes brebis."
,"27":"Mes brebis entendent ma voix, et moi je les connais; et elles me suivent."
,"28":"Je leur donne de vivre pour toujours: jamais elles ne périront, et personne ne les arrachera de ma main."
,"29":"Ce que mon Père me donne est plus fort que tout, et personne ne peut rien arracher de la main de mon Père."
,"30":"Le Père et moi, nous sommes un.'"
,"31":"De nouveau les Juifs ramassèrent des pierres pour les lui jeter."
,"32":"Jésus leur dit: 'J'ai fait, et vous avez vu, beaucoup de belles oeuvres qui venaient du Père. Quelle est celle qui mérite ces pierres?'"
,"33":"Les Juifs lui répondirent: 'Ce n'est pas pour une belle oeuvre que nous te lapidons, mais parce que tu blasphèmes: tu n'es qu'un homme et tu te fais Dieu.'"
,"34":"Alors Jésus leur dit: 'Dans votre Loi il est écrit: Je l'ai dit, vous êtes des dieux."
,"35":"On ne peut changer l'Ecriture, et ici elle appelle 'dieux' ceux qui recevaient cette parole de Dieu."
,"36":"Mais moi, après que le Père m'a consacré et envoyé dans le monde, vous dites que je blasphème quand je déclare: 'Je suis Fils de Dieu'?"
,"37":"Si je ne fais pas les oeuvres de mon Père, ne me croyez pas."
,"38":"Mais si je les fais, croyez en moi. Si vous ne me croyez pas, croyez au moins à ces oeuvres, et sachez et reconnaissez que le Père est en moi et moi dans le Père.'"
,"39":"De nouveau on voulut l'arrêter, mais il leur échappa."
,"40":"Jésus passa alors de l'autre côté du Jourdain, à l'endroit où Jean baptisait au commencement, et il y demeura."
,"41":"Beaucoup de gens vinrent le trouver qui disaient: 'Jean n'a fait aucun miracle, mais tout ce que Jean a dit de celui-ci s'est vérifié.'"
,"42":"Et là, beaucoup crurent en lui."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Il y avait un malade: c'était Lazare, de Béthanie, le village de Marie et de sa soeur Marthe."
,"2":"Cette Marie était la même qui a parfumé le Seigneur avec de la myrrhe et lui a essuyé les pieds avec ses cheveux. Son frère Lazare était malade."
,"3":"Les soeurs envoyèrent donc à Jésus ce message: 'Seigneur, celui que tu aimes est malade.'"
,"4":"Lorsque Jésus l'apprit, il déclara: 'Cette maladie n'ira pas à la mort; elle est pour la gloire de Dieu et par elle le Fils de Dieu sera glorifié.'"
,"5":"Jésus aimait Marthe, et sa soeur, et Lazare."
,"6":"Pourtant, quand il sut que La-zare était malade, il resta encore deux jours au même endroit."
,"7":"Après quoi il dit aux disciples: 'Retournons en Judée.'"
,"8":"Les disciples lui dirent: 'Rabbi, récemment les Juifs voulaient te tuer à coups de pierres, et tu retournes là-bas?'"
,"9":"Jésus leur répondit: 'Ne faut-il pas douze heures pour faire une journée? Tant qu'on marche de jour on ne trébuche pas, parce qu'on voit la lumière de ce monde."
,"10":"Mais si on marche de nuit, c'est qu'on n'a pas en soi la lumière, et alors on trébuche.'"
,"11":"Telle fut la réponse de Jésus. Puis il leur dit: 'Notre ami Lazare s'est endormi, mais j'y vais pour le réveiller.'"
,"12":"Les disciples lui dirent: 'Seigneur, s'il s'est endormi, il va guérir.'"
,"13":"Jésus voulait dire que Lazare était mort, et eux l'avaient compris du sommeil ordinaire."
,"14":"Alors Jésus leur dit clairement: 'Lazare est mort,"
,"15":"mais je suis heureux pour vous de ne pas avoir été là, car cela vous fera croire. Allons chez lui.'"
,"16":"A ce moment Thomas, qu'on appelait le Jumeau, dit aux autres disciples: 'Allons-y, nous aussi, nous allons mourir avec lui!'"
,"17":"Lorsque Jésus arriva, Lazare était déjà dans la tombe depuis quatre jours."
,"18":"Comme Béthanie est tout près de Jérusalem, à un peu plus de deux kilomètres,"
,"19":"beaucoup de Juifs étaient venus chez Marthe et Marie pour les consoler de la mort de leur frère."
,"20":"Quand Marthe apprit que Jésus arrivait, elle alla au-devant de lui pendant que Marie restait assise à la maison."
,"21":"Alors Marthe dit à Jésus: 'Seigneur, si tu avais été ici, mon frère ne serait pas mort."
,"22":"Pourtant je sais que tu peux tout demander à Dieu, et Dieu te l'accordera.'"
,"23":"Jésus lui dit: 'Ton frère va se relever.'"
,"24":"Marthe lui dit: 'Je sais qu'il se relèvera au dernier jour, celui de la résurrection.'"
,"25":"Jésus lui dit: 'C'est moi qui suis la résurrection et la vie. Celui qui croit en moi, même s'il vient à mourir, vivra."
,"26":"Le vivant, celui qui croit en moi, ne mourra pas pour toujours. Crois-tu cela?'"
,"27":"Elle répondit: 'Oui Seigneur, je crois que tu es le Christ, le Fils de Dieu, celui qui vient dans le monde.'"
,"28":"Ayant dit cela, elle alla appeler sa soeur Marie et lui dit à voix basse: 'Le Maître est là et il t'appelle.'"
,"29":"Quand elle l'apprit, elle se leva aussitôt et vint à la rencontre de Jésus."
,"30":"Jésus n'était pas encore entré dans le village, il était là où Marthe l'avait rencontré."
,"31":"En voyant Marie se lever précipitamment et sortir, les Juifs qui étaient avec elle à la maison pour la consoler la suivirent, car ils pensaient qu'elle allait pleurer à la tombe."
,"32":"Mais lorsque Marie arriva là où était Jésus, dès qu'elle le vit elle tomba à ses pieds. Elle lui dit: 'Seigneur, si tu avais été ici, mon frère ne serait pas mort.'"
,"33":"Quand Jésus la vit qui se lamentait, et tous les Juifs qui reprenaient la lamentation, son esprit en fut secoué et il se troubla."
,"34":"Il dit: 'Où l'avez-vous mis?' Ils répondirent: 'Seigneur, viens voir.'"
,"35":"Et Jésus pleura."
,"36":"Les Juifs firent cette réflexion: 'Voyez comme il l'aimait!'"
,"37":"Pourtant certains d'entre eux dirent: 'S'il a ouvert les yeux de l'aveugle, ne pouvait-il pas faire que celui-ci ne meure pas?'"
,"38":"De nouveau Jésus frémit et il alla vers la tombe. C'était une caverne avec une pierre qui bouchait l'entrée."
,"39":"Jésus dit: 'Enlevez la pierre.' Marthe, la soeur du mort, lui dit: 'Seigneur, il en est à son quatrième jour et il sent déjà.'"
,"40":"Jésus lui dit: 'Ne t'ai-je pas dit que si tu crois, tu verras la gloire de Dieu?'"
,"41":"On enlève donc la pierre. Jésus lève les yeux au ciel et dit: 'Père, je te rends grâces car tu m'as écouté."
,"42":"Je savais bien que toujours tu m'écoutes, mais je le dis en pensant à ces gens qui m'entourent, car ils pourront croire que tu m'as envoyé.'"
,"43":"Puis Jésus appelle d'une voix forte: 'Lazare, dehors, viens ici!'"
,"44":"Et voilà que sort celui qui était mort; ses mains et ses pieds sont liés avec les bandes, et son visage est encore enveloppé du couvre-tête. Alors Jésus leur dit: 'Déliez-le, et qu'il puisse marcher!'"
,"45":"Beaucoup de Juifs qui étaient venus chez Marie crurent en Jésus après avoir vu ce qu'il avait fait."
,"46":"Mais certains d'entre eux allèrent dire aux Pharisiens ce que Jésus avait fait."
,"47":"Les Pharisiens et les chefs des prêtres appelèrent à un conseil, et là ils dirent: 'Où en sommes-nous? Cet homme fait quantité de miracles."
,"48":"Si nous le laissons faire, tous vont croire en lui. Les Romains vont alors intervenir, et ils sont capables de tout détruire: nous-mêmes, le Temple et la nation.'"
,"49":"A ce moment l'un d'eux intervint: c'était Caïphe, le Grand Prêtre pour cette année-là, et il dit: 'Vous ne savez pas vous y prendre."
,"50":"Faites le compte: il vaut mieux qu'un seul homme meure pour tout le peuple, plutôt que de voir la ruine de toute la nation.'"
,"51":"Caïphe n'a pas dit cela de lui-même; il était le Grand Prêtre de cette année-là, et il était prophète quand il disait que Jésus allait mourir pour la nation."
,"52":"En fait, ce n'était pas seulement pour la nation mais aussi pour rassembler dans l'unité les enfants de Dieu dispersés."
,"53":"Ce jour-là ils décidèrent de le tuer."
,"54":"Pour cette raison Jésus ne pouvait plus circuler sans danger chez les Juifs. Il s'éloigna vers le désert et il demeura avec ses disciples dans une ville nommée Ephraïm."
,"55":"La Pâque des Juifs était proche et beaucoup montèrent de leurs campagnes à Jérusalem avant la Pâque pour se purifier."
,"56":"Ils cherchaient Jésus et, quand ils se retrouvaient dans le Temple, ils disaient: 'Qu'en pensez-vous? Etes-vous sûrs qu'il ne viendra pas à la fête?'"
,"57":"Pour leur part, les grands prêtres et les Pharisiens avaient donné des instructions: si quelqu'un savait où il était, il devait le dénoncer pour qu'on l'arrête."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Six jours avant la Pâque, Jésus vint à Béthanie, là où était Lazare, celui que Jésus avait fait se lever d'entre les morts."
,"2":"Là on lui prépara un dîner; Marthe faisait le service et Lazare était l'un des convives aux côtés de Jésus."
,"3":"Or voici que Marie prend un flacon de parfum, du vrai nard extrêmement cher, et elle le verse sur les pieds de Jésus; puis elle lui essuie les pieds avec ses cheveux pendant que l'odeur du parfum remplit la maison."
,"4":"Intervient alors Judas Iscariote, l'un des disciples de Jésus, celui qui va le trahir:"
,"5":"'On aurait pu vendre ce parfum pour trois cents pièces d'argent, dit-il, et on l'aurait donné aux pauvres.'"
,"6":"En réalité, Judas ne se souciait pas des pauvres, mais il volait; comme il portait la bourse du groupe, tout ce qu'on y mettait passait par ses mains."
,"7":"Mais Jésus dit: 'Ne lui reproche pas d'avoir gardé ce parfum pour le jour de mon enterrement."
,"8":"Vous avez toujours des pauvres parmi vous, mais moi vous ne m'aurez pas toujours.'"
,"9":"Beaucoup de Juifs apprirent que Jésus était là, et ils vinrent pour lui, bien sûr, mais aussi pour voir Lazare qu'il avait fait se lever d'entre les morts."
,"10":"C'est alors que les grands prêtres pensèrent à tuer aussi Lazare,"
,"11":"car beaucoup de Juifs les quittaient à cause de lui et croyaient en Jésus."
,"12":"Le lendemain, beaucoup de ceux qui étaient venus pour la fête apprirent que Jésus venait à Jérusalem."
,"13":"Ils prirent des palmes et vinrent à sa rencontre en criant: 'Hosanna, béni soit celui qui vient au nom du Seigneur, c'est lui le roi d'Israël!'"
,"14":"Jésus avait trouvé un âne encore jeune, et il monta dessus, comme le dit l'Ecriture:"
,"15":"Ne crains pas Sion, ô ma fille, voici que ton roi vient à toi monté sur le petit d'une ânesse.'"
,"16":"Les disciples au début n'y pensèrent pas. Mais lorsque Jésus entra dans sa gloire, ils se souvinrent qu'ils avaient fait pour lui cela-même, et que ç'avait été écrit pour lui."
,"17":"Tout le peuple qui était auprès de Jésus quand il avait appelé Lazare dans sa tombe et l'avait réveillé d'entre les morts, rendait témoignage."
,"18":"C'est donc une foule qui vint l'accueillir, parce qu'on leur avait parlé de ce signe que Jésus avait fait."
,"19":"Voyant cela, les Pharisiens se dirent entre eux: 'Regardez, nous n'arrivons à rien; le monde entier court après lui!'"
,"20":"Il y avait là des Grecs qui étaient venus à la fête pour adorer."
,"21":"Ils vinrent trouver Philippe, celui qui était de Bethsaïde en Galilée, et ils lui firent cette demande: 'S'il vous plaît, nous voudrions voir Jésus.'"
,"22":"Philippe vient en parler à André, et André part avec Philippe pour le dire à Jésus."
,"23":"Alors Jésus déclare: 'L'heure est venue où le Fils de l'Homme va être glorifié."
,"24":"En vérité, en vérité, je vous le dis: si le grain de blé ne tombe pas en terre pour y mourir, il reste seul. C'est quand il meurt qu'il porte beaucoup de fruits."
,"25":"Celui qui tient à sa vie la détruit, mais celui qui méprise sa vie dans ce monde la sauvegarde pour la vie éternelle."
,"26":"Si quelqu'un veut me servir, qu'il me suive, et là où je suis, là aussi sera mon serviteur; si quelqu'un me sert, le Père saura le récompenser."
,"27":"Maintenant je suis dans un grand trouble. Je pourrais dire: Père, épargne-moi cette épreuve! Mais je suis venu précisément pour connaître cette heure."
,"28":"Père, glorifie ton Nom!' A ce moment une réponse vint du ciel: 'Je l'ai glorifié et je le glorifierai encore.'"
,"29":"Les gens qui étaient là et qui avaient entendu, disaient: 'C'est le tonnerre.' D'autres disaient: 'Un ange lui a parlé.'"
,"30":"Alors Jésus déclara: 'Cette réponse était pour vous et non pour moi."
,"31":"C'est maintenant le jugement de ce monde: le Gouverneur de ce monde va être jeté dehors."
,"32":"Et moi, dès que j'aurai été élevé de terre, j'attirerai tout à moi.'"
,"33":"En disant cela, Jésus faisait allusion au genre de supplice par lequel il allait mourir."
,"34":"Aussi lui dit-on dans la foule: 'Nous avons appris dans la Loi que le Messie demeure à jamais. Et toi, tu dis que le Fils de l'Homme doit être élevé? Qui est ce Fils de l'Homme?'"
,"35":"Jésus leur dit: 'La lumière est avec vous pour peu de temps encore. Marchez tant que vous avez la lumière, ne vous laissez pas surprendre par la nuit. Marcher de nuit, c'est ne pas savoir où l'on va."
,"36":"Lorsque vous avez la lumière, croyez à la lumière et soyez fils de la lumière.',Telles furent les paroles de Jésus. Ensuite il les quitta et ne se montra plus."
,"37":"Il avait fait tant de signes sous leurs yeux et ils ne croyaient pas en lui!"
,"38":"C'est que les paroles du prophète Isaïe devaient s'accomplir: Seigneur, qui a cru à notre message? Les interventions du Seigneur sont restées un mystère pour tous."
,"39":"Ils ne pouvaient pas croire; Isaïe l'a dit en un autre passage:"
,"40":"Il a rendu leurs yeux aveugles, il a engourdi leur intelligence, pour que leurs yeux ne voient pas, pour que leur intelligence ne comprenne pas et qu'ils ne se convertissent pas: autrement je les aurais guéris!"
,"41":"Ce sont les paroles d'Isaïe; car il a vu sa gloire et il a parlé de lui."
,"42":"Il est vrai que, même parmi les chefs, un certain nombre crurent en lui, mais ils ne le dirent pas ouvertement pour ne pas être expulsés, car ils avaient peur des Pharisiens."
,"43":"Ils voulaient être bien considérés par les hommes plutôt que par Dieu."
,"44":"Or Jésus a dit bien haut: 'Celui qui croit en moi ne croit pas seulement en moi, mais en celui qui m'a envoyé."
,"45":"Celui qui me voit, voit celui qui m'a envoyé."
,"46":"Je suis venu dans le monde comme une lumière, pour que l'on croie en moi et qu'on sorte des ténèbres."
,"47":"Si quelqu'un entend mes paroles et ne les garde pas, ce n'est pas moi qui le condamne, car je ne suis pas venu pour condamner le monde mais pour le sauver."
,"48":"Pourtant le juge est là pour celui qui me méprise et ne reçoit pas mon message, c'est la parole que j'ai dite. Elle le jugera au dernier jour."
,"49":"Je n'ai pas parlé de moi-même; le Père, lorsqu'il m'a envoyé, m'a ordonné ce que je dois dire et comment le dire;"
,"50":"et je sais que ses ordres sont vie éternelle. Ainsi, quand je parle, je parle comme le Père me l'a demandé.'"
}`)
	CurrentBook.AddChapter(13, `{
"1":"C'était avant la fête de la Pâque. Jésus savait que son heure était venue et qu'il devait passer de ce monde au Père; lui qui avait aimé les siens qui sont dans le monde, il voulut les aimer jusqu'au bout."
,"2":"Ils prenaient ensemble le repas du soir et déjà le diable avait mis dans le coeur de Judas, fils de Simon Iscariote, la décision de le trahir."
,"3":"Jésus, lui, savait bien que le Père avait tout mis entre ses mains et qu'il retournait à Dieu comme il était venu de Dieu."
,"4":"Alors il se lève de table, retire ses vêtements et passe une serviette dans sa ceinture;"
,"5":"il verse de l'eau dans une cuvette et commence à laver les pieds des disciples. Ensuite il les essuie avec la serviette qu'il a dans la ceinture."
,"6":"Quand il s'approche de Simon-Pierre, celui-ci lui dit: 'Seigneur, tu ne vas pas me laver les pieds!'"
,"7":"Jésus lui répond: 'Tu ne sais pas ce que je veux faire; tu le comprendras plus tard.'"
,"8":"Pierre lui dit: 'Non, tu ne me laveras jamais les pieds.' Et Jésus lui répond: 'Si je ne te lave pas les pieds, tu ne peux pas rester avec moi.'"
,"9":"Alors Simon-Pierre lui dit: 'Seigneur, dans ce cas, ne me lave pas seulement les pieds, mais aussi les mains et la tête.'"
,"10":"Jésus lui dit: 'Quand on s'est déjà baigné, on est complètement pur, et il suffit de se laver les pieds. Vous êtes purs, mais pas tous.'"
,"11":"Jésus savait qui le trahissait; c'est pourquoi il dit: 'Vous n'êtes pas tous purs.'"
,"12":"Après leur avoir lavé les pieds, Jésus remet ses vêtements et reprend sa place à table. Alors il leur dit: 'Comprenez-vous ce que je viens de faire avec vous?"
,"13":"Vous m'appelez le Maître et le Seigneur, et vous dites bien car je le suis."
,"14":"Donc si moi, le Seigneur et le Maître, je vous ai lavé les pieds, vous aussi vous devez vous laver les pieds les uns aux autres."
,"15":"C'est un exemple que je vous ai donné, et vous ferez comme je l'ai fait."
,"16":"En vérité, en vérité, je vous le dis: le serviteur n'est pas au-dessus de son seigneur, et l'envoyé n'est pas au-dessus de celui qui l'envoie."
,"17":"Si maintenant vous savez ces choses, heureux êtes-vous si vous les mettez en pratique!"
,"18":"Je ne parle pas pour vous tous, car je connais ceux que j'ai choisis. Il est écrit: Celui qui partageait mon pain a levé son talon contre moi. Et cela va se vérifier."
,"19":"Je vous le dis maintenant avant que cela n'arrive; ainsi, lorsque cela arrivera, vous saurez que Je Suis."
,"20":"En vérité, en vérité, je vous le dis: celui qui reçoit mon envoyé me reçoit, et celui qui me reçoit, reçoit également celui qui m'a envoyé.'"
,"21":"A peine Jésus avait-il dit cela qu'il fut troublé en son esprit. Alors il dit très clairement: 'En vérité, en vérité, je vous le dis: l'un de vous va me trahir.'"
,"22":"Les disciples se demandaient de qui il pouvait bien parler, et ils se regardaient les uns les autres."
,"23":"Un des disciples, celui que Jésus aimait, était installé juste contre Jésus;"
,"24":"Simon-Pierre lui fit donc un signe pour qu'il demande à Jésus de qui il parlait."
,"25":"Et lui, qui se trouvait juste sur la poitrine de Jésus, se retourna vers Jésus pour lui dire: 'Seigneur, qui est-ce?'"
,"26":"Jésus lui donna cette précision: 'C'est celui à qui je vais passer un morceau trempé dans la sauce.' Il trempa le morceau et le donna à Judas, fils de Simon Iscariote."
,"27":"Et avec ce morceau, Satan entra en lui. Alors Jésus lui dit: 'Ce que tu veux faire, fais-le tout de suite.'"
,"28":"Aucun de ceux qui étaient à table ne comprit de quoi Jésus parlait."
,"29":"Comme Judas avait l'argent, on pouvait penser que Jésus lui disait d'acheter ce qui manquait pour la fête ou de donner quelque chose aux pauvres."
,"30":"Judas prit donc ce morceau et sortit aussitôt. Il faisait nuit."
,"31":"Lorsque Judas fut sorti, Jésus déclara: 'C'est maintenant que le Fils de l'Homme est glorifié et que Dieu est glorifié en lui."
,"32":"Aussi Dieu va-t-il lui faire partager sa Gloire, et il le fera bientôt."
,"33":"Mes petits enfants, je suis encore avec vous pour très peu de temps. Vous me chercherez et, comme je l'ai dit aux Juifs, je vous le dis maintenant: vous ne pouvez pas venir où je vais."
,"34":"Je vous donne ce commandement nouveau: aimez-vous les uns les autres. Aimez-vous les uns les autres comme je vous ai aimés."
,"35":"Ayez de l'amour entre vous; c'est ainsi que tout le monde reconnaîtra que vous êtes mes disciples.'"
,"36":"Alors Simon-Pierre lui dit: 'Seigneur, où vas-tu?' Jésus lui répondit: 'Tu ne peux pas me suivre là où je vais, mais tu m'accompagneras plus tard.'"
,"37":"Pierre lui dit: 'Seigneur, pourquoi est-ce que je ne pourrais t'accompagner maintenant? Je donnerais ma vie pour toi!'"
,"38":"Mais Jésus lui répond: 'Tu donneras ta vie pour moi? En vérité, en vérité, je te le dis: avant que le coq chante, tu m'auras renié trois fois.'"
}`)
	CurrentBook.AddChapter(14, `{
"1":"'Que votre coeur ne se trouble pas: croyez en Dieu et croyez aussi en moi."
,"2":"Dans la maison de mon Père il y a beaucoup de chambres. Sinon, je ne vous aurais pas dit que je m'en vais pour vous préparer une place."
,"3":"Quand je serai allé et que je vous aurai préparé une place, je reviendrai et je vous prendrai près de moi, de sorte que vous soyez aussi là où je suis."
,"4":"Et vous savez le chemin pour aller où je vais.'"
,"5":"Thomas lui dit alors: 'Seigneur, nous ne savons pas où tu vas, comment pouvons-nous en savoir le chemin?'"
,"6":"Jésus lui dit: 'Je suis le chemin, la vérité et la vie. Personne ne vient au Père sans passer par moi."
,"7":"Si vous me connaissez, vous connaîtrez aussi mon Père. D'ailleurs, dès maintenant vous le connaissez et vous l'avez vu.'"
,"8":"Philippe lui dit: 'Seigneur, montre-nous le Père et cela nous suffit.'"
,"9":"Jésus lui dit: 'Philippe, j'ai été si longtemps avec vous et tu ne me connais pas encore? Celui qui m'a vu, a vu le Père. Comment peux-tu dire: Montre-nous le Père?"
,"10":"Ne crois-tu pas que je suis dans le Père, et que le Père est en moi? Tout l'enseignement que je vous ai donné ne vient pas de moi, mais le Père demeure en moi pour accomplir ses propres oeuvres."
,"11":"Je suis dans le Père et le Père est en moi; faites-moi confiance en cela, ou sinon, croyez-le à cause de ces oeuvres."
,"12":"En vérité, en vérité, je vous le dis: si quelqu'un croit en moi, il fera lui aussi les oeuvres que je fais, et comme je retourne vers le Père, il en fera de plus grandes encore."
,"13":"Tout ce que vous demanderez confiant en mon Nom, je le ferai, pour que le Père soit glorifié à travers le Fils."
,"14":"Et de même je ferai ce que vous me demanderez à moi, confiant en mon Nom."
,"15":"Si vous m'aimez, vous garderez mes commandements."
,"16":"Moi, de mon côté, je demanderai au Père de vous donner un autre Protecteur qui sera pour toujours avec vous."
,"17":"C'est l'Esprit de Vérité que le monde ne peut recevoir, car il ne le voit pas et ne le connaît pas. Mais vous, vous le connaissez, puisqu'il est avec vous et demeure en vous."
,"18":"Je ne vous laisserai pas comme des orphelins, puisque je reviens vers vous."
,"19":"Encore un peu de temps et le monde ne me verra plus, mais vous, vous me verrez, puisque je suis vivant et que vous aussi vous vivrez."
,"20":"Ce jour-là vous saurez que je suis dans mon Père, et vous en moi, et moi en vous."
,"21":"Celui qui a reçu mes commandements et qui les garde, voilà celui qui m'aime; et celui qui m'aime sera aimé de mon Père. Moi aussi je l'aimerai et je me manifesterai à lui."
,"22":"A ce moment-là Jude, non pas Judas Iscariote, dit à Jésus: 'Mais comment cela? Veux-tu te manifester à nous et pas au monde?'"
,"23":"Jésus lui répondit: 'Si quelqu'un m'aime, il gardera ma parole et mon Père l'aimera. Alors nous viendrons à lui et nous nous ferons une chambre chez lui."
,"24":"Celui qui ne m'aime pas ne garde pas mes paroles, mais ce discours que vous écoutez n'est pas de moi, il vient du Père qui m'a envoyé."
,"25":"Je vous ai dit tout cela pendant que j'étais avec vous."
,"26":"Mais le Protecteur, l'Esprit Saint que le Père vous enverra grâce à mon Nom, se chargera de vous enseigner toutes choses: il vous rappellera tout ce que je vous ai dit."
,"27":"Je vous laisse la paix, je vous donne ma paix. Je ne vous la donne pas comme le monde la donne. Ne restez pas dans le trouble et dans la crainte."
,"28":"Vous avez appris ce que je vous ai dit, que je m'en vais et je reviens vers vous. Si vous m'aimiez, vous vous réjouiriez de ce que je vais vers le Père, car le Père est plus grand que moi."
,"29":"Et maintenant je vous l'ai dit avant que cela n'arrive, pour que, quand cela arrivera, vous croyiez."
,"30":"Je ne vous parlerai plus beaucoup désormais: déjà s'approche celui qui gouverne le monde, mais en moi il n'y a rien qui soit à lui"
,"31":"Tout au contraire, et le monde doit le savoir, j'aime le Père et je fais comme le Père me l'a ordonné. Levez-vous, allons."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Je suis la vraie vigne et mon Père est le vigneron."
,"2":"Quand une branche, en moi, ne porte pas de fruit, il l'enlève; quand une branche donne du fruit, il la taille et la nettoie pour qu'elle en porte davantage."
,"3":"Le message que je vous ai donné vous a déjà purifiés,"
,"4":"mais demeurez en moi, et moi en vous. Une branche ne pourra pas donner de fruits par elle-même si elle ne reste pas sur la vigne; ce sera pareil pour vous si vous ne restez pas en moi."
,"5":"Je suis la vigne et vous êtes les branches. Sans moi vous ne pouvez rien faire, mais celui qui demeure en moi et moi en lui, porte beaucoup de fruits."
,"6":"Si quelqu'un ne demeure pas en moi, il est jeté dehors comme les branches, et tout se dessèche; on les met en tas, on les jette au feu et elles brûlent."
,"7":"Mais tant que vous demeurez en moi et que mes paroles demeurent en vous, demandez ce que vous voulez et vous l'obtiendrez."
,"8":"C'est ainsi que mon Père est glorifié, quand vous portez beaucoup de fruits; et alors vous devenez mes disciples."
,"9":"Comme le Père m'a aimé, moi aussi je vous ai aimés: demeurez en mon amour."
,"10":"Si vous gardez mes commandements, vous demeurerez en mon amour, tout comme j'ai gardé les commandements de mon Père et je demeure en son amour."
,"11":"Je vous dis tout cela pour que ma joie soit en vous, et que votre joie soit entière."
,"12":"Voici mon commandement: Aimez-vous les uns les autres comme je vous ai aimés."
,"13":"Il ne peut pas y avoir de plus grand amour que de donner sa vie pour ses amis,"
,"14":"et vous, vous êtes mes amis si vous faites ce que je vous commande."
,"15":"Aussi, je ne vous appelle plus des serviteurs, car le serviteur ne sait pas ce que fait son maître; je vous traite d'amis parce que je vous ai fait connaître tout ce que j'ai appris de mon Père."
,"16":"Ce n'est pas vous qui m'avez choisi, mais je vous ai choisis et je vous ai donné mission pour que vous alliez et que vous portiez du fruit, et que ce fruit demeure. C'est ainsi que le Père vous donnera tout ce que vous demanderez en mon nom."
,"17":"Aimez-vous les uns les autres, c'est là mon commandement."
,"18":"Si le monde vous déteste, pensez qu'il m'a détesté avant vous."
,"19":"Si vous étiez du monde, le monde reconnaîtrait les siens et les aimerait. Mais vous n'êtes pas du monde, et le monde vous déteste parce que je vous en ai tirés."
,"20":"Rappelez-vous ce que je vous ai dit: le serviteur n'est pas au-dessus de son maître. Si l'on m'a persécuté, on vous persécutera de même. A-t-on accueilli ma parole? Alors, va-t-on accueillir la vôtre?"
,"21":"Tout ce qu'ils feront contre vous, ce sera à cause de mon nom, parce qu'ils ne connaissent pas celui qui m'a envoyé."
,"22":"Si je n'étais pas venu pour leur parler, ils n'auraient pas de péché. Mais maintenant ils n'ont plus d'excuses pour leurs péchés."
,"23":"Celui qui me déteste, déteste aussi mon Père."
,"24":"Si je n'avais pas fait parmi eux des oeuvres que personne d'autre n'a faites, ils n'auraient pas de péché. Mais maintenant ils ont vu, et ils m'ont détesté aussi bien que mon Père."
,"25":"Il fallait que s'accomplisse cette parole qu'on lit dans leur Loi: ils m'ont détesté sans raison."
,"26":"Mais je vais vous envoyer d'auprès du Père le Protecteur, et quand il sera là, l'Esprit de Vérité qui vient du Père, il me rendra témoignage."
,"27":"Et vous aussi, vous me rendrez témoignage, car vous êtes avec moi depuis le commencement."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Je vous ai dit tout cela pour que vous ne soyez pas déconcertés."
,"2":"Ils vous expulseront de leurs communautés. Bien plus, l'heure vient où l'on pensera qu'il suffit de vous tuer pour rendre hommage à Dieu."
,"3":"Ils agiront ainsi parce qu'ils ne connaissent, ni le Père, ni moi."
,"4":"Je vous ai dit tout cela pour qu'une fois l'heure venue, vous vous souveniez que je vous l'avais dit. Au début, j'étais avec vous, et c'est pourquoi je ne vous en parlais pas."
,"5":"Mais maintenant je m'en vais chez celui qui m'a envoyé, et aucun de vous ne me demande où je vais."
,"6":"Votre coeur s'est rempli de tristesse en entendant ce que je vous ai dit."
,"7":"Pourtant je vous dis la vérité: il est bon pour vous que je m'en aille, car si je ne m'en vais pas, le Protecteur ne viendra pas. Et si je pars, c'est pour vous l'envoyer."
,"8":"Quand il viendra, il rétablira la vérité face au monde en matière de péché, de justice et de jugement."
,"9":"Où est le péché? Ils ne croient pas en moi."
,"10":"Où est la justice? Mais je m'en vais vers le Père tandis que vous ne me voyez plus!"
,"11":"Quel jugement? Celui du gouverneur de ce monde: il est déjà condamné."
,"12":"J'ai beaucoup de choses à vous dire encore, mais vous ne pouvez pas les comprendre maintenant."
,"13":"Quand il viendra, lui, l'Esprit de Vérité, il vous conduira sur le chemin de toute vérité. Il n'a rien à dire de lui-même, mais il dira ce qu'il aura entendu et vous annoncera les choses à venir."
,"14":"Il vous annoncera ce qu'il aura reçu de moi, et grâce à lui je serai glorifié."
,"15":"Tout ce qui est au Père est à moi: c'est pourquoi je viens de dire qu'il vous fera savoir des choses prises chez moi."
,"16":"Encore un peu de temps et vous ne me verrez plus, puis encore un peu de temps et vous me verrez.'"
,"17":"Plusieurs des disciples se demandaient: 'Que nous dit-il là? Un peu de temps et vous ne me verrez plus, puis encore un peu de temps et vous me verrez. Et aussi: Je vais vers le Père."
,"18":"Qu'est-ce que ce: un peu de temps? Nous ne savons pas ce qu'il veut dire.'"
,"19":"Jésus vit qu'ils voulaient le lui demander, et il leur dit: 'Vous vous interrogez parce que j'ai dit: un peu de temps et vous ne me verrez plus, et un peu de temps encore et vous me verrez."
,"20":"En vérité, en vérité, je vous dis que vous serez dans le deuil et les larmes pendant que le monde se réjouira. Vous serez dans la tristesse, mais votre tristesse deviendra joie."
,"21":"Quand une femme est sur le point de mettre au monde, elle est dans la tristesse car le moment de ses douleurs approche. Mais quand l'enfant est né, sa joie est telle qu'elle ne se rappelle plus son angoisse: pensez donc, un nouvel être est apparu dans le monde!"
,"22":"Vous aussi, vous voilà dans la tristesse, mais je vous verrai de nouveau et votre coeur sera dans la joie; et votre joie, personne ne vous l'enlèvera."
,"23":"Ce jour-là vous ne me demanderez plus rien car, je vous le dis et c'est vrai, tout ce que vous demanderez au Père en mon Nom, il vous le donnera."
,"24":"Jusqu'ici vous n'avez rien demandé en mon Nom: mais demandez et vous recevrez, et votre joie sera entière."
,"25":"Je vous ai dit tout cela avec des comparaisons. Mais l'heure vient où je ne donnerai plus des comparaisons, mais je vous parlerai clairement du Père."
,"26":"Ce jour-là vous demanderez en mon Nom. Mais ne pensez pas que je devrai intervenir auprès du Père en votre faveur:"
,"27":"car le Père lui-même vous aime puisque vous m'aimez et vous croyez que je suis sorti de Dieu."
,"28":"Je suis sorti du Père et je suis venu dans le monde: mais maintenant je quitte le monde et je vais vers le Père.'"
,"29":"A ce moment les disciples disent: 'Tout de suite tu parles clairement, ce ne sont plus des comparaisons."
,"30":"Maintenant nous savons que tu sais tout et qu'il n'y a pas de questions à te poser. Car tu es sorti de Dieu; cela, nous le croyons!"
,"31":"Jésus alors leur répond: 'Vous dites que vous croyez?"
,"32":"Pourtant l'heure est proche, et elle est déjà là, où vous allez vous disperser chacun de son côté et vous me laisserez seul. Mais je ne suis pas seul, car le Père est avec moi."
,"33":"Je vous ai parlé ainsi pour que vous ayez la paix en moi, car, dans le monde, vous connaîtrez la persécution. Mais courage: j'ai vaincu le monde!'"
}`)
	CurrentBook.AddChapter(17, `{
"1":"Telles furent les paroles de Jésus. Ensuite il leva les yeux vers le ciel et dit: 'Père, l'heure est arrivée: glorifie ton Fils pour que le Fils te glorifie!"
,"2":"Tu lui as donné autorité sur tout être mortel et tu veux qu'il donne la vie éternelle à tout ce que tu lui as donné."
,"3":"Et la vie éternelle, c'est qu'ils te connaissent, toi, le Dieu Unique et Vrai, et celui que tu as envoyé, Jésus, le Christ."
,"4":"Je t'ai glorifié sur la terre, j'ai achevé l'oeuvre que tu m'avais donnée à faire."
,"5":"Et maintenant, Père, glorifie-moi auprès de toi, donne-moi cette gloire que j'avais auprès de toi dès avant que le monde existe."
,"6":"J'ai fait connaître aux hommes ton Nom. Je parle de ceux que tu as pris dans le monde pour me les donner. Ils étaient à toi et tu me les as donnés, et ils ont gardé ta parole."
,"7":"Maintenant ils savent que tout ce que tu m'as donné vient vraiment de toi."
,"8":"Je leur ai donné le message que tu m'as donné: ils l'ont reçu et ils ont su que je suis réellement sorti de toi, et ils ont cru que tu m'as envoyé."
,"9":"C'est pour eux que je prie; je ne prie pas pour le monde, mais pour ceux qui sont à toi et que tu m'as donnés,"
,"10":"car tout ce que j'ai t'appartient et tout ce qui est à toi m'appartient. Je suis glorifié à travers eux."
,"11":"Je ne suis plus dans le monde, mais eux restent dans le monde alors que moi je retourne vers toi. Père Saint, garde-les en ton Nom, celui-là même que tu m'as donné, pour qu'ils soient un comme nous."
,"12":"Quand j'étais avec eux, je les gardais en ton Nom, car tu me l'as donné. J'en ai pris soin, et aucun d'eux ne s'est perdu, sinon celui qui était déjà perdu: en cela aussi l'Ecriture devait se vérifier."
,"13":"Mais maintenant je dis cela dans le monde avant d'aller vers toi, pour que ma joie soit tout entière en eux."
,"14":"Je leur ai donné ta Parole et le monde les a détestés, car ils ne sont pas du monde, comme moi-même je ne suis pas du monde."
,"15":"Je ne te demande pas de les enlever du monde mais de les garder du Mauvais."
,"16":"Ils ne sont pas du monde, comme moi-même je ne suis pas du monde."
,"17":"Rends-les saints grâce à la Vérité: ta Parole est Vérité."
,"18":"Comme tu m'as envoyé dans le monde, moi aussi je les envoie dans le monde,"
,"19":"et maintenant je me consacre pour eux, de façon qu'eux aussi soient consacrés dans la Vérité."
,"20":"Je ne prie pas seulement pour eux mais pour ceux qui croiront en moi grâce à leur parole."
,"21":"Qu'ils soient tous Un, comme toi, Père, tu es en moi et moi en toi. Qu'ils soient eux aussi en nous, pour que le monde croie que tu m'as envoyé."
,"22":"Je leur ai donné la Gloire que tu m'as donnée, pour qu'ils soient Un comme nous sommes Un:"
,"23":"moi en eux, et toi en moi: ainsi ils atteindront l'unité parfaite, et le monde connaîtra que tu m'as envoyé et que tu les as aimés comme tu m'as aimé."
,"24":"Père, si tu me les a donnés, je veux qu'ils soient avec moi là où je suis: je veux qu'ils voient ma Gloire, que déjà tu me donnes parce que tu m'as aimé dès avant la fondation du monde."
,"25":"Père juste, le monde ne t'a pas connu, mais moi je t'ai connu, et ceux-ci ont reconnu que tu m'as envoyé."
,"26":"Je leur ai fait connaître ton Nom, et je le ferai encore, pour que l'amour que tu as pour moi soit en eux, et que je sois moi aussi en eux.'"
}`)
	CurrentBook.AddChapter(18, `{
"1":"Après avoir dit cela, Jésus sortit avec ses disciples et traversa le torrent du Cédron. Il y avait là un jardin où il entra avec ses disciples."
,"2":"Judas qui le trahissait connaissait ce lieu, parce que Jésus s'était souvent retrouvé là avec ses disciples."
,"3":"Judas prit donc avec lui des soldats de la garnison et des gardes fournis par les grands prêtres et les Pharisiens, et il arrive avec des torches, des lampes et des armes."
,"4":"Jésus savait tout ce qui allait lui arriver. Il s'avança et leur dit: 'Qui cherchez-vous?'"
,"5":"Ils lui répondirent: 'Jésus le Nazôréen.' Il leur dit: 'C'est moi.' Judas, le traître, se tenait là aussi avec eux."
,"6":"A cette parole de Jésus: 'C'est moi', ils reculèrent et tombèrent à terre."
,"7":"Jésus leur demanda de nouveau: 'Qui cherchez-vous?' Ils répondirent: 'Jésus le Nazôréen.'"
,"8":"Jésus leur dit: 'Je vous l'ai déjà dit: c'est moi. Si c'est moi que vous cherchez, laissez ceux-là s'en aller.'"
,"9":"Ainsi devait s'accomplir la parole que Jésus avait dite: 'Je n'ai laissé perdre aucun de ceux que tu m'as donnés.'"
,"10":"Simon-Pierre avait une épée, il la tira pour frapper le serviteur du Grand Prêtre et lui coupa l'oreille droite. Ce serviteur s'appelait Malkus."
,"11":"Alors Jésus dit à Pierre: 'Remets l'épée au fourreau. Est-ce que je peux ne pas boire la coupe que mon Père m'a donnée?'"
,"12":"Les soldats de la garnison et leur commandant, avec les policiers des Juifs, se saisirent alors de Jésus et le lièrent avec des cordes."
,"13":"Ils le conduisirent d'abord chez Anne, le beau-père de Caïphe qui était Grand Prêtre cette année-là."
,"14":"Et c'était Caïphe qui avait donné aux Juifs cet argument: 'Il vaut mieux qu'un homme meure à la place du peuple.'"
,"15":"Simon-Pierre et un autre disciple suivaient Jésus. Comme ce disciple était connu du Grand Prêtre, il entra avec Jésus dans la cour du Grand Prêtre,"
,"16":"et Pierre restait dehors à la porte. Mais l'autre disciple connu du Grand Prêtre, ressortit et dit un mot à la gardienne, et il fit entrer Pierre."
,"17":"Alors cette jeune servante qui gardait la porte dit à Pierre: 'Toi aussi tu es un des disciples de cet homme?' Mais lui répondit: 'Je n'en suis pas!'"
,"18":"Les serviteurs et les gardes étaient là. Ils avaient fait du feu pour se chauffer car il faisait froid, et Pierre était là à se chauffer avec eux."
,"19":"Pendant ce temps le Grand Prêtre interrogeait Jésus sur ses disciples et sur son enseignement."
,"20":"Jésus lui répondit: 'J'ai parlé ouvertement au monde; j'ai constamment enseigné dans la synagogue et dans le Temple, là où les Juifs se réunissent, et je n'ai rien dit en secret."
,"21":"Pourquoi m'interroges-tu? Demande à ceux qui m'ont écouté ce que je leur ai dit.'"
,"22":"A ce moment, un des gardes qui étaient là donna un coup à Jésus, en lui disant: 'C'est ainsi que tu réponds au Grand Prêtre?'"
,"23":"Jésus lui répondit: 'Si j'ai mal parlé, montre où est le mal; mais si j'ai bien parlé, pourquoi me frappes-tu?'"
,"24":"Finalement, Anne envoya Jésus chez Caïphe; on l'avait lié."
,"25":"Simon-Pierre était toujours là à se chauffer. On lui dit: 'Bien sûr, toi aussi tu fais partie de ses disciples.' Mais il le nia et il répondit: 'Je n'en suis pas.'"
,"26":"Un des serviteurs du Grand Prêtre, un parent de celui à qui Pierre avait coupé l'oreille, affirma alors: 'Mais oui, je t'ai vu avec lui dans le jardin!'"
,"27":"De nouveau Pierre nia et, aussitôt après, le coq chanta."
,"28":"On emmena donc Jésus de chez Caïphe au palais du gouverneur romain. C'était le matin. Les Juifs n'entrèrent pas car ce lieu les aurait souillés, et ils voulaient pouvoir manger la Pâque."
,"29":"Pilate sortit donc vers eux à l'extérieur et leur demanda: 'De quoi accusez-vous cet homme?'"
,"30":"Ils lui répondirent: 'S'il ne faisait rien de mal, nous ne serions pas venus te l'amener.'"
,"31":"Pilate leur dit: 'Gardez-le donc, et jugez-le selon votre loi.' Les Juifs lui dirent: 'Mais nous n'avons pas le droit de condamner quelqu'un à mort.'"
,"32":"C'est ainsi que devait se réaliser la parole de Jésus à propos du genre de supplice où il allait mourir."
,"33":"Pilate rentre donc dans le palais. Il fait appeler Jésus et lui demande: 'C'est toi le roi des Juifs?'"
,"34":"Jésus répond: 'Ce que tu me dis là, est-ce que tu le penses, ou est-ce que d'autres te l'ont dit de moi?'"
,"35":"Pilate dit alors: 'Est-ce que je suis Juif, par hasard? C'est ton peuple, ce sont les chefs des prêtres qui t'amènent devant moi. Qu'as-tu fait?'"
,"36":"Jésus répond: 'Ma royauté n'est pas de ce monde. Si ma royauté était de ce monde, mes gens auraient combattu pour que je ne sois pas livré aux Juifs. Mais non, ma royauté n'est pas d'ici-bas.'"
,"37":"Alors Pilate lui dit: 'Donc, tout de même, tu es roi?' Jésus répond: 'Tu dis bien: je suis roi. Je rends témoignage à la vérité, c'est pour cela que je suis né et que je suis venu dans le monde. Tous ceux qui sont pour la vérité écoutent ma voix.'"
,"38":"Alors Pilate lui dit: 'Où est la vérité?' Il sortit de nouveau vers les Juifs et leur dit: 'Je ne trouve rien à condamner chez cet homme."
,"39":"D'ailleurs c'est une coutume chez vous que je vous relâche un prisonnier pour la fête de la Pâque. Si vous le voulez, je vais relâcher le roi des Juifs.'"
,"40":"Mais de nouveau ce furent des cris: 'Pas celui-ci! Relâche Barabbas!',Ce Barabbas était un bandit."
}`)
	CurrentBook.AddChapter(19, `{
"1":"C'est alors que Pilate ordonne de prendre Jésus et de le flageller."
,"2":"Les soldats tressent une couronne avec des épines et la lui mettent sur la tête; ensuite ils lui jettent sur les épaules un manteau rouge, couleur royale,"
,"3":"et ils commencent à se présenter devant lui en disant: 'Salut, roi des Juifs!' Et ils lui donnent des gifles."
,"4":"Pilate sortit de nouveau pour dire aux Juifs: 'Je vais vous l'amener dehors, mais sachez bien que je ne trouve rien à condamner chez lui.'"
,"5":"Jésus sortit donc à l'extérieur avec la couronne d'épines et le manteau de pourpre, et Pilate leur dit: 'Voici l'homme!'"
,"6":"Mais dès qu'ils le voient, les chefs des prêtres se mettent à crier avec leurs policiers: 'Mets-le en croix! Mets-le en croix!' Pilate leur dit: 'Prenez-le vous-mêmes et mettez-le en croix, car moi, je ne lui trouve rien à condamner.'"
,"7":"Les Juifs lui répondent: 'Nous avons une Loi, et d'après la Loi il doit mourir, car il s'est proclamé Fils de Dieu.'"
,"8":"Lorsque Pilate entend cela, ses craintes augmentent."
,"9":"Il rentre dans le palais et dit à Jésus: 'D'où es-tu?' Mais Jésus ne lui répond pas."
,"10":"Pilate lui dit alors: 'Tu ne veux pas me parler? Ne sais-tu pas que je peux te relâcher et que je peux aussi te faire mettre en croix?'"
,"11":"Jésus lui répond: 'Tu n'aurais aucun pouvoir sur moi si tu ne l'avais pas reçu d'en haut. Pour la même raison, celui qui m'a livré entre tes mains porte un plus grand péché que toi.'"
,"12":"Dès ce moment Pilate cherchait à relâcher Jésus, mais les Juifs criaient: 'Si tu le relâches, tu n'es pas l'ami du César. Ceux qui se proclament roi se rebellent contre le César.'"
,"13":"Quand Pilate entendit ces paroles, il leur amena Jésus dehors et le fit asseoir au tribunal à cet endroit qu'on appelle Lithostrotos (en hébreu on dit Gabbatha)."
,"14":"C'était le jour de la Préparation de la Pâque et il était environ midi. Pilate dit aux Juifs: 'Voici votre roi.'"
,"15":"Mais eux criaient: 'A mort! A mort! Crucifie-le!' Pilate leur dit: 'C'est votre roi que je dois mettre en croix?' Et les chefs des prêtres répondirent: 'Nous n'avons pas d'autre roi que le César!'"
,"16":"Alors Pilate leur livra Jésus pour être crucifié. On emmena Jésus, "
,"17":"et lui-même portait sa croix; il sortit et gagna l'endroit qu'on appelle le Crâne (en hébreu cela se dit Golgotha)."
,"18":"Là on le mit en croix, et avec lui deux autres, un de chaque côté: Jésus était au milieu."
,"19":"Pilate avait fait écrire la sentence et elle était affichée sur la croix. Il était écrit: Jésus le Nazôréen, le roi des Juifs."
,"20":"Beaucoup de Juifs lurent cet écriteau car l'endroit où Jésus avait été crucifié était tout proche de la ville. Et c'était écrit en hébreu, en latin et en grec."
,"21":"Les chefs des prêtres des Juifs protestèrent auprès de Pilate: 'N'écris pas: Le roi des Juifs. Mets: Il a dit qu'il était le roi des Juifs.'"
,"22":"Pilate leur répondit: 'Ce que j'ai écrit, est écrit.'"
,"23":"Quand les soldats mirent Jésus en croix, ils prirent ses vêtements et en firent quatre parts, une pour chaque soldat. Il y avait aussi la tunique; elle était sans couture, tissée d'une pièce de haut en bas."
,"24":"Ils se dirent donc entre eux: 'Ne la déchirons pas: tirons-la au sort.' Ainsi devait s'accomplir l'Ecriture; il y est dit en effet: Ils se sont partagé mes vêtements; ils ont tiré au sort ma tunique. C'est bien ce que firent les soldats."
,"25":"Debout près de la croix de Jésus, se tenaient sa mère et la soeur de sa mère, Marie femme de Cléophas, et Marie de Magdala."
,"26":"Jésus vit la Mère et auprès d'elle le disciple qu'il aimait. Il dit à la Mère: 'Femme, voici ton fils.'"
,"27":"Ensuite il dit au disciple: 'Voici ta mère.' Et à partir de ce moment le disciple la reçut chez lui."
,"28":"Avec cela, Jésus voyait que tout était accompli. Mais une parole de l'Ecriture devait encore s'accomplir. Jésus dit: J'ai soif."
,"29":"Il y avait là un vase plein de vin fermenté et quelqu'un y plongea une éponge, la mit au bout d'une branche d'hysope et la porta à sa bouche."
,"30":"Jésus prit ce vin fermenté et alors il dit: 'Tout est accompli.' Il inclina la tête et il remit l'esprit."
,"31":"Les Juifs ne voulaient pas que les corps des condamnés restent en croix durant le sabbat, d'autant plus que c'était la Préparation de la Pâque et ce sabbat était particulièrement important. Aussi les Juifs demandèrent-ils à Pilate de leur faire briser les jambes et de les enlever."
,"32":"Les soldats s'approchèrent donc de ceux qui étaient en croix avec Jésus et brisèrent les jambes au premier puis à l'autre."
,"33":"Arrivés auprès de Jésus, ils virent qu'il était déjà mort et ils ne lui brisèrent pas les jambes."
,"34":"Seulement l'un des soldats lui enfonça sa lance dans le côté et il en sortit du sang et de l'eau."
,"35":"Celui qui l'a vu donne ici son témoignage pour que vous croyiez: son témoignage est vrai et Lui sait qu'il dit vrai."
,"36":"Ainsi s'accomplissait une parole de l'Ecriture: Pas un de ses os ne sera brisé."
,"37":"Et l'Ecriture dit encore: Ils verront celui qu'ils ont transpercé."
,"38":"Après cela, Joseph d'Arimathie intervint auprès de Pilate. Il était disciple de Jésus, mais il ne le disait pas par crainte des Juifs. Il demanda de pouvoir retirer le corps de Jésus et Pilate le lui accorda. Il vint donc pour retirer le corps."
,"39":"Nicodème vint aussi, celui qui au début avait rencontré Jésus de nuit; il amenait près de cent livres d'huile, de myrrhe et d'aloès."
,"40":"Ils prirent le corps de Jésus et l'enveloppèrent de bandes par-dessus les huiles parfumées, comme c'est la coutume chez les Juifs pour ensevelir."
,"41":"A côté de l'endroit où l'on avait mis Jésus en croix, il y avait un jardin, et dans ce jardin un tombeau neuf où personne encore n'avait été mis."
,"42":"Comme la fête juive de la Préparation était sur le point de commencer, et que ce tombeau était juste à côté, Jésus y fut déposé."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Le premier jour de la semaine, Marie de Magdala vient à la tombe très tôt le matin, quand il fait encore noir, et elle voit que la pierre a été retirée du tombeau."
,"2":"Alors elle part en courant et arrive chez Simon-Pierre et l'autre disciple que Jésus aimait. Et elle leur dit: 'Le Seigneur a été enlevé de la tombe et nous ne savons pas où on l'a mis.'"
,"3":"Pierre sort aussitôt avec l'autre disciple, et ils vont à la tombe."
,"4":"Ils courent tous les deux, et l'autre disciple, qui court plus vite, arrive avant Pierre à la tombe."
,"5":"Là il se penche et voit les linges tombés à plat, mais il n'entre pas."
,"6":"Pierre arrive alors derrière lui et pénètre dans la tombe; lui aussi voit les linges posés à plat."
,"7":"Le suaire qui enveloppait la tête n'est pas posé avec les linges, mais à part: il est roulé à un autre endroit."
,"8":"Alors entre l'autre disciple, celui qui est arrivé le premier à la tombe; il voit et il croit."
,"9":"C'est qu'ils n'avaient pas encore compris l'Ecriture: 'il fallait' qu'il ressuscite d'entre les morts!"
,"10":"Après cela les disciples rentrent chez eux."
,"11":"Marie était restée dehors, près de la tombe, et elle pleurait. Mais voici qu'au milieu de ses larmes elle se penche vers la tombe,"
,"12":"et elle voit deux anges en blanc assis là même où on avait mis le corps de Jésus, l'un à la tête et l'autre aux pieds."
,"13":"Ils lui disent: 'Femme, pourquoi pleures-tu?' Elle leur répond: 'C'est qu'on a enlevé mon Seigneur et je ne sais pas où on l'a mis.'"
,"14":"Aussitôt qu'elle a dit cela, elle se retourne et voit derrière elle Jésus debout. Mais elle ne sait pas que c'est Jésus."
,"15":"Jésus lui dit: 'Femme, pourquoi pleures-tu? Qui cherches-tu?' Elle croit que c'est le jardinier, et elle lui répond: 'Seigneur, si c'est toi qui l'as enlevé, dis-moi où tu l'as déposé, que j'aille le prendre.'"
,"16":"Jésus lui dit: 'Marie!' Et elle se retourne et lui dit en hébreu: 'Rabbouni!' C'est-à-dire: Maître!"
,"17":"Jésus lui dit: 'Ne me retiens pas! Je ne suis pas encore remonté vers le Père. Va donc vers mes frères et dis-leur: Je monte vers mon Père qui est votre Père, vers mon Dieu qui est votre Dieu.'"
,"18":"C'est ainsi que Marie de Magdala s'en va porter la nouvelle aux disciples: 'J'ai vu le Seigneur, et voici ce qu'il m'a dit.'"
,"19":"Au soir de ce premier jour de la semaine, les portes étaient fermées par peur des Juifs là où les disciples étaient réunis. Jésus vint et se tint au milieu d'eux. Il leur dit: 'Soyez en paix!'"
,"20":"Ayant dit cela, il leur montra ses mains et son côté, et ce fut la joie pour les disciples qui voyaient le Seigneur."
,"21":"Et puis il leur dit de nouveau: 'Soyez en paix! Comme le Père m'a envoyé, moi aussi je vous envoie.'"
,"22":"Ayant dit cela, Jésus souffla vers eux et leur dit: 'Recevez l'Esprit Saint."
,"23":"Ceux à qui vous enlèverez les péchés, ils leur seront enlevés; quand vous les maintiendrez, ils seront maintenus.'"
,"24":"L'un des Douze était Thomas, surnommé le Jumeau; il n'était pas avec eux pour cette venue de Jésus."
,"25":"Comme les autres lui disaient: 'Nous avons vu le Seigneur', il leur répondit: 'Tant que je ne vois pas ses mains avec la marque des clous et que je ne mets pas le doigt dans la marque des clous; tant que je ne mets pas la main dans son côté, je ne crois pas.'"
,"26":"Et voilà que de nouveau, huit jours plus tard, les disciples étaient à l'intérieur et Thomas avec eux. Alors que les portes étaient fermées, Jésus vint et se tint au milieu. Il dit: 'Soyez en paix.'"
,"27":"Ensuite il dit à Thomas: 'Mets ici ton doigt, regarde mes mains. Avance ta main et mets-la dans mon côté. Cesse de nier, et crois!'"
,"28":"Pour toute réponse Thomas lui dit: 'Tu es mon Seigneur et mon Dieu!'"
,"29":"Et Jésus lui dit: 'Tu m'as vu et tu crois. Heureux ceux qui n'ont pas vu et qui croient.'"
,"30":"Jésus a fait devant ses disciples bien d'autres signes miraculeux qui ne sont pas écrits dans ce livre."
,"31":"Ceux-ci ont été écrits pour que vous croyiez que Jésus est le Christ, le Fils de Dieu; et si vous croyez, vous aurez la vie par l'effet de son Nom."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Après cela Jésus se manifesta encore à ses disciples à la Mer de Tibériade. Voici comment il se manifesta."
,"2":"Simon-Pierre, Thomas surnommé le Jumeau, Nathanaël de Cana en Galilée, et les fils de Zébédée étaient là ensemble avec deux autres disciples de Jésus."
,"3":"Simon-Pierre leur dit: 'Je vais pêcher'; et eux lui disent: 'Nous y allons aussi avec toi.',Ils sortirent et montèrent dans la barque, mais cette nuit-là ils ne prirent rien. "
,"4":"Lorsque déjà le jour se levait, Jésus se tint là sur le rivage, mais les disciples ne savaient pas que c'était Jésus."
,"5":"Jésus les appelle: 'Dites donc, les enfants, avez-vous quelque chose à manger?' Ils lui répondent: 'Rien.'"
,"6":"Alors il leur dit: 'Jetez le filet sur la droite de la barque, vous allez trouver.' Donc, ils le jettent, mais ils n'arrivent pas à le ramener tellement il est plein de poissons."
,"7":"Alors le disciple que Jésus aimait dit à Pierre: 'C'est le Seigneur.',Quand Simon-Pierre l'entend dire que c'est le Seigneur, il remet son vêtement, car il est sans rien, et il se jette à l'eau. "
,"8":"Les autres disciples arrivent avec la barque; de fait, ils ne sont pas loin du bord, une centaine de mètres, et ils traînent le filet avec les poissons."
,"9":"Quand ils sont descendus à terre, ils voient un feu de braises préparé avec du poisson dessus et du pain."
,"10":"Jésus leur dit: 'Donnez-nous donc des poissons que vous avez pris.'"
,"11":"Simon-Pierre monte dans la barque et amène le filet sur le rivage. Il était plein de gros poissons, cent cinquante-trois en tout, mais avec tout ce nombre le filet ne s'était pas déchiré."
,"12":"Alors Jésus leur dit: 'Venez donc déjeuner.' Aucun des disciples n'osait lui demander: 'Qui es-tu?' Car ils savaient bien que c'était le Seigneur."
,"13":"Jésus s'avança, il prit le pain et le leur donna, et de même pour les poissons."
,"14":"C'était la troisième fois que Jésus se manifestait à ses disciples après sa résurrection d'entre les morts"
,"15":"Après le repas, Jésus dit à Simon-Pierre: 'Simon, fils de Jean, m'aimes-tu plus que ceux-ci?' Pierre lui dit: 'Oui, Seigneur, tu sais que je t'aime.' Et Jésus lui dit: 'Fais paître mes agneaux.'"
,"16":"Puis une seconde fois il lui demanda: 'Simon, fils de Jean, m'aimes-tu?' Il répondit: 'Oui, Seigneur, tu sais que je t'aime.' Alors il dit: 'Fais paître mes brebis.'"
,"17":"Pour la troisième fois il lui demanda: 'Simon, fils de Jean, m'aimes-tu bien?' Pierre devint triste parce que Jésus lui demandait pour la troisième fois: 'M'aimes-tu vraiment?' Il répondit: 'Seigneur, tu sais tout, tu sais que vraiment je t'aime.' Et lui, il dit: 'Fais paître mes brebis."
,"18":"En vérité, en vérité, je te le dis: quand tu étais plus jeune tu te mettais ta ceinture et tu allais où tu voulais. Mais quand tu seras vieux, tu étendras les bras, et un autre te mettra ta ceinture et t'emmènera où tu ne veux pas.'"
,"19":"Jésus disait cela pour faire comprendre de quelle façon Pierre devait mourir et rendre gloire à Dieu; car il disait bien: 'Suis-moi!'"
,"20":"Pierre alors se retourne et voit le disciple que Jésus aimait, celui qui était à table juste contre la poitrine de Jésus et lui avait demandé: 'Seigneur, qui va te trahir?'"
,"21":"En le voyant, Pierre dit à Jésus: 'Et lui, que devient-il?'"
,"22":"Jésus lui répond: 'Si je veux qu'il reste jusqu'à ce que je vienne, que t'importe? Toi, suis-moi!'"
,"23":"Voilà pourquoi on s'est mis à dire parmi les frères que ce disciple ne devait pas mourir. Mais Jésus n'avait pas dit: 'Il ne va pas mourir'; il avait dit seulement: 'Si je veux qu'il reste jusqu'à ce que je vienne.'"
,"24":"C'est ce même disciple qui s'est porté témoin de ces choses et les a écrites, et nous savons que son témoignage est vrai."
,"25":"Jésus a encore fait bien d'autres choses qui ne sont pas écrites dans ce livre. Si ou les racontait une par une, je crois que le monde entier serait bien petit pour les livres qu'on écrirait."
}`)

}
func FR_LBDCC_LoadNELCChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Plusieurs se sont appliqués à composer un récit des événements qui ont eu lieu parmi nous,"
,"2":"tels qu'ils nous ont été transmis par ceux qui en furent les premiers témoins et qui par la suite sont devenus serviteurs de la Parole."
,"3":"Après avoir tout étudié depuis le début et avec soin, il m'a paru bon à moi aussi, cher Théophile, de t'en faire un récit suivi."
,"4":"Ainsi tu pourras mesurer la solidité de l'enseignement que tu as reçu."
,"5":"Au temps d'Hérode, roi de Judée, vivait un prêtre du nom de Zacharie. Il était du clan d'Abias; sa femme, qui s'appelait Elisabeth, était aussi de la descendance d'Aaron."
,"6":"Tous deux étaient justes au regard de Dieu et mettaient scrupuleusement en pratique toutes les lois et toutes les ordonnances du Seigneur."
,"7":"Mais ils n'avaient pas d'enfant: Elisabeth était stérile et tous les deux étaient déjà très âgés."
,"8":"Or, pendant que Zacharie assurait avec son groupe le service de Dieu dans le Temple,"
,"9":"selon la règle établie pour les prêtres, il fut désigné par le sort pour entrer dans le sanctuaire du Seigneur et y faire brûler l'encens."
,"10":"Et quand ce fut l'heure d'offrir l'encens, toute la foule était en prière sur le parvis."
,"11":"C'est alors qu'un ange du Seigneur lui apparut debout à droite de l'autel de l'encens."
,"12":"A sa vue Zacharie se troubla et la peur l'envahit."
,"13":"Mais l'ange lui dit: 'N'aie pas peur Zacharie, voici que ta prière a été exaucée; ta femme Elisabeth va te donner un fils que tu appelleras Jean."
,"14":"Ce sera pour toi une vraie joie et beaucoup d'autres se réjouiront de sa naissance"
,"15":"car il sera un grand serviteur du Seigneur. Il ne boira ni vin ni liqueur. Dès le sein de sa mère il sera rempli de l'Esprit Saint; "
,"16":"il ramènera en grand nombre les enfants d'Israël au Seigneur leur Dieu."
,"17":"Il passera en avant du Seigneur, avec l'esprit et la puissance d'Elie, pour réconcilier les pères avec leurs enfants, et ramener les rebelles à la sagesse des justes. Il préparera ainsi pour le Seigneur un peuple bien disposé.'"
,"18":"Zacharie dit à l'ange: 'Comment puis-je croire cela? Je suis un vieillard, ma femme est très âgée!'"
,"19":"Mais l'ange lui répondit: 'J'ai été envoyé pour te parler et te l'annoncer, moi Gabriel qui ai accès au conseil de Dieu."
,"20":"Mes paroles se réaliseront au moment voulu, mais puisque toi tu n'y as pas cru, tu vas être réduit au silence; tu ne pourras plus dire un mot jusqu'au jour où tout s'accomplira.'"
,"21":"Le peuple attendait Zacharie et l'on s'étonnait qu'il s'attarde ainsi dans le sanctuaire."
,"22":"Lorsqu'il sortit, il avait perdu l'usage de la parole et l'on se douta bien qu'il avait eu une vision dans le Temple. Il essayait de se faire comprendre, mais il restait muet."
,"23":"Il arriva ainsi au terme de son temps de service et il retourna chez lui."
,"24":"Dans les jours qui suivirent, Elisabeth, sa femme, devint enceinte. Durant cinq mois elle dissimula son secret. Elle se disait:"
,"25":"'Voilà bien ce que le Seigneur a fait! Je me sentais humiliée devant tout le monde, et c'est le moment qu'il avait fixé pour me délivrer.'"
,"26":"Le sixième mois, l'ange Gabriel fut envoyé par Dieu dans une ville de Galilée appelée Nazareth,"
,"27":"auprès d'une vierge déjà promise en mariage à Joseph, un homme de la famille de David; le nom de la vierge était Marie."
,"28":"L'ange vint à elle et lui dit: 'Réjouis-toi, pleine de grâce, le Seigneur est avec toi.'"
,"29":"Marie était toute troublée de ces paroles et se demandait ce que voulait dire cette salutation."
,"30":"Mais l'ange lui dit: 'Ne crains pas, Marie! Tu as trouvé grâce auprès de Dieu."
,"31":"Tu vas être enceinte et tu mettras au monde un fils que tu appelleras du nom de Jésus."
,"32":"Il sera grand, il sera appelé Fils du Très-Haut, et c'est à lui que le Seigneur Dieu donnera le trône de David son père."
,"33":"Il règnera pour toujours sur la maison de Jacob, et son règne n'aura pas de fin.'"
,"34":"Marie dit à l'ange: 'Comment cela se fera-t-il puisque je n'ai pas de relations avec un homme?'"
,"35":"Mais l'ange lui répondit: 'L'Esprit Saint viendra sur toi, la puissance du Très-Haut te prendra sous son ombre. C'est pourquoi le saint enfant qui naîtra de toi sera appelé Fils de Dieu."
,"36":"Sache que ta cousine Elisabeth a conçu elle aussi un fils dans sa vieillesse; elle en est à son sixième mois, elle qu'on appelait 'la stérile'."
,"37":"Car rien n'est impossible à Dieu!'"
,"38":"Marie dit alors: 'Je suis la servante du Seigneur, qu'il m'arrive selon ta parole!' Et l'ange se retira d'auprès d'elle."
,"39":"En ces jours-là Marie prit sa décision et partit sans perdre de temps vers une ville de Juda dans la région montagneuse."
,"40":"Elle entra dans la maison de Zacharie et salua Elisabeth."
,"41":"Or, quand Elisabeth entendit la salutation de Marie, l'enfant tressaillit dans son ventre. Elisabeth fut remplie de l'Esprit Saint"
,"42":"et elle s'écria: 'Tu es bénie parmi les femmes et le fruit de ton ventre est béni!"
,"43":"Que m'arrive-t-il donc? La mère de mon Seigneur vient à moi!"
,"44":"Sais-tu qu'à l'instant même où ta salutation est parvenue à mes oreilles, l'enfant a tressailli de joie dans mon ventre!"
,"45":"Tu as cru, toi, en l'accomplissement de ce que le Seigneur t'a fait dire: Heureuse es-tu!'"
,"46":"Marie dit alors: 'Mon âme exalte le Seigneur,"
,"47":"mon esprit tressaille de joie en Dieu mon Sauveur!"
,"48":"Car il a regardé son humble servante,et tous les âges désormais me diront heureuse"
,"49":"Le Puissant a fait pour moi de grandes choses, Saint est son Nom!"
,"50":"Sa miséricorde s'étend d'âge en âge sur ceux qui le craignent."
,"51":"Il a fait un coup d'éclat, il a dispersé les orgueilleux et leurs projets."
,"52":"Il a renversé les puissants de leur trône, il a élevé les humbles."
,"53":"Il a comblé de biens les affamés,et renvoyé les riches les mains vides."
,"54":"Il a repris de la main Israël, son serviteur, il s'est souvenu de sa miséricorde,"
,"55":"comme il l'avait promis à nos pères, à Abraham et à sa descendance pour toujours.'"
,"56":"Marie resta trois mois auprès d'Elisabeth, puis elle retourna chez elle."
,"57":"Le temps d'accoucher arriva pour Elisabeth, et elle mit au monde un fils."
,"58":"Ses voisins et ses proches se réjouirent avec elle lorsqu'ils apprirent cette chose extraordinaire que le Seigneur avait faite pour elle dans sa miséricorde."
,"59":"Lorsqu'ils vinrent au huitième jour pour circoncire le petit enfant, ils voulurent l'appeler Zacharie du nom de son père."
,"60":"Mais sa mère déclara: 'Non! Il s'appellera Jean!'"
,"61":"Ils lui répliquèrent: 'Personne dans ta famille ne porte ce nom.'"
,"62":"Alors ils demandèrent par signes à son père quel nom il voulait lui donner."
,"63":"Il se fit donner une tablette et écrivit ceci: 'Son nom est Jean.' Ce fut une surprise pour tous."
,"64":"C'est alors que sa bouche s'ouvrit et que sa langue put articuler. Il se mit à parler, bénissant Dieu."
,"65":"Cette affaire impressionna fortement le voisinage et, dans toute la région montagneuse de Judée on commentait ces événements."
,"66":"Tous ceux qui en entendaient parler les gardaient dans leur coeur et disaient: 'Que sera donc cet enfant?' Il était clair que la main du Seigneur était avec lui."
,"67":"Zacharie, son père, fut alors rempli de l'Esprit Saint, il dit de façon prophétique:"
,"68":"'Béni soit le Seigneur, le Dieu d'Israël, car il a visité et délivré son peuple."
,"69":"Voici que pour nous se lève en force le salut,dans la maison de David son serviteur."
,"70":"Comme il l'avait dit dès les temps anciens, par la bouche de ses saints prophètes; "
,"71":"il nous sauverait de nos ennemis, de la main de ceux qui nous haïssent,"
,"72":"il montrerait de quel coeur il aimait nos pères, et comment il se souvenait de son alliance sainte."
,"73":"Comme il l'avait juré à notre père Abraham,"
,"74":"il nous a libérés des mains ennemies"
,"75":"et nous a donné de le servir sans crainte,dans la sainteté et la justice, sous son regard, tout au long de nos jours."
,"76":"Et toi, petit enfant, tu seras appelé prophète du Très-Haut, toi qui passeras en avant du Seigneur,pour préparer ses chemins,"
,"77":"pour dire à son peuple ce que sera le salut: ils recevront le pardon de leurs péchés,"
,"78":"fruit de la miséricorde de notre Dieu. Elle fera qu'il nous visite d'en-haut, tel un Soleil levant,"
,"79":"pour illuminer ceux qui sont dans les ténèbres,et demeurent dans les ombres de mort, pour conduire nos pas sur un chemin de paix.'"
,"80":"L'enfant grandissait, et il lui venait la force de l'Esprit. Il vécut dans des lieux retirés jusqu'au jour où il se manifesta à Israël."
}`)
	CurrentBook.AddChapter(2, `{
"1":"En ces jours-là un édit de César Auguste ordonna de recenser toute la terre."
,"2":"Ce fut le premier recensement, alors que Quirinius était gouverneur de la Syrie."
,"3":"Tous commencèrent à se déplacer, chacun vers sa propre ville, pour y être recensés."
,"4":"Joseph aussi, qui était en Galilée dans la ville de Nazareth, monta en Judée jusqu'à la ville de David dont le nom est Bethléem, car il était de la descendance de David."
,"5":"Il alla se faire recenser avec Marie, son épouse, qui était enceinte."
,"6":"Or, pendant qu'ils étaient là, le jour où elle devait accoucher arriva."
,"7":"Elle enfanta son fils, le premier-né; elle l'emmaillota et l'installa dans une mangeoire, car il n'y avait pas de place pour eux dans la salle commune."
,"8":"Il y avait dans la région des bergers qui restaient aux champs et se relayaient pour garder leurs troupeaux durant la nuit."
,"9":"Un ange du Seigneur se trouva soudain devant eux, en même temps que la Gloire du Seigneur resplendissait tout autour. Ils furent saisis d'une grande crainte."
,"10":"L'ange leur dit: 'Ne craignez pas, c'est une bonne nouvelle que je vous apporte, et qui fera la joie de tout le peuple."
,"11":"Aujourd'hui, dans la ville de David vous est né un Sauveur. C'est le Messie, le Seigneur."
,"12":"Et voici son signalement: vous trouverez un nourrisson emmailloté et déposé dans une mangeoire.'"
,"13":"Tout à coup se joignit à l'ange une multitude d'esprits célestes qui louaient Dieu en disant:"
,"14":"'Gloire à Dieu dans les cieux, et sur la terre paix aux hommes, car il les prend en grâce.'"
,"15":"Lorsque les anges furent repartis vers le ciel, les bergers se dirent l'un à l'autre: 'Allons donc jusqu'à Bethléem, voyons ce qui vient d'arriver et que le Seigneur nous a fait connaître.'"
,"16":"Ils y allèrent sans perdre un instant et trouvèrent Marie et Joseph ainsi que le petit enfant déposé dans la mangeoire."
,"17":"Alors ils firent connaître ce qui leur avait été dit à propos de cet enfant."
,"18":"Tous ceux qui en entendirent parler restèrent fort surpris de ce que racontaient les bergers."
,"19":"Quant à Marie, elle gardait le souvenir de ces événements et les reprenait dans sa méditation."
,"20":"Les bergers repartirent; ils ne faisaient que remercier et chanter les louanges de Dieu pour tout ce qu'ils avaient entendu et vu, tel qu'on le leur avait annoncé."
,"21":"Quand arriva le huitième jour, ils circoncirent l'enfant selon la loi et lui donnèrent le nom de Jésus, ce nom que l'ange avait indiqué avant que sa mère ne soit enceinte."
,"22":"Puis arriva le jour où, selon la loi de Moïse, ils devaient accomplir le rite de la purification. Ils portèrent alors l'enfant à Jérusalem pour le présenter au Seigneur,"
,"23":"comme il est écrit dans la Loi du Seigneur: Tout enfant mâle premier-né sera consacré au Seigneur."
,"24":"Ils offrirent le sacrifice ordonné par la Loi: une paire de tourterelles ou deux petites colombes."
,"25":"Il y avait à Jérusalem un homme fidèle et pieux appelé Siméon. Cet homme attendait le jour où Dieu aurait pitié d'Israël, et l'Esprit Saint était sur lui."
,"26":"Il avait été averti par l'Esprit Saint qu'il ne mourrait pas avant d'avoir vu le Messie du Seigneur."
,"27":"Ce fut l'Esprit encore qui le fit venir au Temple. Au moment où les parents amenaient l'enfant Jésus pour accomplir les rites de la Loi qui le concernaient,"
,"28":"Siméon le prit dans ses bras et bénit Dieu par ces paroles:"
,"29":"'Laisse maintenant ton serviteur,mourir en paix, Seigneur, comme tu l'as dit,"
,"30":"parce que mes yeux ont vu ton Sauveur."
,"31":"Tu l'as préparé, tu l'offres à tous les peuples,"
,"32":"lumière qui sera révélée aux nations, et gloire de ton peuple Israël.'"
,"33":"Son père et sa mère étaient émerveillés de ce qui était dit de l'enfant."
,"34":"Siméon les félicita; il dit ensuite à Marie sa mère: 'Regarde, cet enfant apportera aux masses d'Israël, soit la chute, soit la résurrection: il sera un signe de division,"
,"35":"et toi-même, une épée te transpercera l'âme. Mais par ce moyen les hommes mettront à nu le secret de leur coeur.'"
,"36":"Il y avait là également une femme très âgée, une prophétesse nommée Anne, fille de Phanouël, de la tribu d'Aser. Elle n'avait pas connu d'autre homme que son premier mari, mort au bout de sept ans."
,"37":"Restée veuve, elle avait atteint les quatre-vingt quatre ans. Elle ne s'éloignait pas du Temple et servait le Seigneur nuit et jour dans le jeûne et la prière."
,"38":"Elle aussi se présenta à cette heure et à son tour elle se mit à chanter les louanges de Dieu, parlant de l'enfant à tous ceux qui attendaient la libération de Jérusalem."
,"39":"Quand ils eurent accompli tout ce qu'ordonnait la Loi du Seigneur, ils retournèrent en Galilée dans la ville de Nazareth."
,"40":"L'enfant grandissait et prenait des forces; il était plein de sagesse et la grâce de Dieu était sur lui."
,"41":"Tous les ans les parents de Jésus se rendaient à Jérusalem pour la fête de la Pâque,"
,"42":"et quand il eut douze ans, comme c'était de règle, il monta avec eux."
,"43":"Lorsque les jours de fête furent achevés, ils s'en retournèrent, mais l'enfant Jésus resta à Jérusalem sans en avertir ses parents."
,"44":"Eux pensaient qu'il était dans la caravane, et ils marchèrent ainsi tout le jour. Puis ils le cherchèrent parmi leurs amis et leurs connaissances."
,"45":"Ne le trouvant pas, ils retournèrent à Jérusalem, toujours à sa recherche."
,"46":"Le troisième jour ils le trouvèrent dans le Temple, assis au milieu des maîtres de la Loi: il les écoutait et les interrogeait."
,"47":"Tous ceux qui l'entendaient étaient étonnés de son intelligence et de ses réponses."
,"48":"En le voyant, ses parents furent très émus et sa mère lui dit: 'Mon fils, pourquoi nous as-tu fait cela? Ton père et moi nous te cherchions, très inquiets.'"
,"49":"Alors il répondit: 'Pourquoi me cherchiez-vous? Ne savez-vous pas que je dois être chez mon Père?'"
,"50":"Mais ils ne comprirent pas une telle réponse."
,"51":"Il descendit alors avec eux et revint à Nazareth. Par la suite il continua à leur obéir; sa mère, pour sa part, gardait tout cela dans son coeur."
,"52":"Quant à Jésus, il grandissait en sagesse, en âge et en grâce, aussi bien devant Dieu que devant les hommes."
}`)
	CurrentBook.AddChapter(3, `{
"1":"C'était la quinzième année du règne de l'empereur Tibère. Ponce Pilate était gouverneur de Judée, Hérode était responsable de la province de Galilée, son frère Philippe de la province d'Iturée et de Trachonitide, et Lysias avait en charge l'Abilène."
,"2":"Anne et Caïphe étaient grands prêtres cette année-là, lorsque la parole de Dieu fut adressée à Jean fils de Zacharie dans le désert."
,"3":"Jean commença à parcourir toute la région du Jourdain, prêchant baptême et conversion en vue d'obtenir le pardon des péchés."
,"4":"C'était écrit déjà dans le livre du prophète Isaïe: 'Ecoutez ce cri dans le désert: Préparez le chemin du Seigneur, aplanissez le sol devant lui."
,"5":"Comblez tous les ravins, aplanissez bosses et collines. Les chemins tortueux seront redressés et les chemins malaisés, aménagés."
,"6":"Tout mortel alors, verra le salut de Dieu.'"
,"7":"Il disait donc aux foules qui de tous côtés venaient à lui pour être baptisées: 'Race de vipères, qui vous a dit que vous échapperez à la Colère qui vient?"
,"8":"Montrez donc les fruits authentiques de la conversion! Ne croyez pas qu'il vous suffise de dire: Abraham est notre père! Car, je vous le dis, Dieu est capable de faire sortir, même de ces pierres, des enfants d'Abraham!"
,"9":"Déjà la hache est au pied de l'arbre: tout arbre qui ne produit pas de bons fruits va être abattu et jeté au feu.'"
,"10":"Les foules l'interrogeaient: 'Que devons-nous faire?'"
,"11":"Il répondait: 'Que celui qui a deux vêtements en donne un à celui qui n'en a pas, et que celui qui a de quoi manger fasse de même.'"
,"12":"Arrivent alors des collecteurs de l'impôt pour être baptisés; ils lui disent: 'Maître, que devons-nous faire?'"
,"13":"Jean leur répond: 'Ne percevez rien de plus que ce qui est dû.'"
,"14":"Des soldats l'interrogent à leur tour; ils lui disent: 'Et nous, que devons-nous faire?' Il leur répond: 'Ne brutalisez personne et ne faites pas de chantage. Contentez-vous de votre paye.'"
,"15":"Le peuple était dans l'attente et tous se demandaient si Jean ne serait pas le Messie."
,"16":"Alors Jean leur répondit à tous: 'Moi, je vous baptise avec l'eau. Mais un autre vient, plus fort que moi: je ne suis pas digne de délier les lacets de ses sandales. Lui vous baptisera dans l'Esprit Saint et le feu."
,"17":"Il tient dans sa main la pelle pour nettoyer son blé; il rassemblera le grain dans son grenier, mais la paille, il la brûlera dans le feu qui ne s'éteint pas.'"
,"18":"Avec ces instructions et beaucoup d'autres, Jean annonçait au peuple la Bonne Nouvelle."
,"19":"Jean avait fait des reproches à Hérode, le gouverneur, à propos d'Hérodiade femme de son frère, mais aussi à propos de tout ce qu'il faisait de mal. Pour cette raison Hérode"
,"20":"ajouta à tous ses autres crimes celui de faire jeter Jean en prison."
,"21":"Avec tout le peuple qui recevait le baptême, Jésus aussi se fit baptiser. Comme il priait, le ciel s'ouvrit"
,"22":"et l'Esprit Saint descendit sur lui sous une forme visible, comme une colombe. Et du ciel vint une voix: 'Tu es mon Fils: moi aujourd'hui je t'ai engendré.'"
,"23":"Lorsque Jésus commença, il avait environ trente ans, et pour tous il était fils de Joseph, fils d'Héli,"
,"24":"fils de Matthat, fils de Lévi, fils de Melki, fils de Jannaï, fils de Joseph,"
,"25":"fils de Mattathias, fils d'Amos, fils de Naoum, fils d'Esli, fils de Naggaï,"
,"26":"fils de Maath, fils de Mattathias, fils de Séméin, fils de Josek, fils de Joda,"
,"27":"fils de Joanam, fils de Résa, fils de Zorobabel, fils de Salathiel, fils de Néri,"
,"28":"fils de Melki, fils d'Addi, fils de Kosam, fils d'Elmadam, fils d'Er,"
,"29":"fils de Jésus, fils d'Eliézer, fils de Jorim, fils de Matthat, fils de Lévi,"
,"30":"fils de Syméon, fils de Juda, fils de Joseph, fils de Jonam, fils d'Eliakim,"
,"31":"fils de Méléa, fils de Menna, fils de Mattatha, fils de Nathan, fils de David,"
,"32":"fils de Jessé, fils de Jobed, fils de Booz, fils de Sala, fils de Naasson,"
,"33":"fils d'Aminadab, fils d'Admin, fils d'Arni, fils de Hesron, fils de Pharès, fils de Juda,"
,"34":"fils de Jacob, fils d'Isaac, fils d'Abraham, fils de Thara, fils de Nakor,"
,"35":"fils de Sérouk, fils de Ragau, fils de Phalec, fils d'Eber, fils de Sala,"
,"36":"fils de Kaïnam, fils d'Arphaxad, fils de Sem, fils de Noé, fils de Lamek,"
,"37":"fils de Mathousala, fils d'Henok, fils de Iaret, fils de Maléléel, fils de Kaïnam,"
,"38":"fils d'Enos, fils de Seth, fils d'Adam, fils de Dieu."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Jésus revint du Jourdain rempli de l'Esprit Saint; il se laissa conduire par l'Esprit à travers le désert"
,"2":"où, durant quarante jours, il fut tenté par le diable. De tous ces jours il ne mangea rien, et lorsqu'ils s'achevèrent il eut faim."
,"3":"Le diable lui dit alors: 'Si tu es Fils de Dieu, commande à cette pierre qu'elle devienne du pain.'"
,"4":"Jésus lui répondit: 'Il est écrit: L'homme ne vit pas seulement de pain. '"
,"5":"Le diable alors l'emporta et lui montra, le temps d'un clin d'oeil, tous les royaumes de la terre."
,"6":"Il lui dit: 'Je te donnerai autorité sur tous; toute cette gloire sera tienne, car elle m'a été remise et je la donne à qui je veux!"
,"7":"Elle sera tout entière à toi si tu te prosternes devant moi.'"
,"8":"Mais Jésus lui répondit: 'Il est écrit: Tu te prosterneras devant le Seigneur ton Dieu et tu n'adoreras que lui.'"
,"9":"Le diable alors le conduisit à Jérusalem. Il le plaça sur le haut du rempart du Temple et lui dit: 'Si tu es Fils de Dieu, jette-toi d'ici en bas."
,"10":"Car il est écrit: Il donnera des ordres à ses anges à ton sujet, pour qu'ils te gardent."
,"11":"Et encore: Leurs mains te saisiront, de peur que ton pied ne heurte quelque pierre.'"
,"12":"Mais Jésus lui répliqua: 'Il est dit: Tu ne mettras pas à l'épreuve le Seigneur ton Dieu.'"
,"13":"Le diable avait tenté Jésus de toutes les façons possibles; il s'éloigna de lui, attendant une occasion."
,"14":"Jésus revint en Galilée avec la puissance de l'Esprit et l'on commença à parler de lui dans toute la région."
,"15":"Il s'était mis à enseigner dans leurs synagogues et tous chantaient ses louanges."
,"16":"Jésus vint ainsi à Nazareth où il avait grandi. Il se rendit à la synagogue comme il avait coutume de faire le jour du sabbat, et il se leva pour faire la lecture."
,"17":"On lui passa le livre du prophète Isaïe et, en le déroulant, il trouva le passage où il est écrit:"
,"18":"L'Esprit du Seigneur est sur moi: il m'a consacré pour donner aux pauvres une bonne nouvelle. Il m'a envoyé annoncer la libération aux captifs, la lumière aux aveugles; il me faut libérer ceux qui sont écrasés,"
,"19":"et proclamer une année de grâce de la part du Seigneur."
,"20":"Il roule alors le livre et le redonne au servant, puis il s'assoit, et tous dans la synagogue ont les yeux fixés sur lui."
,"21":"Alors il commence sur ce thème: 'Cette Ecriture est en train de s'accomplir: voyez les nouvelles qu'on vous rapporte!'"
,"22":"Tous l'approuvaient et admiraient cette révélation de la grâce divine qui tombait de ses lèvres. Ils disaient: 'Et penser que c'est le fils de Joseph!'"
,"23":"Mais il leur dit: 'Sûrement vous allez me citer ce proverbe: Médecin, guéris-toi toi-même! On nous a parlé de bien des merveilles survenues à Capharnaüm: fais-les donc ici dans ta patrie!'"
,"24":"Jésus ajouta: 'En vérité, je vous le dis, aucun prophète n'est bien reçu dans sa patrie!"
,"25":"Croyez-moi, il y avait beaucoup de veuves en Israël au temps d'Elie lorsque le ciel retint l'eau pendant trois ans et demi, et qu'il y eut une grande famine dans tout le pays."
,"26":"Cependant Elie ne fut envoyé à aucune d'elles, mais bien à une femme de Sarepta dans le territoire de Sidon!"
,"27":"Il y avait de même de nombreux lépreux en Israël au temps du prophète Elisée, et aucun d'eux ne fut guéri, sinon Naaman le syrien!'"
,"28":"En entendant cela, tous dans la synagogue sentaient monter leur colère."
,"29":"Ils se lèvent, le poussent hors de la ville et le conduisent jusqu'à un ravin de la colline sur laquelle leur ville est construite, pour le jeter en bas."
,"30":"Mais lui passe au milieu d'eux et il va son chemin."
,"31":"Jésus descendit à Capharnaüm, une ville de Galilée. Les jours de sabbat il les enseignait,"
,"32":"et son enseignement faisait forte impression sur eux parce qu'il parlait avec autorité."
,"33":"Il y avait dans la synagogue un homme possédé par un démon impur. Voici qu'il se met à pousser des cris:"
,"34":"'Que nous veux-tu, Jésus de Nazareth? Es-tu venu pour nous perdre? Je sais qui tu es: le Saint de Dieu!'"
,"35":"Jésus le menace et lui dit: 'Tais-toi! Sors de cet homme!' Alors le démon le projette en plein milieu, puis sort de lui sans lui avoir fait le moindre mal."
,"36":"C'est une vraie stupeur chez tous; ils se disent l'un à l'autre: 'Où veut-il en venir? Avec quelle autorité et quelle puissance il commande aux esprits impurs! Et ils sortent!'"
,"37":"C'est ainsi que la renommée de Jésus commence à se répandre partout aux alentours."
,"38":"Au sortir de la synagogue, Jésus vient à la maison de Simon. La belle-mère de Simon est alors alitée avec une forte fièvre, et ils lui présentent son cas."
,"39":"Jésus se penche sur elle et menace durement cette fièvre: elle la quitte, et à l'instant même la femme se lève pour leur faire le service."
,"40":"Au coucher du soleil, tous ceux qui ont des infirmes atteints de diverses maladies les lui amènent. Il leur impose les mains à chacun et les guérit."
,"41":"Des démons sortent également de plusieurs d'entre eux en criant: 'Tu es le Fils de Dieu!' Mais lui les menace et ne leur permet pas de dire qu'il est le Messie, car ils le savent."
,"42":"Au matin Jésus sortit à la recherche d'un lieu désert. Les foules le cherchaient et ceux qui purent le joindre essayaient de le retenir pour qu'il ne parte pas de chez eux."
,"43":"Mais il leur dit: 'Je dois aussi annoncer la Bonne Nouvelle du Royaume de Dieu aux autres villes: c'est pour cela que j'ai été envoyé.'"
,"44":"Il alla donc porter le message dans les synagogues des Juifs."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Un jour la foule s'écrasait autour de lui pour mieux entendre la parole de Dieu, et lui se tenait au bord du lac de Génésaret."
,"2":"A ce moment il vit deux barques amarrées sur le bord du lac: les pêcheurs en étaient descendus et lavaient leurs filets."
,"3":"Il monta dans l'une des barques, qui était à Simon, et lui demanda de s'écarter un peu de la rive. Puis, de la barque où il était assis, il continua d'enseigner les foules."
,"4":"Quand il eut fini de parler il dit à Simon: 'Avance vers le large et jetez vos filets pour la pêche.'"
,"5":"Simon répondit: 'Maître, nous avons eu beau faire, nous n'avons rien pris de toute la nuit. Mais si tu le dis, je vais jeter les filets.'"
,"6":"C'est ce qu'ils firent, et ils ramassèrent une telle quantité de poissons que leurs filets étaient près de se déchirer!"
,"7":"Alors ils firent signe à leurs associés qui étaient dans l'autre barque pour qu'ils viennent les aider. Ils arrivèrent et remplirent les deux barques presqu'à les faire couler."
,"8":"Voyant cela, Simon-Pierre se jeta aux pieds de Jésus et lui dit: 'Eloigne-toi de moi, Seigneur, car je suis un pécheur!'"
,"9":"Lui et ses aides étaient en effet sous le coup de la stupeur à cause de cette pêche qu'ils venaient de faire;"
,"10":"de même Jacques et Jean, les fils de Zébédée, qui étaient des compagnons de Simon. Jésus dit alors à Simon: 'Ne crains pas! A partir de maintenant ce sont les personnes que tu pêcheras!'"
,"11":"Ils ramenèrent les barques à terre, puis ils laissèrent tout et le suivirent."
,"12":"Comme Jésus se trouvait dans une certaine ville, voici qu'un homme se présente, couvert de lèpre. Arrivé devant Jésus, il se prosterne et le supplie: 'Seigneur, si tu le veux, tu peux me guérir!'"
,"13":"Aussitôt Jésus étend la main et le touche en disant: 'Je le veux: sois guéri!' Sur ce, la lèpre le quitte."
,"14":"Jésus alors lui fait la leçon: 'Ne le dis à personne, mais va te montrer au prêtre et offre pour ta purification le sacrifice ordonné par Moïse: tu feras ainsi ta déclaration.'"
,"15":"Malgré cela, sa renommée se répandait de plus en plus. Des foules nombreuses se regroupaient pour l'entendre et pour se faire guérir de leurs infirmités,"
,"16":"mais lui cherchait des endroits retirés pour y prier."
,"17":"Il était un certain jour en train d'enseigner. Dans l'assistance se trouvaient des Pharisiens et des maîtres de la Loi venus de tous les coins de Galilée et de Judée, et même de Jérusalem. Juste à ce moment la force du Seigneur lui permettait de faire des guérisons."
,"18":"Se présentent alors des hommes qui amènent un paralysé sur un brancard. Ils cherchent à le faire entrer pour le déposer devant Jésus,"
,"19":"mais ils ne voient pas comment le faire passer, tellement il y a de monde. Alors ils montent sur la terrasse et, au travers des tuiles, ils le descendent avec sa paillasse en plein milieu, devant Jésus."
,"20":"Lui, voyant leur foi, dit simplement: 'Mon ami, tes péchés te sont pardonnés!'"
,"21":"Aussitôt les maîtres de la Loi et les Pharisiens commencent à faire des réflexions: 'Cet homme vient de dire un blasphème; qui peut pardonner les péchés sinon Dieu?'"
,"22":"Mais Jésus sait ce qu'ils pensent et il leur répond: 'Pourquoi réagissez-vous ainsi?"
,"23":"Quel est le plus facile de dire: 'Tes péchés te sont pardonnés', ou: 'Lève-toi et marche'?"
,"24":"Eh bien vous saurez que sur la terre le Fils de l'Homme a autorité pour remettre les péchés.' Et Jésus dit au paralysé: 'Lève-toi, tu m'entends! prends ta paillasse et rentre chez toi.'"
,"25":"A l'instant même il se leva sous leurs yeux; il prit la paillasse sur laquelle il était allongé et rentra chez lui, chantant la gloire de Dieu."
,"26":"Tous étaient bouleversés et rendaient gloire à Dieu; ils disaient: 'Aujourd'hui nous avons vu des choses incroyables!' et tous étaient sous le coup d'une crainte religieuse."
,"27":"Comme Jésus sortait, il aperçut un employé de l'impôt du nom de Lévi, assis à son poste de percepteur. Jésus lui dit: 'Suis-moi!'"
,"28":"Lévi laissa tout; il se leva et le suivit."
,"29":"Lévi prépara dans sa maison un grand repas en l'honneur de Jésus; il y avait là à table avec eux tout un monde de collecteurs de l'impôt et d'autres du même genre."
,"30":"Voyant cela, les Pharisiens et les maîtres de la Loi faisaient des réflexions aux disciples: 'Comment pouvez-vous manger et boire avec les collecteurs de l'impôt et les pécheurs?'"
,"31":"C'est Jésus qui leur répondit: 'Les biens portants n'ont pas besoin du médecin, il est pour les malades."
,"32":"Ce ne sont pas les justes que je viens appeler à la conversion, mais les pécheurs.'"
,"33":"Ils dirent à Jésus: 'Les disciples de Jean-Baptiste jeûnent souvent et font des prières, et c'est pareil chez les Pharisiens, mais les tiens mangent et boivent!'"
,"34":"Jésus leur dit: 'Vous ne pouvez pas faire jeûner les compagnons du nouvel époux tant que l'époux est avec eux."
,"35":"Mais un jour l'époux leur sera enlevé; en ces jours-là, oui, ils jeûneront.'"
,"36":"Il leur dit encore cette parabole: 'Personne ne prend une pièce sur un vêtement neuf pour réparer un vieux vêtement. Vous ne le voyez pas déchirant le neuf pour qu'ensuite la pièce prise sur le neuf ne s'accorde pas avec le vieux."
,"37":"Personne non plus ne met le vin nouveau dans de vieilles outres. Sinon le vin nouveau fera éclater les outres: voilà le vin répandu et les outres perdues."
,"38":"Mettez le vin nouveau dans des outres neuves!"
,"39":"Celui qui est habitué au vin vieux n'a aucun désir du nouveau; il dit en effet: 'Le vieux est excellent!'"
}`)
	CurrentBook.AddChapter(6, `{
"1":"Un jour de sabbat, comme Jésus traversait des blés mûrs, ses disciples commencèrent à cueillir des épis et à les écraser dans leurs mains pour les manger."
,"2":"Quelques Pharisiens leur dirent: 'Pourquoi faites-vous ce qui n'est pas permis le jour du sabbat?'"
,"3":"Jésus leur répondit: 'Vous n'avez donc pas lu ce qu'a fait David, et avec lui ses hommes, un jour qu'ils avaient faim?"
,"4":"Il est entré dans la Maison de Dieu et il a pris les pains de l'offrande, il en a mangé et en a donné à ses hommes, alors que seuls les prêtres peuvent en manger.'"
,"5":"Jésus ajoutait: 'Sachez que le Fils de l'Homme est Seigneur du sabbat!'"
,"6":"Un jour de sabbat encore, il était allé à la synagogue et il enseignait. Or il y avait là un homme dont la main droite était paralysée."
,"7":"Les maîtres de la Loi et les Pharisiens l'épiaient pour voir s'il allait le guérir un jour de sabbat: ils auraient alors un motif pour l'accuser."
,"8":"Mais Jésus connaissait leurs pensées; il dit à l'homme qui avait la main paralysée: 'Lève-toi! Tiens-toi là au milieu.' L'autre se leva et resta debout."
,"9":"Alors Jésus leur dit: 'Je vous pose une question: le jour du sabbat, est-il permis de faire du bien ou de faire du mal, de sauver une vie ou de donner la mort?'"
,"10":"Jésus promena son regard sur l'assistance, puis il dit à l'homme: 'Etends ta main!' L'autre étendit la main: elle était guérie."
,"11":"Eux alors, au comble de la colère, commencèrent à discuter entre eux sur ce qu'ils allaient faire à Jésus."
,"12":"En ces jours-là Jésus partit prier dans la montagne et il passa la nuit en prière avec Dieu."
,"13":"Puis, quand vint le jour, il appela ses disciples et il en choisit douze à qui il donna le nom d'apôtres:"
,"14":"Simon, auquel il donna le nom de Pierre, André, son frère, Jacques, Jean, Philippe, Barthélemy,"
,"15":"Matthieu, Thomas, Jacques fils d'Alphée, Simon, appelé le Zélote,"
,"16":"Judas fils de Jacques, et Judas Iscarioth, celui qui devait le trahir."
,"17":"Jésus descendit avec eux et s'arrêta dans la plaine. Il y avait là un nombre impressionnant de disciples et une foule nombreuse venue de toute la Judée, de Jérusalem et des rives de Tyr et de Sidon."
,"18":"Ils étaient venus pour l'entendre et pour être guéris de leurs maladies; s'ils étaient tourmentés par des esprits impurs, il les rétablissait."
,"19":"Toute cette foule cherchait à le toucher, parce qu'une force sortait de lui qui les guérissait tous."
,"20":"Levant les yeux vers ses disciples, Jésus leur dit: 'Heureux, vous les pauvres, parce que le Royaume de Dieu est à vous!"
,"21":"Heureux, vous qui avez faim maintenant, parce que vous serez rassasiés!,Heureux, vous qui pleurez maintenant, parce que vous rirez!"
,"22":"Heureux êtes-vous lorsque les hommes vous haïssent, lorsqu'ils vous chassent, et vous insultent, et vous mettent au rang des malfaiteurs à cause du Fils de l'Homme!"
,"23":"Réjouissez-vous ce jour-là, dansez de joie, car dans le ciel votre récompense est grande. Pensez que leurs pères ont traité les prophètes de la même manière."
,"24":"Mais malheureux, vous, les riches, car vous avez reçu votre consolation!"
,"25":"Malheureux, vous, les nantis d'aujourd'hui, parce que vous aurez faim!,Malheureux, vous qui riez aujourd'hui, parce que vous serez dans les pleurs et les larmes!"
,"26":"Malheureux êtes-vous si tout le monde parle bien de vous: c'est de cette manière que leurs pères ont traité les faux prophètes!"
,"27":"Oui, je vous le dis à vous qui m'écoutez: aimez vos ennemis, faites du bien à ceux qui vous détestent,"
,"28":"bénissez ceux qui vous maudissent, priez pour ceux qui vous calomnient."
,"29":"Si on te frappe sur une joue, présente encore l'autre; si on te prend ton manteau, ne refuse pas ta tunique."
,"30":"Donne à celui qui te demande, ne réclame pas ton bien à celui qui le prend!"
,"31":"Traitez les autres comme vous voulez qu'ils vous traitent."
,"32":"Si vous aimez ceux qui vous aiment, faut-il vous en savoir gré? Les pécheurs eux-mêmes aiment ceux qui les aiment."
,"33":"Si vous faites du bien à ceux qui vous font du bien, faut-il vous en savoir gré? Les pécheurs eux-mêmes en font autant."
,"34":"Et si vous prêtez à ceux dont vous espérez recevoir, faut-il vous en savoir gré? Les pécheurs eux-mêmes prêtent à d'autres pécheurs pour recevoir les mêmes faveurs."
,"35":"Donc aimez vos ennemis, faites du bien et prêtez sans rien attendre en retour. Votre récompense alors sera grande et vous serez les fils du Très-Haut, car il est bon avec les ingrats et les mauvais."
,"36":"Soyez miséricordieux comme votre Père est miséricordieux."
,"37":"Ne jugez pas et vous ne serez pas jugés. Ne condamnez pas et vous ne serez pas condamnés. Pardonnez, et l'on vous pardonnera."
,"38":"Donnez, et l'on vous donnera. On versera dans votre tablier une belle mesure, tassée, secouée, débordante de tous côtés; car on utilisera pour vous la même mesure que vous utilisez.'"
,"39":"Il leur donna cette comparaison: 'Un aveugle peut-il guider un autre aveugle? Ne tomberont-ils pas tous les deux dans le trou?"
,"40":"Le disciple n'est pas au-dessus du maître, mais s'il se laisse former il sera comme son maître."
,"41":"Quoi! Tu vois la paille qui est dans l'oeil de ton frère, et tu n'as pas remarqué la poutre qui est dans le tien?"
,"42":"Comment peux-tu dire à ton frère: 'Laisse-moi t'enlever cette paille que tu as dans l'oeil', alors que tu ne vois pas la poutre qui est dans le tien? Hypocrite, enlève d'abord de ton oeil la poutre, et ensuite tu verras clair pour enlever la paille qui est dans l'oeil de ton frère."
,"43":"Il n'y a pas d'arbre sain qui donne de mauvais fruits, ni d'arbre malade qui donne de bons fruits."
,"44":"D'ailleurs, chaque arbre se reconnaît à son fruit: on ne ramasse pas des figues sur des épines, on ne vendange pas de raisins sur un buisson."
,"45":"L'homme bon dit ce qui est bon à partir du bon fond qui est en lui, mais l'homme mauvais fait sortir le mal du mauvais fond qui est en lui. La bouche parle de l'abondance du coeur."
,"46":"Pourquoi me donnez-vous ce titre: 'Seigneur, Seigneur!' et ne faites-vous pas ce que je dis?"
,"47":"Celui qui vient à moi, qui écoute mes paroles et les met en pratique, je vais vous en donner une image:"
,"48":"il ressemble à un homme qui a bâti une maison; il a creusé profondément et a posé les fondations sur la pierre. Une crue est venue, le torrent s'est jeté sur cette maison, mais il n'a pas été capable de la renverser car elle était bien bâtie."
,"49":"En revanche, celui qui entend et ne met pas en pratique est semblable à un homme qui a construit la maison à même le sol, sans fondations. Le torrent s'est jeté sur elle et elle n'a pas été longue à s'écrouler: ce fut un vrai désas tre.'"
}`)
	CurrentBook.AddChapter(7, `{
"1":"Après avoir donné tout cet enseignement au peuple, Jésus rentra à Capharnaüm."
,"2":"Le serviteur d'un officier était si malade qu'il était sur le point de mourir; or cet officier l'estimait beaucoup."
,"3":"Comme il avait entendu parler de Jésus, il envoya vers lui quelques Juifs importants pour lui demander de venir guérir son serviteur."
,"4":"Arrivés près de Jésus, ceux-ci insistent: 'Il mérite que tu fasses cela pour lui,"
,"5":"car il aime notre nation et c'est lui qui nous a construit la synagogue.'"
,"6":"Jésus part donc avec eux. Quand déjà il n'est plus loin de la maison, l'officier envoie d'autres amis pour lui dire: 'Ne prenez pas tant de peine! Qui suis-je pour que vous veniez sous mon toit?"
,"7":"C'est pourquoi déjà je n'ai pas voulu aller moi-même vous chercher. Dites seulement une parole et mon serviteur sera guéri! "
,"8":"J'ai beau n'être qu'un subalterne, j'ai des soldats sous mes ordres et quand je dis à l'un: 'Va!' il va. A un autre je dis: 'Viens!', et il vient, et à mon serviteur: 'Fais cela', et il le fait.'"
,"9":"En l'entendant parler ainsi, Jésus était dans l'admiration. Il se tourna alors vers la foule qui le suivait et déclara: 'Je vous le dis: même en Israël je n'ai pas rencontré une telle foi!'"
,"10":"Les envoyés s'en revinrent à la maison, ce fut pour y trouver le serviteur en parfaite santé."
,"11":"Un peu plus tard Jésus se rendit dans une ville appelée Naïn. Ses disciples faisaient route avec lui, c'était toute une troupe."
,"12":"Comme il approchait de la porte de la ville, voici qu'on emportait pour l'enterrer, un fils unique dont la mère était veuve. Les gens de la ville, en grand nombre, l'accompagnaient."
,"13":"A sa vue le Seigneur eut pitié d'elle; il lui dit: 'Ne pleure pas.'"
,"14":"Puis il s'approcha et toucha le brancard: les porteurs s'arrêtèrent. Jésus dit alors: 'Jeune homme je te parle: Lève-toi!'"
,"15":"Et voici que le mort se redresse, s'assoit et commence à parler. Et Jésus le rend à sa mère."
,"16":"Une crainte religieuse saisit toute l'assistance; ils louaient Dieu en ces termes: 'Un grand prophète s'est levé parmi nous: Dieu a visité son peuple!'"
,"17":"C'est cela même qu'on entendait dire de lui par tout le pays des Juifs aussi bien que dans les régions voisines."
,"18":"Les disciples de Jean-Baptiste le tenaient au courant de tous ces événements. Il appela deux de ses disciples"
,"19":"et les envoya au Seigneur pour lui dire: 'Es-tu celui qui doit venir ou devons-nous en attendre un autre?'"
,"20":"Lorsque ces hommes arrivèrent près de Jésus, ils lui dirent: 'Jean-Baptiste nous envoie vers toi pour te demander: Es-tu celui qui doit venir ou devons-nous en attendre un autre?'"
,"21":"A ce moment-même Jésus rendit la santé à bien des gens affligés de maladies, d'infirmités et d'esprits mauvais; et il redonna la vue à plusieurs aveugles."
,"22":"Puis il répondit aux envoyés: 'Repartez dire à Jean ce que vous venez de voir et d'entendre: les aveugles retrouvent la vue, les éclopés marchent, les lépreux sont purifiés, les sourds entendent, les morts se réveillent et les pauvres entendent une bonne nouvelle."
,"23":"Mais heureux particulièrement celui qui me voit si ce n'est pas pour sa chute!'"
,"24":"Lorsque les envoyés de Jean furent partis, Jésus commença à parler de Jean à la foule: 'Que cherchiez-vous à voir quand vous alliez au désert? Un roseau agité par le vent?"
,"25":"Qu'alliez-vous voir? Un homme avec des habits douillets? Mais ceux qui portent des habits douillets et font les bons repas se trouvent dans les palais des rois!"
,"26":"Alors, qu'alliez-vous voir? Un prophète? Oui, je vous le dis, et plus qu'un prophète!"
,"27":"Car c'est de lui qu'il est écrit: J'envoie mon messager devant toi pour qu'il te prépare le chemin."
,"28":"Oui, je vous le dis, personne n'est plus grand que Jean parmi les fils de la femme. Et cependant le plus petit dans le Royaume de Dieu est plus grand que lui."
,"29":"Tout le peuple est venu l'entendre, même les collecteurs de l'impôt: ils ont confessé leurs fautes et reçu le baptême de Jean."
,"30":"Et quand les Pharisiens et les maîtres de la Loi ne se sont pas fait baptiser par lui, ils ont dit non à ce que Dieu leur demandait."
,"31":"Comment donc vais-je dépeindre les hommes de la présente génération?"
,"32":"Ils font penser à des gamins assis sur la place; un groupe interpelle les autres: 'Nous avons joué de la flûte pour vous et vous n'avez pas dansé. Et quand nous avons fait la lamentation, vous n'avez pas pleuré!'"
,"33":"Rappelez-vous Jean; il ne mangeait pas de pain, il ne buvait pas de vin, et quand il est venu on a dit: 'Il a un démon.'"
,"34":"Et puis vient le Fils de l'Homme qui mange et qui boit, et l'on dit: 'Voilà un mangeur et un buveur de vin, un ami des collecteurs de l'impôt et des pécheurs!'"
,"35":"Mais les enfants de la Sagesse savent qu'elle a bien agi.'"
,"36":"Un Pharisien avait invité Jésus à manger chez lui. Il entra dans la maison du Pharisien et s'allongea pour le repas."
,"37":"Or dans cette ville il y avait une femme connue comme pécheresse. Sachant que Jésus était à table dans la maison du Pharisien, elle se procura un vase précieux rempli de parfum."
,"38":"Elle se tenait en arrière, aux pieds de Jésus, et elle pleurait. Bientôt ses larmes commencèrent à inonder les pieds de Jésus. De ses cheveux elle les essuyait et les embrassait longuement puis elle y versait du parfum."
,"39":"En voyant cela, le Pharisien qui l'avait invité se dit en lui-même: 'Si cet homme était prophète, il saurait que celle qui le touche est une pécheresse; il connaîtrait cette femme et comment elle est'."
,"40":"Jésus prend alors la parole et lui dit: 'Simon, j'ai quelque chose à te dire.' Et celui-ci de répondre: 'Parle, maître!'"
,"41":"Jésus reprend: 'Un homme a prêté de l'argent à deux clients, l'un lui doit cinq cents pièces d'argent, l'autre cinquante."
,"42":"Comme aucun des deux n'a de quoi lui rendre, il efface leurs dettes à tous les deux. Lequel, à ton avis, l'aimera davantage?'"
,"43":"Simon répond: 'Je suppose que c'est celui qui avait la plus grande dette.' Jésus lui dit: 'Tu as bien jugé!'"
,"44":"Et se tournant vers la femme, il dit à Simon: 'Tu vois cette femme. Je suis entré chez toi et tu ne m'as pas versé d'eau sur les pieds, mais elle, elle les a inondés de ses larmes et les a essuyés de ses cheveux."
,"45":"Tu ne m'as pas embrassé; mais depuis qu'elle est entrée, elle n'a pas cessé de m'embrasser longuement les pieds."
,"46":"Tu ne m'as pas parfumé la tête, alors qu'elle a couvert mes pieds de parfum."
,"47":"C'est pourquoi, je te le dis, ses péchés, ses nombreux péchés lui sont pardonnés, parce qu'elle a beaucoup aimé! Mais celui à qui l'on pardonne peu, montre peu d'amour!'"
,"48":"Jésus dit alors à la femme: 'Tes péchés sont pardonnés!'"
,"49":"Et les invités commencèrent à se dire les uns aux autres: 'Comment peut-il maintenant pardonner les péchés?'"
,"50":"Mais de nouveau Jésus s'adressa à la femme: 'Ta foi t'a sauvée, va en paix.'"
}`)
	CurrentBook.AddChapter(8, `{
"1":"Jésus parcourait ainsi villes et villages, prêchant et donnant la bonne nouvelle du Royaume de Dieu; les Douze l'accompagnaient"
,"2":"et aussi certaines femmes qu'il avait guéries d'esprits mauvais ou d'infirmités: Marie, appelée la Magdaléenne, qu'il avait délivrée de sept démons;"
,"3":"Jeanne, femme de Chouza intendant d'Hérode; Suzanne; et beaucoup d'autres qui les assistaient de leurs biens personnels."
,"4":"Une foule nombreuse s'était rassemblée, car on venait à lui de toutes les villes. Jésus alors leur donna cette comparaison:"
,"5":"'Le semeur est sorti pour semer la semence et il se met à semer. Une partie tombe au long du chemin: elle est piétinée et les oiseaux du ciel la mangent."
,"6":"Des graines tombent sur la rocaille; là elles germent, mais elles se dessèchent par manque d'humidité."
,"7":"D'autres tombent au milieu des épines; les épines poussent en même temps qu'elles et les étouffent."
,"8":"D'autres encore tombent sur la belle terre; là elles poussent et donnent du fruit, cent pour un.',En disant cela, Jésus criait: 'Que celui qui a des oreilles pour entendre, entende!'"
,"9":"Ses disciples lui demandèrent: 'Que veut dire cette comparaison?'"
,"10":"Il leur répondit: 'A vous il a été donné de connaître les mystères du Royaume de Dieu, mais les autres n'ont que des comparaisons, de sorte qu'ils voient sans voir et entendent sans comprendre."
,"11":"Voici le sens de cette parabole: la semence est la parole de Dieu."
,"12":"Ceux qui sont sur le bord du chemin l'ont entendue, mais le diable vient et enlève de leur coeur la parole pour les empêcher de croire et d'être sauvés."
,"13":"Ce qui est tombé sur la pierre, ce sont ceux qui accueillent la parole avec joie lorsqu'ils l'entendent, mais ils n'ont pas de racines: ils ne croient que pour un temps et, venu le temps de l'épreuve, ils se retirent."
,"14":"Ce qui est tombé dans les épines, ce sont ceux qui entendent mais avec le temps se laissent étouffer par les soucis, la richesse et les plaisirs de la vie: ils n'arriveront pas à maturité."
,"15":"Ce qui est tombé dans la belle terre, ce sont ceux qui entendent la parole avec un coeur sincère et généreux; ils la gardent, et portent du fruit par leur persévérance."
,"16":"Quand on a allumé une lampe, on ne met pas une caisse par dessus, on ne la cache pas sous un lit, mais on la met sur un lampadaire pour que ceux qui entrent voient la lumière."
,"17":"Il n'y a rien de caché qui ne doive être mis au jour, rien de secret qui ne doive être éclairci."
,"18":"Faites donc bien attention à la manière dont vous écoutez! Car on donnera à celui qui produit, mais à celui qui n'apporte rien, on lui prendra même ce qu'il croit avoir.'"
,"19":"Sa mère et ses frères vinrent à passer, mais ils ne pouvaient l'approcher à cause de la foule."
,"20":"Quelqu'un le prévient: 'Ta mère et tes frères sont là dehors: ils veulent te voir.'"
,"21":"Jésus répond: 'Ma mère et mes frères sont ceux qui écoutent la parole de Dieu et la mettent en pratique.'"
,"22":"Un jour Jésus monta dans la barque avec ses disciples et il leur dit: 'Passons sur l'autre rive!' Ils gagnèrent donc le large"
,"23":"et, tandis qu'ils naviguaient, lui s'endormit. C'est alors qu'une rafale de vent s'abattit sur le lac; la barque prenait l'eau au point de les mettre en danger."
,"24":"Ils s'approchent, le réveillent et lui disent: 'Maître! Maître! Nous sommes perdus!' Lui, à peine réveillé, rappelle à l'ordre le vent et les eaux déchaînées: ils s'apaisent et le calme revient."
,"25":"Alors il leur demande: 'Où est votre foi?' Ils avaient eu peur, et maintenant ils étaient hors d'eux-mêmes et se disaient l'un à l'autre: 'Qui est-il donc? Il commande même au vent et à la mer, et ils obéissent!'"
,"26":"La traversée prit fin au pays des Géraséniens, de l'autre côté du lac, face à la Galilée."
,"27":"Comme il débarquait, un homme de la ville, possédé par des démons, vint à sa rencontre. Depuis longtemps il ne portait plus de vêtements et ne restait plus dans une maison mais au milieu des tombes."
,"28":"Lorsqu'il vit Jésus, il poussa des hurlements et vint se jeter à terre en criant d'une voix forte: 'Qu'est-ce que tu me veux, Jésus, fils du Dieu Très-Haut? Je t'en supplie: ne me torture pas!'"
,"29":"En effet, Jésus ordonnait à l'esprit impur de sortir de cet homme. Bien des fois le démon s'était emparé de lui et l'avait entraîné dans le désert; dans ces moments c'était inutile de le lier avec des chaînes ou de lui entraver les pieds pour le retenir: il cassait tout."
,"30":"Jésus l'interrogea: 'Quel est ton nom?' Il répondit: 'Légion!' Car de nombreux démons étaient entrés en lui,"
,"31":"et maintenant ils suppliaient Jésus: 'Ne nous ordonne pas de retourner à l'abîme.'"
,"32":"Or il y avait là des bandes de cochons qui cherchaient leur nourriture dans la montagne. Les démons le supplièrent de les laisser entrer dans les cochons et Jésus le leur permit."
,"33":"Les démons sortirent donc de l'homme pour aller vers les cochons; le troupeau se précipita dans le lac du haut de la falaise et s'y noya."
,"34":"Voyant cela, les gardiens du troupeau prirent la fuite et portèrent la nouvelle à la ville comme dans la campagne."
,"35":"Les gens sortirent pour voir ce qui était arrivé et vinrent jusqu'à Jésus. Près de lui ils trouvèrent assis, à ses pieds, cet homme dont les démons étaient sortis: il était habillé et il avait tout son bon sens. Alors tous ces gens prirent peur. "
,"36":"Les témoins leur racontèrent comment le démoniaque avait été délivré"
,"37":"et, pour finir, toute la population du secteur le pria de quitter les lieux, car ils étaient complètement terrifiés. Jésus monta dans la barque et s'en retourna. "
,"38":"L'homme dont les démons étaient sortis demandait à rester avec lui, mais Jésus le renvoya et lui dit:"
,"39":"'Retourne chez toi; là tu raconteras tout ce que Dieu a fait pour toi.' Et l'homme s'en alla raconter par toute la ville les merveilles que Jésus avait faites pour lui."
,"40":"Il y avait du monde pour accueillir Jésus à son retour, car tous l'attendaient."
,"41":"Un homme du nom de Jaïre, président d'une synagogue, se présenta à ce moment. Il tomba aux pieds de Jésus et le supplia de venir chez lui,"
,"42":"car sa fille unique qui avait une douzaine d'années était sur le point de mourir. Comme Jésus s'y rendait, la foule le pressait au point de l'étouffer. "
,"43":"C'est alors qu'une femme qui depuis douze ans souffrait d'hémorragies, et que personne n'avait pu guérir,"
,"44":"s'approcha par derrière et vint toucher la frange de son manteau. Aussitôt l'hémorragie s'arrêta."
,"45":"Jésus demanda: 'Qui m'a touché?' Tous s'en défendaient et Pierre lui dit: 'Maître, c'est la foule qui te presse et te bouscule!'"
,"46":"Mais Jésus dit: 'Quelqu'un m'a touché, j'ai senti qu'une force était sortie de moi.'"
,"47":"Se voyant découverte, la femme arriva toute tremblante et tomba à ses pieds. Devant tout le monde elle fit savoir pour quelle raison elle l'avait touché et comment elle avait été guérie à l'instant même."
,"48":"Alors Jésus lui dit: 'Ma fille, ta foi t'a sauvée: va en paix!'"
,"49":"Il parlait encore lorsque quelqu'un arriva de chez le président de synagogue. C'était pour lui dire: 'Ta fille est morte, tu n'as plus à déranger le Maître.'"
,"50":"Jésus l'entendit et il s'adressa au père: 'Ne crains pas, crois seulement et elle sera sauvée.'"
,"51":"Arrivé à la maison, il ne laissa entrer avec lui que Pierre, Jean et Jacques, ainsi que le père et la mère de l'enfant."
,"52":"Tous étaient là qui pleuraient et se lamentaient, et lui leur dit: 'Ne pleurez pas, elle n'est pas morte, elle dort!'"
,"53":"Mais on se moquait de lui car les gens savaient bien qu'elle était morte."
,"54":"Jésus la prit par la main et l'appela: 'Enfant, lève-toi!'"
,"55":"Son esprit revint en elle; aussitôt elle se leva, et Jésus insista pour qu'on lui donne à manger."
,"56":"Ses parents étaient comme perdus; Jésus, lui, leur commanda de ne dire à personne ce qui était arrivé."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Jésus réunit les Douze; il leur donna autorité sur tous les démons, et puissance pour guérir les malades."
,"2":"Puis il les envoya proclamer le Royaume de Dieu et rendre la santé aux infirmes."
,"3":"Il leur dit: 'Ne prenez rien pour la route: ni sac qu'on accroche à son bâton, ni pain, ni argent; n'ayez pas une seconde tunique."
,"4":"Quand une maison vous sera ouverte, restez-y jusqu'au moment de votre départ."
,"5":"Mais là où on ne vous recevra pas, ne sortez pas de la ville sans avoir secoué la poussière de vos pieds: ce sera un témoignage contre eux!'"
,"6":"C'est ainsi qu'ils allèrent parcourant les villages: ils proclamaient partout la Bonne Nouvelle et multipliaient les guérisons."
,"7":"Hérode, le tétrarque, apprit tout ce qui se faisait. Il ne savait que penser car les uns disaient: 'Jean a été ressuscité d'entre les morts',"
,"8":"d'autres disaient: 'Elie a réapparu', et d'autres encore pensaient: 'C'est l'un des anciens prophètes qui est ressuscité.'"
,"9":"Hérode se disait: 'Je suis bien sûr d'avoir décapité Jean! Qui est maintenant celui-ci dont on raconte tant de merveilles?' Et il aurait aimé voir Jésus."
,"10":"A leur retour, les apôtres racontèrent à Jésus tout ce qu'ils avaient fait. Il les prit avec lui et se retira dans les environs d'une ville appelée Bethsaïde, de façon à être tranquille."
,"11":"Mais les foules le surent et y arrivèrent derrière lui. Il les reçut et continua de leur parler du Royaume de Dieu, tout en rendant la santé à ceux qui étaient malades."
,"12":"Le jour commençait à baisser. Les Douze s'approchèrent et lui dirent: 'Renvoie la foule pour qu'ils aillent se chercher un toit et de la nourriture dans les villages et les campagnes des environs, car ici nous sommes loin de tout.'"
,"13":"Il leur dit: 'Donnez-leur vous-mêmes à manger!',Ils répondirent: 'Nous n'avons que cinq pains et deux poissons. Tu nous vois sans doute y aller nous-mêmes et acheter de quoi manger pour tout ce monde?' "
,"14":"Car il y avait bien là cinq mille personnes. Jésus dit à ses disciples: 'Faites-les s'asseoir par groupes de cinquante.'"
,"15":"Les disciples firent ainsi et tout le monde s'installa."
,"16":"Alors Jésus prend les cinq pains et les deux poissons, il lève le regard vers le ciel, il prononce la bénédiction, il rompt le pain et commence à en donner aux disciples pour qu'ils servent la foule."
,"17":"Ils mangèrent et tous eurent à leur faim. Après quoi on ramassa les restes: il y en avait douze paniers!"
,"18":"Un jour, Jésus était allé un peu à l'écart pour prier, mais ses disciples étaient avec lui. Il les interrogea sur ce que pensait la foule: 'Qui disent-ils que je suis?'"
,"19":"Ils répondirent: 'Pour certains tu es Jean-Baptiste, pour d'autres Elie, pour d'autres encore un des anciens prophètes qui est ressuscité.'"
,"20":"Il leur demanda: 'Et vous, qui dites-vous que je suis?' Pierre répondit: 'Le Messie de Dieu!'"
,"21":"Jésus leur fit un avertissement et leur commanda de ne le dire à personne,"
,"22":"car, leur disait-il: 'le Fils de l'Homme doit souffrir beaucoup et être rejeté par les anciens, les chefs des prêtres et les maîtres de la Loi. Il sera mis à mort et le troisième jour il ressuscitera.'"
,"23":"D'ailleurs Jésus disait à tous: 'Si quelqu'un veut marcher derrière moi, qu'il renonce à lui-même, qu'il prenne chaque jour sa croix et qu'il me suive!"
,"24":"Oui, celui qui veut se sauver lui-même se perdra; mais celui qui se sacrifie pour moi se sauvera."
,"25":"Où est le bénéfice si l'on a gagné le monde entier et qu'on s'est détruit ou diminué soi-même?"
,"26":"Celui qui rougira de moi et de mes paroles, le Fils de l'Homme aussi rougira de lui quand il viendra dans sa gloire avec le Père et les saints anges."
,"27":"Je vous le dis en toute vérité: il en est parmi ceux qui sont ici présents qui ne mourront pas sans avoir vu le royaume de Dieu.'"
,"28":"Huit jours après ces paroles, Jésus prit avec lui Pierre, Jean et Jacques, et il gravit la montagne pour prier."
,"29":"Pendant qu'il priait, son visage changea d'aspect et son vêtement devint d'une blancheur éblouissante."
,"30":"Voici que deux hommes parlaient avec lui: c'étaient Moïse et Elie;"
,"31":"Ils apparaissaient dans un état de gloire et parlaient de son départ qui devait avoir lieu à Jérusalem."
,"32":"Pierre et ses compagnons étaient accablés de sommeil, mais une fois réveillés, ils virent sa gloire et les deux hommes qui se tenaient près de lui."
,"33":"Comme ceux-ci allaient se séparer de lui, Pierre dit à Jésus: 'Maître, cela tombe bien que nous soyons ici. Nous allons dresser trois tentes: une pour toi, une pour Moïse et une pour Elie.' Il ne savait pas ce qu'il disait."
,"34":"Tandis qu'il parlait ainsi, une nuée vint les prendre sous son ombre, et lorsqu'ils entrèrent dans la nuée la crainte s'empara d'eux."
,"35":"Mais des paroles se firent entendre venant de la nuée: 'Celui-ci est mon Fils, et l'homme de mon choix, écoutez-le!'"
,"36":"Aussitôt après ces paroles, Jésus se trouva seul. Les disciples gardèrent le silence; en ces jours-là ils ne racontèrent rien à personne de ce qu'ils avaient vu."
,"37":"Le jour suivant, comme ils descendaient de la montagne, tout un groupe vint à la rencontre de Jésus."
,"38":"Il y avait dans ce groupe un homme qui se mit à crier: 'Maître, je t'en supplie, occupe-toi de mon garçon qui est mon seul enfant! "
,"39":"Le démon s'empare de lui à l'improviste, et alors il se met à crier. Le démon le secoue violemment et le fait baver, et il ne le lâche qu'à grand-peine, le laissant à demi-mort."
,"40":"J'ai demandé à tes disciples de le jeter dehors, et ils n'y sont pas arrivés.'"
,"41":"Jésus prend alors la parole: 'O génération sans foi, égarée, jusqu'à quand serai-je avec vous et me faudra-t-il vous supporter? Amène ici ton fils!'"
,"42":"A peine arrivé, le démon le jette à terre et le secoue violemment. Mais Jésus parle sévèrement à l'esprit impur, il guérit le garçon et le rend à son père."
,"43":"Tous restèrent sous le coup d'une telle intervention de Dieu. Comme tous étaient émerveillés de ce qu'il faisait, Jésus dit à ses disciples: "
,"44":"'Vous, mettez-vous bien ceci dans la tête: le Fils de l'Homme va être livré aux mains des hommes.'"
,"45":"Mais ils ne comprirent pas cette déclaration: elle restait comme voilée pour eux et ils n'en saisissaient pas le sens. Cependant ils craignaient de l'interroger à ce sujet."
,"46":"Ils en étaient venus à se demander lequel d'entre eux était le plus important."
,"47":"Mais Jésus savait à quoi ils pensaient. Il prit un petit enfant et le plaça près de lui,"
,"48":"puis il leur dit: 'Celui qui reçoit ce petit enfant en mon nom, c'est moi qu'il reçoit. Et celui qui me reçoit, reçoit celui qui m'a envoyé. Le plus petit d'entre vous, c'est lui qui est grand!'"
,"49":"Jean prit la parole: 'Maître, dit-il, nous avons vu quelqu'un qui se sert de ton nom pour chasser les démons. Nous l'en avons empêché, car il ne vient pas avec nous.'"
,"50":"Jésus lui répondit: 'Ne l'empêchez pas! Celui qui n'est pas contre vous est avec vous.'"
,"51":"Comme le temps approchait où il devait être enlevé de ce monde, Jésus prit résolument le chemin de Jérusalem."
,"52":"Voici qu'il envoie des messagers devant lui, ils partent et entrent dans un village de Samaritains pour préparer son arrivée."
,"53":"Mais les gens ne veulent pas les recevoir, car ils font route vers Jérusalem."
,"54":"Voyant cela, les disciples Jacques et Jean disent à Jésus: 'Seigneur, si tu voulais, nous dirions une parole pour que le feu descende du ciel et les réduise en cendres.'"
,"55":"Jésus alors se retourne et les reprend,"
,"56":"et ils se dirigent vers un autre village."
,"57":"Tandis qu'ils faisaient route, quelqu'un lui dit: 'Je suis prêt à te suivre partout où tu iras!'"
,"58":"Jésus lui répondit: 'Les renards ont un terrier, les oiseaux du ciel ont un nid, mais le Fils de l'Homme n'a pas où reposer sa tête.'"
,"59":"Il dit à un autre: 'Suis-moi!' Celui-ci répondit: 'Seigneur, permets-moi d'abord de retourner, que je puisse enterrer mon père.'"
,"60":"Jésus lui dit: 'Laisse les morts enterrer leurs morts, mais toi, pars annoncer le Royaume de Dieu!'"
,"61":"Un autre encore lui dit: 'Je suis prêt à te suivre, Seigneur; mais laisse-moi d'abord dire adieu à ma famille.'"
,"62":"Jésus lui dit: 'Celui qui a mis la main à la charrue et puis regarde en arrière, n'est pas bon pour le Royaume de Dieu."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Après cela, le Seigneur en choisit soixante-douze autres. Il les envoya deux par deux en avant de lui vers toutes les villes et tous les endroits où lui-même pensait aller."
,"2":"Il leur disait: 'La moisson est abondante et les ouvriers sont peu nombreux! Priez donc le Seigneur de la moisson pour qu'il envoie des ouvriers à sa moisson!"
,"3":"Allez! Je vous envoie comme des agneaux au milieu des loups."
,"4":"Vous n'emporterez ni bourse, ni sac, ni chaussures, et sur le chemin vous n'irez pas saluer qui que ce soit."
,"5":"Lorsque vous entrerez dans une maison vous commencerez par dire: Paix à cette maison!"
,"6":"Si la paix trouve là un de ses fils, elle reposera sur lui, sinon elle reviendra sur vous."
,"7":"Le temps que vous restez dans cette maison, acceptez ce qu'ils ont à boire et à manger, car l'ouvrier mérite son salaire. Mais ne passez pas de maison en maison."
,"8":"Dans les villes où vous entrez et où l'on vous reçoit, mangez ce qu'on vous sert."
,"9":"Guérissez leurs malades et dites-leur: 'Le Royaume de Dieu est maintenant tout proche de vous!'"
,"10":"Mais si vous êtes entrés dans une ville où l'on ne vous reçoit pas, vous irez dire sur les places:"
,"11":"'Même la poussière de votre ville qui s'est collée à nos pieds, nous vous la laissons! Vous saurez quand même que le Royaume de Dieu est tout proche!'"
,"12":"Je vous le dis: au jour du jugement Sodome s'en tirera à meilleur compte que cette ville-là!"
,"13":"Malheur à toi, Korazïn! Malheur à toi Bethsaïde! Car si l'on avait eu dans Tyr et dans Sidon les miracles qui ont eu lieu chez vous, depuis longtemps elles auraient fait pénitence avec le sac, assises sur la cendre."
,"14":"Tyr et Sidon s'en tireront sûrement à meilleur compte que vous au jour du jugement!"
,"15":"Et toi, Capharnaüm, vas-tu t'élever jusqu'au ciel? Non, tu descendras jusque chez les morts!"
,"16":"Celui qui vous écoute, c'est moi qu'il écoute; celui qui vous rejette, c'est moi qu'il rejette, et celui qui me rejette, rejette celui qui m'a envoyé!'"
,"17":"Les 'soixante-douze' revinrent tout joyeux: 'Seigneur, disaient-ils, on prononçait ton nom, et même les démons nous étaient soumis!'"
,"18":"Jésus leur dit: 'Je voyais Satan descendre du ciel en flèche, comme un éclair!"
,"19":"Voyez, je vous ai donné autorité pour piétiner serpents et scorpions, et toute la puissance de l'ennemi: aucune arme ne vous atteindra."
,"20":"Mais s'il faut vous réjouir, ce n'est pas parce que les esprits vous sont soumis; réjouissez-vous de ce que vos noms sont inscrits dans les cieux.'"
,"21":"A cette heure-même Jésus fut pris tout entier par la joie de l'Esprit Saint. Il éleva la voix et dit: 'Je proclamerai tes grandeurs, Père, Seigneur du ciel et de la terre, car tu as caché ces choses aux sages comme aux intelligents et tu les as révélées à des tout-petits. Oui Père, c'est cela qui t'a paru bon!"
,"22":"Tout m'a été remis par mon Père et personne ne sait qui est le Fils, si ce n'est le Père; ni le Père, si ce n'est le Fils, et celui à qui le Fils veut le révéler.'"
,"23":"Jésus se tourna vers les disciples, à un moment où ils étaient seuls, et il leur dit: 'Heureux les yeux qui voient ce que vous voyez."
,"24":"Oui, je vous le dis: beaucoup de prophètes et de rois ont voulu voir ce que vous voyez et ne l'ont pas vu, entendre ce que vous entendez, et ne l'ont pas entendu!'"
,"25":"Un maître de la Loi se leva et lui dit pour l'embarrasser: 'Maître, que dois-je faire pour recevoir la vie éternelle?'"
,"26":"Jésus lui dit: 'Que dit l'Ecriture, que vois-tu dans la Loi?'"
,"27":"L'homme répondit: ' Tu aimeras le Seigneur ton Dieu de tout ton coeur, de toute ton âme, de toute ta force, de toute ton intelligence, et ton prochain comme toi-même.'"
,"28":"Jésus lui dit: 'Ta réponse est exacte. Fais cela et tu vivras.'"
,"29":"Mais lui voulut s'expliquer, il dit à Jésus: 'Et qui est mon prochain?'"
,"30":"Jésus alors se mit à raconter: 'Un homme descendait de Jérusalem à Jéricho. Il tomba au milieu de bandits qui lui enlevèrent jusqu'à ses vêtements. Ils s'enfuirent le laissant couvert de plaies et à demi mort."
,"31":"Un prêtre par hasard descendait ce même chemin; il vit l'homme et passa de l'autre côté."
,"32":"Un Lévite venait par la même route; arrivé à cet endroit, lui aussi vit l'homme; il changea de côté et passa."
,"33":"Mais voici qu'un Samaritain fait le même trajet, et quand il se trouve face au blessé, il a vraiment pitié de lui."
,"34":"Il s'approche et bande ses blessures en y mettant de l'huile et du vin. Puis il l'installe sur sa propre bête et le conduit jusqu'à une auberge où il prend soin de lui."
,"35":"Le lendemain il sort deux pièces d'argent et les donne à l'hôtelier en lui disant: Fais pour lui le nécessaire; si tu dépenses davantage, je te le rembourserai au retour.'"
,"36":"Jésus alors demanda: 'A ton avis, lequel des trois s'est fait le prochain de l'homme qui a été victime des bandits?'"
,"37":"L'autre répondit: 'Celui qui a eu pitié de lui.' Et Jésus lui dit: 'Va, et fais pareil.'"
,"38":"En cours de route, Jésus entra dans un village et une femme nommée Marthe le reçut chez elle."
,"39":"Elle avait une soeur, du nom de Marie, qui s'était assise aux pieds du Seigneur et restait à écouter sa parole."
,"40":"Marthe, pendant ce temps, était absorbée par tout le service. A la fin elle se tourne vers Jésus et lui dit: 'Seigneur, ne vois-tu pas que ma soeur me laisse seule avec le ser vice? Dis-lui donc de m'aider!'"
,"41":"Mais le Seigneur lui répond: 'Marthe, Marthe, tu t'inquiètes et tu t'agites pour tant de choses!"
,"42":"Une seule est nécessaire. Marie a choisi la meilleure part, elle ne lui sera pas retirée.'"
}`)
	CurrentBook.AddChapter(11, `{
"1":"Jésus était un jour quelque part en train de prier. Quand il eut fini, un de ses disciples lui dit: 'Seigneur, apprends-nous à prier comme Jean-Baptiste a fait avec ses disciples.'"
,"2":"Il leur dit: 'Quand vous priez, dites: Père, que ton Nom soit sanctifié, que ton règne vienne."
,"3":"Donne-nous chaque jour le pain qu'il nous faut;"
,"4":"pardonne-nous nos péchés car nous aussi nous pardonnons à celui qui nous doit, et ne nous laisse pas tomber dans la tentation."
,"5":"Il leur dit encore: 'Imaginez ceci: l'un d'entre vous va trouver son ami au milieu de la nuit pour lui dire: 'Ami, prête-moi trois pains!"
,"6":"Un ami qui voyage vient de m'arriver, et je n'ai rien à lui offrir.'"
,"7":"L'autre lui répond de l'intérieur: 'Laisse-moi tranquille, la porte est maintenant bloquée et nous sommes au lit avec les enfants. Je ne peux pas me lever pour te les donner.'"
,"8":"Je vous le dis: même si celui qui est au lit ne se lève pas pour vous le donner parce que vous êtes un ami, à force d'insister, vous l'obligerez à se lever et à vous donner tout ce dont vous avez besoin."
,"9":"Et je vous dis: Demandez et l'on vous donnera, cherchez et vous trouverez, frappez à la porte et l'on vous ouvrira."
,"10":"Car quiconque demande reçoit, celui qui cherche trouve, et l'on ouvre à celui qui frappe."
,"11":"Quel père parmi vous, si son fils demande un poisson, lui donnera un serpent à la place du poisson?"
,"12":"Et s'il demande un oeuf, lui donnera-t-il un scorpion?"
,"13":"Mauvais comme vous êtes, vous savez donner de bonnes choses à vos enfants: combien plus alors le Père du ciel donnera-t-il un esprit saint à ceux qui le prient."
,"14":"Un autre jour Jésus chassait un démon: il s'agissait d'un muet. Le démon sorti, le muet se mit à parler et la foule resta émerveillée."
,"15":"Il y eut quand même des gens pour dire: 'Il chasse les démons avec l'aide de Béelzéboul, le chef des démons!'"
,"16":"D'autres, pour l'embarrasser, lui demandaient un signe qui vienne vraiment du Ciel."
,"17":"Mais Jésus savait ce qu'ils pensaient, et il leur dit: 'Tout royaume qui se divise court à la ruine: les différents partis s'écroulent l'un après l'autre."
,"18":"Si vous dites que je m'appuie sur Béelzéboul pour chasser les démons, Satan est divisé; donc son pouvoir ne durera pas."
,"19":"Et si c'est Béelzéboul qui m'aide à faire sortir les démons, qui donc aide les gens de chez vous quand ils les font sortir? Ce sont eux qui jugeront vos paroles."
,"20":"Quand je fais sortir les démons, le doigt de Dieu est là: comprenez donc que le Royaume de Dieu est venu jusqu'à vous."
,"21":"Quand le Fort, bien armé, garde sa demeure, ses biens sont en sûreté."
,"22":"Mais voici qu'un autre, plus fort, arrive et triomphe de lui: il lui enlève les armes qui faisaient sa force, et distribue ses dépouilles."
,"23":"Qui n'est pas avec moi est contre moi, qui ne rassemble pas avec moi disperse."
,"24":"Quand l'esprit impur est sorti de son homme, il va errant par des lieux arides à la recherche de quelque repos. Comme il n'en trouve pas, il se dit: 'Retournons à ma maison d'où je suis sorti.'"
,"25":"En arrivant il la trouve balayée et décorée."
,"26":"Alors il va et ramène sept autres esprits plus méchants que lui; ils entrent et s'installent, et la nouvelle situation de cette personne est alors pire que la première.'"
,"27":"Pendant que Jésus parlait ainsi, du milieu de la foule une femme éleva la voix et lui cria: 'Heureuse celle qui t'a porté et qui t'a allaité!'"
,"28":"Lui aussitôt répondit: 'Heureux, dans ce cas, ceux qui entendent la parole de Dieu et qui la gardent!'"
,"29":"Comme la foule devenait plus nombreuse, Jésus se mit à dire: 'Cette génération est une génération mauvaise. Elle peut chercher un signe, on ne lui en donnera pas d'autre que le signe de Jonas."
,"30":"Tout comme Jonas a été un signe pour les habitants de Ninive, le Fils de l'Homme aussi le sera pour cette génération."
,"31":"La reine du Sud ressuscitera pour le Jugement avec les hommes de cette génération et elle les accusera; car elle-même est venue du bout du monde pour entendre la sagesse de Salomon, et ici il y a mieux que Salomon."
,"32":"Les hommes de Ninive ressusciteront pour le Jugement tout comme cette génération et ils l'accuseront; car eux se sont convertis à la prédication de Jonas, et ici il y a mieux que Jonas."
,"33":"Si quelqu'un allume une lampe, il ne la mettra pas dans un trou ou sous un meuble mais sur le lampadaire, pour que ceux qui entrent voient la lumière."
,"34":"Ta lampe, c'est ton oeil. Si ton oeil est transparent, toute ta personne sera lumineuse. Mais s'il est mauvais, tu seras toi aussi dans l'obscurité."
,"35":"Fais donc attention à ce que ta lumière intérieure ne devienne pas ténèbres."
,"36":"Mais si ta personne toute entière devient lumineuse sans aucun recoin de ténèbres, elle rayonnera, tout comme lorsque la lampe jette un éclair sur toi."
,"37":"Lorsque Jésus termina de parler, un Pharisien l'invita à prendre le repas chez lui; il entra et se mit à table."
,"38":"Le Pharisien alors s'étonna en voyant qu'il ne s'était pas purifié les mains avant le repas."
,"39":"Mais le Seigneur lui dit: 'Voilà bien les Pharisiens! Vous purifiez l'extérieur de la coupe et du plat, mais votre intérieur à vous n'est que soif d'argent et méchanceté!"
,"40":"Insensés! Celui qui a fait l'extérieur, n'a-t-il pas fait également l'intérieur?"
,"41":"Mais pour vous il suffit de faire l'aumône et ensuite tout est pur!"
,"42":"Malheur à vous, Pharisiens! Vous payez la dîme jusque sur la menthe, les épices et toutes les infusions, mais vous passez à côté de la justice et de l'amour de Dieu! Là sont les oeuvres à faire, sans pour autant oublier le reste."
,"43":"Malheur à vous, Pharisiens, qui aimez les premières places dans la synagogue et les salutations sur la place!"
,"44":"Malheur à vous, vous êtes comme un tombeau qui n'est pas signalé; sans s'en apercevoir on a marché dessus!'"
,"45":"Un maître de la Loi lui répliqua: 'Maître, en parlant ainsi, tu nous insultes également!'"
,"46":"Jésus répondit: 'Malheur à vous aussi, maîtres de la Loi: vous faites porter aux gens des fardeaux impossibles, et vous, vous ne les touchez même pas du bout du doigt!"
,"47":"Malheur à vous qui élevez des monuments pour les prophètes que vos pères ont tués!"
,"48":"Vous reconnaissez donc ce qu'ils ont fait, mais vous prenez leur suite: après qu'ils les ont éliminés, vous pouvez construire!'"
,"49":"La Sagesse de Dieu a dit de même: 'Je leur enverrai des prophètes et des apôtres, mais ils en tueront plusieurs et ils persécuteront les autres."
,"50":"C'est pourquoi cette génération devra répondre de tout le sang des prophètes qui a été répandu depuis la création du monde,"
,"51":"depuis le sang d'Abel jusqu'au sang de Zacharie, assassiné entre l'autel et le Temple. Oui, je vous le dis: cette génération devra répondre!'"
,"52":"'Malheur à vous, maîtres de la Loi, car vous êtes partis avec la clé de la connaissance! Vous n'êtes pas entrés, et vous avez empêché les autres d'entrer!'"
,"53":"Quand Jésus sortit de là, les maîtres de la Loi et les Pharisiens commencèrent à lui en vouloir terriblement: ils essayaient de le faire parler sur des tas de choses,"
,"54":"afin de le prendre au piège par ses propres paroles."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Sur ces entrefaites une foule se rassembla, si nombreuse qu'on se marchait les uns sur les autres. Alors il se mit à leur dire, et tout d'abord à ses disciples: 'Gardez-vous bien du levain des Pharisiens: c'est l'hypocrisie.'"
,"2":"Il n'y a rien de caché qui ne doive être découvert, rien de secret qui ne doive être connu."
,"3":"Au contraire, tout ce que vous avez dit dans l'obscurité sera entendu en plein jour, et ce que vous avez répété à l'oreille dans les chambres sera crié sur les toits."
,"4":"Je vous le dis à vous, mes amis: Ne craignez pas ceux qui tuent le corps et ensuite ne peuvent rien faire de plus."
,"5":"Je veux vous indiquer celui qu'il vous faut craindre: craignez celui qui, après avoir tué, a encore le pouvoir de jeter dans la géhenne. Oui, je vous le dis, craignez-le!"
,"6":"Cinq moineaux valent deux monnaies tout juste, n'est-ce pas? Or pas un d'eux n'a été oublié de Dieu."
,"7":"Même les cheveux de votre tête ont été comptés! Ne craignez donc pas: vous valez tout de même plus qu'une volée de moineaux."
,"8":"Je vous le dis: Celui qui m'aura reconnu devant les hommes, le Fils de l'Homme à son tour le reconnaîtra devant les anges de Dieu."
,"9":"Mais si quelqu'un me renie devant les hommes, il sera renié en présence des anges de Dieu!"
,"10":"Si l'on a attaqué en paroles le Fils de l'Homme il y aura pardon; mais si l'on a blasphémé contre l'Esprit Saint, il n'y aura pas de pardon."
,"11":"Quand ils vous traîneront devant les conseils de synagogues, ou devant les pouvoirs publics et les autorités, ne vous inquiétez pas de ce que vous direz pour votre défense et comment vous le direz."
,"12":"Car l'Esprit Saint vous donnera à cette heure même ce que vous aurez à dire.'"
,"13":"Du milieu de la foule quelqu'un lui dit: 'Maître, dis à mon frère de partager avec moi l'héritage.'"
,"14":"Jésus lui répondit: 'Mon ami, qui m'a établi juge ou arbitre entre vous?'"
,"15":"Il ajouta: 'Soyez bien en garde contre tout désir de posséder, car même quand on a tout, ce n'est pas cela qui donne la vie.'"
,"16":"Et Jésus leur dit cette parabole: 'Il y avait un homme riche dont le domaine avait bien rapporté. "
,"17":"Il commence alors à se demander: Que vais-je faire? Je n'ai pas où engranger toute ma récolte."
,"18":"Et il se dit: 'Voilà ce que je vais faire: je mettrai par terre mes greniers et j'en bâtirai de plus grands, j'y entasserai tout mon blé, tous mes biens,"
,"19":"et je n'aurai plus qu'à me dire: Mon gaillard, tu as là des tas de choses en réserve pour beaucoup d'années; repose-toi, mange, bois et fais la fête!'"
,"20":"Mais Dieu lui dit: 'Tu es fou! Cette nuit-même on va te réclamer ta vie, qui va recueillir ce que tu as préparé?'"
,"21":"Cela vaut pour quiconque cherche à se faire des réserves, au lieu d'accumuler pour Dieu.'"
,"22":"Jésus s'adressa alors à ses disciples: 'Je vous le dis, ne vous tourmentez pas pour votre vie avec des questions de nourriture, ni pour votre corps avec des questions de vêtement."
,"23":"Voyez que la vie est plus que la nourriture et le corps plus que le vêtement."
,"24":"Observez les corbeaux: ils ne sèment pas, ils ne moissonnent pas, ils n'ont ni cave ni grenier et Dieu les nourrit. Il vous traitera tout de même mieux que les oiseaux!"
,"25":"Qui d'entre vous à force de s'inquiéter, pourra prolonger sa vie d'une coudée?"
,"26":"Et si la moindre chose vous dépasse, pourquoi vous inquiéter du reste?"
,"27":"Observez les lys: ils ne filent pas, ils ne tissent pas. Mais je vous dis que Salomon dans toute sa gloire n'était pas habillé comme l'un d'eux."
,"28":"Si Dieu revêt ainsi la plante sauvage qui aujourd'hui se dresse mais demain sera jetée au four, combien plus le fera-t-il pour vous! Vous avez bien peu la foi!"
,"29":"Ne vous tracassez pas pour ce que vous mangerez et boirez, laissez vos soucis."
,"30":"C'est bien là ce qui donne du tracas aux nations de ce monde, mais votre Père sait que vous en avez besoin."
,"31":"Tracassez-vous donc pour son Royaume, et cela vous sera donné en plus."
,"32":"N'aie pas peur, tout petit troupeau: car il a plu à votre Père de vous donner le Royaume!"
,"33":"Vendez vos biens et donnez-les en aumônes! Faites-vous dans les cieux des bourses qui résistent au temps et des réserves qui ne s'épuisent pas: là, point de place pour le voleur qui dérobe, ni pour la mite qui détruit!"
,"34":"Et là où est ton trésor, là aussi sera ton coeur."
,"35":"Soyez prêts, la ceinture bouclée, avec vos lampes allumées!"
,"36":"Soyez comme des gens qui attendent leur maître: il va rentrer des noces et l'on s'apprête à lui ouvrir aussitôt qu'il sera là et frappera."
,"37":"Heureux ces serviteurs que le Seigneur à son retour trouvera éveillés! En vérité, je vous le dis, c'est lui qui se mettra le tablier; il les fera passer à table et les servira l'un après l'autre."
,"38":"Et si c'est tard le soir quand il arrive et les trouve ainsi, ou même passé minuit, heureux ces serviteurs!"
,"39":"Si le maître de la maison savait à quelle heure viendra le voleur, vous comprenez bien qu'il resterait éveillé et ne le laisserait pas perforer sa maison."
,"40":"De même soyez prêts, car le Fils de l'Homme vient à l'heure que vous ne savez pas.'"
,"41":"Pierre lui dit: 'Seigneur, est-ce pour nous que tu dis cette parabole, ou bien pour tous?'"
,"42":"Le Seigneur lui répondit: 'Imaginez un intendant, digne de confiance et capable. Son seigneur lui a confié la responsabilité de ses serviteurs, et c'est lui qui leur donne les rations de blé en temps voulu."
,"43":"Heureux ce serviteur que son seigneur surprend tout occupé à son travail!"
,"44":"Je vous l'affirme, il lui mettra entre les mains tout ce qui lui appartient."
,"45":"Mais le serviteur peut-être pensera: 'Mon seigneur va rentrer tard.' Si alors il commence à frapper serviteurs et servantes, s'il mange, boit et s'enivre,"
,"46":"son seigneur arrivera au jour et à l'heure que ce serviteur ne pensait pas; il lui enlèvera sa charge et l'enverra chez ceux dont on se méfie."
,"47":"Ce serviteur connaissait la volonté de son seigneur; s'il n'a rien préparé, s'il n'a pas respecté ses ordres, il recevra le maximum de coups."
,"48":"Mais si c'est un autre qui a fait sans le savoir de quoi se faire battre, il n'en recevra pas trop. On sera plus exigeant si l'on a donné plus, on demandera davantage à qui on aura beaucoup confié."
,"49":"Je suis venu jeter le feu sur la terre, et comme je voudrais qu'il soit déjà allumé!"
,"50":"Mais je dois passer par un baptême, et quelle angoisse tant que ce n'est pas fait!"
,"51":"Pensez-vous que je sois venu mettre la paix sur la terre? Non, je vous le dis, mais la division."
,"52":"Car désormais, même une famille de cinq personnes sera divisée: trois contre deux, et deux contre trois."
,"53":"Le père s'opposera au fils et le fils au père; la mère à sa fille et la fille à sa mère; la belle-mère à l'épouse et l'épouse à sa belle-mère!'"
,"54":"Jésus dit encore aux foules: 'Quand vous voyez le ciel couvert à l'ouest, vous dites aussitôt: Voilà la pluie! et cela ne manque pas."
,"55":"Et quand le vent du sud se lève, vous dites: Il fera chaud!, et c'est ce qui arrive."
,"56":"Gens superficiels! Vous savez reconnaître la physionomie de la terre et du ciel, mais vous n'êtes pas capables d'identifier le temps présent!"
,"57":"Serez-vous incapables de juger par vous-mêmes ce qui est juste?"
,"58":"Lorsque tu vas avec ton adversaire devant les autorités, essaie de t'arranger avec lui en chemin; sinon il te traînera devant le juge, le juge te livrera à la police et le policier te jettera en prison."
,"59":"Je te le dis, tu ne sortiras pas de là tant que tu n'auras pas restitué le dernier centime!'"
}`)
	CurrentBook.AddChapter(13, `{
"1":"C'est alors qu'on mit Jésus au courant d'un massacre de Galiléens: Pilate avait fait couler leur sang là-même où ils sacrifiaient leurs victimes."
,"2":"Jésus alors leur dit: 'Croyez-vous que ces Galiléens étaient plus pécheurs que tous les autres Galiléens pour avoir eu ce sort?"
,"3":"Non, je vous le dis; mais si vous ne vous convertissez pas, vous périrez tous pareillement!"
,"4":"Et les dix-huit personnes de Siloé sur qui la tour est tombée, et qui ont été tuées, étaient-elles plus coupables que tous les autres habitants de Jérusalem?"
,"5":"Non, je vous le dis; mais si vous ne vous convertissez pas, vous périrez tous pareillement!'"
,"6":"Jésus leur dit cette parabole: 'Un homme avait un figuier planté dans sa vigne; il vint pour y chercher du fruit et il n'en trouva pas."
,"7":"il dit alors à celui qui soignait la vigne: Voilà trois ans que je viens chercher des fruits sur ce figuier, et je n'en trouve pas. Coupe-le donc, il ne fait qu'épuiser la terre!"
,"8":"Mais l'autre répondit: Maître, laisse-le encore cette année, je piocherai tout autour et je mettrai du fumier."
,"9":"Peut-être après cela donnera-t-il du fruit; sinon, tu le couperas.'"
,"10":"Un jour de sabbat, Jésus était en train d'enseigner dans une synagogue"
,"11":"lorsqu'arriva une femme toute courbée; un esprit la tenait malade depuis déjà dix-huit ans et elle était totalement incapable de se redresser."
,"12":"Dès que Jésus la voit, il l'interpelle: 'Femme, te voici délivrée de ton infirmité!'"
,"13":"Jésus lui impose les mains, et aussitôt elle se redresse, rendant gloire à Dieu."
,"14":"Mais le chef de la synagogue intervient, scandalisé, car Jésus l'a guérie un jour de sabbat, et il dit à la foule: 'Il y a six jours pour travailler; venez ces jours-là pour vous faire guérir, mais pas le jour du sabbat!'"
,"15":"Le Seigneur lui répond en ces termes: 'Comme vous êtes faux! Chacun de vous ne détache-t-il pas de la mangeoire son boeuf ou son âne, même le jour du sabbat, pour le conduire à l'abreuvoir?"
,"16":"Et vous avez là une fille d'Abraham que Satan avait liée voici dix-huit ans: le sabbat n'était-il pas justement le jour pour la délier de son mal?'"
,"17":"Après ces paroles de Jésus, ses adversaires ne savaient plus que dire, mais tout le public était en joie pour tant de merveilles qu'on lui voyait faire."
,"18":"Il disait donc: 'A quoi comparer le Royaume de Dieu, quelle image puis-je en donner?"
,"19":"Il est tout comme la graine de moutarde qu'un homme a prise pour la semer dans son jardin; elle a grandi et elle est devenue un arbre, si bien que les oiseaux du ciel se sont abrités dans ses branches.'"
,"20":"De nouveau Jésus leur dit: 'Quelle image puis-je donner du Royaume de Dieu?"
,"21":"Il est tout comme le levain qu'une femme prend et enfouit dans trois mesures de farine jusqu'à ce que tout soit levé.'"
,"22":"Jésus faisait route vers Jérusalem, et il continuait d'enseigner tout en traversant villes et villages."
,"23":"Quelqu'un lui dit: 'Seigneur, est-ce vrai que peu de gens seront sauvés?',Il répondit: "
,"24":"'Efforcez-vous d'entrer par la porte étroite car, je vous le dis, beaucoup chercheront à entrer et ne pourront pas."
,"25":"Quand le maître de maison se sera levé pour fermer la porte, vous serez là dehors et vous appellerez à la porte: 'Seigneur, ouvre-nous donc!' Mais lui vous répondra: 'Je ne sais pas d'où vous êtes.'"
,"26":"Alors vous saurez dire: 'Nous avons mangé et bu avec toi, tu as enseigné sur nos places!'"
,"27":"Mais lui dira: 'Je ne sais pas d'où vous êtes: éloignez-vous de moi, vous qui travaillez pour le mal."
,"28":"Alors il y aura pleurs et grincements de dents, lorsque vous verrez Abraham, Isaac et Jacob avec tous les prophètes dans le Royaume de Dieu, et vous pendant ce temps, mis à la porte!"
,"29":"Et d'autres viendront de l'orient et de l'occident, du nord et du midi pour s'installer à la table dans le Royaume de Dieu."
,"30":"Quelle surprise: certains qui étaient parmi les derniers se retrouvent premiers, et d'autres qui étaient premiers sont les derniers!'"
,"31":"A ce moment plusieurs Pharisiens s'approchèrent et lui dirent: 'Ne reste pas ici, poursuis ta route, car Hérode cherche à te tuer!'"
,"32":"Il leur répondit: 'Allez dire à ce renard: 'Aujourd'hui et demain je chasse les démons et je fais des guérisons; c'est au troisième jour que j'arrive à ma fin.'"
,"33":"Mais je dois poursuivre mon chemin aujourd'hui, demain et le jour suivant, car un prophète ne peut pas mourir ailleurs qu'à Jérusalem!"
,"34":"Jérusalem! Jérusalem! Tu assassines les prophètes et reçois à coups de pierre ceux qui te sont envoyés! Combien de fois ai-je voulu rassembler tes enfants, comme l'oiseau couvre ses petits de ses ailes; mais vous n'avez pas voulu."
,"35":"Vous vous retrouverez seuls avec votre Maison. Oui, je vous l'affirme, vous ne me verrez plus jusqu'au temps où vous direz: Béni soit celui qui vient au nom du Seigneur! '"
}`)
	CurrentBook.AddChapter(14, `{
"1":"Un jour de sabbat Jésus se rendit chez un personnage important des Pharisiens pour y prendre le repas; tous étaient là et l'observaient."
,"2":"Or il y avait là devant lui un homme atteint d'hydropysie."
,"3":"Jésus pose alors la question aux maîtres de la Loi et aux Pharisiens: 'Oui ou non, est-il permis de guérir un jour de sabbat?'"
,"4":"Ils gardent le silence. Jésus prend donc soin de l'infirme, le guérit et le renvoie."
,"5":"Puis il leur dit: 'Si votre fils ou votre boeuf tombe dans un puits un jour de sabbat, lequel d'entre vous ne l'en retirera pas aussitôt?'"
,"6":"Et à cela ils n'avaient rien à répondre."
,"7":"Jésus avait vu comment les invités cherchaient les premières places. Il dit à leur adresse:"
,"8":"'Lorsque quelqu'un t'invite à des noces, ne te précipite pas à la première place, car il a peut-être invité quelqu'un de plus important que toi."
,"9":"Ne vois-tu pas que celui qui vous a invités tous les deux vienne te dire: Cède-lui la place? Tu devrais alors te glisser tout honteux à la dernière place."
,"10":"Si l'on t'invite, va te mettre à la dernière place; lorsque celui qui t'a invité fera son tour, il te dira: Mon ami, avance plus haut! Et ce sera un honneur pour toi devant tous les invités."
,"11":"Car celui qui s'élève sera abaissé, et celui qui s'abaisse sera élevé.'"
,"12":"Jésus dit encore à celui qui l'avait invité: 'Lorsque tu prépares un déjeuner ou un dîner, n'invite pas tes amis, ni tes frères, ni tes proches, ni de riches voisins; ils t'inviteraient à leur tour et tu aurais là ta récompense."
,"13":"Mais quand tu organises un festin, invite les pauvres, les estropiés, les boiteux et les aveugles."
,"14":"Heureux seras-tu s'ils n'ont pas les moyens de te le rendre, car on te le rendra lors de la résurrection des justes.'"
,"15":"En entendant parler Jésus, un des convives lui dit: 'Heureux celui qui prendra part au banquet dans le Royaume de Dieu!'"
,"16":"Jésus lui répondit: 'Un homme avait préparé un grand dîner, avec beaucoup d'invités."
,"17":"Quand vint l'heure du dîner, il envoya son serviteur pour dire aux invités: Venez, tout est prêt!"
,"18":"Mais tous, comme un seul homme, commencèrent à s'excuser. Le premier lui fait dire: J'ai acheté un champ, il faut absolument que j'aille le voir. Tu voudras bien m'excuser."
,"19":"Un autre dit: J'ai acheté cinq paires de boeufs et je pars les essayer. Tu voudras bien m'excuser."
,"20":"Un autre encore dit: Je viens de me marier, c'est pourquoi je ne viens pas."
,"21":"Le serviteur revint et fit le rapport à son maître. Alors le maître de maison se mit en colère et dit à son serviteur: 'Va tout de suite sur les places, parcours les rues de la ville; tu amèneras ici les pauvres, les estropiés, les aveugles et les boiteux.'"
,"22":"Le serviteur revint lui dire: 'Seigneur, on a fait ce que tu as commandé, mais il y a encore de la place.'"
,"23":"Le maître dit au serviteur: 'Va voir aux sorties de la ville, du côté des baraquements, et oblige les gens à entrer pour que ma maison soit pleine."
,"24":"Mais ces messieurs que j'avais invités, je vous dis que pas un d'eux ne goûtera de mon festin.'"
,"25":"Comme une foule nombreuse faisait route avec Jésus, il se tourna vers eux pour leur dire:"
,"26":"'Si quelqu'un vient à moi sans se détacher de son père, de sa mère, de sa femme, ses enfants, ses frères, ses soeurs, et même de sa propre personne, il ne peut pas être mon disciple."
,"27":"Celui qui ne marche pas à ma suite en portant sa croix ne peut pas être mon disciple."
,"28":"Si l'un d'entre vous pense à se bâtir une tour, ne va-t-il pas d'abord s'asseoir pour calculer la dépense et voir s'il ira jusqu'au bout?"
,"29":"Car s'il pose les fondations et n'est pas capable de terminer, tous ceux qui le verront se moqueront de lui:"
,"30":"'Il a commencé à bâtir et il n'a pas été capable de terminer!'"
,"31":"Si un roi part en guerre contre un autre roi, ne va-t-il pas d'abord s'asseoir et voir s'il peut avec dix mille hommes affronter l'autre qui en amène vingt mille contre lui."
,"32":"Sinon, quand l'autre est encore loin, il envoie une ambassade pour parler de paix."
,"33":"C'est pareil pour vous: si on ne renonce pas à tous ses biens, on ne peut être mon disciple.'"
,"34":"'Le sel est bon; mais si le sel perd son mordant, comment va-t-on le lui redonner?"
,"35":"Il n'est plus bon, ni pour la terre, ni pour le fumier, il faut le jeter dehors! Qui a des oreilles pour entendre, qu'il entende!'"
}`)
	CurrentBook.AddChapter(15, `{
"1":"On voyait tous les collecteurs de l'impôt et les pécheurs s'approcher de Jésus pour l'écouter."
,"2":"Les Pharisiens et les maîtres de la Loi s'en plaignaient: 'Cet homme, disaient-ils, fait bon accueil aux pécheurs et mange avec eux!'"
,"3":"Aussi Jésus dit-il à leur intention cette parabole:"
,"4":"'Imaginez que l'un d'entre vous possède cent brebis, et il en a perdu une. Est-ce qu'il ne va pas laisser les quatre-vingt-dix-neuf autres dans la campagne, et courir après celle qui s'est perdue jusqu'à ce qu'il la retrouve?"
,"5":"Quand il l'a retrouvée, il la met tout joyeux sur ses épaules et,"
,"6":"rentré chez lui, il rassemble amis et voisins et leur dit: Partagez ma joie, car j'ai retrouvé ma brebis perdue!"
,"7":"Je vous le dis: Il y aura plus de joie dans le ciel pour un pécheur qui se repent que pour quatre-vingt-dix-neuf justes qui n'ont pas besoin de se repentir.'"
,"8":"Si une femme a dix pièces d'argent, et elle en perd une, ne va-t-elle pas allumer une lampe, balayer la maison et chercher soigneusement jusqu'à ce qu'elle la trouve?"
,"9":"Et quand elle l'a retrouvée, elle rassemble ses amies et voisines et leur dit: 'Partagez ma joie, car j'ai retrouvé la pièce que j'avais perdue!'"
,"10":"De même, je vous le dis, on est tout joyeux chez les anges de Dieu pour un seul pécheur qui se repent.'"
,"11":"Jésus dit encore: 'Un homme avait deux fils."
,"12":"Le plus jeune dit à son père: 'Père, donne-moi la part du domaine qui me revient.' Et le père leur partagea son bien."
,"13":"Le plus jeune fils ramassa tout et partit peu après pour un pays lointain où il dépensa son héritage dans une vie de désordres."
,"14":"Quand il eut tout dépensé, une grande famine s'abattit sur ce pays et il commença à manquer de tout."
,"15":"Il alla donc se mettre au service d'un des habitants du pays qui l'envoya dans ses champs pour garder les cochons."
,"16":"Là il aurait bien voulu se remplir le ventre des caroubes que mangeaient les cochons, mais à lui, personne ne lui donnait rien."
,"17":"Il rentra alors en lui-même: 'Combien d'ouvriers de mon père, se dit-il, ont du pain plus qu'il n'en faut, et moi ici je meurs de faim."
,"18":"Je vais me lever, retourner vers mon père, et je lui dirai: Père, j'ai péché contre le Ciel et devant toi."
,"19":"Je ne suis plus digne d'être appelé ton fils, mais prends-moi comme l'un de tes ouvriers.'"
,"20":"Il se mit donc en route et retourna chez son père. Quand il était encore loin, son père l'aperçut et fut pris de pitié; il courut se jeter à son cou et l'embrassa tendrement. "
,"21":"Le fils alors lui dit: 'Père, j'ai péché contre le Ciel et devant toi, je ne suis plus digne d'être appelé ton fils.'"
,"22":"Mais le père dit à ses serviteurs: 'Apportez vite la plus belle tunique et habillez-le, mettez-lui un anneau au doigt et des chaussures aux pieds."
,"23":"Allez chercher le veau gras et tuez-le, car il nous faut manger et faire la fête:"
,"24":"mon fils que voici était mort et il est revenu à la vie, il était perdu et il est retrouvé.' Et ils commencèrent à faire la fête."
,"25":"Le fils aîné était aux champs, mais il finit par rentrer. Comme il approchait de la maison, il entendit la musique et les danses."
,"26":"Il appela l'un des garçons et lui demanda ce qui se passait."
,"27":"L'autre lui répondit: 'C'est ton frère qui est arrivé et ton père a tué le veau gras car il l'a retrouvé en bonne santé.'"
,"28":"Il se mit en colère. Comme il refusait d'entrer, son père sortit pour l'en prier."
,"29":"Mais il répondit à son père: 'Voilà tant d'années que je te sers sans avoir jamais désobéi à un seul de tes ordres, et à moi tu ne m'as jamais donné un chevreau pour faire la fête avec mes amis."
,"30":"Mais lorsque revient ton fils que voilà, celui qui a mangé toute ta fortune avec les prostituées, tu fais tuer pour lui le veau gras!'"
,"31":"Le père lui dit: Toi, mon enfant, tu es toujours avec moi et tout ce qui est à moi est à toi."
,"32":"C'est maintenant qu'il fallait faire la fête et se réjouir, car ton frère que voilà était mort et il est revenu à la vie; il était perdu et il est retrouvé!'"
}`)
	CurrentBook.AddChapter(16, `{
"1":"Jésus dit encore aux disciples: 'Quelqu'un de riche avait un intendant, et on vint lui rapporter que l'intendant dissipait ses biens."
,"2":"Il l'appella et lui dit: 'Qu'est-ce que j'entends dire de toi? Donne-moi les comptes de ta gestion, car tu ne peux pas continuer de gérer mes biens.'"
,"3":"L'intendant se dit en lui-même: 'Que vais-je faire, si mon maître me retire la gestion? Bêcher la terre? Je n'en ai pas la force. Mendier? J'en aurais honte."
,"4":"Eh bien, je sais ce que je vais faire: il y aura des gens pour m'accueillir chez eux quand j'aurai été renvoyé de mon poste.'"
,"5":"Il appelle donc un à un ceux qui doivent de l'argent à son maître. Il dit au premier: 'Combien dois-tu à mon maître?'"
,"6":"Celui-ci répond: 'Cent barils d'huile.' L'intendant lui dit: 'Prends ton reçu, assieds-toi et écris vite: cinquante.'"
,"7":"Il dit à un autre: 'Et toi, combien dois-tu?' Celui-là répond: 'Cent mesures de blé.' L'intendant lui dit: Prends ton reçu et écris: 'Quatre-vingts.'"
,"8":"Le maître ne put qu'admirer cet intendant malhonnête, car il avait agi en homme sage. Oui, les fils de ce monde tirent plus de profit de leurs semblables que ne font les enfants de lumière."
,"9":"Et moi je vous dis: Faites-vous des amis avec ce maudit argent, et quand il viendra à vous manquer, eux vous accueilleront dans les demeures éternelles."
,"10":"Celui qui est digne de confiance dans de petites choses le sera pour de plus grandes; celui qui est malhonnête pour de petites choses, le sera également pour de plus grandes."
,"11":"Donc, si on ne peut compter sur vous pour ce maudit argent, qui vous confiera les vrais biens?"
,"12":"Si on ne peut compter sur vous pour des choses extérieures, qui vous donnera ce qui est vraiment vôtre?"
,"13":"Un serviteur ne peut pas rester à servir deux maîtres; ou bien il détestera l'un et aimera l'autre, ou bien il soignera le premier et se moquera de l'autre. Vous ne pouvez pas servir Dieu et le Dieu-Argent.'"
,"14":"Les Pharisiens aimaient l'argent; quand ils entendaient tout cela, ils se moquaient de lui."
,"15":"Mais Jésus leur dit: 'Vous, vous jouez les justes aux yeux des hommes, mais Dieu connaît votre coeur: ce qui s'élève haut chez les humains, Dieu l'a en horreur.','"
,"16":"La Loi et les Prophètes vont jusqu'à Jean. Depuis, c'est l'annonce du Royaume de Dieu, et chacun fait effort pour l'atteindre."
,"17":"Pas un seul détail de la Loi ne tombera: il serait plus facile que passent le ciel et la terre."
,"18":"Celui qui renvoie sa femme et en épouse une autre, est un adultère. Et celui qui épouse une femme renvoyée par son mari est aussi un adultère.'"
,"19":"'Il y avait un homme riche qui s'habillait de pourpre et de lin fin et mangeait royalement tous les jours."
,"20":"Un pauvre du nom de Lazare, tout couvert d'ulcères, était allongé à côté de sa porte."
,"21":"Il aurait bien voulu se nourrir de ce qui tombait de la table du riche; même les chiens venaient lécher ses ulcères."
,"22":"Or le pauvre mourut et les anges l'emportèrent jusque dans le repli du manteau d'Abraham. Le riche aussi mourut et il eut un enterrement."
,"23":"Comme il était au supplice dans le séjour des morts, il leva les yeux et aperçut de loin Abraham avec Lazare auprès de lui."
,"24":"Alors il se mit à crier: 'Père Abraham, aie pitié de moi et envoie-moi Lazare! Qu'il trempe dans l'eau le bout de son doigt et qu'il vienne me rafraîchir la langue, car je suis au supplice dans cette flamme.'"
,"25":"Abraham répondit: 'Mon enfant, souviens-toi que pendant ta vie tu as reçu toutes tes bonnes choses, et Lazare, lui, bien des maux. Maintenant il est ici consolé et toi torturé."
,"26":"De plus, vois ce chaos formidable entre nous et vous: ceux qui voudraient passer d'ici vers vous ne le peuvent pas, et de même on ne peut traverser de là-bas vers nous.'"
,"27":"L'autre reprit: 'Dans ce cas, père, envoie-le chez mes parents,"
,"28":"chez mes cinq frères; qu'il leur apporte son témoignage pour qu'ils ne viennent pas eux aussi dans ce lieu de tortures.'"
,"29":"Abraham répondit: 'Ils ont Moïse et les prophètes, qu'ils les écoutent!'"
,"30":"L'autre lui dit: 'Ils ne le feront pas, père Abraham, mais si un mort allait les trouver, ils se repentiraient!'"
,"31":"Abraham répondit: 'S'ils n'écoutent pas Moïse, et les prophètes, même avec la résurrection d'un mort on ne les convaincrait pas.'"
}`)
	CurrentBook.AddChapter(17, `{
"1":"Jésus dit à ses disciples: 'Il est impossible qu'il n'y ait pas de scandales, mais malheur à celui par qui il arrive."
,"2":"Pour lui ce serait préférable qu'on le jette à la mer avec une pierre de moulin attachée à son cou, plutôt que de scandaliser un des petits que voilà."
,"3":"Surveillez-vous de très près!,Si ton frère pèche contre toi, reprends-le, et s'il regrette, pardonne-lui. "
,"4":"S'il pèche contre toi sept fois le jour et que sept fois il revienne vers toi en disant: 'Je regrette', tu lui pardonneras.'"
,"5":"Les apôtres dirent alors au Seigneur: 'Donne-nous un peu plus la foi!'"
,"6":"Le Seigneur répondit: 'Si vous avez un peu la foi, gros comme une graine de moutarde, vous direz à cet arbre: Arrache-toi et plante-toi dans la mer, et il vous obéira."
,"7":"Lorsque votre serviteur a labouré ou gardé le troupeau, et qu'il revient des champs, lequel d'entre vous lui dira: 'Allons, viens te reposer!'"
,"8":"Vous lui direz sûrement: 'Prépare-moi à dîner. Boucle ta ceinture et sers-moi, que je puisse manger et boire, ensuite tu mangeras et tu boiras.'"
,"9":"Et quand il aura fait ce qu'on lui a commandé, qui d'entre vous lui en saura gré?"
,"10":"Cela vaut pour vous: lorsque vous aurez fait tout ce qui vous a été commandé, dites: Nous ne sommes que de la main d'oeuvre, nous avons fait ce que nous devions faire.'"
,"11":"Comme Jésus faisait route vers Jérusalem, il arriva aux frontières de la Samarie et de la Galilée."
,"12":"Il entrait dans un village quand dix lépreux vinrent à sa rencontre; se tenant à distance,"
,"13":"ils lui crièrent: 'Jésus, Maître, aie pitié de nous!'"
,"14":"Voyant cela, il leur dit: 'Allez vous montrer aux prêtres.' Et pendant qu'ils y allaient ils furent guéris."
,"15":"Se voyant guéri, l'un d'eux revint, rendant gloire à Dieu à haute voix."
,"16":"Il tomba le visage contre terre aux pieds de Jésus et il le remercia. Or lui était un Samaritain."
,"17":"Alors Jésus demanda: 'Les dix n'ont-ils pas été guéris? Où sont les neuf autres?"
,"18":"Il n'y a donc eu que cet étranger pour revenir et rendre gloire à Dieu?'"
,"19":"Jésus lui dit: 'Relève-toi et va ton chemin, ta foi t'a sauvé.'"
,"20":"Les Pharisiens le questionnaient: 'Quand viendra le règne de Dieu?' Il leur répondit: 'La venue du Royaume de Dieu ne fait pas l'objet d'un constat."
,"21":"On ne va pas dire: Il est ici! Il est là! Et voyez, le Royaume de Dieu est au milieu de vous.'"
,"22":"Jésus dit aux disciples: 'Des jours viendront où vous voudrez voir une manifestation du Fils de l'Homme, et vous n'en verrez pas."
,"23":"On vous dira: Il est ici! Il est là! N'y allez pas, n'y courez pas!"
,"24":"Tout comme la déchirure de l'éclair projette sa lumière d'un bout du ciel à l'autre, ainsi en sera-t-il du Fils de l'Homme quand viendra son jour."
,"25":"Mais il faut d'abord qu'il souffre beaucoup et qu'il soit rejeté par cette génération."
,"26":"Voyez ce qui est arrivé au temps de Noé: ce sera pareil pour la manifestation du Fils de l'Homme."
,"27":"Les gens mangeaient, ils buvaient, hommes et femmes se mariaient... jusqu'au jour où Noé entra dans l'arche; alors vint le cataclysme qui les fit périr tous."
,"28":"Voyez encore ce qui s'est passé avec Lot: on mangeait et buvait, on achetait, on vendait, on plantait, on bâtissait..."
,"29":"Mais le jour où Lot sortit de Sodome, ce fut du haut du ciel un déluge de feu et de soufre qui les fit tous périr."
,"30":"Ce sera pareil le jour où le Fils de l'Homme se manifestera."
,"31":"Si l'on est alors sur la terrasse, ce ne sera pas le jour pour redescendre et prendre ses affaires dans sa maison. Et si quelqu'un est aux champs, qu'il ne regarde pas en arrière!"
,"32":"Rappelez-vous la femme de Lot!"
,"33":"Celui qui cherchera à sauver sa vie la perdra, celui qui la sacrifiera la fera renaître."
,"34":"Cette nuit-là, je vous le dis, deux personnes seront côte à côte sur un même lit, l'un sera pris et l'autre laissé."
,"35":"Et si deux femmes sont à moudre ensemble, l'une sera prise et l'autre laissée.'"
,"37":"Les disciples lui disent: 'Où donc, Seigneur?' Il leur répond: 'Là où est le corps, là se rassemblent les vautours.'"
}`)
	CurrentBook.AddChapter(18, `{
"1":"Il leur raconta cette parabole pour dire qu'il faut prier sans cesse et ne pas se décourager:"
,"2":"'Il y avait dans une ville un juge qui ne craignait pas Dieu et se moquait des gens."
,"3":"Dans cette même ville il y avait une veuve qui venait lui dire: 'Rend la sentence contre mon adversaire.'"
,"4":"Tout un temps il refusa; puis il se dit: C'est vrai que je ne crains pas Dieu et que je n'ai rien à faire des gens,"
,"5":"mais cette veuve me dérange à un tel point que je vais lui faire justice; sinon elle finira par me casser la tête.'"
,"6":"Le Seigneur ajouta: 'Ecoutez bien ce qu'a dit ce juge très peu juste."
,"7":"Dieu ne fera-t-il pas justice à ses élus s'ils crient vers lui jour et nuit alors qu'il les fait attendre!"
,"8":"Je vous le dis: Il leur fera justice, et vite. Mais quand viendra le Fils de l'Homme, trouvera-t-il encore la foi sur la terre?'"
,"9":"Jésus dit cette autre parabole pour certains qui se flattaient d'être des gens bien et regardaient avec mépris le reste des hommes:"
,"10":"'Deux hommes étaient montés au Temple pour prier, l'un était un Pharisien, et l'autre un publicain."
,"11":"Le Pharisien se tenait debout, et il priait ainsi en lui-même: O Dieu, je te rends grâce parce que je ne suis pas comme le reste des hommes, rapaces, injustes, adultères, ou même comme ce publicain."
,"12":"Je jeûne deux fois par semaine et je paie la dîme de tous mes revenus."
,"13":"Le publicain, lui, se tenait à distance: il n'osait même pas lever les yeux vers le ciel, mais il se frappait la poitrine et disait: O Dieu, aie pitié du pécheur que je suis!"
,"14":"Je vous le dis: Celui-ci était en grâce de Dieu quand il est descendu chez lui, mais pas l'autre! Car celui qui s'élève sera humilié, et celui qui s'humilie sera élevé.'"
,"15":"On lui présentait jusqu'à des bébés pour qu'il les touche; voyant cela, les disciples sermonnaient tout ce monde."
,"16":"Jésus alors les fait approcher et il dit: 'Laissez les enfants venir à moi, ne les empêchez pas! Sachez que le Royaume de Dieu est pour ceux qui leur ressemblent."
,"17":"En vérité, je vous le dis, celui qui n'accueille pas le Royaume de Dieu comme un petit enfant n'y entrera pas.'"
,"18":"Un chef interrogea Jésus: 'Bon maître, que me faut-il faire si je veux recevoir la vie éternelle?'"
,"19":"Jésus lui répondit: 'Pourquoi m'appelles-tu bon? Dieu seul est bon, et personne d'autre."
,"20":"Tu connais les commandements: Ne commets pas l'adultère. Ne tue pas. Ne vole pas. Ne porte pas de faux témoignage. Respecte ton père et ta mère '."
,"21":"L'autre reprit: 'J'ai observé tout cela depuis ma jeunesse.'"
,"22":"Alors Jésus lui dit: 'Quelque chose te manque encore: vends tout ce que tu as et distribue-le à des pauvres, tu auras ainsi un trésor dans le ciel; puis reviens et suis-moi.'"
,"23":"En entendant ces paroles l'homme devint tout triste, car il était fort riche."
,"24":"Voyant cela, Jésus dit: 'Comme il est difficile à ceux qui ont de l'argent d'entrer dans le Royaume de Dieu!"
,"25":"Il est plus facile pour un chameau de passer par le trou d'une aiguille que pour un riche d'entrer dans le Royaume de Dieu.'"
,"26":"Ceux qui l'entendaient lui dirent alors: 'Qui donc peut être sauvé?'"
,"27":"Jésus répond: 'Ce qui est impossible aux hommes est possible pour Dieu.'"
,"28":"Pierre lui dit: 'Nous, nous avons tout quitté pour te suivre.'"
,"29":"Jésus répondit: 'En vérité, je vous le dis, personne ne laissera maison, femme, frères, parents ou enfants à cause du Royaume de Dieu,"
,"30":"sans recevoir beaucoup plus dès à présent et, dans le monde à venir, la vie éternelle.'"
,"31":"Jésus prit avec lui les Douze et leur dit: 'Voici que nous montons à Jérusalem et tout ce qui a été écrit par les prophètes à propos du Fils de l'Homme va s'accomplir."
,"32":"Il sera livré aux païens, humilié, insulté, couvert de crachats,"
,"33":"et après l'avoir fouetté, ils le tueront. Mais le troisième jour il ressuscitera.'"
,"34":"Eux ne comprenaient rien de tout cela; ce langage leur paraissait mystérieux et ils ne voyaient pas ce qu'il voulait leur dire."
,"35":"Jésus approchait de Jéricho, et il y avait un mendiant assis sur le bord du chemin. C'était un aveugle."
,"36":"Quand il entendit passer la foule, il demanda ce que c'était"
,"37":"et on le mit au courant: 'C'est Jésus de Nazareth qui passe!'"
,"38":"Il se mit alors à crier: 'Jésus, fils de David, aie pitié de moi!'"
,"39":"Ceux qui étaient en tête voulurent le faire taire, mais lui criait de plus belle: 'Fils de David, aie pitié de moi!'"
,"40":"Jésus s'arrêta et ordonna de le lui amener. Quand il fut tout près, Jésus l'interrogea:"
,"41":"'Que veux-tu que je fasse pour toi?' L'aveugle répondit: 'Seigneur, que la vue me revienne!'"
,"42":"Jésus lui dit: 'Recouvre la vue, ta foi t'a sauvé!'"
,"43":"Aussitôt il recouvra la vue, et il suivait Jésus en glorifiant Dieu. Voyant cela, tout le peuple proclama la louange de Dieu."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Jésus était entré dans Jéricho et traversait la ville."
,"2":"Or il y avait là un homme du nom de Zachée, un homme fort riche qui était chef des collecteurs de l'impôt."
,"3":"Il voulait absolument voir qui était Jésus, mais il ne le pouvait pas car il était de petite taille et il y avait beaucoup de monde."
,"4":"Il courut donc en avant, là où il devait passer, et il monta sur un sycomore afin de le voir."
,"5":"Quand Jésus arriva à cet endroit, il leva les yeux et lui dit: 'Zachée, dépêche-toi de descendre, car c'est chez toi que je dois m'arrêter aujourd'hui.'"
,"6":"Zachée aussitôt s'empressa de descendre, et c'est avec grande joie qu'il le reçut."
,"7":"Voyant cela, tous murmuraient et l'on disait: 'Il s'est arrêté chez un pécheur de bonne condition!'"
,"8":"Mais Zachée faisait le pas et disait au Seigneur: 'Je vais donner aux pauvres la moitié de mes biens, Seigneur, et si j'ai extorqué quelque chose à quelqu'un, je vais rendre quatre fois plus.'"
,"9":"Jésus dit alors, pensant à lui: 'Aujourd'hui le salut est entré dans cette maison; n'est-il pas lui aussi fils d'Abraham?"
,"10":"Le Fils de l'Homme est venu chercher et sauver ce qui était perdu."
,"11":"Comme Jésus approchait de Jérusalem, il dit cette autre parabole car ses auditeurs étaient convaincus que le Royaume de Dieu allait se manifester maintenant."
,"12":"Il leur dit: 'Un homme de grande famille partit dans un pays lointain pour y recevoir le pouvoir royal et ensuite revenir."
,"13":"Il appela dix de ses serviteurs et leur confia dix mines, dix sacs d'argent, en leur disant: 'Faites-les fructifier jusqu'à mon retour.'"
,"14":"Comme ses concitoyens le détestaient, ils envoyèrent une ambassade derrière lui avec ce message: 'Nous ne voulons pas de celui-là comme roi.'"
,"15":"Il revint pourtant, ayant reçu le pouvoir royal, et il fit appeler les serviteurs auxquels il avait confié l'argent pour voir comment chacun d'eux l'avait fait valoir."
,"16":"Le premier arrive et dit: 'Seigneur, ta mine a rapporté dix autres mines!'"
,"17":"Le roi lui répond: 'Très bien, tu es un bon serviteur et tu t'es montré digne de confiance dans cette petite affaire! A cause de cela tu auras dix villes sous ta dépendance.'"
,"18":"Le deuxième vient à son tour et dit: 'Ta mine, seigneur, en a produit cinq autres.'"
,"19":"Le roi lui dit: 'Toi, tu auras cinq villes sous ta dépendance.'"
,"20":"Et puis arrive un autre qui dit: 'Seigneur, voici ta mine! Je l'avais mise de côté dans un linge."
,"21":"Car j'avais peur de toi, je sais que tu es un homme exigeant, tu prends là où tu n'as rien engagé, et tu moissonnes là où tu n'as pas semé.'"
,"22":"Le roi lui dit: 'Mauvais serviteur, je te juge sur tes propres paroles. Tu me connaissais comme un homme exigeant qui prend là où il n'a rien engagé et moissonne là où il n'a pas semé."
,"23":"Pourquoi n'as-tu pas déposé mon argent à la banque? A mon retour je l'aurais retiré avec les intérêts.'"
,"24":"Puis, se tournant vers ceux qui sont là, il leur dit: 'Prenez-lui la mine, et donnez-la à celui qui en a dix.'"
,"25":"Ils répondent: 'Seigneur, il a déjà dix mines!'"
,"26":"'Mais oui! on donnera à celui qui a, mais à celui qui n'a pas, même ce qu'il a lui sera enlevé."
,"27":"Maintenant, amenez ici mes ennemis, ceux qui ne voulaient pas que je règne sur eux, et égorgez-les devant moi.'"
,"28":"Ayant dit cela, Jésus prit la tête du groupe et commença la montée vers Jérusalem."
,"29":"Quand il approcha de Bethphagé et de Béthanie, au mont dit des Oliviers,"
,"30":"il envoya deux des disciples en leur disant: 'Allez jusqu'au village que vous voyez en face; à l'entrée vous trouverez un ânon attaché que personne n'a jamais monté. Détachez-le et amenez-le."
,"31":"Si quelqu'un vous demande pourquoi vous le détachez, vous répondrez simplement: Le Seigneur en a besoin.'"
,"32":"Les envoyés partirent et trouvèrent tout comme il leur avait dit."
,"33":"Au moment où ils détachaient l'ânon, les maîtres leur dirent: 'Pourquoi détachez-vous l'ânon?'"
,"34":"Ils répondirent: 'Le Seigneur en a besoin.'"
,"35":"Ils amenèrent à Jésus l'ânon, jetèrent sur lui leurs manteaux et firent monter Jésus."
,"36":"A mesure qu'il avançait, les gens étendaient leurs manteaux sur le chemin."
,"37":"Comme il approchait déjà de la descente du Mont des Oliviers, toute la foule des disciples manifesta sa joie: ils se mirent à louer Dieu à pleine voix pour tous les miracles qu'ils avaient vus."
,"38":"Ils disaient: ' Béni soit ce roi qui vient au nom du Seigneur! Paix dans le ciel et gloire au plus haut des cieux!'"
,"39":"Dans la foule quelques Pharisiens lui dirent: 'Reprends tes disciples, Maître!'"
,"40":"Il leur répondit: 'Je vous le dis: s'ils se taisent, les pierres crieront.'"
,"41":"Lorsque déjà on approchait il aperçut la ville"
,"42":"et prononça une lamentation sur elle. Il dit: 'Si toi aussi en ce jour tu pouvais reconnaître les chemins de la paix! Mais désormais ils seront cachés à tes yeux."
,"43":"Des jours viendront auxquels tu n'échapperas pas, où tes ennemis t'entoureront de tranchées, t'enfermeront, te presseront de toutes parts"
,"44":"et t'écraseront avec tes enfants au milieu de toi. Il ne restera pas de toi pierre sur pierre, parce que tu n'as pas reconnu le temps où tu étais visitée.'"
,"45":"Alors Jésus entra dans le Temple. Il commença à jeter dehors les vendeurs"
,"46":"en leur disant: 'Il est écrit: Ma maison sera une maison de prière. Mais vous, vous en avez fait une caverne de brigands!'"
,"47":"Chaque jour il était là dans le Temple et il enseignait. Les grands prêtres et les maîtres de la Loi voulaient sa perte, et de même les chefs du peuple,"
,"48":"mais ils ne savaient que faire car tout le peuple l'écoutait, suspendu à ses lèvres."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Un certain jour, tandis qu'il enseignait le peuple dans le Temple et lui donnait la Bonne Nouvelle, les grands prêtres et les maîtres de la Loi se présentèrent avec les Anciens du peuple."
,"2":"Ils lui demandèrent: 'Dis-nous: de quelle autorité fais-tu tout cela? Qui t'a chargé de le faire?'"
,"3":"Il leur répondit: 'Moi aussi je vais vous poser une question et vous me répondrez."
,"4":"Quand Jean s'est mis à baptiser, était-ce une initiative du Ciel, ou simplement humaine?'"
,"5":"Ils firent entre eux ces réflexions: 'Si nous disons que c'était chose du Ciel, il dira: Pourquoi n'avez-vous pas cru en lui?"
,"6":"Et si nous disons que c'était une affaire humaine, tout le peuple va nous lapider, car ils sont convaincus que Jean était un prophète.'"
,"7":"Aussi répondirent-ils qu'ils ne savaient pas."
,"8":"Et Jésus leur dit: 'Je ne vous dirai pas non plus de quelle autorité je fais tout cela.'"
,"9":"Jésus se mit à raconter au peuple cette parabole: 'Un homme avait planté une vigne et l'avait louée à des fermiers, puis il était parti pour un long séjour à l'étranger."
,"10":"Le moment venu il envoie un serviteur auprès des fermiers pour qu'ils lui remettent une part du produit de la vigne. Mais les vignerons le battent et le renvoient les mains vides."
,"11":"De nouveau, il envoie un autre serviteur; les vignerons le battent, se moquent de lui et le renvoient les mains vides."
,"12":"Lui recommence: il envoie un troisième serviteur; mais on le met à mal et on le jette dehors."
,"13":"Le seigneur de la vigne se dit: 'Que puis-je faire? Je vais envoyer mon fils que j'aime, lui au moins ils le respecteront.'"
,"14":"Mais en le voyant, les fermiers font ce calcul: 'C'est lui l'héritier; tuons-le, et l'héritage sera à nous.'"
,"15":"Ils le jettent donc hors de la vigne et le tuent. Comment le seigneur de la vigne va-t-il agir avec eux? "
,"16":"Il viendra, il fera périr ces fermiers et donnera la vigne à d'autres.',En entendant cela ils dirent: 'Ne parlons pas de malheur!' "
,"17":"Alors, les yeux dans les yeux, Jésus leur dit: 'Que signifie cette Ecriture: La pierre rejetée par les bâtisseurs est devenue la pierre d'angle?"
,"18":"Quiconque tombera sur cette pierre se brisera, et si elle tombe sur quelqu'un, elle le réduira en poussière.'"
,"19":"Les maîtres de la Loi et les grands prêtres avaient grande envie de mettre la main sur lui, mais ils craignaient le peuple; ils avaient bien compris que cette parabole de Jésus était pour eux."
,"20":"C'est ainsi qu'ils préparent un piège: ils envoient des mouchards qui jouent les gens bien intentionnés, afin de le prendre en défaut dans ses paroles et de pouvoir ainsi le remettre aux mains du gouverneur et à son tribunal."
,"21":"Ils lui posent cette question: 'Maître, nous savons que tu es droit dans tout ce que tu dis et enseignes. Tu ne cherches pas à te faire bien voir des gens, mais tu enseignes selon la vérité le chemin de Dieu."
,"22":"Nous est-il permis de verser l'impôt à César, ou non?"
,"23":"Jésus a compris leur astuce; il leur dit:"
,"24":"'Montrez-moi un denier. De qui sont l'image et l'inscription?' Ils répondent: 'De César.'"
,"25":"Et lui leur dit: 'Rendez donc à César ce qui est de César et à Dieu ce qui est de Dieu!'"
,"26":"Avec cela il leur fut impossible de prendre en défaut ses paroles devant le peuple. Ils furent très surpris de sa réponse et gardèrent le silence."
,"27":"Alors s'approchèrent quelques Saducéens - ces gens-là nient qu'il y ait une résurrection -"
,"28":"et ils lui posèrent cette question: 'Maître, Moïse nous a mis ceci dans l'Ecriture: Si un homme marié meurt sans enfants, son frère doit prendre la veuve et donner ainsi une descendance à celui qui est mort. "
,"29":"Or il y avait sept frères. Le premier s'est marié et il est mort sans enfants."
,"30":"Le deuxième,"
,"31":"puis le troisième ont pris la veuve, et de même les autres jusqu'au septième: ils sont tous morts sans laisser d'enfant."
,"32":"Ensuite la femme est morte."
,"33":"S'il y a résurrection, duquel d'entre eux sera-t-elle la femme, puisqu'elle l'a été des sept?'"
,"34":"Jésus leur dit: 'Les enfants de ce monde prennent mari ou femme;"
,"35":"mais ceux qu'on a trouvés dignes d'avoir part à l'autre monde et à la résurrection des morts, ne prennent pas mari ou femme."
,"36":"Par ailleurs ils ne peuvent plus mourir, mais ils sont comme des anges. Eux aussi sont fils de Dieu, puisqu'ils sont nés de la résurrection."
,"37":"Quant au fait que les morts ressuscitent, Moïse lui-même l'a insinué dans le passage du Buisson Ardent, là où il appelle le Seigneur: Dieu d'Abraham, Dieu d'Isaac et Dieu de Jacob."
,"38":"Il n'est pas un Dieu des morts, mais bien des vivants: tous vivent pour lui.'"
,"39":"A ce moment quelques maîtres de la Loi prirent la parole et dirent: 'Maître, tu as bien parlé.'"
,"40":"Mais après cette réplique, plus personne n'osait l'interroger."
,"41":"A son tour Jésus leur demanda: 'Comment peut-on dire que le Messie est fils de David?"
,"42":"David lui-même dit, au livre des Psaumes: Le Seigneur a dit à mon Seigneur: Siège à ma droite"
,"43":"et vois comment je fais de tes ennemis ton marchepied."
,"44":"David l'appelle 'Seigneur', et on voudrait qu'il soit son fils?'"
,"45":"Il dit à ses disciples, quand tout le peuple écoutait:"
,"46":"'Méfiez-vous des maîtres de la Loi qui se plaisent à circuler en longues robes, qui aiment les salutations sur les places publiques, les premiers fauteuils dans les synagogues et les premières places dans les festins."
,"47":"Ils s'introduisent avec leurs longues prières, et ensuite ils dévorent les maisons des veuves. Leur condamnation sera terrible.'"
}`)
	CurrentBook.AddChapter(21, `{
"1":"Levant les yeux, Jésus vit des riches qui déposaient leurs offrandes dans le trésor;"
,"2":"il vit ensuite une pauvre veuve qui jetait deux petites pièces."
,"3":"Et il dit: 'En vérité, je vous le dis, cette veuve sans ressources a mis plus que tous les autres:"
,"4":"car tous ceux-là ont donné de ce qui ne leur manquait pas, mais elle, n'ayant rien, elle a mis tout ce qu'elle avait pour vivre.'"
,"5":"Comme certains faisaient l'éloge du Temple avec ses belles pierres et les ex-voto qui en faisaient l'ornement,"
,"6":"Jésus leur dit: 'Vous voyez tout cela? Le jour viendra où il n'en restera pas pierre sur pierre: tout sera détruit.'"
,"7":"On lui posa alors cette question: 'Maître, quand cela arrivera-t-il? A quel signe reconnaîtra-t-on que cela va se réaliser?'"
,"8":"Il répondit: 'Ne vous laissez pas égarer lorsque plusieurs revendiqueront mon titre et diront: 'C'est moi, l'heure est arrivée!' Ne les suivez pas!"
,"9":"Quand vous entendrez parler de guerres et de soulèvements, ne cédez pas à la panique: cela doit arriver d'abord, mais la fin ne sera pas de si tôt.'"
,"10":"Il leur dit encore: 'On verra des soulèvements: peuple contre peuple et nation contre nation."
,"11":"Il y aura de grands tremblements de terre et, par endroits, des pestes et des famines. On verra des choses effrayantes et de grands signes venant du ciel."
,"12":"Mais avant tout cela, ils mettront la main sur vous, ils vous persécuteront, ils vous enverront aux conseils de synagogues et à leurs prisons. Ils vous traîneront devant les rois et les gouverneurs à cause de mon nom,"
,"13":"et ce sera pour vous l'occasion de témoigner."
,"14":"Mettez-vous bien dans la tête que vous n'avez pas à vous soucier d'avance de votre défense;"
,"15":"je vous donnerai, moi, une parole et une sagesse auxquelles tous vos adversaires ne pourront, ni résister, ni répondre."
,"16":"Vous serez livrés par vos propres parents, vos frères, vos proches et vos amis, et on fera mourir plusieurs d'entre vous:"
,"17":"rien qu'à cause de mon nom vous serez haïs de tous."
,"18":"Mais pas un cheveu de votre tête ne se perdra:"
,"19":"tenez bon, et vous sauverez vos âmes."
,"20":"Lorsque vous verrez Jérusalem encerclée par des armées, sachez que sa ruine est proche."
,"21":"Alors, que les habitants de Judée fuient à la montagne et que ceux qui demeurent en ville partent au loin, que ceux des campagnes n'y rentrent pas."
,"22":"Car ce seront les jours du règlement de comptes, et tout ce qui est écrit s'accomplira."
,"23":"Ce sera grande malchance pour une femme que d'être enceinte ou d'allaiter en ces jours-là. Le pays connaîtra une grande détresse et ce peuple sera livré à la Colère."
,"24":"Ils tomberont au fil de l'épée, ils seront déportés dans toutes les nations, et Jérusalem sera foulée aux pieds par les nations, jusqu'à ce que les temps des nations arrivent à leur terme.'"
,"25":"'Puis il y aura des signes dans le soleil, la lune et les étoiles, et sur la terre ce sera l'angoisse pour les nations effrayées par le fracas de la mer et des flots."
,"26":"Les gens s'évanouiront de frayeur dans l'attente de ce qui va tomber sur toute la terre habitée, car l'univers entier sera ébranlé."
,"27":"C'est alors qu'ils verront le Fils de l'Homme venir dans une nuée avec puissance et grande gloire.'"
,"28":"'Dès que commenceront ces choses, redressez-vous et relevez la tête: votre délivrance est proche!'"
,"29":"Et Jésus leur dit cette parabole: 'Observez le figuier et les autres arbres:"
,"30":"lorsque vous les voyez qui bourgeonnent, vous savez que l'été est proche."
,"31":"De même, quand vous verrez ces choses arriver, sachez que le Royaume de Dieu est tout proche."
,"32":"En vérité, je vous le dis, cette génération ne passera pas que tout cela n'arrive."
,"33":"Le ciel et la terre passeront, mes paroles ne passeront pas.'"
,"34":"'Veillez sur vous-mêmes: il ne faudrait pas que la bonne chère, les excès de vin ou les soucis matériels vous endorment, et que ce jour tombe sur vous à l'improviste."
,"35":"Car ce sera comme un piège qui se referme; il surprendra tout le monde, où que ce soit sur la terre."
,"36":"Veillez et priez sans cesse afin d'être assez forts pour échapper à tout ce qui doit arriver, et de pouvoir vous tenir debout devant le Fils de l'Homme.'"
,"37":"Durant le jour Jésus était dans le Temple où il enseignait, puis il sortait et passait la nuit en plein air sur le mont dit des Oliviers."
,"38":"Dès qu'il faisait jour, tout le peuple venait à lui dans le Temple pour l'écouter."
}`)
	CurrentBook.AddChapter(22, `{
"1":"La fête des Pains sans Levain, qu'on appelle la Pâque, était proche;"
,"2":"aussi les grands prêtres se demandaient-ils avec les maîtres de la Loi, comment faire pour le supprimer, car ils avaient peur du peuple."
,"3":"C'est alors que Satan entra en Judas, surnommé Iscariote, qui était du groupe des Douze:"
,"4":"il alla s'entretenir avec les grands prêtres et la police du Temple sur les moyens de le leur livrer."
,"5":"Ils en furent tout heureux et lui offrirent une somme d'argent."
,"6":"Judas accepta, et dès lors il chercha une occasion de le livrer en l'absence de la foule."
,"7":"Arriva le jour des Pains sans Levain où l'on doit sacrifier la Pâque."
,"8":"Jésus envoya Pierre et Jean et leur dit: 'Allez nous faire les préparatifs pour que nous mangions la Pâque.'"
,"9":"Ils lui demandèrent: 'Où veux-tu que nous la préparions?'"
,"10":"Jésus alors leur dit: 'Lorsque vous entrerez en ville, un homme portant une cruche d'eau viendra à votre rencontre; suivez-le jusqu'à la maison où il entrera."
,"11":"Vous direz au propriétaire de cette maison: Le Maître te fait dire: 'Où est la salle où je mangerai la Pâque avec mes disciples?'"
,"12":"Il vous montrera à l'étage une grande pièce aménagée et vous y ferez les préparatifs.'"
,"13":"Ils partirent donc et trouvèrent comme Jésus leur avait dit; ils firent là les préparatifs de la Pâque."
,"14":"L'heure venue, Jésus s'installe pour le repas ainsi que les apôtres."
,"15":"Il leur dit: 'Je désirais beaucoup manger cette Pâque avec vous avant de souffrir."
,"16":"Car, je vous le dis, je ne la mangerai plus avant qu'elle ne soit accomplie dans le Royaume de Dieu.'"
,"17":"On lui passe une coupe; il rend grâces et dit: 'Prenez-la et faites-la passer entre vous."
,"18":"Je vous le dis: je ne boirai plus désormais du produit de la vigne jusqu'à la venue du Royaume de Dieu.'"
,"19":"Il prend un pain, il rend grâces, le partage et le leur donne en disant: 'Ceci est mon corps, livré pour vous: faites cela en mémoire de moi.'"
,"20":"Il fait de même pour la coupe après le dîner; il dit: 'Cette coupe, c'est la nouvelle alliance grâce à mon sang répandu pour vous."
,"21":"Sachez-le, celui qui va me livrer est à cette table avec moi."
,"22":"Pour le Fils de l'Homme, c'est le chemin qui déjà lui était assigné; mais quel malheur pour cet homme par qui il est livré!'"
,"23":"Alors ils commencèrent à se demander les uns aux autres lequel d'entre eux pourrait faire une telle chose."
,"24":"Une discussion surgit entre eux: lequel d'entre eux était le premier?"
,"25":"Jésus leur dit: 'Les rois des nations païennes se comportent avec elles en maîtres, et quand ils les écrasent, ils se font appeler bienfaiteurs."
,"26":"Ce ne sera pas pareil chez vous: le plus grand sera comme le dernier arrivé, et celui qui est à la tête, comme celui qui sert."
,"27":"Qui donc est le plus grand: celui qui est à table, ou celui qui sert? Celui qui est à table, bien sûr; pourtant je suis au milieu de vous comme celui qui sert."
,"28":"Vous êtes ceux qui ne m'ont pas abandonné dans mes épreuves."
,"29":"Aussi je fais pour vous comme mon Père a fait pour moi en me donnant la royauté:"
,"30":"vous mangerez et vous boirez à ma table dans mon Royaume, et vous siègerez sur des trônes pour gouverner les douze tribus d'Israël."
,"31":"Simon, Simon! Satan vous a réclamés pour vous secouer comme on fait pour le blé au tamis,"
,"32":"mais j'ai prié pour toi, pour que tu ne perdes pas la foi; et toi, lorsque tu seras revenu, affermis tes frères.'"
,"33":"Pierre lui dit: 'Seigneur, je suis prêt à te suivre en prison et jusqu'à la mort.'"
,"34":"Jésus lui répond: 'Je te le dis, Pierre: le coq ne chantera pas cette nuit avant que tu n'aies affirmé par trois fois que tu ne me connais pas.'"
,"35":"Jésus leur dit: 'Lorsque je vous ai envoyés sans bourse, ni sac, ni chaussures, quelque chose vous a-t-il manqué?' Ils répondent: 'Non.'"
,"36":"Alors il reprend: 'Mais maintenant, si quelqu'un a une bourse, qu'il la prenne, et de même celui qui a un sac, et que celui qui n'a pas d'épée vende son manteau pour en acheter une."
,"37":"Car, je vous le dis, il faut que s'accomplisse en ma personne cette Ecriture: on l'a mis au rang des malfaiteurs. De fait, ce qui me concerne touche à sa fin.'"
,"38":"Ils lui disent: 'Seigneur, il y a ici deux épées.' Et lui répond: 'C'est assez!'"
,"39":"Sortant de là, il se dirige selon son habitude vers le Mont des Oliviers et ses disciples le suivent."
,"40":"Arrivé en ce lieu il leur dit: 'Priez, pour ne pas être pris par la tentation.'"
,"41":"Puis il s'éloigne d'eux, à la distance d'un jet de pierre,"
,"42":"et fléchissant les genoux il fait cette prière: 'Père, si tu le veux, fais passer cette coupe loin de moi. Cependant, que ce ne soit pas ma volonté mais la tienne qui s'accomplisse.'"
,"43":"C'est alors que du ciel un ange lui apparaît, qui le réconforte."
,"44":"Jésus est entré en agonie et il prie plus intensément; sa sueur se change en gouttes de sang qui tombent à terre."
,"45":"Quand il se relève de sa prière et revient vers les disciples, il les trouve endormis, accablés de tristesse."
,"46":"Alors il leur dit: 'Vous dormez? Levez-vous donc et priez pour ne pas être pris par la tentation.'"
,"47":"Il parlait encore lorsqu'arriva une troupe avec, en tête, le dénommé Judas, l'un des Douze. Comme il s'approchait de Jésus pour l'embrasser,"
,"48":"Jésus lui dit: 'Judas, c'est donc par un baiser que tu livres le Fils de l'Homme?'"
,"49":"Ceux qui entouraient Jésus devinèrent ce qui allait se passer; ils dirent: 'Seigneur, allons-nous frapper de l'épée?'"
,"50":"L'un d'eux frappa le serviteur du Grand Prêtre et lui trancha l'oreille droite."
,"51":"Mais Jésus intervint avec ces mots: 'Restez-en là.' Puis il toucha l'oreille de cet homme et le guérit."
,"52":"Jésus dit alors à ceux qui étaient venus le surprendre, grands prêtres, gardes du Temple et Anciens: 'Vous êtes partis en expédition avec épées et gourdins, comme pour prendre un bandit;"
,"53":"pourquoi ne m'avez-vous pas arrêté lorsque, jour après jour, j'étais avec vous dans le Temple? Mais c'est votre heure lorsque règnent les ténèbres.'"
,"54":"Après s'être emparés de Jésus, ils l'emmenèrent et le firent entrer dans la maison du Grand Prêtre; Pierre les suivait à distance."
,"55":"Au milieu de la cour ils avaient allumé un feu autour duquel ils étaient assis, et Pierre vint s'asseoir au milieu d'eux."
,"56":"Comme il était là assis, à la clarté du feu, une jeune servante le dévisage et dit: 'Celui-ci était aussi avec lui!'"
,"57":"Pierre le nie: 'Femme, je ne le connais pas.'"
,"58":"Peu de temps après un autre le voit et dit: 'Toi aussi tu es du groupe.' Et Pierre de dire: 'Non, je n'en suis pas.'"
,"59":"Une heure à peu près s'écoule, et un autre revient à la charge: 'C'est exact, celui-ci aussi était avec lui. D'ailleurs, c'est un Galiléen!'"
,"60":"Et Pierre répond: 'Je ne sais pas ce que tu veux dire!',Il n'avait pas fini de parler que le coq chanta. "
,"61":"Le Seigneur se retourna et regarda Pierre; Pierre alors se rappela la parole du Seigneur qui lui avait dit: 'Aujourd'hui même, avant que le coq ne chante, tu m'auras renié trois fois.'"
,"62":"Il sortit au-dehors et pleura amèrement."
,"63":"Au même moment les hommes qui détenaient Jésus commencèrent à le tourner en ridicule et à le frapper."
,"64":"Ils lui avaient couvert le visage et ils lui demandaient: 'Fais le prophète: qui t'a frappé?'"
,"65":"Ils lui lançaient encore bien d'autres insultes."
,"66":"Au lever du jour se réunirent les Anciens du peuple, les grands prêtres et les maîtres de la Loi, et l'on amena Jésus devant leur Conseil, ou Sanhédrin."
,"67":"Là ils lui dirent: 'Es-tu le Messie? Réponds-nous!',Jésus leur répondit: 'Si je vous le dis vous ne croirez pas, "
,"68":"et si je vous interroge, vous ne répondrez pas."
,"69":"Mais désormais le Fils de l'Homme siégera à la droite de la Puissance divine.'"
,"70":"Ils lui dirent: 'Tu es donc le Fils de Dieu?' Il répondit: 'Vous venez de le dire: je le suis.'"
,"71":"Et eux de dire: 'Qu'avons-nous encore besoin de témoignages? Nous l'avons entendu nous-mêmes de sa bouche!'"
}`)
	CurrentBook.AddChapter(23, `{
"1":"Alors toute l'assemblée se leva. Ils amenèrent Jésus devant Pilate"
,"2":"et là ils commencèrent à l'accuser: 'Nous avons établi que cet homme sème le désordre dans notre nation; il interdit de payer l'impôt à César et se présente comme le roi-Messie.'"
,"3":"Pilate alors lui posa la question: 'Es-tu le roi des Juifs?' Jésus lui répondit: 'Tu le dis.'"
,"4":"Pilate déclara aux grands prêtres et à la foule: 'Je ne trouve chez cet homme aucun motif de condamnation.'"
,"5":"Mais ils insistèrent: 'Il enseigne à travers tout le pays des Juifs et il soulève le peuple; il a commencé en Galilée et il est venu jusqu'ici.'"
,"6":"Lorsque Pilate entend ces paroles, il demande si l'homme est Galiléen."
,"7":"Il apprend que c'est un sujet d'Hérode, et aussitôt il le renvoie à Hérode qui se trouve lui aussi à Jérusalem durant ces jours."
,"8":"Depuis longtemps Hérode désirait voir Jésus à cause de tout ce qu'on lui en disait. Il fut donc tout heureux de le voir car il espérait bien lui voir faire un miracle."
,"9":"Il lui posa beaucoup de questions. Mais Jésus ne répondit rien,"
,"10":"alors qu'en face de lui les grands prêtres et les maîtres de la Loi multipliaient les accusations graves."
,"11":"Hérode profita de lui pour amuser sa garde: ils lui passèrent un habit somptueux et le renvoyèrent ainsi à Pilate."
,"12":"Jusque là Hérode et Pilate étaient ennemis, mais à partir de ce jour ils devinrent amis."
,"13":"Pilate fit convoquer les grands prêtres, les chefs et le peuple;"
,"14":"il leur dit: 'Vous me l'avez présenté comme un meneur subversif, mais quand je l'ai interrogé devant vous, je ne lui ai trouvé aucun des délits dont vous l'accusez."
,"15":"Hérode non plus: voyez comment il nous le renvoie. Il est clair qu'il n'a rien commis qui mérite la mort,"
,"16":"aussi, après l'avoir corrigé, je le relâcherai.'"
,"17":"Car Pilate devait relâcher un prisonnier à l'occasion de la Pâque."
,"18":"Mais toute la foule se met à crier: 'Supprime-le; c'est Barabbas que tu dois nous relâcher.'"
,"19":"Ce dernier avait été jeté en prison à la suite d'une émeute et d'un meurtre commis dans la ville même."
,"20":"Pilate leur adressa encore une fois la parole, car il voulait relâcher Jésus,"
,"21":"mais les cris devinrent plus forts: 'Mets-le en croix, oui, en croix!'"
,"22":"Une troisième fois Pilate leur dit: 'Mais quel mal a-t-il donc fait? Je ne trouve rien en lui pour une condamnation à mort. Je le corrigerai donc et je le relâcherai.'"
,"23":"Mais eux n'arrêtaient plus de demander à grands cris qu'on le mette en croix, et leur vacarme allait en croissant."
,"24":"A la fin Pilate décida de satisfaire leur demande:"
,"25":"il relâcha celui qu'on avait jeté en prison pour émeute et meurtre, celui qu'ils réclamaient, et il sacrifia Jésus à leur bon plaisir."
,"26":"Comme ils l'emmenaient, ils arrêtèrent un certain Simon de Cyrène qui revenait des champs, et lui firent porter la croix derrière Jésus."
,"27":"Des gens du peuple en foule nombreuse le suivaient; les femmes se lamentaient et pleuraient sur lui."
,"28":"Jésus se retourna vers elles et leur dit: 'Filles de Jérusalem, ne pleurez pas sur moi! Pleurez plutôt sur vous-mêmes et sur vos enfants,"
,"29":"car les jours viennent où l'on dira: Heureuses les femmes stériles, heureuses celles qui n'ont pas mis au monde et n'ont pas allaité!"
,"30":"On en viendra à dire aux montagnes: Tombez sur nous! et aux collines: Couvrez-nous!"
,"31":"Car si l'on traite ainsi l'arbre vert, que fera-t-on de l'arbre sec?'"
,"32":"On emmenait également deux malfaiteurs pour être exécutés avec lui,"
,"33":"et quand on arriva au lieu-dit du Crâne, on le mit en croix ainsi que les malfaiteurs, l'un à sa droite et l'autre à gauche."
,"34":"(Jésus disait: 'Père, pardonne-leur, car ils ne savent ce qu'ils font.') Puis ils se partagèrent ses vêtement en les jouant aux dés."
,"35":"Le peuple restait à regarder. Quant aux chefs, ils ricanaient en disant: 'Il en a sauvé d'autres, qu'il se sauve lui-même s'il est le Messie de Dieu, l'Elu.'"
,"36":"Les soldats aussi le tournèrent en ridicule lorsqu'ils s'approchèrent pour lui présenter du vin acidulé;"
,"37":"ils lui disaient: 'Sauve-toi toi-même, si tu es le roi des Juifs.'"
,"38":"Car au-dessus de lui on avait placé un écriteau: 'Le roi des Juifs.'"
,"39":"Un des malfaiteurs crucifiés l'insultait: 'N'es-tu pas le Messie? Sauve-toi toi-même et nous avec toi.'"
,"40":"Mais l'autre le reprit sévèrement: 'N'as-tu donc pas la crainte de Dieu, toi qui subis la même condamnation?"
,"41":"Pour nous c'est justice: nous payons ce que nous avons fait; mais lui, il n'a commis aucun crime.'"
,"42":"Puis il dit: 'Jésus, souviens-toi de moi quand tu viendras dans ton Royaume.'"
,"43":"Jésus lui répondit: 'En vérité, je te le dis, aujourd'hui même tu seras avec moi dans le paradis.'"
,"44":"Il était environ midi, mais le soleil disparut et ce fut l'obscurité dans tout le pays jusqu'à trois heures;"
,"45":"au même moment le rideau du sanctuaire se déchirait par le milieu."
,"46":"Alors Jésus cria d'une voix forte: 'Père, entre tes mains je remets mon esprit.' Ayant dit cela, il rendit le dernier soupir."
,"47":"Quand le capitaine de service vit ce qui venait d'arriver, il rendit gloire à Dieu: 'En vérité, dit-il, cet homme était un juste.'"
,"48":"De même, à la vue de tout ce qui arrivait, la foule de ceux qui étaient venus pour voir s'en retournait en se frappant la poitrine."
,"49":"A quelque distance restaient les gens de connaissance, en particulier les femmes qui avaient accompagné Jésus depuis la Galilée et qui regardaient tout cela."
,"50":"Alors intervint un homme du nom de Joseph, un homme bon et droit qui était membre du Conseil"
,"51":"mais qui n'avait pas approuvé le projet des autres ni leurs actes. Il était d'Arimathie, une ville juive, et il attendait le Royaume de Dieu."
,"52":"Il alla donc trouver Pilate pour lui réclamer le corps de Jésus."
,"53":"Il le descendit de la croix, l'enveloppa dans un drap et le déposa dans une tombe taillée en plein roc où personne encore n'avait été déposé."
,"54":"C'était le jour de la préparation et l'étoile qui ouvre le sabbat commençait à briller."
,"55":"Les femmes qui étaient venues de Galilée avec Jésus ne s'étaient pas éloignées; elles virent de près la tombe et comment on déposait le corps."
,"56":"Rentrées chez elles elles préparèrent des aromates et de la myrrhe. Puis, durant le sabbat, elles restèrent tranquilles selon le commandement."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Le premier jour de la semaine, aux premières lueurs de l'aube, elles vont à la tombe emportant les aromates qu'elles ont préparés."
,"2":"C'est alors qu'elles font une découverte: la pierre a été roulée de devant la tombe."
,"3":"Elles y pénètrent et ne trouvent pas le corps du Seigneur Jésus."
,"4":"Et comme elles sont là, ne sachant que penser, deux hommes se présentent à elles en habits éblouissants."
,"5":"Saisies de crainte, elles baissent leur visage vers la terre; mais ils leur disent: 'Pourquoi chercher le Vivant parmi les morts?"
,"6":"Il n'est pas ici, il est ressuscité. Souvenez-vous de ce qu'il vous a dit quand il était encore en Galilée:"
,"7":"Il faut que le Fils de l'Homme soit livré aux mains d'hommes pécheurs, qu'il soit mis en croix et qu'il ressuscite le troisième jour.'"
,"8":"A ce moment elles se souvinrent de ces paroles."
,"9":"De retour de la tombe, elles racontèrent tout cela aux Onze et à tous les autres;"
,"10":"c'étaient Marie de Magdala, Jeanne, et Marie mère de Jacques. Les autres femmes qui étaient avec elles disaient la même chose aux apôtres,"
,"11":"mais ils ne les crurent pas: toute cette histoire leur paraissait pure fantaisie."
,"12":"Pierre cependant se lève, il court à la tombe, se penche et voit les linges, rien d'autre. Il rentre chez lui en se demandant ce qui a pu arriver."
,"13":"Ce même jour, deux d'entre eux se rendaient à un village du nom d'Emmaüs, éloigné de soixante stades de Jérusalem,"
,"14":"et ils parlaient entre eux de tous ces événements."
,"15":"Tandis qu'ils parlaient et discutaient entre eux, voici que Jésus lui-même s'approcha et fit route avec eux."
,"16":"Mais leurs yeux étaient empêchés de le reconnaître."
,"17":"Et voilà qu'il leur dit: 'Mais quelle est donc cette affaire dont vous discutez tout en marchant?' Ils s'arrêtent, l'air découragé,"
,"18":"et l'un d'eux nommé Cléopas lui répond: 'Tu es bien le seul homme de passage à Jérusalem à ignorer ce qui s'est passé ici ces derniers jours.'"
,"19":"Il leur dit: 'Quoi donc?' Ils répondent: 'Toute l'affaire de Jésus de Nazareth!,C'était un prophète puissant en oeuvres et en paroles: Dieu en est témoin, et tout le peuple également; "
,"20":"mais nos grands prêtres et nos chefs l'ont renié, ils l'ont condamné à mort et l'ont mis en croix."
,"21":"Et nous, nous pensions que c'était lui qui délivrerait Israël. Mais tout est fait et c'est déjà le troisième jour."
,"22":"C'est vrai que quelques femmes de notre groupe nous ont déroutés. Quand elles sont allées au tombeau à l'aube,"
,"23":"elles n'ont pas trouvé son corps; elles sont venues nous dire qu'elles ont eu une vision avec des anges qui disent qu'il est vivant."
,"24":"Certains des nôtres sont allés au tombeau et ont trouvé les choses comme les femmes avaient dit, mais lui, ils ne l'ont pas vu.'"
,"25":"Alors il leur dit: 'Hommes sans intelligence, coeurs lents à croire ce qu'ont dit les prophètes!"
,"26":"Le Messie ne devait-il pas souffrir pour entrer dans sa gloire?'"
,"27":"Et il leur fit l'interprétation de ce qui le concernait dans toutes les Ecritures, en commençant par Moïse et ensuite tous les prophètes."
,"28":"Lorsqu'ils approchèrent du village où ils se rendaient, il fit semblant d'aller plus loin."
,"29":"Mais ils firent pression sur lui: 'Reste avec nous, le soir tombe et déjà le jour baisse.' Il entra donc pour s'arrêter avec eux."
,"30":"Comme il était à table avec eux, il prit le pain, il le bénit et, après l'avoir rompu, il le leur donna."
,"31":"Alors leurs yeux s'ouvrirent et ils le reconnurent; mais lui déjà était devenu invisible à leurs yeux."
,"32":"Ils se disaient l'un à l'autre: 'Notre coeur n'était-il pas tout brûlant en nous quand il nous parlait sur le chemin et nous expliquait les Ecritures?'"
,"33":"A l'heure même ils se levèrent et retournèrent à Jérusalem où ils trouvèrent rassemblés les Onze et ceux de leur groupe."
,"34":"Ceux-ci leur dirent: 'En vérité le Seigneur est ressuscité, il est apparu à Simon.'"
,"35":"Et eux de leur côté commencèrent à raconter ce qui s'était passé sur le chemin, et comment ils l'avaient reconnu à la fraction du pain."
,"36":"Ils parlaient encore lorsque Jésus lui-même se trouva au milieu d'eux (et leur dit: 'Paix à vous!')"
,"37":"Il y eut un moment d'épouvante: saisis de peur, ils croyaient voir un esprit."
,"38":"Alors il leur dit: 'Pourquoi ce trouble, pourquoi de telles idées vous viennent-elles à l'esprit?"
,"39":"Voyez mes mains et mes pieds: oui, c'est moi. Touchez-moi et regardez: un esprit n'a ni chair ni os comme vous voyez que j'en ai.'"
,"40":"En disant cela il leur montra ses mains et ses pieds."
,"41":"Et comme, dans leur joie et leur étonnement, ils hésitaient encore à croire, il leur dit: 'Avez-vous ici quelque chose à manger?'"
,"42":"Alors ils lui donnent une part de poisson grillé (et une portion de miel),"
,"43":"il le prend et le mange devant eux."
,"44":"Jésus leur dit: 'Rappelez-vous mes paroles lorsque j'étais encore avec vous pour vous parler: il faut que s'accomplisse tout ce qui a été écrit à mon sujet dans la loi de Moïse, les Prophètes et les Psaumes.'"
,"45":"Alors il leur ouvrit l'intelligence pour qu'ils comprennent les Ecritures."
,"46":"Il leur dit: 'Vous voyez, c'était dans l'Ecriture: le Messie devait souffrir et ressusciter d'entre les morts le troisième jour."
,"47":"Et il faut ensuite que la conversion et le pardon des péchés soient proclamés en son nom à toutes les nations, en commençant par Jérusalem."
,"48":"De cela vous êtes témoins."
,"49":"De mon côté je vais envoyer sur vous ce que mon Père a promis; restez en ville jusqu'à ce que vous soyez revêtus de la puissance d'en haut.'"
,"50":"Jésus les conduisit jusque vers Béthanie. Là il éleva les mains et les bénit;"
,"51":"et tandis qu'il les bénissait il s'éloigna d'eux, (emporté dans le ciel."
,"52":"Ils se prosternèrent devant lui.) Puis ils revinrent à Jérusalem en grande joie,"
,"53":"et sans cesse ils étaient dans le Temple à louer Dieu."
}`)

}
func FR_LBDCC_LoadNEMCChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Commencement de la Bonne Nouvelle de Jésus Christ, Fils de Dieu."
,"2":"Il est écrit à ce sujet dans le prophète Isaïe: Voici que j'envoie mon messager devant toi pour te préparer le chemin."
,"3":"Une voix crie dans le désert: Préparez le chemin du Seigneur, aplanissez le sol devant lui."
,"4":"C'est ainsi que Jean se mit à baptiser dans le désert; il prêchait un baptême lié à un changement de vie, en vue d'obtenir le pardon des péchés."
,"5":"Tout le pays de Judée et tout le peuple de Jérusalem venaient à lui et se faisaient baptiser par lui dans la rivière du Jourdain, en même temps qu'ils confessaient leurs péchés."
,"6":"Jean avait un manteau en poils de chameau et portait un pagne de peau autour des reins. Il se nourrissait de sauterelles et de miel d'abeilles sauvages."
,"7":"Il disait bien clairement: 'Un plus fort que moi vient derrière moi et je ne suis pas digne de délier, en me baissant, les lacets de ses sandales."
,"8":"Je vous ai baptisés dans l'eau, mais lui vous baptisera dans l'Esprit Saint.'"
,"9":"En ces jours-là Jésus arriva de Nazareth en Galilée, et il fut baptisé par Jean dans le Jourdain."
,"10":"Aussitôt, comme il remontait de l'eau, il vit les Cieux entrouverts: l'Esprit descendait sur lui comme fait la colombe,"
,"11":"et du ciel venaient ces paroles: 'Tu es mon Fils, le Bien-Aimé, c'est en toi que je me complais.'"
,"12":"Aussitôt, l'Esprit le poussa au désert"
,"13":"et, pendant quarante jours, il y fut tenté par Satan. Il était avec les bêtes sauvages et les anges le servaient."
,"14":"Après l'arrestation de Jean, Jésus s'en alla en Galilée. Il proclamait la bonne nouvelle de Dieu"
,"15":"en ces termes: 'Les délais sont accomplis, le Règne de Dieu est là, convertissez-vous et croyez à la Bonne Nouvelle!'"
,"16":"Comme Jésus passait le long de la mer de Galilée, il y avait là Simon et André, le frère de Simon. Il les vit qui jetaient leurs filets dans la mer, car ils étaient pêcheurs."
,"17":"Jésus leur dit: 'Venez, suivez-moi! Je ferai de vous des pêcheurs d'hommes.'"
,"18":"Eux aussitôt laissèrent leurs filets et le suivirent."
,"19":"Un peu plus loin Jésus voit Jacques, fils de Zébédée, et Jean son frère; ils sont eux aussi dans leur barque, et ils arrangent leurs filets."
,"20":"Jésus les appelle; aussitôt ils laissent leur père Zébédée dans la barque avec les salariés, et ils commencent à le suivre."
,"21":"Voici qu'ils s'arrêtent à Capharnaüm. Dès ce moment Jésus commence à enseigner les jours de sabbat, lorsqu'il vient à la synagogue."
,"22":"Les gens étaient frappés de son enseignement, car il les enseignait avec autorité et non comme les maîtres de la Loi."
,"23":"Or il y avait là, dans leur synagogue, un homme habité par un esprit impur."
,"24":"Voici qu'il se met à crier: 'Que nous veux-tu, Jésus de Nazareth? Es-tu venu pour nous perdre? Je sais qui tu es: le Saint de Dieu!'"
,"25":"Jésus le menace et lui dit: 'Tais-toi! Sors de cet homme!'"
,"26":"L'esprit impur le secoue violemment, pousse un grand cri et sort de lui."
,"27":"Tous sont stupéfaits et se disent l'un à l'autre: 'Qu'est-ce que cela? C'est du nouveau, cette façon d'enseigner avec autorité. Il commande même aux esprits impurs et ils lui obéissent!'"
,"28":"Très rapidement sa renommée se répandit tout autour, à travers toute la Galilée."
,"29":"En sortant de la synagogue, il se rendit à la maison de Simon et André, avec Jacques et Jean."
,"30":"La belle-mère de Simon était au lit avec de la fièvre: tout de suite ils lui en parlent."
,"31":"Jésus s'approche et la soulève en la prenant par la main: la fièvre la quitte et elle commence à leur faire le service."
,"32":"Au soir, dès que le soleil fut couché, on commença de lui amener tous ceux qui souffraient de maladies ou de démons."
,"33":"La ville entière se pressait devant sa porte."
,"34":"Jésus guérit de nombreux malades, atteints de diverses maladies, et chassa de nombreux démons. Mais il ne laissait pas parler les démons, car ils l'avaient reconnu."
,"35":"Au petit matin, alors qu'il faisait encore nuit, Jésus se leva, sortit et s'en alla dans un lieu désert. Il y resta en prière."
,"36":"Simon et ses compagnons se mettent à sa recherche et, quand ils le trouvent, ils lui disent: 'Tout le monde te cherche.'"
,"38":"Il leur dit alors: 'Sortons d'ici, allons aux villages voisins pour que j'y prêche aussi; c'est pour cela que je suis sorti.'"
,"39":"Il alla donc prêcher dans leurs synagogues par toute la Galilée; il chassait aussi les démons."
,"40":"Un lépreux s'approche de lui avec des supplications et des génuflexions; il lui dit: 'Si tu veux, tu peux me purifier.'"
,"41":"Jésus est pris de compassion; il étend la main et le touche en lui disant: 'Je le veux, sois purifié!'"
,"42":"Aussitôt la lèpre le quitte, il est pur."
,"43":"Mais Jésus le sermonne et le met dehors"
,"44":"en lui disant: 'Surtout, n'en parle à personne; va simplement te montrer au prêtre et présente l'offrande pour ta purification, comme Moïse l'a ordonné: tu feras ainsi ta déclaration.'"
,"45":"L'homme n'était pas plus tôt sorti qu'il se mit à le crier partout et à répandre la nouvelle, si bien que Jésus ne pouvait plus se montrer dans une ville; il restait à l'écart dans des lieux déserts. Même ainsi on venait à lui de toutes parts."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Après quelque temps il revint à Capharnaüm. Quand on apprit qu'il était à la maison,"
,"2":"beaucoup de gens s'y retrouvèrent, au point qu'il n'y avait plus de place devant la porte. Et lui, il leur annonçait la Parole."
,"3":"Voici des gens qui arrivent et lui amènent un paralysé: ils sont quatre à le porter."
,"4":"Comme ils ne peuvent le lui présenter à cause de la foule, ils défont le toit là où il se trouve et, après avoir fait un trou, ils font descendre le brancard sur lequel le paralysé est étendu."
,"5":"Voyant leur foi, Jésus dit au paralysé: 'Mon fils, tes péchés te sont pardonnés.'"
,"6":"Quelques maîtres de la Loi sont là assis, et ils font intérieurement cette remarque:"
,"7":"'Comment peut-il parler ainsi? C'est un blasphème! Qui peut pardonner les péchés sinon Dieu?'"
,"8":"Mais Jésus sait déjà dans son esprit qu'ils se font en eux-mêmes ces réflexions. Aussi leur dit-il: 'Pourquoi ruminez-vous cela dans vos coeurs?"
,"9":"Quel est le plus facile: de dire au paralysé: 'Tes péchés te sont pardonnés', ou de dire: 'Lève-toi, prends ton brancard et marche'?"
,"10":"Eh bien, vous saurez que sur la terre le Fils de l'Homme a autorité pour remettre les péchés.'"
,"11":"Jésus dit alors au paralysé: 'Lève-toi, tu m'entends! prends ton brancard et va-t'en chez toi.'"
,"12":"L'homme se leva aussitôt, prit son brancard et sortit devant tout le monde; tous en étaient stupéfaits et glorifiaient Dieu en disant: 'Jamais nous n'avons vu chose pareille!'"
,"13":"De nouveau Jésus sortit sur le bord de mer; toute la foule venait à lui et il les enseignait."
,"14":"En passant il vit Lévi, fils d'Alphée, installé au poste de douane. Il lui dit: 'Suis-moi!' L'autre se leva et commença à le suivre."
,"15":"Comme il était à table dans la maison de Lévi, quelques collecteurs de l'impôt et autres pécheurs prirent place avec Jésus et ses disciples: il y en avait un certain nombre. Mais parmi ceux qui suivaient Jésus"
,"16":"il y avait aussi des maîtres de la Loi du groupe des Pharisiens. En le voyant manger avec des pécheurs et des collecteurs de l'impôt, ils dirent à ses disciples: 'Comment! Il mange avec les collecteurs de l'impôt et les pécheurs?'"
,"17":"Mais Jésus avait entendu; il leur dit: 'Ce ne sont pas les bien-portants qui ont besoin d'un médecin, mais les malades. Je ne suis pas venu, moi, pour appeler des justes mais des pécheurs.'"
,"18":"Les disciples de Jean et les Pharisiens étaient en train de jeûner, et voici qu'on vient demander à Jésus: 'Les disciples de Jean et ceux des Pharisiens jeûnent: pourquoi tes disciples ne jeûnent-ils pas?'"
,"19":"Jésus leur répond: 'Les compagnons du nouvel époux peuvent-ils jeûner pendant que l'époux est avec eux? Aussi longtemps qu'ils ont l'époux avec eux, ils ne peuvent pas jeûner."
,"20":"Le jour viendra où l'époux leur sera enlevé, alors ils jeûneront."
,"21":"On ne rapièce pas un vieux vêtement avec une pièce de tissu qui n'a jamais été lavé; autrement la pièce tire sur lui, le neuf emporte le vieux et la déchirure devient pire."
,"22":"Personne ne met du vin nouveau dans de vieilles outres; autrement le vin fait craquer les outres, et le vin comme les outres sont perdus. On met le vin nouveau dans des outres neuves!'"
,"23":"Or, un jour de sabbat, Jésus traversait des blés mûrs; chemin faisant ses disciples commencèrent à cueillir des épis."
,"24":"Les Pharisiens lui dirent: 'Regarde, pourquoi font-ils le jour du sabbat ce qui n'est pas permis?'"
,"25":"Jésus répondit: 'Vous n'avez donc jamais lu ce qu'a fait David un jour où c'était urgent, car il avait faim, lui et ses hommes."
,"26":"Il est entré dans la Maison de Dieu, au temps du prêtre Abiathar, et il a mangé le pain de l'offrande que nul n'a le droit de manger, sauf les prêtres; il en a donné de même à ses compagnons.'"
,"27":"Jésus leur disait: 'Le sabbat a été fait pour l'homme, et non l'homme pour le sabbat."
,"28":"Sachez que le Fils de l'Homme est Seigneur, même du sabbat.'"
}`)
	CurrentBook.AddChapter(3, `{
"1":"De nouveau Jésus entra dans une synagogue; il y avait là un homme à la main paralysée."
,"2":"Des gens l'observaient, se demandant s'il allait le guérir un jour de sabbat: ils étaient prêts à le dénoncer."
,"3":"Jésus dit à l'homme qui avait la main paralysée: 'Lève-toi et viens au milieu.'"
,"4":"Puis il leur dit: 'Qu'est-ce qui est permis le jour du sabbat, faire du bien ou faire du mal, sauver une vie ou la laisser perdre?',Eux se taisent. "
,"5":"Jésus les regarde l'un après l'autre avec colère, peiné de voir comme ils avaient la tête dure, puis il dit à l'homme: 'Etends la main.' Celui-ci l'étend, sa main est guérie."
,"6":"Mais alors les Pharisiens sortent, et ils tiennent conseil avec les Hérodiens pour voir comment se défaire de Jésus."
,"7":"Jésus s'éloigna avec ses disciples en direction de la mer. Un nombre impressionnant de Galiléens le suivit;"
,"8":"toute une foule vint à lui également de la Judée, de Jérusalem, de l'Idumée et d'au-delà du Jourdain, des environs de Tyr et de Sidon, car ils avaient appris tout ce qu'il faisait."
,"9":"Jésus demanda alors à ses disciples de tenir une barque à sa disposition pour ne pas être écrasé par la foule."
,"10":"En effet, il faisait tellement de guérisons que tous ceux qui souffraient de quelque mal se pressaient contre lui pour essayer de le toucher."
,"11":"Même les esprits impurs se laissaient tomber à ses pieds quand ils le voyaient; ils criaient: 'Tu es le Fils de Dieu!'"
,"12":"Mais il les menaçait sévèrement, car il ne voulait pas qu'ils le fassent reconnaître."
,"13":"Jésus gravit alors la montagne; il appela à lui ceux qu'il voulut et ils allèrent le rejoindre."
,"14":"C'est ainsi qu'il créa les 'Douze' (qu'il nomma aussi apôtres) pour être avec lui; il voulait les envoyer prêcher"
,"15":"et qu'ils aient autorité pour faire sortir les démons."
,"16":"Il établit donc les Douze: Simon, à qui il imposa le nom de Pierre;"
,"17":"Jacques fils de Zébédée, et Jean, frère de Jacques, - il leur imposa le nom de Boanerguès, ce qui veut dire: Fils du tonnerre -;"
,"18":"André, Philippe, Barthélemy, Matthieu, Thomas, Jacques fils d'Alphée, Thaddée,"
,"19":"Simon le Cananéen, et Judas Iscariote, celui-là même qui allait le livrer."
,"20":"Jésus revint à la maison. De nouveau on s'y retrouva en grand nombre, si bien qu'ils ne pouvaient même plus manger."
,"21":"En apprenant cela, les siens vinrent pour le reprendre, car ils disaient: 'Il a perdu la tête!'"
,"22":"Au même moment les maîtres de la Loi qui étaient descendus de Jérusalem affirmaient: 'Il est possédé par Béelzéboul; c'est le chef des démons qui lui permet de chasser les démons!'"
,"23":"Il les fit donc approcher et commença à raisonner avec des comparaisons: 'Comment Satan peut-il faire sortir Satan?"
,"24":"Si l'on est divisé à l'intérieur d'un royaume, ce royaume ne peut tenir."
,"25":"Si l'on est divisé à l'intérieur d'une maison, cette maison ne tiendra pas."
,"26":"Et si Satan s'en prend à lui-même, s'il est divisé, il ne tiendra pas, il est fini."
,"27":"Personne ne peut entrer dans la maison du Fort pour piller ses affaires, sans avoir d'abord ligoté le Fort. Alors seulement on pillera sa maison."
,"28":"En vérité, je vous dis, tout peut être pardonné aux hommes, quel que soit le nombre de leurs péchés et de leurs blasphèmes;"
,"29":"mais pour qui blasphème contre l'Esprit Saint, il n'y aura jamais de pardon: car il est coupable d'une faute qui ne s'en ira jamais.'"
,"30":"C'était leur cas quand ils disaient: 'Il a un esprit impur.'"
,"31":"Sur ce, arrivent sa mère et ses frères; ils restent dehors et envoient quelqu'un pour l'appeler."
,"32":"On dit à Jésus, alors que tout le monde est assis autour de lui: 'Ta mère et tes frères sont là dehors, qui te cherchent.'"
,"33":"Mais Jésus leur répond: 'Qui est ma mère et qui sont mes frères?'"
,"34":"Et promenant son regard sur ceux qui sont assis autour de lui, il déclare: 'Vous voyez là ma mère et mes frères ;"
,"35":"celui qui fait la volonté de Dieu, c'est lui qui m'est un frère, une soeur ou une mère.'"
}`)
	CurrentBook.AddChapter(4, `{
"1":"De nouveau Jésus s'était mis à enseigner sur les bords du lac. La foule s'y rassemble autour de lui, en tel nombre qu'il monte dans une barque où il peut s'asseoir, restant sur la mer; et tout le peuple est sur la rive, face à la mer."
,"2":"Jésus leur enseigne beaucoup de choses en paraboles, et dans son enseignement il leur dit:"
,"3":"'Ecoutez! Voici que le semeur est sorti pour semer."
,"4":"Pendant qu'il sème, une partie du grain tombe au long du chemin, et les oiseaux viennent la manger."
,"5":"Une autre partie tombe sur la rocaille où elle n'a guère de terre. Très vite sort la tige parce que la terre n'est pas profonde;"
,"6":"mais quand le soleil commence à chauffer, elle est grillée et se dessèche parce qu'elle n'a pas de racines."
,"7":"Une autre partie du grain tombe dans les épines. Les épines croissent et l'étouffent, et la graine ne porte pas de fruit."
,"8":"D'autres, enfin, tombent dans la belle terre et donnent du fruit; ces graines ont poussé, elles se sont développées et ont donné, l'une trente, l'autre soixante, l'autre cent."
,"9":"Que celui qui a des oreilles pour entendre, entende!'"
,"10":"Quand on se retrouve entre soi, ceux qui l'entourent avec les Douze le questionnent sur les paraboles."
,"11":"Alors il leur dit: 'C'est à vous qu'on a confié le mystère du Royaume de Dieu; ceux du dehors, tout leur arrive en paraboles,"
,"12":"si bien que, ils ont beau regarder ils ne voient pas, ils ont beau écouter, ils ne comprennent pas; autrement ils se convertiraient et seraient pardonnés.'"
,"13":"Jésus leur dit: 'Si vous ne comprenez pas cette parabole, comment comprendrez-vous toutes les autres?"
,"14":"Ce que sème le semeur, c'est la Parole."
,"15":"Certains sont sur le bord du chemin quand on sème la Parole; ils écoutent, mais Satan vient et enlève la Parole qui leur était destinée."
,"16":"Chez d'autres on sème sur la pierraille: ils écoutent la Parole et aussitôt l'accueillent avec joie;"
,"17":"mais chez eux les racines manquent, ils changent avec le temps. Pour peu que vienne une difficulté ou une persécution à cause de la Parole, ils chutent aussitôt."
,"18":"Chez d'autres on sème au milieu des épines. Ceux-là ont écouté la Parole;"
,"19":"et puis surviennent les soucis du monde, les illusions de la richesse et tous les autres désirs. Ils étouffent la Parole et elle reste stérile."
,"20":"Chez d'autres on sème en belle terre; ceux-là ont écouté la Parole, ils l'ont accueillie et ils portent du fruit, l'un trente, l'autre soixante, l'autre encore cent.'"
,"21":"Jésus leur dit: 'Lorsque arrive la lampe, va-t-on la coiffer d'une caisse, la mettre sous le lit? Ne sera-t-elle pas mise sur le lampadaire?"
,"22":"Il n'y a rien de caché qui ne doive être mis au jour, rien de secret qui ne doive être éclairci."
,"23":"Si quelqu'un a des oreilles pour entendre, qu'il entende!'"
,"24":"Il leur dit encore: 'Que faites-vous, de ce que vous entendez? On vous donnera selon la mesure même où vous en ferez bon usage, et vous recevrez mieux encore."
,"25":"A celui qui produit, on donnera; mais celui qui ne produit pas, on lui reprendra ce qu'il avait.'"
,"26":"Jésus leur dit: 'Voici une image du Royaume de Dieu. Un homme a jeté la semence en terre."
,"27":"Après quoi, de jour et de nuit, qu'il dorme ou se lève, la graine pousse et se développe sans qu'il ait à y voir."
,"28":"D'elle-même la terre donne le fruit: d'abord apparaît l'herbe, puis l'épi, puis le blé plein l'épi."
,"29":"Et quand c'est bon à récolter on y lance la faux: l'heure de la moisson est arrivée.'"
,"30":"Jésus dit encore: 'A quoi vais-je comparer le Royaume de Dieu? Quelle image en donner?"
,"31":"Il est comme la graine de moutarde, la plus petite de celles que l'on sème en terre."
,"32":"Mais une fois semée, elle monte et dépasse toutes les autres plantes; elle fait de longues branches et les oiseaux du ciel viennent chercher son ombre.'"
,"33":"Par beaucoup de paraboles semblables, il leur annonçait la Parole, s'adaptant à la capacité de leur intelligence."
,"34":"Il ne leur parlait jamais sans paraboles, mais il expliquait tout à ses disciples en particulier."
,"35":"Il était déjà tard ce jour-là quand Jésus dit à ses disciples: 'Passons sur l'autre rive.'"
,"36":"Ils laissèrent la foule et prirent Jésus comme il était dans la barque; d'autres barques l'accompagnaient."
,"37":"C'est alors que se lève une violente rafale de vent: les vagues se jettent sur la barque au point que déjà l'eau monte,"
,"38":"mais lui, allongé sur le coussin à l'arrière, il dort. Ils le tirent du sommeil et lui disent: 'Cela ne te fait rien si nous coulons!'"
,"39":"Jésus s'est réveillé, il rappelle à l'ordre le vent et dit à la mer: 'Silence! Tais-toi!' Aussitôt le vent tombe et c'est le grand calme."
,"40":"Alors il leur dit: 'Pourquoi vous mettre dans un tel état? Vous n'avez donc pas la foi?'"
,"41":"Ils furent saisis d'une grande crainte; ils se disaient l'un à l'autre: 'Qui donc est-il? Même le vent et la mer lui obéissent!'"
}`)
	CurrentBook.AddChapter(5, `{
"1":"Ils arrivèrent sur l'autre rive, au pays des Géraséniens."
,"2":"Jésus descendit de la barque et aussitôt vint à sa rencontre un homme qui sortait d'entre les tombes: il était possédé d'un esprit impur."
,"3":"Cet homme habitait dans les tombes et personne ne pouvait le maîtriser, même avec une chaîne;"
,"4":"souvent on lui avait passé des entraves ou on l'avait lié de chaînes, mais il brisait les chaînes et faisait sauter les entraves: personne n'était capable de le dompter."
,"5":"De nuit comme de jour il passait entre les tombes ou sur les collines, poussant des cris et se frappant avec des pierres."
,"6":"Apercevant Jésus de loin, il courut se prosterner devant lui,"
,"7":"puis il se mit à crier d'une voix forte: 'Qu'est-ce que tu me veux, Jésus, Fils du Dieu Très-Haut? Je t'en supplie au nom de Dieu, ne me torture pas!'"
,"8":"C'est que Jésus lui disait: 'Esprit impur, sors de cet homme!'"
,"9":"Jésus l'interrogea: 'Quel est ton nom?' Il répondit: 'Légion! C'est là mon nom car nous sommes nombreux.'"
,"10":"Et ces démons le suppliaient de ne pas les renvoyer du pays."
,"11":"Or il y avait là un grand troupeau de porcs qui cherchait sa nourriture dans la montagne."
,"12":"Les démons le supplièrent: 'Envoie-nous vers les cochons, nous y entrerons!'"
,"13":"Jésus le leur permit. Les esprits impurs sortirent aussitôt et entrèrent dans les cochons, et voici les bandes de cochons qui se précipitent dans le lac du haut de la falaise: elles s'y noyèrent."
,"14":"Ceux qui les gardaient prirent la fuite et racontèrent la chose en ville comme dans la campagne. On sortit donc pour voir ce qui s'était passé."
,"15":"Lorsque les gens arrivent près de Jésus, ils voient l'homme qui avait eu la 'légion' de démons: il était assis, habillé, dans tout son bon sens. Ils furent saisis de crainte."
,"16":"Les témoins racontèrent ce qui était arrivé au démoniaque et l'histoire des cochons."
,"17":"Alors les gens commencèrent à le supplier pour qu'il quitte le pays."
,"18":"Comme Jésus remontait dans la barque, l'ancien démoniaque insista beaucoup pour rester avec lui."
,"19":"Mais Jésus ne le permit pas; il lui dit: 'Rentre plutôt chez toi, dans ta famille, et raconte-leur tout ce que le Seigneur a fait pour toi et comment il a eu pitié de toi.'"
,"20":"L'homme s'éloigna et se mit à proclamer en Décapole tout ce que Jésus avait fait pour lui; ils en étaient tous stupéfaits."
,"21":"Jésus refit la traversée et débarqua sur l'autre rive. Bien des gens se regroupèrent autour de lui non loin de la mer."
,"22":"Un président de synagogue arriva, un certain Jaïre. En voyant Jésus, il tomba à ses pieds"
,"23":"et le supplia instamment: 'Ma petite fille est au plus mal; viens lui imposer les mains pour qu'elle soit sauvée et qu'elle vive!'"
,"24":"Aussitôt Jésus se mit en route, accompagné d'une foule nombreuse qui le suivait et le pressait de tous côtés."
,"25":"Il y avait là une femme qui depuis douze ans souffrait d'hémorragies."
,"26":"Elle avait beaucoup souffert aux mains de nombreux médecins: toutes ses économies y avaient passé sans aucun résultat, son mal avait même empiré."
,"27":"Comme elle avait entendu parler de Jésus, elle s'approcha par derrière dans la foule et toucha son vêtement."
,"28":"Car elle se disait: 'Si j'arrive à toucher, même ses vêtements, je serai sauvée.'"
,"29":"Aussitôt son hémorragie s'arrêta et elle sentit dans son corps qu'elle était guérie de son mal."
,"30":"Au même moment Jésus fut conscient de cette force qui sortait de lui; il se retourna vers la foule et dit: 'Qui a touché mes vêtements?'"
,"31":"Ses disciples lui disaient: 'Tu vois bien que la foule te presse de tous côtés; comment peux-tu demander qui t'a touché?'"
,"32":"Mais Jésus continuait à chercher du regard celle qui l'avait fait."
,"33":"La femme alors arriva craintive et toute tremblante, sachant bien ce qui lui était arrivé. Elle tomba aux pieds de Jésus et lui dit toute la vérité."
,"34":"Jésus lui dit: 'Ma fille, ta foi t'a sauvée, va en paix et sois guérie du mal qui te tourmentait.'"
,"35":"Ils parlait encore lorsque des gens arrivèrent de chez le président de la synagogue; ils lui dirent: 'Ta fille est morte, pourquoi encore déranger le Maître?'"
,"36":"Mais Jésus avait entendu ce qu'ils venaient de dire; il dit au président de synagogue: 'Ne crains pas, crois seulement!'"
,"37":"Après quoi il ne laissa personne l'accompagner, si ce n'est Pierre, Jacques, et Jean, le frère de Jacques."
,"38":"Voici qu'ils arrivent à la maison du président de synagogue et Jésus voit tout un remue-ménage: les gens pleuraient et poussaient des cris."
,"39":"Aussitôt entré il leur dit: 'Pourquoi ce vacarme et tous ces sanglots? La fillette n'est pas morte, mais elle dort.'"
,"40":"Les gens se moquent de lui, mais il les met tous dehors. Il prend avec lui le père de l'enfant, la mère, et ses disciples, et il entre là où est la fillette."
,"41":"Alors il la prend par la main et lui dit: 'Talitha, koum!' (ce qui se traduit: Fillette, tu m'entends: lève-toi!)'"
,"42":"Aussitôt la fil lette se lève et marche (elle avait douze ans). Les parents étaient complètement hors d'eux-mêmes. "
,"43":"Jésus leur recommanda avec insistance de ne rien raconter à personne; puis il dit de lui donner à manger."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Etant sorti de là, Jésus se dirigea vers son village natal et ses disciples le suivaient."
,"2":"Arrivé le jour du sabbat, Jésus se mit à enseigner dans la synagogue et de nombreux auditeurs en étaient stupéfaits: 'D'où lui vient tout cela?' disaient-ils. 'Il a reçu là une étrange sagesse, et ce sont des miracles peu ordinaires qui tombent de ses mains!"
,"3":"Ce n'est pourtant que le charpentier, le fils de Marie; c'est un frère de Jacques, de Joset, de Judas et de Simon. Et ses soeurs, ne sont-elles pas ici chez nous?' Ils butaient donc et ne croyaient pas en lui."
,"4":"Jésus leur dit: 'Le seul endroit où l'on ne reconnaît pas un prophète, c'est dans sa patrie, entre ses parents et dans sa famille!'"
,"5":"Il ne put faire là aucun miracle, si l'on néglige quelques malades qu'il guérit par une imposition de mains."
,"6":"Il s'étonnait de leur manque de foi. Jésus parcourait donc les villages à la ronde et il enseignait. "
,"7":"Il appela à lui les Douze et commença à les envoyer deux par deux; il leur donna autorité sur les esprits impurs."
,"8":"Il leur recommanda de ne rien prendre d'autre qu'un bâton pour la route; ni pain, ni sac, ni monnaie dans la ceinture."
,"9":"'Seulement des sandales aux pieds, leur dit-il, et n'emportez pas deux tuniques.'"
,"10":"Il leur dit encore: 'Quand une maison vous sera ouverte, restez-y jusqu'au moment de votre départ."
,"11":"Si l'on ne vous reçoit pas, si l'on ne vous écoute pas, vous secouerez la poussière qui est sous vos pieds avant de partir, ce sera un avertissement.'"
,"12":"C'est ainsi qu'ils partirent pour appeler à la conversion."
,"13":"Ils chassaient bien des démons et guérissaient de nombreux malades avec une onction d'huile."
,"14":"Le roi Hérode entendit parler de Jésus car son nom était maintenant connu. Certains disaient: 'Jean-Baptiste est ressuscité d'entre les morts, aussi les forces surnaturelles agissent-elles en lui.'"
,"15":"D'autres disaient: 'C'est Elie!' Et d'autres encore: 'C'est un prophète, comme étaient les prophètes.'"
,"16":"Mis au courant des faits, Hérode disait: 'J'ai fait décapiter Jean, mais le voilà ressuscité.'"
,"17":"Il faut savoir qu'Hérode avait fait arrêter Jean-Baptiste et le gardait en prison enchaîné, pour l'affaire d'Hérodiade, la femme de son frère Philippe qu'il avait épousée."
,"18":"Car Jean disait à Hérode: 'Tu n'as pas le droit d'avoir la femme de ton frère.'"
,"19":"Hérodiade lui en voulait terriblement; elle voulait le tuer, mais elle ne le pouvait pas,"
,"20":"car Hérode respectait Jean: il savait que c'était un homme juste et droit et il le protégeait. Quand il l'écoutait il ne savait plus que faire, cependant il l'entendait volontiers."
,"21":"Un jour pourtant se présenta une occasion favorable. Hérode avait offert un festin à ses ministres, à ses officiers et aux notables de Galilée à l'occasion de son anniversaire."
,"22":"La fille de cette Hérodiade entra pour danser et elle captiva Hérode comme ses invités. Le roi dit alors à la jeune fille: 'Demande-moi ce que tu veux et je te le donnerai.'"
,"23":"Et il lui fait ce serment: 'Demande-moi si tu veux la moitié de mon royaume, je te la donnerai.'"
,"24":"Aussitôt la fille sort et dit à sa mère: 'Qu'est-ce que je demande?' La mère répond: 'La tête de Jean-Baptiste.'"
,"25":"Vite elle revient auprès du roi et présente sa demande: 'Je veux que tu me donnes tout de suite sur un plat la tête de Jean-Baptiste.'"
,"26":"Le roi en est très contrarié, mais il a fait un serment et les invités du banquet en sont témoins, aussi ne veut-il pas lui refuser."
,"27":"Sur le champ il envoie un garde avec l'ordre d'apporter la tête de Jean, et le garde va le décapiter dans la prison."
,"28":"Il rapporte sa tête sur un plat et la donne à la jeune fille, et la jeune fille la donne à sa mère."
,"29":"Lorsque les disciples de Jean apprirent la chose, ils vinrent recueillir ses restes et les déposèrent dans une tombe."
,"30":"Les apôtres se retrouvèrent autour de Jésus et lui rapportèrent tout ce qu'ils avaient fait et enseigné."
,"31":"Il leur dit: 'Venez donc à l'écart dans un lieu désert, vous vous reposerez un peu.' Car les gens allaient et venaient en si grand nombre qu'on n'avait même pas un instant pour manger."
,"32":"Ils partent donc en barque pour s'isoler dans un lieu désert,"
,"33":"mais on les voit partir et beaucoup comprennent; de toutes les villes des gens accourent à pied et arrivent avant eux."
,"34":"Lorsque Jésus débarque, il voit beaucoup de monde et il se sent plein de compassion pour ces gens, car ils font penser à des brebis sans berger. Et il se met à les instruire longuement."
,"35":"Comme il se fait déjà tard, ses disciples s'approchent de lui et lui disent: 'L'endroit est désert et l'heure est déjà passée."
,"36":"Renvoie-les pour qu'ils aillent s'acheter de quoi manger dans les campagnes et les villages voisins.'"
,"37":"Jésus leur répond: 'Donnez-leur vous-mêmes à manger.',Ils lui disent: 'Nous voilà partis pour acheter deux cent deniers de pain, et alors ils pourront manger!' "
,"38":"Il leur dit: 'Combien de pains avez-vous? Allez voir.' Ils vérifient et lui disent: 'Cinq, avec deux poissons.'"
,"39":"Alors Jésus commande à tout ce monde de s'étendre par groupes sur l'herbe verte,"
,"40":"et ils s'étendent par carrés de cent et de cinquante."
,"41":"Jésus a pris les cinq pains et les deux poissons; il lève les yeux vers le ciel et prononce la bénédiction, il rompt le pain et commence à en donner aux disciples pour qu'ils le servent. Il partage également les deux poissons pour tout ce monde."
,"42":"Tous mangèrent et furent rassasiés."
,"43":"On ramassa même douze pleins paniers de morceaux de pain et de poissons."
,"44":"Il y avait pourtant là cinq mille hommes qui avaient mangé les pains."
,"45":"Aussitôt Jésus obligea les disciples à monter dans la barque et à le précéder de l'autre côté, vers Bethsaïde, pendant qu'il renvoyait la foule."
,"46":"Après les avoir congédiés, il s'en alla dans la montagne pour prier."
,"47":"La nuit était tombée, la barque était au milieu de la mer, et lui seul à terre."
,"48":"Il put voir qu'ils se fatiguaient à ramer, car le vent leur était contraire, et peu avant le lever du jour il vint vers eux: il marchait sur les eaux et semblait vouloir les dépasser."
,"49":"Le voyant marcher sur la mer, ils crurent que c'était un fantôme et ils se mirent à crier,"
,"50":"car tous étaient effrayés en le voyant ainsi. Lui leur parla aussitôt et leur dit: 'Remettez-vous, c'est moi, ne craignez pas!'"
,"51":"Il monta auprès d'eux dans la barque et le vent tomba. Ils en étaient totalement hors d'eux-mêmes,"
,"52":"car ils n'avaient pas encore réalisé ce qui s'était passé pour les pains: leur esprit était totalement fermé."
,"53":"Ils traversèrent de façon à atteindre la rive de Génésaret: c'est là qu'ils accostèrent."
,"54":"A peine étaient-ils descendus de la barque qu'on le reconnut"
,"55":"et les gens se mirent en branle dans toute la région. On transportait les malades sur des brancards là où l'on apprenait qu'il était; "
,"56":"partout où Jésus passait, que ce soient les villages, les villes, ou les campagnes, on déposait les infirmes sur les places publiques. On le suppliait de pouvoir seulement toucher la frange de son vêtement, et tous ceux qui la touchaient étaient sauvés."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Autour de lui s'étaient rassemblés les Pharisiens, ainsi que plusieurs maîtres de la Loi venus de Jérusalem."
,"2":"Ils virent que certains de ses disciples mangeaient leur pain avec des mains impures, c'est-à-dire non lavées."
,"3":"Il faut savoir que les Pharisiens, et les Juifs en général, ne mangent pas sans s'être lavé les mains jusqu'au coude pour respecter la tradition des anciens."
,"4":"Lorsqu'ils reviennent des lieux publics, ils ne mangent pas avant de s'être aspergés d'eau, et il y a encore bien d'autres coutumes auxquelles ils sont attachés: purification des coupes, des pots et des cruches en bronze."
,"5":"Voici donc les Pharisiens et les maîtres de la Loi qui l'interrogent: 'Pourquoi tes disciples ne suivent-ils pas la tradition des anciens? Tu vois qu'ils mangent leur pain avec des mains impures.'"
,"6":"Jésus leur répond: 'Comédiens! Isaïe a joliment bien parlé de vous quand il a écrit: Ce peuple m'honore des lèvres, mais son coeur est loin de moi."
,"7":"Leur culte ne vaut rien et les préceptes qu'ils enseignent ne sont que des lois humaines."
,"8":"Vous négligez le commandement de Dieu pour maintenir les traditions humaines!'"
,"9":"Jésus reprit: 'Comme vous savez rejeter le commandement de Dieu pour ne pas lâcher votre propre tradition! Voyez, Moïse a dit: Honore ton père et ta mère, et encore: Celui qui maudit père ou mère sera mis à mort."
,"11":"Mais selon vous, quelqu'un peut dire à ses père et mère: 'J'ai déclaré qorban, c'est-à-dire consacré à Dieu, ce que tu pouvais attendre de moi'."
,"12":"Et dans ce cas vous ne le laissez plus aider son père ou sa mère."
,"13":"Ainsi vous annulez la parole de Dieu au profit d'une tradition que vous vous transmettez. Et que de choses semblables dans vos pratiques!'"
,"14":"De nouveau Jésus appelle son monde. Il leur dit: 'Ecoutez et tâchez de comprendre."
,"15":"Tout ce qui est extérieur à l'homme ne peut pas le rendre impur; ce qui le rend impur, c'est ce qui est sorti de lui."
,"16":"Que celui qui a des oreilles pour entendre, entende!'"
,"17":"Lorsque Jésus a quitté la foule et rentre à la maison, les disciples l'interrogent sur cette sentence."
,"18":"Il leur dit: 'Vous aussi, vous êtes bouchés à ce point? Ne comprenez-vous pas que tout ce qui du dehors entre dans l'homme ne peut le rendre impur?"
,"19":"Cela ne va pas au coeur, mais au ventre, et finit sur le fumier.',Donc, pour Jésus, tous les aliments devenaient purs."
,"20":"Et il continuait: 'Ce qui sort de l'homme, c'est cela qui le rend impur."
,"21":"Car du coeur sortent les réflexions malveillantes,"
,"22":"les prostitutions, les vols, les assassinats, les adultères, la soif d'argent, les méchancetés, les perfidies, la débauche, l'envie, les blasphèmes, l'orgueil et la démesure."
,"23":"Toutes ces choses mauvaises viennent du dedans et rendent l'homme impur."
,"24":"Jésus quitta cet endroit, se dirigeant vers la frontière de Tyr. Il entra dans une maison, bien décidé à ce que personne ne le sache, mais il ne put rester inaperçu."
,"25":"Bientôt se présenta une femme qui avait entendu parler de lui. Sa petite fille était possédée par un esprit impur, et elle vint tomber à ses pieds."
,"26":"C'était une femme grecque de Syrie, d'origine phénicienne, et elle suppliait Jésus de faire sortir le démon de sa fille."
,"27":"Jésus lui répond: 'Laisse d'abord les enfants manger à leur faim. On ne prend pas le pain des enfants pour le jeter aux petits chiens.'"
,"28":"Mais elle réplique: 'Seigneur, les petits chiens sous la table, mangent les miettes des enfants.'"
,"29":"Jésus lui dit: 'A cause de cette parole, tu peux t'en retourner: le démon est sorti de ta fille.'"
,"30":"La femme rentra chez elle et trouva la petite fille allongée sur le lit: le démon était sorti."
,"31":"De nouveau Jésus se déplace; de la région de Tyr il passe par Sidon et, longeant la mer de Galilée, il arrive en territoire de la Décapole."
,"32":"C'est alors qu'on lui amène un sourd-muet, en le suppliant pour qu'il lui impose les mains."
,"33":"Jésus le prend à l'écart de la foule, il lui met les doigts sur les oreilles, puis il crache et touche à sa langue."
,"34":"Alors il lève les yeux vers le ciel et dit, comme peiné: 'Effata!', c'est-à-dire: 'Ouvre-toi!'"
,"35":"Aussitôt ses oreilles s'ouvrent et le lien de sa langue se délie: il commence à parler correctement."
,"36":"Jésus les avertit de n'en rien dire à personne; mais plus il insistait, plus eux s'empressaient de le raconter partout."
,"37":"Les gens en étaient hors d'eux-mêmes et ils disaient: 'Il a bien fait toutes choses, il fait entendre les sourds et parler les muets!'"
}`)
	CurrentBook.AddChapter(8, `{
"1":"De nouveau en ces jours-là une foule nombreuse était rassemblée, et elle n'avait rien à manger. Jésus appelle à lui les disciples et leur dit:"
,"2":"'J'ai vraiment compassion de ces gens, car voilà trois jours qu'ils sont avec moi et ils n'ont rien à manger."
,"3":"Si je les renvoie à jeun chez eux, ils ne supporteront pas la route, car certains sont venus de loin.'"
,"4":"Ses disciples lui répondent: 'Qui pourrait leur donner ici tout le pain dont ils ont besoin, quand l'endroit est désert?'"
,"5":"Jésus les interroge: 'Combien avez-vous de pains?' Ils répondent: 'Sept.'"
,"6":"Alors Jésus commande à la foule de s'allonger par terre. Il prend les sept pains, il rend grâces, il rompt le pain et commence à le donner à ses disciples pour le servir; et ils se mettent à servir la foule."
,"7":"Ils avaient également quelques petits poissons: Jésus les bénit et dit de les servir aussi."
,"8":"Ils mangèrent et furent rassasiés; on ramassa ce qui restait, de quoi remplir sept corbeilles."
,"9":"Ils étaient pourtant près de quatre mille. Après quoi Jésus les renvoya."
,"10":"Aussitôt il monta dans la barque avec ses disciples et s'en alla vers Dalmanoutha."
,"11":"Les Pharisiens arrivèrent et commencèrent à discuter avec Jésus: ils voulaient le mettre à l'épreuve, lui demandant un signe qui vienne du Ciel."
,"12":"Jésus soupira et dit: 'Pourquoi cette génération demande-t-elle un signe? En vérité, je vous le dis, aucun signe ne sera donné à cette génération.'"
,"13":"Il les planta là et s'embarqua pour regagner l'autre rive."
,"14":"Ils avaient oublié de prendre des pains; ils n'en avaient qu'un seul avec eux dans la barque."
,"15":"Et voici que Jésus leur fait cette recommandation: 'Ouvrez l'oeil, gardez-vous du levain des Pharisiens, gardez-vous de celui d'Hérode.'"
,"16":"Aussitôt ils font entre eux cette remarque qu'ils n'ont pas de pain."
,"17":"Jésus s'en aperçoit et leur dit: 'De quoi discutez-vous: Vous n'avez pas de pain? Vous ne comprenez toujours pas, vous ne réfléchissez pas! Avez-vous donc l'esprit bouché?"
,"18":"Vous avez des yeux et vous ne voyez pas, vous avez des oreilles et vous n'entendez pas; vous ne vous souvenez pas."
,"19":"Le jour où j'ai partagé les cinq pains pour les cinq mille personnes, combien de paniers pleins de morceaux avez-vous ramassés?' Ils lui répondent: 'Douze.'"
,"20":"'Et le jour des sept pains pour les quatre mille personnes, combien de corbeilles remplies de morceaux avez-vous ramassées?' Ils disent: 'Sept.'"
,"21":"'Alors, dit Jésus, ne comprenez-vous pas?'"
,"22":"Comme ils arrivent à Bethsaïde, on lui amène un aveugle et on le supplie de le toucher."
,"23":"Jésus prend l'aveugle par la main et le conduit hors du village. Là il crache sur ses paupières, et lui impose les mains. Puis il l'interroge: 'Vois-tu quelque chose?'"
,"24":"L'homme lève les yeux et dit: 'C'est sûrement des hommes que j'aperçois: c'est comme des arbres, mais je les vois qui marchent.'"
,"25":"Alors de nouveau Jésus lui impose les mains sur les yeux et l'homme est rétabli; il voit clairement, et même de loin il distingue tout nettement. Jésus le renvoie chez lui en lui disant: 'N'entre même pas dans le village.'"
,"27":"Jésus partit avec ses disciples pour les villages qui entourent Césarée de Philippe. Comme ils étaient en route, il posa cette question à ses disciples: 'Qui dit-on que je suis?'"
,"28":"Ils lui répondirent: 'Pour les uns tu es Jean-Baptiste; pour d'autres, Elie; pour d'autres encore, l'un des prophètes.',Mais Jésus continua ses questions: 'Et vous, qui dites-vous que je suis?' Pierre répondit: 'Tu es le Messie.' "
,"30":"Alors il leur donna un avertissement: ils ne devaient rien raconter à son sujet."
,"31":"Jésus commença à les instruire en ce sens: 'Le Fils de l'Homme doit souffrir beaucoup, il sera rejeté par les prêtres, les Anciens et les maîtres de la Loi; on le tuera et après trois jours il ressuscitera.'"
,"32":"Il leur parlait de cela avec beaucoup d'assurance. Pierre alors le prend à part et commence à lui faire la leçon. "
,"33":"Mais Jésus se retourne, et comme il voit là ses disciples, il sermonne Pierre et lui dit: 'Passe derrière-moi, Satan! Tu ne penses pas comme Dieu, mais de façon toute humaine.'"
,"34":"Jésus avait appelé à lui la foule, en même temps que ses disciples, quand il leur dit: 'Si quelqu'un veut marcher derrière-moi, qu'il renonce à lui-même, qu'il prenne sa croix et qu'il me suive."
,"35":"Oui, celui qui veut se sauver lui-même se perdra; mais celui qui se sacrifie (pour moi et) pour l'Evangile se sauvera."
,"36":"Où est le bénéfice, si l'on gagne le monde entier et qu'on se détruit soi-même?"
,"37":"Avec quoi va-t-on racheter sa propre vie?"
,"38":"Celui qui rougira de moi et de mes paroles au milieu de cette génération adultère et pécheresse, le Fils de l'Homme aussi rougira de lui quand il viendra dans la Gloire de son Père, entouré des saints anges.'"
}`)
	CurrentBook.AddChapter(9, `{
"1":"Jésus leur dit encore: 'En vérité, je vous le dis, certains qui sont ici ne feront pas l'expérience de la mort avant d'avoir vu le Royaume de Dieu venir avec puissance.'"
,"2":"Six jours après, Jésus prit avec lui Pierre, Jacques et Jean, et les emmena à l'écart, seuls, sur une haute montagne. Là, devant eux, il fut transfiguré."
,"3":"Ses vêtements devinrent éclatants de lumière, d'une blancheur telle qu'aucun blanchisseur sur la terre ne peut blanchir de la sorte."
,"4":"Alors Elie leur apparut, avec Moïse: les deux étaient en conversation avec Jésus."
,"5":"Pierre prit la parole pour dire à Jésus: 'Rabbi, cela tombe bien que nous soyons ici; nous allons dresser trois tentes: une pour toi, une pour Moïse et une pour Elie.'"
,"6":"En réalité, il ne savait plus que dire, car ils étaient effrayés."
,"7":"Une nuée survint alors qui les prit sous son ombre, et de la nuée se fit entendre une voix: 'Celui-ci est mon Fils, le Bien-Aimé, écoutez-le!'"
,"8":"Et soudain, regardant autour d'eux, ils ne virent plus personne: seul Jésus était avec eux."
,"9":"Comme ils descendaient de la montagne, Jésus leur ordonna de ne raconter à personne ce qu'ils avaient vu, jusqu'à ce que le Fils de l'Homme soit ressuscité d'entre les morts."
,"10":"Ils respectèrent cet ordre, mais entre eux ils se demandaient ce que c'était que ressusciter d'entre les morts."
,"11":"C'est alors qu'ils lui posèrent la question: 'Pourquoi les maîtres de la Loi disent-ils que d'abord viendra Elie?'"
,"12":"Jésus leur répondit: 'Bien sûr, d'abord vient Elie qui remet tout en ordre... mais comment est-il écrit du Fils de l'Homme qu'il doit souffrir beaucoup et être méprisé?"
,"13":"Elie est bien revenu, et ils l'ont traité comme ils voulaient, selon ce qui est écrit de lui.'"
,"14":"Lorsqu'ils rejoignirent les disciples, ils virent tout un attroupement autour d'eux, et des maîtres de la Loi qui discutaient avec eux."
,"15":"Ce fut une surprise pour tout ce monde quand ils virent Jésus; ils coururent au-devant de lui pour le saluer."
,"16":"Alors Jésus demande aux gens: 'Qu'avez-vous à discuter avec eux?'"
,"17":"De la foule un homme lui répond: 'Maître, je t'ai amené mon fils qui est possédé d'un esprit muet."
,"18":"Quand il s'empare de mon fils, il le déchire: l'enfant bave, grince des dents et devient tout raide. J'ai demandé à tes disciples de le faire sortir, mais ils n'ont pas été capables.'"
,"19":"Jésus répond: 'Gens sans foi, jusqu'à quand serai-je avec vous! Jusqu'à quand devrai-je vous supporter? Amenez-le moi.'"
,"20":"Ils le lui amènent. A la vue de Jésus, l'esprit secoue l'enfant violemment, il tombe à terre et se roule en bavant."
,"21":"Jésus interroge son père: 'Depuis combien de temps cela lui arrive-t-il? Le père répond: 'Depuis son enfance."
,"22":"Souvent même il l'a jeté dans le feu et dans l'eau: il pouvait le tuer. Aie pitié de nous, et si tu peux, viens à notre secours!'"
,"23":"Jésus lui dit: 'Si tu peux... Mais tout est possible pour celui qui croit!'"
,"24":"Aussitôt le père de l'enfant s'écrie: 'Je crois, mais viens en aide à mon manque de foi!'"
,"25":"Quand Jésus voit que les gens arrivent plus en nombre, il menace l'esprit impur: 'Esprit muet et sourd, je te l'ordonne: sors de cet enfant et ne reviens plus jamais!'"
,"26":"A ce moment l'esprit pousse un cri, secoue violemment l'enfant et sort. L'enfant était resté comme mort, et plusieurs disaient: 'Il est mort!'"
,"27":"Mais Jésus le prend par la main et le réveille: l'enfant se remet sur pieds."
,"28":"Jésus revient à la maison; quand ils sont seuls, ses disciples l'interrogent: 'Pourquoi n'avons-nous pas pu le faire sortir?'"
,"29":"Jésus leur répond: 'Il n'y a que la prière pour faire sortir cette espèce-là.'"
,"30":"Ils quittèrent cet endroit, et ils allaient de place en place à travers la Galilée. Jésus ne voulait pas qu'on le sache,"
,"31":"car il était occupé à instruire ses disciples. Alors il leur dit: 'Le Fils de l'Homme sera livré aux mains des hommes. Ils le tueront, et trois jours après sa mort il ressuscitera.'"
,"32":"Eux ne comprenaient pas cet avertissement, et ils avaient peur de lui en demander davantage."
,"33":"Ils arrivèrent à Capharnaüm. Une fois à la maison, Jésus les interrogea: 'De quoi discutiez-vous en chemin?'"
,"34":"Ils se turent, car en chemin ils s'étaient disputés à propos de qui était le plus grand."
,"35":"Alors Jésus s'assoit, il appelle les Douze et leur dit: 'Si quelqu'un veut être le premier, qu'il soit le dernier de tous, qu'il soit le serviteur de tous.'"
,"36":"Puis il place au milieu d'eux un enfant, il l'embrasse et leur dit:"
,"37":"'Si quelqu'un reçoit en mon nom l'un de ces enfants, c'est moi qu'il reçoit.'"
,"38":"Jean lui dit: 'Maître, nous avons vu quelqu'un qui se servait de ton nom pour chasser les démons, et nous l'avons empêché car il n'est pas disciple avec nous.'"
,"39":"Jésus lui répond: 'Ne l'empêchez pas! Car personne ne peut faire un miracle en mon nom et aussitôt après parler mal de moi."
,"40":"Celui qui n'est pas contre nous est pour nous."
,"41":"Celui qui vous donne un verre d'eau parce que vous êtes disciples du Christ, je vous dis qu'il ne perdra pas sa récompense.'"
,"42":"'Si quelqu'un devait faire chuter l'un de ces petits qui croient, mieux vaudrait pour lui qu'on lui attache au cou une meule de moulin et qu'on le jette dans la mer."
,"43":"Si ta main doit te faire chuter, coupe-la! Mieux vaut pour toi entrer dans la vie avec une seule main, que t'en aller avec tes deux mains à la géhenne,"
,"44":"au feu qui ne s'éteint pas."
,"45":"Et si ton pied doit te faire chuter, coupe-le! mieux vaut pour toi entrer dans la vie avec un seul pied, qu'être jeté avec tes deux pieds dans la géhenne ("
,"46":")."
,"47":"Si ton oeil doit te faire chuter, jette-le loin de toi; mieux vaut pour toi entrer dans le Royaume de Dieu avec un seul oeil que d'en avoir deux et d'être jeté dans la géhenne,"
,"48":"où le ver ne meurt pas et où le feu ne s'éteint pas."
,"49":"Car ce feu fera l'office du sel.'"
,"50":"'Le sel est bon; mais si le sel n'est plus salé, comment lui redonnerez-vous du mordant? Ayez du sel en vous-mêmes et vivez en paix les uns avec les autres.'"
}`)
	CurrentBook.AddChapter(10, `{
"1":"Jésus quitta cet endroit. Voici qu'il arrive aux frontières de la Judée par l'autre rive du Jourdain et de nouveau des foules se rassemblent autour de lui. Il recommence donc à les enseigner comme il avait coutume de faire."
,"2":"A ce moment (se présentèrent des Pharisiens, et) ils lui posèrent cette question pour le mettre à l'épreuve: 'Un mari est-il autorisé à renvoyer sa femme?'"
,"3":"Et lui leur demande: 'Qu'est-ce que Moïse vous a commandé?'"
,"4":"Ils répondent: 'Moïse a permis d'écrire un acte de divorce et de renvoyer la femme.'"
,"5":"Jésus leur dit: 'Il a écrit là une loi adaptée à votre coeur endurci."
,"6":"Mais Dieu, au commencement du monde, les fit homme et femme."
,"7":"Pour cette raison, l'homme quittera son père et sa mère"
,"8":"et les deux seront une seule chair. Ils ne sont plus deux, mais une seule chair. "
,"9":"Que l'homme ne sépare pas ce que Dieu a uni.'"
,"10":"De retour à la maison, les disciples l'interrogent de nouveau à ce sujet"
,"11":"et il leur déclare: 'Celui qui renvoie sa femme et en épouse une autre, commet l'adultère à son égard;"
,"12":"et si une femme renvoie son mari et en épouse un autre, elle aussi commet l'adultère.'"
,"13":"On lui amenait de petits enfants pour qu'il les touche; mais les disciples leur faisaient des observations."
,"14":"Voyant cela Jésus se fâcha et leur dit: 'Laissez les petits enfants venir à moi, ne les empêchez pas. Sachez que le Royaume de Dieu est pour ceux qui leur ressemblent."
,"15":"En vérité, je vous le dis: celui qui n'accueille pas le Royaume de Dieu comme un enfant n'y entrera pas.'"
,"16":"Puis il les embrassa et les bénit en leur imposant les mains."
,"17":"Comme Jésus se mettait en route, un homme courut au-devant de lui; il tomba à genoux devant lui et l'interrogea: 'Bon maître, que dois-je faire pour hériter de la vie éternelle?'"
,"18":"Jésus lui répondit: 'Pourquoi m'appelles-tu: 'bon'? Dieu seul est bon, nul autre que lui."
,"19":"Tu connais les commandements: Ne tue pas, ne commets pas l'adultère, ne vole pas, ne porte pas de faux témoignage, ne prends rien à autrui, respecte ton père et ta mère...'"
,"20":"L'autre déclara: 'Maître, tout cela je l'ai observé depuis ma jeunesse.'"
,"21":"Alors Jésus le fixa du regard et l'aima; il lui dit: 'Une seule chose te manque. Va, vends ce que tu as et donne-le aux pauvres, tu auras ainsi un trésor dans le ciel; puis reviens et suis-moi.'"
,"22":"L'homme fut très heurté par cette parole car il avait de grands biens; il s'éloigna fort triste."
,"23":"Alors Jésus jeta un regard sur ses disciples autour de lui; il déclara: 'Comme il est difficile à ceux qui ont de l'argent d'entrer dans le Royaume de Dieu.'"
,"24":"En entendant ces paroles, les disciples furent déconcertés; mais de nouveau Jésus leur dit: 'Mes enfants, comme il est difficile d'entrer dans le Royaume de Dieu."
,"25":"Il est plus facile pour un chameau de passer par le trou d'une aiguille, que pour un riche d'entrer dans le Royaume de Dieu.'"
,"26":"Les disciples étaient complètement déroutés et se demandaient les uns aux autres: 'Qui donc sera sauvé?'"
,"27":"Jésus les fixa du regard et leur dit: 'Pour les hommes, c'est impossible, mais non pour Dieu. Car pour Dieu tout est possible.'"
,"28":"Pierre fit alors remarquer: 'Nous, nous avons tout laissé pour te suivre.'"
,"29":"Jésus répondit: 'En vérité, je vous le dis: personne ne laissera maison, frères et soeurs, mère, père ou enfants, ou champs, à cause de moi et de l'Evangile,"
,"30":"sans recevoir cent fois plus dès à présent en ce monde, en maisons, frères, soeurs, mères, enfants et champs, même avec les persécutions; et dans le monde à venir il aura la vie éternelle."
,"31":"Beaucoup qui sont parmi les premiers seront derniers, mais les derniers seront premiers.'"
,"32":"Ils étaient en route, montant à Jérusalem, et Jésus marchait devant eux. Ils étaient déconcertés, et ceux qui suivaient avaient peur. De nouveau Jésus prit avec lui les Douze pour leur dire ce qui allait lui arriver: "
,"33":"'Maintenant nous montons à Jérusalem et le Fils de l'Homme va être livré aux chefs des prêtres et aux maîtres de la Loi qui le condamneront à mort et le remettront aux mains des étrangers;"
,"34":"ils vont l'humilier, cracher sur lui, le fouetter et le tuer, mais il ressuscitera le troisième jour.'"
,"35":"C'est alors que Jacques et Jean, les fils de Zébédée, s'approchent de lui et lui disent: 'Maître, nous voulons que tu fasses pour nous ce que nous allons te demander.'"
,"36":"Jésus leur répond: 'Que voulez-vous que je fasse pour vous?'"
,"37":"Ils reprennent: 'Accorde-nous d'être assis, l'un à ta droite et l'autre à ta gauche, pour partager ta gloire.'"
,"38":"Jésus leur dit: 'Vous ne savez pas ce que vous demandez. Pouvez-vous boire la coupe que je vais boire, ou être baptisés du baptême dont je vais être baptisé?'"
,"39":"Ils lui disent: 'Nous le pouvons!',Jésus leur dit: 'Vous boirez donc la coupe que je vais boire et vous serez baptisés du même baptême que moi. "
,"40":"Mais les sièges à ma droite ou à ma gauche, ce n'est pas à moi de les donner; ils sont réservés à d'autres.'"
,"41":"En entendant cela, les dix autres s'indignent contre Jacques et Jean."
,"42":"Alors Jésus les appelle et leur dit: 'Vous savez que chez les païens, ceux qui font figure de chefs se conduisent en dictateurs, et leurs grands personnages abusent de leur autorité."
,"43":"Cela ne devra pas être chez vous. Si l'un d'entre vous veut être grand, qu'il se fasse votre serviteur. "
,"44":"Et si l'un d'entre vous veut être le premier, qu'il soit l'esclave de tous."
,"45":"Car le Fils de l'Homme n'est pas venu pour être servi, mais pour servir et donner sa vie en rançon pour la multitude."
,"46":"Ils arrivent à Jéricho. Puis, comme il sort de la ville avec ses disciples et bon nombre de gens, un mendiant est là assis au bord du chemin; c'est Bartimée, le fils de Timée, et il est aveugle."
,"47":"Quand il apprend que c'est Jésus de Nazareth, il se met à crier: 'Jésus, fils de David, aie pitié de moi!'"
,"48":"Beaucoup le sermonnent pour le faire taire, mais il crie encore plus fort: 'Fils de David, aie pitié de moi!'"
,"49":"Jésus s'arrête et dit: 'Appelez-le.' On appelle l'aveugle et on lui dit: 'Courage, lève-toi, il t'appelle.'"
,"50":"L'aveugle laisse son manteau, et d'un bond il est près de Jésus."
,"51":"Jésus lui dit: 'Que veux-tu que je fasse pour toi?' L'aveugle répond: 'Rabbouni, que je voie!'"
,"52":"Alors Jésus lui dit: 'Va! ta foi t'a sauvé!' A l'instant même cet homme voit; et il se met à suivre Jésus sur le chemin."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Comme déjà ils arrivent à Beth phagé et Béthanie, près du mont des Oliviers, et qu'ils sont proches de Jérusalem,"
,"2":"Jésus envoie deux de ses disciples et leur dit: 'Allez jusqu'au village d'en face; juste à l'entrée, vous trouverez un ânon attaché, sur lequel personne n'est encore monté. Détachez-le et amenez-le."
,"3":"Si quelqu'un vous dit: 'Pourquoi faites-vous cela?' vous répondrez: Le Seigneur en a besoin, et aussitôt après il le renverra.'"
,"4":"Ils s'en vont donc et trouvent dans la rue un ânon attaché près d'une porte; ils le détachent."
,"5":"Des gens qui sont là leur disent: 'Pourquoi détachez-vous l'ânon?'"
,"6":"Ils leur répondent comme Jésus l'a dit et on les laisse faire."
,"7":"Ils amènent l'ânon à Jésus; ils jettent sur lui leurs manteaux et Jésus s'assoit dessus."
,"8":"Beaucoup étendent leurs manteaux sur le chemin, et d'autres des feuillages qu'ils ont coupés dans les champs."
,"9":"Ceux qui vont devant et ceux qui suivent lancent des acclamations: 'Hosanna! Béni soit celui qui vient au nom du Seigneur!"
,"10":"Béni soit le Royaume qui vient, le règne de David, notre père! Hosanna dans les hauteurs du ciel!'"
,"11":"Jésus entra dans Jérusalem, et jusque dans le Temple où il inspecta tout du regard. Il était déjà tard lorsqu'il repartit avec les Douze en direction de Béthanie."
,"12":"Le lendemain, comme on sortait de Béthanie, Jésus eut faim."
,"13":"Voyant de loin un figuier couvert de feuilles, il s'approcha pour voir s'il y trouverait quelque chose. Mais en s'approchant il ne trouva rien; il n'y avait que des feuilles, car ce n'était pas la saison des figues."
,"14":"Jésus dit alors au figuier: 'Que personne jamais plus ne mange de ton fruit!' Et ses disciples l'entendirent."
,"15":"Ils arrivèrent à Jérusalem. Jésus entra dans le Temple et commença à jeter dehors tous ceux qui vendaient et achetaient dans le Temple. Il retourna les tables des changeurs de monnaie et les sièges des vendeurs de colombes;"
,"16":"il ne permettait pas qu'on transporte des paquets à travers les parvis du Temple."
,"17":"Jésus leur fit la leçon: 'N'est-il pas écrit: Ma maison sera appelée Maison de Prière pour toutes les nations? Et vous, vous en avez fait une caverne de voleurs.'"
,"18":"Les chefs des prêtres et les maîtres de la Loi en furent informés, et dès lors ils voulaient sa perte. Ils le redoutaient, car tout le monde était impressionné par son enseignement."
,"19":"Quand arrivait le soir, ils sortaient de la ville."
,"20":"Au matin, en repassant, ils voient le figuier desséché jusqu'aux racines."
,"21":"Pierre alors se rappelle, et il dit à Jésus: 'Rabbi, regarde! Le figuier que tu as maudit est tout desséché.'"
,"22":"Jésus répond: 'Ayez foi en Dieu!"
,"23":"En vérité, je vous le dis, si quelqu'un dit à cette montagne: 'Enlève-toi et jette-toi dans la mer!' il ne faut pas qu'il hésite. S'il croit de tout son coeur que ce qu'il dit va se faire, eh bien oui, il l'aura."
,"24":"Aussi je vous dis: Tout ce que vous demandez dans la prière, croyez que vous l'avez reçu et vous le recevrez."
,"25":"Quand vous êtes en train de prier, si vous avez quelque chose contre quelqu'un, pardonnez; et votre Père qui est dans les cieux vous pardonnera aussi vos fautes.' ("
,"26":")."
,"27":"Ils revinrent à Jérusalem. Tandis qu'ils allaient et venaient dans le Temple, les chefs des prêtres, les maîtres de la Loi et les Anciens vinrent à lui"
,"28":"et lui dirent: 'De quelle autorité fais-tu cela? Qui t'a chargé de le faire?'"
,"29":"Jésus leur répond: 'Je vous poserai une question, une seule. Répondez-moi et je vous dirai de quelle autorité je fais cela:"
,"30":"Le baptême de Jean, était-ce une initiative du Ciel, ou simplement hu maine? Répondez-moi.'"
,"31":"Les autres commencent à se dire: 'Si nous répondons que cela venait du Ciel, il nous dira: Pourquoi n'avez-vous pas cru en lui?"
,"32":"Mais comment dire que c'était chose humaine?' Ils ne le pouvaient par crainte du peuple, car tous considéraient Jean comme un vrai prophète."
,"33":"Aussi répondent-ils à Jésus: 'Nous ne savons pas.' Et Jésus leur dit: 'Je ne vous dirai pas non plus de quel droit je fais tout cela.'"
}`)
	CurrentBook.AddChapter(12, `{
"1":"Jésus se mit à leur parler en paraboles: 'Un homme a planté une vigne, il l'a entourée d'un mur, il a creusé un pressoir et bâti un abri pour le garde. Et puis il l'a remise à des fermiers pendant que lui s'en allait à l'étranger."
,"2":"Quand la saison en est venue, il envoie un serviteur pour rencontrer les fermiers et recevoir de leurs mains les fruits de la vigne."
,"3":"Mais les fermiers le prennent, le battent et le renvoient les mains vides."
,"4":"De nouveau il leur envoie un autre serviteur; lui aussi ils le frappent à la tête et le couvrent d'insultes."
,"5":"Il en envoie un autre qui est tué; puis beaucoup d'autres qu'ils battent ou qu'ils tuent."
,"6":"Il lui en restait un, son fils bien-aimé; il le leur envoie en dernier en se disant: Ils auront du respect pour mon fils."
,"7":"Mais ces fermiers se disent entre eux: 'C'est lui l'héritier, allons-y, tuons-le! L'héritage sera pour nous.'"
,"8":"Ils le prennent donc et le tuent; puis ils le jettent hors de la vigne."
,"9":"Que fera le propriétaire de la vigne? Il viendra, il fera périr ces fermiers et confiera la vigne à d'autres."
,"10":"Peut-être avez-vous lu cette Ecriture: La pierre rejetée par les constructeurs est devenue la pierre d'angle."
,"11":"C'est le Seigneur qui l'avait donnée, et nous restons à l'admirer.'"
,"12":"Les chefs auraient voulu s'emparer de lui, mais ils avaient peur de la foule. Ils avaient bien compris en effet que cette parabole de Jésus était pour eux. Ils le laissèrent là et s'en allèrent."
,"13":"Alors on lui envoie quelques Pharisiens, avec des Hérodiens, pour le prendre au piège dans ses paroles."
,"14":"Ils arrivent et lui disent: 'Maître, nous savons que tu es droit, tu ne te laisses influencer par personne et tu ne cherches pas à te faire bien voir des gens; mais tu enseignes les chemins de Dieu selon la vérité. Est-il permis de payer l'impôt à César ou non, devons-nous donner ou non?'"
,"15":"Jésus a vu leur hypocrisie; il leur dit: 'Pourquoi essayez-vous de m'avoir? Apportez-moi un denier pour que je le voie.'"
,"16":"Ils en apportent un et Jésus leur dit: 'Cette tête et ce nom qu'on a gravé, de qui sont-ils?' Ils lui répondent: 'De César.'"
,"17":"Alors Jésus leur dit: 'Rendez à César ce qui est de César, et à Dieu ce qui est de Dieu.',Ils en restèrent fort étonnés."
,"18":"Des Sadducéens vinrent trouver Jésus; ces gens-là disent qu'il n'y a pas de résurrection. Ils l'interrogent donc de la façon suivante:"
,"19":"'Maître, Moïse nous a dit ceci dans l'Ecriture: Si un homme perd son frère qui est marié mais qui n'a pas encore d'enfants, il prendra la femme de ce frère pour lui assurer une descendance."
,"20":"Or il y avait sept frères; le premier s'est marié et est mort sans avoir d'enfants."
,"21":"Le deuxième a pris la veuve et est mort sans laisser non plus d'enfants. Il en a été de même pour le troisième."
,"22":"Aucun des sept n'a laissé d'enfants; la femme est morte la dernière."
,"23":"A la résurrection, s'ils ressuscitent, duquel d'entre eux sera-t-elle la femme? Car les sept l'ont eue pour femme.'"
,"24":"Jésus leur dit: 'Vos difficultés viennent sûrement de ce que vous ne connaissez, ni les Ecritures, ni la puissance de Dieu."
,"25":"Quand ils ressuscitent d'entre les morts, ni hommes, ni femmes ne se marient: ils sont dans les cieux semblables aux anges."
,"26":"Quant à savoir si les morts ressuscitent, n'avez-vous pas approfondi le livre de Moïse au passage du Buisson Ardent? Dieu lui dit: Je suis le Dieu d'Abraham, le Dieu d'Isaac, le Dieu de Jacob!"
,"27":"Il n'est pas un Dieu des morts mais des vivants. Vous êtes complètement dans l'erreur.'"
,"28":"Un maître de la Loi avait suivi leur discussion. Voyant comment Jésus avait su leur répondre, il lui posa cette question: 'Quel est le premier de tous les commandements?'"
,"29":"Jésus lui répond: 'Voici le premier: Ecoute, Israël, le Seigneur notre Dieu est un Seigneur unique."
,"30":"Tu aimeras le Seigneur ton Dieu de tout ton coeur, de toute ton âme, de toute ton intelligence et de toute ta force."
,"31":"Et voilà le deuxième: Tu aimeras ton prochain comme toi-même. Il n'y a pas de commandement plus grand que ces deux-là.'"
,"32":"Le maître de la Loi lui dit: 'Bien, Maître! Tu as dit en toute vérité que Dieu est unique et qu'il n'y en a pas d'autre que lui."
,"33":"L'aimer de tout son coeur, de toute son intelligence, de toute sa force, et aimer le prochain comme soi-même vaut mieux que tous les holocaustes et tous les sacrifices.'"
,"34":"Voyant qu'il disait là quelque chose de très juste, Jésus lui dit: 'Tu n'es pas loin du Royaume de Dieu.' Dès ce moment, personne n'osa plus lui poser de questions."
,"35":"Jésus était en train d'enseigner dans le Temple. Et voici qu'il demande: 'Comment les maîtres de la Loi peuvent-ils dire que le Messie est fils de David?"
,"36":"Car l'Esprit Saint a fait dire à David: Le Seigneur a dit à mon Seigneur: Siège à ma droite, et vois comment je fais de tes ennemis ton marchepied."
,"37":"Si David lui-même l'appelle 'Seigneur', comment peut-il être son fils?',Une foule nombreuse l'écoutait avec plaisir. "
,"38":"Dans son enseignement il leur disait: 'N'imitez pas les maîtres de la Loi qui se plaisent à circuler en longues robes, ou qui aiment les salutations sur les places publiques,"
,"39":"les premiers fauteuils dans les synagogues et les premières places dans les festins."
,"40":"Ils s'introduisent avec leurs longues prières, et ensuite ils dévorent les maisons des veuves. Leur condamnation sera terrible.'"
,"41":"Jésus s'était assis devant le trésor du Temple et observait comment la foule jetait des monnaies dans le tronc. Il y avait des riches qui en jetaient beaucoup;"
,"42":"puis vient une veuve pauvre qui jette deux petites pièces d'un demi-quart."
,"43":"Alors Jésus appelle à lui ses disciples et leur dit: 'En vérité, je vous le dis: cette veuve toute pauvre a jeté plus que tous les autres dans le tronc du Trésor."
,"44":"Car tous ceux-là ont donné de ce qui ne leur manquait pas; mais elle, dans sa pauvreté, a mis tout ce qu'elle avait pour vivre.'"
}`)
	CurrentBook.AddChapter(13, `{
"1":"Comme Jésus sortait du Temple, un de ses disciples lui dit: 'Maître, regarde: quelles pierres et quelles constructions!'"
,"2":"Jésus lui dit: 'Tu vois ces grandes constructions? Eh bien, il ne restera pas ici pierre sur pierre: tout sera détruit.'"
,"3":"Après cela, comme Jésus s'était assis au mont des Oliviers, faisant face au Temple, Pierre, Jacques, Jean et André lui posèrent cette question en particulier:"
,"4":"'Dis-nous quand cela aura lieu et quel sera le signe annonçant que tout cela va s'accomplir.'"
,"5":"Alors Jésus commence à leur dire: 'Ne vous laissez pas égarer,"
,"6":"car plusieurs revendiqueront mon titre, disant: C'est moi! Et ils égareront bien des gens."
,"7":"Quand on vous parlera de guerres et de rumeurs de guerres, ne cédez pas à la panique. Cela doit arriver, mais ce ne sera pas encore la fin."
,"8":"On verra des soulèvements: peuple contre peuple et royaume contre royaume. Il y aura des tremblements de terre en divers lieux et des famines; mais ce ne sera que le début, les premières douleurs."
,"9":"C'est de vous-mêmes qu'il faudra vous préoccuper. Ils vous livreront à leurs conseils de communauté, vous serez battus dans les synagogues; à cause de moi ils vous feront comparaître devant les gouverneurs et les rois, et vous devrez rendre témoignage devant eux."
,"10":"Il faut d'abord que l'Evangile soit proclamé à toutes les nations."
,"11":"Quand ils vous conduiront et vous livreront, ne vous inquiétez pas d'avance de ce que vous pourrez dire; vous direz ce qui vous sera donné à cette heure-là. Car ce n'est pas vous qui parlerez, mais l'Esprit Saint."
,"12":"Le frère livrera son frère à la mort, et le père son enfant. Les enfants accuseront leurs parents et les feront mourir."
,"13":"Rien qu'à cause de mon nom vous serez haïs de tous, mais celui qui restera ferme jusqu'à la fin sera sauvé."
,"14":"Quand vous verrez l'abomination du dévastateur installée là où elle ne doit pas être (que le lecteur comprenne!), alors, si vous êtes en Judée fuyez à la montagne."
,"15":"Si tu es sur la terrasse, ne redescends pas pour prendre tes affaires à l'intérieur de ta maison."
,"16":"Si tu es aux champs, ne reviens pas pour prendre ton vêtement."
,"17":"Ce sera grande malchance pour une femme que d'être enceinte ou d'allaiter en ces jours-là."
,"18":"Demandez à Dieu de n'avoir pas à fuir en hiver."
,"19":"Car ce sera un temps d'épreuve comme il n'y en a pas eu depuis le début du monde que Dieu a créé, jusqu'à maintenant, et il n'en arrivera plus."
,"20":"Si le Seigneur n'avait pas abrégé ces jours, personne n'en serait sorti vivant, mais Dieu a abrégé ces jours par égard pour ses élus."
,"21":"Alors, si l'on vous dit que le Messie est ici ou qu'il est là, ne le croyez pas."
,"22":"Car de faux messies et de faux prophètes se présenteront; ils feront des signes et des prodiges au point d'égarer, s'il était possible, même les élus."
,"23":"Vous donc, faites attention, je vous ai tout dit d'avance.'"
,"24":"'Mais après cette épreuve, d'autres jours viendront. Alors, le soleil s'obscurcira, la lune ne donnera plus sa clarté,"
,"25":"les astres se mettront à tomber du ciel et l'univers entier sera ébranlé."
,"26":"Alors on verra le Fils de l'Homme venant sur les nuées du ciel avec puissance et grande gloire."
,"27":"Il enverra les anges rassembler ses élus des quatre points du ciel, du plus lointain de l'univers."
,"28":"Apprenez cette leçon tirée du figuier. Lorsque déjà sa ramure devient flexible et que ses feuilles poussent, vous savez que l'été est proche;"
,"29":"vous de même, quand vous verrez tous ces événements, sachez que c'est tout proche, sur le pas de la porte."
,"30":"En vérité je vous le dis, cette génération ne passera pas que tout cela n'arrive."
,"31":"Le ciel et la terre passeront, mes paroles ne passeront pas."
,"32":"Quant à ce Jour, quant à cette Heure, personne ne les connaît, pas même les anges dans le ciel, pas même le Fils: seul le Père."
,"33":"Faites attention, restez éveillés! Car vous ne savez pas quand ce sera le moment."
,"34":"Il en sera comme d'un homme qui part à l'étranger et laisse sa maison; il a donné des responsabilités à ses serviteurs: à chacun son travail, et il a demandé au portier de rester éveillé."
,"35":"Veillez donc! Vous ne savez pas si le maître de maison reviendra le soir, au milieu de la nuit, au chant du coq ou au petit matin."
,"36":"Il ne faudrait pas qu'il vous trouve en train de dormir lorsqu'il reviendra à l'improviste. Ce que je vous dis, je le dis à tous: restez éveillés!'"
}`)
	CurrentBook.AddChapter(14, `{
"1":"Encore deux jours, et c'était la Pâque et la fête des Pains sans levain. Les chefs des prêtres et les maîtres de la Loi cherchaient la manière de s'emparer de Jésus dans un coup monté et de le mettre à mort."
,"2":"Mais ils se disaient: 'Pas durant la fête, car le peuple pourrait s'agiter.'"
,"3":"Jésus se trouvait à Béthanie dans la maison de Simon le lépreux. Pendant qu'il était à table, une femme s'approcha de lui, portant un vase d'albâtre avec une essence de myrrhe d'un très grand prix. Elle brisa le col du vase et versa le parfum sur la tête de Jésus."
,"4":"Plusieurs d'entre eux en furent indignés; ils se disaient: 'Pourquoi avoir gâché ce parfum?"
,"5":"On aurait pu vendre cette myrrhe plus de trois cents deniers et les donner aux pauvres.' Et ils lui en faisaient le reproche."
,"6":"Mais Jésus leur dit: 'Laissez-la tranquille, pourquoi lui cherchez-vous des ennuis? Ce qu'elle vient de faire pour moi est une bonne oeuvre."
,"7":"Les pauvres, vous en aurez toujours avec vous et vous pourrez leur faire du bien chaque fois que vous le voudrez, mais moi vous ne m'aurez pas toujours."
,"8":"Elle a fait ce qui lui correspondait: elle a embaumé par avance mon corps pour la sépulture."
,"9":"En vérité, je vous le dis, partout où cet Evangile sera proclamé, jusqu'au bout du monde, on dira aussi ce qu'elle a fait et on gardera sa mémoire.'"
,"10":"Alors Judas Iscariote, qui était l'un des Douze, s'en alla trouver les chefs des prêtres pour leur livrer Jésus."
,"11":"Ils en furent très heureux et promirent de lui donner de l'argent. Dès lors il chercha le moment favorable pour le livrer."
,"12":"Le premier jour des Pains sans Levain, où l'on devait immoler l'agneau de la Pâque, les disciples dirent à Jésus: 'Où veux-tu que nous allions faire les préparatifs pour manger la Pâque?'"
,"13":"Alors il envoie deux de ses disciples en leur disant: 'Allez à la ville; un homme portant une cruche d'eau vous rejoindra: suivez-le."
,"14":"Et là où il entrera, dites au propriétaire: Le Maître te fait dire: Où est ma salle où je mangerai la Pâque avec mes disciples?"
,"15":"Il vous montrera à l'étage une grande pièce garnie de coussins, bien aménagée; vous y préparerez tout ce qu'il nous faut.'"
,"16":"Les disciples partirent, arrivèrent à la ville et trouvèrent tout comme Jésus le leur avait dit; ils firent les préparatifs de la Pâque."
,"17":"Le soir venu, Jésus arrive avec les Douze."
,"18":"Pendant qu'ils sont à table et mangent, Jésus leur dit: 'En vérité je vous le dis: L'un de vous va me livrer, un de ceux qui mangent avec moi'."
,"19":"Profondément peinés, ils se mettent à lui dire l'un après l'autre: 'Serait-ce moi?'"
,"20":"Mais il leur dit: 'C'est l'un des Douze, celui qui plonge avec moi la main dans le plat."
,"21":"Le Fils de l'Homme s'en va comme l'Ecriture le dit de lui, mais malheur à cet homme par qui le Fils de l'Homme est livré! Il vaudrait mieux pour lui qu'il ne soit pas né.'"
,"22":"Pendant qu'ils mangent, Jésus prend du pain, prononce une bénédiction et le rompt. Puis il le leur donne en disant: 'Prenez, ceci est mon corps.'"
,"23":"Il prend ensuite la coupe, il rend grâces, il la leur donne et ils en boivent tous."
,"24":"Puis il leur dit: 'Ceci est mon sang, le sang de l'alliance, qui est versé pour une multitude."
,"25":"En vérité je vous le dis: Je ne boirai plus du produit de la vigne jusqu'au jour où je le boirai nouveau dans le Royaume de Dieu.'"
,"26":"Après cela ils chantèrent les hymnes et partirent vers le Mont des Oliviers."
,"27":"Alors Jésus leur dit: 'Vous allez tous chuter, car il est écrit: Je frapperai le pasteur et les brebis seront dispersées."
,"28":"Mais quand je me relèverai, j'irai vous attendre en Galilée.'"
,"29":"Pierre alors déclare: 'Même si tous doutent de toi et chutent, moi non!'"
,"30":"Jésus lui répond: 'En vérité, je te le dis, cette nuit même, avant que le coq ne chante pour la seconde fois, toi, tu m'auras renié trois fois.'"
,"31":"Mais lui insistait encore: 'Même si je devais mourir avec toi, je ne te renierais pas.' Et tous disaient la même chose."
,"32":"Ils arrivent à une propriété du nom de Gethsémani et Jésus dit à ses disciples: 'Asseyez-vous là pendant que j'irai prier.'"
,"33":"Il prend avec lui Pierre, Jacques et Jean, et il commence à être envahi par la frayeur et l'angoisse."
,"34":"Il leur dit: 'Mon âme est triste à en mourir, restez ici et veillez.'"
,"35":"Puis il s'éloigne un peu et se prosterne face contre terre; il demande que cette heure passe loin de lui si cela se peut."
,"36":"Et il dit: 'Abba, Père, tout t'est possible, éloigne cette coupe loin de moi! Et cependant, non pas comme je veux, mais comme tu veux.'"
,"37":"Après quoi Jésus va vers les disciples et les trouve endormis; il dit à Pierre: 'Simon, tu dors? Tu n'as pas été capable de rester une heure éveillé?"
,"38":"Veillez et priez pour ne pas être pris dans la tentation. Car l'esprit est plein d'ardeur, mais la chair est faible.'"
,"39":"De nouveau il s'éloigne pour prier et redit les mêmes paroles."
,"40":"Puis il revient vers les disciples et les trouve endormis; leurs yeux étaient lourds de sommeil et ils ne savaient que lui répondre."
,"41":"Une troisième fois il revient et leur dit: 'C'est bien le moment de dormir et de vous reposer! Cette fois l'heure est venue où le Fils de l'Homme est livré aux mains des pécheurs."
,"42":"Levez-vous, allons! Celui qui me livre est proche'."
,"43":"Alors que Jésus parlait encore, arriva Judas, l'un des Douze, et avec lui tout un groupe armé d'épées et de bâtons, envoyé par les chefs des prêtres, les maîtres de la Loi et les Anciens."
,"44":"Celui qui le trahissait leur avait donné un signe: 'Celui que j'embrasserai, c'est lui; arrêtez-le et emmenez-le sous bonne garde.'"
,"45":"Aussitôt arrivé, Judas s'avança vers lui en disant: 'Rabbi!' Et il l'embrassa."
,"46":"Les autres mirent la main sur Jésus et l'arrêtèrent."
,"47":"Un de ceux qui étaient là sortit son épée, frappa le serviteur du Grand Prêtre et lui coupa l'oreille."
,"48":"Alors Jésus prit la parole et leur dit: 'Pour m'arrêter vous êtes venus avec épées et gourdins, comme si j'étais un brigand!"
,"49":"Tous les jours pourtant, j'étais au milieu de vous dans le Temple pour y enseigner et vous ne m'avez pas arrêté. Mais il fallait que s'accomplissent les Ecritures.'"
,"50":"Tous l'abandonnèrent et prirent la fuite."
,"51":"Un jeune homme le suivait, qui n'avait sur lui qu'un drap, et ils l'arrêtèrent."
,"52":"Mais lui s'enfuit tout nu, laissant le drap entre leurs mains."
,"53":"Ils conduisirent alors Jésus chez le Grand Prêtre, et tous les chefs des prêtres, les Anciens et les maîtres de la Loi se rassemblèrent."
,"54":"Pierre avait suivi de loin jusqu'à l'intérieur de la cour du Grand Prêtre; il s'assit et resta à se chauffer près du feu avec les hommes de la police du Temple."
,"55":"Les chefs des prêtres et tout le conseil du Sanhédrin cherchaient un témoignage pour condamner Jésus à mort, mais ils n'en trouvaient pas;"
,"56":"plusieurs avaient témoigné faussement contre Jésus, mais leur témoignage ne concordait pas."
,"57":"Certains lancèrent cette fausse accusation:"
,"58":"'Nous l'avons entendu affirmer: Je détruirai ce Temple, construit de main d'homme, et en trois jours j'en bâtirai un autre qui ne sera pas fait de main d'homme.'"
,"59":"Mais là encore leurs témoignages ne concordaient pas."
,"60":"Alors le Grand Prêtre se lève au milieu du conseil et il interroge Jésus: 'Tu ne réponds rien? Quelle est cette histoire dont ils t'accusent?'"
,"61":"Mais Jésus garde le silence et ne répond rien. De nouveau le Grand Prêtre l'interroge et lui dit: 'Es-tu le Messie, le Fils du Béni?'"
,"62":"Jésus répond: 'Je le suis, et vous verrez le Fils de l'Homme siéger à la droite du Tout-Puissant et venir sur les nuées du ciel. '"
,"63":"Le Grand Prêtre alors déchire sa tunique et dit: 'Qu'avons-nous encore besoin de témoins?"
,"64":"Vous venez d'entendre le blasphème. Quel est votre avis?' Et tous décident qu'il mérite la mort."
,"65":"A ce moment plusieurs se mettent à cracher sur lui, ils lui cachent le visage avec un linge et lui donnent des gifles, puis ils disent: 'Fais le prophète!' Et les auxiliaires de police lui donnaient des coups."
,"66":"Pierre était toujours dehors dans la cour. Arrive une des filles au service du Grand Prêtre;"
,"67":"elle voit Pierre qui se chauffe, elle le dévisage et lui dit: 'Toi aussi tu étais avec Jésus le Nazaréen.'"
,"68":"Mais lui le nie et dit: 'Je ne sais pas ce que tu veux dire, je ne comprends pas.' Et aussitôt, il se dirige vers le vestibule."
,"69":"La servante qui l'a vu dit de nouveau à ceux qui sont là: 'Celui-ci fait partie de la bande.'"
,"70":"Pour la deuxième fois Pierre le nie. Un peu plus tard, ceux qui sont présents relancent Pierre: 'Allons, tu es sûrement l'un des leurs; d'ailleurs tu es de Galilée.' "
,"71":"Mais il commence à lancer des malédictions et à jurer: 'Je ne connais pas cet homme dont vous parlez.'"
,"72":"Et c'est alors le second chant du coq. Pierre alors se rappelle les paroles que Jésus lui a dites: 'Avant que le coq ne chante deux fois, tu m'auras renié trois fois.' Et il commence à pleurer."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Dès le matin, les chefs des prêtres, les Anciens et les maîtres de la Loi, en un mot tout le Sanhédrin, se réunirent en conseil. Après avoir lié Jésus, ils l'emmenèrent et le livrèrent à Pilate."
,"2":"Pilate l'interrogea: 'Es-tu bien le roi des Juifs?' Jésus lui répondit: 'C'est toi qui le dis.'"
,"3":"Les chefs des prêtres lançaient contre lui toutes sortes d'accusations,"
,"4":"aussi Pilate l'interrogea-t-il de nouveau: 'Tu ne réponds rien? Regarde tout ce dont ils t'accusent!'"
,"5":"Mais Jésus ne répondait toujours rien, si bien que Pilate était déconcerté."
,"6":"Chaque année, pour la fête, Pilate leur relâchait un prisonnier, celui qu'ils réclamaient."
,"7":"Or il y avait un certain Barabbas qui était dans les chaînes avec ses complices: ils avaient commis un meurtre au cours d'une émeute."
,"8":"La foule vint donc réclamer ce qu'il leur accordait d'habitude."
,"9":"Pilate leur répondit: 'Voulez-vous que je vous relâche le roi des Juifs?'"
,"10":"Il savait bien en effet, que c'étaient les chefs des prêtres qui le livraient par jalousie."
,"11":"Mais les chefs des prêtres manoeuvrèrent la foule et elle demanda que Pilate relâche plutôt Barabbas."
,"12":"Pilate leur adressa de nouveau la parole: 'Que vais-je donc faire de celui que vous appelez le Roi des Juifs?'"
,"13":"Ils crièrent: 'Mets-le en croix!'"
,"14":"Pilate insista: 'Qu'a-t-il donc fait de mal?' Mais ils crièrent de plus belle: 'Mets-le en croix!'"
,"15":"Pilate leur relâcha donc Barabbas, car il lui fallait contenter la foule; puis il fit flageller Jésus et le livra à ceux qui allaient le crucifier."
,"16":"Les soldats emmènent donc Jésus à l'intérieur de la cour de garde et rassemblent tout le bataillon."
,"17":"Ils le couvrent d'un manteau rouge de l'armée et lui mettent une couronne qu'ils ont tressée avec des épines."
,"18":"Puis ils se mettent à le saluer: 'Salut, roi des Juifs!'"
,"19":"Ils lui frappent la tête avec un roseau, ils crachent sur lui et lui font de grandes salutations en pliant le genou devant lui."
,"20":"Quand ils se sont bien moqués de lui, ils lui enlèvent le manteau rouge, lui remettent ses vêtements et le conduisent dehors pour le crucifier."
,"21":"Pour porter sa croix, les soldats réquisitionnèrent un homme qui passait par là en revenant des champs: c'était Simon de Cyrène, le père d'Alexandre et de Rufus."
,"22":"Ils conduisirent Jésus à l'endroit qu'on appelle Golgotha (ce qui veut dire lieu du Crâne)."
,"23":"Arrivés là, ils lui donnèrent un mélange de vin et de myrrhe mais Jésus ne voulut pas en prendre."
,"24":"Après l'avoir crucifié, ils partagèrent ses vêtements, tirant au sort la part de chacun."
,"25":"On était au milieu de la matinée quand ils le crucifièrent."
,"26":"Une inscription mentionnait le motif de sa condamnation: 'Le roi des Juifs.'"
,"27":"Avec lui on avait crucifié deux brigands, l'un à sa droite et l'autre à sa gauche."
,"28":"Ainsi s'accomplissait l'Ecriture qui dit: Il a été compté parmi les malfaiteurs."
,"29":"Ceux qui passaient l'insultaient. Ils hochaient la tête et disaient: 'Eh! Toi qui détruis le Temple et le rebâtis en trois jours,"
,"30":"sauve-toi toi-même, descends de la croix!'"
,"31":"De même les chefs des prêtres et les maîtres de la Loi ricanaient entre eux: 'Il en a sauvé d'autres, mais il ne se sauvera pas lui-même."
,"32":"Que le Messie, le roi d'Israël, descende maintenant de la croix: alors nous verrons et nous croirons.' Même ceux qu'on avait crucifiés avec lui l'insultaient."
,"33":"Il était environ midi, mais ce fut l'obscurité dans tout le pays jusqu'au milieu de l'après-midi."
,"34":"On était à la neuvième heure du jour lorsque Jésus s'écria d'une voix forte: 'Elôï, Elôï, lama sabacthani? Ce qui veut dire: Mon Dieu, mon Dieu, pourquoi m'as-tu abandonné?'"
,"35":"En l'entendant, plusieurs de ceux qui étaient présents firent cette réflexion: 'Voilà qu'il appelle Elie!'"
,"36":"Quelqu'un courut, remplit une éponge de vinaigre, et la fixa à un roseau pour lui donner à boire; il disait: 'Attendons, Elie viendra peut-être pour le faire descendre.'"
,"37":"C'est alors que Jésus poussa un grand cri et rendit le dernier soupir."
,"38":"Le rideau du Sanctuaire se déchira en deux, du haut en bas,"
,"39":"et au même moment, voyant comment Jésus était mort, l'officier romain qui se tenait en face de lui déclara: 'En vérité cet homme était fils de Dieu.'"
,"40":"Un groupe de femmes regardait à distance; parmi elles se trouvaient Marie de Magdala, Marie, mère de Jacques le petit et de Joset, et Salomé,"
,"41":"qui le suivaient et l'assistaient quand il était en Galilée. Avec elles il y en avait d'autres qui étaient montées avec lui à Jérusalem."
,"42":"On était déjà au soir; comme c'était la Préparation (c'est-à-dire la veille du sabbat),"
,"43":"Joseph d'Arimathie arriva. C'était un membre important du Conseil, et un de ceux qui attendaient le Royaume de Dieu. Il n'hésita pas à se rendre chez Pilate pour demander le corps de Jésus."
,"44":"Pilate s'étonna que Jésus soit déjà mort. Il appela donc l'officier et l'interrogea pour savoir s'il était bien mort depuis un moment."
,"45":"Renseigné par cet officier, Pilate autorisa Joseph à prendre le corps."
,"46":"Il acheta un drap, descendit le corps de la croix et l'enveloppa dans le drap. Puis il le déposa dans un tombeau taillé dans le roc et roula une pierre devant l'entrée du tombeau."
,"47":"Marie de Magdala et Marie, mère de Joset, observaient l'endroit où on le déposait."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Une fois terminé le sabbat, Marie de Magdala, Marie, mère de Jacques, et Salomé achetèrent des parfums afin d'embaumer le corps."
,"2":"De grand matin, le premier jour de la semaine, elles vinrent au tombeau au lever du soleil."
,"3":"Elles s'étaient bien posé la question: 'Qui nous roulera la pierre de devant le tombeau?'"
,"4":"Mais au premier regard, elles virent que la pierre avait été roulée de côté, et il s'agissait d'une pierre énorme."
,"5":"Elles entrent alors dans le tombeau et elles voient un jeune homme assis à droite, vêtu d'une tunique blanche. Elles sont saisies de frayeur,"
,"6":"mais il leur dit: 'Ne vous effrayez pas! Vous cherchez Jésus le Nazaréen, celui qu'on a crucifié? C'est bien ici qu'on l'avait mis, mais il est ressuscité, il n'est pas ici."
,"7":"Allez dire à ses disciples, et à Pierre, qu'il vous précède en Galilée; là vous le verrez comme il vous l'a dit.'"
,"8":"Aussitôt elles sortent du tombeau et prennent la fuite, saisies de frayeur et d'étonnement. Leur peur est telle qu'elles ne disent rien à personne."
,"9":"Ressuscité au matin du premier jour de la semaine, Jésus apparut tout d'abord à Marie de Magdala dont il avait chassé sept démons."
,"10":"Elle alla le dire aux compagnons de Jésus qui étaient tristes et qui pleuraient."
,"11":"Quand ils entendirent qu'il était vivant, qu'elle l'avait vu, ils ne la crurent pas."
,"12":"Après cela Jésus se manifesta sous une autre forme à deux d'entre eux qui s'en allaient à la campagne."
,"13":"Eux aussi allèrent le dire aux autres, mais ils ne les crurent pas davantage."
,"14":"Finalement, Jésus se manifesta aux Onze alors qu'ils étaient à table. Il leur reprocha de manquer de foi, d'être si peu ouverts, et de n'avoir pas cru ceux qui l'avaient vu ressuscité."
,"15":"Puis il leur dit: 'Allez dans le monde entier, portez la Bonne Nouvelle à toute la création."
,"16":"Celui qui croira et sera baptisé, sera sauvé; celui qui ne croira pas, sera condamné."
,"17":"Voici les signes qui accompagneront ceux qui auront cru: par mon Nom ils chasseront les démons et parleront des langues nouvelles."
,"18":"Ils saisiront les serpents, et s'ils boivent un poison mortel, il ne leur fera aucun mal; ils imposeront les mains aux malades et ils seront guéris.'"
,"19":"Après leur avoir parlé, le Seigneur Jésus fut enlevé au ciel et il s'assit à la droite de Dieu."
,"20":"Quant à eux, ils partirent prêcher en tout lieu; le Seigneur était à l'oeuvre avec eux et confirmait leurs paroles par les signes qui l'accompagnaient."
}`)

}
func FR_LBDCC_LoadNEMTChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Livre des origines de Jésus Christ, fils de David et fils d'Abraham."
,"2":"Abraham est le père d'Isaac; Isaac, le père de Jacob; Jacob, le père de Juda et ses frères;"
,"3":"Juda, le père de Farès et Zara, dont la mère est Thamar. Farès est le père d'Esron; Esron, le père d'Aram;"
,"4":"Aram, le père d'Aminadab; Aminadab, le père de Nahason; Nahason, le père de Salmon;"
,"5":"Salmon, le père de Booz, et Rahab est sa mère; Booz est le père de Obed, et Ruth est sa mère; Obed est le père de Jessé;"
,"6":"Jessé, le père du roi David. David est le père de Salomon, dont la mère avait été la femme d'Urie. "
,"7":"Salomon est le père de Roboam; Roboam, le père d'Abias; Abias, le père d'Asaph;"
,"8":"Asaph, le père de Josaphat; Josaphat, le père de Joram; Joram, le père d'Ozias;"
,"9":"Ozias, le père de Joatam; Joatam, le père d'Acaz; Acaz, le père d'Ezéquias;"
,"10":"Ezéquias, le père de Manassé; Manassé, le père d'Amon; Amon, le père de Josias;"
,"11":"Josias, le père de Jéconias et de ses frères avant l'exil à Babylone."
,"12":"Après l'exil à Babylone, c'est Jéconias, le père de Salatiel; Salatiel, le père de Zorobabel;"
,"13":"Zorobabel, le père de Abiud; Abiud, le père d'Eliakim; Eliakim, le père d'Azor;"
,"14":"Azor, le père de Sadoq; Sadoq, le père d'Akim; Akim, le père d'Elioud;"
,"15":"Elioud, le père d'Eléazar; Eléazar, le père de Mathan; Mathan, le père de Jacob;"
,"16":"Jacob, le père de Joseph, l'époux de Marie, et c'est d'elle qu'est né Jésus qu'on appelle Christ."
,"17":"Donc au total, cela fait quatorze générations d'Abraham à David, quatorze générations de David jusqu'à l'exil à Babylone, et quatorze générations depuis l'exil à Babylone jusqu'au Christ."
,"18":"Voici quelle fut l'origine de Jésus, le Christ. Sa mère, Marie, avait été donnée en mariage à Joseph, mais avant qu'ils ne vivent ensemble, elle se trouva enceinte par une intervention de l'Esprit Saint."
,"19":"Joseph, son mari, pensa à la renvoyer. Mais c'était un homme droit et il voulait agir discrètement pour ne pas lui faire du tort."
,"20":"Comme il en était préoccupé, un ange du Seigneur vint se manifester à lui dans un rêve et lui dit: 'Joseph, fils de David, n'aie pas peur de prendre chez toi Marie, ton épouse. La voilà enceinte par l'intervention de l'Esprit Saint;"
,"21":"elle mettra au monde un fils et tu lui donneras le nom de Jésus; car c'est lui qui sauvera son peuple de ses péchés.'"
,"22":"Tout cela fut donc l'accomplissement de ce que le Seigneur avait dit par la bouche du prophète:"
,"23":"Voici que la vierge est enceinte et met au monde un fils. On l'appellera Emmanuel, ce qui veut dire Dieu-avec-nous."
,"24":"Quand Joseph se réveilla, il fit ce que l'ange lui avait ordonné et il prit avec lui son épouse."
,"25":"Il n'avait donc pas eu de relations avec elle quand elle mit au monde un fils; il lui donna le nom de Jésus."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Jésus était né à Bethléem de Juda, au temps du roi Hérode; alors, des pays de l'Orient, des mages arrivèrent à Jérusalem"
,"2":"et demandèrent: 'Où se trouve le roi des Juifs qui vient de naître? Nous avons vu son étoile à l'orient et nous sommes venus pour lui rendre hommage.'"
,"3":"Quand le roi Hérode l'apprit, il en eut un choc, et tout Jérusalem avec lui."
,"4":"Il réunit tous les chefs des prêtres et ceux qui enseignaient la religion au peuple, car il voulait leur faire préciser où devait naître le Christ."
,"5":"Ils lui firent cette ré ponse: 'C'est à Bethléem de Juda. Car il est écrit dans le livre du prophète:"
,"6":"Toi, Bethléem en Juda, tu n'es pas le dernier des chef-lieux de Juda, car c'est de toi que sortira le chef, le pasteur de mon peuple Israël.'"
,"7":"Alors Hérode convoqua les mages en secret et leur fit préciser le moment où l'étoile leur était apparue."
,"8":"Il les mit sur le chemin de Bethléem et leur dit: 'Allez là-bas et tâchez de bien vous informer sur cet enfant. Si vous le trouvez, vous me le direz, et moi aussi j'irai lui rendre hommage.'"
,"9":"Après cette entrevue avec le roi ils se mirent en route, et voici que l'étoile qu'ils avaient vue en Orient les conduisait. Finalement elle s'arrêta au dessus de l'endroit où se trouvait l'enfant."
,"10":"Revoir l'étoile fut pour eux une grande joie;"
,"11":"ils entrèrent dans la maison, ils virent l'enfant avec Marie sa mère et ils se prosternèrent pour l'adorer. Ils ouvrirent alors leurs coffres et lui firent des cadeaux: de l'or, de l'encens et de la myrrhe."
,"12":"Ils reçurent alors un avertissement au moyen d'un rêve: ils ne devaient pas revoir Hérode. Ils repartirent donc vers leur pays par un autre chemin."
,"13":"Après le départ des mages, un ange du Seigneur vint se manifester à Joseph au cours d'un rêve. Il lui dit: 'Lève-toi, prends l'enfant et sa mère et va te réfugier au pays d'Egypte. Tu y resteras jusqu'à ce que je te le dise, car Hérode va rechercher l'enfant pour le faire périr.'"
,"14":"Joseph se leva aussitôt; cette même nuit il prit l'enfant et sa mère et partit au loin vers l'Egypte."
,"15":"Il y resta jusqu'à la mort d'Hérode et de cette façon s'accomplit ce que le Seigneur avait dit par la bouche du prophète: J'ai fait revenir mon fils d'Egypte."
,"16":"Quand Hérode se rendit compte qu'il s'était laissé avoir par les mages, il devint furieux. Il envoya massacrer tous les enfants de Bethléem et des environs, tous ceux qui avaient moins de deux ans, selon les précisions que lui avaient données les mages."
,"17":"De cette façon s'accomplit ce qui avait été dit par le prophète Jérémie:"
,"18":"On a entendu des cris à Rama, on gémit et on ne finit pas de se lamenter. C'est Rachel qui pleure ses enfants; ils ne sont plus, et elle ne veut pas s'en consoler."
,"19":"Après la mort d'Hérode, voilà qu'un ange du Seigneur apparaît à Joseph en Egypte au cours d'un rêve;"
,"20":"il lui dit: 'Lève-toi, prends l'enfant et sa mère et retourne au pays d'Israël, car ils sont morts, ceux qui en voulaient à la vie de l'enfant.'"
,"21":"Quand Joseph se réveille, il prend l'enfant et sa mère pour rentrer au pays d'Israël."
,"22":"Mais lorsqu'il apprend qu'Arkelaüs règne en Judée à la place de son père Hérode, il a peur d'y retourner. Ayant reçu des instructions au cours d'un rêve, il s'éloigne vers la Galilée"
,"23":"et il s'y établit dans un village appelé Nazareth. De cette façon s'accomplira ce qui a été dit par la bouche des prophètes: On l'appellera Nazaréen."
}`)
	CurrentBook.AddChapter(3, `{
"1":"En ces jours-là, Jean le Baptiseur fait son apparition et commence à prêcher dans le désert de Juda"
,"2":"avec ce message: 'Convertissez-vous, car le règne de Dieu est tout proche.'"
,"3":"C'était bien Jean que le prophète Isaïe avait en vue quand il disait: Une voix crie dans le désert: Préparez le chemin du Seigneur, aplanissez le sol devant lui."
,"4":"Jean avait un manteau en poils de chameau et un pagne de peau autour des reins; il se nourrissait de sauterelles et de miel d'abeilles sauvages."
,"5":"On se mettait en marche vers lui de Jérusalem, de toute la Judée et de la vallée du Jourdain;"
,"6":"les gens confessaient leurs péchés et se faisaient baptiser dans les eaux du Jourdain."
,"7":"Jean vit arriver sur les lieux du baptême un certain nombre de Pharisiens et de Saducéens. Il leur dit: 'Race de vipères, qui vous donnera le moyen d'échapper à la Colère qui vient?"
,"8":"Convertissez-vous et qu'on en voie le fruit."
,"9":"Ne croyez pas qu'il vous suffira de dire: Abraham est notre père! Car, je vous le dis, Dieu est capable de faire sortir même de ces pierres des enfants d'Abraham."
,"10":"Déjà la hache est au pied de l'arbre: tout arbre qui ne produit pas de bons fruits va être abattu et jeté au feu."
,"11":"Moi je vous donne un baptême d'eau, en vue d'une conversion, mais derrière moi vient un autre plus fort que moi, et je ne mérite même pas de lui présenter ses sandales. Lui vous baptisera dans l'Esprit Saint et dans le feu."
,"12":"Il tient déjà la pelle en main pour nettoyer son blé; il amassera le grain dans son grenier et brûlera la paille dans le feu qui ne s'éteint pas.'"
,"13":"C'est alors que Jésus vient de la Galilée au Jourdain pour trouver Jean et se faire baptiser par lui."
,"14":"Jean cherche à l'en détourner: 'Quoi? Tu viens à moi? C'est moi qui devrais me faire baptiser par toi!'"
,"15":"Mais Jésus lui répond: 'Laisse donc, c'est seulement de cette façon que tout sera dans l'ordre.' Alors Jean le laisse faire."
,"16":"Le baptême terminé, Jésus sortit des eaux. Alors les cieux s'ouvrirent et Jésus vit l'Esprit de Dieu qui descendait comme fait la colombe et s'arrêtait sur lui."
,"17":"Une voix se fit entendre, venant du Ciel: 'C'est lui mon Fils, le Bien-Aimé, celui en qui je me complais.'"
}`)
	CurrentBook.AddChapter(4, `{
"1":"Jésus fut alors conduit par l'Esprit au désert pour y être tenté par le diable."
,"2":"Il resta quarante jours et quarante nuits sans manger, après quoi il eut faim."
,"3":"Le tentateur s'approche donc et lui dit: 'Si tu es Fils de Dieu, dis à ces pierres qu'elles deviennent des pains.'"
,"4":"Mais Jésus lui répond: 'Il est écrit que l'homme ne vit pas seulement de pain, mais de toute parole qui sort de la bouche de Dieu.'"
,"5":"Alors le diable l'emmène à la Ville Sainte et le dépose sur le rempart du Temple."
,"6":"Et il lui dit: 'Si tu es Fils de Dieu, jette-toi en bas, car il est écrit: Il a donné pour toi un ordre à ses anges; de leurs mains ils te tiendront, de peur que ton pied ne heurte quelque pierre."
,"7":"Mais Jésus lui répond: 'Il est écrit aussi: Tu ne mettras pas au défi le Seigneur ton Dieu.'"
,"8":"Une fois encore le diable l'emmène à une très haute montagne et lui montre toutes les nations du monde, dans toute leur splendeur."
,"9":"Et il lui dit: 'Je te donnerai tout cela si tu tombes à mes pieds pour m'adorer.'"
,"10":"Mais Jésus lui dit: 'Retire-toi, Satan; car il est écrit: Tu adoreras le Seigneur ton Dieu, c'est lui seul que tu serviras.'"
,"11":"Alors le diable le laisse. Aussitôt des anges s'approchent, et ils le servent."
,"12":"Quand Jésus apprend que Jean a été arrêté, il s'éloigne et va en Galilée."
,"13":"Là il laisse Nazareth et vient séjourner à Capharnaüm, sur le bord de mer, à la frontière de Zabulon et de Nephtali."
,"14":"Ainsi va s'accomplir ce qu'a dit le prophète Isaïe:"
,"15":"Ecoutez, terres de Zabulon et de Nephtali, route de la mer et rives du Jourdain, et toi Galilée province des païens!"
,"16":"Le peuple jeté dans les ténèbres a vu une grande lumière. Pour ceux qui restaient dans l'ombre, au pays de la mort, une lumière s'est levée."
,"17":"Dès ce moment Jésus commença à proclamer son message. Il disait: 'Convertissez-vous, car le Règne de Dieu est là.'"
,"18":"Comme Jésus passait le long de la mer de Galilée, il y avait là deux frères, Simon qu'on appelle Pierre, et André son frère. Il les vit qui jetaient leurs filets dans la mer, car ils étaient pêcheurs,"
,"19":"et il leur dit: 'Venez, suivez-moi. Je ferai de vous des pêcheurs d'hommes.'"
,"20":"Aussitôt ils laissèrent leurs filets et le suivirent."
,"21":"Un peu plus loin, Jésus vit encore deux frères, Jacques fils de Zébédée, et Jean son frère; ils étaient avec leur père Zébédée dans la barque, en train d'arranger leurs filets. Jésus les appela;"
,"22":"aussitôt ils laissèrent leur père avec la barque et commencèrent à le suivre."
,"23":"Jésus circulait dans toute la Galilée. Il les enseignait dans leurs synagogues, il proclamait la Bonne Nouvelle du Royaume et guérissait le peuple de tout mal et maladie."
,"24":"On entendait parler de lui dans toute la province de Syrie. On lui amenait tous ceux qui allaient mal, des gens atteints de douleurs ou de maladies diverses, ou qui avaient un démon, ainsi que des épileptiques et des paralysés: Jésus les guérissait tous."
,"25":"Des foules commencèrent à le suivre; on venait de la Galilée, de la Décapole, de Jérusalem, de Judée et de l'autre rive du Jourdain."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Quand Jésus vit tout ce peuple, il gravit la montagne. Là il s'assit et ses disciples s'approchèrent de lui,"
,"2":"il ouvrit la bouche et commença à les enseigner:"
,"3":"'Heureux ceux qui ont un coeur de pauvre, le Royaume des Cieux est à eux."
,"4":"Heureux les doux, ils auront la terre en héritage."
,"5":"Heureux ceux qui sont dans le deuil, ils seront réconfortés."
,"6":"Heureux ceux qui ont faim et soif de la justice, ils seront rassasiés."
,"7":"Heureux les miséricordieux, ils auront droit à la miséricorde."
,"8":"Heureux ceux qui ont le coeur pur, ils verront Dieu."
,"9":"Heureux ceux qui sèment la paix, ils seront appelés enfants de Dieu."
,"10":"Heureux ceux qui sont persécutés quand ils agissent en toute droiture, le Royaume des Cieux est à eux."
,"11":"Oui, heureux serez-vous quand on vous insultera à cause de moi, et qu'on vous poursuivra, et qu'on dira sur vous toute sorte de calomnies."
,"12":"Soyez heureux, soyez joyeux, car vous avez dans les cieux une belle récompense. On poursuivait tout pareillement les prophètes qui étaient avant vous.'"
,"13":"'Vous êtes le sel de la terre. Mais si le sel perd son mordant, avec quoi le salera-t-on? Il ne sert plus à rien; on le jette dehors et il sera piétiné."
,"14":"Vous êtes la lumière du monde. Comment cacher une ville bâtie au sommet de la montagne?"
,"15":"Personne n'allume une lampe pour la mettre sous un meuble: on la met sur un lampadaire, et elle donne sa lumière à toute la maison."
,"16":"Que votre lumière, de même, brille devant les hommes: qu'ils voient vos bonnes oeuvres, et qu'ils rendent gloire à votre Père qui est dans les Cieux.'"
,"17":"'Ne croyez pas que je suis venu défaire la Loi et les Prophètes: je ne suis pas venu pour défaire, mais pour amener à l'état parfait."
,"18":"En vérité, je vous le dis, pas une lettre, pas une virgule de la Loi ne passera avant que ne passent le ciel et la terre: tout se réalisera."
,"19":"Si quelqu'un écarte un des plus petits commandements et enseigne aux autres à faire de même, il sera mis au dernier rang dans le Royaume des Cieux. Mais si quelqu'un les met en pratique et les enseigne, celui-là sera grand dans le Royaume des Cieux."
,"20":"Je vous le dis: si votre idéal de perfection ne dépasse pas celui des maîtres de la Loi et des Pharisiens, vous ne pouvez pas entrer dans le Royaume des Cieux."
,"21":"Vous venez d'entendre qu'on a dit à vos ancêtres: Tu ne tueras pas. Si quelqu'un a tué, il doit passer en jugement."
,"22":"Mais moi je vous dis: si quelqu'un se met en colère contre son frère, il mérite un jugement; si quelqu'un traite son frère de fou, il mérite une sentence du Conseil suprême; s'il lui a dit: Sois maudit! il mérite d'aller à l'enfer du feu."
,"23":"Quand donc tu t'avances pour présenter à l'autel ton offrande, si tu te souviens alors que ton frère a quelque chose à te reprocher,"
,"24":"laisse là devant l'autel ton offrande, et va d'abord te réconcilier avec ton frère. Ensuite tu reviendras présenter ton offrande."
,"25":"Trouve tout de suite un accord avec ton adversaire pendant que vous êtes en chemin l'un et l'autre. Ton adversaire peut-être te mettrait entre les mains du juge, le juge te remettrait au policier et tu serais mis en prison."
,"26":"En vérité, je te le dis, tu n'en sortiras pas tant que tu n'auras pas payé le dernier centime."
,"27":"Vous venez d'entendre qu'il a été dit: Tu ne commettras pas d'adultère."
,"28":"Mais moi je vous dis: celui qui regarde une femme pour satisfaire son désir a déjà commis l'adultère dans son coeur."
,"29":"Si ton oeil droit te mène à la chute, arrache-le et jette-le loin de toi. Il vaut mieux pour toi perdre un de tes membres plutôt que d'avoir ton corps entier jeté dans l'enfer du feu."
,"30":"Et si c'est ta main droite qui te mène à la chute, coupe-la et jette-la. C'est ton intérêt de perdre un de tes membres plutôt que d'avoir ton corps jeté tout entier dans la géhenne."
,"31":"Il a été dit: Celui qui renvoie sa femme devra lui donner un billet de divorce."
,"32":"Mais moi je vous dis: celui qui renvoie sa femme, sauf pour infidélité, la fait devenir adultère. Et celui qui épouse cette femme renvoyée commet lui aussi un adultère.'"
,"33":"'Vous avez entendu qu'on a dit à vos ancêtres: Tu ne reviendras pas sur tes serments; tu donneras au Seigneur ce que tu as juré."
,"34":"Mais moi je vous dis de ne pas jurer du tout: ni par le ciel, parce que c'est le trône de Dieu,"
,"35":"ni par la terre, parce que c'est son marchepied, ni par Jérusalem, parce que c'est la ville du grand Roi."
,"36":"Tu ne jureras pas davantage par ta tête parce que tu ne peux même pas rendre noir ou blanc un seul de tes cheveux."
,"37":"Donc, que votre 'oui' soit oui, et votre 'non', non; tout le reste vient du démon."
,"38":"'Vous avez entendu qu'il a été dit: OEil pour oeil, dent pour dent."
,"39":"Mais moi je vous dis de ne pas résister au méchant. Si on te frappe sur la joue droite, présente encore l'autre joue."
,"40":"Et si quelqu'un veut te réclamer ta tunique, donne-lui aussi ton manteau."
,"41":"Si quelqu'un t'impose une corvée, un kilomètre à faire, fais-en deux avec lui."
,"42":"Donne à celui qui te demande et ne te détourne pas de celui qui veut t'emprunter."
,"43":"Vous avez entendu qu'il a été dit: Tu aimeras ton prochain et tu ne feras pas de cadeau à ton ennemi."
,"44":"Mais moi je vous dis: aimez vos ennemis et priez pour ceux qui vous persécutent."
,"45":"C'est ainsi que vous serez les fils de votre Père des Cieux, lui qui fait briller le soleil sur les méchants comme sur les bons, et qui fait pleuvoir pour les gens honnêtes comme pour les malhonnêtes."
,"46":"D'ailleurs, quand vous aimez ceux qui vous aiment, quelle récompense méritez-vous? Même les publicains le font."
,"47":"Et si vous saluez seulement ceux qui sont de votre bord, que faites-vous d'extraordinaire? Les païens eux-mêmes le font."
,"48":"Donc vous, vous serez parfaits comme votre Père du Ciel est parfait.'"
}`)
	CurrentBook.AddChapter(6, `{
"1":"'Evitez de faire vos bonnes actions devant les gens de façon à ce qu'ils vous remarquent. Car alors vous n'avez pas de récompense à attendre de votre Père des Cieux."
,"2":"Donc, si tu donnes aux pauvres, ne fais pas sonner la trompette devant toi; n'imite pas ceux qui jouent la comédie dans les synagogues et dans les rues, et qui veulent que les gens les admirent. En vérité, je vous le dis, ils ont déjà leur récompense."
,"3":"Pour toi, par contre, que ta main gauche ignore ce que fait ta main droite quand elle donne aux pauvres;"
,"4":"ainsi ton aumône restera chose secrète, et ton Père qui voit dans le secret te le rendra."
,"5":"Quand vous priez, n'imitez pas ceux qui jouent la comédie. Ils aiment se planter en prière dans les synagogues, ou à l'angle de la place, pour que les gens les remarquent. En vérité, je vous le dis, ils ont déjà leur récompense."
,"6":"Toi, au contraire, quand tu veux prier, entre dans ta chambre et ferme la porte afin de prier ton Père qui est là dans le secret; et ton Père qui voit dans le secret te le rendra."
,"7":"Quand vous priez, pas de discours interminables comme en font les païens: ils croient qu'à force de parler ils seront entendus."
,"8":"Ne leur ressemblez pas. Pensez-y: avant même que vous ne demandiez, votre Père sait de quoi vous avez besoin.'"
,"9":"'Vous donc priez ainsi: Notre Père qui es dans les cieux, que ton Nom soit sanctifié,"
,"10":"que ton règne vienne, que ta volonté se fasse,sur la terre comme au ciel."
,"11":"Donne-nous aujourd'hui le pain qu'il nous faut;"
,"12":"pardonne-nous, toi, nos dettes, comme nous l'avons fait pour ceux qui nous doivent,"
,"13":"et ne nous laisse pas tomber dans la tentation, mais délivre-nous du Mauvais."
,"14":"Sachez-le: si vous pardonnez aux autres leurs offenses, votre Père céleste vous pardonnera aussi."
,"15":"Mais si vous ne pardonnez pas aux autres, votre Père non plus ne vous pardonnera pas vos offenses."
,"16":"Et quand vous jeûnez, ne prenez pas un air triste comme ceux qui jouent la comédie; ils se font une figure transparente pour que les gens voient bien qu'ils jeûnent. En vérité, je vous le dis, ils tiennent déjà leur récompense."
,"17":"Toi, par contre, le jour où tu jeûnes, parfume ta tête et lave-toi le visage."
,"18":"Ainsi ton jeûne ne sera pas remarqué par les autres, mais par ton Père qui est là dans le secret, et ton Père qui est là dans le secret te le rendra."
,"19":"N'amassez pas richesses et réserves sur cette terre, là où les mites et les vers font des ravages, là où les voleurs percent le mur et emportent tout."
,"20":"Amassez-vous richesses et réserves dans le Ciel, là où il n'y a ni mites ni vers pour faire des ravages, et pas de voleurs pour percer le mur et tout emporter."
,"21":"Oui! Là où est ton trésor, là aussi sera ton coeur."
,"22":"L'oeil est ta lampe. Si tu as l'oeil sain, toute ta personne profite de la lumière."
,"23":"Mais si ton oeil est mauvais, ton être entier est dans le noir. Si la lumière qui était en toi est devenue ténèbres, que deviendront tes propres ténèbres!'"
,"24":"'Personne ne peut servir bien deux maîtres; il détestera l'un et aimera l'autre, ou bien il soignera le premier et se moquera de l'autre. Vous ne pouvez pas servir Dieu et le Dieu-Argent."
,"25":"C'est pourquoi je vous dis: ne vous tourmentez pas pour votre vie avec des questions de nourriture, ni pour votre corps avec des questions de vêtement. La vie n'est-elle pas plus que la nourriture et le corps plus que le vêtement?"
,"26":"Regardez les oiseaux du ciel: ils ne sèment pas, ils ne moissonnent pas, ils n'ont pas de réserves ni de greniers, mais votre Père du Ciel les nourrit. Et vous alors? Ne valez-vous pas beaucoup plus qu'eux?"
,"27":"Qui d'entre vous, à force de s'inquiéter, pourra prolonger sa vie d'une seule coudée?"
,"28":"Et le vêtement, pourquoi vous en préoccuper? Voyez comment sortent les lys des champs et instruisez-vous. Ils ne peinent pas, ils ne tissent pas,"
,"29":"mais je vous dis que Salomon dans toute sa gloire n'était pas habillé comme l'un d'eux."
,"30":"Si Dieu habille ainsi la plante sauvage qui aujourd'hui se dresse mais demain sera jetée au four, ne fera-t-il pas beaucoup mieux pour vous? Vous avez bien peu la foi!"
,"31":"Donc laissez-là vos inquiétudes: Qu'allons-nous manger? Qu'allons-nous boire? Comment nous habiller?"
,"32":"laissez les païens courir après toutes ces choses, car votre Père du ciel sait que tout cela vous est nécessaire."
,"33":"Cherchez d'abord son royaume et sa justice, et tout le reste vous sera donné en plus."
,"34":"Cessez de vous inquiéter pour demain et demain s'inquiétera pour lui-même: à chaque jour suffit sa peine.'"
}`)
	CurrentBook.AddChapter(7, `{
"1":"'Ne jugez pas et vous ne serez pas jugés."
,"2":"Car vous serez jugés de la même façon que vous jugez les autres, et la mesure que vous utilisez servira aussi pour vous."
,"3":"Quoi! Tu vois la paille dans l'oeil de ton frère et tu ne remarques pas la poutre qui est dans le tien?"
,"4":"Et tu vas dire à ton frère: 'Laisse-moi t'enlever de l'oeil cette paille', alors que la poutre reste là dans ton oeil!"
,"5":"Mais tu joues la comédie! Enlève d'abord de ton oeil la poutre, et ensuite tu verras comment enlever la paille de l'oeil de ton frère."
,"6":"Ne donnez pas aux chiens ce qui est saint, n'étalez pas vos perles à la vue des porcs; ils pourraient bien les piétiner, et se retourner ensuite pour vous déchirer."
,"7":"Demandez et l'on vous donnera, cherchez et vous trouverez, frappez à la porte et l'on vous ouvrira;"
,"8":"car quiconque demande reçoit, celui qui cherche trouve, et l'on ouvre à celui qui frappe."
,"9":"Si votre fils vous demande du pain, lui donnerez-vous une pierre?"
,"10":"Et s'il demande du poisson, lui donnerez-vous un serpent?"
,"11":"Mauvais comme vous êtes, vous savez donner de bonnes choses à vos enfants: combien plus alors votre Père qui est dans les cieux donnera-t-il de bonnes choses à ceux qui le prient."
,"12":"Faites donc pour les autres tout ce que vous voulez qu'on fasse pour vous, c'est bien ce que disent la Loi et les Prophètes."
,"13":"Entrez par la porte étroite. Oui, grande ouverte est la porte, large est le chemin qui mène à la perdition, et c'est une foule qui s'y engage."
,"14":"Mais comme elle est étroite la porte qui mène à la vie, comme le chemin en est resserré! Et ceux qui le trouvent sont bien peu.'"
,"15":"'Méfiez-vous des faux prophètes! Ils arrivent chez vous avec leur peau de mouton, mais à l'intérieur ce sont des loups prêts à dévorer."
,"16":"Vous les reconnaîtrez à leurs fruits. Iriez-vous chercher des raisins dans les épines ou des figues sur les ronces?"
,"17":"C'est la même chose pour tout arbre sain: il produit de bons fruits; et tout arbre malade produit de mauvais fruits."
,"18":"Un arbre sain ne peut pas produire de mauvais fruits, et un arbre malade ne peut pas produire de bons fruits."
,"19":"Mais tout arbre qui ne donne pas de beaux fruits, on le coupe et on le jette au feu."
,"20":"Donc vous les reconnaîtrez à leurs fruits.'"
,"21":"'Il ne suffira pas de me dire: 'Seigneur! Seigneur!' pour entrer dans le Royaume des Cieux; entrera celui qui fait la volonté de mon Père des cieux."
,"22":"Beaucoup me diront en ce jour-là: 'Seigneur, Seigneur, nous avons prophétisé en ton nom; nous avons chassé les démons grâce à ton nom; nous avons fait par ton Nom beaucoup de miracles.'"
,"23":"Mais alors je leur dirai en face: 'Je ne vous ai jamais connus, éloignez-vous de moi, vous tous qui travaillez pour le mal.'"
,"24":"C'est pourquoi, si quelqu'un écoute mes paroles que voilà et les met en pratique, on pourra dire de lui: Voici un homme avisé qui a bâti sa maison sur le roc."
,"25":"L'averse est tombée, les torrents sont venus et les vents ont soufflé; ils se sont jetés sur cette maison, mais elle ne s'est pas écroulée car elle était fondée sur le roc."
,"26":"Par contre, si quelqu'un écoute mes paroles que voilà et ne les met pas en pratique, on pourra dire de lui: Voici un homme sans cervelle qui a bâti sa maison sur le sable."
,"27":"L'averse est tombée, les torrents sont venus et les vents ont soufflé; ils se sont jetés sur cette maison et elle s'est écroulée: ce fut un vrai désastre!'"
,"28":"Quand Jésus termina ce discours, son enseignement avait beaucoup frappé les foules;"
,"29":"c'est qu'il les enseignait avec autorité et non pas comme leurs maîtres de la Loi."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Jésus descendit de la montagne et une foule nombreuse se mit à le suivre."
,"2":"Alors s'approche un lépreux, il se prosterne devant lui en disant: 'Seigneur, si tu veux, tu peux me purifier.'"
,"3":"Jésus étend la main et le touche en disant: 'Eh bien, je le veux, sois purifié!' Et aussitôt il est pur: plus de lèpre."
,"4":"Alors Jésus lui dit: 'Ecoute bien, n'en parle à personne, mais va te montrer aux prêtres et présente l'offrande comme Moïse l'a ordonné: tu feras ainsi ta déclaration.'"
,"5":"Comme Jésus partait pour Capharnaüm, un officier s'approcha et lui fit cette demande:"
,"6":"'Seigneur, mon serviteur est au lit à la maison. Il est paralysé et il souffre terriblement.'"
,"7":"Jésus lui dit: 'J'y vais et je le guérirai.'"
,"8":"L'officier répondit: 'Seigneur, qui suis-je pour que tu viennes sous mon toit? Dis un mot seulement et mon serviteur sera guéri."
,"9":"Moi-même j'obéis, mais j'ai aussi des soldats sous mes ordres. Quand je dis à l'un: Pars! il part. Je dis à un autre: Viens! et il vient. Je dis à mon serviteur: Fais cela! et il le fait.'"
,"10":"Jésus l'écoutait, et il en était dans l'admiration. Alors il déclara à ceux qui l'accompagnaient: 'En vérité, je vous le dis, je n'ai rencontré une telle foi chez personne en Israël."
,"11":"Je vous l'affirme: beaucoup viendront de l'orient et de l'occident et seront au festin avec Abraham, Isaac et Jacob dans le Royaume des Cieux."
,"12":"Et par contre, ceux pour qui était le Royaume seront jetés dehors dans les ténèbres. Là il y aura pleurs et grincements de dents.'"
,"13":"Alors Jésus dit à l'officier: 'Va, et que tout se fasse pour toi comme tu as cru.' A l'instant même le serviteur fut guéri."
,"14":"Jésus arriva à la maison de Pierre; il y trouva la belle-mère de ce dernier au lit avec de la fièvre."
,"15":"Il lui prit alors la main et la fièvre tomba. Elle se leva et se mit à leur faire le service."
,"16":"Le soir venu, on commença à lui amener des personnes qui souffraient de divers démons. D'un mot il chassa les esprits, et il guérit tous ceux qui allaient mal."
,"17":"Ainsi s'accomplissait la parole dite autrefois par le prophète Isaïe: Il a pris nos faiblesses, lui-même a porté nos maladies."
,"18":"Comme Jésus se voyait pressé par la foule, il donna l'ordre de passer sur l'autre rive."
,"19":"A ce moment-là, un expert de la Loi s'approcha pour lui dire: 'Maître, je suis prêt à te suivre partout où tu iras!'"
,"20":"Jésus lui répondit: 'Les renards ont un terrier, les oiseaux du ciel ont un nid; mais le Fils de l'Homme n'a pas où reposer sa tête.'"
,"21":"Un autre disciple de Jésus lui dit: 'Seigneur, permets-moi d'abord de retourner, que je puisse enterrer mon père.'"
,"22":"Jésus lui dit: 'Suis-moi, et laisse les morts enterrer leurs morts.'"
,"23":"Jésus monta dans la barque et ses disciples le suivirent."
,"24":"Mais la mer devint de plus en plus agitée, si bien que des vagues passaient par-dessus la barque; et lui dormait."
,"25":"Ils s'approchent donc et le réveillent en lui disant: 'Seigneur, sauve-nous, nous sommes perdus!'"
,"26":"Mais lui leur dit: 'Comme vous êtes peureux, gens de peu de foi!' Jésus se lève alors, il rappelle à l'ordre les vents et la mer, et c'est le grand calme."
,"27":"Les gens en étaient tout étonnés; ils disaient: 'Mais que peut-il bien être? Même les vents et la mer lui obéissent!'"
,"28":"Quand Jésus atteignit le rivage, sur le territoire de Gadara, deux possédés du démon sortirent du milieu des tombes et vinrent à sa rencontre. C'étaient des hommes si sauvages que personne ne pouvait passer sur ce chemin."
,"29":"Et voici qu'ils se mettent à crier: 'Qu'est-ce que tu nous veux, fils de Dieu? Es-tu venu pour nous torturer avant l'heure?'"
,"30":"A une certaine distance il y avait un troupeau de cochons qui cherchaient leur nourriture."
,"31":"Les démons lui font alors cette demande: 'Si tu veux nous mettre dehors, envoie-nous dans ce troupeau de cochons.'"
,"32":"Jésus leur dit: 'Allez.' Ils sortent donc et s'en vont vers les cochons, et voilà tout le troupeau qui dévale la pente jusqu'à la mer où les bêtes se noient."
,"33":"Les gardiens de cochons s'enfuient vers la ville et, quand ils arrivent, ils racontent l'affaire des possédés."
,"34":"Tous les gens de la ville sortent alors de chez eux à la rencontre de Jésus et, aussitôt qu'ils le voient, ils lui demandent de quitter leur territoire."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Jésus monta dans la barque pour faire la traversée et il arriva dans sa ville."
,"2":"A ce moment on lui amena un homme paralysé, étendu sur un brancard. Jésus vit la foi de ces gens et il dit au paralysé: 'Courage, mon gars, tes péchés sont pardonnés!'"
,"3":"Il y avait là des maîtres de la Loi; aussitôt ils se disent: 'Cet homme se moque de Dieu!'"
,"4":"Mais Jésus a vu ce qu'ils pensent, et il leur dit: 'Pourquoi faites-vous ces réflexions méchantes?"
,"5":"Quel est le plus facile à dire: Tes péchés sont pardonnés, ou: Lève-toi et marche?"
,"6":"Sachez donc que le Fils de l'Homme a autorité sur la terre pour pardonner les péchés.',Alors Jésus dit au paralysé: 'Lève-toi, prends ton brancard et rentre chez toi.'"
,"7":"Aussitôt l'homme se leva et rentra chez lui."
,"8":"En voyant cela la foule fut saisie de crainte; elle rendait gloire à Dieu pour avoir donné un tel pouvoir à des humains."
,"9":"Jésus s'en alla plus loin et vit celui qui était à la douane. Il dit à cet homme, un dénommé Matthieu: 'Suis-moi!' L'autre se leva et se mit à le suivre."
,"10":"Comme Jésus était là à table dans la maison, un certain nombre de collecteurs de l'impôt et d'autres pécheurs étaient installés avec Jésus et ses disciples."
,"11":"En voyant cela, les Pharisiens commencent à discuter avec ses disciples: 'Comment votre maître peut-il manger avec des collecteurs de l'impôt et des pécheurs?'"
,"12":"Mais Jésus l'entend et leur dit: 'Ce ne sont pas les bien-portants qui ont besoin d'un médecin, mais les malades."
,"13":"Allez donc apprendre ce que veut dire cette parole: C'est la miséricorde que j'aime, non les offrandes! Je ne suis pas venu, moi, pour appeler des justes mais des pécheurs.'"
,"14":"A leur tour les disciples de Jean s'approchent et lui disent: 'Nous jeûnons souvent et les Pharisiens également; pourquoi tes disciples n'ont-ils pas de jours de jeûne?'"
,"15":"Jésus leur répond: 'Vous ne pouvez tout de même pas imposer le deuil aux compagnons du nouvel époux tant que l'époux est avec eux. Le jour viendra où l'époux leur sera enlevé; alors ils jeûneront."
,"16":"On ne rapièce pas un vieux vêtement avec une pièce de tissu qui n'a pas encore été lavé; sinon la pièce tire sur le vêtement et la déchirure devient pire."
,"17":"On ne met pas non plus du vin nouveau dans de vieilles outres; sinon les outres craquent, le vin se répand et les outres sont perdues. On met le vin nouveau dans des outres neuves, et ils se conservent pareillement.'"
,"18":"Comme Jésus leur parlait, voici qu'un chef arrive et se prosterne devant lui en disant: 'Ma fille vient de mourir. Viens pourtant, tu lui imposeras la main et elle vivra.'"
,"19":"Jésus se leva donc pour l'accompagner avec ses disciples."
,"20":"C'est alors qu'une femme s'approcha par derrière et vint toucher la frange de son manteau. Cette femme souffrait de pertes de sang depuis une douzaine d'années"
,"21":"et elle se disait: 'Si je pouvais seulement toucher son vêtement, je serais sauvée!'"
,"22":"Jésus se retourna et, la voyant, il lui dit: 'Courage, ma fille, ta foi t'a sauvée.' Et dès ce moment la femme fut sauvée."
,"23":"Lorsque Jésus arriva à la maison du chef, il vit les joueurs de flûte et tous les gens qui faisaient du tapage."
,"24":"Et il leur dit: 'Retirez-vous, la fillette dort, elle n'est pas morte!' Les gens se moquaient de lui."
,"25":"On les mit pourtant dehors, et lui entra. Il prit la fillette par la main et elle se leva."
,"26":"Cette affaire fit du bruit dans toute la région."
,"27":"Comme Jésus quittait cet endroit, deux aveugles le suivirent qui criaient par derrière: 'Fils de David, aie pitié de nous!'"
,"28":"Au moment où Jésus entra dans la maison, les aveugles s'approchèrent et Jésus leur dit: 'Croyez-vous vraiment que je peux le faire?' Ils répondirent: 'Oui, Seigneur.'"
,"29":"Alors Jésus toucha leurs yeux et dit: 'Qu'il vous arrive comme vous avez cru.'"
,"30":"Et leurs yeux s'ouvrirent. Jésus leur fit la leçon: 'Faites en sorte que personne ne le sache!' "
,"31":"Mais dès qu'ils furent sortis, ils parlèrent de lui dans toute la région."
,"32":"Les aveugles étaient tout juste sortis lorsqu'on présenta à Jésus un homme qui avait un démon: il ne pouvait pas parler."
,"33":"Jésus chassa le démon et le muet commença à parler. Voilà donc la foule tout émerveillée, car les gens disaient: 'On n'a jamais rien vu de pareil en Israël!'"
,"34":"Cependant les Pharisiens étaient là pour dire: 'Il chasse les démons avec l'aide du chef des démons!'"
,"35":"Jésus faisait la tournée des villes et des villages. Il enseignait dans leurs synagogues, il proclamait la Bonne Nouvelle du Royaume et guérissait n'importe quel mal ou maladie."
,"36":"En voyant ces foules il eut pitié d'elles, car elles étaient accablées et sans réaction, comme des brebis qui n'ont pas de berger."
,"37":"Alors il dit à ses disciples: 'La moisson est abondante et les ouvriers sont peu nombreux."
,"38":"Priez donc le Seigneur de la moisson pour qu'il envoie des ouvriers à sa moisson.'"
}`)
	CurrentBook.AddChapter(10, `{
"1":"Jésus appela ses douze disciples; il leur donna autorité sur les esprits impurs pour les jeter dehors, et pour guérir n'importe quel mal ou maladie."
,"2":"Voici les noms des douze apôtres: d'abord Simon appelé Pierre, et André son frère; puis Jacques fils de Zébédée, et Jean son frère;"
,"3":"Philippe et Barthélemy; Thomas et Matthieu, l'employé de l'impôt; Jacques fils d'Alphée, et Thaddée;"
,"4":"Simon le Cananéen et Judas l'Iscariote, celui qui l'a livré."
,"5":"Ces Douze, Jésus les envoya en mission. Il leur dit: 'N'allez pas vers les païens, n'entrez pas dans une ville de Samaritains;"
,"6":"mais allez plutôt vers les brebis perdues du peuple d'Israël."
,"7":"Partout où vous passerez, vous ferez cette annonce: 'Le Royaume des Cieux est là, tout proche!'"
,"8":"Guérissez les malades, réveillez les morts, purifiez les lépreux, chassez les démons. Vous avez reçu gratuitement, vous donnerez gratuitement."
,"9":"Ne prenez pas d'argent dans vos ceintures, pas plus de petite monnaie que de pièces d'or ou d'argent;"
,"10":"ni sac de voyage, ni tunique de rechange, ni chaussures, ni bâton: pensez que l'ouvrier a droit à sa nourriture."
,"11":"Quand vous entrerez dans une ville ou un village, faites-vous donner le nom d'une personne convenable, et restez là jusqu'à ce que vous repartiez."
,"12":"En entrant dans cette maison vous lui souhaiterez la paix."
,"13":"Si la maison en est digne, la paix viendra sur elle; si elle n'en est pas digne, la paix que vous offrez reviendra sur vous."
,"14":"Si l'on ne vous reçoit pas, si l'on n'écoute pas vos paroles, au moment de sortir de cette maison ou de cette ville, vous secouerez la poussière de vos pieds."
,"15":"En vérité, je vous le dis, le pays de Sodome et de Gomorrhe s'en tirera à meilleur compte que cette ville au jour du jugement.'"
,"16":"'Allez; je vous envoie comme des brebis au milieu de loups. Soyez donc adroits comme le serpent, mais simples comme la colombe."
,"17":"Méfiez-vous des hommes! Ils vous livreront à leurs conseils de communauté et vous serez fouettés dans leurs synagogues."
,"18":"A cause de moi on vous traînera devant des gouverneurs et des rois; et vous rendrez témoignage face à eux et aux païens."
,"19":"Quand on vous livrera, ne vous tourmentez pas pour ce que vous direz et comment vous le direz, car ce que vous aurez à dire vous sera donné au moment même."
,"20":"D'ailleurs ce n'est pas vous qui parlerez, c'est l'Esprit de votre Père qui parlera en vous."
,"21":"Le frère livrera son frère à la mort, et le père son enfant. Les enfants accuseront leurs parents et les feront mourir."
,"22":"Rien qu'à cause de mon nom vous serez haïs de tous; mais celui qui restera ferme jusqu'à la fin sera sauvé."
,"23":"Quand on vous persécutera dans une ville, fuyez vers une autre. En vérité, je vous le dis, vous n'aurez pas fini la tournée des villes d'Israël avant que ne vienne le Fils de l'Homme."
,"24":"Le disciple n'est pas au-dessus du maître, ni le serviteur au-dessus de son seigneur."
,"25":"Ce sera déjà bien si le disciple est comme son maître et le serviteur comme son seigneur. S'ils ont traité de démon le maître de maison, ce sera pire encore pour les gens de sa maison."
,"26":"Donc ne les craignez pas. Il n'y a rien de caché qui ne doive être découvert, rien de secret qui ne sera connu."
,"27":"Ce que je vous dis dans l'obscurité, dites-le en plein jour, et ce qu'on vous a dit à l'oreille, criez-le sur les toits."
,"28":"Ne craignez pas ceux qui tuent le corps mais ne peuvent tuer l'âme. Craignez plutôt celui qui peut faire périr l'âme et le corps dans l'enfer."
,"29":"Deux moineaux ne valent qu'une monnaie, n'est-ce pas? Or pas un d'entre eux ne tombe au sol sans l'accord de votre Père."
,"30":"Quant à vous, même vos cheveux sont tous comptés."
,"31":"Donc ne craignez pas: vous valez tout de même plus qu'une volée de moineaux."
,"32":"Celui qui me reconnaîtra devant les hommes, je le reconnaîtrai devant mon Père du Ciel."
,"33":"Mais si quelqu'un me renie devant les hommes, moi aussi je le renierai devant mon Père du Ciel."
,"34":"Ne croyez pas que je sois venu apporter la paix à la terre. Je ne suis pas venu amener la paix mais l'épée."
,"35":"Je suis venu pour créer la division: on sera contre son propre père, la fille s'opposera à sa mère et la jeune mariée à sa belle-mère."
,"36":"Chacun aura pour ennemis les gens de sa maison."
,"37":"Celui qui aime son père ou sa mère plus que moi n'est pas digne de moi. Celui qui aime son fils ou sa fille plus que moi n'est pas digne de moi."
,"38":"Et celui qui ne prend pas sa croix pour marcher derrière moi n'est pas digne de moi."
,"39":"Celui qui vit sa vie pour soi la perdra, et celui qui la sacrifie pour moi l'aura finalement pour lui."
,"40":"Celui qui vous accueille m'accueille, et celui qui m'accueille accueille Celui qui m'a envoyé."
,"41":"Celui qui accueille un prophète parce que c'est un prophète, recevra une récompense de prophète; celui qui accueille un homme juste parce que c'est un juste, sa récompense sera celle qui convient pour un juste."
,"42":"Et celui qui donne un verre d'eau fraîche à l'un de ces petits parce qu'il est mon disciple, je vous dis qu'il ne perdra pas sa récompense.'"
}`)
	CurrentBook.AddChapter(11, `{
"1":"Jésus donna donc ses instructions à ses douze disciples; lorsqu'il eut terminé, il partit pour enseigner et prêcher dans les villes de la région."
,"2":"Or voici que Jean-Baptiste, dans sa prison, entendait parler de ce que faisait le Christ, et il lui fit porter par ses disciples le message suivant:"
,"3":"'Es-tu celui qui doit venir ou devons-nous en attendre un autre?'"
,"4":"Jésus leur donna cette réponse: 'Allez voir Jean et racontez-lui ce que vous entendez et voyez:"
,"5":"les aveugles retrouvent la vue, les éclopés marchent, les lépreux sont purifiés, les sourds entendent, les morts se réveillent et les pauvres entendent une bonne nouvelle."
,"6":"Mais heureux particulièrement celui qui me voit, si ce n'est pas pour sa chute.'"
,"7":"Lorsque les hommes furent repartis, Jésus commença à parler de Jean à la foule: 'Que cherchiez-vous à voir quand vous alliez au désert? Un roseau agité par le vent?"
,"8":"Qu'alliez-vous voir? Un homme dans le luxe? Mais les gens qui vivent dans le luxe se trouvent dans les palais des rois."
,"9":"Alors pourquoi alliez-vous là-bas? Pour voir un prophète? Oui, je vous le dis, et plus qu'un prophète."
,"10":"Car c'est de lui qu'il est écrit: J'envoie mon messager devant toi pour qu'il te prépare le chemin."
,"11":"Oui, je vous le dis, on n'a pas vu se lever plus grand que Jean parmi les fils de la femme. Et pourtant le plus petit dans le Royaume des Cieux est plus grand que lui."
,"12":"Depuis la venue de Jean-Baptiste jusqu'à présent, le Royaume des Cieux se prend par force et ce sont les plus décidés qui l'emportent."
,"13":"Jusqu'à Jean on en restait à la prophétie, tous les prophètes aussi bien que la Loi,"
,"14":"et si vous voulez me croire, cet Elie qui devait revenir, c'est lui."
,"15":"Celui qui a des oreilles, qu'il entende!"
,"16":"Comment vais-je dépeindre la présente génération? Elle fait penser à des gamins assis sur la place; un groupe interpelle les autres:"
,"17":"Nous avons joué de la flûte pour vous et vous n'avez pas dansé; et quand nous avons fait la lamentation, vous n'avez pas pleuré."
,"18":"Rappelez-vous Jean: il ne mangeait pas, il ne buvait pas, et quand il est venu on a dit: Il a un démon."
,"19":"Et puis vient le Fils de l'Homme qui mange et qui boit, et l'on dit: Il aime le vin et la bonne chère, c'est un ami des collecteurs de l'impôt et des pécheurs! Mais on verra que la Sagesse a bien fait les choses.'"
,"20":"Alors Jésus commença à invectiver les villes où la plupart de ses miracles avaient eu lieu, car elles ne s'étaient pas converties."
,"21":"'Malheur à toi, Korazin! Malheur à toi, Bethsaïde! Si les miracles qui ont eu lieu chez vous avaient eu lieu dans Tyr et dans Sidon, depuis longtemps elles auraient fait pénitence avec le sac et la cendre."
,"22":"Aussi je vous dis: Tyr et Sidon s'en tireront à meilleur compte que vous au jour du jugement."
,"23":"Et toi, Capharnaüm, vas-tu t'élever jusqu'au ciel? Non, tu descendras jusque chez les morts. Car si on avait eu chez les gens de Sodome les miracles qui ont eu lieu chez toi, leur ville serait encore là aujourd'hui."
,"24":"Aussi je vous dis: Sodome s'en tirera à meilleur compte que toi au jour du jugement."
,"25":"En cette même occasion Jésus éleva la voix et dit: 'Je proclamerai tes grandeurs, Père, Seigneur du ciel et de la terre, car tu as caché ces choses aux sages et aux intelligents et tu les as révélées à des tout-petits."
,"26":"Oui, Père, c'est cela qui t'a paru bon!"
,"27":"Tout m'a été remis par mon Père et personne ne connaît vraiment le Fils, si ce n'est le Père; et personne ne connaît vraiment le Père, si ce n'est le Fils et celui à qui le Fils veut le révéler."
,"28":"Venez à moi, vous tous qui peinez, qui êtes surchargés, et je vous donnerai le repos."
,"29":"Prenez sur vous mon joug et apprenez de moi que je suis doux et humble de coeur, et vous trouverez le repos pour vos âmes."
,"30":"Car mon joug est aisé et ma charge légère."
}`)
	CurrentBook.AddChapter(12, `{
"1":"En ce temps-là Jésus traversait des champs de blé, et c'était un jour de sabbat. Les disciples avaient faim et ils commencèrent à cueillir des épis pour les manger."
,"2":"Les Pharisiens s'en aperçurent et ils lui dirent: 'Regarde, tes disciples font ce qu'on n'a pas le droit de faire un jour de sabbat!'"
,"3":"Alors il leur dit: 'N'avez-vous donc pas lu ce qu'a fait David un jour qu'il avait faim, lui et ses hommes?"
,"4":"Il est entré dans la Maison de Dieu et ils ont mangé les pains de l'offrande, qui étaient interdits pour lui comme pour ses hommes, car seuls les prêtres peuvent en manger."
,"5":"N'avez-vous pas lu non plus dans la Loi que dans le Temple les prêtres n'observent pas le repos du sabbat? Et ce n'est pas là une faute."
,"6":"Je vous affirme qu'il y a ici mieux que le Temple."
,"7":"Et si vous aviez compris cette parole: c'est la miséricorde que j'aime, non les offrandes, vous n'auriez pas condamné des innocents!"
,"8":"Sachez que le Fils de l'Homme est Seigneur du sabbat.'"
,"9":"Jésus alla plus loin et il entra dans une de leurs synagogues."
,"10":"Là se trouvait un homme avec une main paralysée. On lui posa alors une question, afin de pouvoir l'accuser ensuite: 'Est-il permis de soigner, un jour de sabbat?'"
,"11":"Jésus leur dit: 'Si l'un de vous n'a qu'une seule brebis et qu'elle tombe dans un trou un jour de sabbat, n'ira-t-il pas la prendre et la remonter?"
,"12":"Un homme vaut sûrement plus qu'une brebis! Donc, le jour du sabbat, il est permis de faire du bien.'"
,"13":"Puis Jésus dit à l'homme: 'Etends ta main!' Il l'étendit: elle était redevenue saine comme l'autre main."
,"14":"Quand les Pharisiens sortirent, ils tinrent conseil pour voir comment se défaire de Jésus."
,"15":"Jésus, qui le savait, s'éloigna et bien des gens le suivirent. Il les guérit tous,"
,"16":"mais il leur demandait avec insistance de ne pas parler de lui,"
,"17":"car il fallait que s'accomplisse la parole du prophète Isaïe:"
,"18":"Voici mon serviteur que j'ai choisi; c'est lui mon bien-aimé, celui qui fait mon plaisir. Je mettrai sur lui mon Esprit pour qu'il annonce le jugement aux nations païennes."
,"19":"Il ne discutera pas, il ne criera pas, on n'entendra pas sa voix sur les places."
,"20":"Il n'écrasera pas le roseau brisé, il n'éteindra pas la mèche qui fume encore, jusqu'à ce qu'il fasse triompher le bon droit."
,"21":"L'espérance des nations reposera sur son nom."
,"22":"On présenta alors à Jésus un homme possédé d'un démon: il était aveugle et muet. Mais Jésus le rétablit si bien que le muet parlait et voyait."
,"23":"Tout le monde était dans l'admiration et les gens disaient: 'C'est sûrement lui le fils de David.'"
,"24":"Mais les Pharisiens qui les entendaient répliquaient: 'Celui qui lui permet de chasser les démons, c'est Béelzéboul, le chef des démons!'"
,"25":"Jésus connaissait leurs réflexions et il leur dit: 'Tout royaume qui se divise court à la ruine; pas une ville, pas une institution ne durera si l'on y est divisé."
,"26":"Si donc Satan chasse Satan, il est divisé et son royaume ne durera pas."
,"27":"Si c'est Béelzéboul qui m'aide à faire sortir les démons, qui donc aide les gens de chez vous quand ils les font sortir? Ce sont eux qui jugeront vos paroles."
,"28":"Mais si c'est l'Esprit de Dieu qui avec moi fait sortir les démons, comprenez que le Royaume de Dieu est venu jusqu'à vous."
,"29":"Comment entrera-t-on dans la maison du Fort pour lui prendre ses affaires? Il faudra d'abord ligoter le Fort, et ensuite on pillera sa maison."
,"30":"Qui n'est pas avec moi est contre moi, qui ne rassemble pas avec moi disperse!"
,"31":"Aussi je vous dis: On pardonnera aux humains n'importe quel péché ou blasphème contre Dieu, mais le blasphème contre l'Esprit Saint ne sera pas pardonné."
,"32":"Celui qui calomnie le Fils de l'Homme sera pardonné, mais celui qui calomnie l'Esprit Saint ne sera pardonné, ni en ce monde ni dans l'autre."
,"33":"Prenez un bon arbre et vous aurez de bons fruits, prenez un arbre mauvais et vous aurez de mauvais fruits; on reconnaîtra l'arbre à son fruit."
,"34":"Race de vipères, comment pourriez-vous avoir de bonnes paroles puisque vous êtes mauvais?,La bouche dit ce qui déborde du coeur. "
,"35":"L'homme bon a un bon fond et il en tire de bonnes choses, l'homme mauvais a un fond mauvais et il en tire le mal."
,"36":"Je vous l'affirme: tout ce qu'on aura dit sans raison, on en rendra compte au jour du jugement."
,"37":"Ce sont tes paroles qui te blanchiront, et ce sont tes paroles qui te condamneront.'"
,"38":"A ce moment-là des maîtres de la Loi et des Pharisiens prirent la parole pour lui dire: 'Maître, fais-nous donc voir un signe miraculeux.'"
,"39":"Jésus leur répondit: 'Génération mauvaise et adultère! Vous réclamez un signe, mais vous n'en aurez pas d'autre que le signe du prophète Jonas."
,"40":"Tout comme Jonas a passé trois jours et trois nuits dans le ventre de la baleine, le Fils de l'Homme aussi restera trois jours et trois nuits au coeur de la terre."
,"41":"Les hommes de Ninive ressusciteront pour le jugement tout comme cette génération et ils l'accuseront; car eux se sont convertis à la prédication de Jonas, et ici il y a mieux que Jonas."
,"42":"La reine du Sud ressuscitera pour le jugement avec cette génération et elle l'accusera; car elle-même est venue du bout du monde pour entendre la sagesse de Salomon, et ici il y a mieux que Salomon."
,"43":"Quand l'esprit impur est sorti de son homme, il va errant par des lieux arides à la recherche d'un toit, mais il n'en trouve pas."
,"44":"Alors il se dit:'Retournons à ma maison d'où je suis sorti'. En arrivant il la trouve débarrassée, balayée et décorée. "
,"45":"Il s'en va donc et ramène avec lui sept autres esprits plus méchants que lui. Ils entrent et s'installent, et la nouvelle situation de cette personne est alors pire que la première: ce sera le cas pour cette génération mauvaise!'"
,"46":"Comme Jésus parlait à la foule, sa mère et ses frères étaient là dehors et voulaient lui parler."
,"47":"Quelqu'un lui dit: 'Ta mère et tes frères sont là dehors et ils voudraient te parler.'"
,"48":"Mais lui répond à celui qui est venu l'avertir: 'Qui est ma mère et qui sont mes frères?'"
,"49":"De la main il montre ses disciples et dit: 'Voilà ma mère et mes frères!"
,"50":"Quiconque fait la volonté de mon Père des cieux est pour moi un frère, une soeur ou une mère.'"
}`)
	CurrentBook.AddChapter(13, `{
"1":"Ce jour-là Jésus sort de la maison et va s'asseoir sur les bords du lac."
,"2":"Mais c'est toute une foule qui s'assemble autour de lui, de sorte qu'il doit monter dans une barque où il s'assoit, pendant que tout son monde se tient sur le rivage."
,"3":"Puis il se met à leur parler longuement en paraboles. Il leur dit: 'Voici que le semeur est sorti pour semer. "
,"4":"Pendant qu'il sème, une partie tombe au long du chemin et les oiseaux viennent et mangent les graines."
,"5":"D'autres graines tombent sur la rocaille où elles n'ont guère de terre. Très vite sortent les tiges parce que la terre n'est pas profonde,"
,"6":"mais aussitôt que le soleil chauffe, elles sont grillées et se dessèchent parce qu'elles n'ont pas de racine."
,"7":"D'autres graines tombent dans les épines, et les épines croissent et les étouffent."
,"8":"D'autres tombent sur la belle terre et donnent du fruit, l'une cent, l'autre soixante et d'autres encore trente."
,"9":"Que celui qui a des oreilles entende!'"
,"10":"Alors ses disciples s'approchent et lui disent: 'Pourquoi leur parles-tu sous forme de paraboles?'"
,"11":"Et lui leur dit ceci: 'A vous il a été donné de connaître les mystères du Royaume des Cieux, mais pas à eux."
,"12":"Car à celui qui a on donnera, et il aura en abondance, mais à celui qui n'a pas on enlèvera même ce qu'il a."
,"13":"Voilà pourquoi je leur parle en paraboles. Car ils regardent sans voir et ils entendent sans entendre ni comprendre."
,"14":"A eux s'applique la prophétie d'Isaïe qui dit: Ecoutez, écoutez donc sans compren dre! Regardez, regardez toujours sans rien voir! "
,"15":"Oui, ce peuple a la conscience endurcie; leurs oreilles ne savent plus entendre, leurs yeux sont bouchés. Ils ont peur de voir de leurs yeux et d'entendre de leurs oreilles, car alors leur coeur comprendrait et se convertirait, et moi je les guérirais."
,"16":"Mais vous, heureux vos yeux parce qu'ils voient et vos oreilles parce qu'elles entendent!"
,"17":"Oui, je vous le dis, bien des prophètes et des justes auraient voulu voir ce que vous voyez et ne l'ont pas vu, ou entendre ce que vous entendez, et ne l'ont pas entendu."
,"18":"Vous donc, écoutez cette parabole du semeur."
,"19":"Un certain nombre entend la parole du Royaume sans l'entendre vraiment. C'est comme le grain semé trop près du chemin: le Mauvais arrive et arrache de leur coeur ce qui a été semé."
,"20":"Du grain a été semé sur la rocaille; c'est celui qui écoute la parole et aussitôt l'accueille avec joie,"
,"21":"mais il change avec le temps, car il n'a pas de racines profondes. Pour peu que vienne une difficulté ou une persécution à cause de la parole, il abandonne aussitôt."
,"22":"Du grain est tombé dans les épines: c'est celui qui a écouté la parole et qui pourtant ne donnera pas de fruit. C'est que les préoccupations du monde et la séduction de la richesse sont venues étouffer cette parole."
,"23":"Du grain enfin a été semé sur la belle terre: voilà celui qui écoute la parole et l'accueille en lui. Il va donner du fruit et produire, peut-être cent, peut-être soi xante, peut-être trente pour un.'"
,"24":"Jésus leur présenta une autre parabole. Il leur dit: 'Voici une image du Royaume des Cieux. Un homme a semé dans son champ de la bonne semence."
,"25":"Pendant que les gens dormaient, l'ennemi est venu et a semé la mauvaise herbe au milieu du blé, puis il est parti."
,"26":"Quand le blé en herbe a donné la tige et le grain, les mauvaises herbes aussi sont apparues."
,"27":"Alors les serviteurs du maître de maison sont allés le trouver pour lui dire: Seigneur, n'est-ce pas de la bonne semence que tu as semée dans ton champ? Et d'où viennent ces mauvaises herbes?"
,"28":"Lui leur dit: C'est un ennemi qui a fait cela. Alors les serviteurs lui demandent: Veux-tu que nous allions les ramasser? "
,"29":"Mais il leur dit: Ne le faites pas; en ramassant les mauvaises herbes vous pourriez aussi arracher le blé."
,"30":"Laissez-les donc grandir ensemble jusqu'à la moisson. Au moment de la moisson je dirai aux moissonneurs: Ramassez d'abord les mauvaises herbes et faites-en des bottes pour les brûler. Ensuite vous rassemblerez le blé dans mon grenier."
,"31":"Jésus leur présenta une autre parabole: 'Voulez-vous une image du Royaume des Cieux? Pensez à la graine de moutarde qu'un homme a prise pour la semer dans son champ."
,"32":"C'est la plus petite des graines, mais quand elle a grandi, elle est plus grande que les légumes. Elle devient un arbre, si bien que les oiseaux du ciel viennent s'abriter dans ses branches.'"
,"33":"Jésus leur dit une autre parabole: 'Voulez-vous encore une image du Royaume des Cieux? Pensez au levain qu'une femme prend et enfouit dans trois mesures de farine, jusqu'à ce que tout soit levé.'"
,"34":"Jésus disait tout cela aux foules en paraboles. Il ne leur disait rien sans faire usage de paraboles,"
,"35":"de sorte que s'accomplissait la parole du prophète: J'ouvrirai la bouche et je parlerai en paraboles; je ferai connaître des choses cachées depuis la fondation du monde."
,"36":"Après cela Jésus laisse la foule et vient à la maison. Alors ses disciples s'approchent de lui et lui disent: 'Explique-nous la parabole des mauvaises herbes dans le champ.'"
,"37":"Jésus leur dit: 'Celui qui sème la bonne graine, c'est le Fils de l'Homme."
,"38":"Le champ, c'est le monde; la bonne graine, ce sont les enfants du Royaume; les mauvaises herbes sont les sujets du Mauvais;"
,"39":"l'ennemi qui les a semées, c'est le diable; la moisson, c'est la fin du monde; les moissonneurs sont les anges."
,"40":"Voyez comment on ramasse les mauvaises herbes pour les jeter au feu: ce sera pareil à la fin du monde."
,"41":"Le Fils de l'Homme enverra ses anges pour qu'ils enlèvent de son Royaume tous les scandales, et aussi ceux qui faisaient le mal."
,"42":"Et ils les jetteront dans la fournaise du feu: là il y aura pleurs et grincements de dents."
,"43":"Par contre les justes brilleront comme le soleil dans le Royaume de leur Père. Que celui qui a des oreilles entende.'"
,"44":"'Le Royaume des Cieux est comme un trésor caché dans un champ. Celui qui l'a trouvé referme aussitôt la cachette; c'est pour lui une telle joie qu'il s'en va vendre tout ce qu'il a et il achète ce champ."
,"45":"Voulez-vous une autre image du Royaume des Cieux? Un marchand est à la recherche de belles perles."
,"46":"Or voici qu'il en trouve une de grande valeur; aussitôt il s'en va vendre tout ce qu'il a et il achète la perle."
,"47":"Voici une autre image du Royaume des Cieux. Un filet a été jeté dans la mer et il y ramasse n'importe quoi."
,"48":"Quand il est plein, on le ramène sur le rivage et on s'assied pour mettre ce qui est bon dans des paniers. Et ce qui n'est pas bon, on le rejette."
,"49":"Ce sera pareil à la fin du monde: les anges viendront pour séparer les mauvais d'avec les justes,"
,"50":"et ils les jetteront dans la fournaise du feu. Là il y aura pleurs et grincements de dents.'"
,"51":"Jésus leur dit alors: 'Avez-vous tout compris?' Ils lui répondent: 'Oui!'"
,"52":"Et Jésus leur dit: 'Vous voyez, quand un maître en religion a été instruit du Royaume des Cieux, il est comme un maître de maison qui trouve toujours dans ses réserves de quoi distribuer, du neuf et du vieux.'"
,"53":"Quand il eut terminé ces paraboles, Jésus quitta l'endroit."
,"54":"Il vint à passer par son village natal et il se mit à les enseigner dans leur synagogue. Ils ne savaient qu'en penser et disaient: 'D'où lui vient cette sagesse? D'où lui viennent ces miracles? "
,"55":"N'est-il pas le fils du charpentier? Sa mère s'appelle Marie, n'est-ce pas? Et ses frères, c'est Jacques, c'est Joseph, c'est Simon et Jude!"
,"56":"Ses soeurs aussi sont toutes des nôtres; alors, d'où lui vient tout cela?'"
,"57":"C'est ainsi qu'ils butaient et ne l'acceptaient pas; mais Jésus leur dit: 'Le seul endroit où l'on ne reconnaît pas un prophète, c'est dans sa patrie et dans sa famille.'"
,"58":"Et à cause de leur manque de foi, il fit là peu de miracles."
}`)
	CurrentBook.AddChapter(14, `{
"1":"En ce temps-là la renommée de Jésus arriva jusqu'à Hérode, le tétrarque,"
,"2":"et il dit à ses serviteurs: 'Ce ne peut être que Jean-Baptiste! Il a été ressuscité d'entre les morts et c'est pourquoi les forces supérieures agissent à travers lui.'"
,"3":"Il faut savoir qu'Hérode avait fait arrêter Jean et l'avait mis en prison avec des chaînes pour l'affaire d'Hérodiade, la femme de son frère Philippe."
,"4":"Car Jean disait à Hérode: 'Tu n'as pas le droit d'avoir cette femme.'"
,"5":"Hérode l'aurait bien fait mourir s'il n'avait pas craint le peuple; en effet les gens le considéraient comme un prophète."
,"6":"Mais voici qu'arrive l'anniversaire d'Hérode: la fille d'Hérodiade vient danser au milieu des invités et elle plaît tellement à Hérode"
,"7":"qu'il jure de lui donner tout ce qu'elle demandera."
,"8":"Poussée par sa mère, elle répond: 'Donne-moi ici, sur un plat, la tête de Jean-Baptiste.'"
,"9":"Le roi est très ennuyé, car il a juré et tous les invités du banquet sont témoins; alors il commande de la lui donner."
,"10":"Il envoie un garde pour décapiter Jean dans sa prison;"
,"11":"la tête est apportée sur un plat et donnée à l'adolescente qui la remet à sa mère."
,"12":"Après cela, les disciples de Jean vinrent prendre son corps pour l'ensevelir, puis ils portèrent la nouvelle à Jésus."
,"13":"Lorsque Jésus connut la nouvelle, il s'éloigna et partit discrètement avec la barque vers un lieu désert. Mais la foule l'apprit et les gens vinrent des villes à pied pour le rejoindre."
,"14":"En débarquant, Jésus vit cette foule nombreuse, il eut pitié d'eux et il guérit leurs malades."
,"15":"Lorsque le soir arriva, ses disciples s'approchèrent de lui et lui dirent: 'L'endroit est désert et l'heure est déjà passée. Renvoie cette foule pour qu'ils aillent s'acheter de quoi manger dans les villages voisins.'"
,"16":"Mais Jésus leur dit: 'Il n'est pas nécessaire qu'ils s'en aillent, donnez-leur vous-mêmes à manger.'"
,"17":"Ils lui disent: 'Ici, nous n'avons que cinq pains et deux poissons!'"
,"18":"Alors Jésus leur dit: 'Apportez-les moi ici!'"
,"19":"Puis il donne l'ordre à tout le monde de s'étendre sur l'herbe. Il prend les cinq pains et les deux poissons, il lève le regard vers le ciel, il prononce la bénédiction et rompt le pain. Ensuite il donne le pain aux disciples et les disciples le donnent à la foule."
,"20":"Tous mangèrent et furent rassasiés, et l'on emporta les morceaux qui restaient: douze pleins paniers."
,"21":"Pourtant ceux qui avaient mangé étaient près de cinq mille hommes, sans compter les femmes et les enfants."
,"22":"Aussitôt Jésus obligea les disciples à monter dans la barque et à passer sur l'autre rive sans l'attendre, pendant que lui renvoyait la foule."
,"23":"Après l'avoir renvoyée, il gravit la montagne pour y prier à l'écart. La nuit était tombée et il était là, seul. "
,"24":"Pendant ce temps la barque était déjà loin de terre, bien secouée par les vagues, car le vent était contraire."
,"25":"Jésus vint à eux peu avant le lever du jour: il marchait sur les eaux."
,"26":"En le voyant marcher sur la mer, les disciples furent effrayés. Ils disaient: 'C'est un fantôme!' et ils se mirent à crier tellement ils avaient peur."
,"27":"Tout de suite Jésus leur parla: 'Remettez-vous, c'est moi, ne craignez pas!'"
,"28":"Pierre alors lui dit: 'Seigneur, si c'est toi, donne-moi l'ordre d'aller sur l'eau jusqu'à toi.'"
,"29":"Et Jésus lui dit: 'Viens!',Pierre descend donc de la barque; il marche sur l'eau et s'approche de Jésus. "
,"30":"Mais il voit que le vent est fort et il a peur, et comme il commence à s'enfoncer, il crie: 'Seigneur, sauve-moi!'"
,"31":"Aussitôt Jésus étend la main, le saisit et lui dit: ' Homme de peu de foi! Pourquoi as-tu hésité?'"
,"32":"Au moment où ils remontaient dans la barque, le vent tomba"
,"33":"et ceux qui étaient dans la barque se prosternèrent devant lui en disant: 'Vraiment tu es Fils de Dieu!'"
,"34":"Ayant achevé la traversée, ils abordèrent la rive de Génésaret."
,"35":"Les hommes de l'endroit le reconnurent et le firent savoir dans tous les environs, de sorte qu'on amenait à Jésus tous ceux qui étaient mal en point."
,"36":"Ils lui demandaient de pouvoir seulement toucher la frange de son vêtement, et tous ceux qui la touchaient étaient sauvés."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Des Pharisiens et des maîtres de la Loi étaient arrivés de Jérusalem; ils s'approchèrent de Jésus et lui demandèrent:"
,"2":"'Pourquoi tes disciples laissent-ils de côté la tradition des anciens? Ils ne se lavent pas les mains quand ils prennent leur repas.'"
,"3":"Alors Jésus leur dit: 'Et vous, pourquoi laissez-vous de côté le commandement de Dieu au nom de votre tradition?"
,"4":"Car Dieu a dit: Honore ton père et ta mère, et aussi: celui qui maudit son père ou sa mère sera mis à mort."
,"5":"Mais selon vous, quelqu'un peut répondre à son père ou à sa mère: 'Ce que tu pourrais attendre de moi, je l'ai consacré à Dieu'."
,"6":"Et on n'est plus tenu d'aider son père ou sa mère. Donc, avec votre tradition, vous annulez la parole de Dieu."
,"7":"Comédiens! Le prophète Isaïe a joliment bien parlé de vous quand il a dit:"
,"8":"Ce peuple m'honore des lèvres mais son coeur est loin de moi."
,"9":"Leur culte ne vaut rien, les préceptes qu'ils enseignent ne sont que des lois humaines.'"
,"10":"Alors Jésus appelle son monde. Il leur dit: 'Ecoutez et tâchez de comprendre."
,"11":"Ce qui entre dans la bouche ne rend pas la personne impure; elle est rendue impure par ce qui sort de sa bouche.'"
,"12":"Les disciples viennent dire à Jésus: 'Sais-tu que les Pharisiens sont scandalisés de ce que tu viens de dire?'"
,"13":"Il leur répond: 'Toute plante que mon Père du ciel n'a pas plantée sera arrachée."
,"14":"Laissez-les; ce sont des guides aveugles, et quand un aveugle guide un autre aveugle, les deux tombent dans le fossé.'"
,"15":"Alors Pierre lui dit: 'Mais explique-nous donc ta sentence.'"
,"16":"Jésus répond: 'Vous avez donc vous aussi l'esprit bouché?"
,"17":"Vous ne comprenez pas que tout ce qui entre dans la bouche va dans le ventre et termine aux ordures?"
,"18":"Mais ce qui sort de la bouche vient du coeur, et c'est cela qui rend l'homme impur."
,"19":"Du coeur proviennent les pensées mauvaises, le meurtre, l'adultère, l'impureté, le vol, les faux témoignages et les calomnies."
,"20":"Tout cela rend l'homme impur, mais manger sans s'être lavé les mains n'a jamais rendu quelqu'un impur."
,"21":"Jésus partit de là et s'en alla vers la frontière de Tyr et Sidon."
,"22":"Une femme cananéenne, qui venait de ce territoire, arriva alors en criant: 'Aie pitié de moi, Seigneur, fils de David! Ma fille est affligée d'un démon!'"
,"23":"Jésus ne répond rien. Les disciples insistent auprès de lui: 'Renvoie-la, vois comme elle crie après nous!'"
,"24":"Jésus leur répond: 'J'ai été envoyé uniquement aux brebis perdues du peuple d'Israël.'"
,"25":"Mais la femme vient se jeter aux pieds de Jésus en lui disant: 'Seigneur, fais quelque chose pour moi!'"
,"26":"Jésus lui répond: 'On ne prend pas le pain des enfants pour le jeter aux chiens.'"
,"27":"La femme lui dit: 'Bien sûr, Seigneur, mais les petits chiens mangent les miettes qui tombent de la table des maîtres.'"
,"28":"Alors Jésus lui fait cette réponse: 'Femme, ta foi est grande, que la chose se fasse comme tu le veux.' Et dès ce moment-là sa fille fut guérie."
,"29":"Jésus partit de là et vint sur les bords de la mer de Galilée. Il gravit la montagne, et là il s'assit."
,"30":"Toute une foule venait à lui; ils amenaient leurs éclopés, des aveugles, des infirmes, des muets et beaucoup d'autres encore. Ils les jetaient à ses pieds et Jésus les guérissait."
,"31":"En voyant cela la foule était émerveillée: les muets parlaient, les infirmes étaient guéris, les éclopés marchaient, les aveugles voyaient! Et ils rendaient grâce au Dieu d'Israël."
,"32":"Alors Jésus appela à lui ses disciples et leur dit: 'J'ai vraiment compassion de ces gens, car voilà trois jours qu'ils sont avec moi et ils n'ont rien à manger. Je ne veux pas les renvoyer à jeun, car ils pourraient se trouver mal en chemin.'"
,"33":"Les disciples lui disent: 'L'endroit est désert, comment pourrions-nous trouver assez de pain pour tant de gens?'"
,"34":"Jésus leur demande: 'Combien de pains avez-vous?' Ils disent: 'Sept, et quelques petits poissons.'"
,"35":"Jésus demande aux gens de s'asseoir par terre."
,"36":"Il prend les sept pains et les poissons, il rend grâces et rompt le pain, puis il commence à le donner aux disciples qui le distribuent à la foule."
,"37":"Tous mangèrent et furent rassasiés; on ramassa ce qui restait, de quoi remplir sept corbeilles."
,"38":"C'étaient pourtant près de quatre mille hommes qui avaient mangé, sans compter les femmes et les enfants."
,"39":"Jésus renvoya la foule et monta dans la barque; il s'en alla vers la frontière de Magadan."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Les Pharisiens et les Saducéens vinrent trouver Jésus pour le mettre à l'épreuve, ils voulaient qu'il leur montre un signe qui vienne du Ciel."
,"2":"Il leur donna cette réponse: 'Le soir vous dites: Le temps sera beau car le ciel est bien rouge;"
,"3":"et le matin: Aujourd'hui nous aurons de la tempête, car le rouge du ciel n'est pas beau. Vous savez donc interpréter l'aspect du ciel, mais les signes des temps, vous ne le pouvez pas! "
,"4":"Génération mauvaise et adultère! Vous réclamez un signe et vous n'aurez pas de signe: seulement le signe de Jonas.',Jésus les laissa et s'en alla."
,"5":"En partant vers l'autre rive, les disciples avaient oublié de prendre avec eux des pains."
,"6":"A un moment Jésus leur dit: 'Ouvrez l'oeil et méfiez-vous du levain des Pharisiens et des Saducéens.'"
,"7":"Aussitôt ils se disent: 'C'est vrai, nous n'avons pas pris de pain.'"
,"8":"Jésus s'en aperçoit et leur dit: 'Qu'est-ce qui vous préoccupe: Vous n'avez pas de pain? Vous avez bien peu la foi!"
,"9":"Vous ne comprenez toujours pas, vous ne vous rappelez pas les cinq pains pour les cinq mille hommes et combien de paniers vous avez emportés?"
,"10":"Ni les sept pains pour les quatre mille et combien de corbeilles vous avez rapportées?"
,"11":"Vous auriez pu penser que je ne vous parlais pas de pain. Je vous disais de vous garder du levain des Pharisiens et des Saducéens.'"
,"12":"Alors ils comprirent ce que Jésus voulait dire: ils devaient se méfier, non pas du levain, mais de la doctrine des Pharisiens et des Saducéens.'"
,"13":"Jésus était allé dans la région de Césarée de Philippe. Là il posa à ses disciples cette question: 'D'après les gens, qui suis-je, qui est le Fils de l'Homme?'"
,"14":"Et ils répondirent: 'Pour les uns tu es Jean-Baptiste, pour d'autres Elie, pour d'autres encore Jérémie ou l'un des prophètes.'"
,"15":"Jésus leur demanda: 'Et vous, qui dites-vous que je suis?'"
,"16":"Simon Pierre prit la parole: 'Tu es le Messie, le Fils du Dieu vivant!'"
,"17":"Jésus lui fit alors cette déclaration: 'Heureux es-tu, Simon Bar-Jona, car ce n'est pas la chair et le sang qui te l'ont révélé, mais mon Père qui est dans les cieux."
,"18":"Et moi je te dis: Tu es Pierre et sur cette pierre je bâtirai mon Eglise, et les forces de mort ne l'emporteront pas sur elle."
,"19":"Je te donnerai les clés du Royaume des Cieux. Ce que tu lieras ici sur terre sera lié dans le ciel, et ce que tu délieras sur la terre sera délié dans les cieux.'"
,"20":"Alors Jésus donna l'ordre à ses disciples de ne dire à personne qu'il était, lui, le Messie."
,"21":"A partir de ce moment Jésus commença à montrer à ses disciples qu'il devait partir pour Jérusalem. Là-bas il aurait à souffrir beaucoup de la part des Anciens, des chefs des prêtres et des maîtres de la Loi. On allait le tuer, mais il devait ressusciter le troisième jour."
,"22":"Pierre alors le prend à part et commence à lui faire la leçon en disant: 'Ne parle pas de malheur, cela ne t'arrivera pas, Seigneur!'"
,"23":"Mais Jésus se retourne et dit à Pierre: 'Passe derrière moi, Satan, voudrais-tu me faire chuter? Ta façon de voir n'est pas celle de Dieu, mais celle des hommes.'"
,"24":"Jésus dit alors à ses disciples: 'Si quelqu'un veut marcher derrière moi, qu'il renonce à lui-même, qu'il prenne sa croix et qu'il me suive."
,"25":"Celui qui veut sauver sa vie la perdra, mais s'il la perd pour moi, il la gagnera."
,"26":"Où est le bénéfice si l'on gagne le monde entier mais qu'on se détruit soi-même? Avec quoi va-t-on racheter sa propre vie?"
,"27":"Pensez que le Fils de l'Homme viendra dans la gloire de son Père, entouré de ses anges, et alors il rendra à chacun selon ce qu'il a fait."
,"28":"En vérité, je vous le dis, certains qui sont ici ne feront pas l'expérience de la mort avant d'avoir vu la royauté et la venue du Fils de l'Homme.'"
}`)
	CurrentBook.AddChapter(17, `{
"1":"Six jours après, Jésus prit avec lui Pierre, Jacques et Jean son frère, et il les emmena à l'écart sur une haute montagne."
,"2":"Là, devant eux, il fut transfiguré. Son visage commença à rayonner comme le soleil pendant que ses vêtements devenaient blancs de lumière."
,"3":"Puis ils virent Moïse et Elie qui parlaient avec Jésus."
,"4":"Pierre prit la parole pour dire à Jésus: 'Seigneur, cela tombe bien que nous soyons ici. Si tu le veux je vais dresser ici trois tentes, une pour toi, une pour Moïse et une pour Elie.'"
,"5":"Il parlait encore lorsqu'une nuée lumineuse vint les recouvrir et du milieu de la nuée une voix dit: 'Celui-ci est mon Fils, le Bien-Aimé, celui en qui je me complais, écoutez-le!'"
,"6":"En entendant cela, les disciples se jetèrent face contre terre et furent saisis d'une crainte extraordinaire."
,"7":"Mais voici que Jésus s'approche et les touche. Il leur dit: 'Levez-vous, n'ayez pas peur.'"
,"8":"Alors ils regardent: il n'y a plus personne, mais Jésus seul."
,"9":"Comme ils descendent de la montagne, Jésus leur donne cet ordre: 'Vous ne parlerez de cette vision à personne, jusqu'au jour où le Fils de l'Homme se lèvera d'entre les morts.'"
,"10":"Les disciples lui demandent: 'Pourquoi donc les maîtres de la Loi disent-ils qu'Elie doit venir d'abord?'"
,"11":"Et Jésus leur répond: 'Bien sûr, Elie doit venir et remettre tout en ordre..."
,"12":"Mais je vous dis qu'Elie est déjà venu et on ne l'a pas reconnu; au contraire ils lui ont fait tout ce qu'ils voulaient. Et ce sera pareil pour le Fils de l'Homme: il aura à souffrir d'eux.'"
,"13":"Alors les disciples comprirent que Jésus leur parlait de Jean-Baptiste."
,"14":"Comme il retrouvait la foule, un homme s'approcha de lui et le supplia à genoux:"
,"15":"'Seigneur, aie pitié de mon fils. Il est épileptique et il est vraiment mal; il tombe souvent dans le feu et souvent dans l'eau."
,"16":"Je l'ai présenté à tes disciples, mais ils n'ont pas été capables de le guérir.'"
,"17":"Jésus prend la parole: 'Génération sans foi, égarée, jusqu'à quand serai-je avec vous? Jusqu'à quand devrai-je vous supporter? Amenez-le moi ici.'"
,"18":"Aussitôt Jésus lui parle et commande; le démon sort de l'enfant et dès ce moment le garçon est rétabli."
,"19":"Un peu après, les disciples vinrent demander à Jésus en particulier: 'Pourquoi n'avons-nous pas pu chasser ce démon?'"
,"20":"Et Jésus leur dit: 'Parce que vous avez bien peu la foi. En vérité je vous le dis, si vous aviez la foi gros comme une graine de moutarde, vous de l'Homme doit être livré aux mains des hommes."
,"22":"Un jour qu'ils étaient réunis en Galilée, Jésus leur dit: 'Le fils del l'Homme doit être livré aux mains des hommes."
,"23":"Ils le tueront, mais le troisième jour il ressuscitera.',Et ils en étaient tout tristes."
,"24":"Comme ils étaient entrés à Capharnaüm, les collecteurs de la taxe pour le Temple viennent trouver Pierre et lui disent: 'Votre maître ne paie-t-il pas la taxe?'"
,"25":"Pierre répond: 'Mais si!' Il rentre à la maison et voici que Jésus lui parle le premier: 'Simon, quand les rois de ce monde mettent des taxes ou des impôts, qui les paye? Leurs fils ou ceux qui ne sont pas de la famille?'"
,"26":"Il répond: 'Ceux qui ne sont pas de la famille.',Alors Jésus lui dit: 'Les fils ne paient donc pas. "
,"27":"Mais n'allons pas les scandaliser. Va à la mer, jette l'hameçon et prends le premier poisson qui mord. Tu lui ouvriras la bouche et tu y trouveras une double monnaie. Tu la prendras et la leur donneras pour moi et pour toi.'"
}`)
	CurrentBook.AddChapter(18, `{
"1":"A ce moment-même les disciples de Jésus viennent lui demander: 'Qui donc est le plus grand dans le Royaume des Cieux?'"
,"2":"Il appelle un petit enfant et le place au milieu d'eux."
,"3":"Puis il dit: 'En vérité, je vous le dis, si vous ne redevenez pas comme des enfants, vous n'entrerez pas dans le Royaume des Cieux."
,"4":"Si quelqu'un peut se rabaisser au niveau de cet enfant, c'est lui le plus grand dans le Royaume des Cieux."
,"5":"Et si quelqu'un reçoit en mon nom un enfant tel que je viens de dire, il me reçoit."
,"6":"Si quelqu'un devait faire chuter un de ces petits qui croient en moi, il vaudrait mieux pour lui qu'on lui attache au cou une meule de moulin et qu'on le fasse couler au plus profond de la mer."
,"7":"Malheur au monde à cause des scandales! Il est nécessaire que les scandales arrivent, mais malheur à celui qui est la cause du scandale."
,"8":"Si ta main ou ton pied doit te faire chuter, coupe-le et jette-le loin de toi. Il vaut mieux pour toi entrer dans la vie avec une seule main ou un seul pied, que d'avoir deux mains et deux pieds quand on te jettera au feu éternel."
,"9":"Si ton oeil doit te faire chuter, arrache-le et jette-le loin de toi. Mieux vaut pour toi entrer dans la vie avec un seul oeil que d'en avoir deux et d'être jeté dans l'enfer du feu."
,"10":"Faites attention à ne mépriser aucun de ces petits. Je vous assure que leurs anges dans le ciel voient constamment le visage de mon Père des cieux. ("
,"11":"Oui, le Fils de l'Homme est venu sauver ce qui était perdu.)"
,"12":"Que se passe-t-il, d'après vous, si quelqu'un a cent brebis et que l'une d'elles vient à s'égarer?"
,"13":"S'il peut la retrouver, je vous affirme qu'elle lui apporte plus de joie que les quatre-vingt-dix-neuf qui ne se sont pas égarées."
,"14":"C'est la même chose chez votre Père des Cieux: là on ne veut pas qu'un seul de ces petits se perde'."
,"15":"'Si ton frère a péché, va le reprendre toi seul avec lui. S'il t'écoute, tu as gagné ton frère."
,"16":"S'il ne t'écoute pas, prends avec toi une ou deux personnes de façon que toute l'affaire se règle en pré sence de deux ou trois témoins."
,"17":"S'il ne les écoute pas, dis-le à l'Eglise, et s'il n'écoute pas l'Eglise, qu'il soit désormais pour toi comme un païen ou un publicain."
,"18":"En vérité je vous le dis: tout ce que vous liez ici sur terre sera lié dans le ciel, et ce que vous déliez sur la terre sera délié dans le ciel."
,"19":"Je vous dis également que si deux d'entre vous se mettent d'accord ici, sur terre, pour demander quoi que ce soit, mon Père dans les cieux fera qu'ils l'obtiennent."
,"20":"Car dès que deux ou trois sont réunis en mon nom, je suis là au milieu d'eux.'"
,"21":"Alors Pierre s'approche et lui pose cette question: 'Seigneur, combien de fois vais-je pardonner à mon frère si de nouveau il me fait tort? Jusqu'à sept fois?'"
,"22":"Et Jésus lui dit: 'Je ne dis pas sept fois, mais soixante-dix-sept fois.'"
,"23":"'A ce propos, apprenez quelque chose du Royaume des Cieux. Un roi a décidé de demander des comptes à ses serviteurs,"
,"24":"et pour commencer on lui en présente un qui doit dix mille lingots d'or."
,"25":"Comme il n'est pas en mesure de rembourser, son seigneur ordonne de le vendre avec sa femme, ses enfants et tout ce qu'il a, de manière à récupérer quelque chose."
,"26":"Alors le serviteur se jette à ses pieds, face contre terre, et lui dit: 'Sois patient avec moi et je te rembourserai tout.'"
,"27":"Le roi a une telle compassion de lui qu'il le remet en liberté, et même il efface sa dette."
,"28":"Mais aussitôt sorti, ce serviteur rencontre un compagnon de travail qui lui doit cent pièces. Il le prend à la gorge en lui disant: 'Rends-moi ce que tu me dois.'"
,"29":"Son compagnon se jette à ses pieds et le supplie: 'Sois patient avec moi et je te rembourserai'."
,"30":"Mais l'autre refuse et s'en va le faire mettre en prison jusqu'à ce qu'il ait remboursé sa dette."
,"31":"En voyant cela, les autres compagnons sont profondément peinés et ils vont dénoncer à leur seigneur ce qui vient de se passer."
,"32":"Le seigneur fait alors appeler l'autre et lui dit: 'Méchant serviteur, quand tu m'as supplié, je t'ai libéré de toute cette dette;"
,"33":"ne devais-tu pas toi aussi avoir pitié de ton compagnon comme j'ai eu pitié de toi?'"
,"34":"Le seigneur était fort en colère et il le remit aux mains des bourreaux jusqu'à ce qu'il ait payé tout ce qu'il devait.'"
,"35":"'Oui, mon Père des cieux vous traitera de la même façon si chacun de vous ne pardonne pas à son frère du fond de son coeur.'"
}`)
	CurrentBook.AddChapter(19, `{
"1":"Jésus avait terminé son discours; il quitta la Galilée et arriva aux frontières de la Judée par l'autre rive du Jourdain."
,"2":"Une foule de gens était à ses côtés, et là encore il les guérissait."
,"3":"C'est alors que des Pharisiens viennent à lui et le mettent à l'épreuve avec cette question: 'Un homme est-il autorisé à renvoyer sa femme pour n'importe quelle raison?'"
,"4":"Il leur fait cette réponse: 'Vous n'avez donc pas lu que le Créateur au commencement les fit homme et femme"
,"5":"et dit: Pour cette raison l'homme quittera son père et sa mère; il s'attachera à sa femme et les deux seront une seule chair?"
,"6":"De sorte qu'ils ne sont plus deux mais une seule chair. Que l'homme ne sépare pas ce que Dieu a uni.'"
,"7":"Les Pharisiens lui disent: 'Mais alors, pourquoi Moïse a-t-il demandé de donner un certificat de renvoi avant de divorcer?'"
,"8":"Il leur dit: 'Moïse vous a permis de renvoyer vos épouses, mais c'est à cause de votre conscience endurcie. Ce n'était pas ainsi au commencement,"
,"9":"et moi je vous dis que celui qui renvoie sa femme -je ne parle pas du cas d'infidélité- et en épouse une autre, commet l'adultère.'"
,"10":"Les disciples lui disent: 'Si tel est le statut de l'homme et de la femme, il vaut mieux ne pas se marier.'"
,"11":"Et Jésus leur dit: 'Voilà une chose que tous ne comprennent pas: il faut avoir reçu ce don."
,"12":"Il y a des eunuques qui le sont de naissance; il y en a qui ont été mutilés par les hommes; et il y en a d'autres qui se sont voulus tels pour le Royaume des Cieux. Que celui qui peut comprenne!'"
,"13":"A ce moment-là on lui amena des enfants pour qu'il prie pour eux en leur imposant les mains. Mais les disciples les recevaient très mal."
,"14":"Alors Jésus dit: 'Laissez les enfants et ne les empêchez pas de venir près de moi. Sachez que le Royaume des Cieux est pour ceux qui leur ressemblent.'"
,"15":"Jésus leur imposa les mains et reprit son chemin."
,"16":"Un homme vint à Jésus avec ces paroles: 'Maître, que puis-je faire de bien pour avoir la vie éternelle?'"
,"17":"Jésus lui dit: 'Pourquoi m'interroges-tu sur ce qui est bon? Lui est bon, lui seul! Mais si tu veux entrer dans la vie, garde les commandements.'"
,"18":"L'autre demande: 'Quels commandements?' Jésus dit: 'Tu ne tueras pas, tu ne commettras pas d'adultère, tu ne voleras pas, tu ne feras pas de faux témoignage,"
,"19":"honore ton père et ta mère. Et encore: Tu aimeras ton prochain comme toi-même.'"
,"20":"Le jeune homme lui répond: 'J'ai observé tout cela; que me manque-t-il encore?'"
,"21":"Jésus lui dit: 'Si tu veux être parfait, va, vends tout ce que tu as et donne-le aux pauvres pour avoir un trésor dans le ciel. Ensuite reviens et suis-moi.'"
,"22":"En entendant ces paroles, le jeune homme s'éloigna fort peiné, car c'était un gros propriétaire."
,"23":"Jésus dit alors à ses disciples: 'En vérité, je vous le dis, il est difficile pour un riche d'entrer dans le Royaume des Cieux."
,"24":"Oui, je vous le répète, il est plus facile pour un chameau de passer par le trou d'une aiguille, que pour un riche d'entrer dans le Royaume de Dieu.'"
,"25":"En entendant cela, les disciples restent abasourdis. Ils lui disent: 'Mais alors, qui peut être sauvé?'"
,"26":"Jésus les regarde bien en face et leur dit: 'Pour les hommes, c'est une chose impossible, mais pour Dieu tout est possible.'"
,"27":"Pierre prend alors la parole et lui dit: 'Maître, nous avons tout laissé pour te suivre: y aura-t-il quelque chose pour nous?'"
,"28":"Et Jésus leur déclare: 'En vérité je vous le dis à vous qui m'avez suivi: lorsque viendra le monde nouveau et que le Fils de l'Homme siégera sur son trône dans la gloire, vous aussi vous siégerez sur douze trônes pour gouverner les douze tribus d'Israël."
,"29":"Quant à ceux qui laissent leur maison, leurs frères et soeurs, leur père et leur mère et même leurs enfants avec leurs champs à cause de mon nom, ils recevront cent fois plus, et ils auront aussi la vie éternelle."
,"30":"Beaucoup qui sont parmi les premiers seront derniers, et d'autres qui sont derniers seront premiers."
}`)
	CurrentBook.AddChapter(20, `{
"1":"'Apprenez donc quelque chose du Royaume des Cieux. Un propriétaire est sorti à la première heure du jour afin d'embaucher des travailleurs pour sa vigne."
,"2":"Il se met d'accord avec les travailleurs pour un denier par jour et il les envoie à sa vigne."
,"3":"Dans la matinée il en voit d'autres qui sont là sur la place sans rien faire,"
,"4":"et il leur dit: 'Allez vous aussi à la vigne et je vous donnerai ce qui sera juste.'"
,"5":"Aussitôt ils y vont. Le propriétaire sort de nouveau à midi, puis dans l'après-midi, et il agit de la même façon."
,"6":"A la tombée du jour - c'était la onzième heure, il sort et il en trouve qui sont là assis. Il leur dit: 'Pourquoi restez-vous là toute la journée sans rien faire?'"
,"7":"Eux lui répondent: 'C'est que personne ne nous a embauchés.' Et il leur dit: 'Allez donc vous aussi à la vigne.'"
,"8":"Le soir venu, le propriétaire de la vigne dit à son intendant: 'Appelle les ouvriers et donne-leur leur salaire; tu commenceras par les derniers et tu continueras jusqu'aux premiers.'"
,"9":"Ceux qui ont été embauchés à la onzième heure se présentent donc les premiers; ils reçoivent un denier."
,"10":"Quand les premiers arrivés se présentent à leur tour, ils pensent qu'ils vont recevoir davantage, mais eux aussi reçoivent un denier."
,"11":"Pendant qu'on les paie, ils protestent contre le propriétaire:"
,"12":"'Ces derniers, disent-ils, n'ont fait qu'une heure, et tu les mets sur le même plan que nous qui avons travaillé toute une journée au soleil.'"
,"13":"Il réplique à l'un d'eux: 'Mon ami, je ne suis pas injuste avec toi. Nous étions d'accord pour un denier, n'est-ce pas?"
,"14":"Prends ce qui te revient et va-t'en. Moi je veux donner à ce dernier autant qu'à toi."
,"15":"N'ai-je pas le droit de faire chez moi ce que je veux? Serait-ce que tu es envieux parce que moi je suis bon?'"
,"16":"Oui, les derniers seront premiers, et les premiers, derniers.'"
,"17":"Quand Jésus était sur la route de Jérusalem, il prit à part les Douze et, tout en marchant, il leur dit:"
,"18":"'Voici que nous montons à Jérusalem; le Fils de l'Homme va être livré aux chefs des prêtres et aux maîtres de la Loi qui le condamneront à mort."
,"19":"Ils le remettront aux étrangers qui vont l'humilier, le fouetter et le mettre en croix. Mais il ressuscitera le troisième jour.'"
,"20":"A ce moment la mère des fils de Zébédée vint trouver Jésus avec ses fils et elle se prosterna pour lui demander une faveur."
,"21":"Jésus lui dit: 'Que veux-tu?' Elle lui dit: 'Tu as là mes deux fils. Ordonne que dans ton royaume ils siègent l'un à ta droite et l'autre à ta gauche.'"
,"22":"Jésus répondit: 'Vous ne savez pas ce que vous demandez. Pouvez-vous boire la coupe que je dois boire?' Ils dirent: 'Oui, nous le pouvons.'"
,"23":"Jésus leur dit: 'Vous boirez donc à ma coupe. Mais de siéger à ma droite et à ma gauche, ce n'est pas à moi de le donner; ce sera pour ceux à qui mon Père l'a destiné.'"
,"24":"En entendant cela, les dix autres étaient indignés contre les deux frères."
,"25":"Jésus les appela et leur dit: 'Vous savez que les chefs des nations païennes se conduisent en dictateurs, et leurs grands personnages abusent de leur autorité. "
,"26":"Cela ne devra pas être chez vous. Si l'un d'entre vous veut être grand, qu'il se fasse votre serviteur,"
,"27":"et si l'un d'entre vous veut être le premier, qu'il soit votre esclave,"
,"28":"tout comme le Fils de l'Homme qui n'est pas venu pour être servi, mais pour servir et donner sa vie en rançon pour la multitude.'"
,"29":"Comme ils sortaient de Jéricho, beaucoup de gens les accompagnaient."
,"30":"Or voici que deux aveugles étaient assis sur le bord du chemin. Quand ils apprirent que Jésus passait, ils crièrent: 'Aie pitié de nous, Seigneur, fils de David!'"
,"31":"Et comme les gens leur disaient de se taire, ils criaient encore plus fort: 'Seigneur, fils de David, aie pitié de nous!'"
,"32":"Jésus s'arrêta et les appela. Il leur demanda: 'Que voulez-vous que je fasse pour vous?'"
,"33":"Ils répondirent: 'Seigneur, que nos yeux s'ouvrent!'"
,"34":"Jésus eut pitié d'eux et toucha leurs yeux. Aussitôt ils purent voir, et ils marchèrent à sa suite."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Ils étaient déjà près de Jérusalem et ils entraient dans Bethphagé sur le mont des Oliviers. Alors Jésus envoya deux disciples"
,"2":"en leur disant: 'Allez jusqu'au village d'en face. Vous trouverez tout de suite une ânesse attachée avec son petit. Vous la détacherez et vous me l'amènerez.'"
,"3":"Et si quelu'un vous dit quelque chose, répondez que le Seigneur en a besoin mais qu'il les renverra aussitôt.'"
,"4":"C'est ainsi que se réalisa la parole du prophète"
,"5":"Dites à la fille de Sion: 'Voici que ton roi vient à toi, pacifique et monté sur un âne, sur un ânon né pour servir.'"
,"6":"Les disciples allèrent et firent comme Jésus leur avait ordonné."
,"7":"Ils amenèrent l'ânesse et l'ânon; ils les couvrirent de leurs manteaux et Jésus s'assit dessus."
,"8":"La foule était très nombreuse; certains étendaient leurs manteaux sur le chemin, d'autres coupaient des rameaux sur les arbes et en couvraient le chemin."
,"9":"La foule qui allait devant ou qui suivait lançait des acclamations: 'Hosamah pur le fils de David! Béni soit celui qui vient au nom du Seigneur! Hosannah dans les hauteurs du ciel!'"
,"10":"Lorsque Jésus entra dans Jérusalem, toute la ville commença à s'agiter. On disait: 'Qui est-ce?'"
,"11":"Et les gens rèpondaient: 'C'est le prophète Jèsus, de Nazareth en gallilée!'"
,"12":"Jes´s entra dans le Temple et il mit dehors tous ceux qui vendaient ou achetaient dans le Temple. Il retournait les tables des changeurs de monnaie et les sièges des vendeurs de colombes."
,"13":"Il leur disait: ' 'Il est écrit: MA maison sera appelée Maison de Prière, mais vous, vous en avez fait une caverne de voleurs.'"
,"14":"Dans le Temple, des aveugles et des écolopés vinrent à lui et il les quérit."
,"15":"Les chefs des prêtes et les maître de la Loi voyaient tous les prodiges que Jésus réalisait; ils voyaient aussi les enfants qui criaient dans le Temple: 'Hosannah au fils de David!' et ils étaient furieux."
,"16":"Ils lui dirent: 'Entends-tu ce qu'ils disent?' Et Jésus leur répondit: 'Bien sûr. N'avez-vous jamais lu ces paroles: Tu as mis ta louange dans la bouche des enfants et deses anciens du peuple s'approchèrent pour lui demander: 'De quelle autorité fais-tu tout cela? Qui t'a chargé de le faire?'"
,"17":"Puis Jésus les laissa et sortit de la ville en direction de Béthanie pour y passer la nuit."
,"18":"Au matin, comme Jésus regagnait la ville, il eut faim."
,"19":"Il alla droit à un figuier qu'il avait vu près du chemin, mais il n'y trouva rien: il n'y avait que des feuilles. Alors il s'adressa à l'arbre: 'Tu ne donneras plus de fruits, plus jamais!'. Et au même instant le figuier devint sec."
,"20":"En voyant cela les disciples étaient tout étonnés et ils lui demandaient: 'Mais comment le figuier est-il devenu sec d'un seul coup?'"
,"21":"Alors Jésus leur dit: 'En vérité, je vous le dis, si vous ferez beaucoup plus que de dessécher ce figuier; vous direz à la montagne: Enlève-toi de là et jette-toi dans la mer, et cela se fera."
,"22":"Tout ce que vous pouvez demander dans la prière, avec la foi vous l'obtiendrez.'."
,"23":"Jésus entra dans le Temple. Il était là en train d'enseigner"
,"24":"Jésus leur dit: 'Eh bien moi aussi je vais vous poser une question, une seule:"
,"25":"Quand Jean s'est mis à baptiser, était-ce un considèrent Jean comme un prophète.'"
,"27":"Aussi répondent-ils à Jésus: 'Nous ne savons pas.' Et lui de leur dire: 'Je ne vous dirai pas non plus de quel droit je fais tout cela."
,"28":"Mais donnez-moi plutôt votre avis: un homme avait deux fils. Il s'adresse ait à l'étranger."
,"34":"Or voici qu'arrive le moment de la récolte, et il envoie ses serviteurs pour rencontrer les fermiers et prendre sa part de la récolte."
,"35":"Mais les fermiers se rendent maîtres des serviteurs: ils frappent l'un, tuent l'autre et assomment un troisième à coups de pierres."
,"36":"De nouveau des serviteurs sont envoyés, plus nombreux que les premiers, mais on les traite de la même manière."
,"37":"Alors lui, pour finir, leur envoie son fils. Il pensait en effet: Ils auront du respect pour mon fils."
,"38":"Mais lorsque les fermiers voient le fils, ils se disent: 'C'est lui l'héritier; allons-y, tuons-le, et son héritage sera à nous."
,"39":"Ils le saisissent donc, le jettent hors de la vigne et le tuent."
,"40":"Maintenant, lorsque le maître de la vigne se présentera, comment va-t-il traiter ces fermiers?'"
,"41":"Les autres répondent: 'Il enverra ces misérables à la mort qu'ils mé ritent et il remettra la vigne à d'autres fermiers: ceux-là lui en donneront les fruits quand viendra la saison.'"
,"42":"Jésus leur dit: 'Peut-être avez-vous lu ceci dans les Ecritures: La pierre rejetée par les constructeurs est devenue la pierre d'angle. C'est le Seigneur qui l'avait donnée, et nous restons à l'admirer."
,"43":"Aussi je vous dis que le Royaume de Dieu vous sera enlevé pour être donné à un peuple qui en produira les fruits."
,"44":"Quant à la pierre, celui qui tombera sur elle sera brisé, et celui sur qui elle tombera, elle l'écrasera!'"
,"45":"Les chefs des prêtres et les Pharisiens écoutaient ces paraboles, et ils comprirent que Jésus parlait pour eux."
,"46":"Ils auraient voulu s'emparer de lui, mais ils craignaient la foule qui voyait en Jésus un prophète."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Jésus reprit la parole pour les enseigner en paraboles:"
,"2":"'Apprenez quelque chose du Royaume des Cieux. Un roi a préparé les noces de son fils. "
,"3":"Mais lorsqu'il envoie ses serviteurs pour appeler les invités aux noces, ils ne veulent pas venir."
,"4":"De nouveau il envoie d'autres serviteurs pour dire aux invités: 'J'ai maintenant mon banquet tout préparé. Mes taureaux et mes animaux à l'engrais sont déjà tués, tout est prêt; venez aux noces!'"
,"5":"Mais les invités s'en moquent et s'en vont, l'un à son champ, l'autre à son commerce."
,"6":"D'autres se saisissent des serviteurs, leur font violence et les tuent."
,"7":"Alors le roi se met en colère: il envoie ses troupes pour massacrer les meurtriers et mettre le feu à leur ville."
,"8":"Puis il dit à ses serviteurs: 'Les noces sont toujours là, mais les invités n'en étaient pas dignes."
,"9":"Allez donc aux sorties de la ville et invitez aux noces tous ceux que vous trouverez.'"
,"10":"Les serviteurs sortent et ramassent sur les chemins tous ceux qu'ils trouvent, bons ou mauvais: la salle du festin se remplit de convives."
,"11":"Alors le roi entre pour voir de près ceux qui sont à table et il trouve là un homme qui n'a pas mis le vêtement des noces."
,"12":"Il lui dit: Mon ami, comment es-tu entré ici sans avoir le vêtement des noces? Et l'autre ne répond rien."
,"13":"Alors le roi dit à ceux qui l'accompagnent: 'Liez-lui les mains et les pieds et jetez-le dehors, dans les ténèbres; là il y aura pleurs et grincements de dents.'"
,"14":"Sachez-le: beaucoup sont invités et peu sont élus.'"
,"15":"Les Pharisiens se déplacèrent pour voir ensemble comment prendre Jésus au piège dans ses propres paroles."
,"16":"Ils lui envoyèrent donc leurs disciples en même temps que des Hérodiens, et ces gens lui dirent: 'Maître, nous savons que tu es droit et que tu enseignes les chemins de Dieu selon la vérité, sans te laisser influencer par personne; car tu ne cherches pas à te faire bien voir."
,"17":"Dis-nous donc ton avis: est-il permis de payer l'impôt à César ou non?'"
,"18":"Jésus a déjà vu leurs mauvaises intentions; il leur répond: 'Hypocrites, pourquoi essayez-vous de m'avoir?"
,"19":"Faites-moi voir la monnaie qu'on donne pour l'impôt.' Et ils lui présentent un denier."
,"20":"Jésus leur dit: 'Cette tête, et ce nom qu'on a gravé, de qui sont-ils?'"
,"21":"Ils répondent: 'De César!' Alors Jésus leur dit: 'Rendez à César ce qui est de César, et à Dieu ce qui est de Dieu.'"
,"22":"En entendant cela, ils étaient très surpris. Ils laissèrent Jésus et s'en allèrent."
,"23":"Un certain jour, des Saducéens vinrent trouver Jésus. Selon eux il n'y a pas de résurrection. Aussi l'interrogèrent-ils de la façon suivante:"
,"24":"'Maître, Moïse a dit: Si un homme meurt sans enfants, son frère prendra la veuve et donnera ainsi des héritiers au défunt."
,"25":"Or il y avait chez nous sept frères; le premier s'est marié et il est mort. Comme il n'avait pas d'héritier, il a laissé sa femme à son frère."
,"26":"La même chose s'est passée pour le deuxième: il l'a laissée au troisième, et ainsi de suite pour les sept."
,"27":"La femme est morte la der nière."
,"28":"Dans le cas d'une résurrection, lequel des sept aura la femme? Car tous l'ont eue pareillement.'"
,"29":"Jésus répondit: 'Vous êtes dans l'erreur, vous ne connaissez pas les Ecritures et pas davantage la puissance de Dieu."
,"30":"A la résurrection on ne prend plus de femme ou de mari: tous sont comme des anges de Dieu dans le ciel."
,"31":"Quant à savoir s'il y a une résurrection, n'avez-vous pas lu ce que Dieu vous a dit:"
,"32":"Je suis le Dieu d'Abraham, le Dieu d'Isaac et le Dieu de Jacob? Il n'est pas un Dieu des morts, mais des vivants!'"
,"33":"Une foule de gens écoutaient Jésus et ils étaient frappés de son enseignement."
,"34":"Quand les Pharisiens apprirent que Jésus avait fermé la bouche aux Saducéens, ils vinrent en groupe,"
,"35":"et l'un d'eux voulut mettre Jésus à l'épreuve avec cette question:"
,"36":"'Maître, quel est le grand commandement de la Loi?'"
,"37":"Jésus lui dit: 'Tu aimeras le Seigneur ton Dieu de tout ton coeur, de toute ton âme et de tout ton esprit."
,"38":"Voilà le grand, le premier commandement."
,"39":"Il y en a un deuxième tout à fait pareil: Tu aimeras ton prochain comme toi-même."
,"40":"Toute la Loi et les Prophètes tournent autour de ces deux commandements.'"
,"41":"Profitant de ce que les Pharisiens étaient là réunis, Jésus leur posa cette question:"
,"42":"'Parlez-moi du Messie: à votre avis, de qui est-il fils?' Ils lui répondirent: 'De David!'"
,"43":"Jésus leur dit: 'Mais pourtant David lui donne le titre de Seigneur dans un texte inspiré. Il dit:"
,"44":"Le Seigneur a dit à mon Seigneur: Siège à ma droite et vois comment je fais de tes ennemis ton marchepied."
,"45":"Si David lui donne le titre de Seigneur, comment peut-il être son fils?'"
,"46":"Et personne ne put lui répondre quoi que ce soit. Aussi, à partir de ce moment-là, personne n'osa plus lui poser ce genre de questions."
}`)
	CurrentBook.AddChapter(23, `{
"1":"Alors Jésus fit ce discours à la foule et à ses disciples:"
,"2":"'Les maîtres de la Loi et les Pharisiens se sont fait les interprètes de Moïse."
,"3":"Faites et observez tout ce qu'ils vous disent, mais ne faites pas comme ils font, car ils disent et ne font pas."
,"4":"Ils préparent de lourdes charges, et ils vous les mettent sur les épaules; mais eux-mêmes ne bougeraient pas un doigt pour les remuer."
,"5":"Tout ce qu'ils font, ils le font pour être vus des hommes: voyez ces larges citations de l'Ecriture fixées à leur front, et ces longues franges à leurs manteaux!"
,"6":"Ils aiment les premières places dans les repas, les premiers fauteuils à la synagogue"
,"7":"et les salutations sur la place; ils aiment que les gens les appellent Maître."
,"8":"Mais vous, n'acceptez pas qu'on vous appelle Maître, car vous n'avez qu'un Maître, et vous êtes tous frères."
,"9":"Ne donnez à personne sur cette terre le titre de Père, car vous n'avez qu'un Père, celui du ciel."
,"10":"N'acceptez pas qu'on vous appelle Guide, car seul le Christ est votre Guide."
,"11":"Que le plus grand d'entre vous soit votre serviteur."
,"12":"Car celui qui s'élève sera abaissé et celui qui s'humilie sera élevé.'"
,"13":"'Malheur à vous, gens de la Loi et Pharisiens hypocrites! Vous fermez aux autres le Royaume des Cieux; vous-mêmes n'y entrez pas, et quand un autre est sur le point d'y entrer, vous l'en empêchez!"
,"15":"Malheur à vous, gens de la Loi et Pharisiens hypocrites! Vous parcourez la terre et les mers pour recruter un prosélyte, et quand il l'est devenu, vous en faites un candidat à l'enfer deux fois pire que vous!"
,"16":"Malheur à vous, guides aveugles! Vous dites: Si quelqu'un jure par le Sanctuaire, le serment n'oblige pas; mais si on a prêté serment sur l'or du Sanctuaire, on est tenu."
,"17":"Aveugles sans cervelle! Quel est le plus grand: l'or, ou le sanctuaire qui rend sacré cet or?"
,"18":"Et vous dites: Si l'on jure sur l'autel, le serment est nul; mais si l'on jure sur l'offrande déposée sur l'autel, on est obligé."
,"19":"Aveugles! Quel est le plus grand: l'offrande, ou l'autel qui rend sacrée cette offrande?"
,"20":"Celui qui jure par l'autel, jure par l'autel et par tout ce qu'il y a dessus."
,"21":"Celui qui jure par le Sanctuaire, jure par le Sanctuaire et par celui qui l'habite."
,"22":"Et celui qui jure par le ciel, jure par le trône de Dieu et par celui qui y siège."
,"23":"Malheur à vous, maîtres de la Loi et Pharisiens hypocrites! Vous payez la dîme jusque sur la menthe, l'anis et le cumin, mais vous oubliez ce qui a le plus de poids dans la Loi: la justice, la miséricorde et la foi! Là sont les oeuvres à faire, sans pour autant oublier le reste."
,"24":"Guides aveugles, vous filtrez le moustique et vous avalez le chameau!"
,"25":"Malheur à vous, maîtres de la Loi et Pharisiens hypocrites! Vous purifiez l'extérieur de la coupe et du plat, mais l'intérieur s'est rempli par les abus et la convoitise."
,"26":"Pharisien aveugle, purifie d'abord l'intérieur du plat, et l'extérieur aussi sera pur."
,"27":"Malheur à vous, maîtres de la Loi et Pharisiens hypocrites! Vous ressemblez à des tombes qu'on a passées à la chaux: elles se présentent bien à l'extérieur, mais à l'intérieur ce ne sont qu'ossements de morts, des choses impures."
,"28":"Vous aussi, à l'extérieur les gens vous voient comme des hommes justes; mais à l'intérieur vous êtes pleins d'hypocrisie et de choses condamnables."
,"29":"Malheur à vous, maîtres de la Loi et Pharisiens hypocrites! Vous construisez des monuments pour les prophètes et vous ornez les tombeaux des hommes justes;"
,"30":"et vous dites: Si nous avions vécu au temps de nos pères, nous n'aurions pas versé le sang des prophètes comme ils l'ont fait."
,"31":"Vous reconnaissez donc que vous êtes les fils de ceux qui ont tué les prophètes."
,"32":"Faites comme vos pères et comblez la mesure!"
,"33":"Serpents, race de vipères, comment échapperez-vous au jugement de l'enfer?"
,"34":"Maintenant je vous envoie des prophètes, des sages et des maîtres de la Loi, mais vous en tuerez et mettrez en croix, vous fouetterez les autres dans vos synagogues et vous les poursuivrez de ville en ville."
,"35":"A la fin, c'est tout le sang innocent répandu sur cette terre qui retombera sur vous, depuis le sang d'Abel, le juste, jusqu'au sang de Zacharie, fils de Barachie, que vous avez tué entre le sanctuaire et l'autel."
,"36":"En vérité, je vous le dis, tout cela retombera sur cette génération."
,"37":"Jérusalem! Jérusalem! toi qui assassines les prophètes et reçois à coups de pierres ceux qui te sont envoyés, combien de fois ai-je voulu rassembler tes enfants comme l'oiseau rassemble ses petits sous ses ailes! Mais vous n'avez pas voulu."
,"38":"Votre Maison vous sera laissée vide."
,"39":"Oui, je vous le dis, vous ne me verrez plus jusqu'à ce que vous disiez: Béni soit celui qui vient au nom du Seigneur.'"
}`)
	CurrentBook.AddChapter(24, `{
"1":"Comme Jésus sortait du Temple pour s'en aller, ses disciples s'approchèrent et lui firent admirer les bâtiments du Temple."
,"2":"Mais il leur dit: 'Vous voyez tout cela? En vérité, je vous le dis, il ne restera pas ici pierre sur pierre: tout sera détruit.'"
,"3":"Un peu plus tard, comme Jésus s'était assis au Mont des Oliviers, ses disciples vinrent lui demander en particulier: 'Dis-nous quand cela aura lieu, et quel sera le signe de ta venue et de la fin des temps.'"
,"4":"Jésus prit la parole et leur dit: 'Ne vous laissez pas égarer "
,"5":"lorsque plusieurs revendiqueront mon titre et diront: Je suis le Messie. Ils égareront bien des gens."
,"6":"Vous entendrez parler de guerres et de rumeurs de guerre; ne cédez pas à la panique. Cela doit arriver, mais ce ne sera pas encore la fin."
,"7":"On verra des soulèvements: peuple contre peuple et nation contre nation. Il y aura des famines et des tremblements de terre en divers lieux,"
,"8":"mais tout cela ne sera que le début, les premières douleurs."
,"9":"Alors vous serez dénoncés et persécutés et l'on vous fera mourir, et vous serez haïs de tous les peuples à cause de mon nom."
,"10":"Beaucoup alors chuteront; ils se dénonceront les uns les autres et se haïront."
,"11":"De faux prophètes se présenteront qui égareront bien des gens,"
,"12":"et le mal se généralisera de telle sorte que chez beaucoup l'amour se refroidira."
,"13":"Mais celui qui tiendra bon jusqu'à la fin sera sauvé."
,"14":"L'Evangile du Royaume sera proclamé dans le monde entier: toutes les nations en recevront l'annonce, et alors viendra la fin."
,"15":"Quand vous verrez ce que dit le prophète Daniel: l'abomination du dévastateur installée dans le lieu saint (que le lecteur comprenne!),"
,"16":"alors, fuyez à la montagne vous qui êtes en Judée."
,"17":"Si tu es sur la terrasse de ta maison, ne redescends pas prendre tes affaires;"
,"18":"si tu es aux champs, ne reviens pas chercher ton vêtement."
,"19":"Ce sera grande malchance pour une femme que d'être enceinte ou d'allaiter en ces jours-là!"
,"20":"Demandez à Dieu de n'avoir pas à fuir en hiver ou un jour de sabbat."
,"21":"Car ce sera une très grande épreuve, comme il n'y en a pas eu depuis le début du monde jusqu'à maintenant et comme il n'en arrivera plus."
,"22":"Si le temps n'en était pas abrégé, personne n'en sortirait vivant, mais Dieu a abrégé ces jours par égard pour ses élus."
,"23":"Alors, si l'on vous dit que le Messie est ici ou là, ne le croyez pas."
,"24":"Car de faux messies et de faux prophètes se présenteront; ils feront voir de grands signes et des prodiges au point d'égarer s'il était possible, même les élus."
,"25":"Mais je vous ai prévenus."
,"26":"Si donc on vous dit: 'Il est là-bas au désert', n'y partez pas; 'Le voilà du côté des grottes', ne le croyez pas."
,"27":"Voyez comment l'éclair part de l'orient et enflamme le ciel jusqu'à l'occident: ce sera pareil à la venue du Fils de l'Homme."
,"28":"Là où le corps est tombé, là se rassemblent les vautours.'"
,"29":"'Mais après l'épreuve de ces jours-là, le soleil s'obscurcira, la lune ne donnera plus sa clarté, les étoiles tomberont du ciel et les forces cosmiques seront déréglées."
,"30":"Alors apparaîtra dans le ciel le signe du Fils de l'Homme, et toutes les races de la terre se frapperont la poitrine quand elles verront le Fils de l'Homme venant sur les nuées du ciel avec puissance et grande gloire."
,"31":"Il enverra ses anges avec une trompette sonore pour rassembler ses élus des quatre points de l'horizon, du plus lointain de l'univers."
,"32":"Ecoutez cette leçon tirée du figuier. Lorsque sa ramure redevient souple et que des feuilles lui poussent, vous savez que l'été est proche;"
,"33":"vous de même, quand vous verrez tout cela, sachez que c'est tout proche, sur le pas de la porte."
,"34":"En vérité, je vous le dis, cette génération ne passera pas que tout cela n'arrive."
,"35":"Le ciel et la terre passeront, mes paroles ne passeront pas."
,"36":"Quant à ce Jour, et quand ce sera l'heure, personne ne sait rien, pas même les anges dans le ciel, pas même le Fils: seul le Père."
,"37":"La venue du Fils de l'Homme rappellera le temps de Noé."
,"38":"Quelques jours encore avant le déluge, les gens mangeaient, ils buvaient, hommes et femmes se mariaient, jusqu'au jour où Noé entra dans l'arche."
,"39":"Ils n'ont rien su jusqu'à ce que vienne le déluge, et il les a tous emportés. Ce sera pareil pour la venue du Fils de l'Homme."
,"40":"Alors, de deux hommes dans un même champ, l'un sera pris, l'autre laissé."
,"41":"De deux femmes qui tournent la meule côte à côte, l'une sera prise, l'autre laissée.'"
,"42":"'Veillez donc, car vous ne savez pas à quelle heure vient votre Seigneur."
,"43":"Pensez-y: si le maître de maison savait quand, cette nuit, viendra le voleur, il resterait éveillé et ne le laisserait pas percer son mur."
,"44":"Soyez donc prêts, vous aussi, car le Fils de l'Homme vient à l'heure que vous ne savez pas."
,"45":"Imaginez un serviteur, digne de confiance et capable. Son seigneur lui a donné la responsabilité des gens de sa maison et c'est lui qui leur donne la nourriture en temps voulu."
,"46":"Heureux ce serviteur si son seigneur en rentrant le trouve occupé à faire ce qu'il doit."
,"47":"En vérité, je vous le dis, il lui confiera tout ce qui lui appartient."
,"48":"Par contre le mauvais serviteur se dit en lui-même: 'Mon seigneur sera en retard.'"
,"49":"Et puis il commence à frapper ses compagnons de service, il mange et boit avec les buveurs."
,"50":"Mais le seigneur viendra le jour où son serviteur ne l'attendait pas, et à l'heure qu'il n'avait pas prévue."
,"51":"Il lui enlèvera sa charge et le mettra avec les irresponsables. Là il y aura pleurs et grincements de dents.'"
}`)
	CurrentBook.AddChapter(25, `{
"1":"'Voyez ce qui se passera alors dans le Royaume des Cieux. Dix jeunes filles ont pris leurs lampes et sont parties à la rencontre du marié."
,"2":"Cinq d'entre elles sont des étourdies, mais les cinq autres savent prévoir."
,"3":"Les étourdies ont pris leurs lampes, mais n'ont pas emporté d'huile en plus,"
,"4":"tandis que les prévoyantes ont pris en même temps que leurs lampes une réserve d'huile."
,"5":"Mais voici que le marié se fait attendre; toutes les filles tombent de sommeil et bientôt elles s'endorment."
,"6":"Au milieu de la nuit on entend un cri: 'Voici le marié, sortez pour le recevoir!'"
,"7":"Toutes aussitôt se réveillent et préparent leurs lampes."
,"8":"Les étourdies disent alors aux prévoyantes: 'Donnez-nous de votre huile, car nos lampes sont près de s'éteindre.'"
,"9":"Mais les prévoyantes répondent: 'Il n'y en aurait sûrement pas assez pour nous et pour vous. Allez trouver ceux qui en vendent et achetez-en pour vous.'"
,"10":"Les voilà donc parties pour en acheter, et c'est alors que le marié arrive. Celles qui sont prêtes à le recevoir entrent avec lui pour les noces, et on referme la porte."
,"11":"Plus tard arrivent aussi les autres: 'Seigneur, Seigneur, disent-elles, ouvre-nous!'"
,"12":"Mais lui répond: 'En vérité, je vous le dis, je ne vous connais pas!'"
,"13":"Restez donc éveillés car vous ne savez ni le jour ni l'heure.'"
,"14":"'Ecoutez encore ceci: Un homme, avant de partir à l'étranger, fait appeler ses serviteurs pour leur remettre son argent."
,"15":"Il donne au premier cinq talents, à un autre deux, et au troisième un talent: à chacun selon sa capacité. Puis il part."
,"16":"Celui qui a reçu les cinq talents va immédiatement les faire travailler et il en gagne cinq autres."
,"17":"Celui qui en a reçu deux fait de même et en gagne deux autres."
,"18":"Quant à celui qui n'en a reçu qu'un, il fait un trou dans la terre et cache l'argent de son maître."
,"19":"Longtemps après, le maître de ces serviteurs vient leur demander des comptes."
,"20":"Celui qui a reçu les cinq talents lui en présente cinq de plus: 'Seigneur, dit-il, tu m'as confié cinq talents, en voici cinq autres que j'ai gagnés.'"
,"21":"Son maître alors lui déclare: 'Très bien, bon et fidèle serviteur, tu as été fidèle pour une petite chose, je te confierai beaucoup plus; viens partager la joie de ton maître.'"
,"22":"Celui qui a reçu les deux talents s'avance à son tour: 'Seigneur, dit-il, tu m'as confié deux talents, en voici deux autres que j'ai gagnés.'"
,"23":"Son maître répond: 'Très bien, bon et fidèle serviteur, tu as été fidèle pour une petite chose, je te confierai beaucoup plus; viens partager la joie de ton maître.'"
,"24":"Celui qui n'a reçu qu'un talent s'avance alors et dit: 'Seigneur, je savais que tu es un homme dur. Tu moissonnes là où tu n'as pas semé et tu amasses quand tu n'as rien engagé."
,"25":"J'ai donc pris peur et je suis allé cacher ton talent dans la terre. Voilà ce qui t'appartient.'"
,"26":"Mais son maître lui répond: 'Mauvais serviteur, bon à rien, tu savais que je moissonne là où je n'ai pas semé et que j'amasse quand je n'ai rien engagé."
,"27":"Mais alors, tu devais placer mon argent à la banque: à mon retour j'aurais repris ce qui est à moi avec les intérêts."
,"28":"Prenez-lui donc ce talent et donnez-le à celui qui en a dix."
,"29":"On donnera à celui qui produit et il sera dans l'abondance, mais celui qui ne produit pas, on lui prendra même ce qu'il a."
,"30":"Et ce serviteur inutile, jetez-le dehors dans les ténèbres: là il y aura pleurs et grincements de dents.'"
,"31":"'Lorsque le Fils de l'Homme viendra dans sa gloire accompagné de tous les anges, il s'assiéra sur le trône de Gloire, le sien."
,"32":"Toutes les nations seront amenées devant lui; il séparera les uns d'avec les autres, comme le berger sépare les brebis d'avec les chèvres."
,"33":"A sa droite il rangera les brebis, et à sa gauche les chèvres."
,"34":"Alors le Roi dira à ceux qui sont à sa droite: 'Venez, les bénis de mon Père, prenez possession du Royaume qui est préparé pour vous depuis la création du monde."
,"35":"Car j'ai eu faim et vous m'avez donné à manger; j'ai eu soif et vous m'avez donné à boire; j'étais étranger et vous m'avez accueilli,"
,"36":"sans vêtement, et vous m'avez habillé. J'étais malade et vous m'avez visité, j'étais en prison et vous êtes venus vers moi.'"
,"37":"Alors les justes lui demanderont: 'Quand donc, Seigneur, t'avons-nous vu affamé pour ainsi te nourrir? Quand t'avons-nous vu assoiffé et t'avons-nous donné à boire?"
,"38":"Quand t'avons-nous vu étranger et t'avons-nous accueilli, quand étais-tu sans vêtements et t'avons-nous vêtu,"
,"39":"quand t'avons-nous vu malade ou en prison et sommes-nous venus à toi?'"
,"40":"Et le roi leur répondra: 'En vérité je vous le dis, tout ce que vous avez fait à l'un de ces petits qui sont mes frères, c'est à moi que vous l'avez fait.'"
,"41":"Puis il dira à ceux qui sont à sa gauche: 'Retirez-vous loin de moi, maudits! Allez au feu éternel qui a été préparé pour le démon et pour ses anges."
,"42":"Car j'ai eu faim et vous ne m'avez pas donné à manger; j'avais soif et vous ne m'avez pas donné à boire;"
,"43":"j'étais étranger et vous ne m'avez pas accueilli, sans vêtement, et vous ne m'avez pas habillé; malade et en prison, et vous ne m'avez pas visité.'"
,"44":"Tous alors protesteront: 'Seigneur, quand t'avons-nous vu affamé ou assoiffé, quand t'avons-nous vu étranger, sans vêtement, malade et en prison, sans te porter secours?'"
,"45":"Et lui leur répondra: 'En vérité, je vous le dis, si vous ne l'avez pas fait à l'un de ces petits, c'est à moi que vous ne l'avez pas fait.'"
,"46":"Alors ceux-ci iront au châtiment éternel, et les justes à la vie éternelle.'"
}`)
	CurrentBook.AddChapter(26, `{
"1":"Après avoir terminé tous ces discours, Jésus dit à ses disciples:"
,"2":"'Vous savez que dans deux jours c'est la Pâque; le Fils de l'Homme sera livré pour être mis en croix.'"
,"3":"Au même moment les chefs des prêtres et les Anciens du peuple se réunissaient à la résidence du Grand Prêtre, qui s'appelait Caïphe."
,"4":"Là ils se mirent d'accord pour s'emparer de Jésus dans un coup monté et pour le mettre à mort."
,"5":"Mais ils disaient: 'Pas durant la fête, car le peuple pourrait s'agiter.'"
,"6":"Tandis que Jésus était à Béthanie dans la maison de Simon le lépreux,"
,"7":"une femme s'approcha de lui. Elle apportait un vase d'albâtre avec du parfum de myrrhe de grande valeur, et elle répandit le parfum sur sa tête pendant qu'il était allongé avec les invités."
,"8":"En voyant cela les disciples s'indignèrent: 'Pourquoi ce gâchis?"
,"9":"On aurait pu vendre ce parfum très cher et donner l'argent aux pauvres.'"
,"10":"Mais Jésus s'en aperçoit et il leur dit: 'Pourquoi cherchez-vous des ennuis à cette femme? Ce qu'elle vient de faire pour moi est une bonne oeuvre."
,"11":"Des pauvres, vous en avez toujours avec vous, mais moi vous ne m'aurez pas toujours."
,"12":"Elle préparait déjà ma sépulture quand elle a versé sur mon corps ce parfum de myrrhe."
,"13":"En vérité je vous le dis, partout où cet Evangile sera proclamé, dans le monde entier, on dira aussi ce qu'elle a fait et on se souviendra d'elle.'"
,"14":"A ce moment l'un des Douze, qui s'appelait Judas Iscariote, alla trouver les chefs des prêtres"
,"15":"et leur dit: 'Combien me donnerez-vous pour que je vous le livre?' Ils lui donnèrent trente pièces d'argent,"
,"16":"et dès lors il chercha l'occasion de le livrer."
,"17":"Le premier jour des Pains sans Levain, les disciples vinrent demander à Jésus: 'Où mangeras-tu la Pâque? Où veux-tu que nous la préparions?'"
,"18":"Il leur dit: 'Allez à la ville, chez un tel, et dites-lui: Le Maître te fait dire: Mon heure est proche, je veux faire la Pâque chez toi avec mes disciples.'"
,"19":"Les disciples firent comme Jésus l'avait ordonné et ils préparèrent la Pâque."
,"20":"Le soir venu, Jésus se mit à table avec les Douze et,"
,"21":"pendant qu'ils mangeaient, il leur dit: 'En vérité je vous le dis, l'un de vous va me livrer.'"
,"22":"Ils en étaient profondément peinés et chacun se mit à lui demander: 'Ce serait moi, Seigneur?'"
,"23":"Et lui leur dit: 'La main du traître était avec la mienne, prenant du même plat!"
,"24":"Le Fils de l'Homme s'en va comme l'Ecriture le dit de lui, mais malheur à cet homme par qui le Fils de l'Homme est livré. Il vaudrait mieux pour lui qu'il ne soit pas né.'"
,"25":"Judas prit également la parole: 'Ce serait moi, Seigneur?' Et Jésus répondit: 'Tu l'as dit.'"
,"26":"Pendant qu'ils mangeaient, Jésus prit du pain, prononça une bénédiction et le rompit. Puis il le donna aux disciples en disant: 'Prenez et mangez, ceci est mon corps.'"
,"27":"Ensuite il prit la coupe, il rendit grâce et la leur donna en disant: 'Buvez-en tous;"
,"28":"ceci est mon sang, le sang de l'alliance, qui est versé pour une multitude, pour le pardon des péchés."
,"29":"Maintenant je vous le dis: je ne boirai plus de ce produit de la vigne jusqu'au jour où, avec vous, je boirai le vin nouveau dans le Royaume de mon Père.'"
,"30":"Après cela ils chantèrent les hymnes et partirent vers le mont des Oliviers."
,"31":"Alors Jésus leur dit: 'Cette nuit vous allez tous chuter à cause de moi. Car il est écrit: Je frapperai le pasteur et les brebis du troupeau seront dispersées."
,"32":"Mais quand je me relèverai, j'irai vous attendre en Galilée.'"
,"33":"Pierre lui dit: 'Même si tous tombent et abandonnent, moi jamais!'"
,"34":"Jésus répond: 'En vérité je te le dis, cette nuit-même, avant que le coq ne chante, tu m'auras renié trois fois.'"
,"35":"Mais Pierre continue: 'Même s'il me fallait mourir avec toi, je ne te renierais pas.' Et tous les disciples disent la même chose."
,"36":"Après cela Jésus arrive avec eux à une propriété appelée Gethsémani et il dit aux disciples: 'Asseyez-vous ici pendant que j'irai prier là-bas.'"
,"37":"Jésus prend avec lui Pierre et les deux fils de Zébédée, et il commence à être envahi par la tristesse et l'angoisse."
,"38":"Il leur dit: 'Mon âme est triste à en mourir. Restez ici et veillez avec moi.'"
,"39":"Puis il s'éloigne un peu et se prosterne face contre terre pour prier, disant: 'Mon Père, si c'est possible, que cette coupe s'éloigne de moi. Cependant, non pas comme je veux, mais comme tu veux.'"
,"40":"Jésus vient alors vers les disciples et les trouve endormis; il dit à Pierre: 'Vous n'avez donc pas été capables de rester une heure éveillés avec moi."
,"41":"Veillez et priez pour ne pas être pris dans la tentation. Car l'esprit est généreux, mais la chair est faible.'"
,"42":"De nouveau Jésus s'éloigne et il prie une deuxième fois: 'Mon Père, si cette coupe ne peut passer sans que je la boive, que ta volonté soit faite!'"
,"43":"Il revient et les trouve encore endormis: leurs yeux étaient lourds de sommeil."
,"44":"Alors il les laisse, et une troisième fois il répète la même prière."
,"45":"Lorsqu'il revient vers les disciples il leur dit: 'C'est bien le moment de dormir et de vous reposer! L'heure est venue, et le Fils de l'Homme va être livré entre les mains des pécheurs."
,"46":"Levez-vous, allons! Celui qui me trahit est déjà là.'"
,"47":"Jésus parlait encore lorsque arriva Judas, l'un des Douze, et avec lui les gens des chefs des prêtres et des Anciens du peuple, toute une troupe armée d'épées et de gourdins."
,"48":"Celui qui le trahissait leur avait donné un signe: 'C'est celui que j'embrasserai. Arrêtez-le.'"
,"49":"Aussitôt il approcha de Jésus et lui dit: 'Salut, maître.' Et il l'embrassa."
,"50":"Jésus lui dit: 'Ami, fais donc ce qui t'amène.'"
,"51":"A ce moment, un de ceux qui étaient avec Jésus tira son épée, frappa le serviteur du Grand Prêtre et lui coupa l'oreille."
,"52":"Alors Jésus lui dit: 'Remets ton épée à sa place. Tous ceux qui prennent l'épée périssent par l'épée."
,"53":"Crois-tu que je ne pourrais pas faire appel à mon Père et il m'enverrait sur le champ douze légions d'anges?"
,"54":"Si les Ecritures disent que cela doit être, ne doivent-elles pas s'accomplir?'"
,"55":"A ce moment Jésus dit à la foule: 'Pour m'arrêter vous êtes venus avec épées et gourdins, comme si j'étais un brigand! Tous les jours pourtant j'allais m'asseoir dans le Temple pour y enseigner, et vous ne m'avez pas arrêté!"
,"56":"Mais tout cela s'est fait de façon que s'accomplissent les écrits prophétiques.',A ce moment-là tous les disciples l'abandonnèrent et s'enfuirent."
,"57":"Ceux qui avaient arrêté Jésus l'amenèrent chez le Grand Prêtre Caïphe. Là se réunirent les maîtres de la Loi et les Anciens."
,"58":"Pierre avait suivi de loin, jusqu'à la résidence du Grand Prêtre; il entra et s'assit avec les hommes de la police du Temple pour voir la fin."
,"59":"Les chefs des prêtres et tout le conseil du Sanhédrin cherchaient un faux témoignage pour condamner Jésus à mort."
,"60":"Plusieurs faux témoins se présentèrent, mais on ne trouva rien. Voici pourtant que deux se présentent"
,"61":"et déclarent: 'Cet homme a dit: Je suis capable de détruire le Temple de Dieu et de le rebâtir en trois jours.'"
,"62":"Alors le Grand Prêtre se lève et lui demande: 'Tu ne réponds rien? Quelle est cette histoire dont ils t'accusent?'"
,"63":"Mais Jésus gardait le silence. Alors le Grand Prêtre lui dit: 'Au nom du Dieu vivant, je t'ordonne de nous dire si tu es le Messie, le Fils de Dieu.' "
,"64":"Et Jésus répond: 'Tu l'as dit! Et j'ajoute que dès maintenant vous verrez le Fils de l'Homme siéger à la droite du Tout-Puissant et venir sur les nuées du ciel.'"
,"65":"Aussitôt le Grand Prêtre déchire ses vêtements en disant: 'Il a blasphémé! Qu'avons-nous à faire de témoins? Vous venez d'entendre le blasphème."
,"66":"Quel est votre avis?' Ils répondent: 'Il mérite la mort!'"
,"67":"A ce moment on commence à le gifler et à lui cracher à la figure; d'autres le frappent"
,"68":"en disant: 'Messie, fais le prophète, dis-nous qui t'a frappé!'"
,"69":"Pierre était toujours assis dehors dans la cour. Or voici qu'une petite servante s'approche et lui dit: 'Toi aussi, tu étais avec Jésus le Galiléen.'"
,"70":"Mais lui le nie devant tout le monde et il répond: 'Je ne sais pas ce que tu veux dire.'"
,"71":"Comme il se rapproche de la porte pour sortir, une autre le voit et dit à ceux qui sont là: 'Il accompagnait Jésus, le Nazaréen.'"
,"72":"De nouveau Pierre nie et même il jure: 'Je ne connais pas cet homme!'"
,"73":"Un peu plus tard ceux qui sont présents disent à Pierre: 'Tu es sûrement l'un des leurs, tu as bien l'accent de là-bas.'"
,"74":"Mais lui commence à lancer des malédictions et à jurer: 'Je ne connais pas cet homme'. Presque aussitôt un coq chante "
,"75":"et Pierre se rappelle le mot que Jésus lui a dit: 'Avant que le coq ne chante, tu m'auras renié trois fois.' Alors il sort et il pleure amèrement."
}`)
	CurrentBook.AddChapter(27, `{
"1":"Au matin il y eut un conseil général des chefs des prêtres et des Anciens du peuple pour voir les moyens de mettre Jésus à mort."
,"2":"Après l'avoir lié, ils le conduisirent chez Pilate, le gouverneur, pour le lui livrer."
,"3":"Lorsque Judas, qui avait trahi Jésus, apprit sa condamnation, il fut pris de remords; il vint rendre les trente pièces d'argent aux chefs des prêtres et aux Anciens."
,"4":"Judas leur dit: 'J'ai péché, j'ai fait mourir un innocent.',Eux lui répondirent: 'Qu'est-ce que cela nous fait? C'est ton problème!' "
,"5":"Alors il jeta les pièces d'argent en direction du Sanctuaire, il se retira et alla se pendre."
,"6":"Les chefs des prêtres ramassèrent les pièces, mais ils dirent: 'Il n'est pas permis de les verser au trésor, car c'est le prix du sang versé.'"
,"7":"Aussi, après en avoir discuté, ils achetèrent avec cet argent le Champ du Potier pour y enterrer les étrangers."
,"8":"C'est la raison pour laquelle ce terrain s'est appelé jusqu'à maintenant le Champ du Sang."
,"9":"De cette façon s'accomplit une parole du prophète Jérémie: Ils ont pris les trente pièces d'argent, le prix de celui qu'on avait mis à prix, le prix fixé par les fils d'Israël,"
,"10":"et ils l'ont donné pour le champ du potier, comme le Seigneur me l'a demandé."
,"11":"Jésus fut amené devant le gouverneur, et le gouverneur l'interrogea. Il lui dit: 'Es-tu bien le roi des Juifs?' Jésus répondit: 'C'est toi qui le dis.'"
,"12":"Les chefs des prêtres et les Anciens du peuple firent alors entendre leurs accusations, mais il ne répondit rien."
,"13":"Pilate lui demanda: 'Tu n'entends pas toutes ces accusations contre toi?'"
,"14":"Mais Jésus ne répondit absolument rien, de sorte que le gouverneur était fort étonné."
,"15":"Chaque année, pour la Fête, c'était la coutume que le gouverneur relâche un prisonnier, celui que le peuple lui réclamait."
,"16":"Or ils avaient à ce moment un prisonnier fameux, le nommé Barabbas."
,"17":"Comme ils étaient là rassemblés, Pilate leur dit: 'Qui voulez-vous que je vous relâche, Barabbas, ou Jésus qu'on appelle le Messie?'"
,"18":"Car Pilate savait bien qu'on lui avait livré Jésus pour des questions de rivalité."
,"19":"Comme Pilate siégeait à son tribunal, sa femme lui fit dire: 'Ne lui fais rien; c'est un homme droit et j'ai eu cette nuit à cause de lui un rêve qui m'a fait beaucoup souffrir.'"
,"20":"Pour leur part les chefs des prêtres et les Anciens surent amener la foule à réclamer Barabbas et à faire périr Jésus."
,"21":"Aussi, quand Pilate leur demanda: 'Lequel des deux voulez-vous que je vous relâche?' ils répondirent: 'Barabbas!'"
,"22":"Pilate leur dit: 'Et que dois-je faire de Jésus qu'on appelle le Messie?' Tous répondirent: 'Qu'il soit mis en croix!'"
,"23":"Il demanda: 'Qu'a-t-il fait de mal?' Mais ils ne firent que crier plus fort: 'Qu'il soit mis en croix!'"
,"24":"Pilate voyait qu'il ne gagnait rien et que l'agitation allait en augmentant; il se fit apporter de l'eau et se lava les mains devant la foule en disant: 'Si son sang est versé, moi j'en suis innocent, vous en répondrez!'"
,"25":"Et tout le peuple dit: 'Que son sang retombe sur nous et sur nos enfants!'"
,"26":"Donc Pilate leur libère Barabbas et il fait flageller Jésus avant de le remettre à ceux qui vont le crucifier."
,"27":"Les soldats du gouverneur prennent Jésus avec eux dans la cour de garde, et ils appellent autour de lui tout le bataillon."
,"28":"Ils lui enlèvent ses habits et le couvrent d'un manteau rouge de l'armée,"
,"29":"puis ils tressent avec des épines une couronne qu'ils lui mettent sur la tête, avec un roseau dans la main droite. Ensuite ils se mettent à genoux devant lui et ils le frappent en disant: 'Salut, roi des Juifs!'"
,"30":"Ils lui crachent dessus, prennent le roseau et frappent sur sa tête."
,"31":"Lorsqu'on eut fini de se moquer de lui, on lui enleva le manteau de soldat et on lui remit ses vêtements. Puis on l'emmena pour le crucifier."
,"32":"Juste en sortant, ils trouvèrent un certain Simon, qui était de Cyrène, et ils l'obligèrent à porter sa croix."
,"33":"Ils vinrent ainsi à l'endroit qu'on appelle Golgotha, c'est-à-dire le Crâne."
,"34":"Là ils lui donnèrent à boire du vin mêlé de fiel. Jésus le goûta mais ne voulut pas en boire."
,"35":"Alors ils le mirent en croix, puis ils tirèrent au sort pour se partager ses vêtements"
,"36":"et ils restèrent là assis pour le garder."
,"37":"Au-dessus de sa tête, on avait écrit le motif de sa condamnation: 'C'est Jésus, le roi des Juifs!'"
,"38":"On avait aussi crucifié avec lui deux bandits, l'un à sa droite et l'autre à sa gauche."
,"39":"Ceux qui passaient l'insultaient. Ils hochaient la tête"
,"40":"et disaient: 'C'est toi qui détruis le Temple et le rebâtis en trois jours! Sauve-toi donc, puisque tu es fils de Dieu, descends de ta croix!'"
,"41":"Les chefs des prêtres le ridiculisaient de la même façon, tout comme les maîtres de la Loi et les Anciens. Ils disaient:"
,"42":"'Il a sauvé les autres, mais il ne se sauvera pas lui-même! Voilà bien le roi d'Israël! Qu'il descende maintenant de la croix et nous croirons en lui."
,"43":"Il a mis sa confiance en Dieu, que Dieu maintenant le délivre s'il l'aime. Car il disait: Je suis le fils de Dieu.'"
,"44":"Et de la même façon les bandits crucifiés avec lui l'insultaient."
,"45":"Tout le pays fut dans l'obscurité depuis midi jusqu'au milieu de l'après-midi."
,"46":"On était à la neuvième heure du jour lorsque Jésus s'écria d'une voix forte: 'Eli, Eli, lema sabacthani?'; ce qui veut dire: Mon Dieu, mon Dieu, pourquoi m'as-tu abandonné?'"
,"47":"En l'entendant, plusieurs de ceux qui étaient présents firent cette réflexion: 'Le voici qui appelle Elie!'"
,"48":"L'un d'eux courut prendre une éponge, la trempa dans du vin acidulé et l'attacha à un roseau pour le faire boire."
,"49":"Mais les autres lui disaient: 'Laisse donc, voyons si Elie vient le sauver.'"
,"50":"De nouveau Jésus poussa un grand cri et il rendit l'esprit."
,"51":"Et voici que le voile du sanctuaire se déchire en deux de haut en bas, la terre tremble, les pierres se fendent,"
,"52":"les tombeaux s'ouvrent, et bien des corps se relèvent, des hommes saints qui reposaient en paix."
,"53":"Oui, après sa Résurrection ils sortirent des tombeaux, entrèrent dans la ville sainte et apparurent à plusieurs personnes."
,"54":"A la suite de ce tremblement de terre, le capitaine et les autres qui gardaient Jésus avec lui furent remplis de crainte, voyant tout ce qui arrivait. Ils disaient: 'Vraiment celui-ci était fils de Dieu.'"
,"55":"Un groupe de femmes se trouvait sur place à quelque distance. Elles avaient accompagné Jésus depuis la Galilée pour le servir et elles suivaient tout;"
,"56":"parmi elles se trouvaient Marie de Magdala, Marie mère de Jacques et Joseph, et la mère des fils de Zébédée."
,"57":"Le soir venu, un certain Joseph arriva. C'était un homme riche; il était d'Arimathie et lui aussi disciple de Jésus."
,"58":"Il s'était adressé à Pilate pour lui réclamer le corps de Jésus et Pilate avait donné l'ordre de le lui remettre."
,"59":"Joseph prit le corps et l'enveloppa dans un linceul propre."
,"60":"Il le déposa dans un tombeau neuf qu'il s'était fait creuser dans le roc, et il fit rouler une grosse pierre devant l'entrée de la tombe. Puis il s'en alla."
,"61":"Mais Marie de Magdala et l'autre Marie restaient là assises en face de la tombe."
,"62":"Le lendemain - c'était le jour après la Préparation - les chefs des prêtres et les Pharisiens allèrent ensemble trouver Pilate"
,"63":"pour lui dire: 'Seigneur, nous nous sommes rappelés que ce menteur a dit quand il vivait: Je ressusciterai le troisième jour."
,"64":"Donne donc l'ordre de faire surveiller la tombe jusqu'au troisième jour. Il ne faudrait pas que ses disciples viennent le faire disparaître et disent ensuite au peuple: Il s'est relevé d'entre les morts. Cette seconde fraude serait pire que la première.'"
,"65":"Pilate leur répondit: 'Je vous donne une garde; allez et faites garder comme vous le jugez bon.'"
,"66":"Ils se chargèrent donc de faire garder la tombe avec des scellés sur la pierre et, devant, un piquet de garde."
}`)
	CurrentBook.AddChapter(28, `{
"1":"Après le sabbat, à l'aube du premier jour de la semaine, Marie de Magdala était allée visiter la tombe avec l'autre Marie."
,"2":"Mais voici que la terre tremble. L'ange du Seigneur descend du ciel et s'approche, il fait rouler la pierre, puis il s'assied dessus."
,"3":"Son apparence est celle de l'éclair et son vêtement est blanc comme neige."
,"4":"Il provoque une telle frayeur parmi ceux qui montent la garde, qu'ils restent sous le choc et sont comme morts."
,"5":"Mais l'ange s'adresse aux femmes et leur dit: 'Vous, ne craignez pas! Je sais que vous cherchez Jésus, le crucifié."
,"6":"Mais il n'est pas ici, il est ressuscité comme il l'avait dit. Approchez et voyez l'endroit où on l'avait déposé,"
,"7":"et puis, vite, allez dire à ses disciples qu'il s'est relevé d'entre les morts. Déjà il vous précède en Galilée, et là vous le verrez. C'est là tout mon message.'"
,"8":"Vite elles partirent de la tombe, partagées entre la joie immense et la frayeur, et elles coururent porter la nouvelle à ses disciples."
,"9":"Jésus lui-même vint à leur rencontre et leur dit: 'Jour de joie!' Elles s'approchèrent pour embrasser ses pieds et se prosternèrent devant lui."
,"10":"Alors Jésus leur dit: 'Ne craignez pas. Allez dire à mes frères qu'ils partent en Galilée, là ils me verront.'"
,"11":"Pendant qu'elles y vont, quelques-uns des gardes reviennent à la ville et racontent toute l'affaire aux chefs des prêtres."
,"12":"Alors ils se réunissent avec les Anciens et décident de donner aux soldats une bonne somme d'argent"
,"13":"avec cette consigne: 'Vous direz que ses disciples sont venus de nuit pendant que vous dormiez, et qu'ils ont fait disparaître son corps."
,"14":"Si le gouverneur apprend quelque chose, nous saurons lui parler de façon que vous n'ayez pas d'ennuis.'"
,"15":"Les soldats prirent donc l'argent et firent comme on leur demandait: jusqu'à maintenant on raconte cette histoire chez les Juifs."
,"16":"Les onze disciples allèrent en Galilée, à la montagne que Jésus leur avait indiquée."
,"17":"En le voyant ils se prosternèrent, mais certains gardaient des doutes."
,"18":"Alors Jésus s'approcha et leur dit: 'Tout pouvoir m'a été donné au ciel et sur la terre."
,"19":"Allez donc et faites-moi des disciples de toutes les nations. Vous les baptiserez au nom du Père et du Fils et de l'Esprit Saint, "
,"20":"et vous leur enseignerez, pour qu'ils l'observent, tout ce que je vous ai ordonné. Voici que je suis avec vous tous les jours jusqu'à la fin du temps.'"
}`)

}
func FR_LBDCC_LoadNP1CChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Paul, apôtre de Jésus Christ par décision de Dieu qui l'a appelé, et Sosthène, votre frère, vous envoient cette lettre,"
,"2":"à vous, Eglise de Dieu, qui êtes à Corinthe, à vous qui avez été sanctifiés en Jésus Christ. Car vous avez été appelés à être saints, comme tous ceux qui en tous lieux invoquent le nom de Jésus Christ, leur Seigneur et le nôtre."
,"3":"Recevez grâce et paix de Dieu notre Père et de Jésus Christ, le Seigneur."
,"4":"A tout moment je rends grâces à mon Dieu pour vous et pour la grâce de Dieu qui vous a été donnée dans le Christ Jésus."
,"5":"En lui, vous êtes devenus riches de mille manières: vous avez reçu tous les dons de la parole et de la connaissance,"
,"6":"à mesure que le message du Christ prenait racines chez vous."
,"7":"Aucun don spirituel ne vous fait défaut, et vous n'attendez plus que la manifestation de Jésus Christ, notre Seigneur."
,"8":"Lui-même vous gardera fermes jusqu'au bout, et vous serez sans reproche le jour où se présentera Jésus, notre Seigneur."
,"9":"Dieu est fidèle, lui qui vous a appelés à cette communion avec Jésus, le Christ, notre Seigneur."
,"10":"Frères, je vous en prie au nom de Jésus Christ, notre Seigneur: mettez-vous d'accord au lieu d'être divisés. Soyez unis, ayez un même esprit et la même façon de voir."
,"11":"Si j'en crois les gens de la maison de Chloé, il y a entre vous des rivalités."
,"12":"Je peux parler ainsi puisque certains disent: 'Je suis avec Paul,' et d'autres: 'Je suis avec Apollos,' ou: 'Je suis avec Pierre,' ou: 'Je suis avec le Christ.'"
,"13":"Allez-vous diviser le Christ? Est-ce Paul qui a été crucifié pour vous? Est-ce le baptême de Paul que vous avez reçu?"
,"14":"Je me réjouis de n'avoir baptisé personne d'autre que Crispus et Gaïus,"
,"15":"autrement vous diriez que vous avez reçu mon baptême."
,"16":"Pardon! j'ai encore baptisé la famille de Stéphanas. A part ceux-là, je ne me rappelle aucun autre."
,"17":"D'ailleurs le Christ ne m'a pas envoyé pour baptiser, mais pour proclamer l'Evangile, et cela, sans discours élevés: sinon la croix du Christ perdrait tout son sens."
,"18":"Le langage de la croix est folie pour ceux qui vont à leur perte, mais pour nous qui sommes sauvés, c'est la force de Dieu."
,"19":"L'Ecriture l'a bien dit: 'Je détruirai la sagesse des sages et je réduirai à rien les raisons de ceux qui savent.'"
,"20":"Voilà pour faire taire le sage, et l'homme cultivé, et le théoricien de ce monde! La sagesse de ce monde, Dieu l'a mise au rang des fous, n'est-il pas vrai!"
,"21":"C'est que le monde, avec sa sagesse, n'a pas reconnu Dieu quand il mettait en oeuvre sa sagesse. Il a donc plu à Dieu de sauver des croyants grâce à une folie que nous proclamons."
,"22":"Alors que les Juifs attendent des miracles et les Grecs veulent de la sagesse,"
,"23":"nous proclamons un Messie crucifié. Quel scandale pour les Juifs! Et pour les autres, quelle folie!"
,"24":"Mais pour ceux que Dieu appelle, qu'ils soient Juifs ou Grecs, ce Messie est force de Dieu et sagesse de Dieu."
,"25":"Oui, les folies de Dieu ont plus de sagesse que les hommes, et la faiblesse de Dieu est plus forte que les humains."
,"26":"Voyez un peu, frères, quelle est votre condition: combien d'entre vous passent pour des gens cultivés, ou sont de familles nobles et influentes? Bien peu."
,"27":"Mais Dieu a choisi ce que le monde considère comme ridicule pour ridiculiser les sages, et il a pris ce qui est faible en ce monde pour humilier les forts."
,"28":"Dieu a choisi ce qui est commun et méprisé en ce monde, ce qui ne compte pas, pour réduire à rien tout ce qui compte."
,"29":"Et ainsi, nul mortel ne pourra se vanter devant Dieu."
,"30":"C'est à Dieu que vous devez d'être à présent dans le Christ Jésus, lequel s'est fait notre sagesse, une sagesse de Dieu; et il est nos mérites, notre sainteté, le prix de notre liberté!"
,"31":"Ainsi donc, comme il est écrit, celui qui se sent fier, qu'il soit fier du Seigneur!"
}`)
	CurrentBook.AddChapter(2, `{
"1":"Moi-même, frères, quand je suis allé chez vous pour vous annoncer le mystérieux projet de Dieu, je ne suis pas venu comme un beau parleur ou un intellectuel."
,"2":"Avec vous, je voulais être seulement celui qui connaît Jésus, le Messie, et Messie crucifié."
,"3":"Et pour mon compte je me suis senti faible au milieu de vous, j'avais des craintes et je tremblais quelque peu."
,"4":"Je n'avais pas de grands mots, ni de discours bien arrangés pour vous dire mon message, et pourtant ce fut une démonstration d'Esprit et de puissance."
,"5":"Car il fallait que votre foi s'appuie, non sur la sagesse humaine, mais sur la force de Dieu."
,"6":"Il est vrai que nous parlons sagesse avec les parfaits, mais cette sagesse n'est pas de ce monde et ne vient pas des grands de ce monde, puisqu'ils sont éliminés."
,"7":"Nous enseignons le mystère de la sagesse divine, c'est-à-dire le plan secret que Dieu a formé dès le commencement pour nous mener jusqu'à la gloire."
,"8":"Cette sagesse, aucun des grands de ce monde ne l'a connue. S'ils l'avaient connue, ils n'auraient pas crucifié le Seigneur de la Gloire."
,"9":"Rappelez-vous qu'il est écrit: Des choses que l'oeil n'a pas vues, que pas une oreille n'a entendues, qui ne sont venues à l'esprit de personne; les choses que Dieu a préparées pour ceux qui l'aiment."
,"10":"Mais à nous, Dieu nous l'a révélé par l'Esprit, car l'Esprit explore tout, jusqu'aux profondeurs de Dieu."
,"11":"Voyez: personne ne nous connaît comme notre propre esprit, parce qu'il est en nous. De même, personne ne connaît les choses de Dieu sinon l'Esprit de Dieu."
,"12":"Et ce n'est pas l'esprit du monde que nous avons reçu, mais l'Esprit qui vient de Dieu, de sorte qu'il nous fait connaître ce que nous avons reçu de Dieu."
,"13":"Voilà ce dont nous parlons, non pas en termes convenus de la sagesse humaine, mais avec ceux que nous enseigne l'Esprit, et nous interprétons ce qui est spirituel pour ceux qui sont des spirituels."
,"14":"Celui qui ne connaît que la raison n'accepte pas ce qui vient de l'Esprit de Dieu. Pour lui, ce sont des bêtises, et il ne peut pas les apprécier parce qu'il faut pour cela des critères spirituels."
,"15":"Par contre, celui qui est un spirituel peut juger de tout et personne ne peut le juger. Rappelez-vous cette parole:"
,"16":"Qui connaît la façon de penser du Seigneur, qui lui donnera des conseils? Et justement, nous avons la façon de penser du Christ."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Pourtant, frères, je n'ai pas pu vous parler comme à des spirituels, mais comme à des hommes charnels, comme à des petits enfants dans le Christ."
,"2":"C'est du lait que je vous ai donné, non de la nourriture. Ce n'était pas possible pour vous et ce ne l'est pas encore,"
,"3":"car vous êtes encore charnels. N'y a-t-il pas chez vous des rivalités et de la jalousie? C'est donc que vous êtes charnels et vous vous conduisez comme les gens ordinaires."
,"4":"Tant que vous dites: 'Je suis pour Paul', ou: 'Je suis pour Apollos', n'êtes-vous pas comme tout le monde?"
,"5":"Qu'est-ce que Paul? Qu'est-ce qu'Apollos? Des serviteurs qui ont reçu de Dieu des dons différents, et grâce à eux vous avez cru."
,"6":"Moi j'ai planté, Apollos a arrosé, mais c'est Dieu qui a fait pousser."
,"7":"Celui qui compte, ce n'est pas le semeur ni l'arroseur, mais Dieu qui fait que cela pousse."
,"8":"Le semeur et l'arroseur sont dans la même situation, et chacun d'eux sera payé selon son travail."
,"9":"Nous travaillons avec et pour Dieu, et vous, vous êtes son champ, vous êtes une construction de Dieu."
,"10":"J'ai mis en place les fondations, comme un bon architecte, puisque c'est le talent que j'ai reçu de Dieu, et c'est un autre qui va construire par-dessus. Mais chacun doit se demander comment il construit."
,"11":"On ne peut pas poser une autre pierre de fondation que celle qui est déjà là: Jésus Christ."
,"12":"Mais sur cette fondation on peut construire avec de l'or, de l'argent, des pierres précieuses, ou avec du bois, ou de la paille et des bambous."
,"13":"Un jour on reconnaîtra le travail de chacun. Le jour du jugement le fera voir, quand tout sera éprouvé par le feu. Le feu permettra de voir ce que vaut le travail de chacun."
,"14":"Si ce qu'on a construit résiste, alors on recevra un salaire;"
,"15":"mais si le feu détruit le travail, l'ouvrier paiera le dommage. Il sera sauvé bien sûr, mais non sans passer par le feu."
,"16":"Ne savez-vous pas que vous êtes le temple de Dieu et que l'Esprit de Dieu habite en vous?"
,"17":"Celui qui détruit le temple de Dieu, Dieu le détruira. Le temple de Dieu est saint, et c'est vous."
,"18":"Ne vous trompez pas: celui d'entre vous qui passe pour un sage, au sens ordinaire, qu'il perde la raison pour devenir sage."
,"19":"Car la sagesse de ce monde est folie aux yeux de Dieu; l'Ecriture le dit: Il prend les sages au filet de leurs propres astuces."
,"20":"Et encore: Le Seigneur connaît les arguments des sages et sait qu'ils ne valent rien."
,"21":"Donc, ne vous vantez jamais de vos grands hommes. Pensez que tout est pour vous,"
,"22":"que ce soit Paul, Apollos ou Pierre, que ce soit le monde, la vie, la mort, le présent ou le futur: tout est à vous."
,"23":"Mais vous, vous êtes au Christ, et le Christ est à Dieu."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Qu'on nous regarde comme des serviteurs du Christ et des administrateurs des mystères de Dieu."
,"2":"Et, bien entendu, on exigera d'un administrateur qu'il fasse son travail."
,"3":"Mais, de mon côté, ce n'est pas votre jugement sur moi qui me préoccupe, ou celui d'une autorité humaine. Je ne veux même pas me juger moi-même."
,"4":"Bien que je n'aie rien à me reprocher, ce n'est pas assez pour me justifier: mon juge, c'est le Seigneur."
,"5":"Aussi bien, ne jugez pas d'avance, attendez que vienne le Seigneur: lui mettra en lumière ce que cachaient les ténèbres, et révélera les intentions des coeurs. Alors chacun recevra de Dieu ses éloges."
,"6":"Frères, j'ai pris ces comparaisons pour vous parler de moi et d'Apollos. Apprenez à ne pas vous servir de l'un ou l'autre de nous pour vous enfler vous-mêmes."
,"7":"Faut-il qu'on te remarque? Qu'as-tu que tu n'aies reçu? Et si tu l'as reçu, pourquoi te vanter comme si cela venait de toi?"
,"8":"Mais voilà, vous êtes riches et repus, vous êtes des rois loin de nous! Si seulement vous étiez des rois! Nous pourrions partager avec vous."
,"9":"Car il me semble que nous, les apôtres, Dieu nous a mis à la dernière place comme des condamnés à mort. Nous sommes un beau spectacle, pour le monde, pour les anges et pour les hommes."
,"10":"Nous sommes les fous du Christ alors que vous, vous avez la sagesse chrétienne. Nous sommes faibles et vous êtes forts, vous êtes des gens bien et nous sommes méprisables."
,"11":"Jusqu'à ce jour, nous avons faim et soif et nous souffrons du froid; on nous gifle et on nous envoie ailleurs;"
,"12":"et nous nous fatiguons à travailler avec nos mains. On nous insulte quand nous bénissons, on nous persé cute et nous supportons."
,"13":"Nous sommes diffamés, mais nous réconfortons les autres. Nous voilà devenus les balayures du monde, et les gens peuvent nous mettre au fumier."
,"14":"Tout cela, je ne l'écris pas pour vous faire honte, mais pour vous corriger comme des enfants bien-aimés."
,"15":"Car même si beaucoup de gens peuvent vous mener au Christ, vous n'avez pas plusieurs pères. Et c'est moi qui vous ai donné la vie dans le Christ Jésus, grâce à l'Evan gile."
,"16":"C'est pourquoi je vous dis: suivez mon exemple."
,"17":"Et c'est la raison pour laquelle je vous envoie Timothée, mon fils bien-aimé et digne de confiance dans le Seigneur. Il vous rappellera mes règles de vie chrétienne telles que je les enseigne en tous lieux dans toutes les Eglises."
,"18":"Certaines personnes se sont monté la tête en pensant que je ne viendrais pas."
,"19":"Mais je serai bientôt chez vous, si le Seigneur le veut, et je verrai non pas leurs belles paroles, mais de quoi ils sont capables."
,"20":"Car le Royaume de Dieu n'est pas une affaire de discours mais de puissance."
,"21":"Que préférez-vous? Que j'arrive chez vous avec la baguette, ou bien avec l'amour et l'esprit de douceur?"
}`)
	CurrentBook.AddChapter(5, `{
"1":"Vous faites surtout parler de vous par une affaire de moeurs, une affaire de moeurs comme on n'en trouve pas, même chez les païens: quelqu'un vit avec la femme de son père."
,"2":"Et vous êtes fiers! Vous feriez mieux de prendre le deuil et d'expulser celui qui a fait cela."
,"3":"Sachez donc que j'ai jugé le coupable comme si j'étais présent - car je suis absent de corps mais présent par l'esprit."
,"4":"Vous allez vous réunir, vous et mon esprit, au nom de Jésus notre Seigneur et avec sa puissance;"
,"5":"et vous allez le livrer à Satan pour que tous les fléaux tombent sur lui, mais que son esprit soit sauvé au jour du Seigneur."
,"6":"Vous pouvez vous vanter! Ne savez-vous pas qu'un peu de levain fait lever toute la pâte?"
,"7":"Dehors le vieux levain, purifiez-vous! Et soyez une pâte neuve, car le Christ est notre victime pascale et vous êtes le pain sans levain!"
,"8":"Donc plus de vieux levain, levain du mal et du vice, mais célébrez la fête avec le pain sans levain, c'est-à-dire la pureté et la vérité."
,"9":"Dans ma lettre je vous ai dit de ne pas fréquenter les gens de mauvaise conduite."
,"10":"Je ne parlais pas des non-chrétiens qui pratiquent la liberté sexuelle, ou qui veulent avoir toujours plus, ou qui profitent des autres ou qui adorent les idoles. Sinon vous devriez sortir de ce monde."
,"11":"Je vous disais de ne plus fréquenter celui qui porte le nom de frère mais qui de fait pratique la liberté sexuelle, ou qui veut en avoir toujours plus, ou qui est un calomniateur, ou un buveur ou qui profite des autres. Ne mangez même pas avec lui."
,"12":"Je n'ai pas à juger ceux du dehors, mais ceux qui sont à l'intérieur, n'est-ce pas à vous de les juger?"
,"13":"Ceux du dehors, Dieu les jugera, mais vous, enlevez le mauvais d'au milieu de vous."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Si l'un d'entre vous a un différend avec un autre croyant, comment ose-t-il aller en justice devant des païens et non devant les saints?"
,"2":"Ou bien ignorez-vous que nous, les saints, nous jugerons le monde? Si donc vous êtes appelés à juger le monde, comment n'auriez-vous pas autorité pour juger des choses si minimes?"
,"3":"Ne savez-vous pas que nous jugerons les anges? A plus forte raison les affaires quotidiennes!"
,"4":"Vous devriez renvoyer ce genre d'affaires aux tout derniers de la communauté!"
,"5":"Je le dis à votre honte: c'est à croire qu'il n'y a personne parmi vous qui soit de bon conseil et puisse servir d'arbitre entre ses frères!"
,"6":"Et c'est ainsi qu'on se traîne en justice entre frères, et cela devant des non-croyants!"
,"7":"De toute façon, c'est déjà un échec que d'avoir des procès entre vous. Pourquoi ne pas souffrir plutôt l'injustice? Pourquoi ne pas vous laisser plutôt déposséder?"
,"8":"Mais non, c'est vous qui commettez l'injustice et qui faites du tort, et c'est à des frères que vous le faites."
,"9":"Ignorez-vous que les injustes n'hériteront pas du Royaume de Dieu? Ne vous égarez pas: Ceux qui pratiquent la liberté sexuelle ou adorent les idoles, les adultères, les jouisseurs, ceux qui pratiquent l'homosexualité,"
,"10":"les voleurs, ceux qui n'en ont jamais assez, les buveurs, les calomniateurs et ceux qui profitent des autres n'hériteront pas du Royaume de Dieu."
,"11":"C'était le cas de plusieurs d'entre vous; mais vous avez été lavés, vous avez été sanctifiés, vous êtes devenus des justes grâce au Nom du Seigneur Jésus Christ et à l'Esprit de notre Dieu."
,"12":"Tout m'est permis, mais tout n'est pas bon pour moi. Tout m'est permis, mais je ne veux rien qui me rende esclave."
,"13":"Les aliments sont pour l'estomac et l'estomac pour les aliments, et Dieu détruira l'un comme l'autre. Par contre le corps n'est pas pour le sexe, mais pour le Seigneur, et le Seigneur est pour le corps."
,"14":"Dieu a ressuscité le Seigneur et, par sa puissance, Il nous ressuscitera aussi."
,"15":"Ne savez-vous pas que vos corps sont les membres du Christ? Alors, puis-je prendre au Christ ses membres et en faire les membres d'une prostituée? Tout sauf cela!"
,"16":"Ne savez-vous donc pas que dans cette union on devient, avec la prostituée, un seul corps? L'Ecriture dit: Les deux seront une seule chair."
,"17":"Par contre, celui qui s'unit au Seigneur devient un seul esprit avec Lui."
,"18":"Fuyez les relations défendues. Tout autre péché qu'on peut faire reste extérieur au corps. Mais avec les relations sexuelles on pèche contre son propre corps."
,"19":"Ne le savez-vous pas: votre corps est un temple de l'Esprit Saint, qui est en vous, venu de Dieu, et vous ne vous appartenez pas."
,"20":"Vous avez été achetés si cher! Glorifiez donc Dieu dans votre corps."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Vous m'écrivez plusieurs choses, et je réponds. C'est très bien de ne pas toucher une femme."
,"2":"Mais l'appel du sexe est là; donc, que chacun prenne femme et que chacune ait son mari."
,"3":"Le mari doit rendre à sa femme ce qu'il lui doit, et la femme fera de même avec son mari."
,"4":"La femme ne dispose pas de son propre corps, mais son mari. De même pour le mari: son corps est à la disposition de sa femme."
,"5":"Ne vous privez pas l'un de l'autre, sauf si c'est d'un commun accord et pour un certain temps, pour mieux vous donner à la prière. Et de nouveau vous aurez des relations; autrement Satan pourrait vous faire tomber parce que vous dominez mal vos instincts."
,"6":"Je vous donne cela comme un conseil: ce n'est pas un ordre."
,"7":"J'aimerais bien que tous soient comme moi, mais chacun a reçu de Dieu son propre don, l'un d'une façon, l'autre d'une autre."
,"8":"Pour cela je dis à ceux qui ne sont pas mariés et aux veuves que ce serait bien de rester comme je suis."
,"9":"Mais s'ils ne sont pas maîtres d'eux-mêmes, qu'ils se marient. Il vaut mieux se marier que rester dans le feu."
,"10":"A ceux qui sont mariés je donne cet ordre - non pas de moi, mais du Seigneur: que la femme ne se sépare pas de son mari."
,"11":"Si elle s'est séparée de son mari, qu'elle reste seule, ou qu'elle se réconcilie avec son mari. Et de même pour le mari: qu'il ne renvoie pas sa femme."
,"12":"Aux autres je dis, moi, pas le Seigneur: si un frère a une femme qui n'est pas croyante mais qui se trouve bien avec lui, qu'il ne la laisse pas."
,"13":"Et de même pour la femme dont le mari n'est pas croyant: s'il se trouve bien avec elle, qu'elle ne laisse pas son mari."
,"14":"Car le mari qui n'est pas croyant est sanctifié à travers sa femme, et celui qui est frère sanctifie sa femme qui n'est pas croyante. Autrement vos enfants aussi ne seraient pas purs, alors que, de fait ils sont déjà sanctifiés."
,"15":"Si celui qui n'est pas croyant veut se séparer, qu'il se sépare. Le frère ou la soeur mariés avec eux ne sont pas liés dans ce cas, car Dieu nous a appelés à vivre dans la paix."
,"16":"Tu as beau être sa femme, es-tu sûre que tu sauveras ton mari? Et si tu es le mari, es-tu sûr que tu sauveras ta femme?"
,"17":"En dehors de ce cas, que chacun vive dans la condition que le Seigneur lui a attribuée, où il était quand Dieu l'a appelé. C'est la règle que je donne dans toutes les églises."
,"18":"Etais-tu circoncis quand Dieu t'a appelé? Ne te fais pas faire une greffe. Et si Dieu appelle un non-Juif, qu'il ne se fasse pas circoncire."
,"19":"Ce qui importe n'est pas la circoncision et pas davantage de ne pas l'avoir, mais de garder les commandements de Dieu."
,"20":"Que chacun demeure donc dans l'état où il a été appelé."
,"21":"L'appel de Dieu t'a trouvé esclave? Ne te préoccupe pas. Mais si tu peux te libérer, profite de l'occasion."
,"22":"Sache que l'esclave appelé à la vie chrétienne devient libre associé du Seigneur. Et l'homme libre qui est appelé, devient aussi bien un esclave du Christ."
,"23":"Vous avez été achetés très cher: ne vous rendez pas esclaves d'autres hommes."
,"24":"Donc, frères, que chacun continue de vivre pour Dieu dans la condition où il a reçu son appel."
,"25":"Vous me parlez des vierges; je n'ai pas d'ordre du Christ, mais mes avis sont ceux d'un homme à qui le Seigneur a bien voulu faire confiance."
,"26":"Je pense que c'est une belle décision. Vu les difficultés actuelles, je pense que c'est bien de vivre ainsi. "
,"27":"Es-tu engagé avec une femme? C'est bien. Es-tu sans engagement? Ne cherche pas de femme."
,"28":"Tu ne fais pas mal si tu te maries, et de même la fille qui se marie: elle ne fait pas de péché. Mais ceux qui se marient auront bien des épreuves sur le plan humain et je voudrais vous les épargner."
,"29":"Je m'explique, frères. Le temps s'est raccourci. De toutes façons, ceux qui ont pris femme doivent vivre comme s'ils n'en avaient pas,"
,"30":"ceux qui pleurent comme s'ils ne pleuraient pas, ceux qui sont heureux, comme s'ils ne l'étaient pas, ceux qui achètent, comme s'ils ne possédaient pas,"
,"31":"et ceux qui jouissent de la vie présente, comme s'ils n'en jouissaient pas. Car les situations de ce monde sont en train de passer."
,"32":"J'aimerais que vous n'ayez pas de soucis. Celui qui n'est pas marié est tout occupé du Seigneur et il veut lui plaire."
,"33":"Par contre celui qui est marié est tout occupé de choses de ce monde, cherchant comment plaire à sa femme. Et il est divisé."
,"34":"La femme qui reste vierge ou qui vit seule est tout occupée du Christ et s'efforce d'être sainte de corps et d'esprit. Par contre la femme mariée est toute occupée de choses de ce monde: elle doit plaire à son mari."
,"35":"Je vous dis cela, non pour vous tendre un piège, mais pour votre bien, en vue d'une vie plus noble où vous serez totalement unis au Seigneur."
,"36":"Quelqu'un peut se sentir gêné vis-à-vis de sa fiancée qui est encore vierge et prend de l'âge. S'il pense que c'est la bonne solution, qu'il fasse pour le mieux: il ne pèche pas. Qu'ils se marient."
,"37":"Mais il se peut qu'un autre reste ferme: il se sent très libre et maître de sa propre décision, et il décide de la laisser vierge. S'il le fait, il agira très bien."
,"38":"Donc celui qui épouse cette fille qu'il avait gardée vierge agit bien, et celui qui ne l'épouse pas fait mieux encore."
,"39":"La femme est liée tout le temps que vit son mari. Quand le mari est mort, elle peut se remarier avec qui elle veut, pourvu que ce soit un mariage chrétien."
,"40":"Mais elle sera plus heureuse si elle reste seule comme je le conseille, et je crois avoir moi aussi l'Esprit de Dieu."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Parlons des viandes consacrées aux idoles. Bien sûr, tous nous avons la connaissance. Mais la connaissance nous enfle, pendant que l'amour construit."
,"2":"Celui qui croit savoir (quelque chose), il ne sait pas encore ce que doit être la connaissance."
,"3":"Par contre, si quelqu'un aime (Dieu), celui-là est connu de Dieu."
,"4":"Peut-on manger les viandes consacrées aux idoles? Nous savons que l'idole n'est rien dans la réalité et qu'il n'y a pas d'autre Dieu que l'Unique."
,"5":"Bien sûr, on parle de dieux aussi bien dans les cieux que sur la terre et cela fait beaucoup de dieux et beaucoup de seigneurs."
,"6":"Mais pour nous il n'y a qu'un seul Dieu, le Père; tout vient de lui et nous allons vers lui. Et il n'y a qu'un seul Seigneur, Jésus, le Christ: tout dépend de lui et nous dépendons de lui."
,"7":"Mais tous n'ont pas la connaissance; pour certains qui étaient habitués aux idoles, c'est là manger une viande consacrée à l'idole, et leur conscience mal formée en est souillée."
,"8":"Après tout, ce n'est pas notre régime qui nous fait plaire à Dieu. Si nous n'en mangeons pas, nous ne perdons rien, et ce n'est pas d'en manger qui nous donnera grand-chose."
,"9":"Donc, avec vos droits, évitez de causer du tort à ceux qui sont mal assurés."
,"10":"Si l'un d'eux te voit, toi qui as la connaissance, installé dans le salon du temple, sa conscience non libérée en est influencée, et lui aussi mangera ce qui est consacré à l'idole."
,"11":"Et voilà que ce faible, ce frère pour qui le Christ est mort, se perd grâce à ton savoir."
,"12":"Quand vous blessez ainsi les consciences non libérées et péchez contre vos frères, vous péchez contre le Christ."
,"13":"Donc si quelque aliment entraîne au mal un de mes frères, je ne veux plus jamais manger de viande plutôt que de faire chuter mon frère."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Moi-même, ne suis-je pas un homme libre? Ne suis-je pas un apôtre, n'ai-je pas vu Jésus, notre Seigneur, et n'êtes-vous pas le fruit de mon travail dans le Christ?"
,"2":"Si pour d'autres je ne suis pas apôtre, pour vous je le suis et vous êtes dans le Christ le certificat de ma mission d'apôtre."
,"3":"Or écoutez comment je réponds à ceux qui me mettent en question:"
,"4":"N'avons-nous pas droit à ce qu'on nous donne à manger et à boire?"
,"5":"N'avons-nous pas le droit de nous faire accompagner par une femme, une soeur, comme font les autres apôtres et les frères du Seigneur, et Pierre lui-même?"
,"6":"Sommes-nous les seuls, moi et Barnabé, à qui on refuse le droit de ne pas travailler?"
,"7":"Avez-vous vu un soldat qui s'engage à ses propres frais, ou un planteur qui ne mange pas des fruits de sa vigne, ou un berger qui se prive du lait de son troupeau?"
,"8":"Tout cela n'est pas seulement sagesse humaine, car la Loi dit la même chose."
,"9":"Il est écrit: N'empêche pas le boeuf de toucher au grain qu'il bat. Croyez-vous que Dieu s'inquiète pour les boeufs?"
,"10":"Non, tout cela vaut pour nous. Il s'agit de nous là où il est écrit que celui qui travaille en attend quelque chose et celui qui bat le grain compte en avoir sa part. "
,"11":"Et si nous avons semé chez vous des richesses spirituelles, ne pouvons-nous pas récolter chez vous quelques avantages de ce monde?"
,"12":"D'autres ont reçu leur part de ce que vous aviez; n'avions-nous pas de meilleures raisons qu'eux? Mais voilà: nous n'avons pas fait usage de ce droit et nous supportons tout plutôt que de mettre un obstacle à l'Evangile du Christ."
,"13":"Ne savez-vous pas que ceux qui préparent les choses saintes reçoivent du Temple leur nourriture? Ceux qui servent à l'autel ont leur part de ce qui est sur l'autel."
,"14":"Et de même le Seigneur a ordonné que ceux qui annoncent l'Evangile vivent de l'Evangile."
,"15":"Mais moi, je n'ai fait aucun usage de tout cela, et si je vous l'écris ce n'est pas pour en bénéficier: j'aimerais mieux mourir... Personne ne m'enlèvera ce titre de gloire. "
,"16":"Car si j'annonce l'Evangile, je ne peux pas m'en vanter: je le fais par contrainte, et malheur à moi si je n'annonçais pas l'Evangile."
,"17":"Si je le faisais librement, j'aurais une récompense, mais on m'a donné cette charge malgré moi."
,"18":"Alors, comment mériter une récompense? Je donnerai l'Evangile gratuitement, sans faire usage des droits que me donne l'Evangile."
,"19":"De même j'étais libre vis-à-vis de tous, mais je me suis fait l'esclave de tous pour gagner cette multitude."
,"20":"Je me suis fait Juif avec les Juifs afin de gagner les Juifs. Ils observent la Loi? Moi aussi j'observe la Loi, bien que je n'y sois pas tenu, parce que je veux gagner ceux qui observent la Loi."
,"21":"Avec ceux qui n'ont pas la Loi, je suis celui qui n'observe pas la Loi (en réalité je ne suis pas sans loi vis-à-vis de Dieu: ma loi, c'est le Christ). Mais je veux gagner ceux qui n'ont pas la Loi."
,"22":"Et pour gagner ceux dont la conscience n'est pas assurée, je me fais faible parmi les faibles. Je me suis fait tout à tous de façon à en sauver pour le moins quelques uns."
,"23":"Et tout cela je le fais pour l'Evangile, parce que moi aussi je veux en avoir ma part."
,"24":"Vous savez bien qu'au stade il y a beaucoup de coureurs au départ, et un seul reçoit le prix. Courez donc de façon à gagner."
,"25":"Les concurrents s'imposent une dure discipline, et c'est pour une couronne vite fanée, alors que la nôtre ne se fanera pas."
,"26":"Je ne veux donc pas courir sans préparation ni donner des coups dans le vide."
,"27":"Aussi vais-je traiter durement mon corps et le tenir en laisse, car je ne voudrais pas être éliminé après avoir prêché aux autres."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Frères, je dois vous rappeler l'exemple de nos pères: tous ont passé sous la nuée et tous ont traversé la mer."
,"2":"Tous ont reçu ce baptême de la nuée et de la mer qui les donnait à Moïse."
,"3":"Tous ont mangé du même aliment spirituel,"
,"4":"et tous ont bu de la même boisson spirituelle: leur eau jaillissait d'un rocher spirituel qui les accompagnait, et ce rocher était le Christ."
,"5":"Et pourtant la plupart d'entre eux n'ont pas plu à Dieu: et leurs corps sont restés dans le désert."
,"6":"Tout ce qui s'est passé là était déjà notre histoire, et nous devons nous garder des mauvais désirs qu'ils ont eus."
,"7":"Ne soyez pas des adorateurs d'idoles, comme certains d'entre eux, et l'Ecriture dit: Le peuple s'assit pour manger et pour boire, après quoi ils firent la fête."
,"8":"Pas de prostitution: beaucoup d'entre eux y ont cédé et il en est mort vingt-trois mille en un seul jour."
,"9":"Ne mettez pas le Seigneur à l'épreuve: beaucoup d'entre eux l'ont mis à l'épreuve et ils sont morts piqués par les serpents."
,"10":"Ne vous plaignez pas par derrière; beaucoup d'entre eux murmuraient ainsi et l'Exterminateur les a fait périr."
,"11":"Tout ce qu'ils ont vécu là avait valeur d'exemple, et cela a été écrit pour mettre en garde ceux qui devaient connaître les derniers temps, c'est-à-dire nous."
,"12":"Donc, que celui qui pense être debout prenne garde de ne pas tomber."
,"13":"De fait, vous n'avez connu que des épreuves très ordinaires. Dieu est fidèle et ne permettra pas que vous soyez tentés au-delà de vos forces; il vous enverra en même temps que l'épreuve la force pour la supporter."
,"14":"Donc, mes bien-aimés, fuyez l'idolâtrie."
,"15":"Je vous parle comme à des gens qui réfléchissent: pensez à ce que je vais dire."
,"16":"Le calice de bénédiction que nous bénissons, n'est-ce pas une communion au sang du Seigneur? Et le pain que nous partageons, n'est-ce pas une communion au corps du Christ?"
,"17":"Nous sommes plusieurs, mais nous devenons un seul corps, car il n'y a qu'un seul pain et tous nous participons du même pain."
,"18":"Pensez à Israël, au peuple qui porte ce nom: quand ils mangent les victimes sacrifiées, ils entrent en communion avec l'autel, n'est-il pas vrai?"
,"19":"Je ne dis pas que les viandes des idoles sont réellement consacrées ou que l'idole existe réellement."
,"20":"Mais les sacrifices des païens vont aux démons et non pas à Dieu, et je ne veux pas que vous entriez en communion avec les démons."
,"21":"Vous ne pouvez pas boire à la fois le calice du Seigneur et le calice des démons. Vous ne pouvez pas en même temps prendre part à la table du Seigneur et à la table des démons."
,"22":"Ou bien voulons-nous défier le Seigneur? Serions-nous plus forts que lui?"
,"23":"Tout est permis, mais tout n'est pas bon pour moi. Tout est permis, mais tout ne fait pas du bien:"
,"24":"que chacun pense, non pas à soi, mais aux autres."
,"25":"Donc, tout ce qu'on vend au marché, mangez-en sans vous faire des scrupules de conscience,"
,"26":"Car la terre appartient au Seigneur avec tout ce qui la recouvre."
,"27":"Et si un non-croyant vous invite, et que vous désiriez aller chez lui, mangez ce qu'on vous présente et n'ayez pas de scrupules de conscience."
,"28":"Mais si on vous dit: C'est de la viande consacrée! n'en prenez pas. Pensez à celui qui vous a avertis, et respectez sa conscience."
,"29":"Je dis bien: la conscience de l'autre, non la vôtre. Mais faut-il que je fasse usage de ma liberté, si cela doit être critiqué par une autre conscience?"
,"30":"Est-il bon que je fasse usage de ce don de Dieu et lui en rende grâce, si cela doit être mal interprété?"
,"31":"Donc, que vous mangiez ou que vous buviez ou que vous fassiez quoi que ce soit, faites que tout soit pour la gloire de Dieu."
,"32":"Ne scandalisez, ni les Juifs, ni les Grecs, ni l'Eglise de Dieu."
,"33":"Faites comme moi: je ne cherche pas mon propre intérêt mais celui des autres, c'est-à-dire leur salut, et je tâche de plaire à tous."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Suivez mon exemple comme je suis celui du Christ."
,"2":"Je vous félicite parce que vous m'êtes fidèles en tout et vous gardez les traditions que je vous ai transmises."
,"3":"Pourtant j'aimerais vous rappeler que pour tout homme le Christ est la tête, tandis que pour la femme, c'est l'homme qui est la tête - et pour le Christ, Dieu est la tête."
,"4":"Quand l'homme prie ou prophétise avec la tête couverte, il déshonore sa tête."
,"5":"Mais quand la femme prie ou prophétise sans se couvrir la tête, elle déshonore sa tête: ce n'est pas mieux que de se faire tondre."
,"6":"Elle ne veut pas se couvrir la tête: qu'elle aille donc se faire tondre! Quelle femme n'aurait honte d'aller les cheveux coupés ou rasés? Alors, qu'elle se couvre la tête."
,"7":"L'homme n'a pas à se couvrir la tête, car il est l'image et la gloire de Dieu; la femme, par contre, est la gloire de l'homme."
,"8":"Car c'est la femme qui vient de l'homme, non l'homme de la femme,"
,"9":"et l'homme n'a pas été créé pour la femme mais la femme pour l'homme."
,"10":"C'est pourquoi la femme doit garder sur sa tête un signe de sa dépendance; sinon, que penseraient les anges?"
,"11":"C'est vrai que, dans le Seigneur, la femme n'existe pas sans l'homme, et l'homme n'existe pas sans la femme,"
,"12":"et si la femme a été tirée de l'homme, l'homme aussi vient de la femme, et tout vient de Dieu."
,"13":"Pensez-y vous-mêmes. Est-ce vraiment convenable quand une femme prie Dieu avec la tête découverte?"
,"14":"L'ordre naturel vous enseigne que c'est une honte pour un homme de porter une coiffure efféminée."
,"15":"Une femme, par contre, est fière de sa coiffure: sa coiffure lui tient lieu de voile."
,"16":"Mais maintenant, si quelqu'un aime discuter, qu'il sache que nous n'acceptons pas cette coutume, et pas davantage les Eglises de Dieu."
,"17":"Et puisque je suis en train de faire des reproches, je ne vous félicite pas pour vos rencontres qui vous font plus de mal que de bien."
,"18":"Tout d'abord on me dit que lorsque vous vous réunissez en Eglise vous êtes divisés, et je le crois en partie."
,"19":"Il faudra qu'un jour on voie chez vous différents partis, et alors on saura sur qui on peut compter chez vous."
,"20":"Donc, quand vous vous réunissez et mangez, cela n'est guère un repas du Seigneur."
,"21":"Chacun prend les devants pour manger son propre repas; l'un s'enivre et l'autre reste sur sa faim."
,"22":"Vous avez vos maisons: ne pouvez-vous pas manger et boire chez vous? Ou vous moquez-vous de l'Eglise de Dieu et voulez-vous insulter ceux qui n'ont rien? Que puis-je vous dire? Vous féliciter? Pour cela sûrement pas."
,"23":"Je vous ai moi-même transmis ce que j'avais reçu et qui venait du Seigneur: la nuit où il était livré, le Seigneur Jésus prit du pain,"
,"24":"rendit grâce et le partagea en disant: 'Ceci est mon corps donné pour vous, faites ceci en mémoire de moi.'"
,"25":"De même pour le calice après le repas; il dit: 'Ce calice est la nouvelle alliance grâce à mon sang. Toutes les fois que vous la boirez, vous le ferez en mémoire de moi.'"
,"26":"Voyez donc: toutes les fois que vous mangez ce pain et buvez ce calice, vous proclamez la mort du Seigneur jusqu'à ce qu'il vienne."
,"27":"Si quelqu'un manque de respect quand il mange le pain ou boit le calice du Seigneur, il pèche contre le corps et le sang du Seigneur."
,"28":"Que chacun donc fasse son examen avant de manger le pain et boire le calice."
,"29":"Car s'il ne reconnaît pas le corps, il mange et boit sa propre condamnation."
,"30":"C'est d'ailleurs la raison pour laquelle plusieurs d'entre vous sont en mauvaise santé ou sont malades, et quelques-uns sont morts."
,"31":"Si nous faisions notre propre examen, nous ne serions pas jugés."
,"32":"Mais le Seigneur nous juge et nous corrige pour que nous ne soyons pas condamnés avec ce monde."
,"33":"Donc, frères, quand vous vous réunissez pour prendre le repas, attendez-vous les uns les autres."
,"34":"Celui qui est affamé peut manger chez lui; mais ne vous réunissez pas pour vous mettre en mauvaise situation. Tout le reste, j'y mettrai ordre quand je viendrai."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Maintenant, frères, je veux vous parler des dons spirituels."
,"2":"Rappelez-vous le temps où vous étiez païens. Vous perdiez tout contrôle de vous-mêmes quand on vous menait à vos idoles sans vie ni voix."
,"3":"Alors je vous dis: on ne peut pas crier: 'Maudit soit le Christ!' quand c'est un esprit de Dieu. Et de même il faut un esprit saint pour dire: 'Jésus est le Seigneur.'"
,"4":"Il y a différents charismes, mais c'est le même Esprit."
,"5":"Il y a différents services, mais le Seigneur est le même."
,"6":"Il y a différents pouvoirs, mais c'est le même Dieu qui fait tout en tous."
,"7":"Chacun reçoit quelque chose qui sert, et c'est une manifestation de l'Esprit."
,"8":"L'un reçoit de l'Esprit une parole de sagesse; chez l'autre c'est une parole de connaissance selon le même Esprit;"
,"9":"un autre a dans le même Esprit la foi; un autre reçoit les charismes de guérison, dans le même Esprit;"
,"10":"un autre reçoit le pouvoir des miracles, un autre reçoit la prophétie, un autre sait reconnaître les esprits, un autre a quelque don de langues, un autre interprète ces langues."
,"11":"Mais c'est le même et unique Esprit qui répartit les dons propres à chacun, et il donne ce qu'il veut."
,"12":"Les membres sont nombreux mais il n'y a qu'un seul corps, et quel que soit leur nombre, les membres du corps sont un seul corps. De même le Christ."
,"13":"Que vous soyez Juifs ou Grecs, esclaves ou hommes libres, l'Esprit qui est un a fait de nous un seul corps au moment du baptême. Et tous nous avons bu de l'Esprit qui est un."
,"14":"Pour qu'il y ait un corps, il ne suffit pas d'un membre, il en faut plusieurs."
,"15":"Imaginez que le pied dise: 'Je ne fais pas partie du corps puisque je ne suis pas la main.' Cela ne l'empêche pas de faire partie du corps."
,"16":"Imaginez que l'oreille dise: 'Je ne fais pas partie du corps, vu que je ne suis pas l'oeil.' Cela ne l'empêche pas de faire partie du corps."
,"17":"Si tout le corps était oeil, comment pourrait-on entendre? Et s'il était tout entier oreille, où serait l'odorat?"
,"18":"Mais Dieu a fait plusieurs membres et il a placé chacun d'eux dans le corps, là où il lui semblait bon."
,"19":"Si tous étaient le même membre, où serait le corps?"
,"20":"Il y a donc divers membres, mais le corps est un seul."
,"21":"L'oeil ne peut pas dire à la main: 'Je n'ai pas besoin de toi,' ni la tête dire aux pieds: 'Je n'ai pas besoin de vous.'"
,"22":"Bien plus, les organes du corps qui paraissent les plus faibles sont les plus nécessaires,"
,"23":"et s'il y en a qui sont moins présentables, nous les traitons avec davantage de respect; nous habillons mieux ceux qui sont moins présentables, car ceux qui se présentent mieux n'en ont pas besoin."
,"24":"Quand Dieu a modelé le corps, il a pris soin davantage de ceux qui sont les derniers,"
,"25":"pour empêcher que le corps se divise. Tous les membres doivent pareillement se préoccuper les uns des autres."
,"26":"Si l'un des membres souffre, tous souffrent avec lui. Si l'un des membres est mis à l'honneur, tous se réjouissent avec lui."
,"27":"Vous êtes le corps du Christ et chacun est membre à sa place."
,"28":"En premier, ceux que Dieu a fait apôtres dans son Eglise. A la deuxième place les prophètes. A la troisième, les maîtres. Ensuite viennent le pouvoir des miracles, puis les charismes de guérison, l'aide mutuelle, la capacité de gouverner et les différents genres de langues."
,"29":"Tous sont-ils apôtres? Tous sont-ils prophètes et maîtres? Est-ce que tous peuvent faire des miracles,"
,"30":"ou guérir, ou parler en langues, ou interpréter ce qui est dit?"
,"31":"Pourtant vous devez ambitionner les charismes les plus élevés, et même je voudrais vous montrer le chemin par excellence."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Je peux bien parler les langues des hommes, et aussi celles des anges, si je n'ai pas l'amour, je suis comme la trompette ou la cymbale: du bruit et rien de plus."
,"2":"Je peux prophétiser et découvrir tous les mystères et le plus haut savoir; je peux avoir la foi parfaite jusqu'à transporter les montagnes; si je n'ai pas l'amour je ne suis rien."
,"3":"Et si je donne tout ce que j'ai, si je me sacrifie moi-même, mais pour en tirer gloire et sans avoir l'amour, cela ne me sert de rien."
,"4":"L'amour sait attendre, l'amour est compréhensif et il n'est pas jaloux. L'amour ne s'enfle pas, il ne se fait pas valoir;"
,"5":"il n'a rien que de noble et ne cherche pas son intérêt. Il ne se met pas en colère, et il oublie le mal."
,"6":"Il ne se réjouit jamais de ce qui est injuste et prend plaisir à la vérité."
,"7":"Il résiste à tout, il croit tout, espère tout et supporte tout."
,"8":"L'amour ne passera pas, tandis que les prophéties auront un terme, et les langues cesseront, et le plus haut savoir sera oublié."
,"9":"Car le savoir est partiel et la prophétie ne dit pas tout."
,"10":"Quand viendra ce qui est parfait, tout ce qui est partiel sera éliminé."
,"11":"Quand j'étais enfant, je parlais comme les petits enfants, je jugeais et je raisonnais comme les petits enfants. Mais quand je suis devenu adulte, j'ai abandonné toutes les choses de l'enfant."
,"12":"Aujourd'hui nous voyons les choses comme dans un mauvais miroir, et il faut les deviner. Mais un jour je verrai face à face. Aujourd'hui je connais en partie, mais un jour je connaîtrai comme je suis connu."
,"13":"Pour l'instant, donc, ce qui vaut c'est la foi, l'espérance et l'amour. Mais le plus grand des trois est l'amour."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Poursuivez l'amour et ambitionnez les dons spirituels, la prophétie avant tout."
,"2":"Celui qui parle dans une langue, parle à Dieu mais non aux hommes. Personne ne le comprend quand il dit en esprit des choses mystérieuses."
,"3":"Par contre, quand on prophétise, on affermit les autres, on les encourage et on les instruit."
,"4":"Celui qui parle dans une langue s'affermit lui-même, tandis que le prophète affermit l'Eglise."
,"5":"J'aimerais que tous vous parliez en langues, mais je préférerais vous voir prophétiser. C'est bien mieux de prophétiser que de parler en langues, à moins que quelqu'un puisse les interpréter pour le profit de toute l'Eglise."
,"6":"Regardez, frères, si je viens chez vous pour vous parler en langues, à quoi cela vous servira-t-il? C'est tout différent si j'ai une révélation pour vous, ou une parole de connaissance, ou une prophétie, ou un enseignement."
,"7":"C'est pareil avec un instrument de musique, que vous preniez une flûte ou une cithare. S'il n'y a pas de notes avec leurs intervalles, qui reconnaîtra mon air de flûte ou de cithare?"
,"8":"Et si le son de la trompette ne ressemble à rien, qui va courir à son poste de combat?"
,"9":"C'est la même chose pour vous avec vos langues: qui va comprendre ce que vous avez dit, si vous ne dites rien clairement? Vous aurez parlé en l'air."
,"10":"Il y a bien des langues dans le monde et chacune a ses mots."
,"11":"Mais si je ne connais pas le sens des mots, je serai un étranger pour celui qui parle et lui sera un étranger pour moi."
,"12":"Tenez-en compte, et puisque vous vous intéressez aux dons spirituels, cherchez ceux qui construisent l'Eglise, de sorte que vous ne manquiez de rien."
,"13":"Si quelqu'un parle dans une langue, qu'il demande à Dieu de lui donner un interprète."
,"14":"Car si je prie en langues, mon esprit est en prière mais mon intelligence reste vide."
,"15":"Est-ce bien? Je prierai en esprit, mais mon intelligence aussi devra prier. Je louerai Dieu en esprit, mais mon intelligence aussi le louera."
,"16":"Si tu rends grâce en esprit, comment fera celui qui se contente d'écouter? Va-t-il dire: 'amen' après ton action de grâces? Il ne sait pas ce que tu as dit."
,"17":"Tu as fait une belle action de grâces, mais cela ne lui a rien apporté."
,"18":"Je rends grâces à Dieu de ce que je parle en langues mieux que vous tous."
,"19":"Mais quand l'Eglise est réunie, j'aime mieux dire cinq paroles qui ont du sens et qui profitent à tous plutôt que dix mille paroles en langues."
,"20":"Frères, ne raisonnez pas comme des enfants. Pour faire le mal, oui, restez comme des enfants, mais raisonnez comme des adultes."
,"21":"Dans la Loi il est écrit: Je me servirai de gens d'autres langues et je parlerai à ce peuple par ces bouches étrangères. Mais même ainsi ils ne m'entendront pas - parole du Seigneur."
,"22":"Donc le parler en langues est un signe, non pour ceux qui croient, mais pour les non-croyants, alors que la prophétie est pour ceux qui croient, et non pour les incroyants."
,"23":"Supposez pourtant que des gens qui ne sont pas au courant ou des incroyants, arrivent quand l'Eglise entière est rassemblée, et que tous parlent en langues: que vont-ils dire? C'est du délire!"
,"24":"Mais supposez que vous êtes tous en train de prophétiser, et voilà qu'arrive une personne qui n'est pas au courant ou un incroyant. Tous aussitôt l'interpellent et lui disent ses vérités,"
,"25":"et lui, voyant découverts les secrets de sa conscience, il tombe le visage contre terre, il adore Dieu et il reconnaît: Dieu est réellement au milieu de vous!"
,"26":"Quelle est la conclusion, frères? Toutes les fois que vous vous réunissez, chacun peut intervenir avec un psaume, un enseignement, une révélation, un parler en langues, une interprétation de ce qui est dit en langues. Mais que tout soit constructif."
,"27":"Qu'on parle en langues, soit, mais pas plus de deux ou trois, et avec un temps limité, et qu'il y ait un interprète."
,"28":"Si personne n'est là pour interpréter, que ces gens se taisent dans l'assemblée et gardent leur parler en langues pour eux-mêmes et pour Dieu."
,"29":"Pour les prophètes, deux ou trois peuvent parler, et les autres ensuite feront le discernement."
,"30":"Si l'un de ceux qui sont restés assis reçoit une révélation, le premier se taira."
,"31":"Vous pourriez tous prophétiser, mais l'un après l'autre, de sorte que tous apprennent et que tous soient motivés."
,"32":"Les esprits de la prophétie obéissent aux prophètes,"
,"33":"car l'oeuvre de Dieu n'est pas le désordre mais la paix. Voyez comment font toutes les Eglises des saints: "
,"34":"les femmes doivent se taire quand l'Eglise est assemblée. Leur rôle n'est pas de parler mais d'obéir, comme il est dit dans la Loi."
,"35":"Il n'est pas bon qu'une femme parle dans l'assemblée; si elles veulent en savoir davantage, elles demanderont à leur mari à la maison."
,"36":"Est-ce de chez vous que la parole de Dieu est venue ou êtes-vous les seuls chez qui elle est arrivée?"
,"37":"Ceux d'entre vous qui passent pour prophètes ou spirituels reconnaîtront que ce que je vous écris est un ordre du Seigneur."
,"38":"Et si quelqu'un veut l'ignorer, lui aussi sera ignoré."
,"39":"Donc frères, aspirez à la prophétie sans pour autant interdire qu'on parle en langues,"
,"40":"mais que tout se passe de façon digne et ordonnée."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Frères, je veux vous rappeler l'Evangile avec lequel je vous ai évangélisés. Vous l'avez reçu, vous y êtes restés fidèles,"
,"2":"et par lui vous êtes sauvés si vous gardez la bonne nouvelle comme je vous l'ai annoncée, à moins que par hasard vous ayez cru ce qui ne tient pas."
,"3":"Je vous ai transmis ceci d'abord, comme je l'avais reçu moi-même, que le Christ est mort pour nos péchés, en accord avec les Ecritures;"
,"4":"qu'il a été enseveli, et qu'il est ressuscité le troisième jour, en accord avec les Ecritures;"
,"5":"qu'il s'est montré à Pierre, et ensuite aux Douze."
,"6":"Il s'est montré ensuite à plus de cinq cents frères à la fois, dont quelques-uns sont morts mais la plupart sont encore vivants."
,"7":"Il s'est montré à Jacques et ensuite à tous les apôtres."
,"8":"Et il s'est montré à moi, - j'allais dire à l'avorton - le dernier de tous."
,"9":"Car je suis le dernier des apôtres et je ne mérite pas d'être appelé apôtre, moi qui ai persécuté l'Eglise de Dieu."
,"10":"Mais par grâce de Dieu je suis ce que je suis, et sa grâce avec moi n'a pas été perdue. Oui, j'ai travaillé plus que tous les autres, non pas moi, mais la grâce de Dieu en moi."
,"11":"Voilà donc ce que nous proclamons, que ce soit eux ou moi, et voilà ce que vous avez cru."
,"12":"Mais si on proclame un Christ ressuscité d'entre les morts, comment peut-on dire chez vous qu'il n'y a pas de résurrection pour les morts?"
,"13":"Si les morts ne ressuscitent pas, le Christ non plus n'est pas ressuscité."
,"14":"Et si le Christ n'est pas ressuscité, notre prédication ne rime à rien, votre foi ne rime à rien!"
,"15":"Nous voilà donc devenus de faux témoins de Dieu, puisque nous affirmons au nom de Dieu qu'il a ressuscité le Christ -"
,"16":"et de fait il ne l'a pas ressuscité, vu que les morts ne ressuscitent pas: si les morts ne ressuscitent pas, le Christ n'a pas pu ressusciter."
,"17":"Si le Christ n'est pas ressuscité, votre foi n'est qu'une illusion et vous êtes encore dans vos péchés."
,"18":"Et finalement ceux qui se sont endormis dans le Christ sont tout à fait perdus."
,"19":"Si notre espérance dans le Christ se termine avec la vie présente, nous sommes les plus à plaindre de tous les hommes."
,"20":"Mais en fait le Christ s'est bien relevé d'entre les morts, et il précède tous ceux qui se sont endormis."
,"21":"Un homme nous avait amené la mort, et c'est un homme encore qui nous apporte la résurrection des morts."
,"22":"Tous meurent parce qu'ils sont inclus en Adam, et tous sont rendus à la vie quand ils sont dans le Christ."
,"23":"Il y a un temps fixé pour tous: le Christ nous précède, et quand il reviendra, ce sera l'heure pour les siens."
,"24":"Alors viendra la fin. Le Christ aura dominé toutes les lois, les forces et les souverains de l'univers, et il remettra le Royaume à Dieu le Père."
,"25":"Il est dit qu'il doit exercer le pouvoir jusqu'à ce qu'il ait mis ses ennemis sous ses pieds,"
,"26":"et le dernier des ennemis vaincus sera la mort."
,"27":"Dieu mettra toutes choses sous ses pieds. Tout lui sera soumis, sauf Dieu bien sûr qui lui soumet l'univers."
,"28":"Quand tout lui sera soumis, le Fils se soumettra à celui qui lui a soumis toutes choses, et Dieu sera désormais tout en tous."
,"29":"Au fait, ceux qui se font baptiser pour les morts, que veulent-ils? Si de toutes façons les morts ne ressuscitent pas, pourquoi se font-ils baptiser pour eux?"
,"30":"Et nous-mêmes, pourquoi risquons-nous notre vie à chaque instant?"
,"31":"Oui, frères, aussi vrai que je suis fier de vous dans le Christ Jésus, notre Seigneur, je meurs un peu chaque jour."
,"32":"S'il n'y a rien d'autre que cette vie, qu'est-ce que j'ai gagné à lutter contre des lions à Ephèse? Si les morts ne ressuscitent pas, mangeons et buvons car demain nous mourrons."
,"33":"Ne vous y trompez pas: les mauvaises doctrines corrompent les bonnes moeurs."
,"34":"Réveillez-vous pour de bon et sortez du péché, car certains d'entre vous ignorent tout de Dieu, je le dis pour votre honte."
,"35":"Quelqu'un va me dire: 'Comment est cette résurrection des morts? Quelle sorte de corps vont-ils retrouver?'"
,"36":"Homme sans cervelle! Tout ce que tu sèmes doit mourir d'abord pour recevoir la vie."
,"37":"Et quand tu sèmes, ce n'est pas la future plante que tu sèmes, mais un grain nu, de blé ou de toute autre espèce."
,"38":"Dieu ensuite va lui donner un corps selon qu'il a décidé, car il donne à chaque semence un corps différent."
,"39":"Et puis la chair, ce n'est pas toujours la même chair. Celle d'un homme n'est pas exactement celle des animaux, ou des oiseaux, ou des poissons."
,"40":"Et quand on parle de 'corps', les 'corps célestes' sont différents des corps qu'on voit sur la terre: ils sont tout lumineux."
,"41":"Et encore la lumière du soleil est différente de celle de la lune ou des étoiles, et les étoiles n'ont pas toutes le même éclat."
,"42":"C'est la même chose pour la résurrection des morts. On sème un corps en décomposition, mais il ressuscite incorruptible."
,"43":"On le sème dans son humiliation, mais il ressuscite dans la gloire. On le sème impuissant, mais il ressuscite plein de force;"
,"44":"On le sème, ce n'était que vie animale, mais il se réveille corps spirituel. Car si le corps doué de vie animale est une réalité, le corps spirituel l'est tout autant."
,"45":"Il est écrit que le premier Adam était homme vivant de vie animale. Le dernier Adam sera esprit et source de vie."
,"46":"C'est la vie animale qui apparaît en premier, et non la vie par l'esprit. Ce qui est spirituel ne vient qu'ensuite."
,"47":"Le premier homme est tiré de la terre et il est terre, le second homme vient du ciel."
,"48":"Ceux qui sont de la terre sont comme cet homme de terre, mais ceux qui atteignent le ciel sont semblables à l'homme du ciel."
,"49":"Aussi, après avoir ressemblé à l'homme de la terre, nous serons à l'image de l'homme du ciel."
,"50":"Comprenez-moi bien, frères: ce qui est chair et sang ne peut pas entrer dans le Royaume de Dieu. Les forces de décomposition ne peuvent pas avoir part à la vie incorruptible."
,"51":"Aussi je vous dis cette chose extraordinaire: même si nous ne mourons pas tous, tous nous serons transformés"
,"52":"lorsque sonnera la trompette finale. Ce sera l'affaire d'un instant, juste un clin d'oeil. Quand sonnera la trompette, les morts ressusciteront dans un état définitif, et nous-mêmes nous serons transformés."
,"53":"Car ce qui en nous subit la décomposition doit revêtir sa forme inaltérable; ce qui en nous va à la mort doit revêtir sa forme immortelle."
,"54":"Donc, quand ce qui subit la décomposition revêtira sa forme inaltérable, quand cette vie mortelle disparaîtra sous la vie immortelle, on pourra dire cette parole de l'Ecriture: Quelle victoire! La mort a été engloutie."
,"55":"Qu'est devenue ta victoire, ô mort? Où est donc, ô mort, ton aiguillon?"
,"56":"L'aiguillon de la mort, c'était le péché, et la Loi faisait sa force."
,"57":"Mais rendons grâces à Dieu qui nous donne la victoire grâce à Jésus Christ, notre Seigneur."
,"58":"Donc, frères bien-aimés, restez fermes. Ne vous laissez pas ébranler, mais donnez-vous pleinement à l'oeuvre du Christ à tout instant; et sachez que, dans le Seigneur, votre peine n'est pas perdue."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Parlons de la collecte destinée aux saints: suivez donc les instructions que j'ai données aux Eglises de Galatie."
,"2":"Chaque dimanche, que chacun d'entre vous mette de côté ce qui lui semble bon: il ne faudrait pas qu'on attende ma venue pour faire des collectes."
,"3":"Quand je serai là, je donnerai des lettres de crédit à ceux que vous jugerez les plus indiqués, pour qu'ils portent vos dons à Jérusalem."
,"4":"Si cela en vaut la peine, j'irai moi-même et ils feront le voyage avec moi."
,"5":"J'arriverai chez vous après avoir traversé la Macédoine. Car je ne ferai que traverser la Macédoine"
,"6":"et, si cela se trouve, je resterai un bon moment et passerai chez vous l'hiver. C'est vous qui me mettrez en route pour une nouvelle destination."
,"7":"J'espère bien rester chez vous un certain temps, si le Seigneur le permet, car je ne voudrais pas vous voir seulement en passant."
,"8":"Je resterai à Ephèse jusqu'à la Pentecôte,"
,"9":"car j'y ai une porte grande ouverte et le travail avance, même avec beaucoup d'adversaires."
,"10":"Quand Timothée viendra, essayez de le mettre à l'aise, puisqu'il travaille comme moi pour le Seigneur."
,"11":"Donc, ne le regardez pas de haut, et faites qu'il puisse prendre congé de vous en paix avant de revenir vers moi. Car je l'attends, ainsi que nos frères."
,"12":"Quant à notre frère Apollos, j'ai beaucoup insisté auprès de lui pour qu'il aille vous visiter avec nos frères. Mais il a nettement refusé de partir, il viendra quand cela lui paraîtra opportun."
,"13":"Soyez vigilants et restez fermes dans la foi; soyez des hommes et montrez du courage -"
,"14":"et que tout se fasse chez vous avec amour."
,"15":"Encore une demande, frères. Comme vous le savez, les gens de la maison de Stéphanas sont le meilleur de la province d'Achaïe, et ils se sont mis au service des saints, au service des frères."
,"16":"Acceptez donc vous aussi la direction de telles personnes et de ceux qui les aident et peinent avec eux."
,"17":"La venue de Stéphanas avec Fortunatus et Achaïcos, a été pour moi une grande joie, car vous me manquiez."
,"18":"Ils ont réussi à tranquilliser votre esprit comme le mien, soyez-leur reconnaissants."
,"19":"Les Eglises d'Asie vous saluent. Aquila et Prisca vous saluent avec toute l'Eglise qui se réunit dans leur maison."
,"20":"Transmettez ce salut et échangez entre vous le saint baiser."
,"21":"Ce salut est de ma propre main, l'écriture est de moi, Paul."
,"22":"Si quelqu'un n'aime pas le Seigneur, malheur à lui!"
,"23":"Marana Tha: viens Seigneur! La grâce de Jésus le Seigneur soit avec vous."
,"24":"Je vous aime tous dans le Christ Jésus!"
}`)

}
func FR_LBDCC_LoadNP1EChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Lettre de Paul, Silvain et Timothée à l'Eglise des Thessaloniciens réunie en Dieu le Père et en Jésus Christ, le Seigneur. Que la grâce et la paix soient avec vous."
,"2":"A tout moment nous rendons grâces à Dieu pour vous tous et nous ne cessons de vous rappeler à son attention dans nos prières."
,"3":"Car nous n'oublions pas les travaux de votre foi, ni votre charité infatigable, ni votre espérance qui persévère dans l'attente de Jésus Christ, notre Seigneur, et tout cela nous le présentons à Dieu notre Père."
,"4":"Frères bien-aimés de Dieu, nous n'oublions pas les circonstances de votre appel."
,"5":"Chez vous notre Bonne Nouvelle n'est pas restée en paroles, mais elle a eu bien des moyens pour convaincre: il y a eu des miracles et l'Esprit Saint. Rappelez-vous comment nous avons agi au milieu de vous et pour vous."
,"6":"Vous nous avez imités et vous avez imité le Seigneur quand vous avez accueilli la Parole avec la joie de l'Esprit Saint en dépit d'une forte persécution."
,"7":"Finalement, vous êtes devenus un exemple pour tous les croyants de Macédoine et d'Achaïe."
,"8":"De fait c'est à partir de vous que la parole du Seigneur s'est étendue à la Macédoine et l'Achaïe et bien au-delà: de tous côtés on a pu mesurer votre foi, si bien que nous n'avons pas besoin d'en parler."
,"9":"Ce sont eux qui disent l'accueil que nous avons trouvé chez vous et comment vous êtes passés des idoles à Dieu. Et vous avez commencé à servir le Dieu vivant et vrai,"
,"10":"attendant que vienne du ciel Jésus, son Fils qu'il a ressuscité d'entre les morts, celui qui nous sauve du jugement à venir."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Vous savez bien, frères, que notre passage chez vous n'a pas été sans profit."
,"2":"Nous venions juste d'être bien éprouvés et maltraités à Philippes, comme vous le savez, mais, comptant sur Dieu, nous avons pris le risque de vous annoncer l'Evangile de Dieu malgré une forte opposition."
,"3":"Nous ne vous avons pas fait entendre la voix de l'erreur ou de l'impureté, et nous n'avons rien déguisé."
,"4":"Puisque c'est Dieu qui nous a examinés et retenus pour nous confier l'Evangile, nous le prêchons, non pour plaire aux hommes, mais à Dieu qui examine nos coeurs."
,"5":"Pas un moment nous ne vous avons flattés, comme vous le savez; et nous n'avons pas cherché l'argent - Dieu en est témoin -"
,"6":"ou les honneurs, que cela vienne de vous ou d'autres personnes."
,"7":"Comme apôtres du Christ, nous aurions pu nous faire servir; mais nous nous sommes faits tout petits au milieu de vous, comme la maman qui joue avec son bébé."
,"8":"Nous tenions tellement à vous que nous étions prêts à vous donner, non seulement l'Evangile de Dieu, mais notre propre vie. C'est que vous nous étiez vraiment chers."
,"9":"Rappelez-vous, frères, nos fatigues et nos soucis. Tout en vous prêchant l'Evangile de Dieu, nous avons travaillé de nuit et de jour pour n'être à la charge d'aucun d'entre vous."
,"10":"Vous êtes témoins, et Dieu aussi, que nous avons été vraiment saints, droits et sans reproche avec vous tous qui avez cru."
,"11":"Vous savez comment nous avons suivi chacun de vous, comme un père ses enfants."
,"12":"Nous vous avons encouragés et instruits, et nous avons insisté pour que votre façon de vivre soit digne du Dieu qui vous a appelés à son Royaume et à sa Gloire."
,"13":"Justement, nous rendons grâce à Dieu constamment parce que, après avoir entendu et reçu de nous la parole de Dieu, vous l'avez prise, non pour une parole humaine, mais pour ce qu'elle est vraiment: une parole de Dieu. Et elle est active parmi vous qui croyez."
,"14":"Dans le Christ, frères, vous avez suivi en tout les Eglises de Dieu en Judée: vous avez été persécutés par vos frères de race, tout comme elles l'ont été par les Juifs."
,"15":"Ce sont eux qui ont tué Jésus et les prophètes, et maintenant ils nous poursuivent. Ils ne plaisent sûrement pas à Dieu, et ils se font les ennemis de tous les hommes,"
,"16":"quand ils nous empêchent de prêcher aux païens pour qu'ils soient sauvés. Ils font tout pour mettre le comble à leurs péchés, mais à la fin, la Colère va se décharger sur eux."
,"17":"Frères, comme nous nous trouvions privés de vous depuis un bon moment, de corps mais non de coeur, nous avions un grand désir de revoir vos visages et nous en cherchions le moyen."
,"18":"Nous avons voulu aller chez vous - pour moi, Paul, ç'a été plus d'une fois - mais Satan nous a mis des obstacles."
,"19":"Car, où sont nos espoirs et qui est notre joie sinon vous? Et qui sera notre couronne et notre orgueil en présence du Seigneur Jésus le jour où il nous visitera?"
,"20":"C'est vous qui êtes notre gloire et notre joie."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Comme nous ne tenions plus en place, nous avons préféré rester seuls à Athènes,"
,"2":"et nous vous avons envoyé Timothée, notre frère, habitué à travailler avec Dieu pour l'Evangile du Christ. Il devait vous affermir et vous encourager à croire,"
,"3":"afin que personne ne lâche prise à cause de ces épreuves. Vous saviez déjà que c'est notre lot. "
,"4":"Quand nous étions auprès de vous, nous vous avons avertis: nous aurons des persécutions. Et tout s'est passé comme nous l'avions dit."
,"5":"De mon côté, je ne tenais plus en place, et je vous l'ai envoyé pour savoir où vous en étiez de la foi: est-ce que le tentateur avait eu raison de vous et réduit à rien tous nos efforts?"
,"6":"Mais voilà que Timothée est de retour de chez vous, et il nous donne de bonnes nouvelles de votre foi et de votre amour; vous nous restez très attachés et vous êtes anxieux de nous revoir, tout comme nous le sommes nous-mêmes."
,"7":"C'est donc votre foi qui nous redonne du courage au milieu des difficultés et des épreuves que nous connaissons au service de votre foi."
,"8":"Frères, si vous restez fermes dans le Seigneur, nous recommençons à vivre."
,"9":"Comment pourrions-nous rendre grâces à Dieu pour toute cette joie que nous ressentons devant notre Dieu à cause de vous?"
,"10":"Jour et nuit nous lui demandons instamment de revoir votre visage et de compléter ce qui manque à votre foi."
,"11":"Que Dieu lui-même, notre Père, avec Jésus notre Seigneur, nous aplanisse le chemin pour vous rejoindre."
,"12":"Que le Seigneur fasse grandir et déborder l'amour que vous avez les uns pour les autres et pour tous, à la mesure de l'amour que nous avons pour vous!"
,"13":"Qu'il vous fortifie intérieurement, pour que vous soyez saints et irréprochables devant Dieu notre Père, le jour où Jésus, notre Seigneur, viendra avec tous ses saints!"
}`)
	CurrentBook.AddChapter(4, `{
"1":"A part cela, frères, nous avons une demande et une prière à vous faire dans le Christ Jésus. Nous vous avons enseigné comment vous devez vous conduire pour plaire à Dieu et déjà vous le faites, mais faites encore des progrès."
,"2":"Vous savez quelles sont les traditions que nous vous avons données avec l'autorité du Seigneur Jésus."
,"3":"La volonté de Dieu est que vous deveniez saints : pas de liberté sexuelle."
,"4":"Que chacun de vous sache faire usage de son corps avec sainteté et respect,"
,"5":"au lieu de s'abandonner à ses passions comme les païens qui ne connaissent pas Dieu."
,"6":"Que personne ne fasse tort et n'abuse de ses frères et soeurs dans ce domaine, car le Seigneur fera justice de tout cela, comme nous vous l'avons dit et redit."
,"7":"Car Dieu ne nous a pas appelés à l'impureté mais à la sainteté,"
,"8":"et si quelqu'un se moque de cet avis, il se moque, non d'un homme, mais de Dieu qui met en vous son Esprit Saint."
,"9":"Vous n'avez pas besoin qu'on vous écrive longuement sur l'amour fraternel: Dieu lui-même vous a appris à vous aimer les uns les autres,"
,"10":"et vous le faites pour tous les frères dans toute la Macédoine. Et pourtant, frères, je vous demande de faire mieux encore. "
,"11":"Pensez que c'est une grande chose d'avoir de la stabilité, de compter sur soi-même et de travailler avec ses mains: nous vous l'avions déjà demandé."
,"12":"De cette façon, les gens du dehors vous auront en bonne estime et vous-mêmes ne serez pas dans le besoin."
,"13":"Frères, nous ne voulons pas que vous restiez dans l'ignorance au sujet de ceux qui se sont endormis; vous ne pouvez pas vous affliger comme font les autres qui n'ont pas d'espérance."
,"14":"Ne croyons-nous pas que Jésus est mort et ressuscité? De même Dieu fera que Jésus prenne avec lui ceux qui se sont endormis."
,"15":"Et nous vous disons ceci comme parole du Seigneur: nous qui vivons et qui serons encore là pour la venue du Seigneur, nous n'aurons rien de plus que ceux qui déjà reposent."
,"16":"Un ordre sera donné, et l'on entendra l'appel de l'archange et de la trompette céleste. Alors le Seigneur lui-même descendra du ciel, et d'abord ressusciteront ceux qui sont morts dans le Christ."
,"17":"Ensuite nous, qui serons encore en vie, nous serons enlevés avec eux dans les nuées pour rencontrer le Seigneur dans les hauteurs. Et alors nous serons définitivement avec le Seigneur."
,"18":"Vous pourrez donc vous réconforter les uns les autres avec ces paroles."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Dans quel délai et quelles circonstances? Cela, frères, vous n'avez pas besoin qu'on vous l'écrive."
,"2":"Vous savez très bien que le Jour du Seigneur se présente de nuit, comme le voleur."
,"3":"Quand tous diront: 'C'est la paix, la sécurité!', la catastrophe les surprendra, comme pour la femme les douleurs de l'accouchement, et ils n'y échapperont pas."
,"4":"Mais vous, frères, vous n'êtes pas dans les ténèbres et ce jour ne vous surprendra pas comme un voleur."
,"5":"Vous êtes tous enfants de lumière et enfants du jour; nous, nous sommes étrangers à la nuit et aux ténèbres."
,"6":"Donc, ne restons pas au lit comme les autres, mais veillons, et soyons sur nos gardes."
,"7":"Les dormeurs dorment de nuit, et les buveurs s'enivrent de nuit."
,"8":"Mais nous sommes du jour, et c'est pourquoi nous veillons: nous nous mettrons comme cuirasse la foi et l'amour, et nous prendrons pour casque l'espérance du salut."
,"9":"Car Dieu ne nous a pas faits pour subir sa Colère, mais pour acquérir le salut par Jésus Christ, notre Seigneur."
,"10":"Il est mort pour nous, pour que nous vivions avec lui, que nous soyons éveillés ou que nous dormions."
,"11":"Donc, donnez-vous du courage les uns aux autres et grandissez dans l'unité comme vous le faites déjà."
,"12":"Frères, nous vous demandons d'être reconnaissants envers ceux qui se donnent tant de mal au milieu de vous: ils sont vos dirigeants dans le Seigneur et ils ont le devoir de vous reprendre."
,"13":"Comprenez que vous devez les aimer davantage à cause de ce qu'ils font et vivez en bon accord avec eux."
,"14":"Nous faisons appel à vous, frères: reprenez les indisciplinés, instruisez ceux qui manquent d'enthousiasme, aidez les faibles, soyez compréhensifs avec tous."
,"15":"Veillez à ce que personne ne rende le mal pour le mal. Au contraire, ne cessez pas de vous faire le bien les uns aux autres et à tous en tout temps."
,"16":"Soyez toujours joyeux"
,"17":"et ne vous lassez pas de prier."
,"18":"Rendez grâces pour tout: c'est ce que Dieu attend de vous dans le Christ Jésus."
,"19":"N'éteignez pas l'esprit."
,"20":"Ne prenez pas à la légère ce que disent les prophètes."
,"21":"Mettez tout à l'épreuve et retenez ce qui est bon."
,"22":"Gardez-vous du mal sous toutes ses formes."
,"23":"Que le Dieu de paix sanctifie toute votre personne; qu'il garde sans tache tout votre esprit, votre âme et votre corps pour le jour où viendra Jésus Christ notre Seigneur."
,"24":"Celui qui vous a appelés est digne de confiance: il le fera."
,"25":"Frères, priez pour nous."
,"26":"Saluez tous les frères avec un saint baiser."
,"27":"Je vous demande au nom du Seigneur que cette lettre soit lue en présence de tous les frères."
,"28":"Que la grâce de Jésus Christ, notre Seigneur, soit avec vous."
}`)

}
func FR_LBDCC_LoadNP1IChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Lettre de Paul, apôtre de Jésus Christ par une décision de Dieu, notre Sauveur, et de Jésus Christ, notre espérance,"
,"2":"lettre que j'adresse à Timothée, mon cher enfant dans la foi. Que vienne sur toi la grâce, la miséricorde et la paix de Dieu le Père et de Jésus Christ, notre sauveur!"
,"3":"Tu sais qu'au moment de partir pour la Macédoine je t'ai demandé de rester à Ephèse. Tu devais avertir certaines personnes de ne pas changer la doctrine"
,"4":"et de laisser de côté les fables et listes d'anges interminables. Ces choses-là amènent plus de discussions qu'elles ne font avancer l'oeuvre de Dieu dans la foi."
,"5":"Ce que je veux avec cette mise en garde, c'est l'amour qui naît d'un coeur pur, d'une conscience droite et d'une foi sans mensonge."
,"6":"Quelques-uns l'ont oublié, et ils se sont perdus dans des discussions creuses."
,"7":"Ils veulent être des Maîtres de la Loi, alors qu'ils ne savent pas ce qu'ils disent ni de quoi ils parlent."
,"8":"Nous savons que la Loi est bonne, pourvu qu'on en fasse un usage légitime."
,"9":"On doit savoir que la Loi n'est pas là pour les personnes droites mais pour les gens sans loi, les insoumis, les esprits irréligieux et les pécheurs, pour les impurs et les gens souillés, ceux qui tuent père et mère, les assassins,"
,"10":"les adultères, ceux qui ont des rapports entre hommes ou avec des enfants, ceux qui trompent, ceux qui font de faux serments. Et il faudrait ajouter tout le reste de ce qui est contraire à une saine éducation"
,"11":"selon le glorieux évangile du Dieu béni, lequel m'a été confié."
,"12":"Je rends grâces à Jésus Christ, notre Seigneur, de qui je tiens la force, parce qu'il m'a fait confiance et m'a pris pour son intendant."
,"13":"Pourtant j'étais au début un contradicteur, un persécuteur et un violent. Mais il m'a pardonné car j'étais de bonne foi quand je refusais de croire,"
,"14":"et la grâce de notre Seigneur est venue plus abondante encore, avec la foi et l'amour qui se trouvent dans le Christ."
,"15":"Voilà une chose sûre et sur laquelle on peut compter: Jésus Christ est venu dans le monde pour sauver les pécheurs, dont je suis le premier."
,"16":"Mais justement j'ai eu droit à sa miséricorde, parce que le Christ a voulu qu'on voie en moi, le premier, toute sa générosité, et que ce soit un exemple dans le futur pour ceux qui croiront en lui et auront ainsi la vie éternelle."
,"17":"Honneur et gloire à Dieu pour les siècles des siècles! Il règne bien au-delà du temps et des choses périssables, lui l'invisible et le seul Dieu: Amen!"
,"18":"Timothée, mon enfant, en te donnant ces instructions, je repense aux paroles prophétiques qui ont été prononcées sur toi. Qu'elles te guident dans le bon combat que tu as à mener."
,"19":"Garde la foi et la conscience droite. Certaines personnes n'en ont pas tenu compte, et leur foi a fait naufrage,"
,"20":"tout spécialement Hyménée et Alexandre que j'ai livrés à Satan pour qu'ils apprennent à ne plus dire des horreurs."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Je demande avant toute autre chose qu'on fasse des prières, des demandes, des supplications et des actions de grâces sans distinction de personnes,"
,"2":"pour les rois et ceux qui nous gouvernent, afin que nous puissions vivre en paix et tranquillité, que notre vie soit religieuse et digne."
,"3":"Voilà ce qui est bien et ce que désire Dieu notre Sauveur;"
,"4":"car il veut que tous les hommes soient sauvés et parviennent à la connaissance de la vérité."
,"5":"Dieu est unique, unique aussi le médiateur entre Dieu et les hommes, le Christ Jésus, homme,"
,"6":"qui s'est livré en rançon pour tous; et c'est là le témoignage (de Dieu) qui devait être donné au temps fixé."
,"7":"C'est de cela même que j'ai été fait prédicateur et apôtre, - je dis la vérité et ne mens pas - j'enseigne les nations païennes de façon vraie et digne de foi."
,"8":"Donc je voudrais que partout où les hommes sont en prière, leurs mains s'élèvent vers le ciel, pures de toute colère et dispute."
,"9":"Et de même, que les femmes sachent se revêtir et se parer de grâce et de bon sens, plutôt que de coiffures, d'or, de perles et de vêtements de prix."
,"10":"Pour une femme qui a reçu une éducation religieuse, les bonnes oeuvres sont la vraie parure."
,"11":"Que la femme sache se taire et être docile quand on l'instruit."
,"12":"Je n'accepte pas qu'une femme enseigne ou qu'elle en remontre à son mari: qu'elle reste tranquille."
,"13":"C'est bien Adam qui a été créé le premier, et ensuite seulement Eve."
,"14":"Et ce n'est pas Adam qui s'est laissé séduire, mais la femme qui a été séduite, et la faute est venue par elle."
,"15":"Bien sûr, elle sera sauvée grâce à sa maternité. Mais il faut que les femmes gardent une retenue, en même temps qu'elles persévèrent dans la foi, la charité et la sainteté."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Une chose est sûre: si quelqu'un aspire à la charge d'évêque, il poursuit un but très noble."
,"2":"Il faut donc que l'évêque soit sans reproche, homme d'une seule femme, chaste, maître de lui-même, correct, hospitalier, capable d'enseigner."
,"3":"Pas un buveur ou un querelleur, mais un homme large d'esprit, pacifique, qui ne recherche pas l'argent;"
,"4":"un homme qui dirige bien sa maisonnée et dont les enfants obéissent et sont bien élevés."
,"5":"Car si quelqu'un ne sait pas mener sa maison, comment va-t-il prendre soin de l'Eglise de Dieu?"
,"6":"Il ne faut pas prendre un nouveau converti; l'orgueil pourrait lui tourner la tête et le diable le ferait tomber."
,"7":"Il faut aussi que ceux de l'extérieur l'aient en estime; sinon il sera discrédité et là encore le diable le prendra au piège."
,"8":"La même chose pour les diacres. Il faut des hommes droits, qui n'ont qu'une seule parole, qui ne sont pas portés au vin ou attirés par l'argent,"
,"9":"des hommes qui gardent dans un coeur pur les mystères de la foi."
,"10":"On les mettra d'abord à l'épreuve, et ensuite, s'il n'y a rien à reprendre, ils rempliront leur charge."
,"11":"La même chose pour les femmes: elles seront droites, pas médisantes, chastes, dignes de confiance sur tous les plans."
,"12":"Les diacres doivent être hommes d'une seule femme, des gens qui savent gouverner leurs enfants et leur propre maison."
,"13":"Ceux qui remplissent bien leur charge se préparent une place d'honneur et deviennent des hommes solides dans la foi chrétienne."
,"14":"Je te dis tout cela alors que j'ai l'espoir de te rejoindre bientôt."
,"15":"Mais si je tarde, tu sauras comment on doit se comporter dans la maison de Dieu: je parle de l'Eglise du Dieu vivant, colonne et fondement de la vérité."
,"16":"Comme il est grand le mystère de la bonté divine: Il s'est fait voir dans la chair,et l'esprit l'a justifié. Les anges l'ont vu, chez les païens on l'a proclamé. Dans le monde on croit en lui, mais lui est élevé dans la gloire."
}`)
	CurrentBook.AddChapter(4, `{
"1":"L'Esprit dit clairement que dans les derniers temps certains laisseront la foi, faisant confiance à des esprits trompeurs et des doctrines soufflées par les démons."
,"2":"On verra des prêcheurs de mensonge, des hypocrites dont la conscience est marquée au fer rouge."
,"3":"Ces gens interdisent le mariage et veulent qu'on s'abstienne d'aliments créés par Dieu pour qu'on en use, et qu'on lui en rende grâces. Ainsi en est-il pour les croyants, qui savent la vérité."
,"4":"Car tout ce que Dieu a créé est bon, et rien n'est à rejeter dans de ce qu'on prend avec action de grâces:"
,"5":"la parole de Dieu et la prière l'ont sanctifié."
,"6":"Expose tout cela aux frères, tu seras un bon serviteur du Christ Jésus, nourri des paroles de la foi et de la saine doctrine que tu as reçue."
,"7":"Laisse de côté les fables indignes et les contes de bonne femme, et par contre exerce en toi l'esprit religieux."
,"8":"L'exercice physique n'a qu'une utilité bien limitée; par contre l'esprit religieux est utile sur tous les plans: il est récompensé dans la vie présente et dans l'autre vie."
,"9":"Veux-tu une parole sûre et qui ne trompe pas?"
,"10":"Nous nous donnons de la peine et nous luttons parce que notre espérance est dans le Dieu vivant, le Sauveur de tous les humains, et particulièrement des croyants."
,"11":"Redis et enseigne toutes ces choses."
,"12":"Que personne ne te méprise pour un manque de maturité. Sois un modèle pour les croyants dans tes paroles, ta charité, ta façon de vivre, ta foi, ta vie sans faute."
,"13":"En attendant que je vienne, consacre ton temps à l'étude, à la prédication, à l'enseignement."
,"14":"Ne laisse pas dormir le charisme qui t'a été donné par une intervention de prophète, avec l'imposition des mains de tous les anciens."
,"15":"Voilà donc tes occupations et comment tu dois te situer, et ainsi tous seront témoins de tes progrès."
,"16":"Veille sur toi-même et sur ton enseignement, et continue sans te lasser. C'est ainsi que tu te sauveras, toi et ceux qui t'écoutent."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Ne traite pas durement un ancien, mais parle-lui comme à un père, et aux plus jeunes comme à tes frères."
,"2":"Parle aux femmes âgées comme à des mères, et aux jeunes comme à tes soeurs, en toute pureté."
,"3":"Prends soin des veuves qui sont vraiment veuves."
,"4":"Quand une veuve a près d'elle des enfants qu'elle a mis au monde, ceux-ci doivent d'abord apprendre leurs devoirs envers leur propre famille et rendre à leurs parents ce qu'ils doivent. Voilà ce qui est correct devant Dieu."
,"5":"Une vraie veuve est celle qui reste seule et qui a mis en Dieu son espérance; et maintenant elle se consacre jour et nuit à la prière et la supplication."
,"6":"Mais celle qui fait la fête est une morte en vie."
,"7":"Dis-le leur bien pour qu'on n'ait rien à leur reprocher."
,"8":"Si quelqu'un ne prend pas soin de ses proches, et spécialement ceux de sa maison, il renie la foi et il est pire qu'un incroyant."
,"9":"Ne mets sur la liste des veuves que celle qui a passé soixante ans, qui a été la femme d'un seul homme"
,"10":"et dont on a vu les bonnes oeuvres. A-t-elle élevé ses enfants, a-t-elle su accueillir chez elle, a-t-elle servi les saints de passage, a-t-elle eu la préoccupation de ceux qui souffrent? En un mot, il faut qu'elle se soit dépensée à faire le bien."
,"11":"Ecarte les jeunes veuves. Quand elles en ont assez du Christ, elles veulent se marier"
,"12":"et se rendent coupables en brisant leur engagement antérieur."
,"13":"Et puis elles apprennent à ne rien faire et traînent de maison en maison. Ne faisant rien, elles sont bavardes et indiscrètes, et elles parlent à tort et à travers."
,"14":"Donc je préfère que les jeunes se marient, qu'elles aient des enfants et s'occupent de leur maison. De cette façon elles ne donneront aucun prétexte à ceux qui sont prêts à nous critiquer."
,"15":"Déjà quelques-unes ont perdu leur chemin et suivent Satan."
,"16":"Si une personne croyante a des veuves, qu'elle les prenne en charge au lieu qu'elles soient un fardeau pour l'Eglise, et alors on aura assez pour celles qui sont de vraies veuves."
,"17":"Les anciens qui savent présider méritent double rétribution, surtout ceux qui portent le poids de la prédication et de l'enseignement."
,"18":"L'Ecriture l'a dit: Tu ne fermeras pas la bouche du boeuf qui bat le grain. Et encore: Le travailleur a droit à son salaire."
,"19":"Ne laisse pas accuser un ancien s'il n'y a pas au moins deux ou trois témoins."
,"20":"Ceux qui sont coupables, tu les reprendras en public pour que les autres aussi fassent attention."
,"21":"Mais je te le demande devant Dieu et devant Jésus Christ, et devant tous les saints anges: observe ces règles de façon impartiale et ne fais pas de favoritisme."
,"22":"N'impose les mains à personne à la légère, car tu te rendrais complice des fautes d'autrui. Ne fais pas de tort à ton image."
,"24":"Il y a des gens dont les fautes sont connues avant toute enquête, et pour d'autres c'est seulement à ce moment-là."
,"25":"De la même façon les actions qui valent peuvent être connues, et sinon, elles ne pourront rester cachées."
,"23":"(Ne bois pas que de l'eau. Prends aussi un peu de vin à cause de ton estomac et de tes fréquentes faiblesses.)"
}`)
	CurrentBook.AddChapter(6, `{
"1":"Tous ceux qui sont soumis à la condition d'esclaves devront traiter leurs maîtres avec le plus grand respect; autrement, les critiques retomberaient sur le nom de Dieu et la doctrine."
,"2":"Ceux qui ont des maîtres croyants ne doivent pas leur manquer de respect sous prétexte que ce sont des frères. Au contraire, si ce sont des croyants et des frères qui profitent de leurs attentions, que leur service soit meilleur!"
,"3":"Voilà ce que tu dois prêcher et enseigner. Si quelqu'un donne un autre enseignement et ne tient pas compte des saines paroles, celles de Jésus Christ, notre Seigneur, ni de l'enseignement qui honore Dieu,"
,"4":"c'est un aveugle et un ignorant. Cet homme a la maladie des controverses et des querelles de mots, et de là viennent l'envie, les rivalités, les insultes, les soupçons malintentionnés"
,"5":"et toutes les discussions sans fin de gens dont les facultés mentales sont corrompues. Ils sont tellement loin de la vérité, qu'ils considèrent la religion comme une bonne affaire. "
,"6":"La religion, bien sûr, est une excellente affaire, mais parce qu'avec elle nous savons nous contenter."
,"7":"Car nous sommes arrivés dans ce monde les mains vides et nous n'emporterons rien avec nous."
,"8":"Soyons donc satisfaits si nous avons de quoi manger et nous couvrir."
,"9":"Ceux qui cherchent à s'enrichir tomberont dans la tentation, dans les pièges de tous ces désirs insensés et pernicieux qui détruisent les personnes et les mènent à leur perte."
,"10":"Car l'amour de l'argent est la racine de tous les maux. Quelques-uns s'y sont laissé prendre et par là se sont égarés loin de la foi; ils ont eu à souffrir de mille manières."
,"11":"Mais toi, homme de Dieu, fuis tout cela. Persévère dans la droiture, la piété, la foi, la charité, la patience, l'humilité."
,"12":"Combats le bon combat de la foi et gagne la vie éternelle à laquelle tu as été appelé et pour laquelle tu as fait une belle profession de foi en présence de nombreux témoins."
,"13":"Je te fais là une demande pressante en présence de Dieu qui donne la vie à tout l'univers et de Jésus Christ qui a donné son magnifique témoignage devant Ponce Pilate:"
,"14":"préserve le commandement de tout ce qui peut le ternir ou l'adultérer, jusqu'au jour où se montrera Jésus Christ, notre Seigneur."
,"15":"Il nous sera présenté au moment voulu par le Dieu Bienheureux qui seul est puissant, le Roi des rois et Seigneur des seigneurs."
,"16":"Lui seul dispose de l'immortalité, lui qui vit dans une lumière inaccessible et que nul homme n'a vu et ne peut voir. A lui l'honneur et la puissance pour toujours! Amen."
,"17":"Rappelle aux riches de ce monde qu'ils ne doivent pas se croire supérieurs; qu'ils ne mettent pas leur confiance dans une richesse qui n'est jamais sûre, mais en Dieu. C'est lui qui nous donne tout, très largement, pour en faire usage."
,"18":"Qu'ils fassent le bien et deviennent riches en bonnes oeuvres; qu'ils donnent de bon coeur et sachent partager."
,"19":"De cette façon ils se préparent pour l'avenir un bon capital avec lequel ils pourront acquérir la vraie vie."
,"20":"O Timothée, garde le dépôt qu'on t'a confié; rejette les discussions creuses et mondaines, comme les objections venant d'une prétendue science."
,"21":"Pour l'avoir prise au sérieux, plusieurs ont perdu la foi. Que la grâce soit avec vous tous."
}`)

}
func FR_LBDCC_LoadNP2CChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Paul, apôtre du Christ Jésus par la volonté de Dieu, et Timothée, votre frère, saluent l'Eglise de Dieu qui est à Corinthe et tous les saints qui résident dans la province d'Achaïe."
,"2":"Recevez grâce et paix de Dieu notre Père et du Seigneur Jésus Christ."
,"3":"Béni soit Dieu, le Père du Christ Jésus notre Seigneur, le Père plein de tendresse, le Dieu de qui vient tout réconfort!"
,"4":"Il nous réconforte quelles que soient nos épreuves, pour qu'à notre tour nous soyons capables de réconforter ceux qui sont éprouvés de quelque manière, à partir du réconfort que nous recevons de Dieu."
,"5":"Quand les souffrances du Christ retombent sur nous plus abondantes, le réconfort aussi nous vient plus abondant grâce au Christ."
,"6":"Donc, si nous sommes dans la détresse, c'est pour votre réconfort et votre salut; et si nous sommes réconfortés, c'est pour votre réconfort: vous en ferez l'expérience quand vous passerez par les mêmes souffrances que nous."
,"7":"Car c'est notre ferme conviction: si vous partagez la souffrance, vous aurez part aussi au réconfort."
,"8":"Frères, nous ne voulons pas vous cacher l'épreuve que nous avons connue en Asie. Elle était telle que nous nous sentions écrasés et ne pensions pas devoir en sortir vivants."
,"9":"Mais si nous avons entendu en nous-mêmes cette sentence de mort, c'était pour que nous ne comptions plus désormais sur nous-mêmes, mais sur Dieu qui fait revivre les morts."
,"10":"Il nous a délivrés de ces périls de mort, et il nous en délivrera encore. Puisque nous avons mis en lui notre espérance, il nous délivrera encore"
,"11":"avec l'aide de vos prières pour nous. Et comme beaucoup lui auront demandé cette grâce, il voudra que tous puissent lui rendre grâces à notre sujet."
,"12":"Nous avons le droit d'être fiers; notre conscience nous assure que la droiture et la simplicité de Dieu ont guidé tous nos agissements en ce monde, et tout spécialement avec vous. Il n'y avait là aucun calcul humain mais seulement la grâce de Dieu."
,"13":"Quand nous vous écrivons, ce n'est pour rien d'autre que ce que vous pouvez lire et entendre clairement, et j'espère bien que ce sera clair jusqu'à la fin."
,"14":"Déjà vous comprenez, au moins en partie, que vous devez être fiers de nous, comme nous aussi serons fiers de vous au Jour du Seigneur Jésus."
,"15":"C'était déjà mon sentiment quand j'ai décidé tout d'abord de venir vous voir pour vous apporter une seconde fois la grâce de Dieu."
,"16":"De chez vous je devais partir et parcourir la Macédoine avant de revenir de Macédoine chez vous; et alors vous m'auriez mis sur la route pour mon retour en Judée."
,"17":"Ai-je pris cette décision trop vite, sans réfléchir? Ou bien était-ce ma décision, une décision toute humaine où se mêlent du oui et du non?"
,"18":"Non, Dieu est témoin que ce que nous vous disons n'est pas oui et non."
,"19":"D'ailleurs vous ne trouverez pas du oui et du non dans le Fils de Dieu, Jésus Christ, tel que nous vous l'avons annoncé, Timothée et Sylvain et moi-même. Tout en lui a été oui,"
,"20":"et grâce à lui toutes les promesses de Dieu sont devenues un oui. Aussi bien nous disons Amen! Oui! pour rendre gloire à Dieu par lui."
,"21":"Dieu lui-même nous a rendus fermes, et vous aussi, pour le service du Christ, quand nous avons reçu l'onction,"
,"22":"quand il nous a marqués de son sceau et a déposé en nos coeurs les premiers dons de l'Esprit."
,"23":"Donc, si j'ai renoncé à venir à Corinthe, ç'a été seulement pour vous épargner, et j'en prends Dieu à témoin."
,"24":"Car je ne cherche pas à être un dictateur de la foi, je veux seulement vous apporter la joie. La foi, vous l'avez."
}`)
	CurrentBook.AddChapter(2, `{
"1":"J'ai donc préféré ne pas revenir chez vous avec des reproches."
,"2":"Car si je vous fais de la peine, personne ne me rendra la joie sinon celui à qui j'ai causé cette peine."
,"3":"Et c'est bien ce que je vous ai dit dans la lettre: 'Si je viens, je ne voudrais pas avoir à m'attrister pour ceux qui devraient être ma joie, et j'espère bien que tous vous partagerez ma joie.'"
,"4":"Car je me voyais dans une grande détresse et très angoissé, et je vous ai écrit entre les larmes, non pour vous faire de la peine, mais pour que vous sachiez combien je vous aime."
,"5":"Si quelqu'un a causé de la peine, la peine n'a pas été pour moi mais, d'une certaine façon, car je ne veux pas exagérer, pour vous tous."
,"6":"Et pour celui-là, les reproches qu'il a reçus de la majorité devraient suffire."
,"7":"Maintenant vous devriez plutôt lui manifester de la bonté et l'encourager. Sinon, il ressentirait plus de peine qu'il n'en peut supporter."
,"8":"Aussi, je vous demande de l'entourer d'affection."
,"9":"Si je vous ai écrit, c'était pour voir votre réaction et savoir si votre obéissance est entière."
,"10":"Si vous pardonnez, moi aussi je pardonne. Et si j'ai quelque chose à pardonner, je pardonne face au Christ à cause de vous,"
,"11":"pour ne pas faire le jeu de Satan. Car nous savons bien où il veut en venir."
,"12":"Comme je disais, je suis allé à Troie pour y donner l'Evangile du Christ, et grâce au Seigneur je fus capable de le faire."
,"13":"Mais mon esprit ne pouvait rester en paix car je n'y avais pas retrouvé Tite, mon frère. Aussi, je les ai laissés et je suis parti pour la Macédoine."
,"14":"Remercions Dieu qui nous entraîne toujours dans la marche victorieuse du Christ et se sert de nous pour répandre en tous lieux le parfum de sa connais sance!"
,"15":"Si le Christ est la victime, nous sommes l'odeur du sacrifice qui monte vers Dieu. Nous le sommes pour ceux qui sont sauvés comme pour ceux qui se perdent. "
,"16":"Pour les uns c'est une odeur de mort qui mène à la mort; pour les autres c'est le parfum de la vie, qui conduit à la vie. Mais qui est à la hauteur d'un tel rôle?"
,"17":"On trouve facilement des revendeurs de la Parole de Dieu, mais chez nous tout est sincère: tout vient de Dieu et tout est dit face à lui, dans le Christ."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Allons! Voilà que je recommence à faire mon éloge. Sans doute devrais-je faire comme les autres et porter des lettres de recommandation venant de vous ou destinées à votre usage."
,"2":"Mais la lettre, c'est vous, une lettre qui est tout à l'intérieur, mais que tout le monde peut lire et comprendre."
,"3":"Vous êtes une lettre du Christ écrite par nos soins, c'est clair; l'Esprit du Dieu vivant en a été l'encre, elle n'était pas gravée sur des tablettes de pierre, mais dans des coeurs humains."
,"4":"Oui, voilà comment nous nous sentons sûrs de Dieu grâce au Christ."
,"5":"De nous-mêmes, nous serions incapables de nous attribuer quelque chose, mais notre capacité vient de Dieu."
,"6":"Il a été jusqu'à faire de nous les administrateurs d'une alliance nouvelle où il n'y a plus un texte écrit, mais l'Esprit. Car la lettre tue alors que l'esprit donne la vie."
,"7":"Celui qui donnait des lois gravées sur la pierre, n'apportait que la mort, et pourtant Dieu lui communiquait sa gloire: les Israélites ne pouvaient pas regarder en face le visage de Moïse tant il rayonnait de gloire; mais cela ne durait pas."
,"8":"Quelle gloire, alors, est-elle réservée aux serviteurs de l'Esprit?"
,"9":"Si c'est un honneur de prononcer la condamnation, c'est un bien plus grand honneur d'apporter justice et sainteté."
,"10":"C'est même une chose tellement glorieuse, quand on la regarde sous cet angle, qu'en comparaison la gloire de l'autre ministère n'existe même pas."
,"11":"Ce ministère était provisoire, aussi n'avait-il qu'un moment de gloire, mais l'autre était durable, et sa gloire également."
,"12":"Quelle espérance! Et quelle assurance elle nous donne!"
,"13":"Ce n'est pas comme Moïse qui se couvrait la figure d'un voile pour que les Israélites ne voient pas le moment où sa gloire allait s'effacer."
,"14":"Voyez: ils n'ont toujours pas compris. Aujourd'hui encore ce voile leur cache le sens de l'ancienne alliance et personne ne leur montre que dans le Christ elle a été annulée."
,"15":"Et jusqu'à ce jour, quand on leur fait la lecture de Moïse, le voile est là devant leurs yeux:"
,"16":"mais quand on se retourne vers le Seigneur, le voile est levé."
,"17":"Le Seigneur, c'est l'esprit. Et là où est l'esprit du Seigneur, c'est la liberté."
,"18":"Tous nous portons sur notre visage découvert les reflets de la gloire du Seigneur, de jour en jour plus resplendissants, et nous sommes transformés en son image, car il est le Maître de l'esprit."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Donc, nous avons reçu cette charge et, puisqu'on nous a fait cette grâce, nous ne nous laissons pas abattre."
,"2":"Bien plus, nous ne cachons pas ce qui paraît humiliant, nous n'y allons pas par quatre chemins, nous ne détournons pas la parole de Dieu. Nous mettons la vérité au grand jour, et c'est ce qui nous vaut l'estime de toute conscience humaine devant Dieu."
,"3":"Si malgré tout notre évangile reste voilé, disons qu'il est voilé pour ceux qui vont à leur perte;"
,"4":"ils refusent de croire et le dieu de ce monde a aveuglé leur esprit pour qu'ils ne puissent voir le rayonnement de l'Evangile du Christ glorieux qui est l'image même de Dieu."
,"5":"Car nous ne nous prêchons pas nous-mêmes: nous proclamons le Christ Jésus comme le Seigneur, et nous-mêmes nous sommes vos serviteurs, pour Jésus."
,"6":"Le même Dieu qui a dit: Que la lumière brille dans les ténèbres a aussi illuminé nos coeurs pour leur faire rayonner la connaissance de la gloire divine qui se voit sur la face du Christ."
,"7":"Mais nous portons ce trésor dans des vases de terre, pour que cette force extraordinaire ne semble pas venir de nous et reste l'affaire de Dieu."
,"8":"Constamment nous sommes mis à l'épreuve, mais jamais acculés; toujours avec des difficultés, mais jamais sans solution."
,"9":"On nous persécute, mais sans nous régler notre compte; nous sommes jetés à terre, mais non défaits."
,"10":"A tout moment nous portons dans notre corps la mort de Jésus, pour que la vie de Jésus se manifeste aussi dans notre personne."
,"11":"Car, si nous sommes des vivants, nous devons être livrés à la mort pour Jésus, afin que la vie de Jésus se manifeste dans notre corps mortel."
,"12":"Et en fin de compte, lorsque la mort travaille en nous, pour vous c'est la vie."
,"13":"Nous avons le même esprit de foi qui a fait écrire: J'ai cru et c'est pourquoi j'ai parlé. Oui, nous aussi nous croyons, et c'est pourquoi nous parlons;"
,"14":"et nous savons que celui qui a ressuscité Jésus, le Seigneur, nous ressuscitera aussi avec Jésus et nous placera, tout comme vous, à côté de lui."
,"15":"Oui, tout cela est pour vous: Les faveurs de Dieu vont se multiplier, et les actions de grâces aussi que tant de personnes rendront à Dieu pour sa plus grande gloire."
,"16":"Donc, nous ne nous laissons pas abattre, et si notre extérieur se défait peu à peu, l'homme intérieur en nous se renouvelle jour après jour."
,"17":"Il n'y a pas de comparaison entre ces petites épreuves passagères et le poids formidable de la gloire divine qu'elles nous préparent."
,"18":"Aussi ne faisons-nous pas attention à ce qui se voit mais à ce qui ne se voit pas; les choses visibles n'ont qu'un temps mais les invisibles sont pour toujours."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Nous le savons, si notre maison terrestre, il faudrait dire notre tente, vient à se démonter, Dieu nous réserve une habitation dans le ciel, une maison qui n'est pas faite de main d'homme et qui est pour toujours."
,"2":"Mais cela même fait naître en nous un désir insatisfait, car nous voudrions bien que notre demeure céleste vienne recouvrir l'actuelle."
,"3":"(En supposant que nous ayons encore celle-ci et ne soyons pas sans rien.)"
,"4":"Oui, tant que nous sommes sous notre tente, c'est pour nous un poids et une angoisse: nous ne voudrions pas qu'on nous en dépouille mais que l'autre vienne par dessus et que la vie vienne absorber ce qui est mortel."
,"5":"Et c'est Dieu qui nous a mis dans cette situation, lui qui nous a donné l'Esprit comme un premier acompte."
,"6":"Donc, quoi qu'il arrive, nous allons sans peur, sachant que vivre en ce corps, c'est être loin du Seigneur."
,"7":"C'est vivre avec la foi et non pas la vision."
,"8":"Aussi allons-nous jusqu'à penser qu'il serait meilleur de sortir de ce corps pour aller vivre auprès du Seigneur."
,"9":"En fait, ce qui nous importe, c'est de lui plaire, que nous restions ici ou que nous partions."
,"10":"Tous, d'ailleurs, nous devrons nous présenter devant le tribunal du Christ, et alors chacun retrouvera ce qu'il a fait, bien ou mal, avec son corps.."
,"11":"Portés par cette crainte du Seigneur dont nous avons l'expérience, nous essayons de convaincre les hommes et de ne rien cacher à Dieu. J'espère que vous aussi vous vous rendrez compte que nous ne cachons rien."
,"12":"Une fois encore, nous ne voulons pas nous recommander mais vous donner des arguments pour être fiers de nous, et pour répondre à ceux qui mettent leur fierté dans de pures apparences au lieu des réalités intérieures."
,"13":"Si nous exagérons, que Dieu seul écoute; si nous paraissons bien dire, prenez-le pour vous."
,"14":"L'amour du Christ nous obsède et nous disons: si lui est mort pour tous, nécessairement tous sont morts."
,"15":"Et il est mort pour tous afin que, s'ils vivent, ils ne vivent plus pour eux-mêmes, mais pour celui qui est mort et ressuscité pour eux."
,"16":"Aussi nous ne considérons plus les gens selon les critères humains; même le Christ, si nous l'avons connu dans son existence humaine, nous ne devons plus le connaître ainsi."
,"17":"Toute personne qui est dans le Christ est une création nouvelle. Ce qui était est du passé: le neuf est arrivé."
,"18":"Et tout cela, c'est l'oeuvre de Dieu qui nous a réconciliés avec lui par le Christ et qui, à nous-mêmes, nous confie l'oeuvre de la réconciliation."
,"19":"Dans le Christ, Dieu réconciliait le monde avec lui-même et ne tenait plus les comptes de leurs fautes. Et il nous a confié le message de réconciliation."
,"20":"Oui, nous sommes les ambassadeurs du Christ, et à travers nous c'est Dieu qui appelle. Nous supplions au nom du Christ: Laissez-vous réconcilier avec Dieu!"
,"21":"Pour nous il a identifié avec le péché celui qui ne connaissait pas le péché, afin que nous devenions en lui justice et sainteté de Dieu."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Nous travaillons avec lui dans ce sens, et nous vous demandons de ne pas recevoir inutilement la grâce de Dieu."
,"2":"Vous savez qu'il dit: Je t'écoute quand c'est le moment, je viens à ton aide au jour du salut. Et c'est maintenant le moment opportun; le jour du salut, c'est maintenant."
,"3":"Nous évitons tout ce qui pourrait donner un prétexte pour critiquer notre ministère,"
,"4":"et de mille manières nous nous présentons comme des intendants de Dieu. C'est l'endurance, ce sont les épreuves, les privations, les situations impossibles,"
,"5":"les coups, les arrestations, les oppositions violentes, les travaux, les veilles, les jeûnes."
,"6":"C'est la pureté, la connaissance, la largeur d'esprit, la bonté; c'est l'esprit saint et la charité sincère,"
,"7":"la parole vraie, la puissance de Dieu; ce sont les armes offensives et défensives de la justice et de la sainteté."
,"8":"On nous honore, mais aussi on nous insulte; les uns nous calomnient et les autres disent du bien de nous. On nous traite de charlatans quand nous disons la vérité;"
,"9":"on ne nous connaît pas alors que tous nous reconnaissent; on nous voit déjà morts, mais voilà, nous vivons. Nous ne cessons de recevoir des coups mais nous ne mourons pas."
,"10":"Les peines se succèdent, mais nous restons joyeux. Nous sommes pauvres et nous faisons beaucoup de riches; nous n'avons rien, mais nous possédons tout."
,"11":"Corinthiens, je vous parle avec franchise et mon coeur vous est grand ouvert."
,"12":"Vous n'y êtes pas dans un recoin, mais c'est chez vous que tout est étroit."
,"13":"Payez-moi de retour: je vous parle comme à mes enfants, et soyez plus ouverts."
,"14":"Pas d'alliance contre nature avec ceux qui ne croient pas. Peut-on associer le péché et la vie sainte? Peut-on unir la lumière et les ténèbres?"
,"15":"Le Christ va-t-il parler comme Béliar et l'incroyant partager le sort de celui qui croit?"
,"16":"Voudriez-vous installer des idoles dans le Temple de Dieu?,Mais vous êtes un temple du Dieu vivant. Dieu l'a dit: J'habiterai et je circulerai au milieu d'eux; je serai leur Dieu et ils seront mon peuple. "
,"17":"Dans ces conditions, Sortez du milieu de ce peuple, dit le Seigneur, restez à part; et ne touchez rien qui puisse vous souiller si vous voulez m'être agréables."
,"18":"Alors je serai pour vous un Père et vous serez pour moi des fils et des filles, dit le Seigneur, Maître de l'Univers."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Avec de telles promesses, mes bien-aimés, il faut nous purifier de toutes impuretés de corps et d'esprit et mener à bien notre sanctification dans la crainte de Dieu."
,"2":"Réservez-nous une place chez vous. Nous n'avons fait de tort à personne; nous n'avons méprisé personne, nous n'avons profité de personne."
,"3":"Je ne vous accuse pas: je vous ai déjà dit que vous êtes dans notre coeur jusqu'à vivre et mourir ensemble."
,"4":"Je sais que je peux compter sur vous et je suis fier de vous; j'en suis très réconforté et c'est pour moi une grande joie dans mes épreuves."
,"5":"Voilà donc qu'en arrivant en Macédoine nous n'avons eu aucun répit sur le plan humain, avec des épreuves de toutes sortes: au-dehors, des affrontements, et en nous-mêmes des craintes."
,"6":"Mais Dieu qui réconforte les humbles nous a réconfortés avec l'arrivée de Tite."
,"7":"Non seulement à cause de sa présence, mais aussi parce que vous l'aviez grandement réconforté. Il nous a dit combien vous m'étiez attachés, et votre regret, et votre indignation pour ce qui me touchait, de sorte que j'en étais tout joyeux. "
,"8":"Et si je vous ai fait de la peine avec ma lettre, je ne le regrette pas. J'aurais pu la regretter car je vois que cette lettre vous a fait de la peine pendant un moment."
,"9":"Mais maintenant je suis heureux, non de votre peine, mais parce que cette peine vous a amenés à la repentance. Votre peine était selon Dieu, de sorte que vous n'avez rien perdu par notre faute. "
,"10":"Quand la peine est selon Dieu, elle amène le repentir et produit une oeuvre de salut qui ne se perdra pas; au contraire, si la peine est selon le monde, elle fait une oeuvre de mort."
,"11":"Votre tristesse était bien selon Dieu, à voir ce qu'elle a produit: votre empressement pour prendre ma défense, votre indignation, vos craintes, vos exigences, votre volonté de faire justice. On a vraiment pu voir que vous étiez innocents en cette affaire."
,"12":"Aussi bien, en vous écrivant, je ne pensais pas d'abord à celui qui a mal agi ni à celui qui a été offensé; c'était pour que vous montriez l'attachement que vous avez pour moi, et que vous en preniez conscience devant Dieu."
,"13":"Donc je me suis senti bien réconforté. Outre ce réconfort, c'était une grande joie pour moi de voir Tite si content, car vous tous l'aviez tranquillisé. "
,"14":"Je m'étais montré assez fier de vous devant lui et je ne l'ai pas regretté. De même que je ne vous avais pas menti, cette fierté non plus et ce que j'avais dit à Tite à propos de vous n'était pas faux."
,"15":"Et il vous reste très attaché quand il se rappelle votre obéissance à tous et comment vous l'avez reçu avec 'crainte et tremblement'."
,"16":"Je suis vraiment heureux de pouvoir ainsi compter sur vous."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Frères, nous voulons vous informer d'une initiative généreuse que Dieu a fait naître dans les Eglises de Macédoine."
,"2":"Au moment même où ils étaient sérieusement mis à l'épreuve, leur joie n'a pas diminué et leur profonde pauvreté n'a fait qu'enrichir leur totale disponibilité."
,"3":"Spontanément, selon leurs moyens et, je peux le dire, au-delà de leur moyens,"
,"4":"ils nous ont rappelé avec beaucoup d'insistance cette initiative généreuse et ce partage qu'est le service d'aide à nos frères de Jérusalem."
,"5":"Ils ont dépassé notre attente, et Dieu a voulu qu'ils prennent l'initiative de s'offrir au Seigneur et à nous-mêmes."
,"6":"Nous avons donc demandé à Tite, puisqu'il a déjà traité avec vous, de mener à bien chez vous cette initiative généreuse."
,"7":"Puisque vous êtes doués pour tout: la foi, la parole, la connaissance, la présence active, - sans parler de l'amour que vous avez pour moi -, entrez également à fond dans cette initiative généreuse."
,"8":"Ce n'est pas un ordre que je vous donne; mais je profite de l'empressement des autres pour mettre à l'épreuve le sérieux de votre amour."
,"9":"Vous savez ce qu'a été la générosité de notre Seigneur Jésus Christ. Lui qui était riche, il s'est fait pauvre pour vous, pour que vous soyez riches au prix de sa pauvreté."
,"10":"Et je vous fais une remarque: vous ne pouvez faire autrement puisque c'est vous qui avez commencé et même qui avez pris la décision l'an passé."
,"11":"Maintenant il faut passer aux actes; quand on a décidé avec enthousiasme, on doit réaliser selon ses moyens."
,"12":"Si l'enthousiasme est là, on sera remercié tenant compte de ce qu'on a et non de ce qu'on n'a pas."
,"13":"Il ne s'agit pas que les autres soient soulagés et vous dans la gêne,"
,"14":"mais qu'il y ait égalité. Sur ce point, ce que vous avez en plus comblera ce qui leur manque, et d'un autre côté, ce dont ils sont riches comblera vos manques; ainsi vous serez à égalité."
,"15":"Il est écrit: Celui qui avait beaucoup n'avait pas de trop, et celui qui avait peu avait assez."
,"16":"Remerciez Dieu de ce qu'il a donné à Tite le même intérêt à votre égard."
,"17":"Aussitôt reçue cette invitation, il est parti vers vous sans hésiter et très spontanément."
,"18":"Avec lui nous avons envoyé un frère dont les mérites comme évangéliste sont reconnus par toutes les Eglises."
,"19":"Ce n'est pas tout: les Eglises l'ont désigné pour voyager avec nous et porter cette aide que nous entendons mener à bien, pour la gloire de Dieu autant que par conviction personnelle."
,"20":"Nous l'avons disposé ainsi pour que personne n'ait de soupçons sur de telles sommes que nous devons administrer."
,"21":"Nous voulons que les choses soient correctes devant Dieu et devant les hommes."
,"22":"C'est pourquoi nous avons aussi envoyé avec eux un frère dont nous avons éprouvé très souvent la disponibilité sur tous les plans; et maintenant il est encore mieux disposé car il a toute confiance en vous."
,"23":"Voilà donc Tite, mon compagnon et mon collaborateur pour ce qui vous touche; et vous avez nos frères, apôtres des Eglises, qui sont la gloire du Christ."
,"24":"Vous leur donnerez, et à toutes les Eglises, la preuve de votre charité, et vous justifierez tout le bien que je dis de vous."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Je n'ai pas besoin de vous écrire longuement au sujet du service d'aide aux saints, à nos frères."
,"2":"Je sais vos bonnes dispositions et j'ai fait votre éloge chez les Macédoniens, disant que ceux d'Achaïe étaient prêts depuis longtemps. Et votre élan a stimulé beaucoup d'entre eux."
,"3":"Maintenant j'ai envoyé ces frères pour qu'on vous trouve prêts comme je l'ai affirmé; il ne faudrait pas démentir le bien que j'ai dit de vous sur ce point."
,"4":"Imaginez que les Macédoniens viennent avec moi et ne vous trouvent pas prêts: quelle honte pour moi et aussi pour vous!"
,"5":"Il m'a donc paru nécessaire de dire à ces frères qu'ils me précèdent chez vous pour organiser cette oeuvre bénie dont nous avons parlé. Car il faut la préparer comme une largesse et non comme une aumône."
,"6":"Une chose est sûre: celui qui sème pauvrement fera une pauvre récolte. Celui qui sème largement fera une grande récolte."
,"7":"Que chacun donc décide personnellement, sans contrainte et sans regret, car Dieu aime celui qui donne joyeusement."
,"8":"Et Dieu est capable de vous bénir de mille manières, de sorte que vous ne manquiez jamais de rien et puissiez multiplier vos bonnes oeuvres,"
,"9":"comme dit l'Ecriture: Il a donné de tous les côtés à ceux qui avaient faim; ses mérites sont là pour toujours."
,"10":"Celui qui procure au semeur la semence, et ensuite le pain qu'il mange, vous procurera la semence et la multipliera; et il fera croître ces rejetons de vos vertus."
,"11":"Soyez riches de tout pour donner sans compter, et nous en ferons une action de grâces à Dieu."
,"12":"Car ce service d'entraide fera plus que soulager la pauvreté des saints: il fera monter vers Dieu de nombreuses actions de grâces."
,"13":"Ce service leur sera une preuve: ils rendront grâces à Dieu parce que vous obéissez à la foi selon l'Evangile du Christ et parce que vous partagez sans compter avec eux et avec tous."
,"14":"Ils vous sauront gré de ce que la grâce de Dieu a agi en vous, et ils prieront pour vous."
,"15":"Que Dieu soit béni pour ce don plus grand qu'on ne saurait dire."
}`)
	CurrentBook.AddChapter(10, `{
"1":"C'est moi, Paul, qui vous supplie au nom de la bonté et l'esprit de compréhension du Christ, moi si humble au milieu de vous, et autoritaire, dit-on, quand je suis loin."
,"2":"Que je n'aie pas à faire preuve d'autorité quand je serai là, comme je compte faire et comme j'oserai faire avec quelques-uns qui croient que nous agissons de façon tout humaine."
,"3":"Humaine est notre condition, mais non la façon de combattre."
,"4":"Nos armes pour ce combat ne sont pas humaines: elles ont la force de Dieu pour détruire les forteresses - tous ces raisonnements"
,"5":"et cet orgueil qui se dressent contre la connaissance de Dieu. Elles désarment les prétentions de l'esprit et les font obéir au Christ,"
,"6":"et nous sommes disposés à condamner toute rébellion dès que votre obéissance sera assurée."
,"7":"Regardez les choses en face. Si quelqu'un croit appartenir au Christ, qu'il pense que nous sommes au Christ tout comme lui."
,"8":"Et même si je rappellle un peu trop mon autorité, que le Seigneur m'a donnée pour construire et non pour détruire, je n'aurai pas à m'en repentir."
,"9":"Vraiment, je ne serais capable que de vous écrire pour vous effrayer?"
,"10":"Certains disent: 'Ses lettres sont dures et sévères, mais quand il est ici, il n'a pas de présence et ce n'est pas un orateur.'"
,"11":"Que ces gens-là sachent que ce que j'écris de loin, je le ferai quand je serai là."
,"12":"Vraiment, je n'oserais pas me regarder ni me comparer avec ces gens qui se mettent si bien en valeur. Le malheur, c'est qu'ils se prennent toujours pour modèle et se comparent à leur propre image."
,"13":"Mais nous, quand nous rappelons notre autorité, nous n'exagérons pas parce que nous prenons pour référence celle-là même que le Seigneur nous a donnée en nous faisant arriver jusque chez vous."
,"14":"Nous ne sommes pas de ceux qui n'ont pas su arriver! Nous intervenons chez vous parce que c'est nous qui sommes allés vous chercher avec l'Evangile du Christ."
,"15":"Nous n'arrivons pas avec des prétentions excessives là où d'autres ont fait le travail, et quand votre foi aura grandi, nous espérons bien grandir nous-mêmes grâce à vous selon notre propre règle."
,"16":"Je veux dire que nous irons évangéliser plus loin que chez vous au lieu de faire les malins là où tout est déjà préparé, ce qui est la règle des autres."
,"17":"Celui qui veut faire le fier, qu'il mette sa fierté dans le Seigneur."
,"18":"Car celui qui vaut, ce n'est pas celui qui se recommande lui-même, mais celui que le Seigneur recommande."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Pouvez-vous supporter un peu de folie de ma part? Eh bien laissez-moi dire."
,"2":"Avec vous je deviens jaloux, et c'est une jalousie de Dieu. Car vous êtes la jeune fille vierge et pure que j'ai fiancée à son unique époux: je vous ai offerts au Christ."
,"3":"Et voilà ma crainte: le même serpent astucieux qui a séduit Eve pourrait aussi détourner vos esprits et vous faire perdre la simplicité du Christ."
,"4":"Voilà qu'on vient vous prêcher un Jésus différent de celui que nous avons prêché, on vous fait prendre un esprit que vous n'aviez pas reçu et un évangile qui n'est pas celui que vous aviez accepté, et vous le prenez très bien!"
,"5":"Pourtant je crois n'être inférieur en rien à ces super-apôtres."
,"6":"Je suis bien ordinaire pour le beau langage, mais pas pour la connaissance, comme je vous l'ai montré de bien des façons, en toutes circonstances."
,"7":"Peut-être mon péché a-t-il été de me mettre plus bas pour que vous soyez plus haut: je vous ai donné l'Evangile de Dieu et vous n'avez pas eu à payer."
,"8":"J'ai demandé de l'argent à d'autres Eglises et elles m'ont aidé pour que je sois à votre service."
,"9":"Quand chez vous j'ai manqué de quelque chose, je n'ai fait pression sur personne: ce sont des frères venus de Macédoine qui m'ont donné le nécessaire. Je me suis bien gardé de vous être à charge, et je veux m'en garder."
,"10":"Aussi vrai que le Christ est en moi, personne ne pourra me lancer un défi sur ce point dans le secteur d'Achaïe."
,"11":"Pourquoi? Parce que je ne vous aime pas? Dieu seul sait comment."
,"12":"Mais je le fais et je le ferai pour enlever tout argument à ceux qui en cherchent; c'est là ma gloire et ils ne pourront pas me ressembler."
,"13":"En réalité ces gens sont de faux apôtres qui trompent leur monde et veulent apparaître comme des apôtres du Christ."
,"14":"Cela n'a rien d'étonnant: si Satan se déguise en ange de lumière,"
,"15":"il est normal que ses serviteurs se déguisent en serviteurs du bien. Mais leur fin sera celle que méritent leurs oeuvres."
,"16":"Je répète: ne me prenez pas pour un fou. Ou alors, acceptez que je le sois et que je chante un peu mes louanges."
,"17":"Je ne vais pas parler à la façon du Christ, car je ne peux pas chanter mes louanges sans que ce soit de la folie."
,"18":"Mais puisque tant de personnes font valoir leurs mérites à la façon des hommes, moi aussi je vais le faire."
,"19":"D'ailleurs vous, si intelligents, vous supportez facilement les fous."
,"20":"Vous aimez être traités comme des esclaves, et être dévorés et volés et dépouillés, et qu'on vous crache à la figure."
,"21":"Nous, nous avons été trop faibles, et j'en suis presque honteux. Mais puisqu'ils sont si hardis, moi aussi je veux l'être - bien sûr ce sera de la folie."
,"22":"Ils sont Hébreux? Moi aussi. Ils sont Israélites? Moi aussi. Ils sont descendants d'Abraham? Moi aussi."
,"23":"Ils sont intendants du Christ? Je vais dire des bêtises: je le suis bien plus qu'eux. Le travail, j'en ai fait beaucoup plus; les prisons, j'y ai été davantage; les coups reçus: sans comparaison, et bien des fois j'ai frôlé la mort. "
,"24":"Cinq fois les Juifs m'ont fait donner les trente-neuf coups de fouet;"
,"25":"trois fois j'ai reçu la bastonnade, une fois j'ai été lapidé; trois fois j'ai fait naufrage, et j'ai surnagé un jour et une nuit entière."
,"26":"J'ai accumulé les fatigues de voyage, avec rivières dangereuses et périls des bandits, avec les complots de mes compatriotes aussi bien que des païens. Périls dans les cités, périls dans la solitude, périls sur mer, périls au milieu des faux-frères."
,"27":"J'ai connu le travail et l'épuisement, les veilles fréquentes, la faim et la soif, les jeûnes répétés, le froid et le manque de vêtements."
,"28":"Et en plus de tout cela, ce qui m'obsède chaque jour, le souci pour toutes les Eglises."
,"29":"Qui se laisse démonter sans que je le sois? Qui vient à tomber sans qu'un feu me dévore?"
,"30":"S'il faut se vanter, je me vanterai de ma faiblesse."
,"31":"Le Dieu et Père du Seigneur Jésus le sait bien, lui qui est béni pour tous les siècles: je ne mens pas."
,"32":"A Damas le ministre du roi Arétas avait fermé la ville de Damas pour me faire arrêter,"
,"33":"et c'est grâce à une corbeille au bout d'une corde qu'on m'a fait descendre de la muraille et que je lui ai échappé."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Faut-il se vanter? Bien que cela ne convienne pas, j'en viendrai aux visions et révélations du Seigneur."
,"2":"Je connais un Chrétien qui, il y a quatorze ans, a été enlevé jusqu'au troisième ciel. Etait-ce avec son corps? je ne le sais pas; était-ce sans son corps? je ne sais pas, Dieu seul le sait."
,"3":"Et je sais que ce quelqu'un - avec son corps ou sans son corps, je ne sais pas, Dieu seul le sait -"
,"4":"ce quelqu'un a été enlevé jusqu'au paradis et a entendu des paroles qui ne sont pas une voix et que personne ne saurait répéter."
,"5":"Je pourrais être fier en pensant à ce quelqu'un, mais pour moi je ne veux être fier que de mes faiblesses."
,"6":"Si je voulais me vanter, ce ne serait pas folie, car je dirais la vérité. Mais je m'abstiens de peur qu'on ne me mette plus haut que ce qu'on peut voir et entendre de moi."
,"7":"Et pour que je ne me croie pas supérieur après de telles révélations, une épine a été plantée dans ma chair, un messager de Satan dont les gifles me gardent de tout orgueil."
,"8":"Trois fois j'ai demandé au Seigneur de m'en débarrasser,"
,"9":"mais il m'a dit: 'Ma grâce te suffit, c'est dans la faiblesse que la puissance donne toute sa mesure.',Aussi je me sens bien plus assuré dans mes faiblesses, car alors je suis couvert par la force du Christ. "
,"10":"Et j'accueille volontiers faiblesses, humiliations, nécessités, persécutions et angoisses, si c'est pour le Christ, parce que, si je me sens faible, je suis fort."
,"11":"J'ai dit des bêtises, mais vous m'y avez obligé. C'est vous qui deviez faire mon éloge, car même si je ne suis rien, je n'ai rien de moins que les super-apôtres."
,"12":"Vous avez pu voir chez vous toutes les caractéristiques d'un apôtre: endurance, signes, prodiges et pouvoirs de Dieu."
,"13":"Qu'avez-vous eu de moins que les autres Eglises? Une seule chose: je ne vous ai rien demandé. Pardonnez-moi cette faute."
,"14":"C'est maintenant la troisième fois que je m'apprête à aller chez vous, et ce ne sera encore pas pour me faire servir. Ce ne sont sûrement pas vos biens que je veux, mais vous-mêmes; car c'est la régle: ce sont les parents qui travaillent pour leurs enfants, et non les enfants pour leurs parents."
,"15":"Et volontiers je dépenserai, et je me dépenserai jusqu'au bout pour vos personnes: si je vous aime davantage, serai-je moins aimé?"
,"16":"Une chose encore: peut-être ne vous ai-je pas été à charge mais c'était une astuce pour mieux tirer profit de vous?"
,"17":"Alors dites, qui vous a pressurés parmi ceux que je vous ai envoyés?"
,"18":"J'ai appelé Tite pour qu'il aille vous voir, et j'ai envoyé avec lui un autre frère. Est-ce que Tite vous a pressurés? N'avons-nous pas agi avec le même esprit et procédé de la même façon?"
,"19":"Peut-être penserez-vous encore une fois que nous cherchons à nous justifier. Mais non, c'est devant Dieu que nous parlons, et selon le Christ; et tout cela, frères, c'est pour votre bien."
,"20":"J'ai peur qu'à mon passage je ne vous trouve pas tels que je voudrais, et que vous non plus ne me trouviez pas comme vous voudriez. Ne verrai-je pas rivalités, jalousies, emportement, querelles, dénonciations, critique, arrogance, insoumission?"
,"21":"Peut-être à mon passage mon Dieu voudra-t-il m'humilier une fois de plus à cause de vous, et je devrai me lamenter pour tant de pécheurs qui ne se sont pas repentis de leur impureté passée, de leur vie licencieuse et des horreurs qu'ils commettaient."
}`)
	CurrentBook.AddChapter(13, `{
"1":"C'est la troisième fois que je vais chez vous et toute affaire se réglera par le dire de deux ou trois témoins."
,"2":"Je vous ai dit, et maintenant même je le redis comme je l'ai fait lors de ma seconde visite - je dis à ceux qui ont vécu dans le péché aussi bien qu'aux autres: quand je repasserai, je serai sans pitié,"
,"3":"et vous aurez la preuve que le Christ parle à travers moi. Avec vous il n'est pas faible, il est même très fort chez vous."
,"4":"Sa faiblesse l'a mené à la croix, mais il est vivant par la force de Dieu. De même, nous aussi nous partageons sa faiblesse, mais nous serons bien vivants avec lui par la force de Dieu qui vient à vous."
,"5":"Examinez-vous et voyez si vous êtes réellement dans la foi. Reconnaissez-vous que le Christ Jésus est en vous? Et si vous étiez réprouvés?"
,"6":"Vous reconnaîtrez au moins, je l'espère, que nous, nous ne sommes pas réprouvés."
,"7":"Si nous demandons à Dieu que vous ne fassiez rien de mal, ce n'est pas pour que nous-mêmes soyons bien jugés. Nous préférons que vous fassiez le bien, même si cela nous met en tort."
,"8":"Car nous n'avons aucun pouvoir contre la vérité, nous sommes au service de la vérité."
,"9":"Et nous sommes heureux d'être faibles si avec cela vous êtes forts. Donc, ce que nous demandons, c'est votre perfection."
,"10":"C'est pour cela que je vous écris d'ici pour n'avoir pas à me montrer sévère quand je serai chez vous, avec l'autorité que le Seigneur m'a donnée pour construire et non pour détruire."
,"11":"Finalement, frères, réjouissez-vous, faites des progrès, ayez bon courage, mettez-vous d'accord, vivez en paix, et le Dieu de l'amour et de la paix sera avec vous."
,"12":"Saluez-vous les uns les autres avec un saint baiser. Tous les saints vous saluent."
,"13":"Que la grâce du Seigneur Jésus Christ, l'amour de Dieu et la communion de l'Esprit Saint soient avec vous tous."
}`)

}
func FR_LBDCC_LoadNP2EChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Lettre de Paul, Silvain et Timothée, à l'Eglise des Thessaloniciens rassemblée en Dieu le Père et en Jésus Christ, le Seigneur."
,"2":"Recevez grâce et paix de Dieu le Père et de Jésus Christ, le Seigneur!"
,"3":"Frères, nous devons rendre grâces à Dieu pour vous à tout moment. Rien de plus juste, car votre foi va grandissant et chacun d'entre vous est plus généreux dans l'amour mutuel."
,"4":"Aussi sommes-nous fiers de vous dans les Eglises de Dieu quand nous parlons de votre persévérance et de votre foi au milieu de toutes ces épreuves et persécutions que vous supportez."
,"5":"Elles sont une forme concrète du juste jugement de Dieu, car ainsi vous devenez dignes du Royaume de Dieu en souffrant pour lui."
,"6":"Mais il sera juste aussi que Dieu fasse souffrir ceux qui vous font souffrir"
,"7":"et qu'il mette à l'aise les persécutés, c'est-à-dire vous, aussi bien que nous, quand Jésus Christ se manifestera et viendra du Ciel escorté par ses anges."
,"8":"Alors le feu ardent fera justice de ceux qui ne reconnaissent pas Dieu et qui ne se soumettent pas à l'Evangile de notre Seigneur Jésus."
,"9":"Leur sentence sera la perdition éternelle loin du visage du Seigneur et de sa Gloire irrésistible."
,"10":"Il viendra en ce jour-là pour qu'on lui rende gloire en la personne de ses saints et qu'on admire ses merveilles en tous les croyants, en vous bien entendu, qui avez cru à notre témoignage."
,"11":"Nous pensons à tout cela lorsque continuellement nous le prions pour vous: qu'il vous rende dignes de cet appel de notre Dieu; qu'il agisse avec force pour mener à bien vos projets généreux et rendre efficace le travail de votre foi,"
,"12":"de sorte que le nom de Jésus, notre Seigneur, soit glorifié en vous et vous en lui, par la bonté de notre Dieu et du Seigneur Jésus."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Frères, parlons de cette venue du Seigneur Jésus Christ et de notre rassemblement autour de lui."
,"2":"Nous vous supplions de ne pas perdre la tête si facilement et de ne pas vous affoler pour quelque manifestation de l'Esprit ou à cause d'une parole ou d'une lettre qu'on dit venir de nous, comme si le jour du Seigneur était imminent."
,"3":"Ne vous laissez pas égarer, de quelque façon que ce soit. Il faudrait d'abord que se produise l'apostasie et que se manifeste celui qui refuse Dieu, l'instrument du mal,"
,"4":"celui qui contredit et qui se met au-dessus de tout ce qu'on considère divin et sacré. Et il ira s'asseoir dans le Temple de Dieu pour montrer que Dieu, c'est lui."
,"5":"Ne vous rappelez-vous pas que je vous le disais quand j'étais avec vous?"
,"6":"Et maintenant vous savez ce qui le retient jusqu'au moment où il doit se faire connaître."
,"7":"Ce soulèvement antireligieux travaille déjà en secret, mais il faut que disparaisse celui qui le retient."
,"8":"Alors se fera connaître l'adversaire de la religion, que le Seigneur doit balayer de son souffle. Et il le jettera à terre quand lui aussi viendra et se montrera."
,"9":"L'autre doit se présenter avec la puissance de Satan; il fera des miracles, des signes, et des prodiges de mensonge"
,"10":"pour égarer et pervertir ceux qui vont à leur perte, tous ceux chez qui l'amour de la vérité n'a pas trouvé place - et ils auraient été sauvés!"
,"11":"C'est bien pourquoi Dieu leur adresse ces forces de mensonge, et ils croiront au mensonge."
,"12":"Ainsi seront punis ceux qui n'ont pas cru à la vérité parce que le mal leur plaisait."
,"13":"Mais pour vous, nous devons rendre sans cesse à Dieu des actions de grâces. Oui, frères bien-aimés du Seigneur, Dieu vous a choisis pour être les premiers de ceux qu'il sauve grâce à la vraie foi et à l'Esprit qui sanctifie."
,"14":"Aussi vous a-t-il appelés par le moyen de notre Evangile pour que la gloire de Jésus Christ, notre Seigneur, devienne vôtre."
,"15":"Alors, frères, tenez bon et gardez fermement les traditions que nous vous avons enseignées de vive voix ou par lettre."
,"16":"Et puis je fais appel à Jésus Christ notre Seigneur, et à Dieu notre Père qui nous a aimés et qui nous a donné le réconfort sans fin avec l'espérance qui ne trompe pas:"
,"17":"il vous soutiendra avec bonté pour que vous restiez fermes dans le bien, dans vos paroles et dans vos actes."
}`)
	CurrentBook.AddChapter(3, `{
"1":"A part cela, frères, priez pour nous. Que la Parole de Dieu continue sa course et gagne le prix, comme c'est arrivé chez vous,"
,"2":"et que nous puissions échapper aux individus indésirables et mauvais, car tous ne croient pas."
,"3":"Le Seigneur est fidèle: il vous affermira et vous gardera du Mauvais."
,"4":"Nous sommes persuadés dans le Seigneur, que vous faites et ferez tout ce que nous vous disons."
,"5":"Que le Seigneur maintienne vos coeurs tournés vers l'amour de Dieu et la capacité de souffrir du Christ!"
,"6":"Frères, nous insistons auprès de vous au nom de Jésus Christ, le Seigneur: si un des frères vit de façon indisciplinée et ne se soumet pas aux traditions que vous avez reçues de nous, séparez-vous de lui."
,"7":"Vous savez comment nous imiter; au milieu de vous nous ne vivions pas sans règle."
,"8":"Nous ne nous sommes pas fait nourrir gratuitement: nous avons travaillé de jour et de nuit avec peines et fatigues pour n'être à la charge d'aucun de vous."
,"9":"Nous en aurions eu le droit, mais nous voulions rester pour vous le modèle à imiter."
,"10":"Et quand nous étions parmi vous, nous vous avons dit: celui qui ne veut pas travailler, qu'il ne mange pas."
,"11":"Mais voilà ce que nous apprenons: il y en a parmi vous qui vivent de façon désordonnée et qui, au lieu de travailler, se mêlent des affaires des autres."
,"12":"Nous avertissons ces gens-là et nous faisons appel à eux au nom du Seigneur Jésus: qu'ils travaillent de façon stable et gagnent leur pain."
,"13":"Et vous, frères, ne vous lassez pas de faire le bien."
,"14":"Si quelqu'un n'écoute pas ce que nous disons dans cette lettre, donnez-lui un avertissement et cessez de le fréquenter pour lui faire honte."
,"15":"Ne le traitez pas en ennemi, mais reprenez-le comme un frère."
,"16":"Que le Seigneur de la paix vous donne la paix en tout temps et partout. Que le Seigneur soit avec vous tous!"
,"17":"La salutation finale est de ma propre main à moi, Paul: c'est mon signe de reconnaissance dans toutes mes lettres; c'est mon écriture."
,"18":"Que la grâce de Jésus Christ, notre Seigneur, soit avec vous tous."
}`)

}
func FR_LBDCC_LoadNP2IChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Lettre de Paul, apôtre du Christ Jésus par une décision de Dieu, pour annoncer la vie qui se trouve dans le Christ Jésus:"
,"2":"Timothée, mon cher enfant, reçois de Dieu le Père et du Christ Jésus, notre Seigneur, la grâce, la miséricorde et la paix!"
,"3":"Tu es toujours présent, jour et nuit, dans mes prières, et pour toi je rends grâces à Dieu que je sers en toute sincérité comme l'ont fait mes pères."
,"4":"Quand je me rappelle tes larmes j'ai hâte de te voir, car cela me remplirait de joie."
,"5":"Je me rappelle ta foi sincère, qu'on trouvait déjà chez ta grand-mère Loïs et ta mère Eunice, et que tu as toi aussi, j'en suis sûr."
,"6":"Et c'est la raison pour laquelle je veux réveiller et raviver le don de Dieu que tu as reçu quand je t'ai imposé les mains."
,"7":"L'esprit que Dieu nous a donné n'est pas timidité, mais force, amour et maîtrise de soi."
,"8":"Donc ne rougis pas du martyre de notre Seigneur ni de moi quand je suis en prison pour lui. Sois capable de souffrir pour l'Evangile avec la force de Dieu."
,"9":"Ils nous a sauvés, nous appelant pour une sainte vocation, non pas à cause de nos mérites, mais gratuitement et par décision personnelle. Cette décision, prise en Jésus Christ de toute éternité,"
,"10":"vient de se manifester avec l'apparition de Jésus Christ, notre Sauveur, qui a détruit la mort et fait resplendir la vie dans l'immortalité grâce à l'Evangile."
,"11":"C'est de cela que je suis le prédicateur, l'apôtre et le maître."
,"12":"C'est pour cela aussi que je souffre à présent, mais je n'en ai pas honte, car je sais à qui j'ai fait confiance, et je le sais capable de me garder mon dépôt jusqu'au grand jour."
,"13":"Prends comme règle les saines paroles que tu m'as entendu dire sur la foi et l'amour selon Jésus Christ,"
,"14":"et garde ce précieux dépôt grâce à l'Esprit Saint qui habite en nous."
,"15":"Tu dois savoir que tous ceux d'Asie m'ont tourné le dos, et parmi eux Phygèle et Hermogène."
,"16":"Que le Seigneur se montre généreux avec la famille d'Onésiphore, car il n'a pas eu honte de venir bien des fois à la prison pour m'encourager."
,"17":"Dès qu'il est arrivé à Rome, il m'a cherché partout et il m'a trouvé."
,"18":"Que le Seigneur lui donne de trouver grâce devant lui quand viendra le jour; tu sais mieux que moi tout le service qu'il a accompli à Ephèse."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Quant à toi, mon enfant, que l'amour qui est dans le Christ Jésus devienne ta force."
,"2":"Transmets à des gens sûrs et capables d'enseigner les autres ce que tu tiens de moi à travers bien des témoins."
,"3":"Fais face aux difficultés comme un bon soldat du Christ Jésus."
,"4":"Celui qui s'engage dans l'armée cherche à donner satisfaction à son chef et oublie les autres moyens de gagner sa vie."
,"5":"Dans le sport, on ne reçoit le prix que si on a lutté selon les règles."
,"6":"Ecoute encore ceci: celui qui travaille la terre doit être le premier à en recevoir les fruits."
,"7":"Essaye de comprendre ce que je veux dire; le Seigneur sûrement te fera tout comprendre."
,"8":"Souviens-toi de Jésus Christ, né de la race de David et ressuscité d'entre les morts selon mon évangile."
,"9":"C'est pour lui que je souffre, y compris la prison, comme un malfaiteur; mais la parole de Dieu n'est pas enchaînée."
,"10":"Et je supporte tout cela pour les élus de Dieu, pour qu'eux aussi obtiennent le salut déposé en Jésus Christ, et la gloire éternelle."
,"11":"Une chose est sûre: si nous souffrons avec lui, avec lui nous vivrons;"
,"12":"si nous supportons avec lui, avec lui nous serons rois; si nous le renions, lui aussi nous reniera;"
,"13":"si nous ne croyons pas, lui reste digne de foi, car il ne peut pas se renier lui-même."
,"14":"Voilà ce que tu dois leur rappeler, et tu leur demanderas au nom de Dieu de ne pas se battre pour des mots. Cela ne sert à rien d'autre qu'à déconcerter les auditeurs."
,"15":"Fais en sorte que le Seigneur trouve en toi un serviteur éprouvé, un travailleur irréprochable, un bon distributeur de la parole de vérité."
,"16":"Et laisse de côté les histoires plus sottes que religieuses; elles ne font que nuire à la religion, et tu vois que les doctrines de ce genre se propagent comme la gangrène."
,"17":"C'est le cas d'Hyménée et Philète qui ont dévié de la vérité;"
,"18":"ils disent que la résurrection a déjà eu lieu, et ils ont retourné la foi de plusieurs personnes."
,"19":"De toute façon, les fondations posées par Dieu restent fermes; on y lit cette inscription: Le Seigneur connaît ceux qui sont à lui; et encore: Rejetez l'injustice, vous tous qui invoquez le nom du Seigneur."
,"20":"Dans une grande maison il n'y a pas seulement des vases d'or et d'argent, mais aussi d'autres en bois et en terre cuite. Les premiers, on les apprécie, mais pas les autres."
,"21":"De même, si quelqu'un se garde de tout cela, il sera comme le vase qu'on apprécie; il sera saint, agréable à son maître, et prêt pour toute oeuvre utile."
,"22":"Ne suis pas les jeunes dans les passions de leur âge. Recherche la sainteté, la foi, l'amour, et vis en bonne relation avec ceux qui invoquent le Seigneur avec un coeur pur."
,"23":"Mais évite les discussions stupides et sans logique, sachant qu'elles amènent des querelles."
,"24":"Le serviteur du Seigneur ne doit pas être querelleur mais accueillant pour tous. Il doit avoir de la pédagogie, être patient devant les oppositions"
,"25":"et reprendre avec douceur les adversaires, car peut-être le Seigneur les fera changer et ils reconnaîtront la vérité."
,"26":"Peut-être se dégageront-ils des filets du diable qui les conduisait à son gré."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Tu dois savoir que dans les derniers temps il y aura des moments difficiles."
,"2":"Les gens seront égoïstes, amis de l'argent, vantards, orgueilleux, prêts à insulter, rebelles à leurs parents, ingrats, sacrilèges,"
,"3":"sans coeur, implacables, calomniateurs, débauchés, ennemis du bien,"
,"4":"traîtres, emportés, suffisants, amis du plaisir plus que de Dieu."
,"5":"Ils auront une apparence de religion alors qu'ils en ont renié l'essentiel. Garde-toi de tous ceux-là."
,"6":"Il y en a parmi eux qui savent s'introduire dans les maisons et aliènent de petites écervelées pleines de péchés, menées par toutes sortes de passions,"
,"7":"qui passent leur temps à apprendre et n'arrivent jamais à la connaissance de la vérité."
,"8":"De la même façon que Janès et Jambrès se sont opposés à Moïse, maintenant aussi ceux-là s'opposent à la vérité; ils ont l'esprit corrompu et leur foi ne vaut rien."
,"9":"Mais ils n'iront pas loin, car tout le monde se rendra compte de leur folie, comme c'est arrivé pour les deux autres."
,"10":"Toi, tu as suivi mon enseignement, ma façon de vivre et mes objectifs; tu connais ma foi, ma patience, ma charité, ma fermeté dans les épreuves."
,"11":"Tu as vu mes persécutions, mes souffrances, et tout ce qui m'est arrivé à Antioche, à Iconium, à Lystres. Combien de persécutions n'ai-je pas eu à endurer! Mais le Seigneur m'a délivré de tout."
,"12":"De même tous ceux qui veulent vivre selon Dieu dans le Christ Jésus seront persécutés."
,"13":"Quant aux gens pervers et aux charlatans, ils iront de pire en pire, les trompeurs comme les trompés."
,"14":"Mais toi, persévère dans ce que tu as appris et qqu'on t'a remis en dépôt, sachant de qui tu le tiens."
,"15":"D'ailleurs, depuis l'enfance tu connais les saintes Ecritures; elles sont capables de te donner la sagesse en vue du salut par la foi chrétienne."
,"16":"Tous les textes de l'Ecriture sont inspirés de Dieu et utiles pour enseigner, reprendre, redresser, éduquer saintement."
,"17":"C'est ainsi que l'homme de Dieu est équipé et préparé pour toute oeuvre utile."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Je te demande au nom de Dieu et du Christ Jésus qui doit venir juger les vivants et les morts - car il va se manifester et il régnera. Je te le demande:"
,"2":"proclame la Parole, insiste à temps et à contretemps, cherche des arguments, ordonne et encourage, toujours avec patience et pédagogie."
,"3":"Un temps viendra où les gens ne voudront plus de la saine doctrine; alors ils se trouveront des maîtres à leur goût qui sauront comment chatouiller leurs oreilles."
,"4":"Ils fermeront leurs oreilles à la vérité et s'intéresseront à des fables."
,"5":"Il te faut donc rester toujours en alerte. Ne ménage pas ta peine, fais ton travail d'évangéliste, remplis ton service."
,"6":"Pour moi, je suis déjà près de la fin et le moment de mon départ approche."
,"7":"J'ai fait un bon match, j'ai couru jusqu'au bout, j'ai gardé le dépôt qu'on m'avait confié."
,"8":"Maintenant j'attends la couronne de toute vie sainte que le Seigneur me donnera, lui le juste Juge, quand viendra son jour, et pas seulement à moi, mais aussi à tous les amis de sa venue glorieuse."
,"9":"Fais tout pour me rejoindre au plus tôt."
,"10":"Démas aimait ce monde, et il m'a laissé; il est rentré à Thessalonique. Crescens est parti en Galatie et Tite en Dalmacie."
,"11":"Seul Luc est avec moi. Prends Marc au passage car il me sera bien utile pour le ministère."
,"12":"J'ai envoyé Tychique à Ephèse."
,"13":"Quand tu viendras, apporte-moi le manteau que j'ai laissé à Troas chez Carpus, et aussi les livres, surtout les parchemins."
,"14":"Alexandre, le forgeron, m'a fait beaucoup de mal: Le Seigneur lui donnera ce que méritent ses oeuvres."
,"15":"Mais méfie-toi de lui car il contredit fortement ce que nous disons."
,"16":"La première fois que j'ai présenté ma défense, personne n'était avec moi, tous m'ont abandonné; que le Seigneur leur pardonne."
,"17":"Mais le Seigneur était avec moi, et il m'a donné la force pour que le message soit proclamé grâce à moi et que tous les peuples en aient connaissance. Et j'ai été sauvé de la gueule du lion."
,"18":"Le Seigneur me délivrera de tout mal et me sauvera, m'envoyant à son royaume du Ciel. A lui seul la gloire pour les siècles des siècles! Amen."
,"19":"Salue Prisca et Aquilas et la famille d'Onésifore."
,"20":"Eraste est resté à Corinthe, et j'ai laissé Trophime à Milet car il était malade."
,"21":"Dépêche-toi de venir avant l'hiver. Je t'envoie le salut d'Euboule et Pudens, de Linus, de Claudia et de tous les frères."
,"22":"Que le Seigneur soit avec ton esprit. Que la grâce soit avec vous tous."
}`)

}
func FR_LBDCC_LoadNPCLChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Paul, apôtre du Christ Jésus par la volonté de Dieu, et Timothée, votre frère,"
,"2":"saluent les saints et croyants qui sont à Colosses, leurs frères dans le Christ: recevez de Dieu notre Père la grâce et la paix!"
,"3":"A tout moment nous prions pour vous et nous rendons grâces à Dieu, Père de Jésus Christ, notre Seigneur,"
,"4":"car nous avons eu des nouvelles de votre foi et votre amour pour tous les saints, vos frères, dans le Christ Jésus;"
,"5":"et c'est le fruit de votre espérance, car vous savez ce qui vous est réservé dans les cieux. Vous l'avez appris de la parole de vérité, cet évangile "
,"6":"qui est arrivé jusqu'à vous. Partout dans le monde il s'étend et donne ses fruits comme on le voit chez vous, depuis le jour où vous avez appris et connu en toute vérité le don de Dieu."
,"7":"Vous l'avez appris d'Epaphras, notre cher compagnon de service, fidèle administrateur du Christ en notre nom."
,"8":"C'est lui, bien sûr, qui m'a donné des nouvelles de votre amour dans l'Esprit."
,"9":"Depuis le jour où nous l'avons su, nous ne cessons de prier pour vous, et nous demandons que vous ayez la pleine connaissance de la volonté de Dieu, grâce aux dons de sagesse et d'intelligence spirituelle;"
,"10":"que votre conduite soit digne du Seigneur et lui plaise; que vous sachiez porter du fruit: toutes vos bonnes actions, et progresser dans la connaissance de Dieu;"
,"11":"que vous deveniez forts dans tous les sens du mot, par l'effet de sa Gloire, pour supporter comme pour être patients, sans perdre la joie;"
,"12":"et que vous rendiez grâces au Père qui vous a rendus capables de partager l'Héritage avec les saints dans la lumière."
,"13":"Il nous a arrachés au pouvoir des Ténèbres, et nous a fait passer dans le royaume du Fils qu'il aime."
,"14":"En lui nous sommes rachetés et pardonnés de nos péchés."
,"15":"Il est l'image du Dieu qu'on ne peut voir, et pour toute créature il est le premier-né."
,"16":"Car en lui tout a été créé, dans les cieux et sur la terre, l'univers visible et invisible, Trônes, Seigneurs, Principautés, Autorités... Tout a été créé grâce à lui et pour lui,"
,"17":"il était là avant tous et tout se tient en lui."
,"18":"Il est aussi la tête du corps, de l'Eglise, car il est le principe, revenu le premier d'entre les morts, afin d'occuper, en tout, la première place."
,"19":"Car il a plu à Dieu que 'le tout' se retrouve en lui"
,"20":"et que tout soit réconcilié avec Dieu grâce à lui, après que le sang de sa croix ait rétabli la paix, ce qui est sur la terre, et ce qui est dans les cieux."
,"21":"Auparavant vous restiez à l'écart et vos oeuvres mauvaises faisaient de vous des opposants."
,"22":"Mais maintenant vous avez été réconciliés, grâce à la mort du Christ dans son être de chair, et vous êtes devant lui saints, sans tache, irréprochables."
,"23":"Mais il faut que vous restiez fermes dans la foi, solides sur vos bases. Ne déviez pas de l'espérance contenue dans l'évangile que vous avez reçu, qui a été proclamé à toute créature sous le ciel, et dont moi, Paul, j'ai reçu la charge."
,"24":"Et maintenant, mes souffrances pour vous sont ma joie; je complète dans ma chair ce qui manque encore aux épreuves du Christ pour son corps qui est l'Eglise."
,"25":"J'en suis l'administrateur, du fait que Dieu m'a confié la charge de mettre en oeuvre chez vous le projet de Dieu,"
,"26":"son plan mystérieux caché depuis des siècles et des siècles. Ce secret de Dieu vient d'être révélé à ses saints. "
,"27":"Il a voulu leur faire connaître les richesses et la gloire que ce projet réservait aux nations païennes: le Christ est en vous, et il vous fait espérer la Gloire."
,"28":"C'est ce que nous disons et redisons quand nous reprenons qui que ce soit et lui enseignons la sagesse, car nous voulons que tout homme devienne parfait dans le Christ."
,"29":"C'est là mon travail et je m'y dépense avec une énergie qui me vient de lui et agit puissamment en moi."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Frères, je veux que vous sachiez quel dur combat je livre pour vous, pour ceux de Laodicée et tous les autres qui ne m'ont jamais vu personnellement."
,"2":"Je veux qu'ils prennent courage, qu'ils se soutiennent les uns les autres dans l'amour, visant au plein épanouissement des dons d'intelligence, afin de bien connaître le secret mystère de Dieu qui est le Christ."
,"3":"En lui sont renfermés tous les trésors de la sagesse et de la connaissance:"
,"4":"j'y insiste pour que vous ne vous laissiez pas tromper par de faux arguments."
,"5":"Bien que je sois absent de corps, mon esprit vous accompagne et je me réjouis quand je vois l'équilibre et la solidité de votre foi dans le Christ."
,"6":"Puisque vous avez accepté le Christ Jésus comme le Seigneur, prenez son chemin."
,"7":"Prenez racine en lui et construisez-vous en lui; soyez fermes dans la foi qu'on vous a enseignée et ne vous lassez pas de rendre grâces."
,"8":"Ne vous laissez pas égarer par des sagesses et des théories creuses qui ne sont que la pensée d'un homme: c'est là le chemin du monde et non celui du Christ."
,"9":"Vous savez que toute la plénitude de la divinité habite en lui faite corps."
,"10":"Et en lui vous avez tout, puisqu'il est au-dessus de n'importe quel Principe ou Autorité."
,"11":"En lui vous avez reçu une circoncision, non humaine, non chirurgicale, qui vous enlève tout ce corps charnel. C'est la circoncision du Christ,"
,"12":"le baptême, où vous avez été ensevelis avec lui. Et puis, en lui, vous avez été ressuscités quand vous avez cru à la puissance de Dieu qui l'a ressuscité d'entre les morts. "
,"13":"Vous étiez morts avec toutes vos fautes, et c'est votre être même qui était non circoncis, mais Dieu vous a fait revivre avec le Christ: il nous a pardonné tous les péchés!"
,"14":"Lui a effacé la dette qui nous accablait: elle était écrite dans les commandements. Il en a cloué la facture à sa croix et il l'a supprimée."
,"15":"Vainqueur par la croix, il a dépouillé les Principautés et les Autorités, il s'est moqué d'elles devant tout le monde et il les a traînées derrière lui enchaînées."
,"16":"Donc, que personne ne vous critique pour ce que vous mangez et buvez, ou parce que vous n'observez pas une fête, ou une nouvelle lune ou le sabbat."
,"17":"Tout cela n'était que des ombres, et la réalité, c'est la personne du Christ."
,"18":"Donc ne vous laissez pas avoir par ceux qui viennent avec une religion de courbettes et le culte des anges.. Ces gens-là ne croient qu'à leurs propres visions, et ils sont fiers bien à tort de leurs théories tout humaines."
,"19":"Ils en ont oublié de se tenir ferme à celui qui est la tête, et qui donne au corps son unité par un réseau de nerfs et de jointures, lui permettant de s'affermir et de grandir en Dieu."
,"20":"Si, avec le Christ, vous êtes morts à tous les règlements du monde, comment peut-on vous faire la leçon comme si vous y viviez encore :"
,"21":"ne prends pas... n'y goûte pas... n'y touche pas...!"
,"22":"Il s'agit toujours de choses qu'on utilise, des choses périssables, et on reconnaît bien là les obligations et les doctrines humaines."
,"23":"Tout cela paraît sage, très religieux et très humble, avec un grand mépris pour le corps. Mais c'est inefficace quand la chair se rebelle."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Si vous êtes ressuscités avec le Christ, cherchez les choses d'en haut, là où le Christ siège à la droite de Dieu."
,"2":"Préoccupez-vous des choses d'en haut, et non de celles de la terre."
,"3":"Vous êtes morts et votre vie est cachée en Dieu avec le Christ;"
,"4":"quand le Christ apparaîtra, lui qui est votre vie, vous apparaîtrez vous aussi avec lui dans la gloire."
,"5":"Faites donc mourir ce qui en vous est encore de la terre: liberté sexuelle, impureté, passions, mauvais désirs, et l'amour de l'argent qui est une forme d'idolâtrie."
,"6":"Car tout cela attire la colère de Dieu."
,"7":"C'étaient vos pratiques autrefois, et c'était là votre vie."
,"8":"Mais maintenant défaites-vous de tout cela: colère, emportement, méchanceté, insultes, et toutes les autres paroles mauvaises qu'on peut dire."
,"9":"Qu'il n'y ait pas de mensonges entre vous. Vous vous êtes dépouillés de l'homme ancien et vieilli, avec toutes ses pratiques,"
,"10":"et vous vous êtes revêtus de l'Homme Nouveau, qui ne cesse de se renouveler pour atteindre la parfaite connaissance et rejoindre l'image de son Créateur."
,"11":"Là il n'y a plus le Grec et le Juif, peuple circoncis et peuple païen, ou étrangers, ou sauvages, ou esclaves et hommes libres, sinon que le Christ est tout en tous."
,"12":"Il vous faut revêtir la tenue des élus de Dieu, saints et bien-aimés: la miséricorde, la bonté, l'humilité, la douceur, la patience."
,"13":"Supportez-vous les uns les autres, et pardonnez si vous avez eu à vous plaindre d'un autre. Comme le Seigneur vous a pardonné, pardonnez vous aussi."
,"14":"Une fois revêtus ainsi, vous ferez de l'amour votre ceinture pour que l'ensemble soit parfait."
,"15":"Alors la paix du Christ régnera en vos coeurs: c'est pour ce but que vous avez été appelés et que vous êtes en un seul corps. Soyez reconnaissants!"
,"16":"Que la parole du Christ habite chez vous et y soit au large. Ayez la sagesse; alors vous vous instruirez et vous affermirez mutuellement avec des psaumes, des hymnes, des cantiques spirituels. Que la grâce vous fasse chanter Dieu dans vos coeurs,"
,"17":"et quoi que vous fassiez, que vous parliez ou que vous agissiez, faites-le toujours au nom du Seigneur Jésus Christ, rendant grâces par lui à Dieu le Père."
,"18":"Vous, femmes, soyez soumises à vos maris de la façon qui convient entre Chrétiens."
,"19":"Et vous, maris, aimez vos femmes au lieu de leur rendre la vie impossible."
,"20":"Vous, jeunes, obéissez avec exactitude à vos parents. C'est cela qui est bien pour des Chrétiens."
,"21":"Et vous, les pères, ne disputez pas toujours vos enfants, sinon ils se décourageront."
,"22":"Vous, esclaves, obéissez avec exactitude à vos maîtres de la terre, pas seulement quand on vous surveille ou pour être bien vus, mais avec un coeur droit, comme vous respectez le Seigneur."
,"23":"Ce que vous faites, mettez-y votre coeur, comme si c'était pour le Seigneur et non pour des hommes."
,"24":"D'ailleurs, c'est le Seigneur qui vous récompensera et vous donnera l'héritage. Vous êtes au service du Christ, votre maître."
,"25":"Celui qui fait le mal sera payé du mal qu'il aura fait, et Dieu ne fera pas de faveurs."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Vous, maîtres, donnez à vos serviteurs ce qui est juste et correct. Vous savez que vous avez un maître dans le ciel."
,"2":"Persévérez dans la prière, et prolongez-la de nuit pour l'action de grâces."
,"3":"Priez aussi pour nous, que Dieu nous donne des paroles, et que je puisse annoncer le mystère du Christ: c'est la raison pour laquelle je suis enchaîné."
,"4":"Que je sache donc le faire connaître quand j'aurai à présenter ma défense."
,"5":"Agissez intelligemment avec ceux de l'extérieur et profitez des occasions:"
,"6":"que votre conversation soit toujours agréable et que le sel n'y manque pas; ayez le savoir-faire pour répondre à chacun ce qui convient."
,"7":"Celui qui vous donnera de mes nouvelles est Tychique, notre frère bien-aimé, fidèle intendant, mon compagnon de travail dans le Seigneur."
,"8":"Je vous l'ai envoyé précisément pour vous donner de mes nouvelles et vous réconforter."
,"9":"Avec lui part Onésime qui est de chez vous, un frère fidèle et bien-aimé. Ils vous diront tout ce qui se passe ici."
,"10":"Aristarque, mon compagnon de prison, vous salue, et aussi Marc, le cousin de Barnabé; on vous a parlé de lui, et s'il vient, recevez-le."
,"11":"Jésus, qu'on appelle Justus, vous salue également. Ce sont les seuls d'origine juive qui travaillent avec moi pour le Royaume de Dieu, et ils ont été mon réconfort."
,"12":"Epaphras, votre envoyé, vous salue. Voilà un vrai serviteur du Christ, toujours occupé à vous soutenir par sa prière pour que vous restiez parfaits et produisiez tous les fruits que Dieu désire."
,"13":"Je peux affirmer qu'il vous regrette beaucoup, ainsi que ceux de Laodicée et de Hiérapolis."
,"14":"Notre cher Luc, le médecin, vous salue, et aussi Démas."
,"15":"Vous saluerez les frères de Laodicée, spécialement Nymphas et l'Eglise qui se réunit dans sa maison."
,"16":"Quand cette lettre aura été lue, veillez à ce qu'on la lise aussi dans l'Eglise de Laodicée, et lisez vous-mêmes la lettre de Laodicée."
,"17":"Vous direz aussi à Archippe: Veille à bien remplir la charge que tu as reçue dans le Seigneur."
,"18":"Ce salut est de ma main à moi, Paul. N'oubliez pas que je suis enchaîné. La grâce soit avec vous."
}`)

}
func FR_LBDCC_LoadNPEPChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Lettre de Paul, apôtre du Christ Jésus par une décision de Dieu, aux saints qui vivent à Ephèse, à tous ceux qui ont la foi chrétienne."
,"2":"Recevez grâce et paix de Dieu, notre Père, et du Christ Jésus le Seigneur."
,"3":"Béni soit Dieu, le Père du Christ Jésus notre Seigneur!,Oui, il nous a donné dans les cieux, dans le Christ, toute bénédiction spirituelle."
,"4":"En lui il nous a choisis avant la création du monde,pour être devant lui saints et sans tache. Par amour "
,"5":"il décidait dès ce moment,qu'il ferait de nous ses fils par Jésus Christ et pour lui. Tel a été son vouloir et son bon plaisir,"
,"6":"afin que soit louée et glorifiée sa grâce, ce don qu'il nous faisait dans le Bien-Aimé."
,"7":"Rachetés par son sang, nous avons en lui le pardon de nos fautes, à la mesure même de la richesse de sa grâce,"
,"8":"car elle a débordé sur nous. Ses dons de sagesse, d'intelligence,"
,"9":"nous ont fait connaître sa décision mystérieuse, cet amour pour nous qu'il a déposé dans le Christ."
,"10":"En lui Dieu voulait réunir sous une seule tête, quand le temps serait accompli, tout ce qui est au ciel, et ce qui est sur terre."
,"11":"C'est ainsi qu'en lui nous avons été choisis; Celui qui agit en tout selon sa libre volonté, avait en effet décidé de nous mettre à part."
,"12":"Nous devions porter cette attente du Messie, pour qu'en résulte à la fin la louange de sa gloire."
,"13":"Vous aussi, après avoir entendu la parole de vérité, l'Evangile qui vous sauve, vous avez cru en lui; en lui vous avez été marqués de l'Esprit Saint, cela même qu'il promettait."
,"14":"C'est là le premier acompte de notre héritage, dans l'attente d'une délivrance pour le peuple que Dieu s'est donné,pour sa louange et pour sa gloire."
,"15":"On m'a dit comment, dans le Christ Jésus, vous vivez la foi et l'amour pour tous les saints, je veux dire pour nos frères."
,"16":"Aussi je vous tiens présents dans mes prières et sans cesse je rends grâce pour vous."
,"17":"Que le Dieu de Jésus Christ, notre Seigneur, le Père qui est dans la Gloire, se révèle à vous et vous donne un esprit de sagesse pour le connaître en vérité."
,"18":"Qu'il illumine le regard de votre coeur! Vous saurez alors quelle espérance s'offre à vous à la suite de son appel, et quel riche héritage, quelle gloire il a réservée à ses saints,"
,"19":"et quelle force extraordinaire il met en oeuvre pour nous qui croyons. C'est la même énergie toute-puissante "
,"20":"qui a agi dans le Christ quand il l'a ressuscité d'entre les morts et l'a fait siéger à sa droite dans le monde d'en-haut."
,"21":"Il y est plus haut que toute Principauté, Autorité, Majesté ou Puissance (angéliques), au dessus de tout ce qui compte dans ce monde et dans l'autre."
,"22":"Dieu a tout mis sous ses pieds, et a fait de lui, de façon spéciale, la tête de l'Eglise."
,"23":"Elle est son corps, et en elle se déploie pleinement celui qui est tout en tous."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Vous étiez des morts par suite de vos fautes et de vos péchés."
,"2":"Elles vous faisaient vivre au rythme du monde présent et vous suiviez celui qui règne entre ciel et terre, l'esprit qui est actif dans les coeurs rebelles."
,"3":"Tous nous étions de leur nombre: nous nous laissions mener par nos passions humaines. Nous faisions ce que voulait la chair avec ses ambitions, et de nous-mêmes, nous allions droit au châtiment, tout comme les autres."
,"4":"Mais Dieu est riche en miséricorde: de quel amour ne nous a-t-il pas aimés!"
,"5":"Nous étions morts de nos péchés, et il nous a fait revivre avec le Christ: il vous a sauvés par pure bonté!"
,"6":"Dans le Christ Jésus il nous a ressuscités avec lui pour nous faire siéger avec lui dans le monde d'en-haut."
,"7":"Dans le Christ Jésus il est toute bonté envers nous; il veut montrer dans les temps à venir toute son extraordinaire générosité."
,"8":"C'est à sa bonté que vous devez ce salut par la foi."
,"9":"Cela n'est pas venu de vous, car Dieu l'a donné; ni de vos oeuvres, et donc nul ne peut s'en vanter."
,"10":"Nous sommes une oeuvre de Dieu, nous avons été créés dans le Christ Jésus en vue de toutes les belles choses que Dieu a préparées d'avance pour que nous les réalisions."
,"11":"Rappelez-vous que vous avez été païens; vous l'étiez jusque dans votre chair, et ceux qui se nomment eux-mêmes 'les circoncis' (par une circoncision chirurgicale) vous appelaient 'non circoncis'."
,"12":"En ce temps-là vous n'aviez pas de Messie, vous étiez étrangers à la société israélite et aux alliances qui portaient la promesse de Dieu. Vous étiez dans ce monde sans Dieu ni espérance."
,"13":"Mais aujourd'hui vous êtes dans le Christ Jésus, et vous qui alors étiez loin, vous êtes devenus proches grâce au sang du Christ."
,"14":"Il est notre paix. Il a détruit le mur de séparation, la haine, et les deux mondes sont devenus un seul. Lorsqu'il a détruit dans son propre corps"
,"15":"la Loi avec ses commandements mis en formules, il a fait la paix; il a recréé en lui-même les deux peuples pour en faire un seul homme nouveau."
,"16":"Par la croix il a tué la haine: il a réconcilié avec Dieu les deux peuples devenus un seul corps."
,"17":"Il est venu annonçant la paix à vous qui étiez loin, et la paix aussi à ceux qui étaient proches."
,"18":"Par lui nous venons au Père, les uns et les autres, dans un même Esprit."
,"19":"Vous n'êtes donc plus des étrangers ou des gens qu'on accueille, vous êtes des citoyens de la cité des saints et vous êtes de la maison de Dieu."
,"20":"Vous êtes pris dans la construction, sur ces fondations que sont les apôtres et les prophètes; et le Christ Jésus en est lui-même la pierre d'angle."
,"21":"En lui les éléments s'adaptent l'un à l'autre et la construction tout entière s'élève jusqu'à devenir un temple saint dans le Seigneur."
,"22":"En lui vous vous construisez ensemble pour être une demeure spirituelle de Dieu."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Voilà pourquoi moi, Paul, prisonnier du Christ pour vous, les non-Juifs..."
,"2":"On a dû vous dire comment m'est venue cette grâce de Dieu que j'ai reçue pour vous:"
,"3":"une révélation m'a fait connaître ce plan mystérieux dont je vous ai parlé en peu de mots."
,"4":"C'est assez pour que vous puissiez apprécier l'intelligence que j'ai du mystère du Christ."
,"5":"Il n'avait pas été révélé aux humains des temps passés comme il vient de l'être grâce aux dons spirituels des saints apôtres et prophètes,"
,"6":"et c'est que dans le Christ Jésus les païens ont part à l'héritage, qu'ils sont incorporées, et qu'ils jouissent de la même Promesse. C'est cela la Bonne Nouvelle "
,"7":"dont je suis devenu administrateur sans aucun mérite, lorsque Dieu a montré en moi toute sa force et m'a donné cette grâce."
,"8":"A moi, le dernier des croyants, il m'a donné cette mission d'annoncer aux nations païennes la richesse inépuisable du Christ"
,"9":"et de mettre en lumière la réalisation du plan mystérieux, caché depuis toujours en Dieu, Créateur de l'univers."
,"10":"Dès maintenant les Principautés et Autorités du monde supérieur vont découvrir à travers l'Eglise les multiples aspects de la sagesse de Dieu,"
,"11":"selon le plan éternel qu'il a fait dans le Christ Jésus, notre Seigneur."
,"12":"En lui nous nous approchons maintenant de Dieu pleins d'assurance, avec la foi qu'il nous a laissée."
,"13":"Donc, je vous en prie, ne vous laissez pas abattre par les épreuves qui m'arrivent pour vous: elles sont votre gloire."
,"14":"Et maintenant je me mets à genoux devant le Père,"
,"15":"de qui toute patrie, toute famille céleste, a reçu son nom: car patrie vient de Père."
,"16":"Que vous receviez de lui la force, à la mesure de sa Gloire inépuisable, et soyez affermis intérieurement par son Esprit."
,"17":"Que le Christ habite en vos coeurs par la foi, que vous preniez racine dans l'amour pour vous construire sur lui."
,"18":"Que vous deveniez capables, vous et tous les saints, de comprendre combien cet amour est étendu, large, haut et profond,"
,"19":"- que vous puissiez connaître, en un mot, l'amour du Christ qui dépasse toute connaissance, afin que vous soyez comblés et puissiez atteindre la plénitude de Dieu."
,"20":"A celui dont la force agit en nous, à celui qui peut faire infiniment plus que ce que nous demandons ou comprenons,"
,"21":"à lui la gloire dans l'Eglise et dans le Christ Jésus, tout au long des générations et dans tous les siècles! Amen."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Je vous le demande, moi, le prisonnier dans le Seigneur: montrez-vous dignes de l'appel que vous avez reçu."
,"2":"Faites preuve d'humilité, de bonté, d'esprit de compréhension, et supportez-vous les uns les autres avec amour."
,"3":"Efforcez-vous de garder l'unité de l'esprit grâce au lien de la paix."
,"4":"Qu'il y ait un seul corps et un seul esprit, tout comme vous avez été appelés à une même vocation et espérance:"
,"5":"un seul Seigneur, une seule foi, un seul baptême,"
,"6":"un seul Dieu et Père de tous, qui est au-dessus de tout, et qui fait tout en tous!"
,"7":"Chacun de nous a reçu sa grâce, et c'est le Christ qui a fixé à chacun sa mesure."
,"8":"Il est bien dit: Il est monté vers les hauteurs pour y faire des prisonniers, puis il a distribué aux hommes ses dons."
,"9":"Il est monté: il s'agit de celui qui était descendu dans les profondeurs de la terre."
,"10":"Celui qui est descendu est aussi monté plus haut que les cieux de façon à remplir tout l'univers."
,"11":"Et quels sont ses dons? Les uns sont apôtres, les autres prophètes, les autres évangélistes, les autres pasteurs et enseignants."
,"12":"C'est ainsi qu'il prépare les saints pour les oeuvres de leur ministère, pour la construction du corps du Christ,"
,"13":"pour que nous arrivions tous à l'unité dans la foi et la connaissance du Fils de Dieu, pour que nous devenions l'Homme accompli et adulte dans lequel se déploie la plénitude du Christ."
,"14":"Alors nous ne serons plus de petits enfants traînant à la dérive, emportés par le vent, par n'importe quelle doctrine et invention d'hommes astucieux et experts en tromperie."
,"15":"Nous serons dans l'amour et nous serons dans le vrai; nous irons grandissant sans arrêt pour rejoindre celui qui est la tête, le Christ."
,"16":"De lui vient la croissance du corps où tout un réseau établit l'harmonie et donne la fermeté, mettant en valeur et tenant compte des capacités de chacun; et le corps se construit dans l'amour."
,"17":"Donc je vous dis, et je vous l'ordonne dans le Seigneur: n'imitez pas la conduite des païens, car ils se laissent mener par des ambitions vaines."
,"18":"Leur esprit n'est que ténèbres; leur conscience s'étant endurcie, ils sont pleins d'ignorance et totalement étrangers à la vie de Dieu."
,"19":"Ils se sont souillés, ils se sont livrés à l'impureté, ils recherchent avec frénésie les actions impures qu'ils pourraient commettre."
,"20":"Ce n'est pas pour cela que vous êtes devenus disciples du Christ,"
,"21":"car je suppose, c'est de lui qu'on vous a parlé, c'est lui qu'on vous a enseigné, prenant comme vérité ce qui est en Jésus lui-même."
,"22":"Vous devez renoncer à votre ancienne façon de vivre, à cet homme déjà vieux qui se laisse égarer par ses passions et se détruit lui-même."
,"23":"Il s'agit de vous renouveler spirituellement à partir de l'intérieur,"
,"24":"et de revêtir l'Homme Nouveau, l'homme selon Dieu, qui est créé dans la vraie droiture et sainteté."
,"25":"Renoncez donc au mensonge. Que chacun dise la vérité à son prochain, car nous sommes membres du même corps."
,"26":"Mettez-vous en colère mais ne péchez pas: que le soleil ne se couche pas avant votre colère;"
,"27":"car autrement le diable s'y mettrait."
,"28":"Si tu étais voleur, ne vole plus, mais travaille avec tes mains et même fatigue-toi pour partager avec celui qui est dans le besoin."
,"29":"Que votre bouche ne laisse échapper aucune plaisanterie sale, mais seulement ce qui est bon et qui apporte quelque chose aux autres."
,"30":"N'attristez pas l'Esprit Saint de Dieu qui est votre marque, en vue du jour où Dieu nous prendra avec lui."
,"31":"Débarrassez-vous de tout ce qui est mauvais: paroles méchantes, emportements, colère, cris, injures."
,"32":"Traitez-vous avec bonté et compréhension, et pardonnez comme Dieu vous a pardonné dans le Christ."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Imitez Dieu puisque vous êtes ses enfants bien-aimés."
,"2":"Que l'amour soit votre loi: voyez comme le Christ vous a aimés et s'est sacrifié pour nous, comme ces victimes dont l'odeur était agréable à Dieu."
,"3":"Qu'on ne fasse même pas allusion chez vous à la liberté sexuelle, l'impureté, ou la soif d'argent, car cela n'est pas digne de vous: vous êtes des saints."
,"4":"Et de même les plaisanteries stupides ou de mauvais goût et le gros rire: vous n'êtes pas faits pour cela, mais pour l'action de grâces."
,"5":"D'ailleurs vous savez que le licencieux, l'impur et celui qui aime l'argent - qui adore un faux dieu - n'ont pas leur place dans le royaume du Christ et de Dieu."
,"6":"Ne vous laissez pas égarer par les fausses raisons. C'est cela qui attire la colère de Dieu sur les ennemis de la foi:"
,"7":"ne partagez pas leur sort."
,"8":"Autrefois vous étiez ténèbres, mais maintenant, dans le Seigneur, vous êtes lumière. Marchez comme des enfants de lumière"
,"9":"dans la bonté, la droiture et la vérité, car ce sont les fruits de la lumière."
,"10":"Essayez de discerner ce qui plaît au Seigneur."
,"11":"Ne vous rendez pas complices des oeuvres de ténèbres, car on n'y gagne rien; dénoncez-les plutôt."
,"12":"On a honte même de dire ce qu'ils font en cachette,"
,"13":"mais tout ce que la lumière a dénoncé vient au jour,"
,"14":"et ce qui est venu au jour devient lumière. Il est bien dit: Réveille-toi, toi qui dors, lève-toi d'entre les morts, que t'illumine la lumière du Christ!"
,"15":"Examinez donc avec soin votre conduite, soyez sérieux et non irréfléchis."
,"16":"Essayez de tirer parti du moment présent, car ces jours ne sont pas favorables."
,"17":"Donc, ne soyez pas irresponsables, mais cherchez à voir où est la volonté du Seigneur."
,"18":"Plus d'excès de vin, car cette ivresse mène à l'immoralité; c'est l'Esprit qui doit vous mettre en forme."
,"19":"Communiquez entre vous avec des psaumes, des hymnes, des cantiques spirituels. Que le Seigneur entende le chant et la musique de vos coeurs."
,"20":"Rendez grâces en tout temps et pour tout à Dieu le Père, par Jésus Christ notre Seigneur."
,"21":"Que la crainte du Christ inspire votre soumission aux autres."
,"22":"C'est le cas des femmes: soumises à leurs maris comme au Seigneur."
,"23":"Pour la femme, le mari est la tête, tout comme le Christ est la tête de l'Eglise, lui qui sauve le corps."
,"24":"Aussi l'Eglise est soumise au Christ, et de même les femmes le seront à leur mari, sans réserve."
,"25":"Vous, les maris, aimez vos femmes, tout comme le Christ a aimé l'Eglise et s'est sacrifié pour elle."
,"26":"Et après l'avoir baignée dans l'eau et la Parole afin de la purifier, il l'a rendue sainte."
,"27":"Car il voulait se donner lui-même une Eglise rayonnante, sans ride ni tache ou défaut: il la voulait sainte et sans reproche."
,"28":"De même les maris doivent aimer leur femme comme leur propre corps: aimer sa femme, c'est s'aimer soi-même."
,"29":"Personne ne veut de mal à son propre corps, on le nourrit, on en prend soin, comme le Christ le fait pour son Eglise -"
,"30":"et nous, nous sommes les membres de son corps."
,"31":"Voilà comment l'homme laissera son père et sa mère pour s'attacher à sa femme, et les deux seront une seule chair."
,"32":"Je dis que c'est là un grand mystère, car je l'applique au Christ et à l'Eglise."
,"33":"Quant à vous, que chacun aime sa femme comme lui-même, et que la femme respecte son mari."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Vous, jeunes, obéissez à vos parents, car c'est un devoir."
,"2":"Honore ton père et ta mère: c'est le premier commandement accompagné d'une promesse:"
,"3":"afin que tu réussisses et que tu aies longue vie sur la terre."
,"4":"Et vous, pères, ne soyez pas énervants avec vos enfants, mais éduquez-les avec des corrections et remontrances inspirées du Seigneur."
,"5":"Vous, esclaves, quand vous obéissez à vos maîtres de la terre, que ce soit un respect attentif et sincère, comme pour le Seigneur."
,"6":"Ne regardez pas si on vous surveille ou si vous serez bien considérés: vous êtes des serviteurs du Christ qui font d'eux-mêmes la volonté de Dieu."
,"7":"Soyez consciencieux dans votre service: vous le faites pour le Seigneur, non pour les hommes,"
,"8":"et vous savez que le Seigneur rendra à chacun le bien qu'il a fait, qu'il soit esclave ou homme libre."
,"9":"Quant à vous, patrons, agissez de même avec vos serviteurs au lieu de crier sur eux: vous savez bien que dans les cieux le Seigneur est le même pour eux et pour vous, et qu'il ne fait pas de différence entre les personnes."
,"10":"A part cela, devenez forts dans le Seigneur, grâce à sa force et sa puissance."
,"11":"Portez sur vous toutes les armes de Dieu, de façon à repousser toutes les attaques du diable."
,"12":"Car nos ennemis ne sont pas de chair et de sang: ce sont les Principautés, les Autorités, les maîtres de ce monde obscur, les forces spirituelles mauvaises du monde supérieur."
,"13":"Ayez donc toutes les armes de Dieu, de façon à résister dans les jours difficiles et à défendre votre terrain par tous les moyens."
,"14":"Vous tiendrez bon si vous avez la vérité pour ceinturon, la droiture pour cuirasse."
,"15":"Soyez bien chaussés: préparez les chemins pour l'Evangile de la paix."
,"16":"Ne lâchez jamais le bouclier de la foi avec lequel vous éteindrez les flèches incendiaires du Mauvais."
,"17":"Portez le casque du salut et l'épée de l'Esprit, c'est-à-dire la Parole de Dieu."
,"18":"En toute occasion priez dans l'Esprit: demandez et suppliez. Restez éveillés, persévérant et priant pour tous les saints, vos frères."
,"19":"Priez aussi pour moi, pour que la parole me vienne quand j'ai à parler, et que je sois plein d'assurance pour faire connaître le mystère de l'Evangile quand j'aurai à présenter ma défense."
,"20":"J'en suis pour l'instant l'ambassadeur enchaîné, il convient que j'en parle avec pleine assurance."
,"21":"Si vous voulez de mes nouvelles, vous en aurez par Tychique, ce frère bien-aimé qui est un fidèle serviteur dans le Christ: il vous dira où j'en suis."
,"22":"Je vous l'envoie précisément pour que vous ayez de nos nouvelles, et pour vous réconforter."
,"23":"Que tous les frères reçoivent de Dieu le Père et du Seigneur Jésus-Christ la paix, l'amour et la foi."
,"24":"Que la grâce soit avec tous ceux qui aiment Jésus Christ, notre Seigneur, d'un amour sans mélange."
}`)

}
func FR_LBDCC_LoadNPGAChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Moi, Paul, apôtre, - et pour cela personne ne m'a envoyé ou n'est intervenu, seulement Jésus Christ et Dieu le Père qui l'a ressuscité d'entre les morts;"
,"2":"moi et tous les frères qui sont avec moi, nous saluons les Eglises de Galatie."
,"3":"Recevez grâce et paix de Dieu notre Père et du Seigneur Jésus Christ."
,"4":"Il a donné sa vie pour nos péchés, pour nous arracher à cette existence misérable, faisant en cela la volonté de Dieu notre Père:"
,"5":"Gloire à lui pour les siècles des siècles. Amen!"
,"6":"Je m'étonne que vous passiez si vite de Celui qui vous a appelés par la grâce du Christ, à un autre évangile."
,"7":"Mais il n'y en a pas d'autre: il y a seulement des gens qui vous créent des problèmes et qui veulent mettre à l'envers l'évangile du Christ."
,"8":"Mais je dis: Dehors! Et cela, même si c'était nous ou quelque ange de Dieu qui venait vous donner un autre évangile que celui qui vous a été annoncé."
,"9":"Et je redis: Dehors! Anathème! pour celui qui vous présente l'Evangile autrement que vous ne l'avez reçu."
,"10":"Faut-il être bien vu des hommes, ou de Dieu? Dois-je chercher à plaire aux hommes? Si je cherchais à plaire aux hommes, je ne serais pas serviteur du Christ."
,"11":"Je vous le rappelle, frères, l'évangile avec lequel je vous ai évangélisés n'est pas d'origine humaine."
,"12":"Je ne l'ai pas reçu d'un homme; on ne me l'a pas enseigné, mais je l'ai par une révélation du Christ Jésus."
,"13":"Vous savez ce qu'a été mon attitude autrefois dans le Judaïsme: j'ai persécuté au maximum l'Eglise de Dieu et j'ai voulu la déraciner."
,"14":"J'étais plus avancé dans le Judaïsme que la plupart de ceux de mon âge et j'étais farouchement attaché aux traditions de mes pères."
,"15":"Mais un jour, il a plu à Celui qui m'avait mis à part dès le ventre de ma mère de m'appeler par pure bonté"
,"16":"et de révéler en moi son Fils pour que je le proclame parmi les nations païennes. Alors, je n'ai consulté personne,"
,"17":"et je ne suis pas monté à Jérusalem pour y rencontrer ceux qui étaient apôtres avant moi, mais je suis parti pour l'Arabie et de là je suis revenu à Damas."
,"18":"Plus tard, au bout de trois ans, je suis monté à Jérusalem pour y rencontrer Képhas et je suis resté quinze jours avec lui."
,"19":"Mais je n'ai vu aucun autre apôtre, seulement Jacques, le frère du Seigneur."
,"20":"Et quand je vous écris cela, je vous affirme devant Dieu que je ne mens pas."
,"21":"Après cela je suis parti vers la Syrie et la Cilicie."
,"22":"Les Eglises chrétiennes de Judée ne me connaissaient pas de visage;"
,"23":"on y disait seulement: 'Celui qui nous persécutait et voulait déraciner la foi est maintenant en train de la prêcher.'"
,"24":"Et ils rendaient grâces à Dieu à mon sujet."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Plus tard, au bout de quatorze ans, je suis monté à Jérusalem avec Barnabé, et nous avons aussi emmené Tite."
,"2":"J'y suis allé à la suite d'une révélation et je leur ai exposé l'évangile que je proclame chez les païens. J'en ai parlé en privé avec ceux qui comptaient, pour le cas où j'aurais fait et ferais encore un travail qui ne mène à rien."
,"3":"Mais personne n'imposa la circoncision à Tite qui était avec moi et qui est Grec."
,"4":"En effet de faux-frères s'étaient infiltrés: ils s'étaient introduits pour tout savoir de la liberté que nous avons dans le Christ Jésus, et ils voulaient nous ramener à l'esclavage."
,"5":"Mais nous ne leur avons pas cédé, pas même un instant, pour que la vérité de l'Evangile reste intacte chez vous."
,"6":"Ceux que l'on regardait comme des autorités (leur situation antérieure ne m'importe pas, car Dieu ne fait pas de favoritisme), ces autorités donc ne me firent aucune remarque."
,"7":"Au contraire, ils reconnurent que l'évangélisation du monde païen m'avait été confiée, tout comme à Pierre l'évangélisation du monde juif."
,"8":"Celui qui a donné sa grâce à Pierre pour qu'il soit l'apôtre du monde juif, m'a aussi donné sa grâce pour le monde païen."
,"9":"Jacques, Képhas et Jean reconnurent la grâce que j'avais reçue. Eux, qui passaient pour les piliers de l'Eglise, ils nous donnèrent la main à moi et à Barnabé en signe de communion: nous irions vers les nations païennes et eux vers les Juifs."
,"10":"Nous devions seulement ne pas oublier leurs pauvres, et cela, j'en ai toujours eu le souci."
,"11":"Lorsque Képhas est venu à Antioche, je lui ai résisté en face parce qu'il était dans son tort."
,"12":"Avant que n'arrivent des gens de l'entourage de Jacques, il mangeait avec les frères d'origine païenne, mais quands ils furent là, il prit ses distances et marqua la séparation par crainte des éléments juifs."
,"13":"Les autres Juifs aussitôt prirent le même faux visage, et Barnabé lui-même fut entraîné dans ce double jeu."
,"14":"Alors, quand je vis que ce n'était plus le droit chemin de l'Evangile dans toute sa vérité, je dis à Képhas devant tout le monde: 'Toi qui es Juif de naissance, tu as laissé les façons juives pour celles des non-Juifs; pourquoi maintenant veux-tu imposer les façons juives à des non-Juifs?'"
,"15":"Nous sommes nés Juifs, nous n'appartenons pas à ces nations de pécheurs;"
,"16":"cependant nous avons reconnu que l'on ne reçoit pas la droiture du coeur par la pratique de la Loi, mais par la foi selon le Christ Jésus. Et nous avons cru dans le Christ Jésus pour être droits aux yeux de Dieu grâce à cette foi selon le Christ et non par la pratique de la Loi. Car si l'on s'en tient aux oeuvres de la Loi, nul mortel ne sera reconnu juste."
,"17":"Nous sommes allés au Christ pour recevoir cette véritable droiture, et maintenant nous nous retrouverions pécheurs! Mais alors, le Christ devient un auxiliaire du péché. Impossible!"
,"18":"Pourtant, regardez: si d'abord on supprime et ensuite on rétablit, on reconnaît qu'on a mal agi."
,"19":"Quant à moi, c'est la Loi elle-même qui m'a amené à mourir à la Loi afin de vivre pour Dieu. J'ai été crucifié avec le Christ, "
,"20":"et si maintenant je vis, ce n'est plus moi qui vis: le Christ vit en moi. Et ce que je vis maintenant dans la chair, je le vis avec cette foi où le Fils de Dieu m'a aimé et a donné sa vie pour moi."
,"21":"Voilà ma façon de ne pas mépriser la générosité de Dieu. Car si l'on devient juste à partir de la Loi, le Christ est mort pour rien!"
}`)
	CurrentBook.AddChapter(3, `{
"1":"O Galates sans cervelle! Comment ont-ils pu vous fasciner alors qu'on vous avait mis sous les yeux Jésus Christ crucifié?"
,"2":"Je voudrais que vous me disiez: avez-vous reçu l'Esprit en pratiquant la Loi ou en accueillant la foi?"
,"3":"Vraiment vous êtes intelligents: vous avez commencé par l'Esprit et vous terminez par la chair!"
,"4":"Une telle expérience ne vous a donc servi à rien? Servi à rien-est-ce possible?"
,"5":"Si Dieu vous distribue les dons de l'Esprit, s'il fait pour vous des miracles, qu'est-ce que cela a à voir avec la Loi? N'est-ce pas plutôt parce que vous avez accueilli la foi"
,"6":"à l'exemple d'Abraham? Il crut à Dieu, et c'est pourquoi il fut regardé comme juste."
,"7":"Donc, vous le voyez, les fils d'Abraham sont ceux qui s'appuient sur la foi."
,"8":"L'Ecriture savait déjà que Dieu donnerait aux païens la vraie droiture par le chemin de la foi. Aussi Abraham reçut-il cette promesse: La bénédiction passera de toi à toutes les nations."
,"9":"Ce sont donc bien ceux qui comptent sur la foi qui sont bénis avec le croyant Abraham."
,"10":"Au contraire, c'est une malédiction qui attend ceux qui comptent sur la pratique de la Loi: Maudit soit celui qui ne met pas en pratique à tout moment tout ce qui est écrit dans ce livre de la Loi."
,"11":"Avec la Loi, personne ne devient juste devant Dieu. C'est évident, puisque le juste vivra par la foi,"
,"12":"et la Loi ignore la foi quand elle dit: Celui qui met en pratique ces choses, vivra grâce à elles."
,"13":"Le Christ nous a rachetés de cette malédiction de la Loi quand pour nous il est devenu malédiction, selon ce qui est écrit: Celui que l'on pend à un poteau est une malédiction."
,"14":"C'est alors que, dans le Christ Jésus, la bénédiction d'Abraham a atteint les nations païennes, et par la foi nous avons reçu la promesse, c'est-à-dire l'Esprit."
,"15":"Frères, je prends un exemple. Si quelqu'un fait un testament selon les règles, personne ne peut l'annuler ou le modifier."
,"16":"Dans le cas d'Abraham, les promesses étaient pour lui et pour son descendant. Il n'est pas dit: 'pour tes descendants'; on ne fait pas allusion à plusieurs, mais à un seul: ton descendant, et c'est le Christ."
,"17":"Alors je dis: si Dieu a fait un testament selon les règles, la Loi qui est venue quatre cent trente ans plus tard ne l'a pas annulé, elle n'a pas pu revenir sur la promesse."
,"18":"Or si on hérite en vertu de la Loi, ce n'est plus en vertu de la promesse. Et précisément cet héritage était pour Abraham une promesse et un don de Dieu."
,"19":"Alors, pourquoi la Loi? Elle a été ajoutée en vue des désobéissances, elle valait jusqu'à la venue de ce descendant d'Abraham pour qui était la promesse, et ce sont des anges qui l'ont mise en place. D'où l'intervention d'un médiateur,"
,"20":"entre eux; si c'était Dieu, lui est un seul."
,"21":"Alors, est-ce que la Loi va contre les promesses? Pas du tout. Si on avait donné une loi capable de nous rendre la vie, cette loi nous donnerait la droiture du coeur."
,"22":"Mais non, l'Ecriture a tout fait rentrer dans la logique du péché, et c'est par la foi selon Jésus Christ, que les croyants reçoivent la promesse."
,"23":"Jusqu'à la venue de la foi, la Loi nous tenait sous clé, attendant le moment où la foi ferait son apparition."
,"24":"La Loi nous conduisait à l'école, celle du Christ, pour que, par la foi, nous devenions droits au regard de Dieu."
,"25":"Mais quand la foi est là, nous n'avons plus à suivre celle qui nous mène à l'école."
,"26":"Vous êtes fils de Dieu par la foi en Jésus Christ,"
,"27":"et vous avez revêtu le Christ, vous tous qui avez été donnés au Christ par le baptême."
,"28":"Là, il n'y a plus de distinctions: Juif et Grec, esclave et homme libre, homme et femme; tous vous êtes devenus un dans le Christ Jésus."
,"29":"Et si vous êtes au Christ, vous êtes la descendance d'Abraham, les héritiers de la promesse."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Maintenant je dis: tant que le fils du propriétaire est un enfant, on ne le distingue pas des esclaves, bien qu'il soit leur maître à tous."
,"2":"Il dépend de tuteurs et d'économes jusqu'à l'âge fixé par son père."
,"3":"C'était pareil pour nous, car nous étions des mineurs et nous étions soumis aux obligations morales de ce monde."
,"4":"Mais lorsque fut arrivée la plénitude des temps, Dieu envoya son Fils, né d'une femme, né sous la Loi"
,"5":"afin de racheter ceux qui étaient sous la Loi, pour que nous recevions notre titre d'enfants."
,"6":"Et parce que vous êtes fils, Dieu a fait venir à vos coeurs l'Esprit de son Fils, celui qui peut crier: Abba, Père!"
,"7":"Donc tu n'es plus esclave, tu es fils, et comme à un fils, Dieu te donne l'héritage."
,"8":"Autrefois vous ne connaissiez pas Dieu, et vous serviez des dieux qui ne le sont pas."
,"9":"Et puis vous avez connu Dieu, ou plus exactement: Dieu vous a reconnus. Mais alors, pourquoi revenez-vous à des obligations, à des choses pauvres et sans vie? Vous allez donc de nouveau en être esclaves?"
,"10":"Et vous allez observer tel et tel jour, et la nouvelle lune et cette période-ci et cette année-là..."
,"11":"Vraiment, je crains d'avoir perdu ma peine avec vous."
,"12":"Je me suis bien fait l'un de vous, frères; vous aussi, je vous en prie, soyez comme je suis. Vous m'avez toujours bien traité."
,"13":"Vous savez comment j'étais malade tout au début, quand je vous ai évangélisés."
,"14":"Mon état de santé était pour vous une épreuve, mais vous ne m'avez pas pour autant méprisé ou montré du dégoût; au contraire vous m'avez reçu comme un ange de Dieu, comme le Christ Jésus."
,"15":"Mais qu'est devenu ce bonheur parfait? Car, je ne mens pas, vous vous seriez arraché les yeux pour me les donner."
,"16":"Alors suis-je maintenant votre ennemi parce que je vous dis la vérité?"
,"17":"Là-bas on est plein de zèle pour vous, mais pas dans le bon sens. Ces gens-là veulent vous prendre à part pour que vous soyez pleins de zèle pour eux."
,"18":"Comme ce serait bon d'être toujours plein de zèle, et dans le bon sens, et pas seulement quand je suis près de vous!"
,"19":"Oui, mes petits enfants, je souffre pour vous les douleurs d'une mère jusqu'à ce que le Christ ait pris forme en vous."
,"20":"Combien je voudrais être auprès de vous en ce moment et vous parler de vive voix, car je ne sais comment faire avec vous."
,"21":"Dites-moi, vous qui voulez vous soumettre à la Loi, l'avez-vous entendue?"
,"22":"Il est écrit qu'Abraham eut deux fils, l'un né de son esclave, l'autre de celle qui était libre."
,"23":"Le premier fils, celui de l'esclave, lui était né par le jeu de la chair; mais celui de la femme libre, il le devait à une promesse de Dieu."
,"24":"Il y a là un symbole: on y reconnaît deux alliances. La première, celle du Mont Sinaï, c'est Agar: elle donne le jour à des esclaves."
,"25":"Agar était d'Arabie, où est le Sinaï, et représente bien la Jérusalem actuelle qui est esclave avec ses enfants."
,"26":"Mais la Jérusalem céleste est libre, et c'est elle notre mère."
,"27":"Il est écrit: Réjouis-toi, femme stérile qui n'as pas eu d'enfants, saute et crie de joie, toi qui n'as pas connu les douleurs de l'enfantement. Car la femme laissée pour compte aura plus d'enfants que celle qui avait un mari."
,"28":"Frères, vous êtes enfants de la promesse, tout comme Isaac."
,"29":"Mais déjà dans ce temps l'enfant de la chair persécutait l'enfant de l'esprit, et c'est pareil aujourd'hui."
,"30":"Mais que dit l'Ecriture? Renvoie l'esclave et son fils, car le fils de l'esclave ne recevra rien de ce que doit hériter le fils de la femme libre."
,"31":"Nous sommes nés de femme libre et non pas fils d'esclaves."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Le Christ nous a libérés pour que nous soyons libres, donc soyez fermes et ne retombez pas dans l'esclavage."
,"2":"C'est moi, Paul, qui vous le dis: si vous recevez la circoncision, le Christ ne vous servira plus de rien."
,"3":"Je dis clairement à quiconque se fait circoncire: tu es maintenant obligé de pratiquer toute la Loi."
,"4":"Vous qui prétendez gagner des mérites grâce aux pratiques de la Loi, vous avez perdu le Christ et vous êtes retombés du monde de la grâce."
,"5":"Mais nous, l'Esprit nous donne la ferme conviction que nous serons droits aux yeux de Dieu grâce à la foi."
,"6":"Quand on est dans le Christ Jésus, avoir ou non la circoncision n'est plus une valeur; seule vaut la foi qui agit grâce à l'amour."
,"7":"Vous marchiez bien, qui vous a dit de vous arrêter et de ne plus suivre la vérité?"
,"8":"Car ce que vous écoutez n'est pas la voix de celui qui vous a appelés."
,"9":"Mais ce n'est qu'un peu de levure qui cherche à soulever toute la pâte."
,"10":"Je suis convaincu dans le Seigneur que vous penserez exactement comme moi; mais celui qui sème la confusion devra être jugé, quel qu'il soit."
,"11":"Moi aussi, frères, je pourrais faire maintenir la circoncision: croyez-vous que je serais encore persécuté? Mais voilà, ce serait fini du scandale de la croix."
,"12":"Si seulement ceux qui vous révolutionnent pouvaient se mutiler pour de bon!"
,"13":"Frères, votre vocation c'est la liberté. Non pas cette liberté qui sert à justifier les appels de la chair, mais celle qui nous met au service les uns des autres par amour."
,"14":"Car la Loi se résume en une seule phrase: Tu aimeras ton prochain comme toi-même."
,"15":"Mais si vous vous mordez et vous déchirez les uns les autres, prenez garde: vous en arriverez à tous vous détruire."
,"16":"Donc je vous dis: vivez selon l'esprit, et vous ne céderez pas aux désirs de la chair."
,"17":"Les désirs de la chair vont contre l'esprit et les désirs de l'esprit contre la chair; ils s'opposent l'un à l'autre de sorte que vous ne faites pas comme vous voulez."
,"18":"Mais être conduit par l'Esprit, ce n'est pas obéir à une loi."
,"19":"On connaît bien les oeuvres de la chair: liberté sexuelle, impureté,"
,"20":"idolâtrie, mauvais sorts, haines, colère, jalousie, emportement, querelles, divisions, sectes,"
,"21":"envie, excès de boisson, de nourriture et tout le reste. Je vous l'ai déjà dit et je le répète: ceux qui font ces choses-là, n'hériteront pas du royaume de Dieu."
,"22":"Par contre les fruits de l'Esprit sont: amour, joie, paix, largeur d'esprit, générosité, bonté, foi,"
,"23":"douceur, maîtrise de soi. Ce sont des choses qu'aucune loi ne condamne. "
,"24":"Et de fait, ceux qui appartiennent au Christ ont crucifié la chair avec ses mouvements et ses désirs."
,"25":"Si nous vivons par l'Esprit, vivons comme des spirituels:"
,"26":"renonçons à la vaine gloire, cessons de vouloir être les premiers et de jalouser les autres."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Frères, si quelqu'un se trouve en faute, remettez-le sur la bonne voie, vous qui êtes spirituels, avec un esprit de douceur. Pense à toi-même: si toi aussi, tu étais tenté?"
,"2":"Portez les fardeaux les uns des autres, si vous voulez respecter la Loi du Christ."
,"3":"D'ailleurs, si on se croit quelque chose alors qu'on n'est rien, on ne trompe que soi-même."
,"4":"Que chacun examine ses propres oeuvres et, s'il y trouve quelque fierté, qu'il la garde pour lui-même au lieu de la faire sentir aux autres."
,"5":"Pour cela, oui, que chacun porte son propre fardeau."
,"6":"Celui qui se fait instruire doit rétribuer celui qui lui donne la parole selon ce dont il dispose."
,"7":"Ne vous y trompez pas, on ne se moque pas de Dieu et finalement chacun récoltera ce qu'il a semé."
,"8":"Si la chair est le terrain où vous semez, vous y récolterez la corruption. Mais si vous semez dans l'esprit, vous récolterez de l'esprit la vie éternelle."
,"9":"Donc, faisons le bien sans faiblir; si nous ne nous décourageons pas, le moment venu nous récolterons."
,"10":"Ne manquons pas les occasions, agissons bien envers tous et tout spécialement avec ceux de notre maison, je veux dire avec les croyants."
,"11":"Avez-vous remarqué ces grandes lettres? C'est mon écriture."
,"12":"Ceux qui vous pressent de recevoir la circoncision veulent avant tout faire bonne figure dans le monde: ils ne veulent pas que la croix du Christ leur attire des ennuis."
,"13":"Ce n'est pas parce qu'ils sont circoncis qu'ils observent la Loi, et si vous y passiez, ils en tireraient gloire."
,"14":"Pour moi, je ne veux être fier de rien d'autre que de la croix de Jésus Christ, notre Seigneur, car elle a crucifié le monde pour moi, et elle m'a crucifié pour le monde."
,"15":"Etre circoncis ou non n'a plus d'importance; seule compte la nouvelle créature."
,"16":"Que la paix et la miséricorde accompagnent ceux qui vivent suivant ce principe: ils sont l'Israël de Dieu."
,"17":"Et maintenant, que ces gens-là gardent pour eux leurs critiques: moi, je porte dans mon corps les cicatrices de Jésus."
,"18":"Frères, que la grâce de Jésus Christ, notre Seigneur, ne s'éloigne pas de votre esprit. Amen!"
}`)

}
func FR_LBDCC_LoadNPPMChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Lettre de Paul, prisonnier du Christ Jésus, et de Timothée, votre frère, adressée à notre cher coopérateur Philémon,"
,"2":"à notre soeur Appia, à notre compagnon d'armes Archippe, et à toute l'Eglise qui se réunit dans leur maison."
,"3":"Recevez grâce et paix de Dieu notre Père et du Seigneur Jésus Christ!"
,"4":"Tu es toujours présent dans mes prières et je rends grâce à mon Dieu"
,"5":"car j'entends parler de la charité et de la foi avec lesquelles tu sers le Seigneur Jésus et les saints frères."
,"6":"Je voudrais que ta foi soit assez forte pour te faire découvrir tout le bien que nous pouvons faire pour le Christ."
,"7":"Oui, frère, grâce à toi les saints se sentent bien à l'aise et ta charité me procure beaucoup de joie et de réconfort."
,"8":"Aussi, bien que j'aie toute l'autorité pour te dire au nom du Christ ce que tu dois faire,"
,"9":"j'aime mieux faire appel à ta charité. Celui qui te prie est Paul, un homme d'âge respectable, et maintenant prisonnier pour le Christ Jésus, "
,"10":"et la pétition est pour mon enfant Onésime; car dans ma prison j'ai eu ce fils."
,"11":"S'il ne t'a guère servi dans le passé, il va maintenant te donner satisfaction tout comme à moi."
,"12":"Aussi je te l'envoie et, avec lui, le meilleur de moi-même."
,"13":"J'aurais voulu le garder auprès de moi pour qu'il me serve de ta part le temps que je suis en prison à cause de l'Evangile."
,"14":"Mais je n'ai pas voulu le faire sans que tu le saches, car je ne veux pas t'obliger à me faire un cadeau: il faudrait que tu sois d'accord."
,"15":"S'il a disparu de chez toi pour un temps, c'était sûrement pour que tu le retrouves de façon définitive;"
,"16":"non plus comme un esclave, mais beaucoup mieux qu'un esclave, comme un frère bien-aimé. Il est en effet mon frère par le sang et dans le Seigneur, et il le sera bien plus encore pour toi."
,"17":"Donc, si tu ne m'as pas oublié, reçois-le comme moi-même,"
,"18":"et s'il t'a fait du tort ou te doit quelque chose, mets-le à mon compte."
,"19":"C'est moi, Paul, qui signe de ma propre main, et je paierai sans même te rappeler que tu as une dette envers moi, et cette dette, c'est toi."
,"20":"Donc, frère, je compte bien sur toi, donne-moi cette satisfaction au nom du Christ."
,"21":"Je t'écris et tu m'écouteras, je le sais; tu feras même plus encore que je ne te demande."
,"22":"Et puis, prépare-moi un coin dans ta maison car, grâce à vos prières, j'espère bien vous être rendu."
,"23":"Reçois les saluts d'Epaphras, mon compagnon de captivité dans le Seigneur Jésus,"
,"24":"et aussi de Marc, d'Aristarque, de Démas et de Luc, mes coopérateurs."
,"25":"Que la grâce du Seigneur Jésus Christ soit avec vous tous."
}`)

}
func FR_LBDCC_LoadNPPPChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Lettre de Paul et de Timothée, serviteurs du Christ Jésus, à vous tous qui, à Philippes, êtes dans le Christ Jésus, à tous les saints avec leurs évêques et leurs diacres."
,"2":"Recevez de Dieu notre Père et du Seigneur Jésus Christ, la grâce et la paix."
,"3":"Je rends grâces à Dieu chaque fois que je pense à vous,"
,"4":"c'est-à-dire dans ma prière pour vous à tout moment. Et ma prière est joyeuse,"
,"5":"quand je repense à la part que vous avez prise dans l'évangélisation depuis le premier jour jusqu'à maintenant."
,"6":"Je suis convaincu que celui qui a commencé chez vous ce bon travail le poursuivra jusqu'au Jour du Seigneur Jésus."
,"7":"Et c'est bien ce que je dois espérer pour vous tous, car ici-même, que je sois enchaîné ou occupé à défendre et à affermir l'Evangile, vous m'êtes intérieurement présents, vous partagez tous avec moi cette grâce."
,"8":"Dieu m'est témoin que je pense à vous avec toute la tendresse du Christ Jésus."
,"9":"Je voudrais que chez vous l'amour aille en croissant en même temps que la connaissance et la lucidité."
,"10":"Je voudrais que vous donniez à chaque chose sa valeur, de façon que vous soyez purs et sans reproche au Jour du Christ,"
,"11":"ayant mené à terme grâce au Christ Jésus le fruit de la sainteté. Ce sera pour la gloire de Dieu, et ce sera mon honneur."
,"12":"Frères, je veux que vous le sachiez, mes problèmes ont plutôt fait avancer l'Evangile."
,"13":"Chez les gens du Prétoire et chez les autres, mes chaînes ont fait parler du Christ."
,"14":"Elles ont été un stimulant pour la plupart de nos frères dans le Seigneur, qui sont maintenant plus hardis pour annoncer ouvertement la Parole."
,"15":"Il est vrai que certains le font par envie et pour me faire concurrence, mais d'autres proclament le Christ avec de bonnes intentions."
,"16":"Ils savent que je suis là pour la cause de l'Evangile, et l'amour les inspire."
,"17":"Les autres, au contraire, annoncent le Christ par esprit de rivalité, et non avec un coeur droit, car ils pensent me rendre ainsi la captivité plus pénible."
,"18":"Mais qu'importe? De toute façon, que l'on soit vrai ou qu'on fasse semblant, le Christ est annoncé et je m'en réjouis. J'ai de quoi me réjouir; "
,"19":"je sais que tout cela se terminera bien pour moi, grâce à votre prière, car l'Esprit de Jésus Christ se surpassera."
,"20":"C'est là mon attente et mon espérance: à la fin je n'aurai pas honte. Au contraire, sans aucun doute, maintenant comme toujours le Christ sera glorifié en ma personne, que je vive ou que je meure."
,"21":"La vie, pour moi, c'est le Christ, et je gagne à mourir."
,"22":"Mais aussi, tant que je vis, mon travail rapporte, si bien que je ne sais que choisir."
,"23":"Je suis pris entre les deux: j'aimerais larguer les amarres et rejoindre le Christ, ce qui serait bien meilleur."
,"24":"Mais pour vous il vaut mieux que je reste en cette vie."
,"25":"De fait, je suis convaincu que je resterai. Je vous serai rendu pour votre avantage, et votre foi en sera plus joyeuse."
,"26":"Grâce à moi et à mon retour chez vous, vous vous sentirez encore un peu plus fiers du Christ Jésus."
,"27":"Mais conduisez-vous d'une façon digne de l'Evangile du Christ. Soit que je vienne et que je le voie, ou que de loin j'entende parler de vous, maintenez vos rangs: un même esprit et une même ardeur dans le combat pour la foi de l'Evangile."
,"28":"Ne vous laissez pas impressionner par vos adversaires. On verra là qu'ils vont à leur perte et que vous êtes sauvés, et que vous l'êtes par Dieu."
,"29":"Car c'est une grâce pour vous que non seulement vous ayez cru au Christ mais aussi que vous ayez à souffrir pour lui"
,"30":"et que vous ayez à combattre comme vous m'avez vu faire et comme vous entendez dire de moi."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Puis-je vous faire un appel dans le Christ? Puis-je faire appel à l'amour? Sommes-nous en communion dans un même esprit, et y a-t-il chez vous tendresse et compassion?"
,"2":"Alors donnez-moi cette joie: mettez-vous d'accord, soyez unis dans l'amour, n'ayez qu'une âme avec un même projet."
,"3":"Ne faites rien par rivalité ou pour la gloire; ayez l'humilité de croire les autres meilleurs que vous-mêmes."
,"4":"Au lieu de penser chacun à son intérêt, que chacun se préoccupe des autres."
,"5":"Que l'on trouve en vous le même projet que chez le Christ Jésus:"
,"6":"Lui qui jouissait de la façon d'être de Dieu, il ne s'est pas attaché à cette égalité avec Dieu,"
,"7":"mais il s'est réduit à rien, jusqu'à prendre la condition de serviteur. Et devenu homme entre les humains,"
,"8":"il s'est mis au plus bas, il s'est fait obéissant jusqu'à la mort, et la mort en croix."
,"9":"C'est pourquoi Dieu l'a élevé,et lui a donné le Nom qui passe tout autre nom"
,"10":"afin qu'au Nom de Jésus tout genou fléchisse,au ciel, sur terre, et en bas chez les morts,"
,"11":"et que toute langue proclame: 'Jésus Christ est Seigneur!', pour la gloire de Dieu le Père!"
,"12":"Donc, mes bien-aimés, puisque toujours vous m'écoutez, continuez de mener à bien l'oeuvre de votre salut avec 'crainte et tremblement'. Ne le faites pas seulement quand je suis là, mais plus encore quand je suis au loin."
,"13":"Pensez que Dieu lui-même agit en vous pour que vous désiriez, et ensuite pour que vous agissiez en cherchant à lui plaire."
,"14":"Faites donc tout sans récrimination ni discussion."
,"15":"Ainsi vous serez sans faute ni tache; soyez des enfants de Dieu sans reproche au milieu d'un peuple dévoyé et perverti. Au milieu d'eux vous êtes lumière, comme les astres dans l'univers,"
,"16":"quand vous leur présentez la parole de vie. Vous serez ainsi ma fierté au Jour du Christ, car je n'aurai pas couru, je n'aurai pas travaillé pour rien. "
,"17":"Et si je dois donner ma vie pour ce sacrifice et ce service religieux qu'est votre foi, je m'en réjouis et je partage votre joie."
,"18":"Et de votre côté, réjouissez-vous et partagez ma joie."
,"19":"J'ai bon espoir dans le Seigneur Jésus de vous envoyer bientôt Timothée: cela me réconfortera d'avoir de vos nouvelles."
,"20":"De fait, je n'ai personne qui s'intéresse à vos problèmes aussi sincèrement que lui."
,"21":"Chacun pense à ses intérêts, non à ceux du Christ Jésus,"
,"22":"mais pour lui, vous savez qu'il a fait ses preuves et il a travaillé avec moi pour l'Evangile comme un fils avec son père."
,"23":"Donc je compte vous l'envoyer dès que je saurai comment vont mes affaires,"
,"24":"et j'ai bon espoir dans le Seigneur que moi aussi j'irai sans tarder."
,"25":"J'ai cru nécessaire de vous renvoyer Epaphrodite, notre frère, qui a combattu et travaillé avec moi. Vous l'aviez envoyé pour m'assister de votre part,"
,"26":"mais il supportait mal votre absence, et de plus il regrettait que vous ayez appris sa maladie."
,"27":"De fait, il a été bien malade et près d'en mourir, mais Dieu a eu pitié de lui et aussi de moi, car j'avais déjà assez de peine."
,"28":"J'ai donc tenu à vous le renvoyer, pour que vous ayez la joie de le revoir et que moi-même je sois en paix."
,"29":"Faites-lui bon accueil dans le Seigneur, joyeusement, et sachez apprécier les gens comme lui."
,"30":"Car ce sont ses activités chrétiennes qui l'ont presque mené à la mort; il a payé de sa personne pour ne pas laisser en plan ce que vous aviez décidé de faire pour m'aider."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Que vous dire de plus, frères? Soyez joyeux dans le Seigneur. Cela ne me coûte pas de le répéter et pour vous c'est plus sûr: "
,"2":"prenez garde aux chiens, prenez garde aux mauvais ouvriers, prenez garde au groupe des circoncis!"
,"3":"La circoncision, c'est nous qui l'avons, puisque nous servons Dieu en esprit et nous nous appuyons sur le Christ et non sur des sécurités humaines."
,"4":"Parlant de références humaines, moi aussi j'aurais sur quoi m'appuyer. Si un autre pense s'appuyer sur quelque mérite humain, je le peux davantage."
,"5":"Né de la race d'Israël, de la tribu de Benjamin, Hébreu et fils d'Hébreux, j'ai été circoncis au huitième jour. Etais-je religieux? Oui, j'étais Pharisien, "
,"6":"et convaincu jusqu'à persécuter l'Eglise. Est-ce que j'étais un juste selon la Loi? Oui, je n'avais rien à me reprocher."
,"7":"Mais avec le Christ, tous les avantages me sont apparus comme des poids morts, du négatif."
,"8":"Je dirai plus: tout me semble poids mort à côté de la connaissance du Christ Jésus, mon Seigneur, si extraordinaire! A cause de lui, je n'ai plus trouvé de valeur à rien, et je regarde tout cela comme des riens quand je cherche à gagner le Christ."
,"9":"Et je veux me retrouver en lui, sans aucun mérite à moi, sans cette droiture qu'on attend de la Loi, mais avec celle qui vient de la foi selon le Christ, cette vraie droiture que Dieu donne au croyant."
,"10":"Je veux le connaître lui, et la force de sa résurrection, partager ses souffrances jusqu'à lui ressembler dans sa mort"
,"11":"pour au moins atteindre la résurrection d'entre les morts."
,"12":"Je ne suis pas encore au but, je ne suis pas encore un 'parfait', mais je poursuis ma course: ne vais-je pas saisir, comme j'ai été saisi moimême par le Christ?"
,"13":"Frères, je ne me crois pas déjà qualifié, mais je reste tendu de l'avant sans plus penser à ce que je laisse derrière,"
,"14":"et je cours les yeux fixés sur le prix de la vocation divine, je veux dire de l'appel de Dieu dans le Christ Jésus."
,"15":"Nous tous qui nous disons 'parfaits', voilà notre objectif, et si vous ne voyez pas encore les choses ainsi, Dieu vous les fera voir."
,"16":"Au moins, ne perdez pas ce que vous avez conquis."
,"17":"Frères, soyez mes imitateurs et prenez exemple sur ceux qui suivent notre exemple."
,"18":"Car il y en a, je vous l'ai souvent dit et je le répète avec larmes, qui vivent en ennemis de la croix du Christ."
,"19":"Ils vont à leur perte car ils ont pour dieu leur ventre; ce sont des matérialistes qui se vantent quand ils devraient avoir honte."
,"20":"Nous, au contraire, notre cité nous attend dans les cieux, et de là nous attendons notre sauveur, Jésus Christ, le Seigneur."
,"21":"Car il transformera notre corps misérable, avec cette force qui lui permet de soumettre même l'univers, et il le rendra semblable à son propre corps glorieux."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Donc, frères bien-aimés que je voudrais revoir, vous, ma joie et ma couronne, restez fermes dans le Seigneur, mes bien-aimés."
,"2":"Je demande à Evodie et je demande à Syntiqué qu'elles travaillent ensemble dans le Seigneur."
,"3":"Et toi, cher compagnon, je te demande de leur faire bon accueil car avec moi elles ont travaillé dur pour l'Evangile, de même que Clément et mes autres collaborateurs dont les noms sont inscrits au Livre de Vie."
,"4":"Soyez joyeux dans le Seigneur. Je le répète: soyez joyeux en tout temps."
,"5":"Que tous vous trouvent accueillants. Le Seigneur est proche. "
,"6":"Que rien ne vous tienne préoccupés; exposez plutôt vos demandes à Dieu à tout moment dans la prière, et joignez l'action de grâces à la supplication."
,"7":"Alors la paix de Dieu que rien n'arrête viendra garder vos coeurs et vos esprits dans le Christ Jésus."
,"8":"A part cela, frères, arrêtez-vous à tout ce qui est vrai, ce qui est saint, ce qui est juste, ce qui est pur, ce qui est fraternel, ce qui est noble, et à toutes les valeurs morales qu'on peut admirer."
,"9":"Faites ce qu'on vous a enseigné et que vous avez accueilli, ce que vous avez appris de moi et avez vu chez moi, et le Dieu de paix sera avec vous."
,"10":"J'ai été très heureux dans le Seigneur en voyant refleurir votre préoccupation pour moi. Elle était toujours là, mais l'occasion vous manquait."
,"11":"Ce n'est pas le besoin qui me fait parler car j'ai appris à me suffire,"
,"12":"je sais vivre avec rien et je sais vivre dans l'abondance. De mille manières je suis entraîné pour la faim comme pour la satiété, pour le manque et pour l'abondance;"
,"13":"je peux tout en celui qui me fortifie."
,"14":"Mais vous avez bien fait de prendre part à mes épreuves."
,"15":"Vous le savez, Philippiens, quand je suis parti de Macédoine, dans les débuts de l'Evangile, aucune Eglise ne m'a ouvert un compte d'avoirs et de dettes: il n'y a eu que vous."
,"16":"Et quand j'étais à Thessalonique, par deux fois vous m'avez envoyé ce dont j'avais besoin."
,"17":"Ce n'est pas que je coure après vos dons; je désire plutôt que les intérêts s'accumulent sur votre compte."
,"18":"Mais de fait j'ai assez et plus qu'assez. Je suis dans l'abondance avec ce que j'ai reçu d'Epaphrodite de votre part. C'était là une offrande authentique, agréable à Dieu et dont le parfum monte jusqu'à lui."
,"19":"Mon Dieu à son tour fera face à toutes vos nécessités selon la richesse de sa Gloire, dans le Christ Jésus."
,"20":"Gloire soit à Dieu notre Père pour les siècles des siècles! Amen."
,"21":"Mes saluts dans le Christ vont à tous les saints."
,"22":"Tous les frères qui sont avec moi vous saluent, spécialement ceux du palais de l'empereur."
,"23":"Que la grâce du Christ Jésus, le Seigneur, soit toujours avec votre esprit."
}`)

}
func FR_LBDCC_LoadNPRMChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Lettre de Paul, serviteur du Christ Jésus, apôtre mis à part et appelé pour servir la Bonne Nouvelle de Dieu,"
,"2":"pour redire ce qu'il avait annoncé déjà par ses prophètes dans les saintes Ecritures"
,"3":"au sujet de son Fils. Il est venu comme un descendant de David selon la chair, "
,"4":"mais par sa résurrection d'entre les morts, oeuvre de l'Esprit de sainteté, il a été désigné comme le Fils de Dieu revêtu de la Puissance. C'est de lui, Jésus Christ, notre Seigneur, "
,"5":"que nous avons reçu cette grâce et cette mission: faire que la foi soit accueillie dans toutes les nations païennes pour la gloire de son Nom."
,"6":"Vous en êtes vous aussi, élus du Christ Jésus"
,"7":"qui êtes à Rome, vous que Dieu aime, qu'il a appelés et qu'il a consacrés. Que viennent sur vous, de Dieu notre Père et du Seigneur Jésus Christ, la grâce et la paix!"
,"8":"D'abord je rends grâces à mon Dieu par le Christ Jésus pour vous tous, car dans le monde entier on parle de votre foi."
,"9":"Je pense constamment à vous dans mes prières, et de cela Dieu est témoin, Lui auquel je rends un culte spirituel quand je travaille pour l'Evangile de son Fils."
,"10":"Car je voudrais bien, si Dieu le veut, que tout s'arrange pour que je puisse aller chez vous."
,"11":"Je voudrais vous voir et vous transmettre quelque don spirituel qui vous affermisse,"
,"12":"et que nous ayons un échange mutuel dans la foi, la mienne et la vôtre."
,"13":"Il faut que vous le sachiez, j'ai eu bien des fois l'intention d'aller chez vous, mais jusqu'à maintenant j'en ai été empêché, alors que je voulais faire mûrir quelques fruits chez vous comme je l'ai fait dans d'autres pays."
,"14":"C'est que je me dois à tous, à ceux du monde grec comme aux étrangers, aux gens cultivés comme à ceux qui n'ont pas étudié."
,"15":"Et pour ma part, je désire aller aussi chez vous à Rome pour donner l'Evangile."
,"16":"Vous le voyez, je n'ai pas honte de l'Evangile. C'est une force de Dieu, et c'est le salut pour tous ceux qui croient, les Juifs d'abord, et de même les Grecs."
,"17":"L'Evangile révèle comment Dieu nous remet en ordre, ou nous fait 'justes', à partir de la foi, et pour une vie de foi, comme il est dit dans l'Ecriture: Celui dont la justice vient de la foi, vivra."
,"18":"Car Dieu est en train de dévoiler toute sa réprobation pour l'insolence et l'injustice de ceux qui étouffent la vérité par le mal."
,"19":"Tout ce qu'on peut connaître de Dieu, ils l'ont sous les yeux: Dieu le leur a montré."
,"20":"Ce qu'il est et qu'on ne peut voir, est devenu visible grâce à la création de l'univers, et l'on connaît à travers ses oeuvres son éternité, sa puissance et sa divinité. De sorte qu'ils n'ont pas d'excuse."
,"21":"Alors qu'ils connaissaient Dieu, ils ne lui ont rendu, ni l'honneur, ni l'action de grâces dûs à Dieu. Au contraire ils se sont perdus dans leurs discussions, et leur conscience aveugle est devenue ténèbres."
,"22":"Ce sont des fous qui passent pour sages;"
,"23":"ils ont même remplacé le Dieu de la Gloire, le Dieu qui ne passera pas, par des images de tout ce qui passe, des images d'hommes, d'oiseaux, de bêtes ou de serpents."
,"24":"C'est pourquoi Dieu les a livrés à leurs passions secrètes: ils ont couru à l'impureté et ont déshonoré leur propre corps."
,"25":"Oui, ils ont préféré le mensonge à la vérité de Dieu, ils ont préféré servir et adorer la créature plutôt que le Créateur, lui qui est béni pour tous les siècles: Amen!"
,"26":"Et c'est pourquoi Dieu les a livrés à des passions honteuses. Leurs femmes maintenant remplacent les relations normales par la perversion sexuelle."
,"27":"De même les hommes ne veulent pas de la relation normale avec la femme: ils brûlent de passion les uns pour les autres. Ils font entre hommes des choses honteuses, et ainsi ils reçoivent dans leur propre personne le châtiment dû à leur égarement."
,"28":"Puisqu'ils n'ont pas jugé important de connaître Dieu, Dieu à son tour les a abandonnés aux erreurs de leur propre jugement, de sorte qu'ils font tout ce qu'il ne faut pas."
,"29":"Chez eux on ne trouve qu'injustice, perversité, avarice, méchanceté; ils sont pleins d'envie, de meurtres, de querelles, de tromperie, de mauvaise volonté, de médisances"
,"30":"et de calomnies. Ils défient Dieu, ils sont orgueilleux, insolents, vantards, habiles pour faire le mal, insoumis à leurs parents,"
,"31":"sans conscience, déloyaux, sans amour ni miséricorde."
,"32":"Ils connaissent les lois de Dieu et savent qu'en faisant tout cela on mérite la mort. Mais ils le font et ils approuvent ceux qui le font."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Donc mon ami, puisque tu sais critiquer, tu n'as plus d'excuse; tu te condamnes toi-même quand tu critiques ton prochain, puisque tu fais ce que tu condamnes."
,"2":"Nous trouvons bien que Dieu condamne ceux qui font tout cela."
,"3":"Crois-tu donc que si tu fais la même chose tu échapperas au jugement de Dieu, simplement parce que toi aussi tu les condamnes?"
,"4":"Ce serait là mépriser l'infinie bonté de Dieu, sa patience, sa générosité, ne pas voir que cette bonté de Dieu veut t'amener à la conversion."
,"5":"Si ton coeur s'endurcit et refuse de se repentir, tu te prépares une sévère sentence pour le jour de la Sentence, quand le juste jugement de Dieu se fera connaître."
,"6":"Car il rendra à chacun selon ses oeuvres:"
,"7":"la vie éternelle si l'on a marché vers la gloire, l'honneur et l'immortalité en persévérant dans le bien;"
,"8":"la sentence et le châtiment pour les rebelles qui ne se sont pas soumis à la vérité mais plutôt au mal."
,"9":"L'épreuve et l'angoisse atteindront tous les humains qui ont vécu dans le mal, les Juifs en premier, et de même les Grecs."
,"10":"Mais la gloire, l'honneur et la paix seront pour tous ceux qui ont vécu dans le bien, les Juifs d'abord et de même les Grecs,"
,"11":"car Dieu ne fait pas de différence entre les personnes."
,"12":"Ceux qui ont péché mais qui n'avaient pas la Loi, iront à leur perte sans qu'on parle de la Loi. Ceux qui ont péché, ayant la Loi, seront jugés par la Loi."
,"13":"Car Dieu considère justes, non pas les auditeurs de la religion, mais ceux qui la mettent en pratique."
,"14":"Quand les païens qui n'ont pas la Loi font naturellement ce que demande la Loi, ils écrivent eux-mêmes cette loi qu'ils n'ont pas,"
,"15":"et on voit que les demandes de la Loi sont écrites au fond de leur coeur. C'est leur propre conscience qui fera leur procès, et ils se verront accusés ou approuvés par leur propre raison"
,"16":"le jour où Dieu jugera les secrets des coeurs par Jésus Christ, comme le dit mon Evangile."
,"17":"Mais je suppose que tu es Juif et que tu te reposes sur la Loi, et tu penses que Dieu est de ton côté."
,"18":"Tu connais sa volonté, car la Loi t'a instruit, et tu sais comment agir selon les circonstances."
,"19":"Tu es sûrement le guide des aveugles, tu es une lumière dans les ténèbres,"
,"20":"celui qui instruit les ignorants et enseigne les petits enfants, et tu possèdes avec la Loi l'essentiel, car tu trouves dans ta Loi les formules de la connaissance et la vérité...!"
,"21":"Mais si tu prêches à ton prochain, tu devrais te prêcher toi-même. Tu dis de ne pas voler, et toi tu voles?"
,"22":"Tu dis qu'on ne doit pas tromper sa femme, pourquoi le fais-tu? Tu as horreur des idoles, et tu vas cambrioler dans leurs temples?"
,"23":"Tu es tout fier de ta Loi, mais tu la violes de telle façon que c'en est une honte pour Dieu,"
,"24":"comme le dit l'Ecriture: C'est à cause de vous que les païens insultent le Nom de Dieu."
,"25":"La circoncision te sert si tu observes la Loi. Mais si tu ne l'observes pas, tu te ranges avec ceux qui n'ont pas la circoncision."
,"26":"Et inversement, si l'un d'entre eux pratique ce que demande la Loi, il sera considéré exactement comme s'il avait la circoncision."
,"27":"Et lui qui observe la Loi bien que, physiquement, il ne soit pas circoncis, il pourra te condamner parce que tu es infidèle à la Loi alors que tu as à la fois l'Ecriture et la circoncision."
,"28":"Car ce qui fait le Juif, ce n'est pas une chose extérieure, et la circoncision n'est pas ce qu'on remarque sur le corps."
,"29":"C'est l'intérieur qui fait le Juif, et la circoncision doit être celle du coeur, une oeuvre de l'esprit, et non pas une affaire de lois. C'est Dieu qui sait l'apprécier, non les hommes."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Quel est donc l'avantage du Juif, et à quoi sert la circoncision?"
,"2":"C'est important sur tous les plans. D'abord, c'est à eux que Dieu a confié ses paroles."
,"3":"C'est vrai que certains ne lui ont pas répondu, mais leur infidélité va-t-elle faire que Dieu ne soit pas fidèle?"
,"4":"C'est impossible! On verra que Dieu est fidèle alors que tout homme est menteur. Comme dit l'Ecriture: Tes paroles suffiront pour Te justifier, et s'ils veulent Te juger, Tu auras le dernier mot."
,"5":"Mais si notre mauvaise conduite met en relief la justice de Dieu, ne faut-il pas dire, si l'on raisonne à la façon des hommes: 'Dieu ne doit pas nous punir, ce serait injuste'? -"
,"6":"Mais non, car alors Dieu ne pourrait pas juger le monde."
,"7":"On pourra dire encore: 'Si la fidélité de Dieu devient plus évidente quand je passe à côté de la vérité, peut-on vraiment parler d'un péché et me condamner?',- Comment donc! "
,"8":"Alors faisons le mal pour qu'il en sorte du bien! Je sais qu'il y a des gens qui nous calomnient et prétendent que nous disons cela, mais ils devront en répondre."
,"9":"Alors donc, sommes-nous supérieurs? Oui et non, car nous avons démontré que tous sont soumis au péché, qu'ils soient Juifs ou Grecs,"
,"10":"comme dit l'Ecriture: Pas un n'est juste, pas un seul,"
,"11":"pas un qui soit intelligent et qui cherche Dieu,"
,"12":"tous ont dévié, on ne peut compter sur eux. Pas un ne fait le bien, pas même un seul,"
,"13":"leur bouche est un tombeau ouvert, leurs langues sont bonnes pour mentir, leurs lèvres sont celles d'un serpent venimeux,"
,"14":"leur bouche est pleine de fiel et d'amertume,"
,"15":"leurs pieds sont rapides pour aller verser le sang,"
,"16":"et là où ils passent, ils sèment la ruine et le malheur."
,"17":"Ils ne connaissent pas le chemin de la paix,"
,"18":"la crainte de Dieu n'est jamais présente à leurs yeux."
,"19":"Et nous savons que si la Loi dit quelque chose, elle le dit pour le peuple de la Loi. Donc, finalement, tous devront se taire, car le monde entier est coupable devant Dieu."
,"20":"C'est que pas un mortel ne sera juste devant lui si on en reste à la pratique de la Loi. La Loi, c'est la découverte du péché."
,"21":"Mais maintenant, sans parler de Loi, Dieu nous a fait connaître comment il nous donne la vraie droiture, et c'était déjà dit dans la Loi et les Prophètes."
,"22":"Dieu fait justes et droits par la foi du Christ Jésus, tous ceux qui viennent à la foi. Il n'y a pas de différence, "
,"23":"car tous ont péché et sont privés de la Gloire de Dieu."
,"24":"Ils sont faits justes et droits par pure bonté de Dieu, grâce à la délivrance que nous recevons dans le Christ Jésus."
,"25":"Dieu a fait de lui la victime dont le sang nous obtient le pardon grâce à la foi. Il a montré ainsi comment il nous fait justes et saints: il pardonne les péchés du temps passé,"
,"26":"que Dieu supportait jusqu'ici. Car maintenant il veut montrer ce qu'est son chemin de justice: lui, qui est juste, nous fait justes par la foi qui vient de Jésus."
,"27":"Alors, où sont nos mérites? On les a mis dehors. Qui les a mis dehors, la loi qui demandait des pratiques? Non, mais une autre loi qui s'appelle la foi."
,"28":"Voilà ce que nous affirmons: on devient juste et droit par la foi, sans passer par la Loi et les commandements."
,"29":"Sans cela, Dieu serait seulement Dieu des Juifs. Alors, et les nations païennes? Bien sûr, il est aussi Dieu pour les nations,"
,"30":"puisque lui seul est Dieu, et il nous fait justes et saints: le peuple de la circoncision à cause de sa foi, et les autres peuples par le moyen de la foi."
,"31":"Croyez-vous qu'avec la foi nous éliminons la Loi? Pas du tout: nous la mettons à sa place."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Parlons donc d'Abraham, le premier père de notre race. Qu'est-ce qu'il y a eu de neuf avec lui?"
,"2":"Abraham est devenu un juste, et s'il l'était devenu par l'obéissance à une loi, il en aurait du mérite; mais il n'en a pas devant Dieu."
,"3":"En effet, que dit l'Ecriture: Abraham crut à Dieu qui lui en tint compte, et fit de lui un juste."
,"4":"Celui qui fait un travail, on ne dit pas qu'on lui 'en tient compte' pour lui faire une faveur: on lui doit son salaire."
,"5":"Mais si quelqu'un n'a aucun travail à montrer, mais seulement a eu foi en Celui qui fait les pécheurs justes et droits, on lui tient compte de cette foi pour faire de lui un juste."
,"6":"C'est ainsi que David proclame heureux ceux que Dieu compte parmi les justes, sans regarder à ce qu'ils ont fait:"
,"7":"Heureux ceux dont les fautes sont remises et dont les péchés sont enterrés;"
,"8":"heureux est l'homme à qui Dieu ne tient pas compte de son péché."
,"9":"Mais pour atteindre ce bonheur, la circoncision est-elle nécessaire, ou non? Nous lisons: Il a tenu compte de la foi d'Abraham pour en faire un juste."
,"10":"Il lui en a tenu compte, mais quand? Quand il était circoncis, ou avant de l'être? Bien sûr, quand il n'était pas encore circoncis."
,"11":"Il a reçu la circoncision comme la marque extérieure, le signe de cette jus tice et sainteté, fruit de sa foi d'avant la circoncision. Ainsi il est le père de tous ceux qui croient sans être circoncis, et Dieu leur en tient compte pour les faire justes et saints."
,"12":"Il est aussi le père du peuple juif, à condition qu'il n'ait pas seulement la circoncision mais qu'il marche sur les traces d'Abraham, notre père, quand il croyait sans être encore circoncis."
,"13":"La Loi n'intervient pas non plus dans la promesse faite à Abraham, ou plutôt à sa race, laquelle doit hériter du monde entier; là encore il s'agit de devenir justes par la foi."
,"14":"Si maintenant c'est la Loi qui donne accès à l'héritage, la foi n'a plus aucun sens, et de la promesse il ne reste rien."
,"15":"Mais de fait, la Loi n'amène que des condamnations; sans loi, pas de manquement à la loi."
,"16":"C'est pourquoi la foi est le chemin, et tout est don; c'est ainsi que la promesse se réalise pour toute la race d'Abraham, non seulement pour ses enfants par la race, mais aussi pour ses enfants par la foi. Abraham est notre père à tous, "
,"17":"comme dit l'Ecriture: Je fais de toi le père de nombreuses nations. Et il l'est devenu quand il a eu foi en ce Dieu qui fait revivre les morts et qui appelle ceux qui n'existent pas comme s'ils existaient."
,"18":"Il a espéré contre toute attente, et il a si bien cru qu'il est devenu le père de nombreuses nations, comme on le lui avait dit: Voilà comment sera ta descendance."
,"19":"Sa foi n'a pas faibli; il a oublié que son corps était comme mort (il devait avoir cent ans), et que Sara ne pouvait plus avoir d'enfants."
,"20":"Il n'a pas douté de la promesse de Dieu, ni cessé de croire; au contraire sa foi lui a donné des forces et il a rendu gloire à Dieu,"
,"21":"ayant la certitude que si Dieu promet, il est capable de réaliser."
,"22":"Et on lui en a tenu compte pour faire de lui un juste."
,"23":"Ce n'est pas seulement pour lui que l'Ecriture parle de tenir compte,"
,"24":"mais pour nous aussi, car il nous sera tenu compte de notre foi en Celui qui a ressuscité Jésus, notre Seigneur, d'entre les morts."
,"25":"S'il a été livré pour nos péchés, il a été ressuscité pour que nous recevions justice et sainteté."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Par la foi nous sommes devenus justes et saints, et nous sommes en paix avec Dieu par Jésus Christ."
,"2":"Par lui nous avons accès à cet état de grâce et nous devenons assez hardis pour espérer la Gloire de Dieu."
,"3":"En même temps, nous sommes pleins d'allant au milieu des épreuves, car nous savons que l'épreuve exerce la patience,"
,"4":"la patience nous fait mûrir, la maturité nous porte à espérer,"
,"5":"et l'espérance ne sera pas déçue, car l'Esprit Saint déjà nous a été donné et fait déborder en nous l'amour de Dieu."
,"6":"Voyez comment le Christ est mort pour les pécheurs, au moment voulu, alors que nous étions sans force."
,"7":"On donne difficilement sa vie pour quelqu'un de bien; peut-être en réalité quelqu'un accepterait-il de mourir à la place d'une personne vraiment bonne."
,"8":"Mais voyez comment Dieu démontre l'amour qu'il a pour nous: le Christ est mort pour nous quand nous étions encore pécheurs!"
,"9":"A plus forte raison nous met-il à l'abri de la condamnation quand, par son sang, nous sommes devenus tels que Dieu nous voulait."
,"10":"Quand nous étions contre Dieu, nous avons été réconciliés avec lui par la mort de son Fils; à plus forte raison, maintenant que nous sommes réconciliés, sa vie nous apportera-t-elle une plénitude."
,"11":"Mieux encore, nous nous sentirons tout à fait sûrs de Dieu grâce à Jésus Christ, notre Seigneur, par qui nous avons obtenu la réconciliation."
,"12":"Un seul homme a fait entrer le péché dans l'univers, et par le péché, la mort. Ensuite la mort s'est étendue à tous les hommes puisque tous commettaient le péché."
,"13":"Quand on n'avait pas encore la Loi, on n'avait pas à rendre compte du péché, mais le péché était déjà dans le monde."
,"14":"C'est pourquoi, depuis Adam jusqu'à Moïse, la mort avait pouvoir même sur ceux qui ne désobéissaient pas vraiment comme a fait Adam, cet Adam qui n'était que l'ombre d'un autre à venir."
,"15":"Ainsi fut la chute; mais le don de Dieu est sans comparaison. Tous mouraient par la faute d'un seul, mais la grâce de Dieu se multiplie plus encore quand ce don gratuit passe d'un seul homme, Jésus Christ, à toute la multitude."
,"16":"Il n'y a pas de comparaison entre ce pécheur tout seul, et le don de Dieu maintenant. La condamnation venait d'une sentence individuelle, mais maintenant c'est une multitude de pécheurs qui sont réhabilités."
,"17":"Si de fait il y a eu un règne de la mort par la faute d'un seul et grâce à lui seul, il est bien plus vrai que grâce au seul Jésus Christ il y aura un règne de la vie pour tous ceux qui reçoivent l'abondance de la grâce et le don de la vraie rectitude."
,"18":"Il reste vrai que la sentence pour une seule faute a étendu la condamnation à tous les hommes, mais de même une unique réhabilitation vaut à tous les hommes cette justice et droiture qui les mènent à la vie."
,"19":"De même que la désobéissance d'un seul homme a enfoncé dans le péché toute une multitude, de même aussi par l'obéissance d'un seul toute une multitude accède à la vraie droiture."
,"20":"La Loi est venue à son tour, et du coup le péché a été partout. Mais là où abondait la faute, la grâce de Dieu est venue plus abondante encore."
,"21":"Et comme le péché avait établi son empire de mort, de même la grâce devait établir son em pire où la justice mène à la vie éternelle grâce à Jésus Christ, notre Seigneur."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Après cela, que devons-nous dire? Allons-nous rester dans le péché pour faire multiplier la grâce?"
,"2":"Sûrement pas. Pour le péché, nous sommes devenus des morts: faut-il qu'il nous retrouve vivants?"
,"3":"Vous le savez, nous tous qui avons été baptisés dans le Christ Jésus, c'est dans sa mort que nous avons été plongés."
,"4":"Par ce baptême dans sa mort, nous avons été mis en terre avec lui, et de même que le Christ a été ressuscité d'entre les morts par la Gloire du Père, de même nous aussi nous commençons une vie nouvelle."
,"5":"C'était une image de sa mort quand nous avons été greffés sur lui, mais nous le suivrons aussi dans sa résurrection."
,"6":"Vous le savez, le vieil homme qui est en nous a été mis en croix avec lui, et les forces vives du péché ont été détruites, de façon que nous ne soyons plus esclaves du péché."
,"7":"Bien sûr, si on est mort, on ne lui doit plus rien."
,"8":"Mais si c'est avec le Christ que nous sommes morts, nous vivrons aussi avec lui."
,"9":"Nous savons que le Christ ressuscité d'entre les morts ne meurt plus, la mort n'a plus de pouvoir sur lui."
,"10":"Il y a donc une mort, et c'est une mort au péché pour toujours, et il y a la vie, la vie pour Dieu."
,"11":"Vous devez donc penser que pour le péché vous êtes des morts, mais que pour Dieu vous vivez en Jésus Christ."
,"12":"Ne laissez pas le péché gouverner ce corps puisque c'est un mort: ne faites donc pas toutes ses volontés."
,"13":"Le péché a besoin de vos membres pour le mauvais combat: ne les lui livrez pas. Puisque vous êtes passés de la mort à la vie, offrez-vous à Dieu et mettez vos armes - vos membres - au service de la sainteté."
,"14":"Le péché ne sera plus votre maître car vous n'êtes plus sous le régime de la Loi mais sous celui de la grâce."
,"15":"Le fait que nous soyons en grâce, et non plus sous la Loi, nous autorise-t-il à pécher? Bien sûr que non."
,"16":"Vous le savez, si vous vous proposez comme esclaves, vous êtes les esclaves de celui à qui vous obéissez. Si c'est le péché, vous en mourrez, alors qu'avec la vraie obéissance, vous progressez dans la droiture."
,"17":"Mais rendez grâces à Dieu, car vous étiez esclaves du péché, et vous avez voulu obéir de tout coeur à cette doctrine à laquelle vous vous êtes offerts."
,"18":"Vous avez donc été libérés du péché et vous vous êtes faits les esclaves de la vraie droiture."
,"19":"(Je m'exprime ainsi, de façon bien humaine, car peut-être êtes-vous encore faibles). Jadis, vous avez vécu de façon désordonnée, vous avez rendu votre corps esclave de l'impureté et de l'inconduite; aujourd'hui, faites de votre corps l'esclave de la vraie droiture et vous serez droits."
,"20":"Quand vous étiez esclaves du péché, vous étiez libres vis-à-vis de la vraie droiture,"
,"21":"mais toutes ces choses dont vous rougissez maintenant, quel en a été le profit? Elles débouchent sur la mort."
,"22":"Maintenant, au contraire, libres du péché et au service de Dieu, vous y gagnez d'aller à la sainteté, et au terme, c'est la vie éternelle."
,"23":"Le péché paye un salaire, et c'est la mort. Mais en face il y a la vie éternelle, et c'est un don de Dieu dans le Christ Jésus, notre Seigneur."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Frères, je vous parle comme à des gens qui connaissent la Loi. Vous le savez, la Loi n'a pouvoir sur nous que pour la durée de notre vie."
,"2":"Ainsi la femme mariée n'est tenue par la Loi que si le mari est vivant; s'il meurt elle n'a plus d'obligation vis-à-vis de son mari."
,"3":"Quand il vivait, c'était pour elle un adultère de se donner à un autre, mais lorsque le mari est mort, elle n'a plus d'obligation et ce ne sera pas un adultère de se donner à un autre homme."
,"4":"Donc, frères, vous êtes morts à la Loi dans et avec le corps du Christ, pour appartenir à un autre, celui qui est ressuscité d'entre les morts pour que nous donnions des fruits pour Dieu."
,"5":"Quand nous étions au niveau de la chair, la Loi excitait les désirs de tout ce qui est péché, et ils agissaient en nos membres pour porter des fruits de mort."
,"6":"Mais maintenant, nous sommes morts vis-à-vis de tout ce qui nous tenait captifs, et la Loi ne vaut plus pour nous. Nous ne sommes donc plus au service d'une Loi écrite, ce qui était le passé: avec l'Esprit nous sommes dans le neuf."
,"7":"Qu'est-ce que cela signifie? Que la Loi est péché? Bien sûr que non. Mais sans la Loi je ne connaîtrais pas le péché. Voyez: je n'aurais pas conscience du désir sans la Loi qui dit: Tu ne désireras pas."
,"8":"Le péché a trouvé là son occasion, et il s'est servi du commandement pour faire naître en moi tous les désirs, car sans la Loi le péché est mort."
,"9":"Au départ, il n'y avait pas de Loi et je vivais. Mais le commandement arrive et il donne vie au péché,"
,"10":"et pour moi c'est la mort. Il se trouve donc que le commandement donné pour la vie m'a apporté la mort."
,"11":"Le péché a su se servir du commandement; il m'a égaré afin que le commandement me donne la mort."
,"12":"Mais la Loi elle-même est sainte et le commandement est saint et juste et bon."
,"13":"Est-il possible que quelque chose de bon me mène à la mort? Bien sûr que non, cela vient du péché, et on voit mieux encore ce qu'est le péché quand il se sert de quelque chose de bon pour me donner la mort. Avec le commandement, le péché dévoile tout ce qu'il porte en lui."
,"14":"Nous savons que la Loi est spirituelle, mais moi, je suis un homme de chair et vendu au péché."
,"15":"Je ne comprends pas mes propres actes: je ne fais pas ce que je voudrais, et je fais ce que je déteste."
,"16":"Donc, si je fais ce que je ne voudrais pas, je reconnais que la Loi est bonne."
,"17":"Ce n'est pas moi qui le fais, mais le péché qui habite en moi."
,"18":"Je sais que le bien n'habite pas en moi, je veux dire dans ma chair. Oui, je peux vouloir le bien, mais je suis incapable de le faire."
,"19":"Car je ne fais pas le bien que je voudrais et je fais le mal que je ne voudrais pas."
,"20":"Mais alors, si je fais ce que je ne voudrais pas, ce n'est plus mon oeuvre, mais l'oeuvre du péché qui habite en moi."
,"21":"Me voilà donc devant une loi: quand je voudrais faire le bien, c'est le mal qui arrive."
,"22":"Oui, l'homme intérieur en moi se sent en accord avec la loi de Dieu,"
,"23":"mais je vois dans mes membres une autre loi qui lutte contre la loi de mon esprit, et je tombe prisonnier de cette loi du péché qui est dans mes membres."
,"24":"Que je suis malheureux! Qui me délivrera de ce corps vendu à la mort?"
,"25":"Grâces soient rendues à Dieu par Jésus Christ, notre Seigneur!,En résumé, par ma conscience je suis soumis à la loi de Dieu, mais par la chair je suis esclave de la loi du péché."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Mais pour ceux qui sont dans le Christ Jésus, cette condamnation n'existe plus."
,"2":"Dans le Christ Jésus, la loi de l'Esprit qui est vie t'a délivré de la loi du péché et de la mort."
,"3":"La Loi n'y pouvait rien car la chair ne suivait pas; alors Dieu a envoyé son propre Fils pour faire face au péché; il l'a rendu semblable à cette chair liée au péché et il a condamné le péché dans la chair."
,"4":"Grâce à cela les exigences de la Loi sont maintenant réalisées en nous qui vivons selon l'Esprit et non plus selon la chair."
,"5":"Ceux qui vivent selon la chair vont aux choses de la chair, et ceux qui vivent selon l'Esprit vont aux choses de l'Esprit."
,"6":"Mais il n'y a que mort dans les désirs de la chair; par contre, ce que l'esprit désire est vie et paix."
,"7":"Les projets de la chair sont contraires à Dieu, car la chair ne se soumet pas à la loi de Dieu, et elle ne peut pas se soumettre."
,"8":"C'est pourquoi ceux qui en restent à la chair ne peuvent pas plaire à Dieu."
,"9":"Mais vous n'êtes plus dans la chair: vous vivez dans l'esprit puisque l'Esprit de Dieu habite en vous. Si quelqu'un n'avait pas l'Esprit du Christ, il ne lui appartiendrait pas."
,"10":"Mais le Christ est en vous, et si le corps est mort à cause du péché, l'esprit, est vie pour avoir été sanctifié."
,"11":"Et si l'Esprit de Celui qui a ressuscité Jésus d'entre les morts habite en vous, Celui qui a ressuscité Jésus Christ d'entre les morts, rendra aussi la vie à vos corps mortels, grâce à son Esprit qui habite en vous."
,"12":"Donc frères, rompez avec la chair, vous ne devez plus vivre selon la chair."
,"13":"Car si vous vivez selon la chair, il vous faudra mourir, mais si avec l'Esprit vous faites mourir les oeuvres du corps, vous vivrez."
,"14":"Vous le savez, tous ceux qui sont conduits par l'Esprit de Dieu sont fils et filles de Dieu."
,"15":"Alors, finie la crainte: vous n'avez pas reçu un esprit d'esclaves mais un esprit de fils; c'est lui qui nous pousse à appeler: 'Papa! Père!'"
,"16":"L'Esprit assiste notre esprit et lui redit que nous sommes enfants de Dieu."
,"17":"Etant fils, vous êtes héritiers, héritiers de Dieu, ses héritiers avec le Christ. Et quand nous aurons souffert avec lui, nous serons avec lui dans la Gloire."
,"18":"Je pense que ce que nous souffrons pour un temps limité n'a pas de comparaison avec la Gloire qui nous attend et qui doit se manifester."
,"19":"Le monde créé attend que les fils et filles de Dieu viennent au grand jour: c'est cela qui ne le laisse pas en repos."
,"20":"Car si la création actuellement ne peut rien faire de valable et durable, cela ne vient pas d'elle mais de celui qui lui a imposé ce destin. Il lui reste cependant une espérance:"
,"21":"la création aussi cessera de travailler pour ce qui se défait, et recevra sa part de la liberté et de la gloire des enfants de Dieu."
,"22":"Nous voyons bien que toute la création gémit et souffre comme pour un enfantement."
,"23":"Nous-mêmes, bien que nous ayons reçu l'Esprit comme un premier don, nous gémissons en nous-mêmes, dans l'attente de nos droits de fils et de la rédemption de notre corps."
,"24":"Déjà nous sommes sauvés, mais tout reste une espérance, et dès qu'on voit ce qu'on espére, ce n'est plus l'espérance. Comment espérer ce que déjà on voit?"
,"25":"Espérons donc sans voir, et nous l'aurons si nous persévérons."
,"26":"Nous sommes faibles, mais l'Esprit vient à notre secours. Comment et pour quoi devons-nous prier? Nous ne le savons pas, mais l'Esprit le demande pour nous sans paroles, comme dans un gémissement."
,"27":"Et Celui qui scrute les coeurs comprend les aspirations de l'Esprit, car l'Esprit veut obtenir pour les saints ce qui est de Dieu."
,"28":"Nous savons que pour ceux qui aiment Dieu, ceux qu'il a choisis et appelés, Dieu se sert de tout pour leur bien."
,"29":"Ceux qu'il a connus d'avance, il les a destinés à être comme son Fils, comme à son image, pour qu'il soit le premier-né au milieu de nombreux frères."
,"30":"Ceux qu'il a ainsi destinés, il les a appelés; ceux qu'il a appelés, il les a faits justes et droits; ceux qu'il a faits justes et droits, il leur a donné la Gloire."
,"31":"Que dire de plus? Si Dieu est pour nous, qui sera contre nous?"
,"32":"Il n'a même pas épargné son propre Fils, mais il l'a livré pour nous tous. Comment donc ne nous donnera-t-il pas tout le reste avec lui?"
,"33":"Qui accusera ceux que Dieu appelle? C'est Dieu leur juge."
,"34":"Qui les condamnera? Le Christ qui est mort et, plus encore, ressuscité, qui est à la droite de Dieu et qui intercède en notre faveur?"
,"35":"Qui nous enlèvera cet amour du Christ: une catastrophe, une épreuve, une persécution, la faim, le manque de tout, le danger, le glaive?"
,"36":"Il est bien écrit: A cause de toi nous sommes massacrés tout au long du jour, nous sommes traités comme des brebis à l'abattoir."
,"37":"Mais au milieu de tout, nous restons les vainqueurs grâce à celui qui nous aime."
,"38":"Je sais que ni la mort, ni la vie, ni les anges, ni les forces du monde, ni le présent, ni le futur,"
,"39":"ni les puissances du ciel ou de l'enfer ou quelque autre créa ture ne peut nous priver de cet amour de Dieu dans le Christ Jésus notre Seigneur."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Je veux vous parler sincèrement, dans le Christ, sans aucun mensonge, et j'ai pour moi ma conscience qui parle dans l'Esprit Saint."
,"2":"C'est pour moi une très grande peine et une souffrance continuelle"
,"3":"au point que je voudrais être rejeté et loin du Christ à la place de mes frères, je veux dire mes frères de race."
,"4":"Ils sont Israélites, du peuple adopté par Dieu; sa Gloire est au milieu d'eux avec les alliances, le don de sa Loi, le culte et les promesses."
,"5":"Les grands ancêtres sont les leurs, et le Christ est des leurs selon la chair, lui qui comme Dieu est aussi au-dessus de tout. Béni soit-il éternellement. Amen!"
,"6":"Je ne veux pas parler d'échec pour les promesses de Dieu, car tous les Israélites ne sont pas Israël,"
,"7":"comme déjà les descendants d'Abraham n'étaient pas tous ses enfants. En effet il lui a été dit: Les enfants d'Isaac seront regardés comme ta descendance."
,"8":"Donc il ne suffit pas d'être enfant d'Abraham selon la chair pour être enfant de Dieu: la vraie descendance d'Abraham sont ceux qui lui naissent en vertu de la promesse de Dieu."
,"9":"Et la promesse, la voici: Quand je reviendrai à la même époque, Sara aura un fils."
,"10":"Voyez encore: Rébecca était enceinte de notre ancêtre et portait des jumeaux,"
,"11":"et comme ils n'avaient encore fait ni bien ni mal, seul comptait le choix de Dieu;"
,"12":"tout dépendait, non de leurs oeuvres, mais de celui qui appelle, lorsqu'il fut dit à Rebecca: Le premier sera soumis au plus jeune."
,"13":"Et l'Ecriture dit: J'ai aimé Jacob et non Esaü."
,"14":"Allons-nous dire que Dieu est injuste? Sûrement pas, mais il dit à Moïse:"
,"15":"J'aurai pitié de qui j'ai pitié, et ma compassion sera pour qui je veux."
,"16":"Il ne suffit donc pas de vouloir ou d'arriver le premier: c'est Dieu qui décide d'avoir pitié."
,"17":"Et l'Ecriture dit à propos du Pharaon: Je t'ai mis sur le trône précisément pour montrer ma force et que toute la terre connaisse mon Nom."
,"18":"Ainsi donc, Dieu fait miséricorde quand il le veut, mais aussi il aveugle qui il veut."
,"19":"Bien sûr, tu vas dire: Dieu n'a plus rien à me reprocher puisque je ne peux pas échapper à ce qu'il a décidé."
,"20":"Mais dis donc, ami, qui es-tu pour juger Dieu? Est-ce que l'argile va dire au potier: Que fais-tu de moi?"
,"21":"Le potier est bien libre de faire avec la même boue un vase artistique et un autre pour le service."
,"22":"Donc Dieu supporte très patiemment ces vases qui méritent sa colère et sont tout prêts pour le châtiment: par eux Il veut montrer sa justice et faire connaître sa puissance."
,"23":"Et il montre la richesse de sa gloire avec d'autres vases, les vases de la miséricorde qu'il a préparés d'avance pour la Gloire."
,"24":"C'est ainsi qu'il nous a appelés d'entre les Juifs, et également d'entre les nations païennes."
,"25":"Il le dit dans le livre d'Osée: J'appellerai 'mon peuple' celui qui n'est pas mon peuple, et j'appellerai 'mon aimée' celle qui n'est pas aimée."
,"26":"Et de même qu'on leur disait: 'Vous n'êtes pas mon peuple', on les appellera: 'fils du Dieu vivant'."
,"27":"Parlant d'Israël, Isaïe dit sans hésiter: Même si les fils d'Israël étaient nombreux comme le sable du bord de mer, seulement un reste serait sauvé."
,"28":"Le Seigneur le fera dans ce pays, sans retard et sans se reprendre."
,"29":"Isaïe l'a dit d'avance: Si le Seigneur des armées ne nous avait pas laissé quelques descendants, ce serait comme pour Sodome, nous serions comme Gomorrhe."
,"30":"Et la conclusion? C'est que les nations païennes qui n'étaient pas à la recherche de la vraie droiture l'ont rencontrée - la vraie droiture qui vient de la foi."
,"31":"Et Israël qui s'attachait à une loi de droiture, n'a pas atteint le but de la Loi."
,"32":"Pourquoi? Parce qu'il s'attachait aux oeuvres et non à la foi. Ils ont buté sur la pierre qui fait chuter,"
,"33":"comme il est dit dans l'Ecriture: Voici que je mets dans Sion un caillou sur lequel on butte, une pierre qui fait chuter."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Frères, je désire de tout coeur et je demande à Dieu qu'ils soient sauvés."
,"2":"Je dois dire en leur faveur qu'ils sont pleins d'ardeur pour Dieu, mais c'est une ardeur mal entendue."
,"3":"Ils ne savent pas comment Dieu nous fait justes et ils veulent établir leur propre perfection. C'est pourquoi ils ne sont pas entrés dans le chemin de la droiture selon Dieu."
,"4":"Car le Christ est le but de la Loi, et c'est alors que tout croyant devient juste et saint."
,"5":"Moïse parle bien de devenir juste par la Loi; il a écrit: Celui qui la met en pratique vivra."
,"6":"Mais de son côté la justice qui vient de la foi te dit: Ne dis pas dans ton coeur: Qui montera au ciel? C'est une façon de dire que le Christ devait en descendre."
,"7":"Et ensuite: Qui descendra dans l'abîme? C'est une façon de dire que le Christ devait remonter d'entre les morts."
,"8":"Et ensuite il est dit: La parole est proche de toi, elle est déjà dans ta bouche et dans ton coeur. Il s'agit là de la parole que nous proclamons, et c'est la foi."
,"9":"Tu es sauvé lorsque ta bouche proclame que Jésus est le Seigneur, et que ton coeur croit que Dieu l'a ressuscité d'entre les morts."
,"10":"Le coeur qui croit te donne la vraie droiture, ta bouche qui le proclame te donne le salut."
,"11":"L'Ecriture dit en effet: Aucun de ceux qui croient en lui ne sera déçu."
,"12":"Il n'y a donc pas de différence entre Juifs et Grecs, ils ont un même Seigneur, fort généreux pour tous ceux qui l'invoquent:"
,"13":"Celui qui invoque le nom du Seigneur sera sauvé, quel qu'il soit."
,"14":"Mais peuvent-ils invoquer le Nom du Seigneur s'ils ne croient pas en lui? Peuvent-ils croire en lui si on ne l'a pas proclamé?"
,"15":"Va-t-on le proclamer si on n'a pas été envoyé pour cela? Il est écrit: Comme ils sont beaux à voir les pas de ceux qui apportent la bonne nouvelle."
,"16":"Mais voilà, tous n'acceptent pas la bonne nouvelle. Isaïe dit en effet: Seigneur, qui nous a entendus et a cru?"
,"17":"C'est qu'il faut entendre pour croire, il faut entendre ce qu'on dit du Christ."
,"18":"Alors je demande: N'ont-ils pas entendu? Bien sûr que si: Cette voix s'est fait entendre par toute la terre; ces paroles ont résonné jusqu'aux extrémités du monde."
,"19":"Alors je demande: Comment, Israël n'a pas compris? Et tout de suite Moïse nous dit: Je vous rendrai jaloux d'un peuple qui n'en est pas un; je prends pour vous défier un peuple sans intelligence."
,"20":"Isaïe ensuite ose dire: Ceux qui ne me cherchaient pas m'ont trouvé, je me suis fait connaître de ceux qui ne me demandaient pas."
,"21":"Il ajoute, et c'est pour Israël: Tout le jour j'ai tendu les mains vers un peuple qui n'écoute pas et qui me contredit."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Alors je demande: Comment, Dieu a rejeté son peuple? Sûrement pas. Moi-même je suis un Israélite, de la race d'Abraham, de la tribu de Benjamin."
,"2":"Dieu n'a pas rejeté son peuple, ceux qu'il a connus d'avance. Vous devez savoir ce que l'Ecriture fait dire à Elie, comment il accusait devant Dieu le peuple d'Israël:"
,"3":"Seigneur, ils ont massacré tes prophètes, ils ont détruit tes autels; je reste seul et ils en veulent encore à ma vie."
,"4":"Mais quelle a été la réponse prophétique? Je me suis gardé sept mille hommes qui n'ont pas plié le genou devant Baal."
,"5":"Et c'est la même chose aujourd'hui: il y a un reste élu par grâce."
,"6":"Je dis bien: par grâce, et non pas à cause de leurs oeuvres; sinon ce ne serait plus une grâce."
,"7":"Alors, que dire? Ce qu'Israël cherchait, il ne l'a pas trouvé, mais il y a eu des élus pour le trouver pendant que les autres s'aveuglaient."
,"8":"Il est écrit: Dieu a rendu leur esprit insensible, avec des yeux qui ne voient pas et des oreilles qui n'entendent pas jusqu'à ce jour."
,"9":"Et David dit: Que leur table soit pour eux un filet, un piège, une pierre sur laquelle ils buttent et qui les fait tomber; que ce soit là leur châtiment."
,"10":"Que leurs yeux soient en ténèbres et ne puissent voir, qu'ils marchent en tout temps le dos plié."
,"11":"Je demande alors: Sont-ils tombés pour ne pas se relever? Certainement pas. Grâce à leur chute, les nations païennes ont reçu le salut, et cela va être un défi pour eux."
,"12":"Si par leur chute le monde est devenu riche, et ce qu'ils ont perdu est devenu la richesse des nations, ne faut-il pas espérer mieux encore quand ils seront rétablis?"
,"13":"Ecoutez-moi, vous qui n'êtes pas juifs, je suis apôtre des non-Juifs, et je remplis cette charge de mon mieux."
,"14":"Mais je le fais comme un défi adressé aux miens, car je voudrais en sauver un certain nombre."
,"15":"Voyez: ils sont écartés et le monde est réconcilié; que sera-ce alors quand ils retrouveront leur place? Ce sera le retour des morts à la vie."
,"16":"Quand on donne à Dieu les prémices, toute la masse en est sanctifiée; si la racine est sainte, les branches le sont aussi."
,"17":"Mais voilà, des branches sont tombées, et toi, on t'a pris sur un arbre sauvage pour te greffer sur leur arbre: tu profites ainsi de la racine et de la sève de l'olivier."
,"18":"Ne te moque donc pas de ceux qui sont tombés. Comment voudrais-tu te moquer? Ce n'est pas toi qui portes la racine, mais c'est la racine qui te porte. "
,"19":"Tu dis: ils sont tombés pour que je prenne leur place. Oui, ils n'ont pas cru et ils sont tombés, et toi, tu es là grâce à la foi."
,"20":"Mais prends garde, laisse là ton orgueil et surveille tes pas."
,"21":"Si Dieu n'a pas épargné les branches naturelles, il le fera encore moins pour toi."
,"22":"Tu peux le voir, Dieu est généreux et sévère à la fois. Sévère, puisqu'ils sont tombés; bon avec toi si tu persévères dans le bien. Autrement tu seras retranché toi aussi."
,"23":"Mais eux, s'ils ne persévèrent pas dans le refus de croire, ils seront greffés, car Dieu est capable de les greffer de nouveau."
,"24":"Tu as bien été greffé toi-même, contre nature, sur le bon olivier, alors que par nature tu étais d'un olivier sauvage; ce sera bien plus facile et plus naturel de les greffer sur leur propre olivier."
,"25":"Frères, je veux que vous compreniez ce mystère au lieu d'être trop sûrs de vous-mêmes. Une partie d'Israël restera dans son aveuglement jusqu'à ce que l'ensemble des nations soit entré,"
,"26":"et à ce moment c'est Israël tout entier qui sera sauvé, comme le dit l'Ecriture: De Sion viendra le rédempteur pour éloigner de Jacob ses fautes contre Dieu."
,"27":"Et voici l'alliance que je ferai avec eux après leur avoir enlevé leurs péchés."
,"28":"Du point de vue de l'Evangile, ils sont des adversaires, et c'est pour votre bien. Mais si l'on s'en tient à l'élection, ils sont aimés à cause de leurs pères."
,"29":"Car Dieu ne revient pas sur ses dons ni sur son appel."
,"30":"Voyez: alors que vous étiez loin de l'obéissance à Dieu, c'est leur désobéissance qui vous a obtenu la grâce."
,"31":"Eux aussi auront droit à sa miséricorde après cette désobéissance qui vous a valu la miséricorde."
,"32":"Ainsi Dieu nous fait tous passer par la désobéissance, afin de montrer à tous sa miséricorde."
,"33":"Y a-t-il quelque chose d'aussi profond que la richesse, et la sagesse et la connaissance de Dieu? Comment expliquer ses décisions, comment reconnaître tous ses chemins?"
,"34":"Qui est entré dans les pensées du Seigneur? Qui pourrait être son conseiller?"
,"35":"Qui lui a donné le premier pour que Dieu ait à lui rendre?"
,"36":"Tout vient de lui, tout arrive par lui, tout va vers lui. Gloire à lui pour les siècles. Amen!"
}`)
	CurrentBook.AddChapter(12, `{
"1":"Je vous en prie, frères, au nom de Dieu et de sa grande tendresse, offrez à Dieu votre propre personne comme une victime vivante et sainte, capable de lui plaire: c'est là l'hommage d'une créature raisonnable."
,"2":"Ne vous laissez pas façonner par ce monde, quand c'est le renouveau intérieur qui doit vous transformer. Alors vous pourrez reconnaître ce que Dieu veut, ce qui est bien, ce qui lui plaît, ce qui est parfait."
,"3":"Avec la grâce que j'ai reçue, je peux dire à chacun et à tous: ayez de l'initiative mais n'exagérez pas; que chacun fasse usage, mais avec sagesse, des dons de la foi qu'il a reçus de Dieu."
,"4":"Prenez l'exemple de notre corps: il est un et il a plusieurs membres, et les membres ont différentes fonctions."
,"5":"Nous, de même, nous sommes un seul corps dans le Christ. Les membres sont solidaires les uns des autres,"
,"6":"et nous avons des capacités différentes selon le don que nous avons reçu. Si tu es prophète, c'est pour donner les lumières de la foi."
,"7":"Si tu es diacre, assure ton service; si tu es chargé de la formation, enseigne."
,"8":"Si tu es prédicateur, prêche; si tu es au service de l'entraide, fais-le simplement; si tu es responsable, sois actif; si tu aides ceux qui souffrent, fais-le avec joie."
,"9":"L'amour doit être sincère, fuyez ce qui est mal et cherchez toujours le bien."
,"10":"Que l'amour fraternel soit inventif, et tâchez d'être les premiers dans le respect mutuel."
,"11":"Soyez actifs et non paresseux; soyez enthousiastes grâce à l'Esprit et servez le Seigneur."
,"12":"Gardez la joie de l'espérance, supportez les épreuves et persévérez dans la prière."
,"13":"Partagez avec les frères en difficulté et sachez recevoir chez vous."
,"14":"Bénissez ceux qui vous persécutent, ne les maudissez pas mais priez pour eux."
,"15":"Partagez la joie de ceux qui sont joyeux et les larmes de ceux qui pleurent."
,"16":"Mettez-vous d'accord, ne rêvez pas de choses extraordinaires, mais soyez à l'aise dans ce qui est humble; et ne vous prenez pas pour des sages."
,"17":"Ne rendez à personne mal pour mal, mais que tous soient témoins de votre bon vouloir."
,"18":"Si c'est possible, essayez de vivre en paix avec tous."
,"19":"Ne vous faites pas justice vous-mêmes mais laissez agir la justice de Dieu, car il est écrit: A moi la vengeance, c'est moi qui rendrai à chacun - parole du Seigneur."
,"20":"Au contraire, si ton ennemi a faim, donne-lui à manger, s'il a soif, donne-lui à boire. Et ce seront autant de charbons brûlants sur sa conscience."
,"21":"Tu ne te laisseras pas vaincre par le mal, mais tu vaincras le mal par le bien."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Chacun dans cette vie doit obéir aux représentants de l'autorité. Car il n'y a d'autorité que celle qui vient de Dieu, et les charges publiques ont été voulues par Dieu."
,"2":"Donc celui qui résiste à l'autorité s'insurge contre un décret de Dieu, et ceux qui s'insurgent préparent leur propre condamnation."
,"3":"On n'a pas à craindre les chefs quand on fait le bien, mais quand on fait le mal. Veux-tu vivre sans avoir à craindre les autorités? Fais-le bien et tu recevras des éloges."
,"4":"Ce sont des agents de Dieu qui t'aident à faire le bien, et si tu agis mal, fais bien attention: ce n'est pas pour rien qu'ils sont armés. Ils sont encore les agents de Dieu quand ils punissent les malfaiteurs."
,"5":"Donc il faut obéir, et pas seulement par peur du châtiment mais en conscience."
,"6":"C'est ainsi que vous devez payer les impôts. C'est encore comme fonctionnaires de Dieu qu'ils en exigent le paiement."
,"7":"Donc payez à chacun ce que vous lui devez: l'impôt s'il a droit à l'impôt, la taxe s'il a droit à la taxe, l'obéissance si c'est l'obéissance, le respect si c'est le respect."
,"8":"Tâchez de ne rien devoir à personne, si ce n'est l'amour que vous vous devez entre vous. Et quand on aime le prochain, on est en règle avec la Loi:"
,"9":"Tu aimeras le prochain comme toi-même. Cette seule parole résume les commandements: Tu ne commettras pas l'adultère, tu ne tueras pas, tu ne voleras pas, tu ne désireras pas, et tous les autres encore. "
,"10":"L'amour est donc la parfaite réponse à la Loi: si on aime, on ne fait plus de mal au prochain."
,"11":"Comprenez le temps où nous sommes: c'est l'heure de nous réveiller, car notre salut est déjà plus proche que lorsque nous sommes venus à la foi."
,"12":"La nuit est bien avancée et le jour est proche. Laissons donc là les oeuvres des ténèbres, et revêtons une armure de lumière."
,"13":"Agissons noblement, comme en plein jour: pas d'excès de table et d'alcool, pas de coucheries ni d'impureté, pas de querelles ni de jalousie."
,"14":"Revêtez-vous du Seigneur Jésus, le Christ, et ne faites pas ce que la chair vous suggère; ne vous mettez pas au service de ses convoitises."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Soyez compréhensifs avec celui qui n'a pas une foi assurée. Pas de discussions qui tournent à la division."
,"2":"L'un se croit autorisé à manger de tout, l'autre est moins sûr et reste végétarien."
,"3":"Celui qui mange ne doit pas mépriser l'autre, et celui qui ne mange pas ne doit pas le critiquer: le Seigneur l'a accepté comme il est."
,"4":"Qui es-tu pour juger le serviteur d'un autre? Qu'il soit fort ou qu'il tombe, c'est l'affaire de son maître, mais il sera fort car son maître a tout pouvoir pour le fortifier."
,"5":"Pour l'un, tous les jours ne portent pas bonheur, pour l'autre, tous les jours sont bons. Que chacun suive son opinion en toute liberté."
,"6":"Celui qui choisit une date le fait pour le Seigneur, et si on mange, on mange pour le Seigneur et on rend grâces à Dieu - et si on s'abstient de manger, c'est pour le Seigneur et pour lui rendre grâces."
,"7":"Aucun de nous ne vit pour lui-même, et aucun ne meurt pour son propre compte."
,"8":"Si nous vivons, nous vivons pour le Seigneur, et si nous mourons, nous mourons pour le Seigneur. Vivants ou morts, nous appartenons au Seigneur,"
,"9":"et c'est pourquoi le Christ devait mourir et ensuite revivre pour être le Seigneur des morts et des vivants."
,"10":"Alors pourquoi juger ton frère? Pourquoi critiquer ton frère? Nous nous retrouverons tous pareillement au tribunal de Dieu."
,"11":"Comme le dit l'Ecriture: Par ma vie, dit le Seigneur, tout genou pliera devant moi et toute langue reconnaîtra la vérité devant Dieu."
,"12":"Il est donc clair que chacun de nous rendra compte à Dieu pour lui-même."
,"13":"Cessons de nous examiner mutuellement. Examinons plutôt comment ne pas donner à nos frères des occasions de chute ou de scandale."
,"14":"Je sais, et j'en suis convaincu devant le Seigneur Jésus, que rien n'est impur en soi. Mais cela devient impur pour celui qui le croit impur."
,"15":"Donc, si ton manger offense ton frère, tu ne vis pas selon l'amour. Ne va pas détruire avec ton manger celui pour qui le Christ est mort."
,"16":"Ne provoquez pas la critique quand votre position est bonne."
,"17":"Vous savez que le Royaume de Dieu n'est pas une affaire d'aliments et de boissons, mais de vie droite, de paix et de joie dans l'Esprit Saint."
,"18":"Si vous servez le Christ de cette façon-là, vous serez agréables à Dieu et les gens vous apprécieront."
,"19":"Travaillez donc pour la paix et pour ce qui nous aide à grandir ensemble."
,"20":"Ne défaisons pas le travail de Dieu pour une affaire de nourriture, car même si tout aliment est pur, il devient impur pour celui qui agit contre sa conscience."
,"21":"Il vaut mieux ne pas manger de viande ou ne pas boire de vin, ou n'importe quoi d'autre qui va heurter notre frère."
,"22":"Garde ta conviction pour toi-même devant Dieu: heureux celui qui use de tout d'accord avec sa conscience!"
,"23":"Mais si quelqu'un mange quand sa conscience proteste, sa propre conviction le condamne; tout ce qu'on fait contre sa conviction est péché."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Si vraiment nous sommes forts, nous devons porter les faiblesses de ceux qui n'ont pas cette capacité, au lieu de faire ce qui nous plaît."
,"2":"Que chacun cherche ce qui plaît à son prochain, ce qui est bon et le fera grandir."
,"3":"Voyez que le Christ n'a pas fait ce qui lui plaisait. Il est écrit: Les insultes de ceux qui t'insultaient sont retombées sur moi."
,"4":"Et ce qui a été ainsi écrit d'avance l'a été pour notre instruction, pour qu'avec la persévérance et le réconfort des Ecritures nous sachions espérer."
,"5":"Que Dieu, avec la persévérance et le réconfort, vous donne aussi de vivre en bon accord selon l'esprit du Christ Jésus."
,"6":"Alors vous pourrez rendre gloire à Dieu, le Père du Christ Jésus, notre Seigneur, d'un seul coeur et d'une seule voix."
,"7":"Acceptez-vous les uns les autres comme le Christ vous a acceptés pour la gloire de Dieu."
,"8":"Je n'hésite pas à le dire: le Christ s'est fait le serviteur du peuple Juif pour tenir les promesses faites à leurs pères, parce que Dieu est fidèle."
,"9":"Quant aux autres peuples, ils peuvent rendre gloire à Dieu pour sa miséricorde, comme dit l'Ecriture: Pour tout cela je dirai tes bienfaits à travers les nations et je chanterai ton nom."
,"10":"Et encore: Toutes les nations, partagez la joie de son peuple."
,"11":"Et encore: Chantez le Seigneur, toutes les nations, louez-le tous les peuples."
,"12":"Isaïe dit encore: Plante qui reverdit, Jessé aura un descendant, il gouvernera les peuples, ils mettront en lui leurs espérances."
,"13":"Que le Dieu de l'espérance vous donne de croire dans la joie et dans la paix, et qu'il fasse grandir en vous l'espérance par la force de l'Esprit Saint."
,"14":"Pour ma part, frères, je suis sûr que vous êtes pleins de bonnes dispositions, et que vous avez toutes les connaissances nécessaires pour vous soutenir les uns les autres."
,"15":"Pourtant j'ai pris la liberté de vous parler un peu franchement et de vous rappeler certaines choses. Je le fais avec l'autorité que Dieu m'a donnée"
,"16":"quand il a fait de moi le chargé d'affaires du Christ Jésus parmi les nations païennes. Oui, je suis devenu le prêtre de l'Evangile de Dieu pour que ces nations deviennent une offrande agréable à Dieu, sanctifiée par l'Esprit Saint."
,"17":"J'ai donc dans les choses de Dieu une certaine fierté, comme on peut l'avoir avec le Christ Jésus."
,"18":"Mais je n'oserais pas parler d'autre chose que ce que le Christ a fait à travers moi pour évangéliser les païens, par la parole et par les actes,"
,"19":"avec quantité de signes et de miracles, et la puissance de l'Esprit. Depuis Jérusalem jusqu'à l'Illyrie, de tous côtés j'ai fait passer l'Evangile du Christ."
,"20":"Je me suis bien gardé d'annoncer l'Evangile là où déjà on connaissait le Christ, car je ne voulais pas profiter des fondations posées par un autre."
,"21":"D'ailleurs il est écrit: Ceux qui n'ont pas reçu le message le verront, ceux qui n'avaient rien entendu le connaîtront."
,"22":"J'avais trop de travail pour aller chez vous,"
,"23":"mais puisque je le désire depuis si longtemps et que maintenant il n'y a plus de place pour moi dans ces régions,"
,"24":"je le ferai quand j'irai en Espagne. J'espère bien vous voir en passant et, quand j'aurai suffisamment profité de votre compagnie, vous me remettrez sur mon chemin."
,"25":"Pour l'instant, c'est l'aide aux saints qui me fait aller à Jérusalem."
,"26":"Car en Macédoine et en Achaïe, ils ont pensé bon de faire une collecte en faveur des frères de Jérusalem qui sont dans la détresse."
,"27":"Ils ont voulu le faire, et en réalité ils le leur devaient. Ceux qui ne sont pas Juifs ont profité de leurs richesses spirituelles; il était donc juste qu'ils organisent pour eux une aide matérielle."
,"28":"Aussitôt cela terminé, dès que j'aurai mis le point final à cette affaire, je partirai pour l'Espagne en passant par chez vous,"
,"29":"et je sais que j'arriverai chez vous chargé de toutes les bénédictions du Christ."
,"30":"Je vous en prie donc au nom du Christ Jésus, notre Seigneur, et au nom de l'amour, fruit de l'Esprit, priez Dieu pour moi, luttez avec insistance"
,"31":"pour que j'échappe aux Juifs de Judée qui s'opposent à la foi, et pour que cette aide soit bien reçue des frères de Jérusalem."
,"32":"De cette façon j'arriverai chez vous avec joie, si Dieu le veut, et je me reposerai parmi vous."
,"33":"Que le Dieu de paix soit avec vous tous. Amen!"
}`)
	CurrentBook.AddChapter(16, `{
"1":"Je vous recommande notre soeur Phébé, diaconesse de l'Eglise de Cenchrées."
,"2":"Recevez-la chrétiennement comme il se doit pour des saints. Aidez-la en tout ce que vous pouvez faire pour elle. Sachez que beaucoup sont en dette avec elle, moi le premier."
,"3":"Saluez Prisca et Aquila, mes collaborateurs dans le Christ Jésus."
,"4":"Ils ont risqué leur tête pour moi et je leur suis reconnaissant comme aussi les Eglises des nations."
,"5":"Saluez aussi l'Eglise qui se réunit chez eux. Salut à mon cher Epénète, le premier converti chrétien en Asie. "
,"6":"Saluez Marie qui a tellement travaillé pour vous."
,"7":"Saluez Andronique et Junias, mes compatriotes qui ont été en prison avec moi. Ce sont des apôtres éminents, convertis au Christ avant moi."
,"8":"Saluez Ampliatus que j'aime bien dans le Seigneur."
,"9":"Saluez mon collaborateur Urbanus et mon cher Stachys."
,"10":"Saluez Apelles, toujours ferme dans le Christ, et la famille d'Aristobule."
,"11":"Saluez mon compatriote Hérodion. Saluez les gens de chez Narcisse, qui sont Chrétiens."
,"12":"Saluez Tryphène et Tryphose, bonnes travailleuses pour le Seigneur. Saluez ma chère Persis qui travaille bien pour le Seigneur."
,"13":"Saluez Rufus, l'élu du Seigneur, et sa mère qui est aussi la mienne."
,"14":"Saluez Asyncrite, Phlégon, Hermès, Patrobas, Hermas et tous les frères avec eux."
,"15":"Saluez Philologue et Julie, Nérée et sa soeur, et Olympas et tous les saints avec eux."
,"16":"Saluez-vous mutuellement et donnez-vous le saint baiser. Toutes les Eglises du Christ vous saluent."
,"17":"Je vous en prie, frères, prenez garde à ceux qui créent des divisions et des scandales en sortant de la doctrine qu'on vous a enseignée. Evitez tous ces gens-là."
,"18":"Ils ne servent pas le Christ, notre Seigneur, mais leur propre ventre, et ils trompent les ingénus avec leurs belles paroles pleines de piété."
,"19":"Tout le monde sait que vous êtes ouverts à la foi, et j'en suis heureux pour vous. Mais je veux que vous soyez avisés pour le bien, et fermes contre le mal."
,"20":"Le Dieu de la paix écrasera Satan sous vos pieds d'ici peu. Que la grâce de Jésus, notre Seigneur, soit avec vous!"
,"21":"Mon collaborateur Timothée vous salue, également mes compatriotes Lucius, Jason et Sosipatros."
,"22":"Moi aussi, Tertius, qui ai écrit la lettre, je vous salue dans le Seigneur."
,"23":"Gayus, qui me loge chez lui, et toute l'Eglise avec moi vous saluent."
,"24":"Saluts d'Eraste, le trésorier de la ville, et de notre frère Quartus."
,"25":"Gloire à Celui qui est capable de vous garder fermes dans l'Evangile que j'annonce et la proclamation du Christ Jésus!,Voici que se découvre le projet mystérieux gardé secret durant tant de siècles,"
,"26":"et qui maintenant est mis en lumière grâce aux écrits des prophètes. Il y a là une décision du Dieu éternel, et toutes les nations devront accueillir la foi."
,"27":"A Dieu, seul sage, la gloire pour les siècles par Jésus Christ! Amen."
}`)

}
func FR_LBDCC_LoadNPTTChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Lettre de Paul, serviteur de Dieu, apôtre de Jésus Christ, pour mener les élus de Dieu à la foi et, par la religion, à la connaissance de la vérité."
,"2":"Elle nous fait espérer la vie éternelle que, depuis toujours, le Dieu qui ne ment pas nous avait promise."
,"3":"Au moment fixé il nous a parlé en toute clarté, et c'est le message qui m'a été confié par une décision de Dieu, notre Sauveur."
,"4":"Salut à toi, Tite, mon cher enfant dans la foi que nous partageons ensemble. Reçois grâce et paix de Dieu le Père et du Christ Jésus, notre Sauveur!"
,"5":"Si je t'ai laissé en Crête, c'était pour que tu achèves la remise en ordre, et que tu établisses dans chaque ville des anciens, comme je te l'avais ordonné."
,"6":"Il te faut des gens irréprochables, hommes d'une seule femme. Il faut que leurs enfants aient la foi et qu'on ne puisse pas dire qu'ils se conduisent mal et n'obéissent pas."
,"7":"L'évêque est l'administrateur de Dieu; il doit donc être au-dessus de tout reproche. Ni arrogant, ni coléreux, ni buveur, ni querelleur, ni intéressé,"
,"8":"mais au contraire hospitalier, ami du bien, homme de bon jugement, juste, pieux, maître de lui-même."
,"9":"Quand il parle, il doit s'attacher à ce qui est sûr, en accord avec la doctrine. Il doit être capable de prêcher la saine doctrine et de réfuter les opposants."
,"10":"Car il y a beaucoup d'esprits rebelles et de beaux parleurs qui trompent leur monde; très souvent ils sont d'origine juive."
,"11":"Il faut leur fermer la bouche quand ils parlent de travers de façon très intéressée, ou sinon, ils retournent des familles entières."
,"12":"Un homme de leur race, leur propre prophète, a dit: 'Crétois, toujours menteurs; sales bêtes et ventres fainéants!'"
,"13":"Il a dit vrai. C'est pourquoi tu les reprendras sévèrement afin que leur foi reste saine."
,"14":"Il ne faut pas qu'ils prennent au sérieux les fables juives, les règles données par des gens qui tournent le dos à la vérité."
,"15":"Tout est pur pour ceux qui sont purs, mais rien n'est pur pour les gens impurs, c'est-à-dire les infidèles, puisque même leur esprit et leur conscience sont souillés."
,"16":"Ils prétendent connaître Dieu, mais ils le renient par leurs oeuvres. Ce sont des rebelles que Dieu déteste et qui ne valent rien pour aucune oeuvre utile."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Donc tu leur diras comment mettre en pratique la saine doctrine."
,"2":"Les hommes plus âgés devront être sobres, dignes, modérés. Que leur foi soit solide, de même que leur charité et leur endurance."
,"3":"Que les femmes d'âge mûr, de même, aient une conduite digne de saintes personnes: ni médisantes, ni esclaves de l'alcool. Qu'elles soient de bon conseil;"
,"4":"ainsi elles apprendront aux plus jeunes à bien faire, à être équilibrées, à aimer leurs maris et leurs enfants,"
,"5":"à être prudentes, saintes, actives dans leurs foyers, bonnes, soumises à leurs maris. De cette façon personne ne pourra critiquer la parole de Dieu."
,"6":"Invite de même les jeunes à se montrer sérieux"
,"7":"dans tous les domaines. Tu seras pour eux un exemple quand ils verront ta bonne conduite, ton enseignement désintéressé, ta droiture,"
,"8":"ta parole rigoureuse et inattaquable. De cette façon les gens d'en face n'auront rien à nous reprocher et se sentiront plutôt honteux."
,"9":"Les esclaves obéiront à leurs maîtres et chercheront à leur plaire en tout au lieu de les contredire."
,"10":"Pas de petits vols; au contraire ils montreront une honnêteté de tous les moments et ainsi, ils feront estimer la doctrine de Dieu, notre Sauveur."
,"11":"Car le Dieu Sauveur vient de manifester son don à toute l'humanité."
,"12":"Il nous enseigne à rejeter la vie sans Dieu et les désirs propres de ce monde, et à mener dans le temps présent une vie de sobriété, de justice et de sainteté."
,"13":"C'est ainsi que nous devons attendre ce que nous espérons, la manifestation en Gloire de notre grand Dieu et Sauveur Jésus Christ."
,"14":"En donnant pour nous sa propre vie, il voulait nous racheter de toutes fautes, et purifier ceux qui devenaient son peuple, un peuple entièrement donné au bien."
,"15":"Voilà ce que tu diras et prêcheras, avec insistance et avec autorité. Que personne ne se moque de toi."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Tu leur rappelleras la soumission aux chefs et aux autorités. Qu'ils obéissent et soient toujours prêts à faire le bien."
,"2":"Qu'ils soient pleins de compréhension et d'amabilité avec tout le monde au lieu de critiquer et de se quereller."
,"3":"Nous aussi nous avons été de ces gens qui ne réfléchissent pas et n'en font qu'à leur tête, des égarés, esclaves de leurs passions et courant après le plaisir. Nous étions pleins de méchanceté et d'envie, nous étions insupportables et ennemis les uns des autres."
,"4":"Mais voilà que s'est manifestée la bonté de Dieu, notre Sauveur, et son amour pour les humains,"
,"5":"Car ce n'est pas à cause de nos mérites et de nos bonnes oeuvres qu'il nous a sauvés, mais par pure miséricorde. Et ce fut le bain de la seconde naissance, avec le renouveau de l'Esprit Saint "
,"6":"qu'il a largement répandu sur nous grâce à Jésus Christ notre Sauveur."
,"7":"Après avoir été ainsi relevés par sa grâce, nous espérons l'héritage, c'est-à-dire la vie éternelle."
,"8":"Voilà une chose sûre, et tu dois en être convaincu: ceux qui croient en Dieu doivent se soucier d'être les premiers à faire le bien. Voilà ce qui est bon et ce qui est utile pour la société."
,"9":"Quant aux objections sottes, aux grandes explications, disputes et discussions à propos de la Loi, évite-les. Elles sont inutiles et sans intérêt."
,"10":"Reprends celui qui déforme le message. Après un second avertissement tu l'éviteras,"
,"11":"sachant qu'il est un dévoyé: c'est un pécheur qui se condamne lui-même."
,"12":"Je pense t'envoyer Artémas ou Tychique; aussitôt tu viendras me retrouver à Nicopolis car j'ai décidé d'y rester tout l'hiver."
,"13":"Prépare bien le voyage de Zénon, l'avocat, et d'Apollos. Veille à ce que rien ne leur manque."
,"14":"Les gens de chez nous doivent apprendre à se remuer dès qu'une nécessité se présente, au lieu de rester comme des inutiles."
,"15":"Reçois le salut de tous ceux qui sont autour de moi et salue tous ceux qui nous aiment dans la foi. La grâce soit avec vous tous."
}`)

}
func FR_LBDCC_LoadNTAAChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Cher Théophile, dans une première partie j'ai parlé de tout ce que Jésus avait commencé de faire et d'enseigner:"
,"2":"à la fin il donnait par l'Esprit Saint ses instructions aux apôtres qu'il avait choisis, et il était enlevé au ciel."
,"3":"De fait, après sa passion il s'était présenté à eux: il vivait, et il leur en donna bien des preuves. Sur une période de quarante jours il se fit voir et leur parla du Royaume de Dieu."
,"4":"Un jour qu'il les tenait réunis, il leur dit de ne pas s'éloigner de Jérusalem, mais d'attendre ce que le Père avait promis: 'Je vous en ai déjà parlé, leur dit-il:"
,"5":"Jean a baptisé dans l'eau, mais vous, vous serez baptisés d'ici peu dans l'Esprit Saint.'"
,"6":"Ceux qui étaient venus là lui posèrent la question: 'Seigneur, est-ce donc maintenant que tu vas rétablir le royaume d'Israël?'"
,"7":"Il leur dit: 'Vous n'avez pas à savoir les délais et les étapes que seul le Père avait autorité pour décider."
,"8":"Mais vous recevrez la force de l'Esprit Saint: il descendra sur vous et vous serez mes témoins, à Jérusalem d'abord, puis en Judée, en Samarie, et jusqu'au bout du monde.'"
,"9":"Comme il disait cela, il fut enlevé sous leurs yeux; une nuée le cacha bientôt à leurs regards."
,"10":"Ils restaient là à regarder vers le ciel pendant qu'il s'éloignait. Mais voici que deux hommes vêtus de blanc se trouvent à leurs côtés"
,"11":"et leur disent: 'Amis galiléens, pourquoi restez-vous là à regarder vers le ciel? Ce Jésus qu'on vous reprend pour qu'il aille au ciel, il reviendra de la même façon que vous l'avez vu partir vers le ciel.'"
,"12":"Alors ils retournèrent à Jérusalem depuis cet endroit qu'on appelle le Mont des Oliviers: il est tout près de Jérusalem, c'est juste le parcours autorisé un jour de sabbat."
,"13":"Aussitôt arrivés ils montèrent à l'étage, là où se logeaient Pierre, Jean, Jacques et André, Philippe et Thomas, Barthélemy et Matthieu, Jacques fils d'Alphée, Simon le Zélote et Jude frère de Jacques."
,"14":"Tous persévéraient d'un même coeur dans la prière, et avec eux également des femmes, tout spécialement Marie, mère de Jésus, et ses frères."
,"15":"Dans les jours qui suivirent, Pierre prit la parole au milieu des frères; quelque cent vingt personnes étaient là réunies. Il leur dit:"
,"16":"'Frères, il fallait que s'accomplisse l'Ecriture. Car l'Esprit Saint avait annoncé par la bouche de David le geste de Judas: il a guidé ceux qui sont venus arrêter Jésus,"
,"17":"alors qu'il faisait partie de notre groupe et bénéficiait de la même charge."
,"18":"(Cet homme s'est acheté un champ avec ce qu'on lui a payé pour son crime, puis il s'est précipité la tête la première et il s'est ouvert par le milieu: ses intestins sortaient par la blessure!"
,"19":"L'affaire est connue de tous à Jérusalem et l'on a appelé ce champ: Aceldama, ce qui dans leur langue signifie: Champ du Sang.)"
,"20":"Il était bien écrit dans le livre des Psaumes: Que son enclos soit laissé dévasté, et sa tente sans habitants. Mais il est dit aussi: Qu'un autre reçoive sa charge."
,"21":"Voyons donc parmi ceux qui ont été disciples avec nous tout le temps que le Seigneur Jésus a agi au milieu de nous,"
,"22":"depuis le temps où Jean baptisait jusqu'au jour où il nous a été repris; il faut que l'un d'eux soit avec nous le témoin de sa Résurrection.'"
,"23":"On en présenta deux: Joseph Barsabas, surnommé le Juste, et Matthias."
,"24":"Alors ils firent cette prière: 'Toi, Seigneur, qui connais tous les coeurs, montre-nous lequel des deux tu as choisi."
,"25":"Qu'il puisse recevoir cette charge, ce ministère et cet apostolat dont Judas s'est retiré pour aller à la place qui lui correspondait.'"
,"26":"On les fit tirer au sort, et le sort tomba sur Matthias. Il se retrouva donc parmi les apôtres avec les Onze."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Lorsqu'arriva la fête de la Pentecôte, ils étaient tous réunis."
,"2":"Un bruit soudain se fit entendre dans le ciel, comme une violente rafale, et il remplit toute la maison où ils se trouvaient."
,"3":"Ils virent comme un feu qui se divisait, et sur chacun d'eux se posait une des langues de ce feu."
,"4":"Tous furent remplis de l'Esprit Saint et ils se mirent à parler en d'autres langues dans lesquelles l'Esprit leur donnait de s'exprimer."
,"5":"Il y avait alors à Jérusalem des Juifs de passage, des croyants venus de toutes les nations qui sont sous le ciel."
,"6":"Et ces gens, quel que soit leur dialecte, les entendirent s'exprimer dans leur propre langue, car le bruit qui s'était produit avait attiré la foule. Ils n'en revenaient pas!"
,"7":"Ils étaient stupéfaits, étonnés: 'Ce sont tous des Galiléens, disaient-ils, et voyez comme ils parlent!"
,"8":"Chacun de nous les entend s'exprimer dans sa propre langue."
,"9":"Que nous soyons Parthes ou Mèdes ou Elamites, habitants de Mésopotamie, de Judée ou de Cappadoce, du Pont et de l'Asie,"
,"10":"de Phrygie et de Pamphylie, d'Egypte ou de la Libye en allant sur Cyrène,"
,"11":"que nous soyons des Juifs installés à Rome ou des prosélytes, des Crétois ou des Arabes, nous les entendons proclamer dans nos diverses langues les merveilles de Dieu!'"
,"12":"Ils étaient tous stupéfaits et se demandaient les uns aux autres ce que cela signifiait."
,"13":"Certains répondaient en riant: 'Ils ont simplement bu plus que leur compte.'"
,"14":"C'est alors que Pierre s'avança et prit la parole; les Onze étaient avec lui. Il leur cria: 'Ecoutez donc, amis Juifs et vous tous qui êtes de passage à Jérusalem, j'ai quelque chose à vous apprendre."
,"15":"Ne pensez pas que nous avons bu: il n'est encore que neuf heures du matin."
,"16":"C'est simplement ce qu'avait annoncé le prophète Joël:"
,"17":"Dans les derniers jours, dit Dieu, voici ce qui aura lieu: je communiquerai mon Esprit aux humains, quels qu'ils soient. Vos fils et vos filles prophétiseront, vos jeunes auront des visions, et vos vieillards des révélations en songes."
,"18":"Même sur mes serviteurs, sur mes servantes, je répandrai mon Esprit en ces jours-là et ils prophétiseront."
,"19":"Je réaliserai des prodiges là-haut dans le ciel et des signes ici-bas sur la terre: sang et feu et nuée ardente."
,"20":"Le soleil se changera en ténèbres et la lune en sang avant la venue du grand jour du Seigneur."
,"21":"Alors sera sauvé, quel qu'il soit, celui qui invoquera le Nom du Seigneur."
,"22":"Hommes d'Israël, écoutez bien ces paroles: Dieu avait accrédité au milieu de vous un homme, Jésus de Nazareth. Dieu lui avait donné de faire au milieu de vous des miracles, des choses étonnantes et des signes, vous le savez tous."
,"23":"Cependant vous l'avez livré, vous l'avez fait supplicier et mourir par la main des païens; cela répondait à un plan de Dieu qui d'avance avait prévu cela."
,"24":"Mais Dieu l'a délivré des douleurs de la mort et l'a ressuscité: le royaume des morts ne pouvait pas le garder."
,"25":"Voyez ce que David dit à son sujet: Je garde toujours le Seigneur devant mes yeux, s'il se tient à ma droite, qui pourra m'ébranler?"
,"26":"J'en ai le coeur joyeux, ma langue le chante, même ma chair en éprouve sécurité;"
,"27":"car tu ne donneras pas mon âme au royaume des morts, tu ne voudras pas pour ton fidèle l'expérience de la corruption."
,"28":"Tu me feras connaître le chemin de la vie, une plénitude de joie en ta présence."
,"29":"Frères, je n'ai pas besoin de vous prouver que notre patriarche David est mort et qu'il a été enterré: son tombeau est toujours là chez nous."
,"30":"Mais il était prophète: Dieu lui avait juré qu'un fils de son sang régnerait sur son trône et, sachant cela,"
,"31":"quand il parlait de ne pas rester au pouvoir de la mort et de ne pas connaître la corruption de sa chair, il avait en vue la résurrection du Messie."
,"32":"C'est ainsi que Dieu a ressuscité Jésus: nous en sommes tous témoins."
,"33":"Une fois élevé à la droite de Dieu, Jésus a reçu du Père le don qu'il promettait, c'est-à-dire l'Esprit Saint, et il l'a répandu: c'est ce que vous venez de voir et d'entendre."
,"34":"David n'était pas monté au ciel, mais il avait dit: Le Seigneur a dit à mon Seigneur: Siège à ma droite,"
,"35":"le temps que je fasse de tes ennemis un escabeau pour tes pieds."
,"36":"Toute la maison d'Israël doit donc savoir en toute certitude que Dieu a fait Seigneur et Messie ce Jésus que vous avez crucifié.'"
,"37":"En entendant cela, tous furent pris de remords. Ils dirent à Pierre et aux autres apôtres: 'Frères, que devons-nous faire?'"
,"38":"Pierre leur dit: 'Repentez-vous et que chacun de vous se fasse baptiser au nom de Jésus, le Messie, pour obtenir le pardon de ses péchés. Alors vous recevrez le don de l'Esprit Saint."
,"39":"Car la promesse est pour vous, pour vos enfants et pour tous ceux que le Seigneur Dieu voudra appeler, même s'ils se sont éloignés.'"
,"40":"Pierre continua et insista, leur disant bien d'autres choses. Il les pressait et leur répétait: 'Sauvez-vous, laissez là cette génération égarée!'"
,"41":"Beaucoup de gens accueillirent ses paroles et furent baptisés; ce jour-là près de trois mille personnes vinrent s'ajouter."
,"42":"Elles venaient de façon assidue pour l'enseignement des apôtres, le partage communautaire, la fraction du pain et les prières."
,"43":"Tout le monde en était impressionné, d'autant qu'à Jérusalem de nombreux signes et prodiges se réalisaient par les mains des apôtres."
,"44":"Tous ceux qui avaient cru se retrouvaient ensemble: ils mettaient tout en commun"
,"45":"et vendaient leurs propriétés, leurs biens, partageant avec tous ceux qui étaient dans le besoin."
,"46":"Ils se retrouvaient tous les jours avec un même entrain dans le Temple; ils avaient à leur domicile la fraction du pain et ils prenaient leur nourriture dans la joie et la simplicité du coeur."
,"47":"Ils louaient Dieu et tout le peuple leur était favorable; le Seigneur amenait de jour en jour à l'Eglise ceux qu'il voulait sauver."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Pierre et Jean montèrent un jour au Temple en milieu d'après-midi, à l'heure de la prière."
,"2":"On venait d'y amener un homme infirme de naissance. Chaque jour on le déposait à la Belle Porte, une des portes du Temple, et il demandait l'aumône à ceux qui franchissaient l'enceinte du Temple."
,"3":"Comme Pierre et Jean étaient sur le point d'entrer au Temple, il leur demanda l'aumône."
,"4":"Alors Pierre le fixe du regard, tout comme Jean, et il lui dit: 'Regarde-nous!'"
,"5":"L'homme ne les lâchait pas du regard, car il s'attendait à recevoir quelque chose."
,"6":"Mais Pierre lui dit: 'Je n'ai ni or ni argent, je te donnerai ce que j'ai: au nom du Messie, Jésus de Nazareth, lève-toi et marche!'"
,"7":"Pierre le prend de la main et le met debout: l'autre aussitôt sent que ses pieds et ses chevilles deviennent fermes."
,"8":"Il saute, se met sur pieds et commence à marcher, puis il entre au Temple avec eux, marchant, sautant et rendant grâces à Dieu."
,"9":"Tout le monde le voit marcher et rendre grâces à Dieu,"
,"10":"et alors on le reconnaît: 'C'est lui le mendiant de la Belle Porte du Temple!',Cela produisit un vrai choc: tous étaient stupéfaits de ce qui venait de lui arriver. "
,"11":"L'homme ne quittait pas Pierre et Jean, si bien que tout le peuple accourut et se retrouva autour d'eux au Portique de Salomon, incapable de dire un mot."
,"12":"Alors Pierre s'adressa au peuple: 'Hommes d'Israël, cela vous étonne? Vous nous regardez comme si nous avions un pouvoir pour faire marcher cet homme, ou comme si nous étions des saints."
,"13":"Mais non, c'est le Dieu d'Abraham, d'Isaac et de Jacob qui vient de glorifier Jésus, son serviteur. Vous l'avez livré, et quand Pilate voulait le relâcher, vous l'avez renié."
,"14":"Vous avez demandé la grâce d'un assassin et vous avez renié le juste, le saint."
,"15":"Celui que vous avez tué était le Prince de la vie, et Dieu l'a relevé d'entre les morts: nous en sommes les témoins."
,"16":"Voyez ce que peut la foi en son Nom: son Nom vient de remettre sur pieds cet homme que vous voyez et que vous connaissez. La foi qui s'appuie sur Jésus lui a rendu la santé sous vos yeux à tous."
,"17":"Maintenant, frères, je sais que vous avez agi par ignorance, tout comme vos chefs,"
,"18":"et c'est ainsi que Dieu a accompli ce qu'il disait par la bouche de tous les prophètes, que son Messie devait souffrir."
,"19":"Il faut donc vous repentir et vous convertir pour que vos péchés soient effacés."
,"20":"Alors le Seigneur fera venir des temps meilleurs et il vous enverra ce Messie qui vous est destiné: Jésus lui-même."
,"21":"Car le ciel va le garder jusqu'au moment où l'univers sera restauré, comme Dieu l'a annoncé dans le passé par la bouche de ses saints prophètes."
,"22":"Moïse a dit: Le Seigneur votre Dieu fera surgir d'entre vos frères un prophète comme moi; vous l'écouterez, vous ferez tout ce qu'il vous dira."
,"23":"Si quelqu'un n'écoute pas ce prophète, il sera retranché de son peuple."
,"24":"Et à la suite de Moïse, tous les prophètes qui ont parlé, en commençant par Samuel, ont annoncé les jours présents."
,"25":"N'êtes-vous pas les héritiers des prophètes, le peuple de l'Alliance que Dieu a faite avec vos pères? Il a bien dit à Abraham: Toutes les familles humaines seront bénies à travers ta descendance."
,"26":"C'est donc pour vous d'abord que Dieu a ressuscité son Serviteur. Il l'a envoyé pour vous donner la bénédiction dès le moment où chacun de vous se détournera de sa vie mauvaise."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Ils n'avaient pas fini de parler au peuple quand ils furent pris à partie par les prêtres, le chef de la police du Temple et les Sadducéens."
,"2":"Tout ce monde était très contrarié parce que les apôtres affirmaient la résurrection des morts à propos de Jésus."
,"3":"Ils furent arrêtés et mis sous les verrous en attendant le lendemain, car il était déjà tard."
,"4":"Mais beaucoup de ceux qui avaient écouté leurs paroles crurent. Le nombre des hommes s'éleva à cinq mille."
,"5":"Le lendemain ils furent appelés par les chefs, les Anciens et les maîtres de la Loi de Jérusalem."
,"6":"Le grand-prêtre Anne était là, et aussi Caïphe, Jean, Alexandre et tous ceux qui étaient de la famille des grands-prêtres."
,"7":"Ils firent avancer les apôtres au milieu d'eux et les interrogèrent: 'Avec quelle force avez-vous fait cela, vous? Avec quelle puissance supérieure?'"
,"8":"Alors Pierre, rempli de l'Esprit Saint, leur dit ceci:"
,"9":"'Chefs du peuple et Anciens, on nous demande aujourd'hui des explications pour avoir guéri un infirme. Comment a-t-il été rétabli?"
,"10":"Sachez-le tous, et avec vous tout le peuple d'Israël: c'est grâce au Nom de Jésus de Nazareth, le Messie que vous avez crucifié et que Dieu a relevé d'entre les morts."
,"11":"Il est la pierre dont les constructeurs, c'est-à-dire vous, n'ont pas voulu, et qui est devenue la pierre d'angle."
,"12":"Le salut ne se trouve en aucun autre. Aucun autre Nom sous le ciel n'a été donné aux hommes par lequel nous devrions être sauvés.'"
,"13":"Tous purent apprécier l'assurance de Pierre et de Jean; ils étaient étonnés, voyant que c'étaient des hommes sans études ni préparation. Mais, on le savait, ils avaient été avec Jésus."
,"14":"Les chefs voyaient debout à côté d'eux l'homme qui avait été guéri, de sorte qu'ils ne pouvaient rien dire."
,"15":"Ils donnèrent donc l'ordre de les faire sortir de la salle du Conseil pendant qu'eux-mêmes délibéraient."
,"16":"Ils se posèrent la question: 'Qu'est-ce que nous allons faire avec ces hommes? Pour tous les habitants de Jérusalem il est clair qu'un miracle peu ordinaire s'est réalisé par leurs mains, et nous ne pouvons pas le nier."
,"17":"Empêchons cependant que cela fasse du bruit dans le peuple: faisons-leur des menaces pour le cas où ils proclameraient encore ce nom devant qui que ce soit.'"
,"18":"Ils firent donc rappeler les apôtres et ils leur dirent de façon péremptoire de ne donner aucun enseignement au nom de Jésus et de ne pas le nommer."
,"19":"Alors Pierre et Jean leur répondirent: 'Dites-nous s'il est meilleur devant Dieu de vous obéir à vous plutôt qu'à Dieu."
,"20":"Nous ne pouvons pas ne pas parler de ce que nous avons vu et entendu.'"
,"21":"On les menaça de nouveau, puis on les relâcha. On ne voyait pas comment les punir à cause du peuple, car tous rendaient gloire à Dieu à la suite de cet événement:"
,"22":"l'homme qui avait bénéficié de cette guérison miraculeuse était âgé en effet de plus de quarante ans."
,"23":"Une fois relâchés, ils se rendirent auprès des leurs et racontèrent tout ce que les chefs des prêtres et les Anciens leur avaient dit."
,"24":"En entendant cela, les autres élevèrent la voix vers Dieu avec un bel ensemble. Ils dirent: 'Maître, c'est toi qui as fait le ciel et la terre avec tout ce qui s'y trouve, "
,"25":"et tu as dit par la bouche de notre père David, ton serviteur: Pourquoi tout ce tapage des nations? Voyez ces peuples et leur projet fou."
,"26":"Les rois de la terre se sont alliés, les grands chefs se sont soulevés contre le Seigneur et contre son Christ."
,"27":"C'est bien vrai qu'il y a eu un complot dans cette ville contre ton saint serviteur Jésus que tu avais consacré: Hérode et Ponce Pilate, les païens et les peuples d'Israël."
,"28":"Ils n'ont fait que réaliser ce que toi-même avais décidé et préparé."
,"29":"Maintenant donc, Seigneur, vois leurs menaces et donne à tes serviteurs de dire ta parole avec assurance,"
,"30":"alors que tu frappes un grand coup et que surviennent des guérisons, des miracles et des prodiges par le Nom de Jésus, ton saint serviteur.'"
,"31":"A ce moment de leur prière, le sol trembla là où ils étaient réunis. Tous furent remplis de l'Esprit Saint et ils se mirent à proclamer la parole de Dieu avec assurance."
,"32":"La multitude des croyants n'avait qu'un coeur et une âme; aucun d'eux ne considérait comme sien ce qui lui appartenait, mais ils mettaient tout en commun."
,"33":"Avec beaucoup de force les apôtres rendaient témoignage à la résurrection du Seigneur Jésus: c'était pour tous un temps de grâce exceptionnel."
,"34":"Aucun d'entre eux n'était dans le besoin, car tous ceux qui avaient des champs, des maisons, les vendaient et apportaient l'argent de la vente."
,"35":"Ils le déposaient aux pieds des apôtres et on le répartissait selon les besoins de chacun."
,"36":"C'est ce que fit Joseph, un Lévite originaire de Chypre que les apôtres surnommèrent Barnabé, c'est-à-dire: Notre Consolation."
,"37":"Il vendit un champ dont il était propriétaire, apporta le prix de la vente et le déposa aux pieds des apôtres."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Un homme appelé Ananias vendit également une propriété en accord avec sa femme Saphire,"
,"2":"mais il mit de côté une partie de cet argent et sa femme le savait. Il apporta et déposa l'autre partie aux pieds des apôtres."
,"3":"Pierre alors lui dit: 'Qu'est-ce que Satan t'a mis dans la tête, Ananias? Tu as mis de côté une partie de l'argent et tu viens mentir à l'Esprit Saint!"
,"4":"Tu pouvais garder ton champ, tu pouvais le vendre et l'argent t'appartenait; pourquoi as-tu monté cette histoire? Ce n'est pas à des hommes que tu as menti, mais à Dieu.'"
,"5":"En entendant ces paroles, Ananias s'écroula, sans vie: la crainte s'empara de tous ceux qui l'apprirent."
,"6":"Les jeunes se mirent d'accord pour son convoi, ils enlevèrent son corps et le mirent en terre."
,"7":"Mais voici que trois heures plus tard sa femme arrive sans rien savoir de ce qui s'est passé."
,"8":"Pierre lui adresse la parole: 'Dis-moi, c'est à ce prix-là que vous avez vendu le terrain? Elle lui répond: 'Mais oui, c'est exact.'"
,"9":"Et Pierre lui dit: 'Alors, vous vous êtes mis d'accord pour mentir à l'Esprit Saint? Entends les pas de ceux qui viennent d'enterrer ton mari: ils sont à la porte et ils vont t'emporter.'"
,"10":"Au même instant elle s'écroule à ses pieds et rend l'âme. Les jeunes gens étaient de retour; ils la trouvèrent morte et ils l'emportèrent pour l'enterrer à côté de son mari. "
,"11":"A la suite de quoi une grande crainte s'empara de l'Eglise et de tous ceux qui furent mis au courant."
,"12":"Beaucoup de miracles et de choses prodigieuses survenaient dans le peuple par les mains des apôtres. Ils se retrouvaient tous au Portique de Salomon"
,"13":"et personne d'autre n'osait se mêler à eux, mais le peuple les avait en grande estime."
,"14":"Mieux: une quantité d'hommes et de femmes croyait dans le Seigneur et venait augmenter leur nombre."
,"15":"On allait jusqu'à amener les malades à la rue, on les déposait sur des lits ou des civières là où Pierre allait passer, pour que son ombre au moins fasse effet sur l'un d'eux."
,"16":"Une foule de gens accourait des villes voisines de Jérusalem, amenant leurs malades et les personnes possédées par des esprits impurs: tous étaient guéris."
,"17":"Le grand-prêtre intervint avec tous ceux de son groupe, le parti des Sadducéens, car ils étaient décidés à en finir."
,"18":"Ils firent arrêter les apôtres et on les mit dans la prison publique."
,"19":"Mais voici que durant la nuit un ange du Seigneur ouvrit les portes de la prison et les mit dehors en leur disant:"
,"20":"'Allez, vous vous tiendrez dans le Temple et vous redirez au peuple tout ce message porteur de vie.'"
,"21":"Suivant ce qu'on leur disait, ils entrèrent au Temple dès le matin et commencèrent à enseigner. Au même moment le grand-prêtre et son entourage convoquaient le Sanhédrin avec tous les Anciens. C'est alors qu'on envoie un ordre à la prison pour les faire amener. "
,"22":"Les gardes du Temple y vont et ne les trouvent pas; ils reviennent et disent:"
,"23":"'Nous avons trouvé la prison verrouillée, les gardes étaient à leur poste devant les portes, mais quand nous avons ouvert, il n'y avait personne à l'intérieur.'"
,"24":"En entendant ce rapport, le chef de la police du Temple et les chefs des prêtres se demandent ce qui a bien pu leur arriver."
,"25":"Quelqu'un arrive sur ces entrefaites et leur donne la nouvelle: 'Les hommes que vous avez envoyés à la prison sont en ce moment dans le Temple, ils enseignent le peuple.'"
,"26":"Le chef de la police du Temple s'y rend alors avec les auxiliaires et il les amène, mais sans violence, car ils n'ont pas envie de se faire lapider par le peuple"
,"27":"Donc on les amène, on les fait comparaître devant le Sanhédrin et le grand-prêtre les interroge."
,"28":"Il leur dit: 'Nous vous avons strictement défendu d'enseigner au nom de cet homme, mais à présent on n'entend plus que votre enseignement dans Jérusalem et vous nous rendez responsables de la mort de cet homme.'"
,"29":"Alors Pierre leur dit, avec les apôtres: 'C'est à Dieu qu'il faut obéir d'abord, non aux hommes."
,"30":"Le Dieu de nos pères a ressuscité ce Jésus que vous avez fait mourir, suspendu au bois."
,"31":"Dieu l'a élevé, il l'a mis à sa droite comme un chef, un Sauveur, pour donner à Israël la repentance et le pardon des péchés."
,"32":"Nous sommes témoins de ces choses, et avec nous l'Esprit Saint que Dieu a donné à ceux qui lui obéissent.'"
,"33":"Les autres écoutaient tout cela les dents serrées, ils auraient voulu les tuer."
,"34":"C'est alors que se leva, dans le Conseil, un Pharisien nommé Gamaliel, un docteur de la Loi fort estimé de tout le peuple. Il donna un ordre: 'Faites sortir un instant ces hommes'."
,"35":"Puis il dit à ceux du Conseil: 'Israélites, n'agissez pas à la légère avec ces hommes."
,"36":"Rappelez-vous Theudas qui s'est lancé il y a un certain nombre d'années. Il se présentait comme un grand personnage et quatre cents hommes ont pris son parti. Puis il a été tué et tous ceux qui croyaient en lui se sont désorganisés, il n'en est rien resté."
,"37":"Plus tard est venu Judas le Galiléen, à l'époque du recensement; il a entraîné tout un monde derrière lui. Puis il s'est fait tuer lui aussi, et tous ceux qui croyaient en lui se sont dispersés."
,"38":"Voilà pourquoi je vous dis: Laissez ces hommes, ne vous occupez plus d'eux."
,"39":"Si leur projet, ou leur activité, vient des hommes, cela se défera. Mais si cela vient de Dieu, vous ne pourrez pas le détruire: voudriez-vous vous retrouver luttant contre Dieu?',Ils se laissèrent convaincre "
,"40":"et ils firent appeler les apôtres. Ils les firent bâtonner, puis ils leur défendirent de proclamer le Nom de Jésus et ils les remirent en liberté."
,"41":"Eux sortirent tout joyeux de leur comparution devant le Sanhédrin, car ils avaient été jugés dignes de se faire maltraiter pour ce Nom."
,"42":"Et de tout le jour ils n'arrêtaient pas: dans le Temple et de maison en maison ils enseignaient et proclamaient Jésus, le Messie."
}`)
	CurrentBook.AddChapter(6, `{
"1":"En ces jours où les disciples allaient en se multipliant, certains d'entre eux, les Hellénistes, se plaignirent des Hébreux: selon eux, les veuves de leur groupe étaient négligées dans le service quotidien."
,"2":"Les Douze convoquèrent alors la foule des disciples. Ils dirent: 'Ce ne serait pas normal que nous laissions de côté la parole de Dieu pour assurer le service des tables."
,"3":"Trouvez plutôt parmi vous, frères, sept hommes bien considérés, remplis de l'Esprit et de sagesse: nous leur confierons cette charge,"
,"4":"et nous-mêmes, nous continuerons de nous donner à la prière et au service de la parole.'"
,"5":"Cette intervention plut à l'assemblée; on choisit Etienne, un homme rempli de foi et de l'Esprit Saint, Philippe, Procore, Nicanor, Timon, Parménas et Nicolas, un prosélyte d'Antioche."
,"6":"On les présenta aux apôtres qui se mirent en prière et leur imposèrent les mains."
,"7":"La parole du Seigneur se répandait; à Jérusalem le nombre des disciples était en constante augmentation et bon nombre de prêtres se soumettaient à la foi."
,"8":"Etienne jouissait d'une plénitude de grâce et de puissance, il opérait parmi le peuple des choses prodigieuses, de grands miracles."
,"9":"Il rencontra de l'opposition chez des gens de la synagogue dite des Affranchis de Cyrène et d'Alexandrie, ainsi que d'autres de Cilicie et d'Asie. Ils se mirent à discuter avec Etienne,"
,"10":"mais ils ne pouvaient pas résister à la sagesse et à l'Esprit qui le faisaient parler."
,"11":"Alors ils se trouvèrent des hommes pour l'accuser en ces termes: 'Nous avons entendu ses blasphèmes contre Moïse et contre Dieu.'"
,"12":"Puis ils mobilisèrent le peuple, les Anciens et les maîtres de la Loi; ils arrivèrent à l'improviste, ils l'enlevèrent et le traînèrent devant le Sanhédrin."
,"13":"Là se présentèrent de faux témoins qui dirent: 'Cet homme n'arrête pas de parler contre le Lieu Saint et contre la Loi."
,"14":"Il dit, nous l'avons entendu, que Jésus le Nazoréen détruira ce lieu et changera les coutumes que nous avons reçues de Moïse.'"
,"15":"A ce moment tous dans le Sanhédrin se tournèrent vers lui: son visage était comme celui d'un ange."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Le grand-prêtre lui demanda: 'Les choses sont-elles ainsi?'"
,"2":"Il répondit: 'Frères et pères, écoutez! Le Dieu de gloire est apparu à notre père Abraham quand il était en Mésopotamie, avant qu'il n'aille vivre à Harran."
,"3":"Il lui a dit : Quitte ton pays et ta parenté et va vers la terre que je te donnerai."
,"4":"C'est alors qu'il a quitté la Chaldée pour vivre à Harran. Après la mort de son père, Dieu l'a fait émigrer vers le pays où vous habitez à présent. "
,"5":"Il ne lui a donné aucun domaine en ce pays, pas même de quoi poser son pied, mais il lui a promis cette terre: il devait la lui donner en propriété, comme à sa descendance après lui. Mais de fait il était sans enfants."
,"6":"Dieu lui a parlé ainsi: Tes descendants vivront tels des émigrés sur une terre étrangère. Durant quatre cents ans ils seront maltraités et feront un travail d'esclaves."
,"7":"Mais, dit encore Dieu, je jugerai la nation qui les aura maintenus en servitude. Après quoi ils en sortiront et viendront m'adorer en ce lieu.'"
,"8":"C'est à lui que Dieu a donné l'alliance de la circoncision. Après avoir engendré Isaac, il le circoncit le huitième jour; Isaac a fait de même pour Jacob, et Jacob pour les douze patriarches."
,"9":"Les patriarches devinrent jaloux de Joseph et le firent emmener en Egypte. Mais Dieu était avec lui:"
,"10":"il le libéra de toutes ses épreuves et lui donna grâce et sagesse aux yeux de Pharaon, roi d'Egypte. Celui-ci fit de lui le gouverneur de l'Egypte et de toute sa propre maison."
,"11":"Survint une famine en Egypte et en Canaan; l'épreuve fut telle que nos pères ne trouvaient plus à manger."
,"12":"Jacob apprit qu'il y avait du blé en Egypte et il y envoya nos pères une première fois."
,"13":"C'est à la deuxième fois que Joseph se fit reconnaître de ses frères. Le Pharaon connut alors la race de Joseph."
,"14":"Puis Joseph fit appeler son père Jacob et toute sa famille, au nombre de soixante-quinze personnes."
,"15":"Jacob descendit en Egypte et il y mourut, nos pères également."
,"16":"On les fit ramener à Sichem et déposer dans le sépulcre qu'Abraham avait acheté à prix d'argent aux fils de Hamor, à Sichem."
,"17":"Le terme approchait pour la promesse que Dieu avait jurée à Abraham. Le peuple se développait et foisonnait en Egypte"
,"18":"lorsqu'arriva un autre roi qui ne connaissait pas Joseph."
,"19":"Il vit notre race d'un mauvais oeil et fit tout pour nuire à nos pères, leur faisant abandonner leurs bébés pour qu'ils n'aient plus de descendance."
,"20":"C'est à ce moment que Moïse est né, celui qui était cher à Dieu. Durant trois mois il fut élevé dans la maison de son père, et quand on l'exposa, il fut recueilli par la fille de Pharaon qui l'éleva comme son fils."
,"22":"Moïse fut instruit de tout le savoir des Egyptiens: il était très doué pour la parole et pour l'action."
,"23":"Il avait déjà passé l'âge de quarante ans lorsque l'idée lui vint de visiter ses frères, les fils d'Israël."
,"24":"Voyant comment on maltraitait l'un d'eux, il voulut le défendre et rendit la pareille à celui qui abusait de lui: il fit périr l'Egyptien."
,"25":"Ses frères allaient-ils comprendre que par sa main Dieu leur offrait le salut? Moïse le croyait. De fait ils ne comprirent pas."
,"26":"Le jour suivant il les vit qui se battaient entre eux et il essaya de ramener la paix: 'Vous êtes frères!' leur dit-il, 'pourquoi vous faire du mal l'un à l'autre?'"
,"27":"Mais celui qui maltraitait son prochain s'y refusa: Qui t'a fait notre chef ou notre juge?"
,"28":"Veux-tu me tuer comme tu as tué hier l'Egyptien?"
,"29":"En entendant cela, Moïse prit la fuite et s'en alla demeurer au pays de Madian. Là il eut deux fils."
,"30":"Quarante ans déjà s'étaient écoulés lorsque, dans le désert du mont Sinaï, un ange lui apparut dans les flammes d'un buisson en feu."
,"31":"Moïse fut très intrigué par ce qu'il voyait. Comme il s'approchait pour mieux se rendre compte, il y eut une voix du Seigneur:"
,"32":"Je suis le Dieu de tes pères, le Dieu d'Abraham, d'Isaac et de Jacob. Moïse ressentait une telle crainte qu'il n'osait plus regarder."
,"33":"le Seigneur lui dit alors: Enlève les sandales que tu as aux pieds, car le lieu où tu te trouves est une terre sainte."
,"34":"J'ai vu comment on maltraite mon peuple en Egypte, j'ai entendu leurs gémissements et je suis descendu pour les délivrer. Va, je te renvoie en Egypte."
,"35":"Ce Moïse qu'ils avaient renié, à qui ils avaient dit: 'Qui t'a fait chef et juge?' c'était lui que Dieu leur envoyait comme chef et libérateur, avec l'appui de l'ange qui lui était apparu dans le buisson."
,"36":"C'est lui qui les a fait sortir, qui a opéré signes et prodiges au pays d'Egypte, à la Mer Rouge et au désert durant quarante années."
,"37":"C'est ce même Moïse qui a dit aux fils d'Israël: Le Seigneur fera se lever d'entre vos frères un prophète comme moi."
,"38":"C'est lui qui était avec nos pères à l'assemblée du désert, avec l'ange qui lui parlait sur le mont Sinaï; et il a reçu les paroles vivantes pour nous les donner."
,"39":"Nos pères ne voulaient pas l'écouter, ils se rebellaient et ne pensaient qu'à retourner en Egypte."
,"40":"Ils dirent même à Aaron: Fais-nous des dieux qui marchent à notre tête, car ce Moïse qui nous a fait sortir d'Egypte, nous ne savons pas ce qui lui est arrivé."
,"41":"C'est alors qu'ils firent le veau: ils offrirent un sacrifice à l'idole et firent leur bonheur de l'oeuvre de leurs mains."
,"42":"Dieu détourna son visage et les laissa rendre un culte à l'armée du ciel, comme il est écrit au livre des Prophètes: M'avez-vous offert victimes et sacrifices durant les quarante années au désert, maison d'Israël?"
,"43":"Vous portiez la tente de Molok et l'étoile de Rafa votre dieu, les images que vous aviez faites pour vous incliner devant elles. C'est pourquoi je vous déménagerai au-delà de Babylone."
,"44":"Nos pères avaient au désert la Tente du Témoignage; celui qui parlait à Moïse lui avait ordonné de la faire selon le modèle qu'il avait vu."
,"45":"Après l'avoir reçue, nos pères l'introduisirent avec Josué quand ils dépossédèrent les nations que Dieu chassait devant eux. Rien ne changea jusqu'au temps de David."
,"46":"David jouissait de la faveur de Dieu et voulut lui procurer un lieu de repos dans la maison de Jacob."
,"47":"De fait, ce fut Salomon qui lui construisit ce Temple."
,"48":"Mais le Très-Haut n'habite pas des constructions humaines; le prophète l'a dit:"
,"49":"Le ciel est mon trône et la terre est mon marchepied; quelle maison pourriez-vous me construire? dit le Seigneur. Ai-je besoin d'un lieu de repos?"
,"50":"N'est-ce pas ma main qui a fait tout cela?"
,"51":"Mais vraiment vous avez la nuque raide! La circoncision n'a pas touché vos coeurs ni vos oreilles, et toujours vous résistez à l'Esprit Saint. Vous faites exactement comme vos pères:"
,"52":"quel est le prophète qu'ils n'ont pas persécuté? Ils ont tué ceux qui annonçaient la mort du Juste, et c'est vous maintenant qui l'avez livré et tué."
,"53":"Déjà vous aviez reçu les préceptes de la Loi, une institution à la mesure des anges, et vous ne l'avez pas observée!"
,"54":"En entendant ces paroles d'Etienne, ils frémissaient de rage contre lui et grinçaient des dents."
,"55":"C'est alors qu'Etienne fut rempli de l'Esprit Saint, il leva son regard vers le ciel et il vit Jésus siégeant à la droite de Dieu."
,"56":"Il s'écria: 'Je vois les cieux ouverts et le Fils de l'Homme placé à la droite de Dieu!'"
,"57":"Ils se bouchèrent les oreilles et commencèrent à pousser de grands cris. Tous ensemble ils se jetèrent sur lui."
,"58":"On le conduisit hors de la ville et on commença à lui jeter des pierres. Les témoins avaient déposé leurs vêtements aux pieds d'un jeune homme du nom de Saul."
,"59":"Pendant qu'on le tuait à coups de pierres, Etienne faisait cette prière: 'Seigneur Jésus, reçois mon esprit.'"
,"60":"Il se mit à genoux et cria d'une voix forte: 'Seigneur, ne leur tiens pas compte de ce péché!' Après quoi il s'endormit dans le Seigneur."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Saul, pour sa part, était bien d'accord pour qu'on le fasse mourir. C'est alors le début d'une grande persécution contre l'Eglise à Jérusalem, et tous sauf les apôtres se dispersent dans les districts de Judée et de Samarie. "
,"2":"Des hommes de foi ensevelissent Etienne et font pour lui un grand deuil"
,"3":"cependant que Saul essaye de détruire l'Eglise: il entre dans les maisons et en fait sortir hommes et femmes qu'il fait mettre en prison."
,"4":"Mais ceux qui se sont dispersés répandent la Bonne Nouvelle là où ils passent."
,"5":"C'est ainsi que Philippe annonce le Christ à des Samaritains dans une de leurs villes où il est descendu."
,"6":"En entendant parler Philippe, en voyant les miracles qu'il fait, toute la population accueille son message."
,"7":"Car plusieurs démons impurs sont sortis des possédés en poussant de grands cris, des gens paralysés ou impotents ont été guéris,"
,"8":"et c'est une véritable joie dans cette ville."
,"9":"Un homme du nom de Simon avait précédé Philippe dans cette ville. Avec ses tours de magie, il éblouissait le peuple de Samarie et se faisait passer pour un grand personnage."
,"10":"Tous ne juraient que par lui, du plus petit jusqu'au plus grand, et l'on disait: 'C'est lui la Puissance de Dieu, celle qu'on appelle la Grande.'"
,"11":"Cela faisait un bon moment qu'il les émerveillait avec ses tours magiques, aussi ne juraient-ils que par lui."
,"12":"Mais lorsque Philippe leur annonce le Royaume de Dieu et le pouvoir sauveur de Jésus, le Messie, ils le croient, et les hommes comme les femmes viennent se faire baptiser."
,"13":"Simon lui-même croit et se fait baptiser; il ne lâche pas Philippe et il n'en revient pas quand il voit les signes et les grands miracles qui se produisent."
,"14":"Les apôtres restés à Jérusalem savaient déjà qu'en Samarie on avait accueilli la parole de Dieu; ils leur envoyèrent donc Pierre et Jean."
,"15":"Ceux-ci firent la route et prièrent pour eux afin qu'ils reçoivent l'Esprit Saint,"
,"16":"car il n'était encore descendu sur aucun d'eux: ils étaient seulement baptisés au nom du Seigneur Jésus."
,"17":"Mais alors on leur imposa les mains et ils reçurent l'Esprit Saint."
,"18":"Lorsque Simon vit l'Esprit Saint donné par l'imposition des mains, il se présenta comme acheteur:"
,"19":"'Donnez-moi ce pouvoir, leur dit-il, que je puisse moi aussi imposer les mains et que les gens reçoivent l'Esprit Saint.'"
,"20":"Pierre lui dit: 'Ton argent peut se perdre avec toi! Comment as-tu pensé acquérir le don de Dieu en l'achetant?"
,"21":"Tu n'as rien à espérer dans cette affaire, ce n'est pas ta place, car ton coeur n'est pas droit devant Dieu."
,"22":"Il faut te repentir de cette aberration et prier le Seigneur qu'il te pardonne, si c'est possible, ton projet."
,"23":"Car je ne vois sur ta route que l'amer tume du fiel et les liens du mal.'"
,"24":"Simon répondit: 'Priez vous-mêmes le Seigneur pour moi, que rien de ce que vous venez de dire ne m'arrive.'"
,"25":"Les apôtres donnèrent un témoignage. Après avoir fait entendre la parole du Seigneur, ils retournèrent à Jérusalem; cela leur avait permis de porter la Bonne Nouvelle à plusieurs villages samaritains."
,"26":"Un ange du Seigneur s'adressa à Philippe: 'Lève-toi, pars en direction du sud par la route qui descend de Jérusalem à Gaza. Il n'y a personne pour le moment.'"
,"27":"Philippe se leva et partit. Or voici que passe un Ethiopien, un eunuque de Candace, la reine des Ethiopiens, un homme très haut placé qui administrait toute sa fortune. Il était venu adorer à Jérusalem,"
,"28":"et maintenant il retournait; il était assis dans son char et lisait le prophète Isaïe."
,"29":"C'est alors que l'Esprit dit à Philippe: 'Approche-toi de ce char et reste collé juste à côté.'"
,"30":"Philippe prend donc le pas de course et il entend l'autre qui lit à voix haute le prophète Isaïe. Alors il demande: 'Comprends-tu ce que tu lis?' Et lui répond: 'Comment vais-je comprendre sans personne pour me guider?' Puis il invite Philippe à monter et à s'asseoir à côté de lui."
,"32":"Le passage de l'Ecriture qu'il était en train de lire était celui-ci: On l'a conduit comme une brebis à celui qui l'égorge, comme un agneau muet devant celui qui le tond, il n'a pas ouvert la bouche."
,"33":"Dans son humiliation on l'a privé de ses droits; qui parlera de sa postérité?,car sa vie a été retranchée de la terre."
,"34":"L'eunuque demande alors à Philippe: 'Je voudrais que tu me dises de qui le prophète dit cela: de lui-même ou de quelqu'un d'autre?'"
,"35":"Et Philippe commence à parler; il lui annonce Jésus en partant de cette Ecriture."
,"36":"Continuant leur chemin, ils arrivent à un point d'eau et l'eunuque demande: 'Il y a de l'eau, qu'est ce qui m'empêcherait d'être baptisé?'"
,"38":"Il ordonne d'arrêter le char; tous les deux, avec Philippe, ils descendent à l'eau et Philippe le bap tise."
,"39":"Après cela ils remontent de la source, et c'est alors que l'Esprit du Seigneur enlève Philippe: l'eunuque ne le voit plus, mais c'est avec une grande joie qu'il reprend sa route."
,"40":"Quant à Philippe, il se retrouve à Azot et il part évangéliser l'un après l'autre tous les villages jusqu'à ce qu'il atteigne Césarée."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Pendant ce temps Saul ne démordait pas de sa soif de violence et de meurtre contre les disciples du Seigneur. Il alla trouver le grand prêtre"
,"2":"pour lui demander des lettres de pouvoir à l'intention des synagogues de Damas. Il voulait faire enchaîner les hommes et les femmes appartenant au Chemin qu'il pourrait y trouver; il les amènerait ensuite à Jérusalem."
,"3":"Il se met donc en route et, comme il approche de Damas, une lumière venue du ciel resplendit auprès de lui."
,"4":"Il tombe par terre et entend une voix qui lui parle: 'Saul, Saul, pourquoi me persécutes-tu?'"
,"5":"Il demande: 'Qui es-tu, Seigneur?' Et lui répond: 'Je suis Jésus que tu persécutes."
,"6":"Mais relève-toi et entre dans la ville; là on te dira ce que tu dois faire.'"
,"7":"Les hommes qui faisaient route avec lui restaient sans comprendre: ils entendaient parler, mais ils ne voyaient personne,"
,"8":"et lorsque Saul se relève de terre, il a beau ouvrir les yeux, il ne voit rien. Ils le prennent donc par la main et l'amènent à Damas."
,"9":"Là il reste trois jours ne voyant rien, sans boire et sans manger."
,"10":"Il y avait à Damas un disciple du nom d'Ananias. Le Seigneur l'appela dans une vision: 'Ananias!' Il répondit: 'Me voici, Seigneur!'"
,"11":"Et le Seigneur lui dit: 'Lève-toi et va jusqu'à la Rue Droite. Tu iras trouver dans la maison de Judas un certain Saul qui est de Tarse. En ce moment il est en prière;"
,"12":"il a vu en vision un homme du nom d'Ananias qui lui imposait les mains afin qu'il recouvre la vue.'"
,"13":"Ananias reprit: 'Seigneur, bien des gens m'ont parlé de lui et de tout le mal qu'il a fait aux saints à Jérusalem."
,"14":"Et ici même le grand prêtre lui a donné pouvoir pour faire enchaîner tous ceux qui invoquent ton nom.'"
,"15":"Mais le Seigneur lui dit: 'Vas-y donc. Il sera pour moi un instrument exceptionnel pour porter mon nom devant les païens et leurs rois, tout comme devant les fils d'Israël."
,"16":"Je me charge de lui montrer tout ce qu'il aura à souffrir pour mon Nom.'"
,"17":"Ananias partit donc. Il entra dans cette maison et lui fit l'imposition des mains en disant: 'Frère Saul, c'est le Seigneur qui m'envoie, Jésus lui-même qui t'est apparu sur ta route: recouvre la vue et sois rempli de l'Esprit Saint.'"
,"18":"Aussitôt tombèrent de ses yeux comme des écailles et il put voir. Il se leva et fut baptisé,"
,"19":"puis il recommença à s'alimenter et reprit des forces. Saul resta quelques jours avec les disciples de Damas, "
,"20":"mais bien vite il se mit à parler de Jésus dans les synagogues: il le présentait comme le Fils de Dieu."
,"21":"Ses auditeurs n'en revenaient pas; ils disaient: 'Penser qu'à Jérusalem il s'acharnait contre ceux qui invoquent ce Nom! Et s'il est venu ici, c'était pour les faire enchaîner et les amener aux chefs des prêtres!'"
,"22":"Saul n'en était que plus déterminé quand il démontrait que c'est lui, Jésus, le Messie; et il réfutait toutes les objections des Juifs de Damas."
,"23":"Au bout d'un certain temps, les Juifs se mirent d'accord pour se débarrasser de lui."
,"24":"Saul fut mis au courant de leur projet. De jour comme de nuit on montait la garde aux portes pour le tuer."
,"25":"Mais les disciples le firent descendre de nuit le long de la muraille en le mettant dans un panier au bout d'une corde."
,"26":"Arrivé à Jérusalem, Saul chercha à se joindre aux disciples, mais tous avaient peur de lui; ils ne pouvaient pas croire qu'il était maintenant disciple."
,"27":"Ce fut Barnabé qui le prit pour le conduire aux apôtres. Il leur expliqua comment Saul avait vu le Seigneur sur la route et ce qu'il lui avait dit; il leur dit aussi avec quelle assurance Saul avait agi à Damas au nom de Jésus."
,"28":"Saul se mit à travailler en commun avec eux, proclamant avec beaucoup d'enthousiasme le Nom du Seigneur."
,"29":"Il parlait aux Hellénistes et discutait avec eux; eux de leur côté, se préparaient à l'éliminer."
,"30":"Les frères parvinrent à le savoir; ils le conduisirent à Césarée, et de là on l'envoya à Tarse."
,"31":"L'Eglise eut un temps de paix dans toute la Judée, la Samarie et la Galilée. Elle s'édifiait, elle cheminait dans la crainte du Seigneur, et elle avait en abondance le réconfort de l'Esprit Saint."
,"32":"Pierre passait dans les différents endroits. C'est ainsi qu'il descendit chez les saints qui résidaient à Lydda."
,"33":"Il trouva là un certain Enée, un paralysé qui depuis huit ans déjà était immobilisé sur une civière."
,"34":"Pierre lui dit: 'Enée, le Christ Jésus te guérit. Lève-toi et arrange ton lit!' Enée se leva aussitôt."
,"35":"Tous les habitants de Lydda et de Saron en furent témoins, à la suite de quoi ils se tournèrent vers le Seigneur."
,"36":"A Joppé vivait une certaine Tabitha. Ce nom se traduit Dorcas, c'est-à-dire Gazelle. C'était une disciple dont on ne pouvait compter les bonnes oeuvres et les aumônes qu'elle faisait."
,"37":"Elle tomba malade à ce moment-là et elle mourut. Après avoir lavé son corps, on le déposa dans la chambre à l'étage."
,"38":"Comme Lydda est près de Joppé, les disciples apprirent que Pierre se trouvait là et ils lui envoyèrent deux hommes pour l'inviter de façon pressante: 'Passe jusque chez nous, fais au plus vite.'"
,"39":"Pierre se lève et part avec eux. Aussitôt arrivé, ils le conduisent à l'étage et lui font voir toutes les veuves en pleurs. Elles-mêmes lui montrent les tuniques et les manteaux que faisait Dorcas quand elle était avec elles."
,"40":"Pierre les fait toutes sortir et se met à genoux en prière. Puis il se tourne vers le corps et il dit: 'Lève-toi, Tabitha!' Elle ouvre les yeux, elle reconnaît Pierre et elle s'assied."
,"41":"Alors il lui donne la main et la fait lever; après avoir appelé les saints et les veuves, il la leur présente en vie."
,"42":"La chose fut connue dans tout Joppé et beaucoup de gens crurent dans le Seigneur."
,"43":"Pierre resta à Joppé un bon bout de temps; il se logeait chez un certain Simon, tanneur de son métier."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Un certain Cornélius vivait à Césarée. C'était un centurion du bataillon Italique,"
,"2":"un vrai serviteur de Dieu; avec tous ceux de sa maison il faisait partie des adorateurs de Dieu. Il faisait au peuple Juif beaucoup d'aumônes et priait Dieu constamment."
,"3":"Or voici qu'en milieu d'après-midi il voit sans possibilité d'erreur un ange de Dieu qui entre chez lui et l'appelle: 'Cornélius!'"
,"4":"Lui le regarde en face et il est rempli de crainte. Il demande: 'Mais, qu'y a-t-il, Seigneur?' La réponse vient: 'Tes prières et tes aumônes sont montées jusqu'à Dieu, elles viennent d'être rappelées à son attention."
,"5":"Maintenant tu vas envoyer des hommes à Joppé pour faire venir un certain Simon surnommé Pierre."
,"6":"Il loge chez un tanneur du nom de Simon dont la maison est sur le bord de mer.'"
,"7":"Lorsque l'ange qui lui a parlé s'est éloigné, Cornélius appelle deux de ses domestiques ainsi qu'un soldat serviteur de Dieu choisi parmi ceux qui le servent."
,"8":"Il leur raconte toute l'affaire et les envoie à Joppé."
,"9":"Le lendemain, tandis qu'ils marchent, quand ils ne sont déjà plus loin de la ville, Pierre monte sur la terrasse pour prier; c'est l'heure de midi."
,"10":"Or voici que Pierre a faim et demande à manger quelque chose. Et pendant qu'on le lui prépare, il a une extase."
,"11":"Il voit le ciel ouvert et quelque chose descend du ciel; c'est comme une tente de grand modèle dont les quatre coins viennent se poser sur la terre,"
,"12":"et à l'intérieur il y a de tout: animaux sauvages, reptiles, oiseaux du ciel."
,"13":"Alors une voix s'adresse à lui: 'Allons, Pierre, tue et mange!'"
,"14":"Pierre répond: 'Tu n'y penses pas, Seigneur, jamais je n'ai mangé de ce qui est souillé ou impur.'"
,"15":"Et de nouveau la voix se fait entendre: 'N'appelle pas impur ce que Dieu a voulu pur.'"
,"16":"Trois fois de suite la scène se reproduit, après quoi la chose remonte vers le ciel."
,"17":"Une fois revenu à lui-même, Pierre cherche en vain à comprendre cette vision qu'il a eue, et c'est alors qu'arrivent les hommes envoyés par Corneille. Ils se sont renseignés pour trouver la maison de Simon et maintenant ils sont devant la porte."
,"18":"Ils appellent, demandant si c'est bien là que loge Simon surnommé Pierre."
,"19":"Comme Pierre est toujours sous le coup de sa vision, l'Esprit lui dit: 'Il y a là des hommes qui te cherchent,"
,"20":"descends sans attendre, car c'est moi qui les envoie.'"
,"21":"Pierre descend donc pour saluer ces hommes. Il leur dit: 'Je suis celui que vous cherchez, qu'est-ce qui vous amène?'"
,"22":"Ils répondent: 'C'est pour le centurion Cornélius. C'est un homme droit, un adorateur de Dieu, et d'ailleurs tous les Juifs l'ont en estime. Or il a été averti par un saint ange de te faire venir chez lui pour apprendre de toi quelque chose.'"
,"23":"Pierre les fait donc entrer et les garde pour la nuit. Le lendemain il se lève et part avec eux; quelques-uns des frères de Joppé l'accompagnent."
,"24":"Le jour suivant ils arrivent à Césarée. Le centurion Cornélius les attendait; il avait fait venir ses proches et ses amis intimes."
,"25":"A peine Pierre est-il entré que Cornélius va vers lui, tombe à ses pieds et se prosterne."
,"26":"Pierre le relève en lui disant: 'Lève-toi donc, je ne suis qu'un homme.'"
,"27":"Il commence à lui parler et fait son entrée; il découvre alors tout ce monde qui s'est rassemblé"
,"28":"et il leur dit: 'Vous savez très bien qu'il est totalement interdit à un Juif de se lier à un étranger ou d'entrer dans sa maison. Mais Dieu m'a fait voir que personne ne doit être considéré comme impur ou souillé. "
,"29":"C'est pourquoi je suis venu quand vous m'avez appelé, sans faire la moindre objection. Et maintenant je voudrais savoir pourquoi vous m'avez fait venir.'"
,"30":"Cornélius dit alors: 'Il y a quatre jours déjà, j'étais en prière dans ma maison en milieu d'après-midi quand un homme en vêtements resplendissants a été là devant moi."
,"31":"Il m'a dit: Ta prière a été exaucée, tes aumônes ont été rappelées en présence de Dieu."
,"32":"Envoie donc chercher à Joppé Simon surnommé Pierre, qui se loge chez le tanneur Simon sur le bord de mer; quand il sera là, il te parlera."
,"33":"Aussitôt je t'ai envoyé chercher et tu as bien fait de venir, car maintenant nous sommes tous ici devant Dieu, prêts à écouter tout ce qui t'a été commandé par Dieu.'"
,"34":"Alors Pierre prend la parole. Il leur dit: 'Je réalise vraiment que Dieu ne fait pas de différence entre les personnes."
,"35":"Dans toute nation il regarde avec bienveillance celui qui le craint et fait des oeuvres de justice."
,"36":"Or voici qu'il a envoyé au peuple d'Israël un message de paix, une bonne nouvelle par l'intermédiaire de Jésus, le Messie, qui est aussi le Seigneur de tous."
,"37":"Vous savez déjà cette affaire qui s'est déroulée à travers tout le pays des Juifs; elle avait débuté en Galilée après le baptême que prêchait Jean."
,"38":"Jésus de Nazareth a reçu alors de Dieu sa consécration, oeuvre de l'Esprit Saint et de la puissance divine. Et, comme Dieu était avec lui, il est passé faisant le bien, guérissant tous ceux qui étaient opprimés par le diable."
,"39":"Nous autres, nous sommes témoins de tout ce qu'il a fait dans la province des Juifs et à Jérusalem. Ensuite ils l'ont éliminé; ils l'ont fait suspendre au bois des suppliciés. "
,"40":"Mais au troisième jour Dieu l'a ressuscité d'entre les morts et lui a donné de se manifester,"
,"41":"non pas à tout le peuple, mais aux témoins que Dieu avait désignés d'avance, c'est-à-dire à nous qui avons mangé et bu avec lui après sa résurrection d'entre les morts."
,"42":"Aussi nous a-t-il chargés de prêcher au peuple, et de dire avec certitude que Dieu l'a choisi pour juge des vivants et des morts."
,"43":"Tous les prophètes lui rendent ce témoignage: quiconque croit en lui reçoit, grâce à son Nom, le pardon de ses péchés.'"
,"44":"Pierre était encore à son discours lorsque l'Esprit Saint tomba sur tous ceux qui écoutaient la Parole."
,"45":"Quelle surprise pour les croyants d'origine juive qui étaient venus avec Pierre: 'Quoi, les dons de l'Esprit Saint sont déversés sur des non-Juifs!'"
,"46":"Ils les entendaient parler en d'autres langues et chanter les merveilles de Dieu. Alors Pierre demande: 'Peut-on refuser l'eau et ne pas baptiser ceux qui ont reçu l'Esprit Saint tout comme nous?' "
,"48":"Et il ordonne de les baptiser au nom du Seigneur Jésus, le Christ. Après quoi on le prie de rester là quelques jours."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Les apôtres et les frères qui étaient en Judée apprirent que des non-Juifs avaient accueilli la parole de Dieu."
,"2":"Quand Pierre monta à Jérusalem, des Juifs devenus croyants lui firent des reproches:"
,"3":"'Tu es entré chez des gens qui ne sont pas circoncis et tu as mangé avec eux!'"
,"4":"Et Pierre commença à leur exposer les faits dans l'ordre:"
,"5":"J'étais en prière dans la ville de Joppé quand j'ai eu une extase. Quelque chose descendait du ciel, c'était comme une tente très vaste qui reposait sur ses quatre coins, et elle arrivait du ciel jusqu'à moi."
,"6":"Comme je la regardais et cherchais à comprendre, j'y ai vu des animaux sauvages, des bêtes féroces, des reptiles et des oiseaux."
,"7":"Et puis j'ai entendu une voix qui me disait: 'Lève-toi, Pierre, tue et mange.'"
,"8":"J'ai répondu: 'Tu ne voudrais pas, Seigneur! Rien d'impur ou de souillé n'est encore entré dans ma bouche.'"
,"9":"Et la voix qui venait du ciel me dit: 'Ne vois pas d'impureté là où Dieu a fait les choses pures.'"
,"10":"Cela s'est reproduit trois fois et tout a été remonté au ciel."
,"11":"Immédiatement après, trois hommes arrivaient de Césarée à la maison où j'étais; on les avait envoyés me chercher."
,"12":"C'est alors que l'Esprit m'a dit d'aller avec eux sans faire de difficultés. Avec moi sont partis les six frères que voilà, et nous sommes entrés dans la maison de cet homme."
,"13":"Il nous a alors raconté comment il avait vu dans sa maison un ange qui s'était présenté devant lui et lui avait dit: Envoie chercher à Joppé Simon surnommé Pierre;"
,"14":"il te donnera un message grâce auquel tu seras sauvé avec tous ceux de ta maison."
,"15":"Je commence à m'expliquer, et voici que le Saint Esprit tombe sur eux comme il avait fait pour nous au début."
,"16":"Je me suis alors rappelé la parole du Seigneur qui disait: Jean a baptisé dans l'eau, mais vous, vous serez baptisés dans l'Esprit Saint."
,"17":"Puisque Dieu leur avait accordé le même don qu'à nous quand nous avons cru au Seigneur Jésus Christ, pouvais-je moi m'opposer à Dieu?'"
,"18":"Avec ces explications ils se tranquillisèrent. Ils rendirent gloire à Dieu en disant: 'Ainsi donc, Dieu donne aussi aux autres peuples la conversion qui mène à la vie!'"
,"19":"Certains qui s'étaient dispersés à cause de la persécution, au moment de l'affaire d'Etienne, étaient allés jusqu'en Phénicie, à Chypre et à Antioche. Mais ils ne prêchaient la parole qu'aux Juifs."
,"20":"Quelques-uns cependant, des hommes de Chypre et de Cyrène qui étaient venus à Antioche, s'adressèrent également aux Grecs et leur donnèrent la bonne nouvelle du Seigneur Jésus."
,"21":"La main du Seigneur fut avec eux, et il y eut pas mal de monde pour croire et se tourner vers le Seigneur."
,"22":"Ce qu'on en racontait arriva aux oreilles de l'Eglise qui était à Jérusalem et ils envoyèrent Barnabé jusqu'à Antioche."
,"23":"Une fois sur place, il fut témoin de la grâce de Dieu. Il s'en réjouit et les invita à persévérer dans le Seigneur en y mettant tout leur coeur."
,"24":"C'était un homme excellent, plein de foi et d'Esprit Saint. Finalement, bon nombre de personnes firent leur adhésion au Seigneur."
,"25":"Barnabé partit pour Tarse pour y chercher Saul."
,"26":"Il le trouva et l'amena à Antioche. Là, durant une année entière, ils travaillèrent ensemble dans l'Eglise, instruisant beaucoup de monde. C'est à Antioche que les disciples reçurent pour la première fois le nom de Chrétiens."
,"27":"A cette époque, des prophètes descendirent de Jérusalem à Antioche."
,"28":"L'un d'eux, qui s'appelait Agabus, se leva sous l'action de l'Esprit et fit comprendre qu'une grande famine allait affecter toute la terre habitée. Elle eut lieu sous l'empereur Claudius."
,"29":"Chacun des disciples commença alors à mettre de côté, à la mesure de ses moyens, ce qu'il enverrait pour l'aide aux frères qui vivaient en Judée."
,"30":"Quand ce fut fait, on l'envoya aux Anciens, par l'intermédiaire de Barnabé et de Saul."
}`)
	CurrentBook.AddChapter(12, `{
"1":"C'est alors que le roi Hérode mit la main sur plusieurs membres de l'Eglise qu'il voulait mettre à mal."
,"2":"Il fit tuer par l'épée Jacques, frère de Jean."
,"3":"Voyant que cela plaisait aux Juifs, il fit arrêter également Pierre; c'était juste la semaine des Pains sans Levain."
,"4":"Il le fit détenir et mettre en prison, avec quatre escouades de quatre soldats chargées de le garder, car son idée était de le faire comparaître devant le peuple après la Pâque."
,"5":"Et pendant que Pierre était en prison sous bonne garde, la prière ininterrompue de l'Eglise montait pour lui vers Dieu."
,"6":"On arrivait au jour où Hérode devait le faire comparaître; cette nuit même Pierre dormait entre deux soldats, lié par deux chaînes, et des gardes devant la porte gardaient la prison."
,"7":"D'un seul coup une lumière resplendit dans la pièce: l'ange du Seigneur est là! Il frappe Pierre au côté et le réveille en lui disant: 'Vite, lève-toi!' Au même moment les chaînes tombent de ses mains."
,"8":"L'ange lui dit: 'Passe ta ceinture et attache tes sandales.' Pierre le fait. Il lui dit: 'Enveloppe-toi de ton manteau et suis-moi.'"
,"9":"Pierre sort et le suit. Pierre ne voyait pas que tout ce qu'il faisait avec l'ange était du réel: il croyait rêver."
,"10":"Ils passent le premier poste de garde, puis le second, et ils arrivent à la porte de fer qui donne à la rue: elle s'ouvre d'elle-même devant eux et ils sortent. Ils enfilent une première rue, puis l'ange le laisse."
,"11":"Alors Pierre reprend conscience et il dit: 'Cette fois-ci, c'est bien vrai, je vois que le Seigneur a envoyé son ange pour me tirer des mains d'Hérode et de tout ce que le peuple juif me tenait préparé.'"
,"12":"Après un moment de réflexion il se dirige vers la maison de Marie, mère de Jean surnommé Marc, où beaucoup de personnes se sont réunies pour prier."
,"13":"Quand il frappe à la porte du portail, une jeune servante du nom de Rodé s'approche pour écouter."
,"14":"Elle reconnaît la voix de Pierre, et c'est une telle joie qu'au lieu d'ouvrir le portail elle rentre en courant pour annoncer que Pierre est là devant le portail."
,"15":"Les autres lui disent: 'Tu es folle!' Et comme elle insiste que c'est bien lui, on lui répond: 'C'est sans doute son ange.'"
,"16":"Pendant ce temps Pierre continuait de frapper. On finit par lui ouvrir et on n'en revient pas de le voir ainsi."
,"17":"Pierre leur fait signe de la main pour qu'ils se taisent, et il leur raconte comment le Seigneur l'a fait sortir de la prison. Puis il leur dit: 'Faites-le savoir à Jacques et aux frères.' Après quoi il sort et se dirige vers un autre endroit."
,"18":"Quand il fit jour, ce fut une commotion peu ordinaire chez les soldats: Qu'était devenu Pierre?"
,"19":"Hérode le fit rechercher et ne le trouva pas. Il fit donc interroger les gardes et ordonna de les mettre à mort. Peu après il descendait de Judée à Césarée où il demeura."
,"20":"Hérode était alors en conflit avec les habitants de Tyr et de Sidon. Ceux-ci se mirent d'accord pour se présenter devant lui car leur territoire dépendait de celui du roi pour son alimentation. Ils gagnèrent à leur cause Blastos, le maître du palais du roi, et ils demandèrent la paix."
,"21":"Au jour fixé Hérode vint s'asseoir à la tribune, vêtu des habits royaux, et leur fit un discours officiel."
,"22":"Tout le peuple reprenait les acclamations: 'Ce n'est pas la voix d'un homme, c'est la voix d'un Dieu!'"
,"23":"Mais sans avertir un ange le frappa, car il n'avait pas rendu gloire à Dieu. Des vers commencèrent à le ronger et il rendit l'âme."
,"24":"La parole de Dieu se répandait, se multipliait."
,"25":"C'est alors que Barnabé et Saul revinrent de Jérusalem ayant accompli leur service; ils amenaient avec eux Jean, surnommé Marc."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Il y avait à Antioche, dans l'Eglise qui y était établie, des prophètes et des docteurs: Barnabé, Siméon surnommé le Noir, Lucius et Cyrénius, Manahem, qui avait été élevé avec le tétrarque Hérode, et Saul."
,"2":"Au cours d'une liturgie qu'ils célébraient pour le Seigneur, avec un jeûne, l'Esprit Saint dit ceci: 'Séparez-moi Barnabé et Saul pour l'oeuvre à laquelle je les ai appelés.'"
,"3":"Alors on fit un jeûne, on se mit en prière et on leur imposa les mains, après quoi ils s'en allèrent."
,"4":"Les voilà donc envoyés par l'Esprit Saint. Ils descendirent à Séleucie et de là firent voile vers Chypre."
,"5":"Débarqués à Salamine, ils commencèrent d'annoncer la parole de Dieu dans les synagogues des Juifs; Jean leur servait d'auxiliaire."
,"6":"Parcourant l'île entière jusqu'à Paphos, ils tombèrent sur un magicien juif, un soi-disant prophète du nom de Barjésus."
,"7":"Cet homme s'accrochait au gouverneur Sergius Paulus, un homme ouvert. Celui-ci fit appeler Barnabé et Saul, car il voulait entendre la parole de Dieu,"
,"8":"mais l'autre se mit en travers. L'Elymas (c'était son nom, qui signifie le Mage) s'efforçait de détourner de la foi le gouverneur."
,"9":"Alors Saul, qui n'est autre que Paul, le fixa du regard, rempli de l'Esprit Saint."
,"10":"Il lui dit: 'Fils du diable, ennemi de tout ce qui est juste, tu es sans scrupules et tu ne fais que tromper: tu ne cesses de fausser les chemins droits du Seigneur."
,"11":"Mais déjà vient sur toi la main du Seigneur et tu vas te retrouver aveugle! Pour un temps tu ne verras plus la lumière du soleil.',A l'instant même tombèrent sur lui ténèbres et nuit obscure, et il tournait en rond, cherchant une main pour le conduire. "
,"12":"A la suite de cet incident, le gouverneur eut la foi. Il était très impressionné par la doctrine du Seigneur."
,"13":"Le groupe de Paul partit à la voile de Paphos; ils arrivèrent à Pergé de Pamphylie. Puis Jean se sépara d'eux et revint à Jérusalem"
,"14":"tandis qu'eux-mêmes traversaient le pays depuis Pergé et arrivaient à Antioche de Pisidie. Là, le jour du sabbat, ils entrèrent à la synagogue et prirent un siège."
,"15":"Après la lecture de la Loi et des Prophètes, les chefs de la synagogue les font appeler. 'Frères, leur disent-ils, si vous avez pour l'assemblée quelques paroles d'encouragement, parlez."
,"16":"Alors Paul se lève, fait un signe de la main et prend la parole: 'Ecoutez-moi, Israélites, et vous aussi adorateurs de Dieu! "
,"17":"Le Dieu de ce peuple, le Dieu d'Israël, avait choisi nos pères. Il a fait que le peuple se multiplie durant leur séjour en Egypte, il les en a fait sortir à coups de prodiges"
,"18":"et il les a menés par le désert durant une quarantaine d'années."
,"19":"Il a détruit devant eux sept peuples du pays de Canaan et il leur a donné cette terre en héritage."
,"20":"Durant cette période de quatre cent cinquante ans il leur a donné des Juges jusqu'au prophète Samuel."
,"21":"Après quoi ils ont demandé un roi et il leur a donné Saul, fils de Quis, un homme de la tribu de Benjamin: cela, pour une quarantaine d'années."
,"22":"Mais ensuite Dieu l'a rejeté et a fait arriver le roi David. 'J'ai trouvé David, le fils de Jessé, disait-il, c'est un homme selon mon désir, il réalisera tous mes projets.'"
,"23":"Et de fait, c'est de la descendance de David que Dieu a fait surgir pour Israël un sauveur, comme il l'avait promis: je veux parler de Jésus."
,"24":"Avant qu'il ne débute sa carrière, Jean déjà avait prêché à tout le peuple d'Israël un baptême de conversion."
,"25":"Et lorsque Jean était sur le point de terminer sa propre course, il disait: 'Je ne suis pas ce que vous voudriez que je sois. Mais après moi vient un autre à qui je ne suis pas digne de retirer la sandale.'"
,"26":"Frères Israélites, qui êtes la descendance et les fils d'Abraham, et vous aussi adorateurs de Dieu, c'est à nous qu'a été envoyé ce message de salut."
,"27":"Les habitants de Jérusalem et leurs chefs l'ont méconnu; ils lui ont fait un procès et de cette façon ils ont accompli les paroles des prophètes qu'on lit chaque sabbat."
,"28":"Bien qu'ils n'aient rien trouvé pour une condamnation à mort, ils ont demandé à Pilate de le faire exécuter."
,"29":"Et après avoir accompli tout ce qui était écrit à son sujet, ils l'ont détaché du bois sur lequel il était mort et l'ont mis au tombeau."
,"30":"Mais Dieu l'a ressuscité d'entre les morts."
,"31":"Durant de nombreux jours il s'est montré à ceux qui étaient montés avec lui de Galilée à Jérusalem et qui sont aujourd'hui ses témoins au milieu du peuple."
,"32":"Voilà comment nous-mêmes sommes porteurs de la promesse que Dieu a faite à nos pères:"
,"33":"Dieu l'a faite réalité pour nous, qui sommes leurs enfants, en ressuscitant Jésus, comme il est écrit dans le deuxième psaume: Tu es mon Fils, moi aujourd'hui je t'ai donné la vie."
,"34":"Dieu l'a relevé d'entre les morts, et il ne retombera pas, il ne fera pas l'expérience de la corruption. Cela a été dit: Je vous donnerai les choses saintes de David, celles qui ne trompent pas."
,"35":"Et il est dit ailleurs: Tu ne permettras pas que ton saint connaisse la corruption."
,"36":"David a eu beau servir les plans de Dieu à son époque, il s'est endormi et est allé rejoindre ses pères: il a connu la corruption."
,"37":"En revanche, celui que Dieu a ressuscité n'a pas vu la corruption."
,"38":"-"
,"39":"Sachez-le donc, frères, ce qui nous est promis, c'est que par son intermédiaire vous recevrez le pardon des péchés. Oui, celui qui croit en lui est justifié de toutes ces choses dont vous ne pouviez être justifiés par la Loi de Moïse."
,"40":"Veillez donc à ce que ne vous arrive pas ce qui est dit dans les prophètes:"
,"41":"Regardez, vous qui êtes bons pour vous moquer, soyez stupéfaits, abasourdis, car je vais faire quelque chose, et ce sera de vos jours, une oeuvre que vous ne croiriez pas si on vous le disait.'"
,"42":"Quand ils sortirent de la synagogue, on les pria de reprendre ce sujet le sabbat suivant."
,"43":"L'assistance se dispersa, mais un certain nombre de Juifs et de prosélytes adorateurs de Dieu suivirent Paul et Barnabé. Ils continuèrent de converser avec eux pour les persuader de persévérer dans la grâce de Dieu."
,"44":"Le sabbat suivant, presque toute la ville était là pour entendre Paul qui fit un long expossé sur le Seigneur."
,"45":"Les Juifs furent pris de jalousie en voyant tout ce monde, et ils commencèrent à contredire Paul avec des insultes."
,"46":"Paul et Barnabé ne se laissèrent pas démonter; ils leur dirent: 'C'est à vous qu'il fallait d'abord annoncer la parole de Dieu. Mais, puisque vous la rejetez et vous privez vous-mêmes de la vie éternelle, nous allons vers les païens."
,"47":"Le Seigneur nous en fait un devoir: Je fais de toi la lumière des nations, tu porteras mon salut jusqu'aux extrémités du monde."
,"48":"Ceux qui n'étaient pas Juifs se réjouissaient d'entendre cela, et ils prenaient en estime la parole de Dieu. Un certain nombre eurent la foi, tous ceux qui étaient destinés à la vie éternelle."
,"49":"La parole de Dieu commença donc à se répandre dans toute la région."
,"50":"Les Juifs montèrent la tête aux femmes de bonne condition qui adoraient Dieu, ainsi qu'aux notables de la ville. Ils suscitèrent une persécution contre Paul et Barnabé et les chassèrent de leur territoire."
,"51":"Ceux-ci secouèrent dans leur direction la poussière de leurs pieds et partirent vers Iconium."
,"52":"Ils laissaient les disciples remplis de joie et de l'Esprit Saint."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Les choses se passèrent de la même façon à Iconium. Ils entrent à la synagogue des Juifs et ils parlent de telle façon qu'un grand nombre de Juifs et de Grecs croient;"
,"2":"mais alors les Juifs qui n'ont pas cru excitent et indisposent les païens contre les frères."
,"3":"Ils restèrent là un bon bout de temps, pleins d'assurance dans le Seigneur; il rendait témoignage à cette annonce de sa grâce par les signes et miracles qu'il opérait par leurs mains."
,"4":"L'ensemble de la ville se divisa: les uns étaient pour les Juifs, les autres pour les apôtres."
,"5":"Il y eut un complot de païens et de Juifs, où participaient leurs chefs, pour les maltraiter et les tuer à coups de pierres."
,"6":"Mis au courant, ils s'enfuirent vers les villes de Lycaonie: Lystres, Derbé et la région environnante."
,"7":"C'est là qu'ils restèrent à évangéliser."
,"8":"On pouvait voir à Lystres un homme impotent assis les jambes croisées. C'était un invalide de naissance: il n'avait jamais marché."
,"9":"Tandis qu'il écoutait le discours de Paul, celui-ci le fixa du regard et vit qu'il avait la foi pour être sauvé."
,"10":"Alors il lui dit d'une voix forte: 'Lève-toi, tiens-toi sur tes pieds!' Il se leva d'un bond et commença à marcher."
,"11":"En voyant ce que Paul venait de faire, la foule se mit à crier dans son dialecte, en lycaonien: 'Les dieux ont pris forme humaine et sont descendus chez nous!'"
,"12":"Pour eux Barnabé était Zeus, et Paul, Hermès, car c'est lui qui parlait le plus."
,"13":"Le prêtre du Zeus de l'entrée de la ville amena des taureaux et des guirlandes, car il s'était mis d'accord avec la foule pour les offrir en sacrifice."
,"14":"En entendant cela, les apôtres Barnabé et Paul déchirèrent leurs vêtements; ils se précipitèrent vers la foule en criant:"
,"15":"'Que faites-vous? Comme vous, nous sommes humains et mortels, et nous venons justement vous dire de laisser toutes ces choses sans valeur, et de vous tourner vers le Dieu vivant qui a fait le ciel et la terre ainsi que la mer, avec tout ce qu'ils contiennent."
,"16":"Au cours des générations passées il a laissé les nations suivre chacune son chemin."
,"17":"Mais en même temps il répandait ses bienfaits, car il ne voulait pas rester inconnaissable; c'est lui qui vous donne les pluies du ciel, la saison des récoltes, la nourriture abondante; c'est lui qui met la joie dans vos coeurs.'"
,"18":"Paul et Barnabé développèrent ce thème; ils eurent bien du mal à empêcher la foule de leur offrir un sacrifice."
,"19":"Ils restèrent tout un temps en cet endroit, où ils enseignaient. Ensuite arrivèrent les Juifs d'Antioche de Pisidie. Ils parlèrent avec beaucoup d'assurance, affirmant qu'il n'y avait rien de vrai dans toute cette prédication, que tout était inventions. Ils surent amener la population à s'éloigner d'eux et finalement ils lapidèrent Paul. Ils le traînèrent hors de la ville pensant qu'il était mort."
,"20":"Mais alors ses disciples vinrent l'entourer; il se releva pour rentrer dans la ville, et le lendemain il sortit avec Barnabé pour Derbé."
,"21":"Ils évangélisèrent cette ville où ils firent un bon nombre de disciples, puis ils repartirent sur Lystres, Iconium et Antioche."
,"22":"Ce faisant, ils affermissaient les disciples: 'Persévérez dans la foi, leur disaient-ils, il nous faut passer par beaucoup d'épreuves pour entrer dans le Royaume de Dieu.'"
,"23":"Ils établissaient des Anciens dans chaque Eglise - ils le faisaient avec jeûnes et prières, puis ils les confiaient au Seigneur en qui ils avaient cru."
,"24":"Traversant toute la Pisidie ils atteignirent la Pamphylie."
,"25":"A Pergé ils annoncèrent la Parole, puis ils descendirent à Attale."
,"26":"De là ils firent voile sur Antioche d'où ils avaient été recommandés à la grâce de Dieu pour cette mission qu'ils venaient de remplir."
,"27":"A leur arrivée ils convoquèrent toute l'Eglise; ils racontèrent tout ce que Dieu avait fait avec eux et comment il avait ouvert aux peuples païens la porte de la foi."
,"28":"Ils restèrent là tout un temps avec les disciples."
}`)
	CurrentBook.AddChapter(15, `{
"1":"C'est alors que des gens arrivèrent de Judée. Ils donnaient aux frères cet enseignement: 'Si vous ne vous faites pas circoncire comme Moïse l'a établi, vous ne pouvez pas être sauvés.'"
,"2":"Voilà donc pas mal d'agitation et des discussions animées avec Paul et Barnabé. A la suite de cela on décide que Paul, Barnabé et quelques-uns des autres monteront à Jérusalem pour voir ce problème avec les apôtres et les Anciens."
,"3":"L'Eglise les met en chemin et ils traversent la Phénicie et la Samarie. Tout au long du parcours ils donnent des détails sur la conversion des païens, procurant ainsi une grande joie à tous les frères."
,"4":"A leur arrivée à Jérusalem ils sont reçus par l'Eglise, les apôtres et les Anciens. Ils leur font alors un récit de tout ce que Dieu a fait avec eux."
,"5":"Mais des membres de la secte des Pharisiens qui sont devenus croyants se lèvent et prennent la parole: Il faut circoncire ceux qui ne sont pas d'origine juive et leur demander d'observer la loi de Moïse."
,"6":"Les apôtres et les Anciens se réunissent donc pour étudier cette affaire."
,"7":"Une grande discussion commence, puis Pierre se lève et dit: 'Frères, vous savez bien comment Dieu est intervenu chez vous dès les commencements. Il m'a choisi pour que des non-Juifs entendent de ma bouche la parole de l'Evangile et arrivent à la foi. "
,"8":"Et Dieu qui connaît les coeurs s'est prononcé en leur faveur quand il leur a donné l'Esprit Saint tout comme à nous."
,"9":"Il n'a pas fait de différence entre eux et nous: il a purifié leurs coeurs par la foi."
,"10":"Voulez-vous maintenant commander à Dieu? Pourquoi imposer aux disciples un joug que nos pères n'ont pas été capables de porter, et nous pas davantage?"
,"11":"Selon notre foi, ce qui nous sauve, tout comme eux, c'est la grâce du Seigneur Jésus.'"
,"12":"Toute l'assemblée garde le silence et l'on entend Barnabé et Paul raconter tous les signes et prodiges que Dieu a accomplis chez les non-Juifs par leur intermédiaire."
,"13":"Quand ils ont terminé, Jacques prend la parole: 'Frères, écoutez-moi."
,"14":"Simon vous a rappelé comment dès le début Dieu a pris soin de se chercher parmi les païens un peuple à son nom."
,"15":"Les paroles des prophètes lui font écho, car il est écrit:"
,"16":"Après cela je reviendrai, je relèverai la tente de David qui s'est effondrée. Je rebâtirai ses ruines et je la relèverai,"
,"17":"pour que le reste des hommes recherche le Seigneur, toutes ces nations sur lesquelles mon Nom a été appelé. Ainsi dit le Seigneur qui fait ces choses"
,"18":"telles qu'il les avait prévues depuis toujours."
,"19":"C'est pourquoi je pense qu'on ne doit pas compliquer la vie des païens qui se tournent vers Dieu."
,"20":"Ecrivons-leur seulement de s'abstenir des viandes souillées par les idoles, des unions illégitimes, et des viandes d'animaux étouffés ou non saignés."
,"21":"Car depuis des générations on lit Moïse chaque sabbat dans les synagogues, et il a dans toutes les villes ses prédicateurs.'"
,"22":"Alors il parut bon aux apôtres, aux Anciens et à toute l'assemblée, de choisir parmi eux des hommes qu'ils enverraient à Antioche avec Paul et Barnabé. Ces hommes choisis parmi les frères furent Judas surnommé Barsabas et Silas, l'un et l'autre dirigeants parmi les frères."
,"23":"Ils devaient remettre cette lettre: 'Les apôtres et les frères ayant titre d'Anciens saluent leurs frères d'Antioche, de Syrie et de Cilicie qui ne sont pas d'origine juive."
,"24":"Nous avons su que quelques personnes de chez nous vous avaient causé du trouble et que leurs paroles vous laissaient déconcertés. Nous ne leur avions rien demandé."
,"25":"Nous nous sommes mis d'accord pour vous envoyer des délégués en même temps que Barnabé et Paul,"
,"26":"ces hommes qui se donnent tout entiers pour le Nom du Seigneur Jésus."
,"27":"Nous vous envoyons donc Judas et Silas qui vous rediront tout de vive voix."
,"28":"Il a paru bon à l'Esprit Saint et à nous de ne vous imposer aucun fardeau qui ne soit le strict nécessaire:"
,"29":"abstenez-vous donc des viandes sacrifiées aux idoles, ou non saignées ou étouffées, ainsi que des unions illégitimes. Gardez-vous en par l'action de l'Esprit Saint, et vous ferez bien.'"
,"30":"Ils se mirent en route et descendirent à Antioche où ils réunirent toute la multitude pour la remise de la lettre."
,"31":"La lecture en causa une joie générale et fut un encouragement."
,"32":"Judas et Silas étaient prophètes; ils parlèrent longuement pour encourager et affermir les frères."
,"33":"Ils s'arrêtèrent quelque temps, puis on les laissa retourner en paix vers ceux qui les avaient envoyés."
,"34":"Silas cependant choisit de rester avec eux, et Judas revint seul à Jérusalem."
,"35":"Paul et Barnabé s'attardèrent à Antioche où ils enseignaient et donnaient avec beaucoup d'autres la bonne nouvelle du Seigneur."
,"36":"Puis un jour Paul dit à Barnabé: 'Retournons là-bas pour visiter les frères, voyons où ils en sont dans les différentes villes où nous avons annoncé la parole du Seigneur.'"
,"37":"Barnabé voulait prendre avec lui Jean Marc."
,"38":"Mais Paul était décidé à ne pas emmener celui qui les avait abandonnés en Pamphylie alors qu'il devait les accompagner dans leur entreprise."
,"39":"Ils s'échauffèrent tellement qu'ils se séparèrent l'un de l'autre, et Barnabé prit le bateau pour Chypre avec Marc."
,"40":"Paul, de son côté, choisit Silas. Les frères le recommandèrent à la grâce de Dieu et il partit."
,"41":"Il fit le tour de la Syrie et de la Cilicie, affermissant les Eglises."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Paul se dirigea ensuite vers Derbé et Lystres. Il y avait là un disciple du nom de Timothée, fils d'une Juive devenue croyante, mais dont le père était Grec;"
,"2":"les frères de Lystres et Iconium en disaient beaucoup de bien."
,"3":"Paul voulait qu'il vienne avec lui, aussi lui fit-il la circoncision, pensant aux Juifs qui se trouvaient dans ces parages, car tous savaient que son père était Grec."
,"4":"Dans les villes qu'ils traversaient, ils transmettaient les décrets que les apôtres et les Anciens de Jérusalem avaient demandé d'observer."
,"5":"Ces Eglises s'affermissaient dans la foi et de jour en jour avaient davantage de monde."
,"6":"L'Esprit Saint ne leur permit pas d'annoncer la parole en Asie. Les voilà donc qui traversent la Phrygie et la région des Galates."
,"7":"Quand ils arrivent en Mysie, ils veulent faire marche vers la Bithynie, mais l'Esprit de Jésus ne le leur permet pas."
,"8":"Ils traversent donc la Mysie et arrivent à Troas."
,"9":"Là, de nuit, Paul a une vision: un Macédonien se tient devant lui et lui présente une supplique: 'Passe en Macédoine, viens à notre secours!'"
,"10":"A la suite de cette vision de Paul, nous cherchons à partir au plus tôt pour la Macédoine, persuadés que Dieu nous appelle à les évangéliser."
,"11":"Nous prenons donc le bateau à Troas et nous courons droit sur l'île de Samothrace; le lendemain c'est Néapolis;"
,"12":"de là nous atteignons Philippes, cité principale de la Macédoine, ville de colonie. Nous y demeurons quelques jours, "
,"13":"et le jour du sabbat nous passons la porte de la ville en direction de la rivière où nous pensons qu'aura lieu la prière. Nous nous asseyons et commençons à parler avec les femmes qui se sont réunies."
,"14":"L'une d'elles est une adoratrice de Dieu du nom de Lydia, une marchande de pourpre de la ville de Thyatire. Tandis qu'elle nous écoute, le Seigneur lui ouvre le coeur et la fait s'attacher aux paroles de Paul."
,"15":"Elle se fait baptiser avec toute sa maison, après quoi elle nous invite avec insistance: 'Si vous croyez que j'ai bien la foi au Seigneur, venez donc et restez dans ma maison.' Elle nous y obligea presque."
,"16":"Un jour où nous nous rendions à la prière, une fille qui avait un esprit de divination se trouva sur notre chemin. Elle disait la bonne aventure et procurait ainsi de gros revenus à ses maîtres."
,"17":"Et voici qu'elle se met à nous suivre, avec Paul, en criant: 'Ces gens sont des serviteurs du Dieu Très-Haut, ils vous annoncent le chemin du salut!'"
,"18":"Et cela se répète un certain nombre de jours. A la fin Paul est excédé, il se retourne et dit à l'esprit: 'Je te l'ordonne par le Nom de Jésus Christ, sors de cette fille!' L'esprit sort à l'instant même."
,"19":"Mais du coup les patrons de la fille voient s'envoler les profits sur lesquels ils comptaient. Ils mettent la main sur Paul et Silas et les traînent devant les magistrats à la cour de justice."
,"20":"Ils les présentent aux officiers de police en disant: 'Ces gens-là sont Juifs et ils viennent mettre le trouble dans notre ville."
,"21":"Ils prêchent des usages que nous, Romains, ne pouvons pas accepter ni mettre en pratique.'"
,"22":"L'assistance se tourne contre eux; les officiers de police ordonnent de leur arracher les vêtements et de les frapper à coups de bâton."
,"23":"Après quoi ils les font jeter dans la prison couverts de plaies, et ils ordonnent au gardien de prison de bien veiller sur eux."
,"24":"Avec une telle consigne, il les jette dans le cachot intérieur de la prison et leur immobilise les pieds dans des entraves."
,"25":"Vers le milieu de la nuit, Paul et Silas chantaient à Dieu des hymnes et les prisonniers les écoutaient."
,"26":"Subitement la terre tremble, et la secousse est telle que les fondations de la prison sont ébranlées. D'un seul coup toutes les portes s'ouvrent et les chaînes de tous les prisonniers se défont."
,"27":"Le gardien de prison se réveille; voyant ouvertes les portes de la prison, il tire son épée et pense à se tuer, à l'idée que les prisonniers se sont échappés."
,"28":"Mais Paul l'appelle à grands cris: 'Ne te fais pas de mal, nous sommes tous ici!'"
,"29":"L'homme demande de la lumière: il entre et, après avoir bien enfermé les autres prisonniers, il se jette plein de crainte aux pieds de Paul et de Silas."
,"30":"Puis il les fait sortir et demande: 'Seigneurs, que dois-je faire pour être sauvé?'"
,"31":"Ils lui disent: 'Crois au Seigneur Jésus et tu seras sauvé avec toute ta famille.'"
,"32":"Alors ils lui annoncent la parole du Seigneur comme à tous ceux de sa maison,"
,"33":"et lui, sans attendre, bien que ce soit la nuit, il lave leurs plaies puis se fait baptiser avec tous les siens."
,"34":"Dans sa maison où il les a conduits, il leur fait préparer la table, et toute la maison est en fête parce qu'ils ont cru en Dieu."
,"35":"Le jour venu, les officiers de police envoient des sergents avec ce message: 'Renvoie ces gens-là!'"
,"36":"Le gardien de prison fait part de ce message à Paul: 'Les officiers de police ont dit de vous libérer, allez donc et marchez en paix.'"
,"37":"Mais Paul réplique: 'Nous sommes citoyens romains et ils nous ont fait bâtonner publiquement, ils nous ont fait emprisonner sans jugement. Vont-ils maintenant nous mettre dehors à la sauvette? Pas du tout! Ils viendront eux-mêmes pour nous faire sortir.'"
,"38":"Les sergents rapportèrent ces paroles aux officiers de police, et ils eurent très peur en apprenant que c'étaient des citoyens romains."
,"39":"Ils vinrent à la prison accompagnés d'un groupe d'amis de Paul pour leur demander de s'en aller. Ils disaient: 'Comment allions-nous savoir que vous êtes des gens très bien?' Et lorsque Paul et Silas partirent, ils leur firent cette recommandation: 'Quand vous serez dehors, ayez la bonté de ne pas nous créer de problèmes pour vous avoir ainsi parlé un peu durement.'"
,"40":"Aussitôt sortis de prison, ils allèrent chez Lydia. Là ils virent les frères, et ils leur remontèrent le moral avant de s'en aller."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Après avoir traversé Amphipolis et Apollonie, ils arrivèrent à Thessalonique où les Juifs avaient une synagogue."
,"2":"Paul entra chez eux comme il en avait l'habitude. Trois sabbats de suite il discuta avec eux à partir des Ecritures."
,"3":"Il les interprétait, montrant que le Messie devait souffrir et ressusciter des morts. Et il ajoutait: 'Ce Messie, c'est précisément Jésus que je vous annonce.'"
,"4":"Quelques-uns d'entre eux se laissèrent convaincre et formèrent un groupe autour de Paul avec pas mal d'adorateurs de Dieu et un bon petit nombre de femmes de notables."
,"5":"Les Juifs voulurent réagir. Ils firent appel à des mauvais garçons, des traîneurs de rues, et ils ameutèrent la population de façon à créer le désordre dans la ville. Ils firent une démonstration devant chez Jason, car ils voulaient les conduire au tribunal du peuple. "
,"6":"Comme ils ne les trouvèrent pas, ils entraînèrent de force Jason et quelques frères jusque devant les magistrats de la ville. Ils criaient: 'Ceux qui mettent le désordre par toute la terre sont arrivés ici,"
,"7":"et Jason les a accueillis. Tous ces gens-là attaquent les décrets de l'empereur, ils prétendent qu'il y a un autre roi qui est Jésus!'"
,"8":"Ils créèrent la confusion dans la foule et chez les magistrats qui les entendaient;"
,"9":"ceux-ci exigèrent une caution de Jason et des autres avant de les renvoyer."
,"10":"Cette nuit même les frères mirent Paul et Silas sur le chemin de Bérée. Arrivés là, ils allèrent à la synagogue des Juifs. "
,"11":"Ceux-ci avaient l'âme plus noble que ceux de Thessalonique. Ils accueillirent la Parole avec beaucoup de bonne volonté, et chaque jour ils vérifiaient dans les Ecritures si les choses étaient bien ainsi."
,"12":"Un bon nombre d'entre eux arriva à la foi, ainsi que des Grecs: des femmes de personnages importants et un petit groupe d'hommes."
,"13":"Mais voici que les Juifs de Thessalonique apprennent la nouvelle: Paul annonce à Bérée la parole de Dieu! Ils accourent et commencent à faire du tapage et à ameuter la foule."
,"14":"Immédiatement les frères font partir Paul jusqu'à la mer par la route, tandis que Silas et Timothée restent sur place."
,"15":"Ceux qui escortent Paul le conduisent à Athènes, puis ils reviennent avec un message pour Silas et Timothée de venir le rejoindre au plus vite."
,"16":"Paul les attendait à Athènes et son esprit ne tenait pas en place en voyant cette ville pleine d'idoles."
,"17":"Il commença à converser dans la synagogue avec des Juifs et des adorateurs de Dieu; il conversait aussi tous les jours sur la place avec ceux qui se présentaient."
,"18":"Quelques philosophes épicuriens et stoïciens acceptaient le dialogue, d'autres disaient: 'Que cherche ce grand parleur?', ou encore: 'Ce doit être un prédicateur de divinités étrangères.' Tout cela parce que Paul parlait de Jésus et de la Résurrection."
,"19":"Alors ils le conduisent avec eux à l'Aréopage et lui posent la question: 'Pouvons-nous connaître cette doctrine nouvelle que tu prêches?'"
,"20":"Tu nous lances aux oreilles des choses bien étranges et nous aimerions savoir à quoi rime tout cela.'"
,"21":"Il faut dire que les Athéniens et les étrangers qui sont là de passage n'ont pas de plus grand plaisir que de dire ou d'entendre la dernière nouveauté."
,"22":"Paul prend donc la parole au milieu de l'Aréopage et commence à leur dire: 'Athéniens, j'admire jusqu'où va votre sens religieux."
,"23":"Je me promenais, je regardais vos monuments sacrés, et je découvre un autel avec cette inscription: 'Au Dieu inconnu'. Or je viens précisément vous annoncer ce que vous vénérez sans le connaître."
,"24":"Le Dieu qui a fait l'univers avec tout ce qui s'y trouve ne réside pas dans des temples de notre fabrication, puisqu'il est Seigneur du ciel et de la terre."
,"25":"Il n'a que faire de mains humaines pour le servir: de quoi a-t-il besoin, lui qui donne à tous la vie, le souffle, et tout le reste?"
,"26":"Il avait tiré d'un même sang toute la race humaine; il a voulu qu'elle occupe toute la face de la terre, puis il a fixé pour chaque peuple un territoire déterminé et un temps de l'histoire."
,"27":"Il leur fallait chercher l'être divin: peut-être trouveraient-ils à force de tâtonnements. Car de fait il n'est pas loin de nous, "
,"28":"c'est en lui que nous avons la vie, le mouvement et l'être, comme l'ont dit quelques-uns de vos poètes: Nous sommes aussi de sa race."
,"29":"Mais si nous sommes, nous, de la race de Dieu, n'allons pas croire que l'être divin ressemble aux créations de l'art et de la fantaisie humaine, qu'elles soient de pierre ou d'or ou d'argent."
,"30":"Justement, Dieu veut maintenant dépasser les temps de l'ignorance et il demande que tous les hommes en tous lieux se reprennent totalement."
,"31":"Il a fixé une date où il jugera selon la justice toute la terre habitée; pour cela il aura recours à un homme choisi par lui, que tous reconnaîtront de façon sûre, car il l'a ressuscité des morts.'"
,"32":"En entendant parler de résurrection des morts, un certain nombre commencèrent à se moquer de lui. Les autres lui dirent: 'Pour cela nous t'écouterons une autre fois.'"
,"33":"C'est ainsi que Paul quitta l'endroit."
,"34":"Quelques hommes s'attachèrent à lui et crurent, parmi eux Denys, qui était de l'Aréopage, ainsi qu'une femme du nom de Damaris et quelques autres."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Plus tard, Paul quitta Athènes et vint à Corinthe."
,"2":"Il trouva là un Juif du nom d'Aquila, originaire du Pont, qui arrivait juste d'Italie avec sa femme Priscilla à la suite d'un décret de Claude; en effet, tous les Juifs avaient reçu l'ordre de quitter Rome. Paul s'attacha à eux;"
,"3":"ils avaient le même métier et fabriquaient des tentes, aussi demeurait-il et travaillait-il avec eux."
,"4":"Chaque sabbat il avait des entretiens à la synagogue, tâchant de convaincre les Juifs comme les Grecs."
,"5":"Lorsque Silas et Timothée arrivèrent de Macédoine, Paul commença à se consacrer à la Parole, affirmant aux Juifs que Jésus était le Messie."
,"6":"Eux lui répondirent avec des insultes; alors il secoua devant eux ses vêtements et leur dit: 'Vous serez responsables de ce qui vous arrivera, moi je n'y serai pour rien. Désormais je vais vers les non-Juifs.'"
,"7":"Paul changea d'endroit; il alla vivre chez Titus Justus, un adorateur de Dieu dont la maison était juste à côté de la synagogue."
,"8":"Un chef de la synagogue, Crispus, crut au Seigneur ainsi que toute sa maison; de même, parmi les Corinthiens qui l'écoutaient, beaucoup croyaient et se faisaient baptiser."
,"9":"Une nuit le Seigneur dit à Paul dans une vision: 'Ne crains pas, continue de parler, ne te tais pas."
,"10":"Je suis avec toi et personne ne te fera de mal; sache que j'ai ici dans cette ville un peuple nombreux.'"
,"11":"Paul continua donc de leur enseigner la parole de Dieu; il demeura là un an et six mois."
,"12":"Dans le temps où le gouverneur de l'Achaïe était Gallion, les Juifs se mirent d'accord pour manifester contre Paul. Ils le traînèrent au tribunal"
,"13":"en disant: 'Cet homme veut amener les gens à servir Dieu d'une manière qui contredit la Loi.'"
,"14":"Paul allait prendre la parole lorsque Gallion dit aux Juifs: 'S'il s'agissait d'un délit ou d'une action malintentionnée, j'aurais le devoir de vous écouter, messieurs les Juifs."
,"15":"Mais si ce sont des discussions à propos de messages, de puissances supérieures ou de votre loi, voyez vous-mêmes, je ne veux pas me faire votre juge pour ces affaires-là.'"
,"16":"Là-dessus il leur fit dégager le tribunal."
,"17":"Mais en face du tribunal, tous se mirent à frapper Sosthène, qui était chef de synagogue, et Gallion ne fit rien pour l'empêcher."
,"18":"Paul resta encore un bon bout de temps, puis il prit congé des frères et s'embarqua pour la Syrie; Priscilla et Aquila l'accompagnaient. Il avait fait un voeu et seulement quand il fut au port, à Cenchrées, il se rasa la tête."
,"19":"Arrivé à Ephèse il se sépara d'eux. Il était entré à la synagogue et il avait commencé à parler aux Juifs. "
,"20":"Eux lui demandaient de s'attarder plus longtemps, mais il ne voulut pas."
,"21":"Il prit congé d'eux avec ces mots: 'Je reviendrai chez vous si Dieu le veut.' Puis il quitta Ephèse avec le voilier."
,"22":"Paul débarqua à Césarée; il monta saluer l'Eglise, puis il descendit à Antioche."
,"23":"Il y resta un certain temps, puis il repartit. Il parcourut successivement la région des Galates et la Phrygie en vue d'affermir les disciples."
,"24":"Un Juif du nom d'Apollos était arrivé à Ephèse. Il était originaire d'Alexandrie et très fort sur les Ecritures; c'était un vrai orateur."
,"25":"On lui avait enseigné le chemin du Seigneur et il parlait avec beaucoup d'enthousiasme. Il enseignait de façon correcte ce qui se rapportait à Jésus, mais il ne savait pas plus loin que le baptême de Jean."
,"26":"Il parlait donc très librement dans la synagogue. Priscilla et Aquila l'entendirent, ils le prirent à part et lui exposèrent le Chemin plus en détail."
,"27":"Comme il avait l'intention de passer en Achaïe, les frères l'y encouragèrent, écrivant aux disciples de là-bas de l'accueillir. De fait, quand il arriva, il aida beaucoup ceux qui avaient cru par grâce de Dieu,"
,"28":"car il discutait fermement en public avec les Juifs, prouvant par les Ecritures que Jésus est le Messie."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Dans le temps qu'Apollos était à Corinthe, Paul voyageait à Ephèse, passant par la montagne, et il y trouvait quelques disciples."
,"2":"Il leur demande: 'Avez-vous reçu l'Esprit Saint quand vous avez cru?' Ils répondent: 'Nous n'avons même pas entendu dire qu'on reçoive l'Esprit Saint.'"
,"3":"Paul leur dit: 'Quel baptême avez-vous reçu?' Ils répondent: 'Le baptême de Jean.'"
,"4":"Alors Paul explique: 'Lorsque Jean baptisait en vue d'un changement de vie, il disait au peuple de croire en celui qui viendrait après lui, et c'est Jésus.'"
,"5":"En entendant cela, ils se font baptiser au nom du Seigneur Jésus."
,"6":"Paul alors leur impose les mains et l'Esprit Saint vient sur eux: ils commencent à parler en langues et à prophétiser."
,"7":"Les hommes dont il s'agit étaient une douzaine en tout."
,"8":"Paul était allé à la synagogue et durant trois mois il leur parla du royaume de Dieu avec conviction, essayant de les persuader."
,"9":"Quand il vit qu'un certain nombre se durcissaient et refusaient de croire, allant jusqu'à calomnier le Chemin devant tous les autres, il se sépara d'eux. Il prenait à part ses disciples et discutait avec eux tous les jours dans la salle d'un certain Tyrannos, de onze heures à quatre heures."
,"10":"Deux années s'écoulèrent ainsi, de sorte que tous les habitants de la province d'Asie, Grecs ou Juifs, entendirent parler du message du Seigneur."
,"11":"Dieu opérait des miracles peu ordinaires par les mains de Paul."
,"12":"C'était à tel point qu'on allait poser sur des malades les linges et les bandes qu'il avait en sous-vêtements, et ils étaient soulagés de leurs maux. De la même façon les esprits mauvais sortaient."
,"13":"Il y eut des Juifs, des exorcistes ambulants, qui firent l'essai d'invoquer le Nom du Seigneur Jésus sur ceux qui étaient au pouvoir d'esprits mauvais. Ils disaient: 'Je te l'ordonne au nom de ce Jésus que Paul prêche'."
,"14":"Parmi eux se trouvaient les fils d'un prêtre juif nommé Escéva. Mais un jour qu'ils se risquèrent à le faire là où ils étaient entrés,"
,"15":"l'esprit mauvais leur répondit: 'Je connais Jésus et je sais qui est Paul, mais vous, qui êtes-vous?'"
,"16":"L'homme qui avait cet esprit mauvais se jeta sur eux, les maîtrisa tous les deux et les brutalisa de telle manière qu'ils s'enfuirent nus et blessés."
,"17":"La nouvelle fut connue de tous les habitants d'Ephèse, Juifs ou Grecs; tous en furent fortement impressionnés et le Nom du Seigneur Jésus y gagna en prestige."
,"18":"Beaucoup de ceux qui avaient cru venaient confesser et dire en public ce qu'ils avaient fait."
,"19":"Un certain nombre de ceux qui avaient pratiqué la magie apportèrent leurs livres et les brûlèrent devant tout le monde. On en fit l'estimation: cela représentait cinquante mille pièces d'argent."
,"20":"C'est dire que la parole du Seigneur manifestait sa puissance, elle se répandait et se fortifiait."
,"21":"Tout cela avait déjà eu lieu lorsque Paul prit sa décision dans l'Esprit Saint: il irait à Jérusalem en retraversant la Macédoine et l'Achaïe. Il ajoutait: 'Après être passé là-bas, il faudra que j'aille également voir Rome.'"
,"22":"Paul fit partir pour la Macédoine deux de ses assistants, Timothée et Eraste, et il resta encore quelque temps en Asie."
,"23":"C'est alors que se produisit une véritable émeute à cause du Chemin."
,"24":"Un orfèvre du nom de Démétrios faisait en argent des petits temples d'Artémis et procurait aux artisans de bons revenus."
,"25":"Il les réunit, ainsi que d'autres qui faisaient le même genre de travail, et il leur dit: 'Camarades, vous savez que c'est ce travail qui nous rapporte le plus,"
,"26":"mais vous voyez et vous apprenez que ce Paul a retourné les convictions de beaucoup de gens, non seulement à Ephèse, mais dans presque toute la province d'Asie. A l'entendre, les dieux ne peuvent pas sortir des mains humaines."
,"27":"Ce ne sont pas seulement nos intérêts qui vont en souffrir, c'est aussi le temple de la grande déesse Artémis qui va y perdre son crédit; finalement, celle que vénère toute l'Asie, et je dirais: la terre entière, va être dépouillée de son prestige.'"
,"28":"Ce discours les rendit agressifs. Ils se mirent à crier: 'Vive l'Artémis des Ephésiens!'"
,"29":"et ce fut une confusion totale dans la ville. Ils se précipitèrent tous vers le théâtre, entraînant avec eux Gaius et Aristarque, deux Macédoniens qui voyageaient avec Paul."
,"30":"Paul voulait affronter l'assemblée du peuple, mais les disciples ne le laissèrent pas y aller."
,"31":"Quelques notables de la province d'Asie qui étaient ses amis lui firent passer l'avis de ne pas se risquer au théâtre."
,"32":"D'ailleurs on ne savait plus ce que criaient les uns ou les autres, l'assemblée n'était qu'un désordre et la plupart ne savaient même pas pourquoi ils étaient là."
,"33":"A ce moment on fit sortir de la foule un certain Alexandre que les Juifs poussaient vers la tribune. Il voulait les mettre hors de cause devant la multitude et il fit signe de la main;"
,"34":"mais quand on sut qu'il était Juif, ce ne fut qu'une clameur dans toute l'assemblée. Et ils restèrent à crier durant près de deux heures: 'Grande est l'Artémis des Ephésiens!'"
,"35":"Le secrétaire de la ville parvint à calmer la foule. Il leur dit: 'Ephésiens, y a-t-il une seule personne pour ignorer que la ville d'Ephèse garde le temple de la grande Artémis et sa statue tombée du ciel?"
,"36":"Personne ne peut dire le contraire. Il vous faut donc retrouver votre calme et ne rien faire par emportement."
,"37":"Vous amenez là des hommes qui n'ont pas profané le temple ni insulté notre déesse."
,"38":"Si Démétrios et ses artisans ont à se plaindre de quelqu'un, qu'ils le traduisent en justice: il y a des audiences et des magistrats."
,"39":"Et si le problème va plus loin, on devra le résoudre dans l'assemblée régulière."
,"40":"Vous rendez-vous compte qu'on pourrait nous accuser de sédition pour l'affaire d'aujourd'hui? Nous n'aurions aucun argument à présenter pour justifier ce désordre.',Ceci dit, il renvoya l'assemblée."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Une fois apaisé le tumulte, Paul fit appeler les disciples pour les encourager. Il leur fit ses adieux et partit pour la Macédoine."
,"2":"Il parcourut cette région, multipliant ses entretiens avec les disciples, et parvint en Grèce."
,"3":"Il y resta trois mois, après quoi il pensa rentrer en Syrie par le bateau. Mais l'Esprit lui fit savoir que les Juifs préparaient quelque chose contre lui, aussi décida-t-il de rentrer par la Macédoine."
,"4":"Quand vint le moment de quitter la province d'Asie, d'autres partirent avec lui: Sopatros fils de Pyrros, de Bérée; Aristarque et Secondus, deux Thessaloniciens; Gaius de Derbé, avec Timothée; Tychique et Trophime, de la province d'Asie."
,"5":"Ils partirent en avant: ils devaient nous attendre à Troas."
,"6":"Et puis nous sommes partis de Philippe par le bateau après les jours de la Pâque, et nous les avons rejoints à Troas au bout de cinq jours. Nous y sommes restés sept jours."
,"7":"Le lendemain du sabbat, nous nous sommes réunis pour la fraction du pain et Paul a commencé à converser avec eux. Comme il devait partir le lendemain, il a continué de parler jusque vers minuit."
,"8":"Il y avait pas mal de lampes qui brûlaient à l'étage, là où nous étions réunis."
,"9":"Un jeune qui s'appelait Eutykos s'est assis sur la fenêtre, et comme Paul n'en finissait pas de parler, il n'a pas résisté au sommeil. Il s'est si bien endormi qu'il est tombé du second étage et on l'a ramassé mort."
,"10":"Alors Paul est descendu, il s'est penché sur lui et l'a pris dans ses bras; ensuite il a dit: 'Ne vous affolez pas, son âme est en lui.'"
,"11":"Paul est remonté, il a fait la fraction du pain et il a mangé. Et puis il a recommencé à parler longuement jusqu'au point du jour, après quoi il est parti."
,"12":"De fait on a ramené le garçon vivant, ce qui a bien réconforté tout le monde."
,"13":"Nous sommes partis en bateau pour Assos; nous devions y arriver avant Paul, car il avait décidé de faire le voyage à pied, et c'est là que nous devions le reprendre."
,"14":"Il nous a bien retrouvés à Assos, nous l'avons emmené et sommes partis pour Mitylène."
,"15":"Nous en sommes repartis à la voile et le lendemain nous passions face à l'île de Quios; le lendemain nous avons touché Samos et le jour suivant nous sommes arrivés à Milet."
,"16":"Paul avait décidé de ne pas faire escale à Ephèse et de ne pas s'attarder en Asie, car il faisait tout pour être à Jérusalem pour la fête de la Pentecôte."
,"17":"C'est donc de Milet que Paul a envoyé un courrier à Ephèse pour convoquer les Anciens de l'Eglise."
,"18":"Lorsqu'ils sont arrivés, il leur a dit: 'Vous avez été témoins de ma façon d'agir tout le temps que j'ai passé avec vous, depuis le premier jour où j'ai débarqué en Asie."
,"19":"J'ai servi le Seigneur sans me faire valoir, au milieu des larmes et des épreuves que m'ont attirées les complots des Juifs."
,"20":"Vous savez que je n'ai reculé devant rien lorsque quelque chose pouvait vous être utile. J'ai prêché et enseigné en public et dans les maisons,"
,"21":"insistant auprès des Juifs comme des Grecs sur la conversion à Dieu et la foi au Seigneur Jésus."
,"22":"Maintenant je pars à Jérusalem, enchaîné par l'Esprit. Je ne sais pas ce qui m'arrivera là-bas,"
,"23":"bien que dans chaque ville l'Esprit Saint me réaffirme que la prison et les épreuves m'attendent."
,"24":"Mais ma vie ne compte pas pour moi si je peux courir jusqu'au bout et mener à bien la mission que le Seigneur Jésus m'a confiée: annoncer la Bonne Nouvelle de la grâce de Dieu."
,"25":"Et maintenant je sais que vous ne reverrez plus mon visage, vous tous parmi lesquels je suis venu prêcher le Royaume."
,"26":"C'est pourquoi aujourd'hui je veux dire bien haut que je ne suis pas responsable de ce qui peut vous arriver,"
,"27":"puisque je n'ai rien négligé pour vous annoncer toute la volonté de Dieu."
,"28":"Mais veillez sur vous-mêmes et sur tout le troupeau à la tête duquel l'Esprit Saint vous a placés: vous êtes inspecteurs pour prendre soin de cette Eglise du Seigneur qu'il s'est acquise par son propre sang."
,"29":"Je sais qu'après mon départ des loups rapaces viendront chez vous et mettront à mal le troupeau."
,"30":"Certains d'entre vous se mettront à enseigner une doctrine falsifiée, dans le seul but de détacher les disciples pour qu'ils les suivent."
,"31":"Restez donc en éveil. Rappelez-vous que durant trois ans, de jour et de nuit, je n'ai pas cessé de reprendre chacun de vous dans les larmes."
,"32":"Maintenant je vous confie à Dieu et à la parole porteuse de sa grâce: elle est capable de construire vos personnes et de vous assurer l'héritage, avec tous ceux qui ont été sanctifiés."
,"33":"Je n'ai attendu de personne argent, or ou vêtements."
,"34":"Voyez mes mains: vous savez qu'elles m'ont assuré le nécessaire pour moi et pour ceux qui étaient avec moi."
,"35":"Je vous ai ainsi montré clairement comment vous donner du mal pour aider ceux qui sont en difficulté; rappelez-vous les paroles du Seigneur Jésus, qui a dit: 'C'est une chance de donner, plus que de recevoir'."
,"36":"Lorsque Paul a eu terminé, il s'est mis à genoux avec tous pour prier."
,"37":"Tous pleuraient et se jetaient à son cou pour l'embrasser;"
,"38":"ils étaient très peinés de ce qu'il avait dit, qu'ils ne le reverraient pas. Ensuite ils l'ont conduit au bateau."
}`)
	CurrentBook.AddChapter(21, `{
"1":"L'heure du départ est arrivée, et nous nous sommes arrachés à eux. Nous sommes allés droit sur Cos puis, le jour suivant, sur Rhodes, et de là, sur Patara."
,"2":"Nous y avons trouvé un bateau en partance pour la Phénicie, nous y sommes montés et le bateau est parti."
,"3":"Nous sommes arrivés en vue de Chypre, nous l'avons laissée sur la gauche et avons fait voile sur la Syrie. Nous avons débarqué à Tyr, car c'était là que le bateau devait décharger sa cargaison. "
,"4":"Nous avons pu retrouver les disciples et nous nous sommes arrêtés sept jours. Ils disaient bien à Paul, sous l'action de l'Esprit, de ne pas monter à Jérusalem,"
,"5":"mais quand nous nous sommes trouvés à la date du départ, nous sommes partis. Tous nous ont accompagnés avec leurs femmes et leurs enfants pour sortir de la ville. Sur la plage nous nous sommes mis à genoux et nous avons prié."
,"6":"Après nous être embrassés, nous sommes montés à bord tandis qu'ils retournaient chez eux."
,"7":"Nous avons achevé la traversée avec cette étape de Tyr à Ptolémaïs. Là nous avons salué les frères et sommes restés un jour chez eux."
,"8":"Le lendemain nous partions et prenions la route de Césarée. Nous y avons été reçus dans la maison de Philippe l'Evangéliste, un des Sept;"
,"9":"il avait quatre filles vierges qui prophétisaient."
,"10":"Nous étions là depuis quelques jours quand s'est présenté Agabus, un prophète qui arrivait de Judée."
,"11":"Reçu chez nous, il a pris la ceinture de Paul avec laquelle il s'est attaché les mains et les pieds, et il a dit: 'L'homme à qui appartient cette ceinture, les Juifs de Jérusalem vont le lier juste comme je viens de faire, et ils le remettront aux étrangers.'"
,"12":"En entendant cela, nous avons insisté auprès de lui, avec tous ceux de là-bas, pour qu'il ne monte pas à Jérusalem."
,"13":"Mais Paul a déclaré: 'En pleurant ainsi vous ne faites que me déchirer le coeur. Je vous dis que je suis prêt, pour le Nom du Seigneur Jésus, non seulement à me faire arrêter à Jérusalem, mais même à y mourir.'"
,"14":"Comme il était impossible de le convaincre, nous nous sommes tenus tranquilles, disant: 'Que se fasse la volonté du Seigneur'."
,"15":"Passés ces quelques jours, nous avons préparé les bagages et sommes repartis pour Jérusalem."
,"16":"Des disciples de Césarée y sont montés avec nous et nous ont conduits chez Mnason, un disciple de la première heure, qui était de Chypre. Nous devions nous loger chez lui."
,"17":"Nous arrivons donc à Jérusalem où nous sommes bien accueillis par les frères et soeurs."
,"18":"Le lendemain Paul est allé rendre visite à Jacques: nous sommes allés avec lui."
,"19":"Paul les a salués, puis il leur a raconté en détail tout ce que Dieu avait fait dans les contrées païennes grâce à son ministère."
,"20":"Eux, bien sûr, ont rendu grâces à Dieu pour tout ce qu'ils entendaient, mais ensuite ils lui ont dit: 'Tu peux voir, frère, que parmi les Juifs les croyants se comptent par dizaines de mille, et tous sont très attachés à la Loi."
,"21":"Or ils ont entendu dire que tu invites les Juifs installés dans les contrées païennes à laisser de côté Moïse: tu leur dis de ne plus circoncire les enfants et de ne plus observer les pratiques."
,"22":"Sûrement ils sauront que tu es là: que faire?,Il va falloir réunir une assemblée générale "
,"23":"et toi, tu vas faire comme nous te disons. Nous avons ici quatre hommes qui ont fait un voeu."
,"24":"Tu vas les parrainer, tu te sanctifieras avec eux et tu paieras les frais quand ils se feront couper leur chevelure. Comme cela tous sauront qu'il n'y a rien de vrai dans ce qu'on rapporte sur ton compte, mais que toi aussi tu restes fidèle à la Loi."
,"25":"Pour ce qui est des croyants d'origine païenne, nous leur avons envoyé des directives, leur demandant de s'abstenir des viandes consacrées aux idoles, du sang et des viandes d'animaux non saignés, et des unions illégitimes.'"
,"26":"Voilà donc Paul qui parraine les hommes en question. Le lendemain il se sanctifie avec eux et il entre au Temple pour faire savoir la date où s'achèvera leur consécration temporaire et où on offrira pour eux le sacrifice."
,"27":"La semaine était sur le point de se terminer. C'est alors que des Juifs d'Asie l'ont vu dans le Temple: ils ont ameuté la foule et ils ont mis la main sur lui."
,"28":"Ils criaient: 'Israélites, aidez-nous! Voici l'homme qui prêche partout contre le peuple, contre la Loi et contre le Lieu-Saint. Maintenant il est venu profaner le Lieu-Saint, il a fait entrer des Grecs dans l'enceinte du Temple.'"
,"29":"De fait, ils l'avaient vu en ville accompagné de Trophime, un Grec d'Ephèse, et ils croyaient que Paul l'avait introduit dans le Temple."
,"30":"Du coup, toute la ville s'est agitée. Il y a eu un attroupement. Ceux qui tenaient Paul l'ont emmené vers la sortie et aussitôt on a fermé les portes."
,"31":"Ils voulaient le tuer, mais déjà on avait fait dire au commandant du bataillon que tout Jérusalem était en émoi."
,"32":"Lui, aussitôt, rassemble soldats et centurions, et il fonce sur la foule. Quand les gens voient arriver le commandant et la troupe, ils arrêtent de frapper Paul. "
,"33":"Le commandant s'approche, met la main sur Paul et ordonne de lui passer des chaînes. Puis il demande qui il est et ce qu'il a fait."
,"34":"Mais dans la foule chacun crie n'importe quoi. Voyant qu'il ne peut rien tirer au clair dans un tel tumulte, le commandant ordonne d'emmener Paul à la forteresse."
,"35":"Quand on arrive aux escaliers, les soldats sont obligés de porter Paul tant la foule est excitée:"
,"36":"tout le peuple est là qui suit en criant: 'Faites-le disparaître!'"
,"37":"Au moment de passer la porte de la forteresse, Paul a dit au commandant: 'Est-ce que je pourrais te demander quelque chose?' Il a répondu: 'Tu parles grec?"
,"38":"Tu n'es donc pas l'Egyptien qui s'est révolté il y a quelques jours et qui est parti au désert avec quatre cent terroristes?'"
,"39":"Paul alors lui a dit: 'Je suis Juif, mais je suis de Tarse en Cilicie, une ville assez connue. Permets-moi, s'il te plaît, de dire quelque chose à la foule.'"
,"40":"Avec l'autorisation du commandant, Paul s'est tenu sur les escaliers et il a fait signe de la main au peuple. On a eu un peu de silence et il a pris la parole en hébreu:"
}`)
	CurrentBook.AddChapter(22, `{
"1":"'Frères et pères, écoutez un peu, laissez-moi m'expliquer.'"
,"2":"Quand ils ont vu qu'il leur parlait en hébreu, ils se sont tenus plus tranquilles."
,"3":"Il a alors continué: 'Je suis né Juif, je suis de Tarse en Cilicie mais j'ai été éduqué ici dans cette ville. Avec Gamaliel comme maître, j'ai été instruit de la Loi de nos pères de la façon la plus correcte, et j'étais fanatique pour Dieu comme vous l'êtes tous aujourd'hui."
,"4":"J'ai donc poursuivi à mort ce Chemin: je faisais arrêter et mettre en prison les femmes comme les hommes."
,"5":"Le grand prêtre et tout le conseil des Anciens peuvent le dire: avec des lettres de pouvoir qu'ils m'ont données, je suis parti chez nos frères de Damas. Je devais faire arrêter ceux du Chemin qui s'y trouvaient et les ramener à Jérusalem pour y recevoir leur condamnation."
,"6":"J'étais sur la route et déjà proche de Damas quand, aux environs de midi, tout d'un coup il y a eu comme un éclair, une lumière qui du ciel se projetait sur moi."
,"7":"Je suis tombé à terre et j'ai entendu une voix qui me disait: 'Saul, Saul, pourquoi me persécutes-tu?'"
,"8":"J'ai répondu: 'Qui es-tu, Seigneur?' et lui m'a dit: 'Je suis Jésus de Nazareth que tu persécutes.'"
,"9":"Ceux qui m'accompagnaient avaient vu la lumière, mais ils n'entendaient pas celui qui me parlait."
,"10":"Alors j'ai dit: 'Seigneur, que dois-je faire?' Le Seigneur m'a répondu: 'Relève-toi, va à Damas et là on te dira ce que tu dois faire, comme c'est déjà prévu pour toi.'"
,"11":"La lumière avait été telle que je restais sans voir; mes compagnons m'ont donc pris par la main jusqu'à l'arrivée à Damas."
,"12":"Il y avait là un certain Ananie, un homme très observant de la Loi: tous les Juifs installés là-bas en disent du bien."
,"13":"Il est venu me trouver et il m'a dit: 'Frère Saul, recouvre la vue!' Au même moment j'ai pu voir."
,"14":"Il m'a dit alors: 'Le Dieu de nos pères t'a choisi d'avance pour connaître ses desseins, pour voir le Juste et entendre sa propre voix."
,"15":"Avec tout ce que tu as vu et entendu, tu lui rendras témoignage devant les personnes les plus diverses."
,"16":"Que te reste-t-il à faire? Reçois le baptême et invoque son Nom: ainsi tu seras lavé de tes péchés.'"
,"17":"Après mon retour à Jérusalem, un jour où je priais au Temple, j'ai eu une extase."
,"18":"Je l'ai vu qui me disait: 'N'attends pas davantage, sors au plus tôt de Jérusalem, car ils ne feront aucun cas de ton témoignage à mon sujet.'"
,"19":"J'ai répondu: 'Seigneur, ils savent bien que j'emprisonnais ceux qui croient en toi et que je les faisais flageller dans les synagogues."
,"20":"Et quand on a versé le sang d'Etienne, ton martyr, j'étais présent et j'étais d'accord. Même je gardais les vêtements de ceux qui le mettaient à mort.'"
,"21":"Mais le Seigneur m'a dit: 'Pars, je t'envoie au loin, vers les païens!'"
,"22":"Jusqu'à cette dernière phrase on avait écouté Paul. Mais alors ils se mirent à crier: 'Débarrassez le monde de cet individu, il n'a pas le droit de vivre!'"
,"23":"Ils criaient, ils déchiraient leurs vêtements et soulevaient des nuages de poussière."
,"24":"Le commandant ordonna de faire passer Paul dans la forteresse, puis il demanda de le flageller jusqu'à savoir pourquoi on criait tellement contre lui."
,"25":"Mais quand on voulut lui enlever ses vêtements, Paul dit au centurion: 'Avez-vous le droit de flageller un citoyen romain tant qu'il n'a pas été jugé?'"
,"26":"Le centurion alla aussitôt trouver le commandant pour lui dire: 'Il est Romain, qu'est-ce que tu veux faire?'"
,"27":"Le commandant s'approcha de Paul: 'Dis-moi: tu es citoyen romain?' Paul répondit: 'Oui.'"
,"28":"Le commandant fit cette réflexion: 'J'ai dû payer cher pour acheter ce titre.' Paul lui dit: 'Moi, je le suis de naissance.'"
,"29":"Aussitôt se retirèrent les soldats qui devaient faire avouer Paul, et le commandant eut peur en pensant qu'il avait passé des chaînes à un citoyen romain."
,"30":"Le lendemain il fit délier Paul. Il voulait savoir avec certitude de quoi les Juifs l'accusaient. Il demanda aux grands prêtres de se réunir avec tout le sanhédrin, et il fit descendre Paul pour qu'il s'explique devant eux."
}`)
	CurrentBook.AddChapter(23, `{
"1":"Paul regarda un moment le sanhédrin, puis il leur dit: 'Frères, je n'ai rien à me reprocher devant Dieu pour la façon dont j'ai agi jusqu'ici.'"
,"2":"Sur ce, le grand prêtre Ananias ordonna à ses assistants de le frapper sur la bouche."
,"3":"Mais Paul lui adressa ces mots: 'C'est Dieu qui va te frapper, muraille blanchie! Tu es là pour me juger selon la Loi, et tu violes la Loi en ordonnant de me frapper.'"
,"4":"Les assistants lui dirent: 'Tu oses insulter le grand prêtre de Dieu?'"
,"5":"Paul répondit: 'Frères, je ne savais pas qu'il était le grand prêtre. Bien sûr il est écrit: Tu ne maudiras pas le chef de ton peuple.'"
,"6":"Paul savait qu'une partie d'entre eux étaient Saducéens, et les autres Pharisiens, c'est pourquoi il s'écria en plein sanhédrin: 'Frères, je suis Pharisien, fils de Pharisiens, c'est pour notre espérance que je suis mis en accusation, pour la résurrection des morts!'"
,"7":"A ces mots, les Pharisiens et les Saducéens entrèrent en conflit, et l'assemblée se divisa."
,"8":"Car les Saducéens disent qu'il n'y a pas de résurrection, et pas davantage d'anges ou d'esprit, alors que les Pharisiens admettent l'un et l'autre."
,"9":"Il y eut donc un grand vacarme. Quelques maîtres de la Loi du parti des Pharisiens se levèrent pour déclarer: 'Nous ne voyons rien à reprocher à cet homme: peut-être qu'un esprit ou un ange lui a parlé.'"
,"10":"Le conflit prenait des proportions et le commandant eut peur qu'ils ne mettent Paul en pièces. Il ordonna à la troupe de descendre et de le leur reprendre pour le conduire à la forteresse."
,"11":"La nuit suivante le Seigneur vint à Paul et lui dit: 'Courage! Tu as été mon témoin à Jérusalem, il faut que tu le sois pareillement à Rome.'"
,"12":"Quand il fit jour, un certain nombre de Juifs firent un complot. Ils s'enga-gèrent sous peine de malédiction à ne rien manger ni boire tant qu'ils n'auraient pas tué Paul."
,"13":"Ils étaient plus de quarante à avoir fait ensemble ce serment."
,"14":"Quelques-uns d'entre eux allèrent trouver les grands prêtres et les Anciens et leur dirent: 'Nous nous sommes engagés sous peine de malédiction à ne rien avaler jusqu'à ce que nous ayons tué Paul."
,"15":"Allez donc trouver le commandant avec les Anciens, et demandez-lui d'amener Paul parce que vous voulez examiner à fond son cas. Et nous, avant qu'il n'approche, nous sommes là pour le tuer."
,"16":"Le fils de la soeur de Paul entendit parler du complot qui se tramait. Il alla à la forteresse pour le lui faire savoir."
,"17":"Paul appela alors l'un des centurions et lui dit: 'Conduis donc ce garçon au commandant, il a une information à lui donner.'"
,"18":"L'autre l'emmena chez le comandant auquel il dit: 'Le prisonnier Paul vient de m'appeler pour me demander de t'amener ce garçon. Il a quelque chose à te dire.'"
,"19":"Le commandant le prit par le bras et, une fois seuls, il posa la question: 'Quelle nouvelle as-tu pour moi?'"
,"20":"Et le garçon lui dit: 'Les Juifs ont pris une décision; ils vont te demander de faire descendre Paul demain au sanhédrin sous le prétexte qu'ils veulent regarder son cas de plus près."
,"21":"Mais toi, ne les crois pas. Il y a là plus de quarante hommes qui se sont engagés sous peine de malédiction à ne pas manger ni boire avant de l'avoir tué, et ils le guettent. Ils sont prêts et n'attendent que ta réponse.'"
,"22":"Le commandant renvoya le garçon avec cette recommandation: 'Ne dis surtout à personne que tu m'as révélé cette affaire.'"
,"23":"Il appela alors deux centurions et leur dit: 'Tenez prêts deux cents soldats pour aller à Césarée, et avec eux soixante-dix chevaux et deux cents auxiliaires. Départ au troisième quart de la nuit."
,"24":"Vous préparerez des montures pour y faire monter Paul et le mettre en sûreté chez le gouverneur Félix.'"
,"25":"Il écrivit ensuite une lettre qui disait:"
,"26":"'Claudius Lysias envoie ses respects à son Excellence le gouverneur Félix."
,"27":"Les Juifs s'étaient emparés de cet homme et ils étaient sur le point de le tuer. J'ai su qu'il était Romain, aussi je suis intervenu avec la troupe et je l'ai enlevé."
,"28":"J'ai voulu savoir de quoi ils l'accusaient et je l'ai amené à leur sanhédrin."
,"29":"Là j'ai vu qu'on l'accusait pour des histoires de leur loi, mais qu'il n'y avait aucun crime qui mérite la mort ou la prison."
,"30":"Maintenant on m'informe d'un complot qu'ils ont monté contre lui; je te l'envoie donc et je fais savoir à ses accusateurs qu'ils aillent te parler à son sujet.'"
,"31":"Les soldats prirent Paul conformément aux ordres reçus et, de nuit, ils partirent avec lui pour Antipatris."
,"32":"Le lendemain ils revinrent à la citadelle, laissant les cavaliers continuer avec lui."
,"33":"Ceux-ci remirent la lettre au gouverneur et lui présentèrent Paul."
,"34":"Le gouverneur s'informa, demanda de quelle contrée Paul était ressortissant et, quand il sut qu'il était de Cilicie, il déclara:"
,"35":"'Je t'entendrai quand tes accusateurs se présenteront.' Après quoi il ordonna de le garder dans le palais d'Hérode."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Cinq jours plus tard, le grand prêtre Ananias descendit à Césarée avec un groupe d'Anciens et un avocat, un certain Tertullus. Ils se présentèrent devant le gouverneur comme accusateurs de Paul."
,"2":"On le fit appeler, et Tertullus commença son réquisitoire: 'Excellent Félix, nous jouissons d'une vraie tranquillité grâce à toi et aux réformes que tu as su prévoir pour le bien de cette nation. "
,"3":"Constamment et partout nous savons le reconnaître et nous t'en disons un vrai merci."
,"4":"Mais je ne voudrais pas t'importuner, et je te prie de nous écouter quelques instants avec ta bienveillance habituelle."
,"5":"Nous avons établi que cet homme soulève des émeutes chez tous les Juifs du monde civilisé: c'est une vraie peste! Et c'est un des porte-paroles de la secte des Nazaréens."
,"6":"Il a essayé de profaner le Temple, aussi l'avons-nous arrêté et voulions-nous le juger selon notre Loi."
,"7":"C'est alors que le commandant Lysias est intervenu de façon très violente; il nous l'a arraché des mains et a ordonné à ses accusateurs de se présenter devant toi."
,"8":"Tu pourras d'ailleurs lui faire confirmer tous ces détails et tu sauras ainsi de quoi nous l'accusons.'"
,"9":"Les Juifs l'appuyèrent et certifièrent que tout cela était exact."
,"10":"Alors, sur un signe du gouverneur, Paul prit la parole: 'Je sais que tu gouvernes cette nation depuis un bon nombre d'années, et pour cela même je me défendrai plus spontanément. "
,"11":"Tu pourras d'abord vérifier toi-même que je suis à Jérusalem depuis seulement douze jours: j'y suis venu pour adorer."
,"12":"Ensuite, on ne m'a pas pris dans le Temple en train de discuter ou d'exciter la foule, et pas davantage dans les synagogues ou en ville."
,"13":"Ils sont incapables de prouver ce dont ils m'accusent en ce moment."
,"14":"Mais c'est vrai, je t'avoue que je sers le Dieu de mes pères selon notre Chemin, qu'ils traitent d'hérésie. Je crois donc tout ce qui est écrit dans la Loi et les Prophètes,"
,"15":"et j'attends de Dieu, comme eux-mêmes l'attendent, une résurrection des bons et des mauvais."
,"16":"C'est bien pourquoi j'ai soin d'être irréprochable sur tous les plans, aussi bien devant Dieu que devant les hommes."
,"17":"Après bien des années, je suis venu à la fois pour porter une aide à ceux de ma nation, et pour présenter des offrandes."
,"18":"C'est la raison pour laquelle ils m'ont trouvé dans le Temple. J'étais en état de pureté, il n'y avait ni attroupement ni tumulte;"
,"19":"il y a eu seulement ces Juifs d'Asie: ils auraient bien dû venir et m'accuser s'ils avaient quelque chose à me reprocher!"
,"20":"Mais ceux qui sont ici devraient dire quel délit ils m'ont trouvé quand j'ai comparu devant le sanhédrin."
,"21":"A moins que ce soit parce que j'ai crié face à eux: C'est pour la résurrection des morts que je suis aujourd'hui devant vous en accusé.'"
,"22":"Félix était fort bien informé au sujet du Chemin, aussi les renvoya-t-il en disant: 'Quand le commandant Lysias sera descendu, je déciderai votre affaire.'"
,"23":"Félix donna des instructions au centurion: il devait garder Paul, mais avec une certaine souplesse, et n'empêcher aucun des siens de lui venir en aide."
,"24":"Quelques jours plus tard, Félix vint avec sa femme Drusille qui était Juive. Il fit appeler Paul et l'entendit sur la foi au Christ Jésus."
,"25":"Mais quand il commença à discuter sur la justice, le contrôle des instincts et le jugement à venir, Félix prit peur. Il coupa: 'Pour l'instant tu peux t'en aller, je trouverai un moment pour te rappeler.'"
,"26":"De fait, il espérait obtenir de Paul quelque présent, c'est pourquoi il l'appelait assez régulièrement et conversait avec lui."
,"27":"Deux années s'écoulèrent ainsi. Félix fut alors remplacé par Porcius Festus et, comme il voulait faire aux Juifs une faveur, il laissa Paul en captivité."
}`)
	CurrentBook.AddChapter(25, `{
"1":"Trois jours après son arrivée dans la province, Festus monta de Césarée à Jérusalem."
,"2":"Les grands prêtres et les notables des Juifs vinrent donc lui présenter leurs accusations contre Paul. Ils insistèrent"
,"3":"et demandèrent à Festus de leur faire cette faveur de renvoyer Paul à Jérusalem; ils avaient toujours leur plan de le tuer sur le trajet."
,"4":"Festus répondit que Paul était détenu à Césarée et que lui-même devait s'y rendre sous peu."
,"5":"Il leur dit: 'Ceux d'entre vous qui ont les responsabilités descendront avec moi et feront valoir contre lui ce qu'il a fait de condamnable.'"
,"6":"Festus ne resta chez eux que quelques huit ou dix jours. Il descendit à Césarée, et le lendemain il siégeait à son tribunal. Il ordonna d'amener Paul."
,"7":"Dès qu'il fut arrivé, les Juifs qui étaient descendus de Jérusalem l'assaillirent avec quantité d'accusations graves qu'ils étaient incapables de prouver."
,"8":"Paul se défendit: 'Je n'ai rien commis qui offense la loi juive, ou le Temple, ou l'empereur.'"
,"9":"Mais Festus voulait faire un cadeau aux Juifs. Il intervint pour demander à Paul: 'Veux-tu monter à Jérusalem si c'est moi qui suis là-bas ton juge?'"
,"10":"Paul répondit: 'Je suis sous la juridiction de César, et c'est lui qui doit me juger. Je n'ai pas fait de tort aux Juifs, tu le sais parfaitement."
,"11":"Si j'ai commis une injustice, un crime qui mérite la mort, très bien, que je meure. Mais si rien n'est vrai de toutes leurs accusations, personne ne peut me céder à eux. J'en appelle à César.'"
,"12":"Festus eut alors un entretien avec son conseil, après quoi il déclara: 'Tu as fait appel à César, tu iras à César.'"
,"13":"Quelques jours plus tard, le roi Agrippa arrivait à Césarée accompagné de Bérénice; ils venaient saluer Festus."
,"14":"Ils s'arrêtèrent là plusieurs jours et Festus soumit au roi le cas de Paul. 'Il y a ici, lui dit-il, un homme que Félix a laissé en captivité."
,"15":"Quand je me suis trouvé à Jérusalem, les grands prêtres et les Anciens des Juifs sont venus me trouver pour me réclamer sa condamnation."
,"16":"Je leur ai répondu que ce n'est pas la coutume des Romains de livrer quelqu'un tant que l'accusé n'a pas eu devant lui ses accusateurs avec la possibilité de se défendre de ce dont on l'accuse."
,"17":"Ils m'ont donc accompagné ici et, dès le lendemain, sans traîner, j'ai siégé au tribunal et j'ai fait appeler l'homme."
,"18":"Ses accusateurs ont présenté leurs charges, mais ils n'ont fait état d'aucune faute comme je pouvais imaginer."
,"19":"Ce n'étaient que des discussions relatives à leurs croyances et à un certain Jésus qui est mort et dont Paul affirme qu'il est vivant."
,"20":"Comme j'étais perdu dans une discussion de ce genre, je lui ai demandé s'il voulait faire le voyage de Jérusalem et qu'on fasse là-bas son procès sur de telles questions."
,"21":"Mais Paul a fait appel; il a demandé que l'instruction de son procès soit confiée au tribunal de l'empereur. J'ai donc donné l'ordre de le garder jusqu'à ce que je puisse l'envoyer à César.'"
,"22":"Agrippa dit à Festus: 'J'aimerais moi aussi entendre cet homme.' L'autre répondit: 'Tu l'entendras demain.'"
,"23":"Le lendemain, Agrippa vient avec Bérénice, faisant tout un étalage. Ils entrent dans la salle d'audience où sont réunis les officiers supérieurs et les autorités de la ville, puis Festus donne un ordre et on amène Paul."
,"24":"Alors Festus prend la parole: 'Roi Agrippa, et vous tous messieurs qui êtes ici présents, vous avez devant vous cet homme au sujet duquel toute la communauté juive est venue me solliciter, à Jérusalem et ici-même. Ils me criaient aux oreilles: 'Cet homme n'a plus le droit de vivre!'"
,"25":"Pour moi, j'ai établi qu'il n'a rien fait qui mérite la mort, et comme lui faisait appel à l'empereur, j'ai décidé de l'envoyer."
,"26":"Mais je n'ai rien de sûr que je puisse mettre par écrit pour notre Seigneur. Je vous le présente donc à tous, et spécialement à toi, roi Agrippa, de façon à pouvoir écrire quelques mots quand on verra mieux les choses."
,"27":"Car je ne me vois pas envoyant un prisonnier sans dire de quoi on l'accuse.'"
}`)
	CurrentBook.AddChapter(26, `{
"1":"Agrippa dit alors à Paul: 'Tu es invité à présenter ta défense.' Paul étendit la main et commença ainsi sa défense:"
,"2":"'Roi Agrippa, je crois que j'ai bien de la chance de pouvoir m'expliquer aujourd'hui devant toi sur toutes ces accusations des Juifs."
,"3":"Car tu es très au fait de toutes les pratiques, comme des discussions propres aux Juifs. Je te prie donc de bien vouloir m'écouter."
,"4":"Tous les Juifs savent ce qu'a été ma vie dès ma jeunesse, aussi bien dans la communauté juive qu'à Jérusalem."
,"5":"Ils m'ont toujours vu de près et ils pourraient dire, s'ils le voulaient, que j'ai vécu en Pharisien, dans la secte la plus stricte de notre religion."
,"6":"Et si aujourd'hui je suis ici en accusé, c'est bien parce que j'espère en la promesse faite par Dieu à nos pères;"
,"7":"d'ailleurs, le culte perpétuel que nos douze tribus rendent à Dieu de jour et de nuit, ne vise à rien d'autre qu'à obtenir cette promesse. C'est pour cette espérance que je suis accusé par les Juifs, roi Agrippa."
,"8":"Pourquoi refusez-vous de croire que Dieu ressuscite les morts?"
,"9":"Pour ma part, j'avais pris le parti de m'opposer par tous les moyens au Nom de Jésus de Nazareth."
,"10":"Je l'ai fait à Jérusalem même. J'ai fait mettre en prison un bon nombre des saints après que les grands prêtres m'en avaient donné le pouvoir. Et quand on les mettait à mort, je donnais mon approbation."
,"11":"Je faisais le tour des synagogues et je multipliais les mesures de répression pour les obliger à renier leur foi. J'étais tellement enragé contre eux que je les poursuivais jusque dans les villes hors des frontières."
,"12":"C'est ainsi que je suis allé à Damas avec l'autorisation et même le mandat des grands prêtres."
,"13":"Sur le chemin, ô roi, vers l'heure de midi, j'ai vu une lumière qui venait du ciel, plus brillante que le soleil. Elle m'a ébloui, de même que mes compagnons de route;"
,"14":"nous sommes tous tombés à terre et j'ai entendu une voix qui me disait en dialecte hébreu: 'Saul, Saul, pourquoi me persécutes-tu? Tu te fais mal en résistant.'"
,"15":"J'ai dit: 'Qui es-tu, Seigneur?' Et le Seigneur m'a répondu: 'Je suis Jésus que tu persécutes."
,"16":"Relève-toi donc, tiens-toi sur tes pieds. Si je me suis montré à toi, c'est pour faire de toi le serviteur et le témoin de ce que tu as déjà vu de moi, et de ce que je te ferai voir encore."
,"17":"Je te délivrerai de ton peuple aussi bien que des nations vers lesquelles je t'enverrai."
,"18":"Tu leur ouvriras les yeux pour qu'ils se retournent des ténèbres vers la lumière, et passent du pouvoir de Satan à Dieu. Qu'ils croient en moi: ils recevront le pardon des péchés, et ils auront leur place parmi les saints.'"
,"19":"Cette vision céleste, roi Agrippa, je n'ai pas voulu m'y soustraire."
,"20":"J'ai prêché à Damas pour commencer, à Jérusalem ensuite et dans tout le pays de Judée, puis dans les nations païennes. Je parlais de se convertir et de se retourner vers Dieu, faisant désormais des oeuvres dignes d'une vraie conversion."
,"21":"Voilà pourquoi les Juifs m'ont arrêté dans le Temple et ont essayé de me tuer."
,"22":"Mais, avec la protection de Dieu, jusqu'à ce jour j'ai continué de donner mon témoignage aux petits comme aux grands. A aucun moment je ne sors de ce que les prophètes et Moïse lui-même ont annoncé:"
,"23":"le Messie devait souffrir, il serait le premier à ressusciter d'entre les morts, et il proclamerait la lumière, aussi bien pour son peuple que pour les nations étrangères.'"
,"24":"Paul en était là de sa défense lorsque Festus l'interpella d'une voix forte: 'Mais tu es fou, Paul, tu as trop étudié et tu perds la raison!'"
,"25":"'Je ne suis pas fou, excellent Festus, répondit Paul, je dis des choses vraies et qui ont beaucoup de sens."
,"26":"Si je parle devant le roi avec une telle assurance, c'est parce qu'il est bien au courant de ces choses; je suis persuadé que rien ne lui en échappe, d'ailleurs tout cela ne s'est pas passé dans un recoin."
,"27":"Crois-tu aux prophètes, roi Agrippa? Je sais que tu crois.'"
,"28":"Agrippa dit à Paul: 'Un petit peu encore et tu penses m'avoir fait chrétien!'"
,"29":"Paul répondit: 'Plaise à Dieu qu'avec un petit peu ou avec beaucoup, non seulement toi, mais vous tous qui m'entendez aujourd'hui, vous en arriviez où j'en suis, sauf pour ces chaînes.'"
,"30":"Après cela le roi se leva ainsi que le gouverneur et Bérénice et toute l'assistance."
,"31":"En s'éloignant ils en reparlaient: 'Ce prisonnier, disaient-ils, n'est pas un homme à faire des crimes qui méritent la mort.'"
,"32":"Agrippa dit à Festus: 'S'il n'avait pas appelé à César, on pouvait le mettre en liberté.'"
}`)
	CurrentBook.AddChapter(27, `{
"1":"Quand il a été décidé de nous faire prendre le bateau pour l'Italie, on a remis Paul, avec un certain nombre d'autres prisonniers, à un centurion du bataillon impérial qui s'appelait Julius."
,"2":"Nous sommes montés sur un bateau d'Adramyttium qui mettait à la voile pour les côtes d'Asie, et nous avons levé l'ancre. Il y avait avec nous Aristarque, un Macédonien qui est de Thessalonique."
,"3":"Le lendemain nous arrivions sur Sidon. Julius a montré beaucoup de bienveillance vis-à-vis de Paul. Il lui a permis de visiter ses amis qui ont pu lui rendre quelques services."
,"4":"En repartant de là, nous avons fait voile sur Chypre car nous avions le vent contre nous."
,"5":"Nous avons traversé les mers de Cilicie et de Pamphylie et nous sommes arrivés à Myre en Lycie."
,"6":"Là le centurion a trouvé un bateau d'Alexandrie qui partait pour l'Italie et il nous y a fait monter."
,"7":"Durant plusieurs jours nous avons navigué très lentement, et nous avons eu du mal à arriver à Cnide; le vent ne nous a pas permis d'entrer dans le port. Puis nous avons navigué à l'abri de la Crête, passant le cap Salmoné."
,"8":"Nous avons eu du mal à le doubler et nous sommes arrivés à un endroit qui s'appelle Bons-Ports, près de la ville de Lasaïa."
,"9":"On avait pris bien du retard et la navigation devenait dangereuse: la fête du jeûne était déjà passée. Paul a insisté alors auprès d'eux,"
,"10":"il leur a dit: 'Mes amis, je vois que la traversée est risquée et nous allons y perdre pas mal, non seulement le chargement du navire, mais même nos vies.'"
,"11":"Mais le centurion s'est fié davantage au commandant du navire et à l'armateur qu'aux raisons de Paul;"
,"12":"le port n'était pas indiqué pour y passer l'hiver et la plupart ont été d'avis de repartir et d'essayer d'atteindre Phénix, un port de Crête ouvert sur le sud-ouest et le nord-ouest: on y passerait l'hiver."
,"13":"Un vent du sud a alors commencé à souffler, et ils ont pensé qu'ils allaient atteindre leur objectif; on a levé l'ancre et nous avons longé les côtes de Crête."
,"14":"Mais peu après l'île a été balayée par un vent d'ouragan qu'on appelle le 'nord-oriental';"
,"15":"le bateau a été emporté, incapable de faire face au vent, si bien que nous sommes partis à la dérive."
,"16":"A un moment notre course nous a fait passer sous une île appelée Cauda: alors nous avons pu, non sans peine, remonter la chaloupe."
,"17":"Après l'avoir remontée, on a passé des câbles de secours pour ceinturer le bateau. Craignant d'échouer sur les sables de la Syrte, on a jeté à la mer une ancre flottante et on s'est laissé aller à la dérive."
,"18":"La tempête était telle que le lendemain ils ont commencé à jeter le chargement par-dessus bord."
,"19":"Le surlendemain, c'étaient les agrès du navire qu'ils jetaient de leurs propres mains."
,"20":"La tempête continuait avec la même violence, les jours passaient et ni le soleil ni les étoiles ne se montraient; nous avions perdu tout espoir de nous sauver."
,"21":"Cela faisait déjà longtemps qu'on ne mangeait plus. Alors Paul s'est adressé à tous et il a dit: 'Mes amis, il fallait m'écouter et ne pas quitter la Crête, nous aurions évité ces risques et toute cette perte."
,"22":"Mais maintenant je vous invite à reprendre courage: sachez que le navire va se perdre, mais nous n'aurons pas de perte de vies humaines."
,"23":"Car cette nuit un ange du Dieu à qui j'appartiens et que je sers s'est tenu à côté de moi"
,"24":"et il m'a dit: 'Ne crains pas, Paul, tu te présenteras au tribunal de César et Dieu t'accorde tous ceux qui voyagent avec toi'."
,"25":"Donc, compagnons, reprenez courage, je fais confiance à Dieu et les choses seront comme il m'a été dit."
,"26":"Il faudra bien que nous arrivions sur une île.'"
,"27":"Ce devait être notre quatorzième nuit à la dérive sur l'Adriatique quand, en pleine nuit, les matelots ont eu l'impression qu'ils avaient une terre devant eux."
,"28":"Ils ont jeté la sonde et ils ont trouvé vingt brasses. Un peu plus tard ils en ont trouvé quinze."
,"29":"Comme ils avaient peur d'échouer sur un haut-fond, ils ont lancé quatre ancres de l'avant et on a attendu impatiemment le jour."
,"30":"Les matelots ont alors cherché à se sauver et ils ont mis la chaloupe à la mer sous prétexte de rallonger les câbles d'ancre à l'avant."
,"31":"Mais Paul a dit au centurion et aux soldats: 'Vous ne pourrez pas vous sauver si ces gens-là ne restent pas sur le bateau.'"
,"32":"Les soldats ont donc tranché les câbles de la chaloupe et l'ont laissé tomber."
,"33":"En attendant qu'il fasse jour, Paul a invité tout le monde à s'alimenter. Il a dit: 'Cela fait aujourd'hui quatorze jours que nous ne prenons rien, nous ne faisons qu'attendre et nous restons à jeun."
,"34":"J'insiste pour que vous preniez de la nourriture, car il y va de votre vie: pour le reste, pas un cheveu de votre tête ne se perdra.'"
,"35":"Sur ce, il a pris du pain devant tout le monde, il a rendu grâces à Dieu, il l'a partagé et il a commencé à manger."
,"36":"Les autres ont repris courage et eux aussi ont pris de la nourriture:"
,"37":"nous étions en tout sur le bateau (deux cent) soixante-seize personnes."
,"38":"Une fois l'estomac plein, on a jeté tout le blé à la mer pour alléger le bateau."
,"39":"Quand il a fait jour, ils n'ont pas reconnu l'endroit, mais ils ont aperçu une baie avec une plage et ils ont décidé de faire tout pour y aborder."
,"40":"Ils ont donc détaché les ancres et les ont abandonnées à la mer; ils ont relâché les câbles du gouvernail et, avec une voile hissée à l'avant, ils ont laissé le vent les pousser vers le rivage."
,"41":"Mais on a touché un haut-fond, et le bateau s'est échoué; l'avant s'est enfoncé et n'a plus bougé pendant que l'arrière se disloquait sous la violence des vagues."
,"42":"A ce moment les soldats ont voulu tuer les prisonniers de peur qu'il y en ait qui s'échappent à la nage."
,"43":"Mais le centurion voulait sauver Paul et il les en a empêchés; il a ordonné à ceux d'entre eux qui savaient nager de se jeter les premiers et d'atteindre le rivage,"
,"44":"Les autres auraient les planches et les débris du bateau. C'est ainsi que nous sommes tous arrivés à terre sains et saufs."
}`)
	CurrentBook.AddChapter(28, `{
"1":"Nous étions donc sauvés. C'est alors que nous avons su que l'île s'appelait Malte."
,"2":"Les indigènes nous ont accueilli avec une cordialité peu courante. Ils ont allumé un feu et on s'est occupé de nous, car la pluie maintenant tombait, et il faisait froid."
,"3":"Paul avait ramassé une brassée de bois sec. Au moment où il l'a jetée dans le feu, la chaleur en a fait sortir une vipère qui est restée accrochée à sa main."
,"4":"Voyant la vipère qui pendait de sa main, les indigènes se sont dit: 'Celui-là est sûrement un meurtrier: il a eu beau échapper à la mer, la Justice ne lui permet pas de vivre.'"
,"5":"Mais Paul a secoué la bête dans le brasier et lui n'a eu aucun mal."
,"6":"Les autres s'attendaient à le voir enfler et tomber mort subitement, mais le temps passait et rien d'anormal ne lui arrivait. En voyant cela, ils ont changé d'avis et ils ont commencé à dire que c'était un dieu."
,"7":"Les terres près de là appartenaient au premier personnage de l'île: il s'appelait Publius. Il nous a accueilli et nous a offert très aimablement l'hospitalité durant trois jours."
,"8":"Le père de Publius était retenu au lit par une dysenterie et il avait de la fièvre. Paul est allé le voir; il a prié et lui a fait l'imposition des mains, et il l'a guéri."
,"9":"Du coup tous les autres de l'île qui avaient des malades se sont présentés et ils ont été rétablis."
,"10":"Ils nous ont donc montré beaucoup d'égards, et quand nous sommes repartis, ils nous ont pourvus de tout le nécessaire."
,"11":"Trois mois plus tard, nous partions sur un bateau d'Alexandrie qui avait passé l'hiver dans l'île; il portait le pavillon des Dioscures."
,"12":"Nous avons mis à la voile sur Syracuse où nous sommes restés trois jours."
,"13":"De là, longeant la côte, nous avons atteint Reggio. Le jour suivant le vent du sud est arrivé et deux jours plus tard nous étions à Potioles."
,"14":"Là nous avons trouvé les frères, qui ont insisté pour que nous nous arrêtions chez eux huit jours. Et ainsi nous avons atteint Rome. "
,"15":"Les frères y avaient reçu de nos nouvelles et ils sont venus jusqu'au Forum d'Appius, aux Trois-Tavernes, pour nous rencontrer. En les voyant, Paul a rendu grâces à Dieu et s'est senti réconforté."
,"16":"Quand nous sommes entrés dans Rome, le centurion a remis les prisonniers au gouverneur militaire, mais Paul a eu l'autorisation de se loger à ses frais, avec le soldat qui le gardait."
,"17":"Trois jours plus tard Paul convoquait les plus importants des Juifs. Quand ils furent chez lui, il commença à leur dire: 'Frères, on m'a amené de Jérusalem comme prisonnier; j'ai été livré aux Romains alors que je n'avais offensé en rien les autorités de notre peuple ou les coutumes de nos pères. "
,"18":"Après examen, les Romains voulaient me relâcher, vu qu'il n'y avait rien dans mon cas qui mérite la mort."
,"19":"Mais devant l'opposition des Juifs, j'ai été forcé d'en appeler à César, sans avoir pourtant la moindre intention d'accuser les autorités de mon peuple."
,"20":"Voilà pourquoi j'ai demandé à vous voir et à vous parler. Si je porte cette chaîne, c'est à cause de l'espérance d'Israël.'"
,"21":"Ils lui dirent: 'Nous n'avons pas reçu de lettres de Judée à ton sujet, et aucun des frères qui sont passés ne nous a dit ou transmis quelque chose de défavorable à ton sujet."
,"22":"Mais nous aimerions entendre de toi comment tu te situes, car nous savons que cette secte rencontre partout de l'opposition."
,"23":"Ils fixèrent avec lui un rendez-vous, et un bon nombre d'entre eux vinrent à son logement. Il leur fit tout un exposé: depuis le matin jusqu'au soir il leur parla du royaume de Dieu, partant de la loi de Moïse et des Prophètes, pour les convaincre au sujet de Jésus."
,"24":"Certains se laissaient persuader par ses raisons, les autres refusaient de croire."
,"25":"Ils n'étaient pas d'accord entre eux quand ils se retirèrent, et Paul leur dit ces mots: 'L'Esprit Saint a dit vrai quand il parlait par le prophète Isaïe au sujet de vos pères:"
,"26":"Va vers ce peuple et dis leur: Vous aurez beau écouter, vous ne comprendrez rien; vous aurez beau regarder, vous ne verrez pas."
,"27":"Oui, ce peuple a la conscience endurcie; leurs oreilles ne savent plus entendre, et leurs yeux sont bouchés. Ils ont peur de voir de leurs yeux,et d'entendre de leurs oreilles, mais alors leur coeur comprendrait et se convertirait, et moi je les guérirais."
,"28":"Sachez que déjà, ce salut de Dieu a été annoncé aux païens: eux l'écouteront.'"
,"29":"Sur ce les Juifs repartirent, ayant entre eux de fortes discussions.)"
,"30":"Paul, donc, avait ce logement particulier qu'il louait; il y resta deux années entières. Il y recevait tous ceux qui venaient le voir;"
,"31":"il leur faisait l'annonce du Royaume de Dieu et leur enseignait avec beaucoup d'assurance tout ce qui a trait au Christ Jésus, le Seigneur, et personne ne l'en empêchait."
}`)

}
func FR_LBDCC_LoadNTAIChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Voici la révélation de Jésus Christ. Dieu lui a donné de montrer à ses serviteurs ce qui doit arriver bientôt. Et il a chargé son ange d'en donner une idée à Jean, son serviteur,"
,"2":"lequel certifie que toute cette vision qu'il a eue est parole de Dieu et déclaration de Jésus Christ."
,"3":"Heureux celui qui fait la lecture, heureux ceux qui écoutent les paroles de cette prophétie et tiennent compte de tout ce qui est écrit!,Car le temps est proche."
,"4":"Lettre de Jean aux sept Eglises d'Asie: Recevez grâce et paix de celui Qui est, Qui était et Qui vient, et des sept Esprits qui se tiennent devant son trône,"
,"5":"et de Jésus Christ, le témoin fidèle, le premier re-né d'entre les morts, le souverain de tous les rois de la terre."
,"6":"Il nous a aimés, et par son sang il nous a délivrés de nos péchés; il a fait de nous un royaume, une race de prêtres pour Dieu son Père. A lui la gloire et la puissance pour les siècles des siècles! Amen."
,"7":"Voici qu'il vient porté par les nuées; tout oeil le verra, même ceux qui l'ont transpercé; toutes les races de la terre se frapperont la poitrine à cause de lui. Oui. Amen."
,"8":"'Je suis l'Alpha et l'Oméga, dit le Seigneur Dieu Qui est, Qui était et Qui vient, le Maître de l'Univers.'"
,"9":"Moi, Jean, qui suis votre frère et partage avec vous les persécutions, le royaume et l'endurance pour Jésus, je fus pris par l'Esprit certain jour du Seigneur. J'étais alors dans l'île de Patmos à cause de la parole de Dieu et des déclarations de Jésus."
,"10":"J'entendis derrière moi une voix qui résonnait comme une trompette:"
,"11":"'Ecris ce que tu vois, disait-elle, et envoie-le aux sept Eglises: à Ephèse, à Smyrne, à Pergame, à Thyatire, à Sardes, à Philadelphie et à Laodicée.'"
,"12":"Au bruit je me suis retourné pour voir qui me parlait; j'ai vu derrière moi sept lampes d'or"
,"13":"et, au milieu des sept lampes, comme un fils d'homme dont le vêtement tombait sur les talons, avec une ceinture d'or à la hauteur de la poitrine."
,"14":"Sa tête et ses cheveux sont blancs comme laine blanche, comme la neige, et ses yeux sont une flamme de feu."
,"15":"Ses pieds brillent comme le bronze en fusion, et sa voix résonne comme les eaux d'un gros torrent."
,"16":"Il a sept étoiles dans sa main droite, et de sa bouche sort une épée aiguisée à double tranchant. Son visage resplendit comme le soleil dans toute sa force."
,"17":"Quand je l'ai vu, je suis tombé à ses pieds comme mort. Mais il a posé sur moi sa main droite et m'a dit: 'N'aie pas peur. Je suis le premier et le dernier;"
,"18":"je suis Celui qui Vit. J'étais mort mais maintenant je vis pour les siècles des siècles et j'ai en main les clés de la mort et de son royaume."
,"19":"Ecris donc ce que tu vois: c'est à la fois le présent et ce qui va bientôt arriver."
,"20":"Veux-tu le secret des sept étoiles que tu as vues dans mes mains et des sept lampes d'or; les sept étoiles sont les anges des sept Eglises et les lampes sont les sept Eglises."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Ecris à l'ange de l'Eglise qui est à Ephèse: Voici ce que dit celui qui a les sept étoiles en sa main, celui qui se promène entre les sept lampes d'or:"
,"2":"Je connais tes oeuvres, tes fatigues et ta persévérance. Tu ne tolères pas ceux qui font le mal, mais tu as mis à l'épreuve ces prétendus apôtres qui ne le sont pas, et tu as vu qu'ils mentaient."
,"3":"Et puis tu as du courage: tu as eu à souffrir pour mon nom et tu ne t'es pas lassé."
,"4":"J'ai pourtant un reproche à te faire: tu as perdu ton amour du début."
,"5":"Rappelle-toi d'où tu es tombé, reprends-toi et reviens à tes premières oeuvres. Sinon je viendrai, si tu ne te reprends pas, et je déplacerai ta lampe de là où elle est."
,"6":"Mais tu fais bien de détester ce que font les Nicolaïtes: moi aussi je le déteste."
,"7":"Que celui qui a des oreilles écoute ce que l'Esprit dit aux Eglises: Le vainqueur, je lui ferai manger du fruit de l'arbre de vie qui est dans le paradis de Dieu."
,"8":"Ecris à l'ange de l'Eglise qui est à Smyrne: Voici ce que dit le Premier et Dernier, qui était mort et est revenu à la vie:"
,"9":"Je connais tes épreuves et ta pauvreté (en réalité tu es riche) et les moqueries de ceux qui se proclament Juifs alors qu'ils ne le sont pas: leur synagogue est celle de Satan."
,"10":"N'aie pas peur de ce que tu vas avoir à souffrir. Le diable fera mettre en prison plusieurs d'entre vous pour vous éprouver, et ce seront dix jours de persécution. Reste fidèle jusqu'à la mort et je te donnerai la couronne de vie."
,"11":"Que celui qui a des oreilles écoute ce que dit l'Esprit aux Eglises: 'Le vainqueur n'aura pas à souffrir de la seconde mort.'"
,"12":"Ecris à l'ange de l'Eglise qui est à Pergame: Voici ce que dit le porteur de l'épée aiguisée à double tranchant:"
,"13":"Je sais où tu habites: là même où est le trône de Satan. Mais tu n'as pas lâché mon nom et tu n'as pas renié ta foi, même quand on a tué Antipas, mon fidèle martyr. Et c'était chez vous, là où se loge Satan."
,"14":"Pourtant j'ai quelque chose à te reprocher. Tu as chez toi des gens qui suivent les leçons de Balaam, celui qui enseignait à Balac le moyen de faire fauter les Israélites, par la prostitution et les viandes offertes aux idoles."
,"15":"Ceux qui chez toi suivent les leçons des Nicolaïtes font tout pareil."
,"16":"Donc reprends-toi, ou sinon j'irai te trouver et je combattrai ces gens avec l'épée qui sort de ma bouche."
,"17":"Que celui qui a des oreilles écoute ce que l'Esprit dit aux Eglises: 'Le vainqueur, je lui donnerai la manne cachée; je lui donnerai un caillou blanc où est gravé un nom nouveau que seul connaît celui le reçoit.'"
,"18":"Ecris à l'ange de l'Eglise qui est à Thyatire: voici ce que dit le Fils de Dieu dont les yeux sont une flamme de feu et dont les pieds sont comme bronze en fusion."
,"19":"Je connais tes oeuvres, ta charité, ta foi, tes services et ta persévérance. Tu as fait ces derniers temps plus encore que dans les débuts."
,"20":"Mais je te reproche de tolérer ta Jézabel, cette femme soi-disant prophète qui enseigne mes serviteurs et les fait s'égarer, après quoi ils se prostituent et mangent les viandes consacrées aux idoles."
,"21":"Je lui ai donné un délai pour se repentir, mais elle ne veut pas renoncer à sa prostitution."
,"22":"Je vais donc la jeter sur un lit de malade; ceux qui commettent l'adultère avec elle, s'ils ne renoncent pas à ses oeuvres, je les ferai aussi passer par une dure épreuve."
,"23":"Ses enfants, je vais les frapper à mort: toutes les Eglises sauront ainsi que je perce les secrets des reins et des coeurs et je rends à chacun selon ses oeuvres."
,"24":"Mais je dis aux autres, à vous tous de Thyatire qui ne suivez pas cette doctrine: Je ne vous frapperai pas, vous qui n'avez pas connu ses 'secrets', comme ils disent, et ce sont les secrets de Satan."
,"25":"Seulement gardez bien jusqu'à ce que j'arrive ce que vous avez déjà."
,"26":"Le vainqueur, celui qui aura gardé mes commandements jusqu'au bout, je lui donnerai autorité sur les nations"
,"27":"pour qu'il les mène avec une baguette de fer et qu'il les brise comme vases de terre:"
,"28":"C'est le pouvoir que j'ai reçu de mon Père. Et je lui donnerai l'étoile du matin."
,"29":"Que celui qui a des oreilles écoute ce que l'Esprit dit aux Eglises!"
}`)
	CurrentBook.AddChapter(3, `{
"1":"Ecris à l'ange de l'Eglise qui est à Sardes: Voici ce que dit celui qui a les sept esprits de Dieu, et les sept étoiles sont à lui."
,"2":"Je connais tes oeuvres: on te croit vivant mais tu es mort. Réveille-toi et affermis ceux qui restent mais sont près de mourir. Car tes oeuvres m'ont paru bien minces à la lumière de Dieu."
,"3":"Rappelle-toi ce que tu as reçu et entendu; mets-le en pratique et reprends-toi. Si tu ne restes pas éveillé, je viendrai à toi comme un voleur, et tu ne sais pas à quelle heure j'irai te surprendre."
,"4":"J'ai pourtant quelques noms de ceux qui, à Sardes, n'ont pas souillé leurs vêtements; ceux-là m'accompagneront vêtus de blanc car ils l'ont mérité."
,"5":"Le vainqueur portera ce vêtement blanc. Jamais je n'effacerai son nom du livre de vie; je proclamerai bien sûr son nom, devant mon Père et devant ses anges."
,"6":"Que celui qui a des oreilles écoute ce que l'Esprit dit aux Eglises!"
,"7":"Ecris à l'ange de l'Eglise qui est à Philadelphie: Voici ce que dit le Saint, le Vrai, celui qui garde la clé de David et, s'il ouvre, nul autre ne ferme; s'il ferme, nul n'ouvrira."
,"8":"Je connais tes oeuvres. Je viens d'ouvrir devant toi une porte que personne ne fermera. Tu n'as guère de force, mais tu as gardé ma parole et tu n'as pas renié mon nom."
,"9":"Aussi vais-je te donner quelques-uns de ceux qui se proclament Juifs mais ne le sont pas: c'est un mensonge, ils sont la synagogue de Satan. Je te les donne et les fais venir chez toi, et ils se jetteront à tes pieds car ils verront que je t'ai aimé."
,"10":"Oui, tu as gardé mes paroles qui éprouvent la constance, et je te garderai à mon tour de ce temps d'épreuve qui va surprendre toute la terre, pour éprouver tous les habitants de la terre."
,"11":"Tout de suite j'arrive; garde bien ce que déjà tu as, que personne ne t'enlève le prix."
,"12":"Le vainqueur, je le placerai comme une colonne dans le Temple de mon Dieu, de sorte qu'on ne puisse l'en retirer. Je graverai sur lui le nom de mon Dieu et le nom de la cité de mon Dieu, la nouvelle Jérusalem qui descend du Ciel d'auprès de mon Dieu, ainsi que mon nom nouveau."
,"13":"Que celui qui a des oreilles écoute ce que l'Esprit dit aux Eglises!"
,"14":"Ecris à l'ange de l'Eglise qui est à Laodicée: Voici ce que dit celui qui est l'Amen, le témoin, celui qui est sûr et vrai, et l'origine de la création de Dieu."
,"15":"Je connais tes oeuvres: tu n'es ni froid ni chaud. Si tu pouvais être froid ou chaud!"
,"16":"Mais non, tu es tiède, ni froid ni chaud, et je vais te vomir de ma bouche. Tu te dis: 'Je suis riche, si riche que je n'ai besoin de rien.' Et tu ne vois pas que tu es misérable et digne de pitié, pauvre, aveugle et nu."
,"18":"Je te conseille, si tu veux être riche, de m'acheter de l'or éprouvé par le feu , des vêtements blancs pour t'en habiller et qu'on ne voie plus ta honte, car tu es nu; achète-moi des gouttes pour mettre dans tes yeux, et alors tu pourras voir."
,"19":"Je reprends et je corrige ceux que j'aime; fais donc des efforts et reprends-toi."
,"20":"Me voilà devant la porte et je frappe; celui qui entend ma voix et ouvre la porte, j'entrerai chez lui et je mangerai avec lui, et lui avec moi."
,"21":"Le vainqueur, je le ferai asseoir avec moi sur mon trône, tout comme moi après ma victoire je me suis assis avec mon père sur son trône."
,"22":"Que celui qui a des oreilles écoute ce que l'Esprit dit aux Eglises!"
}`)
	CurrentBook.AddChapter(4, `{
"1":"Voici ce que j'ai vu ensuite: une porte était ouverte dans le ciel. Alors la voix que j'avais entendue au début, qui résonne comme une trompette, me dit: 'Monte ici, je vais te montrer ce qui arrivera par la suite.'"
,"2":"Aussitôt je suis saisi par l'Esprit et je vois dans le ciel un trône, et sur le trône quelqu'un est assis."
,"3":"L'éclat de celui qui siège fait penser à une pierre de jaspe ou de sardoine. Un arc-en-ciel couleur d'émeraude enveloppe le trône."
,"4":"Tout autour du trône il y a vingt-quatre trônes et vingt quatre Anciens sont assis sur ces trônes, tout habillés de blanc, avec sur la tête des couronnes d'or."
,"5":"Des éclairs jaillissent du trône avec un grand vacarme et des coups de tonnerre. Devant le trône brûlent sept torches qui sont les sept esprits de Dieu."
,"6":"Un bassin transparent comme du cristal se voit devant le trône. Quatre êtres vivants occupent l'espace entre le trône et ce qui est autour. "
,"7":"Le premier Vivant ressemble à un lion, le second à un boeuf, le troisième a un visage d'homme et le quatrième est comme un aigle en plein vol."
,"8":"Chacun des quatre Vivants a six ailes couvertes d'yeux tout autour et à l'intérieur. Et de jour ou de nuit ils ne cessent de répéter: 'Saint, Saint, Saint, le Seigneur Dieu, Maître de l'Univers, Celui qui était et Qui est et Qui vient.'"
,"9":"Et chaque fois que ces Vivants rendent gloire, honneur et action de grâce à celui qui est assis sur le trône et qui vit pour les siècles des siècles,"
,"10":"les vingt quatre Anciens se prosternent devant celui qui est assis sur le trône. Ils adorent celui qui vit pour les siècles des siècles et ils jettent leurs couronnes au pied du trône en disant:"
,"11":"'Que revienne à toi, Seigneur notre Dieu, gloire, honneur et puissance, car tu en es digne. C'est toi qui as créé toutes choses, selon ta volonté elles ont été et se sont formées.'"
}`)
	CurrentBook.AddChapter(5, `{
"1":"J'ai vu alors, dans la main de celui qui siège sur le trône, un rouleau tout écrit à l'intérieur et à l'extérieur, et fermé avec sept sceaux."
,"2":"Et puis j'ai vu un ange formidable qui appelait d'une voix forte: 'Qui donc pourra briser les sceaux et ouvrir le livre?'"
,"3":"Mais personne au ciel ne pouvait ouvrir le livre et y regarder, et personne non plus sur la terre ou dans le monde d'en-bas."
,"4":"Alors j'ai beaucoup pleuré: nul n'était donc digne d'ouvrir le livre et d'en voir le contenu!"
,"5":"Mais un des Anciens m'a dit: 'Ne pleure donc pas. Le lion de Juda, le rejeton de David, a remporté la victoire: lui fera sauter les sept sceaux du livre.'"
,"6":"J'ai vu alors un agneau qui semblait avoir été égorgé. Il se tenait entre le trône et les quatre Vivants, au milieu des vingt quatre Anciens; on lui voyait sept cornes et sept yeux qui sont les sept esprits de Dieu envoyés sur toute la terre."
,"7":"C'est alors que l'Agneau se présente et prend le livre de la main de celui qui est assis sur le trône."
,"8":"A peine l'a-t-il pris que les quatre Vivants et les vingt-quatre Anciens se prosternent devant l'Agneau, chacun avec sa cithare et des coupes d'or remplies de parfums qui sont les prières des saints."
,"9":"Et ils entonnent ce cantique nouveau: 'Tu es digne de prendre le livre,et d'en ouvrir les sceaux, car tu as été égorgé et tu as acquis pour Dieu, par ton sang, des hommes de toute tribu et langue, de tout peuple et nation."
,"10":"Tu as fait d'eux pour notre Dieu un royaume, des prêtres; ils régneront sur la terre.'"
,"11":"Alors, comme je regardais, j'entendis la voix d'une quantité d'anges qui entouraient le trône avec les Vivants et les Anciens. Ils sont des milliers de milliers et des myriades de myriades,"
,"12":"et ils crient: 'L'Agneau sacrifié est digne de recevoir,la puissance, la richesse, la sagesse et la force, l'honneur, la gloire et les bénédictions.'"
,"13":"Toutes les créatures leur firent écho dans le ciel, sur la terre et dans le monde d'en-bas. Je les entendis qui disaient: 'A celui qui siège sur le trône, et à l'Agneau, la bénédiction, l'honneur, la gloire et la puissance, pour tous les siècles des siècles!'"
,"14":"Les quatre Vivants dirent l'Amen, et les Anciens se jetèrent à terre pour adorer."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Comme je regardais, l'Agneau ouvrit l'un des sept sceaux et j'entendis comme un tonnerre. C'était l'un des quatre Vivants qui disait: 'Viens'."
,"2":"Je vois alors un cheval blanc et celui qui le monte tient un arc. On lui donne une couronne; il part déjà vainqueur, et il aura la victoire."
,"3":"Puis le second sceau est ouvert, et j'entends le deuxième Vivant qui dit: 'Viens'."
,"4":"Un autre cheval sort, couleur de feu. Celui qui le monte est chargé de mettre fin à la paix sur la terre, et on lui donne une grande épée pour que les gens se tuent les uns les autres."
,"5":"Puis le troisième sceau est ouvert, et j'entends le troisième Vivant qui dit: 'Viens'. Je vois alors un cheval noir et celui qui le monte tient une balance."
,"6":"A ce moment une voix se fait entendre au milieu des quatre Vivants: 'Un kilo de blé pour une pièce d'argent, et trois kilos d'orge pour une pièce d'argent. Ne gâche pas l'huile ni le vin.'"
,"7":"Puis le quatrième sceau est ouvert, et j'entends le quatrième Vivant qui appelle: 'Viens'."
,"8":"Je vois alors un cheval verdâtre; son cavalier, c'est la Mort avec, derrière elle, le Séjour des Morts. On l'autorise à exterminer un quart de la population par l'épée, la faim, l'épidémie et les bêtes de la terre."
,"9":"Quand le cinquième sceau est ouvert, je vois sous l'autel les âmes de ceux qui ont été massacrés à cause de la parole de Dieu et du témoignage qu'ils avaient à rendre."
,"10":"Ils appellent à grands cris: 'Quand donc vas-tu faire justice, ô Maître saint et vrai? Ne feras-tu pas payer notre sang aux habitants de la terre?'"
,"11":"On donne alors à chacun d'eux un manteau blanc, et on les prie de patienter un moment jusqu'à ce que soit au complet le nombre de leurs frères et compagnons de service qui, comme eux, doivent être massacrés."
,"12":"Lorsque je le vis ouvrir le sixième sceau, il y eut un grand tremblement de terre. Le soleil devint noir comme de la toile à sac, et la lune, couleur de sang;"
,"13":"les étoiles du ciel tombèrent sur la terre comme les premières figues d'un figuier secoué par la tempête."
,"14":"Le ciel se replia comme un rouleau qu'on enroule et les montagnes et les îles abandonnèrent leur place."
,"15":"Alors les rois de la terre et les grands seigneurs, les généraux, les riches et les gens importants, et tous les autres, libres ou esclaves coururent se cacher dans les cavernes et dans les montagnes entre les roches."
,"16":"Alors ils dirent aux montagnes et aux rochers: 'Recouvrez-nous et cachez-nous aux regards de celui qui est assis sur le trône, loin de la colère de l'Agneau,"
,"17":"car le jour est venu de leur formidable colère: qui pourrait rester en place!"
}`)
	CurrentBook.AddChapter(7, `{
"1":"Après cela j'ai vu quatre anges. Ils se tenaient aux quatre extrémités de la terre et retenaient les quatre vents de la terre pour empêcher que le vent souffle sur la terre, sur la mer et sur les arbres."
,"2":"J'ai vu aussi un autre ange qui s'élevait de là où le soleil se lève et qui tenait en mains le sceau du Dieu vivant. Et voici qu'il interpelle les quatre anges qui ont reçu le pouvoir de nuire à la terre et à la mer:"
,"3":"'Ne frappez pas la terre, ni la mer, ni les arbres, le temps que nous marquions au front les serviteurs de notre Dieu.'"
,"4":"Après quoi j'ai entendu le nombre de ceux qui avaient été marqués: cent quarante-quatre mille avaient été marqués parmi les différentes tribus d'Israël."
,"5":"Douze mille de la tribu de Juda portaient la marque; douze mille aussi de la tribu de Ruben; douze mille de la tribu de Gad;"
,"6":"douze mille de la tribu d'Aser; douze mille de la tribu de Nephtali; douze mille de la tribu de Manassé;"
,"7":"douze mille de la tribu de Siméon; douze mille de la tribu de Lévi; douze mille de la tribu d'Issacar;"
,"8":"douze mille de la tribu de Zabulon; douze mille de la tribu de Joseph; douze mille enfin de la tribu de Benjamin portaient la marque."
,"9":"Aussitôt après j'ai vu une foule immense que personne ne pourrait compter. Ils appartiennent à toutes les nations, à tous les peuples et tous les clans, à toutes les langues, et se tiennent face au trône et à l'Agneau, vêtus de blanc, avec des palmes à la main."
,"10":"Et ils crient de toutes leurs forces: 'La victoire est à notre Dieu qui siège sur le trône, et à l'Agneau!'"
,"11":"Tous les anges étaient rangés autour du trône, des Anciens et des quatre Vivants. Ils se sont alors jetés au sol sur leur face et ils ont adoré Dieu:"
,"12":"'Amen. La bénédiction, la gloire, la sagesse et l'action de grâce, l'honneur, le pouvoir et la force reviennent à notre Dieu pour les siècles des siècles. Amen!'"
,"13":"Alors un des Anciens m'a posé cette question: 'Sais-tu qui sont ces gens vêtus de blanc et d'où ils viennent?'"
,"14":"J'ai répondu: 'C'est vous qui devez le savoir.',Il m'a dit: 'Ceux-là nous viennent de la grande persécution. Ils ont lavé leurs vêtements et les ont blanchis dans le sang de l'Agneau."
,"15":"C'est pourquoi ils sont là devant le trône de Dieu. Ils le serviront jour et nuit dans son temple, et celui qui siège sur le trône s'établira au milieu d'eux. "
,"16":"Ils ne connaîtront plus la faim, ni la soif, ni le vent torride et la brûlure du soleil."
,"17":"L'Agneau qui est au centre du trône sera leur pasteur,et les conduira aux fontaines d'eau vive. Et Dieu essuiera toute larme de leurs yeux.'"
}`)
	CurrentBook.AddChapter(8, `{
"1":"Quand il ouvrit le septième sceau, ce fut le silence dans le ciel pour près d'une demi-heure."
,"2":"J'ai vu alors les sept anges qui se tiennent devant Dieu: on leur remettait sept trompettes."
,"3":"Un autre ange est venu, qui se tenait à côté de l'autel de l'encens, et on lui a remis un encensoir d'or avec beaucoup d'encens; c'étaient les prières des saints qu'il devait présenter devant Dieu sur l'autel d'or, l'autel de l'encens."
,"4":"Et la fumée de l'encens, c'est-à-dire les prières de tous les saints, est montée vers Dieu de la main de l'ange."
,"5":"Ensuite l'ange a pris l'encensoir et l'a rempli des charbons allumés pour l'encens; puis il l'a vidé sur la terre. Alors il y a eu des coups de tonnerre, un grand vacarme et des éclairs, et la terre a tremblé."
,"6":"Alors les sept anges, ceux des sept trompettes, se sont tenus prêts à les faire sonner."
,"7":"Coup de trompette du premier! Du feu et de la grêle mêlés de sang tombent sur la terre; le tiers de la surface de la terre en est brûlée, un tiers des arbres sont brûlés, et toute l'herbe verte est brûlée."
,"8":"Coup de trompette du second ange! Une énorme montagne de feu ardent est précipitée dans l'océan;"
,"9":"le tiers des eaux de la mer est changé en sang, un tiers des êtres vivants qui sont dans la mer périssent, et un tiers des bateaux sont détruits."
,"10":"Coup de trompette du troisième ange! Une grande étoile tombe du ciel tout en flammes. Elle tombe sur le tiers des eaux douces et sur les sources d'eau potable."
,"11":"Le nom de cette étoile est Absinthe. Le tiers des eaux se trouve changé en absinthe et beaucoup de gens meurent à cause de ces eaux devenues amères."
,"12":"Coup de trompette du quatrième ange! Un tiers du soleil est affecté et devient obscur, et de même un tiers de la lune et le tiers des étoiles, de sorte que le jour perd un tiers de sa clarté et la nuit de même."
,"13":"Comme je restais à regarder, un aigle est passé dans les hauteurs du ciel et il a crié: 'Malheur, malheur, malheur pour les habitants de la terre! quand on entendra les coups de trompette encore à venir des trois anges qui restent.'"
}`)
	CurrentBook.AddChapter(9, `{
"1":"Coup de trompette du cinquième ange! J'ai vu un astre du ciel qui tombait sur la terre. On lui a donné la clé du puits de l'Abîme."
,"2":"Voilà qu'il ouvre le puits de l'Abîme et du puits sort de la fumée. C'est comme la fumée d'une énorme fournaise, le soleil et l'atmosphère sont obscurcis par la fumée du puits."
,"3":"De la fumée sortent des sauterelles qui se répandent sur la terre, aussi dangereuses que les scorpions de la terre,"
,"4":"et on leur donne l'ordre de s'attaquer, non pas à l'herbe des champs ni à la verdure ni aux arbres, mais aux personnes qui n'ont pas sur leur front la marque du Dieu vivant."
,"5":"Elles ne vont pas les tuer mais les faire souffrir terriblement durant cinq mois. Ces gens-là vont souffrir comme on souffre après une piqûre de scorpion."
,"6":"En ces jours-là les hommes chercheront la mort et elle ne viendra pas; ils auront beau vouloir mourir, la mort leur échappera."
,"7":"Ces sauterelles ont l'allure de chevaux équipés pour la guerre. Elles ont, semble-t-il, des couronnes d'or sur la tête; leur visage est un visage humain,"
,"8":"leur chevelure est comme une chevelure de femmes et elles ont des dents de lion;"
,"9":"elles portent des cuirasses métalliques. Leurs ailes font le même bruit qu'une armée de chars avec leurs chevaux quand ils se lancent à l'attaque."
,"10":"Leur queue est comme celle des scorpions, avec un aiguillon, et c'est leur queue qui est dangereuse et qui fait souffrir les gens durant cinq mois."
,"11":"Elles ont pour roi l'ange de l'abîme qu'on appelle en hébreu Abaddon, et en grec Apolyon (en français Perdition)."
,"12":"Voilà le premier Malheur. Aussitôt qu'il est passé, les deux autres arrivent."
,"13":"Coup de trompette du sixième ange! J'entends alors une voix qui sort des quatre cornes de l'autel de l'encens, l'autel d'or juste devant Dieu;"
,"14":"un ordre est donné à l'ange de la sixième trompette: 'Libère les quatre anges retenus au bord du grand fleuve, l'Euphrate.'"
,"15":"Et voilà que sont relâchés les quatre anges qui attendaient l'année, le mois, le jour et l'heure où ils devaient exterminer le tiers de l'humanité."
,"16":"Le nombre des combattants de leur cavalerie s'élève à vingt-mille fois dix-mille. C'est le nombre que j'ai entendu."
,"17":"Voilà comment j'ai vu les chevaux et ceux qui les montent. Ils ont des cuirasses couleur de feu avec du violet et du jaune. Les chevaux ont une tête semblable à celle d'un lion et leur bouche projette du feu, de la fumée et du soufre."
,"18":"Un tiers de l'humanité a été exterminé par ces trois fléaux: le feu, la fumée et le soufre qui sortent de leur bouche."
,"19":"les chevaux sont redoutables à cause de leur tête, mais aussi à cause de leurs queues. Ces queues sont comme des serpents avec une tête au bout, et c'est cette tête qui est redoutable."
,"20":"Les survivants, ceux qui n'étaient pas morts de ces fléaux, n'en ont pas pour autant renoncé à leurs pratiques. Ils ont continué d'adorer les démons, avec ces idoles d'or, d'argent, de bronze, de fer et de bois, qui sont incapables de voir ou d'entendre ou de marcher. Et ils ne se sont pas repentis de leurs meurtres, de leurs sorcelleries, de leur débauche et de leurs vols."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Je vis alors un autre ange formidable qui descendait du ciel. D'un nuage il s'était fait son manteau, un arc-en-ciel entourait sa tête, son visage était comme le soleil, et ses pieds, comme des colonnes de feu."
,"2":"Il tenait à la main un petit livre ouvert. Il posa son pied droit sur la mer, son pied gauche sur le continent,"
,"3":"et il poussa un cri terrible, un vrai rugissement de lion. A ce cri les sept tonnerres firent entendre leurs voix."
,"4":"Je voulus mettre par écrit le message des sept tonnerres, mais une voix venue du ciel me dit: 'Garde secret le message des sept tonnerres, n'écris rien.'"
,"5":"L'ange que je voyais planté sur la mer et sur le continent leva alors sa main droite vers le ciel"
,"6":"pour faire un serment. Invoquant le Dieu qui vit pour les siècles des siècles et qui a formé le ciel avec ce qu'il contient, la terre avec ce qui s'y trouve, les mers avec ce qu'elles renferment, il affirma qu'il n'y aurait plus de délais: "
,"7":"le septième ange s'apprête à sonner de la trompette, et le jour où on l'entendra, le plan mystérieux de Dieu se réalisera comme il l'a promis par la bouche de ses serviteurs les prophètes."
,"8":"De nouveau j'entendis cette voix du ciel qui m'avait déjà parlé: 'Va et prends le livre ouvert de la main de l'ange qui s'est planté à la fois sur la mer et sur le continent.'"
,"9":"Je m'approche donc de l'ange et je lui demande de me donner ce petit livre. Et lui me répond: 'Prends-le et mange-le. Pour ta bouche il sera doux comme miel, mais ensuite il te brûlera les boyaux.'"
,"10":"Je prends ce petit livre de la main de l'ange et je le mange. Dans ma bouche, c'est la douceur du miel, mais après l'avoir mangé il me brûle l'intérieur."
,"11":"C'est alors qu'on me dit: 'Tu dois te remettre à prophétiser, à menacer bien des royaumes, des nations et des peuples de toutes langues.'"
}`)
	CurrentBook.AddChapter(11, `{
"1":"A ce moment on me donne une canne à mesurer, en me disant: 'Va, fais l'inventaire du Temple de Dieu et de l'autel avec ceux qui y viennent pour adorer."
,"2":"Tu ne mesureras pas la cour extérieure du Temple, n'en tiens pas compte, car elle a été abandonnée aux nations païennes; elles vont piétiner la Cité sainte durant quarante deux mois."
,"3":"Je vais faire venir mes deux témoins qui doivent prophétiser durant mille deux cent soixante jours, vêtus de toile à sac."
,"4":"Ils sont les deux oliviers et les deux lampes qui brûlent devant le Seigneur de toute la terre."
,"5":"Si quelqu'un leur fait du mal, un feu sortira de leur bouche pour consumer leurs ennemis: ainsi périra celui qui s'avise de leur faire du mal."
,"6":"Tout le temps de leur activité prophétique, ils ont le pouvoir de fermer le ciel de sorte qu'il ne donne plus une goutte de pluie. Ils ont le pouvoir de changer les eaux en sang et de frapper la terre de toutes sortes de plaies aussi souvent qu'ils le veulent."
,"7":"Puis, quand ils auront fini de donner leur témoignage, la bête qui monte de l'abîme leur fera la guerre, les vaincra et les fera mourir."
,"8":"Leur cadavre est resté sur la place de la Grande Ville qu'on appelle de façon symbolique Sodome, ou encore l'Egypte, là même où leur Seigneur a été crucifié."
,"9":"Durant trois jours et demi les humains de toute race et tribu, de toute langue et de toute nation contemplent leurs restes , car on ne permet pas de les ensevelir."
,"10":"Quelle joie alors pour les habitants de la terre! Ils en sont ravis et même ils échangent des cadeaux, car ces deux prophètes mettaient au supplice les habitants de la terre."
,"11":"Mais après ces trois jours et demi un souffle de vie, un esprit de Dieu, entra en eux. Ils étaient là debout, et tous les spectateurs furent saisis d'une grande crainte."
,"12":"J'entendis alors une voix qui venait du ciel et leur disait: 'Montez jusqu'ici!' Et ils montèrent au ciel dans la nuée sous les yeux de leurs ennemis."
,"13":"A ce moment précis il y eut un fort tremblement de terre et le dixième de la Ville s'écroula. Sept mille personnes périrent dans le séisme, et les autres, tout effrayées, rendirent gloire au Dieu du ciel."
,"14":"C'était là le deuxième malheur. Voilà qu'il est passé et le troisième malheur arrive."
,"15":"Coup de trompette du septième ange! De grandes acclamations se font entendre dans le ciel: 'C'est maintenant le règne de notre Seigneur,et celui de son Messie: Il règnera pour les siècles des siècles.'"
,"16":"A ce moment les vingt-quatre Anciens qui siégeaient devant Dieu sur leurs trônes se sont prosternés et ils ont adoré Dieu"
,"17":"en disant: 'Nous te rendons grâce, Seigneur Dieu, Maître de l'univers, toi Qui es et Qui étais, car tu as fait usage de ton pouvoir souverain,et tu as commencé à régner."
,"18":"Les nations étaient en fureur, mais ta fureur les a surprises. Le moment était venu de juger les morts,et de récompenser tes serviteurs les prophètes, avec tous ceux qui craignent ton nom, les saints grands ou humbles, et tu devais déchirer ceux qui déchirent le monde.'"
,"19":"Le temple de Dieu dans le ciel s'est alors ouvert et l'on a pu voir l'arche de son Alliance à l'intérieur du temple. Il y eut des éclairs, un grand vacarme et du tonnerre. La terre a tremblé et de gros grêlons sont tombés."
}`)
	CurrentBook.AddChapter(12, `{
"1":"On a vu ensuite dans le ciel un signe impressionnant, une femme revêtue du soleil, avec la lune sous ses pieds et sur sa tête une couronne de douze étoiles."
,"2":"La femme est enceinte, et elle crie de douleur car elle est près d'accoucher."
,"3":"Mais un autre signe est apparu dans le ciel: un dragon couleur de feu était là. Il avait sept têtes et dix cornes, et ses têtes étaient couronnées;"
,"4":"sa queue balayait un tiers des étoiles du ciel et les précipitait sur la terre. Le dragon s'est posté devant la femme qui allait accoucher de façon à dévorer son enfant sitôt qu'elle aurait accouché. "
,"5":"Elle a mis au monde son fils, un mâle, celui qui doit mener les nations avec une baguette de fer. Et subitement l'enfant a été enlevé vers Dieu, jusqu'auprès de son trône."
,"6":"Quant à la femme, elle a fui au désert; Dieu lui a préparé là un endroit où on la nourrira durant mille deux cent soixante jours."
,"7":"Il y eut alors dans le ciel une guerre; Michel et ses anges ont combattu le dragon et le dragon a combattu, aidé par ses anges;"
,"8":"mais il n'a pas été le plus fort et ils ont perdu leurs places dans le ciel."
,"9":"Il a donc été précipité, le grand dragon, le serpent d'autrefois, celui qu'on appelle Diable et Satan, celui qui égare la terre entière. On l'a précipité sur la terre et ses anges ont été précipités avec lui."
,"10":"A ce moment j'ai entendu de grandes acclamations dans le ciel: Voici enfin le salut, la puissance,et la royauté de notre Dieu, le règne de son Messie est arrivé!,Maintenant est mis à bas celui qui accusait nos frères, qui nuit et jour les accusait devant Dieu."
,"11":"Mais ils l'ont vaincu par le sang de l'Agneau, par leur parole et leur témoignage, parce qu'ils ont méprisé leur propre vie jusqu'à en mourir."
,"12":"Réjouissez-vous, cieux et habitants des cieux, mais malheur à vous terre et mer, car le diable est descendu chez vous; sa fureur est grande car il sait qu'il a peu de temps.'"
,"13":"Quand il s'est vu précipité sur terre, le dragon a poursuivi la femme qui avait mis au monde l'enfant mâle."
,"14":"Mais on a donné à la femme les deux ailes du grand aigle pour qu'elle vole jusqu'à son endroit au désert. Là elle sera nourrie loin du serpent durant une période, deux périodes et une demi-période."
,"15":"Le serpent a fait jaillir l'eau de sa bouche derrière la femme. C'était un vrai fleuve où elle allait se noyer."
,"16":"Mais la terre est venue au secours de la femme. La terre a ouvert sa bouche, avalant le fleuve que le dragon faisait sortir de sa bouche."
,"17":"Furieux contre la femme, le dragon est parti en guerre contre le reste de ses enfants, ceux qui observent les commandements de Dieu et gardent les déclarations de Jésus."
,"18":"Il s'est arrêté sur les sables du bord de mer."
}`)
	CurrentBook.AddChapter(13, `{
"1":"J'ai vu alors une bête qui remontait de la mer et qui avait dix cornes et sept têtes; ses cornes portaient dix couronnes et sur ses têtes étaient gravés des titres qui offensent Dieu."
,"2":"La bête que j'ai vue ressemblait à un léopard, mais elle avait des pattes d'ours et une gueule de lion. Le dragon lui a donné sa propre puissance, son trône et le pouvoir politique."
,"3":"Une des têtes paraissait blessée à mort, mais cette blessure mortelle s'est guérie et toute la terre en est restée stupéfaite. Ils ont suivi la bête"
,"4":"et ils ont adoré le dragon qui avait donné à la bête le pouvoir politique. Ils ont même adoré la bête: 'Qui donc, disaient-ils, est comme la bête, qui pourrait lui tenir tête?'"
,"5":"On lui a donné de parler avec beaucoup d'orgueil et elle a insulté Dieu. On lui a donné le pouvoir politique pour quarante-deux mois,"
,"6":"et elle a ouvert la bouche pour insulter Dieu, pour insulter son Nom et sa Résidence, c'est-à-dire ceux qui résident dans les cieux."
,"7":"On lui a donné de faire la guerre aux saints et de les vaincre; on lui a donné de soumettre les gens de toute tribu, de tout peuple, de toute langue et nation."
,"8":"Tous les habitants de la terre vont l'adorer, tous ceux dont le nom n'est pas écrit depuis la création du monde sur le livre de vie de l'Agneau sacrifié."
,"9":"Que celui qui a des oreilles écoute ceci:"
,"10":"Qui est pour la prison ira à la prison, qui est pour l'épée périra par l'épée. C'est pour les saints l'heure de la fermeté et de la foi."
,"11":"A ce moment j'ai vu une autre bête qui montait de la terre; elle avait deux cornes comme celles de l'Agneau, mais elle parlait comme le dragon."
,"12":"Elle est au service de la première bête et dispose de toute son autorité. Elle fait que la terre et ses habitants adorent la première bête qui s'est remise de sa blessure mortelle."
,"13":"Elle fait de grands prodiges; elle a même fait tomber sur terre le feu du ciel à la vue de tous."
,"14":"C'est ainsi qu'elle égare les habitants de la terre grâce aux prodiges qu'on lui a donné de faire au service de cette bête. Elle dit aux habitants de la terre: 'Faites donc une image de cette bête qui a été frappée de l'épée et s'en est remise.'"
,"15":"Elle a été capable de donner vie à cette image de la bête. Et voilà que l'image de la bête se met à parler, et elle fait mettre à mort tous ceux qui n'adorent pas l'image de la bête."
,"16":"C'est ainsi que tous, petits et grands, riches et pauvres, libres ou esclaves, se laissent marquer de la marque de la bête sur leur main droite ou sur le front."
,"17":"Et personne ne peut plus acheter ou vendre s'il n'est pas marqué de la marque de la bête, ou de son nom ou du chiffre de son nom."
,"18":"Si vous êtes intelligents, cherchez un peu et devinez à partir du chiffre de la bête. Son chiffre est celui d'une personne et ce chiffre est 666."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Ensuite j'ai vu ceci: l'Agneau se tenait sur le Mont Sion avec autour de lui les 14 4.000 qui portent son nom et le nom de son père écrit sur leur front."
,"2":"J'ai entendu une clameur dans le ciel, puissante comme le vacarme des grandes eaux ou comme celui du tonnerre. Ce que j'entendais devait être un choeur où chacun chante et s'accompagne avec sa guitare,"
,"3":"pendant qu'il chante le cantique nouveau en présence du trône et des quatre Vivants et des vingt quatre Anciens. Personne ne pouvait apprendre ce chant sinon les 14 4.000 qui ont été rachetés de ce monde."
,"4":"Ceux-là sont comme les prémices offertes à Dieu et à l'Agneau; ils ont été rachetés d'entre les hommes."
,"5":"Il n'y a pas eu de mensonge dans leur bouche; ils sont sans tache."
,"6":"Alors j'ai vu un autre ange qui volait dans les hauteurs du ciel, apportant une bonne nouvelle, la définitive, qu'il doit annoncer à tous les habitants de la terre, à tout peuple et tribu de toute langue et de toute nation."
,"7":"Et il leur crie: 'Craignez Dieu et rendez-lui gloire, car l'heure de son jugement est arrivé. Adorez celui qui a fait le ciel et la terre, la mer et les sources!'"
,"8":"Un second ange est venu qui a dit: 'Elle est tombée! elle est tombée, Babylone la Grande! celle qui enivrait toutes les nations avec sa prostitution sau vage!'"
,"9":"Un troisième ange est venu qui a crié: 'Celui qui adore la bête et son image et qui se laisse marquer au front ou sur la main droite,"
,"10":"celui-là boira aussi jusqu'à l'ivresse la fureur de Dieu, ce vin pur qu'il a préparé dans la coupe de sa colère! Il sera torturé par le feu et par le soufre en présence des saints anges et de l'Agneau.'"
,"11":"Oui, la fumée de leur supplice continue de monter siècle après siècle. De jour et de nuit ils n'ont pas de repos, ceux qui ont adoré la bête et son image, ceux qui ont accepté la marque de son nom."
,"12":"C'est donc l'heure de la fermeté pour les saints, pour ceux qui gardent les commandements de Dieu et la foi de Jésus."
,"13":"Et j'ai entendu une voix dans le ciel qui disait: 'Ecris ceci: Heureux, dès maintenant, ceux qui sont morts dans le Seigneur! Oui, dit l'Esprit, ils sont réconfortés après toutes leurs peines, car leurs oeuvres les ont suivis.'"
,"14":"Après cela j'ai vu un nuage lumineux et quelqu'un assis sur le nuage; on aurait dit un fils d'homme. Il avait sur sa tête une couronne d'or, et dans sa main une faucille affûtée."
,"15":"Un autre ange est sorti du temple et il a crié à celui qui siégeait sur le nuage: 'Lance ta faucille et moissonne, car il est temps de moissonner, la moisson de la terre est mûre.'"
,"16":"Alors celui qui siégeait sur le nuage a lancé sa faucille sur la terre, et la terre a été moissonnée."
,"17":"Un autre ange est sorti du temple qui est dans le ciel, ayant lui aussi une faucille affûtée;"
,"18":"et un autre ange en core est venu de l'autel de l'encens, celui qui est chargé du feu. Il a appelé celui qui tenait la faucille affûtée pour lui crier: 'Lance ta faucille affûtée et coupe les grappes de la vigne de la terre, car ses raisins sont mûrs.'"
,"19":"L'ange a alors lancé sa faucille sur la terre, afin de vendanger les raisins de la terre; et il les a jetés dans le pressoir de la terrible fureur de Dieu."
,"20":"Le pressoir a été foulé hors de la ville, et du pressoir il est sorti du sang. Sur une étendue de douze cents stades le sang montait jusqu'au mors des chevaux."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Alors j'ai vu dans le ciel un autre signe grand et étonnant, sept anges porteurs de sept fléaux. Ce sont les derniers, car avec eux s'apaisera la fureur de Dieu."
,"2":"J'ai vu un grand bassin de cristal avec des veines de feu, et sur cette estrade de cristal se tenaient les vainqueurs de la bête et de son image et du chiffre de son nom; ils avaient en main les guitares de Dieu."
,"3":"Leur chant, c'est le cantique de Moïse, serviteur de Dieu, et le cantique de l'Agneau: 'Grandes et admirables sont tes oeuvres, Seigneur Dieu, Maître de l'univers!,Tes actes sont justes et vrais, ô Roi des nations!"
,"4":"Peut-on refuser de te craindre, Seigneur, et de donner gloire à ton nom?,Car toi seul es saint: tous les peuples viendront adorer en ta présence, car tes décisions maintenant sont venues à la lumière.'"
,"5":"Et voici ce que j'ai vu ensuite: le Temple céleste de Dieu s'est ouvert, la Tente des Déclarations divines."
,"6":"Les sept anges porteurs des sept fléaux sont sortis du temple vêtus de lin brillant et impeccable, avec des ceintures d'or à la hauteur de la poitrine,"
,"7":"et l'un des quatre Vivants a remis aux sept anges sept coupes d'or remplies de la fureur du Dieu qui vit pour les siècles des siècles."
,"8":"Le temple a été envahi par la fumée provenant de la Gloire de Dieu et de sa puissance; il n'a plus été possible d'entrer dans le temple avant que les sept fléaux des sept anges aient pris fin."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Alors j'ai entendu dans le temple une voix forte qui appelait les sept anges: 'Allez, versez sur la terre les sept coupes de la fureur de Dieu.'"
,"2":"Le premier sort et verse sa coupe sur la terre: de gros ulcères forts pénibles apparaissent sur tous ceux qui portent la marque de la bête et adorent son image."
,"3":"Le deuxième verse sa coupe sur la mer: voilà du sang comme après un meurtre, et tout ce qui vit dans la mer en meurt."
,"4":"Quand le troisième verse sa coupe sur les rivières et les sources d'eau douce, c'est du sang partout."
,"5":"J'ai entendu cet ange des eaux potables qui disait: 'Tu as pris une juste décision, toi qui Es et qui Etais, et tu es parfait en tout:"
,"6":"ils ont versé le sang des saints et des prophètes et tu leur donnes à boire le sang. Ils l'ont bien mérité.'"
,"7":"Alors l'autel de l'encens a parlé, je l'ai entendu: 'Oui, Seigneur Dieu, Maître de l'Univers, tes décisions sont justes et vraies.'"
,"8":"Quand le quatrième ange a versé sa coupe sur le soleil, il a commencé a commencé à brûler les humains."
,"9":"Les humains avaient de terribles coups de soleil et ils insultaient le nom de Dieu qui a pouvoir sur de tels fléaux, mais ils ne se sont par repentis et ils n'ont pas reconnu leurs fautes."
,"10":"Quand le cinquième ange a versé sa coupe sur le trône de la bête, la nuit est venue sur tout son royaume. Les gens se mordaient la langue de douleur,"
,"11":"et ils insultaient le Dieu du ciel à cause de leurs douleurs et de leurs ulcères. Ils ne se sont pas repentis de leurs oeuvres.."
,"12":"Quand le sixième ange a versé sa coupe sur le Grand Fleuve de l'Euphrate, les eaux ont tari, ouvrant ainsi un chemin aux rois qui viennent de l'orient."
,"13":"Alors j'ai vu trois esprits impurs qui sortaient de la bouche du dragon, de la bouche de la bête et de celle du faux prophète: on aurait dit des grenouilles."
,"14":"Ces esprits démoniaques font des miracles, et ils vont ameuter les rois du monde entier pour le combat du grand jour de Dieu, Maître de l'Univers."
,"15":"J'arrive comme un voleur. Heureux celui qui veille et qui reste habillé, il ne risquera pas de se lever tout nu et qu'on voie ce qu'on ne doit pas voir."
,"16":"Il a réuni les rois au lieu qu'on appelle en hébreu Har-Maguédon (ou montagne de Méguiddo)."
,"17":"Alors le septième ange a déversé sa coupe dans l'atmosphère pendant qu'une voix puissante sortait du temple. Elle venait du trône et disait: 'C'est arrivé.'"
,"18":"Il y a eu des éclairs, du vacarme et du tonnerre, et un grand tremblement de terre. On n'avait jamais vu un tel séisme depuis que la terre est habitée."
,"19":"La Grande Ville s'est divisée en trois parties et les cités des nations se sont écroulées. Devant Dieu on venait de se souvenir de Babylone la Grande et on allait l'enivrer de la fureur et de la colère de Dieu."
,"20":"Toutes les îles ont pris la fuite et les montagnes ont décampé."
,"21":"Une grosse grêle avec des grêlons de plusieurs kilos s'est abattue sur les humains, et les humains ont insulté Dieu pour ce fléau de la grêle, car c'est un terrible fléau."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Alors un des sept anges des sept fléaux est venu à moi et m'a parlé: 'Viens donc que je te montre le jugement de la grande prostituée installée au bord des grandes eaux;"
,"2":"les rois de la terre couchaient avec elle et les habitants de la terre s'enivraient de sa luxure.'"
,"3":"L'ange m'enleva en esprit et me conduisit au désert. Là j'ai vu une femme assise sur une bête couleur écarlate, qui avait sept têtes et dix cornes, toute couverte de titres qui sont autant d'insultes à Dieu."
,"4":"La femme était vêtue de rouge pourpre et écarlate, elle était parée d'or, de perles et de pierres précieuses. Elle tenait à la main une coupe d'or remplie de choses abominables, toutes les impuretés de sa prostitution."
,"5":"Sur son front était écrit son nom, un nom à mystères: Babylone la Grande, la mère des prostituées et des abominations de toute la terre."
,"6":"Et j'ai vu cette femme ivre du sang des saints et du sang des martyrs de Jésus."
,"7":"Quand je la vis, ce fut pour moi un grand étonnement. Alors l'ange me dit: 'Qu'est-ce qui t'étonne? Je vais t'expliquer le secret de la femme et de la bête qui la porte, qui a sept têtes et dix cornes."
,"8":"La bête que tu as vue était mais n'Est pas. Elle va remonter de l'abîme mais elle va à sa perte. Et ce sera une grande surprise pour les habitants de la terre dont le nom n'est pas écrit depuis le commencement du monde sur le livre de vie, quand ils verront que la bête qui était N'Est Pas, mais qu'elle passe.'"
,"9":"Si vous êtes astucieux, essayez ici de comprendre. Les sept têtes sont sept monts sur lesquels la femme est assise; et ce sont aussi sept rois."
,"10":"Les cinq premiers sont tombés; un est en place; un autre n'est pas encore arrivé, mais une fois là il durera peu."
,"11":"S'il faut un huitième, ce sera la bête qui était et N'Est Pas, laquelle va avec les sept et court à sa perte."
,"12":"Les dix cornes que tu as vues sont dix rois qui n'ont pas encore commencé à régner; ils obtiendront le pouvoir et seront rois pour une heure à la suite de la bête."
,"13":"Ils poursuivent un même but et ils donneront à la bête leurs forces et leur autorité."
,"14":"Ils feront la guerre à l'Agneau, mais l'Agneau est Seigneur des seigneurs et Roi des rois; il sera vainqueur, et avec lui ceux qu'il a élus et appelés et qui lui sont fidèles.'"
,"15":"Il me dit encore: 'Les eaux que tu as vues, au bord desquelles la prostituée est assise, ce sont des peuples et des multitudes de toute nation et de toute langue."
,"16":"Quant aux dix cornes que tu as vues sur la bête, elles haïront la prostituée. elles la dépouilleront et la laisseront nue, elles mangeront sa chair et la réduiront en cendres."
,"17":"Dieu leur fait vouloir tout cela afin de réaliser son propre projet; ils n'ont qu'un même dessein et ils livreront leur royaume à la bête jusqu'à ce que s'accomplissent les paroles de Dieu."
,"18":"Oui, la femme que tu as vue est la Grande Ville, celle qui a autorité sur tous les rois de la terre.'"
}`)
	CurrentBook.AddChapter(18, `{
"1":"Après cela je vis un autre ange qui descendait du ciel et rayonnait une telle puissance que la terre était illuminée par sa gloire."
,"2":"Il cria d'une voix puissante: 'Elle est tombée! Elle est tombée, Babylone la Grande!,Elle est devenue une demeure de démons, un abri pour tout esprit impur, un repaire d'oiseaux impurs et indésirables."
,"3":"Toutes les nations s'enivraient de sa luxure effrénée,les rois de la terre couchaient avec elle,les marchands de la terre se sont enrichis avec elle, tant elle savait dépenser.'"
,"4":"Alors j'ai entendu une autre voix venant du ciel qui disait: 'Sortez de chez elle, ô mon peuple. Ne vous laissez pas contaminer par ses péchés, car vous auriez part à ses châtiments."
,"5":"Ses péchés se sont accumulés jusqu'à toucher le ciel, et Dieu s'est souvenu de ses injustices."
,"6":"Payez-la de sa propre monnaie, rendez-lui au double ce qu'elle a fait, préparez-lui double mesure de ce qu'elle faisait boire!"
,"7":"Donnez-lui tourments et peines,à la mesure de son orgueil et de son luxe. Elle dit en son coeur: Je suis là et je suis reine, je ne suis pas veuve et ne connaîtrai pas le deuil."
,"8":"Pour cela en un jour ses fléaux tomberont sur elle: la mort, le deuil et la famine, après quoi le feu la réduira en cendres. Car Dieu qui l'a condamnée est un puissant Seigneur."
,"9":"Les rois de la terre qui couchaient avec elle, pleureront et se frapperont la poitrine quand ils verront les fumées de son incendie."
,"10":"Ils se tiendront à distance effrayés du tourment qui la frappe et diront: 'Hélas, hélas pour toi, Grande Ville!,Hélas pour toi, Babylone, ville puis sante!,En l'espace d'une heure ta sentence est venue.'"
,"11":"Les marchands de la terre pleurent et se lamentent sur elle, car plus per sonne ne leur achète leur marchandise,"
,"12":"leur cargaison d'or et d'argent, de pierres précieuses et de perles, de lin fin, de soie, et d'étoffes de couleur; leurs bois odorants, leurs objets d'ivoire et de bois précieux; le bronze, le fer et le marbre;"
,"13":"le cinnamome, l'amome, les parfums, la myrrhe et l'encens; le vin, l'huile, la semoule et les blés; les bestiaux, les moutons, les chevaux, les mulets, les humains - les personnes humaines!"
,"14":"Tout ce qui rassasiait ton désir est maintenant loin de toi; tout ce qui est chic et tout ce qui brille, est perdu pour toi et ne reviendra pas."
,"15":"Ceux qui vendaient toutes ces choses et se faisaient riches chez elle, vont se tenir à distance par peur du tourment qui la frappe. Ils vont pleurer et se lamenter:"
,"16":"'Hélas, hélas pour toi, Grande Ville!,Tu t'habillais de lin fin, d'étoffes de couleur, et tu te parais de bijoux d'or et d'argent, de pierres précieuses et de perles:"
,"17":"et l'espace d'une heure, tant de richesse s'est perdue!',Le navigateur, le pilote et le matelot, avec tous ceux qui vivent de la mer sont restés à distance. "
,"18":"Voyant les fumées de son incendie, ils ont crié: 'Y a-t-il eu jamais comme la Grande Ville?'"
,"19":"Ils se sont jeté de la poussière sur la tête, ils ont pleuré et se sont lamentés: 'Hélas! Hélas pour toi, Grande Ville!,Tous ceux qui ont des bateaux à la mer,se sont faits riches grâce à ton luxe, et l'espace d'une heure, tout est saccagé!'"
,"20":"Mais que le ciel soit en fête! Réjouissez-vous, saints, apôtres et prophètes, car Dieu a défendu votre cause et elle a payé."
,"21":"A ce moment un ange formidable a pris une pierre, une meule énorme, et l'a jetée dans la mer. Il a dit: 'Babylone, la Grande Ville, sera précipitée avec la même violence. On ne la reverra pas."
,"22":"On n'entendra plus chez toi le chanteur avec sa guitare, le musicien, l'homme de la flûte ou de la harpe. On ne verra plus chez toi les artisans de tout métier; on n'entendra plus chez toi le bruit de la meule."
,"23":"On ne verra plus de lumières, ni de feu ni de lampe; chez toi ne s'entendra plus le chant du marié ou celui de l'épouse. C'est que tes marchands étaient les grands de ce monde,et tu égarais tous les peuples avec tes drogues:"
,"24":"chez elle on a trouvé le sang des prophètes, des saints, de tous ceux qui furent massacrés sur cette terre.'"
}`)
	CurrentBook.AddChapter(19, `{
"1":"Après cela j'ai entendu comme l'acclamation d'une foule immense. Ils disaient: 'Alléluia!,A notre Dieu la victoire, la gloire et la puissance."
,"2":"Oui, ses décisions sont vraies et justes; il a jugé la grande prostituée dont les prostitutions pourrissaient le monde, il lui a réclamé le sang de ses serviteurs.'"
,"3":"Et de nouveau ils ont dit: 'Alléluia! Que sa fumée monte sans trêve pour les siècles des siècles!'"
,"4":"A ce moment les vingt-quatre Anciens et les quatre Vivants se sont jetés à terre pour adorer Dieu qui siège sur le trône. Ils ont dit: 'Amen, Alléluia!'"
,"5":"Alors une voix est sortie du trône qui disait: 'Chantez pour notre Dieu, vous tous ses serviteurs, petits et grands, vous tous qui le craignez.'"
,"6":"J'ai entendu ensuite, comme l'acclamation d'une foule immense, comme le vacarme d'un gros torrent ou le grondement d'un fort tonnerre. Ils disaient: 'Alléluia!,C'est maintenant le règne du Seigneur, de notre Dieu, maître de l'univers."
,"7":"Réjouissons-nous, crions de joie et rendons-lui gloire, car ce sont maintenant les noces de l'Agneau, et son épouse s'est préparée."
,"8":"On lui a donné pour se vêtir,du lin fin, blanc et net."
,"9":"A ce moment il me dit: 'Ecris ceci: Heureux les invités au banquet des noces de l'Agneau.' Et il me dit encore: 'Ce sont des paroles de Dieu authentiques.'"
,"10":"Alors je me suis jeté à ses pieds pour l'adorer, mais il m'a dit: 'Non! Je sers comme toi et comme tes frères qui transmettent les déclarations de Jésus. C'est Dieu que tu dois adorer.'"
,"11":"Alors j'ai vu le ciel ouvert. J'ai vu un cheval blanc et celui qui le monte; on l'appelle le Fidèle et le Vrai. Il juge, il combat, selon la droiture."
,"12":"Ses yeux sont une flamme de feu et l'on voit sur sa tête de nombreuses couronnes. Nul autre que lui ne connaît le Nom écrit sur lui."
,"13":"Il s'enveloppe d'un manteau trempé de sang et on l'appelle le Verbe de Dieu."
,"14":"Les armées du ciel le suivent, équipées de chevaux blancs, vêtues de lin fin net et blanc."
,"15":"Une épée aiguisée sort de sa bouche, pour en frapper les nations. C'est lui qui doit les mener avec une baguette de fer, et c'est lui encore qui foule au pressoir le vin de la fureur et de la colère de Dieu, Maître de l'univers. "
,"16":"Sur son manteau et sur sa cuisse, un titre est inscrit: Roi des rois et Seigneur des seigneurs."
,"17":"Je vis alors un ange debout sur le soleil, appelant à grands cris tous les oiseaux qui volaient dans les hauteurs du ciel: 'Tous ici, rassemblez-vous pour le grand banquet de Dieu!"
,"18":"Vous mangerez la chair des rois, la chair des généraux, la chair des héros, des chevaux et des cavaliers. Libres ou esclaves, petits et grands, vous les mangerez tous.'"
,"19":"Je vis la bête avec les rois de la terre et leurs armées, réunis pour combattre celui qui monte le cheval et son armée."
,"20":"La bête fut prise, et avec elle le faux prophète qui faisait des prodiges à son service: il a égaré grâce à ses prodiges ceux qui ont reçu la marque de la bête et adorent son image. Les deux furent jetés vivants dans l'étang de feu où brûle le soufre."
,"21":"Tous les autres furent massacrés par l'épée de celui qui monte le cheval, cette épée qui sort de sa bouche, et tous les oiseaux du ciel se sont rassasiés de leurs chairs."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Alors j'ai vu un ange qui descendait du ciel et tenait dans sa main la clé de l'abîme avec une grande chaîne."
,"2":"Il se rendit maître du dragon, le Serpent d'autrefois, c'est-à-dire le diable ou Satan, et il l'enchaîna pour mille ans."
,"3":"Il le précipita dans l'abîme, il ferma la serrure et scella le tout pour qu'il ne puisse plus égarer les nations le temps que s'achèvent les mille années. Après cela il faudra le relâcher pour un peu de temps."
,"4":"J'ai vu des trônes et ceux qui y prenaient place avec mission de juger. J'ai vu les âmes de ceux qui furent décapités à cause des déclarations de Jésus et de la parole de Dieu, parce qu'ils n'avaient pas adoré la bête et son image et ne s'étaient pas laissé marquer au front et sur la main droite. Ils vécurent et régnèrent avec le Christ pour mille ans,"
,"5":"alors que le reste des morts ne revivait pas avant la fin de ces mille années. C'est la première résurrection."
,"6":"Heureux et saint celui qui a part à la première résurrection! La seconde mort n'a pas de pouvoir sur eux; ils seront prêtres de Dieu et du Christ et ils régneront avec lui durant mille années."
,"7":"Mais au bout de ces mille ans, Satan sera relâché de sa prison."
,"8":"Il en sortira pour égarer Gog et Magog avec les nations des quatre coins du monde. Il les ameutera pour la guerre, aussi nombreux que les grains de sable du bord de mer."
,"9":"Voici qu'ils couvrent l'étendue de la terre, ils assiègent le camp des saints, la cité bien-aimée... Mais le feu du ciel tombe sur eux et les consume."
,"10":"Le diable qui les égarait est jeté dans l'étang de feu et de soufre où se trouvent déjà la bête et le faux prophète; ils seront torturés jour et nuit pour les siècles des siècles."
,"11":"J'ai vu un trône élevé, resplendissant, et celui qui y siégeait: devant sa face la terre s'enfuit ainsi que le ciel, et on n'eut plus rien à en faire."
,"12":"J'ai vu les morts, grands et petits, debout face au trône, pendant qu'on ouvrait des livres. Un autre livre fut ouvert, le livre de la Vie, et les morts furent jugés d'après ces livres, c'est-à-dire selon leurs oeuvres."
,"13":"La mer rendit les morts qui s'y trouvaient; la Mort et le Séjour des morts rendirent les morts qui étaient chez eux, et chacun fut jugé selon ses oeuvres."
,"14":"Après quoi la Mort et le Séjour des morts furent jetés dans l'étang de feu: cet étang de feu est la seconde mort"
,"15":"Tous ceux qui n'étaient pas inscrits dans le livre de vie furent jetés dans l'étang de feu."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Alors j'ai vu un ciel nouveau et une terre nouvelle, puisque le premier ciel et la première terre avaient disparu; il n'y a plus de mer."
,"2":"J'ai vu la Cité sainte, Jérusalem, qui descendait du ciel, d'auprès de Dieu, toute parée comme la fiancée qui se fait belle pour son époux."
,"3":"Et j'ai entendu une voix puissante qui sortait du trône. Elle disait: 'Voici la tente de Dieu au milieu des hommes; il aura chez eux sa demeure et ils seront son peuple, et lui, Dieu, sera Dieu-avec-eux."
,"4":"Il essuiera toute larme de leurs yeux; il n'y aura plus de mort désormais, plus de deuil, de cris ou de peines, car les premières choses ont disparu.'"
,"5":"Celui qui siège sur le trône déclara: 'Voici que je fais toutes choses nouvelles.',Il me dit: 'Ecris que ces paroles sont vraies et dignes de foi.'"
,"6":"Il me dit alors: 'C'est fait, je suis l'Alpha et l'Oméga, le commencement et la fin. Je ferai boire celui qui a soif, gratuitement, à la source d'eau vive."
,"7":"Le vainqueur sera le bénéficiaire de ces choses, et puis je serai Dieu pour lui, tandis qu'il sera pour moi un fils."
,"8":"Mais les lâches, les infidèles, les abominables, les meurtriers, ceux qui sont débauchés, ou qui jettent des sorts, ou qui adorent des idoles: tous ceux qui vivent dans la fausseté, - leur place est dans l'étang de feu où brûle le soufre. C'est la seconde mort.'"
,"9":"Alors s'est approché de moi l'un des sept anges des sept coupes, pleines des sept fléaux qui seront les derniers, et il m'a parlé: 'Viens que je te montre la fiancée, l'épouse de l'Agneau.'"
,"10":"Il m'emporta en esprit sur une montagne grande et haute, et il me montra la ville sainte, la Jérusalem qui descend du ciel d'auprès de Dieu, rayonnante de la Gloire de Dieu."
,"11":"Son éclat est celui d'une pierre précieuse, on dirait un jaspe cristallin."
,"12":"Sa muraille est large et haute. Elle a douze portes, et douze anges veillent sur ces portes; sur elles sont gravés les douze noms des douze tribus des fils d'Israël."
,"13":"Elles sont trois à l'orient, trois au nord, trois au sud et trois à l'occident."
,"14":"La muraille de la ville repose sur douze lits de pierre qui portent les noms des douze apôtres de l'Agneau."
,"15":"Celui qui me parlait avait une canne à mesurer en or, afin de mesurer la ville, ses entrées et sa muraille."
,"16":"De fait, le plan de la ville est un carré: elle est aussi longue que large. Il mesura la ville avec sa canne et compta douze mille stades. Longueur, largeur et hauteur sont égales."
,"17":"Il mesura la muraille: cent quarante quatre coudées. L'ange utilisait la même coudée que nous."
,"18":"Des pierres de jaspe forment le revêtement des murs, la ville est bâtie sur de l'or fin semblable à un cristal limpide."
,"19":"Quant à la muraille de la ville, des pierres précieuses de toute sorte rehaussent ses fondations: jaspe pour le premier lit, saphir pour le second, calcédoine pour le troisième, émeraude pour le quatrième,"
,"20":"sardoine pour le cinquième, sarde pour le sixième, chrysolithe pour le septième, béryl pour le huitième, topaze pour le neuvième, chrysoprase pour le dixième, hyacinthe pour le onzième, et améthyste pour le douzième."
,"21":"Douze perles forment les douze portes: chacune des portes est faite d'une seule perle. Le pavement de la ville est d'or fin qui fait penser à du verre transparent."
,"22":"Je n'y ai pas vu de temple. Le Seigneur Dieu, Maître de l'univers, est lui-même son temple, avec l'Agneau."
,"23":"La ville n'a pas besoin du soleil ou de la lune pour l'éclairer car la Gloire de Dieu l'illumine et l'Agneau est sa lampe."
,"24":"Les nations se dirigeront à sa lumière et les rois de la terre lui apporteront leurs richesses."
,"25":"Ses portes ne se fermeront pas avant la fin du jour, car la nuit là-bas, n'existe pas."
,"26":"On y apportera la gloire et la richesse des nations."
,"27":"Rien d'impur n'y entrera, et pas un de ceux qui pratiquent l'abomination et le mensonge, sinon seulement ceux qui sont inscrits au livre de vie de l'Agneau."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Il m'a encore montré le fleuve des eaux de la vie. Le fleuve, limpide comme le cristal, sortait du trône de Dieu et de l'Agneau."
,"2":"Sur la place de la ville et de chaque côté du fleuve, l'arbre de vie produit ses douze fruits; chaque mois il donne ses fruits, et les feuilles de l'arbre sont médicinales pour les nations."
,"3":"Il n'y a plus de calamités en ce lieu, car le trône de Dieu et de l'Agneau est dans la ville. Ses serviteurs l'y adoreront"
,"4":"et ils verront sa face; son nom est écrit sur leur front."
,"5":"Il n'y aura plus de nuit, eux-mêmes n'auront plus besoin de lumière, de la lampe ou du soleil, car le Seigneur Dieu les inondera de lumière. Et ils régneront pour les siècles des siècles!"
,"6":"Alors il me dit: 'Ces paroles sont vraies et dignes de foi. Le Seigneur Dieu des esprits des prophètes a voulu envoyer son ange pour faire connaître à ses serviteurs ce qui doit arriver d'ici peu."
,"7":"Oui, très vite je serai là. Heureux celui qui tient compte des paroles prophétiques de ce livre!'"
,"8":"C'est moi, Jean, qui ai vu et entendu tout cela. Après l'avoir vu et entendu, je me suis jeté à terre, voulant me prosterner aux pieds de l'ange qui m'avait montré tout cela."
,"9":"Mais il me dit: 'Non! Je sers comme toi et tes frères les prophètes, et tous ceux qui vont prendre en compte les paroles de ce livre. C'est Dieu que tu dois adorer.'"
,"10":"Ensuite il me dit: 'Ne mets pas de mystères autour des paroles prophétiques de ce livre, car le temps est proche."
,"11":"Laisse le mauvais persévérer dans l'injustice, le souillé se souiller encore, l'homme de bien ajouter à ses oeuvres bonnes et le saint se sanctifier."
,"12":"Très vite je serai là, et j'amène avec moi la récompense: je rendrai à chacun selon ses oeuvres."
,"13":"Je suis l'Alpha et l'Oméga, le premier et le dernier, le commencement et la fin."
,"14":"Heureux ceux qui lavent leurs vêtements! Ils auront accès à l'arbre de vie et ils entreront dans la ville, passant par ses portes."
,"15":"Mais dehors les chiens et ceux qui font de la magie, ceux qui courent à la débauche, ceux qui tuent et qui adorent des idoles. Dehors celui qui aime et qui pratique la fausseté."
,"16":"Moi, Jésus, j'ai envoyé mon ange pour vous donner ce témoignage au sujet des Eglises. Je suis la racine de David et son rejeton, et l'étoile qui brille à l'aurore.'"
,"17":"L'Esprit et la fiancée disent: 'Viens'. Celui qui suit la lecture de ce livre dira aussi: 'Viens!'. Que celui qui a soif approche. Que celui qui le désire reçoive gratuitement l'eau qui donne la vie."
,"18":"Je dis à tous ceux qui entendent les paroles prophétiques de ce livre: si quelqu'un y rajoute, Dieu ajoutera à son compte tous les châtiments décrits dans ce livre."
,"19":"Et si quelqu'un efface l'une des paroles prophétiques de ce livre, Dieu effacera le droit qu'il avait à l'arbre de vie et à la Cité sainte décrite dans ce livre."
,"20":"Celui qui a fait toute cette déclaration dit: 'C'est exact, et bientôt j'arrive.',- Oui, viens, Seigneur Jésus!"
,"21":"Que la grâce du Seigneur Jésus soit avec vous tous."
}`)

}
func FR_LBDCC_LoadNTHBChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Dieu dans le passé avait parlé à nos pères à bien des reprises et de bien des façons par les prophètes,"
,"2":"mais en ces jours qui sont les derniers, il nous a parlé par le Fils. C'est par lui que Dieu a disposé les temps de la création, et c'est lui que Dieu a fait le destinataire de toutes choses."
,"3":"Il est l'irradiation de la Gloire de Dieu et l'expression de son être le plus profond. Lui qui soutient toutes choses par la force de sa parole, il a effectué la purification des péchés, après quoi il est allé siéger à la droite du Dieu de Grandeur, dans les cieux."
,"4":"Il est donc maintenant très supérieur aux anges, exactement comme le nom qu'il a reçu est tout différent du leur."
,"5":"A qui parmi les anges Dieu a-t-il jamais dit: Tu es mon Fils, aujourd'hui je t'ai donné la vie. Ou encore: Je serai pour lui un Père et il sera pour moi un Fils."
,"6":"Quand il introduit dans le monde le Premier-né, il dit: Que tous les anges de Dieu l'adorent."
,"7":"Pour les anges on dit: Dieu a fait ses anges comme des esprits, ses fonctionnaires sont comme des flammes de feu."
,"8":"Pour le Fils, par contre, on dit: Ton trône, ô Dieu, est là pour tous les siècles, et ton règne est celui de la justice."
,"9":"Tu aimes le bien et tu détestes le mal, c'est pourquoi Dieu, ton Dieu, t'a donné ce qu'il n'a pas donné à tes semblables: une consécration royale qui est source de joie."
,"10":"Et encore: C'est toi, Seigneur, qui as fondé l'univers, et les cieux sont l'oeuvre de tes mains."
,"11":"Ils passeront, mais toi tu restes. Tous vieilliront comme un vêtement;"
,"12":"comme un manteau tu les rouleras dans un coin. Comme un vêtement ils seront remplacés, mais toi tu es là toujours et tes années n'ont pas de fin."
,"13":"Est-ce qu'on a jamais dit pour un ange: Assieds-toi à ma droite, attends que j'aie mis tes ennemis sous tes pieds?"
,"14":"C'est qu'ils sont tous des fonctionnaires spirituels; on les envoie, mais ils restent au service de ceux qui hériteront du salut."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Voilà pourquoi il faut prendre au sérieux le message que nous avons écouté, et ne pas aller à la dérive."
,"2":"Voyez comment la Loi donnée par les anges était inflexible: toute faute, toute désobéissance recevait son juste châtiment."
,"3":"Mais alors, pour un tel message de salut, comment pourrons-nous échapper si nous l'avons méprisé?,C'est le Seigneur qui l'a prêché le premier, puis il a été repris par ceux qui l'avaient entendu de lui. "
,"4":"Dieu lui-même a appuyé leur témoignage par des signes, des prodiges et toutes sortes de miracles, sans compter les charismes de l'Esprit Saint qu'il distribue comme il veut."
,"5":"Le monde nouveau dont nous voulons parler n'est pas sous le contrôle des anges."
,"6":"Quelqu'un a déclaré: Qu'est-ce que l'homme pour que tu te souviennes de lui? Comme tu te préoccupes pour le fils de l'homme!"
,"7":"Tu l'as rabaissé pour un moment au-dessous des anges, puis tu l'as couronné de gloire et d'honneur:"
,"8":"tu as tout mis sous ses pieds. Vous voyez, tout lui est soumis, rien n'est laissé hors de son contrôle. De fait nous ne voyons pas encore que tout lui soit soumis, "
,"9":"mais le texte dit bien: Tu l'as rabaissé pour un moment au-dessous des anges. Il s'agit de Jésus, et nous voyons que pour le prix de sa mort douloureuse il a été couronné de gloire et d'honneur. C'est une grâce de Dieu qu'il ait fait pour tous l'expérience de la mort."
,"10":"Oui, Celui de qui tout vient et qui agit en tout, voulait faire entrer dans la Gloire de nombreux fils. Et il a jugé bon de rendre parfait par le moyen de la souffrance celui qui se chargeait de leur salut à tous."
,"11":"Celui qui sanctifie ne fait plus qu'un avec ceux qui deviennent saints, et c'est pourquoi il n'a pas honte de les appeler ses frères."
,"12":"Il dit: J'annoncerai ton nom à mes frères, je te chanterai devant toute l'assemblée."
,"13":"Et encore: Je mettrai en lui ma confiance. Et encore: Me voici, moi et les enfants que Dieu m'a donnés."
,"14":"Et puisque ces enfants sont de chair et de sang, il a voulu partager avec eux, et donc mourir, afin de détruire celui qui était le maître de la mort, c'est à dire le diable."
,"15":"C'est ainsi qu'il a délivré ceux qui, par crainte de la mort, restaient esclaves dans toute la réalité de leur vie."
,"16":"Ce ne sont pas les anges qu'il prend en charge: il prend en charge la race d'Abraham."
,"17":"Il lui fallait donc ressembler en tout à ses frères et devenir ce grand-prêtre plein de compassion, mais aussi fidèle au service de Dieu, qui obtiendra le pardon pour les fautes du peuple."
,"18":"Il a été éprouvé par la souffrance, il peut donc secourir ceux qui sont éprouvés."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Sachant cela, frères saints qui jouissez d'une vocation surnaturelle, tournez les yeux vers Jésus, l'apôtre et le grand-prêtre de notre foi commune."
,"2":"Il est fidèle à Celui qui l'a établi, tout comme Moïse a été fidèle en sa maison,"
,"3":"mais il mérite bien plus d'honneurs que Moïse, dans la mesure où la maison n'est rien à côté de celui qui l'a bâtie."
,"4":"Toute maison est l'oeuvre de quelqu'un, et l'univers est l'oeuvre de Dieu."
,"5":"Moïse a été fidèle à Dieu dans tout le service de sa maison: son service était de faire connaître ce qui lui avait été dit."
,"6":"Le Christ, par contre, est dans sa maison comme Fils, et nous sommes de sa maison si nous nous maintenons fermes et pleins d'espérance."
,"7":"Voyez ce que dit l'Esprit Saint: Si vous pouviez aujourd'hui écouter sa voix!"
,"8":"Ne soyez pas endurcis comme au jour de l'Amertume, comme au jour du Défi dans le désert,"
,"9":"lorsque vos pères m'ont défié. Ils ont voulu m'éprouver et ils m'ont vu à l'oeuvre"
,"10":"pendant quarante ans. J'en avais assez de cette génération et j'ai dit: Ils sont toujours hors du vrai, ils ne connaissent pas mes voies."
,"11":"Et j'ai dit, car j'étais en colère: Ils n'entreront pas dans mon repos."
,"12":"Donc, frères, il ne faudrait pas que l'un d'entre vous ait assez mauvais esprit pour cesser de croire et qu'il abandonne le Dieu vivant."
,"13":"Aidez-vous mutuellement à tenir jour après jour, tout au long de cet aujourd'hui dont on parlait. Que nul d'entre vous ne s'endurcisse et ne s'enfonce dans le péché."
,"14":"Nous sommes devenus solidaires du Christ, mais il s'agit de garder fermement jusqu'à la fin notre conviction du début."
,"15":"Il était dit: Si vous pouviez aujourd'hui entendre sa voix! Ne soyez pas endurcis comme au jour amer."
,"16":"Qui donc avait entendu mais était devenu amer? Tous ces gens, bien sûr, qui étaient sortis d'Egypte avec Moïse."
,"17":"De qui Dieu en avait-il eu assez durant quarante ans? De tous ces pécheurs. Aussi ils tombèrent et leurs corps restèrent dans le désert."
,"18":"A qui Dieu a-t-il juré qu'ils n'entreraient pas dans son lieu de repos? A ces rebelles bien sûr,"
,"19":"et nous voyons que c'est à cause de leur manque de foi qu'ils ne sont pas entrés."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Soyons donc sur nos gardes, il ne faudrait pas que l'un d'entre nous reste sur la route et renonce à l'entrée qu'on nous promet dans ce lieu de repos."
,"2":"Comme eux nous avons reçu une bonne promesse, mais cette annonce ne leur a servi à rien, car ils n'ont pas cru et fait cause commune avec ceux qui l'avaient entendue."
,"3":"Il nous faut croire pour entrer dans ce lieu de repos dont on a parlé: J'ai dit, car j'étais en colère: Ils n'entreront pas dans mon repos. Bien entendu, il s'agit de Dieu qui se repose de ses oeuvres après avoir créé le monde,"
,"4":"car déjà on en avait parlé à propos du septième jour: Dieu se reposa de toutes ses oeuvres le septième jour."
,"5":"Et ici on le retrouve: Ils n'entreront pas dans mon repos."
,"6":"C'est donc que certains y entreront, alors que les premiers invités ne sont pas entrés à cause de leur manque de foi."
,"7":"C'est pourquoi, beaucoup plus tard, Dieu fixe de nouveau une date: Aujourd'hui, avec cette parole de David citée plus haut: Aujourd'hui, si vous pouviez écouter sa voix! Ne soyez pas endurcis."
,"8":"Si Josué leur avait vraiment donné le lieu du repos, on ne parlerait pas dans la suite d'un autre jour."
,"9":"Un repos sacré est donc encore disponible pour le peuple de Dieu,"
,"10":"et celui qui entre dans ce repos se reposera de toutes ses oeuvres, comme Dieu se repose des siennes."
,"11":"Efforçons-nous donc d'entrer dans ce repos, et que personne ne suive cet exemple de manque de foi."
,"12":"Car la parole de Dieu est vivante et efficace, plus pénétrante qu'une lame aiguisée sur les deux bords; elle atteint là où se séparent l'âme et l'esprit, les jointures et les nerfs, elle fait le discernement des désirs et des intentions les plus secrètes."
,"13":"Aucune créature ne résiste à sa lumière; tout est nu et exposé à la vue de celui à qui nous rendrons compte."
,"14":"Nous avons donc un exceptionnel grand-prêtre qui est entré dans les cieux, Jésus, le Fils de Dieu. C'est assez pour tenir ferme à notre foi."
,"15":"Notre grand-prêtre n'est pas incapable de comprendre nos faiblesses; lui-même a été éprouvé comme nous de toutes manières, mais il n'a pas péché."
,"16":"Nous pouvons donc nous présenter avec assurance là où siège la Grâce: miséricorde nous sera faite et grâce nous sera donnée, et le secours viendra au moment voulu."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Un grand-prêtre est choisi d'entre les hommes pour les représenter dans les choses de Dieu, pour offrir leurs dons et les sacrifices pour le péché."
,"2":"Il sera capable de comprendre les ignorants et ceux qui se trompent, car lui-même sent le poids de sa faiblesse."
,"3":"Elle est cause qu'il lui faille offrir un sacrifice pour ses propres péchés, tout comme il en offre un pour les péchés du peuple."
,"4":"Mais personne ne s'attribue cette charge: seulement celui qui est appelé par Dieu comme Aaron."
,"5":"Ainsi le Christ ne s'est pas attribué à lui-même l'honneur d'être grand-prêtre. Il l'a reçu par cette parole: Tu es mon Fils. Moi, aujourd'hui, je t'ai donné la vie."
,"6":"Et il est dit ailleurs: Tu es prêtre pour toujours dans la ligne de Melquisédek."
,"7":"Quand il vivait sur terre, il a offert ses prières et ses supplications à celui qui pouvait le sauver de la mort: ce fut là son sacrifice, fait de grands cris et de larmes, et son obéissance lui a valu d'être entendu."
,"8":"Tout Fils qu'il était, il a appris à obéir dans la souffrance."
,"9":"Et maintenant qu'il a acquis la perfection, il procure le salut définitif à ceux qui lui obéissent,"
,"10":"d'accord avec le titre que Dieu lui a donné: Grand-prêtre dans la ligne de Melquisédek."
,"11":"Ce que nous voudrions dire à ce sujet risque d'être long et difficile, car vous êtes devenus lents pour comprendre."
,"12":"Après tant d'années vous devriez être des maîtres, mais vous avez besoin qu'on vous rappelle les premiers éléments de la doctrine de Dieu. C'est du lait qu'il vous faut et non de la nourriture solide."
,"13":"Si quelqu'un en est encore au lait, il ne peut entendre ce qu'est vivre selon Dieu: c'est un petit enfant."
,"14":"La nourriture solide, par contre, est pour ceux déjà formés, ceux qui ont le sens intérieur exercé par la pratique et sont capables de reconnaître le bien et le mal."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Mais laissons là les premiers enseignements sur le Christ et passons aux choses plus avancées. Nous n'allons pas établir une fois de plus les bases, c'est-à-dire le renoncement aux oeuvres de mort, la foi en Dieu,"
,"2":"la doctrine des baptêmes, l'imposition des mains, la résurrection des morts, le jugement éternel."
,"3":"Nous ferons comme nous avons dit, si Dieu le permet."
,"4":"De toute façon, on ne peut renouveler ceux qui ont déjà été illuminés, qui ont goûté le don surnaturel, qui ont eu leur part de l'Esprit Saint"
,"5":"et ont goûté la merveilleuse parole de Dieu avec des expériences du monde nouveau."
,"6":"S'ils viennent à retomber, on ne peut pas les renouveler par la pénitence alors qu'ils crucifient le Fils de Dieu pour leur propre compte et se moquent de lui."
,"7":"La terre qui boit la pluie quand régulièrement elle tombe, et qui donne de la bonne herbe au cultivateur, est bénie de Dieu."
,"8":"Mais si elle ne produit qu'épines et chardons, elle devient sans valeur. Un peu plus et on la maudit: pour finir, tout sera brûlé."
,"9":"Même quand nous parlons ainsi, frères bien-aimés, nous sommes sûrs que vous êtes dans une meilleure situation et qu'il y a de l'espoir."
,"10":"Dieu serait injuste s'il oubliait ce que vous avez fait par amour pour son Nom et pour le service des saints, et comment vous les servez encore."
,"11":"Mais nous voudrions que chacun d'entre vous fasse tout jusqu'au bout, pour que votre espérance porte ses fruits."
,"12":"Ne devenez pas nonchalants, imitez plutôt ceux qui ont bénéficié à la fin de la promesse, grâce à la foi et la persévérance."
,"13":"Quand Dieu a promis à Abraham, il a juré par lui-même, car il n'y avait personne plus grand que lui."
,"14":"Et il a dit: Je te bénirai et tu seras béni, je veux te multiplier et te multiplierai."
,"15":"Abraham a su attendre, et il a vu la réalisation de la promesse."
,"16":"On jure d'habitude par quelqu'un de plus grand que soi, et quand on a juré, plus personne ne conteste."
,"17":"De même, Dieu a ajouté le serment à la promesse pour montrer de façon certaine à ses destinataires qu'il ne reviendrait pas en arrière."
,"18":"Voilà donc deux choses décidées sans appel où Dieu ne peut pas mentir, et c'est assez pour nous donner courage quand nous nous accrochons à l'espérance qui nous est proposée."
,"19":"Elle est notre ancre spirituelle, sûre et solide, jetée dans le sanctuaire même au-delà du rideau."
,"20":"C'est là que Jésus est entré le premier, ayant acquis son titre de grand-prêtre pour toujours dans la ligne de Melquisédek."
}`)
	CurrentBook.AddChapter(7, `{
"1":"On sait que Melquisédek, roi de Salem, prêtre du Dieu Très-haut, vint à la rencontre d'Abraham qui rentrait de sa victoire sur les rois. Il le bénit"
,"2":"et Abraham lui donna la dîme de tout ce qu'il ramenait. Melquisédek signifie Roi de Justice, et il est roi de Salem, ce qui signifie Roi de Paix. "
,"3":"Pour lui on ne parle pas de père ni de mère ou d'ancêtres; on ne mentionne ni commencement ni fin de ses jours. Voilà bien le prêtre qui demeure à jamais, vraie figure du Fils de Dieu."
,"4":"Imaginez quel peut être cet homme à qui notre ancêtre Abraham donne la dîme de tout ce qu'il ramène."
,"5":"Selon la Loi, il n'y a que les prêtres de la tribu de Lévi qui puissent se faire donner la dîme par tout le peuple, c'est-à-dire par leurs frères qui sont comme eux du sang d'Abraham."
,"6":"Mais ici un homme qui n'est pas de leur descendance se fait donner la dîme par Abraham et bénit celui qui porte les promesses."
,"7":"Sans aucun doute, c'est le supérieur qui bénit l'inférieur."
,"8":"Dans le premier cas, ce sont des hommes mortels qui reçoivent les dîmes; mais lui, ici, on ne le voit que vivant."
,"9":"Mieux encore: si Abraham a payé la dîme, Lévi aussi, le receveur des dîmes, a payé avec lui,"
,"10":"car il était en germe dans son ancêtre Abraham au moment ou Melquisédek le rencontra."
,"11":"Le sacerdoce des lévites est à la base des institutions d'Israël, mais ils ne sont pas capables de le mener à la vraie sainteté. Sinon, faudrait-il en venir à un sacerdoce dans la ligne de Melquisédek et non plus dans la ligne d'Aaron?"
,"12":"C'est donc qu'on change le sacerdoce, et il faut aussi changer la Loi."
,"13":"On sait que Jésus, puisque nous parlons de lui, appartenait à une tribu dont les hommes ne servent pas à l'autel."
,"14":"Notre Seigneur était originaire de Juda, comme tout le monde sait, et Moïse n'a pas mentionné cette tribu à propos des prêtres."
,"15":"Cette installation d'un autre prêtre à la ressemblance de Melquisédek est plus frappante encore"
,"16":"du fait qu'il ne le devait pas à des qualités humaines exigées par la loi: Jésus est bien devenu prêtre, mais il le devait à la vie qui n'a pas de fin."
,"17":"Car il est bien dit: C'est pour toujours que tu es prêtre dans la ligne de Melquisédek."
,"18":"On remplace donc l'ancienne Loi parce qu'elle est devenue inefficace et inutile"
,"19":"(cette Loi n'a rien amené de définitif), et en même temps on nous apporte une espérance bien meilleure: nous arriverons jusqu'à Dieu."
,"20":"Les autres prêtres n'étaient pas garantis par un serment, mais cette fois il y a un serment."
,"21":"Dieu lui a fait ce serment: Le Seigneur l'a juré et ne reviendra pas sur sa parole: Tu es prêtre pour toujours."
,"22":"C'est la preuve que Jésus vient avec une bien meilleure alliance."
,"23":"Les prêtres se succédaient l'un à l'autre car la mort les empêchait de durer."
,"24":"Lui, au contraire, demeure pour les siècles et personne ne peut lui enlever le sacerdoce;"
,"25":"et il est capable de donner le salut définitif à ceux qui par lui vont à Dieu, car il est toujours vivant pour intercéder en leur faveur."
,"26":"C'est bien ainsi que devait être notre Grand-prêtre: saint, sans défaut ni reproche. Il devait être retiré du monde des pécheurs et placé plus haut que les cieux."
,"27":"A la différence des grands-prêtres, il n'a pas à offrir chaque jour des sacrifices, d'abord pour ses propres péchés et ensuite pour le peuple. Pour le peuple, il ne l'a fait qu'une fois, quand il s'est offert lui-même."
,"28":"La Loi établit comme grands-prêtres des hommes pleins de faiblesse; mais après la Loi, le serment installe le Fils, parfait, et pour toujours."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Pour résumer ce que nous avons dit, nous avons un grand-prêtre qui siège à la droite du Dieu de Grandeur dans les cieux."
,"2":"Il fait la liturgie du Sanctuaire et de la vraie Tente que le Seigneur lui-même a plantée et non les hommes."
,"3":"Un grand-prêtre est ordonné pour offrir des dons et des sacrifices; donc lui aussi doit avoir quelque chose à offrir."
,"4":"Sur terre Jésus ne serait même pas prêtre, puisque d'autres, désignés par la Loi, offrent les sacrifices."
,"5":"Mais leur liturgie n'est que la figure et l'ombre des choses surnaturelles, comme il a été dit à Moïse quand il devait réaliser la Tente: Regarde et fais tout selon le modèle qui t'a été montré sur la montagne."
,"6":"Mais lui, son service liturgique est bien supérieur, car il est le médiateur d'une bien meilleure alliance et qui nous promet des choses beaucoup plus élevées."
,"7":"S'il n'y avait rien à critiquer dans la première alliance, il n'y aurait pas de place pour une seconde."
,"8":"Mais voici que Dieu la critique: Les jours viennent, dit le Seigneur, où je ferai une nouvelle alliance avec le peuple d'Israël, avec la maison de Juda."
,"9":"Non pas comme l'alliance que j'ai donnée à leurs pères au jour où je les ai pris par la main pour les faire sortir d'Egypte. Car ils ne sont pas restés dans mon alliance et moi aussi je les ai délaissés - dit le Seigneur."
,"10":"Voici l'alliance que je ferai avec le peuple d'Israël en ce jour-là, dit le Seigneur. Je mettrai mes lois dans leur conscience et je les graverai sur leurs coeurs. Et alors je serai Dieu pour eux et ils seront pour moi un peuple."
,"11":"Ils n'auront plus à s'instruire mutuellement; ils ne diront plus à leur frère ou à leur concitoyen: Connais le Seigneur! Car tous me connaîtront, du plus petit jusqu'au plus grand."
,"12":"Je pardonnerai leurs fautes et ne me souviendrai plus de leurs péchés."
,"13":"Il est dit: nouvelle alliance. C'est donc que la première a vieilli. Ce qui est vieux et hors d'âge est tout près d'être remplacé."
}`)
	CurrentBook.AddChapter(9, `{
"1":"La première alliance avait une liturgie et un sanctuaire comme on peut en avoir en ce monde."
,"2":"On prépara donc une première tente avec le chandelier, la table et les pains qu'on présente à Dieu: c'est le Lieu Saint."
,"3":"Ensuite, au-delà du second rideau, se trouve le Saint des Saints"
,"4":"avec l'autel d'or pour les parfums et l'Arche d'Alliance toute recouverte d'or, avec à l'intérieur de la manne dans un vase d'or, le bâton d'Aaron qui avait fleuri, et les tables de l'Alliance."
,"5":"Et au-dessus de l'Arche, les Chérubins de Gloire dont les ailes couvrent le Lieu du Pardon; mais ce n'est pas le moment d'en parler en détail."
,"6":"Dans ces conditions, les prêtres ont accès en tout temps à la première tente pour le service liturgique,"
,"7":"mais seul le grand-prêtre entre dans la seconde, une seule fois par an, et seulement avec le sang qu'il vient offrir pour ses erreurs et pour celles du peuple."
,"8":"De cette façon l'Esprit Saint nous montre que le chemin du sanctuaire ne peut être ouvert tant que la première tente est encore debout."
,"9":"C'est une leçon pour le temps présent. On a beau offrir des dons et des victimes, elles ne donnent pas à celui qui les offre la perfection intérieure."
,"10":"Tout cela n'est qu'aliments, boissons, baptêmes et purifications, en un mot, des règles humaines qui attendent une réforme."
,"11":"Le Christ est venu comme le grand-prêtre qui administre les dons de Dieu propres des temps nouveaux. Il est entré dans un autre sanctuaire, plus grand et plus parfait, qui n'est pas l'oeuvre de l'homme, je veux dire qu'il n'est pas de ce monde."
,"12":"Ce n'était pas le sang des boeufs et des boucs qui lui ouvrait le sanctuaire, mais son propre sang, quand il a obtenu une fois pour toutes le salut définitif."
,"13":"Le sang des taureaux et des boucs, et l'aspersion avec les cendres d'une vache, peuvent redonner à ceux qui sont souillés une pureté tout extérieure;"
,"14":"mais bien plus sûrement le sang du Christ qui s'est offert lui-même à Dieu par l'Esprit éternel comme une victime sans tache, lavera notre conscience des oeuvres de mort pour que nous servions le Dieu vivant."
,"15":"Voilà comment il est le médiateur d'une nouvelle alliance. Sa mort a racheté les manquements à la première alliance, et maintenant ceux que Dieu appelle peuvent bénéficier de la promesse, c'est-à-dire de l'éternel héritage."
,"16":"Quand il y a alliance, ou testament, il faut que meure celui qui a fait le testament."
,"17":"Un testament n'a pas d'effet avant la mort: il n'a pas de valeur tant que vit celui qui l'a fait."
,"18":"C'est pourquoi déjà la première alliance a été célébrée avec du sang."
,"19":"Moïse a commencé par exposer au peuple toutes les exigences de la Loi. Ensuite il a pris le sang des boeufs mêlé avec de l'eau, de la laine rouge et du bois d'hysope, et il en a aspergé le livre et tout le peuple."
,"20":"Et il a dit: Ceci est le sang de l'alliance que Dieu a disposée pour vous."
,"21":"De même il a aspergé de sang la Tente avec tous les objets liturgiques."
,"22":"D'ailleurs, selon la Loi, presque toutes les purifications demandent du sang. S'il n'y a pas de sang versé, il n'y a pas de pardon."
,"23":"Sans doute il fallait purifier de la sorte ces choses qui ne sont que l'image du culte surnaturel; mais alors ce culte céleste réclame de bien meilleurs sacrifices."
,"24":"Car il ne s'agit plus d'un sanctuaire fait de main d'homme, figure d'un autre qui est le vrai; le Christ est entré dans le ciel même, et c'est là qu'il s'est présenté face à Dieu pour nous."
,"25":"Il n'avait pas à s'offrir lui-même de façon répétée, comme fait le grand-prêtre: lui peut bien revenir chaque année, car le sang n'est pas le sien."
,"26":"Mais alors le Christ aurait dû souffrir bien des fois la Passion depuis la création du monde. De fait, il s'est présenté une seule fois, quand l'histoire était à son tournant, et ç'a été pour détruire le péché grâce à son sacrifice. "
,"27":"Les hommes n'ont à mourir qu'une seule fois, ensuite c'est le jugement."
,"28":"C'est pareil pour le Christ. Il a été sacrifié une seule fois pour enlever le péché de la multitude. Une deuxième fois il se montrera à ceux qui l'attendent comme leur sauveur, mais ce ne sera plus pour le péché."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Avec la Loi on n'a jamais que l'ombre des biens nouveaux: elle n'a pas la vraie figure des choses. C'est pourquoi elle ne peut jamais mener à la perfection définitive, au moyen de leurs sacrifices, ceux qui reviennent chaque année les offrir."
,"2":"Sinon, ils seraient purifiés dès la première fois grâce à leur culte; ils n'auraient plus de péchés sur la conscience et ils auraient cessé de les offrir."
,"3":"Mais non, chaque année ces sacrifices rappellent leurs péchés;"
,"4":"c'est que le sang des taureaux et des boucs n'enlève pas le péché."
,"5":"Alors lui, il entre dans le monde et il dit: Tu n'as voulu ni offrande ni sacrifice, mais tu m'as donné un corps."
,"6":"Ni les holocaustes, ni les sacrifices pour le péché ne te plaisaient."
,"7":"Alors j'ai dit: Voici que je viens, ô Dieu, car on parlait de moi dans un chapitre du livre, je viens faire ta volonté."
,"8":"D'abord il dit: Tu n'as voulu ni offrande, ni sacrifices, ni holocaustes ou sacrifices pour le péché; ils ne te plaisaient pas. - Et pourtant la Loi demandait ces offrandes."
,"9":"Alors il continue: Maintenant je viens pour faire ta volonté. Voilà donc qu'il supprime le premier ordre de choses pour établir le second,"
,"10":"et cette volonté dont il parle, c'est que nous soyons sanctifiés par l'offrande unique du corps de Jésus Christ."
,"11":"Les prêtres assurent chaque jour leur service liturgique et ils offrent constamment les mêmes sacrifices qui n'arrivent pas à enlever le péché."
,"12":"Lui, au contraire, après avoir offert un unique sacrifice pour les péchés, il siège pour toujours à la droite de Dieu"
,"13":"attendant seulement que Dieu mette ses ennemis sous ses pieds."
,"14":"Son unique offrande établit dans un état de perfection définitive ceux qu'il sanctifie."
,"15":"L'Esprit Saint nous l'affirme. Il est dit:"
,"16":"Voici l'alliance que je ferai avec eux après ces jours-ci - parole du Seigneur. Je mettrai mes lois dans leur coeur et je les graverai sur leur conscience."
,"17":"Et il ajoute: Je ne me souviendrai plus de leurs péchés ni de leurs fautes."
,"18":"Les voilà donc pardonnés, il n'y aura plus d'offrande pour le péché."
,"19":"Donc, frères, nous sommes sûrs d'entrer dans le Sanctuaire grâce au sang de Jésus."
,"20":"Il nous a ouvert ce nouveau chemin qui traverse le rideau, un chemin vivant à travers sa chair."
,"21":"Nous avons un prêtre exceptionnel au service de la Maison de Dieu."
,"22":"Approchons-nous donc avec sincérité, avec une foi entière, le coeur purifié de ce qui souillait notre conscience, et le corps baigné dans l'eau qui purifie."
,"23":"Restons iné branlables dans notre espérance, car celui qui a promis est fidèle,"
,"24":"et tâchons de nous surpasser les uns les autres dans l'amour et les bonnes oeuvres."
,"25":"Ne manquons pas nos assemblées, comme certains en ont l'habitude; aidons-nous à tenir, d'autant plus que vous voyez déjà s'approcher le jour."
,"26":"Si nous péchons volontairement après avoir reçu toute la connaissance de la vérité, il n'y a plus de sacrifice pour le péché,"
,"27":"mais seulement l'attente redoutable du jugement et du feu tout prêt à dévorer les rebelles."
,"28":"Celui qui viole la loi de Moïse est mis à mort sans pitié sur la parole de deux ou trois témoins."
,"29":"Le châtiment sera bien pire, ne croyez-vous pas, pour celui qui foule aux pieds le Fils de Dieu, qui profane le sang de la Nouvelle Alliance par lequel il a été sanctifié, et se moque de l'Esprit Saint qu'on lui avait donné par pure bonté."
,"30":"Nous savons qui a dit: A moi la vengeance, c'est moi qui rendrai à chacun son dû, et encore: Le Seigneur jugera son peuple."
,"31":"Quelle chose terrible que de tomber entre les mains du Dieu vivant!"
,"32":"Rappelez-vous les premiers jours. Peu après l'illumination vous avez eu à supporter un rude et douloureux combat."
,"33":"On vous a donnés en spectacle, on vous a insultés et maltraités, ou bien vous avez eu à vous montrer solidaires de ceux qu'on persécutait ainsi."
,"34":"Vous avez souffert avec les prisonniers et vous avez accepté avec joie la saisie de vos biens, sachant qu'une richesse meilleure et durable vous était réservée."
,"35":"Ce n'est donc pas le moment de renoncer à cette fermeté qui vous prépare une grande récompense."
,"36":"Il vous faut persévérer faisant la volonté de Dieu si vous voulez recevoir ce qui vous est promis."
,"37":"Oui, encore un peu, bien peu, et celui qui vient sera là, il ne tardera pas."
,"38":"Mon juste à moi vivra par la foi; mais s'il se retire, il cessera de me plaire."
,"39":"Nous ne sommes pas de ceux qui se retirent et vont à leur perte, nous sommes des hommes de foi et nous sauverons notre âme."
}`)
	CurrentBook.AddChapter(11, `{
"1":"La foi, c'est s'accrocher à ce qu'on espère, c'est la certitude de choses qu'on ne voit pas."
,"2":"C'est cela même qu'on donne en exemple chez nos aînés."
,"3":"C'est la foi lorsque nous croyons que les étapes de la création ont été agencées par une parole de Dieu, et que les choses visibles proviennent de réalités invisibles."
,"4":"C'est la foi qui a rendu l'offrande d'Abel meilleure que celle de Caïn. A cause de sa foi il est dit qu'il était juste et saint, comme Dieu l'a laissé entendre, parlant de ses offrandes. Par la foi, même mort il crie vers Dieu."
,"5":"C'est la foi encore lorsqu'Hénok est enlevé au lieu de passer par la mort: on ne le vit plus car Dieu l'avait enlevé. C'est qu'avant d'être enlevé, il avait été agréable à Dieu, nous dit-on,"
,"6":"et sans la foi il est impossible de lui plaire. Nécessairement celui qui vient à Dieu croit que Dieu existe et récompense ceux qui le cherchent."
,"7":"Quand Noë fut averti d'événements qu'on ne pouvait prévoir, c'est sa foi qui lui fit construire l'Arche où il devait se sauver avec sa famille. Sa foi condamnait le monde alors que lui-même héritait de la vraie droiture, fruit de la foi."
,"8":"Quand Abraham fut appelé, c'est la foi qui le fit obéir et partir vers le lieu qu'il devait recevoir en héritage, car il partit sans savoir où il allait."
,"9":"C'est la foi qui l'a amené à rester sur cette terre promise qui n'était pas encore sienne, et il a vécu là sous la tente, de même qu'Isaac et Jacob, héritiers de la même promesse."
,"10":"C'est qu'ils attendaient la cité aux solides fondations dont Dieu est l'architecte et le réalisateur."
,"11":"Par la foi il fut capable d'avoir un fils alors qu'il avait déjà passé l'âge, et que Sara était stérile; car il eut confiance en celui qui promettait."
,"12":"C'est ainsi que d'un seul homme, et déjà impuissant, est sortie une multitude nombreuse comme les étoiles des cieux, semblable aux grains de sable sur le rivage."
,"13":"Tous sont morts en croyants. Ils n'avaient pas joui des promesses, mais ils les avaient vues et saluées de loin, et ils savaient qu'ils étaient sur terre des nomades et des étrangers."
,"14":"Cette façon de parler montre qu'ils cherchaient une patrie."
,"15":"Car s'ils regrettaient leur patrie d'origine, ils pouvaient y retourner."
,"16":"Mais non, c'est une autre meilleure qu'ils désiraient, celle du ciel. C'est pourquoi Dieu n'a pas honte de se faire appeler 'leur' Dieu, puisque c'est lui qui leur a préparé la cité."
,"17":"Quand Abraham fut mis à l'épreuve, c'est la foi qui lui fit sacrifier Isaac, car il s'agissait d'offrir son fils unique, celui qui devait jouir de la promesse."
,"18":"Il lui avait bien été dit: Les enfants d'Isaac seront ta vraie descendance."
,"19":"Mais il pensa que Dieu était capable même de ressusciter les morts, et il retrouva ce fils, ce qui avait un sens pour l'avenir."
,"20":"La foi dans l'avenir était là lorsqu'Isaac bénit Jacob et Esaü."
,"21":"La foi était encore là lorsque Jacob mourant bénit séparément les fils de Joseph; on dit qu' il s'appuya sur son bâton pour adorer."
,"22":"La foi était là lorsque Joseph annonça aux enfants d'Israël leur sortie d'Egypte et donna des ordres pour ses propres ossements."
,"23":"A la naissance de Moïse, c'est la foi de ses parents qui leur fit cacher le bébé durant trois mois: ils virent que l'enfant était beau, et ils ne craignirent pas l'ordre du roi."
,"24":"C'est la foi encore lorsque Moïse devenu grand refuse de passer pour un fils de la fille du Pharaon,"
,"25":"et il préfère souffrir avec le peuple de Dieu plutôt que de rester avec la joie bien courte du péché."
,"26":"Car il sait qu'il y aura une récompense, et il comprend que l'humiliation avec le Christ a plus de valeur que les richesses de l'Egypte."
,"27":"C'est la foi encore lorsqu'il quitte l'Egypte. Il ne craint pas la colère du roi car il a les yeux fixés sur l'autre Colère, encore invisible."
,"28":"C'est la foi lorsqu'il sacrifie la Pâque et fait l'aspersion du sang pour empêcher l'Exterminateur de toucher à leurs premiers-nés."
,"29":"C'est la foi lorsqu'ils traversent la Mer Rouge comme un terrain sec, alors que les Egyptiens se noient en essayant d'y passer."
,"30":"Grâce à la foi les murailles de Jéricho s'écroulent après qu'on en a fait le tour sept jours de suite."
,"31":"Et c'est grâce à sa foi que Rahab, la prostituée, échappe au destin des incrédules après avoir bien accueilli les espions."
,"32":"Que dirai-je de plus? Je n'ai pas le temps de parler en détail de Gédéon, de Barac, de Samson, de Jephté, de David, de Samuel et des prophètes."
,"33":"C'est par la foi qu'ils l'emportent sur les autres nations, qu'ils imposent la justice et voient se réaliser les promesses. Ils ferment la gueule des lions, "
,"34":"font tomber la chaleur du feu, échappent à l'épée, sortent guéris de leurs maladies. Ils sont courageux dans la guerre et repoussent les assauts de l'étranger."
,"35":"Des femmes ont retrouvé leurs morts, rendus à la vie, mais il en est d'autres qui n'ont pas cherché à sauver leur vie quand ils étaient torturés, parce qu'ils voulaient bénéficier d'une résurrection bien supérieure."
,"36":"Certains ont subi les outrages et les fouets, d'autres ont été enchaînés et mis en prison,"
,"37":"ou tués à coups de pierres, ou sciés en deux ou tués par l'épée. Ils allaient sans savoir où, vêtus de peaux de chèvres et de brebis, manquant de tout, persécutés, maltraités. "
,"38":"Eux, dont le monde n'était pas digne, ils erraient dans les lieux déserts, dans la montagne, et se cachaient dans les grottes et les refuges du pays."
,"39":"Tous ces hommes dont on donne la foi en exemple n'ont pas bénéficié de la promesse."
,"40":"Mais c'est que Dieu voyait plus loin et pensait à nous: ils ne devaient pas atteindre le but sans nous."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Puisque nous voici entourés d'une vraie nuée de témoins, laissons là tout le poids mort, ce péché qui nous assiège, et sachons tenir dans la course qui nous attend."
,"2":"Fixons les yeux sur Jésus, qui dirige cette compétition de la foi et qui la mène à son terme. Au lieu de la joie qui lui était offerte, il a choisi la croix. Il n'a pas eu peur de l'humiliation et maintenant il siège à la droite de Dieu."
,"3":"Si vous pensez à celui qui a souffert une telle opposition de la part des pécheurs, vous ne risquerez pas de manquer de forces et de courage."
,"4":"Vous êtes aux prises avec l'injustice, mais vous n'avez pas encore résisté jusqu'au sang."
,"5":"Peut-être avez-vous oublié cette bonne parole que la sagesse vous dit comme à ses fils: Mon fils, ne sois pas triste quand le Seigneur te corrige, ne perds pas courage quand il te reprend."
,"6":"Le Seigneur corrige celui qu'il aime, les fils qu'il préfère auront droit à ses coups."
,"7":"Vous souffrez, mais c'est pour votre bien; Dieu vous traite comme des fils. Quel fils n'est pas corrigé par son père?"
,"8":"Si vous ne receviez pas de correction, comme il arrive à tous, vous ne seriez pas des fils, mais des bâtards."
,"9":"Nous avons accepté que nos pères selon la chair nous corrigent: à bien plus forte raison nous nous soumettrons au Père des esprits pour trouver la vie."
,"10":"Nos pères nous corrigeaient sans voir plus loin que la vie présente, si brève, mais lui a en vue ce qui nous aidera à atteindre sa propre sainteté."
,"11":"Une correction n'est jamais agréable sur le moment, elle nous fait mal; mais ensuite, si nous nous laissons instruire, elle produit ses fruits: la vie selon Dieu et la paix."
,"12":"Allons donc, redressez ces épaules qui tombent et ces genoux qui vacillent"
,"13":"et rendez droit le chemin par où vous devez passer pour que l'éclopé ne reste pas sur la route, mais qu'il se rétablisse."
,"14":"Ayez pour objectif la paix avec tous et la sainteté, car sans elle on ne peut voir le Seigneur."
,"15":"Faites attention que personne ne perde la grâce de Dieu. Prenez garde à la plante amère qui prend racine et porte tort à beaucoup d'autres."
,"16":"Qu'on ne voie pas quelqu'un de mauvaises moeurs, quelque profanateur comme Esaü qui vendit ses privilèges de fils aîné pour une assiette de soupe."
,"17":"Vous savez qu'ensuite il fut rejeté quand il voulut avoir, lui aussi, sa part de la bénédiction. Il eut beau supplier et pleurer, il ne put rien y changer."
,"18":"Rappelez-vous votre initiation. Il n'y a pas eu de feu qui brûle physiquement, pas de nuée obscure ou d'ouragan,"
,"19":"ni le son de la trompette et cette voix qui parlait de telle façon que ceux qui l'entendirent demandaient de ne plus l'entendre."
,"20":"Tout cela c'était pour qu'ils respectent l'ordre qu'on leur avait donné: Homme ou animal, celui qui s'approche de la montagne sera tué à coups de pierres."
,"21":"Ce spectacle était si terrifiant que Moïse dit: Je suis terrifié et je tremble."
,"22":"Mais vous avez eu accès au Mont Sion et à la cité du Dieu vivant, la Jérusalem céleste avec ses milliers d'anges."
,"23":"L'assemblée des Premiers-nés, premiers admis dans le ciel, était là en fête. Vous êtes venus jusqu'à Dieu, le juge universel, avec les esprits des justes déjà arrivés à leur perfection. "
,"24":"Là était Jésus, le médiateur de la Nouvelle Alliance, avec le sang de l'aspersion qui crie beaucoup plus fort que le sang d'Abel."
,"25":"Prenez donc garde de ne pas faire la sourde oreille à celui qui parle. En ce temps-là ceux qui n'ont pas écouté le prophète de la terre, n'ont pu échapper. Que se passera-t-il si nous nous détournons de celui qui parle du haut du ciel?"
,"26":"En ce temps-là sa voix a fait trembler la terre, mais maintenant on nous avertit: Un peu plus et je vais secouer non seulement la terre mais aussi le ciel."
,"27":"Ce un peu plus signifie qu'on va remplacer ces choses qu'on ébranle parce qu'elles sont créées, et alors restera ce qui est inébranlable."
,"28":"Et puisque nous avons reçu un royaume inébranlable, gardons la faveur qui nous est faite et servons Dieu comme il le désire, avec amour et pour de bon,"
,"29":"car notre Dieu est un feu dévorant."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Aimez vos frères."
,"2":"Sachez recevoir les autres, vous savez que certains ont ainsi reçu des anges sans s'en douter."
,"3":"Pensez aux prisonniers comme si vous étiez en prison avec eux. Pensez à ceux qui souffrent: vous avez, vous aussi, un corps."
,"4":"Que tous respectent le mariage; ne souillez pas votre union, car vous savez que Dieu punit les impurs et les adultères."
,"5":"Ne courez pas après l'argent, sachez vivre avec ce que vous avez. Lui-même a dit: Je ne te laisserai pas, je ne t'abandonnerai pas."
,"6":"Vous pouvez donc dire avec assurance: Le Seigneur est avec moi et je ne crains pas; que pourrait me faire un mortel?"
,"7":"Souvenez-vous de vos guides qui vous ont donné la parole de Dieu. Voyez comment ils ont quitté cette vie et imitez leur foi."
,"8":"Jésus Christ est le même, hier et aujourd'hui, et pour tous les siècles."
,"9":"Ne vous laissez pas prendre par les doctrines de toutes sortes et de partout. La grâce est le bon moyen pour fortifier la vie intérieure, et non pas ces autres aliments dont personne n'a tiré profit."
,"10":"Nous avons nous aussi notre table, mais on ne peut en profiter tant qu'on prend part au culte du Temple."
,"11":"Et voyez encore: après que le grand-prêtre a offert pour le péché, dans le lieu saint, le sang des victimes, leurs corps sont brûlés hors du campement."
,"12":"De même Jésus a souffert hors des murs, quand il a voulu sanctifier le peuple par son sang."
,"13":"Allons donc le rejoindre hors du campement et partageons son humiliation,"
,"14":"sachant que nous n'avons pas de cité définitive ici-bas, mais que nous attendons celle qui doit venir."
,"15":"Offrons donc à Dieu en tout temps, par Jésus, un sacrifice de louange, celui qui consiste à proclamer son Nom."
,"16":"Et n'oubliez pas non plus de partager et de faire du bien, car ce sont là des sacrifices qui plaisent à Dieu."
,"17":"Obéissez à vos guides et acceptez-les. Pensez qu'ils se font du souci pour vos âmes, sachant qu'ils en rendront compte, et il vaut mieux pour vous qu'ils le fassent avec joie qu'en gémissant."
,"18":"Priez pour nous; nous ne voulons pas autre chose que ce qui est bon et nous pensons que notre conscience est droite."
,"19":"Je vous demande donc instamment de prier pour moi, pour que je vous sois rendu au plus tôt."
,"20":"Que le Dieu de paix vous bénisse, lui qui a ramené d'entre les morts Jésus, notre Seigneur, suprême berger des brebis pour avoir versé le sang de l'Alliance Eternelle."
,"21":"Qu'il vous fasse acquérir toute perfection et vous fasse faire sa volonté, puisque c'est lui qui fait naître en nous tout ce qui lui est agréable, par Jésus Christ, à qui soit la gloire pour tous les siècles. Amen!"
,"22":"Je vous en prie, frères, prenez bien ces paroles d'encouragement; je n'y ajoute que quelques mots."
,"23":"Sachez que notre frère Timothée a été mis en liberté et, s'il n'arrive pas trop tard, je pense vous visiter avec lui."
,"24":"Saluez tous vos responsables et tous les saints, nos frères. Ceux d'Italie vous saluent."
,"25":"Que la grâce soit avec vous tous!"
}`)

}
func FR_LBDCC_LoadVH1MChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Alexandre fils de Philippe, roi de Macédoine, venait du pays de Kittim: il régnait jusque-là sur la Grèce. Après avoir battu Darius, roi des Perses et des Mèdes, il régna à sa place."
,"2":"Il livra de nombreux combats, il s'empara des villes fortifiées et mit à mort les rois de la région."
,"3":"Il s'avança jusqu'aux extrémités du monde, ramassant les richesses de nombreux pays. La terre finit par se taire devant lui et son orgueil n'eut plus de limites."
,"4":"Il réunit une armée très puissante, il domina des provinces, des peuples et des rois et il en fit ses serviteurs."
,"5":"Mais après tout cela il tomba malade et vit qu'il allait mourir;"
,"6":"alors il fit venir ses compagnons, ceux qui avaient été élevés avec lui depuis son enfance, et il leur partagea son royaume alors qu'il était encore en vie."
,"7":"Alexandre mourut donc après douze ans de règne;"
,"8":"ses compagnons prirent le pouvoir, chacun dans son secteur."
,"9":"Lui étant mort, ils se firent tous couronner rois, et de même leurs fils après eux pendant de longues années: le mal alla en augmentant sur la terre."
,"10":"L'un de leurs descendants, Antiocus Epiphane, fils du roi Antiocus, fut particulièrement mauvais. Il avait été d'abord otage à Rome, mais en l'an cent trente sept de la royauté des Grecs, il monta sur le trône."
,"11":"C'est en ce temps-là que se leva en Israël une génération de gens dévoyés qui entraînèrent beaucoup de monde derrière eux: 'Faisons alliance avec les nations qui nous entourent, disaient-ils, car depuis que nous nous sommes séparés d'elles, beaucoup de malheurs nous sont arrivés.'"
,"12":"Ce genre de discours fut bien accueilli:"
,"13":"quelques personnes de notre peuple allèrent trouver le roi qui leur donna l'autorisation de suivre les coutumes des païens."
,"14":"Ils construisirent une salle de gymnastique à Jérusalem comme le faisaient les païens,"
,"15":"ils se refirent des prépuces et renièrent l'Alliance sainte pour se mettre dans le même attelage que les païens; ils se vendirent pour faire le mal."
,"16":"Lorsque Antiocus pensa avoir son royaume bien en mains, il voulut régner aussi sur l'Egypte et devenir ainsi le souverain des deux royaumes."
,"17":"Il entra en Egypte avec une puissante armée, des chars, des éléphants, des cavaliers et de nombreux bateaux."
,"18":"Il attaqua Ptolémée roi d'Egypte qui ne put résister et prit la fuite; beaucoup de ses hommes furent tués."
,"19":"Antiocus s'empara des forteresses d'Egypte et fit main basse sur les richesses du pays."
,"20":"Après avoir vaincu l'Egypte, il prit le chemin du retour en l'an cent quarante-trois. C'est alors qu'il marcha sur Israël et sur Jérusalem avec une puissante armée."
,"21":"Plein d'orgueil, Antiocus entra dans le sanctuaire, il enleva l'autel d'or, le chandelier sur lequel brille la lumière, avec tous les accessoires,"
,"22":"la table et les vases pour les offrandes, les coupes, les encensoirs d'or, le voile, les couronnes; il arracha tout le plaquage d'or qui ornait la façade du Temple."
,"23":"Il ramassa l'argent et l'or, les objets précieux et tous les trésors cachés qu'il put découvrir."
,"24":"Il emporta tout et retourna dans son pays. Il répandit beaucoup de sang et fit des déclarations insultantes contre Dieu."
,"25":"Le pays d'Israël tout entier était dans le deuil,"
,"26":"les chefs et les anciens gémissaient. Jeunes filles et jeunes gens restaient sans force, et les femmes en perdaient leur beauté."
,"27":"Les chants du marié se changèrent en lamentation et la mariée prit le deuil dans sa chambre."
,"28":"La terre trembla à cause de ses habitants, toute la maison de Jacob était couverte de honte."
,"29":"Deux ans plus tard, le roi envoya dans les villes de Juda un chef, qui arriva à Jérusalem avec une puissante armée."
,"30":"Il adressa de bonnes paroles aux habitants pour gagner leur confiance, mais c'était un mensonge, car ensuite il se jeta par surprise sur la ville, il la frappa brutalement et fit mourir beaucoup de gens d'Israël."
,"31":"Il pilla la ville, il l'incendia, il abattit ses maisons et son rempart."
,"32":"Ses soldats emmenèrent en captivité les femmes et les enfants et ramassèrent le bétail."
,"33":"Alors ils reconstruisirent la cité de David pour en faire une forteresse avec un très gros rempart et des tours puissantes."
,"34":"A l'intérieur ils placèrent des gens sans conscience, des renégats qui s'y installèrent."
,"35":"Ils y emmagasinèrent des armes et des provisions, ils y entassèrent tout ce qu'ils avaient ramassé dans Jérusalem: elle devint une menace redoutable."
,"36":"C'était un danger pour le Lieu Saint, et de là l'ennemi menaçait Israël en tout temps."
,"37":"Ils répandirent le sang innocent autour du sanctuaire, ils profanèrent le Lieu Saint."
,"38":"Ils firent fuir les habitants de Jérusalem, qui devint un repaire d'étrangers; elle devint une étrangère pour ses fils, et ses enfants l'abandonnèrent."
,"39":"Son temple devint un désert, ses fêtes se changèrent en jours de deuil, ses sabbats furent tournés en dérision, au lieu du respect ce fut le mépris."
,"40":"Sa honte fut aussi grande que sa gloire d'autrefois, sa grandeur fit place au deuil."
,"41":"Le roi donna ensuite des ordres pour que tous dans son empire ne fassent plus qu'un seul peuple:"
,"42":"chacun devait renoncer à ses coutumes. Tous les païens se soumirent aux ordres du roi"
,"43":"et même en Israël, beaucoup de gens firent bon accueil à son culte: ils sacrifiaient aux idoles et profanaient le sabbat."
,"44":"Le roi envoya des messagers à Jérusalem et aux villes de Juda pour y porter ses ordres: il fallait désormais suivre des coutumes étrangères au pays,"
,"45":"faire cesser les holocaustes du Temple, les sacrifices et les libations. On devait profaner les sabbats et les fêtes,"
,"46":"souiller le Sanctuaire et tout ce qui est saint,"
,"47":"élever des autels, des lieux de culte et des temples pour les idoles, immoler des porcs et des animaux impurs."
,"48":"On devait laisser les fils sans circoncision et se rendre ainsi odieux par toute sorte d'impuretés et de profanations."
,"49":"En un mot, on devait oublier la Loi et négliger toutes ses observances:"
,"50":"celui qui n'obéirait pas aux ordres du roi devait être mis à mort."
,"51":"C'est ainsi que s'exprimaient les lettres du roi envoyées à tout son royaume; il établit des inspecteurs sur tout le peuple et ordonna à toutes les villes de Juda d'offrir des sacrifices."
,"52":"Beaucoup de gens parmi le peuple obéirent, tous ceux qui abandonnaient la Loi; ils firent du mal dans le pays,"
,"53":"obligeant Israël à se chercher des refuges."
,"54":"Le quinzième jour du mois de Kisleu, en l'an cent quarante-cinq, le roi dressa l'Abomination de la Désolation sur l'autel des holocaustes, et on éleva des autels dans les villes voisines de Juda."
,"55":"On brûlait de l'encens à la porte des maisons et sur les places,"
,"56":"on déchirait et on jetait au feu les livres de la Loi quand on les trouvait,"
,"57":"et si l'on découvrait chez quelqu'un un livre de l'Alliance ou si quelqu'un obéissait à la Loi de Dieu, on le mettait à mort selon le décret du roi."
,"58":"On punissait les Israélites que l'on prenait en contravention mois après mois dans leurs villes,"
,"59":"et le vingt-cinq de chaque mois on offrait des sacrifices sur l'autel élevé à la place de l'autel des holocaustes."
,"60":"On mit à mort selon cette loi des femmes qui avaient fait circoncire leurs enfants,"
,"61":"avec leurs nourrissons pendus à leur cou; on mit à mort également les gens de leur famille et ceux qui avaient opéré la circoncision."
,"62":"Malgré tout cela, plusieurs en Israël restèrent fidèles et furent assez courageux pour ne pas manger des mets impurs."
,"63":"Ils aimaient mieux mourir que de se rendre impurs avec des aliments qui contrevenaient à l'Alliance sainte, et de fait ils furent mis à mort."
,"64":"Ce fut une grande épreuve pour Israël."
}`)
	CurrentBook.AddChapter(2, `{
"1":"En ces jours-là, un prêtre du nom de Mattathias, fils de Jean, fils de Siméon, de la descendance de Yoarib, quitta Jérusalem pour s'installer à Modin."
,"2":"Il avait cinq fils, Jean surnommé Gadi,"
,"3":"Simon surnommé Tassi,"
,"4":"Judas surnommé Maccabée,"
,"5":"Eléazar surnommé Avaram, Jonathan surnommé Afous."
,"6":"A la vue des péchés qui se commettaient en Juda et à Jérusalem,"
,"7":"il s'écria: 'Quel malheur! Je suis né pour voir la ruine de mon peuple et la ruine de la Ville Sainte! Je reste là assis alors que la ville est livrée aux mains des ennemis, et le Temple au pouvoir des étrangers."
,"8":"Le Temple de Dieu est devenu comme un homme méprisé."
,"9":"Tout ce qui faisait sa gloire est parti en captivité. Ses enfants ont été tués sur les places, et ses jeunes, frappés par l'épée de l'ennemi."
,"10":"Y a-t-il une nation qui n'ait pas hérité de ses biens. qui ne se soit pas emparée de ses dépouilles?"
,"11":"Toute sa beauté lui a été enlevée, elle était libre, elle est devenue esclave."
,"12":"Le Lieu Saint, notre merveille et notre gloire, est maintenant devenu un désert, les païens l'ont profané."
,"13":"A quoi me sert de vivre encore?'"
,"14":"Mattathias et ses fils déchirèrent leurs vêtements, ils s'habillèrent avec des sacs et firent un grand deuil."
,"15":"Arrivèrent alors à Modin les officiers du roi qui devaient imposer l'apostasie et faire offrir les sacrifices."
,"16":"Beaucoup d'Israélites s'approchèrent d'eux, mais Mattathias et ses fils se tenaient à l'écart."
,"17":"Les officiers du roi dirent à Mattathias: 'Tu es un personnage important et respecté dans cette ville, tu as des fils et des frères derrière toi;"
,"18":"avance donc le premier pour obéir aux ordres du roi comme l'ont fait toutes les nations, les chefs de Juda et ceux qui sont restés à Jérusalem. Toi et tes fils vous serez admis parmi les amis du roi, vous serez honorés de cadeaux en argent et en or et de bien d'autres choses.'"
,"19":"Mattathias répondit d'une voix forte: 'Même si tous les peuples qui forment l'empire du roi lui obéissent, même si chacun abandonne le culte de ses pères pour se conformer à ses ordonnances,"
,"20":"moi, mes fils et mes frères, nous suivrons l'Alliance de nos pères."
,"21":"Que Dieu nous garde d'abandonner la Loi et ses observances!"
,"22":"Nous n'écouterons pas les ordres du roi, nous ne dévierons pas de notre religion, ni à droite ni à gauche.'"
,"23":"Lorsqu'il eut terminé de parler, un Juif s'avança devant tout le monde pour sacrifier sur l'autel de Modin conformément au décret du roi."
,"24":"En voyant cela, Mattathias fut pris d'indignation et de colère, il donna libre cours à sa fureur, se jeta sur l'homme et l'égorgea sur l'autel."
,"25":"Il tua du même coup l'officier du roi qui obligeait à sacrifier et il renversa l'autel."
,"26":"Son zèle pour la Loi fut semblable à celui de Pinhas lorsqu'il frappa Zimri fils de Salu."
,"27":"Mattathias cria alors d'une voix forte à travers la ville: 'Que ceux qui veulent défendre la Loi et rester dans l'Alliance me suivent!'"
,"28":"Il s'enfuit avec ses fils dans les montagnes, abandonnant dans la ville tout ce qu'il possédait."
,"29":"Beaucoup de gens qui avaient à coeur la justice et les décrets de la Loi, vinrent au désert pour s'y installer."
,"30":"Ils arrivèrent avec leurs enfants, leurs femmes et leur bétail, parce que la vie leur était devenue impossible."
,"31":"On annonça aux officiers du roi et aux troupes qui étaient à Jérusalem dans la Cité de David, que des gens qui rejetaient les ordres du roi s'étaient réfugiés dans les cachettes du désert."
,"32":"Un fort détachement se mit à leur poursuite et les rejoignit; il vint se poster face à eux et se disposa à les attaquer le jour du sabbat."
,"33":"On leur dit: 'C'est assez, sortez! Obéissez à l'ordre du roi et vous aurez la vie sauve!'"
,"34":"Mais ils répondirent: 'Nous ne sortirons pas! Nous n'observerons pas le décret du roi et nous ne violerons pas le jour du sabbat.'"
,"35":"On les attaqua aussitôt."
,"36":"Ils refusèrent de riposter, de lancer des pierres ou de se barricader dans leurs cachettes:"
,"37":"'Mourons tous, disaient-ils, nous resterons sans reproche; le ciel et la terre sont témoins que vous nous faites périr injustement.'"
,"38":"Les autres leur donnèrent l'assaut alors que c'était le sabbat, et ils moururent avec leurs femmes, leurs enfants, leur bétail; il y avait là environ mille personnes."
,"39":"Lorsque Mattathias et ses amis apprirent la chose, ils firent un grand deuil."
,"40":"Mais ils se dirent entre eux: 'Si nous faisons tous comme ont fait nos frères, si nous ne nous défendons pas contre les païens pour sauver notre vie et nos observances, ils nous feront vite sortir de ce monde.'"
,"41":"Ils prirent donc le jour même cette décision: 'Si quelqu'un vient nous attaquer le jour du sabbat, nous lui ferons face et nous ne nous laisserons pas massacrer comme l'ont fait nos frères qui sont morts dans leurs refuges.'"
,"42":"Tout un groupe d'Assidéens vint les rejoindre, des Israélites courageux et tout dévoués à la Loi."
,"43":"Tous ceux qui fuyaient le danger vinrent en renfort et grossirent leur nombre;"
,"44":"ils organisèrent ainsi leur armée. Ils commencèrent alors à décharger leur colère sur les pécheurs, et leur fureur sur ceux qui avaient abandonné la Loi. Ceux-ci s'enfuirent chez les nations païennes pour y trouver refuge."
,"45":"Mattathias et ses amis firent alors une tournée pour détruire les autels"
,"46":"et circoncire de force tous les enfants non circoncis qu'ils trouvèrent sur le territoire d'Israël."
,"47":"Ils poursuivirent les insolents et ils eurent plein succès;"
,"48":"ils reprirent leur religion de la main des nations païennes et de leur roi, et réduisirent les pécheurs au silence."
,"49":"Lorsque la vie de Mattathias touchait à sa fin, il réunit ses fils: 'Vous voyez maintenant le règne de l'insolence et du mépris, leur dit-il, le temps de la révolution et le débordement de la Colère."
,"50":"Vous, mes fils, soyez remplis de courage pour la Loi et donnez vos vies pour l'Alliance de nos pères."
,"51":"Souvenez-vous de ce que nos pères ont accompli en leur temps, et vous gagnerez une grande gloire et un nom immortel."
,"52":"C'est dans l'épreuve qu'Abraham a été trouvé fidèle, et à cause de cela il a été regardé comme un juste."
,"53":"Joseph, au temps du malheur, a observé la Loi, et il est devenu maître de l'Egypte."
,"54":"Pinhas, notre père, a brûlé de zèle, et il a reçu l'alliance d'un sacerdoce éternel."
,"55":"Josué a rempli fidèlement sa mission, et il est devenu juge en Israël."
,"56":"Caleb a proclamé la vérité au milieu de l'assemblée, et il a reçu un héritage dans le pays."
,"57":"David, à cause de sa piété, a reçu un trône royal qui passera les siècles."
,"58":"Elie, qui avait brûlé de zèle pour la Loi, a été enlevé jusqu'au ciel."
,"59":"Ananias, Azarias, Misaël, ont eu confiance, et ils furent sauvés de la flamme."
,"60":"Daniel, qui n'avait pas transigé, a été sauvé de la gueule des lions."
,"61":"Comprenez donc que, de génération en génération, ceux qui espèrent en Dieu ne seront pas vaincus."
,"62":"Ne craignez pas les menaces d'un homme qui va contre Dieu, car sa gloire finira sur le fumier et dans la pourriture."
,"63":"Aujourd'hui il est honoré, et demain on ne le connaîtra plus: il retournera à la poussière d'où il est sorti et il ne restera rien de son projet."
,"64":"Soyez forts, mes fils, et restez fidèles à la Loi, parce que c'est d'elle que vous viendra la gloire."
,"65":"Voyez votre frère Siméon, je sais qu'il est de bon conseil. Ecoutez-le toujours, il sera pour vous un père."
,"66":"Judas Maccabée a été courageux dès son enfance, il sera le chef de votre armée, il mènera la guerre contre les nations."
,"67":"Vous allez rassembler tous ceux qui observent la Loi et vous vengerez votre peuple."
,"68":"Rendez aux nations païennes le mal qu'elles vous ont fait et attachez-vous aux commandements de la Loi.'"
,"69":"Alors il les bénit et il fut réuni à ses pères."
,"70":"Il mourut en l'an cent quarante-six; on l'enterra dans la tombe de ses pères à Modin et Israël fit un grand deuil pour lui."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Son fils Judas, surnommé Maccabée, prit sa place;"
,"2":"ses frères et tous ceux qui avaient pris le parti de son père lui apportèrent leur concours, et ils menèrent le combat d'Israël avec ardeur."
,"3":"Il étendit la renommée de son peuple, c'était un géant lorsqu'il revêtait sa cuirasse et prenait ses armes pour engager le combat. Son épée protégeait le camp d'Israël."
,"4":"Dans les batailles, il était comme un lion, comme un jeune lion qui rugit après sa proie."
,"5":"Il fit la chasse aux renégats, il les recherchait, il livra au feu ceux qui troublaient son peuple."
,"6":"Il jetait la terreur parmi les renégats, ceux qui s'en prenaient à la Loi étaient effrayés, et grâce à lui, la libération fut menée à bien."
,"7":"Il rendit la vie amère à plus d'un roi, mais ses actions mettaient Jacob en joie: sa mémoire sera bénie pour toujours."
,"8":"Il parcourut les villes de Juda, il en extermina les impies, il détourna d'Israël la colère divine."
,"9":"Son nom devint célèbre jusqu'aux extrémités du monde, lui qui a rassemblé ceux qui étaient perdus."
,"10":"Apollonius rassembla des païens et beaucoup de gens de Samarie pour combattre Israël."
,"11":"Lorsque Judas l'apprit, il sortit à sa rencontre, il l'assaillit et le tua; beaucoup tombèrent blessés à mort et le reste prit la fuite."
,"12":"Lorsqu'on ramassa les dépouilles, Judas prit pour lui l'épée d'Apollonius; dès ce moment il s'en servit toujours dans les combats."
,"13":"Séron, le général de l'armée de Syrie, apprit que Judas avait réuni autour de lui beaucoup de croyants et d'hommes de guerre."
,"14":"Il se dit alors: 'J'ai l'occasion de me rendre célèbre et de me couvrir de gloire dans le royaume. Je vais combattre Judas et ses hommes qui méprisent les ordres du roi.'"
,"15":"Il arriva donc à son tour avec une puissante armée d'impies pour tirer vengeance des fils d'Israël."
,"16":"Comme il approchait de la montée de Beth-Horon, Judas sortit à sa rencontre avec peu de monde."
,"17":"En voyant le détachement qui s'avançait contre eux, les hommes de Judas lui dirent: 'Comment pourrons-nous lutter contre une si forte troupe, étant si peu nombreux? De plus nous sommes sans forces, car nous n'avons rien mangé aujourd'hui.'"
,"18":"Judas leur répondit: 'Ce n'est pas difficile que beaucoup d'hommes soient vaincus par un petit nombre. Pour le Ciel c'est la même chose de donner le salut avec beaucoup d'hommes ou avec peu de monde:"
,"19":"sachez qu'à la guerre la victoire ne va pas aux plus nombreux, car c'est du Ciel que vient la force."
,"20":"Eux s'avancent contre nous pleins d'orgueil et d'impiété, ils veulent nous exterminer, nous, nos femmes et nos enfants, et prendre nos biens."
,"21":"Mais nous, nous défendons nos vies et nos lois,"
,"22":"et le Ciel les brisera devant nous. N'ayez pas peur d'eux!'"
,"23":"Lorsqu'il eut fini de parler, il se jeta sur eux à l'improviste: Séron et son armée furent écrasés."
,"24":"Ils les poursuivirent dans la descente de Beth-Horon jusqu'à la plaine; huit cents hommes environ tombèrent et le reste s'enfuit vers le pays des Philistins."
,"25":"On commença à redouter Judas et ses frères et la crainte s'empara de toutes les nations d'alentour;"
,"26":"même le roi connaissait son nom et toutes les nations parlaient des batailles de Judas."
,"27":"Antiocus entra dans une grande colère lorsqu'il l'apprit; il donna l'ordre de rassembler toutes les troupes de son royaume, une armée formidable."
,"28":"Il ouvrit son trésor et donna aux troupes leur solde pour un an, avec la consigne d'être prêts à tout."
,"29":"Il s'aperçut alors que l'argent manquait dans ses coffres et que les impôts de la province avaient diminué à cause des divisions et autres maux: lui-même les avait provoqués en supprimant dans le pays des lois qui existaient depuis toujours."
,"30":"Autrefois il distribuait généreusement des cadeaux, plus que ne l'avaient fait les rois qui étaient avant lui; mais maintenant il avait peur de manquer, de ne pas avoir assez pour faire face aux dépenses."
,"31":"Comme il se voyait dans de sérieuses difficultés, il décida de se rendre en Perse pour percevoir les impôts des provinces et revenir avec beaucoup d'argent."
,"32":"Il laissa donc Lysias, un noble de la famille royale, pour s'occuper de ses affaires depuis l'Euphrate jusqu'à la frontière d'Egypte."
,"33":"Lysias devait prendre soin de son fils Antiocus jusqu'à son retour."
,"34":"Il lui confia la moitié de son armée avec les éléphants et lui donna ses ordres à propos de tout, et particulièrement au sujet des habitants de Judée et de Jérusalem."
,"35":"Il devait envoyer contre eux une armée pour écraser, éliminer les forces d'Israël et le petit reste de Jérusalem, pour qu'on n'en parle même plus dans cette ville."
,"36":"Après quoi on établirait des étrangers sur tout le territoire et on leur distribuerait les terres."
,"37":"Le roi prit avec lui l'autre moitié de l'armée et quitta sa capitale d'Antioche en l'an cent quarante-sept; il traversa l'Euphrate et s'enfonça à travers les provinces de la montagne."
,"38":"Parmi les amis du roi, Lysias choisit Ptolémée, fils de Dorimène, Nicanor et Gorgias, tous des hommes influents."
,"39":"Il envoya avec eux quarante mille fantassins et sept mille cavaliers pour envahir et ruiner le pays de Juda selon l'ordre du roi."
,"40":"Gorgias se mit en marche avec toute son armée et il arriva près d'Emmaüs dans le Bas-Pays; là ils dressèrent leur camp."
,"41":"Lorsque les commerçants de la province apprirent la chose, ils vinrent chargés d'or et d'argent, avec des menottes en quantité, et ils se présentèrent au camp prêts à acheter des prisonniers Israélites. Des gens d'Idumée et du pays des Philistins vinrent aussi les rejoindre."
,"42":"Lorsque Judas et ses frères virent les armées camper sur leur territoire, ils comprirent que les choses allaient très mal. Ils apprirent aussi la consigne que le roi avait donnée: de livrer leur peuple à une destruction totale."
,"43":"Ils se dirent alors les uns aux autres: 'Sauvons notre peuple de la ruine et luttons pour notre peuple et notre Lieu Saint.'"
,"44":"On convoqua l'assemblée: on se préparait à la guerre, on priait et on implorait pitié et miséricorde."
,"45":"Jérusalem, dépeuplée, devenait un désert. Nul de ses enfants n'y entrait, personne n'en sortait, le sanctuaire était foulé aux pieds, des étrangers habitaient la citadelle, elle était devenue une auberge de païens. En Jacob, les danses avaient cessé, on n'entendait plus le son de la flûte et de la lyre."
,"46":"Tous se rassemblèrent à Masfa, en face de Jérusalem, car Masfa avait été autrefois un lieu de prière pour Israël."
,"47":"Ce jour-là on jeûna, on s'habilla de sacs, on répandit de la cendre sur sa tête et l'on déchira ses vêtements."
,"48":"On déroula le livre de la Loi pour y trouver des réponses, les mêmes que les païens demandaient à leurs idoles."
,"49":"On apporta les vêtements des prêtres, des prémices et des dîmes, on fit venir des Naziréens qui avaient achevé le temps de leur voeu."
,"50":"Tous crièrent vers le ciel, ils disaient: 'Que faire de ces hommes? Où les mener?"
,"51":"Ton Lieu Saint a été foulé aux pieds et profané. Tes prêtres sont en deuil, humiliés."
,"52":"Les nations se sont liguées contre nous pour nous faire disparaître. Tu connais bien leurs intentions."
,"53":"Comment pourrons-nous tenir devant elles si tu ne viens pas toi-même à notre secours.'"
,"54":"Alors on fit sonner les trompettes et l'on poussa de grands cris."
,"55":"Après cela, Judas établit des chefs sur le peuple, chefs de mille, chefs de cent, chefs de cinquante et chefs de dix."
,"56":"Il dit à ceux qui étaient en train de bâtir une maison, à ceux qui venaient de se fiancer ou de planter une vigne, et à tous ceux qui avaient peur, de s'en retourner chez eux comme l'autorisait la Loi."
,"57":"Puis la troupe se mit en marche et vint camper au sud d'Emmaüs."
,"58":"Judas leur dit: 'Equipez-vous et soyez courageux! Tenez-vous prêts à combattre demain ces nations qui se sont rassemblées contre nous pour nous détruire, nous et notre sanctuaire."
,"59":"Mieux vaut pour nous mourir dans la bataille, qu'assister à la ruine de notre peuple et de notre Lieu Saint: arrive ce que le ciel voudra!'"
}`)
	CurrentBook.AddChapter(4, `{
"1":"Gorgias prit avec lui cinq mille fantassins et un millier des meilleurs cavaliers. Il partit de nuit"
,"2":"pour pénétrer dans le camp des Juifs et les frapper par surprise: des hommes de la citadelle lui servaient de guides."
,"3":"Judas en fut averti; il sortit alors avec ses hommes pour attaquer l'armée du roi qui était à Emmaüs,"
,"4":"profitant de ce que les troupes s'étaient dispersées loin du camp."
,"5":"Gorgias arriva de nuit au camp de Judas; il n'y trouva personne et se mit à chercher les Juifs dans les montagnes car il se disait: 'Ils ont pris la fuite devant nous.'"
,"6":"Mais au petit matin Judas parut dans la plaine avec trois mille hommes. Ils n'avaient, de fait, ni les armures ni les épées qu'ils auraient désirées,"
,"7":"et ils voyaient devant eux le camp des païens, puissant et bien fortifié, avec de la cavalerie tout autour; c'étaient des gens qui savaient se battre."
,"8":"Judas dit alors à ses hommes: 'N'ayez pas peur de cette foule, ne redoutez pas leur attaque."
,"9":"Rappelez-vous que nos pères furent délivrés à la mer Rouge lorsque le Pharaon les poursuivait avec son armée."
,"10":"Crions donc vers le Ciel! S'il veut de nous, il se souviendra de son Alliance avec nos pères et il écrasera aujourd'hui cette armée que vous voyez devant nous."
,"11":"Alors toutes les nations sauront qu'il y a quelqu'un pour racheter et sauver Israël.'"
,"12":"En levant les yeux, les étrangers virent les Juifs qui venaient droit sur eux;"
,"13":"ils sortirent de leur camp pour combattre. Les soldats de Judas sonnèrent de la trompette"
,"14":"et engagèrent la bataille. Les païens furent écrasés et prirent la fuite à travers la plaine,"
,"15":"mais tous les derniers tombèrent sous l'épée. On les poursuivit jusqu'à Gazer, jusqu'aux plaines d'Idumée, d'Azotos et de Jamnia: il y eut près de trois mille morts."
,"16":"Revenu de la poursuite avec son armée,"
,"17":"Judas dit au peuple: 'Ce n'est pas le moment de penser au pillage, car un autre combat vous attend:"
,"18":"Gorgias et ses hommes sont dans la montagne tout près de nous, il faut faire face à nos ennemis et les combattre; après cela, vous pourrez ramasser le butin sans crainte.'"
,"19":"Judas venait à peine de prononcer ces paroles, lorsqu'on aperçut des troupes ennemies qui observaient du haut de la montagne."
,"20":"Elles virent que les leurs avaient pris la fuite et que les flammes avaient dévoré leur camp: il suffisait de voir la fumée pour comprendre."
,"21":"Ce spectacle les remplit de crainte; mais quand ils virent dans la plaine l'armée de Judas prête à combattre,"
,"22":"ils prirent tous la fuite vers le pays des Philistins."
,"23":"Alors Judas revint pour piller le camp; on ramassa quantité de pièces d'or et d'argent, des étoffes de pourpre violette et de pourpre rouge et beaucoup d'autres richesses."
,"24":"A leur retour, les Juifs louaient et bénissaient le Ciel en chantant: 'Il est bon et son amour est éternel!'"
,"25":"Ce jour-là, Israël connut une grande délivrance."
,"26":"Les étrangers qui avaient pu s'enfuir rapportèrent à Lysias tout ce qui s'était passé."
,"27":"Cette nouvelle le bouleversa et lui fit perdre courage; les affaires avec Israël ne s'étaient pas déroulées comme il l'aurait voulu, et le résultat était tout le contraire de ce que le roi avait ordonné."
,"28":"L'année suivante, Lysias réunit soixante mille hommes parmi les meilleurs et cinq mille cavaliers, afin de venir à bout des Juifs."
,"29":"Ils arrivèrent en Idumée et campèrent à Beth-Sour; Judas vint à leur rencontre avec dix mille hommes."
,"30":"Quand il vit cette puissante armée, il fit cette prière: 'Tu es béni, toi qui sauves Israël! Tu as brisé l'attaque du puissant guerrier par la main de ton serviteur David, tu as livré le camp des Philistins entre les mains de Jonathan, fils de Saül, et de son compagnon:"
,"31":"livre de même cette armée entre les mains de ton peuple Israël! Qu'ils soient totalement déçus de leurs troupes et de leur cavalerie!"
,"32":"Jette la panique dans leurs rangs, fais fondre la confiance qu'ils mettent dans leurs forces et que leur défaite les décourage."
,"33":"Fais-les tomber sous l'épée de ceux qui t'aiment, et que ceux qui connaissent ton Nom te louent par leurs cantiques.'"
,"34":"Ils se lancèrent les uns contre les autres et cinq mille hommes de l'armée de Lysias tombèrent au cours du corps à corps."
,"35":"Voyant l'échec de son armée et le courage des soldats de Judas, décidés à vivre ou à mourir courageusement, Lysias repartit vers Antioche où il recruta des étrangers pour revenir en Judée avec une troupe encore plus nombreuse."
,"36":"Judas et ses frères dirent alors: 'Nos ennemis sont maintenant abattus, purifions le Sanctuaire et célébrons la Dédicace.'"
,"37":"Toute l'armée se rassembla donc pour monter au mont Sion."
,"38":"Là ils virent que le Lieu Saint était à l'abandon, l'autel profané, les portes brûlées; de petits arbres poussaient dans les cours comme dans un bois ou sur une montagne et les chambres étaient détruites."
,"39":"Alors ils déchirèrent leurs vêtements et firent un grand deuil en répandant de la cendre sur leur tête."
,"40":"Ils se prosternèrent la face contre terre et au son des trompettes ils poussèrent des cris vers le Ciel."
,"41":"Pendant qu'ils nettoyaient le Sanctuaire, Judas désigna des hommes pour combattre ceux qui restaient dans la citadelle."
,"42":"Il choisit ensuite des prêtres purs et pleins de zèle pour la Loi;"
,"43":"ils purifièrent le Sanctuaire et jetèrent dans un lieu impur les pierres de l'autel païen."
,"44":"Ils virent ensemble ce que l'on devait faire pour l'autel des holocaustes qui avait été profané,"
,"45":"ils eurent la bonne idée de le supprimer car c'était pour eux un motif d'humiliation, du fait que les païens l'avaient souillé. Ils le démolirent donc"
,"46":"et déposèrent les pierres de cet autel sur la montagne de la Demeure dans un endroit convenable. Ils attendaient qu'un prophète vienne pour se prononcer à ce sujet."
,"47":"Ils prirent des pierres qui n'avaient pas été taillées, comme le demandait la Loi, et ils firent un nouvel autel sur le modèle du précédent."
,"48":"Ils réparèrent le sanctuaire et l'intérieur de la Demeure, et ils purifièrent les cours."
,"49":"Après avoir fait de nouveaux ustensiles sacrés, ils placèrent dans le Temple les chandeliers, l'autel des parfums et la table pour les pains."
,"50":"Ils firent brûler de l'encens sur l'autel, ils allumèrent les lampes du chandelier qui brillèrent à l'intérieur du Temple."
,"51":"Ils déposèrent sur la table les pains, ils suspendirent les rideaux et achevèrent tout ce qu'ils avaient entrepris."
,"52":"Le vingt-cinq du neuvième mois, qu'on appelle le mois de Kisleu, en l'an cent quarante-huit, ils se levèrent dès l'aube,"
,"53":"et offrirent un sacrifice comme le demande la Loi sur le nouvel autel des holocaustes qu'ils avaient construit."
,"54":"On inaugura l'autel au son des cantiques, des cithares, des harpes et des cymbales, à la même époque et le même jour où les païens l'avaient profané."
,"55":"Le peuple tout entier se prosterna pour adorer, il fit monter sa louange vers le ciel qui avait mené à bien toutes choses."
,"56":"Durant huit jours on célébra la dédicace de l'autel, on offrit dans la joie des holocaustes, ainsi qu'un sacrifice de communion et d'actions de grâce."
,"57":"On décora la façade du Temple avec des couronnes d'or et des écussons, on répara les entrées et l'on mit des portes aux chambres."
,"58":"Le peuple était dans une grande joie et la honte que les païens avaient infligée fut effacée."
,"59":"Avec ses frères et toute l'assemblée d'Israël, Judas décida que les jours de la dédicace de l'autel seraient célébrés chaque année à la même date, pendant huit jours, à partir du vingt-cinq du mois de Kisleu, dans la joie et la fête."
,"60":"En ces jours-là on entoura le mont Sion de remparts et de tours fortifiées, pour que les païens ne viennent pas comme autrefois profaner ces lieux."
,"61":"Judas y établit une garnison pour le garder, il fortifia aussi Beth-Sour pour que le peuple ait une forteresse face à l'Idumée."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Les nations environnantes apprirent que l'autel et le Sanctuaire étaient reconstruits comme autrefois; elles en furent très en colère"
,"2":"et elles décidèrent de faire disparaître les descendants de Jacob qui vivaient au milieu d'elles. Alors commencèrent les assassinats et les expulsions de gens de notre peuple."
,"3":"Judas fit la guerre aux fils d'Esaü en Idumée; il marcha contre les habitants du pays d'Akrabatène, car ils assiégeaient les Israélites; il les attaqua violemment, il les battit et s'empara de leurs dépouilles."
,"4":"Il se rappela aussi la méchanceté des fils de Baïan: ils étaient une menace et un danger pour le peuple, car ils dressaient des embuscades sur les chemins."
,"5":"Il les bloqua dans leurs tours, il les assiégea et les voua à l'anathème; il mit le feu à leurs tours et les brûla avec tous ceux qui étaient dedans."
,"6":"Il passa de là chez les Ammonites, il y trouva une forte armée et un peuple nombreux commandé par Timothée."
,"7":"Il leur livra bataille, ils furent battus devant lui et il les écrasa complètement."
,"8":"Il prit alors Yazer et les villages des environs, puis il rentra en Judée."
,"9":"Les peuples païens de Galaad se coalisèrent pour faire disparaître les Israélites qui habitaient sur leur territoire, et ceux-ci se réfugièrent dans la forteresse de Dathéma."
,"10":"Ils envoyèrent à Judas et à ses frères des lettres dans lesquelles ils disaient: 'Les païens qui nous entourent sont venus nous assiéger pour nous faire disparaître,"
,"11":"ils s'apprêtent à prendre d'assaut la forteresse où nous nous sommes réfugiés. C'est Timothée qui commande leur armée."
,"12":"Viens donc maintenant nous délivrer de leurs mains, car déjà beaucoup d'entre nous sont morts."
,"13":"Tous nos frères qui sont du pays de Tobie ont été massacrés, on a emmené leurs femmes et leurs enfants en captivité, on a pris leurs biens: un millier d'hommes environ ont péri en cet endroit.'"
,"14":"On lisait ces lettres lorsque d'autres messagers arrivèrent de Galilée, qui avaient les vêtements déchirés et apportaient des nouvelles semblables:"
,"15":"'Ptolémaïs, Tyr et Sidon, disaient-ils, se sont rassemblés contre nous avec toute la Galilée des nations pour nous faire disparaître.'"
,"16":"En apprenant cela, Judas et le peuple convoquèrent une grande assemblée: Qu'allait-on faire pour ces frères mis à l'épreuve qui devaient lutter pour leur vie?"
,"17":"Judas dit à son frère Simon: 'Choisis des hommes et va délivrer les frères qui sont en Galilée. Moi et mon frère Jonathan nous irons au pays de Galaad.'"
,"18":"Il laissa en Judée Joseph fils de Zacharie, et Azarias chef de l'armée, avec le reste du peuple, pour monter la garde."
,"19":"Mais il leur donna cette consigne: 'Commandez le peuple, mais n'engagez pas le combat avec les païens jusqu'à notre retour.'"
,"20":"On donna trois mille hommes à Simon pour la Galilée, et huit mille à Judas pour le pays de Galaad."
,"21":"Simon partit pour la Galilée, il livra plusieurs batailles contre les païens qui furent balayés."
,"22":"Il les poursuivit jusqu'aux portes de Ptolémaïs, et ils laissèrent sur le terrain près de trois mille hommes dont il ramassa les dépouilles."
,"23":"Il prit alors avec lui les Juifs de Galilée et d'Arbata, leurs femmes, leurs enfants, et tout ce qu'ils possédaient; il les ramena en Judée au milieu de la joie générale."
,"24":"Pendant ce temps Judas Maccabée et Jonathan, son frère, traversèrent le Jourdain et marchèrent dans le désert durant trois jours."
,"25":"Ils rencontrèrent les Nabatéens qui leur firent bon accueil et les mirent au courant de ce qui arrivait à leurs frères au pays de Galaad:"
,"26":"'Beaucoup d'entre eux, disaient-ils, sont enfermés dans les villes fortifiées de Bosora, de Bosor près d'Aléna, de Casfo, de Maked et de Karnaïn."
,"27":"Certains sont assiégés dans les autres villes du pays de Galaad et leurs ennemis ont décidé d'attaquer demain ces forteresses, de s'en emparer et de faire disparaître en un seul jour tous ceux qui s'y trouvent.'"
,"28":"Judas fit alors prendre à son armée la route de Bosora, à travers le désert; il s'empara de la ville, il extermina tous les mâles et, après avoir ramassé tout le butin, il y mit le feu."
,"29":"Au milieu de la nuit il repartit et marcha jusqu'aux abords de la forteresse de Tathéma."
,"30":"Au petit matin on put voir une foule nombreuse qui dressait des échelles et des machines de siège contre la ville: l'attaque était déjà commencée."
,"31":"Lorsque Judas vit la situation, lorsqu'il entendit le grand cri qui montait de la ville vers le Ciel, ainsi que le son des trompettes,"
,"32":"il dit aux hommes de son armée: 'Combattez aujourd'hui pour vos frères!'"
,"33":"Ses hommes attaquèrent l'ennemi par derrière, disposés en trois groupes; on sonna de la trompette et l'on poussa le cri de guerre."
,"34":"Lorsque l'armée de Timothée reconnut les troupes de Maccabée, tous prirent la fuite, mais lui les écrasa tant et si bien qu'ils laissèrent ce jour-là près de huit mille hommes sur le terrain."
,"35":"Ensuite il s'en retourna sur Anéma, il l'attaqua, s'en empara, et après avoir exterminé tous les mâles et ramassé le butin, il y mit le feu."
,"36":"De là, il alla s'emparer de Casfo, de Maked, de Bosor et des autres villes du pays de Galaad."
,"37":"A la suite de cela, Timothée rassembla une autre armée qui vint s'établir en face de Raphon, de l'autre côté du torrent."
,"38":"Judas envoya des hommes pour reconnaître le camp, ils lui dirent: 'Tous les païens qui nous entourent se sont regroupés autour de ce chef, ils forment une armée extrêmement nombreuse."
,"39":"On a engagé des Arabes comme auxiliaires, ils sont campés au-delà du torrent et sont prêts à nous attaquer.' Judas marcha à leur rencontre."
,"40":"Pendant que Judas et sa troupe s'approchaient du torrent, Timothée dit aux chefs de son armée: 'S'il passe le premier vers nous, nous ne pourrons lui résister, il aura l'avantage sur nous."
,"41":"Mais s'il a peur et s'installe de l'autre côté du fleuve, alors nous traverserons vers lui et nous l'écraserons.'"
,"42":"En arrivant près du torrent, Judas donna cet ordre aux officiers du peuple qu'il avait disposés le long du torrent: 'Empêchez les hommes de dresser leurs tentes, mais que tous marchent au combat.'"
,"43":"Le premier, il franchit le torrent et marcha sur l'ennemi, suivi par tout le peuple. Il écrasa devant lui tous les païens, ils jetèrent leurs armes et coururent se réfugier dans le sanctuaire de Karnaïn."
,"44":"Les Juifs s'emparèrent de la ville et brûlèrent ensuite le temple avec tous ceux qui s'y trouvaient; Karnaïn fut renversé et désormais plus personne ne fut capable de résister à Judas."
,"45":"Judas rassembla alors tous les Israélites qui habitaient le pays de Galaad, depuis le plus petit jusqu'au plus grand; les femmes et les enfants avec leurs bagages formaient une colonne immense qui prit le chemin de Juda."
,"46":"Ils arrivèrent à Efron, ville grande et fortifiée. Comme elle était sur le chemin et qu'on ne pouvait l'éviter, ni sur la droite, ni sur la gauche, il fallait la traverser."
,"47":"Les habitants refusèrent le passage et bloquèrent les portes avec des pierres."
,"48":"Judas cependant leur envoya un message de paix: 'Nous allons traverser votre pays pour aller dans le nôtre, personne ne vous fera de mal. Nous traverserons comme de simples passants.' Mais ils refusèrent de lui ouvrir les portes."
,"49":"Judas fit alors passer dans les rangs cette consigne: que chacun se mît en position là où il se trouvait."
,"50":"Tous les hommes de sa troupe prirent position et Judas mena l'assaut contre la ville tout le jour et toute la nuit; finalement elle tomba."
,"51":"Il extermina tous les mâles, il détruisit la ville jusqu'à ses fondations, il ramassa tout ce qui avait quelque valeur et traversa la ville sur les cadavres."
,"52":"Ensuite on franchit le Jourdain pour entrer dans la Grande Plaine en face de Beth-Shan."
,"53":"Judas, pour sa part, regroupait ceux qui étaient à la traîne et encourageait le peuple tout au long de la route, jusqu'à l'arrivée au pays de Juda."
,"54":"On gravit le mont Sion dans la joie et la fête, on y offrit des holocaustes, car tous étaient revenus sains et saufs sans perdre personne."
,"55":"Pendant que Judas et Jonathan étaient au pays de Galaad et que leur frère Simon assiégeait Ptolémaïs en Galilée,"
,"56":"Joseph fils de Zacharie, et Azarias chef de l'armée, apprirent tout ce qu'ils avaient fait: leurs actes de bravoure et leurs combats."
,"57":"Ils se dirent: 'Rendons-nous célèbres nous aussi, allons attaquer les païens qui nous entourent.'"
,"58":"Ils donnèrent des ordres aux troupes qu'ils commandaient et marchèrent sur Jamnia."
,"59":"Mais Gorgias et ses hommes sortirent de la ville à leur rencontre et les attaquèrent."
,"60":"Joseph et Azarias furent mis en fuite: on les poursuivit jusqu'aux frontières de la Judée et ce jour-là il périt environ deux mille hommes du peuple d'Israël."
,"61":"Ce fut une grande défaite pour le peuple, et cela, parce qu'ils n'avaient pas écouté Judas et ses frères. Ils pensaient se rendre célèbres par leur bravoure,"
,"62":"mais ils n'étaient pas de la race de ces hommes à qui il était donné de sauver Israël."
,"63":"Par contre le valeureux Judas et ses frères méritèrent les louanges de tout Israël et de toutes les nations où l'on entendait parler d'eux."
,"64":"On se rassembla autour d'eux pour les féliciter."
,"65":"Judas et ses frères partirent en guerre contre les fils d'Esaü dans la région du Sud; il s'empara d'Hébron et des villages qui l'entouraient, il abattit les remparts et mit le feu aux tours de défense."
,"66":"Il leva ensuite son camp et partit pour le pays des Philistins; il traversa Marisa."
,"67":"Ce jour-là des prêtres voulurent montrer leur courage en attaquant de façon téméraire, et ils se firent tuer."
,"68":"Judas continua sa route sur Azotos, dans le pays des Philistins, il détruisit leurs autels, il brûla les idoles de leurs dieux, il mit les villes au pillage, puis il revint au pays de Juda."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Le roi Antiocus parcourait les provinces de la montagne. Il entendit alors parler de la ville d'Elymaïs en Perse, célèbre pour ses richesses, son argent et son or."
,"2":"Le temple de cette ville était très riche, il y avait là des tentures d'or, des cuirasses et des armes laissées par Alexandre fils de Philippe, roi de Macédoine (celui qui régna le premier sur les Grecs)."
,"3":"Il arriva donc et voulut s'emparer de cette ville pour la piller, mais il ne réussit pas, car les habitants de la ville avaient appris la chose."
,"4":"Ils le reçurent les armes à la main, il dut prendre la fuite et abandonner la place très désappointé pour revenir à Babylone."
,"5":"Il était encore en Perse lorsqu'il reçut cette nouvelle: 'Les armées qui sont allées au pays de Juda ont été battues."
,"6":"Lysias, qui s'était avancé avec une armée puissante, a dû céder le terrain aux Juifs. Ceux-ci se sont renforcés en armes et en nombre, sans parler de tout ce qu'ils ont récupéré sur les colonnes qu'ils ont vaincues."
,"7":"Ils ont renversé l'abomination que le roi avait élevée sur l'autel de Jérusalem, ils ont entouré leur Lieu Saint de hauts remparts comme autrefois, et de même Beth-Sour, l'une des villes royales.'"
,"8":"En apprenant ces nouvelles, le roi fut consterné et resta très abattu, il se laissa tomber sur son lit et en fut malade de chagrin, parce que les choses ne s'étaient pas déroulées comme il le voulait."
,"9":"Durant plusieurs jours il resta ainsi, retombant sans cesse dans un profond abattement. Lorsqu'il se vit prêt de mourir,"
,"10":"il rassembla tous ses amis: 'Le sommeil, leur dit-il, a quitté mes yeux et mon coeur est rempli d'inquiétude."
,"11":"Je me suis dit: A quel degré d'angoisse suis-je arrivé? Comment suis-je tombé dans un tel abattement, moi qui étais beau et aimé lorsque j'étais puissant?"
,"12":"Maintenant je me souviens de tout le mal que j'ai fait à Jérusalem lorsque j'ai pris tous les objets d'argent et d'or qui s'y trouvaient, et que j'ai envoyé des hommes pour faire disparaître sans raison tous les habitants de Juda."
,"13":"Je reconnais que c'est là la cause des malheurs qui m'atteignent maintenant. Voyez que je meurs misérable sur une terre étrangère.'"
,"14":"Il fit appeler Philippe, un de ses Amis, et l'établit sur tout son royaume."
,"15":"Il lui donna sa couronne, son manteau et son anneau, pour qu'il prenne soin de l'éducation et de l'entretien de son fils Antiocus, pour le préparer au trône."
,"16":"Le roi Antiocus mourut à cet endroit en l'an cent quarante neuf."
,"17":"En apprenant sa mort, Lysias lui donna pour successeur son fils Antiocus qu'il avait élevé depuis son enfance et auquel il avait donné le surnom d'Eupator."
,"18":"Les défenseurs de la Citadelle bloquaient Israël autour du Temple; ils cherchaient toutes les occasions de nuire et ils étaient un point d'appui pour les païens."
,"19":"Judas décida de les éliminer et il convoqua tout le peuple pour les assiéger."
,"20":"Tous se rassemblèrent et mirent le siège devant la Citadelle en l'an cent cinquante; ils construisirent des tours et des machines de siège."
,"21":"Cependant quelques assiégés parvinrent à s'échapper. Des Israélites impies se joignirent à eux"
,"22":"et ils allèrent ensemble trouver le roi. Ils lui dirent: 'Combien de temps attendras-tu pour nous rendre justice et venger nos frères?"
,"23":"Nous avons accepté de servir ton père, nous nous sommes conduits selon ses ordres et nous avons observé ses décrets,"
,"24":"et à cause de cela des gens de notre peuple nous ont rejetés. Bien plus! Ils ont tué tous ceux d'entre nous qui sont tombés entre leurs mains et ils ont pris nos domaines."
,"25":"Ils ne s'en sont pas pris seulement à nous, mais aussi à tes territoires."
,"26":"A présent ils assiègent la Citadelle de Jérusalem pour s'en emparer et ils ont fortifié le Temple et Beth-Sour."
,"27":"Si tu ne prends pas les devants, ils feront bien pire encore et tu ne pourras plus les arrêter.'"
,"28":"En entendant cela, le roi se mit en colère, il réunit tous ses Amis, les chefs de son armée et les commandants."
,"29":"Des troupes mercenaires lui arrivèrent également des autres royaumes et des îles de la mer."
,"30":"Son armée comptait cent mille fantassins, vingt mille cavaliers et trente-deux éléphants entraînés à la guerre."
,"31":"Ils arrivèrent par l'Idumée et assiégèrent Beth-Sour avec leurs machines; le siège dura longtemps car les défenseurs faisaient des sorties, mettaient le feu aux machines et se battaient courageusement."
,"32":"Alors Judas laissa la Citadelle et vint camper à Beth-Zakaria, face à l'armée du roi."
,"33":"Levé de bon matin, le roi mena ses troupes pleines d'ardeur sur les chemins de Beth-Zakaria, où elles prirent position pour le combat. On sonna de la trompette, "
,"34":"on mit sous les yeux des éléphants du jus de raisins et du jus de mûres pour les exciter à l'attaque,"
,"35":"on répartit les bêtes parmi les corps d'armée; autour de chaque éléphant on rangea mille hommes avec des cuirasses de fer et des casques de bronze; cinq cents cavaliers parmi les meilleurs accompagnaient chaque éléphant."
,"36":"Ils surveillaient tous les mouvements de l'animal et l'accompagnaient partout sans jamais s'écarter de lui."
,"37":"Sur chaque éléphant, une solide tour de bois servait de défense, elle était attachée avec des sangles et dans chacune se trouvaient trois guerriers qui combattaient sur le dos de l'éléphant, en plus de son guide."
,"38":"Le reste de la cavalerie avait été réparti par le roi sur les deux côtés de l'armée, pour combattre l'ennemi et protéger les corps d'armée."
,"39":"Lorsque le soleil brilla sur les boucliers d'or et de bronze, les montagnes furent illuminées et brillèrent comme des torches allumées."
,"40":"Une partie de l'armée du roi se déploya sur le sommet des montagnes, et l'autre au pied. Ils avançaient en formation régulière et bien ordonnée."
,"41":"Il suffisait d'entendre la rumeur de cette masse, le pas de cette multitude et le bruit des armes qui s'entrechoquaient pour être pris de peur: c'était vraiment une armée grande et puissante."
,"42":"Malgré tout, Judas et ses hommes s'avancèrent pour engager le combat et six cents hommes de l'armée du roi tombèrent."
,"43":"Eléazar surnommé Auaram aperçut un des éléphants portant un harnais royal; comme il dépassait tous les autres par sa taille, il pensa que le roi était dessus."
,"44":"Il sacrifia sa vie pour sauver son peuple et devenir célèbre pour toujours."
,"45":"Hardiment, il courut sur l'animal au milieu des soldats: il tuait à droite, il tuait à gauche, si bien que les ennemis s'écartaient devant lui."
,"46":"Il se glissa alors sous l'éléphant, le frappa par en-dessous et le tua; la bête s'écroula à terre sur Eléazar qui mourut sur place."
,"47":"Les Juifs avaient pu mesurer les forces du roi et l'ardeur de ses soldats, ils leur laissèrent le terrain."
,"48":"Une partie de l'armée du roi monta à Jérusalem pour les combattre et le roi mit en état de siège la Judée et le mont Sion."
,"49":"Au même moment il faisait la paix avec les gens de Beth-Sour. Ils évacuèrent la ville car ils n'avaient pas de nourriture pour soutenir un siège, vu qu'on était dans l'année sabbatique où la terre est au repos."
,"50":"Le roi prit possession de Beth-Sour et il y mit une garnison pour la défendre."
,"51":"Il fit le siège du Temple durant de longs jours avec ses tours et ses machines de siège, avec ses machines à lancer le feu et les pierres, et les plus petites pour les flèches et les cailloux."
,"52":"De leur côté, les assiégés dressèrent des machines contre celles des attaquants et le siège dura longtemps."
,"53":"Il n'y avait pas de nourriture dans les entrepôts parce que c'était la septième année, et les Israélites que l'on avait sauvés des territoires païens et ramenés en Judée avaient mangé les dernières réserves."
,"54":"Il ne resta donc que quelques hommes dans le Lieu Saint, car la famine avait été la plus forte et ils s'étaient dispersés chacun chez soi."
,"55":"C'est alors que Lysias reçut des nouvelles de Philippe, celui que le roi Antiocus avait choisi alors qu'il était encore en vie pour élever son fils Antiocus et le préparer à régner."
,"56":"Il était revenu de Perse et de Médie avec les troupes qui avaient accompagné le roi, et maintenant il cherchait à prendre en main les affaires."
,"57":"Lysias voulut donner au plus tôt le signal du départ. Il dit donc au roi, aux chefs de l'armée et aux soldats: 'Nous allons en nous affaiblissant, nous avons peu de vivres et la place que nous assiégeons est bien fortifiée; pendant ce temps, les affaires du royaume nous attendent."
,"58":"Faisons donc la paix avec ces hommes, faisons la paix avec eux et avec tout leur peuple."
,"59":"Accordons-leur de vivre selon leurs coutumes, comme autrefois, car c'est à cause de ces coutumes que nous avons supprimées qu'ils se sont soulevés et en sont arrivés là.'"
,"60":"Le roi et les chefs approuvèrent ses raisons; le roi envoya des hommes pour offrir la paix aux Juifs et ceux-ci acceptèrent."
,"61":"Le roi et les chefs s'engagèrent par serment et les assiégés sortirent de la forteresse."
,"62":"Mais lorsque le roi entra au mont Sion et qu'il vit la force de cette place, il viola le serment qu'il avait prêté et donna l'ordre de détruire tout le rempart."
,"63":"De là, il se mit en route rapidement pour regagner Antioche. Là, il trouva Philippe maître de la ville; il lui livra bataille et reprit la ville par la force."
}`)
	CurrentBook.AddChapter(7, `{
"1":"En l'an cent cinquante et un, Démétrius fils de Séleucus quitta Rome et débarqua avec quelques hommes dans un port d'où il commença à régner."
,"2":"En le voyant rentrer au royaume de ses ancêtres, l'armée s'empara d'Antiocus et de Lysias pour les lui amener."
,"3":"Lorsqu'il apprit la chose, il déclara: 'Ne me faites pas voir leur visage.'"
,"4":"Aussitôt l'armée les exécuta et Démétrius s'assit sur son trône."
,"5":"Tous les hommes d'Israël qui n'avaient ni foi ni loi vinrent le trouver; Alkime, qui rêvait d'être grand prêtre, les conduisait."
,"6":"Devant le roi ils accusèrent leur peuple en disant: 'Judas et ses frères ont tué tous tes amis et ils nous ont chassés de notre pays."
,"7":"Envoie donc maintenant un homme en qui tu as confiance: qu'il aille voir tout le tort que Judas nous a fait, à nous et aux territoires du roi, et qu'il punisse ces gens-là avec tous ceux qui les aident.'"
,"8":"Le roi choisit Bakidès. C'était un de ses amis, un grand personnage et un fidèle du roi: il était gouverneur de la province au-delà de l'Euphrate."
,"9":"Le roi l'envoya avec Alkime, cet homme impie qu'il nomma grand-prêtre, et il lui donna l'ordre de réprimer les Israélites."
,"10":"Ils se mirent donc en route et arrivèrent au pays de Juda avec une armée nombreuse. Ils envoyèrent à Judas et à ses frères des messagers avec de bonnes paroles, mais c'était un mensonge."
,"11":"Ceux-ci ne les crurent pas: ils voyaient bien que les autres étaient venus avec une puissante armée."
,"12":"Cependant il y eut une réunion de maîtres de la Loi avec Alkime et Bakidès pour chercher une solution juste."
,"13":"Les Assidéens étaient les premiers parmi les Israélites à demander la paix,"
,"14":"et ils se disaient: 'Un prêtre de la race d'Aaron est venu avec cette armée, il ne nous fera pas de mal.'"
,"15":"Il leur donna des paroles de paix et même il leur jura: 'Nous ne voulons pas vous faire de mal, pas plus qu'à vos amis.'"
,"16":"Ils le crurent, mais lui fit arrêter et mettre à mort soixante d'entre eux en un seul jour selon la parole de l'Ecriture:"
,"17":"Ils ont laissé à terre les corps de tes fidèles et répandu leur sang autour de Jérusalem, et personne ne leur a donné la sépulture."
,"18":"Alors tout le peuple fut pris de crainte et de peur, on disait: 'Ils n'ont pas de parole, aucun sens de la justice, car ils ont violé leur accord et le serment qu'ils avaient fait.'"
,"19":"Bakidès quitta Jérusalem et vint camper à Beth-Zeth; de là il envoya arrêter un certain nombre de personnes importantes qui étaient passées de son côté, et avec eux quelques-uns du peuple; il les fit égorger et jeter dans un grand puits."
,"20":"Bakidès confia ensuite la province à Alkime, lui laissant des troupes pour l'épauler, après quoi il retourna près du roi."
,"21":"Alkime chercha à s'imposer comme grand prêtre,"
,"22":"et tous ceux qui mettaient la pagaille dans le pays se groupèrent autour de lui. Ils se rendirent maîtres du pays de Juda et firent beaucoup de mal en Israël."
,"23":"Judas vit qu'Alkime et ses partisans faisaient encore plus de tort aux Israélites que les païens."
,"24":"Aussi se mit-il à parcourir toute la Judée pour tirer vengeance de ceux qui étaient passés à l'ennemi et les empêcher de circuler dans le pays."
,"25":"Alkime s'aperçut que Judas et ses partisans allaient se renforçant: il comprit qu'il ne pourrait leur résister. Il retourna donc chez le roi et les accusa des pires crimes."
,"26":"Le roi aussitôt envoya Nicanor, un de ses plus illustres généraux, qui de plus n'avait que de la haine et du mépris pour Israël. Il lui ordonna d'exterminer le peuple."
,"27":"Nicanor arriva donc à Jérusalem avec une nombreuse armée. Il fit porter à Judas et à ses frères de bonnes paroles: "
,"28":"'Ne nous faisons pas la guerre, je viendrai à votre rencontre dans un esprit de paix avec une petite escorte.' Ce n'était qu'une ruse."
,"29":"Il arriva donc chez Judas et ils se saluèrent l'un et l'autre pacifiquement, mais les ennemis étaient prêts à enlever Judas."
,"30":"Judas se rendit compte que Nicanor était venu chez lui avec de mauvaises intentions, il se méfia de lui et refusa de le recevoir de nouveau."
,"31":"Voyant que son projet était découvert, Nicanor s'avança pour livrer combat à Judas près de Cafarsalama."
,"32":"Nicanor perdit cinq cents hommes, et les autres se réfugièrent dans la cité de David."
,"33":"A la suite de cela, Nicanor monta au mont Sion; des prêtres sortirent du Lieu Saint avec les anciens du peuple, pour le saluer pacifiquement et lui montrer l'holocauste que l'on offrait pour le roi."
,"34":"Mais Nicanor se moqua d'eux, il les tourna en ridicule, il les méprisa en multipliant les insultes."
,"35":"Au comble de la colère, il fit ce serment: 'Si Judas cette fois-ci n'est pas livré entre mes mains avec son armée, je brûlerai ce Temple lorsque je reviendrai vainqueur.' Il partit très en colère."
,"36":"Les prêtres en le quittant allèrent se tenir devant l'autel. Devant le Temple ils se mirent à pleurer:"
,"37":"'C'est toi qui as choisi cette maison pour qu'elle porte ton Nom, pour qu'elle soit pour ton peuple une maison de prière et de supplication."
,"38":"Venge-toi sur cet homme et sur son armée, qu'il tombe sous l'épée. Souviens-toi de leurs insultes et ne leur accorde pas de pitié.'"
,"39":"Nicanor sortit donc de Jérusalem. Il installa son camp à Beth-Horon, et l'armée de Syrie vint l'y rejoindre."
,"40":"Judas, de son côté, campa à Adasa avec trois mille hommes. Il fit cette prière:"
,"41":"'Lorsque les messagers du roi ont blasphémé, ton ange est sorti et en a frappé cent quatre-vingt-cinq mille."
,"42":"De même aujourd'hui écrase devant nous cette armée, et tous sauront que ses insultes contre ton Sanctuaire lui ont porté malheur. Juge-le selon sa méchanceté.'"
,"43":"Les armées engagèrent la bataille le treize du mois d'Adar; l'armée de Nicanor fut écrasée et lui-même tomba l'un des premiers dans la bataille."
,"44":"Lorsque les soldats de Nicanor virent qu'il était tombé, ils jetèrent leurs armes et prirent la fuite."
,"45":"Les Juifs les poursuivirent toute la journée, depuis Adasa jusqu'aux abords de Gazer, et tout en les poursuivant, ils sonnaient de la trompette de toutes leurs forces."
,"46":"De tous les villages de Judée on sortait pour encercler les fuyards et on les obligeait à s'arrêter pour se défendre; ainsi tous tombèrent par l'épée et pas un seul n'échappa."
,"47":"On ramassa leurs dépouilles et tout ce qu'on trouva; on coupa la tête de Nicanor et la main droite qu'il avait levée dans son insolence, et on les apporta à Jérusalem où elles furent exposées."
,"48":"Le peuple était dans la joie et ce jour-là on fit une grande fête;"
,"49":"on décida que ce jour serait célébré chaque année, le treize du mois d'Adar."
,"50":"Après cela le pays de Juda eut la paix pour quelque temps."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Judas entendit alors parler des Romains. 'Ils sont puissants, lui dit-on, compréhensifs envers tous ceux qui prennent leur parti, ils offrent leur amitié à ceux qui s'adressent à eux. De plus, ce sont de vaillants guerriers.'"
,"2":"On raconta à Judas leurs guerres et leurs exploits chez les Gaulois, comment ils s'étaient rendus maîtres de ce peuple et l'avaient contraint à payer l'impôt."
,"3":"On lui raconta également tout ce qu'ils avaient fait en Espagne pour s'emparer des mines d'argent et d'or de ce pays,"
,"4":"comment ils étaient venus à bout par leur intelligence et leur persévérance de tout ce pays qui était pourtant fort éloigné de chez eux; ils avaient de même écrasé tous les rois qui étaient venus des extrémités de la terre pour les attaquer, ils leur avaient infligé une grande défaite, de sorte que les survivants leur payaient chaque année un impôt."
,"5":"Enfin ils avaient triomphé par les armes de Philippe, puis de Persée roi des Kittim, et de ceux qui s'étaient dressés contre eux: ils les avaient tous soumis."
,"6":"Antiocus le Grand, roi d'Asie, s'était avancé pour les combattre avec cent vingt éléphants, des chevaux, des chars et une immense armée, mais il avait été complètement battu par eux."
,"7":"Ils l'avaient même pris vivant, ils lui avaient imposé ainsi qu'à ses successeurs un lourd impôt qu'ils devaient payer à date fixe, et la livraison d'otages."
,"8":"On lui avait enlevé le pays indien, la Médie, la Lydie et plusieurs de ses plus belles provinces que l'on avait données au roi Eumène."
,"9":"Les Grecs voulaient se débarrasser des Romains."
,"10":"Lorsque ceux-ci l'avaient appris, ils avaient envoyé contre eux un seul général; il les avait battus, faisant de très nombreuses victimes. Les Romains avaient alors emmené en captivité les femmes et les enfants, ils avaient pillé leurs biens et soumis leur pays, détruit leurs forteresses et réduit en esclavage beaucoup de gens qui y sont encore aujourd'hui."
,"11":"Les autres royaumes et les îles qui avaient résisté, avaient été détruits et soumis par les Romains."
,"12":"'Mais, lui dit-on, ils gardent leur amitié à ceux qui leur sont fidèles et leur font confiance; comme ils ont soumis les rois proches ou lointains, tous ceux qui entendent parler d'eux les redoutent."
,"13":"Ceux qu'ils soutiennent et veulent faire régner, règnent, et ils changent ceux qu'ils veulent changer; leur puissance est considérable."
,"14":"Malgré cela, aucun parmi eux n'a pris la couronne ou revêtu le manteau royal pour en tirer gloire."
,"15":"Ils ont institué un conseil de trois cent vingt membres qui chaque jour délibère sur les affaires du peuple pour que tout soit en ordre."
,"16":"Chaque année ils confient à un seul homme l'autorité et le pouvoir sur tout le pays; tous obéissent à ce seul homme et entre eux il n'y a ni envie ni jalousie.'"
,"17":"Judas choisit donc Eupolème fils de Jean, de la famille d'Akkos, et Jason fils d'Eléazar; il les envoya à Rome pour faire avec les Romains un traité d'alliance et d'amitié."
,"18":"Il voyait là le moyen de briser le joug des Grecs, puisque ceux-ci réduisaient Israël à l'esclavage."
,"19":"Au bout d'un très long voyage, ils arrivèrent à Rome, entrèrent au sénat et parlèrent ainsi:"
,"20":"'Judas, surnommé Maccabée, ses frères et le peuple Juif, nous ont envoyés vers vous pour faire avec vous un traité d'alliance et de paix. Nous voulons compter parmi vos alliés et amis.'"
,"21":"Cette demande plut aux sénateurs."
,"22":"Voici donc la copie de la lettre qu'ils écrivirent sur des tablettes de bronze et qu'ils envoyèrent à Jérusalem comme document de paix et d'alliance avec les Juifs:"
,"23":"'Que les Romains et la nation des Juifs aient la paix sur mer et sur terre à jamais! Que le glaive et l'ennemi s'éloignent d'eux!"
,"24":"S'il survient une guerre à Rome ou chez l'un de ses alliés, partout où s'étend sa puissance,"
,"25":"la nation des Juifs combattra sincèrement à leurs côtés selon ce que les circonstances lui indiqueront."
,"26":"Ils ne donneront et ne fourniront ni blé, ni armes, ni argent, ni bateaux à ses adversaires, suivant en cela les décisions de Rome: ils seront fidèles à leurs engagements sans recevoir de paiement."
,"27":"De même, s'il survient une guerre à la nation des Juifs, les Romains combattront sincèrement à ses côtés selon ce que les circonstances leur indiqueront."
,"28":"Ils ne donneront ni blé, ni armes, ni argent, ni bateaux aux ennemis: c'est ainsi que Rome en a décidé, ils seront fidèles à leurs promesses sans autre paiement."
,"29":"Ceci est l'accord que les Romains ont conclu avec le peuple Juif."
,"30":"Si dans la suite les uns et les autres veulent ajouter ou retrancher quelque chose, ils le feront en toute liberté et ce qu'ils auront ajouté ou retranché aura force de loi."
,"31":"Quant aux maux que le roi Démétrius a causés aux Juifs, nous lui avons écrit ceci: Pourquoi opprimes-tu les Juifs? Ce sont nos amis et nos alliés!"
,"32":"S'ils t'accusent de nouveau, nous soutiendrons leurs droits et nous te combattrons sur mer et sur terre.'"
}`)
	CurrentBook.AddChapter(9, `{
"1":"Lorsque Démétrius apprit que Nicanor était tombé avec ses hommes au cours du combat, il envoya de nouveau Bakidès et Alkime à la tête de l'aile droite de l'armée, dans le pays de Juda."
,"2":"Ils prirent la route de la Galilée et mirent le siège devant Mésalot, dans le territoire d'Arbèles; ils s'en emparèrent et massacrèrent beaucoup de ses habitants."
,"3":"Le premier mois de l'an cent cinquante-deux, ils établirent leur camp en face de Jérusalem,"
,"4":"puis ils partirent pour Bérée; ils avaient avec eux vingt mille fantassins et deux mille cavaliers."
,"5":"Judas, de son côté, avait dressé son camp à Eléasa, il avait avec lui trois mille soldats parmi les meilleurs."
,"6":"Lorsqu'ils virent que les ennemis étaient si nombreux, ils furent effrayés et beaucoup s'enfuirent du camp: il n'en resta que huit cents."
,"7":"Judas vit que son armée se dispersait alors qu'il ne pouvait refuser le combat; il fut consterné car il n'avait plus le temps de rassembler les fuyards."
,"8":"Malgré cela, il dit à ceux qui étaient restés avec lui: 'Debout! Marchons contre nos ennemis et nous verrons bien si nous pouvons les vaincre!'"
,"9":"Ses compagnons essayèrent de le détourner, ils lui disaient: 'Pour le moment nous ne pouvons rien faire d'autre que sauver notre vie. Nous reviendrons ensuite reprendre la lutte avec nos frères, mais nous sommes vraiment trop peu nombreux.'"
,"10":"Judas leur répondit: 'Je n'agirai pas ainsi, que Dieu me garde de fuir devant eux! Si notre heure est arrivée, mourons comme des braves pour nos frères, mais ne faisons rien qui puisse salir notre honneur.'"
,"11":"L'armée sortit de son camp pour les affronter, ils partagèrent la cavalerie en deux; les frondeurs et les archers marchaient sur le devant et les premiers rangs de l'armée étaient formés des plus courageux."
,"12":"Bakidès était avec l'aile droite, les fantassins s'avançaient des deux côtés au son de la trompette. Ceux qui étaient avec Judas sonnèrent également de la trompette,"
,"13":"et la terre fut comme ébranlée par le cri des armées. Le combat s'engagea au matin et il dura jusqu'au soir."
,"14":"Judas vit que Bakidès et les plus solides de ses troupes se trouvaient à droite; avec les plus courageux, qui se rassemblèrent autour de lui,"
,"15":"ils enfoncèrent l'aile droite de Bakidès et la poursuivirent jusqu'au mont Azara."
,"16":"Mais en voyant l'aile droite enfoncée, les Syriens qui formaient l'aile gauche se lancèrent derrière Judas et ses compagnons et les prirent à revers."
,"17":"Le combat devint acharné et beaucoup tombèrent dans les deux camps;"
,"18":"Judas tomba lui aussi et le reste de ses hommes s'enfuit."
,"19":"Jonathan et Simon emportèrent le corps de leur frère Judas et l'ensevelirent dans le tombeau de ses pères à Modin."
,"20":"Tout Israël le pleura et fit un grand deuil sur lui, répétant pendant plusieurs jours cette lamentation:"
,"21":"'Comment est-il tombé, le héros qui sauvait Israël?'"
,"22":"Le reste des actions de Judas, ses guerres, ses actes courageux et ses titres de gloire n'ont pas été écrits car il y en avait trop."
,"23":"Après la mort de Judas, les hors-la-loi se manifestèrent sur tout le territoire d'Israël, et tous ceux qui faisaient le mal réapparurent."
,"24":"En ces jours-là une grande famine sévit dans tout le pays et les gens passèrent de l'autre côté."
,"25":"Bakidès choisit donc des hommes sans foi ni loi pour gouverner le pays."
,"26":"Ils soumirent les partisans de Judas à des perquisitions et des enquêtes, ils les faisaient comparaître devant Bakidès qui les punissait et les humiliait."
,"27":"Israël connut une oppression si terrible qu'il n'y en avait pas eu de pareille depuis la fin du temps des prophètes."
,"28":"Alors tous les partisans de Judas se rassemblèrent, ils dirent à Jonathan:"
,"29":"'Depuis la mort de ton frère Judas, nous n'avons plus un homme de sa valeur pour faire la guerre à nos ennemis, aux gens de Bakidès et à tous ceux qui détestent notre nation."
,"30":"C'est pourquoi nous t'avons choisi pour le remplacer à notre tête comme chef et comme général; tu conduiras nos combats.'"
,"31":"Et à partir de ce moment-là Jonathan prit le commandement et la succession de Judas son frère."
,"32":"Bakidès apprit la chose et il chercha à faire mourir Jonathan."
,"33":"Lorsqu'ils le surent, Jonathan, son frère Simon et tous leurs compagnons, s'enfuirent au désert de Tékoa et campèrent près de la Citerne d'Asfar."
,"34":"Le jour du sabbat Bakidès l'apprit, et il traversa lui aussi le Jourdain avec toute son armée."
,"35":"Jonathan envoya son frère, qui avait un commandement dans l'armée, chez ses amis les Nabatéens; il voulait déposer chez eux ses bagages qui étaient considérables."
,"36":"Mais les gens de Médaba, les Yambrites, sortirent pour s'emparer de Jean et de tout ce qu'il avait, puis ils prirent la fuite avec leur butin."
,"37":"Un peu plus tard Jonathan et son frère Simon apprirent que les Yambrites célébraient un grand mariage et amenaient en grand cortège depuis Nabatha la fiancée; c'était la fille d'un des principaux personnages de Canaan."
,"38":"Ils se rappelèrent alors le meurtre de leur frère Jean, et ils montèrent se cacher dans la montagne."
,"39":"Ils aperçurent bientôt une foule nombreuse et bruyante, puis le fiancé avec ses amis et ses frères qui s'avançaient à la tête d'un cortège avec des tambourins, des musiques et de riches vêtements militaires."
,"40":"Les Juifs, du haut de leur embuscade, se jetèrent sur eux et les massacrèrent; ils tuèrent beaucoup de monde tandis que les survivants s'enfuyaient vers la montagne. Toutes leurs dépouilles furent emportées."
,"41":"Ainsi les noces se changèrent en deuil et les joyeuses musiques en lamentations."
,"42":"Ils vengèrent ainsi le sang de leur frère, puis ils regagnèrent les rives marécageuses du Jourdain."
,"43":"C'est cela même que Bakidès avait appris; il s'avança donc le jour du sabbat jusqu'aux berges du Jourdain avec une armée nombreuse."
,"44":"Jonathan dit alors à ses hommes: 'Debout, défendons-nous, car aujourd'hui ce ne sera pas comme les autres fois!"
,"45":"Le combat est là devant nous, et derrière nous c'est l'eau du Jourdain: le marécage ou le fourré, il n'y a pas de chemin pour battre en retraite."
,"46":"Maintenant donc, criez vers le Ciel pour qu'il vous sauve de vos ennemis!'"
,"47":"La bataille commença et Jonathan étendit la main pour frapper Bakidès, mais celui-ci échappa en se jetant en arrière."
,"48":"Jonathan et ses compagnons sautèrent dans le Jourdain et rejoignirent l'autre rive à la nage, mais les ennemis ne franchirent pas le fleuve à leur suite."
,"49":"Ce jour-là environ mille hommes tombèrent du côté de Bakidès."
,"50":"Bakidès revint à Jérusalem et il se mit à construire des forteresses en Judée: Jéricho, Emmaüs, Beth-Horon, Béthel, Tamnatha, Faraton et Téfon. Il y fit de grands remparts avec des portes garnies de verrous."
,"51":"Dans chacune d'elles il laissa une garnison pour maintenir la répression contre Israël."
,"52":"Il fortifia Beth-Sour, Gazer et la Citadelle, il y mit des hommes armés avec des vivres en réserve."
,"53":"Il prit des otages, les fils des chefs du pays, et les fit placer sous bonne garde dans la Citadelle de Jérusalem."
,"54":"Au deuxième mois de l'an cent cinquante-trois, Alkime donna l'ordre d'abattre le mur de la cour intérieure du sanctuaire qui avait été édifié par des prophètes. Lorsqu'on commençait à le démolir,"
,"55":"Alkime eut une attaque et ses projets en restèrent là. Il avait la bouche paralysée et ne pouvait plus prononcer un seul mot, ni donner des ordres au sujet de sa maison."
,"56":"Alkime mourut ainsi dans de grandes souffrances."
,"57":"Voyant qu'Alkime était mort, Bakidès retourna auprès du roi, si bien que le pays de Juda fut en paix pendant deux ans."
,"58":"Tous les hors-la-loi tinrent conseil, ils se dirent: 'Jonathan et les siens vivent maintenant en paix et en sécurité. Rappelons donc Bakidès pour qu'il les fasse tous arrêter en une seule nuit.'"
,"59":"Ils partirent le trouver et ils en discutèrent avec lui,"
,"60":"Bakidès se mit donc en route avec une forte troupe et il envoya en secret des lettres à tous ses partisans de Judée pour leur demander d'arrêter Jonathan et ses compagnons. Mais il n'eut pas de succès car les autres avaient eu connaissance de son projet."
,"61":"Jonathan et ses compagnons arrêtèrent dans le pays une cinquantaine d'hommes qui étaient à l'origine de ce projet criminel, et ils les mirent à mort."
,"62":"Jonathan et Simon se retirèrent ensuite avec leurs partisans dans le désert à Beth-Bassi. Ils réparèrent cette ville en ruine et la fortifièrent."
,"63":"Lorsque Bakidès l'apprit, il réunit tous ses hommes et fit appel à ses partisans de Judée."
,"64":"Il établit son camp près de Beth-Bassi et durant de longs jours il fit construire des machines pour l'attaquer."
,"65":"Jonathan laissa son frère Simon dans la ville; il en sortait avec quelques hommes pour faire des expéditions aux alentours."
,"66":"Il attaqua le campement d'Odoméra et de ses frères, et celui des fils de Fasiron. Les ennemis se décidèrent à frapper eux aussi, et ils montèrent avec leurs troupes."
,"67":"De leur côté, Simon et ses hommes firent une sortie et brûlèrent les machines de siège."
,"68":"Ils attaquèrent ensuite Bakidès et lui infligèrent une telle défaite qu'il tomba dans un profond découragement parce que son plan et son attaque avaient échoué."
,"69":"Il se retourna plein de colère contre les mécréants qui lui avaient conseillé de venir dans le pays; il en massacra un grand nombre et décida de retourner chez lui avec ses gens."
,"70":"En apprenant cela, Jonathan lui envoya des hommes pour lui proposer la paix et le retour des prisonniers."
,"71":"Bakidès accepta et resta fidèle à sa promesse, il jura à Jonathan de ne plus chercher à lui faire du mal durant tout le reste de sa vie."
,"72":"Bakidès rendit les prisonniers qu'il avait faits auparavant dans le pays de Juda, puis il retourna chez lui pour ne plus jamais revenir dans le pays des Juifs."
,"73":"Il y eut un temps de paix en Israël, et Jonathan s'installa à Macmas d'où il jugea le peuple; il fit disparaître les impies du milieu d'Israël."
}`)
	CurrentBook.AddChapter(10, `{
"1":"En l'an cent soixante, Alexandre, fils d'Antiocus Epiphane, se mit en campagne et occupa Ptolémaïs. Il y fut bien reçu et il y commença son règne."
,"2":"Aussitôt connue la nouvelle, le roi Démétrius réunit une armée très puissante et partit en guerre contre lui."
,"3":"Démétrius envoya à Jonathan des lettres amicales où il lui promettait de le combler d'honneurs."
,"4":"Il se disait en effet: 'Faisons vite la paix avec ces hommes-là avant qu'ils ne la fassent avec Alexandre contre nous,"
,"5":"car sûrement Jonathan n'a pas oublié tout le mal que nous lui avons fait ainsi qu'à ses frères et à sa nation.'"
,"6":"Il donna même à Jonathan l'autorisation de lever une armée, de fabriquer des armes, de se présenter comme son allié, et il ordonna de lui rendre les otages enfermés dans la Citadelle."
,"7":"Jonathan arriva donc à Jérusalem et lut le message devant tout le peuple et devant les hommes de la Citadelle."
,"8":"Lorsqu'ils entendirent que le roi l'autorisait à lever des troupes, les gens de la Citadelle eurent grand peur."
,"9":"Ils rendirent donc les otages à Jonathan qui les rendit à leurs parents."
,"10":"Jonathan s'installa à Jérusalem et commença à rebâtir et à réparer la ville."
,"11":"Il donna en particulier des instructions aux entrepreneurs de travaux pour reconstruire le rempart et le pourtour du mont Sion avec des pierres de taille, pour que ce soit une défense; c'est ce que l'on fit."
,"12":"Les étrangers qui occupaient les forteresses construites par Bakidès prirent la fuite:"
,"13":"ils abandonnèrent leur poste et s'en retournèrent dans leur pays."
,"14":"A Beth-Sour cependant, on laissa quelques hommes qui avaient abandonné la Loi et les préceptes, on le considéra comme un lieu de refuge."
,"15":"Le roi Alexandre apprit les promesses que Démétrius avait faites à Jonathan; on lui raconta les guerres et les exploits dans lesquels lui et ses frères s'étaient distingués, ainsi que les épreuves qu'ils avaient endurées."
,"16":"Alors le roi s'écria: 'Trouverons-nous jamais un homme comme lui? Faisons de lui notre ami et notre allié.'"
,"17":"Il lui écrivit donc une lettre ainsi rédigée:"
,"18":"'Le roi Alexandre salue son frère Jonathan."
,"19":"On nous a fait savoir que tu es un homme de grande valeur, tu mérites de devenir notre ami."
,"20":"C'est pourquoi nous faisons de toi aujourd'hui le grand prêtre de ta nation, et nous te donnons le titre d'Ami du roi - en même temps il lui envoyait le manteau de pourpre et la couronne d'or - ainsi tu seras l'un des nôtres et tu nous garderas ton amitié.'"
,"21":"Voilà comment, au septième mois de l'an cent soixante, pour la fête des Tentes, Jonathan revêtit les habits sacrés; il rassembla des troupes et fabriqua beaucoup d'armes."
,"22":"Démétrius fut très contrarié de tout cela:"
,"23":"'Qu'avons-nous fait? dit-il, Alexandre a été plus vite que nous pour se gagner l'amitié des Juifs et renforcer sa position."
,"24":"Moi aussi je vais leur écrire et les persuader en leur offrant des honneurs et des bénéfices, pour qu'ils viennent à mon aide.'"
,"25":"Il leur écrivit donc ceci: 'Le roi Démétrius salue la nation des Juifs."
,"26":"Vous avez respecté les accords passés avec nous et vous nous avez gardé votre amitié au lieu de passer du côté de nos ennemis: nous l'avons appris et nous en sommes très heureux."
,"27":"Restez-nous donc fidèles et nous saurons récompenser ce que vous faites pour nous."
,"28":"Nous vous déchargerons de beaucoup d'obligations et nous vous ferons des faveurs."
,"29":"Dès aujourd'hui, je dispense tous les Juifs et je leur fais remise des impôts, des droits sur le sel et de la taxe royale."
,"30":"Le tiers des produits du sol et la moitié des fruits des arbres qui jusqu'ici me revenaient, je cesse de les prélever dès aujourd'hui et pour toujours dans le pays de Juda et les trois districts de la Samarie-Galilée qui lui sont annexés."
,"31":"Jérusalem sera une ville sainte, dispensée de dîmes et de droits de même que sa banlieue."
,"32":"Je renonce à la possession de la Citadelle de Jérusalem et je la donne au grand prêtre; il choisira lui-même les hommes chargés de la garder."
,"33":"Je rends la liberté sans rançon à toute personne d'origine juive emmenée en-dehors du pays de Juda et maintenant captive où que ce soit dans mon royaume. Tous seront dispensés d'impôts, même sur les bêtes."
,"34":"Je veux que toutes les fêtes, les sabbats, les nouvelles lunes, les jours fixés par la Loi et les trois jours qui précèdent et qui suivent, soient des jours où l'on remettra les dettes et les droits d'octroi pour tous les Juifs de mon royaume."
,"35":"Durant ces jours personne ne pourra exiger un paiement ou inquiéter un Juif pour quelque affaire que ce soit."
,"36":"Les armées royales recruteront parmi les Juifs jusqu'à trente mille soldats qui recevront la même solde que les autres troupes du roi."
,"37":"On en placera dans les forteresses royales les plus importantes, ainsi que dans les emplois de confiance du royaume. Ceux qui veilleront sur eux et leurs chefs sortiront de leurs rangs et vivront selon leur Loi, comme le roi en a donné l'ordre pour tout le pays de Juda."
,"38":"Les trois districts qui ont été rattachés à la Judée aux dépens de la province de Samarie seront annexés à la Judée; on les regardera comme relevant d'un seul homme, n'obéissant à personne d'autre que le grand prêtre."
,"39":"Je donne la ville de Ptolémaïs et le territoire qui s'y rattache au Temple de Jérusalem pour assurer les dépenses nécessitées par le culte."
,"40":"Personnellement je donnerai chaque année quinze mille pièces d'argent; on les prendra sur la part qui revient au roi dans des lieux à désigner."
,"41":"Les fonctionnaires donneront désormais pour les travaux du Temple tout le surplus qu'ils n'ont pas versé, comme dans les années précédentes."
,"42":"On prélevait autrefois chaque année sur les comptes et revenus du Temple cinq mille pièces d'argent; désormais cette redevance est abandonnée au profit des prêtres qui font le service liturgique."
,"43":"Si quelqu'un est poursuivi pour une dette envers le trésor royal ou pour toute autre dette, et s'il se réfugie dans Jérusalem ou dans ses limites, il sera libre ainsi que tous les biens qu'il possède dans mon royaume."
,"44":"Les dépenses nécessitées par les travaux de construction ou de restauration du Temple seront prélevées sur le compte du roi."
,"45":"On prélèvera encore sur le compte du roi l'argent nécessaire pour reconstruire les murs de Jérusalem, fortifier son enceinte et relever les remparts des villes de Judée.'"
,"46":"Lorsque Jonathan et le peuple entendirent ces paroles, ils ne les crurent pas et refusèrent de leur accorder confiance: ils se rappelaient trop bien le mal que Démétrius avait fait à Israël et comment il les avait opprimés."
,"47":"Ils choisirent le parti d'Alexandre car ils y voyaient plus d'avantages et ils furent ses fidèles alliés."
,"48":"Le roi Alexandre rassembla alors une grande armée et s'avança contre Démétrius;"
,"49":"les deux rois engagèrent la bataille et l'armée de Démétrius tourna le dos. Alexandre la poursuivit et prit l'avantage sur elle."
,"50":"Il combattit énergiquement jusqu'au coucher du soleil, et Démétrius fut tué ce même jour."
,"51":"Alors Alexandre envoya au roi d'Egypte, Ptolémée, des ambassadeurs pour lui dire:"
,"52":"'Je suis revenu dans mon royaume et je me suis assis sur le trône de mes pères. Je me suis emparé du pouvoir, j'ai écrasé Démétrius et j'ai pris possession de mon pays."
,"53":"En effet, je lui ai livré bataille et il ont été écrasés par nous, lui et son armée. Maintenant que je suis monté sur son trône royal,"
,"54":"faisons ensemble un traité d'amitié. Donne-moi ta fille comme épouse, je serai ton gendre et je te ferai comme à elle des cadeaux dignes de toi.'"
,"55":"Le roi Ptolémée répondit ainsi: 'Que le jour où tu es rentré dans le pays de tes pères et où tu as occupé le trône royal soit béni!"
,"56":"Je vais faire pour toi ce que tu m'as demandé, mais viens à ma rencontre à Ptolémaïs pour que nous nous voyions l'un l'autre, et ensuite je serai ton beau-père comme tu l'as dit.'"
,"57":"Ptolémée partit d'Egypte avec sa fille Cléopâtre, il arriva à Ptolémaïs en l'an cent soixante-deux."
,"58":"Le roi Alexandre vint à la rencontre de Ptolémée qui lui donna sa fille Cléopâtre, et l'on célébra le mariage à Ptolémaïs avec beaucoup de solennité, comme il convient à des rois."
,"59":"Le roi Alexandre écrivit à Jonathan de venir le retrouver,"
,"60":"Jonathan se rendit donc à Ptolémaïs en grand cortège. Il rencontra les deux rois, il leur donna ainsi qu'à leurs amis de l'argent et de l'or, il distribua de nombreux cadeaux et acquit leur faveur."
,"61":"Des renégats, la peste d'Israël, étaient venus en groupe pour se plaindre de lui, mais le roi ne leur prêta aucune attention."
,"62":"Il ordonna même de faire changer ses habits à Jonathan pour l'habiller de pourpre, ce que l'on fit."
,"63":"Le roi le fit ensuite asseoir près de lui et il dit à ses ministres: 'Allez avec lui en ville et proclamez bien ceci: Que personne ne vienne se plaindre de lui pour quelque affaire que ce soit et que personne ne lui cherche d'ennui pour aucune raison.'"
,"64":"Quand ses accusateurs virent les honneurs qu'on lui rendait et la pourpre royale sur ses épaules, quand ils entendirent la proclamation qui était faite, ils prirent tous la fuite."
,"65":"Le roi lui fit l'honneur de le compter parmi ses premiers Amis et il l'institua grand chef et gouverneur,"
,"66":"après quoi Jonathan revint tout joyeux à Jérusalem, sain et sauf."
,"67":"En l'an cent soixante-cinq, Démétrius fils de Démétrius arriva de Crète au pays de ses pères."
,"68":"Quand le roi Alexandre l'apprit, il fut très contrarié et il rentra à Antioche."
,"69":"Démétrius confirma Apollonius dans la charge de gouverneur de Coelé-Syrie, et celui-ci rassembla une puissante armée. Il fit dresser son camp à Jamnia et envoya dire ceci au grand prêtre Jonathan:"
,"70":"'Veux-tu être le seul à prendre parti contre nous? Ne vois-tu pas qu'on se moque de moi et qu'on m'insulte à cause de toi? Pourquoi veux-tu commander seul sans nous dans tes montagnes?"
,"71":"Si tu es si confiant dans ton armée, descends donc vers nous dans la plaine, et là nous nous mesurerons, car j'ai avec moi l'armée des villes."
,"72":"Renseigne-toi et tu sauras qui je suis et qui sont ceux qui sont avec moi; on me dit que vous ne pourrez pas nous résister puisque par deux fois tes pères ont été mis en fuite dans leur propre pays."
,"73":"Maintenant tu ne pourras pas tenir devant ma cavalerie et une armée si puissante, dans cette plaine où il n'y a ni rocher, ni pierre, ni chemin, pour s'enfuir.'"
,"74":"Lorsque Jonathan entendit les paroles d'Apollonius, il fut très secoué. Il recruta dix mille hommes et partit de Jérusalem; son frère Simon vint le rejoindre et lui prêter main-forte."
,"75":"Il établit son camp en face de Joppé; les gens de la ville lui fermèrent leurs portes, car il y avait dans Joppé une garnison d'Apollonius. On attaqua la ville:"
,"76":"pris de peur, les habitants de Joppé ouvrirent les portes et Jonathan se rendit maître de la ville."
,"77":"Quand Apollonius apprit cela, il équipa trois mille cavaliers et une nombreuse infanterie et il prit la direction d'Azotos comme s'il voulait traverser le pays. Il s'enfonçait ainsi dans la plaine, confiant dans l'importance de sa cavalerie."
,"78":"Jonathan le poursuivit en direction d'Azotos et les deux armées engagèrent la bataille."
,"79":"Apollonius avait laissé mille cavaliers cachés derrière lui,"
,"80":"mais Jonathan apprit l'existence de cette embuscade dans son dos. Les cavaliers entourèrent son armée et lancèrent sur elle leurs flèches depuis le matin jusqu'au soir."
,"81":"L'armée résista comme Jonathan en avait donné l'ordre, pendant que les chevaux de l'ennemi se fatiguaient."
,"82":"Une fois la cavalerie épuisée, Simon lança ses troupes à l'attaque des bataillons. Les ennemis furent enfoncés et s'enfuirent"
,"83":"pendant que la cavalerie se dispersait dans la plaine. Les fuyards arrivèrent à Azotos et entrèrent dans Beth-Dagon, le temple de leur idole, pour y chercher refuge."
,"84":"Mais Jonathan incendia Azotos et les villes des environs; il ramassa tout sur le terrain et brûla le temple de Dagon avec tous ceux qui s'y étaient réfugiés."
,"85":"Le nombre de ceux qui étaient tombés sous l'épée ou avaient été brûlés atteignait les huit mille."
,"86":"Jonathan partit de là et dressa son camp près d'Ascalon; les habitants de cette ville sortirent à sa rencontre et le reçurent avec beaucoup d'égards."
,"87":"Jonathan revint ensuite à Jérusalem avec ses compagnons ramenant un immense butin."
,"88":"Lorsque le roi Alexandre apprit cela, il accorda de nombreux honneurs à Jonathan."
,"89":"Il lui envoya une agrafe d'or comme cela se fait pour les parents des rois, et il lui donna en propriété Akaron avec tous ses environs."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Le roi d'Egypte rassembla une armée aussi nombreuse que le sable qui est au bord des mers; il rassembla aussi beaucoup de bateaux, car il voulait s'emparer du royaume d'Alexandre par ruse, pour l'ajouter à son propre royaume."
,"2":"Il se mit en chemin pour la Syrie avec de très bons prétextes; les gens lui ouvraient les portes de leurs villes et venaient l'accueillir, parce que le roi Alexandre avait donné l'ordre de bien accueillir son beau-père."
,"3":"Mais aussitôt entré dans les villes, Ptolémée y installait ses propres soldats."
,"4":"Lorsqu'il approcha d'Azotos, on lui montra le temple de Dagon qui avait été incendié. Azotos et ses environs étaient ravagés, les corps gisaient sur le sol ainsi que les restes de ceux que Jonathan avait brûlés pendant la guerre; ils en avaient fait des tas sur le chemin que suivait le roi."
,"5":"Ils racontèrent au roi ce qu'avait fait Jonathan pour que celui-ci le condamne, mais le roi se taisait."
,"6":"Jonathan vint donc à la rencontre du roi à Joppé avec un beau cortège, ils échangèrent leurs saluts et dormirent en ce lieu."
,"7":"Jonathan accompagna le roi jusqu'au fleuve nommé Eleutère, puis il rentra à Jérusalem."
,"8":"De son côté, le roi Ptolémée se rendit maître des villes de la côte jusqu'à Séleucie-sur-Mer, avec de mauvaises intentions vis-à-vis d'Alexandre."
,"9":"Il envoya donc des ambassadeurs au roi Démétrius. Il lui faisait dire: 'Viens, faisons ensemble une alliance: je te donnerai la fille que j'avais précédemment donnée à Alexandre, et tu régneras sur le royaume de ton père."
,"10":"Je regrette en effet de lui avoir donné ma fille, car il a cherché à me tuer.'"
,"11":"Il lui faisait ces reproches, mais il cherchait simplement à s'emparer de son royaume."
,"12":"Quand il eut repris sa fille, qu'il donna à Démétrius, il changea d'attitude vis-à-vis d'Alexandre; désormais il était clair qu'ils étaient devenus ennemis."
,"13":"Ptolémée entra à Antioche et il se couronna roi d'Asie: il régnait désormais à la fois sur l'Egypte et sur l'Asie."
,"14":"Le roi Alexandre se trouvait alors en Cilicie, car les gens de cette région s'étaient révoltés."
,"15":"Apprenant tout cela, Alexandre s'avança pour livrer bataille à Ptolémée; de son côté Ptolémée se mit en route et marcha à sa rencontre avec une puissante armée qui le mit en fuite."
,"16":"Alexandre courut se réfugier en Arabie pendant que le roi Ptolémée triomphait."
,"17":"Sur ce l'Arabe Zabdiel trancha la tête d'Alexandre et l'envoya à Ptolémée."
,"18":"Mais voilà que le roi Ptolémée mourut le surlendemain et les Egyptiens qui occupaient les villes fortifiées furent massacrés par leurs habitants."
,"19":"Démétrius devint donc roi en l'an cent soixante-sept."
,"20":"En ces jours-là Jonathan réunit les gens de Judée pour attaquer la Citadelle de Jérusalem, il fit dresser contre elle de nombreuses machines de guerre."
,"21":"Alors un certain nombre de renégats, qui haïssaient leur nation, allèrent trouver le roi pour l'avertir que Jonathan assiégeait la Citadelle."
,"22":"Le roi aussitôt fut très en colère. A peine fut-il au courant qu'il se mit en route et vint à Ptolémaïs. Il écrivit à Jonathan de cesser le siège et de venir au plus tôt le trouver à Ptolémaïs pour parler avec lui."
,"23":"Après avoir reçu cette lettre, Jonathan ordonna tout d'abord de poursuivre le siège. Puis il choisit quelques compagnons, des anciens d'Israël et des prêtres, et il n'eut pas peur d'affronter personnellement le danger."
,"24":"Il emporta avec lui de l'argent, de l'or, des vêtements et beaucoup d'autres cadeaux, il se rendit auprès du roi à Ptolémaïs et gagna sa faveur."
,"25":"Quelques renégats de son peuple l'accusèrent de toutes sortes de choses,"
,"26":"mais le roi se comporta avec lui comme ses prédécesseurs, il lui fit honneur en présence de tous ses Amis."
,"27":"Il le confirma dans la charge de grand prêtre, dans toutes les autres distinctions qu'il avait reçues et le fit mettre au nombre des premiers amis du roi."
,"28":"Jonathan demanda au roi de dispenser d'impôts la Judée et les trois districts de Samarie; il lui promit en retour trois cents talents d'argent."
,"29":"Le roi accepta et fit rédiger une lettre en ces termes:"
,"30":"'Le roi Démétrius salue son frère Jonathan et la nation des Juifs."
,"31":"Vous trouverez ici la copie de la lettre que nous avons écrite à votre sujet à notre parent Lastène. Prenez-en connaissance:"
,"32":"Le roi Démétrius salue Lastène, son père!"
,"33":"Nous voulons faire du bien à la nation des Juifs, vu leurs bons sentiments envers nous. Ils sont nos amis et se sont comportés avec droiture envers nous."
,"34":"Nous confirmons leur autorité sur la Judée et les trois districts d'Aféréna, de Lydda et de Ramataïm; ils ont été retirées à la Samarie et annexés à la Judée avec tous leurs environs au profit de tous ceux qui sacrifient à Jérusalem. En échange nous recevrons les taxes royales que le roi percevait autrefois chaque année sur les produits de la terre et les fruits des arbres."
,"35":"Mais nous les dispensons complètement des dîmes et des impôts qui nous reviennent sur les marais salants ainsi que les autres taxes royales."
,"36":"On ne remettra plus jamais en question ces privilèges."
,"37":"Veillez donc à en faire une copie qui sera donnée à Jonathan et placée sur la Montagne Sainte en un lieu bien visible.'"
,"38":"Le roi Démétrius vit que le pays était en paix et qu'il n'avait plus à redouter aucune opposition; il renvoya toutes ses troupes et chacun rentra chez soi à l'exception des troupes étrangères qu'il avait recrutées dans des îles lointaines. Il s'attira ainsi la haine de toutes les troupes dont il avait hérité."
,"39":"Voyant que toute l'armée murmurait contre Démétrius, Tryphon, qui avait pris autrefois le parti d'Alexandre, alla trouver Imalkoué, l'Arabe qui élevait Antiocus, le jeune fils d'Alexandre."
,"40":"Il l'amena à lui livrer l'enfant pour le faire régner à la place de son père; il lui raconta tout ce que Démétrius avait fait, la haine de ses troupes contre lui et il resta là de longs jours."
,"41":"Au même moment Jonathan envoyait demander au roi Démétrius de faire sortir les troupes de la Citadelle de Jérusalem et des autres forteresses, car elles étaient toujours en guerre avec Israël."
,"42":"Démétrius lui envoya cette réponse: 'Je ne me contenterai pas de faire cela pour toi et pour ta nation, je veux te combler d'honneurs ainsi que ta nation dès que j'en aurai l'occasion."
,"43":"Pour le moment tu ferais bien d'envoyer des troupes à mon aide, car toutes mes armées m'ont abandonné.'"
,"44":"Jonathan lui envoya à Antioche trois mille hommes d'élite et le roi fut tout heureux de les voir arriver."
,"45":"Près de cent vingt mille habitants se rassemblèrent au centre de la ville avec l'intention de tuer le roi."
,"46":"Le roi s'était réfugié dans le palais. Les habitants occupèrent les rues de la ville et commencèrent l'attaque."
,"47":"Alors le roi appela à son secours les Juifs. Ils se regroupèrent tous autour de lui, puis ils se répandirent à travers la ville; ils massacrèrent ce jour-là près de cent mille hommes."
,"48":"Ils incendièrent la ville et ramassèrent ce jour-là un butin considérable: ils avaient délivré le roi."
,"49":"Quand les habitants virent les Juifs maîtres de la ville, ils perdirent toute assurance et se tournèrent vers le roi avec des cris suppliants:"
,"50":"'Tends-nous la main et que les Juifs cessent de lutter contre nous et contre la ville!'"
,"51":"Ils jetèrent leurs armes et firent la paix; ce fut une grande gloire pour les Juifs aux yeux du roi et aux yeux de tous les habitants de son royaume. Ils retournèrent ainsi à Jérusalem porteurs d'un riche butin;"
,"52":"le trône royal de Démétrius fut affermi et le pays fut en paix sous son autorité."
,"53":"Mais alors il manqua à toutes ses promesses. Il changea d'attitude envers Jonathan, il oublia les services qu'il lui avait rendus et l'humilia de mille façons."
,"54":"Tryphon revint alors, ramenant avec lui Antiocus qui était encore un jeune enfant; il le proclama roi et lui remit la couronne."
,"55":"Toutes les troupes que Démétrius avait renvoyées se rassemblèrent autour de lui, elles combattirent Démétrius qui prit la fuite et fut écrasé."
,"56":"Tryphon s'empara des éléphants et occupa Antioche."
,"57":"Alors le jeune Antiocus écrivit cette lettre à Jonathan: 'Je te confirme dans la charge de grand prêtre, je t'établis sur les quatre provinces et je te compte au nombre des Amis du roi.'"
,"58":"En même temps il lui envoya des vases d'or, un service de table avec l'autorisation de boire dans une coupe d'or, de s'habiller de pourpre et de porter une agrafe d'or."
,"59":"Il établit son frère Simon comme général depuis l'Echelle de Tyr jusqu'aux frontières de l'Egypte."
,"60":"Jonathan partit alors et se mit à parcourir le pays et les villes au-delà du Fleuve. Toutes les troupes de Syrie se rassemblèrent autour de lui pour combattre derrière lui. Il arriva à Ascalon où les habitants le reçurent magnifiquement."
,"61":"De là il se rendit à Gaza, mais Gaza lui ferma ses portes; il l'assiégea et livra ses environs au feu et au pillage."
,"62":"Alors les habitants de Gaza supplièrent Jonathan qui leur accorda la paix; il prit cependant les fils de leurs chefs en otages et les envoya à Jérusalem. C'est ainsi qu'il parcourut toute la région jusqu'à Damas."
,"63":"Jonathan apprit que les généraux de Démétrius étaient à Quédesh de Galilée avec une nombreuse armée, bien décidés à l'écarter de sa charge."
,"64":"Il marcha donc à leur rencontre après avoir confié le pays à son frère Simon."
,"65":"Simon s'avança vers Beth-Sour, il y mit le siège et y enferma les habitants."
,"66":"Ils lui demandèrent alors la paix qu'il leur accorda, mais il les fit sortir de la ville et, après en avoir pris possession, il y plaça une garnison."
,"67":"Jonathan et son armée campèrent près des eaux de Gennésar et au matin ils arrivèrent dans la plaine d'Azor."
,"68":"L'armée des étrangers s'avançait au-devant de lui dans la plaine, mais elle avait envoyé des troupes dans les montagnes pour prendre à revers Jonathan; pendant ce temps les autres marchaient droit sur les Juifs."
,"69":"Lorsque les hommes de l'embuscade sortirent de leur cachette et engagèrent le combat,"
,"70":"tous ceux qui entouraient Jonathan prirent la fuite, sauf ses deux généraux, Mattathias fils d'Absalom, et Judas fils de Chalfi."
,"71":"Alors Jonathan déchira ses vêtements, il répandit de la poussière sur sa tête et pria."
,"72":"Il repartit ensuite au combat, les fit reculer et les mit en fuite."
,"73":"A cette vue, ses hommes qui s'étaient enfuis revinrent près de lui, et ensemble ils poursuivirent l'ennemi jusqu'à Quédesh, où se trouvait son camp; eux-mêmes établirent leur camp en ce lieu."
,"74":"L'armée des étrangers perdit trois mille hommes ce jour-là; quant à Jonathan, il revint à Jérusalem."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Quand il vit que les choses tournaient à son avantage, Jonathan choisit des hommes qu'il envoya à Rome pour confirmer et renouveler l'amitié avec les Romains."
,"2":"Il envoya des lettres semblables à Sparte et dans d'autres villes."
,"3":"Ses envoyés se rendirent donc à Rome, ils entrèrent au Sénat et dirent: 'Jonathan, le grand prêtre, et la nation des Juifs, nous ont envoyés pour renouveler l'amitié et l'alliance que vous avez établies avec eux précédemment.'"
,"4":"Le Sénat leur donna des lettres de recommandation pour que, dans chaque pays, on les achemine en paix jusqu'au pays de Juda."
,"5":"Et voici la copie de la lettre que Jonathan écrivit aux gens de Sparte:"
,"6":"'Jonathan, le grand prêtre, le Sénat de la nation, les prêtres et le reste du peuple Juif saluent les habitants de Sparte, leurs frères."
,"7":"Déjà dans les temps passés une lettre a été envoyée au grand prêtre Onias de la part de votre roi Areios; elle affirmait que vous êtes bien nos frères comme le montre la copie qui suit."
,"8":"Onias accueillit avec honneur l'homme qui lui était envoyé, il reçut la lettre où il était clairement parlé d'alliance et d'amitié."
,"9":"Nous ne voulons pas aujourd'hui vous supplier à ce sujet, car les livres saints qui sont entre nos mains sont notre réconfort."
,"10":"Mais nous ne voudrions pas devenir des étrangers pour vous, et nous avons voulu réaffirmer notre fraternité et notre amitié, car bien des années se sont écoulées depuis que nous vous avons envoyé une lettre."
,"11":"Nous ne cessons de penser à vous en tous temps, dans nos fêtes et nos autres jours saints, dans les sacrifices que nous offrons et dans nos prières, comme il est juste et convenable de le faire pour des frères."
,"12":"Nous sommes heureux de votre réussite!"
,"13":"Pour nous, ce sont les épreuves et les guerres continuelles qui nous ont accablés, car les rois qui nous entourent nous ont combattus."
,"14":"A l'occasion de ces guerres, nous n'avons voulu être à charge, ni à vous, ni à nos autres alliés et amis,"
,"15":"et de fait le secours du Ciel nous est venu en aide, nous avons été délivrés et nos ennemis ont été humiliés."
,"16":"C'est pourquoi nous avons choisi Nouménios fils d'Antiocos, et Antipater fils de Jason, les mêmes que nous avons envoyés aux Romains pour renouveler avec eux l'amitié et l'alliance d'autrefois."
,"17":"Nous leur avons demandé d'aller aussi chez vous pour vous saluer et vous apporter cette lettre pour réaffirmer notre fraternité."
,"18":"Maintenant, ayez la bonté de nous répondre à ce sujet.'"
,"19":"Voici maintenant la copie de la lettre qui avait été envoyée à Onias:"
,"20":"'Aréios, roi des Spartiates, salue Onias le grand prêtre!"
,"21":"On a découvert dans un écrit que les Spartiates et les Juifs sont frères: ils sont de la race d'Abraham."
,"22":"Maintenant que nous savons cela, vous ferez bien de nous écrire pour nous dire si tout va bien pour vous."
,"23":"De notre côté nous vous écrivons ceci: vos troupeaux et vos biens sont à nous et les nôtres sont à vous. Nous avons donc donné des ordres pour vous le faire savoir.'"
,"24":"Jonathan apprit que les généraux de Démétrius étaient revenus l'attaquer avec une armée plus forte encore qu'auparavant."
,"25":"Il partit donc de Jérusalem et marcha à leur rencontre jusqu'au pays de Hamat: ainsi il ne leur donnait pas le temps d'envahir son territoire."
,"26":"Il envoya des espions dans leur camp et à leur retour ils l'informèrent que les Syriens faisaient des préparatifs pour le surprendre pendant la nuit."
,"27":"Aussi, lorsque le soleil fut couché, Jonathan ordonna à ses hommes de veiller et de se tenir en armes toute la nuit, prêts au combat, et il mit en place des postes avancés tout autour du camp."
,"28":"Quand les ennemis apprirent que Jonathan et les siens étaient prêts à combattre, ils furent pris de peur et remplis d'épouvante; ils allumèrent des feux dans leur camp et prirent la fuite."
,"29":"Comme ils voyaient des feux allumés, Jonathan et ses hommes ne s'aperçurent qu'au matin de leur départ."
,"30":"Jonathan les poursuivit mais sans réussir à les rejoindre, car ils avaient traversé le fleuve Eleutère."
,"31":"Jonathan se retourna alors contre les Arabes appelés Zabadéens, il les battit et s'empara de leurs biens,"
,"32":"puis il leva le camp, arriva à Damas et parcourut toute la province."
,"33":"De son côté Simon s'était mis en route et s'était avancé jusqu'à Ascalon et aux forteresses voisines; ensuite il se retourna vers Joppé et l'occupa."
,"34":"Il avait appris en effet que les habitants de cette forteresse avaient l'intention de la livrer à Démétrius; il y mit une garnison pour garder la ville."
,"35":"De retour à Jérusalem, Jonathan convoqua les anciens du peuple et décida avec eux de construire des forteresses en Judée,"
,"36":"de rehausser les murs de Jérusalem et de bâtir un rempart élevé entre la Citadelle et la ville pour l'isoler de la ville et pour que ses occupants ainsi isolés, ne puissent plus ni acheter ni vendre."
,"37":"Ils se réunirent pour reconstruire la ville car une partie du rempart vers le torrent qui se trouve à l'est était tombée. On remit à neuf le quartier appelé Chafénata."
,"38":"De son côté Simon reconstruisit Adida dans le Bas-Pays, il la fortifia et y plaça des portes garnies de verrous."
,"39":"Tryphon voulait régner sur l'Asie, se faire couronner, et mettre la main sur le roi Antiocus,"
,"40":"mais il craignait que Jonathan ne l'en empêche et ne lui fasse la guerre. C'est pourquoi Tryphon cherchait le moyen de mettre la main sur lui et de le faire mourir; il se mit ainsi en route et arriva à Beth-Shéan."
,"41":"Jonathan sortit au-devant de lui avec quarante mille hommes choisis parmi les meilleurs et il marcha vers Beth-Shéan."
,"42":"Quand Tryphon vit que Jonathan arrivait avec une forte armée, il n'osa pas mettre la main sur lui."
,"43":"Il le reçut donc avec honneur, il le recommanda à tous ses Amis, lui offrit des cadeaux et commanda à ses Amis et à ses soldats de lui obéir comme à lui-même."
,"44":"Il dit alors à Jonathan: 'Pourquoi as-tu fatigué tous ces hommes, alors qu'il n'y a entre nous aucune menace de guerre."
,"45":"Renvoie-les donc chez eux, gardes-en seulement quelques uns pour t'accompagner et viens avec moi à Ptolémaïs. Je remettrai cette ville entre tes mains ainsi que les autres forteresses, les autres troupes et tous les serviteurs du roi, puis je repartirai à Antioche car c'est pour cela que je suis venu.'"
,"46":"Jonathan lui fit confiance et fit comme il avait dit; il renvoya ses hommes qui retournèrent en Judée,"
,"47":"et il n'en garda près de lui que trois mille. Il en envoya deux mille en Galilée et n'en prit que mille pour l'accompagner."
,"48":"Mais Jonathan était à peine entré à Ptolémaïs que les habitants refermèrent les portes, mirent la main sur lui et tuèrent par l'épée tous ceux qui l'accompagnaient."
,"49":"Pendant ce temps, Tryphon envoyait une armée et des cavaliers en Galilée pour massacrer dans la Grande Plaine tous les hommes de Jonathan."
,"50":"Mais quand ceux-ci entendirent que Jonathan avait été pris et mis à mort avec tous ses compagnons, ils s'encouragèrent les uns les autres et firent la route en rangs serrés, prêts à combattre."
,"51":"En voyant qu'ils étaient décidés à défendre leur vie, ceux qui les poursuivaient firent demi-tour,"
,"52":"et c'est ainsi qu'ils rentrèrent tous sans difficulté au pays de Juda; ils pleurèrent Jonathan et ses compagnons et furent saisis d'une grande crainte. Tout Israël fit un grand deuil. "
,"53":"Toutes les nations d'alentour ne pensaient qu'à les éliminer; on y disait: 'Ils n'ont plus ni chef ni allié, attaquons-les maintenant et effaçons leur mémoire du milieu des hommes!'"
}`)
	CurrentBook.AddChapter(13, `{
"1":"Simon apprit que Tryphon avait réuni une grande armée pour envahir le pays de Juda et le dévaster."
,"2":"Comme il voyait que le peuple avait peur, que c'était la panique, il monta à Jérusalem et réunit le peuple."
,"3":"Il l'encouragea par ces mots: 'Vous savez tout ce que mes frères, moi-même et toute la maison de mon père, nous avons fait pour nos lois et notre religion. Vous savez les combats et les épreuves que nous avons connus."
,"4":"Tous mes frères y ont laissé la vie pour Israël et je reste seul;"
,"5":"mais que Dieu me garde de me mettre à l'abri en un temps d'épreuves, car ma vie ne vaut pas plus que celle de mes frères."
,"6":"Puisque toutes les nations qui nous haïssent se sont réunies pour nous détruire, je ferai justice à mon peuple, au Temple, à nos femmes et à nos enfants.'"
,"7":"En entendant ces paroles, l'esprit du peuple se réveilla;"
,"8":"ils répondirent par de grandes acclamations: 'Tu seras notre chef à la place de Judas et de ton frère Jonathan!"
,"9":"Mène-nous au combat et nous ferons tout ce que tu nous diras!'"
,"10":"Alors Simon rassembla tous les hommes de guerre. Rapidement il termina les remparts de Jérusalem et fortifia tout le tour de la ville."
,"11":"Puis il envoya à Joppé Jonathan fils d'Absalon avec une puissante armée; celui-ci en chassa tous les habitants et s'installa dans la ville."
,"12":"Tryphon quitta Ptolémaïs avec une puissante armée pour envahir le pays de Juda; il emmenait avec lui Jonathan prisonnier."
,"13":"Simon, de son côté, installa son camp à Adida, en face de la plaine."
,"14":"Lorsque Tryphon apprit que Simon avait pris le commandement à la place de son frère Jonathan et qu'il était prêt à le combattre, il lui envoya des messagers:"
,"15":"'Nous retenons ton frère Jonathan prisonnier, dirent-ils, à cause de l'argent qu'il doit au trésor royal comme haut-fonctionnaire."
,"16":"Envoie donc cent talents d'argent et deux de ses fils comme otages pour que, une fois libre, il ne nous échappe pas; alors nous lui rendrons la liberté.'"
,"17":"Simon voyait bien que leurs paroles n'étaient pas sincères; il envoya cependant l'argent et les deux jeunes enfants pour ne pas attirer sur lui la colère du peuple , car on aurait pu dire ensuite:"
,"18":"'C'est parce qu'il n'a pas envoyé l'argent et les enfants que Jonathan est mort.'"
,"19":"Il envoya donc les enfants et les cent talents d'argent, mais Tryphon ne tint pas sa promesse et il ne relâcha pas Jonathan."
,"20":"Tryphon s'avança alors pour envahir le pays et le ravager; il fit un détour, prenant le chemin d'Adora, mais Simon et son armée lui faisaient obstacle partout où il allait."
,"21":"Les hommes de la Citadelle envoyèrent des messagers à Tryphon pour le supplier de venir rapidement par le désert et de leur apporter des vivres."
,"22":"Tryphon disposa toute sa cavalerie pour y aller, mais cette nuit-là il y eut une forte chute de neige et la neige l'empêcha d'y aller. Il leva le camp et repartit pour Galaad."
,"23":"Avant d'arriver à Baskama, il fit tuer Jonathan qui fut enterré en cet endroit."
,"24":"Puis Tryphon s'en retourna pour regagner son pays."
,"25":"Simon envoya prendre les ossements de son frère Jonathan et les ensevelit à Modin dans la ville de ses pères."
,"26":"Tout Israël fit sur lui un grand deuil et on le pleura durant de nombreux jours."
,"27":"Simon fit construire un monument sur la tombe de son père et de ses frères; il était fait de pierres polies par devant et par derrière, et suffisamment haut pour être vu de loin."
,"28":"Il fit dresser sept pyramides qui se faisaient face, pour son père, sa mère et ses quatre frères,"
,"29":"afin de garder à jamais leur souvenir. Il fit garnir ces pyramides d'un cercle de hautes colonnes surmontées d'armures, et à côté des armures il fit sculpter des navires que pourraient apprécier tous ceux qui naviguent sur la mer."
,"30":"Tel est jusqu'à ce jour le monument que Simon fit construire à Modin."
,"31":"Tryphon menait un double jeu avec le jeune roi Antiocus: il le tua"
,"32":"et régna à sa place. Il prit la couronne des rois d'Asie et fit beaucoup de tort au pays."
,"33":"Simon reconstruisit les forteresses de Judée, il les garnit de hautes tours, de remparts élevés, de portes et de verrous, et il y mit de la nourriture en réserve."
,"34":"Par ailleurs, Simon choisit des hommes qu'il envoya au roi Démétrius pour qu'il accorde des remises d'impôts au pays, car Tryphon ne faisait que brigandage sur brigandage."
,"35":"Le roi Démétrius répondit à sa demande par cette lettre:"
,"36":"'Le roi Démétrius salue Simon, grand prêtre et ami des rois, les anciens et la nation des Juifs!"
,"37":"Nous avons reçu la couronne d'or et la palme que vous nous avez envoyées, nous sommes prêts à faire avec vous une paix totale et à écrire aux percepteurs royaux pour qu'ils vous fassent différentes remises."
,"38":"Tous nos engagements envers vous sont fermes, les forteresses que vous avez construites sont à vous."
,"39":"Nous voulons oublier tous les manquements et les offenses commises jusqu'à ce jour ainsi que la taxe royale que vous nous deviez, et si par hasard on percevait quelque autre impôt à Jérusalem, qu'il ne soit plus perçu."
,"40":"S'il y a parmi vous des gens disposés à s'engager dans notre garde personnelle, qu'il s'y engage et que la paix règne entre nous.'"
,"41":"C'est ainsi que le joug des nations qui pesait sur Israël fut enlevé en l'an cent soixante-dix."
,"42":"Le peuple d'Israël commença à dater ainsi ses actes et ses contrats: 'En la première année de Simon, grand prêtre éminent, général et gouverneur des Juifs.'"
,"43":"En ce temps-là Simon marcha sur Gaza et la fit assiéger par ses troupes; il construisit des tours roulantes et les plaça pour attaquer la ville; à partir d'une de ces tours, il fit une brèche et s'en rendit maître."
,"44":"Ceux qui étaient dans la tour roulante sautèrent dans la ville et y jetèrent la panique:"
,"45":"les habitants, leurs femmes et leurs enfants, montèrent sur les remparts, les vêtements déchirés et poussant de grands cris, demandant à Simon de leur accorder la paix."
,"46":"Ils lui disaient: 'Ne nous traite pas selon notre méchanceté mais selon ta miséricorde!'"
,"47":"Simon eut pitié d'eux: il arrêta le combat, mais il chassa les habitants de la ville, il purifia les maisons dans lesquelles se trouvaient des idoles et fit une entrée solennelle au chant des hymnes, des cantiques et des psaumes d'action de grâce."
,"48":"Après avoir enlevé de la ville toutes les impuretés, il y plaça des hommes fidèles à la Loi, puis il la fortifia et s'y construisit une maison."
,"49":"Pendant ce temps, les hommes qui occupaient la Citadelle de Jérusalem ne pouvaient plus ni sortir ni circuler dans le pays, ni acheter, ni vendre; ils souffraient de la famine et nombreux étaient ceux qui mouraient de faim."
,"50":"Ils supplièrent Simon de faire la paix avec eux. Il la leur accorda, mais il les chassa de là et purifia la Citadelle de toute impureté."
,"51":"Il y fit une entrée solennelle le vingt-troisième jour du second mois, en l'an cent soixante et onze, avec palmes et chants de louange, au son des cithares, des cymbales, des harpes, des hymnes et des cantiques, car un grand ennemi d'Israël était abattu."
,"52":"Il ordonna de célébrer ce jour de joie chaque année."
,"53":"Il fortifia la Montagne du Temple située à côté de la Citadelle et il y résida avec ses hommes."
,"54":"Voyant que son fils Jean était maintenant un homme, Simon lui confia le commandement de toutes les troupes et lui donna Gazer comme résidence."
}`)
	CurrentBook.AddChapter(14, `{
"1":"En l'an cent soixante-douze, le roi Démétrius rassembla ses forces et partit en Médie pour y recruter des troupes auxiliaires, car il voulait combattre Tryphon."
,"2":"Arsace, roi de Perse et de Médie, apprit que Démétrius était entré sur son territoire, et il envoya un de ses généraux pour le prendre vivant."
,"3":"Celui-ci se mit en route, écrasa la colonne de Démétrius et mit la main sur lui; il le conduisit à Arsace qui le fit jeter en prison."
,"4":"Le pays fut ainsi en paix durant tout le règne de Simon. Il rechercha le bien de son peuple et durant tous ses jours, le peuple apprécia son autorité et sa renommée. "
,"5":"Il ajouta à ses autres titres de gloire la prise de Joppé; il en fit un port qui lui ouvrait la route des îles de la mer."
,"6":"Il recula les frontières de sa nation et devint le maître du pays."
,"7":"Il fit revenir un grand nombre de prisonniers, il s'empara de Gazer, de Beth-Sour et de la Citadelle; il en retira toutes les impuretés et plus personne ne put lui résister."
,"8":"Chacun travaillait ses champs en paix, le sol donnait ses produits et les arbres des champs leurs fruits."
,"9":"Assis sur les places publiques, les vieillards parlaient de la prospérité du pays et les jeunes gens aimaient à revêtir des habits de guerre."
,"10":"Simon procura aux villes des vivres et tout ce qui était nécessaire à leur défense; sa renommée atteignit jusqu'aux extrémités de la terre."
,"11":"Il rendit la paix au pays et Israël connut du bon temps."
,"12":"Chacun put s'asseoir sous sa vigne ou son figuier, nul ne les inquiétait."
,"13":"On avait cessé de les attaquer dans leur pays, les rois en ce temps-là avaient été vaincus."
,"14":"Simon fut le soutien des humbles de son peuple; il était zélé pour la Loi, il fit disparaître les renégats comme les méchants."
,"15":"Il redonna au Temple sa gloire et multiplia les objets sacrés."
,"16":"Lorsqu'on apprit à Rome et à Sparte la mort de Jonathan, tous en furent profondément peinés;"
,"17":"mais lorsqu'ils surent que son frère Simon était devenu grand prêtre à sa place, qu'il était maître de tout le pays et de toutes les villes qui s'y trouvent,"
,"18":"ils lui écrivirent sur des tables de bronze pour renouveler avec lui l'alliance et l'amitié qu'ils avaient faites avec Judas et Jonathan, ses frères."
,"19":"On lut ce document en présence de toute l'assemblée à Jérusalem, et voici la copie de la lettre que les Spartiates envoyèrent:"
,"20":"'Les chefs des Spartiates et la cité saluent le grand prêtre Simon, les anciens, les prêtres, et le reste du peuple des Juifs."
,"21":"Les ambassadeurs que vous avez envoyés à notre peuple nous ont parlé de votre gloire et votre prospérité. Nous avons été heureux de leur visite,"
,"22":"et voici comment nous avons enregistré leur déclaration sur les comptes rendus de notre peuple: Nouménios fils d'Antiocos, et Antipater fils de Jason, ambassadeurs des Juifs, sont venus chez nous pour renouveler l'amitié avec nous."
,"23":"Le peuple s'est fait un plaisir de recevoir ces hommes avec honneur et de déposer la copie de leur discours dans les archives publiques, pour que le peuple de Sparte en garde la mémoire; nous en avons fait faire cette copie pour le grand prêtre Simon.'"
,"24":"Simon envoya alors à Rome Nouménios avec un grand bouclier d'or pesant plus de cinq cents kilos, pour confirmer l'alliance avec les Romains."
,"25":"En apprenant tout cela, le peuple dit: 'Comment pourrons-nous témoigner notre reconnaissance à Simon et à ses fils?"
,"26":"Lui, ses frères, et la maison de son père ont été notre appui: ils ont combattu et repoussé les ennemis d'Israël, ils lui ont assuré la liberté.' Ils gravèrent donc une inscription sur des tablettes de bronze qu'on fixa sur une colonne sur le mont Sion."
,"27":"En voici la copie: 'Le dix-huit du mois d'Eloul, en l'an cent soixante-douze, en la troisième année du grand prêtre Simon, dans la cour intérieure du Temple, "
,"28":"les prêtres et le peuple, les princes de la nation et les anciens du pays ont tenu une grande assemblée. Ils ont publié ce décret:"
,"29":"Simon fils de Mattathias, descendant des fils de Yoarib, et ses frères, se sont exposés au danger dans les combats incessants qui ont eu lieu dans le pays. Ils ont tenu tête aux ennemis de la nation pour que le Temple et la Loi restent debout, ils ont ainsi couvert de gloire leur nation."
,"30":"Jonathan a rassemblé la nation et est devenu son grand prêtre, puis il est allé rejoindre ses pères."
,"31":"Les ennemis des Juifs ont voulu alors envahir leur pays pour ravager leur territoire et mettre la main sur leur Lieu Saint,"
,"32":"mais Simon s'est levé et a combattu pour sa nation. Il a beaucoup dépensé de ses propres richesses pour fournir des armes aux combattants de sa nation et leur verser un salaire."
,"33":"Il a fortifié les villes de Juda, ainsi que Beth-Sour aux limites de la Judée: il a placé une garnison juive dans cette ville qui était occupée jusqu'alors par les ennemis."
,"34":"Il a fortifié Joppé sur la mer, et Gazer aux frontières d'Azotos; autrefois les ennemis l'habitaient, mais il y a placé des colons Juifs et entreposé tout ce qui était nécessaire pour leur entretien."
,"35":"Voyant la fidélité de Simon et la gloire qu'il voulait donner à sa nation, le peuple l'a fait gouverneur et grand prêtre, reconnaissant ainsi tous les services qu'il avait rendus, la justice et la fidélité qu'il avait montrées à la nation, parce que, en toute occasion, il avait cherché à élever son peuple."
,"36":"Durant ses jours, et grâce à lui, les nations ont été chassées du pays qu'elles occupaient, et de même ceux qui s'étaient installés dans la Cité de David à Jérusalem, d'où ils sortaient pour souiller les alentours du Temple et profaner sa sainteté de façon honteuse."
,"37":"Il y a placé des soldats Juifs et l'a fortifiée pour assurer la défense du pays et de la ville; il a aussi surélevé les remparts de Jérusalem."
,"38":"A la suite de cela, le roi Démétrius lui a confié la charge de grand prêtre,"
,"39":"l'a déclaré son ami et lui a accordé les plus grands honneurs:"
,"40":"il avait appris que les Romains appelaient les Juifs leurs amis, leurs alliés et leurs frères, et qu'ils avaient reçu les envoyés de Simon avec honneur.'"
,"41":"'Les Juifs et les prêtres ont donc jugé bon que Simon soit prince et grand prêtre pour toujours, jusqu'au jour où paraîtra un prophète digne de foi. Il commandera leurs armées,"
,"42":"il aura la charge des Lieux-Saints, il établira les responsables des services publics et de l'administration du pays. Il veillera sur les armements et la défense des forteresses."
,"43":"Il aura la charge du peuple saint, il sera obéi de tous. Tous les actes publics dans le pays seront écrits en son nom, et lui sera revêtu de pourpre et d'or."
,"44":"Parmi le peuple, comme parmi les prêtres, personne ne pourra rejeter aucun de ces points, contredire aucun de ses ordres ou convoquer sans son autorisation une assemblée dans le pays, porter une robe de pourpre ou une agrafe d'or."
,"45":"Quiconque agira contrairement à ce décret ou en violera un seul article sera châtié."
,"46":"Le peuple a jugé bon que Simon agisse selon ce décret"
,"47":"et Simon a accepté. Il a bien voulu remplir la charge de grand prêtre, de chef des armées et de gouverneur des Juifs et des prêtres, enfin, d'exercer le commandement suprême.'"
,"48":"On décida de graver ce document sur des tablettes de bronze et de les placer dans la galerie du Temple, en un lieu bien visible;"
,"49":"on en déposa une copie dans la chambre du trésor pour l'usage de Simon et de ses fils."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Le roi Antiocus, fils de Démétrius, envoya depuis les îles de la mer une lettre à Simon, grand prêtre et gouverneur des Juifs, ainsi qu'à toute la nation."
,"2":"Voici ce qu'on y lisait: 'Le roi Antiocus salue Simon, grand prêtre et gouverneur, ainsi que la nation des Juifs."
,"3":"Des bandits se sont emparés du royaume de nos pères, mais je veux le revendiquer pour le rétablir tel qu'il était autrefois. Pour cela j'ai rassemblé des troupes nombreuses et armé beaucoup de bateaux de guerre."
,"4":"J'ai l'intention de débarquer dans le pays pour me venger de ceux qui ont fait la ruine de notre pays et qui ont dévasté un grand nombre de villes de ce royaume."
,"5":"Je te confirme donc toutes les remises d'impôts que t'ont accordées les rois qui sont venus avant moi et toutes les autres remises qu'ils t'ont accordées."
,"6":"Tu peux frapper monnaie à ton nom dans tout le pays,"
,"7":"Jérusalem et le Temple seront libres, toutes les armes que tu as fabriquées, les forteresses que tu as construites et que tu occupes, resteront en ton pouvoir."
,"8":"Tout ce qui est dû ou à devoir au trésor royal, te sera remis dès à présent et pour toujours."
,"9":"Lorsque nous serons rentrés en possession de notre royaume, nous te comblerons d'honneurs, toi, ta nation et le Temple, si bien que votre gloire brillera sur toute la terre.'"
,"10":"Antiocus se mit en route vers le pays de ses pères en l'an cent soixante-quatorze; toutes les troupes vinrent se ranger autour de lui, si bien qu'il ne resta que peu d'hommes à Tryphon."
,"11":"Le roi Antiocus se lança à sa poursuite et Tryphon s'enfuit à Dora, au bord de la mer."
,"12":"Il voyait que le malheur s'abattait sur lui et que son armée l'abandonnait."
,"13":"Antiocus vint camper devant Dora avec cent vingt mille hommes et huit mille cavaliers."
,"14":"Il assiégea la ville pendant que ses bateaux faisaient le blocus du côté de la mer, il l'encercla et par terre et par mer et ne laissa plus personne entrer ni sortir."
,"15":"De Rome arrivèrent alors Numémius et ses compagnons avec des lettres pour les rois et les pays. Voici ce qu'on y lisait:"
,"16":"'Lucius, consul de Rome, salue le roi Ptolémée."
,"17":"Le grand prêtre Simon et le peuple Juif ont envoyé des ambassadeurs auprès de nous comme amis et alliés, pour renouveler l'ancienne amitié et l'ancienne alliance."
,"18":"Ils ont apporté un bouclier d'or de plus de cinq cents kilos,"
,"19":"c'est pourquoi il nous a paru bon d'écrire aux rois et aux pays de ne pas leur faire de tort, de ne pas les attaquer, de respecter leurs villes et leur pays, et de ne pas apporter d'aide à ceux qui voudraient leur faire la guerre."
,"20":"Il nous a paru bon de recevoir leur bouclier."
,"21":"En conséquence, si de mauvais sujets s'enfuient de leur pays dans le vôtre, livrez-les au grand prêtre Simon pour qu'il les punisse selon leurs lois.'"
,"22":"On envoya la même lettre au roi Démétrius, à Attale, à Ariarate, à Arsace -"
,"23":"et à tous les pays: à Sampsamé, aux Spartiates, à Délos, à Myndos, à Sicione, en Carie, à Samos, en Pamphylie, en Lycie, à Halicarnasse, à Rhodes, à Fasélis, à Cos, à Sidé, à Arados, à Gortyne, à Cnide, à Chypre et à Cyrène."
,"24":"On fit une copie de ces lettres pour le grand prêtre Simon."
,"25":"Le roi Antiocus attaqua le quartier neuf de Dora. Ses hommes avancèrent peu à peu, puis ils construisirent des machines de siège; il assiégea Tryphon si bien que l'on ne pouvait plus ni entrer ni sortir."
,"26":"Simon lui envoya deux mille de ses meilleurs guerriers pour l'appuyer, avec de l'argent, de l'or, et beaucoup de matériel."
,"27":"Mais le roi ne voulut pas les recevoir: bien plus, il annula tous les engagements qu'il avait pris autrefois avec Simon et changea d'attitude envers lui."
,"28":"Il lui envoya Athénobius, un de ses Amis, pour discuter avec lui: 'Vous occupez Joppé, faisait-il dire, Gazer et la Citadelle de Jérusalem, qui sont des villes de mon royaume."
,"29":"Vous en avez ravagé les environs, vous avez ruiné le pays et vous vous êtes rendus maîtres de beaucoup de cités dans mes Etats."
,"30":"Maintenant donc, rendez-nous les villes que vous avez prises et les impôts des cités que vous avez soumises en dehors du territoire de la Judée."
,"31":"Sinon, donnez cinq cents talents d'argent à leur place et cinq cents autres pour les ravages que vous avez commis et pour les impôts que devaient ces cités. Si vous ne le faites pas, nous partirons en guerre contre vous.'"
,"32":"Lorsqu'Athénobius, Ami du roi, arriva à Jérusalem, il vit la richesse de Simon, le buffet couvert de vases d'or et d'argent et le luxe qui l'entourait. Il en fut stupéfait. Quand il rapporta les paroles du roi,"
,"33":"Simon lui répondit: 'Nous n'avons pas conquis une terre étrangère, nous ne nous sommes pas emparés des biens d'autrui, mais c'est l'héritage de nos pères qui avait été volé pour un temps par nos ennemis."
,"34":"L'occasion étant favorable, nous en avons profité pour reprendre l'héritage de nos pères."
,"35":"Joppé et Gazer que tu réclames, sont deux villes qui ont fait beaucoup de tort à notre peuple et à notre pays; aussi nous ne donnerons pour elles que cent talents.' Athénobius ne répondit rien,"
,"36":"mais il repartit furieux vers le roi et lui rapporta la réponse de Simon. Il parla de sa richesse et de tout ce qu'il avait vu, et cela mit le roi dans une grande colère."
,"37":"Tryphon s'était enfui sur un bateau à Orthosia."
,"38":"Le roi choisit alors Kendébée comme gouverneur de la zone maritime et lui confia une armée de fantassins et de cavaliers."
,"39":"Il lui ordonna d'établir son camp face à la Judée, de reconstruire Kédron, de renforcer ses portes et de combattre le peuple; de son côté le roi allait poursuivre Tryphon."
,"40":"Kendébée se rendit à Jamnia et commença d'inciter le peuple à faire des expéditions en Judée, à faire des massacres et à ramener des prisonniers."
,"41":"Il fortifia Kédron, il y plaça des cavaliers et des fantassins qui partaient en expédition et patrouillaient sur les routes de Judée comme le roi le lui avait demandé."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Jean monta de Gazer pour prévenir son père Simon de ce que Kendébée était en train de faire."
,"2":"Simon appela alors ses deux fils plus âgés, Judas et Jean; il leur dit: 'La maison de mon père, mes frères, et moi-même, nous avons combattu les ennemis d'Israël depuis notre jeunesse jusqu'à ce jour, et grâce à nous Israël a été délivré bien des fois."
,"3":"Maintenant je suis vieux, alors que vous, grâce au ciel, vous êtes dans la force de l'âge. Prenez donc ma place et celle de mon frère. Partez combattre pour votre nation et que l'aide du Ciel soit avec vous.'"
,"4":"Il choisit alors dans le pays vingt mille hommes et des cavaliers qui marchèrent contre Kendébée et passèrent la nuit à Modin."
,"5":"Quand ils se levèrent de bon matin et s'avancèrent dans la plaine, une puissante armée venait à leur rencontre avec des fantassins et des cavaliers; un torrent les séparait."
,"6":"Jean pensait établir son camp face aux ennemis, mais il vit que ses hommes avaient peur de traverser le torrent. Alors il passa le premier. Voyant cela, ses hommes le passèrent derrière lui."
,"7":"Il divisa son armée en deux, plaçant les cavaliers au milieu des fantassins, car la cavalerie des ennemis était beaucoup plus nombreuse."
,"8":"On sonna de la trompette et Kendébée fut mis en fuite avec son armée; beaucoup de ses hommes tombèrent et ceux qui échappèrent se réfugièrent dans la forteresse."
,"9":"C'est alors que Judas, le frère de Jean, fut blessé, mais Jean poursuivit l'ennemi jusqu'à ce que Kendébée arrive à Kédron qu'il avait fortifiée."
,"10":"Comme d'autres s'étaient réfugiés dans des tours, dans la banlieue d'Azotos, Jean y mit le feu; deux mille d'entre eux succombèrent et Jean regagna en paix la Judée."
,"11":"Ptolémée fils d'Aboubos avait été nommé gouverneur de la plaine de Jéricho; il était riche en or et en argent,"
,"12":"et il était le gendre du grand prêtre."
,"13":"Dans son orgueil il souhaitait devenir le maître du pays, et dans sa méchanceté, il calcula comment supprimer Simon et ses fils."
,"14":"Or Simon, préoccupé du bien-être des villes du pays, était en train de faire une tournée d'inspection; il arriva ainsi à Jéricho avec ses deux fils, Mattathias et Judas, au mois de Chebat, le onzième mois de l'année cent soixante-dix-sept."
,"15":"Le fils d'Aboubos les reçut hypocritement dans une petite forteresse du nom de Dok, qu'il avait construite. Il leur prépara un grand repas, mais il avait caché des hommes,"
,"16":"et lorsque Simon et ses fils furent ivres, Ptolémée et ses hommes prirent leurs armes et se jetèrent sur Simon dans la salle du repas; ils le tuèrent avec ses deux fils et quelques-uns de ses compagnons."
,"17":"C'était un geste odieux par lequel il rendait le mal pour le bien."
,"18":"Ptolémée écrivit au roi pour lui raconter ce qu'il avait fait, il lui demandait de lui envoyer des troupes pour lui permettre ainsi de livrer au roi le pays et les villes des Juifs."
,"19":"Il envoya d'autres hommes à Gazer pour tuer Jean, et il écrivit aux généraux de venir le rejoindre, pour qu'il leur donne de l'argent, de l'or et des cadeaux."
,"20":"Il en envoya d'autres encore pour s'emparer de Jérusalem et de la Montagne du Temple."
,"21":"Mais quelqu'un avait pris les devants et avait appris à Jean, qui était à Gazer, l'assassinat de son père et de ses frères. Il ajoutait: 'Il a aussi envoyé des hommes pour te tuer.'"
,"22":"En apprenant cela, Jean fut bouleversé. Il se saisit des hommes qui venaient pour le tuer et les fit mettre à mort, car il était clair qu'ils avaient l'intention de le tuer."
,"23":"Le reste de l'histoire de Jean, ses guerres, ses actes de bravoure, les remparts qu'il a édifiés et tout ce qu'il a fait,"
,"24":"tout cela n'est-il pas écrit dans les archives des grands prêtres, à dater du jour où il a reçu cette charge à la suite de son père?"
}`)

}
func FR_LBDCC_LoadVH1PChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Adam, Seth, Enos,"
,"2":"Caïnan, Mahalaléel, Yared,"
,"3":"Hénok, Mathusalem, Lamek,"
,"4":"Noé, Sem, Kam et Japhet."
,"5":"Fils de Japhet: Gomer, Magog, les Mèdes, Yavan, Méchek et Tiras."
,"6":"Fils de Gomer: Ashkenaz, Riphat et Togorma."
,"7":"Fils de Yavan: Elicha, Tarsis, Kittim, les Dananéens."
,"8":"Fils de Kam: Kouch, Misraïm, Pout et Canaan."
,"9":"Fils de Kouch: Séba, Havila, Sabta, Rama, Sabtéka. Fils de Rama: Chéba, Dédan."
,"10":"Kouch eut comme fils Nemrod qui fut le premier homme important sur la terre."
,"11":"Misraïm engendra les gens de Loud, de Anam, de Léhab, de Naftouk,"
,"12":"de Patros, de Kasleu et de Kaftor: de là viennent les Philistins."
,"13":"Canaan engendra Sidon, son premier-né, ensuite naquirent Hèt,"
,"14":"le Jébusite, l'Amorite, le Guirgachite,"
,"15":"le Hivvite, l'Arkite, le Sinite,"
,"16":"l'Arvadite, le Sémarite, le Hamatite."
,"17":"Fils de Sem: Elam, Achour, Arpakchad, Loud, Aram; fils d'Aram: Ous, Oul, Guéther et Molok."
,"18":"Arpakchad engendra Salé; Salé engendra Héber."
,"19":"Héber eut deux fils, dont l'un s'appelait Phaleg, car la terre s'était divisée à sa naissance, et l'autre Yoctan."
,"20":"Voici les fils de Yoktan: Almodad, Chélef, Assarmavet, Yéra,"
,"21":"Adoram, Ouzal, Dikla,"
,"22":"Obal, Abimaël, Chéba,"
,"23":"Ofir, Havila, Yobab. Tous ceux-là sont fils de Yoktan."
,"24":"Sem, Arpakchad, Chéla,"
,"25":"Eber, Péleg, Ragau,"
,"26":"Sérug, Nachor, Térah,"
,"27":"Abram, qui devint Abraham."
,"28":"Abraham engendra Isaac et Ismaël."
,"29":"Voici leur descendance: Nébayot est le premier-né d'Ismaël, ensuite viennent Kédar, Adbéel, Mabsam, "
,"30":"Masma, Duma, Massa, Hadad, Thema,"
,"31":"Yétur, Nafis, Cedma. Voilà les fils d'Ismaël."
,"32":"Fils de Kétoura, concubine d'Abraham: elle mit au monde Zamram, Yoksan, Madan, Madian, Yichbak et Choua. Fils de Yoksan: Chéba et Dédan."
,"33":"Fils de Madian: Epha, Epher, Enok, Abida, Eldaa. Tous ceux-là sont fils de Kétoura."
,"34":"Abraham engendra Isaac. Isaac eut deux fils: Esaü et Jacob."
,"35":"Fils d'Esaü: Eliphaz, Rauël, Yéouch, Yélam, Koré."
,"36":"Fils d'Eliphaz: Théman, Omar, Séfi, Gaétam, Kenaz, Timna, Amalec."
,"37":"Fils de Rauël: Nahath, Zara, Samma, Méza."
,"38":"Fils de Séir: Lotan, Chobal, Sibéon, Ana, Dichon, Eser, Dichan."
,"39":"Fils de Lotan: Hori, Homam. Timna est la soeur de Lotan."
,"40":"Fils de Chobal: Alyan, Manahat, Ebal, Chéfi, Onam. Fils de Sibéon: Aya, Ana."
,"41":"Fils d'Ana: Dichon. Fils de Dichon: Hamram, Echban, Yitran, Kéran."
,"42":"Fils d'Eser: Bilhan, Zavan, Yaakan. Fils de Dichan: Ous, Aran."
,"43":"Voici les rois qui ont gouverné le pays d'Edom avant que les Israélites n'aient un roi: Béla, fils de Béor; sa ville s'appelait Dinaba."
,"44":"Béla mourut et Jobab, fils de Zaré, de Bosra, régna à sa place."
,"45":"Jobab mourut et Husam du pays des Thémanites régna à sa place."
,"46":"Husam mourut et à sa place régna Hadad, fils de Badad, qui vainquit Madian dans la campagne de Moab. Avit était le nom de sa ville."
,"47":"Hadad mourut et Semla de Masréka régna à sa place."
,"48":"Samla mourut et Saül de Rehobot-Ha-Nahar régna à sa place."
,"49":"Saül mourut et Balanan, fils d'Akbor, régna à sa place."
,"50":"Balanan mourut et Hadad régna à sa place; Phau était le nom de sa ville, Métabel le nom de sa femme, fille de Mézaab."
,"51":"Hadad mourut, il fut remplacé par les chefs d'Edom qui sont: le chef Tamna, le chef Alva, le chef Jéthet,"
,"52":"le chef Oholibama, le chef Ela, le chef Finon,"
,"53":"le chef Cénez, le chef Théman, le chef Mabsar,"
,"54":"le chef Magdiel, le chef Hiram. Ce sont les chefs d'Edom."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Les fils d'Israël sont: Ruben, Siméon, Lévi, Juda Issacar, Zabulon,"
,"2":"Dan, Joseph, Benjamin, Nephtali, Gad, Asher."
,"3":"Fils de Juda: Er, Onan, Shéla; ils sont nés tous les trois de la fille de Sué, la Cananéenne. Yahvé fit mourir le premier-né Er, car il déplut à ses yeux."
,"4":"La belle-fille de Juda, Tamar, lui enfanta Farès et Zara. Les fils de Juda sont cinq en tout."
,"5":"Fils de Farès: Hesron, Hamul."
,"6":"Fils de Zara: Zamri, Ethan, Eman, Kalkol, Dara: ce qui fait cinq."
,"7":"Fils de Charmi: Akan, qui amena le malheur à Israël quand il viola l'anathème."
,"8":"Fils d'Ethan: Azarias."
,"9":"Fils qui sont nés à Hesron: Yérahméel, Ram, Kalubi."
,"10":"Ram engendra Aminadab; Aminadab engendra Nahasson, prince des fils de Juda."
,"11":"Nahasson engendra Salma; Salma engendra Booz."
,"12":"Booz engendra Obed; Obed engendra Jessé."
,"13":"Jessé engendra Eliab, son premier-né, Abinadab, le deuxième, Chiméa, le troisième,"
,"14":"Nathanaël, le quatrième, Raddaï, le cinquième,"
,"15":"Asom, le sixième, David, le septième."
,"16":"Serouyah et Abigaïl furent leurs soeurs. Serouyah eut trois fils: Abisaï, Joab, Azaël."
,"17":"Abigaïl eut un fils: Amasa; Yéter l'Ismaélite fut son père."
,"18":"Caleb, fils de Hesron, engendra Yériot d'Azuba, sa femme; celui-ci eut des fils: Yaser, Sobab, Ardon."
,"19":"Azuba mourut et Caleb prit pour femme Ephrata qui lui enfanta Our."
,"20":"Our engendra Uri, et Uri engendra Betsaléel."
,"21":"Hesron s'unit ensuite à la fille de Makir, père de Galaad: il avait soixante ans quand il la prit pour femme; elle lui enfanta Ségub."
,"22":"Ségub engendra Yaïr, qui eut dans le pays de Galaad vingt, trois villes."
,"23":"Gueshour et Aram prirent à Ségub les villages de Yaïr, Kénat et ses dépendances: au total soixante villages. Ils étaient tous fils de Makir, le père de Galaad."
,"24":"Après la mort de Hesron, Caleb épousa Ephrata, la femme de son père Hesron. Elle lui donna un fils: Ashéhour, père de Tékoa."
,"25":"Yérahméel, le fils aîné d'Hesron, eut des fils: son premier-né, Ram; Bouna; Oren; Ossem; Ahiyas."
,"26":"Yérahméel épousa une autre femme: Atara. Elle est la mère d'Onam."
,"27":"Voici les fils de Ram, le premier-né de Yérahméel: Maas. Yamin et Eker."
,"28":"Voici les fils d'Onam: Chammaï et Yada; les fils de Chamaï: Nadab et Abichour."
,"29":"La femme d'Abichour s'appelait Abihayil, elle lui donna deux fils. Ahban et Molid."
,"30":"Fils de Nadab: Séled et Apaïm. Séled mourut sans enfants."
,"31":"Fils d'Apaïm: Yichéï. Fils de Yichéï: Chéchan. Fils de Chéchan: Ahlaï."
,"32":"Fils de Yada, frère de Chammaï: Yéter et Yonathan. Yéter mourut sans enfants."
,"33":"Fils de Yonathan: Pélet et Zaza. Voilà les fils de Yérahméel."
,"34":"Chéchan eut des filles mais pas de fils. Il avait un serviteur Egyptien du nom de Yarha"
,"35":"auquel il donna sa fille en mariage. Elle lui donna un fils: Attï."
,"36":"Attï engendra Nathan, Nathan engendra Zabad,"
,"37":"Zabad engendra Eflal, Eflal engendra Obed,"
,"38":"Obed engendra Yéhou, Yéhou engendra Azaryas,"
,"39":"Azaryas engendra Héles, Héles engendra Eléaza,"
,"40":"Eléaza engendra Sismaï, Sismaï engendra Challoum,"
,"41":"Challoum engendra Yékanyas, Yékanyas engendra Elichama."
,"42":"Fils de Caleb, frère de Yérahméel: premier-né, Mécha, père de Zif. Son fils s'appelait Marécha, père de Hébron."
,"43":"Fils de Hébron: Korah, Tapouah, Rékem et Chéma."
,"44":"Chéma eut un fils, Raham, père de Yorkéam. Rékem eut un fils: Chammaï."
,"45":"Le fils de Chammaï fut Maon, le père Beth-Sour."
,"46":"Caleb eut des fils de sa concubine Efa: Haran, Mossa et Gazez. Haran engendra Gazez."
,"47":"Fils de Yahdaï: Réguém, Yotam, Géchan, Pélet, Efa et Chaaf."
,"48":"Caleb eut des fils de sa concubine Maaka: Chéber et Tirana."
,"49":"Elle enfanta aussi Chaaf, père de Madmanna et Chéva, père de Makbéna et de Guibéa. Caleb eut une fille Aksa."
,"50":"Voilà les descendants de Caleb. Fils de Hour, premier-né d'Ephrata: Chobal, père de Kiryat-Yéarim, "
,"51":"Salma, père de Bethlehem, Harèf, père de Beth-Gader."
,"52":"Chobal, père de Kiryat-Yéarim, eut des fils: Haroé, ancêtre de la moitié des Manahatites,"
,"53":"les clans de Kiryat-Yéarim: les Yitrites, les Poutites, les Choumatites et les Michraïtes. De là sont sortis les hommes de Soréa et d'Echtaol."
,"54":"Fils de Salma: Bethlehem, les Nétofatites, Atrot-Beth-Yoab, la moitié des Manahatites, les Soréatites,"
,"55":"les clans des Sofrites qui habitent Yabesh, les Tirathites, les Schiméatites, les Soukathites. Voilà les Kénites qui viennent de Hammam, le père de la descendance de Rékab."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Voici les fils de David qui lui naquirent à Hébron: le premier, Amnon, d'Ahinoam de Yizréel; le deuxième, Daniel, d'Abigaïl de Karmel;"
,"2":"le troisième, Absalom, fils de Maaka, qui était fille du roi de Gueshour, Talmaï; le quatrième, Adonias, fils de Haggit;"
,"3":"le cinquième, Chéfatya, d'Abital; le sixième, Yitréam, de sa femme Egla."
,"4":"Il eut donc six fils qui naquirent à Hébron: c'est là qu'il régna sept ans et six mois. Il régna trente-trois ans à Jérusalem. "
,"5":"Voici ceux qui lui naquirent à Jérusalem: Chiméa, Chobab, Nathan, Salomon; ce sont les quatre fils de Bethsabée, qui était fille d'Ammiel;"
,"6":"Yibar, Elichama, Elifélèt,"
,"7":"Noga, Néfeg, Yafia,"
,"8":"Elichama, Elyada, Elifélèt: soit neuf fils."
,"9":"Voilà tous les fils de David, sans compter les fils des concubines et leur soeur, Tamar."
,"10":"Descendants de Salomon: Roboam; Abiyas, son fils; Asa, son fils; Josaphat, son fils;"
,"11":"Joram, son fils; Okozias, son fils; Joas, son fils;"
,"12":"Amasias, son fils; Azarias, son fils; Yotam, son fils;"
,"13":"Akaz, son fils; Ezéquias, son fils; Manassé, son fils;"
,"14":"Amon, son fils; Josias, son fils."
,"15":"Fils de Josias: le premier, Yohanan; le deuxième, Joïaqim; le troisième, Sédécias; le quatrième, Challoum."
,"16":"Fils de Joïaqim: Jékonias, son fils; Sédécias, son fils."
,"17":"Fils de Jékonias, le prisonnier: Chéaltiel, son fils;"
,"18":"Malkiram, Pédayas, Chénéassar, Yékanyas, Hochama, Nédabya."
,"19":"Fils de Pédayas: Zorobabel et Chiméï. Fils de Zorobabel: Méchoullam et Hananya; leur soeur s'appelait Chélomit."
,"20":"Voici les cinq fils de Méchoullam: Hachouba, Ohel, Bérékya, Hasadya, Youchab-Hesed."
,"21":"Fils de Hananya: Pélatya, Yéchayas son fils, Réfayas son fils, Arnan son fils, Obadya son fils, Chékanya son fils."
,"22":"Voici les six fils de Chékanya: Chémayas, Hattouch, Yiguéal, Baria, Néarya, Chafat."
,"23":"Voici les trois fils de Néarya: Elyoénaï, Hizkiyas, Azrikan."
,"24":"Voici les sept fils de Elyoénaï: Hodavias, Elyachib, Pélayas, Akoub, Yohanan, Délayas, Anani."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Fils de Juda: Péres, Hesron, Karmi, Hour, Chobal."
,"2":"Réayas, fils de Chobal, est le père de Yahat. Yahat est le père d'Ahoumaï et Lahad. Voilà les clans des Soréatites."
,"3":"Abi-Etam, Yizréel, Yichma et Yidbach avaient une soeur Haslelponi."
,"4":"Pénuel était le père de Guédor, Ezer, le père de Houcha. Voilà les fils de Hour, le premier-né d'Ephrata, le père de Bethlehem."
,"5":"Ashéhour, père de Tékoa, eut deux femmes: Héléa et Naara."
,"6":"Naara lui donna: Ahouzam, Héfer, les Timnites etles Ahachtarites. Voilà les fils de Naara."
,"7":"Fils de Héléa: Séret, Sohar, Etnan."
,"8":"Kos engendra Anoub, Assobéba, les clans d'Aharhel, le fils de Haroum."
,"9":"Yabes était plus honoré que ses frères. Sa mère l'appela Yabes car, dit-elle: 'Je l'ai enfanté dans la douleur.'"
,"10":"Yabes invoqua le Dieu d'Israël: 'Si vraiment tu me bénis, si tu fais grandir mon territoire, si ta main est avec moi, tu m'auras délivré de mes malheurs.' Dieu exauça sa demande."
,"11":"Kéloub, frère de Chouha, engendra Méhir, le père d'Echton."
,"12":"Echton engendra Beth-Rafa, Paséah, Téhina, le père de Ir-Na hach. Voilà les descendants de Rékab."
,"13":"Fils de Kénaz: Otniel et Séraya. Fils de Otniel: Hatat et Méonotaï."
,"14":"Méonotaï engendra Ofra. Sérayas engendra Yoab, le père de Gé-Harachim. Ils étaient artisans."
,"15":"Fils de Caleb, fils de Yéfouné: Ir, Ela et Naam. Fils d'Ela: Kénaz."
,"16":"Fils de Yéhaléléel: Zif, Zifa, Tirya, Azaréel."
,"17":"Fils d'Hézra: Yéter, Méred, Efer, Yalon. Bitya donna le jour à Miryam, Chammaï et Yichba, père d'Echtémoa."
,"18":"Celui-ci avait une femme judéenne qui lui enfanta Yéred, père de Guédor, Héber père de Soko et Yékoutiel, père de Zanoah. Voilà les fils que Bitia, fille du Pharaon donna à Méred."
,"19":"Le père de Kéïla le Garmite est Echtémoa: le Maakatite était fils de la soeur de Naam, femme de Ohodia."
,"20":"Fils de Chimon: Amnon, Rinna, Ben-Hanan, Tilon. Fils de Yichéï: Zohet et Ben-Zohet."
,"21":"Fils de Chéla , fils de Juda: Er père de Léka, Lada père de Marécha, et les clans de Beth-Achléa qui travaillent le lin;"
,"22":"Yokim, les hommes de Kozéba, Yoach et Saraf qui dominèrent le pays de Moab et revinrent ensuite à Bethlehem (ce sont de vieilles histoires)."
,"23":"Ils étaient potiers et habitaient à Nétaïm et Gédéra. Ils habitaient à côté du roi et travaillaient dans son atelier."
,"24":"Fils de Siméon: Némouel, Yamin, Yarib, Zérah, Chaoul."
,"25":"Challoum son fils, Mibsam son fils."
,"26":"Fils de Michma: Hamouel son fils, Zakkour son fils, Chiméï son fils."
,"27":"Chiméï eut seize fils et six filles. Cependant, comme ses frères n'avaient pas beaucoup d'enfants, le total de leurs familles resta très inférieur à celui des fils de Juda."
,"28":"Ils habitèrent à Bersabé, Molada, Hasar-Choual,"
,"29":"Bilha, Esem, Tolad,"
,"30":"Bétuel, Horma, Siklag,"
,"31":"Beth-Markabot, Hasar-Sousim, Beth-Biréï, Chaarayim. Voilà leurs villes jusqu'au règne de David."
,"32":"Voici maintenant leurs cinq villages: Etam, Ayin, Rimmon, Token, Akan,"
,"33":"avec tous les villages qui les entouraient jusqu'à Baalat. Voilà leur habitat et leur recensement."
,"34":"Méchobab, Yamlek, Yocha fils d'Amasya,"
,"35":"Yoël, Yéhu fils de Yochibya, fils de Sérayas, fils d'Aziel,"
,"36":"Elyoénaï, Yaakoba, Yéchohayas, Azayas, Adiel, Yésimiel, Bénayas,"
,"37":"Ziza, Ben-Chiféï, Ben-Alon, Ben-Yédayas, Ben-Chimri, Ben-Chémayas:"
,"38":"ces hommes recensés un par un étaient chefs de leurs clans, leurs familles se développèrent énormément."
,"39":"Ils marchèrent vers l'entrée de Guérar jusqu'à l'est du vallon, afin de trouver des pâturages pour leur petit bétail."
,"40":"Ils trouvèrent là de gras et bons pâturages. Le pays, très étendu dans toutes les directions, était calme et paisible, ceux qui l'habitaient autrefois appartenaient à la descendance de Kam."
,"41":"Tous ces hommes que l'on vient de nommer arrivèrent au temps d'Ezéquias, roi de Juda. Ils détruisirent les tentes et les refuges des gens du pays. Ils les vouèrent à l'anathème et ils s'installèrent à leur place, car il y avait là des pâturages pour leur petit bétail."
,"42":"Certains des fils de Siméon partirent vers la montagne de Séïr: ils étaient au nombre de cinq cents avec, à leur tête, Pélatya, Néarya, Réfayas, Ouziel, fils de Yichéï."
,"43":"Ils battirent ceux qui restaient des Amalécites et s'installèrent là jusqu'à nos jours."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Fils de Ruben premier-né d'Israël. Il était bien le premier-né, mais après qu'il eût souillé la couche de son père, son droit d'aînesse fut donné aux fils de Joseph, fils d'Israël: cependant on ne les considéra pas comme les aînés."
,"2":"Et Joseph eut le droit d'aînesse, bien que Juda l'emportât sur ses frères et qu'il y eût un prince grâce à lui."
,"3":"Fils de Ruben, premier-né d'Israël: Henok, Palou, Hesron et Karmi."
,"4":"Fils de Yoël: Chémaïa son fils, Gog son fils, Chiméï son fils,"
,"5":"Mika son fils, Réayas son fils, Baal son fils,"
,"6":"Bééra son fils: Téglat-Phalasar, roi d'Assyrie emmena ce dernier en captivité. Il était chef des Rubénites."
,"7":"Voici ses frères d'après leurs familles et leur descendance: d'abord Yéhiël, Zékaryas,"
,"8":"Béla fils de Azaz, fils de Chéma, fils de Yoël. Ruben était établi à Aroër et s'étendait jusqu'au Nébo et Baal-Méon."
,"9":"A l'est il s'étendait de l'Euphrate jusqu'à l'entrée du désert: ses troupeaux s'étaient développés au pays de Galaad."
,"10":"Au temps de Saül, ils firent la guerre aux Hagrites et tombèrent entre leurs mains: ceux-ci s'installèrent dans leurs tentes sur tout le versant oriental de Galaad."
,"11":"En face d'eux, les fils de Gad s'installèrent dans le pays du Bashan jusqu'à Salka:"
,"12":"le premier, Yoël, le second, Chafam, ensuite Yanaï et Chafat, au pays du Bashan."
,"13":"Voici leurs sept frères, par familles: Mikaël, Méchoullam, Chéba, Yoraï, Yakan, Zia, Eber."
,"14":"Voici les fils d'Abihayil: Ben-Houri, Ben-Yaroah, Ben-Galaad, Ben-Mikaël, Ben-Yéchichaï, Ben-Yahdo, Ben-Bouz."
,"15":"Ahi, fils d'Abdiel, fils de Gouni, était leur chef de clan."
,"16":"Ils s'installèrent en Galaad et dans le Bashan, dans leurs environs et dans tous les pâturages jusqu'aux limites de Charon."
,"17":"Tous ceux-là furent recensés sous les règnes de Yotam, roi de Juda et de Jéroboam, roi d'Israël."
,"18":"Dans les tribus de Ruben et de Gad, dans la demi-tribu de Manassé, il y avait des guerriers, des hommes qui portaient le bouclier et l'épée, des hommes exercés à la guerre qui tiraient à l'arc: ils étaient 44760 hommes préparés pour faire la guerre."
,"19":"Ils firent la guerre aux Hagrites, à Yétour, à Nafich et à Nodab."
,"20":"Ils reçurent du secours de Dieu: les Hagrites et tous leurs alliés tombèrent entre leurs mains; ils avaient en effet invoqué Dieu dans la bataille, et lui les avait exaucés, car ils avaient eu confiance en lui."
,"21":"Ils pillèrent leurs troupeaux: 50000 chameaux, 250000 brebis, 2000 ânes et 100000 personnes."
,"22":"Dieu avait conduit la bataille, c'est pourquoi ils firent beaucoup de victimes. Ils s'installèrent donc à leur place jusqu'à l'exil."
,"23":"Les fils de la demi-tribu de Manassé s'installèrent entre le Bashan et Baal-Hermon, le Sénir et la montagne de l'Hermon. Ils étaient nombreux."
,"24":"Voici les chefs de leurs clans: Efer, Yichéï, Eliel, Azriel, Yirméya, Hodaviyas, Yahdiel. C'étaient des guerriers courageux, des hommes renommés, tous chefs de leurs clans."
,"25":"Cependant ils furent infidèles envers le Dieu de leurs pères. Ils se prostituèrent auprès des dieux des nations que Dieu avait exterminées devant eux dans le pays."
,"26":"C'est pourquoi le Dieu d'Israël excita le mauvais esprit de Poul, roi d'Assyrie, et celui de Téglat-Phalasar, roi d'Assyrie. Il déporta Ruben, Gad et la demi-tribu de Manassé; il les emmena à Halah, sur le Habor, à Hara et sur le fleuve de Gozan: ils y sont encore aujourd'hui."
,"27":"Fils de Lévi: Guérchom, Kahat et Mérari."
,"28":"Fils de Kahat: Amram, Yisar, Hebron, Ouziel."
,"29":"Fils d'Amram: Aaron, Moïse et Miryam. Fils d'Aaron: Nadab et Abihou, Eléazar et Itamar."
,"30":"Eléazar engendra Pinhas; Pinhas engendra Abichoua,"
,"31":"Abichoua engendra Bouki, Bouki engendra Ouzi,"
,"32":"Ouzi engendra Zérayas, Zérayas engendra Mérayot,"
,"33":"Mérayot engendra Amarya, Amarya engendra Ahitoub,"
,"34":"Ahitoub engendra Sadoq, Sadoq engendra Ahimaas,"
,"35":"Ahimaas engendra Azaryas, Azaryas engendra Yohanan,"
,"36":"Yohanan engendra Azaryas: il était grand prêtre dans le Temple construit à Jérusalem par Salomon."
,"37":"Azaryas engendra Amarya, Amarya engendra Ahitoub,"
,"38":"Ahitoub engendra Sadoq, Sadoq engendra Challoum,"
,"39":"Challoum engendra Hilkiyas, Hilkiyas engendra Azaryas,"
,"40":"Azaryas engendra Sérayas, Sérayas engendra Yosadak"
,"41":"et Yosadak partit lorsque Yahvé déporta Juda et Jérusalem par la main de Nabukodonozor."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Fils de Lévi: Guérchom, Kahat et Mérari."
,"2":"Voici les noms des fils de Guérchom: Libni et Chiméï."
,"3":"Fils de Kahat: Amram, Yisar, Hébron, Ouziel."
,"4":"Fils de Mérari: Mali et Mouchi. Voilà les clans de Lévi selon leurs ancêtres."
,"5":"Fils de Guérchom: Libni son fils, Yahat son fils, Zimma son fils,"
,"6":"Yoah son fils, Iddo son fils, Zérah son fils, Yéatraï son fils."
,"7":"Fils de Kahat: Aminadab son fils, Koré son fils, Assir son fils,"
,"8":"Elkana son fils, Ebyasaph son fils, Assir son fils,"
,"9":"Tahat son fils, Ouriel son fils, Ouziyas son fils, Chaoul son fils."
,"10":"Fils d'Elkana: Amasaï et Ahimot."
,"11":"Elkana son fils, Sofaï son fils, Nahat son fils,"
,"12":"Elyab son fils, Yéroham son fils, Elkana son fils."
,"13":"Fils d'Elkana: l'aîné Samuel, le second Abiyas."
,"14":"Fils de Mérari: Mali, Libni son fils, Chiméï son fils, Ouza son fils,"
,"15":"Chiméa son fils, Hagiyas son fils, Azayas son fils."
,"16":"Voici ceux que David chargea d'organiser le chant dans la maison de Yahvé lorsque l'Arche eut son lieu de repos."
,"17":"Ils étaient chargés du chant devant la demeure de la Tente du Rendez-Vous jusqu'au jour où Salomon bâtit à Jérusalem la Maison de Yahvé. Ils accomplissaient leur service selon le règlement."
,"18":"Voici ceux qui reçurent cette charge, avec leurs fils: chez les Kahatites: Héman le chantre, fils de Yoël, fils de Samuel,"
,"19":"fils d'Elkana, fils de Yéroham, fils d'Eliel, fils Toha,"
,"20":"fils de Souf, fils d'Elkana, fils de Mahat, fils d'Amasaï,"
,"21":"fils d'Elkana, fils de Yoël, fils d'Azaria, fils de Séfanya,"
,"22":"fils de Tahat, fils d'Assir, fils d'Ebiasaph, fils de Koré,"
,"23":"fils d'Yisar, fils de Kahat, fils de Lévi, fils d'Israël."
,"24":"Son frère Asaph se tenait à sa droite: Asaph, fils de Bérékyas, fils de Chiméa,"
,"25":"fils de Mikaël, fils de Baaséya, fils de Malkiyas,"
,"26":"fils d'Etni, fils de Zéra, fils d'Adayas,"
,"27":"fils d'Etan, fils de Zimma, fils de Chiméï,"
,"28":"fils de Yahat, fils de Guérchom, fils de Lévi."
,"29":"A gauche se tenaient leurs frères, les fils de Mérari: Etan fils de Kichi, fils d'Abdi, fils de Malouk,"
,"30":"fils de Hachbayas, fils de Amassya, fils de Hilkiyas,"
,"31":"Fils de Amsi, fils de Bani, fils de Chémer,"
,"32":"fils de Mali, fils de Mouchi, fils de Mérari, fils de Lévi."
,"33":"Leurs frères, les lévites, s'occupaient de tout le service de la Demeure de la Maison de Dieu."
,"34":"Aaron et ses fils faisaient fumer les sacrifices sur l'autel des holocaustes et sur l'autel des parfums; ils s'occupaient de tout le service des rites sacrés et du rite de l'expiation pour Israël, selon tout ce qu'avait ordonné Moïse, serviteur de Dieu."
,"35":"Voici les fils d'Aaron: Eléazar son fils, Pinhas son fils, Abichoua son fils,"
,"36":"Bouki son fils, Ouzi son fils, Zérahya son fils,"
,"37":"Merayot son fils, Amarya son fils, Ahitoub son fils,"
,"38":"Sadoq son fils, Ahimaas son fils."
,"39":"Voici leurs lieux d'habitation et les frontières de leurs campements: d'abord les Kahatites fils d'Aaron. Voici ce que le sort leur attribua:"
,"40":"on leur donna Hébron dans le pays de Juda et les pâturages qui l'entourent,"
,"41":"mais on donna à Caleb fils de Yéfouné la campagne et les villages d'alentour."
,"42":"Quant aux fils d'Aaron, on leur donna des villes de refuge: Hébron, Libna et ses pâturages, Yattir, Echtémoa et ses pâturages,"
,"43":"Hilaz et ses pâturages, Débir et ses pâturages,"
,"44":"Akan et ses pâturages, Beth-Shémesh et ses pâturages."
,"45":"Dans le territoire de Benjamin on leur donna Guéba et ses pâturages, Alémet et ses pâturages, Anatot et ses pâturages. Au total: treize villes réparties entre les clans."
,"46":"Les autres fils de Kahat reçurent par le sort dix villes dans la tribu d'Ephraïm, dans la tribu de Dan et dans la demi-tribu de Manassé."
,"47":"Les fils de Guérchom et leurs clans reçurent treize villes dans la tribu d'Issacar, dans la tribu d'Asher, dans la tribu de Nephtali et dans la tribu de Manassé installée dans le Bashan."
,"48":"Les fils de Mérari et leurs clans reçurent du sort douze villes dans la tribu de Ruben, dans la tribu de Gad et dans la tribu de Zabulon."
,"49":"Les Israélites cédèrent aux lévites ces villes avec leurs pâturages."
,"50":"Ils cédèrent encore par le sort des villes auxquelles ils donnèrent leurs noms dans les territoires des tribus des fils de Juda, des fils de Siméon et des fils de Benjamin."
,"51":"D'autres clans Kahatites reçurent des territoires dans la tribu d'Ephraïm."
,"52":"On leur donna comme villes de refuge: Sichem et ses pâturages, dans la montagne d'Ephraïm; Guézer et ses pâturages;"
,"53":"Yoknéam et ses pâturages, Beth-Horon et ses pâturages;"
,"54":"Ayalon et ses pâturages; Gat-Rimmon et ses pâturages;"
,"55":"et dans la demi-tribu de Manassé: Taanak et ses pâturages; Yibléam et ses pâturages. Voilà pour les autres clans Kahatites."
,"56":"Les fils de Guérchom reçurent dans la demi-tribu de Manassé: Golan dans le Bashan et ses pâturages, Achtarot et ses pâturages;"
,"57":"dans la tribu d'Issacar: Quédesh et ses pâturages, Dabérat et ses pâturages,"
,"58":"Ramot et ses pâturages, Anem et ses pâturages;"
,"59":"dans la tribu d'Asher: Machal et ses pâturages, Abdon et ses pâturages,"
,"60":"Houkok et ses pâturages, Réhob et ses pâturages;"
,"61":"dans la tribu de Nephtali: Quédesh en Galilée et ses pâturages, Hamon et ses pâturages, Kiryatayim et ses pâturages."
,"62":"Les autres fils de Mérari reçurent dans la tribu de Zabulon: Rimmon et ses pâturages, Thabor et ses pâturages;"
,"63":"dans la tribu de Ruben, au-delà du Jourdain vers Jéricho, (à l'est du Jourdain) Béser dans le désert et ses pâturages, Yahsa et ses pâturages,"
,"64":"Kédémot et ses pâturages, Méfaat et ses pâturages;"
,"65":"et dans la tribu de Gad: Ramot en Galaad et ses pâturages, Mahanayim et ses pâturages,"
,"66":"Heshbon et ses pâturages, Yazer et ses pâturages."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Les quatre fils d'Issacar: Tola, Poua, Yachoub, Chimron."
,"2":"Fils de Tola: Ouzi, Réfayas, Yériel, Yahmaï, Yibsam, Chémouel, ce sont les chefs des familles de Tola. Ces familles au temps de David, comptaient vingt-deux mille six cents courageux guerriers."
,"3":"Fils d'Ouzi: Yizrahya. Fils d'Yizrahya: Mikaël, Obadyas, Yoël, Yichchya. Ils étaient cinq chefs,"
,"4":"responsables des trente-six mille hommes de guerre, appartenant à des familles et des clans comptant aussi de nombreuses femmes et enfants."
,"5":"Ils avaient des frères appartenant à tous les clans d'Issacar. Le total de ces courageux guerriers était de quatre-vingt-sept mille."
,"6":"Les trois fils de Benjamin: Béla, Béker, Yédiael."
,"7":"Fils de Béla: Esbon, Ouzi, Ouziel, Yérimot et Iri. Ils étaient chefs de cinq familles comptant vingt-deux mille trente-quatre courageux guerriers."
,"8":"Fils de Béker: Zémira, Yoach, Eliézer, Elyoenaï, Omri, Yérémot, Abiyas, Anatot, Alémét. C'étaient les fils de Béker,"
,"9":"chefs de familles groupant vingt mille deux cents courageux guerriers."
,"10":"Fils de Yédiael: Bilhan. fils de Bilhan: Yéouch, Benjamin, Ehoud, Kénaa, Zétan, Tarchich, Ahichaar."
,"11":"Ces fils de Yédiael devinrent chefs de familles comptant dix-sept mille deux cents courageux guerriers, prêts à partir en campagne et à combattre."
,"12":"Fils de Ir: Choupim et Oupim; Ouchim, Aher son fils."
,"13":"Fils de Nephtali: Yahasiel, Gouni, Yéser, Challoum. Ils étaient fils de Bilha."
,"14":"Fils de Manassé: Asriel, fils de sa concubine Araméenne. Elle enfanta aussi Makir, père de Galaad."
,"15":"Makir prit une femme pour Oupim et Choupim. Sa soeur s'appelait Maaka. Le second fils de Manassé était Séloféhad. Séloféhad n'eut que des filles."
,"16":"La femme de Makir, Maaka, lui donna un fils qu'elle appela Pérech. Son frère s'appelait Sérech, il eut pour fils Oulam et Rékem."
,"17":"Fils d'Oulam: Bédan. Voilà les fils de Galaad, fils de Makir, fils de Manassé."
,"18":"Sa soeur Ha-Moléket. Elle enfanta Ichéhod, Abiézer et Mahla."
,"19":"Chémida eut des fils: Ahyan, Sichem, Liki et Aniam."
,"20":"Fils d'Ephraïm: Choutela; Béred son fils; Tahat son fils; Eléada son fils; Tahat son fils;"
,"21":"Zabad son fils; Choutela son fils; Ezer et Eléad. Des hommes de Gat originaires du pays tuèrent ces deux-là, parce qu'ils étaient venus pour voler leurs troupeaux."
,"22":"Ephraïm leur père porta le deuil pendant de longs jours et ses frères vinrent le consoler."
,"23":"Il s'unit à sa femme, elle fut enceinte et lui donna un fils qu'elle appela Béria car, dit-elle: 'Le malheur est dans la maison.'"
,"24":"Sa fille Chéera bâtit Beth-Horon-le-bas, Beth-Horon-le-haut et Ouzen-Chéera."
,"25":"Fils de Béria: Réfah son fils, Réchef son fils, Téela son fils,"
,"26":"Ladan son fils, Amihoud son fils, Elichama son fils,"
,"27":"Noun son fils, Josué son fils."
,"28":"Le territoire où ils habitaient comprenait Béthel et ses dépendances, avec à l'est Naaran, à l'ouest Guézer et ses dépendances, Sichem et ses dépendances, jusqu'à Ayah et ses dépendances."
,"29":"Les fils de Manassé possédaient Beth-Shéan et ses dépendances, Taanak et ses dépendances, Méguiddo et ses dépendances, Dor et ses dépendances. Les fils de Joseph, fils d'Israël, habitaient ces villes."
,"30":"Fils d'Asher: Yimna, Yichva, Yichvi, Béria; leur soeur était Sérah."
,"31":"Fils de Béria: Héber et Malkiel, père de Birzayit."
,"32":"Héber engendra Yaflet, Chémer, Hotam et leur soeur Choua."
,"33":"Fils de Yaflet: Pasak, Bimhal et Hachfat. Voilà les fils de Yaflet."
,"34":"Fils de son frère Shémer: Roga, Houba et Aram."
,"35":"Fils de son frère Hélem: Sofa, Yimna, Chélech et Amal."
,"36":"Fils de Sofa: Chouah, Harnéfer, Choual, Béri, Yimra,"
,"37":"Béser, Hod, Chamma, Chilcha, Yitran et Bééra."
,"38":"Fils de Yitran: Yéfouné, Pispa et Ara."
,"39":"Fils d'Oulla: Arah, Haniel et Risiya."
,"40":"Voilà les fils d'Asher, chefs de familles, hommes d'élite et courageux guerriers. Ils étaient les premiers parmi les princes, à la tête de vingt-six mille hommes entraînés au combat."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Fils de Benjamin: premier-né Béla, second Achbel, troisième Ahiram,"
,"2":"quatrième Noha, cinquième Rafa."
,"3":"Fils de Béla: Addar, Géra père d'Ehoud,"
,"4":"Abichoua, Naham, Ahoa,"
,"5":"Géra, Chéfoufam et Houram."
,"6":"Voici les fils d'Ehoud qui étaient chefs des familles installées à Guéba et qui les conduisirent à Manahat:"
,"7":"Naaman, Ahiyas et Guéra; c'est celui-ci qui les conduisit à Manahat, il est le père de Ouza et Ahihoud."
,"8":"Après avoir répudié ses femmes Ouchim et Baara, Chaharayim eut des fils aux Champs-de-Moab."
,"9":"Sa nouvelle femme mit au monde: Yobab, Sibya, Mécha, Malkom,"
,"10":"Yéhous, Sakia, Mirma. Voilà ses fils, tous chefs de familles."
,"11":"Ouchim lui avait donné pour fils Abitoub et Elpaal."
,"12":"Fils d'Elpaal: Eber, Michéam et Chémed: c'est lui qui bâtit Ono, et Lod et ses dépendances."
,"13":"Béria et Chéma étaient chefs des familles résidant à Ayalon: ils mirent en fuite les habitants de Gat."
,"14":"Ahyo, Chéchak, Yérémot,"
,"15":"Zébadia, Arad, Eder,"
,"16":"Mikaël, Yichpa et Yoha étaient fils de Béria."
,"17":"Zébadia, Méchoullam, Hizki, Haber,"
,"18":"Yichméraï, Yizlia, Yobab étaient fils d'Elpahal."
,"19":"Yakim, Zikri, Zabdi,"
,"20":"Elyénaï, Silétaï, Eliël,"
,"21":"Adayas, Bérayas, Chimrat étaient fils de Chiméï."
,"22":"Yichpan, Eber, Eliël,"
,"23":"Abdon, Zikri, Hanan,"
,"24":"Hananya, Elam, Antotiyas,"
,"25":"Yifdéya, Pénuel étaient fils de Chéchak."
,"26":"Chamchéraï, Chéharya, Atalya,"
,"27":"Yaaréchya, Eliyas, Zichri étaient fils de Yéroham."
,"28":"Voilà les chefs de famille, groupés par clans, ils habitaient à Jérusalem."
,"29":"Ceux-ci habitaient à Gabaon: Yéhiël, père de Gabaon (sa femme s'appelait Maaka);"
,"30":"son premier-né Abdon, Sour, Quis, Baal, Ner, Nadab,"
,"31":"Guédor, Ahyo, Zaker et Miklot."
,"32":"Miklot engendra Chiméa. Mais auparavant ils avaient habité à Jérusalem comme leurs frères."
,"33":"Ner engendra Kich, Kich engendra Saül, Saül engendra: Jonathan, Malki-Choua, Abinadab et Echbaal."
,"34":"Fils de Jonathan: Méribaal qui engendra Mika."
,"35":"Fils de Mika: Piton, Mélek, Taréa, Ahaz."
,"36":"Ahaz engendra Yoada, Yoada engendra Alémet, Azmavet et Zimri. Zimri engendra Mosa."
,"37":"Mosa engendra Binéa. Descendance de Binéa: Rafa son fils, Eléaza son fils, Asel son fils."
,"38":"Voici les noms des six fils d'Asel: Azrikam, Bokrou, Ismaël, Chéarya, Obadya et Hanan: ce sont les fils d'Asel."
,"39":"Fils de Echek son frère: le premier-né Oulam, le second Yéouch, le troisième Elifélét."
,"40":"Les fils d'Oulam étaient de courageux guerriers, habiles à tirer à l'arc. Ils eurent beaucoup de fils et de petits-fils: cent cinquante. Tous ceux-là étaient de la tribu de Benjamin."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Tous les Israélites avaient été enregistrés dans le Livre des Rois d'Israël et de Juda avant d'être déportés à Babylone à cause de leur infidélité."
,"2":"Les premiers à revenir dans leurs propriétés et dans leurs villes furent ceux d'Israël: les prêtres, les lévites et les hommes consacrés au service de Dieu."
,"3":"Des fils de Juda, des fils de Benjamin, des fils d'Ephraïm et de Manassé s'installèrent à Jérusalem."
,"4":"Parmi les fils de Juda: Outaï fils d'Amihoud, fils d'Omri, fils d'Imri, fils de Bani, l'un des fils de Pérès, fils de Juda."
,"5":"Des Chélanites: Azaïa, l'aîné, et ses autres fils."
,"6":"Parmi les fils de Zéra: Yéouel. Plus leurs frères: six cent quatre-vingt-dix."
,"7":"Parmi les fils de Benjamin: Chalou fils de Méchoullam, fils de Hodavya, fils de Hasénoua;"
,"8":"Yibdnéya, fils de Yéroham; Ela, fils de Ouzi, fils de Mikri; Méchoullam fils de Chéfatya, fils de Réouel, fils Yibniya."
,"9":"Ils étaient neuf cent cinquante-six frères groupés par familles. Ils étaient tous chefs de leur propre famille."
,"10":"Parmi les prêtres: Yédayas, Yoyarib, Yakin,"
,"11":"Azaryas fils de Hilkiyas, fils de Méchoullam, fils de Sadoq, fils de Mérayot, fils d'Ahitoub, chef dans la Maison de Dieu,"
,"12":"Adayas fils de Yéroham, fils de Pachéhour, fils de Malkiyas, Maasaï fils d'Adiel, fils de Yahzéra, fils de Méchoullam, fils de Méchilémit, fils d'Immer."
,"13":"Leurs frères chefs de familles, comptaient mille sept cent soixante courageux guerriers chargés du service du Temple de Dieu."
,"14":"Parmi les lévites: Chémayas fils de Hachoub, fils d'Azrikam, fils de Hachbayas, un Mérarite;"
,"15":"Bakbakar, Hérech, Galal, Matanya fils de Mika, fils de Zikri, fils d'Azaf;"
,"16":"Obadya fils de Chémayas, fils de Galal, fils de Yédoutoun et Bérékya, fils d'Aza, fils d'Elkana: ils habitaient dans les villages aux alentours de Nétofa."
,"17":"Parmi les portiers: Challoum, Akoub, Talmon, Ahiman et leurs frères. Leur chef était Challoum."
,"18":"Ils sont encore aujourd'hui les portiers des camps de Lévi à la Porte Royale, à l'est."
,"19":"Challoum fils de Koré, fils d'Eby-Asaph, fils de Koré, et ses frères les Koréites appartenant à la même famille assuraient le service liturgique. Ils gardaient l'entrée de la Tente, tout comme leurs pères avaient été chargés de garder l'entrée du camp de Yahvé."
,"20":"Pinhas, fils d'Eléazar, en avait été autrefois le chef: que Yahvé soit avec lui!"
,"21":"Zakarie, fils de Méchélémya, était portier à l'entrée de la Tente du Rendez-Vous."
,"22":"Ces hommes avaient été choisis comme portiers des entrées, ils étaient deux cent douze , recensés par familles et par villages. David et Samuel le Voyant leur avaient confié cette charge à cause de leur fidélité."
,"23":"Avec leurs fils, ils étaient responsables des portes du Temple de Yahvé, de la maison de la Tente."
,"24":"Les portiers se tenaient aux quatre points cardinaux: à l'est, à l'ouest, au nord et au sud."
,"25":"Leurs frères habitaient dans leurs villages et se joignaient à eux de temps en temps, pour sept jours."
,"26":"Par contre, les quatre chefs des portiers y demeuraient en permanence. Ces lévites étaient préposés aux salles du trésor de la Maison de Dieu."
,"27":"Ils passaient la nuit à côté de la Maison de Dieu, car ils en avaient la garde et en possédaient la clé pour l'ouvrir chaque matin."
,"28":"D'autres parmi eux étaient chargés des objets du culte, ils les comptaient lorsqu'ils les rangeaient et lorsqu'ils les sortaient."
,"29":"D'autres encore étaient chargés des vases, de tous les vases sacrés, de la fleur de farine, du vin, de l'huile, de l'encens et des parfums."
,"30":"Mais c'étaient les fils de prêtres qui préparaient le mélange des parfums."
,"31":"L'un des lévites, Mattitya, premier-né de Challoum fils de Koré, eut la pleine responsabilité de la préparation des offrandes cuites sur la poële."
,"32":"Parmi leurs frères, les fils des Kahatites étaient chargés de disposer chaque Sabbat les pains en rangées."
,"33":"Chefs de familles au milieu des lévites, ils assuraient aussi le chant: ils vivaient dans des pièces à part, car de jour et de nuit, ils étaient responsables de ce service."
,"34":"Voilà les chefs des familles de lévites, d'après leur descendance; ils habitaient à Jérusalem."
,"35":"Yéouel, père de Gabaon, habitait cette ville avec sa femme Maaka,"
,"36":"son premier-né Abdon, Sour, Kich, Baal, Ner, Nadab,"
,"37":"Guédor, Ahyo, Zékarias et Miklot."
,"38":"Miklot engendra Chiméam. Comme leurs frères, ces derniers avaient habité autrefois à Jérusalem."
,"39":"Ner engendra Kich, Kich engendra Saül, Saül engendra Jonathan, Malki-Choua, Abinadab, Echbaal."
,"40":"Fils de Jonathan: Meribaal. Meribaal engendra Mika."
,"41":"Fils de Mika: Piton, Mélek, Taréa."
,"42":"Akaz engendra Yara, Yara engendra Alémet, Azmavet et Zimri. Zimri engendra Mosa."
,"43":"Mosa engendra Binéa. Il eut pour fils Réfayas, qui eut pour fils Eléaza, qui eut pour fils Asel."
,"44":"Voici les noms des six fils d'Asel: Azrikam, Bokrou, Ismaël, Chéarya, Obadya et Hanan. C'étaient les fils d'Asel."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Les Philistins firent la guerre à Israël, les Israélites s'enfuirent devant les Philistins et tombèrent frappés à mort sur le mont Guelboé."
,"2":"Les Philistins serraient de près Saül et ses fils: ils tuèrent Jonathan, Aminadab et Malki-Choua, fils de Saül."
,"3":"La bataille se reporta sur Saül; des archers le découvrirent et se voyant face à eux, il fut pris de panique."
,"4":"Saül dit alors à son écuyer: 'Dégaine ton épée et transperce-moi. Il ne faut pas que ces incirconcis arrivent sur moi et se jouent de moi.' Mais son écuyer ne voulut pas: il avait peur. Saül prit donc son épée et se jeta sur elle."
,"5":"Lorsque son écuyer vit qu'il était mort, il se jeta lui aussi sur son épée et mourut avec lui."
,"6":"C'est ainsi que ce jour-là, Saül, ses trois fils et toute sa maison moururent ensemble."
,"7":"Apprenant la défaite, la mort de Saül et de ses fils, les Israélites qui habitaient la vallée abandonnèrent leurs villes et prirent la fuite. Les Philistins arrivèrent et s'établirent à leur place."
,"8":"Le lendemain, les Philistins venus pour dépouiller les morts trouvèrent Saül et ses fils gisant sur le mont Guelboé."
,"9":"Ils le dépouillèrent et emportèrent sa tête et ses armes, puis ils firent porter cette bonne nouvelle dans tout le pays des Philistins, à leurs idoles et à toute la populace."
,"10":"Ils mirent ses armes dans le temple de leurs dieux et suspendirent sa tête dans le temple de Dagon."
,"11":"Lorsque les habitants de Yabesh de Galaad apprirent comment les Philistins avaient traité Saül,"
,"12":"tous les braves parmi eux se mirent en route; ils emportèrent les corps de Saül et de ses fils et les ramenèrent à Yabesh. Ils enterrèrent leurs ossements sous le térébinthe et jeûnèrent durant sept jours."
,"13":"C'est ainsi que mourut Saül: il avait été infidèle envers Yahvé, il n'avait pas observé sa parole, il s'était même rendu chez une nécromancienne pour la consulter."
,"14":"Mais il n'avait pas consulté Yahvé: Yahvé le fit mourir et donna sa royauté à David, fils de Jessé."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Tout le peuple d'Israël se rassembla auprès de David à Hébron, en disant: 'Regarde, nous sommes de ta chair et de ton sang."
,"2":"Même quand Saül était notre roi, tu conduisais les Israélites au combat; et Yahvé ton Dieu t'a dit: Tu seras le berger de mon peuple Israël, c'est toi qui le dirigeras.'"
,"3":"Alors tous les anciens d'Israël vinrent trouver le roi à Hébron et David conclut une alliance avec eux à Hébron en présence de Yahvé. Il sacrèrent David comme roi sur Israël, selon la promesse que Yahvé avait faite par la voix de Samuel."
,"4":"David et tous les Israélites attaquèrent Jérusalem (c'était alors Jébus et là vivaient les Jébusites)."
,"5":"Les habitants de Jébus dirent à David: 'Tu n'entreras pas ici!' Mais David s'empara de la forteresse de Sion: c'est la Cité de David."
,"6":"David dit: 'Le premier qui attaquera les Jébusites deviendra le chef et commandera l'armée.' C'est Joab, fils de Serouyah, qui attaqua le premier, et il devint le commandant."
,"7":"David s'installa dans la forteresse, c'est pourquoi elle fut appelée la Cité de David."
,"8":"Alors il construisit autour de la ville depuis le Millo jusqu'aux environs, tandis que Joab restaurait le reste de la ville."
,"9":"David devint de plus en plus glorieux, et Yahvé Sabaot était avec lui."
,"10":"Voici quels étaient les célèbres guerriers de David, ceux qui sous son règne se battirent à ses côtés, avec tout Israël, pour le faire roi comme Yahvé l'avait promis."
,"11":"Voici la liste de ces guerriers de David: Ishbaal le Hakmonite, le chef des Trois; un jour il donna le signal avec sa lance et tua trois cents ennemis d'un seul coup."
,"12":"Après lui, Eléazar fils de Dodo, l'Akokite; c'était l'un des Trois."
,"13":"Il était auprès de David à Pasdamim où les Philistins s'étaient rassemblés avant l'attaque. Il y avait un champ plein d'orge à cet endroit. Quand les Israélites commencèrent à s'enfuir,"
,"14":"Eléazar prit position fermement dans le champ, le défendit et combattit les Philistins; Yahvé donna là aux Israélites une grande victoire."
,"15":"Trois d'entre les Trente rejoignirent David près de la grotte d'Adoullam au temps de la moisson, tandis qu'une compagnie de Philistins campait dans la vallée de Réfaïm."
,"16":"David était à ce moment dans la forteresse, alors que les Philistins occupaient Bethlehem."
,"17":"David soupira et dit: 'Oh! Si seulement on allait me chercher à boire de l'eau de la citerne qui se trouve près de la porte de Bethlehem!'"
,"18":"Les Trois se frayèrent donc un passage à travers le camp des Philistins, tirèrent de l'eau de la citerne près de la porte de Bethlehem et l'apportèrent pour l'offrir à David. Mais David refusa de la boire et la versa en offrande à Yahvé."
,"19":"'Dieu, dit-il, garde-moi de faire une chose pareille! Boirai-je le sang de ces hommes? Car c'est au péril de leur vie qu'ils l'ont rapportée.' Ainsi il ne voulut pas la boire. Voilà ce qu'ont fait les Trois guerriers."
,"20":"Abisaï, frère de Joab, était le chef des Trente. Il donna un signal avec sa lance et abattit trois cents ennemis, se faisant ainsi un nom parmi les Trente."
,"21":"Il était le plus réputé des Trente et devint leur commandant, mais il ne fut pas aussi célèbre que les Trois."
,"22":"Benayas, fils de Yoyada, un héros originaire de Kabzeel, accomplit de nombreux exploits; il tua les deux fils d'Ariel de Moab. Un jour de neige, il descendit dans une fosse et tua le lion qui s'y trouvait."
,"23":"Il tua également un Egyptien, un homme de plus de deux mètres de haut. L'Egyptien était armé d'une lance longue comme une pièce de métier à tisser, mais Benayas s'attaqua à lui avec un bâton, fit voler la lance des mains de l'Egyptien et le tua de sa propre lance."
,"24":"Ces hauts faits de Benayas fils de Yoyada lui valurent un nom parmi les Trente."
,"25":"Il était réputé parmi les Trente, mais il ne fut pas aussi célèbre que les Trois. David le fit chef de sa garde personnelle."
,"26":"Les autres braves étaient: Azaël, frère de Joab; Elhanan, fils de Dodo, originaire de Bethlehem;"
,"27":"Chammoth de Harod; Hélès de Pélet;"
,"28":"Hira fils de Ikech, de Tékoa; Abiézer, d'Anatot;"
,"29":"Sibékaï, le Huchatite; Ilaï, l'Ahohite;"
,"30":"Maharaï, de Nétofa; Héléd fils de Baanah, de Netofa;"
,"31":"Ittaï fils de Ribaï, de Guibeah des fils de Benjamin; Benayas, de Piréaton;"
,"32":"Houraï, des Torrents-de-Gaash; Abiël, de Beth-Ha-Arabah;"
,"33":"Azmavét, de Bahourim; Elyahba, de Shaalbon;"
,"34":"les fils de Hashém le Gizonite; Yonathan fils de Shagué, le Hararite;"
,"35":"Ayiam fils de Sakar, le Hararite; Elifelet, fils d'Our;"
,"36":"Efer, le Mékéra tite; Ahiyas le Pélonite;"
,"37":"Hesro de Karmel; Naaraï, fils d'Ezabaï;"
,"38":"Yoël, frère de Nathan; Mibhar, fils d'un Gadite;"
,"39":"Sélec, l'Ammonite; Naharaï de Beéroth, porteur d'armes de Joab, fils de Serouya;"
,"40":"Ira de Yattir; Gareb de Yattir;"
,"41":"Urie, le Hittite; Zabad, fils d'Ahlaï;"
,"42":"Adina fils de Shiza, le Rubénite, chef des Rubénites, et trente autres avec lui;"
,"43":"Hanan, fils de Maakah; Josaphat, le Mitnite;"
,"44":"Ouzzia d'Ashtarot; Shama et Yoël, fils de Hotham d'Aroër;"
,"45":"Yédiaël fils de Shimri et Yoha son frère, le Tisite;"
,"46":"Eliel, de Mahum; Yéribaï et Yochavya, fils d'Elnaam; Yetma, le Moabite;"
,"47":"Eliel, Obed et Yasiel de Soba."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Voici ceux qui rejoignirent David à Siklag, lorsqu'il était loin de Saül, fils de Kich. C'étaient des combattants courageux et dignes de confiance, membres de la tribu de Benjamin, à laquelle appartenait Saül."
,"2":"C'étaient des archers capables de lancer des pierres ou de tirer des flèches de la main gauche comme de la main droite. Parmi les gens de Benjamin, frères de Saül, "
,"3":"il y avait Ahiézer, le chef, et Yoach, tous deux fils d'Achemaa de Guibéa; Yéziel et Pélet, fils d'Azmavet; Béraka; Yéhou d'Anatot;"
,"4":"Yichmayas de Gabaon, l'un des Trente braves et le chef des Trente;"
,"5":"Yirméya; Yahaziel; Yohanan; Yozabad, de Guédérot;"
,"6":"Eluzaï; Yérimot; Béalya; Chémaryas; Chéfatyas de Harif;"
,"7":"Elkana, Yichiyas, Azaréel, Yoézer et Yachobéam, fils de Koré;"
,"8":"Yoéla et Zabadya, fils de Yéroham, de Guédor."
,"9":"Quelques Gadites désertèrent pour rejoindre les troupes de David quand il était retranché dans le désert. C'étaient de vaillants combattants, habiles à manier le bouclier et la lance. Ils étaient féroces comme des lions et rapides comme des bouquetins."
,"10":"Ezer était le chef, Obadyah le second, Eliab le troisième,"
,"11":"Machmanna le quatrième, Yirméya le cinquième,"
,"12":"Attaï le sixième, Eliël le septième,"
,"13":"Yohanan le huitième, Elzabad le neuvième,"
,"14":"Yirmeyas le dixième, Makbannaï le on zième."
,"15":"Ces fils de Gad étaient les têtes de l'armée: le moins expérimenté valait à lui seul cent hommes, le plus expérimenté en valait mille."
,"16":"Ce sont eux qui traversèrent le Jourdain au premier mois, quand il déborde de ses rives et met en fuite les habitants des vallées de l'est comme de l'ouest."
,"17":"Des hommes sortis des tribus de Benjamin et de Juda rejoignirent David dans son refuge."
,"18":"David vint à leur rencontre et leur dit: 'Si vous venez à moi en amis, pour me soutenir, je suis prêt à me joindre à vous. Mais si c'est pour me livrer à mes adversaires alors que je n'ai rien fait de mal, que le Dieu de nos pères le voie et vous punisse.'"
,"19":"Alors l'esprit de Dieu s'empara d'Amasaï, chef des Trente: 'Nous sommes à toi, David!,Nous sommes avec toi, fils de Jessé!,La paix soit avec toi et avec qui te soutient, Car Dieu est avec toi!',David les accueillit et les fit officiers dans son armée."
,"20":"Quelques-uns de la tribu de Manassé se rallièrent à David alors qu'il se préparait avec les Philistins à lutter contre Saül. Mais David n'aida pas les Philistins, parce que leurs chefs avaient décidé en conseil de le renvoyer. Ils se disaient: 'Il rejoindra son maître Saül au prix de notre vie.'"
,"21":"Il était sur le chemin de Siklag quand les hommes de Manassé se joignirent à lui: c'étaient Adnah, Yozabad, Yédiaël, Mikaël, Yozabad, Elihou et Silétaï, chefs de milliers en Manassé."
,"22":"Ils étaient un bon renfort pour David et ses troupes, car c'étaient tous d'excellents soldats: ils devinrent officiers dans l'armée."
,"23":"En fait, presque tous les jours de nouveaux hommes se joignaient aux forces de David si bien que son camp devint un camp énorme."
,"24":"Voici des chiffres tirés de la liste des braves qui se joignirent à David à Hébron pour lui remettre la royauté de Saül, selon la volonté de Yahvé:"
,"25":"Les fils de Juda portant bouclier et lance: six mille huit cents hommes équipés pour le combat."
,"26":"Des fils de Siméon: sept mille cent hommes parfaitement entraînés."
,"27":"Des fils de Lévi: quatre mille six cents,"
,"28":"s'ajoutant à Yoyada, renommé parmi les fils d'Aaron, à la tête de trois mille sept cents hommes,"
,"29":"et Sadoq, un jeune et habile combattant, vingt deux chefs de sa famille."
,"30":"Des fils de Benjamin: trois mille parents de Saül, dont la plupart avaient été au service de la maison de Saül."
,"31":"Des fils d'Ephraïm: vingt mille huit cents hommes de renom dans leurs familles."
,"32":"De la moitié de la tribu de Manassé: dix-huit mille hommes qui furent désignés nommément pour aller proclamer David roi."
,"33":"Des fils d'Issacar, sachant discerner les moments où Israël devait agir et la façon de le faire: deux cents chefs avec leurs parents sous leurs ordres."
,"34":"De Zabulon: cinquante mille hommes entraînés et prêts au combat avec toutes sortes d'armes, des gens qui combattaient résolument."
,"35":"De Nephtali: mille commandants, et avec eux trente-sept mille hommes armés de boucliers et de lances."
,"36":"De Dan: vingt-huit mille six cents hommes prêts au combat."
,"37":"D'Asher: quarante mille hommes entraînés au combat."
,"38":"Venant de Transjordanie: cent vingt mille hommes de Ruben, Gad et la moitié de la tribu de Manassé avec toutes sortes d'armes."
,"39":"Tous ces guerriers prêts au combat, vinrent spontanément pour proclamer David roi sur tout Israël; tout le reste d'Israël d'ailleurs, était d'accord pour proclamer David roi."
,"40":"Ils restèrent là pendant trois jours, prenant leurs repas et buvant avec David, car leurs parents leur avaient envoyé des vivres."
,"41":"D'ailleurs, du plus loin d'Issacar, de Zabulon ou de Nephtali, on leur apportait des provisions sur des ânes, des chameaux, des mulets et des boeufs: de la farine, des gâteaux de figues, des raisins secs, du vin, de l'huile, des quantités de boeufs et de moutons, car la joie régnait en Israël."
}`)
	CurrentBook.AddChapter(13, `{
"1":"David tint conseil avec les chefs des milliers et des centaines, et avec tous les commandants."
,"2":"David dit à toute l'assemblée d'Israël: 'Si vous acceptez, et si Yahvé notre Dieu le veut, nous enverrons des messagers vers nos frères à travers tous les territoires d'Israël, ainsi que vers les prêtres et les lévites dans leurs villes et leurs environs pour leur dire de venir nous rejoindre."
,"3":"Nous irons alors chercher l'Arche de notre Dieu, car du temps de Saül nous l'avons négligée."
,"4":"Ils furent d'accord avec cette proposition, car aux yeux de tout le peuple, cela paraissait juste."
,"5":"Aussi David rassembla-t-il tout le peuple depuis le Shihor d'Egypte jusqu'au défilé de Hamat pour ramener l'Arche de Kiryat-Yéarim."
,"6":"Alors David et les Israélites montèrent à Baala, c'est-à-dire Kiryat-Yéarim dans le pays de Juda, pour apporter l'Arche de Dieu qui porte le nom de 'Yahvé assis sur les Chérubins.'"
,"7":"A la maison de Abinadab, ils placèrent l'Arche de Dieu sur un chariot neuf. Ouza et Ahyo conduisaient le chariot."
,"8":"David et les Israélites dansaient devant Dieu de toutes leurs forces, ils chantaient en s'accompagnant de lyres, harpes, tambourins, cymbales et trompettes."
,"9":"Quand ils arrivèrent à l'aire de Kidon, les boeufs trébuchèrent et Ouza étendit la main pour retenir l'Arche."
,"10":"Alors la colère de Yahvé éclata contre Ouza et il le fit mourir, car il avait étendu la main et touché l'Arche. Il mourut là devant Dieu."
,"11":"David fut contrarié de voir que Yahvé avait 'brisé' Ouza; aussi donna-t-on à ce lieu le nom de Pérez-Ouza qu'il a gardé jusqu'à ce jour."
,"12":"Ce jour-là David fut rempli de la crainte de Dieu, il dit: 'Je ne vais sûrement pas introduire l'Arche de Dieu dans ma maison!'"
,"13":"David ne fit donc pas entrer l'Arche dans sa maison, dans la Cité de David; il la conduisit chez Obèd-Edom de Gat."
,"14":"L'Arche de Dieu demeura chez Obèd-Edom, dans sa maison, pendant trois mois: Yahvé bénit la famille d'Obèd-Edom et tout ce qui lui appartenait."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Hiram, roi de Tyr, envoya des messagers à David avec du bois de cèdre, des tailleurs de pierre et des charpentiers pour lui bâtir un palais."
,"2":"David sut alors que Yahvé l'avait établi roi sur Israël: son royaume était en train de monter pour le bien des Israélites."
,"3":"David prit encore des femmes à Jérusalem: il en eut des fils et des filles."
,"4":"Voici les noms de ces fils qui lui sont nés à Jérusalem: Chammoua, Chobab, Nathan, Salomon,"
,"5":"Yibhar, Elichoua, Elpalet,"
,"6":"Nogah, Népheg, Yafia,"
,"7":"Elichama, Baalyada, Elifélét."
,"8":"Quand les Philistins apprirent que David avait été consacré comme roi sur tout Israël, ils marchèrent tous sur lui pour le capturer. En apprenant cela, David partit à leur rencontre."
,"9":"Les Philistins arrivèrent et commencèrent à se déployer dans la vallée des Réfaïm."
,"10":"David alors consulta Yahvé: 'Dois-je attaquer les Philistins? Vas-tu me les livrer?' Yahvé lui répondit: 'Attaque! Je te les livrerai!'"
,"11":"Les Philistins montèrent vers Baal-Pérasim, et là David les battit. David dit: 'Dieu a fait une brèche à travers eux comme ferait l'eau dans une digue.' C'est pour cela qu'on donna à ce lieu le nom de Baal-Pérasim."
,"12":"Ils avaient abandonné là leurs dieux et David donna l'ordre de les brûler."
,"13":"Les Philistins se déployèrent de nouveau dans la vallée."
,"14":"De nouveau David consulta Dieu, et Dieu lui répondit: 'Ne les attaque pas de face mais contourne-les. Prépare-toi à les attaquer de l'autre côté près des micocouliers."
,"15":"Quand tu entendras un bruit de pas dans le haut de ces arbres, lance ton attaque: c'est Dieu qui passe devant toi pour battre l'armée des Philistins.'"
,"16":"David fit comme Yahvé le lui avait ordonné: ils battirent l'armée philistine depuis Gabaon jusqu'à Guézer."
,"17":"La renommée de David s'étendit partout et Yahvé le rendit redoutable à toutes les nations."
}`)
	CurrentBook.AddChapter(15, `{
"1":"David construisit des édifices dans la Cité de David et il prépara une place pour l'Arche de Dieu: il dressa une tente pour elle."
,"2":"Puis il dit: 'Seuls les lévites déplaceront l'Arche de Dieu puisque Yahvé les a choisis pour porter l'Arche et le servir à jamais!'"
,"3":"David rassembla alors les Israélites à Jérusalem pour transporter l'Arche de Dieu au lieu qu'il lui avait préparé."
,"4":"David réunit les fils d'Aaron et les fils de Lévi:"
,"5":"parmi les fils de Kahat: Ouriel, le chef, et ses cent vingt frères."
,"6":"Des fils de Mérari: Asayas et ses deux cent vingt frères."
,"7":"Des fils de Guerchom: Yoël et ses cent trente frères."
,"8":"Des fils de Elisafan: Chemayas et ses deux cents frères."
,"9":"Des fils d'Hébron: Eliel et quatre-vingts de ses frères."
,"10":"Des fils de Ouziel: Aminadab et ses cent douze frères."
,"11":"David appela les prêtres Sadoq et Ebyatar, et les lévites Ouriel, Asayas, Yoël, Chemayas, Eliel et Aminadab."
,"12":"Il leur dit: ' Vous êtes les chefs de familles des lévites. Purifiez-vous, vous et vos frères, et apportez l'Arche de Yahvé Dieu d'Israël jusqu'à l'endroit que je lui ai préparé."
,"13":"La première fois vous n'étiez pas là pour la porter, et Yahvé notre Dieu nous a punis pour ne pas l'avoir consulté comme nous aurions dû le faire.'"
,"14":"Ainsi les prêtres et les lévites se purifièrent pour emporter l'Arche de Yahvé Dieu d'Israël."
,"15":"Les lévites portèrent l'Arche de Dieu avec des barres sur leurs épaules, comme Moïse l'avait ordonné selon la volonté de Yahvé."
,"16":"Alors David dit aux lévites qui dirigeaient, de désigner quelques-uns d'entre eux pour chanter et jouer gaiement de leurs divers instruments de musique: harpes, lyres et cymbales."
,"17":"Les lévites désignèrent: Héman, fils de Yoël; Asaph, fils de Bérébyas, un de ses frères; Etam, fils de Kouchayas, un de leurs frères Mérarites;"
,"18":"et avec eux, leurs frères de second rang: les portiers: Zékaryas, Ouziel, Chémiramot, Yéhiel, Ouni, Eliab, Benayas, Maaséyas, Mattityas, Eliflés, Miknéyas, Obèd-Edom, Yéhiël."
,"19":"Les chantres Heyman, Asaph, et Eytan faisaient sonner les cymbales de bronze."
,"20":"Zékarias, Ouziel, Chemiramoth, Yéhiel, Ounni, Eliab, Maaséyas et Benayas jouaient de la harpe en sourdine."
,"21":"Mattityas, Eliflés, Miknéyas, Obèd-Edom, Yéhiël et Azazyas donnant le rythme, jouaient de la lyre à l'octave."
,"22":"Kenanyas, chef du transport, dirigeait les lévites chargés du transport, car il s'y connaissait."
,"23":"Bérékyas et Elkana étaient portiers de l'Arche."
,"24":"Les prêtres Chebanyas, Yochafat, Nétanéel, Amasaï, Zékaryas, Benayas et Eliézer jouaient de la trompette devant l'Arche de Dieu. Obèd-Edom et Yéhiyas étaient portiers de l'Arche."
,"25":"Ainsi, David avec les chefs d'Israël et les commandants de milliers partirent de la maison d'Obèd-Edom avec des chants de joie: ils portaient l'Arche de l'Alliance de Yahvé."
,"26":"Et tandis que Dieu veillait sur les lévites qui portaient l'Arche de l'Alliance de Yahvé, on sacrifia sept taureaux et sept béliers."
,"27":"David, tous les lévites qui portaient l'Arche, les chantres et Kénanyas, responsable du transport, étaient vêtus de manteaux de lin fin. David portait aussi l'Ephod de lin."
,"28":"Tout Israël accompagna l'Arche d'Alliance de Yahvé avec des cris de joie et des sonneries de cors, de trompettes et de cymbales, jouant de la musique sur les harpes et les lyres."
,"29":"Comme l'Arche de l'Alliance de Yahvé entrait dans la cité de David , Mikal, la fille de Saül était à sa fenêtre et regardait. Elle vit le roi David qui dansait et sautait, et elle le méprisa."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Ils apportèrent l'Arche de Dieu et l'installèrent dans la tente que David avait préparée pour elle, puis on offrit à Dieu de l'encens et des offrandes de paix."
,"2":"Après avoir offert les holocaustes et les sacrifices de communion, David bénit le peuple au nom de Yahvé."
,"3":"Puis il distribua à tous les Israélites, hommes et femmes , à chacun une miche de pain, un morceau de viande rôtie et un gâteau de raisins."
,"4":"David désigna quelques-uns des lévites pour servir devant l'Arche de Yahvé, pour célébrer, remercier et rendre gloire à Yahvé Dieu d'Israël:"
,"5":"d'abord Asaph, ensuite Zékarias, puis Ouziel, Chemiramot, Yéhiel, Mattityas, Eliab, Benayas, Obèd-Edom, Yéhïel. Ils jouaient de la harpe et de la lyre pendant qu'Asaph faisait retentir les cymbales."
,"6":"Les prêtres Benayas et Yahaziël jouaient sans interruption de la trompette devant l'Arche de l'Alliance de Dieu."
,"7":"Ce jour-là, pour la première fois, David chargea Asaph et ses frères de rendre grâces:"
,"8":"Rendez grâce à Yahvé, invoquez son Nom, Proclamez ses hauts faits parmi les peuples."
,"9":"Chantez pour lui, chantez ses louanges, Racontez toutes ses merveilles."
,"10":"Gloire à son Saint Nom, Que les coeurs qui cherchent Yahvé se réjouissent!"
,"11":"Cherchez Yahvé et sa puissance, Cherchez sa face inlassablement,"
,"12":"Rappelez-vous les merveilles qu'il a faites, Ses miracles, les jugements qui sont sortis de sa bouche."
,"13":"Descendants d'Israël, son serviteur, Fils de Jacob, son élu."
,"14":"C'est Yahvé notre Dieu, Ses lois emplissent toute la terre."
,"15":"Souvenez-vous de son alliance à jamais, De sa promesse faite à mille générations."
,"16":"De l'Alliance qu'il a faite pour toujours avec Abraham, De sa promesse à Isaac,"
,"17":"il en a fait une loi pour Jacob, Une alliance éternelle pour Israël."
,"18":"Il a dit: 'Je vous donne en héritage,La terre de Canaan;"
,"19":"Vous étiez pourtant peu nombreux, Etrangers aux pays, vous ne comptiez pour rien.'"
,"20":"Ils erraient de nation en nation, D'un royaume à l'autre."
,"21":"Mais il ne laissa personne les opprimer,Et punit des rois par égard pour eux."
,"22":"Ne touchez pas à mes oints, Ne faites pas de mal à mes prophètes."
,"23":"Chantez pour Yahvé, toute la terre. Proclamez jour après jour son salut."
,"24":"Annoncez sa gloire parmi les nations, Ses merveilles à tous les peuples."
,"25":"Yahvé est grand et mérite les louanges, il est plus redoutable que tous les dieux."
,"26":"Moins que rien sont les dieux des nations, C'est Yahvé lui-même qui fit les cieux."
,"27":"Splendeur et majesté s'avancent devant lui, Louange et joie sont dans son sanctuaire."
,"28":"Rendez à Yahvé, familles des peuples, Rendez à Yahvé gloire et louange."
,"29":"Rendez à Yahvé la gloire de son Nom. Apportez des offrandes et prosternez-vous devant lui. Servez Yahvé en ornements sacrés."
,"30":"Sois attentive, terre entière, devant lui!,Fort, il a fait le monde, il ne peut être ébranlé."
,"31":"Que les cieux se réjouissent, que la terre exulte de joie!,Annoncez à toutes les nations: Yahvé est roi!"
,"32":"Que gronde la mer et tout ce qu'elle contient, Que jubilent les champs et tout ce qui est en eux."
,"33":"Que les arbres de la forêt crient de joie,En présence de Yahvé, Car il vient pour gouverner la terre."
,"34":"Rendez grâce à Yahvé, car il est bon, Son amour durera toujours."
,"35":"Dites: 'Sauve-nous, ô Dieu, notre Sauveur, Rassemble-nous et délivre-nous d'entre les nations. Pour que nous puissions rendre grâce à ton saint Nom,Et que notre gloire soit de te louer."
,"36":"Béni soit Yahvé Dieu d'Israël, Eternellement et pour toujours!,Que tous les peuples disent: Amen, Alléluia!'"
,"37":"David laissa là, devant l'Arche d'Alliance de Yahvé, Asaph et ses frères lévites pour le service de l'Arche selon le rituel de chaque jour."
,"38":"Il laissa aussi Obèd-Edom avec ses soixante-huit frères. Obèd-Edom, fils de Yédoutoun et Osah, étaient les gardiens de la porte."
,"39":"Il laissa Sadoq et les prêtres, ses frères, devant la Sainte Tente de Yahvé sur le Haut-Lieu qui est à Gabaon,"
,"40":"pour offrir l'holocauste à Yahvé, matin et soir, sur l'autel de l'holocauste, et pour accomplir tout ce qui est écrit dans la Loi que Yahvé a prescrite à Israël."
,"41":"Avec eux se trouvaient Heyman et Yédoutoun, et d'autres choisis et désignés par leurs noms pour rendre gloire à Dieu: 'Car son amour est éternel.'"
,"42":"Avec eux étaient ceux qui devaient jouer de la trompette, des cymbales et de tous les instruments de musique pour accompagner les hymnes à Dieu. Les fils de Yédoutoun se tenaient à la porte."
,"43":"Après cela tous repartirent, chacun chez lui; David aussi s'en retourna pour bénir sa maison."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Lorsque David était déjà dans sa maison, il dit au prophète Nathan: 'Voilà, je vis dans une maison de cèdre mais l'Arche de l'Alliance de Yahvé demeure sous une tente de toile.'"
,"2":"Nathan dit à David: 'Tout ce que tu as dans le coeur, fais-le, car Dieu est avec toi.'"
,"3":"Mais cette nuit même, Yahvé dit à Nathan:"
,"4":"'Va dire à mon serviteur David cette parole de Yahvé: Ce n'est pas toi qui me construiras une Maison pour que j'y habite!"
,"5":"Je n'ai jamais habité un temple de tout le temps que j'ai conduit Israël jusqu'à aujourd'hui; mais je suis allé de tente en tente, d'un abri à l'autre."
,"6":"Durant tout mon voyage avec les Israélites, ai-je dit à un seul des juges d'Israël que j'avais désignés comme bergers de mon peuple: Pourquoi ne me construis-tu pas un temple en bois de cèdre?"
,"7":"Tu vas transmettre à mon serviteur David cette parole de Yahvé Sabaot: Je t'ai pris derrière le troupeau pour être à la tête d'Israël, mon peuple."
,"8":"Je suis allé avec toi partout où tu es allé, et j'ai vaincu tous tes ennemis devant toi. Je rendrai ton nom aussi célèbre que le nom des plus grands sur terre."
,"9":"Je donnerai un lieu à mon peuple Israël; là je les fixerai, et là ils vivront. Ils ne seront plus jamais perturbés, plus jamais les méchants ne les opprimeront."
,"10":"Le temps est fini où j'établissais des juges sur mon peuple Israël; j'ai soumis tous tes ennemis et je t'ai annoncé que je te bâtirais une maison."
,"11":"Et quand tes jours seront finis, que tu devras mourir et être enterré avec tes ancêtres, je te donnerai un successeur sorti de toi, un de tes fils, et je grandirai son royaume."
,"12":"Il me construira un temple et j'affermirai son trône pour toujours."
,"13":"Je serai un père pour lui et lui sera pour moi un fils. Je ne lui retirerai pas ma faveur comme j'ai fait pour celui qui régnait avant toi."
,"14":"Je lui donnerai la charge de ma maison et de mon royaume pour toujours, sa royauté sera ferme à jamais.'"
,"15":"Nathan raconta à David ces paroles et cette vision."
,"16":"Alors le roi David entra, s'assit devant Yahvé et dit: 'Je ne suis pas digne de tout ce que tu as déjà fait pour moi, Yahvé Dieu, et ma famille non plus."
,"17":"Pourtant, ô Dieu, ce n'était pas encore assez à tes yeux. Tu me fais maintenant une promesse pour ma descendance qui va loin dans l'avenir. Tu m'as considéré comme un grand homme, ô Yahvé Dieu!"
,"18":"Que puis-je te dire de plus? Tu connais ton serviteur David."
,"19":"Tout ce que tu as fait, Yahvé, tu l'as fait par bonté pour ton serviteur et pour manifester ta grandeur."
,"20":"O Yahvé! Nul n'est comme toi! Il n'y a pas de Dieu, excepté toi seul, dont nous ayons entendu les paroles."
,"21":"Y a-t-il un autre peuple sur terre comme ton peuple Israël? Y a-t-il une seule nation sur la terre que Dieu ait achetée pour en faire son peuple? Tu as rendu célèbre ton peuple. Tu as fait pour lui des choses grandes et terribles: tu as chassé les nations devant lui lorsque tu l'as racheté d'Egypte."
,"22":"Tu as fait du peuple d'Israël ton propre peuple à jamais, et toi, Yahvé, tu es devenu son Dieu."
,"23":"Maintenant, Yahvé, fais que dure la promesse que tu m'as faite au sujet de ma descendance, et agis comme tu l'as dit."
,"24":"Que cette promesse tienne bon et que ton Nom soit exalté à jamais; que l'on puisse dire: 'Yahvé Sabaot, le Dieu d'Israël, est un Dieu pour Israël'. Fais que ma descendance se tienne fermement devant toi pour toujours."
,"25":"O mon Dieu! Tu as fait savoir à ton serviteur que tu lui construiras une maison; c'est pourquoi ton serviteur a l'audace de te faire cette demande."
,"26":"Oui, Yahvé, c'est toi qui promets ce bonheur à ton serviteur, toi qui es vraiment Dieu!"
,"27":"Qu'il te plaise alors de bénir la maison de ton serviteur, pour qu'elle reste à jamais devant toi. C'est toi, Yahvé, qui as béni, elle est bénie à jamais!'"
}`)
	CurrentBook.AddChapter(18, `{
"1":"Après cela, David battit les Philistins et les soumit. Il leur enleva Gat et les villages aux alentours."
,"2":"Il vainquit aussi les Moabites: ils devinrent les sujets de David et lui payèrent l'impôt."
,"3":"David battit à Hamat Hadadézer, roi de Soba, alors qu'il cherchait à soumettre les régions de l'Euphrate."
,"4":"David captura un millier de chars, sept mille cavaliers et vingt mille soldats d'infanterie. David fit couper les jarrets de tous les chevaux d'attelage, s'en réservant seulement une centaine."
,"5":"Les Araméens de Damas vinrent à l'aide de Hadadézer, roi de Soba, mais David tua vingt-deux mille hommes aux Araméens."
,"6":"Puis David installa des gouverneurs à Aram de Damas; les Araméens furent soumis à David et lui payèrent le tribut. Partout où David passait, Yahvé lui donnait la victoire."
,"7":"David s'empara des boucliers d'or des gardes de Hadadézer et les emporta à Jérusalem."
,"8":"De Tibhat et de Koun, villes qui appartenaient à Hadadézer, David prit une grande quantité de bronze dont Salomon allait faire la Mer d'Airain, les colonnes et les ustensiles du Temple."
,"9":"Lorsque Toou, roi de Hamat, apprit que David avait vaincu toute l'armée de Hadadézer, roi de Soba,"
,"10":"il envoya son fils Hadoram au roi David pour l'accueillir et le féliciter d'avoir combattu et vaincu Hadadézer, car Hadadézer était l'ennemi de Toou. Hadoram apporta toutes sortes d'objets en or, en argent et en bronze."
,"11":"Le roi David les consacra à Yahvé en même temps que les objets d'argent et d'or qu'il avait rapportés de toutes les nations: d'Edom, de Moab, des Ammonites, des Philistins, d'Amalec."
,"12":"David se rendit célèbre lorsqu'il revint d'avoir battu dix-huit mille Edomites dans la vallée du Sel."
,"13":"Il imposa des gouverneurs à Edom, et tous les Edomites furent soumis à David. Partout où David passait, Yahvé lui donnait la victoire."
,"14":"David régnait sur tout Israël; il rendait la justice et défendait les droits de son peuple."
,"15":"Joab fils de Serouya, commandait l'armée; Yochafat fils d'Ahiloud était archiviste;"
,"16":"Sadoq fils d'Ahitoub, et Ahimélek fils d'Ebyatar étaient prêtres; Chavcha était scribe;"
,"17":"Benayas, fils de Yoyada, commandait aux Kérétiens et aux Pélétiens. Les fils de David étaient les premiers aux côtés du roi."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Après cela, Nahach, roi des Ammonites, mourut, et son fils devint roi à sa place."
,"2":"David dit: 'Je montrerai de la bienveillance à Anoun, fils de Nahach, puisque son père a été bienveillant avec moi.' Et David envoya des messagers pour lui présenter ses condoléances pour la mort de son père. Mais lorsque les serviteurs de David rencontrèrent Anoun au pays des Ammonites pour présenter ses condoléances,"
,"3":"les chefs des Ammonites dirent à Anoun: 'Penses-tu que David veuille vraiment honorer ton père et t'apporter sa sympathie en t'envoyant ses messagers? Il a sûrement envoyé ces hommes pour espionner, afin d'envahir et de saccager notre territoire.'"
,"4":"Anoun fit saisir les serviteurs de David, les rasa, coupa leurs vêtements à mi-hauteur jusqu'aux fesses et les renvoya."
,"5":"Lorsqu'on raconta à David ce qui était arrivé à ses hommes, il envoya quelqu'un à leur rencontre, car ces hommes étaient vraiment honteux. Le roi leur fit dire: 'Restez à Jéricho jusqu'à ce que votre barbe ait repoussé, ensuite vous rentrerez.'"
,"6":"Les Ammonites savaient qu'ils s'étaient rendus odieux à David. Anoun et les Ammonites envoyèrent donc mille talents d'argent pour louer des chars et des conducteurs de chars aux Araméens de Mésopotamie, de Maaka et aux gens de Soba."
,"7":"Ils louèrent trente-deux mille chars: le roi de Maaka vint avec son armée. Ceux-ci vinrent camper devant Médba, tandis que les Ammonites sortaient de leurs villes et se préparaient à combattre."
,"8":"Quand David apprit cela, il envoya Joab avec toute sa garde."
,"9":"Les Ammonites s'avancèrent et se mirent en ordre de bataille à l'entrée de la ville, tandis que les rois qui étaient venus restèrent dans les environs."
,"10":"Voyant qu'il allait devoir combattre sur deux fronts, face à lui et derrière lui, Joab choisit les plus solides des Israélites et les mit en ligne face aux Araméens."
,"11":"Il plaça le reste des troupes sous le commandement de son frère Abisaï, face aux Ammonites."
,"12":"Il lui dit: 'Si les Araméens sont trop forts pour moi, tu viendras à mon aide; si les Ammonites se montrent trop forts pour toi, je te viendrai en aide."
,"13":"Sois courageux et combattons de toutes nos forces pour notre peuple et pour les villes de notre Dieu! Yahvé fera ce qui lui semble juste.'"
,"14":"Lorsque Joab et sa troupe attaquèrent, les Araméens s'enfuirent devant eux."
,"15":"Quand les Ammonites virent que les Araméens fuyaient, eux aussi s'enfuirent devant Abisaï, frère de Joab, et se retirèrent dans la ville. Alors Joab rentra à Jérusalem."
,"16":"Voyant qu'ils avaient été battus par Israël, les Araméens envoyèrent des messagers pour mobiliser les Araméens qui se trouvaient de l'autre côté du Fleuve; Chofak, chef de l'armée d'Hadadézer, était à leur tête."
,"17":"On rapporta la nouvelle à David qui rassembla les troupes israélites, traversa le Jourdain et les affronta. David installa sa ligne de combat face aux Araméens et le combat s'engagea."
,"18":"Les Araméens s'enfuirent devant Israël. David tua sept mille de leurs attelages et quarante mille fantassins. Il tua également Chofak, leur général."
,"19":"Quand les princes soumis à Hadadézer virent qu'ils étaient vaincus par Israël, ils firent la paix avec David et devinrent ses sujets. Dès lors les Araméens refusèrent d'aller au secours des Ammonites."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Au printemps, lorsque les rois repartent en campagne, Joab partit avec l'armée pour envahir le pays des Ammonites et mettre le siège devant Rabba; David resta à Jérusalem. Joab attaqua Rabba et la détruisit."
,"2":"David enleva la couronne qui était sur la tête de Milkom; il se trouva qu'elle pesait un talent d'or et qu'une pierre précieuse y était fixée; David la mit sur sa tête. De Rabba, David emporta une énorme quantité de butin."
,"3":"Il emmena la population et la condamna à travailler à la scie, à la pioche et à la hache. David traita toutes les villes ammonites de la même façon, puis il revint avec tout le peuple à Jérusalem."
,"4":"Après cela, la guerre reprit avec les Philistins à Guézer. C'est alors que Sibekaï de Housha tua Sippaï, un descendant des Réfaïm. Les Philistins furent vaincus."
,"5":"La guerre reprit encore avec les Philistins, et Elhanan fils de Yaïr tua Lahmi, le frère de Goliath de Gat, dont le bois de lance était aussi épais qu'une navette de tisserand."
,"6":"Dans une autre bataille à Gat, il y avait un géant avec six doigts à chaque main et six orteils à chaque pied, ce qui fait un total de vingt-quatre. Lui aussi était un descendant de Rafa."
,"7":"Il lança un défi à Israël, mais Yonathan, le fils de Chiméa, frère de David, le tua."
,"8":"Ces hommes étaient des descendants de Rafa de Gat, et ils furent tués par David et ses gardes."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Satan voulut jeter le trouble en Israël, aussi poussa-t-il David à recenser Israël."
,"2":"David dit à Joab et aux chefs du peuple: 'Allez recenser Israël depuis Bersabée jusqu'à Dan, puis revenez me faire connaître le nombre des habitants. '"
,"3":"Joab dit: 'Que Yahvé multiplie son peuple par cent, mon seigneur le roi; ne sont-ils pas tous tes serviteurs? Mais pourquoi mon seigneur fait-il ce recensement? Pourquoi faire courir Israël les risques d'une telle faute?'"
,"4":"Cependant le roi imposa cet ordre à Joab, et Joab partit. Après avoir parcouru tout Israël, il rentra à Jérusalem."
,"5":"Joab donna alors à David les chiffres du recensement de la population: dans tout Israël ils étaient onze cent mille hommes capables de tirer l'épée, et Juda comptait quatre cent soixante-dix mille hommes capables de tirer l'épée."
,"6":"Comme Joab désapprouvait l'ordre donné par le roi, il n'avait recensé ni Lévi ni Benjamin."
,"7":"Mais Dieu frappa Israël, car tout cela lui avait déplu."
,"8":"Alors David dit à Dieu: 'J'ai commis un grave péché en agissant ainsi, mais maintenant je te supplie de me pardonner cette faute, j'ai été vraiment insensé.'"
,"9":"A ce moment Yahvé parla à Gad, le voyant de David:"
,"10":"'Va dire à David cette parole de Yahvé: Je t'offre trois possibilités, choisis-en une et j'agirai ainsi avec toi.'"
,"11":"Gad alla trouver David et lui dit: 'Yahvé te donne à choisir:"
,"12":"trois années de famine, où trois mois durant lesquels tu fuiras devant l'adversaire et l'ennemi te poursuivra, ou trois jours durant lesquels l'épée de Yahvé, la peste, ravagera ta terre et l'ange destructeur de Yahvé répandra la mort sur tout Israël. Maintenant décide: Quelle réponse dois-je porter à Celui qui m'a envoyé.'"
,"13":"David dit à Gad: 'Le choix est difficile, mais mieux vaut tomber dans les mains de Yahvé que dans les mains des hommes, car grande est sa miséricorde.'"
,"14":"Alors Yahvé envoya la peste sur Israël et soixante-dix mille hommes d'Israël moururent."
,"15":"Dieu envoya l'Ange sur Jérusalem pour la détruire, mais au moment où il allait la détruire, Yahvé regarda et revint sur sa décision; il dit à l'Ange destructeur: 'Assez! Maintenant retire ta main!' L'ange de Yahvé se tenait près de l'aire d'Ornan le Jébusite."
,"16":"David leva les yeux et vit l'ange de Yahvé qui se tenait entre ciel et terre, brandissant une épée nue à la main, prêt à détruire Jérusalem. Alors David et les anciens vêtus de sacs tombèrent la face contre terre."
,"17":"David dit à Dieu: 'N'est-ce pas moi qui ai commandé de recenser le peuple? C'est moi qui ai péché et qui ai commis le mal; mais ceux-là ne sont que le troupeau, qu'ont-ils fait? Yahvé, mon Dieu, que ta main tombe sur moi et sur ma famille, mais épargne à ton peuple cette souffrance!'"
,"18":"L'ange de Yahvé dit alors à Gad: 'David doit monter construire un autel à Yahvé sur l'aire d'Ornan le Jébusite.'"
,"19":"David monta donc selon l'ordre que lui avait donné Gad de la part de Yahvé."
,"20":"C'est alors qu'Ornan aperçut l'ange en se retournant; il se cacha avec ses quatre fils. Ornan était en train de battre le blé"
,"21":"quand David s'approcha de lui. Ornan leva les yeux et vit David venir vers lui, il laissa l'aire et, le visage contre terre, il rendit hommage à David."
,"22":"David dit alors à Ornan: ' Vends-moi ton aire à battre pour y construire un autel à Yahvé. Vends-la moi à son vrai prix, afin que la peste se détourne du peuple.'"
,"23":"Ornan dit à David: 'Prends-la et que mon seigneur le roi fasse comme il lui semble juste. Regarde, je donne les boeufs pour les holocaustes, les herses pour le bois et le blé pour l'oblation. Tout cela, je le donne.'"
,"24":"Mais le roi David dit à Ornan: 'Non, je dois te l'acheter à son vrai prix. Je ne vais pas prendre pour Yahvé ce qui est à toi et faire des holocaustes qui ne me coûtent rien!'"
,"25":"Aussi David donna donc à Ornan six cents sicles d'or pour l'aire à battre."
,"26":"David fit construire un autel à cet endroit pour Yahvé; il y fit monter la fumée des holocaustes et des sacrifices de communion. Il invoqua Yahvé qui lui répondit par le feu du ciel sur l'autel où se trouvait l'holocauste."
,"27":"Après quoi Yahvé ordonna à l'ange de remettre son épée au fourreau."
,"28":"Voyant que Yahvé lui avait répondu à cet endroit, David continua d'y offrir des sacrifices."
,"29":"La Demeure de Yahvé que Moïse avait faite dans le désert était alors avec l'autel des holocaustes dans le Haut-Lieu de Gabaon,"
,"30":"mais David avait été tellement effrayé par l'épée de l'ange de Yahvé, qu'il n'y était pas allé pour consulter Dieu."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Alors David dit: 'C'est ici que doit être la Maison de Yahvé Dieu et l'autel pour les holocaustes d'Israël."
,"2":"David donna des ordres pour qu'on rassemble tous les étrangers qui vivaient sur la terre d'Israël; il se procura des tailleurs de pierre pour préparer les pierres destinées à la construction du Temple de Dieu."
,"3":"David fit emmagasiner du fer en quantité pour les clous des battants des portes et pour les crampons; du bronze en quantité incalculable;"
,"4":"du bois de cèdre sans nombre que les Sidoniens et les Tyriens avaient apporté à David, des bois de cèdre en abondance."
,"5":"David se disait en effet: 'Mon fils Salomon est jeune et inexpérimenté, et le Temple que l'on construira pour Yahvé doit être d'une splendeur admirable afin d'être renommé et glorieux dans tous les pays. Je veux donc tout préparer pour lui.' C'est pourquoi David prépara beaucoup de choses avant sa mort."
,"6":"Il envoya chercher son fils Salomon et lui ordonna de construire un temple pour Yahvé Dieu d'Israël."
,"7":"David dit à Salomon: 'Mon fils, je désirais construire une Maison pour le Nom de Yahvé mon Dieu;"
,"8":"mais cette parole de Yahvé m'a été adressée: Tu as versé beaucoup de sang et tu as combattu dans de grandes batailles. Tu ne construiras pas cette Maison pour mon Nom car tu as versé beaucoup de sang à terre sous mes yeux."
,"9":"Mais un fils t'est né, il sera, lui, un homme de paix, et je lui donnerai la tranquillité du côté de tous les ennemis qui l'entourent. Salomon sera son nom, et durant son temps, je donnerai paix et repos à Israël."
,"10":"Il construira une Maison pour mon Nom, il sera un fils pour moi et je serai pour lui un père. J'affermirai le trône de sa royauté sur Israël pour toujours."
,"11":"Maintenant donc, mon fils, que Yahvé t'accompagne et te fasse réussir cette construction d'une Maison pour Yahvé notre Dieu, comme il l'a dit à ton sujet."
,"12":"Que Yahvé te donne aussi la clairvoyance et la sagesse pour que tu observes la Loi de Yahvé ton Dieu lorsqu'il t'aura établi roi sur Israël."
,"13":"Le succès te sera assuré si tu observes soigneusement les préceptes et les règles que Yahvé a donnés à Moïse pour Israël. Sois fort et courageux, sois sans crainte et rempli de confiance."
,"14":"A grand-peine j'ai mis de côté pour la construction du Temple, cent mille talents d'or et un million de talents d'argent, sans compter le bronze et le fer qu'on ne peut peser tellement il y en a; j'ai emmagasiné du bois et des pierres: toi, tu en ajouteras encore."
,"15":"Tu as à ta disposition de nombreux ouvriers: des hommes qui travaillent dans les carrières, des tailleurs de pierre, des charpentiers, et des artisans qualifiés de toutes sortes."
,"16":"Les réserves d'or, d'argent, de bronze et de fer sont sans limites. Va! Mets-toi au travail et que Yahvé t'accompagne!'"
,"17":"David ordonna alors à tous les chefs d'Israël d'aider son fils Salomon:"
,"18":"'Yahvé votre Dieu est bien avec vous puisqu'il vous a donné la paix de tous côtés et qu'il m'a soumis tous les habitants du pays. Aujourd'hui ce pays est bien soumis à Yahvé et à son peuple."
,"19":"Mettez donc votre coeur et votre âme à chercher Yahvé votre Dieu. Vous allez construire un sanctuaire de Yahvé votre Dieu et vous apporterez l'Arche de l'Alliance de Yahvé et les objets sacrés de Dieu dans cette Maison construite pour le Nom de Yahvé.'"
}`)
	CurrentBook.AddChapter(23, `{
"1":"Quand David fut très vieux, il plaça son fils Salomon sur le trône d'Israël."
,"2":"Il rassembla alors tous les chefs d'Israël, les prêtres et les lévites."
,"3":"On recensa les lévites âgés de trente ans et plus: ils étaient trente-huit mille au total,"
,"4":"vingt-quatre mille étaient responsables du culte dans la Maison de Yahvé, six mille étaient scribes et juges,"
,"5":"quatre mille étaient gardiens de la porte, quatre mille louaient Yahvé avec les instruments que David avait faits pour accompagner les chants."
,"6":"Ensuite David répartit les lévites en trois groupes suivant leurs clans: Guerchom, Kahat et Mérari."
,"7":"Pour les Guerchomites: Ladan et Chimeï."
,"8":"Fils de Ladan: Yéhiël le premier, Zétam, Joël, trois en tous."
,"9":"Fils de Chimeï: Chélomit, Haziel, Haran, trois en tout. Ils étaient chefs des familles de Ladan."
,"10":"Fils de Chimeï: Yahat, Ziza, Yéouch, Béria: ce sont les quatre fils de Chimeï."
,"11":"Yahat était l'aîné, Ziza le second, puis Yéouch et Béria qui n'avaient pas beaucoup d'enfants et formaient une seule famille, un seul groupe."
,"12":"Fils de Kahat: Amram, Yishar, Hebron, Ouzziel; quatre en tout."
,"13":"Fils d'Amram: Aaron et Moïse. Aaron et ses fils furent mis à part pour s'occuper à tout jamais des objets sacrés, pour faire brûler l'encens en présence de Yahvé, pour le servir et bénir le peuple en son Nom pour toujours."
,"14":"Mais les fils de Moïse, homme de Dieu, furent appelés du nom même de la tribu de Lévi."
,"15":"Les fils de Moïse: Guerchom et Eliézer."
,"16":"Fils de Guerchom: Chéouël le premier."
,"17":"Eliézer avait comme fils: Rehabya le premier. Eliézer n'avait pas d'autre fils, mais nombreux furent les fils de Rehabya."
,"18":"Fils de Yichar: Chelomit le premier."
,"19":"Fils d'Hebron: Yériyas le premier, Amarya le second, Yahaziel le troisième, Yékaméam le quatrième."
,"20":"Fils d'Ouziel: Mika le premier, Yichchyia le second."
,"21":"Fils de Mérari: Mahli et Mouchi. Fils de Mahli: Eléazar et Quis."
,"22":"Eléazar mourut sans laisser de fils, mais seulement des filles: leurs cousins, les fils de Quis, les épousèrent."
,"23":"Fils de Mouchi: Mahli, Eder, Yérémot: trois au total."
,"24":"Voilà donc les fils de Lévi selon leurs familles. Ces chefs de familles avaient été inscrits par leurs noms individuellement à partir de l'âge de vingt ans: c'étaient eux qui servaient dans la Maison de Yahvé."
,"25":"David avait dit: 'Yahvé, le Dieu d'Israël, a donné la paix à son peuple, et il habite pour toujours à Jérusalem;"
,"26":"les lévites n'auront donc plus à transporter la Demeure ni les objets utilisés pour son service.'"
,"27":"Selon les dernières paroles de David, on recensa les lévites à partir de l'âge de vingt ans."
,"28":"Leur tâche est d'assister les fils d'Aaron dans le service du Temple de Yahvé, dans les cours et les salles, pour la purification de tous les objets sacrés et le bon déroulement du culte dans la Maison de Dieu."
,"29":"Ils sont aussi chargés des pains mis en rangées, de la fleur de farine pour les offrandes, des galettes de pain sans levain, des gâteaux cuits sur le gril ou dans les pots, et ils veillent au respect du poids et des mesures fixés pour les offrandes."
,"30":"Ils doivent être présents chaque matin comme chaque soir, pour chanter la gloire et les louanges de Yahvé."
,"31":"Ils doivent être là sans cesse devant Yahvé, au nombre fixé par le règlement, toutes les fois qu'on présente les holocaustes du sabbat, des Nouvelles Lunes et des fêtes, en l'honneur de Yahvé."
,"32":"Ils assurent ainsi dans la Maison de Yahvé le culte qui se célébrait dans la Tente du Rendez-Vous, en suivant le rituel du Sanctuaire et le rituel de leurs frères, les fils d'Aaron."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Voici les groupes selon lesquels se répartissent les fils d'Aaron. Fils d'Aaron: Nadab, Abihou, Eléazar et Itamar."
,"2":"Nadab et Abihou moururent avant leur père sans laisser de fils. Seuls Eléazar et Itamar exercèrent le sacerdoce."
,"3":"David, aidé de Sadoq, fils d'Eléazar, et d'Ahimélèk, fils d'Itamar, les répartit par groupes, selon leurs fonctions."
,"4":"Comme les fils d'Eléazar comprenaient plus de chefs que les fils d'Itamar, on fit seize groupes avec les chefs de familles d'Eléazar et huit avec les chefs de famille d'Itamar."
,"5":"On répartit au sort les uns et les autres: il y eut en effet des chefs consacrés et des chefs marqués d'un caractère divin, aussi bien dans les fils d'Eléazar que dans les fils d'Itamar."
,"6":"Un des lévites, le scribe Chemayas fils de Nathanaël, les inscrivit en présence du roi, de ses officiers, de Sadoq le prêtre, d'Ahimélèk fils d'Ebyatar, et des chefs de familles des prêtres et des lévites (pour une famille tirée au sort chez les fils d'Itamar, on en tirait deux pour les fils d'Eléazar)."
,"7":"La première part fut attribuée à Yéhoyarib, la seconde à Yédayas,"
,"8":"la troisième à Harim, la quatrième à Séorim,"
,"9":"la cinquième à Malkyia, la sixième à Miyiamin,"
,"10":"la septième à Hakos, la huitième à Abiyas,"
,"11":"la neuvième à Yéchoua, la dixième à Chekanyas,"
,"12":"la onzième à Elyachib, la douzième à Yakim,"
,"13":"la treizième à Houpa, la quatorzième à Ichbaal,"
,"14":"la quinzième à Bilga, la seizième à Immer,"
,"15":"la dix-septième à Hézir, la dix-huitième à Hapisès,"
,"16":"la dix-neuvième à Petahya, la vingtième à Yéhèzkel,"
,"17":"la vingt et unième à Yakin, la vingt-deuxième à Gamoul,"
,"18":"la vingt-troisième à Delayas, la vingt-quatrième à Maazyas."
,"19":"Voilà ceux qui avaient comme fonction d'entrer dans la Maison de Yahvé, selon les règles que Yahvé, Dieu d'Israël, avaient données par l'intermédiaire d'Aaron, leur ancêtre: c'est bien ainsi que Yahvé, le Dieu d'Israël, l'avait ordonné."
,"20":"Pour les autres fils de Lévi: Pour les fils d'Aram: Shoubaël. Pour les fils de Shoubaël: Yédeyas. "
,"21":"Pour Réabyas, pour les fils de Réabyas, l'aîné Yichchiyia."
,"22":"Pour les Yicharites, Chelomit; pour les fils de Chelomit, Yahat."
,"23":"Fils de Hebron: Yériyia le premier, Amaryas le second, Yahaziel le troisième, Yékaméam le quatrième."
,"24":"Fils d' Ouziel: Mika; pour les fils de Mika: Chamir."
,"25":"Frère de Mika, Yichchiyia; pour les fils de Yichchiyia, Zekaryas."
,"26":"Fils de Mérari: Mahli et Mouchi. Fils de Yaaziyas, son fils;"
,"27":"fils de Mérari, pour Yaaziyas son fils: Choham, Zakour et Ibri;"
,"28":"pour Mahli, Eléazar qui n'eut pas de fils;"
,"29":"pour Quis: fils de Quis, Yérahméel."
,"30":"Fils de Mouchi: Mahli, Eder, Yérimot. Voilà les fils de Lévi d'après leurs clans. "
,"31":"Devant le roi, Sadoq, Ahimélek et les chefs de familles des prêtres et des lévites, ils tirèrent eux aussi au sort comme l'avaient fait leurs frères, les fils d'Aaron. La famille du chef était sur le même rang que celle du plus jeune frère."
}`)
	CurrentBook.AddChapter(25, `{
"1":"Pour la liturgie, David et les officiers de la milice du Temple, mirent à part les fils d'Asaph, de Heman et de Yédoutoun, qui prophétisaient en s'accompagnant de la lyre, de la harpe et des cymbales. On dressa la liste suivante des hommes chargés de ce service:"
,"2":"Pour les fils d'Asaph: Zakour, Joseph, Netanya, Asarééla; les fils d'Asaph étaient sous la direction d'Asaph qui prophétisait chaque fois que le roi en donnait l'ordre."
,"3":"Pour Yédoutoun: fils de Yédoutoun: Guédalyas, Seri, Yéchayas, Hachabyas, Mattityas; ils étaient six sous la direction de leur père Yédoutoun, qui au son de la lyre, chantaient les louanges au Seigneur et lui rendaient grâces."
,"4":"Pour Heman les fils d'Heman: Boukiyas, Mattanyas, Ouziel, Chebouel, Yérimot, Hananya, Hanani, Eliata, Gidalti, Romamti-Ezer, Yochbekasha, Maloti, Hotir, Mahaziot."
,"5":"Ils étaient tous fils d'Heman, le devin du roi; ceux-ci jouaient de la trompette quand la parole de Yahvé se faisait entendre. Dieu donna à Heman quatorze fils et trois filles:"
,"6":"tous chantaient dans la Maison de Yahvé, sous la direction de leur père, accompagnés de cymbales, harpes et lyres: c'était le service qu'ils assuraient dans la Maison de Dieu, sous la direction du roi, d'Asaph, de Yédoutoun et d'Heman."
,"7":"Leur nombre, en comptant leurs frères qui assuraient avec compétence le chant en l'honneur de Yahvé, était de deux cent quatre-vingt-huit."
,"8":"On tira au sort l'ordre que l'on devait respecter, pour les petits comme pour les grands, pour les maîtres comme pour les disciples."
,"9":"Le premier tiré au sort, pour le clan d'Asaph, fut Joseph. Le second fut Guédalyas, avec ses fils et ses frères: ils étaient douze."
,"10":"Le troisième fut Zakour, avec ses fils et ses frères: ils étaient douze."
,"11":"Le quatrième fut Yisri, avec ses fils et ses frères: ils étaient douze."
,"12":"Le cinquième fut Netanyas, avec ses fils et ses frères: ils étaient douze."
,"13":"Le sixième fut Boukiyas, avec ses fils et ses frères: ils étaient douze."
,"14":"Le septième fut Yésarééla, avec ses fils et ses frères: ils étaient douze."
,"15":"Le hui tième fut Yéchayas, avec ses fils et ses frères: ils étaient douze."
,"16":"Le neuvième fut Mattanyas, avec ses fils et ses frères: ils étaient douze."
,"17":"Le dixième fut Shiméï, avec ses fils et ses frères: ils étaient douze."
,"18":"Le onzième fut Azaréel, avec ses fils et ses frères: ils étaient douze."
,"19":"Le douzième fut Hachabyas, avec ses fils et ses frères: ils étaient douze."
,"20":"Le treizième fut Choubaël, avec ses fils et ses frères: ils étaient douze."
,"21":"Le quatorzième fut Mattityas, avec ses fils, ses frères: ils étaient douze."
,"22":"Le quinzième fut Yérémot, avec ses fils, ses frères: ils étaient douze."
,"23":"Le seizième fut Hananias, avec ses fils, ses frères: ils étaient douze."
,"24":"Le dix-septième fut Yochbekacha, avec ses fils, ses frères: ils étaient douze."
,"25":"Le dix-huitième fut Hanani, avec ses fils, ses frères: ils étaient douze."
,"26":"Le dix-neuvième fut Maloti, avec ses fils, ses frères: ils étaient douze."
,"27":"Le vingtième fut Elyata, avec ses fils, ses frères: ils étaient douze."
,"28":"Le vingt et unième fut Hotir, avec ses fils, ses frères: ils étaient douze."
,"29":"Le vingt-deuxième fut Giddalti, avec ses fils, ses frères: ils étaient douze."
,"30":"Le vingt-troisième fut Mahaziot, avec ses fils, ses frères: ils étaient douze."
,"31":"Le vingt-quatrième fut Romanti-Ezer, avec ses fils, ses frères: ils étaient douze."
}`)
	CurrentBook.AddChapter(26, `{
"1":"Voici les classes des portiers: Pour les Koréites: Méchélémyas, fils de Koré, l'un des fils d'Ebyasaph."
,"2":"Méchélémyas eut pour fils: Zekaryas le premier, Yédiaël le second, Zebadyas le troisième, Yatniel le quatrième,"
,"3":"Elam le cinquième, Yohanan le sixième, Elyoénaï le septième."
,"4":"Obed-Edom eut pour fils: Chemayas l'aîné, Yéhozabad le second, Yoah le troisième, Sakar le quatrième, Nathanaël le cinquième,"
,"5":"Ammiel le sixième, Issacar le septième, Péouletaï le huitième; car Dieu avait béni Obed-Edom."
,"6":"Son fils Chemayas eut des fils qui furent considérés dans leurs familles, car ils étaient des hommes de valeur."
,"7":"Voici les fils de Chemayas: Otni, Rephaël, Obed, Elzabad, et ses frères, Elihou et Semakyas, hommes de valeur."
,"8":"Ils étaient tous fils d'Obèd-Edom. Eux, leurs fils, leurs frères, étaient des hommes courageux et énergiques dans leur travail. De la famille d'Obèd-Edom, ils étaient soixante-deux."
,"9":"Mechélémyas eut des fils et des frères: dix-huit hommes courageux."
,"10":"Hosa, fils de Mérari, eut pour fils: le chef Chimri, car bien qu'il ne soit pas le premier-né, son père en avait fait le chef;"
,"11":"Hilkyia était le second, Tebalyas le troisième, Zekaryas le quatrième. Les fils et frères d'Hosa étaient treize en tout."
,"12":"Ces groupes de portiers, tous des hommes, avaient comme leurs frères des responsabilités dans le service du Temple de Yahvé."
,"13":"On tira au sort, porte par porte, pour attribuer les charges, pour les petits comme pour les grands, selon leur famille."
,"14":"Pour l'Orient, le sort tomba sur Chelemyas; son fils Zekaryas était un judicieux conseiller, le sort lui attribua la porte nord."
,"15":"A Obèd-Edom revint le sud et à ses fils, les magasins."
,"16":"Choupim et Hosa étaient à l'ouest près de la porte de la Salle, sur la chaussée montante, deux postes de garde se trouvaient en vis-à-vis."
,"17":"Il y avait donc chaque jour six lévites à l'Orient, quatre au nord, quatre au sud et deux pour chacun des magasins;"
,"18":"pour les bâtiments de l'ouest, quatre pour la chaussée et deux pour l'Annexe."
,"19":"Tels étaient les groupes de portiers pour les fils de Koré et ceux de Mérari."
,"20":"Des lévites, leurs frères, étaient chargés du Trésor du Temple de Dieu et des magasins où étaient entreposées les offrandes consacrées."
,"21":"Les fils de Ladan, fils de Guerchom par Ladan, avaient les Yéhiélites pour chefs de familles: car ils étaient fils de Ladan le Guerchomite."
,"22":"Les Yéhiélites Zétam et Joël son frère, étaient chargés des trésors du Temple de Yahvé."
,"23":"Chez les Amramites, Yicharites, Hébronites, et Ouziélites:"
,"24":"Shébouel, fils de Guerchom, fils de Moïse, était responsable des trésors."
,"25":"Ses frères par Eliézer étaient: Rehabyas, Yéchayas, Yoram, Zikri et Chelomit."
,"26":"Ce Chelomit et ses frères étaient chargés de toutes les offrandes saintes consacrées par le roi David, les chefs de familles, les chefs de mille et de cent et les chefs de l'armée."
,"27":"C'était du butin de guerre qui avait été consacré pour enrichir la Maison de Yahvé."
,"28":"Il y avait aussi tous les objets consacrés par Samuel, le voyant, Saül fils de Quis, Abner fils de Ner, et Joab fils Sérouya. Tous ces objets consacrés étaient sous la responsabilité de Chelomit et de ses frères."
,"29":"Pour les Yicharites: Kenanyas et ses fils étaient chargés des affaires civiles d'Israël, comme scribes et juges."
,"30":"Parmi les Hébronites, Hachabyas et ses frères, mille sept cents guerriers étaient chargés de la surveillance d'Israël à l'ouest du Jourdain, pour tout le service de Yahvé et le service du roi."
,"31":"Pour les Hébronites, Yéryia était le chef, selon la généalogie des familles d'Hébron. En l'an quarante du règne de David, on fit des recherches et l'on trouva chez eux des hommes de valeur établis à Yazer en Galaad."
,"32":"Le roi David désigna deux mille sept cents hommes de valeur, chefs de familles, frères de Yériyas, et leur confia toutes les affaires de Dieu et les affaires du roi, dans les tribus de Ruben, de Gad et dans la demi-tribu de Manassé."
}`)
	CurrentBook.AddChapter(27, `{
"1":"Voici le recensement des fils d'Israël, chefs de familles, chefs de mille et de cent, scribes au service du roi, selon leurs classes et selon la fonction qu'ils remplissaient chaque mois, tout au long de l'année: chaque groupe comptait 24000 hommes."
,"2":"Pour le premier mois, Yachobéam, fils de Zabdiel, était à la tête de la première division, il avait 24000 hommes dans sa division."
,"3":"Il était l'un des fils de Pérès, chef de tous les officiers du premier mois."
,"4":"Pour le second mois, Dodaï l'Ahohite, était à la tête d'une division de 24000 hommes."
,"5":"Pour le troisième mois, Benayas, fils de Yoyada, le grand prêtre, avait sous ses ordres une division de 24000 hommes."
,"6":"C'est Bénayas qui fut le héros des Trente et eut la responsabilité des Trente et de sa division; son fils s'appelait Amizabad."
,"7":"Pour le quatrième mois, Azaël frère de Joab était à la tête d'une division de 24000 hommes; son fils Zebadya lui succéda."
,"8":"Pour le cinquième mois, l'officier Chamehout le Zarhite, était à la tête d'une division de 24000 hommes."
,"9":"Pour le sixième mois, Ira fils d'Ikkesh, de Tékoa, était à la tête d'une division de 24000 hommes."
,"10":"Pour le septième mois, Héles le Pélonite, l'un des fils d'Ephraïm, était à la tête d'une division de 24000 hommes."
,"11":"Pour le huitième mois, Sibbekaï de Houcha, un Zarhite, était à la tête d'une division de 24000 hommes."
,"12":"Pour le neuvième mois, Abiézer d'Anatot, un Benjaminite, était à la tête d'une division de 24000 hommes."
,"13":"Pour le dixième mois, Mahraï de Netopha, un Zarhite, était à la tête d'une division de 24000 hommes."
,"14":"Pour le onzième mois, Benayas de Piréaton, un fils d'Ephraïm, était à la tête d'une division de 24000 hommes."
,"15":"Pour le douzième mois, Heldaï de Netopha, de la famille d'Otniel, était à la tête d'une division de 24000 hommes."
,"16":"Responsables des tribus d'Israël: Eliézer fils de Zikri, était l'officier en chef des Rubénites, Chefatyas fils de Maaka, celui des Siméonites,"
,"17":"Hachabya fils de Kemouel, celui des lévites, Sadoq, celui des Aaronites,"
,"18":"Elihou, l'un des frères de David, celui des Judéens, Omri fils de Mikaël, celui des Issascarites,"
,"19":"Yichmayas fils d'Obadyas, celui des Zabulonites, Yérimot fils d'Azriel, celui des Nephtalites,"
,"20":"Hochéa fils d'Azazyas, celui des Ephraïmites, Joël fils de Pedayas, celui de la demi-tribu de Manassé,"
,"21":"Yiddo fils de Zekaryas, celui de la demi-tribu de Manassé en Galaad, Yaasiel fils d'Abner, celui des Benjaminites,"
,"22":"Azaréel fils de Yéroham, celui des Danites. Voilà la liste des chefs des tribus d'Israël."
,"23":"David ne compta pas ceux qui avaient vingt ans ou moins, puisque Yahvé avait promis de rendre Israël aussi nombreux que les étoiles du ciel."
,"24":"Joab fils de Sérouya commença le recensement, mais il ne le termina pas car la colère de Dieu avait éclaté contre Israël. Le chiffre n'atteignit pas celui qui est inscrit dans le Livre des Chroniques du roi David."
,"25":"Responsable des réserves du roi: Azmavet fils d'Adiel. Responsable des réserves dans les villes, les villages et les forteresses: Jonathan fils d'Ozias."
,"26":"Responsable des travailleurs agricoles qui cultivaient la terre: Ezri fils de Keloub."
,"27":"Responsable des vignobles: Chiméï de Rama; responsable de ceux qui s'occupaient des réserves de vin: Zabdi de Chephan."
,"28":"Responsable des oliviers et des sycomores dans le Bas-Pays: Baal-Hanan de Guéder. Responsable des réserves d'huile: Yoach."
,"29":"Responsable du gros bétail dans les pâturages en Saron: Chitraï de Saron. Responsable du gros bétail dans les vallées: Chafat fils de Adlaï."
,"30":"Responsable des chameaux: Obil l'Ismaélite. Responsable des ânesses: Yédéyas de Méronot."
,"31":"Responsable du petit bétail: Yaziz le Hagrite. Ils étaient tous surveillants des biens du roi David."
,"32":"Yonathan, oncle de David, était un conseiller plein d'intelligence et d'instruction. Yéhiël fils de Hakmoni était chargé de l'éducation des fils du roi."
,"33":"Ahitophel était conseiller du roi. Housaï l'Arkite était un ami très proche du roi."
,"34":"Yoyada, fils de Benayas, et Ebyatar succédèrent à Ahitophel. Joab était le commandant en chef de l'armée du roi."
}`)
	CurrentBook.AddChapter(28, `{
"1":"David rassembla à Jérusalem tous les chefs d'Israël, les chefs de tribus et les chefs des divers groupes au service du roi, les chefs de mille, les chefs de cent, les intendants préposés aux biens et aux troupeaux du roi et de ses fils, ainsi que les eunuques, les soldats d'élite, et tous les courageux guerriers."
,"2":"Alors David se leva et dit: 'Mes frères et mon peuple, écoutez-moi! Je voulais construire une demeure fixe pour l'Arche d'Alliance de Yahvé sur laquelle se repose notre Dieu. J'ai donc fait les préparatifs pour la construction, "
,"3":"mais Dieu m'a dit: tu ne bâtiras pas une Maison pour mon Nom, car tu as été un homme de guerre et tu as fait couler le sang."
,"4":"Yahvé, Dieu d'Israël, m'a choisi parmi toute la famille de mon père pour régner à jamais sur Israël. En effet, il a choisi Juda comme chef; dans la tribu de Juda, il a choisi la maison de mon père, et parmi les fils de mon père, c'est moi qu'il a voulu établir comme roi sur tout Israël."
,"5":"De tous mes fils, - car Yahvé m'en a donné beaucoup - il a choisi mon fils Salomon pour s'asseoir sur le trône de Yahvé en Israël."
,"6":"Il m'a dit: c'est ton fils Salomon qui construira mon Temple et mes parvis, car je l'ai choisi pour fils, et moi, je serai un père pour lui."
,"7":"S'il continue à observer soigneusement mes lois et mes commandements comme il le fait maintenant, j'affermirai sa royauté à jamais."
,"8":"Et maintenant, sous les yeux de tout Israël qui est l'assemblée de Yahvé, et aux oreilles de notre Dieu, je vous le dis: observez et méditez tous les commandements de Yahvé notre Dieu pour qu'il nous garde en ce beau pays et que vous le transmettiez à vos fils en héritage perpétuel."
,"9":"Et toi, Salomon, mon fils, connais le Dieu de ton père, sers-le avec fidélité et générosité, car Yahvé connaît le fond de tous les coeurs et pénètre toutes les pensées. Si tu le cherches, il se laissera trouver par toi, mais si tu l'abandonnes, il te rejettera pour toujours."
,"10":"Regarde maintenant! Yahvé t'a choisi pour lui construire une demeure qui sera un sanctuaire. Sois fort et mets-toi à l'oeuvre.'"
,"11":"David donna à son fils Salomon les plans du vestibule, des bâtiments, des salles des trésors, des chambres hautes, des appartements intérieurs, et de la salle de l'Instrument du Pardon."
,"12":"Il lui donna aussi le plan de tout ce qu'il avait dans l'esprit pour les parvis de la demeure de Yahvé, pour tous les appartements environnants, les salles des trésors de la Maison de Yahvé et des trésors des offrandes saintes,"
,"13":"l'ordre des prêtres et des lévites, les rituels liturgiques de la Maison de Yahvé, et tout le mobilier du service de la Maison de Yahvé."
,"14":"Il lui donna des instructions sur la quantité d'or nécessaire aux objets utilisés pour chacun des services, sur la quantité d'argent nécessaire aux objets utilisés pour chacun des services,"
,"15":"la quantité d'or des chandeliers et de leurs lampes selon le poids de chaque chandelier et de ses lampes, la quantité d'argent pour les chandeliers et leurs lampes, selon l'usage que l'on devait en faire;"
,"16":"la quantité d'or pour chacune des tables sur lesquelles les pains seraient rangés; l'argent pour les tables en argent,"
,"17":"les fourchettes, les coupes d'or; le poids d'or pour chaque plat creux, le poids d'argent pour chaque coupe;"
,"18":"le poids d'or fin pour l'autel des encens. Il lui donna les plans du Char avec les Chérubins en or dont les ailes déployées couvraient l'Arche d'Alliance de Yahvé."
,"19":"'Tout cela, dit-il, m'a été donné par écrit par Yahvé, il m'en a fait connaître les moindres détails.'"
,"20":"David dit ensuite à son fils Salomon: 'Sois fort et courageux, sois sans crainte et déterminé! Mets-toi à l'oeuvre: Yahvé mon Dieu sera avec toi. Il ne te fera pas défaut ni ne t'abandonnera avant que tu aies terminé tout le travail qui doit être fait pour la Maison de Yahvé."
,"21":"Voici les ordres des prêtres et des lévites pour tous les services de la Maison de Dieu: chaque homme de bonne volonté avec ses aptitudes t'apportera son concours pour tout ce travail; les chefs et tout le peuple seront entièrement à tes ordres.'"
}`)
	CurrentBook.AddChapter(29, `{
"1":"Le roi David dit à toute l'assemblée: 'Mon fils Salomon, que Yahvé a choisi, est encore jeune et fragile, et la tâche est énorme, ce palais n'est pas pour un homme, mais pour Yahvé Dieu."
,"2":"Courageusement, j'ai préparé ce qu'il fallait pour la Demeure de mon Dieu: l'or pour les objets d'or, l'argent pour les objets d'argent, le bronze pour les objets de bronze, le fer pour les objets de fer, le bois pour ce qui doit être fait en bois, et en outre de l'onyx, des pierres à sertir, des pierres de toutes couleurs, des pierres précieuses de toutes sortes, des quantités d'albâtre."
,"3":"Je donne par amour pour la Demeure de Yahvé l'or et l'argent de mon propre trésor, en plus de ce que j'ai déjà fourni pour la Sainte Maison:"
,"4":"trois mille pièces d'or, en or d'Ophir, et sept mille pièces d'argent, en argent pur, pour revêtir les parois des salles."
,"5":"Chacun de vous offrira-t-il aujourd'hui généreusement à Yahvé ce qu'il a d'or pour les objets d'or, d'argent pour les objets d'argent, mais aussi pour payer le travail des artisans?'"
,"6":"Les chefs de familles, les chefs des tribus d'Israël, les chefs de mille et les chefs de cent, et ceux qui géraient les affaires du roi,"
,"7":"donnèrent pour le culte de la Maison de Dieu: cinq mille pièces d'or, dix mille pièces perses, dix mille pièces d'argent, dix-huit mille pièces de bronze et cent mille pièces de fer."
,"8":"Ceux qui possédaient des pierres précieuses les apportèrent à Yéhiël le Guerchomite pour le trésor de la Maison de Yahvé."
,"9":"Le peuple se réjouit de voir ces offrandes spontanées, car c'est du fond du coeur qu'ils avaient fait ces offrandes à Yahvé. Le roi David en fut lui aussi rempli de joie."
,"10":"Devant toute l'assemblée David bénit Yahvé: 'Sois béni, Yahvé, Dieu d'Israël, notre Père, depuis toujours et pour toujours!"
,"11":"A toi Yahvé la grandeur, la puissance, la splendeur, l'éternité, la gloire, car tout ce qui est dans les cieux et sur la terre est à toi! Tu es notre souverain pour toujours, ô Yahvé! Tu es celui qui règne sur toutes choses."
,"12":"La richesse et l'honneur viennent de toi et tu gouvernes tout; dans ta main se trouvent force et puissance. Tu es celui qui donne à tous grandeur et force."
,"13":"Maintenant, notre Dieu, nous te rendons grâce, nous louons la splendeur de ton Nom."
,"14":"Qui suis-je et qui est mon peuple? N'est-ce pas toi qui nous permets aujourd'hui de te présenter ces offrandes? Tout vient de toi, et ce que nous t'avons donné, nous l'avons reçu de ta propre main."
,"15":"Nous sommes des étrangers devant toi, rien que des migrants, comme l'étaient nos ancêtres; nos jours sur terre passent comme une ombre et que nous reste-t-il comme espoir?"
,"16":"Yahvé, notre Dieu, c'est de ta main que sort toute cette richesse que nous avons rassemblée pour construire une Maison à ton Saint Nom: tout est à toi."
,"17":"O mon Dieu, je sais que tu sondes les coeurs et que tu aimes la droiture; c'est avec droiture que j'ai volontairement donné tout cela, et à présent j'ai vu avec joie ton peuple offrir ses dons spontanément."
,"18":"O Yahvé, Dieu de nos pères Abraham, Isaac et Jacob, garde à jamais ces dispositions dans le coeur et dans l'esprit de ton peuple: conduis-le vers toi."
,"19":"Donne à mon fils Salomon une fidélité sans faille pour observer tes commandements, tes décrets, tes prescriptions; puisse-t-il les mettre en pratique et construire ce palais que j'ai préparé.'"
,"20":"David dit alors à toute l'assemblée: 'Maintenant bénissez Yahvé notre Dieu!' Et toute l'assemblée bénit Yahvé, le Dieu de ses pères; elle s'agenouilla et se prosterna devant Yahvé et devant le roi."
,"21":"Le jour suivant, on offrit des sacrifices et des holocaustes à Yahvé: mille taureaux, mille béliers et mille agneaux avec leurs offrandes de vin, ainsi que de nombreux sacrifices pour tout Israël."
,"22":"Ce jour-là ils mangèrent et burent joyeusement en présence de Yahvé. Pour la seconde fois ils proclamèrent roi Salomon, fils de David; ils lui donnèrent l'onction pour qu'il les gouverne au nom de Yahvé, et ils consacrèrent aussi Sadoq comme prêtre."
,"23":"Salomon s'assit sur le trône de Yahvé et régna à la place de David, son père; il réussit bien et tout Israël lui obéissait."
,"24":"Tous les chefs, les guerriers d'élites et les fils du roi David étaient soumis au roi Salomon."
,"25":"Grâce à Yahvé, Salomon était très considéré par tout Israël et son règne fut plus glorieux que celui des rois d'Israël qui l'avaient précédé."
,"26":"David, fils de Jessé, avait régné sur tout Israël."
,"27":"La durée de son règne sur Israël avait été de quarante ans; il avait régné à Hebron pendant sept ans et à Jérusalem pendant trente-trois ans."
,"28":"Il mourut dans une heureuse vieillesse, comblé de jours, de richesses et d'honneurs; Salomon, son fils, lui succéda."
,"29":"Les actes du roi David, du premier jusqu'au dernier, sont écrits dans le Livre de Samuel le voyant, dans l'histoire de Nathan le prophète, dans l'histoire de Gad le voyant."
,"30":"On y lit tout ce qui concerne son règne, sa bravoure et tout ce qui est arrivé, à lui, à Israël et à tous les royaumes étrangers."
}`)

}
func FR_LBDCC_LoadVH1RChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Le roi David se faisait vieux, il était très âgé; on avait beau le couvrir de vêtements, il ne pouvait plus se réchauffer."
,"2":"Ses serviteurs lui dirent: 'Que l'on aille chercher pour mon seigneur le roi une jeune fille vierge; elle sera à son service, elle le soignera, elle dormira avec lui et elle tiendra chaud à mon seigneur le roi.'"
,"3":"On chercha donc à travers tout le pays d'Israël une belle jeune fille, et l'on trouva Abisag de Sunem; on la conduisit auprès du roi."
,"4":"Cette jeune fille était vraiment très belle, elle soignait le roi, et elle le servait, mais il n'eut pas de rapports avec elle."
,"5":"Pendant ce temps, Adonias fils de Haggit se mettait en avant: 'C'est moi, disait-il, qui régnerai.' Il s'était acheté un char et des chevaux et cinquante hommes couraient devant lui."
,"6":"Son père n'avait jamais voulu le contrarier, lui dire: 'Pourquoi agis-tu de la sorte?' Sa mère Haggit l'avait mis au monde après Absalom et lui aussi était très beau."
,"7":"Il eut des entretiens avec Joab fils de Sérouya, avec le prêtre Ebyatar, et ceux-ci entrèrent dans le parti d'Adonias,"
,"8":"mais le prêtre Sadoc, Bénayas fils de Yoyada, le prophète Nathan, Chiméï et Réï, ainsi que les braves de David, refusèrent de soutenir Adonias."
,"9":"Un jour Adonias immola des brebis, des boeufs et des veaux gras près de la Pierre-qui-Glisse, à côté de la source du Foulon. Il invita tous ses frères, les fils du roi et tous les hommes de Juda qui étaient au service du roi,"
,"10":"mais il n'invita ni le prophète Nathan, ni Bénayas, ni les braves, ni son frère Salomon."
,"11":"Alors Nathan dit à Bethsabée, la mère de Salomon: 'Sais-tu qu'Adonias fils d'Haggit s'est fait roi, et mon seigneur David n'en sait rien?"
,"12":"Maintenant laisse-moi te donner un conseil si tu veux sauver ta tête et celle de ton fils Salomon."
,"13":"Va trouver le roi David et dis-lui: Mon seigneur le roi a bien fait ce serment à sa servante: C'est ton fils Salomon qui régnera après moi, c'est lui qui s'assiéra sur mon trône. Comment se fait-il donc qu'Adonias se soit fait roi?"
,"14":"Et pendant que tu seras là à parler avec le roi, j'entrerai derrière toi et je confirmerai tes paroles.'"
,"15":"Bethsabée se rendit donc à la chambre du roi; il était très vieux et Abisag de Sunem était à son service."
,"16":"Elle s'agenouilla et se prosterna devant le roi, et le roi lui dit: 'Que veux-tu?'"
,"17":"Elle lui répondit: 'Mon seigneur n'a-t-il pas fait ce serment à sa servante par Yahvé, son Dieu: Ton fils Salomon régnera après moi, c'est lui qui s'assiéra sur mon trône?"
,"18":"Or voilà qu'Adonias s'est fait roi sans que tu le saches, mon seigneur le roi."
,"19":"Il a immolé une quantité de boeufs, des veaux gras, des moutons; il a invité tous les fils du roi ainsi que le prêtre Ebyatar et le général Joab, mais ton serviteur Salomon, il ne l'a pas invité."
,"20":"Pendant ce temps tout Israël a les yeux tournés vers toi, mon seigneur le roi, pour que tu désignes ton successeur."
,"21":"Ne vois-tu pas que lorsque mon seigneur le roi sera couché avec ses pères, moi et mon fils Salomon nous paierons tout cela?'"
,"22":"Elle n'avait pas fini de parler que le prophète Nathan arriva."
,"23":"On l'annonça au roi: 'Le prophète Nathan est là.' Il entra chez le roi, se prosterna la face contre terre,"
,"24":"puis il dit: 'Mon seigneur le roi, tu as sans doute décidé qu'Adonias serait roi après toi et s'assiérait sur ton trône,"
,"25":"car aujourd'hui il est descendu pour immoler une quantité de boeufs, de veaux gras et de moutons. Il a invité tous les fils du roi, les chefs de l'armée et le prêtre Ebyatar, et en ce moment ils mangent, ils boivent devant lui et ils crient: Vive le roi Adonias!"
,"26":"Mais moi, ton serviteur, le prêtre Sadoc, Bénayas, fils de Yoyada et ton serviteur Salomon, nous n'avons pas été invités."
,"27":"Est-il possible que cela vienne de mon seigneur le roi? Est-il possible qu'il ait caché à ses serviteurs le nom de celui qui s'assiérait sur le trône après lui?'"
,"28":"Le roi David répondit: 'Appelez-moi Bethsabée.' Elle entra donc chez le roi et se tint devant lui."
,"29":"Le roi fit ce serment: 'Aussi vrai que Yahvé est vivant, lui qui m'a délivré de toutes mes épreuves,"
,"30":"aujourd'hui même je vais tenir le serment que j'ai fait par Yahvé, Dieu d'Israël. Car j'ai bien dit: Ton fils Salomon régnera après moi, c'est lui qui s'assiéra sur mon trône à ma place.'"
,"31":"Bethsabée s'agenouilla, elle se prosterna la face contre terre devant le roi et dit: 'Que mon seigneur le roi David vive à jamais!'"
,"32":"Alors le roi David ordonna: 'Appelez-moi le prêtre Sadoc, le prophète Nathan et Bénayas fils de Yoyada.' Ils vinrent et se présentèrent devant le roi."
,"33":"Le roi leur dit: 'Réunissez les serviteurs de votre seigneur; vous ferez monter mon fils Salomon sur ma propre mule et vous descendrez avec lui à la source de Guihon."
,"34":"Là, le prêtre Sadoc et le prophète Nathan le consacreront comme roi d'Israël; vous sonnerez du cor et tout le monde criera: Vive le roi Salomon!"
,"35":"Puis vous remonterez derrière lui et il viendra s'asseoir sur mon trône. Car c'est lui qui va régner à ma place, c'est lui que j'ai choisi pour diriger Israël et Juda.'"
,"36":"Bénayas, fils de Yoyada, répondit au roi: 'Amen! Que Yahvé, le Dieu de mon seigneur le roi réalise tout cela!"
,"37":"Que Yahvé soit maintenant avec Salomon comme il a été avec mon seigneur le roi, qu'il rende son trône plus glorieux encore que le trône de mon seigneur le roi David!'"
,"38":"Le prêtre Sadoc, le prophète Nathan et Bénayas, fils de Yoyada, firent donc monter Salomon sur la mule du roi David et le menèrent à Guihon escortés des Kérétiens et des Pélétiens."
,"39":"Le prêtre Sadoc prit la corne d'huile dans la Tente et il consacra Salomon, on sonna du cor et tout le peuple cria: 'Vive le roi Salomon!'"
,"40":"Puis tout le peuple remonta derrière lui; les gens jouaient de la flûte et manifestaient une grande joie, la terre tremblait à se fendre au bruit qu'ils faisaient."
,"41":"Adonias et tous ses invités en entendirent l'écho alors qu'ils achevaient leur repas. Joab entendit le son du cor: 'Pourquoi, dit-il, ces bruits d'une ville en fête?'"
,"42":"Il parlait encore lorsque Yonathan, le fils du prêtre Ebyatar, arriva. Adonias lui dit: 'Approche, tu es un homme et tu apportes sûrement de bonnes nouvelles.'"
,"43":"Mais Yonathan répondit à Adonias: 'C'est tout le contraire! Notre seigneur le roi David a consacré Salomon comme roi."
,"44":"Le roi a envoyé avec lui le prêtre Sadoc, le prophète Nathan, Bénayas fils de Yoyada, les Kérétiens et les Pélétiens. Ils l'ont assis sur la mule du roi"
,"45":"et ensuite, à Guihon, le prêtre Sadoc et le prophète Nathan l'ont consacré comme roi. Ils sont remontés en poussant des cris de joie et la ville était en fête: c'est le bruit que vous avez entendu."
,"46":"Et mieux que cela: Salomon s'est assis sur le trône du roi"
,"47":"et les serviteurs du roi sont venus féliciter notre seigneur le roi David: Que ton Dieu, disaient-ils, rende le nom de Salomon plus glorieux encore que le tien, qu'il élève son trône plus encore que le tien. Le roi lui-même s'est prosterné sur son lit,"
,"48":"et voici ce qu'il a dit: Béni soit Yahvé, le Dieu d'Israël, qui a permis aujourd'hui que mes yeux voient l'un de mes descendants assis sur mon trône!'"
,"49":"A ces mots, tous les invités d'Adonias furent pris de panique, ils se levèrent et partirent chacun de leur côté."
,"50":"Adonias eut peur de Salomon, il se leva et s'en alla saisir les cornes de l'autel."
,"51":"On informa Salomon: 'Voici qu'Adonias a peur du roi Salomon, il a saisi les cornes de l'autel et il a dit: Que le roi Salomon me jure aujourd'hui de ne pas me faire mourir par l'épée.'"
,"52":"Salomon répondit: 'S'il se conduit comme un homme honnête, pas un de ses cheveux ne tombera à terre, mais s'il se conduit mal, il mourra.'"
,"53":"Le roi envoya des gens pour le faire descendre de l'autel, et Adonias vint se prosterner devant le roi Salomon. Salomon lui dit: 'Rentre chez toi.'"
}`)
	CurrentBook.AddChapter(2, `{
"1":"Lorsque David sentit que les jours de sa mort approchaient, il donna ses instructions à son fils Salomon:"
,"2":"'Je m'en vais par le chemin de toute la terre, montre-toi fort et sois un homme."
,"3":"Reste fidèle à Yahvé, ton Dieu, marche dans ses voies, observe ses lois, ses commandements, ses ordonnances et ses préceptes, tels qu'ils sont écrits dans la loi de Moïse. Ainsi tu réussiras dans tout ce que tu feras"
,"4":"et Yahvé tiendra la promesse qu'il m'a faite: Si tes fils veillent à leur conduite, s'ils marchent devant moi sincèrement de tout leur coeur et de toute leur âme, tu auras toujours un descendant sur le trône d'Israël."
,"5":"Maintenant tu sais ce que m'a fait Joab, fils de Sérouya, comment il a tué deux chefs de l'armée d'Israël, Abner fils de Ner, et Amasa fils de Yéter. Il a versé en temps de paix le sang de la guerre; ce sang de la guerre a rejailli sur la ceinture nouée autour de mes reins et sur les sandales que je porte aux pieds."
,"6":"Toi donc, tu ne laisseras pas ses cheveux blancs descendre en paix au séjour des morts."
,"7":"Tu te montreras généreux envers les fils de Barzillaï de Galaad: ils mangeront à ta table car ils sont venus au-devant de moi lorsque je fuyais devant ton frère Absalom."
,"8":"Tu as près de toi Chiméï, fils de Guéra, le Benjaminite de Bahourim, qui m'a insulté lorsque je fuyais vers Mahanayim. Il m'a maudit de façon horrible mais, lorsqu'il est venu à ma rencontre au Jourdain, je lui ai juré par Yahvé de ne pas le mettre à mort."
,"9":"Puisque tu es un homme sage et tu sais ce que tu dois fair e, tu ne laisseras pas sa faute sans punition et c'est dans le sang que tu feras descendre ses cheveux blancs au séjour des morts.'"
,"10":"Alors David se coucha avec ses pères et on l'enterra dans la cité de David."
,"11":"David avait régné quarante ans sur Israël: sept ans à Hébron et trente trois ans à Jérusalem."
,"12":"Salomon s'assit sur le trône de David son père, et sa royauté s'affermit."
,"13":"Un jour Adonias, fils de Haggit, arriva chez Bethsabée, la mère de Salomon. Elle lui dit: 'Viens-tu avec de bonnes intentions?' Il répondit: 'Oui.'"
,"14":"Il ajouta: 'Je voudrais te parler.' Elle lui dit: 'Parle.'"
,"15":"Il dit: 'Tu sais que la royauté m'appartenait; tous les Israélites s'étaient tournés vers moi pour que je sois leur roi, mais la royauté m'a échappé et mon frère en a hérité, Yahvé la lui a donnée."
,"16":"Maintenant j'ai une demande à te faire, ne me le refuse pas.' Elle lui dit: 'Parle.'"
,"17":"'Je voudrais, dit-il, que tu parles au roi Salomon, il ne te repoussera pas. Dis-lui qu'il me donne pour femme Abisag la Sunamite.'"
,"18":"Bethsabée répondit: 'C'est bien, je parlerai au roi à ton sujet.'"
,"19":"Bethsabée entra donc chez le roi Salomon pour lui faire part de la demande d'Adonias. Le roi vint à sa rencontre, il se prosterna devant elle, puis il s'assit sur son trône. On plaça un trône pour la mère du roi et elle s'assit à sa droite. "
,"20":"Elle dit alors: 'Je n'ai qu'une petite demande à te faire, écoute-moi.' Le roi lui dit: 'Mère, demande, je t'écouterai.'"
,"21":"Elle lui dit: 'Permets qu'Abisag la Sunamite soit donnée pour femme à ton frère Adonias.'"
,"22":"Le roi Salomon répondit à sa mère: 'Pourquoi demandes-tu Abisag la Sunamite pour Adonias? Demande plutôt pour lui la royauté: déjà il est mon frère aîné et il a pour lui le prêtre Ebyatar et Joab fils de Sérouya.'"
,"23":"Alors le roi Salomon jura par Yahvé: 'Que Dieu me maudisse et me maudisse encore si Adonias ne paye pas de sa vie cette parole qu'il a dite!"
,"24":"Je le jure par Yahvé qui a confirmé mon pouvoir, qui m'a fait asseoir sur le trône de David mon père et m'a donné une maison comme il l'avait promis - aussi vrai que Yahvé est vivant, aujourd'hui même Adonias sera mis à mort.'"
,"25":"Le roi Salomon confia la chose à Bénayas fils de Yoyada: il frappa Adonias et il mourut."
,"26":"Quant au prêtre Ebyatar, le roi lui dit: 'Va-t'en: dans ta propriété d'Anatot. Tu mérites la mort, mais aujourd'hui je ne te ferai pas mourir, car tu as porté l'Arche de Dieu devant mon père, et tu as partagé les souffrances de mon père.'"
,"27":"Salomon chassa donc Ebyatar, il le priva de sa charge de prêtre de Yahvé; ainsi se réalisa la parole que Yahvé avait dite contre la maison d'Héli à Silo."
,"28":"La nouvelle en arriva à Joab. Joab n'avait pas suivi le parti d'Absalom mais il avait suivi le parti d'Adonias. Il se réfugia donc dans la Tente de Yahvé et saisit les cornes de l'autel."
,"29":"On avertit le roi Salomon que Joab s'était réfugié à côté de l'autel dans la Tente de Yahvé. Salomon envoya dire à Joab: 'Pourquoi te réfugier près de l'autel?' Joab lui dit: 'J'ai eu peur de toi et je me suis réfugié auprès de Yahvé.' Alors Salomon envoya Bénayas fils de Yoyada avec cet ordre: 'Va et frappe-le.'"
,"30":"Bénayas entra dans la Tente de Yahvé et lui dit: 'Le roi te commande de sortir.' Mais il répondit: 'Non! Je mourrai ici.' Bénayas rapporta ces paroles au roi: 'Voici ce qu'a dit Joab, voici ce qu'il m'a répondu.'"
,"31":"Le roi lui dit: 'Fais comme il a dit: frappe-le, et ensuite tu l'enterreras. Ainsi tu écarteras loin de moi et de la maison de mon père le sang innocent qu'a versé Joab."
,"32":"Yahvé fera retomber son sang sur sa propre tête, car il a frappé deux hommes plus justes et meilleurs que lui. Il a tué par l'épée, à l'insu de David mon père, Abner fils de Ner chef de l'armée d'Israël, et Amasa fils de Yéter, chef de l'armée de Juda."
,"33":"Leur sang retombera sur la tête de Joab et sur sa famille pour toujours, mais David et sa descendance, sa maison et son trône seront en paix avec Yahvé pour toujours.'"
,"34":"Bénayas fils de Yoyada monta donc; il frappa Joab, qui mourut. On l'enterra dans sa maison au désert."
,"35":"Le roi plaça alors Bénayas fils de Yoyada à la tête de son armée, en remplacement de Joab; le roi mit aussi le prêtre Sadoc à la place d'Ebyatar."
,"36":"Le roi fit ensuite appeler Chiméï; il lui dit: 'Construis-toi une maison à Jérusalem, tu y habiteras et tu n'en sortiras pas."
,"37":"Le jour où tu en sortiras et où tu traverseras le torrent du Cédron, tu seras mis à mort: te voilà prévenu, tu seras responsable de ta propre mort.'"
,"38":"Chiméï répondit au roi: 'C'est bon! Ton serviteur fera comme mon seigneur le roi vient de le dire.' Et Chiméï resta de longs jours à Jérusalem."
,"39":"Cependant, au bout de trois ans, deux des serviteurs de Chiméï s'étaient enfuis auprès d'Akich fils de Maakah, roi de Gat. On en informa Chiméï: 'Tes serviteurs sont à Gat.'"
,"40":"Chiméï se leva, sella son âne et se rendit à Gat, chez Akich, pour rechercher ses serviteurs. Puis Chiméï ramena ses serviteurs de Gat."
,"41":"On avertit Salomon que Chiméï était allé de Jérusalem à Gat et qu'il en était revenu."
,"42":"Alors le roi fit appeler Chiméï: 'Au nom de Yahvé je te l'avais dit, je t'avais averti solennellement: Le jour où tu sortiras et où tu iras ici où là, tu mourras. Tu m'as alors répondu: C'est bon."
,"43":"Pourquoi donc n'as-tu pas respecté ton serment juré au nom de Yahvé et l'ordre que je t'avais donné?'"
,"44":"Le roi dit encore à Chiméï: 'Tu sais le mal que tu as fait à mon père David et tous les malheurs que tu as appelés sur lui. Mais aujourd'hui Yahvé fait retomber sur ta tête le malheur;"
,"45":"par contre le roi Salomon sera béni et le trône de David sera affermi à jamais devant Yahvé.'"
,"46":"Le roi donna un ordre à Bénayas fils de Yoyada: il sortit et frappa Chiméï qui mourut. Ainsi le pouvoir royal s'affermit dans les mains de Salomon."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Salomon devint gendre du Pharaon d'Egypte; il épousa la fille du Pharaon et la mena dans la cité de David, car il n'avait pas encore fini de construire sa maison, la maison de Yahvé et le rempart de Jérusalem."
,"2":"Le peuple offrait alors des sacrifices sur les Hauts-Lieux car la maison destinée au Nom de Yahvé n'était pas encore bâtie."
,"3":"Salomon aimait Yahvé, il marchait selon les préceptes de son père David, mais il offrait des sacrifices sur les Hauts-Lieux et y brûlait des parfums."
,"4":"Le roi se rendit à Gabaon pour y offrir des sacrifices; c'était le Haut-Lieu principal et Salomon offrit mille holocaustes sur cet autel."
,"5":"Là, à Gabaon, Yahvé apparut en songe à Salomon pendant la nuit. Il lui dit: 'Demande-moi ce que tu veux et je te le donnerai.'"
,"6":"Salomon répondit: 'Tu as montré une très grande bonté à ton serviteur David, mon père; il est vrai qu'il marchait en ta présence dans la fidélité, la justice et la sincérité. Tu n'as pas mis fin à cette grande bonté à son égard: tu as voulu que son fils soit assis aujourd'hui sur son trône."
,"7":"Tu m'as fait roi, Yahvé, mon Dieu, à la place de mon père David. Mais je ne suis qu'un tout jeune homme et je ne sais encore pas agir."
,"8":"Ton serviteur se retrouve avec ton peuple, que tu as choisi toi-même, et c'est un peuple si nombreux qu'on ne peut ni l'évaluer, ni le compter."
,"9":"Accorde donc à ton serviteur l'intelligence pour distinguer entre le bien et le mal lorsqu'il gouverne ton peuple. Qui pourrait en effet bien gouverner un peuple aussi important?'"
,"10":"La demande de Salomon plut au Seigneur,"
,"11":"et Dieu lui dit: 'Je retiens que tu n'as demandé pour toi, ni une longue vie, ni la richesse, ni la mort de tes ennemis. Parce que tu m'as fait cette autre demande, parce que tu m'as demandé l'intelligence pour exercer la justice,"
,"12":"je vais faire ce que tu m'as demandé. Je te donne un coeur sage et intelligent, tel qu'il n'y en a pas eu de pareil avant toi et qu'il n'y en aura pas de pareil après toi."
,"13":"Et je te donnerai même ce que tu n'as pas demandé: tu auras richesse et gloire plus qu'aucun autre roi de la terre durant ta vie."
,"14":"Si tu marches dans mes voies, si tu observes mes ordonnances et mes commandements comme l'a fait ton père David, je te donnerai longue vie.'"
,"15":"Alors Salomon s'éveilla: il comprit que c'était un rêve. Une fois rentré à Jérusalem, il alla officier face à l'Arche de l'Alliance de Yahvé et il offrit des holocaustes et des sacrifices de communion; puis il donna un grand repas à tous ses serviteurs."
,"16":"Deux prostituées vinrent au tribunal du roi."
,"17":"L'une d'elles lui dit: 'Je t'en prie, mon seigneur, cette femme et moi nous habitons la même maison et dans cette maison j'ai donné le jour à un enfant."
,"18":"Trois jours après la naissance, elle aussi a mis au monde un enfant. Nous étions ensemble, aucune personne étrangère avec nous, nous étions seules dans la maison."
,"19":"Or, durant la nuit, le fils de cette femme est mort car elle s'était couchée sur lui."
,"20":"Alors elle se lève au milieu de la nuit, elle prend mon fils à côté de moi tandis que je dors, elle le couche sur elle et elle place son fils mort à côté de moi."
,"21":"Au matin, lorsque je me lève pour allaiter mon fils, je vois qu'il est mort, mais en regardant attentivement, je m'aperçois que ce n'est pas l'enfant que j'ai mis au monde.'"
,"22":"A ce moment l'autre femme se met à crier: 'C'est mon fils qui est vivant et c'est ton fils qui est mort!' Et la première réplique: 'Ce n'est pas vrai, c'est ton fils qui est mort, le mien est en vie!' Et elles se disputaient ainsi devant le roi."
,"23":"Le roi prit la parole: 'Tu dis, toi: C'est mon fils qui est vivant et c'est ton fils qui est mort. Et toi tu dis: Non! C'est ton fils qui est mort et c'est le mien qui est vivant.'"
,"24":"Le roi ordonna: 'Apportez-moi une épée.' On apporta l'épée devant le roi."
,"25":"Le roi dit alors: 'Coupez en deux l'enfant qui vit, et donnez-en la moitié à l'une et l'autre moitié à l'autre.'"
,"26":"Alors la femme dont le fils était vivant dit au roi, car elle était bouleversée dans son coeur de mère: 'Non, je t'en prie, mon seigneur, donne-lui plutôt l'enfant qui vit, qu'on ne le tue pas.' Mais l'autre répliquait: 'Il ne sera ni à toi ni à moi, partagez-le.'"
,"27":"Alors le roi décida: 'Donnez l'enfant qui vit à la première, ne le tuez pas; c'est elle qui est la mère.'"
,"28":"Tout Israël entendit parler du jugement que le roi avait prononcé; dès lors on eut un grand respect pour le roi car on voyait que la sagesse de Dieu était en lui lorsqu'il rendait la justice."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Le roi Salomon régnait sur tout Israël."
,"2":"Voici les fonctionnaires qu'il avait à son service: Azaryas fils de Sadoc était prêtre,"
,"3":"Elihaf et Ahyias fils de Chicha étaient secrétaires, Yochafat fils d'Ayiloud était archiviste,"
,"4":"Bénayas fils de Yoyada commandait l'armée, Sadoc et Ebyatar étaient prêtres,"
,"5":"Azaryas fils de Nathan, chef des préfets; Zaboud fils de Nathan, familier du roi;"
,"6":"Ahichar était maître du palais; Eliab fils de Joab, chargé de l'armée; Adoram fils d'Abda, chef de la corvée."
,"7":"Salomon avait douze gouverneurs pour tout Israël; ils approvisionnaient le roi et son palais, chacun durant un mois par an."
,"8":"Voici leurs noms: Ben-Hour dans la montagne d'Ephraïm;"
,"9":"Ben-Déker à Mahas, Chaalbim, Beth-Chémech, Ayalon et Beth-Hanan,"
,"10":"Ben-Hézed à Aroubot, il avait aussi en charge Soko et tout le pays de Héfer;"
,"11":"Ben-Abinadab sur les coteaux de Dor, sa femme Tabaat était fille de Salomon;"
,"12":"Baana fils d'Ayiloud, à Tanak et Méguiddo et jusqu'au-delà de Yoknéam: il avait également Beth-Shéan au-dessous de Yizréel et de Beth-Shéan jusqu'à Abel-Méhola en direction de Sartan;"
,"13":"Ben-Guéber à Ramot de Galaad: il avait les Douars de Yaïr fils de Manassé en Galaad, et le territoire d'Argob dans le Bashan, soit soixante villes fortifiées, entourées de remparts et munies de verrous de bronze."
,"14":"Ahinadab fils d'Iddo, à Mahanayim;"
,"15":"Ahimaas en Nephtali: il épousa lui-aussi une fille de Salomon nommée Basmat."
,"16":"Baana fils de Houchaï pour Asher et pour la côte rocheuse;"
,"17":"Yochafat fils de Parouah pour Issacar;"
,"18":"Chiméï fils d'Ela pour Benjamin;"
,"19":"Guéber fils d'Ouri pour le pays de Gad et le pays de Sihon, roi des Amorites, et d'Og, roi du Bashan. En outre, un préfet demeurait dans le pays de Juda."
,"20":"Juda et Israël étaient aussi nombreux que le sable sur le bord de la mer, on mangeait, on buvait et on vivait heureux."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Salomon étendit son autorité sur tous les royaumes, depuis le Fleuve jusqu'au pays des Philistins et jusqu'à la frontière d'Egypte. Tous ces peuples étaient soumis à Salomon et lui apportaient leur tribut."
,"2":"Pour l'entretien de Salomon il fallait chaque jour trente mesures de fleur de farine et soixante mesures de farine ordinaire,"
,"3":"dix boeufs gras, vingt boeufs de pâturage, cent moutons, sans compter les cerfs, les gazelles, les chevreuils et les volailles engraissées."
,"4":"Son pouvoir s'étendait sur tout le pays en deçà du fleuve, depuis Tafsa jusqu'à Gaza, sur tous les rois de cette région, et la paix régnait sur ses frontières."
,"5":"Durant tout le règne de Salomon, Juda et Israël habitèrent en paix, chacun sous sa vigne ou sous son figuier, depuis Dan jusqu'à Bersabée."
,"6":"Salomon avait quatre mille stalles pour le service de ses chars et de ses douze mille chevaux."
,"7":"Chacun de ces gouverneurs assurait durant un mois l'entretien de Salomon et de tous ceux qui mangeaient à la table du roi. Ils veillaient à ce que rien ne manque, selon les ordres qu'ils avaient reçus,"
,"8":"chacun faisait parvenir l'orge et la paille pour les chevaux et les bêtes de somme, là où ils étaient parqués."
,"9":"Dieu donna à Salomon la sagesse, une très grande intelligence, et une science aussi vaste que le sable qui est au bord des mers."
,"10":"La sagesse de Salomon surpassait la sagesse de n'importe quel sage de l'Orient et toute la sagesse de l'Egypte. Il fut plus sage que n'importe quel autre, plus sage qu'Etan l'Ezrahite, plus sage que Héman, Kalkol et Darda, les fils de Mahol. Sa renommée s'étendit à tous les pays voisins."
,"12":"Il prononça trois mille maximes, il composa mille cinq cantiques,"
,"13":"il parla des plantes, depuis le cèdre du Liban jusqu'à l'hysope qui pousse sur les murs; il parla des animaux, des oiseaux, des reptiles et des poissons."
,"14":"De tous les pays on venait entendre la sagesse de Salomon et il reçut des cadeaux de tous les rois de la terre qui avaient entendu parler de sa sagesse."
,"15":"Quand Hiram, roi de Tyr, apprit qu'on avait sacré roi Salomon à la place de son père, il lui envoya une ambassade, car Hiram s'était toujours montré l'ami de David."
,"16":"Salomon envoya donc ce message à Hiram:"
,"17":"'Tu le sais, Yahvé a finalement mis tous les ennemis de David sous la plante de ses pieds, mais ces guerres ont empêché mon père de construire un temple pour le Nom de Yahvé, son Dieu."
,"18":"Maintenant que Yahvé, mon Dieu, m'a donné la paix de tous côtés, et qu'il n'y a plus ni ennemi ni fléau,"
,"19":"je pense bâtir ce temple pour le Nom de Yahvé, mon Dieu. Lui-même a déclaré à David, mon père: 'C'est ton fils, celui que je mettrai à ta place sur ton trône, qui construira la Maison pour mon Nom."
,"20":"Tu sais bien que personne chez nous n'est aussi adroit pour couper les arbres que les gens de Sidon; ordonne donc que l'on coupe pour moi des cèdres dans le Liban. Mes serviteurs travailleront avec les tiens et je paierai pour le salaire de tes serviteurs ce que tu me diras.'"
,"21":"Hiram fut tout joyeux d'entendre les paroles de Salomon; il dit: 'Béni soit aujourd'hui Yahvé qui a donné à David un fils aussi sage pour gouverner ce grand peuple!"
,"22":"Hiram répondit à Salomon: 'J'ai bien reçu ton message, je ferai ce que tu me demandes à propos du bois de cèdre et du bois de cyprès."
,"23":"Mes serviteurs les descendront depuis le Liban jusqu'à la mer et je les ferai remorquer en radeaux jusqu'à l'endroit que tu m'indiqueras; là je les ferai dévier et tu les prendras. De mon côté je te demande de me fournir des vivres pour ma maison.'"
,"24":"Hiram livra à Salomon du bois de cèdre et du bois de cyprès, autant qu'il en voulut;"
,"25":"Salomon, de son côté, donnait à Hiram vingt mille mesures de blé pour l'entretien de sa maison et vingt mille mesures d'huile d'olives broyées. Voilà ce que Salomon livrait chaque année à Hiram."
,"26":"Yahvé donnait la sagesse à Salomon comme il l'avait promis, de sorte que la paix régna entre Hiram et Salomon: les deux conclurent une alliance."
,"27":"Le roi Salomon leva parmi les Israélites trente mille hommes de corvée,"
,"28":"il les envoyait au Liban à tour de rôle: dix mille chaque mois. Ils étaient un mois au Liban et deux mois chez eux; Adoram était responsable de la corvée."
,"29":"Salomon disposait de soixante-dix-mille hommes pour porter les charges et de quatre-vingt mille autres pour tailler les pierres dans la montagne,"
,"30":"sans compter les trois mille trois cents contremaîtres établis par Salomon pour surveiller le peuple qui travaillait dans les chantiers."
,"31":"Le roi ordonna d'extraire de grandes pierres, des pierres de choix, pour faire les fondations du Temple en pierres de taille."
,"32":"Les ouvriers de Salomon, les ouvriers de Hiram et les habitants de Byblos, taillèrent et préparèrent le bois et les pierres pour la construction du Temple."
}`)
	CurrentBook.AddChapter(6, `{
"1":"En l'an 48 0 après la sortie des Israélites du pays d'Egypte, la quatrième année du règne de Salomon sur Israël, au second mois, le mois de Ziv, il mit en chantier la Maison, ou Temple de Yahvé."
,"2":"Elle avait soixante coudées de long, vingt de large et trente coudées de haut."
,"3":"Le vestibule en avant du sanctuaire de la Maison avait vingt coudées de long dans le sens de la largeur de la Maison et dix coudées de profondeur sur le devant de la Maison."
,"4":"Les fenêtres de la Maison étaient garnies de grilles."
,"5":"Le long des murs de la Maison, on construisit une galerie qui faisait le tour du Sanctuaire et du Saint des Saints. Tout autour s'ouvraient des chambres latérales."
,"6":"La galerie d'en-bas avait une largeur de cinq coudées, celle du milieu une largeur de six coudées, et la troisième une largeur de sept coudées, car on avait disposé des retraits tout autour de la Maison à l'extérieur, pour ne pas entailler les murs."
,"7":"Pour construire la Maison, on se servit de pierres préparées dans les carrières; tout le temps de la construction on n'entendit dans la Maison ni marteau, ni hache, ni aucun outil de fer."
,"8":"L'entrée de la galerie inférieure était sur le côté droit de la Maison. On montait par des escaliers à la galerie intermédiaire et, de là, à la galerie supérieure."
,"9":"Salomon mit en chantier la Maison et il l'acheva. Il y mit un plafond avec des moulures et des panneaux de cèdres."
,"10":"Il donna cinq coudées de hauteur à la galerie qui faisait le tour de la Maison. Elle tenait à la Maison par ses poutres de cèdre."
,"11":"La parole de Yahvé fut adressée à Salomon, pour lui dire:"
,"12":"'Tu bâtis cette Maison. Si tu marches selon mes lois et mets en pratique mes ordonnances, si tu observes mes commandements et règles sur eux ta conduite, cette Maison que tu construis me permettra de tenir la promesse que j'ai faite à ton père David:"
,"13":"J'habiterai au milieu des Israélites et je n'abandonnerai pas mon peuple Israël.'"
,"14":"Salomon construisit la Maison et l'acheva."
,"15":"A l'intérieur, les murs étaient couverts depuis le sol jusqu'au plafond avec des planches de cèdres; tout l'intérieur était couvert de bois et le sol était couvert d'un plancher de cyprès."
,"16":"Le fond de la Maison était recouvert de planches de cèdre depuis le sol jusqu'au plafond: c'est là qu'il construisit le Saint des Saints."
,"17":"La Maison en avant du Saint des Saints avait quarante coudées."
,"18":"A l'intérieur de la Maison le cèdre était sculpté en forme de coloquintes et de guirlandes de fleurs: tout était revêtu de cèdre et l'on ne voyait pas les pierres."
,"19":"On avait préparé le Saint des Saints au coeur de la Maison, à l'intérieur, pour y placer l'Arche d'Alliance de Yahvé."
,"20":"En avant du Saint des Saints qui avait vingt coudées de long, vingt coudées de large et vingt coudées de haut, on dressa un autel de cèdre recouvert d'or fin."
,"21":"Salomon revêtit d'or fin l'intérieur de la Maison et une chaîne plaquée d'or fermait le Saint des Saints."
,"22":"Ainsi toute la Maison était recouverte d'or; il avait aussi recouvert d'or l'autel placé devant le Saint des Saints."
,"23":"Dans le Saint des Saints, il fit deux Chérubins de bois d'olivier sauvage de dix coudées de haut."
,"24":"Chacune des ailes de chérubin avait cinq coudées: cela faisait donc dix coudées de l'extrémité d'une aile à l'extrémité de l'autre."
,"25":"Le second chérubin mesurait également dix coudées; les deux chérubins avaient la même taille et la même forme."
,"26":"La hauteur du premier, comme du deuxième chérubin, était de dix coudées."
,"27":"Salomon plaça les chérubins au coeur de la Maison, les ailes déployées; l'aile du premier touchait l'un des murs et l'aile du second touchait l'autre mur, et leurs ailes se touchaient aile contre aile au milieu de la Maison."
,"28":"Salomon revêtit d'or les chérubins."
,"29":"Il fit sculpter en relief sur tous les murs de la Maison, tout autour, à l'intérieur comme à l'extérieur, des chérubins, des palmes et des fleurs."
,"30":"A l'intérieur comme à l'extérieur, le sol de la Maison était recouvert d'or."
,"31":"Les battants de la porte du Saint des Saints étaient en bois d'olivier sauvage, le linteau et les montants occupaient le cinquième de la porte,"
,"32":"les deux battants en bois d'olivier sauvage étaient sculptés de chérubins, de palmes et de fleurs; tout était recouvert d'or, y compris les chérubins et les palmes."
,"33":"De mêm e l'entrée du sanctuaire était garnie de montants en bois d'olivier sauvage, qui occupaient le quart de la porte."
,"34":"Les deux battants étaient en bois de cyprès; chacun d'eux était formé de deux panneaux qui s'articulaient;"
,"35":"on y avait sculpté des chérubins, des palmes et des guirlandes de fleurs, le tout recouvert d'or."
,"36":"On construisit la cour intérieure de trois rangées de pierres de taille et d'une rangée de poutres de cèdres."
,"37":"La quatrième année, au mois de Ziv, on posa les fondements de la Maison de Yahvé."
,"38":"La onzième année, au mois de Boul, le huitième mois, le Temple fut achevé dans tous ses détails, selon le plan qu'on avait établi; Salomon construisit le Temple en sept ans."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Salomon construisit également son palais, il mit treize ans pour le terminer."
,"2":"Il construisit la maison de la Forêt-du-Liban: elle avait cent coudées de long, cinquante coudées de large et trente coudées de haut. Elle était portée par des poutres de cèdres reposant sur des colonnes de cèdre."
,"3":"Un plafond de cèdre recouvrait les chambres, porté par les qua rante-cinq colonnes réparties en trois rangées de quinze."
,"4":"Il y avait aussi trois rangées de chambres dont les fenêtres se faisaient face tous les trois pas."
,"5":"Toutes les portes et fenêtres étaient carrés et les fenêtres se faisaient face tous les trois pas."
,"6":"Il fit un vestibule à colonnes, sa longueur était de cinquante coudées et sa largeur de trente; en avant se dressait un portique avec des colonnes et des degrés."
,"7":"Salomon fit aussi le Vestibule du Trône où il rendait la justice, on l'appelait le vestibule du Jugement; il était recouvert de cèdre depuis le sol jusqu'au plafond."
,"8":"Son habitation privée était construite de la même façon, dans une seconde cour, au-delà du Vestibule; Salomon construisit pour la fille du Pharaon qu'il avait épousée une maison semblable au Vestibule."
,"9":"Toutes ces constructions, depuis les fondations jusqu'aux corniches, étaient faites de pierres de choix taillées sur mesure et débitées à la scie."
,"10":"Les fondations étaient également en pierres de choix, des pierres de grandes dimensions, de huit à dix coudées."
,"11":"Au-dessus on trouvait encore des pierres de choix taillées sur mesure, ainsi que du bois de cèdre."
,"12":"La grande cour était faite de trois rangées de pierres de taille et d'une rangée de poutres de cèdre, comme la cour intérieure et comme le vestibule de la Maison."
,"13":"Salomon envoya chercher Houram de Tyr,"
,"14":"il était fils d'une veuve de la tribu de Nephtali, mais son père était de Tyr et il travaillait le bronze. C'était un homme très habile, plein de sagesse et de savoir-faire pour tout ce qui concernait le bronze. Il arriva donc auprès de Salomon pour exécuter tous ses travaux."
,"15":"Il fondit les deux colonnes de bronze; chaque colonne avait dix-huit coudées de haut, un fil de douze coudées en mesurait le tour; la seconde colonne était comme la première."
,"16":"Il fit deux chapiteaux coulés en bronze pour le sommet des colonnes; chaque chapiteau mesurait cinq coudées de haut."
,"17":"Les chapiteaux qui se trouvaient au sommet des colonnes étaient revêtus de filets et de chaînettes de bronze: il y en avait sept pour chaque chapiteau."
,"18":"Il fit ensuite les grenades, deux rangées autour de chaque filet, pour recouvrir les chapiteaux placés au sommet des colonnes."
,"19":"Les chapiteaux placés au sommet des colonnes dans le vestibule étaient en forme de lys; ils avaient quatre coudées de haut."
,"20":"Deux cents grenades entouraient les chapiteaux placés sur les deux colonnes, au-dessus du renflement garni du filet de bronze."
,"21":"Salomon dressa les colonnes devant le vestibule de la Maison; il dressa la première à droite et lui donna le nom de Yakin; il dressa la seconde à gauche et lui donna le nom de Boaz."
,"22":"Ainsi fut achevé le travail des colonnes."
,"23":"Il fit encore la Mer de bronze. Elle était ronde, avec dix coudées de diamètre et cinq coudées de hauteur; un fil de trente coudées en mesurait le tour."
,"24":"Au-dessous du rebord il y avait une double rangée de coloquintes en métal fondu."
,"25":"La Mer de bronze reposait sur douze boeufs, trois regardaient le nord, trois regardaient l'ouest, trois regardaient le midi, et trois regardaient l'est; la partie postérieure de leur corps était cachée par la Mer qui reposait sur eux."
,"26":"L'épaisseur de la Mer était d'un palme, son bord était façonné comme celui d'une coupe, semblable à une fleur de lys; elle pouvait contenir deux mille mesures."
,"27":"On fabriqua dix supports de bronze; chacun mesurait quatre coudées de long, quatre coudées de large et trois coudées de haut."
,"28":"Voici comment étaient les supports: ils étaient formés de panneaux et les panneaux s'emboîtaient dans des châssis."
,"29":"Sur les panneaux qui s'emboîtaient dans les châssis il y avait des lions, des taureaux et des chérubins; sur les châssis au-dessus et au-dessous on voyait en relief des lions et des boeufs."
,"30":"Chaque support avait quatre roues de bronze avec des essieux de bronze; les quatre pieds avaient des appliques de bronze qui supportaient le bassin; elles étaient fondues avec les pieds, tournées vers l'intérieur."
,"31":"L'ouverture pour recevoir le bassin était à l'intérieur de la couronne du support qu'elle dépassait d'une coudée sur le haut; cette ouverture était ronde, elle avait un support d'une coudée et demie. Sur cette ouverture il y avait des sculptures, les panneaux étaient carrés et non pas arrondis."
,"32":"Les quatre roues étaient au-dessous des panneaux, les essieux des roues étaient fixés au support de bronze; chaque roue avait une coudée et demie de haut."
,"33":"Les roues étaient façonnées comme les roues d'un char: leurs essieux, leurs jantes, leurs rayons et leurs moyeux, tout avait été fondu."
,"34":"Aux quatre angles des supports de bronze il y avait des attaches et ces attaches faisaient corps avec le support."
,"35":"La couronne qui s'élevait d'une coudée sur le support ne formait qu'un tout avec les appuis et les panneaux."
,"36":"Sur les plaques des appuis et sur les panneaux on grava des chérubins, des lions et des palmiers, selon la place disponible; des guirlandes en faisaient le tour."
,"37":"C'est ainsi qu'on façonna les dix supports de bronze pareillement fondus, tous de la même dimension et de la même forme."
,"38":"On fit également dix bassins de bronze, chaque bassin contenait quarante mesures, chaque bassin avait quatre coudées de diamètre; ils reposaient sur les supports, chaque bassin avait le sien."
,"39":"On disposa les dix supports, cinq sur le côté droit de la Maison et cinq sur le côté gauche; on plaça la Mer du côté droit de la Maison quand on regarde l'est, c'est-à-dire vers le sud."
,"40":"Houram fit également les chaudrons, les pelles et les coupes. Houram acheva ainsi tous les travaux que le roi Salomon lui avait commandés pour la Maison de Yahvé: "
,"41":"les deux colonnes, les chapiteaux placés au sommet des colonnes, avec les filets de bronze qui les recouvraient,"
,"42":"les quatre cents grenades réparties en deux rangées et accrochées au filet de bronze qui couvraient les chapiteaux,"
,"43":"les dix supports de bronze avec leur bassin,"
,"44":"la Mer de bronze et les douze boeufs qui la portaient,"
,"45":"les chaudrons, les pelles et les coupes. Houram fit en bronze poli tous ces objets que le roi Salomon avait commandés pour la Maison de Yahvé."
,"46":"Le roi les fit fondre dans la plaine du Jourdain, près du gué d'Adam, entre Soukkoth et Sartan."
,"47":"Ces objets étaient si nombreux que l'on ne pouvait calculer la quantité de bronze qu'on avait utilisée."
,"48":"Salomon fit encore tous les autres objets qui étaient dans la Maison de Yahvé: l'autel d'or, la table d'or sur laquelle on plaçait les pains de proposition,"
,"49":"les chandeliers d'or pur placés devant le Saint des Saints: cinq d'un côté et cinq de l'autre, les fleurs, les lampes, les éteignoirs en or,"
,"50":"les cuvettes, les couteaux, les cruches, les écuelles, les encensoirs en or, et également les gonds en or pour le Saint des Saints et pour les portes de la Maison."
,"51":"Avec cela se terminèrent les travaux que le roi Salomon avait entrepris pour la Maison de Yahvé. Salomon fit amener tout ce que son père David avait donné et consacré, l'or, l'argent et les vases, et il déposa le tout dans le trésor de la Maison de Yahvé."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Le roi Salomon rassembla alors auprès de lui, à Jérusalem, les anciens d'Israël, tous les chefs des tribus et les anciens des familles Israélites, pour transporter l'Arche d'Alliance de Yahvé qui était encore dans la cité de David qu'on appelle Sion."
,"2":"Tous les Israélites se rassemblèrent autour du roi Salomon pour la fête des Tentes; on était au mois d'Etanim, le septième mois de l'année."
,"3":"Lorsque les anciens d'Israël furent arrivés, les prêtres firent le transport de l'Arche."
,"4":"Ils firent monter l'Arche de Yahvé ainsi que la Tente du Rendez-Vous et tous les objets sacrés qui se trouvaient dans la Tente."
,"5":"Le roi Salomon et toute la communauté d'Israël rassemblée autour de lui, étaient là devant l'Arche. Ils offrirent des sacrifices de petit et de gros bétail en telle quantité qu'il était impossible de les compter."
,"6":"Les prêtres portèrent l'Arche de l'Alliance de Yahvé à sa place, dans le lieu le plus saint de la Maison, le Saint des Saints, au-dessous des ailes des Chérubins."
,"7":"Les Chérubins étendaient leurs ailes au-dessus de l'endroit où se trouvait l'Arche et ils couvraient ainsi l'Arche et ses barres."
,"8":"Comme les barres étaient assez longues, on pouvait en apercevoir l'extrémité lorsque l'on était dans le Saint, en avant du Saint des Saints, mais de l'extérieur on ne les voyait pas; elles sont restées là jusqu'à ce jour."
,"9":"Il n'y avait rien d'autre dans l'Arche que les deux tables de pierre que Moïse y avait déposées à l'Horeb, les tables de l'Alliance que Yahvé avait conclue avec les Israélites lorsqu'ils sortirent du pays d'Egypte."
,"10":"Au moment où les prêtres sortaient du Saint, la nuée remplit la Maison de Yahvé."
,"11":"Les prêtres ne purent continuer leur service liturgique à l'intérieur à cause de la nuée, car la Gloire de Yahvé remplissait la Maison de Yahvé."
,"12":"Alors Salomon déclara: 'Yahvé a dit qu'il habite dans la nuée;"
,"13":"ce que j'ai bâti est donc réellement la Maison où tu demeures, le lieu où tu résideras à jamais.'"
,"14":"Le roi se retourna pour bénir toute la communauté d'Israël qui était là debout."
,"15":"'Béni soit Yahvé, dit-il, le Dieu d'Israël! Ce que sa bouche avait annoncé à mon père David, sa main vient de le mener à bien. Il avait dit en effet:"
,"16":"Depuis le jour où j'ai fait sortir d'Egypte mon peuple Israël, je n'ai choisi aucune ville parmi toutes les tribus d'Israël pour qu'on y construise un Temple où habiterait mon Nom, j'ai seulement choisi David pour qu'il règne sur mon peuple Israël."
,"17":"David, mon père, voulait construire une Maison pour le Nom de Yahvé, Dieu d'Israël."
,"18":"Mais Yahvé a dit à David, mon père: Ce désir que tu as de construire un Temple en l'honneur de mon Nom, c'est très bien que tu l'aies eu."
,"19":"Seulement, ce ne sera pas toi qui construira le Temple, mais ton fils, celui qui naîtra de toi. C'est lui qui construira la Maison en l'honneur de mon Nom."
,"20":"Yahvé a donc réalisé la parole qu'il avait dite: j'ai succédé à David, mon père, et je me suis assis sur le trône d'Israël, comme Yahvé l'avait dit. Puis j'ai bâti la Maison en l'honneur de Yahvé, Dieu d'Israël,"
,"21":"j'en ai fait un lieu où réside l'Arche de l'Alliance de Yahvé, l'alliance qu'il a conclue avec nos pères lorsqu'il les a fait sortir du pays d'Egypte.'"
,"22":"Salomon était debout devant l'autel de Yahvé, face à toute la communauté d'Israël. Il étendit alors ses mains vers le ciel,"
,"23":"et il dit: 'Yahvé, Dieu d'Israël! Aucun Dieu en haut dans les cieux ou en bas sur la terre n'est semblable à toi, car tu gardes ton Alliance et ta fidélité envers tes serviteurs lorsqu'ils marchent devant toi de tout leur coeur."
,"24":"Tu as tenu la promesse que tu avais faite à ton serviteur David, mon père, et aujourd'hui tu as réalisé toi-même ce que tu avais promis."
,"25":"Maintenant Yahvé, Dieu d'Israël, tiens la promesse que tu as faite à ton serviteur David, mon père: Si tes fils veillent à leur conduite, s'ils marchent devant moi comme toi-même tu as marché devant moi, alors tu ne manqueras jamais d'un descendant qui siège devant moi sur le trône d'Israël."
,"26":"Maintenant, Dieu d'Israël, que se réalise cette promesse que tu as faite à ton serviteur David mon père."
,"27":"Dieu pourrait-il vraiment habiter sur la terre? Voici que les cieux et les cieux des cieux ne peuvent te contenir, combien moins cette Maison que j'ai construite."
,"28":"Cependant, Yahvé mon Dieu, sois attentif à la prière et à la supplication de ton serviteur, écoute le cri joyeux et la prière que ton serviteur fait aujourd'hui devant toi."
,"29":"Que tes yeux soient ouverts nuit et jour sur cette Maison, sur ce lieu dont tu as dit: C'est là qu'habitera mon Nom. Ecoute la prière que ton serviteur fera en ce lieu."
,"30":"Ecoute la supplication de ton serviteur et de ton peuple Israël lorsqu'ils viendront prier en ce lieu. Ecoute du haut du ciel, du lieu où tu habites, écoute et pardonne."
,"31":"Si quelqu'un pèche contre son frère et que celui-ci l'oblige à prêter un serment solennel, lorsqu'il viendra prêter ce serment dans cette Maison devant ton autel,"
,"32":"écoute-le du haut du ciel et interviens. Juge tes serviteurs, condamne le coupable et fais retomber sur sa tête sa faute, mais rends justice à l'innocent en proclamant son innocence."
,"33":"Lorsque ton peuple Israël aura péché contre toi et qu'il sera écrasé par ses ennemis, lorsqu'il reviendra vers toi et rendra gloire à ton Nom, lorsqu'il t'adressera sa prière et sa supplication dans cette Maison,"
,"34":"écoute du haut du ciel. Pardonne le péché de ton peuple Israël et ramène-le dans ce pays que tu as donné à ses pères."
,"35":"Lorsque ton peuple aura péché contre toi et que le ciel sera fermé, qu'il n'y aura plus de pluie, s'il vient dans ce lieu pour prier et rendre gloire à ton Nom, s'il renonce au péché pour lequel tu l'as humilié,"
,"36":"écoute du haut du ciel et pardonne le péché de tes serviteurs et de ton peuple Israël. Tu leur montreras le bon chemin dans lequel ils doivent marcher, tu feras tomber la pluie sur la terre que tu as donnée en héritage à ton peuple."
,"37":"Lorsqu'il y aura dans le pays une famine, une peste, un fléau sur le blé, des sauterelles, des criquets, lorsque l'ennemi assiégera l'une de ses villes, ou encore lorsqu'il y aura une catastrophe ou une maladie,"
,"38":"si un homme, si Israël, ton peuple, vient te prier et te supplier, s'il reconnaît sa faute du fond du coeur et qu'il tende ses mains vers cette Maison,"
,"39":"alors toi du haut des cieux où tu habites, écoute et pardonne. Tu connais son coeur, puisque toi et toi seul connais le coeur de tous les hommes: rends à chacun selon ses oeuvres."
,"40":"Ainsi, tout au long de leur vie, ils te craindront dans ce pays que tu as donné à leurs pères."
,"41":"Lorsqu'un étranger qui n'est pas de ton peuple Israël, mais qui viendra d'un pays lointain à cause de ton Nom"
,"42":"- car on entendra parler de ton grand Nom, de ta main puissante et des grands coups que tu frappes - lorsqu'il viendra donc prier dans cette Maison,"
,"43":"écoute du haut du ciel où tu habites, et réponds à la demande de cet étranger. Ainsi tous les peuples de la terre connaîtront ton nom, ils te craindront comme ton peuple Israël te craint, et ils sauront que ton Nom repose sur cette Maison que j'ai construite en l'honneur."
,"44":"Lorsque ton peuple partira en guerre contre ses ennemis par le chemin sur lequel tu l'auras envoyé, s'il se tourne vers cette ville que tu as choisie, vers cette Maison que j'ai construit en l'honneur de ton nom,"
,"45":"écoute du haut du ciel leurs prières et leurs supplications, et fais-leur justice."
,"46":"Lorsqu'il auront péché contre toi - car personne n'est sans péché, lorsque tu seras en colère contre eux, que tu les livreras à leurs ennemis et que leurs vainqueurs les emmèneront captifs dans leur pays, loin ou proche,"
,"47":"si du fond de leur exil ils regrettent vraiment leur attitude, s'ils se convertissent et qu'ils t'adressent leurs prières dans ce pays où ils sont déportés, s'ils te disent: Nous avons péché, nous avons fait ce qui est mal, nous avons commis un crime,"
,"48":"si du fond de leur exil ils reviennent vers toi de tout leur coeur et de toute leur âme, s'ils t'adressent leurs prières en se tournant vers leur pays que tu avais donné à leurs pères, vers la ville que tu as choisie et vers cette Maison que j'ai bâtie en l'honneur de ton Nom,"
,"49":"écoute du haut du ciel où tu habites, leurs prières et leurs supplications et exauce-les."
,"50":"Pardonne à ton peuple ses fautes et tous les péchés qu'il a commis contre toi; fais que ses vainqueurs aient pitié de lui,"
,"51":"car il est ton peuple et ton bien personnel, c'est toi qui les as fait sortir d'Egypte, du milieu de la fournaise de fer."
,"52":"Ainsi tes yeux seront attentifs à la supplication de ton serviteur, à la supplication de ton peuple Israël, et tu les écouteras dans toutes leurs demandes."
,"53":"C'est toi, Seigneur Yahvé, qui les a mis à part de tous les peuples de la terre pour qu'ils soient ton héritage, comme tu l'as dit par la bouche de Moïse ton serviteur lorsque tu as fait sortir nos pères d'Egypte.'"
,"54":"Durant toute cette prière et cette supplication, Salomon était à genoux, les mains tendues vers le ciel face à l'autel de Yahvé. Lorsqu'il eut fini,"
,"55":"il se releva et bénit toute la communauté d'Israël à haute voix:"
,"56":"'Béni soit Yahvé, dit-il, car il a donné la paix à son peuple Israël comme il l'avait promis. Il a fait se réaliser toutes les bonnes paroles qu'il avait fait entendre par la bouche de Moïse son serviteur."
,"57":"Que Yahvé, notre Dieu, soit avec nous comme il l'a été avec nos pères, qu'il ne nous abandonne pas et ne nous délaisse pas."
,"58":"Qu'il tourne nos coeurs vers lui pour que nous marchions dans toutes ses voies et que nous observions ses commandements, les lois et les ordonnances qu'il a données à nos pères."
,"59":"Que les paroles de cette supplication que j'ai adressée à Yahvé restent présentes nuit et jour devant Yahvé, notre Dieu. Ainsi, selon les besoins de chaque jour, il répondra à son serviteur et à son peuple Israël,"
,"60":"et tous les peuples de la terre sauront que Yahvé est Dieu, et qu'il n'y en a pas d'autre que lui."
,"61":"Que votre coeur soit tout entier à Yahvé, notre Dieu: marchez selon ses lois, observez ses commandements comme nous le faisons aujourd'hui.'"
,"62":"Le roi et tout Israël offrirent des sacrifices devant Yahvé:"
,"63":"Salomon fit immoler vingt-deux mille boeufs et cent vingt mille brebis pour le sacrifice de communion qu'il offrit à Yahvé. C'est ainsi que le roi et tous les Israélites consacrèrent la Maison de Yahvé."
,"64":"Ce jour-là, le roi consacra aussi le milieu de la cour qui est devant la Maison de Yahvé; c'est là qu'il offrit les holocaustes, les offrandes et les graisses des sacrifices de communion, parce que l'autel de bronze qui est devant était trop petit pour recevoir tous les holocaustes, les offrandes et les graisses des sacrifices de communion."
,"65":"Durant sept jours Salomon célébra la fête avec tout le peuple d'Israël, une grande foule qui était venue se rassembler devant Yahvé, depuis l'entrée d'Hamat jusqu'au Torrent d'Egypte."
,"66":"Le huitième jour il renvoya le peuple; ils bénirent le roi et s'en retournèrent chacun chez soi, joyeux et le coeur content pour tout le bien que Yahvé avait fait à David, son serviteur, et à son peuple Israël."
}`)
	CurrentBook.AddChapter(9, `{
"1":"La construction de la Maison de Yahvé, du palais royal et de tout ce que Salomon avait voulu bâtir, était terminée."
,"2":"Alors Yahvé apparut à Salomon une seconde fois, comme il lui était apparu à Gabaon."
,"3":"Yahvé lui dit: 'J'ai exaucé la prière et la supplication que tu as fait monter vers moi, j'ai consacré cette Maison que tu as construite pour y faire habiter mon Nom à jamais; mes yeux et mon coeur y seront toujours présents."
,"4":"Si tu marches devant moi comme a marché ton père David, dans la sincérité du coeur, dans la droiture, si tu mets en pratique ce que je t'ai commandé, si tu observes mes lois et mes ordonnances,"
,"5":"j'affermirai pour toujours le trône de ta royauté en Israël comme je l'ai promis à David ton père: tu auras toujours un de tes descendants sur le trône d'Israël."
,"6":"Mais si vous vous détournez de moi, vous et vos fils, si vous n'obéissez pas à mes commandements et à mes lois que j'ai placés devant vous, si vous allez servir d'autres dieux, si vous vous prosternez devant eux,"
,"7":"alors je supprimerai Israël du pays que je lui ai donné. Je rejetterai de devant moi la Maison que j'ai consacrée à mon Nom; Israël sera un objet de mépris et de moquerie parmi tous les peuples,"
,"8":"tout homme qui passera devant mon Temple en ruines sera dans l'étonnement et sifflera. On dira: Pourquoi Yahvé a-t-il traité de la sorte ce pays et cette Maison? "
,"9":"Et voici ce que l'on répondra: Ils ont abandonné Yahvé, leur Dieu, qui avait fait sortir leurs pères du pays d'Egypte, ils se sont attachés à d'autres dieux, ils se sont prosternés devant eux et les ont servis; c'est pourquoi Yahvé a fait venir sur eux toutes ces catastrophes."
,"10":"Tout le temps que Salomon construisait les deux maisons, la Maison de Yahvé et le palais royal,"
,"11":"Hiram, roi de Tyr, avait fourni à Salomon des bois de cèdre et de cyprès, et de l'or, autant qu'il en voulait; au terme de ces vingt années, le roi Salomon donna à Hiram vingt villes en Galilée."
,"12":"Hiram quitta Tyr pour voir les villes que Salomon lui donnait; très déçu, il dit à Salomon:"
,"13":"'Quelles sont ces villes que tu m'as données là, mon frère?' Et il les appela 'Pays de Kaboul'; c'est le nom qu'elles ont gardé jusqu'à ce jour."
,"14":"Hiram avait envoyé en effet à Salomon cent vingt talents d'or."
,"15":"Voici ce qui concerne la corvée, ces hommes que Salomon réquisitionna pour construire la Maison de Yahvé, son propre palais, le Millo, le mur de Jérusalem, Hazor, Méguiddo et Guézer"
,"16":"- (le pharaon, roi d'Egypte, était monté et s'était emparé de Guézer; il brûla la ville et tua tous les Cananéens qui l'habitaient, puis il donna la ville en dot à sa fille, femme de Salomon."
,"17":"Salomon rebâtit donc Guézer), Beth-Horon-le-Bas,"
,"18":"Baalat, Tamar dans le désert,"
,"19":"toutes les villes-entrepôts qu'avait Salomon, les villes pour les chars et les chevaux et tout ce que Salomon avait voulu construire à Jérusalem, au Liban, et dans tous les pays qui lui étaient soumis."
,"20":"On réquisitionna tout ce qui restait des Amorites, des Hittites, des Périsites, des Hivvites, et des Jébusites, en un mot tous ceux qui n'étaient pas Israélites."
,"21":"Tous leurs fils qui étaient restés dans le pays, car ils n'avaient pas été exterminés par les Israélites en raison de l'anathème, Salomon les prit comme hommes de corvées et ils le sont encore aujourd'hui."
,"22":"Mais il n'imposa pas la corvée aux Israélites; ceux-ci servaient comme soldats, ils faisaient partie de la garde, ils étaient officiers, écuyers, chefs de chars ou cavaliers."
,"23":"Des contremaîtres nommés par les préfets étaient préposés aux travaux du roi: ils étaient cinq cent cinquante qui commandaient les travailleurs sur les chantiers."
,"24":"Dès que la fille du Pharaon fut montée de la cité de David à la maison que Salomon lui avait construite, il bâtit le Millo."
,"25":"Salomon offrait trois fois par an des holocaustes et des sacrifices de communion sur l'autel qu'il avait fait bâtir à Yahvé. Là il faisait fumer ses offrandes par le feu devant Yahvé, et il veillait au bon état de la Maison."
,"26":"Le roi Salomon construisit une flotte à Ezyon-Guéber, à côté d'Elat, sur le bord de la Mer Rouge, au pays d'Edom."
,"27":"Hiram envoya ses serviteurs, des matelots qui connaissaient bien la mer, pour aider les serviteurs de Salomon sur ses vaisseaux."
,"28":"Ils allèrent ainsi à Ofir où ils se procurèrent de l'or, quatre cent vingt talents d'or qu'ils remirent au roi Salomon."
}`)
	CurrentBook.AddChapter(10, `{
"1":"La renommée de Salomon arriva jusqu'à la reine de Saba; elle vint le mettre à l'épreuve sur des énigmes de sagesse."
,"2":"Elle entra dans Jérusalem avec un cortège considérable, des chameaux portant des aromates, de l'or en très grande quantité, des pierres précieuses. Lorsqu'elle fut introduite auprès de Salomon, elle lui dit tout ce qu'elle avait en tête."
,"3":"Salomon répondit à toutes ses questions: rien n'était caché pour le roi, rien ne resta sans réponse."
,"4":"La reine de Saba put voir l'ordre instauré par Salomon: le palais qu'il avait construit,"
,"5":"le menu de sa table, les appartements de ses serviteurs, les costumes de ses ministres, les vêtements des échansons, les holocaustes qu'il offrait dans la Maison de Yahvé; elle en eut le souffle coupé."
,"6":"Elle dit alors au roi: 'Tout ce que j'ai entendu dire dans mon pays à propos de toi et de ta sagesse était donc vrai!"
,"7":"Je n'en croyais pas le récit avant d'avoir vu de mes yeux, mais c'est un fait qu'on ne m'en avait pas dit la moitié. Tu dépasses en sagesse et en gloire ce que la renommée m'avait appris."
,"8":"Heureuses tes femmes, heureux tes serviteurs qui sont continuellement devant toi et qui entendent tes sages décisions."
,"9":"Béni soit Yahvé, ton Dieu, qui t'a choisi pour te placer sur le trône d'Israël! Yahvé aime Israël à tout jamais et c'est pour cela qu'il t'a établi comme roi, pour que tu fasses régner le droit et la justice.'"
,"10":"Elle donna au roi cent vingt talents d'or, des aromates en très grande quantité et des pierres précieuses; on n'a jamais vu arriver une telle quantité d'aromates comme ce que la reine de Saba donna au roi Salomon."
,"11":"La flotte de Hiram qui avait amené l'or d'Ofir, avait rapporté aussi du bois de santal en très grande quantité, ainsi que des pierres précieuses."
,"12":"Avec le bois de santal le roi fit une balustrade pour la Maison de Yahvé, et une autre pour son palais. Il fit également avec ce bois des cithares et des harpes pour les musiciens; on n'a plus jamais vu une telle quantité de bois de santal."
,"13":"Le roi Salomon donna à la reine de Saba tout ce qu'elle pouvait désirer, tout ce qu'elle demanda, sans compter les cadeaux qu'il lui fit avec une générosité royale; elle s'en retourna ensuite et repartit vers son pays avec ses serviteurs."
,"14":"En une seule année on apportait à Salomon six cent soixante-six talents d'or,"
,"15":"sans compter les taxes des voyageurs, les impôts des commerçants et tout ce qui venait des rois d'Arabie et des gouverneurs du pays."
,"16":"Le roi Salomon fit deux cents grands boucliers d'or; on utilisa pour chaque bouclier six cents sicles d'or."
,"17":"Il fit également trois cents petits boucliers d'or pour lesquels on employa trois mines d'or par bouclier; le roi les plaça dans la maison de la Forêt-du-Liban."
,"18":"Le roi fit encore un grand trône d'ivoire revêtu d'or fin."
,"19":"Le trône avait six marches, c'était un fauteuil avec un dossier arrondi et, sur les deux côtés du siège, des bras qui s'appuyaient sur des lions."
,"20":"Il y avait également douze lions qui se tenaient de chaque côté sur les six marches du trône; dans aucun royaume on n'a fait chose semblable."
,"21":"Toutes les coupes du roi Salomon étaient en or, ainsi que tous les objets de la maison de la Forêt-du-Liban; rien n'était en argent, on le considérait même sans valeur aux jours de Salomon."
,"22":"Salomon avait sur mer, avec la flotte de Hiram, des navires pour expéditions lointaines. Tous les trois ans la flotte revenait d'outremer, apportant de l'or, de l'argent, des ivoires, des singes et des paons."
,"23":"Le roi Salomon dépassa tous les rois de la terre en richesse et en sagesse."
,"24":"Tout le monde voulait être reçu en audience par Salomon et entendre la sagesse que Dieu lui avait donnée."
,"25":"Chacun amenait son cadeau, objets d'argent et objets d'or, vêtements, armures, parfums, chevaux et mulets; et cela d'année en année."
,"26":"Salomon acquit un grand nombre de chars et des cavaliers; il les établit dans les villes de chars et à Jérusalem auprès du roi."
,"27":"Le roi fit si bien qu'à Jérusalem l'argent était aussi commun que les pierres, et les cèdres aussi nombreux que les sycomores dans le Bas-Pays."
,"28":"Les chevaux de Salomon venaient de Mousour et de Cilicie; les marchands du roi les achetaient en Cilicie et les faisaient venir."
,"29":"Un char importé de Mousour coûtait six-cents pièces d'argent, et un cheval cent cinquante; on en exportait ainsi pour les rois des Hittites et les rois d'Aram."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Le roi Salomon aima beaucoup de femmes étrangères:"
,"3":"il eut sept cents femmes de rang princier et trois cents concubines (en plus de la fille du Pharaon): des Moabites, des Ammonites, des Edomites, des Sidoniennes, des Hittites (et ses femmes détournèrent son coeur)."
,"2":"Elles étaient de ces nations dont Yahvé avait dit: 'Vous n'entrerez pas chez elles et elles n'entreront pas chez vous, car sûrement elles vous entraîneraient à la suite d'autres dieux.' Mais Salomon s'attacha à elles, il les aima."
,"4":"Lorsque Salomon prit de l'âge, ses femmes entraînèrent son coeur à la suite d'autres dieux, il ne fut plus tout entier à Yahvé son Dieu, comme l'avait été son père David."
,"5":"Salomon suivit Astarté, la déesse des Sidoniens, et Milkom, l'abomination des Ammonites."
,"6":"Il fit ce qui déplaît à Yahvé au lieu d'obéir parfaitement comme son père David."
,"7":"En ce temps-là il construisit sur la montagne à l'est de Jérusalem un sanctuaire à Kémosh, l'abomination de Moab, et un autre à Milkom, l'abomination des Ammonites."
,"8":"Voilà ce qu'il fit pour toutes ses femmes étrangères qui offraient de l'encens et des sacrifices à leurs dieux."
,"9":"Yahvé fut en colère contre Salomon, car il s'était détourné de Yahvé Dieu d'Israël, qui pourtant lui était apparu deux fois"
,"10":"et lui avait interdit de suivre d'autres dieux. Salomon n'avait pas respecté les ordres de Yahvé,"
,"11":"et Yahvé lui dit: 'Parce que tu as fait cela, que tu n'as pas observé mon alliance et les lois que je t'avais données, je t'enlèverai le royaume et je le donnerai à ton serviteur: c'est décidé."
,"12":"Seulement, à cause de ton père David, je ne ferai pas cela de ton vivant: c'est à ton fils que je le reprendrai."
,"13":"Et encore, je ne lui enlèverai pas tout le royaume: je lui laisserai une tribu à cause de David mon serviteur et de Jérusalem que j'ai choisie.'"
,"14":"Yahvé donna à Salomon un adversaire, Hadad, qui était de la famille royale d'Edom."
,"15":"Lorsque David avait battu Edom et que Joab, le chef de l'armée, était allé pour enterrer les morts, il avait tué tous les mâles en Edom."
,"16":"Joab était resté six mois avec Israël, jusqu'à l'extermination complète de tous les mâles d'Edom."
,"17":"Mais Hadad avait pris la fuite avec des Edomites serviteurs de son père pour se rendre en Egypte; Hadad était encore très jeune en ce temps-là."
,"18":"Ils partirent de Madian et se rendirent à Paran, puis il repartirent entraînant avec eux des hommes de Paran. Ils arrivèrent ainsi en Egypte auprès du Pharaon, roi d'Egypte, qui lui donna une maison, de la nourriture et des terres."
,"19":"Le Pharaon avait de l'estime pour Hadad, il lui donna comme épouse la soeur de sa femme (l'épouse royale se dit Tafnés en Egyptien)."
,"20":"La soeur de Tafnés donna un fils à Hadad: il l'appela Guénoubat. Tafnés éleva Guénoubat dans la maison du Pharaon; il vivait dans le palais au milieu des enfants du Pharaon."
,"21":"Hadad apprit en Egypte la mort de David et celle de Joab, chef de l'armée; il dit alors au Pharaon: 'Laisse-moi retourner dans mon pays.'"
,"22":"Le Pharaon lui répondit: 'Tu ne manques de rien auprès de moi: pourquoi retourner dans ton pays?' Il lui dit: 'Rien ne me manque, mais laisse-moi partir.' Hadad revint donc à son pays plein de haine pour Israël, et il devint roi d'Edom."
,"23":"Dieu donna un autre adversaire à Salomon: Rézon fils d'Elyada. Il s'était enfui de chez son maître Hadadézer, roi de Soba,"
,"24":"il avait réuni des gens autour de lui, et il était devenu chef de bande. Lorsque David voulut les massacrer, ils partirent pour Damas et s'y établirent. Rézon devint roi à Damas"
,"25":"et il créa des problèmes à Israël durant toute la vie de Salomon."
,"26":"Jéroboam aussi se révolta contre le roi alors qu'il était à son service. Il était fils de Nabat, originaire de Séréda dans la tribu d'Ephraïm, et sa mère Sérouya était veuve."
,"27":"Et voici ce qui arriva: Salomon bâtissait alors le Millo et il fermait la brèche de la cité de David son père."
,"28":"Ce Jéroboam était un homme courageux et de grande valeur, Salomon avait remarqué la qualité de son travail. Il fit donc de lui le chef des hommes de corvée de la maison de Joseph."
,"29":"Un jour où Jéroboam était sorti de Jérusalem, le prophète Ahyia de Silo le rencontra. Le prophète était vêtu d'un manteau neuf et ils étaient tous deux seuls dans la campagne."
,"30":"Ahyia saisit le manteau neuf qu'il portait sur lui, il le déchira en douze morceaux et dit à Jéroboam:"
,"31":"'Prends pour toi dix morceaux, car voici ce que dit Yahvé, le Dieu d'Israël: Je vais arracher le royaume de la main de Salomon, et je te donnerai dix tribus."
,"32":"Cependant je laisserai une tribu à Salomon à cause de mon serviteur David et à cause de Jérusalem, la ville que j'ai choisie au milieu de toutes les tribus d'Israël."
,"33":"Je ferai cela parce qu'il m'a abandonné, parce qu'il s'est prosterné devant Astarté, la déesse des Sidoniens, devant Ké mosh, le dieu de Moab, et devant Milkom, le dieu des Ammonites, parce qu'il n'a pas marché dans mes voies pour faire ce qui est juste à mes yeux, parce qu'il n'a pas obéi à mes lois et à mes ordonnances comme David son père."
,"34":"Cependant, de toute sa vie, je ne lui retirerai rien du royaume et je le maintiendrai sur le trône, à cause de David, mon serviteur, que j'ai choisi et qui a observé mes commandements et mes lois."
,"35":"C'est à son fils que j'enlèverai le royaume pour t'en donner dix tribus,"
,"36":"je donnerai cependant une tribu à son fils afin que David mon serviteur ait toujours une lampe devant moi à Jérusalem, la ville que j'ai choisie pour y faire habiter mon Nom."
,"37":"Je te ferai régner sur tout ce que tu désireras: tu régneras sur Israël."
,"38":"Si tu obéis à mes commandements, si tu marches dans mes voies et fais ce qui est juste à mes yeux, observant mes lois et mes commandements comme l'a fait David mon serviteur, je serai avec toi. Je te bâtirai une maison aussi solide que celle j'ai bâtie à David. ("
,"39":")'"
,"40":"Salomon chercha à faire mourir Jéroboam, mais Jéroboam s'enfuit en Egypte auprès de Chéchonk, roi d'Egypte, et il resta en Egypte jusqu'à la mort de Salomon."
,"41":"Le reste des actes de Salomon, tout ce qu'il a fait, et sa sagesse, n'est-il pas écrit dans le livre des actes de Salomon?"
,"42":"Salomon régna sur tout Israël à Jérusalem pendant quarante ans."
,"43":"Salomon se coucha alors avec ses pères et on l'enterra dans la ville de David, son père. Son fils Roboam régna à sa place."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Roboam se rendit à Sichem, car tout Israël était venu là pour le proclamer roi."
,"2":"Jéroboam fils de Nabat en fut averti quand il était encore en Egypte où il s'était enfui loin du roi Salomon: aussitôt il rentra d'Egypte."
,"3":"On l'envoya chercher, après quoi Jéroboam et toute la communauté d'Israël s'en vinrent trouver Roboam et lui dirent:"
,"4":"'Ton père nous a imposé un joug pesant. Si tu allèges ces travaux forcés, ce joug pesant que ton père nous a fait porter, nous te servirons.'"
,"5":"Il leur répondit: 'Allez, vous reviendrez me voir dans trois jours.' Et le peuple s'en alla."
,"6":"Le roi Roboam consulta les anciens qui avaient été les conseillers de son père Salomon quand il vivait. Il leur dit: 'Que me conseillez-vous de répondre à ce peuple?'"
,"7":"Ils lui répondirent: 'Si aujourd'hui tu te fais leur serviteur, si tu te montres conciliant dans ta réponse, ils seront pour toujours à ton service.'"
,"8":"Mais Roboam n'écouta pas le conseil des anciens, il se tourna vers les jeunes gens qui avaient grandi avec lui, et il leur demanda leur avis."
,"9":"Il leur dit: 'Que me conseillez-vous de répondre à ce peuple? Vous savez qu'ils me disent: Rends moins pénible le joug que ton père nous a fait porter.'"
,"10":"Les jeunes gens qui avaient grandi avec lui répondirent: 'Ces gens-là t'ont dit: Ton père nous a fait porter un joug pesant, allège notre fardeau! Tu vas leur répondre: Mon petit doigt est plus gros que les reins de mon père."
,"11":"Mon père vous a fait porter un joug pesant? Avec moi ce sera pire. Mon père vous a corrigés avec des lanières de cuir? Avec moi, les fouets auront des pointes de fer.'"
,"12":"Au troisième jour Jéroboam et tout le peuple d'Israël revinrent auprès de Roboam, puisque le roi leur avait dit: 'Dans trois jours vous reviendrez.'"
,"13":"Le roi parla sèchement au peuple; il ne tint pas compte du conseil des anciens,"
,"14":"mais il leur dit, comme voulaient les jeunes gens: 'Si mon père a rendu votre joug pesant, avec moi ce sera pire. Si mon père vous a corrigés avec des lanières de cuir, avec moi les fouets auront des pointes de fer.'"
,"15":"Le roi ne voulut donc pas entendre le peuple; il y eut là une intervention de Yahvé, afin de réaliser cela même qu'il avait dit à Jéroboam fils de Nabat par la bouche d'Ahyia de Silo."
,"16":"Lorsque tout Israël vit que le roi ne l'écoutait pas, le peuple répliqua au roi: 'Quelle part avons-nous avec David? Nous n'avons rien à hériter du fils de Jessé. Allez Israël! A tes tentes! Et maintenant David, assure toi-même la nourriture de ta maison!' Et tout Israël regagna ses foyers. ("
,"17":"Les Israélites qui habitaient les villes de Juda reconnurent Roboam comme roi.)"
,"18":"Le roi Roboam envoya Adoniram, le chef de la corvée, mais tout Israël le reçut avec des pierres et il mourut. Roboam fut obligé de monter sur son char et de s'enfuir à Jérusalem."
,"19":"Et depuis ce jour jusqu'à maintenant, Israël a renié la maison de David."
,"20":"Quand tout Israël apprit que Jéroboam était revenu, ils l'envoyèrent chercher pour l'assemblée, et ils le firent roi sur tout Israël; seule la tribu de Juda resta fidèle à la maison de David."
,"21":"Après son retour à Jérusalem, Roboam convoqua toute la maison de Juda ainsi que la tribu de Benjamin, environ cent quatre-vingt mille hommes d'élite entraînés au combat. C'était pour faire la guerre à la maison d'Israël et rendre le royaume à Roboam fils de Salomon."
,"22":"A ce moment une parole de Dieu fut adressée à Chémaya, l'homme de Dieu:"
,"23":"'Voici ce que tu diras à Roboam fils de Salomon, roi de Juda, à toute la maison de Juda et de Benjamin, et au reste du peuple:"
,"24":"N'allez pas combattre vos frères, les fils d'Israël. Que chacun retourne chez soi, car c'est moi qui ai arrangé tout cela.',Ils écoutèrent la parole de Yahvé et, comme il leur disait, ils s'en retournèrent chacun chez soi."
,"25":"Jéroboam fortifia Sichem dans la montagne d'Ephraïm; il y habita un temps, puis il la quitta pour Pénuel qu'il fortifia également."
,"26":"Jéroboam se dit: 'Le royaume pourrait bien revenir à la maison de David."
,"27":"Si ce peuple continue de monter à Jérusalem pour offrir des sacrifices dans la Maison de Yahvé, le coeur du peuple se retournera vers Yahvé et vers Roboam, roi de Juda, et ils me tueront.'"
,"28":"Après avoir pris conseil, le roi Jéroboam fit donc deux veaux en or et il dit au peuple: 'Ne montez plus à Jérusalem, la chose a assez duré. Israël, voici ton Dieu qui t'a fait sortir du pays d'Egypte!'"
,"29":"Il plaça l'un des veaux à Béthel et l'autre à Dan."
,"30":"C'est de là qu'est parti le péché d'Israël; le peuple escorta l'un des veaux jusqu'à Béthel, et ils allèrent en procession devant l'autre jusqu'à Dan."
,"31":"Jéroboam construisit des sanctuaires, ou Hauts-Lieux, il y établit des prêtres pris parmi le peuple, qui n'appartenaient pas à la tribu de Lévi."
,"32":"Jéroboam institua une fête le quinzième jour du huitième mois, comme la fête qui existait en Juda, et il sacrifia sur l'autel. Il le fit à Béthel où il offrit des sacrifices aux veaux qu'il avait faits, et c'est à Béthel qu'il établit les prêtres pour les Hauts-Lieux qu'il avait construits."
,"33":"Il monta donc à l'autel le quinzième jour du huitième mois, une date qu'il avait choisie lui-même et dont il avait fait une fête pour les fils d'Israël; il monta à l'autel et y brûla de l'encens."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Par ordre de Yahvé, un homme de Dieu arriva de Juda à Béthel alors que Jéroboam était près de l'autel et faisait brûler l'encens."
,"2":"L'homme de Dieu cria contre l'autel sur l'ordre de Yahvé: 'Autel, autel, voici ce que dit Yahvé: il naîtra dans la maison de David un fils du nom de Josias. Il sacrifiera sur toi les prêtres des Hauts-Lieux, ceux qui brûlent l'encens sur toi, et l'on brûlera sur toi des ossements humains.'"
,"3":"Ce même jour il donna cette preuve: 'Voici la preuve que Yahvé vous donne: l'autel va se fendre et la cendre qui est dessus va se répandre.'"
,"4":"Lorsque le roi Jéroboam entendit cette malédiction de l'homme de Dieu contre l'autel de Béthel, il étendit la main et ordonna: 'Saisissez-le!' Mais la main qu'il avait étendue contre l'homme de Dieu devint raide, il ne put la ramener à lui."
,"5":"L'autel se fendit et la cendre de l'autel se répandit; c'était bien la preuve qu'avait donnée l'homme de Dieu sur l'ordre de Yahvé."
,"6":"Le roi prit alors la parole et dit à l'homme de Dieu: 'Je t'en prie, apaise Yahvé ton Dieu, prie pour moi afin que ma main me revienne.' L'homme de Dieu apaisa Yahvé et la main du roi lui revint: elle était comme auparavant."
,"7":"Le roi dit alors à l'homme de Dieu: 'Rentre avec moi à la maison, prends des forces, et je te ferai un cadeau.'"
,"8":"Mais l'homme de Dieu dit au roi: 'Même si tu me donnais la moitié de ta maison, je n'y entrerais pas avec toi. Je ne mangerai pas de pain, je ne boirai pas d'eau en ce lieu,"
,"9":"car j'ai reçu cet ordre de la part de Yahvé: Tu ne mangeras pas de pain, tu ne boiras pas d'eau, et tu ne reviendras pas par le chemin par lequel tu es allé.'"
,"10":"Il s'en alla donc par un autre chemin, délaissant le chemin par lequel il était monté à Béthel."
,"11":"Or, à Béthel, il y avait un vieux prophète, et ses fils vinrent lui raconter tout ce que l'homme de Dieu avait fait ce jour-là à Béthel; ils rapportèrent à leur père toutes les paroles que cet homme avaient dites au roi."
,"12":"Leur père leur dit: 'Par quel chemin s'en est-il allé?' Et ses fils lui firent voir le chemin par lequel était reparti l'homme de Dieu venu de Juda."
,"13":"Il dit alors à ses fils: 'Sellez mon âne.' Ils lui sellèrent son âne et il monta dessus."
,"14":"Il partit donc derrière l'homme de Dieu et le trouva assis sous un térébinthe. Il lui dit: 'C'est toi l'homme de Dieu qui est venu de Juda?' Il répondit: 'Oui, c'est moi.'"
,"15":"Il lui dit: 'Viens chez moi et tu mangeras un morceau.'"
,"16":"L'autre répondit: 'Je ne peux pas revenir avec toi ni rentrer chez toi. Je ne mangerai pas de pain, je ne boirai pas d'eau avec toi en ce lieu,"
,"17":"car c'est un ordre que j'ai reçu de Yahvé: Tu ne mangeras pas de pain, tu ne boiras pas d'eau là-bas, et tu ne reviendras pas par le chemin par lequel tu es allé.'"
,"18":"Mais le vieux prophète lui dit: 'Moi aussi je suis prophète comme toi, et un ange m'a parlé. Il m'a transmis cet ordre de Yahvé: Ramène-le avec toi, chez toi, pour qu'il mange du pain et qu'il boive de l'eau.' C'était un mensonge."
,"19":"L'homme de Dieu revint donc avec lui, il mangea du pain et but de l'eau dans sa maison."
,"20":"Comme ils étaient assis à table, la parole de Dieu fut adressée au prophète qui l'avait ramené."
,"21":"Il cria à l'homme de Dieu qui était monté de Juda: 'Ainsi a parlé Yahvé: Puisque tu as été rebelle à l'ordre de Yahvé, et que tu n'as pas observé le commandement que Yahvé ton Dieu t'avait donné,"
,"22":"puisque tu es revenu sur tes pas et que tu as mangé ici du pain et bu de l'eau, alors que tu avais reçu l'ordre de ne pas manger ni boire, ton cadavre n'entrera pas dans le tombeau de tes pères.'"
,"23":"Après qu'ils eurent mangé et bu, le prophète qui l'avait ramené lui sella son âne"
,"24":"et l'homme partit. Un lion le rencontra sur le chemin et le mit à mort. Son cadavre resta là sur le chemin, l'âne ne le quitta pas et le lion aussi resta à côté du corps."
,"25":"Des gens qui passaient par là virent le cadavre sur le chemin et le lion qui se tenait à côté, ils rentrèrent chez eux et en parlèrent dans la ville où habitait le vieux prophète"
,"26":"qui l'avait détourné de son chemin. Dès que le prophète le sut, il dit: 'C'est l'homme de Dieu qui a désobéi à l'ordre de Yahvé, et Yahvé l'a livré au lion qui l'a déchiré et mis à mort selon la parole que Yahvé lui avait dite.'"
,"27":"Il s'adressa aussitôt à ses fils: 'Sellez-moi mon âne', leur dit-il. Ils le lui sellèrent."
,"28":"Il s'en alla et trouva le cadavre au travers du chemin, avec l'âne et le lion qui étaient toujours là de chaque côté. Le lion n'avait pas dévoré le corps, il n'avait pas non plus déchiré l'âne."
,"29":"Le prophète souleva le cadavre de l'homme de Dieu, le mit sur son âne et le ramena; quand il eût regagné la ville il se chargea du deuil et de l'enterrement."
,"30":"Il déposa le cadavre dans son propre tombeau et l'on fit sur lui le deuil: 'Hélas, mon frère!'"
,"31":"Après qu'il l'eut mis au tombeau, il dit à ses fils: 'Quand je serai mort, vous me déposerez dans le tombeau où l'on a enterré l'homme de Dieu. Vous déposerez mes os à côté des siens."
,"32":"Car, je vous le dis, elle se réalisera la malédiction qu'il a prononcée sur l'ordre de Yahvé contre l'autel de Béthel et contre tous les sanctuaires de Hauts-Lieux des villes de Samarie.'"
,"33":"Malgré cela, Jéroboam ne se détourna pas de sa mauvaise conduite. Il recommença à choisir des prêtres parmi le peuple pour les Hauts-Lieux; il instituait prêtres tous ceux qui le désiraient et ils faisaient partie des prêtres des Hauts-Lieux."
,"34":"Ce fut une cause de péché pour la maison de Jéroboam, à cause de cela elle a été détruite et retranchée de la terre."
}`)
	CurrentBook.AddChapter(14, `{
"1":"En ce temps-là Abiyas, fils de Jéroboam, tomba malade."
,"2":"Jéroboam dit à sa femme: 'Voici ce que tu devrais faire: te déguiser pour qu'on ne sache pas que tu es la femme de Jéroboam, et ensuite aller à Silo. Là-bas se trouve le prophète Ahyia qui m'a annoncé que je régnerais sur ce peuple."
,"3":"Tu prendras avec toi dix pains, des gâteaux et un pot de miel, tu entreras chez lui et il te dira l'avenir pour l'enfant.'"
,"4":"La femme de Jéroboam fit ainsi: elle partit pour Silo et entra dans la maison d'Ahyia. Or Ahyia ne pouvait plus voir, son regard était fixe à cause de son grand âge."
,"5":"Mais Yahvé avait dit une parole à Ahyia: 'La femme de Jéroboam va venir te consulter au sujet de son fils qui est malade et voici ce que tu lui diras. Quand elle se présentera, elle se fera passer pour une autre.'"
,"6":"Aussi, lorsqu'elle franchit la porte, lorsqu'Ahyia entendit le bruit de ses pas, il lui dit: 'Entre, femme de Jéroboam. Pourquoi te faire passer pour une autre? Je suis chargé pour toi d'un message redoutable."
,"7":"Va redire à Jéroboam cette parole de Yahvé, Dieu d'Israël: Je t'ai choisi du milieu du peuple pour faire de toi le chef de mon peuple Israël."
,"8":"J'ai enlevé le royaume à la maison de David pour te le donner. Mais tu n'as pas été comme mon serviteur David: il observait mes commandements, il marchait de tout son coeur à ma suite, il faisait ce qui est droit à mes yeux."
,"9":"Mais toi, tu as agi plus mal que tous les autres avant toi, tu es allé te faire d'autres dieux, des idoles de métal qui ne pouvaient que m'irriter, et tu t'es débarrassé de moi."
,"10":"A cause de tout cela je fais venir le malheur sur la maison de Jéroboam, j'en exterminerai tous les mâles, qu'ils soient esclaves ou libres en Israël. Je balaierai la maison de Jéroboam comme on balaie les ordures, jusqu'à ce qu'il ne reste plus rien."
,"11":"Celui de la maison de Jéroboam qui mourra dans la ville sera dévoré par les chiens, celui qui mourra dans la campagne sera mangé par les oiseaux du ciel: c'est Yahvé qui le dit.'"
,"12":"Et toi maintenant, lève-toi et retourne chez toi. Dès que tes pieds franchiront la porte de la ville, l'enfant mourra."
,"13":"Tout Israël le pleurera et on l'enterrera: il sera le seul de la maison de Jéroboam à recevoir une sépulture, car c'est le seul de la maison de Jéroboam en qui Yahvé Dieu d'Israël ait trouvé quelque chose de bon."
,"14":"Yahvé établira sur Israël un roi qui fera disparaître la maison de Jéroboam; le châtiment est tout proche, il est déjà là."
,"15":"Yahvé secouera Israël comme un roseau emporté par le courant, il arrachera Israël de ce bon pays qu'il avait donné à leurs pères, il les dispersera de l'autre côté du Fleuve parce qu'ils ont excité la colère de Yahvé par leurs pieux sacrés."
,"16":"Il livrera Israël à cause des péchés que Jéroboam a commis et qu'il a fait commettre à Israël.'"
,"17":"La femme de Jéroboam se leva et se mit en route pour Tirsa. Au moment où elle franchissait le seuil de sa maison, l'enfant mourut."
,"18":"On l'enterra et tout Israël le pleura selon la parole que Yahvé avait dite par son serviteur Ahyia, le prophète."
,"19":"Le reste des actes de Jéroboam, les guerres qu'il fit et comment il régna, tout cela n'est-il pas écrit dans le livre des Chroniques des rois d'Israël?"
,"20":"Jéroboam régna vingt- deux ans, puis il se coucha avec ses pères et son fils Nadab régna à sa place."
,"21":"Roboam fils de Salomon régna en Juda; Il avait quarante et un ans lorsqu'il monta sur le trône. Il régna dix-sept ans à Jérusalem, la ville que Yahvé avait choisie parmi toutes les tribus d'Israël pour y faire habiter son Nom. Sa mère était Naama l'Ammonite."
,"22":"Juda fit ce qui déplaît aux yeux de Yahvé et, plus encore que leurs pères, ils excitèrent sa colère par leurs péchés."
,"23":"Eux aussi construisirent des Hauts-Lieux avec des pierres dressées et des pieux sacrés sur toutes les hautes collines et sous tout arbre vert."
,"24":"Il y eut même des prostitués sacrés dans le pays et ils imitèrent toutes les pratiques honteuses des païens que Yahvé avait chassés devant les Israélites."
,"25":"La cinquième année du règne de Roboam, Chéchonk roi d'Egypte attaqua Jérusalem."
,"26":"Il prit les trésors de la Maison de Yahvé et les trésors du palais royal: il ramassa tout. Il prit tous les boucliers d'or que Salomon avait faits;"
,"27":"à leur place le roi Roboam fit des boucliers de bronze et il les remit entre les mains de ceux qui couraient devant son char et de ceux qui gardaient l'entrée du palais royal."
,"28":"Chaque fois que le roi se rendait au Temple de Yahvé, ceux qui couraient en avant de lui les prenaient; ils les rapportaient ensuite dans la salle des gardes."
,"29":"Le reste des actes de Roboam, tout ce qu'il a fait, cela n'est-il pas écrit dans le livre des Chroniques des rois de Juda?"
,"30":"Ce fut continuellement la guerre entre Roboam et Jéroboam."
,"31":"Lorsque Roboam se coucha avec ses pères, on l'enterra comme eux dans la ville de David; Abiyam, son fils, régna à sa place."
}`)
	CurrentBook.AddChapter(15, `{
"1":"La dix-huitième année du roi Jéroboam fils de Nabat, Abiyam devint roi de Juda."
,"2":"Il régna trois ans à Jérusalem, sa mère était Maaka fille d'Absalom."
,"3":"Il imita tous les péchés que ses pères avaient commis avant lui, son coeur ne fut pas tout entier à Yahvé comme l'avait été le coeur de son ancêtre David."
,"4":"Mais Yahvé voulait garder une lampe à David à Jérusalem: son fils régna après lui à sa place et Jérusalem fut protégée."
,"5":"En effet, David avait fait ce qui est droit aux yeux de Yahvé, il ne s'était pas détourné de toute sa vie des commandements qu'il avait reçus, sauf dans l'affaire d'Urie le Hittite."
,"7":"Le reste des actes d'Abiyam, tout ce qu'il a fait, cela n'est-il pas écrit dans le livre des Chroniques des rois de Juda? Il y eut guerre entre Abiyam et Jéroboam."
,"8":"Quand Abiyam se coucha avec ses pères, on l'enterra dans la cité de David; Aza, son fils, régna à sa place."
,"9":"La vingtième année de Jéroboam roi d'Israël, Aza devint roi de Juda."
,"10":"Il régna quarante et un ans à Jérusalem; sa grand-mère était Maaka fille d'Absalom."
,"11":"Aza fit ce qui est juste aux yeux de Yahvé comme David son père,"
,"12":"il fit disparaître du pays les prostitués et il enleva toutes les idoles que ses pères avaient faites."
,"13":"Il retira même à sa grand-mère Maaka la dignité de Grande Dame, car elle avait fait une idole honteuse en l'honneur d'Astarté; Aza abattit cette idole honteuse et la brûla dans la vallée du Cédron."
,"14":"Les Hauts-Lieux ne disparurent pas: cela n'empêche que Aza se comporta bien vis-à-vis de Yahvé durant toute sa vie."
,"15":"Il déposa dans la Maison de Yahvé les objets que son père avait consacrés, tout comme ceux qu'il avait consacrés lui-même: de l'argent, de l'or et des vases."
,"16":"Entre Aza, et Bacha roi d'Israël, ce fut la guerre durant toute leur vie."
,"17":"Bacha roi d'Israël, marcha contre Juda et fortifia Rama pour barrer la route à Aza, roi de Juda."
,"18":"Aza rassembla alors tout l'argent et tout l'or qui étaient restés dans les trésors de la Maison de Yahvé et dans les trésors du palais royal; il les confia à ses serviteurs en même temps qu'il les envoyait vers Ben-Hadad fils de Tabrimon, fils de Hézyon, qui était roi d'Aram à Damas. Ils lui portèrent ce message: "
,"19":"'Qu'il y ait alliance entre moi et toi, entre mon père et ton père. Je te fais remettre une belle somme d'argent et d'or, mais brise ton alliance avec Bacha, roi d'Israël, pour qu'il s'éloigne de moi.'"
,"20":"Ben-Hadad écouta le roi Aza, il envoya ses chefs d'armée à l'assaut des villes d'Israël. Il frappa Iyon, Dan, Abel-Beth-Maaka, toute la région du lac de Kinnéret et le pays de Nephtali tout entier."
,"21":"Voyant cela, Bacha arrêta les travaux de fortification de Rama et rentra à Tirsa."
,"22":"Le roi Aza convoqua alors tout Juda sans aucune exception: on enleva les pierres et le bois avec lesquels Bacha fortifiait Rama, et le roi Aza s'en servit pour fortifier Guéba de Benjamin et Mispa."
,"23":"Le reste des actes d'Aza, ses exploits, tout ce qu'il a fait, les villes qu'il a construites, cela n'est-il pas écrit au livre des Chroniques des rois de Juda? A part cela, dans sa vieillesse il fut malade des pieds."
,"24":"Lorsque Aza se coucha avec ses pères, on l'enterra avec ses pères dans la cité de David son ancêtre, et son fils Josaphat régna à sa place."
,"25":"Nadab, fils de Jéroboam, devint roi d'Israël dans la seconde année d'Aza roi de Juda; il régna deux ans sur Israël."
,"26":"Il fit ce qui est mal aux yeux de Yahvé, il suivit les traces de son père et le péché dans lequel il avait entraîné Israël."
,"27":"Bacha fils d'Ahyias, de la tribu d'Issacar, conspira contre lui et, pendant que Nadab avec tout Israël assiégeait la ville philistine de Guibéton, il l'assassina."
,"28":"Bacha le mit à mort en l'an trois du règne d'Aza de Juda et régna à sa place."
,"29":"Dès qu'il fut roi, il détruisit la maison de Jéroboam tout entière; il n'y épargna aucun être vivant, mais il les tua tous selon la parole que Yahvé avait dite par son serviteur Ahyias de Silo."
,"30":"En effet, Jéroboam avait excité la colère de Yahvé, Dieu d'Israël, par les péchés qu'il avait commis et dans lesquels il avait entraîné Israël."
,"31":"Le reste des actes de Nadab, tout ce qu'il a fait, cela n'est-il pas écrit dans le livre des Chroniques des rois d'Israël? ("
,"32":")."
,"33":"En l'an trois du règne d'Aza de Juda, Bacha, fils d'Ahyias, commença à régner sur Israël à Tirsa; il régna vingt-quatre ans."
,"34":"Il fit ce qui est mal aux yeux de Yahvé, il suivit les traces de Jéroboam et le péché dans lequel il avait entraîné Israël."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Une parole de Yahvé fut alors adressée à Jéhu, fils de Hanani, contre Bacha:"
,"2":"'Je t'ai tiré de la poussière et j'ai fait de toi le chef de mon peuple Israël, mais tu as marché sur les traces de Jéroboam et tu as fait commettre à mon peuple Israël les péchés qui me mettent en colère!"
,"3":"C'est pourquoi je vais balayer Bacha et sa maison, je rendrai ta maison semblable à celle de Jéroboam fils de Nabat."
,"4":"Celui de la famille de Bacha qui mourra dans la ville sera dévoré par les chiens, et celui qui mourra dans la campagne sera mangé par les oiseaux du ciel.'"
,"5":"Le reste des actes de Bacha, ce qu'il a fait et ses exploits, cela n'est-il pas écrit dans le livre des Chroniques des rois d'Israël?"
,"6":"Lorsque Bacha se coucha avec ses pères, on l'enterra à Tirsa, et son fils régna à sa place dans cette même ville."
,"7":"Mais il y avait cette parole de Yahvé adressée au prophète Jéhu, fils d'Hanani, contre Bacha et sa maison, à cause de tout le mal qu'il avait fait aux yeux de Yahvé: il l'avait mis en colère par sa conduite, en imitant la maison de Jéroboam, mais aussi par la façon dont il avait frappé cette maison."
,"8":"En l'an vingt-six du règne d'Aza de Juda, Ela fils de Bacha devint roi sur Israël et il régna deux ans à Tirsa."
,"9":"Son serviteur Zimri, chef de la moitié des chars, conspira contre lui; le roi était alors à Tirsa, il buvait et s'enivrait dans la maison d'Arsa, le commandant du palais royal de Tirsa."
,"10":"C'était en l'an vingt sept du règne d'Aza de Juda; Zimri entra, le frappa et le tua, et il régna à sa place."
,"11":"Dès qu'il fut roi, aussitôt assis sur le trône, il frappa toute la maison de Bacha; il n'épargna ni un enfant mâle, ni un parent, ni un ami."
,"12":"C'est ainsi que Zimri extermina toute la maison de Bacha, selon la parole que Yahvé avait dite contre Bacha par le prophète Jéhu."
,"13":"C'était à cause des péchés de Bacha et de son fils Ela: ils avaient entraîné Israël dans leur péché et leurs idoles avaient excité la colère de Yahvé, Dieu d'Israël."
,"14":"Le reste des actes d'Ela, tout ce qu'il a fait, cela n'est-il pas écrit dans le livre des Chroniques des rois d'Israël?"
,"15":"En l'an vingt-sept du règne d'Aza de Juda, Zimri devint roi pour sept jours à Tirsa. Le peuple assiégeait la ville philistine de Guibéton."
,"16":"Dans le camp le peuple apprit la nouvelle: 'Zimri a conspiré contre le roi et l'a assassiné.' Le jour même, dans le camp, tout Israël établit Omri, le chef de l'armée, comme roi d'Israël."
,"17":"Omri et tout Israël montèrent alors de Guibéton pour assiéger Tirsa."
,"18":"Quand Zimri vit que la ville était sur le point d'être prise, il s'enferma dans la forteresse du palais, il y mit le feu et mourut ainsi dans l'incendie du palais."
,"19":"Il avait en effet commis les péchés qui déplaisent à Yahvé, il avait suivi les traces de Jéroboam et le péché dans lequel il avait entraîné Israël."
,"20":"Le reste des actes de Zimri, le complot qu'il forma, tout cela n'est-il pas écrit dans le livre des Chroniques des rois d'Israël?"
,"21":"Le peuple d'Israël se divisa: les uns voulaient faire roi Tibni fils de Guinat, les autres étaient pour Omri;"
,"22":"le parti d'Omri l'emporta sur celui de Tibni fils de Guinat: Tibni mourut et Omri devint roi."
,"23":"En l'an trente et un du règne d'Aza en Juda, Omri devint roi d'Israël; il régna douze ans."
,"24":"Après avoir régné six ans à Tirsa, il acheta de Chémer la colline de Samarie pour deux talents d'argent et il commença à construire sur cette colline. Il appela cette ville Samarie, du nom de Chémer propriétaire de la colline."
,"25":"Omri fit ce qui est mal aux yeux de Yahvé, il imita la mauvaise conduite de tous ceux qui avaient régné avant lui,"
,"26":"il suivit les traces de Jéroboam fils de Nabat, et les péchés qu'il avait commis et dans lesquels il avait entraîné Israël: ses idoles excitèrent la colère de Yahvé, Dieu d'Israël."
,"27":"Le reste des actes d'Omri, ce qu'il a fait, ses exploits, tout cela n'est-il pas écrit dans le livre des Chroniques des rois d'Israël?"
,"28":"Quand Omri se coucha avec ses pères, on l'enterra à Samarie; son fils Akab régna à sa place."
,"29":"En l'an trente-huit du règne d'Aza de Juda, Akab fils d'Omri devint roi d'Israël; Akab fils d'Omri régna vingt-deux ans sur Israël à Samarie."
,"30":"Akab fit ce qui est mal aux yeux de Yahvé, et cela, plus que tous ceux qui étaient venus avant lui."
,"31":"Cela ne lui suffisait pas d'imiter les péchés de Jéroboam fils de Nabat; ayant pris pour femme Jézabel, fille d'Ittobaal roi de Sidon, il se mit à servir leur Baal et à se prosterner devant lui."
,"32":"Il lui éleva un autel dans le temple de Baal qu'il construisit à Samarie."
,"33":"Akab dressa encore un pieu sacré et, par bien d'autres péchés, il excita la colère de Yahvé, Dieu d'Israël, plus que tous les autres rois d'Israël qui étaient venus avant lui."
,"34":"De son temps, Hiel de Béthel rebâtit Jéricho. Il en posa les fondations au prix de son premier-né Abiram, et lorsqu'il mit en place les portes, il sacrifia son second fils Ségoub, selon la parole que Yahvé avait dite par Josué fils de Noun."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Le prophète Elie - il était de Tichbé en Galaad - vint dire à Akab: 'Aussi vrai que Yahvé Dieu d'Israël, celui que je sers, est vivant, il n'y aura durant ces années-ci ni rosée ni pluie, sauf à ma parole.'"
,"2":"Une parole de Yahvé fut alors adressée à Elie:"
,"3":"'Pars d'ici et va du côté de l'est. Tu te cacheras dans le torrent de Kérit à l'est du Jourdain."
,"4":"Tu boiras l'eau du torrent et j'ai donné des ordres aux corbeaux pour que là-bas ils te ravitaillent.'"
,"5":"Elie partit donc et fit ce que Yahvé lui avait dit; il alla s'établir au torrent de Kérit à l'est du Jourdain."
,"6":"Les corbeaux lui apportaient du pain le matin et de la viande le soir."
,"7":"Mais au bout d'un certain temps le torrent resta à sec, car la pluie ne tombait plus sur le pays."
,"8":"Une parole de Dieu lui fut alors adressée:"
,"9":"'Lève-toi, va t'établir à Sarepta dans la région de Sidon. J'ai donné des ordres là-bas à une veuve pour qu'elle te nourrisse.'"
,"10":"Il se leva donc et partit pour Sarepta. Lorsqu'il arriva à la porte de la ville, une veuve était là qui ramassait du bois. Il l'appela et lui dit: 'Voudrais-tu me chercher un peu d'eau dans cette cruche pour que je boive.'"
,"11":"Comme elle allait en prendre, il l'appela et lui dit: 'Voudrais-tu m'apporter aussi un morceau de pain.'"
,"12":"Elle répondit: 'Aussi vrai que Yahvé ton Dieu est vivant, je n'ai rien de cuit, je n'ai qu'un peu de farine dans un pot et un peu d'huile dans une cruche. Je m'en vais ramasser deux morceaux de bois et je reviens le préparer à la maison pour moi et pour mon fils. Nous le mangerons, et ensuite ce sera la mort.'"
,"13":"Elie lui dit: 'N'aie pas peur, rentre et fais ce que tu as dit; seulement prépare-moi d'abord une petite galette que tu m'apporteras, tu en feras une ensuite pour toi et pour ton fils."
,"14":"Car voici ce que dit Yahvé, Dieu d'Israël: La farine du pot ne s'épuisera pas, l'huile dans la cruche ne se terminera pas jusqu'au jour où Yahvé fera tomber la pluie sur la terre.'"
,"15":"Elle partit donc et fit comme Elie le lui avait dit, et pendant longtemps ils eurent à manger, lui et elle et le fils."
,"16":"La farine du pot ne s'épuisa pas et l'huile dans la cruche ne se termina pas, selon la parole que Yahvé avait dite par la bouche d' Elie."
,"17":"Dans la suite il arriva que le fils de la maîtresse de maison tomba malade; sa maladie empira et il rendit le dernier souffle."
,"18":"Alors elle dit à Elie: 'Pourquoi t'es-tu mis dans mes affaires, homme de Dieu? Es-tu venu chez moi pour remettre devant Dieu toutes mes fautes et pour faire mourir mon fils?'"
,"19":"Il lui répondit: 'Donne-moi ton fils.',Elie le prit des bras de cette femme, il le monta dans la chambre haute où il logeait et le coucha sur son lit. "
,"20":"Puis il invoqua Yahvé: 'Yahvé, mon Dieu, dit-il, feras-tu venir le malheur même sur cette veuve qui me loge, feras-tu mourir son fils?'"
,"21":"Alors il s'allongea par trois fois sur l'enfant et il invoqua Yahvé: 'Yahvé mon Dieu, redonne à cet enfant le souffle de vie.'"
,"22":"Yahvé entendit l'appel d'Elie et le souffle de l'enfant lui revint: il était vivant!"
,"23":"Elie prit l'enfant, le fit descendre de la chambre haute dans la maison, et le redonna à sa mère. Elie lui dit: 'Regarde, ton fils est vivant.'"
,"24":"Alors la femme dit à Elie: 'Maintenant je sais que tu es un homme de Dieu, et quand tu dis la parole de Dieu, c'est vrai!'"
}`)
	CurrentBook.AddChapter(18, `{
"1":"Longtemps après - cela faisait déjà trois ans - la parole de Dieu fut adressée à Elie: 'Va et montre-toi à Akab, je vais faire tomber la pluie sur la terre.'"
,"2":"Elie partit donc pour se présenter devant Akab. La famine était terrible à Samarie. "
,"3":"Akab venait d'envoyer Obadyas, chef du palais royal, - cet Obadyas avait réellement la crainte de Yahvé;"
,"4":"lorsque Jézabel avait massacré les prophètes de Yahvé, Obadyas en avait pris cent et les avait cachés cinquante par cinquante dans des grottes où il leur apportait du pain et de l'eau."
,"5":"Akab dit à Obadyas: 'Parcours le pays, va inspecter toutes les sources et tous les torrents. Peut-être trouverons-nous de l'herbe pour garder en vie chevaux et mulets au lieu d'abattre les bêtes.'"
,"6":"Ils se partagèrent donc le pays pour le parcourir: Akab partit seul par un chemin, et Obadyas aussi seul par un autre chemin."
,"7":"Alors qu'Obadyas était en route, Elie vint à sa rencontre. Obadyas le reconnut, tomba la face contre terre et lui dit: 'Est-ce toi, mon seigneur Elie?'"
,"8":"Il lui répondit: 'Oui, c'est moi. Va dire à ton maître que j'arrive.'"
,"9":"Obadyas répondit: 'Quel péché ai-je commis pour que tu livres ton serviteur entre les mains d'Akab? Il me fera mourir!"
,"10":"Aussi vrai que Yahvé, ton Dieu, est vivant, il n'y a pas un pays, il n'y a pas un royaume où mon maître n'ait envoyé te chercher. Et lorsqu'on disait: 'Elie n'est pas ici', il faisait jurer ce royaume ou ce pays qu'on ne t'avait pas vu."
,"11":"Et maintenant je devrais dire à mon maître que tu arrives?"
,"12":"Lorsque je t'aurai quitté, le temps que j'informe Akab, l'esprit de Yahvé t'aura transporté je ne sais où et, comme on ne te trouvera pas, il me mettra à mort. Cependant, tu le sais, ton serviteur craint Yahvé depuis qu'il est enfant."
,"13":"N'a-t-on pas raconté à mon seigneur ce que j'ai fait lorsque Jézabel massacrait les prophètes de Yahvé? J'ai caché cent prophètes de Yahvé, cinquante par cinquante dans des grottes, et je leur ai donné le pain et l'eau."
,"14":"Tu veux que j'aille dire à ton maître: 'Voici Elie!' mais il me tuera.'"
,"15":"Elie lui répondit: 'Aussi vrai que Yahvé Sabaot, celui que je sers, est vivant, aujourd'hui même je me présenterai devant Akab.'"
,"16":"Obadyas alla donc trouver Akab pour lui porter la nouvelle: Akab partit à la rencontre d'Elie."
,"17":"Dès qu'Akab aperçut Elie, il lui dit: 'Ah! le voilà celui qui fait le malheur d'Israël!'"
,"18":"Elie répondit: 'Ce n'est pas moi qui fais le malheur d'Israël, c'est toi et la maison de ton père, car vous avez abandonné les commandements de Yahvé et vous vous êtes tournés vers les Baals."
,"19":"Fais donc rassembler tout Israël; qu'ils viennent vers moi au mont Carmel, et avec eux les quatre cent cinquante prophètes de Baal qui mangent à la table de Jézabel.'"
,"20":"Akab fit convoquer tout Israël au mont Carmel, il rassembla également les prophètes."
,"21":"Alors Elie s'approcha du peuple et dit: 'Combien de temps encore sauterez-vous d'un pied sur l'autre? Si Yahvé est Dieu, suivez-le, si c'est Baal, suivez-le.' Le peuple ne répondit pas."
,"22":"Elie dit au peuple: 'Je suis le seul qui reste des prophètes de Yahvé, et vous voyez ici les quatre cent cinquante prophètes de Baal."
,"23":"Que l'on nous donne deux taureaux! Ils en choisiront un, ils le couperont en morceaux et ils le placeront sur le bois, mais ils n'y mettront pas le feu. Moi, je préparerai l'autre taureau, je le placerai sur le bois mais je n'y mettrai pas le feu."
,"24":"Puis vous invoquerez le nom de votre dieu, et moi j'invoquerai le nom de Yahvé. Le Dieu qui répondra par le feu, c'est lui qui est Dieu.' Tout le peuple répondit: 'Très bien!'"
,"25":"Elie dit aux prophètes de Baal: 'Puisque vous êtes les plus nombreux, choisissez les premiers votre taureau. Préparez-le, invoquez le nom de votre dieu, mais ne mettez pas le feu.'"
,"26":"Ils prirent donc le taureau qu'on leur présenta, ils le préparèrent et ils invoquèrent le nom de Baal depuis le matin jusqu'à midi en criant: 'Baal, réponds-nous!' Mais on n'entendit rien, il n'y eut pas de réponse pendant qu'ils sautaient devant l'autel qu'ils avaient construit."
,"27":"Midi arriva; Elie se moqua d'eux: 'Criez plus fort, leur dit-il. Il est Dieu, bien sûr, mais il est en méditation, ou il est occupé, ou en voyage; peut-être il dort et vous allez le réveiller.'"
,"28":"Ils crièrent de plus en plus fort et se firent selon leurs habitudes des entailles avec des épées et des couteaux pour faire couler le sang."
,"29":"Ils gesticulèrent encore tout l'après-midi jusqu'au moment où l'on présente l'offrande du soir, mais on n'entendit rien: pas de réponse, pas de réaction!"
,"30":"Elie dit alors à tout le peuple: 'Approchez-vous de moi.' Tous le peuple s'approcha d'Elie tandis qu'il relevait l'autel de Yahvé qui avait été renversé."
,"31":"Il prit douze pierres selon le nombre des tribus de Jacob, l'homme qui avait reçu cette parole de Yahvé: 'Ton nom sera Israël.'"
,"32":"Elie disposa les pierres, puis il creusa autour de l'autel un fossé qui pouvait contenir deux mesures."
,"33":"Il prépara le bois, coupa le taureau en morceaux et les disposa sur le bois."
,"34":"Puis il dit: 'Remplissez d'eau quatre cruches et versez-les sur l'holocauste et sur le bois.' On le fit et il leur dit: 'Recommencez!' On le fit une seconde fois. Il ajouta: 'Une troisième fois!' Et on le fit une troisième fois."
,"35":"L'eau coula autour de l'autel et remplit tout le fossé."
,"36":"A l'heure où l'on présente l'offrande du soir, Elie le prophète s'avança et il dit: 'Yahvé, Dieu d'Abraham, d'Isaac et d'Israël, que l'on sache aujourd'hui que tu es Dieu en Israël, que je suis ton serviteur, et que j'ai agi en tout selon ta parole."
,"37":"Réponds-moi, Yahvé, réponds-moi! Que ce peuple sache que tu es Dieu, toi Yahvé, et que c'est toi qui convertis leur coeur!'"
,"38":"Le feu de Yahvé tomba, il dévora l'holocauste et le bois, et il absorba toute l'eau qui était dans le fossé."
,"39":"A cette vue, tout le peuple tomba la face contre terre, on criait: 'C'est Yahvé qui est Dieu! C'est Yahvé qui est Dieu!'"
,"40":"Alors Elie leur dit: 'Arrêtez les prophètes de Baal, que pas un d'entre eux n'échappe!' On mit la main sur eux; Elie les fit descendre au torrent de Cison, et là il les égorgea."
,"41":"Elie dit à Akab: 'Remonte maintenant, mange et bois, car voici le tonnerre qui annonce la pluie.'"
,"42":"Akab remonta pour manger et boire tandis qu'Elie montait jusqu'au sommet du Carmel. Là il s'inclina et mit son visage entre ses genoux,"
,"43":"puis il dit à son serviteur: 'Monte et regarde du côté de la mer.' Le garçon regarda et il dit: 'Il n'y a rien.',Elie lui dit: 'Retourne une seconde fois!' "
,"44":"Quand il retourna pour la septième fois, un petit nuage montait de la mer, pas plus grand que la paume de la main. Elie dit alors: 'Va dire à Akab d'atteler son char et de descendre, sinon la pluie va le surprendre.'"
,"45":"En peu de temps le ciel devint tout sombre, le vent chassait les nuages et la pluie se mit à tomber à verses; Akab monta sur son char et s'en retourna à Yizréel."
,"46":"Alors la main de Yahvé se posa sur Elie: il serra sa ceinture et courut devant Akab jusqu'à l'entrée de Yizréel."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Akab raconta à Jézabel tout ce qu'avait fait Elie et comment il avait fait périr par l'épée tous les prophètes."
,"2":"Jézabel envoya dire à Elie: 'Que les dieux me maudissent et me maudissent encore si demain à pareille heure je ne t'ai pas supprimé comme tu as fait pour eux.'"
,"3":"Elie craignit et chercha son salut dans la fuite. Il arriva à Bersabée dans le territoire de Juda et il laissa là son serviteur. "
,"4":"Il s'enfonça dans le désert toute une journée de marche, puis il alla s'asseoir sous un genêt et demanda la mort: 'C'en est assez, dit-il. Reprends ma vie, Yahvé, car je ne suis pas meilleur que mes pères.'"
,"5":"Il se coucha là et il s'endormit. Or voici qu'un ange le toucha et lui dit: 'Lève-toi et mange.' "
,"6":"Il regarda: il y avait là près de lui une galette cuite sur des pierres et une cruche d'eau. Il mangea, il but et se recoucha."
,"7":"Une seconde fois l'ange de Yahvé s'approcha, le toucha et lui dit: 'Lève-toi et mange, car le chemin est trop long pour toi.'"
,"8":"Il mangea et il but. Réconforté par cette nourriture, il marcha quarante jours et quarante nuits jusqu'à la montagne de Dieu, l'Horeb."
,"9":"Là, il se dirigea vers la grotte et il y passa la nuit. Voici que la parole de Dieu lui fut adressée: 'Que fais-tu ici, Elie?'"
,"10":"Il répondit: 'Je brûle d'indignation pour Yahvé Sabaot, car les enfants d'Israël t'ont abandonné. Ils ont renversé tes autels, ils ont tué par l'épée tes prophètes; je suis resté seul, et ils cherchent à me tuer.'"
,"11":"Yahvé répondit: 'Sors et tiens-toi dans la montagne devant Yahvé.',Et voici que Yahvé passe. Un vent fort et violent passe en avant de Yahvé, il déchire les montagnes et fend les rochers, mais Yahvé n'est pas dans le vent. Après le vent, un tremblement de terre, mais Yahvé n'est pas dans le tremblement de terre. "
,"12":"Après le tremblement de terre, un feu, mais Yahvé n'est pas dans le feu. Après le feu, ce fut le murmure d'un souffle léger. "
,"13":"Lorsqu'Elie l'entendit, il se couvrit le visage avec son manteau, il sortit et se tint à l'entrée de la grotte. Alors une voix se fit entendre: 'Que fais-tu ici, Elie?'"
,"14":"Il répondit: 'Je brûle d'indignation pour Yahvé Sabaot, car les enfants d'Israël t'ont abandonné. Ils ont renversé tes autels, ils ont tué par l'épée tes prophètes; je suis resté seul et ils cherchent à me tuer.',Yahvé lui dit: "
,"15":"'Retourne par le même chemin et va jusqu'au désert de Damas. Lorsque tu seras arrivé, tu consacreras Hazaël comme roi d'Aram,"
,"16":"tu consacreras Jéhu fils de Nimchi comme roi d'Israël, et tu consacreras Elisée fils de Chafat, d'Abel-Méhola, comme prophète à ta place."
,"17":"Celui qui échappera à l'épée de Hazaël, Jéhu le fera mourir. Celui qui échappera à l'épée de Jéhu, Elisée le fera mourir."
,"18":"Mais je laisserai en vie sept mille hommes en Israël, tous ceux dont les genoux n'ont pas fléchi devant Baal et dont la bouche ne lui a pas donné le baiser.'"
,"19":"Elie partit de là et il trouva Elisée fils de Chafat. Il était en train de labourer, il avait douze arpents de terre à labourer et il arrivait au douzième. Elie s'approcha de lui et jeta son manteau sur lui."
,"20":"Aussitôt, laissant les boeufs, Elisée courut vers Elie: 'Permets, lui dit-il, que j'embrasse mon père, et je viendrai à ta suite.' Mais Elie lui dit: 'Tu peux retourner, ce n'était rien!'"
,"21":"Elisée s'éloigna, mais ce fut pour prendre la paire de boeufs et les sacrifier; il fit cuire leur viande avec le joug des boeufs et la servit en repas à ses gens, puis il se leva, partit derrière Elie et entra à son service."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Ben-Hadad, roi d'Aram, rassembla toute son armée. Il avait avec lui trente- deux rois, des chevaux et des chars lorsqu'il monta mettre le siège devant Samarie pour s'en emparer."
,"2":"Il envoya des messagers en ville auprès d'Akab, roi d'Israël,"
,"3":"pour lui porter ce message: 'Ainsi a parlé Ben Hadad: Ton argent et ton or sont à moi, tes femmes et tes fils sont à moi.'"
,"4":"Le roi d'Israël répondit: 'Tu as bien dit, mon seigneur le roi, je suis à toi avec tout ce qui m'appartient.'"
,"5":"Mais les messagers vinrent de nouveau; ils dirent à Akab de la part de Ben-Hadad: 'Si je t'ai dit: Tu me donneras ton or et ton argent, tes femmes et tes fils,"
,"6":"sois bien sûr que demain à pareille heure j'enverrai mes serviteurs chez toi. Ils fouilleront ta maison et les maisons de tes serviteurs, et tout ce qui leur plaira, ils le ramasseront et l'emporteront.'"
,"7":"Alors le roi d'Israël rassembla les anciens du pays et leur dit: 'Regardez, il est évident que celui-là nous veut du mal. Quand il m'a réclamé mes femmes et mes fils, mon argent et mon or, je ne lui ai rien refusé.'"
,"8":"Tous les anciens et tout le peuple lui dirent: 'Ne l'écoute pas! Il ne faut pas accepter.'"
,"9":"Alors il dit aux messagers de Ben-Hadad: 'Dites ceci à mon seigneur le roi: Ce que tu m'as demandé la première fois, je le ferai, mais je ne peux accepter cette nouvelle exigence.' Les messagers partirent et rapportèrent sa réponse."
,"10":"Alors Ben-Hadad lui envoya dire: 'Que les dieux me maudissent et me maudissent encore s'il y a assez de poussière dans Samarie pour que chacun de mes combattants puisse en remplir le creux de sa main.'"
,"11":"Le roi d'Israël répondit aux messagers: 'Vous direz à votre maître que celui qui prend son épée ne doit pas se vanter comme celui qui la repose!'"
,"12":"L'autre était en train de boire avec les rois sous les tentes quand on lui rapporta cette parole; il dit à ses serviteurs: 'Prenez vos postes de combat!' Et ils prirent position contre la ville."
,"13":"A ce moment un prophète s'avança vers le roi d'Israël et lui dit: 'Ecoute cette parole de Yahvé: Vois-tu cette grande armée? Moi, aujourd'hui, je la livre entre tes mains et tu sauras que je suis Yahvé.'"
,"14":"Akab lui dit: 'Qui fera ce travail?' Il répondit: 'Yahvé a dit: Les jeunes des chefs de provinces.' Akab reprit la parole: 'Qui engagera le combat?' Il répondit: 'Toi.'"
,"15":"Akab passa en revue les jeunes des chefs de provinces, ils étaient deux cent trente-deux. Il passa ensuite en revue tout le peuple, tous les Israélites: ils étaient sept mille."
,"16":"A l'heure de midi, ils firent une sortie quand Ben-Hadad était en train de s'enivrer sous les tentes avec les trente-deux rois venus avec lui."
,"17":"Les jeunes des chefs de provinces sortirent d'abord. On le fit savoir à Ben-Hadad: 'Des hommes sont sortis de Samarie.'"
,"18":"Il répondit: 'Qu'ils soient sortis pour combattre ou pour demander la paix, faites-les prisonniers!'"
,"19":"Mais derrière les jeunes des chefs de provinces, c'est toute l'armée qui sortit de la ville."
,"20":"Ils abattirent chacun son homme, les Araméens tournèrent le dos et Israël se lança à leur poursuite. Ben-Hadad roi d'Aram sauta sur un cheval et prit la fuite avec ses cavaliers."
,"21":"Le roi d'Israël sortit, il ramassa les chevaux et les chars et il infligea à Aram une grande défaite."
,"22":"Alors le prophète s'avança vers le roi d'Israël et lui dit: 'Renforce-toi et prends tes dispositions, car au début de l'an prochain le roi d'Aram viendra de nouveau t'attaquer.'"
,"23":"De leur côté, les conseillers du roi d'Aram lui dirent: 'Les dieux d'Israël sont des dieux des montagnes, c'est pourquoi ils ont été plus forts que nous. Mais attirons-les dans la plaine, et nous aurons sûrement le dessus."
,"24":"Par ailleurs, fais ceci: enlève leur poste à tous ces rois, et mets à leur place des gouverneurs."
,"25":"Tu vas réunir une armée aussi nombreuse que celle que tu as perdue, avec autant de chevaux et autant de chars, et nous les combattrons dans la plaine: nous aurons sûrement le dessus.' Le roi suivit donc leur conseil."
,"26":"Au début de l'année suivante, Ben-Hadad passa en revue les Araméens et monta vers Afek pour combattre Israël."
,"27":"On passa aussi les Israélites en revue, ils reçurent des vivres et s'avancèrent à la rencontre des Araméens. Les Israélites campèrent en face d'eux comme deux troupeaux de chèvres, alors que les Araméens remplissaient le pays."
,"28":"Un homme de Dieu s'avança à ce moment et dit au roi d'Israël: 'Voici ce que dit Yahvé: Les Araméens prétendent que Yahvé est un dieu des montagnes et non pas un dieu de la plaine; pour cette raison je vais livrer toute cette grande armée entre tes mains, et vous saurez que je suis Yahvé.'"
,"29":"Ils campèrent sept jours les uns en face des autres; le septième jour on engagea la bataille et les Israélites tuèrent aux Araméens cent mille fantassins en un seul jour."
,"30":"Ceux qui restaient se réfugièrent dans la ville d'Afek, mais la muraille tomba sur les dix-sept mille qui restaient. Ben-Hadad s'était enfui et il allait dans la ville de maison en maison. "
,"31":"Ses serviteurs lui dirent: 'Nous avons entendu dire que les rois d'Israël sont des rois généreux, laisse-nous mettre des sacs autour de nos reins et des cordes autour de notre tête, et nous irons trouver le roi d'Israël, peut-être te laissera-t-il la vie sauve.'"
,"32":"Ils se mirent donc des sacs autour des reins, des cordes autour de leur tête, et ils allèrent dire au roi d'Israël: 'Ton serviteur Ben-Hadad te fait dire ceci: Accorde-moi seulement la vie sauve!' Le roi Akab répondit: 'Est-il toujours en vie? Il est mon frère!'"
,"33":"Les autres n'en espéraient pas tant, ils dirent aussitôt: 'Ben-Hadad est ton frère!' Le roi répondit: 'Allez le chercher.',Ben-Hadad vint donc à sa rencontre et Akab le fit monter sur son char. "
,"34":"Ben-Hadad lui dit: 'Je te rendrai les villes que mon père a prises à ton père, et tu pourras installer des commerces à Damas comme mon père en avait installé à Samarie.' Akab répondit: 'Je te laisserai partir en échange d'un traité.' Il conclut donc un traité avec lui et le laissa partir."
,"35":"Au même moment un frère prophète disait à son compagnon sur l'ordre de Yahvé: 'Frappe-moi donc!' Mais l'autre refusa de le frapper."
,"36":"Il lui dit alors: 'Puisque tu n'as pas écouté la voix de Yahvé, le lion te frappera après que tu m'auras quitté.' Il s'en alla, le lion le rencontra et le tua."
,"37":"Le prophète alla trouver un autre compagnon et lui dit: 'Frappe-moi donc!' L'homme commença à le frapper et le blessa."
,"38":"Alors le frère prophète alla se poster sur le passage du roi; il s'était déguisé avec un bandeau sur les yeux."
,"39":"Au moment où le roi passait, il cria vers le roi: 'Je suis arrivé sur le champ de bataille lorsqu'un autre en partait. Il m'a laissé un prisonnier en me disant: Garde bien cet homme, car s'il s'échappe, ta vie paiera pour la sienne ou tu verseras un talent d'argent."
,"40":"Or pendant que j'étais occupé ici et là, le prisonnier a disparu.',Le roi d'Israël lui répondit: 'Mais tu prononces toi-même ton jugement!' "
,"41":"Aussitôt le prophète enleva le bandeau qu'il avait sur les yeux et le roi d'Israël le reconnut pour un des prophètes."
,"42":"Alors il dit au roi: 'Ecoute cette parole de Yahvé: Puisque tu as laissé échapper l'homme que j'avais voué à l'anathème, ta vie répondra pour sa vie, et ton peuple pour son peuple.'"
,"43":"Le roi d'Israël s'en alla démoralisé et de très mauvaise humeur; il rentra chez lui à Samarie."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Nabot de Yizréel avait une vigne juste à côté du palais d'Akab, roi de Samarie."
,"2":"Akab dit à Nabot: 'Ta vigne est à côté de mon palais, donne-la moi pour que j'en fasse un jardin potager. A la place je te donnerai une vigne meilleure, ou si tu préfères, je te la paierai au prix qu'elle vaut.'"
,"3":"Nabot répondit à Akab: 'Que Yahvé me garde d'abandonner l'héritage de mes pères!'"
,"4":"Akab rentra chez lui découragé et de très mauvaise humeur pour cette réponse de Nabot de Yizréel: 'Je ne céderai pas l'héritage de mes pères.' Il se coucha sur son lit, tourna la tête contre le mur et refusa de manger."
,"5":"Jézabel, sa femme, vint le trouver et lui dit: 'Pourquoi fais-tu cette tête-là? Pourquoi ne manges-tu pas?'"
,"6":"Il lui répondit: 'Je viens de dire à Nabot de Yizréel: Donne-moi ta vigne, je te la paierai ou, si tu préfères, je t'en donnerai une autre à la place. Mais il m'a répondu: je ne te donnerai pas ma vigne.'"
,"7":"Alors sa femme Jézabel lui dit: 'Te voilà bien là, roi d'Israël! Allez! Lève-toi, mange et cesse de faire cette tête. Je te donnerai, moi, la vigne de Nabot de Yizréel.'"
,"8":"Elle écrivit au nom du roi une lettre qu'elle scella avec le cachet du roi, elle l'envoya aux anciens et aux chefs de la ville, les voisins de Nabot."
,"9":"Voici ce que disait cette lettre: 'Proclamez un jeûne et placez Nabot face au peuple."
,"10":"Vous trouverez bien deux vauriens pour lui lancer cette accusation: Tu as maudit Dieu et le roi! Alors vous le ferez sortir et vous le tuerez à coups de pierres.'"
,"11":"Les gens de la ville, les anciens et les chefs qui habitaient avec Nabot, firent ce que Jézabel demandait dans la lettre qu'elle leur avait envoyée."
,"12":"Ils proclamèrent un jeûne et ils placèrent Nabot face au peuple."
,"13":"Alors arrivèrent les deux vauriens, ils se placèrent devant Nabot pour témoigner contre lui et devant tout le peuple ils dirent: 'Nabot a maudit Dieu et le roi!' On le fit sortir hors de la ville et on le lapida. Et Nabot mourut."
,"14":"On le fit savoir à Jézabel: 'Nabot a été tué à coups de pierres.'"
,"15":"Dès que Jézabel apprit la mort de Nabot, elle dit à Akab: 'Lève-toi, prends la vigne de Nabot de Yizréel, celui qui ne voulait pas te la donner pour son prix; il n'y a plus de Nabot, car Nabot est mort.'"
,"16":"Lorsque Akab entendit que Nabot était mort, il se leva pour descendre à Yizréel et il prit possession de la vigne de Nabot."
,"17":"Mais la parole de Yahvé fut adressée à Elie de Tichbé:"
,"18":"'Lève-toi, descends à la rencontre d'Akab roi d'Israël. Il est en ce moment à Samarie, il est allé à la vigne de Nabot pour en prendre possession."
,"19":"Tu lui diras cette parole de Yahvé: Tu assassines, et ensuite tu prends l'héritage! Ecoute donc ceci: là où les chiens ont léché le sang de Nabot, les chiens lécheront aussi ton propre sang.'"
,"20":"Akab dit à Elie: 'Te voilà! mon ennemi m'a surpris!' Elie répondit: 'Oui, je t'ai surpris, car tu t'es vendu pour faire ce qui est mal aux yeux de Yahvé."
,"21":"Aussi vais-je faire venir le malheur sur toi. Je balaierai derrière toi, je ferai disparaître tous les mâles de la maison d'Akab, qu'ils soient esclaves ou hommes libres en Israël."
,"22":"Puisque tu m'as mis en colère et que tu as fait pécher Israël, je rendrai ta maison semblable à la maison de Jéroboam, fils de Nabat, et à la maison de Bacha, fils d'Ahya.'"
,"23":"Il y eut aussi une parole de Yahvé au sujet de Jézabel: 'Les chiens mangeront Jézabel au pied du mur de Yizréel."
,"24":"Celui de la maison d'Akab qui mourra dans la ville sera dévoré par les chiens, et celui qui mourra dans la campagne sera mangé par les oiseaux du ciel.'"
,"25":"Il ne s'est trouvé vraiment personne comme Akab pour se vendre et faire ce qui est mal aux yeux de Yahvé; il faut dire que sa femme Jézabel l'y entraînait."
,"26":"Il s'est conduit de façon épouvantable, il a servi les idoles comme le faisaient les Amorites que Yahvé avait chassés devant les Israélites."
,"27":"En entendant les paroles d'Elie, Akab déchira ses vêtements, il s'habilla avec un sac et jeûna; il dormait avec son sac et marchait lentement."
,"28":"Alors la parole de Yahvé fut adressée à Elie de Tichbé:"
,"29":"'As-tu remarqué comment Akab a fait pénitence devant moi? Puisqu'il a fait pénitence devant moi, je ne ferai pas venir le malheur durant sa vie, je le ferai venir sur sa maison durant la vie de son fils."
}`)
	CurrentBook.AddChapter(22, `{
"1":"La paix entre Aram et Israël dura trois ans."
,"2":"La troisième année, comme Josaphat roi de Juda était descendu chez le roi d'Israël,"
,"3":"celui-ci dit à ses serviteurs: 'Avez-vous oublié que Ramot de Galaad est à nous? Nous ne faisons rien pour la reprendre au roi d'Aram.'"
,"4":"Il dit alors à Josaphat: 'Viendras-tu combattre avec moi à Ramot de Galaad?' Josaphat répondit au roi d'Israël: 'Moi, mon peuple et mes chevaux, nous ne ferons qu'un avec toi, ton peuple et tes chevaux.'"
,"5":"Cependant Josaphat dit au roi d'Israël: 'J'aimerais consulter la parole de Yahvé.'"
,"6":"Le roi d'Israël rassembla les prophètes - ils étaient bien quatre cents - et il leur dit: 'Faut-il que j'attaque Ramot de Galaad ou faut-il que j'y renonce?' Ils répondirent: 'Pars en campagne et le Seigneur la livrera entre les mains du roi.'"
,"7":"Josaphat dit alors: 'N'y a-t-il pas ici un prophète de Yahvé par lequel nous puissions le consulter?'"
,"8":"Le roi d'Israël répondit à Josaphat: 'Si, il y a encore un homme par qui l'on pourrait consulter Yahvé, mais je le déteste car il ne me prophétise jamais rien de bon , seulement le mal; c'est Michée fils de Yimla.' Josaphat dit: 'Que le roi ne parle pas ainsi!'"
,"9":"Le roi d'Israël appela un serviteur et lui dit: 'Va tout de suite chercher Michée fils de Yimla.'"
,"10":"Le roi d'Israël et Josaphat, roi de Juda, étaient assis chacun sur son trône, en costume de cérémonie, sur l'aire qui est à l'entrée de la porte de Samarie, et tous les prophètes continuaient de prophétiser devant eux."
,"11":"Sédécias fils de Kénaana s'était fait des cornes de fer, il disait: 'Voici ce que dit Yahvé: Je te les donne pour frapper les Araméens jusqu'au dernier.'"
,"12":"Et tous les prophètes ne faisaient qu'un pour dire: 'Pars en campagne contre Ramot de Galaad, tu seras vainqueur, Yahvé la livrera entre les mains du roi!'"
,"13":"Le messager qui était allé chercher Michée lui dit: 'Tous les prophètes comme un seul homme encouragent le roi. Tu as intérêt à parler comme eux: annonce le succès.'"
,"14":"Mais Michée répondit: 'Aussi vrai que Yahvé est vivant, je ne dirai que ce que Yahvé me dira.'"
,"15":"Il arriva donc devant le roi, et le roi lui demanda: 'Michée, faut-il que nous allions combattre à Ramot de Galaad, ou devons-nous y renoncer?' Michée répondit: 'Pars en campagne et tu seras vainqueur; Yahvé la livrera entre les mains du roi!'"
,"16":"Mais le roi lui dit: 'Combien de fois faut-il que je te demande au nom de Yahvé de ne me dire que la vérité?'"
,"17":"Alors Michée répondit: 'J'ai vu tout Israël dispersé sur les montagnes comme des brebis qui n'ont plus de berger, et Yahvé disait: Ils n'ont plus de maître, que chacun retourne chez soi.'"
,"18":"Le roi d'Israël se tourna vers Josaphat: 'Je te l'avais bien dit, il ne me prophétise jamais rien de bon, seulement le mal.'"
,"19":"Michée ajouta: 'Ecoute cette parole de Yahvé: J'ai vu Yahvé qui siégeait sur son trône, avec toute l'armée des cieux à sa droite et à sa gauche."
,"20":"Et Yahvé a dit: Qui trompera le roi d'Israël pour qu'il parte en campagne et se fasse tuer à Ramot de Galaad? L'un répondait d'une façon, l'autre d'une autre."
,"21":"Alors l'Esprit s'est avancé et il s'est tenu devant Yahvé: Moi, a-t-il dit, je le tromperai. Yahvé lui a demandé: Comment cela?"
,"22":"Il a répondu: Je vais aller et je me ferai esprit de mensonge dans la bouche de tous ses prophètes. Alors Yahvé lui a répondu: Tu réussiras, tu arriveras à le tromper: pars et fais comme tu l'as dit."
,"23":"Sache donc que Yahvé a mis un esprit de mensonge dans la bouche de tous les prophètes qui sont ici, parce que lui, Yahvé, a décidé ta perte.'"
,"24":"A ce moment Sédécias, fils de Kénaana, s'avança et gifla Michée; il dit: 'Par où l'esprit de Yahvé est-il sorti de moi pour te parler?'"
,"25":"Michée lui répondit: 'Tu le sauras le jour où tu fuiras de chambre en chambre pour te cacher.'"
,"26":"Alors le roi prit la parole: 'Arrête cet homme et confie-le à Amon, le gouverneur de la ville, et à Yoach, fils du roi."
,"27":"Vous leur direz: Voici l'ordre du roi: Mettez cet homme en prison, vous ne lui donnerez qu'une maigre ration de pain et d'eau jusqu'à ce que je revienne victorieux.'"
,"28":"Michée lui dit alors: 'Si tu reviens victorieux, ce sera le signe que Yahvé n'a pas parlé par moi.'"
,"29":"Le roi d'Israël et le roi de Juda, Josaphat, partirent en campagne contre Ramot de Galaad."
,"30":"Le roi d'Israël dit à Josaphat: 'Je vais me déguiser pour aller combattre, mais toi, porte ton costume.' Et le roi d'Israël se déguisa pour aller au combat."
,"31":"Or le roi d'Aram avait donné cet ordre à ses trente-deux chefs de chars: 'N'attaquez ni petit ni grand, mais seulement le roi d'Israël.'"
,"32":"Lorsque les chefs de chars aperçurent Josaphat, ils se dirent: 'Sûrement c'est le roi d'Israël.' Et ils se dirigèrent vers lui pour l'attaquer. Mais Josaphat poussa un cri;"
,"33":"lorsque les chefs de chars virent que ce n'était pas le roi d'Israël, ils se détournèrent de lui."
,"34":"Au même moment un soldat tira avec son arc sans savoir sur qui, et il atteignit le roi d'Israël entre les attaches et la cuirasse. Le roi dit à son conducteur de char: 'Fais demi-tour et fais-moi sortir de la mêlée, je suis blessé.'"
,"35":"Mais le combat était très rude ce jour-là, il fallut maintenir le roi debout sur son char face aux Araméens, et le soir il mourut. Le sang de sa blessure avait coulé à l'intérieur du char."
,"36":"Au coucher du soleil, un cri parcourut le camp: 'Que chacun rentre dans sa ville, que chacun retourne à sa terre:"
,"37":"le roi est mort!',On le ramena à Samarie, et là on l'enterra. "
,"38":"On lava le char à l'étang de Samarie; les chiens léchèrent le sang et les prostituées s'y baignèrent, comme Yahvé l'avait annoncé."
,"39":"Le reste des actes d'Akab, tout ce qu'il a fait, le palais d'ivoire qu'il s'est construit, les villes qu'il a bâties, cela n'est-il pas écrit dans le livre des Chroniques des rois d'Israël?"
,"40":"Akab se coucha avec ses pères et son fils Okozias régna à sa place."
,"41":"Josaphat, fils d'Aza, devint roi de Juda l'an quatre du règne d'Akab d'Israël."
,"42":"Josaphat avait trente-cinq ans lorsqu'il devint roi et il régna vingt-cinq ans à Jérusalem; sa mère Azouba était fille de Chilhi."
,"43":"Il suivit pas à pas les traces de son père Aza, il ne s'en détourna pas: il fit ce qui est juste aux yeux de Yahvé."
,"44":"Cependant les Hauts-Lieux ne disparurent pas, le peuple continuait d'offrir des sacrifices et de l'encens sur les Hauts-Lieux."
,"45":"Josaphat fut en paix avec le roi d'Israël."
,"46":"Le reste des actes de Josaphat, ses exploits, les guerres qu'il fit, tout cela n'est-il pas écrit dans le livre des Chroniques des rois de Juda?"
,"47":"Il fit disparaître du pays les prostitués sacrés qui étaient restés au temps de son père Aza."
,"48":"En ce temps-là il n'y avait pas de roi en Edom, mais seulement un gouverneur royal."
,"49":"Josaphat avait construit dix vaisseaux de Tarsis pour aller chercher de l'or à Ofir, mais on n'y alla pas, car ses vaisseaux se brisèrent à Ezyon-Guéber."
,"50":"A cette occasion Okozias, fils d'Akab, dit à Josaphat: 'Laisse mes serviteurs s'embarquer avec les tiens sur les vaisseaux.' Mais Josaphat refusa."
,"51":"Lorsque Josaphat se coucha avec ses pères, on l'enterra avec ses pères dans la cité de David son ancêtre. Joram, son fils, régna à sa place."
,"52":"Okozias fils d'Akab devint roi d'Israël à Samarie l'an dix-sept du règne de Josaphat de Juda; il régna deux ans sur Israël."
,"53":"Il fit ce qui est mal aux yeux de Yahvé et suivit les traces de son père et de sa mère; il imita la conduite de Jéroboam, fils de Nabat, qui avait fait pécher Israël. Il mit en colère Yahvé, Dieu d'Israël, comme l'avait fait son père, car il servait Baal et se prosternait devant lui."
}`)

}
func FR_LBDCC_LoadVH1SChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Il y avait un homme de Ramatayim, un Soufite de la montagne d'Ephraïm, qui s'appelait Elqana. Il était fils de Yéroham, fils d'Elihou, fils de Tohou, fils de Souf, de la tribu d'Ephraïm."
,"2":"Il avait deux femmes, l'une s'appelait Anne, l'autre Pénina. Pénina avait des enfants mais Anne n'en avait pas."
,"3":"Cet homme montait chaque année de sa ville pour adorer et pour offrir des sacrifices à Yahvé Sabaot, au sanctuaire de Silo; les deux fils d'Héli, Hofni et Pinhas, servaient comme prêtres de Yahvé en cet endroit."
,"4":"Un jour Elqana offrait un sacrifice; il donna des portions à sa femme Pénina ainsi qu'à ses fils et à ses filles;"
,"5":"il servit une double portion à Anne car il aimait Anne, mais Yahvé l'avait rendue stérile."
,"6":"Sa rivale ne faisait qu'augmenter sa peine: elle l'humiliait parce que Yahvé l'avait rendue stérile."
,"7":"Chaque année c'était pareil quand elle montait à la maison de Yahvé: l'autre ravivait sa peine, Anne pleurait et ne mangeait plus."
,"8":"Elqana, son mari, lui dit: 'Anne, pourquoi pleures-tu, pourquoi ne manges-tu pas, pourquoi es-tu si triste, est-ce que je ne vaux pas mieux pour toi que dix fils?'"
,"9":"Ce jour-là, après qu'on eut mangé et bu à Silo, Anne se leva alors que le prêtre Héli était assis sur son siège contre un des montants de la porte du sanctuaire de Yahvé."
,"10":"Dans sa peine elle se tourna vers Yahvé et le pria sans cesser de pleurer;"
,"11":"elle fit ce voeu: 'Yahvé des armées, regarde avec bonté la peine de ta servante, souviens-toi de moi, n'oublie pas ta servante. Si tu donnes à ta servante un petit garçon, je le consacrerai à Yahvé pour le restant de ses jours et le rasoir ne passera pas sur sa tête.'"
,"12":"Elle priait là longuement devant Yahvé et Héli la regardait."
,"13":"Anne priait dans le fond de son coeur, elle remuait à peine les lèvres et l'on n'entendait pas sa voix."
,"14":"Héli pensa donc qu'elle était ivre, il lui dit: 'Combien de temps vas-tu rester dans cet état? Va cuver ton vin.'"
,"15":"Anne répondit: 'Non, mon seigneur, je ne suis qu'une femme en peine; je n'ai bu ni vin, ni boisson alcoolisée, mais j'épanche mon coeur devant Yahvé."
,"16":"Ne prends pas ta servante pour une femme de rien: si je me suis tellement attardée à prier, c'est parce que ma souffrance et mon chagrin sont grands.'"
,"17":"Héli reprit la parole et lui dit: 'Va en paix, et que le Dieu d'Israël exauce la prière que tu lui as faite.'"
,"18":"Elle lui dit à son tour: 'Que ta servante trouve grâce à tes yeux!' Elle se leva, mangea, mais son visage n'était plus le même."
,"19":"De bon matin on se leva et, après s'être prosternés devant Yahvé, ils s'en retournèrent pour regagner leur maison à Rama."
,"20":"Elkana eut des relations avec sa femme Anne et Yahvé se souvint d'elle. Lorsque le temps fut accompli, Anne enfanta un fils et lui donna le nom de Samuel, car, dit-elle: 'Je l'ai demandé à Yahvé.'"
,"21":"Elqana, son mari, monta avec toute sa maison pour offrir à Yahvé le sacrifice comme chaque année et s'acquitter de son voeu."
,"22":"Anne ne monta pas, mais elle dit à son mari: 'Lorsque l'enfant sera sevré, je le conduirai devant Yahvé et il y restera pour toujours.'"
,"23":"Elqana lui répondit: 'Fais comme il te semble bon. Reste ici jusqu'à ce que tu l'aies sevré, et que Yahvé fasse comme tu viens de dire.' La femme resta donc, elle allaita son fils jusqu'au jour où il fut sevré."
,"24":"Après qu'elle l'eut sevré, elle le fit monter avec elle à la maison de Yahvé à Silo; elle menait un taureau de trois ans avec une mesure de farine et une outre de vin. L'enfant était encore tout jeune."
,"25":"Ils sacrifièrent le taureau et ils amenèrent l'enfant à Héli."
,"26":"Anne lui dit: 'Pardon, mon seigneur! Aussi vrai que tu vis, mon seigneur, c'est moi la femme qui se tenait ici près de toi pour prier Yahvé."
,"27":"C'est pour cet enfant que j'ai prié et Yahvé m'a donné ce que je lui demandais."
,"28":"A mon tour je le cède à Yahvé pour le restant de ses jours: il sera donné à Yahvé.' C'est ainsi qu'il resta là au service de Yahvé."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Alors Anne prononça ce cantique: 'En Yahvé mon coeur chante de joie, avec Yahvé je suis pleine de force; je peux répondre à mes ennemis,car tu m'as sauvée, c'est là mon bonheur."
,"2":"Nul n'est Saint comme Yahvé, personne ne l'est sinon toi: il n'y a pas d'autre rocher que notre Dieu."
,"3":"Laissez là votre orgueil, vos paroles inutiles, que l'arrogance ne sorte plus de votre bouche. Yahvé est un Dieu qui connaît toute chose, c'est lui qui pèsera vos actes."
,"4":"L'arc des guerriers se brise, mais les faibles sont remplis de force."
,"5":"Ceux qui n'ont pas eu faim s'embauchent pour du pain. pour ceux qui avaient faim, fini de travailler, celle qui était stérile met au monde sept enfants,une autre avait des fils: seule, elle s'éteint,"
,"6":"Yahvé donne la mort et donne la vie, il fait descendre au séjour des morts, il fait qu'on en remonte."
,"7":"C'est Yahvé qui rend pauvre, c'est lui qui enrichit, Il abaisse, mais ensuite il relève."
,"8":"Il retire de la poussière le petit, de son fumier il relève le pauvre,pour le faire asseoir avec les grands, et lui donner un trône de gloire. La terre et ses colonnes appartiennent à Yahvé, sur elles il a établi le monde."
,"9":"Il veille sur les pas de ses fidèles, mais les méchants périssent dans les ténèbres: nulle violence ne donne à l'homme la victoire."
,"10":"Tes ennemis, Yahvé, sont mis en déroute, quand dans les cieux tu tonnes, ô Très-Haut!,Yahvé fait justice jusqu'aux confins du monde, il donne la force à son roi,et rend invincible son Messie.'"
,"11":"Elkana revint donc chez lui à Rama, tandis que l'enfant restait au service de Yahvé, sous la garde du prêtre Héli."
,"12":"Les fils d'Héli étaient des moins que rien, ils ne respectaient, ni Yahvé,"
,"13":"ni la loi des prêtres vis à vis du peuple. Lorsque quelqu'un offrait un sacrifice, le serviteur du prêtre venait pendant qu'on cuisait la viande. Avec une fourchette à trois dents,"
,"14":"il piquait dans le chaudron, ou dans la marmite, ou dans la terrine, ou dans le pot, et tout ce que ramenait la fourchette était pour le prêtre. On faisait ainsi à l'égard de tous les Israélites qui venaient à Silo."
,"15":"Avant même que l'on fasse fumer la graisse, le serviteur du prêtre arrivait; il disait à celui qui offrait le sacrifice: 'Donne de la viande à rôtir pour le prêtre, il n'acceptera pas de la viande bouillie, seulement de la viande à rôtir.'"
,"16":"Et si cet homme répondait: 'Qu'on fasse d'abord fumer la graisse, ensuite tu prendras ce que tu veux', il répliquait: 'Non, tu vas me le donner tout de suite, sinon je le prends de force!'"
,"17":"La faute de ces jeunes gens était très grande devant Yahvé, car ils jetaient le discrédit sur l'offrande qu'on fait à Yahvé."
,"18":"Samuel était encore un enfant, il était au service de Yahvé et portait un pagne de lin."
,"19":"Chaque année sa mère lui faisait une petite tunique qu'elle lui apportait lorsqu'elle montait avec son mari pour le sacrifice annuel."
,"20":"C'est alors qu'Héli bénit Elkana et sa femme: 'Que Yahvé, dit-il, te donne des enfants de cette femme en échange du fils qu'elle a consacré à Yahvé.' Après quoi ils s'en retournèrent chez eux."
,"21":"Yahvé se souvint d'Anne: elle conçut et enfanta trois fils et deux filles. Quant au jeune Samuel, il grandissait sous le regard de Yahvé."
,"22":"Héli était très vieux. Il apprit la mauvaise conduite de ses fils à l'égard de tout Israël: ils couchaient en effet avec les femmes qui faisaient le service à l'entrée de la Tente du Rendez-Vous."
,"23":"Il leur dit: 'Pourquoi vous conduisez-vous comme cela? Tout le monde me parle de vos mauvaises actions."
,"24":"Non, mes enfants! Ce que j'entends n'a rien de beau: vous péchez contre Yahvé."
,"25":"Si un homme pèche contre un autre homme, Dieu peut faire l'arbitre, mais celui qui pèche contre Yahvé, qui intercédera pour lui?' Cependant ils n'écoutèrent pas la voix de leur père: Yahvé avait déjà décidé de les faire périr."
,"26":"Quant au jeune Samuel, de jour en jour il grandissait et devenait meilleur, aux yeux de Yahvé comme aux yeux des hommes."
,"27":"Un homme de Dieu vint trouver Héli et lui dit: 'Ecoute cette parole de Yahvé: Je me suis révélé clairement à la maison de ton père lorsqu'ils étaient en Egypte chez le Pharaon."
,"28":"Je l'ai choisi entre toutes les tribus d'Israël pour qu'il soit mon prêtre, pour monter à mon autel, pour faire fumer l'encens et porter l'éphod devant moi. J'ai donné à la maison de ton père toutes les offrandes que les Israélites sacrifient par le feu."
,"29":"Pourquoi maintenant jetez-vous le discrédit sur les sacrifices et les offrandes que j'ai ordonnés dans ma maison? Tu as plus d'égards pour tes fils que pour moi et tu les laisses s'engraisser avec tout le meilleur des offrandes que présente mon peuple Israël."
,"30":"C'est pourquoi voici ce que dit Yahvé, le Dieu d'Israël: J'avais déclaré que ta maison, celle de ton père, resterait pour toujours à mon service. Mais maintenant, dit Yahvé, c'est fini! Car j'honore ceux qui m'honorent mais ceux qui me méprisent seront méprisés."
,"31":"Voici venir des jours où je te briserai les bras à toi et à la maison de ton père, et on ne verra plus de vieillards dans ta maison."
,"32":"Tu verras tout le bien que je ferai à Israël, pendant que ta demeure sera plongée dans l'angoisse: plus jamais on n'y verra des gens âgés."
,"33":"Je laisserai toujours près de mon autel l'un de tes descendants pour que ses yeux le voient, et qu'il en soit humilié, mais tout l'ensemble de ceux qui seront nés dans ta maison, périront par l'épée des hommes."
,"34":"Toi même tu vas avoir un signe de ce qui arrivera par la suite: tes fils Hofni et Pinhas mourront tous les deux le même jour."
,"35":"Alors se lèvera un prêtre fidèle qui agira selon mon coeur et selon mon âme; je lui ferai une maison inébranlable et il remplira toujours sa charge sous le regard de celui que j'ai choisi."
,"36":"Ceux qui resteront de ta maison viendront se prosterner devant lui pour une pièce d'argent ou un morceau de pain, et ils diront: Confie-moi, je t'en prie, une petite charge dans le sacerdoce, pour que j'aie un morceau de pain à manger.'"
}`)
	CurrentBook.AddChapter(3, `{
"1":"Le jeune Samuel servait Yahvé sous le regard d'Héli. En ce temps-là la parole de Yahvé était chose rare, et les visions, peu fréquentes."
,"2":"Ce jour-là Héli était couché dans sa chambre, ses yeux étaient si faibles qu'il ne voyait plus."
,"3":"La lampe de Dieu n'était pas encore éteinte et Samuel était couché dans le sanctuaire de Yahvé, là où se trouvait l'Arche de Dieu."
,"4":"Yahvé appela: 'Samuel! Samuel!' Il répondit: 'Me voici.'"
,"5":"Il courut vers Héli et dit: 'Me voici puisque tu m'as appelé.' Héli répondit: 'Je ne t'ai pas appelé, retourne te coucher.' Et Samuel alla se coucher."
,"6":"Yahvé appela de nouveau: 'Samuel! Samuel!' Il se leva et se rendit auprès d'Héli: 'Me voici, dit-il, puisque tu m'as appelé.' Héli répondit: 'Je ne t'ai pas appelé mon fils, retourne te coucher.'"
,"7":"Samuel ne connaissait pas encore Yahvé: la parole de Yahvé ne lui avait pas encore été révélée."
,"8":"Lorsque Yahvé appela Samuel pour la troisième fois, il se leva et se rendit auprès d'Héli: 'Me voici, dit-il, puisque tu m'as appelé.' Alors Héli comprit que c'était Yahvé qui appelait le garçon."
,"9":"Il dit à Samuel: 'Va te coucher; si on t'appelle, tu répondras: Parle, Yahvé, car ton serviteur écoute.' Et Samuel repartit se coucher."
,"10":"Yahvé entra; il se tint là et il appela comme les autres fois: 'Samuel! Samuel!' Samuel répondit: 'Parle, car ton serviteur écoute.'"
,"11":"Yahvé dit alors à Samuel: 'Je vais accomplir en Israël une chose telle, que les deux oreilles en tinteront à quiconque l'apprendra."
,"12":"En ce jour-là je ferai tomber sur Héli la condamnation que j'ai prononcée contre sa maison, depuis le début jusqu'à la fin."
,"13":"Tu lui diras que je condamne sa maison à jamais, car il savait que ses fils maudissaient Dieu et il ne les a pas corrigés."
,"14":"C'est pourquoi, je le jure à la maison d'Héli, aucun sacrifice, aucune offrande ne pourront effacer la faute de la maison d'Héli.'"
,"15":"Samuel se recoucha jusqu'au matin, puis il ouvrit les portes du sanctuaire de Yahvé. Samuel avait peur de raconter la vision à Héli,"
,"16":"mais Héli l'appela et lui dit: 'Samuel, mon fils.' 'Me voici, répondit-il.'"
,"17":"Héli demanda: 'Quelle est la parole qu'il t'a dite? Ne me cache rien. Que Dieu te maudisse et qu'il te maudisse encore, si tu me caches un seul mot de tout ce qu'il t'a dit.'"
,"18":"Alors Samuel lui raconta tout, il ne lui cacha rien. Héli dit: 'Il est Yahvé, qu'il fasse comme il lui semble bon.'"
,"19":"Samuel avait grandi, Yahvé était avec lui et ses paroles ne manquaient jamais de se réaliser."
,"20":"Tout Israël l'apprit, depuis Dan jusqu'à Bersabée: Samuel était prophète de Yahvé, c'était une chose certaine."
,"21":"Yahvé continua de se manifester à Silo; il se révélait à Samuel à Silo pendant qu'Héli vieillissait et que ses fils s'enfonçaient dans leur voie mauvaise."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Or il arriva en ces jours-là, que les Philistins se rassemblèrent pour combattre Israël et les Israélites sortirent à leur rencontre pour la bataille. Ils campaient près d'Eben-Ha-Ezer, tandis que les Philistins campaient à Afek."
,"2":"Les Philistins se rangèrent en bataille face à Israël et le combat fut violent. Israël fut battu par les Philistins qui tuèrent environ quatre mille hommes dans leurs rangs en rase campagne."
,"3":"Lorsque le peuple regagna le camp, les anciens d'Israël se demandèrent: 'Pourquoi Yahvé nous a-t-il écrasés aujourd'hui devant les Philistins? Allons à Silo, ramenons l'Arche de l'Alliance! Qu'elle vienne au milieu de nous et qu'elle nous sauve de la main de nos ennemis.'"
,"4":"Le peuple envoya donc chercher à Silo l'Arche de l'Alliance de Yahvé des armées, qui siège sur les chérubins. Les deux fils d'Héli, Hofni et Pinhas, l'accompagnaient."
,"5":"Lorsque l'Arche de l'Alliance de Yahvé entra dans le camp, tout Israël poussa des cris à faire trembler le sol."
,"6":"En entendant ces cris, les Philistins se dirent: 'Que signifie cette grande acclamation dans le camp des Hébreux?' Quand ils apprirent que l'Arche de Yahvé était arrivée au camp,"
,"7":"les Philistins eurent peur: 'Dieu est arrivé dans leur camp, dirent-ils, malheur à nous, car jusqu'ici rien de pareil n'était arrivé."
,"8":"Malheur à nous! Qui nous délivrera de la main de ces Dieux puissants? Ce sont eux qui ont frappé les Egyptiens de toutes sortes de plaies lorsqu'ils étaient au désert."
,"9":"Courage, Philistins! Luttons comme des hommes, n'allons pas nous soumettre à ces Hébreux comme ils nous ont été soumis jusqu'à ce jour. Soyons courageux et luttons!'"
,"10":"Les Philistins livrèrent bataille; les Israélites furent écrasés et chacun s'enfuit chez lui. Ce fut une très grande défaite: trente mille fantassins tombèrent dans les rangs d'Israël."
,"11":"L'Arche de Dieu fut prise et les deux fils d'Héli, Hofni et Pinhas, moururent."
,"12":"Un homme de Benjamin s'échappa des lignes et arriva le jour même à Silo, les vêtements déchirés et la tête couverte de poussière."
,"13":"Lorsqu'il arriva, Héli était assis sur son siège à côté de la porte, il guettait la route car son coeur tremblait pour l'Arche de Dieu. L'homme arriva donc à la ville portant la nouvelle et, de la ville, s'éleva une grande lamentation."
,"14":"Quand Héli l'entendit, il demanda: 'Pourquoi une telle lamentation?' L'homme courut vers Héli pour l'avertir:"
,"15":"il avait alors quatre-vingt-dix-huit ans, son regard était fixe et il ne voyait plus."
,"16":"Le messager dit à Héli: 'J'arrive du camp, je me suis enfui des lignes aujourd'hui même.' Héli demanda: 'Que s'est-il passé, mon fils?'"
,"17":"Le messager répondit: 'Israël a fui devant les Philistins, c'est une terrible défaite pour le peuple. Tes deux fils aussi sont morts et l'Arche de Dieu a été prise.'"
,"18":"A peine eut-il mentionné l'Arche de Dieu, qu'Héli tomba de son siège à la renverse, en travers de la porte. Il se brisa la nuque et il mourut, car le vieillard était lourd. Il avait jugé Israël pendant quarante ans."
,"19":"Sa belle-fille, la femme de Pinhas, était enceinte et sur le point d'accoucher. En apprenant la prise de l'Arche de Dieu, la mort de son beau-père et celle de son mari, elle fut prise de douleurs, elle s'accroupit et accoucha."
,"20":"Les femmes qui l'assistaient virent qu'elle était sur le point de mourir; elles lui dirent: 'Courage! Courage! C'est un fils que tu as enfanté.' Mais elle ne répondit rien et n'y prêta aucune attention."
,"21":"Elle appela l'enfant Ikabod car, dit-elle: 'La Gloire a été retranchée d'Israël.' Elle pensait à la fois à la prise de l'Arche, à son beau-père et à son mari."
,"22":"Et ell e déclara: 'La Gloire a été retranchée d'Israël puisque l'Arche de Dieu a été enlevée.'"
}`)
	CurrentBook.AddChapter(5, `{
"1":"Les Philistins avaient donc capturé l'Arche de Dieu, ils la transportèrent d'Eben-Ha-Ezer à Ashdod."
,"2":"Ils prirent l'Arche de Dieu et la placèrent dans le temple de Dagon à côté de la statue de Dagon."
,"3":"Le lendemain, lorsque les habitants d'Ashdod se levèrent, tôt le matin, et vinrent au temple de Dagon, ils virent Dagon par terre: il était tombé sur sa face devant l'Arche de Yahvé. Ils relevèrent Dagon et le remirent à sa place."
,"4":"Le lendemain de bon matin, ils se levèrent et, cette fois encore, Dagon était par terre, sur le nez, devant l'Arche de Yahvé. Le tronc de Dagon était resté en place, mais la tête et les deux mains lui manquaient et gisaient sur le seuil;"
,"5":"c'est d'ailleurs pour cela que les prêtres de Dagon et tous ceux qui entrent dans le temple de Dagon à Ashdod, encore aujourd'hui, ne foulent pas de leurs pieds le seuil de Dagon."
,"6":"La main de Yahvé s'abattit sur les habitants d'Ashdod, il les tourmenta et envoya des tumeurs aussi bien sur Ashdod que sur ses environs."
,"7":"Lorsque les habitants d'Ashdod virent ce qui leur arrivait, ils dirent: 'Il ne faut pas que l'Arche du Dieu d'Israël reste chez nous, car il a eu la main lourde avec nous et notre Dieu Dagon.'"
,"8":"Ils firent donc avertir tous les princes des Philistins et les réunirent chez eux. Ils leur dirent: 'Qu'allons-nous faire de l'Arche du Dieu d'Israël?' Les autres répondirent: 'L'Arche du Dieu d'Israël ira à Gat.' On emmena donc l'Arche du Dieu d'Israël."
,"9":"Or, dès qu'on l'eut amenée, la main de Yahvé se fit pesante sur la ville: ce fut une grande panique. Il frappa les habitants, du plus petit jusqu'au plus grand, et il leur sortit des tumeurs."
,"10":"Ils renvoyèrent donc l'Arche de Dieu à Ekron, mais lorsque l'Arche de Dieu arriva à Ekron, les habitants de la ville s'écrièrent: 'Ils nous ont amené l'Arche du Dieu d'Israël pour nous faire périr, nous et notre peuple!'"
,"11":"On rassembla donc tous les princes des Philistins: 'Renvoyez l'Arche du Dieu d'Israël, dirent-ils, qu'elle retourne d'où elle vient. Sinon nous allons mourir, nous et notre peuple.' Il y avait en effet une terrible panique dans toute la ville, tellement la main de Dieu s'était faite pesante."
,"12":"Ceux qui ne mouraient pas étaient frappés de tumeurs, et une grande lamentation montait de la ville jusqu'au ciel."
}`)
	CurrentBook.AddChapter(6, `{
"1":"L'Arche de Yahvé resta sept mois dans le territoire des Philistins."
,"2":"Les Philistins firent alors appel aux prêtres et aux devins: 'Que ferons-nous de l'Arche de Yahvé, dirent-ils, dites-nous comment nous devons la renvoyer à sa place.'"
,"3":"Ceux-ci répondirent: 'Si vous renvoyez l'Arche du Dieu d'Israël, ne la renvoyez pas sans rien: remettez-lui une offrande de réparation, ainsi vous guérirez et vous saurez pourquoi la main de Dieu s'était abattue sur vous.'"
,"4":"On leur demanda encore: Quelle sera la réparation que nous enverrons?' Les devins répondirent: 'Cinq tumeurs d'or et cinq souris d'or, selon le nombre des princes des Philistins, puisque c'est la même plaie qui vous a frappés, vous et vos princes."
,"5":"Faites des images de vos tumeurs, des images des souris qui ravagent votre pays, et rendez gloire au Dieu d'Israël. Peut-être sa main cessera-t-elle de vous frapper, vous, vos dieux et votre pays."
,"6":"Pourquoi vous entêter comme l'ont fait les Egyptiens et leur Pharaon? Dieu les a tellement frappés qu'ils ont bien fini par les laisser partir."
,"7":"Quant à vous, préparez maintenant un chariot neuf, prenez deux vaches qui allaitent encore et qui n'ont pas porté le joug. Vous attellerez les vaches au chariot pendant qu'on ramènera leurs petits à l'étable."
,"8":"Vous prendrez l'Arche de Yahvé et vous la déposerez sur le chariot; quant aux objets d'or que vous lui remettrez en réparation, vous les placerez dans un coffre à côté de l'Arche et vous la laisserez partir."
,"9":"Alors regardez. Si elle prend le chemin de son pays vers Beth-Chemech, c'est lui sûrement qui nous a amené ces fléaux. Sinon, nous saurons que ce n'est pas sa main qui nous a frappés, mais que tout cela nous est arrivé par hasard.'"
,"10":"On fit donc ainsi: on prit deux vaches qui allaitaient encore, on les attela au chariot et l'on ramena les petits à l'étable."
,"11":"On plaça l'Arche de Yahvé sur le chariot avec le coffre qui contenait les souris en or et les images des tumeurs."
,"12":"Les vaches prirent tout de suite la route de Beth-Chemech; elles allaient leur chemin et elles meuglaient, sans s'écarter à droite ni à gauche. Les princes des Philistins les suivirent jusqu'à la frontière de Beth-Chemech."
,"13":"Les gens de Beth-Chemech étaient en train de moissonner les blés dans la plaine. En levant les yeux, ils aperçurent l'Arche et ils allèrent tout joyeux au-devant d'elle."
,"14":"Lorsque le chariot arriva au champ de Josué de Beth-Chemech, il s'arrêta. Il y avait là une grande pierre. On fendit le bois du chariot et on offrit les vaches en holocauste à Yahvé."
,"15":"Les Lévites avaient descendu l'Arche de Yahvé avec le coffre qui était à côté d'elle et qui contenait les objets en or. Ils avaient déposé le tout sur la grande pierre. Les hommes de Beth-Chemech offrirent ce jour-là des holocaustes et des sacrifices à Yahvé."
,"16":"Les cinq princes des Philistins en furent témoins; ils s'en retournèrent le jour-même à Ekron."
,"17":"Voici la liste des tumeurs en or que les Philistins avaient offertes en réparation à Yahvé: une pour Ashdod, une pour Gaza, une pour Ashkélon, une pour Gat et une pour Ekron."
,"18":"Il y avait autant de souris d'or que de villes, en comptant les villes fortifiées des cinq princes mais aussi les villages. La grande pierre sur laquelle on avait déposé l'Arche de Yahvé en garde le souvenir: elle est encore aujourd'hui dans le champ de Josué de Beth-Chemech."
,"19":"Les fils de Yékonya, de Beth-Chemech, n'avaient pas participé à la fête quand on avait revu l'Arche de Yahvé. Yahvé en frappa soixante-dix et le peuple se mit en deuil parce que Yahvé l'avait durement corrigé."
,"20":"Alors les gens de Beth-Chemech se dirent: 'Qui pourrait tenir en face de Yahvé, le Dieu Saint? Chez qui pourrions-nous l'envoyer?'"
,"21":"Ils envoyèrent des messagers aux habitants de Kiryat-Yéarim: 'Les Philistins, dirent-ils, ont rendu l'Arche de Yahvé, descendez et prenez-la chez vous.'"
}`)
	CurrentBook.AddChapter(7, `{
"1":"Les gens de Kiryat-Yéarim vinrent et firent monter l'Arche de Yahvé. Ils l'amenèrent dans la maison d'Abinadab sur la colline, et ils consacrèrent son fils Eléazar comme gardien de l'Arche de Yahvé."
,"2":"De nombreuses années s'écoulèrent après que l'Arche fût installée à Kiryat-Yéarim: près de vingt ans. L'ensemble du peuple d'Israël se retourna alors vers Yahvé."
,"3":"Samuel déclara au peuple d'Israël tout entier: 'Si vraiment vous voulez revenir vers Yahvé, enlevez du milieu de vous les dieux étrangers et les Astartés. Fixez votre coeur sur Yahvé et ne servez plus que lui; alors il vous délivrera de la main des Philistins.'"
,"4":"Les Israélites enlevèrent donc les Baals et les Astartés pour ne plus servir que Yahvé."
,"5":"Samuel ajouta: 'Que tout Israël se rassemble à Mispa: là je ferai pour vous un appel à Yahvé.'"
,"6":"Ils se rassemblèrent donc à Mispa. Ils puisèrent de l'eau qu'ils versèrent devant Yahvé, et ils jeûnèrent tout le jour, car ils reconnaissaient: 'Nous avons péché contre Yahvé.' Et là, à Mispa, Samuel s'imposa comme chef aux Israélites."
,"7":"Quand les princes des Philistins apprirent que les Israélites s'étaient rassemblés à Mispa, ils se mirent en route pour combattre Israël. Les Israélites le surent et ils eurent peur des Philistins."
,"8":"Ils dirent donc à Samuel: 'Ne cesse pas de supplier pour nous Yahvé notre Dieu, pour qu'il nous sauve de la main des Philistins.'"
,"9":"Samuel prit alors un jeune agneau et l'offrit en holocauste à Yahvé. Samuel supplia Yahvé pour Israël, et Yahvé l'exauça."
,"10":"Pendant que Samuel offrait le sacrifice, les Philistins s'approchèrent pour combattre Israël, mais ce jour-là Yahvé tonna à grand fracas contre les Philistins. Ils prirent la fuite et furent battus par Israël."
,"11":"Les Israélites sortirent de Mispa et poursuivirent les Philistins, ils les battirent jusqu'au dessous de Beth-Kar."
,"12":"Samuel prit alors une pierre qu'il plaça entre Mispa et la Yéchana, il l'appela du nom d'Eben-Ha-Ezer, car, dit-il: 'C'est jusqu'ici que Yahvé nous a porté secours.'"
,"13":"Les Philistins avaient été humiliés, ils ne revinrent plus sur le territoire d'Israël. La main de Yahvé pesa sur les Philistins durant toute la vie de Samuel:"
,"14":"Israël récupéra les villes que les Philistins lui avaient prises depuis Ekron jusqu'à Gat, Israël délivra leur territoire de la main des Philistins. Il y eut alors la paix entre Israël et les Amorites."
,"15":"Samuel fut le chef d'Israël durant toute sa vie."
,"16":"Chaque année il faisait la tournée de Béthel, Guilgal et Mispa, et de là il gouvernait Israël."
,"17":"Ensuite il revenait à Rama où se trouvait sa maison, et là encore il gouvernait Israël. A Rama il éleva un autel à Yahvé."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Lorsque Samuel prit de l'âge, il établit ses fils comme juges d'Israël."
,"2":"L'aîné s'appelait Yoël et le plus jeune Abiya, ils gouvernaient à Bersabée."
,"3":"Mais ses fils ne suivirent pas son exemple, ils étaient attirés par l'argent et, au lieu de rendre la justice, ils acceptaient des cadeaux."
,"4":"Tous les anciens d'Israël se donnèrent rendez-vous chez Samuel à Rama."
,"5":"Ils lui dirent: 'Tu es devenu vieux et tes fils ne marchent pas sur tes traces, il est temps que tu nous donnes un roi pour qu'il nous gouverne comme le font toutes les nations.'"
,"6":"Voilà qui déplut à Samuel: 'Donne-nous un roi pour qu'il nous gouverne!' Samuel se tourna donc vers Yahvé,"
,"7":"et Yahvé dit à Samuel: 'Ecoute tout ce que te dit ce peuple, car ce n'est pas toi qu'ils ont rejeté, c'est moi. Ils ne veulent plus que je règne sur eux."
,"8":"Ils agissent avec toi comme ils ont toujours agi avec moi, depuis le jour où je les ai fait sortir d'Egypte, quand ils m'abandonnaient et servaient des dieux étrangers."
,"9":"Réponds à leur demande, mais dis-leur bien quel sera le droit du roi qui régnera sur eux.'"
,"10":"Samuel rapporta aux gens qui lui avaient demandé un roi, toutes les paroles de Yahvé."
,"11":"Puis il leur dit: 'Voici quel sera le droit du roi qui régnera sur vous: il prendra vos fils pour s'occuper de ses chars et de ses chevaux, et ils courront devant son char."
,"12":"Il les prendra comme chefs de mille et chefs de cinquante, ils les prendra pour labourer ses champs, pour récolter sa moisson, pour fabriquer ses armes de guerre et les harnais de ses chars."
,"13":"Vos filles, il les prendra pour en faire ses parfumeuses, ses cuisinières ou ses boulangères."
,"14":"Il prendra les meilleurs de vos champs, de vos vignes et de vos oliviers et il les donnera à ses serviteurs."
,"15":"Il prélèvera le dixième de vos récoltes et de vos raisins, pour le donner à ses eunuques et à ses serviteurs."
,"16":"Il prendra les meilleurs de vos serviteurs, de vos servantes, de vos jeunes gens, de vos ânes, et il les utilisera pour ses travaux."
,"17":"Il prélèvera le dixième de votre petit bétail et vous, vous serez ses esclaves."
,"18":"Alors vous viendrez vous plaindre à cause du roi que vous aurez choisi, mais ce jour-là Yahvé ne vous répondra pas.'"
,"19":"Le peuple refusa d'écouter Samuel. Ils lui dirent: 'Non, nous voulons un roi."
,"20":"Nous serons nous aussi comme toutes les nations, notre roi nous gouvernera; il marchera à notre tête et conduira nos guerres.'"
,"21":"Samuel entendit toutes les paroles du peuple et les rapporta aux oreilles de Yahvé."
,"22":"Yahvé dit alors à Samuel: 'Ecoute ce peuple et donne-leur un roi.' Et Samuel dit aux hommes d'Israël: 'Que chacun retourne dans sa ville.'"
}`)
	CurrentBook.AddChapter(9, `{
"1":"Il y avait un homme qui s'appelait Kich, fils d'Abiel, fils de Séror, fils de Békorat, fils d'Afiah, de la tribu de Benjamin. Il vivait à Guibéa de Benjamin et c'était un homme de valeur."
,"2":"Saül, son fils, était jeune et beau, on n'aurait pas trouvé un plus bel homme en Israël: il les dépassait tous de la hauteur d'une tête."
,"3":"Les ânesses de Kich, le père de Saül, s'étaient égarées, et Kich dit à son fils Saül: 'Prends avec toi l'un des serviteurs et pars à la recherche des ânesses.'"
,"4":"Ils allèrent à la montagne d'Ephraïm et traversèrent le pays de Chalicha: ils ne trouvèrent rien. Ils traversèrent encore le pays de Chaalim, elles n'y étaient pas non plus. Ils parcoururent alors le pays de Benjamin sans rien trouver."
,"5":"Quand ils arrivèrent au pays de Souf, Saül dit à son serviteur: 'Allons, retournons, notre père va maintenant s'inquiéter davantage de nous que des ânesses.'"
,"6":"Le serviteur répondit: 'Il y a dans cette ville un homme de Dieu. Cet homme est très estimé, tout ce qu'il prédit arrive. Allons le trouver, peut-être nous indiquera-t-il le chemin que nous devons prendre.'"
,"7":"Saül dit au garçon: 'Si nous y allons, que pourrons-nous offrir à cet homme? Nous n'avons plus de pain dans nos sacs et nous n'avons pas de cadeau à offrir à cet homme de Dieu. Que pourrons-nous lui donner?'"
,"8":"Le serviteur répondit à Saül: 'J'ai encore un quart de sicle d'argent, je le donnerai à cet homme de Dieu pour qu'il nous indique notre chemin.'"
,"10":"Saül dit à son serviteur: 'Tu as raison, allons-y.' Et ils se dirigèrent vers la ville où se trouvait l'homme de Dieu."
,"11":"Sur le chemin qui montait à la ville, ils rencontrèrent des jeunes filles qui sortaient pour puiser de l'eau. Ils leur demandèrent: 'Le voyant est-il là?'"
,"9":"Car autrefois en Israël on disait: 'Allons chez le voyant' pour dire qu'on allait consulter Dieu. Car on ne parlait pas de prophètes comme aujourd'hui, mais de voyants."
,"12":"Elles répondirent: 'Oui, il est là. Il est arrivé un peu avant vous; il vient d'arriver en ville, car il y a aujourd'hui un sacrifice pour le peuple sur le Haut-Lieu."
,"13":"Dès que vous entrerez dans la ville, allez le trouver avant qu'il ne monte au Haut-Lieu pour le repas, car le peuple ne mangera pas avant son arrivée. C'est lui qui doit offrir le sacrifice et les invités mangeront après. Montez donc tout de suite, vous le trouverez.'"
,"14":"Ils prirent le chemin de la ville et, comme ils entraient, Samuel vint à leur rencontre: il sortait pour gagner le Haut-Lieu."
,"15":"Or, la veille de la venue de Saül, Yahvé avait fait une révélation à Samuel:"
,"16":"'Demain à cette heure je t'enverrai un homme du pays de Benjamin, tu le consacreras comme chef de mon peuple Israël. Cet homme va sauver mon peuple de la main des Philistins, car j'ai vu la misère de mon peuple et son cri est monté jusqu'à moi.'"
,"17":"Lorsque Samuel aperçut Saül, Yahvé lui dit: 'Voici l'homme dont je t'ai parlé, c'est lui qui gouvernera mon peuple.'"
,"18":"Saül s'avança vers Samuel au milieu de la porte et lui demanda: 'Pourrais-tu m'indiquer où est la maison du voyant?'"
,"19":"Samuel répondit à Saül: 'Je suis le voyant, monte donc devant moi vers le Haut-Lieu. Vous mangerez aujourd'hui avec moi, et demain je te dirai tout ce qui te préoccupe; ensuite je te laisserai partir."
,"20":"Ne t'inquiète surtout pas des ânesses que tu as perdues depuis trois jours: elles sont retrouvées. Mais sais-tu qui va se retrouver avec toute la richesse d'Israël? Peut-être bien toi et la maison de ton père?'"
,"21":"Saül répondit: 'Je suis de la tribu de Benjamin, la plus petite des tribus d'Israël, et dans la tribu de Benjamin ma famille est la plus petite. Pourquoi me dis-tu de telles paroles?'"
,"22":"Samuel fit entrer Saül et son serviteur dans la salle où se trouvaient une trentaine d'invités, et là il leur donna la première place."
,"23":"Puis Samuel dit au cuisinier: 'La part que je t'avais donnée en te disant de la mettre de côté, sers-la maintenant.'"
,"24":"Le cuisinier préleva donc le gigot et tout ce qui l'entourait et le plaça devant Saül. Samuel lui dit: 'Tu as devant toi la part que l'on a mise de côté, mange-la.' Et ce jour-là Saül mangea avec Samuel."
,"25":"Quand ils redescendirent du Haut-Lieu vers la ville, on prépara un lit pour Saül sur la terrasse"
,"26":"et il se coucha. Au petit matin Samuel appela Saül sur la terrasse et lui dit: 'Lève-toi, je vais te mettre sur ta route.' Saül se leva et tous deux, lui et Samuel, sortirent dehors."
,"27":"Comme ils approchaient de la sortie de la ville, Samuel dit à Saül: 'Dis à ton serviteur de passer devant nous, mais toi, reste-là pour que je te fasse entendre la parole de Dieu.'"
}`)
	CurrentBook.AddChapter(10, `{
"1":"Samuel prit son flacon d'huile et le versa sur la tête de Saül, puis il l'embrassa et lui dit: 'Yahvé t'a consacré comme chef de son peuple d'Israël. C'est toi qui gouverneras le peuple de Yahvé et tu le délivreras de la main de ses ennemis. Veux-tu être sûr que Yahvé t'a consacré comme chef de son héritage? Voici des signes:"
,"2":"Aujourd'hui même, après que tu m'auras quitté, tu rencontreras deux hommes près de la tombe de Rachel, sur le territoire de Benjamin; ils te diront: On a retrouvé les ânesses que tu étais parti chercher; ton père ne se préoccupe plus maintenant des ânesses mais de vous, et il se demande que faire pour son fils."
,"3":"Tu continueras ton chemin et tu arriveras au Chêne-de-Tabor. Là tu rencontreras trois hommes qui s'en vont au sanctuaire de Dieu, à Béthel. L'un portera trois chevreaux, l'autre, trois boules de pain, et le dernier, une outre de vin."
,"4":"Ils te salueront et te donneront deux pains que tu accepteras de leur part."
,"5":"Ensuite tu arriveras à Guibéa-de-Dieu, où il y a un commissaire Philistin. Aussitôt entré en ville, tu croiseras une bande de prophètes qui descendent du Haut-Lieu avec harpes, tambourins, flûtes et cithares, tous en train de prophétiser."
,"6":"Alors l'esprit de Yahvé fondra sur toi et tu deviendras un autre homme."
,"7":"Lorsque ces signes se seront accomplis, tu agiras pour le mieux, car Dieu est avec toi."
,"8":"Tu me précéderas à Guilgal et moi, je t'y rejoindrai pour offrir des holocaustes et des sacrifices de communion. Tu m'y attendras sept jours, et je te ferai savoir alors ce que tu devras faire.'"
,"9":"Saül avait à peine tourné le dos pour quitter Samuel, que Dieu lui changea le coeur et le jour même tous ces signes s'accomplirent."
,"10":"En arrivant à Guibéa, Saül et son serviteur rencontrèrent la bande de prophètes: l'esprit de Dieu s'empara de lui et il se mit à prophétiser au milieu d'eux."
,"11":"En le voyant prophétiser avec les prophètes, tous ceux qui le connaissaient auparavant se dirent les uns aux autres: 'Qu'est-ce qui est arrivé au fils de Kich? Saül est-il entré chez les prophètes?'"
,"12":"L'un d'entre eux répondit: 'Des gens dont le père n'est rien!' Et c'est ainsi qu'est venu ce proverbe: 'Saül est entré chez les prophètes!'"
,"13":"Après qu'il eût fini de prophétiser, il rentra à la maison."
,"14":"Son oncle lui demanda, comme à son serviteur: 'Où êtes-vous donc allés?' Il répondit: 'Nous avons couru à la recherche des ânesses et nous ne les avons pas trouvées, alors nous sommes allés trouver Samuel.'"
,"15":"Son oncle lui dit: 'Raconte-moi ce que vous a dit Samuel.'"
,"16":"Saül répondit à son oncle: 'Il nous a dit simplement que les ânesses étaient retrouvées.' Il ne parla pas de ce que Samuel avait dit au sujet de la royauté."
,"17":"Samuel convoqua le peuple près de Yahvé à Mispa."
,"18":"Il dit aux Israélites: 'Voici ce que dit Yahvé, le Dieu d'Israël: C'est moi qui ai fait sortir Israël d'Egypte, c'est moi qui vous ai délivrés de la main des Egyptiens et de la main de tous les rois qui vous opprimaient."
,"19":"Mais maintenant vous en avez assez de votre Dieu qui vous a sauvés de tous vos malheurs et de toutes vos détresses; vous lui avez dit: Cela suffit, donne-nous un roi! Maintenant donc, présentez-vous devant Yahvé par tribu et par famille.'"
,"20":"Samuel fit alors approcher toutes les tribus d'Israël et la tribu de Benjamin fut désignée par le sort."
,"21":"Il fit approcher les différentes familles de la tribu de Benjamin, et la famille de Matri fut désignée par le sort. Il fit approcher les hommes de la famille de Matri, et Saül, fils de Kish, fut désigné par le sort. On le chercha mais on ne le trouva pas."
,"22":"Alors on demanda une réponse à Yahvé: 'Saül est-il venu ici?' Yahvé répondit: 'Il est allé se cacher là où sont les bagages.'"
,"23":"On courut donc et on le fit sortir de là pour le présenter au peuple: il dépassait tout le monde de la hauteur de la tête!"
,"24":"Samuel dit à tout le peuple: 'Voyez celui que Yahvé a choisi. Il n'y a personne comme lui dans tout le peuple.' Et tous poussèrent des acclamations en criant: 'Vive le roi!'"
,"25":"Samuel dit alors au peuple le droit du roi et il l'inscrivit dans le livre qu'il déposa devant Yahvé; puis Samuel renvoya tout le peuple, chacun chez soi."
,"26":"Saül aussi rentra chez lui à Guibéa et les hommes courageux dont Dieu avait touché le coeur partirent avec lui."
,"27":"Mais des gens de rien répliquèrent: 'Ce n'est pas celui-là qui nous délivrera!' Ils le méprisèrent et ne lui offrirent point de cadeau."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Environ un mois plus tard, Nahach l'Ammonite vint établir son camp contre Yabesh de Galaad. Tous les gens de Yabesh dirent à Nahach: 'Fais la paix avec nous et nous te servirons.'"
,"2":"Mais Nahach l'Ammonite répondit: 'Voici à quelle condition je ferai la paix avec vous: je vous crèverai à tous l'oeil droit, et ce sera une humiliation pour tout Israël.'"
,"3":"Les anciens de Yabech lui dirent: 'Laisse-nous un répit de sept jours pour que nous envoyions des messagers dans tout le pays d'Israël. Et si personne ne vient nous délivrer, nous nous rendrons à toi.'"
,"4":"Les messagers arrivèrent à Guibéa de Saül et rapportèrent au peuple toute cette affaire: tout le peuple poussa une grande lamentation et pleura."
,"5":"Or c'était le moment où Saül rentrait de la campagne derrière ses boeufs. Il demanda: 'Pourquoi le peuple pleure-t-il ainsi?' Et on lui répéta les paroles des gens de Yabesh."
,"6":"Quand Saül entendit ces paroles, l'esprit de Dieu fondit sur lui et il se mit en colère."
,"7":"Il prit une paire de boeufs, il la dépeça et en fit porter les morceaux dans tout le territoire d'Israël par les messagers de Yabesh; ils étaient chargés de dire: 'Celui qui ne marchera pas à la suite de Saül et à la suite de Samuel, je lui ferai ce que j'ai fait à ces boeufs.' Alors la crainte de Yahvé s'empara de tout le peuple et tous marchèrent comme un seul homme."
,"8":"Saül les passa en revue à Bézek, les Israélites étaient trois cent mille et les hommes de Juda trente mille."
,"9":"On donna donc cette réponse aux messagers qui étaient venus: 'Voici ce que vous direz aux gens de Yabesh de Galaad: Demain, lorsque le soleil commencera à chauffer, vous recevrez du secours.' Les messagers rapportèrent cette nouvelle aux gens de Yabech qui en furent tout heureux."
,"10":"Aussitôt ils dirent à Nahach: 'Demain nous nous rendrons à toi et tu nous feras tout ce qui te semble bon.'"
,"11":"Le lendemain Saül répartit le peuple en trois groupes qui envahirent le camp des Ammonites au petit matin et les combattirent jusqu'au plus chaud du jour. Ceux qui échappèrent se dispersèrent et il n'en resta pas deux ensemble."
,"12":"Le peuple dit alors à Samuel: 'Qui osait dire: Saül ne régnera pas sur nous.? Livrez-nous ces hommes pour que nous les mettions à mort.'"
,"13":"Mais Samuel répondit: 'Personne ne sera mis à mort aujourd'hui, car c'est un jour où Yahvé a sauvé Israël.'"
,"14":"Samuel ajouta: 'Venez et rendons-nous à Guilgal: nous allons inaugurer la royauté.'"
,"15":"Tout le peuple se réunit à Guilgal et Saül y fut proclamé roi devant Yahvé. On offrit à Yahvé des sacrifices de communion, et ce fut une très grande fête pour Saül et tous les Israélites."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Samuel dit à tout Israël: 'Je vous ai écoutés, j'ai fait tout ce que vous m'avez demandé et je vous ai donné un roi."
,"2":"Que le roi, maintenant, prenne la direction de vos affaires, car je suis vieux, j'ai blanchi, et ce sont mes fils aujourd'hui qui sont avec vous. Depuis ma jeunesse et jusqu'à ce jour j'ai marché à votre tête; "
,"3":"alors, dites et soyez témoins devant Yahvé et devant celui qu'il a choisi: ai-je pris le boeuf ou l'âne de l'un d'entre vous? Ai-je volé ou maltraité quelqu'un? Ai-je accepté un cadeau pour fermer les yeux sur la conduite de l'un d'entre vous? Je suis prêt à le rendre.'"
,"4":"Tous répondirent: 'Tu ne nous as jamais maltraités, tu n'as volé aucun d'entre nous et tu n'as accepté de cadeau de la main de personne.'"
,"5":"Samuel leur dit: 'Donc Yahvé est témoin, et celui qu'il vient de choisir en est aujourd'hui le témoin: vous n'avez rien à me reprocher.' Ils lui répondirent: 'Ils sont témoins.'"
,"6":"Alors Samuel dit au peuple: 'Que Yahvé soit donc témoin, lui qui vous a donné Moïse et Aaron et qui a fait sortir vos pères du pays d'Egypte."
,"7":"Venez donc avec moi aujourd'hui au tribunal de Yahvé: je veux vous rappeler tous les bienfaits de Yahvé pour vous et pour vos pères."
,"8":"Lorsque Jacob arriva en Egypte, les Egyptiens les opprimèrent et vos pères crièrent vers Yahvé. Alors il envoya Moïse et Aaron pour faire sortir vos pères d'Egypte et les installer en ce lieu."
,"9":"Après cela ils oublièrent Yahvé leur Dieu et il les livra entre les mains de Siséra, le général de l'armée d'Hasor, entre les mains des Philistins et du roi de Moab qui leur firent la guerre."
,"10":"Alors ils crièrent vers Yahvé: Nous avons péché et nous avons abandonné Yahvé. Nous avons servi les Baals et les Astartés, maintenant délivre-nous de la main de nos ennemis et nous te servirons."
,"11":"Yahvé vous a alors donné Yéroubbaal, Barac, Jephté et Samuel, il vous a délivrés de vos ennemis et vous a redonné la paix."
,"12":"Cependant, lorsque vous avez vu Nahach, roi des Ammonites, se mettre en campagne contre vous, vous m'avez dit: Non! Il nous faut un roi qui règne sur nous. Yahvé pourtant, votre Dieu, régnait sur vous."
,"13":"Mais maintenant Yahvé vous a donné le roi que vous-mêmes avez choisi."
,"14":"Si vous craignez Yahvé et que vous le servez, si vous lui obéissez sans vous révolter contre ses ordres, si vous-mêmes et le roi qui règne sur vous suivez Yahvé votre Dieu, tout ira bien."
,"15":"Mais si vous n'obéissez pas à Yahvé, si vous vous révoltez contre ses ordres, la main de Yahvé pèsera sur vous et sur votre roi."
,"16":"Restez encore ici et regardez le prodige que Yahvé va accomplir sous vos yeux."
,"17":"N'est-ce pas le temps de la moisson des blés? Eh bien, je vais invoquer Yahvé et il enverra tonnerre et pluie. Alors vous devrez comprendre que vous avez commis un grand péché au regard de Yahvé en demandant pour vous un roi.'"
,"18":"Samuel invoqua Yahvé et Yahvé envoya ce même jour des tonnerres et de la pluie. Tout le peuple fut rempli de crainte devant Yahvé et devant Samuel."
,"19":"Le peuple disait à Samuel: 'Intercède auprès de Yahvé ton Dieu pour tes serviteurs, pour que nous ne mourrions pas, car en demandant un roi nous avons mis le comble à tous nos péchés.'"
,"20":"Samuel dit au peuple: 'Ne craignez pas. Certes, vous avez commis cette faute, mais ne vous détournez plus de Yahvé et servez Yahvé de tout votre coeur."
,"21":"Si vous vous détournez de lui, qui suivrez-vous? Des idoles qui ne sont rien, qui ne valent rien, qui sont incapables de vous sauver car elles ne sont rien."
,"22":"Mais Yahvé ne rejettera pas son peuple car ce serait faire tort à son grand Nom après qu'il a fait de vous son propre peuple."
,"23":"Quant à moi, si je cessais de prier pour vous, je pécherais contre Yahvé; je vous enseignerai le bon et le droit chemin."
,"24":"Mais vous, craignez Yahvé, servez-le sincèrement, du fond de votre coeur, maintenant que vous l'avez vu faire de si grandes choses."
,"25":"Si vous faites le mal, vous périrez sûrement, vous et votre roi."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Saül était roi et il gouvernait Israël."
,"2":"Il se choisit trois mille hommes parmi les Israélites; deux mille étaient avec lui à Mikmas ainsi que dans la montagne de Béthel, et il confia les mille qui restaient à Jonathan, à Guibéa de Benjamin. Quant aux autres, Saül les renvoya chacun sous sa tente."
,"3":"Jonathan tua le chef des Philistins qui se trouvait à Guibéa et les Philistins apprirent la nouvelle. Saül fit alors sonner du cor dans tout le pays pour dire: 'Que les Hébreux le sachent!'"
,"4":"Et tout Israël sut la nouvelle: 'Saül a tué le chef des Philistins, Israël s'est rendu odieux aux Philistins.' Le peuple aussitôt se rassembla derrière Saül à Guilgal."
,"5":"Les Philistins se regroupèrent pour combattre Israël. Ils avaient trois mille chars et six mille cavaliers, leur peuple était nombreux comme le sable sur le rivage de la mer. Il montèrent camper à Mikmas, à l'est de Beth-Aven."
,"6":"Les Israélites se virent en péril à mesure qu'ils étaient refoulés; ils se cachèrent dans les cavernes, les broussailles, les rochers, les grottes et les citernes."
,"7":"Certains Hébreux traversèrent le Jourdain vers Gad et le pays de Galaad. Saül attendait encore à Guilgal, mais tout le peuple tremblait derrière lui."
,"8":"Saül attendit sept jours selon le temps fixé par Samuel, Samuel ne venait toujours pas à Guilgal et les gens commençaient à se disperser."
,"9":"Alors Saül dit: 'Amenez-moi l'holocauste et les sacrifices de communion.' Et il offrit l'holocauste."
,"10":"Il achevait à peine d'offrir l'holocauste lorsque Samuel arriva. Saül vint à sa rencontre pour le saluer."
,"11":"Samuel lui dit: 'Qu'as-tu fait?' Et Saül lui répondit: 'J'ai vu que les gens commençaient à se disperser car tu n'arrivais pas à la date prévue, et déjà les Philistins se rassemblaient à Mikmas."
,"12":"Alors je me suis dit: Les Philistins vont descendre sur moi à Guilgal sans que j'aie même eu le temps d'implorer Yahvé. C'est pourquoi j'ai pris sur moi d'offrir l'holocauste.'"
,"13":"Samuel dit à Saül: 'Tu t'es comporté comme un insensé: si tu avais observé le commandement que Yahvé ton Dieu t'avait donné, il aurait assuré ta royauté sur Israël pour toujours."
,"14":"Maintenant ta royauté ne tiendra pas: Yahvé a déjà cherché un homme selon son coeur pour l'établir comme chef sur son peuple, parce que tu n'as pas observé les commandements de Yahvé.'"
,"15":"Samuel s'en alla donc, il quitta Guilgal et alla son chemin. Le reste du peuple monta derrière Saül à la rencontre des ennemis. De Guilgal il monta à Guibéa de Benjamin où Saül passa en revue les gens qui se trouvaient avec lui, ils étaient environ six cents."
,"16":"Saül, son fils Jonathan et les gens qui étaient avec eux, restèrent à Guibéa de Benjamin tandis que les Philistins campaient à Mikmas."
,"17":"Une troupe sortit du camp des Philistins, divisée en trois corps. Un corps se dirigea sur la route d'Ofra, au pays de Choual,"
,"18":"un autre corps prit la direction de Beth-Horon et le troisième la direction de la colline qui domine la vallée des Hyènes, vers le désert."
,"19":"En ce temps-là il n'y avait pas de forgeron dans tout le pays d'Israël, car les Philistins s'étaient dit: 'Il ne faut pas que les Hébreux se fabriquent des épées ou des lances.'"
,"20":"C'est pour cela que tous les Israélites descendaient chez les Philistins pour affûter leur soc, leur hache, leur faux ou leur binette."
,"21":"Pour aiguiser les socs et les lames, on payait deux tiers de sicle; pour affûter les haches ou redresser les aiguillons, on payait un tiers de sicle."
,"22":"C'est ainsi qu'au jour du combat aucun des hommes qui étaient avec Saül et Jonathan n'avait en main lance ou épée. Seuls Saül et Jonathan avaient des armes."
,"23":"Un poste de Philistins était parti pour la passe de Mikmas."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Jonathan, le fils de Saül, dit au jeune homme qui portait ses armes: 'Allons et passons vers le poste des Philistins qui est de l'autre côté.' Mais il ne dit rien à son père."
,"2":"Or Saül siégeait à la frontière de Guibéa, sous le grenadier qui est près de l'aire, et avec lui se tenaient environ six cents hommes."
,"3":"Ahiya, fils d'Ahitoub, frère d'Ikabod, fils de Pinhas, fils d'Héli, qui était prêtre de Yahvé à Silo, portait l'éphod. Personne dans la troupe ne remarqua que Jonathan était parti."
,"4":"De chaque côté du défilé que Jonathan cherchait à traverser pour atteindre le poste philistin, il y avait un rocher: l'un était le rocher de Bosès et l'autre s'appelait Senné."
,"5":"Le premier rocher se trouve au nord, en face de Mikmas, le second au sud face à Guéba."
,"6":"Jonathan dit au jeune homme qui portait ses armes: 'Allons et traversons vers le poste de ces incirconcis. Peut-être Yahvé fera-t-il quelque chose pour nous, car rien n'arrête Yahvé. Qu'on soit beaucoup ou très peu, il peut toujours délivrer.'"
,"7":"Le jeune homme répondit: 'Fais à ton idée pour le mieux, je suis avec toi et tu décides.'"
,"8":"Jonathan lui dit: 'Ecoute, nous passerons vers ces hommes et nous nous montrerons à eux."
,"9":"S'ils nous disent: Arrêtez-vous, attendez que nous venions!, nous resterons sur place et nous ne monterons pas vers eux."
,"10":"Mais s'ils nous disent: Montez vers nous!, nous monterons. Ce sera le signe que Yahvé les a livrés entre nos mains.'"
,"11":"Ils se montrèrent donc tous les deux au poste des Philistins. Ceux-ci pensèrent: 'Voici des Hébreux qui sortent des trous où ils se cachaient.'"
,"12":"Les hommes du poste s'adressèrent à Jonathan et au jeune homme qui portait ses armes, ils leur dirent: 'Montez vers nous, nous avons quelque chose à vous apprendre.' Jonathan dit à son compagnon: 'Monte derrière moi, car Yahvé les a livrés entre les mains d'Israël.'"
,"13":"Jonathan monta en escaladant avec les mains et les pieds et son compagnon le suivit. Les Philistins tombaient devant Jonathan et son compagnon les achevait derrière lui."
,"14":"Jonathan et son compagnon firent là un premier massacre: une vingtaine d'hommes tombèrent sur un terrain qui mesurait à peine un arpent."
,"15":"La terreur se répandit dans le camp, dans la campagne et dans tout le peuple. Le poste et la troupe des guerriers furent saisis de peur eux aussi, la terre trembla, c'était comme une terreur venant de Dieu."
,"16":"Les sentinelles de Saül qui étaient à Guibéa de Benjamin virent que le camp des Philistins se dispersait de tous côtés."
,"17":"Alors Saül dit à ceux qui étaient avec lui: 'Passez en revue le peuple et voyez qui est parti de chez nous.' On passa le peuple en revue et il ne manquait que Jonathan et le jeune homme qui portait ses armes."
,"18":"Saül dit à Ahiya: 'Apporte l'éphod.' C'était lui en effet qui portait l'éphod en présence d'Israël."
,"19":"Mais pendant que Saül parlait au prêtre, la confusion allait en grandissant dans le camp des Philistins. Finalement Saül dit au prêtre: 'Retire ta main.' "
,"20":"Puis Saül et toutes les troupes se rassemblèrent et arrivèrent au lieu du combat. Il y avait là une énorme panique: ils tiraient leur épée les uns contre les autres."
,"21":"Les Hébreux qui s'étaient mis au service des Philistins et qui étaient montés avec eux au camp, se retournèrent pour se joindre aux Israélites qui étaient avec Saül et Jonathan."
,"22":"Tous les Israélites qui s'étaient cachés dans la montagne d'Ephraïm se lancèrent à leur tour à la poursuite des Philistins qui s'enfuyaient devant eux."
,"23":"Ce jour-là Yahvé donna la victoire à Israël. La bataille s'étendit au-delà de Beth-Aven. "
,"24":"Au moment où les Israélites étaient serrés de tous côtés, Saül avait déclaré solennellement devant tout le peuple: 'Maudit soit celui qui mangera quelque chose avant le soir, avant que j'aie tiré vengeance de mes ennemis!' Et tout le peuple était resté à jeun."
,"25":"Or on trouva du miel sur le terrain."
,"26":"Le peuple entra dans la forêt et vit ce miel qui coulait. Nul d'entre eux ne porta la main à sa bouche, car le peuple se rappelait la malédiction prononcée par le roi."
,"27":"Mais Jonathan n'avait pas entendu le serment de son père; il avança le bout de son bâton, le plongea dans le rayon de miel et le ramena à sa bouche: ses yeux s'éclaircirent."
,"28":"Quelqu'un de l'armée lui dit: 'Ton père a déclaré solennellement devant tout le peuple: Maudit soit celui qui mangera quelque chose aujourd'hui.'"
,"29":"Jonathan répondit: 'Mon père a fait bien du tort au pays; regardez donc comme mes yeux se sont éclaircis depuis que j'ai goûté un peu de miel."
,"30":"Si aujourd'hui tout le peuple avait pris sur le butin de ses ennemis de quoi manger, la défaite des Philistins aurait sûrement été plus grande.'"
,"31":"Ce jour-là on écrasa les Philistins de Mikmas jusqu'à Ayyalon, mais le peuple était à bout de forces."
,"32":"Le peuple alors se jeta sur le butin, il prit du petit bétail, des boeufs, des veaux, les immola à même la terre et se mit à manger au-dessus du sang."
,"33":"On avertit Saül: 'Le peuple est en train de pécher contre Yahvé: les gens mangent la viande au-dessus du sang.' Saül s'écria: 'Vous êtes tous des infidèles! Roulez ici une grande pierre.'"
,"34":"Puis Saül ajouta: 'Dispersez-vous au milieu du peuple et dites-leur que chacun amène ici son boeuf ou son mouton. Vous les immolerez et vous les mangerez, mais ne péchez pas contre Yahvé en mangeant la viande au-dessus du sang.' Chacun amena donc ce qu'il avait sous la main ce soir-là: ils firent l'immolation en ce lieu."
,"35":"Saül y construisit un autel à Yahvé, ce fut le premier autel qu'il lui construisit."
,"36":"Saül dit encore: 'Descendons à la poursuite des Philistins pendant la nuit, pillons-les jusqu'à ce que brille l'aube et ne laissons personne en vie parmi eux.' On lui répondit: 'Fais à ton idée!' Le prêtre dit alors: 'Il nous faut consulter Dieu.'"
,"37":"Saül consulta Dieu: 'Dois-je descendre à la poursuite des Philistins? Les livreras-tu entre les mains d'Israël?' Mais ce jour-là Dieu ne lui répondit pas."
,"38":"Alors Saül dit: 'Approchez vous tous, chefs du peuple, regardez et vérifiez en quoi a consisté le péché."
,"39":"Je le jure par la vie de Yahvé qui vient de délivrer Israël: même si c'est mon fils Jonathan qui a péché, il mourra.' Dans tout le peuple nul ne lui répondit."
,"40":"Alors il dit à tout Israël: 'Vous, vous serez d'un côté, moi et mon fils Jonathan, nous nous mettrons de l'autre.' Le peuple dit à Saül: 'Fais à ton idée!'"
,"41":"Saül demanda à Yahvé: 'Dieu d'Israël, pourquoi n'as-tu pas répondu à ton serviteur aujourd'hui? Si cette faute se trouve en moi ou en mon fils Jonathan, donne les Ourim. Mais si cette faute se trouve du côté de ton peuple Israël, donne les Toumim.' Jonathan et Saül furent désignés tandis que le peuple était épargné."
,"42":"Saül dit: 'Jetez le sort entre moi et mon fils Jonathan.' Et Jonathan fut désigné."
,"43":"Alors Saül dit à Jonathan: 'Dis-moi ce que tu as fait.' Jonathan répondit: 'J'ai simplement goûté un peu de miel au bout du bâton que j'avais dans la main, mais je suis prêt à mourir.'"
,"44":"Saül répondit: 'Que Dieu me maudisse, et me maudisse encore si tu ne meurs pas, Jonathan!'"
,"45":"Mais le peuple dit à Saül: 'Jonathan va-t-il mourir, lui qui a donné une si grande victoire à Israël? Il n'en est pas question! Par la vie de Yahvé, il ne tombera pas à terre un seul des cheveux de sa tête, car c'est avec Dieu qu'il a agi en ce jour.' C'est ainsi que le peuple sauva la tête de Jonathan."
,"46":"Saül cessa de poursuivre les Philistins; il remonta cependant que les Philistins s'en retournaient chez eux."
,"47":"Saül avait affermi sa royauté sur Israël; il combattit contre tous ses ennemis: Moab, les fils d'Ammon, Edom, les rois de Soba et les Philistins. Partout où il se tournait, il était vainqueur."
,"48":"Il écrasa Amalec au cours d'une grande expédition, et il délivra Israël des attaques des pillards."
,"49":"Les fils de Saül étaient Jonathan, Ichyo et Malki-Choua. Il eut deux filles, l'aînée s'appelait Mérob et la seconde Mikal."
,"50":"La femme de Saül était Ahinoam, fille d'Ahimaas. Le chef de son armée se nommait Abner, il était fils de Ner, l'oncle de Saül."
,"51":"Kich, le père de Saül, et Ner, le père d'Abner, étaient fils d'Abiel."
,"52":"Durant toute la vie de Saül on eut une guerre acharnée contre les Philistins. Chaque fois que Saül voyait un homme solide et courageux, il l'attachait à son service."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Samuel dit à Saül: 'Yahvé m'a envoyé pour te consacrer comme roi de son peuple Israël. Maintenant, écoute Yahvé."
,"2":"Voici ce que dit Yahvé des armées: Je veux punir Amalec pour ce qu'il a fait à Israël lorsqu'il remontait d'Egypte: il lui a barré la route."
,"3":"Va donc frapper Amalec et jette l'anathème sur tout ce qui est à lui. Tu n'auras pas de pitié pour lui, tu mettras à mort les hommes, les femmes, les enfants, les nourrissons, les boeufs et les moutons, les chameaux et les ânes.'"
,"4":"Saül rassembla le peuple et le passa en revue à Télam: il y avait deux cent mille hommes de pied, dont dix mille de Juda."
,"5":"Saül s'avança jusqu'à la ville d'Amalec et se cacha dans le ravin."
,"6":"Saül dit alors aux Kénites: 'Eloignez-vous, séparez-vous des Amalécites, sinon vous serez exterminés avec eux alors que vous avez montré de la bonté à l'égard des Israélites lorsqu'ils montaient d'Egypte.' Les Kénites s'éloignèrent donc des Amalécites."
,"7":"Saül écrasa Amalec depuis Havila jusqu'à Chour qui est à l'est de l'Egypte."
,"8":"Il fit prisonnier Agag, le roi des Amalécites, et passa tout le peuple au fil de l'épée en raison de l'anathème."
,"9":"Mais Saül et son armée refusèrent de vouer à l'anathème Agag et le meilleur du petit et du gros bétail, les bêtes grasses et les agneaux, en un mot, tout ce qui était bon. Par contre ils vouèrent à l'anathème tout ce qui, dans le troupeau, était mauvais et sans valeur."
,"10":"Une parole de Yahvé fut alors adressée à Samuel:"
,"11":"'Je regrette d'avoir donné la royauté à Saül, car il s'est écarté de moi et n'a pas obéi à mes ordres.' Samuel en fut très mécontent et il supplia Yahvé toute la nuit."
,"12":"Tôt le matin Samuel partit pour rencontrer Saül; on lui donna cette information: 'Saül est allé à Karmel pour y dresser un monument en souvenir de sa victoire, puis il est reparti et est descendu à Guilgal.'"
,"13":"Lorsque Samuel arriva auprès de Saül, Saül lui dit: 'Que Yahvé te bénisse, j'ai exécuté les ordres de Yahvé.'"
,"14":"Mais Samuel lui dit: 'Quel est ce bruit de petit bétail que j'entends? Quel est ce bruit de gros bétail que j'entends également?'"
,"15":"Saül répondit: 'Nous les avons ramenés de chez les Amalécites. Le peuple a épargné le meilleur du petit et du gros bétail pour l'offrir en sacrifice à Yahvé ton Dieu, mais le reste ils l'ont voué à l'anathème.'"
,"16":"Alors Samuel dit à Saül: 'Arrête! Je vais t'apprendre ce que Yahvé m'a dit cette nuit.' Saül lui dit: 'Parle.'"
,"17":"Samuel lui dit: 'N'es-tu pas devenu le chef des tribus d'Israël? Yahvé ne t'a-t-il pas consacré comme roi sur Israël alors que tu étais si petit à tes propres yeux?"
,"18":"Yahvé t'avait confié une mission, il t'avait dit: Va, tu voueras à l'anathème ces pécheurs d'Amalécites, tu les combattras jusqu'à extermination."
,"19":"Pourquoi n'as-tu pas écouté la voix de Yahvé? Pourquoi t'es-tu jeté sur le butin? Pourquoi as-tu fait ce qui est mal aux yeux de Yahvé?'"
,"20":"Saül répondit à Samuel: 'J'ai écouté la voix de Yahvé, je suis parti en expédition là où Yahvé m'avait envoyé. J'ai ramené Agag, roi d'Amalec, et j'ai voué Amalec à l'anathème."
,"21":"Seulement le peuple a prélevé sur le butin le meilleur du petit et du gros bétail. Il l'a pris sur l'anathème pour l'offrir en sacrifice à Yahvé ton Dieu, à Guilgal.'"
,"22":"Alors Samuel lui dit: 'Penses-tu que Yahvé prenne autant de plaisir aux holocaustes et aux sacrifices, qu'à l'obéissance à sa parole? L'obéissance vaut mieux que le sacrifice, et la fidélité vaut mieux que la graisse des béliers."
,"23":"La révolte est un péché aussi grave que la sorcellerie, la désobéissance un crime aussi grave que l'idolâtrie. Puisque tu as rejeté la parole de Yahvé, Yahvé te rejette de la royauté!'"
,"24":"Saül dit à Samuel: 'J'ai péché et j'ai désobéi à l'ordre de Yahvé et à ses paroles! C'est que je craignais le peuple et j'ai fait ce qu'il demandait."
,"25":"Maintenant, je t'en prie, pardonne mon péché et reviens avec moi pour que je me prosterne devant Yahvé.'"
,"26":"Mais Samuel dit à Saül: 'Je n'irai pas avec toi. Tu as rejeté la parole de Yahvé et Yahvé t'a rejeté: tu ne régneras plus sur Israël.'"
,"27":"Comme Samuel repartait chez lui, Saül voulut le retenir par le pan de son manteau qui se déchira."
,"28":"Alors Samuel lui dit: 'Aujourd'hui Yahvé t'a arraché la royauté d'Israël, il l'a donnée à ton prochain qui est meilleur que toi."
,"29":"Celui qui est la Gloire d'Israël ne peut ni mentir ni se repentir, il n'est pas un homme pour se repentir.'"
,"30":"Saül dit: 'C'est vrai, j'ai péché. Mais tu ne vas pas m'humilier devant les anciens de mon peuple et devant Israël. Reviens avec moi, que j'aille me prosterner devant Yahvé ton Dieu.'"
,"31":"Samuel revint donc avec Saül, et Saül se prosterna devant Yahvé."
,"32":"Puis Samuel dit: 'Amenez-moi Agag, roi d'Amalec.' Et Agag arriva tout tremblant; il s'était dit: 'L'amertume de la mort s'est sûrement éloignée.'"
,"33":"Mais Samuel lui dit: 'Ton épée a privé des femmes de leurs enfants, et ce sera pareil pour ta mère: elle restera sans enfant.' Et Samuel mit en pièces Agag en présence de Yahvé, à Guilgal."
,"34":"Samuel s'en retourna à Rama, tandis que Saül regagnait sa maison à Guibéa de Saül."
,"35":"Samuel ne revit plus Saül jusqu'au jour de sa mort, il était triste à cause de Saül car Yahvé regrettait de l'avoir établi comme roi sur Israël."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Yahvé dit à Samuel: 'Combien de temps pleureras-tu sur Saül? N'est-ce pas moi qui l'ai rejeté pour qu'il ne règne plus sur Israël? Emplis donc d'huile ta corne et va. Je t'envoie vers Jessé de Bethléem, car je me suis choisi un roi parmi ses fils.'"
,"2":"Samuel répondit: 'Comment pourrai-je aller? Si Saül l'apprend, il me tuera.' Mais Yahvé lui dit: 'Tu prendras une génisse et tu diras que tu es venu pour offrir un sacrifice à Yahvé."
,"3":"Tu inviteras Jessé au sacrifice et moi, je te ferai savoir ce que tu dois faire: tu me consacreras celui que je te montrerai.'"
,"4":"Samuel fit comme Yahvé l'avait dit. Lorsqu'il arriva à Bethléem, les anciens sortirent en tremblant à sa rencontre. Ils lui dirent: 'Es-tu venu pour la paix?'"
,"5":"Il répondit: 'Oui, pour la paix. Je suis venu offrir un sacrifice à Yahvé. Purifiez-vous et venez avec moi au sacrifice.' Il alla donc purifier Jessé et l'inviter au sacrifice avec ses fils."
,"6":"Ils entrèrent. Lorsque Samuel aperçut Eliab, il se dit: 'Voilà sûrement devant Yahvé celui qu'il va consacrer.'"
,"7":"Mais Yahvé dit à Samuel: 'Oublie sa belle apparence et sa haute taille, je l'ai écarté. Car Dieu ne voit pas les choses à la façon des hommes: l'homme s'arrête aux apparences mais Dieu regarde le coeur.'"
,"8":"Jessé appela Abinadab et il le fit passer devant Samuel. Mais Samuel dit: 'Il n'est pas celui que Yahvé a choisi.'"
,"9":"Jessé fit passer Chamma, mais Samuel dit: 'Ce n'est pas lui non plus que Yahvé a choisi.'"
,"10":"Finalement Jessé fit passer ses sept fils devant Samuel, car Samuel disait à Jessé: 'Yahvé n'a choisi aucun de ceux-là.'"
,"11":"Alors Samuel dit à Jessé: 'Ce sont donc là tous tes garçons?' Il répondit: 'Il y a encore le plus jeune, il garde le troupeau.' Samuel dit à Jessé: 'Fais-le chercher, car nous ne nous mettrons pas à table avant qu'il ne soit ici.'"
,"12":"On partit le chercher et il arriva; il était roux avec de beaux yeux et une belle apparence. C'est alors que Yahvé dit: 'Lève-toi, consacre-le: c'est lui.'"
,"13":"Samuel prit donc sa corne d'huile et le consacra au milieu de ses frères. Dès lors et pour la suite des jours, l'esprit de Yahvé s'empara de David. Quant à Samuel, il se leva et retourna à Rama."
,"14":"L'esprit de Yahvé se retira de Saül et un mauvais esprit venant de Yahvé, lui causa des frayeurs."
,"15":"Les serviteurs de Saül lui dirent: 'Un mauvais esprit de Dieu te cause des frayeurs."
,"16":"Que notre seigneur ordonne, puisque tes serviteurs sont là autour de toi; nous chercherons un homme qui sache jouer de la cithare, et dès que le mauvais esprit viendra sur toi, il en jouera et tu iras mieux.'"
,"17":"Saül dit à ses serviteurs: 'Cherchez-moi donc un homme qui soit bon musicien et amenez-le-moi.'"
,"18":"L'un des serviteurs prit la parole et dit: 'Je connais un des fils de Jessé, de Bethléem, qui sait jouer de la musique. C'est un garçon courageux, un bon guerrier; il est intelligent, il est beau et Yahvé est avec lui.'"
,"19":"Saül envoya donc des messagers à Jessé et lui fit dire: 'Envoie-moi ton fils David, celui qui garde le troupeau.'"
,"20":"Jessé prit du pain, une outre de vin et un chevreau, et il les envoya à Saül par la main de son fils David."
,"21":"C'est ainsi que David arriva chez Saül et se mit à son service. Saül l'aima beaucoup et David devint celui qui portait ses armes."
,"22":"Aussi Saül fit-il dire à Jessé: 'Permets que David reste à mon service, car il m'est sympathique.'"
,"23":"Et ainsi lorsque l'esprit de Dieu malmenait Saül, David prenait la cithare et il en jouait; cela faisait du bien à Saül, il était soulagé et le mauvais esprit se retirait loin de lui."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Les Philistins rassemblèrent leurs troupes pour la guerre. Ils se réunirent à Soko de Juda: leur camp se trouvait à Ephès-Damim, entre Soko et Azéka."
,"2":"Saül et les Israélites se concentrèrent également, ils établirent leur camp dans la vallée du Térébinthe et se rangèrent en bataille face aux Philistins."
,"3":"Les Philistins se tenaient sur un des versants de la montagne et les Israélites sur l'autre, la vallée les séparait."
,"4":"Un guerrier d'élite, du nom de Goliath, sortit des rangs Philistins; c'était un homme de Gat qui mesurait plus de deux mètres."
,"5":"Il avait un casque de bronze sur la tête et il était revêtu d'une cuirasse d'écailles. Le poids de sa cuirasse de bronze était de soixante kilos."
,"6":"Il portait des jambières de bronze et un javelot de bronze entre les épaules,"
,"7":"le bois de sa lance était aussi gros que celui dont on fait le cadre d'un métier à tisser et la pointe de fer de sa lance pesait à elle seule sept kilos. Un porte-bouclier marchait devant lui."
,"8":"Il se plaça face aux rangs d'Israël et les interpella: 'Pourquoi êtes-vous sortis pour vous ranger en bataille? Je suis le Philistin et vous êtes les esclaves de Saül, n'est-ce pas? Choisissez donc parmi vous un homme, et qu'il vienne lutter contre moi."
,"9":"S'il est capable de l'emporter sur moi, s'il m'abat, alors nous serons vos serviteurs; mais si je l'emporte sur lui, si je l'abats, c'est vous qui deviendrez nos esclaves et qui nous servirez.'"
,"10":"Le Philistin ajouta: 'Aujourd'hui j'ai lancé un défi aux troupes d'Israël, donnez-moi donc un homme pour que nous nous mesurions en combat singulier.'"
,"11":"Lorsque Saül et Israël entendirent les paroles du Philistin, ils furent terrifiés et complètement démoralisés."
,"12":"David était le fils de Jessé, un Ephratéen de Bethléem de Juda qui avait huit fils. Au temps de Saül, Jessé était déjà vieux, avancé en âge,"
,"13":"mais ses trois aînés étaient partis à la guerre avec Saül. Ces trois fils qui partirent à la guerre étaient Eliab, l'aîné, Abinadab, le second, et Chamma, le troisième."
,"14":"David était plus jeune, et comme les trois aînés étaient partis avec Saül,"
,"15":"David allait et venait du service de Saül à la garde du troupeau de son père à Bethléem."
,"16":"Chaque matin et chaque soir le Philistin se présentait: il fit ainsi pendant quarante jours."
,"17":"Jessé dit à David son fils: 'Prends donc pour tes frères une mesure de grain grillé et dix pains. Tu iras au camp pour les porter à tes frères."
,"18":"Tu donneras ces dix morceaux de fromage au chef de mille, puis tu prendras des nouvelles de tes frères et tu me ramèneras d'eux un gage."
,"19":"Or ils étaient avec Saül et tout Israël dans la vallée du Térébinthe pour combattre les Philistins."
,"20":"De bon matin David se leva, il confia le troupeau à un gardien, puis il emporta son sac et partit comme Jessé le lui avait ordonné. Lorsqu'il arriva, l'armée quittait le camp pour prendre ses positions et pousser le cri de guerre."
,"21":"Les Israélites et les Philistins se rangèrent face à face."
,"22":"David confia son sac à celui qui gardait les bagages et courut vers le front des troupes. Il alla saluer ses frères."
,"23":"Pendant qu'il parlait avec eux, voici que le colosse philistin sortit des lignes. Il s'appelait Goliath, c'était un Philistin de Gat. Il répétait toujours les mêmes paroles et David l'entendit."
,"24":"Dès qu'on le voyait, les Israélites se mettaient à distance car ils tremblaient de peur."
,"25":"Un homme d'Israël dit: 'Avez-vous vu cet homme qui monte des lignes philistines pour insulter Israël. Le roi comblera de richesses celui qui l'abattra, il lui donnera sa fille en mariage et exemptera la maison de son père de tout impôt en Israël.'"
,"26":"David demanda aux hommes qui étaient autour de lui: 'Que fera-t-on pour celui qui abattra ce Philistin et vengera l'insulte faite à Israël? Qui est ce Philistin incirconcis, pour insulter les troupes du Dieu vivant!'"
,"27":"Les gens lui répétèrent les paroles qu'ils avaient entendues: 'Voilà ce qu'on fera pour l'homme qui l'abattra.'"
,"28":"Eliab, son frère aîné, l'entendit qui parlait avec les hommes de guerre et il se mit en colère contre David. Il lui dit: 'Pourquoi es-tu venu ici? A qui as-tu confié les quelques brebis que nous avons dans le désert? Je te connais: tu cours après les occasions, et c'est pour voir la bataille que tu es venu ici.'"
,"29":"David répondit: 'Qu'ai-je donc fait? N'a-t-on plus le droit de parler?'"
,"30":"Il se tourna vers un autre et lui posa la même question, mais les gens lui firent la même réponse que la première fois."
,"31":"On avait entendu les paroles de David et on les avait rapportées à Saül qui le fit venir."
,"32":"David dit à Saül: 'Que personne ne tremble en face de ce Philistin, ton serviteur ira se battre contre lui.'"
,"33":"Mais Saül dit à David: 'Tu ne pourras pas combattre ce Philistin, tu n'es qu'un enfant et lui est un homme de guerre depuis sa jeunesse.'"
,"34":"David dit à Saül: 'Ton serviteur gardait les troupeaux de son père, et lorsqu'un lion ou un ours venait pour emporter un mouton du troupeau,"
,"35":"je partais à sa poursuite, je le frappais et je lui arrachais de la gueule sa proie. S'il se jetait sur moi, je le saisissais par la barbe, je le frappais et je le mettais en pièces."
,"36":"Ton serviteur a mis à mal le lion et l'ours, et ce sera pareil pour ce Philistin qui a insulté les troupes du Dieu vivant!'"
,"37":"David dit encore: 'Yahvé qui m'a délivré de la griffe du lion et de la patte de l'ours, me délivrera de la main de ce Philistin.' Alors Saül dit à David: 'Va et que Yahvé soit avec toi.'"
,"38":"Saül donna à David ses propres vêtements, il mit sur sa tête un casque de bronze et l'habilla d'une cuirasse."
,"39":"David attacha son épée par-dessus ses vêtements, il essaya de marcher, mais il n'était pas habitué. Alors David dit à Saül: 'Je ne peux marcher avec tout cela, car je ne suis pas habitué.' Et David enleva tout."
,"40":"Il prit son bâton et choisit dans le torrent cinq pierres bien plates. Il les mit dans son sac de berger, dans sa sacoche, il prit sa fronde en main et s'avança contre le Philistin."
,"41":"Le Philistin allait et venait et s'approchait de David; son porte-bouclier s'avançait devant lui."
,"42":"Le Philistin regarda David et il le méprisa, car il n'était encore qu'un garçon (David était roux et d'une belle apparence)."
,"43":"Le Philistin dit à David: 'Suis-je un chien, pour que tu viennes contre moi avec des bâtons?' Alors le Philistin maudit David par tous ses dieux,"
,"44":"puis il dit à David: 'Avance vers moi, pour que je te livre en pâture aux oiseaux des cieux et aux bêtes des champs.'"
,"45":"David répondit au Philistin: 'Tu viens à moi avec l'épée, la lance et le javelot, mais moi je marche contre toi au Nom de Yahvé des armées, le Dieu des troupes d'Israël que tu as insultées."
,"46":"Aujourd'hui Yahvé te livrera entre mes mains, je t'abattrai et j'enlèverai ta tête de sur tes épaules. Aujourd'hui je te donnerai en pâture, toi et toute l'armée des Philistins, aux oiseaux des cieux et aux animaux de la terre, pour que toute la terre sache qu'il y a un Dieu en Israël."
,"47":"Tous ceux qui sont ici rassemblés sauront que Yahvé ne sauve ni par l'épée ni par la lance, mais que la victoire appartient à Yahvé: c'est lui qui va vous livrer entre nos mains.'"
,"48":"A ce moment le Philistin avance et s'approche de David. David se décide, court droit devant lui à la rencontre du Philistin,"
,"49":"puis il porte la main à sa sacoche, il en tire une pierre et la lance avec la fronde. Il frappe le Philistin au front, la pierre s'enfonce dans son front et le Philistin tombe la face contre terre."
,"50":"C'est ainsi que David triomphe du Philistin avec la fronde et la pierre: il abat le Philistin et le met à mort. Mais il n'a pas d'épée dans la main."
,"51":"Alors David court, il se tient debout sur le Philistin, il lui prend son épée qu'il tire du fourreau et, l'épée en main, il tranche la tête du Philistin. C'est ainsi qu'il l'achève. Les Philistins avaient vu la mort de leur champion: ils prirent la fuite. "
,"52":"Les hommes d'Israël et de Juda se levèrent, poussèrent le cri de guerre et se lancèrent à la poursuite des Philistins jusqu'à l'entrée de Gat, et jusqu'aux portes d'Ekron. Tout au long du chemin qui va de Chaarayim jusqu'à Gat et Ekron, on voyait des cadavres de Philistins."
,"53":"Quand les Israélites revinrent de cette poursuite acharnée contre les Philistins, ils pillèrent leur camp."
,"54":"David saisit la tête du Philistin et l'apporta à Jérusalem; quant à ses armes, il les déposa dans sa propre tente."
,"55":"En voyant David partir à la rencontre du Philistin, Saül avait dit à Abner, le chef de son armée: 'De qui ce garçon est-il le fils, Abner? Abner répondit: 'Aussi vrai que je suis vivant, ô roi, je n'en sais rien.'"
,"56":"Le roi lui dit: 'Renseigne-toi pour savoir de qui ce garçon est le fils.'"
,"57":"Lorsque David revint d'avoir abattu le Philistin, Abner le conduisit devant Saül; il tenait à la main la tête du Philistin."
,"58":"Saül lui dit: 'De qui es-tu le fils, jeune homme?' Et David lui répondit: 'Je suis le fils de ton serviteur Jessé de Bethléem.'"
}`)
	CurrentBook.AddChapter(18, `{
"1":"David n'avait pas fini de parler à Saül que le coeur de Jonathan s'attacha à David et, à partir de ce jour, Jonathan aima David comme lui-même."
,"2":"Ce jour-là Saül garda David chez lui et ne le laissa pas retourner chez son père."
,"3":"Quant à Jonathan, il fit une alliance avec David car il l'aimait comme lui-même."
,"4":"Jonathan retira le manteau qu'il avait sur lui et il le donna à David avec sa tenue, son épée, son casque et sa ceinture."
,"5":"Dans toutes les expéditions où Saül l'envoyait, David avait plein succès et Saül le plaça à la tête de tous ses hommes de guerre. Il était aimé de tout le peuple et même des serviteurs du roi."
,"6":"Quand on rentra, après que David avait tué le Philistin, les femmes sortirent de toutes les villes d'Israël à la rencontre du roi Saül, chantant et dansant, avec des tambourins, des chants de fête et des harpes."
,"7":"Le choeur des danseuses entonna ce chant: 'Saül en a tué mille, mais David en a tué dix mille.'"
,"8":"Cela déplut beaucoup à Saül et il se mit en colère. Il se dit: 'On en donne dix mille à David et seulement mille à moi, il ne lui manque plus que la royauté.'"
,"9":"A partir de ce jour, Saül regarda David d'un oeil mauvais."
,"10":"Le lendemain, un mauvais esprit de Dieu fondit sur Saül, il était comme un fou dans sa maison. David jouait de la cithare comme chaque jour, mais Saül avait saisi sa lance."
,"11":"Il brandit sa lance en pensant: 'Je vais clouer David au mur.' Mais par deux fois David évita le coup."
,"12":"Saül redoutait David parce que Yahvé était avec lui, et qu'il s'était retiré de Saül."
,"13":"Saül éloigna donc David de chez lui et il en fit un chef de mille: il allait et venait à la tête du peuple."
,"14":"David réussissait dans toutes ses expéditions, car Yahvé était avec lui."
,"15":"Saül vit les succès de David et il le redouta."
,"16":"Tout Israël et Juda, en effet, aimaient David parce qu'il allait et venait à leur tête."
,"17":"Saül dit alors à David: 'Tu connais ma fille aînée Mérob. Je te la donnerai pour femme si tu te montres courageux à mon service lorsque tu conduis les guerres de Yahvé.' Saül se disait en effet: 'Qu'il ne meure pas de ma main, mais de la main des Philistins.'"
,"18":"David dit à Saül: 'Qui suis-je? Quelle valeur a ma vie? Qu'est-ce que la famille de mon père en Israël, pour que je devienne le gendre du roi?'"
,"19":"Mais lorsque le jour arriva où l'on devait donner à David la fille de Saül, Mérob, on la donna pour femme à Adriel de Méhola."
,"20":"Mikal, la seconde fille de Saül, aima David et on le dit à Saül; il en fut bien heureux."
,"21":"Il se dit en effet: 'Je la lui donnerai, mais elle sera un piège pour lui. Je le ferai tomber sous la main des Philistins.' Saül appela David une seconde fois: 'Cette fois-ci tu seras mon gendre.'"
,"22":"Saül donna cet ordre à ses serviteurs: 'Parlez discrètement à David et dites-lui: Le roi te veut du bien. Tu sais que tous ses serviteurs t'aiment, deviens donc maintenant le gendre du roi.'"
,"23":"Les serviteurs de Saül rapportèrent ces paroles à David, et David leur répondit: 'Croyez-vous que ce soit peu de chose pour moi que de devenir le gendre du roi? Je suis un homme sans argent et de petite condition.'"
,"24":"Les serviteurs de Saül lui firent leur rapport: 'Voici la réponse de David.'"
,"25":"Saül leur dit: 'Vous parlerez ainsi à David: Le roi pour ce mariage ne désire aucune somme d'argent, mais seulement cent prépuces de Philistins pour se venger de ses ennemis.' Ainsi Saül pensait faire tomber David dans les mains des Philistins."
,"26":"Les serviteurs rapportèrent ces paroles à David et il lui parut que ce serait une bonne chose de devenir le gendre du roi. Le délai n'était pas encore écoulé,"
,"27":"que David partit en campagne avec ses hommes. Il tua deux cents Philistins et rapporta leurs prépuces qu'il remit au roi, pour devenir son gendre. Alors Saül lui donna sa fille Mikal comme épouse."
,"28":"A cette occasion Saül se rendit compte que Yahvé était avec David; quant à Mikal, la fille de Saül, elle aimait David."
,"29":"Saül redoutait David de plus en plus, sa haine pour David était devenue habituelle."
,"30":"Chaque fois que les chefs des Philistins partaient en campagne, David remportait plus de succès que les autres serviteurs de Saül. Il devint très célèbre."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Saül dit à son fils Jonathan et à tous ses serviteurs qu'il faudrait bien tuer David, mais Jonathan, le fils de Saül, était très attaché à David."
,"2":"Il avertit David: 'Saül, mon père, cherche à te tuer; tiens-toi sur tes gardes demain matin, mets-toi à l'abri et reste caché."
,"3":"Moi, je sortirai et je resterai à côté de mon père dans le champ où tu seras; je parlerai de toi à mon père et je verrai ce qu'il en est. Ensuite, je te le ferai savoir.'"
,"4":"Jonathan fit l'éloge de David devant son père Saül et lui dit: 'Que le roi ne fasse pas de tort à son serviteur David; il ne t'a fait aucun tort et ce qu'il a fait t'a beaucoup servi."
,"5":"Il a risqué sa vie pour abattre le Philistin et Yahvé a donné là une grande victoire à tout Israël. Quand tu l'as vu, tu en as été bien content. Pourquoi donc pécherais-tu contre un sang innocent en faisant mourir David sans motif?'"
,"6":"Saül écouta Jonathan et il lui jura: 'Par la vie de Yahvé, David ne mourra pas.'"
,"7":"Alors Jonathan appela David pour lui rapporter cet entretien, puis il ramena David auprès de Saül; il se remit à son service comme auparavant."
,"8":"La guerre reprit. David partit en campagne contre les Philistins et leur infligea une grande défaite: ils prirent la fuite devant lui."
,"9":"Pendant que Saül était assis dans sa maison avec sa lance dans la main, un mauvais esprit de Yahvé s'empara de lui. David se mit à jouer de la cithare."
,"10":"Saül essaya de clouer David au mur avec sa lance, mais David évita le coup de Saül, et sa lance se planta dans le mur. David prit la fuite et il échappa encore une fois. Cette même nuit "
,"11":"Saül envoya des hommes pour cerner la maison de David et le tuer au matin. Mais Mikal, la femme de David, lui donna cet avertissement: 'Si tu ne t'échappes pas cette nuit, demain tu seras assassiné.'"
,"12":"Mikal fit descendre David par la fenêtre; il s'éloigna, prit la fuite et se mit en sûreté."
,"13":"Mikal allongea alors sur le lit une des idoles qu'elle avait à la maison, elle mit à la place de la tête un filet en poils de chèvre et recouvrit le tout avec un drap."
,"14":"Elle dit aux hommes que Saül avait envoyés pour prendre David: 'Il est malade.'"
,"15":"Mais Saül renvoya ses hommes avec mission de voir David; il leur dit: 'Amenez-le moi dans son lit, pour que je le mette à mort.'"
,"16":"Les messagers entrèrent, et voici que l'idole était sur le lit avec le filet en poils de chèvre à la place de la tête."
,"17":"Saül dit à Mikal: 'Pourquoi t'es-tu moquée de moi? Tu as laissé partir mon ennemi et il s'est échappé.' Mikal répondit à Saül: 'C'est qu'il m'a dit: Laisse-moi partir, sinon je te tue.'"
,"18":"David échappa donc par la fuite et arriva chez Samuel à Rama, il lui raconta tout ce que lui avait fait Saül. Avec Samuel il alla demeurer aux Cellules-des-prophètes."
,"19":"On avertit Saül, on lui dit: 'David est aux Cellules près de Rama.'"
,"20":"Alors Saül envoya des hommes pour s'emparer de David. Lorsqu'ils rencontrèrent la bande des prophètes en train de prophétiser, avec Samuel à leur tête, l'esprit de Dieu s'empara des envoyés de Saül, qui se mirent à prophétiser."
,"21":"On le fait savoir à Saül: il envoie d'autres messagers, et voici qu'ils prophétisent eux-aussi. Pour la troisième fois Saül envoie des messagers, et ils se mettent encore à prophétiser."
,"22":"Alors il part lui-même pour Rama et arrive à la grande citerne qui se trouve à Sékou. Là il interroge: 'Où sont Samuel et David?' On lui répond: 'Ils sont aux Cellules, près de Rama.'"
,"23":"Et tandis qu'il se rend aux Cellules près de Rama, l'esprit de Dieu s'empare de lui: il continue sa marche en prophétisant, jusqu'à son entrée aux Cellules, près de Rama."
,"24":"Lui aussi retira ses vêtements et prophétisa devant Samuel, jusqu'à ce qu'il s'écroule. Il resta nu sur le sol tout le jour et toute la nuit. C'est pour cela que l'on dit: 'Saül est-il aussi parmi les prophètes?'"
}`)
	CurrentBook.AddChapter(20, `{
"1":"David s'était enfui des Cellules-de-Rama. Il vint trouver Jonathan et lui dit: 'Qu'ai-je fait? Quelle est ma faute et quel est mon péché envers ton père, pour qu'il veuille me tuer?'"
,"2":"Jonathan répondit: 'Non, tu ne mourras pas. Mon père ne me cache rien de ce qu'il fait, que ce soit important ou non. Pourquoi donc mon père me cacherait-il cela? Tu te trompes.'"
,"3":"Mais David lui dit: 'Ton père sait très bien l'amitié que tu as pour moi, et il s'est dit: Il ne faut pas que Jonathan le sache, il le prendrait très mal. Mais je te le jure par la vie de Yahvé et sur ma propre tête: il n'y a qu'un pas entre moi et la mort.'"
,"4":"Alors Jonathan dit à David: 'Que désires-tu? Je le ferai.'"
,"5":"David lui répondit: 'Demain c'est la nouvelle lune, et je dois m'asseoir à côté du roi pour manger; cependant laisse-moi partir et je me cacherai dans la campagne jusqu'au troisième soir."
,"6":"Si ton père remarque mon absence, tu lui diras: 'David m'a demandé la permission d'aller à Bethléem, sa ville natale, car il y a là un sacrifice annuel pour toute sa famille."
,"7":"Si ton père répond: 'C'est bon,' ton serviteur n'a rien à craindre; mais s'il se met en colère, tu sauras qu'il a décidé ma perte."
,"8":"Puisque tu as fait un pacte avec moi au nom de Yahvé, je te demande en raison de cette amitié: s'il y a une faute de ma part, tue-moi. Pourquoi me conduirais-tu jusqu'à ton père?'"
,"9":"Jonathan répondit: 'Non, si je viens à savoir que mon père a décidé ta perte, je te préviendrai moi-même.'"
,"10":"David dit à Jonathan: 'Qui me préviendra au cas où ton père te répondrait méchamment?'"
,"11":"Jonathan dit à David: 'Viens, sortons dans la campagne.' Et tous deux sortirent dans la campagne."
,"12":"Jonathan dit alors à David: 'Par Yahvé Dieu d'Israël, dès demain ou après-demain je verrai ce que mon père a dans la tête. Si tout va bien pour toi, je t'enverrai quelqu'un et je te le ferai savoir;"
,"13":"si je ne le fais pas, que Dieu me maudisse et me maudisse encore! De même , si mon père veut te faire du mal, je te le ferai savoir. Je te laisse donc partir, va en paix; Yahvé sera avec toi comme il a été avec mon père."
,"14":"Si alors je suis encore de ce monde, ne me fais pas mourir; que ta bonté pour moi soit comme celle de Yahvé."
,"15":"Ne prive jamais ma famille de ta bienveillance lorsque Yahvé aura exterminé tes ennemis de la surface de la terre"
,"16":"Si le nom de Jonathan disparaissait avec la maison de Saül, Yahvé en demanderait compte à la famille de David.'"
,"17":"Et de nouveau Jonathan fit un serment à David au nom de son amitié pour lui, car il l'aimait comme lui-même."
,"18":"Jonathan lui dit: 'C'est demain la nouvelle lune et ton absence sera remarquée, on verra que ta place est vide."
,"19":"Attends donc le troisième jour; alors tu descendras et tu viendras à l'endroit où tu t'étais caché la première fois. Tu resteras là à côté de la borne,"
,"20":"et moi, je tirerai trois flèches de ton côté en me fixant une cible."
,"21":"Ensuite j'enverrai mon serviteur, je lui dirai: Va, recherche les flèches. Si je lui dit: Regarde, les flèches sont en deçà de toi, rapporte-les. Alors tu pourras venir car tu n'auras rien à craindre; par la vie de Yahvé il n'y aura aucun danger pour toi."
,"22":"Mais si je dis à mon serviteur: Regard e, les flèches sont au-delà de toi, alors sauve-toi; cela voudra dire que Yahvé te fait partir."
,"23":"Pour ce qui est de notre alliance, Yahvé lui-même est entre moi et toi pour toujours.'"
,"24":"David alla se cacher dans les champs. Lorsque la nouvelle lune arriva, le roi se mit à table pour le repas."
,"25":"Il s'assit comme chaque fois sur le siège qui est contre le mur. Jonathan était en face de lui et Abner était assis à côté de Saül, mais la place de David était vide."
,"26":"Ce jour-là Saül ne dit rien, il pensait: 'Il n'est pas pur, c'est une chose qui arrive. Sûrement il n'est pas pur.'"
,"27":"Le lendemain de la nouvelle lune, le second jour, la place de David était encore vide. Saül dit à son fils Jonathan: 'Pourquoi le fils de Jessé n'est-il pas venu au repas ni hier ni aujourd'hui?'"
,"28":"Jonathan répondit à Saül: 'David m'a demandé la permission d'aller à Bethléem."
,"29":"Il m'a dit: Laisse-moi aller, car nous avons un sacrifice de famille dans ma ville natale, et mon frère me l'a demandé; permets-moi de m'absenter et de voir mes frères. C'est pour cela qu'il n'est pas venu à la table du roi.'"
,"30":"A ces mots, Saül se mit en colère contre Jonathan et lui dit: 'Fils de prostituée! Je le savais bien, tu prends parti pour le fils de Jessé, à ta honte et à la honte de la nudité de ta mère."
,"31":"Tant que le fils de Jessé sera de ce monde, il n'y aura de paix ni pour toi, ni pour ton royaume. Envoie donc le chercher, il mérite la mort.'"
,"32":"Jonathan répondit à son père Saül: 'Pourquoi serait-il mis à mort? Qu'a-t-il fait?'"
,"33":"Mais Saül leva sa lance en menaçant de le frapper et Jonathan comprit que son père avait décidé la mort de David."
,"34":"Jonathan était tellement en colère qu'il quitta la table. Ce second jour de la nouvelle lune il ne mangea rien; il était fort peiné pour David, mais aussi parce que son père l'avait insulté."
,"35":"Le lendemain matin Jonathan sortit vers la campagne pour le rendez-vous avec David; son serviteur était avec lui."
,"36":"Il dit à son serviteur: 'Cours et rapporte les flèches que je tire.' Le garçon courait mais Jonathan lançait les flèches de manière à le dépasser,"
,"37":"et pendant que le jeune homme allait là où Jonathan avait tiré la flèche, Jonathan lui cria: 'La flèche n'est-elle pas plus loin?'"
,"38":"Jonathan cria encore à son serviteur: 'Vite, dépêche-toi, ne t'arrête pas.' Le serviteur de Jonathan ramassa la flèche et revint vers son maître."
,"39":"Le serviteur ne savait rien de tout cela, seuls Jonathan et David étaient au courant."
,"40":"Puis Jonathan remit ses armes à son serviteur en lui disant: 'Va et reporte-les à la ville.'"
,"41":"Lorsque le serviteur fut parti, David sortit de sa cachette, il tomba la face contre terre et se prosterna trois fois. Ensuite ils s'embrassèrent l'un l'autre, et ils pleurèrent longuement l'un sur l'autre, mais le moment de partir était venu pour David."
,"42":"Alors Jonathan lui dit: 'Va en paix. Nous nous sommes fait un serment l'un à l'autre au nom de Yahvé, Yahvé sera entre moi et toi, entre ma race et ta race pour toujours."
}`)
	CurrentBook.AddChapter(21, `{
"1":"David se leva, partit, et Jonathan rentra dans la ville."
,"2":"David arriva à Nob, chez le prêtre Ahimélek. Celui-ci vint en tremblant à la rencontre de David et lui demanda: 'Pourquoi es-tu seul? Pourquoi n'y a-t-il personne avec toi?'"
,"3":"David répondit au prêtre Ahimélek: 'Le roi m'a donné un ordre, il m'a dit: Personne ne doit connaître la mission que je t'ai confiée ni l'ordre que je t'ai donné. C'est pourquoi j'ai donné rendez-vous à mes hommes à tel endroit."
,"4":"Maintenant, qu'as-tu sous la main? Si tu as cinq pains ou autre chose, donne-les moi.'"
,"5":"Le prêtre dit à David: 'Je n'ai pas de pain ordinaire sous la main, seulement du pain consacré. Pourvu que tes hommes se soient gardés de toute relation avec une femme.'"
,"6":"David répondit au prêtre: 'Certainement, la femme nous était interdite jusqu'ici chaque fois que je sortais; mes hommes restaient purs pour ce qui est du sexe, et il s'agissait d'expéditions profanes. A combien plus forte raison aujourd'hui. Ils sont tous en état de pureté quant au sexe.'"
,"7":"Alors le prêtre lui donna du pain consacré, car il n'y avait pas d'autre pain que les pains de proposition, celui qu'on enlève de devant Yahvé pour le remplacer par du pain frais le jour où on le reprend."
,"8":"Or, le même jour, l'un des serviteurs de Saül se trouvait là, retenu au sanctuaire de Yahvé; il s'appelait Doëg l'Edomite, et il était le plus considéré parmi les bergers de Saül."
,"9":"David dit à Ahimélek: 'N'as-tu pas ici sous la main une lance ou une épée? L'affaire du roi était si urgente que je n'ai pas pu prendre mon épée et mes armes.'"
,"10":"Le prêtre répondit: 'L'épée du Philistin Goliath que tu as abattu dans la vallée du Térébinthe est ici, enveloppée dans un manteau derrière l'éphod. Si tu la veux, prends-la, il n'y en a pas d'autre.' David répondit: 'Il n'y en a pas de pareille, donne-la-moi.'"
,"11":"Ce jour-là David s'enfuit loin de Saül et il arriva chez Akich, roi de Gat."
,"12":"Les serviteurs d'Akich lui dirent: 'Mais, majesté, c'est David! N'est-ce pas à son sujet que l'on dansait en chantant: Saül en a abattu mille, mais David en a tué dix mille?'"
,"13":"Ces réflexions inquiétèrent fortement David, il eut peur d'Akich, roi de Gat."
,"14":"Alors David fit croire qu'il était devenu fou, il joua les débiles au milieu d'eux: il tambourinait sur les montants des portes et laissait couler sa bave sur sa barbe."
,"15":"Akich dit à ses serviteurs: 'Vous voyez bien que c'est un fou, pourquoi me l'avez-vous amené ici?"
,"16":"Est-ce que je manque de fous pour que vous m'ameniez celui-là, pour qu'il continue ses folies devant moi? Un peu plus il entrerait chez moi!'"
}`)
	CurrentBook.AddChapter(22, `{
"1":"David partit de là et se mit en sûreté dans la grotte d'Adoullam. Ses frères et sa famille l'apprirent et descendirent vers lui en ce lieu."
,"2":"Tous ceux qui avaient des ennuis se rassemblèrent également autour de lui, tous ceux qui étaient poursuivis par un créancier ou qui étaient mécontents. Il devint leur chef, et avec lui ils étaient environ quatre cents."
,"3":"De là David alla à Mispé de Moab. Il dit au roi de Moab: 'J'aimerais que mon père et ma mère se retirent chez toi jusqu'à ce que je sache ce que Dieu me réserve.'"
,"4":"Il conduisit ses parents chez le roi de Moab et ils restèrent là jusqu'au jour où David quitta le refuge."
,"5":"Le prophète Gad dit un jour à David: 'Ne reste pas au refuge, va et rentre au pays de Juda.' David s'en alla et arriva à la forêt de Hérèt."
,"6":"Saül apprit que l'on avait des nouvelles de David et des hommes qui étaient avec lui. Saül siégeait à ce moment à Guibéa sous le tamaris qui est sur la colline: il avait sa lance à la main et tous ses serviteurs étaient debout autour de lui."
,"7":"Saül dit alors à ses serviteurs réunis autour de lui: 'Ecoutez donc, hommes de Benjamin! Croyez-vous que le fils de Jessé vous donnera aussi à tous des champs et des vignes, et qu'il fera de vous tous des chefs de mille et des chefs de cent?"
,"8":"Pourquoi êtes-vous tous d'accord contre moi? Personne ne m'a prévenu que mon fils avait fait une alliance avec le fils de Jessé. Nul d'entre vous ne s'inquiète pour moi, pas un ne m'a révélé que mon fils avait soulevé contre moi mon serviteur et m'en avait fait un adversaire, comme c'est le cas aujourd'hui.'"
,"9":"Doëg l'Edomite, qui était l'un des chefs des serviteurs de Saül, prit alors la parole: 'J'ai vu le fils de Jessé quand il arrivait à Nob chez Ahimélek fils d'Ahitoub."
,"10":"Celui-ci a consulté Yahvé pour lui, il lui a donné des provisions et lui a remis l'épée de Goliath le Philistin.'"
,"11":"Alors Saül fit appeler le prêtre Ahimélek fils d'Ahitoub, et toute sa famille, les prêtres de Nob; ils arrivèrent tous chez le roi."
,"12":"Saül dit: 'Ecoute-moi donc fils d'Ahitoub.' Il répondit: 'Me voici mon seigneur.'"
,"13":"Saül lui dit: 'Pourquoi avez-vous conspiré contre moi, toi et le fils de Jessé? Tu lui as donné du pain et une épée, tu as consulté Dieu pour lui, pour qu'il se soulève contre moi, et il s'est fait mon adversaire, comme on le voit aujourd'hui.'"
,"14":"Ahimélek répondit au roi: 'Qui était fidèle comme David parmi tous les serviteurs du roi? Il est le gendre du roi, il est affecté à sa garde personnelle, il est honoré dans sa maison."
,"15":"Assurément, ce n'est pas la première fois que j'ai consulté Dieu pour lui. Que le roi ne me reproche rien, pas plus qu'à toute la maison de mon père, ton serviteur ne savait rien de tout cela, absolument rien.'"
,"16":"Mais le roi dit: 'Ahimélek, tu vas mourir, toi et toute la maison de ton père avec toi.'"
,"17":"Puis le roi dit aux soldats qui étaient autour de lui: 'Avancez et mettez à mort les prêtres de Yahvé, car eux-aussi soutiennent David. Ils savaient qu'il s'enfuyait loin de moi et ils ne m'ont rien dit.' Mais les serviteurs du roi ne voulurent pas frapper les prêtres de Yahvé."
,"18":"Alors le roi dit à Doëg: 'Avance toi, et frappe les prêtres.' Et Doëg l'Edomite s'avança et frappa les prêtres. Ce jour-là il mit à mort quatre vingt cinq hommes qui portaient le pagne de lin."
,"19":"Nob, la ville des prêtres, fut passée au fil de l'épée: hommes et femmes, enfants et nourrissons, on passa tout au fil de l'épée, y compris les boeufs, les ânes et les moutons."
,"20":"Seul échappa un fils d'Ahimélek fils d'Ahitoub, il s'appelait Ebyatar. Il courut rejoindre David."
,"21":"Ebyatar raconta à David comment Saül avait tué les prêtres de Yahvé,"
,"22":"et David lui dit: 'Doëg l'Edomite était présent ce jour-là et je savais bien qu'il préviendrait Saül. C'est moi qui ai causé la mort de toute ta famille."
,"23":"Reste donc avec moi et ne crains rien, celui qui s'en prend à ta vie, s'en prend à la mienne: à côté de moi tu seras bien gardé.'"
}`)
	CurrentBook.AddChapter(23, `{
"1":"On rapporta cette nouvelle à David: 'Les Philistins sont partis en campagne contre Keïla et ils ont pillé les aires à battre le grain.'"
,"2":"Alors David consulta Yahvé; il demanda: 'Dois-je partir en campagne contre ces Philistins?' Yahvé répondit à David: 'Va, tu battras les Philistins et tu délivreras Keïla.'"
,"3":"Mais les hommes de David lui dirent: 'Nous avons déjà assez à craindre ici en Juda, faut-il maintenant aller chercher les Philistins à Keïla?'"
,"4":"David consulta de nouveau Yahvé et Yahvé répondit: 'Lève-toi, descends à Keïla, car je livre les Philistins entre tes mains.'"
,"5":"David partit donc pour Keïla avec ses hommes, et il livra combat aux Philistins. Il enleva leurs troupeaux et leur infligea une grande défaite; c'est ainsi que David délivra les habitants de Keïla."
,"6":"(Quand Ebyatar fils d'Ahimélek s'était enfui auprès de David à Keïla, il était descendu avec l'éphod.)"
,"7":"On avertit Saül que David était entré à Keïla; Saül dit: 'Dieu l'a livré entre mes mains: en entrant dans une ville avec portes et verrous, il s'est enfermé lui-même.'"
,"8":"Saül convoqua tout le peuple pour la guerre: ils descendirent à Keïla pour assiéger David et ses hommes."
,"9":"Lorsque David apprit que Saül préparait quelque chose contre lui, il dit au prêtre Ebyatar: 'Amène l'éphod.'"
,"10":"David fit cette consultation: 'Yahvé, Dieu d'Israël, ton serviteur a appris que Saül cherche à forcer Keïla et à détruire la ville à cause de moi."
,"11":"Est-ce que Saül descendra comme l'a entendu dire ton serviteur? Yahvé, Dieu d'Israël, renseigne-moi, je te prie.' Yahvé répondit: 'Il viendra.'"
,"12":"David dit: 'Est-ce que les habitants de Keïla me livreront à Saül avec mes hommes?' Yahvé répondit: 'Ils vous livreront.'"
,"13":"Alors David se leva avec ses hommes, au nombre d'environ six cents, ils sortirent de Keïla et partirent sans savoir où. Lorsque Saül apprit que David s'était enfui de Keïla, il renonça à son expédition."
,"14":"David demeura dans les refuges du désert, puis dans la montagne, dans le désert de Ziph. Tous les jours Saül le recherchait, mais Dieu ne le livra pas entre ses mains."
,"15":"Quand David était à Horcha, dans le désert de Ziph, il apprit que Saül s'était mis en campagne pour le tuer."
,"16":"C'est alors que Jonathan, fils de Saül, se rendit près de David, à Horcha, pour le réconforter de la part de Dieu."
,"17":"Il lui dit: 'Ne crains rien, mon père Saül ne te trouvera pas. Tu régneras sur Israël et je serai ton second, mon père Saül le sait bien.'"
,"18":"Tous deux alors conclurent une alliance devant Yahvé. David resta à Horcha tandis que Jonathan s'en retournait chez lui."
,"19":"Des gens de Ziph se rendirent à Guibéa auprès de Saül, ils lui dirent: 'David n'est-il pas caché chez nous dans les refuges d'Horcha, sur la colline de Hakila qui domine le sud de la Steppe?"
,"20":"Que mon seigneur descende lorsqu'il le voudra, nous livrerons David entre les mains du roi.'"
,"21":"Saül leur dit: 'Que Yahvé vous bénisse pour avoir eu pitié de moi."
,"22":"Retournez maintenant et informez-vous exactement du lieu où il se cache. Sachez qui l'a vu là-bas, car on m'a dit qu'il était très rusé."
,"23":"Regardez attentivement, reconnaissez toutes les cachettes où il pourrait se trouver. Vous reviendrez vers moi une fois que vous serez bien informés, et je partirai avec vous. S'il est dans le pays, je le rechercherai dans tous les clans de Juda.'"
,"24":"Ils s'en retournèrent à Ziph, précédant Saül. David et ses hommes se trouvaient au désert de Maon, dans la vallée qui est au sud de la Steppe. "
,"25":"Saül et ses hommes partirent à sa recherche, mais David en fut informé et il descendit à la Roche. Il demeura dans le désert de Maon. Saül le sut et il poursuivit David dans le désert de Maon."
,"26":"Saül marchait d'un côté de la montagne, et David avec ses hommes, de l'autre côté. David et ses hommes pressaient le pas pour échapper à Saül tandis que lui et ses hommes cherchaient à encercler David et ses compagnons pour s'emparer d'eux."
,"27":"Un messager vint alors trouver Saül pour lui dire: 'Dépêche-toi de venir, les Philistins ont envahi le pays.'"
,"28":"Saül renonça donc à poursuivre David et partit combattre les Philistins, c'est pourquoi on appela ce lieu la Roche des Séparations."
}`)
	CurrentBook.AddChapter(24, `{
"1":"De là David monta aux refuges d'Engadi et il s'y installa."
,"2":"Quand Saül revint de sa campagne contre les Philistins, on lui dit: 'David est au désert d'Engadi.'"
,"3":"Saül choisit alors parmi tout Israël trois mille hommes, et il partit avec eux à la recherche de David à l'est du Rocher des Bouquetins."
,"4":"Il arriva ainsi aux parcs à brebis qui sont au bord du chemin, il y avait là une grotte où Saül entra pour satisfaire ses besoins. Or David et ses hommes étaient assis au fond de la grotte."
,"5":"Les compagnons de David lui dirent: 'Aujourd'hui Yahvé livre ton ennemi entre tes mains. Tu peux lui faire maintenant tout ce que tu veux.'"
,"7":"Il dit à ses compagnons: 'Oh non! Par la vie de Yahvé, je ne porterai pas la main sur lui! Je ne peux pas faire à mon seigneur une chose semblable car il est l'élu de Yahvé!"
,"8":"Et par ses paroles David empêcha ses hommes de se jeter sur Saül. David se leva et alla couper en douce le pan du manteau de Saül,"
,"6":"mais après cela le coeur lui battait d'avoir coupé le pan du manteau de Saül. Saül se leva, sortit de la grotte et reprit son chemin. "
,"9":"A son tour David se leva et sortit de la grotte, il cria derrière Saül: 'Mon seigneur le roi!' Saül se retourna et David se prosterna la face contre terre."
,"10":"David dit alors à Saül: 'Pourquoi écoutes-tu ceux qui te disent que je cherche ta perte?"
,"11":"Regarde toi-même, aujourd'hui Yahvé t'avait livré entre mes mains dans cette grotte, et l'on m'avait même dit de te tuer, mais j'ai eu pitié de toi. Je me suis dit: Je ne porterai pas la main sur mon seigneur, car il est l'élu de Yahvé."
,"12":"Regarde, mon père, regarde le pan de ton manteau qui est dans ma main. Lorsque j'ai coupé le pan de ce manteau, j'aurais pu te tuer. Reconnaisdonc qu'il n'y a en moi ni malice ni méchanceté; je ne t'ai pas fait de tort, alors que toi tu me recherches pour me tuer."
,"13":"Que Yahvé juge entre moi et toi. Que Yahvé me venge de toi, mais ma main ne se dressera pas contre toi."
,"14":"Comme le dit le proverbe des anciens: C'est des méchants que sort la méchanceté. C'est pourquoi ma main ne se lèvera pas contre toi."
,"15":"Après qui le roi d'Israël s'est-il lancé? Qui poursuit-il? un chien mort, une simple puce?"
,"16":"Que Yahvé juge entre moi et toi. Qu'il examine et qu'il défende ma cause, qu'il me rende justice et me délivre de ta main.'"
,"17":"Lorsque David eut terminé de prononcer ces paroles, Saül dit: 'Est-ce bien ta voix, mon fils David?' Et Saül éclata en sanglots."
,"18":"Il dit à David: 'Tu es plus juste que moi, car tu m'as rendu le bien, et moi je t'avais fait le mal."
,"19":"Aujourd'hui tu as montré ta bonté envers moi, car Yahvé m'avait livré entre tes mains et tu ne m'as pas tué."
,"20":"Lorsqu'un homme rencontre son ennemi, le laisse-t-il poursuivre son chemin? Yahvé te récompensera du bien que tu m'as fait aujourd'hui."
,"21":"Dès maintenant je le sais: tu régneras et ta royauté en Israël sera inébranlable."
,"22":"Jure-moi donc par Yahvé que tu ne supprimeras pas ma descendance après moi et que tu ne feras pas disparaître mon nom de la famille de mon père.'"
,"23":"Alors David le jura à Saül. Et Saül retourna chez lui tandis que David et ses compagnons remontaient au refuge."
}`)
	CurrentBook.AddChapter(25, `{
"1":"En ce temps-là mourut Samuel. Tout Israël se rassembla et fit une lamentation sur lui; on l'enterra dans sa maison à Rama. David descendit alors au désert de Maon."
,"2":"Il y avait à Maon un homme dont l'exploitation se trouvait à Karmel. C'était un homme très important, il possédait trois mille brebis et mille chèvres; il était alors à Karmel pour la tonte de ses brebis."
,"3":"Cet homme s'appelait Nabal et sa femme, Abigayil. La femme avait du bon sens, elle était belle, mais l'homme était dur et méchant: il était du clan de Caleb."
,"4":"Alors qu'il était au désert, David apprit que Nabal faisait la tonte de ses brebis."
,"5":"David envoya dix de ses hommes avec cette recommandation: 'Montez à Karmel, entrez chez Nabal et vous le saluerez de ma part."
,"6":"Vous lui parlerez ainsi: Frère, salut à toi, paix à ta maison, paix sur tout ce qui t'appartient!"
,"7":"J'apprends que les tondeurs sont aujourd'hui chez toi. Tu dois le savoir, lorsque tes bergers étaient avec nous, nous ne leur avons pas créé de problèmes, rien de ce qui était à eux n'a disparu tout le temps qu'ils étaient à Karmel."
,"8":"Interroge tes serviteurs et ils te le diront. Fais donc aujourd'hui un geste pour mes gars, puisque nous arrivons en un jour de fête. Je t'en prie, donne à tes serviteurs et à ton fils David, ce que le coeur te dira.'"
,"9":"Les gars de David allèrent transmettre à Nabal le message de David, puis ils se reposèrent sur place."
,"10":"Nabal donna alors cette réponse aux serviteurs de David: 'Mais qui est David? Qui est le fils de Jessé? Il y a trop de serviteurs aujourd'hui qui s'échappent de chez leur maître!"
,"11":"Et j'irais prendre mon pain, mon vin, la viande des bêtes que j'ai égorgées pour les tondeurs, et je la donnerais à des gens qui viennent de je ne sais où!'"
,"12":"Les gars de David refirent le chemin; ils revinrent et rapportèrent à David toutes ces paroles."
,"13":"David leur dit: 'Que chacun de vous prenne son épée.' Chacun d'eux prit donc son épée et David prit la sienne. Ils étaient quatre cents qui montèrent derrière David, tandis que deux cents gardaient les bagages."
,"14":"Abigayil, la femme de Nabal, fut mise au courant par un de ses garçons; il lui dit: 'David avait envoyé, du désert, des messagers pour saluer notre maître, mais celui-ci les a renvoyés comme des malpropres."
,"15":"Pourtant ces hommes ont été très corrects avec nous, ils ne nous ont pas fait de mal durant tout le temps que nous avons passé dans la campagne, et nous n'avons rien perdu quand nous étions au milieu d'eux."
,"16":"Ils ont été pour nous comme un rempart, aussi bien la nuit que le jour, aussi longtemps que nous avons eu nos troupeaux au milieu d'eux."
,"17":"Maintenant penses-y et vois ce que tu dois faire, car le sort de notre maître et de toute sa maison est déjà décidé, et lui est trop mauvais pour qu'on puisse lui parler.'"
,"18":"Rapidement, Abigayil ramassa deux cents pains, deux outres de vin, cinq brebis déjà préparées, cinq mesures de grains grillés, cent grappes de raisins secs et deux gâteaux de figues; elle mit le tout sur des ânes."
,"19":"Puis elle dit aux garçons: 'Passez devant moi, je vous suis.' Mais elle ne dit rien à son mari Nabal."
,"20":"Montée sur un âne, elle descendit à l'abri de la montagne pendant que David et ses hommes descendaient dans le sens inverse."
,"21":"David se disait: 'C'est vraiment pour rien que j'ai protégé tout ce que cet homme avait dans le désert, et que rien de ce qui lui appartenait n'a disparu. Aujourd'hui, il me rend le mal pour le bien."
,"22":"Que Dieu maudisse David et le maudisse encore, si d'ici demain matin je laisse en vie un seul de ses hommes.'"
,"23":"En apercevant David, Abigayil sauta de son âne, elle tomba la face contre terre devant David et se prosterna."
,"24":"Ainsi prosternée à ses pieds, elle lui dit: 'Mon seigneur, pardonne mon audace. Permets à ta servante de dire un mot, écoute les paroles de ta servante."
,"25":"Que mon seigneur ne tienne pas compte de cette brute de Nabal: son nom veut dire Le Fou, et c'est bien la folie qui le mène. Et moi, ta servante, je n'ai pas pu voir les garçons que mon seigneur a envoyés."
,"26":"Par la vie de Yahvé et par ta propre vie, que tes ennemis et que tous ceux qui veulent du mal à mon seigneur, connaissent aujourd'hui le sort de Nabal! Mais regarde: Yahvé t'a empêché d'en venir au sang pour te faire justice toi-même."
,"27":"Que l'on remette aux jeunes gens qui accompagnent mon seigneur, les cadeaux que lui apporte aujourd'hui sa servante."
,"28":"Pardonne, je t'en prie, la faute de ta servante. Certainement Yahvé rendra inébranlable la maison de mon seigneur, car tu es le combattant des guerres de Yahvé et, de toute ta vie, on ne te prendra pas en faute."
,"29":"Si un homme veut te poursuivre et s'en prend à ta vie, l'âme de mon seigneur sera en sûreté auprès de Yahvé. Yahvé te protégera, alors qu'il lancera loin de lui, comme avec une fronde, l'âme de tes ennemis."
,"30":"Ainsi, lorsque Yahvé aura accompli à ton égard toutes les promesses qu'il t'a faites, lorsqu'il t'aura établi comme chef sur Israël,"
,"31":"tu ne pourras pas te reprocher d'avoir répandu le sang sans raison et de t'être fait justice toi-même. Lorsque Yahvé aura comblé mon seigneur, qu'il se souvienne de sa servante!'"
,"32":"David répondit à Abigayil: 'Béni soit Yahvé, le Dieu d'Israël, qui t'a envoyée à ma rencontre aujourd'hui!"
,"33":"Sois bénie pour ta prudence, sois bénie parce qu'aujourd'hui tu m'as empêché d'en venir au sang et de me faire justice moi-même."
,"34":"Car je te le jure par la vie de Yahvé, le Dieu d'Israël qui m'a empêché de te faire du mal, si tu n'étais venue aussi vite à ma rencontre, avant même le lever du soleil il ne serait pas resté à Nabal un seul homme en vie.'"
,"35":"David prit de sa main ce qu'elle lui avait apporté, puis il dit: 'Retourne en paix chez toi, je t'ai écoutée et je t'ai fait grâce.'"
,"36":"Lorsqu'Abigayil rentra, Nabal était attablé chez lui pour un festin royal. Nabal était tout joyeux, complètement ivre, et elle ne lui raconta rien jusqu'au lendemain matin."
,"37":"Mais le lendemain, lorsque Nabal eut cuvé son vin, sa femme lui raconta ce qui s'était passé. Il en eut une attaque et il devint comme une pierre."
,"38":"Environ dix jours plus tard, Yahvé frappa Nabal et il mourut."
,"39":"Lorsque David apprit que Nabal était mort, il dit: 'Béni soit Yahvé! Il a fait payer Nabal qui m'avait insulté, et il m'a épargné une mauvaise action. Yahvé a fait retomber sur la tête de Nabal sa propre méchanceté.' Alors David envoya dire à Abigayil qu'il la prendrait pour femme."
,"40":"Les serviteurs de David arrivèrent donc chez Abigayil, à Karmel, et ils lui dirent ceci: 'David nous a envoyés vers toi, il veut te prendre pour épouse.'"
,"41":"Elle se leva, se prosterna à terre et dit: 'Ta servante sera pour toi comme une esclave, pour laver les pieds des serviteurs de mon seigneur.'"
,"42":"Abigayil se décida aussitôt, elle monta sur son âne et cinq jeunes servantes la suivirent; elle partit derrière les envoyés de David et devint ainsi sa femme."
,"43":"David avait épousé également Ahinoam de Yizréel: toutes deux devinrent femmes de David."
,"44":"Pendant ce temps Saül avait donné sa fille Mikal, femme de David, à Pâti, fils de In de Gallim."
}`)
	CurrentBook.AddChapter(26, `{
"1":"Les gens de Ziph vinrent trouver Saül à Guibéa: 'Ne sais-tu pas, lui dirent-ils, que David est caché sur la colline Hakila, à l'est de la Steppe?'"
,"2":"Saül descendit aussitôt au désert de Ziph avec trois mille hommes d'élite d'Israël; il alla à la recherche de David dans le désert de Ziph."
,"3":"Alors que Saül campait sur la colline de Hakila, qui est sur le bord du chemin à l'est de la Steppe, David, qui séjournait au désert, fut averti que Saül venait le rejoindre dans son désert."
,"4":"Il envoya des espions et il sut que Saül arrivait."
,"5":"Alors David vint à l'endroit même où Saül campait. David reconnut l'endroit où étaient couchés Saül et Abner, fils de Ner, le chef de l'armée. Saül était couché au centre et les gens de sa troupe étaient tout autour."
,"6":"David demanda à Ahimélek le Hittite et à Abisaï fils de Sérouyah, frère de Joab: 'Qui ira avec moi jusqu'à Saül au milieu de son camp?' Abisaï répondit: 'J'irai avec toi.'"
,"7":"David et Abisaï arrivèrent donc de nuit jusqu'à la troupe. Saül dormait au milieu du camp et sa lance était plantée en terre à côté de lui, et tous ses hommes dormaient autour de lui."
,"8":"Abisaï dit alors à David: 'Aujourd'hui Dieu a livré ton ennemi entre tes mains. Laisse-moi le clouer à terre avec sa lance, je n'aurai pas besoin de m'y reprendre à deux fois.'"
,"9":"Mais David répondit à Abisaï: 'Ne le tue pas! Peux-tu porter la main sur celui que Yahvé a consacré, et rester impuni?'"
,"10":"David dit encore: 'Aussi vrai que Yahvé est vivant, c'est Yahvé lui-même qui le frappera; ou bien il mourra parce que ce sera son jour, ou bien il ira au combat et il y restera."
,"11":"Mais je ne porterai pas la main sur celui que Yahvé a consacré. Prends seulement la lance qui est à côté de lui et la cruche d'eau, et allons-nous en.'"
,"12":"David prit la lance et la cruche qui étaient à côté de Saül et ils partirent. Personne ne le vit, personne ne sut, personne ne bougea; tous dormaient, et Yahvé avait envoyé sur eux un sommeil de plomb."
,"13":"David passa de l'autre côté et il se tint à distance sur le sommet de la montagne; un grand espace les séparait."
,"14":"David appela alors les hommes de troupe et Abner, fils de Ner: 'Ne répondras-tu pas Abner?' Abner répondit: 'Qu'as-tu à m'appeler?'"
,"15":"David dit à Abner: 'N'es-tu pas un homme, et qui n'a pas son pareil en Israël? Pourquoi donc as-tu gardé si mal le roi, ton seigneur? Quelqu'un est entré et il voulait tuer le roi, ton seigneur."
,"16":"Tu as bien mal agi; aussi vrai que Yahvé est vivant, vous méritez la mort pour n'avoir pas gardé votre maître, celui que Yahvé a consacré. Regarde donc où sont la lance et la cruche d'eau qui étaient à côté du roi?'"
,"17":"Saül reconnut la voix de David et dit: 'Est-ce ta voix, mon fils David!' David répondit: 'Oui, c'est moi, mon seigneur le roi!'"
,"18":"Il ajouta: 'Pourquoi mon seigneur se lance-t-il à la poursuite de son serviteur? Qu'ai-je fait? Quel crime ai-je commis?"
,"19":"Que mon seigneur veuille bien écouter les paroles de son serviteur. Si c'est Yahvé qui t'a excité contre moi, je lui présenterai une offrande pour l'apaiser. Mais si ce sont des hommes, que Yahvé les maudisse, car aujourd'hui ils m'ont chassé de l'héritage de Yahvé, comme s'ils disaient: Va et sers d'autres dieux!"
,"20":"Et le roi d'Israël est parti aujourd'hui en expédition pour chasser un homme comme s'il poursuivait une perdrix dans la montagne. Que mon sang ne tombe pas sur une terre étrangère, loin de Yahvé!'"
,"21":"Saül lui répondit: 'J'ai péché! Reviens, mon fils David, je ne te ferai plus de mal. Aujourd'hui tu as respecté ma vie, et moi, je me suis conduit comme un insensé, j'ai commis un grand péché!'"
,"22":"David lui dit: 'Voici ta lance, mon seigneur, que l'un des jeunes gens vienne la chercher."
,"23":"Yahvé rendra à chacun selon sa justice et sa fidélité. Aujourd'hui Yahvé t'avait livré entre mes mains et je n'ai pas voulu porter la main sur celui que Yahvé a consacré."
,"24":"Puisque aujourd'hui j'ai eu pour ta vie un très grand respect, Yahvé aura pour la mienne un très grand respect et il me délivrera de tout péril.'"
,"25":"Saül dit à David: 'Mon fils, sois béni. Tu réussiras certainement dans tout ce que tu feras.',Après cela David continua son chemin et Saül rentra chez lui."
}`)
	CurrentBook.AddChapter(27, `{
"1":"David se dit en lui-même: 'Un jour ou l'autre Saül va me tuer. Il vaut mieux que je me réfugie chez les Philistins: Saül cessera de me rechercher dans tout le pays d'Israël et j'échapperai à sa main.'"
,"2":"David passa donc avec ses six cents hommes chez le roi de Gat, Akish fils de Maok."
,"3":"David s'installa avec ses hommes auprès d'Akish, à Gat. Chacun était venu avec sa famille, David avec ses deux femmes: Ahinoam de Yizréel et Abigayil, femme de Nabal de Karmel."
,"4":"On fit savoir à Saül que David s'était enfui à Gat, et Saül cessa de le rechercher."
,"5":"David dit à Akish: 'Si vraiment j'ai conquis ton amitié, donne-moi une place dans l'une des villes des environs et je m'y installerai. Il n'y a aucune raison pour que j'habite à côté de toi dans la capitale.'"
,"6":"Akish ce jour-là lui donna Siklag et depuis ce jour, Siklag appartient aux rois de Juda."
,"7":"David resta en territoire philistin pendant un an et quatre mois."
,"8":"David et ses hommes partirent en expédition contre les Géchourites, les Girzites et les Amalécites: ces tribus occupent la région qui s'étend de Télam en direction de Chour et de l'Egypte."
,"9":"David ravageait la contrée; il ne laissait en vie ni homme ni femme, il enlevait les brebis, les boeufs, les ânes, les chameaux et tous les vêtements; ensuite il revenait chez Akish."
,"10":"Akich lui disait: 'Où avez-vous fait une expédition aujourd'hui?' Et David répondait: 'Dans le Négueb de Juda', ou:'Dans le Négueb de Yérahméel', ou: 'Dans le Négueb des Kénites.'"
,"11":"David ne laissait en vie ni homme ni femme, il ne voulait pas ramener à Gat quelqu'un qui aurait pu lui faire du tort et dire: 'Voici ce qu'a fait David.',Telle fut la façon d'agir de David tout le temps où il séjourna chez les Philistins. "
,"12":"Mais Akich faisait confiance à David, il se disait même: 'Les Israélites, les gens de son peuple, ne peuvent sûrement plus le sentir, il restera donc pour toujours à mon service.'"
}`)
	CurrentBook.AddChapter(28, `{
"1":"En ces jours-là les Philistins rassemblèrent toutes leurs troupes en une seule armée pour combattre Israël. Akich dit à David: 'Je veux te faire savoir que tu vas venir avec moi à la guerre avec tous tes hommes.'"
,"2":"David répondit à Akich: 'Ainsi tu sauras toi aussi de quoi est capable ton serviteur.' Akish dit encore à David: 'Dès à présent je te fais le gardien de ma personne.'"
,"3":"On sait que Samuel était mort, que tout Israël l'avait pleuré et qu'on l'avait enterré dans sa ville, à Rama. Disons aussi que Saül avait fait disparaître du pays tous les devins, ceux qui évoquent les esprits des morts."
,"4":"Les Philistins se rassemblèrent à Sunem et ils y établirent leur camp. Saül aussi rassembla tout Israël: il installa son camp à Guelboé."
,"5":"Lorsque Saül vit le camp des Philistins, il eut peur et son coeur trembla."
,"6":"Saül consulta Yahvé, mais Yahvé ne répondit, ni par les songes, ni par l'ourim, ni par les prophètes."
,"7":"Saül dit alors à ses serviteurs: 'Cherchez-moi une femme qui évoque les morts et j'irai la consulter.' Ses serviteurs lui dirent: 'Il y a à En-Dor une femme qui évoque les morts.'"
,"8":"Saül se déguisa, il mit d'autres habits et partit, accompagné de deux hommes. Ils arrivèrent à la nuit chez cette femme et Saül lui dit: 'Annonce-moi l'avenir en évoquant les esprits: tu feras monter du séjour des morts celui que je te dirai.'"
,"9":"La femme répondit: 'Tu dois bien savoir que Saül a fait disparaître du pays tous les devins et ceux qui évoquent les esprits; tu me tends peut-être un piège?'"
,"10":"Saül lui fit ce serment par Yahvé: 'Aussi vrai que Yahvé est vivant, il ne t'arrivera aucun mal pour cela.'"
,"11":"La femme lui dit: 'Qui ferai-je monter du séjour des morts?' Il répondit: 'Fais monter Samuel.'"
,"12":"La femme vit Samuel et elle poussa un grand cri. Elle dit à Saül: 'Pourquoi m'as-tu trompée? Tu es Saül!'"
,"13":"Le roi lui dit: 'N'aie pas peur. Qu'as-tu vu?' La femme dit: 'Je vois un être supérieur qui monte du profond de la terre.'"
,"14":"Saül demanda: 'Comment est-il?' Elle répondit: 'C'est un vieillard qui monte, enveloppé dans son manteau.',Saül comprit que c'était Samuel, il s'agenouilla, la face contre terre, et se prosterna. "
,"15":"Samuel dit alors à Saül: 'Pourquoi m'as-tu dérangé et me fais-tu monter du séjour des morts?' Saül répondit: 'Je suis dans une grande détresse, les Philistins me font la guerre, Dieu s'est retiré de moi et ne me répond plus ni par les prophètes ni par les songes. Je t'ai donc appelé pour que tu me dises ce que je dois faire.'"
,"16":"Samuel lui dit: 'Pourquoi me consultes-tu? Parce que Yahvé s'est retiré de toi et qu'il est maintenant avec ton prochain?"
,"17":"Yahvé a réalisé ce qu'il m'avait chargé de t'annoncer: il a arraché la royauté de ta main et l'a donnée à ton serviteur David."
,"18":"Yahvé a agi de la sorte envers toi parce que tu ne lui as pas obéi et que tu n'as pas fait tomber sur Amalec le poids de sa colère."
,"19":"Yahvé va te livrer, et il livrera Israël avec toi aux mains des Philistins. Demain, toi et tes fils vous serez ici avec moi, et Yahvé livrera le camp d'Israël entre les mains des Philistins."
,"20":"Saül tomba à terre de tout son long, car les paroles de Samuel l'avaient glacé d'effroi; de plus les forces lui manquaient, car il n'avait rien mangé durant ce jour, ni de toute la nuit."
,"21":"Voyant combien il était abattu, la femme s'approcha de Saül et lui dit: 'Ta servante t'a obéi, j'ai risqué ma vie pour obéir à ta demande."
,"22":"Ecoute-moi donc maintenant, accepte ce morceau de pain que je t'offre, mange et reprends des forces pour continuer ton chemin.'"
,"23":"Mais il refusait et disait: 'Je ne mangerai rien.' Les serviteurs et la femme insistèrent tellement qu'il finit par les écouter: il se leva et s'assit sur le divan."
,"24":"La femme avait un veau gras, elle se dépêcha de le tuer. Elle prit de la farine, elle la pétrit et en fit des pains sans levain,"
,"25":"puis elle servit ce repas à Saül et à ses serviteurs. Ils mangèrent, puis ils se levèrent et, cette même nuit, ils repartirent."
}`)
	CurrentBook.AddChapter(29, `{
"1":"Les Philistins rassemblèrent toutes leurs troupes à Afek, tandis que les Israélites campaient à côté de la source qui se trouve dans la plaine de Yizréel."
,"2":"Les chefs des Philistins défilaient avec leurs groupes de cent et de mille; David et ses hommes étaient à l'arrière-garde avec Akich."
,"3":"Les chefs des Philistins demandèrent à Akich: 'Qui sont ces Hébreux?' Akich leur répondit: 'Mais c'est David, le serviteur de Saül, roi d'Israël. Depuis longtemps, deux ans peut-être, il est chez moi, et je n'ai jamais eu à me plaindre de lui depuis quest passé de mon côté.'"
,"4":"Les chefs des Philistins se mirent en colère contre Akich, ils lui dirent: 'Renvoie cet homme, et qu'il retourne d'où il vient! Qu'il ne vienne pas avec nous à la bataille, il pourrait bien se retourner contre nous. Comment pourrait-il acheter le pardon de son maître, sinon avec les têtes de nos hommes?"
,"5":"N'est-ce pas à propos de ce David que l'on dansait en chantant: Saül en a tué mille, mais David en a tué dix mille?'"
,"6":"Akich appela donc David et lui dit: 'Aussi vrai que Yahvé est vivant, tu es un homme droit. Pour ma part, je suis heureux que tu sois ici avec moi, car tu n'as mérité aucun reproche depuis que tu es arrivé jusqu'à maintenant, mais tu es très mal vu des chefs."
,"7":"Retourne donc, va-t'en en paix et n'indisposons pas les chefs des Philistins.'"
,"8":"David dit à Akich: 'Qu'ai-je donc fait? Qu'as-tu à reprocher à ton serviteur depuis que je suis venu jusqu'à maintenant, pour que tu me refuses de combattre les ennemis de mon seigneur le roi?'"
,"9":"Akich répondit à David: 'Je le sais, tu es aussi sûr pour nous qu'un ange de Dieu, mais les chefs des Philistins ont décidé que tu ne viendrais pas avec nous à la bataille."
,"10":"Levez-vous donc de bon matin, toi et les serviteurs de ton maître qui sont venus avec toi, et retournez à l'endroit que je vous ai assigné. Ne le prends pas mal, tu sais que je t'estime. Demain matin vous vous lèverez tôt, et dès que le jour se lèvera vous partirez.'"
,"11":"David et ses hommes se levèrent donc de bonne heure; dès le matin ils repartirent pour le pays des Philistins; quant aux Philistins, ils montèrent vers Yizréel."
}`)
	CurrentBook.AddChapter(30, `{
"1":"David arriva le surlendemain à Siklag avec ses hommes. Or les Amalécites avaient fait un raid dans le Négueb jusqu'à Siklag, ils avaient frappé la ville et l'avaient incendiée."
,"2":"Ils avaient capturé les femmes et tous ceux qui s'y trouvaient, petits et grands, mais sans tuer personne; et ils avaient repris leur route en emmenant tout le monde."
,"3":"Lorsque David et ses compagnons arrivèrent à la ville, ils la trouvèrent incendiée: leurs femmes, leurs fils et leurs filles avaient été emmenés."
,"4":"David et le peuple qui l'accompagnait se mirent à crier et à pleurer jusqu'à ce qu'ils n'aient plus la force de pleurer."
,"5":"Les deux femmes de David, Ahinoam de Yizréel et Abigayil femme de Nabal de Karmel, avaient été aussi emmenées captives."
,"6":"David se vit dans une grande détresse car ses gens parlaient de le lapider, tellement chacun se désespérait à cause de ses fils et de ses filles. Mais David reprit courage en Yahvé son Dieu."
,"7":"David dit au prêtre Ebyatar, fils d'Ahimélek: 'Apporte-moi l'éphod.' Ebyatar apporta l'éphod à David."
,"8":"David consulta Yahvé: 'Dois-je poursuivre cette bande? Est-ce que je la rattraperai?' La réponse fut: 'Poursuis-les, tu les rattraperas et tu délivreras les captifs.'"
,"9":"David partit; six cents compagnons marchèrent avec lui jusqu'au torrent de Bésor,"
,"10":"mais quatre cents seulement continuèrent la poursuite avec David, car les deux cents autres s'étaient arrêtés, trop fatigués pour traverser le torrent de Bésor."
,"11":"Ils trouvèrent dans la campagne un Egyptien et le conduisirent à David. Ils lui donnèrent du pain et de l'eau, il mangea et il but."
,"12":"Ils lui donnèrent encore une tranche d'un gâteau de figues et deux grappes de raisins secs, il mangea et ses esprits lui revinrent, car il n'avait pas mangé ni bu depuis trois jours et trois nuits."
,"13":"David lui dit: 'A qui appartiens-tu et d'où viens-tu?' Il dit: 'Je suis un jeune Egyptien esclave d'un Amalécite; mon maître m'a abandonné depuis trois jours car j'étais malade."
,"14":"Nous avons fait une expédition dans le Négueb des Kérétiens, dans le Négueb de Juda et dans le Négueb de Caleb; nous avons brûlé Siklag.'"
,"15":"David lui dit: 'Peux-tu nous conduire vers ces pillards?' Il répondit: 'Jure-moi par ton Dieu de ne pas me tuer et de ne pas me livrer à mon maître, et je te conduirai vers ces pillards.'"
,"16":"Il le conduisit donc. Les pillards étaient dispersés, mangeant, buvant, faisant la fête avec tout le butin qu'ils avaient ramassé au pays des Philistins et au pays de Juda."
,"17":"David les massacra depuis l'aube jusqu'au soir et les extermina, pas un d'entre eux n'échappa sauf quatre cents jeunes qui s'étaient enfuis sur des chameaux."
,"18":"David récupéra tout ce que les Amalécites avaient pris; il récupéra entre autres ses deux femmes."
,"19":"Rien ne fut laissé aux Amalécites, petit ou grand, garçon ou fille; rien non plus de tout le butin qu'ils avaient ramassé: David ramena tout."
,"20":"David prit leur petit et leur gros bétail, et l'on poussait ce troupeau devant lui en disant: 'Voilà le butin de David!'"
,"21":"Lorsque David arriva près des deux cents hommes qui s'étaient arrêtés, trop fatigués, au torrent de Bésor, ils vinrent au-devant de lui et de la troupe qui l'accompagnait. David s'avança vers eux et les salua,"
,"22":"mais parmi ceux qui l'accompagnaient, les plus mauvais et méchants prirent la parole: 'Puisque ces hommes ne sont pas venus avec nous, nous ne leur donnerons rien du butin que nous avons récupéré. Nous ne leur rendrons que leurs femmes et leurs fils, ils les emmèneront et partiront.'"
,"23":"Mais David leur dit: 'Non, frères, ne faites pas cela après ce que Yahvé a fait pour vous. Voyez qu'il nous a protégés, il a livré entre nos mains cette bande de pillards qui étaient venus nous attaquer."
,"24":"Qui pourrait être d'accord avec vous? Le combattant et celui qui garde les bagages auront part égale.'"
,"25":"Depuis ce jour, cette façon de faire a été la règle et est devenue une coutume en Israël."
,"26":"Une fois rentré à Siklag, David envoya une part du butin aux anciens de Juda; il leur dit: 'Voici pour vous un cadeau sur le butin que nous avons pris aux ennemis de Yahvé.'"
,"27":"Il l'envoya à Bétoul, à Rama du Négueb, à Yattir,"
,"28":"à Aroër, à Sifmot, à Echtémoa,"
,"29":"à Karmel, dans les villes de Yérahméel, dans les villes des Kénites,"
,"30":"à Horma, à Bor-Achan, à Eter,"
,"31":"à Hébron, et dans tous les endroits que David avait fréquentés avec ses compagnons: chacun eut sa part."
}`)
	CurrentBook.AddChapter(31, `{
"1":"Les Philistins attaquèrent Israël, et les hommes d'Israël prirent la fuite devant les Philistins. Beaucoup tombèrent blessés à mort sur les monts de Guelboé."
,"2":"Les Philistins s'acharnèrent sur Saül et ses fils, ils tuèrent Jonathan, Abinadab et Malkichoua, les trois fils de Saül."
,"3":"Puis ils reportèrent le combat contre Saül; les archers l'avaient découvert, ils le blessèrent très sérieusement."
,"4":"Alors Saül dit à son écuyer: 'Prends ton épée et tue-moi, de peur que ces incirconcis ne viennent eux-mêmes me tuer et m'outrager.' Son écuyer ne voulait pas le faire car il avait peur, alors Saül prit lui-même son épée et se jeta dessus."
,"5":"Voyant que Saül était mort, l'écuyer se jeta aussi sur son épée et mourut avec lui."
,"6":"C'est ainsi que dans la même journée Saül et ses trois fils, son écuyer et tous ses hommes, moururent."
,"7":"Lorsqu'on sut que les Israélites avaient pris la fuite et que Saül et ses fils étaient morts, les Israélites qui étaient de l'autre côté de la plaine et ceux qui étaient du côté du Jourdain, abandonnèrent leurs villes et s'enfuirent. Les Philistins arrivèrent ensuite et s'installèrent à leur place."
,"8":"Le lendemain les Philistins vinrent dépouiller les morts; ils trouvèrent Saül et ses trois fils morts sur les monts de Guelboé."
,"9":"Ils lui coupèrent la tête et lui enlevèrent ses armes, puis ils envoyèrent publier la nouvelle dans tout le pays des Philistins, dans les temples de leurs idoles et parmi le peuple."
,"10":"Ils déposèrent les armes de Saül dans le temple d'Astarté et suspendirent son cadavre aux remparts de Beth-Chéan."
,"11":"Lorsque les habitants de Yabech de Galaad surent ce que les Philistins avaient fait à Saül,"
,"12":"les plus vaillants d'entre eux partirent et marchèrent toute la nuit. Ils enlevèrent des remparts de Beth-Chéan les corps de Saül et de ses fils, puis ils revinrent à Yabech où ils les brûlèrent."
,"13":"Ils prirent leurs ossements et les enterrèrent sous le tamaris de Yabesh, puis ils jeûnèrent durant sept jours."
}`)

}
func FR_LBDCC_LoadVH2MChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Salut aux frères Juifs qui sont en Egypte! Leurs frères Juifs de Jérusalem et du pays de Judée leur souhaitent une véritable paix."
,"2":"Que Dieu vous comble de ses bienfaits, qu'il se souvienne de son Alliance avec Abraham, Isaac et Jacob, ses fidèles serviteurs."
,"3":"Qu'il vous donne à tous un coeur pour l'adorer et faire sa volonté généreusement et sincèrement."
,"4":"Qu'il ouvre votre coeur à sa Loi et à ses commandements et qu'il y mette la paix."
,"5":"Qu'il écoute vos prières et se réconcilie avec vous, qu'il ne vous abandonne pas au jour du malheur."
,"6":"Quant à nous, nous prions d'ici pour vous."
,"7":"Nous, les Juifs, nous vous avions déjà écrit en l'an cent soixante-neuf, sous le règne de Démétrius, au plus fort de l'épreuve qui tomba sur nous ces années-là, lorsque Jason et ses partisans trahirent la cause de la Terre Sainte et du royaume,"
,"8":"brûlèrent la porte du Temple et répandirent le sang innocent. Mais nous nous sommes tournés vers le Seigneur et nous avons été exaucés. Maintenant nous pouvons offrir le sacrifice et l'offrande de fleur de farine, nous allumons les lampes et exposons les pains de l'offrande."
,"9":"Aussi nous vous invitons à célébrer les jours de la fête des Tentes au mois de Kasleu."
,"10":"Date de cette lettre: cette année cent quatre-vingt-huit.','Les habitants de Jérusalem et de Judée, le Sénat et Judas, saluent et souhaitent bonne santé à Aristobule, conseiller du roi Ptolémée et membre de la famille des prêtres consacrés, ainsi qu'aux Juifs qui sont en Egypte. "
,"11":"Nous venons d'être sauvés par Dieu de grands dangers, et nous le remercions beaucoup de nous avoir soutenus contre le roi."
,"12":"Lui-même a éliminé ceux qui s'étaient avancés en armes contre la Ville Sainte."
,"13":"En effet, leur chef était parti en Perse avec une armée que tous croyaient invincible, mais ils ont été massacrés dans le temple de Nanaïa, grâce à une ruse des prêtres de la déesse."
,"14":"Antiocus s'était rendu en ce lieu sous prétexte d'épouser la déesse Nanaïa, mais en fait il voulait se faire donner le trésor à titre de dot."
,"15":"Les prêtres du temple de Nanaïa avaient exposé le trésor et Antiocus était entré avec quelques amis dans l'intérieur du temple; mais les prêtres fermèrent les portes derrière lui"
,"16":"et, après avoir ouvert une trappe secrète dans le plafond, ils l'assommèrent sous les pierres. Ensuite ils le mirent en pièces et jetèrent sa tête à ceux qui se trouvaient dehors."
,"17":"Que notre Dieu soit béni en toutes choses, lui qui a livré les impies à la mort!"
,"18":"Puisque nous allons célébrer la purification du Temple le vingt-cinq du mois de Kasleu, nous avons pensé bon de vous le dire, pour que vous la célébriez vous aussi comme on célèbre la fête des Tentes et la fête du Feu qui se manifesta lorsque Néhémie offrit des sacrifices après avoir reconstruit le sanctuaire et l'autel."
,"19":"Vous devez savoir en effet que, lorsque nos pères ont été emmenés en Perse, les prêtres zélés de cette époque avaient pris du feu de l'autel; ils l'avaient caché secrètement dans un trou tout pareil à un puits sec, et ils l'avaient mis si bien en sûreté que tout le monde ignorait cet endroit."
,"20":"Au bout de nombreuses années, selon le bon plaisir de Dieu, le roi de Perse envoya Néhémie. Il fit alors rechercher le feu par les descendants des prêtres qui l'avaient caché. Quand ils expliquèrent qu'ils n'avaient pas trouvé de feu mais un liquide épais, Néhémie leur ordonna d'en puiser et de l'apporter."
,"21":"Au moment où les sacrifices étaient prêts, Néhémie ordonna aux prêtres de répandre ce liquide sur le bois et sur les offrandes que l'on avait placées dessus;"
,"22":"on fit donc comme il l'avait ordonné. Jusque-là le soleil était caché par les nuages, mais lorsque tout à coup il resplendit, un grand feu s'alluma: tout le monde était dans l'admiration."
,"23":"Pendant que les offrandes brûlaient, les prêtres faisaient la prière avec tous ceux qui étaient présents. Jonathan et les prêtres commençaient, et Néhémie avec les autres répondaient."
,"24":"Voici ce que disait cette prière: 'Seigneur! Seigneur Dieu, créateur de toute chose, tu es terrible et fort, juste et plein de miséricorde! Toi seul es roi, toi seul es bon,"
,"25":"toi seul généreux, juste, tout-puissant et éternel. Tu sauves Israël de tout mal, tu as choisi nos pères et tu les as sanctifiés."
,"26":"Reçois ce sacrifice au nom de tout ton peuple Israël, garde ton héritage et sanctifie-le."
,"27":"Rassemble ceux d'entre nous qui sont dispersés, délivre ceux qui sont captifs au milieu des nations, regarde avec bonté ceux que l'on méprise et que l'on compte pour rien; ainsi les nations sauront que tu es notre Dieu."
,"28":"Corrige ceux qui nous persécutent et qui nous méprisent méchamment."
,"29":"Installe ton peuple dans ton Lieu Saint comme Moïse l'a promis.'"
,"30":"Les prêtres accompagnaient les cantiques sur la harpe."
,"31":"Lorsque le sacrifice fut entièrement brûlé, Néhémie ordonna de verser le reste du liquide sur des grandes pierres;"
,"32":"un feu s'alluma mais il fut vite éclipsé par l'éclat du feu de l'autel."
,"33":"Tout cela vint à se savoir, on fit même ce rapport au roi des Perses: Dans le lieu où les prêtres avaient caché le feu au moment de la déportation, on a trouvé un liquide avec lequel Néhémie et ses compagnons ont consumé les offrandes saintes."
,"34":"Le roi fit vérifier le fait, puis il clôtura le lieu et en fit un sanctuaire."
,"35":"Le roi en tira des revenus importants qui lui permettaient de faire des dons."
,"36":"Néhémie et ses hommes appelèrent ce liquide 'nephtar', ce qui veut dire purification, mais habituellement on l'appelle naphte."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Dans les archives on lit que le prophète Jérémie donna aux déportés l'ordre de prendre du feu comme on l'a déjà dit."
,"2":"On y voit aussi que le prophète recommanda aux déportés de ne pas oublier les commandements du Seigneur et de ne pas se laisser séduire quand ils verraient des statues d'or et d'argent ornées et habillées."
,"3":"De mille manières il leur recommanda de ne pas laisser la Loi s'éloigner de leur coeur."
,"4":"Voici ce qu'on lit encore dans ces mêmes archives: sur un ordre de Dieu, le prophète prit avec lui la Tente et l'Arche, il monta sur la montagne où Moïse était monté et d'où il avait contemplé l'héritage de Dieu."
,"5":"En arrivant là, Jérémie trouva une habitation en forme de grotte, il y déposa la Tente et l'Arche avec l'autel des parfums et il en boucha l'entrée."
,"6":"Quelques-uns de ses compagnons vinrent ensuite pour marquer le chemin avec des repères, mais ils ne purent le retrouver."
,"7":"Lorsque Jérémie l'apprit, il leur fit des reproches: 'Ce lieu, leur dit-il, doit rester caché jusqu'au jour où Dieu rassemblera son peuple et lui fera miséricorde."
,"8":"Alors le Seigneur révélera tout cela, la Gloire du Seigneur apparaîtra avec la nuée comme elle est apparue au temps de Moïse, ou quand Salomon prononça la prière pour la consécration solennelle du Temple.'"
,"9":"A propos du sacrifice que ce roi plein de sagesse offrit pour la dédicace et l'achèvement du Temple on lit encore ceci dans ces écrits:"
,"10":"tout comme Moïse avait prié le Seigneur et un feu tombé du ciel avait consumé la victime, de même à la prière de Salomon le feu descendit et consuma les holocaustes."
,"11":"Moïse l'avait dit: Parce que la victime pour le péché n'a pas été mangée, elle a été consumée."
,"12":"Ce fut pareil lorsque Salomon célébra les huit jours de fête de la Dédicace."
,"13":"Tout ceci était raconté dans les archives et dans les mémoires du temps de Néhémie. On y apprend encore que Néhémie fonda une bibliothèque et y rassembla les livres concernant les rois et les prophètes, les livres de David et les instructions des rois à propos des sacrifices."
,"14":"De même Judas vient de rassembler tous les livres qui avaient été dispersés pendant la guerre que nous avons connue; ils sont entre nos mains."
,"15":"Si donc vous avez besoin de ces livres, envoyez-nous des messagers qui vous les porteront."
,"16":"Nous vous envoyons cette lettre alors que nous allons célébrer la fête de la Purification: vous ferez bien de célébrer ces jours avec nous."
,"17":"Dieu a délivré tout son peuple; il a rendu à tous l'héritage, faisant d'eux un royaume, un sacerdoce et un peuple saint,"
,"18":"comme il l'a dit dans la Loi. Nous espérons qu'il aura bientôt pitié de nous et qu'il nous rassemblera de toutes les nations qui sont sous le ciel dans le Lieu Saint. Il nous a en effet arrachés à de grands malheurs et a purifié le Temple."
,"19":"L'histoire de Judas Maccabée et de ses frères, la purification du Temple sublime, la dédicace de l'autel,"
,"20":"les guerres contre Antiocus Epiphane et son fils Eupator,"
,"21":"les manifestations célestes qui ont eu lieu en faveur de ceux qui luttaient héroïquement pour le Judaïsme - car malgré leur petit nombre ils ont reconquis toute la région et mis en fuite les armées barbares,"
,"22":"ils ont repris le Temple célèbre dans tout l'univers, délivré la ville et rétabli les lois qu'on voulait abolir, lorsque le Seigneur toujours juste leur a été favorable -"
,"23":"tout cela a été exposé par Jason de Cyrène en cinq livres que nous essaierons de résumer en un seul."
,"24":"La documentation y est très abondante, il s'y trouve une grande quantité de chiffres, et nous mesurons la difficulté qu'éprouvent ceux qui veulent suivre dans tous leurs détails les récits de l'histoire."
,"25":"C'est pourquoi nous avons eu le souci d'offrir un texte agréable à ceux qui se contentent d'une simple lecture, un texte pratique pour ceux qui aiment garder la mémoire des faits, un texte utile à tous sans distinction."
,"26":"Cela n'a pas été pour nous une tâche facile que d'entreprendre ce résumé; nous y avons dépensé beaucoup de sueur et de veilles."
,"27":"C'était tout comme organiser un grand repas pour la satisfaction des invités. Nous aussi nous avons accepté ce fardeau pour rendre service à beaucoup de gens."
,"28":"Nous souhaitions rester dans le cadre d'un simple résumé et nous avons laissé à l'auteur le soin de traiter chaque chose en détail."
,"29":"Je pense que nous sommes un peu comme l'architecte d'une maison neuve qui doit avoir à l'esprit l'ensemble de la construction, alors que celui qui se charge des peintures et de la cire étudie ce qui convient le mieux pour la décoration."
,"30":"Celui qui écrit l'histoire doit approfondir les questions, rendre compte de tout, étudier avec attention les détails,"
,"31":"mais il faut accepter de celui qui résume, qu'il cherche d'abord à faire un texte bref, sans se laisser entraîner dans les détails du récit."
,"32":"Commençons donc ici notre récit, sans rien ajouter à ce qui est déjà dit, car ce serait ridicule d'être long dans la préface de l'ouvrage, et bref ensuite pour l'histoire elle-même."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Au temps où les habitants de la Ville Sainte connaissaient une véritable paix, en un temps où les lois étaient scrupuleusement observées grâce à la piété du grand prêtre Onias qui détestait le mal,"
,"2":"il arrivait que les rois eux-mêmes honorent le Saint Lieu et ornent le Temple de dons magnifiques."
,"3":"C'est ainsi que Séleucus roi d'Asie assurait par ses revenus personnels toutes les dépenses nécessaires au service des sacrifices."
,"4":"Mais il arriva qu'un certain Simon, de la tribu de Benjamin, qui était administrateur du Temple, entra en conflit avec le grand prêtre au sujet de la police des marchés de la ville."
,"5":"Comme il n'arrivait pas à imposer son point de vue à Onias, il alla trouver Apollonius fils de Thraséos, qui était à cette époque le gouverneur de Coelé-Syrie et de Phénicie."
,"6":"Il lui raconta que le trésor de Jérusalem contenait des sommes énormes, une quantité incroyable de richesses qui n'avaient pas de rapport avec les dépenses nécessaires pour les sacrifices: il serait donc possible de faire passer tout ce trésor dans les mains du roi."
,"7":"Au cours d'une rencontre avec le roi, Apollonius lui parla des richesses qu'on lui avait signalées et le roi choisit Héliodore, qui était à la tête des affaires de l'Etat; il l'envoya avec l'ordre de confisquer toutes les richesses dont on avait parlé."
,"8":"Aussitôt Héliodore se mit en route sous prétexte d'inspecter les villes de Coelé-Syrie et de Phénicie, mais en fait pour exécuter l'ordre du roi."
,"9":"Arrivé à Jérusalem, Héliodore fut reçu amicalement par le grand prêtre et par la ville. Il raconta alors ce qu'on lui avait dit, il dévoila le but de sa visite et demanda si tout cela était exact."
,"10":"Le grand prêtre lui expliqua que le trésor contenait les dépôts des veuves et des orphelins,"
,"11":"qu'une partie appartenait à Hyrcan fils de Tobie, un homme très important, mais que contrairement aux mensonges de Simon, cet homme impie, le trésor se réduisait à quatre cents talents d'argent et deux cents talents d'or."
,"12":"Il était d'autre part impossible de dépouiller ceux qui avaient mis leur confiance dans la sainteté de ce lieu et dans la majesté intouchable d'un temple vénéré dans tout l'univers."
,"13":"Mais Héliodore, en vertu des ordres qu'il avait reçus du roi, soutenait que de toute façon cet argent devait être confisqué au profit du trésor royal."
,"14":"Au jour qu'il avait fixé pour entrer dans la salle du trésor et pour faire le compte de toutes ces richesses, la ville entière était retournée."
,"15":"Les prêtres s'étaient prosternés devant l'autel, revêtus de leurs habits sacerdotaux; ils invoquaient le Ciel qui avait donné la loi sur les dépôts, ils lui demandaient de conserver ces biens intacts à ceux qui les avaient déposés."
,"16":"En voyant le visage du grand prêtre on était bouleversé, car son visage défait, sa pâleur, montraient bien l'angoisse de son âme."
,"17":"Il était pris d'une frayeur qui faisait trembler tout son corps, et tous étaient témoins de la souffrance qu'il ressentait."
,"18":"Les habitants se précipitaient par groupes hors des maisons et priaient pour que le Lieu Saint ne connaisse pas la honte."
,"19":"Les femmes serrées dans des sacs au-dessous des seins remplissaient les rues, les jeunes filles encore tenues à la maison couraient aux portes ou montaient sur le rempart, d'autres se penchaient aux fenêtres."
,"20":"Toutes les mains se tendaient vers le Ciel criant leur prière;"
,"21":"l'angoisse de cette foule unie dans un même abattement et l'attente anxieuse du grand prêtre faisaient peine à voir."
,"22":"Pendant qu'on suppliait le Seigneur Tout-Puissant de garder les dépôts intacts et saufs à ceux qui les avaient confiés,"
,"23":"Héliodore faisait comme il avait dit."
,"24":"Il était déjà avec sa garde près du trésor, lorsqu'à cet endroit même le Souverain des esprits et des puissants de tout ordre fit une grande apparition; tous ceux qui avaient osé pénétrer là restèrent sans forces ni courage, comme paralysés par la force de Dieu."
,"25":"Un cheval leur apparut, monté par un cavalier terrible et richement équipé, qui paraissait porter une armure d'or; il se précipita droit sur Héliodore et lança sur lui ses sabots de devant."
,"26":"En même temps lui apparurent deux autres jeunes hommes, pleins de force, éclatants de lumière, et vêtus d'habits magnifiques. Ils se placèrent de chaque côté d'Héliodore et se mirent à le fouetter, faisant tomber sur lui une grêle de coups."
,"27":"Héliodore tomba à terre et se retrouva dans de profondes ténèbres. On le ramassa, on le mit sur une civière,"
,"28":"et cet homme qui venait d'entrer dans la chambre du trésor avec une suite nombreuse de gardes et d'hommes armés, fut emporté incapable de s'aider lui-même: la puissance de Dieu s'était ainsi manifestée à tous."
,"29":"Pendant qu'il était là, sous le coup de la force divine, muet et sans espoir de guérison,"
,"30":"les Juifs bénissaient le Seigneur qui avait glorifié son Saint Lieu; le Temple, qui un instant plus tôt était habité par l'épouvante et l'inquiétude, se remplit de joie et d'allégresse à la suite de la manifestation du Seigneur Tout-Puissant."
,"31":"Aussitôt, quelques-uns des compagnons d'Héliodore demandèrent à Onias de prier le Très-Haut et d'accorder la vie à celui qui était là couché à terre à demi-mort."
,"32":"Le grand prêtre accepta et offrit un sacrifice pour la vie de cet homme: il était à craindre en effet que le roi pense à un attentat des Juifs contre Héliodore."
,"33":"Pendant que le grand prêtre offrait le sacrifice de réparation, les mêmes jeunes gens apparurent de nouveau à Héliodore, habillés des mêmes vêtements; se tenant debout à côté de lui, ils lui dirent: 'Tu peux dire un grand merci au grand prêtre Onias, car c'est à cause de lui que le Seigneur te conserve en vie."
,"34":"Tu as été fouetté par le Ciel, tu feras donc connaître à tous la grande puissance de Dieu.' Après avoir dit cela, ils disparurent."
,"35":"Héliodore offrit un sacrifice au Seigneur et fit de longues prières à celui qui lui avait conservé la vie; puis, après avoir promis à Onias son amitié, il repartit avec ses hommes vers le roi."
,"36":"A tous il rendait témoignage de cette intervention du Dieu très grand qu'il avait vue de ses propres yeux."
,"37":"Comme le roi demandait à Héliodore qui était le plus indiqué pour aller de nouveau à Jérusalem, Héliodore répondit:"
,"38":"'Si tu as un ennemi ou quelqu'un qui fait du tort à l'Etat, envoie-le là-bas et il te reviendra déchiré par les fouets, si toutefois il en réchappe, car il y a vraiment là une force divine;"
,"39":"celui qui habite dans le Ciel veille sur ce lieu et le protège. Il frappe et fait mourir ceux qui y viennent avec de mauvaises intentions.'"
,"40":"Voici donc comment se déroula l'affaire d'Héliodore et comment le trésor fut protégé."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Ce fameux Simon qui avait dénoncé le trésor et sa propre patrie commença à calomnier Onias: selon lui, c'était Onias qui avait fait attaquer Héliodore et qui était à l'origine de toutes les difficultés.'"
,"2":"Il osait faire passer pour un ennemi de l'Etat celui qui était le bienfaiteur de la ville, le défenseur de ses compatriotes, et qui observait si fidèlement la Loi."
,"3":"Cette haine alla si loin que des partisans de Simon commirent des attentats."
,"4":"Onias comprit le danger de cette rivalité et vit qu'Apollonius, le gouverneur militaire de la Coelé-Syrie et de la Phénicie, encourageait la méchanceté de Simon."
,"5":"C'est pourquoi il alla trouver le roi, non pour accuser ses compatriotes, mais parce qu'il était soucieux de l'intérêt général et du bien particulier de tout son peuple;"
,"6":"il voyait bien que sans une intervention du roi les affaires ne s'arrangeraient pas et Simon continuerait dans sa folie."
,"7":"Séleucus était mort et Antiocus surnommé Epiphane lui avait succédé. Jason, frère d'Onias, s'empara alors du souverain pontificat."
,"8":"Dans une rencontre avec le roi, il lui promit trois cent soixante talents d'argent et quatre-vingts talents venant d'autres revenus."
,"9":"Il était prêt en outre à s'engager par écrit pour cent cinquante autres talents si on l'autorisait à construire de sa propre autorité et selon ses propres vues un gymnase et une école militaire et s'il pouvait donner à des habitants de Jérusalem le titre de 'citoyens d'Antioche'."
,"10":"Le roi consentit à tout. Dès que Jason eut obtenu le pouvoir, il commença à introduire les habitudes grecques parmi ses concitoyens. "
,"11":"Il supprima les franchises que les rois avaient accordées aux Juifs par humanité, (elles avaient été obtenues par Jean, père de cet Eupolème qui plus tard fut envoyé en ambassadeur pour conclure un traité d'alliance et d'amitié avec les Romains). Il supprima aussi les institutions légitimes et il établit des coutumes contraires à la Loi."
,"12":"Il se fit un plaisir de construire un gymnase au pied même de l'acropole, et il entraîna les meilleurs des jeunes gens dans les exercices du gymnase."
,"13":"Complètement perverti, Jason se conduisait comme un impie et non comme un grand prêtre. Vivre à la grecque devint une mode, et ce fut une invasion de coutumes étrangères."
,"14":"Les prêtres ne montraient plus aucun soin pour le service de l'autel, ils méprisaient le Temple et négligeaient les sacrifices: dès qu'ils entendaient l'appel pour le lancement du disque, ils couraient au terrain de sport pour prendre part aux compétitions, ce qui était interdit par la Loi."
,"15":"Ils se moquaient bien des valeurs traditionnelles, mais ils étaient convaincus de la supériorité grecque."
,"16":"Ils allaient ainsi au-devant de situations difficiles, car ceux-là mêmes dont ils cherchaient à copier les manières de vivre et auxquels ils voulaient ressembler en tous points, allaient devenir leurs ennemis et leurs bourreaux."
,"17":"La période suivante montrera bien qu'on ne viole pas sans châtiment les lois divines."
,"18":"Comme on célébrait à Tyr, en présence du roi, les jeux qui se déroulaient tous les quatre ans,"
,"19":"le méprisable Jason envoya comme délégués de Jérusalem des 'citoyens d'Antioche' qui portaient avec eux trois cents drachmes d'argent pour le sacrifice en l'honneur d'Héraclès. Heureusement, ceux qui portaient cet argent ne voulurent pas le donner pour le sacrifice, pensant que ce n'était pas convenable, et demandèrent qu'on en fasse un autre usage."
,"20":"Ainsi l'argent destiné par Jason au sacrifice en l'honneur d'Héraclès fut affecté à la construction de navires de guerre grâce à cette demande de ceux qui l'apportaient."
,"21":"Apollonius fils de Ménestée avait été envoyé en Egypte pour assister au mariage du roi Philométor. Antiocus apprit que ce roi était devenu hostile à sa politique et il se préoccupa de sa propre sécurité; c'est pourquoi il vint à Joppé, d'où il gagna Jérusalem."
,"22":"Jason et la ville le reçurent solennellement, il fit son entrée à la lumière des torches et au milieu des acclamations; après quoi il partit avec ses troupes vers la Phénicie."
,"23":"Au bout de trois ans, Jason envoya Ménélas, le frère du Simon dont on a parlé plus haut, pour porter l'argent au roi et régler un certain nombre de problèmes importants."
,"24":"Ménélas se fit recommander auprès du roi et se présenta comme un homme important; il lui offrit trois cents talents d'argent de plus que ne l'avait fait Jason et se fit attribuer le souverain pontificat."
,"25":"Après avoir reçu les lettres royales confirmant sa charge, il repartit; il n'avait rien pour mériter ce titre de grand prêtre et il n'apportait avec lui que la violence d'un tyran cruel et la rage d'une bête sauvage."
,"26":"Ainsi Jason, qui avait pris la place de son frère, voyait aujourd'hui un autre prendre sa place et l'obliger à fuir en Ammanitide."
,"27":"Ménélas s'empara du pouvoir, mais il ne versa rien de l'argent qu'il avait promis au roi"
,"28":"en dépit des réclamations de Sostrate, préfet de la forteresse, qui était chargé de percevoir les impôts. C'est pourquoi ils furent tous les deux convoqués par le roi."
,"29":"Ménélas laissa pour le remplacer comme grand prêtre son frère Lysimaque, et Sostrate laissa Kratès, le chef des Chypriotes."
,"30":"C'est alors que les habitants de Tarse et de Mallos se révoltèrent, car leur ville avait été donnée en cadeau à Antiokis, la concubine du roi."
,"31":"Le roi partit au plus vite pour régler cette affaire et laissa Andronique, grand fonctionnaire, pour le remplacer."
,"32":"Ménélas pensa que c'était le bon moment pour voler quelques vases d'or dans le Sanctuaire et les offrir à Andronique; il réussit à en vendre d'autres à Tyr et dans les villes voisines."
,"33":"Lorsque Onias le sut de façon certaine, il alla se réfugier dans un lieu d'asile, à Daphné près d'Antioche, et de là il le dénonça."
,"34":"C'est pourquoi Ménélas prit à part Andronique et le pressa d'assassiner Onias; Andronique vint donc trouver Onias de mauvaise foi, il lui prêta serment en lui tendant la main droite et le décida ainsi, malgré ses soupçons, à sortir de son asile; et aussitôt il le mit à mort sans le moindre respect pour la justice."
,"35":"C'est pourquoi, non seulement les Juifs, mais aussi beaucoup parmi les non-Juifs, furent indignés et trouvèrent scandaleux l'assassinat criminel de cet homme."
,"36":"Lorsque le roi rentra de la région de Cilicie, les Juifs de la ville et les Grecs qui avaient comme eux le mal en horreur, vinrent le trouver à propos de l'assassinat injuste d'Onias."
,"37":"Se rappelant la sagesse et la vie irréprochable de la victime, Antiocus pleura, tant il était peiné, ému au plus profond de lui-même:"
,"38":"Puis il fut pris de colère, il retira à Andronique sa charge et lui fit déchirer les vêtements; il fit conduire ce meurtrier par toute la ville et le fit mettre à mort à l'endroit même où il avait assassiné injustement Onias; c'est ainsi que le Seigneur le frappa d'un juste châtiment."
,"39":"Pendant ce temps Lysimaque, en accord avec Ménélas, avait commis un grand nombre de vols sacrilèges dans la ville. Comme le bruit s'en répandait au-dehors, le peuple se souleva contre Lysimaque après que beaucoup d'objets d'or avaient déjà été dispersés."
,"40":"Pour réprimer le soulèvement du peuple en colère, Lysimaque arma près de trois mille hommes et prit l'initiative de la violence; il avait mis à leur tête un certain Auranos, aussi fou qu'il était vieux."
,"41":"Quand ils se virent attaqués par Lysimaque, les uns ramassèrent des pierres, les autres des bâtons, d'autres encore prirent à pleines mains la cendre qui se trouvait là, et tous se jetèrent dans la bagarre contre les gens de Lysimaque,"
,"42":"à tel point qu'ils firent beaucoup de blessés et un certain nombre de morts; ils mirent le reste en fuite et massacrèrent près du trésor le voleur sacrilège."
,"43":"On engagea un procès contre Ménélas à propos de tous ces faits."
,"44":"Lorsque le roi arriva à Tyr, trois hommes envoyés par les anciens lui exposèrent leur cause."
,"45":"Se voyant alors perdu, Ménélas promit une grosse somme d'argent à Ptolémée, fils de Dorimène, pour qu'il lui obtienne le secours du roi."
,"46":"Ptolémée emmena le roi sous la colonnade, sous prétexte de prendre le frais, et il le fit changer de décision."
,"47":"Le roi déclara Ménélas innocent de toutes ces accusations alors qu'il était responsable de tous les maux, et il condamna à mort des malheureux qui auraient été déclarés innocents, même devant des barbares."
,"48":"Ces hommes qui avaient pris la défense de la ville, du peuple et des objets sacrés, subirent sans attendre cette peine injuste."
,"49":"Les habitants de Tyr eux-mêmes en furent scandalisés et ils firent aux victimes des funérailles solennelles."
,"50":"Quant à Ménélas, il conserva sa charge grâce aux gens en place qui n'avaient de considération que pour l'argent; il grandissait en méchanceté et en cruauté, il était le fléau de ses compatriotes."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Antiocus préparait alors sa seconde attaque contre l'Egypte."
,"2":"Or voici qu'à la même époque, dans toute la ville, on eut pendant près de quarante jours des apparitions: des cavaliers dont les vêtements étaient brodés d'or galopaient dans le ciel, des troupes armées défilaient en bon ordre,"
,"3":"des escadrons montés se rangeaient pour la bataille, avec des attaques et des charges de part et d'autre, des mouvements de boucliers, des forêts de lances, des épées tirées du fourreau, des flèches qui volaient, des armures d'or brillant de tout leur éclat et des cuirasses de toute espèce."
,"4":"C'est pourquoi tous souhaitaient que ces apparitions annoncent quelque événement heureux."
,"5":"A la suite d'une fausse rumeur sur la mort d'Antiocus, Jason prit avec lui au moins un millier d'hommes et vint attaquer la ville à l'improviste; ceux qui défendaient les remparts furent débordés et la ville fut prise, obligeant Ménélas à se réfugier dans la forteresse."
,"6":"Jason se livra au massacre de ses propres concitoyens sans la moindre pitié, sans penser qu'une victoire remportée sur ses compatriotes est la plus grande défaite; il les écrasait voyant en eux des ennemis, et non des gens de sa nation."
,"7":"Cependant il n'arriva pas à prendre le pouvoir: toute son entreprise aboutit à un échec et il fut obligé de se réfugier de nouveau en Ammanitide."
,"8":"Sa conduite criminelle arriva à son terme: accusé d'abord auprès d'Arétas, roi des Arabes, il chercha refuge de ville en ville. Poursuivi par tous, détesté pour avoir renié les lois, rejeté comme le bourreau de sa patrie et de ses compatriotes, il partit pour l'Egypte."
,"9":"Lui qui avait exilé beaucoup de gens loin de leur patrie, il mourut finalement sur une terre étrangère, car il partit pour Lacédémone où il pensait qu'on l'accueillerait en raison de notre parenté de race avec ce peuple."
,"10":"Lui qui avait laissé sur le sol tant de cadavres sans sépulture, il ne fut pas enterré dans le tombeau de ses pères: personne ne le pleura, personne ne lui rendit les derniers devoirs."
,"11":"lorsque le roi apprit tout cela, il pensa que la Judée voulait prendre son indépendance; il quitta donc l'Egypte, furieux comme une bête sauvage, et s'empara de la ville à main armée."
,"12":"Il commanda aux soldats de massacrer sans pitié ceux qu'ils rencontreraient et d'égorger ceux qui se réfugieraient dans leurs maisons."
,"13":"On tua ainsi les jeunes et les vieux, on fit périr les femmes et les enfants, on égorgea des jeunes filles et des nourrissons."
,"14":"En trois jours il y eut quatre-vingt mille victimes; quarante mille tombèrent sous les coups et les autres furent vendus comme esclaves."
,"15":"Comme si cela ne suffisait pas, le roi pénétra dans le Sanctuaire le plus saint de toute la terre, guidé par Ménélas qui en était arrivé à trahir les lois et la patrie."
,"16":"De ses mains impures il prit les vases sacrés, de ses mains profanes il ramassa les offrandes que d'autres rois avait déposées là pour augmenter encore la gloire de ce lieu."
,"17":"Gonflé d'orgueil, Antiocus ne voyait pas que le Seigneur s'était mis en colère pour peu de temps à cause des péchés des habitants de la ville et que pour cette raison il semblait oublier ce lieu."
,"18":"Sinon, s'ils n'avaient pas été coupables d'un grand nombre de péchés, il aurait été fouetté lui aussi dès son arrivée et corrigé de son audace, tout comme cet Héliodore que le roi Séleucus avait envoyé pour inspecter le trésor;"
,"19":"mais Dieu n'a pas choisi le peuple à cause de ce lieu, il a choisi ce lieu à cause du peuple."
,"20":"C'est pour cela que ce lieu a participé aux malheurs du peuple comme par la suite il a été associé aux bienfaits du Seigneur; il a été abandonné par le Tout-Puissant dans sa colère, comme par la suite il a été rétabli dans toute sa gloire quand le Seigneur Tout-Puissant s'est réconcilié avec son peuple."
,"21":"Antiocus donc, avait enlevé dix-huit cents talents dans le Temple et s'en était retourné rapidement à Antioche; dans son orgueil il se croyait capable de rendre navigable la terre ferme et de tracer des routes sur la mer."
,"22":"Il laissa des fonctionnaires pour réprimer notre race: à Jérusalem, Philippe originaire de Phrygie, qui était plus cruel encore que celui qui l'avait établi;"
,"23":"au Garizim, Andronique; et en plus de ces derniers, Ménélas dont la méchanceté envers ses compatriotes était pire encore: il n'avait que de la haine pour ses compatriotes Juifs."
,"24":"Le roi envoya le gouverneur Apollonius à la tête d'une armée de vingt-deux mille hommes, avec l'ordre d'égorger tous ceux qui étaient dans la force de l'âge et de vendre comme esclaves les femmes et les enfants."
,"25":"Il arriva ainsi à Jérusalem en jouant les hommes pacifiques et il attendit jusqu'au saint jour du sabbat. Profitant du repos des Juifs, il commanda à ses hommes de faire une prise d'armes;"
,"26":"il fit massacrer tous ceux qui étaient sortis pour assister au spectacle et, parcourant la ville avec ses soldats, il mit à mort une grande quantité de personnes."
,"27":"C'est alors que Judas appelé Maccabée se retira dans le désert avec une dizaine de personnes; avec ses compagnons, il vivait comme les bêtes sauvages sur les montagnes, s'obligeant à un régime végétarien plutôt que de se rendre impur."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Peu de temps après, le roi envoya un vieil Athénien pour obliger les Juifs à abandonner le culte de leurs pères et pour les empêcher de vivre selon les lois de Dieu:"
,"2":"il voulait profaner le Temple de Jérusalem et le consacrer à Zeus Olympien, et le temple du Garizim à Zeus Hospitalier, selon la demande des habitants du lieu."
,"3":"Cette aggravation du mal fut pénible et difficile à supporter pour tous."
,"4":"Le sanctuaire était rempli de débauches et d'orgies par les païens qui s'amusaient avec des prostituées, qui faisaient l'amour avec des femmes dans les cours sacrées, et qui en outre y apportaient des choses interdites."
,"5":"L'autel était couvert de victimes inacceptables, interdites par les lois;"
,"6":"on n'avait plus le droit de célébrer le sabbat, d'observer les fêtes de nos pères, ni même de confesser que l'on était Juif."
,"7":"On était obligé par une dure nécessité de participer chaque mois au repas rituel, le jour de la naissance du roi, et lorsque arrivaient les fêtes de Dionysos, on devait accompagner le cortège de la divinité en portant des couronnes de lierre."
,"8":"A l'initiative de Ptolémée, un décret fut publié pour les villes grecques des environs: on devait réprimer les Juifs de la même façon et les obliger à prendre part aux repas rituels;"
,"9":"on devait égorger ceux qui refuseraient d'adopter les coutumes grecques. Tout cela était l'annonce de malheurs terribles."
,"10":"C'est ainsi que deux femmes furent traînées en justice pour avoir circoncis leurs enfants: on les mena en public à travers la ville, leur enfant suspendu à leur sein, avant de les précipiter du haut des remparts."
,"11":"D'autres qui s'étaient donné rendez-vous dans des grottes voisines pour y célébrer en cachette le jour du sabbat, furent dénoncés à Philippe. Tous furent livrés aux flammes; ils ne voulurent pas se défendre, pensant que ce serait aller contre la sainteté de ce jour."
,"12":"Je supplie ceux qui auront ce livre entre leurs mains de ne pas se scandaliser de tant de malheurs, mais de croire que les persécutions ne viendront pas à bout de notre race; au contraire elles servent à nous corriger."
,"13":"Lorsque les pécheurs ne sont pas laissés longtemps à eux-mêmes mais que les châtiments leur arrivent rapidement, c'est une marque de grande bonté."
,"14":"Nous voyons que pour les autres nations le Maître attend avec patience qu'elles arrivent à la pleine mesure de leurs fautes, mais ce n'est pas ainsi qu'il a jugé bon d'agir envers nous."
,"15":"Il n'a pas voulu attendre pour nous punir que nos péchés atteignent leur pleine mesure."
,"16":"C'est qu'il n'abandonne pas son peuple: il nous corrige par l'épreuve et ne nous prive pas de sa miséricorde."
,"17":"Qu'il nous suffise d'avoir rappelé cette vérité; nous reprendrons notre récit après ces quelques réflexions."
,"18":"Eléazar était l'un des principaux docteurs de la Loi, un homme âgé et de noble prestance. On voulut lui ouvrir la bouche de force pour lui faire manger de la viande de porc,"
,"19":"mais il préféra une mort glorieuse à une existence honteuse et marcha volontairement au supplice de la roue."
,"20":"Il cracha ce qu'il avait dans la bouche, comme doivent le faire ceux qui ont le courage de rejeter ce qui est interdit, plutôt que de manger par attachement à la vie."
,"21":"Ceux qui présidaient ce repas rituel, défendu par la loi le prirent à part car ils connaissaient cet homme depuis longtemps. Ils lui proposèrent de faire apporter des viandes autorisées par la Loi et qu'il aurait préparées lui-même, et lui ferait semblant de manger de la viande offerte en sacrifice selon l'ordre du roi."
,"22":"En agissant ainsi, et grâce à cette vieille amitié qui les unissait, il échapperait à la mort."
,"23":"Mais lui prit une noble décision, digne de son âge, de l'autorité que lui donnaient sa vieillesse et ses vénérables cheveux blanchis par l'âge, digne aussi de sa conduite irréprochable depuis son enfance et conforme aux saintes lois établies par Dieu lui-même. Il répondit qu'il vaudrait mieux l'envoyer sans attendre au séjour des morts."
,"24":"Il ajouta ceci: 'A notre âge, il ne convient pas de faire semblant; beaucoup de jeunes pourraient penser qu'Eléazar, à quatre-vingt-dix ans, s'est laissé gagner par les étrangers."
,"25":"Eux aussi s'égareraient avec moi à cause de mon double jeu en un moment où ne me reste que si peu de temps à vivre. J'attirerais ainsi sur ma vieillesse la honte et le déshonneur."
,"26":"Et si j'échappais pour le moment au châtiment des hommes, je n'échapperais pas, vivant ou mort, aux mains du Tout-Puissant."
,"27":"En quittant maintenant la vie de façon courageuse, je me montrerai digne de ma vieillesse;"
,"28":"je laisserai aux jeunes le noble exemple d'une belle mort, volontaire et généreuse, pour la défense des lois vénérables et saintes.' Ayant ainsi parlé, il marcha droit au supplice de la roue."
,"29":"Pour ceux qui le conduisaient, les paroles qu'il venait de prononcer n'étaient que folie, et la générosité qu'ils avaient eue pour lui peu de temps auparavant fit place à la méchanceté.."
,"30":"Lorsqu'il fut près de mourir sous les coups, il dit dans un soupir: 'Le Seigneur possède la science sainte, il voit quelles douleurs cruelles j'endure sous les coups dans mon corps, alors que je pouvais échapper à la mort; mais il voit qu'en mon âme je les souffre avec joie à cause de la crainte que j'ai de lui.'"
,"31":"C'est ainsi qu'il quitta la vie, laissant dans sa mort un exemple de courage et le souvenir de sa vertu, non seulement à la jeunesse, mais à la grande majorité de la nation."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Voici ce qui arriva encore: on avait arrêté sept frères avec leur mère, et le roi voulait les obliger, en les déchirant à coups de fouets et de nerfs de boeuf, à prendre de la viande de porc interdite par la Loi."
,"2":"L'un d'eux prit la parole au nom de tous: 'Que demandes-tu et que veux-tu savoir de nous? Nous sommes prêts à mourir plutôt que de désobéir à la Loi de nos pères.'"
,"3":"Furieux, le roi ordonna de mettre sur le feu des poêles et des chaudrons. Aussitôt qu'elles furent brûlantes,"
,"4":"il ordonna de couper la langue à celui qui avait parlé au nom de tous, puis de lui arracher la peau de la tête et de lui couper les extrémités, sous les yeux de ses frères et de sa mère."
,"5":"Lorsqu'il fut complètement mutilé, le roi ordonna de l'approcher du feu et de le brûler à la poêle alors qu'il respirait encore. Pendant que la fumée de la poêle se répandait au loin, ses frères et leur mère s'encourageaient les uns les autres à mourir courageusement; ils disaient: "
,"6":"'Le Seigneur Dieu regarde, il aura sûrement pitié de nous, selon la parole de Moïse dans le Cantique qu'il a prononcé face à tous. Il y est dit: Il aura pitié de ses serviteurs.'"
,"7":"Lorsque le premier eut passé ainsi à une autre vie, on amena le second pour le supplice, on lui arracha la peau de la tête avec les cheveux et on lui demanda s'il voulait manger du porc plutôt que d'être torturé dans tous les membres de son corps."
,"8":"Il répondit dans la langue de ses pères: 'Non!' C'est pourquoi à son tour il subit les mêmes supplices que le premier."
,"9":"Au moment de rendre le dernier soupir, il dit: 'Tu n'es qu'un criminel! Tu nous ôtes la vie présente, mais le Roi de l'Univers nous ressuscitera pour une vie éternelle, nous qui mourons par fidélité à ses Lois.'"
,"10":"Après lui on tortura le troisième; à la demande du bourreau il présenta aussitôt sa langue et tendit sans hésiter ses mains."
,"11":"Il eut le courage de déclarer: 'Je tiens du Ciel ces mains, mais à cause de ses lois je les sacrifie, et c'est de lui que j'attends qu'il me les rende.'"
,"12":"Le roi lui-même et son entourage furent étonnés du courage de ce jeune homme qui comptait pour rien ses souffrances."
,"13":"Lorsqu'il fut mort, on fit subir au quatrième les mêmes supplices."
,"14":"Sur le point de mourir il dit: 'Heureux ceux qui meurent de la main des hommes avec l'espérance qu'ils ont reçue de Dieu, d'être ressuscités par lui; mais pour toi il n'y aura pas de résurrection pour la vie.'"
,"15":"On amena ensuite le cinquième et on le tortura. Les yeux fixés sur le roi, il dit:"
,"16":"'Quoique mortel, tu as autorité sur les hommes et tu fais ce que tu veux, mais ne crois pas que notre race soit abandonnée par Dieu."
,"17":"Attends, et tu verras sa grande puissance et comment il te tourmentera, toi et ta race.'"
,"18":"Après lui on amena le sixième. Sur le point de mourir il dit: 'Ne te fais aucune illusion, c'est en péchant contre notre Dieu que nous nous sommes attiré ces malheurs, et maintenant nous passons par des épreuves peu communes."
,"19":"Mais toi qui oses faire la guerre à Dieu, ne pense pas que tu resteras sans châtiment.'"
,"20":"Elle fut vraiment admirable, et elle mérite de rester célèbre, cette mère qui vit mourir ses sept fils en l'espace d'un jour! Elle le supporta sans faiblir à cause de l'espérance qu'elle mettait dans le Seigneur."
,"21":"Elle encourageait chacun d'eux dans la langue de ses pères, et remplie des plus beaux sentiments, elle soutenait par un courage viril sa tendresse de mère."
,"22":"Elle leur disait: 'Je ne sais comment vous êtes apparus dans mes entrailles: ce n'est pas moi qui vous ai donné l'esprit et la vie, ce n'est pas moi qui ai assemblé les différents membres qui forment votre corps."
,"23":"Le Créateur du monde, qui a formé l'homme à sa naissance et qui a conçu l'origine de tous les êtres, vous rendra dans sa miséricorde l'esprit et la vie, puisque maintenant vous vous méprisez vous-mêmes par amour pour ses lois.'"
,"24":"Antiocus pensa qu'elle était en train de l'insulter et de le maudire. Comme le plus jeune était encore en vie, le roi lui dit, et même il lui promit par serment de le rendre à la fois riche et heureux s'il abandonnait les traditions de ses ancêtres. Il lui promettait d'en faire son ami et de lui confier de hautes fonctions."
,"25":"Comme le garçon n'y prêtait aucune attention, le roi fit approcher la mère et lui parla avec insistance pour qu'elle conseille à son fils de sauver sa vie."
,"26":"Comme il insistait tellement, elle accepta de persuader son fils."
,"27":"Elle se pencha donc vers lui et, trompant le cruel tyran, elle parla ainsi à son fils dans la langue de ses pères: 'Mon fils, aie pitié de moi! Je t'ai porté neuf mois dans mon sein, je t'ai allaité durant trois ans, je t'ai nourri et élevé jusqu'à l'âge où tu es: en toutes choses j'ai pris soin de toi."
,"28":"Je t'en supplie, mon enfant, regarde le ciel et la terre, vois tout ce qu'ils contiennent, et sache que c'est Dieu qui les a faits de rien: c'est ainsi qu'est apparue la race humaine."
,"29":"Ne redoute pas ce bourreau, mais montre-toi digne de tes frères, accepte la mort pour que je te retrouve avec tes frères au temps de la miséricorde.'"
,"30":"Elle parlait encore quand le jeune homme dit: 'Qu'attendez-vous? Je n'obéis pas aux ordres du roi, j'obéis aux prescriptions de la Loi donnée par Moïse à nos pères."
,"31":"Mais toi qui as amené tant de malheurs sur les Hébreux, tu n'échapperas pas aux mains de Dieu!"
,"32":"Nous, nous souffrons à cause de nos péchés,"
,"33":"Notre Seigneur, qui est vivant, nous a montré un moment sa colère pour nous corriger et nous éduquer, mais il se réconciliera avec ses serviteurs."
,"34":"Toi par contre, impie et le plus impur de tous les hommes, ne te gonfle pas d'orgueil, laisse-là tes rêves et cesse de lever la main contre les serviteurs de Dieu,"
,"35":"car tu n'as pas encore échappé au jugement du Dieu tout-puissant qui veille sur toute chose."
,"36":"Nos frères ont souffert une épreuve passagère en échange d'une vie qui ne finit pas, ils sont déjà couverts par l'Alliance de Dieu. Toi au contraire, par la justice de Dieu, tu porteras le châtiment de ton orgueil."
,"37":"Comme mes frères, je livre mon corps et ma vie pour les lois de mes pères. Je supplie Dieu d'avoir bientôt pitié de notre race et de t'amener par les tourments et la souffrance à reconnaître qu'il est le seul Dieu."
,"38":"Que la colère du Tout-Puissant, justement déchaînée contre toute notre race, s'arrête enfin sur moi et sur mes frères.'"
,"39":"Le roi fut profondément blessé par ces paroles de défi. Devenu furieux, il tortura celui-ci plus cruellement que les autres."
,"40":"C'est ainsi que ce jeune homme mourut, dans la droiture et la totale confiance dans le Seigneur."
,"41":"Enfin la mère mourut, la dernière, après ses fils."
,"42":"Mais en voilà assez sur la question des repas rituels et sur des supplices qui passèrent toute mesure.."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Cependant Judas Maccabée et ses compagnons s'introduisaient secrètement dans les villages. Ils rassemblaient leurs parents et entraînaient à leur suite ceux qui étaient restés fidèles au Judaïsme; c'est ainsi qu'ils rassemblèrent environ six mille hommes."
,"2":"Ils suppliaient le Seigneur de regarder son peuple que tous piétinaient et d'avoir pitié de son Temple profané par les impies,"
,"3":"d'avoir pitié de la ville dévastée et réduite à l'état de ruines, d'écouter la voix du sang qui criait vers lui,"
,"4":"de se souvenir du meurtre criminel des petits enfants innocents, et des insultes faites à son Nom: enfin, de montrer sa haine des méchants."
,"5":"Dès que Maccabée eut une troupe organisée, les païens furent incapables de lui résister, car la colère du Seigneur s'était changée en miséricorde."
,"6":"Tombant par surprise sur les villes et les villages, il les brûlait; il occupait les positions les plus favorables et, de là, infligeait à l'ennemi des pertes sévères."
,"7":"La nuit était son meilleur auxiliaire pour ce genre d'expéditions; sa réputation de vaillance se répandit partout."
,"8":"Philippe vit que cet homme ne cessait de progresser et que ses victoires étaient de plus en plus fréquentes; il écrivit donc à Ptolémée, qui était le chef militaire de la Coelé-Syrie et de la Phénicie, pour qu'il rétablisse les affaires du roi."
,"9":"Ptolémée choisit aussitôt Nicanor fils de Patrocle, l'un des principaux favoris du roi, et l'envoya avec une armée d'au moins vingt mille hommes de diverses nations pour exterminer la race entière des Juifs; avec lui, il envoya Gorgias, un général qui avait une bonne expérience des choses de la guerre."
,"10":"Comme le roi devait un tribut de deux mille talents aux Romains, Nicanor pensa l'assurer par la vente des captifs que l'on ferait en Judée."
,"11":"Il s'empressa donc d'envoyer une invitation aux villes maritimes pour qu'elles viennent acheter des esclaves juifs: il leur en offrait quatre-vingt-dix pour un talent. Mais il ne s'attendait pas à la vengeance du Tout-Puissant prête à tomber sur lui."
,"12":"Judas apprit la marche de Nicanor et il informa ses compagnons de l'arrivée de cette armée."
,"13":"Ceux qui manquaient de courage et qui ne croyaient pas à la justice de Dieu s'enfuirent vers d'autres lieux."
,"14":"Les autres vendirent tout ce qui leur restait, suppliant le Seigneur de les délivrer de l'impie Nicanor qui les avait vendus avant même que la bataille n'ait commencé."
,"15":"Ils lui demandaient d'intervenir, non pas à cause d'eux, mais par égard pour les alliances conclues avec leurs pères, et parce qu'eux-mêmes portaient son Nom auguste et plein de majesté."
,"16":"Maccabée réunit donc ceux qui étaient restés avec lui, près de six mille hommes, et il les encouragea à ne pas se laisser impressionner par l'ennemi. Ils ne devaient pas craindre ces païens malgré leur nombre, car ils venaient les attaquer pour une mauvaise cause. Il les encouragea à combattre de toutes leurs forces,"
,"17":"pensant à la profanation scandaleuse du Lieu Saint, au traitement infligé par eux à la ville outragée, et à la ruine des institutions de leurs pères."
,"18":"Maccabée leur disait encore: 'Ils ne croient qu'aux armes et à leur propre audace, alors que nous, nous comptons sur Dieu, le Maître de toutes choses, qui peut d'un geste renverser ceux qui viennent nous attaquer, et avec eux l'univers entier.'"
,"19":"Il passa en revue sous leurs yeux les exemples anciens de la protection de Dieu, comme ces cent quatre-vingt mille hommes qui périrent au temps de Sennakérib."
,"20":"Il leur rappela la bataille livrée aux Galates en Babylonie; les Juifs n'étaient que huit mille hommes à prendre part à la bataille, mais lorsque les quatre mille Macédoniens qui étaient avec eux furent mis en échec, ces huit mille avaient détruit cent vingt mille ennemis grâce au secours venu du Ciel, et ils avaient ramassé un abondant butin."
,"21":"Après leur avoir redonné confiance par ces souvenirs et les avoir disposés à mourir pour les lois et pour la patrie, il divisa son armée en quatre troupes."
,"22":"Il plaça ses frères Simon, Joseph et Jonathas à la tête de chacune des troupes, et il leur donna à chacun quinze cents hommes. Eléazar était là lui aussi."
,"23":"Il fit la lecture du Livre Saint, puis ayant donné comme mot d'ordre: 'Secours de Dieu!' il prit la tête de la première troupe et attaqua Nicanor."
,"24":"Le Tout-Puissant vint à leur aide: ils tuèrent plus de neuf mille ennemis, blessèrent et mutilèrent la plus grande partie des hommes de Nicanor et les mirent tous en fuite."
,"25":"Ils ramassèrent l'argent de ceux qui étaient venus pour les acheter, poursuivirent les ennemis assez loin. Mais ils durent interrompre car le temps leur manquait:"
,"26":"c'était la veille du sabbat, c'est pourquoi ils s'arrêtèrent de les poursuivre."
,"27":"Quand ils eurent ramassé les armes des ennemis et enlevé leurs dépouilles, ils célébrèrent le sabbat; ils bénissaient Dieu mille fois et louaient le Seigneur qui les avait délivrés en ce jour et avait fait pour eux un premier geste de miséricorde."
,"28":"Après le sabbat ils distribuèrent une part du butin à ceux qui avaient souffert de la persécution, aux veuves et aux orphelins; eux-mêmes et leurs enfants se partagèrent le reste."
,"29":"Ensuite ils se mirent à prier tous ensemble, suppliant le Seigneur miséricordieux de se réconcilier totalement avec ses serviteurs."
,"30":"Ils affrontèrent ensuite les hommes de Timothée et Bakidès, ils en tuèrent plus de vingt mille; ils s'emparèrent de hautes forteresses et partagèrent encore leur butin en faisant deux parts égales: l'une pour eux, l'autre pour les victimes de la persécution, les orphelins, les veuves et les vieillards."
,"31":"Ils recueillirent les armes et les déposèrent toutes soigneusement aux endroits les plus convenables, puis ils transportèrent à Jérusalem le reste du butin."
,"32":"Ils mirent à mort le chef des gardes de Timothée, car c'était un homme très mauvais qui avait fait beaucoup de mal aux Juifs."
,"33":"Pendant qu'ils fêtaient leur victoire dans leur capitale, ils brûlèrent ceux qui avaient incendié les saintes portes et s'étaient réfugiés avec Kallistène dans une petite maison; ils reçurent ainsi le juste salaire de leur impiété."
,"34":"Ce triple criminel de Nicanor, qui avait amené les mille marchands pour la vente des Juifs,"
,"35":"fut humilié avec l'aide du Seigneur par des gens qui, pensait-il, étaient les derniers de tous. Nicanor se dépouilla de ses vêtements princiers et prit la fuite à travers champs comme un esclave fugitif, sans escorte. Il eut la chance inespérée de se retrouver à Antioche après le désastre de son armée."
,"36":"Lui qui avait promis de régler le tribut dû aux Romains avec l'argent des captifs de Jérusalem, il annonçait maintenant que les Juifs avaient Dieu pour défenseur et qu'ils étaient invincibles, car ils obéissaient aux lois qu'il leur avait ordonnées."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Vers ce temps-là Antiocus était revenu fort humilié des régions de la Perse."
,"2":"En effet il était allé jusqu'à une ville du nom de Persépolis, il avait essayé de piller le temple et de soumettre la ville, mais la foule s'était soulevée contre lui. Elle avait pris les armes et Antiocus, mis en fuite par les habitants du pays, avait dû se retirer sans gloire."
,"3":"Comme il était dans la région d'Ekbatane, il apprit ce qui était arrivé à Nicanor et à l'armée de Timothée."
,"4":"Fou de colère, il pensait faire payer aux Juifs l'audace de ceux qui l'avaient obligé à fuir. Il ordonna donc au conducteur de son char de rouler sans s'arrêter pour arriver au plus tôt; mais la vengeance du ciel le poursuivait, car dans son orgueil il avait dit: 'Aussitôt arrivé à Jérusalem, je ferai de cette ville le tombeau des Juifs.'"
,"5":"Mais voici que le Seigneur Dieu d'Israël, qui voit toute chose, le frappa d'une plaie incurable et horrible à voir. Il venait à peine de prononcer cette parole qu'il fut atteint d'un mal d'intestins sans espoir de guérison, avec des douleurs aiguës dans le ventre."
,"6":"C'était bien juste, car il avait déchiré les entrailles des autres dans des supplices cruels et incroyables."
,"7":"Cependant, son insolence ne diminuait pas pour autant et, toujours rempli d'orgueil, il laissait aller contre les Juifs le feu de sa colère, ordonnant d'accélérer la marche. Soudain, dans un grand bruit, il tomba de son char en pleine course, et la chute fut si violente que tous les membres de son corps en furent disloqués."
,"8":"Lui qui tout à l'heure se prenait pour un surhomme, prêt à commander aux flots de la mer ou à peser dans une balance la masse des montagnes, il était maintenant jeté à terre; on l'emporta sur un brancard et la puissance de Dieu éclata aux yeux de tous."
,"9":"Des vers sortaient du corps de cet impie alors qu'il vivait encore, ses chairs s'en allaient en lambeaux avec d'atroces douleurs, et l'odeur de pourriture qui sortait de lui incommodait toute l'armée."
,"10":"A cause de cette odeur insupportable, plus personne maintenant ne pouvait rester auprès de celui qui autrefois semblait toucher aux astres du ciel."
,"11":"Alors, au milieu de ses terribles souffrances, il commença à revenir de son grand orgueil et à reconnaître lui-même sa condition sous le fouet divin qui à chaque moment redoublait ses douleurs."
,"12":"Lui-même ne pouvait plus supporter sa propre odeur, il reconnut: 'Il est juste de se soumettre à Dieu et de ne pas s'égaler à la Divinité quand on est un simple mortel.'"
,"13":"Cet homme souillé fit alors un voeu au Maître qui, à cette heure, ne devait plus avoir pitié de lui."
,"14":"Il promettait de déclarer libre cette Ville Sainte vers laquelle il s'était hâté de revenir pour la raser et en faire le tombeau de ses habitants."
,"15":"Il promettait de donner à tous les Juifs les mêmes droits qu'aux Athéniens, alors que peu avant il ne les jugeait pas dignes de sépulture et qu'il les donnait déjà, eux et leurs enfants, en pâture aux oiseaux de proie et aux bêtes féroces."
,"16":"Il promettait d'orner des plus belles offrandes le Temple Saint qu'il avait jadis dépouillé, de lui rendre et bien au-delà, tous les objets sacrés et d'assurer sur ses propres revenus les frais des sacrifices."
,"17":"Plus encore, il promettait de se faire Juif et de parcourir tous les lieux habités pour y proclamer la toute-puissance de Dieu."
,"18":"Mais ses souffrances ne se calmèrent pas pour autant, car le juste jugement de Dieu s'était abattu sur lui; alors, se voyant dans un état désespéré, il écrivit aux Juifs cette lettre qui ressemblait à une supplication et qui était rédigée ainsi:"
,"19":"'Le roi et général Antiocus salue les Juifs, ses excellents citoyens, et leur souhaite santé et bonheur parfaits."
,"20":"Si vous et vos enfants vous portez bien, si vos affaires vont comme vous le souhaitez, j'en rends grâce au Ciel"
,"21":"car je me rappelle avec affection les marques d'honneur et de bonté que j'ai reçues de vous. A mon retour des régions de Perse, je suis tombé dans une cruelle maladie et je crois nécessaire de me préoccuper de votre avenir à tous."
,"22":"Ce n'est pas que je désespère de guérir, j'ai même bon espoir de sortir de cette maladie;"
,"23":"mais je repense à mon père qui désignait son successeur lorsqu'il partait en campagne dans les provinces lointaines."
,"24":"Il voulait en effet qu'en cas d'un malheur imprévu ou d'une pénible nouvelle, les gens du royaume ne soient pas déconcertés, mais qu'ils sachent à qui le gouvernement était remis."
,"25":"Je pense par ailleurs que les rois voisins et les princes des Etats qui m'entourent guettent les occasions et sont à l'affût de tout ce qui peut arriver. C'est pourquoi j'ai désigné comme roi mon fils Antiocus. Plus d'une fois, lorsque je parcourais les provinces lointaines, je l'ai recommandé à la plupart d'entre vous et je lui ai écrit la lettre recopiée ci-dessous."
,"26":"Je vous demande donc et je vous prie de vous rappeler les bienfaits que vous avez reçus de moi, tous ensemble ou en particulier, et de nous conserver votre bienveillance, à moi comme à mon fils."
,"27":"Je suis certain qu'il poursuivra avec modération et humanité ma politique à votre égard et qu'il se montrera bienveillant envers vous.'"
,"28":"C'est ainsi que cet assassin, ce blasphémateur, passa par de terribles souffrances, comme il en avait fait subir aux autres, avant de mourir d'une mort misérable sur une terre étrangère, au milieu des montagnes."
,"29":"Philippe, son compagnon d'enfance, fit emporter son corps; puis il se réfugia en Egypte auprès de Ptolémée Philométor, car il craignait le jeune Antiocus."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Maccabée et ses compagnons reprirent le Temple et la ville avec le secours du Seigneur."
,"2":"Ils détruisirent les autels que les étrangers avaient construits sur la place publique, ainsi que les enceintes sacrées."
,"3":"Après avoir purifié le Temple, ils construisirent un nouvel autel et ils allumèrent un feu nouveau à partir d'étincelles tirées de la pierre. Après deux ans d'interruption, ils offrirent un sacrifice, ils firent fumer l'encens, allumèrent les lampes et posèrent sur la table les pains de proposition."
,"4":"Ensuite, prosternés et étendus à terre, ils prièrent le Seigneur de ne plus les laisser tomber dans de tels malheurs. Ils lui demandaient, s'ils péchaient encore, de les corriger comme il convient, mais de ne plus les livrer à des nations impies et barbares."
,"5":"Le Temple fut purifié au même jour où il avait été profané par les païens, c'est-à-dire le vingt-cinquième jour du mois de Kasleu."
,"6":"On célébra joyeusement la fête durant huit jours comme on le fait aux jours des Tentes; on pouvait se rappeler que quelque temps plus tôt on avait célébré la fête des Tentes dans les montagnes, s'abritant dans des grottes comme les bêtes sauvages."
,"7":"C'est pourquoi, portant des rameaux, des feuillages et des palmes, ils chantèrent des cantiques à la gloire de celui qui avait mené à bien la purification de son Temple."
,"8":"Après une déclaration publique et un vote, on décida que toute la nation juive célébrerait chaque année ces mêmes jours."
,"9":"Voilà donc les faits relatifs à la mort d'Antiocus, surnommé Epiphane."
,"10":"Nous parlerons maintenant d'Antiocus Eupator, le fils de ce roi impie, en passant rapidement sur les malheurs causés par les guerres."
,"11":"Après avoir hérité du royaume, Antiocus Eupator choisit pour gouverner un certain Lysias qui fut aussi nommé général en chef de Coelé-Syrie et de Phénicie."
,"12":"Il faut dire ici quelques mots de Ptolémée, appelé Macron. Cet homme essayait de régler les problèmes des Juifs dans un esprit de paix; il avait même été le premier à réparer avec justice les injustices faites aux Juifs."
,"13":"A cause de cela les Amis du roi l'accusèrent auprès d'Eupator. A tout moment il s'entendait appeler traître: on lui reprochait d'avoir abandonné Chypre, qui lui avait été confiée par Philométor, et d'être passé dans le camp d'Antiocus Epiphane. Voyant qu'il ne pouvait remplir sa charge avec honneur, il s'était empoisonné."
,"14":"Or Gorgias était devenu général dans ces régions. Il entretenait des mercenaires et ne manquait pas une occasion de faire la guerre aux Juifs."
,"15":"En même temps que lui, les Iduméens qui possédaient des forteresses bien placées, ne cessaient de harceler les Juifs. Ils accueillaient ceux qu'on chassait de Jérusalem et faisaient tout pour entretenir la guerre."
,"16":"Maccabée et ses hommes firent des prières publiques. Ils demandèrent à Dieu de se mettre de leur côté, puis ils se lancèrent contre les forteresses des Iduméens."
,"17":"Au cours d'une violente attaque ils se rendirent maîtres de ces positions après avoir repoussé tous ceux qui combattaient sur les remparts. Alors ils égorgèrent tous ceux qui tombaient entre leurs mains, ils en tuèrent au moins vingt mille."
,"18":"Neuf mille au moins s'étaient réfugiés dans deux tours bien fortifiées et remplies de tout ce qui était nécessaire pour soutenir un siège."
,"19":"Maccabée laissa Simon et Joseph, ainsi que Zachée et ses compagnons en nombre suffisant pour les assiéger, et lui-même partit combattre là où c'était le plus urgent."
,"20":"Mais les hommes de Simon, par amour de l'argent, se laissèrent acheter par quelques-uns de ceux qui étaient dans les tours; pour soixante-dix mille drachmes ils laissèrent s'échapper un certain nombre."
,"21":"Dès que Maccabée fut au courant de ce qui était arrivé, il rassembla les chefs du peuple et il accusa ces hommes qui avaient vendu leurs frères et laissé échapper leurs ennemis pour de l'argent."
,"22":"Il fit donc exécuter ces traîtres et aussitôt il s'empara des deux tours."
,"23":"Les armes à la main, il eut un plein succès et il fit mourir dans ces deux forteresses plus de vingt mille hommes."
,"24":"Rappelons que Timothée avait été vaincu auparavant par les Juifs. Il rassembla donc des troupes étrangères en très grand nombre, entre autres une nombreuse cavalerie venue d'Asie, et il revint avec l'idée de s'emparer de la Judée par les armes."
,"25":"Comme il approchait, Maccabée et ses hommes s'habillèrent avec des sacs pour supplier Dieu, et jetèrent de la poussière sur leur tête."
,"26":"Ils se prosternèrent au pied de l'autel, demandant au Seigneur de leur montrer sa bonté, de se faire l'ennemi de leurs ennemis et l'adversaire de leurs adversaires, comme la Loi le dit en toutes lettres."
,"27":"Leur prière terminée, ils prirent les armes et s'avancèrent assez loin au-dehors de la ville. Arrivés tout près de l'ennemi, ils prirent position."
,"28":"Le soleil venait tout juste de se lever quand ils s'élancèrent des deux côtés. Les uns comptaient pour le succès et la victoire sur leur courage, mais plus encore sur l'aide du Seigneur, les autres se laissaient emporter par leur passion."
,"29":"Au plus fort de la mêlée, les ennemis aperçurent, venant du ciel, cinq hommes magnifiques montés sur des chevaux aux brides d'or, qui s'avançaient à la tête des Juifs."
,"30":"Ils prirent Maccabée au milieu d'eux et, le protégeant de leurs armures, ils le rendaient invulnérable. En même temps, ils lançaient sur les ennemis flèches et foudre, et ceux-ci, aveuglés, paniqués, s'enfuyaient de tous côtés."
,"31":"On en égorgea vingt mille cinq cents, ainsi que six cents cavaliers."
,"32":"Timothée lui-même se réfugia dans une place nommée Gazara, une forteresse importante dont le général s'appelait Chéréas."
,"33":"Pleins d'enthousiasme, Maccabée et ses hommes assiégèrent la forteresse pendant quatre jours."
,"34":"Ceux qui étaient à l'intérieur, comptant sur la solidité de leurs défenses, prononçaient toutes sortes de blasphèmes, des paroles que l'on ne peut répéter."
,"35":"Au début du cinquième jour, vingt jeunes de l'armée de Maccabée, rendus furieux par ces blasphèmes, s'élancèrent contre le rempart avec un grand courage et frappèrent sauvagement tous ceux qui leur tombaient sous la main."
,"36":"D'autres s'avancèrent aussi contre les assiégés en les prenant à revers et mirent le feu aux tours; ils allumèrent des bûchers où furent brûlés vifs ceux qui avaient blasphémé. D'autres enfonçaient les portes et ouvraient un passage au reste de l'armée qui s'empara de la ville."
,"37":"Timothée s'était caché dans une citerne, on l'égorgea avec son frère Chéréas et Apollofane. Cela fait, on bénit le Seigneur par des hymnes et des chants d'actions de grâce, car il venait d'accorder un grand bienfait à Israël en lui donnant la victoire."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Lysias, le tuteur et parent du roi qui gouvernait le royaume, fut très contrarié de ce qui venait de se passer. Très peu de temps après"
,"2":"il rassembla environ quatre-vingt mille hommes et toute la cavalerie; il se mit en marche contre les Juifs avec l'idée de faire de leur ville une résidence de Grecs,"
,"3":"de tirer de l'argent du Temple comme des sanctuaires des païens, et de mettre en vente chaque année la charge de grand prêtre."
,"4":"Il se laissait aveugler par la foule de ses fantassins, par ses milliers de cavaliers et ses quatre-vingts éléphants, et il oubliait complètement la force de Dieu."
,"5":"Il entra donc en Judée et s'approcha de Beth-Sour, une forteresse distante de Jérusalem d'environ trente kilomètres; il en fit le siège."
,"6":"Quand Maccabée et ses hommes apprirent que Lysias venait assiéger les forteresses, ils supplièrent le Seigneur avec des cris et des larmes; avec toute la foule, ils priaient le Seigneur d'envoyer son bon ange pour sauver Israël."
,"7":"Maccabée, le premier, reprit les armes, encourageant les autres à se lancer avec lui au-devant du danger pour secourir leurs frères. Et tous ensemble, courageusement, ils se mirent en route."
,"8":"Comme ils étaient encore près de Jérusalem, un cavalier habillé de blanc, portant une armure d'or, apparut marchant à leur tête."
,"9":"Tous ensemble ils bénirent le Dieu plein de miséricorde; déjà ils se sentaient pleins de courage, prêts à affronter non seulement des hommes mais les bêtes les plus féroces, et même à renverser des remparts de fer."
,"10":"Ils s'avancèrent donc en ordre de bataille avec cet allié venu du ciel: le Seigneur avait eu pitié d'eux et venait à leur secours."
,"11":"Ils se lancèrent comme des lions sur les ennemis et ils en tuèrent onze mille, plus seize cents cavaliers, obligeant tous les autres à prendre la fuite."
,"12":"Presque tous s'enfuyaient blessés et sans armes, et Lysias lui-même ne sauva sa vie que grâce à une fuite honteuse."
,"13":"Mais Lysias était intelligent, il réfléchit sur la défaite qu'il venait de subir. Il comprit que les Hébreux étaient invincibles parce que le Dieu fort combattait avec eux."
,"14":"C'est pourquoi il leur envoya quelqu'un pour les amener à faire la paix sur des bases justes et il ajouta qu'il saurait persuader le roi et l'obliger à devenir leur ami."
,"15":"Maccabée accepta tout ce que proposait Lysias, car il n'avait pas d'autre souci que le bien du peuple, et de fait, le roi accorda aux Juifs tout ce que Maccabée avait demandé par écrit à Lysias."
,"16":"Voici ce que disaient les lettres envoyées aux Juifs par Lysias: 'Lysias salue la communauté des Juifs."
,"17":"Vos envoyés Jean et Absalom m'ont remis vos propositions et ils attendaient une réponse aux problèmes qui ont étè soulevés."
,"18":"J'ai exposé au roi tout ce qui devait lui être soumis, et j'ai accordé ce que je pouvais accorder."
,"19":"Si donc vous conservez vos bons sentiments à l'égard de l'Etat, de mon côté j'essaierai à l'avenir de faire tout ce que je peux pour votre bien."
,"20":"Pour les questions de détails, j'ai ordonné à vos envoyés et aux miens d'en discuter avec vous."
,"21":"Portez-vous bien. L'an cent quarante-huit, le vingt-quatre de Zeus Corinthien.'"
,"22":"Voici comment était tournée la lettre du roi: 'Le roi Antiocus salue son frère Lysias."
,"23":"Notre père étant allé rejoindre les dieux, nous voulons maintenant que les sujets de notre royaume puissent s'occuper de leurs affaires sans inquiétude."
,"24":"Nous avons appris que les Juifs n'acceptent pas de suivre, comme le voulait notre père, les coutumes des Grecs, mais qu'ils préfèrent vivre à leur manière et demandent que leurs coutumes soient respectées."
,"25":"Comme nous voulons que cette nation sorte de ses troubles, nous décidons que le Temple leur sera rendu et qu'ils pourront vivre selon les coutumes de leurs ancêtres."
,"26":"Tu feras donc bien d'envoyer auprès d'eux quelqu'un pour leur tendre la main, pour qu'ils connaissent nos bonnes intentions, qu'ils soient rassurés et puissent s'occuper tranquillement de leurs propres affaires.'"
,"27":"Voici maintenant le texte de la lettre du roi adressée à la nation: 'Le roi Antiocus salue le conseil des anciens des Juifs et tous les autres Juifs!"
,"28":"Nous souhaitons que vous soyez en bonne santé, nous sommes nous-mêmes en bonne santé."
,"29":"Ménélas nous a appris votre désir de rentrer dans vos foyers et de vous occuper de vos affaires."
,"30":"Aussi tendons-nous la main et offrons-nous la paix à tous ceux qui retourneront chez eux avant le trente du mois de Xanthique."
,"31":"Les Juifs pourront manger leurs aliments et suivre leurs lois comme autrefois. Personne parmi eux ne sera inquiété de quelque manière que ce soit pour les fautes qu'il a pu commettre par ignorance."
,"32":"J'envoie d'ailleurs Ménélas pour vous rassurer."
,"33":"Portez-vous bien. L'an cent quarante huit, le quinze du mois de Xanthique.'"
,"34":"Les Romains aussi envoyèrent la lettre suivante: 'Quintus Memmius, Titus Manilius, Manius Sergius, ambassadeurs de Rome, saluent le peuple juif."
,"35":"Nous sommes pleinement d'accord avec ce que Lysias, parent du roi, vous a accordé."
,"36":"Quant aux difficultés que Lysias a décidé de soumettre au roi, envoyez-nous rapidement quelqu'un pour que nous puissions les examiner et les présenter au roi comme vous le désirez. Car nous nous rendons à Antioche."
,"37":"Ne tardez donc pas à nous envoyer quelqu'un pour que nous sachions nous aussi ce que vous pensez."
,"38":"Soyez en bonne santé. L'an cent quarante-huit, le quinze du mois de Xanthique.'"
}`)
	CurrentBook.AddChapter(12, `{
"1":"Une fois ces accords passés, Lysias retourna auprès du roi, et les Juifs retournèrent aux travaux des champs."
,"2":"Mais bien des chefs militaires de la région: Timothée, Apollonius fils de Généos, Hiéronyme, Démofon et Nicanor, le chef des mercenaires de Chypre, ne laissaient aux Juifs ni paix ni tranquillité."
,"3":"Par ailleurs, les habitants de Joppé commirent un crime odieux. Ils invitèrent les Juifs qui habitaient chez eux à monter avec leurs femmes et leurs enfants dans des barques qu'ils avaient préparées eux-mêmes;"
,"4":"cela répondait à un décret de la ville qui ne laissait voir aucune mauvaise intention. Les Juifs acceptèrent donc comme des gens qui veulent la paix et n'ont aucune méfiance; mais quand ils furent au large, on les fit couler par le fond. Ils étaient au moins deux cents."
,"5":"Dès que Judas apprit cette action cruelle commise contre des gens de sa nation, il le fit savoir à ses hommes."
,"6":"Après avoir supplié Dieu, le juste Juge, il alla surprendre les meurtriers de ses frères. Il incendia le port pendant la nuit, il brûla toutes les barques et mit à mort tous ceux qui s'y étaient réfugiés."
,"7":"La ville avait été fermée; il s'en alla donc, mais bien décidé à revenir pour mettre à mort tous les habitants de Joppé."
,"8":"Il apprit que les habitants de Yamnia voulaient faire la même chose aux Juifs qui habitaient chez eux."
,"9":"Alors, de nuit, il attaqua Yamnia, mettant le feu au port et aux bateaux; l'incendie était si grand, qu'on l'apercevait de Jérusalem, éloignée pourtant d'une cinquantaine de kilomètres."
,"10":"De là ils marchèrent contre Timothée. Comme ils s'étaient déjà éloignés d'un ou deux kilomètres, des Arabes se jetèrent sur Judas avec au moins cinq mille hommes et cinq cents cavaliers."
,"11":"Le combat fut sérieux mais les hommes de Judas, grâce à l'aide que Dieu leur donnait, remportèrent la victoire. Les nomades vaincus demandèrent à Judas de lui tendre la main, ils promirent de livrer du bétail et de leur rendre des services à l'avenir."
,"12":"Judas pensa qu'ils pourraient être utiles pour bien des choses et il accepta de faire la paix avec eux. Les Arabes, après avoir fait la paix, se retirèrent sous leurs tentes."
,"13":"Judas attaqua encore une ville fortifiée protégée par des levées de terre et des remparts; elle était habitée par des païens, avec une population très mélangée, et s'appelait Kaspin."
,"14":"Ceux de l'intérieur comptaient sur la solidité des remparts et sur leurs réserves de nourriture. Ils se montraient grossiers envers Judas et ses hommes, ils les insultaient et blasphémaient, avec des paroles qu'on ne peut répéter."
,"15":"Judas et ses hommes supplièrent alors le Grand Souverain du monde: il avait bien fait tomber Jéricho sans béliers ni machines de guerre au temps de Josué. Ensuite ils se jetèrent avec fureur contre le rempart."
,"16":"Ils s'emparèrent de la ville par la volonté de Dieu et ils y firent un massacre si incroyable que l'étang voisin, qui a plus de cent mètres de large, semblait rempli de sang."
,"17":"Après une marche de cent quarante kilomètres environ, ils arrivèrent à Charax, dans le pays des Juifs Toubiens,"
,"18":"mais ils n'y trouvèrent pas Timothée. Il était parti sans avoir rien fait, mais il avait laissé en un certain point une garnison très forte."
,"19":"Dosithée et Sosipater, généraux de Maccabée, y firent une expédition et massacrèrent les dix mille hommes que Timothée avait laissés dans cette place."
,"20":"De son côté, Maccabée divisa son armée en bataillons et mit des chefs à leur tête, puis il se lança contre Timothée. Celui-ci avait avec lui cent vingt mille fantassins et deux mille cinq cents cavaliers."
,"21":"Lorsque Timothée apprit l'avance de Judas, il renvoya les femmes, les enfants et le reste des bagages en un lieu appelé Karnion. C'était une forteresse imprenable, car les passages dans ce secteur sont très étroits, et l'accès en était difficile."
,"22":"Dès que l'avant-garde de Judas apparut, les ennemis furent remplis de peur; ils furent également effrayés par une manifestation de Celui qui voit tout, si bien qu'ils s'enfuirent de tous côtés. Ils se transperçaient les uns les autres et beaucoup furent blessés par leurs propres compagnons."
,"23":"Judas les poursuivit sans relâche, il massacra ces bandits et fit périr plus de trente mille hommes."
,"24":"Timothée lui-même était tombé aux mains des hommes de Dosithée et de Sosipater. Il fut assez habile pour leur demander de le relâcher sain et sauf car, disait-il, il détenait les parents et les frères de beaucoup d'entre eux et il pourrait bien leur arriver malheur."
,"25":"Aussi, quand il s'engagea après bien des paroles à renvoyer libres ces personnes, ils le relâchèrent pour sauver leurs frères."
,"26":"Judas fit une expédition à Karnion et à Atargatéion, il y égorgea vingt-cinq mille hommes."
,"27":"Après avoir mis en fuite ou détruit ses ennemis, Judas fit une expédition contre Efron, ville fortifiée où habitait Lysanias. Des jeunes gens vigoureux, rangés au pied des murailles, combattaient avec courage, et à l'intérieur il y avait de nombreuses machines avec des réserves de projectiles."
,"28":"Mais, après avoir supplié le Souverain qui brise par sa puissance la force des ennemis, les Juifs s'emparèrent de la ville et couchèrent sur le sol environ vingt-cinq mille hommes de ceux qui s'y trouvaient."
,"29":"Partant de là, ils se rendirent à Scythopolis, à une centaine de kilomètres de Jérusalem."
,"30":"Mais les Juifs qui y résidaient affirmèrent que les gens de Scythopolis s'étaient bien conduits envers eux et avaient eu pour eux bien des attentions aux jours de malheur."
,"31":"Judas et ses hommes remercièrent les habitants de Scythopolis et les engagèrent à continuer dans leurs bonnes dispositions envers ceux de leur race. Après quoi ils furent de retour à Jérusalem peu de temps avant la fête des Semaines."
,"32":"Après cette fête, appelée Pentecôte, ils se lancèrent contre Gorgias, général de l'Idumée."
,"33":"Ce Gorgias s'avançait avec trois mille fantassins et quatre cents cavaliers."
,"34":"On engagea la bataille et quelques Juifs tombèrent."
,"35":"Un nommé Dosithée, un solide cavalier de la troupe de Bakenor, attrapa Gorgias en personne par sa pèlerine; il le tirait vigoureusement, car il voulait capturer vivant cet homme maudit, mais un cavalier thrace se jeta sur Dosithée et lui fendit l'épaule, ce qui permit à Gorgias de s'enfuir à Marissa."
,"36":"Le combat se prolongeait et les hommes d'Esdrias tombaient de fatigue. Alors Judas supplia le Seigneur de se montrer, dans le combat, leur allié et leur guide."
,"37":"A haute voix, dans la langue de ses pères, il poussa le cri de guerre et chanta des hymnes, puis il fondit à l'improviste sur les hommes de Gorgias et les mit en fuite."
,"38":"Judas emmena son armée jusqu'à la ville d'Odollam. Arrivé le septième jour de la semaine, ils se purifièrent selon la coutume et célébrèrent le sabbat en ce lieu."
,"39":"Le jour suivant, les hommes de Judas allèrent relever les corps de ceux qui étaient tombés au combat (il était grand temps) pour les déposer avec leurs parents dans les tombeaux de leurs pères."
,"40":"et voici qu'ils trouvèrent sous les tuniques de chacun des morts des objets consacrés aux idoles de Yamnia, ce qui est bien sûr interdit aux Juifs par la Loi. La raison pour laquelle ces hommes avaient succombé devenait évidente: "
,"41":"tous bénirent la conduite du Seigneur, le juste Juge, qui met au grand jour les choses cachées."
,"42":"Ils se mirent en prière, demandant que le péché commis soit complètement effacé. L'héroïque Judas encouragea l'assemblée à se garder de tout péché: ils venaient de voir de leurs propres yeux ce qui était arrivé à leurs compagnons, tombés à cause de leurs péchés."
,"43":"Il fit alors parmi ses hommes une collecte qui rapporta environ deux mille pièces; il les envoya à Jérusalem pour qu'on y offre un sacrifice pour le péché. C'était là un geste très beau et très noble, inspiré par la pensée de la résurrection. "
,"44":"En effet, s'il n'avait pas cru que ceux qui étaient tombés ressusciteraient, il aurait été inutile et ridicule de prier pour des morts."
,"45":"Mais il pensait qu'une belle récompense était réservée à ceux qui se sont couchés dans la mort ayant la foi; c'était là une pensée sainte et en accord avec la foi. Il fit donc offrir ce sacrifice d'expiation pour les morts, afin qu'ils soient délivrés de leurs péchés."
}`)
	CurrentBook.AddChapter(13, `{
"1":"En l'an cent quarante-neuf, Judas et ses hommes apprirent qu'Antiocus Eupator avançait sur la Judée avec une grande armée."
,"2":"Il était accompagné de son tuteur Lysias, administrateur du royaume. Chacun avait une armée grecque de cent dix mille fantassins, cinq mille trois cents cavaliers, vingt-deux éléphants et trois cents chars armés de faux."
,"3":"Ménélas s'était joint à eux et, avec une grande astuce, il s'empressait auprès d'Antiocus, non pas pour le salut de la patrie, mais avec l'espoir de retrouver sa charge."
,"4":"Or voici que Lysias le dénonça comme la cause de tous les maux, et le Roi des rois excita la colère d'Antiocus contre ce criminel. Antiocus aussitôt ordonna de le conduire à Bérée pour le mettre à mort selon la coutume de l'endroit."
,"5":"Il y a en effet en ce lieu une tour de cinquante coudées de haut, remplie de cendres et munie d'une machine tournante qui de tous côtés fait retomber dans la cendre."
,"6":"C'est là qu'on pousse, pour le mettre à mort, celui qui est coupable d'un vol sacrilège ou de tout autre crime odieux,"
,"7":"et c'est ainsi que devait mourir ce traître Ménélas: même la terre refusa de le recevoir."
,"8":"C'était justice, car il avait commis beaucoup de péchés contre l'autel dont le feu et la cendre sont sacrés: c'est dans la cendre qu'il trouva la mort."
,"9":"Le roi s'avançait donc avec des intentions barbares: il voulait faire voir aux Juifs des choses pires encore que ce qu'ils avaient connu sous le règne de son père."
,"10":"Lorsque Judas en fut informé, il ordonna au peuple d'invoquer le Seigneur jour et nuit pour qu'une fois de plus, comme il l'avait fait tant d'autres fois, il vienne en aide à ceux qu'on voulait priver de la Loi, de leur patrie et du Temple Saint."
,"11":"Il ne pouvait pas abandonner le peuple qui venait à peine de reprendre vie et le laisser tomber aux mains de païens infâmes."
,"12":"Lorsque tout le monde eut fini de prier le Seigneur plein de miséricorde avec des pleurs, des jeûnes et des prosternations continuelles durant trois jours, Judas leur adressa la parole et leur commanda de se tenir prêts."
,"13":"Il se retira ensuite avec les anciens et l'on décida de ne pas attendre que l'armée du roi envahisse la Judée et prenne la ville, mais de sortir immédiatement et d'obtenir une décision avec l'aide de Dieu."
,"14":"Après avoir confié cette décision au Créateur du monde, il encouragea ses compagnons à combattre courageusement jusqu'à la mort, pour les lois, le Temple, la ville, la patrie et les institutions; puis il établit son camp dans les environs de Modin."
,"15":"Il donna comme mot d'ordre à ses hommes: 'Victoire de Dieu!' Et de nuit il attaqua la tente du roi avec l'élite des jeunes. Il tua dans le camp environ deux mille hommes et transperça l'éléphant de tête avec celui qui était dans sa tour."
,"16":"Enfin, il remplit le camp de terreur et de confusion, et tous se retirèrent après un total succès."
,"17":"Le jour commençait à peine à se lever que déjà tout était terminé, grâce à la constante protection du Seigneur en faveur de Judas."
,"18":"Le roi avait pu mesurer le courage des Juifs. Il essaya donc de prendre les places en manoeuvrant."
,"19":"Il marcha contre Beth-Sour qui était une place forte des Juifs, mais il fut repoussé, mis en échec et vaincu."
,"20":"Judas faisait passer aux assiégés ce dont ils avaient besoin."
,"21":"Mais Rodocos, de l'armée juive, livrait les secrets aux ennemis; on le rechercha, on l'arrêta et on le fit disparaître."
,"22":"Le roi reprit les pourparlers avec les gens de Beth-Sour, il leur tendit la main et accepta la leur, puis il se retira pour attaquer Judas et ses hommes, mais il fut battu."
,"23":"Il apprit alors que Philippe, qu'il avait laissé à Antioche pour diriger les affaires du royaume, s'était révolté. Il en fut bouleversé. Il fit appeler les Juifs et se soumit: il accepta avec serment toutes leurs conditions. Il se réconcilia avec eux et offrit un sacrifice, il honora le Temple et traita le Lieu Saint avec générosité."
,"24":"Il réserva un bon accueil à Maccabée et laissa Hégémonide comme général d'armée depuis Ptolémaïs jusqu'au pays des Géréniens."
,"25":"Il se rendit ensuite à Ptolémaïs, mais les habitants de la ville voyaient ce traité d'un mauvais oeil: ils en étaient scandalisés et voulaient en violer les accords."
,"26":"Alors Lysias monta à la tribune et justifia de son mieux les accords. Il persuada les gens de Ptolémaïs, les calma et les amena à changer d'attitude, puis il partit pour Antioche. C'est ainsi que se déroulèrent l'offensive et la retraite du roi."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Trois ans plus tard, les partisans de Judas entendirent parler de Démétrius fils de Séleucus, qui venait de débarquer dans le port de Tripoli avec une grande armée et une flotte."
,"2":"Il s'était emparé du pays et avait fait périr Antiocus avec son tuteur Lysias."
,"3":"Alors intervint un certain Alkime, qui avait rempli autrefois la charge de grand prêtre et s'était volontairement rendu impur au temps de la révolte. Il comprenait qu'il n'avait plus aucun avenir et qu'il ne retrouverait plus sa place auprès du saint autel."
,"4":"Aussi, vers l'an cent cinquante et un, il alla trouver le roi Démétrius et lui offrit une couronne d'or avec une palme et, selon l'usage, des rameaux d'olivier au nom du Temple. Ce jour-là il ne fit rien de plus."
,"5":"Mais sa perversité trouva une bonne occasion lorsque Démétrius le convoqua au conseil et l'interrogea sur les intentions et les projets des Juifs. Il répondit alors: "
,"6":"'Un groupe juif, celui des Assidéens, dont Judas Maccabée a pris la direction, entretient la guerre et la sédition. Ils ne permettront pas que le royaume retrouve la stabilité."
,"7":"Pour ma part, j'ai été privé de la charge qui me venait de mes ancêtres, je parle du souverain sacerdoce. Si maintenant je suis venu ici,"
,"8":"c'est d'abord avec le souci sincère des intérêts du roi, mais aussi parce que je veux le bien de mes concitoyens. Car toute notre race connaît une véritable misère par la faute des insensés que je viens de nommer."
,"9":"Informe-toi donc dans le détail, ô roi, et puis fais quelque chose pour notre pays et pour notre race si menacée, avec cette humanité bienveillante que tu montres envers tous."
,"10":"Car tant que Judas sera là, l'Etat ne connaîtra pas la paix.'"
,"11":"Dès qu'il eut fini de parler, les autres amis du roi qui détestaient aussi Judas firent tout pour exciter davantage encore Démétrius."
,"12":"Aussitôt il désigna Nicanor, qui était devenu chef des éléphants de combat, comme général pour la Judée. Il l'envoya"
,"13":"avec l'ordre de faire disparaître Judas, de disperser ses hommes et de rétablir Alkime comme grand prêtre du Temple Sublime."
,"14":"Les païens que Judas avait pourchassés se joignirent en masse à Nicanor, ils pensèrent que les misères et les malheurs des Juifs feraient leur propre bonheur."
,"15":"Lorsque les Juifs apprirent la venue de Nicanor et l'agression des païens, ils se couvrirent de poussière pour supplier Celui qui avait établi son peuple pour toujours et qui, chaque fois, soutenait son peuple personnel par quelque manifestation."
,"16":"Puis ils partirent sans délai sur l'ordre de leur chef et engagèrent le combat avec l'ennemi au-dessus de Dessau."
,"17":"Simon, le frère de Judas, avait affronté Nicanor mais, surpris par la riposte de l'ennemi, il avait subi un léger échec."
,"18":"De son côté, Nicanor avait appris la bravoure de Judas et de ses hommes, leur courage dans les combats qu'ils menaient pour la patrie, et il craignait de s'en remettre à la décision de la bataille."
,"19":"C'est pourquoi il envoya Posidonius, Théodote et Mattathias, pour tendre la main aux Juifs et recevoir la leur."
,"20":"Judas examina soigneusement leurs propositions; le chef les communiqua aux troupes et, comme tous étaient du même avis, les accords furent approuvés."
,"21":"On fixa un jour où les chefs se rencontreraient en particulier. De chaque côté un char s'avança, on plaça des sièges d'honneur."
,"22":"Judas avait posté aux bons endroits des hommes armés prêts à tout, pour le cas d'une trahison soudaine de la part des ennemis, mais l'entretien se passa correctement."
,"23":"Nicanor resta à Jérusalem sans rien faire de mal, il renvoya même les foules qui s'étaient rassemblées autour de lui."
,"24":"Comme Judas était sans cesse à ses côtés, il éprouva peu à peu pour cet homme une profonde admiration."
,"25":"Il l'engagea à se marier et à avoir des enfants; Judas se maria, il goûta la paix et mena une vie normale."
,"26":"Alkime se rendit compte de cette compréhension réciproque. Alors il se procura une copie du traité qu'ils avaient signé. Il entra chez Démétrius et lui dit que les plans de Nicanor n'étaient pas conformes aux intérêts de l'Etat: n'avait-il pas désigné comme son lieutenant Judas, l'ennemi du royaume?"
,"27":"Hors de lui, excité par les calomnies de ce misérable, le roi écrivit à Nicanor pour lui dire à quel point il était mécontent de ces accords. Il lui ordonnait de lui envoyer tout de suite, à Antioche, Maccabée chargé de chaînes."
,"28":"Lorsque Nicanor apprit cela, il fut bouleversé car il lui coûtait beaucoup de violer les accords face à un homme qui n'avait pas le moindre tort."
,"29":"Mais comme il ne pouvait pas s'opposer à la volonté du roi, il chercha une occasion favorable pour réaliser ce projet par ruse."
,"30":"De son côté, Maccabée se rendit compte que Nicanor était plus distant avec lui et que son attitude envers lui se faisait habituellement plus dure. Il comprit que ce refroidissement n'annonçait rien de bon. Il appela donc auprès de lui un bon nombre de partisans et cessa de fréquenter Nicanor."
,"31":"Quand Nicanor vit que Maccabée avait déjoué ses plans, il se rendit au Temple très grand et saint à l'heure où les prêtres offrent les sacrifices habituels, et il ordonna de lui livrer cet homme."
,"32":"Les prêtres déclarèrent avec serment qu'ils ne savaient pas où se trouvait celui qu'on cherchait."
,"33":"Alors il étendit la main droite vers le Temple et jura: 'Si vous ne me livrez pas Judas enchaîné, je raserai ce lieu consacré à Dieu, j'abattrai l'autel et au même endroit je construirai un temple magnifique en l'honneur de Dionysos.'"
,"34":"Après ces paroles, il s'en alla. Les prêtres tendirent les mains vers le Ciel, invoquant le perpétuel Défenseur de notre nation: "
,"35":"'Tu n'as besoin de rien, Seigneur! Tu as pourtant voulu au milieu de nous ce Temple où tu habites."
,"36":"Maintenant donc, Seigneur, Saint de toute sainteté, protège à jamais ce Temple de toute souillure puisqu'il vient d'être purifié.'"
,"37":"On dénonça auprès de Nicanor un certain Razi, l'un des anciens de Jérusalem. C'était un homme qui aimait ses concitoyens, un homme d'une excellente réputation qu'on appelait à cause de sa bonté: 'Le père des Juifs'."
,"38":"Dans les premières heures de la révolte, il avait été accusé de Judaïsme et il s'était dépensé corps et âme, de mille façons, pour défendre le Judaïsme."
,"39":"Nicanor, voulant donner des preuves de son hostilité envers les Juifs, envoya plus de cinq cents soldats pour l'arrêter."
,"40":"Il pensait en effet qu'en arrêtant cet homme, il ferait un très grand tort aux Juifs."
,"41":"La troupe était sur le point d'occuper la tour, déjà les hommes forçaient la porte de la tour et demandaient du feu pour en brûler les portes, lorsque Razi, se voyant cerné, se transperça avec son épée:"
,"42":"il préféra mourir noblement plutôt que de tomber entre les mains de ces bandits et de subir des violences indignes de sa noblesse."
,"43":"Mais il avait fait trop vite, il n'avait pas frappé au bon endroit. Alors que déjà la foule franchissait sa porte, il courut bravement au sommet du mur et se jeta sur la foule."
,"44":"Les gens reculèrent et Razi tomba au milieu de la place vide."
,"45":"Il respirait encore; rempli d'ardeur il se releva tout ruisselant de sang et couvert de terribles blessures. Il traversa la foule en courant et s'arrêta sur une roche escarpée."
,"46":"Il était déjà vidé de son sang, mais il fit encore sortir ses entrailles et, les prenant dans ses deux mains, il les jeta sur la foule. Puis, après avoir prié le maître de la vie et du souffle, lui demandant de les lui rendre un jour, il quitta cette vie."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Nicanor apprit que Judas et ses hommes étaient du côté de la Samarie et il décida de les attaquer sans risque le jour du sabbat."
,"2":"Les Juifs qui étaient obligés de le suivre lui dirent: 'Ne les fais pas mourir d'une manière si sauvage et si barbare. Respecte ce jour puisque Celui qui voit tout l'a voulu supérieur à tous les autres: il en a fait un jour saint.'"
,"3":"Alors ce triple criminel demanda s'il y avait bien au ciel un souverain qui ait ordonné de célébrer le jour du sabbat."
,"4":"Les Juifs répondirent: 'C'est le Seigneur vivant, le Souverain du ciel, qui a ordonné de célébrer le septième jour."
,"5":"Mais l'autre déclara: 'Eh bien, moi qui suis souverain sur la terre, j'ordonne de prendre les armes et d'obéir à la volonté du roi.' Cependant il ne put réaliser son projet sanguinaire."
,"6":"Avec beaucoup de suffisance et de prétention, Nicanor avait décidé de faire une exposition des dépouilles de Judas et de ses hommes."
,"7":"Maccabée n'en était pas moins confiant, il comptait fermement sur l'aide du Seigneur."
,"8":"Il encouragea donc ses hommes à ne pas redouter l'approche des païens; il les invita à se rappeler les secours qui leur étaient venus du ciel dans le passé: ils devaient être sûrs que le Tout-Puissant leur donnerait aujourd'hui la victoire."
,"9":"Il leur redit les paroles de la Loi et des prophètes et ranima leur enthousiasme en leur remettant en mémoire les nombreux combats où ils avaient triomphé."
,"10":"Après avoir ainsi réveillé leur ardeur, il confirma ses paroles en faisant voir à ses hommes la déloyauté des païens et comment ils avaient violé leur serment."
,"11":"Judas les laissa ainsi bien équipés: ce n'était pas la sécurité que donnent les boucliers et les lances, mais le réconfort qu'apportent de bonnes paroles. Pour terminer, il leur raconta un songe digne de foi, une sorte de vision qui les remplit de joie."
,"12":"Voici ce qu'il avait vu: Le grand-prêtre Onias, qui avait été un homme droit, humble et doux dans son comportement, distingué dans le langage et appliqué depuis l'enfance à pratiquer la vertu, cet Onias donc, priait les mains levées vers le ciel pour tout le peuple juif."
,"13":"Ensuite était apparu dans la même attitude un homme qui se distinguait par ses cheveux blancs et sa dignité, revêtu d'une étonnante et prodigieuse majesté."
,"14":"Onias prit alors la parole et dit: 'Cet homme préoccupé pour ses frères, c'est Jérémie, le prophète de Dieu; il prie beaucoup pour le peuple et pour la Ville Sainte.'"
,"15":"Alors Jérémie avait étendu la main droite; il avait remis à Judas une épée d'or et, en la lui donnant, il avait prononcé ces paroles:"
,"16":"'Prends cette épée sainte, c'est un don de Dieu! Avec elle, tu tailleras en pièces les ennemis.'"
,"17":"Réconfortés par ces paroles de Judas, si belles et capables d'exciter le courage, de donner aux jeunes une âme virile, ils décidèrent de ne pas dresser de camp mais de prendre vaillamment l'offensive. Ils voulaient emporter la décision en se jetant dans la bataille avec tout leur courage, car la ville, le Lieu Saint et le Temple, étaient en danger."
,"18":"Leur inquiétude pour leurs femmes et leurs enfants, pour leurs frères et leurs parents, passait au second rang; la plus grande et la première de leurs craintes était pour le Sanctuaire sacré."
,"19":"Quant à ceux qu'on avait laissés dans la ville, leur anxiété n'était pas moindre, ils redoutaient le sort de cette attaque en rase campagne."
,"20":"Tous attendaient la décision prochaine. Les ennemis s'étaient rassemblés et rangés en ordre de bataille; on avait disposé les éléphants au point le plus favorable et la cavalerie était sur les côtés."
,"21":"Maccabée vit devant lui ces multitudes, la variété des armes, l'aspect farouche des éléphants. Alors il étendit les mains vers le Ciel et il invoqua le Seigneur qui accomplit des prodiges: il savait bien que ce ne sont pas les armes, mais sa volonté qui procure la victoire à ceux qui en sont dignes."
,"22":"Il prononça cette prière: 'Toi, Souverain, tu as envoyé ton ange au temps d'Ezéquias roi de Judée: il a fait périr plus de cent quatre vingt-cinq mille hommes dans l'armée de Sennakérib."
,"23":"Aujourd'hui encore, Souverain des Cieux, envoie ton bon ange devant nous pour semer la panique et la terreur."
,"24":"Que tes coups puissants frappent d'épouvante ceux qui attaquent ton peuple saint en criant leurs blasphèmes!' C'est ainsi qu'il acheva sa prière."
,"25":"Les gens de Nicanor s'avancèrent au son des trompettes et des cors;"
,"26":"Judas et ses hommes, de leur côté, engagèrent le combat avec des invocations et des prières."
,"27":"De leurs mains ils combattaient, et de tout coeur ils priaient Dieu; enthousiasmés par la manifestation de Dieu, ils n'abattirent pas moins de trente cinq mille hommes."
,"28":"La bataille terminée, alors qu'ils revenaient tout joyeux, ils reconnurent Nicanor, tombé dans son armure."
,"29":"Au milieu des cris et de la confusion générale, ils bénirent le Souverain dans la langue de leurs pères."
,"30":"Alors, celui qui avait combattu au premier rang pour ses concitoyens, de tout son coeur et de toutes ses forces, celui qui avait gardé pour sa nation les bons sentiments de sa jeunesse, ordonna de trancher la tête de Nicanor et son bras jusqu'à l'épaule, et de les emporter à Jérusalem."
,"31":"Arrivé là, il rassembla tout le peuple, il plaça les prêtres devant l'autel et envoya chercher les hommes de la Citadelle."
,"32":"Il leur montra la tête de l'infâme Nicanor et la main que ce blasphémateur avait levée dans son orgueil contre le saint Temple du Tout-Puissant."
,"33":"Puis, après avoir tranché la langue de l'impie Nicanor, il donna ordre de la donner par petits morceaux aux oiseaux et de suspendre en face du Temple le bras qu'il avait tendu dans un geste insensé."
,"34":"Tous firent monter vers le Ciel une louange au Seigneur qui s'était manifesté: 'Béni soit, disaient-ils, Celui qui a conservé son Lieu sans souillure.'"
,"35":"Judas fit accrocher à la Citadelle la tête de Nicanor comme une preuve évidente pour tous de l'aide du Seigneur."
,"36":"Tous décidèrent par un vote public de ne plus laisser passer ce jour sans le commémorer: on célébrerait le treizième jour du douzième mois, qu'on appelle en araméen le mois d'Adar, la veille du jour appelé jour de Mardochée."
,"37":"Voilà comment se déroulèrent les événements concernant Nicanor. Comme depuis ce temps la ville est demeurée entre les mains des Hébreux, moi aussi j'arrêterai là mon récit."
,"38":"S'il est bon et réussi, c'est ce que je voulais. S'il est quelconque et médiocre, c'est tout ce que j'ai pu faire."
,"39":"De même qu'il n'est pas bon de boire du vin seul, ou seulement de l'eau, alors que le vin coupé d'eau est agréable et procure beaucoup de plaisir, de même la belle ordonnance du récit charme les oreilles de ceux qui lisent l'ouvrage. Ici sera la fin."
}`)

}
func FR_LBDCC_LoadVH2PChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Salomon, fils de David, prit fermement en mains le royaume d'Israël. Yahvé, son Dieu, était avec lui et il l'éleva au plus haut point."
,"2":"Salomon s'adressa alors à tout Israël, aux chefs de mille, aux chefs de cent, aux juges, à tous les princes d'Israël et à tous les chefs de familles."
,"3":"Salomon et toute l'assemblée s'en allèrent au Haut-Lieu de Gabaon; là se trouvait la Tente du Rendez-Vous de Dieu, que Moïse, le serviteur de Dieu, avait faite dans le désert."
,"4":"Quant à l'Arche de Dieu, David l'avait amenée de Kiryat-Yéarim à l'endroit qu'il avait préparé, car il avait dressé pour elle une tente à Jérusalem."
,"5":"L'autel de bronze fabriqué par Besaléel, fils d'Ouri, fils de Hour, se trouvait devant la Tente; Salomon et l'assemblée s'en approchèrent pour y consulter Yahvé."
,"6":"Salomon monta à cet autel de bronze qui était devant Yahvé à côté de la Tente du Rendez-Vous, et il y offrit mille holocaustes."
,"7":"Cette nuit-là Dieu apparut à Salomon et dit: 'Demande-moi ce que tu veux et je te le donnerai.'"
,"8":"Salomon répondit à Dieu: 'Tu as montré une grande bonté envers David, mon père, et tu m'as fait roi à sa place."
,"9":"Yahvé Dieu, la promesse que tu as faite à David, mon père, est réalisée maintenant puisque tu m'as fait roi sur un peuple aussi nombreux que la poussière de la terre!"
,"10":"Aussi donne-moi la sagesse et la connaissance pour que je puisse conduire ce peuple, car qui peut gouverner un peuple aussi grand que le tien?'"
,"11":"Dieu dit à Salomon: 'Voilà donc ton désir: tu ne m'as pas demandé la richesse, ni les trésors, ni la gloire, ni la vie de tes ennemis. Tu ne m'as pas demandé non plus une longue vie, mais tu as demandé pour toi la sagesse et la connaissance pour diriger mon peuple dont je t'ai fait roi."
,"12":"Je te donne donc sagesse et connaissance, mais je te donne aussi richesse, trésor et gloire comme aucun roi qui t'a précédé ou qui te succédera n'en aura jamais.'"
,"13":"Salomon quitta le Haut-Lieu de Gabaon où se trouvait la Tente du Rendez-Vous et retourna à Jérusalem; il régna sur Israël."
,"14":"Salomon rassembla des chars et des chevaux; il avait 1400 chars et 12000 chevaux, il les installa dans les villes de chars et à Jérusalem, à côté du roi."
,"15":"Pendant son règne, l'argent et l'or étaient aussi courants à Jérusalem que les pierres, et les cèdres aussi nombreux que les sycomores dans le Bas-Pays."
,"16":"Les chevaux de Salomon étaient importés de Mousour et de Cilicie; les envoyés du roi allaient les acheter en Cilicie."
,"17":"Ils s'en allaient aussi en Egypte pour y acheter des chars: un char valait six cents pièces d'argent, un cheval cent cinquante; ils fournissaient encore les rois des Hittites et les rois d'Aram."
,"18":"Salomon décida de construire une maison pour le Nom de Yahvé et un palais pour lui-même."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Salomon engagea 70000 porteurs, 80000 hommes pour tailler la pierre dans les collines et 3600 pour les surveiller."
,"2":"Salomon envoya alors ce message à Hiram, roi de Tyr: 'Fais pour moi comme pour mon père David lorsque tu lui as envoyé des cèdres pour construire son palais."
,"3":"A mon tour je vais construire une Maison pour le Nom de Yahvé mon Dieu; je la consacrerai, j'y ferai fumer devant lui l'encens parfumé, j'y aurai aussi les pains disposés en rangées à perpétuité; j'y offrirai des holocaustes le matin et le soir, durant les sabbats, les Nouvelles Lunes et les jours de fête en l'honneur de Yahvé notre Dieu, selon la loi fixée à jamais pour Israël."
,"4":"La maison que je vais construire sera vaste, car notre Dieu est plus grand que tous les dieux."
,"5":"Pourtant personne ne peut réellement bâtir un temple pour Dieu, car les cieux et les cieux des cieux ne peuvent le contenir: qui donc pourrait prétendre lui construire une Maison pour y faire fumer l'encens devant lui?"
,"6":"Aussi envoie-moi un homme habile à travailler l'or, l'argent, le bronze, le fer, la pourpre rouge, les étoffes de couleur et la pourpre violette; qu'il soit également doué pour la gravure. Il travaillera avec mes artisans que David, mon père, a rassemblés en Juda et à Jérusalem."
,"7":"Envoie-moi du Liban du bois de cèdre, du cyprès, du bois de santal, car je sais que tes serviteurs savent abattre des arbres du Liban; mes serviteurs travailleront avec les tiens."
,"8":"Ils me prépareront du bois en quantité, puisque la maison que je désire construire doit être grande et magnifique."
,"9":"Je donnerai pour la nourriture de tes serviteurs, pour les bûcherons qui couperont les arbres, vingt mille mesures de blé, vingt mille mesures d'orge, vingt mille mesures de vin, vingt mille mesures d'huile.'"
,"10":"Dans une lettre envoyée au roi Salomon, Hiram, roi de Tyr, répondit: ' Si Yahvé t'a fait roi, c'est parce qu'il aime son peuple."
,"11":"Béni soit Yahvé, Dieu d'Israël, celui qui a fait le ciel et la terre! Il a donné au roi David un fils sage, rempli de bon sens et d'intelligence, qui va construire une Maison pour Yahvé et un palais royal."
,"12":"Je t'envoie donc un habile artisan, intelligent: Houram-Abi,"
,"13":"sa mère est une fille de Dan et son père est de Tyr. Il est habile à travailler l'or, l'argent, le bronze, le fer, la pierre, le bois, la pourpre rouge et violette, le lin fin et les étoffes de couleur, habile aussi pour toute sorte de gravure et pour exécuter tout projet qu'on lui soumet. Il travaillera avec tes artisans et ceux de mon seigneur David, ton père."
,"14":"Aussi, que mon seigneur envoie dès maintenant à ses serviteurs le blé, l'orge, l'huile et le vin dont il a parlé."
,"15":"De notre côté, nous allons abattre les arbres du Liban dont tu as besoin. Nous les enverrons par mer sur des radeaux jusqu'à Joppé; de là, tu les feras transporter à Jérusalem.'"
,"16":"Salomon fit alors le compte de tous les étrangers qui vivaient sur la terre d'Israël, d'après le recensement que David son père avait fait; il en dénombra 153600."
,"17":"Il en désigna 70000 comme porteurs, 80000 pour extraire les pierres dans la montagne et 3600 comme surveillants pour faire travailler le peuple."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Salomon commença à bâtir la Maison de Yahvé à Jérusalem sur le Mont Moriya où David son père avait eu une vision, à l'endroit que David avait réservé sur l'aire d'Ornan le Jébusite."
,"2":"Salomon commença la construction le deuxième mois de la quatrième année de son règne."
,"3":"La Maison que Salomon construisait était longue de soixante coudées (en ancienne coudée) et large de vingt coudées."
,"4":"Le vestibule sur le devant mesurait vingt coudées dans le sens de la largeur de la Maison; sa hauteur était de cent vingt coudées. Salomon recouvrit l'intérieur d'or pur."
,"5":"Il garnit la grande salle de bois de cyprès recouvert d'or pur; il la décora de palmes et de festons."
,"6":"Il rehaussa la construction de pierres précieuses d'une grande beauté; l'or venait de Parvayim."
,"7":"Il en recouvrit la maison: poutres, seuils, murs et portes. Sur les murs il fit graver des chérubins."
,"8":"Puis il construisit le Saint des Saints; sa profondeur, faisant suite à la grande salle, était de vingt coudées et sa largeur de vingt coudées; il le revêtit de la valeur de six cents pièces d'or fin,"
,"9":"les clous en or pesaient cinquante sicles. Il revêtit aussi les chambres hautes d'or fin."
,"10":"Dans le Saint des Saints il fit deux Chérubins en bois sculpté et les recouvrit d'or."
,"11":"La largeur des ailes des Chérubins était de vingt coudées, chaque aile mesurait cinq coudées, avec une aile qui touchait le mur de la pièce tandis que l'autre touchait celui de l'autre Chérubin."
,"12":"Ainsi une aile de Chérubin longue de cinq coudées touchait le mur de la pièce, la deuxième, longue de cinq coudées, touchait l'aile de l'autre Chérubin."
,"13":"Les ailes déployées de ces Chérubins mesuraient vingt coudées; ils étaient debout et regardaient vers la Maison."
,"14":"Il fit le rideau de pourpre violette et de pourpre rouge, d'étoffe de couleur et de lin fin; il y fit broder des chérubins."
,"15":"Devant la grande salle il fit deux colonnes d'une hauteur de trente-cinq coudées, et au sommet de chacune, un chapiteau mesurant cinq coudées."
,"16":"Il plaça des festons en haut des colonnes et cent grenades qu'il fixa sur les festons."
,"17":"Il dressa les colonnes devant le Temple, l'une à droite, l'autre à gauche; à celle de droite il donna le nom de Yakin, à celle de gauche il donna le nom de Boaz."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Il fit un autel de bronze de vingt coudées de long, vingt coudées de large et dix de haut."
,"2":"Il fit la Mer en fonte, elle faisait dix coudées de bord à bord et cinq de haut; une corde de trente coudées en aurait fait le tour."
,"3":"Des coloquintes la bordaient tout autour, il y en avait dix par coudée: elles encerclaient la Mer. Il y avait deux rangées de coloquintes venues de fonte."
,"4":"La Mer était posée sur douze boeufs, trois tournés vers le nord, trois vers l'ouest, trois vers le sud, trois vers l'est; ils étaient tournés vers l'extérieur et portaient la Mer sur leur dos."
,"5":"Elle avait la largeur d'une main et son bord était façonné comme le bord d'une coupe, comme une fleur; elle pouvait contenir trois mille mesures."
,"6":"Il fit dix bassins: cinq à droite et cinq à gauche. Ils servaient pour les purifications: on y lavait ce qui servait pour l'holocauste, mais les prêtres se purifiaient dans la Mer."
,"7":"Il fit les dix chandeliers dorés selon le modèle fixé et les plaça dans la première salle du Temple: cinq à droite et cinq à gauche."
,"8":"Il fit dix tables: on les plaça dans le Temple: dix a droite et dix à gauche. Il fit également cent cruches d'or."
,"9":"Il fit la cour des prêtres et la grande cour avec leurs portes; les portes étaient recouvertes de bronze."
,"10":"Il plaça la Mer du côté droit et regardant vers le Sud."
,"11":"Houram fit aussi les vases, les pelles et les coupes. Houram termina donc tout le travail que le roi Salomon lui avait commandé pour la Maison de Dieu: "
,"12":"les deux colonnes, les deux moulures des chapiteaux en haut des colonnes, les deux filets qui couvraient les moulures des deux chapiteaux au sommet des colonnes,"
,"13":"les quatre cents grenades des deux filets, fixées en deux rangées pour chaque filet et qui recouvraient donc les chapiteaux au sommet des colonnes,"
,"14":"les dix bassins avec leurs bases,"
,"15":"la Mer et les douze boeufs qui la soutenaient,"
,"16":"les vases, les pelles, les fourchettes. Houram-Abi fit en bronze poli tous ces objets commandés par le roi Salomon pour la Maison de Yahvé."
,"17":"Le roi les fit fondre dans la plaine du Jourdain, près du gué d'Adam, entre Soukkoth et Sartan."
,"18":"Ces objets faits par Salomon étaient si nombreux qu'on ne pouvait en compter le poids de bronze."
,"19":"Salomon fit faire tous les objets qui étaient dans la Maison de Dieu: l'autel en or et les tables pour les pains des offrandes,"
,"20":"les chandeliers d'or fin et leurs lampes pour les faire brûler selon la coutume devant le Sanctuaire: ils étaient en or fin,"
,"21":"les décorations florales, les lampes, les éteignoirs en or fin,"
,"22":"les couteaux, les cruches, les écuelles, les encensoirs en or fin, la porte de la Maison, les portes intérieures qui menaient au Saint des Saints, en or fin."
}`)
	CurrentBook.AddChapter(5, `{
"1":"On termina ainsi tout le travail commandé par Salomon pour la Maison de Yahvé. Salomon apporta les offrandes consacrées par David son père: l'argent, l'or et les vases, et les plaça dans les réserves de la Maison."
,"2":"Salomon rassembla alors à Jérusalem les anciens d'Israël, les chefs de tribus et les chefs des familles d'Israël, pour faire monter de la Cité de David (c'est Sion), l'Arche de l'Alliance de Yahvé."
,"3":"Tous les hommes d'Israël s'assemblèrent autour du roi durant la fête du septième mois."
,"4":"Tous les anciens d'Israël étant arrivés, les lévites transportèrent l'Arche:"
,"5":"on fit donc monter l'Arche, mais aussi la Tente du Rendez-Vous, et tous les objets sacrés qui se trouvaient dans la Tente: les prêtres et les lévites les transportaient."
,"6":"Le roi Salomon et toute la communauté d'Israël rassemblée autour de lui face à l'Arche, offraient en sacrifice des moutons et des boeufs en quantité incalculable."
,"7":"Les prêtres portèrent l'Arche d'Alliance de Yahvé à sa place, dans le Sanctuaire de la Maison, qu'on appelle le Saint des Saints: ils la placèrent sous les ailes des Chérubins."
,"8":"Les Chérubins déployaient leurs ailes au-dessus de l'Arche: ils recouvraient ainsi l'Arche et ses barres."
,"9":"Les barres de l'Arche étaient assez longues pour qu'on en voie le bout depuis la première salle du Temple, mais on ne pouvait pas les voir de l'extérieur; elles sont restées là jusqu'à ce jour."
,"10":"Il n'y avait rien d'autre dans l'Arche que les deux tables que Moïse y avait placées à l'Horeb, lorsque Yahvé avait fait Alliance avec le peuple d'Israël quand il sortait d'Egypte."
,"11":"Finalement les prêtres sortirent du Sanctuaire. Ils s'étaient tous purifiés, quel que soit le groupe auquel ils appartenaient."
,"12":"Tous les lévites musiciens, Asaf, Heman et Yédoutoun, étaient rassemblés avec leurs fils et leurs frères sur le côté 'est' de l'autel, revêtus de lin fin, jouant des cymbales, de la harpe, et de la lyre; cent vingt prêtres les accompagnaient à la trompette."
,"13":"Tous ceux qui jouaient de la trompette ou qui chantaient, s'unissaient pour rendre gloire et louange à Yahvé. Ils chantaient au son de la trompette, des cymbales et des instruments de musique, ils rendaient gloire à Yahvé: ' Car il est bon, son amour est éternel!' La nuée de la Gloire de Yahvé envahit alors la Maison."
,"14":"A cause de la nuée, les prêtres durent arrêter leur service, car la Gloire de Yahvé avait rempli la Maison de Dieu."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Alors Salomon dit: 'Yahvé a choisi de vivre dans la nuée obscure."
,"2":"Oui! Je t'ai construit une demeure, un Temple, un lieu où tu habiteras à jamais!'"
,"3":"Puis le roi se tourna pour bénir toute l'assemblée d'Israël qui se tenait là."
,"4":"Il dit: 'Béni soit Yahvé Dieu d'Israël, car il vient de réaliser ce qu'il avait dit à David mon père:"
,"5":"Depuis le jour où j'ai fait sortir mon peuple d'Egypte, je n'ai choisi aucune ville sur la terre d'Israël pour y bâtir la Maison où serait mon Nom, et je n'ai choisi personne pour être le chef de mon peuple Israël."
,"6":"Mais j'ai choisi Jérusalem pour être le lieu où sera mon Nom, et David comme chef de mon peuple!"
,"7":"Mon père David voulait construire un Temple pour le Nom de Yahvé, le Dieu d'Israël,"
,"8":"mais Yahvé a dit à mon père: Tu voulais construire un Temple pour mon Nom: c'était très bien!"
,"9":"Cependant, ce n'est pas toi qui construira la Maison, mais ton fils né de toi: lui me construira une Maison."
,"10":"Yahvé a réalisé ce qu'il avait dit: j'ai succédé à David, mon père, et je me suis assis sur le trône d'Israël selon la promesse de Yahvé. J'ai construit une Maison pour le Nom de Yahvé, Dieu d'Israël,"
,"11":"et j'y ai placé l'Arche qui renferme l'Alliance que Yahvé a faite avec le peuple d'Israël.'"
,"12":"Alors, debout devant l'autel de Yahvé, en présence de toute l'assemblée d'Israël, Salomon étendit ses mains."
,"13":"Salomon avait fait une tribune de bronze et l'avait placée au milieu de la cour: elle mesurait cinq coudées de long, cinq de large, et trois de haut. Monté sur la tribune, Salomon s'agenouilla devant toute l'assemblée d'Israël: il étendit ses mains vers le ciel"
,"14":"et dit: 'Yahvé, Dieu d'Israël, ni au ciel ni sur la terre il n'y a de Dieu comme toi. Tu es fidèle à ton Alliance et tu te montres plein de bonté envers tes serviteurs quand ils vivent en t'obéissant de tout leur coeur."
,"15":"Tu as tenu la promesse que tu as faite à ton serviteur David, mon père, aujourd'hui ta main a réalisé ce que tu avais promis en paroles."
,"16":"Maintenant, Yahvé, Dieu d'Israël, tiens la promesse que tu as faite à ton serviteur David quand tu lui as dit: Si tes fils sont attentifs à leur conduite et suivent ma Loi comme toi-même l'as fait, toujours il y aura quelqu'un de ta descendance pour régner sur Israël."
,"17":"Maintenant, Yahvé Dieu d'Israël, que se vérifie la parole que tu as dite à ton serviteur David!"
,"18":"Serait-ce vrai que Dieu habite avec l'homme sur la terre? Les cieux et les cieux des cieux ne peuvent te contenir, bien moins encore cette maison que j'ai construite!"
,"19":"Ecoute cependant la prière et la supplication de ton serviteur! Yahvé, mon Dieu, entends le cri et la prière que ton serviteur te présente."
,"20":"Que tes yeux soient ouverts jour et nuit sur cette Maison, sur ce lieu où tu as promis de mettre ton Nom. Ecoute la prière que ton serviteur fait monter en ce lieu;"
,"21":"écoute les supplications que ton serviteur et ton peuple Israël t'adresseront en ce lieu; du lieu de ta Demeure, des cieux, écoute et pardonne."
,"22":"Si quelqu'un pèche contre son frère et qu'on l'oblige à prêter un serment solennel, lorsqu'il viendra prêter ce serment devant ton autel, dans cette maison,"
,"23":"écoute-le du haut des cieux, agis et juge tes serviteurs: condamne le coupable en faisant retomber sa conduite sur sa tête, mais fais voir l'innocence du juste et traite-le selon sa justice."
,"24":"Lorsque ton peuple Israël aura péché contre toi et qu'il sera battu devant l'ennemi, s'il se repent et loue ton Nom,"
,"25":"écoute-le du haut des cieux, pardonne le péché de ton peuple Israël et ramène-le vers le pays que tu as donné, à lui et à ses pères."
,"26":"Lorsque ton peuple aura péché contre toi et que le ciel retiendra la pluie, s'il vient prier dans ce lieu, s'il célèbre ton Nom, s'il renonce au péché pour lequel tu l'auras humilié,"
,"27":"toi, écoute du haut des cieux, pardonne le péché de tes serviteurs et de ton peuple Israël. Montre-leur le bon chemin qu'ils doivent suivre et envoie la pluie sur la terre que tu as donnée à ton peuple en héritage."
,"28":"Lorsqu'il y aura dans le pays une famine, une peste, un fléau ou une catastrophe, sauterelles ou criquets, lorsque son ennemi l'assiégera dans l'une de ses villes, lorsqu'il y aura une épidémie ou une maladie -"
,"29":"quelle que soit la prière de qui que ce soit ou de tout ton peuple, lorsqu'ils se voient dans la douleur ou la détresse et tendent les mains vers cette Maison,"
,"30":"écoute du haut des cieux où tu habites et pardonne; toi qui connais leurs coeurs -puisque toi seul connais le coeur des hommes - traite chacun selon sa conduite."
,"31":"Ainsi tous te craindront et marcheront dans tes chemins tous les jours de leur vie, sur cette terre que tu as donnée à nos pères."
,"32":"Un étranger, qui n'est pas de ton peuple Israël, pourrait venir d'un pays lointain à cause de ta grande renommée, de ta main puissante et de tes grandes interventions. S'il vient prier dans cette Maison,"
,"33":"écoute-le du haut des cieux où tu habites et exauce en toutes choses la prière de cet étranger. Ainsi tous les peuples de la terre connaîtront ton Nom, ils te craindront comme le fait ton peuple Israël, et ils sauront que ton Nom repose sur cette Maison que j'ai bâtie."
,"34":"Lorsque ton peuple partira en guerre contre ses ennemis par le chemin sur lequel tu l'auras envoyé, s'il te prie en se tournant vers cette ville que tu as choisie, et vers la Maison que j'ai bâtie en l'honneur de ton Nom,"
,"35":"écoute du haut des cieux ses prières et ses supplications et fais-lui justice."
,"36":"Lorsqu'ils auront péché contre toi - car y a-t-il un seul homme qui ne pèche jamais? -lorsque tu seras en colère contre eux, que tu les livreras à leurs ennemis et que leurs vainqueurs les emmèneront captifs dans leur pays loin ou proche,"
,"37":"si dans le pays où on les a emmenés ils regrettent vraiment leur attitude, s'ils se convertissent et te supplient dans ce pays où ils sont captifs, s'ils te disent: Nous avons péché, nous avons fait ce qui est mal et nous avons commis un crime,"
,"38":"si dans le pays de leur captivité ils reviennent vers toi de tout leur coeur et de toute leur âme, s'ils te prient en se tournant vers le pays que tu as donné à leurs pères, vers la ville que tu as choisie et vers la Maison que j'ai bâtie en l'honneur de ton Nom,"
,"39":"écoute du haut des cieux où tu habites, leurs prières et leurs supplications, et fais-leur justice. Pardonne à ton peuple les péchés qu'il a commis contre toi."
,"40":"Maintenant, mon Dieu, que tes yeux soient ouverts et tes oreilles attentives à la prière qui se fait en ce lieu!"
,"41":"Lève-toi, Yahvé Dieu! viens avec l'Arche de ta puissance à ce lieu de repos! Que tes prêtres, Yahvé Dieu, soient revêtus de ton salut et que tes fidèles se réjouissent de bonheur!"
,"42":"Yahvé Dieu, ne repousse pas celui que tu as consacré et souviens-toi de ton amitié pour ton serviteur David.'"
}`)
	CurrentBook.AddChapter(7, `{
"1":"Lorsque Salomon eut terminé sa prière, le feu descendit du ciel et brûla l'holocauste et les sacrifices, tandis que la Gloire de Dieu remplissait la Maison."
,"2":"Les prêtres ne pouvaient plus entrer dans la Maison de Yahvé car la Gloire de Yahvé remplissait sa Maison."
,"3":"Quand ils virent le feu qui descendait et la Gloire de Yahvé qui reposait sur la Maison, tous les Israélites se mirent à genoux, le visage contre terre sur le pavé; ils adorèrent et célébrèrent Yahvé: 'Car il est bon, éternel est son amour!'"
,"4":"Le roi et tout le peuple offrirent des sacrifices devant Yahvé:"
,"5":"le roi Salomon offrit en sacrifices 22000 boeufs et 120000 moutons C'est ainsi que le roi et tout le peuple firent la dédicace de la Maison de Dieu."
,"6":"Les prêtres se tenaient à leur place, les lévites chantaient Yahvé avec les instruments de musique que le roi David avait faits pour célébrer Yahvé: 'Car éternel est son amour!' Ainsi, David chantait par leur bouche. En face d'eux les prêtres jouaient de la trompette et tout Israël se tenait debout."
,"7":"Salomon consacra l'intérieur de la cour qui se trouvait devant la Maison de Yahvé; c'est là qu'il offrit les holocaustes et la graisse des sacrifices de communion, car l'autel de bronze qu'il avait fait ne pouvait contenir l'holocauste, l'offrande et la graisse."
,"8":"En cette occasion Salomon célébra la fête pendant sept jours avec tout Israël: c'était une immense assemblée venue depuis l'Entrée-de-Hamat jusqu'au Torrent d'Egypte."
,"9":"On eut une assemblée solennelle le huitième jour: on avait en effet célébré la dédicace de l'autel par une fête qui dura sept jours."
,"10":"Le vingt-troisième jour du septième mois, Salomon renvoya le peuple à ses tentes. Tous étaient joyeux, le coeur en fête, pour tout le bien que Yahvé avait fait à David, à Salomon et à son peuple Israël."
,"11":"Salomon termina la Maison et le palais royal, il mena à bien tout ce qu'il avait décidé de faire dans la Maison de Yahvé et dans son palais."
,"12":"Durant la nuit, Yahvé apparut à Salomon: 'J'ai entendu ta prière, lui dit-il, et je me suis choisi ce lieu pour qu'elle soit une maison de sacrifices."
,"13":"Quand je fermerai le ciel, quand il n'y aura plus de pluie, quand j'ordonnerai à la sauterelle de dévorer le pays, que j'enverrai sur mon peuple la peste,"
,"14":"si mon peuple sur qui est invoqué mon Nom s'humilie, s'il prie, s'il recherche mon visage et se détourne de ses mauvais chemins, moi, j'écouterai du haut des cieux, je pardonnerai son péché et je guérirai son pays."
,"15":"Désormais mes yeux seront ouverts et mes oreilles attentives à la prière que l'on fait en ce lieu."
,"16":"Car j'ai choisi cette Maison, je l'ai consacrée pour que mon Nom y demeure pour toujours; mes yeux et mon coeur y seront pour toujours."
,"17":"Pour toi, si tu marches devant moi comme ton père David l'a fait, si tu agis selon tout ce que je t'ai ordonné, si tu observes mes commandements et mes ordonnances,"
,"18":"je maintiendrai ton trône royal comme je m'y suis engagé envers ton père David lorsque je lui ai dit: Tu ne manqueras jamais d'un descendant pour gouverner Israël."
,"19":"Mais si vous vous détournez, si vous abandonnez les ordonnances et les commandements que j'ai placés devant vous, si vous allez servir d'autres dieux et vous prosterner devant eux,"
,"20":"alors je vous arracherai de la terre que je vous ai donnée, je rejetterai loin de moi cette Maison que j'ai consacrée en l'honneur de mon Nom, j'en ferai une moquerie, et on en rira dans tous les peuples."
,"21":"Celui qui passera près de ce Temple, qui avait été élevé si haut, sera stupéfait; il demandera: Pourquoi Yahvé a-t-il traité ainsi ce pays et ce Temple?"
,"22":"Et l'on répondra: parce qu'ils ont abandonné Yahvé, le Dieu de leurs pères qui les avait fait sortir d'Egypte; ils se sont attachés à d'autres dieux, ils se sont prosternés devant eux et les ont servis: voilà pourquoi il a fait venir tout ce malheur sur eux!'"
}`)
	CurrentBook.AddChapter(8, `{
"1":"Salomon mit vingt ans à bâtir la Maison de Yahvé et son propre palais."
,"2":"Ensuite Salomon reconstruisit les villes que lui avait données Hiram et il y installa les Israélites."
,"3":"Il partit alors à Hamat-de-Soba et s'en empara."
,"4":"Il reconstruisit Tadmor dans le désert, et toutes les villes de dépôts qu'il avait bâties au pays de Hamat."
,"5":"Il reconstruisit Beth-Horon-le-Haut et Beth-Horon-le-Bas: c'étaient des villes fortifiées avec des remparts, des portes et des verrous."
,"6":"Il reconstruisit encore Baalat, toutes les villes de dépôts qui lui appartenaient, toutes les villes de chars et de cavalerie, et tout ce qu'il désirait reconstruire à Jérusalem, au Liban et dans tous les pays qui lui étaient soumis."
,"7":"Il restait encore des Hittites, des Amorites, des Périzites, des Hivvites et des Jébuséens, qui n'étaient pas Israélites;"
,"8":"leurs descendants étaient restés dans le pays après eux et les Israélites ne les avaient pas exterminés. Salomon en fit des hommes de corvée et cela dure encore aujourd'hui."
,"9":"Mais Salomon n'imposa pas de corvées aux Israélites: ils étaient soldats, officiers, commandants ou écuyers des chars, ou encore cavaliers."
,"10":"Deux cent cinquante chefs nommés par les préfets du roi Salomon commandaient le peuple."
,"11":"Salomon fit monter la fille du Pharaon de la Cité de David au palais qu'il lui avait construit. Il se disait en effet: 'Je ne peux pas garder une femme dans la maison de David, roi d'Israël: c'est un lieu saint dans lequel est entrée l'Arche de Yahvé.'"
,"12":"Salomon offrit alors des holocaustes sur l'autel de Yahvé qu'il avait construit devant le Vestibule."
,"13":"Jour après jour on offrait ce qui avait été ordonné par Moïse pour les sabbats, pour les nouvelles lunes, les fêtes, et lors des trois fêtes annuelles des Azymes, des Semaines et des Tentes."
,"14":"Conformément aux règlements de David son père, il établit les différentes classes de prêtres dans leur service, les lévites avec leurs fonctions pour louer et célébrer à côté des prêtres selon le rituel de chaque jour, ainsi que les classes de portiers pour les diverses portes: c'était l'ordre de David, l'homme de Dieu."
,"15":"On ne s'écarta sur aucun point, même pour les trésors, de l'ordre que le roi avait donné au sujet des prêtres et des lévites."
,"16":"Salomon mena à bien tout le travail qu'il avait entrepris depuis le jour de la fondation de la Maison de Yahvé jusqu'à ce qu'il eût achevé ce Temple de Yahvé."
,"17":"Salomon se rendit à Ezyon-Guéber et à Elat, au bord de la mer, dans le pays d'Edom."
,"18":"Hiram lui envoya par ses serviteurs des navires ainsi que des hommes qui connaissaient bien la mer. Ils allèrent avec les serviteurs de Salomon à Ofir. Ils en rapportèrent quatre cent cinquante talents d'or qu'ils remirent au roi Salomon."
}`)
	CurrentBook.AddChapter(9, `{
"1":"La reine de Saba avait entendu parler de Salomon et elle vint pour le mettre à l'épreuve par ses énigmes: elle arriva avec d'énormes richesses, des chameaux chargés de parfums, de l'or en grande quantité ainsi que des pierres précieuses. Arrivée près de Salomon, elle parla avec lui de tous ses doutes."
,"2":"Salomon éclaira toutes ses questions, aucune d'entre elles ne resta sans réponse pour Salomon."
,"3":"Lorsque la reine de Saba vit la sagesse de Salomon, le palais qu'il avait construit,"
,"4":"le menu de sa table, le logement de ses serviteurs, le service et les costumes de ses gens, les maîtres d'hôtel et leurs tenues et les holocaustes qu'il offrait dans la Maison de Yahvé, elle en eut le souffle coupé."
,"5":"Elle dit alors au roi: 'Ce que j'ai entendu dire dans mon pays sur tes paroles et ta sagesse était donc vrai!"
,"6":"Je n'en croyais pas les rumeurs avant d'être venue le voir de mes propres yeux; mais vraiment, on ne m'avait pas dit la moitié de ta grande sagesse! Tu surpasses tout ce qu'on m'avait dit de toi."
,"7":"Que tes femmes sont heureuses! Qu'ils sont heureux, ces serviteurs qui se tiennent constamment devant toi et entendent ta sagesse!"
,"8":"Béni soit Yahvé ton Dieu qui t'a montré sa faveur et qui t'a placé sur son trône comme roi ! Ton Dieu aime Israël et veut le garder pour toujours, c'est pourquoi il a fait de toi leur roi pour exercer le droit et la justice.'"
,"9":"Elle donna au roi cent vingt talents d'or, des parfums en très grande quantité ainsi que des pierres précieuses; jamais il n'y eut autant de parfums que ceux que la reine de Saba donna au roi Salomon."
,"10":"Les serviteurs de Hiram et ceux de Salomon qui avaient amené l'or d'Ofir, apportèrent aussi des bois exotiques et des pierres précieuses."
,"11":"Avec ces bois exotiques, le roi fit faire des planchers pour la Maison de Yahvé et pour le palais royal, des lyres et des harpes pour les musiciens; jamais encore on n'avait vu chose pareille dans le pays de Juda!"
,"12":"Le roi Salomon donna à la reine de Saba tout ce qu'elle désirait: beaucoup plus qu'elle n'avait apporté au roi. Elle s'en retourna alors et regagna son pays avec ses serviteurs."
,"13":"Chaque année Salomon recevait six cent soixante-six talents d'or,"
,"14":"sans compter ce qui venait des impôts des marchands et des profits des commerçants. Tous les rois d'Arabie et les gouverneurs du pays apportaient de l'or et de l'argent à Salomon."
,"15":"Le roi Salomon fit faire deux cents grands boucliers en or martelé, (on avait appliqué sur chacun d'eux six cents sicles d'or),"
,"16":"trois cents petits boucliers d'or martelé (on avait appliqué sur chacun d'eux trois cents sicles d'or): le roi les plaça dans la Maison-de-la-Forêt-du-Liban."
,"17":"Le roi fit exécuter un grand trône d'ivoire revêtu d'or pur."
,"18":"Ce trône avait six marches, un dossier arrondi derrière le trône et des bras de chaque côté du siège, deux lions à côté des bras,"
,"19":"et douze lions répartis de chaque côté des six marches. On n'avait jamais rien fait de semblable dans aucun royaume!"
,"20":"Tous les gobelets dans lesquels buvait le roi Salomon étaient en or et tous les meubles de la Maison-de-la-Forêt-du-Liban étaient plaqués d'or fin: au temps de Salomon, l'argent paraissait sans valeur."
,"21":"Car le roi avait des navires qui se rendaient à Tarsis avec les serviteurs d'Hiram, et tous les trois ans les navires revenaient de Tarsis chargés d'or, d'argent, de singes et de guenons."
,"22":"Le roi Salomon dépassa en richesse et en sagesse tous les rois de la terre;"
,"23":"tous les rois de la terre voulaient voir Salomon pour entendre la sagesse que Dieu lui avait donnée."
,"24":"Chacun apportait son cadeau: des objets en argent ou en or, des vêtements, des armes, des parfums, des chevaux et des mulets; il en était ainsi tous les ans."
,"25":"Salomon eut quatre mille stalles pour ses chevaux de chars et douze mille chevaux. Il les avait dans les villes de chars et à Jérusalem, aux côtés du roi."
,"26":"Il dominait sur tous les rois, depuis le Fleuve jusqu'au pays des Philistins et jusqu'à la frontière d'Egypte."
,"27":"Le roi fit si bien, que l'argent était à Jérusalem aussi ordinaire que les cailloux et que les cèdres étaient aussi nombreux que les sycomores du Bas-Pays."
,"28":"On importait pour le service de Salomon des chevaux de Mousour et de tous les pays."
,"29":"Le reste des actes de Salomon, depuis les premiers jusqu'aux derniers, cela n'est-il pas écrit dans l'histoire du prophète Nathan, dans les prophéties d'Ahiya de Silo et dans les visions de Yédo le voyant concernant Jéroboam fils de Nabat?"
,"30":"Salomon régna quarante ans sur tout Israël, à Jérusalem."
,"31":"Salomon se coucha avec ses pères et on l'enterra dans la Cité de David son père. Roboam, son fils, régna à sa place."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Roboam se rendit à Sichem, car c'est à Sichem que tout Israël était venu pour le faire roi."
,"2":"Lorsque Jéroboam fils de Nébat l'apprit, il rentra d'Egypte où il avait fui pour échapper au roi Salomon."
,"3":"On l'avait envoyé chercher, et Jéroboam arriva en même temps que tout Israël. Ils dirent ceci à Roboam:"
,"4":"'Ton père nous a imposé un joug pesant. Si tu allèges ces travaux forcés, ce joug pesant que ton père nous a fait porter, nous te servirons.'"
,"5":"Il leur répondit: 'Attendez trois jours, puis revenez me voir.' Et le peuple s'en alla."
,"6":"Le roi Roboam consulta les anciens qui avaient été les conseillers de son père Salomon quand il vivait. Il leur dit: 'Que me conseillez-vous de répondre à ce peuple?'"
,"7":"Ils lui répondirent: 'Si aujourd'hui tu te fais leur serviteur, si tu te montres conciliant dans ta réponse, ils seront pour toujours à ton service.'"
,"8":"Mais Roboam n'écouta pas le conseil que les anciens lui avaient donné et il se tourna vers les jeunes gens qui avaient grandi avec lui et qui se tenaient près de lui."
,"9":"Il leur demanda: 'Que me conseillez-vous de répondre à ce peuple? Vous savez qu'ils me disent: rends moins pénible le joug que ton père nous a fait porter.'"
,"10":"Les jeunes gens lui dirent: 'Tu dois répondre au peuple qui te dit: Ton père nous a fait porter un joug pesant, allège notre fardeau. Tu leur diras ceci: Mon petit doigt est plus gros que les reins de mon père."
,"11":"Mon père vous a fait porter un joug pesant? Avec moi ce sera pire. Mon père vous a corrigés avec des lanières de cuir? Avec moi, les fouets auront des pointes de fer.'"
,"12":"Jéroboam et tout le peuple revinrent le troisième jour auprès de Roboam, puisque le roi leur avait dit: Dans trois jours vous reviendrez."
,"13":"Le roi leur parla sèchement, il ne tint pas compte du conseil des anciens."
,"14":"Roboam suivit le conseil des jeunes gens et leur dit: 'Si mon père a rendu votre joug pesant, avec moi ce sera pire. Si mon père vous a corrigés avec des lanières de cuir, avec moi les fouets auront des pointes de fer.'"
,"15":"Le roi n'avait donc pas écouté le peuple: c'était une intervention de Dieu pour que Yahvé réalise la parole qu'il avait dite à Jéroboam fils de Nabat par la bouche d'Ahiya de Silo."
,"16":"Lorsque tout Israël vit que le roi ne l'écoutait pas, le peuple répliqua au roi: 'Quelle part avons-nous avec David? Nous n'avons rien à hériter du fils de Jessé. Allez Israël! A tes tentes! Et maintenant David, assure toi-même la nourriture de ta maison!' Et tout Israël regagna ses foyers."
,"17":"Cependant Roboam régna sur les Israélites qui habitaient les villes de Juda."
,"18":"Le roi Roboam envoya Adoram, le chef de la corvée, mais les Israélites le reçurent à coups de pierres et il mourut. Le roi Roboam fut obligé de monter sur son char pour s'enfuir à Jérusalem."
,"19":"Et depuis ce jour jusqu'à maintenant, Israël a renié la maison de David."
}`)
	CurrentBook.AddChapter(11, `{
"1":"En arrivant à Jérusalem, Roboam convoqua la maison de Juda et celle de Benjamin, soit 180000 excellents soldats, pour combattre Israël et le ramener sous l'autorité de Roboam."
,"2":"Mais la parole de Yahvé fut adressée à Chémaya, l'homme de Dieu, en ces termes:"
,"3":"'Voici ce que tu diras à Roboam, fils de Salomon, roi de Juda, et à tous les Israélites de Juda et de Benjamin:"
,"4":"Ainsi parle Yahvé: Ne partez pas combattre vos frères, que chacun retourne chez soi, car ce qui est arrivé vient de moi.' Ils tinrent compte des paroles de Yahvé et ils renoncèrent à se mettre en campagne contre Jéroboam."
,"5":"Roboam résida à Jérusalem et construisit des villes fortifiées en Juda."
,"6":"Il reconstruisit Bethléem, Tékoa,"
,"7":"Beth-Sour, Soko, Adoullam,"
,"8":"Gat, Marécha, Zif,"
,"9":"Adoraïm, Lakish, Azéka,"
,"10":"Soréa, Ayalon et Hébron: ce sont les villes fortifiées de Juda et de Benjamin."
,"11":"Il les fortifia solidement et y plaça des chefs et des réserves: des vivres, de l'huile et du vin."
,"12":"Dans chacune de ces villes il y avait des boucliers et des lances; il en fit des villes fortes et il affermit son pouvoir sur Juda et Benjamin."
,"13":"Les prêtres et les lévites qui se trouvaient dans tout Israël vinrent, chacun de leur pays, se présenter à lui:"
,"14":"ils avaient abandonné leurs pâturages et leurs propriétés pour venir en Juda et à Jérusalem, car Jéroboam et ses fils les avaient rejetés du sacerdoce de Yahvé."
,"15":"Jéroboam avait établi en effet ses propres prêtres dans les Hauts-Lieux, pour servir les boucs et les veaux qu'il y avait faits."
,"16":"Avec les lévites arrivèrent à Jérusalem des hommes de toutes les tribus d'Israël qui s'appliquaient de tout leur coeur à chercher Yahvé, Dieu d'Israël; ils venaient offrir leurs sacrifices à Yahvé, le Dieu de leurs pères."
,"17":"Ils renforcèrent le royaume de Juda et pendant trois ans ils apportèrent leur soutien à Roboam, fils de Salomon, car pendant trois ans on suivit les traces de David et de Salomon."
,"18":"Roboam épousa Mahalat, fille de Yérimot, fils de David et d'Abigaïl, fils d'Eliab, fils de Jessé."
,"19":"Elle lui donna des fils: Yéouch, Chémarya et Zaham."
,"20":"Après elle il épousa Maaka fille d'Absalom; elle lui donna Abiya, Attaï, Ziza et Chélomit."
,"21":"Roboam aima Maaka, fille d'Absalom, plus que toutes ses autres femmes ou concubines; il eut en effet dix-huit femmes et soixante concubines et il en eut vingt-huit fils et soixante filles."
,"22":"C'est pourquoi Roboam donna le premier rang à Abiya fils de Maaka; il en fit le chef de ses frères afin qu'il devienne roi."
,"23":"Roboam eut l'intelligence de disperser ses fils dans tout le pays de Juda et de Benjamin, dans toutes les villes fortifiées, et il leur assura une nourriture abondante et des épouses."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Mais une fois devenu fort, avec le pouvoir bien en mains, Roboam abandonna la Loi de Yahvé et tout Israël le suivit."
,"2":"Comme on avait été infidèle à Yahvé, Chéchonk, roi d'Egypte, monta contre Jérusalem en la cinquième année du règne de Roboam."
,"3":"Il avait avec lui douze cents chars et soixante mille cavaliers, et c'était une foule innombrable qui était venue d'Egypte avec lui: des Libyens, des Soukiens et des Kouchites."
,"4":"Il s'empara des villes fortifiées de Juda et arriva à Jérusalem."
,"5":"Le prophète Chémaya vint alors trouver Roboam et les chefs de Juda qui s'étaient repliés à Jérusalem devant Chéchonk. Il leur dit: 'Voici ce que dit Yahvé: Vous m'avez abandonné? Eh bien moi aussi je vous abandonnerai aux mains de Chéchonk.'"
,"6":"Les chefs d'Israël et le roi s'humilièrent: 'Yahvé est juste, dirent-ils.'"
,"7":"Lorsque Yahvé vit qu'ils s'humiliaient, la parole de Yahvé fut adressée ainsi à Chémaya: 'Puisqu'ils se sont humiliés, je ne les détruirai pas. Je les délivrerai dans peu de temps et ma fureur ne se répandra pas sur Jérusalem par la main de Chéchonk."
,"8":"Cependant ils deviendront ses serviteurs et ils verront la différence entre me servir et servir les puissances étrangères.'"
,"9":"Chéchonk roi d'Egypte mit la main sur Jérusalem et il ramassa les trésors du Temple de Yahvé et ceux du palais royal: il prit tout. Comme il avait pris les boucliers d'or qu'avait faits Salomon,"
,"10":"le roi Roboam fit faire à leur place des boucliers de bronze qu'on remit aux chefs des gardes du palais royal."
,"11":"Chaque fois que le roi se rendait à la Maison de Yahvé, les gardes venaient les prendre, puis ils les reportaient à la salle des gardes."
,"12":"Comme Israël s'était humilié, la colère de Yahvé se détourna de lui et ne le détruisit pas complètement: il y avait encore du bon en Juda."
,"13":"Le roi Roboam renforça son autorité à Jérusalem où il fut vraiment roi; il avait quarante et un ans quand il monta sur le trône et il régna dix sept ans à Jérusalem, la ville que Yahvé avait choisie parmi toutes les tribus d'Israël pour y faire habiter son Nom. Sa mère était Naama l'Ammonite."
,"14":"Il fit le mal et ne s'appliqua pas à rechercher Yahvé de tout son coeur."
,"15":"Les actes de Roboam, depuis les premiers jusqu'aux derniers, cela n'est-il pas écrit dans les actes du prophète Chémaya et du voyant Iddo? Il y eut une guerre continuelle entre Roboam et Jéroboam."
,"16":"Roboam se coucha avec ses pères et on l'enterra dans la Cité de David. Son fils Abiya régna à sa place."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Abiya commença à régner sur Juda en la dix-huitième année du roi Jéroboam;"
,"2":"il régna trois ans à Jérusalem. Sa mère était Mikayas, fille d'Ouriel de Gibéa. Il y eut une guerre entre Abiya et Jéroboam."
,"3":"Abiya engagea la bataille avec une armée de soldats entraînés (400000 excellents soldats) et Jéroboam se rangea face à lui avec 800000 excellents soldats, tous soldats entraînés."
,"4":"Abiya alla se poster sur le mont Sémarayim, dans la montagne d'Ephraïm; de là il cria: 'Jéroboam et vous tous, gens d'Israël, écoutez-moi!"
,"5":"Ne savez-vous pas que Yahvé, Dieu d'Israël, a donné pour toujours la royauté sur Israël à David et à ses fils, grâce à une alliance qui ne peut être rompue?"
,"6":"Mais Jéroboam fils de Nabat, serviteur de Salomon fils de David, s'est révolté contre son seigneur."
,"7":"Des hommes de rien composaient alors l'entourage de Roboam fils de Salomon, ils lui ont imposé leur loi. Roboam était jeune et timide alors, et il n'a pas su leur tenir tête."
,"8":"Et c'est vous maintenant qui voulez tenir tête à la royauté de Yahvé, quand elle est entre les mains des descendants de David puisque vous êtes venus une foule immense. Et vous avez amené les veaux d'or que Jéroboam vous a donnés comme dieux."
,"9":"N'avez-vous pas chassé les prêtres de Yahvé, les fils d'Aaron, et les lévites, pour vous donner des prêtres comme le font les peuples étrangers? Quiconque arrive avec un taureau et sept béliers pour se faire donner la consécration, peut devenir prêtre d'idoles qui ne sont pas Dieu!"
,"10":"Notre Dieu à nous, c'est Yahvé, et nous ne l'avons pas abandonné; les fils d'Aaron sont prêtres au service de Yahvé et les lévites les assistent."
,"11":"Chaque matin et chaque soir on fait fumer pour Yahvé les holocaustes et l'encens parfumé. Nous avons les pains rangés sur la table sainte, le chandelier d'or avec ses lampes qu'on allume chaque soir. Nous observons l'ordonnance de Yahvé notre Dieu que vous, vous avez abandonnée!"
,"12":"Nous avons Dieu à notre tête, avec ses prêtres et les trompettes pour l'appeler, et elles vont sonner contre vous, fils d'Israël! Ne combattez pas contre Yahvé, le Dieu de vos pères; vous ne réussirez pas!'"
,"13":"Jéroboam fit faire un mouvement tournant aux hommes qu'il avait placés en embuscade et ils arrivèrent sur les arrières de Juda: l'armée était devant et l'embuscade, derrière."
,"14":"En se retournant, les Judéens virent qu'ils avaient à combattre devant et derrière eux; ils crièrent vers Yahvé, les prêtres sonnèrent de la trompette,"
,"15":"et les hommes de Juda poussèrent le cri de guerre. Pendant qu'ils poussaient ainsi ce cri, Dieu frappa Jéroboam et tout Israël devant Abiya et Juda."
,"16":"Les Israélites prirent la fuite devant Juda et Yahvé les livra entre leurs mains."
,"17":"Abiya et son peuple leur infligèrent une grande défaite; cinq cent mille excellents soldats d'Israël tombèrent blessés à mort."
,"18":"En cette occasion les Israélites furent abaissés tandis que les fils de Juda sortaient raffermis, car ils s'étaient appuyés sur Yahvé, le Dieu de leurs pères."
,"19":"Abiya poursuivit Jéroboam et lui prit des villes: Béthel et ses dépendances, Yéchana et ses dépendances, Efron et ses dépendances."
,"20":"Jéroboam ne retrouva pas sa puissance durant les jours d'Abiya, puis Yahvé le frappa et il mourut."
,"21":"Abiya au contraire se raffermit; il eut quatorze femmes qui lui donnèrent vingt-deux fils et seize filles."
,"22":"Le reste des actes d'Abiya, tous ses faits et gestes, cela est écrit dans le récit du prophète Iddo."
,"23":"Abiya se coucha avec ses pères et on l'enterra dans la Cité de David; son fils Aza régna à sa place et le pays fut alors tranquille pendant dix ans."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Aza fit ce qui est juste et droit au regard de Yahvé son Dieu."
,"2":"Il supprima les autels étrangers ainsi que les Hauts-Lieux, il brisa les pierres dressées et coupa les pieux sacrés."
,"3":"Il ordonna aux Judéens de rechercher Yahvé, le Dieu de leurs pères, et de pratiquer la Loi et le Commandement."
,"4":"Dans toutes les villes de Juda il supprima les Hauts-Lieux et les autels à encens. Le royaume fut en paix sous son autorité."
,"5":"Il reconstruisit les villes fortifiées de Juda, car le pays était en paix et en ces années-là personne ne lui fit la guerre: Yahvé lui donna un temps de repos."
,"6":"Il dit donc à Juda: 'Construisons ces villes, entourons-les de remparts, de tours, de portes et de verrous pendant que nous sommes maîtres du pays. Nous avons recherché Yahvé notre Dieu, lui aussi nous a recherchés et nous a procuré la paix de tous côtés.' Ils menèrent à bien leurs constructions."
,"7":"L'armée d'Aza comptait trois cent mille hommes de Juda portant le grand bouclier et la lance, et deux cent quatre-vingt mille hommes de Benjamin portant le bouclier rond et sachant tirer à l'arc: tous étaient des guerriers entraînés."
,"8":"Zérah le Kouchite vint les attaquer avec une armée de mille milliers d'hommes et de trois cents chars: ils arrivèrent à Marécha."
,"9":"Aza sortit à sa rencontre, on se rangea en bataille dans la vallée de Séfata, près de Marécha."
,"10":"Aza pria alors Yahvé, son Dieu: 'Yahvé, dit-il, lorsque tu veux secourir, il n'y a pas de différence pour toi entre le puissant et le faible. Secours-nous, Yahvé, notre Dieu! C'est sur toi que nous comptons et c'est en ton Nom que nous marchons contre cette foule. Yahvé, tu es notre Dieu, qu'un homme ne l'emporte pas sur toi!'"
,"11":"Yahvé battit les Kouchites devant Aza et devant Juda, et les Kouchites prirent la fuite."
,"12":"Aza et son armée les poursuivirent jusqu'à Gérar ; il tomba tellement de Kouchites qu'il n'en resta rien: Yahvé et son armée les avaient brisés. On emporta un énorme butin."
,"13":"On frappa toutes les villes autour de Gérar, car la frayeur de Yahvé pesait sur elles, et l'on pilla toutes ces villes où l'on trouva un butin considérable."
,"14":"On s'en prit même aux tentes des nomades et l'on emporta quantité de petit bétail et de chameaux, puis on rentra à Jérusalem."
}`)
	CurrentBook.AddChapter(15, `{
"1":"L'Esprit de Dieu s'empara d'Azaryas, fils d'Oded."
,"2":"Il sortit au-devant d'Aza et lui dit: 'Aza et vous tous, gens de Juda et de Benjamin, écoutez-moi! Yahvé est avec vous quand vous êtes avec lui. Si vous le recherchez, il se laissera trouver par vous, mais si vous l'abandonnez, il vous abandonnera."
,"3":"Pendant de longs jours Israël n'avait ni Dieu véritable, ni prêtre pour enseigner, ni Loi."
,"4":"Mais dans sa misère il est revenu vers Yahvé, Dieu d'Israël: ils l'ont cherché et il s'est laissé trouver par eux."
,"5":"En ce temps-là il n'y avait pas de sécurité pour voyager, car tous les habitants du pays vivaient sous la menace de la violence."
,"6":"On se battait nation contre nation, ville contre ville, et Dieu les frappait de toutes sortes de malheurs."
,"7":"Mais vous, tenez bon! Que vos mains ne faiblissent pas, votre peine aura sa récompense.'"
,"8":"En entendant ces paroles et cette prophétie, Aza se décida à enlever les idoles de tout le pays de Juda et de Benjamin, et dans les villes qu'il avait prises dans la montagne d'Ephraïm. Il restaura l'autel de Yahvé qui se trouvait devant le Vestibule de Yahvé."
,"9":"Puis il rassembla tout Juda et Benjamin, et les gens d'Ephraïm, de Manassé et de Siméon qui habitaient au milieu d'eux, car des Israélites étaient passés en grand nombre de son côté quand ils avaient vu que Yahvé, son Dieu, était avec lui."
,"10":"Le troisième mois de la quinzième année du règne d'Aza, ils se rassemblèrent à Jérusalem"
,"11":"et ils offrirent des sacrifices à Yahvé ce jour-là sept cent boeufs et sept mille moutons pris sur le butin qu'ils avaient ramené."
,"12":"Ils s'engagèrent par une alliance à rechercher Yahvé, le Dieu de leurs pères, de tout leur coeur et de toute leur âme."
,"13":"Si quelqu'un, petit ou grand, homme ou femme, ne recherchait pas Yahvé Dieu d'Israël, il serait mis à mort."
,"14":"Ils prêtèrent serment à Yahvé à haute voix et avec des acclamations, au son des trompettes et des cors."
,"15":"Tous les Judéens se réjouirent de ce serment, car ils l'avaient prêté de tout leur coeur et ils cherchaient Dieu sincèrement, c'est pourquoi Yahvé se laissa trouver par eux et leur accorda la paix de tous côtés."
,"16":"Le roi Aza retira même la dignité de Grande Dame à sa grand-mère Maaka parce qu'elle avait fait une idole en l'honneur d'Achéra; Aza brisa cette idole, la réduisit en poudre et la brûla dans la vallée du Cédron."
,"17":"Les Hauts-Lieux ne disparurent pas d'Israël; mais durant toute sa vie Aza s'attacha à Yahvé de tout son coeur."
,"18":"Il fit porter dans la Maison de Dieu l'argent, l'or et le mobilier que son père et lui-même avaient consacrés."
,"19":"Il n'y eut pas de guerre jusqu'à la trente-cinquième année du règne d'Aza."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Bacha, roi d'Israël, marcha contre Juda en la trente-sixième année du règne d'Aza, et il fortifia Rama pour couper la route à Aza roi de Juda."
,"2":"Aza prit alors de l'argent et de l'or dans les trésors de la Maison de Yahvé et du palais royal et il l'envoya à Ben-Hadad, roi d'Aram, qui résidait à Damas, avec ce message:"
,"3":"'Qu'il y ait alliance entre moi et toi, entre mon père et ton père. Regarde ce que je t'envoie d'argent et d'or! Casse ton alliance avec Bacha, roi d'Israël, pour qu'il s'en aille de chez moi.'"
,"4":"Ben-Hadad écouta le roi Aza: il envoya ses chefs de guerre contre les villes d'Israël. Ils frappèrent Iyon, Dan, Abel-Mayim et tous les entrepôts des villes de Nephtali."
,"5":"Quand il apprit cela, Bacha arrêta les fortifications de Rama et ses travaux."
,"6":"Le roi Aza fit alors appel à tous les Judéens et l'on emporta les pierres et le bois avec lesquels Bacha fortifiait Rama; on les prit pour fortifier Géba et Mispa."
,"7":"A ce moment-là, le voyant Hanani vint trouver Aza, roi de Juda. Il lui dit: 'Tu t'es appuyé sur le roi d'Aram au lieu de t'appuyer sur Yahvé ton Dieu, à cause de cela tu ne pourras plus soumettre l'armée du roi d'Aram."
,"8":"Les Kouchites et les Libyens ne formaient-ils pas une grande armée avec des chars et des chevaux innombrables? Mais Yahvé les a livrés entre tes mains parce que tu t'étais appuyé sur lui."
,"9":"Oui, les yeux de Yahvé observent toute la terre, il est la force de ceux qui s'attachent à lui de tout leur coeur. Mais toi, tu t'es conduit comme un insensé en tout cela: désormais, tu auras la guerre.'"
,"10":"Aza se mit en colère contre le voyant et le fit mettre en prison, enchaîné: il était furieux contre lui à cause de cette parole. Durant ce même temps, Aza maltraita une partie du peuple."
,"11":"Les actes d'Aza, des premiers aux derniers, sont écrits dans les livres des rois de Juda et d'Israël."
,"12":"En la trente-neuvième année de son règne, Aza eut les pieds malades et la maladie s'aggrava. Etant déjà bien malade, il ne consulta pas Yahvé mais les médecins."
,"13":"Puis Aza se coucha avec ses pères, il mourut dans la quarante et unième année de son règne."
,"14":"On l'enterra dans le tombeau qu'il s'était fait creuser dans la Cité de David. On le coucha sur un lit tout recouvert d'aromates et de parfums préparés à la manière des parfumeurs, et l'on fit en son honneur un feu magnifique."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Son fils Josafat régna à sa place et renforça son pouvoir contre Israël."
,"2":"Il plaça des troupes dans toutes les villes fortifiées de Juda, et il établit des préfets dans le pays de Juda et dans les villes d'Ephraïm que son père Aza avait prises."
,"3":"Yahvé fut avec Josafat, car il suivait le chemin que son père avait suivi au début, et il ne rechercha pas les Baals."
,"4":"Au contraire, il rechercha le Dieu de son père et il suivit ses commandements au lieu d'imiter la conduite d'Israël."
,"5":"C'est pourquoi Yahvé affermit la royauté entre ses mains: tous les Judéens payaient un tribut à Josafat et c'est ainsi qu'il eut richesses et honneurs en abondance."
,"6":"Il suivit avec enthousiasme les voies de Yahvé et de nouveau il fit disparaître de Juda les Hauts-Lieux et les pieux sacrés."
,"7":"La troisième année de son règne, il envoya ses chefs: Ben-Hayil, Obadya, Zékarya, Nétanéel, Mikayas, pour instruire les cités de Juda."
,"8":"Les lévites Chémayas, Nétanyas, Zébadyas, Azahel, Chémiramot, Yonatan, Adoniyas, Tobiyas et les prêtres Elichama et Yoram, les accompagnaient."
,"9":"Emmenant avec eux le livre de la Loi de Yahvé pour enseigner Juda, ils firent le tour de toutes les villes de Juda en enseignant le peuple."
,"10":"Une terreur venue de Yahvé s'empara alors de tous les royaumes situés sur les frontières de Juda, ils ne furent pas en guerre avec Josafat."
,"11":"Des Philistins apportèrent à Josafat des cadeaux et de l'argent en tribut; même les Arabes lui amenèrent du petit bétail: (7700 béliers et 7700 boucs)."
,"12":"La gloire de Josafat ne cessait de grandir. Il construisit des forteresses et des villes de dépôts en Juda."
,"13":"Il y avait d'importantes réserves dans les villes de Juda, et à Jérusalem des hommes de guerre entraînés."
,"14":"En voici le recensement par famille: Pour Juda: chef de mille: Adna, général, et avec lui 300000 guerriers entraînés;"
,"15":"sous ses ordres Yohanan, général, avec 280000 hommes;"
,"16":"et Amasias fils de Zikri, engagé volontairement au service de Yahvé avec 200000 guerriers entraînés."
,"17":"Pour Benjamin: le courageux Elyada avec 200000 hommes armés de l'arc et du bouclier rond;"
,"18":"sous ses ordres: Yozabad avec 180000 hommes équipés pour la guerre."
,"19":"C'étaient eux les officiers du roi, sans compter ceux que le roi avait placés dans les villes fortifiées de tout Juda."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Lorsque Josafat eut richesses et gloire en abondance il s'allia par mariage à la famille d'Akab."
,"2":"Au bout de quelques années, il rendit visite à Akab à Samarie. Akab offrit en son honneur et pour les gens qui l'accompagnaient quantité de boeufs et de moutons, et il le poussa à attaquer Ramot-de-Galaad."
,"3":"Akab, roi d'Israël, dit en effet à Josafat, roi de Juda: 'Viendras-tu avec moi à Ramot-de-Galaad?' Il lui répondit: 'Je ferai comme toi et mon peuple fera comme ton peuple. Nous serons à tes côtés dans la bataille.'"
,"4":"Josafat dit au roi d'Israël: 'Consulte d'abord, s'il te plaît, la parole de Yahvé.'"
,"5":"Le roi d'Israël rassembla ses prophètes, au nombre de quatre cents, et leur dit: 'Devons-nous partir attaquer Ramot-de-Galaad ou faut-il y renoncer?' Ils répondirent: 'Pars, Dieu la livrera entre les mains du roi.'"
,"6":"Josafat ajouta: 'N'y-a-t-il pas quelque autre prophète de Yahvé par qui nous puissions le consulter?'"
,"7":"Le roi d'Israël répondit à Josafat: 'Il y a encore un homme par qui l'on pourrait consulter Yahvé, mais je le déteste: il ne me prophétise jamais le bien, mais toujours le mal: c'est Michée, fils de Yimla.' Josafat lui dit: 'Que le roi ne parle pas ainsi!'"
,"8":"Le roi d'Israël appela donc un serviteur et lui dit: 'Va-t'en vite chercher Michée fils de Yimla!'"
,"9":"Le roi d'Israël et Josafat roi de Juda étaient assis chacun sur un trône, habillés de cérémonie: ils étaient assis sur la place qui est à l'entrée de la porte de Samarie et tous les prophètes entraient en transes devant eux."
,"10":"Sédécias fils de Kénaana s'était fait des cornes de fer et il disait: 'Voici ce que dit Yahvé: Voilà comment tu embrocheras les Araméens jusqu'au dernier.'"
,"11":"Tous les prophètes prophétisaient de même: 'Pars à Ramot-de-Galaad, disaient-ils, tu seras vainqueur: Yahvé la livrera entre les mains du roi.'"
,"12":"Le serviteur qui était allé chercher Michée lui dit: 'Ecoute, les prophètes sont unanimes pour annoncer la victoire au roi. Toi aussi, parle comme eux et prédis la victoire.'"
,"13":"Mais Michée répondit: 'Par la vie de Yahvé, je ne dirai que ce que dira mon Dieu.'"
,"14":"Quand il arriva près du roi, le roi lui dit: 'Michée, devons-nous partir attaquer Ramot-de-Galaad ou faut-il y renoncer?' Michée répondit: 'Montez, ce sera un succès! Ils seront livrés entre vos mains.'"
,"15":"Mais le roi lui dit: 'Combien de fois me faudra-t-il te l'ordonner: ne me dis que la vérité au Nom de Yahvé!'"
,"16":"Michée s'écria: 'J'ai vu tout Israël dispersé sur les montagnes, comme des brebis qui n'ont plus de berger, et Yahvé disait: Ces hommes n'ont plus de maître, que chacun retourne en paix chez soi!'"
,"17":"Le roi d'Israël dit alors à Josafat: 'Ne te l'avais-je pas dit? Il ne me prophétise jamais le bien, mais seulement le mal.'"
,"18":"Michée dit encore: 'Ecoutez donc la parole de Yahvé! J'ai vu Yahvé assis sur son trône et toute la cour des cieux se tenait à sa droite et à sa gauche."
,"19":"Yahvé a demandé: qui trompera Akab, roi d'Israël, pour qu'il parte et tombe à Ramot-de Galaad? L'un a répondu d'une façon, l'autre d'une autre."
,"20":"Alors l'Esprit s'est avancé et s'est tenu devant Yahvé: Moi, a-t-il, je le tromperai. Yahvé lui a demandé: Comment feras-tu?"
,"21":"J'irai, a-t-il dit répondu, et je me ferai esprit de mensonge dans la bouche de tous ses prophètes. Yahvé lui a dit alors: Oui, tu réussiras à le tromper; va et fais ainsi."
,"22":"Sache que Yahvé a mis un esprit de mensonge dans la bouche de tes prophètes parce que lui, Yahvé, a décrété contre toi le malheur.'"
,"23":"Alors Sédécias, fils de Kénaana, s'avança et gifla Michée: 'Par quel chemin l'esprit de Yahvé est-il sorti de moi pour te parler?'"
,"24":"Michée répondit: 'Tu le sauras le jour où tu iras de refuge en refuge pour te cacher.'"
,"25":"Le roi d'Israël ordonna: 'Prenez Michée et remettez-le à Amon, gouverneur de la ville, et à Yoas, fils du roi."
,"26":"Vous leur transmettrez cet ordre du roi: Mettez cet homme en prison, vous ne lui donnerez qu'une maigre ration de pain et d'eau jusqu'à ce que je revienne sain et sauf.'"
,"27":"Michée lui dit: 'Si vraiment tu reviens sain et sauf, c'est que Yahvé n'a pas parlé par moi.'"
,"28":"Le roi d'Israël et Josafat roi de Juda, partirent pour Ramot-de-Galaad;"
,"29":"Le roi d'Israël dit à Josafat: 'Je vais me déguiser pour aller à la bataille, mais toi, porte ton uniforme.' Le roi d'Israël se déguisa donc pour aller à la bataille."
,"30":"Le roi d'Aram avait donné cet ordre à ses chefs de chars: 'N'attaquez ni petit ni grand, mais seulement le roi d'Israël.'"
,"31":"Lorsque les chefs de chars aperçurent Josafat, ils se dirent: 'C'est le roi d'Israël!' Et ils l'encerclèrent pour l'attaquer, mais Josafat poussa un cri; Yahvé lui porta secours et Dieu les entraîna loin de lui."
,"32":"Lorsque les chefs de chars virent que ce n'était pas le roi d'Israël, ils arrêtèrent de le poursuivre."
,"33":"Mais un homme tira à l'arc sans savoir sur qui, et il atteignit le roi d'Israël entre les attaches et la cuirasse. Le roi dit alors à son conducteur de char: 'Fais demi-tour et fais-moi sortir de la mêlée, car je me sens mal.'"
,"34":"Le combat devenait de plus en plus violent ce jour-là. Le roi d'Israël resta debout sur son char jusqu'au soir, face aux Araméens, mais au coucher du soleil il mourut."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Josafat roi de Juda rentra chez lui sain et sauf, à Jérusalem."
,"2":"Jéhu fils de Hanani, le voyant, sortit alors à sa rencontre et dit au roi Josafat: 'Fallait-il porter secours aux méchants? Aimerais-tu par hasard ceux qui détestent Yahvé? Tu as sûrement attiré ainsi sa colère."
,"3":"Néanmoins il y a ceci de bon chez toi: tu as supprimé les pieux sacrés du pays et tu t'es appliqué à rechercher Dieu de tout ton coeur.'"
,"4":"Après un séjour à Jérusalem, Josafat repartit visiter son peuple depuis Bersabée jusqu'à la montagne d'Ephraïm, pour le ramener à Yahvé le Dieu de ses pères."
,"5":"Il établit des juges dans le pays, dans chacune des villes fortifiées de Juda."
,"6":"Il dit aux juges: 'Faites attention à ce que vous faites! Vous ne rendez pas justice pour des hommes, mais pour Yahvé: il est avec vous quand vous prononcez la sentence."
,"7":"Ayez donc la crainte de Yahvé, faites bien attention à ce que vous faites, car en Yahvé notre Dieu il n'y a ni injustice ni partialité, il n'accepte pas les pots-de-vin.'"
,"8":"Josafat établit aussi à Jérusalem des lévites, des prêtres et des chefs de familles d'Israël pour ce qui concernait les droits de Yahvé et pour juger les procès des habitants de Jérusalem."
,"9":"Il leur donna les ordres suivants: 'Voici comment vous agirez: dans la crainte de Yahvé, avec sincérité et droiture."
,"10":"Vous instruirez vos frères qui habitent dans les villes à l'occasion de tous les procès qu'ils porteront devant vous, qu'il s'agisse de crimes de sang ou de la Loi, que ce soit pour les commandements, les ordonnances ou les règles. Ainsi ils se garderont d'être coupables envers Yahvé; autrement il s'emporterait contre vous ou contre vos frères. Si vous faites ainsi vous ne serez pas coupables."
,"11":"Amaryas, le chef des prêtres, aura autorité sur vous pour toute affaire qui regarde Yahvé, et Zébadyas, fils d'Ismaël, chef de la maison de Juda, pour toutes les affaires qui regardent le roi. Les lévites vous serviront de scribes. Soyez courageux, travaillez! Yahvé sera avec les hommes droits!'"
}`)
	CurrentBook.AddChapter(20, `{
"1":"Après cela, les Moabites, les Ammonites firent une expédition contre Josaphat, des Méounites les accompagnaient."
,"2":"On vint avertir Josaphat: 'Des ennemis arrivent, c'est une vraie multitude venue d'Edom, au-delà de la mer. Elle est à Assasson-Tamar c'est-à-dire En-Gadi.'"
,"3":"Josaphat, effrayé, consulta Yahvé et proclama un jeûne pour tout Juda."
,"4":"Les Judéens se rassemblèrent pour supplier Yahvé: même des villes de Juda on venait pour chercher Yahvé."
,"5":"Josaphat vint parler à l'assemblée de Juda à Jérusalem, dans la Maison de Yahvé, devant la nouvelle cour."
,"6":"Il dit: 'Yahvé, Dieu de mon père, n'est-ce pas toi qui es Dieu dans les cieux et qui as pouvoir sur tous les royaumes des païens? La force et la puissance sont dans ta main, et personne ne peut te résister."
,"7":"N'est-ce pas toi, notre Dieu, qui as dépossédé les habitants de ce pays devant ton peuple Israël? Et tu l'as donné à la race d'Abraham, ton ami, pour toujours!"
,"8":"Ils s'y sont installés et y ont construit un sanctuaire en l'honneur de ton Nom; ils ont dit:"
,"9":"Si un malheur quelconque vient sur nous: guerre, fléau, peste ou famine, nous nous tiendrons devant ce Temple et devant toi, car ton Nom habite cette maison. Dans notre malheur, nous crierons vers toi, tu nous entendras et tu nous sauveras."
,"10":"Maintenant, regarde ces Ammonites, ces Moabites et ces gens de la montagne de Séïr. Lorsque Israël montait du pays d'Egypte, tu n'as pas laissé Israël entrer chez eux, mais au contraire il est passé à l'écart sans les détruire."
,"11":"Or aujourd'hui ils nous récompensent en venant nous chasser de l'héritage que tu nous as donné!"
,"12":"Ne nous feras-tu pas justice, ô notre Dieu? Nous sommes sans force devant cette armée immense qui s'avance contre nous, nous ne savons plus que faire: nos yeux se tournent vers toi.'"
,"13":"Tous les Judéens se tenaient debout devant Yahvé, même leurs enfants, leurs femmes et leurs fils étaient là."
,"14":"Alors, en pleine assemblée, l'esprit de Yahvé s'empara de Yahaziel, fils de Zékaryas, fils de Bénayas, fils de Yéhiel, fils de Mattania le lévite, l'un des fils d'Azaf."
,"15":"Il s'écria: 'Ecoutez bien vous tous, Judéens, habitants de Jérusalem, et toi aussi, roi Josaphat! Voici ce que dit Yahvé: n'ayez pas peur, ne tremblez pas devant cette foule immense, car ce combat ne sera pas le vôtre mais celui de Dieu."
,"16":"Demain, tombez sur eux, car voici qu'ils montent par la montée de Sis: vous les rencontrerez au bout de la vallée, en face du désert de Yérouel."
,"17":"Vous n'aurez pas à combattre, soyez là sur vos positions et vous verrez comment Yahvé vous délivrera. Juda et Jérusalem, n'ayez pas peur, ne tremblez pas, demain, marchez au-devant d'eux et Yahvé sera avec vous.'"
,"18":"Josaphat se prosterna le visage contre terre, tous les Judéens et les habitants de Jérusalem se prosternèrent devant Yahvé pour l'adorer."
,"19":"Les lévites, les fils des Kahatites, et des Koréites, se levèrent pour louer Yahvé le Dieu d'Israël à pleine voix."
,"20":"De grand matin, ils se mirent en route pour le désert de Tékoa. Au moment du départ, Josaphat debout, leur cria: 'Ecoutez-moi Judéens et habitants de Jérusalem, mettez votre foi en Yahvé votre Dieu et vous vivrez, croyez en ses prophètes et vous gagnerez.'"
,"21":"Après avoir délibéré avec le peuple, il plaça les chantres de Yahvé et ceux qui célèbrent la splendeur de son Temple, en tête de la troupe. Ils disaient: 'Chantez Yahvé car éternel est son amour!'"
,"22":"Au moment où l'on commençait à pousser des cris de joie et de louange, Yahvé fit un mauvais coup aux Ammonites, aux Moabites et aux gens de la montagne de Séïr qui étaient venus contre Juda: il provoqua un désastre."
,"23":"Les Ammonites et les Moabites se lancèrent contre les gens de la montagne de Séïr qui furent voués à l'anathème et exterminés, puis ils se retournèrent les uns contre les autres pour s'entretuer."
,"24":"Arrivés à l'endroit où l'on découvre le désert, les Judéens purent voir toute cette multitude: il n'y avait que cadavres gisant à terre, pas un rescapé!"
,"25":"Josaphat arriva avec son peuple pour enlever leurs dépouilles; ils trouvèrent beaucoup de bétail, des provisions, des habits et des objets précieux. Ils en ramassèrent plus qu'ils ne pouvaient en porter: le pillage du butin dura trois jours, tellement il y en avait."
,"26":"Le quatrième jour ils se rassemblèrent dans la vallée de Béraka: cette vallée a reçu ce nom qu'elle a porté jusqu'à ce jour, car c'est là qu'ils bénirent Yahvé."
,"27":"Tous les hommes de Juda et de Jérusalem, Josaphat en tête, se mirent en route pour retourner à Jérusalem, tout joyeux car Yahvé les avait comblés de joie aux dépens de leurs ennemis."
,"28":"Au son des harpes, des lyres et des trompettes, ils entrèrent dans Jérusalem pour se rendre à la Maison de Yahvé."
,"29":"Quand les nations païennes apprirent que Yahvé avait combattu les ennemis d'Israël, une frayeur venant de Dieu s'abattit sur elles toutes."
,"30":"Le royaume de Josaphat fut alors en paix, car son Dieu lui procura le repos de tous côtés."
,"31":"Josaphat régna sur Juda. Il avait trente-cinq ans lorsqu'il monta sur le trône et il régna vingt-cinq ans à Jérusalem; sa mère était Azouba fille de Chilhi."
,"32":"Il suivit les traces de son père Aza et ne s'en détourna pas, il fit ce qui est juste au regard de Yahvé."
,"33":"Cependant les Hauts-Lieux ne disparurent pas, car le peuple ne s'était pas encore attaché de tout son coeur au Dieu de ses pères."
,"34":"Le reste des actes de Josaphat, depuis les premiers jusqu'aux derniers, sont écrits dans les actes de Jéhu, fils de Hanani, ils ont été repris dans le Livre des Rois d'Israël."
,"35":"Après cela Josaphat, roi de Juda, se lia avec Okosias, roi d'Israël, qui le poussa à mal faire."
,"36":"Il s'allia avec lui pour construire des navires qui iraient à Tarsis et ils construisirent ces navires à Ezyon-Guéber."
,"37":"Mais Eliézer, fils de Dodavas, de Marécha, prophétisa alors contre Josaphat: 'Parce que tu as fait alliance avec Okosias, Yahvé a fait une brèche dans tes entreprises.' Les navires se brisèrent et ne partirent donc pas pour Tarsis."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Josaphat se coucha avec ses pères et on l'enterra avec ses pères dans la Cité de David; Joram, son fils, régna à sa place."
,"2":"Il avait six frères, tous fils de Josaphat: Azarias, Yéhiel, Zékaryas, Azaryas, Mikaël, Chéfatyas; ce sont là les fils de Josaphat, roi d'Israël."
,"3":"Leur père leur avait fait des dons importants en argent, en bijoux et en villes fortifiées en Juda, mais il avait laissé la royauté à Joram, car il était l'aîné."
,"4":"Joram prit la succession royale de son père et, dès qu'il se sentit fort, il tua par l'épée tous ses frères et même quelques chefs en Israël."
,"5":"Joram avait trente-deux ans lorsqu'il monta sur le trône et il régna huit ans à Jérusalem."
,"6":"Il suivit les traces des rois d'Israël, agissant comme faisait la maison d'Akab - sa femme était en effet une fille d'Akab - et il fit ce qui est mal au regard de Yahvé."
,"7":"Cependant Yahvé ne voulut pas détruire la maison de David à cause de l'alliance qu'il avait faite avec David: il lui avait promis de lui garder toujours une lampe allumée, ainsi qu'à ses fils."
,"8":"Durant ses jours, Edom se libéra de la domination de Juda et se donna un roi."
,"9":"Joram franchit alors la frontière avec ses chefs et tous ses chars. Avec ses commandants de chars, il se leva de nuit et battit les Edomites qui l'encerclaient."
,"10":"Mais depuis ce jour et jusqu'à maintenant, Edom s'est libéré de la domination de Juda. Libna également se libéra de la domination de Juda en ces jours-là, car Joram avait abandonné Yahvé, le Dieu de ses pères."
,"11":"Joram établit même des Hauts-Lieux dans les villes de Juda, ce qui incita les habitants de Jérusalem à se prostituer et les Judéens à s'égarer."
,"12":"On lui porta alors un écrit du prophète Elie qui disait ceci: 'Ainsi parle Yahvé le Dieu de David ton père: Tu n'as pas suivi les traces de Josaphat ton père, ni celles d'Aza roi de Juda,"
,"13":"mais tu as suivi les traces des rois d'Israël et tu as poussé Juda et les habitants de Jérusalem à se prostituer comme le fait la maison d'Akab. Tu as même tué tes frères, - la famille de ton père! - qui étaient meilleurs que toi;"
,"14":"aussi Yahvé va frapper d'un grand malheur ton peuple, tes fils, tes femmes et tout ce qui est à toi."
,"15":"Tu auras de terribles souffrances aux intestins et, sous l'effet du mal, les boyaux te sortiront du corps jour après jour.'"
,"16":"Yahvé excita contre Joram la malveillance des Philistins et des Arabes voisins des Kouchites."
,"17":"Ils montèrent contre Juda, l'envahirent et enlevèrent tout ce qu'ils trouvèrent dans le palais royal, ainsi que les fils de Joram et ses femmes; il ne lui resta plus qu'un fils, le plus jeune, Okozias."
,"18":"Après tout cela Yahvé le frappa au ventre d'une maladie incurable."
,"19":"Au bout de quelque temps - deux ans s'étaient écoulés - ses boyaux sortirent sous l'effet du mal et il mourut dans de terribles souffrances. Son peuple ne lui fit pas de feu comme on en avait fait pour ses pères."
,"20":"Il était âgé de trente-deux ans quand il monta sur le trône et il régna huit ans à Jérusalem. Quand il partit, personne ne le regretta; on l'enterra bien dans la Cité de David, mais pas dans les tombes royales."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Les habitants de Jérusalem établirent Okozias, son plus jeune fils, comme roi à sa place, car la bande qui était entrée avec les Arabes dans le camp, avait assassiné tous les aînés. Voilà comment Okozias fils de Joram, devint roi."
,"2":"Okozias avait vingt-deux ans lorsqu'il monta sur le trône; sa mère était Athalie, fille d'Omri."
,"3":"Lui aussi suivit les traces de la maison d'Akab, car sa mère le poussait au mal."
,"4":"Il fit ce qui est mal au regard de Yahvé, comme les gens de la maison d'Akab. Après la mort de son père, en effet, ce sont eux qui le conseillèrent pour son malheur."
,"5":"Sur leurs conseils il se mit en campagne et partit avec Joram fils d'Akab, roi d'Israël, pour combattre Hazaël roi d'Aram à Ramot-de-Galaad; mais les Araméens blessèrent Joram"
,"6":"et il revint à Yizréel pour se faire soigner des blessures qu'il avait reçues à Ramot en combattant Hazaël roi d'Aram. Okozias fils de Joram, roi de Juda, s'en alla rendre visite à Joram fils d'Akab à Yizréel, car il était blessé."
,"7":"Mais Dieu voulut que cette visite d'Okozias à Joram tourne à sa perte. Dès son arrivée, Okozias sortit avec Joram à la rencontre de Jéhu fils de Nimchi, que Yahvé avait consacré roi pour exterminer la maison d'Akab."
,"8":"Comme Jéhu cherchait à faire justice de la maison d'Akab, il rencontra les chefs de Juda et les neveux d'Okozias qui étaient au service du roi, et il les tua."
,"9":"Puis il partit à la recherche d'Okozias qui fut pris alors qu'il se cachait dans Samarie; on le conduisit à Jéhu qui le mit à mort. Mais on l'enterra car on se disait: 'C'est le fils de Josaphat qui cherchait Yahvé de tout son coeur.',Or personne dans la maison d'Okozias n'était de taille à régner."
,"10":"Voyant que son fils était mort, Athalie, mère d'Okozias, décida d'exterminer toute la descendance royale de la maison de Juda."
,"11":"Mais Yochéba, fille du roi, prit Joas fils d'Okozias et réussit à l'enlever du milieu des fils du roi, tandis qu'on les mettait à mort; elle le cacha avec sa nourrice dans la chambre des lits. Yochéba, fille du roi Joram et femme du prêtre Yoyada - elle était la soeur d'Okozias - le déroba ainsi au regard d'Athalie et il échappa à la mort."
,"12":"Il resta caché avec elle dans la Maison de Dieu durant six ans, alors qu'Athalie régnait sur le pays."
}`)
	CurrentBook.AddChapter(23, `{
"1":"La septième année, Yoyada fit un acte courageux. Il prit les chefs de cent: Azarias fils de Yéroham, Ismaël fils de Yohanan, Azaryas fils d'Obed, Maaséyas fils d'Adadyas, Elichafat fils de Zikri, et il conclut un pacte avec eux."
,"2":"Ils parcoururent Juda et rassemblèrent les lévites de toutes les villes de Juda ainsi que les chefs de famille d'Israël et ils vinrent à Jérusalem."
,"3":"Toute l'assemblée conclut une alliance avec le roi dans la Maison de Dieu et Yoyada leur dit: 'Voici le fils du roi, qu'il règne comme Yahvé l'a dit au sujet des fils de David!"
,"4":"Voici ce que vous ferez: un tiers d'entre vous, prêtres et lévites qui prenez votre service le jour du sabbat, assurera la garde des entrées;"
,"5":"un tiers sera dans le palais royal et un dernier tiers à la Porte-du-Fondement, tandis que tout le peuple sera dans les cours de la Maison de Yahvé."
,"6":"Seuls les prêtres et les lévites de service entreront dans la Maison de Yahvé: eux seuls sont consacrés et peuvent entrer; mais tout le peuple se pliera aux ordres de Yahvé."
,"7":"Les lévites entoureront le roi les armes à la main, et si quelqu'un veut pénétrer dans la Maison, il sera mis à mort. Vous accompagnerez le roi dans tous ses déplacements.'"
,"8":"Les lévites et tous les Judéens firent tout ce que le prêtre Yoyada avait ordonné. Chacun prit ses hommes, ceux qui prennent leur service le jour du sabbat et ceux qui le terminent le jour du sabbat: le prêtre Yoyada ne donna congé à aucun des groupes."
,"9":"Le prêtre Yoyada donna aux chefs de cent les lances, les boucliers ronds et les boucliers du roi David qui étaient dans la Maison de Dieu."
,"10":"Il mit tout le monde à son poste, chacun son javelot dans la main, depuis le côté sud de la Maison jusqu'au côté nord de la Maison, devant l'autel et devant la Maison, de manière à bien entourer le roi."
,"11":"On fit alors sortir le fils du roi et on lui posa sur la tête le diadème et le témoignage : on le proclama roi. Yoyada et ses fils le consacrèrent et l'on cria: 'Vive le roi!'"
,"12":"Quand Athalie entendit les cris du peuple qui accourait et acclamait le roi, elle se rendit au Temple au-devant du peuple."
,"13":"Elle regarda et vit le roi debout près de la colonne à l'entrée, les chefs et les joueurs de trompette auprès du roi, tout le peuple sonnant joyeusement des trompettes et les chantres avec leurs instruments de musique qui dirigeaient les acclamations. Athalie déchira ses vêtements en s'écriant: 'Trahison! Trahison!'"
,"14":"Le prêtre Yoyada donna des ordres aux chefs de cent qui étaient à la tête de l'armée: 'Faites-la sortir hors des rangs, leur dit-il, et si quelqu'un la suit, mettez-le à mort par l'épée!' Car le prêtre avait dit: 'Vous ne la tuerez pas dans la Maison de Yahvé.'"
,"15":"On la saisit et on l'entraîna par l'entrée de la Porte-des-Chevaux jusqu'au palais royal, et là on la mit à mort."
,"16":"Yoyada fit un pacte entre Yahvé, tout le peuple et le roi: on s'engageait à être le peuple de Yahvé."
,"17":"On se rendit à la Maison de Baal et on la détruisit, puis l'on brisa autels et images. Quant à Mattan, le prêtre de Baal, on le tua devant les autels."
,"18":"Yoyada plaça des postes de surveillance dans la Maison de Yahvé qu'il confia aux prêtres-lévites, car David leur avait donné comme part la Maison de Yahvé. Ils y offraient des holocaustes à Yahvé, comme il est écrit dans la loi de Moïse, dans la joie et les chants, selon les ordres de David."
,"19":"Il plaça des portiers aux portes de la Maison de Yahvé, pour qu'aucune personne impure pour quelque raison que ce soit, n'y entre."
,"20":"Il prit les chefs de cent, les notables, ceux qui avaient une responsabilité publique et tout le peuple du pays, il fit descendre le roi depuis la Maison de Yahvé, et passant par la Porte-Haute, on gagna le palais royal. Là on fit asseoir le roi sur le trône royal,"
,"21":"et tout le peuple du pays se réjouit. La ville était paisible, Athalie avait été mise à mort par l'épée."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Joas avait sept ans lorsqu'il monta sur le trône et il régna quarante ans à Jérusalem; sa mère s'appelait Cibya, elle était de Bersabée."
,"2":"Joas fit ce qui est juste aux yeux de Yahvé tant que vécut le prêtre Yoyada."
,"3":"Yoyada lui fit épouser deux femmes et il engendra des fils et des filles."
,"4":"Après cela, Joas décida de réparer la Maison de Yahvé."
,"5":"Il rassembla les prêtres et les lévites et il leur dit: 'Partez vers les villes de Juda; chaque année vous ramasserez de l'argent dans tout Israël pour réparer la Maison de votre Dieu; dépêchez-vous de le faire.' Mais les lévites ne se pressèrent pas."
,"6":"Le roi appela alors Yoyada, leur chef, et lui dit: 'Pourquoi n'as-tu pas insisté auprès des lévites pour qu'ils perçoivent en Juda et à Jérusalem la redevance que Moïse, le serviteur de Yahvé, et l'assemblée d'Israël ont imposée pour la Tente du Témoignage?"
,"7":"En effet, cette maudite Athalie et ses fils ont laissé la Maison se dégrader, ils ont même utilisé pour les Baals les objets consacrés de la Maison de Yahvé.'"
,"8":"Le roi ordonna donc de faire un coffre que l'on plaça à la porte de la Maison de Yahvé, à l'extérieur."
,"9":"Puis il fit proclamer dans Juda et dans Jérusalem: 'Que l'on apporte à Yahvé la redevance que Moïse, le serviteur de Dieu, avait imposée à Israël quand il était au désert."
,"10":"Tous les chefs et tout le peuple se réjouirent; ils apportèrent et versèrent dans le coffre la totalité de leur redevance."
,"11":"Chaque fois que les lévites voyaient beaucoup d'argent dans le coffre, ils le portaient à l'inspecteur du roi; le secrétaire du roi venait alors avec le délégué du prêtre en chef, il vidait le coffre, puis on le reportait et le remettait à sa place. On faisait ainsi jour après jour; on ramassa beaucoup d'argent."
,"12":"Le roi et Yoyada confiaient l'argent à ceux qui étaient chargés des travaux d'entretien dans la Maison de Yahvé; ceux-ci engageaient des tailleurs de pierre, des charpentiers, des artisans du fer et du bronze, pour réparer la Maison de Yahvé."
,"13":"Ceux qui étaient chargés des travaux se mirent à l'ouvrage et grâce à eux les travaux de réparation avancèrent. On remit en état la Maison de Yahvé et on la consolida."
,"14":"Lorsque les ouvriers eurent terminé, ils apportèrent le reste de l'argent au roi et à Yoyada. On en fit des objets pour la Maison de Yahvé: des objets pour le culte et pour les holocaustes, coupes et vases d'or et d'argent. Durant toute la vie de Yoyada on ne cessa d'offrir des holocaustes dans la Maison de Yahvé."
,"15":"Yoyada vieillit, et il mourut chargé d'années. Il avait alors cent trente ans."
,"16":"On l'enterra avec les rois dans la Cité de David car, en Israël, il avait bien agi envers son Dieu et le Temple de son Dieu."
,"17":"Après la mort de Yoyada, les chefs de Juda vinrent se prosterner devant le roi et le roi les écouta."
,"18":"Ils abandonnèrent alors la Maison de Yahvé, le Dieu de leurs pères, et ils servirent les pieux sacrés et les idoles; à cause de cette faute le malheur se fit menaçant sur Juda et Jérusalem."
,"19":"Yahvé leur envoya des prophètes pour les ramener vers lui; ces prophètes témoignèrent contre eux, mais ils n'y firent aucune attention."
,"20":"L'esprit de Dieu s'empara de Zékaryas, fils du prêtre Yoyada. Il se posta devant le peuple et lui dit: 'Voici ce que dit Dieu: Pourquoi désobéir aux commandements de Yahvé et courir à l'échec? Vous avez abandonné Yahvé? Eh bien lui, il vous abandonne!'"
,"21":"Ils complotèrent contre lui et l'assommèrent avec des pierres dans la cour du Temple, sur l'ordre du roi."
,"22":"Le roi Joas oublia la fidélité que lui avait montrée Yoyada, père de Zékaryas: il mit son fils à mort! Mais en mourant celui-ci s'écria: 'Que Yahvé regarde et qu'il demande des comptes!'"
,"23":"Vers le milieu de l'année, l'armée d'Aram partit en guerre contre Joas et s'avança en Juda jusqu'à Jérusalem. Parmi la population, ils firent un massacre des chefs, et ils envoyèrent leurs dépouilles au roi de Damas."
,"24":"L'armée d'Aram qui était venue n'était guère nombreuse, mais Yahvé avait livré entre ses mains une armée très puissante, car le peuple avait abandonné Yahvé, le Dieu de ses pères. Les Araméens firent justice de Joas"
,"25":"et le laissèrent en très mauvais état. Lorsqu'ils s'éloignèrent, ses serviteurs conspirèrent contre lui: c'est qu'il avait versé le sang du fils de Yoyada, le prêtre! Ils le tuèrent sur son lit. Une fois mort, on l'enterra dans la Cité de David, mais on ne le mit pas dans le cimetière des rois."
,"26":"Voici les noms des conspirateurs: Zabad fils de Chiméat l'Ammonite, et Yozabad fils de Chimrit la Moabite."
,"27":"Ce qui concerne les fils du roi, les nombreux oracles dirigés contre lui et la restauration de la Maison de Yahvé, cela est écrit dans le commentaire du livre des Rois. Son fils Amasias régna à sa place."
}`)
	CurrentBook.AddChapter(25, `{
"1":"Amasias devint roi à l'âge de vingt-cinq ans et il régna vingt-neuf ans à Jérusalem; sa mère s'appelait Yohaddan, elle était de Jérusalem."
,"2":"Il fit ce qui est juste au regard de Yahvé, mais non sans quelques faiblesses."
,"3":"Lorsqu'il eut bien en main le pouvoir, il tua les serviteurs qui avaient mis à mort le roi, son père."
,"4":"Mais il ne mit pas à mort leurs fils, selon le commandement de la Loi de Yahvé où il est écrit: 'Les pères ne seront pas mis à mort pour les fils et les fils ne mourront pas pour les pères: chacun mourra pour son propre péché.'"
,"5":"Amasias rassembla les hommes de Juda et les organisa par familles, avec des chefs de mille et des chefs de cent, dans tout le territoire de Juda et de Benjamin. Il recensa tous ceux de plus de vingt ans; il trouva 300000 hommes de guerre portant la lance et le bouclier et entraînés au combat."
,"6":"Pour cent talents d'argent il loua en Israël 100000 soldats entraînés."
,"7":"Mais un homme de Dieu vint le trouver et lui dit: 'O roi! Ne prends pas avec toi une armée d'Israël: Yahvé n'est pas avec Israël, avec tous ces fils d'Ephraïm!"
,"8":"Si tu la prends, Dieu te fera trébucher devant l'ennemi, même si tu es courageux au combat: Dieu seul est la force qui vient en aide ou qui fait trébucher!'"
,"9":"Amasias répondit à l'homme de Dieu: 'Que vais-je faire des cent talents que j'ai donnés pour cette armée d'Israël?' L'homme de Dieu lui dit: 'Yahvé a de quoi te donner beaucoup plus que cela.'"
,"10":"Amasias laissa donc de côté l'armée qui était venue d'Ephraïm et la renvoya chez elle, mais ces hommes étaient furieux contre Juda et ils s'en retournèrent chez eux rouges de colère."
,"11":"Plein d'ardeur, Amasias emmena son peuple et gagna la vallée du Sel; il écrasa là dix mille hommes parmi les fils de Séïr."
,"12":"Les Judéens ramenèrent 10000 prisonniers et les conduisirent au sommet de La Roche; du sommet de La Roche, ils les jetèrent en bas où tous se brisèrent."
,"13":"Pendant ce temps, les mercenaires qu'Amasias avait renvoyés sans leur permettre d'aller avec lui au combat, se jetèrent sur les villes de Juda, depuis Samarie jusqu'à Beth-Horon; ils massacrèrent trois mille hommes et emportèrent un grand butin."
,"14":"Au retour de sa campagne contre les Edomites, Amasias rapporta les dieux des gens de Séïr. Il en fit ses propres dieux, il se prosterna devant eux et fit fumer de l'encens."
,"15":"Yahvé se mit en colère contre Amasias et lui envoya un prophète pour lui dire: 'Pourquoi t'es-tu adressé aux dieux de ce peuple: ils n'ont même pas été capables de le sauver de ta main?'"
,"16":"Mais le roi répondit à ces paroles: 'Est-ce que nous t'avons choisi comme conseiller du roi? Garde tes réflexions pour toi, ou bien veux-tu que l'on te frappe?' Le prophète se tut, mais non sans ajouter: 'Après avoir fait cela, tu n'as pas écouté mon avertissement; je vois donc que Dieu a décidé ta perte.'"
,"17":"Après avoir pris conseil, Amasias roi de Juda envoya dire à Joas fils de Joakaz, fils de Jéhu, roi d'Israël: 'Viens te mesurer avec moi!'"
,"18":"Joas, roi d'Israël envoya dire à Amasias, roi de Juda: 'L'épine du Liban envoya dire au cèdre du Liban: Donne ta fille pour qu'elle soit l'épouse de mon fils. Mais une bête sauvage du Liban passa, qui piétina l'épine."
,"19":"Tu te dis: J'ai écrasé Edom, et tu en es très fier. Reste donc chez toi, pourquoi attirer le malheur et la ruine sur toi, et sur Juda avec toi?'"
,"20":"Mais Amasias n'écouta pas. Cela venait de Dieu, il voulait les livrer parce qu'ils avaient recherché les dieux d'Edom."
,"21":"Joas roi d'Israël monta donc et ils se mesurèrent, lui et Amasias roi de Juda, à Beth-Shémesh, dans le territoire de Juda."
,"22":"Juda fut battu par Israël et chacun s'enfuit vers sa tente."
,"23":"Joas roi d'Israël fit prisonnier à Beth-Shémesh Amasias roi de Juda, fils de Joas, fils d'Okozias. Il l'emmena à Jérusalem et il abattit le rempart de Jérusalem sur une centaine de mètres, depuis la porte d'Ephraïm jusqu'à la porte de l'Angle."
,"24":"Il ramassa tout l'or, tout l'argent et tout le mobilier qui se trouvaient dans la Maison de Dieu, chez Obèd-Edom; il prit les trésors du palais royal et des otages, puis il repartit à Samarie."
,"25":"Amasias fils de Joas, roi de Juda, vécut encore quinze ans après la mort de Joas fils de Joakaz, roi d'Israël."
,"26":"Le reste des actes d'Amasias depuis les premiers jusqu'aux derniers, cela n'est-il pas écrit dans le Livre des Rois de Juda et d'Israël?"
,"27":"Après l'époque où Amasias s'écarta de Yahvé, une conspiration s'organisa contre lui à Jérusalem; il prit la fuite pour Lakish, mais on le poursuivit jusqu'à Lakish, et là il fut mis à mort."
,"28":"On le ramena avec des chevaux, et on l'enterra avec ses pères dans la Cité de David."
}`)
	CurrentBook.AddChapter(26, `{
"1":"Tout le peuple de Juda choisit Ozias qui avait alors seize ans et on le fit roi à la place de son père Amasias."
,"2":"Il rebâtit Elat et la rendit à Juda après que le roi se fut couché avec ses pères."
,"3":"Ozias avait seize ans lorsqu'il monta sur le trône et il régna cinquante-deux ans à Jérusalem; sa mère Yékolyas était de Jérusalem."
,"4":"Il fit ce qui est juste au regard de Yahvé, tout comme l'avait fait son père Amasias."
,"5":"Durant toute la vie de Zékaryas qui lui apprenait la crainte de dieu, Amasias s'appliqua à rechercher Dieu. Dieu lui accorda la réussite tout le temps qu'il chercha Dieu."
,"6":"Il se mit en campagne contre les Philistins; il démolit le rempart de Gat, les murs de Yabné et d'Ashdod, puis il reconstruisit les villes de la région d'Ashdod et du pays des Philistins."
,"7":"Dieu l'aida contre les Philistins, contre les Arabes qui habitaient Gour-Baal et les Méounites."
,"8":"Les Ammonites versèrent l'impôt à Ozias; il fut célèbre jusqu'aux portes de l'Egypte, car il était devenu très puissant."
,"9":"Ozias construisit des tours à Jérusalem, à la Porte de l'Angle, à la Porte de la Vallée et aux raccords du rempart: il leur donna des défenses."
,"10":"Il construisit aussi des tours dans le désert et il y creusa de grandes citernes, car il y avait de nombreux troupeaux, tout comme dans le bas-pays et sur le plateau. Il aimait l'agriculture et possédait laboureurs et vignerons."
,"11":"Ozias avait une armée entraînée, des hommes prêts à combattre organisés selon les données du recensement fait par Yéhiel, le secrétaire, et le greffier Maaséyas. Elle était aux ordres de Hananias, l'un des officiers du roi."
,"12":"Elle comptait au total 2600 hommes, bons combattants et chefs de familles."
,"13":"Sous leurs ordres se trouvait l'armée de campagne: elle comptait 30 500 hommes prêts à combattre pour épauler le roi contre l'ennemi."
,"14":"Ozias leur prépara pour toutes les campagnes, des boucliers, des lances, des casques, des cuirasses, des arcs et des pierres pour les frondes."
,"15":"Il fit aussi pour Jérusalem des machines, inventées par un ingénieur, que l'on installait sur les tours et sur les angles du rempart pour lancer des flèches et de grosses pierres. Son nom devint célèbre au loin, car il sut si bien se faire aider qu'il devint très puissant."
,"16":"Mais avec la puissance il devint orgueilleux au point de se corrompre; sans aucun égard pour Yahvé son Dieu, il entra dans la Maison de Yahvé pour faire fumer lui-même de l'encens sur l'autel des parfums."
,"17":"Le prêtre Azaryas entra derrière le roi Ozias, et avec lui quatre-vingts prêtres courageux;"
,"18":"ils lui firent front: 'Ce n'est pas à toi, Ozias, lui dirent-ils, de faire fumer l'encens en l'honneur de Yahvé, mais bien aux prêtres fils d'Aaron qui ont été consacrés pour cela! Sors de la Maison! Tu désobéis et cela ne te couvrira pas de gloire devant Yahvé Dieu!'"
,"19":"Ozias tenait en main un encensoir pour faire fumer l'encens; rouge de colère, il s'emportait contre les prêtres; mais alors sur son front la lèpre apparut, sous les yeux des prêtres qui se tenaient près de l'autel des parfums dans la Maison de Yahvé."
,"20":"Azaryas, le prêtre en chef, et tous les autres prêtres se tournèrent vers lui; voyant la lèpre sur son front, ils le chassèrent aussitôt; lui-même se dépêcha de sortir car Yahvé l'avait frappé."
,"21":"Le roi Ozias fut lépreux jusqu'au jour de sa mort et, comme lépreux, il habita dans une maison isolée; il fut exclu de la Maison de Yahvé. Yotam, son fils, était chargé du palais royal et gouvernait le peuple du pays."
,"22":"Le reste des actes d'Ozias, depuis les premiers jusqu'aux derniers, ont été écrits par le prophète Isaïe, fils d'Amos."
,"23":"Ozias se coucha avec ses pères et on l'enterra avec eux, mais seulement dans le terrain des tombes royales, car on disait: 'C'est un lépreux!' Son fils Yotam régna à sa place."
}`)
	CurrentBook.AddChapter(27, `{
"1":"Yotam avait vingt-cinq ans lorsqu'il monta sur le trône, il régna seize ans à Jérusalem; sa mère était Yéroucha fille de Sadoq."
,"2":"Il fit ce qui est juste au regard de Yahvé tout comme l'avait fait son père Ozias, et lui n'entra pas dans la Maison de Yahvé; le peuple cependant continuait de faire le mal."
,"3":"Il construisit la Porte Haute de la Maison de Yahvé et fit de nombreuses réparations au mur de l'Ophel."
,"4":"Il construisit des villes dans la montagne de Juda, des forteresses et des tours dans les régions boisées."
,"5":"Il fit la guerre au roi des Ammonites et l'emporta sur lui. Les Ammonites lui donnèrent cette année-là cent talents d'argent, dix mille mesures de blé et dix mille d'orge; les Ammonites lui en remirent encore autant la seconde et la troisième année."
,"6":"Yotam devint puissant car il prenait ses décisions sous le regard de Yahvé son Dieu."
,"7":"Les reste des actes de Yotam, toutes ses guerres et ses travaux, cela est écrit dans le livre des rois d'Israël et de Juda."
,"8":"Il avait vingt-cinq ans lorsqu'il monta sur le trône et il régna seize ans à Jérusalem."
,"9":"Yotam se coucha avec ses pères et on l'enterra dans la Cité de David. Son fils Akaz régna à sa place."
}`)
	CurrentBook.AddChapter(28, `{
"1":"Akaz avait vingt ans lorsqu'il monta sur le trône et il régna seize ans à Jérusalem; il ne fit pas ce qui est juste au regard de Yahvé comme l'avait fait son ancêtre David."
,"2":"Il suivit les traces des rois d'Israël et fit même des idoles de métal en l'honneur des Baals."
,"3":"Il fit fumer de l'encens dans la vallée de Ben-Hinnom, il y brûla ses fils par le feu selon la pratique odieuse des nations que Yahvé avait dépossédées devant les Israélites."
,"4":"Il offrit des sacrifices et fit fumer l'encens dans les Hauts-Lieux, sur les collines et sous tout arbre vert."
,"5":"Yahvé son Dieu le livra entre les mains du roi des Araméens; il fut écrasé et on lui fit beaucoup de prisonniers qui furent emmenés à Damas. Il fut aussi livré entre les mains du roi d'Israël; ce fut pour lui une grande défaite. "
,"6":"Pékah fils de Rémalyas tua en un seul jour 120000 hommes de Juda; tous étaient de bons soldats, mais ils avaient abandonné Yahvé Dieu de leurs pères."
,"7":"Zikri, un brave d'Ephraïm, tua Maaséyas fils du roi, Azrikam, le maître du palais, et Elkana, un officier du roi."
,"8":"Les Israélites firent 200000 prisonniers parmi leurs frères de Juda, en comptant leurs femmes, fils et filles, et ils leur prirent aussi un important butin qu'ils emportèrent à Samarie."
,"9":"Un prophète de Yahvé nommé Obed se trouvait là; il sortit au-devant de l'armée qui rentrait à Samarie: 'Regardez, leur dit-il, Yahvé Dieu de vos pères a livré Juda entre vos mains dans sa colère; mais vous, vous les avez tués avec une rage qui montait jusqu'aux cieux!"
,"10":"Maintenant, vous parlez de réduire en esclavage les gens de Juda et de Jérusalem, hommes et femmes. Mais n'êtes-vous pas aussi coupables envers Yahvé votre Dieu?"
,"11":"Ecoutez-moi maintenant: renvoyez ces prisonniers que vous avez faits parmi vos frères, car la violente colère de Yahvé vous guette.'"
,"12":"Certains parmi les chefs d'Ephraïm, Azaryas fils de Yohanan, Bérékyas fils de Méchillémot, Yiskyas fils de Challoum, Amaza fils de Hadlaï, s'emportèrent alors contre ceux qui revenaient de la bataille:"
,"13":"'Vous n'amènerez pas ici ces prisonniers. Voulez-vous donc nous rendre coupables envers Yahvé et ajouter encore à nos péchés et à nos fautes, alors que nous sommes déjà terriblement coupables et qu'une violente colère nous guette.'"
,"14":"Alors les soldats abandonnèrent les prisonniers et le butin en présence des chefs et de toute l'assemblée."
,"15":"Des hommes furent désignés personnellement pour s'occuper des prisonniers. Avec le butin ils habillèrent tous ceux qui étaient nus, ils leur donnèrent des vêtements, des chaussures, à manger et à boire. Ils les parfumèrent et les renvoyèrent - on avait fait monter sur des ânes ceux qui étaient épuisés. Ils les reconduisirent à Jéricho, la ville des Palmiers, au milieu de leurs frères, après quoi ils rentrèrent à Samarie."
,"16":"En ce temps-là le roi d'Akaz envoya demander au roi d'Assyrie de venir à son secours,"
,"17":"car les Edomites étaient encore venus; ils avaient écrasé Juda et lui avaient fait des prisonniers."
,"18":"Les Philistins, de leur côté, avaient fait des expéditions contre les villes du Bas-Pays et du Négueb de Juda; ils avaient pris Beth-Shémesh, Ayalon, Guédérot, Soko et ses environs, Timna et ses environs, Guimzo et ses environs, et ils s'y étaient installés."
,"19":"Yahvé avait humilié Juda à cause d'Akaz, roi d'Israël, qui laissait tout faire en Juda et se montrait infidèle à Yahvé."
,"20":"Téglat-Falazar, roi d'Assyrie, l'attaqua et l'assiégea au lieu de le secourir."
,"21":"Alors Akaz dépouilla la Maison de Yahvé, le palais royal et les maisons des chefs pour faire des cadeaux au roi d'Assyrie, mais cela ne servit à rien."
,"22":"En effet, durant cette période où il se voyait pressé de toutes parts, le roi Akaz continua d'être infidèle à Yahvé."
,"23":"Il offrit des sacrifices aux dieux de ses ennemis de Damas qui l'avaient battu, car il se disait: 'Puisque les dieux des rois d'Aram leur apportent du secours, je leur offrirai aussi des sacrifices pour qu'ils m'aident.' C'est ainsi qu'ils le firent trébucher, lui et tout Israël avec lui."
,"24":"Akaz rassembla les objets de la Maison de Yahvé et il les brisa; il ferma les portes de la Maison de Yahvé et se construisit des autels à tous les coins de rues de Jérusalem."
,"25":"Il établit des Hauts-Lieux dans chacune des villes de Juda pour y faire brûler de l'encens en l'honneur d'autres dieux, ce qui provoqua la colère de Yahvé, le Dieu de ses pères."
,"26":"Le reste de ses actes, tous ses travaux du premier jusqu'au dernier, sont écrits dans le livre des rois de Juda et d'Israël."
,"27":"Akaz se coucha avec ses pères et on l'enterra dans la Cité à Jérusalem, mais non dans les tombes des rois d'Israël. Son fils Ezéquias régna à sa place."
}`)
	CurrentBook.AddChapter(29, `{
"1":"Ezéquias devint roi à l'âge de vingt-cinq ans, il régna vingt-neuf ans à Jérusalem; sa mère était Abiya, fille de Zékaryas."
,"2":"Il fit ce qui est juste au regard de Yahvé, suivant en tout ce que son ancêtre David avait fait."
,"3":"La première année de son règne, au premier mois, il rouvrit les portes de la Maison de Yahvé et les répara."
,"4":"Il fit venir les prêtres et les lévites et les rassembla sur la place de l'est:"
,"5":"'Ecoutez-moi, lévites, leur dit-il, purifiez-vous et purifiez la Maison de Yahvé, Dieu de nos pères; enlevez du Temple toute cette ordure."
,"6":"Nos pères ont été infidèles, ils ont fait ce qui est mal au regard de Yahvé, ils l'ont abandonné; ils ont détourné leur regard de la Demeure de Yahvé et ils lui ont tourné le dos."
,"7":"Ils ont fermé les portes du Vestibule, ils ont éteint les lampes et n'ont plus fait fumer l'encens, ils ont cessé d'offrir des holocaustes dans le Lieu Saint en l'honneur du Dieu d'Israël."
,"8":"C'est pour cela que la colère de Yahvé s'est déchaînée contre Juda et contre Jérusalem, et qu'il en a fait un exemple: on s'étonne de leur malheur et on se moque, comme vous le voyez vous-mêmes."
,"9":"A cause de cela nos pères sont tombés sous l'épée, nos fils, nos filles et nos femmes sont en captivité."
,"10":"Maintenant j'ai à coeur de conclure une alliance avec Yahvé Dieu d'Israël, pour qu'il éloigne de nous la violence de sa colère."
,"11":"O mes fils, ne soyez pas négligents! C'est vous que Yahvé a choisis pour se tenir devant lui, pour le servir, pour assurer son culte et faire fumer l'encens.'"
,"12":"Des lévites se levèrent: parmi les Kahatites: Maahat fils de Amasaï, Yoël fils d'Azaryas; parmi les Mérarites: Kish fils d'Abdi et Azaryas fils de Yalléléel; parmi les Guerchomites: Yoah fils de Zimma, et Eden fils Yoah;"
,"13":"parmi les fils d'Elisafan: Chimri et Yeïel; parmi les fils d'Asaf: Zékaryas et Matanyas;"
,"14":"parmi les fils de Héman: Yéhiel et Chiméï; parmi les fils de Yédoutoun: Chémaya et Ouziel."
,"15":"Ils réunirent leurs frères et se purifièrent comme le roi le demandait, selon les paroles de Yahvé; on commença alors à purifier la Maison de Yahvé."
,"16":"Les prêtres entrèrent dans la Maison de Yahvé et ils en retirèrent toutes les choses impures qu'ils trouvèrent dans le Sanctuaire; ils les déposèrent dans la cour. Là les lévites les ramassèrent pour aller les jeter dans le torrent du Cédron."
,"17":"Ils commencèrent cette purification le premier jour du premier mois et ils arrivèrent au vestibule de Yahvé le huitième jour de ce mois; ils mirent donc huit jours pour purifier la Maison de Yahvé, et le seizième jour du premier mois, tout était achevé."
,"18":"Ils se rendirent alors chez le roi Ezéquias: 'Nous avons purifié, dirent-ils, toute la Maison de Yahvé, l'autel des holocaustes et tous ses accessoires, la table des pains et tous ses accessoires."
,"19":"Nous avons remis en ordre et purifié tous les objets que le roi Akaz avait mis au rebut durant son règne à cause de son impiété; ils sont maintenant devant l'autel.'"
,"20":"De bon matin, le roi Ezéquias se leva, il réunit les chefs de la ville et monta à la Maison de Yahvé."
,"21":"On amena des taureaux, des béliers, des agneaux et des boucs - sept de chaque espèce - que l'on devait offrir en sacrifice de réparation pour le royaume, pour le Sanctuaire et pour Juda. Ensuite le roi ordonna aux prêtres, fils d'Aaron, d'offrir sur l'autel de Yahvé des holocaustes."
,"22":"On immola des boeufs, des béliers et des agneaux et on en recueillit le sang pour en asperger l'autel."
,"23":"On fit alors avancer les boeufs devant le roi pour le sacrifice de réparation: il leur imposa les mains devant toute l'assemblée."
,"24":"Les prêtres alors les immolèrent et ils versèrent le sang sur l'autel en sacrifice de réparation afin d'expier au nom de tout Israël; le roi avait en effet ordonné cet holocauste et ce sacrifice pour le péché pour tout Israël."
,"25":"Il plaça les lévites dans la Maison de Yahvé avec les cymbales, les harpes et les lyres, selon les règlements de David, de Gad, le voyant du roi, et de Nathan, le prophète: ce que les prophètes avaient établi venait en réalité de Yahvé lui-même."
,"26":"Les lévites prirent donc place avec les instruments de David et les prêtres avec les trompettes."
,"27":"Ezéquias ordonna alors d'offrir l'holocauste sur l'autel, et lorsque l'on commença l'holocauste, le chant de Yahvé débuta également au son des trompettes, accompagné par les instruments de David, roi d'Israël."
,"28":"Toute l'assemblée resta prosternée pendant que le chant retentissait et que l'on sonnait de la trompette: cela dura jusqu'à la fin de l'holocauste."
,"29":"L'holocauste terminé, le roi et tous ceux qui étaient avec lui s'agenouillèrent et se prosternèrent."
,"30":"Le roi Ezéquias et les chefs demandèrent alors aux lévites de louer Dieu par les paroles de David et d'Azaf le voyant. Ils le louèrent joyeusement, à genoux ou prosternés."
,"31":"Alors Ezéquias prit la parole et dit: 'Vous vous êtes consacrés à Yahvé, venez donc offrir à la Maison de Yahvé des sacrifices d'action de grâces.' L'assemblée présenta des sacrifices de communion et d'action de grâces, et tous ceux qui le voulaient amenèrent généreusement des holocaustes."
,"32":"L'assemblée présenta pour l'holocauste à Yahvé soixante-dix boeufs, cent béliers, deux cents agneaux."
,"33":"Six cents boeufs et trois mille moutons furent offerts et consacrés."
,"34":"Mais les prêtres n'étaient pas assez nombreux pour immoler tous les holocaustes; leurs frères, les lévites, les aidèrent jusqu'à la fin de la besogne, jusqu'à ce que les prêtres soient purifiés. En effet, les lévites avaient été plus zélés que les prêtres, pour se purifier."
,"35":"Il y eut beaucoup de victimes à brûler en holocauste, sans compter les graisses des sacrifices de communion et les libations des holocaustes. C'est ainsi que le service de la Maison de Yahvé fut rétabli."
,"36":"Ezéquias et tout le peuple étaient heureux de ce que Dieu avait réalisé pour le peuple, car tout s'était fait rapidement."
}`)
	CurrentBook.AddChapter(30, `{
"1":"Ezéquias envoya des messagers par tout Israël et tout Juda - il écrivit même des lettres en ce sens à Ephraïm et à Manassé - pour que l'on vienne à la Maison de Yahvé à Jérusalem, afin de célébrer une Pâque en l'honneur de Yahvé, Dieu d'Israël."
,"2":"Le roi, les chefs et toute l'assemblée de Jérusalem, tombèrent d'accord pour célébrer la Pâque au second mois"
,"3":"car on n'avait pas pu la célébrer en son temps : les prêtres ne s'étaient pas purifiés en nombre suffisant et le peuple n'était pas encore rassemblé à Jérusalem."
,"4":"La décision parut juste au yeux du roi et de toute l'assemblée,"
,"5":"à la suite de quoi ils décidèrent de faire passer un avis dans tout Israël, de Bersabée jusqu'à Dan, pour que l'on vienne célébrer une Pâque en l'honneur de Yahvé Dieu d'Israël. En effet, ceux qui l'avaient fait conformément à l'Ecriture, étaient peu nombreux."
,"6":"Les messagers partirent donc dans tout Israël et tout Juda avec les lettres signées de la main du roi et des chefs qui contenaient les instructions du roi: 'Israélites! Revenez à Yahvé, Dieu d'Abraham et d'Israël, pour qu'il revienne lui aussi vers les survivants, vers vous qui avez échappé à la main des rois d'Assyrie."
,"7":"Ne soyez pas comme vos pères et vos frères qui ont été infidèles à Yahvé, le Dieu de leurs pères: il les a livrés à la ruine comme vous l'avez vu."
,"8":"Ne faites plus maintenant la forte tête comme l'ont fait vos pères, rendez gloire à Yahvé, venez au sanctuaire qu'il a consacré pour toujours; servez Yahvé votre Dieu, et lui détournera de vous sa violente colère."
,"9":"Si vous revenez à Yahvé, vos frères et vos fils trouveront grâce auprès de leurs gardiens et reviendront en ce pays, car Yahvé votre Dieu est bon et fait miséricorde. Si vous revenez à lui, il ne détournera pas de vous son visage.'"
,"10":"Les messagers allaient de ville en ville dans le pays d'Ephraïm et de Manassé et jusqu'en Zabulon; mais on riait d'eux, on se moquait d'eux."
,"11":"Quelques hommes d'Asher cependant, de Manassé et de Zabulon, firent pénitence et vinrent à Jérusalem."
,"12":"La main de Dieu était à l'oeuvre en Juda pour leur donner un seul coeur et pour exécuter l'ordre du roi et des chefs, selon la parole de Yahvé."
,"13":"Un peuple nombreux se trouva donc rassemblé à Jérusalem au second mois pour célébrer la fête des Azymes: c'était une énorme assemblée."
,"14":"Ils se mirent au travail, firent disparaître les autels à travers Jérusalem; tous les autels à encens furent jetés dans le torrent du Cédron."
,"15":"On immola la Pâque au quatorze du second mois. Tout confus, les prêtres et les lévites se purifièrent et firent avancer les holocaustes vers la Maison de Yahvé."
,"16":"Ils se tenaient à leur poste selon la règle, selon la Loi de Moïse, l'homme de Dieu; les prêtres faisaient l'aspersion avec le sang reçu de la main des lévites."
,"17":"Comme beaucoup dans l'assemblée ne s'étaient pas purifiés, les lévites étaient chargés d'immoler les victimes pascales pour tous ceux qui n'étaient pas purs, et de les consacrer à Yahvé."
,"18":"La plus grande partie du peuple, beaucoup de gens d'Ephraïm, de Manassé et de Zabulon, ne s'étaient pas purifiés: ils avaient mangé la Pâque sans se conformer à ce qui est écrit. Ezéquias pria donc pour eux: 'Que Yahvé qui est bon, pardonne"
,"19":"à tous ceux qui s'appliquent à rechercher Yahvé, le Dieu de leurs pères, même s'ils n'ont pas la pureté nécessaire pour les rites sacrés.'"
,"20":"Yahvé écouta Ezéquias et il épargna le peuple."
,"21":"Les Israélites qui étaient à Jérusalem, célébrèrent donc la fête des Azymes durant sept jours, au milieu de la joie générale. Jour après jour les lévites et les prêtres louaient Yahvé au son puissant des instruments sacrés."
,"22":"Ezéquias sut parler au coeur de tous les lévites qui se montraient si zélés pour le culte de Yahvé. On termina la semaine de célébration en offrant des sacrifices de communion, rendant grâces à Yahvé, le Dieu des pères."
,"23":"Alors toute l'assemblée décida d'un commun accord de célébrer encore sept autres jours: on les fêta dans la joie,"
,"24":"car Ezéquias, roi de Juda, avait prélevé pour l'assemblée mille taureaux et sept mille moutons; de leur côté les chefs avaient prélevé mille taureaux et dix mille moutons. Cette fois les prêtres s'étaient purifiés en grand nombre."
,"25":"Toute l'assemblée de Juda était dans la joie, et avec elle les prêtres et les lévites, et de même l'assemblée venue d'Israël, aussi bien ceux qui étaient venus d'Israël pour quelques jours, que ceux qui habitaient en Juda."
,"26":"La joie était grande à Jérusalem car, depuis les jours de Salomon fils de David, roi d'Israël, on n'avait rien vu de semblable."
,"27":"Les prêtres-lévites se levèrent et bénirent le peuple; on entendait leurs voix, leurs prières qui montaient jusqu'aux cieux, là où habite Sa Sainteté."
}`)
	CurrentBook.AddChapter(31, `{
"1":"Cette Pâque terminée, tous les Israélites qui se trouvaient là repartirent vers les villes de Juda. Ils brisèrent les pierres dressées dans tout Juda et Benjamin, mais aussi dans Ephraïm et Manassé, ils coupèrent les pieux sacrés, démolirent les Hauts-Lieux et les autels jusqu'à ce que tout fut détruit. Les Israélites retournèrent ensuite dans leurs villes, chacun chez soi."
,"2":"Ezéquias rétablit les classes de prêtres et de lévites qui alternaient dans les différents services, qu'il s'agisse des prêtres ou des lévites, pour l'holocauste, pour les sacrifices de communion, pour l'action de grâces et la louange, et pour le service des portes du Lieu Saint de Yahvé."
,"3":"Le roi préleva sur sa fortune personnelle pour offrir les holocaustes: holocauste du matin et du soir, holocauste du sabbat, des nouvelles lunes et des fêtes selon ce qui est écrit dans la Loi de Yahvé."
,"4":"Il ordonna au peuple et aux habitants de Jérusalem de verser la part qui revient aux prêtres et aux lévites, pour qu'ils puissent se consacrer à la Loi de Yahvé."
,"5":"Aussitôt cet ordre connu, les Israélites offrirent généreusement les prémices du blé, du vin nouveau, de l'huile fraîche, du miel et de tous les produits des champs: ils apportèrent des dîmes abondantes."
,"6":"Les gens d'Israël et de Juda qui habitaient les villes de Juda apportèrent eux aussi la dîme du gros et du petit bétail. On entreposa, tas après tas, la dîme des offrandes saintes consacrées à Yahvé."
,"7":"On commença à les entasser le troisième mois et on ne termina qu'au septième mois."
,"8":"Lorsque Ezéquias arriva avec les chefs pour voir tous ces dépôts, ils bénirent Yahvé et son peuple Israël."
,"9":"Ezéquias se renseigna auprès des prêtres et des lévites à propos de ces dépôts."
,"10":"Azaryas, le prêtre en chef, de la maison de Sadoq, lui répondit: 'Depuis que l'on a commencé à apporter à la Maison de Yahvé la part réservée aux lévites, nous avons eu à manger en abondance et il en est même resté, car Yahvé a béni son peuple et il reste encore tout ce tas.'"
,"11":"Ezéquias demanda d'aménager des salles dans la Maison de Yahvé et on les prépara."
,"12":"On y apportait en permanence la part prélevée, la dîme et les offrandes saintes. Le lévite Konanyas en fut chargé, avec son frère Chiméï pour l'assister."
,"13":"Yéhiel, Azaryas, Nahat, Azahel, Yérimot, Yozabad, Eliel, Yismakyas, Mahat et Bénayas, en assuraient la surveillance sous l'autorité de Konanyas et de son frère Chiméï. Le roi Ezéquias et Azaryas, le chef de la Maison de Yahvé, les contrôlaient."
,"14":"Le lévite Koré, fils de Yimna, gardien de la porte de l'Est, avait la charge des offrandes volontaires faites à Dieu. Il répartissait le prélèvement en l'honneur de Yahvé et les offrandes saintes."
,"15":"Il avait sous ses ordres Eden, Minyamin, Yéchoua, Chémayas, Amaryas, et Chékanyas, qui résidaient habituellement dans les villes sacerdotales. Ils assuraient les distributions à leurs frères, répartis selon leurs classes, aux grands comme aux petits."
,"16":"On enregistra aussi les hommes âgés de trente ans et plus, ceux qui montaient à la Maison de Yahvé selon le rituel de chaque jour pour y assurer leur service, quand c'était le tour de leur classe."
,"17":"On enregistra les prêtres par familles, ainsi que les lévites à partir de l'âge de vingt ans, selon leurs fonctions et leur classe."
,"18":"On les recensa avec tous ceux qui leur étaient à charge: femmes, fils et filles, en un mot, toute la famille. Ils prenaient soin de toutes les choses saintes."
,"19":"Un certain nombre de prêtres, fils d'Aaron, se trouvaient dans les campagnes comme dans les villes; on inscrivit nom par nom, ceux qui devaient distribuer les parts réservées à ces prêtres, à tous les mâles, et à tous ceux qui étaient enregistrés comme lévites."
,"20":"Voilà ce que fit Ezéquias dans tout Juda; il fit ce qui était bon, juste et droit devant Yahvé, son Dieu. Il chercha Dieu de tout son coeur et il mena à bien tout ce qu'il entreprit pour le service de la Maison de Dieu, pour la Loi et les commandements."
}`)
	CurrentBook.AddChapter(32, `{
"1":"Après toute cette oeuvre dans laquelle Ezéquias montra sa fidélité à la Loi, Sennakérib, roi d'Assyrie, envahit Juda. Il installa son camp face aux villes fortifiées et ordonna d'y faire des brèches."
,"2":"Lorsque Ezéquias vit que Sennakérib arrivait avec l'intention d'attaquer Jérusalem,"
,"3":"il décida avec ses officiers et ses conseillers de boucher les sources qui étaient à l'extérieur de la ville: ils lui apportèrent leur aide."
,"4":"Une foule nombreuse se rassembla pour boucher toutes les sources ainsi que tous les ruisseaux qui arrosaient les jardins: 'Pourquoi, disait-on, les rois d'Assyrie trouveraient-ils de l'eau en abondance à leur arrivée?'"
,"5":"Ezéquias prit courageusement les choses en mains. Il releva tout le rempart qui était dégradé, il éleva des tours, une seconde muraille à l'extérieur, et il fortifia le Millo de la Cité de David. Il fit fabriquer beaucoup de lances et de boucliers."
,"6":"Il établit des chefs de guerre à la tête du peuple et les rassembla autour de lui, sur la place devant la porte de la ville. Alors il leur parla franchement:"
,"7":"'Soyez forts et courageux! Ne craignez pas et ne tremblez pas devant le roi d'Assyrie et toute l'armée qu'il amène, car il y a plus avec nous qu'il n'y a avec lui."
,"8":"Il a pour lui la puissance des hommes, mais nous avons, nous, Yahvé notre Dieu, qui est notre secours et qui combat nos combats!' Ces paroles d'Ezéquias roi de Juda raffermirent le peuple."
,"9":"C'est alors que Sennakérib, roi d'Assyrie, qui se trouvait personnellement à Lakish avec son armée, envoya de ses hommes à Jérusalem auprès d'Ezéquias, roi de Juda, et de tous les Judéens qui habitaient à Jérusalem."
,"10":"Ils leur transmirent ce message de Sennakérib, roi d'Assyrie: En qui mettez-vous votre confiance pour soutenir le siège dans Jérusalem?"
,"11":"Ne voyez-vous pas qu'Ezéquias va vous faire mourir de faim et de soif? Il vous trompe quand il vous dit: Yahvé notre Dieu nous délivrera de la main du roi d'Assyrie."
,"12":"C'est bien Ezéquias qui a fait disparaître les autels et les Hauts-Lieux de Yahvé et qui a dit aux gens de Juda et de Jérusalem: Vous n'aurez que cet autel pour vous prosterner devant lui et y faire fumer votre encens!"
,"13":"Ne savez-vous pas ce que nous avons fait, moi et mes pères, à tous les peuples des nations? Les dieux des nations ont-ils été capables de délivrer leurs pays de ma main?"
,"14":"Parmi tous les dieux de ces nations que mes pères ont vouées à l'anathème, y en a-t-il eu un seul pour délivrer son peuple de ma main? Et vous croyez que votre dieu pourra vous délivrer de ma main?"
,"15":"Maintenant donc, qu'Ezéquias arrête de vous tromper! Qu'il cesse de vous aveugler! Ne le croyez pas: aucun dieu dans aucun pays ou royaume n'a pu délivrer son peuple de ma main, ni de la main de mes pères; moins encore votre dieu pourra-t-il vous délivrer de ma main!'"
,"16":"Les envoyés de Sennakérib parlaient encore contre Yahvé Dieu et contre son serviteur Ezéquias,"
,"17":"lorsque Sennakérib lui-même, écrivit une lettre pour insulter Yahvé, Dieu d'Israël, et pour parler contre lui: 'De même que les dieux des nations, écrivait-il, n'ont pu délivrer leur peuple de ma main, de même le dieu d'Ezéquias ne délivrera pas son peuple de ma main.'"
,"18":"Les envoyés crièrent d'une voix forte, en Judéen, aux habitants de Jérusalem qui étaient sur le rempart, pour les effrayer, les terroriser et pouvoir ainsi prendre la ville."
,"19":"Mais ils parlaient du Dieu de Jérusalem comme d'un dieu quelconque des peuples de la terre, qui ne sont en fait que l'oeuvre des hommes."
,"20":"Durant ce temps le roi Ezéquias et le prophète Isaïe, fils d'Amos, étaient en prière et criaient vers le Ciel."
,"21":"Alors Yahvé envoya un ange qui extermina tous les brillants guerriers, les princes et les chefs dans le camp du roi d'Assyrie. Celui-ci, couvert de honte, retourna dans son pays, et comme il entrait dans la Maison de son dieu, ses fils, ceux-là mêmes à qui il avait donné le jour, l'assassinèrent à coups d'épée."
,"22":"Yahvé sauva ainsi Ezéquias et les habitants de Jérusalem, de la main de Sennakérib roi d'Assyrie, et de la main de tous leurs ennemis; ils eurent la paix sur toutes leurs frontières."
,"23":"Beaucoup de gens apportèrent à Jérusalem des offrandes à Yahvé et des cadeaux à Ezéquias, roi de Juda: son prestige en sortit très renforcé aux yeux de tous les peuples."
,"24":"En ces jours-là, Ezéquias tomba malade et fut près de mourir. Il adressa une prière à Yahvé qui lui dit une parole et lui fit voir un prodige."
,"25":"Mais Ezéquias ne répondit pas aux bienfaits qu'il avait reçus, il était devenu orgueilleux, aussi la colère de Dieu se fit-elle menaçante sur lui, sur Juda et sur Jérusalem."
,"26":"Ezéquias pourtant s'humilia après ce péché d'orgueil, et les habitants de Jérusalem firent de même; c'est pourquoi la colère de Yahvé ne s'abattit pas sur eux durant le temps d'Ezéquias."
,"27":"Ezéquias eut plus que son compte de richesses de gloire, il accumula des trésors d'argent, d'or, de pierres précieuses, de parfums, de boucliers et de toutes sortes d'objets précieux."
,"28":"Il fit des magasins pour entreposer son blé, son vin et son huile fraîche, des étables pour toute espèce de bétail et des parcs pour ses troupeaux."
,"29":"Il construisit des villes, il acquit de nombreux troupeaux de gros et de petit bétail, car Dieu lui avait donné une très grande fortune."
,"30":"C'est Ezéquias qui ferma l'entrée supérieure de la source de Gihon et en dirigea les eaux vers le bas de la Cité de David, à l'ouest. Ezéquias mena à bien tous ses travaux."
,"31":"Lorsque les envoyés des princes de Babylone arrivèrent près de lui pour faire une enquête sur le prodige qui avait eu lieu dans le pays, Dieu l'abandonna un moment pour le mettre à l'épreuve et pour voir ce qu'il avait dans le coeur."
,"32":"Le reste des actes d'Ezéquias, les témoignages de sa fidélité, sont écrits dans les visions du prophète Isaïe fils d'Amos et dans le Livre des Rois de Juda et d'Israël."
,"33":"Ezéquias se coucha avec ses pères et on l'enterra dans la montée des tombes des fils de David. A sa mort les Judéens et les habitants de Jérusalem lui rendirent hommage. Son fils Manassé régna à sa place."
}`)
	CurrentBook.AddChapter(33, `{
"1":"Manassé avait douze ans quand il monta sur le trône, et il régna cinquante-cinq ans à Jérusalem."
,"2":"Il fit ce qui est mal au regard de Yahvé, suivant les pratiques honteuses des nations que Yahvé avait dépossédées devant les Israélites."
,"3":"Il rebâtit les Hauts-Lieux que son père Ezéquias avait détruits, il éleva des autels aux Baals, il dressa des pieux sacrés, il se prosterna devant toute l'Armée des cieux et les servit."
,"4":"Il construisit des autels dans la Maison dont Yahvé lui-même avait dit: 'Mon Nom sera pour toujours à Jérusalem.'"
,"5":"Il construisit des autels pour toute l'Armée des cieux dans les deux cours de la Maison de Yahvé."
,"6":"Il sacrifia ses fils par le feu dans la vallée de Ben-Hinnom. Il pratiqua l'astrologie, la divination, la sorcellerie, il eut recours à ceux qui évoquent les morts et aux devins. Que de fois n'a-t-il pas provoqué la colère de Dieu en faisant le mal sous son regard!"
,"7":"Il avait fait une statue de monstre sacré, il la plaça dans ce Temple dont Dieu lui-même avait dit à David et à son fils Salomon: 'Je mettrai mon Nom pour toujours dans ce Temple, dans Jérusalem que j'ai choisie parmi toutes les tribus d'Israël."
,"8":"Si Israël veille à observer tout ce que je lui ai commandé selon toute la Loi, les ordonnances et les règles données par Moïse, je ne conduirai plus ses pas loin du pays que j'ai donné à leurs pères.'"
,"9":"Mais Manassé égara Juda et les habitants de Jérusalem; il les amena à pratiquer le mal comme les nations que Yahvé avait anéanties devant les Israélites."
,"10":"Yahvé parla bien à Manassé et à son peuple, mais ils n'y prêtèrent aucune attention."
,"11":"Yahvé envoya contre eux les chefs de l'armée du roi d'Assyrie. Ils immobilisèrent Manassé avec des crocs, ils le lièrent avec une double chaîne de bronze et l'emmenèrent à Babylone."
,"12":"Du fond de sa misère, il attendrit Yahvé son Dieu, il s'humilia sincèrement devant le Dieu de ses pères,"
,"13":"il le pria et fut écouté. Yahvé écouta ses supplications et le ramena à Jérusalem dans son royaume, et Manassé reconnut que seul Yahvé est Dieu."
,"14":"Après cela il reconstruisit la muraille extérieure de la Cité de David, à l'ouest de Gihon, dans le ravin. Ce rempart faisait le tour de l'Ophel et atteignait l'entrée de la porte des Poissons, Manassé le suréleva beaucoup. Il plaça des chefs de guerre dans toutes les villes fortifiées de Juda."
,"15":"Il fit disparaître de la Maison de Yahvé les dieux étrangers et l'idole du monstre sacré, il enleva tous les autels qu'il avait construits sur la montagne de la Maison de Yahvé ou dans Jérusalem: il fit tout jeter hors de la ville."
,"16":"Il restaura l'autel de Yahvé, il y offrit des sacrifices de communion et d'actions de grâces et il donna ordre aux Judéens de servir Yahvé, Dieu d'Israël."
,"17":"Le peuple continua bien d'offrir des sacrifices sur les Hauts-Lieux, mais seulement en l'honneur de Yahvé son Dieu."
,"18":"Le reste des actes de Manassé, sa prière à Dieu, les paroles des voyants qui lui parlèrent au nom de Yahvé, Dieu d'Israël, se trouvent dans les actes des rois d'Israël."
,"19":"Sa prière et comment il fut exaucé, tout son péché et toute son infidélité, les endroits où il éleva des Hauts-Lieux, des pieux sacrés et des idoles avant de s'humilier, cela est écrit dans les actes de Hozaï."
,"20":"Manassé se coucha avec ses pères et on l'enterra dans le jardin de son palais. Son fils Amon régna à sa place."
,"21":"Amon avait vingt-deux ans lorsqu'il monta sur le trône, il régna deux ans à Jérusalem."
,"22":"Il fit ce qui est mal au regard de Yahvé, comme l'avait fait son père Manassé. Amon offrit des sacrifices à toutes les idoles qu'avait faites son père Manassé, il les servit."
,"23":"Mais, contrairement à son père Manassé, il ne s'humilia pas devant Yahvé: il accumula les fautes."
,"24":"Ses serviteurs conspirèrent contre lui et l'assassinèrent dans son palais."
,"25":"Mais le-peuple-du-pays mit à mort tous ceux qui avaient conspiré contre le roi Amon; on établit son fils Josias comme roi à sa place."
}`)
	CurrentBook.AddChapter(34, `{
"1":"Josias avait huit ans quand il monta sur le trône, il régna trente et un ans à Jérusalem."
,"2":"Il fit ce qui est juste au regard de Yahvé et suivit les traces de David son ancêtre: il ne s'en écarta ni à droite, ni à gauche."
,"3":"La huitième année de son règne, quand il était encore jeune, il commença à rechercher le Dieu de David, son ancêtre, et la douzième année il commença à purifier Juda et Jérusalem des Hauts-Lieux, des pieux sacrés et des idoles de bois ou de bronze."
,"4":"On détruisit en sa présence les autels des Baals et les autels à parfum placés dessus. Il brisa les pieux sacrés et les statues de bois et de bronze, et les réduisit en poussière qu'il jeta sur les tombes de ceux qui leur avaient offert des sacrifices."
,"5":"Il brûla les ossements des prêtres sur leurs autels et purifia ainsi Juda et Jérusalem."
,"6":"Dans les villes de Manassé, d'Ephraïm, de Siméon, et jusqu'en Nephtali, même dans les villes en ruines,"
,"7":"il abattit les autels, les pieux sacrés et les statues de bois; il les fit marteler et réduire en poussière. Il renversa tous les autels à parfum dans tout les pays, après quoi il rentra à Jérusalem."
,"8":"En la dix-huitième année de son règne, il envoya Chafan, fils d'Asalyas, Maaséyas gouverneur de la ville, et Yoah fils de Yoahaz l'archiviste, pour purifier le pays et la Maison et pour réparer la Maison de Yahvé son Dieu."
,"9":"Ils allèrent trouver Hilkiyas le grand prêtre et lui donnèrent l'argent qu'on avait apporté à la Maison de Dieu: les lévites, gardiens de la Porte, l'avaient reçu de Manassé, d'Ephraïm, des autres tribus d'Israël, de tout Juda, de Benjamin, et des habitants de Jérusalem."
,"10":"On le confia à ceux qui s'occupaient des travaux et qui étaient chargés de la Maison de Yahvé, ils le donnèrent aux ouvriers qui faisaient le travail nécessaire pour reconstruire ou réparer la Maison de Yahvé."
,"11":"On le donna aux charpentiers et aux maçons, on acheta des pierres de taille et des bois pour le chaînage et la charpente des bâtiments qu'avaient détruits les rois de Juda."
,"12":"Ces hommes travaillaient là en permanence et voici ceux qui avaient autorité sur eux: Yahat et Obadyas, lévites du clan de Mérari, Zékaryas et Méchoulam, contremaîtres du clan de Kahat, les lévites experts en instruments de musique,"
,"13":"les responsables des porteurs, les chefs des différents corps de métier, et enfin quelques lévites secrétaires, greffiers et portiers."
,"14":"Donc, lorsqu'on vint prendre l'argent qui avait été offert à la Maison de Yahvé, il se trouva que le prêtre Hilkiyas avait trouvé le livre de la Loi de Yahvé donnée par Moïse."
,"15":"Hilkiyas prit la parole et dit au secrétaire Chafan: 'J'ai trouvé le livre de la Loi dans la Maison de Yahvé.' Et Hilkiyas remit le livre à Chafan."
,"16":"Chafan porta le livre au roi et lui fit ce rapport: 'Tes serviteurs font bien le travail qu'on leur a confié."
,"17":"Ils ont versé l'argent qui se trouvait dans la Maison de Yahvé et ils l'ont remis aux responsables et aux ouvriers.'"
,"18":"Puis, s'adressant au roi, le secrétaire Chafan ajouta: 'Le prêtre Hilkiyas m'a remis ce livre.' Et Chafan le lut devant le roi."
,"19":"En entendant les paroles de la Loi, le roi déchira ses habits,"
,"20":"puis il donna cet ordre à Hilkiyas, à Ahikam fils de Chafan, à Abdon fils de Mika, au secrétaire Chafan et au ministre du roi, Asaya:"
,"21":"'Allez consulter Yahvé pour moi, pour ce qui reste d'Israël et de Juda, à propos des paroles du livre que l'on a trouvé. Grande doit-être la colère de Yahvé contre nous, car nos pères n'ont pas obéi à la parole de Yahvé et n'ont rien fait de ce qui est écrit dans ce livre.'"
,"22":"Alors Hilkiyas et les hommes du roi allèrent trouver la prophétesse Houlda femme de Challoum, fils de Tokat, fils de Hasra, le gardien des vêtements; elle habitait à Jérusalem dans le nouveau quartier. Ils lui exposèrent les faits,"
,"23":"et elle leur répondit: 'Voici ce que dit Yahvé, Dieu d'Israël: vous direz à l'homme qui vous a envoyés chez moi:"
,"24":"Ainsi parle Yahvé: Sur ce lieu et sur ses habitants je fais venir un malheur, toutes les malédictions écrites dans le livre qu'on a lu devant le roi de Juda."
,"25":"Car ils m'ont abandonné, ils ont offert de l'encens à d'autres dieux et ils ont provoqué ma colère par tout ce qu'ils ont fait; ma colère s'est répandue sur ce lieu et elle ne s'éteindra pas."
,"26":"Vous direz encore au roi de Juda qui vous envoie consulter Yahvé: Voici ce que dit Yahvé Dieu d'Israël: Tu as prêté l'oreille à ces paroles,"
,"27":"moi aussi je t'ai entendu - parole de Yahvé. Tu as été bouleversé, tu t'es humilié devant Dieu en entendant les paroles de ce livre contre ce lieu et contre ses habitants. Tu t'es humilié devant moi, tu as déchiré tes habits et tu as pleuré devant moi."
,"28":"Voilà pourquoi je te réunirai à tes pères et tu reposeras en paix dans ta tombe. Tes yeux ne verront pas le malheur que je fais venir sur ce lieu et sur ses habitants.' Ils rapportèrent au roi cette réponse."
,"29":"Le roi envoya chercher tous les anciens de Juda et de Jérusalem."
,"30":"Avec tous les hommes de Juda et tous les habitants de Jérusalem, avec les prêtres et les lévites, avec tout le peuple du plus grand au plus petit, le roi monta à la Maison de Yahvé. Devant eux il fit la lecture de toutes les paroles du livre de l'alliance qu'on avait trouvé dans la Maison de Yahvé."
,"31":"Debout sur son estrade, le roi conclut l'alliance en présence de Yahvé: on s'engageait à marcher à la suite de Yahvé, à observer ses commandements, ses ordonnances et ses préceptes, de tout son coeur et de toute son âme, à mettre en pratique les paroles de l'alliance écrites dans ce livre."
,"32":"Il demanda instamment à tous ceux qui étaient à Jérusalem et en Benjamin de s'engager dans l'alliance de Dieu, le Dieu de leurs pères."
,"33":"Josias enleva toutes les Ordures, de quelque pays que ce soit, qui étaient aux mains des Israélites, il obligea tous ceux qui étaient en Israël à servir Yahvé leur Dieu, et tant qu'il vécut, ils ne s'écartèrent plus de Yahvé, le Dieu de leurs pères."
}`)
	CurrentBook.AddChapter(35, `{
"1":"Josias célébra à Jérusalem une Pâque en l'honneur de Yahvé: on immola la Pâque le quatorzième jour du premier mois."
,"2":"Il fixa aux prêtres leurs fonctions et leur confia le service de la Maison de Yahvé."
,"3":"Puis le roi dit aux lévites qui enseignent tout Israël et qui sont consacrés au service de Yahvé: 'Puisque l'Arche Sainte repose dans la Maison que Salomon fils de David, roi d'Israël, a construit, vous n'avez plus à la porte: servez donc Yahvé votre Dieu et son peuple Israël."
,"4":"Organisez-vous par familles, d'après vos classes, selon l'écrit de David, roi d'Israël, et le décret de Salomon, son fils."
,"5":"Tenez-vous dans le Lieu saint selon la distribution de vos familles pour le service de vos frères, les hommes du peuple, et selon la répartition des lévites par familles."
,"6":"Vous allez immoler la Pâque, purifiez-vous donc et faites les préparatifs pour vos frères, selon la parole de Yahvé que Moïse nous a donnée.'"
,"7":"Josias donna pour les hommes du peuple du petit bétail, agneaux et chevreaux, de quoi fournir la victime pascale à tous ceux qui se trouvaient là; ils étaient trente mille. Il préleva en outre trois mille têtes de gros bétail provenant des propriétés royales."
,"8":"Ses chefs avaient également fait un don pour le peuple. Les prêtres et les lévites: Hilkiyas, Zékaryas et Yéhiel, chefs de la Maison de Dieu, donnèrent aux prêtres deux mille six cents têtes de petit bétail et trois cents boeufs comme victimes pascales."
,"9":"Les chefs des lévites, Konanyas, Chémayas et son frère Nétanéel, Hochabyas, Yéhiel et Yozabad donnèrent aux lévites comme victimes pascales cinq mille têtes de petit bétail et cinq cents boeufs."
,"10":"Le service étant organisé, les prêtres et les lévites se tinrent à leur place selon leur classe, comme l'avait ordonné le roi."
,"11":"On immola la Pâque; les prêtres recevaient le sang de la main des lévites, ils le répandaient, puis les lévites écorchaient les victimes."
,"12":"On mit à part les holocaustes pour les répartir entre le peuple selon leurs clans familiaux et qu'ils les offrent à Yahvé, selon ce qui est écrit dans le livre de Moïse; on fit de même pour le gros bétail."
,"13":"D'accord avec le rituel, la Pâque fut rôtie au feu, mais on fit cuire dans des chaudrons, dans des marmites et dans des pots, les offrandes saintes que l'on porta ensuite au peuple."
,"14":"Les lévites préparèrent alors la Pâque pour eux et pour les prêtres, car les prêtres fils d'Aaron furent pris jusqu'à la nuit par l'offrande des holocaustes et des graisses. C'est pour cela que les lévites firent les préparatifs pour eux-mêmes et pour les prêtres fils d'Aaron."
,"15":"Les chantres, fils d'Asaf, se tenaient à leur place selon les ordres de David, d'Asaf, de Héman, et de Yédoutoun le voyant du roi; quant aux portiers, ils se tenaient aux diverses portes. Aucun d'entre eux n'avait de raison de quitter son service, puisque leurs frères lévites préparaient tout pour eux."
,"16":"Voilà comment on organisa ce jour-là tout le culte de Yahvé, de façon à célébrer la Pâque et présenter les holocaustes sur l'autel de Yahvé comme l'avait ordonné le roi Josias."
,"17":"Les Israélites qui se trouvaient là célébrèrent alors la Pâque et, durant les sept jours suivants, la fête des Azymes."
,"18":"Depuis le temps du prophète Samuel, jamais en Israël on n'avait célébré une Pâque comme celle-là. Aucun des rois d'Israël n'avait célébré une Pâque comme celle que fit Josias avec les prêtres, les lévites, tout Juda, les Israélites de passage et tous les habitants de Jérusalem."
,"19":"On célébra cette Pâque la dix-huitième année du règne de Josias."
,"20":"Tout cela était terminé, et Josias avait réparé le Temple, lorsque le roi d'Egypte Nékao, monta pour combattre à Karkémich, sur l'Euphrate. Josias partit à sa rencontre."
,"21":"Nékao lui envoya des messagers: 'Nous n'avons rien à voir ensemble, roi de Juda, ce n'est pas toi que je suis venu combattre. Je suis parti en guerre contre une autre maison et Dieu m'a dit de me presser. Laisse donc faire le Dieu qui est avec moi, sinon il pourrait te détruire!'"
,"22":"Mais Josias ne se détourna pas de Nékao, il était décidé à le combattre et n'écouta pas les paroles de Nékao qui sortaient de la bouche de Dieu. Il s'avança donc pour combattre dans la plaine de Méguiddo."
,"23":"Des archers tirèrent sur le roi Josias et le roi dit à ses hommes: 'Emportez-moi, je me sens très mal.'"
,"24":"Ses hommes le descendirent de son char, et l'emmenèrent sur un autre char à Jérusalem où il mourut. On l'enterra dans les tombes de ses ancêtres; tout Juda et tout Jérusalem célébrèrent le deuil de Josias."
,"25":"Jérémie composa un chant funèbre pour Josias; tous les chanteurs et chanteuses ont parlé de Josias dans leurs chants funèbres jusqu'à ce jour: c'est devenu un rite en Israël. Ils sont écrits dans le Recueil des chants funèbres."
,"26":"Le reste des actes de Josias, les témoignages de sa fidélité à ce qui est écrit dans la Loi de Yahvé,"
,"27":"en un mot, tous ses actes du premier jusqu'au dernier, cela est écrit dans le Livre des Rois d'Israël et de Juda."
}`)
	CurrentBook.AddChapter(36, `{
"1":"Le peuple du pays prit Joakaz, fils de Josias, pour le faire roi à la place de son père à Jérusalem."
,"2":"Joakaz avait vingt-trois ans quand il monta sur le trône et il régna trois mois à Jérusalem."
,"3":"Le roi d'Egypte l'écarta du trône de Jérusalem et frappa le pays d'un impôt de cent talents d'argent et d'un talent d'or."
,"4":"Puis le roi d'Egypte établit comme roi sur Juda et Jérusalem son frère Elyaqim, dont il changea le nom en Joïaqim. Quant à Joakaz, son frère, Nékao le prit et l'emmena en Egypte."
,"5":"Joïaqim avait vingt-cinq ans quand il monta sur le trône, il régna onze ans à Jérusalem. Il fit ce qui est mal au regard de Yahvé son Dieu."
,"6":"Nabukodonozor, roi de Babylone, monta contre lui et l'emmena à Babylone, enchaîné d'une double chaîne de bronze."
,"7":"Nabukodonozor emporta à Babylone une partie du mobilier de la Maison de Yahvé et le déposa dans son palais à Babylone."
,"8":"Le reste des actes de Joïaqim, ses pratiques honteuses et ce qu'elles lui valurent, cela est écrit dans le livre des rois d'Israël et de Juda. Joïakin, son fils, régna à sa place."
,"9":"Joïakin avait dix-huit ans lorsqu'il monta sur le trône, il régna trois mois et dix jours à Jérusalem. Il fit ce qui est mal au regard de Yahvé."
,"10":"Au retour de l'année, le roi Nabukodonozor le fit saisir pour l'emmener à Babylone où se trouvaient déjà les objets précieux de la Maison de Yahvé, et il établit comme roi sur Juda et Jérusalem son oncle Sédécias."
,"11":"Sédécias avait vingt et un ans quand il monta sur le trône, il régna onze ans à Jérusalem."
,"12":"Il fit ce qui est mal au regard de Yahvé et ne s'humilia pas devant Jérémie, le prophète, qui lui parlait de la part de Yahvé."
,"13":"Il se révolta même contre Nabukodonozor alors qu'il lui avait juré sur Dieu d'être fidèle. Il fit la forte tête, il durcit son coeur au lieu de revenir vers Yahvé, Dieu d'Israël."
,"14":"Tous les chefs de Juda, les prêtres et le peuple, multiplièrent eux aussi les infidélités, ils imitèrent toutes les pratiques honteuses des nations, ils souillèrent la Maison que Yahvé avait consacrée dans Jérusalem."
,"15":"Yahvé, le Dieu de leurs pères, leur envoyait des messagers sans se lasser car il voulait épargner son peuple et sa Demeure."
,"16":"Mais eux se moquaient des messagers de Dieu, ils méprisaient ses paroles et tournaient ses prophètes en ridicule, à tel point que la colère de Yahvé contre son peuple se déchaîna: cette fois ce fut irrémédiable."
,"17":"Aussi Dieu fit-il venir contre eux le roi des Kaldéens: il tua les jeunes par l'épée à l'intérieur même du Sanctuaire, il n'épargna ni l'adolescent, ni la vierge, ni l'homme mûr, ni le vieillard: Dieu les lui livra tous!"
,"18":"Il emporta à Babylone tous les objets de la Maison de Dieu, grands et petits, les trésors de la Maison de Yahvé, ceux du roi et des chefs."
,"19":"On brûla la Maison de Dieu, on abattit le rempart de Jérusalem, on livra au feu tous les palais et on détruisit tous leurs objets précieux."
,"20":"Nabukodonozor déporta à Babylone ceux que l'épée avait épargnés, ils devinrent ses esclaves et les esclaves de ses fils jusqu'à l'arrivée de l'empire Perse."
,"21":"Ainsi s'accomplissait la parole de Yahvé proclamée par Jérémie: 'La terre devra acquitter ses années de repos qui n'ont pas été respectées, elle chômera durant tout le temps où elle sera désertée, durant soixante-dix ans.'"
,"22":"La première année de Cyrus, roi de Perse, la parole de Yahvé proclamée par Jérémie s'accomplit; Yahvé éveilla l'esprit de Cyrus roi de Perse. De vive voix, mais aussi par écrit, Cyrus fit proclamer ceci dans tout son royaume:"
,"23":"'Ainsi parle Cyrus, roi de Perse: Yahvé, le Dieu des Cieux, m'a donné tous les royaumes de la terre; et voici qu'il me charge de rebâtir sa Maison à Jérusalem de Juda. Quiconque parmi vous appartient à son peuple, que Yahvé son Dieu soit avec lui, et qu'il monte!'"
}`)

}
func FR_LBDCC_LoadVH2RChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Après la mort d'Akab, Moab se révolta contre Israël."
,"2":"Okozias tomba par la fenêtre de sa chambre haute à Samarie, et comme il n'était pas bien, il envoya des hommes en leur disant: 'Allez consulter Baal-Zéboub, le dieu d'Eqron, pour savoir si je guérirai de mon mal.'"
,"3":"Mais l'ange de Yahvé dit à Elie de Tichbé: 'Lève-toi et va à la rencontre des messagers du roi de Samarie. Tu leur diras: N'y-a-t-il donc plus de Dieu en Israël? Pourquoi allez-vous consulter Baal-Zéboub, le dieu d'Eqron?"
,"4":"Puisque c'est ainsi, dit Yahvé, tu ne descendras pas du lit sur lequel tu es monté: sache que tu vas mourir.' Et Elie s'éloigna."
,"5":"Les messagers revinrent donc auprès du roi; il leur dit: 'Pourquoi êtes-vous revenus?'"
,"6":"Ils répondirent: 'Un homme est venu à notre rencontre et il nous a dit: 'Allez, retournez auprès du roi qui vous a envoyés, et redites-lui cette parole de Yahvé: N'y a-t-il donc plus de Dieu en Israël pour que tu ailles consulter Baal-Zéboub, le dieu d? C'est pourquoi tu ne descendras pas du lit sur lequel tu es monté, tu mourras, c'est décidé!'"
,"7":"Il leur dit: 'Comment était cet homme qui est venu à votre rencontre et qui vous a dit tout cela?'"
,"8":"Ils répondirent: 'Cet homme portait un vêtement de peau, il avait une ceinture de cuir autour des reins.' Okozias s'exclama: 'C'est Elie de Tichbé!'"
,"9":"Il envoya vers Elie cinquante hommes avec leur chef, qui montèrent à sa recherche; il était assis au sommet de la montagne. Le chef lui cria: 'Homme de Dieu, c'est un ordre du roi, descends!'"
,"10":"Elie répondit au chef des cinquante: 'Si je suis un homme de Dieu, que le feu du ciel descende et te dévore, toi et tes cinquante hommes!' Et le feu du ciel descendit: il le dévora, lui et ses cinquante hommes."
,"11":"De nouveau le roi envoya cinquante hommes avec un autre chef; lui aussi cria: 'Homme de Dieu, voici l'ordre du roi: Dépêche-toi de descendre!'"
,"12":"Elie répondit: 'Si je suis un homme de Dieu, que le feu du ciel descende et qu'il te dévore, toi et tes cinquante hommes!' Et le feu de Dieu descendit du ciel: il le dévora lui et ses cinquante hommes."
,"13":"Une troisième fois le roi envoya cinquante hommes avec leur chef; arrivé près d'Elie, le troisième chef se mit à genoux et le supplia, il lui dit: 'Homme de Dieu, je suis ton serviteur, que ma vie et celle de mes hommes compte un peu pour toi!"
,"14":"Le feu de Dieu est déjà descendu du ciel dévorer les deux premiers chefs avec leur cinquante hommes, épargne ma vie à présent!'"
,"15":"Alors l'ange de Yahvé dit à Elie: 'Descends avec lui, tu n'as rien à craindre de sa part.' Il se leva donc et descendit avec eux auprès du roi."
,"16":"Il lui dit: 'Voici ce que dit Yahvé: Parce que tu as envoyé des messagers pour consulter Baal-Zéboub, le dieu d'Eqron, tu ne descendras pas du lit sur lequel tu es monté. Tu mourras: c'est décidé!'"
,"17":"Okozias mourut en effet selon la parole de Yahvé qu'avait rapportée Elie. Joram, son frère, régna à sa place, car il n'avait pas de fils (c'était la deuxième année de Joram fils de Josaphat, roi de Juda)."
,"18":"Le reste des actes d'Okozias, ce qu'il a fait, tout cela n'est-il pas écrit dans le Livre des Chroniques des rois d'Israël?"
}`)
	CurrentBook.AddChapter(2, `{
"1":"Yahvé fit monter Elie au ciel dans un tourbillon: voici comment. Comme Elie sortait de Guilgal en compagnie d'Elisée,"
,"2":"Elie lui dit: 'Reste ici je te prie. Yahvé m'envoie jusqu'à Béthel.' Mais Elisée répondit: 'Aussi vrai que Yahvé est vivant et que je suis vivant, je ne te quitterai pas.' Et ils descendirent ensemble à Béthel."
,"3":"Les frères prophètes qui étaient à Béthel vinrent à la rencontre d'Elisée. Ils lui dirent: 'Sais-tu que Yahvé enlèvera aujourd'hui ton maître au-dessus de toi?' Il répondit: 'Je le sais bien, mais ne dites rien.'"
,"4":"Elie lui dit: 'Elisée, reste ici, je te prie, car Yahvé m'envoie à Jéricho.' Mais il répondit: 'Aussi vrai que Yahvé est vivant et que je suis vivant, je ne te quitterai pas.' Ils arrivèrent ainsi à Jéricho."
,"5":"Les frères prophètes qui étaient à Jéricho s'approchèrent d'Elisée: 'Sais-tu, lui dirent-ils, que Yahvé enlèvera aujourd'hui ton maître au-dessus de toi?' Il répondit: 'Je le sais, mais gardez votre calme.'"
,"6":"Elie lui dit: 'Reste ici, je te prie, car Yahvé m'envoie au Jourdain.' Il répondit: 'Aussi vrai que Yahvé est vivant et que je suis vivant, je ne te quitterai pas.' Et les deux prirent la route."
,"7":"Une cinquantaine des frères prophètes allèrent aussi, ils restèrent à distance pendant que tous les deux s'arrêtaient au bord du Jourdain."
,"8":"Alors Elie prit son manteau et le roula; il frappa les eaux avec et elles se partagèrent, de sorte que tous les deux passèrent à pied sec."
,"9":"Lorsqu'ils eurent traversé, Elie dit à Elisée: 'Que veux-tu que je fasse pour toi? Demande-le avant que je ne sois enlevé d'auprès de toi.' Elisée répondit: 'Que vienne sur moi une double part de ton esprit.'"
,"10":"Elie répondit: 'Tu demandes une chose difficile! Si tu me vois pendant que je suis enlevé d'auprès de toi, tu l'auras; sinon, cela ne sera pas.'"
,"11":"Ils parlaient tout en marchant, lorsqu'un char de feu et des chevaux de feu les séparèrent l'un de l'autre: Elie monta au ciel dans un tourbillon."
,"12":"Elisée le voyait et criait: 'Mon père! Mon père! Char d'Israël et ses cavaliers!' Puis il ne les vit plus. Il saisit alors ses vêtements et les déchira en deux parts."
,"13":"Elisée ramassa le manteau d'Elie qui était tombé près de lui et il revint. Arrivé au bord du Jourdain il s'arrêta,"
,"14":"il prit le manteau d'Elie et il en frappa les eaux. Elles ne se divisèrent pas. Alors il dit: 'Où est le Dieu d'Elie, où est-il?' Et comme il frappait les eaux, celles-ci se partagèrent en deux: Elisée traversa."
,"15":"Les frères prophètes le virent de loin et ils dirent: 'L'esprit d'Elie repose sur Elisée!' Ils vinrent à sa rencontre et se prosternèrent à terre devant lui."
,"16":"Ils lui dirent: 'Il y a bien ici parmi tes serviteurs cinquante hommes solides. Laisse-les partir à la recherche de ton maître. L'Esprit de Yahvé l'a peut-être emporté et jeté sur quelque montagne ou dans l'une des vallées.' Mais il leur répondit: 'Non! N'envoyez personne!'"
,"17":"Comme ils insistaient au point d'en être fatigants, Elisée leur dit: 'Eh bien, envoyez-les.' Ils envoyèrent donc les cinquante hommes qui cherchèrent durant trois jours sans le retrouver."
,"18":"Quand ils revinrent vers lui à Jéricho, il leur dit: 'Ne vous avais-je pas dit de ne pas y aller?'"
,"19":"Les gens de la ville dirent à Elisée: 'On est bien ici, comme le voit mon seigneur, mais les eaux sont mauvaises et les femmes du pays sont stériles.'"
,"20":"Il leur dit: 'Donnez-moi une assiette neuve et mettez du sel dedans.' Ils la lui donnèrent."
,"21":"Il se rendit à la source et jeta le sel dans l'eau, puis il dit: 'Voici ce que dit Yahvé: J'ai assaini ces eaux, il n'en sortira plus jamais ni mort ni stérilité.'"
,"22":"Et les eaux furent assainies jusqu'à ce jour, selon la parole qu'avait prononcée Elisée."
,"23":"De là, il partit pour Béthel; comme il était sur la route qui monte, de jeunes garçons sortirent de la ville et se moquèrent de lui: 'Allez le chauve, grimpe! Allez le chauve, grimpe!' disaient-ils."
,"24":"Il se retourna et, les voyant, il les maudit au nom de Yahvé: deux ourses sortirent de la forêt et déchirèrent quarante-deux de ces garçons."
,"25":"De là, il se rendit au mont Carmel puis il retourna à Samarie."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Pendant la dix-huitième année du règne de Josaphat, roi de Juda, Joram fils d'Akab devint roi d'Israël à Samarie. Il régna douze ans;"
,"2":"il fit ce qui déplaît à Yahvé, mais pas autant que son père et sa mère, car il fit disparaître la pierre que son père avait dressée en l'honneur de Baal."
,"3":"Cependant il resta attaché au péché de Jéroboam fils de Nabat, lequel avait entraîné Israël dans son péché: il ne s'en détourna pas."
,"4":"Mécha, roi de Moab, était un éleveur de troupeaux. Il livrait au roi d'Israël un tribut de cent mille agneaux et cent mille béliers avec leur laine."
,"5":"Mais à la mort d'Akab, le roi de Moab se révolta contre le roi d'Israël."
,"6":"Alors le roi Joram sortit de Samarie et passa Israël en revue;"
,"7":"il se mit en marche et envoya dire à Josaphat, roi de Juda: 'Le roi de Moab s'est révolté contre moi, viendras-tu attaquer Moab avec moi?' Josaphat répondit: 'J'irai: il en sera de moi comme de toi, de mon peuple comme de ton peuple, et de mes chevaux comme de tes chevaux.'"
,"8":"Il ajouta: 'Par quel chemin iras-tu?' Joram répondit: 'Par la route du désert d'Edom.'"
,"9":"Le roi d'Israël, le roi de Juda et le roi d'Edom se mirent en route, mais après sept jours de marche il n'y avait plus d'eau pour l'armée ni pour les bêtes."
,"10":"Alors le roi d'Israël dit: 'Ah, ah! Yahvé a donc rassemblé ces trois rois pour les livrer entre les mains de Moab!'"
,"11":"Josaphat lui demanda: 'N'y a-t-il pas ici un prophète de Yahvé par lequel nous pourrions consulter Yahvé?' L'un des serviteurs du roi d'Israël lui dit: 'Il y a ici Elisée fils de Chafat, celui qui versait l'eau sur les mains d'Elie.'"
,"12":"Josaphat dit: 'La parole de Yahvé est avec lui.',Alors le roi d'Israël, Josaphat et le roi d'Edom descendirent à sa rencontre. "
,"13":"Elisée dit au roi d'Israël: 'Qu'est-ce que j'ai à voir dans tes affaires? Va donc trouver les prophètes de ton père!' Mais le roi d'Israël insista: 'C'est Yahvé qui a fait venir ces trois rois, va-t-il maintenant les livrer entre les mains de Moab?'"
,"14":"Elisée lui dit: 'Aussi vrai que Yahvé des armées, celui que je sers, est vivant, si je n'avais pas égard à Josaphat roi de Juda, je ne te regarderais même pas, je ne te verrais pas."
,"15":"Maintenant, amenez-moi un joueur de harpe.',Pendant que le harpiste jouait, la main de Yahvé fut sur Elisée. "
,"16":"Il dit alors: 'Ainsi parle Yahvé: Creusez des fosses et des fosses dans cette vallée!"
,"17":"Car voici ce que dit Yahvé: Vous ne verrez pas de vent, vous ne verrez pas de pluie, et cependant la vallée se remplira d'eau. Alors vous boirez, vous, vos troupeaux et vos bêtes de somme."
,"18":"Mais tout cela est peu de chose aux yeux de Yahvé, il veut encore livrer Moab entre vos mains."
,"19":"Vous frapperez toutes les villes fortifiées, vous abattrez tous les arbres fruitiers, vous boucherez toutes les sources d'eau et vous dévasterez tous les meilleurs champs en y jetant des pierres.'"
,"20":"De fait, au matin, à l'heure où l'on présente le sacrifice, voici que l'eau arriva par le chemin d'Edom et la terre se remplit d'eau."
,"21":"Tous les Moabites avaient appris que les rois s'avançaient pour les attaquer; tous les hommes capables de porter les armes furent donc rassemblés et ils se postèrent sur la frontière."
,"22":"Ils s'étaient levés de bon matin, et lorsque le soleil brilla au-dessus des eaux, les Moabites virent les eaux en face d'eux rouges comme du sang."
,"23":"Ils se dirent: 'C'est du sang! Les rois se sont battus, ils se sont frappés les uns les autres! Maintenant Moabites, au pillage!'"
,"24":"Ils s'avancèrent donc vers le camp d'Israël, mais les Israélites se levèrent et frappèrent Moab qui prit la fuite devant eux; ils pénétrèrent dans le pays de Moab et le dévastèrent."
,"25":"Ils détruisirent les villes: chacun jetait sa pierre dans les meilleurs champs, au point qu'ils en étaient remplis. Ils bouchèrent toutes les sources et abattirent tous les arbres fruitiers, si bien qu'il ne resta rien à Qir-Hérès sinon ses pierres. Les frondeurs qui l'avaient encerclée la harcelèrent."
,"26":"Lorsqu'il vit que la bataille tournait mal pour lui, le roi de Moab prit sept cents hommes armés d'épées pour faire une percée en direction du roi d'Edom; mais il ne réussit pas."
,"27":"Alors il prit son fils aîné, celui qui devait régner à sa place et il l'offrit en holocauste sur la muraille. A la suite de cela, les Israélites eurent de grosses difficultés, ils s'éloignèrent de lui et regagnèrent leur pays."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Une des femmes des frères prophètes fit appel à Elisée: 'Ton serviteur, mon mari, est mort, dit-elle, et tu sais que ton serviteur craignait Yahvé. Or un homme à qui nous devions de l'argent est venu prendre mes deux fils pour en faire ses esclaves.'"
,"2":"Elisée lui dit: 'Que puis-je faire pour toi? Dis-moi, qu'as-tu à la maison?' Elle répondit: 'Ta servante n'a rien du tout à la maison, sauf une petite cruche d'huile.'"
,"3":"Il lui dit: 'Va demander à tous tes voisins des cruches, des cruches vides, et pas seulement quelques-unes."
,"4":"Lorsque tu seras de retour, tu fermeras la porte sur toi et tes fils, tu verseras de ton huile dans toutes ces cruches, et à mesure qu'elles seront pleines, tu les mettras de côté.'"
,"5":"Alors elle s'en alla, elle ferma la porte sur elle et sur ses fils; ils approchaient les cruches et elle les remplissait."
,"6":"Lorsque les cruches furent remplies, elle dit à son fils: 'Apportes-en encore une.' Mais il lui répondit: 'Il n'y en a plus.' Et l'huile s'arrêta de couler."
,"7":"Elle alla rapporter tout cela à l'homme de Dieu; il lui dit: 'Va vendre l'huile et paie ta dette; ce qui restera te permettra de vivre avec tes fils.'"
,"8":"Un jour Elisée passait à Sunem. Il y avait là une femme aisée qui insista pour qu'il reste à manger, et dès lors, chaque fois qu'il passait par là, il s'arrêtait chez elle."
,"9":"Elle dit à son mari: 'J'ai appris que cet homme qui passe souvent chez nous est un saint homme de Dieu;"
,"10":"nous allons construire sur la terrasse une petite chambre et nous y mettrons pour lui un lit, une table, une chaise et une lampe. Et lorsqu'il passera chez nous, il pourra s'y retirer.'"
,"11":"Ainsi, un jour qu'il était de passage, il se retira dans la chambre haute et s'étendit."
,"12":"Il dit à son serviteur Guéhazi: 'Appelle cette bonne Sunamite! Lorsque tu l'auras appelée et qu'elle sera près de toi,"
,"13":"tu lui diras: Tu te donnes beaucoup de mal pour nous, que pouvons-nous faire pour toi? Veux-tu que nous disions pour toi un mot au roi ou au chef de l'armée?' Mais elle répondit: 'Je suis bien au milieu de mon clan.'"
,"14":"Elisée revint un jour sur le même sujet: 'Alors, que peut-on faire pour elle?' Guéhazi répondit: 'Elle n'a pas de fils et son mari est vieux.'"
,"15":"Elisée dit: 'Ap pelle-la moi!' Le serviteur l'appela et elle vint à l'entrée de la chambre."
,"16":"Elisée lui dit alors: 'A cette même époque l'an prochain, tu caresseras un fils.' Elle répondit: 'Non, mon seigneur, tu es un homme de Dieu; ne mens pas à ta servante!'"
,"17":"Or la femme conçut et, l'année suivante à la même époque, elle eut un fils comme Elisée l'avait annoncé."
,"18":"L'enfant grandit. Un jour qu'il était allé trouver son père auprès des moissonneurs,"
,"19":"il dit à son père: 'Ma tête! Ma tête!' Le père dit au serviteur: 'Porte-le vite à sa mère!'"
,"20":"Le serviteur l'emporta et le donna à sa mère; l'enfant resta assis sur ses genoux, puis à midi il mourut."
,"21":"Alors elle monta le coucher sur le lit de l'homme de Dieu, puis elle ferma la porte et sortit."
,"22":"Elle appela son mari et lui dit: 'Envoie-moi donc un des garçons avec une ânesse. Je vais courir chez l'homme de Dieu et ensuite je reviendrai.'"
,"23":"Il lui demanda: 'Pourquoi veux-tu aller vers lui aujourd'hui? Ce n'est pas un jour de nouvelle lune ni un sabbat.' Elle lui répondit: 'Ne t'inquiète pas.'"
,"24":"Elle sella donc l'ânesse et dit au serviteur: 'Allons, conduis-moi et ne m'arrête pas en chemin sauf si je te le demande.'"
,"25":"Elle partit donc et se rendit vers l'homme de Dieu, sur le mont Carmel. Lorsque l'homme de Dieu l'aperçut de loin, il dit à Guéhazi, son serviteur: 'Voici la Sunamite. "
,"26":"Cours donc à sa rencontre et demande-lui: Tout va-t-il bien? Ton mari se porte-t-il bien? Et l'enfant?' Elle répondit: 'Oui, bien.'"
,"27":"Mais dès qu'elle fut arrivée auprès de l'homme de Dieu sur la montagne, elle lui étreignit les pieds. Guéhazi s'approcha pour la repousser, mais l'homme de Dieu lui dit: 'Laisse-la! Son coeur est rempli de tristesse, Yahvé me l'a caché et ne m'a rien fait connaître.'"
,"28":"Alors elle dit: 'Est-ce moi qui avais demandé un fils à mon seigneur? Je t'avais bien dit: Ne me mens pas!'"
,"29":"Elisée dit à Guéhazi: 'Mets ta ceinture, prends mon bâton et va! Si tu rencontres quelqu'un, ne t'arrête pas pour le saluer, et si quelqu'un te salue, ne lui réponds pas. Tu mettras mon bâton sur le visage de l'enfant.'"
,"30":"Mais la mère de l'enfant lui dit: 'Par la vie de Yahvé et par ta propre vie, je ne te quitterai pas.' Alors il se leva et la suivit."
,"31":"Guéhazi avait pris de l'avance; il posa le bâton sur le visage de l'enfant, mais il n'y eut ni voix ni réponse. Il revint donc vers Elisée et lui fit savoir: 'L'enfant ne s'est pas réveillé.'"
,"32":"Elisée entra dans la maison; l'enfant était là, mort, couché sur son lit."
,"33":"Il entra et ferma la porte sur eux deux, puis il pria Yahvé."
,"34":"Il se coucha ensuite sur l'enfant, il mit sa bouche sur sa bouche, ses yeux sur ses yeux, ses mains sur ses mains; il resta là penché sur lui et la chair de l'enfant se réchauffa."
,"35":"Puis il redescendit dans la maison et fit quelques pas de long en large, il remonta et se pencha de nouveau sur l'enfant. Il fit ainsi sept fois. Alors l'enfant remua et il ouvrit les yeux."
,"36":"Elisée appela Guéhazi; il lui dit: 'Fais venir cette Sunamite.' Il l'appela et elle monta vers lui; il lui dit: 'Emporte ton fils.'"
,"37":"Elle tomba à ses pieds et se prosterna à terre, puis elle prit son fils et sortit."
,"38":"Elisée revint à Guilgal, il y avait la famine dans le pays. Comme les frères prophètes étaient assis avec lui, il dit à son serviteur: 'Prépare le grand chaudron et fais cuire un potage pour les frères prophètes.'"
,"39":"L'un d'entre eux sortit dans la campagne pour ramasser des herbes, il trouva une sorte de vigne sauvage, il y cueillit des coloquintes et en remplit son vêtement. De retour, il les coupa en morceaux dans le pot où l'on préparait le potage, mais personne ne savait ce que c'était."
,"40":"On en versa à tous ces hommes pour leur repas, mais dès qu'ils eurent goûté, ils se mirent à crier: 'Homme de Dieu, la mort est dans le chaudron!' Et ils étaient incapables d'en manger."
,"41":"Il leur dit: 'Trouvez-moi de la farine.' Il la jeta dans le chaudron, puis il ajouta: 'Verse du potage à ces hommes et qu'ils mangent.' Il n'y avait plus rien de mauvais dans le chaudron."
,"42":"Un homme arriva de Baal-Chalicha; dans son sac il apportait du pain à l'homme de Dieu: vingt pains d'orge et de blé que l'on avait faits avec la farine de la nouvelle récolte. Elisée lui dit: 'Donne à ces hommes pour qu'ils mangent.'"
,"43":"Mais son serviteur lui dit: 'Je ne vais tout de même pas servir cela pour cent personnes.' Il reprit: 'Donne à ces gens et qu'ils mangent, car voici ce que dit Yahvé: On en mangera et il en restera.'"
,"44":"Il les servit donc, ils en mangèrent et laissèrent des restes comme Yahvé l'avait dit."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Naaman était le général de l'armée du roi d'Aram. C'était un homme très estimé de son maître; il était son favori car c'est par lui que Yahvé avait donné la victoire aux Araméens. Mais cet homme de valeur était lépreux."
,"2":"Or, au cours d'une sortie, les Araméens avaient ramené du pays d'Israël une adolescente qui entra au service de la femme de Naaman."
,"3":"Elle dit à sa maîtresse: 'Ah! Si mon maître allait trouver le prophète qui est à Samarie, il le délivrerait de sa lèpre.'"
,"4":"Naaman informa son maître, il lui dit: 'Voici ce qu'a dit cette jeune fille qui vient du pays d'Israël.'"
,"5":"Le roi d'Aram lui dit: 'Va, pars! Je vais te donner une lettre pour le roi d'Israël.' Il se mit donc en route, prit avec lui dix talents d'argent, six mille pièces d'or et dix habits de rechange."
,"6":"Il fit remettre au roi d'Israël la lettre dans laquelle il était écrit: 'Avec cette lettre, je t'envoie mon serviteur Naaman pour que tu le délivres de sa lèpre.'"
,"7":"A la lecture de la lettre, le roi d'Israël déchira ses habits et dit: 'Suis-je donc comme Dieu pour faire mourir ou revivre? Celui-là me fait demander d'enlever à quelqu'un sa lèpre! Regardez et dites-moi si ce n'est pas simplement pour me chercher querelle.'"
,"8":"Elisée, l'homme de Dieu, apprit que le roi d'Israël avait déchiré ses vêtements; il envoya dire au roi: 'Pourquoi as-tu déchiré tes vêtements? Qu'il vienne vers moi et il saura qu'il y a un prophète en Israël!'"
,"9":"Naaman vint donc avec ses chevaux et son char et se tint à la porte de la maison d'Elisée."
,"10":"Elisée lui fit dire par un messager: 'Va te baigner sept fois dans le Jourdain, ta chair redeviendra comme auparavant et tu seras guéri.'"
,"11":"Naaman se mit en colère et s'en alla; il disait: 'Je pensais qu'il allait sortir en personne, qu'il invoquerait le nom de Yahvé son Dieu, qu'il frotterait de sa main l'endroit malade et me délivrerait de la lèpre."
,"12":"Les fleuves de Damas, l'Abana et le Parpar, ne sont-ils pas meilleurs que toutes les eaux d'Israël? Il me suffirait donc de m'y laver pour guérir!',Très en colère il fit demi-tour pour s'en aller. "
,"13":"Alors ses serviteurs s'approchèrent et lui dirent: 'Mon père, si le prophète t'avait demandé quelque chose de difficile, tu l'aurais fait? Pourquoi ne le fais-tu pas quand il te dit seulement: Lave-toi et tu seras guéri!.'"
,"14":"Il descendit donc et se plongea dans le Jourdain: sept fois, comme l'avait dit l'homme de Dieu. Et puis sa chair redevint comme la chair d'un petit enfant: il était guéri!"
,"15":"Alors il retourna chez l'homme de Dieu avec tous ses compagnons, il entra et se présenta devant lui: 'Maintenant, dit-il, je sais qu'il n'y pas de Dieu sur toute la terre, sauf en Israël. Accepte donc ce présent de la part de ton serviteur.'"
,"16":"Elisée lui répondit: 'Par la vie de Yahvé que je sers, je n'accepterai rien.' L'autre insista pour qu'il accepte, mais il refusa."
,"17":"Alors Naaman lui dit: 'Bien! Mais j'aimerais au moins qu'on donne à ton serviteur de la terre, de quoi charger une paire de mulets, car désormais ton serviteur n'offrira plus de sacrifices ni d'holocaustes à d'autres dieux qu'à Yahvé."
,"18":"Cependant, que Yahvé pardonne ceci à ton serviteur: Lorsque mon maître entre dans le temple de Rimmon pour s'y prosterner, il s'appuie sur mon bras et je me prosterne avec lui dans le temple de Rimmon. Que Yahvé daigne donc pardonner cela à ton serviteur.'"
,"19":"Elisée lui dit: 'Va en paix!',Il était déjà assez loin, "
,"20":"lorsque Guéhazi, le serviteur d'Elisée, se dit en lui même: 'Mon maître a été trop discret envers cet Araméen. Penser qu'il n'a rien accepté de ce que Naaman avait apporté! Par la vie de Yahvé, si je peux le rattraper, j'en tirerai quelque chose.'"
,"21":"Guéhazi se mit donc à la poursuite de Naaman, et Naaman l'aperçut qui courait derrière lui. Il sauta de son char et lui dit: 'Tout va-t-il bien?'"
,"22":"Guéhazi répondit: 'Tout va bien, mais mon maître m'a envoyé pour te dire: A l'instant, deux jeunes gens de la montagne d'Ephraïm, des frères prophètes, viennent d'arriver chez moi. Pourrais-tu me donner pour eux un talent d'argent et deux habits de rechange.'"
,"23":"Naaman insista: 'Accepte donc deux talents.' Il le força d'accepter et serra deux talents d'argent dans deux sacs avec les deux habits de rechange, puis il les confia à deux de ses serviteurs pour qu'ils les portent devant Guéhazi."
,"24":"Lorsque Guéhazi arriva à l'Ophel, il prit le tout de leurs mains et le déposa dans la maison; il renvoya les hommes, et ceux-ci partirent."
,"25":"Quant à lui, il rentra et se présenta devant son maître. Elisée lui dit: 'D'où viens-tu, Guéhazi?' Il dit: 'Ton serviteur est allé par-ci, par-là.'"
,"26":"Elisée lui dit: 'Mon esprit n'était-il pas avec toi lorsque cet homme a sauté de son char pour venir à ta rencontre? Te voilà donc avec l'argent, avec des vêtements, des oliviers, des vignes, des brebis, des boeufs, des serviteurs et des servantes!"
,"27":"Et te voilà aussi avec la lèpre de Naaman: elle sera sur toi et sur ta famille pour toujours!',Et Guéhazi s'éloigna de lui avec une lèpre blanche comme la neige."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Les frères prophètes dirent à Elisée: 'L'endroit où nous habitons avec toi est devenu trop petit pour nous."
,"2":"Descendons jusqu'au Jourdain; là, chacun prendra un tronc et nous construirons un abri pour nous loger.' Il leur dit: 'Allez-y!'"
,"3":"Mais l'un d'entre eux lui dit: 'Accepte de venir avec tes serviteurs.' Il répondit: 'J'irai.'"
,"4":"Il partit donc avec eux, ils arrivèrent au Jourdain et coupèrent du bois."
,"5":"Tandis que l'un d'entre eux abattait un tronc, le fer de hache tomba dans l'eau. Il se mit à crier: 'Ah! Ah! Mon seigneur! Et c'était une hache qu'on m'avait prêtée!'"
,"6":"L'homme de Dieu lui dit: 'Où est-il tombé?' L'autre lui montra l'endroit. Elisée coupa un morceau de bois, le jeta dans l'eau et fit surnager le fer."
,"7":"Il ajouta: 'Remonte-le maintenant.' L'autre étendit sa main et reprit le fer."
,"8":"Le roi d'Aram était en guerre avec Israël. Il tint conseil avec ses serviteurs et leur dit: 'J'irai me mettre en embuscade à tel et tel endroit.'"
,"9":"Mais l'homme de Dieu envoya dire au roi d'Israël: 'Ne passe pas par cet endroit, car les Araméens vont y descendre.'"
,"10":"Alors le roi d'Israël fit porter des ordres à l'endroit que l'homme de Dieu lui avait dit. Elisée l'avertissait ainsi, et pas seulement une fois ou deux, et le roi se tenait sur ses gardes."
,"11":"Le roi d'Aram en fut très préoccupé; il appela ses serviteurs et leur dit: 'Dites-moi donc lequel des nôtres est pour le roi d'Israël.'"
,"12":"Un de ses serviteurs répondit: 'Personne, mon seigneur le roi, c'est Elisée, le prophète d'Israël, qui révèle au roi d'Israël même les paroles que tu prononces dans ta chambre à coucher.'"
,"13":"Le roi leur dit: 'Allez et voyez où il est, et je le ferai enlever.',On lui donna une information: 'Il est à Dothan.' "
,"14":"Le roi envoya donc là-bas des chevaux, des chars et une troupe nombreuse; ils arrivèrent de nuit pour encercler la ville."
,"15":"Le serviteur de l'homme de Dieu se leva de bon matin; lorsqu'il sortit, une troupe entourait la ville avec des chevaux et des chars. Le garçon dit à Elisée: 'Ah, mon seigneur! Qu'allons-nous faire?'"
,"16":"Il lui répondit: 'Ne crains pas, car ceux qui sont avec nous sont plus nombreux que ceux qui sont avec eux.'"
,"17":"Elisée se mit en prière: 'Yahvé, ouvre ses yeux pour qu'il voie.' Et Yahvé ouvrit les yeux du jeune homme, il vit la montagne couverte de chevaux et de chars de feu tout autour d'Elisée."
,"18":"Les Araméens descendirent vers Elisée. Il fit cette prière à Yahvé: 'Daigne frapper d'aveuglement cette troupe!' Et Yahvé les frappa d'aveuglement selon la parole d'Elisée."
,"19":"Elisée leur dit: 'Ce n'est pas ici le chemin et ce n'est pas ici la ville, suivez-moi et je vous conduirai vers l'homme que vous cherchez.' Et il les conduisit à Samarie."
,"20":"Lorsqu'ils furent entrés dans Samarie, Elisée dit: 'Yahvé! Ouvre les yeux de ces hommes et qu'ils voient.' Yahvé ouvrit leurs yeux et ils virent qu'ils étaient au milieu de Samarie."
,"21":"Le roi d'Israël, en les voyant, dit à Elisée: 'Dois-je les frapper, mon père?'"
,"22":"Il répondit: 'Ne les frappe pas. Frappe-t-on ceux qu'on a fait prisonniers par l'épée ou l'arc? Donne-leur plutôt du pain et de l'eau pour qu'ils mangent et qu'ils boivent; ils retourneront ensuite chez leur maître.'"
,"23":"Alors le roi leur fit servir un bon repas, ils mangèrent et ils burent. Puis il les renvoya et ils s'en retournèrent chez leur maître; à partir de ce moment-là, les bandes araméennes cessèrent leurs raids sur le territoire d'Israël."
,"24":"Beaucoup plus tard, Ben-Hadad roi d'Aram rassembla toute son armée et monta pour assiéger Samarie."
,"25":"La famine fut grande à Samarie, la situation était telle qu'une tête d'âne valait quatre vingts pièces d'argent et qu'une petite mesure de pois chiches en valait cinq."
,"26":"Au moment où le roi passait sur le rempart, une femme cria vers lui: 'Sauve-moi, mon seigneur le roi!'"
,"27":"Il répondit: 'Si Yahvé ne te sauve pas, que puis-je faire? N'attends rien de moi pour manger ou pour boire?'"
,"28":"Puis le roi lui dit: 'Qu'y a-t-il?' Elle répondit: 'La femme que voici m'avait dit: Donne ton fils pour que nous le mangions aujourd'hui; demain nous mangerons mon fils."
,"29":"Nous avons donc fait cuire mon fils et nous l'avons mangé, mais lorsque le jour suivant je lui ai dit: donne ton fils pour que nous le mangions, elle l'a caché.'"
,"30":"En entendant les paroles de cette femme, le roi déchira ses vêtements, et comme il était sur le rempart, le peuple vit qu'en dessous de ses vêtements il portait un sac à même le corps."
,"31":"Le roi dit: 'Que Dieu me maudisse et me maudisse encore, si la tête d'Elisée fils de Chafat reste aujourd'hui sur ses épaules!'"
,"32":"Or Elisée était assis dans sa maison, et les anciens étaient assis autour de lui. Le roi envoya un de ses hommes, mais avant que le messager n'arrive, Elisée avait dit aux anciens: 'Savez-vous que ce fils d'assassin envoie quelqu'un pour me couper la tête? Faites attention! Lorsque le messager viendra, fermez la porte et repoussez-le avec la porte. On entendra sûrement les pas de son maître juste derrière les siens.'"
,"33":"Elisée parlait encore avec eux lorsque le roi arriva chez lui: 'Ce malheur vient de Yahvé, dit-il, que puis-je encore espérer de Yahvé?'"
}`)
	CurrentBook.AddChapter(7, `{
"1":"Elisée dit: 'Ecoutez la parole de Yahvé! Voici ce que dit Yahvé: Demain à cette heure, à la porte de Samarie, on aura une mesure de fleur de farine pour une pièce, et deux mesures d'orge pour une pièce.'"
,"2":"L'officier sur la main duquel s'appuyait le roi répondit à l'homme de Dieu: 'Quand bien même Yahvé ouvrirait des fenêtres dans le ciel, cela n'arrivera pas!' Elisée lui dit: 'Eh bien, tu le verras de tes yeux, mais toi, tu n'en mangeras pas!'"
,"3":"Près de la porte de la ville il y avait quatre lépreux; ils se dirent l'un à l'autre: 'Pourquoi rester ici à attendre la mort?"
,"4":"Si nous décidons d'entrer en ville, nous mourrons, puisqu'en ville c'est la famine. Si nous restons ici, nous mourrons également. Le mieux est de déserter; allons au camp des Araméens. S'ils nous laissent la vie, nous vivrons, et s'ils nous mettent à mort, nous mourrons.'"
,"5":"Peu après le coucher du soleil ils se rendirent au camp des Araméens, mais lorsqu'ils arrivèrent à l'entrée du camp, ils virent qu'il n'y avait plus personne."
,"6":"Le Seigneur en effet avait fait entendre dans le camp des Araméens un bruit de chars et de chevaux, le bruit d'une immense armée, et ils s'étaient dit l'un à l'autre: 'Sûrement, le roi d'Israël a payé les rois des Hittites et les rois des Egyptiens pour venir combattre contre nous.'"
,"7":"Ils s'étaient donc enfuis au coucher du soleil, abandonnant leurs tentes, leurs chevaux, leurs ânes, en un mot, le campement tel qu'il était: ils n'avaient pensé qu'à sauver leur vie."
,"8":"Les lépreux étaient donc arrivés à l'entrée du camp; ils entrèrent dans une tente, ils mangèrent et ils burent. Puis ils prirent de l'or, de l'argent et des habits qu'ils allèrent cacher. Après cela ils revinrent et entrèrent dans une autre tente d'où ils enlevèrent tout ce qu'il y avait pour aller le cacher de nouveau."
,"9":"Alors ils se dirent l'un à l'autre: 'Ce que nous faisons n'est pas bien, car ce jour est un jour de bonne nouvelle et nous ne disons rien. Si nous attendons jusqu'au lever du jour, nous aurons un mauvais sort. Allons donc porter la nouvelle au palais du roi.'"
,"10":"Ils retournèrent en ville, appelèrent les gardes de la porte et leur rapportèrent ceci: 'Nous sommes allés au camp des Araméens. Il n'y a plus personne, aucune présence humaine, mais seulement les chevaux et les ânes attachés et les tentes telles qu'ils les ont laissées.'"
,"11":"Les portiers crièrent et l'on porta la nouvelle au palais du roi."
,"12":"En pleine nuit le roi se leva et dit à ses conseillers: 'Je vais vous dire ce que les Araméens ont fait: ils savent que nous sommes affamés et ils ont quitté leur camp pour se cacher dans la campagne. Ils se sont dit: Quand les Israélites sortiront de la ville, nous les ferons prisonniers, puis nous entrerons dans leur ville.'"
,"13":"L'un de ses conseillers répondit: 'Prenons cinq chevaux parmi ceux qui sont restés. De toute façon ils sont bons pour mourir, comme toute la foule des Israélites. Envoyons-les et nous verrons bien.'"
,"14":"On prit donc deux chars attelés de chevaux et le roi les envoya à la poursuite de l'armée des Araméens: 'Allez et voyez! 'leur dit-il."
,"15":"Ils suivirent leurs traces jusqu'au Jourdain et virent que toute la route était jonchée d'habits et d'objets que les Araméens avaient abandonnés dans leur fuite. Les messagers revinrent le dire au roi."
,"16":"Le peuple sortit alors et le camp des Araméens fut mis au pillage; pour une pièce d'argent on avait une grande mesure de fleur de farine ou deux grandes mesures d'orge, comme l'avait dit Yahvé."
,"17":"Justement le roi avait placé à la porte de la ville l'officier sur la main duquel il s'appuyait. Les gens le piétinèrent près de la porte et il mourut comme l'avait annoncé l'homme de Dieu lorsque le roi était descendu chez lui."
,"18":"En effet, lorsque l'homme de Dieu avait dit au roi: 'Demain - et c'était le cas - on aura à la porte de Samarie deux grandes mesures d'orge ou une grande mesure de fleur de farine pour une pièce d'argent',"
,"19":"l'officier avait répondu à l'homme de Dieu: 'Même si Yahvé ouvrait des fenêtres dans le ciel, cela n'arriverait pas!' Et Elisée lui avait dit: 'Eh bien, tu le verras de tes yeux, mais toi, tu n'en mangeras pas!'"
,"20":"C'est ce qui arriva: les gens le piétinèrent à la porte de la ville, et il mourut."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Elisée dit à la femme dont il avait ressuscité le fils: 'Lève-toi, pars avec ta famille et installe-toi où tu pourras, car Yahvé a appelé la famine et elle arrive sur le pays. Il y en aura pour sept ans.'"
,"2":"La femme se leva donc et fit comme l'homme de Dieu le lui avait dit, elle partit avec sa famille et elle resta sept ans au pays des Philistins."
,"3":"Au bout de sept ans, la femme revint du pays des Philistins et alla réclamer auprès du roi au sujet de sa maison et de son champ."
,"4":"Or le roi parlait avec Guéhazi, serviteur de l'homme de Dieu: 'Raconte-moi, lui disait-il, toutes les choses extraordinaires qu'a faites Elisée.'"
,"5":"Pendant que le serviteur racontait au roi comment son maître avait rendu la vie à un mort, voici qu'arrive la femme dont Elisée avait ressuscité le fils, et elle fait sa demande au roi au sujet de sa maison et de son champ. Guéhazi lui dit: 'Mon seigneur le roi, voici justement la femme, et voici le fils auquel Elisée a rendu la vie!'"
,"6":"Le roi l'interrogea et la femme lui donna tous les détails, après quoi le roi la confia à un serviteur auquel il donna cet ordre: 'Fais rendre à cette femme tout ce qui lui appartient, ainsi que les revenus du champ depuis le jour où elle a quitté le pays jusqu'à présent.'"
,"7":"Elisée se rendit à Damas. Le roi d'Aram, Ben-Hadad, était malade et on lui donna la nouvelle: 'L'homme de Dieu est arrivé ici.'"
,"8":"Alors le roi dit à Hazaël: 'Prends avec toi un cadeau et va à la rencontre de l'homme de Dieu. Tu lui demanderas de consulter Yahvé pour savoir si je guérirai de cette maladie.'"
,"9":"Hazaël partit donc à la rencontre de l'homme de Dieu, il avait pris avec lui comme cadeau tout ce qu'il y a de meilleur à Damas: de quoi charger quarante chameaux! Il arriva chez l'homme de Dieu et, quand il fut introduit, il lui dit: 'Ton fils Ben-Hadad, le roi d'Aram, m'a envoyé vers toi pour savoir s'il guérirait de cette maladie.'"
,"10":"Elisée lui répondit: 'Dis-lui qu'il est sûr de guérir, mais Yahvé m'a fait voir qu'il mourra certainement.'"
,"11":"Alors le visage de l'homme de Dieu se contracta et son regard devint fixe, ensuite il pleura."
,"12":"Hazaël lui dit: 'Pourquoi pleures-tu, mon seigneur?' Il répondit: 'C'est que je vois tout le mal que tu vas faire aux Israélites. Tu mettras le feu à leurs forteresses, tu tueras leurs jeunes gens par l'épée, tu écraseras les enfants et tu éventreras les femmes enceintes.'"
,"13":"Hazaël lui dit: 'Moi qui suis moins qu'un chien, comment pourrais-je accomplir de tels exploits?' Elisée lui répondit: 'Yahvé me l'a fait voir: je t'ai vu roi d'Aram.'"
,"14":"Hazaël quitta Elisée et s'en retourna chez son maître. Celui-ci lui dit: 'Que t'a dit Elisée?' Il répondit: 'Il m'a dit que tu guérirais certainement.'"
,"15":"Mais le lendemain il prit une couverture, il la plongea dans l'eau et l'étendit sur le visage de Ben-Hadad qui mourut. Et Hazaël régna à sa place."
,"16":"Joram, fils de Josaphat, devint roi de Juda dans la cinquième année du règne de Joram, fils d'Akab, roi d'Israël."
,"17":"Il avait trente deux ans lorsqu'il devint roi, et il régna huit ans à Jérusalem."
,"18":"Il avait épousé une fille d'Akab, c'est pourquoi il fit ce qui est mal aux yeux de Yahvé, il imita la conduite des rois d'Israël comme l'avait fait la famille d'Akab."
,"19":"Pourtant Yahvé ne voulut pas détruire Juda, à cause de David son serviteur, et de la promesse qu'il lui avait faite de lui donner toujours un héritier parmi ses fils."
,"20":"Durant son règne, Edom rejeta la domination de Juda et se donna un roi."
,"21":"Le roi Joram descendit sur Séïr avec tous ses chars, mais les Edomites l'encerclèrent. Il se leva de nuit et, avec les chefs de chars, il força les lignes édomites, mais toute l'armée avait fui, chacun chez soi."
,"22":"Et depuis, jusqu'à ce jour, Edom n'a plus été sous la domination de Juda. En ce temps-là encore, Libna se révolta."
,"23":"Le reste de l'histoire de Joram, toutes ses actions, cela n'est-il pas écrit au Livre des Annales des Rois de Juda?"
,"24":"Joram se coucha avec ses pères et on l'enterra avec ses pères dans la Cité de David; Okozias, son fils, devint roi à sa place."
,"25":"Okozias fils de Joram devint roi de Juda en la douzième année du règne de Joram fils d'Akab, roi d'Israël."
,"26":"Okozias avait vingt-deux ans quand il devint roi, il régna un an à Jérusalem. Sa mère s'appelait Athalie, elle était fille d'Omri, roi d'Israël."
,"27":"Il se choisit une femme dans la famille d'Akab; ensuite il suivit les traces de la famille d'Akab et fit ce qui déplaît à Yahvé."
,"28":"Avec Joram, fils d'Akab, il alla combattre Hazaël, roi d'Aram à Ramot de Galaad; mais les Araméens battirent Joram."
,"29":"Le roi Joram revint à Yizréel pour se faire soigner, car les Araméens l'avaient blessé à Ramot lorsqu'il combattait Hazaël, roi d'Aram. Okozias, fils de Joram, roi de Juda, descendit alors à Yizréel pour voir Joram fils d'Akab, qui était blessé."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Le prophète Elisée appela l'un des frères prophètes, il lui dit: 'Mets ta ceinture, emporte cette cruchette d'huile et pars pour Ramot en Galaad."
,"2":"Une fois arrivé, tu chercheras Jéhu, fils de Josaphat, fils de Nimchi, tu t'approcheras de lui et tu le feras sortir du milieu de ses compagnons. Tu le conduiras dans une chambre à part,"
,"3":"puis tu prendras la cruchette d'huile, tu la verseras sur sa tête, et tu diras: Voici ce que dit Yahvé: Je t'ai consacré comme roi d'Israël! Puis tu ouvriras la porte et tu t'enfuiras sans plus attendre.'"
,"4":"Le jeune homme, le jeune prophète, partit donc pour Ramot en Galaad."
,"5":"Lorsqu'il arriva, les chefs de l'armée étaient assis ensemble; il dit: 'Chef! J'ai un mot à te dire!' Jéhu répondit: 'Auquel de nous tous?' Il lui dit: 'A toi, chef!'"
,"6":"Jéhu se leva et entra dans la maison; alors le frère prophète versa l'huile sur sa tête et lui dit: 'Voici ce que dit Yahvé, Dieu d'Israël: Je t'ai consacré comme roi sur le peuple de Yahvé, sur Israël."
,"7":"Tu frapperas la maison de ton maître Akab. Je veux faire payer à Jézabel le sang de mes serviteurs les prophètes et le sang de tous les serviteurs de Yahvé."
,"8":"J'exterminerai toute la maison d'Akab: je retrancherai de la maison d'Akab tous les mâles, aussi bien l'esclave que celui qui est libre en Israël!"
,"9":"Je ferai pour la maison d'Akab ce que j'ai fait à la maison de Jéroboam, fils de Nabat, et à celle de Bacha, fils d'Ahyia!"
,"10":"Les chiens dévoreront Jézabel dans le champ de Yizréel et personne ne l'enterrera!' Alors il ouvrit la porte et prit la fuite."
,"11":"Lorsque Jéhu revint vers les officiers de son maître, ils lui demandèrent: 'Tout va bien? Pourquoi ce fou cherchait-il après toi?' Il leur répondit: 'Vous connaissez déjà le bonhomme et son discours!'"
,"12":"Mais ils lui dirent: 'Pas du tout. Dis-nous ce qui s'est passé!' Il leur répondit: 'Il m'a dit ceci et cela, et il a ajouté: Voici ce que dit Yahvé: Je t'ai consacré comme roi sur Israël.'"
,"13":"Alors, sans plus attendre, tous jetèrent leurs manteaux sous ses pieds, sur les gradins, puis ils sonnèrent de la trompette et dirent: 'Jéhu est roi!'"
,"14":"Voici maintenant comment Jéhu, fils de Josaphat, fils de Nimchi, conspira contre Joram. Joram, avec tout Israël, défendait Ramot-en-Galaad contre Hazaël, roi d'Aram."
,"15":"Mais le roi Joram était venu se faire soigner à Yizréel, car il avait été blessé par les Araméens lorsqu'il combattait contre Hazaël, roi d'Aram. Jéhu dit alors: 'Si vous êtes d'accord, que personne ne s'échappe de la ville pour porter la nouvelle à Yizréel.'"
,"16":"Jéhu monta sur son char et partit pour Yizréel. Joram était au lit et Okozias, roi de Juda, était venu lui rendre visite."
,"17":"Le guetteur qui se tenait sur la tour de Yizréel aperçut la troupe qui venait avec Jéhu; il dit alors: 'Je vois une troupe.' Joram lui dit: 'Prends un cavalier, envoie-le à leur rencontre et il leur demandera s'ils viennent en amis.'"
,"18":"Le cavalier partit donc à leur rencontre et dit: 'Voici ce que dit le roi: Venez-vous en amis?' Jéhu répondit: 'Qu'est-ce que cela peut te faire? Fais demi-tour et suis-moi.' Le guetteur avertit le roi: 'Le messager les a rejoints mais il ne revient pas.'"
,"19":"On envoya un second cavalier qui rejoignit la troupe; il leur dit: 'Voici ce que dit le roi: Venez-vous en amis?' Jéhu répondit: 'Qu'est-ce que cela peut te faire? Fais demi-tour et suis-moi.'"
,"20":"Le guetteur avertit le roi en disant: 'Il les a rejoints et il ne revient pas. Mais la façon de conduire est celle de Jéhu, fils de Nimchi: il conduit comme un fou.'"
,"21":"Alors Joram dit: 'Attelle!' Et l'on attela son char. Joram, roi d'Israël et Okozias, roi de Juda sortirent chacun sur son char pour aller à la rencontre de Jéhu; ils le rencontrèrent dans le champ de Nabot de Yizréel."
,"22":"Dès que Joram aperçut Jéhu, il lui dit: 'Viens-tu en ami, Jéhu?' Mais celui-ci répondit: 'Quelle paix peut-il y avoir tant que durent les prostitutions de ta mère Jézabel et ses nombreuses sorcelleries?'"
,"23":"Joram fit demi-tour et prit la fuite, il cria à Okozias: 'Nous sommes trahis, Okozias!'"
,"24":"Jéhu avait bandé son arc, il frappa Joram entre les épaules et la flèche traversa le coeur: le roi s'écroula dans son char."
,"25":"Jéhu dit alors à son écuyer Bidkar: 'Emporte-le et jette-le dans le champ de Nabot de Yizréel! Rappelle-toi cette parole que Yahvé a prononcée contre lui, lorsque toi et moi nous chevauchions derrière son père Akab:"
,"26":"J'ai vu hier le sang de Nabot et le sang de ses fils - oracle de Yahvé - je te le ferai payer dans ce champ. Emporte-le donc et jette-le dans le champ, comme a dit Yahvé.'"
,"27":"En voyant tout cela, Okozias roi de Juda avait pris la fuite par le chemin de Beth-Ha-Gan. Jéhu le poursuivit: 'Tuez-le lui aussi!' criait-il. On le frappa sur son char à la montée de Gour, près de Yibléam; il se réfugia à Méguiddo et c'est là qu'il mourut."
,"28":"Ses serviteurs le ramenèrent en char à Jérusalem et le déposèrent dans son tombeau, dans la Cité de David."
,"29":"Okozias était devenu roi de Juda dans la onzième année de Joram, fils d'Akab."
,"30":"Jéhu entra dans Yizréel: Jézabel savait déjà la nouvelle. Elle se farda les yeux, arrangea sa coiffure et se mit à la fenêtre."
,"31":"Comme Jéhu passait la porte de la ville, elle lui dit: 'Tout va bien, Zimri, assassin de son maître?'"
,"32":"Il leva la tête vers la fenêtre et cria: 'Qui est avec moi?' Deux ou trois serviteurs se penchèrent aussitôt."
,"33":"Il leur dit: 'Jetez-la par la fenêtre!' Et ils la jetèrent. Son sang gicla sur le mur et sur les chevaux qui la piétinèrent."
,"34":"Jéhu rentra ensuite, il mangea et il but; après quoi il dit: 'Occupez-vous de cette maudite et mettez-la au tombeau, car c'est une fille de roi.'"
,"35":"Les serviteurs allèrent pour la déposer dans le tombeau, mais ils ne retrouvèrent que le crâne, les pieds et les mains."
,"36":"Ils revinrent le dire à Jéhu, qui déclara: 'C'est la parole de Yahvé qui vient de s'accomplir; il avait fait dire par son serviteur Elie, de Tichbé: Les chiens mangeront le corps de Jézabel dans le champ de Yizréel."
,"37":"Le cadavre de Jézabel sera comme du fumier répandu et l'on ne pourra même plus dire: C'est Jézabel.'"
}`)
	CurrentBook.AddChapter(10, `{
"1":"Soixante-dix fils d'Akab vivaient à Samarie. Jéhu écrivit des lettres qu'il envoya à Samarie. Il faisait dire aux chefs de la ville, aux anciens et à ceux qui élevaient les fils d'Akab:"
,"2":"'Vous avez avec vous les fils de votre maître, des chars et des chevaux; votre ville est fortifiée et vous avez des armes. Lorsque vous recevrez cette lettre,"
,"3":"choisissez le meilleur et le plus valable des fils de votre maître, placez-le sur le trône de son père et préparez-vous à combattre pour la maison de votre maître.'"
,"4":"Ils furent tous terrifiés; ils se dirent: 'Si les deux rois n'ont pas été capables de lui résister, que dire de nous?'"
,"5":"Le maître du palais, le gouverneur de la ville, les anciens et ceux qui élevaient les fils du roi donnèrent donc cette réponse à Jéhu: 'Nous sommes tes serviteurs et nous ferons tout ce que tu nous diras. Nous ne proclamerons pas de roi. Fais ce qui te semble bon.'"
,"6":"Jéhu leur écrivit donc une seconde lettre dans laquelle il disait ceci: 'Si vous êtes pour moi et si vous êtes prêts à me servir, prenez les têtes des fils de votre maître et venez me trouver demain à la même heure à Yizréel.',Les fils du roi étaient soixante-dix et ils étaient élevés par les notables de la ville. "
,"7":"Lorsque ceux-ci reçurent la lettre, ils prirent les fils du roi, égorgèrent tous les soixante-dix; ils mirent les têtes dans des paniers et les envoyèrent à Yizréel."
,"8":"Un messager vint avertir Jéhu: 'On vient d'apporter les têtes des fils du roi!' Jéhu répondit: 'Placez-les en deux tas à l'entrée de la porte de la ville, jusqu'au matin.'"
,"9":"Au matin Jéhu sortit et se présenta devant le peuple; il leur dit: 'Vous êtes des justes, alors que moi j'ai conspiré contre mon seigneur et je l'ai tué... Mais au fait, tous ceux-ci, qui les a frappés?"
,"10":"Voyez qu'aucune des paroles prononcées par Yahvé contre la maison d'Akab n'est restée sans effet. Yahvé a accompli tout ce qu'il avait annoncé par la voix de son serviteur Elie.'"
,"11":"Jéhu frappa tous ceux qui restaient en vie de la maison d'Akab à Yizréel: ses conseillers, ses serviteurs, ses prêtres; il ne laissa personne en vie."
,"12":"Puis Jéhu se mit en route pour Samarie. Comme il arrivait à Beth-Eqed-Des-Pasteurs,"
,"13":"il rencontra les frères d'Okozias, roi de Juda. Il leur demanda: 'Qui êtes-vous?' Ils répondirent: 'Nous sommes les frères d'Okozias et nous descendons pour saluer les fils du roi et les fils de la reine.'"
,"14":"Alors Jéhu dit: 'Arrêtez-les!' On les fit prisonniers et on les égorgea à la Citerne de Beth-Eqed. Ils étaient quarante- deux et Jéhu n'en laissa pas un seul en vie."
,"15":"Il partit de là et rencontra Yonadab, fils de Rékab qui venait au-devant de lui. Il le salua et lui dit: 'Seras-tu loyal envers moi comme je veux l'être avec toi?' Yonadab répondit: 'Oui.' 'Si c'est oui, dit-il, donne-moi la main.' Yonadab lui donna la main et Jéhu le fit monter à côté de lui sur son char."
,"16":"Il l'emmena sur son char en lui disant: 'Viens avec moi et tu verras mon zèle pour Yahvé.'"
,"17":"Une fois entré à Samarie, Jéhu frappa tous ceux qui restaient de la famille d'Akab à Samarie; il les tua tous, selon la parole que Yahvé avait dite à Elie."
,"18":"Ensuite Jéhu rassembla tout le peuple. Il fit cette proclamation: 'Akab n'a servi qu'un peu le Baal, Jéhu le servira bien mieux."
,"19":"Rassemblez donc autour de moi tous les prophètes du Baal, tous ceux qui sont à son service, tous ses prêtres: que personne ne manque, car je dois offrir un grand sacrifice au Baal. Ceux qui ne viendront pas seront mis à mort.' C'était une ruse, Jéhu voulait ainsi mettre à mort tous ceux qui servaient le Baal."
,"20":"Jéhu ajouta: 'Convoquez une assemblée solennelle en l'honneur du Baal.' Ils la convoquèrent."
,"21":"Jéhu envoya des messagers dans tout Israël, et tous les serviteurs du Baal se rassemblèrent; il n'en manqua pas un. Ils entrèrent dans la Maison du Baal et la remplirent de bout en bout."
,"22":"Jéhu avait dit à l'homme chargé du vestiaire: 'Sors les vêtements pour tous les serviteurs de Baal', et l'autre avait sorti les vêtements."
,"23":"Et lorsque Jéhu arriva à la maison de Baal avec Yonadab fils de Rékab, il dit aux serviteurs de Baal: 'Cherchez et assurez-vous qu'il n'y a ici aucun serviteur de Yahvé, mais seulement des serviteurs de Baal.'"
,"24":"Ensuite il entra pour offrir les sacrifices et les holocaustes. Jéhu avait posté dehors quatre-vingts hommes; il leur avait dit: 'Je vais livrer des hommes entre vos mains, celui d'entre vous qui en laissera échapper un seul, paiera de sa propre vie.' "
,"25":"Aussitôt l'holocauste terminé, Jéhu dit aux gardes et aux officiers: 'Entrez, frappez-les et que pas un ne sorte.' Les gardes et les officiers les frappèrent de leur épée; ils jetaient dehors les cadavres tandis qu'ils s'avançaient jusqu'au sanctuaire du temple du Baal."
,"26":"Ils arrachèrent le pieu sacré de la Maison du Baal et le brûlèrent,"
,"27":"puis ils démolirent l'autel du Baal et ils en firent un fumier qui existe encore aujourd'hui."
,"28":"C'est ainsi que Jéhu fit disparaître le culte du Baal en Israël."
,"29":"Cependant Jéhu ne se détourna pas des péchés dans lesquels Jéroboam fils de Nabat avait entraîné Israël: les veaux d'or établis à Béthel et à Dan."
,"30":"Yahvé dit à Jéhu: 'Parce que tu as bien agi, que tu as fait ce qui est juste à mes yeux, parce que tu as accompli contre la maison d'Akab tout ce que j'avais décidé, tes fils régneront sur Israël jusqu'à la quatrième génération.'"
,"31":"Mais Jéhu ne s'appliqua pas à marcher de tout son coeur selon la Loi de Yahvé, Dieu d'Israël. Il ne se détourna pas des péchés dans lesquels Jéroboam avait entraîné Israël."
,"32":"En ces jours-là, Yahvé commença à réduire le territoire d'Israël: Hazaël battit les Israélites sur tout le territoire"
,"33":"à l'est du Jourdain , tout le pays de Galaad, le pays de Gad, de Ruben et de Manassé, depuis Aroër qui est au-dessus du torrent d'Arnon: en un mot, le Galaad et le Bashan."
,"34":"Le reste des actions de Jéhu, tout ce qu'il a fait et toute sa bravoure, cela n'est-il pas écrit au Livre des Chroniques des rois d'Israël?"
,"35":"Jéhu se coucha avec ses pères et on l'enterra à Samarie; Yoacaz, son fils, régna à sa place."
,"36":"Jéhu avait régné sur Israël à Samarie pendant vingt-huit ans."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Voyant que son fils Okozias était mort, Athalie, sa mère , décida de mettre à mort toute la descendance du roi."
,"2":"Pendant que l'on mettait à mort tous les fils du roi, Yochéba, fille du roi Joram et soeur d'Okozias, retira discrètement l'un d'entre eux, Joas fils d'Okozias. Elle fit passer l'enfant avec sa nourrice dans la chambre des lits. Elle put ainsi le cacher à Athalie et il ne fut pas mis à mort."
,"3":"Durant six années il demeura caché auprès de Yochéba dans la Maison de Yahvé, tandis qu'Athalie régnait sur le pays."
,"4":"La septième année, le prêtre Yoyada envoya chercher les officiers des Kariens et la garde. Il les fit entrer près de lui dans la Maison de Yahvé, et là il fit une alliance avec eux; après leur avoir fait prêter serment dans la Maison de Yahvé, il leur montra le fils du roi."
,"5":"Il leur dit alors: 'Voici ce que vous allez faire: un tiers d'entre vous, ceux qui prennent leur service le jour du sabbat, montera la garde au palais royal;"
,"6":"un tiers se tiendra à la Porte de Fondation et un autre tiers à la porte qui se trouve en face des gardes; vous monterez alternativement la garde dans la Maison."
,"7":"Deux sections parmi vous, tous ceux qui finissent leur service le jour du sabbat, monteront la garde au Temple de Yahvé, autour du roi."
,"8":"Vous ferez cercle autour du roi, chacun aura son arme à la main, et si quelqu'un cherche à forcer vos rangs, vous le mettrez à mort. Vous serez aux côtés du roi dans tous ses mouvements.'"
,"9":"Les officiers firent tout ce qu'avait commandé le prêtre Yoyada; chacun prit ses hommes, ceux qui commençaient leur service le jour du sabbat et ceux qui le finissaient, et ils se rassemblèrent autour du prêtre Yoyada."
,"10":"Le prêtre donna aux officiers les lances et les boucliers du roi David qui se trouvaient dans la Maison de Yahvé;"
,"11":"les gardes étaient à leur poste, chacun tenant son arme à la main, depuis le côté droit du Temple jusqu'au côté gauche, entourant l'autel et la Maison."
,"12":"Alors le prêtre fit avancer le fils du roi et il lui remit la couronne et les bracelets royaux. On le proclama roi et on le consacra; tout le monde applaudissait et criait: 'Vive le roi!'"
,"13":"En entendant les cris du peuple, Athalie se dirigea vers l'attroupement de la Maison de Yahvé."
,"14":"Elle regarda: le roi était debout sur l'estrade selon la coutume, les chefs et les joueurs de trompette entouraient le roi, et tout le peuple-du-pays était en fête et sonnait de la trompette. Alors Athalie déchira ses habits et cria: 'Trahison! Trahison!'"
,"15":"Le prêtre Yoyada donna cet ordre aux officiers: 'Sortez-la hors du Temple, et si quelqu'un la suit, frappez-le de l'épée!' En effet le prêtre se disait: 'Il ne faut pas la mettre à mort dans la Maison de Yahvé.'"
,"16":"Ils mirent donc la main sur elle et l'entraînèrent par le chemin qui mène à l'Entrée des Chevaux jusqu'au palais royal; là, elle fut mise à mort."
,"17":"Yoyada conclut une alliance entre Yahvé, le roi et le peuple, pour que tout le peuple se conduise vraiment en peuple de Yahvé."
,"18":"Tout le peuple-du-pays vint au temple de Baal et on le démolit, on y brisa les autels et les stèles; quant à Mattan, le prêtre de Baal, on le tua devant les autels. Le prêtre plaça des gardes au Temple de Yahvé,"
,"19":"il prit avec lui les officiers, les Kariens, les gardes et tout le peuple-du-pays; on fit descendre le roi du Temple de Yahvé jusqu'au palais royal par le chemin de la Porte des Gardes et là il s'assit sur le trône royal."
,"20":"Tout le peuple-du-pays était en fête, et la ville avait retrouvé la paix; quant à Athalie, on l'avait mise à mort par l'épée dans le palais royal."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Joas devint roi à l'âge de sept ans:"
,"2":"c'était la septième année du règne de Jéhu. Il régna quarante ans à Jérusalem; sa mère s'appelait Sibya, elle était de Bersabée."
,"3":"Joas fit ce qui plaît à Yahvé tout le temps qu'il fut sous la tutelle du prêtre Yoyada."
,"4":"Cependant les Hauts-Lieux ne disparurent pas, le peuple continuait à sacrifier et à brûler de l'encens sur les Hauts-Lieux."
,"5":"Joas dit aux prêtres: 'Tout l'argent qu'on apporte dans la Maison de Yahvé, l'argent des taxes personnelles comme l'argent qui provient des offrandes volontaires pour la Maison,"
,"6":"chacun des prêtres le recevra des gens qui s'adressent à lui. Ensuite ils s'en serviront pour réparer la Maison partout où cela sera nécessaire.'"
,"7":"Or, à la vingt-troisième année du règne de Joas, les prêtres n'avaient pas encore réparé la Maison."
,"8":"Le roi Joas appela donc le prêtre Yoyada et les autres prêtres; il leur dit: 'Pourquoi ne réparez-vous pas la Maison? Désormais vous ne prendrez plus l'argent de ceux qui s'adressent à vous, mais vous le verserez pour la réparation du Temple.'"
,"9":"Les prêtres acceptèrent de ne plus recevoir cet argent et de ne plus avoir à leur charge la réparation du Temple."
,"10":"Le prêtre Yoyada prit donc un coffre et fit percer un trou dans le couvercle; il le mit à côté de l'autel, sur la droite quand on entre dans la Maison de Yahvé. Les prêtres qui gardaient la porte du Temple y déposaient tout l'argent que l'on apportait pour la Maison de Yahvé."
,"11":"Quand ils voyaient pas mal d'argent dans le coffre, le secrétaire du roi et le grand prêtre montaient pour ramasser et compter cet argent qui se trouvait dans la Maison de Yahvé."
,"12":"Une fois l'argent compté, on le remettait à ceux qui faisaient le travail et qui étaient chargés d'entretenir la Maison de Yahvé; ils l'utilisaient pour les charpentiers et les ouvriers qui travaillaient dans la Maison de Yahvé,"
,"13":"pour les maçons et les tailleurs de pierres, et aussi pour acheter le bois et les pierres de taille des réparations du Temple de Yahvé; en un mot, ils le dépensaient pour toutes les réparations nécessaires dans la Maison de Yahvé."
,"14":"Avec l'argent apporté pour la Maison de Yahvé, on ne faisait ni cuvettes d'argent, ni couteaux, ni cruchettes, ni trompettes, ni aucun objet d'or ou d'argent pour la Maison de Yahvé,"
,"15":"mais on le remettait à ceux qui faisaient le travail et ils s'en servaient pour réparer la Maison de Yahvé."
,"16":"On ne demandait aucun compte aux hommes à qui l'on remettait l'argent pour payer les travailleurs, car c'étaient des hommes honnêtes."
,"17":"Seul l'argent des sacrifices pour le péché et des sacrifices de réparation n'était pas apporté au Temple de Yahvé: il était pour les prêtres."
,"18":"C'est en ce temps-là qu'Hazaël, roi d'Aram, monta pour combattre Gat et s'en empara. Hazaël voulait attaquer Jérusalem,"
,"19":"mais Joas, roi de Juda, prit tous les objets consacrés par Josaphat, Joram et Okozias, ses ancêtres, les rois de Juda. Il prit aussi tout ce qu'il avait consacré lui-même, tout l'or qui se trouvait dans les trésors du Temple de Yahvé et du palais royal, et il l'envoya à Hazaël, roi d'Aram. Celui-ci s'éloigna de Jérusalem."
,"20":"Le reste des actions de Joas, tout ce qu'il a fait, cela n'est-il pas écrit au Livre des Chroniques des rois de Juda?"
,"21":"Les serviteurs de Joas firent une conspiration pour l'assassiner à Beth-Millo;"
,"22":"là, Yozakar fils de Chiméat et Yozabad fils de Chomer le frappèrent à mort. On l'enterra avec ses pères dans la Cité de David, et Amasias, son fils, régna à sa place."
}`)
	CurrentBook.AddChapter(13, `{
"1":"En la vingt-troisième année du règne de Joas fils d'Okozias en Juda, Yoacaz, fils de Jéhu, devint roi à Samarie; il régna dix- sept ans sur Israël."
,"2":"Il fit ce qui déplaît à Yahvé et il imita le péché dans lequel Jéroboam fils de Nabat avait entraîné Israël: il ne s'en détourna pas."
,"3":"Yahvé se mit en colère contre les Israélites, il les livra entre les mains d'Hazaël roi d'Aram, et de Ben-Ha-Adad, fils d'Hazaël, durant de longs jours."
,"4":"Yoacaz supplia Yahvé et Yahvé l'écouta, car il avait vu à quel point le roi d'Aram opprimait les Israélites."
,"5":"C'est pourquoi Yahvé donna un sauveur à Israël; ils se libérèrent de l'oppression d'Aram et les Israélites habitèrent de nouveau dans leurs tentes comme dans le passé."
,"6":"Ils ne se détournèrent pas pour autant des péchés dans lesquels la maison de Jéroboam avait entraîné Israël, bien au contraire: même le pieu sacré de Samarie resta debout."
,"7":"Il ne resta à Yoacaz, de toute son armée, que cinquante cavaliers, dix chars et dix mille fantassins: le roi d'Aram l'avait écrasée et réduite en poussière."
,"8":"Le reste des actions de Yoacaz, ce qu'il a fait et sa bravoure, tout cela n'est-il pas écrit au Livre des Chroniques des rois d'Israël?"
,"9":"Yoacaz se coucha avec ses pères et on l'enterra à Samarie; Joas, son fils, régna à sa place."
,"10":"En la trente-septième année du règne de Joas en Juda, Joas, fils de Yoacaz, devint roi à Samarie; il régna seize ans sur Israël."
,"11":"Il fit ce qui déplaît à Yahvé, il ne se détourna pas du péché dans lequel Jéroboam fils de Nabat, avait entraîné Israël, bien au contraire."
,"12":"Le reste des action de Joas, tout ce qu'il a fait et la bravoure avec laquelle il s'est battu contre Amasias, roi de Juda, cela n'est-il pas écrit dans le Livre des Chroniques des rois d'Israël?"
,"13":"Joas se coucha avec ses pères et Jéroboam s'assit sur son trône. On enterra Joas à Samarie avec les rois d'Israël."
,"14":"Elisée était déjà malade de la maladie dont il devait mourir. Joas, roi d'Israël, descendit auprès de lui et pleura; il dit: 'Mon père! Mon père! Char d'Israël et ses cavaliers!'"
,"15":"Elisée lui dit: 'Prends un arc et des flèches.' Joas alla donc prendre un arc et des flèches."
,"16":"Elisée dit au roi d'Israël: 'Prends ton arc dans la main.' Il le fit. Elisée posa ses mains sur les mains du roi,"
,"17":"puis il dit: 'Ouvre la fenêtre vers l'est!' Il l'ouvrit. Elisée ajouta: 'Tire!' Et il tira. Elisée dit alors: 'Flèche de victoire de la part de Yahvé! Flèche de victoire contre Aram! Tu battras Aram à Afek, jusqu'à ce qu'il n'en reste plus un seul.'"
,"18":"Il dit ensuite: 'Ramasse les flèches.' Il les ramassa. Elisée dit au roi d'Israël: 'Frappe à terre.' Et le roi frappa trois fois, puis s'arrêta."
,"19":"Alors l'homme de Dieu se mit en colère contre le roi et lui dit: 'Il fallait frapper cinq ou six fois! Alors tu aurais battu Aram jusqu'à ce qu'il n'en reste plus un seul! Mais à présent, tu ne battras Aram que trois fois.'"
,"20":"Elisée mourut et on l'enterra. Des bandes moabites pénétraient alors chaque année dans le pays,"
,"21":"et il arriva que des gens qui portaient un mort en terre, aperçurent l'une de ces bandes: ils jetèrent le mort dans le tombeau d'Elisée et se sauvèrent. L'homme toucha les os d'Elisée et il revint à la vie: aussitôt il se remit sur ses pieds."
,"22":"Hazaël roi d'Aram avait opprimé les Israélites durant tout le règne de Yoacaz."
,"23":"Ensuite Yahvé leur fit grâce, il eut pitié d'eux; il se tourna vers eux à cause de l'alliance qu'il avait faite avec Abraham, Isaac et Jacob et il ne voulut pas les détruire. Il ne les avait pas encore rejetés loin de lui."
,"24":"Hazaël roi d'Aram mourut et son fils Ben-Ha-Adad régna à sa place."
,"25":"Alors Joas reprit à Ben-Ha-Adad les villes que son père Hazaël avait enlevées à Yoacaz, père de Joas, au cours des guerres. Par trois fois Joas le battit, et il reprit les villes d'Israël."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Amasias fils de Joas, roi de Juda, commença à régner la deuxième année de Joas fils de Yoacaz, roi d'Israël."
,"2":"Il avait vingt- cinq ans lorsqu'il monta sur le trône et il régna vingt-neuf ans à Jérusalem; sa mère s'appelait Yoaddan, elle était de Jérusalem."
,"3":"Il fit ce qui est juste aux yeux de Yahvé, mais cependant pas comme son père David. En toute chose il se comporta comme son père Joas."
,"4":"Les Hauts-Lieux ne disparurent pas, le peuple continua d'offrir des sacrifices et de faire fumer de l'encens sur les Hauts-Lieux."
,"5":"Dès qu'Amasias fut maître de la situation dans son royaume, il mit à mort ceux de ses serviteurs qui avaient tué le roi son père,"
,"6":"mais il ne mit pas à mort les fils des assassins, selon ce qui est écrit dans le livre de la Loi de Moïse. Yahvé, en effet, a donné ce commandement: 'Les pères ne seront pas mis à mort pour les fils et les fils ne seront pas mis à mort pour les pères: chacun sera mis à mort pour son propre péché.'"
,"7":"C'est lui qui battit les Edomites dans la vallée du Sel et qui s'empara de la Roche au prix d'un dur combat; il lui donna le nom de Yoktéel, qu'elle porte jusqu'à ce jour."
,"8":"Alors Amasias envoya des messagers à Joas fils de Yoacaz, fils de Jéhu, roi d'Israël: 'Viens te mesurer avec moi', lui dit-il."
,"9":"Joas roi d'Israël fit répondre à Amasias roi de Juda: 'L'épine du Liban envoya dire au cèdre du Liban: Donne ta fille pour femme à mon fils. Mais la bête sauvage du Liban passa et écrasa l'épine."
,"10":"Tu as bien battu Edom et tu en es tout fier. Eh bien, glorifie-toi et reste chez toi. Pourquoi attirer le malheur et la mort sur toi et sur Juda avec toi?'"
,"11":"Mais Amasias n'écouta pas. Alors Joas, roi d'Israël, s'avança et ils s'affrontèrent à Beth-Chémech, qui est en Juda."
,"12":"Juda fut battu par Israël et tous s'enfuirent à leurs tentes."
,"13":"Joas, roi d'Israël, fit prisonnier Amasias, roi de Juda, fils de Joas, fils d'Okozias, à Beth-Chémech et le ramena à Jérusalem. Il abattit le rempart de Jérusalem sur plus de cent mètres, depuis la porte d'Ephraïm jusqu'à la porte de l'Angle;"
,"14":"il prit tout l'or et l'argent, tous les objets qui se trouvaient dans la Maison de Yahvé et dans le trésor du palais royal, ainsi que des otages; puis il retourna à Samarie."
,"15":"Le reste des actes de Joas, ce qu'il a fait, sa bravoure, comment il combattit contre Amasias, roi de Juda, cela n'est-il pas écrit dans le Livre des Chroniques des rois d'Israël?"
,"16":"Joas se coucha avec ses pères et on l'enterra à Samarie avec les rois d'Israël; Jéroboam, son fils, régna à sa place."
,"17":"Après la mort de Joas fils de Yoacaz, roi d'Israël, Amasias fils de Joas, roi de Juda, vécut encore quinze ans."
,"18":"Le reste des actes d'Amasias, cela n'est-il pas écrit dans le Livre des Chroniques des rois de Juda?"
,"19":"On complota contre lui à Jérusalem et il s'enfuit à Lakish, mais on le poursuivit jusqu'à Lakish, et là il fut mis à mort."
,"20":"On le ramena avec des chevaux et on l'enterra à Jérusalem avec ses pères, dans la Cité de David."
,"21":"Tout le peuple de Juda prit Azarias - il n'avait alors que seize ans - et on le fit roi à la place de son père Amasias."
,"22":"Il rebâtit Elat et la rendit à Juda après que le roi se fut couché avec ses pères."
,"23":"En la quinzième année d'Amasias fils de Joas, roi de Juda, Jéroboam fils de Joas, roi d'Israël, devint roi à Samarie. Il régna quarante et un ans."
,"24":"Il fit ce qui est mal au regard de Yahvé, il ne se détourna pas de tous les péchés dans lesquels Jéroboam, fils de Nabat, avait entraîné Israël."
,"25":"Mais c'est lui qui rétablit les frontières d'Israël depuis l'entrée de Hamat jusqu'à la mer de la Araba, comme Yahvé, Dieu d'Israël, l'avait dit par la bouche de son serviteur, le prophète Jonas, fils d'Amittaï, qui était de Gat-Héfer."
,"26":"En effet, Yahvé avait vu la très grande misère d'Israël: il n'y avait plus personne, ni esclave ni homme libre, capable de secourir Israël."
,"27":"Yahvé n'avait pas décidé d'effacer le nom d'Israël de dessous les cieux, et il le délivra par la main de Jéroboam, fils de Joas."
,"28":"Le reste des actes de Jéroboam, tout ce qu'il a fait et sa bravoure, comment il combattit et redonna Damas et Hamat à Israël, cela n'est-il pas écrit dans le Livre des Chroniques des rois d'Israël?"
,"29":"Jéroboam se coucha avec ses pères et on l'enterra à Samarie avec les rois d'Israël; Zacharie, son fils, régna à sa place."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Azarias, fils d'Amasias, roi de Juda, commença à régner en la vingt-septième année de Jéroboam, roi d'Israël."
,"2":"Il avait seize ans lorsqu'il monta sur le trône et il régna cinquante deux ans à Jérusalem; sa mère s'appelait Yékolyas, elle était de Jérusalem."
,"3":"Il fit ce qui est juste aux yeux de Yahvé, comme l'avait fait son père Amasias."
,"4":"Seulement les Hauts-Lieux ne disparurent pas, le peuple continua d'offrir des sacrifices et de faire fumer de l'encens sur les Hauts-Lieux."
,"5":"Yahvé frappa le roi: il fut lépreux jusqu'à sa mort et il dut habiter une maison isolée; Yotam, le fils du roi, était chef du palais et gouvernait le peuple-du-pays."
,"6":"Le reste des actes d'Azarias, tout ce qu'il a fait, cela n'est-il pas écrit dans le Livre des Chroniques des rois de Juda?"
,"7":"Azarias se coucha avec ses pères et on l'enterra avec ses pères dans la Cité de David; son fils Yotam régna à sa place."
,"8":"En la trente-huitième année d'Azarias, roi de Juda, Zacharie, fils de Jéroboam devint roi sur Israël à Samarie pour six mois."
,"9":"Il fit ce qui est mal au regard de Yahvé, comme l'avaient fait ses pères. Il ne se détourna pas des péchés dans lesquels Jéroboam, fils de Nabat, avait entraîné Israël."
,"10":"Challoum, fils de Yabech, conspira contre lui; il l'assassina à Yibléam et devint roi à sa place."
,"11":"Le reste des actes de Zacharie est écrit dans le Livre des Chroniques des rois d'Israël."
,"12":"Yahvé avait bien dit à Jéhu: 'Tes fils s'assiéront sur le trône d'Israël jusqu'à la quatrième génération.' Et c'est ce qui arriva."
,"13":"Challoum fils de Yabech commença à régner en la trente-neuvième année d'Ozias, roi de Juda. Il ne régna qu'un mois à Samarie."
,"14":"Ménahem fils de Gadi monta de Tirsa et entra à Samarie où il assassina Challoum fils de Yabech; après quoi il devint roi à sa place."
,"15":"Le reste des actes de Challoum et la façon dont il conspira, cela est écrit dans le Livre des Chroniques des rois d'Israël."
,"16":"Alors Ménahem frappa Tapoua et tous ses habitants ainsi que tout son territoire à partir de Tirsa parce qu'on ne lui avait pas ouvert les portes; il éventra toutes les femmes enceintes."
,"17":"Ménahem fils de Gadi commença à régner sur Israël à Samarie en la trente-neuvième année d'Azarias, roi de Juda. Il régna dix ans."
,"18":"Il fit ce qui est mal au regard de Yahvé, il ne se détourna pas des péchés dans lesquels Jéroboam fils de Nabat avait entraîné Israël. Durant ses jours, "
,"19":"Poul, roi d'Assyrie, envahit le pays; Ménahem lui donna mille talents d'argent pour qu'il lui apporte son aide et qu'il affermisse le pouvoir royal entre ses mains."
,"20":"Ménahem préleva cet argent sur Israël: tous les notables durent verser cinquante pièces d'argent par personne pour les donner au roi d'Assyrie. Après quoi le roi d'Assyrie quitta le pays et s'en retourna."
,"21":"Le reste des actes de Ménahem, tout ce qu'il a fait, cela n'est-il pas écrit dans le Livre des Chroniques des rois d'Israël?"
,"22":"Ménahem se coucha avec ses pères et Pékahya, son fils, régna à sa place."
,"23":"Pékahya, fils de Ménahem, commença à régner sur Israël pour deux ans à Samarie, en la cinquantième année d'Azarias, roi de Juda."
,"24":"Il fit ce qui est mal aux yeux de Yahvé, il ne se détourna pas des péchés dans lesquels Jéroboam fils de Nabat avait entraîné Israël."
,"25":"Pékah, fils de Rémalyas, son écuyer, conspira contre lui et l'assassina à Samarie dans le donjon du palais royal. Il avait eu recours à cinquante hommes de Galaad pour assassiner le roi et régner à sa place."
,"26":"Le reste des actes de Pékahya et tout ce qu'il a fait, cela est écrit dans le Livre des Chroniques des rois d'Israël."
,"27":"Pékah fils de Rémalyas commença à régner à Samarie en la cinquante-deuxième année d'Azarias, roi de Juda; il régna vingt ans."
,"28":"Il fit ce qui est mal au regard de Yahvé, il ne se détourna pas des péchés dans lesquels Jéroboam fils de Nabat avait entraîné Israël."
,"29":"Durant les jours de Pékah, roi d'Israël, Téglat-Falasar, roi d'Assyrie, vint s'emparer d'Iyon, d'Abel-Beth-Maaka, de Yanoah, de Quédesh, de Hazor, du Galaad et de la Galilée, de tout le pays de Nephtali; il déporta leurs habitants en Assyrie."
,"30":"Osée, fils d'Ela, monta alors un complot contre Pékah fils de Rémalyas; il l'assassina et régna à sa place en la vingtième année de Yotam fils d'Ozias."
,"31":"Le reste des actes de Pékah et tout ce qu'il a fait, cela est écrit dans le Livre des Chroniques des rois d'Israël."
,"32":"Yotam, fils d'Ozias, roi de Juda, commença à régner en la deuxième année de Pékah fils de Rémalyas, roi d'Israël."
,"33":"Il avait vingt cinq ans lorsqu'il monta sur le trône et il régna seize ans à Jérusalem; sa mère s'appelait Yéroucha, elle était fille de Sadoc."
,"34":"Il fit ce qui est juste au regard de Yahvé, comme l'avait fait son père Ozias;"
,"35":"seulement les Hauts-Lieux ne disparurent pas. Le peuple continua d'offrir des sacrifices et de faire fumer de l'encens sur les Hauts-Lieux. C'est lui qui construisit la Porte Haute du Temple de Yahvé."
,"36":"Le reste des actes de Yotam, ce qu'il a fait, cela n'est-il pas écrit dans le Livre des Chroniques des rois de Juda?"
,"37":"En ces jours-là, Yahvé commença de lancer Razone, roi d'Aram, et Pékah fils de Rémalyas, contre Juda."
,"38":"Yotam se coucha avec ses pères, et on l'enterra avec ses pères dans la Cité de David son ancêtre; Akaz, son fils, régna à sa place."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Akaz, fils de Yotam, roi de Juda, commença à régner en la dix-septième année de Pékah fils de Rémalyas."
,"2":"Akaz avait vingt ans lorsqu'il monta sur le trône et il régna seize ans à Jérusalem. Il ne fit pas ce qui est juste au regard de Yahvé, son Dieu, comme son ancêtre David."
,"3":"Il suivit les traces des rois d'Israël, et même il sacrifia son fils par le feu, selon les pratiques odieuses des peuplades que Yahvé avait dépossédées devant les Israélites."
,"4":"Il offrit des sacrifices et fit fumer l'encens sur les Hauts-Lieux, sur les collines et sous tout arbre vert."
,"5":"Alors Razone, roi d'Aram, et Pékah, fils de Rémalyas, roi d'Israël, montèrent vers Jérusalem pour l'attaquer. Ils assiégèrent Akaz, mais ils ne purent l'abattre."
,"6":"En ce temps-là le roi d'Edom récupéra Elat et expulsa les Judéens qui y étaient installés; les Edomites en prirent possession et y restèrent jusqu'à ce jour."
,"7":"Akaz envoya des messagers à Téglat-Falazar, roi d'Assyrie: 'Je suis ton serviteur et ton fils, lui dit-il, viens me délivrer du roi d'Aram et du roi d'Israël qui sont venus m'attaquer.'"
,"8":"Akaz prit l'argent et l'or qui se trouvaient dans la Maison de Yahvé et dans le trésor du palais royal, et il en fit don au roi d'Assyrie."
,"9":"Le roi d'Assyrie l'écouta: il alla attaquer Damas et s'en empara, il en déporta les habitants à Kir et il fit exécuter Razone."
,"10":"Lorsque le roi Akaz alla à Damas pour y rencontrer Téglat-Falazar, roi d'Assyrie, il vit l'autel qui était à Damas; il envoya l'image de cet autel et son plan, avec tous ses détails, au prêtre Ouriya."
,"11":"Avant même que le roi Akaz ne revienne de Damas, le prêtre Ouriya construisit un autel exactement conforme aux données que le roi Akaz lui envoyait."
,"12":"Lorsque le roi vit l'autel à son retour de Damas, il monta lui-même à l'autel pour y sacrifier."
,"13":"Il fit fumer son holocauste et son offrande, il versa une libation et aspergea l'autel avec le sang des sacrifices pacifiques."
,"14":"On déplaça l'autel de bronze qui était devant Yahvé, on le retira de devant la Maison où il se trouvait maintenant entre le nouvel autel et la Maison de Yahvé; on le mit sur le côté du nouvel autel vers le nord."
,"15":"Le roi Akaz donna cet ordre au prêtre Ouriya: 'Tu feras fumer l'holocauste du matin et l'offrande du soir, l'holocauste du roi et son offrande, l'holocauste pour tout le peuple-du-pays, son offrande et ses libations, sur ce grand autel. Tu feras là l'aspersion du sang pour tous les holocaustes et les sacrifices. Quant à l'autel de bronze, je verrai quoi en faire.'"
,"16":"Le prêtre Ouriya fit tout ce que lui avait commandé le roi Akaz."
,"17":"Le roi Akaz brisa les panneaux et les bases, il ôta les bassins qui étaient dessus, il fit descendre la Mer de bronze de dessus les boeufs qui la portaient et la posa sur un dallage de pierres."
,"18":"Par égard pour le roi d'Assyrie, il transforma le Portique du Sabbat que l'on avait construit à l'intérieur et l'Entrée du Roi qui se trouvait à l'extérieur du Temple de Yahvé."
,"19":"Le reste des actes d'Akaz, ce qu'il a fait, cela n'est-il pas écrit dans le Livre des Chroniques des rois de Juda?"
,"20":"Akaz se coucha avec ses pères et on l'enterra avec ses pères dans la Cité de David; Ezéquias, son fils, régna à sa place."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Osée fils, d'Ela, commença à régner sur Israël, à Samarie, en la douzième année d'Akaz, roi de Juda; il régna neuf ans."
,"2":"Il fit ce qui est mal au regard de Yahvé, mais pas autant que les rois d'Israël qui l'avaient précédé."
,"3":"Salmanazar roi d'Assyrie vint l'attaquer, et Osée dut se soumettre: il lui paya un tribut."
,"4":"Mais le roi d'Assyrie s'aperçut que Osée conspirait contre lui: il avait envoyé des messagers à Saïs, vers le roi d'Egypte, et il ne payait plus le tribut, comme chaque année, au roi d'Assyrie. Celui-ci le fit donc arrêter et mettre en prison, enchaîné."
,"5":"Le roi d'Assyrie envahit tout le pays; il arriva devant Samarie et l'assiégea durant trois ans."
,"6":"La neuvième année d'Osée, le roi d'Assyrie s'empara de Samarie et il déporta les Israélites en Assyrie. Il les établit à Hala sur le Habor, le fleuve de Gozan, ainsi que dans les villes de Médie."
,"7":"Cela arriva parce que les fils d'Israël avaient péché contre Yahvé leur Dieu, qui les avait fait monter du pays d'Egypte et les avait délivrés de la main du Pharaon, roi d'Egypte: ils s'étaient tournés vers d'autre dieux."
,"8":"Les Israélites imitèrent les coutumes des nations que Yahvé avait dépossédées devant les fils d'Israël."
,"9":"Ils prononcèrent contre Yahvé, leur Dieu, des paroles indécentes, ils se construisirent des Hauts-Lieux dans toutes leurs villes, depuis la tour de garde jusqu'à la ville fortifiée."
,"10":"Ils mirent des pierres levées et des pieux sacrés sur toute colline élevée et sous tout arbre vert."
,"11":"Et là, dans tous ces Hauts-Lieux, ils faisaient fumer l'encens comme avaient fait les nations que Yahvé avait chassées devant eux; ils commirent encore toutes sortes d'actions mauvaises pour mettre Yahvé en colère."
,"12":"Ils se mirent au service de sales idoles alors que Yahvé leur avait dit: 'Vous ne ferez pas cela.'"
,"13":"Pourtant Yahvé avait solennellement averti Israël et Juda par la bouche de tous les prophètes et de tous les voyants: 'Renoncez à votre mauvaise conduite et observez mes commandements et mes ordres, selon cette Loi que j'ai ordonnée à vos pères et que je vous ai communiquée par la bouche de mes serviteurs les prophètes.'"
,"14":"Mais ils n'écoutèrent pas. Et plus encore que leurs pères, qui n'avaient pas cru en Yahvé, leur Dieu, ils firent la forte tête."
,"15":"Ils méprisèrent ses commandements et l'Alliance qu'il avait conclue avec leurs pères, les ordonnances qu'il leur avait données. Ils s'attachèrent à des idoles inutiles et devinrent eux-mêmes aussi inutiles que leurs idoles, comme les nations qui les entouraient, alors que Yahvé leur avait commandé de ne pas les imiter."
,"16":"Ils abandonnèrent tous les commandements de Yahvé leur Dieu, ils se firent des idoles de métal: leurs deux veaux! Ils dressèrent des pieux sacrés, ils se prosternèrent devant toutes les puissances du ciel, et ils servirent Baal."
,"17":"Ils sacrifièrent leurs fils et leurs filles par le feu, ils pratiquèrent la sorcellerie et la magie, ils se vendirent pour faire ce qui est mal au regard de Yahvé, pour le mettre en colère."
,"18":"Finalement, Yahvé s'emporta contre Israël et le rejeta loin de lui. Seule la tribu de Juda est restée. "
,"19":"Mais Juda non plus n'a pas observé les commandements de Yahvé, son Dieu; ils ont imité les pratiques qui étaient devenues habituelles en Israël."
,"20":"C'est pourquoi Yahvé a rejeté toute la race d'Israël, il les a frappés, il les a livrés aux mains de pillards et en fin de compte il les a rejetés loin de lui."
,"21":"Lorsque Jéroboam fils de Nabat a arraché Israël à la maison de David, lorsqu'on l'a consacré comme roi, il a éloigné Israël loin de Yahvé: il lui a fait commettre un grand péché."
,"22":"Les Israélites ont persévéré dans tous les péchés que Jéroboam avait commis, ils ne s'en sont pas détournés."
,"23":"Si bien qu'à la fin Yahvé a rejeté Israël loin de lui, comme il l'avait dit par la bouche de tous ses serviteurs les prophètes; Israël a été déporté en Assyrie loin de sa terre jusqu'à ce jour."
,"24":"Le roi d'Assyrie fit venir des gens de Babylone, de Kouta, de Awa, de Hamat, et de Séfarvayim; il les installa dans les villes de Samarie à la place des Israélites. Ils prirent ainsi possession de la Samarie et s'établirent dans ses villes."
,"25":"Au début, quand ils s'installèrent dans ce lieu, ces gens n'honoraient pas Yahvé, aussi Yahvé envoya-t-il contre eux des lions qui en firent un carnage."
,"26":"Alors ils dirent au roi d'Assyrie: 'Les nations que tu as déportées et installées dans les villes de Samarie ne connaissent pas la Loi du Dieu du pays. C'est pourquoi il a envoyé contre elles des lions et ceux-ci les font mourir, car ils ne connaissent pas la Loi du Dieu du pays.'"
,"27":"Le roi d'Assyrie donna donc cet ordre: 'Renvoyez là-bas l'un des prêtres que j'ai déportés, il s'y établira et il leur apprendra la Loi du Dieu du pays.'"
,"28":"L'un des prêtres de Samarie qui avaient été déportés y alla donc; il s'établit à Béthel et il leur apprit comment on devait honorer Yahvé."
,"29":"Mais chaque nation se faisait ses propres dieux et les plaçait dans les maisons des Hauts-Lieux que les Samaritains avaient construits , chaque nation dans les villes où elle habitait."
,"30":"Ainsi les gens de Babylone se firent un Soukot-Bénot; les gens de Kouta, un Nergal; ceux de Hamat, un Achima;"
,"31":"les Avites se firent un Nibhaz et un Tartak; les gens de Séfarvayim faisaient passer leurs enfants par le feu en l'honneur d'Adramélek et d'Anamélek, les divinités de Séfarvayim."
,"32":"Ils servaient aussi Yahvé, c'est pourquoi ils choisirent parmi eux des prêtres pour les Hauts-Lieux, pour servir en leur nom dans les maisons des Hauts-Lieux."
,"33":"Ils servaient Yahvé mais ils servaient aussi leurs dieux selon les coutumes des nations d'où ils avaient été déportés."
,"34":"Jusqu'à ce jour ils suivent leurs anciennes coutumes. Ils n'honorent pas vraiment Yahvé, car ils ne tiennent pas compte de ses rites et de ses coutumes, selon la Loi et le commandement que Yahvé a donnés aux fils de Jacob, l'homme à qui il a donné le nom d'Israël."
,"35":"Yahvé avait conclu avec eux une Alliance et il leur avait donné cet ordre: 'Vous ne servirez pas les dieux étrangers, vous ne vous prosternerez pas devant eux, vous ne leur rendrez pas de culte et vous ne leur offrirez pas de sacrifices:"
,"36":"vous n'aurez que Yahvé, qui vous a fait monter du pays d'Egypte en montrant sa force, en frappant de grands coups. C'est lui que vous servirez, c'est devant lui que vous vous prosternerez et c'est à lui que vous offrirez des sacrifices."
,"37":"Vous observerez et vous mettrez en pratique tous les jours les préceptes, les ordonnances, la Loi et le commandement qu'il a écrits pour vous; vous ne servirez pas d'autres dieux."
,"38":"N'oubliez pas l'Alliance que j'ai conclue avec vous et ne servez pas d'autres dieux."
,"39":"C'est Yahvé, votre Dieu, que vous servirez, lui vous délivrera de la main de tous vos ennemis.'"
,"40":"Mais ils n'ont pas entendu, ils continuent avec leurs anciennes coutumes."
,"41":"Ainsi donc, ces nations craignaient Yahvé mais elles servaient aussi leurs idoles, et leurs fils et leurs petits-fils agissent jusqu'à ce jour comme faisaient leurs pères."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Ezéquias, fils d'Akaz, roi de Juda, devint roi en la troisième année d'Osée fils d'Ela, roi d'Israël."
,"2":"Il avait vingt-cinq ans lorsqu'il monta sur le trône, et il régna vingt-neuf ans à Jérusalem. Sa mère s'appelait Abiya, elle était fille de Zékarias."
,"3":"Il fit ce qui est juste au regard de Yahvé, tout comme l'avait fait son ancêtre David."
,"4":"Il fit disparaître les Hauts-Lieux, il brisa les pierres dressées, coupa les pieux sacrés et détruisit même le serpent d'airain que Moïse avait fait, car jusqu'à ce jour les Israélites lui offraient de l'encens; on l'appelait Néhouchtan."
,"5":"Il mit sa confiance en Yahvé, le Dieu d'Israël, et parmi les rois de Juda qui le suivirent, pas un ne lui fut comparable."
,"6":"Il resta attaché à Yahvé; jamais il ne se détourna de lui, mais il observa les commandements que Yahvé avait ordonnés à Moïse."
,"7":"Pour cette raison Yahvé fut avec lui et il réussit dans tout ce qu'il entreprit. Il se révolta contre le roi d'Assyrie et cessa de le servir;"
,"8":"il écrasa les Philistins jusqu'à Gaza et ses environs, détruisant tours de garde et villes fortes."
,"9":"La quatrième année du roi d'Ezéquias - c'était la septième année d'Osée fils d'Ela, roi d'Israël - Salmanazar roi d'Assyrie monta contre Samarie, l'assiégea et la prit."
,"10":"Au bout de trois ans, en la sixième année d'Ezéquias - c'était la neuvième année d'Osée, roi d'Israël - Samarie fut prise."
,"11":"Le roi d'Assyrie déporta les Israélites en Assyrie et les installa à Halah, sur les bords du fleuve de Gozan, appelé Habor, et dans les villes des Mèdes."
,"12":"Tout cela, parce qu'ils n'avaient pas obéi à la parole de Yahvé, leur Dieu, et qu'ils avaient violé son Alliance; ils n'avaient pas tenu compte de tout ce qu'avait ordonné Moïse, le serviteur de Yahvé, ils ne l'avaient pas mis en pratique."
,"13":"En la quatorzième année du roi Ezéquias, Sennakérib roi d'Assyrie vint attaquer toutes les villes fortifiées de Juda et s'en empara."
,"14":"Alors Ezéquias roi de Juda envoya ce message au roi d'Assyrie qui était à Lakish: 'Je suis coupable! Eloigne-toi de moi et je ferai ce que tu me demanderas.' Le roi d'Assyrie exigea d'Ezéquias, roi de Juda, trois cents talents d'argent et trente talents d'or."
,"15":"Ezéquias donna tout l'argent qui était dans la Maison de Yahvé et dans les trésors du palais royal."
,"16":"En ce temps-là Ezéquias, roi de Juda, enleva des portes du Temple de Yahvé et de leurs montants, l'or dont il les avait revêtus, pour le donner au roi d'Assyrie."
,"17":"De Lakish, le roi d'Assyrie envoya à Jérusalem vers le roi Ezéquias son général en chef, son grand eunuque et son grand échanson avec une armée importante; ils se mirent en route et arrivèrent à Jérusalem. Ils se tenaient près de l'aqueduc de la piscine supérieure qui se trouve sur la route du champ du Foulon."
,"18":"Ils appelèrent le roi. Alors Elyaqim fils d'Hilkiyas, maître du palais, Chebna le secrétaire et Yoah fils d'Asaf, l'archiviste, sortirent à sa rencontre."
,"19":"Le grand échanson leur dit: 'Vous redirez à Ezéquias ces paroles du grand roi, le roi d'Assyrie: Sur quoi peux-tu encore compter?"
,"20":"Tu crois peut-être que pour faire la guerre quelques déclarations remplacent la sagesse et la bravoure? Sur qui t'es-tu appuyé pour te révolter contre moi?"
,"21":"Tu t'es appuyé sur l'Egypte; mais ce n'est qu'un roseau brisé: celui qui s'appuie dessus, il lui perce la main et la transperce. Voilà ce qu'est Pharaon, le roi d'Egypte, pour tous ceux qui comptent sur lui!"
,"22":"Vous me direz peut-être: C'est en Yahvé, notre Dieu, que nous mettons notre confiance! Mais les Hauts-Lieux et les autels de Yahvé, c'est bien Ezéquias qui les a fait disparaître quand il a dit à Juda et à Jérusalem: Vous ne vous prosternerez qu'à Jérusalem et devant cet autel."
,"23":"Fais donc maintenant un pari avec mon seigneur le roi d'Assyrie: je te donne deux mille chevaux si tu possèdes assez de cavaliers pour les monter."
,"24":"Mais tu ne pourrais même pas faire reculer le dernier des chefs qui servent mon seigneur. Alors que tu comptais sur l'Egypte pour recevoir des chars et des cavaliers,"
,"25":"moi, c'est par la volonté de Yahvé que je suis monté contre cet endroit pour le ravager. C'est Yahvé qui m'a dit: Monte contre ce pays et ravage-le!'"
,"26":"Elyaqim, Chebna et Yoah, répondirent au grand échanson: 'Je t'en prie, parle à tes serviteurs en araméen, car nous le comprenons, mais ne nous parle pas en judéen devant tous ces gens qui se trouvent sur le rempart.'"
,"27":"Le grand échanson leur dit: 'Est-ce à ton patron et à toi que mon seigneur m'a envoyé porter ces paroles? N'est-ce pas plutôt à ces hommes assis sur la muraille, qui bientôt devront tout comme vous manger leurs excréments et boire leur urine?'"
,"28":"Le grand échanson se leva alors et d'une voix forte cria en judéen: 'Ecoutez la parole du grand roi, du roi d'Assyrie:"
,"29":"Ezéquias vous trompe! Il est incapable de vous sauver de ma main."
,"30":"Et qu'il ne vous dise pas de compter sur Yahvé; qu'il ne dise pas: Yahvé nous délivrera sûrement et cette ville ne sera pas livrée entre les mains du roi d'Assyrie."
,"31":"N'écoutez pas Ezéquias; voyez au contraire ce que dit le roi d'Assyrie: Faites la paix avec moi, rendez-vous à moi, et chacun de vous continuera de manger de sa vigne et de son figuier, chacun de vous boira de l'eau de sa citerne."
,"32":"Plus tard je viendrai et je vous emmènerai dans un pays semblable au vôtre, un pays de blé et de vin, un pays de pain et de vignobles, un pays d'huile fraîche et de miel. Là vous vivrez, vous ne mourrez pas. Mais n'écoutez pas Ezéquias, car il vous trompe quand il vous dit que Yahvé vous délivrera. "
,"33":"Est-ce que les dieux des nations ont été capables de sauver chacun son pays de la main du roi d'Assyrie?"
,"34":"Où sont les dieux de Hamat et d'Arpad, où sont les dieux de Séfarvayim, de Héna et de Ivva? Où sont les dieux du pays de Samarie? Ont-ils été capables de sauver Samarie de ma main?"
,"35":"Parmi tous les dieux de ces pays, lequel a été capable de délivrer son pays de ma main? Et Yahvé délivrerait Jérusalem?'"
,"36":"Le peuple gardait le silence, il ne répondit pas un mot, car le roi en avait donné l'ordre: 'Vous ne lui répondrez pas!'"
,"37":"Puis Elyaqim fils de Hilqiyas, le secrétaire Chebna et l'archiviste Yoah fils d'Asaf, retournèrent auprès d'Ezéquias, les vêtements déchirés. Ils lui rapportèrent les paroles du grand échanson."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Lorsque le roi Ezéquias entendit ces paroles, il déchira ses habits, il se couvrit d'un sac et se rendit à la Maison de Yahvé."
,"2":"Puis il envoya le maître du palais Elyaqim, le secrétaire Chebna et les anciens des prêtres vers le prophète Isaïe, fils d'Amos: tous étaient vêtus de sacs."
,"3":"Ils lui dirent: 'Voici ce qu'a dit Ezéquias: Ce jour est un jour de malheur, de châtiment et de honte. L'enfant est pour sortir du sein maternel, mais la force manque pour accoucher."
,"4":"Que Yahvé, ton Dieu, entende toutes les paroles du grand échanson que le roi d'Assyrie, son seigneur, a envoyé pour insulter le Dieu vivant. Que Yahvé, ton Dieu, punisse les paroles qu'il a entendues; et toi, fais monter une prière en faveur du reste qui subsiste encore.'"
,"5":"Les serviteurs du roi Ezéquias arrivèrent auprès d'Isaïe."
,"6":"Isaïe leur dit: 'Vous redirez à votre maître cette parole de Yahvé: N'aie pas peur des paroles que tu as entendues, ces blasphèmes que les serviteurs du roi d'Assyrie ont prononcés contre moi."
,"7":"Je vais agir sur son esprit, lui faire entendre une nouvelle qui le fera reprendre la route de son pays et, dans son pays, je le ferai tomber par l'épée.'"
,"8":"Le grand échanson repartit et trouva le roi d'Assyrie occupé à combattre contre Libna: le grand échanson savait déjà que le roi avait quitté Lakish"
,"9":"après avoir reçu cette nouvelle: 'Tirhaka, roi de Kouch, s'est mis en route pour te faire la guerre.',De nouveau donc, le roi envoya des messagers à Ezéquias en leur disant: "
,"10":"'Voici ce que vous direz à Ezéquias, roi de Juda: Tu mets ta confiance en ton Dieu et tu dis que Jérusalem ne sera pas livrée entre les mains du roi d'Assyrie. Mais ton Dieu pourrait bien te décevoir."
,"11":"Tu as entendu ce que les rois d'Assyrie ont fait à tous les pays, ils les ont voués à l'anathème. Pourquoi toi serais-tu délivré?"
,"12":"Les dieux des nations que mes pères ont exterminées, Gozan, Haran, Récef et les Edénites qui étaient à Tel-Basar, ont-ils été capables de les sauver?"
,"13":"Où sont les rois d'Hamat, d'Arpad, de Laïr, de Séfarvayim, de Héna et de Ivva?'"
,"14":"Ezéquias prit la lettre des mains des messagers et la lut, puis il se rendit à la Maison de Yahvé. Là, Ezéquias la déroula devant Yahvé"
,"15":"et il fit cette prière: 'Yahvé, Dieu d'Israël, Dieu qui sièges sur les Chérubins, il n'y a pas d'autre Dieu que toi dans tous les royaumes de la terre: c'est toi qui as fait le ciel et la terre."
,"16":"Prête l'oreille, Yahvé, entends, ouvre les yeux, Yahvé, et vois! Entends les paroles, les insultes de Sennakérib contre le Dieu vivant."
,"17":"C'est vrai, Yahvé, les rois d'Assyrie ont ravagé les nations païennes."
,"18":"Ils ont livré leurs dieux au feu, mais ce n'étaient pas des dieux, seulement l'oeuvre des mains de l'homme, du bois et de la pierre; ils les ont donc détruits."
,"19":"Mais maintenant, Yahvé, notre Dieu, délivre-nous de sa main, je t'en prie, et tous les royaumes de la terre sauront que toi seul, Yahvé, tu es Dieu!'"
,"20":"Isaïe, fils d'Amos, envoya dire ceci à Ezéquias: 'Voici ce que dit Yahvé, le Dieu d'Israël: J'ai entendu la prière que tu m'as adressée au sujet de Sennakérib, roi d'Assyrie."
,"21":"Eh bien, voici la parole que Yahvé prononce contre lui: Elle te méprise, elle se moque de toi, la vierge fille de Sion, elle secoue la tête en te regardant, la fille de Jérusalem."
,"22":"Qui as-tu insulté avec tes blasphèmes? Contre qui as-tu élevé la voix et levé tes yeux pleins d'orgueil? Contre le Saint d'Israël!"
,"23":"Par la bouche de tes messagers tu as insulté le Seigneur! Tu as dit: Avec mes nombreux chars j'ai gravi les sommets des montagnes, les pentes du Liban. J'ai coupé la forêt de cèdres et les plus beaux de ses cyprès. J'ai atteint le plus lointain de ses repaires et son jardin boisé."
,"24":"J'ai creusé, et j'ai bu des eaux étrangères, j'ai desséché sous la plante de mes pieds tous les canaux de l'Egypte."
,"25":"On ne t'a donc pas dit que depuis longtemps je préparais cela? Dès le commencement j'ai fait un projet, que maintenant je réalise. Tu devais transformer des villes fortifiées en un tas de ruines;"
,"26":"leurs habitants, trop faibles, étaient effrayés, apeurés; ils étaient comme l'herbe des champs, comme le gazon encore vert, comme la mousse qui pousse sur les toits, comme le grain qui rouille avant de devenir épi."
,"27":"Mais je sais lorsque tu t'assieds, lorsque tu sors et que tu rentres. Et quand tu te mets en colère contre moi, je le sais encore."
,"28":"Eh bien, puisque tu t'es mis en colère contre moi et que ton insolence est montée jusqu'à mes oreilles, je vais passer mon anneau à ta narine, et mon mors à tes lèvres, et je te reconduirai par le chemin par lequel tu es venu."
,"29":"Maintenant, voici un signe pour toi, Ezéquias: cette année on mangera du grain tombé; l'an prochain, le grain qui pousse tout seul, mais la troisième année vous sèmerez et vous moissonnerez; vous planterez des vignes et vous en mangerez le fruit."
,"30":"Les rescapés de la maison de Juda donneront de nouveau des racines en bas et des fruits en haut."
,"31":"Car de Jérusalem sortira un reste et du mont Sion, des survivants. Ce sera l'oeuvre de Yahvé Sabaot et de son soin jaloux."
,"32":"C'est pourquoi, voici ce que Yahvé dit au sujet du roi d'Assyrie: Il n'entrera pas dans cette ville et il n'y lancera pas de flèches. Il ne dressera pas contre elle le bouclier, il ne fera pas monter un remblai,"
,"33":"mais il retournera par le chemin par lequel il est venu. Il n'entrera pas dans cette ville. Parole de Yahvé! "
,"34":"Je protégerai cette ville et je la sauverai, à cause de moi et de mon serviteur David.'"
,"35":"Cette même nuit l'ange de Yahvé sortit et frappa dans le camp des Assyriens cent quatre-vingt-cinq mille hommes. Le matin, quand on se leva, il n'y avait que des cadavres: tous morts!"
,"36":"Sennakérib, roi d'Assyrie, partit donc et revint séjourner à Ninive."
,"37":"Là, pendant qu'il était prosterné dans la Maison de son dieu Nisrok, ses fils Adramélek et Sarécer le frappèrent de leur épée et prirent la fuite au pays d'Ararat. Asarhaddon, son fils, devint roi à sa place."
}`)
	CurrentBook.AddChapter(20, `{
"1":"En ces jours-là Ezéquias fut atteint d'une maladie mortelle. Le prophète Isaïe, fils d'Amos, vint le trouver et lui dit: 'Voici ce que dit Yahvé: Mets ordre à ta maison car tu vas mourir. Tu n'en réchapperas pas.'"
,"2":"Alors Ezéquias se tourna le visage contre le mur et fit cette prière à Yahvé:"
,"3":"'Ah Yahvé, je t'en supplie, rappelle-toi comment j'ai marché devant toi avec sincérité et d'un coeur fidèle! J'ai fait ce qui est juste à tes yeux.' Et Ezéquias pleura, pleura beaucoup."
,"4":"Isaïe n'était pas encore sorti de la cour du milieu, lorsque la parole de Yahvé lui fut adressée:"
,"5":"'Retourne et va dire à Ezéquias, chef de mon peuple: Voici ce que dit Yahvé, le Dieu de David, ton père: J'ai entendu ta prière et j'ai vu tes larmes. Je vais te guérir, dans trois jours tu monteras à la Maison de Yahvé."
,"6":"Je rajouterai quinze années à ta vie. De plus je te délivrerai, toi et cette ville, de la main du roi d'Assyrie, je protégerai cette ville à cause de moi et de mon serviteur David.'"
,"8":"Ezéquias dit à Isaïe: 'Comment être sûr que Yahvé me guérira et que dans trois jours je monterai à la Maison de Yahvé? Je voudrais un signe.'"
,"9":"Isaïe répondit: 'Voici le signe que Yahvé te donne pour te montrer qu'il accomplira la parole qu'il a dite. Veux-tu que l'ombre avance de dix degrés ou qu'elle recule de dix degrés?'"
,"10":"Ezéquias lui dit: 'Ce n'est pas difficile pour l'ombre d'avancer de dix degrés, mais c'est tout différent si l'ombre recule de dix.'"
,"11":"Alors le prophète Isaïe pria Yahvé: il fit reculer l'ombre sur dix degrés qu'elle avait déjà parcourus sur les degrés d'Akaz."
,"7":"Isaïe dit alors: 'Que l'on prenne un gâteau de figues.' On en prit un qu'on plaça sur l'ulcère, et le roi guérit."
,"12":"En ce temps-là Mérodak-Baladan, fils de Baladan, roi de Babylone, envoya des lettres et un cadeau à Ezéquias; il avait appris en effet comment Ezéquias s'était remis de sa maladie."
,"13":"Ezéquias en fut si heureux qu'il montra aux envoyés tous ses trésors, l'argent, l'or, les parfums, l'huile parfumée, les armes: en un mot, tout ce qui se trouvait dans ses magasins. Ezéquias leur montra absolument tout dans son palais et dans toutes ses dépendances."
,"14":"Alors le prophète Isaïe alla trouver le roi Ezéquias et lui dit: 'Qu'est-ce que ces hommes t'ont dit? D'où viennent-ils te voir?' Ezéquias répondit: 'Ils arrivent d'un pays lointain, de Babylone.'"
,"15":"Isaïe lui dit: 'Qu'ont-ils vu dans ton palais?' Ezéquias répondit: 'Ils ont vu tout ce qu'il y a dans mon palais. Il n'y a rien dans mes magasins que je ne leur aie montré.'"
,"16":"Isaïe dit à Ezéquias: 'Ecoute cette parole de Yahvé:"
,"17":"Des jours viendront où l'on emportera à Babylone tout ce qui se trouve dans ton palais, tout ce que tes pères ont entassé jusqu'à ce jour; il n'en restera rien, dit Yahvé."
,"18":"On prendra de tes fils issus de toi, ceux que tu as engendrés, et ils seront eunuques dans le palais du roi de Babylone.'"
,"19":"Ezéquias répondit à Isaïe: 'Elle est bonne, cette parole de Yahvé que tu viens de prononcer!' Car il se disait: 'Qu'importe, pourvu que durant ma vie il y ait paix et tranquillité.'"
,"20":"Le reste des actes d'Ezéquias, toute sa bravoure, comment il fit la piscine et le canal pour amener l'eau dans la ville, tout cela n'est-il pas écrit au Livre des Chroniques des rois de Juda?"
,"21":"Ezéquias se coucha avec ses pères, et son fils Manassé régna à sa place."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Manassé avait douze ans quand il monta sur le trône, il régna cinquante- cinq ans à Jérusalem. Sa mère s'appelait Hephsiba."
,"2":"Il fit ce qui est mal au regard de Yahvé, selon les pratiques honteuses des nations que Yahvé avait dépossédées devant les Israélites."
,"3":"Il reconstruisit les Hauts-Lieux que son père Ezéquias avait fait disparaître. Il dressa un autel à Baal, un pieu sacré comme l'avait fait Akab, roi d'Israël; il se prosterna devant toute l'Armée des Cieux et se mit à la servir."
,"4":"Il construisit des autels dans la Maison de Yahvé, dans ce temple dont Yahvé lui-même avait dit: 'C'est à Jérusalem que je mettrai mon Nom.'"
,"5":"Il construisit des autels à toute l'Armée des Cieux dans les deux cours de la Maison de Yahvé."
,"6":"Il offrit son fils en sacrifice par le feu, il pratiqua l'astrologie et la magie, il installa des sorciers et des devins, et de bien des façons il provoqua la colère de Yahvé en faisant ce qui est mal à ses yeux."
,"7":"Il mit la statue d'Ashéra qu'il avait faite dans la Maison dont Yahvé avait dit à David et à Salomon son fils: 'C'est dans ce Temple, dans cette ville de Jérusalem que j'ai choisie parmi toutes les tribus d'Israël, que je mettrai mon Nom pour toujours."
,"8":"S'ils font bien tout ce que je leur ai commandé, s'ils pratiquent la Loi que mon serviteur Moïse leur a ordonnée, je ne ferai plus errer Israël loin de la terre que j'ai donnée à ses pères.'"
,"9":"Mais ils n'écoutèrent pas et Manassé les entraîna à faire le mal, plus encore que les nations que Yahvé avait détruites devant les Israélites."
,"10":"C'est ce que Yahvé déclara par la bouche de ses serviteurs les prophètes:"
,"11":"'Manassé, roi de Juda, a fait des choses honteuses. Il a agi plus mal encore que les Amorites qui étaient là auparavant, et par ses idoles il a fait pécher Juda."
,"12":"C'est pourquoi, dit Yahvé, Dieu d'Israël, je ferai venir sur Jérusalem et sur Juda un malheur tel, que les oreilles tinteront à tous ceux qui l'apprendront."
,"13":"Je nivellerai Jérusalem comme j'ai fait pour Samarie, je la traiterai comme la maison d'Akab. Je nettoierai Jérusalem comme on nettoie un plat: on le lave et ensuite on le retourne à l'envers."
,"14":"Je rejetterai le reste de ceux qui m'appartenaient, je les livrerai aux mains de leurs ennemis et ils deviendront la proie et le butin de tous leurs ennemis."
,"15":"Car depuis le jour où leurs pères sont montés d'Egypte jusqu'à ce jour, ils ont fait ce qui est mal à mes yeux; ils n'ont fait que me mettre en colère.'"
,"16":"En plus du péché que Manassé fit commettre à Juda, faisant ce qui est mal au regard de Yahvé, il répandit le sang innocent à tel point que Jérusalem en était remplie d'un bout à l'autre."
,"17":"Le reste des actes de Manassé, tout ce qu'il a fait, le péché qu'il a commis, cela n'est-il pas écrit dans le Livre des Chroniques des rois de Juda?"
,"18":"Manassé se coucha avec ses pères et on l'enterra dans le jardin de sa maison, dans le jardin d'Ouza. Son fils Amon régna à sa place."
,"19":"Amon avait vingt-deux ans lorsqu'il monta sur le trône, il régna deux ans à Jérusalem; sa mère était Méchoulémet, fille de Harous, de Yotba."
,"20":"Il fit ce qui est mal au regard de Yahvé, tout comme son père Manassé."
,"21":"Il suivit en tout point la conduite de son père, il servit les ordures qu'avait servies son père et il se prosterna devant elles."
,"22":"Il abandonna Yahvé, le Dieu de ses pères, au lieu de marcher dans ses voies."
,"23":"Les serviteurs d'Amon conspirèrent contre lui: ils assassinèrent le roi dans son palais."
,"24":"Mais le peuple-du-pays fit périr tous ceux qui avaient conspiré contre le roi Amon; ils établirent Josias, son fils, comme roi à sa place."
,"25":"Le reste des actes d'Amon, ce qu'il a fait, cela n'est-il pas écrit au Livre des Chroniques des rois de Juda?"
,"26":"On l'enterra dans la tombe de son père, dans le jardin d'Ouza, et son fils Josias régna à sa place."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Josias avait huit ans lorsqu'il monta sur le trône, il régna trente et un ans à Jérusalem; sa mère était Yédida, fille d'Adaya, de Boskat."
,"2":"Il fit ce qui est juste au regard de Yahvé et il marcha sur les traces de David, son ancêtre, ne s'en détournant ni à droite ni à gauche."
,"3":"En la dix-huitième année du roi Josias, le roi envoya le secrétaire Chafan, fils d'Asalyas, fils de Méchoulam, au Temple de Yahvé."
,"4":"Il lui dit: 'Va trouver le grand prêtre Hilkiyas. Qu'il fasse le compte exact de l'argent qui a été apporté au Temple de Yahvé et que les gardiens de la porte ont reçu du peuple."
,"5":"Il le remettra à ceux qui s'occupent des travaux, à ceux qui ont la charge de la Maison de Yahvé. Ils le donneront aux ouvriers qui font le travail dans la Maison de Yahvé et qui réparent les dégâts de la Maison,"
,"6":"aux charpentiers, aux constructeurs et aux maçons, et l'on achètera également le bois et les pierres de taille pour réparer la Maison."
,"7":"Mais ne faites pas de comptes avec eux, à propos de cet argent qu'on leur a confié, car ce sont des gens honnêtes.'"
,"8":"Le grand prêtre Hilkiyas dit alors au secrétaire Chafan: 'Dans la Maison de Yahvé, j'ai trouvé le livre de la Loi.' Puis il donna le livre à Chafan, qui le lut."
,"9":"Le secrétaire Chafan se rendit alors auprès du roi et lui fit son rapport. Il lui dit: 'Tes serviteurs ont versé l'argent qui se trouvait dans la Maison et ils l'ont remis aux mains des ouvriers qui sont chargés de la Maison de Yahvé.'"
,"10":"Puis le secrétaire Chafan annonça la nouvelle au roi: 'Le prêtre Hilkiyas, lui dit-il, m'a donné un livre.' Et Chafan le lut en présence du roi."
,"11":"Lorsque le roi entendit les paroles du livre de la Loi, il déchira ses habits."
,"12":"Le roi donna cet ordre au prêtre Hilkiyas, à Ahikam fils de Chafan, à Akbor fils de Mikaya, au secrétaire Chafan et au ministre du roi Asaya:"
,"13":"'Allez consulter Yahvé pour moi, pour le peuple, pour tout Juda, au sujet des paroles de ce livre que l'on a trouvé. Yahvé doit être prêt à décharger sur nous toute sa colère, parce que nos pères n'ont pas obéi aux paroles de ce livre et n'ont pas mis en pratique tout ce qui y est écrit.'"
,"14":"Alors le prêtre Hilkiyas, Ahikam, Akbor, Chafan et Asaya, se rendirent auprès de la prophétesse Houlda; elle était femme de Chaloum, fils de Tikva, fils de Harhas, le gardien des vêtements, et elle habitait à Jérusalem dans le quartier neuf. Lorsqu'ils la mirent au courant,"
,"15":"elle leur répondit: 'Voici ce que dit Yahvé, Dieu d'Israël: Rapportez à l'homme qui vous a envoyés vers moi "
,"16":"cette parole de Yahvé: Je vais faire venir sur ce lieu et sur ses habitants tous les malheurs annoncés dans le livre qu'a lu le roi de Juda."
,"17":"Car ils m'ont abandonné et ils ont offert de l'encens à d'autres dieux. Ils m'ont mis en colère par leur conduite: ma colère contre ce lieu est devenue un feu qui ne s'éteindra pas."
,"18":"Quant au roi de Juda qui vous a envoyés pour consulter Yahvé, vous lui redirez cette parole de Yahvé, Dieu d'Israël:"
,"19":"Ton coeur a été touché et tu t'es humilié devant Yahvé en entendant ce que j'ai dit contre ce lieu et ses habitants, que leur sort serait épouvantable, une vraie malédiction. Tu as déchiré tes habits et tu as pleuré devant moi, et je t'ai entendu - oracle de Yahvé!"
,"20":"C'est pourquoi je te réunirai à tes pères et je te ferai déposer en paix dans la tombe: ainsi tu ne verras pas tous les malheurs que je fais venir sur ce lieu.' Ils rapportèrent au roi cette réponse."
}`)
	CurrentBook.AddChapter(23, `{
"1":"Le roi envoya alors un message, et tous les anciens de Juda et de Jérusalem se rassemblèrent autour de lui."
,"2":"Il monta à la Maison de Yahvé accompagné de tous les hommes de Juda et de tous les habitants de Jérusalem, des prêtres et des prophètes, de tout le peuple, du plus petit jusqu'au plus grand. Devant eux il lut toutes les paroles du livre de l'Alliance qui avait été trouvé dans la Maison de Yahvé."
,"3":"Le roi se tenait debout sur l'estrade et, en présence de Yahvé, il conclut l'alliance. On s'engageait à suivre Yahvé, à observer ses commandements, ses ordres et ses préceptes, de tout son coeur et de toute son âme, afin de respecter les paroles de cette alliance comme elles sont écrites dans ce livre; tout le peuple s'engagea dans l'alliance."
,"4":"Le roi donna ordre au grand prêtre Hilkiyas, au prêtre en second et aux gardiens de la porte, de jeter hors de la Maison de Yahvé tous les objets qu'on avait faits pour Baal, pour Ashéra et pour toute l'Armée des cieux. Il les fit brûler en dehors de Jérusalem au bûcher du Cédron, et on porta leurs cendres à Béthel."
,"5":"Il supprima les faux prêtres que les rois de Juda avaient installés et qui offraient l'encens sur les Hauts-Lieux, dans les villes de Juda et les environs de Jérusalem. Il supprima aussi ceux qui offraient l'encens aux Baals, au soleil, à la lune, aux étoiles et à toute l'Armée des cieux."
,"6":"Il sortit l'Ashéra de la Maison de Yahvé, la jeta hors de Jérusalem dans la vallée du Cédron, et là il la fit brûler et réduire en cendres, puis il en jeta les cendres à la fosse des gens du peuple."
,"7":"Il démolit les maisons des prostitués sacrés qui étaient dans la Maison de Yahvé, et où des femmes tissaient des voiles pour l'Ashéra."
,"8":"Il rappela des villes de Juda tous les prêtres; il profana les Hauts-Lieux où ces prêtres offraient de l'encens, depuis Guéba jusqu'à Bersabée. Il démolit le Haut-Lieu des portes, qui était à l'entrée de la Porte-de-Josué, gouverneur de la ville, à gauche lorsqu'on pénétrait dans la ville."
,"9":"Ces prêtres des Hauts-Lieux n'eurent pas accès à l'autel de Yahvé à Jérusalem, ils se contentèrent de manger les pains sans levain au milieu de leurs frères."
,"10":"Josias détruisit le bûcher de la vallée de Ben-Hinnom, pour que plus personne ne puisse sacrifier par le feu son fils ou sa fille en l'honneur de Molek."
,"11":"Il élimina les chevaux que les rois de Juda avaient consacrés au soleil, à l'entrée de la Maison de Yahvé, près de la chambre de l'eunuque Nétan-Mélek (elle se trouvait dans les dépendances) et il jeta au feu le char du soleil."
,"12":"Le roi démolit encore et réduisit en poudre les autels qui avaient été installés par les rois de Juda sur le toit de la chambre haute d'Akaz, et les autels que Manassé avait placés dans les deux cours de la Maison de Yahvé. Il en jeta la poussière dans le torrent du Cédron."
,"13":"Le roi détruisit également les Hauts-Lieux qui se trouvaient face à Jérusalem, au sud du mont des Oliviers: Salomon, roi d'Israël, les avait construits en l'honneur d'Astarté, l'ordure des Sidoniens, de Kémoch, l'ordure des Moabites, et de Milkom, la honte des Ammonites."
,"14":"Il brisa aussi les pierres dressées, fit couper les pieux sacrés, et on remblaya l'endroit avec des ossements humains."
,"15":"Il démolit l'autel qui était à Béthel, le Haut-Lieu construit par Jéroboam fils de Nabat, qui avait entraîné Israël dans le péché. Il démolit le Haut-Lieu, il en brisa les pierres et les réduisit en poussière, après quoi, il brûla le pieu sacré."
,"16":"Josias, en se retournant, aperçut les tombeaux creusés dans la montagne. Il envoya prendre des ossements dans ces tombes et il les brûla sur l'autel pour le profaner; alors s'accomplit la parole de Yahvé qu'un homme de Dieu avait proclamée un jour de fête, lorsque Jéroboam officiait à l'autel. Se retournant de nouveau, Josias aperçut le tombeau de l'homme de Dieu qui avait proclamé ces paroles."
,"17":"Il demanda: 'Quel est ce monument que je vois là-bas?' Les gens de la ville répondirent: 'C'est le tombeau de l'homme de Dieu qui est venu de Juda et qui a annoncé ce que tu viens de faire pour profaner l'autel de Béthel.'"
,"18":"Le roi leur dit: 'Laissez-le! Que personne ne touche à ses ossements.' On épargna donc ses ossements ainsi que ceux du prophète qui était venu de Samarie."
,"19":"Josias fit disparaître toutes les maisons des Hauts-Lieux que les rois d'Israël avaient installées dans les villes de Samarie et qui avaient provoqué la colère de Yahvé. Il les traita de la même manière qu'il avait traité Béthel."
,"20":"Il fit massacrer sur leurs autels tous les prêtres des Hauts-Lieux qui se trouvaient là; il y fit brûler des ossements humains, puis il rentra à Jérusalem."
,"21":"Le roi donna ensuite cet ordre à tout le peuple: 'Célébrez la Pâque en l'honneur de Yahvé votre Dieu, selon ce qui est écrit dans ce livre de l'Alliance.'"
,"22":"Durant tout le temps des rois d'Israël et de Juda, depuis le temps des Juges qui avaient gouverné Israël, on n'avait jamais plus célébré une Pâque comme celle-là."
,"23":"Il fallut attendre la dix-huitième année du roi Josias pour voir célébrer à Jérusalem une Pâque comme celle-là."
,"24":"Josias balaya les sorciers et les devins, les idoles et les ordures: en un mot, toutes les horreurs qu'on voyait dans le pays de Juda et à Jérusalem. Il mettait ainsi en pratique les paroles de la Loi écrites dans le livre que le prêtre Hilkiyas avait trouvé dans la Maison de Yahvé."
,"25":"Aucun roi avant lui ne s'était comme lui tourné vers Yahvé de tout son coeur, de toute son âme, de toutes ses forces, en total accord avec la Loi de Moïse, et pas un roi comme lui ne se leva après lui."
,"26":"Cependant Yahvé ne revint pas de sa très grande colère contre Juda à cause de toutes les actions de Manassé qui l'avaient scandalisé."
,"27":"C'est pourquoi Yahvé déclara: 'Juda aussi, je le rejetterai loin de moi comme j'ai rejeté Israël. Je rejetterai Jérusalem, cette ville que j'avais choisie, ainsi que la Maison dont j'avais dit: là sera mon Nom.'"
,"28":"Le reste des actes de Josias, tout ce qu'il a fait, cela n'est-il pas écrit au Livre des Chroniques des rois de Juda?"
,"29":"De son temps le Pharaon Nékao, roi d'Egypte, fit une expédition vers l'Euphrate pour combattre le roi d'Assyrie. Le roi Josias se porta à sa rencontre, mais Nékao le fit frapper dès qu'il le vit."
,"30":"De Méguiddo, ses serviteurs ramenèrent son corps en char et le firent entrer dans Jérusalem où on le déposa dans sa tombe; puis le peuple choisit Joakaz, fils de Josias, on le consacra et on l'établit comme roi à la place de son père."
,"31":"Joakaz avait vingt- trois ans lorsqu'il monta sur le trône et il régna trois mois à Jérusalem; sa mère était Hamoutal, fille de Yirméyas, de Libna."
,"32":"Il fit ce qui est mal au regard de Yahvé, tout comme avaient fait ses ancêtres."
,"33":"A Ribla, au pays de Hamat, le Pharaon Nékao le fit enchaîner, mettant fin à son règne à Jérusalem; puis il fixa au pays un tribut de cent talents d'argent et de dix talents d'or."
,"34":"Le Pharaon Nékao établit Eliakim, fils de Josias comme roi, à la place de Josias son père, et il changea son nom en Joïaqim. Après quoi il emmena Joakaz en Egypte où il mourut."
,"35":"Joïaqim livra bien au Pharaon l'argent et l'or, mais il dut imposer le pays pour livrer au Pharaon la somme exigée. Il préleva sur chacun, selon sa fortune, l'argent et l'or que l'on devait au Pharaon Nékao."
,"36":"Joïaqim avait vingt-cinq ans lorsqu'il monta sur le trône, il régna onze ans à Jérusalem; sa mère était Zébida, fille de Pédaya, de Rouma."
,"37":"Il fit ce qui est mal au regard de Yahvé, tout comme avaient fait ses ancêtres."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Durant ses jours, Nabukodonozor roi de Babylone envahit le pays, et Joïaqim lui fut soumis pendant trois ans; mais ensuite il se révolta contre lui."
,"2":"Yahvé envoya contre lui des bandes kaldéennes, des Araméens, des Moabites et des Ammonites; il les envoya contre Juda pour le faire disparaître, selon la parole que Yahvé avait dite par la bouche de ses serviteurs les prophètes."
,"3":"C'est sur l'ordre de Yahvé que tout cela est arrivé à Juda. Il voulait écarter Juda loin de lui à cause des péchés de Manassé,"
,"4":"mais aussi à cause du sang innocent tellement répandu que Jérusalem en était remplie; Yahvé ne voulait plus pardonner."
,"5":"Le reste des actes de Joïaqim, tout ce qu'il a fait, cela n'est-il pas écrit dans le Livre des Chroniques des rois de Juda?"
,"6":"Joïaqim se coucha avec ses pères, et Joïakin, son fils, régna à sa place."
,"7":"Le roi d'Egypte ne sortit plus de ses frontières, car le roi de Babylone avait pris tout ce qui appartenait au roi d'Egypte, depuis le torrent d'Egypte jusqu'au fleuve de l'Euphrate."
,"8":"Joïakin avait dix-huit ans lorsqu'il monta sur le trône, il régna trois mois à Jérusalem; sa mère Néhouchta était fille d'Elnatan de Jérusalem."
,"9":"Il fit ce qui est mal au regard de Yahvé, tout comme l'avait fait son père."
,"10":"En ce temps-là, les hommes de Nabukodonozor, roi de Babylone, marchèrent sur Jérusalem, et la ville fut assiégée."
,"11":"Nabukodonozor, roi de Babylone, arriva pour attaquer la ville alors que ses hommes l'assiégeaient."
,"12":"Joïakin, roi de Juda, sortit pour se rendre au roi de Babylone avec sa mère, ses serviteurs, ses chefs et ses eunuques; le roi de Babylone le fit prisonnier la huitième année de son règne."
,"13":"Il emporta tous les trésors de la Maison de Yahvé et les trésors du palais royal. Il brisa tous les objets d'or que Salomon, roi d'Israël, avait faits pour la Maison de Yahvé, comme Yahvé l'avait prédit."
,"14":"Il déporta tout Jérusalem, tous les chefs et tous les hommes de guerre, soit dix mille déportés en comptant tous les forgerons et tous les serruriers; du peuple-du-pays il ne laissa que les petites gens."
,"15":"Il déporta Joïakin à Babylone; il fit partir en déportation de Jérusalem vers Babylone, la mère du roi, ses femmes, ses eunuques et les personnages importants du pays."
,"16":"Le roi de Babylone fit déporter à Babylone sept mille hommes qui valaient: mille forgerons et serruriers et tous les hommes en état de porter les armes."
,"17":"Le roi de Babylone établit comme roi à la place de Joïakin son oncle Mattanya dont il changea le nom en Sédécias."
,"18":"Sédécias avait vingt et un ans lorsqu'il monta sur le trône, il régna onze ans à Jérusalem; sa mère Hamital était fille de Yirméyas, de Libna."
,"19":"Il fit ce qui est mal au regard de Yahvé, tout comme l'avait fait Joïaqim."
,"20":"Et c'est la colère de Yahvé qui détermina le sort de Jérusalem et de Juda jusqu'au jour où il finit par les rejeter loin de lui. Sédécias se révolta contre le roi de Babylone."
}`)
	CurrentBook.AddChapter(25, `{
"1":"En la neuvième année du règne de Sédécias, le dixième jour du dixième mois, Nabukodonozor, roi de Babylone, arriva avec toute son armée devant Jérusalem. Ils campèrent face à la ville et construisirent un retranchement tout autour:"
,"2":"elle fut assiégée jusqu'en la onzième année du roi Sédécias."
,"3":"Le neuf du quatrième mois, la famine était telle dans la ville qu'il n'y avait plus de pain pour le peuple-du-pays."
,"4":"C'est alors que s'ouvrit une brèche dans le rempart et, de nuit, tous les hommes de guerre s'enfuirent par la Porte-entre-les-deux-murs qui domine le jardin du roi, et ils prirent le chemin de la Steppe."
,"5":"L'armée des Kaldéens se lança à la poursuite du roi; ils l'atteignirent dans la plaine de Jéricho et toute sa troupe se dispersa loin de lui."
,"6":"On saisit le roi et on l'amena devant le roi de Babylone, à Ribla; on le fit passer en jugement."
,"7":"Le roi de Babylone égorgea les fils de Sédécias sous ses yeux, puis il lui creva les yeux et l'emmena à Babylone enchaîné d'une double chaîne de bronze."
,"8":"Le sept du cinquième mois, on était dans la dix-neuvième année de Nabukodonozor, roi de Babylone, ce fut l'entrée à Jérusalem de Nébuzaradan, chef des gardes et officier du roi de Babylone."
,"9":"Il brûla la Maison de Yahvé, le palais royal, et toutes les maisons de Jérusalem."
,"10":"Les troupes kaldéennes qui accompagnaient le chef des gardes détruisirent le rempart tout autour de Jérusalem."
,"11":"Nébuzaradan, chef des gardes, déporta le reste de la population: ceux qui étaient restés dans la ville, ceux qui avaient déserté pour passer au roi de Babylone et le reste des artisans."
,"12":"Le chef des gardes laissa les petites gens du pays pour travailler comme vignerons et cultivateurs."
,"13":"Les Kaldéens brisèrent les colonnes de bronze de la Maison de Yahvé, les bases et la Mer de bronze qui étaient dans la Maison de Yahvé, et ils emportèrent tout ce bronze à Babylone."
,"14":"Ils emmenèrent aussi les chaudrons, les pelles, les couteaux, les coupes et tous les objets de bronze qui servaient au culte."
,"15":"Le chef des gardes prit encore les brûloirs et les cruchettes, tout ce qui était en or ou en argent."
,"16":"Les deux colonnes, la Mer et ses bases que Salomon avait faites pour la Maison de Yahvé, cela représentait un poids de bronze incalculable."
,"17":"En effet, la hauteur d'une colonne était de dix-huit coudées, elle était surmontée d'un chapiteau de bronze, et la hauteur d'un chapiteau était de trois coudées. Il y avait aussi le filet et les grenades qui entouraient le chapiteau, ils étaient en bronze; les deux colonnes étaient semblables."
,"18":"Le chef des gardes prit Séraya, le chef des prêtres, Séfanyas, le prêtre en second, et les trois gardiens des portes."
,"19":"Il prit encore un eunuque de la ville qui était préposé aux hommes de troupes, cinq hommes attachés au service personnel du roi qui se trouvaient dans la ville, le secrétaire du chef de l'armée, celui qui recrutait parmi le peuple-du-pays, et soixante de ceux-ci qui se trouvaient alors dans la ville."
,"20":"Nébuzaradan, chef des gardes, les arrêta et les amena au roi de Babylone à Ribla."
,"21":"Le roi de Babylone les fit mettre à mort à Ribla, au pays de Hamat. Ainsi Juda fut déporté loin de sa terre."
,"22":"Nabukodonozor, roi de Babylone, avait laissé une partie de la population dans le pays de Juda; il lui donna comme gouverneur Godolias, fils d'Ahiqam, fils de Chafan."
,"23":"Lorsque les chefs d'armée et leurs hommes apprirent que le roi de Babylone avait mis en place Godolias, ils vinrent le trouver à Mispa: c'était Ismaël, fils de Nétanya, Yohanan, fils de Karéah, Séraya, fils de Tanhoumet, qui était de Nétofa, Yaazanyas du pays de Maaka. Ils vinrent donc avec leurs troupes."
,"24":"Godolias leur prêta serment à eux et à leurs hommes. Il leur dit: 'N'ayez pas peur des Kaldéens, restez dans le pays, servez le roi de Babylone et tout ira bien pour vous.'"
,"25":"Mais au septième mois, Ismaël fils de Nétanya, fils d'Elichama, qui était de la famille royale, arriva avec dix hommes et mit à mort Godolias ainsi que les Judéens et les Kaldéens qui étaient auprès de lui à Mispa."
,"26":"Alors tout le peuple, du plus petit jusqu'au plus grand, s'enfuit en Egypte avec les chefs de l'armée par peur des Kaldéens."
,"27":"En la trente-septième année de la déportation de Joïakin, roi de Juda, au douzième mois, le vingt-sept du mois, Evil-Mérodak, roi de Babylone, fit grâce à Joïakin, roi de Juda, et le sortit de prison. Evil-Mérodak, qui était monté sur le trône cette année-là,"
,"28":"se lia d'amitié avec Joïakin, il plaça son trône au-dessus des trônes des autres rois déportés avec lui à Babylone."
,"29":"Il lui fit enlever ses vêtements de prisonnier, et désormais, jusqu'à la fin de sa vie, Joïakin prit ses repas à la table du roi."
,"30":"Sa nourriture fut constamment assurée par le roi de Babylone, jour après jour, jusqu'à la fin de sa vie."
}`)

}
func FR_LBDCC_LoadVH2SChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"La mort de Saül survint peu après que David avait massacré les Amalécites: depuis deux jours déjà il était revenu à Siklag."
,"2":"Le troisième jour un homme arriva du camp de Saül, il avait des habits déchirés et de la terre sur la tête. Dès qu'il arriva près de David, il se jeta à terre et se prosterna."
,"3":"David lui dit: 'D'où viens-tu?' Il répondit: 'Je me suis sauvé du camp d'Israël.'"
,"4":"David lui dit: 'Comment les choses se sont-elles passées? Dis-le moi donc.' Cet homme répondit: 'Le peuple s'est enfui du champ de bataille, beaucoup dans le peuple sont tombés et sont morts, Saül aussi et son fils Jonathan sont morts.'"
,"5":"David dit au jeune homme qui lui apportait cette nouvelle: 'Comment sais-tu que Saül et son fils Jonathan sont morts?'"
,"6":"Il répondit: 'Je me trouvais par hasard sur les monts de Guelboé. Saül s'appuyait sur sa lance, les chars et les cavaliers le serraient de près."
,"7":"Alors il me voit, il se retourne et m'appelle. Je lui dis: Me voici."
,"8":"Il me dit: Qui es-tu? Je lui dis: Je suis un Amalécite."
,"9":"Il me dit: Approche-toi et donne-moi la mort, je suis encore plein de force et pourtant me voici pris de vertige."
,"10":"Alors je me suis approché et je l'ai tué car je savais bien qu'il ne survivrait pas une fois tombé à terre, puis j'ai pris la couronne qui était sur sa tête, la chaîne qu'il portait au bras, et je les ai apportées ici à mon seigneur.'"
,"11":"David déchira ses habits, et tous les hommes qui étaient avec lui firent de même."
,"12":"Ils poussèrent une grande lamentation, ils pleurèrent, ils jeûnèrent jusqu'au soir à cause de Saül et de son fils Jonathan, à cause du peuple de Yahvé et de la maison d'Israël qui étaient tombés sous l'épée."
,"13":"David dit ensuite au jeune homme qui lui apportait cette nouvelle: 'D'où es-tu?' Il répondit: 'Je suis un étranger dans ce pays, fils d'un Amalécite.'"
,"14":"David lui dit: 'Comment donc as-tu osé frapper à mort celui que Yahvé avait consacré?'"
,"15":"Alors David appela l'un de ses compagnons et lui dit: 'Approche et frappe-le.' Il le frappa et il mourut."
,"16":"David dit encore: 'Que ton sang retombe sur ta tête. Tu t'es condamné toi-même quand tu as dit que tu avais frappé à mort l'homme consacré par Yahvé.'"
,"17":"Puis David entonna une lamentation sur Saül et sur son fils Jonathan"
,"18":"et il ordonna de l'apprendre aux fils de Juda: c'est le chant de l'arc, qu'on peut lire dans le livre du Juste."
,"19":"Comment sont-ils tombés sur les montagnes, ces héros qui faisaient la gloire d'Israël?"
,"20":"Ne l'annoncez pas dans Gat, ne portez pas la nouvelle dans les rues d'Ashkélon, ne donnez pas cette joie aux femmes Philistines, aux filles des incirconcis!"
,"21":"Que plus jamais rosée ni pluie ne tombent sur vous, montagnes de Guelboé, campagne verdoyante: c'est là que fut profané le bouclier des héros. Il ne fallait pas d'huile pour le bouclier de Saül,"
,"22":"mais le sang des blessés, la graisse des héros. Ni l'arc de Jonathan ne reculait, ni l'épée de Saül ne frappait dans le vide."
,"23":"Vous étiez aimés, désirés, Saül et Jonathan: ni la vie ni la mort ne vous ont séparés. Ils étaient plus rapides que les aigles, ils étaient plus forts que les lions."
,"24":"Pleurez sur Saül, filles d'Israël!,Il vous revêtait d'étoffes de couleur, sur vos robes de fête il posait des bijoux d'or."
,"25":"Comment sont-ils tombés, ces héros?,Qui frappa à mort Jonathan, au coeur du combat?"
,"26":"J'ai le coeur brisé pour toi, Jonathan, mon frère, tu m'étais si cher! Ton amour était pour moi, plus merveilleux que l'amour des femmes."
,"27":"Comment sont-ils morts, les héros?,Comment furent-elles brisées, les armes de guerre?"
}`)
	CurrentBook.AddChapter(2, `{
"1":"Après cela David consulta Yahvé: 'Monterai-je dans l'une des villes de Juda?' Yahvé répondit: 'Monte.' David ajouta: 'Où monterai-je?' Et Yahvé répondit: 'A Hébron.'"
,"2":"David monta donc avec ses deux femmes, Ahinoam de Yizréel et Abigayil femme de Nabal de Karmel."
,"3":"David fit monter également ses compagnons d'armes, chacun avec sa famille, et ils s'installèrent dans les villes d'Hébron."
,"4":"Alors les hommes de Juda se rassemblèrent, et là ils consacrèrent David comme roi sur la maison de Juda. On fit savoir à David que les gens de Yabech de Galaad avaient enterré Saül.' "
,"5":"Alors David envoya de ses hommes aux gens de Yabech de Galaad avec ce message: 'Que Yahvé vous bénisse pour avoir enterré Saül, votre seigneur, pour lui avoir montré ainsi votre attachement."
,"6":"Que Yahvé vous montre sa bonté et sa fidélité: moi aussi je vous revaudrai cette belle action."
,"7":"Mais ne vous lamentez plus sur la mort de Saül votre seigneur, sachez que les hommes de la maison de Juda m'ont consacré comme roi à leur tête.'"
,"8":"Abner, fils de Ner, était chef de l'armée de Saül. Il emmena Ichbaal, le fils de Saül, et le fit passer à Mahanayim."
,"9":"Là il l'établit comme roi de Galaad, de la tribu d'Asher, de Yizréel, Ephraïm et Benjamin: en un mot, de tout Israël."
,"10":"Ichbaal, fils de Saül, avait quarante ans lorsqu'il devint roi d'Israël et il régna deux ans, tandis que la maison de Juda suivait David."
,"11":"David régna à Hébron sur la maison de Juda durant sept ans et six mois."
,"12":"Abner fils de Ner et la garde d'Ichbaal fils de Saül quittèrent Mahanayim pour se rendre à Gabaon."
,"13":"Joab fils de Sérouya et la garde de David se mirent également en route, et les deux troupes se rencontrèrent près de l'étang de Gabaon. Les premiers s'arrêtèrent d'un côté de l'étang, les autres de l'autre côté."
,"14":"Abner dit à Joab: 'Que les jeunes gens se lèvent et luttent devant nous.' Joab répondit: 'D'accord, qu'ils se lèvent.'"
,"15":"Ils se levèrent et on les dénombra: il y en avait douze de la tribu de Benjamin pour Ichbaal fils de Saül, et douze de la garde de David."
,"16":"Chacun saisit son adversaire par la tête et lui enfonça son épée dans le côté, si bien qu'ils tombèrent tous ensemble. On a appelé cet endroit le Champ des Côtés, il se trouve à côté de Gabaon."
,"17":"Ce jour-là il y eut une très dure bataille, Abner et les gens d'Israël furent battus par la garde de David."
,"18":"Les trois fils de Sérouya étaient là: Joab, Abisaï et Azaël. Or Azaël était rapide à la course comme une gazelle sauvage,"
,"19":"il se lança à la poursuite d'Abner sans s'écarter ni à droite ni à gauche."
,"20":"Abner se retourna et lui dit: 'C'est toi Azaël?' Il répondit: 'Oui, c'est moi.'"
,"21":"Alors Abner lui dit: 'Ecarte-toi à droite ou à gauche et lance-toi sur l'un de ces jeunes, si tu veux prendre son équipement.' Mais Azaël ne voulut pas s'écarter de lui."
,"22":"Abner répéta à Azaël: 'Ecarte-toi de moi, sinon je te laisse sur le sol; mais comment pourrais-je ensuite parler à ton frère?'"
,"23":"Comme il refusait de s'écarter, Abner le frappa au ventre avec la pointe de sa lance et la lance lui ressortit par le dos: il tomba là et mourut sur place. Tous ensuite s'arrêtèrent à mesure qu'ils arrivaient à l'endroit où Azaël était tombé mort."
,"24":"Joab et Abisaï se lancèrent à la poursuite d'Abner et, lorsque le soleil se couchait, ils arrivèrent à la colline d'Amma, à l'est de Giah sur le chemin du désert de Gabaon."
,"25":"Les gens de Benjamin se groupèrent alors derrière Abner en formation serrée, et ils s'arrêtèrent au sommet d'une colline."
,"26":"Abner interpella Joab: 'L'épée dévorera-t-elle toujours, ne sais-tu pas que cela finira dans les larmes? Qu'attends-tu pour ordonner à tes hommes de cesser de poursuivre leurs frères?"
,"27":"Joab répondit: 'Aussi vrai que Yahvé est vivant, si tu n'avais pas parlé, c'est jusqu'au matin que ces gens auraient poursuivi leurs frères.'"
,"28":"Alors Joab fit sonner du cor et toute l'armée s'arrêta, on cessa de poursuivre Israël et le combat finit."
,"29":"Abner et ses hommes marchèrent par la Araba durant toute la nuit, ils traversèrent le Jourdain et, après avoir marché toute une matinée encore, ils arrivèrent à Mahanayim."
,"30":"Joab, de son côté, avait rassemblé ses troupes après avoir mis fin à la poursuite d'Abner; la garde de David avait perdu dix-neuf hommes en plus d'Azaël,"
,"31":"mais elle avait tué à ceux de Benjamin, dans l'armée d'Abner, trois cent soixante hommes."
,"32":"On emporta Azaël et on l'enterra dans le tombeau de son père à Bethléem. Joab et ses hommes marchèrent toute la nuit et ils arrivèrent à Hébron au lever du jour."
}`)
	CurrentBook.AddChapter(3, `{
"1":"La guerre se prolongea entre la maison de Saül et celle de David. David s'imposait de plus en plus, tandis que le parti de Saül s'effritait."
,"2":"David eut des fils à Hébron: l'aîné était Amnon, né d'Ahinoam de Yizréel;"
,"3":"le second était Kiléab, né d'Abigayil femme de Nabal de Karmel; le troisième, Absalom fils de Maaka, une fille de Talmaï, roi de Guéchour,"
,"4":"le quatrième était Adonias, né de Haggit; le cinquième, Chéfatyas, né d'Abital,"
,"5":"le sixième, Yitréam né d'Egla, femme de David. Tous ces fils de David naquirent à Hébron."
,"6":"Durant la guerre entre la maison de Saül et la maison de David, Abner prenait de plus en plus d'importance dans la maison de Saül."
,"7":"Saül avait une concubine nommée Rispa, fille d'Ayya, Abner la prit. Ichbaal dit à Abner: 'Pourquoi as-tu pris la concubine de mon père?'"
,"8":"A ces mots Abner entra dans une violente colère contre Ichbaal: 'Suis-je donc une tête de chien? Je me suis montré plein d'attentions pour la maison de Saül ton père, pour ses frères et ses amis, je ne t'ai pas laissé entre les mains de David, et aujourd'hui tu me fais une scène pour une histoire de femme?"
,"9":"Que Dieu me maudisse et me maudisse encore si je ne réalise pas moi-même ce que Yahvé a promis par serment à David."
,"10":"Il a dit qu'il enlèverait la royauté à la maison de Saül et qu'il ferait David roi d'Israël et de Juda, depuis Dan jusqu'à Bersabée.'"
,"11":"Ichbaal n'osa pas répliquer un seul mot à Abner, car il avait peur de lui."
,"12":"Abner envoya des messagers à David: 'Fais un accord avec moi et je t'aiderai à rassembler autour de toi tout Israël.'"
,"13":"David répondit: 'Très bien, je ferai un accord avec toi. Je ne mets qu'une condition: quand tu viendras, tu me ramèneras Mikal, la fille de Saül; sinon il est inutile de te présenter devant moi.'"
,"14":"David envoya des messagers à Ichbaal, fils de Saül: 'Rends-moi ma femme Mikal qu'on m'a donnée contre cent prépuces de Philistins.'"
,"15":"Alors Ishbaal l'envoya prendre chez son nouveau mari Paltiel, fils de Layich."
,"16":"Son mari partit avec elle et l'accompagna en pleurant jusqu'à Bahourim. Là Abner lui dit: 'Retourne chez toi!' Et il s'en retourna."
,"17":"Abner eut des entretiens avec les anciens d'Israël; il leur dit: 'Déjà ces derniers temps vous avez demandé que David règne sur vous."
,"18":"Maintenant passez aux actes, car Yahvé a parlé de David en ces termes: Par la main de mon serviteur David, je sauverai mon peuple Israël de la main des Philistins et de tous ses ennemis.'"
,"19":"Abner parla ainsi aux hommes de Benjamin, puis il alla répéter à David, à Hébron, tout ce que souhaitaient les gens d'Israël et de Benjamin."
,"20":"Abner vint trouver David à Hébron avec vingt hommes, et David fit un festin pour Abner et pour les hommes qui l'accompagnaient."
,"21":"Abner dit alors à David: 'Maintenant je m'en vais pour rassembler tout Israël autour de mon seigneur le roi; ils feront un pacte avec toi, et tu régneras sur tout ce que tu peux souhaiter. Puis David congédia Abner qui s'en retourna en paix."
,"22":"Or voici que Joab et la garde de David revenaient d'une razzia: ils ramenaient un énorme butin. Abner, lui, avait quitté David à Hébron, David l'avait congédié et il s'en retournait tranquillement."
,"23":"Lorsque Joab et sa troupe arrivèrent, on avertit Joab qu'Abner, fils de Ner était venu chez le roi et que celui-ci l'avait congédié amicalement."
,"24":"Alors Joab entra chez le roi et lui dit: 'Qu'as-tu fait? Abner est venu chez toi et tu l'as laissé partir?"
,"25":"Tu connais Abner, fils de Ner: il est venu pour te tromper, pour connaître tes faits et gestes et savoir ce que tu prépares.'"
,"26":"Aussitôt sorti de chez David, et sans le dire à David, Joab envoya des messagers à la citerne de Sira pour faire revenir Abner."
,"27":"Et quand Abner arriva à Hébron, Joab l'entraîna à l'intérieur de la porte sous prétexte de parler discrètement avec lui; là il le frappa au ventre pour venger le sang de son frère Azaël. Abner mourut."
,"28":"David n'apprit la chose qu'ensuite. Il s'écria: 'Moi et mon royaume nous serons pour toujours innocents devant Yahvé, du sang d'Abner, fils de Ner."
,"29":"Que ce sang retombe sur la tête de Joab et sur toute la maison de son père. Qu'il y ait toujours dans la maison de Joab des malades souffrant d'un écoulement ou de lèpre, des hommes bons pour manier le fuseau, des victimes de l'épée, des gens qui manquent de pain!'"
,"30":"(Joab et son frère Abisaï avaient tué Abner parce qu'il avait frappé à mort leur frère Azaël lors du combat de Gabaon.)"
,"31":"David dit ensuite à Joab et à tout le monde qui était autour de lui: 'Déchirez vos vêtements, mettez des sacs sur vos reins et faites le deuil pour Abner.' Le roi David marchait derrière le corps."
,"32":"Pendant l'enterrement à Hébron, le roi éleva la voix et pleura devant la tombe: tout le peuple pleurait avec lui."
,"33":"Le roi entonna alors cette lamentation sur Abner: 'Abner devait-il mourir comme un homme de rien?"
,"34":"Tes mains n'étaient pas liées, tes pieds n'étaient pas serrés dans des chaînes de bronze, mais tu es tombé comme on tombe devant des criminels.',Tout le peuple se remit à pleurer."
,"35":"Tous insistèrent auprès de David pour qu'il mange pendant qu'il faisait encore jour, mais David fit ce serment: 'Que Dieu me maudisse et me maudisse encore si je goûte du pain ou quoi que ce soit avant le coucher du soleil.'"
,"36":"Les gens du peuple furent très impressionnés et trouvèrent cela très bien, d'ailleurs ils trouvaient très bien tout ce que faisait le roi."
,"37":"Ainsi tout le peuple et tout Israël comprirent que ce n'était pas le roi qui avait fait assassiner Abner, fils de Ner."
,"38":"Le roi dit à ses serviteurs: 'Ne savez-vous pas qu'un chef, un grand chef, est tombé aujourd'hui en Israël?"
,"39":"Moi, pour l'instant, je ne peux pas grand-chose bien que j'aie reçu la consécration royale; ces hommes, les fils de Sérouya, sont plus durs que moi. Que Yahvé fasse payer le mal à celui qui l'a fait!'"
}`)
	CurrentBook.AddChapter(4, `{
"1":"Le fils de Saül apprit qu'Abner était mort à Hébron; les bras lui en tombèrent et tout Israël trembla."
,"2":"Le fils de Saül avait deux chefs de bande, deux fils de Rimmon de Béérot: l'un s'appelait Baana et le second s'appelait Rékab."
,"3":"Les gens de Béérot s'étaient réfugiés à Gittayim et ils étaient restés là jusqu'à ce jour.)"
,"4":"Il y avait là un fils de Jonathan, fils de Saül, qui était infirme des deux pieds. Lorsque la nouvelle de la mort de Saül et de Jonathan arriva à Yizréel, il n'avait que cinq ans. Sa nourrice l'emporta et prit la fuite, mais dans la précipitation l'enfant tomba et s'estropia; il s'appelait Méribaal."
,"5":"Les fils de Rimmon de Béérot, Rékab et Baana, partirent pour la maison d'Ichbaal: ils arrivèrent au plus chaud du jour tandis que celui-ci faisait la sieste."
,"6":"La femme qui gardait la porte s'était assoupie et endormie tandis qu'elle triait son blé. Rékab et son frère Baana entrèrent discrètement,"
,"7":"ils pénétrèrent dans la maison et trouvèrent Ichbaal étendu sur son lit dans la chambre à coucher. Ils le frappèrent et lui coupèrent la tête, puis toute la nuit ils marchèrent par la route de la Araba, emportant sa tête."
,"8":"Ils apportèrent la tête d'Ichbaal à David, à Hébron, et ils dirent au roi: 'Voici la tête d'Ichbaal, le fils de ton ennemi Saül qui en voulait à ta vie. Aujourd'hui Yahvé a vengé mon seigneur le roi, de Saül et de sa race.'"
,"9":"Mais David répondit à Rékab et à son frère Baana, fils de Rimmon de Béérot: 'Aussi vrai que Yahvé est vivant, lui qui m'a délivré de toutes mes détresses,"
,"10":"lorsqu'un homme est venu me trouver avec cette nouvelle: Saül est mort! il se croyait porteur d'une bonne nouvelle, mais je l'ai fait arrêter et tuer à Siklag, alors que j'aurais pu le récompenser pour cette bonne nouvelle."
,"11":"A plus forte raison lorsque des malfaiteurs ont tué un homme droit dans sa maison tandis qu'il dormait; je vais vous faire payer le sang que vous avez versé, je vais vous balayer de la terre!'"
,"12":"David donna des ordres aux jeunes gens qui étaient présents et on les mit à mort. Ensuite on leur coupa les mains et les pieds et on les attacha au-dessus de la piscine d'Hébron. On prit alors la tête d'Ichbaal et on la déposa dans le tombeau d'Abner à Hébron."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Toutes les tribus d'Israël se rassemblèrent autour de David à Hébron et lui dirent: 'Nous sommes de tes os et de ta chair."
,"2":"Déjà auparavant, lorsque Saül était notre roi, c'est toi qui conduisais Israël. Yahvé t'a bien dit: C'est toi qui seras le pasteur de mon peuple Israël, tu deviendras le chef d'Israël.'"
,"3":"Tous les anciens d'Israël vinrent trouver le roi à Hébron et le roi David conclut une alliance avec eux à Hébron en présence de Yahvé. Après quoi ils consacrèrent David comme roi d'Israël."
,"4":"David avait trente ans lorsqu'il devint roi, il régna quarante ans."
,"5":"Il avait régné sept ans et six mois à Hébron sur Juda, et il régna sur tout Israël et Juda durant trente-trois ans à Jérusalem."
,"6":"Le roi et ses hommes marchèrent sur Jérusalem pour attaquer les Jébusites qui habitaient alors la contrée. Ceux-ci dirent à David: 'Tu n'entreras pas ici, même les aveugles et les boiteux te repousseraient.' Ce qui voulait dire: 'David n'entrera pas ici'."
,"7":"Mais David s'empara de la forteresse de Sion: c'est la cité de David."
,"8":"Ce jour-là en effet, David avait dit: 'Quiconque veut battre les Jébusites, qu'il y pénètre par le canal. Ces boiteux et ces aveugles, David les maudit!' C'est pour cela d'ailleurs que l'on dit: 'Les aveugles et les boiteux n'entreront pas dans la Maison de Dieu.'"
,"9":"David s'installa dans la forteresse et l'appela cité de David, puis il construisit tout autour depuis le Milo vers l'intérieur."
,"10":"David allait sans cesse grandissant, et Yahvé Sabaot était avec lui."
,"11":"Le roi de Tyr, Hiram, envoya une mission à David avec du bois de cèdre, des charpentiers et des tailleurs de pierre, et ils construisirent une maison pour David."
,"12":"Alors David comprit que Yahvé l'avait confirmé comme roi sur Israël et qu'il allait rendre son règne glorieux à cause de son peuple Israël."
,"13":"Après que David fut arrivé d'Hébron, il se choisit encore à Jérusalem des concubines et des femmes; il en eut des fils et des filles."
,"14":"Voici les noms des enfants qu'il eut à Jérusalem: Chammoua, Chobab, Nathan, Salomon,"
,"15":"Yibhar, Elichoua, Néfeg, Yafia,"
,"16":"Elichama, Baalyada et Elifélèt."
,"17":"Lorsque les Philistins apprirent que David avait été sacré roi de tout Israël, ils montèrent tous pour s'emparer de lui; David fut averti et il descendit au refuge."
,"18":"Les Philistins vinrent se déployer dans le vallon des Réphaïm,"
,"19":"et David consulta Yahvé: 'Dois-je attaquer les Philistins? Les livreras-tu entre mes mains?' Yahvé répondit à David: 'Attaque-les, je livrerai les Philistins entre tes mains.'"
,"20":"David avança sur Baal-Pérasim, et là, il les écrasa. 'Yahvé, dit-il, a été comme un torrent: il m'a ouvert une brèche dans les lignes ennemies.' C'est pourquoi on appela cet endroit Baal-Pérasim (le Seigneur de la Brèche)."
,"21":"Les Philistins laissèrent là leurs idoles, David et ses hommes les emportèrent."
,"22":"Une fois de plus les Philistins montèrent et se déployèrent dans le vallon des Réphaïm,"
,"23":"David consulta Yahvé qui répondit: 'Ne les attaque pas de front, prends-les par derrière, passe du côté du bois."
,"24":"Lorsque tu entendras un bruit de pas au sommet des arbres, dépêche-toi: c'est Yahvé qui sort devant toi pour écraser l'armée des Philistins.'"
,"25":"David fit donc comme Yahvé le lui avait commandé, et il battit les Philistins depuis Gabaon jusqu'à l'entrée de Guézer."
}`)
	CurrentBook.AddChapter(6, `{
"1":"David rassembla alors trente mille hommes, toute l'élite d'Israël,"
,"2":"et il se mit en route pour Baala de Juda, accompagné de tout son peuple. Il voulait ramener l'Arche de Dieu sur laquelle a été déposé le Nom de Yahvé Sabaot, celui qui siège sur les Chérubins."
,"3":"On plaça l'Arche de Dieu sur un chariot neuf: on l'avait retirée de chez Abinadab, au sommet de la colline. Ouza et Ahyo, les fils d'Abinadab, conduisaient le chariot:"
,"4":"Ouza marchait à côté de l'Arche de Dieu et Ahyo allait devant elle."
,"5":"David et tous les Israélites dansaient devant Yahvé, de toutes leurs forces; ils chantaient au son des guitares, des harpes, des tambourins, des cymbales et de toute sorte d'instruments."
,"6":"Au moment où l'on approchait de l'aire de Nakon, les boeufs firent un faux pas: Ouza voulut retenir l'Arche de Dieu et il porta la main sur elle."
,"7":"Alors Yahvé se mit en colère contre Ouza et Dieu le frappa surle-champ: il mourut là à côté de l'Arche de Dieu."
,"8":"David était indigné de ce que Yahvé ait transpercé Ouza; depuis cet incident ce lieu s'est appelé Pérez-Ouza."
,"9":"Ce jour-là David eut une vraie crainte de Yahvé, il se dit: 'Comment l'Arche de Yahvé entrerait-elle chez moi?'"
,"10":"David ne voulut donc pas garder l'Arche de Yahvé chez lui, dans la cité de David; il la fit conduire chez Obed-Edom de Gat."
,"11":"L'Arche de Yahvé resta ainsi trois mois chez Obed-Edom de Gat, et Yahvé bénit Obed-Edom et toute sa famille."
,"12":"On fit savoir au roi David que Yahvé bénissait la famille d'Obed-Edom et tout ce qui lui appartenait à cause de l'Arche de Dieu.' Alors David s'y rendit et, en grande joie, il fit monter l'Arche de Dieu depuis la maison d'Obed-Edom jusqu'à la cité de David."
,"13":"Les hommes qui portaient l'Arche de Yahvé firent les six premiers pas: on offrit alors en sacrifice un boeuf et un veau gras."
,"14":"David dansait et tournait de toutes ses forces devant Yahvé, il portait le pagne de lin."
,"15":"David et tous les Israélites firent ainsi monter l'Arche de Yahvé au son de la fanfare et du cor."
,"16":"Lorsque l'Arche entra dans la cité de David, Mikal, fille de Saül regarda par la fenêtre. Elle vit le roi qui sautait et tournait devant Yahvé, et elle le méprisa dans son coeur."
,"17":"Voici donc qu'on amène l'Arche de Yahvé; on l'installe à sa place au milieu de la tente que David a dressée pour elle et David offre à Yahvé des holocaustes et des sacrifices de communion."
,"18":"Lorsque David a achevé d'offrir des holocaustes et des sacrifices de communion, il bénit le peuple au nom de Yahvé Sabaot,"
,"19":"puis il distribue à tout le monde, à tous les Israélites, aux hommes comme aux femmes, à chacun un gâteau, une part de viande, une pâte de raisin sec, et tout le monde repart chez soi."
,"20":"David aussi retourna pour bénir sa maison. Alors Mikal, la fille de Saül, sortit au-devant de David et lui dit: 'Vraiment, le roi d'Israël s'est couvert de gloire aujourd'hui! Tu t'es découvert sous les yeux des femmes de tes serviteurs, comme le ferait un homme de rien.'"
,"21":"Mais David répondit à Mikal: 'Je dansais en présence de Yahvé. Aussi vrai que Yahvé est vivant, lui qui m'a choisi de préférence à ton père et à toute sa famille, pour faire de moi le chef de son peuple Israël, je danserai encore en présence de Yahvé."
,"22":"Je m'abaisserai plus encore et à tes yeux je ne serai rien, mais je serai grand aux yeux de ces femmes dont tu as parlé.'"
,"23":"Et Mikal, fille de Saül, n'eut pas d'enfant jusqu'à sa mort."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Le roi s'était installé dans sa maison, et Yahvé l'avait débarrassé de tous ses ennemis à la ronde."
,"2":"Alors il dit au prophète Nathan: 'J'habite dans une maison de cèdre et l'Arche de Dieu est encore sous la tente: qu'en dis-tu?'"
,"3":"Nathan répondit au roi: 'Fais tout ce qui te paraît bon, car Yahvé est avec toi.'"
,"4":"Mais cette nuit-là la parole de Yahvé fut adressée à Nathan:"
,"5":"' Tu diras à mon serviteur David: Voici ce que dit Yahvé: Est-ce toi qui me construiras une maison pour que j'y habite?"
,"6":"Depuis le jour où j'ai fait sortir les Israélites d'Egypte jusqu'à aujourd'hui, je n'ai pas eu de maison pour habiter, mais j'étais avec eux et je n'avais qu'une tente comme demeure."
,"7":"De tout le temps que j'ai fait route au milieu des Israélites, je n'ai jamais dit à l'un des juges d'Israël, à ceux que j'avais faits pasteurs de mon peuple Israël: Pourquoi ne me construisez-vous pas une maison de cèdre?"
,"8":"Tu vas donc transmettre à mon serviteur David cette parole de Yahvé Sabaot: Je suis allé te chercher au pâturage derrière les brebis, et j'ai fait de toi le chef de mon peuple Israël."
,"9":"Partout où tu allais j'étais avec toi, j'ai éliminé devant toi tous tes ennemis. Je rendrai grand ton nom, autant que celui des plus grands de la terre,"
,"10":"et je mettrai à sa place mon peuple Israël. Là je le planterai et il y restera. Il ne sera plus ballotté; les méchants ne continueront plus de l'opprimer comme autrefois,"
,"11":"lorsque j'établissais des juges sur mon peuple Israël: je le débarrasserai de tous ses ennemis. Et voici ce que Yahvé te fait dire: Moi je vais te construire une maison."
,"12":"Lorsque tes jours seront achevés et que tu te coucheras avec tes pères, j'élèverai après toi ton descendant, celui qui sort de tes entrailles et j'affermirai sa royauté."
,"13":"Lui me construira une maison, et moi, j'affermirai son trône royal pour toujours."
,"14":"Je serai pour lui un père et il sera pour moi un fils; s'il fait le mal je le corrigerai comme font les hommes, je le frapperai de façon humaine."
,"15":"Mais je ne me détournerai pas de lui comme je me suis détourné de Saül, comme je l'ai rejeté de devant moi."
,"16":"Ta maison et ta royauté dureront à jamais devant moi, ton trône sera ferme à jamais.'"
,"17":"Nathan vint donc parler à David, il lui rapporta toutes ces paroles et cette vision."
,"18":"Alors le roi David alla s'asseoir devant Yahvé: 'Qui suis-je Seigneur Yahvé? Qu'est-ce que ma famille pour que tu m'aies conduit jusque là?"
,"19":"Mais cela te paraissait encore trop peu, Seigneur Yahvé, puisque aujourd'hui tu étends tes promesses à la famille de ton serviteur pour un lointain avenir: est-ce là une destinée normale pour un homme, Seigneur Yahvé?"
,"20":"Que pourrait ajouter ton serviteur David? Tu le connais, Seigneur Yahvé."
,"21":"Tu as réalisé librement ces grandes choses pour honorer tes promesses, et tu viens les communiquer à ton serviteur."
,"22":"Oui, vraiment, tu es grand, Seigneur Yahvé: nul n'est comme toi; selon tout ce que nous avons entendu de nos propres oreilles, il n'y a pas d'autre Dieu que toi."
,"23":"Et qui est comme ton peuple Israël? Y-a-t-il une autre nation sur la terre qu'un Dieu soit allé racheter pour en faire son peuple, et pour lui faire un nom, pour faire en sa faveur de grandes et terribles choses, pour chasser devant ce peuple des nations avec leurs dieux?"
,"24":"Tu as établi ton peuple Israël pour qu'il soit à jamais ton peuple, et toi Yahvé, tu es devenu son Dieu."
,"25":"Maintenant donc, Seigneur Yahvé, fais que soit toujours vraie la parole que tu viens de prononcer au sujet de ton serviteur et de sa famille, fais ce que tu as dit."
,"26":"Alors ton Nom sera glorifié à jamais, et l'on dira: Yahvé Sabaot est Dieu en Israël!,La maison de ton serviteur David restera ferme devant toi, "
,"27":"puisque c'est toi Yahvé Sabaot, le Dieu d'Israël, qui as fait cette révélation à ton serviteur: 'Je te bâtirai une maison.' C'est pour cela que ton serviteur a l'audace de t'adresser cette prière."
,"28":"Oui, Seigneur Yahvé, tu es vraiment Dieu, tes paroles sont vraies, et c'est toi qui promets à ton serviteur."
,"29":"Bénis donc la maison de ton serviteur, qu'elle soit à jamais devant toi. C'est toi, Seigneur Yahvé, qui as parlé, et grâce à ta bénédiction la maison de ton serviteur sera bénie pour toujours.'"
}`)
	CurrentBook.AddChapter(8, `{
"1":"Après cela David battit les Philistins et ils lui furent soumis: David mit fin au pouvoir philistin."
,"2":"Il battit de même les Moabites. Il les fit coucher à terre et mesurer avec un cordeau; on en mesurait deux cordeaux qui étaient mis à mort, et un cordeau à qui on laissait la vie. Les Moabites devinrent un peuple soumis qui payait un tribut à David."
,"3":"David battit Hadadézer, fils de Réhob, roi de Saba, lorsque celui-ci fit une expédition pour redevenir maître du Fleuve."
,"4":"Il lui prit mille sept cents combattants des chars et vingt mille hommes de pied. David coupa les jarrets de tous les attelages: il n'en garda que cent."
,"5":"Les Araméens de Damas voulurent porter secours à Hadadézer, roi de Saba, mais David leur tua vingt-mille hommes."
,"6":"Après cela David établit des gouverneurs dans la région de Damas et les Araméens furent soumis à David: ils lui payaient un tribu. C'est ainsi que Yahvé donna la victoire à David partout où il allait."
,"7":"David prit les boucliers d'or que portaient les gardes de Hadadézer et les emmena à Jérusalem."
,"8":"Le roi David enleva encore une énorme quantité de bronze à Tébah et à Bérotaï, les villes de Hadadézer."
,"9":"Lorsque Toou, roi de Hamat, apprit que David avait écrasé l'armée de Hadadézer,"
,"10":"il envoya son fils Hadoram à David pour le saluer et le féliciter d'avoir fait la guerre à Hadadézer et de l'avoir vaincu. Hadadézer en effet était toujours en guerre avec Toou. Hadoram apporta des objets en argent, en or et en bronze."
,"11":"Le roi David consacra le tout à Yahvé, en même temps que l'argent et l'or provenant de toutes les nations qu'il avait soumises:"
,"12":"Aram, Moab, les Ammonites, les Philistins, Amalec; il y avait là, bien entendu, le trésor qu'il avait pris à Hadadézer, fils de Réob, roi de Saba."
,"13":"David se rendit célèbre encore lorsqu'il revint d'avoir battu les Edomites dans la vallée du Sel: ils étaient dix-huit mille."
,"14":"Il établit des gouverneurs en Edom et tous les Edomites furent soumis à David. Yahvé donnait la victoire à David partout où il allait."
,"15":"David régna sur tout Israël, il rendait le droit et faisait justice à son peuple,"
,"16":"Joab, fils de Sérouya commandait l'armée, Yochafat, fils d'Ahiloud était archiviste,"
,"17":"Sadoc et Ebyatar, fils d'Ahimélek, fils d'Ahitoub, étaient prêtres, Séraya était secrétaire;"
,"18":"Bénayas, fils de Yoyada commandait la garde des Kérétiens et des Pélétiens, les fils de David étaient prêtres."
}`)
	CurrentBook.AddChapter(9, `{
"1":"David demanda: 'Y-a-t-il encore un survivant dans la famille de Saül pour que je le traite avec bonté en souvenir de Jonathan?'"
,"2":"Or la famille de Saül avait un intendant qui se nommait Siba. On le conduisit auprès de David et le roi lui dit: 'Tu es bien Siba?' Il répondit: 'Pour te servir.'"
,"3":"Le roi lui demanda: 'Reste-t-il encore un survivant de la famille de Saül pour que je le traite avec une bonté digne de Dieu?' Siba répondit au roi: 'Il reste encore un fils de Jonathan qui est infirme des deux pieds.'"
,"4":"'Où est-il?' demanda le roi. Siba répondit au roi: 'Il est dans la maison de Makir, fils d'Ammiel, à Lo-Débar.'"
,"5":"Le roi David l'envoya donc chercher à la maison de Makir, fils d'Ammiel à Lo-Débar."
,"6":"Quand Méribaal, fils de Jonathan, fils de Saül, arriva auprès de David, il se prosterna le visage contre terre. David lui dit: 'Méribaal!' Il répondit: 'Je suis ton serviteur.'"
,"7":"Alors David lui dit: 'Ne crains rien, je veux te traiter avec bonté à cause de ton père Jonathan. Je te rendrai toutes les terres de Saül ton ancêtre, et tous les jours tu prendras tes repas à ma table.'"
,"8":"Il se prosterna de nouveau et dit: 'Qui est ton serviteur, pour que tu fasses attention à un chien crevé tel que moi?'"
,"9":"Le roi convoqua Siba, le serviteur de Saül, et lui dit: 'Je donne au fils de ton maître tout ce qui appartenait à Saül et à sa famille."
,"10":"Tu travailleras pour lui la terre avec tes fils et tes esclaves, tu en récolteras les fruits, et ainsi tu assureras à la famille de ton maître la nourriture dont elle a besoin. Mais Méribaal, le fils de ton maître, prendra tous les jours ses repas à ma table.' Siba avait quinze fils et vingt esclaves,"
,"11":"il répondit au roi: 'Ton serviteur fera tout ce que mon seigneur le roi a commandé à son serviteur.',Ainsi Méribaal prenait ses repas à la table de David comme l'un des fils du roi, "
,"12":"Méribaal avait un petit garçon qui se nommait Mika. Tous les gens de la maison de Siba travaillaient pour Méribaal,"
,"13":"Mais Méribaal résidait à Jérusalem où il prenait tous les jours ses repas à la table du roi. Il était infirme de ses deux pieds."
}`)
	CurrentBook.AddChapter(10, `{
"1":"En ce temps-là mourut le roi des Ammonites, son fils Anoun régna à sa place."
,"2":"David se dit: 'Je serai plein d'attentions pour Anoun, fils de Nahach, puisque son père a fait la même chose pour moi.' David envoya donc ses serviteurs pour lui présenter ses condoléances à l'occasion de la mort de son père. Mais lorsque les serviteurs de David arrivèrent chez les Ammonites,"
,"3":"les princes Ammonites dirent à leur maître Anoun: 'Penses-tu donc que David a envoyé ses messagers avec des condoléances pour honorer ton père? Il les a sûrement envoyés pour espionner la ville, pour en connaître les défenses et s'en emparer?'"
,"4":"Alors Anoun saisit les serviteurs de David, il leur rasa la moitié de la barbe, coupa leurs vêtements à la hauteur des fesses et les renvoya;"
,"5":"En apprenant cela, David envoya quelqu'un à leur rencontre car ces hommes étaient couverts de honte. Il leur fit dire: 'Restez à Jéricho jusqu'à ce que votre barbe ait repoussé, vous reviendrez ensuite.'"
,"6":"Les Ammonites se rendirent bien compte qu'ils s'étaient rendus odieux à David; ils engagèrent donc à leur service les Araméens de Beth-Réhob et les Araméens de Soba, au nombre de vingt mille hommes. Ils engagèrent également le roi de Maaka avec mille hommes et douze mille hommes de Tob."
,"7":"Quand David apprit cela, il envoya Joab avec toute l'armée et les troupes d'élite."
,"8":"Les Ammonites sortirent et se rangèrent en bataille à l'entrée de la porte, tandis que les Araméens de Soba et de Réhob avec les gens de Tob et de Maaka restaient en rase campagne."
,"9":"Joab se retrouva donc avec des ennemis devant lui et derrière lui. Il choisit les troupes d'élite d'Israël et les rangea face aux Araméens,"
,"10":"puis il confia à son frère Abisaï le reste du peuple, et celui-ci les rangea face aux Ammonites."
,"11":"Il dit alors: 'Si les Araméens sont plus forts que moi, tu viendras à mon secours, si les Ammonites sont plus forts que toi, je viendrai à ton secours."
,"12":"Sois fort, montrons-nous courageux pour notre peuple et pour les villes de notre Dieu; Yahvé fera ce qui lui semblera bon.'"
,"13":"Joab s'avança avec son armée pour combattre les Araméens, et ils s'enfuirent devant lui."
,"14":"Lorsque les Ammonites virent que les Araméens fuyaient, eux aussi tournèrent le dos devant Abisaï et rentrèrent en ville. Alors Joab mit fin à la campagne contre les Ammonites et rentra à Jérusalem."
,"15":"Voyant qu'ils avaient été battus par Israël, les Araméens rassemblèrent leurs forces."
,"16":"Hadadézer envoya des messagers pour appeler tous les Araméens qui étaient de l'autre côté du fleuve et ils se rassemblèrent à Hélam; Chobak, le chef de l'armée d'Hadadézer, était à leur tête."
,"17":"Lorsque David l'apprit, il réunit tout Israël, traversa le Jourdain et arriva à Hélam."
,"18":"Les Araméens se rangèrent en bataille face à David et le combat s'engagea. Les Araméens tournèrent le dos devant Israël et David leur tua sept cents attelages et quarante mille hommes. Chobak, leur chef, fut abattu et mourut sur place."
,"19":"Lorsque tous les rois, vassaux de Hadadézer, virent qu'ils avaient été battus par Israël, ils demandèrent la paix aux Israélites et firent leur soumission; à partir de ce jour les Araméens n'osèrent plus porter secours aux Ammonites."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Au retour de l'année, au moment où les rois se mettent en campagne, David envoya Joab avec sa garde et tout Israël. Ils massacrèrent les Ammonites et assiégèrent Rabba, pendant que David restait à Jérusalem."
,"2":"Or un soir, comme David s'était levé de son lit et faisait les cent pas sur la terrasse du palais, il aperçut du haut de sa terrasse une femme qui prenait son bain; la femme était fort belle."
,"3":"David se renseigna sur cette femme et on lui répondit: 'C'est Bethsabée fille d'Eliam, la femme de Urie le Hittite.'"
,"4":"David envoya des gens pour la lui amener. Elle arriva chez lui, il coucha avec elle alors qu'elle venait de se purifier de ses règles, puis elle retourna dans sa maison."
,"5":"Voyant qu'elle était prise, la femme envoya dire à David: 'Je suis enceinte.'"
,"6":"Alors David fit passer ce message à Joab: 'Envoie-moi Urie le Hittite.' Et Joab envoya Urie à David."
,"7":"Urie arriva, David lui demanda des nouvelles de l'armée et de la guerre,"
,"8":"puis il dit à Urie: 'Va chez toi, tu as bien le droit de te laver les pieds.' Urie sortit de chez le roi et David envoya derrière lui un cadeau de sa table."
,"9":"Mais Urie ne rentra pas chez lui, il coucha à la porte de la maison du roi avec tous les gardes de son maître."
,"10":"On informa David: 'Urie n'est pas descendu chez lui.' David demanda à Urie: 'Ne viens-tu pas de voyager? Pourquoi n'es-tu pas descendu chez toi?'"
,"11":"Urie répondit à David: 'L'Arche de Dieu, Israël et Juda logent sous des tentes. Mon maître Joab et la garde de mon seigneur le roi campent en rase campagne, et moi, je rentrerais chez moi pour manger et boire, pour coucher avec ma femme? Aussi vrai que Yahvé est vivant et que tu vis toi-même, jamais je ne ferai une chose pareille.'"
,"12":"Alors David dit à Urie: 'Reste encore ici aujourd'hui et demain tu repartiras.' Urie resta donc à Jérusalem ce jour-là. Le lendemain"
,"13":"David l'invita à manger et à boire à sa table, et il l'enivra. Cependant, ce soir-là encore Urie ne descendit pas chez lui: il se coucha avec les serviteurs de son maître."
,"14":"Le lendemain matin, David écrivit une lettre à Joab et la fit porter par Urie."
,"15":"Il écrivait ceci dans la lettre: 'Placez Urie au plus fort de la bataille, ensuite écartez-vous de lui pour qu'il soit frappé et qu'il meure.'"
,"16":"Joab assiégeait alors la ville, il plaça Urie à l'endroit où se trouvaient les meilleurs défenseurs."
,"17":"Les gens de la ville firent une sortie et attaquèrent Joab, il y eut des morts dans l'armée parmi les officiers de David et Urie le Hittite mourut aussi."
,"18":"Joab fit porter à David des nouvelles des opérations,"
,"19":"et il donna cet ordre au messager: 'Lorsque tu auras achevé de raconter au roi tous les détails de la bataille,"
,"20":"peut-être le roi se mettra en colère et te dira: Pourquoi vous êtes-vous approchés de la ville dans cette rencontre? Ne savez-vous donc pas que l'on tire du haut des remparts?"
,"21":"Qui donc a frappé Abimélek, fils de Yéroubbaal? N'est-ce pas une femme qui lui a balancé une meule du haut des murs de Tébès, et il en est mort? Pourquoi vous êtes-vous approchés du mur? Alors tu répondras simplement: Ton serviteur Urie le Hittite est mort lui aussi.'"
,"22":"Le messager partit; à son arrivée il redit à David tout le message de Joab. David se mit en colère."
,"23":"Alors le messager lui répondit: 'Ces hommes ont essayé un coup de force contre nous, ils ont fait une sortie en rase campagne, et nous, nous les avons refoulés jusqu'à la porte de la ville."
,"24":"Mais alors les archers ont tiré du haut des remparts sur tes serviteurs, plusieurs des gardes du roi sont morts et ton serviteur Urie le Hittite est parmi les morts.'"
,"25":"David dit au messager: 'Tu diras à Joab qu'il ne se fasse pas de souci pour cette affaire, car l'épée dévore tantôt celui-ci, tantôt celui-là. Dis-lui qu'il renforce son attaque contre la ville jusqu'à la détruire: dis-lui de tenir ferme.'"
,"26":"La femme d'Urie apprit que son mari était mort. Elle en fit le deuil,"
,"27":"et quand les jours du deuil furent achevés, David l'envoya chercher. Il la prit chez lui, elle devint sa femme et elle lui donna un fils; mais ce que David avait fait parut très mal à Yahvé."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Yahvé envoya donc à David le prophète Nathan. Il entra et lui dit: 'Il y avait dans une ville deux hommes, l'un était riche, l'autre était pauvre."
,"2":"Le riche avait beaucoup de petit et de gros bétail,"
,"3":"le pauvre n'avait qu'une seule brebis qu'il avait achetée. Il la nourrissait, elle grandissait à côté de lui avec ses fils, elle mangeait de son pain, buvait dans sa coupe et dormait sur son sein: elle était pour lui comme une fille."
,"4":"Un jour l'homme riche reçut une visite. Comme il ne voulait pas prendre sur son petit ou sur son gros bétail pour préparer un repas au voyageur qui lui arrivait, il vola la brebis du pauvre et la prépara pour son visiteur.'"
,"5":"David entra dans une grande colère contre cet homme et dit à Nathan: 'Aussi vrai que Yahvé est vivant, l'homme qui a fait cela mérite la mort."
,"6":"Il remboursera quatre fois la brebis pour avoir commis une telle action et n'avoir pas eu de pitié.'"
,"7":"Alors Nathan dit à David: 'Cet homme, c'est toi. Voici ce que dit Yahvé, le Dieu d'Israël: Je t'avais consacré comme roi d'Israël, je t'avais délivré de la main de Saül,"
,"8":"je t'avais donné la maison de ton seigneur et les femmes de ton seigneur, je t'avais donné la maison d'Israël et celle de Juda, et si ce n'était pas assez, j'aurais fait encore bien plus."
,"9":"Pourquoi donc as-tu méprisé la parole de Yahvé? Pourquoi as-tu fait cette chose si mauvaise à ses yeux, de frapper par l'épée Urie le Hittite? Tu as pris pour toi sa femme, et lui, tu l'as tué par l'épée des Ammonites."
,"10":"Pour cela, l'épée désormais ne s'écartera plus de ta maison, parce que tu m'as méprisé et que tu as pris la femme d'Urie le Hittite pour en faire ta propre femme."
,"11":"Voici ce que dit Yahvé: De ta propre maison, je ferai venir sur toi le malheur, je prendrai tes femmes sous tes yeux, et je les donnerai à ton prochain, il couchera avec tes femmes à la vue du soleil."
,"12":"Toi, tu as agi dans le secret, mais moi, j'accomplirai cela à la face de tout Israël, à la face du soleil.'"
,"13":"David répondit à Nathan: 'J'ai péché contre Yahvé!' Nathan dit alors à David: 'Voici que Yahvé efface ton péché, tu ne mourras pas."
,"14":"Cependant, parce que tu as méprisé Yahvé dans cette affaire, le fils qui t'est né mourra.'"
,"15":"Dans le même temps où Nathan s'en retournait chez lui, Yahvé frappa l'enfant que la femme d'Urie avait donné à David: il tomba malade."
,"16":"David supplia Dieu pour son garçon, il refusa toute nourriture et, quand il rentra chez lui, il dormit sur le sol."
,"17":"Les anciens de sa maison insistèrent auprès de lui pour qu'il se lève, mais il refusa et ne prit aucune nourriture avec eux."
,"18":"Le septième jour l'enfant mourut. Les serviteurs de David n'osaient pas lui annoncer la nouvelle, ils se disaient: 'Lorsque l'enfant était encore en vie, nous lui avons parlé et il refusait de nous entendre. Que fera-t-il lorsque nous lui annoncerons que l'enfant est mort?'"
,"19":"David s'aperçut que ses serviteurs chuchotaient entre eux: il comprit que l'enfant était mort et il dit à ses serviteurs: 'L'enfant est donc mort?' Ils répondirent: 'Oui, il est mort.'"
,"20":"Alors David se leva, se baigna, se parfuma et changea de vêtements. Il entra dans la Maison de Yahvé où il se prosterna, puis il revint chez lui et demanda qu'on lui serve un repas: il mangea."
,"21":"Ses serviteurs lui dirent: 'Que fais-tu là? Lorsque l'enfant était vivant, tu jeûnais, tu pleurais, et maintenant que l'enfant est mort, tu te lèves et tu manges.'"
,"22":"Il répondit: 'Lorsque l'enfant était encore en vie, je jeûnais et je pleurais. Je me disais: Qui sait? Peut-être Yahvé aura-t-il pitié de moi et guérira-t-il l'enfant."
,"23":"Mais s'il est mort, pourquoi jeûner? Est-ce que je peux le faire revenir? C'est moi qui m'en irai vers lui, lui ne reviendra pas vers moi.'"
,"24":"David consola sa femme Bethsabée, il alla la voir et coucha avec elle. Elle conçut et enfanta un fils auquel elle donna le nom de Salomon. Yahvé aima cet enfant,"
,"25":"il le fit savoir par le prophète Nathan qui le nomma Yédidya, comme Yahvé le demandait."
,"26":"Joab attaqua Rabba des Ammonites et s'empara de cette ville royale,"
,"27":"puis il envoya des messagers pour dire à David: 'J'ai attaqué Rabba, je me suis même emparé de la ville basse."
,"28":"Il est temps que tu rassembles le reste du peuple. Viens toi-même camper face à la ville et t'en emparer, ou sinon c'est moi qui vais la prendre et on l'appellera de mon nom.'"
,"29":"David rassembla donc tout le peuple et partit pour Rabba; il attaqua la ville et s'en empara."
,"30":"Il enleva au dieu Milkom sa couronne qui pesait un talent d'or; elle portait une pierre précieuse qui se retrouva bientôt sur la tête de David. Il emporta un énorme butin."
,"31":"Puis on déporta tous les habitants de la ville, on les mit à manier la scie, le pic ou la hache et on les employa au travail des briques. David fit ainsi pour toutes les villes des Ammonites, puis il retourna à Jérusalem avec toute l'armée."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Voici ce qui arriva par la suite. Absalom, fils de David, avait une soeur qui était fort belle et qui se nommait Tamar; Amnon, un autre fils de David s'éprit d'elle."
,"2":"Amnon se tourmentait au point de s'en rendre malade, quand il pensait à sa demi-soeur Tamar; mais elle était vierge et Amnon ne voyait vraiment pas ce qu'il pouvait faire."
,"3":"Amnon avait un ami qui s'appelait Yonadab, fils de Chiméa, le frère de David, et Yonadab était très astucieux."
,"4":"Il lui dit: 'Comment se fait-il, fils de roi, que tu sois sans énergie dès le matin? Me le diras-tu?' Amnon répondit: 'C'est que j'aime Tamar, la soeur de mon frère Absalom.'"
,"5":"Alors Yonadab lui dit: 'Mets-toi au lit, fais semblant d'être malade, et quand ton père viendra te voir, tu lui diras: Permets que ma soeur Tamar vienne me donner à manger. Elle préparera un plat sous mes yeux pour que je le voie et que je le mange de sa main.'"
,"6":"Amnon se coucha donc et fit semblant d'être malade. Le roi vint le voir et Amnon dit au roi: 'Permets que ma soeur Tamar vienne, qu'elle prépare des gâteaux sous mes yeux et qu'elle me les donne de sa main.'"
,"7":"David envoya chercher Tamar à la maison: 'Va chez ton frère Amnon, et prépare-lui à manger.'"
,"8":"Tamar se rendit chez son frère Amnon qui était au lit, elle prit de la pâte, elle la pétrit, elle prépara sous ses yeux des gâteaux qu'elle fit cuire."
,"9":"Elle prit ensuite la poêle et la vida devant lui, mais il refusa de manger. Amnon dit alors: 'Faites sortir tout le monde de chez moi', et tous sortirent de chez lui."
,"10":"Amnon dit alors à Tamar: 'Apporte la nourriture dans la chambre pour que je la reçoive de tes mains.' Tamar prit les gâteaux qu'elle avait préparés et les apporta à son frère Amnon dans la chambre."
,"11":"Comme elle les lui présentait, il la saisit et lui dit: 'Viens coucher avec moi, ma soeur.'"
,"12":"Mais elle lui répondit: 'Non mon frère, ne me fais pas violence, on n'agit pas ainsi en Israël. Ne commets pas cette faute."
,"13":"Où irais-je donc porter ma honte? Et toi, tu serais comme un maudit en Israël, parle plutôt au roi! Il ne refusera pas de me donner à toi.'"
,"14":"Mais il ne voulut rien entendre, il la maîtrisa et lui fit violence, et il coucha avec elle."
,"15":"Mais alors Amnon se prit à la détester. C'était une haine encore plus forte que l'amour dont il l'avait aimée. Amnon lui dit: 'Lève-toi, va-t'en!'"
,"16":"Elle répondit: 'Non, mon frère, ne me chasse pas! Ce serait pire encore que ce que tu viens de faire.' Mais il ne voulut pas l'écouter."
,"17":"il appela le jeune homme qui était à son service et lui dit: 'Chasse-la dehors, loin de moi, et ferme la porte au verrou derrière elle.'"
,"18":"Elle portait une tunique à manches, car c'est ainsi que s'habillaient les filles de roi lorsqu'elles étaient vierges. Le serviteur la jeta donc dehors et ferma la porte au verrou derrière elle."
,"19":"Tamar jeta de la cendre sur sa tête, elle déchira sa tunique à manches et elle mit sa main sur sa tête, puis elle partit en poussant des cris."
,"20":"Son frère Absalom lui dit: 'Ton frère Amnon aurait-il couché avec toi? Ecoute-moi, ma soeur, ne dis rien à personne! N'est-il pas ton frère? Ne prends donc pas cette affaire à coeur.' Tamar demeura ainsi délaissée dans la maison de son frère Absalom."
,"21":"Lorsque le roi David apprit toute cette affaire, il fut très en colère mais il ne voulut pas faire de reproches à son fils Amnon, car c'était son premier-né et il le préférait."
,"22":"Absalom non plus ne lui dit rien, ni une bonne ni une mauvaise parole, mais il avait de la haine pour lui parce qu'il avait violé sa soeur Tamar."
,"23":"Deux ans plus tard, Absalom avait les tondeurs à Baal-Hazor, à côté d'Ephraïm. Absalom invita donc tous les fils du roi."
,"24":"Absalom dit au roi: 'Ton serviteur reçoit les tondeurs, que le roi vienne avec ses gens chez ton serviteur.'"
,"25":"Mais le roi répondit à Absalom: Non, mon fils, nous n'irons pas tous, ce serait une charge trop lourde pour toi.' Absalom eut beau insister auprès du roi, il ne voulut pas y aller et se contenta de le bénir."
,"26":"Absalom dit alors: 'Soit! Mais du moins, accepte que mon frère Amnon vienne.' Le roi lui répondit: 'Pourquoi irait-il avec toi?'"
,"27":"Mais Absalom insista tellement que le roi laissa partir Amnon avec les autres fils du roi. Absalom prépara un festin royal. "
,"28":"Il donna cet ordre à ses garçons: 'Faites attention, lorsque Amnon sera ivre, je vous dirai: Frappez Amnon! Aussitôt vous le tuerez. Ne craignez rien. C'est moi qui vous donne cet ordre. Vous n'hésiterez pas, vous montrerez que vous êtes des hommes.'"
,"29":"Les serviteurs d'Absalom firent donc pour Amnon comme Absalom leur avait ordonné. Voyant cela, tous les fils du roi se levèrent: chacun enfourcha sa mule et ils prirent la fuite."
,"30":"Ils étaient encore en route que déjà la nouvelle arrivait à David: 'Absalom a frappé tous les fils du roi, aucun n'en est réchappé.'"
,"31":"Le roi se leva, déchira ses vêtements et se coucha par terre; tous ses gens qui étaient autour de lui déchirèrent aussi leurs vêtements."
,"32":"Alors Yonadab, fils de Chiméa, le frère de David, prit la parole et dit: 'Mon seigneur ne doit pas croire qu'on a mis à mort tous les jeunes gens, les fils du roi: seul Amnon est mort, et c'était une chose décidée dans la tête d'Absalom depuis le jour où Amnon avait violé sa soeur Tamar."
,"33":"Que mon seigneur ne prenne donc pas la chose à coeur, qu'il ne pense pas que tous les fils du roi sont morts. Non, seul Amnon est mort,"
,"34":"et Absalom aura pris la fuite.',Le jeune homme qui faisait le guet leva les yeux et vit un groupe important qui arrivait par la route de Bahourim. Le guetteur en informa le roi: 'J'ai vu des hommes qui descendent par le chemin de Bahourim, au flanc de la montagne.' "
,"35":"Yonadab dit alors au roi: 'Ce sont les fils du roi qui arrivent. Tu vois bien que ton serviteur ne s'était pas trompé.'"
,"36":"Il parlait encore lorsque les fils du roi entrèrent: tous poussaient des cris et pleuraient. Le roi aussi se mit à pleurer avec ses serviteurs."
,"37":"Pendant ce temps Absalom avait pris la fuite, il s'était rendu chez Talmaï, fils d'Ammihoud, roi de Guéchour;"
,"38":"b il y resta trois ans."
,"37":"b Durant de longs jours le roi fit le deuil de son fils,"
,"39":"puis il se consola de la mort d'Amnon et sa colère contre Absalom se calma."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Joab, fils de Sérouya, s'aperçut que maintenant le roi se faisait du souci pour Absalom."
,"2":"Alors Joab envoya chercher à Tékoa une femme astucieuse: 'Ecoute-moi, lui dit-il, tu vas mettre des vêtements de deuil; tu ne te parfumeras pas et tu feras tout comme une femme qui porte depuis longtemps le deuil d'un mort."
,"3":"Tu te rendras chez le roi et tu lui rediras toute l'histoire que je vais te dire.'"
,"4":"La femme de Tékoa se rendit donc chez le roi, elle se prosterna la face contre terre et s'écria: 'Au secours, mon seigneur!'"
,"5":"Le roi lui demanda: 'Qu'as-tu?' Elle répondit: 'Hélas! Je suis veuve, mon mari est mort."
,"6":"Ta servante avait deux fils. Ils se sont battus dans la campagne, personne n'était là pour les séparer, et l'un d'eux a tué l'autre."
,"7":"Maintenant toute la famille s'est dressée contre moi. On me dit: Livre-nous celui qui a tué son frère, nous le mettrons à mort pour lui faire payer la vie de son frère. Mais ils vont nous enlever l'héritier! Ils vont éteindre la petite braise qui me reste encore, ils me laisseront sur la terre sans mari, sans nom, sans descendance.'"
,"8":"Le roi dit à la femme: 'Retourne chez toi et je donnerai moi-même des ordres à ton sujet.'"
,"9":"La femme de Tékoa dit au roi: 'Mon seigneur le roi, que toute la faute retombe sur moi et sur ma famille, que le roi et son trône n'aient pas à en souffrir!'"
,"10":"Le roi reprit: 'Amène-moi celui qui t'a menacée et je te promets qu'il ne reviendra plus te faire de mal.'"
,"11":"Elle lui dit: 'Que le roi me promette au nom de Yahvé son Dieu, que le vengeur du sang n'augmentera pas ma peine et ne fera pas périr mon fils.' Il lui dit: 'Aussi vrai que Yahvé est vivant, il ne tombera pas à terre un seul cheveu de ton fils.'"
,"12":"La femme reprit alors la parole: 'Que mon seigneur le roi permette à sa servante de dire encore un mot.' Il lui dit: 'Parle.'"
,"13":"La femme répondit: 'En prononçant ce jugement, le roi se condamne lui-même: il fait du tort au peuple de Dieu quand il refuse de faire revenir celui qu'il a exilé."
,"14":"Nous sommes condamnés à mourir: on ne ramasse pas l'eau qu'on a versé sur le sol, Dieu ne fait pas revenir les morts. Il faut donc trouver le moyen de faire revenir celui qu'on a exilé."
,"15":"Voilà pourquoi je suis venue raconter au roi toute cette histoire des gens qui me faisaient peur. Je me suis dit: Je parlerai au roi, peut-être fera-t-il ce que lui demande sa servante."
,"16":"Peut-être le roi m'écoutera-t-il et voudra-t-il me délivrer de celui qui veut nous retrancher, moi et mon fils, de l'héritage de Dieu."
,"17":"Et je me suis dit: Si seulement mon seigneur le roi pouvait dire une parole apaisante, car le roi est comme un ange de Dieu, il comprend le bien et le mal. Que Yahvé ton Dieu soit donc avec toi.'"
,"18":"Le roi répondit à la femme: 'Ne me cache rien, réponds à ma question.' La femme lui dit: 'Que mon seigneur le roi parle.'"
,"19":"Le roi lui dit: 'Joab n'est-il pas derrière toute cette affaire?' La femme lui répondit: 'Aussi vrai que tu es vivant, mon seigneur le roi, on ne peut s'écarter ni à droite ni à gauche, de tout ce que dit mon seigneur le roi. Oui, c'est bien ton serviteur Joab qui m'a donné cet ordre. C'est lui qui a mis toutes ces paroles dans ma bouche."
,"20":"Oui, Joab a fait tout cela pour que la paix revienne dans cette affaire; mais la sagesse de mon seigneur le roi est comme la sagesse d'un ange de Dieu, il sait tout ce qui se passe sur la terre.'"
,"21":"Alors le roi dit à Joab: 'J'ai réglé toute cette affaire: ramène le jeune Absalom.'"
,"22":"Joab se prosterna la face contre terre et bénit le roi, puis il ajouta: 'Maintenant que le roi a réglé cette affaire de son serviteur, j'ai la preuve qu'il est plein d'attentions pour moi.'"
,"23":"Joab partit à Guéchour et il ramena Absalom à Jérusalem."
,"24":"Cependant le roi dit: 'Qu'il se retire chez lui et qu'il ne se présente pas devant moi.' Absalom se retira donc dans sa maison et ne se présenta pas devant le roi."
,"25":"Personne n'était aussi beau qu'Absalom dans tout le pays d'Israël. Tout le monde chantait ses louanges: des pieds à la tête on ne lui trouvait pas le moindre défaut."
,"26":"Chaque année Absalom se rasait la tête, quand ses cheveux lui pesaient trop lourd, et lorsqu'il se rasait on pesait sa chevelure. Eh bien, elle pesait deux cents sicles au poids du roi."
,"27":"Absalom eut trois fils, et une fille qu'il appela Tamar: elle était très belle."
,"28":"Absalom resta deux ans à Jérusalem sans se présenter devant le roi,"
,"29":"après quoi il envoya chercher Joab pour l'envoyer vers le roi, mais Joab ne voulut pas venir. Il envoya une seconde fois le chercher, mais il ne voulut toujours pas venir."
,"30":"Il dit donc à ses serviteurs: 'Vous voyez le champ de Joab à côté du mien, là où on a mis de l'orge. Allez-y et mettez-y le feu.' Les serviteurs d'Absalom mirent donc le feu au champ. Aussitôt les serviteurs de Joab allèrent le trouver avec les habits déchirés et ils lui dirent: 'Les serviteurs d'Absalom ont mis le feu dans ton champ.'"
,"31":"Joab se leva et se rendit chez Absalom, il lui dit: 'Pourquoi tes serviteurs ont-ils mis le feu dans mon champ?'"
,"32":"Absalom répondit à Joab: 'Je t'ai fait chercher, je t'ai fait dire: Viens, je voudrais t'envoyer vers le roi. Tu lui demanderas pour quelle raison il m'a fait revenir de Guéchour. Il aurait mieux valu pour moi rester là-bas. Maintenant je veux me présenter devant le roi: si j'ai commis un crime, qu'il me mette à mort.'"
,"33":"Joab alla rapporter tout cela au roi; il fit appeler Absalom. Celui-ci arriva chez le roi, se prosterna la face contre terre, et le roi l'embrassa."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Après cela Absalom acheta un char, des chevaux, et se procura cinquante hommes qui couraient devant lui."
,"2":"Le matin de bonne heure Absalom allait se tenir près de la route qui conduit à la porte de la ville. Chaque fois qu'un homme avait un procès et qu'il devait se rendre chez le roi pour le jugement, Absalom l'appelait: 'De quelle ville es-tu?' lui disait-il. Si l'autre répondait: 'Ton serviteur est de telle tribu d'Israël',"
,"3":"Absalom lui disait: 'Regarde, ta cause est bonne et juste, mais il n'y aura personne pour t'écouter chez le roi.'"
,"4":"Puis Absalom ajoutait: 'Si seulement j'étais chargé de la justice dans ce pays! Tous ceux qui auraient un procès viendraient me trouver et je leur ferais justice.'"
,"5":"Et puis, lorsque quelqu'un s'approchait pour se prosterner devant lui, Absalom lui tendait la main, le relevait et l'embrassait."
,"6":"Absalom faisait ainsi envers tous les Israélites qui venaient trouver le roi pour un procès, et il se gagnait le coeur de tous les Israélites."
,"7":"Au bout de quatre ans, Absalom dit au roi: 'Laisse-moi partir à Hébron pour un voeu que j'ai fait à Yahvé."
,"8":"Pendant que j'étais à Guéchour, en Aram, j'ai fait ce voeu: 'Si Yahvé me laisse revenir à Jérusalem, j'irai honorer Yahvé à Hébron.'"
,"9":"Le roi lui dit: 'Va en paix.' Alors Absalom se leva et partit pour Hébron."
,"10":"Absalom envoya des gens à lui dans toutes les tribus d'Israël: 'Dès que vous entendrez le son du cor, disait-il, vous proclamerez: Absalom est roi à Hébron.'"
,"11":"Deux cents personnes invitées par Absalom étaient parties de Jérusalem avec lui, mais ils étaient allés sans savoir, sans rien connaître de toute cette affaire."
,"12":"Pendant qu'Absalom offrait des sacrifices, il envoya chercher à Guilo un conseiller de David qui s'appelait Ahitofel de Guilo. La conspiration grandissait de jour en jour et les partisans d'Absalom devenaient plus nombreux."
,"13":"Quelqu'un vint informer David: 'Les hommes d'Israël se sont tournés vers Absalom.'"
,"14":"Alors David dit à ses serviteurs, à ceux qui étaient avec lui à Jérusalem: 'Vite, fuyons! ou nous n'échapperons pas à Absalom. Dépêchez-vous de partir; s'il venait à nous rejoindre, il nous mettrait à mal et il passerait la ville au fil de l'épée.'"
,"15":"Les serviteurs du roi lui dirent: 'Quelle que soit la décision de mon seigneur le roi, nous sommes tes serviteurs.'"
,"16":"Le roi sortit donc à pied avec toute sa famille, laissant dans la ville dix de ses concubines pour garder son palais."
,"17":"Le roi allait à pied accompagné de tous ses gens, et ils firent une halte à la dernière maison."
,"18":"Tous ses serviteurs se tenaient à côté de lui pendant que les Kérétiens, les Pélétiens, les hommes de Gat passaient devant le roi: six cents hommes au total qui étaient venus de Gat à sa suite."
,"19":"Le roi dit à Ittaï de Gat: 'Pourquoi viens-tu toi aussi avec nous? Retourne et demeure auprès du nouveau roi. Tu es un étranger, tu as déjà eu à quitter ton pays."
,"20":"Tu es arrivé récemment et déjà je te ferais partir à l'aventure avec nous? Retourne, remmène avec toi tes frères, et que Yahvé te montre sa bonté et sa fidélité.'"
,"21":"Mais Ittaï répondit au roi: 'Aussi vrai que Yahvé est vivant et aussi vrai que mon seigneur le roi est vivant, là où sera mon seigneur le roi, là seront pour moi la mort et la vie.'"
,"22":"Alors David dit à Ittaï: 'Va et passe.' Et Ittaï de Gat passa avec tous ses hommes et leurs familles."
,"23":"Le peuple défilait et tout le monde pleurait à haute voix. Le roi traversa le torrent du Cédron et toute la population passa à l'est de la route qui longe le désert."
,"24":"Sadoc aussi était là avec tous les Lévites qui portaient l'Arche de l'Alliance de Dieu; ils déposèrent l'Arche de Dieu pendant que tout ce peuple montait de la ville et défilait."
,"25":"Alors le roi dit à Sadoc: 'Ramène l'Arche de Dieu en ville. Si je trouve grâce aux yeux de Yahvé, il me ramènera et me fera revoir l'Arche et sa Demeure."
,"26":"Mais s'il dit: Je ne veux plus de toi! me voici: qu'il me traite comme il lui semblera bon.'"
,"27":"Le roi dit encore au prêtre Sadoc: 'Retourne en paix dans la ville avec ton fils Ahimaas et Yonathan, fils d'Ebyatar."
,"28":"Regardez, je m'attarderai dans les défilés du désert jusqu'à ce que je reçoive un mot de vous pour me donner des nouvelles.'"
,"29":"Sadoc et Ebyatar ramenèrent donc l'Arche de Dieu à Jérusalem et ils y restèrent."
,"30":"David gravissait le Mont des Oliviers, il montait en pleurant, un voile sur la tête, et marchait pieds nus. Tous ceux qui étaient avec lui avaient la tête voilée et montaient en pleurant."
,"31":"On apporta cette nouvelle à David: 'Ahitophel est l'un des conjurés, il est avec Absalom!' Et David s'écria: 'Oh Yahvé, rends fous les conseils d'Ahitofel!'"
,"32":"David arrivait au sommet, là où l'on adore Dieu. Il vit venir à sa rencontre l'un de ses familiers, Houchaï l'Arkite, il avait sa tunique déchirée et de la terre sur la tête."
,"33":"David lui dit: 'Si tu viens avec moi tu me seras à charge."
,"34":"Tu pourrais retourner en ville et tu dirais à Absalom: Je serai à ton service, mon seigneur le roi; autrefois je servais ton père, maintenant je te servirai. Alors tu me rendrais service en brouillant les conseils d'Ahitofel."
,"35":"Les prêtres Sadoc et Ebyatar seront avec toi. Tout ce que tu auras appris dans le palais, tu le répéteras aux prêtres Sadoc et Ebyatar."
,"36":"Leurs deux fils, Ahimaas, fils de Sadoc et Yonathan fils, d'Ebyatar, sont avec eux, et par leur intermédiaire vous me ferez connaître tout ce que vous aurez appris.'"
,"37":"Houchaï, le familier de David, rentra donc en ville au moment où Absalom arrivait à Jérusalem."
}`)
	CurrentBook.AddChapter(16, `{
"1":"David avait dépassé le sommet; Siba, le serviteur de Méribaal, vint alors à sa rencontre avec une paire d'ânes. Il portait deux cents pains, cent grappes de raisins secs, cent fruits de saison et une outre de vin."
,"2":"Le roi dit à Siba: 'Que vas-tu faire de tout cela?' Siba répondit: 'Les ânes serviront de monture pour la famille du roi, le pain, les fruits de saison, seront pour la nourriture de ses compagnons. On donnera le vin à boire à ceux qui seront fatigués dans le désert.'"
,"3":"Alors le roi lui dit: 'Mais où donc est le fils de ton seigneur Saül?' Siba dit au roi: 'Il est resté à Jérusalem, car il pense que la maison d'Israël lui rendra aujourd'hui la royauté de son père.'"
,"4":"Le roi dit à Siba: 'Tout ce qui est à Méribaal t'appartient.' Siba répondit: 'Je ne peux que m'incliner, que je trouve grâce aux yeux de mon seigneur le roi!'"
,"5":"Le roi David approchait de Bahourim; un homme en sortit qui était de la famille de Saül et s'appelait Chiméï, fils de Guéra. Tout en marchant, il prononçait toutes sortes de malédictions."
,"6":"Il jetait des pierres vers David et les serviteurs du roi, tandis que le roi David avançait entouré à droite et à gauche par le peuple et par sa garde."
,"7":"Chiméï maudissait: 'Va-t'en, va-t'en! Tu n'es qu'un homme de sang et un criminel!"
,"8":"Yahvé a fait retomber sur toi tout le sang de la maison de Saül. Tu étais devenu roi à sa place, mais aujourd'hui Yahvé a donné la royauté à l'un de tes fils, Absalom. Le malheur est venu sur toi car tu n'es qu'un homme de sang.'"
,"9":"Abisaï, fils de Sérouya, dit au roi: 'Pourquoi ce chien crevé maudit-il mon seigneur le roi? Laisse-moi traverser, je vais lui couper la tête.'"
,"10":"Mais le roi répondit: 'Ne te mêle pas de mes affaires, fils de Sérouya: s'il maudit, c'est peut-être que Yahvé lui a dit: Maudis David! Qui donc ira lui demander pourquoi il agit de la sorte?'"
,"11":"Alors David dit à Abisaï et à ses serviteurs: 'Voici que mon fils, celui qui est sorti de moi, en veut à ma vie, à combien plus forte raison cet homme de Benjamin. Laissez-le maudire, si Yahvé le lui a dit."
,"12":"Peut-être Yahvé tiendra-t-il compte de ma peine pour me rendre du bonheur après la malédiction d'aujourd'hui.'"
,"13":"David et ses hommes continuèrent donc leur marche pendant que Chiméï suivait dans le même sens l'autre versant de la montagne; il maudissait, lançait des pierres et jetait de la poussière."
,"14":"Le roi et tout son peuple s'arrêtèrent enfin exténués; on souffla un peu."
,"15":"Absalom et tout le peuple d'Israël entrèrent à Jérusalem; Ahitofel était avec lui."
,"16":"Houchaï l'Arkite, le conseiller de David, vint se présenter à Absalom; il lui dit: 'Vive le roi! Vive le roi!'"
,"17":"Absalom répondit à Houchaï: 'Voilà toute ton affection pour ton ami! Pourquoi n'es-tu pas allé rejoindre ton ami?'"
,"18":"Mais Houchaï répondit à Absalom: 'Non, n'est-ce pas toi que Yahvé, tout ce peuple et tous les hommes d'Israël ont choisi? Je t'appartiens et je reste près de toi."
,"19":"Et puis, qui vais-je servir? N'es-tu pas son fils? Je te servirai tout comme j'ai servi ton père.'"
,"20":"Absalom dit à Ahitofel: 'Réunissons un conseil pour savoir ce que nous allons faire.'"
,"21":"Ahitofel dit à Absalom: 'Va vers les concubines de ton père, celles qu'il a laissées pour garder le palais. Tout Israël saura que tu t'es rendu odieux à ton père, et tous tes partisans se sentiront davantage compromis avec toi.'"
,"22":"On dressa donc une tente sur la terrasse du palais et Absalom s'approcha des concubines de son père aux yeux de tout Israël."
,"23":"En ce temps-là, tous les conseils d'Ahitofel étaient comme des paroles de Dieu; il en était ainsi pour David comme pour Absalom."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Ahitofel dit à Absalom: 'Permets que je choisisse douze mille hommes, je veux aller poursuivre David cette nuit-même."
,"2":"Je l'attaquerai alors qu'il est fatigué et qu'il a les mains lasses, je jetterai la panique dans tout le peuple et le peuple s'enfuira. Alors il me suffira d'abattre le roi"
,"3":"et je te ramènerai tout le peuple, comme une fiancée revient vers son époux. Il ne te faut que la vie d'un homme, que tout le peuple soit en paix.'"
,"4":"La chose parut bonne aux yeux d'Absalom et aux yeux de tous les anciens d'Israël."
,"5":"Absalom dit alors: 'Appelez aussi Houchaï l'Arkite, pour que nous entendions son avis.'"
,"6":"Houchaï s'approcha d'Absalom et Absalom lui dit ceci: 'Ahitofel a donné son avis. Devons-nous le suivre? Sinon, donne-nous ton avis.'"
,"7":"Houchaï répondit à Absalom: 'Pour une fois le conseil d'Ahitofel n'est pas bon.'"
,"8":"Houchaï ajouta: 'Tu sais que ton père et ses compagnons sont courageux, ils sont enragés comme une ourse en liberté à qui on a enlevé ses petits, ou comme la truie sauvage dans les champs. Ton père est un homme de guerre, il ne laissera pas l'armée fermer l'oeil;"
,"9":"en ce moment il est sûrement caché dans quelque grotte ou dans quelque autre lieu. Si les nôtres ont des pertes dès le début, il y aura des rumeurs et l'on dira: L'armée d'Absalom a subi une défaite."
,"10":"Alors, même les plus braves, ceux qui ont un coeur de lion, se décourageront. Tout Israël le sait bien, ton père est brave et tous ceux qui sont avec lui sont des hommes courageux. "
,"11":"C'est pourquoi voici mon conseil: Que tout Israël se rassemble autour de toi, de Dan jusqu'à Bersabée, aussi nombreux que les grains de sable au bord de la mer, et toi, tu marcheras en personne au milieu d'eux."
,"12":"Nous arriverons sur lui en quelque lieu où il se trouve, nous nous poserons sur eux comme la rosée tombe sur le sol et nous ne laisserons en vie, ni lui ni aucun de ses compagnons."
,"13":"S'il s'enferme dans une ville, tout Israël apportera des cordes pour tirer cette ville jusqu'au torrent, au point que l'on n'y trouvera plus même un caillou.'"
,"14":"Absalom et tous les gens d'Israël s'écrièrent: 'Le conseil de Houchaï l'Arkite est meilleur que le celui d'Ahitofel.' C'est que Yahvé avait décidé de faire échouer le conseil d'Ahitofel, qui était le bon; Yahvé voulait amener le malheur sur Absalom."
,"15":"Houchaï dit alors aux prêtres Sadoc et Ebyatar: 'Ahitofel a donné ce conseil à Absalom et aux anciens d'Israël, mais moi, voilà ce que je leur ai conseillé."
,"16":"Maintenant allez vite prévenir David. Dites-lui: Ne t'attarde pas cette nuit dans les défilés du désert. Dépêche-toi de traverser, sinon le roi et toute l'armée seront anéantis.'"
,"17":"Yonathan et Ahimaas étaient postés près de la source du Foulon. Une servante devait les prévenir pour qu'ils aillent porter la nouvelle au roi, car ils ne voulaient pas entrer en ville et se faire voir."
,"18":"Mais un jeune homme les vit et il informa Absalom. Alors ils s'enfuirent tous les deux et se réfugièrent chez un homme de Bahourim. Dans la cour il y avait une citerne où ils s'enfermèrent."
,"19":"La femme prit une bâche, elle l'étendit sur l'ouverture de la citerne et étala dessus du grain, si bien que l'on ne voyait plus rien."
,"20":"Les serviteurs d'Absalom arrivèrent chez cette femme et lui demandèrent: 'Où sont Ahimaas et Yonathan?' La femme leur répondit: 'Ils ont continué leur route vers le Jourdain.' Ils cherchèrent et, ne trouvant rien, ils revinrent à Jérusalem."
,"21":"Après leur départ, Ahimaas et Yonathan sortirent de la citerne et allèrent prévenir le roi David: 'Mettez-vous en route, dépêchez-vous de traverser, car voilà le conseil qu'Ahitofel a donné à votre sujet.'"
,"22":"David et toute l'armée qui l'accompagnait se mirent donc en route, ils passèrent le Jourdain et à l'aube tout le monde avait traversé le Jourdain."
,"23":"Lorsque Ahitofel vit que son conseil n'était pas suivi, il sella son âne et rentra chez lui dans sa ville, il mit de l'ordre dans sa maison et se pendit. C'est ainsi qu'il mourut et on l'enterra dans le tombeau de son père."
,"24":"David arriva à Mahanayim tandis qu'Absalom franchissait le Jourdain avec tous les Israélites."
,"25":"Absalom avait mis Amasa à la tête de l'armée à la place de Joab. (Amasa était fils de Yitra l'Ismaélite: cet homme s'était uni à Abigayil, fille de Jessé et soeur de Sérouya, la mère de Joab)."
,"26":"Israël et Absalom établirent leur camp dans le pays de Galaad."
,"27":"Lorsque David arriva à Mahanayim, Chobi, fils de Nahach de Rabba des Ammonites, Matir, fils d'Ammiel de Lo-Débar, et Barzillaï de Roglim en Galaad,"
,"28":"apportèrent des paillasses, des tapis, des coupes et de la vaisselle. Ils apportèrent aussi du blé et de l'orge, de la farine, des grains grillés, des fèves et des lentilles,"
,"29":"du miel et du lait caillé, des fromages de brebis et de vache, pour la nourriture de David et du peuple qui l'accompagnait. Ils s'étaient dit en effet: 'Après la marche dans le désert, ce peuple doit être fatigué, il a faim et il a soif.'"
}`)
	CurrentBook.AddChapter(18, `{
"1":"David passa en revue les hommes qui étaient avec lui et il mit à leur tête des chefs de mille et des chefs de cent."
,"2":"Ensuite David divisa la troupe en trois: il confia un tiers à Joab, un tiers à Abisaï, fils de Sérouya et frère de Joab, et un tiers à Ittaï de Gat. Le roi dit à la troupe: 'Moi aussi j'irai avec vous.'"
,"3":"Mais la troupe répondit: 'Non, ne viens pas, car si nous tournons le dos, personne n'y prêtera attention. Si la moitié d'entre nous meurt, personne n'y prêtera attention, mais toi, tu es comme dix mille d'entre nous. Il vaut mieux que tu restes en ville et que tu puisses nous porter secours.'"
,"4":"Le roi leur dit: 'Je ferai ce qui vous semble bon.' Il resta donc près de la porte de la ville et toute la troupe sortit par cents et par milles."
,"5":"Le roi donna cet ordre à Joab, à Abisaï et à Ittaï: 'Ménagez le jeune Absalom par égard pour moi.' Toute la troupe entendit cet ordre que le roi donnait aux chefs à propos d'Absalom."
,"6":"L'armée se mit en campagne et marcha à la rencontre d'Israël; la bataille se déroula dans la forêt d'Ephraïm."
,"7":"Ce fut une grande défaite pour l'armée d'Israël, les serviteurs de David l'écrasèrent et elle perdit vingt mille hommes."
,"8":"Le combat s'étendit à tout le secteur et ce jour-là les abrupts de la forêt firent plus de morts que l'épée."
,"9":"Les serviteurs de David rencontrèrent Absalom par hasard, il était monté sur un mulet et le mulet arriva sous les branches d'un grand chêne. Sa tête se prit dans le chêne et il resta suspendu entre ciel et terre tandis que le mulet continuait sa course."
,"10":"Un homme l'aperçut et il avertit Joab: 'J'ai aperçu Absalom suspendu à un chêne.'"
,"11":"Joab dit à celui qui lui apportait cette nouvelle: 'Ainsi tu l'as vu! Pourquoi ne l'as-tu pas frappé sur le champ? Je t'aurais donné dix pièces d'argent et une ceinture.'"
,"12":"Mais l'homme répondit à Joab: 'Même si j'avais dans les mains tes mille pièces d'argent, je ne porterais pas la main sur le fils du roi. Devant nous tous le roi a donné cet ordre à toi, à Abisaï et à Ittaï: Epargnez le jeune Absalom par égard pour moi."
,"13":"Même si je n'avais rien dit, le roi l'aurait su, et toi, tu te serais tenu à l'écart.'"
,"14":"Joab dit: 'Je perds mon temps avec toi.' Il prit dans sa main trois javelots et les enfonça dans le coeur d'Absalom qui était encore en vie dans le chêne."
,"15":"Ensuite dix jeunes gens compagnons d'armes de Joab frappèrent Absalom et l'achevèrent."
,"16":"Alors Joab sonna du cor: il fit retenir la troupe et l'on cessa de poursuivre Israël."
,"17":"Ils prirent Absalom et le jetèrent dans une grande fosse au milieu de la forêt, et l'on éleva par-dessus un grand tas de pierres. Quant aux Israélites, ils avaient pris la fuite et ils étaient retournés chacun chez soi."
,"18":"De son vivant Absalom s'était élevé une stèle dans la Vallée du Roi, car il se disait: 'Je n'ai pas de fils pour conserver mon nom.' Il avait donné son nom à cette pierre dressée, et aujourd'hui encore on l'appelle: 'Le monument d'Absalom.'"
,"19":"Ahimaas fils de Sadoc dit alors: 'Je vais courir annoncer au roi cette bonne nouvelle, que Yahvé lui a rendu justice et l'a délivré de ses ennemis.'"
,"20":"Mais Joab lui dit: 'Tu ne serais pas porteur d'une bonne nouvelle aujourd'hui, tu le seras peut-être un autre jour mais aujourd'hui ce ne serait certainement pas une bonne nouvelle, puisque le fils du roi est mort.'"
,"21":"Joab dit alors au Kouchite: 'Va annoncer au roi ce que tu as vu.' Le Kouchite se prosterna devant Joab et partit en courant."
,"22":"Ahimaas fils de Sadoc reprit la parole et dit à Joab: 'Qu'importe ce qui arrivera. Moi aussi je veux courir derrière ce Kouchite.' Joab lui dit: 'Pourquoi courir mon fils? Tu n'en tireras aucune récompense.'"
,"23":"Il répondit: 'Peu importe, je veux courir.' Alors Joab lui dit: 'Eh bien, cours.' Ahimaas partit en courant, il prit le chemin de la plaine et il devança le Kouchite."
,"24":"David était assis entre les deux portes, et le guetteur faisait les cent pas sur le toit de la porte, au-dessus du rempart. Il leva les yeux et aperçut un homme qui courait seul."
,"25":"Le guetteur cria la nouvelle au roi, qui déclara: 'S'il est seul, c'est qu'il est porteur de bonne nouvelle.' L'autre pendant ce temps approchait."
,"26":"Le guetteur aperçut un autre homme qui courait derrière, il appela le portier et lui dit: 'Il y a en un autre qui court aussi seul.' Le roi dit: 'Celui-là aussi apporte une bonne nouvelle.'"
,"27":"Le guetteur reprit: 'Je reconnais le premier, c'est Ahimaas fils de Sadoc, je reconnais sa façon de courir.' Le roi dit: 'C'est un homme qui vaut, il apporte sûrement une bonne nouvelle.'"
,"28":"Lorsque Ahimaas fut tout près, il cria: 'Salut!' Puis il se prosterna la face contre terre devant le roi. 'Béni soit Yahvé ton Dieu, dit-il, il a livré les hommes qui s'étaient dressés contre mon seigneur le roi!'"
,"29":"Le roi dit alors: 'Le jeune Absalom est-il sauf?' Ahimaas répondit: 'Lorsque ton serviteur Joab m'a envoyé, j'ai vu une grande confusion, mais je ne sais pas exactement ce qui se passait.'"
,"30":"Le roi lui dit: 'Mets-toi là et attendons.' Il se rangea de côté et attendit."
,"31":"Derrière lui arrivait le Kouchite; il dit: 'Que mon seigneur le roi apprenne la bonne nouvelle: Yahvé t'a fait justice aujourd'hui, il t'a délivré de tous ceux qui s'étaient dressés contre toi.'"
,"32":"Le roi demanda au Kouchite: 'Le jeune Absalom est-il sauf?' Le Kouchite lui répondit: 'Que les ennemis de mon seigneur le roi, que tous ceux qui se dressent contre lui pour faire le mal, aient le sort de ce jeune homme.'"
}`)
	CurrentBook.AddChapter(19, `{
"1":"Alors le roi se troubla, il monta à la chambre haute de la porte et se mit à pleurer. Tout en marchant il parlait ainsi: 'Mon fils Absalom! Mon fils! Mon fils Absalom! Pourquoi ne suis-je pas mort à ta place? Absalom, mon fils! Mon fils!'"
,"2":"On le dit à Joab: 'Le roi pleure et se lamente sur Absalom.'"
,"3":"Ce jour-là la victoire se changea en deuil pour tout le peuple, car tout le peuple apprit que le roi était désespéré à cause de son fils."
,"4":"C'est pourquoi ce jour-là le peuple rentra sans bruit dans la ville, comme des gens qui ont fui pendant la bataille et qui rentrent tout honteux sans se faire remarquer."
,"5":"Le roi, lui, s'était voilé la face et il criait à haute voix: 'Mon fils Absalom! Absalom, mon fils! Mon fils!'"
,"6":"Joab entra dans la chambre du roi et lui dit: 'Aujourd'hui tu couvres de honte tous tes serviteurs. Ils t'ont sauvé la vie, la vie des tes fils et de tes filles, la vie de tes femmes et de tes concubines."
,"7":"Mais tu aimes ceux qui te haïssent et tu haïs ceux qui t'aiment. Tu le montres bien aujourd'hui: tes serviteurs et leurs chefs ne sont rien pour toi et si aujourd'hui Absalom était en vie, et que tous nous soyons morts, tu serais très content."
,"8":"Maintenant lève-toi, sors et parle à tes serviteurs! Je le jure par Yahvé, si tu ne sors pas, personne ne restera près de toi cette nuit, et ce serait pour toi un plus grand malheur que tous ceux qui t'ont frappé depuis ta jeunesse jusqu'à aujourd'hui.'"
,"9":"Alors le roi se leva et vint s'asseoir à la porte. On l'annonça à tout le peuple: 'Voici, le roi est assis à la porte.' Et tout le peuple se présenta devant le roi. Tous les gens d'Israël s'étaient enfui chez eux, "
,"10":"et dans toutes les tribus d'Israël on discutait. On disait: 'C'est le roi qui nous a délivrés de la main de tous nos ennemis, c'est lui qui nous a délivrés des Philistins, et maintenant à cause d'Absalom il a dû s'enfuir du pays."
,"11":"Cet Absalom que nous avions consacré comme roi, il est mort dans la bataille, alors, ne ferez-vous rien pour ramener le roi?'"
,"12":"Ce que l'on disait dans tout Israël arriva aux oreilles du roi. Le roi David donna cette mission aux prêtres Sadoc et Ebyatar: 'Faites passer ce message aux anciens de Juda: Pourquoi seriez-vous les derniers à faire revenir le roi chez lui?"
,"13":"N'êtes-vous pas mes frères? N'êtes-vous pas de ma chair et de mes os? Pourquoi seriez-vous les derniers à faire revenir le roi?"
,"14":"Vous direz aussi à Amasa: N'es-tu pas de ma chair et de mes os? Que Dieu me maudisse et me maudisse encore si je ne te fais pas chef de l'armée à la place de Joab.'"
,"15":"Par ces paroles il gagna la confiance de tous les hommes de Juda, et d'un commun accord ils envoyèrent ce message au roi: 'Reviens avec tous tes serviteurs.'"
,"16":"Le roi revint donc. Il atteignait le Jourdain lorsque les gens de Juda arrivèrent à Guilgal, venant à la rencontre du roi pour l'aider à traverser le Jourdain."
,"17":"Chiméï fils de Guéra, le Benjaminite de Bahourim, descendait avec les gens de Juda au-devant du roi David,"
,"18":"amenant avec lui mille hommes de la tribu de Benjamin. Siba, l'intendant de la maison de Saül, était descendu dans le Jourdain avec ses quinze fils et ses vingt serviteurs au devant du roi David,"
,"19":"pour faire traverser la famille du roi, et pour toute autre chose qu'il pouvait désirer. Chiméï fils de Guéra se jeta aux pieds du roi au moment où il traversait le Jourdain. "
,"20":"Il dit au roi: 'Que mon seigneur oublie ma faute, ne m'en garde pas rancune. Oublie le mal que ton serviteur a fait à mon seigneur le roi, le jour où il sortait de Jérusalem."
,"21":"Ton serviteur sait bien qu'il a péché, mais aujourd'hui il est venu le premier de toute la maison de Joseph pour descendre à la rencontre de mon seigneur le roi.'"
,"22":"Abisaï fils de Sérouya prit la parole et dit: 'Chiméï mérite la mort, car il a maudit le roi consacré par Yahvé.'"
,"23":"Mais David répondit: 'Ne vous mêlez pas de mes affaires, fils de Sérouya, vous me feriez du tort aujourd'hui si quelqu'un était mis à mort en Israël. Je sais très bien qu'aujourd'hui je suis roi de tout Israël.'"
,"24":"Et le roi fit à Chiméï ce serment: 'Tu ne mourras pas.'"
,"25":"Méribaal, le fils de Saül, était descendu lui aussi à la rencontre du roi. Depuis le jour où le roi était parti, jusqu'à ce jour où il revenait en paix, Méribaal ne s'était pas lavé les pieds ni les mains, il n'avait pas taillé sa moustache ni lavé ses vêtements."
,"26":"Comme il arrivait de Jérusalem au-devant du roi, le roi lui demanda: 'Pourquoi n'es-tu pas venu avec moi Méribaal?'"
,"27":"Il répondit: 'Mon seigneur le roi, c'est mon serviteur qui m'a trompé. Je lui avais dit: Selle mon ânesse, je la monterai pour rejoindre le roi, car tu le sais, ton serviteur est infirme."
,"28":"Et voilà qu'il m'a calomnié auprès de mon seigneur le roi. Mais mon seigneur le roi est comme l'ange de Yahvé, qu'il agisse aujourd'hui comme bon lui semble."
,"29":"La famille de mon père ne pouvait rien attendre de mon seigneur le roi sinon la mort, et cependant tu m'as admis parmi ceux qui mangent à ta table. De quel droit pourrais-je encore demander quelque chose au roi?'"
,"30":"Le roi lui dit: 'Assez de discours! Toi et Siba, vous partagerez les terres.'"
,"31":"Méribaal dit au roi: 'Qu'il garde tout, puisque mon seigneur le roi est rentré chez lui en paix.'"
,"32":"Barzillaï de Galaad était descendu de Roglim, il avait passé le Jourdain avec le roi avant de prendre congé de lui."
,"33":"Or Barzillaï était très vieux, il avait quatre-vingts ans; c'est lui qui avait ravitaillé le roi alors qu'il était à Mahanayim, car c'était un homme très riche."
,"34":"Le roi dit à Barzillaï: 'Reste avec moi et je te nourrirai à Jérusalem.'"
,"35":"Mais Barzillaï dit au roi: 'Combien de jours, combien d'années me reste-t-il à vivre pour que je vienne avec le roi à Jérusalem?"
,"36":"J'ai maintenant quatre-vingts ans et je ne distingue plus ce qui est bon et ce qui est mauvais, je n'ai plus le goût de ce que je mange ou de ce que je bois, je n'entends plus la voix des chanteurs et des chanteuses. Pourquoi donc ton serviteur serait-il encore à charge à mon seigneur le roi?"
,"37":"Ton serviteur t'accompagnera encore un peu au-delà du Jourdain, mais pourquoi le roi me donnerait-il une telle récompense?"
,"38":"Permets-moi de retourner et de mourir dans ma ville, près du tombeau de mon père et de ma mère. Mais mon fils Kinham, ton serviteur, continuera avec mon seigneur le roi et tu feras pour lui ce qui te semblera bon.'"
,"39":"Le roi dit: 'Que Kinham reste avec moi. Je ferai pour lui ce que tu voudras, et tout ce que tu me demanderas, je le ferai pour toi.'"
,"40":"Tout le peuple traversa le Jourdain après le roi. Lui embrassa Barzillaï et le bénit, et celui-ci s'en retourna chez lui."
,"41":"Le roi marcha vers Guilgal en compagnie de Kinham; tout le peuple de Juda accompagnait le roi, ainsi que la moitié du peuple d'Israël."
,"42":"C'est alors que les hommes d'Israël vinrent auprès du roi et lui dirent: 'Pourquoi nos frères, les hommes de Juda, t'ont-ils enlevé avec ta famille pour te faire traverser le Jourdain, alors que tu avais là toute ta garde avec toi?'"
,"43":"Les hommes de Juda répondirent aux Israélites: 'Le roi n'est-il pas de notre tribu? Pourquoi vous mettre en colère? Est-ce que le roi nous a donné à manger, ou quelque chose d'autre?'"
,"44":"Les Israélites répondirent aux hommes de Juda: 'Nous avons dix fois plus de droits que vous sur le roi. Pourquoi donc nous avoir méprisés? C'est nous qui avons demandé les premiers le retour de notre roi.' Mais les hommes de Juda leur répondirent durement, plus qu'eux-mêmes ne l'avaient fait."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Alors il se trouva un homme de rien, un nommé Chéba fils de Bikri, de la tribu de Benjamin. Il sonna du cor et fit cet appel: 'Nous n'avons pas de part avec David, nous n'avons rien à attendre du fils de Jessé. Israël, retourne à tes tentes!'"
,"2":"Alors tous les hommes d'Israël abandonnèrent David et suivirent Chéba, fils de Bikri, tandis que ceux de Juda restaient avec le roi et l'accompagnaient du Jourdain jusqu'à Jérusalem."
,"3":"David rentra dans son palais à Jérusalem; il en fit sortir les dix concubines qu'il avait laissées pour garder le palais et les plaça dans une maison surveillée. Il assura leur entretien mais il ne s'approcha plus jamais d'elles. Jusqu'à leur mort elles restèrent ainsi enfermées, menant une vie de veuves."
,"4":"Le roi dit à Amasa: 'Tu as trois jours pour rassembler les hommes de Juda et te présenter devant moi.'"
,"5":"Amasa partit pour rassembler Juda, mais il tarda au-delà de la date que le roi lui avait fixée."
,"6":"A ce moment David dit à Abisaï: 'Chéba, fils de Bikri, va être bientôt plus dangereux pour nous qu'Absalom. Pars à la tête de la garde de ton maître et pourchasse-le, sinon il pourrait gagner une ville fortifiée et nous échapper.'"
,"7":"Joab, les Kérétiens, les Pélétiens et tous les braves, partirent en campagne. Ils quittèrent Jérusalem derrière Abisaï et se lancèrent à la poursuite de Chéba, fils de Bikri."
,"8":"Ils étaient près de la grande pierre qui se trouve à Gabaon, lorsque Amasa se présenta devant eux. Joab portait par-dessus son vêtement une ceinture à laquelle était attachée son épée dans son fourreau; l'épée sortit et tomba."
,"9":"Joab dit à Amasa: 'Mon frère, est-ce la paix?' Et de la main droite il saisit la barbe d'Amasa comme pour l'embrasser."
,"10":"Amasa ne se méfiait pas de l'épée que Joab tenait à la main: Joab l'en frappa au ventre et ses entrailles se répandirent à terre. Il n'eut pas besoin de frapper un second coup, Amasa était mort. Alors Joab et son frère Abisaï se lancèrent à la poursuite de Chéba, fils de Bikri."
,"11":"On demanda à l'un des compagnons de Joab de rester à côté du corps d'Amasa; il disait: 'Que ceux qui sont pour David et qui aiment Joab, suivent Joab!'"
,"12":"Car Amasa s'était roulé dans son sang au milieu du chemin, et tous les hommes de l'armée qui arrivaient là s'arrêtaient. Voyant cela, le garçon tira le corps d'Amasa dans un champ et jeta sur lui un vêtement."
,"13":"Dès qu'il l'eût retiré du chemin, tous continuèrent derrière Joab et se lancèrent à la poursuite de Chéba, fils de Bikri."
,"14":"Chéba parcourut toutes les tribus d'Israël jusqu'à Abel-Beth-Maaka. Les hommes du clan de Bikri s'étaient rassemblés et ils se joignirent à lui."
,"15":"Joab assiégea donc Chéba dans Abel-Beth-Maaka, on éleva contre la ville un terrassement qui s'appuyait sur le rempart. Quand toute l'armée de Joab creusait pour faire tomber le rempart,"
,"16":"une femme de bon sens qui était dans la ville cria: 'Ecoutez! Ecoutez! Dites à Joab qu'il approche jusqu'ici, je voudrais lui parler.'"
,"17":"Joab s'approcha et la femme lui dit: 'C'est toi Joab?' Il répondit: 'Oui, c'est moi.' Elle lui dit: 'Ecoute ce que j'ai à te dire.' Il répondit: 'J'écoute.'"
,"18":"Elle lui dit: 'Autrefois on avait l'habitude de dire: C'est à Abel et à Dan qu'on vous enseignera"
,"19":"les anciennes coutumes d'Israël. Et toi aujourd'hui, tu détruirais cette ville, un chef-lieu d'Israël? Pourquoi détruirais-tu l'héritage de Yahvé?'"
,"20":"Joab répondit: 'Je ne veux surtout pas détruire et ruiner."
,"21":"La seule question, c'est que Chéba, fils de Bikri, un homme de la montagne d'Ephraïm, s'est dressé contre le roi David. Livrez-le lui seul et je m'éloignerai de la ville.',La femme répondit à Joab: 'C'est bien, on va te jeter sa tête par-dessus la muraille.' "
,"22":"La femme sut parler et convaincre les habitants de la ville; on trancha la tête de Chéba, fils de Bikri, et on la jeta à Joab. Aussitôt Joab sonna du cor; on se dispersa et chacun revint de là à son foyer. Quant à Joab, il retourna à Jérusalem auprès du roi."
,"23":"Joab commandait toute l'armée d'Israël, Bénayas, fils de Yoyada commandait les Pélétiens et les Kérétiens,"
,"24":"Adoram était chef de la corvée, Yochafat, fils d'Ahiloud était archiviste,"
,"25":"Chiya était secrétaire, les prêtres étaient Sadoc et Ebyatar,"
,"26":"Ira le Yaïrite était également prêtre de David."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Sous le règne de David, il y eut une famine qui dura trois ans. David consulta Yahvé, et Yahvé répondit: 'Il y a du sang sur Saül et sur sa famille parce que Saül a mis à mort les Gabaonites.'"
,"2":"De fait, ces Gabaonites n'étaient pas des Israélites, ils descendaient des anciens Amorites mais les Israélites s'étaient engagés envers eux par serment. Malgré cela, Saül avait cherché à les détruire dans son zèle pour Israël et pour Juda. David convoqua donc les Gabaonites, "
,"3":"il leur dit: 'Que devons-nous faire pour réparer, pour que vous bénissiez l'héritage de Yahvé?'"
,"4":"Les Gabaonites répondirent: 'Ce n'est pas une question d'argent ou d'or avec Saül et sa famille, et nous ne cherchons pas non plus de victimes en Israël.' David leur dit: 'Je ferai pour vous ce que vous me direz.'"
,"5":"Ils répondirent au roi: 'Un homme nous a massacrés, il voulait nous détruire et nous faire disparaître du territoire d'Israël."
,"6":"Qu'on nous livre aujourd'hui sept de ses fils, nous les pendrons devant Yahvé à Gabaon, sur la montagne de Yahvé.' Le roi leur dit: 'Je vous les livrerai.'"
,"7":"Cependant le roi épargna Méribaal, le fils de Jonathan fils de Saül, à cause du serment qu'il avait prêté à Jonathan fils de Saül devant Yahvé."
,"8":"Rispa fille d'Ayyia avait donné deux fils à Saül, Armoni et Méribaal. Mérab fille de Saül avait donné à Adriel, fils de Barzillaï, de Méhola, cinq fils. David les fit prendre"
,"9":"et livrer aux Gabaonites, et ceux-ci les pendirent sur la montagne devant Yahvé; les sept moururent ensemble. Ils furent mis à mort au premier jour de la moisson, au début de la moisson des orges. "
,"10":"Rispa fille d'Ayyia prit un sac, elle l'étendit pour elle sur le rocher et, depuis le début de la moisson jusqu'au temps des premières pluies, elle empêcha les oiseaux du ciel de se poser sur eux durant le jour, et les bêtes sauvages durant la nuit."
,"11":"On apprit à David ce que Rispa fille d'Ayyia et concubine de Saül avait fait."
,"12":"Alors David alla chercher les ossements de Saül et ceux de son fils Jonathan chez les gens de Yabech de Galaad. En effet, les Philistins avaient pendu leurs corps sur la place de Beth-Chéan après leur victoire sur Saül à Guelboé, mais les gens de Yabech de Galaad les avaient dérobés."
,"13":"David ramena donc les ossements de Saül et ceux de Jonathan, puis on recueillit les ossements de ceux que l'on avait pendus,"
,"14":"et on enterra les ossements de Saül dans le tombeau de son père Kich, à Séla, au pays de Benjamin. On y déposa également les ossements de son fils Jonathan et ceux des pendus. On fit tout ce que le roi avait ordonné, après quoi Dieu eut pitié du pays."
,"15":"La guerre reprit entre les Philistins et Israël, David descendit avec sa garde pour combattre les Philistins. Au moment où David était fatigué,"
,"16":"un descendant de Rafa appelé Ichbo-Bénob prétendit l'abattre. Il portait une lance de bronze pesant trois cents sicles, et il avait une épée toute neuve."
,"17":"Mais Abisaï fils de Sérouya vint au secours de David, il frappa le Philistin et le tua. Alors les hommes de David insistèrent auprès de lui: 'Tu ne viendras pas avec nous au combat, il ne faut pas que s'éteigne la lampe d'Israël.'"
,"18":"Après cela il y eut encore une bataille à Gob avec les Philistins; c'est là que Sibékaï de Houcha tua un descendant de Rafa nommé Saf."
,"19":"La guerre reprit de nouveau à Gob avec les Philistins, Elhanan fils de Yaïr, de Bethléem, tua Goliath de Gat; le bois de sa lance était comme une pièce de métier à tisser."
,"20":"Il y eut un autre combat à Gat; là se trouvait un homme de haute taille qui avait six doigts à chaque main, six doigts à chaque pied: au total vingt-quatre doigts. Lui aussi était un descendant de Rafa."
,"21":"Comme il insultait Israël, Yonathan fils de Chiméa, frère de David, le tua."
,"22":"Tous les quatre étaient des hommes de Gat descendants de Rafa. Ils tombèrent sous la main de David et de ses gardes."
}`)
	CurrentBook.AddChapter(22, `{
"1":"David dit à Yahvé les paroles de ce cantique le jour où Yahvé le délivra de la main de tous ses ennemis et de la main de Saül."
,"2":"'Yahvé est mon rocher, ma forteresse et mon sauveur."
,"3":"Mon Dieu est mon rocher, je m'abrite en lui. Il est mon bouclier, mon salut, ma citadelle et mon refuge. Tu es mon sauveur, qui me sauve de la violence."
,"4":"Je prie Yahvé, digne de louange, et je me vois sauvé de mes ennemis."
,"5":"Les flots de la mort m'enveloppaient, les torrents diaboliques m'épouvantaient,"
,"6":"j'étais pris dans les filets du monde infernal, je voyais devant moi les pièges de la mort:"
,"7":"dans mon angoisse j'ai appelé Yahvé, j'ai crié vers mon Dieu. Mon cri s'est fait entendre en sa présence, de son temple il a écouté ma voix,"
,"8":"Alors la terre a tremblé, elle s'est ébranlée, les fondements des cieux en ont frémi, ils tremblaient en voyant sa colère."
,"9":"Une vapeur montait de ses narines, de sa bouche s'échappait un feu dévorant, il en sortait des charbons embrasés."
,"10":"Il inclina les cieux et descendit, dessous lui s'étendait une nuée obscure."
,"11":"Il vola, monté sur un chérubin, il apparut porté sur les ailes du vent."
,"12":"Tout autour de lui un rideau de ténèbres, de lourds nuages amoncelés formaient sa tente."
,"13":"Une flamme de feu marchait devant lui, d'où jaillissaient des charbons ardents."
,"14":"Yahvé tonna du haut des cieux, le Très-Haut fit retentir sa voix."
,"15":"Il lança ses flèches, dispersa ses ennemis, la foudre les remplit de terreur."
,"16":"Le fond de la mer apparut, les bases de la terre furent mises à nu, à la menace de Yahvé, lorsque passa sur eux le souffle de ses narines."
,"17":"D'en haut il étendit la main et me saisit, il me tira des grandes eaux."
,"18":"Il me délivra d'ennemis redoutables, d'un adversaire plus fort que moi."
,"19":"Ils m'attaquaient au jour de mon malheur, mais Yahvé s'est fait mon protecteur."
,"20":"Il m'a mis au large, il m'a sauvé parce qu'il m'aime."
,"21":"Yahvé m'a traité selon mon mérite, mes mains étaient pures, il m'a récompensé."
,"22":"J'ai gardé les voies de Yahvé, je n'ai pas péché, m'écartant de mon Dieu."
,"23":"Tous ses jugements étaient présents devant moi, je ne m'écartais pas de ses lois."
,"24":"J'étais sans reproche devant lui, je me gardais de toute faute."
,"25":"Yahvé me récompense selon mes mérites, il voit de ses yeux ma pureté."
,"26":"Tu es bon avec celui qui est bon, tu es parfait avec celui qui es parfait."
,"27":"Tu es droit avec celui qui est droit, mais si l'homme est retors, tu sais le prendre au piège."
,"28":"Tu viens au secours d'un peuple humilié, mais tu fais baisser les yeux aux arrogants."
,"29":"Tu es ma lumière, ô Yahvé!,Lui, Yahvé, éclaire mes ténèbres."
,"30":"Avec toi je me lance contre les assaillants, avec mon Dieu je saute la muraille."
,"31":"La voie de Dieu est parfaite, la parole de Yahvé ne peut faillir. Il est un bouclier pour ceux qui s'abritent en lui."
,"32":"Qui est Dieu en dehors de Yahvé?,Qui est un rocher comme notre Dieu?"
,"33":"Dieu est mon asile et ma forteresse, il m'ouvre une voie royale."
,"34":"Il rend mes pieds pareils à ceux des biches, et me fait me tenir debout sur les hauteurs."
,"35":"Il entraîne mes mains au combat, et mes bras tendent l'arc de bronze."
,"36":"Tu m'as donné ton salut comme un bouclier, et tes bontés me grandissent."
,"37":"Tu me fais allonger le pas, et mes pieds ne chancellent pas."
,"38":"Je poursuis mes ennemis, je les écrase, je ne reviens pas sans les avoir battus."
,"39":"Achevés, brisés, ils ne se relèvent pas, ils tombent sous mes pieds."
,"40":"Tu me remplis de force pour le combat, tu fais plier sous moi mes ennemis."
,"41":"Tu fais tourner le dos à mes adversaires, tous ceux qui me haïssent, je les anéantis."
,"42":"Ils peuvent crier, pas de sauveur pour eux, Yahvé ne leur répond pas."
,"43":"Je les broie comme la poussière du sol, dans la boue du chemin je les écrase, je les foule."
,"44":"Des querelles de mon peuple, tu me délivres. Tu me gardes à la tête des nations, des peuples m'obéissent qui n'étaient pas le mien."
,"45":"Les étrangers cherchent ma faveur, dès qu'ils m'entendent, ils m'obéissent."
,"46":"Les étrangers sont sans force, ils s'enferment dans leurs remparts."
,"47":"Vive Yahvé! Béni soit mon rocher!,Je veux rendre gloire au Dieu qui me sauve!"
,"48":"O Dieu, tu m'as accordé la vengeance, tu m'as soumis tous les peuples."
,"49":"Tu me libères de tous mes ennemis, tu me rends maître de l'agresseur, tu me délivres des violents."
,"50":"C'est pourquoi je loue Yahvé au milieu des nations. Je chante un psaume en l'honneur de son Nom:"
,"51":"Il donne à son roi victoire sur victoire, et garde sa grâce à celui qu'il a consacré, à David et sa descendance pour toujours.'"
}`)
	CurrentBook.AddChapter(23, `{
"1":"Voici les dernières paroles de David: 'Oracle de David, fils de Jessé, oracle de celui qui fut mis au plus haut, de l'homme consacré par le Dieu de Jacob, de celui qui chantait les psaumes d'Israël."
,"2":"L'esprit de Yahvé a parlé par moi, et sa parole est dans ma bouche."
,"3":"Le Dieu de Jacob a parlé, le rocher d'Israël a dit: Un juste qui est meneur d'hommes, qui les mène dans la crainte de Dieu,"
,"4":"il est lumière du matin au lever du soleil, il est un matin sans nuages,où brille après la pluie le gazon de la terre."
,"5":"Ma maison n'est-elle pas cela même pour Dieu, lui qui m'a réservé une alliance éternelle, bien ordonnée, bien garantie?,Ne fera-t-il pas germer mon salut, tout ce que j'ai désiré?"
,"6":"Les gens sans foi ni loi ne sont que des épines: on les rejette, on ne les prendra pas avec la main."
,"7":"Qui veut s'y attaquer,s'arme d'un fer ou d'un bois de lance, ils sont brûlés, consumés par le feu.'"
,"8":"Voici les noms des braves qui étaient au service de David: Ichbaal le Hakmonite, le chef des 'Trois'; c'est lui qui, de sa lance, fit en une seule fois huit cents victimes."
,"9":"Après lui, Eléazar fils de Dodo l'Ahohite, qui était un autre des trois braves; il était avec David à Pasdamim lorsque les Philistins se rassemblèrent pour le combat. Les Israélites battaient en retraite,"
,"10":"mais lui fit face; il frappa les Philistins, jusqu'à en avoir la main si fatiguée qu'elle restait crispée sur son épée. Ce jour-là Yahvé donna une grande victoire. L'armée revint par la suite, mais il n'y avait plus qu'à dépouiller les ennemis."
,"11":"Après lui, Chamma fils d'Ela, le Hararit e. Les Philistins s'étaient réunis à Léhi; il y avait là tout près un champ de lentilles et l'armée tourna le dos devant les Philistins."
,"12":"Alors il se plaça au milieu du champ, il le dégagea et battit les Philistins: Yahvé donna la victoire."
,"13":"Parmi les 'Trente', il y en eut trois qui descendirent à la rencontre de David au temps de la moisson, à la grotte d'Adoullam, alors qu'une compagnie de Philistins campait dans le vallon des Réphaïm,"
,"14":"David était dans le refuge et il y avait un poste de Philistins à Bethléem."
,"15":"David eut un désir, il dit: 'Qui me fera boire l'eau de la citerne qui est à l'entrée de Bethléem?'"
,"16":"Les trois braves s'ouvrirent un passage au travers du camp des Philistins, ils puisèrent de l'eau dans la citerne qui est à l'entrée de Bethléem, ils la rapportèrent et la donnèrent à David. Mais lui ne voulut pas en boire et il la répandit en offrande devant Yahvé."
,"17":"Il déclara: 'Que Dieu me garde de boire cette eau, c'est le sang de ces hommes qui ont risqué leur vie.' Il ne voulut donc pas en boire. Voilà ce que firent ces trois braves."
,"18":"Le chef des 'Trente' était Abisaï frère de Joab et fils de Sérouya. Il se fit un nom parmi les 'Trente' lorsque, brandissant sa lance, il fit trois cents victimes."
,"19":"Il fut le plus célèbre des 'Trente' et devint leur chef, mais il n'atteignit pas au niveau des 'Trois'."
,"20":"Bénayas fils de Yoyada était un vaillant, auteur de nombreux exploits: il venait de Qabzéel. C'est lui qui abattit les deux héros de Moab; un jour de neige il descendit dans une citerne pour y tuer le lion."
,"21":"Il abattit aussi un Egyptien de haute taille; l'Egyptien avait en main sa lance, et Bénayas s'avança vers lui avec un gourdin. Il arracha la lance de la main de l'Egyptien et le tua avec sa propre lance."
,"22":"Voilà les exploits de Bénayas fils de Yoyada. Il se fit un nom parmi les trente braves"
,"23":"et fut même plus célèbre que les 'Trente', mais on ne le compta pas parmi les 'Trois'. David le fit entrer dans sa garde personnelle."
,"24":"Azaël frère de Joab faisait partie des 'Trente'. De même Elhanan fils de Dodo, de Bethléem,"
,"25":"Chamma de Harod, Elika de Harod,"
,"26":"Hélès de Beth-Pélet, Ira fils d'Ikech de Tékoa,"
,"27":"Abiézer d'Anatot, Sibékaï de Houcha,"
,"28":"Salmon d'Ahoh, Mahraï de Nétofa,"
,"29":"Héled fils de Baana, de Nétofa, Ittaï fils de Ribaï, de Guibéa de Benjamin,"
,"30":"Bénayas de Piréaton, Hiddaï des Torrents de Gaach,"
,"31":"Abibaal de Beth-Ha-Araba, Azmavèt de Bahourim,"
,"32":"Elyahba de Chaalbon, Yachen de Guimzo, Yonathan"
,"33":"fils de Chamma, de Harar, Ahiam fils de Charar, de Harar,"
,"34":"Elifélèt fils d'Ahasbaï, de Beth-Maaka, Eliam fils d'Ahitofel, de Guilo,"
,"35":"Hésraï de Karmel, Paraï d'Arab,"
,"36":"Yiguéal fils de Nathan, de Soba, Bani de Gad,"
,"37":"Sélek l'Ammonite, Nahraï de Béérot: il était écuyer de Joab fils de Sérouya;"
,"38":"Ira de Yattir, Gareb de Yattir,"
,"39":"Urie le Hittite. Total: trente sept."
}`)
	CurrentBook.AddChapter(24, `{
"1":"De nouveau la colère de Yahvé s'enflamma contre Israël, il poussa David à faire leur malheur. 'Va, dit-il, et fais le recensement d'Israël et de Juda.'"
,"2":"Le roi dit à Joab, chef de l'armée, qui était avec lui: 'Parcours toutes les tribus d'Israël depuis Dan jusqu'à Bersabée. Dénombre le peuple, ainsi je saurai combien ils sont.'"
,"3":"Joab dit au roi: 'Que Yahvé, ton Dieu multiplie cent fois le peuple, et que les yeux de mon seigneur le roi le voient. Mais pourquoi mon seigneur le roi désire-t-il une chose semblable?'"
,"4":"Cependant la parole du roi était un ordre pour Joab et les chefs de l'armée: il sortit de chez le roi avec les chefs de l'armée pour aller recenser la population d'Israël."
,"5":"Ils traversèrent le Jourdain et campèrent au sud d'Aroër; la ville est au milieu du Torrent de Gad. Ils continuèrent ensuite vers Yazer,"
,"6":"puis ils arrivèrent en Galaad, au pays des Hittites, à Qadesh et de là à Dan. Ils parcoururent les environs en direction de Sidon,"
,"7":"ils arrivèrent à la forteresse de Tyr et traversèrent les villes des Hivvites et des Cananéens. Puis ils repartirent vers Bersabée, dans le Négueb de Juda."
,"8":"Ils parcoururent donc tout le pays et revinrent à Jérusalem au bout de neuf mois et vingt jours."
,"9":"Joab remit au roi le compte exact de la population: Israël comptait huit cent mille hommes de guerre capables de manier l'épée, et Juda cinq cent mille."
,"10":"Mais ensuite le coeur de David lui battit: il avait recensé le peuple! Il dit à Yahvé: 'J'ai commis un très grand péché. Maintenant, Yahvé, pardonne la faute de ton serviteur: j'ai agi comme un insensé.'"
,"11":"Le lendemain, tandis que David se levait, la parole de Yahvé fut adressée au prophète Gad, le voyant de David:"
,"12":"'Va transmettre à David cette parole de Yahvé: Je te propose trois choses, choisis l'une d'entre elle et je la réaliserai.'"
,"13":"Gad se rendit auprès de David et lui dit: 'Que choisiras-tu: trois années de famine dans ton pays, trois mois de fuite devant un ennemi qui te poursuivra, ou trois jours de peste dans ton pays? A toi de réfléchir, tu me diras quelle réponse je dois porter à celui qui m'envoie.'"
,"14":"David dit à Gad: 'Me voilà dans une grande détresse , mais mieux vaut pour nous tomber entre les mains de Yahvé, car il est riche en miséricorde, plutôt que de tomber entre les mains des hommes.'"
,"15":"David choisit donc la peste. C'était le temps de la moisson des blés, et Yahvé envoya la peste en Israël depuis ce matin-là jusqu'au temps fixé. Le fléau s'abattit sur le peuple et soixante-dix mille hommes en moururent depuis Dan jusqu'à Bersabée."
,"16":"L'ange exterminateur étendit sa main vers Jérusalem, mais Yahvé se repentit du mal et il dit à l'ange exterminateur: 'Arrête! Retire ta main!' L'ange de Yahvé se tenait à ce moment auprès de l'aire d'Arauna le Jébusite."
,"17":"Lorsqu'il vit l'ange qui frappait la population, David se tourna vers Yahvé et lui dit: 'J'ai péché, c'est moi qui ai commis cette grande faute, mais eux le troupeau, qu'ont-ils fait? Que ta main ne s'en prenne qu'à moi et à la maison de mon père.'"
,"18":"Ce jour-là le prophète Gad se rendit auprès de David et lui dit: 'Monte et construis un autel à Yahvé sur l'aire d'Arauna le Jébusite.'"
,"19":"David monta donc suivant la parole de Gad, comme Yahvé l'avait ordonné."
,"20":"Or Arauna regardait: il vit le roi et ses serviteurs qui s'avançaient vers lui. Arauna sortit et se prosterna la face contre terre devant le roi,"
,"21":"puis il demanda: 'Pourquoi mon seigneur le roi est-il venu chez son serviteur?' David répondit: 'Je viens pour acheter l'aire afin d'y construire un autel à Yahvé, ainsi le fléau cessera de frapper le peuple.'"
,"22":"Arauna dit alors à David: 'Que mon seigneur le roi prenne et offre tout ce qui lui semblera bon. Voici les boeufs pour l'holocauste, le traîneau et les jougs des boeufs fourniront le bois."
,"23":"Tout cela, mon seigneur, Arauna le donne au roi.' Arauna dit encore: 'Que Yahvé ton Dieu accepte ton sacrifice.'"
,"24":"Mais le roi répondit à Arauna: 'Non, je veux te le payer à son juste prix, je ne veux pas offrir à Yahvé, mon Dieu des holocaustes qui ne me coûtent rien.',David acheta donc l'aire et les boeufs pour cinquante sicles d'argent. "
,"25":"David construisit là un autel à Yahvé et il y offrit des holocaustes et des sacrifices de communion. Alors Yahvé eut pitié du pays et la peste s'écarta d'Israël."
}`)

}
func FR_LBDCC_LoadVHEDChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"En la première année de Cyrus, roi de Perse, la parole de Yahvé proclamée par Jérémie s'accomplit: Yahvé éveilla l'esprit de Cyrus, roi de Perse. De vive voix, mais aussi par écrit, Cyrus fit proclamer ceci dans tout son royaume:"
,"2":"'Ainsi parle Cyrus, roi de Perse: Yahvé, le Dieu des Cieux, m'a donné tous les royaumes de la terre; et voici qu'il me charge de reconstruire son temple à Jérusalem de Juda."
,"3":"Que Dieu soit avec ceux qui appartiennent à son peuple et qui monteront à Jérusalem de Juda pour reconstruire le Temple de Yahvé Dieu d'Israël: c'est le Dieu qui est à Jérusalem."
,"4":"Quel que soit l'endroit où ils se trouvent, les gens de la région où habitent les survivants leur fourniront de l'argent, de l'or, des biens, du bétail, ainsi que des offrandes volontaires pour le Temple de Dieu qui est à Jérusalem.'"
,"5":"Alors les chefs de famille de Juda et de Benjamin, les prêtres et les lévites, tous ceux dont Dieu avait ouvert l'esprit pour aller reconstruire le Temple de Yahvé à Jérusalem, se mirent en route."
,"6":"Tous ceux qui les entouraient leur apportèrent leur aide de toutes sortes de façons: en leur donnant de l'argent, de l'or, des biens, du bétail, des objets précieux en quantité, en plus des offrandes volontaires."
,"7":"Le roi Cyrus prit les objets du Temple de Yahvé que Nabukodonozor avait enlevés de Jérusalem et qu'il avait placés dans le Temple de son Dieu."
,"8":"Cyrus roi de Perse les fit enlever par Mithridate, le trésorier, qui les compta devant Chechbassar, prince de Juda."
,"9":"Voici leur liste: 30 bassins d'or, 1 000 bassins d'argent, 29 couteaux,"
,"10":"30 coupes d'or, 41 0 coupes d'argent de seconde qualité, 1 000 autres objets."
,"11":"Il y avait en tout, 5 40 0 objets d'or et d'argent; Chechbassar emporta tout cela au moment du retour des exilés de Babylone à Jérusalem."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Voici les gens de la province qui revinrent de la captivité; ils avaient été déportés à Babylone par Nabukodonozor, roi de Babylone. Ils retournaient à Jérusalem et en Juda, chacun dans sa ville."
,"2":"Ils arrivèrent avec Zorobabel, Josué, Néhémie, Serayas, Rélayas, Mordokaï, Bilchan, Mispar, Bigvaï, Réhoum, Baana. Liste des hommes du peuple d'Israël:"
,"3":"les fils de Paréoch: 2172;"
,"4":"les fils de Chefatayas: 372;"
,"5":"les fils d'Ara: 775;"
,"6":"les fils de Pahat-Moab (fils de Josué et Yoab): 2812;"
,"7":"les fils d'Elam: 1254;"
,"8":"les fils de Zatou: 945;"
,"9":"les fils de Zakaï: 760;"
,"10":"les fils de Bani: 642;"
,"11":"les fils de Bébaï: 623;"
,"12":"les fils d'Azgad: 1222;"
,"13":"les fils d'Adonikam: 666;"
,"14":"les fils de Bigvaï: 2056;"
,"15":"les fils d'Adin: 454;"
,"16":"les fils d'Ater (Yehizkiya): 98;"
,"17":"les fils de Bésaï: 323;"
,"18":"les fils de Yora: 112;"
,"19":"les fils de Hachoum: 223;"
,"20":"les fils de Gibar: 95;"
,"21":"les fils de Bethléem: 123;"
,"22":"les hommes de Nétofa: 56;"
,"23":"les hommes d'Anatot: 128;"
,"24":"les fils d'Azmavet: 42;"
,"25":"les fils de Kyriat-Yéarim, Kefira et Béerot: 743;"
,"26":"les fils de Rama et Géba: 621;"
,"27":"les hommes de Mikmas: 122;"
,"28":"les hommes de Béthel et de Aï: 223;"
,"29":"les fils de Nebo: 52;"
,"30":"les fils de Magbich: 156;"
,"31":"les fils d'un autre Elam: 1254;"
,"32":"les fils de Harim: 320;"
,"33":"les fils de Lod, Hadid et Ono: 725;"
,"34":"les fils de Jéricho: 345;"
,"35":"les fils de Senaa: 3630."
,"36":"Les prêtres: les fils de Yedayas (la maison de Josué): 97 3 ;"
,"37":"les fils d'Imer: 1052;"
,"38":"les fils de Pachehour: 1247;"
,"39":"les fils de Harim: 1017."
,"40":"Les lévites: les fils de Josué (Kadmiel, des fils de Hodavya): 74."
,"41":"Les chantres: les fils d'Asaf: 12 8."
,"42":"Les fils des portiers: les fils de Challoum, les fils d'Ater, les fils de Talmon, les fils de Akoub, les fils de Atita, les fils de Chobaï: en tout 13 9."
,"43":"Les serviteurs: les fils de Siha, les fils de Asoufa, les fils de Tabaot,"
,"44":"les fils de Kéros, les fils de Sia, les fils de Padon,"
,"45":"les fils de Lebana, les fils de Agaba, les fils de Akoub,"
,"46":"les fils d'Agab, les fils de Chamlaï, les fils de Hanan,"
,"47":"les fils de Gidel, les fils de Gahar, les fils de Reayas,"
,"48":"les fils de Resin, les fils de Nekoda, les fils de Gazam,"
,"49":"les fils d'Ouza, les fils de Paséa, les fils de Bésaï,"
,"50":"les fils d'Asna, les fils des Méounites, les fils des Néfousites,"
,"51":"les fils de Babouk, les fils de Hakoufa, les fils de Harour,"
,"52":"les fils de Baslout, les fils de Mehida, les fils de Harcha,"
,"53":"les fils de Barkos, les fils de Sisra, les fils de Téma,"
,"54":"les fils de Nesia, les fils de Hatifa."
,"55":"Les fils des esclaves de Salomon: les fils de Sotaï, les fils de Ha-Soférèt, les fils de Perouda,"
,"56":"les fils de Yaala, les fils de Darkon, les fils de Gidel,"
,"57":"les fils de Chefatyas, les fils de Hatil, les fils de Pokérèt-Ha-Sabayim, les fils d'Ami."
,"58":"Total des serviteurs et des fils des esclaves de Salomon: 39 2."
,"59":"Les survivants qui étaient de Tel-Méla, de Tel-Harcha, de Kéroub, d'Addan et d'Immer furent incapables de dire si leurs familles et leurs clans étaient d'Israël:"
,"60":"les fils de Delayas, les fils de Tobiyas, les fils de Nekoda: 652."
,"61":"Parmi les fils des prêtres, les fils d'Hobayas, les fils d'Hakos, les fils de Barzilaï -cet homme avait adopté le nom de Barzilaï de Galaad dont il avait épousé une des filles-"
,"62":"Tous ceux-là recherchèrent leurs listes généalogiques, mais ils ne les trouvèrent pas, ils furent écartés du sacerdoce comme impurs."
,"63":"Le gouverneur leur interdit de manger des aliments sacrés jusqu'au jour où un prêtre réglerait la question par l'Ourim et le Toumim."
,"64":"L'assemblée tout entière comptait 42 36 0 personnes,"
,"65":"sans compter les esclaves et les servantes au nombre de 7 33 7; il y avait aussi 20 0 chanteurs et chanteuses."
,"66":"On comptait 73 6 chevaux, 24 5 mulets,"
,"67":"43 5 chameaux et 6 72 0 ânes."
,"68":"Certains chefs de familles, en arrivant au Temple de Yahvé à Jérusalem, firent des offrandes volontaires pour le Temple de Yahvé, pour qu'on le reconstruise sur son emplacement."
,"69":"Pour ce travail, ils versèrent dans le trésor, selon leurs moyens, 61 000 pièces d'or, 5 000 pièces d'argent et 10 0 tuniques pour les prêtres."
,"70":"Les prêtres, les lévites et une partie du peuple habitèrent à Jérusalem; les chantres, les portiers, les serviteurs et tous les autres Israélites habitèrent dans leur ville."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Les Israélites étaient donc dans leus villes, mais quand le septième mois arriva, le peuple se rassembla comme un seul homme, à Jérusalem."
,"2":"Josué fils de Yosadak, ses frères prêtres, Zorobabel, fils de Chéaltiel, et ses frères, se mirent ensemble à rebâtir l'autel du Dieu d'Israël pour y offrir des holocaustes, comme il est écrit dans la loi de Moïse, l'homme de Dieu."
,"3":"On avait beau avoir peur des païens, on reconstruisit l'autel à son emplacement et l'on y offrit des holocaustes en l'honneur de Yahvé: l'holocauste du matin et celui du soir."
,"4":"On célébra la fête des Tentes comme il est écrit, avec le nombre d'holocaustes fixés pour chaque jour,"
,"5":"puis, en plus de l'holocauste perpétuel, on offrit ceux qui étaient prévus pour les sabbats, les nouvelles lunes et toutes les fêtes en l'honneur de Yahvé; on y offrit encore les holocaustes que chacun en toute liberté voulait offrir à Yahvé."
,"6":"Ce fut le premier jour du septième mois que l'on commença à offrir des holocaustes à Yahvé, alors que les fondations du sanctuaire de Yahvé n'étaient pas encore posées."
,"7":"On donna de l'argent aux tailleurs de pierre et aux charpentiers; des vivres, de la boisson et de l'huile aux gens de Sidon et de Tyr, pour qu'ils fassent venir du bois de cèdre. Ils devaient l'amener par mer depuis le Liban jusqu'à Jaffa, selon l'autorisation reçue de Cyrus, roi de Perse."
,"8":"La deuxième année après leur arrivée au Temple de Dieu à Jérusalem, au deuxième mois, Zorobabel fils de Chéaltiel et Josué fils de Yosadak, le reste de leurs frères, les prêtres, les lévites et tous ceux qui étaient rentrés de captivité à Jérusalem commencèrent le travail. On chargea les lévites de vingt ans et plus, de diriger les travaux du Temple de Yahvé."
,"9":"Josué, ses fils et ses frères, Kadmiel et ses fils, les fils de Hodavyas, prirent tous ensemble la direction de ceux qui travaillaient dans le Temple de Dieu."
,"10":"Lorsque les bâtisseurs posèrent les fondations du Temple de Yahvé, les prêtres en tunique avec leurs trompettes, les lévites fils d'Azaf avec leurs cymbales, se présentèrent pour célébrer Yahvé comme l'avait ordonné David, roi d'Israël."
,"11":"Ils entonnèrent ce chant, louant et célébrant Yahvé: 'Car il est bon, car éternel est son amour pour Israël!' Tout le peuple poussait de grandes acclamations, il rendait grâce à Yahvé de ce qu'on posait les fondations du Temple de Yahvé."
,"12":"Beaucoup de personnes âgées, prêtres et lévites, chefs de familles qui avaient connu le premier Temple, pleuraient abondamment pendant qu'on posait sous leurs yeux les fondations, mais beaucoup d'autres laissaient éclater leurs joyeuses acclamations."
,"13":"On ne pouvait plus distinguer le bruit des acclamations joyeuses et celui des pleurs du peuple; les acclamations étaient telles qu'on les entendait de loin."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Les adversaires de Juda et Benjamin apprirent que ceux qui étaient revenus de la captivité construisaient un Temple à Yahvé Dieu d'Israël."
,"2":"Ils vinrent trouver Zorobabel et les chefs de familles et leur dirent: 'Nous allons construire avec vous puisque, comme vous, nous invoquons votre Dieu et nous lui offrons des sacrifices depuis le temps d'Asarhaddon, roi d'Assyrie, qui nous a déportés ici.'"
,"3":"Zorobabel, Josué et le reste des chefs de familles d'Israël, leur répondirent: 'Ce n'est pas à vous et à nous ensemble, de construire un Temple à notre Dieu. C'est nous, et nous seuls, qui construirons pour Yahvé Dieu d'Israël, comme nous l'a ordonné Cyrus roi de Perse!'"
,"4":"Le peuple du pays chercha alors à décourager le peuple de Juda et à le menacer pour l'empêcher de construire."
,"5":"Et pendant tout le temps de Cyrus, roi de Perse, jusqu'au règne de Darius roi de Perse, ils payèrent des conseillers pour faire échouer le projet du peuple de Juda."
,"6":"Dès le commencement du règne de Xerxès, ils envoyèrent des lettres pour accuser les habitants de Juda et de Jérusalem."
,"7":"Au temps d'Artaxerxès, Bichlam, Mithridate, Tabéel et le reste de leurs collègues, écrivirent à Artaxerxès roi de Perse pour les accuser à nouveau; le texte du document était écrit en araméen, mais on l'avait traduit."
,"8":"Ensuite Réhoum, gouverneur, et Chimchaï, secrétaire, écrivirent contre Jérusalem la lettre que voici destinée au roi Artaxerxès:"
,"9":"'Réhoum, le gouverneur en chef, Chimchaï, le secrétaire, et le reste de leurs collègues, les juges et les ambassadeurs, les fonctionnaires de Perse, les gens d'Ourouk, de Babylone et de Suse (c'est-à-dire les Elamites)"
,"10":"et les autres peuples que le grand et célèbre Assourbanipal a déportés et installés dans les villes de Samarie et de la province qui est au-delà de l'Euphrate, écrivent ceci.'"
,"11":"Voici donc la copie de la lettre qu'ils envoyèrent: 'Au roi Artaxerxès, tes serviteurs, les hommes d'au-delà du Fleuve."
,"12":"Le roi doit savoir que les Juifs qui sont revenus de chez toi vers nous, sont arrivés à Jérusalem. Ils reconstruisent cette ville rebelle et méchante, ils relèvent les remparts et réparent les fondations."
,"13":"Le roi doit savoir ceci: s'ils arrivent à reconstruire la ville et que les remparts sont relevés, ils ne verseront plus de tributs, d'impôts ou de droits de passage; finalement, les rois en paieront les frais."
,"14":"Comme nous mangeons le sel du palais royal, nous ne pouvons supporter de voir le tort qui sera fait au roi; c'est pourquoi nous envoyons ces informations au roi."
,"15":"On doit faire des recherches dans les livres où sont gardés les mémoires de tes pères. Là, dans le livre des mémoires, tu découvriras et tu apprendras que cette ville est rebelle et qu'elle a fait du tort aux rois et aux provinces, et que dans les temps anciens beaucoup de révoltes y sont nées; c'est pour cela que cette ville a été détruite."
,"16":"Nous faisons savoir au roi que si cette ville est reconstruite, si ses remparts sont relevés, tu n'auras plus de territoires au-delà du Fleuve.'"
,"17":"Le roi envoya cette réponse: 'A Réhoum, gouverneur, et Chimchaï, le secrétaire, au reste de leurs collègues qui habitent en Samarie et dans la région au-delà du Fleuve, salut!"
,"18":"La lettre que vous nous avez envoyée a été lue devant moi, point par point."
,"19":"Sur mon ordre on a fait des recherches et l'on a constaté ceci: depuis les temps anciens, cette ville s'est dressée contre les rois: on y a vu des troubles et des révoltes."
,"20":"Des rois puissants ont régné à Jérusalem sur la province au-delà du Fleuve: on leur payait tribut, impôt et droit de passage."
,"21":"Aussi, donnez l'ordre d'arrêter le travail de ces gens: cette ville ne doit pas être reconstruite jusqu'à nouvel ordre de ma part."
,"22":"Ne négligez rien dans cette affaire, de peur que le mal n'aille en grandissant, au détriment des rois.'"
,"23":"On fit la lecture de la copie de la lettre du roi Artaxerxès devant Réhoum, le secrétaire Chimchaï et leurs collègues. Aussitôt la lecture terminée, ils partirent pour Jérusalem et obligèrent les Juifs par la violence et par la force, à cesser leurs travaux."
,"24":"Alors le travail du Temple de Dieu à Jérusalem s'arrêta et il demeura dans cet état jusqu'à la deuxième année du règne de Darius, roi de Perse."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Les prophètes Aggée et Zacharie fils de Iddo, prophétisèrent pour les Juifs de Juda et de Jérusalem au nom du Dieu d'Israël qui était avec eux."
,"2":"Alors Zorobabel fils de Chéaltiel, et Josué fils de Yosadak décidèrent de reprendre la construction du Temple de Dieu à Jérusalem; les prophètes de Dieu étaient avec eux et les appuyaient."
,"3":"Dans ce même temps, Tatténaï, gouverneur de la province au-delà du Fleuve, Chétar-Boznaï et leurs collègues, vinrent les trouver. Ils leur demandèrent: 'Qui vous a permis de rebâtir ce Temple et de reconstruire cette charpente?"
,"4":"Donnez-nous les noms de ceux qui construisent ce bâtiment.'"
,"5":"Mais Dieu veillait sur les anciens de Juda; on ne les obligea pas à cesser le travail le temps qu'on enverrait un rapport à Darius et qu'on attendrait sa réponse."
,"6":"Voici la copie de la lettre que Tatténaï, gouverneur de la province au-delà du Fleuve, Chétar-Boznaï, ses collègues et les responsables de la Province, écrivirent au roi Darius:"
,"7":"'Salut au roi Darius!"
,"8":"Le roi doit savoir que nous sommes allés dans la province de Juda, au Temple du Grand Dieu. On le construit en pierres de taille, avec des pièces de charpente posées sur le mur. Le travail est fait soigneusement et avance bien, grâce à leur travail."
,"9":"Nous avons donc interrogé les anciens et nous leur avons posé cette question: Qui vous a autorisés à rebâtir ce Temple et à restaurer ce Sanctuaire?"
,"10":"Nous leur avons aussi demandé leur nom et nous avons noté par écrit les noms des responsables pour te les communiquer."
,"11":"Voici la réponse qu'ils nous ont donnée: Nous sommes les serviteurs du Dieu du ciel et de la terre, et nous reconstruisons le Temple qui fut bâti il y a de nombreuses années; un grand roi d'Israël l'avait édifié et terminé."
,"12":"Mais comme nos pères avaient mis en colère le Dieu du Ciel, il les a livrés entre les mains de Nabukodonozor, roi de Babylone, le Kaldéen. Il a démoli ce Temple et emmené le peuple en exil à Babylone."
,"13":"Cependant, au cours de la première année du règne de Cyrus, roi de Babylone, celui-ci a donné l'autorisation de reconstruire ce Temple de Dieu."
,"14":"Le roi Cyrus a fait reprendre les objets d'or et d'argent du Temple de Dieu que Nabukodonozor avait emportés de Jérusalem et déposés dans le temple de Babylone. Il les a donnés à Chechbassar, qu'il a nommé gouverneur,"
,"15":"en lui disant: Prends ces objets, va les reporter dans le Temple de Jérusalem, et reconstruisez le Temple de Dieu sur son emplacement."
,"16":"Alors ce Chechbassar est venu, il a posé les fondations du Temple de Dieu à Jérusalem et, depuis ce jour jusqu'à maintenant, la construction se poursuit sans être encore achevée."
,"17":"Maintenant donc, si le roi est d'accord, on recherchera dans la maison des trésors du roi, là-bas à Babylone, s'il y a bien eu une autorisation du roi Cyrus pour reconstruire ce Temple de Dieu à Jérusalem. Et le roi nous dira sa volonté à ce sujet.'"
}`)
	CurrentBook.AddChapter(6, `{
"1":"Alors le roi Darius donna l'ordre de faire des recherches dans la salle des trésors où l'on conservait les archives de Babylone."
,"2":"On découvrit dans la ville fortifiée d'Ekbatane, dans la province des Mèdes, un rouleau sur lequel il était écrit ceci:"
,"3":"'La première année du roi Cyrus, le roi Cyrus a donné cet ordre au sujet du Temple de Dieu à Jérusalem: Le Temple sera reconstruit et sera un lieu pour offrir des sacrifices. On lui fera des fondations, sa hauteur sera de soixante coudées et sa largeur de soixante coudées."
,"4":"Il y aura trois assises de pierres et une assise de bois. La dépense sera assurée par le palais royal."
,"5":"Les objets d'or et d'argent du Temple de Dieu que Nabukodonozor a enlevés et emportés à Babylone seront rendus; ils seront déposés dans la Maison de Dieu et chacun d'eux retrouvera sa place dans le Temple de Jérusalem.'"
,"6":"'Toi, Tatténaï, gouverneur de la province qui est au-delà de l'Euphrate, ainsi que Chétar-Boznaï et vous autres, leurs collègues, et les chefs de la province, retirez-vous de là."
,"7":"Le gouverneur de Juda et les anciens des Juifs rebâtiront le Temple de Dieu sur son emplacement; laissez-les travailler!"
,"8":"Voici mes ordres pour cette reconstruction du Temple de Dieu par les anciens des Juifs: Vous réglerez les dépenses de ces hommes scrupuleusement et régulièrement avec la part des impôts de la province que vous devez au trésor royal."
,"9":"Ce qui sera nécessaire pour les holocaustes offerts au Dieu du ciel: jeunes taureaux, béliers et agneaux, blé, sel, vin, huile, tout cela sera donné chaque jour sans faute selon l'indication des prêtres de Jérusalem."
,"10":"Ils offriront des sacrifices d'agréable odeur au Dieu du ciel et ils le prieront pour la vie du roi et de ses fils."
,"11":"J'ordonne encore ceci: Si quelqu'un désobéit à cet ordre, on arrachera une poutre de sa maison, on le pendra à cette poutre et sa maison sera transformée en un tas de ruines."
,"12":"Que le Dieu dont le Nom habite dans le Temple de Jérusalem, renverse tout roi ou tout peuple qui voudrait détruire cette Maison au mépris de ce décret. Moi, Darius, j'ai donné cet ordre, qu'il soit exécuté point par point.'"
,"13":"Alors Tatténaï, gouverneur de la province qui est au-delà de l'Euphrate, Chétar-Boznaï et leurs collègues, firent exactement ce que le roi Darius avait ordonné."
,"14":"Les anciens des Juifs bâtissaient et le travail avançait rapidement grâce au prophète Aggée et à Zacharie fils de Iddo; ils bâtirent et ils achevèrent conformément aux ordres du Dieu d'Israël et à ceux de Cyrus et de Darius."
,"15":"Le Temple fut achevé le troisième jour du mois d'Adar, en la sixième année du règne de Darius."
,"16":"Les Israélites, les prêtres, les lévites et les autres déportés firent une grande fête pour la consécration de ce Temple de Dieu."
,"17":"Ils apportèrent pour la consécration du Temple cent taureaux, deux cents béliers et quatre cents agneaux; ils offrirent douze boucs en sacrifice pour le péché, au nom de tout le peuple, selon le nombre des tribus d'Israël."
,"18":"Ils établirent les prêtres selon leurs groupes et les lévites selon leurs classes pour assurer le service de Dieu à Jérusalem, comme cela est écrit dans le livre de Moïse."
,"19":"Ceux qui avaient été déportés célébrèrent la Pâque le quatorze du premier mois."
,"20":"Tous les Lévites s'étaient purifiés; ils étaient purs et ils immolèrent la Pâque pour tous les déportés, pour leurs frères prêtres et pour eux-mêmes."
,"21":"Les Israélites qui étaient revenus de la déportation mangèrent la Pâque, et avec eux, tous ceux qui avaient renoncé aux pratiques impures des païens du pays pour chercher Yahvé Dieu d'Israël."
,"22":"C'est avec joie qu'ils célébrèrent pendant sept jours la fête des pains sans levain, car Yahvé les avait comblés de joie: il avait changé le coeur du roi d'Assyrie en leur faveur, il leur était venu en aide pour reconstruire le Temple de Dieu, du Dieu d'Israël!"
}`)
	CurrentBook.AddChapter(7, `{
"1":"Après tout cela, sous le règne d'Artaxerxès roi de Perse, Esdras fils de Sérayas, fils d'Azaryas, fils de Hilkiyas,"
,"2":"fils de Challoum, fils de Sadoq, fils d'Ahitoub,"
,"3":"fils d'Amaryas, fils d'Azaryas, fils de Mérayot,"
,"4":"fils de Zérahyas, fils de Ouzi, fils de Bouki,"
,"5":"fils d'Abichoua, fils de Pinhas, fils d'Eléazar, fils du grand prêtre Aaron -"
,"6":"cet Esdras donc, arriva de Babylone. C'était un scribe très instruit dans la Loi que Yahvé Dieu d'Israël avait donnée par Moïse. Comme Yahvé son Dieu était avec lui, le roi lui accorda tout ce qu'il demandait."
,"7":"Des Israélites, des prêtres, des lévites, des chantres, des portiers, et des serviteurs, arrivèrent à Jérusalem la septième année du roi Artaxerxès."
,"8":"Esdras arriva à Jérusalem le cinquième mois de la septième année du roi."
,"9":"Il avait fixé son départ de Babylone au premier jour du premier mois, et il arriva à Jérusalem le premier jour du cinquième mois avec l'aide de Dieu."
,"10":"En effet, il s'était attaché de tout son coeur à étudier la Loi de Yahvé, à la mettre en pratique et à en enseigner les lois et les coutumes à Israël."
,"11":"Voici la copie de la lettre que le roi Artaxerxès donna à Esdras, le prêtre scribe (un scribe instruit des paroles et des lois que Yahvé avait données à Israël):"
,"12":"'Artaxerxès, le roi des rois, à Esdras, le prêtre, scribe de la Loi du Dieu du ciel."
,"13":"Voici l'ordre que je donne: tous les hommes, prêtres et lévites du peuple d'Israël, qui habitent mon royaume et qui veulent retourner à Jérusalem, peuvent partir avec toi."
,"14":"Le roi et ses sept conseillers t'envoient pour inspecter Juda et Jérusalem selon la Loi de ton Dieu que tu portes en main."
,"15":"Tu porteras l'argent et l'or que le roi et ses conseillers offrent de plein gré au Dieu d'Israël qui habite à Jérusalem."
,"16":"Tu porteras tout l'argent et l'or que tu trouveras dans la province de Babylone, et les offrandes que le peuple et les prêtres offrent généreusement pour le Temple de leur Dieu à Jérusalem."
,"17":"Tu auras donc soin d'acheter avec cet argent des taureaux, des béliers, des agneaux, des offrandes et des libations; tu les offriras sur l'autel du Temple de votre Dieu à Jérusalem."
,"18":"Avec le reste de l'argent et de l'or, toi et tes frères vous ferez ce qui vous semble bon, selon la volonté de votre Dieu."
,"19":"Tu déposeras devant le Dieu de Jérusalem, pour le service de sa maison, les objets qui te sont confiés."
,"20":"Si tu dois fournir encore autre chose pour la Maison de ton Dieu, tu le prendras sur le trésor royal."
,"21":"Moi, le roi Artaxerxès, j'ordonne ceci à tous les trésoriers de la province au-delà de l'Euphrate: vous exécuterez point par point tout ce que vous demandera le prêtre Esdras, scribe de la Loi du Dieu du ciel."
,"22":"Vous pouvez dépenser pour tout cela, jusqu'à cent talents d'argent, cent mesures de blé, cent mesures de vin, cent mesures d'huile; quant au sel, vous le verserez sans compter."
,"23":"On exécutera scrupuleusement tout ordre du Dieu du ciel concernant sa Maison, pour que sa colère ne s'emporte pas contre le royaume du roi et de ses fils."
,"24":"Nous faisons encore savoir ceci: Vous ne percevrez ni taxe, ni impôt, ni droit de passage sur les prêtres, les lévites, les chantres, les portiers et les serviteurs, en un mot: sur tous ceux qui assurent le service de ce Temple de Dieu."
,"25":"Quant à toi, Esdras, avec cette sagesse qui te vient de ton Dieu, tu établiras des juges et des magistrats pour rendre la justice à tout le peuple de la province au-delà du Jourdain, à tous ceux qui connaissent la Loi de ton Dieu et tu la feras connaître à celui qui ne la connaît pas encore."
,"26":"Si quelqu'un n'observe pas la Loi de ton Dieu et la loi du roi, il sera traîné en justice et condamné à l'amende, à la prison, à l'exil ou à la mort.'"
,"27":"Béni soit Yahvé, le Dieu de nos pères: il a mis dans le coeur du roi cette décision de rendre glorieux le Temple de Yahvé qui est à Jérusalem."
,"28":"Il a rendu le roi, ses conseillers et tous les hauts fonctionnaires du roi, favorables à mes projets. Alors, plein de courage, car Yahvé mon Dieu était avec moi, j'ai réuni les chefs d'Israël pour qu'ils partent avec moi."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Voici avec leur généalogie, les chefs de familles qui partirent de Babylone avec moi sous le règne du roi Artaxerxès:"
,"2":"des fils de Pinhas: Gerchom; des fils d'Itamar: Daniyel; des fils de David: Hatouch,"
,"3":"fils de Chekanyas; des fils de Paréoch: Zekaryas, avec qui furent enregistrés cent cinquante hommes;"
,"4":"des fils de Pahat-Moab: Elyoénaï fils de Zerahyas, et avec lui deux cents hommes;"
,"5":"des fils de Zatou: Chekanyas fils de Yahaziel, et avec lui trois cents hommes;"
,"6":"des fils de Adin: Ebed fils de Yonatan, et avec lui cinquante hommes;"
,"7":"des fils d'Elam: Yechayas fils d'Atalyas, et avec lui soixante-dix hommes;"
,"8":"des fils de Chefatyas: Zebadyas fils de Mikaël, et avec lui quatre-vingts hommes;"
,"9":"des fils de Yoab: Obadyas fils de Yehiel, et avec lui deux cent dix-huit hommes;"
,"10":"des fils de Bani: Chelomit fils de Yosifyas, et avec lui cent soixante hommes;"
,"11":"des fils de Bébaï: Zékaryas fils de Bébaï, et avec lui vingt-huit hommes;"
,"12":"des fils de Azgad: Yohanan fils de Hakatan, et avec lui cent dix hommes;"
,"13":"des fils d'Adonikam: les cadets dont voici les noms: Elifélet, Yeïel et Chemayas, avec eux soixante hommes;"
,"14":"des fils de Bigvaï: Outaï fils de Zaboud, et avec lui soixante-dix hommes."
,"15":"Je les ai rassemblés près de la rivière qui coule vers Ahava et pendant trois jours nous avons campé là. J'ai reconnu des laïcs et des prêtres, mais il n'y avait pas de lévites."
,"16":"J'ai donc envoyé Eliézer, Ariel, Chémayas, Yarib, Elnatan, Natan, les chefs, Zékaryas et Méchoullam, des instructeurs."
,"17":"Je les ai envoyés à Iddo, le gouverneur de Kasifya, je leur ai dit les paroles qu'ils devaient répéter à Iddo et à ses frères, installés à Kasifya, pour qu'ils nous amènent des serviteurs pour le Temple de notre Dieu."
,"18":"Comme Dieu dans sa bonté disposait toute chose en notre faveur, ils nous ramenèrent Chérébyas, un homme intelligent du clan de Mahli fils de Lévi fils d'Israël. Il vint avec ses fils et ses frères; ils étaient dix-huit."
,"19":"Hachabyas et son frère Yéchayas, du clan de Mérari, arrivèrent avec leurs fils, au nombre de vingt personnes."
,"20":"Parmi les serviteurs que David et les chefs avaient attribués au service des lévites, il en arriva également deux cent vingt; on les enregistra tous un par un."
,"21":"Là, au bord de la rivière Ahava, j'ai proclamé un jeûne pour faire pénitence devant notre Dieu, pour le supplier de nous donner un heureux voyage avec nos enfants et tout ce que nous emmenions."
,"22":"J'aurais eu honte de demander au roi une troupe ou des cavaliers pour nous protéger d'attaquants sur la route. En effet, nous avions dit au roi: 'La force de notre Dieu accompagne pour leur bien, tous ceux qui le cherchent, mais sa force et sa colère sont pour tous ceux qui l'abandonnent.'"
,"23":"Nous avons donc jeûné et nous avons supplié Dieu à cette intention, et il nous a exaucés."
,"24":"Alors j'ai pris à part douze parmi les chefs des prêtres en plus de Chérébyas, Achabyas et dix de leurs frères."
,"25":"J'ai pesé l'argent, l'or et les objets que le roi, ses conseillers, ses chefs et tous les Israélites présents avaient donnés pour le Temple de notre Dieu."
,"26":"Tout cela je l'ai pesé et remis entre leurs mains: 65 0 talents d'argent, 10 0 objets d'argent valant chacun 2 talents d'argent, cent talents d'or,"
,"27":"20 coupes d'or valant 1 000 pièces perses et deux beaux vases de bronze doré aussi précieux que de l'or."
,"28":"Je leur ai dit: 'Vous êtes consacrés au service de Yahvé; ces objets sont sacrés; cet argent et cet or ont été donnés pour Yahvé, le Dieu de vos pères."
,"29":"Faites donc attention et gardez-les jusqu'au jour où vous pourrez les peser devant les chefs des prêtres et des lévites et devant les chefs des familles d'Israël dans les salles du Temple de Yahvé à Jérusalem.'"
,"30":"Alors les prêtres et les lévites se chargèrent de cet argent, de cet or et de tous ces objets que l'on avait pesés pour les emporter au Temple de notre Dieu, à Jérusalem."
,"31":"Nous avons quitté la rivière Ahava le douze du premier mois, pour nous rendre à Jérusalem; la main de notre Dieu était avec nous et il nous a protégés tout au long de la route des attaques des ennemis et des pillards."
,"32":"Arrivés à Jérusalem, nous avons pris trois jours de repos."
,"33":"Le quatrième jour, on a pesé l'or, l'argent et les objets dans le Temple de notre Dieu; on les a remis entre les mains du prêtre Mérémot fils d'Ourya. Eléazar fils de Pinhas était là ainsi que les lévites Yozabad fils de Josué, et Noadyas fils de Binnouï."
,"34":"Tout était là en nombre et en poids, et on enregistra le poids total."
,"35":"Ceux qui revenaient de la captivité après leur exil offrirent des holocaustes au Dieu d'Israël: douze taureaux pour tout Israël, quatre-vingt-seize béliers, soixante-douze agneaux et douze boucs pour le péché; on offrit tout en holocauste à Yahvé."
,"36":"On remit les ordonnances du roi aux gouverneurs et aux chefs de la province d'au-delà de l'Euphrate: ils apportèrent leur aide au peuple et au Temple de Dieu."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Après cela, les chefs s'avancèrent vers moi: 'Le peuple d'Israël, me dirent-ils, les prêtres et les lévites, ne se sont pas séparés de tous ces peuples Cananéens, Hittites, Périzites, Jébuséens, Ammonites, Moabites, Egyptiens ou Amorites, dont les pratiques sont abominables!"
,"2":"Ils ont pris de leurs filles pour eux et pour leurs fils, et la race sainte s'est mélangée avec les peuples des pays. Les chefs et les responsables ont été les premiers à pécher de cette façon.'"
,"3":"En apprenant cela, j'ai déchiré mon vêtement et mon manteau, je me suis arraché les cheveux et la barbe et, bouleversé, je me suis assis."
,"4":"Alors tous ceux qui redoutaient les paroles du Dieu d'Israël à propos de ce péché des déportés, se sont rassemblés autour de moi, et moi je suis resté là bouleversé jusqu'à l'offrande du soir."
,"5":"Au moment de l'offrande du soir, je suis sorti de mon abattement et c'est en habit et en manteau déchirés que je me suis jeté à genoux. J'ai tendu les mains vers Yahvé mon Dieu"
,"6":"et je lui ai dit: 'Je suis si honteux et si confus que je n'ose lever mon visage vers toi, mon Dieu! Nos fautes se sont accumulées au point de dépasser nos têtes et notre péché s'est élevé jusqu'au Ciel!"
,"7":"Depuis le temps de nos pères jusqu'à ce jour, nous n'avons cessé de pécher devant toi, et à cause de nos fautes, nous, nos rois et nos prêtres avons été livrés aux rois des nations païennes, livrés au glaive, à la captivité et au pillage, et aujourd'hui encore nous portons la honte sur notre visage."
,"8":"Depuis quelque temps Yahvé notre Dieu nous a montré sa bonté: il nous a laissé un petit reste de survivants, il nous a laissé mettre un pied dans son Lieu Saint Notre Dieu a voulu rendre un peu de lumière à nos yeux et nous donner vie dans notre esclavage."
,"9":"Nous restons esclaves, mais notre Dieu ne nous a pas abandonnés dans cet esclavage, il nous a couverts de sa miséricorde face aux rois de Perse. Il nous a donné un répit, la Maison de notre Dieu a été relevée de ses ruines, il nous a rendu les remparts de Juda et de Jérusalem."
,"10":"Maintenant, notre Dieu, que pouvons-nous dire de plus? En effet, nous avons abandonné tes commandements,"
,"11":"l'avertissement que tu nous avais donné par la bouche de tes serviteurs les prophètes: Le pays où vous allez entrer et qui sera votre héritage est un pays souillé par l'impureté des peuples païens. D'un bout à l'autre, ils l'ont rempli d'impuretés par leurs pratiques honteuses."
,"12":"Ne donnez donc pas vos filles en mariage à leurs fils et ne prenez pas leurs filles pour vos fils. Ne faites rien pour leur bonheur et prospérité. Si vous agissez selon ma Loi, vous serez forts, vous mangerez les produits du pays et vous le laisserez en héritage à vos fils pour toujours."
,"13":"Bien des malheurs nous sont arrivés à cause de nos pratiques mauvaises et de notre grand péché; toi pourtant, notre Dieu, tu n'as retenu que peu de nos fautes et tu nous as laissé les survivants qui sont ici."
,"14":"Allons-nous donc encore une fois violer tes commandements et nous unir par le mariage avec ces abominables? Sûrement tu te mettrais en colère contre nous et tu nous détruirais au point qu'il n'y ait ni reste ni survivant."
,"15":"Yahvé, Dieu d'Israël, tu es juste, toi qui nous as laissé un reste, des survivants, car c'est un fait. Nous voici devant toi avec notre faute: comment rester ainsi devant ta face.'"
}`)
	CurrentBook.AddChapter(10, `{
"1":"Tout en pleurs et prosterné devant le Temple de Dieu, Esdras faisait cette prière et cette confession; une foule très nombreuse d'Israélites, hommes, femmes et enfants, se rassembla autour de lui: le peuple pleurait bruyamment."
,"2":"Chékanyas fils de Yéhiel, l'un des fils d'Elam, prit la parole et dit à Esdras: 'Nous avons trahi notre Dieu en prenant des femmes étrangères parmi les peuples du pays, mais il y a encore de l'espoir pour Israël."
,"3":"Nous allons nous engager devant notre Dieu, de façon solennelle, à renvoyer toutes nos femmes étrangères et les enfants qui en sont nés. Ainsi nous obéirons aux conseils de mon seigneur et de ceux qui craignent le commandement de notre Dieu. Oui, nous agirons selon la Loi!"
,"4":"Lève-toi! Car la chose te regarde et nous sommes avec toi. Sois fort et mets-toi au travail.'"
,"5":"Esdras se leva et fit jurer les chefs des prêtres et des lévites et tout Israël de faire comme on venait de le dire; ils le jurèrent."
,"6":"Esdras quitta le Temple de Dieu et alla dans la chambre de Yohanan, fils d'Elyachib, il passa là toute la nuit sans manger de pain et sans boire d'eau, car il était dans la tristesse à cause de l'infidélité des exilés."
,"7":"On proclama un avis dans Juda et dans Jérusalem à l'attention de tous ceux qui avaient été déportés: ils devaient se rassembler à Jérusalem."
,"8":"Si quelqu'un ne venait pas dans les trois jours - c'était l'avis des chefs et des anciens-, tous ses biens seraient voués à l'anathème et lui-même serait rejeté de la communauté des déportés."
,"9":"Tous les hommes de Juda et de Benjamin se rassemblèrent donc à Jérusalem le troisième jour; c'était le vingt du neuvième mois. Tout le peuple s'assit sur la place devant le Temple de Dieu. Les gens tremblaient à cause des événements, mais aussi parce qu'il pleuvait."
,"10":"Alors le prêtre Esdras se leva et leur dit: 'Vous avez été infidèles, vous avez épousé des femmes étrangères et vous avez augmenté la faute d'Israël."
,"11":"Mais maintenant, confessez la vérité devant Yahvé, le Dieu de vos pères et faites ce qu'il vous demande: séparez-vous des peuples du pays et des femmes étrangères.'"
,"12":"Toute l'assemblée répondit d'une voix forte: 'Tu as bien dit, il ne nous reste qu'à le faire."
,"13":"Mais le peuple est nombreux et nous sommes à la saison des pluies, nous ne pouvons rester dehors et l'affaire ne se réglera pas en un jour ou deux. Nous sommes en effet nombreux à avoir commis ce péché."
,"14":"Que nos chefs restent là pour toute la durée de l'assemblée: tous ceux qui dans nos villes ont épousé des femmes étrangères, viendront à la date qu'on leur fixera, et avec eux viendront les anciens de chaque ville et les juges, jusqu'à ce que l'on ait écarté de nous la colère de notre Dieu à ce sujet.'"
,"15":"Seuls Yonatan fils d'Asahel, et Yahzéyas fils de Tikva, furent opposés à cette façon de faire; Méchoulam et le lévite Chabtaï les soutenaient."
,"16":"Mais les exilés firent comme on l'avait proposé; le prêtre Esdras choisit pour chaque maison des chefs de famille nommément désignés. Ils commencèrent à siéger le premier jour du dixième mois, pour examiner les cas,"
,"17":"et au premier jour du premier mois ils avaient achevé de régler le problème de ceux qui avaient épousé des femmes étrangères."
,"18":"Voici pour les prêtres la liste de ceux qui avaient pris des femmes étrangères: parmi les fils de Josué fils de Yosadak et parmi ses frères: Maaséyas, Eliézer, Yarib et Geldaya."
,"19":"Ils firent le serment de renvoyer leurs femmes et d'offrir un bélier en sacrifice de réparation pour leur péché;"
,"20":"parmi les fils d'Immer: Hanani et Zebadya;"
,"21":"parmi les fils de Harim: Maaséyas, Eliyas, Chémayas, Yehiel et Ouziya;"
,"22":"parmi les fils de Pachehour: Elyoénaï, Maaséyas, Ismaël, Netanéel, Yozabad et Eléasa;"
,"23":"parmi les lévites: Yozabad, Chiméï, Kélaya -le même que Kélita -, Petayas, Yehouda et Eliézer;"
,"24":"parmi les chantres: Elyachib et Zakour; parmi les portiers: Challoum, Télem et Ouri;"
,"25":"et parmi les Israélites: des fils de Paréoch: Ramyas, Yiziyas, Malkiyas, Miyamin, Eléazar, Malkiya et Benaya;"
,"26":"des fils d'Elam: Mattanyas, Zekaryas, Yehiel, Abdi, Yerémot et Eliya;"
,"27":"des fils de Zattou: Elyoénaï, Elyachib, Mattanyas, Yerémot, Zabad et Aziza;"
,"28":"des fils de Bébaï: Yohanan, Hananyas, Zabaï, Atlaï;"
,"29":"des fils de Bigvaï: Mechoulam, Malouk, Yedayas, Yachoub, Yichal, Yerémot;"
,"30":"des fils de Pahat-Moab: Adna, Kelal, Benayas, Maaséyas, Mattanyas, Besaléel, Binouï et Menassé;"
,"31":"des fils de Harim: Eliézer, Yichchiyas, Malkiyas, Chemayas, Chimeon,"
,"32":"Binyamin, Malouk, Chemarya;"
,"33":"des fils de Hachoum: Mattenaï, Mattatyas, Zabad, Elifélet, Yerémaï, Menassé, Chiméï;"
,"34":"des fils de Bani: Maadaï, Amram, Yoël,"
,"35":"Benayas, Bédyas, Kélayas,"
,"36":"Vanyas, Merémot, Elyachib,"
,"37":"Mattanyas, Mattenaï et Yaasaï;"
,"38":"des fils de Binouï: Chiméï,"
,"39":"Chélémyas, Natan et Adaya;"
,"40":"des fils de Zakaï: Chachaï, Charaï,"
,"41":"Azaréel, Chélémyas, Chemaryas,"
,"42":"Challoum, Amaryas, Yosef;"
,"43":"des fils de Nebo: Yeïel, Mattityas, Zabad, Zebina, Yaddaï, Yoël, Benaya."
,"44":"Tous ceux-là avaient épousé des femmes étrangères, ils les renvoyèrent avec leurs enfants."
}`)

}
func FR_LBDCC_LoadVHETChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"On était donc au temps du roi Assuérus; son empire s'étendait de l'Inde jusqu'à l'Ethiopie et comptait cent vingt-sept provinces;"
,"2":"son trône royal était alors établi dans la forteresse de Suse."
,"3":"En la troisième année de son règne, il fit un grand repas pour ses hauts fonctionnaires et ses serviteurs chefs de l'armée des Perses et des Mèdes, pour les gouverneurs et les chefs de provinces. Lui-même présidait le banquet."
,"4":"Il voulait pendant de nombreux jours (cent quatre-vingts jours) leur montrer la richesse de son royaume et sa propre gloire, sa richesse et sa réussite."
,"5":"Lorsque ce temps fut écoulé, le roi organisa dans la cour de son palais un grand repas qui devait durer sept jours; tout le peuple de la forteresse de Suse, du plus grand jusqu'au plus petit, y était invité."
,"6":"Des tentures blanches et violettes étaient suspendues par des cordons de lin et de pourpre à des anneaux d'argent fixés sur des colonnes de marbre. Des lits d'or et d'argent étaient disposés sur un pavé de pierres rares, de marbre, de nacre et de mosaïques."
,"7":"On servait les boissons dans des vases en or de différentes formes et selon l'ordre du roi, le vin coulait à flots."
,"8":"Cependant personne n'était obligé de boire, car le roi avait ordonné à tous ses serviteurs de respecter la volonté de chacun."
,"9":"La reine Vasthi avait organisé de son côté un repas pour les femmes dans le palais d'Assuérus."
,"10":"Le septième jour, comme le vin l'avait mis de fort bonne humeur, le roi ordonna à Méhouman, à Bizéta, à Harbona, à Bigta, à Abgata, à Zétar et à Karkas, les sept eunuques attachés à son service personnel,"
,"11":"de lui amener la reine Vasthi coiffée de la couronne royale. Il voulait se vanter de la beauté de la reine devant le peuple et devant ses officiers: c'est vrai qu'elle était très belle."
,"12":"Mais la reine Vasthi refusa de répondre à l'ordre du roi transmis par les eunuques; le roi en fut très vexé et se mit dans une grande colère."
,"13":"Il se tourna vers les sages, les spécialistes des lois (en effet, toutes les affaires du roi étaient traitées en présence de ceux qui avaient la connaissance de la loi et du droit)."
,"14":"Il fit donc venir près de lui Karchéna, Chétar, Admata, Tarchich, Mérès, Marséna et Mémoukan, les sept hauts fonctionnaires perses et mèdes qui étaient admis en sa présence et qui occupaient les premières places dans le royaume."
,"15":"Il leur dit: 'D'après la loi, que doit-on faire à la reine Vasthi pour n'avoir pas obéi à l'ordre du roi Assuérus, qu'il lui a fait porter par les eunuques?'"
,"16":"Mémoukan répondit en présence du roi et des hauts fonctionnaires: 'Ce n'est pas seulement au roi que la reine Vasthi a fait tort, mais aussi à tous les hauts fonctionnaires et aux différents peuples répandus à travers les provinces du royaume d'Assuérus."
,"17":"Toutes les femmes viendront à savoir ce qu'a fait la reine, et cela les encouragera à ne plus respecter l'autorité de leur mari. Elles diront: Le roi Assuérus avait donné personnellement à la reine Vasthi l'ordre de venir, et elle n'est pas venue!"
,"18":"Aujourd'hui même les princesses de Perse et de Médie vont être au courant du refus de la reine: Comment vont-elles répondre à tous les fonctionnaires du roi? Partout ce ne sera que mépris et colère."
,"19":"Si le roi le juge bon, il faut publier aujourd'hui de sa part une ordonnance royale et l'inscrire parmi les lois des Perses et des Mèdes, de sorte que personne ne puisse aller contre. Cette ordonnance interdira à la reine Vasthi de se présenter désormais devant le roi Assuérus, et le roi donnera son titre de reine à une autre meilleure qu'elle."
,"20":"L'ordonnance que le roi aura publiée sera portée à la connaissance de tous dans son royaume, afin que toutes les femmes aient du respect pour leur mari, depuis le plus grand jusqu'au plus petit.'"
,"21":"Cette proposition parut bonne au roi et à ses fonctionnaires, et le roi suivit l'avis de Mémoukan."
,"22":"Il envoya des lettres dans toutes les provinces, à chaque province selon son écriture, à chaque peuple selon sa langue, pour que tout mari soit maître dans sa maison."
}`)
	CurrentBook.AddChapter(2, `{
"1":"La colère du roi Assuérus finit par se calmer, il ne pensa plus à Vasthi, à ce qu'elle avait fait et ce qu'on avait décidé à son sujet."
,"2":"Les serviteurs du roi lui dirent alors: 'Cherchons pour le roi des jeunes filles qui soient à la fois vierges et belles."
,"3":"Il faut que le roi nomme des inspecteurs dans toutes les provinces de son royaume, et qu'ils rassemblent dans la citadelle de Suse toutes les jeunes filles vierges et belles à la fois. On les placera dans la maison des femmes sous la surveillance de Hégé, l'eunuque du roi qui est le gardien de ses femmes. Il leur donnera tous les produits de beauté,"
,"4":"et la jeune fille qui plaira au roi deviendra reine à la place de Vasthi.' Le roi trouva cela très bien, et l'on fit donc ainsi."
,"5":"Or il y avait dans la forteresse de Suse un Juif nommé Mardochée; il était fils de Yaïr, fils de Chiméï, fils de Kish, de la tribu de Benjamin."
,"6":"Il faisait partie des déportés que Nabukodonozor, roi de Babylone, avait emmenés de Jérusalem avec Jékonias, roi de Juda."
,"7":"Ce Juif élevait sa nièce Hadassah - c'est Esther - car elle avait perdu son père et sa mère; la jeune fille était élégante et ravissante. A la mort de son père et de sa mère, Mardochée l'avait adoptée pour fille."
,"8":"Aussitôt connus l'ordre du roi et sa décision de rassembler de nombreuses jeunes filles dans la forteresse de Suse, sous la surveillance de Hégé, Esther fut conduite elle aussi au palais du roi et placée sous la surveillance du gardien des femmes."
,"9":"Comme la jeune fille lui plaisait, Hégé la traita avec beaucoup d'attentions; il se dépêcha de lui donner ce qui était nécessaire à sa toilette et à sa nourriture. Il mit à son service sept servantes choisies dans le palais royal et il l'installa avec ses servantes dans le meilleur appartement de la maison des femmes."
,"10":"Esther n'avait dit à personne quel était son peuple, qui étaient ses parents, car Mardochée lui avait interdit de le faire."
,"11":"Mais chaque jour Mardochée allait faire sa promenade devant la cour de la maison des femmes, pour prendre des nouvelles d'Esther et de sa santé."
,"12":"Durant douze mois les jeunes filles se préparaient: pendant six mois elles se parfumaient avec de l'huile de myrrhe, et pendant les six autres mois avec des parfums et des produits de beauté pour femmes. Après ce temps occupé par les soins de beauté, chaque jeune fille à son tour devait se rendre auprès du roi."
,"13":"Quand elle allait chez le roi, chaque jeune fille pouvait demander tout ce dont elle avait besoin pour passer de la maison des femmes au palais royal."
,"14":"Elle s'y rendait le soir et le lendemain matin elle regagnait une autre maison des femmes confiée à Chaachgaz, l'eunuque du roi chargé de la garde des concubines. Elle ne retournait plus auprès du roi, sauf si le roi était devenu amoureux d'elle; alors il la faisait rappeler personnellement."
,"15":"Le jour arriva pour Esther , fille d'Abihayil, l'oncle de Mardochée, son père adoptif, de se présenter devant le roi. Elle ne demanda rien d'autre que ce que lui avait donné Hégé, l'eunuque du roi, chargé de la garde des femmes. Or tous ceux qui la virent, trouvèrent Esther ravissante."
,"16":"On la conduisit auprès du roi Assuérus, dans le palais royal, le dixième mois - c'est Tébet- en la septième année de son règne."
,"17":"Le roi la préféra à toutes les autres femmes; elle gagna sa faveur et sa bienveil lance plus qu'aucune autre jeune fille. Il posa sur sa tête la couronne royale et la choisit pour reine à la place de Vasthi."
,"18":"Après cela, le roi donna en l'honneur d'Esther un grand festin à tous les hauts fonctionnaires et à ses serviteurs, il accorda un jour de congé dans toutes les provinces et distribua des cadeaux avec une générosité royale."
,"19":"Comme les autres jeunes filles, Esther passa dans la seconde maison des femmes."
,"20":"Obéissant aux ordres de Mardochée, comme lorsqu'elle était élevée par lui, Esther ne révéla à personne ses origines."
,"21":"Tandis que Mardochée était assis à la porte royale, deux eunuques du roi, Bigtan et Térech, gardiens des portes, décidèrent d'assassiner le roi Assuérus, car ils étaient mécontents de lui."
,"22":"Mardochée l'apprit et le dit à la reine Esther; à son tour, celle-ci en parla au roi de la part de Mardochée."
,"23":"On fit une enquête, on s'aperçut que cela était exact et les deux hommes furent pendus; puis, sous les yeux du roi, on écrivit dans le Livre des Chroniques le récit de cet événement."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Quelque temps plus tard, le roi Assuérus honora Aman, fils de Hamdata, de la race d'Agag, de façon toute particulière; il le mit au-dessus de tous les hauts fonctionnaires, ses collègues."
,"2":"Par ordre du roi, tous ses serviteurs, responsables du service de la Porte, devaient s'agenouiller et se prosterner devant lui. Mais Mardochée refusa de plier le genou et de se prosterner."
,"3":"Les autres serviteurs du roi qui étaient à la Porte dirent à Mardochée: 'Pourquoi désobéis-tu à l'ordre du roi?'"
,"4":"Tous les jours ils lui redisaient la même chose, mais il ne les écoutait pas; Mardochée leur dit alors qu'il était Juif. Ils le dénoncèrent auprès d'Aman pour voir s'il persisterait dans son attitude."
,"5":"Lorsqu'Aman vit que Mardochée ne pliait pas le genou et ne se prosternait pas devant lui, il devint furieux."
,"6":"Il aurait pu frapper Mardochée tout seul, mais comme on lui avait appris à quel peuple appartenait Mardochée, Aman chercha à exterminer le peuple de Mardochée, c'est-à-dire tous les Juifs qui étaient dans le royaume d'Assuérus."
,"7":"Au premier mois (c'est le mois de Nisan), en la douzième année du roi Assuérus, on jeta le Pour (c'est-à-dire le sort) en présence d'Aman, pour savoir à quel moment on exterminerait les Juifs; le sort tomba sur le douzième mois, c'est-à-dire le mois d'Adar."
,"8":"Aman dit alors au roi Assuérus: 'Dans toutes les provinces de ton royaume on retrouve un peuple inassimilable, dispersé au milieu des autres peuples. Leurs lois ne ressemblent à celles d'aucun autre et ils n'observent pas les lois du roi. Ce n'est pas l'intérêt du roi de les laisser faire."
,"9":"Si le roi le juge bon, donnons l'ordre de les exterminer, et je donnerai dix mille talents d'argent aux fonctionnaires pour qu'ils les versent dans le trésor du roi.'"
,"10":"Le roi enleva son anneau, avec lequel il scellait ses lettres, et il le donna à Aman, fils d'Hamdata, de la race d'Agag, l'ennemi des Juifs."
,"11":"Le roi ajouta: 'Garde ton argent, et fais ce que tu veux avec ce peuple."
,"12":"Le treizième jour du premier mois, on convoqua les secrétaires du roi; on écrivit selon les ordres d'Aman, aux gouverneurs du roi, aux chefs de chaque province et de chaque peuple, à chaque province selon son écriture, à chaque peuple selon sa langue. Les lettres portaient le nom du roi Assuérus, elles étaient scellées avec l'anneau royal."
,"13":"Des messagers portèrent ces lettres dans toutes les provinces du royaume: on y ordonnait de faire disparaître, de tuer, d'exterminer en un même jour tous les Juifs, les jeunes gens comme les vieillards, les enfants avec les femmes, le treizième jour du douzième mois (c'est le mois d'Adar) On mettrait au pillage tous leurs biens."
,"14":"On devait remettre une copie de cette lettre dans chaque province pour qu'elle ait force de loi, et la faire connaître à tous les peuples pour qu'ils soient prêts ce jour-là."
,"15":"Sur l'ordre du roi les messagers partirent aussitôt; la loi fut publiée d'abord dans la forteresse de Suse. La ville de Suse en resta abasourdie, tandis que le roi et Aman ne faisaient que boire et festoyer."
}`)
	CurrentBook.AddChapter(4, `{
"1":"En apprenant ces mesures, Mardochée déchira ses vêtements, il prit un sac et se recouvrit de cendres, puis il parcourut toute la ville en poussant des cris déchirants."
,"2":"Il alla ainsi jusqu'à la porte royale que nul ne pouvait franchir habillé d'un sac."
,"3":"Dans les provinces, à mesure que parvenaient l'ordre et le décret, ce n'était parmi les Juifs, que deuil, jeûne, larmes et lamentations; beaucoup se couchaient sur le sac et la cendre."
,"4":"Quand elle apprit tout cela par ses servantes et ses eunuques, Esther fut épouvantée. Elle fit porter des vêtements à Mardochée pour qu'il les mette à la place de son sac, mais il refusa."
,"5":"Elle appela alors Hatak, l'un des eunuques que le roi avait mis à son service, et elle l'envoya à Mardochée pour apprendre de lui ce qui se passait et pourquoi il agissait ainsi."
,"6":"Hatak sortit donc à la rencontre de Mardochée sur la place de la ville, face à la Porte."
,"7":"Mardochée lui raconta tout ce qui venait d'arriver et lui parla de la somme d'argent qu'Aman voulait offrir au trésor royal en échange de la vie des Juifs."
,"8":"Il lui donna une copie du décret d'extermination publié à Suse pour qu'il la montre à Esther et la mette au courant. Il ordonnait à Esther d'aller trouver le roi pour implorer sa bonté et le supplier en faveur de son peuple. Mardochée lui fit dire ceci: 'Souviens-toi du temps où tu étais dans la misère et où je te nourrissais de ma main. Puisque maintenant Aman, le second personnage du royaume, a demandé notre mort au roi, prie le Seigneur, parle pour nous au roi, arrache-nous à la mort!' "
,"9":"Hatak rapporta à Esther les paroles de Mardochée."
,"10":"Esther renvoya Hatak avec cette réponse:"
,"11":"'Les serviteurs du roi savent bien, tout comme le peuple des provinces du roi, que quiconque, homme ou femme, entre chez le roi dans la cour intérieure sans avoir été appelé, doit être mis à mort. La loi ne fait pas d'exception à ce sujet, seul celui à qui le roi tend son sceptre d'or, conserve la vie sauve. Et moi, je n'ai pas été appelée chez le roi depuis trente jours.'"
,"12":"Hatak rapporta à Mardochée les paroles d'Esther."
,"13":"Mais Mardochée fit dire de nouveau à Esther: 'Ne pense pas que tu échapperas à la mort, seule parmi les Juifs, parce que tu es dans le palais royal."
,"14":"Si aujourd'hui tu te tais, le salut et la délivrance viendront pour les Juifs d'un autre côté, mais toi et la maison de ton père, vous périrez. Qui sait si ce n'est pas pour un jour comme celui-ci que tu es devenue reine.'"
,"15":"Esther fit répondre à Mardochée:"
,"16":"'Rassemble tous les Juifs qui sont à Suse et jeûnez pour moi. Ne mangez pas, ne buvez pas pendant trois jours et trois nuits, et moi aussi je jeûnerai avec mes servantes; puis j'irai trouver le roi contrairement à la loi et, si je dois mourir, je mourrai.'"
,"17":"Mardochée s'en alla donc et fit tout ce qu'Esther lui avait demandé."
}`)
	CurrentBook.AddChapter(5, `{
"3":"'Qu'y a-t-il, reine Esther?' demanda le roi. 'Dis-moi ce que tu veux: quand ce serait la moitié de mon royaume, elle te serait donnée.'"
,"4":"Esther répondit: 'Est-ce que le roi acceptera de venir aujourd'hui avec Aman au festin que j'ai préparé pour lui?'"
,"5":"Le roi dit aussitôt: 'Allez vite chercher Aman et faisons ce qu'Esther a demandé.',Le roi se rendit donc avec Aman au festin qu'Esther avait préparé. "
,"6":"Tandis qu'on servait le vin, le roi dit à Esther: 'Quelle est ta demande? Elle te sera accordée. Dis-moi ce que tu désires, serait-ce même la moitié du royaume, ce sera fait.'"
,"7":"Esther répondit: 'Ma demande et mon désir?"
,"8":"Si j'ai trouvé grâce au yeux du roi, si le roi juge bon de satisfaire ma demande et mon désir, que le roi vienne encore avec Aman au repas que je préparerai pour eux demain. Alors je donnerai au roi ma réponse.'"
,"9":"Ce jour-là Aman sortit joyeux et de bonne humeur. Mais quand il vit à la porte du roi Mardochée qui ne se levait pas et ne se dérangeait pas devant lui, de nouveau il fut rempli de colère contre Mardochée."
,"10":"Il se domina cependant et rentra chez lui; il envoya alors chercher ses amis et sa femme Zérech."
,"11":"Aman leur redit en détail son incroyable richesse, le grand nombre de ses fils, et tout ce que le roi avait fait pour l'élever et le mettre au-dessus de tous les fonctionnaires et de tous les serviteurs du roi."
,"12":"Aman ajouta: 'La reine Esther n'a invité personne d'autre que moi au festin qu'elle a préparé pour le roi, et demain encore je suis invité par elle avec le roi."
,"13":"Mais tout cela n'est rien pour moi tant que je vois Mardochée, ce Juif, assis à la porte du roi."
,"14":"Sa femme Zérech et ses amis lui dirent: 'Donne l'ordre de dresser une potence haute de cinquante coudées, et demain matin tu demanderas au roi qu'on y pende Mardochée. Tu seras ainsi de bonne humeur pour aller au festin avec le roi.' Aman partagea cet avis et donna l'ordre de dresser la potence."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Mais cette nuit-là, le roi n'arrivait pas à s'endormir. Il se fit apporter le Livre des mémoires, les Chroniques, et on en fit la lecture devant le roi."
,"2":"On tomba sur le passage où l'on racontait comment Mardochée avait dénoncé les deux eunuques du roi, Bigtan et Térech, les gardiens de la Porte qui avaient voulu assassiner le roi Assuérus."
,"3":"Le roi dit alors: 'A-t-on fait quelque chose de spécial pour Mardochée? Lui a-t-on donné de l'avancement?' Les serviteurs du roi répondirent: 'On n'a rien fait pour lui.'"
,"4":"Alors le roi dit: 'Qui est dans la cour?' Et justement c'était Aman qui franchissait la cour extérieure du palais royal pour demander au roi de faire pendre Mardochée à la potence qu'il avait dressée pour lui."
,"5":"Les serviteurs du roi répondirent: 'C'est Aman qui est dans la cour.' Le roi dit: 'Faites-le entrer.'"
,"6":"Aman entra et le roi lui demanda: 'Que peut-on faire pour un homme que le roi veut honorer?' Aman se dit en lui-même: 'Quel autre que moi le roi pourrait-il bien honorer?'"
,"7":"Il répondit au roi: 'Le roi veut-il honorer quelqu'un?"
,"8":"Qu'il fasse apporter un vêtement royal que le roi a porté, un cheval que le roi a monté et sur la tête duquel on a déjà placé une couronne royale."
,"9":"Qu'on remette le vêtement et le cheval à l'un des principaux ministres du roi, qu'on en habille l'homme que le roi veut honorer, qu'on le fasse monter sur le cheval et qu'on le fasse promener à travers toute la ville. Quelqu'un criera devant lui: Voici ce que l'on fait à l'homme que le roi veut honorer.'"
,"10":"Le roi dit alors à Aman: 'Dépêche-toi, prends ce vêtement et le cheval comme tu l'as dit, et fais tout cela pour Mardochée, le Juif, qui est assis à la porte du roi. N'oublie rien de ce que tu as dit.'"
,"11":"Aman prit donc le vêtement et le cheval, il en fit revêtir Mardochée et le promena à cheval à travers la ville, et il proclamait devant lui: 'Voici ce que l'on fait à l'homme que le roi veut honorer!'"
,"12":"Puis Mardochée retourna à la Porte du roi, tandis qu'Aman rentrait chez lui précipitamment, honteux et la tête voilée."
,"13":"Aman raconta en détail à sa femme Zérech et à tous ses amis ce qui venait de se passer. Ces hommes sages lui dirent, ainsi que sa femme Zérech: 'Si Mardochée est de race juive et que tu as commencé de basculer, tu ne pourras rien contre lui. Tu tomberas devant lui.'"
,"14":"Ils parlaient encore lorsque les eunuques arrivèrent et prirent Aman avec eux pour le conduire au festin qu'Esther avait préparé."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Le roi vint donc, ainsi qu'Aman, au festin de la reine Esther."
,"2":"Ce second jour, le roi dit encore à Esther au moment où l'on servait le vin: 'Quelle est ta demande, reine Esther? Elle te sera accordée! Quel est ton désir? Quand ce serait la moitié de mon royaume, cela se fera.'"
,"3":"La reine Esther répondit au roi: 'Si j'ai trouvé grâce aux yeux du roi, et si le roi le veut bien, je demande qu'on m'accorde la vie, je désire qu'on l'accorde à mon peuple."
,"4":"Car nous avons été vendus, moi et mon peuple, pour être massacrés, tués, exterminés. Si nous avions été seulement vendus en esclavage, je n'aurais rien dit; mais comment l'ennemi pourra-t-il compenser ce dommage fait au roi?'"
,"5":"Le roi Assuérus prit la parole et dit à la reine Esther: 'Mais, qui est-ce? Où est-il cet homme qui nourrit de tels projets?'"
,"6":"Esther répondit: 'L'adversaire, l'ennemi, le voici! C'est Aman, ce méchant homme!' Aman resta glacé de terreur face au roi et à la reine."
,"7":"Le roi se leva de table très en colère et gagna le jardin du palais; Aman, lui, resta pour implorer son salut auprès de la reine Esther, car il voyait bien que le roi avait décidé sa perte."
,"8":"Lorsque le roi revint du jardin du palais à la salle du festin, Aman s'était laissé tomber sur le divan où Esther était étendue. Le roi s'écria: 'Va-t-il maintenant faire violence à la reine, chez moi, dans mon palais?' Aussitôt, le roi donna un ordre et l'on jeta un voile sur le visage d'Aman."
,"9":"Arbona, l'un des eunuques, dit au roi: 'Il y a une potence qu'Aman a préparée pour Mardochée, celui qui a bien mérité du roi. Elle est dressée devant la maison d'Aman et elle est haute de cinquante coudées.' Alors le roi dit: 'Pendez-y Aman.'"
,"10":"On pendit Aman à la potence qu'il avait préparée pour Mardochée, et la colère du roi s'apaisa."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Ce jour même, le roi Assuérus donna à la reine Esther la maison d'Aman, l'ennemi des Juifs, et Mardochée vint se présenter devant le roi, car Esther avait révélé au roi ce qu'il était pour elle."
,"2":"Le roi enleva son anneau qu'il avait repris à Aman et le donna à Mardochée. Pour sa part, Esther confia à Mardochée la direction de la maison d'Aman."
,"3":"De nouveau, Esther parla au roi, elle tomba à ses pieds, pleura et le supplia de faire échouer la méchante entreprise d'Aman, descendant d'Agag, et les projets qu'il avait formés contre les Juifs."
,"4":"Le roi tendit à Esther son sceptre d'or; Esther se releva et resta debout devant le roi."
,"5":"Elle lui dit: 'Si le roi le juge bon, et si j'ai trouvé grâce à ses yeux, si cela paraît juste au roi et s'il a de l'amitié pour moi, qu'il écrive pour annuler les lettres écrites par Aman, fils d'Amdata, descendant d'Agag. Car il a écrit de mettre à mort tous les Juifs qui se trouvent dans les provinces du royaume."
,"6":"Comment pourrais-je voir le malheur prêt à tomber sur mon peuple? Comment pourrais-je voir la destruction de ma race?'"
,"7":"Le roi Assuérus répondit à la reine Esther et au Juif Mardochée: 'J'ai donné à Esther la maison d'Aman et lui on l'a pendu pour s'en être pris aux Juifs."
,"8":"Ecrivez donc vous-mêmes au sujet des Juifs, au nom du roi, comme vous le jugerez bon, et signez avec l'anneau royal, car une lettre écrite au nom du roi et signée avec l'anneau royal, ne peut être annulée.'"
,"9":"On rassembla donc les secrétaires du roi le vingt-troisième jour du troisième mois (c'est le mois de Sivan) et l'on écrivit sous la dictée de Mardochée, aux Juifs, aux gouverneurs, aux fonctionnaires, aux responsables des provinces, depuis l'Inde jusqu'à l'Ethiopie. On écrivit aux cent vingt-sept provinces, à chaque province selon son écriture, à chaque peuple selon sa langue, et aux Juifs selon leur écriture et leur langue."
,"10":"On écrivit au nom du roi Assuérus, on signa avec l'anneau royal et on confia les lettres à des cavaliers qui montaient des chevaux des écuries royales."
,"11":"Par ces lettres le roi autorisait les Juifs, dans chaque ville, à se rassembler et à défendre leurs vies. Ils pourraient massacrer, tuer et exterminer avec femmes et enfants, tous ceux qui les attaqueraient par les armes, dans quelque province que ce soit; et ils pillerait leurs biens."
,"12":"Ce serait le même jour pour toutes les provinces du royaume d'Assuérus, le treizième jour du douzième mois (c'est le mois d'Adar)."
,"13":"Une copie de cette lettre devait être donnée dans chaque province et portée à la connaissance de tous les peuples; au jour dit les Juifs se tiendraient prêts pour se venger de leurs ennemis."
,"14":"Les messagers à cheval de l'état partirent aussitôt pour exécuter sans retard l'ordre du roi. La loi fut publiée également dans la forteresse de Suse."
,"15":"Mardochée sortit de chez le roi avec un vêtement royal violet et blanc, une grande couronne d'or et un manteau de lin et de pourpre, et dans la ville de Suse ce fut la fête et la joie."
,"16":"Pour les Juifs, ce n'était que joie débordante, bonheur, fête et gloire."
,"17":"A mesure que parvenaient, dans chaque province et dans chaque ville, l'ordre du roi et son décret, ce n'étaient pour les Juifs que joie, fête, banquets et festivités de toute sorte. Bien des gens parmi le peuple du pays se firent Juifs, car ils avaient la crainte des Juifs."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Le treizième jour du douzième mois (le mois d'Adar), la situation se retourna. Ce jour même où l'on devait exécuter l'ordre du roi et son décret, ce jour où les ennemis des Juifs avaient pensé les exterminer, les Juifs triomphèrent de ceux qui les détestaient."
,"2":"Dans toutes les provinces du royaume d'Assuérus, les Juifs se réunirent dans leurs villes pour frapper ceux qui leur voulaient du mal; personne ne put leur résister, car tous les peuples avaient peur des Juifs."
,"3":"Tous les gouverneurs de province, les chefs, les responsables et les fonctionnaires du roi, aidaient les Juifs par peur de Mardochée."
,"4":"Car Mardochée était un personnage important dans le palais royal, sa renommée s'était répandue dans toutes les provinces et cet homme, Mardochée, devenait de plus en plus puissant."
,"5":"Les Juifs frappèrent à coups d'épée tous leurs ennemis; ce fut une tuerie, un massacre! Ils traitèrent comme ils le voulaient tous ceux qui les détestaient."
,"6":"Dans la forteresse de Suse, les Juifs tuèrent et massacrèrent cinq cents hommes."
,"7":"Parchandata, Dalfon, Aspata,"
,"8":"Porata, Adalya, Aridata,"
,"9":"Parmachta, Arisaï, Aridaï et Yézada,"
,"10":"les dix fils d'Aman, fils de Amdata, l'ennemi des Juifs, furent mis à mort; cependant les Juifs ne se livrèrent pas au pillage."
,"11":"Ce jour-là, on apprit au roi le nombre de ceux qui avaient été mis à mort dans la forteresse de Suse."
,"12":"Le roi dit alors à la reine Esther: 'Rien que dans la forteresse de Suse, les Juifs ont tué et massacré cinq cents hommes et les dix fils d'Aman; que n'auront-ils fait dans les autres provinces! Mais dis-moi ce que tu veux, cela te sera accordé. As-tu une demande? Cela sera fait.'"
,"13":"Esther lui dit: 'Si le roi le veut bien, qu'il accorde aux Juifs de Suse de continuer demain comme ils ont fait aujourd'hui, selon le décret du roi, et qu'on pende à la potence les dix fils d'Aman.'"
,"14":"Le roi décida que l'on ferait ainsi. On publia un décret dans Suse, et l'on pendit les dix fils d'Aman."
,"15":"Les Juifs de Suse se rassemblèrent le quatorzième jour du mois d'Adar et tuèrent encore dans Suse, trois cents hommes, mais ils ne se livrèrent pas au pillage."
,"16":"Les autres Juifs qui étaient dans les provinces du royaume, se réunirent aussi pour défendre leurs vies; ils firent le nécessaire pour être tranquilles du côté de ceux qui les détestaient, et tuèrent soixante quinze mille de leurs ennemis; mais ils ne se livrèrent pas au pillage."
,"17":"Ils firent cela le treizième jour du mois d'Adar, et ils firent du quatorzième jour un jour de repos, de banquets et de fête."
,"18":"Les Juifs qui étaient à Suse se réunirent le treize et le quatorze du mois, et ils firent du quinzième jour du mois un jour de repos, de banquets et de fête."
,"19":"C'est pour cela que les Juifs qui habitent la campagne ou les villes non fortifiées, font du quatorzième jour du mois d'Adar, un jour de réjouissance, de banquets et de fête; chacun envoie à cette occasion, des cadeaux à son prochain."
,"20":"Mardochée mit tout cela par écrit et envoya des lettres à tous les Juifs des différentes provinces d'Assuérus, aux plus proches comme aux plus lointains."
,"21":"Il leur ordonnait de célébrer chaque année le quatorzième et le quinzième jour du mois d'Adar."
,"22":"Car en ces jours les Juifs s'étaient enfin débarrassés de leurs ennemis; en ce mois les larmes avaient fait place à la joie et le deuil à la fête. Ils devaient en ces jours organiser des banquets et des réjouissances, s'envoyer des cadeaux les uns aux autres et faire des offrandes pour les pauvres."
,"23":"Les Juifs firent passer dans la coutume ce qu'ils avaient fait ces jours-là, comme Mardochée le leur avait ordonné."
,"24":"Aman, fils de Amdata, de la race d'Agag, l'ennemi des Juifs, avait fait le projet de les exterminer; il avait jeté le Pour, c'est-à-dire le sort, pour les détruire et les massacrer,"
,"25":"mais lorsque le roi l'apprit, il ordonna par un décret de faire retomber sur la tête du coupable son mauvais dessein contre les Juifs, et de le pendre avec ses fils à la potence."
,"26":"A cause du mot Pour, on appelle ces jours, les Pourim. C'est pourquoi à la suite de la lettre du roi, de ce qu'ils avaient vu et de ce qui leur était arrivé,"
,"27":"les Juifs établirent cette règle pour eux, pour leurs descendants et pour tous ceux qui se joindraient à eux: ils célébreraient chaque année à la date fixée, sans y manquer, ces deux jours, selon la règle prescrite."
,"28":"Chaque génération, chaque clan, chaque province, chaque ville, devait rappeler et célébrer ces deux jours, pour que les Juifs ne les oublient jamais, pour que leur souvenir ne soit jamais effacé."
,"29":"La reine Esther , fille d'Abihayil, et le Juif Mardochée, apportèrent l'appui de leur autorité à cette seconde lettre concernant les Pourim."
,"30":"On envoya des lettres à tous les Juifs des cent vingt sept provinces du royaume d'Assuérus, avec des paroles de paix et d'amitié,"
,"31":"pour confirmer ces jours des Pourim, pour en rappeler la date fixée par Mardochée, le Juif, et la reine Esther, les règles établies pour eux et pour leurs descendants, ainsi que tout ce qui concerne les jeûnes et les lamentations."
,"32":"Le décret d'Esther qui confirmait l'institution des Pourim fut noté dans un livre."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Le roi Assuérus établit un impôt sur le pays et sur les îles de la mer."
,"2":"Toutes les actions de son règne, son courage, les détails concernant les honneurs accordés par le roi à Mardochée, tout cela n'est-il pas écrit dans le Livre des Chroniques des rois de Médie et de Perse?"
,"3":"Mardochée, le Juif, était le second du royaume après Assuérus; il était respecté des Juifs, aimé de la foule de ses frères, car il recherchait le bien de son peuple et la paix de toute sa race."
,"4":"Mardochée dit: 'Tout cela est venu de Dieu."
,"5":"Lorsque je me rappelle le songe que j'ai eu à ce sujet, pas un détail qui ne se soit vérifié:"
,"6":"ni la petite source qui devient un fleuve, ni la lumière, ni le soleil, ni les eaux débordantes. Le fleuve, c'est Esther"
,"7":"que le roi a épousée et qu'il a faite reine;"
,"8":"les deux dragons, c'était Aman et moi, les nations sont celles qui se sont rassemblées pour effacer le nom des Juifs;"
,"9":"mon peuple, ce sont les enfants d'Israël qui ont crié vers Dieu et ont été délivrés. Le Seigneur a sauvé son peuple, le Seigneur nous a délivrés de tous ces malheurs, faisant de grands miracles et de grands prodiges, comme il n'y en a jamais eu chez les païens."
,"10":"Il est clair que Dieu a jeté deux sorts, un pour le peuple de Dieu et un pour toutes les nations païennes."
,"11":"A l'heure, au temps et au jour du jugement, ces deux sorts ont été présents devant Dieu, et présents au milieu des nations."
,"12":"Dieu s'est alors souvenu de son peuple et il a rendu justice aux siens."
,"13":"Pour cela, de génération en génération et pour toujours, le peuple d'Israël passera ces deux jours, le quatorzième et le quinzième du mois d'Adar, en assemblées joyeuses et en réjouissances devant Dieu. La quatrième année du règne de Ptolémée et de Cléopâtre, Dosithée se présenta comme prêtre et Lévite avec son fils Ptolémée; il apportait la présente lettre concernant les Pourim. Il affirma qu'elle était authentique et qu'elle avait été traduite par Lysimaque, fils de Ptolémée, un homme de la communauté de Jérusalem."
}`)
	CurrentBook.AddChapter(11, `{
"1":"En la deuxième année du règne du grand roi Assuérus,"
,"2":"Mardochée, fils de Yaïr, fils de Chiméï, fils de Kish, de la tribu de Benjamin, eut un songe."
,"3":"Ce Juif habitant à Suse, était un personnage bien connu à la cour du roi;"
,"4":"il faisait partie des déportés que Nabukodonozor, roi de Babylone, avait emmenés en captivité avec Jékonias, roi de Juda."
,"5":"Or voici le songe de Mardochée. Soudain des cris et des bruits épouvantables se font entendre, le tonnerre gronde, la terre tremble; tout est bouleversé."
,"6":"Alors deux énormes dragons s'avancent, prêts à s'affronter. Ils poussent un hurlement,"
,"7":"et aussitôt toutes les nations se préparent à faire la guerre au peuple des justes."
,"8":"C'est un jour de ténèbres et d'obscurité, jour d'épreuve et d'angoisse, de violence et de terreur, sur toute la terre!"
,"9":"Le peuple entier des justes en est épouvanté, ils redoutent le malheur et se préparent à mourir. Mais ils crient vers Dieu,"
,"10":"et leur cri fait surgir une petite source qui devient comme un grand fleuve aux eaux débordantes."
,"11":"Alors revient la lumière et le soleil se lève, les humbles triomphent et dévorent les orgueilleux."
,"12":"C'est à ce moment que Mardochée se réveilla. Il devait y avoir un projet de Dieu dans le songe qu'il avait eu, aussi ne cessa-t-il d'y penser. Jusqu'au soir il chercha par tous les moyens à en comprendre le sens."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Comme Mardochée se reposait dans la cour du palais avec deux eunuques, Bigtan et Térech, gardiens des portes,"
,"2":"il entendit leur conversation. Il chercha à comprendre leur entretien et il découvrit qu'ils se préparaient à assassiner le roi Assuérus; aussitôt il les dénonça auprès du roi."
,"3":"Le roi fit interroger les deux eunuques; ils avouèrent et on les mit à mort."
,"4":"Après quoi le roi fit noter dans ses Mémoires le récit de cet événement, et Mardochée en fit autant de son côté."
,"5":"Pour récompenser Mardochée, le roi lui confia une charge dans son palais et lui fit de nombreux cadeaux. Mais cette affaire des deux eunuques du roi valut à Mardochée l'hostilité d'Aman, fils de Hamdata, un descendant d'Agag, qui était très bien vu du roi."
}`)
	CurrentBook.AddChapter(13, `{
"1":"'Le grand roi Assuérus aux gouverneurs des cent vingt-sept provinces qui vont de l'Inde à l'Ethiopie, et aux chefs de région qui leur sont soumis!"
,"2":"Bien que je me trouve à la tête de peuples sans nombre, et que je sois maître de toute la terre, je me suis fait un devoir de ne pas me laisser enivrer par l'orgueil du pouvoir, de gouverner toujours avec sagesse et bienveillance, de garantir en tout temps à mes sujets une vie paisible. Je veux étendre jusqu'aux frontières de mon royaume la civilisation et la libre circulation, faisant en sorte que règne la paix que tous désirent."
,"3":"Je me suis donc informé auprès de mes conseillers sur les moyens d'atteindre ce but. C'est alors qu'un homme dont la sagesse est éminente, le dévouement sans faille, la fidélité à toute épreuve, et qui a obtenu la seconde place dans le royaume - je veux parler d'Aman -"
,"4":"cet homme nous a dénoncé un peuple plein d'arrière-pensées, mêlé à tous les peuples du monde. Ses lois le mettent en conflit avec toutes les nations; ces gens ignorent systématiquement les ordres des rois, au point de ruiner les efforts d'un gouvernement que nous dirigeons de façon irréprochable."
,"5":"Nous avons constaté que ce peuple unique en son genre s'oppose constamment au reste de l'humanité, qu'il entretient de mauvais sentiments envers notre gouvernement, qu'il est prêt à commettre les pires méfaits pour empêcher le royaume de vivre en paix."
,"6":"C'est pourquoi nous ordonnons ceci: Tous ceux qui sont désignés dans les lettres d'Aman, lequel est responsable du gouvernement et est pour nous comme un second père, seront radicalement exterminés avec leurs femmes et enfants le quatorzième jour du douzième mois (le mois d'Adar) de la présente année. Ils seront livrés à l'épée de leurs ennemis sans aucune pitié ni ménagement."
,"7":"Ainsi les opposants d'hier et d'aujourd'hui seront envoyés en un seul jour au séjour des morts, et les affaires publiques retrouveront la paix et la tranquillité pour le temps à venir.'"
,"8":"Mardochée pria le Seigneur, il lui rappela toutes ses merveilles et lui dit:"
,"9":"'Seigneur, Seigneur, Roi tout-puissant, tout est entre tes mains, et personne ne peut s'opposer à toi si tu as décidé de sauver Israël."
,"10":"C'est toi qui as fait le ciel, la terre et toutes les merveilles qui sont sous le ciel."
,"11":"Tu es le Seigneur de toutes choses, et personne ne peut te résister, puisque tu es le Seigneur."
,"12":"Tu connais tout, Seigneur, tu sais que ce n'est ni par insolence, ni par orgueil, ni par vanité, que j'ai refusé de me prosterner devant l'orgueilleux Aman:"
,"13":"je serais prêt à baiser la plante de ses pieds pour le salut d'Israël."
,"14":"Mais j'ai agi ainsi pour ne pas mettre la gloire d'un homme au-dessus de la gloire de Dieu. Je ne veux adorer personne en dehors de toi, mon Seigneur, et ce n'est pas par orgueil que je le ferai."
,"15":"Maintenant Seigneur, Dieu et Roi, Dieu d'Abraham, sauve ton peuple lorsqu'on a les yeux fixés sur nous pour nous détruire et faire disparaître le peuple qui t'appartient depuis le commencement."
,"16":"N'abandonne pas ton propre peuple que tu as racheté du pays d'Egypte."
,"17":"Ecoute ma prière, sois favorable à ton peuple, change notre deuil en joie. Fais-nous vivre, et nous chanterons des cantiques en l'honneur de ton Nom, Seigneur. Ne fais pas disparaître ceux qui chantent tes louanges.'"
,"18":"Et tout Israël criait de toutes ses forces, car il se voyait face à la mort."
}`)
	CurrentBook.AddChapter(14, `{
"1":"La reine Esther se réfugia auprès du Seigneur, saisie d'une angoisse mortelle."
,"2":"Elle avait enlevé ses vêtements de reine et revêtu des vêtements de misère et de deuil. Au lieu des riches parfums, elle s'était recouvert la tête de cendres et d'ordures."
,"3":"Elle humiliait sévèrement son corps: loin de le parer de bijoux, elle le couvrait de ses cheveux défaits et c'est ainsi qu'elle suppliait le Seigneur, le Dieu d'Israël:"
,"4":"'O mon Seigneur, notre roi, tu es l'Unique! Viens à mon secours, car je suis seule et n'ai pas d'autre secours que toi, et je dois risquer ma vie."
,"5":"Depuis ma naissance j'ai appris de mes pères que tu as choisi Israël parmi tous les peuples, et nos pères parmi tous leurs ancêtres. Tu as fait d'eux ton héritage et tu as accompli pour eux tes promesses."
,"6":"Mais alors nous avons péché contre toi et tu nous as livrés entre les mains de nos ennemis"
,"7":"parce que nous avions servi leurs dieux. Tu es juste, Seigneur!"
,"8":"Mais il ne leur suffit plus de voir notre triste esclavage, ils ont fait appel à leurs idoles pour ruiner le décret sorti de ta bouche,"
,"9":"pour faire disparaître ton héritage, pour fermer la bouche de ceux qui te chantent, éteindre la gloire de ton autel et de ton Temple."
,"10":"Voici que les païens s'apprêtent à chanter la victoire de leurs idoles, à s'extasier sans fin devant un roi qui n'est qu'un homme."
,"11":"N'abandonne pas ta royauté, Seigneur, à ceux qui ne sont rien. Que nul ne puisse rire de notre ruine! Retourne contre eux leurs plans et fais un exemple de celui qui les dresse contre nous."
,"12":"Souviens-toi, Seigneur, montre-toi au jour de notre épreuve, et à moi, Roi des dieux et Maître de toute autorité, donne-moi le courage."
,"13":"Lorsque je serai devant le lion, mets sur mes lèvres les paroles qui le séduiront, retourne son coeur pour qu'il déteste notre ennemi, pour qu'il le fasse périr avec tous ceux qui lui ressemblent."
,"14":"Quant à nous, que ta main nous sauve. Viens à mon secours, car je suis seule et je n'ai personne en dehors de toi, Seigneur."
,"15":"Tu connais toute chose, tu sais que je déteste la gloire des impies et que j'ai en horreur la couche des païens et de tout étranger,"
,"16":"mais tu sais que j'y suis obligée. La couronne que je dois porter aux jours de fête, comme un signe de ma grandeur, me dégoûte autant que le linge souillé par les règles d'une femme; c'est pourquoi, quand je suis chez moi, je ne la porte pas."
,"17":"Ta servante n'a pas mangé à la table d'Aman, elle n'aime pas les banquets des rois, elle ne boit pas de leur vin."
,"18":"Ta servante n'a pas connu d'autre joie que toi, Seigneur, Dieu d'Abraham, depuis le jour de son couronnement jusqu'à aujourd'hui."
,"19":"O Dieu, toi qui l'emportes sur tous, écoute la voix des désespérés, délivre-nous de la main des méchants, et libère-moi de ma peur!'"
}`)
	CurrentBook.AddChapter(15, `{
"4":"Le troisième jour, quand elle eut fini sa prière, elle quitta ses vêtements de pénitence pour mettre sa tenue d'apparat."
,"5":"Eclatante de beauté, elle invoqua le Dieu qui voit tout et qui sauve, puis elle prit avec elle deux servantes:"
,"6":"elle s'appuyait sur l'une d'entre elles, tandis que l'autre l'accompagnait, soulevant sa traîne."
,"8":"Elle était au sommet de sa beauté, elle rougissait et son visage rayonnait la confiance; pourtant la crainte faisait frémir son coeur."
,"9":"Après avoir franchi toutes les portes, elle se trouva devant le roi. Il était assis sur son trône royal, revêtu de tous les ornements des fêtes solennelles: l'éclat de l'or et des pierres précieuses le rendait terrible à voir."
,"10":"Tout brillant de gloire il leva son visage et lança un regard furieux. La reine s'évanouit, elle changea de couleur et pencha sa tête sur la servante qui l'accompagnait."
,"11":"Alors Dieu changea le coeur du roi et le disposa à la douceur. Tout inquiet, le roi s'élança de son trône et la prit dans ses bras jusqu'à ce qu'elle revienne à elle. Il la réconfortait par des paroles pleines de tendresse:"
,"12":"' Qu'as-tu Esther? Je suis ton frère!"
,"13":"Rassure-toi, tu ne mourras pas. Notre décret vise les gens du commun, approche-toi.'"
,"14":"Alors il leva son sceptre d'or et le posa sur le cou d'Esther , il l'embrassa et lui dit: 'Parle-moi.' - 'Seigneur, répondit-elle, je t'ai vu semblable à un ange de Dieu."
,"15":"Ta gloire inspire la crainte et mon coeur s'est troublé. Car tu es admirable, seigneur, et ton visage est plein de charme.'"
,"16":"Tout en parlant, elle s'évanouit de nouveau; le roi était très inquiet et son entourage cherchait à la ranimer."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Voici le texte de cette lettre: 'Le grand roi Assuérus salue les gouverneurs des cent vingt-sept provinces qui s'étendent de l'Inde à l'Ethiopie, les fonctionnaires des provinces et tous ses fidèles sujets!"
,"2":"Beaucoup de gens se gonflent d'orgueil pour avoir été trop souvent comblés d'honneurs par l'extrême bonté de leurs bienfaiteurs; non contents de nuire à nos sujets, ils en viennent, avec une insolence effrénée, à comploter contre leurs propres bienfaiteurs."
,"4":"Avec eux la reconnaissance disparaît du coeur humain; aveuglés par la folie propre à ceux qui n'ont aucun sens du bien, ils pensent échapper à la justice du Dieu qui observe toute chose, laquelle combat le mal."
,"5":"C'est ainsi que trop souvent, ceux qui avaient été placés au pouvoir ont dû porter le poids du sang innocent et se sont vus mêlés à des affaires lamentables, pour avoir confié à des amis malhonnêtes l'administration des affaires."
,"6":"Et ces amis avaient abusé par des discours perfides la générosité confiante des souverains."
,"7":"Il n'est pas nécessaire de retourner à l'histoire ancienne, il suffit de regarder ce qui se passe sous nos yeux, pour voir les crimes commis par la méchanceté de gens indignes du pouvoir."
,"8":"Désormais, nous serons très attentifs à procurer à tous les habitants de notre royaume la tranquillité et la paix."
,"9":"Nous ferons les changements nécessaires et nous jugerons avec indulgence et bienveillance tout ce qui remontera jusqu'à nous."
,"10":"Voici qu'Aman, fils d'Amdata, un Macédonien, un homme très étranger au sang des Perses, et plus étranger encore à notre bonté, avait reçu l'hospitalité au milieu de nous."
,"11":"Il avait trouvé chez nous l'accueil que nous avons pour chaque peuple, au point que nous l'avions appelé notre père. Il était devenu le second personnage du royaume et tous se prosternaient devant lui."
,"12":"Mais il a été incapable de freiner son orgueil et il a tout fait pour nous enlever le pouvoir et la vie."
,"13":"Par toutes sortes de mensonges et de tromperies, il nous a réclamé la mort de Mardochée, celui qui nous avait sauvé la vie et qui n'avait cessé de nous faire du bien, - la mort aussi d'Esther , la compagne irréprochable de notre royauté, et la mort de leur peuple tout entier."
,"14":"Il comptait par ces mesures nous priver de tout appui, et remettre aux Macédoniens l'empire des Perses."
,"15":"Alors que ce triple scélérat voulait exterminer les Juifs, pour notre part nous avons la preuve que ce ne sont pas des malfaiteurs, mais qu'ils vivent selon des lois très justes."
,"16":"Ils sont les fils du Dieu vivant, très haut et très grand,"
,"17":"lequel fait prospérer le royaume pour nous comme pour nos ancêtres."
,"18":"Vous ferez donc bien de ne pas tenir compte des lettres envoyées par Aman, fils d'Amdata, car leur auteur a été pendu avec toute sa famille aux portes de Suse. Le Dieu tout-puissant lui a infligé sans tarder le châtiment qu'il méritait."
,"19":"Vous publierez ouvertement en tous lieux la copie de cette lettre, après quoi vous laisserez les Juifs pratiquer leurs coutumes."
,"20":"Au treizième jour du douzième mois, le mois d'Adar, vous les aiderez à mater ceux qui s'en sont pris à eux au temps de l'oppression."
,"21":"Dieu, en effet, Maître de tout, a fait de ce jour prévu pour l'extermination de la race élue, un jour de fête pour eux."
,"22":"C'est pourquoi vous aussi, parmi vos fêtes officielles, célébrez ce jour exceptionnel par des réjouissances de toutes sortes, demandant que vienne le salut, dès maintenant et dans l'avenir, pour nous et pour tous ceux qui aiment les Perses."
,"23":"Mais pour ceux qui nous cherchent du mal, ce jour sera le rappel de leur perte."
,"24":"La ville ou la province qui ne suivra pas ces instructions, sera brutalement dévastée par la lance et par le feu. Elle restera inhabitable pour les humains, mieux encore, les bêtes sauvages et les oiseaux la fuiront.'"
}`)

}
func FR_LBDCC_LoadVHIDChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Josué était mort. Les Israélites consultèrent Yahvé: 'Qui de nous, dirent-ils, montera le premier à l'attaque contre les Cananéens?'"
,"2":"Yahvé répondit: 'C'est Juda qui montera, j'ai livré le pays entre ses mains.'"
,"3":"Ceux de Juda dirent à leurs frères de Siméon: 'Venez nous aider dans notre héritage contre les Cananéens, et à notre tour nous irons vous aider dans votre héritage.' Et Ceux de Siméon vinrent les aider."
,"4":"Juda monta donc et Yahvé livra entre leurs mains les Cananéens et les Périsites à Bézek: ils écrasèrent dix mille hommes."
,"5":"A Bézek ils rencontrèrent Adoni-Bézek; ils engagèrent le combat et écrasèrent Cananéens et Périsites."
,"6":"Adoni-Bézek prit la fuite et ils le poursuivirent. Ils le prirent et lui coupèrent les pouces des mains et des pieds."
,"7":"Adoni-Bézek dit alors: 'Soixante-dix rois, avec les pouces des mains et des pieds coupés, ramassaient les miettes sous ma table, Dieu me rend aujourd'hui ce que je leur ai fait.' On l'emmena à Jérusalem et il y mourut."
,"8":"Les fils de Juda combattirent contre Jérusalem et s'en emparèrent, ils la passèrent au fil de l'épée et incendièrent la ville."
,"9":"Après cela, les fils de Juda descendirent combattre les Cananéens qui habitaient la Montagne, le Négueb et le Bas-Pays."
,"10":"Juda marcha contre les Cananéens qui habitaient Hébron (Hébron s'appelait autrefois Kiryat-Arba); ils battirent Chéchaï, Ahiman et Talmaï."
,"11":"Ils partirent de là combattre contre les habitants de Débir (Débir s'appelait autrefois Kiryat-Séfer)."
,"12":"Caleb dit alors: 'Je donnerai ma fille Aksa en mariage à celui qui attaquera Kiryat-Séfer et s'en emparera.'"
,"13":"Otniel, fils de Kénaz, frère cadet de Caleb, s'en empara, et c'est à lui qu'il donna sa fille Aksa."
,"14":"Dès qu'elle arriva, il la poussa à demander à son père un champ. Comme elle descendait de son âne, Caleb lui dit: 'Que veux-tu?'"
,"15":"Elle répondit: 'Fais-moi plaisir. Puisque tu m'as envoyée dans le pays du Négueb, donne-moi au moins des sources d'eau.' Caleb lui donna donc les Fontaines-d'en-Haut et les Fontaines-d'en-Bas."
,"16":"Les fils de Hobab le Kénite, beau-frère de Moïse, montèrent avec les fils de Juda, de la Ville des Palmiers jusqu'au désert de Juda, au sud d'Arad. Là ils s'établirent au milieu du peuple."
,"17":"Juda partit alors avec son frère Siméon. Ils écrasèrent les Cananéens qui habitaient Séfat et lui jetèrent l'anathème, c'est pourquoi on appela la ville Horma."
,"18":"Juda ne s'empara pas de Gaza et de son territoire, ni d'Ashkélon et de son territoire, ni d'Ekron et de son territoire."
,"19":"Juda se rendit maître de la montagne avec l'aide de Yahvé, mais il ne put chasser les habitants de la plaine, car ils avaient des chars de fer."
,"20":"Comme Moïse l'avait ordonné, on donna Hébron à Caleb; il en chassa les trois fils d'Anak."
,"21":"Quant aux Jébusites qui habitaient Jérusalem, les fils de Benjamin ne les dépossédèrent pas, et jusqu'à ce jour les Jébusites habitent Jérusalem avec les fils de Benjamin."
,"22":"Les gens de la maison de Joseph firent une expédition contre Béthel, et Yahvé était avec eux."
,"23":"Ils montèrent leur camp devant Béthel (la ville s'appelait autrefois Louz)."
,"24":"Les guetteurs virent un homme qui sortait de la ville et ils lui dirent: 'Montre-nous par où on peut entrer dans la ville, et nous te ferons grâce.'"
,"25":"Il leur montra donc comment entrer dans la ville. Ils la passèrent au fil de l'épée, mais ils laissèrent aller cet homme avec toute sa famille."
,"26":"L'homme alla au pays des Hittites et il y construisit une ville qu'il appela Louz (c'est le nom qu'elle porte encore aujourd'hui)."
,"27":"Manassé ne put s'emparer de la ville de Beth-Chéan, ni de ses dépendances; de même à Tanak, à Dor, à Yibléam et à Méguiddo: les Cananéens s'obstinèrent à rester dans ce pays."
,"28":"Mais lorsque Israël devint plus fort, il réduisit les Cananéens à la corvée, sans les éliminer pour autant."
,"29":"Ephraïm non plus ne déposséda pas les Cananéens qui habitaient Guézer, les Cananéens continuèrent donc d'y habiter avec lui."
,"30":"Zabulon ne déposséda pas les habitants de Kitron ni ceux de Nahalol; les Cananéens demeurèrent ainsi au milieu de Zabulon mais ils furent réduits à la corvée."
,"31":"Asher ne déposséda pas les habitants d'Akko ni ceux de Sidon, de Mahaleb, d'Akzib, d'Helbah, d'Afek et de Réhob."
,"32":"Les gens d'Asher demeurèrent donc au milieu des Cananéens qui habitaient le pays, car ils ne les avaient pas dépossédés."
,"33":"Nephtali ne déposséda pas les habitants de Beth-Chéan ni ceux de Beth-Anat; il habita donc au milieu des Cananéens qui habitaient le pays, mais il imposa des corvées aux habitants de Beth-Chémesh et de Beth-Anat."
,"34":"Les Amorites refoulèrent dans la montagne les fils de Dan, ils les empêchèrent de descendre dans la plaine."
,"35":"Les Amorites restèrent à Har-Hérès, à Ayyalon et Chaalbim, mais lorsque la maison de Joseph devint plus forte, eux aussi furent réduits à la corvée."
,"36":"(Le territoire des Edomites s'étend de la Montée des Scorpions jusqu'à la Roche, et continue ensuite en montant.)"
}`)
	CurrentBook.AddChapter(2, `{
"1":"L'ange de Yahvé monta de Guilgal vers Boquim: 'Je vous ai fait monter d'Egypte, dit-il, et je vous ai conduits dans ce pays que j'ai promis par serment à vos pères. J'avais dit: Je ne romprai jamais mon Alliance avec vous,"
,"2":"et de votre côté vous ne ferez pas d'alliance avec les habitants de ce pays: vous renverserez leurs autels. Mais vous ne m'avez pas écouté. Qu'avez-vous fait là?"
,"3":"Voici donc ce que j'ai décidé: Je ne les chasserai pas de devant vous! Ils seront sans cesse à vos côtés et leurs dieux deviendront un piège pour vous.'"
,"4":"Lorsque l'ange de Yahvé parla ainsi à tout Israël, le peuple poussa des cris et se mit à pleurer."
,"5":"C'est pourquoi ils appelèrent cet endroit Bokim et ils y offrirent des sacrifices à Yahvé."
,"6":"Quand Josué avait congédié le peuple, les Israélites étaient retournés chacun à sa part d'héritage, cherchant à occuper le pays."
,"7":"Le peuple servit Yahvé durant toute la vie de Josué et durant toute la vie des anciens qui lui succédèrent. Ils avaient vu en effet les prodiges accomplis par Yahvé en faveur d'Israël."
,"8":"Josué, fils de Noun, serviteur de Yahvé, mourut alors: il avait cent dix ans."
,"9":"On l'enterra dans le territoire qu'il avait reçu en héritage à Timnat-Héres, dans la montagne d'Ephraïm, au nord du mont Gaach."
,"10":"Lorsque cette génération fut à son tour réunie à ses pères, une autre génération lui succéda qui ne connaissait ni Yahvé, ni ce qu'il avait fait pour Israël."
,"11":"Les Israélites firent donc ce qui est mal au regard de Yahvé, ils servirent les Baals."
,"12":"Ils abandonnèrent Yahvé, le Dieu de leurs pères qui les avait fait sortir du pays d'Egypte, et ils suivirent d'autres dieux. Ils se prosternèrent devant les dieux des peuples qui les entouraient, et ils attirèrent sur eux la colère de Yahvé."
,"13":"Dès qu'ils abandonnèrent Yahvé pour servir le Baal et les Astartés,"
,"14":"la colère de Yahvé s'enflamma contre Israël. Il les livra aux mains de pillards qui les dépouillèrent, il les vendit à leurs ennemis tout à l'entour: maintenant ils ne résistaient plus à leurs ennemis."
,"15":"Chaque fois qu'ils partaient en guerre, la Main de Yahvé se dressait contre eux pour leur malheur comme Yahvé le leur avait dit, comme Yahvé le leur avait juré: ils étaient dans une très grande détresse."
,"16":"Alors Yahvé leur donna des juges qui les sauvèrent de la main de ceux qui les dépouillaient."
,"17":"Mais ils n'écoutèrent pas davantage leurs juges et ils se prostituèrent à la suite d'autres dieux; ils se prosternèrent devant eux. Ils se détournèrent bien vite de la voie sur laquelle leurs pères avaient marché quand ils écoutaient les commandements de Yahvé. Eux faisaient tout le contraire."
,"18":"Lorsque Yahvé leur envoyait des juges, Yahvé était avec le juge et, durant toute la vie du juge, il les délivrait de la main de leurs ennemis. En effet, Yahvé avait pitié d'eux quand il entendait leurs cris sous l'oppression et la persécution."
,"19":"Mais dès que le juge était mort, ils recommençaient à faire le mal, pire que leurs pères. Ils se mettaient à la traîne d'autres dieux, ils les servaient et se prosternaient devant eux. Ils ne voulaient pas renoncer à leurs mauvaises actions; ils s'entêtaient dans cette voie."
,"20":"La colère de Yahvé s'enflamma donc contre Israël; il déclara: 'Puisque cette nation a violé mon Alliance que j'avais donnée à leurs pères et qu'ils ne m'écoutent pas,"
,"21":"moi non plus, je ne chasserai plus devant eux la moindre des peuplades que Josué a laissées à sa mort."
,"22":"Elles me serviront pour mettre Israël à l'épreuve: peut-être voudront-ils suivre les chemins de Yahvé comme leurs pères ont fait.'"
,"23":"Yahvé laissa donc tranquilles ces nations qu'il n'avait pas livrées aux mains de Josué et il ne se pressa pas de les chasser."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Voici les nations que Yahvé laissa tranquilles pour mettre à l'épreuve Israël, c'est-à-dire les Israélites qui n'avaient pas connu les guerres de Canaan."
,"2":"Il voulait que la jeunesse d'Israël, ceux qui n'avaient pas connu la guerre, apprenne à combattre."
,"3":"Restèrent donc les cinq princes des Philistins, tous les Cananéens et les Sidoniens, et aussi les Hivvites qui habitaient la montagne du Liban, depuis la montagne de Baal-Hermon jusqu'à l'Entrée-de-Hamat."
,"4":"Yahvé voulut donc mettre Israël à l'épreuve et voir s'il obéirait à ses commandements, ceux que Moïse avait donnés à leurs pères."
,"5":"Les Israélites habitèrent au milieu des Cananéens, des Hittites, des Amorites, des Périsites, des Hivvites et des Jébusites."
,"6":"Ils épousèrent leurs filles, ils donnèrent pour leurs fils leurs propres filles, et ils servirent leurs dieux."
,"7":"Les Israélites firent donc ce qui est mal aux yeux de Yahvé. Ils oublièrent Yahvé leur Dieu et servirent les Baals et les Ashérahs."
,"8":"Alors la colère de Yahvé s'enflamma contre Israël. Il les livra aux mains de Kouchan-Richéatayim, roi d'Edom, et les Israélites furent soumis à Kouchan-Richéatayim pendant huit ans."
,"9":"Les Israélites crièrent vers Yahvé, et Yahvé leur fit surgir un sauveur qui les délivra: c'était Otniel, fils de Kénaz, frère cadet de Caleb."
,"10":"L'esprit de Yahvé reposa sur lui et il agit comme juge en Israël. Il partit en guerre et Yahvé livra entre ses mains Kouchan-Richéatayim, roi d'Edom: il écrasa Kouchan-Richéatayim."
,"11":"Le pays fut en paix pendant quarante ans, puis Otniel, fils de Kénaz mourut."
,"12":"Une fois de plus les Israélites firent ce qui est mal aux yeux de Yahvé, et lui rendit Eglon, roi de Moab, beaucoup plus fort qu'Israël, simplement parce qu'ils faisaient ce qui déplaît à Yahvé."
,"13":"Les Moabites s'allièrent avec les Ammonites et les Amalécites pour combattre Israël, et ils s'emparèrent de la Ville des Palmiers."
,"14":"Pendant dix-huit ans les Israélites furent soumis à Eglon, roi de Moab."
,"15":"Les Israélites crièrent alors vers Yahvé, et Yahvé leur fit surgir un sauveur, Ehoud, fils de Guéra, un homme de Benjamin qui était gaucher. Les Israélites le chargèrent de porter le tribut à Eglon, roi de Moab."
,"16":"Ehoud se fit un poignard à deux tranchants, à lame courte, qu'il portait sous son habit contre sa cuisse droite."
,"17":"Puis il alla offrir le tribut à Eglon, roi de Moab (or Eglon était un homme très gros)."
,"18":"De retour, après l'offrande du tribut, Ehoud renvoya les gens venus avec lui pour l'apporter,"
,"19":"comme ils étaient déjà aux Idoles de Guilgal. Lui revint sur ses pas et dit: 'O roi! J'ai pour toi un message secret.' Le roi répondit: 'Silence!' Et tous ceux qui se tenaient autour du roi se retirèrent. "
,"20":"Alors Ehoud s'approcha de lui, tandis qu'il était assis dans la chambre haute, bien au frais dans ses appartements privés. Ehoud dit: 'C'est un message de Dieu que j'ai pour toi.' Alors le roi se leva de son siège."
,"21":"Ehoud étendit sa main gauche, saisit le poignard de dessus sa cuisse droite et le lui enfonça dans le ventre."
,"22":"La poignée entra à la suite de la lame et la graisse se referma par-dessus la lame, car il ne retira pas le poignard de son ventre, tandis que les excréments sortaient."
,"23":"Ehoud alors s'échappa par derrière, ferma sur lui les portes de la chambre haute et mit le verrou."
,"24":"Lui sorti, les serviteurs arrivèrent, et voyant les portes de la chambre haute verrouillées, ils se dirent: 'Sans doute fait-il ses besoins dans ses appartements privés.'"
,"25":"Ils attendirent tellement qu'ils en avaient honte, et les portes de la chambre haute ne s'ouvraient toujours pas. Alors ils prirent la clé et ouvrirent: leur maître gisait à terre, mort!"
,"26":"Ehoud s'était mis en sûreté pendant qu'ils attendaient. Il repassa par les Idoles et se sauva à Ha-Seïra."
,"27":"Dès qu'il fut arrivé, il sonna du cor dans la montagne d'Ephraïm, et les Israélites descendirent de la montagne à sa suite."
,"28":"Il leur dit: 'Suivez-moi, car Yahvé a livré vos ennemis, les Moabites, entre nos mains.' Tous descendirent à sa suite, coupèrent les gués du Jourdain en direction de Moab, et ne laissèrent aucun homme s'échapper."
,"29":"En ce temps-là, ils abattirent dix mille hommes de Moab, tous robustes et entraînés: pas un seul n'échappa."
,"30":"En ce jour-là, Moab fut soumis à Israël, et le pays fut en paix durant quatre-vingts ans."
,"31":"Après lui se leva Chamgar, fils d'Anat. Il abattit six cents hommes de chez les Philistins avec un aiguillon à boeufs; lui aussi fut un libérateur d'Israël."
}`)
	CurrentBook.AddChapter(4, `{
"1":"De nouveau, après la mort d'Ehoud, les Israélites firent ce qui est mal aux yeux de Yahvé,"
,"2":"et Yahvé les livra entre les mains de Yabin, roi de Canaan, qui régnait à Hasor. Siséra était le chef de son armée et il habitait à Harochet-Ha-Goyim."
,"3":"Les Israélites crièrent vers Yahvé, car Yabin avait neuf cents chars de fer et il opprimait durement les Israélites depuis vingt ans."
,"4":"En ce temps-là la prophétesse Débora, femme de Lapidot, jugeait Israël."
,"5":"Elle siégeait sous le Palmier-de-Débora, entre Rama et Béthel, dans la montagne d'Ephraïm, et les Israélites montaient auprès d'elle pour obtenir justice."
,"6":"Elle envoya chercher Barac, fils d'Abinoam, de Qédesh en Nephtali. Elle lui fit dire: 'Ceci est un ordre de Yahvé, le Dieu d'Israël: rends-toi au Mont Thabor et recrute dix mille hommes parmi les fils de Nephtali et les fils de Zabulon."
,"7":"J'attirerai vers toi au torrent du Quichon, Siséra, chef de l'armée de Yabin, avec ses chars et tous ses hommes, et je le livrerai entre tes mains.'"
,"8":"Barac lui répondit: 'Si tu viens avec moi, j'irai, mais si tu ne viens pas avec moi, je n'irai pas.'"
,"9":"Elle lui dit: 'J'irai donc avec toi, mais puisque tu prends ce chemin, la gloire de cette expédition ne sera pas pour toi: Yahvé livrera Siséra aux mains d'une femme.' Débora se leva donc, et Barac partit avec elle pour Qé-desh."
,"10":"A Qédesh Barac rassembla Zabulon et Nephtali, et dix mille hommes le suivirent. Débora était avec lui."
,"11":"Héber le Kénite s'était séparé de la tribu de Kayin et du clan des fils de Hobab, beau-frère de Moïse. Il avait planté sa tente près du Chêne-de-Saananim, à côté de Qédesh."
,"12":"On annonça à Siséra que Barac, fils d'Abinoam, s'était rendu au mont Thabor."
,"13":"Siséra rassembla donc tous ses chars de fer au nombre de neuf cents, ainsi que ses troupes, et ils vinrent de Harochet-Ha-Goyim jusqu'au torrent du Quichon."
,"14":"Débora dit alors à Barac: 'C'est le moment, aujourd'hui même Yahvé livrera Siséra entre tes mains. Yahvé ne marche-t-il pas devant toi?',Barac descendit du mont Thabor suivi de ses dix mille hommes, "
,"15":"et Yahvé mit en déroute devant Barac, Siséra, tous ses chars et toute son armée; Siséra lui-même descendit de son char et s'enfuit à pied."
,"16":"Barac se lança à la poursuite des chars et de l'armée, jusqu'à Harochet-Ha-Goyim, et toute l'armée de Siséra tomba sous le tranchant de l'épée, pas un n'échappa."
,"17":"Siséra, lui, s'était enfui à pied vers la tente de Yaël, femme de Héber, le Kénite, car la paix régnait entre Yabin, roi de Hasor, et Héber le Kénite."
,"18":"Yaël sortit donc au-devant de Siséra et lui dit: 'Viens par ici, mon seigneur! Viens par ici, n'aie pas peur.' Il vint de son côté, entra sous la tente et elle le recouvrit d'une couverture."
,"19":"Il lui dit: 'Donne-moi à boire un peu d'eau, car j'ai soif.' Elle prit une outre de lait et lui donna à boire, puis elle le couvrit de nouveau."
,"20":"Il lui dit: 'Reste à l'entrée de ta tente, si quelqu'un arrive et te demande s'il y a quelqu'un ici, tu répondras qu'il n'y a personne.'"
,"21":"Mais Yaël, femme de Héber, prit l'un des pieux de la tente et saisit le marteau, elle s'approcha doucement derrière lui et lui planta le pieu dans la tempe, si fort qu'il se ficha en terre. Il dormait profondément car il était épuisé de fatigue, et c'est ainsi qu'il mourut."
,"22":"Comme Barac arrivait, à la poursuite de Siséra, Yaël sortit au-devant de lui et lui dit: 'Entre, je te montrerai l'homme que tu cherches.' Il entra et vit Siséra étendu mort, le pieu dans la tempe."
,"23":"En ce jour-là Dieu humilia Yabin, roi de Canaan, devant les Israélites."
,"24":"La main des Israélites se fit de plus en plus pesante sur Yabin, roi de Canaan, jusqu'au jour où ils s'en débarrassèrent."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Ce jour-là, Débora et Barac, fils d'Abinoam, entonnèrent ce cantique."
,"2":"En Israël ils ont dénoué leur chevelure: un peuple de volontaires s'est levé: bénissez Yahvé!"
,"3":"Que les rois écoutent, que les souverains prêtent l'oreille, car je vais chanter Yahvé! Je vais chanter un psaume pour Yahvé, un psaume pour le Dieu d'Israël!"
,"4":"O Yahvé! Quand tu sortis de Séïr, traversant les campagnes d'Edom, la terre trembla, les cieux fondirent, les nuées se changèrent en eaux."
,"5":"Les montagnes furent ébranlées devant Yahvé, devant Yahvé le Dieu d'Israël."
,"6":"Aux jours de Chamgar, fils d'Anat, aux jours de Yaël, les caravanes ne partaient plus, les voyageurs empruntaient des chemins détournés."
,"7":"Les villages étaient désertés, ils étaient déserts en Israël jusqu'au jour où moi, Débora, je me suis levée: j'ai été comme une mère pour Israël."
,"8":"On suivait des dieux nouveaux, c'est pourquoi la guerre était aux portes, mais pour les quarante mille hommes d'Israël, il n'y avait ni bouclier ni lance."
,"9":"Mon coeur se tourne vers les chefs d'Israël, vers les volontaires du peuple: bénissez Yahvé!"
,"10":"Vous qui montez de blanches ânesses, assis sur vos tapis, vous qui allez par les chemins, chantez!"
,"11":"Près des abreuvoirs le berger chante les bienfaits de Yahvé, les bienfaits de sa bonté envers Israël; mais le peuple de Yahvé est descendu vers les portes de la ville."
,"12":"Réveille-toi, réveille-toi, Débora! Réveille-toi et réveille ton peuple! Lève-toi, Barac, et capture ceux qui te capturaient, fils d'Abinoam!"
,"13":"Que nos survivants écrasent les puissants, que Yahvé avec moi écrase ceux qui se croient forts."
,"14":"Les chefs d'Ephraïm sont descendus dans la vallée. Benjamin est à ta suite parmi tes troupes. Des chefs sont descendus de Makir, et de Zabulon ceux qui portent le sceptre."
,"15":"Les chefs d'Issacar sont avec Débora, Issacar est aux côtés de Barac, et dans la plaine il marche sur ses traces. Mais près des ruisseaux de Ruben il n'y a que des palabres. "
,"16":"Pourquoi es-tu resté dans tes pâturages, à écouter la flûte de tes bergers? Près des ruisseaux de Ruben, on s'est contenté de palabres."
,"17":"Galaad était assis sur l'autre rive du Jourdain, Dan est resté sur ses vaisseaux, Asher n'a pas bougé du bord de mer, installé dans ses ports."
,"18":"Mais Zabulon est un peuple qui risque sa vie, comme Nephtali, sur les champs de bataille."
,"19":"Les rois sont venus, ils ont combattu. A Tanak, près des eaux de Méguiddo, les rois de Canaan ont combattu, mais ils n'ont pas ramassé le butin."
,"20":"Du haut des cieux les étoiles ont combattu, de leurs chemins elles ont combattu Siséra."
,"21":"Le torrent du Quichon les a emportés, le torrent des temps anciens, le torrent du Quichon. O mon âme, avance la tête haute!"
,"22":"Quel martellement de sabots de chevaux, des chevaux lancés à plein galop!"
,"23":"Maudissez Méroz, a dit l'ange de Yahvé, maudissez, maudissez ses habitants, car ils n'étaient pas là pour aider Yahvé, pour aider Yahvé avec les courageux."
,"24":"Bénie soit Yaël, la femme de Héber le Kénite, bénie soit-elle entre les femmes! Entre les femmes qui vivent sous la tente, bénie soit-elle."
,"25":"Il demande de l'eau: elle lui donne du lait, elle offre le lait crèmeux dans la meilleure coupe."
,"26":"D'une main elle a saisi le pieu, et de sa droite, le marteau de l'ouvrier. Elle frappe Siséra et lui fracasse la tête, elle fracasse et transperce sa tempe."
,"27":"Il s'écroule à ses pieds, il tombe, il est là étendu. Il est tombé à ses pieds, là où il s'est écroulé il est tombé mort."
,"28":"La mère de Siséra s'est penchée par la fenêtre, elle guette à travers le treillage: 'Pourquoi, dit-elle, son char tarde-t-il à rentrer? Que ses chariots sont lents au retour!'"
,"29":"La plus vive de ses dames lui a répondu, elle même se le répète:"
,"30":"'Bien sûr ils partagent le butin: une captive, deux captives pour chaque guerrier. Les étoffes de couleur seront pour Siséra, les broderies seront pour son cou.'"
,"31":"O Yahvé, que tous tes ennemis périssent ainsi! mais ceux qui t'aiment verront grandir leur force, comme le soleil. Le pays fut alors tranquille pendant quarante ans."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Les Israélites firent ce qui est mal aux yeux de Yahvé et Yahvé les livra pour sept ans entre les mains de Madian."
,"2":"L'oppression de Madian fut dure pour Israël, et c'est à cause de Madian que les Israélites aménagèrent les fentes des montagnes, les grottes et les repaires."
,"3":"Lorsque Israël avait semé, Madian faisait un raid avec Amalec et les fils de l'Orient."
,"4":"Ils s'installaient sur sa terre et dévastaient tous les champs jusqu'aux environs de Gaza; il ne restait rien à manger en Israël, ni moutons, ni boeufs, ni ânes."
,"5":"Ils arrivaient avec leurs troupeaux et leurs tentes, aussi nombreux que des sauterelles; on ne pouvait les compter, eux et leurs chameaux, quand ils arrivaient dans le pays pour tout ravager."
,"6":"Israël était dans la misère à cause de Madian, et les Israélites crièrent vers Yahvé."
,"7":"Voici ce qui arriva quand les Israélites criaient vers Yahvé à cause de Madian."
,"8":"Yahvé envoya un prophète qui leur fit entendre cette parole de Yahvé, le Dieu d'Israël: 'C'est moi qui vous ai fait monter d'Egypte, qui vous ai fait sortir de la maison de l'esclavage."
,"9":"Comme je vous avais délivrés de la main des Egyptiens, je vous ai délivrés de tous ceux qui vous opprimaient. Je les ai chassés devant vous et je vous ai donné leur pays."
,"10":"Alors je vous ai dit: Je suis Yahvé votre Dieu, ne tenez aucun compte des dieux des Amorites dont vous habitez le pays. Mais vous n'avez pas écouté ma voix.'"
,"11":"L'Ange de Yahvé vint s'asseoir sous le térébinthe qui est à Ofra, il appartenait à Yoach du clan d'Abiézer. Or Gédéon, son fils, était en train de battre le blé dans le pressoir pour le cacher aux Madianites."
,"12":"L'Ange de Yahvé lui apparut et lui dit: 'Yahvé est avec toi, courageux guerrier!'"
,"13":"Gédéon répondit: 'Je t'en prie mon seigneur, si Yahvé est avec nous, pourquoi tout cela nous arrive-t-il? Où sont donc tous ces prodiges que nous ont racontés nos pères, quand ils nous disaient: Yahvé nous a fait monter d'Egypte? Pour l'instant Yahvé nous a laissé tomber et nous a livrés entre les mains de Madian.'"
,"14":"Alors Yahvé se tourna vers lui et lui dit: 'Va! tu es bien assez fort pour délivrer Israël de la main de Madian: c'est moi qui t'envoie!'"
,"15":"Mais il répondit: 'Je t'en prie, Mon Seigneur, comment sauverai-je Israël? Mon clan est le plus petit de la tribu de Manassé, et moi, je suis le plus petit dans la maison de mon père.'"
,"16":"Yahvé lui dit: 'Je serai avec toi et tu battras Madian comme un seul homme.'"
,"17":"Il répondit: 'Si vraiment j'ai trouvé grâce à tes yeux, fais-moi voir un signe et je saurai que c'est bien toi qui me parles."
,"18":"Ne t'éloigne donc pas d'ici jusqu'à ce que je revienne avec une offrande que je déposerai devant toi.' Yahvé répondit: 'Je resterai jusqu'à ton retour.'"
,"19":"Gédéon s'en alla donc; il prépara un chevreau et, avec une mesure de farine, il fit des pains sans levain. Il mit la viande dans une corbeille et le jus dans un pot, et il apporta le tout sous le térébinthe pour le lui offrir."
,"20":"L'Ange de Dieu lui dit alors: 'Prends la viande et les pains sans levain, dépose-les sur le rocher qui est là, et verse le jus.' C'est ce qu'il fit."
,"21":"Alors l'ange de Yahvé étendit son bâton et, du bout de son bâton, il toucha la viande et les pains sans levain: le feu s'éleva du rocher et consuma la viande et les pains sans levain; quant à l'Ange de Yahvé, il avait disparu de devant ses yeux."
,"22":"Gédéon comprit que c'était l'Ange de Yahvé et il dit: 'Malheur à moi, Seigneur Yahvé, car vraiment j'ai vu l'Ange de Yahvé face à face!'"
,"23":"Mais Yahvé lui dit: 'Sois sans crainte, tu ne mourras pas.'"
,"24":"Gédéon construisit un autel à Yahvé en ce lieu et il l'appela: Yahvé-Paix. Il existe encore aujourd'hui à Ofra, sur les terres d'Abiézer."
,"25":"Cette même nuit Yahvé lui dit: 'Prends le jeune taureau de ton père. Tu démoliras l'autel de Baal qui appartient à ton père et tu couperas l'ashéra qui est à côté."
,"26":"Puis tu bâtiras un autel à Yahvé ton Dieu, sur le sommet de cette colline fortifiée, et tu prépareras le jeune taureau pour l'offrir par le feu sur le bois de l'ashéra que tu auras coupée.'"
,"27":"Gédéon prit donc dix de ses serviteurs et fit ce que Yahvé lui avait ordonné. Mais il avait peur de le faire de jour, car il craignait la famille de son père et les hommes de la ville; c'est pourquoi il fit cela de nuit."
,"28":"Quand les hommes de la ville se levèrent de bon matin, ils virent que l'autel de Baal était renversé; l'ashéra qui se trouvait à côté avait été coupée, et le jeune taureau avait été offert en holocauste sur le nouvel autel."
,"29":"Ils se demandaient l'un à l'autre qui avait fait cela. Ils se mirent à questionner, à interroger, et on leur répondit: 'C'est Gédéon fils de Yoach qui l'a fait.'"
,"30":"Les hommes de la ville dirent à Yoach: 'Fais sortir ton fils et qu'il meure! C'est lui qui a renversé l'autel de Baal et coupé l'ashéra qui était à côté.'"
,"31":"Mais Yoach répondit à tous ceux qui s'étaient attroupés autour de lui: 'Est-ce à vous de défendre Baal? Est-ce à vous de le délivrer? Si quelqu'un défend Baal, il sera mis à mort avant le matin; si Baal est Dieu, qu'il se défende lui-même puisqu'on a renversé son autel.'"
,"32":"Ce jour-là on donna à Gédéon le surnom de Yéroubbaal, car on disait: 'Que Baal s'en prenne à lui, puisqu'il a renversé son autel.'"
,"33":"Tous les Madianites, les Amalécites et les fils de l'Orient se donnèrent rendez-vous; ils passèrent le Jourdain et campè rent dans la plaine de Yizréel."
,"34":"Alors l'esprit de Yahvé s'empara de Gédéon. Il sonna du cor et tout le clan d'Abiézer se rassembla derrière lui."
,"35":"Il envoya des messagers dans tous le pays de Manassé, qui lui aussi se rassembla derrière lui. Il envoya encore des messagers en Asher, en Zabulon et en Nephtali, et ils vinrent à sa rencontre."
,"36":"Gédéon dit à Dieu: 'Si vraiment tu veux sauver Israël par ma main, comme tu l'as dit, accorde-moi ce signe."
,"37":"Je mettrai une toison de laine sur l'aire. Si la toison seule a de la rosée, alors que toute la terre autour reste sèche, je saurai que tu veux délivrer Israël par ma main, comme tu l'as dit.'"
,"38":"C'est ce qui arriva. Quand il se leva de bon matin, il pressa la toison et il fit égoutter la rosée, de quoi remplir une coupe."
,"39":"Gédéon dit alors à Dieu: 'Ne te fâche pas contre moi. Laisse-moi parler une fois encore et renouveler rien qu'une fois l'épreuve de la toison: que la toison seule reste sèche et que toute la terre autour soit couverte de rosée.'"
,"40":"Dieu fit ainsi cette nuit-là, et la toison resta sèche alors que la rosée couvrait la terre."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Yéroubbaal (c'est Gédéon) se leva de bon matin et s'en vint camper avec tout le peuple qui l'accompagnait, au-dessus de En-Harod. Le camp de Madian était au nord de celui de Gédéon, dans la plaine, au pied du mont Moré."
,"2":"Yahvé dit à Gédéon: 'Le peuple qui t'accompagne est trop nombreux. Si je livrais Madian entre tes mains, Israël pourrait en tirer gloire à mes dépens. Il dirait: Je me suis délivré moi-même."
,"3":"Tu vas donc proclamer ceci devant tout le peuple: Que celui qui a peur et qui tremble, s'en retourne.' Et Gédéon les mit à l'épreuve. Vingt-deux mille hommes du peuple s'en retournèrent et il en resta dix mille."
,"4":"Yahvé dit à Gédéon: 'Le peuple est encore trop nombreux. Fais-les descendre au bord de l'eau, et là je ferai le tri. Celui pour lequel je te dirai: Qu'il aille avec toi! ira avec toi. Et celui pour lequel je te dirai: Qu'il n'aille pas avec toi! n'ira pas avec toi.'"
,"5":"On fit donc descendre le peuple au bord de l'eau, et Yahvé dit à Gédéon: 'Tu sépareras ceux qui laperont l'eau avec la langue, comme lape le chien, de ceux qui se mettront à genoux pour boire.'"
,"6":"Ceux qui lapèrent dans leur main en la portant à leur bouche, furent au nombre de trois cents, car tout le reste du peuple s'était mis à genoux pour boire."
,"7":"Yahvé dit alors à Gédéon: 'Je vous sauverai et je livrerai Madian entre vos mains avec ces trois cents hommes qui ont lapé l'eau. Que tout le reste du peuple s'en retourne chacun chez soi.'"
,"8":"On ramassa les vivres du peuple et leurs trompettes, puis Gédéon les renvoya chacun chez soi et ne garda que les trois cents hommes. Le camp des Madianites était au-dessous de lui, dans la plaine."
,"9":"Durant cette nuit, Yahvé dit à Gédéon: 'Descends donc vers le camp des Madianites, tu n'as rien à craindre d'eux."
,"10":"Si cela te fait peur d'y descendre, descends avec ton serviteur Poura."
,"11":"Tu écouteras ce qu'ils disent et cela te donnera du courage pour aller attaquer leur camp.' Il descendit donc avec son serviteur Poura jusqu'aux avant-postes des Madianites."
,"12":"Ceux-ci s'étaient installés sur toute la plaine avec Amalec et tous les fils de l'Orient. Ils fourmillaient comme les sauterelles et leurs chameaux étaient aussi nombreux que le sable du bord de la mer."
,"13":"Quand Gédéon arriva, un homme était en train de raconter un songe à son camarade: 'J'ai eu un songe. C'était un pain d'orge qui déboulait dans le camp de Madian; il arriva jusqu'à la Tente, la heurta, et elle s'écroula.'"
,"14":"Son camarade lui répondit: 'Ce ne peut pas être autre chose que l'épée de Gédéon, fils de Yoach, l'Israélite. Dieu a sûrement livré tout le camp de Madian entre ses mains.'"
,"15":"Lorsque Gédéon entendit le récit du songe et son interprétation, il se prosterna. Il rentra au camp d'Israël et dit: 'Levez-vous! Yahvé a livré le camp de Madian entre nos mains.'"
,"16":"Il divisa les trois cents hommes en trois groupes. A tous il leur remit des trompettes et des cruches vides avec des torches dans les cruches."
,"17":"Puis il leur dit: 'Regardez-moi bien et faites comme je ferai. Dès que j'arriverai aux abords du camp des Madianites, vous ferez comme moi."
,"18":"Lorsque je sonnerai de la trompette, moi et tous ceux qui sont avec moi, vous aussi vous sonnerez de la trompette tout autour du camp et vous crierez: Pour Yahvé et pour Gédéon!'"
,"19":"Gédéon et les cent hommes qui l'accompagnaient arrivèrent aux abords du camp de Madian vers le milieu de la nuit, alors qu'on venait de relever les sentinelles. Ils sonnèrent de la trompette et brisèrent les cruches qu'ils portaient à la main."
,"20":"Aussitôt les trois groupes sonnèrent de la trompette, brisèrent les cruches. Ils saisirent les torches de la main gauche tout en sonnant de la trompette qu'ils tenaient de la main droite, et ils s'écrièrent: 'Epée pour Yahvé et pour Gédéon!'"
,"21":"Mais ils restèrent chacun à sa place tout autour du camp. Tout le monde dans le camp se mit à courir, à crier et à fuir. "
,"22":"Comme ils n'arrêtaient pas de sonner de la trompette, Yahvé fit que dans tout le camp chacun tourna son épée contre son frère. Ils s'enfuirent tous jusqu'à Beth-Ha-Chitta, du côté de Sartan, et jusqu'à la rive d'Abel-Méhola en face de Tabbat."
,"23":"Les hommes d'Israël venus de Nephtali, d'Asher et de tout Manassé, se regroupèrent et poursuivirent les Madianites."
,"24":"Gédéon envoya alors des messagers dans toute la montagne d'Ephraïm: 'Descendez à la rencontre des Madianites, et avant qu'ils n'arrivent, occupez les gués jusqu'à Beth-Bara tout au long du Jourdain.'"
,"25":"Ils firent prisonniers les deux chefs de Madian, Oreb et Zéeb, ils tuèrent Oreb au Rocher-d'Oreb, et Zéeb, au Pressoir-de-Zéeb. Revenant de la poursuite des Madianites, ils rapportèrent à Gédéon, d'au-delà du Jourdain, les têtes d'Oreb et de Zéeb."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Les hommes d'Ephraïm dirent à Gédéon: 'Qu'est-ce que tu nous as fait là? Tu ne nous as même pas appelés lorsque tu allais combattre les Madianites?' Ils étaient très en colère contre lui."
,"2":"Alors Gédéon leur répondit: 'Toute la vendange d'Abiézer ne valait pas ce qu'Ephraïm a grappillé derrière lui."
,"3":"N'est-ce pas entre vos mains que Yahvé a livré les chefs de Madian Oreb et Zéeb? Ce que j'ai fait n'est rien en comparaison.' Quand il eut ainsi parlé, leur colère s'apaisa."
,"4":"Arrivé au Jourdain, Gédéon le traversa avec les trois cents hommes qui l'accompagnaient, mais ils étaient épuisés par la poursuite."
,"5":"C'est pourquoi il dit aux gens de Soukkot: 'Donnez, s'il vous plaît, des galettes de pain à cette troupe qui m'accompagne, car mes gens sont à bout de forces. Je suis en train de poursuivre Zébah et Salmouna, les rois de Madian.'"
,"6":"Mais les anciens de Soukkot répondirent: 'As-tu déjà lié les mains à Zébah et Salmouna? Et tu voudrais que nous donnions du pain à tes hommes?'"
,"7":"Gédéon leur répondit: 'Très bien! Aussitôt que Yahvé aura livré entre mes mains Zébah et Salmouna, je vous arracherai la peau avec les épines du désert, avec les chardons.'"
,"8":"Il partit donc de là vers Pénuel et il adressa les mêmes paroles aux gens de Pénuel. Ils répondirent comme l'avaient fait ceux de Soukkot."
,"9":"Il répliqua donc aux gens de Pénuel: 'Lorsque je reviendrai vainqueur, je renverserai cette tour.'"
,"10":"Zébah et Salmouna étaient à Karkor avec une troupe d'environ quinze mille hommes (c'étaient les survivants de la grande armée des fils de l'Orient, car il en était déjà tombé cent vingt mille)."
,"11":"Gédéon monta par le Chemin des Nomades, à l'est de Nobah et de Yogbéha, et il écrasa leur armée qui se croyait en sûreté."
,"12":"Zébah et Salmouna s'enfuirent, mais il les poursuivit et fit prisonniers les deux rois de Madian, Zébah et Salmouna, tandis que toute leur armée était mise en déroute."
,"13":"Après la bataille, Gédéon, fils de Yoach s'en retourna par la montée de Harés."
,"14":"Là il arrêta un jeune homme de Soukkot et l'interrogea. Celui-ci lui donna par écrit les noms des chefs de Soukkot et des anciens: ils étaient au nombre de soixante-dix-sept."
,"15":"Gédéon alla trouver les gens de Soukkot et leur dit: 'Voici Zébah et Salmouna à propos desquels vous vous êtes moqués de moi. Vous avez bien dit: Quand Zébah et Salmouna seront tombés entre tes mains, nous donnerons du pain à tous ces hommes épuisés.'"
,"16":"Alors il saisit les anciens de la ville, puis il ramassa des épines du désert et des chardons, avec lesquels il déchira les gens de Soukkot."
,"17":"Gédéon renversa la tour de Pénuel et massacra les habitants de la ville."
,"18":"Puis il dit à Zébah et à Salmouna: 'Comment donc étaient ces hommes que vous avez tués sur le Thabor?' Ils répondirent: 'Ils te ressemblaient, chacun d'eux avait l'allure d'un fils de roi.'"
,"19":"Gédéon répondit: 'C'étaient mes frères, les fils de ma mère! Aussi vrai que Yahvé est vivant, si vous leur aviez laissé la vie, je ne vous tuerais pas.'"
,"20":"Alors il commanda à Yéter, son aîné: 'Vas-y, tue-les!' Mais l'enfant ne tira pas son épée car il avait peur: il était encore jeune."
,"21":"Alors Zébah et Salmouna lui dirent: 'Vas-y toi-même et frappe-nous! On reconnaît l'homme à sa force.' Gédéon tua donc Zébah et Salmouna et prit les croissants qui étaient aux cous de leurs chameaux."
,"22":"Les Israélites dirent à Gédéon: 'Puisque tu nous as délivrés de la main des Madianites, c'est toi qui vas régner sur nous, et après toi, ton fils et ton petit-fils.'"
,"23":"Gédéon leur répondit: 'Ni moi, ni mon fils ne régnerons sur vous: Yahvé sera votre roi.'"
,"24":"Gédéon ajouta: 'Je vous demande seulement que chacun d'entre vous me donne sur son butin un anneau (les vaincus étaient des Ismaélites et ils avaient des anneaux d'or).'"
,"25":"Ils lui dirent: 'Bien sûr, nous te le donnons.' Ils étendirent un manteau à terre et jetèrent chacun un anneau pris sur son butin."
,"26":"Le poids des anneaux d'or fut de mille sept cents sicles, sans compter les croissants, les boucles d'oreilles et les habits de pourpre que portaient les rois de Madian; sans compter non plus les colliers qui pendaient au cou de leurs chameaux."
,"27":"De tout cela Gédéon fit un éphod qu'il dressa dans sa ville à Ofra. Tous les Israélites allaient s'y vendre, ce fut un piège pour Gédéon et pour sa famille."
,"28":"Quant aux Madianites, ils furent désormais soumis aux Israélites et ne relevèrent plus la tête. Le pays fut en paix pendant quarante ans, le temps que vécut Gédéon."
,"29":"Yéroubbaal, fils de Yoach, s'en retourna et résida dans sa maison."
,"30":"Gédéon eut soixante-dix fils, tous issus de lui, car il avait de nombreuses femmes."
,"31":"Il avait à Sichem une concubine qui lui donna elle aussi un fils, et il l'appela Abimélek."
,"32":"Gédéon, fils de Yoach, mourut dans une heureuse vieillesse. On l'enterra dans le tombeau de son père Yoach, à Ofra dans le territoire d'Abiézer."
,"33":"Après la mort de Gédéon, les Israélites recommencèrent à se prostituer à la suite des Baals: ils se donnèrent comme dieu Baal-Bérit."
,"34":"C'est ainsi que les Israélites oublièrent Yahvé leur Dieu, qui les avait délivrés de tous leurs ennemis à l'entour."
,"35":"Ils ne montrèrent pas davantage de reconnaissance à la famille de Yéroubbaal-Gédéon pour tout le bien qu'il avait fait à Israël."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Abimélek, fils de Yéroubbaal, se rendit à Sichem auprès des frères de sa mère. Il leur dit, ainsi qu'à toute la famille de son grand-père maternel:"
,"2":"' Posez donc cette question aux messieurs de Sichem: Préférez-vous être gouvernés par soixante-dix hommes, tous les fils de Yéroubbaal, ou n'avoir qu'un seul maître? Souvenez-vous donc que je suis de votre sang.'"
,"3":"Les frères de sa mère rapportèrent toutes ces paroles aux messieurs de Sichem, et ils se décidèrent en faveur d'Abimélek, car ils se disaient: 'C'est notre frère.'"
,"4":"Ils lui donnèrent donc soixante-dix sicles d'argent, pris dans le temple de Baal-Bérit, et avec cet argent Abimélek paya des voyous, des aventuriers qui se mirent à son service."
,"5":"Il se rendit alors à Ofra, dans la maison de son père, et massacra ses frères, les fils de Yéroubbaal: les soixante dix furent exécutés sur la même pierre. Le plus jeune fils de Yeroubbaal, Yotam, s'était caché et il échappa."
,"6":"Alors tous les notables de Sichem et de Beth-Millo se réunirent et proclamèrent roi Abimélek, près du Chêne-de-la-Stèle qui est à Sichem."
,"7":"On annonça la chose à Yotam. Il alla se poster au sommet du mont Garizim et s'écria d'une voix forte: 'Ecoutez-moi, notables de Sichem, et que Dieu lui-même vous écoute!"
,"8":"Un jour les arbres se mirent en route: ils voulaient se donner un roi. Ils dirent à l'olivier: Sois notre roi!"
,"9":"Mais l'olivier leur répondit: Vais-je laisser là mon huile, si précieuse pour les dieux et les hommes, pour aller me balancer au-dessus des autres arbres?"
,"10":"Les arbres se tournèrent donc vers le figuier: Viens, toi, tu seras notre roi!"
,"11":"Le figuier leur répondit: Vais-je renoncer à la douceur de mes fruits si appréciés pour aller me balancer au-dessus des autres arbres?"
,"12":"Cette fois les arbres se tournèrent vers la vigne: Viens, toi, tu seras notre roi!"
,"13":"Mais la vigne leur répondit: Vais-je renoncer à mon raisin, qui réjouit les dieux et les hommes, pour aller me balancer au-dessus des arbres?"
,"14":"Alors tous les arbres vinrent trouver le buisson d'épines: Viens, toi, tu seras notre roi!"
,"15":"Et le buisson d'épines répondit aux arbres: 'Si vraiment vous voulez me faire roi et que je règne sur vous, venez et restez à mon ombre. Sinon, un feu sortira du buisson d'épines et dévorera jusqu'au cèdre du Liban."
,"16":"Et vous maintenant, avez-vous agi avec sincérité et honnêteté en faisant roi Abimélek? Vous êtes-vous bien conduits envers Yéroubbaal et sa famille? L'avez-vous traité comme il le méritait?"
,"17":"Mon père n'a-t-il pas combattu pour vous? N'a-t-il pas risqué sa vie pour vous? Ne vous a-t-il pas délivrés de la main des Madianites?"
,"18":"Or vous, aujourd'hui, vous vous êtes dressés contre la famille de mon père, vous avez tué ses fils, au nombre de soixante-dix, sur une même pierre. Et vous avez fait d'Abimélek, le fils d'une servante, le roi des messieurs de Sichem, parce qu'il est de votre sang."
,"19":"Si donc aujourd'hui vous vous êtes montrés fidèles et honnêtes envers Yéroubbaal et sa maison, je vous souhaite qu'Abimélek fasse votre bonheur et que vous, vous fassiez le sien!"
,"20":"Sinon, qu'un feu sorte d'Abimélek et dévore les gens de Sichem et de Beth-Millo, et qu'un feu sorte des gens de Sichem et Beth-Millo et dévore Abimélek.'"
,"21":"Yotam prit alors la fuite et se rendit à Béer; il séjourna là car il avait peur de son frère Abimélek."
,"22":"Durant trois ans Abimélek gouverna Israël."
,"23":"Mais Dieu envoya un esprit de discorde entre Abimélek et les habitants de Sichem, et ceux-ci trahirent Abimélek."
,"24":"C'est ainsi que le crime commis contre les soixante-dix fils de Yéroubbaal allait être vengé; leur sang retomba sur Abimélek, leur frère, qui les avait tués, ainsi que sur les gens de Sichem qui l'avaient aidé à tuer ses frères."
,"25":"Pour lui faire du tort, les gens de Sichem placèrent en embuscade, sur les cols de la montagne, des gens qui dévalisaient tous ceux qui passaient près d'eux sur le chemin; on rapporta cela à Abimélek."
,"26":"Gaal, fils d'Obed, passa alors avec ses frères. Ils arrivèrent à Sichem et gagnèrent la confiance des gens de Sichem."
,"27":"Ils sortirent dans la campagne pour vendanger leurs vignes, ils écrasèrent leurs raisins et firent la fête. Puis ils entrèrent dans le temple de leurs dieux, ils mangèrent et ils burent, et ils maudirent Abimélek."
,"28":"Gaal fils d'Obed dit alors: 'Qui est cet Abimélek, et qu'est-ce que Sichem, pour que nous soyons à son service? Le fils de Yéroubbaal, tout comme son lieutenant Zéboul, n'étaient que les serviteurs de Hamor, père de Sichem!"
,"29":"Si seulement j'étais le chef de ce peuple, je chasserais Abimélek et je lui dirais: 'Abimélek, viens donc ici avec toute ton armée!'"
,"30":"Les paroles de Gaal, fils d'Obed, mirent Zéboul, gouverneur de la ville, dans une grande colère."
,"31":"Il envoya discrètement des messagers à Abimélek pour lui dire: 'Gaal, fils d'Obed, vient d'arriver à Sichem avec ses frères, et ils soulèvent la ville contre toi."
,"32":"Lève-toi donc de nuit avec le peuple qui t'accompagne, et cache-toi dans la campagne."
,"33":"Le matin, au lever du soleil, tu te lèveras et tu te jetteras sur la ville. Et lorsque Gaal et ceux qui sont avec lui sortiront à ta rencontre, tu feras comme la situation te le permettra.'"
,"34":"De nuit donc, Abimélek et tous ceux qui étaient avec lui se levèrent, et ils se mirent en embuscade autour de Sichem, répartis en quatre groupes."
,"35":"Alors que Gaal, fils d'Obed, venait se poster à l'entrée de la ville, Abimélek et tous ceux qui étaient avec lui se levèrent de leur cachette."
,"36":"En voyant cette troupe, Gaal dit à Zéboul: 'Voici des gens qui descendent du haut des montagnes.' Zéboul lui répondit: 'Tu prends sûrement pour des hommes les ombres de la montagne.'"
,"37":"Gaal reprit la parole et dit: 'Voici bien une troupe qui descend du coeur du pays. Un autre groupe arrive par le chemin du Chêne-des-Astrologues.'"
,"38":"Alors Zéboul reprit: 'As-tu donc perdu cette langue avec laquelle tu disais: qui est Abimélek, pour que nous soyons à son service? Voici ces gens que tu as méprisés. Sors maintenant, et lutte contre lui!'"
,"39":"Gaal sortit donc à la tête des gens de Sichem et livra combat à Abimélek."
,"40":"Mais Abimélek le poursuivit et Gaal s'enfuit devant lui: beaucoup tombèrent avant d'atteindre la porte."
,"41":"Abimélek séjourna alors à Arouma; quant à Zéboul, il chassa Gaal et ses frères et les empêcha de revenir à Sichem."
,"42":"Le lendemain, le peuple devait sortir dans la campagne. On informa Abimélek."
,"43":"Il rassembla ses hommes et les partagea en trois groupes, puis il se mit en embuscade dans la campagne. Dès qu'il aperçut les gens qui sortaient de la ville, il se jeta sur eux."
,"44":"Abimélek avec ses hommes courut se poster à l'entrée de la porte de la ville. Les deux autres corps pendant ce temps s'élancèrent contre tous ceux qui étaient dans la campagne et ils les écrasèrent."
,"45":"Durant tout ce jour Abimélek fit l'assaut de la ville, il s'en empara et massacra tous ses habitants. Ensuite il rasa la ville et y sema du sel."
,"46":"Tous les gens de la Tour de Sichem, en apprenant cela, se réfugièrent dans la crypte du temple d'El-Bérit."
,"47":"Quand on fit savoir à Abimélek, que tous les gens de la Tour de Sichem s'y étaient rassemblés,"
,"48":"il prit une hache à double tranchant avec laquelle il coupa une branche d'arbre, il la souleva et la mit sur son épaule. Puis il dit à ceux qui l'accompagnaient: 'Vous avez vu ce que j'ai fait, dépêchez-vous de faire comme moi.'"
,"49":"Chacun de ses hommes coupa donc une branche. Ils se mirent en route derrière Abimélek et disposèrent les branches sur la crypte, puis ils mirent le feu et incendièrent cette crypte. C'est ainsi que moururent tous les gens de la Tour de Sichem: près d'un millier d'hommes et de femmes."
,"50":"Abimélek se rendit à Tébès; il l'assiégea et s'en empara."
,"51":"Mais il y avait à l'intérieur de la ville une tour fortifiée dans laquelle se réfugièrent, hommes et femmes, tous les notables de la ville. Ils fermèrent derrière eux la porte et montèrent sur le toit de la tour."
,"52":"Abimélek arriva en force au pied de la tour et s'avança jusqu'à la porte de la tour pour y mettre le feu."
,"53":"C'est alors qu'une femme lui lança une meule sur la tête et lui fracassa le crâne."
,"54":"Aussitôt il appela son écuyer et lui dit: 'Tire ton épée et tue-moi! Il ne faut pas qu'on dise de moi: C'est une femme qui l'a tué.' Alors son écuyer le transperça et il mourut."
,"55":"Quand les Israélites virent qu'Abimélek était mort, ils s'en retournèrent chacun chez soi."
,"56":"Ainsi Dieu rendit à Abimélek le mal qu'il avait fait à son père en tuant ses soixante-dix frères."
,"57":"Et Dieu fit retomber sur les hommes de Sichem toute leur méchanceté. C'est ainsi que se réalisa pour eux la malédiction de Yotam, fils de Yéroubbaal."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Après Abimélek, Tola, fils de Poua, fils de Dodo, se leva pour délivrer Israël. Il était de la tribu d'Issacar et il habitait Chamir, dans la montagne d'Ephraïm."
,"2":"Il jugea Israël pendant vingt-trois ans, puis il mourut et on l'enterra à Chamir."
,"3":"Après lui, se leva Yaïr de Galaad. Il jugea Israël pendant vingt-deux ans."
,"4":"Il avait trente fils qui montaient trente ânons, et il possédait trente villes qu'on appelle encore aujourd'hui les Douars-de-Yaïr, au pays de Galaad."
,"5":"Quand Yaïr mourut, on l'enterra à Kamon."
,"6":"Les Israélites firent de nouveau ce qui est mal aux yeux de Yahvé. Ils servirent les Baals et les Astartés, ainsi que les dieux d'Aram, de Sidon, de Moab, des Ammonites et des Philistins. Ils abandonnèrent Yahvé et ne le servirent plus."
,"7":"C'est pourquoi la colère de Yahvé s'enflamma contre Israël, il le livra aux mains des Philistins et des Ammonites."
,"8":"Dès cette année-là ils écrasèrent et maltraitèrent tous les Israélites qui habitaient au-delà du Jourdain, dans le pays amorite, en Galaad, et cela dura dix-huit ans."
,"9":"Les Ammonites passèrent même le Jourdain pour combattre contre Juda, Benjamin et la maison d'Ephraïm: Israël était dans une très grande détresse."
,"10":"Les Israélites crièrent donc vers Yahvé: 'Nous avons péché contre toi, lui dirent-ils, nous avons abandonné notre Dieu et nous avons servi les Baals.'"
,"11":"Yahvé répondit aux Israélites: 'Quand vous avez été opprimés par les Egyptiens, les Amorites, les Ammonites, les Philistins,"
,"12":"les Sidoniens, les Amalécites ou les Madianites, et que vous avez crié vers moi, ne vous ai-je pas délivré de leurs mains?"
,"13":"Mais vous, vous m'avez abandonné et vous avez servi d'autres dieux, c'est pourquoi je ne vous délivrerai plus."
,"14":"Allez maintenant crier vers les dieux que vous avez choisis, qu'ils vous délivrent quand les choses vont mal pour vous!'"
,"15":"Les Israélites dirent à Yahvé: 'Nous avons péché, traite-nous comme il te semblera bon, mais au moins délivre-nous en ce jour.'"
,"16":"Ils firent disparaître de chez eux les dieux étrangers et ils servirent Yahvé. Alors Yahvé ne supporta pas davantage la souffrance d'Israël."
,"17":"Les Ammonites se rassemblèrent et installèrent leur camp en Galaad. Les Israélites se rassemblèrent aussi, et ils installèrent leur camp à Mispa."
,"18":"Le peuple et les chefs de Galaad se dirent les uns aux autres: 'Quel est l'homme qui engagera le combat contre les Ammonites? On le placera à la tête de tous les habitants de Galaad.'"
}`)
	CurrentBook.AddChapter(11, `{
"1":"Or Jephté de Galaad était un courageux guerrier. Il était fils d'une prostituée, mais son père était Galaad."
,"2":"La femme de Galaad lui avait donné des fils, et quand ils furent grands ils chassèrent Jephté: 'Tu n'auras pas de part d'héritage, lui dirent-ils, dans la maison de notre père, tu n'es que le fils d'une étrangère.'"
,"3":"Jephté s'éloigna donc de ses frères et s'installa au pays de Tob. Des gens de rien se rassemblèrent autour de Jephté et firent campagne avec lui."
,"4":"C'est à ce moment-là que les Ammonites attaquèrent Israël."
,"5":"Les anciens de Galaad allèrent alors chercher Jephté au pays de Tob"
,"6":"et ils lui dirent : 'Viens! Tu seras notre chef et nous combattrons contre les Ammonites.'"
,"7":"Mais Jephté répondit aux anciens de Galaad: 'N'est-ce pas vous qui m'avez méprisé et chassé de la maison de mon père? Et maintenant vous venez me trouver parce que vous êtes en danger!'"
,"8":"Les anciens de Galaad dirent à Jephté: 'C'est bien pour cela que nous sommes revenus vers toi aujourd'hui, pour que tu marches à notre tête et que tu combattes contre les Ammonites; nous voulons te faire chef de tous les habitants de Galaad.'"
,"9":"Jephté répondit aux anciens de Galaad: 'Si vous me faites revenir pour combattre les Ammonites et que Yahvé les livre entre mes mains, je serai votre chef.'"
,"10":"Les anciens de Galaad dirent à Jephté: 'Yahvé sera témoin contre nous si nous n'agissons pas comme tu viens de dire.'"
,"11":"Jephté partit donc avec les anciens de Galaad, et le peuple le mit à sa tête comme son chef et son général. Puis à Mispa, en présence de Yahvé, Jephté répéta toutes ses conditions."
,"12":"Jephté envoya des hommes au roi des Ammonites avec ce message: 'Pourquoi viens-tu te mêler de mes affaires et me faire la guerre dans mon pays?'"
,"13":"Le roi des Ammonites répondit aux messagers de Jephté: 'C'est parce que les Israélites se sont emparés de mon territoire depuis l'Arnon jusqu'au Yabok et au Jourdain lorsqu'ils sont arrivés d'Egypte. Maintenant donc, rends-le de bon gré.'"
,"14":"De nouveau, Jephté envoya des messagers au roi des Ammonites."
,"15":"Il lui fit dire de sa part: 'Israël ne s'est pas emparé du pays de Moab, ni du pays des Ammonites."
,"16":"Lorsque les Israélites sont montés d'Egypte, ils ont marché dans le désert jusqu'à la mer des Roseaux et ils sont arrivés à Qadesh."
,"17":"Alors Israël envoya des messagers au roi d'Edom pour lui dire: Laisse-moi traverser ton pays. Mais le roi d'Edom refusa. Ils envoya de même des messagers au roi de Moab qui refusa aussi. Alors Israël séjourna à Qadesh."
,"18":"Il marcha ensuite dans le désert, contourna le pays d'Edom et le pays de Moab, et arriva par l'est du pays de Moab. Il installa son camp au-delà de l'Arnon, mais il n'entra pas dans le territoire de Moab, puisque sa frontière c'est l'Arnon."
,"19":"Ensuite Israël envoya des messagers à Sihon, roi des Amorites, qui régnait à Heshbon. Israël lui dit: Laisse-nous traverser ton pays jusqu'au lieu où je vais."
,"20":"Mais Sihon refusa de laisser Israël traverser son pays. Sihon rassembla même tous ses gens, ils montèrent leur camp à Yahas et engagèrent le combat contre Israël."
,"21":"Yahvé, le Dieu d'Israël, livra Sihon et toute son armée entre les mains d'Israël qui les écrasa. Et Israël s'empara de tout le pays des Amorites qui habitaient la région."
,"22":"Ensuite, il conquit tout le territoire des Amorites, depuis l'Arnon jusqu'au Yabok, et depuis le désert jusqu'au Jourdain."
,"23":"Maintenant que Yahvé, le Dieu d'Israël, a dépossédé les Amorites en faveur de son peuple, tu voudrais à ton tour déposséder Israël?"
,"24":"Si tu te considères propriétaire de ce que Kémoch, ton dieu, t'a donné, pourquoi veux-tu nous prendre ce que Yahvé notre Dieu nous a donné?"
,"25":"Te crois-tu plus fort que Balak, fils de Sipor, le roi de Moab? A-t-il pu résister à Israël? A-t-il pu triompher de lui?"
,"26":"Voici plus de trois cent ans qu'Israël habite à Heshbon et dans ses dépendances, dans Aroër et ses dépendances et dans toutes les villes qui sont sur les bords de l'Arnon. Pourquoi ne les avez-vous pas libérées durant tout ce temps?"
,"27":"Je ne t'ai pas fait de tort, c'est toi qui as mal agi envers moi en me faisant la guerre. Que Yahvé, le Juge, juge aujourd'hui entre les Israélites et les Ammonites.'"
,"28":"Mais le roi des Ammonites n'écouta pas les paroles que Jephté lui adressait."
,"29":"L'esprit de Yahvé s'empara de Jephté. Il traversa Galaad et Manassé, puis il passa par Mispa-de-Galaad et, de Mispa-de-Galaad, arriva chez les Ammonites."
,"30":"Il fit ce voeu à Yahvé: 'Si tu livres les Ammonites entre mes mains,"
,"31":"le premier qui passera la porte de ma maison pour venir à ma rencontre après ma victoire sur les Ammonites, il sera pour Yahvé et je le sacrifierai par le feu.'"
,"32":"Jephté passa donc sur les terres des Ammonites pour les combattre, et Yahvé les livra entre ses mains."
,"33":"Il les battit depuis Aroër jusqu'aux environs de Minit (il s'empara donc de vingt villes) et jusqu'à Abel-Kéramim. Ce fut une très grande défaite pour les Ammonites, ils furent dès lors soumis aux Israélites."
,"34":"Or, lorsque Jephté regagnait sa maison à Mispa, sa fille sortit à sa rencontre avec des tambourins et des choeurs. Elle était son unique enfant; en dehors d'elle il n'avait ni fils ni fille."
,"35":"Quand il l'aperçut, il déchira ses vêtements et dit: 'Ah, ma fille, tu me mets par terre! Et c'est toi qui viens m'apporter le malheur! J'ai promis à Yahvé sans réfléchir, et maintenant je ne puis revenir en arrière.'"
,"36":"Elle lui répondit: 'Mon père, puisque Yahvé a tiré vengeance de tes ennemis, les Ammonites, même si tu as promis trop vite à Yahvé, tu dois agir envers moi selon la parole qui est sortie de ta bouche.'"
,"37":"Et elle dit à son père: 'Accorde-moi ceci: Laisse-moi un délai de deux mois pour que j'aille errer sur les monts avec mes compagnes et pleurer cette mort quand je suis encore vierge.'"
,"38":"Il lui répondit: 'Va!' et il la laissa partir pour deux mois. Elle s'en alla donc avec ses compagnes pour pleurer sur les monts cette mort quand elle était encore vierge. "
,"39":"Au bout de deux mois elle revint vers son père, et il accomplit envers elle le voeu qu'il avait fait. Elle n'avait pas connu d'homme. Depuis c'est une coutume en Israël"
,"40":"que chaque année les filles d'Israël aillent se lamenter sur la fille de Jephté de Galaad."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Les hommes d'Ephraïm se rassemblèrent et traversèrent à la hauteur de Saphon. Ils dirent à Jephté: 'Pourquoi es-tu parti combattre les Ammonites et ne nous as-tu pas invités pour aller avec toi? Nous allons brûler sur toi ta maison.'"
,"2":"Mais Jephté leur répondit: 'Moi et mon peuple, nous étions en conflit avec les Ammonites. Je vous ai appelés mais vous ne m'avez pas délivré de leurs mains."
,"3":"Quand j'ai vu que vous ne veniez pas me délivrer, j'ai risqué ma vie. J'ai engagé le combat contre les Ammonites et Yahvé les a livrés entre mes mains. Est-ce une raison pour venir maintenant m'attaquer?'"
,"4":"Jephté rassembla tous les hommes de Galaad et engagea le combat contre Ephraïm. Les hommes de Galaad écrasèrent ceux d'Ephraïm qui disaient: 'Vous, gens de Galaad, vous n'êtes que des transfuges d'Ephraïm, vous êtes passés d'Ephraïm à Manassé.'"
,"5":"Galaad s'empara des gués du Jourdain du côté d'Ephraïm, et lorsque les fuyards d'Ephraïm disaient: 'Je veux traverser', les hommes de Galaad lui disaient: 'Es-tu d'Ephraïm?' S'il répondait: 'Non'"
,"6":"alors on lui disait: 'Prononce Chibboleth!' Et s'il prononçait: 'Sibboleth' (car ils ne réussissaient pas à prononcer correctement) on le saisissait et on l'égorgeait au gué du Jourdain. Quarante- deux mille hommes d'Ephraïm furent massacrés ce jour-là."
,"7":"Jephté jugea Israël durant six ans. Puis Jephté de Galaad mourut et fut enterré dans sa ville, en Galaad."
,"8":"Après lui Ibsan de Bethléem jugea Israël."
,"9":"Il eut trente fils et trente filles; il maria ses filles au-dehors et fit venir du dehors des filles pour ses fils. Pendant sept ans il jugea Israël."
,"10":"Ibsan mourut et on l'enterra à Bethléem."
,"11":"Après lui Elon, de Zabulon, jugea Israël. Il jugea Israël pendant dix ans."
,"12":"Puis Elon de Zabulon mourut et on l'enterra à Ayyalon, au pays de Zabulon."
,"13":"Après lui ce fut Abdon, fils de Hillel, de Piréaton, qui jugea Israël."
,"14":"Il avait quarante fils et trente petits-fils qui montaient soixante-dix ânons. Il jugea Israël pendant huit ans."
,"15":"Quand Abdon, fils de Hillel, de Piréaton, mourut, on l'enterra à Piréaton au pays d'Ephraïm, dans la montagne des Amalécites."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Les Israélites recommencèrent à faire ce qui est mal aux yeux de Yahvé, et lui les livra entre les mains des Philistins pendant quarante ans."
,"2":"Il y avait un homme de Soréa, de la tribu de Dan, qui s'appelait Manoa. Sa femme était stérile et n'avait pas enfanté."
,"3":"L'Ange de Yahvé apparut à la femme et lui dit: 'Jusqu'à présent tu étais stérile, et tu n'as pas enfanté, mais tu vas concevoir et enfanter un fils."
,"4":"Maintenant donc, fais attention à ne plus boire ni vin ni boisson enivrante, et ne mange rien d'impur"
,"5":"à cause de ce fils que tu vas concevoir et enfanter. Car dès le sein de sa mère le garçon sera consacré à Dieu: le rasoir ne passera pas sur sa tête, et c'est lui qui commencera à libérer Israël de la main des Philistins.'"
,"6":"De retour chez elle, la femme parla à son mari et lui dit: 'Un homme de Dieu est venu vers moi. Il était majestueux: on aurait dit un ange de Dieu. Mais je ne lui ai pas demandé d'où il venait et il ne m'a pas fait connaître son nom."
,"7":"Il m'a dit ceci: Tu vas concevoir et enfanter un fils, aussi, dès maintenant, ne bois plus ni vin ni boisson enivrante, et ne mange rien d'impur, car le garçon sera consacré à Dieu dès le sein de sa mère et jusqu'au jour de sa mort.'"
,"8":"Alors Manoa supplia Yahvé: 'De grâce Mon Seigneur! Que l'homme de Dieu que tu as envoyé revienne vers nous pour nous dire comment faire avec le garçon qui va naître.'"
,"9":"Dieu entendit la voix de Manoa et l'ange de Dieu vint encore une fois vers la femme, alors qu'elle était assise dans les champs. Mais son mari Manoa n'était pas avec elle."
,"10":"La femme courut aussitôt avertir son mari: 'Je viens de revoir l'homme qui est venu me trouver l'autre jour.'"
,"11":"Manoa se leva et suivit sa femme. Il arriva où était l'homme et lui demanda: 'Tu es bien l'homme qui a parlé à cette femme?' Il répondit: 'Oui, c'est moi.'"
,"12":"Manoa lui dit: 'Si ce que tu as dit se réalise, quelle règle suivrons-nous pour ce garçon, que devra-t-il faire?'"
,"13":"L'Ange de Yahvé répondit à Manoa: 'La femme s'abstiendra de tout ce que j'ai dit."
,"14":"Elle ne mangera d'aucun produit de la vigne, elle ne boira ni vin ni boisson enivrante, elle ne mangera rien d'impur: elle observera tout ce que je lui ai commandé.'"
,"15":"Manoa dit à l'ange de Yahvé: 'Permets que nous te retenions et que nous préparions un chevreau.'"
,"16":"Mais l'ange de Yahvé répondit à Manoa: 'Même si tu me retenais, je ne mangerais pas de ton pain. Cependant, si tu veux offrir un holocauste à Yahvé, offre-le.' Manoa en effet, ne savait pas que c'était l'Ange de Yahvé."
,"17":"Alors Manoa dit à l'Ange de Yahvé: 'Quel est ton nom? Nous voudrions pouvoir te remercier lorsque tes paroles se réaliseront.'"
,"18":"L'Ange de Yahvé lui dit: 'Pourquoi me demandes-tu mon nom? Il est mystérieux.'"
,"19":"Manoa prit le chevreau et une offrande et les disposa sur le rocher en l'honneur de Yahvé et de cet être mystérieux que Manoa et sa femme pouvaient voir."
,"20":"Or, comme la flamme s'élevait au-dessus de l'autel vers les cieux, il arriva que l'Ange de Yahvé monta dans la flamme de l'autel. A cette vue, Manoa et sa femme tombèrent la face contre terre."
,"21":"Quant à l'Ange de Yahvé, il disparut aux yeux de Manoa et de sa femme. Alors Manoa comprit que c'était l'Ange de Yahvé."
,"22":"Manoa dit à sa femme: 'Nous allons mourir, car nous avons vu un Dieu.'"
,"23":"Mais sa femme lui répondit: 'Si Yahvé voulait nous faire mourir, il n'aurait accepté, ni notre holocauste ni notre offrande. Il ne nous aurait pas montré tout cela et aujourd'hui même, nous aurait-il fait entendre pareille promesse?'"
,"24":"C'est ainsi que la femme mit au monde un fils à qui elle donna le nom de Samson. Le garçon grandit et Yahvé le bénit;"
,"25":"l'esprit de Yahvé commença à s'emparer de lui au Camp-de-Dan, entre Soréa et Echtaol."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Samson descendit à Timna et il se trouva une femme parmi les filles des Philistins de Timna."
,"2":"Il remonta pour en informer son père et sa mère: 'J'ai vu une femme à Timna, leur dit-il, une fille des Philistins. Prenez-la moi comme épouse!'"
,"3":"Son père et sa mère lui dirent: 'Est-ce qu'il n'y a pas assez de filles dans notre clan et dans tout notre peuple, pour que tu ailles en prendre une chez les incirconcis, chez les Philistins?',Mais Samson répondit à son père: 'Prends-la moi, car celle-là me plaît.' "
,"4":"Son père et sa mère ne savaient pas que cela venait de Yahvé, qui voulait créer des problèmes aux Philistins (en ce temps-là, Israël était soumis aux Philistins)."
,"5":"Samson descendit donc vers Timna avec son père et sa mère. Comme il était allé aux vignobles de Timna, un jeune lion vint en rugissant à sa rencontre."
,"6":"Au même moment l'esprit de Yahvé s'empara de lui, il déchira le lionceau comme on déchire un chevreau, alors qu'il n'avait rien dans les mains. Il ne raconta rien de son exploit à son père ni à sa mère."
,"7":"Ensuite il descendit et parla à la femme, qui lui plut."
,"8":"Au bout de quelque temps il retourna à Timna pour la prendre. Il fit un détour pour voir le cadavre du lion: il y avait dans le corps du lion un essaim d'abeilles avec du miel."
,"9":"Il en prit dans ses mains et en mangea tout en marchant. Lorsqu'il arriva chez son père et sa mère, il leur en donna et ils en mangèrent, mais il ne leur dit pas qu'il avait trouvé ce miel dans le corps du lion."
,"10":"Quand le père de Samson descendit chez la femme, Samson donna un grand repas selon la coutume des jeunes gens."
,"11":"Comme on avait peur de lui, on lui trouva trente compagnons pour rester avec lui."
,"12":"Samson leur dit: 'Je vais vous proposer une devinette. Je vous donne les sept jours du festin pour trouver et, si vous la devinez, je vous donnerai trente tuniques et trente vêtements de rechange."
,"13":"Mais si vous ne me dites pas la solution, c'est vous qui me donnerez trente tuniques et trente vêtements de rechange.' Ils lui répondirent: 'Dis-nous ta devinette, que nous l'entendions.'"
,"14":"Samson leur dit: 'De celui qui mange est sorti ce qui se mange, et du plus fort est sorti le doux.',Durant trois jours ils furent incapables de résoudre cette devinette. "
,"15":"Alors, le quatrième jour, ils dirent à la femme de Samson: 'Fais du charme à ton mari pour qu'il t'explique la devinette, ou sinon nous te brûlerons, toi et la maison de ton père. Vous ne nous avez tout de même pas invités pour nous dépouiller!'"
,"16":"La femme de Samson se mit à pleurer à ses côtés: 'Tu n'as pour moi que de la haine, lui disait-elle, tu ne m'aimes pas. Tu ne m'as même pas expliqué cette devinette que tu as proposée aux fils de mon peuple!' Il lui répondit: 'Je ne l'ai expliquée, ni à mon père ni à ma mère, et tu voudrais que je te l'explique?'"
,"17":"Elle pleura ainsi pendant les sept jours que dura le festin, et le septième jour, comme il en était fatigué, il lui donna la solution. Mais elle, aussitôt, la donna à ceux de son peuple, "
,"18":"et le septième jour avant le coucher du soleil, les gens de la ville dirent à Samson: 'Quoi de plus doux que le miel, et quoi de plus fort que le lion?' Il leur répondit tout net: 'Si vous n'aviez pas labouré avec ma génisse, vous n'auriez pas trouvé ma devinette.'"
,"19":"L'esprit de Yahvé s'empara de lui et il descendit à Ashkélon. Là il tua trente hommes, il prit leurs dépouilles et donna leurs vêtements à ceux qui avaient expliqué la devinette. Puis, tout en colère, il retourna à la maison de son père."
,"20":"La femme de Samson fut alors donnée à l'un des jeunes qui lui avaient servi de compagnons."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Quelque temps plus tard, au moment de la moisson des blés, Samson alla voir sa femme avec un chevreau. Il dit: 'Je voudrais être avec ma femme, dans sa chambre.' Mais son beau-père lui refusa l'entrée. Il lui dit:"
,"2":"'J'ai pensé que tu avais de la haine pour elle, aussi l'ai-je donnée à ton compagnon. Sa jeune soeur est plus belle, elle sera ta femme à sa place.'"
,"3":"Alors Samson leur dit à tous: 'Cette fois, si je fais du mal aux Philistins, je ne leur devrai rien.'"
,"4":"Samson alla attraper trois cents renards. Il prit des torches et il attacha les renards deux par deux par la queue, en plaçant une torche entre deux."
,"5":"Ensuite il alluma les torches et lâcha les renards dans les moissons des Philistins. C'est ainsi qu'il brûla tout: les meules, les épis sur pied, jusqu'aux vignes et aux oliviers."
,"6":"Les Philistins demandèrent: 'Qui a fait cela?' On leur répondit: 'C'est Samson, le gendre de l'homme de Timna, parce que ce dernier a repris sa femme et l'a donnée à son camarade.' Alors les Philistins montèrent et brûlèrent la femme avec son père."
,"7":"Samson leur dit: 'C'est ainsi que vous agissez? Eh bien moi, je n'arrêterai que lorsque je me serai vengé de vous.'"
,"8":"Il leur administra une incroyable volée, puis il descendit pour séjourner dans la faille du Rocher d'Etam."
,"9":"Les Philistins firent une incursion. Ils campèrent en territoire de Juda et s'infiltrèrent du côté de Léhi."
,"10":"Les hommes de Juda leur dirent: 'Pourquoi êtes-vous montés contre nous?' Ils répondirent: 'Nous sommes montés pour lier Samson et le traiter comme il nous a traités.'"
,"11":"Trois mille hommes de Juda descendirent à la caverne du Rocher d'Etam pour dire à Samson: 'Ne sais-tu pas que les Philistins sont nos maîtres? Qu'as-tu fait?',Il leur répondit: 'Je les ai traités comme ils m'ont traité.' "
,"12":"Les hommes de Juda lui dirent: 'Nous sommes descendus pour te lier et te livrer entre les mains des Philistins.' Samson leur dit: 'Jurez-moi que vous ne me tuerez pas!'"
,"13":"Ils lui répondirent: 'Non, nous allons te lier et te livrer entre leurs mains, mais nous ne te tuerons pas.' Ils le ligotèrent donc avec deux cordes neuves et le ramenèrent du Rocher d'Etam."
,"14":"Comme il arrivait près de Léhi, les Philistins vinrent à sa rencontre en poussant des cris de joie. Alors l'esprit de Yahvé s'empara de lui. Les cordes qui étaient sur ses bras devinrent pour lui comme des fils de lin brûlés, et ses liens se défirent de ses mains."
,"15":"Il trouva là une mâchoire d'âne toute fraîche, il la ramassa et assomma mille Philistins."
,"16":"Alors Samson s'écria: 'Avec la mâchoire d'un âne, je les ai bien rossés. Avec la mâchoire d'un âne, j'en ai assommé mille.'"
,"17":"Lorsqu'il eut fini de parler, il jeta la mâchoire et appela cet endroit Ramat-Léhi."
,"18":"Comme il avait très soif, il invoqua Yahvé et lui dit: 'Tu as accordé à ton serviteur une bien grande victoire, mais tu vois que je meurs de soif et je vais tomber entre les mains des incirconcis.'"
,"19":"Alors Dieu fendit la caverne qui se trouve à Léhi: il en sortit de l'eau et il but. Il se ranima et il retrouva ses forces. C'est pour cela qu'on appelle cette source du nom de En-Ha-Koré; on la voit encore aujourd'hui à Léhi."
,"20":"Il jugea Israël pendant vingt ans, au temps des Philistins."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Samson descendit à Gaza. Il y rencontra une prostituée et entra chez elle."
,"2":"On le dit aux gens de Gaza: 'Samson est venu ici!' Ils organisèrent des rondes et restèrent à l'affût toute la nuit à la porte de la ville. Ils ne bougèrent pas de toute la nuit car ils disaient: 'Attendons-le jusqu'au matin, et alors nous le tuerons.'"
,"3":"Samson resta couché jusqu'à minuit. Au milieu de la nuit il se leva, saisit les battants de la porte de la ville avec leurs montants et les arracha avec la traverse. Il les mit sur son épaule et les emmena au sommet de la montagne en face d'Hébron."
,"4":"Après cela, il s'attacha à une femme de la vallée de Sorek qui s'appelait Dalila."
,"5":"Les chefs des Philistins vinrent la trouver et lui dirent: 'Fais-lui du charme et tâche de savoir d'où lui vient cette grande force et comment nous pourrions nous rendre maîtres de lui, le ligoter et le dompter. Chacun de nous est prêt à te donner onze cents sicles d'argent.'"
,"6":"Dalila demanda à Samson: 'Dis-moi, je te prie, d'où vient ta force extraordinaire? Ne serait-il pas possible de te ligoter et de te dompter?'"
,"7":"Samson lui dit: 'Si l'on me liait avec sept cordes neuves qui ne sont pas encore sèches, je perdrais ma force et je serais comme un homme quelconque.'"
,"8":"Les chefs des Philistins lui apportèrent sept cordes neuves qui n'étaient pas encore sèches, et elle le ligota;"
,"9":"elle avait caché des hommes dans sa chambre. Elle lui cria: 'Les Philistins sont sur toi, Samson!' D'un coup, il rompit les cordes comme se rompt le fil d'étoupe quand il sent le brûlé: on n'eut donc pas le secret de sa force."
,"10":"Dalila dit à Samson: 'Tu t'es moqué de moi et tu m'as raconté des mensonges. Tu devrais bien me dire avec quoi il faudrait te lier.'"
,"11":"Il lui dit: 'Si on me liait avec des cordes neuves qui n'ont jamais servi, je perdrais ma force et je serais comme un homme quelconque.'"
,"12":"Dalila le lia avec des cordes neuves, puis elle dit: 'Les Philistins sont sur toi, Samson!' L'embuscade était prête dans la chambre, mais lui rompit les cordes comme du fil."
,"13":"Dalila dit à Samson: 'Maintenant encore tu t'es moqué de moi et tu m'as raconté des mensonges. Dis-moi donc avec quoi il faudrait te lier.' Il répondit: 'Si tu tissais les sept tresses de ma chevelure dans la chaîne d'un tissu, si tu les serrais à l'aide d'un peigne de tisserand, je perdrais ma force et je serais comme un homme quelconque.'"
,"14":"Elle l'endormit donc, tissa les sept tresses de sa chevelure avec la chaîne d'un tissu, elle les serra à l'aide d'un peigne de tisserand et lui dit: 'Les Philistins sont sur toi, Samson!' Il se réveilla de son sommeil, arracha le peigne, la navette et la chaîne."
,"15":"Alors elle lui dit: 'Comment peux-tu dire que tu m'aimes? Ton coeur n'est pas avec moi, puisque par trois fois tu t'es moqué de moi et tu ne m'as pas dit d'où venait ta grande force.'"
,"16":"Comme tous les jours elle le fatiguait et le harcelait avec les mêmes questions, il crut qu'il allait en mourir."
,"17":"Alors il lui ouvrit le plus secret de son coeur. Il lui dit: ' Je suis consacré à Dieu depuis le sein de ma mère, et le rasoir n'est jamais passé sur ma tête. Si j'étais rasé, ma force se retirerait de moi et je deviendrais aussi faible que n'importe qui.'"
,"18":"Cette fois, Dalila vit qu'il lui avait dévoilé les secrets de son coeur. Elle envoya chercher les chefs des Philistins et leur dit: 'Venez cette fois, car il m'a dévoilé le plus secret de son coeur.' Les chefs des Philistins se rendirent chez elle et ils avaient en main l'argent."
,"19":"Après avoir endormi Samson sur ses genoux, elle appela un homme qui rasa les sept tresses de sa tête et il commença à perdre ses forces: sa force s'était retirée de lui."
,"20":"Alors elle dit: 'Les Philistins sont sur toi, Samson!' Il se réveilla de son sommeil et il se dit: 'Je m'en sortirai comme les autres fois et je me dégagerai.' Mais il ne savait pas que Yahvé s'était retiré loin de lui."
,"21":"Les Philistins le saisirent et lui crevèrent les yeux. Ils le firent descendre à Gaza, le lièrent avec une double chaîne de bronze et le mirent à tourner la meule dans la prison."
,"22":"Cependant, après qu'il eût été rasé, sa chevelure se mit à repousser."
,"23":"C'est alors que les chefs des Philistins se rassemblèrent pour offrir un grand sacrifice à Dagon leur dieu, et on fit la fête. Ils disaient: 'Notre dieu a livré entre nos mains notre ennemi Samson.'"
,"24":"Les gens du peuple le virent et ils louèrent leur dieu en disant: 'Notre dieu a livré entre nos mains notre ennemi, qui ravageait le pays et qui faisait tant de morts parmi nous.'"
,"25":"Quand ils furent tous bien joyeux, ils dirent: 'Appelez Samson et qu'il nous amuse!' On alla chercher Samson dans la prison et il fit des tours sous leurs yeux, puis on le plaça entre les colonnes."
,"26":"Samson dit alors au jeune homme qui le tenait par la main: 'Tu devrais me conduire: fais-moi toucher les colonnes sur lesquelles le temple est construit, que je puisse m'appuyer contre elles.'"
,"27":"Or le temple était rempli d'hommes et de femmes. Tous les chefs des Philistins étaient là, et sur la terrasse se tenaient environ trois mille hommes et femmes qui regardaient les jeux donnés par Samson."
,"28":"Alors Samson invoqua Yahvé et dit: 'Je t'en prie, Seigneur Yahvé! Souviens-toi de moi et rends-moi fort une dernière fois. Je voudrais d'un seul coup faire payer aux Philistins mes deux yeux!'"
,"29":"Samson toucha les deux colonnes du milieu, sur lesquelles le temple était construit, et il s'appuya sur elles: sur l'une de son bras droit, et sur l'autre de son bras gauche."
,"30":"Alors Samson s'écria: 'Que je meure avec les Philistins!' Puis de toute sa force il se raidit, et le temple s'effondra sur les chefs et sur tout le peuple qui s'y trouvait. Ceux qu'il entraîna avec lui dans la mort furent plus nombreux que ceux qu'il avait fait mourir durant toute sa vie."
,"31":"Ses frères et toute la famille de son père descendirent et l'emportèrent. Ils le remontèrent et l'enterrèrent entre Soréa et Echtaol, dans le tombeau de Manoa son père. Pendant vingt ans il avait jugé Israël."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Il y avait dans la montagne d'Ephraïm un homme du nom de Mika."
,"2":"Il dit à sa mère: 'Les onze cents pièces d'argent qu'on t'avait volées et au sujet duquel tu avais prononcé une malédiction, malédiction que j'ai entendue de mes propres oreilles, eh bien, cet argent est entre mes mains: c'est moi qui l'avais pris.' Sa mère s'empressa de dire: 'Que Yahvé bénisse mon fils!'"
,"3":"Il remit les onze cents pièces d'argent à sa mère, mais celle-ci lui dit: 'J'avais consacré moi-même cet argent à Yahvé pour mon fils, pour qu'il en fasse une idole et une statuette de bronze; tu peux donc le garder à présent.'"
,"4":"Mais lui rendit l'argent à sa mère. Sa mère préleva dessus deux cents pièces qu'elle donna au fondeur. Il en fit une idole et une statuette de bronze qui restèrent dans la maison de Mika."
,"5":"Cet homme, Mika, se fit un petit sanctuaire domestique. Il eut un éphod, des téraphim, puis il consacra l'un de ses fils pour qu'il soit son prêtre."
,"6":"En ces jours-là il n'y avait pas de roi en Israël et chacun faisait ce qui lui semblait bon."
,"7":"Il y avait alors à Bethléem de Juda un jeune Lévite qui résidait comme hôte dans ce clan de Juda."
,"8":"Un jour il quitta la ville de Bethléem de Juda pour aller se faire adopter là où il trouverait. Chemin faisant, il arriva à la maison de Mika dans la montagne d'Ephraïm."
,"9":"Mika lui dit: 'D'où viens-tu?' Il répondit: 'Je suis un Lévite de Bethléem de Juda et je cherche à m'installer comme hôte là où je trouverai.'"
,"10":"Mika lui dit: 'Reste chez moi, tu seras pour moi un père et un prêtre. Je te donnerai dix pièces d'argent par an, ainsi que l'habillement et la nourriture.' Le Lévite fut d'accord."
,"11":"Il accepta de rester chez cet homme et il devint pour lui comme l'un de ses fils."
,"12":"Mika consacra le Lévite et le jeune homme devint son prêtre, il servit dans la maison de Mika."
,"13":"Alors Mika pensa: 'Maintenant je sais que Yahvé me fera du bien, puisque j'ai pour prêtre un Lévite.'"
}`)
	CurrentBook.AddChapter(18, `{
"1":"En ces jours-là, il n'y avait pas de roi en Israël. C'était le moment où la tribu de Dan cherchait un territoire où s'installer, car jusqu'à ce jour ils n'avaient pas reçu d'héritage au milieu des tribus d'Israël."
,"2":"Les gens de Dan envoyèrent donc de chez eux cinq hommes de leur clan, des hommes solides de Soréa et d'Echtaol, pour faire une reconnaissance dans le pays et l'explorer. Ils leur dirent: 'Allez inspecter le pays.' Ceux-ci arrivèrent donc dans les monts dïm, près de la maison de Mika, et là ils passèrent la nuit."
,"3":"Comme ils étaient tout près de la maison de Mika, ils entendirent la voix du jeune Lévite et ils firent un détour. Ils le questionnèrent: 'Qui t'a amené ici? Que fais-tu en ce lieu? Qu'as-tu ici?'"
,"4":"Il leur répondit: 'Mika a fait pour moi ceci et cela, il me paie et je lui sers de prêtre.'"
,"5":"Ils lui dirent: 'Consulte donc Dieu pour que nous sachions si ce voyage que nous sommes en train de faire, réussira.'"
,"6":"Le prêtre leur dit: 'Allez en paix! Votre voyage est sous le regard de Dieu.'"
,"7":"Les cinq hommes s'en allèrent donc et ils arrivèrent à Laïch. Ils virent que les habitants vivaient sans crainte, selon l'habitude des Sidoniens, que la ville était paisible et confiante, sans roi pour la gouverner, qu'ils étaient loin des Sidoniens et n'avaient de liens avec personne."
,"8":"Quand ils retournèrent vers leurs frères à Soréa et Echtaol, ceux-ci leur demandèrent: 'Alors! Quelles nouvelles?'"
,"9":"Ils répondirent: 'Debout! Allons! Nous avons vu une terre magnifique! Mais quoi, vous restez là! Allez, en route, il faut nous emparer de cette région!"
,"10":"Vous trouverez là un peuple sans méfiance. Leur territoire est vaste et large, Dieu l'a livré entre vos mains. Rien ne manque là-bas de tout ce qu'on peut trouver sur la terre.'"
,"11":"Les Danites partirent donc de Soréa et Echtaol au nombre de six cents hommes équipés pour la guerre."
,"12":"Ils montèrent à Kiryat-Yéarim en Juda, où ils campèrent. C'est pour cela qu'on a appelé ce lieu Camp-de-Dan jusqu'à ce jour: il se trouve à l'ouest de Kiryat-Yéarim."
,"13":"De là ils partirent pour la montagne d'Ephraïm et arrivèrent près de la maison de Mika."
,"14":"Alors, les cinq hommes qui étaient allés reconnaître le pays jusqu'à Laïch, prirent la parole et dirent à leurs frères: 'Savez-vous qu'il y a dans l'une de ces maisons un éphod et des téraphim, une idole et une statuette de bronze? Pensez un peu à ce que vous devez faire.'"
,"15":"Ils firent un détour et entrèrent dans la maison de Mika. Le jeune Lévite était là et ils le saluèrent"
,"16":"tandis que les six cents hommes, les Danites en armes, se tenaient devant l'entrée de la porte."
,"17":"Les cinq hommes qui étaient allés reconnaître le pays, montèrent, entrèrent dans la maison, prirent l'idole, l'éphod, les téraphim et la statuette de bronze. Le prêtre était là à l'entrée de la porte avec les six cents hommes en armes."
,"18":"Voyant les cinq hommes qui entraient dans la maison de Mika, prenaient l'idole, l'éphod, les téraphim et la statuette de bronze, le prêtre leur dit: 'Qu'est-ce que vous faites là? '"
,"19":"Ils répondirent: 'Tais-toi! Mets ta main sur ta bouche et viens avec nous: tu seras pour nous un père et un prêtre. Que vaut-il mieux pour toi: être le prêtre d'un seul homme dans sa maison, ou être le prêtre de toute une tribu, de tout un clan en Israël?'"
,"20":"Le prêtre en eut la joie au coeur. Il prit l'éphod, les téraphim, l'idole, la statuette de bronze et se mit en route avec tous ces hommes."
,"21":"Au moment de reprendre leur marche ils avaient placé devant eux les petits enfants, le bétail et les bagages."
,"22":"Comme ils étaient déjà loin de la maison, les proches voisins de Mika s'attroupèrent et se lancèrent à la poursuite des Danites;"
,"23":"et ils criaient derrière eux. Les Danites se retournèrent et dirent à Mika: 'Pourquoi cet attroupement?' "
,"24":"Il leur répondit: 'Vous avez pris les dieux que je m'étais fabriqués, vous me prenez mon prêtre et vous partez! Que me reste-t-il? Et vous me demandez ce qu'il y a?'"
,"25":"Les Danites lui dirent: 'Arrête de crier sur nous, car des hommes agacés pourraient bien se jeter sur vous; toi et ta famille vous pourriez bien y laisser votre peau!'"
,"26":"Les Danites reprirent leur route et, voyant qu'ils étaient les plus forts, Mika fit demi-tour et revint à sa maison."
,"27":"Les Danites emmenèrent donc tout ce qu'avait fait Mika, ainsi que le prêtre qui était chez lui, et ils tombèrent à Laïch sur une population paisible et sans méfiance. Ils passèrent tout le monde au fil de l'épée et brûlèrent la ville."
,"28":"Il n'y eut personne pour la sauver, car Sidon était éloignée et eux n'avaient de lien avec personne. La ville en effet se trouve dans la plaine en direction de Beth-Réhob. Ils la reconstruisirent et s'y installèrent."
,"29":"Ils donnèrent à la ville le nom de Dan, en souvenir de leur père Dan, fils d'Israël; mais auparavant la ville s'appelait Laïch."
,"30":"Les Danites installèrent l'idole pour leur compte, et Yonathan, fils de Guerchom, fils de Moïse, et ses fils, furent prêtres pour la tribu de Dan jusqu'au jour de la déportation."
,"31":"Ils installèrent au milieu d'eux l'idole que Mika avait faite et cela dura aussi longtemps que la maison de Dieu à Silo."
}`)
	CurrentBook.AddChapter(19, `{
"1":"En ce temps-là, il n'y avait pas de roi en Israël. Un Lévite qui résidait à l'extrémité de la montagne d'Ephraïm, prit comme concubine une femme de Bethléem en Juda."
,"2":"Sa concubine lui fut infidèle et le quitta pour retourner dans la maison de son père, à Bethléem en Juda, où elle resta environ quatre mois."
,"3":"Son mari se mit en route pour aller la rejoindre, pour parler à son coeur et la ramener avec lui; il avait avec lui son serviteur et deux ânes. Elle le fit entrer dans la maison de son père et, dès que le père de la jeune femme l'aperçut, il vint tout heureux à sa rencontre. "
,"4":"Son beau-père, père de la jeune femme, le retint et il resta là trois jours avec lui. Ils mangèrent, ils burent et passèrent la nuit en ce lieu."
,"5":"Le quatrième jour, ils se levèrent de bonne heure et le Lévite se prépara pour partir. Mais le père de la jeune femme dit à son gendre: 'Prends des forces, mange un morceau de pain; ensuite vous partirez.'"
,"6":"Ils s'assirent donc, ils mangèrent et burent tous les deux. Alors le père de la jeune femme dit à son mari: 'Passe encore une nuit, prends un peu de bon temps!'"
,"7":"L'homme allait se lever pour partir, mais son beau-père insista tellement qu'il revint et passa encore la nuit en cet endroit."
,"8":"Le cinquième jour, quand il se leva de bon matin pour se mettre en route, le père de la jeune femme lui dit: 'Reprends donc des forces, attends la tombée du jour.' Ils mangèrent tous les deux."
,"9":"Comme le mari se levait pour partir avec sa concubine et son serviteur, son beau-père, le père de la jeune femme lui dit: 'Regarde! Le jour baisse, le soir ne tardera pas, passez donc ici la nuit. Prends un peu de bon temps; demain vous vous lèverez de bonne heure et vous vous mettrez en route pour rejoindre ta tente.'"
,"10":"Mais le mari ne voulut pas passer une nuit de plus. Il se mit en route avec ses deux ânes chargés et sa concubine en direction de Jébus (c'est Jérusalem)."
,"11":"Lorsqu'ils furent près de Jébus, le jour avait beaucoup baissé et le serviteur dit à son maître: 'Tu devrais quitter la route et entrer dans cette ville des Jébuséens, nous y passerons la nuit.'"
,"12":"Mais son maître lui répondit: 'Nous n'entrerons pas dans une ville étrangère: ces gens-là ne sont pas des Israélites. Allons plutôt jusqu'à Guibéa.'"
,"13":"Il ajouta: 'Dépêchons-nous d'atteindre l'une de ces villes, Guibéa ou Rama, pour y passer la nuit.'"
,"14":"Ils passèrent donc, continuèrent leur route et arrivèrent près de Guibéa de Benjamin lorsque le soleil se couchait."
,"15":"Quittant la route, ils entrèrent dans Guibéa pour y passer la nuit. Le Lévite alla s'asseoir sur la place, mais personne ne les invita à passer la nuit dans sa maison."
,"16":"Un homme âgé rentrait en fin de journée de son travail aux champs. Cet homme était de la montagne d'Ephraïm, il résidait à Guibéa où les habitants étaient de la tribu de Benjamin."
,"17":"Levant les yeux, il aperçut l'homme de passage assis sur la place de la ville. Le vieillard dit au Lévite: 'Où vas-tu et d'où viens-tu?' "
,"18":"Il répondit: 'Nous venons de Bethléem en Juda et nous allons vers les confins de la montagne d'Ephraïm, car je suis de là-bas. J'étais allé jusqu'à Bethléem en Juda et je retourne chez moi, mais personne ne m'a reçu dans sa maison."
,"19":"J'ai pourtant de la paille et du fourrage pour nos ânes, du pain et du vin pour moi, pour ma femme et pour mon serviteur. Nous n'avons besoin de rien.'"
,"20":"L'homme âgé lui dit alors: 'Ne t'inquiète pas, je te donnerai ce dont tu as besoin, mais ne passe pas la nuit sur la place.'"
,"21":"Il le fit entrer dans sa maison et donna du fourrage aux ânes pendant que les voyageurs se lavaient les pieds. Ils mangèrent et burent."
,"22":"Tout semblait aller bien lorsque les hommes de la ville, de vrais voyous, entourèrent la maison et frappèrent à la porte. Ils dirent au vieillard, au maître de maison: 'Fais sortir cet homme qui est venu chez toi, pour que nous abusions de lui.'"
,"23":"Le maître de maison sortit pour leur parler; il leur dit: 'Non, mes frères, je vous en prie! Ne faites pas de mal. Vous voyez que cet homme est maintenant sous mon toit, ne commettez pas une chose pareille."
,"24":"J'ai une fille qui est encore vierge, et il y a aussi sa concubine. Je vous les amènerai dehors, vous pourrez les violer et les traiter comme bon vous semblera, mais ne commettez pas une chose aussi ignoble envers cet homme.'"
,"25":"Les autres refusèrent de l'écouter. Alors le Lévite prit sa concubine et la leur amena dehors. Ils la violèrent et abusèrent d'elle toute la nuit jusqu'au petit matin; à l'aube ils la laissèrent aller."
,"26":"La femme revint au petit matin et s'écroula devant la porte de la maison où logeait son mari. Elle resta là jusqu'au lever du jour."
,"27":"Alors son mari se leva, ouvrit la porte de la maison et sortit pour reprendre sa route. Sa concubine était étendue devant la porte de la maison, les mains sur le seuil."
,"28":"Il lui dit: 'Lève-toi et partons.' Mais il n'y eut pas de réponse. L'homme alors la chargea sur son âne et se mit en route pour retourner chez lui."
,"29":"Rentré chez lui, il prit un couteau, saisit le corps de sa concubine et la découpa, os par os, en douze morceaux qu'il envoya à travers tout le territoire d'Israël. Il avait donné cet ordre aux hommes qu'il envoyait: 'Vous demanderez partout en Israël: A-t-on jamais vu cela depuis que les Israélites sont montés du pays d'Egypte jusqu'à ce jour? Réfléchissez, tenez conseil et donnez votre avis.'"
,"30":"Tous ceux qui voyaient cela disaient: 'On n'a jamais vu une chose pareille depuis que les fils d'Israël sont montés du pays d'Egypte jusqu'à ce jour.'"
}`)
	CurrentBook.AddChapter(20, `{
"1":"Tous les Israélites sortirent de chez eux, depuis Dan jusqu'à Bersabée, et la communauté se rassembla comme un seul homme auprès de Yahvé à Mispa. Même les gens de Galaad étaient là."
,"2":"Les chefs du peuple et toutes les tribus d'Israël participaient à cette assemblée du peuple de Dieu: c'étaient quatre cent mille hommes sachant manier l'épée."
,"3":"Les fils de Benjamin apprirent que les Israélites étaient montés à Mispa. Les Israélites dirent: 'Racontez-nous comment s'est commis ce crime?' "
,"4":"Alors le Lévite, le mari de la femme assassinée prit la parole et dit: 'Je suis entré à Guibéa de Benjamin avec ma concubine pour y passer la nuit,"
,"5":"et les propriétaires de Guibéa ont décidé de me faire du tort. Durant toute la nuit ils ont cerné la maison où je me trouvais avec l'intention de me tuer; ils ont fait violence à ma concubine de telle façon qu'elle en est morte."
,"6":"Alors j'ai pris ma concubine et je l'ai coupée en morceaux, je les ai envoyés par toutes les terres qui appartiennent à Israël, car ils ont fait quelque chose d'ignoble en Israël."
,"7":"Puisque vous êtes tous venus ici, tout Israël, traitez l'affaire et décidez ici-même.'"
,"8":"Tout le peuple se leva comme un seul homme et dit: 'Que nul d'entre nous ne se retire sous sa tente, que personne ne retourne à sa maison!"
,"9":"Voici comment nous allons procéder avec Guibéa. Nous allons tirer au sort"
,"10":"dix hommes sur cent dans toutes les tribus d'Israël, ou cent sur mille, ou mille sur dix mille. Ils iront chercher des vivres pour ceux qui partiront à Guibéa de Benjamin afin de la traiter comme elle le mérite, après le crime qu'elle a commis en Israël.'"
,"11":"C'est ainsi que les Israélites se rassemblèrent comme un seul homme face à la ville."
,"12":"Les tribus d'Israël envoyèrent des hommes dans tout le territoire de Benjamin pour dire: 'Quel est ce crime que l'on a commis chez vous?"
,"13":"Livrez-nous donc ces hommes, ces criminels de Guibéa, nous les mettrons à mort et nous éliminerons d'Israël le mal.' Mais les gens de Benjamin ne voulurent pas écouter la voix de leurs frères Israélites."
,"14":"Les Benjaminites arrivèrent de leurs villes et se rassemblèrent à Guibéa pour combattre les Israélites."
,"15":"On recensa ce jour-là les Benjaminites venus de leurs villes: vingt-six mille hommes de guerre. On les recensa à part des habitants de Guibéa."
,"16":"Il y avait dans cette armée sept cents hommes d'élites, des gauchers capables avec leur fronde de lancer une pierre au but sans le manquer d'un cheveu."
,"17":"On recensa aussi les Israélites sans les gens de Benjamin: quatre cent mille hommes sachant manier l'épée, tous des hommes de guerre."
,"18":"Ils se levèrent et montèrent à Béthel pour consulter Dieu. Les Israélites demandèrent: 'Qui d'entre nous montera le premier à l'attaque contre les gens de Benjamin?' Yahvé répondit: 'Juda sera le premier.'"
,"19":"Les Israélites se levèrent de bon matin et établirent leur camp face à Guibéa."
,"20":"Ceux d'Israël prirent l'initiative et ils se rangèrent pour attaquer ceux de Benjamin qui étaient à Guibéa."
,"21":"Les gens de Benjamin sortirent alors de Guibéa et massacrèrent en ce jour-là vingt-deux mille hommes d'Israël"
,"23":"Les Israélites montèrent alors à Béthel et ils pleurèrent devant Yahvé jusqu'au soir. Puis ils consultèrent Yahvé en ces termes: 'Devons-nous recommencer à combattre nos frères de Benjamin?' Yahvé répondit: 'Attaquez-les!'"
,"22":"L'armée d'Israël reprit courage et de nouveau elle se rangea au même endroit que le premier jour."
,"24":"Les Israélites attaquèrent donc les Benjaminites,"
,"25":"mais en ce second jour encore, ceux de Benjamin sortirent de Guibéa à leur rencontre et tuèrent chez les Israélites dix-huit mille hommes sachant manier l'épée."
,"26":"Tous les Israélites et tout le peuple montèrent de nouveau à Bethel. Là, assis devant Yahvé, ils pleurèrent et jeûnèrent ce jour-là jusqu'au soir, puis ils offrirent à Yahvé des holocaustes et des sacrifices de communion."
,"27":"Les Israélites consultèrent Yahvé ce jour-là: en effet l'Arche de l'Alliance de Dieu se trouvait en ce lieu,"
,"28":"et Pinhas, fils d'Eléazar, fils d'Aaron, en avait la charge. Les Israélites demandèrent: 'Devons-nous une nouvelle fois attaquer nos frères de Benjamin, ou devons-nous renoncer?' Yahvé répondit: 'Montez, car demain je les livrerai entre vos mains.'"
,"29":"Israël plaça des hommes en embuscade autour de Guibéa."
,"30":"Quand les Israélites montèrent à l'attaque le troisième jour contre ceux de Benjamin, ils se rangèrent devant Guibéa comme les autres fois."
,"31":"Les Benjaminites firent alors une sortie pour rencontrer l'armée, et ils s'éloignèrent de la ville. Comme les autres fois ils commencèrent à massacrer des hommes de l'armée d'Israël (ils en tuèrent environ trente sur les routes qui vont à Béthel et à Guibéa par la campagne)."
,"32":"Les Benjaminites pensaient: 'Les voilà battus devant nous comme les autres fois.' Mais les Israélites s'étaient dit: 'Nous prendrons la fuite pour les attirer sur les routes loin de la ville.'"
,"33":"Tous les Israélites se regroupèrent et firent face à Baal-Tamar, au moment même où ceux de l'embuscade débouchaient du lieu où ils s'étaient postés à l'ouest de Guéba."
,"34":"C'étaient dix-mille hommes d'élite de l'armée d'Israël qui arrivaient sur Guibéa. La bataille fut rude et les Benjaminites ne savaient pas que le malheur allait les frapper."
,"35":"Car Yahvé donna la défaite à Benjamin devant Israël et, ce jour-là, les Israélites tuèrent vingt-cinq mille et cent hommes de Benjamin, tous habiles à manier l'épée."
,"36":"Les Benjaminites virent qu'ils étaient battus. Les Israélites ne leur avaient cédé du terrain que parce qu'ils comptaient sur l'embuscade qu'ils avaient placée contre Guibéa."
,"37":"En effet, les gens de l'embuscade se jetèrent sur Guibéa, se déployèrent et passèrent toute la ville au fil de l'épée."
,"38":"Les Israélites avaient convenu d'un signe avec ceux de l'embuscade: ces derniers feraient monter de la ville un nuage de fumée."
,"39":"Quand les Benjaminites leur avaient déjà tué une trentaine d'hommes et se disaient: 'Les voilà bien battus devant nous comme la dernière fois', à ce moment même les Israélites se retournèrent contre eux."
,"40":"Le signal de fumée s'élevait de la ville et, en se retournant, Benjamin aperçut la lueur qui montait vers les cieux: toute la ville était en flammes."
,"41":"Les hommes d'Israël attaquaient, et ce fut l'épouvante chez les Benjaminites; ils comprirent que le malheur tombait sur eux."
,"42":"Comme ils tentaient de s'enfuir devant les Israélites par les chemins du désert, la bataille les y rejoignit et ceux qui descendaient de la ville les massacrèrent."
,"43":"Benjamin fut cerné, harcelé, écrasé jusqu'à l'orient de Guibéa."
,"44":"Dix-huit mille hommes de Benjamin tombèrent, tous de courageux guerriers."
,"45":"Ceux qui purent s'échapper gagnèrent le désert vers le Rocher-de-Rimon. On en tua cinq mille sur les routes et deux mille parmi ceux que l'on poursuivit jusqu'à Guidéon."
,"46":"Le total des gens de Benjamin qui tombèrent ce jour-là, fut de vingt-cinq mille hommes sachant manier l'épée, tous de courageux guerriers."
,"47":"Ceux qui avaient pu s'échapper et qui s'étaient enfuis au désert vers le Rocher-de-Rimon y restèrent pendant quatre mois, ils étaient six cents."
,"48":"Quand les Israélites se retournèrent contre le peuple de Benjamin, ils passèrent tout au fil de l'épée: la ville, les hommes, le bétail et tout ce qui s'y trouvait. Ils mirent ensuite le feu à toutes les villes qu'ils rencontraient."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Les Israélites avaient fait ce serment à Mispa: 'Personne d'entre nous ne donnera sa fille comme femme à quelqu'un de Benjamin.'"
,"2":"Ils se réunirent à Bethel et restèrent devant Dieu jusqu'au soir avec des cris et de grandes lamentations. Ils disaient:"
,"3":"'Yahvé, notre Dieu, qu'est-il donc arrivé en Israël! Une tribu est manquante aujourd'hui!"
,"4":"Le lendemain le peuple se leva de bon matin; ils construisirent un autel et offrirent des holocaustes et des sacrifices de communion."
,"5":"Puis les Israélites dirent: 'Parmi toutes les tribus d'Israël, y en a-t'il une qui ne soit pas venue à l'assemblée devant Yahvé?' Car on avait fait un serment solennel: Si quelqu'un ne monte pas à Mispa devant Yahvé, il sera mis à mort."
,"6":"Les Israélites étaient fort affligés pour Benjamin leur frère, ils se disaient: 'Aujourd'hui une tribu a été retranchée d'Israël."
,"7":"Que pouvons-nous faire pour que ceux d'entre eux qui restent aient des femmes, puisque nous avons juré devant Yahvé de ne pas leur donner nos filles en mariage?'"
,"8":"C'est alors qu'ils demandèrent: 'Y en a-t'il une parmi toutes les tribus d'Israël, qui ne soit pas montée vers Yahvé à Mispa?',Ils virent que personne de Yabech en Galaad n'était venu à l'assemblée. "
,"9":"En effet, on avait recensé toute la population et il n'y avait là personne de Yabech en Galaad."
,"10":"La communauté envoya là-bas douze mille hommes, tous des gens solides, avec cet ordre: 'Allez! Vous passerez au fil de l'épée les habitants de Yabech en Galaad ainsi que les femmes et les petits enfants:"
,"11":"tout mâle et toute femme qui a eu des relations avec un homme sera voué à l'anathème, mais vous laisserez en vie celles qui sont vierges.' Ils firent ainsi."
,"12":"Ils trouvèrent dans la population de Yabech en Galaad quatre cents filles qui n'avaient pas eu de relations avec un homme, et ils les ramenèrent au camp établi à Silo, au pays de Canaan."
,"13":"Alors la communauté envoya prévenir les gens de Benjamin qui étaient au Rocher-de-Rimon et l'on fit la paix."
,"14":"Les Benjaminites revinrent donc et on leur donna les femmes de Yabech de Galaad qu'on avait laissées en vie. Mais il n'y en avait pas assez pour eux."
,"15":"De nouveau le peuple fut pris de pitié pour Benjamin, car Yahvé avait fait une brèche parmi les tribus d'Israël."
,"16":"Les anciens de la communauté dirent: 'Que pouvons-nous faire pour ceux qui restent, pour qu'ils aient des femmes, puisque les femmes de Benjamin ont été massacrées?'"
,"17":"Ils décidèrent ceci: 'Les survivants garderont toute la terre qui appartient à Benjamin, de façon qu'aucune tribu ne soit retranchée d'Israël."
,"18":"Cependant nous ne pouvons pas leur donner nos filles en mariage, puisque les Israélites ont fait ce serment: 'Maudit soit celui qui donnera sa fille à Benjamin.'"
,"19":"Alors ils pensèrent: 'C'est bientôt la fête de Yahvé, celle qui a lieu chaque année à Silo. (Silo est au nord de Bethel, à l'est de la route qui va de Bethel à Sichem et au sud de Lébona)'"
,"20":"Et ils firent cette proposition aux Benjaminites: 'Allez vous cacher dans les vignes."
,"21":"Lorsque vous verrez les filles de Silo sortir pour danser en choeurs, vous sortirez des vignes, vous enlèverez chacun une des filles de Silo et vous regagnerez le pays de Benjamin."
,"22":"Si jamais leurs pères ou leurs frères viennent se plaindre à nous, nous leur dirons: 'Laissez-les donc tranquilles, vous voyez bien que nous n'avons pu prendre une femme pour chacun d'eux au cours de la guerre. Ce n'est pas vous qui les leur avez données, donc vous n'avez pas été infidèles à votre serment.'"
,"23":"Les Benjaminites firent comme on leur disait pour prendre le nombre de femmes qui correspondait au leur. Ils les enlevèrent parmi celles qui étaient venues danser. Puis ils repartirent et retournèrent sur leurs terres. Là ils rebâtirent les villes et s'y installèrent."
,"24":"A ce moment-là les Israélites quittèrent les lieux et s'en allèrent, chacun dans sa tribu et son propre clan, sur leurs propres terres."
,"25":"En ce temps-là il n'y avait pas de roi en Israël et chacun faisait ce qui lui plaisait."
}`)

}
func FR_LBDCC_LoadVHIEChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Après la mort de Moïse, Yahvé parla à Josué, fils de Noun, l'adjoint de Moïse. Il lui dit:"
,"2":"'Moïse, mon serviteur, est mort. Toi, maintenant, traverse avec tout le peuple le Jourdain, et passe au pays que je donne aux Israélites."
,"3":"Comme je l'ai dit à Moïse, je vous donne tout endroit que foulera ton pied,"
,"4":"c'est à dire depuis ce désert jusqu'au Grand Fleuve, le fleuve de l'Euphrate. Tout le pays des Hittites jusqu'à la Grande Mer du côté du soleil couchant, sera votre territoire."
,"5":"Aussi longtemps que tu vivras, personne ne pourra te résister. Je serai avec toi comme j'ai été avec Moïse, je ne t'oublierai pas et je ne t'abandonnerai pas."
,"6":"Sois fort et sois courageux! C'est toi qui mettras ce peuple en possession du pays que j'ai juré à leurs pères de leur donner."
,"7":"Oui, sois fort et courageux! Veille à observer en tout point cette Loi que mon serviteur Moïse t'a donnée. Ne t'en écarte ni à droite ni à gauche, et tu réussiras partout où tu iras."
,"8":"Tu reliras constamment ce livre de la Loi. Jour et nuit tu le méditeras afin d'agir en toutes choses selon ce qui y est écrit: ainsi tu mèneras à bien tes entreprises et tu réussiras."
,"9":"Je t'ai bien donné cet ordre: Sois fort et courageux, ne tremble pas et n'aie pas peur; Yahvé ton Dieu est avec toi partout où tu iras.'"
,"10":"Josué donna cet ordre aux scribes du peuple:"
,"11":"'Circulez à travers le camp et donnez au peuple ces instructions: Préparez-vous des provisions, car dans trois jours vous traverserez le Jourdain pour aller conquérir le pays que Yahvé votre Dieu vous donne.'"
,"12":"Josué s'adressa alors à la tribu de Ruben, à celle de Gad et à la demi-tribu de Manassé:"
,"13":"'Souvenez-vous de ce que Moïse, le serviteur de Yahvé, vous a ordonné: Yahvé votre Dieu, a-t-il dit, veut votre repos et vous donne ce pays."
,"14":"Aussi, vous allez laisser vos femmes, vos petits enfants, et vos troupeaux dans le pays que Moïse vous a donné de l'autre côté du Jourdain, et vous, vous passerez en armes en avant de vos frères. Vous tous, qui êtes de courageux guerriers, vous les aiderez"
,"15":"jusqu'à ce que Yahvé ait donné le repos à vos frères, comme il l'a fait pour vous, le repos, et qu'ils possèdent eux aussi le pays que Yahvé votre Dieu leur donne. Alors seulement vous reviendrez sur les terres qui sont votre part, et elles seront à vous. C'est le pays que vous a donné Moïse, le serviteur de Yahvé, de l'autre côté du Jourdain, du côté du soleil levant.'"
,"16":"Ils répondirent à Josué: 'Nous ferons tout ce que tu nous as commandé et nous irons partout où tu nous enverras."
,"17":"Nous t'obéirons en toute chose, comme nous avons obéi à Moïse. Oui, puisse Yahvé ton Dieu être avec toi comme il l'a été avec Moïse."
,"18":"On mettra à mort celui qui ne t'obéira pas et ne tiendra pas compte de ce que tu lui commanderas; quant à toi, sois fort et courageux."
}`)
	CurrentBook.AddChapter(2, `{
"1":"De Chittim, Josué fils de Noun envoya secrètement deux espions. Il leur dit: 'Allez! Observez bien le pays et la ville de Jéricho.' Ils firent la route et entrèrent dans la maison d'une prostituée qui s'appelait Rahab; c'est là qu'ils couchèrent."
,"2":"On avertit le roi de Jéricho: 'Des hommes, des Israélites, sont entrés ici cette nuit, ils sont venus espionner le pays.'"
,"3":"Alors le roi de Jéricho envoya dire à Rahab: 'Fais sortir ces hommes qui t'ont approchée et qui sont entrés dans ta maison, car c'est pour espionner le pays qu'ils sont venus.'"
,"4":"Mais la femme alla cacher les deux hommes. Elle répondit: 'Ces hommes sont bien venus chez moi, mais je ne savais pas d'où ils étaient."
,"5":"Ils sont partis à la tombée de la nuit, quand on fermait la porte de la ville, et je ne sais pas où ils sont allés. Lancez-vous vite à leur poursuite et vous les rattraperez.'"
,"6":"En réalité, elle les avait fait monter sur sa terrasse et les avait cachés sous des tiges de lin qu'elle y avait déposées."
,"7":"Les gens se lancèrent à leur poursuite dans la direction du Jourdain, du côté des gués, et dès qu'ils furent sortis on ferma la porte de la ville."
,"8":"Les deux hommes n'étaient pas encore couchés qu'elle les rejoignit sur sa terrasse."
,"9":"Elle leur dit: 'Je sais que Yahvé vous a livré le pays; vous avez semé la panique parmi nous et tous les gens du pays sont ter rorisés devant vous."
,"10":"On nous a dit comment Yahvé a desséché devant vous la mer des Roseaux lorsque vous sortiez d'Egypte, et ce que vous avez fait aux deux rois des Amorites de l'autre côté du Jourdain, à Sihon et à Og, que vous avez voués à l'anathème."
,"11":"Lorsque nous l'avons appris le coeur nous a manqué, et à votre approche tout le monde maintenant est saisi de peur, car Yahvé, votre Dieu, est Dieu là-haut dans les cieux et ici-bas sur la terre."
,"12":"Mais maintenant, puisque je vous ai fait une faveur, jurez-moi par Yahvé que vous ferez vous aussi une faveur à la maison de mon père. Donnez-moi donc la preuve de votre fidélité"
,"13":"et laissez vivre mon père, ma mère, mes frères, mes soeurs et tout ce qui leur appartient. Arrachez-nous à la mort.'"
,"14":"Les hommes répondirent: 'Nous te le jurons sur nos propres têtes: à condition que tu ne révèles pas notre conversation, nous te traiterons avec bonté et fidélité lorsque Yahvé nous aura livré le pays.'"
,"15":"Elle les fit descendre par la fenêtre avec une corde, car sa maison était construite contre le rempart et elle-même logeait dans le rempart."
,"16":"Elle leur dit: 'Fuyez vers la montagne pour que ceux qui vous poursuivent ne vous rencontrent pas. Vous y resterez cachés trois jours, jusqu'au retour de ceux qui vous poursuivent, ensuite vous irez votre chemin.'"
,"17":"Les hommes lui dirent: 'Nous respecterons le serment que nous t'avons fait."
,"18":"Lorsque nous entrerons dans le pays, tu attacheras ce cordon de fil rouge à la fenêtre par laquelle tu nous as fait descendre. Tu réuniras autour de toi dans ta maison, ton père, ta mère, tes frères et toute la famille de ton père."
,"19":"Si l'un d'entre eux ouvre la porte et sort de ta maison, il sera responsable de sa mort et nous, nous serons quittes, mais si l'on porte la main sur ceux qui sont avec toi dans ta maison, c'est nous qui serons responsables."
,"20":"Mais ne révèles pas notre accord, ou sinon nous serons quittes du serment que nous venons de faire.'"
,"21":"Elle leur dit: 'Qu'il en soit comme vous venez de le dire.' Elle les congédia et ils s'en allèrent; puis elle attacha le cordon rouge à sa fenêtre."
,"22":"Aussitôt partis, les hommes se dirigèrent vers la montagne. Ils y restèrent trois jours, jusqu'après le retour de ceux qui les poursuivaient. Ceux-ci avaient cherché partout tout au long de la route, et n'avaient rien trouvé."
,"23":"Les deux hommes alors redescendirent de la montagne et traversèrent le Jourdain. Ils se présentèrent alors à Josué, fils de Noun, et ils lui racontèrent toute leur aventure."
,"24":"Ils ajoutèrent: 'Yahvé a livré tout le pays entre nos mains; tous les habitants du pays sont pris de panique devant nous.'"
}`)
	CurrentBook.AddChapter(3, `{
"1":"De bon matin Josué se leva, avec tous les Israélites. Ils partirent de Chittim et arrivèrent au bord du Jourdain; ils y passèrent la nuit en attendant de traverser."
,"2":"Au bout de trois jours, les scribes passèrent à travers le camp,"
,"3":"et ils donnèrent au peuple ces instructions: 'Dès que vous verrez l'Arche de l'Alliance de Yahvé votre Dieu, avec les prêtres lévites qui la portent, vous quitterez l'endroit où vous êtes et vous la suivrez."
,"4":"Car vous ne connaissez pas la route par laquelle vous irez, c'est une route par laquelle vous n'êtes sûrement pas passés jusqu'ici. Entre vous et l'Arche, vous garderez une distance d'environ deux mille coudées, n'approchez pas d'elle.'"
,"5":"Josué dit au peuple: 'Sanctifiez-vous, car Yahvé demain fera des prodiges au milieu de vous.'"
,"6":"Josué dit encore aux prêtres: 'Portez l'Arche d'Alliance et passez en tête du peuple.' Ils levèrent donc l'Arche d'Alliance et passèrent en tête du peuple."
,"7":"Yahvé dit à Josué: 'Aujourd'hui je vais te grandir aux yeux de tout Israël, ils sauront que je suis avec toi comme j'ai été avec Moïse."
,"8":"Et toi, tu donneras cet ordre aux prêtres qui portent l'Arche de l'Alliance: Dès que vous arriverez au bord des eaux du Jourdain, vous vous arrêterez dans le Jourdain.'"
,"9":"Josué s'adressa aux Israélites: 'Approchez et écoutez les paroles de Yahvé votre Dieu!'"
,"10":"Puis il leur dit: 'Vous allez avoir ici la preuve que le Dieu vivant est au milieu de vous et qu'il dépouillera pour vous les Cananéens, les Hittites, les Hivvites, les Périsites, les Guirgachites, les Amorites et les Jébusites."
,"11":"L'Arche d'Alliance du Seigneur de toute la terre va maintenant traverser devant vous le Jourdain. ("
,"12":"Vous allez donc choisir douze hommes dans les tribus d'Israël, un par tribu.)"
,"13":"Et dès que la plante des pieds des prêtres qui portent l'Arche de Yahvé, le Seigneur de toute la terre, aura touché les eaux du Jourdain, les eaux du Jourdain qui descendent d'en-haut seront coupées et s'arrêteront en une seule masse.'"
,"14":"Lorsque le peuple quitta ses tentes pour traverser le Jourdain, les prêtres qui portaient l'Arche de l'Alliance se placèrent en tête du peuple."
,"15":"C'était le temps de la moisson, le Jourdain débordait partout de ses rives. Or, dès que ceux qui portaient l'Arche arrivèrent au Jourdain, dès que les pieds des prêtres qui portaient l'Arche touchèrent les eaux,"
,"16":"celles qui descendaient d'en-haut s'arrêtèrent et s'amassèrent à une très grande distance, à la hauteur d'Adam, la ville voisine de Sartan. Durant ce temps les eaux qui descendaient vers la mer de la Araba, la Mer Salée, s'écoulèrent car elles étaient coupées, de sorte que le peuple traversa en face de Jéricho."
,"17":"Les prêtres qui portaient l'Arche de l'Alliance de Yahvé se tinrent immobiles au sec, au milieu du Jourdain, jusqu'à ce que la nation eût fini de traverser. Israël passa à pied sec."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Quand toute la nation termina de traverser, Yahvé dit à Josué:"
,"2":"'Choisissez parmi vous douze hommes dans le peuple, un par tribu."
,"3":"Vous leur demanderez de prendre douze pierres au milieu du Jourdain, là où se sont arrêtés les pieds des prêtres. Vous les emporterez avec vous et vous les déposerez à l'endroit où vous passerez la nuit.'"
,"4":"Josué réunit les douze hommes qu'il avait choisis parmi les Israélites, un pour chaque tribu."
,"5":"Josué leur dit: 'Passez au milieu du Jourdain, et prenez chacun une pierre sur votre épaule selon le nombre des tribus d'Israël."
,"6":"Elles seront un signe pour vous, quand demain vos fils vous poseront cette question: Que signifient pour vous ces pierres?"
,"7":"Alors vous leur répondrez: Les eaux du Jourdain se sont séparées devant l'Arche de l'Alliance de Yahvé quand elle traversa le Jourdain. Pour toujours ces pierres en seront le rappel pour les Israélites.'"
,"8":"Les Israélites firent donc comme Josué l'avait ordonné. Ils prirent douze pierres au milieu du Jourdain, comme Yahvé l'avait dit à Josué, selon le nombre des tribus d'Israël, et ils les emportèrent avec eux pour les déposer à l'endroit où ils s'arrêtèrent."
,"9":"Josué fit dresser douze pierres au milieu du Jourdain, à l'endroit où s'étaient arrêtés les pieds des prêtres qui portaient l'Arche de l'Alliance, et elles y sont encore aujourd'hui."
,"10":"Les prêtres qui portaient l'Arche, s'étaient arrêtés au milieu du Jourdain jusqu'à ce qu'on ait fini de dire au peuple tout ce que Yahvé avait ordonné. Alors, tout le peuple se dépêcha de traverser."
,"11":"Lorsque tout le peuple eut achevé de traverser, l'Arche de Yahvé passa et les prêtres se mirent de nouveau en tête du peuple."
,"12":"Comme Moïse l'avait demandé, la tribu de Ruben, la tribu de Gad et la demi tribu de Manassé passèrent en armes en tête des Israélites."
,"13":"C'étaient environ quarante mille hommes qui formaient l'avant-garde de Yahvé et qui s'avançaient vers les Steppes de Jéricho."
,"14":"Ce jour-là Yahvé grandit Josué aux yeux de tout Israël, et on le craignit comme on avait craint Moïse durant toute sa vie."
,"15":"Yahvé dit à Josué:"
,"16":"'Donne aux prêtres qui portent l'Arche du Témoignage, l'ordre de remonter du Jourdain.'"
,"17":"Josué donna donc cet ordre aux prêtres: 'Remontez du Jourdain!'"
,"18":"Or lorsque les prêtres qui portaient l'Arche de l'Alliance de Yahvé remontèrent du Jourdain, lorsque les prêtres touchèrent de leurs pieds la terre ferme, les eaux du Jourdain revinrent à leur place et débordèrent comme les jours antérieurs sur leurs deux rives."
,"19":"C'était le dix du premier mois; le peuple remonta du Jourdain et dressa son camp à Guilgal, à l'orient de Jéricho."
,"20":"Josué fit dresser à Guilgal les douze pierres qu'il avait prises dans le Jourdain."
,"21":"Il dit ensuite aux Israélites: 'Lorsque demain vos fils demanderont à leurs pères ce que font ici ces pierres,"
,"22":"vous leur répondrez: C'est parce qu'Israël a traversé ce Jourdain à pied sec."
,"23":"Oui, Yahvé a mis à sec les eaux du Jourdain devant vous, jusqu'à ce que tout le monde ait traversé. Yahvé votre Dieu avait fait de même pour la mer des Roseaux: il l'avait mise à sec devant nous jusqu'à ce que tout le monde ait traversé."
,"24":"Que tous les peuples de la terre sachent donc combien est puissante la main de Yahvé! Quant à vous, craignez toujours Yahvé votre Dieu."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Tous les rois des Amorites qui se trouvaient à l'ouest du Jourdain, ainsi que les rois des Cananéens qui se trouvaient près de la mer, apprirent que Yahvé avait mis à sec les eaux du Jourdain devant les Israélites, jusqu'à ce que tout le monde soit passé. Alors ils perdirent courage, et tous furent saisis de panique à l'approche des Israélites."
,"2":"En ce temps-là Yahvé dit à Josué: 'Fais-toi des couteaux de silex pour circoncire de nouveau les Israélites.'"
,"3":"Josué se fit donc des couteaux de silex et il circoncit les Israélites sur la Colline des Prépuces."
,"4":"Voici pourquoi Josué fit cette circoncision: tout le peuple qui était sorti d'Egypte, tous les mâles, tous les hommes de guerre, étaient morts dans le désert au long de la route, après leur sortie d'Egypte."
,"5":"Tout le peuple de la sortie avait été circoncis, mais tous ceux nés dans le désert au long de la route, après la sortie d'Egypte, n'étaient pas circoncis."
,"6":"Les Israélites avaient marché quarante ans dans le désert jusqu'à la disparition des hommes de guerre qui étaient sortis d'Egypte, de toute cette génération qui n'avait pas écouté la voix de Yahvé. En effet, Yahvé l'avait juré: il ne leur ferait pas voir le pays qu'il avait promis à leurs pères de nous donner, pays où ruissellent le lait et le miel."
,"7":"Mais leurs fils étaient là à leur place et ils étaient incirconcis, car on ne les avait pas circoncis durant la route. Josué les circoncit."
,"8":"Quand fut terminée la circoncision de tout ce peuple, on resta sur place dans le camp jusqu'à la guérison."
,"9":"Yahvé dit alors à Josué: 'Aujourd'hui j'ai roulé loin de vous la honte de l'Egypte.' C'est pourquoi on donna à ce lieu le nom qu'il porte encore aujourd'hui: Guilgal."
,"10":"Les Israélites campèrent à Guilgal et, le soir du quatorzième jour du mois, ils célébrèrent la Pâque dans les steppes de Jéricho."
,"11":"Au lendemain de la Pâque, ils mangèrent des produits du pays, des pains sans levain et du grain grillé."
,"12":"La manne cessa le surlendemain, vu qu'ils mangeaient des produits du pays. Les Israélites n'eurent plus de manne; à partir de cette année-là ils mangèrent les produits du pays de Canaan."
,"13":"Comme Josué était proche de Jéricho, il leva les yeux et vit un homme debout devant lui, une épée nue à la main. Josué marcha vers lui et lui dit: 'Es-tu pour nous ou pour nos ennemis?'"
,"14":"Il répondit: 'Non! Je suis le chef de l'armée de Yahvé; à présent j'arrive.' Alors Josué tomba la face contre terre et se prosterna. Puis il lui dit: 'Que dit mon Seigneur à son serviteur?'"
,"15":"Le chef de l'armée de Yahvé répondit à Josué: 'Enlève la sandale de ton pied, car le lieu où tu te tiens est un lieu saint.' C'est ce que fit Josué."
}`)
	CurrentBook.AddChapter(6, `{
"1":"La ville de Jéricho était fermée à cause des Israélites; on l'avait fermée et personne n'en sortait, personne n'y entrait."
,"2":"Yahvé dit à Josué: 'Regarde! Je livre Jéricho entre tes mains avec son roi et ses meilleurs soldats."
,"3":"Vous, les hommes de guerre, vous allez faire le tour complet de la ville, et vous ferez de même chaque jour durant six jours."
,"4":"Sept prêtres porteront les sept trompettes des jubilés devant l'Arche. Le septième jour vous tournerez sept fois autour de la ville, ensuite les prêtres sonneront de la trompette."
,"5":"Lorsque le son de la corne de bélier se prolongera, tout le peuple poussera le grand cri de guerre. Alors la muraille de la ville s'effondrera sur place et tout le peuple ira à l'assaut chacun devant soi.'"
,"6":"Josué, fils de Noun, rassembla donc les prêtres et leur dit: 'Vous porterez l'Arche de l'Alliance, et sept prêtres porteront les sept trompettes des jubilés devant l'Arche de Yahvé.'"
,"7":"Puis, se tournant vers le peuple, il lui dit: 'Passez et faites le tour de la ville; les hommes en armes iront en avant de Yahvé.'"
,"8":"Lorsque Josué eut fini de parler au peuple, les sept prêtres qui portaient les sept trompettes des jubilés devant Yahvé, passèrent et sonnèrent de leur trompette; l'Arche de l'Alliance de Yahvé marchait derrière eux."
,"9":"Les hommes en armes marchaient en avant des prêtres qui sonnaient de la trompette, et l'arrière-garde marchait derrière l'Arche. On s'avançait au son des trompettes."
,"10":"Josué avait donné cet ordre au peuple: 'Ne poussez pas le cri de guerre! Qu'on ne vous entende pas, et que pas un mot ne sorte de votre bouche jusqu'au jour où je vous dirai: Criez! Alors, vous pousserez le cri de guerre.'"
,"11":"L'Arche de Yahvé s'avança autour de la ville. Elle en fit une fois le tour puis on rentra au camp où l'on passa la nuit."
,"12":"Le lendemain, de bon matin, Josué se leva ainsi que les prêtres qui portaient l'Arche de Yahvé."
,"13":"Les sept prêtres qui portaient les sept trompettes devant l'Arche de Yahvé, se mirent en route et sonnèrent de la trompette. Les hommes en armes marchaient devant eux et l'arrière-garde suivait l'Arche de Yahvé. On s'avançait au son des trompettes."
,"14":"Le second jour on fit encore une fois le tour de la ville puis on rentra au camp, et l'on fit ainsi pendant six jours."
,"15":"Le septième jour, alors que pointait l'aurore, on tourna de la même façon sept fois autour de la ville. Ce jour-là seulement on fit sept fois le tour de la ville."
,"16":"A la septième fois, lorsque les prêtres sonnèrent de la trompette, Josué dit au peuple: 'Poussez le cri de guerre! Yahvé vous a livré la ville!"
,"17":"On livrera à l'anathème, en l'honneur de Yahvé, la ville avec tout ce qui s'y trouve. Seule Rahab la prostituée sera épargnée avec ceux qui se sont rassemblés autour d'elle, dans sa maison, car elle a caché les espions que nous avions envoyés."
,"18":"Quant à vous, ne prenez rien de ce qui a été voué à l'anathème, car en prenant quelque chose qui a été voué à l'anathème, vous rendriez anathème le camp d'Israël et vous attireriez sur lui le malheur."
,"19":"Tout l'argent et tout l'or, tous les objets de bronze et de fer seront consacrés à Yahvé et entreront dans le trésor de Yahvé.'"
,"20":"Le peuple poussa donc le cri de guerre et l'on sonna de la trompette. Dès que le peuple entendit le son de la trompette, il poussa le grand cri de guerre et la muraille s'effondra sur place. Alors le peuple entra dans la ville, chacun devant soi et ils sèrent de la ville."
,"21":"A cause de l'anathème, on massacra tout ce qui était dans la ville: hommes et femmes, enfants et vieillards, même les boeufs, les moutons et les ânes."
,"22":"Josué dit aux deux hommes qui avaient espionné le pays: 'Entrez dans la maison de la prostituée et faites-en sortir cette femme avec tout ce qui lui appartient, comme vous le lui avez juré.'"
,"23":"Les jeunes gens qui avaient été envoyés en reconnaissance entrèrent donc et firent sortir Rahab, son père, sa mère et ses frères, avec toutes ses affaires. On installa toute la famille au-dehors du camp d'Israël."
,"24":"Ensuite on mit le feu à la ville et à tout ce qui s'y trouvait. Mais on déposa dans le trésor de la Maison de Yahvé, l'argent, l'or ainsi que les objets de bronze ou de fer."
,"25":"Josué laissa en vie Rahab la prostituée ainsi que la maison de son père et tout ce qui lui appartenait. Elle a habité au milieu d'Israël jusqu'à ce jour, car elle avait caché les espions que Josué avait envoyés pour explorer Jéricho."
,"26":"En ce temps-là Josué fit ce serment: 'Que Yahvé maudisse celui qui voudra rebâtir cette ville de Jéricho. Il en posera les fondements au prix de son premier-né, il en relèvera les portes au prix de son plus jeune fils.'"
,"27":"Yahvé était avec Josué, et sa renommée se répandit dans tout le pays."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Les Israélites commirent une grave infidélité au sujet de l'anathème. Akan, fils de Karmi, fils de Zabdi, fils de Zérah, de la tribu de Juda, prit des choses interdites par anathème, et la colère de Yahvé s'enflamma contre les Israélites."
,"2":"De Jéricho, Josué envoya des hommes vers Aï qui est à côté de Beth-Aven, à l'est de Béthel. 'Montez et explorez le pays', leur dit-il. Ces hommes allèrent reconnaître la ville de Aï."
,"3":"A leur retour ils dirent à Josué: 'Inutile de mobiliser tout le peuple; que deux ou trois mille hommes montent à Aï pour en faire la conquête, mais ne fatigue pas tout le peuple, car ses habitants sont peu nombreux.'"
,"4":"Environ trois mille hommes du peuple montèrent, mais les gens d'Aï les mirent en fuite."
,"5":"Les gens d'Aï leur tuèrent environ trente- six hommes, puis ils les poursuivirent depuis la porte de la ville jusqu'à Chébarim. Dans la descente ils les écrasèrent. Saisi de peur, le peuple perdit courage."
,"6":"Alors Josué déchira ses vêtements et se prosterna la face contre terre devant l'Arche de Yahvé jusqu'au soir. Lui et les anciens d'Israël jetèrent de la poussière sur leurs têtes."
,"7":"Josué dit alors: 'Ah! Seigneur Yahvé! Pourquoi as-tu fait traverser le Jourdain à ce peuple? Etait-ce pour nous livrer entre les mains des Amorites et nous faire périr? Pourquoi ne sommes-nous pas restés de l'autre côté du Jourdain?"
,"8":"Seigneur, Israël a tourné le dos devant ses ennemis: que puis-je dire de plus?"
,"9":"Les Cananéens et tous les gens du pays vont l'apprendre, ils nous encercleront et effaceront notre nom de ce pays. Que vas-tu faire pour l'honneur de ton grand Nom?'"
,"10":"Yahvé répondit à Josué: 'Debout! Pourquoi t'es-tu jeté la face contre terre?"
,"11":"Israël a péché, il a été infidèle à l'Alliance que je lui ai prescrite. On a pris des objets interdits par anathème, on les a volés, on a menti et on les a cachés dans les bagages."
,"12":"Les Israélites ne tiendront plus devant leurs ennemis, ils tourneront le dos devant leurs adversaires, car ils sont devenus anathèmes. Je ne serai plus avec vous tant que vous n'enlèverez pas l'anathème du milieu de vous."
,"13":"Tu vas donc sanctifier les Israélites. Tu leur diras: Sanctifiez-vous pour demain, car voici ce que dit Yahvé, le Dieu d'Israël: L'anathème est au milieu de vous, Israélites, et vous ne tiendrez pas devant vos ennemis jusqu'au jour où vous aurez ôté l'anathème du milieu de vous."
,"14":"C'est pourquoi demain vous vous approcherez par tribus. La tribu que Yahvé aura retenue s'approchera par familles, la famille que Yahvé aura retenue s'approchera par maisons, et la maison que Yahvé aura retenue s'approchera par têtes."
,"15":"Celui qui aura été ainsi désigné sera brûlé par le feu avec tout ce qui lui appartient, car il a été infidèle à l'Alliance de Yahvé et il a commis un crime en Israël.'"
,"16":"Le lendemain, Josué se leva de bon matin et fit approcher Israël, tribu par tribu. La tribu de Juda fut retenue."
,"17":"Il fit approcher les familles de Juda et la famille de Zérah fut retenue. Il fit approcher la famille de Zérah par maisons et la maison de Zabdi fut retenue."
,"18":"Il fit approcher la maison de Zabdi par têtes et Akan fils de Karmi, fils de Zabdi, fils de Zérah de la tribu de Juda, fut retenu."
,"19":"Alors Josué dit à Akan: 'Dis la vérité devant Yahvé, le Dieu d'Israël, mon fils! Rends-lui hommage! Dis-moi ce que tu as fait et ne me cache rien.'"
,"20":"Akan répondit à Josué: 'C'est vrai, j'ai péché contre Yahvé, le Dieu d'Israël, et voici ce que j'ai fait:"
,"21":"Au milieu des dépouilles j'ai vu un beau manteau de Chinéar, deux cents pièces d'argent et un lingot d'or du poids de cinquante sicles. J'ai cédé à la tentation et je les ai pris. Ils sont cachés dans le sol au milieu de ma tente et l'argent est en-dessous.'"
,"22":"Josué envoya donc des hommes. Ils coururent vers la tente: tout était bien caché dans la tente et l'argent était dessous."
,"23":"Alors ils le retirèrent de la tente et l'apportèrent là où était Josué avec tout Israël. On déposa le tout devant Yahvé."
,"24":"Josué et tout Israël prirent Akan fils de Zérah, avec l'argent, le manteau, le lingot d'or, les fils et les filles d'Akan avec ses boeufs, ses ânes, ses brebis, sa tente et tout ce qui lui appartenait, et ils les conduisirent dans la vallée d'Akor."
,"25":"Alors Josué lui dit: 'Pourquoi as-tu attiré sur nous le malheur? Que Yahvé, aujourd'hui, fasse passer sur toi le malheur.' Et tout Israël le lapida. On les brûla par le feu et on les lapida."
,"26":"On éleva sur Akan un grand tas de pierres qui est encore là aujourd'hui, et Yahvé revint de l'ardeur de sa colère. Voilà pourquoi, jusqu'à ce jour, on appelle cet endroit: la vallée d'Akor."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Yahvé dit à Josué: 'Ne crains pas, n'aie pas peur! Prends avec toi tous les hommes de guerre, et allez attaquer Aï. Sache que j'ai livré entre tes mains le roi d'Aï et son peuple, sa ville et son territoire."
,"2":"Tu traiteras Aï et son roi comme tu as traité Jéricho et son roi, mais vous pourrez prendre le butin: ses dépouilles et son bétail. Prépare donc maintenant une embuscade derrière la ville.'"
,"3":"Josué se leva avec tous les hommes de guerre pour attaquer Aï, Josué choisit trente mille hommes, de courageux guerriers, et les envoya de nuit."
,"4":"Il leur donna cet ordre: 'Postez-vous en embuscade tout près de la ville, à l'arrière de celle-ci. Ne soyez pas trop loin et restez à l'affût."
,"5":"Moi et tout le peuple qui est avec moi, nous nous approcherons de la ville et, quand ils sortiront à notre rencontre comme l'autre fois, nous fuirons devant eux."
,"6":"Ils sortiront donc derrière nous et nous les attirerons loin de la ville. Car ils se diront sûrement que nous fuyons devant eux comme l'autre fois."
,"7":"A ce moment-là vous sortirez de votre embuscade et vous occuperez la ville, puisque Yahvé votre Dieu la livre entre vos mains."
,"8":"Lorsque vous aurez pris la ville, vous y mettrez le feu: voilà mes ordres!'"
,"9":"Josué les envoya donc et ils partirent se poster en embuscade entre Béthel et Aï, à l'ouest d'Aï."
,"10":"De bon matin Josué se leva et passa le peuple en revue. Puis, avec les anciens d'Israël, il s'avança contre Aï, à la tête du peuple."
,"11":"Tous les hommes de guerre qui étaient avec lui firent la montée, s'approchèrent et arrivèrent face à Aï. Ils campèrent au nord de la ville, laissant la vallée entre eux et Aï."
,"12":"Josué prit alors cinq mille hommes et les posta en embuscade entre Béthel et Aï, à l'ouest de la ville."
,"13":"Le peuple avait établi son camp au nord de la ville, et l'embuscade était à l'ouest de Aï. Josué passa la nuit avec le peuple."
,"14":"Voyant cela, le roi d'Aï se leva de bon matin et sortit avec tout son peuple à la rencontre d'Israël pour l'attaquer dans la descente qui mène à la Araba. Ils ne savaient pas qu'une embuscade était préparée contre eux derrière la ville."
,"15":"Josué et tout Israël se laissèrent enfoncer par eux, et ils battirent en retraite par la route du désert."
,"16":"Alors tous les gens qui étaient dans la ville se rassemblèrent pour les poursuivre; ils poursuivirent Josué et se laissèrent attirer loin de la ville."
,"17":"Finalement il ne resta plus personne dans Aï; tout le monde poursuivait Israël. On avait même laissé la ville ouverte quand on s'était lancé à la poursuite d'Israël."
,"18":"Yahvé dit alors à Josué: 'Brandis vers Aï le javelot que tu as dans la main, et je vais la livrer entre tes mains.' Josué tendit donc vers la ville le javelot qu'il portait à la main,"
,"19":"et dès qu'il eut fait le geste, ceux qui étaient en embuscade surgirent du lieu où ils se trouvaient. Ils coururent, entrèrent dans la ville et la prirent, puis ils mirent le feu à la ville."
,"20":"En se retournant, les hommes d'Aï virent la fumée qui montait de la ville vers le ciel. Ils ne savaient plus par où s'échapper, car le peuple qui tout à l'heure fuyait vers le désert, se retournait maintenant contre eux et les poursuivait."
,"21":"Josué et tout Israël avaient vu que ceux qui étaient en embuscade s'étaient emparés de la ville, car la fumée montait de la ville. Ils revinrent donc et écrasèrent les hommes d'Aï."
,"22":"Ceux-ci se retrouvèrent avec des Israélites des deux côtés, car ceux de l'embuscade sortaient maintenant de la ville à leur rencontre. On les écrasa sans leur laisser un survivant, ni un fuyard."
,"23":"Les Israélites prirent vivant le roi d'Aï et le conduisirent à Josué."
,"24":"Israël acheva de massacrer tous les habitants d'Aï qu'il poursuivait dans la campagne ou dans le désert: tous périrent par l'épée, jusqu'au dernier. Ensuite Israël revint vers Aï et passa la ville au fil de l'épée."
,"25":"Le total de ceux qui tombèrent ce jour-là, hommes ou femmes, fut de douze mille, tous habitants d'Aï."
,"26":"Josué ne ramena sa main qui brandissait le javelot que lorsque tous les habitants d'Aï eurent été voués à l'anathème."
,"27":"Alors les Israélites prirent pour eux le bétail et le butin de la ville, comme Yahvé l'avait ordonné à Josué."
,"28":"Josué brûla Aï et il en fit pour toujours un tas de ruines, comme on le voit encore aujourd'hui."
,"29":"Il fit pendre à un arbre le roi d'Aï et le laissa là jusqu'au soir. Au coucher du soleil Josué commanda de descendre le cadavre de l'arbre; on le jeta à l'entrée de la porte de la ville et on éleva sur lui un grand tas de pierres qui se voit encore aujourd'hui."
,"30":"Josué dressa alors sur le mont Ebal, un autel en l'honneur de Yahvé, le Dieu d'Israël,"
,"31":"C'était un autel de pierres brutes qui n'avaient pas été taillées par le fer, comme Moïse le serviteur de Yahvé l'avait ordonné aux Israélites, et comme il est écrit dans le livre de la Loi de Moïse. On disposa sur l'autel des holocaustes en l'honneur de Yahvé et l'on offrit des sacrifices de communion."
,"32":"Josué écrivit là sur les pierres une copie de la Loi que Moïse avait écrite en présence des Israélites."
,"33":"Tout Israël, avec ses anciens, ses scribes et ses juges, était là rangé sur les deux côtés de l'Arche, faisant face aux prêtres lévites qui portaient l'Arche de l'Alliance de Yahvé. L'étranger s'y mêlait avec l'homme du pays. Une moitié se tenait du côté du mont Garizim, l'autre moitié du côté du mont Ebal, selon l'ordre que Moïse, le serviteur de Yahvé, avait donné autrefois pour la bénédiction du peuple d'Israël."
,"34":"Josué lut toutes les paroles de la Loi, la bénédiction et la malédiction, comme il est écrit dans le livre de la Loi."
,"35":"Josué lut les instructions de Moïse, sans aucune exception, en présence de la communauté d'Israël, en présence des femmes, des enfants et des étrangers qui vivaient au milieu d'eux."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Les rois du pays au-delà du Jourdain apprirent tout cela. Aussitôt, dans la montagne comme dans la plaine, sur la côte de la Grande Mer comme dans les environs du Liban, les Hittites, Amorites, Cananéens, Périsites, Hivvites et Jébusites"
,"2":"se rassemblèrent pour attaquer ensemble Josué et Israël."
,"3":"Les habitants de Gabaon savaient comment Josué avait traité Jéricho et Aï,"
,"4":"ils eurent donc recours à une ruse. Ils prirent avec eux des provisions de voyage, mais c'étaient des sacs usés qu'ils mirent sur leurs ânes, des outres de vin râpées, crevées et réparées."
,"5":"Ils avaient à leurs pieds de vieilles sandales usées et rapiécées, sur eux des vêtements usagés, et le pain de leurs provisions était sec et tombait en miettes."
,"6":"Ils se rendirent près de Josué au camp de Guilgal, et voici ce qu'ils lui racontèrent ainsi qu'aux hommes d'Israël: 'Nous venons d'un pays lointain, faites donc alliance avec nous.' Les hommes d'Israël répondirent à ces Hivvites:"
,"7":"'Peut-être habitez-vous au milieu de nous? Comment pourrons-nous faire alors alliance avec vous?'"
,"8":"Mais ils répondirent à Josué: 'Nous sommes tes serviteurs!' Josué ajouta: 'Qui êtes-vous et d'où venez-vous?'"
,"9":"Ils répondirent: 'C'est la renommée de Yahvé, ton Dieu, qui nous a fait venir d'un pays très éloigné. Nous avons entendu parler de tout ce qu'il a fait en Egypte,"
,"10":"de tout ce qu'il a fait aux deux rois des Amorites au-delà du Jourdain, à Sihon, roi d'Heshbon et à Og, roi du Bashan qui étaient à Achtarot."
,"11":"Alors nos anciens et tous les habitants de notre pays nous ont dit: Prenez avec vous des provisions pour la route, allez au-devant d'eux et dites-leur: Nous sommes vos serviteurs, faites donc alliance avec nous."
,"12":"Regardez, notre pain était encore chaud quand nous l'avons pris dans nos maisons le jour où nous nous sommes mis en route pour venir vers vous, et maintenant le voilà sec, il tombe en miettes."
,"13":"Ces outres de vin étaient neuves quand nous les avons remplies, aujourd'hui elles sont déchirées. Voyez nos vêtements et nos sandales: ils sont usés, tellement le voyage a été long.'"
,"14":"Les hommes d'Israël partagèrent avec eux leurs provisions sans consulter l'oracle de Yahvé."
,"15":"Josué leur donna la paix et conclut avec eux une alliance qui leur garantissait la vie sauve, après quoi, les chefs de la communauté leur prêtèrent serment."
,"16":"Mais trois jours après la conclusion de cette alliance, ils apprirent que ces gens étaient des voisins et qu'ils habitaient au milieu d'eux."
,"17":"Les Israélites se mirent en route et le troisième jour ils atteignirent leurs villes. C'étaient Gabaon, Kéfira, Béérot et Kiryat-Yéarim."
,"18":"Les Israélites ne les mirent pas à mort, car les chefs de la communauté leur avaient prêté serment au nom de Yahvé, le Dieu d'Israël, mais toute la communauté murmura contre les chefs."
,"19":"Les chefs répondirent à la communauté: 'Nous leur avons fait un serment au nom de Yahvé, le Dieu d'Israël: maintenant, nous ne pouvons plus porter la main sur eux."
,"20":"Voici comment nous allons agir: nous les laisserons en vie pour ne pas attirer sur nous un fléau, à cause du serment que nous leur avons fait."
,"21":"Mais ils feront les corvées de toute la communauté, ils fendront le bois et iront puiser l'eau.' Voilà ce que décidèrent les chefs."
,"22":"Josué les réunit et leur dit: 'Pourquoi nous avoir menti? Vous avez dit que vous veniez de très loin, alors que vous habitez au milieu de nous."
,"23":"Maintenant vous êtes maudits, vous serez pour toujours esclaves, vous fendrez le bois et vous puiserez l'eau pour la Maison de mon Dieu.'"
,"24":"Ils répondirent à Josué: 'On nous avait fait savoir les instructions de Yahvé, ton Dieu, à Moïse son serviteur: Yahvé vous donnerait tout le pays et vous deviez exterminer devant vous tous ses habitants. Nous avions très peur pour nos vies et c'est pourquoi nous avons agi de la sorte."
,"25":"Maintenant nous sommes entre tes mains, traite-nous comme cela te paraîtra bon et juste.'"
,"26":"Josué ne les livra donc pas aux Israélites, ils ne furent pas mis à mort,"
,"27":"mais dès ce jour ils durent fendre le bois et puiser l'eau pour la communauté, pour l'autel de Yahvé, dans le lieu que lui-même devait choisir. Ils le font encore."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Adoni-Sédec, roi de Jérusalem, apprit que Josué s'était emparé d'Aï et lui avait jeté l'anathème: il avait traité Aï et son roi comme il avait traité Jéricho et son roi. Il sut aussi que les habitants de Gabaon, qui vivaient au milieu des Israélites, avaient fait la paix avec eux,"
,"2":"et il eut très peur. Car Gabaon était une grande ville, comme une capitale royale; elle était plus grande qu'Aï et ses hommes étaient tous entraînés."
,"3":"Aussi Adoni-Sédec, roi de Jérusalem, envoya-t-il dire à Hoham, roi d'Hébron, à Piréam, roi de Yarmout, à Yafia, roi de Lakish, et à Débir, roi d'Eglon:"
,"4":"'Montez chez moi et aidez-moi à frapper Gabaon, car elle a fait la paix avec Josué et les Israélites.'"
,"5":"Les cinq rois des Amorites se réunirent donc et se mirent en campagne avec toute leur armée: le roi de Jérusalem, le roi d'Hébron, le roi de Yarmout, le roi de Lakish, le roi d'Eglon. Ils campèrent face à Gabaon pour attaquer la ville."
,"6":"Les gens de Gabaon envoyèrent prévenir Josué au camp de Guilgal: 'Ne refuse pas ton secours à tes serviteurs, dépêche-toi de monter vers nous, car tous les rois des Amorites habitant la montagne se sont ligués contre nous. Viens nous délivrer et sauve-nous.'"
,"7":"Josué monta donc de Guilgal, et avec lui tous les hommes de guerre, tous les courageux guerriers."
,"8":"Yahvé dit à Josué: 'Ne crains pas: je les ai livrés entre tes mains, et pas un ne te résistera.'"
,"9":"Josué les attaqua par surprise, car il était monté de Guilgal durant la nuit."
,"10":"Yahvé les mit en déroute devant Israël et leur infligea une grande défaite à Gabaon. Josué les poursuivit sur la route qui monte à Beth-Horon et les frappa jusqu'à Azéka et Makkéda."
,"11":"Tandis qu'ils fuyaient devant Israël, Yahvé lança du haut du ciel comme de grosses pierres alors qu'ils atteignaient la descente de Beth-Horon, jusqu'à Azéka. Ils furent frappés à mort. Ceux qui moururent par les pierres de grêle furent plus nombreux que ceux qui tombèrent sous l'épée des Israélites."
,"12":"En ce jour où Yahvé livra l'Amorite entre les mains des Israélites, Josué se tourna vers Yahvé et s'écria devant tout Israël: 'Arrête-toi, soleil, sur Gabaon! Et toi, lune, sur la vallée d'Ayyalon!'"
,"13":"Et le soleil s'arrêta et la lune devint immobile, jusqu'à ce que le peuple se fut vengé de ses ennemis. Cela n'est-il pas écrit dans le Livre du Juste? Le soleil s'arrêta au milieu des cieux et retarda son coucher durant presque un jour entier."
,"14":"Il n'y a pas eu d'autre jour comme celui-là, ni avant ni après, où Yahvé ait écouté la voix d'un homme. Yahvé, ce jour-là, combattait pour Israël."
,"15":"Josué et tout Israël retournèrent à leur camp, à Guilgal."
,"16":"Or les cinq rois qui étaient en fuite, s'étaient cachés dans la grotte de Makkéda."
,"17":"On avertit Josué: 'On a retrouvé les cinq rois! Ils sont cachés dans la grotte de Makkéda.'"
,"18":"Josué dit: 'Roulez de grandes pierres à l'entrée de la grotte et postez à côté d'elle des hommes pour la garder."
,"19":"Mais vous tous, ne vous arrêtez pas, poursuivez vos ennemis, coupez-leur la retraite; empêchez-les de regagner leur ville, car Yahvé votre Dieu les a livrés entre vos mains.'"
,"20":"Josué et les Israélites achevèrent de les écraser et de les exterminer; seuls quelques fuyards réussirent à rejoindre les villes fortifiées."
,"21":"Alors tout le peuple s'en retourna sans risque près de Josué, à Makkéda; plus personne désormais n'osa lever le petit doigt contre les Israélites."
,"22":"Josué avait dit: 'Ouvrez l'entrée de la grotte et amenez-moi ces cinq rois; faites-les sortir de la grotte.'"
,"23":"On fit donc sortir de la grotte les cinq rois: le roi de Jérusalem, le roi d'Hébron, le roi de Yarmout, le roi de Lakish et le roi d'Eglon."
,"24":"Quand on les eut fait sortir, Josué dit aux chefs de guerre qui avaient combattu avec lui: 'Approchez et posez vos pieds sur la nuque de ces rois.' Ils s'approchèrent donc et posèrent leurs pieds sur leur nuque."
,"25":"Josué leur dit alors: 'Ne craignez pas et n'ayez pas peur, soyez forts et courageux, car c'est ainsi que Yahvé traitera tous les ennemis contre lesquels vous devrez combattre.'"
,"26":"Après cela, Josué les frappa et les fit mourir. On les pendit à cinq arbres et ils y restèrent pendus jusqu'au soir."
,"27":"Au coucher du soleil, Josué donna l'ordre de les descendre des arbres. On les jeta dans la grotte où ils s'étaient cachés et l'on ferma l'entrée de la grotte avec les grandes pierres qui s'y trouvent encore aujourd'hui."
,"28":"Ce même jour, Josué s'empara de Makkéda et passa la ville au fil de l'épée. Il jeta l'anathème sur la ville et tous ses habitants et ne laissa pas un rescapé. Il traita le roi de Makkéda comme il avait traité le roi de Jéricho."
,"29":"Ensuite Josué et tout Israël avec lui, passa de Makkéda à Libna qu'il attaqua."
,"30":"Yahvé livra la ville et son roi entre les mains d'Israël. Il la frappa de l'épée ainsi que tous ses habitants, sans laisser échapper personne, et il traita son roi comme il avait traité le roi de Jéricho."
,"31":"Josué et tout Israël avec lui, passa de Libna à Lakish. Il établit son camp devant la ville et l'attaqua."
,"32":"Yahvé livra Lakish entre les mains d'Israël. Il s'en empara le second jour et la frappa de l'épée ainsi que tous ses habitants, comme il l'avait fait pour Libna."
,"33":"Alors Horam, roi de Guézer, partit au secours de Lakish mais Josué battit le roi et son peuple et ne laissa pas un seul survivant."
,"34":"Josué, à la tête de tout Israël, passa de Lakish à Eglon. Ils établirent leur camp devant la ville et l'attaquèrent."
,"35":"Ils s'en emparèrent le jour-même et la passèrent au fil de l'épée. Ce jour-là Josué jeta l'anathème sur tous les habitants comme il l'avait fait pour Lakish."
,"36":"Josué, à la tête de tout Israël, monta d'Eglon vers Hébron et l'attaqua."
,"37":"Ils s'en emparèrent; ils frappèrent de l'épée la ville, son roi, toutes les villes qui dépendaient de lui et tous leurs habitants, comme on l'avait fait pour Eglon, sans laisser un seul survivant. Josué voua la ville et tous ses habitants à l'anathème."
,"38":"Josué, à la tête de tout Israël, se tourna vers Débir pour l'attaquer."
,"39":"Il s'empara de la ville, de son roi et de toutes les villes qui dépendaient de lui. Il les frappa de l'épée et jeta l'anathème sur tous les habitants sans laisser un seul survivant. Il traita Débir et son roi comme il avait traité Hébron et comme il avait traité Libna et son roi."
,"40":"Ainsi donc, Josué frappa tout le pays et ses rois: la montagne, le Négueb, les plaines et les coteaux. Il ne laissa pas un seul survivant, car il jetait l'anathème sur tout être vivant comme Yahvé, le Dieu d'Israël, l'avait ordonné."
,"41":"Josué les frappa depuis Qadesh-Barné jusqu'à Gaza, et depuis le pays de Gossen jusqu'à Gabaon."
,"42":"Josué se rendit maître d'un seul coup de tous ces rois et de leurs territoires, car Yahvé, le Dieu d'Israël, combattait pour Israël."
,"43":"Alors Josué et tout Israël avec lui, regagna le camp de Guilgal."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Quand Yabin, roi d'Hasor, apprit tout cela, il avertit Yobab, roi de Mérom, le roi de Chimron, le roi d'Akchaf"
,"2":"et les rois qui habitaient la montagne au nord, la plaine de Kinnérot au sud, la plaine et les coteaux de Dor à l'ouest."
,"3":"Les Cananéens se trouvaient à l'est et à l'ouest; les Amorites, les Hittites, les Périsites et les Jébusites, dans la montagne; les Hivvites au pied de l'Hermon, dans le pays de Mispa."
,"4":"Ils se mirent en campagne avec toutes leurs armées, c'était un peuple aussi nombreux que le sable du bord des mers, avec une foule de chevaux et de chars."
,"5":"Tous ces rois se rassemblèrent et campèrent ensemble près des eaux de Mérom pour combattre Israël."
,"6":"Mais Yahvé dit à Josué: 'Ne les crains pas, car demain à cette heure je les livrerai blessés à mort à Israël. Tu couperas les jarrets de leurs chevaux et tu jetteras au feu leurs chars.'"
,"7":"Josué et tous ses hommes de guerre les attaquèrent par surprise aux eaux de Mérom; ils se jetèrent sur eux."
,"8":"Yahvé les livra entre les mains d'Israël qui les écrasa et les poursuivit jusqu'à Sidon-la-Grande et jusqu'aux eaux de Misréfot et la vallée de Mispa, à l'est. Il les écrasa si bien, qu'il n'y eut pas un seul survivant."
,"9":"Josué les traita comme Yahvé l'avait dit: il coupa les jarrets des chevaux et jeta au feu leurs chars."
,"10":"En ce temps-là, Josué revint et s'empara d'Hasor. Il frappa son roi de l'épée, car Hasor était autrefois la capitale de tous ces royaumes."
,"11":"On voua à l'anathème et on passa au fil de l'épée tous les êtres vivants qui s'y trouvaient; on ne laissa rien en vie dans Hasor qu'on incendia."
,"12":"Josué se rendit maître de toutes ces villes et de tous leurs rois. Il jeta sur elles l'anathème et les frappa de l'épée, comme Moïse, le serviteur de Yahvé, l'avait ordonné."
,"13":"Mais Israël ne brûla aucune des villes construites sur les collines, sauf Hasor que Josué incendia."
,"14":"Les Israélites ramassèrent pour eux tout le butin et le bétail de ces villes, mais ils passèrent au fil de l'épée toute la population jusqu'à extermination complète: il n'en resta pas un seul."
,"15":"Josué exécuta tout ce que Yahvé avait ordonné à Moïse son serviteur, et que Moïse avait transmis à Josué. Il n'oublia rien de tout ce que Yahvé avait ordonné à Moïse."
,"16":"Ainsi Josué s'empara de tout le pays: de la montagne, de tout le Négueb, de la région de Gossen, de la plaine, de la Araba, de la montagne d'Israël et de ses plaines,"
,"17":"depuis le mont Pelé qui se dresse du côté de Séïr jusqu'à Baal-Gad dans la vallée du Liban au pied de l'Hermon. Il captura tous les rois, les frappa et les mit à mort."
,"18":"Pendant de longs jours Josué lutta contre tous ces rois:"
,"19":"à part les Hivvites de Gabaon, pas une de ces villes ne fit la paix avec les Israélites."
,"20":"Tout cela venait de Yahvé. Ils devaient résister à Israël pour qu'ensuite Israël les voue à l'anathème et les détruise sans pitié comme Yahvé l'avait ordonné à Moïse."
,"21":"En ce temps-là, Josué revint pour exterminer les Anakim de la montagne, d'Hébron, de Débir, d'Anab, en un mot, de toute la montagne de Juda et de toute la montagne d'Israël: il les voua à l'anathème avec leurs villes."
,"22":"Il ne resta pas un seul Anakim dans le pays des Israélites, sauf à Gaza, à Gat et à Ashdod."
,"23":"Josué s'empara de tout le pays, comme Yahvé l'avait dit à Moïse, et il le distribua entre les tribus d'Israël pour qu'il soit leur héritage. Alors le pays se reposa de la guerre."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Voici les rois du pays que les Israélites avaient battus au-delà du Jourdain à l'est, depuis le torrent de l'Arnon jusqu'à la montagne de l'Hermon, avec toute la Araba à l'est (Israël s'était emparé de leurs territoires):"
,"2":"Sihon, roi des Amorites, qui habitait Heshbon. Son royaume commençait à Aroër, sur le bord de la vallée de l'Arnon; il comprenait le fond de la vallée, la moitié de Galaad jusqu'au Yabok, le torrent qui marque la frontière avec les Ammonites,"
,"3":"la Araba jusqu'à la mer de Kinnérot à l'est et jusqu'à la mer de la Araba ou Mer Salée à l'est, en direction de Beth-Ha-Yéchimot, et au sud, le bas des coteaux du Pisga."
,"4":"Og, roi du Bashan, un des derniers Réphaïm. Il résidait à Achtarot et à Edréï."
,"5":"Son royaume commençait au mont Hermon avec Salka; il comprenait tout le Bashan jusqu'à la frontière des Guéchourites et des Maakatites, et la moitié de Galaad jusqu'à la frontière de Sihon, roi de Heshbon."
,"6":"Moïse, le serviteur de Yahvé, et les Israélites les avaient vaincus, et Moïse avait donné leur territoire en possession à la tribu de Ruben, à celle de Gad et à la demi-tribu de Manassé."
,"7":"Voici la liste des rois du pays que Josué et les Israélites battirent de ce côté-ci du Jourdain, à l'ouest, depuis Baal-Gad dans la vallée du Liban jusqu'au mont Pelé qui se dresse à côté de Séïr. Josué distribua leurs terres et en fit l'héritage des tribus d'Israël,"
,"8":"que ce soit dans la montagne ou dans le Bas-Pays, dans la Araba ou sur les coteaux arrosés, au désert et au Négueb, chez les Hittites, les Amorites, les Cananéens, les Périsites, les Hivvites et les Jébusites:"
,"9":"Le roi de Jéricho, un; le roi d'Aï, à côté de Béthel, un;"
,"10":"le roi de Jérusalem, un; le roi d'Hébron, un;"
,"11":"le roi de Yarmout, un; le roi de Lakish, un;"
,"12":"le roi d'Eglon, un; le roi de Guézer, un;"
,"13":"le roi de Débir, un; le roi de Guéder, un;"
,"14":"le roi de Horma, un; le roi d'Arad, un;"
,"15":"le roi de Libna, un; le roi d'Adoullam, un;"
,"16":"le roi de Makkéda, un; le roi de Béthel, un;"
,"17":"le roi de Tapoua, un; le roi de Héfer, un;"
,"18":"le roi d'Afek, un; le roi de Saron, un;"
,"19":"le roi de Mérom, un; le roi de Hasor, un;"
,"20":"le roi de Chimron-Méron, un; le roi d'Akchaf, un;"
,"21":"le roi de Tanak, un; le roi de Méguiddo, un;"
,"22":"le roi de Qédesh, un; le roi de Yoknéam, au pied du Carmel, un;"
,"23":"le roi de Dor, sur les coteaux de Dor, un; le roi des nations en Galilée, un;"
,"24":"le roi de Tirsa, un; Ces rois sont en tout trente et un."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Josué avait déjà vécu de nombreux jours et il était très âgé lorsque Yahvé lui dit: 'Tu es devenu vieux, tu es déjà très âgé et il reste encore un grand pays à conquérir."
,"2":"Voici ce qui reste: tous les territoires des Philistins, tout le territoire des Guéchourites,"
,"3":"depuis le Chihor en face de l'Egypte jusqu'à la frontière d'Ekron au nord, que l'on considère comme le pays des Cananéens. (Les cinq petits royaumes Philistins sont: Gaza, Ashdod, Ashkélon, Gat et Ekron et les Avvites sont"
,"4":"au sud.) Puis tout le pays des Cananéens depuis Méara qui appartient à Sidon jusqu'à Aféka et jusqu'au territoire des Amorites;"
,"5":"le pays des Guiblites avec tout le Liban à l'est, depuis Baal-Gad au pied du mont Hermon jusqu'à l'Entrée-de-Hamat."
,"6":"Tous les habitants de la montagne, depuis le Liban jusqu'aux eaux de Misréfot et tous les Sidoniens, je les chasserai devant les Israélites, et tu n'auras qu'à partager le pays en héritage entre les Israélites, comme je te l'ai ordonné."
,"7":"Maintenant donc, partage ce pays pour qu'il devienne l'héritage des neuf tribus et de la demi- tribu de Manassé. Tu le leur donneras depuis le Jourdain jusqu'à la Grande Mer à l'ouest: la Grande Mer sera leur frontière."
,"8":"Moïse avait déjà donné leur héritage de l'autre côté du Jourdain à l'est, à l'autre demi-tribu de Manassé, à la tribu de Ruben et à celle de Gad. Voici ce que Moïse serviteur de Yahvé leur avait alors donné comme territoire:"
,"9":"depuis Aroër sur le versant de l'Arnon, la ville qui est au fond de la vallée, tout le plateau depuis Médba jusqu'à Dibon;"
,"10":"toutes les villes de Sihon, roi des Amorites qui régnait à Heshbon jusqu'à la frontière des Ammonites;"
,"11":"le Galaad et le territoire des Guéchourites et des Maakatites, tout le massif de l'Hermon, tout le Bashan jusqu'à Salka;"
,"12":"et dans le Bashan, tout le royaume de Og qui régnait à Achtarot et à Edréï et qui fut le dernier survivant des Réphaïm. Moïse avait vaincu et dépouillé ces deux rois."
,"13":"Cependant les Israélites ne dépossédèrent ni les Guéchourites ni les Maakatites, c'est pourquoi Guéchour et Maaka existent encore aujourd'hui au milieu d'Israël."
,"14":"La seule tribu à qui l'on ne donna pas d'héritage fut la tribu de Lévi, car Yahvé Dieu d'Israël est son héritage comme il le lui a dit."
,"15":"Moïse avait fait le partage entre les clans de la tribu de Ruben."
,"16":"Voici le territoire qu'ils reçurent: depuis Aroër sur le versant de l'Arnon, la ville qui est au fond de la vallée, tout le plateau jusqu'à Médba;"
,"17":"Heshbon avec toutes les villes qui sont sur le plateau: Dibon, Bamot-Baal, Beth-Baal-Méon,"
,"18":"Yahas, Kédémot, Méfaat,"
,"19":"Kiryatayim, Sibma et Séret-Ha-Chahar dans la montagne de la Araba;"
,"20":"Beth-Péor, les versants arrosés du Pisga, Beth-Ha-Yéchimot,"
,"21":"toutes les villes du plateau et tout le royaume de Sihon, roi des Amorites, (il avait été battu par Moïse avec les princes de Madian: Evi, Rékem, Sour, Hour et Réba qui étaient soumis à Sihon et qui habitaient le pays."
,"22":"Le devin Balaam, fils de Péor, faisait partie de ceux qui avaient été passés au fil de l'épée.)"
,"23":"La frontière de Ruben était donc le Jourdain et tout son territoire. Voilà l'héritage des clans de Ruben, avec leurs villes et leurs villages."
,"24":"Moïse avait fait le partage entre les clans de la tribu de Gad, les fils de Gad."
,"25":"Voici le territoire qu'ils reçurent: Yazer, toutes les villes de Galaad, la moitié du pays des Ammonites jusqu'à Aroër qui fait face à Rabba,"
,"26":"depuis Heshbon jusqu'à Ramat-Ha-Mispé et Bétonim, à partir de Mahanayim jusqu'au territoire de Lo-Débar,"
,"27":"dans la vallée: Beth-Haram, Beth-Nimra, Soukkoth, Safon, (tout cela formait la seconde moitié du royaume de Sihon, roi de Heshbon.) le Jourdain et le territoire qui s'étend jusqu'à l'extrémité de la mer de Kinnéret sur la rive est du Jourdain."
,"28":"Voilà l'héritage des clans de Gad, avec leurs villes et leurs villages."
,"29":"Moïse avait fait le partage entre les clans de la demi-tribu de Manassé."
,"30":"Voici le territoire qu'ils reçurent: à partir de Mahanayim, tout le Bashan, tout le royaume de Og roi du Bashan, tous les Douars de Yaïr dans le Bashan; au total soixante villes."
,"31":"Les fils de Makir, fils de Manassé, reçurent la moitié du Galaad avec Achtarot et Edréï, les capitales de Og de Bashan. Tel fut le territoire des clans de Makir."
,"32":"C'étaient là l'héritage que Moïse avait donné en héritage dans les Steppes de Moab, de l'autre côté du Jourdain, à l'est de Jéricho."
,"33":"Mais Moïse n'avait pas donné d'héritage à la tribu de Lévi, car Yahvé le Dieu d'Israël est son héritage, comme il le lui a dit."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Voici l'héritage des Israélites au pays de Canaan. Voici ce que le prêtre Eléazar, Josué fils de Noun, et les chefs des clans des tribus d'Israël leur donnèrent en héritage."
,"2":"On partagea l'héritage par le sort, comme Yahvé l'avait ordonné par la voix de Moïse, entre neuf tribus et demie."
,"3":"Moïse avait en effet donné un héritage aux deux tribus et demie de l'autre côté du Jourdain. Il n'avait pas donné d'héritage aux Lévites au milieu d'eux,"
,"4":"mais par ailleurs côté les fils de Joseph formaient deux tribus: Manassé et Ephraïm. Les Lévites ne reçurent rien d'autre que les villes où ils habitaient, avec les terres qui les entouraient, pour leurs troupeaux et leurs biens."
,"5":"Les Israélites partagèrent le pays en se conformant à l'ordre que Yahvé avait donné à Moïse."
,"6":"Les fils de Juda vinrent trouver Josué à Guilgal et Caleb, fils de Yéfouné le Kénizite, lui dit: 'Tu sais ce que Yahvé a dit à Moïse, l'homme de Dieu, à mon sujet et au tien, lorsque nous étions à Qadesh-Barné."
,"7":"J'avais quarante ans lorsque Moïse, le serviteur de Yahvé, m'envoya de Qadesh-Barné pour reconnaître le pays, et je lui ai fait mon rapport en toute sincérité."
,"8":"Alors que mes frères qui étaient montés avec moi décourageaient le peuple, je suis resté fidèle à Yahvé mon Dieu."
,"9":"C'est pourquoi ce jour-là Moïse a fait ce serment: Le pays que ton pied a foulé sera ton héritage et celui de tes descendants pour toujours, parce que tu as suivi fidèlement Yahvé mon Dieu."
,"10":"Cela fait quarante-cinq ans que Yahvé a adressé cette parole à Moïse alors qu'Israël marchait dans le désert, et Yahvé m'a conservé en vie comme il l'avait promis. J'ai maintenant quatre-vingt-cinq ans,"
,"11":"mais je suis encore aussi solide qu'au jour où Moïse m'a envoyé. Je suis aussi fort maintenant qu'autrefois, aussi bien pour combattre que pour aller et venir."
,"12":"Donne-moi donc cette montagne dont Yahvé a parlé ce jour-là. Tu l'as entendu toi-même alors: là se trouvent les Anakim, dans leurs villes grandes et fortifiées, mais Yahvé sera avec moi et je réussirai à les chasser comme Yahvé l'a dit."
,"13":"Josué bénit Caleb fils de Yéfouné et lui donna Hébron en héritage."
,"14":"C'est pour cela qu'Hébron a fait partie jusqu'à ce jour de l'héritage de Caleb, fils de Yéfouné le Kénisite, car il avait suivi fidèlement Yahvé, le Dieu d'Israël."
,"15":"Hébron s'appelait autrefois Kiryat-Arba (cet Arba était en effet le grand homme des Anakim); et avec cela le pays se reposa de la guerre."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Les clans de la tribu de Juda reçurent par le sort un territoire qui touchait la frontière d'Edom et s'étendait depuis le désert de Tsin jusqu'à Qadesh, au sud."
,"2":"La frontière méridionale partait de l'extrémité de la Mer de Sel, depuis la langue de terre tournée vers le midi,"
,"3":"elle se prolongeait par le sud de la montée des Scorpions, traversait Tsin, montait au sud de Qadesh-Barné; elle passait ensuite par Hesron, montait jusqu'à Addar et tournait alors vers Karka."
,"4":"Puis la frontière passait à Asmon, elle arrivait au Torrent d'Egypte et s'achevait à la Mer. Voilà pour la frontière méridionale."
,"5":"La Mer de Sel jusqu'à l'embouchure du Jourdain formait la frontière à l'orient. Au nord, la frontière partait de la baie à l'embouchure du Jourdain."
,"6":"La frontière montait ensuite à Beth-Hogla, elle passait au nord de Beth- Ha-Araba, et se prolongeait par la Pierre de Bohan (Bohan était fils de Ruben)."
,"7":"La frontière passait ensuite à Débir, par la vallée d'Akor, et remontait au nord vers le Guilgal en face de la montée d'Adoummim au sud du Torrent. La frontière passait alors par les sources d'En-Chémech et d'En-Roguel;"
,"8":"elle remontait ensuite par le ravin de Ben-Hinnom, passant au sud du territoire des Jébusites (c'est Jérusalem), puis elle se prolongeait par le sommet de la montagne qui fait face au ravin de Hinnom à l'ouest, à l'extrémité de la plaine des Réphaïm au nord."
,"9":"Alors la frontière s'abaissait du sommet de la montagne vers la fontaine des eaux de Neftoa, puis elle se dirigeait vers les villes qui se trouvent sur le mont Efron et tournait dans la direction de Baala (c'est Kiryat-Yéarim)."
,"10":"De Baala, la frontière continuait à l'ouest vers la montagne de Séïr, elle longeait le versant du mont Yéarim vers le nord (c'est Késalon), passait à Beth-Chémech, traversait Timna,"
,"11":"et arrivait sur le flanc nord d'Ekron. Là, elle tournait vers Chikaron, passait par la montagne de Baala, puis par Yabnéel. La frontière s'achevait à la mer."
,"12":"La Grande Mer formait la frontière occidentale. Voilà quelle était la frontière des clans de Juda."
,"13":"On donna un héritage à Caleb, fils de Yéfouné, au milieu de la tribu de Juda, selon l'ordre de Yahvé à Josué: Kiryat-Arba, la ville du père d'Anak (aujourd'hui c'est Hébron)."
,"14":"Caleb en chassa les trois fils d'Anak: Chéchaï, Ahiman et Talmaï, tous trois descendants d'Anak."
,"15":"De là, il se mit en campagne contre les habitants de Débir (autrefois Débir s'appelait Kiryat-Séfer)."
,"16":"Alors Caleb s'écria: 'Celui qui battra Kiryat-Séfer et s'en emparera, je lui donnerai ma fille Aksa en mariage!'"
,"17":"Otniel, fils de Kénaz, frère de Caleb, s'en empara, et Caleb lui donna sa fille Aksa en mariage."
,"18":"Lorsqu'elle fut arrivée près de son mari, celui-ci lui conseilla de demander à son père un champ. Elle sauta donc de son âne et Caleb lui demanda: 'Que veux-tu?'"
,"19":"Elle répondit: 'Fais-moi plaisir, puisque tu m'as envoyée dans le Négueb, donne-moi au moins des sources d'eau.' Et il lui donna les Sources d'en Haut et les Sources d'en Bas."
,"20":"Voilà l'héritage des clans de Juda."
,"21":"Voici les villes du sud du territoire de Juda, du côté de la frontière d'Edom, dans le Négueb: Quabzéel, Arad, Yagour,"
,"22":"Kina, Dimon, Aroër,"
,"23":"Qédesh, Hasor-Yitnan,"
,"24":"Zif, Télém, Balot,"
,"25":"Hasor-Hadata, Kériyot-Hésron (c'est Hasor),"
,"26":"Amam, Chéma, Méolada,"
,"27":"Hasar-Gada, Hechmon, Beth-Pélet,"
,"28":"Hasar-Choual, Bersabée et ses pâturages,"
,"29":"Baala, Iyim, Esem,"
,"30":"Eltolad, Kesil, Horma,"
,"31":"Siklag, Madmana, Sansana,"
,"32":"Lébaot, Chilhim, Ayin et Rimmon: au total, vingt-neuf villes et leurs villages."
,"33":"Dans le Bas-Pays: Echtaol, Soréa, Achna,"
,"34":"Zanoua, En-Gannim, Tapoua, Enam,"
,"35":"Yarmout, Adoullam, Soko, Azéka,"
,"36":"Chaarayim, Aditayim, Ha-Guédéra et Guédérotaïm: quatorze villes et leurs villages."
,"37":"Sénan, Adacha, Migdal-Gat,"
,"38":"Diléan, Ha-Mispé, Yoktéel,"
,"39":"Lakish, Boskat, Eglon,"
,"40":"Kabon, Lahmas, Kitlich,"
,"41":"Guédérot, Beth-Dagon, Naama et Makkéda: seize villes et leurs villages."
,"42":"Libna, Eter, Achan,"
,"43":"Yifta, Achna, Nésib,"
,"44":"Keïla, Akzib et Marécha: neuf villes et leurs villages."
,"45":"Ekron avec ses pâturages et ses villages,"
,"46":"tout ce qui se trouve dans la région d'Ashdod, avec ses villages, depuis Ekron jusqu'à la mer."
,"47":"Ashdod avec ses pâturages et ses villages, Gaza avec ses pâturages et ses villages, depuis la Grande Mer jusqu'au Torrent d'Egypte."
,"48":"Dans la montagne: Chamir, Yattir, Soko,"
,"49":"Dana, Kiryat-Séfer (aujourd'hui c'est Débir),"
,"50":"Anab, Echtémoa, Anim,"
,"51":"Gossen, Holon et Guilo: onze villes et leurs villages."
,"52":"Arab, Douma, Echéan,"
,"53":"Yanoum, Beth-Tapoua, Aféka,"
,"54":"Oumta, Kiryat-Arba (aujourd'hui c'est Hébron), et Sior: neuf villes et leurs villages."
,"55":"Maon, Karmel, Zif, Youta,"
,"56":"Yizréel, Yoqdéam, Zanoua,"
,"57":"Ha-Kayin, Guibéa et Timna: dix villes et leurs villages."
,"58":"Halhoul, Beth-Sour, Guédor,"
,"59":"Maarat, Beth- Anot, et Eltékon: six villes et leurs villages. Tékoa, Efrata (aujourd'hui c'est Bethléem), Péor, Etam, Koulon, Tatam, Sorés, Karem, Gallim, Béter et Mana: onze villes et leurs villages."
,"60":"Kiryat-Baal (c'est Kiryat-Yéarim), et Ha-Rabba: deux villes et leurs villages."
,"61":"Dans le désert: Beth-Ha-Araba, Midin, Sékaka,"
,"62":"Nibchan, la Ville-du-Sel et Engaddi: six villes et leurs villages."
,"63":"Les fils de Juda ne purent chasser les Jébusites qui habitaient à Jérusalem, c'est pourquoi les Jébusites habitent encore aujourd'hui Jérusalem, à côté des fils de Juda."
}`)
	CurrentBook.AddChapter(16, `{
"1":"L'héritage des fils de Joseph commençait à l'est du côté du Jourdain, à Jéricho (aux sources de Jéricho). Il comportait le désert qui s'étend de Jéricho à Béthel dans la montagne."
,"2":"Il s'étendait de Béthel vers Louz et touchait la frontière des Arkites à Atarot."
,"3":"Il se prolongeait à l'ouest vers la frontière des Yaflétites jusqu'à la frontière de Beth-Horon-le-Bas et jusqu'à Guézer, il se terminait à la mer."
,"4":"Voilà l'héritage de Manassé et Ephraïm, fils de Joseph."
,"5":"Pour le territoire des clans d'Ephraïm, la frontière de leur héritage passait à Atrot-Arak, à Beth-Horon-le-Haut,"
,"6":"et se terminait à la mer. Au nord se trouvait le Mikmétat. La frontière tournait alors à l'est vers Taanat-Silo et traversait à l'est en direction de Yanoa."
,"7":"Elle descendait de Yanoa vers Atarot et Naara, passait à Jéricho pour s'achever au Jourdain."
,"8":"De Tapoua, la frontière continuait vers l'ouest jusqu'au torrent de Kana et s'achevait à la mer. Voilà l'héritage des clans de la tribu d'Ephraïm, "
,"9":"en plus des villes (villes et villages) qui furent réservées aux fils d'Ephraïm à l'intérieur de l'héritage de la tribu de Manassé."
,"10":"Cependant ils ne purent chasser les Cananéens qui habitaient à Guézer; ceux-ci sont restés au milieu d'Ephraïm jusqu'à ce jour, mais ils sont soumis à la corvée."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Makir était le premier-né de Manassé, qui lui-même était le premier-né de Joseph. C'était un homme de guerre et il reçut en héritage le Galaad et le Bashan."
,"2":"Voici à présent ce qui concerne les autres fils de Manassé et leurs clans: les fils d'Abiézer, les fils d'Hélek, les fils d'Asriel, les fils de Chékem, les fils de Héfer et les fils de Chémida (c'étaient les enfants mâles de Manassé, fils de Joseph, selon leurs clans)."
,"3":"Séloféhad, fils de Héfer, fils de Galaad, fils de Makir, fils de Manassé, n'avait pas de fils, mais seulement des filles. Elles s'appelaient: Mahla, Noa, Hogla, Milka et Tirsa."
,"4":"Elles vinrent donc trouver le prêtre Eléazar et Josué, fils de Noun, ainsi que tous les chefs. Elles leur dirent: 'Yahvé a ordonné à Moïse de nous donner un héritage au milieu de nos frères.' On leur donna donc un héritage au milieu des frères de leur père, selon l'ordre de Yahvé."
,"5":"Manassé reçut donc dix parts en plus du pays de Galaad et du Bashan de l'autre côté du Jourdain,"
,"6":"puisque les filles de Manassé reçurent un héritage au milieu de ses fils. Le Galaad appartenait aux autres fils de Manassé."
,"7":"Du côté d'Asher, le Mikmétat qui fait face à Sichem formait la frontière. Celle-ci descendait au sud vers Yachib qui est la source de Tapoua."
,"8":"Manassé possédait en effet la région de Tapoua, mais Tapoua sur la frontière de Manassé appartenait à Ephraïm."
,"9":"La frontière se prolongeait par le torrent de Kana; au sud du torrent se trouvaient les villes d'Ephraïm, outre celles que possédait Ephraïm au milieu des villes de Manassé. La frontière de Manassé passait au nord du torrent et s'achevait à la mer."
,"10":"Le sud appartenait à Ephraïm et le nord à Manassé, et la mer en faisait la limite. Il touchait Asher au nord et Issacar à l'est."
,"11":"Dans le territoire d'Issacar et dans celui d'Asher, Manassé possédait Beth-Chéan et les villes qui en dépendent, Yibléam et les villes qui en dépendent, les habitants de Dor et des villes qui en dépendent, les habitants de Tanak et de Méguiddo et les villes qui en dépendent (ces trois dernières villes sont situées sur des hauteurs)."
,"12":"Comme les fils de Manassé ne purent s'emparer de ces villes, les Cananéens demeurèrent dans le pays."
,"13":"Cependant, lorsqu'ils furent devenus plus forts, les Israélites soumirent les Cananéens à la corvée, mais ils ne les chassèrent pas."
,"14":"Les fils de Joseph dirent à Josué: 'Pourquoi nous as-tu donné pour héritage un seul lot et une seule part, alors que nous formons un peuple nombreux, tellement Yahvé nous a bénis jusqu'à ce jour.'"
,"15":"Josué leur répondit: 'Si vous êtes un peuple nombreux, montez vers la forêt des Périsites et des Réphaïm. Défrichez-la pour votre compte, si la montagne d'Ephraïm est trop petite pour vous.'"
,"16":"Les fils de Joseph lui dirent: 'La montagne ne nous suffit pas, mais les Cananéens qui habitent la plaine ont tous des chars de fer, aussi bien ceux qui habitent à Beth-Chéan et dans ses villages, que ceux qui habitent dans la plaine d'Yizréel.'"
,"17":"Alors Josué répondit à la maison de Joseph, à Ephraïm et à Manassé: 'Vous êtes un peuple nombreux et vous êtes très forts. Il n'y aura pour vous qu'une seule part."
,"18":"La montagne vous appartient: vous la déboiserez, puisque c'est une forêt, et elle sera à vous dans toute son étendue. Le Cananéen a beau être fort et avoir des chars de fer, vous la lui prendrez."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Toute la communauté des Israélites se réunit à Silo, et là, ils dressèrent la Tente de Réunion. Le pays leur était soumis."
,"2":"Sept tribus parmi les Israélites n'avaient pas encore reçu leur héritage."
,"3":"Josué dit alors aux Israélites: 'Combien de temps allez-vous attendre encore pour conquérir le pays que Yahvé, le Dieu de vos pères, vous a donné?"
,"4":"Désignez trois hommes par tribu: je les enverrai parcourir tout le pays, ils en feront un état en vue du partage, puis ils reviendront vers moi."
,"5":"Ils le diviseront en sept parts, car Juda restera au sud dans ses frontières et la maison de Joseph, au nord dans ses frontières."
,"6":"Quand vous aurez établi un état du pays en sept parts, vous me l'apporterez et je ferai le tirage au sort pour vous devant Yahvé notre Dieu."
,"7":"Il n'y aura pas de part pour les Lévites au milieu de vous, car le service de Yahvé est leur héritage. Quant à Gad, Ruben et la demi-tribu de Manassé, ils ont déjà reçu leur héritage de l'autre côté du Jourdain, à l'est: Moïse, le serviteur de Yahvé, le leur a donné.'"
,"8":"Les hommes se levèrent donc et se mirent en route. Josué leur avait donné ses instructions au moment du départ pour qu'ils fassent un état du pays: 'Allez! Parcourez le pays, décrivez-le et revenez auprès de moi. Alors je jetterai pour vous les sorts, ici à Silo, devant Yahvé.'"
,"9":"Les hommes partirent et parcoururent le pays. Ils firent par écrit la description du pays et de ses villes: l'ensemble était divisé en sept parts. Ensuite ils retournèrent auprès de Josué, au camp de Silo."
,"10":"Là, à Silo, Josué jeta pour eux les sorts, en présence de Yahvé. C'est là que Josué répartit le pays entre les Israélites."
,"11":"Le premier lot fut pour les clans de Benjamin et ils reçurent par le sort un territoire situé entre celui de Juda et celui de Joseph."
,"12":"Au nord, leur frontière partait du Jourdain; elle montait sur le versant de Jéricho et se prolongeait dans la montagne à l'ouest pour aboutir au désert de Beth-Aven."
,"13":"La frontière partait de là vers Louz sur son versant méridional (aujourd'hui c'est Béthel); elle descendait vers Atrot-Arak par la montagne qui est au sud de Beth-Horon-le-Bas."
,"14":"La frontière s'avançait encore vers l'ouest, puis tournait vers le sud, depuis la montagne qui est en face de Beth-Horon au sud, pour aboutir dans les environs de Kiryat-Baal (aujourd'hui Kiryat-Yéarim, une ville de la tribu de Juda). Voilà pour le côté ouest."
,"15":"Au sud, partant de Kiryat-Yéarim, la frontière s'en allait vers Gasin, passait près de la source des eaux de Neftoa,"
,"16":"puis elle descendait à l'extrémité de la montagne, en face de la vallée de Ben-Hinnom, dans la partie nord de la plaine des Réphaïm. Ensuite elle descendait la vallée de Hinnom, passait sur le versant sud des Jébusites, pour arriver à En-Roguel."
,"17":"Alors elle repartait vers le nord, passait à En-Chémech, au Guilgal qui fait face à la montée d'Adoummim, puis descendait à la Pierre de Bohan (Bohan était fils de Ruben)."
,"18":"Elle passait ensuite à Kétef sur le versant nord de Beth- Ha-Arama et descendait alors vers la Araba."
,"19":"La frontière passait sur le versant nord de Beth-Ogla et se terminait avec la partie nord de la Mer du Sel, près de l'embouchure du Jourdain. C'était la frontière sud."
,"20":"A l'est, le Jourdain servait de frontière. Voilà l'héritage des clans de Benjamin avec ses frontières."
,"21":"Voici les villes des clans de Benjamin: Jéricho, Beth-Hogla, Emek-Késis,"
,"22":"Beth-Ha-Araba, Sémarayim, Béthel,"
,"23":"Avvim, Para, Ofra,"
,"24":"Kéfar-Ha-Ammoni, Ofni, Gaba: douze villes et leurs villages."
,"25":"Gabaon, Rama, Béérot,"
,"26":"Mispé, Kéfira, Mosa,"
,"27":"Rékem, Yirpéel, Taréala,"
,"28":"Séla-Ha-Eléf, le Jébusite (c'est Jérusalem), Guibéa et Kiryat: quatorze villes et leurs villages. Voilà l'héritage des clans de Benjamin."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Le sort attribua la deuxième part à Siméon, aux clans de la tribu de Siméon: leur héritage se trouva au milieu de celui de Juda."
,"2":"Ils reçurent en héritage Bersabée, Chéma, Molada,"
,"3":"Hasar-Choual, Bala, Esem,"
,"4":"Eltolad, Bétoul, Horma,"
,"5":"Siklag, Beth-Ha-Markabot, Hasar-Sousa,"
,"6":"Beth-Lébaot et Charouhen: treize villes et leurs villages."
,"7":"Ayin, Rimmon, Eter, Achan: quatre villes et leurs villages,"
,"8":"et de plus tous les villages qui les entouraient jusqu'à Baalat-Ber et Rama du Négueb; voilà l'héritage des clans de la tribu de Siméon."
,"9":"On préleva l'héritage de Siméon sur le lot de Juda, car la part de Juda était trop grande pour lui. La tribu de Siméon reçut donc son héritage au milieu de l'héritage de Juda."
,"10":"Le sort attribua la troisième part aux clans de Zabulon. Le territoire qu'ils reçurent en héritage s'étendait jusqu'à Sadoud."
,"11":"Leur frontière montait à l'ouest vers Maraala, elle passait à côté de Tabechet et du Torrent qui est en face de Yoknéam."
,"12":"A partir de Sadoud, la frontière tournait vers l'est du côté du soleil levant. Elle atteignait Kislot-Tabor, passait près de Dabérat et montait à Yafia."
,"13":"A partir de là, elle s'étendait vers l'est au levant, vers Gat-Héfer et Itta-Kasin. Elle touchait alors Rimmon et arrivait dans les environs de Néa."
,"14":"Puis la frontière faisait un détour vers le nord, en direction d'Hannaton et arrivait à la vallée de Yifta-El."
,"15":"Il y avait là Katat, Nahalal, Chimron, Yiréala et Bethléem: douze villes et leurs villages;"
,"16":"voilà l'héritage des clans de Zabulon, avec ses villes et ses villages."
,"17":"Le sort attribua la quatrième part à Issacar, aux clans de la tribu d'Issacar."
,"18":"Leur territoire s'étendait vers Yizréel, il comptait Késoulot, Sunem,"
,"19":"Hafarayim, Chion, Anaharat,"
,"20":"Dabérat, Kichyon, Ebes,"
,"21":"Rémet, En-Gannim, En-Hadda et Beth-Passés."
,"22":"Touchant Thabor, Chahasima et Beth-Chémech, la frontière arrivait au Jourdain: seize villes et leurs villages."
,"23":"Voilà l'héritage des clans de la tribu d'Issacar avec ses villes et ses villages."
,"24":"Le sort attribua la cinquième part aux clans de la tribu d'Asher."
,"25":"Leur territoire comptait Helkat, Hali, Béten, Akchaf,"
,"26":"Alammélek, Améad et Michéal. A l'ouest il touchait le Carmel et le lit du Libnat."
,"27":"Du côté du soleil levant, il allait jusqu'à Beth-Dagon; il touchait Zabulon, la vallée de Yifta-El, Beth-Ha-Emek et Néïel, au nord de Kaboul."
,"28":"Il comprenait Abdon, Réhob, Hammon et Kana, jusqu'à Sidon-la-Grande. La frontière allait vers Rama et jusqu'à la ville fortifiée de Tyr."
,"29":"Ensuite, elle gagnait Hosa et aboutissait à la mer, à la hauteur de Mahaleb et Akzib,"
,"30":"avec Akko, Afek et Réhob: vingt-deux villes et leurs villages."
,"31":"Voilà l'héritage des clans de la tribu d'Asher, avec leurs villes et leurs villages."
,"32":"Le sort attribua la sixième part à Nephtali, aux clans de la tribu de Nephtali."
,"33":"Partant de Hélef et du Chêne de Saanannim, leur frontière passait à Adami-Ha-Nékeb et Yabnéel, Lakoum et arrivait au Jourdain."
,"34":"La frontière passait à l'ouest par Aznot-Tabor, par Houkok et touchait Zabulon au sud et Asher à l'ouest, le Jourdain formait la frontière orientale."
,"35":"Les villes étaient Siddim, Ser, Hammat, Rakat, Kinnéret,"
,"36":"Adama, Rama, Hasor,"
,"37":"Qédesh, Edréï, En-Hasor,"
,"38":"Yiréon, Migdal-El, Horem, Beth-Anat et Beth-Chémech: dix-neuf villes et leurs villages."
,"39":"Voilà l'héritage des clans de la tribu de Nephtali, avec leurs villes et leurs villages."
,"40":"Le sort attribua la septième part aux clans de Dan."
,"41":"Le territoire qu'ils reçurent comprenait Soréa, Echtaol, Ir-Chémech,"
,"42":"Chaalbim, Ayyalon, Silata,"
,"43":"Elon, Timna, Ekron,"
,"44":"Elteké, Guibéton, Baalat,"
,"45":"Azor, Béné-Pérak et Gat-Rimmon;"
,"46":"vers la mer, Yérakon avec le territoire qui fait face à Joppé."
,"47":"Mais la tribu de Dan ne sut pas s'emparer de son territoire. C'est pourquoi ses clans montèrent combattre Léchem; ils s'en emparèrent et la passèrent au fil de l'épée. Après la prise de Léchem, ils s'y installèrent et lui donnèrent le nom de Dan, celui de leur ancêtre."
,"48":"Voilà l'héritage des clans de la tribu de Dan, avec leurs villes et leurs villages."
,"49":"Le partage du pays avec ses frontières était terminé. Alors les Israélites donnèrent à Josué, fils de Noun, un héritage au milieu d'eux."
,"50":"Selon l'ordre de Yahvé, ils lui donnèrent la ville qu'il avait demandée: Timnat-Séra, dans la montagne d'Ephraïm. Il reconstruisit la ville et s'y installa."
,"51":"Ce sont là les parts d'héritage que le prêtre Eléazar, Josué fils de Noun et les chefs de clans, répartirent par le sort entre les tribus d'Israël. C'était à Silo, en présence de Yahvé à l'entrée de la Tente du Rendez-Vous. Ainsi s'acheva le partage du pays."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Yahvé dit à Josué de répéter aux Israélites"
,"2":"ce qu'il avait fait dire à Moïse: 'Donnez-vous des villes de refuge où pourra se réfugier"
,"3":"celui qui aura tué quelqu'un par erreur, involontairement. Elles lui serviront de refuge contre le vengeur du sang."
,"4":"Celui qui voudra se réfugier dans l'une de ces villes se présentera à l'entrée de la porte de la ville. Là il exposera son cas aux anciens de la ville, et ceux-ci l'accueilleront auprès d'eux dans la ville et lui donneront une maison pour qu'il habite avec eux."
,"5":"Si le vengeur du sang le poursuit, ils ne livreront point le meurtrier entre ses mains, car c'est involontairement qu'il a tué son prochain: il n'avait pas de haine pour lui auparavant."
,"6":"Le meurtrier restera dans la ville jusqu'à ce qu'il comparaisse devant la communauté pour être jugé, et jusqu'à ce que soit mort le Grand Prêtre en fonction ces jours-là. Alors le meurtrier pourra regagner sa maison dans la ville d'où il s'était enfui.'"
,"7":"On consacra donc Qédesh en Galilée dans la montagne de Nephtali, Sichem dans la montagne d'Ephraïm et Kiryat-Arba, c'est-à-dire Hébron, dans la montagne de Juda."
,"8":"Au-delà du Jourdain, à l'est de Jéricho, on avait désigné Béser dans le désert, sur le plateau, dans le territoire de Ruben; Ramot-en-Galaad, dans le territoire de Gad et Golan du Bashan, dans le territoire de Manassé."
,"9":"Ce sont là les villes de refuge pour les Israélites et pour les étrangers qui habitent au milieu d'eux. C'est là que se réfugie celui qui a tué quelqu'un involontairement, pour échapper à la main du vengeur du sang, jusqu'au moment où il comparaît devant la communauté."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Les chefs de famille des Lévites s'approchèrent du prêtre Eléazar, de Josué fils de Noun et des chefs de clans des tribus d'Israël"
,"2":"à Silo, au pays de Canaan, et ils leur dirent: 'Yahvé a ordonné par la voix de Moïse de nous donner des villes pour y habiter et des pâturages pour notre bétail.'"
,"3":"Les Israélites donnèrent donc aux Lévites sur leur part, selon l'ordre de Yahvé, les villes suivantes avec leurs pâturages."
,"4":"On tira au sort pour les clans des Kahatites, lévites fils du prêtre Aaron. Ils reçurent treize villes dans les tribus de Juda, de Siméon et de Benjamin."
,"5":"Les autres fils de Kahat reçurent selon leurs clans, dix villes dans les tribus d'Ephraïm, de Dan et dans la demi-tribu de Manassé."
,"6":"Les fils de Guerchon reçurent selon leurs clans treize villes dans les tribus d'Issacar, d'Asher, de Nephtali et dans la demi-tribu de Manassé installée au Bashan."
,"7":"Les fils de Mérari reçurent selon leurs clans douze villes dans les tribus de Ruben, de Gad et de Zabulon."
,"8":"Les Israélites attribuèrent donc par le sort ces villes et ces pâturages aux Lévites, comme Yahvé l'avait ordonné par la bouche de Moïse."
,"9":"Voici les noms des villes qu'ils donnèrent dans la tribu de Juda et dans la tribu de Siméon."
,"10":"La première part fut pour les fils d'Aaron appartenant au clan des Kahatites, de la tribu de Lévi."
,"11":"Dans la montagne de Juda, ils leur donnèrent Kiryat-Arba avec ses pâturages, c'était la ville du père d'Anak (aujourd'hui c'est Hébron)."
,"12":"Mais ils donnèrent en propriété à Caleb, fils de Yéfouné la campagne de cette ville et ses villages."
,"13":"Ils donnèrent aux fils du prêtre Aaron, Hébron et ses pâturages (Hébron était une ville de refuge pour les meurtriers), Libna et ses pâturages,"
,"14":"Yattir et ses pâturages, Echtémoa et ses pâturages,"
,"15":"Holon et ses pâturages, Débir et ses pâturages,"
,"16":"Achan et ses pâturages, Youta et ses pâturages et Beth-Chémech et ses pâturages: neuf villes prises dans ces deux tribus."
,"17":"De la tribu de Benjamin: Gabaon et ses pâturages, Guéba et ses pâturages,"
,"18":"Anatot et ses pâturages et Almon et ses pâturages: quatre villes."
,"19":"Le total des villes pour les prêtres, fils d'Aaron, fut de treize villes avec leurs pâturages."
,"20":"Pour les autres clans des fils de Kahat, pour les Lévites qui restaient parmi les fils de Kahat, on prit des villes sur la tribu d'Ephraïm."
,"21":"On leur donna Sichem et ses pâturages, dans la montagne d'Ephraïm (c'était une ville de refuge pour les meurtriers), Guézer et ses pâturages,"
,"22":"Kibsayim et ses pâturages et Beth-Horon et ses pâturages: quatre villes."
,"23":"Dans la tribu de Dan: Elteké et ses pâturages, Guibéton et ses pâturages,"
,"24":"Ayyalon et ses pâturages et Gat-Rimmon et ses pâturages: quatre villes."
,"25":"Dans la demi-tribu de Manassé: Tanak et ses pâturages et Yibléam et ses pâturages: deux villes."
,"26":"Le total fut de dix villes avec leurs pâturages pour les clans qui restaient parmi les fils de Kahat."
,"27":"Aux fils de Guerchon qui appartenaient au clan de Lévi, on donna Golan en Bashan (c'était une ville de refuge pour les meurtriers) et Achtarot avec leurs pâturages, dans la demi-tribu de Manassé: deux villes."
,"28":"Dans la tribu d'Issacar: Kichyon et ses pâturages, Dabérat et ses pâturages,"
,"29":"Yarmout et ses pâturages et En-Gannim et ses pâturages: quatre villes."
,"30":"Dans la tribu d'Asher: Michéal et ses pâturages, Abdon et ses pâturages,"
,"31":"Helkat et ses pâturages et Réhob et ses pâturages: quatre villes."
,"32":"Dans la tribu de Nephtali: Qédesh en Galilée (c'était une ville de refuge pour les meurtriers) et ses pâturages, Hammot-Dor et ses pâturages et Kartan et ses pâturages: trois villes."
,"33":"Le total des villes pour les clans de Guerchon fut de treize villes et leurs pâturages."
,"34":"On attribua au clan des fils de Mérari, au reste des Lévites, dans la tribu de Zabulon: Yoknéam et ses pâturages, Karta et ses pâturages,"
,"35":"Rimmon et ses pâturages et Nahalal et ses pâturages: quatre villes."
,"36":"De l'autre côté du Jourdain, en face de Jéricho, dans la tribu de Ruben: Béser dans le désert, sur le plateau (c'était une ville de refuge pour les meurtriers) et ses pâturages, Yahas et ses pâturages,"
,"37":"Kédémot et ses pâturages et Méfaat et ses pâturages: quatre villes."
,"38":"Dans la tribu de Gad: Ramot en Galaad (c'était une ville de refuge pour les meurtriers) et ses pâturages, Mahanayim et ses pâturages,"
,"39":"Heshbon et ses pâturages et Yazer et ses pâturages: quatre villes."
,"40":"Le total des villes qui furent attribuées au clan des fils de Mérari, le reste des clans de Lévi, fut de douze villes."
,"41":"Le nombre total des villes attribuées aux Lévites au milieu des territoires des Israélites était de quarante-huit villes avec leurs pâturages."
,"42":"Ces villes comprenaient chacune la ville et les pâturages qui l'entouraient, il en était ainsi pour toutes les villes."
,"43":"Ainsi Yahvé donna aux Israélites tout le pays qu'il avait juré à leurs pères de leur donner, ils en prirent possession et s'y installèrent."
,"44":"Yahvé leur accorda la paix sur toutes leurs frontières, comme il l'avait juré à leurs pères, et aucun de leurs ennemis ne put tenir devant eux. Yahvé livra entre leurs mains tous leurs ennemis."
,"45":"Aucune des promesses que Yahvé avait faites à la maison d'Israël ne fut oubliée: tout se réalisa."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Josué convoqua les gens de Ruben, de Gad et de la demi-tribu de Manassé,"
,"2":"et leur dit: 'Vous avez obéi à tout ce que Moïse, serviteur de Yahvé, vous a ordonné, et vous m'avez obéi dans tout ce que je vous ai commandé."
,"3":"Bien du temps a passé, mais vous n'avez pas abandonné vos frères jusqu'à ce jour, et vous avez fidèlement observé le commandement de Yahvé votre Dieu."
,"4":"Maintenant que Yahvé votre Dieu a donné le repos à vos frères comme il l'avait dit, retournez et regagnez vos tentes, dans le pays qui vous appartient et que Moïse, serviteur de Yahvé, vous a donné de l'autre côté du Jourdain."
,"5":"Ayez soin seulement de mettre en pratique les commandements et les lois que Moïse, le serviteur de Yahvé, vous a prescrits. Aimez Yahvé votre Dieu, marchez dans toutes ses voies, gardez ses commandements, attachez-vous à lui et servez-le de tout votre coeur et de toute votre âme.'"
,"6":"Josué les bénit, puis il les renvoya et ils retournèrent à leurs tentes."
,"7":"Moïse avait donné le Bashan à une moitié de la tribu de Manassé; à l'autre moitié de la tribu, Josué donna un héritage parmi ses frères, à l'ouest du Jourdain. En les renvoyant à leurs tentes, Josué les bénit."
,"8":"Il leur dit: 'Retournez à vos tentes chargés de richesses! Que de troupeaux, d'or, d'argent, de bronze, de fer et de vêtements! Partagez les dépouilles de vos ennemis avec vos frères.'"
,"9":"Les gens de Ruben, de Gad et de la demi-tribu de Manassé quittèrent les Israélites à Silo, dans le pays de Canaan. Ils regagnèrent le pays de Galaad, puisque c'était l'héritage qu'ils avaient reçu comme Yahvé l'avait ordonné par Moïse."
,"10":"Lorsqu'ils arrivèrent aux environs du Jourdain qui font partie du pays de Canaan, les gens de Ruben, de Gad et de la demi-tribu de Manassé construisirent un autel au bord du Jourdain. C'était un autel de taille impressionnante."
,"11":"On vint en avertir les Israélites: 'Voilà que les gens de Ruben, de Gad et de la demi-tribu de Manassé ont construit un autel face au pays de Canaan, dans les environs du Jourdain, du côté des Israélites.'"
,"12":"Alors toute la communauté d'Israël se réunit à Silo pour monter contre eux et leur faire la guerre"
,"13":"Les Israélites envoyèrent aux gens de Ruben, de Gad et de la demi-tribu de Manassé, dans le pays de Galaad, Pinhas, fils d'Eléazar le prêtre,"
,"14":"et dix chefs avec lui: un chef de clan pour chacune des tribus d'Israël."
,"15":"Arrivés chez les gens de Ruben, de Gad et de la demi-tribu de Manassé, au pays de Galaad, ils leur dirent:"
,"16":"'Voici ce que dit la communauté de Yahvé: Quelle infidélité avez-vous commise envers le Dieu d'Israël! Vous voulez donc vous détourner de Yahvé? En bâtissant un autel vous vous révoltez contre Yahvé!"
,"17":"Le crime de Péor ne suffit-il pas? Nous n'en sommes pas encore guéris après le fléau qui a frappé toute la communauté de Yahvé."
,"18":"Si vous vous révoltez aujourd'hui contre Yahvé, demain il se mettra en colère contre toute la communauté d'Israël."
,"19":"Si le pays que vous possédez est impur à vos yeux, venez dans le pays qui est l'héritage de Yahvé, là où il a établi sa Demeure. Vous y recevrez un héritage au milieu de nous. Mais ne vous révoltez pas contre Yahvé, ne vous révoltez pas contre nous en bâtissant un autel autre que celui de Yahvé notre Dieu."
,"20":"Rappelez-vous l'infidélité de Akan, fils de Zérah, à propos de l'anathème: la colère de Yahvé a frappé toute la communauté d'Israël, et il ne fut pas le seul à mourir à cause de son crime.'"
,"21":"Les gens de Ruben, de Gad et de la demi-tribu de Manassé répondirent aux chefs des clans d'Israël:"
,"22":"'Le Dieu des dieux, Yahvé, le Dieu des dieux, sait la vérité et Israël doit la savoir. Si nous nous sommes révoltés contre Yahvé, si nous lui avons été infidèles, alors, oui! que Yahvé ne nous épargne pas."
,"23":"Si nous avons bâti cet autel pour nous détourner de Yahvé, pour lui offrir des holocaustes et des oblations, pour y présenter des sacrifices de communion, que Yahvé lui-même nous en demande compte."
,"24":"Mais nous avons agi de la sorte par crainte de ce qui pourrait arriver plus tard; peut-être un jour vos fils diront-ils aux nôtres: Qu'y a-t-il de commun entre vous et Yahvé le Dieu d'Israël?"
,"25":"Yahvé a placé le Jourdain comme frontière entre nous et vous, vous n'avez donc point de part avec Yahvé. Et ainsi, à cause de vos fils, nos fils cesseraient de craindre Yahvé."
,"26":"Alors, nous nous sommes dit: Construisons-nous un autel, non pour y offrir des holocaustes ou des sacrifices,"
,"27":"mais pour qu'il soit témoin entre nous et vous, et nos descendants après nous. Il prouvera que nous pratiquons le culte de Yahvé, en sa présence, par nos holocaustes, nos offrandes et nos sacrifices de communion. Ainsi vos fils ne pourront pas dire à nos fils: Vous n'avez rien à voir avec Yahvé."
,"28":"Nous nous sommes dit: si demain ils nous parlent ainsi à nous ou à nos descendants, nous leur dirons: Regardez la forme de l'autel de Yahvé que nos pères ont construit, non pas pour les holocaustes ou pour les sacrifices, mais pour qu'il soit témoin entre nous et vous."
,"29":"Nous ne voulons pas nous révolter contre Yahvé et cesser de le suivre. Nous n'avons pas bâti cet autel pour l'holocauste, pour l'offrande ou pour le sacrifice de communion, par mépris pour l'autel de Yahvé qui est devant sa Demeure.'"
,"30":"Pinhas le prêtre, les chefs de la communauté et les chefs des clans d'Israël qui étaient avec lui, entendirent les paroles que prononçaient les fils de Ruben, les fils de Gad et les fils de Manassé, et ces paroles leur plurent."
,"31":"Alors Pinhas le prêtre dit aux fils de Ruben, de Gad et de Manassé: 'Aujourd'hui nous savons que Yahvé est bien au milieu de nous puisque vous n'avez pas commis d'infidélité envers Yahvé et vous avez épargné à Israël les fléaux de Yahvé.'"
,"32":"Alors, quittant les fils de Ruben et de Gad au pays de Galaad, Pinhas le prêtre et les chefs revinrent au pays de Canaan, vers les Israélites. Il leur rendirent compte de tout,"
,"33":"et les Israélites approuvèrent. Ils bénirent Dieu et renoncèrent à partir en guerre pour ravager le pays où habitaient les fils de Ruben et de Gad."
,"34":"Quant aux fils de Ruben et aux fils de Gad, ils appelèrent cet autel Témoin, car, dirent-ils: 'Il est témoin entre nous de ce que Yahvé est Dieu.'"
}`)
	CurrentBook.AddChapter(23, `{
"1":"Un long temps s'était écoulé depuis que Yahvé avait délivré Israël de tous ses ennemis d'alentour et lui avait donné le repos. Quant à Josué, il était vieux, avancé en âge."
,"2":"Alors Josué rassembla tout Israël avec ses anciens, ses chefs, ses juges et ses scribes, et il leur dit: 'Je suis maintenant vieux, avancé en âge."
,"3":"Vous avez vu tout ce que Yahvé votre Dieu a fait à ces nations qui vous faisaient face: Yahvé votre Dieu les a combattues à vos côtés."
,"4":"Regardez! Je vous ai partagé par le sort le domaine de ces nations qui demeuraient au milieu de vous et que j'ai éliminées. C'est là l'héritage de vos tribus depuis le Jourdain jusqu'à la Grande Mer du côté du soleil couchant."
,"5":"Yahvé votre Dieu les chassera devant vous, et il leur prendra la terre pour qu'elle devienne vôtre, comme Yahvé votre Dieu vous l'a dit."
,"6":"Soyez donc courageux! Observez et mettez en pratique tout ce qui est écrit dans le livre de la Loi de Moïse. Ne vous en détournez ni à droite ni à gauche,"
,"7":"ne vous mêlez pas avec ces peuplades qui sont demeurées au milieu de vous. N'invoquez pas le nom de leurs dieux, et ne jurez pas par eux; ne les servez pas et ne vous prosternez pas devant eux."
,"8":"C'est à Yahvé votre Dieu, et à lui seul, que vous vous attacherez, comme vous l'avez fait jusqu'à ce jour."
,"9":"Yahvé a chassé devant vous des nations grandes et puissantes et personne n'a pu vous résister jusqu'à ce jour."
,"10":"Un seul d'entre vous en poursuivait mille, car Yahvé votre Dieu combattait pour vous, comme il vous l'avait dit."
,"11":"Aimez Yahvé votre Dieu, il y va de votre vie."
,"12":"Si vous vous détournez de lui, si vous vous liez aux autres peuplades qui sont restées au milieu de vous, si vous vous mêlez avec elles par le mariage et que vous allez les uns chez les autres,"
,"13":"sachez-le bien: Yahvé votre Dieu ne continuera pas à les dépouiller devant vous. Mais elles seront pour vous comme un filet et comme un piège, comme un fouet sur votre dos et des épines dans vos yeux, jusqu'à ce que vous disparaissiez de cette bonne terre que Yahvé votre Dieu vous a donnée."
,"14":"Au moment où je m'en vais par le chemin de toute créature, reconnaissez du fond du coeur, du fond de votre esprit, que Yahvé votre Dieu a réalisé tout ce qu'il avait dit dans sa bonté. Ses paroles se sont toutes réalisées, pas une seule n'est restée sans effet."
,"15":"C'est pourquoi, de même que toute promesse de Yahvé votre Dieu à votre sujet s'est réalisée, de même Yahvé réalisera contre vous toutes ses menaces, jusqu'à vous exterminer de cette bonne terre qu'il vous a donnée."
,"16":"Si vous êtes infidèles à l'Alliance que Yahvé votre Dieu vous a proposée, si vous allez servir d'autres dieux et vous prosterner devant eux, alors la colère de Yahvé s'enflammera contre vous et vous disparaîtrez rapidement de cette bonne terre qu'il vous a donnée.'"
}`)
	CurrentBook.AddChapter(24, `{
"1":"Josué rassembla donc à Sichem toutes les tribus d'Israël. Il convoqua les anciens d'Israël, les chefs, les juges et les scribes, et ils se présentèrent devant Dieu."
,"2":"Josué dit alors à tout le peuple: 'Voici ce que Yahvé, le Dieu d'Israël vous fait dire: Vos pères habitaient au-delà du Fleuve, et ils servaient d'autres dieux: rappelez-vous Térah, père d'Abraham et père de Nahor."
,"3":"Mais j'ai pris votre père Abraham d'au-delà du Fleuve et je lui ai fait parcourir tout le pays de Canaan, j'ai multiplié sa race et je lui ai donné Isaac."
,"4":"A Isaac, j'ai donné Jacob et Esaü. J'ai donné le mont Séïr à Esaü pour son domaine; mais Jacob et ses fils, eux, sont descendus en Egypte."
,"5":"Puis j'ai envoyé Moïse et Aaron, et ce furent les plaies d'Egypte, tout ce que j'ai fait au milieu d'elle; ensuite je vous ai fait sortir."
,"6":"Quand j'ai fait sortir vos pères d'Egypte, vous êtes arrivés à la mer et les Egyptiens ont poursuivi vos pères avec leurs chars et leurs cavaliers jusqu'à la Mer des Roseaux."
,"7":"Alors ils ont crié vers Yahvé et Yahvé a placé un brouillard entre vous et les Egyptiens, il a ramené la mer sur eux et les a recouverts. Vos yeux ont donc vu ce que j'ai fait en Egypte, après quoi vous avez séjourné de longs jours dans le désert."
,"8":"Alors je vous ai fait entrer dans le pays des Amorites qui habitaient au-delà du Jourdain. Ils ont combattu contre vous, et je les ai livrés entre vos mains. Vous avez conquis leur pays et je les ai exterminés devant vous."
,"9":"C'est alors que Balak, fils de Sipor, roi de Moab, est parti en guerre contre Israël, et a envoyé chercher Balaam, fils de Béor, pour vous maudire."
,"10":"Mais je n'ai pas voulu écouter Balaam et il a été obligé de vous bénir: ainsi je vous ai donc délivrés de sa main."
,"11":"Vous avez ensuite traversé le Jourdain et vous êtes arrivés à Jéricho. Les chefs de Jéricho, les Amorites, les Périsites, les Cananéens, les Hittites, les Guirgachites, les Hivvites et les Jébusites ont combattu contre vous, mais je les ai livrés entre vos mains."
,"12":"J'ai chassé de devant vous les deux rois des Amorites, non par l'épée ou par l'arc, mais par les frelons que j'ai envoyés devant vous."
,"13":"Je vous ai donné une terre où vous n'avez pas travaillé, des villes que vous n'avez pas construites mais que vous avez habitées, des vignes et des oliviers que vous n'avez pas plantés, mais dont vous avez mangé les fruits."
,"14":"Maintenant donc, craignez Yahvé! Servez-le avec sincérité et fidélité. Eliminez les dieux que vos pères ont servis au-delà du Fleuve et en Egypte et servez Yahvé!"
,"15":"Mais si vous ne voulez pas servir Yahvé, choisissez maintenant qui vous servirez: ou bien les dieux que vos pères ont servi au-delà du Fleuve, ou bien les dieux des Amorites dans le pays desquels vous habitez? Mais moi et ma maison, c'est Yahvé que nous servirons.'"
,"16":"Le peuple répondit: 'Loin de nous d'abandonner Yahvé pour servir d'autres dieux,"
,"17":"car c'est Yahvé notre Dieu qui nous a fait monter avec nos pères du pays d'Egypte, de la maison de l'esclavage. C'est lui qui a accompli sous nos yeux ces prodiges et qui nous a protégés tout au long de la route sur laquelle nous avons marché, chez tous les peuples au milieu desquels nous sommes passés."
,"18":"C'est Yahvé qui a chassé devant nous tous les peuples, de même que les Amorites qui habitaient le pays. Nous voulons donc servir Yahvé, il est notre Dieu.'"
,"19":"Alors Josué dit au peuple: 'Vous ne saurez pas servir Yahvé, car c'est un Dieu saint, un Dieu jaloux; il ne pardonnera pas vos infidélités et vos péchés."
,"20":"Si vous abandonnez Yahvé pour servir des dieux étrangers, lui aussi changera: il vous fera du mal et vous exterminera après vous avoir fait du bien.'"
,"21":"Le peuple dit à Josué: 'Non! C'est Yahvé que nous servirons!'"
,"22":"Alors Josué dit au peuple: 'Vous êtes témoins contre vous-mêmes que c'est Yahvé que vous avez choisi de servir.' Ils lui répondirent: 'Nous sommes témoins.'"
,"23":"'Maintenant donc, dit Josué, enlevez les dieux étrangers qui sont au milieu de vous et tournez votre coeur vers Yahvé le Dieu d'Israël.'"
,"24":"Le peuple dit à Josué: 'Nous servirons Yahvé notre Dieu et nous écouterons sa voix.'"
,"25":"Ce jour-là donc Josué conclut une alliance avec le peuple, il lui imposa un statut et une règle à Sichem."
,"26":"Il écrivit toutes ces paroles dans le livre de la Loi de Dieu. Il prit une grande pierre et la dressa sous le Chêne qui était dans le sanctuaire de Yahvé."
,"27":"Josué dit alors à tout le peuple: 'Cette pierre sera témoin contre nous, car elle a entendu toutes les paroles que Yahvé a prononcées devant nous. Elle servira donc de témoin contre vous, pour vous empêcher de renier votre Dieu.'"
,"28":"Ensuite Josué renvoya le peuple, chacun dans son héritage."
,"29":"Josué, fils de Noun, serviteur de Yahvé, mourut après cela, âgé de cent dix ans."
,"30":"On l'ensevelit dans le territoire qu'il avait reçu en partage, à Timnat-Séra, dans la montagne d'Ephraïm, au nord du mont Gaach."
,"31":"Israël servit Yahvé durant toute la vie de Josué et durant toute la vie des anciens qui succédèrent à Josué: ils avaient en effet connu tout ce que Yahvé avait accompli en faveur d'Israël."
,"32":"On ensevelit à Sichem les ossements de Joseph que les Israélites avaient rapportés d'Egypte. On les mit dans la parcelle de champ que Jacob avait achetée aux fils de Hamor, père de Sichem, pour cent pièces d'argent: elle était devenue l'héritage des fils de Joseph."
,"33":"Eléazar, fils d'Aaron mourut à son tour et on l'enterra dans la montagne d'Ephraïm à Guibéa, ville qui avait été donnée à son fils Pinhas."
}`)

}
func FR_LBDCC_LoadVHIHChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Tout ceci arriva en la douzième année du règne de Nabukodonozor sur les Assyriens, à Ninive, la grande ville. Arfaxad régnait alors sur les Mèdes, à Ekbatane."
,"2":"Il avait entouré cette ville d'un rempart en belles pierres de taille de trois coudées de large et six de long; le rempart était haut de soixante-dix coudées et large de cinquante;"
,"3":"des tours de cent coudées de haut, larges de soixante à la base, se dressaient de chaque côté des portes."
,"4":"Pour faciliter le passage de sa grande armée et le défilé de ses troupes, les portes elles-mêmes avaient soixante-dix coudées de haut et quarante de large."
,"5":"C'est alors que le roi Nabukodonozor livra bataille au roi Arfaxad, dans la grande plaine du territoire de Ragau."
,"6":"Arfaxad avait regroupé autour de lui tous les peuples des montagnes, tous les habitants des rives de l'Euphrate, du Tigre et de l'Hydaspe, et tous ceux des plaines soumises à Ariok, roi des Elyméens. Ainsi, ces nombreux peuples s'étaient enrôlés dans l'armée des fils de Chéléoud."
,"7":"De son côté, Nabukodonozor, roi des Assyriens, avait fait appel à tous les habitants de la Perse, des régions de l'occident, de la Cilicie, de Damas, du Liban, de l'Anti-Liban et de la côte,"
,"8":"aux peuples du Carmel, de Galaad, de la Haute-Galilée, de la grande plaine d'Esdrelon,"
,"9":"aux gens de Samarie et des villes qui l'entourent, les gens d'au-delà du Jourdain jusqu'à Jérusalem, à ceux de Batanée, de Chélous, de Cadès, à ceux du Fleuve d'Egypte, de Tafnès, de Ramsès, à tous ceux qui habitent le terri toire de Gochen,"
,"10":"à ceux de Tanis, de Memphis, à tous les habitants de l'Egypte jusqu'aux frontières de l'Ethiopie."
,"11":"Mais les habitants de toute la terre se moquaient bien de l'appel de Nabukodonozor, roi des Assyriens; ils refusèrent de se rassembler autour de lui pour le combat car ils ne le craignaient pas: pour eux ce n'était qu'un homme. Ils renvoyèrent donc ses messagers les mains vides et humiliés."
,"12":"Nabukodonozor se mit en colère contre tous ces pays. Il jura par son trône et par son royaume, de corriger sévèrement tous les pays de Cilicie, de Damascène et de Syrie, et de faire mourir par l'épée tous les habitants de Moab, d'Ammon, de Judée et d'Egypte, jusqu'aux frontières des deux mers."
,"13":"Puis, avec son armée, il livra bataille au roi Arfaxad en la dix-septième année de son règne. Il remporta la victoire, écrasant toute l'armée d'Arfaxad, sa cavalerie et ses chars."
,"14":"Il s'empara de ses villes et arriva jusqu'à Ekbatane. Là il prit les tours, pilla les rues et transforma en ruines la cité fameuse."
,"15":"Il captura Arfaxad dans les montagnes de Ragau, le transperça de ses lances et le fit disparaître pour toujours."
,"16":"Il revint ensuite avec tout son monde, une foule immense d'hommes de guerre, et pendant cent vingt jours il s'installa avec son armée dans une vie de plaisirs et de luxe."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Le vingt-deuxième jour du premier mois, en la dix-huitième année de son règne, on parla dans le palais de Nabukodonozor, roi des Assyriens, de tirer vengeance de toute la terre, selon la promesse qu'il avait faite."
,"2":"Il rassembla donc tous ses généraux, tous les chefs, et leur exposa le projet qu'il avait décidé en lui-même. Il voulait en finir, d'une parole de sa bouche, avec ce mauvais vouloir de la terre entière."
,"3":"Et tous furent d'accord pour exterminer tous ceux qui n'avaient pas obéi à sa parole."
,"4":"A la fin du conseil, Nabukodonozor roi des Assyriens appela Holoferne, général en chef de son armée, son adjoint, et il lui dit:"
,"5":"'Ainsi parle le grand roi, le seigneur de toute la terre: Dès que tu m'auras quitté, tu prendras avec toi des hommes sûrs de leur force, environ cent vingt mille fantassins, une grande quantité de chevaux avec douze mille cavaliers,"
,"6":"et tu iras combattre tous les pays de l'Occident, car ils ont désobéi à mon ordre."
,"7":"Tu leur ordonneras de se préparer à l'esclavage, car dans ma colère, je vais marcher contre eux. Les pas de mes soldats fouleront toute la terre et je la livrerai au pillage."
,"8":"Les blessés rempliront les ravins, tous les torrents et tous les fleuves seront remplis de cadavres jusqu'à déborder."
,"9":"Je déporterai les prisonniers jusqu'aux extrémités de la terre."
,"10":"Va donc et prépare-moi le terrain. S'ils se livrent à toi, tu me les garderas pour le jour du châtiment; s'ils ne t'écoutent pas,"
,"11":"tu seras sans pitié pour eux, tu les livreras au massacre et tout le pays au pillage."
,"12":"Car aussi vrai que je suis vivant et que mon royaume est puissant, ce que ma bouche a dit, mes mains le feront."
,"13":"Quant à toi, ne désobéis à aucun des ordres de ton seigneur! Exécute point par point tout ce que je t'ai ordonné et exécute-le sans retard!'"
,"14":"Holoferne se retira donc de la présence de son seigneur. Il appela les chefs, les généraux, les officiers de l'armée d'Assyrie."
,"15":"Il dénombra les hommes de guerre pour la bataille, comme son seigneur le lui avait ordonné; il y avait environ cent vingt mille hommes et douze mille archers à cheval."
,"16":"Il les organisa comme on organise une grande armée."
,"17":"Il prit des chameaux, des ânes et des mulets en grande quantité pour porter les bagages, et comme provisions il emmena des moutons, des boeufs et des chèvres en nombre incalculable."
,"18":"Il avait ainsi tout le ravitaillement nécessaire pour chaque homme, ainsi qu'une masse d'or et d'argent venant du palais royal."
,"19":"Il se mit en route avec toute son armée pour conquérir toutes les terres situées à l'occident. Avec ses chars, ses cavaliers et les fantassins, il précédait le roi Nabukodonozor."
,"20":"Un peuple nombreux comme des sauterelles ou comme la poussière de la terre, les accompagnait, leur nombre était tel qu'on ne pouvait les compter."
,"21":"Quittant Ninive, ils marchèrent trois jours dans la direction de la plaine de Bektilet. De Bektilet ils allèrent camper au pied de la montagne, à gauche de la Haute-Cilicie."
,"22":"Puis avec toute son armée, avec les fantassins, les cavaliers et les chars, Holoferne s'engagea dans la montagne."
,"23":"Il attaqua Pout et Loud, il rançonna tous les fils de Rassis et ceux d'Ismaël qui vivent à l'entrée du désert, au sud de Chéléon."
,"24":"Il longea l'Euphrate, il traversa la Mésopotamie, il dévasta toutes les villes qui dominaient le torrent d'Abrona jusqu'à arriver à la mer."
,"25":"Il s'empara des pays de la Cilicie, massacra tous ceux qui lui résistaient et arriva jusqu'aux limites méridionales de Jafet, en face de l'Arabie."
,"26":"Il encercla tout le peuple des Madianites, brûla leurs campements et pilla leurs parcs à brebis."
,"27":"Ensuite il descendit dans la plaine de Damas au moment de la fauche des blés, et il mit le feu aux moissons. Il extermina le petit et le gros bétail, il pilla les villes, dévasta les campagnes et tua tous les jeunes par l'épée."
,"28":"La terreur et l'épouvante s'emparèrent alors de tous les habitants de la côte, que ce soit à Sidon, à Tyr, à Sour, à Okina ou à Jamnia; les habitants d'Azot et d'Askalon étaient terrorisés."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Alors on lui envoya des messagers pour demander la paix:"
,"2":"'Nous sommes les serviteurs de Nabukodonozor, le grand roi. Nous voici devant toi, fais de nous ce qu'il te plaira."
,"3":"Voici nos fermes, nos villages, tous nos champs de blé, nos brebis et nos boeufs, tous nos campements et leurs enclos; tout cela est à toi, fais-en ce que tu voudras."
,"4":"Voici nos villes: leurs habitants sont tes esclaves. Viens, tu peux t'y présenter comme tu voudras. '"
,"5":"Ces messagers se présentèrent donc devant Holoferne et lui remirent leur message."
,"6":"Alors il descendit vers la côte avec son armée, il établit des garnisons dans toutes les villes fortifiées et il enrôla des hommes de guerre comme troupes auxiliaires."
,"7":"Les habitants de ces cités et des cités voisines le reçurent avec des couronnes et des danses accompagnées de tambourins."
,"8":"Cela ne l'empêcha pas de détruire leurs temples et de couper leurs arbres sacrés. Il avait reçu la mission d'exterminer tous les dieux des pays et d'obliger tous les peuples à ne plus adorer que le seul Nabukodonozor. Il devait obliger toute langue et toute race à l'invoquer comme un Dieu."
,"9":"C'est ainsi qu'il arriva dans la plaine d'Esdrelon, près de Dotaia, un village situé aux pieds de la grande chaîne de Judée."
,"10":"Il installa son camp entre Guéba et Scythopolis et il y resta tout un mois pour refaire ses forces."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Les Israélites qui habitaient en Judée apprirent tout ce qu'Holoferne, le général en chef de Nabukodonozor, roi des Assyriens, avait fait aux nations païennes, comment il avait dépouillé tous leurs temples et les avait laissés en ruines."
,"2":"A son approche, ils furent remplis d'une peur effroyable, avec une grande inquiétude pour Jérusalem et pour le Temple du Seigneur leur Dieu."
,"3":"En effet, ils rentraient à peine de la captivité, et depuis peu de temps seulement le peuple de Judée s'était rassemblé pour consacrer le mobilier, l'autel et le Temple, après leur profanation."
,"4":"Ils sonnèrent donc l'alerte dans toute la Samarie, à Kona, à Beth-Oron, à Belmaïn, à Jéricho, à Choba, à Esora et dans la vallée de Salem."
,"5":"On occupa les sommets des plus hautes montagnes et l'on fortifia les villages qui s'y trouvaient. Comme les champs venaient d'être moissonnés, on prépara des réserves de nourriture en vue de la guerre."
,"6":"Le grand prêtre Yoakim, qui était alors en place à Jérusalem, envoya des lettres aux habitants de Béthulie et Bétomestaïm, car ils faisaient face à la plaine d'Esdrelon et la vallée de Dotaïn."
,"7":"Il leur demandait d'occuper les défilés de la montagne qui étaient le seul chemin d'accès vers la Judée: il leur serait facile, disait-il, d'arrêter les ennemis, car les défilés étaient étroits et l'on ne pouvait passer que deux à la fois."
,"8":"Les Israélites exécutèrent les ordres du grand prêtre Yoakim et du conseil des anciens du peuple d'Israël qui siégeait à Jérusalem."
,"9":"De toutes leurs forces, tous les hommes d'Israël crièrent vers Dieu et s'humilièrent devant lui."
,"10":"Eux, leurs femmes, leurs enfants, leurs troupeaux, tous ceux qui vivaient avec eux, serviteurs ou esclaves, s'habillèrent de sacs."
,"11":"Tous les Israélites de Jérusalem, avec leurs femmes et leurs enfants, se prosternèrent devant le Temple, la tête couverte de cendre; ils tendirent les mains vers le Seigneur."
,"12":"L'autel lui-même fut recouvert d'un sac. Avec de grands cris, ils suppliaient d'un seul coeur le Dieu d'Israël de ne pas livrer leurs enfants à l'esclavage, leurs femmes au viol, leurs villes à la destruction, le Temple à la profanation et à la moquerie insolente des païens."
,"13":"Attentif à leur détresse, le Seigneur écouta leur appel. Dans toute la Judée et à Jérusalem, devant le Temple du Seigneur tout-puissant, le peuple jeûnait à longueur de journée. "
,"14":"Le grand prêtre Yoakim avec tous les prêtres et serviteurs du Seigneur qui se tenaient devant le Seigneur, habillés de sacs, offraient l'holocauste perpétuel, les offrandes et les dons volontaires du peuple;"
,"15":"et le turban couvert de cendre, de toutes leurs forces ils suppliaient le Seigneur de venir au secours de la maison d'Israël."
}`)
	CurrentBook.AddChapter(5, `{
"1":"On annonça à Holoferne, le général en chef de l'armée d'Assyrie, que les Israélites s'étaient préparés pour la guerre: ils avaient fermé les défilés de la montagne, fortifié les sommets des hautes montagnes et placé des obstacles dans les plaines."
,"2":"Il entra alors dans une très grande colère. Il rassembla tous les princes de Moab, tous les généraux d'Ammon, tous les gouverneurs de la côte:"
,"3":"'Hommes de Canaan, leur dit-il, renseignez-moi! Quel est ce peuple qui habite dans la montagne? Quelles sont les villes qu'il habite? Quelle est l'importance de leur armée et quels sont leurs points forts? Quel est le roi qui les gouverne et commande cette armée?"
,"4":"Pourquoi a-t-il refusé de venir au-devant de moi comme l'ont fait tous les habitants de la côte?'"
,"5":"Akior, le chef des Ammonites, lui répondit: 'Que mon seigneur daigne écouter les paroles que son serviteur va prononcer, je vais te dire la vérité sur ce peuple de la montagne qui habite tout près d'ici; aucun mensonge ne sortira de la bouche de ton serviteur."
,"6":"Ces gens descendent des Kaldéens."
,"7":"Ils ont habité d'abord en Mésopotamie, car ils ne voulaient pas suivre les dieux de leurs pères qui habitaient en Kaldée."
,"8":"Ils se sont séparés de la voie de leurs ancêtres, et ils ont adoré le Dieu du Ciel, le Dieu qu'ils avaient reconnu. On les chassa donc d'auprès de leurs dieux et ils se sont réfugiés en Mésopotamie où ils ont séjourné longtemps."
,"9":"Puis leur Dieu leur a ordonné de sortir du pays où ils séjournaient et de s'en aller au pays de Canaan. Là, ils se sont installés et ils ont amassé de l'or, de l'argent et de nombreux troupeaux."
,"10":"Comme la famine avait ravagé le pays de Canaan, ils sont descendus en Egypte pensant y rester le temps qu'ils devraient s'y nourrir. Mais là, ils sont devenus si nombreux"
,"11":"que le roi d'Egypte s'en est pris à eux et les a obligés à fabriquer des briques; on les humiliait et on les traitait comme des esclaves."
,"12":"Ils ont alors crié vers leur Dieu et il a frappé tout le pays d'Egypte de fléaux incurables; les Egyptiens les ont donc chassé loin d'eux."
,"13":"C'est alors que Dieu a desséché la mer Rouge devant eux"
,"14":"et les a conduits par la route du Sinaï vers Qadesh-Barné. Ils ont chassé devant eux tous ceux qui habitaient dans le désert,"
,"15":"puis ils se sont installés dans le pays des Amorites et ils ont été capables d'exterminer tous les habitants d'Hesh bon. Ensuite ils ont traversé le Jourdain et ont pris possession de toute la montagne."
,"16":"Ils ont chassé devant eux les Cananéens, les Périsites, les Jébusites, les Sikémites et tous les Girgashites, et ils se sont installés là pour longtemps."
,"17":"Tant qu'ils ne péchaient pas devant leur Dieu, tout allait bien pour eux, car leur Dieu déteste l'injustice."
,"18":"Mais quand ils se sont écartés de la voie qu'il leur avait tracée, une moitié d'entre eux a été complètement détruite par des guerres, et l'autre a été emmenée en captivité sur une terre étrangère. Le Temple de leur Dieu a été rasé et leurs villes sont tombées entre les mains de leurs ennemis."
,"19":"Alors, de nouveau, ils se sont tournés vers leur Dieu et ils sont revenus de la déportation. Ils sont rentrés des lieux où ils avaient été dispersés, de nouveau ils se sont installés à Jérusalem où se trouve leur Temple et ils ont repeuplé la montagne qui était restée déserte."
,"20":"Dans ces conditions, maître et seigneur, si ce peuple est en faute, s'ils ont péché contre leur Dieu - il faudra nous assurer qu'il y a bien chez eux cette cause de chute, - alors montons et attaquons-les."
,"21":"Mais si cette nation n'est pas en faute, que mon seigneur renonce, car leur Seigneur et Dieu les protégera, et toute la terre verra notre échec ridicule.'"
,"22":"Lorsqu'Akior eut fini de parler, tout le groupe qui était là rassemblé autour de la tente se mit à murmurer: les conseillers d'Holoferne, tous les habitants de la côte, ceux de Moab, voulaient même le frapper."
,"23":"Ils disaient: 'Nous n'avons rien à craindre des Israélites! Regardez, c'est un peuple sans force, incapable de résister à une attaque sérieuse,"
,"24":"attaquons-les! Notre armée n'en fera qu'une bouchée, seigneur Holoferne!'"
}`)
	CurrentBook.AddChapter(6, `{
"1":"Les hommes qui entouraient Holoferne finirent par se calmer. Alors le général en chef de l'armée des Assyriens dit à Akior devant tous les étrangers et tous les Moabites qui s'étaient rassemblés:"
,"2":"'Dis-moi Akior, qui êtes-vous, toi et tous les mercenaires d'Ephraïm, pour jouer les prophètes au milieu de nous comme tu le fais en ce moment, et pour nous dire de ne pas combattre les Israélites car leur Dieu les protégera? Qui donc est Dieu? N'est-ce pas Nabukodonozor? Il enverra ses forces, il les fera disparaître de la terre et leur Dieu ne les délivrera pas."
,"3":"Nous, ses serviteurs, nous les frapperons comme un seul homme et ils ne résisteront pas à la force de nos chevaux."
,"4":"Nous les brûlerons chez eux, leur montagne sera baignée de leur sang, leurs plaines remplies de leurs cadavres; ils ne tiendront pas devant nous et ils mourront tous, - parole du roi Nabukodonozor, le seigneur de toute la terre. Il a parlé, et les paroles qu'il a dites ne passeront pas."
,"5":"Et toi, Akior, le mercenaire d'Ammon, puisque tu as prononcé ces paroles dans un moment de folie, tu ne verras plus mon visage désormais, jusqu'au jour où j'aurai tiré vengeance du peuple sorti d'Egypte."
,"6":"Alors le fer de mon armée et les lances de mes soldats te transperceront; tu tomberas mort au milieu de leurs blessés le jour où je reviendrai."
,"7":"Maintenant mes serviteurs vont te conduire dans la montagne et te déposer dans l'une des villes qui sont sur le sommet,"
,"8":"et c'est avec leurs habitants que tu mourras."
,"9":"Pourquoi prends-tu cet air abattu si tu comptes réellement qu'ils ne seront pas tués? Voici que j'ai parlé, aucune de mes paroles ne restera sans effet.'"
,"10":"Holoferne appela ses serviteurs qui se tenaient dans sa tente, il leur ordonna de prendre Akior, de le conduire à Béthulie et de le remettre aux mains des Israélites."
,"11":"Les serviteurs le prirent, le conduisirent dans la plaine hors du camp, puis de là ils partirent vers la montagne et arrivèrent aux sources qui sont au pied de Béthulie."
,"12":"Les hommes de la ville les aperçurent du sommet de la montagne, ils prirent leurs armes et sortirent de la ville pour gagner le sommet de la montagne. Et tous ceux qui avaient une fronde lançaient des pierres aux serviteurs d'Holoferne pour les empêcher de monter."
,"13":"Alors ils s'abritèrent au pied de la montagne et ligotèrent Akior. Ils le laissèrent ainsi en cet endroit, puis ils s'en retournèrent vers leur maître."
,"14":"Les Israélites descendirent alors de la ville, ils s'arrêtèrent près de lui et défirent ses liens. Puis ils le conduisirent à Béthulie et le présentèrent aux chefs de la ville:"
,"15":"c'étaient Osias fils de Michée, de la tribu de Siméon, Chabris fils de Gotoniel, et Charmis fils de Melkiel."
,"16":"Ces hommes convoquèrent les anciens de la ville, mais tous les jeunes gens et toutes les femmes se précipitèrent aussi à cette assemblée; Akior était là au milieu de la foule. Osias l'interrogea et lui demanda ce qui était arrivé."
,"17":"Prenant la parole, il leur raconta ce qui s'était passé au conseil d'Holoferne, ce qu'il avait dit lui-même devant les chefs Assyriens et les paroles arrogantes d'Holoferne quand il menaçait la maison d'Israël."
,"18":"Alors le peuple se prosterna, adora Dieu et lui adressa cet appel:"
,"19":"'Seigneur, Dieu du ciel, regarde l'orgueil sans mesure de cet homme. Prends en pitié l'humiliation de notre peuple. Montre aujourd'hui à ceux qui te sont consacrés un visage plein de bonté.'"
,"20":"On encouragea Akior et on le félicita chaleureusement;"
,"21":"quittant l'assemblée, Osias emmena Akior chez lui. Il offrit un repas aux anciens et toute la nuit on supplia Dieu de venir au secours d'Israël."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Le lendemain, Holoferne ordonna à toute son armée et à toutes les troupes auxiliaires qui étaient venues avec lui, de lever le camp pour Béthulie. Elles devaient occuper les pentes de la montagne et livrer bataille aux Israélites."
,"2":"Ce jour-là même, tous les soldats levèrent le camp; il y avait environ cent soixante-dix mille fantassins et douze mille cavaliers, sans compter ceux qui s'occupaient des bagages et la foule considérable qui les accompagnait."
,"3":"Ils s'engagèrent dans le vallon qui est au pied de Béthulie, en direction de la source: ils avançaient depuis Dotaïn jusqu'à Belbaïn, et depuis Béthulie jusqu'à Cyamon, qui se trouve en face d'Esdrelon."
,"4":"Lorsque les Israélites aperçurent cette foule immense, saisis de peur ils se dirent entre eux: 'Maintenant ils vont raser tout le pays! Ni les sommets les plus élevés, ni les gorges les plus profondes, ni les collines ne résisteront devant eux!'"
,"5":"Chacun prit alors ses armes, on alluma des feux sur les tours et on monta la garde toute la nuit."
,"6":"Le deuxième jour, Holoferne étala toute sa cavalerie sous les yeux des Israélites de Béthulie."
,"7":"Il inspecta soigneusement les sentiers qui montaient vers la ville ainsi que les sources d'eau; il les occupa, il y mit des postes de soldats, et lui-même retourna à son armée."
,"8":"Les princes d'Esaü, les chefs des Moabites et les généraux de la région de la côte, s'approchèrent de lui et lui dirent:"
,"9":"'Que notre maître veuille bien nous écouter et pas un de ses hommes ne sera blessé."
,"10":"Le peuple d'Israël compte plus sur la hauteur des montagnes qu'il habite que sur ses lances, car il n'est pas facile d'escalader ces montagnes."
,"11":"Alors, maître, si tu ne veux perdre aucun de tes hommes, n'engage pas contre eux une bataille en règle."
,"12":"Reste dans ton camp et garde avec toi tous les hommes de ton armée, il suffit d'envoyer quelques uns de tes serviteurs pour interdire l'accès de la source qui est au pied de la montagne."
,"13":"Puisque c'est là que les habitants de Béthulie viennent chercher l'eau, la soif les obligera à te livrer leur ville. Pendant ce temps, nous et nos gens, nous monterons sur les crêtes des montagnes les plus proches et nous y établirons des camps de sorte que personne ne puisse sortir de la ville."
,"14":"Ils seront dévorés par la faim, eux, leurs femmes et leurs enfants, et sans même que l'épée ne les frappe, nous les trouverons étendus dans les rues, devant leurs maisons."
,"15":"C'est le bon moyen de leur faire payer cher leur révolte et leur refus de venir pacifiquement à ta rencontre.'"
,"16":"Ce discours plut à Holoferne et à tous ses officiers, et il décida de suivre leur avis."
,"17":"On envoya donc une troupe de Moabites, et avec eux cinq mille Assyriens. Ils se glissèrent dans le vallon, s'emparèrent des sources et des points d'eau des Israélites."
,"18":"Pendant ce temps, les Edomites et les Ammonites montèrent, prirent position dans la montagne en face de Dotaïn, et envoyèrent une partie de leurs hommes vers le sud et vers l'est, en face d'Egrebel, qui est proche de Chous, sur le torrent de Mochmour. Le reste de l'armée assyrienne s'installa dans la plaine: elle couvrait toute la région. La foule était considérable et les tentes et les bagages formaient un campement énorme."
,"19":"Les Israélites crièrent vers leur Seigneur, leur Dieu. Ils avaient perdu courage en voyant que les ennemis les entouraient et leur coupaient toute retraite."
,"20":"Cela faisait trente-quatre jours que l'armée Assyrienne avec ses fantassins, ses chars et ses cavaliers, les tenaient encerclés; les habitants de Béthulie voyaient toutes les cruches d'eau et toutes les citernes se vider peu à peu."
,"21":"L'eau était rationnée et l'on ne buvait plus à sa soif."
,"22":"Les enfants faisaient peine à voir, les femmes et les jeunes gens tombaient de soif, ils tombaient sans force dans les rues et jusqu'aux portes de la ville."
,"23":"C'est alors que tout le peuple, jeunes gens, femmes et enfants, fit une manifestation bruyante. Ils vinrent protester contre Osias et les anciens de la ville:"
,"24":"'Que Dieu juge entre vous et nous! Vous nous avez fait un tort immense! Il fallait traiter avec les Assyriens!"
,"25":"Maintenant il n'y a plus personne pour nous secourir, Dieu nous a abandonnés entre leurs mains, nous sommes terrassés par la soif sous leurs yeux et nous allons tous mourir."
,"26":"Il faut les appeler tout de suite et accepter que la ville soit mise au pillage par les gens d'Holoferne et toute son armée."
,"27":"De toutes façons, il vaut beaucoup mieux pour nous de tomber entre leurs mains. Certainement nous serons leurs esclaves, mais au moins, nous n'assisterons pas à la mort de nos nourrissons, ni à celle de nos femmes et de nos enfants."
,"28":"Nous vous supplions au nom du ciel et de la terre, au nom du Dieu et Seigneur de nos pères, qui nous punit à cause de nos fautes et des fautes de nos pères: faites aujourd'hui même ce que nous vous demandons.'"
,"29":"Toute la foule se lamentait et criait à haute voix vers le Seigneur Dieu."
,"30":"Osias leur dit: 'Reprenez courage, mes frères, tenons encore cinq jours! Sûrement le Seigneur aura pitié de nous, il ne nous abandonnera pas jusqu'au bout."
,"31":"Mais si au bout de cinq jours aucun secours ne nous est arrivé, je suivrai votre avis.'"
,"32":"Il renvoya la foule qui se dispersa dans la ville. Les hommes retournèrent aux remparts et aux tours, pendant que femmes et enfants rentraient à la maison, mais la ville tout entière était plongée dans une profonde angoisse"
}`)
	CurrentBook.AddChapter(8, `{
"1":"C'est alors qu'intervint Judith. Elle était fille de Mérari, fils d'Ox, fils de Joseph, fils d'Oziel, fils d'Elkia, fils d'Ananias, fils de Gédéon, fils de Rafen, fils d'Akitob, fils d'Elias, fils d'Helkias, fils d'Eliab, fils de Nathanaël, fils de Salamiel, fils de Sarasadé, fils d'Israël."
,"2":"Son mari, Manassé, qui était de sa tribu et de sa famille, était mort pendant la moisson des orges:"
,"3":"pendant qu'il surveillait ceux qui liaient les gerbes dans les champs, il attrapa une insolation, il se coucha et mourut dans sa ville de Béthulie. On l'enterra avec ses pères, dans le champ qui se trouve entre Dotaïn et Balamon."
,"4":"Cela faisait trois ans et quatre mois que Judith restait veuve en sa maison."
,"5":"Elle s'était fait une tente sur le toit de sa maison, elle portait un sac à même le corps, et par-dessus, ses vêtements de veuve."
,"6":"Elle jeûnait tous les jours, sauf la veille du sabbat, le jour même du sabbat, la veille des nouvelles lunes, au jour des nouvelles lunes, et les jours de fête et de joie en Israël."
,"7":"Elle était très belle et pleine de charme; Manassé, son mari, lui avait laissé de l'or, de l'argent, des serviteurs, des servantes, du bétail et des champs, et elle restait à la tête de cette fortune."
,"8":"Elle était très pieuse et on ne pouvait rien lui reprocher."
,"9":"Or voici qu'elle apprit comment le peuple, découragé par le manque d'eau, avait protesté contre les chefs. Elle apprit aussi la réponse d'Osias, et comment il avait promis de livrer la ville aux Assyriens au bout de cinq jours."
,"10":"Alors elle envoya aux anciens de la ville, Chabris et Charmis, la servante qui administrait tous ses biens."
,"11":"Lorsqu'ils se présentèrent chez elle, elle leur dit: 'Ecoutez-moi bien, chefs des habitants de Béthulie! Vous avez eu tort de parler aujourd'hui comme vous l'avez fait devant le peuple, et de vous engager par serment devant Dieu, à livrer la ville à nos ennemis si le Seigneur ne vous envoyait pas ces jours-ci du secours."
,"12":"Qui êtes-vous donc pour mettre Dieu aujourd'hui à l'épreuve et pour prendre la place de Dieu au milieu des hommes?"
,"13":"Vous venez de lancer un défi au Seigneur Tout-Puissant, alors que jamais vous ne serez capables de le comprendre!"
,"14":"Vous n'êtes pas capables de démêler ce qui se passe dans le coeur de l'homme, ni de saisir les raisonnements de son esprit, et vous voulez pénétrer le mystère de Dieu qui a fait toutes ces choses, comprendre son esprit et saisir sa pensée?,Non, non, mes frères! Ne mettez pas en colère le Seigneur notre Dieu, "
,"15":"car s'il ne veut pas nous secourir pendant ces cinq jours, il a le pouvoir de nous protéger lorsqu'il lui plaira, et il peut aussi nous détruire sous les yeux de nos ennemis."
,"16":"Le Seigneur a ses plans, n'exigez pas de lui des garanties. On ne fait pas de menaces à Dieu comme à un homme et on ne l'achète pas non plus comme un homme."
,"17":"C'est pourquoi, attendez avec patience le salut qu'il voudra bien nous envoyer. Appelons-le à notre secours, et s'il le veut, il écoutera notre prière."
,"18":"C'est un fait qu'aujourd'hui, à notre époque, il n'y a plus aucune de nos tribus ou de nos familles, plus aucune de nos villes ou de nos villages, qui adore des dieux fabriqués par les hommes, comme cela était arrivé autrefois."
,"19":"Or c'est à cause de cela que nos pères furent livrés à l'épée et à la ruine, et qu'ils connurent un tel désastre face à leurs ennemis."
,"20":"Nous, nous n'avons pas servi d'autres dieux que lui, aussi pouvons-nous espérer qu'il n'oubliera ni nous, ni notre peuple."
,"21":"Mais voyez: si nous capitulons, toute la Judée sera prise et notre Temple saint sera pillé. Dieu se vengera sur nous de cette profanation,"
,"22":"il fera retomber sur nous le massacre de nos frères, la déportation des habitants et la ruine de notre héritage. Nous deviendrons esclaves des nations païennes et nous serons pour nos nouveaux maîtres un exemple d'humiliation et de honte."
,"23":"Le Seigneur n'aura pas pitié de nous dans notre esclavage, il en fera au contraire une punition honteuse."
,"24":"Si nous croyons que la vie de nos frères dépend de la nôtre et que le sort du Lieu Saint, du Temple, et de l'autel, sont entre nos mains, montrons-le."
,"25":"Mais surtout, rendons grâce au Seigneur notre Dieu, qui nous met à l'épreuve comme il l'a fait pour nos pères."
,"26":"Rappelez-vous ce qu'il a fait pour Abraham, les épreuves qu'il a envoyées à Isaac et tout ce qui est arrivé à Jacob en Mésopotamie, en Syrie, lorsqu'il gardait les troupeaux de Laban, le frère de sa mère."
,"27":"Dieu ne nous a pas soumis comme eux à l'épreuve du feu, il ne nous a pas condamnés non plus, mais il nous a frappés comme il corrige ceux qui le touchent de près.'"
,"28":"Osias lui répondit: 'Tout ce que tu viens de dire est plein de bon sens et personne ne trouvera à y redire."
,"29":"Ce n'est d'ailleurs pas la première fois que ta sagesse se manifeste. Depuis ta jeunesse, tout le peuple a reconnu ton intelligence et tu juges toute chose avec droiture."
,"30":"Mais le peuple souffre tellement de la faim qu'il nous a obligés à faire ce que nous lui avons promis, et il nous a fait prêter un serment que nous ne pouvons pas violer."
,"31":"Maintenant prie pour nous, car tu es une sainte femme; si le Seigneur envoyait la pluie pour remplir nos citernes, nous retrouverions des forces.'"
,"32":"Judith leur dit: 'Ecoutez-moi, je vais faire quelque chose d'extraordinaire qui se racontera de génération en génération dans notre peuple."
,"33":"Soyez cette nuit à la porte de la ville pour que je sorte avec ma servante. Avant la fin du délai que vous avez fixé pour livrer la ville aux ennemis, le Seigneur se servira de moi pour secourir Israël."
,"34":"Ne cherchez pas à savoir ce que je vais faire, je ne vous dirai rien avant que tout cela ne soit accompli.'"
,"35":"Osias et les chefs lui dirent: 'Va en paix! Que le Seigneur guide tes pas et fasse justice de nos ennemis!'"
,"36":"Et sortant de la tente, ils rejoignirent leur poste."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Judith tomba la face contre terre, elle répandit de la cendre sur sa tête, elle laissa voir le sac dont elle était habillée, et à l'heure même où, à Jérusalem, dans le Temple de Dieu, on offrait l'encens du soir, Judith supplia le Seigneur à haute voix:"
,"2":"'Seigneur, Dieu de mon père Siméon, tu as mis dans sa main l'épée pour punir des étrangers qui avaient fait violence à une vierge et l'avaient souillée: ils l'avaient déshabillée pour la déshonorer et avaient profané son sein pour sa honte. Tu avais dit: Surtout pas cela! Et ils l'avaient fait."
,"3":"C'est pourquoi tu as livré leurs chefs au massacre et tu as fait de leur couche souillée par leur crime, un lit de sang. Tu as frappé les esclaves avec les princes et les princes avec leurs serviteurs."
,"4":"Tu as livré leurs femmes au viol, leurs filles à la captivité; toutes leurs richesses ont été pillées par tes fils bien-aimés qui avaient brûlé de zèle pour toi: ils avaient en horreur la souillure infligée à leur race et ils t'avaient appelé à leur secours. O Dieu, ô mon Dieu! Exauce la veuve que je suis. "
,"5":"C'est toi qui as fait le passé, le présent et l'avenir. Tu connais le présent et l'avenir, et tel que tu le connais, il se réalise."
,"6":"Les choses que tu as voulues viennent à ta rencontre, elles disent: Nous sommes là! Car toutes tes voies sont préparées et tes jugements sont prévus d'avance."
,"7":"Regarde ces Assyriens: ils mettent leur confiance dans leur armée, ils sont fiers de leurs chevaux et de leur cavalerie. Ils sont orgueilleux de la force de leurs fantassins, ils comptent sur leurs lances et leurs boucliers, sur leurs arcs et leurs frondes, mais ils n'ont pas reconnu que c'est toi, le Seigneur, qui brise la guerre!"
,"8":"Ton Nom est 'le Seigneur', et tu briseras leur force par ta puissance. Tu les fracasseras dans ta colère, car ils ont voulu profaner ton Lieu Saint, souiller la Tente où habite ton Nom glorieux et renverser ton autel par l'épée."
,"9":"Regarde leur insolence, envoie sur eux ta colère! Donne à ma main de veuve la force nécessaire."
,"10":"Par la ruse de mes lèvres, frappe l'esclave avec le chef et le chef avec son serviteur. Brise leur orgueil par la main d'une femme!"
,"11":"Ta force n'est pas avec les plus nombreux, ni ta puissance avec les violents, mais tu es le Dieu des humbles. Tu es le secours des opprimés, tu es la force des faibles, tu es l'abri de ceux qui sont abandonnés et le sauveur de ceux qui sont sans espoir."
,"12":"Oui! Dieu de mon père, Dieu qui es l'héritage d'Israël! Toi, le Maître du ciel et de la terre, le Créateur des eaux, le Roi de toute la création, exauce ma prière."
,"13":"Donne-moi la parole qui séduit, pour blesser et pour tuer ceux qui ont fait de si cruels projets contre ton alliance, ta sainte Maison, la montagne de Sion et la maison qui appartient à tes fils."
,"14":"Montre à tous les peuples et à toute tribu que tu es le Seigneur, le Dieu tout puissant et fort, et que le peuple d'Israël n'a pas d'autre sauveur que toi.'"
}`)
	CurrentBook.AddChapter(10, `{
"1":"Quand Judith termina de crier vers le Dieu d'Israël, quand elle eut mis fin à sa prière,"
,"2":"elle se releva, appela sa servante et descendit dans la maison comme elle faisait les jours de sabbat et les jours de fête."
,"3":"Elle enleva le sac qu'elle portait sur son corps et quitta ses habits de deuil, elle prit un bain, se parfuma abondamment, peigna ses cheveux; elle se mit un turban et enfila une robe de fête qu'elle portait du vivant de son mari Manassé."
,"4":"Elle mit des sandales, elle passa ses colliers, ses bracelets, ses bagues, ses boucles d'oreilles, en un mot, tous ses bijoux. Elle se fit, on ne peut plus belle: rien qu'à la voir, n'importe quel homme aurait été séduit. "
,"5":"Elle confia à sa servante une outre de vin, une jarre d'huile, elle mit dans un sac des grains rôtis, un gâteau de figues et des pains purs; elle enveloppa le tout soigneusement et le lui donna."
,"6":"Elles sortirent toutes deux par la porte de la ville de Béthulie; là se trouvaient Osias et les anciens de la ville Chabris et Charmis."
,"7":"Lorsqu'ils la virent changée d'aspect et si belle dans ses vêtements, ils furent émerveillés de sa beauté. Ils lui dirent:"
,"8":"'Que le Dieu de nos pères te garde en sa bonté et qu'il te permette de réaliser tes projets pour la joie des fils d'Israël et la gloire de Jérusalem!'"
,"9":"Elle adora Dieu puis elle leur dit: 'Ordonnez qu'on m'ouvre la porte de la ville et je sortirai pour faire cela même que vous venez de dire.' Alors ils ordonnèrent aux gardes de lui ouvrir, comme elle l'avait demandé."
,"10":"On ouvrit la porte et Judith sortit avec sa servante; les hommes de la ville la suivirent du regard pendant qu'elle descendait de la montagne, puis lorsqu'elle franchit le vallon; ensuite ils ne la virent plus."
,"11":"Comme elle marchait tout droit dans le vallon, des éclaireurs assyriens vinrent à sa rencontre."
,"12":"Ils l'arrêtèrent et lui demandèrent: 'De quel côté es-tu? D'où viens-tu et où vas-tu?' Elle répondit: 'Je suis une fille des Hébreux et je m'enfuis, car ils ne vont pas tarder à être livrés au pillage."
,"13":"Et moi, je viens voir Holoferne, le général en chef de votre armée, pour lui donner des renseignements précis. Je vais lui indiquer un chemin par lequel il pourra passer pour se rendre maître de toute la montagne, sans aucun risque pour ses hommes.'"
,"14":"Les soldats qui la voyaient et l'entendaient parler ainsi lui dirent:"
,"15":"'Tu as eu bien raison de descendre au plus vite pour aller voir notre seigneur. Va donc le trouver dans sa tente. Quelques-uns d'entre nous vont t'accompagner et te remettront entre ses mains."
,"16":"Lorsque tu seras devant lui, n'aie pas peur, mais dis-lui bien tout ce que tu as à lui dire et il te le revaudra.'"
,"17":"Ils choisirent donc cent hommes qui se joignirent à elle et à sa servante et qui les conduisirent toutes deux à la tente d'Holoferne."
,"18":"De tout le camp on accourut, car la nouvelle de sa présence s'était répandue dans les tentes. On se rassemblait autour d'elle pendant qu'elle attendait devant la tente d'Holoferne à qui l'on avait annoncé son arrivée."
,"19":"Tous étaient émerveillés de sa beauté et, à travers elle, ils admiraient les Israélites. Ils se disaient l'un à l'autre: 'Qui pourrait mépriser un peuple qui possède de si belles femmes? Il n'est pas bon d'en laisser un seul en vie, ceux qui resteraient seraient capables de séduire toute la terre.'"
,"20":"Les gardes d'Holoferne et tous ses officiers sortirent, ils la firent entrer dans la tente."
,"21":"A ce moment Holoferne était étendu sur son lit, sous une draperie de pourpre et d'or brodée d'émeraudes et de pierres précieuses."
,"22":"Dès qu'on lui parla d'elle, il vint à sa rencontre dans le vestibule de la tente, précédé de flambeaux d'argent."
,"23":"Lorsque Judith arriva devant lui et devant ses officiers, tous furent émerveillés de sa beauté; quant à elle, elle tomba la face contre terre et se prosterna devant lui. Les serviteurs d'Holoferne la relevèrent."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Holoferne lui dit: 'Courage, ma fille, ne crains pas, car je n'ai jamais fait de mal à ceux qui choisissent de servir Nabukodonozor, le roi de toute la terre."
,"2":"Si ton peuple qui habite la montagne ne m'avait pas défié, je n'aurais pas combattu contre eux. Ce sont eux qui l'ont voulu."
,"3":"Dis-moi donc à présent pourquoi t'es-tu enfuie de chez eux pour venir chez nous. Tu as sûrement sauvé ta vie en venant. N'aie pas peur, dès cette nuit tu vivras, et cela continuera par la suite."
,"4":"Personne ici ne te fera du mal. Au contraire, tu seras aussi bien traitée que les autres serviteurs de mon seigneur, le roi Nabukodonozor.'"
,"5":"Judith lui dit: 'Ecoute les paroles de ta servante, permets que ta servante te parle, et cette nuit je ne dirai aucun mensonge."
,"6":"Si tu fais exactement ce que te dit ta servante, Dieu réalisera avec toi une grande chose, et mon Seigneur ne connaîtra pas l'échec dans son entreprise."
,"7":"Vive Nabukodonozor, le roi de toute la terre, et vive la puissance de celui qui t'a envoyé pour remettre à leur place tous les vivants: grâce à toi, non seulement les hommes le servent, mais encore les bêtes des champs, le bétail et les oiseaux du ciel vivent pour Nabukodonozor et toute sa maison, grâce à ta force."
,"8":"On nous a parlé de ta sagesse et de toutes les ressources de ton esprit. Par toute la terre on raconte que personne dans tout le royaume n'est aussi capable, aussi expérimenté et aussi redoutable que toi à la guerre."
,"9":"Or, tu le sais, nous sommes au courant des paroles qu'Akior a prononcé devant ton conseil, car les gens de Béthulie l'ont épargné et il nous a raconté tout ce qu'il avait dit devant toi."
,"10":"Eh bien, maître et seigneur, n'oublie pas ce qu'il a dit, mais garde-le bien présent à l'esprit, car c'est exact. On ne peut frapper notre race et la détruire par l'épée, que lorsqu'elle a péché contre son Dieu."
,"11":"Mais justement ils viennent de tomber dans le péché et chaque fois qu'ils se livrent au désordre, ils attirent la colère de leur Dieu. Mon seigneur ne va donc pas connaître l'échec, et la mort va tomber sur eux."
,"12":"En effet, voyant que la nourriture manque et que l'eau est rationnée, ils ont décidé de prendre dans leurs troupeaux et de garder pour eux ce que Dieu par ses lois leur interdit de manger."
,"13":"Ils ont même décidé de manger et de boire les prémices du blé, la dîme sur le vin et sur l'huile, qui sont pourtant consacrés et réservés aux prêtres qui assurent le service de notre Dieu à Jérusalem. Or personne dans le peuple n'a le droit même d'y toucher."
,"14":"Ils ont donc envoyé des gens à Jérusalem pour leur rapporter la permission du conseil des anciens, sachant que ceux qui habitent là-bas font pareil."
,"15":"Et dès qu'ils auront reçu cette permission et qu'ils passeront aux actes, ce jour-même ils seront livrés entre tes mains pour leur perte."
,"16":"Moi, ta servante, je connais bien tout cela et je me suis enfuie de chez eux; Dieu m'a envoyée pour réaliser avec toi des choses extraordinaires dont toute la terre sera étonnée lorsqu'on les apprendra."
,"17":"Ta servante est pieuse, et nuit et jour elle sert le Dieu du ciel. Je vais donc rester près de toi, mon seigneur, mais ta servante sortira de nuit dans le vallon; je prierai Dieu et il me dira quand ils auront commis ce péché."
,"18":"Aussitôt je t'avertirai, tu sortiras avec toute ton armée et personne parmi eux ne pourra te résister."
,"19":"Ensuite je te conduirai à travers toute la Judée jusqu'à Jérusalem, et je placerai ton trône au milieu de la ville. Tu les conduiras comme un berger conduit ses brebis, et pas un chien n'aboiera après toi. J'ai été avertie d'avance de tout cela; cela m'a été communiqué pour que je te le rapporte.'"
,"20":"Holoferne et ses officiers furent enchantés de ce discours. Ils étaient émerveillés de sa sagesse et disaient:"
,"21":"'Il n'y a pas sur toute la terre, d'une extrémité à l'autre, une femme aussi belle et aussi intelligente.'"
,"22":"Holoferne lui dit: 'Dieu a bien fait de t'envoyer en avant du peuple, ainsi la puissance restera entre nos mains et ceux qui ont méprisé mon seigneur n'auront que le malheur."
,"23":"Oui, tu es vraiment belle et tes paroles sont sages. Si tu fais comme tu l'as dit, ton Dieu sera mon Dieu, et toi, tu habiteras dans le palais du roi Nabukodonozor: tu seras célèbre dans le monde entier."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Holoferne ordonna alors de la conduire là où l'on avait préparé sa vaisselle d'argent, de lui servir de ses mets et de lui donner à boire de son vin."
,"2":"Mais Judith répondit: 'Je n'en mangerai pas, pour ne pas commettre de faute. J'ai apporté suffisamment avec moi.'"
,"3":"Holoferne lui dit: 'Si tes provisions viennent à se terminer, où pourrons-nous trouver une nourriture semblable pour te la donner? Car il n'y a avec nous personne de ta race.'"
,"4":"Mais Judith lui dit: 'Aussi vrai que tu es vivant, mon seigneur, ta servante n'aura pas fini de manger ses provisions que le Seigneur aura exécuté par ma main ce qu'il a projeté.'"
,"5":"Les officiers d'Holoferne la menèrent alors à sa tente. Elle dormit jusqu'au milieu de la nuit, puis elle se leva avant l'aube."
,"6":"Elle envoya prévenir Holoferne: 'Mon seigneur voudra bien ordonner qu'on laisse ta servante sortir pour la prière.'"
,"7":"Holoferne ordonna à ses gardes de ne pas l'empêcher. Elle resta trois jours dans le camp, mais la nuit elle se rendait dans le vallon de Béthulie, puis elle se baignait dans le camp établi à la source d'eau. "
,"8":"Lorsqu'elle remontait, elle priait le Seigneur, le Dieu d'Israël, de conduire ses pas pour le salut de son peuple."
,"9":"Une fois rentrée, purifiée, elle restait dans sa tente jusqu'au moment où on lui servait son repas du soir."
,"10":"Le quatrième jour, Holoferne fit un grand repas pour ses seuls conseillers; il n'invita aucun autre fonctionnaire."
,"11":"Mais il dit à Bagoas, l'eunuque de service: 'Va donc persuader cette fille des Hébreux qui est chez toi, de venir chez nous, pour manger et boire avec nous."
,"12":"Ce serait vraiment une honte pour nous de laisser partir une telle femme sans lui avoir parlé à notre façon. Si nous ne réussissons pas, elle se moquera bien de nous.'"
,"13":"Bagoas sortit donc de chez Holoferne et entra dans la tente de Judith. Il lui dit: 'Que cette belle servante n'hésite pas à venir chez mon seigneur. Elle sera entourée d'honneurs et elle boira avec nous le vin de la fête. Ce jour-là, elle sera comme l'une des femmes assyriennes qui sont à demeure dans le palais de Nabukodonozor.'"
,"14":"Judith répondit: 'Qui suis-je pour refuser l'invitation de mon Seigneur? Je ferai absolument tout ce qui est agréable à ses yeux, et ce sera pour moi une grande joie jusqu'au jour de ma mort.'"
,"15":"Elle se leva, mit ses vêtements de fête et tous ses bijoux; sa servante marchait devant elle. Elle étala pour elle sur le sol, devant Holoferne, les couvertures qu'elle avait reçues de Bagoas, pour son usage personnel. Ainsi elle pourrait s'installer à terre pour manger."
,"16":"Judith entra et s'installa par terre. Holoferne n'avait plus de regards que pour elle. Il en avait l'esprit troublé et il fut pris d'un violent désir de s'unir à elle. En effet, depuis le jour où il l'avait vue, il cherchait une occasion de la séduire."
,"17":"Il lui dit: 'Allez, bois, partage notre fête!'"
,"18":"Judith répondit: 'Je boirai donc seigneur, car, depuis que je suis au monde, jamais la vie ne m'a paru plus belle qu'aujourd'hui.'"
,"19":"Elle se servit, mangea et but à côté de lui ce que sa servante avait préparé."
,"20":"Quant à Holoferne, il était si joyeux de sa présence qu'il but énormément de vin, beaucoup plus qu'il n'en avait jamais bu en un seul jour depuis sa naissance."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Lorsqu'il se fit tard, ses officiers sortirent; Bagoas ferma la porte de l'extérieur, après avoir mis dehors ceux qui étaient encore là. Tout le monde partit se coucher,"
,"2":"épuisé par l'excès de la boisson, tandis que Judith restait seule dans la tente avec Holoferne écroulé sur son lit et noyé dans son vin."
,"3":"Judith avait dit à sa servante de se tenir hors de la chambre à coucher et de guetter sa sortie comme chaque jour. Elle devait sortir, avait-elle dit, pour faire sa prière, et elle avait dit la même chose à Bagoas."
,"4":"Lorsque tout le monde fut sorti et qu'il n'y eut personne, petit ou grand, dans la chambre à coucher, Judith se tint à côté du lit d'Holoferne et fit cette prière au plus profond de son coeur: 'Seigneur, Dieu de toute puissance, pose ton regard à cette heure sur ce que je vais faire pour la gloire de Jérusalem!"
,"5":"C'est maintenant le moment de venir en aide à ton peuple et de faire réussir mon entreprise pour la ruine des ennemis qui se sont dressés contre nous.'"
,"6":"Alors elle s'avança vers la traverse du lit qui était à la tête d'Holoferne, elle en décrocha son épée."
,"7":"Elle s'approcha du lit et le saisit par ses cheveux: 'Seigneur,dit-elle, Dieu d'Israël, donne-moi aujourd'hui ta force!'"
,"8":"Elle le frappa à deux reprises au cou, de toutes ses forces, et lui coupa la tête."
,"9":"Elle fit rouler son corps en bas du lit et décrocha la draperie de ses colonnes; elle sortit ensuite, donnant la tête d'Holoferne à sa servante."
,"10":"Vite, elle la mit dans le sac à provisions et toutes deux partirent ensemble, comme elles le faisaient chaque jour pour la prière. Elles traversèrent le camp, elle firent le tour du vallon et ensuite montèrent vers Béthulie pour se présenter devant la porte."
,"11":"Judith cria de loin à ceux qui montaient la garde près des portes: 'Ouvrez! Ouvrez vite la porte! Dieu, notre Dieu est avec nous! Aujourd'hui il a manifesté sa force en Israël et montré sa puissance à nos ennemis!'"
,"12":"Dès que les hommes de la ville entendirent sa voix, ils se dépêchèrent de descendre vers la porte de la ville et appelèrent les anciens."
,"13":"Tout le monde accourut, du plus petit jusqu'au plus grand, car on ne s'attendait pas à son retour! Ils ouvrirent la porte et accueillirent les deux femmes. Ils allumèrent un feu pour éclairer et se rassemblèrent autour d'elles."
,"14":"Judith leur dit alors d'une voix forte: 'Louez Dieu! Louez-le! Louez Dieu qui n'a pas été infidèle à la maison d'Israël, mais qui, cette nuit, a écrasé nos ennemis par ma main!'"
,"15":"A ces mots, elle tira la tête de son sac et la leur montra: 'Voici la tête d'Holoferne, le général en chef de l'armée des Assyriens, et voici la draperie sous laquelle il gisait ivre mort. Le Seigneur l'a frappé par la main d'une femme."
,"16":"Oui! Aussi vrai que le Seigneur est vivant, lui qui m'a gardé sur le chemin où j'ai marché, mon visage l'a séduit pour sa perte, mais il ne m'a ni souillée, ni déshonorée par le péché.'"
,"17":"Tout le monde était saisi de stupeur, on se prosternait, on adorait Dieu et tous ensemble disaient: 'Béni sois-tu ô notre Dieu, toi qui en ce jour as réduit à rien les ennemis de ton peuple!"
,"18":"Osias lui dit: 'Tu es bénie, ma fille, par le Dieu Très-Haut, plus que toutes les femmes de la terre!,Béni soit le Seigneur Dieu, Créateur du ciel et de la terre, qui a fait réussir ton projet: tu as donc tranché la tête du chef de nos ennemis!"
,"19":"Désormais tous ceux qui voudront rappeler les exploits de Dieu auront présente à l'esprit ton espérance."
,"20":"Que Dieu te comble d'honneurs et de toutes sortes de biens, car tu as su risquer ta propre vie pour notre race humiliée, tu nous as sauvé de la ruine en faisant de ton mieux les oeuvres de notre Dieu.',Tout le peuple répondit: 'Amen! Amen!'"
}`)
	CurrentBook.AddChapter(14, `{
"1":"Judith leur dit: 'Ecoutez-moi, frères, prenez cette tête et suspendez-la au créneau du rempart."
,"2":"Et lorsque le jour se lèvera, lorsque le soleil paraîtra sur la terre, que chacun prenne ses armes. Tous les hommes valides sortiront de la ville avec un chef à leur tête, comme si vous alliez descendre dans la plaine vers les avant-postes des Assyriens. Mais vous ne descendrez pas."
,"3":"Alors ils prendront leurs armes, ils iront au camp pour réveiller les généraux de l'armée d'Assyrie, et ceux-ci à leur tour courront vers la tente d'Holoferne. En ne le voyant pas, ils seront pris de panique et prendront la fuite devant vous."
,"4":"Alors vous les poursuivrez, vous et tous ceux qui habitent sur le territoire d'Israël et vous les abattrez sur les chemins."
,"5":"Mais pour commencer, appelez-moi Akior l'Ammonite, pour qu'il voie et reconnaisse celui qui a méprisé la maison d'Israël, celui qui l'avait envoyé au milieu de nous comme on envoie un homme à la mort.'"
,"6":"On partit donc chercher Akior chez Osias. Lorsqu'il fut là et qu'il vit la tête d'Holoferne que l'un des hommes de l'assemblée tenait à la main, il tomba la face contre terre, évanoui."
,"7":"On le releva; alors il se jeta aux pieds de Judith et se prosterna devant elle en disant: 'Bénie sois-tu dans tous les foyers de Juda et parmi tous les peuples! Tous ceux qui entendront prononcer ton nom, seront frappés d'étonnement."
,"8":"Maintenant, dis-moi ce que tu as fait durant ces jours.',Et Judith lui raconta devant tout le peuple ce qu'elle avait fait, depuis le jour où elle était sortie jusqu'à ce moment où elle leur parlait. "
,"9":"Quand elle eut cessé de parler, le peuple acclama à grands cris et fit entendre dans toute la ville des cris de joie."
,"10":"En voyant ce que le Dieu d'Israël avait fait, Akior crut fermement en Dieu et se fit circoncire; c'est ainsi qu'il est entré dans le peuple d'Israël."
,"11":"Au lever du jour, on accrocha la tête d'Holoferne au rempart; tous les hommes prirent leurs armes et sortirent par groupes vers les pentes de la montagne."
,"12":"Lorsque les Assyriens les aperçurent, ils partirent prévenir leurs chefs. Ceux-ci allèrent trouver les généraux et tous les officiers supérieurs."
,"13":"Eux se présentèrent à la tente d'Holoferne et dirent à celui qui était chargé de toutes ses affaires: 'Réveille notre seigneur! Ce peuple d'esclaves est maintenant assez téméraire pour descendre et nous attaquer! Ils veulent vraiment se faire massacrer jusqu'au dernier.'"
,"14":"Bagoas entra et frappa des mains à la porte de la tente, car il pensait qu'Holoferne dormait avec Judith."
,"15":"Mais comme personne ne semblait répondre, il écarta la tenture, entra dans la chambre à coucher et le trouva par terre, mort et décapité."
,"16":"Il poussa un cri déchirant, il pleurait, gémissait, hurlait, déchirait ses vêtements."
,"17":"Puis il entra dans la tente où logeait Judith: elle n'était plus là. Alors il sortit comme un fou vers l'armée en criant:"
,"18":"'Ces esclaves nous ont eus! Une seule femme de chez les Hébreux a couvert de honte la maison du roi Nabukodonozor! Holoferne est sur le sol, sans tête!'"
,"19":"En entendant cela, les chefs de l'armée d'Assyrie déchirèrent leurs vêtements; ils en étaient si bouleversés qu'ils se lamentaient et poussaient de grands cris au milieu du camp!"
}`)
	CurrentBook.AddChapter(15, `{
"1":"En apprenant ce qui s'était passé, ceux qui étaient dans les tentes ne savaient plus que penser."
,"2":"La peur, la terreur, fondirent sur eux, et ils commencèrent à se disperser sans plus se préoccuper les uns des autres, prenant la fuite par tous les chemins de la plaine et de la montagne."
,"3":"Ceux qui campaient sur les montagnes autour de Béthulie prirent la fuite eux aussi. Alors les Israélites, tous ceux qui étaient en état de se battre, fondirent sur eux. "
,"4":"Osias fit porter des messages à Bétomestaïm, à Bèbé, à Chobé, à Kola, dans tout le territoire d'Israël, pour faire savoir ce qui s'était passé et inviter tout le monde à se jeter sur les ennemis et à les anéantir."
,"5":"A peine avertis, les hommes d'Israël tombèrent sur tous ceux qui fuyaient et ils les frappèrent jusqu'à Choba. Ceux de Jérusalem et de toute la montagne se joignirent à eux car ils avaient appris eux aussi ce qui était arrivé dans le camp ennemi. Puis ce fut le tour des gens de Galaad et de Galilée qui les prirent sur le côté et les frappèrent sévèrement jusqu'à proximité de Damas et de sa région."
,"6":"Quant aux gens qui étaient restés à Béthulie, ils se jetèrent sur le camp des Assyriens; ils le pillèrent et ramassèrent un énorme butin."
,"7":"Les Israélites qui revenaient du massacre se servirent avec ce qui restait. Les gens des bourgs et des villages de la montagne et de la plaine eurent aussi leur part de butin puisqu'il y en avait partout."
,"8":"Le grand prêtre Yoakim et tout le conseil des anciens d'Israël qui étaient à Jérusalem, vinrent pour voir de plus près les bienfaits dont le Seigneur avait comblé Israël, pour voir Judith et pour la saluer."
,"9":"En entrant chez elle, tous la bénissaient d'une seule voix: 'Tu es la gloire de Jérusalem!,Tu es la joie et l'orgueil d'Israël!,Tu es le grand honneur de notre race!"
,"10":"C'est une grande chose que tu as faite, tu as bien mérité d'Israël, car Dieu était avec toi en tout ce que tu as fait. Que le Seigneur tout-puissant te bénisse pour les siècles!',Tout le peuple reprenait: 'Amen!'"
,"11":"La population pilla le camp durant trente jours; on donna à Judith la tente d'Holoferne et toute sa vaisselle d'argent, sa literie, ses bassins et tous ses meubles. Elle le prit, elle en chargea sa mule, attela ses chariots, et rassembla le tout."
,"12":"Toutes les femmes d'Israël sortirent pour la voir, elles la bénissaient et beaucoup d'entre elles firent un choeur en son honneur. Judith prit des branchages et les donna aux femmes qui étaient avec elle. "
,"13":"Elles se firent des couronnes d'olivier, elle et ses compagnes, puis elle prit la tête du cortège, conduisant le choeur des femmes; tous les hommes d'Israël suivaient, armés et couronnés, chantant des cantiques à pleine voix."
,"14":"Alors Judith entonna cette action de grâces devant tout Israël, et tout le peuple reprit son cantique:"
}`)
	CurrentBook.AddChapter(16, `{
"1":"'Chantez pour mon Dieu au son des tambourins, chantez le Seigneur au son des cymbales, chantez-lui des psaumes, des cantiques, célébrez son Nom, invoquez-le!"
,"2":"Le Seigneur est un Dieu qui brise les guerres, il a dressé son camp au milieu de son peuple, il m'a reprise aux mains de mes persécuteurs."
,"3":"L'Assyrien est venu des montagnes du nord, il est venu: une armée innombrable. Leur foule remplissait les vallées, leurs chevaux couvraient les montagnes."
,"4":"Ils voulaient incendier mon pays, faire périr les jeunes gens par l'épée, écraser à terre mes nourrissons, livrer mes enfants au pillage, et mes jeunes filles au viol."
,"5":"Le Seigneur tout-puissant les a eus, et par la main d'une femme."
,"6":"Pas de jeunes guerriers pour abattre leur chef, pas de géants pour le frapper, pas de surhommes pour le terrasser!,C'est Judith, la fille de Mérari, qui l'a désarmé par la beauté de son visage."
,"7":"Elle a laissé ses vêtements de veuve, pour relever les opprimés d'Israël. Elle s'est parfumé le visage,"
,"8":"elle a serré ses cheveux dans un bandeau. Elle avait pour le séduire une robe de lin,"
,"9":"ses sandales ont accroché son regard, sa beauté a captivé son âme, et l'épée lui a tranché le cou."
,"10":"Les Perses étaient émus de son audace, les Mèdes, décontenancés par son courage."
,"11":"Les humbles de mon peuple ont élevé la voix: les autres ont pris peur. Les miens étaient faibles: les autres ont tremblé; ils ont élevé la voix: les autres ont pris la fuite."
,"12":"Des fils de femmelettes les ont transpercés, les ont abattus comme des déserteurs: ils sont morts, mon Seigneur a gagné la bataille."
,"13":"Je chanterai pour mon Dieu un cantique nouveau. Seigneur, tu es grand et glorieux, ta force est admirable, invincible."
,"14":"Que toute ta création te serve, car tu commandes et tout existe, tu envoies ton souffle et tout est mis sur pied, nul ne peut résister à ta voix."
,"15":"Le socle des montagnes, des mers, peut trembler, et les rochers comme cire fondre devant ta face, mais toi toujours tu seras secourable,pour ceux qui te craignent!"
,"16":"C'est peu, un sacrifice d'agréable odeur, moins que rien, la graisse des holocaustes,celui qui craint le Seigneur, c'est lui qui est grand."
,"17":"Malheur à ces nations qui s'en prennent à ma race!,Au jour du jugement, le Seigneur fera payer, le Tout-Puissant mettra le feu, les vers, dans leur chair, et ils pleureront de douleur pour toujours.'"
,"18":"Quand ils arrivèrent à Jérusalem, ils adorèrent Dieu. Le peuple se purifia pour offrir des holocaustes, des offrandes volontaires et toute sorte d'offrandes."
,"19":"Judith offrit au Temple tout le mobilier d'Holoferne que le peuple lui avait donné; elle voua à Dieu, par l'anathème, la draperie qu'elle avait prise elle-même dans sa chambre à coucher."
,"20":"Le peuple resta trois mois à Jérusalem, devant le Lieu Saint, pour célébrer l'événement, et Judith resta avec eux."
,"21":"Les jours de fête étant écoulés, chacun retourna dans son village et Judith revint à Béthulie pour y gérer sa propriété; elle était célèbre dans tout le pays."
,"22":"Beaucoup auraient voulu l'épouser, mais aucun homme ne la connut durant toute sa vie, depuis le jour où son mari Manassé mourut et fut réuni à ses pères."
,"23":"Sa gloire ne cessa de grandir; elle vieillit dans la maison de son mari jusqu'à l'âge de cent cinq ans. Elle mourut à Béthulie après avoir rendu la liberté à sa servante; c'est là qu'on l'enterra dans la grotte de son mari Manassé."
,"24":"Le peuple d'Israël fit pour elle un deuil de sept jours. Avant de mourir, elle avait partagé ses biens entre tous les proches parents de Manassé, son mari, et les proches parents de sa propre famille."
,"25":"Durant les jours de Judith, personne n'osa plus inquiéter les fils d'Israël, et cela dura encore longtemps après sa mort."
}`)

}
func FR_LBDCC_LoadVHNHChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Paroles de Néhémie, fils d'Hakalya. En la vingtième année du règne d'Artaxerxès, au mois de Kisleu, j'étais dans la forteresse de Suse."
,"2":"Comme un de mes frères, Hanani, venait d'arriver avec quelques hommes de Juda, je les interrogeai au sujet des Juifs, des survivants qui étaient revenus de la captivité, et sur Jérusalem."
,"3":"Ils me répondirent: 'Là-bas, dans la Province, ceux qui sont rentrés de la captivité, les survivants, vivent dans une grande misère et au milieu des humiliations; le rempart de Jérusalem n'est que brèches et les portes sont brûlées.'"
,"4":"En entendant cela, je me suis assis et j'ai pleuré. Et pendant plusieurs jours je suis resté dans le deuil: je jeûnais et je priais devant le Dieu du Ciel,"
,"5":"et je lui disais: 'Ah! Yahvé, Dieu du Ciel, Dieu grand et terrible, toi qui gardes ton Alliance et ta fidélité à ceux qui t'aiment et observent tes commandements!"
,"6":"Ecoute attentivement, ouvre les yeux, entends la prière de ton serviteur! Car tu le vois, jour et nuit je prie pour les fils d'Israël, tes serviteurs: je confesse les péchés des fils d'Israël. Oui, nous avons péché contre toi; moi et la maison de mon père, nous avons péché!"
,"7":"Nous nous sommes très mal conduits envers toi, nous n'avons pas observé les commandements, les ordonnances et les décrets que tu nous avais donnés par Moïse, ton serviteur."
,"8":"Souviens-toi cependant de la parole que tu as confiée à Moïse, ton serviteur, lorsque tu lui as dit: 'Si vous êtes infidèles, je vous disperserai parmi les nations,"
,"9":"mais quand vous reviendrez vers moi, quand vous observerez mes commandements et les mettrez en pratique, même si vos exilés se trouvaient au bout du ciel, je les rassemblerais et je les ferais revenir au lieu que j'ai choisi pour y faire habiter mon Nom.'"
,"10":"Car ils sont tes serviteurs et ton peuple que tu as délivrés par ta grande force et par ta main puissante."
,"11":"Ah! Seigneur, écoute attentivement la prière de ton serviteur, la prière de tes serviteurs qui trouvent leur joie à craindre ton Nom; fais donc aujourd'hui réussir ton serviteur et fais-lui gagner le coeur du roi.' En ce temps-là j'étais auprès du roi, je lui préparais ses boissons."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Donc, en la vingtième année du roi Artaxerxès, au mois de Nisan, puisque je servais le vin, je le prends et j'en donne au roi. Jamais jusque-là, je n'avais été triste devant lui."
,"2":"Le roi me demanda: 'Pourquoi es-tu si triste? Tu n'es pas malade, il y a certainement quelque chose qui te fait de la peine.' Après un moment de crainte,"
,"3":"je dis au roi: 'Que le roi vive à jamais! Comment ne serais-je pas triste alors que la ville où se trouvent les tombes de mes ancêtres est en ruines et que ses portes ont été brûlées par le feu?'"
,"4":"Le roi me répond: 'Que veux-tu?' Alors je prie le Dieu du ciel"
,"5":"et je dis au roi: 'Si le roi le veut bien et si son serviteur lui est agréable, envoie-moi en Juda vers la ville où se trouvent les tombes de mes ancêtres, je la reconstruirai.'"
,"6":"La reine était assise à côté du roi, et les deux me demandent: 'Combien de temps durera ton voyage et quand reviendras-tu?' Alors je fixe un délai et le roi accepte de me laisser partir."
,"7":"Je dis encore au roi: 'Si le roi le veut bien, qu'on me remette des lettres pour les gouverneurs de la province qui se trouve au-delà de l'Euphrate: il faut qu'ils me laissent passer jusqu'à ce que j'arrive en Juda."
,"8":"Qu'on me donne aussi une lettre pour Asaf, le gouverneur du parc royal, pour qu'il me donne du bois de charpente pour les portes de la forteresse du Temple, pour le rempart de la ville et pour la maison que j'habiterai.' La main bienveillante de mon Dieu était avec moi, et voici que le roi m'accorde tout."
,"9":"Quand je suis arrivé chez les gouverneurs de la province qui se trouve au-delà de l'Euphrate, je leur ai donné les lettres du roi; le roi m'avait fait accompagner par des officiers et des cavaliers."
,"10":"Mais Samballat le Horonite, et Tobiya, le fonctionnaire ammonite, ont appris la chose et ils en ont été très contrariés: quelqu'un venait prendre en charge les intérêts des Israélites!"
,"11":"A mon arrivée à Jérusalem j'ai attendu trois jours,"
,"12":"puis de nuit je me suis levé avec quelques hommes mais je n'avais dit à personne ce que mon Dieu m'avait inspiré de faire pour Jérusalem, et je n'avais avec moi aucune autre bête que celle sur laquelle j'étais monté."
,"13":"De nuit donc, je suis sorti par la Porte de la Vallée, je me suis dirigé vers la source du Dragon et vers la Porte du Fumier. J'ai regardé attentivement le rempart de Jérusalem: il y avait des brèches et les portes avaient été dévorées par le feu."
,"14":"J'ai continué vers la Porte de la Source et vers l'Etang du roi, mais il n'y avait plus de passage pour la bête sur laquelle j'étais monté."
,"15":"Alors je suis reparti en remontant de nuit le long du ravin; j'examinais toujours le rempart et, après avoir fait demi-tour, je suis revenu en passant par la Porte de la Vallée."
,"16":"Les conseillers ne savaient pas où j'étais allé ni ce que j'avais fait. En effet, jusque-là je n'avais rien dit, ni aux Juifs, ni aux prêtres, ni aux responsables, ni aux conseillers, ni à aucun autre fonctionnaire."
,"17":"Mais alors je leur ai dit: 'Regardez la misère où nous sommes, Jérusalem est en ruines et ses portes sont brûlées. Allons, il nous faut reconstruire le rempart de Jérusalem pour qu'on cesse de se moquer de nous.'"
,"18":"Je leur ai dit encore comment la main de mon Dieu, sa main pleine de bonté, avait été avec moi, et je leur ai rapporté les paroles du roi. 'Debout! s'écrièrent-ils, construisons!' Et ils se mirent courageusement à l'oeuvre pour ce beau travail."
,"19":"Lorsque Samballat le Horonite, Tobiyas le fonctionnaire ammonite, et Guéchem l'Arabe, apprirent cela, ils se moquèrent de nous. Ils nous regardèrent avec mépris: 'Que faites-vous là, dirent-ils, voulez-vous donc vous révolter contre le roi?'"
,"20":"Mais je leur répondis sèchement: 'Le Dieu du Ciel nous fera réussir, nous sommes ses serviteurs et nous allons nous mettre au travail. Quant à vous, vous n'avez ni droit, ni héritage, ni aucun souvenir dans Jérusalem.'"
}`)
	CurrentBook.AddChapter(3, `{
"1":"Elyachib le grand prêtre se mit à l'oeuvre avec ses frères prêtres, et ils reconstruisirent la Porte des Brebis. Ils montèrent la charpente, ils posèrent les battants des portes et continuèrent jusqu'à la Tour-des-Cent et jusqu'à la Tour-de-Hananéel."
,"2":"Après eux c'étaient les gens de Jéricho, puis Zakour fils d'Imri qui travaillaient."
,"3":"Les fils de Ha-Sénaa construisirent la Porte des Poissons, ils en montèrent la charpente et posèrent les battants avec les verrous et les barres."
,"4":"Ensuite Mérémot, fils d'Ouriyas, fils d'Hakos, se mit au travail, puis Méchoullam, fils de Bérékyas, fils de Méchézabéel, enfin Sadoq fils de Baana."
,"5":"Les gens de Tékoa se mirent au travail mais leurs chefs jugèrent indigne d'eux de travailler au service de leur Seigneur."
,"6":"Yoyada fils de Paséah et Méchoullam fils de Bésodyas, réparèrent la Porte du Quartier Neuf, ils en montèrent la charpente et posèrent ses battants avec les verrous et les barres."
,"7":"Mélatyas de Gabaon et Yadon de Méronot travaillèrent à leur suite avec les gens de Gabaon et de Mispa qui dépendaient du gouverneur de la province d'au-delà de l'Euphrate."
,"8":"Après eux Ouziel, de la corporation des orfèvres, et Hananyas, de la corporation des parfumeurs, fortifièrent Jérusalem jusqu'au Gros Mur."
,"9":"Après eux travaillait Réfayas fils de Hour, chef de la moitié du secteur de Jérusalem."
,"10":"Puis Yédayas fils de Haroumaf, sur le devant de sa maison, ensuite Hatouch fils de Hachabnéyas."
,"11":"Malkiyas fils de Harim, et Hachchoub fils de Pahah-Moab, réparèrent le secteur suivant jusqu'à la tour des Fours."
,"12":"A leur suite, Challoum fils de Hallohech, chef de l'autre moitié du secteur de Jérusalem, travailla avec ses filles."
,"13":"Hanoun et les habitants de Zanoah réparèrent la porte de la Vallée, ils la reconstruisirent et posèrent ses battants avec les verrous et les barre; ils firent mille coudées de mur jusqu'à la porte du Fumier."
,"14":"Malkiyas fils de Rékab, chef du secteur de Beth-Ha-Kérem, répara la porte du Fumier avec ses fils, il en posa les battants avec les verrous et les barres."
,"15":"Challoum fils de Kol-Hozé, chef du secteur de Mispa, répara la porte de la Fontaine, il la reconstruisit, il en posa le toit et les battants des portes avec les verrous et les barres, il releva le mur de la Citerne de Siloé jusqu'aux escaliers qui descendent de la Cité de David (la Citerne se trouve à côté du Jardin du Roi)."
,"16":"Néhémyas fils d'Azbouk, chef de la moitié du secteur de Bet-Sour, prolongea les travaux jusqu'aux sépultures de David, jusqu'à la Citerne et jusqu'à la maison de la garde royale."
,"17":"Après lui travaillaient les lévites: Réhoum fils de Bani, Achabyas chef de la moitié du secteur de Kéla;"
,"18":"puis leurs frères, Binnouï fils de Hénadad, chef de la moitié du secteur de Kéla,"
,"19":"Ezer fils de Yéchoua, chef de Mispa, à l'angle des remparts près de la Maison des Armes;"
,"20":"après eux Barouk fils de Zabaï, depuis l'angle des remparts jusqu'à la porte de la maison du grand prêtre Elyachib;"
,"21":"après lui, pour la section suivante, Mérémot fils d'Ouriyas, fils d'Hakos, depuis l'entrée de la maison d'Elyachib jusqu'à son extrémité."
,"22":"Les prêtres qui habitaient les autres secteurs travaillèrent également aux réparations:"
,"23":"Dinyamin et Hachchoub, en face de leur propre maison, Azaryas fils de Maaséryas, fils d'Hananyas, près de sa maison;"
,"24":"dans le secteur suivant, Binnouï fils de Hénadad, depuis la maison d'Azaryas jusqu'à l'angle des remparts;"
,"25":"puis Palal fils d'Ouzaï, près de l'angle des remparts et de la tour qui protège le palais royal du côté de la cour de la prison. Pédayas, fils de Paréach, travailla"
,"26":"jusqu'en face de la porte des Eaux, à l'est, et jusqu'à la tour d'angle;"
,"27":"après lui les gens de Tékoa, en face de la grande tour d'angle et jusqu'au mur de l'Ophel."
,"28":"Les prêtres travaillèrent aux réparations, chacun en face de sa propre maison, à partir de la porte des Chevaux:"
,"29":"Sadoq fils d'Immer, en face de sa propre maison; Chémayas fils de Chékanyas, gardait la porte de l'Est."
,"30":"Hananyas fils de Chélémyas, et Hanoun, le sixième fils de Salaf, travaillèrent dans le secteur suivant. Méchoullam fils de Bérékyas, en face de sa propre maison;"
,"31":"Malkiyas, de la corporation des orfèvres, jusqu'à la maison des serviteurs et des commerçants: c'était en face de la porte de la Surveillance, près de la salle haute de l'angle des remparts."
,"32":"Entre ces deux salles hautes et la Porte des Brebis, les orfèvres et les commerçants firent le travail."
,"33":"Lorsque Samballat apprit que nous étions en train de reconstruire le rempart, il en fut très agacé et se mit en colère. Se moquant des Juifs,"
,"34":"il déclara devant ses frères et devant les troupes de Samarie: 'Que font ces pauvres Juifs? Ils pensent sans doute qu'ils vont faire revivre ces pierres qu'ils ont sorties des ruines et qui sont toutes brûlées!'"
,"35":"Et Tobiyas l'Ammonite, qui était à côté de lui, ajouta: 'Ils peuvent bien construire, le premier renard qui voudra passer fera tomber leur mur de pierre!'"
,"36":"Ecoute, ô notre Dieu, comme nous sommes méprisés! Fais retomber leurs insultes sur leur propre tête et qu'ils soient eux-mêmes méprisés dans un pays où ils seront prisonniers!"
,"37":"Ne pardonne pas leur faute, n'efface pas ce péché, car ils ont insulté ceux qui construisaient."
,"38":"C'est ainsi que nous avons relevé le rempart et l'avons laissé terminé jusqu'à mi-hauteur, car le peuple travaillait avec ardeur."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Samballat, Tobiyas, les Arabes, les Ammonites et les habitants d'Ashdod apprirent que la réparation du rempart de Jérusalem avançait: les brèches étaient presque toutes bouchées. Ils en furent très en colère"
,"2":"et se rassemblèrent tous pour attaquer Jérusalem et y jeter la panique."
,"3":"Nous avons donc prié notre Dieu et nous avons établi une garde de jour et de nuit pour nous protéger contre eux."
,"4":"C'était le moment où les Judéens disaient: 'Il y a trop de décombres et les forces des porteurs sont à la limite, nous ne pourrons jamais reconstruire le rempart.'"
,"5":"Et nos adversaires disaient: 'Nous allons tomber sur eux sans qu'ils le sachent, avant qu'ils ne nous aient vus. Nous les tuerons et nous ferons cesser le travail.'"
,"6":"Des Juifs qui habitaient à côté d'eux vinrent nous dire au moins dix fois: 'Ils vont arriver de tous les côtés pour vous attaquer!'"
,"7":"J'ai donc posté dans les creux en contrebas du rempart le peuple tout entier par familles, avec ses épées, ses lances et ses arcs."
,"8":"Je voyais leur peur, je suis donc allé dire aux chefs, aux fonctionnaires et à tout le peuple: 'N'ayez pas peur d'eux! Pensez au Seigneur qui est grand et terrible, combattez pour vos frères, vos fils, vos filles, vos femmes et vos maisons.'"
,"9":"Lorsque nos ennemis apprirent que nous étions renseignés et que Dieu avait fait échouer leur projet, nous sommes tous retournés au rempart, chacun à son travail."
,"10":"Mais à partir de ce jour, la moitié de mes hommes travaillait et l'autre moitié avait en mains des lances, des boucliers, des arcs et des cuirasses, et ils se tenaient derrière les Judéens"
,"11":"qui travaillaient sur le rempart. Ceux qui portaient les charges étaient armés, d'une main ils travaillaient et de l'autre ils tenaient leur lance."
,"12":"Ceux qui construisaient gardaient leur épée à la ceinture pendant leur travail. Un sonneur de trompe se tenait près de moi,"
,"13":"car j'avais dit aux chefs, aux fonctionnaires et à tout le peuple: 'Le chantier est important, il est étendu et nous sommes dispersés sur le rempart, éloignés les uns des autres."
,"14":"Aussi, dès que vous entendrez le son de la trompe, venez vous rassembler auprès de nous de l'endroit où vous êtes, et notre Dieu combattra pour nous.'"
,"15":"Nous étions ainsi au travail depuis le lever du jour jusqu'à l'apparition des premières étoiles, et la moitié tenaient des lances."
,"16":"En ce temps-là je dis encore au peuple: 'Que chacun avec son serviteur passe la nuit dans Jérusalem. La nuit ils monteront la garde et le jour ils seront sur le chantier.'"
,"17":"Ni moi, ni mes frères, ni mes hommes, ni ceux qui montaient la garde, ne quittions nos vêtements, et nous avions sans cesse notre arme dans la main droite."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Les gens du peuple et leurs femmes se plaignirent de leurs frères juifs."
,"2":"Certains disaient: 'Nous devons donner nos fils et nos filles en gage pour recevoir du blé, manger et vivre.'"
,"3":"D'autres disaient: 'Nous devons engager nos champs, nos vignes et nos maisons pour recevoir du blé durant cette famine.'"
,"4":"D'autres encore disaient: 'Pour payer l'impôt du roi, nous avons dû emprunter de l'argent sur nos champs et sur nos vignes."
,"5":"Nous sommes pourtant du même sang que nos frères et nos enfants valent autant que les leurs; or nous devons donner en gage nos fils et nos filles, et souvent on profite de nos filles. Nous n'y pouvons rien puisque nos champs et nos vignes appartiennent déjà à d'autres que nous.'"
,"6":"En entendant cette plainte et ces paroles, je me suis mis dans une grande colère."
,"7":"Après y avoir réfléchi, j'ai secoué sévèrement les nobles et les fonctionnaires. Je leur ai dit: 'Chacun de vous fait peser un lourd fardeau sur ses frères!',Alors j'ai convoqué une grande assemblée, "
,"8":"et je leur ai dit: 'Nous avons selon nos moyens racheté nos frères juifs qui avaient été vendus parmi les nations, et aujourd'hui c'est vous qui vendez vos frères, ou c'est à nous qu'ils sont vendus.' Tous se taisaient, ils n'avaient rien à répliquer."
,"9":"J'ai ajouté: 'Ce que vous faites là n'est vraiment pas bien. Marchez plutôt dans la crainte de notre Dieu et vous n'aurez pas à redouter le mépris des nations ennemies."
,"10":"Moi aussi, et mes frères, et mes hommes, nous leur avons prêté de l'argent et du blé: eh bien, remettons-leur cette dette!"
,"11":"Rendez-leur immédiatement leurs champs, leurs vignes, leurs oliviers et leurs maisons; remettez-leur la dette en argent, en blé, en vin ou en huile qu'ils ont envers vous.'"
,"12":"Tous répondirent: 'Nous rendrons ce que nous avons pris en gage, nous ne réclamerons rien et nous ferons comme tu l'as dit.',Alors j'ai appelé les prêtres et j'ai fait jurer à tout le monde de mettre en pratique cette promesse. "
,"13":"Ensuite, j'ai secoué le pli de mon vêtement et j'ai dit: 'Que Dieu secoue ainsi hors de sa maison et de ses biens, tout homme qui ne tiendra pas cette parole! Qu'il soit ainsi secoué et vidé!' Toute l'assemblée répondit: 'Amen!' et on loua Yahvé. Quant au peuple, il respecta cet engagement."
,"14":"Depuis le jour où l'on m'a nommé gouverneur du pays de Juda, depuis la vingtième année d'Artaxerxès jusqu'à la trente-deuxième année de son règne, c'est-à-dire pendant douze ans, ni moi, ni mes frères, n'avons touché au 'pain du gouverneur'."
,"15":"Les premiers gouverneurs qui m'ont précédé écrasaient le peuple. Chaque jour ils lui prenaient pour quatre cents pièces d'argent de pain et de vin, et leurs hommes abusaient du peuple. Moi je n'ai pas fait pareil, car je craignais Dieu."
,"16":"J'étais si absorbé par le travail des remparts que je n'ai pas acheté de champs, et tous mes hommes se trouvaient là pour le travail."
,"17":"J'avais à ma table les nobles et les fonctionnaires au nombre de cent cinquante, sans compter ceux qui arrivaient des nations étrangères."
,"18":"Chaque jour on devait préparer un boeuf, six moutons de choix et des volailles: tout cela était à mes frais; tous les dix jours on apportait de nombreuses outres de vin. Malgré cela, je n'ai pas réclamé 'le pain du gouverneur', car je voyais que ce travail pesait lourdement sur le peuple."
,"19":"Souviens-toi de moi, mon Dieu, n'oublie pas tout ce que j'ai fait pour ce peuple."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Samballat, Tobiyas, Guéchem l'Arabe, et les autres ennemis, apprirent que j'avais reconstruit le rempart et qu'il n'y avait plus une seule brèche; cependant, je n'avais pas encore posé les battants des portes."
,"2":"Alors Samballat et Guéchem m'envoyèrent ce message: 'Viens nous retrouver à Ha-Kéfirim, dans la vallée d'Ono.' En fait, ils avaient prévu de me faire du mal."
,"3":"Je leur ai envoyé des messagers avec cette réponse: 'Je suis occupé à un travail important et je ne peux venir. Je ne vais tout de même pas l'interrompre pour venir à votre rencontre.'"
,"4":"Ils me l'ont fait dire quatre fois, et je leur ai donné la même réponse."
,"5":"Alors, à la cinquième fois, Samballat m'envoya son serviteur avec une lettre"
,"6":"où il disait: 'Le bruit court chez les étrangers, c'est Gachmou qui me l'a dit, que toi et les Juifs vous préparez une révolte; c'est pour cela que tu as reconstruit le rempart, et c'est toi qui veux devenir le roi."
,"7":"Tu as même prévu des prophètes pour te soutenir et proclamer dans Jérusalem: 'Juda a maintenant un roi.' Le roi va sûrement être informé de tout cela, viens donc et discutons ensemble.'"
,"8":"Je lui ai retourné cette réponse: 'Il n'y a rien de vrai dans tout ce que tu dis, c'est toi qui as tout inventé.'"
,"9":"Tous en effet, voulaient nous faire peur, ils se disaient: 'Ils vont se lasser du travail et la chose ne se fera pas.' Moi, au contraire, je m'accrochais davantage."
,"10":"Alors je me suis rendu à la maison de Chémayas fils de Délayas, fils de Méhétabel, car il ne pouvait venir. Il me dit: 'Retrouvons-nous au Temple de Dieu, à l'intérieur du Sanctuaire, et fermons les portes du Sanctuaire: voici qu'ils arrivent pour te tuer et c'est de nuit qu'ils vont te tuer.'"
,"11":"Je lui répondis: 'Un homme comme moi irait se réfugier? Un homme comme moi ne peut pas entrer dans le Sanctuaire et demeurer en vie. Je n'y entrerai pas."
,"12":"J'avais reconnu que ce n'était pas Dieu qui l'avait envoyé. Sa prophétie à mon sujet, c'était simplement Tobiyas qui l'avait payé."
,"13":"C'était pour que j'aie peur et que je commette un péché en faisant ce qu'il me disait. Il m'aurait couvert de honte et cela m'aurait fait très mauvaise réputation."
,"14":"O mon Dieu! Souviens-toi de Tobiyas et de ce qu'il a fait là. Souviens-toi aussi de Noadyas, la prophétesse, et des autres prophètes qui voulaient me faire peur."
,"15":"On termina le rempart le vingt-cinq du mois d'Eloul; on l'avait fait en cinquante-deux jours."
,"16":"Lorsque tous nos ennemis apprirent cela, toutes les nations qui sont autour de nous furent remplies de peur, elles se sentirent humiliées à leurs propres yeux et elles reconnurent que c'était grâce à notre Dieu que ce travail s'était réalisé."
,"17":"C'est encore en ce temps-là que se multiplia la correspondance entre les nobles de Juda et Tobiyas."
,"18":"En effet, beaucoup de gens en Juda étaient liés par le serment qu'ils avaient fait à Tobiyas: il était le gendre de Chékanyas, fils d'Ara et son fils Yohanan avait épousé la fille de Méchoullam, fils de Bérékyas."
,"19":"Ils chantaient même devant moi ses bonnes actions et lui rapportaient tout ce que je disais, c'est pourquoi Tobiyas envoyait des lettres pour me faire peur."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Une fois terminé le rempart, j'avais fixé les battants des portes et j'avais placé des portiers."
,"2":"C'est alors que j'ai confié à mon frère Hanani l'administration de Jérusalem, et j'ai donné le commandement de la forteresse à Hananyas, car c'était un homme de confiance qui craignait Dieu plus que beaucoup d'autres."
,"3":"Je leur ai dit: 'Les portes de Jérusalem ne seront ouvertes que lorsque le soleil commencera à chauffer, et tandis qu'il sera encore haut dans le ciel, on devra fermer et verrouiller les portes. On établira des postes de garde avec les habitants de Jérusalem: les uns à leur poste, les autres devant leur maison."
,"4":"La ville était vaste, étendue, mais la population était peu nombreuse et les maisons n'étaient pas encore reconstruites."
,"5":"C'est pourquoi mon Dieu m'inspira de réunir les nobles, les fonctionnaires et le peuple pour en faire le recensement par familles. Je mis la main sur le livre où l'on avait enregistré par familles ceux qui étaient revenus les premiers, et voici ce que j'y ai lu:"
,"6":"Liste des gens de la province qui sont revenus de captivité, des déportés que Nabukodonozor roi de Babel avait exilés et qui sont revenus à Jérusalem et en Juda, chacun dans sa ville."
,"7":"Ceux-là sont arrivés avec Zorobabel, Josué, Néhémie, Azaryas, Raamyas, Nahamani, Mardochée, Bilchan, Mispérèt, Bigvaï, Nehoum, Baana. Nombre des hommes du peuple d'Israël: "
,"8":"les fils de Paréoch: 2172;"
,"9":"les fils de Chefatyas: 372;"
,"10":"Les fils d'Ara: 652;"
,"11":"les fils de Pahat-Moab (c'est-à-dire les fils de Josué et de Yoab): 2818;"
,"12":"les fils d'Elam: 1254;"
,"13":"les fils de Zattou: 845;"
,"14":"les fils de Zakaï: 760;"
,"15":"les fils de Binnouï: 648;"
,"16":"les fils de Bébaï: 628;"
,"17":"les fils d'Azgad: 2322;"
,"18":"les fils d'Adonikam: 667;"
,"19":"les fils de Bigvaï: 2067;"
,"20":"les fils d'Adin: 655;"
,"21":"les fils d'Ater (c'est-à-dire de Hizkiyas): 98;"
,"22":"les fils de Hachoum: 328;"
,"23":"les fils de Bésaï: 324;"
,"24":"les fils de Harif: 112;"
,"25":"les fils de Gabaon: 95;"
,"26":"les hommes de Bethléem et de Nétofa: 188;"
,"27":"les hommes d'Anatot: 128;"
,"28":"les hommes de Beth-Azmavèt: 42;"
,"29":"les hommes de Kiryat-Yéarim, Kefira et Béérot: 743;"
,"30":"les hommes de Rama et Géba: 621;"
,"31":"les hommes de Mikmas: 122;"
,"32":"les hommes de Béthel et de Aï: 123;"
,"33":"les hommes de l'autre Nebo: 52;"
,"34":"les fils de l'autre Elam: 1254;"
,"35":"les fils de Harim: 320;"
,"36":"les fils de Jéricho: 345;"
,"37":"les fils de Lod, Hadid et Ono: 721;"
,"38":"les fils de Senaa: 3930."
,"39":"Les prêtres: les fils de Yedayas (c'est-à-dire la maison de Josué): 973;"
,"40":"les fils d'Immer: 1052;"
,"41":"les fils de Pachehour: 1247;"
,"42":"les fils de Harim: 1017;"
,"43":"les lévites: les fils de Josué (c'est-à-dire Kadmiel), les fils de Hodva: 74;"
,"44":"les chantres: les fils d'Asaf: 148;"
,"45":"les portiers: les fils de Chaloum, les fils d'Ater, les fils de Talmon, les fils d'Akoub, les fils de Hatita, les fils de Chobaï: 138;"
,"46":"Les 'Serviteurs': les fils de Siha, les fils de Hasoufa, les fils de Tabaot,"
,"47":"les fils de Kéros, les fils de Sia, les fils de Padon,"
,"48":"les fils de Lebana, les fils de Hagaba, les fils de Chalmaï,"
,"49":"les fils de Hanan, les fils de Gidel, les fils de Gahar,"
,"50":"les fils de Reayas, les fils de Resin, les fils de Nekoda,"
,"51":"les fils de Gazam, les fils d'Ouza, les fils de Paséa,"
,"52":"les fils de Bésaï, les fils des Méounites, les fils des Nefousites,"
,"53":"les fils de Bakbouk, les fils de Hakoufa, les fils de Harhour,"
,"54":"les fils de Baslit, les fils de Mehida, les fils de Harcha,"
,"55":"les fils de Barkos, les fils de Sisra, les fils de Téma,"
,"56":"les fils de Nesia, les fils de Hatifa;"
,"57":"Les fils des esclaves de Salomon: les fils de Sotaï, les fils de Soférèt, les fils de Perida,"
,"58":"les fils de Yaala, les fils de Darkon, les fils de Gidel,"
,"59":"les fils de Chefatyas, les fils de Hatil, les fils de Pokérèt-Ha-Sébayim, les fils d'Amon."
,"60":"Total des 'Serviteurs' et des esclaves de Salomon: 392."
,"61":"Les survivants qui étaient de Tel-Méla, de Tel-Harcha, de Kéroub, d'Addan, et d'Immer, furent incapables de dire si leurs familles et leurs clans étaient d'Israël:"
,"62":"les fils de Delayas, les fils de Tobiyas, les fils de Nekoda: 642."
,"63":"Parmi les fils des prêtres, les fils d'Hobayas, les fils d'Hakos, les fils de Barzillaï - cet homme avait adopté le nom de Barzillaï de Galaad dont il avait épousé une des filles -"
,"64":"Tous ceux-là ont recherché leurs listes généalogiques, mais ils ne les ont pas trouvées; ils ont été écartés du sacerdoce comme impurs."
,"65":"Le gouverneur leur a interdit de manger des aliments sacrés jusqu'au jour où un prêtre réglerait la question par l'Ourim et le Toumim."
,"66":"L'assemblée tout entière comptait 42360 personnes,"
,"67":"sans compter les esclaves et les servantes au nombre de 7337; il y avait aussi 245 chanteurs et chanteuses."
,"68":"On comptait 435 chameaux et 6720 ânes."
,"69":"Certains chefs de familles ont fait des dons pour les travaux. Le gouverneur a donné au trésor 1000 pièces d'or, 50 coupes et 30 tuniques pour les prêtres."
,"70":"Pour les travaux, certains chefs de familles ont versé au trésor 20000 pièces d'or et 2200 mines d'argent."
,"71":"Quant aux dons offerts par le reste du peuple, ils se montent à 20000 pièces d'or, 2000 mines d'argent et 67 tuniques pour les prêtres."
,"72":"Les prêtres, les lévites et une partie du peuple habitèrent à Jérusalem; les chantres, les portiers, les serviteurs et tous les autres Israélites, habitèrent dans leurs villes. Les Israélites étaient déjà dans leurs villes lorsqu'arriva le septième mois."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Le peuple tout entier se rassembla comme un seul homme sur la place en face de la porte des Eaux. On demanda alors au scribe Esdras d'apporter le livre de la Loi de Moïse que Yahvé avait ordonnée à Israël."
,"2":"Le prêtre Esdras apporta la Loi devant l'assemblée qui était faite d'hommes, de femmes, et de tous ceux qui avaient l'âge de raison; on était au premier jour du septième mois."
,"3":"Il lut dans le livre, depuis l'aube jusqu'à midi, en présence des hommes, des femmes et des enfants en âge de comprendre qui étaient rassemblés sur la place devant la porte des Eaux. Tout le peuple prêta une grande attention au livre de la Loi."
,"4":"Le scribe Esdras se tenait sur une estrade en bois construite pour cette occasion. Mattityas, Chéma, Anayas, Ouriyas, Hilkiyas et Maaséyas, se tenaient près de lui, à sa droite. Pédayas, Michael, Malkiyas, Hachoum, Hachbadana, Zékaryas et Méchoullam, se tenaient à sa gauche."
,"5":"Esdras dominait tout le monde; il ouvrit le livre devant tout le peuple, et quand il l'ouvrit tout le monde se leva."
,"6":"Alors Esdras bénit Yahvé, le Grand Dieu et tout le peuple répondit les mains levées: 'Amen! Amen!' Puis ils s'inclinèrent et se prosternèrent devant Yahvé, le visage contre terre."
,"7":"Josué, Bani, Chérébyas, Yamin, Akkoub, Chabtaï, Hodiyas, Maaséyas, Kélita, Azaryas, Yozabad, Hanan et Pélayas, qui étaient Lévites, expliquaient la Loi au peuple, pendant que le peuple restait debout."
,"8":"Esdras fit la lecture du livre de la Loi de Dieu, il traduisait et donnait le sens pour que l'on comprenne la lecture."
,"9":"Alors, Son Excellence Néhémie et Esdras le prêtre scribe, ainsi que les Lévites qui instruisaient le peuple, dirent à tout le peuple: 'Ce jour-ci est un jour saint pour Yahvé votre Dieu. Ne soyez pas tristes! Ne pleurez pas!' En effet, tout le peuple pleurait en entendant les paroles de la loi."
,"10":"Il leur dit encore: 'Allez, mangez de bonnes viandes, buvez des boissons agréables, réservez une part pour celui qui n'a rien de prêt et portez-la lui, car aujourd'hui est un jour saint pour notre Seigneur! Ne soyez pas tristes! La joie de Yahvé est votre forteresse!'"
,"11":"Les lévites calmaient le peuple, ils lui disaient: 'Pas tant de bruit! Ce jour est un jour saint, ne pleurez pas ainsi!'"
,"12":"Alors tout le peuple se dispersa pour manger, boire, partager, et laisser éclater sa joie, car ils avaient compris les paroles qu'on leur avait enseignées."
,"13":"Le deuxième jour, les chefs de familles du peuple, les prêtres et les Lévites se rassemblèrent autour du scribe Esdras pour étudier les paroles de la Loi."
,"14":"Ils trouvèrent écrit ceci dans la Loi que Yahvé avait ordonnée par la bouche de Moïse: 'Les enfants d'Israël habiteront dans des huttes pendant la fête du septième mois."
,"15":"Aussitôt ils publièrent et firent proclamer ceci dans toutes leurs villes et dans Jérusalem: 'Allez à la montagne et rapportez des branchages d'oliviers, de pins, de sycomores, de palmiers et d'autres arbres, pour en faire des huttes comme cela est écrit.'"
,"16":"Alors le peuple partit et rapporta des feuillages, il se fit des huttes sur les toits, dans les courettes, dans les cours du Temple de Dieu, sur la place de la porte des Eaux et sur la place de la porte d'Ephraïm."
,"17":"Toute l'assemblée, tous ceux qui étaient revenus de la captivité, firent des huttes et y habitèrent. Depuis le temps de Josué, fils de Noun, jusqu'à ce jour, les enfants d'Israël n'avaient rien fait de pareil, c'était une fête extraordinaire."
,"18":"Jour après jour on fit la lecture du livre de la Loi de Dieu, depuis le premier jour jusqu'au dernier. La fête dura sept jours, et le huitième jour il y eut selon la Loi, une assemblée solennelle."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Le vingt-quatrième jour de ce mois, les Israélites se réunirent pour un jeûne; ils venaient habillés de sacs et couverts de terre."
,"2":"La race Israël se sépara de tous les étrangers, ils se présentèrent et confessèrent leurs péchés et les fautes de leurs pères."
,"3":"Ils se levèrent sur place et on fit la lecture du livre de la Loi de Yahvé leur Dieu, pendant le quart de la journée. Pendant un autre quart, ils confessèrent leurs péchés et se prosternèrent devant Yahvé leur Dieu."
,"4":"Josué, Binnouï, Kadmiel, Chébanyas, Bouni, Chérébyas, Bani, Kénani, se placèrent sur l'estrade des lévites et, à haute voix, ils crièrent vers Yahvé leur Dieu."
,"5":"Les lévites Josué, Kadmiel, Bani, Hachbadléyas, Chérébyas, Odiyas, Chébanyas, Bétahyas, dirent: 'Levez-vous et bénissez Yahvé votre Dieu! Béni sois-tu, Yahvé notre Dieu, pour les éternités d'éternités! Qu'on bénisse ton Nom glorieux, car il surpasse toute bénédiction et louange!'"
,"6":"Toi, Yahvé, tu es l'Unique! Tu as fait les cieux, les cieux des cieux, et tout ce qu'ils contiennent, la terre et tout ce qu'elle porte, les mers et tout ce qui s'y trouve; tu donnes la vie à tous, et devant toi se prosterne l'armée des cieux."
,"7":"Toi, Yahvé, tu es Dieu; tu as choisi Abram, tu l'as tiré d'Our en Kaldée et tu lui as donné le nom d'Abraham."
,"8":"Tu l'as trouvé fidèle et tu as fait alliance avec lui. Tu lui as donné le pays du Cananéen, du Hittite et de l'Amorite, du Périzite, du Jébusite et du Girgachite. Tu as tenu tes promesses, car tu es juste."
,"9":"Tu as vu la détresse de nos pères en Egypte, tu as entendu leurs cris au bord de la mer des Roseaux,"
,"10":"tu as accompli des signes et des prodiges contre Pharaon, contre tous ses serviteurs et tout le peuple de son pays dont tu connaissais l'orgueil; et tu t'es fait un nom qui dure encore."
,"11":"Tu as ouvert la mer devant eux, ils ont passé au milieu de la mer, à pied sec, et tu as jeté au fond des eaux ceux qui les poursuivaient, comme une pierre dans des eaux déchaînées."
,"12":"Tu les as guidés le jour par une colonne de nuée et la nuit par une colonne de feu, pour éclairer devant eux la route sur laquelle ils s'avançaient."
,"13":"Tu es descendu sur le mont Sinaï et du haut du ciel tu leur as parlé, tu leur as donné des commandements, des lois vraies, des préceptes et des décisions excellentes."
,"14":"Tu leur as fait connaître ton saint sabbat et tu leur as ordonné commandements, préceptes et lois par la bouche de Moïse, ton serviteur."
,"15":"Du haut du ciel tu leur as donné le pain pour apaiser leur faim, et du rocher tu as fait jaillir l'eau pour leur soif. Tu leur as dit de partir à la conquête du pays que tu avais juré de leur donner;"
,"16":"mais nos pères se sont rebiffés, ils ont fait la forte tête et n'ont pas obéi à tes ordres."
,"17":"Ils ont refusé d'obéir; ils ont oublié les merveilles que tu avais accomplies pour eux et il leur a pris de vouloir retourner en Egypte à leur esclavage. Mais toi, tu es un Dieu de pardon, plein de pitié et de tendresse, lent à la colère et riche en bonté, et tu ne les as pas abandonnés."
,"18":"Ils se sont fabriqué un veau en métal fondu, ils ont dit: Voilà ton dieu qui t'as fait monter d'Egypte! Et ils ont prononcé toutes sortes de blasphèmes."
,"19":"Toi cependant, dans ton immense tendresse, tu ne les as pas abandonnés au milieu du désert; la colonne de nuée ne les a pas quittés. Elle les guidait de jour sur la route, et la nuit la colonne de feu illuminait devant eux la route où ils s'avançaient."
,"20":"Tu leur as donné ton bon esprit pour les rendre sages, tu ne leur as pas refusé la manne et tu leur as donné l'eau pour leur soif."
,"21":"Pendant quarante ans tu as pris soin d'eux dans le désert, ils n'ont manqué de rien, leurs vêtements ne se sont pas usés et leurs pieds n'ont pas gonflé."
,"22":"Tu leur as livré des royaumes et des peuples, et tu leur as donné ces territoires comme une province-frontière. Ils se sont emparés du pays de Sihon roi d'Heshbon, et du pays d'Og roi du Bashan."
,"23":"Tu as multiplié leurs fils autant que les étoiles du ciel et tu les as fait entrer dans le pays dont tu avais parlé à leurs pères, pour qu'ils y entrent et en prennent possession."
,"24":"Leurs fils y sont entrés, ils ont conquis ce pays; tu as abaissé devant eux les Cananéens habitants du pays, tu as livré entre leurs mains les rois et les peuples du pays pour qu'ils les traitent comme ils le voulaient."
,"25":"Ils se sont emparés de villes fortifiées et d'une bonne terre, ils ont hérité de maisons où rien ne manquait, de citernes déjà creusées, de vignes, d'oliviers, d'arbres fruitiers en quantité; ils ont mangé autant qu'ils voulaient, ils ont fait leur joie de tes bienfaits sans nombre."
,"26":"Mais ils ont été rebelles, ils se sont révoltés contre toi, ils ont rejeté derrière eux ta Loi. Ils ont tué les prophètes qui les invitaient à revenir vers toi et ils ont commis de grands crimes."
,"27":"Alors tu les a livrés aux mains de leurs ennemis qui les ont opprimés. Ils ont crié vers toi au temps de leur oppression, et toi, du haut du ciel, tu les a entendus. Dans ton immense tendresse tu leur as donné des libérateurs pour les délivrer des mains de leurs ennemis."
,"28":"Mais à peine la paix retrouvée, ils recommençaient à faire le mal devant toi. Alors de nouveau tu les abandonnais aux mains de leurs oppresseurs. Eux, de nouveau, criaient vers toi, et toi, du haut du ciel, tu les entendais. Que de fois dans ta tendresse ne les as-tu pas ainsi délivrés!"
,"29":"Tu les as avertis pour les ramener à ta Loi, mais dans leur orgueil ils n'ont pas observé tes ordres; ils ont péché contre ces commandements qui donnent la vie à quiconque les met en pratique. Ils ne t'ont offert qu'une épaule rebelle et une nuque raide: ils n'ont pas obéi."
,"30":"Pourtant, tu as été patient avec eux durant des années, tu les as avertis par ton esprit, par la bouche de tes prophètes, mais ils n'ont pas écouté. Alors tu les as livrés aux mains des nations païennes;"
,"31":"mais dans ton immense tendresse, tu ne les as pas fait disparaître, tu ne les as pas abandonnés, car tu es un Dieu plein de pitié et de tendresse."
,"32":"Maintenant, ô notre Dieu, toi le Dieu grand, puissant et redoutable, qui toujours maintiens ton alliance et ta bonté, ne sois pas insensible à toutes ces épreuves qui sont tombées sur nous, sur nos rois, nos chefs, nos prêtres, nos prophètes et tout notre peuple depuis les jours des rois d'Assyrie jusqu'à aujourd'hui."
,"33":"Tu as été juste dans tout ce qui nous est arrivé, car tu as agi selon la vérité, et nous, nous nous sommes mal conduits."
,"34":"Oui, nos rois, nos chefs, nos prêtres et nos pères n'ont pas suivi ta Loi, ils ont oublié tes commandements et les ordonnances que tu leur avais donnés."
,"35":"Tout le temps où ils ont été dans leur royaume, jouissant de tant de bienfaits que tu leur donnais, dans ce pays vaste et fertile que tu avais mis à leur disposition, ils ne t'ont pas servi et ils ne se sont pas détournés de leurs actions mauvaises."
,"36":"Aussi nous voilà aujourd'hui comme des esclaves, nous sommes esclaves en ce pays que tu avais donné à nos pères et dont tous les fruits, tous les biens, devraient être à nous."
,"37":"Ces produits sont aujourd'hui entre les mains des rois que tu nous as imposés à cause de nos péchés et qui disposent selon leur volonté de nos personnes et de nos troupeaux. Et pendant ce temps notre détresse est grande."
}`)
	CurrentBook.AddChapter(10, `{
"1":"En raison de tout cela, nous prenons un engagement solennel et nous le mettons par écrit. Sur ce document officiel figurent les noms de nos chefs, de nos lévites et de nos prêtres."
,"2":"Sur le document signé figuraient: Néhémie fils de Hakalya et Sidkiya, "
,"3":"Serayas, Azaryas, Yirmeyas,"
,"4":"Pachehour, Amaryas, Malkiyas,"
,"5":"Hatouch, Chebanyas, Malouk,"
,"6":"Harim, Mérémot, Obadyas,"
,"7":"Daniel, Gineton, Barouk,"
,"8":"Méchoullam, Abiyas, Miyamin,"
,"9":"Maazyas, Bilgaï, Chemayas: ce sont les prêtres."
,"10":"Puis les lévites: Josué fils d'Azanyas, Binnouï, des fils de Hénadad, Kadmiel,"
,"11":"et leurs frères Chekanyas, Hodavyas, Kelita, Pelayas, Hanan,"
,"12":"Mika, Rehob, Hachabyas,"
,"13":"Zakour, Chérébyas, Chebanyas,"
,"14":"Hodiyas, Bani, Kenani."
,"15":"Les chefs du peuple: Paréoch, Pahat-Moab, Elam, Zatou, Bani,"
,"16":"Bouni, Azgad, Bébaï,"
,"17":"Adoniyas, Bigvaï, Adin,"
,"18":"Ater, Hizkiyas, Azour,"
,"19":"Hodiyas, Hachoum, Bésaï,"
,"20":"Harif, Anatot, Nobaï,"
,"21":"Magpiach, Méchoullam, Hézir,"
,"22":"Mechézabéel, Sadoq, Yadoua,"
,"23":"Pelatyas, Hanan, Anayas,"
,"24":"Hochéa, Hananyas, Hakchoub,"
,"25":"Halohech, Pilha, Chobèk,"
,"26":"Rehoum, Hachabna, Maaséyas,"
,"27":"Ahiyas, Hanan, Anan,"
,"28":"Malouk, Harim, Baana."
,"29":"Et le reste du peuple: les prêtres, les lévites, les portiers, les chantres, les serviteurs, en un mot tous ceux qui se sont séparés des peuples des nations pour obéir à la Loi de Dieu avec leurs femmes, leurs fils et leurs filles: tous ceux en âge de comprendre."
,"30":"Tous se joignent à leurs frères, les chefs; ils s'engagent solennellement et par serment à marcher selon la Loi que Dieu a donnée par la bouche de Moïse, le serviteur de Dieu; à garder et à observer tous les commandements de Yahvé notre Dieu, ses coutumes et ses lois."
,"31":"Nous ne donnerons plus nos filles comme épouses au peuple du pays et nous ne prendrons plus leurs filles pour nos fils."
,"32":"Si, le jour du sabbat, les peuples du pays apportent pour les vendre, des marchandises ou d'autres produits quelconques, nous ne les achèterons pas un jour de sabbat ni un jour sacré. La septième année, nous renoncerons aux produits du sol et à tout argent qui nous est dû."
,"33":"Nous nous obligeons à verser un tiers de pièce d'argent par an pour le culte du Temple de notre Dieu:"
,"34":"pour le pain d'oblation, pour l'offrande et l'holocauste perpétuels, pour les sacrifices du sabbat, des Nouvelles Lunes, des fêtes, pour les repas sacrés, pour les sacrifices offerts pour l'expiation des péchés d'Israël; en un mot, pour tout le service du Temple de notre Dieu."
,"35":"Prêtres, lévites et peuple, nous avons tiré au sort pour chacune de nos familles la date à laquelle chaque année elles offriront le bois au Temple de notre Dieu pour le faire brûler sur l'autel de Yahvé notre Dieu, selon ce qui est écrit dans la Loi."
,"36":"Chaque année nous apporterons au Temple de Yahvé les premiers produits de nos champs et les premiers fruits de tous les arbres,"
,"37":"ainsi que les premiers-nés de nos fils et de notre troupeau, selon ce qui est écrit dans la Loi. Les premiers-nés de notre gros et petit bétail seront apportés au Temple de notre Dieu et destinés aux prêtres de service dans le Temple de notre Dieu."
,"38":"Nous apporterons aux prêtres, dans les salles du Temple de notre Dieu, la meilleure part de nos farines, des produits de nos arbres, du vin nouveau et de l'huile; et la dîme de nos champs sera pour les lévites. Ils prélèveront eux-mêmes cette dîme dans les régions agricoles."
,"39":"Un prêtre, fils d'Aaron, accompagnera les lévites quand ils prélèveront la dîme; les lévites porteront ensuite cette dîme dans les salles de la maison du trésor, au Temple de notre Dieu."
,"40":"C'est en effet dans ces salles que les Israélites et les lévites apporteront les impôts en blé, en vin et en huile; c'est là que se gardera le matériel du Sanctuaire, là où sont les prêtres de service, les portiers et les chantres. Et désormais, nous ne négligerons plus le Temple de notre Dieu."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Les chefs du peuple s'installèrent à Jérusalem et le reste du peuple tira au sort pour qu'un homme sur dix vienne habiter à Jérusalem, la ville sainte; les neuf autres pourraient rester dans les villes de province."
,"2":"Le peuple bénit tous les hommes qui avaient accepté d'habiter à Jérusalem."
,"3":"Vient alors la liste des chefs de la province qui s'installèrent à Jérusalem. Dans les villes de Juda chacun habita dans sa ville et dans sa propriété: Israélites, prêtres, lévites, serviteurs ou fils des esclaves de Salomon."
,"4":"Des fils de Juda et des fils de Benjamin habitaient à Jérusalem: parmi les fils de Juda: Atayas, fils de Ouziyas, fils de Zekaryas, fils d'Amaryas, fils de Chefatyas, fils de Mahalaléel, des descendants de Pérès; "
,"5":"Maaséyas, fils de Barouk, fils de Kol-Hozé, fils de Hazayas, fils de Adayas, fils de Yoyarib, fils de Zekaryas, descendant de Chéla."
,"6":"Le total des descendants de Pérès fixés à Jérusalem était de 468 hommes bons pour la guerre."
,"7":"Voici les fils de Benjamin: Salou, fils de Méchoullam, fils de Yoëd, fils de Pedayas, fils de Kolayas, fils de Maaséyas, fils d'Itiel, fils de Yechayas,"
,"8":"et ses frères, Gabaï, Salaï: 928."
,"9":"Yoël fils de Zikri les commandait, Yéhouda fils de Hasenoua commandait en second la ville."
,"10":"Parmi les prêtres: Yedayas fils de Yoyakim, fils de"
,"11":"Serayas, fils d'Hilkiyas, fils de Méchoullam, fils de Sadoq, fils de Merayot, fils d'Ahitoub, chef du Temple de Dieu,"
,"12":"et ses frères qui étaient au service du Temple: 822 ; Adayas fils de Yeroham, fils de Pelalyas, fils d'Amsi, fils de Malkiyas,"
,"13":"et ses frères, chefs de famille: 242; et Amasaï fils d'Azaréel, fils d'Achaï, fils de Mechilémot, fils d'Immer,"
,"14":"et ses frères, hommes vaillants: 128. Zabdiel fils de Hagadol, les commandait."
,"15":"Parmi les lévites: Chémayas fils de Hakchoub, fils d'Azrikam, fils de Hachabyas, fils de Bouni;"
,"16":"Chabtaï et Yozabad, chefs lévites, responsables des affaires extérieures du Temple de Dieu;"
,"17":"Mattanyas fils de Mika, fils de Zabdi, fils d'Asaf, qui dirigeait les hymnes et entonnait l'action de grâce pour la prière; Bakboukyas, le second parmi ses frères; Obadyas fils de Chamoua, fils de Galal, fils de Yedoutoun."
,"18":"Total des lévites dans la ville sainte: 284."
,"19":"Les portiers: Akoub, Talmon et leurs frères, qui montaient la garde aux portes: 172."
,"20":"Le reste des Israélites, des prêtres et des lévites, habitaient dans les villes de Juda, chacun dans sa propriété ou dans les villages entourés de leurs champs."
,"21":"Les 'serviteurs' habitaient l'Ophel; Siha et Gishpa, étaient chefs des serviteurs."
,"22":"Ouzi fils de Bani, fils de Hachabyas, fils de Mattanyas, fils de Mika, était chef des lévites de Jérusalem; il appartenait aux fils d'Asaf, les chantres chargés du service du Temple de Dieu."
,"23":"Une instruction royale et un règlement fixaient le rôle des chantres, jour après jour."
,"24":"Petayas fils de Méchézabéel, qui appartenait aux fils de Zérah, fils de Juda, était commissaire du roi pour tout ce qui concernait le peuple."
,"25":"Des hommes de Juda habitaient à Kiryat-Ha-Arba et dans ses environs, à Dibon et dans ses environs, à Yékadséel et dans les villages qui l'entourent,"
,"26":"à Yéchoua, à Molada, à Beth-Pélet,"
,"27":"à Hasar-Choual, à Bersabée et dans ses environs,"
,"28":"à Siklag, à Nékona et dans ses environs,"
,"29":"à En-Rimmon, à Soréa, à Yarmout,"
,"30":"à Zanoah, à Adoulam et dans les villages qui les entourent, à Lakish et dans ses campagnes, à Azéka et dans ses environs. Ils s'installèrent donc de Bersabée jusqu'au val de Hinnom."
,"31":"Des fils de Benjamin habitaient à Géba, à Mikmas, à Aya et Béthel ainsi que dans leurs environs,"
,"32":"à Anatot, à Nob, à Ananyas,"
,"33":"à Hasor, à Rama, à Gitayim,"
,"34":"à Hadid, à Séboyim, à Nédalat,"
,"35":"à Lod et à Ono, ainsi que dans le val des artisans."
,"36":"Des groupes de lévites se trouvaient aussi bien en Juda qu'en Benjamin."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Voici les prêtres et les lévites qui revinrent avec Zorobabel, fils de Chéaltiel, et Josué: Serayas, Yirmeyas, Esdras,"
,"2":"Amaryas, Malouk, Hatouch,"
,"3":"Chekanyas, Rehoum, Mérémot,"
,"4":"Iddo, Gineton, Abiyas,"
,"5":"Miyamin, Maadyas, Bilga,"
,"6":"Chemayas; plus: Yoyarib, Yedayas,"
,"7":"Salou, Amoq, Hilkiyas, Yedaya. C'étaient les chefs des prêtres et de leurs frères, au temps de Josué."
,"8":"Lévites: Josué, Binnouï, Kadmiel, Chérébyas, Yéhouda, Mattanyas: ils dirigeaient le chant d'action de grâce."
,"9":"Bakboukyas, Ouni, et leurs frères, formaient le deuxième choeur, selon leurs classes."
,"10":"Josué engendra Yoyakim, Yoyakim engendra Elyachib, Elyachib Yoyada,"
,"11":"Yoyada engendra Yohanan, et Yohanan engendra Yadoua."
,"12":"Voici les chefs des familles de prêtres au temps de Yoyakim: famille de Serayas: Merayas; famille de Yirmeyas: Hananyas;"
,"13":"famille d'Esdras: Méchoullam; famille d'Amaryas: Yohanan;"
,"14":"famille de Malouk: Yonatan; famille de Chebanyas: Yosef;"
,"15":"famille de Harim: Adna; famille de Merayot: Helkaï;"
,"16":"famille d'Iddo: Zekaryas; famille de Gineton: Méchoullam;"
,"17":"famille d'Abiyas: Zikri; famille de Minyamin, et de Madyas, Piltay;"
,"18":"famille de Bilga: Chamoua; famille de Chemayas: Yonatan;"
,"19":"plus: famille de Yoyarib: Matenaï; famille de Yedayas: Ouzi;"
,"20":"famille de Salaï: Kalaï; famille d'Amok: Eber;"
,"21":"famille de Hilkiyas: Hachabyas; famille de Yedayas: Netanéel."
,"22":"Les chefs de familles et les prêtres furent enregistrés jusqu'au règne de Darius le Perse, au temps d'Elyachib, de Yoyada, de Yohanan et de Yadoua."
,"23":"Les fils de Lévi, chefs des familles, furent inscrits sur le Livre des Chroniques, mais seulement jusqu'au temps de Yohanan, petit-fils d'Elyachib."
,"24":"Voici les chefs des lévites: Hachabyas, Chérébyas, Josué, Binnouï et Kadmiel; ils se tenaient face à leurs frères Mattanyas, Bakboukyas et Obadyas, et les deux groupes, face à face, exécutaient les hymnes de louange et d'action de grâce selon la règle fixée par David, l'homme de Dieu."
,"25":"Méchoullam, Talmon et Akoub, étaient portiers, ils montaient la garde devant les magasins situés près des portes."
,"26":"Ceux-ci vivaient au temps de Yoyakim fils de Josué, fils de Yosadak, et au temps de Néhémie le gouverneur et d'Esdras le prêtre-scribe."
,"27":"Pour l'inauguration du rempart de Jérusalem, on alla chercher les lévites partout où ils habitaient; on les fit venir à Jérusalem de façon que l'inauguration soit célébrée dans la joie avec des chants d'actions de grâce, au son des cymbales, des harpes et des cithares."
,"28":"Les chantres fils de Lévi se rassemblèrent donc de toute la région qui entoure Jérusalem, des villages de Nétofa,"
,"29":"de Beth-Ha-Gilgal, des champs de Géba et d'Azmaveth. Les chantres avaient en effet construit leurs villages aux alentours de Jérusalem."
,"30":"Les prêtres et les lévites se purifièrent, puis ils purifièrent le peuple, les portes et le rempart."
,"31":"Alors j'ai fait monter les chefs de Juda sur le rempart et je les ai disposés en deux groupes. Le premier avançait sur le haut du rempart vers la droite, en direction de la porte du Fumier."
,"32":"Derrière lui marchaient Hochayas et une moitié des chefs de Juda,"
,"33":"avec Azaryas, Esdras, Méchoullam,"
,"34":"Yéhouda, Benjamin, Chemayas et Yirméya."
,"35":"On les avait choisis parmi les prêtres et on leur avait donné des trompettes. Ensuite venait Zékaryas fils de Yonatan, fils de Chémayas, fils de Mattanyas, fils de Mika, fils de Zakour, fils d'Asaf."
,"36":"Lui et ses frères Chémayas, Azaréel, Milalaï, Gilalaï, Maaï, Nétanéel, Yéhouda et Hanani, portaient les instruments de musique de David, l'homme de Dieu; le scribe Esdras marchait à leur tête."
,"37":"En arrivant à la porte de la Fontaine, ils sont montés droit devant eux, à côté des escaliers de la Cité de David, par le sommet du rempart et par la rampe du palais de David, jusqu'à la porte des Eaux, à l'est."
,"38":"Le second groupe s'avançait par la gauche; je l'ai suivi avec la moitié des chefs du peuple sur le haut du rempart, du côté de la tour des Fours et jusqu'au gros mur."
,"39":"Puis nous avons dépassé la porte d'Ephraïm, la porte des Poissons, la tour de Hananéel et la Tour-des-Cent jusqu'à la porte des Brebis, et nous nous sommes arrêtés à la porte de la Garde."
,"40":"Les deux groupes ont pris place ensuite dans le Temple de Dieu; j'avais avec moi la moitié des fonctionnaires,"
,"41":"ainsi que les prêtres Elyakim, Maaséyas, Minyanim, Mika, Elyoénaï, Zékaryas, Ananyas, avec leurs trompettes,"
,"42":"et Maaséyas, Chémayas, Eléazar, Ouzi, Yohanan, Malkyas, Elam et Ezer. Les chantres étaient dirigés par Yizrahya."
,"43":"Ce jour-là nous avons offert de nombreux sacrifices et le peuple a fait éclater sa joie, car Dieu lui avait donné un grand sujet de joie; les femmes et les enfants participaient à la fête, et la joie de Jérusalem s'entendait au loin."
,"44":"En ce temps-là on confia les salles prévues pour les provisions, les taxes, les prémices et les dîmes à ceux qui devaient y entreposer la part que la Loi donne aux prêtres et aux lévites; il en arrivait de toutes les villes du pays, car le peuple de Juda était satisfait des prêtres et des lévites qui faisaient le service."
,"45":"Ils assuraient le service de leur Dieu et le service des purifications; les chantres et les portiers observaient les règlements de David et de son fils Salomon."
,"46":"En effet, déjà au temps de David, Asaf était chef des chantres, et on avait des cantiques de louange et d'actions de grâce à Dieu."
,"47":"Et dès le temps de Zorobabel Israël donnait la part qui revenait aux chantres et aux portiers, jour après jour; on donnait aux lévites les offrandes, et les lévites les remettaient aux fils d'Aaron."
}`)
	CurrentBook.AddChapter(13, `{
"1":"En ce temps-là on fit la lecture du livre de Moïse devant le peuple. Or il y était écrit: 'L'Ammonite et le Moabite seront toujours exclus de l'assemblée de Dieu,"
,"2":"car ils ne sont pas venus à la rencontre des Israélites avec du pain et de l'eau. Au contraire ils ont payé Balaam pour les maudire, mais notre Dieu a changé la malédiction en bénédiction.'"
,"3":"Après avoir entendu la Loi, on mit à l'écart d'Israël tous les étrangers."
,"4":"Mais avant cela, le prêtre Elyachib avait été chargé des salles du Temple de notre Dieu. Comme il était de la famille de Tobiyas,"
,"5":"il lui avait arrangé une vaste salle où l'on déposait autrefois les offrandes, l'encens, les objets sacrés, la dîme du blé, du vin et de l'huile, en un mot: la part des lévites, des chantres et des portiers, et ce qu'on en prélevait pour les prêtres."
,"6":"En ce temps-là, j'étais absent de Jérusalem, car dans la trente-deuxième année du règne d'Artaxerxès, roi de Babylone, j'étais retourné auprès du roi. Mais au bout d'un certain temps, j'avais demandé au roi la permission"
,"7":"de revenir à Jérusalem; c'est là que j'avais appris la mauvaise action qu'Elyachib avait faite pour plaire Tobiyas; il lui avait arrangé une salle dans la cour du Temple de Dieu."
,"8":"Cela ne me plaisait pas du tout; j'ai donc jeté dans la cour, hors de la salle, tous les meubles de Tobiyas,"
,"9":"et j'ai ordonné de purifier les salles. Ensuite j'y ai remis les objets du Temple de Dieu, les offrandes et l'encens."
,"10":"J'avais appris également que les parts des lévites ne rentraient plus et que les lévites et les chantres chargés du service, étaient retournés chacun vers leurs champs."
,"11":"Aussi, j'ai secoué sévèrement les fonctionnaires. Je leur ai dit: 'Pourquoi le Temple de Dieu est-il à l'abandon?' J'ai rassemblé les lévites et je les ai rétablis dans leur fonction."
,"12":"Alors tout le peuple de Juda a apporté de nouveau dans les magasins, la dîme du blé, du vin et de l'huile."
,"13":"J'ai confié les magasins au prêtre Chélémyas, au scribe Sadoq, à Pedayas qui était lévite, et pour les aider je leur ai donné Hanan fils de Zakou, fils de Matanyas. Ils avaient la réputation d'être honnêtes, et ils étaient chargés de la répartition à leurs frères."
,"14":"Souviens-toi, mon Dieu, de ce que j'ai fait là, n'oublie pas les bonnes oeuvres que j'ai accomplies pour le Temple de mon Dieu et pour ses lois."
,"15":"En ce temps-là j'ai vu, un jour de sabbat, des hommes qui foulaient des raisins dans le pressoir; d'autres transportaient des gerbes de blé, les chargeaient sur des ânes avec du vin, des raisins, des figues et toutes sortes d'autres fardeaux, et ils les apportaient à Jérusalem le jour du sabbat. Alors je les ai avertis de ne pas vendre ces produits."
,"16":"A Jérusalem même, des Tyriens qui y habitaient faisaient venir du poisson et des produits de toutes sortes pour les vendre aux Judéens le jour du sabbat."
,"17":"J'ai secoué sévèrement les nobles de Juda, je leur ai dit: 'Quelle chose honteuse vous faites là! Vous profanez le jour du sabbat!"
,"18":"Vos pères aussi ont fait cela et Dieu a fait venir tout ce malheur sur nous et sur cette ville. Et vous, vous augmentez encore la colère de Dieu contre Israël en profanant le sabbat!'"
,"19":"Aussi ai-je ordonné de fermer les battants des portes de Jérusalem dès qu'elles commençaient à être dans l'ombre au début du sabbat, et d'attendre la fin du sabbat pour les ouvrir de nouveau. J'ai placé aux portes quelques-uns de mes hommes pour voir qu'aucun fardeau n'entre en ville le jour du sabbat."
,"20":"Une ou deux fois des marchands, des trafiquants de toute espèce, avaient passé la nuit hors de Jérusalem,"
,"21":"mais je les ai prévenus: 'Pourquoi passez-vous la nuit près du rempart? Si vous recommencez, je vous arrête!' Du coup, ils ne sont plus revenus un jour de sabbat."
,"22":"J'ai ordonné aux lévites de se purifier et de venir garder les portes afin de faire respecter le jour du sabbat. Pour cela aussi, souviens-toi de moi, mon Dieu. Aie pitié de moi dans ta grande miséricorde."
,"23":"En ces jours-là encore, j'ai vu des Juifs qui avaient épousé des femmes d'Ashdod, des Ammonites ou des Moabites."
,"24":"La moitié de leurs fils parlaient la langue d'Ashdod ou de tel ou tel peuple, et ne savaient pas le Judéen."
,"25":"Je leur ai fait des reproches et je les ai maudits; j'en ai même frappé quelques-uns, je leur ai arraché les cheveux et au nom de Dieu je leur ai dit sévèrement: 'Vous ne donnerez plus vos filles à leurs fils et vous ne prendrez plus leurs filles pour vos fils ou pour vous."
,"26":"C'est ainsi que Salomon, le roi d'Israël a péché. Il n'y avait pas de roi comme lui en aucun pays, il était aimé de son Dieu qui l'avait fait roi sur tout Israël; et pourtant ses femmes étrangères l'ont fait pécher."
,"27":"Voulez-vous qu'on dise de vous que vous avez commis la même faute et que vous avez été infidèles à notre Dieu en épousant des femmes étrangères?'"
,"28":"Un des fils de Yoyada fils d'Elyachib le grand prêtre, était gendre de Samballat le Horonite; je l'ai chassé loin de moi."
,"29":"N'oublie pas, mon Dieu, à quel point ils avaient discrédité le sacerdoce et ton alliance avec les prêtres et les lévites."
,"30":"Je les ai purifiés de tout étranger; j'ai établi des règles pour les prêtres et les lévites, chacun dans son propre travail,"
,"31":"des règles également pour l'offrande du bois au temps fixé et pour les premiers fruits. Souviens-toi de moi, mon Dieu, et bénis-moi."
}`)

}
func FR_LBDCC_LoadVHRTChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Au temps des Juges, un homme quitta Bethléem de Juda avec sa femme et ses deux fils pour s'installer dans les campagnes de Moab, car il y avait la famine dans le pays."
,"2":"Cet homme s'appelait Elimélek, sa femme se nommait Noémi, et ses deux fils Mahlon et Kilyon; ils étaient d'Ephrata de Bethléem, en Juda. Ils arrivèrent donc dans les campagnes de Moab et s'y installèrent."
,"3":"Elimélek, le mari de Noémi, mourut et elle resta là avec ses deux fils."
,"4":"Ceux-ci se marièrent avec des Moabites; l'une s'appelait Orpa et l'autre Ruth. Ils vécurent ainsi pendant près de dix ans."
,"5":"Mahlon et Kilyon moururent à leur tour et la femme resta seule, sans fils et sans mari."
,"6":"Elle prit donc la décision, avec ses belle-filles, de revenir des campagnes de Moab, car elle avait appris que Yahvé avait visité son peuple et lui donnait du pain."
,"7":"Elle quitta avec ses belle-filles le lieu où elle habitait, et se mit en route pour retourner au pays de Juda."
,"8":"Noémi dit alors à ses belle-filles: 'Allez, retournez chacune chez votre mère et que le Seigneur, dans sa bonté, vous récompense de la bonté que vous avez eue pour nos morts et pour moi-même."
,"9":"Que Yahvé accorde à chacune d'entre vous de trouver un mari avec qui elle vivra en paix.',Mais tandis qu'elle les embrassait, elles lui répondirent tout en larmes: "
,"10":"'Non! Nous retournerons avec toi vers ton peuple!'"
,"11":"Noémi leur dit: 'Repartez mes filles. Pourquoi venir avec moi? Est-ce que je peux encore avoir des fils qui deviendraient vos maris?"
,"12":"Allez, retournez, mes filles. Je suis trop vieille pour me remarier. Et même si je pensais qu'il me reste encore un espoir, si je me disais: Cette nuit je me donnerai à un homme et j'enfanterai encore des fils"
,"13":"auriez-vous la patience d'attendre qu'ils soient grands? Est-ce pour cela que vous renonceriez à vous remarier? Non mes filles, mon amertume est trop lourde à porter pour vous maintenant que la main de Yahvé m'a frappée.'"
,"14":"Alors elles poussèrent des cris et pleurèrent de nouveau; puis Orpa embrassa sa belle-mère et repartit vers son peuple, mais Ruth resta attachée à Noémi."
,"15":"Celle-ci lui dit: 'Regarde, ta belle-soeur est repartie vers son peuple et vers son Dieu. Toi aussi retourne, suis-la.'"
,"16":"Mais Ruth répondit: 'N'insiste pas pour que je t'abandonne et que je m'éloigne de toi, car là où tu iras j'irai, là où tu resteras je resterai. Ton peuple sera mon peuple et ton Dieu sera mon Dieu."
,"17":"Là où tu mourras je mourrai, et là je serai enterrée. Que Yahvé me maudisse et me maudisse encore si ce n'est pas la mort qui nous sépare.'"
,"18":"Noémi cessa d'insister auprès d'elle car elle voyait que Ruth était décidée à l'accompagner."
,"19":"Elles partirent donc toutes les deux et arrivèrent à Bethléem. Toute la ville était retournée en les voyant arriver: 'Est-ce bien Noémi?' s'écriaient les femmes."
,"20":"'Ne m'appelez plus Noémi, répondit-elle, appelez-moi Mara, car le Dieu des Steppes m'a remplie d'amertume."
,"21":"J'étais partie comblée de richesses, et Yahvé me ramène les mains vides. Pourquoi m'appeler encore Noémi alors que Yahvé s'est dressé contre moi et que le Dieu des Steppes m'a rendue malheureuse?'"
,"22":"C'est ainsi que Noémi revint, ayant avec elle Ruth la Moabite, sa belle-fille, qui arrivait des champs de Moab. Elles arrivèrent à Bethléem au début de la moisson des orges."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Du côté de son mari, Noémi avait un parent qui s'appelait Booz; c'était un homme respecté qui était du même clan qu'Elimélek."
,"2":"Ruth la Moabite dit à Noémi: 'Laisse-moi aller dans les champs glaner des épis derrière quelqu'un qui ne me fera pas d'histoire.' Elle lui répondit: 'Va ma fille.'"
,"3":"Ruth partit donc et s'en alla glaner dans les champs, derrière les moissonneurs. Par bonheur, elle arriva dans une pièce de terre appartenant à Booz, du clan d'Elimélek."
,"4":"Or Booz arrivait de Bethléem: 'Que Yahvé soit avec vous!' dit-il aux moissonneurs, et ils lui répondirent: 'Que Yahvé te bénisse.'"
,"5":"Booz demanda alors à celui de ses serviteurs qui commandait les moissonneurs: 'A qui est cette jeune femme?'"
,"6":"Le serviteur qui commandait les moissonneurs répondit: 'Cette jeune femme est la Moabite, celle qui est revenue des champs de Moab avec Noémi."
,"7":"Elle m'a dit: Permets-moi de glaner et de ramasser ce qui tombe des gerbes derrière les moissonneurs. Elle est donc venue et elle est restée là; depuis le matin jusqu'à présent elle s'est à peine arrêtée.'"
,"8":"Booz dit à Ruth: 'Ecoute-moi ma fille: ne va pas glaner dans un autre champ, ne t'éloigne pas d'ici mais attache-toi à mes servantes."
,"9":"Regarde le champ qu'on moissonne et suis-les. Sache bien que j'ai défendu aux serviteurs de te frapper. Si tu as soif, va boire aux cruches l'eau qu'ils auront puisée.'"
,"10":"Alors Ruth se prosterna la face contre terre et lui dit: 'Qu'ai-je donc fait pour que tu me regardes avec bonté et que tu t'intéresses à moi qui ne suis qu'une étrangère?'"
,"11":"Booz lui répondit: 'On m'a rapporté tout ce que tu as fait pour ta belle-mère après la mort de ton mari. On m'a dit comment tu as quitté ton père, ta mère et ton pays natal, pour te rendre dans un peuple que tu ne connaissais pas, ni d'hier, ni d'avant-hier."
,"12":"Que Yahvé te rende aujourd'hui ce que tu as fait et que tu obtiennes une bonne récompense de la part de Yahvé, le Dieu d'Israël, puisque tu es venue t'abriter sous ses ailes.'"
,"13":"Elle lui dit: 'Je voudrais bien mériter ta bonté, mon seigneur. Tu m'as consolée et tu as parlé au coeur de ta servante, alors que je ne suis même pas comme l'une de tes servantes.'"
,"14":"Au moment du repas Booz lui dit: 'Approche un peu, mange de ce pain et trempe ton morceau dans le vinaigre.' Elle s'assit donc à côté des moissonneurs et Booz lui mit un tas de grains rôtis devant elle. Elle mangea à sa faim et emporta le reste."
,"15":"Ensuite elle se leva de nouveau pour glaner. Booz donna cet ordre à ses serviteurs: 'Qu'elle glane même entre les gerbes, ne la tourmentez pas. "
,"16":"Ayez même soin de tirer vous-mêmes quelques épis de vos gerbes. Vous les laisserez tomber pour qu'elle les ramasse et vous ne crierez pas sur elle.'"
,"17":"Ruth glana ainsi dans le champ jusqu'au soir et lorsqu'elle eut battu ce qu'elle avait ramassé, il y avait environ une mesure d'orge."
,"18":"Elle l'emporta, rentra à la ville, et sa belle-mère vit ce qu'elle avait ramassé. Elle tira même ce qu'elle avait mis en réserve de son repas, et le lui donna."
,"19":"'Où as-tu glané aujourd'hui? lui dit sa belle-mère, dans quel champ as-tu ramassé? Béni soit celui qui s'est intéressé à toi!' Ruth apprit à sa belle-mère chez qui elle avait travaillé. Elle lui dit: 'L'homme chez qui j'ai travaillé aujourd'hui s'appelle Booz.'"
,"20":"Noémi dit alors à sa belle-fille: 'Qu'il soit béni de Yahvé, qui ne cesse de montrer sa bonté envers les vivants et envers les morts!' Et Noémi ajouta: 'Cet homme est notre proche parent, il est l'un de ceux qui ont sur nous un droit de rachat.'"
,"21":"Ruth la Moabite dit alors à sa belle-mère: 'Il m'a dit encore: Reste avec mes serviteurs jusqu'à ce qu'ils aient terminé toute la moisson.'"
,"22":"Noémi dit à Ruth, sa belle-fille: 'C'est une bonne chose ma fille que tu restes avec ses servantes, car dans un autre champ on risquerait de te maltraiter.'"
,"23":"Elle resta donc au milieu des servantes de Booz pour glaner jusqu'à la fin de la moisson des orges et de la moisson des blés; elle habitait avec sa belle-mère."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Noémi, sa belle-mère, lui dit: 'Ma fille, je dois chercher à t'établir pour que tu sois heureuse."
,"2":"Or, Booz, dont tu as suivi les servantes, est notre parent. Cette nuit il doit vanner l'orge sur son aire."
,"3":"Lave-toi donc, parfume-toi, mets ton manteau et descends vers l'aire à battre. Ne te fais pas reconnaître par lui avant qu'il ait fini de manger et de boire."
,"4":"Lorsqu'il sera couché, regarde bien l'endroit où il dort. Alors tu iras, tu te feras une place à ses pieds et tu te coucheras. Lui-même te fera savoir ce que tu dois faire.'"
,"5":"Ruth lui répondit: 'Je ferai tout ce que tu m'as dit.'"
,"6":"Elle descendit donc vers l'aire à battre et fit tout ce que sa belle-mère lui avait ordonné."
,"7":"Booz mangea et but, il était de très bonne humeur; puis il s'en alla dormir auprès du tas d'orge. Discrètement Ruth s'y rendit, elle se fit une place à ses pieds et se coucha."
,"8":"Au milieu de la nuit l'homme eut un frisson, il se tourna et aperçut une femme couchée à ses pieds."
,"9":"'Qui es-tu?' dit-il. Elle répondit: 'Je suis Ruth, ta servante. Etends sur ta servante le pan de ton manteau, car tu as sur moi un droit de rachat.'"
,"10":"- 'Que Yahvé te bénisse ma fille, lui dit-il, cet acte de fidélité est encore plus beau que le premier, car tu n'as pas recherché des jeunes gens pauvres ou riches."
,"11":"Maintenant ma fille, sois sans crainte. Je ferai pour toi tout ce que tu me diras, car tout le monde sait bien dans ma ville que tu es une femme vertueuse."
,"12":"Cependant, s'il est vrai que j'ai le droit de rachat, il y a ici un parent plus proche que moi."
,"13":"Passe la nuit ici et, au matin, s'il veut exercer son droit à ton égard, c'est bien, qu'il te rachète. Mais s'il ne veut pas te racheter, aussi vrai que Dieu est vivant, c'est moi qui te rachèterai. Reste donc couchée jusqu'au matin.'"
,"14":"Elle resta donc couchée à ses pieds jusqu'au matin. Puis, avant l'heure où un homme peut en reconnaître un autre, elle se leva. Car Booz se disait: 'Il ne faut pas qu'on sache que cette femme est venue sur l'aire à battre.'"
,"15":"Il ajouta: 'Présente le manteau que tu as sur toi et tiens-le bien.' Elle l'étendit et il versa six mesures d'orge qu'il chargea sur elle au moment où elle retournait à la ville."
,"16":"Lorsque Ruth entra chez sa belle-mère, celle-ci lui dit: 'Comment tout cela s'est-il passé, ma fille?' Ruth lui raconta tout ce que cet homme avait fait pour elle."
,"17":"Elle lui dit: 'Il m'a donné ces six mesures d'orge et il m'a dit: Tu ne reviendras pas les mains vides chez ta belle-mère.'"
,"18":"Noémi répondit: 'Ma fille, tu n'as plus à t'inquiéter pour savoir comment cela finira, car cet homme voudra sûrement que tout soit réglé aujourd'hui même.'"
}`)
	CurrentBook.AddChapter(4, `{
"1":"Booz était venu à la porte de la ville. Il y était assis lorsque passa le parent dont Booz avait parlé. 'Approche ici, lui dit Booz, et assieds-toi.' L'homme s'approcha et s'assit."
,"2":"Booz fit venir dix hommes des anciens de la ville: 'Asseyez-vous ici' leur dit-il, et ils s'assirent."
,"3":"Alors il dit à celui qui avait droit de rachat: 'Noémi, qui est revenue des champs de Moab, met en vente le champ qui appartenait à notre frère Elimélek."
,"4":"J'ai voulu t'en informer, et je te propose de l'acheter en présence de ceux qui sont assis avec nous et des anciens de mon peuple. Si tu veux exercer ton droit de rachat, rachète. Mais si tu ne le veux pas, dis-le moi, que je le sache, car tu es le premier pour le droit de rachat, je ne viens qu'après toi.' L'autre répondit: 'Oui, je vais le racheter.'"
,"5":"Mais Booz lui dit: 'En même temps que tu achètes ce champ de la main de Noémi, tu rachètes aussi Ruth la Moabite, la femme de celui qui est mort, pour qu'un héritier portant son nom reste sur sa terre.'"
,"6":"Alors celui qui avait droit de rachat répondit: 'Je ne peux exercer mon droit, car ce serait au détriment de mon patrimoine. Prends donc à ton compte mon droit de rachat, car moi, je ne peux l'exercer.'"
,"7":"Voici quelle était la coutume autrefois en Israël, en cas de rachat ou d'héritage. Pour que l'affaire soit réglée, on ôtait sa sandale et on la donnait à l'autre: c'était la façon de régler un contrat en Israël."
,"8":"Celui qui avait droit de rachat dit donc à Booz: 'Fais l'achat à ton compte.' Et il retira sa sandale."
,"9":"Booz dit aux anciens et à tout le peuple: 'Vous êtes donc témoins aujourd'hui que j'achète de la main de Noémi tout ce qui appartenait à Elimélek et tout ce qui appartenait à Mahlon et à Kilyon."
,"10":"En même temps, je rachète et prends pour femme Ruth la Moabite, la veuve de Mahlon. Ainsi je lui donnerai un héritier qui restera sur sa terre, et le nom du mort ne disparaîtra pas d'au milieu de ses frères, ni à la porte de la ville. Vous en êtes témoins aujourd'hui.'"
,"11":"Tout le peuple qui était là à la porte de la ville répondit: 'Nous en sommes témoins.' Et les anciens ajoutèrent: 'Que Yahvé rende cette femme, qui entre en ta maison, semblable à Rachel et à Léa, ces deux femmes qui ont édifié la maison d'Israël. Deviens puissant en Ephrata et célèbre à Bethléem!"
,"12":"Que Yahvé te donne des enfants de cette jeune femme, que par eux ta maison soit semblable à celle de Pérès, ce fils que Thamar donna à Juda!'"
,"13":"Booz prit Ruth et elle devint sa femme. Il s'approcha d'elle et Yahvé donna à Ruth de concevoir et d'enfanter un fils."
,"14":"Les femmes dirent alors à Noémi: 'Béni soit Yahvé! Il t'a donné aujourd'hui pour te racheter, un fils dont le nom sera célèbre en Israël."
,"15":"Cet enfant sera ta consolation et le soutien de ta vieillesse, car sa mère est ta belle-fille et elle t'aime; elle vaut mieux pour toi que sept fils.'"
,"16":"Noémi prit l'enfant et le mit sur son sein, et ce fut elle qui s'occupa de lui."
,"17":"Les voisines lui donnèrent un nom. Elles dirent: 'Il est né un fils à Noémi', et elles le nommèrent Obed; c'est le père de Jessé, père de David."
,"18":"Voici la descendance de Pérès. Pérès engendra Hesron."
,"19":"Hesron engendra Ram et Ram engendra Amminadab."
,"20":"Amminadab engendra Nachon et Nachon engendra Salmon."
,"21":"Salmon engendra Booz et Booz engendra Obed."
,"22":"Obed engendra Jessé et Jessé engendra David."
}`)

}
func FR_LBDCC_LoadVHTBChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Histoire de Tobit, fils de Tobiel, fils d'Ananiel, fils d'Adouel, fils de Gabaël, du clan d'Asiel, de la tribu de Nephtali."
,"2":"Au temps de Salmanasar, roi d'Assyrie, Tobit fut déporté de Tibé, au sud de Quédes-Nephtali (c'est en Haute-Galilée, au-dessus d'Hazor, à l'ouest, du côté du soleil couchant et au nord de Chéfat)."
,"3":"Moi, Tobit, j'ai marché sur des chemins de vérité. J'ai fait le bien tous les jours de ma vie. J'ai fait beaucoup d'aumônes à mes frères et à ceux de mon peuple qui ont été emmenés avec moi à Ninive, au pays des Assyriens."
,"4":"Lorsque j'étais encore jeune dans mon pays, sur la terre d'Israël, toute la tribu de Nephtali, mon ancêtre, s'était séparée de la maison de David mon père et de Jérusalem, la ville choisie parmi toutes les tribus d'Israël; c'est là que toutes les tribus doivent offrir leurs sacrifices. C'était là que le Temple où Dieu demeure avait été construit et consacré pour toutes les générations à venir."
,"5":"Mais tous mes frères et la maison de Nephtali sacrifiaient au veau que Jéroboam, roi d'Israël, avait placé à Dan; ils sacrifiaient aussi sur toutes les montagnes de Galilée."
,"6":"Bien souvent je partais seul à Jérusalem pour les fêtes, selon le commandement perpétuel qui fut rédigé pour tout Israël. Je partais à Jérusalem avec les premiers de nos fruits et de nos animaux, la dîme du bétail et la première tonte des brebis."
,"7":"Là je les donnais aux prêtres, fils d'Aaron, pour le service de l'autel. Je donnais la dîme du vin, du blé, des olives, des grenades et des autres fruits aux Lévites de service à Jérusalem. Durant six années de suite je prélevais en espèces une seconde dîme et chaque année j'allais la dépenser à Jérusalem."
,"8":"Je donnais la troisième dîme aux orphelins, aux veuves, aux étrangers qui vivent au milieu d'Israël, et tous les trois ans je leur en faisais cadeau. Pour les repas, nous obéissions aux commandements de la Loi de Moïse et aux ordres que nous avait donnés Déborah, la mère d'Ananiel, notre père, car mon père était mort et m'avait laissé orphelin. "
,"9":"Devenu homme, j'ai épousé une femme de notre famille, et par elle j'ai eu un fils que j'ai appelé du nom de Tobie."
,"10":"Au temps de la déportation en Assyrie, j'ai été emmené à Ninive. Tous mes frères et ceux de mon peuple partageaient la nourriture des païens,"
,"11":"mais moi, je me suis gardé de manger la nourriture des païens."
,"12":"Aussi, comme j'étais fidèle à mon Dieu du fond du coeur,"
,"13":"le Très-Haut m'a accordé la faveur de Salmanasar et je devins son homme d'affaires."
,"14":"C'est alors que j'ai voyagé en Médie où j'ai passé des marchés en son nom jusqu'à sa mort. A cette occasion, je déposai chez Gabaël frère de Gabri, à Rhagès, en Médie, des sacs contenant dix talents d'argent."
,"15":"A la mort de Salmanasar, son fils Sennakérib régna à sa place. On ferma alors les routes de Médie et je ne pouvais plus me rendre en Médie."
,"16":"Aux jours de Salmanasar, j'avais souvent fait l'aumône à mes frères de race:"
,"17":"je donnais mon pain à ceux qui avaient faim et des habits à ceux qui étaient nus. Lorsque je voyais les cadavres de mes compatriotes jetés par-dessus les remparts de Ninive, je les enterrais."
,"18":"J'enterrai aussi ceux que Sennakérib avait tués. En effet, à la suite du châtiment que le roi du Ciel lui avait infligé pour ses blasphèmes, il s'était enfui de Judée et, à son retour, il fit tuer un grand nombre d'Israélites. Je cachai leurs corps pour les ensevelir, si bien que Sennakérib les chercha et ne les trouva pas."
,"19":"Un habitant de Ninive fit savoir au roi que c'était moi qui les ensevelissais, et je dus me cacher. Mais quand j'appris que le roi était bien informé sur mon compte, lorsque je vis qu'il me recherchait pour me mettre à mort, j'eus peur et je pris la fuite."
,"20":"Tous mes biens furent confisqués pour le trésor royal; il ne me restait plus que ma femme Ana et mon fils Tobie."
,"21":"Mais il ne s'était pas encore écoulé quarante jours, lorsque les deux fils du roi l'assassinèrent, après quoi ils prirent la fuite vers les monts d'Ararat. Son fils Asarhaddon régna à sa place. Ahikar, fils de mon frère Anaël, fut alors chargé des comptes du royaume et de la direction générale des affaires."
,"22":"En effet, Ahikar avait été grand échanson sous le règne de Sennakérib, roi d'Assyrie, il était gardien du sceau royal, administrateur et responsable des comptes, et Asarhaddon l'avait maintenu dans ses fonctions. Or il était de ma famille, c'était mon neveu. Ahikar intervint en ma faveur et je pus revenir à Ninive."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Sous le règne d'Asarhaddon, je suis donc revenu chez moi et on me rendit ma femme Ana et mon fils Tobie. A la fête de la Pentecôte, la fête des Semaines, on fit un grand dîner. Je me suis allongé pour le repas,"
,"2":"on m'a apporté la table et de nombreux plats. J'ai dit alors à mon fils Tobie: 'Mon enfant, va! Et si tu trouves parmi nos frères déportés à Ninive, quelque pauvre qui se souvienne de Dieu de tout son coeur, amène-le pour qu'il partage mon repas. Je t'attendrai, mon enfant, jusqu'à ce que tu sois revenu.'"
,"3":"Tobie partit chercher un pauvre parmi nos frères et, à son retour, il dit: 'Père, quelqu'un de notre race vient d'être assassiné. On l'a étranglé, on l'a jeté sur la place du marché et il y est encore.'"
,"4":"J'ai laissé mon repas sans y toucher; je n'ai fait qu'un bond, j'ai enlevé l'homme de la place et je l'ai déposé dans une chambre en attendant le coucher du soleil pour l'enterrer."
,"5":"Puis je suis rentré, je me suis lavé et j'ai mangé mon pain dans les larmes."
,"6":"Je me suis souvenu des paroles du prophète Amos, sur Béthel: 'Vos fêtes seront changées en deuil et tous vos cantiques en lamentations.'"
,"7":"J'ai pleuré, et lorsque le soleil s'est couché, je suis allé creuser une fosse et je l'ai enterré."
,"8":"Mes voisins disaient en se moquant: 'Il n'a donc pas peur? Une première fois déjà il a dû s'enfuir, et de nouveau il enterre les morts!'"
,"9":"Ce soir-là j'ai pris un bain. Je suis sorti dans la cour et je me suis allongé le long du mur de la cour; comme il faisait chaud, j'avais le visage découvert."
,"10":"Je ne savais pas qu'au-dessus de moi dans le mur il y avait des oiseaux; de la fiente toute chaude me tomba dans les yeux et provoqua des taches blanches. J'allai me faire soigner chez les médecins, mais plus ils m'appliquaient de médicaments, plus les taches se développaient. A la fin j'étais complètement aveugle. Je suis resté ainsi quatre ans sans voir, tous mes frères en étaient désolés. Mais durant les deux années qui précédèrent le départ d'Ahikar en Elymaïde, il s'occupa de moi."
,"11":"A ce moment-là, ma femme trouva du travail: elle filait la laine et recevait de la toile à tisser."
,"12":"Lorsqu'elle livrait la commande elle recevait son salaire. Or le sept du mois de Dystros, elle termina une pièce et la livra aux clients; ils lui payèrent ce qu'ils devaient et lui donnèrent en plus un chevreau pour le repas."
,"13":"Quand elle rentra chez moi, le chevreau se mit à bêler; alors j'appelai ma femme et je lui dis: 'D'où vient ce chevreau, peut-être a-t-il été volé? Rends-le à ses maîtres, nous n'avons pas le droit de manger ce qui a été volé.'"
,"14":"Elle me répondit: 'C'est un cadeau qu'on m'a donné en plus de mon salaire.' Je refusai de la croire et je lui dis de le rendre à ses propriétaires, car j'avais honte pour elle. Alors elle me répondit: 'Où sont donc tes aumônes et tes bonnes oeuvres? On sait bien ce que cela t'a rapporté.'"
}`)
	CurrentBook.AddChapter(3, `{
"1":"Cette affaire m'a beaucoup peiné. J'ai soupiré et j'ai pleuré. J'ai prié et je me suis lamenté:"
,"2":"'Tu es juste, Seigneur, et toutes tes oeuvres sont justes. Tes chemins sont miséricorde et vérité, tu es le juge du monde."
,"3":"Maintenant, Seigneur, souviens-toi de moi et regarde-moi! Ne me punis pas pour mes péchés et mes fautes, ni pour celles que mes pères ont commises envers toi."
,"4":"Parce qu'ils avaient désobéi à tes commandements, tu nous as livrés au pillage, à la déportation et à la mort. Nous sommes en butte aux insultes de tous les païens parmi lesquels nous avons été dispersés."
,"5":"Tes jugements sont justes lorsque tu me traites selon mes fautes et selon les fautes de mes pères, car nous n'avons pas obéi à tes commandements et nous n'avons pas marché droit devant toi."
,"6":"Maintenant traite-moi comme tu le voudras. Reprends donc ma vie: je voudrais être délivré de la terre et retourner en poussière, car pour moi la mort vaut mieux que la vie. J'ai subi des insultes sans raison et je suis dans une profonde tristesse. Délivre-moi donc, Seigneur, de cette épreuve, laisse-moi partir vers le séjour éternel. Ne détourne pas ton regard de moi, Seigneur. Mieux vaut pour moi mourir, que passer ma vie dans un mal incurable.'"
,"7":"Or voici que le même jour Sarra, fille de Ragouël, qui habitait à Ekbatane en Médie, se fit insulter par une servante de son père."
,"8":"Sept fois déjà Sarra avait été donnée en mariage, mais Asmodée, un méchant démon, avait tué ses maris l'un après l'autre avant qu'ils n'aient pu s'unir comme de bons époux. Aussi cette servante lui dit-elle: 'Oui, c'est toi qui tues tes maris! On t'en a déjà donné sept et aucun ne t'est resté. "
,"9":"Si tes maris sont morts, ce n'est pas une raison pour nous fouetter. Va donc les retrouver, et que jamais on ne voie de toi, ni garçon, ni fille!'"
,"10":"Elle eut beaucoup de peine ce jour-là; elle pleura et monta dans la chambre de son père avec l'idée de se pendre. Mais elle réfléchit et se dit: 'On en fera sûrement le reproche à mon père, on lui dira: Tu n'avais qu'une fille chérie et elle s'est pendue de malheur. Non! Je ne veux pas endeuiller les derniers jours de mon père. Au lieu de me pendre, je devrais supplier le Seigneur de me faire mourir plutôt que de vivre en étant toujours insultée.'"
,"11":"Aussitôt elle étendit les bras face à la fenêtre et se mit à prier: 'Tu es béni, Dieu plein de miséricorde, que ton nom soit béni pour les siècles et que toutes tes oeuvres te bénissent pour l'éternité!"
,"12":"Vois que je lève mon visage et que je tourne les yeux vers toi."
,"13":"Ordonne que je quitte cette terre pour n'être plus insultée."
,"14":"Tu le sais, Seigneur, je suis restée pure, aucun homme ne m'a touchée."
,"15":"Je n'ai pas déshonoré mon nom ni celui de mon père sur cette terre d'exil. Je suis la fille unique de mon père, il n'a pas d'enfants pour hériter de lui, il n'a même pas un frère auprès de lui, ou quelque parent pour qui je devrais me garder. Pourquoi vivre encore quand j'ai déjà perdu sept maris,? Si tu ne veux pas me faire mourir, regarde-moi avec pitié, que je ne sois plus insultée.'"
,"16":"Leurs prières à l'un et à l'autre parvinrent en même temps au Dieu de Gloire,"
,"17":"et Raphaël fut envoyé pour les guérir tous les deux. Il devait enlever les taches blanches des yeux de Tobit, pour qu'il voie de ses yeux la lumière de Dieu, et il devait faire que Sarra, fille de Ragouël, épouse Tobie, fils de Tobit, et soit délivrée d'Asmodée, le méchant démon. (Il faut savoir qu'avant tout autre prétendant, elle revenait de droit à Tobie.),C'était le moment précis où Tobit rentrait de la cour dans sa maison, et où Sarra fille de Ragouël redescendait de sa chambre."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Ce jour-là, Tobit repensa à l'argent qu'il avait laissé chez Gabaël, à Rhagès en Médie."
,"2":"Il se dit: 'Si je demande vraiment à mourir, je ferais bien d'appeler mon fils Tobie pour lui parler de cette somme avant d'être mort.'"
,"3":"Il appela donc son fils Tobie auprès de lui et lui dit: 'Lorsque je serai mort, fais-moi un enterrement convenable. Honore ta mère et ne l'abandonne pas un seul jour de ta vie. Fais ce qu'elle te demande et ne lui donne aucun sujet de tristesse."
,"4":"Souviens-toi, mon fils, des dangers qu'elle a courus pour toi lorsque tu étais encore dans son sein, et quand elle sera morte, enterre-la auprès de moi dans la même tombe."
,"5":"Mon enfant, sois tous les jours fidèle au Seigneur; ne pèche pas et ne désobéis pas à ses lois. Fais ce qui est bien tous les jours de ta vie et ne marche pas dans les chemins de l'injustice."
,"6":"Si tu agis avec droiture, tu réussiras dans toutes tes entreprises, comme tous ceux qui pratiquent la justice."
,"7":"Prends sur tes biens pour faire l'aumône, ne détourne pas ton regard d'un pauvre, et Dieu ne détournera pas le sien de toi."
,"8":"Donne généreusement. Si tu as beaucoup, donne davantage, si tu as peu, donne moins, mais n'hésite pas à faire l'aumône."
,"9":"Ainsi tu te prépares un beau trésor pour le jour du besoin."
,"10":"Car l'aumône délivre de la mort et elle empêche de tomber dans les ténèbres."
,"11":"L'aumône est une offrande de grande valeur pour tous ceux qui la font sous le regard du Très-Haut."
,"12":"Garde-toi, mon enfant, de toute mauvaise conduite. Choisis une femme dans la famille de tes pères, ne prends pas une femme étrangère à la tribu de ton père, car nous sommes les fils des prophètes. Souviens-toi de Noé, d'Abraham, d'Isaac et de Jacob, qui furent nos pères des origines. Tous ont pris une femme dans leur parenté et ils ont été bénis dans leurs enfants; leur race a reçu la terre en héritage."
,"13":"Toi aussi, mon enfant, préfère tes frères; garde-toi de mépriser tes frères, les fils et les filles de ton peuple, et choisis ta femme parmi eux. De même que l'orgueil amène la ruine et beaucoup de soucis, la paresse amène la pauvreté et la misère. En effet, la paresse est la mère de la famine."
,"14":"Ne fais pas attendre au lendemain le salaire de tes ouvriers, mais verse-le tout de suite. Si tu sers Dieu, tu seras récompensé. Sois responsable, mon fils, dans tout ce que tu fais, et correct dans toutes actions."
,"15":"Ne fais pas aux autres ce que tu n'aimerais pas subir toi-même. Ne bois pas de vin au point de t'enivrer, et ne fais pas de la débauche la compagne de ta route."
,"16":"Partage ton pain avec ceux qui ont faim et tes habits avec ceux qui sont nus. Donne généreusement de tout ce que tu as en abondance et, lorsque tu fais l'aumône, ne regrette rien."
,"17":"Sois généreux de pain et de vin sur le tombeau des justes, mais ne donne pas au pécheur."
,"18":"Ecoute les conseils des personnes âgées et ne méprise jamais un bon conseil."
,"19":"En toute occasion bénis le Seigneur Dieu, demande-lui de guider tes pas et de faire réussir tes entreprises et tes projets. La sagesse du monde ne va pas loin, c'est le Seigneur qui donne la prospérité; selon son bon vouloir il élève ou il abaisse jusquséjour des morts. Maintenant, mon enfant, rappelle-toi ces commandements et ne les laisse pas s'effacer dans ton coeur."
,"20":"Il faut que tu saches, mon fils, que j'ai déposé dix talents d'argent chez Gabaël fils de Gabri, à Rhagès en Médie."
,"21":"Mais ne t'inquiètes pas, mon fils, de nous voir devenus pauvres: tu possèdes une grande richesse si tu crains Dieu, si tu évites tout péché, et si tu fais ce qui est agréable au Seigneur ton Dieu.'"
}`)
	CurrentBook.AddChapter(5, `{
"1":"Alors Tobie répondit à son père Tobit: 'Père, je ferai tout ce que tu m'as commandé."
,"2":"Mais comment vais-je récupérer ce dépôt? Gabaël ne me connaît pas et moi je ne le connais pas non plus. Quelle preuve vais-je lui donner pour qu'il me croie et qu'il me remette cet argent? De plus, je ne connais pas la route pour aller en Médie.'"
,"3":"Tobit répondit à son fils Tobie: 'Nous avons échangé nos signatures sur un billet et je l'ai coupé en deux pour que nous en gardions chacun la moitié. J'ai pris l'une et j'ai laissé l'autre avec l'argent lorsque j'ai laissé cet argent en dépôt il y a vingt ans. Maintenant, mon enfant, cherche un homme sérieux comme compagnon de voyage: il sera à nos frais jusqu'à ton retour. Ensuite tu iras rechercher cet argent chez Gabaël.'"
,"4":"Tobie s'en alla donc à la recherche d'un bon guide capable de l'accompagner en Médie. Il rencontra dehors l'ange Raphaël qui venait face à lui, mais il ne savait pas que c'était un ange de Dieu."
,"5":"Il lui dit: 'D'où es-tu, mon ami?' L'ange répondit: 'Je suis l'un de tes frères israélites et je suis venu chercher du travail par ici.' Tobie lui dit: 'Connais-tu la route pour aller en Médie?'"
,"6":"L'ange répondit: 'Bien sûr! J'y suis allé plusieurs fois, je connais tous les chemins parfaitement. J'ai été souvent en Médie, je me logeais chez Gabaël, l'un de nos frères qui habite à Rhagès en Médie. Il faut deux jours de marche d'Ekbatane à Rhagès. Rhagès est dans la montagne et Ekbatane au milieu de la plaine.'"
,"7":"Tobie lui dit: 'Attends-moi un instant, que j'aille prévenir mon père. Tu vas venir avec moi et je te paierai tes journées.'"
,"8":"L'autre répondit: 'Bien, j'attends, mais ne traîne pas!'"
,"9":"Tobie alla dire à son père qu'il avait trouvé quelqu'un parmi leurs frères d'Israël. Son père lui dit: 'Présente-le moi pour que je m'informe de sa famille et de sa tribu. Il faut voir si l'on peut lui faire confiance pour t'accompagner, mon enfant.' Tobie sortit donc pour l'appeler: 'Eh, l'ami, dit-il, mon père te demande.'"
,"10":"L'ange entra dans la maison, Tobit salua le premier et l'autre répondit par des souhaits de bonheur. Tobit lui dit: 'Puis-je connaître encore le bonheur? Je suis aveugle. Je ne vois plus la lumière du ciel, et je vis plongé dans la nuit comme les morts qui ne voient plus jamais la lumière. Je suis un mort-vivant, j'entends la voix des gens sans les voir.' L'ange lui dit: 'Aie confiance. Dieu va bientôt te guérir. Aie confiance.' Tobit lui dit: 'Mon fils Tobie veut se rendre en Médie. Acceptes-tu de lui servir de guide? Je te paierai, mon frère.' Il répondit: 'Je veux bien l'accompagner, je connais tous les chemins. Je suis souvent allé en Médie, j'ai traversé les plaines et les montagnes, et je connais toutes les pistes.'"
,"11":"Tobit lui dit: 'Mon frère, de quelle famille et de quelle tribu es-tu? Veux-tu bien me le dire, mon frère.'"
,"12":"L'autre demanda: 'Qu'importe ma tribu?' Tobit insista: 'Je veux savoir bien de qui tu es le fils et quel est ton nom.'"
,"13":"L'autre répondit: 'Je suis Azarias, fils d'Ananias le Grand, l'un de tes frères.'"
,"14":"Alors Tobit dit: 'Sois donc le bienvenu, mon frère, ne te fâche pas si j'ai voulu connaître ta famille. Il se trouve que tu es mon parent de belle et bonne descendance. Je connais Ananias et Natan, les deux fils de Séméias le Grand. Ils venaient avec moi à Jérusalem, nous y avons adoré ensemble et ils n'ont jamais quitté le droit chemin. Tes frères sont des hommes de bien, tu es de bonne famille, sois donc le bienvenu.'"
,"15":"Il ajouta: 'Je t'engage pour une drachme par jour, et pour ton entretien tu auras ce que je donne à mon fils. Accompagne donc mon fils,"
,"16":"et je dépasserai même le prix fixé.' L'ange répondit: 'Je ferai le voyage avec lui, n'aie pas peur: bien au départ, et bien au retour! D'ailleurs la route est sûre.'"
,"17":"Tobit lui dit: 'Sois béni, mon frère!' Puis il se tourna vers son fils: 'Mon enfant, dit-il, prépare ce dont tu as besoin pour le voyage, puis pars avec ton frère. Que le Dieu qui est dans les cieux vous garde là-bas, et qu'il vous ramène en bonne santé auprès de moi. Que son ange vous accompagne de sa protection, mon enfant!',Au moment de quitter la maison pour prendre la route, Tobie embrassa son père et sa mère. Tobit lui dit: 'Bon voyage!' "
,"18":"mais sa mère pleurait; elle dit à Tobit: 'Pourquoi as-tu voulu le départ de mon enfant? N'est-il pas notre bâton de vieillesse, celui qui s'oc cupe de tout pour nous?"
,"19":"Pourquoi avoir de l'argent? L'argent n'est rien à côté de notre enfant."
,"20":"Nous avions bien assez avec ce que Dieu nous donnait pour vivre.'"
,"21":"Alors Tobit lui dit: 'Tu te fais des idées! Notre enfant part en bonne santé et reviendra de même à la maison. Il reviendra en bonne santé, tu le verras! Ne te fais donc pas des idées, ne t'inquiète pas pour eux, ma soeur."
,"22":"Un bon ange l'accompagnera, il fera bon voyage et il reviendra en bonne santé."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Elle cessa de pleurer"
,"2":"Le jeune homme partit avec l'ange et le chien suivait derrière. Ils marchaient tous les deux et, au soir du premier jour, ils campèrent le long du Tigre."
,"3":"Le jeune homme descendit au fleuve pour se laver les pieds, mais un gros poisson sauta de l'eau et faillit lui dévorer le pied. Le garçon se mit à crier,"
,"4":"mais l'ange lui dit: 'Attrape le poisson, ne le lâche pas!' Le jeune homme se rendit maître du poisson et le tira sur la rive."
,"5":"L'ange lui dit: 'Ouvre-le, enlève le fiel, le coeur et le foie et mets-les de côté avant de jeter les entrailles. En effet le fiel, le coeur et le foie, sont des remèdes bien utiles.'"
,"6":"Le jeune ouvrit le poisson, il enleva le fiel, le coeur et le foie. Il fit cuire une partie du poisson pour le repas et garda le reste pour le saler. Ils continuèrent ensuite tous les deux leur route jusqu'en Médie."
,"7":"Alors le jeune homme interrogea l'ange: 'Mon frère Azarias, quel remède y-a-t-il donc dans le coeur, le foie et le fiel du poisson?'"
,"8":"Il répondit: 'Le coeur et le foie du poisson, on les fait fumer devant l'homme ou la femme qui sont tourmentés par un démon ou un esprit mauvais, et tout malaise disparaît complètement sans plus laisser de trace."
,"9":"Le fiel sert pour guérir les yeux lorsque l'on a des taches sur l'oeil. Il suffit alors de souffler sur les taches pour les faire partir.'"
,"10":"Ils étaient entrés en Médie et s'approchaient déjà d'Ekbatane,"
,"11":"lorsque Raphaël dit au jeune homme: 'Mon frère Tobie!' Il répondit: 'Qu'y-a-t-il?' L'ange lui dit: 'Ce soir nous irons loger chez ton parent Ragouël; il est de ta famille et il a une fille appelée Sarra."
,"12":"A part Sarra, il n'a ni garçon ni fille, et tu es son plus proche parent. Elle te revient donc de droit et tu as droit aussi sur l'héritage de son père. C'est une fille bien, courageuse, très gentille et son père l'aime beaucoup.'"
,"13":"L'ange continua: 'C'est à toi de l'épouser. Ecoute-moi, frère! Dès ce soir je parlerai de la jeune fille à son père, pour qu'elle soit tout-de-suite ta fiancée, et quand nous reviendrons de Rhagès, nous ferons le mariage. Je t'assure que Ragouël n'a absolument pas le droit de te la refuser ou de la donner à un autre. Selon la loi de Moïse, il mériterait la mort du moment qu'il sait que tu as la priorité sur n'importe qui dans la famille pour épouser sa fille. Donc frère, fais ce que je te dis. Dès ce soir nous parlerons de la jeune fille et nous ferons la demande en mariage; et lorsque nous rentrerons de Rhagès, nous la reprendrons et nous l'emmènerons avec nous dans ta famille."
,"14":"Tobie répondit à Raphaël: 'Frère Azarias, on m'a dit qu'elle a déjà été mariée sept fois et que l'un après l'autre ses maris sont morts la nuit même des noces, au moment où ils s'approchaient d'elle. Et j'ai entendu dire que c'était un démon qui les tuait."
,"15":"J'ai peur! A elle, le démon ne lui fait rien parce qu'il l'aime, mais celui qui veut s'approcher d'elle, il le tue. Or, je suis le fils unique de mon père: me vois-tu mourir et que mon père et ma mère restent en deuil jusqu'à la tombe? Ils n'auront pas d'autre fils pour les enterrer.'"
,"16":"L'ange répondit: 'Oublies-tu les recommandations de ton père? Il t'a pourtant recommandé de prendre une femme dans la famille de ton père. Alors, écoute-moi, frère, ne t'inquiète pas pour ce démon, prends-la; je te promets que dès ce soir elle sera ta femme."
,"17":"Mais lorsque tu seras entré dans la chambre, prends le foie et le coeur du poisson et pose-les sur les braises de l'encens. L'odeur se répandra,"
,"18":"et dès que le démon la sentira, il prendra la fuite. Je t'assure qu'on ne le reverra plus jamais rôder autour de la jeune fille. Puis, au moment de vous unir, levez-vous d'abord tous les deux pour prier: demandez au Seigneur du Ciel de vous donner sa grâce et sa protection. N'aie pas peur, depuis toujours elle t'a été réservée, et c'est toi qui la sauveras. Elle te suivra et je te promets qu'elle te donnera des enfants qui seront pour toi comme des frères. Ne te fais pas des idées noires!'"
,"19":"En entendant les paroles de Raphaël, Tobie comprit que Sarra était sa soeur, une parente de la famille de son père et il l'aima tellement qu'il ne cessait plus de penser à elle."
}`)
	CurrentBook.AddChapter(7, `{
"1":"En entrant dans Ekbatane, Tobie dit à Azarias: 'Conduis-moi donc tout de suite chez notre frère Ragouël.' Il le conduisit donc à la maison de Ragouël; il était assis près de la porte de la cour. Ils le saluèrent les premiers et il répondit: 'Frères, je vous salue, vous êtes les bienvenus.' Et il les fit entrer dans sa maison. "
,"2":"Il dit à sa femme Edna: 'Comme ce jeune homme ressemble à mon frère Tobit!'"
,"3":"Edna leur demanda: 'D'où êtes-vous, mes frères?' Ils répondirent: 'Nous sommes des fils de Nephtali déportés à Ninive.'"
,"4":"Elle leur dit: 'Connaissez-vous notre frère Tobit?' - 'Nous le connaissons' dirent-ils."
,"5":"Alors elle ajouta: 'Comment va-t-il?' - 'Il va bien.' répondirent-ils, et Tobie ajouta: 'C'est mon père.'"
,"6":"Aussitôt Ragouël se leva, il l'embrassa et il pleura."
,"7":"Puis il lui dit: 'Sois béni, mon enfant, ton père est un homme bon et excellent. Quel terrible malheur qu'un homme si bon et si généreux soit devenu aveugle!' Il tomba au cou de son frère Tobie et il pleurait; sa femme Edna et leur fille Sarra pleuraient également."
,"8":"Ensuite, il fit tuer un mouton du troupeau et on prépara un bon repas."
,"9":"Alors Tobie dit à Raphaël: 'Frère Azarias, si tu demandais à Ragouël de me donner ma soeur Sarra?'"
,"10":"En entendant ces paroles, Ragouël dit au jeune homme: 'Mange et bois. Ne gâche pas ta soirée, personne n'a le droit d'épouser ma fille Sarra en dehors de toi, mon frère. Moi-même je ne suis pas libre de la donner à un autre, puisque tu es notre plus proche parent. Maintenant, mon enfant, je vais te parler franchement."
,"11":"Je l'ai donnée successivement à sept de nos frères, et tous sont morts dès le premier soir lorsqu'ils s'approchaient d'elle. Pour le moment mon enfant, mange et bois. Le Seigneur vous accordera sa grâce et sa paix.'"
,"12":"Mais Tobie s'écria: 'Je ne veux pas entendre parler de boire et de manger tant que tu n'auras pas réglé cette affaire!' Ragouël répondit: 'Bien! Puisque selon la loi de Moïse elle t'appartient, c'est le Ciel qui décide de te la donner; reçois donc ta soeur. Désormais, tu es son frère et elle est ta soeur, elle t'est donnée aujourd'hui pour toujours. Le Seigneur du Ciel vous viendra en aide ce soir, mon fils, il vous donnera sa grâce et sa paix.'"
,"13":"Ragouël fit donc appeler sa fille Sarra, il lui prit la main et la mit dans celle de Tobie, en disant: 'Reçois-la selon la Loi et le décret écrits dans le livre de Moïse qui te la donne comme épouse. Prends-la, qu'elle arrive heureusement avec toi chez ton père. Que le Dieu du ciel vous accorde de faire un bon voyage sans incidents.'"
,"14":"Il se tourna ensuite vers la mère et lui demanda d'aller chercher une feuille pour écrire. Il rédigea alors le contrat de mariage selon lequel il donnait sa fille comme épouse à Tobie, en application de la Loi de Moïse. Après cela on se mit à table, on mangea et on but. "
,"15":"Ragouël appela sa femme Edna et lui dit: 'Ma soeur, prépare la seconde chambre où tu la conduiras.'"
,"16":"Elle s'en alla faire le lit de la chambre, comme il le lui avait demandé, et elle y conduisit sa fille. Alors elle se mit à pleurer sur elle, et tout en essuyant ses larmes, elle disait:"
,"17":"'Aie confiance, ma fille! Que le Seigneur du Ciel change ton chagrin en joie! Aie confiance ma fille!' Et elle se retira."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Quand le repas fut terminé, on parla d'aller se coucher. On conduisit le jeune homme depuis la salle du repas jusque dans la chambre."
,"2":"Tobie se rappela les conseils de Raphaël; il prit son sac, il en sortit le coeur et le foie du poisson et les posa sur les braises de l'encens."
,"3":"Intoxiqué, le démon prit la fuite à travers les airs jusqu'aux hauts plateaux d'Egypte. Raphaël le poursuivit, il le captura là-bas et le ligota aussitôt."
,"4":"Cependant, les parents étaient sortis et avaient refermé la porte. Tobie se leva du lit et dit à Sarra: 'Lève-toi, ma soeur. Prions tous les deux, supplions notre Seigneur pour obtenir sa grâce et sa protection.' "
,"5":"Elle se leva et ensemble ils se mirent à prier pour leur salut: 'Tu es béni, Dieu de nos pères et ton Nom est béni pour les siècles des siècles. Que les cieux et toutes tes créatures te bénissent de siècle en siècle! "
,"6":"Tu as créé Adam, tu as créé Eve, sa femme, pour être son secours et son soutien, et c'est d'eux que toute la race des hommes est née. Tu as dit: il ne faut pas que l'homme soit seul, faisons-lui une aide semblable à lui."
,"7":"Maintenant ce n'est pas le plaisir que je cherche en épousant cette soeur, je le fais d'un coeur sincère. Aie pitié d'elle et de moi et conduis-nous ensemble jusqu'à la vieillesse.'"
,"8":"Ils terminèrent en disant ensemble: 'Amen! Amen!'"
,"9":"Puis ils se couchèrent pour la nuit. Ragouël s'était levé. Il avait appelé ses serviteurs, et ensemble ils étaient partis creuser une tombe. "
,"10":"Il se disait en effet: 'Si par hasard il était mort, il ne faudrait pas que nous soyons couverts de ridicule et de honte.'"
,"11":"Une fois la fosse creusée, Ragouël rentra à la maison et appela sa femme."
,"12":"Il lui dit: 'Envoie une servante dans la chambre pour voir si Tobie est toujours en vie. S'il est mort, nous l'enterrerons sans que personne ne le sache.'"
,"13":"On envoya donc la servante, on alluma une lampe et on ouvrit la porte. Elle entra et les trouva tous deux couchés et endormis."
,"14":"Elle ressortit et leur fit signe qu'il était en vie, qu'aucun malheur n'était arrivé."
,"15":"Alors Ragouël bénit le Dieu du ciel: 'Tu mérites, ô Dieu, toute sainte bénédiction! Que tous les siècles te bénissent!"
,"16":"Béni sois-tu, car tu m'as rempli de joie. Ce que je redoutais n'est pas arrivé, tu as agi avec nous selon ton immense bonté."
,"17":"Béni sois-tu, toi qui as eu pitié de ces deux enfants uniques. Maître, donne-leur ta grâce et ton salut. Que leur vie toute entière connaisse le bonheur et ta grâce!'"
,"18":"Avant que le jour se lève, Ragouël avait fait reboucher la tombe par ses serviteurs."
,"19":"Il dit à sa femme de faire une fournée de pain, il alla au troupeau, prit deux boeufs et quatre moutons et demanda à la cuisine pour qu'on les tue et qu'on les prépare."
,"20":"Il fit ensuite appeler Tobie et lui dit: 'Ne bouge pas d'ici avant deux semaines, tu mangeras et tu boiras chez moi. Ma fille a eu assez d'épreuves, tu peux bien lui donner un peu de bonheur."
,"21":"Ensuite tu emporteras d'ici la moitié de tous mes biens et tu retourneras sans encombres chez ton père. Quand nous serons morts, ma femme et moi, l'autre moitié sera pour vous. Confiance, mon fils! Maintenant je suis ton père, et Edna est ta mère. Désormais nous sommes à tes côtés comme nous sommes avec ta soeur. Confiance, mon fils!'"
}`)
	CurrentBook.AddChapter(9, `{
"1":"Alors Tobie dit à Raphaël:"
,"2":"'Frère Azarias, prends donc quatre serviteurs et deux chameaux et va à Rhagès."
,"3":"Tu iras chez Gabaël, tu lui donneras le reçu et tu prendras l'argent; puis tu le ramèneras avec toi pour les noces."
,"4":"Tu sais que mon père compte les jours et que chaque jour de retard augmente sa peine."
,"5":"Tu vois comment Ragouël a insisté: je suis tenu par son serment.',Raphaël partit donc pour Rhagès en Médie avec les quatre serviteurs et les deux chameaux, et ils se logèrent chez Gabaël. Raphaël lui présenta le reçu. Il lui fit aussi savoir que Tobie fils de Tobit se mariait, et il l'invita aux noces. Gabaël compta les sacs, qui avaient toujours leur sceau; ils les chargèrent sur les chameaux "
,"6":"et partirent ensemble pour la noce. En arrivant chez Ragouël, ils trouvèrent Tobie à table. Il se leva et le salua. Gabaël pleura et le bénit: 'Tu es le fils excellent d'un père bon, juste et généreux. Que le Seigneur te bénisse du haut du ciel, toi et ta femme, ainsi que le père et la mère de ta femme. Que Dieu soit béni! Il vient de me faire voir le vivant portrait de mon cousin Tobit.'"
}`)
	CurrentBook.AddChapter(10, `{
"1":"Pendant ce temps, Tobit comptait les jours. Il calculait le temps qu'il fallait pour aller et revenir, et quand le temps fut passé, sans que son fils soit revenu,"
,"2":"il pensa: 'Pourvu qu'il ne soit pas retenu là-bas. Pourvu que Gabaël ne soit pas mort. Il n'y avait peut-être personne pour lui remettre l'argent.'"
,"3":"Il commença à s'inquiéter."
,"4":"Sa femme Ana disait: 'J'ai perdu mon fils! Il n'est plus au nombre des vivants!' Et elle se mit à pleurer et à se lamenter sur son fils:"
,"5":"'Quel malheur! Pourquoi t'ai-je laissé partir, mon enfant? Tu étais la lumière de mes yeux.'"
,"6":"Tobit lui répondait: 'Calme-toi ma soeur! Ne te mets pas de mauvaises idées en tête! Il est sûrement en bonne santé, mais ils auront été retardés là-bas. Son compagnon est un homme de confiance, c'est un frère. Ne t'inquiète pas ma soeur, il va revenir dmoment à l'autre.'"
,"7":"Mais elle répondait: 'Laisse-moi! Ne me raconte pas d'histoires, mon enfant est mort!' Et tous les jours elle sortait pour regarder sur la route par laquelle son fils était parti; elle n'avait plus confiance en personne. Et lorsque le soleil se couchait, elle rentrait, pleurait et se lamentait toute la nuit sans pouvoir dormir. Au bout des quatorze jours de noces que Ragouël avait juré de faire pour sa fille, Tobie lui dit: 'Laisse-moi partir, mon père et ma mère doivent se demander s'ils me reverront. Je t'en prie, père, laisse-moi rentrer chez mon père; je t'ai dit dans quel état je l'ai laissé.' "
,"8":"Ragouël dit à Tobie: 'Reste encore, mon fils, reste près de moi. J'enverrai des messagers à ton père Tobit pour lui donner de tes nouvelles.'"
,"9":"Mais Tobie insista: 'Non, je te demande de me laisser retourner chez mon père.'"
,"10":"Aussitôt Ragouël lui remit son épouse Sarra, il remit à Tobie la moitié de ses biens en serviteurs et servantes, en boeufs, brebis, ânes et chameaux, en habits, en argent et en objets de toute sorte."
,"11":"Il les laissa partir dans les meilleures conditions, adressant à Tobie ces paroles d'adieu: 'Bonne santé, mon fils, et bon voyage. Que le Seigneur du ciel soit avec toi et avec ta femme Sarra! J'espère bien voir vos enfants avant de mourir!'"
,"12":"Il ajouta pour sa fille: 'Va chez ton beau-père, puisque désormais ils sont tes parents tout comme ceux qui t'ont donné le jour. Va en paix, ma fille. Je suis sûr que je n'entendrai dire que du bien de toi aussi longtemps que je vivrai.' Il leur fit ses adieux et les laissa partir. A son tour, Edna dit à Tobie: 'Fils et frère très cher, que le Seigneur te ramène. Je souhaite voir vos enfants, à toi et à ma fille Sarra, avant de mourir. Devant le Seigneur je te confie ma fille. Ne lui fais pas de peine aussi longtemps qu'elle vivra. Va en paix, mon fils. Désormais je suis ta mère et Sarra est ta soeur. Que notre vie à tous se déroule jusqu'au bout sans malheur.' Elle les embrassa tous les deux et les laissa partir, emportant leur bonheur avec eux."
,"13":"Tobie partit de chez Ragouël content et joyeux. Il bénissait le Seigneur du ciel et de la terre, le roi de l'univers, de la bonne réussite de ce voyage! Il bénit aussi Ragouël et sa femme Edna: 'Seigneur, veille sur eux tous les jours de leur vie!'"
}`)
	CurrentBook.AddChapter(11, `{
"1":"Comme on arrivait à Kasérim, en face de Ninive,"
,"2":"Raphaël dit: 'Tu sais dans quel état nous avons laissé ton père."
,"3":"Prenons de l'avance sur ta femme, allons préparer la maison le temps qu'ils arrivent.'"
,"4":"Ils firent le chemin tous les deux; il lui avait bien recommandé d'emporter le fiel, et le chien les suivait."
,"5":"Ana était assise, elle surveillait la route par laquelle viendrait son fils."
,"6":"Tout à coup elle eut un pressentiment et elle dit au père: 'Voici ton fils qui arrive avec son compagnon!'"
,"7":"Raphaël avait dit à Tobie avant qu'il ne rejoigne son père: 'Je te promets que les yeux de ton père vont s'ouvrir."
,"8":"Tu lui appliqueras sur l'oeil le fiel du poisson. Le remède fera effet et tu lui retireras des yeux comme une petite peau blanche. Alors ton père retrouvera la vue et il verra la lumière.'"
,"9":"La mère alla se jeter au cou de son fils: 'Maintenant, disait-elle, je peux mourir, car je t'ai retrouvé.' Et elle pleura."
,"10":"Tobit se leva, il marchait en trébuchant mais il réussit à franchir la porte de la cour. Tobie courut à sa rencontre;"
,"11":"il avait à la main le fiel du poisson et il lui dit: 'Aie confiance, père!' Puis il lui appliqua le remède et le laissa quelque temps."
,"12":"Ensuite, de chaque main, il lui ôta une petite peau au coin des yeux."
,"13":"Alors son père tomba à son cou,"
,"14":"il pleura et s'écria: 'Je te vois mon fils! Tu es la lumière de mes yeux!' Et il ajouta: 'Béni soit Dieu!,Béni soit son saint Nom!,Bénis soient tous ses saints anges!,Béni soit son grand Nom, pour les siècles des siècles!"
,"15":"Car il m'avait frappé, mais il a eu pitié de moi, et aujourd'hui je vois mon fils Tobie.',Tobie entra dans la maison. Tout joyeux, il bénissait Dieu à haute voix; puis il raconta son voyage à son père: il rapportait l'argent, il avait épousé Sarra fille de Ragouël, qui arrivait derrière lui et déjà n'était plus loin des portes de Ninive."
,"16":"Tobit se rendit aux portes de Ninive à la rencontre de sa belle-fille, et dans sa joie il louait Dieu. Lorsque les habitants de Ninive le virent marcher sans personne pour lui tenir la main, s'avancer d'un pas alerte comme autrefois, ils furent émerveillés."
,"17":"Alors, devant eux, Tobit proclama que Dieu avait eu pitié de lui et lui avait ouvert les yeux. Puis Tobit s'approcha de Sarra, la femme de son fils Tobie, et il la bénit: 'Sois bienvenue, ma fille! Béni soit Dieu qui t'a fait venir chez nous, ma fille! Béni soit ton père, béni soit mon fils Tobie, bénie sois-tu ma fille; sois la bienvenue chez toi, dans la joie et dans la bénédiction. Entre ma fille!' Ce jour-là on fit une fête pour tous les Juifs de Ninive,"
,"18":"et les cousins de Tobie, Ahikar et Nadab, vinrent partager sa joie."
}`)
	CurrentBook.AddChapter(12, `{
"1":"A la fin du repas de noces, Tobit appela son fils Tobie et lui dit: 'Mon fils, il faut régler ce que tu dois à ton compagnon. Tu rajouteras au prix convenu.'"
,"2":"Tobie demanda: 'Père, comment pourrais-je le payer pour ses services? Même en lui donnant la moitié des biens qu'il a rapportés avec moi, cela ne suffirait pas."
,"3":"Il me ramène sain et sauf, il a guéri ma femme, il rapporte avec moi l'argent, enfin il te guérit. Comment parler d'un salaire après tout cela?'"
,"4":"Tobit répondit: 'Ce serait juste qu'il garde la moitié de ce qu'il a rapporté.'"
,"5":"Tobie appela donc son compagnon et lui dit: 'Garde la moitié de ce que tu as rapporté, ce sera le prix de tes services; et puis tu t'en iras en paix.'"
,"6":"Alors Raphaël les prit tous les deux à part et il leur dit: 'Bénissez Dieu! Célébrez-le au milieu de tous les vivants pour ses bienfaits à votre égard! Bénissez et chantez son Nom! Faites connaître à tous les oeuvres de Dieu, comme elles le méritent, et ne cessez pas de le remercier!"
,"7":"Il est bon de garder le secret du roi, mais il est très recommandé de révéler et de publier les merveilles de Dieu. Remerciez-le comme il convient. Faites ce qui est bien et vous ne connaîtrez pas le malheur. "
,"8":"Mieux vaut la prière et le jeûne, l'aumône et la justice, que la richesse avec l'injustice; mieux vaut avoir peu et être juste, qu'avoir beaucoup en étant pécheur."
,"9":"L'aumône libère de la mort, elle purifie de tout péché; ceux qui font l'aumône connaîtront une longue vie,"
,"10":"ceux qui commettent le péché et le mal, attentent à leur vie."
,"11":"Je vais vous dire toute la vérité et je ne vous cacherai rien. Je vous ai déjà dit qu'il est bon de garder le secret du roi et qu'il est très recommandé de révéler les merveilles de Dieu."
,"12":"Sachez-le donc: lorsque vous étiez en prière, toi et Sarra, c'était moi qui présentait votre prière devant la Gloire du Seigneur. Et lorsque toi tu enterrais les morts, j'étais de même avec toi."
,"13":"Plus tard, tu n'as pas hésité à te lever, à quitter la table pour aller enterrer un mort, et c'est alors que j'ai été envoyé pour éprouver ta foi."
,"14":"Et de nouveau Dieu m'a envoyé pour te guérir et pour guérir en même temps ta belle-fille Sarra."
,"15":"Je suis Raphaël, l'un des sept anges serviteurs du Seigneur qui ont en tout temps accès à sa Gloire.'"
,"16":"Alors, tout remplis de crainte ils se prosternèrent."
,"17":"Mais il leur dit: 'N'ayez pas peur. Que la paix soit avec vous, bénissez Dieu à jamais!"
,"18":"Je ne vous ai fait aucune faveur, c'est par la volonté de Dieu que je vous ai accompagnés. C'est donc lui qu'il faut bénir tout au long des jours, c'est lui qu'il faut chanter."
,"19":"Vous avez cru me voir manger, mais ce n'était qu'une apparence."
,"20":"Bénissez donc le Seigneur, vous qui restez sur terre, et rendez grâce à Dieu pendant que je remonte vers celui qui m'a envoyé. Vous mettrez par écrit tout ce qui est arrivé.' Alors Raphaël s'éleva."
,"21":"Quand ils se relevèrent, ils ne le virent plus. Ils louèrent Dieu par des chants, le remerciant d'avoir fait de telles merveilles: oui, un ange de Dieu leur était apparu!"
}`)
	CurrentBook.AddChapter(13, `{
"1":"Tobie dit: Béni soit Dieu qui vit à jamais. Son règne dure de siècles en siècles."
,"2":"Tour à tour il corrige et il pardonne. Il fait descendre au séjour des morts,et il en fait remonter. nul n'échappe à sa main."
,"3":"Célébrez-le, enfants d'Israël, parmi les nations où il vous a dispersés,"
,"4":"et montrez-leur toute sa puissance. Chantez sa grandeur face à tous les vivants, c'est lui notre Seigneur et notre Dieu!,Il est notre père pour les siècles des siècles!"
,"5":"S'il nous corrige pour nos fautes, de nouveau il aura pitié de nous. Il nous rassemblera de toutes les nations,parmi lesquelles il nous avait dispersés."
,"6":"Revenez à lui de tout coeur, et faites pleinement la vérité devant lui; alors il reviendra vers vous, et ne vous cachera plus son visage."
,"7":"Voyez ce qu'il a fait pour vous, et rendez-lui grâces à haute voix. Bénissez le Seigneur qui est juste!,Chantez le Roi des siècles!"
,"8":"Je veux le célébrer sur cette terre d'exil, dire à un peuple pécheur sa force et sa grandeur: Revenez pécheurs, faites le bien devant lui: peut-être il vous regardera avec bonté,et vous fera miséricorde."
,"9":"Je chante Dieu, mon âme est dans la joie pensant au Roi du ciel. Que tous en Jérusalem chantent sa grandeur!"
,"10":"Jérusalem, Cité Sainte, Dieu punira les crimes de tes fils, puis il aura pitié des enfants des justes."
,"11":"Remercie, remercie le Seigneur!,Bénis le Roi des siècles!,Que sa Tente soit relevée chez toi dans la joie!"
,"12":"Qu'il fasse de toi la joie des déportés, et qu'il aime à travers toi tous les malheureux, pour les générations des générations."
,"13":"Une grande lumière illuminera de sa clarté,toutes les régions de la terre. Des peuples nombreux viendront de loin, ils arriveront de tous les coins du monde, les mains chargées de présents pour le Roi du Ciel. Toutes les générations feront de toi leur joie."
,"14":"Maudits soient ceux qui te haïssent, mais bénis soient à jamais ceux qui t'aiment!"
,"15":"Tu connaîtras la joie, le bonheur,quand les fils des justes se rassembleront en toi, afin d'y bénir le Seigneur des justes."
,"16":"Bienheureux ceux qui t'aiment, car ils auront la joie de te voir prospère. Heureux ceux qui pleuraient quand tu étais frappée, car ils auront la joie de contempler ta gloire. Mon âme, bénis le Seigneur, le Grand Roi:"
,"17":"car voici que Jérusalem est rebâtie,avec des saphirs, des émeraudes!,Tous les remparts seront de pierres précieuses, ses tours et ses défenses seront d'or pur, et leurs remparts en or massif. Jérusalem! On marchera dans ses rues,sur un pavage de rubis, de pierres d'Ophir. Jérusalem! Ses portes résonneront,de cantiques d'allégresse!"
,"18":"Dans toutes les ruelles on entendra l'Alléluia, on chantera: Béni soit le Dieu d'Israël!,En toi l'on bénira le saint Nom, pour les siècles des siècles!'"
}`)
	CurrentBook.AddChapter(14, `{
"1":"Tobit mourut en paix à l'âge de cent douze ans et on l'enterra solennellement à Ninive."
,"2":"Il avait déjà soixante-deux ans quand il devint aveugle; après sa guérison il vécut dans l'abondance, faisant des aumônes. Il ne cessait de bénir Dieu et de célébrer sa grandeur."
,"3":"Sur le point de mourir, il fit venir son fils Tobie et lui fit ses recommandations: 'Mon fils, emmène d'ici tes enfants,"
,"4":"qu'ils se mettent à l'abri en Médie parce que je crois à la parole de Dieu que Nahum a prononcée sur Ninive. Elle se réalisera pour l'Assyrie et pour Ninive. Toutes les paroles des prophètes d'Israël se réaliseront, car c'est Dieu qui les a envoyés. Toutes leurs paroles se réaliseront sans aucune exception. En ce temps-là on sera plus à l'abri en Médie qu'en Assyrie ou en Babylonie. Nos frères qui habitent en terre d'Israël seront tous dispersés et déportés loin de leur beau pays. Toute la terre d'Israël sera ravagée; Samarie et Jérusalem seront dévastées et le Temple de Dieu sera pour un temps ruiné et brûlé. "
,"5":"Mais de nouveau Dieu aura pitié, il les ramènera sur la terre d'Israël. Ils rebâtiront son Temple, moins beau que le premier, en attendant la venue de temps nouveaux. Alors, tous les survivants de la captivité reconstruiront Jérusalem dans sa grandeur et le Temple de Dieu sera rebâti comme l'ont annoncé les prophètes d'Israël."
,"6":"Tous les peuples de la terre entière se convertiront et ils craindront Dieu dans la vérité. Tous rejetteront leurs faux dieux qui les ont égarés dans l'erreur."
,"7":"Et avec sincérité, ils béniront le Dieu des siècles. Tous les Israélites qui se verront sauvés en ces jours-là, se souviendront de Dieu de tout leur coeur. Ils reviendront à Jérusalem où ils habiteront sans que nul ne les inquiète, sur la terre d'Abraham: elle leur sera rendue. Ceux qui aiment Dieu sincèrement se réjouiront, mais tous ceux qui font le mal et pratiquent l'injustice, disparaîtront de la Terre."
,"8":"Maintenant, mes enfants, écoutez cet ordre: Servez Dieu avec fidélité et faites ce qui lui est agréable. Demandez à vos enfants de pratiquer la justice et l'aumône, de se souvenir de Dieu et, en tout temps et de toutes leurs forces, de bénir son Nom avec fidélité."
,"9":"Donc, mon fils, quitte Ninive, ne reste pas ici."
,"10":"Le jour même où tu auras enterré ta mère auprès de moi, va-t, en, ne t'attarde pas dans cette région. Je vois qu'ici il y a beaucoup d'injustice, beaucoup de fausseté, et personne n'en a honte. Regarde, mon enfant, tout ce qu'a fait Nadab à Ahikar qui lélevé. Il l'a enfermé vivant dans un souterrain, mais Dieu a convaincu le criminel face à sa victime. Ahikar est revenu à la lumière tandis que Nadab s'enfonçait dans les ténèbres éternelles: n'avait-il pas voulu la mort d'Ahikar? Mais Ahikar faisait des aumônes, c'est pourquoi il a échappé au filet de la mort que lui avait tendu Nadab, et c'est Nadab qui y est tombé pour sa perte."
,"11":"Aussi, mes enfants, voyez où conduit l'aumône et où conduit l'injustice: elle conduit à la mort. Mais voici que le souffle me manque.',On l'étendit sur le lit et il mourut; on l'enterra solennellement."
,"12":"Lorsque mourut la mère de Tobie, celui-ci l'enterra auprès de son père, puis il partit pour la Médie avec sa femme et ses enfants. Il habita à Ekbatane, chez son beau-père Ragouël."
,"13":"Il entoura de respect et d'attention ses beaux-parents déjà vieux, puis il les enterra en Médie, à Ekbatane. Tobie hérita à la fois de Ragouël et de son père Tobit."
,"14":"Il était respecté et vécut jusqu'à cent dix-sept ans."
,"15":"Avant de mourir il eut les échos de la ruine de Ninive, il vit même les habitants de Ninive prisonniers que Cyaxare, roi de Médie, déportait en Médie. Avant sa mort, il put se réjouir du sort de Ninive et bénir le Seigneur Dieu, pour les siècles des siècles. Amen!"
}`)

}
func FR_LBDCC_LoadVMBRChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Voici les paroles de Baruch, fils de Nérias, fils de Maasias, fils de Sédécias, fils d'Asadias, fils d'Helcias. Il les écrivit dans un livre, à Babylone,"
,"2":"la cinquième année, le septième jour du mois, quand les Kaldéens avaient pris et incendié Jérusalem."
,"3":"Baruch lut les paroles de ce livre devant Jékonias, fils de Joiakim, roi de Juda, et devant tout le peuple qui s'était rassemblé pour cette lecture."
,"4":"Il y avait là les nobles et les fils de roi, les anciens et le peuple entier, petits et grands - tous ceux qui habitaient à Babylone, au bord de la rivière Soud."
,"5":"Alors le peuple se mit à pleurer, à jeûner et à supplier le Seigneur."
,"6":"On recueillit de l'argent selon les moyens de chacun,"
,"7":"et on l'envoya à Jérusalem, au prêtre Joaqim, fils d'Helcias, fils de Salom, aux autres prêtres et à tout le peuple resté avec lui à Jérusalem."
,"8":"Ce même Baruch avait entrepris de renvoyer au pays de Juda, au dixième jour du mois de Sivan, les objets sacrés qui avaient été enlevés de la Maison du Seigneur. Ces objets en argent avaient été faits par Sédécias fils de Josias, roi de Juda,"
,"9":"après que Nabukodonozor, roi de Babylone, avait déporté de Jérusalem vers Babylone, Jékonias, les chefs, les serruriers, les notables et le petit peuple."
,"10":"On écrivit donc: Nous vous envoyons ici de l'argent. Avec cet argent, payez des holocaustes, des sacrifices pour le péché et de l'encens. Préparez des offrandes et portez-les sur l'autel du Seigneur notre Dieu."
,"11":"Priez pour la vie de Nabukodonozor, roi de Babylone, et pour la vie de son fils Balthazar; que leurs jours sur la terre soient comme les jours du Ciel."
,"12":"Que le Seigneur nous donne la force et qu'il fasse briller sa lumière à nos yeux; ainsi nous vivrons à l'ombre de Nabukodonozor, roi de Babylone, et à l'ombre de son fils Balthazar, nous les servirons longtemps et nous trouverons grâce à leurs yeux."
,"13":"Priez aussi pour nous le Seigneur notre Dieu, car nous avons péché contre le Seigneur notre Dieu et sa colère ardente ne s'est pas détournée de nous jusqu'à ce jour."
,"14":"Lisez ce livre que nous vous envoyons, faites-en une lecture publique dans le Temple du Seigneur, au jour de la Fête et aux jours d'assemblées."
,"15":"Alors vous direz ceci: Que tous reconnaissent la justice du Seigneur notre Dieu, mais c'est la honte et la confusion qui conviennent en ce jour au peuple de Juda et aux habitants de Jérusalem, "
,"16":"à nos rois, nos chefs, nos prêtres, nos prophètes, tout comme à nos pères,"
,"17":"car nous avons péché contre le Seigneur."
,"18":"Nous lui avons désobéi, nous n'avons pas écouté la voix du Seigneur notre Dieu, nous n'avons pas suivi les commandements que le Seigneur avait placés devant nous."
,"19":"Nous avons désobéi au Seigneur notre Dieu, depuis le jour où le Seigneur a fait sortir nos pères du pays d'Egypte, jusqu'à ce jour. Dans notre folie, nous avons refusé d'écouter sa voix."
,"20":"C'est pourquoi, comme on le voit aujourd'hui, malheurs et malédictions sont tombés sur nous comme le Seigneur l'avait annoncé par son serviteur Moïse, le jour où il a fait sortir nos pères du pays d'Egypte pour nous donner un pays où coulent le lait et le miel."
,"21":"Nous n'avons pas écouté la voix du Seigneur notre Dieu, qui parlait par la bouche des prophètes qu'il nous a envoyés."
,"22":"Chacun de nous a suivi l'inclination de son coeur mauvais, et nous avons servi d'autres dieux, faisant ce qui déplaît au Seigneur notre Dieu."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Le Seigneur a donc réalisé la parole qu'il avait dite contre nous, contre nos juges qui ont jugé Israël, contre nos rois, nos chefs et tous les gens d'Israël et de Juda."
,"2":"Jamais sous le ciel on n'a vu chose semblable à ce qui est arrivé à Jérusalem, cela même qui est écrit dans la Loi de Moïse."
,"3":"Certains parmi nous en sont venus à manger la chair de leur fils ou de leur fille."
,"4":"Le Seigneur les a livrés au pouvoir de tous les royaumes qui nous entourent; ils sont devenus un exemple de malédiction et de ruine pour les peuples d'alentour parmi lesquels il les a dispersés."
,"5":"Nous avons été soumis au lieu de dominer, car nous avions péché contre le Seigneur notre Dieu et nous n'avions pas écouté sa voix."
,"6":"Le Seigneur notre Dieu est juste, mais pour nous et nos pères, c'est la honte du visage qui nous convient en ce jour."
,"7":"Tous ces malheurs dont le Seigneur avait parlé sont tombés sur nous,"
,"8":"et nous n'avons pas renoncé chacun aux pensées mauvaises de notre coeur pour apaiser la colère du Seigneur."
,"9":"C'est pourquoi le Seigneur a prévu ces malheurs et les a fait venir sur nous, car le Seigneur est juste dans tout ce qu'il nous a commandé."
,"10":"Et nous, nous n'avons pas écouté sa voix, nous n'avons pas obéi aux commandements que le Seigneur avait placés devant nous."
,"11":"Seigneur, Dieu d'Israël, tu as fait sortir ton peuple du pays d'Egypte à main forte, avec miracles, prodiges, faisant usage de ta puissance et frappant de grands coups. Tu t'y es rendu célèbre et tu l'es encore,"
,"12":"mais nous, nous avons péché, nous avons commis le mal, nous avons pratiqué l'injustice, Seigneur notre Dieu, oubliant tous tes commandements."
,"13":"Que ta colère se détourne de nous puisque nous ne sommes plus qu'un petit reste au milieu des nations où tu nous as dispersés."
,"14":"Ecoute Seigneur notre prière et notre supplication, délivre-nous pour l'honneur de ton nom, et fais-nous trouver grâce devant ceux qui nous ont déportés."
,"15":"Alors toute la terre saura que tu es le Seigneur notre Dieu, car ton nom a été invoqué sur Israël et sur sa descendance."
,"16":"Regarde Seigneur de ta Demeure sainte, pense à nous, prête l'oreille, écoute-nous."
,"17":"Ouvre les yeux et regarde: ce ne sont pas les morts, couchés dans le monde d'en-bas, qui rendront gloire et justice au Seigneur après que l'esprit a quitté leur corps,"
,"18":"c'est le vivant, Seigneur, lui qui va courbé et sans force, accablé par son fardeau, les yeux affaiblis et le coeur angoissé."
,"19":"Nous ne comptons pas sur les mérites de nos pères et de nos rois lorsque nous faisons monter cette prière vers toi, Seigneur notre Dieu;"
,"20":"car tu as envoyé sur nous ta colère et ta fureur comme tu l'avais annoncé par tes serviteurs les prophètes"
,"21":"en ces termes: 'Ainsi parle le Seigneur: inclinez-vous, servez le roi de Babylone et vous resterez dans le pays que j'ai donné à vos pères."
,"22":"Mais si vous n'écoutez pas la voix du Seigneur votre Dieu, si vous refusez de servir le roi de Babylone,"
,"23":"je ferai cesser dans les villes de Juda et à Jérusalem, le chant de joie et le chant de fête, les chants du fiancé et de la fiancée, et tout le pays sera désert, privé d'habitants.'"
,"24":"Mais nous n'avons pas écouté ton appel à servir le roi de Babylone, et tu as accompli ce que tu avais annoncé par tes serviteurs les prophètes: les ossements de nos rois, les ossements de nos pères ont été enlevés de leurs tombes."
,"25":"Ils ont été jetés sur le sol exposés au soleil comme au froid de la nuit. Nos pères eux-mêmes sont morts dans de cruelles souffrances, par la faim, l'épée et la peste."
,"26":"Tu as fait cette Maison qui porte ton nom ce qu'elle est aujourd'hui, à cause de la méchanceté de la maison d'Israël et de la maison de Juda."
,"27":"Tu nous as traités, Seigneur notre Dieu, avec grande bonté et grande miséricorde,"
,"28":"comme tu l'avais annoncé par le bouche de ton serviteur Moïse, le jour où tu lui as ordonné d'écrire ta Loi en présence des enfants d'Israël."
,"29":"Tu leur avais dit: 'Si vous n'écoutez pas ma voix, cette grande et vaste multitude sera réduite à un tout petit nombre parmi les nations où je les disperserai."
,"30":"Oui, je sais bien qu'ils ne m'écouteront pas, car c'est un peuple à la tête dure, mais dans le pays où ils seront déportés, ils rentreront en eux-mêmes."
,"31":"Alors ils sauront que je suis le Seigneur leur Dieu et je leur donnerai un coeur pour comprendre et des oreilles pour entendre."
,"32":"Dans le pays de leur exil ils me loueront et se souviendront de mon nom."
,"33":"Ils renonceront à leur tête dure et à leurs pensées mauvaises; ils se souviendront du sort de leurs pères qui ont péché devant le Seigneur."
,"34":"Alors je les ramènerai dans le pays que j'ai promis par serment à Abraham, Isaac et Jacob, leurs pères; ils le posséderont, je ferai qu'ils s'y multiplient et ne diminuent plus."
,"35":"Je ferai avec eux une alliance éternelle, je serai leur Dieu et ils seront mon peuple et je ne chasserai plus mon peuple Israël du pays que je leur ai donné.'"
}`)
	CurrentBook.AddChapter(3, `{
"1":"Seigneur tout puissant, Dieu d'Israël, c'est une âme angoissée, un esprit accablé qui crient vers toi."
,"2":"Ecoute Seigneur et prends pitié car nous avons péché contre toi."
,"3":"Tu règnes éternellement alors que nous, nous périssons pour toujours."
,"4":"Seigneur tout puissant, Dieu d'Israël, écoute la prière des morts d'Israël. Nous sommes les enfants de ceux qui ont péché contre toi; ils n'ont pas écouté la voix du Seigneur leur Dieu, et c'est pourquoi tous ces malheurs sont tombés sur nous."
,"5":"Ne te souviens plus des péchés de nos pères mais rappelle-toi ta puissance et pense à ton nom,"
,"6":"car tu es le Seigneur notre Dieu, et c'est toi que nous louerons, Seigneur."
,"7":"Tu as mis dans nos coeurs ta crainte pour que nous invoquions ton nom. De notre lieu d'exil nous te louerons, car nous avons chassé de nos coeurs tout ce qui portait nos pères à pécher contre toi."
,"8":"Tu nous vois aujourd'hui dans le pays de notre exil, où tu nous as dispersés pour y être maudits, insultés, humiliés, à cause des péchés de nos pères qui se sont détournés du Seigneur notre Dieu."
,"9":"Ecoute, Israël, les commandements de vie, prête l'oreille et apprends à te conduire."
,"10":"D'où vient, Israël, que tu es au pays de tes ennemis, et que tu vieillis sur une terre étrangère?"
,"11":"D'où vient que tu te souilles avec les morts, déjà compté entre ceux qui partent chez les morts?"
,"12":"C'est que tu as laissé la source de la sagesse."
,"13":"Si tu avais marché dans la voie de ton Dieu, la paix serait pour toujours ta demeure."
,"14":"Apprends donc où est la sagesse, où est la force, où est l'intelligence; pour que tu saches,où se trouvent longs jours et vie, la paix et les yeux rayonnants."
,"15":"Qui a découvert le lieu de la sagesse, qui pénétrera là où sont ses richesses?"
,"16":"Où sont les chefs des nations,qui dominaient jusqu'aux bêtes de la terre,"
,"17":"qui jouaient avec les oiseaux du ciel?"
,"18":"Ils amassaient l'argent, l'or,en qui les hommes placent leur confiance. Ils ne se lassaient pas d'accumuler l'argent, et ils avaient l'art de l'utiliser: on ne saurait compter leurs oeuvres."
,"19":"Ils ont passé, ils sont descendus chez les morts, et d'autres se sont levés à leur place."
,"20":"Une jeune génération a vu le jour, s'est installée sur la terre, mais qui n'a pas su la voie de la connais sance."
,"21":"Ils n'ont pas vu ses sentiers, ils ne l'ont pas trouvée; leurs fils se sont égarés en chemin."
,"22":"On ne l'a pas connue en Canaan, on ne l'a pas vue dans Téman."
,"23":"Fils d'Agar, avides de sagesse humaine, marchands de Madian et de Téma, conteurs de fables ou philosophes, ils n'ont pas connu le chemin de la sagesse, ils n'ont pu découvrir ses voies."
,"24":"Vois, Israël, comme est grande la Demeure de Dieu, qu'il est vaste son domaine,"
,"25":"étendu et sans limites, élevé au delà de toute mesure!"
,"26":"Là sont nés les fameux géants d'autrefois, d'une taille énorme, exercés à la guerre."
,"27":"Dieu pourtant ne les a pas choisis,pour leur enseigner les voies de la connaissance."
,"28":"Ils sont morts pour n'avoir pas eu le savoir,leur folie a fait leur perte."
,"29":"Qui est monté au ciel afin de la saisir?,L'a-t-il fait descendre des nuages?"
,"30":"Qui l'a trouvée, traversant les mers?,L'a-t-on rapportée à prix d'or?"
,"31":"Personne ne connaît son chemin, nul n'a la moindre idée de ses sentiers."
,"32":"Mais celui qui sait toutes choses la connaît; il l'a trouvée par sa propre intelligence, lui qui forma la terre pour une éternité,et la remplit de bêtes à quatre pattes."
,"33":"Il envoie la lumière et elle part; s'il la rappelle, elle tremble et obéit."
,"34":"Les étoiles se sont mises à briller, joyeuses, et chacune à son poste veille sur la nuit."
,"35":"Il les appelle; elles lui répondent: 'Nous voici!',Quelle joie pour elles de briller pour leur Créateur!"
,"36":"C'est lui qui est notre Dieu, rien ne saurait lui être comparé."
,"37":"Il a trouvé, lui, la voie de la connaissance, et l'a confiée à Jacob, son serviteur, à Israël, son bien-aimé."
,"38":"C'est alors que la Sagesse est apparue sur terre,elle a séjourné parmi les hommes."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Elle est le livre des commandements de Dieu, la Loi qui demeure pour toujours. Quiconque s'y attache, vivra, mais pour ceux qui l'abandonnent c'est la mort."
,"2":"Reviens, Jacob, embrasse cette sagesse, marche à sa lumière jusqu'à la splendeur."
,"3":"Ne cède pas à d'autres ta gloire, ni tes privilèges à une nation étrangère."
,"4":"Heureux sommes-nous Israël: ce qui plaît à Dieu nous a été révélé!"
,"5":"Courage, ô mon peuple, toi qui gardes vivant le souvenir d'Israël."
,"6":"Vous avez été vendus aux nations, mais non pour votre ruine; vous aviez excité la colère de Dieu et c'est pourquoi vous avez été livrés à vos ennemis."
,"7":"Vous aviez irrité celui qui vous a faits, avec vos sacrifices offerts, non à Dieu, mais aux démons."
,"8":"Vous avez oublié le Dieu éternel qui vous a nourris, et vous avez fait la tristesse de Jérusalem qui vous a élevés."
,"9":"Voyant la colère qui de par Dieu venait sur vous, elle a dit: 'Voyez, cités voisines de Sion, quel deuil il a fait tomber sur moi! "
,"10":"J'ai vu l'exil de mes fils et de mes filles: c'est l'Eternel qui l'a voulu pour eux."
,"11":"J'étais joyeuse quand je les nourrissais, et ce furent des larmes de deuil quand je les vis partir."
,"12":"Que nul ne se réjouisse, me voyant veuve, abandonnée de tous. C'est à cause des péchés de mes fils que je suis restée seule: tous s'étaient détournés de la loi de Dieu."
,"13":"Ils ont négligé ses préceptes, ils n'ont pas marché dans la voie de ses commandements, ils n'ont pas suivi la discipline qui mène à la droiture."
,"14":"Venez, voisines de Sion, faites mémoire de l'exil que l'Eternel a voulu pour mes fils et mes filles."
,"15":"Il a fait venir contre eux, de très loin, une nation cruelle au langage barbare, qui n'a pas respecté le vieillard, et n'a eu nulle pitié pour l'enfant;"
,"16":"elle a pris le fils unique de la veuve, elle a emmené sa fille et l'a laissée seule."
,"17":"Comment pourrais-je, moi, vous seco u 'rir?"
,"18":"Mais celui qui a fait venir sur vous ce malheur vous reprendra de la main de vos ennemis."
,"19":"Allez mes fils, allez: je reste seule."
,"20":"J'ai quitté ma robe des jours de fête et j'ai revêtu le sac de la pénitence, car je veux crier vers l'Eternel tous les jours de ma vie."
,"21":"Courage mes fils, criez vers le Seigneur, c'est lui qui vous arrachera à la violence de l'ennemi."
,"22":"J'ai attendu de l'Eternel votre délivrance, et voici que l'Eternel m'a rendu la joie: bientôt se lèvera sur vous la miséricorde de l'Eternel, votre Sauveur."
,"23":"Je vous ai laissé partir dans les larmes et le deuil, mais dans la joie et la fête Dieu vous ramènera à moi pour toujours."
,"24":"Les voisines de Sion ont vu votre captivité, mais bientôt elles vous verront délivrés par Dieu; il vous manifestera la gloire immense et l'éclat du Dieu éternel."
,"25":"Mes enfants, supportez avec patience ce châtiment de Dieu qui est tombé sur vous; votre ennemi vous a persécuté mais bientôt vous verrez sa chute et vous mettrez votre pied sur son cou."
,"26":"Mes enfants bien-aimés ont marché par de rudes chemins; ils allaient comme un troupeau volé par l'ennemi."
,"27":"Courage, mes fils, criez vers le Seigneur: celui qui a fait venir l'épreuve se souviendra de vous."
,"28":"Vous avez voulu vous éloigner de Dieu: avec dix fois plus d'ardeur revenez à lui et cherchez-le."
,"29":"Celui qui vous a envoyé le malheur vous donnera salut et joie éternelle.'"
,"30":"Courage Jérusalem, celui qui t'a donné ton nom te consolera."
,"31":"Malheur à ceux qui t'ont fait du mal et se sont réjouis de ta chute!"
,"32":"Malheur aux villes dans lesquelles tes enfants furent esclaves! Malheur à la nation où ils ont dû vivre!"
,"33":"Elle s'est réjouie de ta chute, elle a pris plaisir à ta ruine! Mais à son tour elle connaîtra la douleur et la ruine."
,"34":"Elle n'aura plus la joie d'être un peuple nombreux, son orgueil fera place au deuil."
,"35":"Un feu venu de l'Eternel la brûlera pour de longs jours, elle sera pour longtemps un refuge de démons."
,"36":"Tourne-toi vers l'orient, Jérusalem, vois: la joie te vient de Dieu."
,"37":"Tes fils dispersés reviennent; de l'orient comme de l'occident ils se rassemblent à l'appel du Saint et jouissent de la gloire de Dieu."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Quitte ta robe de deuil et de tristesse, Jérusalem, revêts-toi pour toujours de la Gloire du Dieu."
,"2":"Drape-toi dans le manteau de droiture qui t'arrive de Dieu, et couronne ta tête de la Gloire de l'Eternel."
,"3":"Il veut révéler ta beauté à tout être vivant sous le ciel,"
,"4":"et pour toujours il te donne ce nom: 'Paix dans la Justice', 'Splendeur dans la crainte de Dieu'."
,"5":"Lève-toi Jérusalem, porte-toi sur les hauteurs et regarde vers l'orient. Vois tes enfants qui se rassemblent du couchant jusqu'au levant à la parole du Saint; ils sont tout à la joie car Dieu s'est souvenu d'eux."
,"6":"Ils t'avaient quittée à pied, enlevés par l'ennemi, Dieu les ramène en carrosses, honorés comme des princes royaux."
,"7":"Car Dieu a décidé de niveler les montagnes hautes, les collines éternelles, de combler les vallées et d'aplanir le sol, pour qu'Israël marche d'un pas sûr, abrité par la gloire de son Dieu."
,"8":"Sur l'ordre de Dieu, les forêts elles-mêmes et tous les arbres odorants prêteront leur ombre à Israël."
,"9":"Oui, Dieu conduira Israël en fête à la lumière de sa gloire, sa miséricorde et sa justice lui feront escorte."
}`)
	CurrentBook.AddChapter(6, `{
"0":"Copie de la lettre que Jérémie envoya à ceux qui allaient être déportés à Babylone, par le roi des Babyloniens. Il leur faisait savoir ce que Dieu lui avait ordonné."
,"1":"A cause des péchés que vous avez commis devant Dieu, vous serez déportés à Babylone par Nabukodonozor, roi des Babyloniens."
,"2":"Une fois arrivés à Babylone, vous y resterez de nombreuses années: le temps de sept générations; mais après cela je vous en ferai revenir sans dommage."
,"3":"Vous verrez à Babylone des dieux d'argent, d'or et de bois qu'on transporte sur les épaules et qui inspirent la terreur aux païens."
,"4":"Prenez garde de ne pas imiter ce que font ces étrangers, ne partagez pas leur crainte"
,"5":"lorsque vous verrez la foule se presser devant et derrière ces idoles pour les adorer. Dites alors vous-mêmes: 'C'est toi, Maître, qu'il faut adorer.'"
,"6":"Mon ange est avec vous, il veillera sur votre vie."
,"7":"Un ouvrier a poli leur langue; ils ont beau être couverts d'or ou d'argent, ce n'est que du toc: ils ne peuvent pas parler."
,"8":"Mais on fait des couronnes d'or pour la tête de ces dieux comme on en ferait pour une fille qui aime se parer."
,"9":"Il arrive que les prêtres volent à leurs dieux cet or et cet argent; ils s'en servent pour eux-mêmes et pour les prostituées qui sont dans leur temple."
,"10":"On habille ces dieux comme si c'étaient des hommes mais ce n'est que de l'argent, de l'or ou du bois. C'est pourquoi ils ne peuvent se défendre de la rouille ni des vers."
,"11":"Quand on les a vêtus de pourpre, on lave leurs visage car ils prennent dans le temple une bonne couche de poussière."
,"12":"Le dieu porte un sceptre, comme un gouverneur de province, mais il ne fera pas mourir celui qui l'a insulté."
,"13":"Un autre a dans sa main droite une épée ou une hache, mais il n'en fera rien, ni à la guerre ni contre les voleurs."
,"14":"Cela prouve bien qu'ils ne sont pas des Dieux; ne les craignez donc pas."
,"15":"Une cruche brisée ne sert plus à personne: leurs dieux qui trônent dans leurs temples sont tout aussi inutiles."
,"16":"Ils ont les yeux remplis de la poussière qu'on soulève en entrant."
,"17":"On ferme soigneusement les portes sur celui qui a offensé le roi ou sur un criminel condamné à mort. C'est tout pareil pour ces dieux: les prêtres défendent leurs temples par des portes, des serrures et des verrous afin qu'ils ne soient pas dépouillés par les voleurs."
,"18":"Ils leur allument des lampes, beaucoup plus de lampes qu'eux-mêmes n'en utilisent, mais le dieu n'en voit pas une seule."
,"19":"Le dieu n'est qu'une poutre de plus parmi les poutres de la Maison, et même on se dit à l'oreille que tout son intérieur est rongé par les termites; les vers sortent du sol pour manger le dieu avec ses vêtements, mais lui ne sent rien."
,"20":"Leur visage noircit car il y a beaucoup de fumée dans le temple."
,"21":"Sur leur corps et sur leur tête se perchent les hiboux, les hirondelles et les autres oiseaux, même les chats y grimpent."
,"22":"Vous voyez donc bien qu'ils ne sont pas des dieux; ne les craignez pas."
,"23":"On les a recouverts d'or pour les faire beaux, mais l'or ne brillera pas si personne ne les nettoie; d'ailleurs ils n'ont rien senti quand on les fondait."
,"24":"On les a sûrement achetés très cher, mais dedans il n'y a pas d'esprit."
,"25":"Comme ils n'ont pas de pieds, on les porte sur les épaules: quelle honte pour eux, et devant tant de monde! Et quelle honte aussi pour leurs adorateurs quand le Dieu tombe à terre: il faut le relever!"
,"26":"On le met sur pieds, il ne bougera pas; on lui donne un choc, il ne se redressera pas: on peut bien leur faire des offrandes comme on ferait pour des morts."
,"27":"Les prêtres ramassent les victimes offertes en sacrifice; ils en vendent une partie et leurs femmes salent le reste, mais elles ne donnent rien au pauvre ou à l'infirme: est-ce que ce sont vraiment des offrandes? Même les femmes qui viennent d'accoucher ou sont en état d'impureté y touchent."
,"28":"Vous voyez donc que ce ne sont pas des Dieux: ne les craignez pas."
,"29":"Comment pourrait-on les appeler des Dieux? Même des femmes présentent les offrandes à ces choses d'argent, d'or et de bois."
,"30":"Dans leur temple, les prêtres sont assis avec des habits déchirés, la tête et la barbe rasée et sans rien sur la tête."
,"31":"Ils poussent des cris épouvantables devant leurs dieux comme certains le font lors d'un repas funéraire."
,"32":"Les prêtres leur retirent leurs vêtements, et puis ils en habillent leurs femmes et leurs enfants."
,"33":"Qu'on les traite bien ou mal, ils sont incapables de rendre la pareille, tout comme ils sont incapables d'établir un roi ou de le renverser."
,"34":"Ce ne sont pas eux qui donnent richesse ou argent. Si on ne tient pas un voeu qu'on a fait, ils ne réclament pas."
,"35":"Ils n'arrachent pas un homme à la mort, ils ne délivrent pas le faible de la main du puissant,"
,"36":"ils ne rendent pas la vue à l'aveugle, ils ne sauvent pas de l'épreuve."
,"37":"Ils n'ont pas compassion de la veuve et n'aident pas l'orphelin."
,"38":"Ces morceaux de bois couverts d'or et d'argent ne valent guère mieux que les roches de la montagne, et ceux qui les adorent se couvrent de ridicule."
,"39":"Comment pourrait-on croire que ce sont des Dieux, et pourquoi les appelle-t-on Dieux?"
,"40":"Les Kaldéens eux-mêmes les déshonorent: ils voient un muet qui ne peut parler, ils le conduisent à Bel et lui demandent de le faire parler! Comme si le Dieu était capable d'entendre!"
,"41":"Des gens qui réfléchissent sont incapables d'abandonner des dieux qui ne savent pas penser!"
,"42":"On voit dans les rues des femmes qui brûlent du son, assises, une corde nouée autour des reins."
,"43":"Lorsque l'une d'elles s'est fait cueillir par un passant et a couché avec lui, au retour elle reproche à sa compagne de n'avoir pas eu cet honneur et de n'avoir pas sa corde brisée."
,"44":"Tout ce qui tourne autour de ces dieux n'est que mensonge, comment donc pourrait-on croire ou affirmer que ce sont des Dieux?"
,"45":"Des artisans et des orfèvres les ont façonnés, et ils ne sont rien d'autre que ce que ces ouvriers ont voulu qu'ils soient."
,"46":"Si ceux qui les ont faits n'ont pas pour longtemps à vivre, comment des choses faites par eux pourraient-elles être des Dieux?"
,"47":"Ils ne laissent à leurs descendants que mensonge et ridicule."
,"48":"Si une guerre survient, ou quelque malheur, les prêtres discutent entre eux pour savoir où se cacher avec leurs dieux."
,"49":"Comment donc ne comprennent-ils pas que si on ne peut se sauver soi-même de la guerre ou du malheur, on n'est pas Dieu."
,"50":"Plus tard on reconnaîtra que ces morceaux de bois doré et argenté, ne sont que mensonges; il deviendra évident pour toutes les nations et pour tous les rois, qu'ils ne sont pas des Dieux mais seulement l'oeuvre des humains, et que Dieu n'agit pas à travers eux."
,"51":"Quelqu'un n'est-il pas encore convaincu que ce ne sont pas des Dieux?"
,"52":"Ils sont incapables d'établir un roi sur un pays ou de donner la pluie aux hommes."
,"53":"Ils ne savent discerner ce qui est juste, sauver celui qui souffre de l'injustice; ils sont aussi inutiles que des corbeaux entre ciel et terre."
,"54":"Si un feu se déclare dans la Maison de ces dieux de bois, doré et argenté, leurs prêtres y échappent par la fuite, mais eux se consument avec les poutres au milieu des flammes."
,"55":"Ils ne résisteront pas à un roi ou à une armée ennemie:"
,"56":"comment donc peut-on supposer ou croire que ce sont des Dieux?"
,"57":"Ces dieux de bois doré et argenté ne peuvent échapper aux voleurs ni aux brigands, ceux-ci sont plus puissants qu'eux; ils arrachent l'or et l'argent et prennent les vêtements qui les couvrent sans qu'eux-mêmes puissent se défendre."
,"58":"Mieux vaut un roi qui montre sa puissance, ou même une cruche qui sert au maître de maison, que n'importe lequel de ces faux-dieux; mieux vaut une porte de maison qui garde les choses de l'intérieur, ou une colonne de bois dans un palais royal, que qui que ce soit de ces faux-dieux."
,"59":"Le soleil, la lune et les étoiles qui brillent à notre service, obéissent à Dieu."
,"60":"De même l'éclair si beau à voir, ou le vent qui souffle sur toute la contrée;"
,"61":"ou encore les nuages: quand Dieu leur ordonne de parcourir toute la terre, ils font ce qu'on leur a commandé; de même le feu envoyé d'en-haut pour consumer montagnes et forêts: il fait ce qui lui est commandé."
,"62":"Mais ces objets de bois ne peuvent pas se comparer, ni pour la beauté, ni pour la puissance."
,"63":"S'ils sont incapables de rendre la justice et de faire du bien aux gens, il ne faut pas croire que ce sont des Dieux, ni même les appeler Dieux."
,"64":"Vous saurez donc que ce ne sont pas des dieux et vous ne les craindrez pas."
,"65":"Ils ne peuvent ni maudire, ni bénir les rois;"
,"66":"ils ne font pas dans le ciel des signes que les nations puisent voir, ils ne brillent pas comme le soleil, ils ne donnent pas de lumière comme la lune."
,"67":"Les bêtes valent mieux qu'eux, car elles peuvent s'enfuir et sauver leur vie."
,"68":"Ainsi donc, de quelque manière que ce soit, il est évident pour nous que ce ne sont pas des Dieux: vous ne les craindrez pas."
,"69":"Ces dieux de bois doré ou argenté ne protègent pas plus qu'un épouvantail dans un champ de concombres."
,"70":"On ne peut les comparer qu'à un buisson d'épines dans un jardin où tous les oiseaux se posent, ou à un mort jeté dans un lieu obscur."
,"71":"Il vous suffit de voir pourrir sur eux la pourpre ou l'écarlate pour comprendre que ce ne sont pas des Dieux; eux-mêmes finissent par être dévorés et le ridicule retombe sur leur pays."
,"72":"Mieux vaut en définitive l'homme droit qui n'a pas d'idole: nul ne lui prendra son honneur."
}`)

}
func FR_LBDCC_LoadVMDNChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"En l'an trois du règne de Joïaqim, roi de Juda, Nabukodonozor, roi de Babylone, s'en vint à Jérusalem et y mit le siège."
,"2":"Le Seigneur livra entre ses mains Joïaqim, roi de Juda et une partie des objets du Temple de Dieu; il les emmena au pays de Chinéar et déposa ces objets dans le trésor de ses dieux."
,"3":"Le roi demanda à Achpénaz, chef des eunuques, de choisir parmi les Israélites quelques enfants de race royale ou de grande famille."
,"4":"Ces jeunes gens devaient être sans défaut, ils devaient avoir une bonne présentation, posséder un bon jugement, être instruits et bien éduqués, en un mot: être capables de tenir leur rang dans le palais du roi et d'y apprendre l'écriture et la langue des Kaldéens."
,"5":"Le roi leur attribuait chaque jour une part sur les plats qu'il mangeait et le vin qu'il buvait; ils devaient être ainsi élevés pendant trois ans, après quoi ils se tiendraient en présence du roi."
,"6":"Parmi eux se trouvaient de jeunes Judéens: Daniel, Ananias, Misaël et Azaryas."
,"7":"Le chef des eunuques leur imposa un nouveau nom: Daniel s'appellerait Baltassar; Ananias, Chadrak; Misaël, Mechak; et Azaryas, Abed-Négo."
,"8":"Daniel décida en lui-même de ne pas se souiller en mangeant les plats du roi ou en buvant son vin. Il demanda donc au chef des eunuques de ne pas l'obliger à manger cette nourriture impure."
,"9":"Dieu accorda à Daniel de s'attirer la sympathie du chef des eunuques."
,"10":"Mais le chef des eunuques dit à Daniel: 'Je crains mon seigneur le roi. C'est lui qui a fixé votre nourriture et votre boisson: s'il vous voit plus maigres que les jeunes gens de votre âge, il m'en rendra responsable.'"
,"11":"Alors Daniel dit au garde que le chef des eunuques avait choisi pour veiller sur Daniel, Ananias, Misaël et Azaryas:"
,"12":"'Je t'en prie, mets-nous à l'épreuve pendant dix jours, donne-nous seulement des légumes à manger et de l'eau à boire."
,"13":"Tu compareras notre mine et celles des garçons qui mangent les plats du roi, et tu agiras avec tes serviteurs selon ce que tu auras vu.'"
,"14":"Il les écouta et les mit à l'épreuve pendant dix jours."
,"15":"Or, au bout des dix jours, on voyait bien qu'ils avaient meilleure mine que tous les garçons qui mangeaient la nourriture du roi."
,"16":"Dès lors le garde enlevait les plats et le vin qu'ils devaient boire et ne leur donnait que des légumes."
,"17":"Dieu accorda à ces quatre jeunes la sagesse et l'intelligence, aussi bien en littérature qu'en philosophie; Daniel était habile pour expliquer les visions et les songes."
,"18":"Au bout du temps fixé par le roi, le chef des eunuques les conduisit devant Nabukodonozor."
,"19":"Le roi leur parla et, parmi eux tous, il n'en trouva pas un comme Daniel, Ananias, Misaël et Azaryas. Ils restèrent donc au service du roi"
,"20":"et, quel que soit le sujet de philosophie ou de réflexion sur lequel le roi les interrogeait, il les trouvait dix fois supérieurs à tous les magiciens et devins de son royaume."
,"21":"Daniel resta là jusqu'à la première année du roi Cyrus."
}`)
	CurrentBook.AddChapter(2, `{
"1":"En la deuxième année de son règne, Nabukodonozor eut un songe qui le troubla au point d'en perdre le sommeil."
,"2":"Le roi donna l'ordre de convoquer les magiciens, les devins, les sorciers et les astrologues pour lui expliquer le songe qu'il avait eu; ils arrivèrent et se tinrent devant le roi."
,"3":"Le roi leur dit: 'J'ai fait un songe et je n'aurai pas l'esprit en repos tant que je ne saurai pas ce que signifie ce songe.'"
,"4":"Les astrologues dirent au roi: 'Vive le roi à jamais! Raconte à tes serviteurs le songe et nous te donnerons l'interprétation.'"
,"5":"Mais le roi répondit aux astrologues: 'Voici ce que j'ai décidé: si vous ne me faites pas connaître le songe et son explication, vous serez mis en pièces et vos maisons seront ruinées."
,"6":"Mais si vous me faites connaître le songe et son explication, vous recevrez de moi des dons, des cadeaux et de grands honneurs. Donc racontez-moi le songe et vous en donnerez l'interprétation.'"
,"7":"Ils prirent de nouveau la parole et dirent: 'Le roi doit raconter le songe à ses serviteurs, ensuite nous l'expliquerons.'"
,"8":"Mais le roi leur dit: 'Je le vois bien, vous cherchez à gagner du temps, parce que vous savez que ma décision est prise."
,"9":"Si vous ne me faites pas connaître le songe, vous serez tous exécutés. Autrement, vous vous mettez d'accord pour me dire des choses inventées et tordues alors que le temps passe; racontez-moi donc le songe et je saurai que vous êtes capables de l'interpréter.'"
,"10":"Les astrologues répondirent au roi: 'Il n'y a personne sur la terre qui puisse faire ce que le roi demande. Aucun roi, si grand et si puissant fût-il, n'a demandé une chose pareille à l'un de ses magiciens, devins ou astrologues."
,"11":"La chose que le roi demande est trop difficile, seuls les dieux pourraient répondre à la demande du roi, mais ils n'habitent pas chez les hommes.'"
,"12":"Alors le roi entra dans une telle co lère, dans une telle fureur, qu'il ordonna d'exécuter tous les sages de Babylone."
,"13":"On afficha l'ordre d'exécuter les sages et l'on chercha aussi Daniel et ses compagnons pour les mettre à mort."
,"14":"Alors Daniel parla avec sagesse et astuce à Aryok, le chef des bourreaux du roi qui était parti pour exécuter les sages de Babylone."
,"15":"Il dit à Aryok, le chef des bourreaux: 'Pourquoi le roi a-t-il donné cet ordre de façon si urgente?' Aryok expliqua à Daniel ce qui se passait."
,"16":"Daniel alla dire au roi: 'Accorde-moi un délai et je te donnerai l'explication du songe.'"
,"17":"Daniel rentra chez lui et fit connaître la chose à ses compagnons Ananias, Misaël et Azaryas."
,"18":"Il leur demanda de supplier la miséricorde du Dieu du ciel pour qu'il leur éclaire ce mystère: autrement on ferait mourir Daniel et ses compagnons avec le reste des sages de Babylone."
,"19":"Et voilà que le mystère fut révélé à Daniel au cours d'une vision pendant la nuit. Daniel bénit le Dieu du Ciel,"
,"20":"il dit: 'Béni soit Dieu pour les siècles des siècles!,à lui appartiennent la sagesse et la force."
,"21":"Il est le maître des temps et des moments, il renverse les rois comme il les établit, il donne la sagesse aux sages, l'intelligence à ceux qui décident."
,"22":"Il révèle les mystères et les secrets, il connaît ce qui est caché dans les ténèbres; là où il est, tout est lumière."
,"23":"Dieu de mes pères, je te loue et je te glorifie, car tu m'as donné la sagesse et la force et tu viens de me faire connaître ce que nous t'avons demandé: tu nous as révélé le secret du roi.'"
,"24":"Alors Daniel entra chez Aryok que le roi avait chargé d'exécuter les sages de Babylone. Il lui dit: 'Ne fais pas périr les sages de Babylone, mais conduis-moi chez le roi et je donnerai au roi l'explication.'"
,"25":"Aryok conduisit Daniel en toute hâte chez le roi et il lui dit: 'Parmi les déportés de Juda j'ai trouvé un homme qui donnera au roi la signification du songe.'"
,"26":"Le roi prit la parole et dit à Daniel, dont le nom était Baltassar: 'Es-tu capable de me faire connaître le songe que j'ai eu et de m'en donner l'interprétation?'"
,"27":"Daniel prit la parole en présence du roi et dit: 'Ni les sages, ni les devins, ni les magiciens ou les astrologues n'ont pu faire connaître au roi le mystère sur lequel il les interroge,"
,"28":"car c'est Dieu, dans le ciel, qui a révélé des mystères. Il a fait connaître au roi Nabukodonozor ce qui doit arriver dans la suite des jours. Ton songe et les visions que tu as eues dans ton lit, les voici:"
,"29":"Les pensées qui te sont venues à l'esprit pendant la nuit concernent l'avenir, Celui qui révèle les mystères t'a fait connaître ce qui arrivera."
,"30":"Si ce mystère m'a été révélé, ce n'est pas que j'aie en moi une sagesse supérieure à celle des autres hommes, c'est pour que tu entendes ce mystère et que tu en connaisses l'explication."
,"31":"Tu as vu une statue très grande et d'un éclat extraordinaire; elle était là dressée devant toi et son aspect était redoutable."
,"32":"Cette statue avait une tête d'or fin, la poitrine et les bras étaient d'argent, le ventre et les cuisses de bronze,"
,"33":"les jambes de fer, et les pieds de fer mélangé d'argile."
,"34":"Tu regardais, et voici qu'une pierre se détacha sans que personne ne l'ait touchée; elle frappa la statue au niveau des pieds de fer et d'argile et les brisa."
,"35":"Alors le fer, l'argile, le bronze, l'argent et l'or furent brisés du même coup, le vent les emporta sans laisser de trace, comme il emporte la balle du blé sur les aires à battre pendant l'été. Mais la pierre qui avait frappé la statue devint une grande montagne et remplit toute la terre."
,"36":"Voilà donc le songe: maintenant nous donnerons au roi son explication."
,"37":"Tu es le roi des rois, le Dieu du Ciel t'a donné la royauté, la puissance, la force et la gloire."
,"38":"Il a remis entre tes mains les hommes, les bêtes des champs et les oiseaux du ciel, il a fait de toi leur maître partout où ils habitent. La tête d'or, c'est toi."
,"39":"Après toi se lèvera un autre royaume inférieur au tien, puis un troisième royaume qui sera de bronze et dominera toute la terre."
,"40":"Ensuite viendra un quatrième royaume, fort comme le fer. De même que le fer brise et réduit tout en poussière, il brisera et réduira tout."
,"41":"Comme tu l'as vu, les pieds et les orteils sont mélangés de fer et d'argile de potier; ce royaume sera un royaume divisé. Il y aura en lui la solidité du fer: tu as vu le fer mélangé à l'argile boueuse."
,"42":"Mais les orteils des pieds sont moitié fer, moitié argile; le royaume sera fort en partie seulement, il sera aussi fragile."
,"43":"De même que tu as vu le fer mélangé à l'argile boueuse, ils se mêleront par une semence d'hommes mais ils ne seront pas unis l'un à l'autre, tout comme le fer ne peut s'unir avec l'argile."
,"44":"Au temps de ces rois, le Dieu du Ciel suscitera un royaume qui ne sera jamais détruit; sa puissance ne passera pas à un autre peuple. Il brisera et détruira tous les royaumes et les remplacera pour toujours."
,"45":"Tu as vu qu'une pierre s'est détachée de la montagne sans qu'aucune main l'ait touchée, qu'elle a broyé le fer, le bronze, l'argile, l'argent et l'or: c'est cela même qui arrivera. Le Grand Dieu vient de faire connaître au roi ce qui arrivera un jour; puisque c'est bien là le songe, l'interprétation est exacte.'"
,"46":"En entendant cela, le roi Nabukodonozor tomba la face contre terre et se prosterna devant Daniel, puis il donna l'ordre de lui présenter des offrandes et des parfums d'agréable odeur."
,"47":"Le roi s'adressa à Daniel, il lui dit: 'En vérité, votre Dieu est le Dieu des Dieux, le Seigneur des Rois; c'est bien lui qui fait connaître les mystères, puisque tu as pu nous les révéler."
,"48":"Le roi éleva Daniel et lui donna de nombreux et riches cadeaux; il en fit le gouverneur de la province de Babylone et le grand chef de tous les sages de Babylone."
,"49":"Aussitôt Daniel demanda au roi de mettre à la tête de l'administration de la province de Babylone, Chadrak, Méchak et Abed-Négo; Daniel restait à la disposition du roi."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Le roi Nabukodonozor fit une statue d'or d'une hauteur de soixante coudées et d'une largeur de six; il la fit dresser dans la plaine de Doura, dans la province de Babylone."
,"2":"Le roi Nabukodonozor appela les fonctionnaires, les préfets, les gouverneurs, les conseillers, les trésoriers, les procureurs, les juges et tous les chefs des provinces, pour qu'ils se rassemblent et assistent à l'inauguration de la statue."
,"3":"Ainsi donc les fonctionnaires, les préfets, les gouverneurs, les conseillers, les trésoriers, les procureurs, les juges et tous les chefs des province se réunirent pour l'inauguration de la statue que le roi Nabukodonozor avait fait dresser. Ils étaient debout devant la statue dressée par Nabukodonozor."
,"4":"Un messager cria d'une voix forte: 'Hommes de toutes races, nations et langues, écoutez!"
,"5":"Lorsque vous entendrez le son de la trompette, du cor, de la cithare, de la flûte, du trombone, de la cornemuse et de toutes sortes d'instruments, vous tomberez la face contre terre et vous adorerez la statue d'or qu'a dressée le roi Nabukodonozor."
,"6":"Celui qui ne tombera pas la face contre terre et n'adorera pas, sera jeté à l'instant même dans une fournaise de feu ardent.'"
,"7":"En conséquence, lorsque tous les peuples entendirent le son de la trompette, du cor, de la cithare, de la flûte, du trombone, de la cornemuse et de toutes sortes d'instruments, les hommes de tout peuple, nation et langue tombèrent la face contre terre et adorèrent la statue d'or qu'avait dressée le roi Nabukodonozor."
,"8":"A ce moment des hommes de Kaldée s'approchèrent pour accuser les Juifs."
,"9":"Ils prirent la parole et dirent au roi Nabukodonozor: 'Vive le roi à jamais!"
,"10":"O roi, tu as bien donné cet ordre: Tout homme qui entendra le son de la trompette, du cor, de la cithare, de la flûte, du trombone, de la cornemuse et de toutes sortes d'instruments, devra tomber la face contre terre et adorer la statue d'or."
,"11":"Et tu as dit que celui qui ne tomberait pas la face contre terre et n'adorerait pas, serait jeté dans une fournaise de feu ardent."
,"12":"Or, il y a des Juifs, Chadrak, Méchak et Abed-Négo, des hommes que tu as mis à la tête de l'administration de la province de Babylone, qui n'ont pas tenu compte de l'ordre du roi. Ils ne servent pas tes dieux et n'adorent pas la statue d'or que tu as dressée.'"
,"13":"Rouge de colère, Nabukodonozor demanda de lui amener Chadrak, Méchak et Abed-Négo; on amena ces hommes devant le roi."
,"14":"Nabukodonozor prit la parole et leur dit: 'Chadrak, Méchak et Abed-Négo, est-il vrai que vous n'honorez pas mes dieux et que vous n'adorez pas la statue d'or que j'ai dressée?"
,"15":"Maintenant, si vous êtes prêts à tomber la face contre terre lorsque vous entendrez le son de la trompette, du cor, de la cithare, de la flûte, du trombone, de la cornemuse et de toutes sortes d'instruments, si alors vous adorez la statue d'or que j'ai faite, c'est bien. Mais si vous n'adorez pas, vous serez à l'instant même jetés dans une fournaise de feu ardent. Quel est le dieu qui vous sauvera de ma main?'"
,"16":"Chadrak, Méchak et Abed-Négo répondirent au roi Nabukodonozor: 'Nous n'avons pas besoin de te donner une réponse à ce sujet."
,"17":"Si notre Dieu, celui que nous servons, veut nous sauver de la fournaise de feu ardent et de ta main, il nous sauvera."
,"18":"Mais s'il ne le fait pas, sache bien que nous ne servirons pas tes dieux et nous n'adorerons pas la statue d'or que tu as dressée.'"
,"19":"Fou de colère, Nabukodonozor changea d'attitude envers Chadrak, Méchak et Abed-Négo; il donna l'ordre de chauffer la fournaise sept fois plus qu'il n'était nécessaire."
,"20":"Puis il donna l'ordre aux hommes les plus forts de son armée de lier Chadrak, Méchak et Abed-Négo pour les jeter dans la fournaise de feu ardent."
,"21":"On lia donc ces hommes avec leurs manteaux, leurs tuniques, leurs turbans et tous leurs vêtements, pour les jeter dans la fournaise de feu ardent."
,"22":"Comme l'ordre du roi était sans discussion, on avait chauffé au maximum la fournaise; aussi les hommes qui avaient amené Chadrak, Méchak et Abed-Négo furent-ils tués par les flammes du feu."
,"23":"Ces trois hommes, Chadrak, Méchak et Abed-Négo, tombèrent donc tout liés dans la fournaise de feu ardent."
,"24":"Or voilà qu'ils marchaient au milieu des flammes, louant Dieu et bénissant le Seigneur!"
,"25":"Debout au milieu du feu, Azaryas ouvrit la bouche et pria ainsi:"
,"26":"'Béni sois-tu, Seigneur, Dieu de nos pères, que ton Nom soit loué et glorifié éternellement!"
,"27":"Car tu es juste dans tout ce que tu fais, toutes tes voies sont droites, tes oeuvres sont vérité,et tous tes jugements sans reproche."
,"28":"Tu as prononcé une sentence juste dans tout ce que tu as fait venir sur nous et sur Jérusalem, la ville sainte de nos pères. Oui, tu nous as traités avec loyauté et justice lorsque tu as fait venir tout cela à cause de nos péchés."
,"29":"Car nous avons péché et nous avons commis l'injustice, nous nous sommes éloignés de toi; en tout cela nous avons péché gravement, nous n'avons pas obéi à tes commandements."
,"30":"Nous ne les avons pas observés, nous n'avons pas fait ce que tu nous commandais pour que ta bénédiction vienne sur nous."
,"31":"Oui, dans tout ce que tu as fait venir sur nous, dans tout ce que tu as fait, tu as agi selon une juste décision."
,"32":"Tu nous as livrés aux mains d'ennemis païens, les plus détestables des infidèles, tu nous as livrés à un roi injuste, le plus mauvais de toute la terre."
,"33":"Aujourd'hui nous n'osons plus ouvrir la bouche devant toi, tes serviteurs et ceux qui t'adorent sont couverts de honte et de confusion."
,"34":"A cause de ton nom ne nous abandonne pas pour toujours, n'oublie pas ton alliance."
,"35":"En souvenir d'Abraham ton ami, d'Isaac ton serviteur et d'Israël ton saint, ne nous re tire pas ta miséricorde,"
,"36":"toi qui leur as promis de multiplier leur descendance comme les étoiles du ciel et comme le sable qui est sur le rivage de la mer."
,"37":"Oui, Maître, parmi toutes les nations nous sommes les plus petits, et nous sommes humiliés aujourd'hui devant toute la terre à cause de nos péchés."
,"38":"Nous n'avons plus en ce temps-ci, ni prince, ni prophète, ni chef, ni holocauste, ni sacrifice, ni offrande, ni encens, pas même un lieu pour te les présenter et trouver grâce."
,"39":"Accueille cependant notre coeur brisé et notre esprit humilié comme des holocaustes de béliers et de taureaux, comme des sacrifices de milliers d'agneaux gras."
,"40":"Qu'il en soit ainsi aujourd'hui de notre sacrifice devant toi, donne-nous de te suivre fidèlement, car ceux qui mettent en toi leur confiance ne seront pas déçus."
,"41":"Maintenant nous te suivons de tout notre coeur, nous te craignons et nous recherchons ton visage. Ne nous couvre plus de honte,"
,"42":"mais traite-nous selon ta bienveillance et selon ta grande miséricorde."
,"43":"Dans ta puissance délivre-nous et fais-nous voir la gloire de ton Nom, Seigneur."
,"44":"Que tous ceux qui maltraitent tes serviteurs soient confondus et couverts de honte, qu'ils soient privés de toute puissance et de toute autorité et que leurs forces soient brisées."
,"45":"Qu'ils reconnaissent que c'est toi le Seigneur, le seul Dieu, glorieux sur toute la terre.'"
,"46":"Cependant les serviteurs du roi qui les avaient jetés dans la fournaise ne cessaient de la chauffer avec du goudron, de la poix, de l'huile et du bois."
,"47":"La flamme s'éleva de quarante neuf coudées au-dessus de la fournaise,"
,"48":"elle brûla même ceux des Kaldéens qu'elle trouva près de la fournaise."
,"49":"Mais l'ange du Seigneur était descendu dans la fournaise avec Azaryas et ses compagnons et il écartait de la fournaise la flamme de feu."
,"50":"Il fit souffler comme un souffle frais dans la fournaise, si bien que le feu ne les touchait pas et ne leur causait ni gêne ni souffrance."
,"51":"Alors tous les trois, d'un seul coeur, se mirent à chanter, à glorifier et à bénir Dieu du fond de la fournaise. Ils disaient:"
,"52":"'Béni sois-tu Seigneur, Dieu de nos pères, loué et exalté éternellement!,Béni soit ton nom saint et glorieux, chanté et exalté éternellement!"
,"53":"Béni sois-tu dans le Temple de ta sainte gloire, chanté et loué éternellement!"
,"54":"Béni sois-tu sur le trône de ton règne, chanté et glorifié éternellement!"
,"55":"Béni sois-tu, toi qui sondes les abîmes et qui sièges sur les Chérubins, loué et chanté éternellement!"
,"56":"Béni sois-tu à la voûte du ciel, chanté et glorifié éternellement!"
,"57":"Vous toutes, les oeuvres du Seigneur, bénissez le Seigneur, chantez-le et glorifiez-le éternellement!"
,"58":"Anges du ciel bénissez le Seigneur, chantez-le et glorifiez-le éternellement!"
,"59":"Que les cieux bénissent le Seigneur, qu'ils le chantent et le glorifient éternellement!"
,"60":"Vous toutes les eaux du ciel, bénissez le Seigneur, chantez-le et glorifiez-le éternellement!"
,"61":"Vous toutes les puissances du Seigneur, bénissez le Seigneur, chantez-le et glorifiez-le éternellement!"
,"62":"Soleil et lune bénissez le Seigneur, chantez-le et glorifiez-le éternellement!"
,"63":"Etoiles du ciel bénissez le Seigneur, chantez-le et glorifiez-le éternellement!"
,"64":"Pluies et rosées bénissez le Seigneur, chantez-le et glorifiez-le éternellement!"
,"65":"Que tous les vents bénissent le Seigneur, qu'ils le chantent et le glorifient éternellement!"
,"66":"Feux et chaleurs bénissez le Seigneur, chantez-le et glorifiez-le éternellement!"
,"67":"Froidure et ardeur bénissez le Seigneur, chantez-le et glorifiez-le éternellement!"
,"68":"Rosées et giboulées bénissez le Seigneur, chantez-le et glorifiez-le éternellement!"
,"69":"Gel et froidure bénissez le Seigneur, chantez-le et glorifiez-le éternellement!"
,"70":"Glaces et neiges bénissez le Seigneur, chantez-le et glorifiez-le éternellement!"
,"71":"Nuits et jours bénissez le Seigneur, chantez-le et glorifiez-le éternellement!"
,"72":"Lumières et ténèbres bénissez le Seigneur, chantez-le et glorifiez-le éternellement!"
,"73":"Eclairs et nuées bénissez le Seigneur, chantez-le et glorifiez-le éternellement!"
,"74":"Que la terre bénisse le Seigneur, qu'elle le chante et le glorifie éternellement!"
,"75":"Montagnes et collines bénissez le Seigneur, chantez-le et glorifiez-le éternellement!"
,"76":"Que toutes les semences qui germent sur la terre bénissent le Seigneur, qu'elles le chantent et le glorifient éternellement!"
,"77":"Que les sources bénissent le Seigneur, qu'elles le chantent et le glorifient éternellement!"
,"78":"Mers et rivières, bénissez le Seigneur, chantez-le et glorifiez-le éternellement!"
,"79":"Que les monstres marins et tout ce qui s'agite dans les eaux bénissent le Seigneur, qu'ils le chantent et le glorifient éternellement!"
,"80":"Que tous les oiseaux du ciel bénissent le Seigneur, qu'ils le chantent et le glorifient éternellement!"
,"81":"Que toutes les bêtes et tous les animaux bénissent le Seigneur, qu'ils le chantent et le glorifient éternellement!"
,"82":"Vous tous enfants des hommes, bénissez le Seigneur, chantez-le et glorifiez-le éternellement!"
,"83":"Israël, bénis le Seigneur, chante-le et glorifie-le éternellement!"
,"84":"Que les prêtres bénissent le Seigneur, qu'ils le chantent et le glorifient éternellement!"
,"85":"Vous tous, serviteurs du Seigneur, bénissez le Seigneur, chantez-le et glorifiez-le éternellement!"
,"86":"Que les esprits et les âmes des justes bénissent le Seigneur, qu'ils le chantent et le glorifient éternellement!"
,"87":"Que tous les saints et les humbles de coeur bénissent le Seigneur, qu'ils le chantent et le glorifient éternellement!"
,"88":"Ananias, Azaryas et Misaël, bénissez le Seigneur, chantez-le et glorifiez-le éternellement!,Car Il nous a délivrés de l'enfer et nous a sauvés de la mort; il nous a arrachés à la fournaise de feu et nous a tirés du milieu des flammes."
,"89":"Rendez grâce au seigneur car il est bon, car son amour est éternel."
,"90":"Vous tous qui craignez le Seigneur, bénissez-le, bénissez le Dieu des Dieux, chantez-le et rendez-lui grâce car son amour est éternel."
,"91":"Le roi Nabukodonozor était bouleversé, il se leva en hâte et demanda à ses conseillers: 'N'avons-nous pas jeté ces trois hommes liés dans le feu?' Ils répondirent: 'Certainement.'"
,"92":"Le roi ajouta: 'Eh bien moi, je vois quatre hommes qui marchent en toute liberté au milieu du feu et qui n'en souffrent pas; le quatrième ressemble à un fils des dieux.'"
,"93":"Nabukodonozor s'approcha de l'ouverture de la fournaise de feu et il appela: 'Chadrak, Méchak et Abed-Négo, serviteurs du Dieu Très Haut, sortez et venez ici.' Alors Chadrak, Méchak et Abed-Négo sortirent du milieu du feu."
,"94":"Les fonctionnaires, les préfets, les gouverneurs et les conseillers du roi s'assemblèrent pour voir ces hommes. Le feu ne leur avait rien fait: ni leur corps, ni leurs cheveux n'avaient été brûlés, leurs vêtements n'avaient pas été touchés et nulle odeur de feu ne s'attachait à leur personne."
,"95":"Nabukodonozor dit alors: 'Béni soit le Dieu de Chadrak, Méchak et Abed-Négo qui a envoyé son ange pour délivrer ses serviteurs; ils se sont confiés en lui, ils ont désobéi à l'ordre du roi et ont livré leur corps au feu plutôt que de servir ou d'adorer tout autre dieu que leur Dieu."
,"96":"Voici donc ce que j'ordonne à tous les peuples, nations et langues: Tous ceux d'entre vous qui parleront sans respect du Dieu de Chadrak, Méchak et Abed-Négo seront mis en pièces et leurs maisons seront détruites car il n'y a pas d'autre Dieu capable de sauver de la sorte.'"
,"97":"Alors le roi donna une place encore plus importante dans la province de Babylone à Chadrak, Méchak et Abed-Négo."
,"98":"Le roi Nabukodonozor, à tous les peuples, nations et langues qui habitent sur toute la terre. Que l'abondance et la paix soient sur vous."
,"99":"Il m'a paru bon de faire connaître les signes et merveilles que le Dieu Très-Haut a fait pour moi."
,"100":"Que ses prodiges sont grands, que ses miracles sont puissants!,Son règne est un règne éternel, son empire s'étend de génération en génération."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Moi, Nabukodonozor, j'étais tranquille dans ma maison et je vivais heureux dans mon palais,"
,"2":"lorsque j'ai fait un songe qui m'a effrayé; les pensées et les visions que j'ai eues durant la nuit m'ont épouvanté."
,"3":"J'ai alors donné l'ordre de faire venir près de moi tous les sages de Babylone pour qu'ils me fassent connaître la signification du songe."
,"4":"Les magiciens, les devins, les sorciers et les astrologues sont arrivés et je leur ai raconté le songe, mais ils ne m'en ont pas donné l'interprétation."
,"5":"Pour finir s'est présenté Daniel (nommé Baltassar selon le nom de mon Dieu), qui a en lui l'esprit des dieux saints. Je lui ai donc raconté le songe et je lui ai dit:"
,"6":"'Baltassar, chef des magiciens, je sais que l'esprit des dieux saints est en toi et qu'il n'y a pas de mystère pour toi. Voici donc le songe que j'ai eu, explique-le moi."
,"7":"J'étais sur mon lit et j'ai eu cette vision: il y avait un arbre au centre de la terre, il était de très haute taille."
,"8":"L'arbre grandit et devint si important que son sommet touchait le ciel; on l'apercevait depuis les extrémités de la terre."
,"9":"Son feuillage était beau et ses fruits abondants. Il donnait à tous leur nourriture, les bêtes des champs s'abritaient à son ombre, les oiseaux du ciel nichaient dans ses branches; il donnait à tout être vivant sa nourriture."
,"10":"Je contemplais cette vision dans mon lit quand un ange, un saint, descendit du ciel."
,"11":"Il se mit à crier d'une voix forte: Abattez l'arbre et coupez ses branches, arrachez ses feuilles et faites tomber ses fruits. Que les bêtes sauvages fuient son ombre, et les oiseaux du ciel, ses branches."
,"12":"Mais laissez en terre dans l'herbe des champs sa souche et ses racines liées de chaînes de fer et de bronze. Qu'il soit trempé de la rosée du ciel et qu'il partage l'herbe de la terre avec les bêtes sauvages."
,"13":"Que son coeur d'homme lui soit enlevé et qu'on lui donne un coeur de bête, que sept ans passent sur lui!"
,"14":"Tel est le jugement prononcé par les anges, telle est la décision des saints; ainsi tout être vivant saura que le Très-Haut est maître des royautés humaines. Il élève s'il le veut le plus humble des hommes."
,"15":"Voilà le songe que j'ai eu, moi le roi Nabukodonozor; à toi Baltassar de me l'expliquer, car tous les sages de mon royaume ont été incapables de le faire. Mais toi tu le peux car l'esprit des dieux saints est en toi.'"
,"16":"Alors Daniel, appelé Baltassar, resta sans parole pendant un moment; il était effrayé par ce qui lui venait à l'esprit. Le roi s'adressa à lui: 'Baltassar, n'aie pas peur de me dire la signification de ce songe!' Baltassar prit donc la parole et dit: 'Seigneur, que le songe soit pour ceux qui te haïssent et sa signification pour tes ennemis!"
,"17":"Tu as vu un arbre qui grandissait et devenait si important que son sommet touchait les cieux et qu'on le voyait de toute la terre."
,"18":"Son feuillage était beau et son fruit abondant. A tous il procurait la nourriture, les bêtes sauvages reposaient à son ombre, et dans ses branches nichaient les oiseaux du ciel."
,"19":"Cet arbre, ô roi, c'est toi. Tu as grandi à tel point que ton pouvoir s'élève jusqu'aux cieux et ta puissance s'étend jusqu'aux extrémités de la terre."
,"20":"Mais tu as vu, ô roi, un ange, un saint, qui descendait du ciel et disait: Coupez l'arbre, détruisez-le, mais laissez en terre la souche et les racines liées de chaînes de fer et de bronze dans l'herbe des champs, qu'il soit trempé de la rosée du ciel et qu'il ait sa part avec les bêtes des champs jusqu'à ce que sept ans aient passé sur lui."
,"21":"Voici ce que cela signifie, ô roi. C'est une décision du Très-Haut qui touche mon seigneur le roi."
,"22":"On te chassera du milieu des hommes et tu habiteras avec les bêtes sauvages, tu te nourriras d'herbe comme le boeuf et tu seras mouillé de la rosée du ciel. Sept ans passeront sur toi jusqu'à ce que tu reconnaisses que le Très-Haut est maître des royautés humaines et qu'il donne le pouvoir à qui il veut."
,"23":"On a dit de laisser la souche et les racines de l'arbre; de même ton royaume te sera rendu lorsque tu auras compris que les Cieux sont maîtres de tout."
,"24":"C'est pourquoi, ô roi, écoute mon conseil. Rachète tes péchés en pratiquant la justice, et tes injustices en étant bon pour les malheureux; alors tout ira bien pour toi.'"
,"25":"Tout cela arriva au roi Nabukodonozor."
,"26":"Douze mois plus tard, alors qu'il se promenait sur la terrasse du palais royal de Babylone,"
,"27":"le roi disait: 'N'est-ce pas ici la grande Babylone que j'ai construite par ma puissance et ma force, dont j'ai fait ma résidence royale, et qui sera la gloire de mon règne?'"
,"28":"Cette parole était encore dans la bouche du roi, qu'une voix tomba du ciel: 'C'est à toi que s'adresse cette parole, roi Nabukodonozor: La royauté s'est retirée de toi."
,"29":"On va te chasser du milieu des hommes, tu habiteras avec les bêtes sauvages, tu te nourriras d'herbe comme le boeuf, et sept ans passeront sur toi, jusqu'à ce que tu reconnaisses que le Très-Haut est maître des royautés humaines et qu'il donne le pouvoir à qui il veut.'"
,"30":"A l'instant même cette parole se réalisa. Nabukodonozor fut chassé du milieu des hommes; il mangeait de l'herbe comme le boeuf et son corps était trempé de la rosée du ciel, ses cheveux grandirent comme les plumes des aigles et ses ongles comme ceux des oiseaux."
,"31":"A la fin du temps fixé, moi Nabukodonozor, j'ai levé mes yeux vers le ciel et mon intelligence m'est revenue. J'ai béni le Très-Haut, j'ai loué et glorifié celui qui vit éternellement. Sa puissance est une puissance éternelle et sa royauté s'étend de génération en génération."
,"32":"Pour lui, tous les habitants de la terre sont comme rien, il fait ce qu'il veut de l'armée des cieux et des habitants de la terre; nul ne peut s'opposer à sa puissance ou lui dire: Que fais-tu?"
,"33":"A ce moment même, l'intelligence est revenue en moi, j'ai retrouvé ma majesté et ma splendeur et j'ai pu renouer un règne glorieux. Mes conseillers et mes ministres m'ont recherché, j'ai été rétabli sur mon trône et j'ai même gagné en puissance."
,"34":"Maintenant moi, Nabukodonozor, je loue, je célèbre et je glorifie le Roi des cieux; tous ses chemins sont justes et ses oeuvres sont vérité. Il sait abaisser ceux qui se conduisent avec orgueil."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Le roi Balthasar fit un grand festin pour mille de ses hauts fonctionnaires, et devant ces mille invités il but du vin."
,"2":"Après avoir goûté le vin, Balthasar donna l'ordre d'apporter les vases d'or et d'argent que son père Nabukodonozor avait enlevés dans le Temple de Jérusalem. Il voulait y boire, lui le roi, ses hauts fonctionnaires, ses femmes et ses concubines."
,"3":"On apporta donc les vases d'or qui avaient été enlevés du Temple de Dieu à Jérusalem. Le roi et ses hauts fonctionnaires, ses femmes et ses concubines les prirent pour boire:"
,"4":"ils burent du vin à la santé de leurs dieux d'or, d'argent, de bronze, de fer, de bois et de pierre."
,"5":"Or, à un moment, les doigts d'une main humaine apparurent face au chandelier: ils écrivaient sur le plâtre du mur du palais royal. Le roi vit cette main qui écrivait,"
,"6":"et aussitôt il changea de couleur: il était effrayé, tremblant de tout son corps et de tous ses membres."
,"7":"Il cria d'une voix forte pour qu'on appelle les magiciens, les sorciers et les astrologues, et devant les sages de Babylone le roi prit la parole: 'L'homme qui lira cette écriture et me fera connaître sa signification sera habillé de pourpre, on lui mettra au cou un collier d'or et il aura la troisième place dans le royaume."
,"8":"Tous les sages du roi qui étaient venus étaient incapables de déchiffrer l'inscription et d'en donner le sens."
,"9":"Le roi Balthasar fut donc plus effrayé encore, il était sans couleurs et ses hauts fonctionnaires étaient bouleversés."
,"10":"En apprenant les paroles du roi et de ses hauts fonctionnaires, la reine entra dans la salle du festin, elle prit la parole et dit: 'Vive le roi à jamais! Que tes pensées ne te troublent pas et que ton visage ne change pas ainsi de couleur."
,"11":"Il y a un homme dans ton royaume qui a en lui l'esprit des dieux saints. Pendant le règne de ton père on a pu se rendre compte qu'il y avait en lui une lumière, un jugement et une sagesse digne des Dieux. Aussi le roi ton père l'a-t-il établi chef des devins, des magiciens, des sorciers et des astrologues."
,"12":"On a remarqué en lui un esprit supérieur, une intelligence, un jugement, l'art d'expliquer les songes, d'interpréter les mystères et de résoudre les problèmes: je parle de Daniel à qui le roi avait donné le nom de Baltassar. Appelons donc Daniel et il nous dira ce que signifie tout cela."
,"13":"On amena donc Daniel en présence du roi. Le roi prit la parole et lui dit: 'Es-tu bien Daniel, l'un des déportés que mon père a fait venir de Juda?"
,"14":"On me dit que l'esprit des dieux est en toi et qu'on a remarqué en toi une lumière, un jugement et une sagesse extraordinaires."
,"15":"Or justement on vient de me faire venir les sages et les magiciens pour lire cette écriture et m'en donner la signification, mais ils n'ont pas été capables de le faire."
,"16":"Ensuite on m'a dit que tu es capable d'interpréter et de résoudre les problèmes. Si tu peux lire l'écri ture et me faire connaître sa signification, tu seras habillé de pourpre, tu porteras au cou un collier d'or et tu seras le troisième personnage du royaume.'"
,"17":"Alors Daniel prit la parole et, devant le roi, il dit: 'Garde tes cadeaux pour toi ou donne-les à d'autres! Je vais déchiffrer pour le roi cette écriture et je lui en ferai connaître la signification."
,"18":"O roi, le Dieu Très-Haut a donné à ton père Nabukodonozor la royauté, la puissance, la gloire et la majesté."
,"19":"A cause de cette puissance qu'il avait reçue, les hommes de tous les peuples, nations et langues, étaient pris de crainte et de tremblement devant lui. Il tuait ou laissait vivre à son gré, il élevait ou abaissait qui il voulait."
,"20":"Mais lorsque son coeur s'est gonflé d'orgueil et que son esprit s'est endurci, il fut rejeté de son trône royal et la gloire lui fut enlevée."
,"21":"Il fut chassé du milieu des hommes car son esprit était devenu comme celui d'une bête; il habitait avec les ânes sauvages, se nourrissait d'herbe comme le boeuf, et son corps était trempé de la rosée du ciel. Cela dura jusqu'au jour où il reconnut que le Dieu Très-Haut est maître des royautés humaines et qu'il y appelle celui qu'il veut."
,"22":"Mais toi, Balthasar son fils, tu ne t'es pas humilié alors que tu connaissais tout cela."
,"23":"Au contraire, tu t'es dressé contre le Seigneur des cieux, tu as a fait apporter devant toi les vases de son Temple et vous y avez bu du vin, toi, tes hauts fonctionnaires, tes femmes et tes concubines. Et vous avez bu à la santé de vos dieux d'argent et d'or, de bronze, de fer, de bois et de pierre, qui ne voient rien, qui n'entendent rien et qui ne savent rien. Mais tu n'as pas glorifié le Dieu qui tient ta vie dans sa main et à qui appartiennent toutes tes voies."
,"24":"Alors cette main a été envoyée de sa part pour tracer cette écriture,"
,"25":"et l'écriture tracée, la voilà: 'Méné, Méné', 'Tékel' et 'Parsin'."
,"26":"Maintenant, voici l'explication de ces mots: 'Méné': Dieu a mesuré ton royaume et il y a mis fin."
,"27":"'Tékel': tu as été pesé dans la balance et ton poids s'est trouvé bien léger."
,"28":"'Parsin': ton royaume a été divisé et donné aux Mèdes et aux Perses.'"
,"29":"Alors Balthasar ordonna d'habiller Daniel de pourpre, de lui mettre au cou un collier d'or et de proclamer qu'il était maintenant le troisième personnage du royaume."
,"30":"Mais cette nuit-là le roi kaldéen Balthasar fut assassiné."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Et Darius le Mède reçut son royaume alors qu'il avait déjà soixante deux ans."
,"2":"Darius prit un décret pour son royaume: il mettait cent vingt gouverneurs à la tête de chacune des provinces du royaume."
,"3":"Pour préserver les intérêts du roi, ils devaient rendre des comptes à trois hauts fonctionnaires placés à leur tête (Daniel était l'un des trois)."
,"4":"Mais Daniel se distingua vite parmi les hauts fonctionnaires et les gouverneurs, car il y avait en lui un esprit vraiment supérieur, et le roi songeait à le mettre à la tête du royaume tout entier."
,"5":"C'est pourquoi les hauts fonctionnaires et les gouverneurs cherchèrent dans les affaires de l'Etat un prétexte pour accuser Daniel, mais ils ne trouvèrent pas un seul reproche à lui faire, car il était fidèle et l'on ne pouvait lui reprocher ni négligence ni faute."
,"6":"Ces hommes se dirent donc: 'Puisqu'on ne peut rien reprocher à ce Daniel, trouvons quelque prétexte dans la religion de son Dieu.'"
,"7":"Les hauts fonctionnaires et les gouverneurs se précipitèrent chez le roi et lui dirent: 'Vive le roi Darius à jamais!"
,"8":"Tous les hauts fonctionnaires du royaume, les préfets, les gouverneurs, les conseillers et les hommes de loi, pensent qu'il serait bon de proclamer cette interdiction par décret royal: Quiconque, durant ces trente jours, adressera une prière à un autre dieu ou à une autre personne que toi, ô roi, sera jeté dans la fosse aux lions."
,"9":"Maintenant, ô roi, prends cette décision, fais-la mettre par écrit pour qu'elle ne soit pas modifiée et ainsi, selon la loi des Mèdes et des Perses, personne ne pourra l'annuler.'"
,"10":"Le roi Darius signa donc cette interdiction."
,"11":"Quand il apprit que ce décret était signé, Daniel rentra chez lui; la chambre était à l'étage et ses fenêtres regardaient vers Jérusalem. Trois fois par jour Daniel se mettait à genoux, priait et louait Dieu comme il l'avait toujours fait."
,"12":"Or ces hommes arrivèrent en nombre et trouvèrent Daniel en train de supplier et d'implorer son Dieu."
,"13":"Ils coururent donc chez le roi et lui rappelèrent l'interdiction royale: 'N'as-tu pas signé un décret selon lequel tout homme qui, dans les trente jours à venir, adressera une prière à un autre dieu ou à une autre personne que toi, sera jeté dans la fosse aux lions?' Le roi répondit: 'La chose a été décidée de façon ferme, selon la loi des Mèdes et des Perses: personne ne peut aller contre.'"
,"14":"Alors ils dirent au roi: 'Daniel, cet homme qui fait partie des déportés de Juda, n'a aucun respect pour toi, ni pour l'interdiction que tu as signée. Trois fois par jour il fait sa prière.'"
,"15":"En entendant ces mots, le roi fut très contrarié; il voulait sauver Daniel et, jusqu'au coucher du soleil, il chercha en vain une solution."
,"16":"Mais ces hommes le pressaient, ils lui disaient: 'Sache-le bien, ô roi, selon la loi des Mèdes et des Perses, aucune interdiction ou décret signé par le roi ne peut être annulé.'"
,"17":"Alors le roi donna l'ordre d'amener Daniel et de le jeter dans la fosse aux lions. Le roi dit à Daniel: 'Que ton Dieu que tu sers avec tant de fidélité te délivre!'"
,"18":"On apporta une grosse pierre pour fermer l'entrée de la fosse; le roi et ses hauts fonctionnaires y apposèrent leurs sceaux, si bien que l'on ne pouvait plus rien changer au sort de Daniel."
,"19":"Le roi rentra dans son palais, jeûna toute la nuit et refusa de coucher avec ses concubines; il lui fut impossible de dormir."
,"20":"Avant même le lever du soleil, le roi se leva et se rendit au plus vite à la fosse aux lions."
,"21":"Il s'approcha de la fosse et cria à Daniel d'une voix inquiète: 'Daniel, serviteur du Dieu vivant, ce Dieu que tu sers avec tant de fidélité, a-t-il été capable de te délivrer des lions?'"
,"22":"Daniel répondit au roi: 'Que le roi vive à jamais!"
,"23":"Mon Dieu a envoyé son ange, il a fermé la gueule des lions et ils ne m'ont pas touché car j'ai été trouvé innocent devant lui, et devant toi aussi, ô roi, je suis innocent.'"
,"24":"Le roi éprouva une grande joie et donna l'ordre de faire sortir Daniel de la fosse. On fit donc sortir Daniel de la fosse aux lions et on le trouva en parfait état parce qu'il avait mis sa confiance en son Dieu."
,"25":"Alors le roi fit venir les hommes qui avaient calomnié Daniel, il les fit jeter dans la fosse aux lions avec leurs enfants et leurs femmes, et avant même qu'ils aient touché le sol de la fosse, les lions s'étaient jetés sur eux et leur brisaient les os."
,"26":"Le roi Darius écrivit à tous les peuples, nations et langues qui habitent sur toute la terre: 'Que l'abondance et la paix soient avec vous!"
,"27":"Voici le décret que je prends: Dans toute l'étendue de mon royaume, les gens craindront et respecteront le Dieu de Daniel. Il est le Dieu vivant, qui demeure à jamais: son royaume ne sera pas détruit et son empire n'aura pas de fin."
,"28":"C'est lui qui sauve et qui délivre, qui opère des signes et des prodiges dans les cieux et sur la terre: il a sauvé Daniel des griffes et de la dent des lions.'"
,"29":"Durant le règne de Darius et celui de Cyrus le Perse, Daniel fut de plus en plus considéré."
}`)
	CurrentBook.AddChapter(7, `{
"1":"En la première année de Balthasar roi de Babylone, au cours d'une nuit, Daniel eut un rêve et des visions qu'il fixa par écrit. En voici le récit."
,"2":"Daniel prit la parole et dit: 'J'ai eu des visions durant la nuit: les quatre vents du ciel soulevaient la grande mer"
,"3":"et quatre bêtes énormes sortirent de la mer; elles étaient toutes les quatre différentes."
,"4":"La première ressemblait à un lion avec des ailes d'aigle; pendant que je la regardais, ses ailes lui furent arrachées, elle fut soulevée de terre et se dressa sur ses pieds comme un homme; un coeur d'homme lui fut donné."
,"5":"La seconde bête était semblable à un ours, elle était dressée sur un côté et tenait trois côtes entre ses dents. Alors on lui dit: 'Lève-toi et dévore beaucoup de viande.'"
,"6":"Je regardai et je vis une autre bête semblable à un léopard; elle avait quatre ailes d'oiseau sur les côtés, elle avait quatre têtes, et le pouvoir lui fut donné."
,"7":"Tandis que je contemplais mes visions nocturnes, j'aperçus une quatrième bête terrible, effrayante, d'une puissance incroyable; elle avait de grandes dents de fer, elle mangeait, broyait et écrasait de ses pieds tout ce qui restait. Différente de toutes les bêtes qui étaient venues avant elle, elle avait dix cornes."
,"8":"Je regardais les cornes: voici qu'une autre corne, petite, sortit du milieu d'elles et trois des cornes précédentes furent arrachées pour lui laisser la place. Alors je vis sur cette corne des yeux semblables à des yeux d'homme et une bouche qui prononçait des paroles insolentes."
,"9":"Je regardais toujours; on installa des trônes et un vieillard s'assit; son vêtement était blanc comme la neige, les cheveux de sa tête, comme la laine blanche, son trône était de flammes de feu avec des roues de feu ardent."
,"10":"Un fleuve de feu sortait et jaillissait de devant lui; des mille et des milliers le servaient, des millions et des millions se tenaient debout devant lui. Le tribunal se mit en place et l'on ouvrit les livres."
,"11":"Les paroles insolentes prononcées par la corne avaient créé un grand désordre. Aussi, tandis que je regardais, la bête fut tuée, son corps fut détruit et jeté dans un feu ardent."
,"12":"On enleva aux autres bêtes leur pouvoir, mais leur vie fut prolongée pour un moment, jusqu'à la date fixée."
,"13":"Tandis que je contemplais ces visions nocturnes, je vis comme un fils d'homme venant avec les nuées du ciel; il s'avança vers le vieillard et on le conduisit en sa présence."
,"14":"On lui donna le pouvoir, la gloire et la royauté: tous les peuples, nations et langues, le servirent. Son pouvoir est le pouvoir pour toujours, qui ne passera pas; son royaume ne sera pas détruit."
,"15":"Moi, Daniel, je restai là. Mon esprit était troublé à la suite de tout cela, car ces visions m'avaient effrayé."
,"16":"Je m'approchai donc de l'un de ceux qui se tenaient là debout et je lui demandai de me dire la réalité de tout ce que j'avais vu. Il me parla et me donna la signification de toutes ces choses."
,"17":"Ces bêtes énormes au nombre de quatre sont quatre rois qui apparaîtront sur la terre,"
,"18":"après quoi les saints du Très-Haut recevront la royauté et la posséderont pour les siècles et les siècles des siècles."
,"19":"Je voulais encore connaître la vérité au sujet de la quatrième bête, si différente des autres et si terrible avec ses dents de fer et ses griffes de bronze, qui dévorait, broyait, et piétinait ensuite tout ce qui restait."
,"20":"Je voulais savoir qui étaient ces dix cornes qu'elle portait sur la tête, et l'autre corne qui avait poussé, devant laquelle trois des premières étaient tombées; je voulais savoir ce qu'était cette corne avec des yeux et une bouche qui prononçait des paroles insolentes et qui semblait plus importante que les autres."
,"21":"Je regardais cette corne qui faisait la guerre aux saints et qui remportait sur eux la victoire,"
,"22":"jusqu'à l'arrivée du vieillard qui rendit un jugement en faveur des saints du Très-Haut, et à ce moment les saints possédèrent le royaume."
,"23":"Alors celui que j'avais interrogé me dit: 'La quatrième bête est un quatrième royaume sur la terre qui sera différent de tous les autres; il dévorera toute la terre, l'écrasera et la piétinera. "
,"24":"Ces dix cornes sont dix rois qui se lèveront dans ce royaume, puis un autre se lèvera après eux, différent des précédents, qui abattra trois rois."
,"25":"Il parlera contre le Très-Haut, il persécutera les saints du Très-Haut, il essaiera de changer le calendrier et la Loi; les saints seront livrés en son pouvoir pour un temps, deux temps et la moitié d'un temps."
,"26":"Mais le tribunal se mettra en place, on lui retirera son pouvoir, il sera détruit et exterminé pour toujours."
,"27":"Alors la royauté, l'autorité et la grandeur de tous les royaumes qui sont sous les cieux seront données au peuple des saints du Très-Haut; son règne est un règne éternel et toutes les puissances le serviront et lui obéiront.'"
,"28":"Ici s'achève le récit. Moi, Daniel, ces visions m'avaient effrayé et mon visage avait changé de couleur, mais j'ai conservé tout cela dans mon coeur."
}`)
	CurrentBook.AddChapter(8, `{
"1":"En la troisième année du règne de Balthasar, moi Daniel, j'ai reçu une nouvelle vision à la suite des précédentes."
,"2":"Durant cette vision j'ai vu la citadelle de Suze, dans la province d'Elam; dans cette vision je me trouvais près de la rivière d'Oulaï, et de là je regardais."
,"3":"Comme je levais les yeux, je vis un bélier avec deux cornes qui se tenait devant le torrent. Les deux cornes étaient grandes, mais l'une dépassait l'autre, et la plus grande fut celle qui se dressa la dernière."
,"4":"Je vis le bélier donner des coups de corne vers l'ouest, vers le nord et vers le sud; aucune bête ne pouvait lui résister, rien ne pouvait lui échapper. Il faisait ce qui lui plaisait et devint puissant."
,"5":"Comme je cherchais à comprendre, j'aperçus un bouc qui venait de l'occident après avoir parcouru toute la terre, mais sans toucher le sol; ce bouc avait une corne énorme entre les yeux."
,"6":"Il s'approcha du bélier à deux cornes que j'avais vu sur le rivage et s'élança vers lui de toutes ses forces."
,"7":"Je le vis se jeter sur le bélier: il le frappa furieusement et lui brisa les deux cornes sans que le bélier puisse lui résister. Il le jeta par terre, le piétina et nul ne put délivrer le bélier de sa main."
,"8":"Le bouc devint très puissant mais, au comble de sa puissance, la grande corne se brisa et quatre cornes poussèrent à sa place, tournées vers les quatre vents du ciel."
,"9":"De l'une d'elles sortit une corne plus pe tite, mais qui s'étendit beaucoup en direction du sud, de l'est, et vers la terre de Beauté."
,"10":"Elle grandit au point d'atteindre l'armée des cieux, elle en fit tomber à terre une partie ainsi que des étoiles qu'elle piétina."
,"11":"Elle se dressa même contre le chef de cette armée: elle lui enleva le sacrifice perpétuel et renversa les fondations de son sanctuaire"
,"12":"en même temps que son armée. Au lieu même où l'on présentait le sacrifice, elle dressa l'Abomination, piétina la vérité et réussit dans toutes ses entreprises."
,"13":"J'entendis alors un saint qui parlait et un autre saint lui posa cette question: 'Jusqu'à quand ce qu'annonce cette vision: le sacrifice perpétuel enlevé, l'Abomination dressée et le lieu saint et l'armée piétinés?'"
,"14":"Il lui répondit: 'Jusqu'à deux mille trois cents soirs et matins; alors le lieu saint sera rétabli selon le droit.'"
,"15":"Or pendant que moi, Daniel, je regardais la vision et cherchais à comprendre, je crus voir un homme devant moi"
,"16":"et j'entendis une voix sur les bords de l'Oulaï qui lui criait: 'Gabriel, fais-lui comprendre la vision.'"
,"17":"Il se dirigea donc vers l'endroit où je me tenais, mais à son approche je fus effrayé et je tombai la face contre terre. Il me dit: 'Fils d'homme, comprends que cette vision concerne le temps de la fin.'"
,"18":"Pendant que j'étais prosterné à terre et qu'il me parlait, je perdis connaissance; il me toucha et me releva."
,"19":"Puis il me dit: 'Maintenant je vais te faire connaître ce qui arrivera à la fin du temps de la colère, car la fin est décidée."
,"20":"Le bélier que tu as vu avec ses deux cornes, ce sont les rois des Mèdes et des Perses."
,"21":"Le bouc velu est le roi de Yavan, la grande corne entre ses yeux est leur premier roi."
,"22":"La corne brisée et les quatre cornes qui ont poussé à sa place, ce sont quatre royaumes sortis de cette nation, mais qui n'atteindront pas sa puissance."
,"23":"Au terme de leur règne, lorsque le péché sera arrivé à son comble, on verra se lever un roi au visage fier qui aimera les difficultés."
,"24":"Sa puissance ne cessera de grandir; il entreprendra des choses incroyables et il réussira dans ses entreprises. Il détruira les puissants et le peuple des saints."
,"25":"Grâce à son astuce ses stratagèmes réussiront; il se gonflera d'orgueil et détruira bien des gens par surprise. Il se dressera contre le Roi des rois, mais sans qu'intervienne la main de l'homme, il sera brisé."
,"26":"La vision des soirs et des matins, celle que tu viens d'avoir, est absolument sûre, mais garde-la pour toi car elle concerne un avenir lointain.'"
,"27":"Moi, Daniel, je m'évanouis; je fus malade plusieurs jours, puis je me levai pour m'occuper des affaires du roi. Mais je restais bouleversé par cette vision que je ne comprenais pas."
}`)
	CurrentBook.AddChapter(9, `{
"1":"c'était la première année de Darius fils d'Artaxerxès, le Mède, qui régna sur le royaume de Kaldée."
,"2":"En cette première année de son règne, moi Daniel j'étudiais les Ecritures et je faisais le compte de ces soixante-dix années qui doivent passer sur Jérusalem en ruines, comme cela a été révélé au prophète Jérémie."
,"3":"Je tournai mon regard vers le Seigneur Dieu pour l'invoquer dans la prière et le supplier par le jeûne, le sac et la cendre."
,"4":"Je suppliai Yahvé mon Dieu et je lui fis cette confession: 'Ah mon Seigneur, Dieu grand et redoutable qui gardes l'alliance et ta miséricorde envers ceux qui t'aiment et observent tes commandements!"
,"5":"Nous avons péché, nous avons commis l'injustice, nous avons été infidèles, nous nous sommes révoltés; nous nous sommes détournés de tes commandements et de tes lois."
,"6":"Nous n'avons pas écouté tes serviteurs les prophètes qui parlaient en ton nom à nos rois, à nos chefs et à nos pères, comme au peuple-du-pays."
,"7":"Toi, Seigneur, tu as été juste, et nous n'avons droit qu'à la honte comme en ce jour, nous les gens de Juda, les habitants de Jérusalem et tout Israël, qu'ils soient proches ou au loin dans tous les pays où tu nous as dispersés à cause des infidélités que nous avons commises contre toi."
,"8":"A nous, Yahvé, la honte, à nos rois, nos chefs et nos prêtres, car nous avons péché contre toi."
,"9":"Que le Seigneur notre Dieu ait miséricorde et pardonne, car nous nous sommes révoltés contre lui."
,"10":"Nous n'avons pas obéi à Yahvé notre Dieu, nous n'avons pas marché selon les lois qu'il avait fait placer devant nous par ses serviteurs les prophètes."
,"11":"Tout Israël a désobéi à ta Loi et s'est détourné de ta parole; aussi la malédiction et la menace qui sont écrites dans la loi de Moïse, serviteur de Dieu, sont-elles venues sur nous, car nous avions péché contre toi."
,"12":"Yahvé a accompli les paroles qu'il avait prononcées contre nous et contre les chefs qui nous gouvernaient. Il a fait venir contre nous un terrible malheur; on n'avait jamais vu sous le ciel ce qui est arrivé à Jérusalem."
,"13":"Le malheur est venu sur nous comme il est écrit dans la loi de Moïse, mais nous n'avons pas pour autant apaisé Yahvé notre Dieu en renonçant à notre mauvaise conduite et en faisant attention à sa vérité."
,"14":"C'est Yahvé qui a prévu ce malheur et l'a fait venir sur nous, car Yahvé notre Dieu est juste dans tout ce qu'il fait: nous n'avions pas écouté sa voix."
,"15":"Oui, Seigneur notre Dieu, toi qui as fait sortir ton peuple du pays d'Egypte par ta main puissante, c'est envers toi dont la renommée est éternelle, que nous avons péché et que nous avons été infidèles."
,"16":"Dans ta grande bonté, Seigneur, détourne ta colère et ta fureur de Jérusalem, ta ville, et de ta montagne sainte, car à cause de nos péchés et des péchés de nos pères Jérusalem et ton peuple sont un objet de moquerie pour tous ceux qui nous entourent."
,"17":"Toi donc, notre Dieu, écoute la prière de ton serviteur et sa supplication. Pour ton honneur, Seigneur, fais briller ton visage sur ton sanctuaire en ruines."
,"18":"Prête l'oreille, ô mon Dieu, écoute, ouvre tes yeux, regarde notre ruine et la ville sur laquelle ton Nom a été prononcé. Nous te supplions: nous n'attendons rien de nos mérites, mais nous confions en ta grande miséricorde."
,"19":"Ecoute, Seigneur, pardonne, Seigneur, regarde, Seigneur. Agis ô mon Dieu, ne tarde pas par amour de toi-même, car ta ville et ton peuple sont appelés de ton nom."
,"20":"Je parlais encore, je priais et confessais mon péché et celui de mon peuple Israël et je faisais monter ma supplication devant Yahvé mon Dieu sur sa sainte montagne -"
,"21":"je parlais et priais encore lorsque Gabriel arriva vers moi en volant, celui que j'avais vu en vision au commencement. C'était l'heure de l'offrande du soir."
,"22":"Il vint vers moi et me dit: 'Daniel, je suis venu maintenant pour que tu puisses comprendre."
,"23":"Au commencement de ta prière, une parole est sortie et je suis venu pour te la faire connaître, car tu es aimé de Dieu. Applique ton esprit à cette parole et comprends la vision:"
,"24":"Pour ton peuple et ta ville sainte, soixante-dix semaines ont été fixées,pour faire cesser l'injustice, pour mettre un terme au péché, pour expier l'offense, pour faire venir la justice éternelle, pour accomplir vision et prophétie, pour oindre le Saint des saints."
,"25":"Comprends donc bien ceci: Depuis que l'ordre a été donné de reconstruire Jérusalem jusqu'à un chef consacré, ce seront sept semaines; puis soixante-deux semaines pour reconstruire la place et les fossés. Puis viendra la fin."
,"26":"Après les soixante-deux semaines, un homme consacré sera mis à mort, bien que l'on n'ait pas trouvé de faute en lui. Un peuple viendra dont le chef détruira la ville et le Temple. Et jusqu'à la fin il n'y aura que guerre et désastres."
,"27":"Durant une semaine il consolidera son alliance avec beaucoup; le temps d'une demi-semaine il fera cesser le sacrifice et l'offrande. Sur le côté du Temple se dressera l'Abomination de la Désolation jusqu'au temps fixé pour la ruine du dévastateur."
}`)
	CurrentBook.AddChapter(10, `{
"1":"En la troisième année de Cyrus roi de Perse, une parole fut révélée à Daniel, appelé Baltassar: une parole sûre qui se référait à une grande épreuve. Daniel comprit la parole et reçut l'explication de la vision."
,"2":"En ce temps-là, moi Daniel, je faisais un deuil de trois semaines."
,"3":"Pendant ces trois semaines je n'ai pas mangé de bons plats, je me suis privé de viande et de vin et j'ai renoncé à tout parfum."
,"4":"Le vingt-quatrième jour du premier mois j'étais au bord du grand fleuve, le Tigre."
,"5":"Comme je levais les yeux, je vis un homme habillé de lin qui portait une ceinture d'or brillant."
,"6":"Son corps semblait de pierres précieuses, son visage avait l'aspect de l'éclair, ses yeux étaient comme des lampes de feu, ses bras et ses jambes avaient l'éclat du bronze poli et ses paroles résonnaient comme le vacarme d'une foule."
,"7":"Moi, Daniel, j'étais seul à contempler cette vision; les hommes qui étaient avec moi n'avaient rien vu, mais une grande frayeur s'abattit sur eux et ils coururent se cacher."
,"8":"Je restai seul à contempler cette grande vision. J'étais là sans forces, mon visage avait changé de couleur et j'avais perdu tous mes moyens."
,"9":"J'entendis ce qu'on disait et en l'entendant je tombai évanoui le visage contre terre."
,"10":"Alors une main me toucha et me fit trembler de tous mes membres."
,"11":"L'homme me dit: 'Daniel, prends au sérieux les paroles que je te dis et tiens-toi debout; j'ai été envoyé vers toi car tu es aimé de Dieu.' Quand il m'eut parlé ainsi, je pus me tenir debout bien que tremblant."
,"12":"Puis il ajouta: 'N'aie pas peur, Daniel, car depuis le premier jour où tu as pris à coeur de comprendre et de t'humilier sous le regard de ton Dieu, tes paroles ont été entendues et c'est pour cela que je suis venu en personne.'"
,"13":"Le prince du royaume de Perse m'a résisté pendant vingt et un jours, mais Michel, l'un des premiers princes, est venu à mon aide; je l'ai laissé lutter contre le roi de Perse"
,"14":"et je suis venu t'expliquer ce qui adviendra à ton peuple à la fin des jours. Car cette vision encore est pour ces jours-là.'"
,"15":"A ces mots j'ai baissé la tête vers le sol et je suis resté sans parole."
,"16":"Mais un person nage d'allure humaine me toucha les lèvres. J'ouvris la bouche pour parler et je dis à celui qui se tenait devant moi: 'Mon seigneur, cette vision m'a rempli d'angoisse et m'a fait perdre tous mes moyens."
,"17":"Je ne suis que le serviteur de mon seigneur, comment pourrais-je parler à mon seigneur alors que je suis sans forces et que le souffle me manque?'"
,"18":"De nouveau, le personnage qui ressemblait à un homme me toucha et me réconforta."
,"19":"Il me dit: 'N'aie pas peur, toi qui es aimé de Dieu, que la paix soit avec toi. Courage, courage!' Et pendant qu'il me parlait, je sentais mes forces qui revenaient. Je lui dis: 'Que mon seigneur parle encore, car il m'a réconforté.'"
,"20":"-"
,"21":"Il ajouta: 'Sais-tu pourquoi je venu vers toi? Je vais t'annoncer ce qui est écrit dans le livre de vérité. Et puis je retournerai combattre le prince de Perse et ensuite viendra le prince de Yavan; personne ne m'aide contre eux sinon Michel, votre prince."
}`)
	CurrentBook.AddChapter(11, `{
"1":"En la première année de Darius le Mède, je me tenais auprès de lui pour le fortifier et l'encourager."
,"2":"Et maintenant je vais te révéler la vérité: trois rois se lèveront encore sur la Perse et le quatrième sera beaucoup plus riche que tous les autres. Sa richesse le rendra puissant et il fera tout pour s'opposer au royaume de Yavan."
,"3":"Mais là se lèvera un roi courageux qui se rendra puissant et fera ce qui lui plaît."
,"4":"Au milieu de ses succès, sa royauté sera brisée et son royaume partagé aux quatre vents du ciel, mais non entre ses descendants, car son royaume leur sera arraché et sera livré à d'autres."
,"5":"Le roi du midi deviendra fort, mais l'un de ses princes l'emportera sur lui et se taillera un empire plus grand que le sien."
,"6":"Au bout de quelques années ils feront alliance ensemble; la fille du roi du midi ira trouver le roi du nord pour conclure un accord, mais elle perdra son pouvoir et ne laissera pas de descendance: elle sera bientôt mise à mort avec sa suite, son enfant et son mari. A ce moment"
,"7":"un rejeton de sa race se lèvera à sa place, il viendra mettre le siège devant la citadelle du roi du nord, s'en emparera et la traitera en vainqueur."
,"8":"Il emportera même en Egypte comme butin, leurs dieux, leurs statues et leurs vases précieux d'argent et d'or. Et pendant quelques années, il gardera ses distances avec le roi du nord."
,"9":"Ce dernier fera une expédition vers le royaume du midi, puis s'en retournera vite chez lui."
,"10":"Ses fils se lèveront et rassembleront des forces nombreuses et puissantes. L'un d'entre eux s'avancera, débordera comme un fleuve, traversera le pays et de nouveau se lèvera pour attaquer la forteresse du roi du midi."
,"11":"Furieux, celui-ci se mettra en campagne contre le roi du nord avec une puissante armée, et les troupes nombreuses du roi du nord seront livrées entre ses mains."
,"12":"La destruction de cette armée excitera son orgueil; il massacrera quantité de gens, mais sans résultat."
,"13":"Le roi du nord reviendra après avoir rassemblé des troupes plus nombreuses que les premières, et après quelques années, il s'avancera avec une armée puissante et très bien équipée."
,"14":"En ce temps-là beaucoup se lèveront contre le roi du midi et, parmi eux, des hommes violents de ton peuple; ils se lèveront car la vision doit s'accomplir, mais ce sera pour leur perte."
,"15":"Le roi du nord s'avancera, il fera des retranchements et s'emparera d'une ville fortifiée; l'armée du midi ne résistera pas devant lui et les plus courageux de ses hommes perdront pied."
,"16":"Alors l'attaquant fera tout ce qui lui plaît, personne ne tiendra devant lui, il occupera le pays de Beauté et le saccagera."
,"17":"Voulant dominer tout le royaume du midi, il fera un pacte avec lui et lui donnera une de ses filles comme épouse, uniquement pour le perdre, mais cela n'aboutira pas et ne se réalisera pas."
,"18":"Il se tournera vers les îles et en prendra beaucoup, mais un chef l'arrêtera et l'humiliera sans qu'il puisse prendre sa revanche."
,"19":"Il se tournera ensuite vers les villes fortifiées de son pays, mais il trébuchera, tombera et disparaîtra pour toujours."
,"20":"Un autre se lèvera à sa place qui enverra dans la gloire du Royaume un collecteur d'impôts, mais en quelques jours celui-ci sera brisé sans armes ni combat."
,"21":"A sa place se lèvera un homme méprisable à qui l'on ne donnera pas l'honneur de la royauté; il viendra en toute tranquillité et s'emparera du royaume par ses trahisons."
,"22":"Des armées puissantes prendront la fuite devant lui et seront brisées; le Prince de l'Alliance sera également brisé."
,"23":"Usant de corruption et de trahison, il prendra de l'importance et deviendra fort, bien qu'il n'ait que peu de monde avec lui."
,"24":"Il envahira sans risques de riches provinces et fera ce que ni ses pères, ni les pères de ses pères, n'avaient fait: il distribuera à ses hommes, butin, dépouilles et richesse, et pour un temps il essaiera de s'emparer de forteresses."
,"25":"Il dirigera ses forces et son ardeur contre le roi du midi, appuyé par une grande armée; l'autre aussi se lancera dans la guerre avec une armée grande et puissante, mais il sera vaincu à la suite de complots menés contre lui."
,"26":"Ceux qui mangeaient à sa table le briseront, son armée sera écrasée et perdra beaucoup de monde."
,"27":"Les deux rois ne penseront qu'à se faire du mal, et bien qu'assis à la même table ils se mentiront l'un à l'autre. Cela ne changera rien: la fin viendra au temps fixé."
,"28":"Le roi du nord rentrera dans son pays avec de grandes richesses et de mauvais projets contre l'Alliance Sainte; il luttera contre elle puis il rentrera dans son pays."
,"29":"Le moment venu, il repartira contre le royaume du midi, mais cette fois les choses se termineront mal."
,"30":"En voyant approcher les vaisseaux de Kittim il perdra son assurance; il fera demi-tour et déchaînera sa colère contre l'Alliance Sainte. De nouveau il comblera d'honneurs ceux qui abandonnent cette alliance. "
,"31":"Des troupes à lui viendront profaner la citadelle du temple, feront cesser le sacrifice perpétuel et dresseront l'Abomination de la Désolation."
,"32":"Par ses paroles trompeuses il obtiendra que des hommes infidèles à l'Alliance trahissent, mais le peuple de ceux qui connaissent leur Dieu restera ferme dans ses pratiques."
,"33":"Ceux du peuple qui ont la connaissance en instruiront beaucoup, mais ils seront persécutés: l'épée, le feu, la captivité et le pillage seront leur lot durant bien des jours."
,"34":"Pendant leur persécution, quelques uns leur apporteront leur soutien, mais beaucoup ne le feront que par hypocrisie."
,"35":"La chute de certains parmi ceux qui ont la connaissance, servira à purifier, laver et blanchir un grand nombre d'autres jusqu'au temps de la fin, mais ce temps fixé est encore à venir."
,"36":"Dans son orgueil, le roi fera tout selon son bon plaisir, il se placera au-dessus de tous les dieux; il prononcera même des paroles insolentes contre le Dieu des Dieux, et tout lui réussira jusqu'à ce que la Colère soit à son comble, car ce qui est décidé s'accomplira."
,"37":"Il n'aura aucune attention, ni pour les dieux de ses pères, ni pour le dieu chéri des femmes, ni pour tout autre dieu, car c'est lui-même qu'il placera au-dessus de tout."
,"38":"A leur place il honorera le dieu des forteresses, un dieu que ses pères n'ont pas connu; il lui offrira de l'or, de l'argent, des pierres précieuses et des objets de grand prix."
,"39":"Il mettra le siège devant les villes fortifiées avec l'aide d'un dieu étranger; à quiconque reconnaîtra ce dieu il donnera honneur, pouvoir, et des terres en partage."
,"40":"Au temps de la fin, le roi du midi l'attaquera; le roi du nord se jettera sur lui avec ses chars, ses cavaliers et de nombreux navires. Il descendra vers toutes ses terres, les envahira et les traversera."
,"41":"Il traversera le pays de Beauté et beaucoup de gens seront massacrés, pendant qu'Edom, Moab et les meilleurs des fils d'Ammon échapperont à ses mains."
,"42":"Il étendra la main sur tous les pays et l'Egypte n'échappera pas."
,"43":"Il s'emparera des trésors d'or et d'argent et de tous les objets précieux d'Egypte. Les Lybiens et les Kouchites lui seront soumis."
,"44":"Mais bientôt des nouvelles venues d'orient et du nord l'inquiéteront; il repartira très en colère pour détruire et massacrer beaucoup de gens."
,"45":"Il dressera les tentes de son armée entre la mer et les montagnes du pays de Beauté. Après quoi il arrivera à sa fin et nul ne lui portera secours."
}`)
	CurrentBook.AddChapter(12, `{
"1":"En ce temps-là se lèvera Michel, le grand prince, celui qui défend les enfants de ton peuple; car ce sera un temps de détresse comme il n'y en a pas eu depuis qu'il existe des peuples jusqu'à ce jour. En ce temps-là sera sauvé ton peuple, tous ceux qui sont inscrits dans le Livre."
,"2":"Beaucoup de ceux qui dorment au pays de la poussière se réveilleront, les uns pour la vie éternelle, les autres pour la honte et l'horreur éternelle."
,"3":"Ceux qui ont la connaissance brilleront comme un ciel resplendissant, ceux qui auront conduit les autres à la justice brilleront comme les étoiles pour les siècles des siècles."
,"4":"Toi, Daniel, garde secrètes ces paroles, qu'elles soient comme un livre scellé jusqu'au temps de la fin; beaucoup chercheront ici et là et l'injus tice ira en grandissant."
,"5":"Comme je levais les yeux, moi Daniel, je vis deux autres hommes qui se tenaient sur l'une et l'autre rive du fleuve."
,"6":"L'un des deux dit à l'homme vêtu de lin qui était au-dessus des eaux du fleuve: 'Quand s'accompliront ces choses prodigieuses?'"
,"7":"L'homme vêtu de lin qui était au-dessus des eaux du fleuve leva alors ses deux mains vers le ciel et je l'entendis qui faisait ce serment par celui qui vit éternellement: 'Tout se réalisera dans un temps, des temps et un demi-temps. C'est lorsque le peuple saint sera complètement écrasé et sans force, que toutes ces choses s'accompliront.'"
,"8":"J'entendais, mais je ne comprenais pas. Je posai donc cette question: 'Mon Seigneur, comment sera la fin des choses?'"
,"9":"Il me répondit: 'Va, Daniel, ces choses resteront secrètes et cachées jusqu'au temps de la fin."
,"10":"Beaucoup seront purifiés, blanchis et mis à l'épreuve, les méchants feront le mal et aucun d'eux ne saura, mais ceux qui ont la connaissance comprendront."
,"11":"Depuis le jour où l'on supprimera le sacrifice perpétuel et où sera dressée l'Abomination de la Désolation, il s'écoulera mille deux cent quatre-vingt-dix jours."
,"12":"Heureux celui qui tiendra et arrivera à mille trois cent trente-cinq jours."
,"13":"Quant à toi, Daniel, va jusqu'au bout de ton chemin; tu te reposeras, et puis tu te lèveras à la fin des jours pour recevoir ta part.'"
}`)
	CurrentBook.AddChapter(13, `{
"1":"Il y avait un homme du nom de Yoakim qui vivait à Babylone."
,"2":"Il avait épousé une femme nommée Suzanne, fille d'Helquias; elle était très belle et craignait Dieu"
,"3":"car ses parents étaient excellents et ils avaient élevé leur fille selon la loi de Moïse."
,"4":"Yoakim était très riche, il avait un jardin qui touchait sa maison; les Juifs venaient nombreux chez lui car il était le plus respecté de tous."
,"5":"Cette année-là on avait choisi comme juges deux anciens du peuple, de ceux pour lesquels le Seigneur a dit: 'L'injustice s'est manifestée à Babylone avec des anciens, des juges qui voulaient passer pour chefs du peuple.'"
,"6":"Ces hommes fréquentaient la maison de Yoakim et tous ceux qui avaient un procès venaient les trouver."
,"7":"Lorsque le peuple se retirait vers le milieu du jour, Suzanne allait au jardin de son mari pour s'y promener."
,"8":"Les deux anciens qui la voyaient chaque jour entrer et se promener, commencèrent à la désirer;"
,"9":"ils en perdirent la tête, ils cessèrent de regarder vers le Ciel et oublièrent ses justes jugements."
,"10":"Ils étaient tous les deux dévorés par la même passion, mais ils se le cachaient l'un à l'autre;"
,"11":"ils avaient honte d'avouer le désir qui les pressait de coucher avec elle,"
,"12":"mais chaque jour ils faisaient tout pour l'apercevoir."
,"13":"Ils se dirent un jour l'un à l'autre: 'Rentrons chez nous, c'est l'heure du déjeuner.' Ils sortent, ils se séparent,"
,"14":"et puis ils font demi-tour et ils se retrouvent au même endroit. Ils s'interrogent l'un l'autre sur la raison de ce retour et ils finissent par s'avouer leur désir. Alors ils commencent à chercher ensemble une occasion de la trouver seule."
,"15":"Tandis qu'ils étaient à l'affût d'une occasion favorable, Suzanne entra dans le jardin comme elle avait fait jusque-là, accompagnée seulement de deux servantes. Il faisait chaud et elle voulut se baigner."
,"16":"Il n'y avait personne dans le jardin en dehors des deux anciens qui s'étaient cachés et qui la guettaient."
,"17":"Suzanne dit aux jeunes filles: 'Apportez-moi donc de l'huile et des parfums et fermez les portes du jardin pour que je puisse me baigner.'"
,"18":"Elles firent comme Suzanne avait dit; elles fermèrent les portes du jardin et sortirent par la porte de derrière pour rapporter ce qu'elle avait demandé; elle ne savait pas que les anciens étaient là cachés."
,"19":"Dès que les servantes furent sorties, les deux anciens se levèrent et coururent vers Suzanne."
,"20":"Ils lui dirent: 'Les portes du jardin sont maintenant fermées, personne ne nous voit et nous sommes fous de désir pour toi: accepte donc de te donner à nous."
,"21":"Sinon, nous porterons témoignage contre toi, nous dirons qu'un jeune homme était avec toi et que c'est pour cela que tu as renvoyé les jeunes filles.'"
,"22":"Suzanne soupira et dit: 'De toutes parts pour moi c'est l'angoisse: ce serait pour moi la mort que de faire une telle chose, et si je ne le fais pas, je n'échapperai pas à vos mains."
,"23":"Mais il vaut mieux pour moi tomber innocente entre vos mains, que de pécher sous le regard du Seigneur.'"
,"24":"Alors Suzanne cria d'une voix forte, mais les deux anciens crièrent aussi contre elle"
,"25":"et l'un d'entre eux courut ouvrir les portes du jardin."
,"26":"En entendant les cris dans le jardin, les serviteurs de la maison arrivèrent en courant par la porte de derrière pour voir ce qui était arrivé."
,"27":"Les anciens s'expliquèrent, et les serviteurs furent couverts de confusion car on n'avait jamais entendu dire quelque chose de semblable à propos de Suzanne."
,"28":"Le lendemain, lorsque le peuple se rassembla chez Yoakim, le mari de Suzanne, les deux anciens arrivèrent le coeur rempli de pensées criminelles contre Suzanne; ils étaient décidés à la faire mourir."
,"29":"Devant tout le peuple ils dirent: 'Allez chercher Suzanne, fille d'Helquias, la femme de Yoakim.' Aussitôt on alla la chercher."
,"30":"Elle arriva avec ses parents, ses enfants et sa famille."
,"31":"Suzanne avait un très beau visage: elle était très belle."
,"32":"Comme elle était voilée, ces misérables lui firent enlever son voile pour se rassasier encore de sa beauté."
,"33":"Tous ses proches pleuraient, ainsi que tous ceux qui la voyaient."
,"34":"Alors les deux vieillards se levèrent au milieu de l'assemblée et posèrent leurs mains sur sa tête."
,"35":"Elle pleurait: le vi sage tourné vers le ciel, elle mettait sa confiance en Dieu."
,"36":"Les vieillards prirent la parole: 'Tandis que nous nous promenions seuls dans le jardin, cette femme est entrée avec deux servantes. Elle a fermé les portes du jardin, puis elle a renvoyé les jeunes filles."
,"37":"Alors un jeune homme qui était caché s'est approché d'elle et a péché avec elle."
,"38":"Nous étions dans un coin du jardin et, quand nous avons vu ce scandale, nous nous sommes précipités vers eux"
,"39":"et nous les avons vu coucher ensemble. Mais nous n'avons pas pu saisir le jeune homme parce qu'il était plus fort que nous. Après avoir ouvert les portes, il a pris la fuite."
,"40":"Mais elle, nous l'avons prise et nous lui avons demandé qui était ce jeune homme,"
,"41":"et elle n'a pas voulu nous le dire. Nous sommes témoins de tout cela.',Comme ils étaient anciens et juges du peuple, l'assemblée crut à leurs paroles et ils la condamnèrent à mort. "
,"42":"Alors Suzanne cria d'une voix forte: 'Dieu éternel, toi qui connais les secrets et qui sais tout avant que les choses n'arrivent,"
,"43":"tu sais qu'ils ont porté contre moi un faux témoignage et que maintenant je meurs innocente de tout ce que ces misérables ont imaginé contre moi!'"
,"44":"Le Seigneur entendit la voix de Suzanne."
,"45":"Pendant qu'on la conduisait au supplice, Dieu éveilla l'esprit saint d'un jeune garçon nommé Daniel,"
,"46":"et d'une voix forte il cria: 'Je suis innocent du sang de cette femme!'"
,"47":"Tout le monde se retourna vers lui et lui dit: 'Qu'est-ce que tu nous dis là?'"
,"48":"Et lui, se tenant au milieu de tous, leur dit: 'Etes-vous donc tellement stupides, fils d'Israël? Sans avoir jugé, sans connaître la vérité, vous condamnez une fille d'Israël!"
,"49":"Retournez au tribunal, car ils ont porté contre elle un faux témoignage.'"
,"50":"Tout le monde s'empressa de retourner au tribunal et les anciens dirent à Daniel: 'Viens, assieds-toi au milieu de nous et dis-nous ta pensée, car Dieu t'a donné la sagesse des anciens.'"
,"51":"Daniel leur dit: 'Séparez-les l'un de l'autre, et moi je vais les juger.'"
,"52":"Lorsqu'ils furent séparés l'un de l'autre, Daniel appela le premier et lui dit: 'Tu as vieilli dans le mal, et maintenant les péchés de ta vie passée retombent sur toi."
,"53":"Tu rendais des jugements injustes, tu condamnais les innocents et tu renvoyais libres les coupables, alors que le Seigneur a dit: Tu ne feras pas mourir l'innocent et le juste."
,"54":"Eh bien, puisque tu l'as vue, dis-nous sous quel arbre tu les as vus coucher ensemble.' Il répondit: 'Sous un acacia.'"
,"55":"Daniel lui dit: 'Ton mensonge retombe sur ta propre tête et Dieu a déjà donné l'ordre à son ange de te fendre par le milieu.'"
,"56":"Il le renvoya et ordonna de faire venir le second; il lui dit: 'Race de Canaan et non de Juda! la beauté t'a fait perdre la tête et le désir a perverti ton coeur."
,"57":"Voilà comment vous agissiez avec les filles d'Israël, et par crainte elles se donnaient à vous, mais une fille de Juda n'a pas supporté votre misérable conduite."
,"58":"Eh bien, dis-moi donc sous quel arbre tu les as surpris en train de coucher ensemble.' Il répondit: 'Sous un chêne.'"
,"59":"Daniel lui dit: 'Ton mensonge à toi aussi retombe sur ta tête, l'ange de Dieu est là qui t'attend l'épée à la main pour te couper par le milieu et te faire périr.'"
,"60":"Alors toute l'assemblée cria d'une voix forte: ils bénirent Dieu parce qu'il sauve ceux qui espèrent en lui."
,"61":"Puis ils se retournèrent contre les deux anciens que Daniel avait convaincus de faux témoignage par leurs propres paroles; on leur infligea le châtiment que, dans leur méchanceté, ils avaient projeté contre leur prochain."
,"62":"On appliqua la loi de Moïse: ils furent mis à mort et, ce jour-là, le sang innocent fut sauvé."
,"63":"Helquias et sa femme louèrent Dieu pour leur fille Suzanne, et de même Yoakim, son mari, et toute sa famille, car on n'avait rien trouvé à lui reprocher."
,"64":"A partir de ce jour-là et dans la suite, le peuple respecta Daniel."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Le roi Astyage mourut et Cyrus le Perse hérita du royaume."
,"2":"Daniel mangeait à la table du roi, il était encore plus honoré que ses autres Amis."
,"3":"Il y avait à Babylone une idole nommée Bel; chaque jour on dépensait pour elle douze mesures de fleur de farine, quarante brebis et six petits tonneaux de vin."
,"4":"Le roi aussi l'adorait et chaque jour il allait la vénérer. Mais Daniel adorait son Dieu."
,"5":"Le roi lui dit: 'Pourquoi n'adores-tu pas Bel?' Daniel répondit: 'Parce que je ne vénère pas les idoles faites de main d'homme, mais seulement le Dieu vivant qui a fait le ciel et la terre et qui a pouvoir sur tout être vivant.'"
,"6":"Le roi lui dit: 'Est-ce que Bel n'est pas un dieu vivant? Ne vois-tu pas tout ce qu'il mange et boit chaque jour?'"
,"7":"Daniel répondit en riant: 'Que le roi ne se fasse pas d'illusion, ce dieu est d'argile à l'intérieur et de bronze à l'extérieur, il n'a jamais rien mangé ni bu.'"
,"8":"Très en colère, le roi appela ses prêtres et leur dit: 'Si vous ne me dites pas qui est celui qui mange cette offrande qui me coûte si cher, vous mourrez, mais si vous me montrez que c'est Bel qui la mange, c'est Daniel qui mourra pour avoir blasphémé contre Bel.'"
,"9":"Daniel dit au roi: 'Faisons comme tu l'as dit.',Or il y avait soixante-dix prêtres de Bel, sans compter les femmes et les enfants. "
,"10":"Le roi alla avec Daniel au temple de Bel."
,"11":"Les prêtres de Bel lui dirent: 'Nous allons sortir maintenant, et toi, seigneur, tu placeras les plats et tu apporteras le vin après l'avoir mélangé; puis tu fermeras la porte et tu poseras ton sceau pour que personne ne puisse l'ouvrir. Demain matin tu viendras et, si tout n'a pas été mangé par Bel, nous mourrons; sinon, ce sera Daniel qui aura menti contre nous.'"
,"12":"Ils étaient tranquilles, car ils avaient fait sous la table une entrée dérobée par laquelle ils entraient régulièrement pour manger les offrandes."
,"13":"Ils sortirent donc et le roi fit placer les aliments devant Bel,"
,"14":"mais Daniel commanda à ses serviteurs d'apporter de la cendre et il en répandit partout dans le temple en la seule présence du roi. Puis ils sortirent, on ferma la porte, on posa le cachet du roi, et tout le monde s'en alla."
,"15":"Durant la nuit, les prêtres vinrent, comme ils en avaient l'habitude, avec leurs femmes et leurs enfants; ils mangèrent et burent tout ce qu'il y avait."
,"16":"Dès le petit matin, le roi et Daniel partirent voir."
,"17":"Le roi dit à Daniel: 'Les cachets sont-ils intacts?' Il répondit: 'Absolument, seigneur.'"
,"18":"A peine avait-on ouvert les portes que le roi vit la table et cria d'une voix forte: 'O Bel, tu es grand et l'on ne trouve en toi nul mensonge!'"
,"19":"Daniel se mit à rire et, retenant le roi pour qu'il n'aille pas plus loin, il lui dit: 'Regarde le pavé et remarque ces traces.'"
,"20":"Le roi dit: 'Je vois des traces, des pas d'hommes, de femmes et d'enfants.'"
,"21":"Alors, très en colère, le roi fit arrêter les prêtres, leurs femmes et leurs enfants, et ils lui montrèrent les portes dérobées par lesquelles ils entraient pour manger ce qui était sur la table."
,"22":"Le roi les fit mettre à mort et livra Bel au bon vouloir de Daniel qui détruisit l'idole et son temple."
,"23":"Il y avait également un grand dragon que les Babyloniens vénéraient."
,"24":"Le roi dit à Daniel: 'Tu ne diras pas que celui-ci n'est pas un dieu vivant, adore-le donc.'"
,"25":"Daniel répondit: 'J'adore le Seigneur mon Dieu, car lui seul est un Dieu vivant, mais toi, ô roi, donne-moi la permission et je tuerai le dragon sans épée ni bâton.'"
,"26":"Le roi lui donna la permission."
,"27":"Alors Daniel prit de la poix, de la graisse et des poils, il fit bouillir le tout ensemble et en fit des boulettes qu'il jeta dans la gueule du dragon; le dragon les mangea et creva. Daniel dit alors: 'Regardez ce que vous vénérez!'"
,"28":"En apprenant cela, les Babyloniens furent scandalisés. Révoltés contre le roi ils disaient: 'Le roi s'est fait Juif! Il a détruit Bel, tué le dragon et massacré les prêtres.'"
,"29":"Puis ils montèrent chez le roi et lui dirent: 'Livre-nous Daniel! Sinon nous te tuerons, toi et toute ta famille.'"
,"30":"Devant leur violence, le roi céda et leur livra Daniel."
,"31":"Ils le jetèrent dans la fosse aux lions et il y resta six jours."
,"32":"Dans la fosse il y avait sept lions; chaque jour on leur donnait deux corps et deux brebis, mais pour qu'ils dévorent Daniel on ne leur donna rien."
,"33":"Le prophète Habaquq était alors en Judée; il avait fait cuire une bouillie et broyé des pains dans une terrine, et il allait aux champs pour porter cette nourriture aux moissonneurs."
,"34":"L'ange du Seigneur dit à Habaquq: 'Porte le repas que tu as dans les mains à Babylone, à Daniel qui est dans la fosse aux lions.'"
,"35":"Habaquq répondit: 'Seigneur, je n'ai jamais vu Babylone et je ne connais pas la fosse aux lions.'"
,"36":"Alors l'ange du Seigneur le prit par le sommet de la tête et, l'ayant soulevé par les cheveux, il le déposa à Babylone au dessus de la fosse avec l'agilité d'un esprit."
,"37":"Habaquq cria: 'Daniel, Daniel, prends ce repas que Dieu t'envoie!'"
,"38":"Daniel répondit: 'O Dieu, tu t'es souvenu de moi et tu n'as pas abandonné ceux qui t'aiment!'"
,"39":"Daniel se leva et mangea, et l'ange du Seigneur reposa Habaquq où il l'avait pris."
,"40":"Le septième jour, le roi arriva pour pleurer Daniel; il s'approcha de la fosse et regarda: Daniel était assis!"
,"41":"Alors le roi s'écria d'une voix forte: 'Tu es grand, Seigneur, Dieu de Daniel! Il n'y a pas d'autre Dieu que toi.'"
,"42":"Le roi fit sortir Daniel de la fosse et il fit jeter dedans tous ceux qui avaient cherché sa perte; aussitôt ils furent dévorés sous ses yeux."
}`)

}
func FR_LBDCC_LoadVMEZChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"En la trentième année, le cinquième jour du quatrième mois, alors que j'étais parmi les déportés sur le bord du fleuve Kébar, les cieux s'ouvrirent et je vis des visions de Dieu."
,"2":"Le cinquième jour du mois, en la cinquième année de la déportation du roi Joiakin,"
,"3":"la parole de Yahvé fut adressée au prêtre Ezéquiel fils de Bouzi, au pays des Kaldéens, sur les bords du fleuve Kébar. La main de Yahvé fut sur moi. "
,"4":"Je regardai: un vent de tempête venait du nord. Je vis une grande nuée: là un feu fulgurant s'environnait de lumière, et tout au centre c'était comme du métal incandescent."
,"5":"Au milieu du feu il y avait quatre êtres vivants, tous les quatre semblables."
,"6":"Chacun avait quatre faces et quatre ailes."
,"7":"Leurs jambes étaient droites, avec des sabots comme ceux des boeufs; elles brillaient comme le bronze poli."
,"8":"Sous leurs ailes ils avaient (sur les quatre côtés) des mains d'hommes. Leurs ailes à tous les quatre"
,"9":"se touchaient de l'un à l'autre. Ils n'avaient pas à se tourner dans leur marche: ils allaient droit devant une de leurs faces."
,"10":"Leur face était semblable à celle d'un homme, mais les quatre avaient aussi une face de lion à droite, les quatre avaient une face de taureau à gauche et les quatre avaient une face d'aigle."
,"11":"Leurs ailes étaient déployées vers le haut; chacun avait deux ailes qui rejoignaient celles de ses compagnons et deux ailes qui lui couvraient le corps."
,"12":"Chacun d'eux allait droit devant une de ses faces, ils allaient là où l'esprit les poussait et ne se tournaient pas en marchant."
,"13":"Entre les êtres il y avait comme des charbons ardents: on aurait dit un ballet de torches entre ces êtres; le feu illuminait, et du feu jaillissaient des éclairs."
,"14":"Ces êtres allaient et venaient comme l'éclair."
,"15":"Regardant bien ces êtres, je vis une roue à terre à côté de chacun des quatre."
,"16":"Ces roues scintillaient comme des pierres précieuses; toutes les quatre avaient la même forme. Chaque roue était double: on aurait dit deux roues entrecroisées."
,"17":"De cette façon elles pouvaient avancer dans les quatre directions, elles n'avaient pas à se tourner."
,"18":"Leur jante était de grande taille et d'aspect terrifiant, car les quatre avaient des yeux tout autour."
,"19":"Lorsque les êtres avançaient, les roues avançaient à côté d'eux, lorsque les êtres s'élevaient de terre, les roues aussi s'élevaient."
,"20":"Les êtres allaient là où l'Esprit voulait, et les roues y allaient aussi, car l'esprit qui était dans l'être était aussi dans les roues."
,"21":"Quand ils avançaient, elles avançaient; quand ils s'arrêtaient, elles s'arrêtaient; quand ils s'élevaient de terre, les roues s'élevaient également, car l'esprit de l'être était aussi celui des roues."
,"22":"Par-dessus les êtres on voyait comme une plate-forme de cristal resplendissant;"
,"23":"sous la plate-forme leurs ailes se dressaient parallèles l'une à l'autre."
,"24":"J'entendis alors le bruit de leurs ailes, comme le bruit des grandes eaux, comme la voix du Dieu Tout-Puissant. Lorsqu'ils marchaient, c'était un bruit de tempête, comme le vacarme d'une foule; lorsqu'ils s'arrêtaient, ils repliaient leurs ailes."
,"25":"J'entendis un bruit au-dessus de la plate-forme qui était par-dessus leur tête."
,"26":"Je vis comme une pierre de saphir en forme de trône, et sur cette forme de trône un être ayant une apparence humaine dans sa partie supérieure."
,"27":"Je le vis comme entouré de métal incandescent, plongé dans le feu, et depuis ce qui était comme ses reins et au-dessous, ce n'était que du feu qui projetait de la lumière."
,"28":"La lumière qui l'entourait avait l'aspect de l'arc qu'on voit dans les nuages aux jours de pluie. Cette vision était une image de la Gloire de Yahvé, quand je la vis je tombai la face contre terre; j'entendis alors une voix qui me parlait."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Il me dit: 'Fils d'homme, tiens-toi de=bout, je te parlerai.'"
,"2":"Au moment même où il me parle, un esprit entre en moi et me fait tenir debout; alors je l'entends me dire:"
,"3":"'Fils d'homme, je t'envoie vers les Israélites, vers un peuple de rebelles qui se sont révoltés contre moi; eux et leurs pères m'ont été infidèles jusqu'à ce jour."
,"4":"Je t'envoie vers cette race de têtes dures et de coeurs obstinés pour que tu leur dises: Voici la parole de Yahvé...!"
,"5":"Ils t'écouteront ou ne t'écouteront pas - car c'est une race de rebelles - mais ils sauront qu'il y a un prophète au milieu d'eux."
,"6":"Et toi, fils d'homme, ne les crains pas, ne crains pas leurs menaces; ils seront pour toi comme des ronces ou des orties, comme un scorpion là où tu t'es assis. N'aie pas peur de leurs paroles, ne crains pas devant eux: ils ne sont qu'une race de rebelles."
,"7":"Tu leur diras mes paroles, qu'ils t'écoutent ou ne t'écoutent pas, car ils sont une race de rebelles."
,"8":"Maintenant, fils d'homme, écoute ce que je vais te dire, ne te rebelle pas comme cette race de rebelles, mais ouvre la bouche et mange ce que je te donne."
,"9":"Je regardai: une main se tendit vers moi qui tenait le rouleau d'un livre."
,"10":"Il le déroula devant moi; c'était écrit sur l'endroit et sur l'envers, et ce n'étaient que chants funèbres, lamentations et gémissements."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Il me dit: 'Fils d'homme, mange ce que je te présente, mange-le, puis va parler à la maison d'Israël.'"
,"2":"J'ouvris la bouche et il me fit manger ce rouleau."
,"3":"Il me dit encore: 'Fils d'homme, mange et remplis ton ventre avec ce rouleau que je te donne.' Je le mangeai donc, et dans ma bouche il était doux comme du miel."
,"4":"Il me dit: 'Fils d'homme, va vers la maison d'Israël et dis-leur mes paroles."
,"5":"Tu n'es pas envoyé vers un peuple étranger dont la langue te serait difficile, mais vers la maison d'Israël."
,"6":"Si je t'envoyais vers des foules étrangères au parler obscur et à la langue difficile, dont tu ne comprends pas le langage, ils pourraient bien t'écouter."
,"7":"Mais la maison d'Israël ne voudra pas t'écouter, car elle ne veut pas m'écouter; ils ont tous la tête dure et le coeur obstiné."
,"8":"Aussi ai-je rendu ta face aussi dure que la leur, et ton front aussi dur que leur front."
,"9":"Je fais de ton front un diamant, plus dur que le rocher: tu ne les craindras pas, tu n'auras pas peur d'eux, car ils ne sont qu'une race de rebelles.'"
,"10":"Il me dit: 'Fils d'homme, reçois dans ton coeur, écoute de tes oreilles, toutes mes paroles que je vais te dire;"
,"11":"puis va, rends-toi chez les déportés, chez les gens de ton peuple. Tu leur parleras et tu leur diras: Ainsi parle Yahvé...! qu'ils écoutent ou n'écoutent pas.'"
,"12":"Alors l'esprit m'enleva tandis que j'entendais derrière moi une acclamation formidable: 'Bénie soit la Gloire de Yahvé, de son Lieu Saint elle rayonne!'"
,"13":"J'entendis les ailes des êtres qui battaient l'une contre l'autre, j'entendis aussi le bruit des roues: ce fut un énorme vacarme."
,"14":"L'esprit m'avait enlevé, il m'avait emporté. Je restai plein d'amertume, l'esprit fiévreux, car la main de Yahvé pesait fortement sur moi."
,"15":"Lorsque j'arrivai à Tel-Aviv, chez les déportés installés sur les bords du fleuve Kébar, je restai sept jours comme hébété au milieu d'eux."
,"16":"Au bout de sept jours une parole de Yahvé me fut adressée:"
,"17":"'Fils d'homme, je t'ai placé comme un guetteur pour la maison d'Israël: si tu entends une parole qui sort de ma bouche, aussitôt tu les avertiras de ma part."
,"18":"Si je dis au méchant: Tu vas mourir! et si toi tu ne l'avertis pas, si tu ne parles pas de façon que ce méchant revienne de sa mauvaise conduite et ainsi sauve sa vie, ce méchant mourra à cause de sa faute, mais je te demanderai compte de son sang."
,"19":"Par contre, si tu avertis le méchant et qu'il ne veut pas renoncer à sa méchanceté et à sa mauvaise conduite, lui mourra à cause de sa faute, mais toi tu auras sauvé ta vie."
,"20":"Si le juste cesse de faire le bien et commet l'injustice, je mettrai une pierre devant lui pour le faire tomber et il mourra. Si tu ne l'as pas averti, il mourra à cause de son péché, on oubliera les bonnes actions qu'il avait faites, mais à toi je te demanderai compte de son sang."
,"21":"Par contre, si tu avertis le juste pour qu'il ne pèche pas et qu'il reste sans pécher, il vivra grâce à ton avertissement, et toi tu auras sauvé ta vie."
,"22":"La main de Yahvé fut sur moi et il me dit: 'Lève-toi, sors vers la vallée; là je te parlerai.'"
,"23":"Alors je me lève et je sors vers la vallée. Là je vois la Gloire de Yahvé: elle se tient là, tout comme lorsque j'ai vu la Gloire sur les bords du fleuve Kébar. Aussitôt je tombe sur ma face."
,"24":"Voici que l'esprit entre en moi et me fait tenir sur mes jambes; et Lui me parle et me dit: 'Va, enferme-toi dans ta maison."
,"25":"Regarde, fils d'homme, comme on te met des liens, on te ligote; tu ne pourras plus sortir pour partager avec eux."
,"26":"Je fais que ta langue se colle à ton palais: te voilà muet et tu cesses de leur faire des reproches parce qu'ils sont une race de rebelles."
,"27":"Mais plus tard je te parlerai, je t'ouvrirai la bouche et tu leur diras: Voici ce que dit Yahvé! écoute celui qui veut écouter, et celui qui ne veut pas, qu'il n'écoute pas, puisque c'est une race de rebelles."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Prends donc une brique, fils d'homme, et pose-la devant toi; tu y dessineras une ville: Jérusalem."
,"2":"Ensuite tu en feras le siège, tu construiras une tour d'attaque, tu feras des terrassements, tu établiras contre elle des camps et tu disposeras tout autour d'elle des machines de siège."
,"3":"Tu prendras alors une poêle de fer que tu placeras comme une muraille de fer entre toi et la ville, et tu resteras à la surveiller; tu en feras le siège et elle sera assiégée. Ce sera un signe pour la maison d'Israël."
,"4":"Couche-toi sur le côté gauche et prends sur toi la faute de la maison d'Israël; tu porteras leur faute autant de jours que tu resteras ainsi couché."
,"5":"Je t'ai fait un compte de jours qui correspond aux années de leurs péchés; tu porteras le péché de la maison d'Israël pendant 190 jours. "
,"6":"Lorsque ces jours seront achevés, tu te coucheras sur ton côté droit et cette fois tu porteras le péché de la maison de Juda; ce seront"
,"40":"jours, je t'ai compté un jour par année."
,"7":"Tu tourneras ton regard et ton bras nu vers Jérusalem assiégée et tu prophétiseras contre elle."
,"8":"Vois que je mets sur toi des cordes afin que tu ne puisses pas te tourner d'un côté ou de l'autre aussi longtemps que dureront les jours de ton siège."
,"9":"Prends du blé, de l'orge, des fèves, des lentilles, du millet et du seigle, et mets-les dans un vase; tu vas t'en faire du pain en tenant compte du nombre de jours où tu seras couché sur ton côté. Tu en mangeras pendant 190 jours."
,"10":"Pour ta ration journalière tu en pèseras vingt sicles; tu le mangeras en plusieurs fois."
,"11":"Tu boiras de même ton eau rationnée, un sixième de mesure en plusieurs fois."
,"12":"Tu le prépareras comme on prépare des galettes d'orge et tu le feras cuire sous leurs yeux sur un feu d'excréments humains desséchés."
,"13":"Car de la même façon, me dit-il, les enfants d'Israël mangeront un pain impur au milieu des nations où je les disperserai.'"
,"14":"Je dis: 'Ah, Seigneur Yahvé, regarde, je ne me suis jamais souillé. Je n'ai pas mangé de bêtes mortes ou déchirées depuis ma jeunesse jusqu'à présent, aucune viande impure n'est entrée dans ma bouche.'"
,"15":"Alors il me dit: 'Je t'accorde des excréments d'animaux desséchés au lieu d'excréments humains pour le feu où tu cuis ton pain.'"
,"16":"Il me dit encore: 'Vois donc, fils d'homme, je laisse Jérusalem sans pain. Ils mangeront dans l'angoisse un pain qui leur sera compté, et ils boiront dans la crainte une eau qui leur sera rationnée."
,"17":"Par manque de pain et d'eau ils s'affaibliront, ils dépériront ensemble à cause de leurs péchés."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Prends donc une lame tranchante, fils d'homme, affûte-la comme un rasoir de barbier et fais-la passer sur ta tête et sur ta barbe. Ensuite, prends une balance et partage les poils que tu auras coupés."
,"2":"Tu en brûleras un tiers au milieu de la ville assiégée. Tu prendras un autre tiers que tu frapperas de l'épée autour de la ville, et tu jetteras au vent le dernier tiers; moi, je lâcherai l'épée derrière eux."
,"3":"Tu en mettras de côté quelques-uns que tu cacheras dans les plis de ton manteau;"
,"4":"de ceux-là tu en prendras encore pour les jeter au feu et les brûler. Alors tu diras à toute la maison d'Israël: "
,"5":"'Voici ce que dit Yahvé: Vous avez là Jérusalem! Je l'avais placée au milieu des nations, les pays étrangers restaient sur les bords."
,"6":"Mais dans sa méchanceté, elle a rejeté mes commandements plus que les autres nations, et mes lois plus que les pays qui l'entourent: ces gens ont rejeté mes commandements et n'ont pas marché selon mes lois."
,"7":"C'est pourquoi, voici ce que dit Yahvé: Vous avez été plus rebelles que les nations qui vous entourent, et vous n'avez pas marché selon mes lois; vous n'avez pas observé mes commandements, mais au contraire vous avez agi comme les nations qui vous entourent."
,"8":"A cause de cela Yahvé vous dit: Moi à mon tour je m'en prends à toi; j'accomplirai au milieu de toi sous les yeux des nations ce que j'ai décidé."
,"9":"A cause de tous tes crimes je te ferai ce que je n'ai jamais fait et que je ne ferai jamais plus."
,"10":"On verra chez toi des pères manger leurs fils et des fils dévorer leur père. J'accomplirai ce que j'ai décidé contre toi et je disperserai à tous vents ce qui restera de toi."
,"11":"Je le jure par ma vie, dit Yahvé, parce que tu as souillé mon Sanctuaire avec toutes tes ordures et tes horreurs, moi à mon tour je ferai place nette et mon oeil sera sans pitié, je serai sans miséricorde."
,"12":"Un tiers de tes habitants mourra par la peste ou sera consumé par la faim dans tes murs; un tiers sera frappé par l'épée tout autour de toi, je disperserai les autres à tous les vents et je lâcherai l'épée derrière eux."
,"13":"Ma colère se déchaînera avec fureur et, quand ma colère se déchaînera, ils sauront quelle indignation me faisait parler, moi Yahvé."
,"14":"Je ferai de toi une ruine au milieu des nations qui t'entourent et un objet de moquerie pour tous les passants."
,"15":"Tu deviendras un objet de raillerie et de moquerie pour les nations qui t'entourent, lorsque je te corrigerai sans pitié et je te ferai comme je l'ai dit. Moi, Yahvé, j'ai parlé."
,"16":"J'enverrai contre vous les flèches redoutables de la faim pour vous exterminer, je vous laisserai sans pain."
,"17":"J'enverrai contre toi famine et bêtes féroces pour te priver de tes enfants; tu connaîtras la peste et le sang répandu, car je ferai venir l'épée contre toi. Moi, Yahvé, j'ai parlé."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Une parole de Yahvé me fut adressée:"
,"2":"'Fils d'homme, tourne ton regard vers les montagnes d'Israël et prophétise contre elles."
,"3":"Tu diras: Montagnes d'Israël, écoutez la parole de Yahvé. Voici ce que dit Yahvé aux montagnes et aux collines, aux ravins et aux vallées: 'Je fais venir contre vous l'épée, je vais détruire vos Hauts-Lieux. "
,"4":"Vos autels seront abattus, vos autels à parfum seront brisés. Je ferai que vos habitants soient massacrés devant vos idoles."
,"5":"Je disperserai vos ossements autour de vos autels."
,"6":"Partout où vous habitez, les villes seront dévastées et les Hauts-Lieux abattus; vos autels seront abandonnés, vos idoles brisées, vos autels à parfum renversés."
,"7":"Vos habitants seront massacrés au milieu de vous et vous saurez que je suis Yahvé."
,"8":"Quelques uns, cependant échapperont à l'épée, je vous laisserai un reste parmi les nations lorsque je vous aurai dispersés au milieu d'elles."
,"9":"Les survivants se souviendront de moi au milieu des nations où je veux qu'ils soient prisonniers; je briserai leur coeur adultère qui s'est détourné de moi, et leurs yeux adultères qui regardaient vers les idoles, ils auront honte d'eux-mêmes pour tout le mal qu'ils ont fait et les horreurs qu'ils ont commises."
,"10":"Alors ils sauront que je suis Yahvé."
,"11":"Voici ce que dit Yahvé: Frappe dans ta main, tape du pied et dis: Bien fait! Quand tu verras la maison d'Israël tomber sous l'épée, la famine et la peste, tu te rappelleras toutes ses sales ordures."
,"12":"Celui qui sera au loin mourra par la peste, celui qui sera près tombera sous l'épée, le survivant mourra de faim: ma colère se déchargera jusqu'au bout."
,"13":"Vous saurez que je suis Yahvé quand les morts seront couchés au milieu de leurs idoles, près de leurs autels, sur toutes les collines élevées, sous tout arbre vert et sous tout chêne feuillu, partout où ils ont offert à leurs ordures la bonne odeur de l'encens."
,"14":"Je les frapperai d'un grand coup, je ferai de leur pays une solitude, une ruine partout où ils habitent, depuis le désert jusqu'à Ribla. Alors ils sauront que je suis Yahvé."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Une parole de Yahvé me fut adressée:"
,"2":"Fils d'homme, ainsi parle Yahvé à la terre d'Israël: Voici la fin! La fin est là aux quatre coins du pays! "
,"3":"C'est maintenant la fin pour toi. Je vais déchaîner ma colère contre toi, je te jugerai selon ta conduite et je ferai retomber sur toi tous tes crimes."
,"4":"Mon oeil ne t'épargnera pas, je serai sans pitié. Oui, je ferai retomber ta conduite sur toi, et te rappellerai tous tes crimes; alors vous saurez que je suis Yahvé."
,"5":"Voici ce que dit Yahvé: Le malheur arrive, un malheur unique."
,"6":"Voici la fin, la fin arrive, elle se montre, elle est là."
,"7":"Voici ton tour, habitant du pays, le temps est venu, le jour est proche; il ne manquera pas, il ne tardera pas."
,"8":"Je vais faire déborder ma colère sur toi; ma colère va se décharger sur toi et je te jugerai selon ta conduite. Je te ferai payer tous tes crimes."
,"9":"Mon oeil ne t'épargnera pas; je serai sans pitié, je te ferai payer ta conduite et je rappellerai tes crimes; alors vous saurez que c'est moi, Yahvé, qui frappe."
,"10":"Voici le jour! L'insolence a fleuri, l'orgueil s'est épanoui,"
,"11":"la violence règne, elle frappe méchamment."
,"12":"Le temps est venu, le jour est arrivé! Que l'acheteur ne se réjouisse pas, que le vendeur n'aie pas de regrets,"
,"13":"car le vendeur, même s'il reste en vie, ne retrouvera pas sa marchandise. Chacun vit dans ses injustices, où trouvera-t-on des forces?"
,"14":"On sonnera de la trompette, on fera des préparatifs, mais personne ne partira au combat."
,"15":"L'épée attend celui qui ira au-dehors. Celui qui est dans la campagne mourra par l'épée, celui qui est dans la ville sera la proie de la famine et de la peste."
,"16":"Ceux qui échappent erreront dans la montagne comme des colombes effrayées; ils mourront tous, chacun à cause de son péché."
,"17":"Toutes les mains seront accablées et tous les genoux ébranlés."
,"18":"Ils s'habilleront de sacs et seront saisis d'angoisse; la honte se lira sur tous les visages et toutes les têtes seront tondues."
,"19":"Ils laisseront leur argent dans les rues, ils jetteront leur or aux ordures. Ce n'est pas cela qui calmera leur faim ou qui remplira leur ventre: tout cela n'a fait que les mener au mal."
,"20":"Leur 'Joyau', qui faisait leur orgueil, ils y mettaient leurs misérables idoles, c'est pourquoi je leur en ferai un fumier."
,"21":"Je le livrerai aux mains des étrangers, il sera pillé, il deviendra le butin des méchants de la terre, qui le profaneront."
,"22":"Je détournerai d'eux mon regard, on profanera mon trésor; des voleurs y entreront et le profaneront."
,"23":"Ils y feront un massacre, car le pays est couvert de sang,et la ville, remplie de violences."
,"24":"Je ferai disparaître l'orgueil des violents,et leurs sanctuaires seront profanés."
,"25":"L'angoisse est là, ils cherchent la paix mais elle ne viendra pas."
,"26":"Malheur sur malheur, rumeur après rumeur; les prophètes n'ont plus de visions, les prêtres, plus rien à dire, les anciens ne savent plus que conseiller."
,"27":"Le roi sera en deuil, accablé d'effroi, les notables ont les mains qui tremblent; je les traiterai selon leur conduite, ils auront la sentence qu'ils méritent,et ils sauront que je suis Yahvé."
}`)
	CurrentBook.AddChapter(8, `{
"1":"En la sixième année, le cinquième jour du sixième mois, j'étais assis dans ma maison et les anciens de Juda étaient assis en face de moi. Alors la main de Yahvé tomba sur moi."
,"2":"Je regardai: c'était une forme humaine; au-dessous de la ceinture elle n'était que feu, et depuis la ceinture vers le haut, elle était comme un métal incandescent."
,"3":"Il étendit ce qui pouvait être une main et me saisit par les cheveux: aussitôt l'Esprit m'enleva entre terre et ciel. Il me conduisit à Jérusalem dans une vision divine, jusqu'à l'entrée de la porte qui regarde vers le nord, là où est l'idole qui provoque la jalousie du Seigneur."
,"4":"Là se tenait la Gloire du Dieu d'Israël, telle que je l'avais vue en vision dans la vallée."
,"5":"Il me dit: 'Fils d'homme, regarde donc vers le nord.' Je regardai vers le nord, et cette idole de la jalousie était là au nord de l'entrée vers l'autel."
,"6":"Il me dit: 'Fils d'homme, as-tu vu toutes les horreurs que la maison d'Israël commet ici pour me mettre à la porte de mon Sanctuaire? Mais tu verras pire encore.'"
,"7":"Il me conduit alors vers la porte de la cour"
,"8":"et il me dit: 'Fils d'homme, perce ce mur.' Je perce le mur et j'y fais une porte."
,"9":"Lui me dit: 'Entre et regarde les choses scandaleuses qu'ils font ici.'"
,"10":"J'entre, je regarde et je vois toutes sortes de reptiles et de bêtes impures gravées tout autour sur le mur: toutes les sales idoles de la maison d'Israël."
,"11":"Soixante- dix hommes étaient là, chacun avec son encensoir à la main et la fumée de l'encens s'élevait. C'étaient des anciens d'Israël et je reconnus parmi eux Yazanyas fils de Chafan."
,"12":"Il me dit: 'As-tu vu, fils d'homme, ce que font les anciens d'Israël, chacun dans sa chambre? Ils se disent: Yahvé ne voit rien, Yahvé ne s'occupe pas de la terre.'"
,"13":"Puis il me dit: 'Tu verras encore d'autres choses scandaleuses qu'ils commettent.'"
,"14":"Alors il me conduit vers l'entrée de la porte du Temple de Yahvé qui est au nord, et là je vois des femmes assises en train de pleurer Tammouz."
,"15":"Il me dit: 'As-tu vu, fils d'homme? Tu vas voir des choses encore plus scandaleuses que celles-ci.'"
,"16":"Il me conduit vers la cour intérieure du Temple de Yahvé et, à l'entrée du Temple de Yahvé, entre le vestibule et l'autel, je vois environ vingt-cinq hommes tournant le dos au Temple de Yahvé. Ils sont là, regardant vers l'est et ils se prosternent face au soleil."
,"17":"Alors il me dit: 'As-tu vu, fils d'homme, n'est-ce pas assez pour la maison de Juda de faire ici tant de choses scandaleuses? Vont-ils encore continuer de me mettre en colère? Cette fois ils ont passé la mesure,"
,"18":"et je vais agir avec fureur, je ne les épargnerai pas, mon oeil sera sans pitié."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Il cria de toutes ses forces à mes oreilles: 'Approchez, châtiments de la ville! Que chacun tienne en main son instrument de mort!'"
,"2":"Et voici que six hommes arrivent du côté de la Porte-Haute qui regarde vers le nord: chacun tient en main un instrument de mort, et je vois au milieu d'eux un homme habillé de lin avec une écritoire de scribe à la ceinture. Ils viennent se placer à côté de l'autel de bronze,"
,"3":"et aussitôt la Gloire du Dieu d'Israël, qui jusque-là reposait sur les Chérubins, s'élève en direction de la porte du Temple. Il appelle l'homme habillé de lin qui porte un écritoire de scribe à la ceinture,"
,"4":"et il lui dit: 'Parcours Jérusalem, tu marqueras d'une croix au front les hommes qui se lamentent et qui gémissent sur toutes ces pratiques scandaleuses qui se commettent dans cette ville.'"
,"5":"Puis il dit aux autres, de façon que je l'entende: 'Parcourez la ville derrière lui et frappez. N'épargnez personne, que votre oeil soit sans pitié."
,"6":"Vieillards, jeunes gens, jeunes filles, enfants et femmes, tuez-les tous jusqu'à extermination. Mais vous ne toucherez pas à ceux qui ont sur eux la croix. Vous commencerez par mon Sanctuaire.' Ils commencèrent donc par les gens qui se trouvaient là devant le Temple."
,"7":"Il leur avait dit, en effet: 'Remplissez les cours de cadavres, le Temple en sera souillé; ensuite vous sortirez et vous frapperez dans la ville.'"
,"8":"Pendant qu'ils frappaient ainsi je tombai la face contre terre, je criais et lui disais: 'Ah! Yahvé, vas-tu donc répandre ta fureur sur Jérusalem et détruire ce qui reste d'Israël?'"
,"9":"Il me répondit: 'La faute de la maison d'Israël et de Juda est trop grande, elle est sans mesure; le pays est rempli de sang et la ville est pleine d'injustice. Ils se disent: Yahvé ne s'occupe pas du pays, Yahvé ne voit rien."
,"10":"Pour cela à mon tour je ne les épargnerai pas, mon oeil sera sans pitié. Je ferai retomber sur leur tête leur propre conduite.'"
,"11":"A ce moment-là, l'homme habillé de lin qui avait une écritoire à la ceinture, vint rendre compte; il déclara: 'J'ai fait tout ce que tu m'avais ordonné.'"
}`)
	CurrentBook.AddChapter(10, `{
"1":"A ce moment-là, je vis que sur la plate-forme, au-dessus des chérubins, il y avait une pierre de saphir qui formait comme un trône."
,"2":"Alors il dit à l'homme habillé de lin: 'Passe en-dessous, entre les roues, et prends à pleines mains des charbons que tu répandras sur la ville.' L'homme y alla sous mes yeux;"
,"3":"pendant qu'il s'y glissait, les chérubins se tenaient à l'arrêt sur le côté sud et la nuée remplissait la cour intérieure."
,"4":"La Gloire de Yahvé s'éleva de dessus le chérubin, en direction de la porte du Temple; la nuée remplissait le Temple et toute la cour était inondée de l'éclat de la gloire de Yahvé."
,"5":"Le bruit des ailes des chérubins s'entendait jusque dans la cour extérieure, on aurait cru la voix du Dieu Tout-Puissant lorsqu'il parle."
,"6":"Il donna cet ordre à l'homme habillé de lin: 'Prends du feu au milieu des roues entre les chérubins'. L'homme s'approcha et se tint près de la roue."
,"7":"Le chérubin étendit la main vers le feu, il en prit et déposa les braises dans la main de l'homme habillé de lin; celui-ci les prit et sortit."
,"8":"J'ai bien vu alors comme une main d'homme sous les ailes des chérubins."
,"9":"J'ai vu quatre roues placées à côté des chérubins (il y avait une roue à côté de chaque chérubin) et les roues avaient l'éclat de la pierre précieuse."
,"10":"Les quatre roues avaient la même forme: on aurait dit que chaque roue était faite de deux roues entrecroisées."
,"11":"Elles pouvaient donc aller sans se tourner vers les quatre points cardinaux, elles allaient sans se tourner dans la même direction où était la face du chérubin."
,"12":"Les jantes des quatre roues étaient remplies d'yeux tout autour."
,"13":"J'entendis alors que l'on donnait à ces roues le nom de 'tourbillon'."
,"16":"Lorsque les chérubins avançaient, les roues avançaient avec eux; lorsque les chérubins déployaient leurs ailes pour s'élever de terre, les roues ne cessaient de les accompagner."
,"17":"Lorsque les chérubins s'arrêtaient, les roues s'arrêtaient, et lorsqu'ils s'élevaient elles s'élevaient avec eux, car l'esprit de l'être vivant était en elles."
,"18":"La Gloire de Yahvé sortit du Temple et s'arrêta au-dessus des chérubins."
,"19":"Sous mes yeux, les chérubins ouvrirent leurs ailes pour s'élever de terre, et ils sortirent accompagnés par les roues; ils s'arrêtèrent à l'entrée de la porte orientale du Temple de Yahvé, avec la gloire du Dieu d'Israël reposant sur eux."
,"20":"C'étaient bien les êtres vivants que j'avais vus au bord du fleuve Kébar portant le Dieu d'Israël; alors j'ai su que c'étaient des chérubins."
,"21":"Chacun avait quatre visages et quatre ailes, et sous leurs ailes ils avaient comme des mains d'homme."
,"22":"Leurs visages étaient les mêmes que j'avais vus près du fleuve Kébar: chacun allait droit dans la direction d'une de ses faces."
}`)
	CurrentBook.AddChapter(11, `{
"1":"L'Esprit m'enleva et me conduisit à la porte orientale du Temple de Yahvé, celle qui regarde vers l'est. A l'entrée de la porte se tenaient vingt-cinq hommes au milieu desquels j'aperçus Yazanya fils d'Azzour et Pélatyas fils de Bénayas, chefs du peuple."
,"2":"Yahvé me dit: 'Fils d'homme, voilà des hommes qui méditent le mal et qui donnent de mauvais conseils à cette ville."
,"3":"Ils disent: Nos maisons ne sont pas près de tomber, nous sommes la viande, et la ville est la marmite qui la conserve."
,"4":"C'est pourquoi, prophétise contre eux, prophétise, fils d'homme!'"
,"5":"A ce moment l'esprit de Yahvé tomba sur moi. Il me dit: 'Redis-leur cette parole de Yahvé: Je sais ce que vous avez dans la tête, maison d'Israël, je sais ce que vous dites."
,"6":"Mais vous avez rempli cette ville de victimes, et les rues de cadavres,"
,"7":"et Yahvé vous dit: Les victimes que vous avez laissées dans la ville sont la viande, et la ville est la marmite. Mais vous, je vous en ferai sortir."
,"8":"Puisque c'est l'épée que vous redoutez, j'amènerai sur vous l'épée - parole de Yahvé."
,"9":"Je vous ferai sortir de la ville et je vous livrerai aux étrangers; c'est ainsi que je ferai justice de vous."
,"10":"Vous serez frappés par l'épée sur les frontières d'Israël; là je vous châtierai et vous saurez que je suis Yahvé."
,"12":"Car je suis Yahvé, et vous n'avez pas obéi à mes commandements, vous n'avez pas suivi mes règles, mais vous vous êtes conduits comme les païens qui vous entourent.'"
,"13":"Comme je prophétisais, Pélatyas fils de Bénayas mourut; je tombai la face contre terre et m'écriai d'une voix forte: 'Ah, Yahvé! Veux-tu donc détruire tout ce qui reste d'Israël?'"
,"14":"Cette parole de Yahvé me fut alors adressée:"
,"15":"'Fils d'homme, tu sais ce que les habitants de Jérusalem disent de tes frères, de tes proches, de toute la race d'Israël: Qu'ils restent là-bas loin de Yahvé, c'est nous qui avons hérité du pays."
,"16":"C'est pourquoi tu vas leur dire cette pa role de Yahvé: Oui, je les ai envoyés au loin parmi les nations, je les ai dispersés dans ces pays, mais je suis pour eux un sanctuaire dans ces pays où ils sont allés."
,"17":"Tu vas donc leur dire cette parole de Yahvé: Je vous rassemblerai d'entre les peuples, je vous réunirai de ces pays où vous avez été dispersés et je vous redonnerai la terre d'Israël."
,"18":"Ils y entreront de nouveau et ils en arracheront toutes les horreurs, toutes les idoles."
,"19":"Je leur donnerai un coeur nouveau et je mettrai au-dedans d'eux un esprit nouveau. J'ôterai de leur chair leur coeur de pierre et je leur donnerai un coeur de chair."
,"20":"Ainsi ils marcheront selon mes commandements, ils observeront mes lois et les mettront en pratique; alors ils seront mon peuple et moi je serai leur Dieu."
,"21":"Mais ceux dont le coeur est attaché à leurs ordures et à leurs horreurs, je leur ferai payer leur con duite, parole de Yahvé.'"
,"22":"A ce moment les chérubins déployèrent leurs ailes et les roues allèrent avec eux; la Gloire du Dieu d'Israël reposait sur eux."
,"23":"La Gloire de Yahvé se leva du milieu de la ville; elle s'éleva et s'arrêta sur la montagne qui est à l'orient de la ville."
,"24":"Alors l'Esprit m'enleva et me ramena en Kaldée auprès des captifs; tout cela se déroula dans une vision, c'était l'oeuvre de l'Esprit de Dieu. Et puis cette vision que j'avais eue s'éloigna de moi"
,"25":"et je pus raconter aux exilés tout ce que Yahvé m'avait montré."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Cette parole de Yahvé me fut adressée:"
,"2":"'Fils d'homme, tu habites au milieu d'une bande de rebelles; ils ont des yeux pour voir et ne voient pas, des oreilles pour entendre et n'entendent pas. C'est vraiment une bande de rebelles."
,"3":"Prépare-toi donc, fils d'homme, un bagage d'exilé, en plein jour et sous leurs yeux. Tu quitteras le lieu où tu te trouves pour un autre endroit; peut-être reconnaîtront-ils alors qu'ils sont une bande de rebelles."
,"4":"Tu prépareras tes affaires en plein jour, comme fait un exilé, et le soir tu sortiras, comme sortent les exilés."
,"5":"Devant eux tu feras un trou dans le mur, par où tu sortiras."
,"6":"Tu chargeras ton ballot sur l'épaule et tu sortiras devant eux dans l'obscurité; tu te couvriras le visage pour ne pas voir le pays, car j'ai fait de toi un signe pour la maison d'Israël."
,"7":"J'ai donc exécuté l'ordre que j'avais reçu. J'ai préparé durant le jour mes affaires, comme un bagage d'exilé, et le soir j'ai percé avec la main un trou dans le mur, puis je suis sorti de nuit devant eux après avoir chargé mon sac sur l'épaule."
,"8":"Au matin une parole de Yahvé m'a été adressée:"
,"9":"'Fils d'homme, ces gens d'Israël, cette bande de rebelles, ne t'ont pas demandé ce que tu faisais là?"
,"10":"Eh bien, tu leur diras de la part de Yahvé: Ainsi feront le prince qui est à Jérusalem et tous les Israélites qui y demeurent."
,"11":"Tu vas dire à leur intention: Je suis pour vous un signe; il vous sera fait comme j'ai fait. Vous partirez en déportation, en exil!"
,"12":"Le prince qui est au milieu de vous chargera son bagage sur son épaule dans l'obscurité et sortira par le trou qu'on aura percé pour le faire sortir; il aura le visage couvert, de sorte qu'il ne verra pas le pays."
,"13":"Mais j'étendrai mon filet sur lui, et dans mon filet il sera pris; je le conduirai à Babylone, au pays des Kaldéens. Il y mourra, mais il ne le verra pas."
,"14":"Je disperserai à tous les vents ceux qui l'entourent, toute sa troupe, et je les poursuivrai avec l'épée."
,"15":"Ils sauront que je suis Yahvé lorsque je les aurai semés parmi les nations, dispersés dans ces pays."
,"16":"Cependant j'épargnerai quelques uns d'entre eux qui échapperont à l'épée, à la famine et à la peste, et alors ils pourront confesser au milieu des nations où ils iront toutes les horreurs qu'ils ont commises; alors ils sauront que je suis Yahvé.'"
,"17":"Cette parole de Yahvé me fut encore adressée:"
,"18":"'Fils d'homme, tu vas manger ton pain en tremblant et boire ton eau comme angoissé et accablé."
,"19":"Et puis tu diras à l'intention des messieurs de Jérusalem: Cette parole de Yahvé est destinée aux habitants de Jérusalem, à tous ceux qui sont encore sur la terre d'Israël: Ils mangeront leur pain dans l'angoisse, ils boiront leur eau dans la tristesse, leur pays sera désolé, privé de ses richesses à cause de la violence de ses habitants."
,"20":"Les villes habitées seront réduites en ruines et le pays deviendra un désert; alors vous saurez que je suis Yahvé.'"
,"21":"Cette parole de Dieu me fut adressée:"
,"22":"'Fils d'homme, qu'est-ce qu'on entend répéter chez vous en terre d'Israël: 'Le délai s'allonge, la vision ne valait rien'?"
,"23":"Tu vas leur dire, toi, cette parole de Yahvé: Je ferai mentir ce proverbe et on ne le répétera plus en Israël. Et tu ajouteras: Les jours viennent où toute vision s'accomplira."
,"24":"Oui, pour la maison d'Israël il n'y aura aucune vision ou signe sans résultat."
,"25":"Car moi, Yahvé, je dis ce que j'ai à dire et mes paroles s'accomplissent. Il n'y aura plus de délai, car c'est de vos jours, bande de rebelles, que je vais parler et réaliser - parole de Yahvé.'"
,"26":"Cette parole de Yahvé me fut adressée:"
,"27":"'Fils d'homme, les gens d'Israël disent: Encore une vision qui n'est pas pour aujourd'hui, il prophétise pour un avenir lointain."
,"28":"Mais toi tu vas leur dire cette parole de Yahvé: Aucune de mes paroles ne tardera plus à s'accomplir; ce que je dis se fera - parole de Yahvé.'"
}`)
	CurrentBook.AddChapter(13, `{
"1":"Cette parole de Yahvé me fut adressée:"
,"2":"'Fils d'homme, prophétise contre les prophètes d'Israël, prophétise et dis-leur: Ecoutez cette parole de Yahvé.'"
,"3":"Oui, voici ce que dit Yahvé: Malheur aux prophètes irresponsables, qui suivent leur imagination mais qui n'ont pas eu de vision!"
,"4":"Tes prophètes, Israël, sont comme des renards dans les ruines."
,"5":"Vous n'êtes pas montés sur la brèche, vous n'avez pas construit de remparts autour de la maison d'Israël pour qu'elle soutienne le choc au jour de Yahvé."
,"6":"Vous dites: Parole de Yahvé! mais ce sont des visions fausses, des prédictions mensongères. Yahvé ne les a pas envoyés: veulent-ils que lui réalise leurs promesses?"
,"7":"Quand vous dites: Parole de Yahvé! alors que moi je n'ai rien dit, n'est-ce pas une vision fausse, une prophétie mensongère?"
,"8":"C'est pourquoi, voici ce que dit Yahvé: Je vais m'en prendre à vous à cause de vos paroles creuses et de vos visions de mensonge - parole de Yahvé."
,"9":"Je frapperai les prophètes aux visions fausses, aux promesses mensongères; ils ne seront plus admis dans le conseil de mon peuple, ils ne seront plus inscrits dans le livre de famille d'Israël, ils n'entreront pas dans la terre d'Israël: alors ils sauront que je suis Yahvé."
,"10":"Ces prophètes égarent mon peuple, ils disent 'Paix!' alors qu'il n'y a pas de paix; mon peuple se construit un rempart et ils y mettent le crépi."
,"11":"Dis à ceux qui mettent le crépi: Voici venir la pluie torrentielle, la chute de grêle et le vent de tempête:"
,"12":"le mur est tombé! Alors on vous dira: Où est le crépi que vous aviez étalé sur ce mur?"
,"13":"Voici ce que dit Yahvé: Ma colère déchaîne un vent de tempête, ma fureur envoie la pluie torrentielle, ma rage jette les grêlons de la destruction."
,"14":"J'abats le mur que vous avez couvert de crépi, je le mets au niveau du sol et ses fondations sont mises à nu; voici qu'il tombe sur vous et vous écrase! Alors vous saurez que je suis Yahvé."
,"15":"Quand ma colère se sera déchaînée contre le mur et ceux qui le crépissaient, on vous demandera: Où est donc le mur, où sont ceux qui le crépissaient?"
,"16":"Où sont ces prophètes d'Israël qui prophétisaient sur Jérusalem, et qui voyaient pour elle des visions de paix quand il n'y avait pas de paix? -parole de Yahvé-."
,"17":"Tourne-toi, fils d'homme, vers les filles de ton peuple qui prophétisent pour leur propre compte; oui, prophétise contre elles."
,"18":"Tu leur diras cette parole de Yahvé: Malheur à celles qui cousent des bandelettes magiques pour tous les poignets et tissent des voiles pour les têtes de toute taille! Elles ne font que prendre au piège les âmes. Vous qui prenez au piège les âmes de mon peuple, croyez-vous que vous sauverez vos propres vies?"
,"19":"Pour une poignée d'orge et un morceau de pain vous me discréditez auprès de mon peuple; vous faites mourir ceux qui ne doivent pas mourir et vous laissez vivre ceux qui ne doivent pas vivre, vous trompez mon peuple et mon peuple écoute le mensonge."
,"20":"Eh bien, voici ce que dit Yahvé: Je déteste ces bandelettes avec lesquelles vous prenez au piège les âmes; je les déchirerai sur vos bras et je délivrerai les vies que vous voulez prendre au piège."
,"21":"Je déchirerai vos voiles et j'arracherai mon peuple de vos mains pour qu'il ne soit plus une proie entre vos mains; ainsi vous saurez que je suis Yahvé."
,"22":"Vous avez abattu l'homme juste avec vos mensonges, alors que moi je ne voulais pas le décourager. Vous avez encouragé le méchant et il n'a pas renoncé à sa mauvaise conduite pour retrouver la vie."
,"23":"C'est pourquoi vous n'aurez plus de fausses visions et vous ne prononcerez plus de prophéties, mais je délivrerai mon peuple de vos mains et vous saurez que je suis Yahvé."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Quelques anciens d'Israël sont venus chez moi et se sont assis près de moi."
,"2":"Alors une parole de Yahvé m'a été adressée:"
,"3":"'Fils d'homme, ces hommes ont leurs idoles enracinées en leur coeur; ils sont attachés à ce qui les fait pécher. Vais-je permettre qu'ils me consultent?"
,"4":"Tu vas leur dire cette parole de Yahvé: Si quelqu'un en Israël porte en lui ses idoles et s'accroche à ce qui le fait pécher, il peut bien aller trouver le prophète: moi Yahvé je lui donnerai une réponse à la mesure de ses sales idoles."
,"5":"Je veux regagner le coeur de la maison d'Israël qui s'est éloignée de moi avec toutes ses ordures."
,"6":"Tu diras donc à la maison d'Israël cette parole de Yahvé: Revenez vers moi, détournez-vous de vos idoles et renoncez à tous vos crimes."
,"7":"Moi, Yahvé, je répondrai personnellement à tout Israélite, comme à tout étranger qui habite en Israël, qui vit éloigné de moi, qui ne pense qu'à ses sales idoles qui l'amènent à pécher, et qui ensuite va trouver le prophète pour me consulter."
,"8":"Je m'en prendrai à lui et je ferai de lui un exemple que l'on ne sera pas près d'oublier; je le retrancherai de mon peuple et vous saurez que je suis Yahvé."
,"9":"Si le prophète se laisse entraîner par une telle personne et lui donne de ma part une réponse, c'est que moi, Yahvé, j'aurai cherché sa perte. Je frapperai ce prophète et je le retrancherai du milieu de mon peuple Israël."
,"10":"Tous les deux porteront le poids de leur faute, celui qui consulte et le prophète qu'il aura consulté."
,"11":"Ainsi la maison d'Israël ne s'égarera plus loin de moi. Ils cesseront de se souiller avec leurs fautes, ils seront mon peuple et je serai leur Dieu - parole de Yahvé.'"
,"12":"Cette parole de Yahvé me fut adressée:"
,"13":"'Fils d'homme, imagine un pays qui pèche contre moi: il est infidèle et je le frappe; je le laisse sans pain, j'envoie la famine pour y éliminer bêtes et gens."
,"14":"Imagine que dans ce pays se trouvent ces trois hommes: Noé, Daniel et Job. Eh bien je le dis, ces hommes sauveraient leur vie à cause de leur justice - parole de Yahvé."
,"15":"Imagine que je lâche les bêtes féroces dans ce pays pour le priver de ses enfants et en faire un désert que nul ne pourra traverser à cause des animaux sauvages;"
,"16":"mais dans ce pays se trouvent ces trois hommes. Par ma vie, dit Yahvé, ils ne pourraient sauver ni fils ni fille, mais eux, même seuls, seraient sauvés tandis que le pays deviendrait un désert."
,"17":"Imagine que je fasse venir l'épée contre ce pays et que je dise: Que l'épée ravage ce pays et y frappe bêtes et gens!"
,"18":"Mais ces trois hommes sont dans le pays. Par ma vie, dit Yahvé, ils ne pourraient sauver ni fils ni fille, mais eux, même seuls, seraient sauvés."
,"19":"Imagine encore que je cède à une fureur meurtrière et que j'envoie la peste dans ce pays, que j'en retranche bêtes et gens."
,"20":"Si Noé, Daniel et Job étaient dans ce pays, par ma vie, dit Yahvé, ils ne sauveraient ni fils ni fille mais ils sauveraient leur propre vie à cause de leur justice."
,"21":"Voici ce que dit le Seigneur: J'ai envoyé contre Jérusalem mes quatre terribles châtiments: l'épée, la famine, les bêtes féroces et la peste, car je veux supprimer bêtes et gens."
,"22":"Certains pourtant en réchapperont, des fils et des filles qu'on fera sortir et qui arriveront chez vous. Quand vous verrez leur conduite et leurs oeuvres,"
,"23":"vous vous consolerez et vous comprendrez que ce n'est pas sans raison que j'ai agi avec Jérusalem comme je l'ai fait - parole de Yahvé."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Cette parole de Yahvé me fut adressée:"
,"2":"'Fils d'homme, le bois de la vigne vaudrait-il mieux que les autres bois, que les branches des arbres de la forêt?"
,"3":"Prend-on du bois de vigne pour en fabriquer un objet? En fait-on une cheville pour y accrocher quelque chose?"
,"4":"Pire encore s'il a été livré au feu: le feu en a dévoré les deux bouts, le milieu est brûlé, peut-on encore le travailler?"
,"5":"Déjà, quand il était entier, on ne pouvait rien en faire, combien plus maintenant qu'il est dévoré et brûlé par le feu."
,"6":"Ecoutez donc ce que dit Yahvé: Je regarde les habitants de Jérusalem comme le bois de la vigne qu'on livre au feu avec les arbres sauvages."
,"7":"Je vais tourner contre eux ma face: ils ont échappé au feu mais le feu les dévorera, et ils sauront que je suis Yahvé lorsque je tour nerai contre eux mon visage."
,"8":"Je ferai du pays un désert car ils ont été infidèles - parole de Yahvé."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Cette parole de Yahvé me fut adressée:"
,"2":"'Fils d'homme, fais-voir à Jérusalem toutes ses horribles actions."
,"3":"Voici une parole de Yahvé que tu rediras à Jérusalem: Tu es née en Canaan et c'est de là que tu es sortie; l'Amorite a été ton père, une Hittite était ta mère."
,"4":"A ta naissance, le jour où tu es venue au monde, ton cordon n'a pas été coupé, tu n'as pas été baignée dans l'eau, on ne t'a pas frottée de sel, on ne t'a pas enveloppée de langes."
,"5":"Personne n'a eu de compassion, nul ne t'a donné des soins, même par pitié; le jour où tu es venue au monde, tu n'intéressais personne et on t'a laissée sur le sol dans la campagne."
,"6":"Je suis alors passé près de toi, je t'ai vue te débattant dans ton sang et je t'ai dit: Vis, toi qui perds ton sang,"
,"7":"et grandis comme une herbe des champs! Alors tu as commencé à grandir, tu t'es développée, tu es devenue une jeune fille, ta poitrine s'est affermie et ta chevelure s'est développée; mais tu étais nue, tu n'avais rien."
,"8":"Alors je suis passé près de toi et je t'ai vue; c'était le temps des amours, j'ai tendu sur toi le pan de mon manteau, j'ai couvert ta nudité et je t'ai prêté serment. J'ai fait une alliance avec toi, parole de Yahvé - et tu es devenue mienne."
,"9":"Je t'ai baignée dans l'eau, je t'ai lavée de ton sang et je t'ai parfumée d'huile."
,"10":"Je t'ai habillée de vêtements brodés, avec des chaussures de cuir fin, j'ai mis sur ta tête un voile de lin et de soie,"
,"11":"je t'ai parée de bijoux, j'ai mis des bracelets à tes poignets, un collier à ton cou,"
,"12":"un anneau à ton nez, des boucles à tes oreilles, et pour ta tête un splendide diadème."
,"13":"Tes bijoux étaient d'or et d'argent, tes vêtements, de lin fin, avec des étoffes précieuses toutes brodées. Tu te nourrissais de fine farine, de miel et d'huile, et tu es devenue magnifique: un jour tu as été reine."
,"14":"Ta beauté est devenue célèbre parmi les nations: c'était une beauté parfaite grâce à ma splendeur que je répandais sur toi - parole de Yahvé."
,"15":"Et puis tu as mis ta confiance dans ta beauté, ta renommée t'a permis de te prostituer; tu as prodigué tes charmes à tout passant et tu es allée avec lui."
,"16":"Tu as pris de tes habits pour décorer les Hauts-Lieux sur lesquels tu te prostituais."
,"17":"Tu as pris tes bijoux d'or et d'argent que je t'avais donnés, tu en as fait des statues, des mâles avec lesquels tu t'es prostituée."
,"18":"Tu les recouvrais de tes vêtements brodés et tu déposais devant elles mon huile et mon encens."
,"19":"Tu leur présentais en offrande d'agréable odeur, le pain que je t'avais donné, la fleur de farine, l'huile, le miel dont je te nourrissais - parole de Yahvé."
,"20":"Tu as même pris tes fils et tes filles que tu m'avais enfantés, tu les leur offrais pour qu'ils les dévorent: cela ne te suffisait donc pas de te débaucher?"
,"21":"Mais non, tu as égorgé mes fils et tu les as livrés en sacrifice,"
,"22":"pour faire mieux encore que de te prostituer, et tu oubliais les jours de ta jeunesse, lorsque tu étais nue et sans vêtements et que tu te débattais dans ton sang."
,"23":"Après toutes tes méchancetés, dit Yahvé,"
,"24":"tu t'es encore construit des estrades sur toutes tes places;"
,"25":"à toutes les entrées de chemin tu élevais un monticule. Tu as profané ta beauté, tu as offert ton corps à tout passant et tu t'es vautrée dans la débauche."
,"26":"Tu t'es prostituée avec les Egyptiens, tes voisins bien charpentés, tu as multiplié tes débauches à plaisir pour m'irriter."
,"27":"Alors j'ai frappé, j'ai diminué ta ration et je t'ai livrée à celles qui te haïssaient, aux Philistines qui rougissaient de ton inconduite."
,"28":"Mais tu n'étais pas encore rassasiée, tu t'es prostituée avec les Assyriens, après quoi tu n'étais pas encore satisfaite."
,"29":"Tu as multiplié tes débauches dans un pays de marchands, en Kaldée, et là encore tu n'étais pas rassasiée."
,"30":"Quelle fureur est la mienne, dit Yahvé, en voyant ta conduite de prostituée insolente!"
,"31":"Lorsque tu élevais ton estrade à toutes les entrées de chemins ou sur les places, tu ne demandais pas de salaire comme fait la prostituée,"
,"32":"tu étais la femme adultère qui cherche des étrangers au lieu de son mari."
,"33":"Aux prostituées on donne un cadeau, mais toi, tu donnais tes cadeaux à tous tes amants; tu les payais pour qu'ils viennent de partout se débaucher avec toi."
,"34":"Tu te prostituais, mais c'était le contraire des autres femmes: per sonne ne courait après toi, c'est toi qui payais et on ne te payait pas. Tu n'étais vraiment pas comme les autres."
,"35":"C'est pourquoi, prostituée, écoute la pa role de Yahvé."
,"36":"Voici ce que dit Yahvé: Parce que tu as étalé ta nudité dans tes prostitutions avec tes amants, avec toutes tes abominables idoles, parce que tu as versé le sang de tes enfants,"
,"37":"moi, à mon tour, je rassemblerai tous ces amants pour lesquels tu t'es enflammée, ceux que tu as aimés comme ceux que tu as détestés. Je les rassemblerai contre toi de toutes parts et je découvrirai devant eux ta nudité: ils te verront privée de tout."
,"38":"Je t'appliquerai la sentence des femmes adultères et des criminelles: je te livrerai à la colère et l'indignation."
,"39":"Je te livrerai entre leurs mains, ils démoliront et abattront tes estrades, ils te dépouilleront de tes habits, ils prendront tes bijoux et te laisseront nue, sans rien."
,"40":"Ils convoqueront contre toi une assemblée, ils te lapideront avec des pierres et te perceront de leurs épées."
,"41":"Ils t'appliqueront ta sentence et te livreront au feu sous les yeux de toutes les autres femmes; je ferai en sorte que tu ne puisses plus te prostituer ni payer des amants."
,"42":"Lorsque ma fureur se sera déchargée, mon indignation prendra fin, je me calmerai et ne me mettrai plus en colère."
,"43":"Mais, parce que tu ne t'es pas souvenue des jours de ta jeunesse et que tu m'as provoqué de mille façons, à mon tour je ferai retomber ta conduite sur ta tête, parole de Yahvé. Tes actions honteuses n'ont-elles pas été suivies de crimes?"
,"44":"Ceux qui aiment les sentences te diront: 'Telle mère, telle fille'."
,"45":"Tu es bien la fille de ta mère qui détestait son mari et ses enfants, tu es bien la soeur de tes soeurs qui détestaient leurs maris et leurs enfants; votre mère était Hittite et votre père Amorite."
,"46":"Ta soeur aînée, c'est Samarie qui habite avec ses filles sur ton côté nord, ta soeur la plus jeune, c'est Sodome qui habite avec ses filles vers le sud."
,"47":"Ce n'est pas à moitié que tu as suivi leurs chemins pour commettre le crime, tu t'es montrée plus dévergondée qu'elles dans toute ta conduite."
,"48":"Par ma vie, dit Yahvé, ta soeur Sodome et ses filles n'ont pas agi comme toi et tes filles."
,"49":"Quelle a été la faute de ta soeur Sodome? Elle était orgueilleuse, elle mangeait bien et vivait insouciante; elle et ses filles n'ont rien fait pour le pauvre et le malheureux."
,"50":"Elles sont devenues arrogantes, elles ont fait ce qui me déplaît; c'est pourquoi je les ai fait disparaître comme tu l'as vu."
,"51":"Quant à Samarie, elle n'a pas commis la moitié de tes péchés: toi, tu as commis tellement d'abominations que tes soeurs paraissent justes à côté de toi."
,"52":"Aussi maintenant porte ta honte puisque tes péchés plus horribles que les leurs les font paraître innocentes. Tu devrais être rouge de honte d'avoir ainsi justifié tes soeurs."
,"53":"Je les rétablirai, je rétablirai Sodome et ses filles, je rétablirai Samarie et ses filles, et ensuite je te rétablirai au milieu d'elles."
,"54":"Et tu seras confuse, tu devras porter ta honte pour tout ce que tu as fait, car cela même leur a rendu courage."
,"55":"Tes soeurs, Sodome et ses filles, Samarie et ses filles, seront rétablies comme autrefois; toi et tes filles, vous serez aussi rétablies comme autrefois."
,"56":"Tu te moquais bien de ta soeur Sodome dans le temps où tu étais fière,"
,"57":"quand on n'avait pas encore découvert ta nudité; mais tu es comme elle maintenant. Les filles d'Edom et leurs voisines rient de toi, les filles des Philistins près de toi te méprisent."
,"58":"Maintenant tu paies tes péchés et tes crimes, parole de Yahvé."
,"59":"Voici ce que dit Yahvé: J'agirai envers toi comme tu as agi toi-même: tu as rompu l'alliance sans plus penser à ton serment."
,"60":"Cependant je me souviendrai de mon alliance avec toi au temps de ta jeunesse et je t'accorderai une alliance éternelle."
,"61":"Tu te souviendras alors de ta conduite et tu en auras honte lorsque tu recevras tes soeurs, les aînées comme les plus jeunes, lorsque je te les donnerai pour filles, sans rien renier de mon alliance avec toi."
,"62":"Car je maintiendrai mon alliance avec toi et tu sauras que je suis Yahvé."
,"63":"Alors tu te souviendras, tu seras couverte de honte et tu n'oseras plus ouvrir la bouche lorsque je te pardonnerai tout ce que tu as fait - parole de Yahvé."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Cette parole de Yahvé me fut adressée:"
,"2":"'Fils d'homme, invente une comparaison pour les gens d'Israël, et fais-les deviner."
,"3":"Tu leur diras: Voici une parole de Yahvé. Le grand aigle aux larges ailes, au long plumage, avec ses plumes de toutes les couleurs, est venu au Liban: il y a enlevé la cime du cèdre. "
,"4":"Il a cueilli la branche la plus haute, il l'a emportée au pays des affaires, dans une ville de commerçants."
,"5":"Puis il a pris un plant dans le pays, il l'a mis dans un champ tout comme un saule, là où l'eau ne manquait pas."
,"6":"Le plant a grandi, il est devenu une vigne, de taille modeste mais fertile, qui tournait ses branches vers l'aigle tandis que ses racines s'enfonçaient. La vigne a poussé et s'est faite arbre, elle a donné branches et sarments."
,"7":"Mais arrive un autre aigle, grand, avec de larges ailes, un plumage fourni, et voici que la vigne dirige vers lui ses racines et ses branches, espérant trouver plus d'eau qu'elle n'en avait sur sa terre."
,"8":"Elle était pourtant plantée dans une bonne terre où l'eau ne manquait pas, elle pouvait étendre ses branches, porter du fruit, devenir une vigne magnifique."
,"9":"Et maintenant Yahvé demande: Va-t-il réussir? L'autre ne va-t-il pas arracher ses racines, couper ses fruits et laisser ses jeunes pousses se dessécher? Il ne faudra ni grands efforts ni beaucoup de bras pour l'arracher à ses racines."
,"10":"Il est planté, va-t-il pour autant prospérer? Que le vent d'est se lève, et le voilà desséché: il se desséchera sur la terre où il fleurissait."
,"11":"Une parole de Yahvé me fut alors adressée:"
,"12":"'Tu diras à cette bande de rebelles: Ne savez-vous pas ce que cela signifie? Voici: le roi de Babylone est venu à Jérusalem, il a enlevé son roi et ses chefs et les a emmenés avec lui à Babylone."
,"13":"Ensuite il a pris un rejeton de race royale, il a conclu une alliance avec lui et lui a imposé un serment. Il a même pris les responsables du pays"
,"14":"pour que le royaume reste petit, ne puisse pas se révolter, et que l'autre garde et respecte son alliance."
,"15":"Mais ce prince s'est révolté contre le roi de Babylone, il a envoyé des messagers en Egypte pour qu'on lui donne des chevaux et une armée nombreuse. Pourra-t-il réussir? Après avoir rompu l'alliance, va-t-il s'en tirer?"
,"16":"Par ma vie - parole de Yahvé, c'est dans le pays du roi qui l'a mis sur le trône qu'il mourra, chez ce roi dont il a méprisé le serment et rompu l'alliance. C'est à Babylone qu'il mourra."
,"17":"Le Pharaon ne lui enverra pas un fort contingent, avec beaucoup de monde, quand on élèvera le remblais et les tours pour abattre les défenseurs."
,"18":"Il a méprisé le serment, il a rompu l'alliance alors qu'il avait donné sa parole; et après cela il s'en sortirait?"
,"19":"C'est pourquoi, voici ce que dit Yahvé: Aussi vrai que je suis vivant, je ferai retomber sur sa tête mon serment qu'il a méprisé et mon alliance qu'il a rompue."
,"20":"J'étendrai sur lui mon filet et il sera pris dans ses mailles."
,"21":"Ses gardes tomberont sous l'épée et les survivants seront dispersés à tous les vents: alors vous saurez que moi, Yahvé, j'ai parlé."
,"22":"Voici ce que dit Yahvé: Je prendrai moi-même sur le cèdre une jeune pousse, et je la planterai sur une montagne haute et fière."
,"23":"Je la planterai sur une haute montagne d'Israël, elle se développera, elle produira du fruit et deviendra un cèdre magnifique; sous lui se reposeront tous les oiseaux de toute espèce, ils s'abriteront à l'ombre de ses branches."
,"24":"Tous les arbres dans la campagne sauront alors que je suis Yahvé: j'abaisse l'arbre élevé et j'élève l'arbre humilié, je dessèche l'arbre vert et fais fleurir l'arbre sec; moi Yahvé je l'ai dit, et je le ferai."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Cette parole de Yahvé me fut adressée:"
,"2":"'Pourquoi donc répétez-vous ce proverbe au sujet du pays d'Israël: Les pères ont mangé des raisins verts et les dents des fils en sont agacées?"
,"3":"Aussi vrai que je suis vivant - parole de Yahvé, ce proverbe n'aura plus cours en Israël."
,"4":"Car toutes les vies sont à moi, la vie du fils comme celle du père; elles sont à moi, et celui qui pèche, c'est lui qui mourra."
,"5":"Voici un homme juste qui pratique le droit et la justice;"
,"6":"il ne mange pas la chair non saignée, il ne tourne pas son regard vers les sales idoles de la maison d'Israël, il ne souille pas la femme de son prochain et ne s'approche pas d'une femme durant ses règles;"
,"7":"il n'opprime personne, il rend le gage à celui qui lui doit, il ne commet pas de vol, il donne son pain à celui qui a faim et couvre d'un vêtement celui qui est nu;"
,"8":"il ne prête pas son argent avec intérêt, il ne prend pas de commission, il détourne sa main de l'injustice, il juge selon la vérité entre un homme et son prochain;"
,"9":"il suit mes commandements, observe mes lois et agit en tout avec fidélité. Cet homme est donc juste et il vivra, parole de Yahvé."
,"10":"Mais voici que cet homme a un fils violent qui répand le sang et commet ces fautes"
,"11":"que son père n'a pas commises. Il mange la chair non saignée, il souille la femme de son prochain,"
,"12":"il violente le pauvre et l'indigent, il vole, il ne rend pas le gage prêté, il tourne son regard vers les sales idoles et commet le crime,"
,"13":"il prête son argent avec intérêt et prend une commission. Après tout cela, vivra-t-il? Non, il ne vivra pas. S'il a commis tous ces crimes, il doit mourir: il sera responsable de sa mort."
,"14":"Mais voici que cet homme à son tour a un fils; ce fils a vu tous les péchés que son père commettait; il les a vus et il ne l'a pas imité."
,"15":"Il ne mange pas la chair non saignée, il ne tourne pas son regard vers les sales idoles de la maison d'Israël, il ne souille pas la femme de son prochain,"
,"16":"il ne violente personne, ne garde pas le gage, il ne vole pas, il donne son pain à celui qui a faim et couvre d'un vêtement celui est nu,"
,"17":"il ne fait pas violence au pauvre, il ne prend pas d'intérêt ou de commission, il observe mes lois et suit mes commandements. Celui-là ne mourra pas pour le péché de son père, mais au contraire il vivra."
,"18":"C'est le père qui mourra pour son péché, celui qui a multiplié les violences, qui a volé son frère, qui a fait ce qui est mal au milieu de son peuple."
,"19":"Et après cela vous demandez: 'Pourquoi le fils ne porte-t-il pas le péché de son père?' Mais le fils s'est conduit selon le droit et la justice, il a observé tous mes commandements et les a mis en pratique! Il doit vivre."
,"20":"Celui qui pèche, c'est celui-là qui mourra; le fils ne portera pas le péché du père, et le père ne portera pas le péché du fils. Le mérite du juste restera sur lui, et la méchanceté du méchant restera sur lui."
,"21":"Si le méchant se détourne de tous les péchés qu'il a commis, s'il se met à observer tous mes commandements et se conduit selon le droit eée, il vivra."
,"23":"Croyez-vous que je prenne plaisir à la mort du méchant, dit Yahvé? Mon plaisir est qu'il renonce à sa mauvaise conduite et qu'il vive."
,"24":"Par contre, si le juste se détourne de sa justice et se met à agir mal, s'il commet les mêmes mét se détourne de la mauvaise conduite qu'il avait et agit selon le droit et la justice, il vivra."
,"28":"S'il se détourne de toutes les infidélités qu'il commettait, il doit vivre et non pas mourir."
,"29":"Les gens d'Israël disent: La façon de voir du Seigneur n'est pas juste. Mais, est-ce ma façon de voir qui n'est pas juste, gens d'Israël, n'est-ce pas plutôt la vôtre?"
,"30":"Je vous jugerai chacun selon votre conduite, gens d'Israël, dit Yahvé. Reprenez-vous et renoncez à toutes vos infidélités si vous ne voulez plus payer le prix de votre injustice."
,"31":"Rejetez loin de vous toutes les infidélités que vous avez commises, faites-vous un coeur nouveau et un esprit nouveau; voulez-vous donc mourir, gens d'Israël?"
,"32":"Moi, je ne prends pas plaisir à la mort de qui que ce soit - parole de Yahvé; convertissez-vous et vivez.'"
}`)
	CurrentBook.AddChapter(19, `{
"1":"Tu vas prononcer une lamentation sur les princes d'Israël."
,"2":"Tu diras: Quelle lionne était ta mère au milieu des lions! Elle se couchait entre ses petits et les nourrissait. "
,"3":"Elle éleva un de ses petits qui devint un jeune lion, il apprit à déchirer la proie et à dévorer les hommes."
,"4":"Mais les nations entendirent parler de lui, il fut capturé dans leur fosse et on le mena en Egypte enchaîné."
,"5":"La lionne fut déçue, ses espoirs étaient perdus; elle prit un autre de ses petits dont elle fit un jeune lion."
,"6":"Comme un jeune lion, il alla avec les lions; il apprit à déchirer la proie et à dévorer les hommes."
,"7":"Il détruisit leurs palais, il ravagea leurs villes, son rugissement terrorisait le pays et ses habitants."
,"8":"Des étrangers sont venus l'attaquer de toutes leurs provinces; ils ont tendu sur lui leurs filets, il est tombé dans leur fosse."
,"9":"On l'a mis en cage avec des anneaux, on l'a conduit à Babylone où on l'a fait garder: on n'entendra plus sa voix sur les montagnes d'Israël!"
,"10":"Ta mère était comme une vigne plantée au bord de l'eau, une vigne fertile et verdoyante car l'eau ne manquait pas."
,"11":"Elle a même donné une branche assez forte pour faire un sceptre de roi. Elle a grandi jusqu'aux nuages; on admirait sa hauteur et son feuillage bien fourni."
,"12":"Mais on l'a arrachée avec colère et jetée à terre, le vent d'est a desséché ses fruits qui sont tombés. La branche vigoureuse s'est desséchée, le feu l'a dévorée."
,"13":"La voici maintenant plantée dans une terre aride, au désert."
,"14":"(Un feu sorti de son tronc a dévoré branches et fruits.) La branche vigoureuse, le sceptre royal, c'est fini pour elle. C'est bien une lamentation, et voilà comment on se lamentera."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Le dix du cinquième mois de la septième année, quelques anciens d'Israël étaient venus pour consulter Yahvé et se trouvaient assis en face de moi."
,"2":"Cette parole de Yahvé me fut alors adressée:"
,"3":"'Fils d'homme, tu vas dire aux anciens d'Israël cette parole de Yahvé: Vous êtes venus pour me consulter, n'est-ce pas? Aussi vrai que je suis vivant, je ne me laisserai pas consulter par vous - parole de Yahvé."
,"4":"Juge-les, fils d'homme, ne vas-tu pas les juger? Fais-leur donc voir les horribles actions de leurs pères."
,"5":"Tu leur diras cette parole de Yahvé: J'ai prêté un serment à la race de Jacob le jour même où j'ai choisi Israël; je me suis fait connaître à eux en Egypte et je leur ai fait ce serment: Moi Yahvé, je serai votre Dieu."
,"6":"Ce jour-là, la main levée, j'ai juré de les faire sortir d'Egypte pour un pays que j'avais reconnu pour eux, un pays qui ruisselle de lait et de miel; le plus beau de tous les pays."
,"7":"Je leur avais dit: Rejetez loin de vous ces choses qui vous séduisent, ne vous souillez pas avec les idoles de l'Egypte: je suis Yahvé votre Dieu."
,"8":"Mais ils se sont révoltés contre moi et n'ont pas voulu m'écouter. Ils n'ont pas rejeté loin d'eux ces idoles qui les séduisaient, ils n'ont pas abandonné les idoles de l'Egypte. J'ai pensé déchaîner contre eux ma colère, leur faire sentir ma fureur dans ce pays d'Egypte."
,"9":"Mais je n'ai pas voulu que mon nom soit profané aux yeux des nations parmi lesquelles ils vivaient: au contraire, je me suis fait connaître de ces nations en les faisant sortir du pays d'Egypte."
,"10":"Une fois sortis d'Egypte, je les ai conduits au désert."
,"11":"Là je leur ai donné mes commandements et leur ai fait connaître mes lois que l'homme doit pratiquer pour vivre."
,"12":"Je leur ai donné mes sabbats pour qu'ils soient un signe entre moi et eux, pour que l'on sache que je suis Yahvé qui les rend saints."
,"13":"Mais le peuple d'Israël s'est révolté contre moi au désert. Ils n'ont pas suivi mes commandements, ils ont méprisé mes lois que l'homme doit pr."
,"15":"Une fois cependant, au désert, j'ai juré de ne pas les conduire au pays que je leur avais promis, ce pays qui ruisselle de lait et de miel, le plus beau de tous les pays."
,"16":"En effet, ils avaient rejeté mes commandements, ils n'avaient pas suivi mes les traces de vos pères, n'imitez pas leur conduite, ne vous rendez pas impurs en servant leurs idoles."
,"19":"Je suis Yahvé votre Dieu, suivez mes commandements, observez mes lois et mettez-les en pratique."
,"20":"Respectez mes sabbats, qu'ils soient un signe entre moi et vous pour que l'on sache que je suis Yahvé votre Dieu."
,"21":"Mais les fils se sont révoltés contre moi, ils n'ont pas suivi mes commandements, ils n'ont pas observé mes lois (ces lois que l'homme doit mettre en pratique pour vivre) et ils n'ont eu aucun respect pour mes sabbats. J'ai pensé déchaîner contre eux ma colère, répandre sur eux ma fureur au désert,"
,"22":"mais je n'ai pas voulu que mon nom soit profané devant les nations sous les yeux desquelles je les avais fait sortir."
,"23":"Cependant, une fois encore au désert, j'ai juré de les jeter parmi les nations et de les disperser parmi les pays étrangers."
,"24":"Car ils n'avaient pas mis en pratique mes lois, ils avaient méprisé mes commandements, ils n'avaient pas respecté mes sabbats, mais leurs yeux se tournaient vers les sales idoles de leurs pères."
,"25":"Je suis même allé jusqu'à leur donner des commandements mauvais et des lois incapables de les faire vivre:"
,"26":"je les ai rendus impurs par leurs offrandes lorsqu'ils faisaient passer leurs premiers-nés par le feu."
,"27":"Voilà donc, fils d'homme, ce que tu vas dire au peuple d'Israël. Tu lui diras cette pa role de Yahvé: Voyez cette infidélité de vos pères et comment ils m'ont offensé!"
,"28":"Je les ai fait entrer au pays que je leur avais promis par serment, mais aussitôt, sur n'importe quelle colline élevée, sous tout arbre vert, ils ont offert des sacrifices, déposé les parfums d'encens et versé leurs libations."
,"29":"Je leur ai dit: Qu'est-ce que vous allez faire là? Et ils ont appelé ces endroits 'Bama' (Qu'est-ce que?) jusqu'à ce jour."
,"30":"Et maintenant tu vas dire aux gens d'Israël de la part de Yahvé: Vous vous rendez impurs comme vos pères et vous vous prostituez avec leurs sales idoles, n'est-ce pas?"
,"31":"Maintenant encore vous vous rendez impurs par toutes ces sales idoles, vous leur apportez vos offrandes, et moi je devrais me laisser consulter par vous, gens d'Israël? Aussi vrai que je suis vivant - parole de Yahvé - je ne me laisserai pas consulter par vous."
,"32":"Vous rêvez d'être comme les païens, de vivre comme on fait dans les pays étrangers où l'on adore le bois et la pierre; mais cela ne sera pas."
,"33":"Aussi vrai que je suis vivant, je régnerai sur vous à la manière forte, en frappant durement, et je vous ferai connaître le poids de ma colère."
,"34":"Je vous ferai sortir d'entre les autres peuples et je vous rassemblerai de tous ces pays où, dans ma colère, je vous ai dispersés à la manière forte, en frappant durement."
,"35":"Je vous conduirai au désert et là je vous jugerai face à face."
,"36":"Je vous jugerai, dit Yahvé, comme j'ai jugé vos pères au désert d'Egypte."
,"37":"Je vous ferai passer sous ma baguette et je vous compterai un à un."
,"38":"J'expulserai de chez vous les rebelles, ceux qui se sont révoltés contre moi; je les ferai sortir du pays où ils se trouvent, mais ils n'entreront pas en terre d'Israël; alors vous saurez que je suis Yahvé."
,"39":"Gens d'Israël, Yahvé vous dit: Allez donc servir chacun vos sales idoles, mais à la fin vous m'écouterez et vous ne profanerez plus mon saint Nom par ces offrandes et ces idoles."
,"40":"Oui, sur ma montagne sainte, sur une haute montagne d'Israël, dit Yahvé, toute la maison d'Israël viendra me rendre hommage. Là j'accueillerai et j'attendrai vos offrandes, les prémices de tout ce que vous m'apportez, de tout ce que vous me consacrez."
,"41":"Lorsque vous serez sortis du milieu des peuples et que je vous aurai rassemblés du milieu des pays où vous avez été dispersés, vous serez pour moi comme un parfum d'agréable odeur. C'est alors que, par vous, je ferai voir aux nations ma sainteté."
,"42":"En ce jour où je vous ramènerai à la terre d'Israël, au pays que j'ai juré de donner à vos pères, vous saurez que je suis Yahvé."
,"43":"Là vous vous rappellerez votre conduite et tout ce qui vous a rendus impurs, vous aurez honte de vous-mêmes et de toutes vos mauvaises actions."
,"44":"J'agirai envers vous pour l'honneur de mon Nom, et non comme le méritent votre conduite et vos mauvaises actions, dit Yahvé; alors vous saurez que je suis Yahvé."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Cette parole de Yahvé me fut adressée:"
,"2":"'Fils d'homme, tourne-toi vers ta droite, prophétise vers le sud, prophétise contre la forêt du sud."
,"3":"Tu diras à la forêt du sud: Ecoute la parole de Yahvé... Voici ce que dit Yahvé: Je vais allumer chez toi un feu qui dévorera tout arbre, vert ou sec. Ce feu violent ne s'éteindra pas et tous les personnages s'y brûleront, depuis le sud jusqu'au nord. "
,"4":"Alors tout mortel comprendra que c'est moi, Yahvé, qui l'ai allumé, car il ne s'éteindra pas.'"
,"5":"Je répondis: 'Ah! Yahvé, ils disent que je parle toujours de façon mystérieuse!'"
,"6":"Alors cette parole de Yahvé me fut adressée:"
,"7":"'Fils d'homme, tourne-toi vers Jérusalem, prophétise contre le Temple, prophétise contre la terre d'Israël."
,"8":"Tu diras à la terre d'Israël cette parole de Yahvé: Je viens m'en prendre à toi. Je vais sortir mon épée du fourreau et retrancher le juste comme le méchant."
,"9":"Oui, je veux retrancher de toi le juste comme le méchant; c'est pourquoi mon épée sort de son fourreau pour frapper tout mortel, depuis le sud jusqu'au nord."
,"10":"Et tout mortel saura que c'est moi Yahvé qui ai sorti l'épée du fourreau: elle n'y rentrera pas."
,"11":"Mets-toi à gémir, fils d'homme! Pousse des gémissements sous leurs yeux, comme si tu avais le coeur brisé, rempli de tristesse."
,"12":"Et s'ils te disent: Pourquoi ces plaintes? tu leur répondras: C'est une nouvelle qui vient d'arriver, tous vont se démoraliser, les mains leur en tomberont, les esprits se troubleront et les genoux trembleront. Or voici qu'elle vient, elle est là, dit Yahvé."
,"13":"Une parole de Yahvé me fut adressée:"
,"14":"'Fils d'homme, prophétise. Tu leur diras cette parole de Yahvé: L'épée brille, on l'a aiguisée!"
,"15":"On l'a aiguisée pour le massacre, elle brille et jette des éclairs."
,"16":"Yahvé l'a donnée pour qu'on la fasse briller et qu'on la prenne à pleine main; elle est aiguisée cette épée, elle brille, on va la remettre au bourreau."
,"17":"Crie, fils d'homme, pousse des hurlements, car elle est destinée à mon peuple, à tous les chefs d'Israël. Ils sont livrés à l'épée avec le peuple, frappe-toi de désespoir!"
,"18":"Le châtiment est décidé - parole de Yahvé."
,"19":"Et toi, fils d'homme, prophétise et applaudis des deux mains. Que l'épée repasse trois fois, l'épée qui transperce les victimes, la grande épée qui massacre et qui passe au milieu d'eux."
,"20":"Tous vont perdre coeur et beaucoup tomberont, car à toutes les portes j'ai placé l'épée pour le massacre; elle jette des éclairs, elle brille pour le massacre."
,"21":"Tranche à droite, tranche à gauche, frappe de tous côtés!"
,"22":"Et moi j'applaudirai des deux mains, ma colère sera satisfaite: moi Yahvé, j'ai parlé."
,"23":"Cette parole de Yahvé me fut adressée:"
,"24":"'Fils d'homme, trace donc deux chemins pour l'épée du roi de Babylone. Les deux partent du même endroit et tu y mets une pan carte pour que l'épée puisse choisir entre les deux chemins qui mènent chacun à une ville:"
,"25":"soit Rabba-des-Ammonites, soit Juda, avec Jérusalem au centre."
,"26":"Le roi de Babylone se tient à la croisée des chemins, il consulte les sorts, il a secoué les flèches, interrogé les idoles, examiné le foie des animaux."
,"27":"Le sort a fait venir Jérusalem dans sa main droite. Aussitôt il lance un cri de guerre: 'Placez les machines contre les portes, élevez des remblais, creusez des tranchées!'"
,"28":"Les habitants de Jérusalem n'osent pas y croire, mais le roi de Babylone n'a pas oublié leur infidélité et il va les faire payer."
,"29":"Et voici ce que dit Yahvé: Vous avez fait le nécessaire pour que vos méfaits soient dévoilés, pour qu'on se souvienne de vos dettes, pour qu'on mette le péché à nu dans toutes vos mauvaises actions. Je me suis souvenu de vous et vous serez pris par force."
,"30":"Le temps du châtiment définitif est arrivé pour toi, prince d'Israël, infâme criminel."
,"31":"Voici ce que dit Yahvé: On arrachera le turban, on enlèvera la couronne, et la situation sera retournée; ce qui est bas sera élevé et ce qui est élevé sera abaissé."
,"32":"Des ruines, des ruines, encore des ruines, voilà ce que j'en ferai, jusqu'à ce que vienne celui à qui appartient le droit; c'est lui que je mettrai en place."
,"33":"Prophétise donc, fils d'homme, à l'intention des Ammonites en réponse à leurs insultes. Tu leur diras cette parole de Yahvé: On a tiré l'épée pour le massacre, l'épée brille et dévore, elle lance des éclairs."
,"34":"Tu t'appuies sur des visions fausses, des signes mensongers; tu seras livré à l'épée et jeté avec les méchants massacrés: l'heure est venue, l'injustice arrive à sa fin."
,"35":"Retourne chez toi, laisse ces terres: je veux te juger là même où tu as été créé, sur la terre où tu es né."
,"36":"Je déchaînerai contre toi ma colère, le feu de ma fureur soufflera sur toi; je te livrerai aux mains d'hommes barbares qui ne savent que détruire."
,"37":"Je te livrerai au feu, ton sang se répandra sur tes terres, et l'on ne se souviendra plus de toi, car moi Yahvé, j'ai parlé."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Cette parole de Yahvé me fut adressée:"
,"2":"'Fils d'homme, ne vas-tu pas juger la ville sanguinaire?"
,"3":"Fais-lui connaître tous ses crimes. Tu lui diras cette parole de Yahvé: Malheur à cette ville: elle a avancé son heure avec le sang versé au milieu d'elle, elle s'est rendue impure avec les idoles qu'elle s'est faites. "
,"4":"Le sang répandu fait de toi une coupable, tu t'es fait des idoles et tu en es restée souillée. Tu as avancé ton heure et le terme de tes années est là: je vais faire de toi la honte des nations, un sujet de moqueries pour tous les peuples."
,"5":"Qu'ils soient proches ou lointains, ils se moqueront de toi pour avoir souillé ton nom et multiplié tes crimes."
,"6":"Les chefs d'Israël n'ont fait que répandre le sang, chacun pour son compte."
,"7":"Chez toi on méprise père et mère, on maltraite l'étranger, on fait violence à l'orphelin et à la veuve."
,"8":"On méprise ce qui m'est consacré, on ne respecte pas mes sabbats."
,"9":"Chez toi, des gens calomnient et répandent le sang, chez toi, on mange la chair non saignée, on commet mille méfaits."
,"10":"Chez toi on couche avec son père, on fait violence à la femme qui a ses règles."
,"11":"L'un commet l'adultère avec la femme de son prochain, un autre se livre à des pratiques honteuses avec sa belle-fille, un autre encore fait violence à sa soeur, à la fille de son père."
,"12":"Chez toi on condamne à mort pour de l'argent; vous prêtez avec intérêt, vous prenez des commissions. Tu dépouilles brutalement ton prochain, et moi tu m'as oublié - parole de Yahvé."
,"13":"Mais maintenant je frappe dans mes mains pour tout cet argent que tu as accumulé et pour le sang qui est au milieu de toi."
,"14":"Garderas-tu ton assurance, seras-tu si hardie le jour où je m'en prendrai à toi? Moi Yahvé j'ai parlé, et je le ferai."
,"15":"Je te disperserai parmi les nations, je te jetterai au milieu des peuples, je ferai disparaître de chez toi ton impureté."
,"16":"Je te laisserai déshonorée à la face des nations et tu sauras que je suis Yahvé."
,"17":"Cette parole de Yahvé me fut adressée:"
,"18":"'Fils d'homme, les gens d'Israël sont devenus pour moi un métal impur. Ils sont comme le cuivre, l'étain, le fer ou le plomb qu'on fait passer par le feu parce que le métal est impur."
,"19":"C'est pourquoi, voici ce que dit Yahvé: Je vais vous rassembler dans Jérusalem comme on fait pour du métal impur."
,"20":"Comme on rassemble l'argent, le cuivre, le fer, le plomb et l'étain dans une fournaise pour les faire fondre à force de chauffer, de même je vous rassemblerai et je ferai chauffer ma colère jusqu'à vous faire fondre."
,"21":"Je vous rassemblerai au milieu de la ville et je vous ferai fondre dans le feu surchauffé de ma colère."
,"22":"Comme on fond l'argent dans la fournaise, ainsi serez-vous fondus au milieu de la ville et vous saurez que c'est moi, Yahvé, qui ai déchaîné ma colère contre vous."
,"23":"Cette parole de Yahvé me fut adressée:"
,"24":"'Fils d'homme, dis à Jérusalem: Tu es une terre, qui n'a reçu ni pluie ni averse au temps des semailles."
,"25":"Chez toi ceux qui commandent sont comme un lion rugissant qui déchire sa proie: ils dévorent les gens, ils prennent les biens et les bijoux, et les veuves à cause d'eux sont de plus en plus nombreuses."
,"26":"Tes prêtres ont méprisé ma loi et profané ce qui m'était consacré; ils n'ont pas distingué entre ce qui est saint et ce qui est profane. Ils n'ont pas montré la différence entre l'impur et le pur; ils ont ignoré mes sabbats et chez eux je me sens déshonoré."
,"27":"Tes chefs sont au milieu du pays comme des loups qui déchirent une proie, qui répandent le sang et mettent à mort les gens pour en tirer profit."
,"28":"Pendant ce temps tes prophètes ne font que du replâtrage, leur révélation n'est que tromperie, et leur prédiction mensonge. Ils disent: 'Parole de Yahvé!' alors que Yahvé n'a rien dit."
,"29":"Les propriétaires se livrent à la violence, commettent le vol, maltraitent le pauvre et l'indigent; ils font violence à l'étranger sans aucun droit."
,"30":"Parmi eux j'ai cherché un homme qui construirait un rempart et me ferait face sur le créneau pour m'empêcher de détruire le pays, mais je ne l'ai pas trouvé."
,"31":"Alors j'ai déchaîné contre eux ma colère, je les ai exterminés par le feu de ma fureur et j'ai fait retomber sur leur tête leur propre conduite, parole de Yahvé."
}`)
	CurrentBook.AddChapter(23, `{
"1":"Cette parole de Yahvé me fut adressée:"
,"2":"'Fils d'homme, il y avait deux femmes, filles de la même mère."
,"3":"Dès leur jeunesse en Egypte elles se sont prostituées, on a porté la main sur leurs seins et l'on a caressé leur poitrine de jeunes filles."
,"4":"L'aînée s'appelait Ohola et sa soeur Oholiba; elles étaient à moi et m'ont donné des fils et des filles. Ohola, c'est Samarie; Oholiba, c'est Jérusalem."
,"5":"Ohola m' a trompé: elle brûlait d'amour pour ses amants. C'étaient ses voisins Assyriens,"
,"6":"gouverneurs et fonctionnaires vêtus de pourpre, jeunes et beaux sur leurs chevaux."
,"7":"C'est avec eux qu'elle m'a trompé, avec ces Assyriens de haute classe. Elle brûlait d'amour pour eux, et du même coup elle se souillait avec leurs idoles."
,"8":"Elle n'avait pas oublié sa jeunesse et ses prostitutions avec les Egyptiens, lorsqu'ils couchaient avec elle, tripotaient ses seins et l'entraînaient dans leur débauche."
,"9":"C'est pourquoi je l'ai livrée aux mains de ses amants, aux mains des Assyriens pour qui elle avait brûlé d'amour."
,"10":"Ils l'ont mise nue, ils ont pris ses fils et ses filles et l'ont tuée par l'épée; elle est devenue fameuse parmi les femmes à cause du châtiment qu'on lui avait infligé."
,"11":"Sa soeur Oholiba en a été témoin, mais ses débauches et ses prostitutions ont dépassé celles de sa soeur."
,"12":"Elle aussi a brûlé d'amour pour ses voisins Assyriens, ces gouverneurs et chefs richement habillés, jeunes et beaux sur leurs chevaux."
,"13":"J'ai vu comment elle se souillait; toutes deux suivaient le même chemin."
,"14":"Elle a fait mieux encore dans sa prostitution lorsqu'elle a vu des images de Kaldéens peintes en rouge, de ces hommes qu'on voit dessinés sur le mur"
,"15":"avec des ceintures sur les reins et de larges turbans sur leur têtes, tous ces hommes d'allure martiale dont la Kaldée est la terre natale."
,"16":"Aussitôt qu'elle les a vus, elle a brûlé de désir pour eux: elle a envoyé des messagers vers eux en Kaldée."
,"17":"Les fils de Babylone sont venus la souiller par leurs prostitutions; mais une fois souillée par eux, son coeur s'est détaché d'eux."
,"18":"Mais comme elle s'était donnée et avait découvert sa nudité, mon coeur aussi s'était détaché d'elle comme il s'était détaché de sa soeur."
,"19":"Oui, tu multipliais tes prostitutions , tu revivais ta jeunesse, le temps où tu te prostituais en Egypte."
,"20":"Tu as brûlé de désir pour des débauchés qui s'échauffent comme des ânes et dont le sexe vaut celui des chevaux."
,"21":"Oui, Jérusalem, tu revenais au dévergon dage de ta jeunesse, lorsque les Egyptiens caressaient ta poitrine et passaient leurs mains sur tes seins."
,"22":"C'est pourquoi, Oholiba, voici ce que dit Yahvé: Je vais exciter contre toi tes amants dont ton coeur s'est détaché; je les rassemblerai contre toi de tous côtés."
,"23":"Babyloniens et Kaldéens, gens de Pékod, de Choa et de Koa, et avec eux tous les Assyriens, jeunes et beaux, gouverneurs et fonctionnaires, officiers renommés et cavaliers entraînés."
,"24":"Des peuples coalisés viendront du Nord pour t'assaillir avec chars et chariots. De tous côtés, ils arriveront contre toi avec boucliers, armes et casques; je les chargerai de te juger et ils te jugeront selon leurs lois."
,"25":"Je laisserai libre cours à ma jalousie contre toi: ils te traiteront cruellement, ils te couperont le nez et les oreilles, et ce qui restera des tiens tombera par l'épée. Ils prendront tes fils et tes filles, et les survivants seront dévorés par le feu."
,"26":"Ils te dépouilleront de tes vêtements et prendront tes bijoux;"
,"27":"ainsi je mettrai fin à ton inconduite et à tes prostitutions commencées en Egypte. Tu ne regarderas plus vers eux et tu ne penseras plus à l'Egypte."
,"28":"Voici ce que dit Yahvé: Je vais te livrer aux mains de ceux que tu détestes, aux mains de ceux dont ton coeur s'est détourné."
,"29":"Dans leur haine ils te maltraiteront, ils s'empareront de tout le fruit de ton travail et te laisseront nue; alors tes prostitutions, tes débauches et ton inconduite seront étalées à ta honte."
,"30":"Tout cela t'arrivera parce que tu t'es prostituée avec les nations et que tu t'es souillée avec leurs sales idoles."
,"31":"Puisque tu as pris le chemin de ta soeur, je mettrai aussi sa coupe dans ta main."
,"32":"Voici ce que dit Yahvé: Tu boiras la coupe de ta soeur, une coupe large et profonde, de grande capacité."
,"33":"Tu te rempliras d'ivresse et d'angoisse, car la coupe de ta soeur n'est que ravages."
,"34":"Tu la boiras jusqu'au bout, tu en avaleras les tessons; c'est moi qui le dis, parole de Yahvé.'"
,"35":"Et voici une parole de Yahvé: 'Puisque tu m'as oublié et que tu t'es détournée de moi, tu porteras le poids de ta honte et de tes prostitutions.'"
,"36":"Yahvé me dit encore: 'Fils d'homme, veux-tu juger Ohola et Oholiba et leur reprocher leurs crimes?"
,"37":"Elles ont été adultères, leurs mains sont pleines de sang, elles ont commis l'adultère avec leurs sales idoles, elles ont fait passer par le feu les enfants qu'elles m'avaient enfantés."
,"38":"En même temps qu'elles agissaient ainsi, elles venaient souiller mon Temple et profanaient mes sabbats:"
,"39":"elles immolaient leurs enfants à leurs idoles, et puis elles venaient profaner mon Temple. Voilà ce qu'elles ont fait dans ma Maison."
,"40":"Elles ont fait venir des hommes de pays lointains, elles leur ont envoyé un messager et ils sont venus... Tu t'étais baignée pour eux, tu t'étais maquillé les yeux et tu avais mis tes bijoux. "
,"41":"Puis tu t'es assise sur un lit d'apparat; sur le devant on avait dressé une table, et tu avais déposé mon encens et mon huile."
,"42":"On entendait le bruit d'une foule en fête à laquelle se joignaient des hommes venus du désert; ils mettaient des bracelets aux mains des femmes et de splendides couronnes sur leurs têtes."
,"43":"Alors j'ai dit de cette ville usée par la débauche: 'Quelle prostituée!"
,"44":"On va chez elle comme on va chez une prostituée.' Et c'est bien ainsi qu'on est allé chez Ohola et Oholiba pour faire le mal."
,"45":"Ils agiront avec justice, ceux qui lui appliqueront la sentence qui convient aux femmes adultères, la condamnation réservée à celles qui versent le sang,! Car elles sont réellement adultères et elles ont du sang sur leurs mains."
,"46":"Oui, voici ce que dit Yahvé: Convoquez une assemblée, livrez-les à la terreur et au pillage."
,"47":"L'assemblée les lapidera et les frappera de l'épée, on tuera leurs fils et leurs filles et on brûlera leurs maisons."
,"48":"Ainsi je mettrai un terme à la débauche dans le pays; ce sera une leçon pour toutes les femmes, pour qu'elles ne commettent pas les mêmes fautes."
,"49":"Je ferai retomber sur toi ta débauche et tu porteras le poids des péchés commis avec tes idoles: alors tu sauras que je suis Yahvé."
}`)
	CurrentBook.AddChapter(24, `{
"1":"En la neuvième année, le dixième jour du dixième mois, cette parole de Yahvé me fut adressée:"
,"2":"'Fils d'homme, note par écrit cette date, car c'est aujourd'hui que le roi de Babylone a mis le siège devant Jérusalem."
,"3":"Parle donc de façon imagée pour cette bande de rebelles. Tu diras de la part de Yahvé: Pose la marmite sur le feu et verses-y de l'eau. "
,"4":"Remplis-la de morceaux de viande, des meilleurs morceaux: la cuisse et l'épaule. Remplis-la des meilleurs os."
,"5":"Tu iras prendre au troupeau ce qu'il y a de meilleur, tu amasseras du bois sous la marmite et la feras bouillir à gros bouillons jusqu'à ce que les os eux-mêmes soient cuits.'"
,"6":"Et maintenant, voici ce que dit Yahvé: 'Malheur à la ville sanguinaire! C'est une marmite rouillée et sa rouille ne s'en va pas, vide-la morceau par morceau sans choisir."
,"7":"Car il y a du sang au milieu d'elle. Elle l'a répandu à même le roc, elle ne l'a pas versé sur le sol ni recouvert avec de la terre."
,"8":"Moi-même j'ai voulu ce sang à même le rocher, pas même recouvert, de façon à exciter ma colère et précipiter la vengeance."
,"9":"C'est pourquoi, voici ce que dit Yahvé: Malheur à la ville sanguinaire! A mon tour je prépare un grand bûcher ,"
,"10":"j'entasse le bois, j'allume le feu et je vais cuire si bien la viande que le jus aura disparu."
,"11":"Je poserai ensuite la marmite vide sur les charbons, elle chauffera, le bronze rougira, ses impuretés disparaîtront et sa rouille sera dévorée."
,"12":"Mais non! La rouille est profonde et ne s'en va pas avec le feu."
,"13":"Tes fautes t'ont souillée à tel point que tu ne pourras redevenir pure si je ne laisse pas libre cours à ma colère contre toi."
,"14":"Moi Yahvé je l'ai dit, et je le ferai; je ne reviendrai pas en arrière, je n'aurai ni pitié ni miséricorde, on te jugera selon ta conduite et selon tes oeuvres, parole de Yahvé."
,"15":"Une parole de Yahvé me fut adressée:"
,"16":"'Fils d'homme, je vais d'un coup te retirer la joie de tes yeux, mais tu ne feras pas de lamentation et tu ne pleureras pas."
,"17":"Soupire en silence et ne prends pas le deuil comme on le fait pour les morts; garde ton turban sur la tête et tes sandales à tes pieds, ne couvre pas ta barbe et ne mange pas de pain apporté par les voisins."
,"18":"Le matin je parlais au peuple, et le soir ma femme était morte. Le lendemain matin j'ai fait comme j'en avais reçu l'ordre;"
,"19":"alors le peuple m'a dit: 'Vas-tu nous expliquer pourquoi tu agis ainsi?'"
,"20":"Je leur ai répondu: ' Voici la parole de Yahvé qui m'a été adressée:"
,"21":"Tu diras de ma part à la maison d'Israël: Je m'apprête à profaner mon sanctuaire dont vous êtes si orgueilleux, qui est la joie de vos yeux; vos fils et vos filles que vous avez laissés et auxquels vous ne cessez de penser, seront également frappés."
,"22":"Mais vous ferez comme j'ai fait, vous ne vous couvrirez pas la barbe, vous ne mangerez pas le pain apporté par les voisins,"
,"23":"vous garderez vos turbans sur la tête et vos sandales aux pieds, vous ne gémirez pas et vous ne pleurerez pas. Vous dépérirez à cause de vos méfaits et vous vous lamenterez entre vous."
,"24":"Ezéquiel sera pour vous un signe: tout ce qu'il a fait, vous le ferez pareillement et, lorsque cela arrivera, vous saurez que je suis Yahvé."
,"25":"Retiens cet avis, fils d'homme: le jour où je leur enlèverai leur 'refuge', ce joyau qui est la joie de leurs yeux, ainsi que leurs fils et leurs filles auxquels ils ne cessent de penser,"
,"26":"ce jour-là un rescapé viendra t'en apporter la nouvelle."
,"27":"Alors ta bouche s'ouvrira pour parler au rescapé, tu ne seras plus muet. Tu seras pour eux un signe et ils sauront que je suis Yahvé."
}`)
	CurrentBook.AddChapter(25, `{
"1":"Cette parole de Yahvé me fut adressée:"
,"2":"'Fils d'homme, tourne-toi vers les Ammonites et prophétise contre eux."
,"3":"Tu diras ceci aux fils d'Ammon de la part de Yahvé: Tu as bien ri lorsque mon Temple a été profané, lorsque la terre d'Israël a été dévastée et le peuple de Juda est parti en captivité. "
,"4":"Eh bien, à cause de cela, je vais te livrer aux fils de l'Orient; ils viendront camper chez toi, ils fixeront chez toi leurs tentes, ils mangeront tes fruits et boiront ton lait."
,"5":"Je ferai de Rabba un pâturage pour les chameaux, et du pays d'Ammon un enclos pour les brebis; alors vous saurez que je suis Yahvé."
,"6":"Car voici ce que dit Yahvé: Tu as applaudi des deux mains et tu as frappé du pied, tu as ricané avec mépris au sujet de la terre d'Israël."
,"7":"Eh bien, à cause de cela, je lève la main contre toi; je te livrerai en pâture aux nations, je te ferai disparaître du milieu des peuples et tu ne seras plus un pays. Alors tu sauras que je suis Yahvé."
,"8":"Voici encore une parole de Yahvé: Moab a dit que la maison de Juda était comme toutes les autres nations.'"
,"9":"A cause de cela je vais ouvrir le flanc de Moab et ravager d'une frontière à l'autre ces villes qui sont l'ornement du pays: Bet-Yéchimot, Baal-Méon et Kiryatayim."
,"10":"Comme les Ammonites, je les livrerai aux fils de l'Orient et l'on ne se souviendra plus d'elles parmi les nations."
,"11":"Lorsque je châtierai Moab, on saura que je suis Yahvé."
,"12":"Voici ce que dit Yahvé: Edom s'est vengé des gens de Juda et cette vengeance va lui coûter cher."
,"13":"Voici ce que dit Yahvé: Je vais lever la main contre Edom et j'en retrancherai hommes et bêtes; j'en ferai un désert: de Téman jusqu'à Dédan ils tomberont sous l'épée."
,"14":"Je confierai à mon peuple Israël le soin de me venger d'Edom; il traitera Edom selon ma colère et ma fureur , et l'on connaîtra ma vengeance - parole de Yahvé."
,"15":"Voici ce que dit Yahvé: Les Philistins se sont vengés, ils se sont vengés avec mépris et haine, ils ont détruit avec une haine sans bornes."
,"16":"Eh bien, voici ce que dit Yahvé: Je m'apprête à lever la main contre les Philistins, je vais éliminer les Kérétiens et détruire ce qui reste des habitants de la côte."
,"17":"Je vais me venger de façon terrible: alors ils sauront que je suis Yahvé."
}`)
	CurrentBook.AddChapter(26, `{
"1":"La onzième année, le premier du mois, une parole de Yahvé me fut adressée:"
,"2":"'Fils d'homme, Tyr a bien ri de Jérusalem, elle a dit: La voilà brisée, la porte des peuples! Elle est en ruines, et tout le trafic aboutira chez moi."
,"3":"Eh bien, voici ce que dit Yahvé: Je vais m'en prendre à toi, Tyr, et je ferai monter contre toi des nations nombreuses comme les flots de la mer."
,"4":"Elles détruiront les remparts de Tyr et abattront ses tours; j'en balaierai la poussière et j'en ferai un rocher nu."
,"5":"Elle ne sera plus qu'un séchoir en mer pour étendre les filets. C'est moi Yahvé qui le dis: elle sera pillée par les nations."
,"6":"Ses villages qui sont sur la terre ferme seront livrés à l'épée et l'on saura que je suis Yahvé."
,"7":"Car voici ce que dit Yahvé: Du nord je fais venir contre Tyr Nabukodonozor, le roi de Babylone, le roi des rois! Il vient avec chevaux, chars et cavaliers, des peuples coalisés, une armée énorme."
,"8":"Il frappera de l'épée tes villes qui sont sur la terre ferme, il établira contre toi des retranchements, il élèvera un remblais et dressera un bouclier,"
,"9":"il frappera tes remparts à coups de bélier et démolira tes tours avec ses machines de siège."
,"10":"Il entrera par les portes dans la ville prise d'assaut, le pas de ses chevaux te couvrira de poussière, le vacarme des attelages, des chariots et des chars ébranlera tes remparts ,"
,"11":"les sabots de ses chevaux frapperont tes pavés. Il passera ton peuple au fil de l'épée et tes pierres dressées seront jetées à terre."
,"12":"On emportera tes richesses, on pillera les fruits de ton travail, tes remparts seront abattus, et tes belles maisons, démolies: on jettera les pierres à la mer, avec le bois et les décombres."
,"13":"Je ferai taire le bruit de tes chansons, personne n'entendra plus le son de tes harpes."
,"14":"Je ferai de toi un rocher nu, un séchoir pour étendre les filets, et tu ne seras pas reconstruite: c'est moi qui le dis - parole de Yahvé."
,"15":"Voici ce que dit Yahvé à propos de Tyr: Ta chute fera du bruit. On entendra les appels des blessés, lorsque le massacre fera rage au milieu de toi: les îles en seront dans l'épouvante."
,"16":"Alors tous les princes de la mer descendront de leur trônes, ils enlèveront leur manteau et quitteront leurs vêtements de fête. Ils prendront les habits de deuil et s'assiéront par terre. Ils seront frappés de stupeur en pensant à toi, et resteront là à trembler."
,"17":"Alors ils chanteront sur toi ce chant funèbre: Où est-elle, la ville fameuse qui dominait les mers, à qui ses habitants donnaient tant de prestige?"
,"18":"Ta chute aujourd'hui a fait trembler les îles!"
,"19":"Oui, c'est Yahvé qui le dit: Je ferai de toi une ville déserte, comme les villes qu'on n'habite plus. L'océan viendra battre contre toi, ses vagues passeront sur toi."
,"20":"Je te ferai descendre avec ceux qui vont à la tombe, et tu rejoindras le peuple des trépassés. Je veux que tu habites au monde d'en-bas, avec tout ce qui a passé, avec ceux qui s'en sont allés à la fosse; tu n'en reviendras pas, tu ne seras pas rebâtie sur la terre des vivants."
,"21":"Je ferai de toi un exemple et tu ne seras plus, plus jamais! parole de Yahvé."
}`)
	CurrentBook.AddChapter(27, `{
"1":"Une parole de Yahvé me fut adressée:"
,"2":"'Fils d'homme, prononce donc une lamentation sur Tyr."
,"3":"Tu diras à Tyr, la ville installée au débouché des mers, le grand marché des peuples et des îles sans nombre: Parole de Yahvé!,Ne disais-tu pas, Tyr: Je suis parfaitement belle. "
,"4":"Tu n'avais de frontières que les mers, et tes bâtisseurs t'avaient voulue très belle."
,"5":"Ils avaient tiré des cyprès de Senir les planches de tes bordages, ils avaient pris ton mât dans un cèdre du Liban,"
,"6":"et tes rames, dans les chênes du Bashan; ton pont était de cèdre des îles de Kittim, incrusté d'ivoire."
,"7":"Tes voiles étaient de lin d'Egypte, et de même ton pavillon. Tes tentures de pourpre et d'écarlate venaient des îles d'Elisha."
,"8":"Les habitants de Sidon et d'Arvad étaient tes rameurs, mais tes sages étaient les pilotes;"
,"9":"les anciens de Guébal réparaient tes avaries."
,"10":"On trouvait dans ton armée des gens de Perse, de Loud et de Pout; ils accrochaient chez toi casque et bouclier, ils étaient ta fierté."
,"11":"Les fils d'Arvad à ton service veillaient sur tes remparts; les Guémadiens gardaient tes tours, leurs boucliers pendant au long de tes remparts te donnaient de la couleur."
,"12":"Tarsis te fournissait de tout: elle prenait tes marchandises contre l'argent, le fer, l'étain et le plomb."
,"13":"Yavan, Toubal et Méchek étaient tes clients; ils prenaient tes marchandises contre des esclaves et des objets de bronze."
,"14":"De Bet-Togorma te venaient les chevaux pour les chars et la cavalerie , ainsi que des mulets."
,"15":"Les fils de Dédan commerçaient avec toi; les îles populeuses étaient sous ton contrôle et te payaient en défenses d'ivoire et bois d'ébène."
,"16":"Edom payait tes nombreux produits avec des bijoux, de la pourpre, des broderies, des pierres précieuses, du corail et des rubis."
,"17":"Juda et le pays d'Israël t'apportaient du blé de Minnit, de la cire, du miel, de l'huile et des parfums en échange de tes marchandises."
,"18":"Damas s'approvisionnait chez toi, car tu avais de tout; il te fournissait en vin de Helbon et laine de Sadad."
,"19":"Les gens d'Ouzal apportaient sur tes marchés du fer forgé, de la cannelle et des roseaux."
,"20":"Dédan vendait chez toi des couvertures pour les chevaux."
,"21":"Même l'Arabie et les princes de Kédar se fournissaient chez toi; ils te payaient avec des agneaux, des béliers et des boucs."
,"22":"Les marchands de Chéba et de Rahama t'apportaient les baumes de qualité, les pierres précieuses et l'or."
,"23":"Haran, Kanné , Eden, les marchands de Chéba et ceux de l'Assyrie, aussi bien que les Mèdes, venaient trafiquer chez toi:"
,"24":"riches vêtements, manteaux de pourpre, étoffes brodées et tapis de couleur, cordes bien tressées."
,"25":"Les navires de Tas et tout ce que tu portes: marins et matelots, charpentiers de marine, commerçants, hommes de guerre et passagers: c'est le naufrage!"
,"28":"Les cris de tes matelots ont ébranlé jusqu'au rivage."
,"29":"Tous les rameurs descendent de leurs bateaux et les marins s'arrêtent à terre."
,"30":"Ils ne parlent que de toi et poussent des cris, ils se jettent de la poussière sur la tête et se roulent dans la cendre."
,"31":"Pour toi ils se rasent le crâne et s'habillent de sacs; très affligés, ils font entendre leurs plaintes, une lamentation amère."
,"32":"Ils ont composé pour toi un chant funèbre, et ils se lamentent: 'Qui était semblable à Tyr au milieu des mers?"
,"33":"Tu débarquais tes marchandises: les peuples étaient rassasiés. C'était toi, c'étaient tes marchandises, qui rendaient riches les rois de la terre."
,"34":"Voici que la mer t'a brisée, tu es au fond des eaux; ta cargaison et tout ton monde ont sombré avec toi."
,"35":"Les habitants des îles sont tous consternés, les rois ont un frisson, leur visage perd sa couleur."
,"36":"Partout dans le monde les marchands sifflent quand on parle de toi, tu es devenue un exemple, on ne te reverra plus."
}`)
	CurrentBook.AddChapter(28, `{
"1":"Une parole de Yahvé me fut adressée:"
,"2":"'Fils d'homme, adresse-toi au prince de Tyr; tu lui diras cette parole de Yahvé: Tu es bien prétentieux, tu te vois comme un dieu dans sa résidence divine, au coeur des mers! Vas-tu te prendre pour Dieu, toi qui es homme et non pas Dieu? "
,"3":"Te voilà plus sage que Daniel: il n'y a plus de secrets pour toi!"
,"4":"Tu as l'intelligence, tu as su y faire, et la richesse t'est venue: l'or et l'argent ont rempli tes coffres."
,"5":"Grâce à ton intelligence, grâce à tes affaires, ta richesse s'est accrue, et l'orgueil t'est venu à la mesure de ta richesse."
,"6":"C'est pourquoi, voici ce que dit Yahvé à celui qui se prend pour Dieu:"
,"7":"Je fais venir contre toi des étrangers, les tombeurs des peuples; leur épée va se mesurer avec ta belle culture, ils piétineront ta gloire."
,"8":"Ils te feront descendre dans la tombe et tu mourras là, au coeur des mers."
,"9":"Quand on viendra te tuer, diras-tu encore: 'Je suis Dieu'? Aux mains du meurtrier tu seras homme et non pas Dieu."
,"10":"Tu mourras de la mort des païens, et par la main des étrangers, c'est moi qui le dis - parole de Yahvé."
,"11":"Cette parole de Yahvé me fut encore adressée:"
,"12":"'Fils d'homme, chante cette lamentation sur le roi de Tyr. Tu lui diras cette parole de Yahvé: 'Tu étais là comme la clef de voûte, plein de sagesse, et d'une beauté parfaite."
,"13":"Tu vivais en Eden, dans le jardin de Dieu, sur toi ce n'étaient que pierres précieuses: cornaline, topaze et diamant, chrysolithe, onyx et jaspe, saphir, malachite, émeraude, avec des croissants, des pendentifs en or,ouvragés, dès le jour où tu fus créé."
,"14":"Je t'avais mis de garde, comme un Kéroub, sur la montagne sainte de Dieu: tu y restais, allant et venant entre les pierres de feu."
,"15":"Depuis le jour où tu fus créé, ta conduite avait été parfaite, jusqu'au jour où le mal s'est trouvé chez toi."
,"16":"(A force de trafiquer, tu t'es rempli de violence et tu as péché;),alors je t'ai banni de la montagne de Dieu: j'ai liquidé le Kéroub, celui qui veillait entre les pierres de feu."
,"17":"Tu étais trop fier de ta beauté: ta beauté t'a fait perdre la sagesse; c'est pourquoi je t'ai jeté à terre, donné en spectacle aux rois de la terre."
,"18":"A force de richesse, de profits malhonnêtes, tu as profané le lieu sacré; j'ai fait que le feu sorte de toi et te dévore, je n'ai laissé de toi que cendres sur la terre,sous les yeux de ceux qui te regardaient."
,"19":"Tous ceux qui te connaissent à l'étranger, en ont eu le souffle coupé; tu n'inspires plus que de l'effroi: on ne te reverra plus."
,"20":"Cette parole de Yahvé me fut adressée:"
,"21":"'Fils d'homme, adresse-toi maintenant à Sidon et prophétise contre elle."
,"22":"Tu lui diras cette parole de Yahvé: Je vais m'en prendre à toi, Sidon, et je me couvrirai de gloire à tes dépens. On saura que je suis Yahvé, lorsque j'exécuterai mes décisions: alors on connaîtra ma sainteté."
,"23":"L'épée frappera de tous côtés, les morts tomberont dans la ville: alors on saura que je suis Yahvé."
,"24":"La maison d'Israël n'aura plus parmi ses voisins qui la méprisent, ni épines pour la blesser, ni ronces pour la déchirer: alors on saura que je suis Yahvé."
,"25":"Voici ce que dit Yahvé: Je rassemblerai Israël du milieu des peuples où il est dispersé: c'est ainsi que je ferai voir aux nations ma sainteté. Israël habitera sur le sol que j'ai donné à mon serviteur Jacob."
,"26":"Ils l'habiteront en sécurité, ils construiront des maisons et planteront des vignes. Ils habiteront en sécurité, car j'aurai châtié tous leurs voisins qui les méprisent. Alors on saura que je suis Yahvé, leur Dieu."
}`)
	CurrentBook.AddChapter(29, `{
"1":"En la dixième année, le douze du dixième mois, cette parole de Yahvé me fut adressée:"
,"2":"'Fils d'homme, parle pour Pharaon, le roi d'Egypte, et prophétise contre lui et contre toute l'Egypte."
,"3":"Tu lui diras de la part de Yahvé: Je viens m'en prendre à toi, Pharaon, grand Dragon! Tu te prélasses entre tes canaux et tu dis: 'Mes canaux sont à moi, c'est moi qui les ai creusés!' "
,"4":"Mais je vais te planter des crocs dans la mâchoire et je te tirerai de tes canaux, toi et tous les poissons de tes canaux."
,"5":"Je te jetterai sur la terre sèche, avec les poissons des canaux; tu resteras à plat sur la face du sol et tu ne seras, ni relevé, ni ramassé. Je te donnerai en pâture aux bêtes de la terre et aux oiseaux du ciel."
,"6":"Alors les habitants de l'Egypte sauront que je suis Yahvé. Tu n'as été qu'un roseau lorsqu'Israël cherchait un appui; "
,"7":"lorsque mon peuple s'est accroché à toi, tu t'es brisé dans leur main et les as déchirés jusqu'à l'épaule; quand ils se sont appuyés sur toi, tu as cédé et leur as fait perdre l'équilibre."
,"8":"C'est pourquoi, voici ce que dit Yahvé: Je fais venir contre toi l'épée et je supprimerai chez toi hommes et bêtes."
,"9":"Le pays d'Egypte deviendra un désert, une ruine, et ils sauront que je suis Yahvé. Tu dis: 'Le Nil est à moi, c'est moi qui l'ai fait.' "
,"10":"C'est pourquoi je t'en veux, à toi et à tes canaux; je ferai de l'Egypte un désert, une ruine, depuis Migdol jusqu'à Syène et la frontière d'Ethiopie."
,"11":"Hommes et bêtes n'y passeront plus, elle sera inhabitée durant quarante ans."
,"12":"Oui, je ferai de l'Egypte le plus dévasté des pays: ses villes seront pour quarante ans les plus saccagées des villes. Je disperserai les Egyptiens au milieu des nations, je les disséminerai dans tous les pays."
,"13":"Mais voici ce que dit Yahvé: Après quarante ans je rassemblerai les Egyptiens du milieu des peuples où ils avaient été dispersés."
,"14":"Je changerai leur sort et je les ramènerai au pays de Patros, leur pays d'origine; là ils formeront un royaume, le plus modeste"
,"15":"de tous: il ne dominera plus les autres nations; je vais l'abaisser pour qu'il ne se dresse plus au-dessus des nations."
,"16":"Les gens d'Israël ne mettront plus en lui leur confiance, mais ils se rappelleront la faute qu'ils commettaient en se tournant vers l'Egypte; alors on saura que je suis Yahvé."
,"17":"En la vingt-septième année, le premier jour du premier mois, cette parole de Yahvé me fut adressée:"
,"18":"Fils d'homme, le siège de Tyr a été une entreprise difficile pour Nabukodonozor roi de Babylone et pour son armée; ses hommes y ont perdu leurs cheveux et sont revenus les épaules écorchées, mais ce siège de Tyr n'a rapporté aucun profit, ni pour lui ni pour son armée."
,"19":"C'est pourquoi, voici ce que dit Yahvé: Je vais livrer l'Egypte aux mains de Nabukodonozor, roi de Babylone: il emportera ses richesses, ramassera ses dépouilles et la mettra au pillage: ce sera le salaire de son armée."
,"20":"Je lui donne l'Egypte pour la peine qu'il s'est donnée au siège de Tyr, car il a travaillé pour moi, parole de Yahvé."
,"21":"En ce jour-là la maison d'Israël retrouvera sa force, et à toi, je te donnerai d'ouvrir la bouche au milieu d'eux. Alors on saura que je suis Yahvé."
}`)
	CurrentBook.AddChapter(30, `{
"1":"Cette parole de Yahvé me fut adressée:"
,"2":"'Fils d'homme, prophétise. Tu diras cette parole de Yahvé: Ah, quel jour! "
,"3":"Ce jour est proche, c'est l'heure de Yahvé, c'est le jugement des nations."
,"4":"L'épée est venue en Egypte, Kouch en a tremblé; les victimes tombent en Egypte et ses fondations sont disloquées."
,"5":"Kouch, Pout et Loud, l'Arabie, Koub et les coalisés tombent ensemble sous l'épée."
,"6":"Les alliés de l'Egypte succombent, et de Migdol à Syène son orgueilleuse puissance s'effondre: ils tomberont sous l'épée, parole du Seigneur Yahvé."
,"7":"Ils seront le plus ruiné des pays, leurs villes seront les plus saccagées des villes."
,"8":"On saura que je suis Yahvé lorsque je porterai le feu en Egypte et que tous ses alliés seront brisés."
,"9":"Des messagers iront jusqu'à Kouch, là-bas tous trembleront à la nouvelle de sa chute: ce jour vient."
,"10":"Voici ce que dit Yahvé: Je réduirai à rien les armées de l'Egypte par la main de Nabukodonozor, roi de Babylone."
,"11":"Je l'amènerai, lui et son monde, le tombeur des peuples, pour ravager le pays. Ils frapperont l'Egypte avec l'épée et le pays sera couvert de victimes."
,"12":"Je mettrai ses canaux à sec, et je livrerai aux étrangers le pays et tout ce qu'il contient - parole de Yahvé."
,"13":"Voici ce que dit encore Yahvé: Il n'y aura plus de seigneurs à Nof, plus de princes en Egypte."
,"14":"Je dévasterai Patros, je brûlerai Soan et je châtierai No."
,"15":"Je déchaînerai ma colère contre Sin, la forteresse de l'Egypte et je ferai disparaître la foule de No."
,"16":"Je mettrai le feu à l'Egypte, Sin sera pris de tremblements, à No on ouvrira une brèche et les eaux se déverseront."
,"17":"Les jeunes de On et de Pi-Béset tomberont sous l'épée: la ville ira en captivité."
,"18":"A Tahpanhès le jour se changera en ténèbres lorsque je briserai le sceptre de l'Egypte et mettrai fin à sa puissance insolente; elle ne sortira pas du nuage, et ses villes connaîtront la déportation."
,"19":"Je ferai rendre compte à l'Egypte, et l'on saura que je suis Yahvé."
,"20":"En la onzième année, le sept du premier mois, cette parole de Yahvé me fut adressée:"
,"21":"'Fils d'homme, j'ai brisé le bras de Pharaon roi d'Egypte, et personne n'est venu le soigner, lui appliquer un remède pour qu'il ait la force de reprendre l'épée."
,"22":"C'est pourquoi, voici ce que dit Yahvé: Je vais revenir contre Pharaon roi d'Egypte; je lui briserai le bras et je ferai tomber l'épée de sa main."
,"23":"Je disperserai les Egyptiens au milieu des nations, je les disséminerai parmi les pays."
,"24":"Je rendrai forts les bras du roi de Babylone et je placerai mon épée dans sa main; il en frappera l'Egypte et il s'en ira avec les dépouilles."
,"25":"Je rendrai forts les bras du roi de Babylone, et le Pharaon devra baisser les siens. On saura que je suis Yahvé lorsque je placerai mon épée dans la main du roi de Babylone et qu'il la lèvera contre l'Egypte."
,"26":"Je disperserai les Egyptiens parmi les nations, je les disséminerai parmi les peuples et l'on saura que je suis Yahvé."
}`)
	CurrentBook.AddChapter(31, `{
"1":"En la onzième année, le premier jour du troisième mois, cette parole de Yahvé me fut adressée:"
,"2":"'Fils d'homme, tu diras ceci à Pharaon, roi d'Egypte, et à tout son monde: Comment exprimer ta grandeur? "
,"3":"Tu étais un cèdre du Liban aux branches magnifiques, au feuillage abondant, si haut de taille qu'il atteignait les nuages."
,"4":"Les eaux l'avaient fait grandir, les eaux de dessous terre lui avaient donné sa prestance, et de là où il était, lui-même irriguait par ses canaux tous les arbres de la campagne."
,"5":"Il était le plus élevé des arbres de la campagne, ses branches s'étaient multipliées, ses rameaux s'étendaient tout autour grâce à l'abondance des eaux."
,"6":"Tous les oiseaux du ciel se nichaient dans ses branches, et des peuples nombreux recherchaient son ombre. ("
,"7":"Sa taille, ses longues branches faisaient sa beauté, ses racines étaient tournés vers des eaux abondantes.)"
,"8":"Nul cèdre ne l'égalait dans le jardin de Dieu: les cyprès n'avaient pas de telles branches, les platanes n'avaient pas un tel feuillage."
,"9":"Sa ramure était si fournie, que tout le jardin de Dieu était jaloux de lui."
,"10":"Mais voici ce que dit Yahvé: Il est monté trop haut, sa cime s'est élevée jusqu'aux nuages et son coeur s'est gonflé d'orgueil."
,"11":"C'est pourquoi je le livre aux mains du prince des nations qui le mettra à mal, car moi je l'ai rejeté."
,"12":"Des étrangers, les tombeurs des peuples, l'ont coupé: ils l'ont abattu dans la montagne, et ses branches sont tombées dans toutes les vallées. Elles se sont brisées dans le creux des ravins; tous les peuples de la terre se sont retirés de sous son ombre et l'ont abandonné."
,"13":"Les oiseaux du ciel se perchent sur ses débris, les animaux sauvages s'installent au milieu de ses branches."
,"14":"Qu'on ne voie plus, désormais, un arbre bien irrigué tirant orgueil de sa grandeur, ou qui veuille pousser sa ramure jusqu'aux nuages. Aucun arbre dont les racines atteignent les eaux profondes ne placera plus sa confiance en lui-même, car tous sont voués à la mort, tous iront au séjour des morts comme les humains qui descendent à la tombe."
,"15":"Voici ce que dit Yahvé: Le jour où le cèdre est descendu au séjour des morts, j'ai ordonné un grand deuil; j'ai refermé sur lui l'abîme, j'ai arrêté ses fleuves et les eaux ont tari. Pour lui j'ai vêtu de noir le Liban, et tous les arbres de la campagne se sont fanés."
,"16":"Les nations ont été saisies d'effroi au bruit de sa chute, lorsque je l'ai fait descendre au séjour des morts avec ceux qui descendent à la tombe. Mais dans le pays souterrain tous les arbres d'Eden, les plus beaux du Liban et les mieux irrigués se sont consolés."
,"17":"Ceux qui vivaient à son ombre parmi les nations sont descendus avec lui au séjour des morts, ils ont rejoint les victimes de l'épée."
,"18":"A qui pourrais-je te comparer? Mais je t'ai précipité au plus profond de la terre, tout comme les arbres d'Eden: te voilà couché avec les incirconcis, avec les victimes de l'épée. Voilà Pharaon et voilà son peuple, dit Yahvé."
}`)
	CurrentBook.AddChapter(32, `{
"1":"La douzième année, le premier jour du douzième mois, cette parole de Yahvé me fut adressée:"
,"2":"'Fils d'homme, prononce un chant funèbre sur le Pharaon, roi d'Egypte. Tu diras ceci: Quoi, le lion des nations a disparu? Tu étais comme le dragon des mers; tu faisais bouillonner les eaux, de tes pattes tu en remuais les eaux et tu troublais les flots. "
,"3":"Voici ce que dit Yahvé: J'étendrai sur toi mon filet et je te tirerai sur le rivage avec mes cordes."
,"4":"Je t'abandonnerai sur le sol, je te jetterai sur la face des champs, je ferai descendre sur toi tous les oiseaux du ciel, les bêtes de la terre te dévoreront."
,"5":"J'exposerai tes chairs sur les montagnes, je remplirai les vallées de tes restes"
,"6":"et j'arroserai le pays de ton sang"
,"7":"au jour de ta mort. Je couvrirai les cieux et j'obscurcirai les étoiles, je couvrirai le soleil de nuages et la lune ne donnera plus sa clarté. "
,"8":"A cause de toi j'éteindrai toutes les étoiles du ciel et je répandrai les ténèbres sur ton pays, parole de Yahvé."
,"9":"Beaucoup de peuples seront troublés lorsque j'annoncerai ta ruine à des nations, à des pays que tu ne connaissais pas."
,"10":"De nombreux peuples seront frappés d'épouvante en voyant ton sort, leurs rois seront pris de tremblements quand je ferai passer mon épée devant eux; chacun tremblera pour sa vie au jour de ta ruine."
,"11":"Voici ce que dit Yahvé: L'épée du roi de Babylone arrive chez toi."
,"12":"Je ferai tomber tes multitudes sous l'épée de ses guerriers, les tombeurs des peuples; ils abattront l'orgueil de l'Egypte et tout son monde sera exterminé."
,"13":"Je ferai périr tout son bétail au bord des grandes eaux; ni le pied de l'homme ni les sabots du bétail ne les troubleront plus."
,"14":"Alors les eaux d'Egypte se calmeront, ses fleuves couleront comme l'huile - parole de Yahvé."
,"15":"Je vais ravager l'Egypte; je frapperai ses habitants et elle sera vidée de tout: alors ils sauront que je suis Yahvé."
,"16":"Voilà le chant funèbre que chanteront les filles des nations; elles le chanteront à propos de l'Egypte et de son peuple, elles chanteront ce chant funèbre, parole de Yahvé."
,"17":"En la douzième année, le quinze du premier mois, cette parole de Yahvé me fut adressée:"
,"18":"'Fils d'homme, lamente-toi sur la gloire de l'Egypte et fais-la descendre vers le séjour des morts avec tous ceux qui descendent dans la tombe."
,"20":"Oui, elle descendra chez les victimes de l'épée: c'est là qu'on a placé tout son peuple."
,"21":"Alors, du séjour des morts, les plus fameux et les plus puissants lui parleront:"
,"19":"'Tu te croyais sans doute au-dessus des autres? Descends donc et couche-toi avec les incirconcis, toi et tes auxiliaires, descendez et couchez-vous avec les incirconcis qui sont tombés sous l'épée."
,"22":"Voilà Assour et toute son armée, tous massacrés."
,"23":"On a placé leurs tombeaux dans les profondeurs du séjour des morts et toute cette armée entoure le tombeau d'Assour. Ceux qui répandaient la terreur sur la terre des vivants ont tous été massacrés par l'épée."
,"24":"Voici Elam et tout son peuple regroupé autour de son tombeau. Eux aussi répandaient la terreur sur la terre des vivants, mais ils ont été massacrés par l'épée; ils sont descendus incirconcis au séjour des morts, emportant leur honte chez ceux qui descendent dans la tombe."
,"25":"On les a placés au milieu des victimes."
,"26":"Voici Méchek, voici Toubal et tout son peuple dans les tombeaux qui l'entourent; tous ces incirconcis répandaient la terreur sur la terre des vivants, et puis ils sont tombés sous l'épée."
,"27":"Tous sont couchés avec les héros d'autrefois, car ces hommes sont descendus au séjour des morts les armes à la main. On a placé leur épée sous leur tête et leur bouclier sous leurs ossements, car c'est leur vaillance qui les faisait craindre sur la terre des vivants."
,"28":"Mais toi, c'est au milieu des incirconcis que tu te coucheras, avec les victimes de l'épée."
,"29":"Voici Edom, ses rois et ses chefs; malgré leur courage, ils ont été livrés à l'épée comme les autres. Ils sont couchés avec les incirconcis, avec ceux qui descendent dans la tombe."
,"30":"Voici tous les princes du nord, et les hommes de Sidon: ils sont descendus avec tout leur prestige, en dépit de leur vaillance. Ils sont couchés incirconcis au milieu des victimes de l'épée, ils ont emporté leur honte chez ceux qui descendent à la tombe."
,"31":"En les voyant le Pharaon se consolera de son armée tombée sous l'épée - parole de Yahvé."
,"32":"Lui qui répandait la terreur sur la terre des vivants, on le couchera parmi les incirconcis, parmi les victimes de l'épée, et avec lui toute son armée - parole de Yahvé."
}`)
	CurrentBook.AddChapter(33, `{
"1":"Cette parole de Yahvé me fut adressée:"
,"2":"'Fils d'homme, tu diras ceci aux enfants de mon peuple, tu leur diras: Lorsque je fais venir l'épée contre un pays, les gens du pays choisissent quelqu'un parmi eux et le mettent à faire le guet."
,"3":"S'il voit que l'épée menace l'endroit, il sonne du cor et avertit le peuple."
,"4":"Si quelqu'un entend le son du cor et ne tient pas compte de l'avertissement, si l'épée vient et le fauche, il est responsable de sa mort."
,"5":"S'il a entendu le son du cor et n'a pas tenu compte de l'avertissement, il est responsable, et la sentinelle qui a donné l'avertissement n'a rien à craindre."
,"6":"Mais si le guetteur voit que l'épée menace et ne sonne pas du cor, si le peuple n'est pas averti et que l'épée vient faucher quelqu'un parmi le peuple, celui-ci sera fauché à cause de sa faute, mais je demanderai compte de son sang à la sentinelle."
,"7":"Toi donc, fils d'homme, je t'ai placé comme une sentinelle pour la maison d'Israël; dès que tu entendras une parole sortir de ma bouche, tu les avertiras de ma part."
,"8":"Lorsque je dirai au méchant: 'Méchant, tu vas mourir!' si tu ne lui parles pas, si tu ne le mets pas en garde contre sa mauvaise conduite, le méchant mourra à cause de sa faute, mais je te demanderai compte de son sang."
,"9":"Par contre, si tu as mis en garde le méchant contre sa mauvaise conduite et qu'il ne s'en est pas écarté, s'il ne revient pas de sa mauvaise conduite, il mourra à cause de sa faute et toi tu n'auras rien à craindre."
,"10":"Fils d'homme, tu vas dire à la maison d'Israël: On vous entend dire: 'Nous sommes sous le poids de nos péchés et nous dépérissons à cause d'eux sans espoir d'en sortir.'"
,"11":"Tu leur répondras: 'Aussi vrai que je suis vivant - parole de Yahvé - je ne désire pas la mort du méchant, mais qu'il renonce à sa mauvaise conduite et qu'il vive. Revenez, revenez du chemin que vous avez pris: pourquoi mourir, maison d'Israël?'"
,"12":"Tu diras aux enfants de ton peuple: La justice du juste ne le sauvera pas après qu'il se sera mis à pécher, et la méchanceté du méchant ne le fera pas tomber après qu'il se sera détourné de sa méchanceté, pour la même raison que le juste, lui, ne vivra pas."
,"13":"Je peux dire au juste: Tu vivras! Mais s'il se repose alors sur ses mérites et se met à commettre l'injustice, on oubliera sa justice et il mourra à cause de l'injustice qu'il aura commise."
,"14":"De même je peux dire au méchant: Tu mourras! Mais s'il se détourne de son péché et se met à faire ce qui est droit et juste,"
,"15":"s'il rend ce qu'on lui a prêté ou ce qu'il a volé, s'il marche selon mes commandements et ne commet plus l'injustice, en vérité il vivra et ne mourra pas."
,"16":"On ne tiendra plus compte de tous les péchés qu'il a commis; puisqu'il agit selon le droit et la justice, il vivra."
,"17":"Les enfants de ton peuple disent: 'La façon de voir de Yahvé n'est pas correcte'; mais c'est la leur qui n'est pas correcte."
,"18":"Dès que le juste se détourne de sa justice et commet ce qui est injuste, cela-même le fait mourir."
,"19":"Et quand le méchant se détourne de sa méchanceté et se met à faire ce qui est droit et juste, cela même lui donne la vie."
,"20":"Vous avez beau dire: 'La voie de Yahvé n'est pas correcte', moi je vous jugerai, chacun selon sa conduite, maison d'Israël."
,"21":"En la onzième année de notre déportation, le cinq du dixième mois, un rescapé de Jérusalem arriva chez moi; il me dit: 'La ville est tombée.'"
,"22":"Or la main de Yahvé avait été sur moi durant la soirée avant l'arrivée du fugitif, et au matin, au moment où cet homme arrivait chez moi, Yahvé m'ouvrit la bouche: je n'étais plus muet!"
,"23":"Alors cette parole de Yahvé me fut adressée:"
,"24":"'Fils d'homme, ceux qui sont restés dans les ruines en terre d'Israël disent ceci: Abraham était seul et il a reçu le pays en possession. Nous sommes encore nombreux et le pays nous appartient."
,"25":"Tu leur diras cette parole de Yahvé: 'Vous mangez la chair non saignée, vous tournez vos regards vers vos sales idoles, vous répandez le sang, - et vous voulez posséder ce pays?"
,"26":"Vous êtes sur des ruines, et vous continuez de vivre de façon scandaleuse, chacun souille la femme de son prochain. Et vous voulez posséder ce pays!'"
,"27":"Tu ajouteras: 'Voici ce que dit Yahvé: Aussi vrai que je suis vivant, ceux qui sont dans les ruines tomberont par l'épée, ceux qui sont dans la campagne seront dévorés par les bêtes sauvages, et ceux qui sont dans les abris et les cavernes mourront par la peste."
,"28":"Je ferai de ce pays une ruine, je mettrai par terre leur force et leur orgueil, et les montagnes resteront abandonnées, sans habitants."
,"29":"Le jour où j'aurai fait du pays une ruine et un désert à cause de tous les crimes qu'ils ont commis, ils sauront que je suis Yahvé'."
,"30":"Tu le sais, fils d'homme, les enfants de ton peuple parlent de toi le long des murs et aux portes des maisons, ils se disent l'un à l'autre: 'Allons entendre ce qui vient de Yahvé.'"
,"31":"Alors ils viennent vers toi comme ils iraient ailleurs, ils s'asseyent près de toi pour entendre tes paroles, mais ils ne les mettent pas en pratique. Le mensonge est dans leur bouche et ils ne cherchent que leur intérêt."
,"32":"Tu es pour eux comme une chanson qu'on aime: la voix est belle et il joue bien! Ils écoutent tes paroles mais ils n'en font rien."
,"33":"Mais quand cela arrivera - et cela va arriver - ils sauront qu'il y avait un prophète au milieu d'eux."
}`)
	CurrentBook.AddChapter(34, `{
"1":"Cette parole de Yahvé me fut adressée:"
,"2":"'Fils d'homme, prophétise contre les bergers d'Israël, prophétise! Tu diras aux bergers: Voici une parole de Yahvé: Malheur aux bergers d'Israël: des bergers qui prennent soin d'eux-mêmes! N'est-ce pas du troupeau que le berger prend soin? "
,"3":"Vous vous nourrissez du lait, vous vous habillez de la laine, vous sacrifiez les bêtes grasses, mais vous ne prenez pas soin des brebis."
,"4":"Vous n'avez pas raffermi la brebis épuisée, vous n'avez pas soigné celle qui était malade, ni pansé celle qui était blessée, vous n'avez pas ramené la brebis égarée, et pas même cherché celle qui était perdue. Quant à celles qui étaient fortes, vous les avez menées par la terreur."
,"5":"Faute de bergers, mes brebis se sont dispersées: une proie toute prête pour les bêtes sauvages."
,"6":"Mon troupeau s'est dispersé dans la montagne et sur les collines; il reste dispersé à travers tout le pays, et personne ne s'inquiète ou part à sa recherche."
,"7":"C'est pourquoi, bergers, écoutez la parole de Yahvé:"
,"8":"Aussi vrai que je suis vivant, dit Yahvé, si mes brebis ont été livrées aux pillards, si elles sont devenues la proie des bêtes sauvages, la faute est aux bergers. Mes bergers n'ont pas pris soin de mes brebis, c'est d'eux-mêmes qu'ils prenaient soin, et non pas du troupeau."
,"9":"C'est pourquoi, bergers,"
,"10":"Yahvé a parlé: Je vais droit aux bergers pour leur reprendre mon troupeau. Ils ne seront plus les bergers du troupeau, des bergers qui prennent soin d'eux-mêmes. J'arracherai mes brebis de leur bouche et elles ne seront plus leur proie."
,"11":"Car voici ce que dit Yahvé: Me voici, je suis là! Je viens rechercher les brebis et c'est moi qui m'en occuperai,"
,"12":"comme le berger s'occupe de son troupeau le jour où il se trouve au milieu de ses brebis en liberté. Moi aussi je m'occuperai de mes brebis et je les tirerai de tous les lieux où elles ont été dispersées en un jour de brouillard et de sombres nuages."
,"13":"Je les ferai sortir du milieu des autres peuples, je les rassemblerai des différents pays et je les conduirai sur leur propre terre. Je les ferai brouter sur les montagnes d'Israël, dans les vallées et dans tous les pâturages du pays."
,"14":"Oui, je les ferai brouter dans un bon pâturage, sur les hautes montagnes d'Israël; elles reposeront dans une bonne bergerie et se nourriront dans les grasses prairies des montagnes d'Israël."
,"15":"C'est moi qui prendrai soin de mes brebis, c'est moi qui les ferai reposer - parole de Yahvé."
,"16":"Je chercherai celle qui est perdue, je ramènerai celle qui est égarée, je panserai celle qui est blessée, je raffermirai celle qui est malade, je veillerai sur celle qui est forte; je prendrai soin d'elles avec justice."
,"17":"Et vous, mes brebis, voici ce que vous dit Yahvé: Je vais juger entre brebis et brebis, entre béliers et boucs."
,"18":"Quoi, cela ne vous suffisait pas de paître dans un bon pâturage? Pourquoi avez-vous piétiné le reste de l'herbe? Vous buviez une eau claire, pourquoi avez-vous troublé le reste avec vos pieds?"
,"19":"Mes brebis doivent-elles brouter ce que vous avez piétiné et boire ce que vous avez troublé de vos pieds?"
,"20":"C'est pourquoi, voici ce que vous dit Yahvé: Je vais faire le jugement de la brebis grasse et de la brebis maigre."
,"21":"Vous avez bousculé des côtes et de l'épaule, vous avez frappé de la corne tous les plus faibles, jusqu'à ce que vous les ayez chassés dehors."
,"22":"C'est pourquoi je vais sauver mes brebis, les mettre à l'abri des pillards, et je jugerai entre brebis et brebis."
,"23":"J'appellerai à leur tête un berger unique pour prendre soin d'elles, mon serviteur David. Lui sera leur berger."
,"24":"Moi, Yahvé, je serai leur Dieu, et mon serviteur David sera prince au milieu d'elles."
,"25":"Je conclurai avec elles une alliance de paix, je ferai disparaître du pays les bêtes sauvages; mes brebis pourront rester dans le désert et dormir dans les forêts."
,"26":"Je les installerai tout autour de ma colline et je ferai tomber la pluie en son temps; ce sera une pluie de bénédiction."
,"27":"L'arbre des champs donnera son fruit et la terre sa récolte; mon peuple sera en sécurité sur sa terre, car j'aurai brisé leur joug, je les aurai délivrés des mains de leurs oppresseurs. Alors ils sauront que je suis Yahvé."
,"28":"Ils ne seront plus la proie des nations, les bêtes sauvages ne les dévoreront plus, mais ils habiteront en paix et personne ne viendra les inquiéter."
,"29":"Je ferai que la terre produise abondamment: ils ne connaîtront plus la famine, ils ne connaîtront plus cette humiliation devant les autres peuples."
,"30":"Car je suis Yahvé leur Dieu, et ils sont Israël, mon peuple - parole de Yahvé."
,"31":"Vous êtes mon troupeau, les brebis de mon pâturage, et moi je suis votre Dieu - parole de Yahvé."
}`)
	CurrentBook.AddChapter(35, `{
"1":"Cette parole de Yahvé me fut adressée:"
,"2":"'Tourne ton regard vers la montagne de Séïr et prophétise contre elle. Tu leur diras"
,"3":"de la part de Yahvé: Voici que je viens et que j'étends la main sur toi, montagne de Séïr, je vais faire de toi une ruine et un désert."
,"4":"Tes villes seront ravagées, tu deviendras un désert et tu sauras que je suis Yahvé."
,"5":"Avec ta haine de toujours, tu as livré les Israélites à l'épée au temps de l'épreuve, quand j'ai mis fin à leurs fautes."
,"6":"C'est pourquoi, aussi vrai que je suis vivant, dit Yahvé, puisque tu as fait verser le sang, le sang te poursuivra."
,"7":"Je ferai de la montagne de Séïr une ruine et un désert et j'en éliminerai toute présence humaine."
,"8":"Tes montagnes seront couvertes de cadavres; l'épée fera des victimes sur tes collines, dans tes vallées et dans tous les ravins."
,"9":"Je te ruinerai pour toujours et tes villes ne seront plus habitées; alors tu sauras que je suis Yahvé."
,"10":"Comment as-tu pu dire: 'Les deux nations sont à moi, leur terre maintenant m'appartient'? Yahvé était là!"
,"11":"Aussi vrai que je suis vivant, dit Yahvé, ma colère et ma jalousie seront aussi grandes que la haine que tu as eue pour eux; je me ferai connaître à toi le jour où je te jugerai."
,"12":"Tu sauras que moi, Yahvé, j'ai entendu toutes ces insultes que tu as lancées: 'Tout est ruiné, tout sera pour nous!'"
,"13":"Vous avez tenu contre moi des propos insolents, et moi j'ai entendu."
,"14":"Ainsi parle Yahvé: alors que toute la terre sera dans la joie, je ferai de toi une ruine."
,"15":"Non seulement la montagne de Séïr, mais tout Edom sera ravagé, et l'on saura que je suis Yahvé."
}`)
	CurrentBook.AddChapter(36, `{
"1":"Prophétise donc, fils d'homme, pour les montagnes d'Israël. Dis-leur: Montagnes d'Israël, écoutez une parole de Yahvé."
,"2":"Voici ce que dit Yahvé: L'ennemi s'est moqué de vous: 'Ah oui, les montagnes éternelles sont devenues notre propriété!'"
,"3":"C'est pourquoi tu vas prophétiser. Dis-leur de ma part: Vous avez été dévastées, piétinées de tous côtés, vous êtes devenues la propriété des autres nations, on a raconté n'importe quoi sur votre compte, on vous a insultées. "
,"4":"Eh bien, montagnes d'Israël, écoutez la parole de Yahvé. Voici ce qu'il dit aux montagnes et aux collines, aux ravins et aux vallées, aux ruines dévastées et aux villes abandonnées qui sont devenues une proie et un jeu pour ce qui restait de leurs voisins:"
,"5":"Oui, dans le feu de mon indignation je me tournerai contre Edom et les autres nations qui se sont emparées de ma terre avec plaisir et beaucoup de mépris, pour la prendre ou la piller."
,"6":"C'est pourquoi, prophétise à propos de la terre d'Israël. Tu diras aux montagnes et aux collines, aux ravins et aux vallées, cette parole de Yahvé: Voici ce que j'ai décidé dans mon indignation et ma colère. Puisque vous avez été humiliées par les nations,"
,"7":"à mon tour je lève la main pour jurer que les nations qui vous entourent vont être humiliées."
,"8":"Mais vous, montagnes d'Israël, vous produirez récoltes et fruits pour mon peuple Israël qui est près de revenir."
,"9":"Je vais revenir chez vous et me tourner vers vous; vous serez travaillées et ensemencées."
,"10":"Je multiplierai sur vous les hommes, toute la maison d'Israël; les villes seront de nouveau habitées, et les ruines rebâties."
,"11":"Je multiplierai sur vous les humains comme le bétail. Vous serez habitées comme autrefois et je vous traiterai mieux encore que dans les commencements; alors vous saurez que je suis Yahvé."
,"12":"Sur vous, montagnes d'Israël, on verra circuler du monde, les enfants d'Israël mon peuple. Ils s'installeront chez toi, tu redeviendras leur héritage et tu ne les laisseras plus désormais sans enfants."
,"13":"Voici ce que dit Yahvé: On dit que tu dévores tes habitants et que tu laisses la nation sans enfants."
,"14":"Eh bien, tu ne dévoreras plus tes habitants et tu ne laisseras plus ta nation sans enfants - parole de Yahvé."
,"15":"Je ferai que tu ne te fasses plus insulter par les nations - parole de Yahvé.'"
,"16":"Cette parole de Yahvé me fut adressée:"
,"17":"'Fils d'homme, lorsqu'Israël habitait sur son sol, il l'a rendu impur par sa conduite et ses actions; leur conduite était à mes yeux comme l'impureté d'une femme."
,"18":"Alors j'ai déchaîné contre eux ma colère,"
,"19":"je les ai dispersés au milieu des nations, disséminés parmi les pays; je les ai jugés selon leur conduite et leurs actions."
,"20":"Ils sont donc arrivés parmi les nations. Mais là encore mon saint Nom a été profané. On disait en effet: 'C'est le peuple de Yahvé qui a dû sortir de son pays.' "
,"21":"Alors j'ai eu à coeur la sainteté de mon Nom, car dans les nations où se trouvait la maison d'Israël, et à cause d'elle, mon Nom était profané."
,"22":"C'est pourquoi tu vas dire à la maison d'Israël cette parole de Yahvé: ce n'est pas pour vous que je le fais, maison d'Israël, c'est pour mon saint Nom qui par votre faute a été profané parmi les nations où vous êtes."
,"23":"Je sanctifierai mon Nom qui a été profané parmi les nations - et c'est vous qui l'avez fait mépriser. Les nations sauront que je suis Yahvé lorsque, à travers vous, je montrerai à leurs yeux ma sainteté."
,"24":"Je vous prendrai du milieu des nations, je vous rassemblerai d'entre les peuples et je vous ramènerai sur votre terre."
,"25":"Je vous aspergerai d'une eau pure et vous serez purifiés; je vous purifierai de toutes vos impuretés et de toutes vos sales idoles."
,"26":"Je vous donnerai un coeur nouveau et je mettrai au dedans de vous un esprit nouveau. J'enlèverai de votre chair le coeur de pierre et je vous donnerai un coeur de chair."
,"27":"Je mettrai en vous mon Esprit et je ferai que vous marchiez selon mes commandements, que vous observiez mes lois et les mettiez en pratique."
,"28":"Vous habiterez le pays que j'ai donné à vos pères, vous serez mon peuple et je serai votre Dieu."
,"29":"Je vous délivrerai de toutes vos impuretés. J'appellerai le blé et il poussera en abondance; je ne vous enverrai plus la famine."
,"30":"Je multiplierai les fruits des arbres et les produits des champs; vous ne serez plus humiliés par la famine aux yeux des autres nations."
,"31":"Alors vous vous souviendrez de votre conduite et de vos actions mauvaises, vous aurez honte de vous-mêmes à cause de vos fautes et de vos crimes."
,"32":"Sachez-le bien, dit Yahvé, ce n'est pas à cause de vous que je le fais. Ayez honte et rougissez de votre conduite, maison d'Israël."
,"33":"Voici ce que dit Yahvé: Le jour où je vous purifierai de vos fautes, je ferai que les villes soient habitées et les ruines reconstruites."
,"34":"La terre ravagée sera de nouveau cultivée après que tous les passants l'auront vue abandonnée."
,"35":"On dira même: 'Cette terre qui était à l'abandon est devenue un jardin d'Eden, les villes en ruines, abandonnées, détruites, ont aujourd'hui des murs et sont habitées.'"
,"36":"Alors les nations qui sont restées autour de vous sauront que moi, Yahvé, j'ai reconstruit ce qui était démoli, j'ai replanté ce qui était ravagé. Moi Yahvé, je le dis et je le ferai."
,"37":"Voici ce que dit Yahvé: J'accorderai encore ceci aux prières de la maison d'Israël: je multiplierai chez eux les hommes autant que le bétail."
,"38":"Dans les villes autrefois en ruines, les hommes seront nombreux comme des brebis, comme le troupeau des bêtes consacrées, comme les brebis dans Jérusalem à l'occasion des grandes assemblées; alors on saura que je suis Yahvé."
}`)
	CurrentBook.AddChapter(37, `{
"1":"La main de Yahvé fut sur moi. Yahvé me fit sortir par son esprit. Il me déposa au milieu de la vallée, et voici qu'elle était pleine d'ossements."
,"2":"Il me fit parcourir la vallée en tout sens; les ossements étaient très nombreux à la surface du sol, et ils étaient complètement secs."
,"3":"Alors il me dit: 'Fils d'homme, ces ossements pourront-ils revivre?' Je répondis: 'Yahvé, c'est toi qui le sais.'"
,"4":"Il me dit: Prophétise sur ces ossements, tu leur diras: Ossements desséchés, écoutez la parole de Yahvé!"
,"5":"Voici ce que dit Yahvé à ces ossements: Je vais faire qu'un esprit entre en vous, et vous vivrez."
,"6":"Je mettrai sur vous des nerfs, je ferai pousser sur vous la chair, j'étendrai sur vous la peau, je mettrai en vous un esprit et vous vivrez: et vous saurez que je suis Yahvé.'"
,"7":"Je fis donc comme j'en avais reçu l'ordre et, tandis que je prophétisais, il y eut toute une agitation: les os se rapprochaient les uns des autres."
,"8":"Je regardai: je les vis se couvrir de nerfs, la chair repoussait et la peau se tendait par-dessus. Mais il n'y avait pas d'esprit en eux."
,"9":"Alors il me dit: 'Prophétise, fils d'homme, appelle l'Esprit! Tu diras à l'Esprit: Voici ce que dit Yahvé: Esprit, viens des quatre vents, souffle sur ces morts afin qu'ils vivent.'"
,"10":"Je prophétisai comme j'en avais reçu l'ordre et l'Esprit entra en eux; ils reprirent vie et se dressèrent sur leurs pieds: c'était une grande, une immense armée."
,"11":"Yahvé me dit alors: Fils d'homme, ces ossements, c'est toute la maison d'Israël. Ils disent: 'Nos os sont desséchés, nos espoirs sont morts, nous avons été rejetés.'"
,"12":"C'est pourquoi prophétise! Tu leur diras cette parole de Yahvé: 'Je vais ouvrir vos tombes, ô mon peuple, je vous ferai remonter de vos tombes et je vous ramènerai sur la terre d'Israël. "
,"13":"Alors vous saurez que je suis Yahvé lorsque j'ouvrirai vos tombes, que je vous en ferai remonter."
,"14":"Je mettrai en vous mon Esprit et vous vivrez; je vous établirai sur votre terre et vous saurez que moi, Yahvé, je dis et je fais - parole de Yahvé.'"
,"15":"Cette parole de Yahvé me fut adressée:"
,"16":"Fils d'homme, prends un morceau de bois sur lequel tu écriras: 'A Juda et aux enfants d'Israël qui lui sont réunis.' Tu prendras ensuite un autre morceau de bois et tu écriras dessus: 'A Joseph.' Ce sera le bois (d'Ephraïm et) de toute la maison d'Israël qui lui est réunie."
,"17":"Puis tu les rapprocheras l'un de l'autre pour qu'ils soient dans ta main comme d'une seule pièce."
,"18":"Lorsque les enfants de ton peuple te diront: 'Vas-tu nous expliquer ce que cela signifie?'"
,"19":"tu leur répondras: 'Voici ce que dit Yahvé: Je m'apprête à prendre le bois de Joseph avec les tribus d'Israël qui lui sont réunies; je les joindrai au bois de Juda et ils n'en feront plus qu'un dans ma main.'"
,"20":"Tu tiendras dans ta main sous leurs yeux les morceaux de bois sur lesquels tu auras écrit,"
,"21":"et tu leur diras de la part de Yahvé: Je vais reprendre les enfants d'Israël du milieu des nations où ils sont allés, je les rassemblerai de toutes parts et les réunirai sur leur terre."
,"22":"Je ferai d'eux une seule nation dans mon pays sur les montagnes d'Israël; un roi unique régnera sur eux tous, ils ne seront plus deux nations, ils ne seront plus séparés en deux royaumes."
,"23":"Ils ne se souilleront plus avec leurs sales idoles, car je les délivrerai de leurs péchés et de toutes leurs révoltes et je les purifierai; ils seront mon peuple et je serai leur Dieu."
,"24":"Mon serviteur David régnera sur eux, il n'auront tous qu'un seul berger. Alors ils marcheront selon mes commandements, ils observeront mes lois et les mettront en pratique."
,"25":"Ils habiteront sur la terre que j'ai donnée à mon serviteur Jacob, cette terre où ils ont habité. Ils y habiteront pour toujours, eux et leurs fils et les fils de leurs fils; mon serviteur David sera leur prince à jamais."
,"26":"Je leur accorderai une alliance de paix, une alliance avec moi pour toujours; je placerai mon sanctuaire au milieu d'eux pour toujours."
,"27":"Ma Demeure restera au-dessus d'eux, je serai leur Dieu et ils seront mon peuple."
,"28":"Les nations sauront que je suis Yahvé qui sanctifie Israël lorsque mon sanctuaire sera au milieu d'eux pour toujours."
}`)
	CurrentBook.AddChapter(38, `{
"1":"Cette parole de Yahvé me fut adressée:"
,"2":"Fils d'homme, tourne ton regard vers Gog, du pays de Magog, le grand chef de Méchek et de Toubal; tu prophétiseras contre lui."
,"3":"Tu diras: Voici ce que dit Yahvé: Je viens te chercher, Gog, grand chef de Méchek et de Toubal. "
,"4":"Je te mettrai en marche avec toute ton armée, tes chevaux et tes cavaliers, tous magnifiquement vêtus, tes troupes nombreuses armées d'épées, de lances et de boucliers."
,"5":"Là sont les Perses, les Kouchites et les gens de Pout, tous avec leurs armes et leurs casques;"
,"6":"Gomer également avec toutes ses troupes, et Beth-Togorma venu des pays lointains du nord avec toutes ses troupes. Que de peuples avec toi!"
,"7":"Prépare-toi et soyez prêts, toi et toute l'armée que tu as rassemblée autour de toi, tiens-toi à ma disposition."
,"8":"Dans très longtemps tu recevras des ordres, après bien des années tu te mettras en route pour le pays dont les habitants ont échappé à l'épée; ils ont été rassemblés du milieu de nombreux peuples sur les montagnes d'Israël qui furent longtemps à l'abandon. Depuis qu'ils ont été séparés des autres peuples, ils habitent tous en paix."
,"9":"C'est alors que tu arriveras comme l'ouragan, que tu couvriras le pays comme font les nuages, toi et toute ton armée avec les nombreux peuples qui t'accompagnent."
,"10":"Voici ce que dit Yahvé: En ce jour-là, des pensées te viendront à l'esprit et tu auras en tête de mauvais projets."
,"11":"Tu te diras: Je vais monter contre un pays sans défense, j'attaquerai des gens tranquilles qui habitent en paix dans des villes sans remparts, sans portes ni verrous."
,"12":"J'emporterai leurs dépouilles et je ramasserai du butin, j'étendrai la main sur ces ruines qui se sont repeuplées, sur ce peuple revenu d'entre les nations, qui vit de l'élevage et du commerce et qui habite le nombril de la terre."
,"13":"Alors Chéba, Dédan, les commerçants de Tarsis et tous les autres te diront: 'Est-ce pour ramasser des dépouilles que tu es venu? Est-ce pour emporter un butin que tu as rassemblé ton armée? Est-ce pour emporter de l'or et de l'argent, pour enlever des troupeaux et des trésors, pour ramasser des dépouilles en quantité?'"
,"14":"C'est pourquoi, fils d'homme, prophétise et dis à Gog de ma part: Ce jour viendra lorsque mon peuple Israël habitera en sécurité, c'est alors que tu tomberas sur lui."
,"15":"Tu viendras de ton pays, aux extrémités du nord, avec des peuples nombreux, tous montés sur des chevaux, une grande, une immense armée."
,"16":"Tu arriveras sur mon peuple Israël comme les nuages qui viennent couvrir le pays; cela se passera dans la suite des jours. Je veux te faire venir contre mon pays, Gog, pour que les nations me connaissent, car grâce à toi je manifesterai aux yeux de tous ma sainteté."
,"17":"Voici ce que dit Yahvé: N'es-tu pas celui dont j'ai parlé dans les jours anciens par la bouche de mes serviteurs les prophètes d'Israël? En ces jours-là, au long des années, ils ont prophétisé que je te ferais venir contre eux."
,"18":"Or en ce jour-là, en ce jour où Gog envahira la terre d'Israël, dit Yahvé, la colère me montera au nez."
,"19":"Dans ma jalousie et dans le feu de ma colère, je le dis: Oui, en ce jour-là, ce sera un tremblement de terre en Israël."
,"20":"Devant moi trembleront les poissons de la mer, les oiseaux du ciel, les bêtes des champs, tous les reptiles qui rampent à la surface du sol et tous les hommes qui sont sur la terre. Les montagnes s'effondreront, les falaises s'écrouleront et tous les remparts tomberont.'"
,"21":"C'est alors que j'appellerai contre lui l'épouvante, dit Yahvé: ils tourneront leur épée les uns contre les autres."
,"22":"Je ferai justice de lui par la peste et le sang, je ferai pleuvoir sur lui, sur son armée et sur les nombreux peuples qui l'accompagnent, une pluie torrentielle, des grêlons, du feu et du soufre."
,"23":"Je montrerai ma grandeur et ma sainteté, et je me ferai connaître aux yeux de nombreuses nations: elles sauront que je suis Yahvé."
}`)
	CurrentBook.AddChapter(39, `{
"1":"Fils d'homme, prophétise donc contre Gog. Tu diras: Voici ce que dit Yahvé: Je me dirige vers toi, Gog, grand chef de Méchek et de Toubal."
,"2":"Je te mènerai, je te conduirai, je te ferai venir des extrémités du nord et je te ferai monter sur les montagnes d'Israël."
,"3":"Dans ta main gauche, je briserai ton arc, et je ferai tomber les flèches de ta main droite."
,"4":"Tu tomberas sur les montagnes d'Israël avec toute ton armée et tous les peuples venus avec toi. Je t'ai déjà livré en pâture aux rapaces, aux oiseaux de toute espèce et aux bêtes sauvages."
,"5":"Tu tomberas sur le sol en pleine campagne, c'est moi qui le dis - parole de Yahvé."
,"6":"J'enverrai un feu dans Magog et chez les habitants des îles qui vivent en sécurité, et ils sauront que je suis Yahvé."
,"7":"Je ferai connaître mon saint Nom au milieu de mon peuple Israël; je ne laisserai plus profaner mon saint Nom et les nations sauront que je suis Yahvé, le Saint d'Israël."
,"8":"La chose vient, dit Yahvé, elle va se faire; voici venir le jour dont j'ai parlé."
,"9":"Alors les habitants des villes d'Israël sortiront, ils feront des feux et ils y brûleront les armes, les petits et les grands boucliers, l'arc et les flèches, le javelot et la lance, ils en feront du feu pour sept ans."
,"10":"On ne les verra plus transporter du bois ramassé dans la campagne, ils n'iront plus en chercher dans les forêts, car ils feront du feu avec les armes; ils dépouilleront ceux qui les dépouillaient et pilleront ceux qui les pillaient - parole de Yahvé."
,"11":"En ce jour-là je donnerai comme sépul ture à Gog un lieu célèbre en Israël: la vallée des Abarim, à l'est de la mer, la vallée où le passant doit s'arrêter. C'est là qu'on enterrera Gog et toute son armée, et on l'appellera: vallée de Hamon-Gog."
,"12":"Il faudra alors purifier le pays: pendant sept mois le peuple d'Israël les enterrera."
,"13":"Tous les gens du pays travailleront à les enterrer et ils en seront fiers, le jour où je manifesterai ma gloire - parole de Yahvé."
,"14":"Passés les sept mois, on désignera des hommes pour parcourir le pays et enterrer ceux qui seront restés, afin de purifier le sol."
,"15":"Ils parcourront donc le pays, et celui qui verra des ossements humains élèvera à côté un tas de pierres: ensuite les fossoyeurs les enterreront dans la vallée de Hamon-Gog."
,"16":"Ainsi le pays sera purifié."
,"17":"Fils d'homme, dis aux oiseaux de toute espèce et aux bêtes sauvages: 'Rassemblez-vous, venez de partout et réunissez-vous pour le sacrifice - parole de Yahvé - un grand sacrifice que je vous ai préparé sur les montagnes d'Israël; il y aura de la viande à manger et du sang à boire."
,"18":"Vous mangerez la chair des guerriers, vous boirez le sang des chefs de la terre: voilà bien des béliers, des agneaux, des boucs et des taureaux gras de Bashan!"
,"19":"A ce sacrifice que je vous ai préparé, la graisse ne vous sera pas mesurée, et vous boirez du sang jusqu'à vous enivrer."
,"20":"C'est Yahvé qui vous le dit: à ma table vous serez rassasiés de chevaux et d'attelages, d'hommes d'élite et de soldats."
,"21":"Je montrerai ainsi ma gloire aux nations. Je veux qu'elles sachent ce qu'est ma justice et comment je sais abattre ma main sur elles."
,"22":"Alors et pour toujours la maison d'Israël saura que je suis Yahvé son Dieu."
,"23":"Les nations comprendront que si le peuple d'Israël a été exilé, c'est parce qu'il a péché contre moi; je lui ai caché mon visage car il m'était infidèle; je l'ai livré aux mains de ses ennemis, et tous sont tombés par l'épée."
,"24":"Je les ai traités comme le méritaient leurs péchés et leurs infidélités, et je leur ai caché mon visage."
,"25":"C'est pourquoi, voici ce que dit Yahvé: Je vais ramener les exilés de Jacob, j'aurai pitié d'Israël tout entier et je défendrai jalousement mon saint Nom."
,"26":"Lorsqu'ils habiteront leur pays en paix et que personne déjà ne les inquiétera, ils oublieront leur triste passé et toutes les infidélités qu'ils ont commises envers moi."
,"27":"Je les rassemblerai du milieu des peuples et je les ferai revenir du pays de leurs ennemis, grâce à eux je manifesterai ma sainteté devant de nombreuses nations."
,"28":"Ils sauront que je suis Yahvé leur Dieu lorsque je me manifesterai aux nations païennes."
,"29":"Je ne leur cacherai plus mon visage mais je répandrai mon Esprit sur le peuple d'Israël - parole de Yahvé."
}`)
	CurrentBook.AddChapter(40, `{
"1":"On était au début de la vingt-cinquième année de notre exil; c'était le dix du mois, quatorze ans après la chute de la ville; ce jour-là la main de Yahvé fut sur moi et il me conduisit là-bas."
,"2":"Par des visions divines, il m'emmena au pays d'Israël et me déposa sur une très haute montagne. Sur le versant sud je crus voir les constructions d'une ville."
,"3":"Il m'y conduisit, et voici qu'il y avait là à l'entrée un homme qu'on aurait cru de bronze; dans sa main il tenait un cordeau de lin et une perche à mesurer."
,"4":"Cet homme me dit: Fils d'homme, regarde bien, écoute de toutes tes oreilles et fais bien attention à tout ce que je vais te montrer, car c'est pour cela qu'on t'a amené ici; tout ce que tu vas voir, tu le feras connaître à la maison d'Israël.'"
,"5":"Un mur, tout autour de la Maison, la séparait de l'extérieur. L'homme avait à la main une perche à mesurer qui faisait six grandes coudées de long. Il mesura cet ouvrage: une perche d'épaisseur et une perche de hauteur."
,"6":"L'homme s'approcha ensuite du porche qui regarde vers l'orient, il en monta les marches et mesura le seuil du porche; il avait une profondeur d'une perche."
,"7":"Chacune des chambres avait une perche de longueur et une perche de largeur, les piliers qui séparaient les chambres avaient cinq coudées d'épaisseur."
,"8":"Le seuil du porche qui regardait vers l'intérieur, du côté du vestibule, avait une perche de profondeur."
,"9":"L'homme mesura encore le vestibule du porche, qui donnait sur l'intérieur: huit coudées; son pilier en faisait deux."
,"10":"Dans ce porche de l'est il y avait trois chambres de chaque côté, toutes trois de même dimension; les piliers aussi étaient de même dimension."
,"11":"Il mesura la largeur de l'entrée du porche: dix coudées; quant au porche, il mesurait treize coudées de long."
,"12":"Les chambres mesuraient six coudées dans chaque sens et devant chacune il y avait une balustrade d'une coudée."
,"13":"L'homme mesura le porche d'une ouverture à l'autre: vingt-cinq coudées."
,"14":"Il mesura le vestibule, qui faisait vingt coudées; le parvis s'étendait tout autour du porche."
,"15":"Depuis la façade du porche jusqu'au fond du vestibule intérieur, il mesura cinquante coudées."
,"16":"Les chambres et les piliers étaient garnis de fenêtres grillagées regardant vers l'intérieur du porche; il y en avait également tout autour du vestibule. Quant aux piliers, ils étaient décorés de palmiers."
,"17":"Il me fit entrer dans la cour extérieure; on y avait disposé trente salles et un dallage faisait tout le tour de la cour."
,"18":"Ce dallage s'ajustait à la profondeur des porches; c'était le dallage intérieur."
,"19":"Depuis la façade de la porte intérieure jusqu'à l'extérieur, il mesura cent coudées. Voilà pour l'est. Au nord, "
,"20":"il mesura la longueur et la largeur du porche qui donnait sur la cour extérieure."
,"21":"Les six chambres réparties sur les deux côtés, les piliers et le vestibule avaient les même dimensions que dans le premier porche; sa largeur était de cinquante coudées et sa profondeur de vingt-cinq."
,"22":"Les fenêtres, le vestibule et les palmiers avaient la même dimension que ceux du porche de l'est; on y accédait par sept marches et le vestibule ouvrait sur l'intérieur."
,"23":"La cour intérieure avait une porte tournée vers le porche du nord, semblable à celle qui regardait vers l'est; l'homme mesura d'une porte à l'autre et trouva cent coudées."
,"24":"Il me conduisit alors vers le sud, et au sud il y avait un porche; il en mesura les piliers et le vestibule: c'étaient les mêmes dimensions."
,"25":"Le porche, le vestibule et les fenêtres tout autour étaient semblables, la largeur du porche était de cinquante coudées et sa profondeur de vingt-cinq."
,"26":"On accédait au vestibule par sept marches, des palmiers décoraient les piliers de part et d'autre."
,"27":"La cour intérieure avait une porte donnant vers le porche du sud; il mesura cent coudées d'une porte à l'autre."
,"28":"Il me ramena vers la cour intérieure par le porche sud et il mesura son porche; il avait les mêmes dimensions que les autres."
,"29":"Ses chambres, ses piliers et son vestibule avaient les mêmes dimensions; le porche et son vestibule avaient des fenêtres tout autour, la longueur du porche était de cinquante coudées et sa largeur de vingt-cinq."
,"30":"Des vestibules l'entouraient longs de vingt coudées et larges de cinq."
,"31":"Son vestibule donnait sur la cour extérieure, des palmiers ornaient ses piliers et l'on y accédait par huit marches."
,"32":"Il me ramena à la cour intérieure par l'est, et il mesura son porche; il avait les mêmes dimensions que les autres."
,"33":"Ses chambres, ses piliers et son vestibule avaient les mêmes dimensions, le porche et son vestibule avaient des fenêtres tout autour. Sa largeur était de cinquante coudées et sa profondeur de vingt-cinq."
,"34":"Son vestibule donnait sur la cour extérieure, des palmiers ornaient ses piliers de part et d'autre et on y accédait par huit marches."
,"35":"Il me fit revenir par l'entrée nord, et il retrouva les mêmes mesure."
,"36":"L'entrée avait ses chambres, ses piliers, son vestibule avec des fenêtres tout autour, sa longueur était de cinquante coudées et sa largeur de vingt-cinq."
,"37":"Son vestibule donnait sur la cour extérieure, des palmiers ornaient ses piliers de part et d'autre et l'on y accédait par huit marches."
,"38":"Une salle s'ouvrait sur le vestibule de la porte; c'est là qu'on lave les victimes pour l'holocauste."
,"39":"Dans le vestibule de la porte il y avait deux tables d'un côté et deux de l'autre pour égorger les victimes pour l'holocauste, les victimes pour le péché ou en réparation."
,"40":"A l'extérieur, en sortant vers le nord, il y avait deux tables d'un côté et deux tables de l'autre."
,"41":"Ainsi il y avait quatre tables à l'intérieur et quatre à l'extérieur de la porte, soit huit tables sur lesquelles on égorgeait les victimes."
,"42":"Les quatre tables pour l'holocauste étaient en pierres de taille longues d'une coudée et demie, larges d'une coudée et demie et hautes d'une coudée. Sur ces tables on déposait les instruments avec lesquels on égorgeait les victimes pour les holocaustes et les divers sacrifices;"
,"43":"ces tables sur lesquelles on déposait la viande des sacrifices avaient un rebord d'un palme de large qui en faisait le tour."
,"44":"Il me fit entrer dans la cour intérieure. Il y avait là deux salles, une tournée vers la fa çade sud du porche nord, l'autre vers la façade nord du porche sud."
,"45":"L'homme me dit: 'La salle qui fait face au sud est réservée aux prêtres qui assurent le service de la Maison."
,"46":"La salle qui fait face au nord est réservée aux prêtres qui assurent le service de l'autel. Parmi les lévites, les fils de Sadoq ont le privilège de s'approcher de Yahvé et de le servir.'"
,"47":"Il mesura la cour, elle était carrée, longue de cent coudées et large de cent. L'autel était en face de la Maison."
,"48":"Il me fit entrer dans le vestibule de la Maison et il en mesura les piliers: cinq coudées d'un côté comme de l'autre. La porte était large de quatorze coudées, entourée de montants larges de trois coudées."
,"49":"Le vestibule avait vingt coudées de large et douze de profondeur; on y accédait par dix marches. Des colonnes encadraient les piliers de chaque côté."
}`)
	CurrentBook.AddChapter(41, `{
"1":"Il me fit entrer dans l'avant-sanctuaire et mesura les piliers de chaque côté: ils faisaient six coudées de large."
,"2":"L'entrée mesurait dix coudées de large et ses montants en faisaient cinq; il mesura sa profondeur, quarante coudées et sa largeur, vingt coudées."
,"3":"Puis il entra dans le sanctuaire et mesura le pilier de l'entrée; il faisait deux coudées de large. L'entrée faisait six coudées, et le mur de chaque côté en faisait sept."
,"4":"Il mesura vingt coudées pour la largeur et vingt pour la profondeur de cette salle, puis il ajouta: 'C'est le Saint des Saints.'"
,"5":"Il mesura ensuite le mur de la Maison; il avait six coudées de haut, la largeur du couloir qui entourait la Maison était de quatre coudées."
,"6":"On y avait aménagé des petites chambres sur trois étages; il y avait trente chamtes chambres augmentait d'un étage à l'autre en prenant sur l'épaisseur du mur; il en était ainsi tout autour de la Maison."
,"8":"Le mur de soutien de ces petites chambres était large d'une perche tout autour de la Maison."
,"9":"Du côté de l'extérieur, le mur des chambres, avec le passage qui les reliait entre elles, faisait cinq coudées."
,"10":"Les chambres tout autour de la Maison ajoutaient donc vingt coudées à ses dimensions."
,"11":"Le passage qui reliait les chambres avait une entrée au nord et une entrée au sud; laomme mesura la Maison, elle était longue de cent coudées: en profondeur, la cour, le bâtiment et ses murs faisaient cent coudées."
,"14":"En largeur, la façade de la Maison donnant sur la cour vers l'est, était également de cent coudées."
,"15":"Il mesura la longueur du bâtiment du côté de l'arrière-cour avec ses couloirs de part et d'autre; elle faisait cent coudées. L'avant-sanctuaire et le vestibule du parvis "
,"16":"les fenêtres grillagées et les entrées avec leurs trois chambres étaient revêtus de bois précieux tout autour, du sol jusqu'aux fenêtres."
,"17":"La décoration s'étendait depuis l'entrée jusqu'à l'intérieur de la Maison, aussi bien à l'extérieur qu'à l'intérieur."
,"18":"Elle était faite de chérubins et de palmiers, il y avait un palmier entre deux chérubins; les chérubins avaient deux faces:"
,"19":"une face d'homme faisant face à un palmier d'un côté, et une face de lion faisant face à un palmier de l'autre côté. On avait fait ainsi sur tout le tour de la Maison."
,"20":"Depuis le sol jusqu'au-dessus de l'entrée, on avait représenté des chérubins et des palmiers sur le mur."
,"21":"Les piliers de l'avant-sanctuaire étaient carrés; devant le sanctuaire on aurait dit"
,"22":"un autel en bois haut de trois coudées; sa longueur comme sa largeur étaient de deux coudées. Il avait des pièces d'angle et ses parois étaient en bois. L'homme me dit: 'C'est la table qui est devant Yahvé.'"
,"23":"L'avant-sanctuaire avait une porte à double battant, et de même le sanctuaire;"
,"24":"chacun des battants était à double panneau."
,"25":"Au-dessus des battants de l'avant-sanctuaire, des chérubins et des palmiers étaient représentés comme sur les murs; un auvent de bois protégeait la façade et la porte extérieure."
,"26":"Des fenêtres grillagées et des palmiers décoraient les piliers du vestibule, les chambres qui entouraient la Maison et les auvents."
}`)
	CurrentBook.AddChapter(42, `{
"1":"L'homme me fit sortir en direction du nord, vers la cour intérieure; il me conduisit vers les salles qui donnaient sur la cour au nord du bâtiment."
,"2":"Du côté du nord, les salles étaient longues de cent coudées et larges de cinquante."
,"3":"Les portes de la cour intérieure s'ouvraient sur une galerie à trois étages donnant sur le pavage de la cour extérieure."
,"4":"Devant les salles il y avait un couloir long de cent coudées et large de dix; les entrées étaient au nord."
,"5":"Les salles supérieures étaient plus étroites que les salles inférieures ou les salles intermédiaires, car les galeries empiétaient sur elles."
,"6":"En effet, ces galeries avaient trois étages et n'avaient pas de colonnes semblables à celles des cours; c'est pour cela qu'il y avait un rétrécissement par rapport aux salles inférieures ou à celles du milieu."
,"7":"Le mur le long des salles à l'extérieur, en direction de la cour extérieure, était long de cinquante coudées."
,"8":"En effet, la longueur des salles qui regardait vers la cour extérieur était de cinquante coudées alors que celles qui faisaient face au Temple en avait cent."
,"9":"En arrivant de la cour extérieure on trouvait au-dessous de ces salles, une entrée venant de l'est."
,"10":"Au milieu du mur de la cour, en direction du sud, il y avait des salles qui faisaient face à la cour et aux bâtiments."
,"11":"Un couloir passait devant elles, ces salles avaient le même aspect que les chambres qui se trouvaient au nord: même longueur, même largeur, même porte, même disposition, même entrée."
,"12":"Au-dessous des salles qui regardaient vers le sud, il y avait une entrée au départ de chaque allée."
,"13":"L'homme me dit alors: 'Les salles du nord et les salles du sud qui regardent vers la cour sont les salles saintes où les prêtres qui s'approchent de Yahvé mangeront les viandes consacrées; c'est là qu'ils déposeront ce qui a été offert pour l'oblation, le sacrifice pour le péché et le sacrifice de réparation. C'est un lieu saint."
,"14":"Lorsque les prêtres sortiront du sanctuaire vers la cour extérieure, ils quitteront là les vêtements avec lesquels ils ont officié, car ces vêtements sont saints. Ils en revêtiront d'autres et s'en iront alors vers la cour réservée au peuple."
,"15":"Lorsque l'homme eut fini de mesurer les constructions intérieures, il me fit sortir par la porte est pour prendre les mesures de l'extérieur."
,"16":"Il mesura le côté est avec sa perche à mesurer et trouva la longueur de cinq cents perches."
,"17":"Il mesura le côté nord avec sa perche et trouva cinq cents perches."
,"18":"Il mesura encore le côté sud avec la perche et de nouveau trouva cinq cents perches."
,"19":"Il mesura enfin le côté ouest avec sa perche et trouva cinq cents perches."
,"20":"Il mesura ainsi les quatre côtés; un mur dont la longueur et la largeur étaient de cinq cents perches séparait le sacré du profane."
}`)
	CurrentBook.AddChapter(43, `{
"1":"L'homme me conduisit vers la porte de l'est,"
,"2":"et voici que la Gloire du Dieu d'Israël arrivait de l'orient avec un bruit semblable à celui des grandes eaux; la terre fut illuminée de sa Gloire."
,"3":"Cette vision était semblable à celle que j'avais eue lorsque Yahvé était venu pour détruire la ville; elle était semblable à la vision que j'avais eue au bord du fleuve Kébar; je tombai la face contre terre."
,"4":"La Gloire de Yahvé entra dans le Temple par la porte de l'est."
,"5":"L'Esprit me souleva et me fit entrer dans la cour intérieure et voici que la Gloire de Yahvé remplissait la Maison."
,"6":"J'entendis alors quelqu'un qui me parlait de l'intérieur du Temple tandis que l'homme se tenait toujours près de moi."
,"7":"Il me dit: 'Fils d'homme, tu as vu la place de mon trône, le lieu pour la plante de mes pieds; c'est là que j'habiterai pour toujours au milieu des Israélites. Le peuple d'Israël avec ses rois ne souillera plus mon saint Nom par ses prostitutions ou par les cadavres de ses rois lorsqu'ils meurent."
,"8":"Ils avaient planté leur porte à côté de ma porte, leurs montants de porte à côté des montants de la mienne: juste un mur entre moi et eux. Les horreurs qu'ils commettaient ont souillé mon saint Nom, et je les ai exterminés dans ma colère."
,"9":"Ils éloigneront de moi leurs prostitutions et les cadavres de leurs rois, de façon que j'habite au milieu d'eux pour toujours."
,"10":"Toi, fils d'homme, décris maintenant au peuple d'Israël la Maison, qu'ils soient confus de leurs fautes et qu'ils en mesurent l'importance."
,"11":"S'ils ont honte de tout ce qu'ils ont commis, tu dessineras la Maison et ses constructions, ses entrées et ses sorties et toutes ses décorations. Tu leur feras connaître et tu mettras par écrit sous leurs yeux tous les règlements et toutes les lois de la Maison, pour qu'ils les observent et les mettent en pratique."
,"12":"Ceci est la loi de la Maison: tout son territoire dans toute son étendue au sommet de la montagne est un lieu très saint."
,"13":"Voici les dimensions de l'autel en coudées du Temple. Cette coudée vaut une coudée ordinaire et un palme. Le soubassement tout autour est haut d'une coudée et sa largeur est d'une coudée, avec un rebord extérieur d'un empan. Voici comment s'élève l'autel:"
,"14":"le socle inférieur est à deux coudées au-dessus du soubassement, laissant une coudée de largeur, et la hauteur est de quatre coudées depuis le petit socle jusqu'au grand socle, laissant encore une coudée de largeur."
,"15":"Le foyer s'élève quatre coudées plus haut, avec au-dessus ses quatre cornes."
,"16":"Le foyer est carré, long et large de douze coudées."
,"17":"Le grand socle a quatorze coudées de long sur quatorze de large, (le petit socle a seize coudées de long et de large ) sur son soubassement d'une coudée, plus le rebord tout autour. Les marches sont sur le côté est."
,"18":"Il me dit: Fils d'homme, voici ce que dit Yahvé: Voici les règles pour l'autel le jour où il sera réalisé. On y fera monter l'holocauste et on y répandra le sang."
,"19":"Alors tu donneras aux prêtres lévites qui sont de la descendance de Sadoq et qui s'approchent de moi pour me servir, parole de Yahvé, un jeune taureau en expiation."
,"20":"Tu prendras de son sang et tu en mettras sur les quatre cornes, sur les angles du socle et sur le rebord tout autour; ainsi tu feras l'expiation pour l'autel."
,"21":"Puis tu prendras le taureau et on le brûlera dans une dépendance de la Maison, en dehors du Temple."
,"22":"Le second jour tu offriras un bouc sans défaut pour l'expiation, et l'on fera l'expiation pour l'autel comme on l'a fait avec le jeune taureau."
,"23":"Lorsque tu auras terminé l'expiation, tu offriras un jeune taureau sans défaut et un bélier sans défaut pris dans le petit bétail."
,"24":"Tu les offriras devant Yahvé, les prêtres jetteront sur eux du sel et les offriront en holocauste à Yahvé."
,"25":"Durant sept jours tu offriras chaque jour un bouc pour l'expiation; on fera de même le sacrifice du jeune taureau et du bélier sans défaut pris parmi le petit bétail."
,"26":"Durant sept jours on fera la supplication pour l'autel, on le purifiera et on l'inaugurera."
,"27":"A partir du huitième jour, les prêtres pourront offrir sur l'autel vos holocaustes et vos sacrifices pacifiques et je vous en saurai gré, parole de Yahvé."
}`)
	CurrentBook.AddChapter(44, `{
"1":"L'homme me fit revenir vers la porte est du Temple; elle était fermée."
,"2":"Il me dit: Cette porte restera fermée, on ne l'ouvrira jamais et personne n'entrera par là, car Yahvé Dieu d'Israël est passé par cette porte; elle restera fermée."
,"3":"Mais le prince, parce qu'il est prince, pourra s'y asseoir pour le repas devant Yahvé; il viendra par le vestibule de la porte et repartira par le même chemin."
,"4":"Ensuite il me ramena au Temple par la porte nord; je regardai, et voici que la Gloire de Yahvé remplissait la Maison. Alors je tombai la face contre terre."
,"5":"Il me dit: Fils d'homme, prête toute ton attention, regarde de tes yeux, écoute de tes oreilles tout ce que je vais te dire au sujet des règles de la Maison de Yahvé et de ses lois. Ecoute bien ce qui concerne les entrées et les sorties du Temple."
,"6":"Tu diras aux gens d'Israël, à cette bande de révoltés: Voici ce que dit Yahvé: En voilà assez, peuple d'Israël, de toutes les horreurs"
,"7":"que vous commettiez lorsque vous faisiez entrer des étrangers incirconcis de coeur et de chair. Ils entraient dans mon sanctuaire et le profanaient lorsque vous m'offriez ma nourriture de graisse et de sang. Vous avez rompu mon alliance par toutes vos horreurs,"
,"8":"les chargeant d'assurer mon culte."
,"9":"Voici ce que dit Yahvé: Aucun étranger incirconcis de coeur ou de chair n'entrera dans mon sanctuaire, aucun des étrangers qui vivent au milieu des Israélites."
,"10":"Quant aux lévites qui se sont éloignés de moi au temps où Israël me laissait pour suivre ses idoles, ils porteront le poids de leur péché."
,"11":"Dans mon sanctuaire ils seront chargés de la surveillance des portes du Temple et ils assureront le service de la Maison. Ils égorgeront les bêtes pour l'holocauste et le sacrifice pour le peuple, ils seront à la disposition du peuple pour le culte."
,"12":"Mais parce qu'il ont fait pour lui le service des idoles et qu'ils ont été pour les gens d'Israël une occasion de chute, je lève la main pour les condamner - parole de Yahvé: ils porteront le poids de leur péché."
,"13":"On ne les comptera plus parmi les prêtres qui s'approchent de moi et touchent aux choses saintes ou très saintes; ils resteront disqualifiés à cause des horreurs qu'ils ont commises."
,"14":"J'en ferai les gardiens de l'ordre de la Maison, du culte et de tout ce que l'on doit faire."
,"15":"Mais ce sont les prêtres lévites descendants de Sadoq qui s'approcheront de moi pour me servir et se tiendront devant moi pour me présenter la graisse et le sang - parole de Yahvé, car ils ont maintenu les lois de mon sanctuaire lorsque les Israélites s'égaraient loin de moi."
,"16":"Ils entreront dans mon sanctuaire et s'approcheront de ma table pour me servir; ils auront la charge de mon culte."
,"17":"Lorsqu'ils franchiront les portes de la cour intérieure, ils revêtiront des habits de lin; ils ne s'habilleront pas de laine lorsqu'ils accompliront leur service dans la cour intérieure."
,"18":"Ils auront des turbans de lin sur la tête et des caleçons de lin sur leurs reins, ils ne mettront rien qui les fasse transpirer."
,"19":"Lorsqu'ils sortiront vers le peuple dans la cour extérieure, ils enlèveront les vêtements avec lesquels ils ont célébré le culte; ils les laisseront dans les salles saintes et revêtiront d'autres habits pour que le peuple n'entre pas en contact avec leurs vêtements sacrés."
,"20":"Ils ne se raseront pas la tête, ils n'auront pas non plus de longs cheveux mais ils se les tailleront comme il faut."
,"21":"Aucun prêtre ne boira du vin avant d'entrer dans la cour intérieure."
,"22":"Les prêtres n'épouseront ni une veuve (sauf une veuve de prêtre), ni une femme répudiée, mais seulement une vierge de la race d'Israël."
,"23":"Ils apprendront à mon peuple la différence entre le sacré et le profane, entre l'impur et le pur."
,"24":"Ils auront autorité pour juger dans les procès, ils jugeront selon mes règles, ils observeront mes lois et mes commandements pour tout ce qui concerne les fêtes, et ils sanctifieront mes sabbats."
,"25":"Ils ne s'approcheront pas d'un mort pour ne pas devenir impurs. Cependant, s'il s'agit de leur père, de leur mère, d'un fils ou d'une fille, d'un frère ou d'une soeur encore vierge, ils pourront se rendre impurs."
,"26":"Lorsque l'un d'eux se sera purifié, on comptera sept jours,"
,"27":"et le jour où il entrera de nouveau dans la cour intérieure pour son service dans le lieu saint, il présentera son sacrifice pour le péché - parole de Yahvé."
,"28":"Voici quel sera leur héritage. Je suis, moi, leur héritage, et vous ne leur donnerez pas de domaine en Israël, car je suis, moi, leur possession."
,"29":"Les victimes offertes pour le péché ou en réparation, et tout ce qui est frappé d'anathème en Israël, sera pour eux."
,"30":"Les prêtres recevront les prémices de tous les premiers fruits et tout ce qui sera prélevé sur ce que vous-mêmes aurez prélevé; les prémices de vos farines seront pour le prêtre et grâce à cela la bénédiction viendra sur votre maison."
,"31":"Les prêtres ne mangeront d'aucune bête crevée ou déchirée, oiseau ou bétail."
}`)
	CurrentBook.AddChapter(45, `{
"1":"Lorsque vous partagerez le pays au sort, vous prélèverez une part pour Yahvé, une terre sacrée prise sur le pays; elle sera longue de vingt cinq mille coudées et large de vingt mille, elle sera sacrée dans toute son étendue."
,"2":"C'est là qu'on prendra l'espace carré de cinq cents coudées sur cinq cents pour le lieu saint, avec tout autour une bordure de cinquante coudées."
,"3":"On mesurera sur cette surface une part longue de vingt-cinq mille coudées et large de dix mille où sera le sanctuaire; ce sera un lieu très saint."
,"4":"Cette part de terre sera pour les prêtres qui assurent le service du sanctuaire et s'approchent de Yahvé pour le servir; ce sera pour leurs maisons et pour leurs troupeaux."
,"5":"Et on donnera aux lévites qui assurent le service de la Maison un territoire de vingt cinq mille coudées sur dix mille: là seront les villes où ils habiteront."
,"6":"Vous prendrez un territoire de cinq mille coudées sur vingt-cinq mille, juste à côté du domaine du Temple: il sera propriété de la ville et sera pour toute la maison d'Israël."
,"7":"Le prince recevra un territoire de chaque côté, de part et d'autre du domaine réservé au Temple et de la propriété de la ville: à l'est jusqu'à la frontière est, à l'ouest jusqu'à la mer. Il aura donc la même longueur que les parts réservées à chaque tribu."
,"8":"Ce sera sa propriété en Israël; ainsi mes princes n'opprimeront plus mon peuple et laisseront la terre d'Israël à ses tribus."
,"9":"Voici ce que dit Yahvé: Vous avez passé les bornes, princes d'Israël! Arrêtez l'oppression et la violence, pratiquez le droit et la justice. Mettez fin à vos abus avec mon peuple - parole de Yahvé."
,"10":"Ayez des balances justes, une mesure et un poids justes."
,"11":"Les mesures pour les semences et les mesures pour les liquides auront la même contenance; ainsi le bat, comme l'épha, contiendra le dixième d'un homer. C'est par rapport au homer qu'on fixera leur contenance."
,"12":"Le sicle fera vingt guéras et quinze sicles feront une mine."
,"13":"Voici ce que vous prélèverez: un sixième d'épha par homer de blé et un sixième d'épha par homer d'orge."
,"14":"Voici la règle pour l'huile: on donnera un dixième de bat par kor, puisque dix bats font un kor."
,"15":"Sur un troupeau de deux cents bêtes établi dans les pâturages d'Israël, on prélèvera une brebis pour l'offrande, l'holocauste et le sacrifice de communion; ce sera pour faire l'expiation pour vous - parole de Yahvé."
,"16":"Tout le peuple du pays participera à cette redevance qui ira au prince d'Israël."
,"17":"Le prince se chargera des holocaustes, des offrandes et de la libation à l'occasion des fêtes, des nouvelles lunes, des sabbats et de toutes les assemblées du peuple d'Israël; c'est lui qui assurera le sacrifice pour le péché, l'offrande, l'holocauste et les sacrifices de communion pour le peuple d'Israël."
,"18":"Voici ce que dit Yahvé: Le premier jour du premier mois tu prendras un jeune taureau sans défaut pour effacer le péché du sanctuaire."
,"19":"Le prêtre prendra du sang de la victime pour le péché et aspergera les montants de la porte de la Maison, les quatre angles du socle de l'autel et les montants des portes de la cour intérieure."
,"20":"On fera de même le sept du mois en faveur de ceux qui auront péché involontairement ou sans réfléchir; c'est ainsi que vous ferez l'expiation pour la Maison."
,"21":"Le quatorzième jour du premier mois sera pour vous la fête de la Pâque; pendant sept jours on mangera des pains sans levain."
,"22":"Ce jour-là le prince offrira un taureau en sacrifice pour le péché, pour lui-même et pour tout le peuple."
,"23":"Pendant les sept jours de la fête on offrira chaque jour à Yahvé sept taureaux et sept béliers en holocauste, et chaque jour un bouc en sacrifice pour le péché."
,"24":"On présentera en offrande une mesure de farine par taureau et une mesure par bélier, avec un sixième de mesure d'huile."
,"25":"Pour la fête des Tentes, au quinze du septième mois, on fera de même pendant sept jours; on offrira sacrifice pour le péché, holocauste, offrande et huile."
}`)
	CurrentBook.AddChapter(46, `{
"1":"Voici ce que dit Yahvé: La porte de la cour intérieure qui regarde vers l'orient restera fermée pendant les six jours ouvrables; on l'ouvrira le jour du sabbat, ainsi que le jour de la nouvelle lune."
,"2":"Le prince y viendra de l'extérieur par le vestibule de la porte et il se tiendra près du montant de la porte; les prêtres offriront alors son holocauste et son sacrifice pacifique. Ensuite il se prosternera sur le seuil de la porte et se retirera; la porte ne sera pas refermée avant le soir."
,"3":"A l'occasion des sabbats et des nouvelles lunes, le peuple du pays se prosternera devant Yahvé à l'entrée de cette porte."
,"4":"Le jour du sabbat le prince présentera en holocauste à Yahvé six agneaux et un bélier sans défaut."
,"5":"Il présentera comme offrande une mesure de farine pour le bélier et ce qu'il voudra pour les agneaux; il ajoutera un sixième de mesure d'huile."
,"6":"Le jour de la nouvelle lune il offrira un jeune taureau, six agneaux et un bélier sans défaut."
,"7":"Avec le jeune taureau il offrira de la farine: une mesure pour le bélier, et ce qu'il voudra pour les agneaux; il y ajoutera un sixième de mesure d'huile."
,"8":"Lorsque le prince entrera, il passera par le vestibule de la porte et repartira par le même chemin."
,"9":"Lorsque le peuple du pays viendra devant Yahvé à l'occasion des fêtes, celui qui viendra par la porte nord pour se prosterner sortira par la porte sud; celui qui viendra par la porte sud sortira par la porte nord. On ne retournera pas par la porte par laquelle on est venu, on sortira par le côté opposé."
,"10":"Le prince entrera avec ses sujets et sortira lorsqu'ils sortiront."
,"11":"A l'occasion des fêtes et des solennités, le prince offrira pour le jeune taureau une mesure de farine, une autre pour le bélier, et pour les agneaux ce qu'il voudra."
,"12":"Lorsque le prince présentera à Yahvé son offrande volontaire, l'holocauste ou le sacrifice pacifique, on lui ouvrira la porte est. Il présentera son holocauste et son sacrifice pacifique comme il le fait le jour du sabbat, puis il se retirera et on fermera la porte dès qu'il sera sorti."
,"13":"Chaque jour tu offriras en holocauste à Yahvé un agneau d'un an sans défaut, tu le présenteras chaque matin."
,"14":"Tu présenteras également chaque matin une offrande à Yahvé: un sixième de mesure de farine et un douzième de mesure d'huile pour pétrir la farine; c'est une règle perpétuelle."
,"15":"Chaque matin on présentera l'holocauste perpétuel: un agneau, avec de la farine et de l'huile."
,"16":"Voici ce que dit Yahvé: Si le prince fait un don à l'un de ses fils sur son héritage, ce don appartiendra à ses fils, il sera leur propriété de génération en génération."
,"17":"Mais s'il fait un don sur son héritage à l'un de ses serviteurs, ce don appartiendra à son serviteur jusqu'à l'année de l'affranchissement, après quoi il reviendra au prince; les fils seuls garderont l'héritage."
,"18":"Le prince ne prendra rien sur l'héritage du peuple; il ne le dépouillera pas de ce qui lui appartient, mais c'est avec ce qui est à lui qu'il donnera un héritage à ses fils; ainsi mon peuple ne sera pas dépouillé de ce qui est à lui.'"
,"19":"L'homme m'emmena par l'entrée située à côté du porche vers les chambres saintes réservées aux prêtres, celles qui sont au nord. Il y avait là, à l'extrémité ouest, un espace."
,"20":"Il me dit: 'Voici l'endroit où les prêtres feront cuire les victimes des sacrifices pour le péché et des sacrifices de réparation. C'est là aussi qu'il feront cuire les offrandes de farine; il ne faudrait pas qu'ils les portent dans la cour extérieure et que les choses saintes entrent en contact avec le peuple.'"
,"21":"Il m'emmena ensuite dans la cour extérieure et me fit passer près des quatre angles de la cour. Dans chacun des angles il y avait une petite cour,"
,"22":"soit quatre petites cours longues de quarante coudées et larges de trente; les quatre avaient la même dimension."
,"23":"Elles étaient entourées d'un mur et des foyers étaient construits au pied de ce mur tout autour."
,"24":"Il me dit: Ce sont les fours où les serviteurs de la Maison feront cuire la viande des sacrifices pour le peuple."
}`)
	CurrentBook.AddChapter(47, `{
"1":"L'homme me ramena à l'entrée du Temple, et voici que des eaux sortaient de dessous le seuil de la Maison: elles couraient vers l'orient, tout comme la Maison regardait vers l'orient. L'eau sortait du côté sud de l'autel."
,"2":"Il me fit sortir par le porche nord et me fit faire le tour par l'extérieur jusqu'au porche de l'est: l'eau courait alors sur ma droite."
,"3":"L'homme s'éloigna vers l'orient. Il mesura mille coudées avec la perche qu'il tenait en main, puis il me fit traverser le cours d'eau: j'avais de l'eau jusqu'aux chevilles."
,"4":"Il compta encore mille coudées et me fit traverser le cours d'eau; j'avais de l'eau jusqu'aux genoux. Il compta encore mille coudées et me fit traverser le cours d'eau; j'avais de l'eau jusqu'aux reins."
,"5":"Il mesura encore mille coudées: cette fois je ne pouvais plus traverser le torrent: les eaux avaient monté, c'était un fleuve qu'on ne traverse pas mais qu'on passe à la nage."
,"6":"Il me dit alors: 'As-tu vu, fils d'homme?' Après quoi il me fait marcher sur la rive."
,"7":"Quand je reviens au torrent, il y a là sur la rive des arbres très nombreux, de part et d'autre du torrent."
,"8":"Il me dit: 'Cette eau court vers la région est, elle descend vers la Araba et se déverse dans la mer sur les eaux infectes. Aussitôt les eaux redeviennent saines."
,"9":"Tout ce qui vit, tout ce qui s'agite partout ou le torrent parviendra, sera plein de vie; le poisson y sera très abondant. Il suffira que ces eaux y arrivent; il y aura santé et vie partout où ces eaux parviendront."
,"10":"Les pécheurs se tiendront sur la rive depuis En-Guédi jusqu'à En-Eglayim: on y tendra des filets. Les poissons y seront très nombreux, des mêmes espèces qu'on trouve dans la grande mer."
,"11":"Les marais et les lagunes, par contre, ne seront pas assainis, on les abandonnera au sel."
,"12":"Toutes sortes d'arbres fruitiers grandiront sur les rives du torrent, de part et d'autre; leur feuillage ne se flétrira pas, ils auront des fruits en toute saison. Tous les mois ils produiront, grâce à cette eau qui vient du sanctuaire. On se nourrira de leurs fruits, et leurs feuilles seront un remède."
,"13":"Ainsi parle Yahvé: Voici le territoire que vous partagerez entre les douze tribus d'Israël (vous donnerez deux parts à Joseph)."
,"14":"Tous vous aurez votre part puisque, la main levée, j'ai juré à vos pères de leur donner ce pays: il sera votre héritage."
,"15":"Au nord, la frontière du pays partira de la grande mer au chemin de Hetlon sur le Sédad à l'entrée de Hamat;"
,"16":"ensuite, en direction du Hauran: Bérota, Sibrayim, entre les territoires de Damas et de Hamat, Haser-Ha-Tikon."
,"17":"La frontière ira donc de la mer jusqu'à Hasar-Enan, laissant au nord le territoire de Damas et celui de Hamat; voilà pour le nord."
,"18":"A l'est elle passera entre le Hauran et Damas, entre Galaad et le pays d'Israël, et le Jourdain servira de fron tière jusqu'à la mer orientale du côté de Tamar; voilà pour la frontière est."
,"19":"Au sud elle se dirigera de Tamar vers les eaux de Mériba de Kadesh, puis vers le torrent jusqu'à la Grande Mer; telle sera la frontière méridionale."
,"20":"A l'ouest la Grande Mer servira de frontière jusqu'à l'entrée de Hamat; telle sera la frontière ouest."
,"21":"Vous partagerez ce pays entre les tribus d'Israël,"
,"22":"Vous tirerez au sort votre héritage et celui des étrangers qui séjournent au milieu de vous avec leurs enfants nés dans le pays. Vous les traiterez comme les Israélites du pays, comme vous ils recevront un héritage au milieu des tribus d'Israël."
,"23":"L'étranger aura son héritage dans la tribu où il habite, parole de Yahvé."
}`)
	CurrentBook.AddChapter(48, `{
"1":"Voici la répartition des tribus. Dan a son territoire tout au nord, dans la direction de Hetlon, vers l'entrée de Hamat et Hasar-Enan; il s'étend de la frontière est à la frontière ouest, laissant plus au nord le territoire de Damas qui longe Hamat."
,"2":"Le territoire d'Asher s'étend de la frontière est à la frontière ouest, juste à côté de Dan."
,"3":"Le territoire de Nephtali s'étend de la frontière est à la frontière ouest, sur le côté d'Asher."
,"4":"Le territoire de Manassé s'étend de la frontière est à la frontière ouest, sur le côté de Nephtali."
,"5":"Le territoire d'Ephraïm s'étend de la frontière est à la frontière ouest, sur le côté de Manassé."
,"6":"Le territoire de Ruben s'étend de la frontière est à la frontière ouest, sur le côté d'Ephraïm."
,"7":"Le territoire de Juda s'étend de la frontière est à la frontière ouest, sur le côté de Ruben."
,"8":"Après Juda, depuis la frontière est jusqu'à la frontière ouest, vous réserverez un territoire large de vingt-cinq mille coudées et aussi long que chacune des autres parts; c'est au milieu de ce territoire que sera le sanctuaire."
,"9":"La part que vous prélèverez pour Yahvé sera longue de vingt-cinq mille coudées et large de dix mille."
,"10":"Le lot sacré destiné aux prêtres aura vingt-cinq mille coudées au nord, dix mille coudées de largeur à l'ouest et à l'est, et vingt cinq mille coudées au sud. Le sanctuaire de Yahvé sera au milieu."
,"11":"Ce territoire sera pour les prêtres consacrés, ces descendants de Sadoq qui ont assuré mon service et n'ont pas suivi les Israélites dans leur égarement comme ont fait les lévites."
,"12":"Ceux-là auront un lot pris sur la part très sainte du pays, à côté du territoire des lévites."
,"13":"Le territoire des lévites, comme celui des prêtres, aura vingt-cinq mille coudées de long et dix mille de large."
,"14":"Ils ne pourront ni vendre ni échanger cette terre, ils ne pourront pas la céder à quelqu'un d'autre, car elle est consacrée à Yahvé."
,"15":"Le terrain qui reste, large de cinq mille coudées et long de vingt-cinq mille, sera un territoire profane pour la ville, les habitations et les pâturages; la ville sera au milieu."
,"16":"Voici ses dimensions: quatre mille cinq cents coudées au nord, quatre mille cinq cents coudées au sud, quatre mille cinq cents coudées à l'est, et quatre mille cinq cents coudées à l'ouest."
,"17":"Au nord, les pâturages de la ville s'étendront sur deux cent cinquante coudées à l'est et deux cent cinquante à l'ouest."
,"18":"Le long de la part consacrée, il restera un terrain long de dix mille coudées vers l'est et de dix mille vers l'ouest; les revenus de ce terrain serviront à nourrir les travailleurs de la ville."
,"19":"Les travailleurs de la ville seront pris parmi toutes les tribus d'Israël et cultiveront ce terrain."
,"20":"Au total, le lot prélevé sur l'héritage d'Israël fera vingt-cinq mille coudées sur vingt-cinq mille. Au centre un espace sera réservé pour la construction de la ville."
,"21":"Le prince recevra ce qui reste à l'est et à l'ouest, de part et d'autre de la part consacrée et de la propriété de la ville, sur la bande large de vingt-cinq mille coudées allant de la frontière est à la frontière ouest; la part du prince sera parallèle aux autre lots, et au milieu sera le domaine sacré avec le sanctuaire de la Maison."
,"22":"Ainsi le prince recevra le terrain au-delà de celui des lévites et au-delà de celui de la ville, entre le territoire de Juda et celui de Benjamin."
,"23":"Voici les parts pour les autres tribus: Benjamin aura une part depuis la frontière est jusqu'à la frontière ouest."
,"24":"Juste à côté de Benjamin, Siméon aura une part depuis la frontière est jusqu'à la frontière ouest."
,"25":"Juste à côté de Siméon, Issacar aura une part depuis la frontière est jusqu'à la frontière ouest."
,"26":"Juste à côté d'Issacar, Zabulon aura une part depuis la frontière est jusqu'à la frontière ouest."
,"27":"Juste à côté de Zabulon, Gad aura une part depuis la frontière est jusqu'à la frontière ouest."
,"28":"La frontière méridionale de Gad ira de Tamar aux eaux de Mériba de Kadesh, jusqu'à la Grande Mer en suivant le torrent d'Egypte."
,"29":"Voilà le pays que vous partagerez en héritage entre les tribus d'Israël, et voilà leur part à chacune - parole de Yahvé."
,"30":"Voici les sorties de la ville. Le côté nord fera quatre mille cinq cents coudées,"
,"31":"Il y aura trois portes au nord: la porte de Ruben, celle de Juda et celle de Lévi (car les portes de la ville recevront les noms des tribus d'Israël)."
,"32":"Le côté est mesurera quatre mille cinq cents coudées, il aura trois portes: les portes de Joseph, de Benjamin et de Dan."
,"33":"Le côté sud mesurera quatre mille cinq cents coudées, il aura trois portes: les portes de Siméon, d'Issacar et de Zabulon."
,"34":"Du côté ouest on mesurera quatre mille cinq cents coudées et il y aura trois portes: les portes de Gad, d'Asher et de Nephtali."
,"35":"Le tour de la ville fera donc dix huit mille coudées. Quant à son nom, il sera à partir de ce jour: 'Yahvé est là.'"
}`)

}
func FR_LBDCC_LoadVMIEChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Paroles de Jérémie, fils de Hilkyas. C'était l'un des prêtres habitant à Anatot, dans le territoire de Benjamin."
,"2":"La parole de Yahvé lui fut adressée dès la treizième année du règne de Josias, fils d'Amon, roi de Juda."
,"3":"Cela continua au temps de Joïaqim, fils de Josias, roi de Juda, et jusqu'à la fin de la onzième année de Sédécias, fils de Josias, roi de Juda, c'est-à-dire jusqu'à la déportation de Jérusalem, au cinquième mois."
,"4":"Une parole de Yahvé me fut adressée:"
,"5":"Avant même de te former dans le ventre de ta mère, je t'ai connu; avant que tu sois sorti de son sein, je t'avais consacré, faisant de toi le prophète des nations.'"
,"6":"Je dis alors: 'Ah, Seigneur Yahvé! Tu vois que je ne sais pas parler, je ne suis qu'un enfant.'"
,"7":"Yahvé répondit: 'Ne dis pas: Je ne suis qu'un enfant. Tu iras vers tous ceux à qui je t'enverrai, et tu leur diras tout ce que je t'ordonnerai."
,"8":"Ne les crains pas, car je suis avec toi pour te délivrer - parole de Yahvé.'"
,"9":"Alors Yahvé étendit la main et me toucha la bouche, et il dit: 'Vois, je place mes paroles dans ta bouche."
,"10":"Aujourd'hui même je te donne autorité sur les nations et les royaumes, pour déraciner et renverser, pour exterminer et détruire, pour bâtir et pour planter.'"
,"11":"La parole de Dieu me fut adressée en ces termes: 'Jérémie, que vois-tu?' Je répondis: 'Je vois une branche d'arbre: c'est l'arbre-veilleur.'"
,"12":"Alors Yahvé me dit: 'Tu as bien vu, car je reste en éveil et je fais que mes paroles se réalisent.'"
,"13":"Une seconde fois la parole de Yahvé vint à moi: 'Que vois-tu?' Je répondis: 'Je vois une marmite qui bouillonne et se déverse: cela vient du nord.'"
,"14":"Alors Yahvé me dit: 'C'est bien du nord que le malheur va se déverser sur tous les habitants du pays."
,"15":"Oui, j'appelle tous les royaumes du nord - parole de Yahvé. Tous viendront et établiront leurs quartiers à l'entrée des portes de Jérusalem, devant la ceinture de ses remparts, comme devant toutes les villes de Juda."
,"16":"Je prononcerai mes jugements contre ce peuple qui m'a abandonné pour faire le mal: ils ont fait fumer l'encens devant d'autres dieux et se sont mis au service de dieux qu'ils ont fabriqués."
,"17":"Aussi vas-tu te mettre à l'oeuvre. Tu leur diras tout ce que je te commanderai; ne tremble pas devant eux, sinon je pourrais te faire trembler devant eux."
,"18":"Sache qu'en ce jour je fais de toi une ville fortifiée, une colonne de fer et un rempart de bronze face au pays tout entier: face au roi de Juda, face à ses chefs et ses prêtres, face à tous les propriétaires."
,"19":"Ils te feront la guerre, mais ils ne pourront rien contre toi, car je suis avec toi pour te délivrer - parole de Yahvé.'"
}`)
	CurrentBook.AddChapter(2, `{
"1":"La parole de Dieu me fut adressée:"
,"2":"Va, crie ceci aux oreilles de Jérusalem: Voici ce que dit Yahvé: Je me rappelle ton affection quand tu étais jeune, ton amour lors de tes fiançailles, lorsque tu me suivais au désert, dans ces terres incultes."
,"3":"Israël était consacré à Yahvé, c'était le meilleur de sa récolte; ceux qui en mangeaient devaient le payer et le malheur tombait sur eux - parole de Yahvé."
,"4":"Ecoutez la parole de Yahvé, maison de Jacob, voici ce que dit Yahvé à toutes les familles de la maison d'Israël:"
,"5":"Vos pères m'avaient-ils pris en tort lorsqu'ils se sont éloignés de moi? Ils ont voulu courir après du rien, et eux-mêmes ne sont plus que du rien."
,"6":"Ils n'ont pas demandé: Où est Yahvé qui nous a fait monter du pays d'Egypte, qui nous a conduit par le désert, à travers ces lieux de steppes et de ravins, pays de la sécheresse et de l'ombre mortelle, pays que nul ne traverse, où nul n'a sa demeure?"
,"7":"Je vous ai fait entrer dans un pays de vergers pour en profiter, pour en manger les fruits. Mais à peine entrés vous avez souillé mon pays, vous avez fait de mon domaine un fumier."
,"8":"Les prêtres n'ont pas dit: 'Cherchons Yahvé'. Les maîtres de la Loi m'ont ignoré. Les bergers m'ont été infidèles, les prophètes ont prophétisé au nom de Baal, on s'est mis à la traîne de ce qui ne sert à rien."
,"9":"C'est pourquoi je maintiens mon procès contre vous et vos fils - parole de Yahvé."
,"10":"Passez aux îles de Kittim et regardez! Envoyez faire une enquête à Kédar et voyez s'il existe quelque chose de pareil:"
,"11":"Une nation change-t-elle de Dieu? Et pourtant ils ne sont pas Dieu. Mais mon peuple a changé sa Gloire contre ce qui ne sert à rien."
,"12":"Cieux, soyez étonnés, tremblez d'horreur, soyez bouleversés - parole de Yahvé."
,"13":"Car mon peuple a commis une double faute: ils m'ont abandonné, et j'étais la source d'eau vive; ils se sont creusé des citernes, et ce sont des citernes fissurées qui ne retiennent pas l'eau!"
,"14":"Israël est-il un esclave, un fils d'esclave? Pourquoi fait-il partie du butin?"
,"15":"Des lions ont rugi contre lui, ils ont élevé la voix, ils ont réduit son pays en ruines et ses villes ont été livrées au feu: plus un habitant!"
,"16":"Même les gens de Nof et de Tahpanhès t'ont rasé le crâne!"
,"17":"Mais si tout cela t'est arrivé, n'est-ce pas parce que tu as abandonné Yahvé ton Dieu?"
,"18":"Pourquoi prends-tu maintenant la route de l'Egypte? Veux-tu boire l'eau du Nil? Si tu prends la route de l'Assyrie, te laissera-t-on boire l'eau du Fleuve?"
,"19":"Non, ta méchanceté appelle le fouet, tes infidélités t'amèneront la punition. Il faut que tu voies et que tu saches combien il est dur et amer d'abandonner Yahvé ton Dieu, et de n'avoir plus de respect envers moi - parole de Yahvé Sabaot."
,"20":"Depuis longtemps tu as brisé ton joug, tu as rompu tes liens, et tu as dis: Je ne te servirai plus! Et puis, comme une prostituée que tu es, tu t'es couchée sur les collines élevées sous tous les arbres verts!"
,"21":"Je t'avais plantée comme une vigne excellente où tous les pieds sont de qualité. Comment es-tu devenue pour moi cette vigne de fortune au raisin dégénéré?"
,"22":"Même si tu te lavais à la soude, si tu te lessivais à la potasse, la saleté de ta faute resterait devant moi - parole de Yahvé."
,"23":"Comment peux-tu dire: 'Je ne me suis pas souillée, je n'ai pas couru derrière les Baals?' Regarde tes traces dans la vallée et reconnais ce que tu as fait!,Comme une chamelle légère qui croise ses pas en tous sens, "
,"24":"comme une ânesse habituée au désert, elle respire le vent car sa passion la brûle: qui l'empêchera de satisfaire son désir? Ceux qui la recherchent n'ont pas à se fatiguer, ils la trouvent quand elle est en chaleur."
,"25":"On te dit: 'Tes chaussures vont lâcher, tu vas mourir de soif.' Et tu réponds: 'Non, laissez-moi, j'aime les étrangers et je veux les retrouver.'"
,"26":"Quelle honte quand on est pris sur le fait!,Ce sera pareil pour les gens d'Israël, pour les rois et les chefs, les prêtres et les prophètes."
,"27":"Ils disent au bois: 'Tu es mon père', et à la pierre: 'C'est toi qui m'as mis au monde'. Ils m'ont tourné le dos et non pas leur visage, puis au jour du malheur ils crient vers moi: 'Allons, délivre-nous!'"
,"28":"Où sont-ils donc les dieux que tu te fabriquais?,Qu'ils essayent de te délivrer au jour de ton malheur!,Car tes dieux, Juda, sont aussi nombreux que tes villes."
,"29":"Vous voudriez me faire un procès?,Tous, vous m'avez été infidèles,- parole de Yahvé."
,"30":"Je n'ai rien gagné à frapper vos fils, vous n'avez pas compris la leçon; l'épée, comme un lion, a dévoré vos prophètes: mais vous n'avez pas pris garde."
,"31":"Ecoutez cette parole de Yahvé: n'ai-je pas été pour Israël,mieux qu'un désert ou une terre en friche?,Pourquoi donc mon peuple dit-il: 'Peu importe où nous irons, nous ne reviendrons pas vers toi'?"
,"32":"Une vierge n'oublie pas ses vêtements de fête, une fiancée n'oublie pas sa ceinture; mais voici bien longtemps que mon peuple m'oublie."
,"33":"Tu sais tous les chemins de l'amour, tu as même appris le chemin du crime."
,"34":"Jusque sur les pans de ta robe,on retrouve le sang des innocents, tu ne les avais pas surpris en train de voler!"
,"35":"Mais tu fais l'innocente: 'Va-t-il enfin détourner de moi sa colère?',Je te reprends si tu dis: 'Je n'ai pas péché.'"
,"36":"Est-ce une solution de chercher ailleurs?,L'Assyrie te décevra comme l'Egypte t'a déçue."
,"37":"de là aussi tu sortiras les mains sur la tête. Car Yahvé ne veut pas de ceux en qui tu crois; et avec eux tu n'arriveras à rien!"
}`)
	CurrentBook.AddChapter(3, `{
"1":"Quand un homme a renvoyé sa femme et que celle-ci, après l'avoir quitté, a été la femme d'un autre, peut-elle revenir vers lui? N'est-elle pas maintenant comme impure pour lui? Or toi tu t'es prostituée avec de nombreux amants; tu voudrais maintenant revenir vers moi? - parole de Yahvé."
,"2":"Lève les yeux vers les monts chauves et regarde: partout tu t'es prostituée. Comme l'Arabe dans le désert tu t'asseyais pour eux au bord de la route. Tu as profané le pays par tes prostitutions et tes méfaits."
,"3":"C'est pourquoi les pluies de l'automne ont été retenues et celles du printemps ont manqué, mais toi, effrontée comme une prostituée, tu as refusé de rougir."
,"4":"Maintenant tu oses me dire: 'Mon Père! C'est toi l'ami de ma jeunesse!"
,"5":"Seras-tu toujours fâché contre moi, ta colère ne va donc pas finir?' Et pendant que tu dis cela, tu continues tes crimes!"
,"6":"Yahvé me dit ceci au temps du roi Josias: 'Sais-tu bien ce que faisait la rebelle Israël? Elle courait se prostituer sur les hauteurs, sous les arbres verts."
,"7":"Je me disais: Après avoir fait tout cela, elle reviendra vers moi. Mais elle n'est pas revenue. Juda, sa soeur perfide, l'a vu; "
,"8":"elle a vu aussi comment je renvoyais la rebelle Israël à cause de tous ses adultères et comment je signais son acte de divorce. Mais Juda la perfide, sa soeur, n'a pas eu peur; elle aussi est allée se prostituer."
,"9":"Elle a souillé le pays par sa prostitution scandaleuse; elle aussi a commis l'adultère avec le bois et la pierre."
,"10":"Et après l'avoir fait, Juda la perfide n'est pas revenue vers moi de tout son coeur, mais comme une hypocrite - parole de Yahvé.'"
,"11":"C'est pourquoi - c'est Yahvé qui parle, la rebelle Israël est meilleure que Juda, la perfide."
,"12":"Tu peux lancer cet appel vers les pays du nord: 'Reviens, rebelle Israël - parole de Yahvé. Je ne vous montrerai plus un visage sévère, car je suis bienveillant - parole de Yahvé, et ma colère n'est pas sans fin."
,"13":"Seulement reconnais ta faute: tu t'es révoltée contre Yahvé ton Dieu et tu as couru de tous côtés après les étrangers, sous tout arbre vert. Et vous n'avez pas écouté ma voix - parole de Yahvé.'"
,"14":"Revenez fils infidèles, car je suis votre Maître - parole de Yahvé. Je vous prendrai, l'un d'une ville, deux d'une famille, et je vous ramènerai à Sion."
,"15":"Je vous donnerai des bergers comme je les aime, qui vous feront paître avec intelligence et sagesse."
,"16":"En ces jours-là vous vous multiplierez, vous serez nombreux dans le pays - parole de Yahvé; alors on ne parlera plus de l'Arche de l'Alliance de Yahvé. On l'aura oubliée, on ne s'en souviendra plus; on ne la regrettera pas et on ne cherchera pas à en faire une autre."
,"17":"C'est qu'en ce temps-là on appellera Jérusalem: le Trône de Yahvé. Là se rassembleront toutes les nations; elles ne suivront plus constamment leurs penchants mauvais."
,"18":"En ces jours-là les gens de Juda feront la route avec ceux d'Israël; ils reviendront ensemble du pays du nord à la terre que j'ai donnée en héritage à vos pères."
,"19":"Je m'étais dit: 'Comment te mettrai-je au rang de mes enfants? Je te donnerai un pays agréable et le plus bel héritage au milieu des nations.',Je me disais: Tu m'appelleras: 'Mon Père', et vous ne vous éloignerez pas de moi. "
,"20":"Mais comme une femme trahit son amant, vous aussi vous m'avez été infidèles, maison d'Israël - parole de Yahvé."
,"21":"Sur les collines déboisées on entend un bruit, ce sont les cris et les supplications des enfants d'Israël. Ils s'étaient égarés en chemin, ils avaient oublié Yahvé leur Dieu."
,"22":"Revenez fils infidèles, je guérirai votre infidélité!,- 'Nous voici, nous revenons vers toi, car tu es Yahvé notre Dieu. "
,"23":"C'est vrai, tout ce bruit sur les collines et les montagnes n'était que mensonges, le salut d'Israël est en Yahvé notre Dieu."
,"24":"Depuis notre jeunesse, les idoles ont dévoré le fruit du travail de nos pères: leurs brebis et leurs boeufs, leurs fils et leurs filles."
,"25":"Notre honte colle à notre peau et nous sommes couverts de confusion! Nous et nos pères, depuis notre jeunesse et jusqu'à présent, nous avons péché contre Yahvé notre Dieu; nous n'avons pas écouté la voix de Yahvé notre Dieu.'"
}`)
	CurrentBook.AddChapter(4, `{
"1":"Si tu veux revenir, Israël, reviens vers moi - parole de Yahvé. Si tu enlèves tes Ordures de devant moi, tu ne t'égareras plus sur le chemin!"
,"2":"Si tu proclames: 'Yahvé est vivant!' avec sincérité, droiture et justice, alors tu seras pour les nations une bénédiction, tu seras leur gloire."
,"3":"Car voici ce que dit Yahvé aux hommes de Juda et de Jérusalem: Travaillez la terre laissée à l'abandon, ne semez pas au milieu des épines."
,"4":"Faites-vous la circoncision de Yahvé: enlevez de vos coeurs vos idoles, hommes de Juda et habitants de Jérusalem, sinon ma colère tombera comme un feu sur vos actions mauvaises, elle brûlera et personne n'éteindra."
,"5":"Proclamez-le dans Juda, annoncez-le dans Jérusalem, faites sonner la trompette dans le pays, criez de toutes vos forces: 'Qu'on se rassemble et se réfugie dans les villes fortifiées!'"
,"6":"Dressez un signal du côté de Sion, sauvez-vous, ne vous arrêtez pas!,Car du nord je fais venir un malheur, une véritable catastrophe."
,"7":"Le lion est sorti de sa tanière, le destructeur des nations s'est mis en route, il a quitté sa place pour faire de ton pays un désert,et laisser tes villes en ruines, sans habitants."
,"8":"Il faut vous habiller de sacs, pleurer et vous lamenter, car la colère de feu de Yahvé ne s'est pas détournée de nous."
,"9":"En ce temps-là - parole de Yahvé - le roi et les princes perdront leur assurance, les prêtres seront déconcertés et les prophètes stupéfaits."
,"10":"Alors ils diront: 'Ah, Seigneur Yahvé, tu as vraiment trompé ce peuple et Jérusalem quand tu disais: Vous aurez la paix! Car l'épée vient pour les frapper à mort.'"
,"11":"En ce temps-là on dira à ce peuple et à Jérusalem: 'Un vent brûlant arrive droit des collines du désert sur la ville de mon peuple; mais ce n'est pas pour vanner ou pour nettoyer.'"
,"12":"- 'C'est un vent menaçant que je vous envoie, c'est mon tour maintenant de parler et de les juger.'"
,"13":"'Voyez ce nuage qui fonce sur nous! Ses chars sont pareils à l'ouragan, ses chevaux plus rapides que l'aigle; malheur à nous, nous sommes perdus!'"
,"14":"Si tu veux être sauvée, Jérusalem, enlève de ton coeur la méchanceté. Combien de temps encore garderas-tu ces pensées coupables dans ton coeur?"
,"15":"Une voix se fait entendre depuis Dan; depuis la montagne d'Ephraïm elle annonce le malheur:"
,"16":"'Avertissez Juda, faites savoir à Jérusalem que ses ennemis arrivent d'un pays lointain. Déjà ils poussent leurs cris de guerre face aux villes de Juda,"
,"17":"et comme les gardiens d'un champ, ils encerclent le pays.',C'est qu'il s'est révolté contre moi - parole de Yahvé. "
,"18":"Voilà le résultat de ta conduite et de tes actions, vois comme ton mal est amer; il t'a frappée en plein coeur."
,"19":"O mes entrailles, mes entrailles! Comme je souffre au plus profond de moi-même! Mon coeur s'agite et je ne peux me taire. N'entends-tu pas, ô mon âme, le son de la trompette et le cri de guerre?"
,"20":"On annonce ruine sur ruine, car tout le pays est dévasté; mes tentes sont emportées d'un seul coup, et mes refuges en un instant."
,"21":"Combien de temps encore verrai-je les drapeaux? Combien de temps encore entendrai-je le son de la trompette?"
,"22":"Oui, mon peuple est fou, ils ne me connaissent pas; ce sont des fils stupides, privés d'intelligence; ils sont adroits pour faire le mal, mais ils ne savent pas faire le bien."
,"23":"J'ai regardé la terre: ce n'était plus qu'un chaos; j'ai regardé les cieux: leur lumière avait disparu."
,"24":"J'ai regardé les montagnes: elles étaient ébranlées; j'ai regardé les collines: toutes chancelaient."
,"25":"J'ai regardé: il n'y avait plus d'hommes, tous les oiseaux du ciel s'étaient enfuis."
,"26":"J'ai regardé: le verger était devenu un désert et toutes les villes étaient détruites. Cela venait de Yahvé, du feu de sa colère."
,"27":"Car voici ce qu'a dit Yahvé: 'Tout le pays sera ravagé; cependant je ne le détruirai pas complètement.'"
,"28":"C'est pourquoi la terre est en deuil et les cieux là-haut se sont obscurcis, parce que je l'ai dit et je l'ai décidé: je ne le regretterai pas, je ne reviendrai pas en arrière.'"
,"29":"Le cavalier, l'archer, avec leurs cris,ont mis toute la ville en fuite, on gagne les bois, on grimpe sur les rochers, les villes sont abandonnées, vidées de leurs habitants."
,"30":"Et toi, la dévastée, que vas-tu faire?,Tu peux t'habiller de pourpre, te couvrir de bijoux d'or, et te farder le tour des yeux; toute cette beauté ne servira de rien. Tes amants n'y feront pas attention,car c'est à ta vie qu'ils en veulent."
,"31":"Oui, j'entends des cris, comme ceux de la femme en travail, cris de souffrance comme ceux d'une femme pour un premier enfant; c'est la fille de Sion qui gémit et tend les mains: 'Malheur à moi, je succombe sous les coups des assassins!'"
}`)
	CurrentBook.AddChapter(5, `{
"1":"Parcourez les rues de Jérusalem et regardez, informez-vous, cherchez sur ses places. Si vous y trouvez un homme, un seul, qui pratique la justice et cherche la vérité, je pardonnerai à la ville."
,"2":"S'ils disent: 'Yahvé est vivant!' c'est pour jurer faussement."
,"3":"Yahvé, tes yeux ne cherchent-ils pas la vérité? Or tu les as frappés et ils n'ont pas réagi, tu les as détruits et ils ont refusé la leçon; ils se sont fait un visage de pierre et ne sont pas revenus vers toi."
,"4":"Moi, je me disais: 'Il n'y a que les pauvres pour être ainsi irresponsables; ils ne connaissent pas la voie de Yahvé, la Loi de leur Dieu."
,"5":"J'irai donc vers les chefs et je leur parlerai, car ils connaissent la voie de Yahvé, la Loi de leur Dieu.' Mais eux, c'est d'un commun accord qu'ils ont cassé le joug et rompu les liens."
,"6":"C'est pourquoi le lion de la forêt les a frappés, le loup du désert a fait des ravages, la panthère est aux aguets à la sortie de leurs villes et déchire tous ceux qui sortent. C'est que leurs péchés sont nombreux, et ils s'entêtent dans leur révolte."
,"7":"Il faudrait te pardonner? Tes fils m'ont abandonné et jurent par des faux dieux. Quand je leur donnais leur pain, ils cherchaient l'adultère, ils s'attroupaient à la maison de la prostituée."
,"8":"Ce sont des étalons bien nourris qui courent en liberté, et chacun renifle après la femme de son prochain."
,"9":"Et je ne punirais pas tout cela? - parole de Yahvé. Et je ne me vengerais pas d'une nation comme celle-là?"
,"10":"Escaladez ces murs et détruisez tout. Arrachez ces pieds de vigne car ils ne sont pas ceux de Yahvé."
,"11":"La maison d'Israël et la maison de Juda m'ont complètement trahi - parole de Yahvé."
,"12":"Ils ont renié Yahvé, ils ont dit: 'Il n'existe pas, le malheur ne viendra pas sur nous, nous ne verrons ni l'épée, ni la famine."
,"13":"Que le vent emporte les prophètes, personne ne parle par eux; que leurs menaces retombent sur eux!'"
,"14":"C'est pourquoi, voici ce que dit Yahvé, le Dieu Sabaot: Puisqu'ils parlent ainsi, je vais mettre dans ta bouche des paroles de feu. Ce peuple sera le bois et le feu les dévorera!"
,"15":"Yahvé l'a dit, maison d'Israël: j'amène contre vous une nation lointaine, une nation forte, une nation ancienne, une nation dont tu ne connais pas la langue, et tu ne comprends pas ce qui s'y dit."
,"16":"Son étui à flèches est une tombe ouverte, là-bas tous sont des vaillants!"
,"17":"Elle dévorera ta moisson et ton pain, elle dévorera tes fils et tes filles, elle dévorera tes brebis et tes boeufs, elle dévorera ta vigne et ton figuier. Ses armes détruiront tes forteresses,dans lesquelles tu mettais ta confiance."
,"18":"Mais, même en ces jours-là, je ne te détruirai pas complètement - parole de Yahvé."
,"19":"Lorsqu'ils demanderont: 'Pourquoi Yahvé notre Dieu nous fait-il tout cela?' tu leur répondras: 'Puisque vous m'avez abandonné pour servir dans votre pays des dieux étrangers, maintenant vous servirez des étrangers dans un pays qui ne sera pas le vôtre.'"
,"20":"Annoncez ceci à la maison de Jacob,et proclamez ces paroles en Juda."
,"21":"Ecoutez donc ceci, peuple insensé et stupide, avec des yeux qui ne voient pas, et des oreilles qui n'entendent pas!"
,"22":"Ne me craindrez-vous pas - parole de Yahvé, ne tremblerez-vous pas devant moi?,C'est moi qui mis le sable à la frontière des mers, comme une borne éternelle qu'elle ne franchira pas. Elle s'agite impuissante, ses flots mugissent mais ne vont pas au-delà."
,"23":"Ce peuple par contre est infidèle et rebelle, ils se reprennent et s'en vont."
,"24":"Ils ne disent pas au fond d'eux-mêmes: 'Craignons Yahvé notre Dieu, qui nous donne les pluies d'automne,et celles du printemps, au bon moment, et puis nous donne les semaines qu'il a fixées pour la moisson.'"
,"25":"Vos fautes ont semé là le désordre, vos péchés vous ont privés de ces biens."
,"26":"Il y a dans mon peuple des êtres malfaisants, toujours à l'affût comme le chasseur d'oiseaux; s'ils dressent un piège, c'est pour prendre des hommes."
,"27":"Ils ont leur cage pleine d'oiseaux, leur maison s'est remplie par la fraude,ils sont devenus puissants et riches."
,"28":"Ils sont gros, ils suent la graisse, ils n'ont plus honte du mal. Leur justice n'en est pas une: ils ne connaissent pas le droit de l'orphelin, et ne font pas droit au malheureux."
,"29":"Et je laisserais passer ces crimes?,D'un peuple comme celui-là - parole de Yahvé, je ne me vengerais pas"
,"30":"On voit ici des choses honteuses, horribles:"
,"31":"les prophètes prophétisent des mensonges, les prêtres ne pensent qu'à leurs intérêts, et mon peuple aime qu'il en soit ainsi. Mais que ferez-vous à la fin?"
}`)
	CurrentBook.AddChapter(6, `{
"1":"Fuyez, fils de Benjamin, sortez de Jérusalem. Sonnez du cor à Tékoa, dressez un signal sur Beth-Ha-Kérem, car un malheur vient du Nord, une véritable catastrophe."
,"2":"N'étais-tu pas, fille de Sion, une prairie délicieuse?"
,"3":"Des bergers y arrivent avec leurs troupeaux, ils piquent leurs tentes tout autour, et chacun y fait paître son troupeau."
,"4":"Engagez contre elle une guerre sainte, debout, il fait jour, montons à l'assaut!,Malheur à nous! Déjà le jour baisse,et les ombres du soir s'allongent."
,"5":"Alors faisons l'assaut de nuit, car il nous faut détruire ses forts."
,"6":"Voici ce que dit Yahvé Sabaot: Abattez les arbres, dressez contre Jérusalem des palissades, car cette ville doit rendre des comptes, tout en elle est oppression."
,"7":"Comme la source fait jaillir son eau, d'elle sort sa méchanceté. On n'y entend parler que d'abus, de violence,et je n'y vois jamais que plaies et coups."
,"8":"Reprends-toi, Jérusalem! Ou bien je me détacherai de toi, je ferai de toi un désert, une terre inhabitée."
,"9":"Voici ce que dit Yahvé Sabaot: On grappillera comme une vigne ce qui restera d'Israël, comme le vendangeur passe la main sur les pieds de sa vigne."
,"10":"A qui puis-je parler? M'écoutera-t-on si j'insiste? Leurs oreilles ont besoin d'une circoncision: elles sont incapables d'attention. La parole de Yahvé est devenue pour eux un sujet de moqueries; ils n'en veulent pas. "
,"11":"Et moi je suis rempli de la colère de Yahvé, je n'en peux plus de la retenir!,- 'Déverse-la sur les enfants dans la rue, ou sur le groupe des jeunes! Le mari et sa femme seront pris ensemble, et le plus âgé avec celui qui ne l'est pas. "
,"12":"Leurs maisons, leurs champs et leurs femmes passeront à d'autres, car je vais lever ma main contre les habitants du pays - parole de Yahvé.'"
,"13":"Tous sont des malhonnêtes, du plus petit jusqu'au plus grand; prophètes ou prêtres, tous mentent."
,"14":"Ils ne font que couvrir la blessure de mon peuple et promettent la paix, alors qu'il n'y a pas de paix."
,"15":"Ils ne rougissent pas de commettre ces horreurs, car ils ne savent même plus rougir, ils ne savent plus ce que c'est que la honte!,C'est pourquoi ils seront au nombre des victimes, ils tomberont le jour où je les visiterai - parole de Yahvé.'"
,"16":"Voici ce que dit Yahvé: 'Revenez au point de départ et renseignez-vous sur les chemins d'autrefois: quel est le chemin du salut? Et puis suivez-le, et vous trouverez du repos pour vos âmes.' Mais voici qu'ils répondent: 'Non, nous ne le prendrons pas!'"
,"17":"J'ai placé à côté de vous des sentinelles: 'Faites attention si la trompette sonne!' Mais ils ont répondu: 'Non, nous n'y ferons pas attention!'"
,"18":"C'est pourquoi nations, écoutez, que l'assemblée des peuples le sache,"
,"19":"et toi, terre, écoute: Je vais faire venir un malheur sur ce peuple, et ce sera le fruit de leur infidélité; car ils n'ont pas été attentifs à ma parole et ils ont rejeté ma loi."
,"20":"Que m'importe l'encens importé de Chéba et le roseau parfumé importé d'un pays lointain? Vos holocaustes ne me plaisent pas, vos sacrifices ne me sont pas agréables."
,"21":"C'est pourquoi, voici ce que dit Yahvé: Je vais mettre des pierres sur leur chemin, ils trébucheront et périront tous ensemble, le père avec son fils, l'homme et son compagnon."
,"22":"Ainsi parle Yahvé: Un peuple arrive du nord, une grande nation se lève des extrémités de la terre."
,"23":"Ce sont des barbares sans pitié, qui savent manier l'arc et le javelot. On dirait le grondement de la mer: ils arrivent sur leurs chevaux comme un seul homme, prêts à combattre, fille de Sion."
,"24":"Quand nous avons appris la nouvelle, nos mains sont restées sans force, l'inquiétude nous a saisis, une douleur comme celle de la femme qui enfante."
,"25":"Ne sortez pas dans les champs, ne vous aventurez pas sur les routes, car l'épée de l'ennemi est là: c'est la terreur de tous côtés."
,"26":"Habille-toi d'un sac, fille de mon peuple, roule-toi dans la cendre et porte le deuil comme pour un fils unique, pousse des lamentations déchirantes, car d'un seul coup le dévastateur est là sur nous."
,"27":"Je t'ai demandé de passer au creuset mon peuple, de connaître et d'éprouver leur conduite."
,"28":"Ce sont tous des rebelles, ils ont la tête dure comme le bronze ou le fer; ils ne font tous que détruire."
,"29":"Le soufflet a soufflé si fort que le plomb a disparu dans le feu; mais le fondeur a perdu ses efforts car les impuretés ne sont pas parties."
,"30":"On les appellera 'argent de balayures' car Yahvé les a mis aux ordures."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Voici la parole venue de Yahvé qui fut adressée à Jérémie:"
,"2":"'Va te placer à la porte du temple de Yahvé. Là, tu proclameras cette parole: Ecoutez la parole de Yahvé, vous tous gens de Judée qui passez par ces portes et venez adorer Yahvé."
,"3":"Voici ce que dit Yahvé Sabaot, le Dieu d'Israël: Améliorez votre conduite, vos actes, et je resterai ici avec vous. "
,"4":"Mais ne vous fiez pas à des paroles mensongères: 'C'est ici le Temple de Yahvé! Le Temple de Yahvé! Le Temple de Yahvé!'"
,"5":"Améliorez pour de bon votre conduite et vos actes. Qu'il y ait une vraie justice entre vous;"
,"6":"n'exploitez pas l'étranger, l'orphelin et la veuve; ne répandez pas le sang innocent en ce lieu; ne suivez pas d'autres dieux pour votre malheur."
,"7":"Alors je vous ferai rester en ce lieu, sur cette terre que j'ai donnée à vos pères depuis le commencement et pour toujours."
,"8":"Mais vous mettez votre confiance dans des paroles creuses qui ne mènent à rien."
,"9":"Quoi! Vous volez, vous tuez, vous commettez l'adultère, vous faites de faux serments, vous brûlez l'encens devant Baal, vous suivez d'autres dieux qui ne sont pas de chez vous..."
,"10":"Et ensuite, vous venez vous présenter devant moi, dans ce Temple qui porte mon Nom, et vous pensez: 'Ici nous n'aurons rien à craindre pour tous les méfaits que nous avons commis.'"
,"11":"Ce Temple où s'est posé mon Nom, le regardez-vous comme une caverne de brigands? En tout cas, moi, je sais regarder - parole de Yahvé."
,"12":"Allez donc à mon sanctuaire de Silo. C'est là que mon Nom habitait autrefois, mais voyez ce que j'en ai fait à cause des méfaits d'Israël, mon peuple."
,"13":"Vous maintenant vous agissez de même - parole de Yahvé. Je vous ai parlé sans me lasser et vous n'avez pas écouté. Je vous ai lancé des appels et vous n'avez pas répondu."
,"14":"C'est pourquoi, ce que j'ai fait à Silo, je vais le faire aussi pour ce Temple sur lequel s'est posé mon Nom, dans lequel vous mettez votre confiance, et pour ce lieu que j'ai donné à vos pères."
,"15":"Je vous rejetterai loin de ma face, comme j'ai rejeté tous vos frères, toute la descendance d'Ephraïm."
,"16":"'Et toi, n'interviens pas pour ce peuple là, ne m'adresse pas de prières ou de supplications en leur faveur; n'insiste pas auprès de moi, car je n'écouterai pas."
,"17":"Tu ne vois donc pas ce qu'ils font dans les villes de Juda et dans les rues de Jérusalem?"
,"18":"Les fils ramassent du bois, les pères allument le feu, les mères pétrissent la pâte et font des gâteaux pour la reine des cieux; ensuite on verse des libations à d'autres dieux pour m'insulter."
,"19":"Mais finalement, est-ce moi qu'ils rabaissent? - parole de Yahvé. N'est-ce pas plutôt eux-mêmes, pour leur propre honte?"
,"20":"C'est pourquoi, voici ce que dit le Seigneur Yahvé: Ma colère et ma fureur vont se déverser sur ce lieu, sur les hommes et sur les bêtes, sur les arbres des champs et sur les fruits de la terre; le feu prendra et ne s'éteindra pas!'"
,"21":"Voici ce que dit Yahvé Sabaot, le Dieu d'Israël: 'Vous pouvez accumuler vos holocaustes et vos sacrifices, et en manger la viande!"
,"22":"Mais le jour où j'ai fait sortir vos pères du pays d'Egypte, je ne leur ai rien dit, rien commandé au sujet de l'holocauste et du sacrifice."
,"23":"Voici ce que je leur ai dit: 'Si vous écoutez ma voix, je serai votre Dieu et vous, vous serez mon peuple. Si vous marchez dans les chemins que je vous ordonne, vous connaîtrez le bonheur.'"
,"24":"Mais ils n'ont pas écouté, ils n'ont pas prêté l'oreille; ils ont préféré suivre leurs mauvais penchants, si bien qu'ils ont reculé au lieu d'avancer."
,"25":"Depuis le jour où vos pères sont sortis du pays d'Egypte jusqu'à ce jour, je vous ai envoyé sans me lasser mes serviteurs - tous les prophètes."
,"26":"Mais vous ne m'avez pas écouté, vous n'avez pas prêté l'oreille, vous avez raidi votre nuque et vous avez fait le mal plus que vos pères."
,"27":"Tu auras beau leur dire tout cela, ils ne t'écouteront pas; tu les appelleras et ils ne te répondront pas."
,"28":"Alors tu leur diras: Vous êtes bien la nation qui n'a pas écouté la voix de Yahvé son Dieu et ne s'est pas laissé instruire. Votre fidélité s'est perdue.'"
,"29":"Coupe tes longs cheveux à ras et jette-les, chante une lamentation sur les collines déboisées; car Yahvé a repoussé et rejeté cette génération qui l'insupporte."
,"30":"Oui, les fils de Juda ont fait ce qui est mal à mes yeux - parole de Yahvé. Ils ont souillé le Temple qui porte mon Nom quand ils y ont placé leurs Ordures."
,"31":"Ils ont construit le haut-lieu du Tophet, dans la vallée de Ben-Hinnom, pour y passer au feu leurs fils et leurs filles. Voilà une chose que je n'avais pas commandée et à laquelle je n'avais même jamais pensé."
,"32":"C'est pourquoi dans les jours qui viennent - parole de Yahvé - on ne dira plus le 'Tophet', ni 'la vallée de Ben-Hinnom', mais 'la vallée du massacre'. Par manque de place on enterrera à Tophet."
,"33":"Les cadavres de ce peuple deviendront la proie des oiseaux du ciel et des bêtes de la terre: personne ne les chassera."
,"34":"Dans les villes de Juda et dans les rues de Jérusalem je ferai disparaître les chants de joie et de fête, le chant du marié et de la mariée, car le pays ne sera plus que ruines."
}`)
	CurrentBook.AddChapter(8, `{
"1":"En ce temps-là - parole de Yahvé - on enlèvera de leurs tombes les os des rois de Juda et les os de ses chefs, les os des prêtres et des prophètes, ainsi que les os des habitants de Jérusalem."
,"2":"On les exposera au soleil et à la lune et à toute l'armée des astres qu'ils ont aimés et servis, dont ils ont fait leurs guides, et qu'ils ont consultés et adorés. Nul ne recueillera ces os, ils ne sont pas enterrés; ils resteront comme le fumier sur la surface du sol."
,"3":"Quant aux survivants de cette méchante race, la mort leur semblera plus douce que la vie dans tous les lieux où je les aurai chassés - parole de Yahvé Sabaot."
,"4":"Tu leur diras: 'Voici ce que dit Yahvé: Est-ce qu'on ne se relève pas après une chute? Est-ce qu'on ne revient pas après une erreur?"
,"5":"Pourquoi l'infidélité de ce peuple, l'infidélité de Jérusalem, ne prend-elle pas fin? Ils se cramponnent à leur mensonge et refusent de revenir."
,"6":"Ils voient, il entendent, mais ils parlent un autre langage, pas un ne renonce à sa méchanceté, pas un ne dit: Qu'ai-je fait? Ils continuent à courir droit devant eux comme un cheval à la bataille."
,"7":"Même la cigogne dans le ciel sait quand elle doit revenir; la tourterelle, l'hirondelle et la grue respectent la date de leur retour. Mais mon peuple ne connaît pas la Loi de Yahvé.'"
,"8":"Et vous, comment osez-vous dire: 'Nous sommes des sages, nous avons la Loi de Yahvé'? La plume menteuse des scribes a bien su la changer en mensonge."
,"9":"Mais les sages vont rester sans réponse, ils seront consternés et pris au piège: on verra ce que vaut votre sagesse, vous qui avez méprisé la parole de Yahvé."
,"10":"Je donnerai leurs femmes à d'autres, leurs champs à de nouveaux maîtres, car du plus petit jusqu'au plus grand ils ne cherchent que leur intérêt; qu'ils soient prophètes ou prêtres, tous ne font que mentir."
,"11":"Ils ne font que recouvrir la blessure de mon peuple, ils disent: 'Ce sera la paix!' quand il n'y a pas de paix."
,"12":"Ils ne rougissent pas de faire des horreurs, car ils ne savent même plus rougir, ils ne savent plus ce qu'est la honte. C'est pourquoi ils tomberont le jour où je les visiterai - parole de Yahvé."
,"13":"Je vais les ramasser, les emporter - parole de Yahvé. Il n'y aura plus de raisins sur la vigne, plus de figues sur le figuier, et les feuilles se faneront."
,"14":"'Pourquoi restons-nous là assis? Allons ensemble nous réfugier dans les villes fortifiées jusqu'à ce que la mort vienne, car Yahvé, notre Dieu, veut notre mort; il nous fait boire des eaux empoisonnées parce que nous avons péché contre lui."
,"15":"Nous espérions la paix mais rien de bon ne vient, le temps ne nous amène pas la guérison, mais la terreur!'"
,"16":"Depuis Dan se fait entendre le souffle de ses chevaux; le bruit de sa cavalerie fait trembler tout le pays. Les voilà: ils dévorent la campagne avec ses richesses, les villes avec leurs habitants."
,"17":"'Voici que j'envoie contre vous des serpents, des vipères sur lesquelles aucun charmeur n'a pouvoir. Ils vous mordront - oracle de Yahvé,"
,"18":"et le mal sera sans remède.',Mon coeur me fait mal. "
,"19":"Par tout le pays on entend les appels de mon peuple: 'Yahvé n'est-il plus dans Sion? Son Roi n'est-il plus en elle?' - 'Pourquoi donc m'ont-ils mis en colère avec leurs idoles, avec ces stupidités venues de l'étranger?'"
,"20":"La moisson s'est terminée, l'été est passé, mais nous n'avons pas été sauvés."
,"21":"La blessure de la fille de mon peuple est devenue ma propre blessure, j'en suis accablé et rempli d'épouvante."
,"22":"N'y a-t-il plus de pommade en Galaad? N'y a-t-il là-bas aucun guérisseur? Pourquoi la guérison de mon peuple n'avance-t-elle pas?"
,"23":"Il faudrait changer ma tête en fontaine et mes yeux en sources de larmes, que je pleure nuit et jour les morts de mon peuple."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Trouvez-moi au désert un gîte d'étape: je laisserai mon peuple, j'irai loin d'eux, ces infidèles, cette bande de traîtres."
,"2":"Avec leur langue ils décochent des flèches, c'est le mensonge et non la vérité,qui règne dans ce pays, car ils vont de crime en crime,au lieu de me connaître - parole de Yahvé."
,"3":"Que chacun se garde de son compagnon, ne faites pas confiance à un frère, car ce frère ne pense qu'à vous avoir, et votre ami vous calomnie."
,"4":"Ils se trompent l'un l'autre, personne ne dit la vérité. Ils sont entraînés au mensonge,et s'épuisent à faire le mal."
,"5":"Ils sont installés dans le mensonge, leur fausseté les empêche de me connaître,- parole de Yahvé."
,"6":"C'est pourquoi Yahvé Sabaot a déclaré: Je vais les éprouver au feu, les examiner; que puis-je faire d'autre pour mon peuple?"
,"7":"Leur langue est une flèche qui tue, leurs paroles ne sont que mensonge, ils souhaitent la paix à leur prochain, mais au fond ils préparent un coup bas."
,"8":"Et je ne les punirais pas pour tout cela?,- parole de Yahvé, je ne me vengerais pas d'une nation comme celle-là?"
,"9":"Faites entendre une lamentation à propos des montagnes, un chant de deuil pour les pâturages du désert, car les voilà brûlés. Nul n'y passe, on n'y entend plus les bruits du troupeau; oiseaux du ciel et bêtes sauvages ont fui, tous ont disparu."
,"10":"'Je ferai de Jérusalem un tas de ruines, un repaire de chacals; je ferai des villes de Juda un désert sans habitants.'"
,"11":"Y aura-t-il quelqu'un d'assez sage pour comprendre ces événements, quelqu'un à qui Yahvé dira d'en expliquer le pourquoi: pourquoi ce pays ravagé, brûlé, devenu un désert où personne ne passe?"
,"12":"Yahvé dit: 'C'est parce qu'ils ont abandonné ma Loi que je leur avais donnée, ils ne m'ont pas écouté, ils ne l'ont pas suivie,"
,"13":"ils ont préféré suivre les Baals comme leurs pères leur avaient enseigné.'"
,"14":"C'est pourquoi, voici ce que dit Yahvé Sabaot, le Dieu d'Israël: Je ferai absorber à ce peuple de l'absinthe, je lui donnerai à boire de l'eau empoisonnée."
,"15":"Je le disperserai au milieu de nations que ni eux ni leurs pères n'ont connues. J'enverrai contre eux l'épée jusqu'à les avoir exterminés."
,"16":"Voici ce que dit Yahvé Sabaot: 'Appelez les pleureuses, envoyez chercher les meilleures et qu'elles pleurent!"
,"17":"Qu'elles nous fassent entendre des lamentations pour que nous pleurions nous aussi et que nos yeux laissent échapper nos larmes.'"
,"18":"Oui, l'écho d'une plainte nous arrive de Sion: 'Hélas, quel pillage,et quelle honte pour nous: nous avons dû quitter le pays, et l'on a démoli nos maisons.'"
,"19":"O femmes, écoutez donc la parole de Yahvé, que vos oreilles entendent les paroles de sa bouche. Enseignez à vos filles ce chant funèbre, redites l'une à l'autre cette lamentation:"
,"20":"'La mort a grimpé par nos fenêtres, elle est entrée dans nos palais, elle a fauché l'enfant dans la rue,et les jeunes gens sur les places."
,"21":"Les cadavres sont étendus,comme du fumier à la surface des champs, comme la gerbe oubliée derrière le moissonneur, que personne ne vient ramasser!'"
,"22":"Voici ce que dit Yahvé: 'Que le sage ne se vante pas de sa sagesse, que le brave ne se vante pas de sa bravoure, que le riche ne se vante pas de ses richesses!"
,"23":"Mais si quelqu'un veut se vanter, qu'il se vante de ceci: d'avoir l'intelligence pour me connaître: moi, Yahvé, mon oeuvre sur terre n'est que bonté, droiture et justice. Voilà ce que j'aime - parole de Yahvé.'"
,"24":"Voici venir des jours - parole de Yahvé - où je demanderai des comptes à tous ceux qui sont circoncis avec ceux qui ne le sont pas:"
,"25":"l'Egypte, Juda, Edom, les fils d'Ammon, Moab et tous les hommes aux tempes rasées qui habitent le désert. Car tous ces païens n'ont pas la circoncision, et les gens d'Israël n'ont pas la circoncision du coeur."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Ecoutez la parole que Yahvé prononce sur vous, maison d'Israël."
,"2":"Voici ce que dit Yahvé: N'apprenez pas les pratiques des païens et ne craignez pas les signes du zodiaque; ce sont les païens qui s'en inquiètent!"
,"3":"Le 'Dieu terrible' des païens n'est que du creux: on a coupé un arbre dans la forêt, un artisan l'a travaillé de ses mains au ciseau."
,"4":"On l'a embelli avec de l'argent ou de l'or, et on l'a fixé au marteau pour qu'il ne bouge pas."
,"5":"Ce n'est guère plus qu'un épouvantail dans un champ de concombres. Ces dieux ne parlent pas; il faut les porter car ils ne marchent pas. Ne les craignez donc pas car ils ne peuvent faire ni mal ni bien."
,"6":"Nul n'est comme toi, Yahvé: tu es grand, et grand est ton Nom si puissant!"
,"7":"Qui ne te craindrait, Roi des nations? C'est justice, car entre tous les sages des païens, entre tous leurs rois, il n'y a personne comme toi."
,"8":"Tous sont pareillement bêtes et stupides: leurs idoles ne peuvent donner qu'une sagesse de bois."
,"9":"C'est du bois neuf, bien sûr, de l'argent martelé importé de Tarsis, de l'or d'Ofir travaillé par un sculpteur ou un orfèvre; on l'a recouvert de pourpre violette ou de pourpre rouge, mais tout cela reste un travail d'artisan."
,"10":"Mais Yahvé est le Dieu véritable, il est le Dieu vivant, le roi d'éternité. Quand il se met en colère, la terre tremble et les nations ne peuvent tenir devant sa fureur."
,"11":"C'est pourquoi vous direz ceci: 'Les dieux qui n'ont fait ni le ciel ni la terre, disparaîtront de sur la terre et de dessous les cieux.'"
,"12":"Mais lui, par sa puissance il a fait la terre; par sa sagesse il a fondé l'univers, par son intelligence il a étendu les cieux."
,"13":"S'il donne de la voix, c'est un grondement d'eaux dans les cieux; il fait venir les nuages du fond de l'horizon, il envoie les éclairs pour qu'il pleuve et fait sortir le vent de ses réservoirs."
,"14":"Voilà donc disqualifiée la sagesse des mortels. L'orfèvre devrait avoir honte des idoles qu'il a faites: il ne produit que des faussetés, elles sont dépourvues d'esprit."
,"15":"Elles ne sont rien, ce sont des oeuvres ridicules qui seront jugées et disparaîtront."
,"16":"Mais le Lot de Jacob n'est pas comme elles, c'est lui qui a façonné le monde; son nom est Yahvé Sabaot, et Israël est sa propre tribu."
,"17":"Fais ton bagage et sors du pays, toi l'Assiégée!"
,"18":"Car voici ce que dit Yahvé: 'Cette fois je vais chasser au loin les habitants du pays, je les ferai poursuivre et ils n'échapperont pas.'"
,"19":"'Comme je suis malheureux, je suis brisé! Comme ma plaie me fait mal! Et pourtant je disais: si ma souffrance n'était que cela."
,"20":"Ma tente a été dévastée, toutes mes cordes ont été arrachées, mes fils m'ont quittée, ils ont disparu; il n'y a personne pour remonter ma tente et en tendre les toiles."
,"21":"Les bergers ont été stupides; ils n'ont pas recherché Yahvé. C'est pourquoi ils ont échoué et tout leur troupeau a été dispersé."
,"22":"Voici qu'arrive une nouvelle, un grand vacarme s'entend dans le nord; les villes de Juda vont devenir un amas de ruines, un repaire pour les chacals.'"
,"23":"Tu le sais, Yahvé, l'homme n'est pas maître de sa route, le marcheur n'est pas sûr de ses pas."
,"24":"Corrige-nous donc Yahvé, mais juste comme il faut, non pas avec colère, car alors tu nous réduis à rien."
,"25":"Déverse ta fureur sur les nations qui ne te connaissent pas, sur les clans qui n'ont pas invoqué ton nom, car ils ont dévoré Jacob. Ils l'ont dévoré, exterminé; ils ont détruit sa demeure."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Voici une parole qui fut adressée à Jérémie de la part de Yahvé: '"
,"2":"Parle aux hommes de Juda et aux habitants de Jérusalem."
,"3":"Tu leur diras de la part de Yahvé Dieu d'Israël: Maudit soit celui qui n'écoute pas les paroles de cette alliance"
,"4":"que j'ai donnée à vos pères quand je les ai fait sortir du pays d'Egypte, de la fournaise de fer. Je leur ai dit: 'Ecoutez ma voix et mettez en pratique tout ce que je vous ai commandé; alors vous serez mon peuple et je serai votre Dieu."
,"5":"Alors je tiendrai le serment que j'ai juré à vos pères et je leur donnerai une terre où coulent le lait et le miel, comme c'est le cas maintenant.',J'ai répondu: 'Oui, Yahvé!'"
,"6":"Yahvé me dit encore: 'Proclame toutes ces paroles dans les villes de Juda et dans les rues de Jérusalem: Ecoutez les paroles de cette alliance et mettez-les en pratique."
,"7":"J'ai averti solennellement vos pères le jour où je les ai fait monter du pays d'Egypte, et jusqu'à présent je n'ai cessé de leur répéter: Ecoutez ma voix!"
,"8":"Mais ils n'ont pas écouté, ils ne m'ont pas fait cas, chacun a suivi les inclinations de son coeur endurci. J'ai donc accompli contre eux toutes les paroles de cette alliance que je leur avais ordonné de mettre en pratique et qu'ils n'ont pas pratiquée."
,"9":"Yahvé me dit encore: Les hommes de Juda et les habitants de Jérusalem se sont mis d'accord"
,"10":"pour retourner au péché de leurs pères qui avaient refusé d'écouter mes paroles; ils se sont mis à la traîne des dieux étrangers et les ont servis. La maison d'Israël et la maison de Juda ont rompu l'alliance que j'avais faite avec leurs pères."
,"11":"C'est pourquoi voici ce que dit Yahvé: Je vais amener sur eux des malheurs auxquels ils ne pourront pas échapper; s'ils crient vers moi, je ne les écouterai pas."
,"12":"Alors les villes de Juda et les habitants de Jérusalem iront supplier les dieux auxquels ils offrent l'encens, mais ces dieux ne les délivreront pas au temps de leur malheur."
,"13":"Car tes dieux, Juda, sont aussi nombreux que tes villes, et vous avez autant d'autels à encens pour Baal, qu'il y a de rues à Jérusalem."
,"14":"C'est pourquoi, toi, n'intercède pas pour ce peuple; ne m'adresse ni supplication ni prière en leur faveur, car je ne t'écoute pas quand les choses vont mal pour eux."
,"15":"Que vient donc faire ma bien-aimée dans ma maison? Elle croit encore qu'elle m'aura avec ses mines. Crois-tu que les graisses et la viande de tes sacrifices feront passer tes fautes et que je t'en tiendrai quitte?"
,"16":"Yahvé t'avait appelée: 'Bel olivier tout en olives'; mais il y a mis le feu, et l'on entend ses craquements dans les branches."
,"17":"Yahvé Sabaot t'avait plantée, mais il te promet maintenant le malheur. C'est que la maison d'Israël et la maison de Juda ont fait le mal; ces gens m'ont mis en colère avec l'encens qu'ils offraient au Baal."
,"18":"Yahvé me donna un avis que je pus vérifier. Oui c'est toi, Yahvé, qui m'as ouvert les yeux sur leurs manoeuvres:"
,"19":"Dire que j'étais comme l'agneau qui se laisse gentiment conduire à la boucherie; je ne savais pas ce qu'ils préparaient contre moi. 'Faisons-lui absorber assez d'épreuves, disaient-ils, pour qu'il disparaisse de la terre des vivants, et plus personne ne prononcera son nom!'"
,"20":"Mais toi, Yahvé Sabaot, tu juges avec justice, tu connais à fond les reins et les coeurs; c'est à toi que j'ai confié ma cause et je te verrai prendre ta revanche."
,"21":"Et voici ce qu'a dit Yahvé Sabaot pour les gens d'Anatot qui s'en prennent à ma vie et qui disent: 'Ne prophétise pas au nom de Yahvé, ou sinon tu mourras de notre main!'"
,"22":"Oui, voici ce que dit Yahvé Sabaot: 'Je vais m'en prendre à eux; leurs jeunes gens mourront par l'épée, leurs fils et leurs filles mourront de faim."
,"23":"L'année où je demanderai des comptes aux gens d'Anatot, j'amènerai sur eux le malheur et il n'y aura pas de survivants.'"
}`)
	CurrentBook.AddChapter(12, `{
"1":"Tu es trop juste, Yahvé, pour que je discute avec toi, et pourtant, c'est bien de justice que je veux parler avec toi: pourquoi les méchants ont-ils de la chance, pourquoi tous ces traîtres sont-ils heureux?"
,"2":"Tu les plantes et ils prennent racines, ils se portent bien et réussissent. Ils ont ton nom sur les lèvres alors que leur coeur est loin de toi."
,"3":"Mais moi, Yahvé, tu me connais, tu me vois. Mon coeur, si près de toi, n'a rien de caché pour toi. Enlève-les donc comme des brebis pour la boucherie, et marque-les pour le jour du massacre."
,"4":"Jusques à quand le pays sera-t-il en deuil, avec cette herbe toute desséchée dans les campagnes? Les bêtes et les oiseaux ont péri à cause de la méchanceté des habitants de ce pays, et ils disent encore: 'Dieu ne voit pas notre conduite.'"
,"5":"- 'Si cela te fatigue de courir avec les coureurs, pourras-tu t'aligner avec les chevaux? Si tu n'es pas en sécurité dans un pays paisible, que feras-tu dans les fourrés du Jourdain?"
,"6":"'Tes frères eux-mêmes et la famille de ton père sont faux avec toi, ils te critiquent ouvertement par derrière; ne te fie pas à leurs bonnes paroles.'"
,"7":"J'ai quitté ma maison, j'ai abandonné mon héritage, j'ai livré ce que j'aimais,entre les mains de mes ennemis."
,"8":"Les miens sont devenus pour moi,comme un lion dans la forêt, ils ont élevé la voix contre moi, et moi je les ai détestés."
,"9":"Mon peuple serait-il devenu,comme un vautour au vilain plumage, que tous les autres vautours fondent sur lui?,Venez, rassemblez-vous, bêtes sauvages, accourez toutes au festin!"
,"10":"Des bergers nombreux ont saccagé ma vigne, ils ont piétiné mon domaine, ils ont changé la parcelle que j'aimais,en une terre inculte et désolée."
,"11":"Ils en ont fait un terrain saccagé, il est en deuil, en friches sous mes yeux; tout le pays a été dévasté,et personne ne s'en préoccupe."
,"12":"Les pillards ont escaladé,toutes les collines déboisées du désert. Voici que l'épée de Yahvé dévore, d'une extrémité à l'autre du pays: il n'y a de paix pour personne."
,"13":"Ils ont semé du blé et moissonné des épines, ils se sont épuisés sans aucun résultat. Ils ont honte de ce qu'ils ont récolté, car la colère de Yahvé a sévi."
,"14":"Voici ce que dit Yahvé: 'Tous mes méchants voisins ont porté la main sur l'héritage que j'avais donné à mon peuple Israël, mais je les arracherai eux-mêmes de sur leur terre lorsque je reprendrai de chez eux les gens de Juda."
,"15":"Je les déracinerai, mais ensuite j'aurai pitié d'eux et je les ramènerai chacun dans son héritage, chacun dans son pays."
,"16":"Et s'ils veulent apprendre les normes de mon peuple, s'ils jurent par mon nom en disant: 'Yahvé est vivant' - tout comme eux-mêmes ont appris à mon peuple à jurer par Baal, - alors je les établirai au milieu de mon peuple."
,"17":"Mais si une nation ne m'écoute pas, je l'arracherai et je la détruirai - parole de Yahvé."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Une parole de Yahvé me fut adressée: 'Va t'acheter une ceinture de lin, mets-la sur toi mais ne la trempe pas dans l'eau.'"
,"2":"Je partis acheter la ceinture, comme il m'était dit, et je la mis sur moi."
,"3":"Une seconde fois la parole de Yahvé me fut adressée. Il me dit:"
,"4":"'Prends la ceinture que tu as achetée et que tu portes sur toi; va au torrent Pérah, et là tu la cacheras dans une fente de rocher.'"
,"5":"Je partis donc la cacher près du torrent Pérah, comme Yahvé me l'avait ordonné."
,"6":"Après de nombreux jours Yahvé me dit: 'Lève-toi, retourne au Pérah, et là tu reprendras la ceinture que je t'avais ordonné d'y cacher.'"
,"7":"Je suis donc retourné au Pérah; là j'ai creusé et repris la ceinture à l'endroit où je l'avais cachée. Mais la ceinture était perdue; elle n'était plus bonne à rien."
,"8":"Alors la parole de Yahvé me fut adressée:"
,"9":"'Voici ce que dit Yahvé: C'est ainsi que je ruinerai le prestige de Juda et la grande renommée de Jérusalem."
,"10":"Ce peuple mauvais refuse d'écouter ma parole et n'en fait qu'à sa tête; il s'est mis à la traîne d'autres dieux pour les servir et les adorer. Eh bien, il en sera de lui comme de cette ceinture qui n'est plus bonne à rien."
,"11":"De même qu'on s'attache une ceinture sur les reins, de même je m'étais attaché toute la maison d'Israël et toute la maison de Juda - parole de Yahvé. Je voulais qu'elles soient mon peuple, mon prestige, ma louange et ma gloire; mais ils n'ont pas écouté.'"
,"12":"Tu leur diras encore cette parole: Voici ce que dit Yahvé, le Dieu d'Israël: 'Toute cruche se remplira de vin.' S'ils te répondent: 'Nous savons bien que toute cruche peut se remplir de vin,'"
,"13":"tu ajouteras: 'Voici ce que dit Yahvé: Je vais remplir jusqu'à l'ivresse tous les habitants de ce pays, les rois qui sont assis sur le trône de David, les prêtres et les prophètes et tous les habitants de Jérusalem."
,"14":"Puis je les ferai se briser l'un contre l'autre, les pères aussi bien que les fils - parole de Yahvé. Je n'aurai ni pitié, ni miséricorde, et je les détruirai sans merci.'"
,"15":"Ecoutez, faites attention, ne faites pas les malins, car c'est Yahvé qui parle."
,"16":"Rendez gloire à Yahvé, votre Dieu, avant que les ténèbres n'arrivent et que vos pieds ne trébuchent sur les montagnes obscures. Vous attendiez la lumière mais il la change en ombres, puis en un brouillard épais."
,"17":"Si vous ne tenez pas compte de cet avis, mon âme pleurera en silence à cause de votre orgueil, mes yeux fondront en larmes quand le troupeau de Jacob sera emmené prisonnier."
,"18":"Dis ceci au roi et à la reine: 'Asseyez-vous par terre; votre glorieuse couronne est tombée de votre tête."
,"19":"Les villes du sud sont bloquées et il n'y a plus d'accès; Juda tout entier est déporté, c'est la déportation en masse.'"
,"20":"Lève les yeux, Jérusalem, et regarde ce qui arrive du nord. Où est-il donc le troupeau dont tu avais la charge, les brebis qui faisaient ta gloire?"
,"21":"Que diras-tu quand ceux que tu as habitués à tes caresses viendront te faire la loi? Ne seras-tu pas saisie de douleurs comme une femme qui enfante?"
,"22":"Et si tu demandes: 'Pourquoi cela m'arrive-t-il?' je répondrai: 'C'est à cause de ta faute énorme que ta robe a été relevée et que l'on a frappé tes talons.'"
,"23":"Un Ethiopien peut-il changer la couleur de sa peau? Un léopard peut-il faire passer ses taches? Et vous, habitués à faire le mal, pouvez-vous faire le bien?"
,"24":"Je les disperserai donc comme la paille emportée par le vent du désert."
,"25":"Tel sera ton lot, le sort que je te réserve - parole de Yahvé, car tu m'as oublié et tu t'es livrée au Mensonge."
,"26":"Aussi je relèverai les pans de ta robe jusque sur ton visage et l'on verra ta nudité."
,"27":"Sur les collines, dans la campagne, j'ai vu tes ordures, tes adultères, tes petits cris et ta honteuse prostitution. Malheur à toi Jérusalem, tu restes dans ton impureté: pour combien de temps encore?"
}`)
	CurrentBook.AddChapter(14, `{
"1":"Voici la parole que Yahvé adressa à Jérémie au sujet de la sécheresse:"
,"2":"Juda est en deuil, ses villes vont à la ruine, de tristesse elles se traînent à terre, et de Jérusalem s'élève un cri!"
,"3":"Les riches ont envoyé leurs serviteurs pour chercher de l'eau: arrivant aux citernes ils n'ont pas trouvé d'eau et sont revenus avec leurs cruches vides."
,"4":"La terre est crevassée parce qu'il n'a pas plu dans le pays; c'est pourquoi les paysans se sont voilé le visage."
,"5":"Même la biche sauvage abandonne ses petits, car il n'y a pas de verdure."
,"6":"les ânes sauvages sont montés sur les sommets, ils aspirent l'air comme des chacals et leurs yeux se troublent parce que l'herbe leur manque."
,"7":"Même si nos fautes nous accusent, sauve l'honneur de ton nom, ô Yahvé! Nos révoltes sont nombreuses et nous avons péché contre toi."
,"8":"Mais toi, espoir d'Israël, toi qui le sauves au temps de la détresse, pourquoi te conduire en étranger dans le pays, comme un voyageur de passage pour une nuit?"
,"9":"Pourquoi restes-tu comme un homme qui perd la tête, comme un guerrier incapable de sauver? Tu es au milieu de nous, Yahvé, et nous sommes sous la protection de ton Nom; ne nous abandonne pas!"
,"10":"Voici ce que dit Yahvé à propos de ce peuple: Oui, ils aiment chercher ailleurs, ils ont couru de tous côtés et Yahvé n'est pas du tout content d'eux: c'est pourquoi maintenant il se souvient de leur faute."
,"11":"Yahvé me dit également: Ne me demande pas de faire du bien à ce peuple."
,"12":"S'ils jeûnent, je n'écouterai pas leurs prières. S'ils offrent des holocaustes ou des sacrifices, je ne les regarderai pas; je veux les exterminer par l'épée, la famine et la peste."
,"13":"Alors j'ai dit: 'Ah, mon Seigneur Yahvé, regarde ce que leurs prophètes leur racontent: Ne craignez pas l'épée, vous ne connaîtrez pas la famine, je ne vous donnerai ici que paix et prospérité!'"
,"14":"Et voici la réponse de Yahvé: 'Ce sont des mensonges que prophétisent ces prophètes en mon nom. Je ne les ai pas envoyés, je ne leur ai rien demandé, je ne leur ai pas parlé. Ce sont des visions fausses et des révélations inventées, ce sont leurs rêves qu'ils vous prophétisent.'"
,"15":"C'est pourquoi, voici ce que dit Yahvé contre ces prophètes qui prophétisent en son nom, alors qu'il ne les a pas envoyés: Ils disent que l'épée et la famine ne viendront pas sur ce pays? Eh bien, c'est par l'épée et par la famine que ces prophètes périront!"
,"16":"Quant à ceux qui écoutent ces prophètes, eux aussi mourront par la famine et par l'épée, et leurs corps resteront sur le sol dans les rues de Jérusalem. Il n'y aura personne pour les enterrer, pas plus eux que leurs femmes, leurs fils ou leurs filles. C'est ainsi que je ferai retomber sur eux leur péché."
,"17":"Tu leur diras encore cette parole: 'Que mes yeux fassent couler des larmes abondantes, qu'ils ne s'arrêtent ni la nuit, ni le jour, car je vois la fille de mon peuple frappée d'un mal très grave, d'une plaie douloureuse.'"
,"18":"Si je vais dans les champs, je vois des gens transpercés par l'épée, si j'entre dans la ville, j'en vois d'autres torturés par la faim; les prophètes et les prêtres ont parcouru le pays et n'y comprennent rien."
,"19":"As-tu donc rejeté Juda?,Ton âme est-elle dégoûtée de Sion?,Pourquoi nous as-tu frappés,et n'y a-t-il pas de guérison pour nous?,Nous attendions le salut et tout va mal, ce devait être la guérison, et c'est l'épouvante."
,"20":"O Yahvé, nous reconnaissons notre faute,et les dettes de nos pères: contre toi nous avons péché!"
,"21":"Mais pense à ton Nom, ne brise pas tout, n'abandonne pas ton trône de gloire!,Veille à ne pas rompre ton alliance avec nous!"
,"22":"Parmi toutes les idoles des nations, en est-il une qui puisse faire pleuvoir?,Est-ce le ciel qui donne les averses, n'est-ce pas toi, qui as fait toutes ces choses, toi en qui nous espérions?"
}`)
	CurrentBook.AddChapter(15, `{
"1":"Alors Yahvé m'a dit: Même si Moïse et Samuel étaient devant moi pour me supplier, je n'aurais pas pitié de ce peuple. Chasse-les de devant moi et qu'ils partent!"
,"2":"S'ils te disent: 'Où irons-nous?' Tu leur diras cette parole de Yahvé: 'Que celui qui est pour la mort aille à la mort! S'il est pour l'épée, qu'il aille à l'épée! S'il est pour la famine, qu'il aille à la famine! S'il est pour la captivité, qu'il aille à la captivité!'"
,"3":"Je les soumettrai à quatre tyrans - parole de Yahvé: le glaive pour tuer, les chiens pour déchirer, les oiseaux des cieux et les bêtes de la terre pour dévorer et exterminer. ("
,"4":"Je ferai d'eux un objet d'horreur pour tous les royaumes de la terre, à cause de tout ce que Manassé fils d'Ezéquias, roi de Juda, a fait dans Jérusalem.)"
,"5":"Qui donc aura pitié de toi, Jérusalem? Qui se lamentera sur toi? Qui fera un détour pour s'informer de ta santé?"
,"6":"Tu m'a repoussé - parole de Yahvé - tu t'es éloignée de moi, c'est pourquoi je vais étendre la main pour te détruire, car je suis fatigué de pardonner."
,"7":"Je les ai passés au tamis aux portes du pays, j'ai laissé mon peuple sans enfants pour qu'il disparaisse, mais ils ne sont pas revenus de leur mauvaise conduite."
,"8":"J'ai fait que les veuves soient plus nombreuses que le sable du bord de mer; en plein midi j'ai fait venir le désastre sur la mère et sur ses fils, j'ai fait tomber sur eux terreur et épouvante."
,"9":"Celle qui avait sept fils se lamente et défaille, car son soleil s'est couché avant la fin du jour; elle reste désemparée, affolée. Même les survivants, je les livrerai à l'épée de leurs ennemis - parole de Yahvé."
,"12":"Brisera-t-on le fer et le bronze qui viennent du nord?"
,"13":"Voici que je livre au pillage ta richesse et tes trésors, pour tous les péchés qui ont été commis dans ton pays."
,"14":"Je ferai de toi l'esclave de tes ennemis dans un pays que tu ne connais pas, car ma colère s'est changée en un feu, et nul ne l'éteindra."
,"10":"Malheur à moi, ô ma mère, pourquoi m'as-tu mis au monde! Je divise tout ce pays et sème les querelles. Je n'ai pas prêté, on ne m'a pas prêté, mais tous me maudissent."
,"11":"Dis-moi, Yahvé, ne t'ai-je pas bien servi? N'étais-je pas là à te supplier au temps du malheur et de l'invasion?"
,"15":"Tu le sais, Yahvé. Souviens-toi de moi, montre-toi et venge-moi de ceux qui me persécutent. Ne retiens pas davantage ta colère, ou ils auront raison de moi; c'est pour toi que je souffre tant d'humiliations!"
,"16":"Lorsque m'arrivaient tes paroles, je les dévorais; tes paroles étaient mon plaisir et la joie de mon coeur, car alors ton Nom reposait sur moi, Yahvé, Dieu Sabaot."
,"17":"Je ne m'asseyais pas dans le cercle des moqueurs pour m'y divertir. Lorsque ta main pesait sur moi, je me tenais à l'écart et tu me remplissais de ta colère."
,"18":"Pourquoi donc ma douleur est-elle continuelle, et ma blessure rebelle à toute guérison?,M'as-tu trompé, toi, ma source, et me laisses-tu soudain sans eau?"
,"19":"Alors Yahvé m'a dit: Si tu reviens, je te reprendrai à mon service; dégage le métal précieux de ses scories, si tu veux être ma bouche. Ils reviendront vers toi, mais tu ne reviendras pas à eux."
,"20":"Je ferai de toi un rempart de bronze face à ce peuple; ils te feront la guerre, mais ils ne l'emporteront pas, car je suis avec toi pour te sauver et te délivrer - parole de Yahvé."
,"21":"Je te délivrerai de la main des méchants, je te reprendrai aux violents."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Une parole de Yahvé me fut adressée:"
,"2":"Ne te cherche pas d'épouse; tu n'auras ni fils ni filles en ce lieu."
,"3":"Car voici la sentence de Yahvé pour les fils et les filles qui naissent en ce lieu, pour les mères qui leur donnent le jour et les pères qui les engendrent dans ce pays:"
,"4":"Ils connaîtront une mort tragique, on ne fera pas leur deuil et on ne les enterrera pas: ils resteront comme du fumier sur la face de la terre. Ils mourront par l'épée et la famine, et leurs cadavres serviront de nourriture aux oiseaux des cieux et aux bêtes de la terre."
,"5":"Car voici ce que dit Yahvé: N'entre pas dans la maison où l'on fait le deuil. Ne te lamente pas, ne pleure pas avec eux, car j'ai privé ce peuple de ma bénédiction, ma pitié et ma miséricorde - parole de Yahvé."
,"6":"Grands et petits, dans ce pays tous mourront. On ne les enterrera pas, on ne fera pas de lamentations sur eux, on ne se fera pas d'entailles sur le corps, ni de tonsure sur la tête."
,"7":"On ne prendra pas de repas pour les morts avec celui qui est en deuil, pour le consoler au sujet de son défunt. On ne lui donnera pas à boire la coupe de consolation pour son père ou sa mère."
,"8":"N'entre pas non plus dans la maison où l'on fait la fête, pour t'asseoir, manger et boire avec eux."
,"9":"Car voici ce que dit Yahvé Sabaot, le Dieu d'Israël: Sous vos yeux et de vos jours je ferai taire ici les cris de joie et de fête, le chant du fiancé et le chant de la fiancée."
,"10":"Lorsque tu diras tout cela à ce peuple, ils te demanderont certainement: 'Pourquoi Yahvé nous annonce-t-il cette grande catastrophe? Quelle est donc notre faute, comment avons-nous péché contre Yahvé notre Dieu?'"
,"11":"Alors tu leur répondras: Vos pères m'ont abandonné - parole de Yahvé. Ils se sont mis à la traîne d'autres dieux pour les servir et les adorer. Ils m'ont abandonné et n'ont pas gardé ma loi."
,"12":"Et vous, vous avez agi plus mal encore que vos pères; chacun de vous s'est obstiné à suivre ses mauvais penchants et a refusé de m'écouter."
,"13":"C'est pourquoi je vous chasserai loin de ce pays, vers une terre que ni vous ni vos pères ne connaissez. Là-bas vous pourrez servir jour et nuit d'autres dieux, car moi, je ne vous regarderai pas."
,"14":"Pourtant des jours viendront - parole de Yahvé- où l'on ne dira plus: 'Vive Yahvé qui a fait sortir les Israélites du pays d'Egypte!'"
,"15":"On dira alors: 'Vive Yahvé qui a fait revenir les Israélites du pays du nord et de tous les pays où il les avait chassés.' Car je les ramènerai au pays que j'ai donné à leurs pères.)"
,"16":"Voici que j'appelle de nombreux pêcheurs pour les pêcher - parole de Yahvé. Ensuite j'appellerai de nombreux chasseurs pour les chasser sur toutes les montagnes, toutes les collines et dans toutes les fentes des rochers."
,"17":"Car je surveille toutes leurs façons d'agir, rien n'est caché à mes yeux et aucune de leurs fautes ne m'échappe."
,"18":"Je leur rendrai le double pour leurs fautes et leurs péchés, car ils ont profané ma terre avec leurs cadavres d'idoles et ils ont rempli mon héritage de leurs ordures."
,"19":"O Yahvé, tu es ma forteresse et mon refuge, tu es mon abri aux jours de détresse. Les nations païennes viendront à toi du plus lointain du monde, et elle reconnaîtront: 'La culture de nos pères n'était que fausseté, stupidité et impuissance.'"
,"20":"Faut-il qu'un homme se fabrique des dieux? Alors ce ne sont pas des dieux, et je vais le leur faire savoir. Cette fois-ci je leur ferai connaître ma main et ma puissance, et ils sauront que mon nom est Yahvé!"
}`)
	CurrentBook.AddChapter(17, `{
"1":"Le péché de Juda est écrit avec un poinçon de fer, une pointe de diamant; il est gravé sur la tablette de leur coeur et sur les cornes de leurs autels."
,"2":"Leurs autels et leurs pieux sacrés le rappellent, sous les arbres verts des hautes collines,"
,"3":"et des buttes dans la plaine. Je vais effacer ton péché sur tout ton territoire: je distribuerai ta richesse et tous tes trésors."
,"4":"Tu devras céder l'héritage que je t'avais donné, je ferai de toi l'esclave de tes ennemis dans un pays que tu ne connais pas, car vous avez allumé le feu de ma colère et il ne s'arrêtera pas de brûler."
,"5":"Voici ce que dit Yahvé: Maudit soit l'homme qui met sa confiance dans un humain, qui fait d'un mortel son recours, et qui détourne son coeur de Yahvé."
,"6":"Il sera comme le chardon dans la Steppe: il s'est fixé dans des lieux arides, dans les terres de sel où nul n'habite; il ne verra jamais arriver le bonheur."
,"7":"Béni soit l'homme qui met sa confiance en Yahvé, et dont Yahvé est le recours."
,"8":"Il est comme l'arbre planté au bord des eaux, qui allonge ses racines vers le ruisseau. Il ne craint pas lorsque vient la chaleur, son feuillage reste vert. Il ne craint pas les années sèches,et porte toujours du fruit."
,"9":"Plus que tout le coeur est complexe, il est mauvais: qui peut le comprendre?"
,"10":"Moi, Yahvé, je sonde les coeurs, je mets à jour le fond du désir: je rends à chacun selon sa conduite, et je lui donne le fruit de ses actes."
,"11":"Celui qui amasse des richesses injustes,est comme la perdrix couvant l'oeuf qu'elle n'a pas pondu; au milieu de ses jours la richesse l'abandonne, et à la fin il n'est qu'un sot."
,"12":"Notre Sanctuaire est un trône élevé, glorieux;"
,"13":"Yahvé, tu es l'espoir d'Israël, quiconque t'abandonne sera confondu. Ceux qui se rebellent contre toi disparaîtront du pays, car ils ont abandonné la source d'eau vive."
,"14":"Guéris-moi, Yahvé, que je sois guéri, sauve-moi, que je sois sauvé: c'est vers toi toujours qu'est allée ma louange."
,"15":"Voici qu'on me dit: 'Encore une parole de Yahvé? Qu'elle se réalise donc!'"
,"16":"Mais je ne te presse pas de faire venir le mal, je n'ai pas désiré les jours mauvais, tu le sais, tout ce que j'ai pu dire est clair pour toi."
,"17":"Ne me fais pas tomber dans l'épouvante, toi, mon refuge au jour du malheur."
,"18":"Que ceux qui me persécutent soient confondus, et que moi, je ne sois pas confondu! Qu'ils soient effrayés, et que moi je ne sois pas effrayé. Fais venir sur eux le jour du malheur, frappe-les, oui, frappe-les bien!"
,"19":"Une parole de Yahvé me fut adressée: Va et tiens-toi à la Porte-des-Fils-du-Peuple, par laquelle les rois de Juda entrent et sortent. Tu iras aussi aux autres portes de Jérusalem"
,"20":"et tu leur diras ceci: Ecoutez la parole de Yahvé, rois de Juda, et vous tous gens de Juda qui habitez Jérusalem et qui passez par ces portes!"
,"21":"Voici ce que Yahvé a dit: Ne faites pas votre malheur, ne transportez pas de fardeaux le jour du sabbat, ne les faites pas entrer par les portes de Jérusalem."
,"22":"Ne sortez pas de vos maisons avec un fardeau le jour du sabbat, ne faites aucun travail. Sanctifiez le jour du sabbat comme je l'ai commandé à vos pères."
,"23":"Eux n'ont pas écouté, ils n'en ont pas tenu compte, mais ils ont fait la forte tête; ils n'ont pas entendu et n'ont pas accepté mes avertissements."
,"24":"Mais si vous m'écoutez - parole de Yahvé - si vous ne faites entrer aucun fardeau par les portes de cette ville le jour du sabbat, si vous sanctifiez le jour du sabbat en ne faisant aucun travail,"
,"25":"alors les portes de cette ville continueront de voir passer des rois successeurs de David. Ils entreront avec leurs chars et leurs chevaux, eux et leurs princes, tout comme les gens de Juda et les habitants de Jérusalem, et cette ville sera toujours habitée."
,"26":"On viendra des villes de Juda et des environs de Jérusalem, du pays de Benjamin et du Bas-Pays, de la montagne et du Négueb, pour offrir des holocaustes et des sacrifices, pour présenter des offrandes et de l'encens, pour offrir des actions de grâce dans le Temple de Yahvé."
,"27":"Mais si vous ne m'écoutez pas, si vous ne sanctifiez pas le jour du sabbat, si vous portez des fardeaux et que vous passez avec par les portes de Jérusalem le jour du sabbat, alors je mettrai le feu à ces portes, il dévorera les palais de Jérusalem et ne s'éteindra plus."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Voici une parole de Yahvé qui fut adressée à Jérémie:"
,"2":"'Lève-toi et descends à la maison du potier; là je te ferai entendre ma parole.'"
,"3":"Je descendis donc à la maison du potier pendant qu'il travaillait à son tour."
,"4":"Le pot qu'il façonnait finit par se perdre, comme cela arrive pour l'argile dans la main du potier; il recommença donc et fit un autre pot à son idée."
,"5":"Alors cette parole de Yahvé me fut adressée:"
,"6":"'Ne suis-je pas capable d'agir envers vous, maison d'Israël, comme ce potier? Vous êtes dans ma main comme l'argile dans la main du potier, maison d'Israël."
,"7":"Tantôt je parle à propos d'une nation ou d'un royaume, et je menace d'arracher, de renverser et de faire périr."
,"8":"Mais si cette nation revient sur sa mauvaise conduite que je dénonçais, je me repens du mal que je songeais à lui faire."
,"9":"D'autres fois, parlant d'une nation ou d'un royaume, je promets de bâtir et de planter."
,"10":"Mais voici qu'elle fait ce que je considère mauvais et elle ne m'écoute pas. Alors je me repens du bien que je voulais lui faire."
,"11":"Maintenant donc, va dire aux gens de Juda et aux habitants de Jérusalem: Je prépare un malheur contre vous, je dresse des plans contre vous; que chacun de vous se détourne de sa mauvaise conduite, changez votre façon de vivre et de faire.'"
,"12":"Mais eux m'ont répondu: 'Ce n'est pas la peine, nous n'en ferons qu'à notre tête.' Tous se laissent conduire par leurs mauvais penchants."
,"13":"C'est pourquoi Yahvé dit ceci: 'Allez vous informer chez les païens: qui a jamais entendu chose pareille? La vierge d'Israël a commis une chose horrible."
,"14":"A-t-on vu la neige du Liban abandonner les hauts sommets? A-t-on vu un fleuve puissant aux eaux fraîches et abondantes rester à sec?"
,"15":"Or mon peuple m'a oublié, il a offert de l'encens à ce qui n'est que du vent; on les a fait dévier de leur chemin, de leurs anciennes pratiques, et ils ont pris des chemins impossibles, des routes impraticables."
,"16":"Leur pays va donc devenir une désolation que personne n'oubliera et dont se moqueront tous ceux qui y passeront."
,"17":"Je les disperserai devant l'ennemi comme fait le vent d'orient. Je leur montrerai mon dos, et non mon visage, au jour de leur malheur."
,"18":"Ils ont dit: 'Venez, montons un complot contre Jérémie. Il y aura encore des prêtres pour nous donner la Loi, des sages pour nous conseiller, des prophètes pour dire les paroles de Dieu. Venez donc, faisons bien attention à ce qu'il dit, et nous attaquerons ses discours.'"
,"19":"Yahvé, donne-moi ton attention, entends ma plainte!"
,"20":"Est-ce qu'on doit rendre le mal pour le bien?,Voici qu'ils m'ont creusé une fosse. Souviens-toi que je me tenais devant toi,pour te parler en leur faveur, et détourner d'eux ta colère."
,"21":"Maintenant, livre leurs enfants à la famine, abandonne-les au tranchant de l'épée!,Que leurs femmes perdent enfants et mari, que les hommes meurent de la peste, que leurs garçons soient frappés par l'épée au combat."
,"22":"Qu'on entende des cris sortir de leurs maisons,parce que soudain tu leur amènes les pillards!,Car ils ont creusé un piège pour me prendre, ils ont caché des filets sous mes pas."
,"23":"Tu le sais, Yahvé, ce qu'ils veulent, c'est ma mort: ne pardonne pas leurs fautes, n'efface pas leurs péchés de devant toi. Tu sauras les jeter sur le sol, tu leur donneras les fruits de ta colère."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Une parole de Yahvé me fut adressée: Va, achète une cruche chez le potier et réunis les Anciens du peuple et les Anciens des prêtres."
,"2":"Tu sortiras vers la vallée de Ben-Hinnom, à l'entrée de la Porte-des-Potiers; là tu prononceras les paroles que je te dirai."
,"3":"Tu leur diras: 'Ecoutez la parole de Yahvé, roi de Juda et vous tous qui habitez Jérusalem! Voici ce qu'a dit Yahvé Sabaot, le Dieu d'Israël: Je vais faire venir sur ce lieu un malheur si grand que les oreilles tinteront à celui qui l'apprendra."
,"4":"Ils m'ont abandonné, ils ont profané ce lieu, ils y ont encensé des dieux étrangers que ni eux ni leurs pères, ni les rois de Juda, n'avaient connus, et ils ont rempli ce lieu du sang des innocents."
,"5":"Ils ont construit des hauts-lieux pour Baal, pour y brûler leurs fils par le feu, en holocauste à Baal; c'est une chose que je n'avais pas commandée, dont je n'avais jamais parlé, qui ne m'était même pas venue à l'esprit."
,"6":"C'est pourquoi, voici que viennent des jours - parole de Yahvé - où ce lieu ne sera plus appelé le Tophet ou la vallée de Ben-Hinnom, mais la vallée du massacre."
,"7":"En ce lieu j'anéantirai les espoirs de Juda et Jérusalem, je les ferai tomber sous l'épée de leurs ennemis, je les livrerai à ceux qui en veulent à leur vie, et leurs cadavres seront la pâture des oiseaux du ciel et des bêtes de la terre."
,"8":"Je ferai de cette ville une ruine et un sujet de moqueries; celui qui passera par là en sera stupéfait et poussera un cri devant une telle catastrophe."
,"9":"Je leur ferai manger la chair de leurs fils et de leurs filles: leurs ennemis, ceux qui en veulent à leur vie, les réduiront à une telle misère, à une telle détresse, qu'ils se dévoreront entre eux.'"
,"10":"Alors, sous les yeux de ceux qui seront venus là avec toi, tu briseras cette cruche."
,"11":"Tu leur diras: 'Voici ce que dit Yahvé Sabaot: Je vais briser ce peuple et cette ville comme on brise un pot de poterie, au point qu'on ne pourra pas le réparer.'"
,"12":"Voilà ce que je ferai de ce lieu et de ses habitants, je rendrai cette ville comme Tophet - parole de Yahvé."
,"13":"Les maisons de Jérusalem, les palais des rois de Juda, deviendront aussi impurs que le lieu de Tophet. Car sur les toits de toutes ces maisons on a fait fumer l'encens en l'honneur de l'armée des cieux et l'on a versé des libations aux dieux étrangers."
,"14":"Jérémie revint de Tophet où Yahvé l'avait envoyé pour prophétiser. Comme il était dans la cour du Temple de Yahvé, il dit à tout le peuple:"
,"15":"Voici ce que dit Yahvé Sabaot, le Dieu d'Israël: 'Je vais faire venir sur cette ville et sur ses environs, les malheurs dont je les menaçais; vous savez qu'ils se sont endurcis et n'ont pas écouté mes paroles.'"
}`)
	CurrentBook.AddChapter(20, `{
"1":"Le prêtre Pachéhour, fils d'Immer, qui était le chef des gardes de la Maison de Yahvé, entendit Jérémie qui prophétisait de la sorte."
,"2":"Pachéhour frappa le prophète Jérémie et le fit enchaîner à la Porte-Haute de Benjamin qui donne sur la Maison de Yahvé."
,"3":"Le lendemain, Pachéhour fit délier Jérémie de ses chaînes. Alors Jérémie lui dit: 'Maintenant Yahvé ne t'appelle plus Pachéhour, mais 'Terreur'."
,"4":"Car voici ce que dit Yahvé: Je vais te livrer à la terreur, toi et tous tes amis, ils tomberont sous l'épée de leurs ennemis et tes yeux le verront! Je livrerai de même Juda tout entier aux mains du roi de Babylone pour qu'il déporte les hommes à Babylone ou qu'il les frappe par l'épée."
,"5":"Je livrerai toutes les richesses de cette ville à leurs ennemis, toutes ses provisions, tous les trésors des rois de Juda; ils les pilleront et les ramasseront pour les emporter à Babylone."
,"6":"Quant à toi, Pachéhour, tu partiras en captivité à Babylone avec tous les gens de ta maison. C'est là que tu mourras et que tu seras enterré avec tous tes amis à qui tu as prophétisé le mensonge.'"
,"7":"Yahvé, tu m'as séduit et je me suis laissé séduire. Tu m'as fait violence et tu as gagné. Tout le jour je suis celui dont on rit; tous se moquent de moi!"
,"8":"Je ne parle que pour dire: 'Violence!',pour crier: 'Dévastation!',La parole de Yahvé est pour moi chaque jour, source d'humiliation et de moquerie."
,"9":"Je me suis dit: 'Je ne penserai plus à lui, je ne parlerai plus en son nom!',Mais c'était en moi comme un feu, qui brûlait et dévorait mes os: j'essayais de le contenir, mais je ne pouvais pas."
,"10":"Je les entendais tout autour de moi: 'Dénoncez-le, oui, dénonçons-le!',Même mes proches guettaient ma chute: 'Au premier faux pas nous aurons le dessus, alors nous nous vengerons de lui!'"
,"11":"Mais Yahvé est avec moi comme un guerrier puissant, c'est pourquoi mes ennemis tomberont: pour eux ce ne sera pas le triomphe, mais l'échec et la honte. Leur humiliation sera définitive, personne jamais ne l'oubliera."
,"12":"Yahvé Sabaot, toi qui examines avec justice, toi qui sondes les reins et les coeurs, prends ta revanche, je voudrais la voir, car c'est à toi que j'ai confié ma cause."
,"13":"Chantez Yahvé, célébrez-le: il a repris la vie du pauvre de la main des méchants!"
,"14":"Maudit soit le jour où je suis né, où ma mère me mit au monde: que nul ne le bénisse!"
,"15":"Maudit soit celui qui en avisa mon père, qui le combla de joie en lui disant: 'C'est un garçon que tu as!'"
,"16":"Que cet homme ait le sort des villes,où Yahvé déversa sans pitié sa colère!,Qu'il entende au matin les cris d'alarme, et à midi encore les appels de trompette,"
,"17":"pour ne m'avoir pas tué dès le sein. Ma mère aurait été mon tombeau, je serais resté dans son sein pour toujours."
,"18":"Pourquoi en suis-je sorti, si je ne dois connaître que peines et tourments, et finir mes jours dans l'humiliation?"
}`)
	CurrentBook.AddChapter(21, `{
"1":"Voici la parole que Jérémie reçut de Yahvé lorsque le roi Sédécias lui envoya Pachéhour, fils de Malkiya, et le prêtre Séfanya, fils de Maaséya. Ils dirent à Jérémie: "
,"2":"'Consulte Yahvé pour nous à propos de la guerre que nous fait Nabukodonozor, roi de Babylone. Peut-être Yahvé fera-t-il encore pour nous un de ses miracles pour l'éloigner de nous.'"
,"3":"Jérémie leur répondit: 'Voici ce que vous direz à Sédécias:"
,"4":"Ainsi parle Yahvé: Je ramènerai en arrière les armes de guerre avec lesquelles vous combattez les Kaldéens qui assiègent vos remparts, et elles resteront empilées au milieu de cette ville."
,"5":"Moi-même je combattrai contre vous, de toute la puissance de ma main et de mon bras, avec la violence de ma colère et de ma fureur."
,"6":"Je frapperai dans cette ville les hommes et les bêtes; ils mourront d'une terrible peste."
,"7":"Après cela - parole de Yahvé - je livrerai Sédécias, roi de Juda, à Nabukodonozor, roi de Babylone, avec ses serviteurs, le peuple et tous ceux qui dans cette ville auront échappé à la peste, à l'épée et à la famine. Je les livrerai aux mains de leurs ennemis qui en veulent à leur vie. Lui sera pour eux sans égards, sans pitié, sans pardon: il les passera au fil de l'épée.'"
,"8":"Tu diras encore à ce peuple: 'Voici ce que dit Yahvé: C'est maintenant que je vous donne à choisir entre le chemin de la vie et le chemin de la mort."
,"9":"Celui qui restera dans cette ville périra par l'épée, la famine et la peste; celui qui en sortira pour se rendre aux Kaldéens qui vous assiègent, vivra; il aura au moins sauvé sa vie."
,"10":"Car je me suis penché sur cette ville pour son malheur et non pour son bonheur - parole de Yahvé. Elle sera livrée au roi de Babylone et il y mettra le feu.'"
,"11":"Tu diras ceci aux magistrats du roi de Juda: Ecoutez la parole de Yahvé,"
,"12":"serviteurs de la dynastie de David. Voici ce que dit Yahvé: Rendez la justice correctement tous les jours, et délivrez celui qu'on opprime des mains de l'oppresseur. Sinon ma colère prendra comme un feu; elle brûlera et personne n'éteindra."
,"13":"Je viens te visiter, toi qui domines la vallée comme un rocher dans la plaine - parole de Yahvé. Vous dites: 'Qui fera une descente chez nous, qui entrera dans nos repaires?'"
,"14":"Je viens vous réclamer des comptes - parole de Yahvé. Je mettrai le feu à la forêt, et il dévorera tout ce qui est autour."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Une parole de Yahvé me fut adressée: Descends au palais du roi de Juda, et là tu prononceras cette parole."
,"2":"Tu diras: Ecoute la parole de Yahvé, roi de Juda, toi qui sièges sur le trône de David. Toi, tes serviteurs et ton peuple qui passez par ces portes, écoutez!"
,"3":"Voici ce que dit Yahvé: Pratiquez le droit et la justice, libérez celui qui est opprimé de la main de l'oppresseur! Ne faites pas violence, n'exploitez pas l'étranger, l'orphelin et la veuve; ne répandez pas en ce lieu le sang innocent."
,"4":"Si vous faites cela, des rois successeurs de David entreront par les portes de ce palais avec chars et chevaux, avec leurs serviteurs et leur peuple."
,"5":"Mais si vous n'écoutez pas ces paroles, je le jure par moi-même - parole de Yahvé - ce palais sera ruiné."
,"6":"Car voici ce que dit Yahvé à propos de la maison de Juda: J'aimais te voir élevée, comme le pays de Galaad, comme le sommet du Liban. Mais je le jure, je vais faire de toi un désert, une ville sans habitants."
,"7":"J'envoie contre toi des destructeurs, chacun avec ses outils; ils couperont tes plus beaux cèdres et les jetteront au feu."
,"8":"Quand les gens de toute nation passeront par cette ville, ils se diront l'un à l'autre: 'Pourquoi Yahvé a-t-il traité ainsi cette grande ville?'."
,"9":"On répondra: 'C'est parce qu'ils ont abandonné l'Alliance de Yahvé leur Dieu et qu'ils se sont prosternés devant d'autres dieux pour les servir.'"
,"10":"Ne pleurez pas celui qui est mort, ne vous lamentez pas sur lui; pleurez, pleurez plutôt celui qui est parti et qui ne reviendra plus, car il ne reverra pas le pays où il est né!"
,"11":"Voici en effet ce que dit Yahvé à propos de Challoum, fils de Josias, roi de Juda, qui a régné à la place de son père et a dû quitter ce lieu: 'Il n'y reviendra pas'."
,"12":"Il mourra là où on l'a emmené prisonnier, il ne reverra jamais ce pays!"
,"13":"Malheur à celui qui construit son palais de façon malhonnête, et se fait des terrasses en ne respectant pas les droits! Malheur à celui qui fait travailler son prochain pour rien, sans lui verser le prix de son travail!"
,"14":"Il se dit: 'Je vais construire un palais grandiose avec de belles terrasses'. Il y perce des fenêtres, il le couvre d'un plafond de cèdre et le décore de peintures..."
,"15":"Crois-tu qu'il faille tant de cèdre pour être roi? Ton père n'a-t-il pas eu à manger et à boire? Et tout allait bien pour lui! Mais il pratiquait le droit et la justice,"
,"16":"il jugeait la cause du pauvre et du petit. N'est-ce pas cela me connaître? - parole de Yahvé."
,"17":"Mais tu ne vois et ne connais que ton propre intérêt, tu répands le sang innocent et tu maintiens l'oppression et la violence."
,"18":"C'est pourquoi voici ce que dit Yahvé au sujet de Joïaqim fils de Josias, roi de Juda: On ne dira pas sur lui la lamentation: Hélas mon frère, hélas ma soeur! On ne dira pas sur lui la lamentation: Hélas mon seigneur, hélas majesté!"
,"19":"Mais il sera enterré comme on enterre un âne: traîné dehors et jeté au-delà des portes de Jérusalem."
,"20":"Monte sur le Liban et crie, fais entendre ta voix dans le Bashan, pousse des cris du haut des Abarim, car tous tes amants ont été écrasés."
,"21":"Je t'ai parlé quand tout allait bien mais tu as répondu: Je n'écouterai pas. C'est ainsi que tu t'es comportée depuis ta jeunesse; tu n'as pas écouté ma voix."
,"22":"Tu as tes bergers? Le vent les enverra paître; tes amants partiront en captivité. Ta mauvaise conduite ne te rapportera que la honte et le mépris."
,"23":"Toi qui habites le Liban et qui places ton repaire au milieu des cèdres, tu gémiras lorsque les douleurs viendront sur toi, une angoisse comme celle d'une femme qui accouche."
,"24":"Je suis vivant! - parole de Yahvé. Même si Jékonias fils de Joïaqim, roi de Juda, était un anneau à ma main droite, je l'en retirerais."
,"25":"Voici que je te livre à ceux qui en veulent à ta vie et qui te font trembler."
,"26":"Toi et ta mère qui t'a mis au monde, je vous jette dans un autre pays où vous n'êtes pas nés, et c'est là que vous mourrez."
,"27":"Ils ne reviendront pas au pays auquel ils ne cessaient de penser."
,"28":"Jékonias est-il donc un objet usé et cassé, un vase dont personne ne veut plus? Pourquoi ont-ils été enlevés, lui et sa race, et jetés sur une terre qu'ils ne connaissaient pas?"
,"29":"Terre, terre, terre, écoute la parole de Yahvé:"
,"30":"Inscrivez cet homme au nombre des sans-enfants: pas un de sa race ne réussira à remonter sur le trône de David, pour régner encore sur Juda."
}`)
	CurrentBook.AddChapter(23, `{
"1":"Malheur aux bergers qui perdent et dispersent les brebis de mon pâturage!"
,"2":"Voici une parole de Yahvé, le Dieu d'Israël, pour les pasteurs qui font paître mon peuple: Vous avez dispersé mes brebis, vous les avez chassées, vous ne vous en êtes pas occupés. C'est pourquoi maintenant je m'occupe de vous et de vos méfaits. "
,"3":"Je vais rassembler le reste de mes brebis de tous les pays où je les ai chassées, et je les ramènerai dans leurs pâturages; là elles se développeront et se multiplieront."
,"4":"Je choisirai pour elles des bergers qui les feront paître; elles n'auront plus ni peur ni crainte, aucune ne se perdra - parole de Yahvé."
,"5":"Voici venir des jours - parole de Yahvé, où je ferai sortir de David un germe juste. Un roi gouvernera avec sagesse, il établira dans le pays la justice et la droiture."
,"6":"En ces jours Juda sera sauvé, Israël trouvera la paix; voici le nom qu'on lui donnera: Yahvé-notre-Justice."
,"7":"C'est pourquoi, voici venir des jours - parole de Yahvé - où l'on ne dira plus: Vive Yahvé qui a fait sortir les Israélites du pays d'Egypte!"
,"8":"Mais on dira: Vive Yahvé qui a fait revenir les enfants d'Israël du pays du nord et de tous les pays où il les avait chassés, et qui les a réinstallés sur leurs terres!"
,"9":"Pour les prophètes. Mon coeur se brise au-dedans de moi, tous mes os frémissent: Yahvé et ses paroles saintes m'ont laissé comme un homme ivre, terrassé par le vin."
,"10":"Car le pays est rempli d'adultères; le pays est en deuil et la malédiction a grillé les pâturages du désert. Les gens courent après le mal, ils dépensent leurs forces pour l'injustice."
,"11":"Même le prophète et le prêtre se sont corrompus; j'ai trouvé le mal jusque dans mon Temple - parole de Yahvé."
,"12":"C'est pourquoi leur chemin va se terminer en glissades dans l'obscurité; ils se heurteront et ils iront à terre quand viendra l'année du châtiment et que j'amènerai sur eux le malheur."
,"13":"Chez les prophètes de Samarie j'ai trouvé la stupidité; ils égaraient mon peuple Israël avec leurs prophéties au nom de Baal."
,"14":"Chez les prophètes de Jérusalem j'ai trouvé des horreurs: l'adultère, l'entêtement dans le mensonge. Ils soutiennent si bien les malfaiteurs, qu'aucun d'eux ne renonce à ses méfaits. Ils sont tous pour moi comme Sodome; quant aux habitants, c'est Gomorrhe."
,"15":"En conséquence, voici ce que dit Yahvé Sabaot pour les prophètes: Je vais leur faire mâcher de l'absinthe, je leur ferai boire des eaux empoisonnées, car la perversité a gagné tout le pays à partir des prophètes de Jérusalem."
,"16":"Yahvé Sabaot dit encore: N'écoutez pas les paroles des prophètes qui prophétisent pour vous; ils vous trompent. Ils vous disent ce qui sort de leur imagination et non pas de la bouche de Yahvé."
,"17":"A ceux qui me méprisent, ils disent: 'Tout ira bien, parole de Yahvé!' Et à ceux qui n'en font qu'à leur tête ils disent: 'Il ne vous arrivera rien de mal!'"
,"18":"Mais qui donc a assisté aux conseils de Yahvé pour connaître et entendre sa parole? Qui a cherché à entendre sa parole pour la redire?"
,"19":"Voici qu'éclate la tempête de Yahvé: un ouragan tourbillonne et fond sur la tête des méchants."
,"20":"Yahvé ne reviendra pas de sa colère avant d'avoir fait, d'avoir mené à bien son projet. Après cela, dans le futur, vous en aurez pleine connaissance."
,"21":"Je n'ai pas envoyé ces prophètes, mais ils courent; je ne leur ai pas parlé, mais ils prophétisent."
,"22":"S'ils avaient assisté à mon conseil, ils auraient fait entendre mes paroles à mon peuple; ils l'auraient fait revenir de sa mauvaise conduite et de ses actions méchantes."
,"23":"Suis-je un Dieu seulement de près? Ne suis-je pas Dieu aussi de loin?"
,"24":"Un homme peut-il se cacher dans ses cachettes sans que je le voie? Est-ce que je n'occupe pas tout l'espace du ciel et de la terre - parole de Yahvé."
,"25":"J'ai entendu ces prophètes qui font en mon nom de fausses prophéties. Ils disent: 'J'ai eu un songe!'"
,"26":"Combien de temps encore y aura-t-il chez les prophètes, des prophètes à fausses prophéties, qui racontent leurs inventions?"
,"27":"Avec les songes qu'ils se repassent l'un à l'autre, ils en arriveront à faire oublier mon nom à mon peuple, comme leurs pères qui ont oublié mon nom pour celui de Baal."
,"28":"Le prophète qui a un songe ne raconte qu'un songe; mais celui qui a reçu ma parole, dit ma parole de vérité. Qu'y a-t-il de commun entre la paille et le blé - parole de Yahvé?"
,"29":"Ma parole est comme le feu, comme le marteau qui brise le roc."
,"30":"C'est pourquoi - parole de Yahvé - je me lève contre les prophètes qui se volent mes paroles l'un à l'autre."
,"31":"Je m'en prends aux prophètes qui n'ont qu'à remuer la langue pour faire une prophétie."
,"32":"Je m'en prends aux prophètes à songes creux, qui les racontent et qui égarent mon peuple avec leurs mensonges et leurs sottises. Je ne les ai pas envoyés, je ne leur ai rien demandé, et ils n'aident en rien ce peuple."
,"33":"Lorsque ce peuple, ou un prophète, ou un prêtre, te demandera: 'Quel est le fardeau de Yahvé?' Tu répondras: 'C'est vous le fardeau dont je vais me débarrasser - parole de Yahvé!'"
,"34":"Et si un prophète, un prêtre ou un homme du peuple dit: 'Fardeau de Yahvé', je punirai l'homme et sa famille."
,"35":"Voici comment vous parlerez entre vous, entre compagnons: 'Qu'a répondu Yahvé, qu'a dit Yahvé?'"
,"36":"Mais ne répétez pas l'expression: 'Fardeau de Yahvé' car elle pourrait devenir pesante pour celui qui l'emploie. (Car vous déformez les paroles du Dieu vivant, Yahvé Sabaot, notre Dieu.)"
,"37":"Voici ce que tu diras au prophète: 'Que t'a répondu Yahvé, qu'a dit Yahvé?'"
,"38":"Sinon Yahvé vous dira ceci: Puisque vous prononcez ce mot 'Fardeau de Yahvé' alors que je vous ai fait dire de ne plus le prononcer,"
,"39":"je vous oublierai complètement et je vous rejetterai loin de moi, vous et la ville que j'avais donnée à vous et à vos pères."
,"40":"Je ferai venir sur vous une humiliation qui restera, une honte que jamais l'on n'oubliera."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Yahvé me montra deux paniers de figues placés devant son Temple. C'était au moment où Nabukodonozor, roi de Babylone, venait de déporter Jékonias fils de Joïaqim, roi de Juda, les chefs de Juda, les forgerons et les serruriers; il les avait déportés de Jérusalem à Babylone."
,"2":"Dans une corbeille il y avait des figues excellentes comme le sont les premières figues; dans l'autre, des figues pourries, si pourries qu'elles en étaient immangeables."
,"3":"Yahvé me dit alors: 'Que vois-tu Jérémie?' Je répondis: 'Des figues. Les bonnes sont excellentes, mais les mauvaises sont pourries, si pourries qu'elles sont immangeables!'"
,"4":"Alors une parole de Yahvé me fut adressée:"
,"5":"Voici ce que dit Yahvé, le Dieu d'Israël: Comme on prend plaisir aux bonnes figues, je m'intéresserai aux déportés de Juda que j'ai envoyés de ce lieu au pays des Kaldéens."
,"6":"Je veillerai sur eux avec bonté, je les ferai revenir dans ce pays; je les reconstruirai au lieu de les démolir, je les planterai au lieu de les arracher."
,"7":"Je leur donnerai un coeur capable de me connaître, moi Yahvé; ils seront mon peuple, et moi je serai leur Dieu, car ils reviendront à moi de tout leur coeur."
,"8":"Mais ce qu'on fait avec les mauvaises figues, si pourries qu'elles sont immangeables, je le ferai avec Sédécias roi de Juda, ses chefs et le reste de Jérusalem, aussi bien ceux qui sont restés dans ce pays que ceux qui se sont installés au pays d'Egypte."
,"9":"J'en ferai un objet d'horreur, une honte aux yeux de tous les royaumes de la terre; on rira et on se moquera d'eux, on les donnera en exemple, eux et leur malédiction, dans tous les lieux où je les chasserai."
,"10":"Je leur enverrai l'épée, la famine et la peste, jusqu'à ce qu'ils disparaissent du pays que je leur avais donné, à eux et à leurs pères."
}`)
	CurrentBook.AddChapter(25, `{
"1":"Voici la parole qui fut adressée à Jérémie en la quatrième année de Joïaqim fils de Josias, roi de Juda; on était dans la première année de Nabukodonozor roi de Babylone."
,"2":"Le prophète Jérémie prononça ces paroles devant le peuple de Juda et les habitants de Jérusalem."
,"3":"Depuis la treizième année de Josias fils d'Amon, roi de Juda, et jusqu'à ce jour, soit pendant vingt trois ans, la parole de Yahvé m'a été adressée; je vous l'ai dite sans me lasser, mais vous n'avez pas écouté."
,"4":"(Yahvé aussi, sans se lasser, vous a envoyé ses serviteurs les prophètes, mais vous n'avez pas écouté, vous n'avez pas prêté l'oreille pour entendre.)"
,"5":"Voici ce qu'était cette parole: 'Que chacun revienne de sa mauvaise conduite et de ses actions mauvaises; alors vous habiterez sur la terre que Yahvé vous a donnée, à vous et à vos pères, depuis toujours et pour toujours."
,"6":"Mais ne suivez pas d'autres dieux, ne les servez pas, ne vous prosternez pas devant eux; ne me mettez pas en colère avec ces choses qui sont sorties de vos mains, et moi, je ne vous ferai pas de mal."
,"7":"Mais vous ne m'avez pas écouté - parole de Yahvé. Vous m'avez irrité pour votre malheur avec ces choses sorties de vos mains."
,"8":"C'est pourquoi, voici ce qu'a dit Yahvé Sabaot: Parce que vous n'avez pas écouté mes paroles,"
,"9":"j'envoie chercher un peuple du nord. Je le fais venir contre ce pays et ses habitants, et je leur jette la malédiction, et pour toujours ce sera la désolation, ce seront des ruines, juste de quoi se moquer."
,"10":"Je ferai disparaître de chez eux le bruit des fêtes et de la joie, la voix de l'époux et de l'épouse, le bruit de la meule et la lumière de la lampe."
,"11":"Tout ce pays ne sera plus que ruines et désolation, et ils seront esclaves parmi les nations pour soixante-dix ans."
,"12":"Mais quand s'achèveront ces soixante-dix années, je demanderai des comptes à la nation des Kaldéens et j'en ferai une ruine éternelle."
,"13":"Ainsi j'accomplirai contre ce pays toutes les paroles que j'ai prononcées contre lui, tout ce qui est écrit dans ce livre, tout ce que Jérémie a prophétisé sur toutes les nations."
,"14":"Car de grandes nations, avec de grands rois, les soumettront à leur tour, et je leur rendrai selon leurs actes, selon l'oeuvre de leurs mains."
,"15":"Voici ce que Yahvé, Dieu d'Israël, me dit: Reçois de ma main cette coupe de vin, cette coupe de ma colère, et fais la boire à toutes les nations vers lesquelles je t'enverrai."
,"16":"Quand elles auront bu, elles trébucheront et seront prises de vertige ()."
,"17":"Alors je pris la coupe de la main de Yahvé et je la fis boire à toutes les nations vers lesquelles Yahvé m'envoyait:"
,"18":"(à Jérusalem et aux villes de Juda, comme à ses rois et à ses chefs, pour qu'elles deviennent une solitude, une ruine, un objet de moquerie.)"
,"19":"Je la fis boire à Pharaon, roi d'Egypte, à ses serviteurs, à ses chefs et à tout son peuple,"
,"20":"et à tous les gens de l'ouest. Puis je la passai () aux rois du pays des Philistins, Ashkélon, Gaza, Akaron, et ce qui reste encore d'Ashdod."
,"21":"Puis à Edom, Moab et les fils d'Ammon,"
,"22":"les rois de Tyr, les rois de Sidon, les rois des îles qui sont au-delà de la mer,"
,"23":"Dedan, Tema, Bouz, tous les hommes aux tempes rasées,"
,"24":"() qui habitent le désert."
,"25":"Puis je la fis boire aux rois de Zimri, les rois d'Elam et de Médie,"
,"26":"les rois du nord, proches ou lointains, l'un après l'autre, et tous les royaumes de la terre ()."
,"27":"Tu leur diras: 'Voici ce que dit Yahvé Sabaot, le Dieu d'Israël: Buvez, enivrez-vous, vomissez, tombez et ne vous relevez plus quand vous verrez l'épée que j'envoie contre vous.'"
,"28":"Et s'ils refusent de prendre de ta main cette coupe à boire, tu leur diras: C'est un ordre de Yahvé Sabaot: vous devez boire!"
,"29":"Si j'ai fait venir le malheur d'abord sur la ville que protège mon Nom, croyez-vous que vous, vous serez épargnés? Certainement pas, vous ne serez pas épargnés, car moi-même j'appelle l'épée contre tous les habitants de la terre."
,"30":"Tu leur annonceras toutes ces paroles et tu leur diras: Yahvé a rugi, du haut de sa sainte Demeure il fait entendre sa voix. Il pousse un rugissement contre son héritage et contre tous les habitants de la terre. Il pousse des cris comme ceux qui piétinent le raisin,"
,"31":"le bruit en est arrivé jusqu'aux extrémités de la terre. Yahvé est en procès avec les nations, il entre en jugement avec tout homme, il livre les méchants à l'épée - parole de Yahvé."
,"32":"Voici ce que dit Yahvé Sabaot: Regardez, le malheur gagne de nation en nation, un ouragan terrible s'est levé, qui nous vient des extrémités de la terre."
,"33":"Les victimes de Yahvé tomberont ce jour-là, d'un bout à l'autre de la terre; on ne les ramassera pas, on ne les enterrera pas; elles resteront comme du fumier sur le sol."
,"34":"Pasteurs, lamentez-vous et criez! Roulez-vous par terre, maîtres du troupeau! Car c'est votre tour d'aller à la boucherie et de tomber comme les bêtes les plus belles."
,"35":"Il n'y a pas d'échappatoire pour les pasteurs, pas de fuite possible pour les maîtres du troupeau."
,"36":"Les pasteurs poussent des cris, les maîtres du troupeau se lamentent, car Yahvé a ravagé leurs prairies"
,"37":"et le silence est tombé sur les paisibles pâturages."
,"38":"Le lion est sorti de son repaire et leur pays n'est plus que ruines sous le feu du châtiment."
}`)
	CurrentBook.AddChapter(26, `{
"1":"Voici la parole qui vint de Yahvé au commencement du règne de Joïaqim fils de Josias, roi de Juda."
,"2":"Voici ce que dit Yahvé: Tiens-toi dans la cour de la Maison de Yahvé, là tu prononceras toutes les paroles que je t'ai commandé de dire aux habitants des villes de Juda qui viennent pour adorer dans la Maison de Yahvé. Tu ne retrancheras pas un mot."
,"3":"Peut-être écouteront-ils et chacun d'eux renoncera à sa mauvaise conduite; alors je me repentirai du mal que j'ai décidé de leur faire à cause de leurs actions mauvaises."
,"4":"Tu leur diras: Voici ce que dit Yahvé: Si vous ne m'écoutez pas, si vous ne marchez pas selon la Loi que j'ai placée devant vous,"
,"5":"si vous n'écoutez pas les paroles de mes serviteurs les prophètes que je vous ai envoyés sans me lasser et que vous n'avez pas écoutés,"
,"6":"alors je ferai de ce Temple ce que j'ai fait de Silo. Je ferai de cette ville une malédiction sous les yeux de toutes les nations de la terre."
,"7":"Les prêtres, les prophètes et tout le peuple, entendirent ces paroles que Jérémie prononçait dans la Maison de Yahvé."
,"8":"Jérémie avait juste terminé de dire tout ce que Yahvé lui avait commandé de dire au peuple, lorsque les prêtres et les prophètes l'arrêtèrent. Ils lui dirent: 'Ce coup-ci tu vas mourir!"
,"9":"Pourquoi as-tu dit de la part de Yahvé que ce Temple deviendrait comme Silo et que cette ville resterait en ruines et sans habitants?' Et il y eut un attroupement autour de Jérémie dans la Maison de Yahvé."
,"10":"En apprenant cela, les chefs de Juda arrivèrent du palais royal à la Maison de Yahvé, et ils s'installèrent à l'entrée de la Porte Neuve de la Maison de Yahvé."
,"11":"Les prêtres et les prophètes dirent aux chefs et à tout le peuple: 'Cet homme mérite la mort, car il a prophétisé contre cette ville, comme vous l'avez entendu vous-mêmes de vos oreilles!'"
,"12":"Mais Jérémie dit au peuple: 'C'est Yahvé qui m'a envoyé proclamer, contre ce Temple et cette ville, toutes les paroles que vous avez entendues."
,"13":"C'est le moment de redresser votre conduite et vos manières d'agir. Ecoutez la voix de Yahvé votre Dieu, et Yahvé renoncera au mal qu'il a prononcé contre vous."
,"14":"Quant à moi, je suis entre vos mains, traitez-moi comme il vous semblera bon et juste."
,"15":"Mais si vous me faites mourir, sachez bien que je suis innocent et que vous aurez à en répondre, vous, votre ville et ses habitants. Car c'est Yahvé qui m'a envoyé vers vous pour proclamer toutes ces paroles à vos oreilles.'"
,"16":"Alors les chefs et tout le peuple dirent aux prêtres et aux prophètes: 'Cet homme ne mérite pas la mort, c'est au nom de Yahvé notre Dieu qu'il nous a parlé.'"
,"17":"Quelques anciens du pays se levèrent même pour dire à tous ceux qui s'étaient attroupés:"
,"18":"'Quand Michée de Moréchèt prophétisait, au temps d'Ezéquias roi de Juda, il a dit à tout le peuple de Juda: Voici une parole de Yahvé Sabaot: Sion deviendra un champ à labourer, Jérusalem sera un monceau de ruines; la montagne du Temple ne sera plus qu'une colline à l'abandon."
,"19":"Mais Ezéquias roi de Juda et le peuple de Juda ne l'ont pas fait mourir pour autant; au contraire ils ont eu la crainte de Yahvé et ils l'ont supplié. Et Yahvé a renoncé au mal qu'il avait prononcé contre eux. Comment pourrions-nous prendre la responsabilité d'un si grand crime?'"
,"20":"Un autre encore avait parlé au nom de Yahvé, c'était Ouriyas fils de Chémayas, qui était de Kyriat-Yéarim. Il avait prophétisé contre cette ville et contre ce pays, et il parlait comme Jérémie."
,"21":"Lorsque le roi Joïaqim, ses officiers et ses chefs entendirent ses paroles, ils cherchèrent à le faire mourir. En apprenant cela Ouriyas eut peur, il prit la fuite et arriva en Egypte."
,"22":"Mais le roi Joïaqim envoya en Egypte Elnathan, fils de Akbor, avec quelques hommes."
,"23":"Ils firent sortir Ouriyas d'Egypte et le ramenèrent au roi Joïaqim. Celui-ci ordonna de le frapper de l'épée et de jeter son cadavre à la fosse commune."
,"24":"Mais Jérémie fut protégé par Ahikam, fils de Chafan, qui empêcha de le livrer au peuple et de le mettre à mort."
}`)
	CurrentBook.AddChapter(27, `{
"1":"Voici la parole de Yahvé qui fut adressée à Jérémie au début du règne de Sédécias fils de Josias, roi de Juda."
,"2":"Voici ce que dit Yahvé: Fais-toi des liens et un joug que tu placeras sur ton cou."
,"3":"Tu vas envoyer un message aux rois d'Edom, de Moab, d'Ammon, de Tyr et de Sidon, par l'intermédiaire de leurs envoyés qui sont venus à Jérusalem pour voir Sédécias, roi de Juda."
,"4":"Tu leur confieras donc ce message pour leurs maîtres: 'Voici ce que dit Yahvé Sabaot, Dieu d'Israël: Vous direz ceci à vos maîtres:"
,"5":"Par ma puissance et mes interventions, j'ai fait la terre, les humains et les bêtes qui sont sur la terre, et je les donne à qui je veux."
,"6":"Or maintenant je remets toute la terre entre les mains de mon serviteur Nabukodonozor roi de Babylone; je lui ai même donné les bêtes des champs pour qu'elles soient à son service."
,"7":"Toutes les nations le serviront, lui, son fils et le fils de son fils, jusqu'au jour où son pays sera dominé à son tour par de grandes nations avec des rois puissants."
,"8":"C'est pourquoi je châtierai par l'épée, la famine et la peste, la nation ou le royaume qui ne servira pas Nabukodonozor, roi de Babylone, et qui refusera de porter le joug du roi Babylone - parole de Yahvé: je lui soumettrai cette nation."
,"9":"Vous donc, n'écoutez pas vos prophètes ni ceux qui lisent dans les rêves ou dans les astres, ni vos sorciers qui vous disent: Vous ne serez pas soumis au roi de Babylone!"
,"10":"Tout ce qu'ils vous prophétisent est faux. Le résultat sera pour vous l'exil, la perte du pouvoir et la disparition."
,"11":"Par contre, si une nation accepte de porter le joug du roi de Babylone et de le servir, je la ferai vivre en paix sur sa terre - parole de Yahvé-; elle la cultivera et l'habitera.'"
,"12":"Je dis alors la même chose à Sédécias, roi de Juda: 'Acceptez de porter le joug du roi de Babylone, servez-le, lui et son peuple, et vous vivrez."
,"13":"Voulez-vous donc mourir, toi et ton peuple, par l'épée, la famine et la peste, comme Yahvé l'a dit à propos de la nation qui refusera de servir le roi de Babylone?"
,"14":"N'écoutez pas les prophètes qui vous disent: Vous ne serez pas soumis au roi de Babylone; ce sont de fausses prophéties."
,"15":"Je ne les ai pas envoyés - parole de Yahvé, et ils font en mon nom de fausses prophéties. Le seul résultat sera que vous disparaîtrez avec vos prophètes.'"
,"16":"Je me tournai ensuite vers les prêtres et tout le peuple, et je leur dis: 'Voici ce que dit Yahvé: N'écoutez pas vos prophètes quand ils vous disent que les objets de la Maison de Yahvé vont bientôt revenir de Babylone. Ce sont de fausses prophéties."
,"17":"Ne les écoutez pas! Au contraire, acceptez de servir le roi de Babylone et vous vivrez. Voulez-vous donc que cette ville devienne une ruine?"
,"18":"S'ils sont réellement prophètes et que la parole de Yahvé les visite, ils vont sûrement me prier ()"
,"19":"() à propos des objets qui restent"
,"20":"et que le roi de Babylone, n'a pas emportés quand il a déporté de Jérusalem à Babylone Jékonias () avec les chefs de Juda et de Jérusalem."
,"21":"Oui, voici ce que dit Yahvé Sabaot, Dieu d'Israël, à propos de ces objets qui restent encore dans la Maison de Yahvé, dans le palais du roi de Juda et dans Jérusalem:"
,"22":"Eux aussi seront emportés à Babylone ()."
}`)
	CurrentBook.AddChapter(28, `{
"1":"On était dans cette même année au cinquième mois de la quatrième année, et c'était le début du règne de Sédécias, roi de Juda. Le prophète Hananyas fils d'Azour, qui était de Gabaon, s'adressa à Jérémie dans la Maison de Yahvé, devant les prêtres et le peuple:"
,"2":"'Voici ce que dit Yahvé Sabaot, le Dieu d'Israël: J'ai brisé le joug du roi de Babylone."
,"3":"Encore deux ans et je ferai revenir en ce lieu tous les objets de la Maison de Yahvé"
,"4":"() ainsi que tous les déportés de Juda; car je vais briser le joug du roi de Babylone."
,"5":"Alors le prophète Jérémie répondit au prophète Hananyas devant les prêtres et devant tous ceux qui se trouvaient dans la Maison de Yahvé."
,"6":"Le prophète Jérémie dit: 'Que Yahvé t'écoute et fasse ainsi, qu'il accomplisse ce que tu viens d'annoncer, et qu'il fasse revenir de Babylone tous les objets de la Maison de Yahvé et tous les exilés."
,"7":"Cependant, écoute bien les paroles que j'ai dites et que tu as entendues, comme tout ce peuple."
,"8":"Car depuis longtemps, les prophètes qui sont venus avant moi et toi ont annoncé pour beaucoup de pays et pour de très grands rois la guerre, le malheur et la peste."
,"9":"Si un prophète annonce la paix, il faudra que sa parole se réalise pour qu'on sache que vraiment Yahvé l'a envoyé.'"
,"10":"Alors le prophète Hananyas prit le joug que le prophète Jérémie portait sur son cou et le brisa."
,"11":"Et devant tout le peuple Hananyas dit: 'Voici la parole de Yahvé: Dans deux ans tout juste je briserai de la même façon le joug du roi de Babylone, et je l'ôterai de sur le cou de toutes les nations.' Et le prophète Jérémie s'en alla."
,"12":"Mais après cette affaire où le prophète Hananyas avait brisé le joug que le prophète Jérémie portait sur son cou, une parole de Yahvé fut adressée à Jérémie:"
,"13":"'Va dire à Hananyas cette parole de Yahvé: Tu as brisé le joug de bois? Remplace-le donc par un joug de fer."
,"14":"En effet, voici ce que dit Yahvé Sabaot, le Dieu d'Israël: Je mets un joug de fer sur le cou de toutes ces nations.'"
,"15":"Ensuite le prophète Jérémie dit au prophète Hananyas: 'Ecoute bien, Hananyas: Yahvé ne t'a pas envoyé pour encourager ce peuple à s'appuyer sur des illusions."
,"16":"C'est pourquoi, voici ce que dit Yahvé: Je te rejette de la face de la terre; cette année-même tu mourras, car tu as prêché la révolte contre Yahvé.'"
,"17":"Au septième mois de cette année, le prophète Hananyas mourut."
}`)
	CurrentBook.AddChapter(29, `{
"1":"Voici le texte de la lettre que le prophète Jérémie envoya de Jérusalem aux Anciens qui avaient survécu et qui avaient été déportés, ainsi qu'aux prêtres, aux prophètes et à tous les gens que Nabukodonozor avait déportés de Jérusalem vers Babylone."
,"2":"A ce moment-là, le roi Jékonias avait déjà quitté Jérusalem avec la reine-mère, ses serviteurs, les princes de Juda et de Jérusalem, les forgerons et les serruriers."
,"3":"La lettre fut portée par Eléasa fils de Chafan, et Guémaryas fils de Hilkiya, car Sédécias roi de Juda les envoyait à Babylone auprès du roi Nabukodonozor. Cette lettre disait:"
,"4":"Voici ce que Yahvé Sabaot, le Dieu d'Israël, dit à l'ensemble des déportés de Jérusalem à Babylone:"
,"5":"Construisez des maisons et installez-vous. Plantez des jardins et mangez-en les fruits."
,"6":"Mariez-vous, ayez des fils et des filles, prenez des femmes pour vos fils et donnez vos filles en mariage; qu'elles aient des fils et des filles. Multipliez-vous là-bas et ne diminuez pas."
,"7":"Recherchez la prospérité du pays où je vous ai exilés, priez Yahvé pour lui, car votre prospérité dépend de la sienne."
,"8":"Car voici ce que dit Yahvé Sabaot, le Dieu d'Israël: Ne vous laissez pas tromper par vos prophètes qui sont au milieu de vous, ou par vos magiciens; n'écoutez pas leurs songes,"
,"9":"car ce qu'ils vous annoncent de ma part n'est que mensonge: je ne les ai pas envoyés."
,"10":"Oui, voici ce que dit Yahvé: Lorsque vous serez restés soixante-dix ans à Babylone, je vous visiterai et je réaliserai ma promesse de vous ramener ici."
,"11":"Car je sais bien ce que j'ai l'intention de faire pour vous: c'est la paix et non le malheur. Je veux vous donner un avenir et une espérance."
,"12":"Vous vous tournerez vers moi, vous me prierez et je vous écouterai."
,"13":"Vous me chercherez et vous me trouverez, car alors vous me rechercherez de tout votre coeur."
,"14":"Aussi je me laisserai trouver par vous. Je ramènerai vos prisonniers et je vous rassemblerai de toutes les nations, de tous les lieux où je vous avais chassés - parole de Yahvé. Et je vous ramènerai en ce lieu d'où je vous ai exilés."
,"15":"Vous dites: 'Yahvé nous a donné des prophètes à Babylone.'"
,"16":"Mais voici ce que dit Yahvé à propos du roi qui est assis sur le trône de David et de tout le peuple qui habite cette ville, à propos de tous vos frères qui ne vous ont pas accompagnés en déportation."
,"17":"Voici ce que dit Yahvé Sabaot: Je vais envoyer sur eux l'épée, la famine et la peste; à la fin ils seront comme des figues pourries, si pourries qu'on ne peut même plus les manger."
,"18":"Je les poursuivrai par l'épée, la famine et la peste; je ferai d'eux un objet d'épouvante pour tous les royaumes de la terre, une honte, un objet d'étonnement, de dérision et de moquerie pour toutes les nations où je les disperserai."
,"19":"Car ils n'ont pas écouté mes paroles - parole de Yahvé. Sans me lasser je leur avais envoyé mes serviteurs les prophètes, mais ils n'ont pas écouté - parole de Yahvé."
,"20":"Quant à vous, les déportés que j'ai envoyés de Jérusalem à Babylone, écoutez tous la parole de Yahvé!"
,"21":"Mais voici ce que dit Yahvé Sabaot, le Dieu d'Israël, au sujet d'Ahab fils de Kolaya, et de Sidkiyas fils de Maaséya: 'Ils vous disent en mon nom des mensonges! C'est pourquoi je vais les livrer entre les mains de Nabukodonozor roi de Babylone, qui les fera mourir sous vos yeux.'"
,"22":"Les déportés de Judée qui sont à Babylone ne l'oublieront pas, et on répétera parmi vous: 'Que Yahvé te traite comme Sidkiyas et Ahab que le roi de Babylone a fait rôtir au feu.'"
,"23":"C'est qu'ils ont accompli une chose ignoble en Israël: ils ont commis l'adultère avec la femme de leur prochain, et ils ont parlé faussement en mon nom alors que je ne leur avais rien commandé. Oui, je le sais et j'en suis le témoin - parole de Yahvé."
,"24":"Tu diras à Chémayas de Nahlam"
,"25":"de la part de Yahvé Sabaot Dieu d'Israël: 'Tu as envoyé en ton nom des lettres à tout le peuple de Jérusalem, au prêtre Séfanyas fils de Maaséyas, et à tous les autres prêtres. Tu disais ceci:"
,"26":"Puisque Yahvé t'a choisi comme prêtre à la place du prêtre Yoyada pour assurer l'ordre dans la Maison de Yahvé, tu dois faire arrêter et enchaîner tout excité qui joue au prophète."
,"27":"Alors, pourquoi n'as-tu pas corrigé Jérémie d'Anatot qui fait le prophète au milieu de vous?"
,"28":"Il vient de nous envoyer à Babylone ce message: Ce sera long, construisez des maisons, installez-vous, plantez des jardins et mangez-en les fruits.'"
,"29":"Le prêtre Séfanyas avait lu cette lettre de Chamayas au prophète Jérémie."
,"30":"Une parole de Yahvé fut alors adressée à Jérémie:"
,"31":"Tu enverras ce message à tous les déportés: 'Voici ce que dit Yahvé à propos de Chémayas de Nahlam: Chémayas a parlé comme un prophète alors que je ne l'avais pas envoyé, et il vous a fait croire des choses qui ne sont pas vraies."
,"32":"C'est pourquoi Yahvé déclare: Je vais faire payer Chémayas de Nahlam et sa descendance; aucun de sa famille n'habitera au milieu de ce peuple, aucun ne profitera du bonheur que je veux donner à mon peuple."
}`)
	CurrentBook.AddChapter(30, `{
"1":"Voici une parole qui fut adressée à Jérémie de la part de Yahvé."
,"2":"Voici ce que dit Yahvé, le Dieu d'Israël: Ecris donc dans un livre toutes les paroles que je t'ai adressées."
,"3":"En effet, voici venir des jours - oracle de Yahvé - où je ramènerai les prisonniers de mon peuple Israël; je les ferai revenir au pays que j'ai donné à leurs pères, dit Yahvé, et ils le possèderont de nouveau."
,"4":"Voici les paroles que Yahvé a prononcées au sujet d'Israël et de Juda:"
,"5":"Nous avons entendu un cri d'épouvante; c'est la terreur et non la paix."
,"6":"Demandez donc et voyez: a-t-on vu un mâle attendre un enfant?,Comment se fait-il donc que je les voie tous,les mains sur les reins comme celles qui enfantent?,Pourquoi tous ces visages consternés?"
,"7":"Malheur! C'est le grand jour!,Il n'y en a pas eu de semblable; c'est un temps de détresse pour Jacob, mais il en sera délivré."
,"8":"En ce jour-là - parole de Yahvé Sabaot - je briserai le joug que tu portes sur ton cou et je mettrai en pièces tes chaînes, tu ne seras plus soumis à des étrangers,"
,"9":"mais Israël et Juda serviront Yahvé leur Dieu, et David, le roi que je leur donnerai."
,"10":"Ne tremble pas Jacob, mon serviteur - parole de Yahvé, n'aie pas peur Israël. Oui, me voici, et de loin je te ramène; tes descendants reviennent du pays de leur exil. Jacob rentre, il connaîtra le calme; il vivra en paix et nul ne l'inquiétera plus."
,"11":"Je suis avec toi pour te sauver - parole de Yahvé. Je détruirai toutes les nations où je t'ai dispersé, mais toi, je ne te détruirai pas. Je te corrigerai avec justice, mais ce ne sera pas une vengeance."
,"12":"Oui, voici ce que dit Yahvé: pas de guérison pour ta blessure, douloureuse est ta plaie."
,"13":"Nul ne vient te faire justice, plus de guérison à espérer;"
,"14":"tous tes amants t'ont oubliée, ils ont cessé de courir après toi. Oui, je t'ai frappé comme fait un ennemi, d'une sévère correction; car ta faute est grande, et tes péchés sont nombreux."
,"15":"Pourquoi crier à cause de ta blessure?,ton mal est sans guérison. Ta faute était si grande, tes péchés si nombreux, que j'ai dû te traiter ainsi."
,"16":"Mais ceux qui te dévoraient seront dévorés, tous tes ennemis partiront en exil, ceux qui te dépouillaient seront dépouillés, je ferai qu'on pille ceux qui te pillaient."
,"17":"Je soignerai ta plaie, je te guérirai de tes blessures - parole de Yahvé, toi qu'on appelait la rejetée, Sion-dont-personne-ne-prend-soin."
,"18":"Voici ce que dit Yahvé: Je vais redresser les tentes de Jacob, j'aurai pitié de ses demeures; une ville sera rebâtie sur sa colline et le palais retrouvera sa place."
,"19":"Il en sortira des chants de louange et des rires joyeux. Je les multiplierai au lieu de les diminuer, leur prestige s'étendra, ils ne seront plus humiliés."
,"20":"Ses fils seront comme autrefois: son assemblée sera inébranlable devant moi et je me lèverai contre ceux qui l'opprimeront."
,"21":"Son chef sera l'un des leurs, son roi sortira de leurs rangs; je l'appellerai et le ferai approcher de moi. Qui donc en effet se risquerait à s'approcher de moi - parole de Yahvé?"
,"22":"Vous serez mon peuple, et je serai votre Dieu."
,"23":"Voici la tempête de Yahvé; la tempête se lève et tourbillonne au-dessus de la tête des infidèles."
,"24":"La colère de Yahvé ne passera pas avant d'avoir réalisé et mené à bien ses projets; à la fin des temps vous comprendrez tout cela."
}`)
	CurrentBook.AddChapter(31, `{
"1":"En ce temps-là - parole de Yahvé - je serai le Dieu de tous les clans d'Israël, et eux seront mon peuple."
,"2":"Voici ce que dit Yahvé: Le peuple rescapé de l'épée affronte les chaleurs du désert; Israël marche vers le lieu de son repos."
,"3":"De loin, Yahvé lui est apparu: Je t'ai aimé d'un amour éternel, c'est pourquoi je t'ai gardé ma faveur."
,"4":"Je te rebâtirai, vierge d'Israël, et tu seras rebâtie. Tu retrouveras tes tambourins et de nouveau tu sortiras au rythme des danses joyeuses."
,"5":"De nouveau, sur les monts de Samarie, tu planteras des vignes, et ceux qui les auront plantées en cueilleront les grappes."
,"6":"Voici venir le jour où les veilleurs crieront dans les monts d'Ephraïm: 'Debout, montons à Sion, vers Yahvé notre Dieu!'"
,"7":"Voici ce que dit Yahvé: Poussez des cris de joie en l'honneur de Jacob! Acclamez la première des nations, proclamez et chantez: Yahvé a sauvé son peuple, le reste d'Israël."
,"8":"Voici que je les amène des pays du nord, je les rassemble des extrémités de la terre: ils sont tous là, l'aveugle et le boiteux, la femme enceinte et celle qui vient de mettre au monde. Quelle assemblée immense au retour!"
,"9":"Ils étaient partis dans les larmes, je les ramènerai apaisés, je les conduirai vers les eaux courantes par un bon chemin où ils ne trébucheront plus, car je serai un père pour Israël, Ephraïm sera mon premier-né."
,"10":"Nations, écoutez la parole de Yahvé, proclamez-la dans les îles lointaines et dites: celui qui a dispersé Israël le rassemble, il le gardera comme un berger garde son troupeau."
,"11":"Car Yahvé a racheté Jacob, il l'a délivré de la main d'un plus fort que lui."
,"12":"Ils arriveront, criant de joie, au haut-lieu de Sion; ils accourront vers les biens de Yahvé: le blé, le vin nouveau et l'huile, les brebis et les boeufs. Leur âme sera comme un jardin bien arrosé, ils ne se traîneront plus."
,"13":"Alors les vierges danseront de joie, jeunes et vieux seront en fête; je changerai leur deuil en joie, je leur donnerai du bonheur après leurs épreuves."
,"14":"Les prêtres recevront la graisse en abondance, et mon peuple sera comblé de mes bienfaits - car Yahvé a parlé."
,"15":"Voici ce que dit Yahvé: On a entendu une rumeur à Rama, des lamentations, des sanglots: c'était Rachel qui pleurait ses enfants; elle refusait de se consoler car ils n'étaient plus."
,"16":"Mais voici ce que dit Yahvé: Retiens les sanglots de ta voix et les larmes de tes yeux, car ta peine aura sa récompense. Ils reviendront du pays de l'ennemi."
,"17":"Espère pour ton avenir, car tes fils rentreront dans leurs frontières."
,"18":"J'entends, j'entends la voix d'Ephraïm qui se plaint: 'Tu m'as corrigé et j'ai été corrigé, comme un jeune taureau pas encore dressé. Fais-moi revenir et je reviendrai, car tu es Yahvé mon Dieu."
,"19":"Après m'être écarté je me suis repenti, j'ai compris et je me suis frappé la poitrine; j'étais tout honteux, je rougissais: oui, ma jeunesse honteuse pesait sur moi."
,"20":"- Ephraïm est-il donc pour moi un fils si chéri, un enfant tellement aimé que si je parle contre lui, je lui suis plus attaché. Aussi je me sens tout retourné et j'ai vraiment pitié de lui - parole de Yahvé."
,"21":"Dresse des signaux et fais-toi des repères, observe bien la route, le chemin par lequel tu t'en es allée, et puis reviens, vierge d'Israël!,Reviens vers ces villes qui t'appartiennent."
,"22":"Combien de temps encore seras-tu errante, fille rebelle?,Voici que Yahvé crée du neuf dans ce pays: c'est la femme qui recherche l'homme!"
,"23":"Voici ce que dit Yahvé Sabaot, le Dieu d'Israël: 'De nouveau on prononcera ces paroles dans le pays de Juda et dans ses villes, lorsque je ramènerai leurs captifs: Que Yahvé te bénisse, Demeure-de-Justice, Sainte-Montagne."
,"24":"Tout Juda et ses villes se rétabliront; ils cultiveront la terre et garderont les troupeaux."
,"25":"Oui, je donnerai à boire à celui qui est fatigué et je comblerai celui qui est épuisé.'"
,"26":"Alors je me suis réveillé et j'ai vu que mon sommeil avait été bon."
,"27":"Des jours viennent - parole de Yahvé - où j'ensemencerai la maison d'Israël et la maison de Juda: avec des hommes, et aussi du bétail."
,"28":"Je me suis occupé d'eux: je déracinais et renversais, je démolissais, j'exterminais et amenais le malheur. Mais maintenant - parole de Yahvé - je m'occuperai d'eux pour bâtir et pour planter."
,"29":"En ces jours-là on ne dira plus: Les pères ont mangé des raisins verts et les dents des fils ont été agacées,"
,"30":"mais chacun mourra pour sa propre faute; l'homme qui mangera du raisin vert, c'est lui dont les dents seront agacées."
,"31":"Voici que des jours viennent - parole de Yahvé - où je ferai avec la maison d'Israël (et la maison de Juda) une alliance nouvelle."
,"32":"Non pas comme l'alliance que j'ai faite avec leurs pères, le jour où je les ai empoignés pour les faire sortir du pays d'Egypte, une alliance qu'ils ont brisée alors que j'étais leur maître - parole de Yahvé."
,"33":"Voici l'alliance que je ferai avec la maison d'Israël après ces jours-là - parole de Yahvé. Je mettrai ma loi au-dedans d'eux et je l'écrirai sur leur coeur; je serai leur Dieu, et eux seront mon peuple."
,"34":"On n'aura plus à instruire son prochain, on ne dira plus à son frère: 'Connais Yahvé!' Tous me connaîtront, du plus petit jusqu'au plus grand - parole de Yahvé, car j'aurai pardonné leurs fautes et je ne me souviendrai plus de leurs péchés."
,"35":"Voici ce que dit Yahvé, qui mit le soleil pour éclairer le jour, la lune et les étoiles pour éclairer la nuit, qui fend la mer et fait gronder ses flots, lui dont le nom est Yahvé Sabaot:"
,"36":"Si ces lois pouvaient disparaître devant moi - parole de Yahvé, la race d'Israël aussi cesserait d'être la nation qui est pour toujours à mon service."
,"37":"Voici ce que dit Yahvé: S'il était possible de mesurer les cieux là-haut, et de fouiller vers le bas jusqu'aux fondations de la terre, je pourrais aussi rejeter la race entière d'Israël pour tout ce qu'ils ont fait - parole de Yahvé."
,"38":"Voici venir des jours - parole de Yahvé - où Yahvé aura sa ville rebâtie depuis la tour de Hananéel jusqu'à la Porte-de-l'Angle."
,"39":"On tendra tout droit le cordeau à mesurer jusqu'à la colline de Gareb, et l'on tournera ensuite vers Goa."
,"40":"Toute la Vallée-des-cadavres-et-des-cendres, tous les terrains jusqu'au torrent du Cédron et jusqu'à l'angle de la Porte-des-Chevaux à l'est, seront consacrés à Yahvé; il n'y aura plus jamais destruction ou ruine."
}`)
	CurrentBook.AddChapter(32, `{
"1":"Voici la parole que Yahvé adressa à Jérémie en la dixième année de Sédécias, roi de Juda; c'était la dix-huitième année de Nabukodonozor."
,"2":"L'armée du roi de Babylone assiégeait alors Jérusalem et le prophète Jérémie était en prison dans la cour de garde qui se trouve dans la maison du roi de Juda."
,"3":"Le roi de Juda, Sédécias, l'avait enfermé là en disant: 'Pourquoi prophétises-tu, pourquoi dis-tu de la part de Yahvé: Je vais livrer cette ville au roi de Babylone et il s'en emparera;"
,"4":"Sédécias roi de Juda n'échappera pas à la main des Kaldéens; c'est sûr qu'il sera livré aux mains du roi de Babylone. Celui-ci lui parlera face à face et ses yeux le verront."
,"5":"On emmènera Sédécias à Babylone et il y restera.'"
,"6":"Jérémie dit alors: Une parole de Yahvé m'a été adressée, la voici:"
,"7":"'Hanaméel, fils de ton oncle Challoum, va venir te demander de lui acheter son champ qui est à Anatot, car tu peux le racheter en priorité.'"
,"8":"De fait Hanaméel, le fils de mon oncle, vint me trouver dans la cour de garde. Il me dit: 'Achète mon champ qui est à Anatot, car tu as la priorité pour le droit d'héritage; achète-le donc.',Je vis que c'était ce que Yahvé m'avait dit. "
,"9":"Alors j'achète ce champ à mon cousin Hanaméel et je lui en verse le prix: dix-sept sicles d'argent."
,"10":"Je rédige l'acte d'achat, je le signe, je prends des témoins et l'on pèse l'argent sur une balance."
,"11":"Je prends l'acte d'achat avec les engagements et les conventions et sa copie officielle,"
,"12":"et je remets l'acte d'achat à Baruch, fils de Nériya, fils de Mahséya, sous les yeux de mon cousin Hanaméel et des témoins qui ont signé l'acte, en présence de tous les Judéens qui sont là dans la cour de garde."
,"13":"Et devant eux je donne cet ordre à Baruch:"
,"14":"'Prends cet acte d'achat ainsi que la copie scellée, et place-les dans un vase de terre où ils se conserveront longtemps."
,"15":"Car voici ce que dit Yahvé Sabaot, le Dieu d'Israël: On achètera encore des maisons, des champs et des vignes dans ce pays.'"
,"16":"Une fois remis l'acte d'achat à Baruch fils de Nériya, je fis cette prière à Yahvé:"
,"17":"'Ah Seigneur Yahvé, tu es intervenu personnellement, avec grande puissance, pour faire le ciel et la terre; pour toi rien n'est impossible;"
,"18":"tu fais miséricorde à des milliers, mais tu fais aussi payer la faute des pères à leurs fils après eux. O Dieu grand et fort, Yahvé Sabaot est ton nom! "
,"19":"Tes projets sont grandioses et tes exploits nombreux; tu as les yeux ouverts sur tous les chemins des hommes et tu donnes à chacun selon ses voies, selon le fruit de ses actions."
,"20":"Tu t'es fait un nom par tes signes et tes prodiges, déjà en Egypte et maintenant encore, en Israël et chez les autres humains. Cela est toujours vrai."
,"21":"Tu as fait sortir Israël, ton peuple, de la terre d'Egypte, par des signes et des prodiges, par ta grande puissance, en frappant de grands coups: tu es apparu terrible!"
,"22":"Tu lui a donné cette terre que par serment tu promettais à nos pères, une terre où coulent le lait et le miel."
,"23":"Ils y sont entrés, ils l'ont conquise, mais ils ne t'ont pas écouté; ils n'ont pas marché selon ta Loi, ils n'ont pas fait ce que tu leur avais commandé de faire; c'est pourquoi tu as fait venir sur eux tous ces malheurs."
,"24":"Déjà commencent les travaux de terrassement pour s'emparer de la ville. L'épée, la famine et la peste vont faire tomber la ville aux mains des Kaldéens qui la combattent et ce que tu as annoncé va se réaliser."
,"25":"Comment peux-tu me dire, Seigneur Yahvé: Achète-toi un champ à prix d'argent en présence de témoins? Oublies-tu que la ville tombe aux mains des Kaldéens?'"
,"26":"Une parole de Yahvé me fut alors adressée:"
,"27":"Moi, Yahvé, je suis le Dieu de tous; qu'y a-t-il d'impossible pour moi?"
,"28":"C'est pourquoi, voici ce que dit Yahvé: Je vais livrer cette ville au roi de Babylone, et il va s'en emparer."
,"29":"Les Kaldéens qui attaquent cette ville vont entrer et y mettre le feu. Avec elle brûleront les maisons sur le toit desquelles on encensait Baal et on me mettait en colère avec toutes ces libations aux dieux étrangers."
,"30":"Les fils d'Israël et les fils de Juda n'ont pas cessé de faire le mal à mes yeux depuis leur jeunesse."
,"31":"Oui, depuis qu'elle a été construite jusqu'à ce jour, cette ville n'a fait qu'exciter ma colère et ma fureur. Je veux l'écarter de ma vue"
,"32":"à cause de tout le mal que les fils d'Israël et les fils de Juda ont commis et avec lequel ils m'ont mis en colère, aussi bien leurs rois que leurs princes, leurs prêtres, leurs prophètes, les hommes de Juda et les habitants de Jérusalem!"
,"33":"Ils me tournaient le dos et me cachaient leur visage; je ne cessais de les instruire, mais ils refusaient mon enseignement."
,"34":"Ils ont placé leurs idoles dans le Temple sur lequel repose mon Nom et ils l'ont souillé."
,"35":"Ils ont construit des hauts-lieux en l'honneur de Baal dans la vallée de Ben-Hinnom; ils y ont brûlé leurs fils et leurs filles en l'honneur de Molok, chose que je ne leur avais pas commandée et qui ne m'était même jamais venue à l'esprit: quoi, commettre une telle horreur pour faire pécher Juda!"
,"36":"Maintenant, voici une parole de Yahvé, Dieu d'Israël, à propos de cette ville dont vous dites: 'L'épée, la famine et la peste vont la faire tomber aux mains du roi de Babylone.'"
,"37":"Je les rassemblerai de tous les pays où je les ai dispersés dans ma colère, ma fureur et mon grand emportement: je les ramènerai ici pour qu'ils y habitent en paix."
,"38":"Ils seront mon peuple et je serai leur Dieu."
,"39":"Je ferai que d'un coeur nouveau ils suivent un chemin neuf, qu'ils aient toujours en eux ma crainte; alors tout ira bien pour eux et leurs fils après eux."
,"40":"Je ferai avec eux une alliance éternelle qui ne finira pas; je mettrai ma crainte dans leurs coeurs pour qu'ils ne se détournent plus de moi."
,"41":"De tout mon coeur et de toute mon âme je prendrai plaisir à leur faire du bien et je les enracinerai solidement sur cette terre."
,"42":"Voici en effet ce que dit Yahvé: De même que j'ai fait venir sur ce peuple la catastrophe, je ferai maintenant que vienne sur eux tout le bonheur que je leur ai promis."
,"43":"On achètera des champs dans ce pays dont vous dites: Il est dévasté, il n'y a plus ni habitants, ni bêtes; il est livré aux mains des Kaldéens."
,"44":"On achètera encore des champs à prix d'argent dans le pays de Benjamin et dans les environs de Jérusalem, dans les villes de Juda et dans la montagne, dans les villes de la Séphéla et dans celles du midi. On signera encore devant témoins des actes d'achats, car je ramènerai leurs captifs - parole de Yahvé."
}`)
	CurrentBook.AddChapter(33, `{
"1":"La parole de Yahvé fut adressée une seconde fois à Jérémie, alors qu'il était enfermé dans la cour de garde:"
,"2":"Ainsi a parlé Yahvé qui a fait la terre, qui l'a façonnée et l'a fixée, lui dont le nom est Yahvé:"
,"3":"Appelle-moi et je te répondrai, je te ferai connaître des choses grandes et cachées que tu ne savais pas."
,"4":"Car voici ce que dit Yahvé, le Dieu d'Israël, à propos des maisons de cette ville, et des maisons des rois de Juda qu'on est en train de détruire pour les travaux du siège."
,"5":"Lorsqu'ils combattront les Kaldéens, ces maisons se rempliront de cadavres; je les frapperai dans ma colère et ma fureur, parce que j'ai détourné mon regard de cette ville, à cause de leurs actions mauvaises."
,"6":"Mais je leur appliquerai un remède et une guérison. Oui, je vais les guérir et je leur ferai connaître la paix dans la vérité."
,"7":"Je ramènerai les déportés de Juda et de Jérusalem et je les rétablirai comme autrefois."
,"8":"Je les purifierai de tous les péchés qu'ils ont commis contre moi; je pardonnerai toutes les offenses et infidélités qu'ils ont commises contre moi."
,"9":"Cette ville sera ma joie et me fera un nom. Elle me vaudra louange et gloire de la part de toutes les nations qui verront cette prospérité; elles trembleront de respect à la vue de cette prospérité et de cette paix que je lui donnerai."
,"10":"Vous voyez ce lieu en ruines, sans hommes et sans bêtes; mais c'est Yahvé qui le dit: dans les villes de Juda et dans les rues de Jérusalem aujourd'hui dévastées, sans passants ni habitants ni bêtes, on entendra encore"
,"11":"les fêtes et la joie, les chants du fiancé et de la fiancée, ainsi que ceux qui font monter la louange dans le Temple de Yahvé: 'Louez Yahvé Sabaot, car Yahvé est bon, éternelle est sa fidélité!' Oui, je ramènerai les déportés de ce pays et ce sera comme autrefois - parole de Yahvé."
,"12":"Voici ce que dit Yahvé Sabaot: Dans ce pays ravagé, sans hommes et sans bêtes, et dans toutes ses villes, on verra de nouveau des pâturages avec des bergers qui gardent leurs troupeaux."
,"13":"Dans les villes de la montagne et celles de la Séphéla, dans les villes du Négueb, sur le territoire de Benjamin et dans les environs de Jérusalem, ainsi que dans les villes de Juda, les brebis passeront encore sous la main de celui qui les compte - parole de Yahvé."
,"14":"Voici venir des jours - parole de Yahvé, où je réaliserai la promesse que j'ai faite à la maison d'Israël et à la maison de Juda."
,"15":"En ces jours-là et en ce temps-là, je ferai pousser un rejeton de David qui sera pour la justice; il établira dans le pays la droiture et la justice."
,"16":"En ces jours-là Juda sera sauvé, Jérusalem habitera en paix; et voici comment on l'appellera: 'Yahvé-notre-Justice'."
,"17":"Oui, voici ce que dit Yahvé: David aura toujours un de ses descendants assis sur le trône de la maison d'Israël."
,"18":"Les prêtres lévites auront toujours des descendants qui se tiendront devant moi pour m'offrir l'holocauste, pour faire fumer l'offrande, et présenter le sacrifice quotidien."
,"19":"La parole de Yahvé fut ensuite adressée à Jérémie:"
,"20":"'Voici ce que dit Yahvé: Si vous pouvez rompre mon contrat avec le jour, ou mon contrat avec la nuit, si bien que le jour et la nuit ne viennent plus au moment fixé,"
,"21":"alors sera aussi brisée mon alliance avec mon serviteur David et il n'aura plus de descendants pour régner sur son trône. Alors seulement sera brisée mon alliance avec mes serviteurs, les prêtres lévites."
,"22":"De même qu'on ne peut compter l'armée du ciel ni mesurer les sables de la mer, de même je multiplierai la descendance de mon serviteur David et celle des Lévites qui me servent."
,"23":"Voici une parole de Yahvé qui fut adressée à Jérémie:"
,"24":"As-tu remarqué comment les gens disent: 'Yahvé a rejeté les deux familles qu'il avait choisies'? Ils ne croient déjà plus à mon peuple, comme s'il n'était plus une nation."
,"25":"Mais voici ce que dit Yahvé: Si je n'ai pas créé le jour et la nuit, si je n'ai pas fixé les règles du ciel et de la terre,"
,"26":"alors je suis capable de rejeter la race de Jacob; alors je rejetterai les descendants de mon serviteur David et je ne prendrai plus parmi eux les gouvernants du peuple d'Abraham, d'Isaac et de Jacob. Car je ramènerai leurs exilés et je serai plein d'attentions pour eux."
}`)
	CurrentBook.AddChapter(34, `{
"1":"Nabukodonozor, roi de Babylone, combattait contre Jérusalem et contre toutes les villes de Juda avec toute son armée, les royaumes de la terre et tous les peuples soumis à son autorité. Une parole de Yahvé fut alors adressée à Jérémie:"
,"2":"Va dire à Sédécias, roi de Juda, cette parole de Yahvé Dieu d'Israël: Je vais livrer cette ville entre les mains du roi de Babylone et il y mettra le feu."
,"3":"Quant à toi, tu n'échapperas pas à sa main. Tu seras arrêté et remis entre ses mains, tes yeux verront les yeux du roi de Babylone, tu lui parleras face à face et tu iras à Babylone."
,"4":"Cependant, écoute la parole de Yahvé, Sédécias, roi de Juda. Voici ce que dit Yahvé à ton sujet: On ne te tuera pas,"
,"5":"mais tu mourras en paix et on fera fumer pour toi des parfums, comme on l'a fait pour tes pères, les rois qui sont venus avant toi. On fera sur toi la lamentation: 'Hélas, seigneur...' C'est moi qui te le dis - parole de Yahvé."
,"6":"C'est à Jérusalem que le prophète Jérémie prononça toutes ces paroles devant Sédécias, roi de Juda,"
,"7":"quand l'armée du roi de Babylone assiégeait Jérusalem et toutes les villes de Juda qui résistaient encore, c'est-à-dire Lakish et Azékah qui comptaient parmi les villes fortifiées de Juda."
,"8":"Voici une parole de Yahvé qui fut adressée à Jérémie. Le roi Sédécias, d'accord avec le peuple de Jérusalem, avait proclamé solennellement une libération."
,"9":"Chacun devait rendre la liberté à ses esclaves hébreux, hommes ou femmes, personne ne devait plus garder en esclavage un frère judéen."
,"10":"Tous les chefs et tout le peuple avaient pris cet engagement: chacun rendrait la liberté à son esclave ou à sa servante, et ne les garderait plus comme esclaves; ainsi firent-ils, ils les renvoyèrent."
,"11":"Mais après cela ils changèrent d'avis, ils firent revenir les esclaves et les servantes à qui ils avaient rendu la liberté et, de nouveau, les traitèrent en esclaves."
,"12":"Une parole de Yahvé fut alors adressée à Jérémie."
,"13":"Voici ce que dit Yahvé Dieu d'Israël: J'ai fait une alliance avec vos pères le jour où je les ai fait sortir d'Egypte, du pays de l'esclavage. Je leur ai dit:"
,"14":"Après sept ans, chacun d'entre vous renverra son frère hébreu qui s'est vendu à lui et qui l'a servi pendant six ans. Vous le renverrez de chez vous, libre. Mais vos pères ne m'ont pas écouté, ils n'ont pas prêté l'oreille."
,"15":"Vous veniez tout juste de vous convertir et vous aviez fait ce qui est juste à mes yeux. Chacun de vous avait proclamé la libération de son prochain, et vous aviez pris un engagement en ma présence, dans le temple que mon Nom a rendu saint."
,"16":"Mais ensuite vous avez déshonoré mon Nom: vous avez changé d'avis et chacun de vous a fait revenir l'esclave ou la servante à qui il avait rendu la liberté. Hommes ou femmes, vous les avez repris comme esclaves."
,"17":"C'est pourquoi, voici ce que dit Yahvé: Vous ne m'avez pas écouté lorsque je parlais de libérer votre frère, votre prochain. Eh bien maintenant - parole de Yahvé - je libère contre vous l'épée, la peste et la famine; je ferai de vous un objet d'épouvante pour tous les royaumes de la terre. "
,"18":"Les hommes qui ont trahi mon alliance et qui n'ont pas respecté les termes de cette alliance qu'ils avaient faite devant moi, je les rendrai semblables au veau qu'ils ont coupé en deux et entre les morceaux duquel ils sont passés pour conclure cette alliance."
,"19":"Je parle des chefs de Juda et de Jérusalem, des officiers et des prêtres, et de tous les propriétaires qui sont passés entre les morceaux du veau."
,"20":"Je les livrerai à leurs ennemis; leur cadavre sera la nourriture des oiseaux des cieux et des bêtes de la terre."
,"21":"Je livrerai Sédécias roi de Juda et les chefs, à leurs ennemis, à cette armée du roi de Babylone qui s'est éloignée de vous."
,"22":"Car je viens de donner un ordre - oracle de Yahvé. Je les ramène contre cette ville pour qu'ils combattent contre elle. Ils la prendront et la livreront aux flammes. Quant aux villes de Juda, elles resteront à l'état de ruines, désertes."
}`)
	CurrentBook.AddChapter(35, `{
"1":"Voici une parole de Yahvé qui fut adressée à Jérémie du temps de Joïaqim fils de Josias, roi de Juda:"
,"2":"'Va trouver le groupe des Rékabites, parle avec eux et fais-les venir dans l'une des salles de la Maison de Yahvé. Là tu leur offriras du vin à boire.'"
,"3":"J'allai donc chercher Yaazanya, fils de Yirméyas, fils de Habassinya, ses frères et tous ses fils; en un mot, tout le groupe des Rékabites,"
,"4":"et je les amenai à la Maison de Yahvé, dans la salle de Ben-Yohanan, fils de Yigdalyas, l'homme de Dieu. Cette salle est à côté de la salle des chefs, au-dessus de la pièce de Maaséyas, fils de Challoum, gardien de la porte."
,"5":"Je fis amener pour les membres du groupe rékabite des jarres pleines de vin et des coupes, et je leur dis: 'Buvez du vin.'"
,"6":"Mais ils me répondirent: 'Nous ne buvons jamais de vin, car notre ancêtre Yonadab fils de Rékab nous a donné ce commandement: vous ne boirez pas de vin, ni vous ni vos fils."
,"7":"De même, vous ne construirez pas de maisons, vous ne ferez pas de semailles, vous ne planterez pas de vignes, vous ne posséderez rien de tout cela. Toute votre vie vous vivrez sous la tente, et si vous le faites, vous vivrez de longs jours sur la terre où vous camperez."
,"8":"Nous avons obéi à toutes les consignes de notre ancêtre Yonadab fils de Rékab; nous ne buvons jamais de vin, ni nous, ni nos femmes, ni nos fils, ni nos filles."
,"9":"Nous ne bâtissons pas de maisons pour y habiter, nous ne possédons ni vignes, ni champs, ni semailles;"
,"10":"mais nous habitons sous la tente. Nous obéissons et nous faisons comme notre ancêtre Yonadab nous a dit de le faire."
,"11":"Mais lorsque Nabukodonozor roi de Babylone est venu faire la guerre à ce pays, nous nous sommes dit: Réfugions-nous à Jérusalem pour échapper à l'armée des Kaldéens et à celle d'Aram. Et c'est ainsi que nous sommes à Jérusalem.'"
,"12":"Alors Jérémie reçut une parole:"
,"13":"Voici ce que dit Yahvé, le Dieu d'Israël: Va dire aux hommes de Juda et aux habitants de Jérusalem: Quand donc comprendrez-vous que vous devez obéir à mes ordres - parole de Yahvé."
,"14":"On a obéi aux ordres de Yonadab fils de Rékab, qui interdisait à ses fils de boire du vin, et jusqu'à ce jour ils n'en ont pas bu par obéissance à leur ancêtre. Mais moi je vous ai parlé et je continue de vous parler, et vous ne m'écoutez pas."
,"15":"Je vous ai envoyé mes serviteurs les prophètes pour vous dire: Que chacun renonce à sa mauvaise conduite; changez vos façons de faire, ne vous mettez pas à la traîne d'autres dieux et ne les servez pas, si vous voulez rester dans le pays que j'ai donné à vos pères et à vous. Mais vous n'avez pas voulu entendre, vous ne m'avez pas écouté."
,"16":"Les descendants de Yonadab fils de Rékab observent les ordres de leur ancêtre, mais ce peuple ne veut pas m'écouter!"
,"17":"C'est pourquoi, voici ce que dit Yahvé, le Dieu Sabaot, le Dieu d'Israël: 'Je vais amener sur Juda et sur tous les habitants de Jérusalem le malheur dont je les ai menacés, car je leur ai parlé et ils n'ont pas écouté, je les ai appelés et ils n'ont pas répondu.'"
,"18":"Ensuite Jérémie dit au groupe des Rékabites: 'Voici ce que dit Yahvé Sabaot, le Dieu d'Israël: Vous avez gardé les commandements de votre ancêtre Yonadab, vous avez observé tous ses ordres et pratiqué tout ce qu'il vous a demandé;"
,"19":"à cause de cela - c'est Yahvé Sabaot, le Dieu d'Israël, qui le dit: Yonadab fils de Rékab aura toujours des descendants pour me servir.'"
}`)
	CurrentBook.AddChapter(36, `{
"1":"Cette parole de Yahvé fut adressée à Jérémie en la quatrième année de Joïaqim fils de Josias, roi de Juda:"
,"2":"Prends un rouleau et écris dessus toutes les paroles que je t'ai adressées au sujet de Jérusalem et de Juda, et des autres nations, depuis le jour où j'ai commencé à te parler au temps de Josias jusqu'à ce jour."
,"3":"Peut-être les gens de Juda prendront-ils au sérieux tout le mal que j'ai décidé de leur faire, et chacun renoncera à sa mauvaise conduite. En ce cas, je leur pardonnerai toutes leurs fautes et leurs péchés."
,"4":"Jérémie fit donc venir Baruch fils de Nériya. Jérémie dictait, et Baruch écrivait sur un rouleau toutes les paroles de Yahvé qui lui étaient dictées."
,"5":"Puis Jérémie donna cet ordre à Baruch: 'On ne me permet pas d'entrer dans la Maison de Yahvé. Aussi tu iras avec le rouleau que tu as écrit sous ma dictée."
,"6":"Au prochain jour de jeûne, tu liras toutes ces paroles de Yahvé devant le peuple, dans la Maison de Yahvé. De cette façon tous les Judéens qui viennent de leurs villes l'entendront aussi."
,"7":"Peut-être leur prière montera-t-elle devant Yahvé de sorte que chacun renonce à sa mauvaise conduite, car grande est la colère, et grand le châtiment dont Yahvé a menacés ce peuple.'"
,"8":"Baruch fils de Nériya fit donc tout ce que lui avait dit le prophète Jérémie: lire ce livre et ces paroles de Yahvé dans le Temple"
,"9":"Le neuvième mois de la cinquième année de Joïaqim fils de Josias, roi de Juda, on décréta un jeûne en présence de Yahvé et l'on convoqua tout le peuple de Jérusalem ainsi que tous ceux qui pouvaient venir des villes de Juda à Jérusalem."
,"10":"C'est alors que Baruch fit devant tout le peuple la lecture publique des paroles de Jérémie qui étaient dans le livre. C'était dans la Maison de Yahvé, dans la salle de Guémaryas, fils du scribe Chafan, dans la cour supérieure, à l'entrée de la porte-neuve de la Maison de Yahvé."
,"11":"Mikayas, fils de Guémaryas fils de Chafan, entendait toutes les paroles de Yahvé écrites sur le livre."
,"12":"Il descendit donc au palais royal, dans la salle du scribe. Tous les chefs étaient là: le scribe Elichama, Délayas fils de Chémayas, Elnathan fils de Akbor, Guémaryas fils de Chafan, Sidkiyas fils de Hananyas et tous les autres chefs."
,"13":"Mikayas leur rapporta toutes les paroles qu'il avait entendues lorsque Baruch les lisait devant le peuple."
,"14":"Alors tous les chefs envoyèrent Yéhoudi, fils de Nétanyas et Chélémyas fils de Kouchi, pour qu'ils disent à Baruch: 'Prends avec toi le rouleau dans lequel tu as lu devant le peuple et viens.' Baruch fils de Nériya prit le rouleau et partit avec eux."
,"15":"Ils lui dirent: 'Assieds-toi, tu vas nous le lire.' Et Baruch en fit la lecture devant eux."
,"16":"A mesure qu'ils entendaient toutes ces paroles, ils se regardaient l'un l'autre effrayés. Ils dirent à Baruch: 'Il faut absolument que nous en parlions au roi.'"
,"17":"Puis ils interrogèrent Baruch: 'Dis-nous donc comment tu as écrit tout cela?'"
,"18":"Baruch leur répondit: 'Pendant qu'il prononçait toutes ces paroles, moi, je les écrivais sur ce livre avec de l'encre.'"
,"19":"Les chefs dirent à Baruch: 'Va te cacher avec Jérémie, et que personne ne sache où vous êtes.'"
,"20":"Après quoi ils déposèrent le rouleau dans la salle du scribe Elichama et allèrent trouver le roi dans la cour. Ils mirent le roi au courant de cette affaire."
,"21":"Alors le roi envoya Yéhoudi prendre le rouleau. Yéhoudi le ramassa dans la salle du scribe Elichama et il en fit la lecture devant le roi et devant tous les chefs qui se tenaient debout autour de lui."
,"22":"Le roi était assis dans le palais d'hiver, car on était au neuvième mois, et l'on avait allumé un réchaud devant lui."
,"23":"Lorsque Yéhoudi avait lu trois ou quatre colonnes, le roi les déchirait avec le rasoir du scribe et les jetait dans le feu du réchaud; tout le rouleau termina ainsi dans le feu du réchaud."
,"24":"Ni le roi, ni ses officiers ne se troublèrent en entendant toutes ces paroles; aucun d'eux ne déchira ses vêtements."
,"25":"Pourtant Elnathan, Délayas et Guémaryas avaient insisté auprès du roi pour qu'il ne brûle pas le rouleau, mais il ne voulut pas les écouter."
,"26":"Il ordonna même à Yérahméel fils du roi, à Sérayas fils d'Azriel, et à Chélémyas fils d'Abdéel, d'arrêter le scribe Baruch et le prophète Jérémie; mais Yahvé les avait cachés."
,"27":"Une parole de Yahvé fut alors adressée à Jérémie à propos de ce rouleau que le roi avait brûlé, où étaient toutes les paroles écrites par Baruch sous la dictée de Jérémie:"
,"28":"'Retourne acheter un autre rouleau; et tu écriras dessus toutes les paroles qui étaient sur le précédent rouleau, celui que Joïaqim, roi de Juda, a brûlé.'"
,"29":"Tu diras ceci à Joïaqim de la part de Yahvé: Tu as brûlé ce rouleau et tu as dit: Comment as-tu pu écrire: C'est décidé, le roi de Babylone viendra et détruira ce pays; il en fera disparaître hommes et bêtes."
,"30":"Eh bien, voici une parole de Yahvé au sujet de Joïaqim, roi de Juda: 'Aucun de sa famille ne s'assiéra sur le trône de David. Son cadavre sera exposé à la chaleur du jour et au froid de la nuit."
,"31":"Je punirai ses fautes et celles de sa famille et de ses serviteurs, je ferai venir sur eux, sur les habitants de Jérusalem et sur les hommes de Juda tout le mal que je leur ai annoncé et qu'ils n'ont pas voulu entendre.'"
,"32":"Alors Jérémie prit un autre rouleau et le donna à Baruch fils de Nériya, le scribe. Celui-ci écrivit sous la dictée de Jérémie toutes les paroles du livre que Joïaqim, roi de Juda, avait brûlé; il en ajouta d'autres du même style."
}`)
	CurrentBook.AddChapter(37, `{
"1":"Le roi Sédécias fils de Josias devint roi à la place de Konias, fils de Joïaqim. En effet, Nabukodonozor roi de Babylone l'avait fait roi du pays de Juda."
,"2":"Mais ni lui, ni ses serviteurs, ni les propriétaires, n'écoutèrent les paroles que Yahvé disait par la bouche du prophète Jérémie."
,"3":"Le roi Sédécias envoya Youkal fils de Chélémyas, et le prêtre Séfanyas fils de Amassé, avec ce message pour le prophète Jérémie: 'Supplie donc Yahvé notre Dieu pour nous.'"
,"4":"A ce moment, Jérémie allait et venait librement, on ne l'avait pas encore mis en prison."
,"5":"Or l'armée du Pharaon était sortie d'Egypte et, en apprenant cette nouvelle, les Kaldéens qui assiégeaient Jérusalem s'étaient éloignés de la ville."
,"6":"Le prophète Jérémie reçut alors une parole de Yahvé."
,"7":"Voici ce que dit Yahvé, Dieu d'Israël: Vous répondrez ceci au roi de Juda qui vous envoie vers moi pour me consulter: L'armée du Pharaon est bien sortie pour vous secourir, mais elle est déjà en train de retourner chez elle en Egypte,"
,"8":"et les Kaldéens vont revenir. Ils attaqueront cette ville, ils la prendront et la livreront au feu."
,"9":"Voici ce que dit Yahvé: Vous faites une lourde erreur quand vous affirmez que les Kaldéens sont partis pour de bon. Non, ils ne s'en iront pas!"
,"10":"Et même si vous pouviez écraser l'armée entière des Kaldéens qui combattent contre vous, s'il n'en restait plus que des blessés, ces hommes sortiraient encore de leurs tentes pour livrer cette ville au feu."
,"11":"L'armée des Kaldéens s'était éloignée de Jérusalem en apprenant l'avancée de l'armée du Pharaon."
,"12":"Jérémie sortit alors de Jérusalem pour se rendre au pays de Benjamin afin d'y partager un héritage avec les siens."
,"13":"Arrivé à la porte de Benjamin, il tomba sur un chef des gardes du nom de Yiréyaï, fils de Chélémyas fils de Hananyas. Celui-ci arrêta le prophète Jérémie en lui disant: 'Tu cherches à passer aux Kaldéens!'"
,"14":"Jérémie répondit: 'Ce n'est pas vrai, je ne vais pas passer aux Kaldéens.' Mais celui-ci refusa de l'écouter. Yiréyaï arrêta donc Jérémie et le conduisit aux chefs."
,"15":"Les chefs se mirent en colère contre Jérémie et le frappèrent, puis ils l'enfermèrent dans la maison du scribe Yonatan, qu'on avait transformée en prison."
,"16":"Jérémie fut enfermé dans un cachot voûté et il resta là de nombreux jours."
,"17":"De là, le roi Sédécias l'envoya chercher pour l'interroger en cachette dans son palais. Il lui dit: 'Y a-t-il une parole de Yahvé?' Jérémie lui répondit: 'Il y en a une' et il ajouta: 'Tu seras livré aux mains du roi de Babylone.'"
,"18":"Jérémie dit encore au roi Sédécias: 'Quel mal ai-je commis contre toi, contre tes officiers et contre ce peuple, pour que tu m'aies mis en prison?"
,"19":"Où sont donc vos prophètes qui vous ont annoncé que le roi de Babylone ne viendrait pas contre vous et contre ce pays?"
,"20":"A présent, monseigneur le roi, écoute, ne repousse pas ma demande: ne me fais pas retourner dans la maison du scribe Yonatan, car je vais y mourir.'"
,"21":"Le roi Sédécias donna donc l'ordre de transférer Jérémie à la cour de garde et de lui donner chaque jour une boule de pain venant de la rue des boulangers, jusqu'au jour où il n'y aurait plus de pain dans la ville. Jérémie resta donc dans la cour de garde."
}`)
	CurrentBook.AddChapter(38, `{
"1":"Chéfatyas fils de Mattan, Guédalyas fils de Pachéhour, Youkal fils de Chéléyas et Pachéhour fils de Malkiyas, entendaient les paroles que Jérémie adressait à tout le peuple:"
,"2":"'Voici ce que dit Yahvé: Celui qui restera dans cette ville périra par l'épée, la famine et la peste; mais celui qui en sortira au-devant des Kaldéens vivra. Il sauvera au moins sa vie.'"
,"3":"Et encore ceci: 'Cette ville ne manquera pas de tomber aux mains de l'armée du roi de Babylone, il s'en emparera.'"
,"4":"Les chefs dirent au roi: 'Cet homme doit être mis à mort; toutes ses paroles ne servent qu'à décourager les soldats qui restent dans cette ville et la population toute entière. Cet homme ne veut pas le salut de notre peuple, mais uniquement son malheur.'"
,"5":"Le roi Sédécias leur répondit: 'Il est à vous, le roi ne peut rien vous refuser.'"
,"6":"Ils prirent donc Jérémie et le jetèrent dans la citerne de Malkiyas fils du roi, dans la cour de garde. Ils le descendirent avec des cordes; il n'y avait pas d'eau dans cette citerne, mais de la boue, et Jérémie s'enfonça dans la boue."
,"7":"Ebed Mélek, un eunuque éthiopien attaché au service du palais royal, apprit qu'on avait mis Jérémie dans la citerne; à ce moment le roi était assis à la porte de Benjamin."
,"8":"Ebed Mélek sortit donc du palais royal et vint dire au roi:"
,"9":"'Monseigneur le roi, sais-tu comment ces hommes ont traité le prophète Jérémie? Ils l'ont jeté dans la citerne. Ils ont très mal agi car sûrement il va y mourir.'"
,"10":"Alors le roi donna cet ordre à Ebed Mélek l'Ethiopien: 'Prends avec toi trois hommes; tu feras sortir de la citerne le prophète Jérémie pour qu'il ne meure pas.'"
,"11":"Ebed Mélek prit donc ses hommes avec lui et entra dans le vestiaire du trésor qui se trouvait dans le palais royal. Là, il prit des morceaux de chiffons et de vieux habits qu'il fit descendre avec des cordes à Jérémie dans la citerne."
,"12":"Ebed Mélek l'Ethiopien dit à Jérémie: 'Mets ces morceaux de chiffon et ces vieux habits sous tes bras, et en-dessous les cordes.' C'est ce que fit Jérémie."
,"13":"Puis ils tirèrent Jérémie avec les cordes et le remontèrent hors de la citerne; après quoi Jérémie demeura dans la cour de garde."
,"14":"Le roi Sédécias envoya chercher le prophète et le fit passer chez lui par la troisième porte de la Maison de Yahvé. Le roi dit à Jérémie: 'Je vais te poser une question, ne me cache rien.'"
,"15":"Jérémie répondit à Sédécias: 'Si je te dis la vérité, tu me feras sûrement mourir, et si je te conseille, tu ne m'écouteras pas.'"
,"16":"Le roi lui fit en secret ce serment: 'Aussi vrai que Yahvé est vivant et qu'il nous donne la vie, je ne te ferai pas mourir et je ne te livrerai pas non plus à ces hommes.'"
,"17":"Jérémie dit alors à Sédécias: 'Voici ce que dit Yahvé, le Dieu Sabaot, le Dieu d'Israël: Si tu sors pour te rendre aux généraux du roi de Babylone, tu sauveras ta vie et cette ville ne sera pas livrée au feu; toi et ta famille, vous aurez la vie sauve."
,"18":"Mais si tu ne te rends pas aux généraux du roi de Babylone, cette ville tombera aux mains des Kaldéens qui y mettront le feu et tu ne leur échapperas pas.'"
,"19":"Le roi Sédécias dit à Jérémie: 'J'ai peur des Judéens qui se sont rendus aux Kaldéens, j'ai peur de tomber entre leurs mains et d'être maltraité par eux.'"
,"20":"Jérémie lui dit: 'On ne te livrera pas à eux. Ecoute plutôt cette parole de Yahvé que je viens de te dire et tu t'en tireras bien, avec la vie sauve."
,"21":"Mais si tu refuses de sortir de la ville, voici ce que Yahvé m'a fait voir:"
,"22":"Toutes les femmes qui restent encore dans le palais royal de Juda sont conduites aux généraux du roi de Babylone; et elles reprennent la chanson: Tes amis ont su comment t'avoir, te voilà les pieds dans la boue, mais eux, ils se sont dégagés."
,"23":"Voici qu'on livre aux Kaldéens tes femmes et tes fils, et toi, tu n'échappes pas à leurs mains; oui, tu seras capturé par le roi de Babylone, et il livrera cette ville au feu.'"
,"24":"Sédécias dit alors à Jérémie: 'Que personne ne sache rien de tout cela, sinon tu mourrais."
,"25":"Sans doute les chefs apprendront que j'ai parlé avec toi et ils viendront te dire: Raconte-nous ce que tu as dit au roi, ne nous cache rien si tu ne veux pas mourir; dis-nous que t'a répondu le roi?"
,"26":"Tu leur répondras: J'ai simplement supplié le roi de ne pas me faire retourner dans la maison de Yonatan, car je ne veux pas y mourir.'"
,"27":"Les chefs vinrent trouver Jérémie et l'interrogèrent, mais il leur répondit comme le roi l'avait ordonné, et ils durent se taire, car personne ne savait ce qui avait été dit."
,"28":"Jérémie resta donc dans la cour de garde jusqu'au jour où Jérusalem fut prise; il y était encore lors de la prise de Jérusalem."
}`)
	CurrentBook.AddChapter(39, `{
"1":"Le dixième mois de la neuvième année de Sédécias roi de Juda, Nabukodonozor, roi de Babylone, arriva avec toute son armée pour assiéger Jérusalem."
,"2":"Le neuvième jour du quatrième mois de la onzième année de Sédécias, une brèche fut ouverte dans le mur de la ville."
,"3":"Tous les chefs du roi de Babylone entrèrent et s'installèrent à la Porte-du-milieu; c'étaient Nergal-saréser, prince de Sin-Maguir, le grand officier, Nébouchazban, le haut dignitaire, et tous les autres chefs du roi de Babylone."
,"4":"Voyant cela, Sédécias roi de Juda et tous ses hommes prirent la fuite. De nuit ils sortirent de la ville par le Chemin-du-Jardin-du-roi; ils passèrent par la porte entre les deux murs et prirent le chemin de la steppe."
,"5":"Mais l'armée des Kaldéens les poursuivit, et elle rattrapa Sédécias dans les steppes de Jéricho. Il fut fait prisonnier et conduit à Nabukodonozor, roi de Babylone, qui était à Ribla, au pays de Hamat. Le roi de Babylone le fit passer en jugement; "
,"6":"il fit égorger les fils de Sédécias sous ses yeux à Ribla; il fit égorger également tous les chefs de Juda."
,"7":"Puis il creva les yeux de Sédécias et le fit lier avec une double chaîne de bronze pour l'emmener à Babylone."
,"8":"Les Kaldéens livrèrent au feu le palais royal et les maisons des résidents avant d'abattre les remparts de Jérusalem."
,"9":"Nébouzaradan, chef des gardes, déporta à Babylone les habitants qui restaient encore dans la ville, ceux qui s'étaient rendus à lui et le reste des artisans."
,"10":"Nébouzaradan, chef des gardes, ne laissa dans le pays de Juda que les pauvres du peuple qui n'avaient rien, et il leur distribua ce jour-là des vignes et des champs."
,"11":"Nabukodonozor, roi de Babylone, avait donné cet ordre à Nébouzaradan, chef des gardes, au sujet de Jérémie:"
,"12":"'Prends-le et vois de près sa situation. Ne lui fais aucun mal, mais au contraire fais pour lui ce qu'il te demandera.'"
,"13":"Nébouzaradan, chef des gardes, Nébouchazban, chef des eunuques, Nergal-Saréser, le grand mage, et tous les chefs du roi de Babylone"
,"14":"envoyèrent prendre Jérémie dans la cour de garde (et le remirent à Godolias, fils d'Ahikam, fils de Chafan; celui-ci l'emmena à sa maison) et Jérémie demeura ainsi au milieu du peuple."
,"15":"Une parole de Yahvé avait été adressée à Jérémie pendant qu'il était enfermé dans la cour de garde:"
,"16":"'Va, tu diras à Ebed-Mélek l'Ethiopien de la part de Yahvé Sabaot, le Dieu d'Israël: Je vais réaliser ce que j'ai promis à cette ville, pour son malheur et non pour son bonheur; tu le verras de tes propres yeux."
,"17":"Mais ce jour-là je te délivrerai - parole de Yahvé. Tu ne seras pas livré aux mains des hommes que tu redoutes."
,"18":"Sois sûr que je te sauverai, tu ne tomberas pas sous l'épée, tu sauveras au moins ta vie, car tu as eu confiance en moi - parole de Yahvé."
}`)
	CurrentBook.AddChapter(40, `{
"1":"Jérémie avait été arrêté. Il était là au milieu de tous les déportés de Jérusalem et de Juda qu'on allait emmener à Babylone, lorsque Nébouzaradan, chef des gardes, le renvoya. Et de nouveau la parole de Yahvé lui fut adressée."
,"2":"Le chef des gardes prit à part Jérémie pour lui dire: 'Yahvé ton Dieu a prédit le malheur qui frapperait ce lieu."
,"3":"Yahvé a fait cela parce que vous avez péché contre lui; tout cela vous est arrivé parce que vous n'avez pas écouté sa voix."
,"4":"Maintenant donc, je te libère de tes chaînes. S'il te paraît bon de venir avec moi à Babylone, viens et je veillerai sur toi, mais si cela ne te convient pas, tu peux ne pas venir avec moi à Babylone. Vois, tout le pays t'est ouvert, va où il te semblera bon et juste d'aller.'"
,"5":"Et comme Jérémie ne partait pas encore, Nébouzaradan lui dit: 'Retourne donc vers Godolias, fils d'Ahikam fils de Chafan, que le roi de Babylone a établi comme gouverneur des villes de Juda. Reste avec lui au milieu du peuple, ou bien va dans tout autre endroit qui te semblera bon.' Le commandant de la garde lui donna de la nourriture et un cadeau, puis il le renvoya."
,"6":"Jérémie se rendit donc auprès de Godolias fils d'Ahikam, à Mispa, et il resta avec lui au milieu des gens du peuple qu'on avait laissés dans le pays."
,"7":"Tous les chefs de l'armée qui tenaient encore la campagne avec leurs hommes apprirent que le roi de Babylone avait établi Godolias fils d'Ahikam comme gouverneur sur le pays; il lui avait confié les hommes, les femmes et les enfants, tous ceux du petit peuple qui n'avaient pas été déportés à Babylone."
,"8":"Ils vinrent donc trouver Godolias à Mispa: c'était Ismaël fils de Nétanyas, Yohanan fils de Karéa, Séraya fils de Tanhoumet, les fils de Efaï le Nétofatite, Yizanyas fils du Maakatite, avec leurs hommes."
,"9":"Godolias fils d'Ahikam, fils de Chafan, leur jura à eux et à leurs hommes: 'N'ayez pas peur, faites votre soumission aux Kaldéens. Vous resterez dans le pays, vous serez soumis au roi de Babylone et tout ira bien pour vous."
,"10":"Quant à moi, je m'installe à Mispa comme responsable vis à vis des Kaldéens qui sont venus chez nous. Faites donc la récolte du vin, des fruits et de l'huile; vous les mettrez en réserve dans vos jarres et vous resterez dans les villes que vous occupez.'"
,"11":"Tous les Judéens qui étaient au pays de Moab, chez les Ammonites ou en Edom, apprirent dans ces différents pays que le roi de Babylone avait laissé un reste à Juda, et qu'il avait établi sur eux Godolias, fils d'Ahikam fils de Chafan."
,"12":"Tous ces Judéens, donc, revinrent de tous les endroits où ils étaient dispersés; ils arrivèrent au pays de Juda auprès de Godolias, à Mispa et ils recueillirent le vin et les fruits en grande quantité."
,"13":"Yohanan fils de Karéa et tous les chefs de l'armée qui étaient dans la campagne, vinrent trouver Godolias à Mispa."
,"14":"Ils lui dirent: 'Sais-tu que Baalis, roi des Ammonites, a envoyé Ismaël fils de Nétanya pour te tuer.' Mais Godolias fils d'Ahikam refusa de les croire."
,"15":"Alors Yohanan fils de Karéa dit en secret à Godolias, à Mispa: 'J'irai frapper Ismaël fils de Nétanya, et personne ne le saura. S'il venait à te frapper, tous les Judéens qui se sont réunis autour de toi se disperseraient. Il ne faut pas que le reste de Juda disparaisse.'"
,"16":"Mais Godolias fils d'Ahikam, répondit à Yohanan fils de Karéa: 'Ne fais pas cela; ce que tu dis au sujet d'Ismaël est sûrement faux.'"
}`)
	CurrentBook.AddChapter(41, `{
"1":"Or, au cours du septième mois, Ismaël fils de Netanya, fils d'Elichama, qui était de la famille royale, arriva avec dix hommes pour rencontrer Godolias fils d'Ahikam à Mispa. Ils prirent ensemble un repas à Mispa,"
,"2":"et c'est alors qu'Ismaël, fils de Netanya et les dix hommes qui étaient avec lui se levèrent pour frapper de leur épée Godolias fils d'Ahikam, fils de Chafan, que le roi de Babylone avait établi sur le pays."
,"3":"Ismaël frappa aussi tous les Judéens qui étaient avec Godolias à Mispa, ainsi que les Kaldéens qui se trouvaient là, tous hommes de guerre."
,"4":"Deux jours après l'assassinat de Godolias, comme personne ne le savait encore,"
,"5":"des hommes de Sichem, de Silo et de Samarie, arrivèrent au nombre de quatre-vingts; ils avaient la barbe rasée, les habits déchirés, le corps couverts d'entailles et ils portaient en mains une offrande et de l'encens pour le Temple de Yahvé."
,"6":"Ismaël fils de Netanya sortit de Mispa à leur rencontre alors qu'ils arrivaient en se lamentant, et il leur dit: 'Venez-voir Godolias fils d'Ahikam!'"
,"7":"Mais comme ils arrivaient au milieu de la ville, Ismaël fils de Netanya, avec la troupe qui l'accompagnait, entreprit d'égorger ces hommes au-dessus de la citerne."
,"8":"Une dizaine d'entre eux dirent à Ismaël: 'Ne nous fais pas mourir! Nous avons des provisions cachées dans la campagne, du blé, de l'orge, de l'huile et du miel.' Alors Ismaël arrêta le massacre et ils ne furent pas mis à mort comme leurs frères."
,"9":"La citerne où Ismaël jeta les cadavres de ces hommes qu'il avait tués, était la grande citerne que le roi Asa avait fait creuser à cause de Bacha, roi d'Israël. Ismaël fils de Netanya la remplit de ses victimes."
,"10":"Puis Ismaël emmena vers l'exil tout le reste du peuple qui était à Mispa, avec les filles du roi et tous ceux du peuple qui étaient encore à Mispa; tous ceux que Nébouzaradan, chef des gardes, avait confiés à Godolias fils d'Ahikam. Ismaël fils de Netanya les fit lever de bon matin pour se rendre chez les Ammonites."
,"11":"Yohanan fils de Karéa et tous les chefs de l'armée qui étaient avec lui apprirent tout le mal qu'Ismaël fils de Netanya avait fait."
,"12":"Ils prirent tous leurs hommes et allèrent attaquer Ismaël fils de Netanya; ils le rencontrèrent aux Grandes-Eaux de Gabaon."
,"13":"En apercevant Yohanan fils de Karéa et tous les chefs de l'armée qui l'accompagnaient, ceux qui étaient avec Ismaël furent remplis de joie."
,"14":"Tous le peuple qu'Ismaël emmenait de Mispa vers l'exil changea de camp; ils se retournèrent et partirent vers Yohanan fils de Karéa."
,"15":"Quant à Ismaël fils de Netanya, il prit la fuite devant Yohanan et arriva chez les Ammonites avec huit hommes."
,"16":"Yohanan fils de Karéa et tous les chefs de l'armée qui étaient avec lui prirent avec eux le reste du peuple qu'ils avaient repris à Ismaël fils de Netanya: c'était ceux qu'il avait emmenés de Mispa après avoir tué Godolias fils d'Ahikam; il y avait là des hommes de guerre, des femmes, des petits enfants et des eunuques qu'il avait ramenés de Gabaon."
,"17":"Ils se mirent en route et s'arrêtèrent au Khan de Kimhan, près de Bethléhem; ensuite ils voulurent gagner l'Egypte"
,"18":"à cause des Kaldéens. Ils en avaient peur du fait qu'Ismaël fils de Netanya avait tué Godolias fils d'Ahikam, que le roi de Babylone avait établi sur le pays."
}`)
	CurrentBook.AddChapter(42, `{
"1":"Les chefs de l'armée, Yohanan fils de Karéa, et Azaryas fils de Hochayas, vinrent alors trouver le prophète Jérémie avec tout le peuple, petits et grands,"
,"2":"et ils lui dirent: 'Ecoute notre demande! Prie Yahvé ton Dieu pour nous et pour tout ce reste. Comme tu peux le voir toi-même, nous restons bien peu sur tout le nombre que nous étions."
,"3":"Que Yahvé ton Dieu nous montre le chemin que nous devons suivre et ce que nous devons faire.'"
,"4":"Le prophète Jérémie leur dit: 'J'ai entendu; oui, je vais prier Yahvé votre Dieu selon votre demande, et tout ce que Yahvé répondra à votre sujet, je vous le ferai savoir. Je ne vous cacherai rien.'"
,"5":"Ils dirent encore à Jérémie: 'Nous nous engageons à faire ce que Yahvé, ton Dieu, nous dira à travers toi: que Yahvé en soit le témoin vrai et fidèle."
,"6":"Que ce soit facile ou non à accepter, nous écouterons la voix de Yahvé notre Dieu que nous t'envoyons consulter. Car nous ne pouvons réussir que si nous écoutons la voix de Yahvé notre Dieu.'"
,"7":"Au bout de dix jours, la parole de Yahvé fut adressée à Jérémie."
,"8":"Il appela Yohanan fils de Karéa et tous les chefs de l'armée qui étaient avec lui, ainsi que tout le peuple, du plus petit jusqu'au plus grand."
,"9":"Il leur dit: 'Voici ce que dit Yahvé, le Dieu d'Israël, vers lequel vous m'avez envoyé, et à qui j'ai transmis votre demande:"
,"10":"Si vous restez pour de bon dans ce pays, je vous rétablirai après vous avoir détruits, je vous planterai après vous avoir déracinés, et même je regretterai tout le mal que je vous ai fait."
,"11":"N'ayez pas peur du roi de Babylone devant lequel vous tremblez; n'ayez pas peur de lui - parole de Yahvé - car je suis avec vous pour vous sauver et pour vous délivrer de sa main."
,"12":"Je vous accorderai la pitié et il aura pitié de vous; il vous fera revenir sur votre terre."
,"13":"Mais si vous n'écoutez pas la voix de Yahvé votre Dieu,"
,"14":"et qu'au lieu de cela vous dites: Nous ne resterons pas dans ce pays; c'est au pays d'Egypte que nous irons, là nous ne verrons plus la guerre, nous n'entendrons plus le son de la trompette, nous ne connaîtrons plus la faim de pain, c'est là que nous resterons -"
,"15":"alors, écoutez la parole de Yahvé. Reste-de-Juda, voici ce que dit Yahvé Sabaot, le Dieu d'Israël: Si vous tournez vos regards vers l'Egypte, si vous y entrez pour vous y installer, "
,"16":"l'épée dont vous avez peur vous rejoindra là, au pays d'Egypte, et la famine que vous redoutez s'attachera à vous en Egypte; c'est là que vous mourrez."
,"17":"Tous les hommes qui auront tourné leur regard vers l'Egypte pour s'y installer, mourront par l'épée, la famine et la peste. Il n'y aura ni survivant, ni fuyard, quand j'amènerai sur eux le malheur."
,"18":"Oui, voici ce que dit Yahvé Sabaot, le Dieu d'Israël: Vous avez vu comment ma violente colère s'est déchaînée contre les habitants de Jérusalem; de même ma fureur se déchaînera contre vous lorsque vous entrerez en Egypte; vous deviendrez une honte et une ruine, une malédiction et une moquerie, et vous ne reverrez plus ce lieu."
,"19":"Voilà ce que Yahvé a annoncé à votre sujet, Reste-de-Juda. N'entrez pas en Egypte. Sachez bien qu'aujourd'hui je vous avertis solennellement."
,"20":"Vous vous trompiez vous-mêmes lorsque vous m'avez envoyé vers Yahvé votre Dieu, et que vous m'avez dit: Prie Yahvé notre Dieu pour nous, et tout ce que Yahvé notre Dieu dira, dis-le nous et nous le ferons."
,"21":"Vous voyez, aujourd'hui je vous l'annonce mais vous n'écoutez pas Yahvé votre Dieu et toutes ces paroles qu'il vous adresse par moi."
,"22":"Maintenant, sachez-le bien, vous mourrez par l'épée, la famine et la peste dans ce lieu où vous voulez aller et vous installer."
}`)
	CurrentBook.AddChapter(43, `{
"1":"Jérémie avait achevé de dire au peuple toutes les paroles de Yahvé leur Dieu, toutes ces paroles pour lesquelles Yahvé leur Dieu l'avait envoyé."
,"2":"Alors Azaryas fils d'Hochayas, Yohanan fils de Karéa et tous les prétentieux qui étaient avec eux, dirent à Jérémie: 'C'est faux ce que tu nous dis, Yahvé notre Dieu ne t'a pas envoyé pour nous dire: N'entrez pas en Egypte pour vous y installer."
,"3":"C'est Baruch fils de Nériya, qui t'excite contre nous: nous allons être livrés aux mains des Kaldéens, et ce sera pour nous la mort et la déportation à Babylone.'"
,"4":"C'est ainsi que Yohanan fils de Karéa, tous les chefs de l'armée et le peuple, refusèrent d'écouter la voix de Yahvé et de rester dans le pays de Juda."
,"5":"Yohanan fils de Karéa et tous les chefs de l'armée, prirent donc ce qui restait de Juda, ceux qui étaient revenus de toutes les nations où ils avaient été dispersés, pour s'installer dans le pays de Juda."
,"6":"Il y avait là des hommes et des femmes, des petits enfants, les filles du roi, et tous ceux que Nébouzaradan, chef des gardes, avait laissés autour de Godolias fils d'Ahikam, fils de Chafan, avec le prophète Jérémie et Baruch fils de Nériya."
,"7":"Au lieu d'écouter la voix de Yahvé, ils partirent pour l'Egypte et s'installèrent à Tahpahnes."
,"8":"Une parole de Yahvé fut adressée à Jérémie à Tahpahnes:"
,"9":"'Prends dans tes mains de grandes pierres; sous les yeux des Judéens, tu les enterreras dans le mortier, dans la fabrique de briques qui est à l'entrée du palais du Pharaon à Tahpahnes;"
,"10":"puis tu leur diras: Sachez que je vais envoyer chercher mon serviteur Nabukodonozor, roi de Babylone. Il placera son trône sur ces pierres que j'ai enterrées, et il y dressera son baldaquin."
,"11":"Il viendra et frappera l'Egypte: celui qui est pour la mort, mourra, celui qui est pour la captivité, ira à l'exil."
,"12":"Il mettra le feu aux temples des dieux égyptiens, il les brûlera et les emmènera prisonniers; il s'enveloppera de l'Egypte, comme le berger s'enveloppe de son manteau et il s'en ira tranquillement."
,"13":"Il brisera les obélisques du temple du soleil et livrera au feu les temples des dieux d'Egypte."
}`)
	CurrentBook.AddChapter(44, `{
"1":"Voici la parole qui fut adressée à Jérémie à propos de tous les Judéens qui habitaient en Egypte: ceux de Migdol, de Tahpahnes, de Nof et du pays de Patros."
,"2":"Voici ce que dit Yahvé Sabaot, le Dieu d'Israël: 'Vous avez vu tout le malheur que j'ai fait venir sur Jérusalem et sur toutes les villes de Juda. Aujourd'hui elles sont en ruines et sans habitants."
,"3":"C'est qu'ils m'avaient mis en colère avec tout le mal qu'ils commettaient: ils sont allés encenser et servir des dieux étrangers qu'ils ne connaissaient pas, ni eux, ni leurs pères."
,"4":"Je n'ai pas cessé de leur envoyer tous mes serviteurs les prophètes, pour leur dire: Ne faites donc pas cette chose honteuse que je déteste!"
,"5":"Mais ils n'ont pas écouté, ils n'ont pas prêté l'oreille, ils ne sont pas revenus de leurs actions mauvaises, ils n'ont pas cessé d'encenser les dieux étrangers."
,"6":"Alors s'est enflammé le feu de ma colère, il a brûlé les villes de Juda et les rues de Jérusalem; il en a fait une ruine, un désert, comme on le voit en ce jour."
,"7":"Et maintenant, voici ce que dit Yahvé, le Dieu Sabaot, le Dieu d'Israël: Pourquoi vous faites-vous du mal à vous-mêmes? Voulez-vous que Juda soit privé d'hommes et de femmes, d'enfants et de nourrissons, au point qu'il n'en reste rien?"
,"8":"Pourquoi agissez-vous de façon à me mettre en colère? N'offrez pas d'encens aux dieux étrangers en cette Egypte où vous êtes venus vous installer. Voulez-vous donc disparaître et devenir une malédiction et une moquerie pour toutes les nations de la Terre?"
,"9":"Avez-vous oublié les crimes de vos pères, les crimes des rois de Juda et les crimes de ses chefs, les crimes que vous et vos femmes avez commis en Juda et dans les rues de Jérusalem?"
,"10":"On ne s'est pas repenti jusqu'à ce jour, on n'a pas suivi ma loi et mes commandements que j'avais placés devant vous et devant vos pères."
,"11":"C'est pourquoi, voici ce que dit Yahvé Sabaot, le Dieu d'Israël: Je me tourne contre vous pour votre malheur et je vais supprimer tout Juda."
,"12":"Je prendrai ce qui reste de Juda, ceux qui ont décidé d'aller en Egypte pour s'y installer, et ils périront tous. Ils tomberont en Egypte, ils y mourront par l'épée et par la famine: du plus petit jusqu'au plus grand, tous mourront par l'épée et par la famine. Ils seront un exemple de malédiction, de déchéance; on ne fera que s'en moquer."
,"13":"Je m'en prendrai à ceux qui habitent en Egypte comme je m'en suis pris à Jérusalem, avec l'épée, la famine et la peste."
,"14":"De tous ceux qui restent de Juda et qui sont entrés en Egypte pour s'y installer, avec l'espoir de retourner en Juda, il n'y aura ni fuyard ni survivant."
,"15":"Tous les hommes qui savaient que leurs femmes encensaient des dieux étrangers, toutes les femmes qui étaient là et tout le peuple qui habitait à Patros, en Egypte - cela faisait beaucoup de monde - répondirent alors à Jérémie:"
,"16":"'Nous ne te suivrons pas dans ce que tu nous dis au nom de Yahvé."
,"17":"Nous ferons comme nous l'avons décidé, nous brûlerons l'encens pour la reine des cieux et nous lui offrirons des libations. Nous le faisions bien, nous et nos pères, nos rois et nos chefs, dans les villes de Juda et dans les rues de Jérusalem, et alors nous avions du pain comme nous voulions, nous étions heureux et nous ne connaissions pas le malheur."
,"18":"Mais dès que nous avons cessé d'encenser la reine des cieux et de lui offrir des libations, nous avons manqué de tout et nous sommes morts par l'épée et par la famine."
,"19":"D'ailleurs, lorsque nous encensons la reine des cieux et que nous lui offrons des libations, ce n'est pas en cachette de nos maris que nous faisons ces gâteaux à son image et que nous préparons ces libations.'"
,"20":"Alors Jérémie prit la parole et dit à tout le peuple, aux hommes, aux femmes et à tous les gens qui lui avaient répliqué:"
,"21":"'C'est tout le contraire: cet encensement que vous pratiquiez dans les villes de Juda et dans les rues de Jérusalem, vous, vos pères, vos rois et vos chefs, et tout le peuple du pays, Yahvé s'en est souvenu et tout lui est revenu à la mémoire."
,"22":"Yahvé ne peut plus supporter le spectacle des mauvaises actions et des horreurs que vous commettez; c'est pourquoi votre pays est devenu une ruine, un désert, une malédiction, privé d'habitants comme il l'est aujourd'hui."
,"23":"Avec votre encens vous avez péché contre Yahvé; vous n'avez pas écouté la voix de Yahvé et vous n'avez pas suivi sa Loi, ses commandements et ses préceptes; c'est pourquoi ce malheur vous est arrivé comme on le voit aujourd'hui.'"
,"24":"Jérémie dit encore à tout le peuple et à toutes les femmes: 'Ecoutez la parole de Yahvé, vous tous Judéens qui êtes en Egypte."
,"25":"Voici ce que dit Yahvé Sabaot, le Dieu d'Israël: Vous, les femmes, faites donc comme vous l'avez décidé. Vous avez dit: Nous accomplirons les voeux que nous avons faits, nous encenserons la reine des cieux et nous lui offrirons des libations. Eh bien, honorez donc vos promesses, faites ce que vous avez promis!"
,"26":"Mais écoutez cette parole de Yahvé, vous tous Judéens qui habitez en Egypte: Voici ce que moi, j'ai juré par mon grand Nom. Mon nom - dit Yahvé - ne sera plus prononcé par aucun homme de Juda dans tout le pays d'Egypte; aucun d'eux ne dira plus: Vive le Seigneur Yahvé!"
,"27":"Je vais m'occuper d'eux pour le malheur et non pour leur faire du bien; tous les hommes de Juda qui sont en Egypte disparaîtront par l'épée et par la famine, jusqu'au dernier."
,"28":"(Un tout petit nombre d'hommes qui aura échappé à l'épée, reviendra d'Egypte au pays de Juda). Tous ceux de Juda qui sont en Egypte sauront alors quelle est la parole qui se réalise: la mienne ou la leur."
,"29":"Voici le signe - parole de Yahvé - qui vous permettra de savoir que je viens vous visiter ici et que les paroles de menaces que j'ai prononcées contre vous se réaliseront."
,"30":"Vous avez vu comment j'ai livré Sédécias, roi de Juda, aux mains de Nabukodonozor, roi de Babylone, son ennemi qui en voulait à sa vie; de même je vais livrer Hofra, le Pharaon d'Egypte, aux mains de ses ennemis qui en veulent à sa vie."
}`)
	CurrentBook.AddChapter(45, `{
"1":"En la quatrième année de Joïaqim, fils de Josias, roi de Juda, Baruch fils de Nériya, écrivait ces paroles dans un livre, sous la dictée de Jérémie. Voici ce que le prophète Jérémie dit alors à Baruch:"
,"2":"'Ecoute une parole de Yahvé Dieu d'Israël à ton sujet, Baruch:"
,"3":"Tu dis: Que je suis malheureux! Yahvé m'envoie épreuve sur épreuve, je suis épuisé à force de gémir; je ne connais aucun repos!"
,"4":"Eh bien, Yahvé te fait dire: Tu vois que je démolis ce que j'ai construit et je déracine ce que j'ai planté, et c'est le pays tout entier."
,"5":"Et tu voudrais pour toi de grandes choses? Ne cherche donc pas. Je fais venir le malheur sur tout le monde - parole de Yahvé, mais à toi, je t'assure au moins la vie sauve dans tous les lieux où tu iras.'"
}`)
	CurrentBook.AddChapter(46, `{
"1":"Voici des paroles de Yahvé au prophète Jérémie à propos des nations étrangères."
,"2":"Parole concernant l'Egypte et l'armée du Pharaon Nékao, roi d'Egypte, alors qu'il était à Karkémich sur les rives de l'Euphrate. Il y fut battu par Nabukodonozor, roi de Babylone, en la quatrième année de Joïaqim fils de Josias, roi de Juda."
,"3":"Préparez le petit et le grand bouclier, et marchez au combat;"
,"4":"attelez les chevaux,cavaliers, montez!,alignez-vous, casque en tête, fourbissez vos lances, attachez vos cuirasses!"
,"5":"Mais que vois-je?,Ils ont peur, ils tournent bride; les plus braves sont mis en fuite, ils fuient sans se retourner. Partout c'est la panique - parole de Yahvé."
,"6":"Le plus agile ne peut échapper, le plus brave ne se sauve pas!,Au nord, sur les rives de l'Euphrate, ils ont trébuché, ils sont tombés."
,"7":"Qui donc montait comme le Nil, comme un fleuve aux eaux bouillonnantes?"
,"8":"Elle disait: 'Je vais monter, recouvrir la terre, emporter les villes avec leurs habitants.'"
,"9":"Cavaliers, chargez! Chars, partez!,Et vous les braves, montrez-vous, gens de Kouch et de Pout avec vos boucliers, et vous Lydiens habiles à manier l'arc!"
,"10":"Mais le Seigneur Yahvé aujourd'hui a son jour de vengeance contre ses adversaires. L'épée dévore et veut se rassasier, s'enivrer du sang des victimes; le Seigneur Yahvé célèbre un sacrifice aux rives de l'Euphrate sur les terres du nord."
,"11":"Iras-tu chercher un baume en Galaad, vierge, fille d'Egypte; en vain tu multiplies les remèdes, pour toi il n'y a pas de guérison!"
,"12":"Les nations ont appris ta défaite, les échos de ta chute ont rempli le monde, car un guerrier a trébuché sur l'autre, ils sont tombés tous ensemble!"
,"13":"Voici la parole que Yahvé adressa au prophète Jérémie lorsque Nabukodonozor roi de Babel vint combattre l'Egypte:"
,"14":"Annoncez-le à Migdol, faites-le savoir à Nof et à Tahpahnes, dites leur de se lever, de se préparer, car déjà l'épée a dévoré les environs."
,"15":"Pourquoi Apis s'est-il enfui?,Ton taureau n'a-t-il pu résister?,Mais non, Yahvé l'a bousculé,"
,"16":"il a chancelé, il est tombé. L'un à l'autre ils se disent: 'Debout, regagnons notre peuple, notre terre natale, fuyons les ravages de l'épée!'"
,"17":"Donnez ce nom à Pharaon, roi d'Egypte: 'Bien du bruit quand il est trop tard'."
,"18":"Aussi vrai que je vis - parole du Roi, qui s'appelle Yahvé Sabaot, vient un guerrier, un ennemi, semblable au Tabor parmi les montagnes, comme le Carmel au dessus de la mer."
,"19":"Fais donc tes bagages d'exilée, habitante de l'Egypte!,Nof bientôt est en ruines, la voilà dévastée, sans habitants!"
,"20":"L'Egypte était une belle génisse, mais un taon est arrivé du nord."
,"21":"On voyait chez elle ses mercenaires, comme des veaux à l'engrais sur ses terres; même eux ont tourné le dos, tous ont lâché pied et se sont enfuis; c'est que le jour fatal était arrivé, celui des règlements de compte."
,"22":"Elle siffle comme serpent qui s'enfuit, car vers elle on arrive en force, pour l'abattre avec la hache, comme fait pour l'arbre le bûcheron."
,"23":"Ils ont coupé sa forêt - parole de Yahvé, on ne pouvait y pénétrer; Ils sont venus comme des sauterelles, si nombreux qu'on ne peut les compter."
,"24":"La fille de l'Egypte est couverte de honte, elle s'est vue livrée au peuple du nord."
,"25":"Voici ce que dit Yahvé Sabaot, le Dieu d'Israël: Je m'en vais visiter Amon de No et le Pharaon, l'Egypte avec ses dieux et ses rois; le Pharaon et tous ceux qui mettent en lui leur confiance."
,"26":"Je les livrerai aux mains de ceux qui en veulent à leur vie; aux mains de Nabukodonozor roi de Babel, et aux mains de ses serviteurs. Mais ensuite l'Egypte sera habitée comme elle l'était autrefois - parole de Yahvé."
,"27":"Quant à toi, mon serviteur Jacob, ne crains pas; ne tremble pas Israël, car je viens pour te sauver des pays lointains et ramener tes descendants de leur exil; Jacob reviendra et connaîtra la paix; il sera en sécurité, nul ne l'inquiétera."
,"28":"Sois sans crainte Jacob, mon serviteur - parole de Yahvé, car je suis avec toi. Je détruirai toutes les nations où je t'avais dispersé, mais toi je ne te détruirai pas; je te corrigerai avec justice, ce ne sera pas ma vengeance."
}`)
	CurrentBook.AddChapter(47, `{
"1":"Voici la parole de Yahvé qui fut adressée au prophète Jérémie, à propos des Philistins, avant la destruction de Gaza par le Pharaon."
,"2":"Voici ce que dit Yahvé: Les eaux montent du nord, c'est un torrent qui déborde; il déborde sur le pays et tout ce qui s'y trouve, sur la ville et tous ceux qui l'habitent. Dans le pays on pousse des cris, les habitants se lamentent;"
,"3":"les sabots des chevaux frappent le sol, on entend les chars, un vacarme de roues. Les pères en oublient leurs fils, tellement le courage leur manque,"
,"4":"car voici que le jour est venu,où sont détruits tous les Philistins, où l'on enlève de Tyr, et de Sidon, tout ce qui peut servir encore. Oui, Yahvé ravage les Philistins,et ce qui reste de l'île de Kaftor."
,"5":"On a rasé Gaza, Ashkélon s'est tue; Ashdod, cité des Anaqim, te feras-tu longtemps encore tes incisions?"
,"6":"Hélas! Epée de Yahvé, qu'attends-tu pour te reposer?,Reviens donc au fourreau, arrête et calme-toi!"
,"7":"Mais comment pourrait-elle se calmer, si Yahvé lui a donné des ordres?,Vers Ashkélon et le rivage de la mer, il lui a fixé sa tâche."
}`)
	CurrentBook.AddChapter(48, `{
"1":"A propos de Moab, voici ce que dit Yahvé Sabaot, le Dieu d'Israël: Malheur à Nébo, elle est saccagée, honte à Kiryatayim, elle été prise, la Citadelle a été violée,"
,"2":"la gloire de Moab n'est plus!,A Heshbon, on a préparé sa chute: 'Venez, rayons-la des villes du pays!',Toi aussi, Madmen, réduite au silence!,derrière toi arrive l'épée."
,"3":"Un cri monte d'Horonaïm: 'Ruine et grande défaite!'"
,"4":"Moab est brisé, jusqu'à Soar on entend ses cris."
,"5":"On prend en pleurant la montée de Louhit; dans la descente d'Horonaïm, on pousse des cris de détresse."
,"6":"Fuyez, sauvez votre vie, imitez l'âne sauvage au désert!"
,"7":"Tu comptais sur tes oeuvres et sur tes richesses, mais toi aussi tu seras prise. Kémoch partira en exil,avec ses prêtres et ses chefs."
,"8":"Le destructeur s'est jeté sur ses villes; aucune ne sera épargnée. La vallée sera dévastée et le plateau saccagé, comme Yahvé l'a dit."
,"9":"Donnez des ailes à Moab,pour qu'il puisse s'envoler!,Ses villes deviendront un désert,et plus personne n'y demeurera."
,"10":"Maudissez qui fait à moitié le travail de Yahvé, maudissez celui qui prive de sang son épée!"
,"11":"Moab était en paix depuis sa jeunesse, reposant sur sa lie comme un vin,que l'on n'a pas vidé de cruche en cruche. Jamais il n'était allé en exil, c'est pourquoi il gardait son goût,et son arôme lui restait."
,"12":"Mais voici que des jours viennent - parole de Yahvé, où j'enverrai chez lui ceux qui le passeront de vase en cruche: ils videront ces vases et briseront ces cruches!"
,"13":"Alors Moab aura honte de Kémoch, comme la maison d'Israël a eu honte de Béthel en qui elle mettait sa confiance."
,"14":"Comment pouvez-vous dire: Nous sommes des braves, nous sommes vaillants à la guerre?"
,"15":"Moab a été dévastée, on a pris ses villes d'assaut; les meilleurs de ses jeunes sont descendus à la boucherie - parole du roi dont le nom est Yahvé Sabaot."
,"16":"La ruine de Moab est proche, son malheur ne saurait tarder."
,"17":"Plaignez-le, vous tous qui l'entourez, vous qui connaissez son nom; dites: 'Comment, on l'a brisé, ce bâton puissant, ce sceptre magnifique?'"
,"18":"Descends de ta gloire, assieds-toi sur le sol brûlé, fille de Dibon trop bien installée!,Le fléau de Moab est monté contre toi, il a détruit tes forteresses."
,"19":"Poste-toi sur la route et guette, toi qui habites Aroër, interroge le fuyard et le rescapé, dis-leur: 'Que s'est-il passé?'"
,"20":"Moab a été battu, humilié. Lamente-toi et pousse des cris, annonce dans l'Arnon que Moab est dévasté!"
,"21":"Le jugement est venu contre le plateau, contre Holon, Yahsa, Méfaat,"
,"22":"Dibon, Nébo, Beth-Diblatayim,"
,"23":"Kiryatayim, Beth-Gamoul, Beth-méon,"
,"24":"Kériyot, Bosra - contre toutes les villes du pays de Moab, les plus lointaines comme les plus proches."
,"25":"La puissance de Moab va être abattue, et son bras, brisé - parole de Yahvé."
,"26":"Enivrez-le parce qu'il s'est dressé contre Yahvé. Que Moab se roule dans son vomissement et qu'on se moque de lui."
,"27":"Est-ce que tu ne te moquais pas d'Israël? Mais avait-il été surpris parmi des voleurs, pour que tu secoues la tête chaque fois que tu parlais de lui?"
,"28":"Laissez vos villes et campez dans les rochers, habitants de Moab, comme la colombe qui accroche son nid,sur la paroi d'une gorge profonde!"
,"29":"Nous avons appris l'orgueil de Moab, du très orgueilleux Moab, ses prétentions, sa fierté, son insolence, et l'arrogance de son coeur."
,"30":"Je connais sa suffisance,- parole de Yahvé, ses bavardages qui ne mènent à rien."
,"31":"C'est pourquoi je me lamente sur Moab, je pousse des cris pour tous ceux de Moab, je gémis sur les habitants de Kir-Héres."
,"32":"Je pleure sur toi comme sur Yazer, vignoble de Sidma. Tes branches s'étendaient au-delà de la mer, elles atteignaient Yazer; mais sur ta récolte et sur ta vendange, le fléau s'est abattu."
,"33":"La joie et la fête ont disparu,des vergers et des champs de Moab; j'ai fait se terminer le vin des cuves, et les fouleurs ne foulent plus, on n'entend plus leurs cris joyeux."
,"34":"Les clameurs d'Heshbon atteignent Eléalé et Yahas; depuis Soar jusqu'à Horonahim et Eglat-Chélichiya on a repris la lamentation, car les Eaux de Nimrim aussi ont été saccagées."
,"35":"Je ferai disparaître de Moab - oracle de Yahvé, celui qui sur un Haut-Lieu offre ses victimes, et celui qui encense ses dieux."
,"36":"Voilà pourquoi pleure mon coeur, comme une flûte, pour Moab; comme une flûte je pleure, pensant aux gens de Kir Hérès: ont-ils donc perdu toutes leurs épargnes?"
,"37":"Ce ne sont que têtes tondues, barbes rasées; on voit sur toutes les mains des incisions, et sur les reins des sacs!"
,"38":"Sur les terrasses de Moab, sur toutes ses places, on entend des lamentations, car j'ai brisé Moab comme un vase dont on ne veut plus - parole de Yahvé."
,"39":"Comment, il s'est laissé briser? Moab a-t-il honteusement tourné le dos? Moab est devenu la risée, la moquerie de tous ses voisins."
,"40":"Voici en effet ce que dit Yahvé: Voyez cet aigle qui monte et qui tourne, il étend ses ailes au-dessus de Moab."
,"41":"Les villes sont prises,et les forteresses enlevées; le coeur des guerriers de Moab est en ce jour, comme le coeur d'une femme qui enfante."
,"42":"Moab est détruit, ce n'est plus un peuple, lui qui se voulait plus fort que Yahvé."
,"43":"La terreur, la fosse et le piège: voilà pour toi, habitant de Moab!,- parole de Yahvé."
,"44":"Qui fuit la terreur, tombera dans la fosse, qui remonte de la fosse se prendra au piège. C'est là ce que j'enverrai à Moab, quand viendra l'an de mon inspection, - parole de Yahvé."
,"45":"Les fuyards se sont arrêtés,sans forces, à l'abri de Heshbon. Mais de Heshbon sort un feu, une flamme, des palais de Sihon; voici qu'elle dévore les tempes de Moab, le crâne de ce monde tapageur."
,"46":"Malheur à toi, Moab, c'est la fin du peuple de Kémoch!,Oui, tes fils sont partis en exil,et tes filles ont été emmenées."
,"47":"Mais à la fin des jours je ramènerai les exilés de Moab, - parole de Yahvé. Voilà le jugement de Moab."
}`)
	CurrentBook.AddChapter(49, `{
"1":"Pour les fils d'Ammon. Voici ce que dit Yahvé: Israël n'a-t-il pas de fils? N'a-t-il pas d'héritiers? Pourquoi Milkom a-t-il hérité du pays de Gad, pourquoi son peuple en occupe-t-il les villes?"
,"2":"Eh bien, dit Yahvé, le jour vient où l'on entendra le cri de guerre dans Rabba-des-Ammonites; elle ne sera plus qu'une ruine déserte et ses villages seront incendiés. Alors Israël dépouillera ceux qui l'ont dépouillé."
,"3":"Ar est détruite, lamente-toi Heshbon! Poussez des cris, filles de Rabba! Habillez-vous de sacs, entonnez la lamentation en vous tailladant le corps: car Milkom part en exil avec ses prêtres et tous ses chefs."
,"4":"Tu es bien fière de ta vallée, fille rebelle; tu dis, confiante en tes richesses: Qui entrera chez moi?"
,"5":"Eh bien, je t'amène de tous les côtés la terreur. Je ferai que chacun se sauve de son côté, et personne ne rassemblera les fuyards."
,"6":"Mais ensuite je ramènerai les exilés d'Ammon - parole de Yahvé."
,"7":"Pour Edom. Voici ce que dit Yahvé Sabaot: Où donc est passée la sagesse de Théman?,Ses fils n'ont-ils rien à proposer?,Leur sagesse s'est-elle envolée?"
,"8":"Fuyez, tournez le dos, habitants de Dédan, car c'est mon heure de visiter Esaü, je lui amène le fléau."
,"9":"Si les vendangeurs passent chez toi, ils ne laisseront rien à grappiller. Si ce sont des voleurs de nuit, ils saccageront tout à leur guise."
,"10":"Oui je viens fouiller Esaü, je mettrai à nu ses repaires; il n'aura plus où se cacher. Sa race est détruite, elle n'est plus. Pas un frère, pas un voisin pour dire:"
,"11":"Laisse-moi tes orphelins, je les ferai vivre, tes veuves pourront compter sur moi!"
,"12":"Car voici ce que dit Yahvé: Ceux qui ne devaient pas boire la coupe maintenant la boivent, et toi, tu passerais au travers? Mais non, tu la boiras!"
,"13":"Car je l'ai juré par moi-même, dit Yahvé, Bosra deviendra un objet d'étonnement et de moquerie, une ruine et une malédiction; ses villages seront ruinés pour toujours."
,"14":"Nous venons d'entendre un appel de Yahvé, un message qu'il fait parvenir aux nations: 'Debout! Partons en guerre contre lui!' C'en est fait!"
,"15":"Te voilà le dernier des peuples, le plus méprisé de tous."
,"16":"La terreur que tu inspirais et l'orgueil de ton coeur, t'ont fait perdre la tête, toi qui habites au creux de La Roche, accroché au sommet des collines. Tu peux élever ton nid comme l'aigle, je t'en ferai descendre - parole de Yahvé."
,"17":"Edom sera un objet d'épouvante, les passants s'étonneront et siffleront en voyant ses plaies;"
,"18":"il sera comme Sodome, ou Gomorrhe et les villes d'alentour après la catastrophe, dit Yahvé. Nul n'y habitera, les humains n'y séjourneront plus."
,"19":"Comme le lion qui monte des fourrés du Jourdain vers les pâturages, moi aussi d'un seul coup je serai sur ses prairies, je les mettrai en fuite. Car qui est mon égal? Qui pourrait se dresser contre moi, quel est le berger qui me tiendrait tête?"
,"20":"Ecoutez donc la décision que Yahvé a prise contre Edom, ses projets contre les habitants de Théman: on fera main basse sur toutes les brebis, jusqu'aux plus efflanquées, et leur pâturage ne s'en remettra pas."
,"21":"Au bruit de leur chute, la terre tremblera, leurs cris s'entendront jusqu'à la Mer-des-Roseaux."
,"22":"Voyez cet aigle qui monte et qui tourne; voici qu'il étend ses ailes au-dessus de Bosra. Le coeur des guerriers d'Edom, ce jour-là, sera bien pareil à celui d'une femme qui enfante."
,"23":"Contre Damas. Voilà Hamat et Arpad décontenancées: elles viennent d'apprendre une mauvaise nouvelle; elles en sont bouleversées, inquiètes comme les flots d'une mer qui ne peut se calmer."
,"24":"Damas est découragée, prête à s'enfuir; elle est saisie de tremblements; l'angoisse et la frayeur l'ont saisie comme une femme qui enfante."
,"25":"Quoi! Elle est abandonnée, la ville glorieuse, la cité de la joie!"
,"26":"Ses jeunes hommes tomberont sur les places; tous ses guerriers périront ce jour-là - parole de Yahvé."
,"27":"J'allumerai un feu dans les remparts de Damas, et il dévorera les palais de Ben-Hadad."
,"28":"Voici ce que dit Yahvé pour Kédar et le royaume d'Hazor, que Nabukodonozor roi de Babel a vaincus: Levez-vous, combattez contre Kédar, exterminez les fils de l'Orient!"
,"29":"Prenez leurs tentes et leurs moutons, leurs toiles et tout leur matériel. Prenez leurs chameaux,et criez sur eux: 'Terreur de partout!'"
,"30":"Fuyez, sauvez-vous, habitants d'Hazor - parole de Yahvé. Car Nabukodonozor, roi de Babylone, a déjà son plan, il a un projet contre vous:"
,"31":"'Attaquons une nation tranquille,qui habite en sécurité; Elle n'a ni portes, ni verrous, elle habite à l'écart."
,"32":"Leurs chameaux sont à prendre, leurs moutons sans nombre seront notre butin!',Je vais les semer à tous les vents, ces hommes aux tempes rasées; de partout viendra sur eux le malheur,- parole de Yahvé."
,"33":"Hazor ne sera plus qu'un gîte de chacals, un désert pour toujours; nul désormais n'y habitera, aucun humain n'y séjournera."
,"34":"Voici la parole de Yahvé qui fut adressée au prophète Jérémie à propos d'Elam, au début du règne de Sédécias roi de Juda."
,"35":"Voici ce que dit Yahvé Sabaot: Je vais briser l'arc d'Elam, le ressort de sa puissance."
,"36":"Des quatre coins du ciel je fais venir, contre Elam, les quatre vents, et je disperse les Elamites à tous ces vents; il n'y aura pas de nation où n'arrivent les gens d'Elam."
,"37":"Je ferai trembler les Elamites devant leurs ennemis, devant ceux qui en veulent à leur vie; je ferai venir sur eux le malheur car ma colère s'enflammera - parole de Yahvé. J'enverrai derrière eux l'épée, jusqu'à leur extermination."
,"38":"J'établirai mon trône en Elam et j'en arracherai ses rois et ses princes - parole de Yahvé,"
,"39":"mais à la fin des jours je ramènerai les prisonniers d'Elam - parole de Yahvé."
}`)
	CurrentBook.AddChapter(50, `{
"1":"Voici une parole que Yahvé a prononcée contre Babylone:"
,"2":"'Proclamez-le parmi les nations, faites-le savoir, ne le cachez pas, Dites que Babylone a été prise. Bel est honteux, et Mérodak, humilié. Oui, ses idoles ont été confondues, et ses ordures, abattues."
,"3":"Une nation du nord l'a attaquée, a réduit son pays en ruines: nul désormais, homme ou bête n'y demeure;"
,"4":"En ces jours-là, en ce temps-là, les fils d'Israël viendront, Ils iront en pleurant,à la recherche de Yahvé leur Dieu."
,"5":"Ils demanderont: 'Où est Sion?',Vers elle ils tourneront leur regard: 'Venez, attachons-nous à Yahvé; que l'alliance soit éternelle, inoubliable!'"
,"6":"Mon peuple n'était que brebis perdues, leurs bergers les avaient égarées. Elles étaient dispersées sur les montagnes, elles erraient de montagne en colline, elles avaient oublié leur bergerie."
,"7":"On les trouvait, on les dévorait; leurs ennemis disaient: 'Aucun risque, puisqu'ils ont péché contre Yahvé, demeure de justice, espérance de leurs pères!'"
,"8":"Sauvez-vous de Babylone, fuyez le pays des Kaldéens; sortez comme les boucs en tête du troupeau!"
,"9":"Car je mets en marche, contre Babel, un rassemblement de grandes nations. Des pays du nord elles viendront, et c'est du nord qu'elles vont la prendre. Leurs flèches sont celles d'un vainqueur, qui ne rentre jamais les mains vides."
,"10":"Alors la Kaldée sera mise au pillage, ils en auront tous les mains pleines."
,"11":"Vous étiez en joie, triomphants, quand vous saccagiez mon héritage; vous pouvez hennir comme de jeunes chevaux!"
,"12":"Voilà votre mère couverte de honte, celle qui vous mit au monde est méprisée; elle est devenue la dernière des nations, un désert, une steppe aride!"
,"13":"Elle ne sera plus habitée, la colère de Yahvé l'a dévastée; ceux qui passent par Babel s'étonnent, ils sifflent à la vue de ses plaies."
,"14":"Rangez-vous face à Babel, encerclez-la; tirez sur elle, tireurs à l'arc, ne ménagez pas vos flèches, car elle a péché contre Yahvé."
,"15":"De tous côtés, contre elle, on a poussé le cri de guerre et elle s'est rendue. Ses tours sont tombées, ses remparts ont été abattus. Vous autres, instruments de la vengeance de Yahvé, traitez-la comme elle-même a fait;"
,"16":"extirpez de Babylone le semeur, comme celui qui fauche au temps de la moisson! Voici que chacun fuit les ravages de l'épée, chacun retourne vers son peuple et s'enfuit vers son pays."
,"17":"Israël était la brebis égarée que pourchassent des lions. Le roi d'Assour commença à la dévorer; pour finir le roi de Babel lui a brisé les os."
,"18":"C'est pourquoi, voici ce que dit Yahvé Sabaot, le Dieu d'Israël: Je vais m'en prendre au roi de Babylone et à son pays, comme j'ai fait pour le roi d'Assour."
,"19":"Je ramènerai Israël à sa prairie, il aura ses pâturages sur le Carmel et sur le Bashan, dans les monts d'Ephraïm et dans ceux de Galaad: il connaîtra l'abondance."
,"20":"En ces jours-là, en ce temps-là, on aura beau chercher la faute d'Israël, on ne verra rien, on ne trouvera plus de péchés en Juda; car lorsque je sauve, je pardonne."
,"21":"Contre le pays de Mératayim. 'Attaque-le, attaque les habitants de Pékod; prends l'épée, extermine-les jusqu'aux derniers - parole de Yahvé - fais tout ce que je t'ordonne!'"
,"22":"C'est un bruit de bataille dans le pays, une immense défaite."
,"23":"Quoi! Le marteau de toute la terre a été abattu et brisé? La Babylone des nations a été pillée?"
,"24":"Je t'ai tendu un piège que tu n'as pas vu, et tu as été prise, Babylone. On a su te trouver et tu as été prise, toi qui te dressais contre Yahvé."
,"25":"Yahvé a ouvert son arsenal pour y prendre les armes de sa colère; oui, le Seigneur Yahvé a son travail au pays des Kaldéens."
,"26":"Accourez tous, ouvrez ses greniers, entassez le butin comme des gerbes, exterminez, ne laissez rien en vie!"
,"27":"Frappez de l'épée ses jeunes taureaux: qu'ils aillent à l'abattoir! Malheur à eux, car leur jour est arrivé, il leur faut maintenant rendre des comptes."
,"28":"Déjà l'on entend les rescapés, les survivants de Babylone, ils apportent la nouvelle à Sion: 'Yahvé notre Dieu s'est vengé, il a vengé son Temple!'"
,"29":"Appelez des archers, tous ceux qui tirent à l'arc, et qu'ils viennent contre Babylone! Campez tout autour, ne laissez pas d'issue! Et puis vous la traiterez selon sa conduite, vous lui ferez comme elle a fait, car elle s'est dressée contre Yahvé, contre le Saint d'Israël."
,"30":"C'est pourquoi ses jeunes tomberont dans les rues, et tous ses guerriers seront réduits au silence en ce jour-là - parole de Yahvé."
,"31":"Me voici contre toi, l'orgueilleuse - parole du Seigneur: ton jour est arrivé, il te faut maintenant rendre des comptes."
,"32":"L'orgueilleuse va trébucher, tomber à terre, et nul ne la relèvera; j'allumerai un feu dans ses villes et il dévorera tout à l'entour."
,"33":"Voici ce que dit Yahvé Sabaot: Les fils d'Israël sont captifs et ceux qui les ont déportés ne veulent pas les lâcher."
,"34":"Mais leur rédempteur se nomme Yahvé Sabaot: lui est fort. Il saura prendre en mains leur cause; il fera taire l'univers et les habitants de Babel trembleront."
,"35":"Epée contre les Kaldéens et les gens de Babylone, contre ses princes et contre ses sages."
,"36":"Epée contre les devins: qu'ils disent des bêtises!,Epée contre ses guerriers: que ce soit la panique!"
,"37":"Epée contre ses chevaux et ses chars: qu'ils ne valent guère plus que des femmes!,Epée contre ses trésors: qu'ils soient pillés!"
,"38":"Epée contre ses eaux: qu'elles soient à sec!,Car c'est un pays d'idoles, ils n'ont de regards que pour leurs Ordures! "
,"39":"C'est pourquoi les chats sauvages y habiteront avec les chacals et les autruches y trouveront leur demeure; elle ne sera plus habitée, elle restera déserte pour toujours."
,"40":"Ce sera comme après la destruction de Sodome, de Gomorrhe et des villes d'alentour par Dieu - parole de Yahvé; nul n'y habitera, les humains n'y séjourneront plus."
,"41":"Regardez, un peuple monte du Nord, c'est une grande nation, des rois nombreux se lèvent des extrémités de la terre."
,"42":"Ils ont leur arc et leur sagaie bien en main; ils sont barbares et sans pitié, leur vacarme est comme celui de la mer. Ils viennent montés sur des chevaux, ils se rangent en bataille comme un seul homme, contre toi, fille de Babylone."
,"43":"Le roi de Babylone vient d'apprendre la nouvelle, ses mains restent sans force, il est saisi d'angoisse,comme la femme lorsqu'elle va enfanter."
,"44":"Comme le lion qui monte des fourrés du Jourdain vers les pâturages, moi aussi d'un seul coup je serai sur ses prairies et je les mettrai en fuite. Car qui est mon égal? Qui pourrait se dresser contre moi?,Quel est le berger qui me tiendrait tête?"
,"45":"Ecoutez donc la décision que Yahvé a prise contre Babylone, ses projets contre le pays des Kaldéens. Oui, on raflera jusqu'aux brebis efflanquées et leur pâturage ne s'en remettra pas."
,"46":"La prise de Babylone a fait grand bruit, la terre en a tremblé et les nations l'ont su."
}`)
	CurrentBook.AddChapter(51, `{
"1":"Voici ce que dit Yahvé: Regardez, je fais que se lève contre Babylone un vent destructeur; j'envoie contre Babylone ceux qui la passeront au tamis et nettoieront sa terre; pour elle est venu le jour néfaste et le malheur vient de partout."
,"3":"Que l'archer bande son arc, qu'il se dresse dans sa cuirasse, n'épargnez pas ses jeunes gens, exterminez toute son armée."
,"4":"Les victimes tombent au pays des Kaldéens, on les poignarde dans les rues."
,"5":"Israël et Juda n'étaient pas veuves de Yahvé leur Dieu, alors même que leur pays était plein de péchés contre le Saint d'Israël."
,"6":"Fuyez du milieu de Babylone, que chacun sauve sa vie; ce n'est pas le moment de mourir à cause de son péché, quand Yahvé exerce sa vengeance et lui rend ce qu'elle a mérité."
,"7":"Babylone était une coupe d'or où s'enivrait toute la terre, les nations buvaient son vin et se mettaient à délirer."
,"8":"Mais soudain Babel est tombée à terre, s'est brisée; lamentez-vous sur elle, prenez du baume pour sa plaie, peut-être guérira-t-elle."
,"9":"'Nous avons soigné Babylone, mais elle n'a pas guéri. Laissons-la donc et que chacun retourne à son pays.' En vérité, ses dettes s'étaient accumulées jusqu'aux cieux, au delà des nuages."
,"10":"Yahvé a fait triompher nos droits; venez, vous raconterez dans Sion les oeuvres de Yahvé notre Dieu."
,"11":"Aiguisez vos flèches, remplissez vos carquois. Yahvé avait fait le projet de détruire Babylone; pour cela il a fait venir le roi des Mèdes. C'est la vengeance de Yahvé: il venge son temple."
,"12":"Dressez un signal face à la muraille de Babylone, renforcez le blocus, mettez en place des sentinelles, préparez des embuscades: Yahvé veut réaliser ce qu'il a projeté, annoncé contre les habitants de Babylone."
,"13":"Installée au bord des grandes-eaux, remplie de trésors, sache que ta fin est proche, tes abus arrivent à leur terme."
,"14":"Yahvé Sabaot l'a juré par lui-même: 'Je te couvrirai d'hommes comme de sauterelles et ils pousseront contre toi le cri de victoire!'"
,"15":"Par sa puissance il fit la terre, par sa sagesse il mit en place le monde, par son intelligence il étendit les cieux."
,"16":"S'il donne de la voix, c'est un grondement d'eaux dans les cieux; il fait monter les nuages du fond de l'horizon. Il envoie les éclairs pour qu'il pleuve et fait sortir le vent de ses réservoirs."
,"17":"Mais l'homme est borné, il ne comprend pas. Que le forgeron rougisse de ses idoles, car ce qu'il a fondu est mensonge, il y manque la vie."
,"18":"Ces idoles ne sont que du creux, des oeuvres mensongères; elles disparaîtront quand Dieu s'en occupera."
,"19":"Il n'en est pas ainsi pour celui qui est l'héritage de Jacob, car lui est l'Auteur de l'univers: il s'appelle Yahvé Sabaot."
,"20":"Tu étais pour moi un marteau, une arme de guerre; avec toi j'ai martelé les nations, j'ai détruit les royaumes."
,"21":"Avec toi j'ai martelé le cheval et son cavalier, avec toi j'ai martelé le char et son conducteur."
,"22":"Avec toi j'ai martelé l'homme et la femme, avec toi j'ai martelé le vieillard et le jeune homme. Avec toi j'ai martelé l'adolescent et la vierge."
,"23":"Avec toi j'ai martelé le berger et son troupeau, avec toi j'ai martelé le laboureur et sa paire de boeufs. Avec toi j'ai martelé les chefs et leurs aides."
,"24":"Mais je ferai payer à Babylone et à tous les habitants de Kaldée, tout le mal qu'ils ont fait dans Sion sous mes yeux - parole de Yahvé."
,"25":"Tu me vois maintenant face à toi, Montagne-d'Oppression, toi qui opprimais toute la terre! Il m'a suffi d'étendre ma main contre toi, et je t'ai fait rouler du haut des rochers, j'ai fait de toi une montagne calcinée."
,"26":"On ne trouvera plus chez toi, ni pierre d'angle, ni pierre de fondation. Tu seras pour toujours une ruine - parole de Yahvé."
,"27":"Dressez un signal dans le pays, sonnez de la trompette parmi les nations. Convoquez les nations contre elle pour une guerre sainte, rassemblez contre elle les royaumes: Ararat, Minni et Achkénaz; contre elle recrutez des officiers, faites charger les chevaux comme des sauterelles en armes."
,"28":"Convoquez les nations contre elle pour une guerre sainte: les rois de Médie, ses gouverneurs et ses fonctionnaires, et tous les pays de son empire."
,"29":"La terre a tremblé, elle a frémi: c'est que Yahvé réalise son plan contre Babylone; il va changer sa terre en un désert inhabité."
,"30":"Les guerriers de Babylone ont cessé le combat, ils restent dans leurs forteresses. Découragés ils sont maintenant comme des femmes. On a mis le feu à toutes les maisons, les verrous ont été brisés."
,"31":"Un messager croise l'autre, un porteur de nouvelles court après un autre pour annoncer au roi de Babylone que sa ville est prise d'un bout à l'autre."
,"32":"Les passages sont occupés, les tours incendiées, et les guerriers sont pris de panique."
,"33":"Voici ce que dit Yahvé Sabaot, le Dieu d'Israël: La fille de Babel sera bientôt comme l'aire qu'on piétine; encore un peu, et viendra son heure."
,"34":"Le roi de Babel, m'a dévorée, engloutie, il m'a laissée comme une cruche vide; tel un dragon il m'a engloutie, il a rempli sa panse et m'a chassé de mon paradis."
,"35":"L'âme de Sion lance un appel: 'Que la violence qu'il m'a faite retombe sur Babylone!' Jérusalem s'écrie: 'Que mon sang retombe sur les habitants de la Kaldée!'"
,"36":"C'est pourquoi, voici ce que dit Yahvé: Je vais prendre en mains ta cause et te venger; je dessécherai sa mer et mettrai à sec sa source."
,"37":"Babylone deviendra un tas de ruines, un repaire de chacals, un exemple terrible, un sujet de moquerie; elle ne sera plus habitée."
,"38":"Ensemble ils rugissent comme des lions, ils grondent comme des petits de lions;"
,"39":"ils s'excitent et s'apprêtent pour le festin. Fait-il trop chaud? Je leur prépare un rafraîchissement; je les ferai boire pour qu'ils soient gais, puis ils s'endormiront d'un sommeil éternel. Ils ne se réveilleront pas - parole de Yahvé."
,"40":"Je les ferai descendre à la boucherie comme des agneaux, les béliers avec les boucs."
,"41":"Comment, Babylone a été prise? elle est tombée, la gloire de toute la terre? Babel n'est-elle plus qu'une ruine au milieu des nations?"
,"42":"La mer est montée contre Babylone et l'a couverte du grondement de ses vagues."
,"43":"Ses villes ont été réduites en solitude, en terre ravagée et déserte, où plus personne n'habite, où les humains ne passent pas."
,"44":"Je me rendrai chez Bel à Babel, et je lui ferai rendre ce qu'il a avalé; il cessera d'attirer les nations. La muraille de Babylone est tombée, "
,"45":"sors du milieu d'elle, ô mon peuple, que chacun sauve sa vie, car voici que se déchaîne la colère de Yahvé."
,"46":"Ne vous laissez pas abattre ou effrayer par les nouvelles qu'on entendra dans le pays, aussi bien cette année que l'an prochain: la violence sera dans le pays, un tyran en remplacera un autre."
,"47":"Les jours viennent où je m'en prendrai aux idoles de Babylone; sa terre sera saccagée et tous tomberont blessés à mort au milieu d'elle!"
,"48":"Le ciel et la terre, avec tout ce qui s'y trouve, crieront de joie lorsqu'arriveront du nord ceux qui s'apprêtent à ravager Babylone - parole de Yahvé."
,"49":"Ecoutez, victimes d'Israël: pour Babel tous les pays ont vu tomber des victimes, et de même Babel tombera."
,"50":"Vous qui avez échappé à l'épée, dépêchez-vous, n'attendez pas; souvenez-vous de Yahvé dans ces terres lointaines, et que Jérusalem revienne à votre mémoire!"
,"51":"Nous étions confus lorsque nous entendions leurs insultes, l'humiliation se lisait sur notre visage lorsque des étrangers sont venus contre le sanctuaire de la Maison de Yahvé."
,"52":"Mais voici que des jours viennent - parole de Yahvé - où je me lèverai contre ses idoles, et dans tout son pays l'on entendra le gémissement des blessés."
,"53":"Même si Babylone s'élevait jusqu'aux cieux et rendait sa citadelle inaccessible, je saurais envoyer des destructeurs jusqu'à elle - parole de Yahvé."
,"54":"Une clameur retentit du côté de Babylone: c'est un vrai désastre au pays des Kaldéens,"
,"55":"c'est Yahvé qui détruit Babylone et fait cesser son vacarme, un grondement semblable à celui des flots lorsque la mer fait entendre sa voix."
,"56":"Le destructeur est venu contre elle, contre Babel. On a capturé ses guerriers, on a brisé leurs arcs, car Yahvé est un Dieu vengeur qui sait rendre la pareille."
,"57":"J'enivrerai ses chefs et ses sages, ses gouverneurs, ses officiers, ses guerriers; ils s'endormiront d'un sommeil éternel pour ne plus se réveiller - parole du Roi dont le nom est Yahvé Sabaot."
,"58":"Voici ce que dit Yahvé Sabaot: La grande muraille de Babylone sera démantelée, ses hautes portes seront incendiées; ainsi les peuples se seront fatigués pour rien, les nations auront travaillé pour le feu."
,"59":"Voici l'ordre que le prophète Jérémie donna à Sérayas, fils de Neriya, fils de Maséya, lorsque celui-ci partit pour Babylone avec Sédécias, roi de Juda. C'était dans la quatrième année de son règne et Sérayas était intendant du palais."
,"60":"Jérémie avait écrit tous les malheurs qui devaient arriver à Babylone; il avait réuni dans un livre toutes les prophéties sur Babylone."
,"61":"Jérémie dit à Sérayas: 'Lorsque tu arriveras à Babylone, tu prendras soin de lire toutes ces paroles,"
,"62":"et tu diras: 'Yahvé, tu as affirmé que ce lieu serait totalement détruit, qu'on n'y verrait plus ni homme ni bête et que ce serait pour toujours un désert.'"
,"63":"Lorsque tu auras fini de lire ce livre, tu y attacheras une pierre et tu le jetteras au milieu de l'Euphrate."
,"64":"Alors tu diras: C'est ainsi que Babylone sera engloutie; elle ne se relèvera plus du malheur que je fais venir sur elle.',Ici se terminent les paroles de Jérémie."
}`)
	CurrentBook.AddChapter(52, `{
"1":"Sédécias avait vingt et un ans lorsqu'il monta sur le trône; il régna onze ans à Jérusalem. Sa mère Hamital était fille de Yirméyas, de Libna."
,"2":"Il fit ce qui est mal au regard de Yahvé, tout comme l'avait fait Joïaqim."
,"3":"Et c'est la colère de Yahvé qui détermina le sort de Jérusalem et de Juda jusqu'au jour où il finit par les rejeter loin de lui. Sédécias se révolta contre le roi de Babylone. "
,"4":"Le dixième jour du dixième mois de la neuvième année de son règne, Nabukodonozor roi de Babylone vint attaquer Jérusalem avec toute son armée. Ils campèrent face à la ville et l'entourèrent d'un retranchement."
,"5":"La ville fut assiégée jusqu'à la onzième année du roi Sédécias."
,"6":"Le neuf du quatrième mois, la famine était grande dans la ville, et même les résidents n'avaient plus de pain."
,"7":"Alors on ouvrit une brèche et tous les guerriers prirent la fuite; ils sortirent de la ville durant la nuit par le chemin de la Porte-entre-les-deux-Murs, au-dessus du jardin du roi, en dépit des Kaldéens qui encerclaient la ville. Le roi et tous ses hommes prirent le chemin de la Steppe."
,"8":"Mais l'armée des Kaldéens se lança à leur poursuite et atteignit Sédécias dans les steppes de Jéricho; toute sa troupe se dispersa loin de lui."
,"9":"On saisit le roi et on l'amena devant le roi de Babylone à Ribla, dans le pays de Hamat; on le fit passer en jugement."
,"10":"Le roi de Babylone égorgea les fils de Sédécias sous ses yeux, il égorgea également tous les chefs de Juda à Ribla."
,"11":"Puis il creva les yeux de Sédécias et le fit lier avec une double chaîne de bronze. Le roi de Babylone l'emmena ainsi jusqu'à Babylone où il le fit enfermer jusqu'au jour de sa mort."
,"12":"Le dix du cinquième mois - on était dans la dix-neuvième année de Nabukodonozor roi de Babylone - ce fut l'entrée à Jérusalem de Nébouzaradan, chef des gardes et officier du roi de Babylone."
,"13":"Il incendia la Maison de Yahvé, le palais royal et toutes les maisons de Jérusalem, c'est-à-dire toutes celles des grands personnages."
,"14":"L'armée des Kaldéens qui accompagnait le chef des gardes démolit tout le rempart autour de Jérusalem."
,"15":"Nébouzaradan, chef des gardes, déporta ce qui restait de la population demeurée dans la ville, ceux qui avaient déserté pour passer au roi de Babylone et le reste des artisans."
,"16":"Mais Nébouzaradan, chef des gardes, laissa les petites gens du pays pour travailler comme vignerons et cultivateurs."
,"17":"Les Kaldéens brisèrent les colonnes de bronze de la Maison de Yahvé, les bases et la Mer de bronze qui étaient dans la Maison de Yahvé, et ils emportèrent tout ce bronze à Babylone."
,"18":"Ils emmenèrent aussi les chaudrons, les pelles, les couteaux, les cruches, les cuillères et tous les objets de bronze dont on se servait pour le culte."
,"19":"Le chef des gardes prit encore les petites cuves, les cassolettes, les cruchettes, les chaudrons, les chandeliers, les cuillères et les tasses: tout ce qui était en or ou en argent."
,"20":"Les deux colonnes, la Mer unique, les douze boeufs de bronze qui étaient au-dessous, les bases qu'avait faites le roi Salomon pour la Maison de Yahvé: tous ces objets représentaient un poids de bronze incalculable."
,"21":"En effet les colonnes avaient dix-huit coudées de haut, un fil de douze coudées en faisait le tour, leur épaisseur était de quatre doigts et elles étaient creuses."
,"22":"Il y avait au-dessus de chacune un chapiteau de bronze. La hauteur d'un chapiteau était de cinq coudées, un filet avec des grenades en faisait le tour, en haut du chapiteau. Tout était en bronze et les deux colonnes étaient semblables."
,"23":"Les grenades étaient au nombre de quatre-vingt seize, elles étaient en relief et le total des grenades qui faisaient le tour du filet était de cent."
,"24":"Le chef des gardes arrêta Sérayas, le grand prêtre , Séfanyas, le prêtre en second, et les trois gardiens de la porte."
,"25":"Un eunuque chargé des hommes de guerre fut trouvé en ville avec sept hommes attachés au service du roi; le scribe du chef de l'armée, chargé d'enrôler les hommes du pays était également dans la ville avec soixante hommes."
,"26":"Nébouzaradan, chef des gardes, les arrêta tous et les emmena au roi de Babylone, à Ribla."
,"27":"Le roi de Babylone les fit mettre à mort à Ribla, au pays de Hamat. Alors Juda fut déporté loin de sa terre."
,"28":"Voici le chiffre de la population que Nabukodonozor déporta. La septième année: 3.023 Judéens."
,"29":"La dix-huitième année de Nabukodonozor, on emmena 83 2 personnes de Jérusalem."
,"30":"La vingt-troisième année de Nabukodonozor, Nébouzaradan, commandant de la garde, déporta 74 5 Judéens, soit au total: 4.600 personnes."
,"31":"Mais le vingt cinq du douzième mois, en la trente-septième année de la déportation de Joiakin, roi de Juda, Evil-Mérodak, roi de Babylone, qui venait de monter sur le trône, libéra Joiakin et le fit sortir de prison."
,"32":"Il lui parla avec bonté et lui donna un siège plus élevé qu'aux autres rois qui étaient avec lui à Babylone."
,"33":"Joiakin quitta ses habits de prisonnier et mangea tous les jours à la table du roi, jusqu'à sa mort."
,"34":"Sa nourriture fut constamment assurée par le roi de Babylone, jour après jour, jusqu'à la fin de sa vie."
}`)

}
func FR_LBDCC_LoadVMISChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Vision d'Isaïe, fils d'Amos, au sujet de Juda et de Jérusalem; il reçut ces visions au temps d'Ozias, de Yotam, d'Akaz et d'Ezéquias, rois de Juda."
,"2":"Que le ciel entende, et toi terre écoute: Yahvé parle. J'ai fait grandir des fils, je les ai élevés, mais ils se sont révoltés contre moi."
,"3":"Le boeuf connaît son propriétaire,et l'âne, la mangeoire de son maître, mais Israël ne me connaît pas; mon peuple ne comprend rien."
,"4":"Malheur à cette nation qui fait le mal, ce peuple chargé de péchés; c'est une race de malfaiteurs, ce sont des fils égarés!,Ils ont abandonné Yahvé, méprisé le Saint d'Israël."
,"5":"Où pourrait-on vous frapper encore, si vous continuez dans votre révolte?,Toute la tête est malade, le coeur bien mal en point."
,"6":"De la plante des pieds jusqu'à la tête, plus rien n'est bon, ce ne sont que blessures, plaies et coups, qui n'ont été ni bandés, ni pansés, ni soignés avec de l'huile."
,"7":"Votre terre est là dévastée, vos villes ravagées par le feu, l'étranger sous vos yeux en dévore les fruits; vous n'êtes pas moins ruinés que ne le fut Sodome."
,"8":"Ils ont laissé la fille de Sion,pareille à une cabane au milieu d'une vigne, comme une hutte dans un champ de melons, comme une ville assiégée."
,"9":"Si Yahvé Sabaot ne nous avait laissé un petit reste, nous serions comme Sodome, semblables à Gomorre."
,"10":"Entendez la Parole de Yahvé, chefs de Sodome, écoutez l'enseignement de notre Dieu, peuple de Gomorre!"
,"11":"Que m'importent tous ces sacrifices, dit Yahvé, j'en ai assez des holocaustes de taureaux,et de la graisse des veaux, je ne prends pas plaisir au sang des taureaux, des agneaux et des boucs."
,"12":"Vous venez vous présenter devant moi, vous fréquentez les cours de mon Temple, mais qui vous l'a demandé?"
,"13":"Arrêtez ces offrandes qui ne sont pas vraies!,Je suis dégoûté de l'encens, des nouvelles lunes et des sabbats; je ne supporte plus vos assemblées, votre hypocrisie et vos fêtes."
,"14":"Je déteste vos nouvelles lunes, vos réunions; elles sont pour moi un fardeau, je ne les supporte plus."
,"15":"Lorsque vous chantez vos psaumes, je me détourne et je ferme les yeux. Vous pouvez multiplier vos prières, moi je n'écoute pas, car vos mains sont pleines de sang."
,"16":"Lavez-vous donc, purifiez-vous!,Enlevez de devant moi vos mauvaises actions!,Cessez de faire le mal"
,"17":"et apprenez à faire le bien, cherchez la justice, reprenez le brutal. Faites justice à l'orphelin, défendez la veuve."
,"18":"Allez, discutons, dit Yahvé. Si vos fautes sont rouges comme l'écarlate, elles deviendront blanches comme la neige. Si elles sont rouges comme la pourpre, elles deviendront comme la laine."
,"19":"Si vous le voulez bien, si vous m'écoutez, vous mangerez les bonnes choses du pays;"
,"20":"mais si vous refusez, si vous vous révoltez, c'est l'épée qui vous mangera. Oui, la bouche de Yahvé a parlé!"
,"21":"Comment la Cité fidèle s'est-elle faite prostituée, cette cité du droit, demeure de la justice?,Maintenant on n'y trouve que des assassins."
,"22":"Ton argent s'est changé en ordures, ton vin en eau."
,"23":"Tes princes sont des rebelles, amis des brigands, ils aiment les pots-de-vin et courent après les cadeaux. Ils ne font pas justice à l'orphelin,et n'entendent pas la cause de la veuve."
,"24":"Voici la sentence du Seigneur, Yahvé Sabaot, le Fort d'Israël!,Je mettrai au pas mes adversaires,et je me vengerai de mes ennemis!"
,"25":"Je tournerai ma main contre toi; comme avec la soude, je laverai tes impuretés, je balaierai tous tes déchets."
,"26":"Tes juges redeviendront comme ceux d'autrefois, tes conseillers, comme dans les premiers temps: alors on t'appellera,Ville-de-la-Justice, Cité-Fidèle."
,"27":"La délivrance de Sion passera par un jugement, et ce sont les justes qui resteront."
,"28":"Mais les pécheurs, les rebelles, périront ensemble, ceux qui abandonnent Yahvé seront exterminés."
,"29":"Alors vous aurez honte,des arbres sacrés que vous aimez tant, vous rougirez des jardins sacrés qui vous plaisent."
,"30":"Vous serez comme l'arbre dont la feuille est tombée, comme un jardin qui n'est plus arrosé."
,"31":"L'homme important sera comme une mèche, et son oeuvre sera l'étincelle; tous les deux brûleront ensemble,et personne n'éteindra."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Vision d'Isaïe fils d'Amos au sujet de Juda et de Jérusalem."
,"2":"Voici ce qui arrivera à la fin des temps: la montagne du temple de Yahvé sera remaniée, elle deviendra le premier des monts,et dominera toute autre hauteur. Toutes les nations monteront vers elle, "
,"3":"des peuples nombreux se mettront en route et diront: 'Venez, montons à la montagne de Yahvé, à la Maison du Dieu de Jacob, il nous enseignera ses voies et nous suivrons ses sentiers.',Oui, l'enseignement sortira de Sion, et de Jérusalem, la Parole de Yahvé."
,"4":"Il gouvernera les nations, il sera un arbitre pour la multitude des peuples. De leurs épées ils feront des socs de charrues, et de leurs lances, des faucilles. On ne lèvera plus l'épée, nation contre nation, on n'apprendra plus à faire la guerre."
,"5":"Peuple de Jacob, allons, marchons à la lumière de Yahvé!"
,"6":"Tu as rejeté le clan de Jacob, ton peuple, il est rempli de devins,et de magiciens, comme les Philistins, et l'on y fait bon ménage avec les païens."
,"7":"Son pays est rempli d'argent et d'or, de trésors incalculables. Son pays est rempli de chevaux et de chars sans nombre. "
,"8":"Son pays est rempli d'idoles, ils se prosternent devant l'ouvrage de leurs mains, devant ce que leurs doigts ont fabriqué!"
,"9":"L'homme sera humilié, le mortel abaissé, ne leur pardonne pas! "
,"10":"Va aux rochers, cache-toi dans la terre, loin de la terreur de Yahvé et de l'éclat de sa majesté!"
,"11":"L'oeil humain plein d'orgueil sera abaissé, et l'insolence du mortel, humiliée: Yahvé, lui seul, sera élevé ce jour-là."
,"12":"Oui, Yahvé Sabaot aura son jour,contre tout orgueil et toute insolence, contre tous ceux qui se croient quelque chose: ils seront abaissés!"
,"13":"Il aura son jour contre les cèdres du Liban, élevés et hautains, contre tous les chênes du Bashan, "
,"14":"contre les montagnes hautaines,et toutes les collines élevées, "
,"15":"contre les hautes tours et les remparts fortifiés,"
,"16":"contre les vaisseaux de Tarsis,et tous les navires princiers."
,"17":"L'orgueil de l'homme sera abaissé, l'insolence du mortel, humiliée; Yahvé, lui seul, sera élevé ce jour-là, "
,"18":"tandis que des idoles il ne restera rien."
,"19":"On se cachera dans les grottes des rochers, dans les trous de la terre, loin de la terreur de Yahvé et de l'éclat de sa majesté, quand il se lèvera pour faire trembler la terre."
,"20":"En ce jour-là, l'homme jettera aux taupes et aux chauves-souris, les idoles d'argent, les idoles en or,qu'il s'était fabriquées pour les adorer. "
,"21":"Il se cachera dans les creux et les fentes des rochers, loin de la terreur de Yahvé et de l'éclat de sa majesté, car il se lèvera pour faire trembler la terre."
,"22":"Ne vous fiez pas à l'homme: il ne tient qu'au souffle de ses narines, que pouvez-vous attendre de lui?"
}`)
	CurrentBook.AddChapter(3, `{
"1":"Voici que le Seigneur, Yahvé Sabaot. enlève de Jérusalem et de Juda,toutes les provisions, toutes les réserves, provisions de pain et réserves d'eau."
,"2":"Il enlève l'homme de guerre et le soldat, le juge et le prophète, l'astrologue et l'ancien,"
,"3":"le capitaine, le noble et le conseiller, le sage, l'artisan et le sorcier."
,"4":"'Je leur donnerai comme chefs de petits jeunes, et des prétentieux pour les gouverner.'"
,"5":"Dans le peuple on se frappera l'un l'autre, on se frappera entre voisins; le jeune homme s'en prendra au vieillard, et l'homme du peuple au grand personnage,"
,"6":"si bien qu'on voudra obliger son frère, n'importe qui de la maison de son père, on lui dira: 'Tu as bien un manteau?,Alors sois notre chef,et prends en mains cette ruine!'"
,"7":"Mais ce jour-là l'autre répondra: 'Je ne suis pas infirmier, il n'y a ni pain, ni manteau dans ma maison; ne faites pas de moi un chef du peuple!'"
,"8":"Oui, Jérusalem tombe, Juda s'effondre, car leurs paroles, leurs actes, sont un défi à Yahvé, et veulent échapper à ses yeux pleins de Gloire."
,"9":"L'expression même de leur visage témoigne contre eux, et sans rou gir, ils étalent leurs péchés comme Sodome. Hélas! ils font eux-mêmes leur propre malheur."
,"10":"'Bienheureux le juste!',Oui, dites-le, car il récoltera le fruit de ses actions; "
,"11":"mais malheur au méchant: c'est le mal qu'il récoltera de ses oeuvres."
,"12":"O mon peuple, des bambins t'oppriment,et des femmes te gouvernent!,O mon peuple, ceux qui devraient te guider t'égarent,et brouillent les pistes que tu dois suivre."
,"13":"Yahvé s'est installé à son tribunal, il se lève pour accuser son peuple. "
,"14":"Yahvé fait le procès des anciens,et des chefs de son peuple: 'Vous avez dévoré les produits de la vigne, on trouve dans vos maisons ce que vous avez volé aux petits. "
,"15":"Pourquoi écraser mon peuple et piétiner les pauvres?',parole du Seigneur, Yahvé Sabaot."
,"16":"Voici ce que dit Yahvé: 'Qu'elles sont prétentieuses les dames de Sion! Elles vont le cou tendu et le regard provoquant, elles marchent à petits pas et font tinter les anneaux de leurs pieds."
,"17":"Mais le Seigneur rasera le crâne des filles de Sion et on les verra chauves."
,"18":"En ce jour-là le Seigneur enlèvera tout ornement: anneaux de che villes, soleils et boucles d'oreilles,"
,"19":"colliers, chaînettes et voiles,"
,"20":"turbans, gourmettes, rubans, boîtes à parfum et portes-bonheur,"
,"21":"bagues, anneaux pour les narines,"
,"22":"robes de fêtes, pèlerines, écharpes et sacs,"
,"23":"miroirs, draperies, tiares et broches."
,"24":"Alors, au lieu de parfum ce sera la pourriture; au lieu de ceinture, une corde; au lieu de jolies tresses, une tête rasée; au lieu de robe précieuse, un sac sur les reins; au lieu d'un savant maquillage, une marque au fer rouge."
,"25":"Tes hommes tomberont sous l'épée, ton armée restera sur le terrain."
,"26":"Tes places n'entendront que lamentations et pleurs, et tu t'assiéras sans plus dans la poussière."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Sept femmes en ce jour-là se disputeront un homme,et lui diront: 'Nous mangerons notre pain,et nous achèterons nos vêtements, mais permets-nous de porter ton nom. Enlève notre humiliation!'"
,"2":"En ce jour-là le germe de Yahvé sera l'ornement et la gloire des rachetés d'Israël; le fruit du pays fera leur honneur et leur fierté. On appellera saints tous ceux qui seront inscrits pour la vie à Jérusalem: ceux qui seront restés dans Sion, qu'on aura laissés à Jérusalem."
,"4":"Car le Seigneur va laver l'ordure des filles de Sion, nettoyer Jérusalem du sang versé au milieu d'elle: le souffle du jugement passera, un souffle de feu."
,"5":"Sur tout le secteur du mont Sion et sur ceux qui s'y rassemblent, Yahvé fera venir une nuée: une fumée de jour, et la nuit l'éclat d'un feu flam boyant. La Gloire de Yahvé sera comme un pavillon,"
,"6":"une tente. Son ombre protégera de la chaleur; elle sera un refuge, un abri, contre l'orage et contre la pluie."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Laissez-moi chanter pour mon ami, le chant de mon ami pour sa vigne. Mon ami avait une vigne sur un coteau fertile."
,"2":"Il a travaillé la terre, enlevé les pierres, il y a planté du raisin de choix, il a construit une tour et creusé une cuve. Il en attendait de bons raisins, mais elle donné des fruits sauvages."
,"3":"Maintenant, habitants de Jérusalem, et vous gens de Juda, jugez vous-mêmes entre moi et ma vigne."
,"4":"Pouvait-on faire pour ma vigne plus que je n'ai fait?,J'en attendais de bons raisins, pourquoi m'a-t-elle donné des fruits sauvages?"
,"5":"Je vais vous dire, moi, ce que je vais faire à ma vigne. J'enlèverai la haie et elle sera broutée, je briserai la clôture et on la piétinera."
,"6":"J'en ferai une terre abandonnée, elle ne sera plus taillée, ni travaillée, mais épines et ronces y pousseront. J'interdirai même aux nuages d'y laisser tomber la pluie."
,"7":"Oui, la vigne de Yahvé Sabaot, c'est la maison d'Israël, l'homme de Juda est le pied de vigne qu'il préfère. Il en attendait la justice et voici la méchanceté, il en attendait le droit et voici des cris de violence."
,"8":"Malheur à ceux qui ajoutent maison à maison, qui regroupent un champ avec d'autres champs. Il ne restera donc plus de place, et vous habiterez vous seuls le pays?"
,"9":"Voici ce que Yahvé Sabaot a juré à mes oreilles: 'De nombreuses maisons seront à l'abandon; grandes et belles, elles seront inhabitées. "
,"10":"Un beau vignoble ne donnera plus que quelques mesures de raisins, et de dix mesures de semence, on ne récoltera qu'une mesure."
,"11":"Malheur à ceux qui dès le matin courent après les bois sons fortes, et qui le soir encore s'enivrent de vin."
,"12":"Leurs banquets ne sont que musique, harpes, tambourins, flûtes et vins; ils ne prêtent aucune attention à l'oeuvre de Yahvé,et ne voient pas ce qu'il est en train de faire."
,"13":"Mon peuple a laissé la sagesse: il sera déporté; les chefs connaî tront la faim, la masse sera torturée par la soif."
,"14":"C'est pourquoi le séjour des morts ouvre sa gueule, toute grande il l'ouvre; la splendeur de Sion y descend, avec l'excitation de sa foule bruyante et joyeuse."
,"15":"L'homme sera abaissé, le mortel humilié, les yeux insolents seront humiliés."
,"16":"Le jugement de Yahvé Sabaot révélera sa grandeur,le Dieu Saint montrera, par sa justice, sa sainteté."
,"17":"(Comme dans un pré les agneaux brouteront, les chèvres chercheront leur pâture dans les prairies dévastées où se nourrissaient les bêtes grasses.)"
,"18":"Malheur à ceux qui traînent leurs fautes,avec les liens du mensonge, et leurs péchés avec des cordes, comme on traîne une charrette."
,"19":"Ils disent: 'Que Yahvé se dépêche, qu'il réalise son oeuvre pour que nous la voyons!,Que le projet du Saint d'Israël se réalise, qu'il vienne et nous le connaîtrons!'"
,"20":"Malheur à ceux qui appellent le mal bien, et le bien, mal, qui font des ténèbres la lumière, et de la lumière, les ténèbres; qui font passer ce qui est doux pour amer,et ce qui est amer pour doux."
,"21":"Malheur à ceux qui se prennent pour des sages, et qui se croient intelligents."
,"22":"Malheur à ceux qui sont champions pour boire le vin, des vedettes pour mélanger des liqueurs."
,"23":"Ils acquittent le criminel pour un pot de vin, et récusent les droits de l'innocent."
,"24":"C'est pourquoi, comme le feu lèche et dévore la paille, et que l'herbe sèche disparaît dans la flamme, leur racine tournera en pourriture, et leur fleur sera soufflée avec la poussière. C'est qu'ils ont rejeté la Loi de Yahvé Sabaot, ils ont méprisé la parole du Saint d'Israël."
,"25":"La colère de Yahvé s'enflamme contre son peuple, il lève la main sur lui et le frappe. Les montagnes s'agitent, les cadavres sont là,comme des ordures au milieu des rues... Avec tout cela, sa colère ne s'apaise pas,et sa main reste levée."
,"26":"Il dresse un signal pour une nation lointaine; du bout de la terre il la siffle, et voici qu'elle arrive rapide et légère."
,"27":"Pas un d'entre eux n'est fatigué, aucun ne tombe, pas un ne sommeille ou ne dort, ou n'a la ceinture qui se déboucle, ou les courroies de sandales qui lâchent."
,"28":"Ses flèches sont aiguisées, tous ses arcs tendus, les sabots de ses chevaux sont durs comme la pierre, les roues de ses chars sont comme l'ouragan."
,"29":"Elle rugit comme une lionne, elle rugit comme le petit lion, elle grogne sur sa proie, elle s'en empare,et l'emporte: personne ne la lui arrache."
,"30":"Contre ce peuple elle grondera ce jour-là, comme gronde la mer. Pour qui regarde le pays,ce ne seront que ténèbres et détresse,et de sombres nuages qui voilent la lumière."
}`)
	CurrentBook.AddChapter(6, `{
"1":"L'année de la mort du roi Ozias, je vis le Seigneur assis sur un trône haut et surélevé; les pans de son manteau remplissaient le Sanc tuaire."
,"2":"Des séraphins se tenaient au-dessus de lui; chacun d'eux avait six ailes; de deux ailes ils se couvraient la face, de deux ailes ils se cou vraient les pieds, de deux ailes ils volaient."
,"3":"Ils se criaient l'un à l'autre: 'Saint, saint, saint, Yahvé Sabaot! Toute la terre est remplie de sa Gloire.'"
,"4":"Cette acclamation faisait trem bler les poteaux du portail: le Temple se remplit de fumée."
,"5":"Alors je dis: 'Malheur à moi, je suis perdu! Oui, je suis un homme aux lèvres impures, je vis au milieu d'un peuple aux lèvres impures, et mes yeux ont vu le roi, Yahvé Sabaot!'"
,"6":"L'un des séraphins vola vers moi. Dans sa main il tenait un charbon ar dent qu'il avait pris sur l'autel avec des pincettes."
,"7":"Il me toucha la bouche et me dit: 'Regarde, ce charbon a touché tes lèvres, ta faute est effacée, ton péché est pardonné.'"
,"8":"Alors j'entendis la voix du Seigneur: 'Qui enverrai-je, disait-il, qui ira pour nous?' Je répondis: 'Me voici, envoie-moi!'"
,"9":"Alors le Seigneur me dit: 'Va! Tu diras à ce peuple: Ecoutez, écoutez donc sans comprendre! Regardez, regardez toujours sans rien voir!"
,"10":"Tu vas endurcir le coeur de ce peuple, boucher ses oreilles et obscur cir ses yeux; que surtout ses yeux ne voient pas, que ses oreilles n'en tendent pas... sinon son coeur comprendrait, il se convertirait et serait guéri.'"
,"11":"Je répondis: 'Jusqu'à quand Seigneur?' Le Seigneur me dit: 'Jusqu'à ce que les villes soient détruites, inhabitées, les maisons sans personne, les champs dévastés et ravagés,"
,"12":"jusqu'à ce que Yahvé en ait chassé les hommes et que la terre reste à l'abandon."
,"13":"S'il en restait encore un dixième, il serait brûlé à son tour comme la souche du térébinthe et du chêne lorsqu'ils sont abattus. De la souche, pourtant, sortira une race sainte.'"
}`)
	CurrentBook.AddChapter(7, `{
"1":"Voici ce qui arriva au temps d'Akaz fils de Yotam, fils d'Ozias roi de Juda: Razone, roi d'Aram, et Péka, fils de Rémalyas, roi d'Israël, s'avancèrent sur Jérusalem pour l'attaquer, mais ils ne purent s'en empa rer."
,"2":"On apporta la nouvelle au palais de David: 'Aram a installé son camp sur le territoire d'Ephraïm.' Alors le coeur du roi et le coeur du peuple commencèrent à s'agiter, comme sous le vent s'agitent les arbres de la fo rêt."
,"3":"Yahvé dit alors à Isaïe: 'Sors avec ton fils Chéar-Yachoub à la ren contre d'Akaz; il est près de l'extrémité du canal de la piscine supé rieure, sur le chemin du Champ-du-Foulon."
,"4":"Tu lui diras ceci: Reste donc calme! N'aie pas peur et ne tremble pas devant ces deux braises fumantes; qu'est-ce que la fureur de Razone roi d'Aram, et celle du fils de Rémalyas?"
,"5":"Aram, Ephraïm et le fils de Rémalyas ont bien décidé ta perte, ils ont dit:"
,"6":"Attaquons Juda, jetons-y la panique; nous le détruirons et nous y installerons comme roi le fils de Tabéel."
,"7":"Mais voici que le Seigneur Yahvé a parlé; il a dit: Cela ne se réalisera pas, cela ne sera pas!"
,"8":"Car Damas n'est que la capitale d'Aram,et Razone n'est que le chef de Damas."
,"9":"Samarie n'est que la capitale d'Ephraïm, et le fils de Rémalyas n'est que la tête de Samarie."
,"8b":"Eh bien, encore soixante cinq ans, et Ephraïm aura cessé d'être un peuple.),Mais si vous ne croyez pas, vous ne tiendrez pas.'"
,"10":"De nouveau il y eut une parole de Yahvé pour Akaz:"
,"11":"'Demande un signe à Yahvé ton Dieu, jusque dans le monde d'en-bas si tu veux, ou bien là-haut dans le ciel.'"
,"12":"Akaz répondit: 'Je ne demanderai rien, je ne mettrai pas Yahvé à l'épreuve.'"
,"13":"Alors le prophète lui dit: 'Ecoutez, maison de David! Il ne vous suffit donc pas de fatiguer tout le monde, voulez-vous aussi fatiguer mon Dieu?"
,"14":"Eh bien, le Seigneur lui-même va vous donner un signe. Voici: La jeune mère est enceinte, elle enfante un fils et lui donne ce nom: Emma nuel, 'Dieu-avec-nous'."
,"15":"L'enfant se nourrira de lait caillé et de miel jusqu'à ce qu'il sache rejeter le mal et choisir le bien."
,"16":"Car avant que l'enfant ne sache rejeter le mal et choisir le bien, le pays dont tu redoutes les deux rois sera dé vasté."
,"17":"Et pour toi, pour ton peuple et la maison de ton père, Yahvé fera venir des temps tellement désastreux qu'il n'y en a pas eu de semblables depuis le jour où Ephraïm s'est séparé de Juda."
,"18":"Oui, en ces jours-là, Yahvé sifflera, et des canaux d'Egypte viendront les mouches, de l'Assyrie, les abeilles."
,"19":"Toutes elles viendront et se poseront,dans les ravins des torrents,et dans les fentes des rochers, sur tous les petits arbres,et sur tous les cours d'eaux."
,"20":"Le Seigneur en ce jour-là, prendra un rasoir au-delà du Fleuve: Le rasoir enlèvera les cheveux, les poils des jambes et la barbe."
,"21":"Ce jour-là chacun élèvera une vache et deux brebis;"
,"22":"cela fera beaucoup de lait,et tous ceux qui seront laissés dans le pays, se nourriront de crème et de miel."
,"23":"En ce jour-là, dans un vignoble de mille pieds de vigne,d'une valeur de mille pièces d'argent, on ne trouvera plus que ronces et épines."
,"24":"On y entrera avec l'arc et les flèches,car le pays ne sera plus que ronces et épines."
,"25":"Par crainte des ronces et des épines, on n'amènera plus la charrue,sur les collines qui étaient cultivées. On y lâchera les boeufs,et les brebis les piétineront.'"
}`)
	CurrentBook.AddChapter(8, `{
"1":"Yahvé me dit: 'Prends une grande tablette et écris dessus avec un poinçon ordinaire: 'Ramassage-immédiat, Pillage-tout-proche.'"
,"2":"Prends-moi ensuite comme témoins deux hommes de confiance: le prêtre Ouriyas et Zékaryas, fils de Yébérekyas.'"
,"3":"Alors je me suis approché de la prophétesse. Elle est tombée enceinte et elle a enfanté un fils. Yahvé me dit: 'Appelle-le: Ramassage-immédiat, Pillage-tout-proche.'"
,"4":"Car avant que l'enfant ne sache dire: Papa et Maman, on apportera au roi d'Assyrie les trésors de Damas et le butin de Samarie."
,"5":"Yahvé me parla de nouveau. Il me dit:"
,"6":"'Puisque ce peuple a méprisé les eaux de Siloé qui coulent en douceur, et qu'il a tremblé devant Razone et le fils de Rémalyas,"
,"7":"le Seigneur va faire venir sur eux les eaux d'un fleuve puissant et profond: le roi d'Assyrie et tout son monde. Le voici qui déborde de son lit et se répand au-delà de ses rives. "
,"8":"Il passe en Juda comme l'inondation qui vient, qui s'étend et qui monte jus qu'au cou; de ses ailes déployées il recouvre tout ton pays, Emmanuel!'"
,"9":"Apprenez-le, peuples: vous serez brisés!,Sachez-le bien vous tous au bout du monde: allez-y, vous serez brisés!,allez-y, vous serez brisés!"
,"10":"Faites un projet, il sera réduit à rien, dites une parole, elle ne se réalisera pas, car Dieu est avec nous!"
,"11":"Lorsque Yahvé m'a empoigné de sa main, il m'a averti de ne pas suivre le chemin de ce peuple. Il m'a dit alors:"
,"12":"'Vous ne crierez pas au complot chaque fois que ce peuple criera au complot. Vous ne craindrez pas lorsqu'il craindra, vous ne tremblerez pas."
,"13":"C'est Yahvé Sabaot que vous traiterez comme le Saint; c'est lui que vous craindrez, c'est devant lui que vous tremblerez."
,"14":"Il sera pour les deux maisons d'Israël un Sanctuaire, mais aussi la pierre sur laquelle on achoppe, un rocher qui fait tomber, un filet et un piège pour les habitants de Jérusalem."
,"15":"Beaucoup d'entre eux trébuche ront, ils tomberont et seront écrasés, ils seront pris au piège et seront attrapés."
,"16":"Maintenant, confie cette parole à mes disciples comme une révélation sous scellés.'"
,"17":"Moi, j'attends Yahvé qui cache son visage au peuple de Jacob, je mets en lui mon espérance."
,"18":"Moi et les enfants que Yahvé m'a donnés, nous sommes pour Israël des signes et des avertissements, de la part de Yahvé Sabaot qui habite sur le mont de Sion."
,"19":"Et si l'on vous dit: 'Allez consulter les magiciens et les sor ciers qui murmurent et qui chuchotent', répondez: 'Bien sûr, un peuple doit consulter ses dieux! Allez donc consulter des morts en faveur des vi vants!'"
,"20":"Revenez donc à ce que Lui enseigne et affirme, comme c'est le cas pour cette parole: là il n'y a pas de nuit."
,"21":"Epuisé et affamé, il traversera le pays, la faim le rendra furieux, il maudira son roi et son Dieu!,Il se tournera vers le ciel,"
,"22":"puis il regardera vers la terre. Partout il ne verra que détresse et ténèbres, la nuit redoutable et l'obscurité angoissante."
,"23":"Mais là où se trouvait l'angoisse, la nuit disparaîtra. Dans le passé, il a réduit à rien le pays de Zabulon et le pays de Neph tali, mais dans l'avenir il couvrira de gloire la route de la mer, au-delà du Jourdain, la province des païens."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Le peuple qui marchait dans la nuit, a vu une grande lumière. Comme ils restaient en terre de ténèbres, une lumière a brillé sur eux."
,"2":"Tu as multiplié la nation, tu as fait déborder sa joie. Ils sont en fête devant toi comme au jour de la moisson, c'est la joie comme au partage du butin."
,"3":"Car le joug qui pesait sur eux, le bâton qui frappait ses épaules, le fouet de son surveillant, tu les as brisés comme au jour de Madian."
,"4":"Les chaussures de guerre et le manteau souillé de sang,sont brûlés, jetés en pâture aux flammes."
,"5":"Oui, un enfant nous est né, un fils nous a été donné. L'insigne du pouvoir est placé sur son épaule. on lui donne ce nom: 'Conseiller-merveilleux, Dieu-fort, Père-éternel, Prince-de-la-paix.'"
,"6":"Avec lui l'empire grandit, et c'est la paix sans fin,pour le trône de David et pour sa dynastie: il l'établit et l'affermit dans le droit et la justice. Le zèle de Yahvé Sabaot fera que cela soit, dès maintenant et à jamais."
,"7":"Le Seigneur a jeté une parole en Jacob, elle est tombée en Israël."
,"8":"Tout ce peuple a été témoin, Ephraïm et les habitants de Samarie. Mais dans leur fierté, leur arrogance, ils ont dit:"
,"9":"'Les briques sont tom bées? Eh bien, nous reconstruirons en pierres de tailles. Les sycomores ont été abattus? Nous les remplacerons par des cèdres.'"
,"10":"C'est pourquoi Yahvé dresse contre ce peuple son ennemi Razone, il ex cite ses adversaires:"
,"11":"Aram à l'est, les Philistins à l'ouest. Ils dévo rent Israël à belles dents. Mais la colère de Yahvé n'est toujours pas satisfaite, sa main menace en core!"
,"12":"Le peuple n'est pas revenu vers celui qui le frappait, il n'a pas consulté Yahvé Sabaot."
,"13":"C'est pourquoi en un seul jour Yahvé a retranché d'Israël la tête et la queue, la palme et le jonc"
,"14":"(la tête c'est l'an cien, le noble; la queue c'est le prophète qui enseigne le mensonge)."
,"15":"Les guides de ce peuple l'égarent, ceux qui le conduisent ont perdu le chemin."
,"16":"C'est pourquoi le Seigneur sera sans pitié pour ses jeunes gens, pour ses orphelins et ses veuves, car tout ce peuple vit dans l'hypo crisie et la méchanceté: ils n'ont sur les lèvres que des paroles stu pides. Mais sa colère n'est toujours pas satisfaite, sa main menace encore!"
,"17":"Car leur dette est devenue un feu, elle dévore les ronces et les épines, elle enflamme les taillis de la forêt"
,"18":"et la fumée s'élève en tourbillons. La colère de Yahvé Sabaot a secoué le pays; le peuple est de venu la proie des flammes, car plus personne n'a pitié de son frère."
,"19":"On coupe à droite et l'on a encore faim, on dévore à gauche et l'on n'est pas rassasié; chacun déchire son voisin."
,"20":"Ephraïm se dresse contre Manassé, Manassé contre Ephraïm, et tous deux se dressent contre Juda. Mais sa colère n'est toujours pas satisfaite, sa main menace encore!"
}`)
	CurrentBook.AddChapter(10, `{
"1":"Malheur à ceux qui font des lois injustes,et n'écrivent que pour instituer l'oppression."
,"2":"Ils privent les malheureux de leur dû,et jouent avec les droits des pauvres de mon peuple. Les veuves deviennent leur proie, ils dépouillent l'orphelin."
,"3":"Que ferez-vous au jour du règlement de comptes?,Où fuirez-vous pour chercher du secours,lorsque viendra la ruine imprévue?,Où déposerez-vous vos trésors?"
,"4":"Rien à faire! Vous serez chargés de chaînes, ou vous tomberez parmi les morts. Car la colère de Yahvé n'est toujours pas satisfaite, sa main menace encore!"
,"5":"Malheur à l'Assyrie, le fouet de ma colère, le bâton que je lève dans ma fureur,"
,"6":"que je dresse contre une nation hypocrite, que j'envoie contre le peuple qui me met en colère,pour en ramasser les dépouilles,et emporter tout le butin, pour le piétiner comme on piétine la terre des rues."
,"7":"Mais le roi d'Assyrie n'entre pas dans ce projet, il ne voit pas ainsi les choses, Lui n'a qu'une idée en tête: détruire, supprimer de nombreuses nations."
,"8":"Il se dit: 'Tous mes chefs ne valent-ils pas des rois?"
,"9":"N'ai-je pas eu Kalno après Karkémich, Samarie après Damas, Hamat après Arpad?"
,"10":"J'ai bien su frapper les royaumes des idoles, plus riches en statues que Jérusalem et Samarie."
,"11":"Ce que j'ai fait à Samarie et ses idoles, je le ferai pour Jérusalem et ses objets sacrés.'"
,"12":"Mais voilà, quand le Seigneur aura terminé son oeuvre sur la montagne de Sion, à Jérusalem, il s'en prendra à l'insolence du roi d'Assyrie qui est si fier de ses exploits:"
,"13":"'Tout cela, dit-il, je l'ai fait parce que je suis fort, parce que je suis sage et intelligent!,J'ai déplacé les frontières des peuples, j'ai pillé leurs richesses, j'ai ruiné des villes habitées."
,"14":"De ma main j'ai pris les trésors des peuples, comme on ramasse dans un nid des oeufs abandonnés, et pas un n'a battu de l'aile, aucun n'a ouvert le bec ou poussé un cri.'"
,"15":"Qui doit se vanter, la hache ou celui qui s'en sert? Qui doit être fier, la scie ou celui qui travaille avec? Est-ce le fouet qui met en mou vement celui qui le lève? Entre le bâton et celui qui n'est pas de bois, qui soulève l'autre?"
,"16":"Aussi le Seigneur, Yahvé Sabaot, est près de frapper,et de consumer les puissants d'Assyrie. Le feu va prendre sous leur faste, et ce sera un brasier."
,"17":"Oui, la Lumière d'Israël sera un feu, et son Saint, une flamme. En un seul jour elle va brûler et dévorer, ses ronces et ses épines."
,"18":"La gloire de sa forêt et ses arbres fruitiers,se défait, disparaît, corps et âme; elle perd le souffle et meurt."
,"19":"Il reste si peu d'arbres dans la forêt,qu'un enfant pourrait les compter."
,"20":"En ces jours-là le reste d'Israël, les survivants de la maison de Ja cob, cesseront de s'appuyer sur celui qui les bat; ils seront fidèles et ils s'appuieront sur Yahvé, le Saint d'Israël."
,"21":"Un reste reviendra vers le Dieu fort, le reste de Jacob."
,"22":"Oui, Is raël! Même si ton peuple était nombreux comme le sable du bord des mers, seul un reste reviendrait. La ruine est décidée, justice entière sera faite."
,"23":"Le Seigneur fera dans tout le pays extermination et nettoyage."
,"24":"C'est pourquoi, voici ce que dit le Seigneur, Yahvé Sabaot: 'O mon peuple, toi qui habites en Sion, ne tremble pas devant l'Assyrie qui te frappe de son bâton et use avec toi de la trique, comme faisaient les Egyp tiens."
,"25":"Car dans bien peu de temps ma colère s'apaisera et c'est lui que ma fureur détruira."
,"26":"Yahvé Sabaot lèvera le fouet contre lui comme il a frappé Madian au Rocher d'Oreb, comme il a frappé l'Egypte avec le bâton qu'il tenait levé sur la mer."
,"27":"Alors, en ce jour-là, le fardeau tombera de ton épaule, son joug tom bera de ton cou, et l'abondance remplacera l'oppression."
,"28":"L'Assyrien est monté contre Ayat, il est passé à Migron, il a laissé ses bagages à Mikmas."
,"29":"Il a traversé le défilé, puis il a dit: 'Guéba sera le point d'étape.' Rama a tremblé, Guibéa de Saül s'est enfuie."
,"30":"Fais-toi entendre Bat-Gallim! Fais attention Laïcha! Réponds-lui Anatot!"
,"31":"Madména s'est enfuie; les habitants de Guébim se sont cachés."
,"32":"Au jourd'hui il fera halte à Nob et déjà il tend la main vers la montagne de la fille de Sion, vers la colline de Jérusalem."
,"33":"Mais voici que le Seigneur, Yahvé Sabaot, a pris la hache, il abat les branches; ceux qui se dressent haut sont coupés, les orgueilleux sont ra baissés."
,"34":"Sa lame tranche les taillis de la forêt et le Liban s'affaisse avec sa gloire."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Un rejeton sortira de la souche de Jessé, une pousse se lèvera de ses racines."
,"2":"Sur lui reposera l'Esprit de Yahvé, esprit de sagesse et d'intelligence, esprit de conseil et de force, esprit de connaissance et de crainte de Yahvé."
,"3":"Il ne jugera pas sur les apparences, il ne décidera pas sur un bruit qui court."
,"4":"Il jugera les petits avec justice, il défendra les droits des pauvres du pays. Sa parole frappera le violent, et son souffle fera mourir le méchant."
,"5":"La justice sera son ceinturon, toujours là sur ses reins avec la vérité."
,"6":"Le loup habitera avec l'agneau, le léopard se couchera à côté du chevreau, le veau et le lion s'en iront au même pâturage,sous la conduite d'un petit garçon."
,"7":"La vache et l'ourse seront amies, leurs petits dormiront ensemble, et le lion mangera de la paille comme le boeuf."
,"8":"Le bébé jouera sur le nid du serpent, l'enfant à peine sevré mettra la main,dans le trou de la vipère."
,"9":"On ne fera plus de mal, on ne détruira plus,sur toute ma montagne sainte, car la connaissance de Yahvé couvrira la terre,comme les eaux le domaine des mers."
,"10":"En ces jours-là, la 'racine de Jessé' sera pour les peuples un signe de ralliement; les nations la chercheront et le lieu de sa demeure sera glorieux."
,"11":"En ce jour-là, de nouveau, le Seigneur lèvera la main pour rapatrier le reste de son peuple d'Assyrie et d'Egypte, de Patros, de Kouch et d'Elam, de Chinéar, d'Hamat et des îles de la mer: tous les sur vivants."
,"12":"Il lèvera un signal, visible dans les nations, et rassemblera les dé portés d'Israël; il regroupera tous ceux de Juda qui avaient été dispersés aux quatre coins de la terre."
,"13":"Alors la jalousie d'Ephraïm cessera, les oppresseurs de Juda seront éliminés, Ephraïm n'attaquera plus Juda et Juda n'opprimera plus Ephraïm."
,"14":"Ils voleront vers les collines des Philistins, près de la mer, ensemble ils pilleront les fils de l'Orient. Edom et Moab leur seront soumis et les fils d'Amon leur obéiront."
,"15":"Yahvé asséchera la lagune de la mer d'Egypte, il lèvera la main contre le fleuve et la violence de son souffle le divisera en sept bras. On les passera en sandales."
,"16":"Pour le reste de son peuple, pour les survivants d'Assyrie, il y aura une route comme autrefois pour Israël lorsqu'il montait du pays d'Egypte."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Tu diras en ce jour: 'Je te chante Yahvé!,Car tu t'étais mis en colère contre moi,mais ta colère s'est apaisée,et tu m'as secouru."
,"2":"C'est lui le Dieu de mon salut, j'ai confiance en lui et ne tremble plus; Yahvé est ma force et je le louerai: c'est bien lui qui m'a sauvé."
,"3":"Vous viendrez joyeusement puiser l'eau,aux sources mêmes du salut!"
,"4":"Vous direz en ce jour: 'Célébrez Yahvé, criez de joie en son honneur, racontez ses merveilles chez tous les peuples, faites savoir que son Nom est grand."
,"5":"Chantez Yahvé, qui fait des choses magnifiques: qu'on le sache sur toute la terre."
,"6":"Pousse des cris de joie, ville de Sion: le Saint d'Israël s'est montré grand chez toi!"
}`)
	CurrentBook.AddChapter(13, `{
"1":"Voici le jugement sur Babylone qui fut révélé à Isaïe fils d'A mos."
,"2":"Dressez un signal sur une montagne pelée, poussez des cris pour les ap peler, faites des signes de la main pour qu'ils entrent par la porte des Princes!"
,"3":"J'ai tout juste donné des ordres à mes Saints; j'appelle aussi mes guerriers joyeux et fiers, au service de ma colère."
,"4":"Sur les montagnes on entend une foule, on dirait un peuple nombreux; c'est un vacarme de royaumes, de nations qui se rassemblent; Yahvé Sabaot passe en revue son armée."
,"5":"Ils arrivent d'un pays lointain, des extrémités du ciel; Yahvé et les instruments de sa colère viennent ravager toute la terre."
,"6":"Poussez des hurlements, car le jour de Yahvé est proche! Il arrive comme les dévastations du Dieu des Steppes."
,"7":"C'est pourquoi toutes les nations sont prises de panique, tout homme perd courage."
,"8":"Ils sont épou vantés, pris de crampes et de douleurs; ils se tordent comme la femme qui accouche. Ils se regardent l'un l'autre, la peur se lit sur leur visage en feu."
,"9":"Car voici venu le jour de Yahvé, jour cruel; sa fureur, sa violente colère se déchaînent pour dévaster la terre et en éliminer les pécheurs."
,"10":"Les astres du ciel et leurs constellations ne donnent plus leur lumière; le soleil se lève tout noir et la lune ne donne plus sa clarté."
,"11":"Je punirai le monde pour sa méchanceté et les criminels pour leur in justice; je ferai taire l'orgueil des arrogants, j'abaisserai l'insolence des violents."
,"12":"Je rendrai les mortels plus rares que l'or fin, les humains plus in trouvables que l'or d'Ofir."
,"13":"C'est pourquoi les cieux tremblent et la terre ne reste plus en place, à la vue de la fureur de Yahvé Sabaot, car aujourd'hui se déchaîne sa colère."
,"14":"Alors, comme une gazelle que l'on poursuit, comme un troupeau que per sonne ne rassemble, chacun s'en retournera vers son peuple, chacun s'en fuira vers son pays."
,"15":"On poignarde ceux qu'on trouve; ceux que l'on prend tombent sous l'é pée."
,"16":"On écrase leurs petits enfants sous leurs yeux, leurs maisons sont saccagées et leurs femmes violées."
,"17":"Voici, je fais venir contre eux les Mèdes, des gens qui se moquent de l'argent et ne recherchent pas l'or."
,"18":"Leurs arcs déchirent les jeunes gens, ils sont sans pitié pour les pe tits-enfants, sans considération pour les enfants."
,"19":"Alors Babylone, la reine des royaumes, la splendeur, l'orgueil des Kaldéens, sera comme Sodome et Gomorre quand Dieu les a détruites."
,"20":"Pour les siècles des siècles elle sera inhabitée. L'Arabe n'y dressera pas sa tente, les bergers n'y feront pas reposer leurs troupeaux,"
,"21":"mais les léopards s'y installeront, les grands aigles feront leurs nids dans ses maisons, les hiboux du désert y auront leurs demeures, et les démons à tête de bouc, leurs danses."
,"22":"Les hyènes se logeront dans ses châteaux, les chacals dans ses luxueux palais; oui, sa fin est proche; ses jours ne se ront pas prolongés."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Yahvé aura pitié de Jacob, Israël sera encore son préféré; il les fera reposer dans leur pays. L'étranger se joindra à eux et s'attachera à la maison de Jacob."
,"2":"Des peuples les prendront pour les ramener chez eux, mais, sitôt arrivé à la terre de Yahvé, le peuple d'Israël sera leur maître: eux seront ses esclaves et ses serviteurs. Israël fera prisonniers ceux qui le tenaient captif et dominera ses oppresseurs."
,"3":"Le jour où Yahvé t'aura délivré de ta peine, de ton angoisse, et de ce dur esclavage auquel tu étais soumis,"
,"4":"tu entonneras ce chant contre le roi de Babylone; tu diras: 'Comment donc a fini le tyran? Comment a cessé l'oppression?'"
,"5":"Yahvé a brisé le fouet des méchants, le bâton des tyrans,"
,"6":"celui qui, dans sa colère, frappait les peuples à coups redoublés, et dans sa fureur imposait aux nations sa tyrannie jalouse."
,"7":"Toute la terre a retrouvé calme et repos, elle éclate en cris de joie."
,"8":"Même les cyprès se réjouissent, avec les cèdres du Liban: 'Depuis que tu es mort, disent-ils, nous n'avons plus à craindre le bûcheron.'"
,"9":"A l'annonce de ta venue, le séjour des morts s'agite dans ses profon deurs, il réveille pour toi ses fantômes, tous les grands de la terre; il fait lever de leur trône tous les rois des nations."
,"10":"Tous commencent à parler. Ils disent: 'Te voilà toi aussi abattu comme nous; tu es devenu l'un de nous."
,"11":"Ta splendeur et le son de tes harpes sont descendus au séjour des morts. Les vers te servent de lit, la vermine est ta couverture."
,"12":"Quoi, tu es tombé du ciel, astre de lumière, fils de l'aurore! Te voilà à terre écrasé, toi qui écrasais les nations."
,"13":"C'est bien toi qui disais: Je monterai jusqu'au ciel, je placerai mon trône plus haut que les étoiles de Dieu. Je siégerai sur la montagne du Rendez-Vous, aux frontières de l'horizon."
,"14":"Je monterai par-dessus les nuages et je serai l'égal du Très-Haut."
,"15":"Mais te voici descendu au séjour des morts, au plus profond de la fosse."
,"16":"Ceux qui t'aperçoivent regardent et s'étonnent: 'Est-ce donc là celui qui faisait trembler la terre, qui renversait les royaumes?"
,"17":"Il chan geait le monde en désert, il détruisait les villes et jamais n'ouvrait la porte de ses prisons.'"
,"18":"Tous les rois des nations reposent avec honneur, chacun dans son palais;"
,"19":"mais toi, on t'a jeté sans sépulture, comme une ordure méprisable, un cadavre piétiné, recouvert des victimes de l'épée."
,"20":"Tu ne rejoindras pas, chez les morts, ceux qui ont eu droit aux funérailles, car tu as dé truit ton pays, tu as massacré ton peuple; jamais plus on ne parlera de la race des malfaisants."
,"21":"Préparez le massacre des fils pour venger les crimes de leurs pères. Que plus jamais ils ne se lèvent pour conquérir la terre, pour couvrir le monde de leurs cités.'"
,"22":"'Je veux m'en prendre à eux - parole de Yahvé Sabaot. J'arracherai de Babylone le nom et le reste, ses enfants et tous ses descendants - parole de Yahvé."
,"23":"Je la donne en héritage aux hérissons et j'en fais une mare d'eau; je la balaie: c'est un balayage par le vide - parole de Yahvé Sa baot.'"
,"24":"Yahvé Sabaot l'a juré: 'Tout sera comme je l'ai conçu et voulu. Les choses se réaliseront."
,"25":"Je briserai l'Assyrie dans mon pays, je l'écra serai sur mes montagnes. Son joug ne pèsera plus sur mon peuple, son far deau sera enlevé de leurs épaules."
,"26":"Telle est la décision que j'ai prise contre toute la terre, c'est ainsi que je frapperai toutes les nations."
,"27":"Si Yahvé Sabaot l'a décidé, qui l'en empêcherait? S'il a levé la main, qui la détournerait?"
,"28":"L'année de la mort du roi Akaz, Isaïe prononça cette parole:"
,"29":"Ne te réjouis pas si vite, Philistie!,Le fouet qui te frappait s'est brisé, mais de la racine du serpent sortira une vipère, et son fruit sera un dragon ailé."
,"30":"Quand mes pauvres trouveront leur nourriture, et que les malheureux dormiront en sécurité, je ferai mourir de faim ta descendance,et je tuerai ce qui restera de toi."
,"31":"Hurlez, à la municipalité, et que toute la ville pousse des cris!,Te voilà sans forces, terre des Philistins: du nord s'élève une fumée, ils viennent!,et nul d'entre eux ne s'écarte de ses rangs."
,"32":"Que répondra-t-on aux messagers de ce peuple?,Que Yahvé a fondé Sion, et que les pauvres de son peuple y sont en sûreté."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Prophétie contre Moab: Ar-Moab s'est tue: en une nuit, elle a été détruite. Kir-Moab a été saccagée: en une nuit, elle a été détruite."
,"2":"La fille de Dibon est montée,sur les hauts-lieux pour pleurer. Sur le Nébo et à Médba, Moab se lamente, toutes les têtes sont rasées, toutes les barbes sont coupées."
,"3":"Dans les rues, sur les terrasses, on les voit couverts d'un sac; sur les places on se lamente: rien que des chants funèbres!"
,"4":"Heshbon, Eléalé ont poussé des cris, leur voix s'est fait entendre jusqu'à Yahas. C'est pourquoi les guerriers de Moab tremblent, tout Moab est défait."
,"5":"Mon coeur se lamente sur Moab; ses fuyards ont atteint Soar, Eglat-Chélichiya, on monte en pleurant la côte de Louhit, sur le chemin d'Horonayïm on crie au désastre."
,"6":"Les Eaux de Nimrim sont devenues un désert, l'herbe, les jeunes pousses sont desséchées; il n'y a plus rien de vert."
,"7":"Ils transportent au-delà du Torrent des Saules,leurs provisions, ce qui leur reste."
,"8":"Leurs cris ont réveillé le pays de Moab, l'écho en parvient à Eglayim, il atteint le puits d'Elim."
,"9":"Les Eaux de Dimon se remplissent de sang, tandis que sur Dibon j'amène le malheur; j'envoie le lion contre les survivants de Moab, contre ceux qui restent encore dans le pays."
}`)
	CurrentBook.AddChapter(16, `{
"1":"De Séla, proche du désert, on envoie les agneaux au mont de la fille de Sion: ne sont-ils pas seigneurs du pays?"
,"2":"Comme des oiseaux errants, qu'on a chassés du nid,les filles de Moab s'arrêtent aux gués de l'Arnon."
,"3":"On leur fait dire: Tenez un conseil, prenez une décision: que même en plein midi ton ombre vaille celle de la nuit, cache les exilés, ne trahis pas les fugitifs."
,"4":"Que les exilés de Moab,puissent se réfugier chez toi, sois leur asile face au pillard, le temps que disparaisse l'oppresseur,que la destruction prenne fin,et que celui qui piétine abandonne le pays,"
,"5":"(Oui, le trône sera rétabli, stable grâce à l'esprit de bonté. Un chef aimant le droit, passionné de justice, siégera sur ce trône en toute loyauté,dans la tente de David.)"
,"6":"Nous en savons assez sur l'orgueil de Moab, du très orgueilleux Moab, sur ses prétentions, son insolence, sa fierté,et ses bavardages qui ne mènent à rien."
,"7":"Laissons Moab se lamenter sur Moab, laissons le pays à ses pleurs. Abattus, vous gémissez, vous regrettez,vos gâteaux de raisins de Kir-Ha-Résset."
,"8":"Les vignobles d'Heshbon se flétrissent, les rois des nations ont saccagé,les beaux raisins des vignes de Sibma. Elles s'étendaient jadis jusqu'à Yaser, elles s'avançaient jusqu'au désert, leurs rejetons s'allongeaient au-delà de la mer."
,"9":"C'est pourquoi je prends part au deuil de Yaser, pour ses vignes de Sibma. Je verse sur vous mes larmes, Heshbon, Eléalé. Car on n'entend plus le chant du paysan,ni sur ta récolte, ni sur ta moisson."
,"10":"La joie et la fête ont disparu de tes vergers: plus un chant, plus une clameur dans tes vignes!,Nul déjà ne foule le raisin dans tes cuves, c'est fini de leurs cris joyeux."
,"11":"Voilà pourquoi, pensant à Moab, je sens mes intérieurs vibrer comme une harpe,et mon coeur en moi frémit pour Kir-Hérès."
,"12":"Moab peut venir et s'agiter sur le haut-lieu, entrer dans son temple pour prier, cela ne changera rien."
,"13":"C'est là la parole que Yahvé prononça jadis au sujet de Moab."
,"14":"Et maintenant Yahvé dit ceci: Encore trois années comptées comme celles d'un salarié, et toute la gloire de Moab, de ce peuple nombreux, sera par terre; ce qui en restera sera peu de chose et de peu de valeur."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Parole contre Damas,Voici Damas rayée de la liste des villes, elle n'est plus qu'un tas de ruines."
,"2":"Désertées, les villes d'Aroër,sont abandonnées aux troupeaux: ils s'y prélassent sans que nul ne les chasse."
,"3":"Ephraïm va perdre son protecteur, car le royaume de Damas et ce qui reste d'Aram, connaîtront le même sort que les fils d'Israël,- parole de Yahvé Sabaot."
,"4":"La gloire de Jacob, ce jour-là, cessera de briller, son corps bien en point verra fondre sa graisse."
,"5":"Comme on ramasse la récolte,et le moissonneur charge les épis sur son bras, ou mieux: comme on glane les épis,dans la vallée des Réfaïm."
,"6":"Il ne restera plus que les oubliés, comme après la cueillette des olives: deux ou trois fruits au sommet de l'arbre, quatre ou cinq au bout des branches. - parole de Yahvé Dieu d'Israël."
,"7":"En ce jour-là, on se tournera vers son Créateur, on lèvera les yeux vers le Saint d'Israël."
,"8":"L'homme ne se tournera plus vers les oeuvres de ses mains, vers ces pieux sacrés, ces autels à parfum que ses doigts ont fabri qués."
,"9":"En ce jour-là vos villes à remparts seront abandonnées, comme celles des Hivvites et des Amorites, qu'ils abandonnèrent devant les enfants d'Israël: elles resteront désertes."
,"10":"Oui, tu as oublié le Dieu qui te sauve, tu as oublié le Rocher, ton refuge. Aussi, lorsque tu plantes des plants de choix, lorsque tu repiques une pousse étrangère,"
,"11":"le jour où tu plantes elle est déjà grande, le matin même ta semence a fleuri. Mais elle dépérit et la récolte t'échappe: alors tu pourras pleurer!"
,"12":"Malheur, quelle masse de peuples nombreux, semblable à la mer en furie, quel vacarme de peuples, comme le vacarme d'un torrent déchaîné!"
,"13":"Mais il menace et de loin elle s'enfuit, comme la paille des collines emportée par le vent, comme un tourbillon de sable devant la tempête."
,"14":"Au soir c'était la terreur, mais au matin il n'en reste rien. Tel sera le sort de ceux qui venaient piller, le lot de ceux qui veulent nous saccager."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Malheur au pays des sauterelles ailées, au-delà des fleuves de Kouch,"
,"2":"ce pays qui envoie des messagers sur mer, dont les barques de roseaux courent sur les eaux. Allez, messagers rapides, vers ces gens de haute taille, à la peau bronzée, vers ce peuple redouté de près et de loin, vers cette nation puissante et dominatrice, dont le pays est traversé de fleuves."
,"3":"Vous tous, habitants du monde, vous qui peuplez la terre, quand l'étendard sera sur les monts, regardez; quand on sonnera du cor, écoutez."
,"4":"Car voici ce que dit Yahvé: D'où je suis je regarde, et je reste immobile, comme la chaleur torride au plein milieu du jour, comme le nuage qui rafraîchit au plus fort de l'été."
,"5":"Fini le temps des fleurs avant la moisson, lorsque la fleur devient raisin qui commence à mûrir, on coupe les grappes à coups de serpe, on taille, on enlève les rameaux..."
,"6":"Les voilà livrés aux rapaces des montagnes,et aux bêtes de la terre. Les rapaces viendront sur eux l'été, et les bêtes sauvages y seront en hiver."
,"7":"Mais un jour ils apporteront l'offrande à Yahvé Sabaot, ces gens de haute taille, à la peau bronzée, ce peuple redouté de près et de loin, cette nation puissante et dominatrice dont le pays est traversé de fleuves. Ils viendront l'apporter au Mont-Sion, là où réside le Nom de Yahvé."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Une sentence contre l'Egypte: Yahvé est monté sur un nuage léger; voici qu'il arrive en Egypte,et l'Egypte sent son coeur défaillir, les idoles d'Egypte tremblent devant lui."
,"2":"Je vais dresser l'Egypte contre l'Egypte, on se battra entre frères, voisin contre voisin, ville contre ville, royaume contre royaume."
,"3":"Voici que l'Egypte ne sait plus que faire, j'ai brouillé sa clairvoyance. Ils s'en vont consulter les idoles, les magiciens, les sorciers et les devins."
,"4":"Je vais livrer l'Egypte à un maître cruel, un tyran règnera sur eux,- parole du Seigneur, Yahvé Sabaot."
,"5":"Les eaux de la mer se perdent, le fleuve se tarit et se dessèche,"
,"6":"les rivières deviennent infectes, les fleuves d'Egypte baissent et se dessèchent, les roseaux et les joncs se flétrissent."
,"7":"Toute l'herbe des bords du Nil, toutes les plantes semées au bord du Nil, se dessèchent, sont emportés, disparaissent."
,"8":"Les pécheurs se lamentent, ceux qui jettent l'hameçon dans le Nil sont en deuil, ceux qui jettent leurs filets sur les eaux sont désespérés."
,"9":"Déception pour ceux qui travaillent le lin!,Ceux qui travaillent la toile blanche,"
,"10":"comme ceux qui la tissent, sont découragés; les ouvriers sont démoralisés."
,"11":"Qu'ils sont bêtes les chefs de Soan, quel conseil stupide que ces sages conseillers du Pharaon!,Comment pouvez-vous dire au Pharaon: 'Nous sommes les fils des sages, les fils des rois d'autrefois?'"
,"12":"Où sont-ils donc tes sages?,Qu'ils t'annoncent, qu'ils devinent,ce que Yahvé Sabaot a décidé contre l'Egypte!"
,"13":"Les princes de Soan ont perdu le sens, les princes de Nof se trompent, les chefs de ses tribus égarent l'Egypte."
,"14":"Yahvé a fait passer dans ce pays,un esprit d'égarement; et voilà l'Egypte qui fait tout de travers, comme un homme ivre, tout hébété quand il vomit."
,"15":"Rien ne profite plus à l'Egypte, que cela vienne de la tête ou de la queue, de la palme ou du jonc."
,"16":"En ce jour-là l'Egypte sera comme une femme, tremblante, effrayée rien qu'à voir la main menaçante de Yahvé Sabaot."
,"17":"Le pays de Juda fera peur à l'Egypte. Chaque fois qu'on parlera de lui elle tremblera en pensant aux menaces de Yahvé Sabaot."
,"18":"En ce jour-là, cinq villes au pays d'Egypte parleront la langue de Ca naan: on aura recours au nom de Yahvé Sabaot pour y prêter serment. L'une d'elle sera appelée ville du Soleil."
,"19":"Ce jour-là il y aura en pleine terre d'Egypte un autel consacré à Yahvé et, près de la frontière, un monu ment dédié à Yahvé."
,"20":"Il sera un signe et un témoin de Yahvé Sabaot dans le pays d'Egypte. Quand ils crieront vers lui au temps de l'oppression, il leur enverra un sauveur, un défenseur qui les délivrera."
,"21":"Yahvé se fera connaître aux Egyptiens et les Egyptiens connaîtront Yahvé. Ils présente ront des sacrifices et des offrandes en l'honneur de Yahvé, ils feront des voeux et les accompliront."
,"22":"Car Yahvé frappera l'Egypte, mais après l'avoir frappée il la guérira; ils reviendront à Yahvé, il entendra leurs prières et les guérira."
,"23":"Ce jour-là une route mènera d'Egypte en Assyrie, l'Assyrie aura des re lations avec l'Egypte et l'Egypte avec l'Assyrie, et l'Egypte, comme l'As syrie, servira Yahvé."
,"24":"En ce jour-là Israël se joindra comme un tiers à l'Egypte et à l'Assyrie, et ce sera une bénédiction dans le monde."
,"25":"Yahvé Sabaot les bénira, il dira: 'Bénie soit l'Egypte, mon peuple, et l'Assyrie, oeuvre de mes mains, et Israël, mon héritage!'"
}`)
	CurrentBook.AddChapter(20, `{
"1":"Cette année-là, Sargon roi d'Assyrie envoya son général en chef à Ashdod pour l'attaquer, et il s'en empara."
,"2":"Alors Yahvé parla ainsi par la bouche d'Isaïe fils d'Amos: 'Va, lui dit-il, laisse pendre un sac de ta ceinture, et enlève les sandales de tes pieds.' Il fit ainsi et il allait nu, déchaussé."
,"3":"Yahvé dit alors: 'Mon serviteur Isaïe a marché nu et déchaussé pendant trois ans: c'était un signe et un avertissement pour l'Egypte et pour Kouch."
,"4":"De même le roi d'Assyrie emmènera les prisonniers d'Egypte et les captifs de Kouch, les jeunes comme les vieux, nus, déchaussés et les fesses à l'air, à la honte de l'Egypte."
,"5":"Les gens seront effrayés, désemparés, car Kouch était leur espérance, et l'Egypte leur fierté."
,"6":"En ce jour-là les habitants de la côte diront: 'Regardez ce qu'est de venu le pays sur lequel nous comptions! Nous allions chercher là-bas une protection pour nous défaire du roi d'Assyrie; mais maintenant, comment échapperons-nous?'"
}`)
	CurrentBook.AddChapter(21, `{
"1":"Oracle contre le désert proche de la mer: Cela vient du désert, d'une terre redoutable, comme un ouragan traversant le Négueb."
,"2":"Je viens d'avoir une vision sinistre: Le traître trahit et le pilleur pille: Elamites, allez-y; Mèdes, à l'assaut!,'J'ai fait taire les derniers gémissements.'"
,"3":"C'est pourquoi je suis rempli d'inquiétude, je suis saisi de convulsions,comme les convulsions de la femme qui enfante, je suis trop bouleversé pour entendre, trop affolé pour voir."
,"4":"Mon esprit s'égare, des choses affreuses me remplissent de terreur; je souhaitais le crépuscule: il me remplit d'épouvante."
,"5":"On prépare la table, on étend les tapis, on mange et on boit. 'Levez-vous chefs! Préparez vos boucliers!'"
,"6":"Oui, voici ce que m'a dit le Seigneur: 'Va, mets en place un guetteur,et qu'il te rapporte ce qu'il verra."
,"7":"S'il voit un char, des cavaliers deux à deux, des hommes montés sur des ânes, des hommes montés sur des chameaux, qu'il fasse attention, très attention!'"
,"8":"Et puis le guetteur a crié: 'Seigneur, je me tiens tout le jour,sur la tour de guet, toute la nuit je suis debout et je monte la garde."
,"9":"Voici une troupe montée,et des cavaliers deux à deux.',Le guetteur a repris: 'Elle est tombée, Babylone, elle est tombée avec les statues de ses dieux!,Il les a toutes brisées à terre.'"
,"10":"O toi mon peuple qu'il a foulé, comme le grain sur son aire, ce que j'ai appris de Yahvé Sabaot, du Dieu d'Israël, je te l'annonce."
,"11":"Oracle contre Douma: Depuis Séïr on me crie: 'Guetteur, où en est la nuit?,Guetteur où en la nuit?'"
,"12":"Le guetteur a répondu: 'Le matin vient mais aussi la nuit. Si vous voulez interroger, interrogez: revenez une autre fois!'"
,"13":"Oracle contre l'Arabie: Dans les steppes d'Arabie vous passez la nuit, caravanes des Dédanites."
,"14":"Allez au-devant des assoiffés, apportez-leur de l'eau, habitants du pays de Téma!,Allez avec du pain au-devant des fugitifs!"
,"15":"Car ils ont pris la fuite devant les épées, devant l'épée dégainée et l'arc bandé, ils ont fui la violence du combat."
,"16":"Voici ce que le Seigneur m'a dit: 'Encore une année comme on compte celle d'un salarié, et toute la gloire de Kédar aura disparu;"
,"17":"il ne res tera que peu de chose des vaillants archers de Kédar: Yahvé, le Dieu d'Is raël a parlé."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Prophétie contre la Vallée de la Vision: Pourquoi donc tout ce monde monté sur les terrasses,"
,"2":"ville pleine de vacarme, ville bruyante et tout en fête?,Si tu as des morts, ils n'ont pas péri par l'épée, ils n'ont pas été tués au combat."
,"3":"Tes chefs ont pris la fuite comme un seul homme, ils se sont rendus sous la menace de l'arc. Tous les tiens qu'on a ramassés étaient en fuite, on les a faits prisonniers."
,"4":"C'est pourquoi je dis: 'Détournez de moi vos regards, laissez-moi pleurer amèrement,et n'insistez pas pour me consoler,de ce désastre de la fille de mon peuple.'"
,"5":"Oui, c'est un jour de défaite, d'écrasement et de désastre, qu'envoie le Seigneur, Yahvé Sabaot. Dans la Vallée de la Vision,on détruit le rempart, on crie vers la montagne."
,"6":"Elam est là avec ses flèches, ses chars et ses cavaliers, et Kir a pris son bouclier."
,"7":"Tes plus belles vallées sont remplies de chars, leurs cavaliers sont en place devant la porte:"
,"8":"voilà Juda sans défenses!,En ce jour-là vous avez tourné les yeux vers l'arsenal de la Maison-de-la-Forêt. "
,"9":"Vous avez vu que la Cité de David avait bien des brèches. Vous avez récupéré les eaux de la piscine inférieure,"
,"10":"vous avez regardé de près les maisons de Jérusalem et vous en avez démoli pour renforcer le rem part."
,"11":"Et puis vous avez creusé un réservoir entre les deux murs pour les eaux de l'ancienne piscine. Mais vous n'avez pas eu un regard pour celui qui mène ces événements, vous n'avez pas vu celui qui en a fait le projet depuis bien longtemps."
,"12":"En ce jour-là le Seigneur, Yahvé Sabaot vous invitait à pleurer et à vous lamenter, à vous tondre la tête, à porter un sac autour de vos reins."
,"13":"Mais au lieu de cela c'est la fête, on veut s'amuser! On tue le boeuf, on égorge le mouton, on mange de la viande, on boit du vin: 'Mangeons et buvons, car demain nous mourrons!'"
,"14":"Voulez-vous savoir une parole que Yahvé Sabaot m'a révélée: 'Cette faute ne leur sera pas pardonnée avant qu'ils ne soient morts!'"
,"15":"Voici ce que dit le Seigneur, Yahvé Sabaot: 'Va trouver ce ministre Chebna, le gouverneur du palais."
,"16":"Il se taille une tombe sur la hauteur, il se creuse un tombeau dans le rocher, et tu lui diras: Qu'as-tu ici, qui es-tu ici,pour te tailler ainsi une tombe?"
,"17":"Voici que Yahvé te jette à terre, il t'attrape, l'ami, il t'attrape!"
,"18":"Il te roule comme une boule,et te fait rouler vers une terre lointaine. C'est là que tu mourras, l'homme aux chars de luxe, toi qui fais honte à la maison de ton maître."
,"19":"Je vais te chasser de ton poste, te renvoyer de ta charge."
,"20":"Un de ces jours j'appellerai Elyakim, le fils d'Hilkiyas, mon serviteur,"
,"21":"je lui donnerai ton manteau, je lui mettrai ta ceinture autour des reins, je lui confierai ta charge, et il sera un père pour les habitants de Jérusalem,et pour la maison de Juda."
,"22":"Je lui donnerai la clé de la Maison de David, s'il ouvre, personne ne fermera, s'il ferme, personne n'ouvrira."
,"23":"Je le planterai comme un clou dans du matériau ferme, et il sera pour la maison de son père, un trône de gloire."
,"24":"(A ce clou on suspendra toute la charge de la maison de son père avec ses rejetons et ses ramifications, toute la vaisselle, depuis les petites cruches jusqu'aux grandes jarres."
,"25":"Mais en ce jour-là - parole de Yahvé Sabaot - le clou planté dans du matériau ferme lâchera; il tombera et tout ce qu'on avait chargé par-dessus se retrouvera par terre. Ainsi a parlé Yahvé.)"
}`)
	CurrentBook.AddChapter(23, `{
"1":"Prophétie contre Tyr: Gémissez, vaisseaux de Tarsis, car tout a été dévasté, plus une maison ne reste. Après leur départ du pays de Kittim, ils en ont reçu la nouvelle."
,"2":"Vous restez sans voix, habitants de la côte, marchands de Sidon!,Tes commis parcouraient les mers,"
,"3":"ils affrontaient l'océan. Les semences de Chihor, les moissons du Nil étaient ta richesse, tu étais le marché des nations."
,"4":"C'est l'échec, Sidon, forteresse en mer!,La reine des mers demande: 'N'ai-je donc pas eu d'enfants, n'ai-je jamais connu les douleurs, n'ai-je pas élevé des garçons, fait grandir des filles?'"
,"5":"Quand on le saura là-bas en Egypte, le sort de Tyr les fera trembler."
,"6":"Retournez donc à Tarsis,et laissez se lamenter les habitants de la côte."
,"7":"Est-ce là la fière cité,dont l'origine remontait aux temps anciens, qui portait au loin ses pas,pour y fonder des colonies?"
,"8":"Qui donc a pris cette décision contre Tyr, la ville qui distribuait les couronnes, dont les commerçants étaient de vrais princes, et les marchands, des grands de la terre?"
,"9":"C'est Yahvé Sabaot; oui, il l'a décidé,pour rabaisser sa splendeur orgueilleuse, pour humilier ces puissants de la terre."
,"10":"Travaille la terre désormais, fille de Tarsis, il n'y a plus de port."
,"11":"Yahvé a étendu la main sur la mer,pour en ébranler les royaumes, il a donné un ordre au sujet de Canaan: ses forteresses seront détruites."
,"12":"Il a dit: 'On ne te verra plus triomphante, fille de Sidon, vierge violentée. Fais la traversée, passe à Kittim, même là tu ne trouveras pas le repos."
,"13":"Regarde le pays des Kaldéens: ce peuple n'existe plus, l'Assyrie l'a livré aux bêtes du désert, ils ont dressé leurs tours, démoli ses palais, ils en ont fait un tas de ruines."
,"14":"Gémissez, vaisseaux de Tarsis, car tout a été dévasté, plus une maison ne reste."
,"15":"Mais voici pour plus tard. Tyr sera oubliée pour soixante-dix ans, la durée d'un règne; au bout de soixante-dix ans ce sera pour Tyr comme dans la chanson de la prostituée:"
,"16":"'Prends ta guitare et fais le tour de la ville, prostituée délaissée, joue de ton mieux: peut-être qu'avec tes chansons on se souviendra de toi.'"
,"17":"Après soixante-dix ans Yahvé visitera Tyr. De nouveau elle retrouvera son salaire en se prostituant dans le monde entier avec tous les royaumes de la terre."
,"18":"Mais ses bénéfices, les cadeaux qu'on lui fait, ne s'accu muleront plus, on ne les mettra pas en réserve. Ses bénéfices seront consa crés à Yahvé, ils iront à ceux qui officient en sa présence; avec cela ils auront bien à manger et ils se vêtiront comme des princes."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Voici que Yahvé déchire la terre, il la défonce; il en boule verse la face et disperse ses habitants."
,"2":"Tous ont le même sort, le peuple et le prêtre, l'esclave et le maître, la servante et la maîtresse, l'acheteur et le vendeur, celui qui emprunte et celui qui prête, le débiteur et le créancier."
,"3":"La terre est toute défoncée, la terre est toute dévastée: Yahvé a parlé."
,"4":"La terre est en deuil, l'univers est usé, le ciel est usé, tout comme la terre."
,"5":"La terre a été souillée par ses habitants, ils ont violé la Loi, faussé les règles et rejeté l'Alliance perpétuelle."
,"6":"C'est pourquoi la malédiction a dévoré la terre: on a fait payer ceux qui l'habitaient. Les habitants de la terre ont été consumés, et peu nombreux sont ceux qui restent."
,"7":"Le vin nouveau est en deuil, la vigne se fane, les coeurs joyeux se lamentent."
,"8":"La joie des tambourins s'est tue, c'en est fini du bruit des fêtes,et le chant de la guitare s'est éteint."
,"9":"Plus de vin, plus de chansons, même la liqueur semble amère."
,"10":"La ville du désordre est en ruines, ses maisons restent fermées."
,"11":"On crie dans la rue: plus de vin!,la joie s'est envolée, les fêtes ont disparu du pays."
,"12":"Ce ne sont plus que ruines dans la ville, la Place est restée sans vie, saccagée.)"
,"13":"Ils sont sur cette terre, là où étaient les peuples, comme les olives après la cueillette, comme les petites grappes après la vendange."
,"14":"Ceux-là élèvent la voix, et ce sont des cris de joie, du rivage de la mer ils acclament Yahvé!"
,"15":"Voici qu'on rend gloire à Yahvé aux îles d'Occident: 'Iles, chantez le Nom de Yahvé, le Dieu d'Israël!'"
,"16":"Nous avons entendu des chants, du plus loin du monde. 'Gloire au Juste!',Or moi, je disais: 'Je suis perdu, tout est perdu!',Mais non: malheur à ceux qui trahissent!"
,"17":"La terreur, le piège et le filet t'attendent, habitant de la terre!"
,"18":"Qui fuit la terreur tombera dans le piège, qui remonte du piège sera pris au filet. Les écluses d'en haut se sont ouvertes, et les bases de la terre ont tremblé."
,"19":"La terre part en morceaux, la terre se fissure; la terre est chavirée."
,"20":"Comme un ivrogne, elle titube en tout sens, comme une cabane elle se balance. C'est qu'elle porte le poids de sa faute, elle tombe pour ne plus se relever."
,"21":"Yahvé, ce jour-là, demandera des comptes,aux puissances du ciel, dans les hauteurs, et sur la terre, aux rois de la terre."
,"22":"Ils seront rassemblés, envoyés prisonniers à la fosse, enfermés dans la prison; après de longs jours ils recevront leur sentence."
,"23":"La lune rougira, le soleil ne saura où se cacher,car Yahvé Sabaot sera roi,sur la montagne de Sion, à Jérusalem, et sa Gloire sera là devant ses Anciens."
}`)
	CurrentBook.AddChapter(25, `{
"1":"Yahvé, tu es mon Dieu! Je veux te célébrer et chanter ton Nom, car tu as réalisé ton oeuvre admirable avec constance, avec fidélité, de puis le lointain passé."
,"2":"Tu as fait de la ville un tas de pierres, de la cité fortifiée, un mon ceau de ruines. La forteresse des étrangers n'est plus une ville, elle ne sera jamais reconstruite."
,"3":"C'est pourquoi un peuple puissant te célèbre, la cité des nations domi natrices tremble devant toi."
,"4":"Tu as été un refuge pour le faible, un refuge pour le pauvre dans sa dé tresse, un toit contre la pluie, une ombre contre la chaleur. Le souffle des tyrans est une pluie d'hiver, "
,"5":"c'est l'ardeur du soleil sur une terre aride. Mais tu rabaisses l'insolence étrangère, comme l'ar deur du soleil par l'ombre d'un nuage. Le choeur des oppresseurs se voit réduit au silence."
,"6":"Sur cette montagne Yahvé Sabaot prépare, pour tous les peuples, un ban quet de viandes grasses, un banquet de bons vins, des viandes juteuses et des vins de qualité."
,"7":"Sur cette montagne il déchirera le voile qui couvrait tous les peuples, le suaire qui enveloppait toutes les nations."
,"8":"Pour toujours il fera disparaître la mort. Le Seigneur Yahvé essuiera les larmes sur tous les visages, il délivrera son peuple de ses humilia tions, il le fera sur toute la terre - c'est Yahvé qui l'a dit."
,"9":"En ce jour-là on dira: 'Voici notre Dieu en qui nous avions mis notre espérance; lui nous a délivrés. Grande est notre joie, notre allégresse, car il nous a sauvés."
,"10":"La main de Yahvé se posera sur cette montagne, tandis que Moab sera piétiné sur place, comme on piétine la paille dans une fosse à fumier."
,"11":"Moab étendra les mains dans sa fosse comme le nageur les étend pour nager, mais Yahvé rabaissera son orgueil quels que soient ses stratagèmes."
,"12":"Tes remparts et ta citadelle imprenable, il les enfoncera, il les jettera à terre, il les réduira en poussière."
}`)
	CurrentBook.AddChapter(26, `{
"1":"En ce jour-là sur la terre de Juda on chantera ce chant: Nous avons une ville forte; avec son mur et son avant-mur,elle est notre salut."
,"2":"Ouvrez les portes, laissez entrer la nation juste, qui demeure fidèle "
,"3":"et qui reste ferme. Tu la gardes en paix,car elle a mis en toi sa confiance."
,"4":"Mettez votre confiance en Yahvé, toujours, car Yahvé sera toujours un rocher."
,"5":"Il a abaissé les habitants de là-haut, il a jeté à terre la cité imprenable, il l'a réduite en poussière."
,"6":"Maintenant on la piétine, sur elle passent les pieds des petits, les pas des pauvres."
,"7":"Le chemin pour le juste est toujours droit, tu aplanis, toi, le sen tier du juste."
,"8":"Tu le sais, Yahvé, nous ne cherchons rien hors du chemin de tes commandements. Ton nom, ton souvenir font le bonheur de nos âmes; "
,"9":"de nuit mon âme aspire à toi, et dès le matin mon esprit est en éveil. Lorsque tes sentences atteignent la terre, les habitants du monde appren nent la justice; "
,"10":"mais fait-on grâce au méchant, il n'apprend pas la justice, il commet le mal dans le pays de la droiture, il ne voit pas la majesté de Yahvé."
,"11":"Yahvé, ta main menace mais ils ne le voient pas. Qu'ils voient ton amour pour ton peuple et qu'ils en soient couverts de honte. Que le feu de ta colère dévore tes ennemis."
,"12":"O Yahvé, donne-nous la paix, toi seul peux mener à bien ce que nous faisons."
,"13":"Yahvé, notre Dieu, d'autres maîtres que toi nous ont dominés, mais nous ne connaissons que toi et nous célébrons ton nom."
,"14":"Les morts ne revivront pas, les ombres ne se relèveront pas, car tu les as jugés, tu les as fait périr; tu as effacé jusqu'à leur souvenir."
,"15":"Yahvé, tu as fait grandir la nation, tu l'as fait grandir pour ta gloire et tu as repoussé les frontières du pays."
,"16":"Dans le malheur nous t'avons recherché, au temps de l'oppression et de tes châtiments."
,"17":"Tu nous vois, Yahvé, semblables à la femme enceinte sur le point d'en fanter, qui se tord et crie dans les douleurs."
,"18":"Nous avons conçu, nous avons connu les douleurs, mais nous n'avons en fanté que le vent, nous n'avons pas apporté le salut à la terre, et les nouveaux habitants du monde ne sont pas nés."
,"19":"Que tes morts revivent, que tes cadavres se relèvent! Que se réveillent et crient de joie ceux qui sont retournés à la poussière! Car ta rosée est rosée de lumière, et la terre nous rendra vivants ses morts."
,"20":"Va, mon peuple! Entre dans tes chambres, ferme la porte derrière toi, cache-toi ne serait-ce qu'un instant, le temps que passe la Colère!"
,"21":"Car voici que Yahvé sort de sa retraite pour faire payer leurs crimes aux habitants de la terre. La terre laissera voir le sang répandu, elle ne cachera plus ceux qu'on a massacrés."
}`)
	CurrentBook.AddChapter(27, `{
"1":"En ce jour-là, avec son épée dure, grande et forte, Yahvé s'en prendra à Léviathan, le serpent fuyard, Léviathan, le serpent perfide; il tuera le dragon qui est dans la mer."
,"2":"En ce jour-là vous direz: Chantez la vigne magnifique!"
,"3":"'Moi, Yahvé, j'en suis le gardien, sans cesse je l'arrose de peur que son feuillage ne tombe; nuit et jour je la garde.'"
,"4":"- 'Je n'ai pas de clôture: d'où me viennent ces épines et ces ronces?','Je leur ferai la guerre et les brûlerai toutes ensemble "
,"5":"à moins qu'on se range sous ma tutelle et qu'on fasse la paix avec moi. Il faudra faire la paix avec moi.'"
,"6":"Dans l'avenir Jacob poussera des racines, Israël aura des bourgeons et des fleurs,et ses fruits couvriront la face de la terre."
,"7":"Yahvé ne l'a pas frappé comme il a frappé ceux qui l'opprimaient, il ne l'a pas exterminé comme il a fait pour ceux qui le massacraient."
,"8":"Il a pris à partie cette ville, il l'a vidée en les chassant par son souffle violent comme un jour de vent d'orient."
,"9":"Mais voici comment sera pardonnée la faute de Jacob, comment il effacera les traces de son péché: il devra mettre en pièces les autels, en écraser les pierres comme la pierre à chaux et ne laisser debout, ni les idoles, ni les autels à parfums."
,"10":"La ville fortifiée est une solitude, une demeure abandonnée, inhabitée comme un désert; le veau en a fait sa pâture, il s'y couche et broute le feuillage."
,"11":"On brise les branches desséchées, puis les femmes viennent y mettre le feu. C'est que ce peuple est sans intelligence, c'est pourquoi son créateur n'a pas pitié de lui; celui qui l'a façonné ne l'épargne pas."
,"12":"Cependant le jour viendra où Yahvé battra les épis depuis le Fleuve jusqu'au torrent d'Egypte, et vous, fils d'Israël, vous serez ramassés un par un."
,"13":"En ce jour-là la corne sonnera, les déportés d'Assyrie reviendront,avec les exilés en terre d'Egypte; ils viendront se prosterner devant Yahvé, sur la montagne sainte à Jérusalem."
}`)
	CurrentBook.AddChapter(28, `{
"1":"Malheur à cette ville, prétentieuse couronne des ivrognes d'Ephraïm, splendide parure aux fleurs fanées,sur le haut d'une riche vallée: ils sont tous là à cuver leur vin!"
,"2":"Un homme fort et puissant, envoyé par le Seigneur, la jette à terre de sa main, comme un orage de grêle, une tempête désastreuse, comme l'inondation des eaux déchaînées."
,"3":"Elle sera piétinée, la prétentieuse couronne des ivrognes d'Ephraïm."
,"4":"Leur splendide parure aux fleurs fanées,sur le haut d'une riche vallée,sera comme une figue mûre avant l'été: celui qui la voit la cueille et la mange."
,"5":"En ce jour-là, Yahvé Sabaot sera pour le reste de son peuple une parure splendide, un bijou magnifique."
,"6":"Il se fera esprit de justice pour celui qui siège au tribunal; il se fera vaillance pour ceux qui défendent les portes de la ville."
,"7":"Eux aussi divaguent sous l'effet du vin, la liqueur les fait tituber, prêtres et prophètes sont sous le coup de la boisson. Le vin les égare, la liqueur trouble leurs sens, ils divaguent dans leurs visions, ils bredouillent leurs sentences."
,"8":"Sur toutes les tables des vomissements, plus un endroit propre!"
,"9":"- 'Qui prétend-il enseigner?,Des enfants à peine sevrés? Des petits bébés?,Qui veut-il instruire? Ce n'est que:"
,"10":"Si tu comprends, tant mieux, si tu ne sais pas, tant pis!'"
,"11":"Eh bien, oui, c'est avec des mots qui font rire, c'est avec une langue étrangère,que Yahvé parlera à ce peuple."
,"12":"Il leur avait dit: 'C'est ici le repos, laissez se reposer celui qui est fatigué, c'est le temps de la pause.',Mais ils n'ont pas voulu entendre."
,"13":"C'est pourquoi la parole de Yahvé sera pour eux: Si tu comprends, tant mieux, si tu ne sais pas, tant pis!,si bien qu'ils marcheront et tomberont à la renverse. Ils se briseront les os, ils tomberont dans le piège et ils seront pris."
,"14":"Ecoutez donc la parole de Yahvé, gouvernants de ce peuple de Jérusalem, vous qui vous moquez du monde!"
,"15":"Vous dites: 'Nous avons un pacte avec la Mort, un contrat avec le séjour des morts, le flot destructeur passera sans nous emporter, car nous avons fait du mensonge notre refuge, nous nous cacherons derrière des paravents!'"
,"16":"Eh bien, voici ce que dit le Seigneur Yahvé: 'Regardez, je pose une pierre en Sion, une pierre de granit, une pierre d'angle, une pierre de valeur, une fondation bien posée: qui s'appuie sur elle ne sera pas déçu."
,"17":"Je ferai que le droit soit la mesure, et la justice, le fil à plomb. La grêle balaiera le refuge illusoire, et les eaux emporteront votre abri."
,"18":"Votre pacte avec la mort sera rompu, votre contrat avec le séjour des morts ne tiendra pas; le flot destructeur passera et vous emportera."
,"19":"Chaque fois qu'il passera, il vous saisira, matin après matin, de jour comme de nuit, et si vous captez quelque message, vous n'y lirez que l'épouvante."
,"20":"'Le lit sera trop court pour s'y allonger.',la couverture trop étroite pour s'y enrouler.'"
,"21":"Comme au Mont-des-Brèches, Yahvé surgira, il s'excitera comme au val de Gabaon,pour mener à bien son oeuvre, une oeuvre étrange, pour faire son travail, un travail étonnant!"
,"22":"Vous donc cessez de vous moquer, de peur qu'on ne resserre vos liens. Sachez-le: Destruction totale et pour tout le pays, voilà ce que j'ai entendu de Yahvé Sabaot."
,"23":"Ouvrez vos oreilles, entendez ma voix, faites attention, écoutez ce que je dis."
,"24":"Le paysan passe-t-il tout le jour à labourer, à retourner et travailler sa terre?"
,"25":"Mais non: sitôt préparé son champ, il sème les épices et répand le cumin. Il met le blé, le millet et l'orge, et sur les bords le seigle."
,"26":"Son Dieu l'a enseigné, lui a donné cette règle."
,"27":"On n'écrasera pas les épices sous le traîneau, on ne passera pas les roues du chariot sur le cumin, mais on bat les épices avec un bâton, et le cumin avec un fléau."
,"28":"Quand on bat le blé on n'insiste pas trop, on fait passer l'attelage et les roues du chariot, mais on ne l'écrase pas."
,"29":"Tout cela vient de Yahvé Sabaot, il prévoit, et c'est merveilleux, il agit, et ce sont de grandes choses."
}`)
	CurrentBook.AddChapter(29, `{
"1":"Malheur à toi Ariel, Ariel,cité où David a dressé sa tente!,Ajoutez un an à l'année présente, une année liturgique avec ses fêtes,"
,"2":"et puis j'assiégerai Ariel: voilà les pleurs et les gémissements!,Tu seras pour moi comme un lion de Dieu."
,"3":"Car je campe contre toi, comme David, je t'entoure de défenses, contre toi je lève mes machines de guerre."
,"4":"Tu parleras du fond de ta fosse, tes mots viendront de plus bas que la terre, comme la voix d'un fantôme souterrain, une parole étouffée par la poussière du sol."
,"5":"Mais la nuée des étrangers se fera poudre fine, la masse adverse sera comme paille au vent. Car de façon surprenante, d'un seul coup,"
,"6":"le Seigneur, Yahvé Sabaot interviendra,dans le tonnerre, le tremblement de terre, dans un fracas épouvantable, dans l'ouragan, la tempête et la flamme d'un feu dévorant."
,"7":"Ce sera comme un rêve, une vision dans la nuit, pour la foule de ceux qui attaquaient Ariel, pour les armées tout autour, leurs défenses et leurs travaux de siège."
,"8":"Il en sera comme d'un homme affamé: il a rêvé qu'il mange, mais quand il se réveille il est à jeun; ou comme un homme assoiffé: il a rêvé qu'il boit, mais il se réveille épuisé, gorge sèche. Il en sera de même pour toutes ces nations, pour les assaillants de la montagne de Sion."
,"9":"Soyez étonnés, stupéfaits, hébétés, soyez ivres mais non de vin, titubez sans avoir bu!"
,"10":"Car Yahvé a versé sur vous,un esprit de somnolence; Il a bouché vos yeux, prophètes!,Il a voilé votre visage, voyants!"
,"11":"Toutes ces révélations ont été pour vous comme les paroles d'un rouleau cacheté. Si on le donne à quelqu'un qui sait lire et qu'on lui dit: 'Lis ceci', il répondra: 'Je ne peux pas, le rouleau est cacheté.'"
,"12":"Et si on le donne à quelqu'un qui ne sait pas lire, il répondra: 'Je ne sais pas lire.'"
,"13":"Le Seigneur dit: Ce peuple ne m'offre que des paroles, ses lèvres me rendent hommage, mais leur coeur est loin de moi. Leur religion à mon égard ne sert de rien: des obligations humaines qu'on se transmet!"
,"14":"C'est pourquoi je vais continuer de les surprendre: des surprises, encore des surprises!,La sagesse des sages s'y perdra, l'intel ligence des intelligents restera dans le noir.'"
,"15":"Malheur à ceux qui croient se cacher de Yahvé quand ils dissimulent leur projet; ils ont agi dans les ténèbres et ils pensent: 'Qui nous voit, qui saura?'"
,"16":"Vous raisonnez de travers: mettrez-vous sur le même plan le potier et son argile? S'il fait une chose, va-t-elle lui dire: 'Tu ne m'as pas fabriquée'? Celui qu'on a modelé, va-t-il dire au modeleur: 'Tu n'y connais rien'?"
,"17":"Dans peu de temps le Liban deviendra un verger et le verger, par contre, ne sera plus que taillis."
,"18":"En ce jour-là les sourds entendront les paroles du livre et, délivrés de l'obscurité et des ténèbres, les yeux des aveugles verront."
,"19":"Plus que jamais les humbles se réjouiront en Yahvé, les pauvres de ce monde seront de fête pour le Saint d'Israël."
,"20":"Car l'oppresseur aura dis paru et le moqueur sera mort, ceux qui maintiennent l'injustice auront été éliminés:"
,"21":"ceux qui font échouer la bonne cause, ceux qui savent tromper le juge au tribunal, et renvoyer sans rien celui qui est dans son droit."
,"22":"C'est pourquoi voici ce que dit Yahvé, le Dieu de la maison de Jacob, celui qui a racheté Abraham: Désormais Jacob n'aura plus à rougir, son visage désormais ne changera plus de couleur,"
,"23":"car lorsqu'on verra grâce à moi,ses enfants de retour chez lui, tous proclameront la sainteté de mon Nom, la sainteté du Saint de Jacob, et l'on craindra le Dieu d'Israël."
,"24":"Ceux qui divaguaient apprendront la sagesse, et les rebelles se laisseront instruire."
}`)
	CurrentBook.AddChapter(30, `{
"1":"Malheur aux fils rebelles, dit Yahvé; ils font des projets mais sans moi, ils font des alliances que je n'ai pas inspirées. Ils accumulent ainsi péché sur péché."
,"2":"Les voilà qui partent, qui descendent en Egypte sans m'avoir consulté; ils cherchent la protection du Pharaon, ils veulent s'abriter à l'ombre de l'Egypte."
,"3":"Mais la protection du Pharaon tournera à votre confusion, l'ombre de l'Egypte sera pour vous une déception."
,"4":"Vos chefs sont allés à Soan, vos envoyés ont atteint Hanès,"
,"5":"mais tous seront déçus d'un peuple incapable de secourir; ils ne trouveront ni aide ni secours auprès d'eux, mais seulement déception et confusion."
,"6":"Oracle sur les bêtes du Négueb. Traversant les terres éprouvantes, accablantes, de la lionne et du lion rugissant, de la vipère et du serpent volant, ils emportent leurs cadeaux à dos d'âne, leurs trésors, sur la bosse des chameaux, vers un peuple incapable de secourir."
,"7":"L'Egypte! Une aide vaine et illusoire, c'est pourquoi je l'ai surnommé 'Rahab, l'incapable!'"
,"8":"Tu vas écrire ceci sur une tablette; inscris-le sur un document, que ce soit un témoin pour toujours jusqu'au dernier jour."
,"9":"Ecris que c'est un peuple rebelle, que ce sont des fils infidèles, des fils qui n'aiment pas entendre ce qu'enseigne Yahvé."
,"10":"Ils ont dit aux voyants: 'Ne voyez rien!',aux visionnaires: 'Plus de visions sur la réalité!,Dites-nous des choses agréables, voyez des choses fantastiques."
,"11":"Déviez de la route, sortez du chemin, ne nous ramenez plus le Saint d'Israël!'"
,"12":"Vous avez donc rejeté ce message, vous avez recours à l'impôt forcé, aux mensonges, et vous comptez dessus:"
,"13":"eh bien, sachez que cette faute sera comme la fente qui apparaît sur un rempart élevé; elle grandit, elle menace, et soudain, d'un seul coup, le rempart s'écroule."
,"14":"Il s'est brisé comme un vase de potier fracassé sans pitié. On ne trouvera même plus un morceau pour prendre de la braise dans le feu ou puiser de l'eau dans une mare."
,"15":"Et voici ce que dit le Seigneur Yahvé, le Saint d'Israël: 'La conver sion et la patience vous auraient sauvés, la sagesse et la confiance au raient été votre force. Au contraire"
,"16":"vous avez dit: 'Nous aurons des chevaux pour fuir!' C'est bien: vous fuirez! Vous avez dit encore: 'Nous monterons des chevaux rapides!' Eh bien, ceux qui vous poursuivent seront plus rapides encore!"
,"17":"Devant la menace d'un seul homme, mille trembleront; devant la menace de cinq, vous prendrez la fuite, et il ne restera de vous qu'un reste, sem blable à un piquet sur le sommet de la montagne, à un signal sur une col line."
,"18":"Mais voilà que Yahvé attend pour vous pardonner. Il se lèvera et il aura pitié de vous, car Yahvé est un Dieu juste: heureux tous ceux qui l'attendent!"
,"19":"Oui, peuple de Sion, toi qui habites Jérusalem, ne pleure plus désormais, car dès que tu appelleras il aura pitié de toi, dès qu'il t'aura entendu il répondra."
,"20":"Après que le Seigneur vous aura donné le pain de l'angoisse et l'eau de la détresse, celui qui t'instruit ne se cachera plus et de tes yeux tu ver ras celui qui t'instruit."
,"21":"Lorsqu'il vous faudra prendre le chemin de droite ou de gauche, vous entendrez derrière vous une voix qui dira: 'Voici le chemin, suivez-le.'"
,"22":"Tu regarderas comme impur l'argent de tes idoles sculptées, l'or qui recouvre tes statues de bronze; vous les rejetterez comme des ordures et vous leur direz: 'Hors d'ici!'"
,"23":"Le Seigneur enverra la pluie sur les graines que tu auras semées en terre, et le pain que la terre donnera sera bon et abondant. En ce jour-là tes troupeaux brouteront dans de gras pâturages,"
,"24":"les boeufs et les ânes qui travaillent la terre mangeront un bon fourrage qu'on étendra à la pelle et à la fourche."
,"25":"Au jour du grand massacre, quand les forteresses tomberont, on verra des ruisseaux et des canaux remplis d'eau sur toute haute montagne et sur toute colline élevée."
,"26":"La lumière de la lune deviendra comme la lumière du soleil, et la lumière du soleil sera sept fois plus forte; ce jour-là Yahvé soignera la blessure de son peuple et le guérira des coups qu'il lui a donnés."
,"27":"Voici que le Nom de Yahvé vient d'un pays lointain; sa colère brûle, pesante, écrasante; on lit sur ses lèvres la fureur, sa langue est un feu dévorant,"
,"28":"son souffle est comme un torrent qui déborde et qui vous monte jusqu'au cou. Car il vient détruire les nations et les passer au tamis, il vient mettre un mors à la mâchoire des peuples et il les enverra au diable."
,"29":"Alors vous chanterez comme dans les nuits de fête et vous aurez le coeur plein de joie, comme celui qui va au son de la flûte, au son des tam bourins et des harpes, à la montagne de Yahvé, près du Rocher d'Israël."
,"30":"Yahvé fera entendre sa voix puissante, il déchaînera la violence de sa colère avec la flamme d'un feu dévorant, avec la tempête, l'ouragan et la grêle."
,"31":"L'Assyrie tremblera à la voix de Yahvé qui la frappe,"
,"32":"car voici qu'il la frappe et qu'il la frappe encore."
,"33":"Oui, le bûcher est déjà préparé, il est aussi pour le roi! Un grand, un large bûcher, où le feu et le bois ne manquent pas. Le souffle de Yahvé, comme un torrent de soufre fera prendre le feu."
}`)
	CurrentBook.AddChapter(31, `{
"1":"Malheur à ceux qui vont chercher du secours en Egypte, et se croient sauvés avec de la cavalerie! Là les chars sont nombreux, les cava liers sont forts, et ils se sentent rassurés. Mais ils n'ont pas regardé vers le Saint d'Israël, ils n'ont pas consulté Yahvé."
,"2":"Pourtant Yahvé est sage, et très capable d'amener le malheur. Lui ne manquera pas à sa parole: il se lèvera contre le parti des malfaiteurs et contre l'aide qu'attendent les méchants."
,"3":"L'Egyptien est un homme, il n'est pas Dieu: ses chevaux sont chair et non esprit. Au premier coup, si Yahvé frappe, celui qui portait secours trébuchera, celui qu'on secourait tombera, les deux seront éliminés."
,"4":"Car voici ce que Yahvé m'a dit: 'Lorsque le lion ou le lionceau gronde sur sa proie, la foule des bergers peut bien se rassembler contre lui: il n'a pas peur de leurs cris, il ne s'effraye pas de leur nombre. C'est ainsi que Yahvé Sabaot descendra pour combattre sur la hauteur du Mont Sion."
,"5":"Comme les oiseaux étendent leurs ailes, Yahvé Sabaot veillera sur Jérusa lem; il couvrira et sauvera, il épargnera et fera qu'on en réchappe."
,"6":"Revenez donc, fils d'Israël, vers celui que vous avez tellement trahi."
,"7":"En ce jour-là on rejettera ces idoles d'argent, ces idoles d'or que vous avez fabriquées de vos mains."
,"8":"L'Assyrie sera abattue, mais ce ne sera pas l'épée d'un homme; l'épée la dévorera, mais pas l'épée des mortels. Elle s'enfuira devant l'épée et ses jeunes gens seront réduits en esclavage."
,"9":"Prise de panique elle fuira sans s'arrêter sur ses défenses, et ses chefs, épouvantés, abandonneront leur drapeau. Ceci est parole de Yahvé, dont le feu est en Sion et le brasier à Jérusa lem."
}`)
	CurrentBook.AddChapter(32, `{
"1":"Un roi régnera avec justice et ses chefs gouverneront avec droi ture."
,"2":"Chacun d'eux sera comme un abri contre le vent, un refuge dans la tempête, comme des cours d'eaux dans une terre aride, comme l'ombre d'un grand rocher dans un pays désert."
,"3":"Les yeux des voyants ne seront plus aveugles, les oreilles de ceux qui écoutent seront attentives."
,"4":"Les impatients s'appliqueront à comprendre et ceux qui bégaient parleront clairement sans hésiter."
,"5":"On ne dira plus de l'homme sans conscience qu'il est noble, ni du fourbe qu'il est grand."
,"6":"En effet, l'homme sans conscience dit ce qui heurte la conscience, et ses oeuvres sont mauvaises; c'est un hypocrite qui blasphème contre Yahvé, il laisse l'affamé sans nourriture et retire l'eau à celui qui a soif."
,"7":"Quant au fourbe, ses inventions sont méchantes, il ne pense qu'à perdre les humbles par ses paroles mensongères, alors qu'en face le pauvre dit la vérité."
,"8":"L'homme au coeur noble, par contre, a de nobles pensées, et ses actes aussi sont nobles."
,"9":"Levez-vous, écoutez ma voix, femmes insouciantes! Prêtez l'oreille à ma parole, filles sans cervelle!"
,"10":"Oui, dans un an et quelques jours, vous tremblerez, filles sans cervelle, car ce sera la vendange mais la ré colte ne viendra pas."
,"11":"Soyez effrayées, insouciantes, tremblez, filles sans cervelle, retirez vos vêtements, dépouillez-vous, puis mettez un sac sur vos reins."
,"12":"De vant les belles campagnes et les riches vignobles, lamentez-vous, frappez-vous les seins."
,"13":"Car voici que les épines et les ronces grandissent sur la terre de mon peuple, et sur les maisons joyeuses de la ville en fête."
,"19":"Mais la forêt tombera sous la grêle tandis que la ville sera humiliée."
,"14":"La forteresse est abandonnée, la ville bruyante est déserte, l'Ophel et la tour fortifiée ont été ruinées pour toujours: elles font le bonheur des ânes sauvages, et les troupeaux y cherchent leur pâture."
,"15":"Mais alors l'Esprit se répandra sur nous d'en haut, le désert se changera en verger et ce verger sera ouvert à tout le monde."
,"16":"La droiture aura sa tente dans le désert et la justice habitera le verger."
,"17":"La justice apportera la paix; le fruit de la justice sera la tranquil lité et la sécurité pour toujours."
,"18":"Mon peuple habitera des maisons pai sibles, des demeures tranquilles dans des lieux sûrs."
,"20":"Quel bonheur pour vous de semer au bord des eaux et de laisser paître en liberté le boeuf et l'âne!"
}`)
	CurrentBook.AddChapter(33, `{
"1":"Malheur à toi, pillard qui n'a pas été pillé, traître qui n'a pas été trahi!,Quand tu auras fini de piller, tu seras pillé, quand tu auras bien trahi, tu seras trahi."
,"2":"Mais toi, Yahvé, aie pitié de nous, c'est en toi que nous espérons. Sois notre force chaque matin, notre sauveur au jour de la détresse."
,"3":"Au son de ta voix les peuples s'enfuient, tu te lèves et les nations se dispersent."
,"4":"Votre butin, ô nations, sera ramassé,tout comme fait la sauterelle; comme un nuage de sauterelles on se jettera dessus."
,"5":"Yahvé est élevé: il siège dans les hauteurs, lui qui comble Sion de justice et de droiture."
,"6":"Il assure en tout temps ta sécurité: sagesse et connaissance sont la richesse qui sauve, la crainte de Yahvé sera ton trésor."
,"7":"Comme on se lamente en Ariel dans les rues!,les messagers de paix pleurent amèrement,"
,"8":"les routes sont désertes, plus de passants sur les chemins. On n'a pas respecté l'alliance, on a méprisé les témoins, on n'a même pas été correct."
,"9":"La terre est en deuil, elle est épuisée; le Liban se cache le visage et se dessèche, Saron est devenu comme une steppe, Bashan et le Carmel tremblent."
,"10":"Maintenant, dit Yahvé, je me lève, maintenant je me dresse de toute ma hauteur."
,"11":"Vous avez conçu du foin, vous enfanterez de la paille, et mon souffle vous dévorera comme le feu."
,"12":"Les peuples seront brûlés, calcinés, dévorés par le feu comme des épines coupées."
,"13":"Vous qui êtes au loin, sachez ce que j'ai fait, vous qui êtes tout près, mesurez ma puissance."
,"14":"Dans Sion les pécheurs ont tremblé, les hypocrites ont été pris de panique. 'Qui de nous tiendra dans ce feu dévorant?,Qui pourra séjourner, sans fin, dans un brasier?'"
,"15":"Celui qui marche dans la justice,et qui dit la vérité, celui qui refuse les profits malhonnêtes, qui refuse de se laisser acheter, qui ne veut pas entendre parler de violence, et ne regarde pas les moyens de mal faire."
,"16":"Celui-là habitera sur les hauteurs, une roche inaccessible sera son refuge, le pain lui sera donné, son eau lui sera assurée."
,"17":"Tes yeux contempleront un roi dans sa splendeur, ils verront le pays élargi sans limites."
,"18":"Alors tu te souviendras de tes terreurs: 'Où est le contremaître, où est l'homme des impôts, celui qui réquisitionnait les jeunes?'"
,"19":"Tu ne verras plus le peuple arrogant, au langage impos sible à comprendre, le peuple dont les mots font rire et n'ont pas de sens.'"
,"20":"Contemple Sion, la ville de nos fêtes, regarde de tous tes yeux Jérusa lem, l'oasis de paix, la tente qui ne sera pas déplacée. Jamais ses pieux ne seront arrachés, nulle de ses cordes ne sera rompue."
,"21":"Yahvé est là, plus magnifique pour nous que les fleuves et les larges canaux. Navires à rames et vaisseaux puissants n'y passeront pas,"
,"22":"mais Yahvé nous gouverne, il nous donne ses lois; Yahvé est notre roi, c'est lui qui nous sauve."
,"23":"Tes cordes ont lâché, tes mâts ne sont plus maintenus et le drapeau n'a pas été hissé; on s'est alors partagé un immense butin, les boiteux eux-mêmes se sont jetés dessus"
,"24":"et personne n'a dit ce jour-là: 'Je suis malade'. Le peuple qui habite ici est pardonné de son péché."
}`)
	CurrentBook.AddChapter(34, `{
"1":"Approchez-vous, nations, pour entendre, et vous peuples, soyez attentifs!,Que le monde et ses habitants, que tout ce qui vit sur terre écoute!"
,"2":"Oui, la colère de Yahvé gronde contre les nations, et sa fureur contre toute leur armée. Il leur a jeté la malédiction et les a livrées au massacre."
,"3":"Les morts sont restés à la rue: on sent la puanteur de leurs cadavres, les montagnes ruissellent de sang,"
,"4":"l'armée entière des astres se défait, les cieux sont roulés comme un livre; leur armée tombe, comme font les feuilles de la vigne, comme tombent celles du figuier."
,"5":"'Mon épée s'est enivrée dans les cieux, et maintenant elle descend pour châtier Edom, le peuple voué à l'anathème.'"
,"6":"L'épée de Yahvé s'est remplie de sang, elle ruisselle de graisse, du sang des agneaux et des boucs, de la graisse des rognons de bélier. Yahvé invite aujourd'hui à Bosra pour un sacrifice, c'est le grand massacre du pays d'Edom."
,"7":"Aujourd'hui tombent les taureaux de leur peuple, leurs boeufs et leurs veaux gras, et la terre ruisselle de sang, la poussière du sol est imprégnée de graisse;"
,"8":"c'est un jour de vengeance pour Yahvé, c'est l'année de revanche dans les luttes de Sion."
,"9":"Leurs torrents se changent en résine, la poussière devient du soufre, leur terre est changée en bitume."
,"10":"Ce pays brûlera nuit et jour, et sa fumée montera éternellement. Il sera aride à jamais, nul n'y passera."
,"11":"Le pélican et le hérisson l'habiteront, la chouette et le corbeau y feront leur nid; le Seigneur tirera le cordeau pour la niveler,et son niveau ne laissera que le vide."
,"12":"Les boucs y habiteront. Il n'y aura plus de chefs pour élire un roi, car ses princes ne seront plus."
,"13":"Les épines pousseront dans ses palais, les ronces et les chardons dans ses forteresses. Ce sera le repaire des chacals,et le domaine des autruches."
,"14":"Les chats sauvages y rencontreront les chacals, et les démons à tête de bouc se répondront l'un à l'autre. Lilit, le mauvais génie des nuits, y aura son gîte pour y prendre son repos."
,"15":"Le serpent y fera son nid et pondra ses oeufs, dans l'ombre il les couvera et les fera éclore. Les vautours s'y rassembleront et seront entre eux."
,"16":"Cherchez donc dans le livre de Yahvé et lisez: Pas un d'eux ne manquera, car c'est sa bouche qui a donné l'ordre,et son esprit les rassemblera."
,"17":"Il tirera au sort, pour chacun d'eux, sa part; de sa main, il partagera le pays au cordeau, et ils le possèderont pour toujours, ils l'habiteront de génération en génération."
}`)
	CurrentBook.AddChapter(35, `{
"1":"Que le désert et la terre aride se réjouissent, que la steppe dise sa joie avec des fleurs; comme le narcisse, "
,"2":"qu'elle se couvre de fleurs, qu'elle pousse des cris de joie, des acclamations!,A elle de recevoir la gloire du Liban, la splendeur du Carmel et de Saron; à eux de voir la Gloire de Yahvé, la splendeur de notre Dieu."
,"3":"Fortifiez les mains qui tombent, affermissez les genoux qui tremblent,"
,"4":"dites aux craintifs: 'Courage, ne craignez pas!,Voici votre Dieu qui vient pour sa revanche, il leur rendra ce qu'ils ont mérité; lui-même vient pour nous sauver.'"
,"5":"Alors les yeux des aveugles verront, les oreilles des sourds entendront,"
,"6":"le boiteux sautera comme un cerf,et la langue du muet chantera sa joie, car des eaux jailliront dans le désert, et des torrents dans la steppe."
,"7":"La terre brûlante se changera en étang, et le pays de la soif en eaux débordantes. Dans le repaire où les chacals étaient chez eux, l'herbe poussera comme les roseaux et les joncs."
,"8":"Il y aura un chemin, une route, qu'on appellera la voie sacrée; l'impur n'y passera pas, car le Seigneur lui-même ouvrira la route,et l'homme sans conscience ne s'y aventurera pas."
,"9":"On n'y verra jamais le lion, les bêtes sauvages n'y monteront pas; on n'en rencontrera pas sur cette route, mais les rachetés y marcheront."
,"10":"Ceux que Yahvé a rachetés reviendront, ils arriveront à Sion tout en fête, on lira sur leur visage la joie qui ne passe pas. Ils déborderont de bonheur et de joie: pleurs et douleurs auront pris fin."
}`)
	CurrentBook.AddChapter(36, `{
"1":"La quatorzième année du roi Ezéquias, Sennakérib roi d'Assyrie attaqua toutes les villes fortifiées de Juda et s'en empara."
,"2":"De Lakish, le roi d'Assyrie envoya son grand échanson à Jérusalem auprès du roi Ezé quias avec une armée importante. Il vint se présenter près du canal de la piscine supérieure, sur le chemin du Champ du Foulon."
,"3":"Alors le gouverneur du palais, Elyaqim fils d'Hilkiyas, le secrétaire Chebna et l'archiviste Yoah fils d'Asaf, sortirent au devant de lui."
,"4":"Le grand échanson leur dit: 'Vous redirez à Ezéquias ces paroles du grand roi, le roi d'Assyrie: Sur quoi peux-tu t'appuyer?"
,"5":"Tu crois peut-être que pour faire la guerre quelques déclarations remplacent la sagesse et la bravoure? Sur qui t'es-tu appuyé pour te révolter contre moi?"
,"6":"Tu t'es appuyé sur l'Egypte. Mais ce n'est qu'un roseau brisé: celui qui s'appuie dessus, il lui entre dans la main et la transperce. Voilà ce qu'est Pharaon, le roi d'Egypte, pour tous ceux qui s'appuient sur lui!"
,"7":"Vous me direz peut-être: C'est en Yahvé notre Dieu que nous mettons notre confiance. Mais c'est bien lui qui avait des hauts-lieux et des autels qu'Ezéquias a fait disparaître; il a donné cet ordre à Juda et à Jérusalem: Vous ne vous prosternerez qu'à Jérusalem et devant cet autel."
,"8":"Fais donc maintenant un pari avec mon seigneur, le roi d'Assyrie: je te donne deux mille chevaux si tu possèdes assez de cavaliers pour les monter."
,"9":"Tu ne pourrais même pas faire reculer le moins puissant des chefs de corps de mon seigneur. Alors que tu comptais sur l'Egypte pour recevoir des chars et des cavaliers,"
,"10":"moi, c'est par la volonté de Yahvé que je suis monté contre ce pays pour le ravager. C'est Yahvé qui m'a dit: Monte contre ce pays et ravage-le!'"
,"11":"Elyaqim, Chebna et Yoah, répondirent au grand échanson: 'Je t'en prie, parle à tes serviteurs en araméen, car nous le comprenons, mais ne nous parle pas en judéen devant tous ces gens qui se trouvent sur le rempart.'"
,"12":"Le grand échanson leur dit: 'Est-ce à ton patron et à toi que mon pa tron m'a envoyé porter ces paroles? N'est-ce pas plutôt à ces hommes assis sur la muraille, qui bientôt devront tout comme vous manger leurs excré ments et boire leur urine?'"
,"13":"Le grand échanson se leva donc et, d'une voix forte, il cria en judéen: 'Ecoutez la parole du grand roi, du roi d'Assyrie;"
,"14":"ainsi a parlé le roi: Ezéquias vous trompe! Il est incapable de vous sauver de ma main."
,"15":"Et qu'il ne vous dise pas de compter sur Yahvé, qu'il ne dise pas: Yahvé nous délivrera sûrement et cette ville ne sera pas livrée entre les mains du roi d'Assyrie."
,"16":"N'écoutez pas Ezéquias. Au contraire le roi d'Assyrie vous dit: Faites la paix avec moi, rendez-vous à moi, et chacun de vous continuera à manger de sa vigne ou de son figuier; chacun de vous boira de l'eau de sa ci terne."
,"17":"Plus tard je viendrai et je vous emmènerai dans un pays sem blable au vôtre, un pays de blé et de vin, un pays de pain et de vignobles."
,"18":"Ezéquias vous trompe quand il vous dit: Yahvé nous délivrera! Est-ce que les dieux des nations ont été capables de sauver chacun son pays de la main du roi d'Assyrie?"
,"19":"Où sont les dieux de Hamat et d'Arpad, où sont les dieux de Chéfarvayim? Où sont les dieux du pays de Samarie? Ont-ils été capables de sauver Samarie de ma main?"
,"20":"Parmi tous les dieux de ces pays, lequel a délivré son pays de ma main? Et Yahvé délivrerait Jérusalem?'"
,"21":"Le peuple gardait le silence, il ne répondit pas un mot car le roi en avait donné l'ordre: 'Vous ne lui répondrez pas!'"
,"22":"Alors le maître du palais, Elyaqim, fils de Hilkiyas, le secrétaire Chebna et l'archiviste Yoah, fils d'Asaf, retournèrent auprès d'Ezéquias, les vêtements déchirés. Ils lui rapportèrent les paroles du grand échanson."
}`)
	CurrentBook.AddChapter(37, `{
"1":"Lorsque le roi Ezéquias entendit ces paroles, il déchira ses ha bits, il se couvrit d'un sac et se rendit à la Maison de Yahvé."
,"2":"Puis il envoya le maître du palais Elyaqim, le secrétaire Chebna et les anciens des prêtres vers le prophète Isaïe, fils d'Amos; tous étaient vêtus de sacs."
,"3":"Ils lui dirent: 'Voici ce que dit Ezéquias: ce jour est un jour de malheur, de châtiment et de honte. L'enfant est pour sortir du sein mater nel, mais la force manque pour accoucher."
,"4":"Que Yahvé ton Dieu entende toutes les paroles du grand échanson, que le roi d'Assyrie, son seigneur, a envoyé pour insulter le Dieu vivant. Que Yahvé ton Dieu punisse les paroles qu'il a entendues; et toi, fais monter une prière en faveur du reste qui tient encore.'"
,"5":"Les serviteurs du roi arrivèrent auprès d'Isaïe."
,"6":"Isaïe leur dit: 'Vous redirez à votre maître cette parole de Yahvé: N'aie pas peur des pa roles que tu as entendues, ces blasphèmes que les serviteurs du roi d'Assy rie ont prononcés contre moi."
,"7":"Je vais agir sur son esprit, lui faire en tendre une nouvelle qui le fera reprendre la route de son pays et, dans son pays, je le ferai tomber par l'épée.'"
,"8":"Le grand échanson repartit vers le roi d'Assyrie qui combattait contre Libna. Le grand échanson savait déjà que le roi avait quitté Lakish"
,"9":"après avoir reçu cette nouvelle: 'Tirhaka, roi de Kouch, s'est mis en route pour te faire la guerre.',De nouveau donc, le roi envoya des messagers à Ezéquias pour lui dire: "
,"10":"'Voici ce que vous direz à Ezéquias, roi de Juda: Tu mets ta confiance en ton Dieu et tu dis que Jérusalem ne sera pas livrée entre les mains du roi d'Assyrie. Mais ton Dieu pourrait bien te décevoir."
,"11":"Tu as entendu ce que les rois d'Assyrie ont fait à tous les pays: ils les ont voués à l'a nathème. Pourquoi toi serais-tu délivré?"
,"12":"Les dieux des nations que mes pères ont exterminées, Gozan, Haran, Récef et les Edénites qui étaient à Tel Bazar, ont-ils été capables de les sauver?"
,"13":"Où sont les rois d'Ha mat, d'Arpad, de Laïr, de Chéfarvayim, de Héna et de Ivva?'"
,"14":"Ezéquias prit la lettre des mains des messagers et la lut, puis il se rendit à la Maison de Yahvé et la déroula devant Yahvé."
,"15":"Ezéquias fit cette prière à Yahvé:"
,"16":"'Yahvé Sabaot, Dieu d'Israël, toi qui sièges sur les Chérubins, dans tous les royaumes de la terre il n'y a pas d'autre Dieu que toi. C'est toi qui as fait le ciel et la terre."
,"17":"Prête l'oreille, Yahvé, entends. Ouvre les yeux, Yahvé, et vois! Entends les paroles de Sennakérib, ses blasphèmes contre le Dieu vivant."
,"18":"C'est vrai, Yahvé, les rois d'Assyrie ont ravagé les pays païens"
,"19":"et ils ont jeté au feu leurs dieux car ce n'étaient pas des dieux. Ce n'était que du bois, de la pierre, l'oeuvre des mains de l'homme; ils les ont donc détruits."
,"20":"Mais maintenant, Yahvé notre Dieu, délivre-nous de sa main, je t'en prie, et tous les royaumes de la terre sauront que toi seul Yahvé, tu es Dieu!'"
,"21":"Isaïe fils d'Amos envoya dire ceci à Ezéquias: 'Voici ce que dit Yahvé, le Dieu d'Israël: J'ai entendu la prière que tu m'as adressée au sujet de Sennakérib, roi d'Assyrie."
,"22":"Ecoute la parole que Yahvé a pro noncée contre lui: Elle te méprise, elle se moque de toi, la vierge fille de Sion, elle secoue la tête en te regardant, la fille de Jérusalem."
,"23":"Qui as-tu insulté avec tes blasphèmes? Contre qui as-tu élevé la voix et levé tes yeux pleins d'orgueil? Contre le Saint d'Israël!"
,"24":"Par la bouche de tes messagers tu as insulté le Seigneur! Tu as dit: avec mes nombreux chars j'ai gravi les sommets des montagnes, les pentes du Liban. J'ai coupé la forêt de cèdres et les plus beaux de ses cyprès. J'ai atteint le plus lointain de ses repaires et son jardin boisé."
,"25":"J'ai creusé et j'ai bu des eaux étrangères, j'ai desséché sous la plante de mes pieds tous les canaux de l'Egypte."
,"26":"On ne t'a donc pas dit que depuis longtemps je préparais cela? Dès le commencement j'ai fait un projet, que maintenant je réalise. Tu devais transformer des villes fortifiées en un tas de ruines;"
,"27":"leurs habi tants, trop faibles, étaient effrayés, apeurés; ils étaient comme l'herbe des champs, comme le gazon encore vert, comme la mousse qui pousse sur les toits, comme le grain qui rouille avant de devenir épi."
,"28":"Mais je sais lorsque tu t'assieds, lorsque tu sors et que tu rentres!"
,"29":"Tu t'es mis en colère contre moi et ton insolence est montée jusqu'à mes oreilles, aussi je vais passer mon anneau à ta narine, et mon mors à tes lèvres, et je te reconduirai par le chemin par lequel tu es venu."
,"30":"Maintenant, voici un signe pour toi, Ezéquias: cette année on mangera du grain tombé; l'an prochain, le grain qui pousse tout seul, mais la troisième année vous sèmerez et vous moissonnerez; vous planterez des vignes et vous en mangerez le fruit."
,"31":"Les rescapés de la maison de Juda donneront de nouveau des racines en bas et des fruits en haut."
,"32":"Car de Jérusalem sortira un reste, et du mont Sion, des survivants. Ce sera l'oeuvre de Yahvé Sabaot et de son soin jaloux."
,"33":"C'est pourquoi, voici ce que Yahvé dit au sujet du roi d'Assyrie: Il n'entrera pas dans cette ville et il n'y lancera pas de flèches. Il ne dressera pas contre elle le bouclier, il ne fera pas monter un remblai,"
,"34":"mais il retournera par le chemin par lequel il est venu. Il n'entrera pas dans cette ville - parole de Yahvé! "
,"35":"Je protégerai cette ville et je la sauverai, par respect pour moi-même et pour mon servi teur David.'"
,"36":"Cette même nuit l'ange de Yahvé sortit et frappa dans le camp des Assy riens 185.000 hommes. Le matin quand on se leva il n'y avait que des ca davres: tous morts!"
,"37":"Sennakérib roi d'Assyrie partit donc et revint séjourner à Ninive."
,"38":"Là, pendant qu'il était prosterné dans la Maison de son dieu Nisrok, ses fils Adramélek et Sarécer le frappèrent de leur épée et prirent la fuite au pays d'Ararat. Asarhaddon, son fils, devint roi à sa place."
}`)
	CurrentBook.AddChapter(38, `{
"1":"En ces jours-là Ezéquias fut atteint d'une maladie mortelle. Le prophète Isaïe fils d'Amos vint le trouver pour lui dire: 'Voici ce que dit Yahvé: Mets ordre à ta maison car tu vas mourir. Tu n'en réchapperas pas.'"
,"2":"Alors Ezéquias tourna son visage contre le mur et fit cette prière à Yahvé:"
,"3":"'Ah Yahvé, je t'en supplie, rappelle-toi comment j'ai marché devant toi avec sincérité et d'un coeur fidèle! J'ai fait ce qui est juste à tes yeux.' Et Ezéquias pleura, pleura beaucoup."
,"4":"Une parole de Yahvé fut alors adressée à Isaïe:"
,"5":"'Va dire à Ezéquias: Voici ce que dit Yahvé, le Dieu de David ton père: J'ai entendu ta prière et j'ai vu tes larmes. Je vais ajouter quinze années à ta vie."
,"6":"Je vous délivrerai de la main du roi d'Assyrie, toi et cette ville; je proté gerai cette ville.'"
,"21":"Isaïe dit: 'Apportez un gâteau de figues et appliquez-le sur l'ulcère, et le roi guérira.'"
,"22":"Ezéquias dit: 'Puis-je être sûr que je monterai encore à la Maison de Yahvé? Je voudrais un signe.'"
,"7":"Isaïe répondit: 'Voici le signe que Yahvé te donne pour te montrer qu'il accomplira la parole qu'il a dite:"
,"8":"Le soleil n'a-t-il pas déjà descendu dix marches sur l'escalier de la chambre d'Akaz? Eh bien, je fais reculer l'ombre de dix marches en arrière.' Et le soleil recula de dix marches sur celles qu'il avait déjà descendues."
,"9":"Poème dédié à Ezéquias, roi de Juda, lorsqu'il fut malade et qu'il guérit de sa maladie:"
,"10":"Il n'est que midi pour moi, me disais-je, et déjà je pars au séjour des morts; on m'y gardera pour le reste de mes ans."
,"11":"Je ne verrai plus Yahvé, me disais-je, sur une terre de vivants, je ne verrai plus aucun des habitants du monde."
,"12":"On a démonté ma demeure, on l'a roulée,comme une tente de berger, loin de moi. Comme un tisserand tu enroulais ma vie, et puis tu me sépares du métier, le soir soudain tombe et tu m'achèves;"
,"13":"j'ai crié jusqu'au matin. Comme un lion il a broyé tous mes os."
,"14":"Comme l'hirondelle je gémis, comme la colombe je dis ma plainte. Mes yeux se sont tournés vers les hauteurs: regarde, Seigneur, et viens à mon aide!"
,"15":"Que lui dire? C'est lui qui l'a fait. Mais ne pourrais-je te louer,des années encore à propos de mon mal,"
,"16":"et que mon coeur vive pour toi, et mon esprit, Seigneur, car tu m'auras guéri, tu m'auras fait revivre?"
,"17":"Voici le mal parti, la santé revenue, tu as repris mon âme de la fosse fatale, rejeté derrière toi tous mes péchés."
,"18":"Attends-tu des morts quelque louange?,la Mort ne sait pas te chanter. Ceux qui descendent dans la tombe, proclameront-ils ta fidélité?"
,"19":"C'est la vie qui te loue, c'est le vivant, comme je fais aujourd'hui; le père enseigne à ses fils ta fidélité."
,"20":"Sauve-moi, Yahvé, et pour toi résonneront nos harpes,dans la Maison de Yahvé tous les jours de notre vie!"
}`)
	CurrentBook.AddChapter(39, `{
"1":"En ce temps-là Mérodak-Baladan, fils de Baladan, roi de Baby lone, envoya des lettres et un cadeau à Ezéquias; il avait appris en effet comment Ezéquias s'était remis de sa maladie."
,"2":"Ezéquias en fut si heureux qu'il montra aux envoyés la salle du trésor avec l'argent et l'or, les aromates, l'huile parfumée, et puis ses armes: en un mot, tout ce qui se trouvait dans ses magasins. Ezéquias leur montra absolument tout dans son palais et dans toutes ses dépendances."
,"3":"Alors le prophète Isaïe vint trouver le roi Ezéquias et lui dit: 'Qu'ont dit ces gens? D'où sont-ils venus?' Ezéquias répondit: 'Ils sont venus d'un pays lointain, de Babylone, pour me voir.'"
,"4":"Isaïe lui dit: 'Qu'ont-ils vu dans ton palais?' Ezéquias répondit: 'Ils ont vu tout ce qu'il y a dans mon palais. Il n'y a rien dans mes magasins que je ne leur aie montré.'"
,"5":"Alors Isaïe dit à Ezéquias: 'Ecoute cette parole de Yahvé Sabaot:"
,"6":"Des jours viendront où l'on emportera à Babylone tout ce qui est dans ton palais, tout ce que tes pères ont amassé jusqu'à ce jour; il n'en restera rien, dit Yahvé."
,"7":"On prendra de tes fils qui seront nés de toi, ceux que tu as engendrés, et on en fera les eunuques du palais royal de Babylone.'"
,"8":"Ezéquias répondit à Isaïe: 'Elle est bonne, cette parole de Yahvé que tu viens de prononcer!' et il ajouta: 'Car au moins durant ma vie, ce sera la paix et la tranquillité.'"
}`)
	CurrentBook.AddChapter(40, `{
"1":"'Consolez, consolez mon peuple, dit Yahvé votre Dieu."
,"2":"Parlez au coeur de Jérusalem, criez-lui ce message: son esclavage a pris fin, sa dette est payée, Yahvé lui a rendu au double pour toutes ses fautes.'"
,"3":"Une voix crie: 'Ouvrez dans le désert la route de Yahvé, tracez dans la steppe un chemin pour notre Dieu."
,"4":"Toute vallée sera comblée, toute montagne et toute colline abaissée, les hauteurs se changeront en plaines, et les monts en larges vallées."
,"5":"La Gloire de Yahvé va se révéler, et tous les mortels ensemble le verront, car la bouche de Yahvé a parlé.'"
,"6":"Une voix m'a dit: 'Crie!',J'ai répondu: 'Que dois-je crier?',- 'Que toute chair est comme l'herbe, et sa grâce comme la fleur des champs."
,"7":"L'herbe se dessèche et la fleur se fane, lorsque sur elles passe le souffle de Yahvé."
,"8":"L'herbe se dessèche et la fleur se fane, mais la parole de notre Dieu demeure à jamais.'"
,"9":"Monte sur une hauteur, toi qui portes à Sion la nouvelle, élève avec force ta voix, toi qui portes à Jérusalem ses nouvelles. N'aie pas peur de crier, dis aux villes de Juda: Voici votre Dieu!"
,"10":"Le Seigneur Yahvé vient avec puissance, son bras lui a tout soumis. Il apporte avec lui son butin: voyez devant lui ses récompenses."
,"11":"Comme un berger il fait paître son troupeau, et son bras le rassemble, il porte les agneaux sur sa poitrine, il mène les brebis qui allaitent."
,"12":"Qui a refermé sa main sur les eaux de la mer, qui a pris les dimensions du ciel,ou recueilli tous les sables du globe?,Qui a pesé les montagnes à la balance, qui a mis les collines sur le plateau?"
,"13":"Et qui a pris la mesure de l'esprit de Yahvé?,Où est le conseiller qui l'assiste?"
,"14":"A-t-il guidé quelqu'un, l'a-t-il éclairé, lui a-t-il enseigné l'art de juger, lui a-t-il fait connaître les voies de la sagesse,et montré les moyens les plus efficaces?"
,"15":"Les nations sont pour lui la goutte au bord du seau, la poussière qu'on néglige sur le plateau de la balance. Et les îles! Elles pèsent comme un grain de sable."
,"16":"Il ne trouverait pas assez de bois au Liban, ses animaux ne lui suffiraient pas pour un holocauste."
,"17":"Les nations sont comme rien devant lui, c'est un zéro, elles ne valent pas pour lui."
,"18":"A qui voulez-vous comparer Dieu?,quelle image pourrez-vous en donner?"
,"19":"Une statue peut-être, coulée par un artisan, que l'orfèvre a plaquée d'or, avec des chaînes d'argent?,Ou bien le bois qu'on a choisi non périssable, travaillé par un expert, solidement fixé pour que rien ne l'ébranle?"
,"20":"Un autre prend du bois,- un bois qui ne pourrit pas; puis il se cherche un bon artisan; et l'on fixe la statue pour qu'elle ne branle pas."
,"21":"Ne l'avez-vous donc pas appris, entendu?,Ne vous l'a-t-on pas dit depuis le début,pour que vous sachiez comment la terre fut mise en place?"
,"22":"Yahvé habite plus haut que la voûte sur la terre: de là ses habitants paraissent des sauterelles. Il a étendu les cieux comme un voile, il les a déroulés, et c'est la tente où il demeure."
,"23":"Il sait réduire à rien les puissants, anéantir ceux qui gouvernent le monde."
,"24":"A peine sont-ils plantés, à peine sont-ils semés, à peine la tige a-t-elle pris racines, que lui, d'un souffle les dessèche, et le tourbillon comme pailles les emporte."
,"25":"'A qui voulez-vous me comparer? dit le Saint. Quelqu'un est-il mon égal?'"
,"26":"Regardez au-dessus de vous: dites-moi qui les a créées?,Vous avez là son armée, il les a déployées, et toutes il les connaît par leur nom; son autorité, sa force sont telles, que pas une n'échappe."
,"27":"Pourquoi dis-tu, Jacob, pourquoi répètes-tu, Israël: 'Yahvé ne voit pas, mon Dieu ne s'occupe pas de ma cause?'"
,"28":"Ne l'as-tu donc pas appris, entendu?,Yahvé est un Dieu éternel, il a créé jusqu'aux extrémités du monde. Il ne se fatigue pas, il ne se lasse pas; sa sagesse est impénétrable."
,"29":"Il rend des forces à qui est fatigué, donne de l'énergie à celui qui est faible."
,"30":"Même les jeunes se fatiguent; mais lorsqu'ils sont las et chancellent,"
,"31":"ceux qui s'appuient sur Yahvé retrouvent des forces; il leur pousse des ailes comme à l'aigle, ils courent et ne se fatiguent pas, ils marchent et ne se lassent pas."
}`)
	CurrentBook.AddChapter(41, `{
"1":"Iles, taisez-vous, écoutez-moi, tous les peuples, venez, approchez-vous!,Et puis vous viendrez prendre la parole, car nous avons à plaider ensemble."
,"2":"Qui a fait venir de l'orient, celui qui a rendez-vous avec la victoire?,Qui lui soumet les nations et les rois?,Son épée les réduit en poussière,son arc, en paille qu'emporte le vent."
,"3":"Il les poursuit sans risques,sur des chemins qu'il ne fait qu'effleurer."
,"4":"Qui a fait cela, qui en est l'auteur?,Moi qui, depuis l'origine, fais monter les générations. Moi, Yahvé, je suis le premier, et je serai encore avec les derniers."
,"5":"Les îles l'ont vu et elles se sont effrayées, les extrémités de la terre en ont tremblé."
,"6":"(Chacun aide son compagnon et lui dit: 'Courage!'"
,"7":"L'artisan encourage l'orfèvre, celui qui finit au marteau encourage celui qui tape sur l'enclume. Il dit de la soudure: 'Elle est bonne', et il la renforce avec des clous pour que rien ne bouge.)"
,"8":"Mais toi, Israël, mon serviteur, Jacob que j'ai choisi, race d'Abraham mon ami,"
,"9":"je t'ai saisi aux extrémités de la terre. Je t'ai appelé d'une région lointaine et je t'ai dit: 'Tu es mon serviteur que j'ai choisi avant tout autre.'"
," 10":"Ne crains rien car je suis avec toi, n'aie pas peur car je suis ton Dieu. Je t'ai donné la force, et puis je t'ai aidé, et je t'ai soutenu de ma main victorieuse."
,"11":"Ceux qui crient après toi s'en iront déçus, confus; tes adversaires seront réduits à rien et périront."
,"12":"Tu chercheras les opposants et tu ne les trouveras plus, ceux qui te font la guerre seront réduits à rien, anéantis."
,"13":"Car moi, Yahvé, je suis ton Dieu. Je t'ai saisi par la main droite et je te dis: 'Ne crains pas, je suis ton secours.'"
,"14":"Ne crains pas, pauvre Jacob, toi Israël, si fragile! C'est moi ton secours - parole de Yahvé. Le Saint d'Israël s'est fait ton rédempteur."
,"15":"Je veux faire de toi une herse, un traîneau tout neuf à doubles dents. Tu écraseras les montagnes, tu les mettras en pièces et tu rendras les collines semblables à la paille."
,"16":"Tu les vanneras et le vent les emportera, l'ouragan les dispersera, et toi, tu seras tout fier de Yahvé; le Saint d'Israël sera ta gloire."
,"17":"Les pauvres cherchent de l'eau, et rien; leur langue est desséchée par la soif. Mais moi, Yahvé, je réponds à leur appel; moi, le Dieu d'Israël, je ne les abandonnerai pas."
,"18":"Je ferai jaillir des torrents sur les montagnes déboisées, des sources au milieu des vallées. Je ferai du désert un étang, et sur la terre aride couleront des fontaines."
,"19":"Dans le désert je planterai le cèdre, l'acacia, le chêne et l'olivier; dans la steppe je mettrai côte à côte le cyprès, le platane et le buis."
,"20":"Alors on verra et on saura, on réfléchira et comprendra tout à la fois, que c'est la main de Yahvé qui a fait ces choses, c'est le Saint d'Israël qui les a créées."
,"21":"Venez défendre votre cause, dit Yahvé, donnez vos arguments, dit le roi de Jacob."
,"22":"Qu'ils s'approchent, et qu'ils nous parlent des événements à venir. Vos prédictions passées, quelles étaient-elles?,Nous y ferons très attention pour en connaître la suite. Ou bien parlez-nous des événements à venir,"
,"23":"annoncez-nous ce qui doit arriver, et nous saurons que vous êtes des dieux. Au moins faites quelque chose, bien ou mal, nous le verrons et nous vous craindrons."
,"24":"Mais non, vous n'êtes rien, et vos oeuvres sont moins que rien: comment peut-on vous choisir?"
,"25":"(Dieu dit:) Du nord je l'ai appelé, et il est venu, depuis l'orient il a été appelé par son nom. Il piétine les gouverneurs comme de la boue, comme le potier quand il prépare son argile."
,"26":"Mais qui l'avait annoncé depuis le début, pour que nous le sachions?,Il fallait le dire à l'avance, et nous pourrions dire: C'est exact!,Mais nul ne l'a annoncé, nul ne l'a fait savoir; personne n'a entendu vos paroles."
,"27":"Moi le premier j'ai dit à Sion: Les voilà!,j'ai dit à Jérusalem: Je t'envoie de bonnes nouvelles!"
,"28":"J'ai regardé: il n'y avait personne chez eux pour donner un avis, pas un que je puisse interroger pour avoir une réponse."
,"29":"Tous ensemble ne sont rien, leurs oeuvres, moins que rien, et leurs statues, du vent et du vide."
}`)
	CurrentBook.AddChapter(42, `{
"1":"Voici mon serviteur que je soutiens, mon élu, celui qu'il m'a plu de choisir. J'ai mis mon esprit sur lui: il établira la justice parmi les nations."
,"2":"Il ne crie pas, il n'élève pas la voix, on n'entend pas ses proclamations sur les places."
,"3":"Il ne brise pas le roseau qui plie, il n'éteint pas la mèche qui faiblit; en toute vérité il fait avancer la justice"
,"4":"Il ne faiblira pas, on ne le brisera pas, qu'il n'ait établi sa justice sur la terre: les îles attendent sa loi."
,"5":"Voici ce que dit Yahvé, le Dieu qui a créé les cieux et les a déroulés, qui a mis en place la terre avec ses produits, et qui donne le souffle aux peuples qui l'habitent, l'esprit, à ceux qui la parcourent."
,"6":"'Moi, Yahvé, je t'ai appelé pour la juste cause, et je t'ai pris par la main et je t'ai façonné; j'ai fait de toi l'alliance du peuple, la lumière des nations,"
,"7":"pour ouvrir les yeux des aveugles, pour faire sortir de prison les captifs, et du cachot ceux qui sont assis dans les ténèbres."
,"8":"Je suis Yahvé, c'est mon nom, je ne laisserai pas ma gloire à un autre, ni mon honneur aux idoles."
,"9":"Les premières choses sont bien arrivées: j'en annonce de nouvelles,et vous les fais connaître avant qu'elles n'arrivent.'"
,"10":"Chantez à Yahvé un chant nouveau!,que sa louange parvienne aux extrémités du monde!,Que les gens de la mer et tout ce qu'elle contient, et les îles et leurs habitants;"
,"11":"que le désert avec ses villes élève la voix, comme les campements où réside Kédar!,Que les habitants de la Roche l'acclament, et que leur chant résonne jusqu'au haut des montagnes!"
,"12":"Que les îles rendent gloire à Yahvé, et proclament ses louanges!"
,"13":"Yahvé s'avance comme un brave, il s'échauffe et s'excite comme un vaillant; le voici qui lance le cri de guerre et rugit, puis il fond sur ses ennemis."
,"14":"'Depuis longtemps j'ai gardé le silence, je me taisais, je me retenais de parler; comme la femme qui enfante je gémissais, je soufflais, j'étais haletant."
,"15":"Je vais ravager les monts et les collines, je dessécherai leur verdure, je ferai tarir les fleuves, et mettrai à sec les étangs."
,"16":"Je conduirai les aveugles sur la route, je les mènerai par des sentiers qu'ils ne connaissaient pas. Les ténèbres pour eux deviendront lumière, je leur aplanirai les endroits difficiles; voilà ce que je ne manquerai pas de faire.'"
,"17":"Ceux qui mettent leur confiance dans les idoles reculeront de honte et seront couverts de confusion, ceux qui disent à des statues: Vous êtes nos dieux."
,"18":"Sourds, entendez! Aveugles, regardez et voyez!"
,"19":"Qui est aveugle, sinon mon serviteur? Qui est sourd comme le messager que j'envoie? Qui est aveugle comme celui que j'ai racheté, et sourd comme le serviteur de Yahvé?"
,"20":"Tu as vu beaucoup de choses mais tu n'as pas fait attention, tu ouvrais les oreilles, mais tu n'entendais pas."
,"21":"Pour son honneur, Yahvé voulait rendre la Loi grande et glorieuse,"
,"22":"mais voilà un peuple pillé et dépouillé! On les a tous jetés dans des cachots, enfermés dans des prisons; ils sont livrés au pillage et personne ne les délivre, on les vole et personne n'est là pour dire: Tu vas rendre!"
,"23":"Qui de vous prêtera l'oreille à ces choses? Qui donnera son attention et commencera d'écouter?"
,"24":"Qui a livré Jacob au pillage, qui a vendu Israël? N'est-ce pas Yahvé contre qui nous avions péché? Ils n'avaient pas voulu suivre ses voies, ni écouter sa Loi,"
,"25":"et lui a déversé sur eux le feu de sa colère, la violence de la guerre. Tout a flambé, mais eux n'ont pas compris; tout a été consumé, ils n'ont pas fait attention."
}`)
	CurrentBook.AddChapter(43, `{
"1":"Et maintenant, voici ce que dit Yahvé, celui qui t'a créé, Jacob, celui qui t'a formé, Israël: N'aie pas peur, puisque je t'ai racheté, je t'ai appelé par ton nom et tu es à moi."
,"2":"Si tu traverses les eaux je serai avec toi, les fleuves ne t'engloutiront pas. Si tu marches à travers le feu, tu ne souffriras pas,et les flammes ne te brûleront pas."
,"3":"Car je suis Yahvé, ton Dieu, le Saint d'Israël, ton Sauveur. J'ai donné l'Egypte pour te racheter, j'ai livré Kouch et Séba en échange de toi."
,"4":"Tu comptes tellement à mes yeux, que je te rachète avec des vies humaines; pour toi je donnerai des peuples, parce que tu vaux pour moi et que je t'aime."
,"5":"N'aie pas peur car je suis avec toi, du levant j'amènerai ta descendance, du couchant je te rassemblerai."
,"6":"Je dirai au nord: 'Donne-les', et au midi: 'Ne les retiens pas, fais venir du plus loin mes fils, et mes filles, des extrémités de la terre,"
,"7":"ramène tous ceux qui portent mon nom, que j'ai créés et formés pour ma gloire."
,"8":"Fais sortir le peuple aveugle et qui a des yeux, les sourds qui ont des oreilles.'"
,"9":"Que les nations se rassemblent toutes et que les peuples se joignent: qui parmi vous nous avait annoncé tout cela, et nous avait fait connaître ce qui est arrivé?,Qu'ils produisent des témoins pour se justifier, en les entendant on pourra dire: 'C'était vrai!'"
,"10":"Vous êtes mes témoins, dit Yahvé. et vous êtes le serviteur que je me suis choisi, sachez-le donc, croyez en moi,et comprenez qui je suis. Aucun Dieu n'a été formé avant moi, et il n'y en aura pas après moi."
,"11":"Il n'y a que moi, moi, Yahvé, et personne ne sauve sinon moi."
,"12":"C'est moi qui ai parlé et qui ai dit juste, c'est moi qui l'ai fait savoir, et non pas un de vos dieux étrangers. Vous êtes mes témoins - parole de Yahvé: c'est moi qui suis Dieu!"
,"13":"Depuis toujours je le suis, et nul ne peut délivrer de ma main, si je fais quelque chose, qui me fera reculer?"
,"14":"Voici ce que dit Yahvé, celui qui vous rachète, le Saint d'Israël: Pour vous j'ai envoyé du monde à Babylone,et j'en ai fait tomber les verrous, chez les Kaldéens la joie s'est changée en pleurs."
,"15":"Je suis Yahvé, votre Saint, le Créateur d'Israël, votre Roi!"
,"16":"Voici ce que dit Yahvé, lui qui ouvrit un chemin à travers la mer, un sentier dans les eaux déchaînées,"
,"17":"qui fit sortir les chars et les chevaux, l'armée, avec tous ses guerriers... Puis ils se sont couchés pour ne plus se relever, ils se sont éteints, consumés comme une mèche."
,"18":"Mais ne parlez plus de ces faits anciens, cessez de penser aux événements du passé,"
,"19":"car voici que je fais une chose nouvelle, elle sort de terre: ne le voyez-vous pas?,Je vais tracer un chemin dans le désert, placer des fleuves dans la terre aride."
,"20":"Les bêtes sauvages me rendront grâces, les chacals et les hiboux du désert, pour avoir donné de l'eau au désert,et des fleuves à la terre aride, afin que boive le peuple que je me suis choisi."
,"21":"Ce peuple, je l'ai créé pour moi: il redira mes louanges."
,"22":"Vois, Jacob, tu ne criais guère vers moi, tu t'étais fatigué de moi."
,"23":"Tu ne m'apportais pas tes agneaux pour un holocauste, tu ne m'honorais pas par des sacrifices. Et moi, je ne t'imposais pas des offrandes, tu n'étais pas taxé pour de l'encens."
,"24":"Tu n'as pas dépensé beaucoup en roseaux parfumés, la graisse de tes sacrifices ne m'a pas étouffé. Tu m'as obligé à supporter tes péchés, j'étais fatigué de tes fautes."
,"25":"Mais moi, moi encore, j'efface tes fautes: je ne me souviendrai plus de tes péchés."
,"26":"Rappelle-moi, que nous mettions les choses au point; explique-toi pour te justifier."
,"27":"Ton premier père a péché, et tes maîtres ensuite ont été infidèles;"
,"28":"c'est pourquoi j'ai rejeté les chefs du Sanctuaire, j'ai livré Jacob à l'anathème, j'ai voulu qu'Israël soit méprisé."
}`)
	CurrentBook.AddChapter(44, `{
"1":"Ecoute donc, Jacob, mon serviteur, Israël, toi que j'ai choisi."
,"2":"Voici ce que dit Yahvé qui t'a fait, qui t'a formé dès le sein maternel et qui t'a sauvé: 'N'aie pas peur, Jacob, mon serviteur, Israël que j'ai choisi."
,"3":"Je répandrai les eaux sur le sol aride, et les eaux courront sur la terre desséchée. Je répandrai mon Esprit sur ta race,et ma bénédiction sera sur tes descendants."
,"4":"Ils grandiront comme l'herbe au bord des eaux, comme des saules plantés près des eaux courantes."
,"5":"L'un dira: 'Je suis à Yahvé', un autre prendra le nom de Jacob, un autre encore écrira sur sa main: 'A Yahvé!',et prendra comme surnom, le nom d'Israël."
,"6":"Voici ce que dit Yahvé, le roi d'Israël, celui qui le rachète, Yahvé Sabaot: 'Je suis le premier et je suis le dernier, il n'y a pas d'autre Dieu que moi."
,"7":"En est-il un comme moi? Qu'il le proclame. Qu'il dise et m'explique,s'il a déjà prédit des signes; et qu'il nous apprenne aussi les choses à venir."
,"8":"Ne vous effrayez pas, n'ayez pas peur: moi, je te l'avais fait savoir, depuis longtemps je l'avais annoncé, n'est-ce pas?,Vous êtes mes témoins: y a-t-il un Dieu autre que moi?,Non, il n'y a pas de Rocher: je n'en connais pas!'"
,"9":"Ceux qui fabriquent des statues ne sont rien, et ces oeuvres qu'ils aiment ne servent à rien. Leurs partisans ne voient pas, ils ne comprennent pas; à la fin ils seront déçus."
,"10":"Quelle idée de façonner un dieu et de fabriquer une statue qui ne sert à rien?"
,"11":"Tous leurs complices seront désappointés et ces artisans en rougiront. Qu'ils se rassemblent tous, qu'ils s'approchent; ils trembleront, et tous ensemble seront couverts de honte."
,"12":"Le forgeron façonne une hache sur les braises, il la forme au marteau et la travaille à la force de son bras; cet homme a faim et ses forces s'usent; s'il n'a pas d'eau à boire, il est épuisé."
,"13":"De son côté le sculpteur sur bois trace des traits, il dessine l'image à la craie et la réalise au ciseau en suivant attentivement le dessin, il prend l'homme comme modèle et lui donne forme humaine pour la mettre dans une maison."
,"14":"Ensuite on est allé débiter un cèdre ou bien telle ou telle sorte de chêne choisi parmi les arbres de la forêt; ou encore on a planté des pins que la pluie a fait grandir."
,"15":"L'homme va brûler le bois pour se chauffer, il l'allume pour cuire son pain; mais il en tire aussi une idole qu'il va adorer, il fabrique une statue et se prosterne devant elle."
,"16":"Ainsi, il en brûle la moitié; avec cette moitié il prépare sa viande, il cuit son rôti et mange, il se chauffe également et dit: 'Ah que c'est bon! Cette flamme me réchauffe!'"
,"17":"Puis avec le reste il fait son Dieu, son idole, et il l'adore; il se prosterne devant elle, il la prie en lui disant: 'Délivre-moi car tu es mon Dieu.'"
,"18":"Ils ne savent pas, ils ne comprennent pas, ils ont des écailles sur les yeux et sont incapables de voir; leur esprit est incapable de comprendre."
,"19":"Aucun ne réfléchit, aucun n'a assez d'intelligence et de bon sens pour se dire: 'J'en ai brûlé la moitié au feu, j'ai fait cuire du pain sur les braises, j'ai rôti de la viande et je l'ai mangée, et maintenant je ferais une idole avec le reste, j'adorerais un morceau de bois!'"
,"20":"Mais non, il s'attache à ce qui n'est que cendre, son esprit aveuglé le fait dérailler. N'essayera-t-il pas de se racheter? Ne sera-t-il pas capable de dire: 'Ce que j'ai dans la main, ce n'est que du vent.'"
,"21":"Souviens-toi de tout cela, Jacob, car tu es mon serviteur, Israël; j'ai fait de toi mon serviteur, ne m'oublie pas, Israël."
,"22":"J'ai dissipé tes fautes comme un nuage, tes péchés comme une nuée, je t'ai racheté, reviens donc à moi."
,"23":"Cieux, criez de joie, et toi terre, fais résonner tes profondeurs: vois ce que Yahvé a fait! Montagnes et forêts, et vous tous les arbres, poussez des cris de joie, car Yahvé a racheté Jacob, il a montré sa gloire en Israël!"
,"24":"Voici ce que dit Yahvé qui te rachète, qui t'a formé dès le sein maternel: C'est moi, Yahvé, qui ai tout fait; moi seul j'ai déroulé les cieux, j'ai affermi la terre: qui était alors avec moi?"
,"25":"Je fais échouer les présages des faux prophètes, je fais délirer les devins, je fais reculer les sages et je change leur science en folie."
,"26":"Je réalise la parole de mes serviteurs, je fais réussir les projets de mes messagers. Aussi je dis de Jérusalem: 'Qu'elle soit de nouveau habitée', et des villes de Juda: 'Qu'elles soient reconstruites, je relèverai les ruines."
,"27":"A la Grande Mer je dis: 'Reste à sec, je ferai tarir tes fleuves!'"
,"28":"Et de Cyrus je dis: Voici mon berger, il accomplira toute ma volonté. Il dira pour Jérusalem: 'Qu'elle soit rebâtie!', et pour le Temple: 'Qu'il soit reconstruit!'"
}`)
	CurrentBook.AddChapter(45, `{
"1":"Voici ce que dit Yahvé à Cyrus, à celui qu'il a consacré: 'Je t'ai pris par la main droite, pour faire plier devant toi les nations, pour défaire la ceinture des rois, pour ouvrir devant toi les portes, et que les portails ne se referment plus."
,"2":"Je marcherai devant toi, j'aplanirai les chemins difficiles; je briserai les portes de bronze,et mettrai en pièces les verrous de fer."
,"3":"Je te donnerai les trésors cachés, les richesses qu'on avait mises en sûreté, et tu sauras que je suis Yahvé, le Dieu d'Israël qui t'a appelé par ton nom."
,"4":"A cause de Jacob mon serviteur, à cause d'Israël que j'ai choisi, je t'ai appelé par ton nom; je t'ai donné un rôle alors que tu ne me connaissais pas."
,"5":"Il n'y a rien sinon moi, Yahvé, il n'y a pas de Dieu en dehors de moi. Je t'ai lancé alors que tu ne me connaissais pas,"
,"6":"pour que l'on sache depuis l'orient jusqu'au couchant, qu'il n'y a rien en dehors de moi. Il n'y a pas d'autre que moi, Yahvé,"
,"7":"celui qui forme la lumière et qui fait les ténèbres, qui mène au succès et qui fait le malheur, tout cela je le fais, moi, Yahvé."
,"8":"Cieux, faites tomber de là-haut la rosée, et que les nuées donnent une pluie de justice. Que s'ouvre la terre, et que fleurisse le salut, tandis que la justice germera: c'est mon oeuvre à moi, Yahvé."
,"9":"Malheur à qui discute avec celui qui l'a formé, quand il n'est qu'un vase entre vases de terre. L'argile dira-t-elle à celui qui la travaille: 'Que fais-tu là?' Elle n'a même pas de mains!"
,"10":"Malheur à celui qui dit à un père: 'Qu'as-tu engendré!' ou à une femme: 'Qu'as-tu mis au monde!'"
,"11":"Voici ce que dit Yahvé, le Saint d'Israël, celui qui l'a formé: Est-ce à vous de me questionner sur mes fils ou de me dire ce que je dois faire?"
,"12":"C'est moi qui ai fait la terre, et j'ai créé l'homme pour l'habiter; de mes mains j'ai étendu les cieux et je commande à toute leur armée."
,"13":"C'est moi de même qui ai lancé Cyrus et ses victoires, et qui lui aplanis tous ses chemins, car il reconstruira ma ville et fera revenir mes déportés, sans demander cadeau ni récompense, - parole de Yahvé Sabaot."
,"14":"Voici ce que dit Yahvé: Le salaire de l'Egypte, avec les produits de Kouch, et les hommes de Séba, tous de grands gaillards, viendront vers toi et seront à toi. Ils marcheront derrière toi et passeront chargés de chaînes, ils se prosterneront devant toi et prieront tournés vers toi: 'Dieu n'est que chez toi, il n'y en a pas d'autre ailleurs. "
,"15":"Tu es Dieu qui aime se cacher, Dieu Sauveur d'Israël!'"
,"16":"Ils seront tous honteux et confus, ils s'en iront couverts de honte, les faiseurs d'idoles,"
,"17":"mais Israël sera sauvé par Yahvé, pour toujours. Plus jamais dans les siècles à venir vous ne connaîtrez la honte ni l'humiliation."
,"18":"Car ainsi parle Yahvé, qui a fait les cieux - car il est Dieu, -,qui a formé et façonné la terre, - car c'est lui qui l'a mise en place: 'Je n'y ai pas mis la confusion, j'ai voulu qu'on y vive, - car je suis Yahvé, et il n'y a pas d'autre;"
,"19":"et de même je n'ai pas parlé en secret, dans quelque endroit caché; et je n'ai pas dit à la race de Jacob: cherchez-moi, mais tout sera confusion, - car moi, Yahvé, je dis vrai et je parle en clair."
,"20":"Rassemblez-vous et venez, et tâchez de comprendre, vous qui survivez parmi les nations: Ceux qui vont avec leur idole de bois ne savent rien: ils prient un dieu incapable de sauver."
,"21":"Sinon, parlez, donnez vos preuves, et s'il le faut, consultez-vous. Qui avait fait savoir ces choses d'avance?,Qui les avait déjà annoncées?,Ne voyez-vous pas que je suis Yahvé,et qu'il n'y a pas d'autre Dieu que moi: il n'est pas de Dieu juste et sauveur sinon moi."
,"22":"Tournez-vous vers moi pour être sauvés, vous tous des quatre coins du monde: Dieu, je le suis, il n'y en a pas d'autre."
,"23":"Je le jure par moi-même, et de ma bouche sort la vérité, la parole dite ne reviendra pas en arrière: Tout genou fléchira devant moi et toute langue proclamera:"
,"24":"'Justice et force ne se trouvent qu'en Yahvé.',Alors viendront vers lui bien humiliés tous ceux qui se dressaient contre lui, "
,"25":"mais pour toute la race d'Israël, ce sera avec Yahvé le triomphe et la gloire."
}`)
	CurrentBook.AddChapter(46, `{
"1":"Bel s'écroule, Nébo s'effondre. On charge leurs statues sur des animaux, sur des bêtes de somme, leurs objets sacrés sont un fardeau pour les bêtes fatiguées."
,"2":"Elles s'affaissent, et avec elles ils tombent, incapables de sauver ceux qui les portent. Eux aussi s'en vont en captivité."
,"3":"Ecoutez-moi donc, maison de Jacob, vous tous qui restez de la maison d'Israël!,Je me suis chargé de vous depuis votre naissance, je vous ai portés depuis le sein maternel."
,"4":"Je ferai ainsi jusqu'à votre vieillesse, et je vous soutiendrai jusqu'à vos cheveux blancs. Je vous porterai encore, je l'ai déjà fait, je vous soutiendrai et je vous sauverai."
,"5":"A qui pouvez-vous me comparer, et qui est comme moi?,Trouverez-vous quelqu'un qui me ressemble?"
,"6":"Voici des gens qui sortent l'or de leur sac, et pèsent l'argent sur une balance. Ils embauchent un artisan pour qu'il leur fasse un dieu; ensuite ils l'adorent et se prosternent devant lui."
,"7":"Ils le portent à l'épaule, ils l'emmènent, et le déposent à sa place. Alors il reste là et ne quitte plus sa place, ils peuvent bien crier, lui ne répondra pas, il ne les sauvera pas du malheur."
,"8":"Souvenez-vous de cela pour en tirer la leçon, pensez bien à cela, infidèles!"
,"9":"Souvenez-vous des événements passés, des choses d'autrefois. Moi je suis Dieu, il n'y en a pas d'autre: il n'y a rien de divin hors de moi."
,"10":"Dès le début, j'annonce ce qui viendra après, je dis d'avance ce qui n'est pas encore fait. Je dis, et mon projet se réalise, tout ce que j'ai voulu se fera."
,"11":"Du levant j'appelle un aigle, d'un pays lointain je fais venir,l'homme qui accomplira mes projets. J'ai parlé, les choses arriveront, j'ai décidé, elles se feront."
,"12":"Ecoutez-moi, gens à la tête dure, si étrangers à la justice."
,"13":"J'ai déjà là ma victoire, elle n'est plus loin, mon salut ne tardera pas. Je donnerai le salut à Sion,et la grandeur sera pour Israël."
}`)
	CurrentBook.AddChapter(47, `{
"1":"Descends, assieds-toi dans la poussière, vierge, fille de Babylone!,Tu n'as plus de trône, assieds-toi par terre, fille des Kaldéens, plus jamais on ne t'appellera la tendre et la délicate."
,"2":"Prends maintenant la double meule,et fais toi-même la farine. Enlève ton voile, relève ta traîne, découvre tes jambes et traverse les fleuves."
,"3":"A ta honte, on te mettra nue, je tirerai vengeance de toi et personne n'interviendra,"
,"4":"- parole de Yahvé Sabaot, celui qui nous rachète; son nom, c'est le Saint d'Israël."
,"5":"Assieds-toi en silence, enfonce-toi dans les ténèbres, fille des Kaldéens, on ne t'appellera plus jamais la reine des royaumes."
,"6":"J'étais en colère contre mon peuple, j'avais rejeté mon héritage, je l'avais livré entre tes mains, mais tu les as traités sans pitié; tu as fait peser sur le vieillard un lourd esclavage."
,"7":"Tu as dit: 'Pour toujours je suis reine.',Mais tu ne réfléchissais pas, tu ne pensais pas à la suite."
,"8":"Maintenant, écoute ceci, toi la délicate, installée dans ton assurance, toi qui penses: 'Il n'y a que moi, rien que moi, jamais je ne serai veuve, jamais je ne serai privée d'enfants.'"
,"9":"Ces deux malheurs vont t'arriver d'un coup, le même jour tu seras veuve et privée d'enfants. Tu auras beau multiplier tes sorcelleries, et faire usage de tes paroles magiques, ces deux malheurs tomberont ensemble sur toi."
,"10":"Tu fais confiance à ta méchanceté, et tu dis: 'Personne ne me voit.',Ta sagesse et ta science t'ont enivrée, au point que tu penses: 'Moi et rien que moi!'"
,"11":"Or le malheur va venir sur toi,et tu ne pourras pas le détourner, une catastrophe va tomber sur toi, que tu ne pourras pas empêcher. Soudain viendra sur toi un désastre dont tu n'as pas idée."
,"12":"Reste donc avec tes sortilèges, et tes nombreuses sorcelleries, sur lesquelles tu t'es fatiguée depuis ta jeunesse; voyons si elles te seront utiles, si tu pourras faire peur au malheur!"
,"13":"Tu t'es fatiguée en consultations de toute sorte: qu'ils se lèvent maintenant et qu'ils te sauvent, ceux qui inspectent le ciel, qui étudient les étoiles, pour te faire savoir chaque mois ce qui doit arriver."
,"14":"Mais ils seront comme la paille, un feu les dévorera, ils ne se sauveront pas des flammes,car ce ne sera pas une braise pour se chauffer, un foyer devant lequel on s'assoit."
,"15":"N'attends rien de plus de tous ceux-là,pour qui tu t'es fatiguée depuis ta jeunesse, ils iront où ils pourront, et nul ne te sauvera."
}`)
	CurrentBook.AddChapter(48, `{
"1":"Ecoutez ceci, maison de Jacob, vous qui portez le nom d'Israël, vous qui êtes la descendance de Juda,et jurez par le nom de Yahvé, vous qui vous adressez au Dieu d'Israël, mais non dans le vrai et droit sens;"
,"2":"vous qui vous réclamez de la Ville Sainte, et vous appuyez sur le Dieu d'Israël,dont le nom est Yahvé Sabaot."
,"3":"Depuis longtemps j'avais annoncé les premiers événements; à peine sortaient-ils de ma bouche que je les faisais connaître. Soudain j'ai agi et ils se sont réalisés."
,"4":"Je savais à quel point tu es têtu, que ta nuque est une barre de fer et que ton front est de bronze."
,"5":"Aussi dès ce temps-là je t'ai annoncé ces choses. Je te les ai fait connaître avant qu'elles n'arrivent, pour que tu ne puisses pas dire: 'C'est mon fétiche qui les a accomplies, c'est ma statue, taillée ou fondue, qui les a ordonnées.'"
,"6":"Tu as tout entendu, tu l'as vu, ne vas-tu pas le reconnaître?,Maintenant, je te fais entendre des choses nouvelles, encore cachées et que tu ne sais pas. "
,"7":"Ce n'est pas dans le passé qu'elles ont été créées, mais maintenant; jusqu'à ce jour tu n'en avais pas entendu parler, donc tu ne pourras pas dire: 'Oui, je le savais.'"
,"8":"Tu ne connaissais rien de cela, tu n'en savais rien, jamais ton oreille ne l'avait entendu; car je savais à quel point tu es rebelle et qu'on t'appelle 'Infidèle-depuis-le-sein-maternel.'"
,"9":"Mais à cause de mon Nom je retiens ma colère. Je veille à mon honneur, aussi je suis patient avec toi et je ne te fais pas disparaître."
,"10":"Regarde, je t'ai purifiée comme l'argent, je t'ai éprouvée au creuset du malheur."
,"11":"Mais à cause de moi je vais agir, oui, à cause de moi: Comment pourrais-je supporter que mon Nom soit profané? Je n'abandonnerai ma gloire à personne."
,"12":"Ecoute-moi Jacob, Israël que j'ai appelé: c'est bien moi! Je suis le premier et je suis aussi le dernier."
,"13":"Ma main a fondé la terre, ma droite a étendu les cieux. Il me suffit de les appeler pour que tous ensemble se présentent."
,"14":"Rassemblez-vous tous et écoutez: qui, de tout ce monde-là, a fait cette annonce: 'Yahvé aime cet homme, il accomplira sa volonté contre Babylone et la race des Kaldéens'?"
,"15":"Moi, oui moi, j'ai parlé, car c'est moi qui l'appelais et qui faisais réussir ses projets.'"
,"16":"'Venez à moi et écoutez: dès le début je n'ai pas parlé en cachette. J'étais présent dès le début de ces événements. Et maintenant le Seigneur Yahvé m'envoie avec son Esprit."
,"17":"Voici ce que dit Yahvé, celui qui te rachète, le Saint d'Israël: 'Je suis Yahvé ton Dieu; je t'instruis pour ton bien et te conduis sur le chemin où tu dois marcher."
,"18":"Si tu avais été attentif à mes lois, ta prospérité serait comme un fleuve, et ta justice comme les vagues de la mer;"
,"19":"ta descendance serait comme le sable, et les fruits de ton sein comme les grains de sable; leur nom ne serait jamais retranché ni effacé de devant moi.'"
,"20":"Sortez de Babel, fuyez de chez les Kaldéens!,Lancez ce cri de joie et qu'on l'entende, qu'il coure jusqu'aux extrémités de la terre, dites: 'Yahvé a racheté son serviteur Jacob!"
,"21":"Ils n'ont pas eu soif au désert où il les menait, pour eux il a tiré l'eau du rocher, il a fendu le roc et les eaux ont jailli.'"
,"22":"Mais pas de paix pour les méchants, dit Yahvé."
}`)
	CurrentBook.AddChapter(49, `{
"1":"Ecoutez-moi, îles lointaines, et que vos peuples soient attentifs!,Yahvé m'a appelé dès le sein de ma mère, il a connu mon nom avant que je sois né."
,"2":"Il a fait de ma bouche une épée tranchante, et m'a gardé dans l'ombre de sa main. Il a fait de moi une flèche aiguisée,qu'il tenait cachée dans son carquois."
,"3":"Il m'a dit: 'Tu es mon serviteur, Israël, c'est par toi que je me ferai connaître.'"
,"4":"Moi, je disais: 'Je me suis fatigué pour rien, ma force s'est épuisée en vain, pour du vent.',Mais Yahvé préservait mes droits, mon Dieu gardait ma récompense. Car j'ai de la valeur aux yeux de Yahvé, et mon Dieu s'est fait ma force."
,"5":"Or voici que Yahvé a parlé, lui qui m'a mis, pas encore né, à son service, pour que je lui ramène Jacob, pour qu'Israël se refasse auprès de lui."
,"6":"Il m'a dit: 'Relever les tribus de Jacob, rassembler les survivants d'Israël, ce ne sera pas là tout ton service: je veux encore faire de toi la lumière des nations, pour que mon salut s'étende à la mesure de la terre.'"
,"7":"Voici ce que dit Yahvé, le Rédempteur et le Saint d'Israël, à cet esclave des tyrans que tous méprisent et que les nations détestent: 'Les rois en seront témoins et se lèveront, les princes se prosterneront! Car Yahvé, le Saint d'Israël, ne peut faillir, et il t'a choisi.'"
,"8":"Ainsi parle Yahvé: Au temps favorable je t'ai écouté, au jour du salut je t'ai porté secours; je t'ai formé et préparé en vue d'une alliance avec le peuple: tu relèveras le pays, tu répartiras les héritages dévastés, "
,"9":"tu diras aux captifs: Sortez! et à ceux qui sont dans le noir: Montrez-vous!,Sur tous les chemins ils pourront paître, ils verront des pâturages sur les montagnes déboisées. "
,"10":"Ils ne connaîtront plus ni la faim ni la soif. Le vent brûlant ni le soleil ne les frapperont plus, car celui qui a pitié d'eux se fera leur guide et les conduira vers les eaux jaillissantes."
,"11":"Il n'y aura plus de montagne que les chemins ne franchissent, et plus de routes en contrebas."
,"12":"Voyez-les qui reviennent des terres lointaines, du nord et de l'ouest, et du pays de Sinim!"
,"13":"Cieux, criez de joie, et toi, terre, sois en fête!,Montagnes, éclatez en cris de joie, car Yahvé console son peuple, il a pitié de ses malheureux."
,"14":"Sion disait: 'Yahvé m'a abandonnée, le Seigneur m'a oubliée.'"
,"15":"- Une femme oubliera-t-elle l'enfant qu'elle nourrit?,N'aura-t-elle plus d'entrailles pour un fils?,Même si l'une d'elles oubliait, moi je ne t'oublierais pas."
,"16":"Regarde, je t'ai gravée sur la paume de mes mains, je ne cesse de penser à tes remparts."
,"17":"Vois comme accourent tes bâtisseurs, alors que se retirent le destructeur et le pillard."
,"18":"Lève les yeux, regarde autour de toi: tous se rassemblent, ils viennent à toi. Par ma vie, dit Yahvé, ils seront ton vêtement de fête, tu feras d'eux ta ceinture de fiancée."
,"19":"Tes ruines, tes déserts et ton pays dévasté, deviendront trop étroits pour tes habitants,car ceux qui te dévoraient seront enfin dehors."
,"20":"De nouveau tes fils - tu en étais privée -,te diront à l'oreille: 'L'endroit est trop petit pour moi, fais-moi de la place, que je puisse m'installer.'"
,"21":"Alors tu diras en ton coeur: 'Qui m'a enfanté ceux-là?,J'étais privée d'enfants et stérile, j'étais rejetée, exilée -,et ceux-ci, qui les a élevés?,Voici que j'étais restée seule, ceux-ci, où étaient-ils?'"
,"22":"Voici ce que dit le Seigneur Yahvé: De la main je fais un signe aux nations, je dresse mon signal à la vue des peuples, et les voici qui ramènent tes fils dans leurs bras, ils t'amènent tes filles sur leurs épaules."
,"23":"Des rois seront tes pères adoptifs,et leurs princesses seront tes nourrices. Le nez à terre ils se prosterneront devant toi, ils lécheront la poussière de tes pieds. Alors tu sauras que je suis Yahvé, et que ceux qui espèrent en moi ne sont pas déçus."
,"24":"Arrache-t-on à un guerrier sa prise?,Le captif d'un tyran s'échappera-t-il?"
,"25":"Eh bien, voici ce que dit Yahvé: La prise du guerrier lui sera enlevée, le captif du tyran lui échappera. Si quelqu'un te prend à partie, je le prendrai à partie, et je sauverai tes fils."
,"26":"Je ferai que tes ennemis dévorent leur propre chair, qu'ils s'enivrent de leur propre sang, et tout mortel saura que moi, Yahvé, je t'ai sauvé, que le Fort de Jacob s'est fait ton rédempteur."
}`)
	CurrentBook.AddChapter(50, `{
"1":"Voici ce que dit Yahvé: Où est la lettre de divorce de votre mère? L'aurais-je renvoyée. A qui dois-je de l'argent, à qui vous aurais-je vendus? C'est à cause de vos fautes que vous avez été vendus, c'est pour vos crimes que j'ai renvoyé votre mère."
,"2":"Pourquoi n'ai-je trouvé personne lorsque je suis venu? Pourquoi n'a-t-on pas répondu quand j'ai appelé? Ma main serait-elle trop courte pour libérer, ne suis-je pas assez fort pour sauver? Il suffit que je menace et la mer se dessèche, la rivière disparaît dans la vallée et ses poissons restent à sec, ils meurent au soleil."
,"3":"J'habille les cieux tout de noir et les oblige à se vêtir d'un sac."
,"4":"Le Seigneur Yahvé m'a formé, pour que je parle comme son disciple, que je sache soutenir celui qui est épuisé. Dès le matin il réveille mon attention,pour que j'écoute comme fait un disciple."
,"5":"Le Seigneur Yahvé m'a ouvert l'oreille,et je ne m'y suis pas refusé, je n'ai pas reculé."
,"6":"J'ai livré mon dos à ceux qui me frappaient, mes joues à ceux qui m'arrachaient la barbe, je n'ai pas dérobé mon visage aux insultes, aux crachats."
,"7":"Le Seigneur Yahvé est de mon côté, et les insultes ne me touchent pas; aussi je garde un visage de pierre, je sais que je n'aurai pas à rougir."
,"8":"Voici venir mon juge, qui veut s'en prendre à moi?,Allez, comparaissons ensemble, si quelqu'un veut m'accuser, qu'il s'approche!"
,"9":"Si le Seigneur Yahvé est avec moi, qui me condamnera?,Regardez-les, voyez comme ils se défont: ils ne sont plus qu'un vêtement dévoré par les mites."
,"10":"Si quelqu'un parmi vous craint Yahvé, qu'il écoute la voix de son serviteur; si quelqu'un marche dans les ténèbres, là où ne brille nulle lumière, qu'il mette sa confiance dans le Nom de Yahvé, qu'il s'appuie sur son Dieu."
,"11":"Mais vous tous qui allumez un feu, et qui faites autour un cercle de braises, allez donc aux flammes de votre feu, et brûlez avec vos bois embrasés: vous vous roulerez dans vos tourments,et cela vous viendra de ma propre main."
}`)
	CurrentBook.AddChapter(51, `{
"1":"Ecoutez-moi, vous qui poursuivez la justice, vous qui cherchez Yahvé, revenez à votre origine, voyez le rocher, la carrière d'où vous avez été tirés,"
,"2":"regardez Abraham, votre père, et Sara qui vous a enfantés. Je l'ai appelé alors qu'il était seul, je l'ai béni et je l'ai multiplié."
,"3":"Or voici que Yahvé réconforte Sion, il rend la vie à ses ruines; de son désert il fait un paradis, et de la steppe, un jardin de Yahvé. Ce ne seront que joie et fête, actions de grâce et chansons."
,"4":"Peuples, soyez attentifs, et vous, nations, écoutez-moi, car de moi sortira la loi, et mes sentences seront la lumière des nations!"
,"5":"Je vais révéler, d'un seul coup, ma justice, et mon salut apparaîtra: c'est moi qui gouvernerai les peuples. Les îles aussi espèrent en moi, elles attendent mon intervention."
,"6":"Levez vos yeux vers le ciel, et puis abaissez vos regards vers la terre: voyez les cieux qui se dissipent, s'en vont en fumée, la terre qui se défait comme un vêtement: ses habitants meurent comme des mouches!,Mais mon salut restera pour toujours, ma justice ne passera pas."
,"7":"Ecoutez-moi, vous qui connaissez le droit -,toi mon peuple qui portes ma loi dans ton coeur. N'aie pas peur des injures des hommes, ne crains pas devant leurs insultes."
,"8":"Car la mite les dévorera comme un vêtement, la vermine les rongera comme la laine, mais ma justice restera pour toujours, mon salut sera là tout au long des siècles."
,"9":"Réveille-toi, réveille-toi, arme-toi de force, bras de Yahvé! Réveille-toi comme aux jours d'autrefois, dans les générations passées! N'est-ce pas toi qui as fracassé Rahab, transpercé le dragon?"
,"10":"N'as-tu pas mis à sec la mer, les eaux du grand abîme, tracé un chemin sur le sol profond des eaux, pour y faire passer ceux que tu rachetais?"
,"11":"De même reviendront les rachetés de Yahvé. Ils entreront dans Sion poussant des cris de joie, avec sur leur visage la joie qui ne passe pas; joie et fête seront au rendez-vous, la tristesse et les plaintes auront fui."
,"12":"C'est moi, oui, c'est moi qui vous réconforte. Comment peux-tu craindre un homme mortel, l'homme qui passe tout comme l'herbe?"
,"13":"As-tu oublié Yahvé, ton Créateur, qui a tendu les cieux et fondé la terre? Pourquoi donc en es-tu toujours à craindre la fureur de l'oppresseur, comme s'il allait tout détruire?,Où donc est la fureur de l'oppresseur? "
,"14":"Bientôt le prisonnier sera relâché, il ne mourra pas dans son cachot et le pain ne lui manquera plus."
,"15":"Je suis Yahvé, ton Dieu, qui soulève la mer et mets en fureur ses vagues, mon nom est Yahvé Sabaot!"
,"16":"Dès le temps où j'étendais les cieux et fondais la terre, j'ai mis mes paroles dans ta bouche. Je t'ai caché dans l'ombre de ma main et j'ai dit à Sion: 'Tu es mon peuple.'"
,"17":"Réveille-toi, réveille-toi, Jérusalem! Si tu as bu de la main de Yahvé la coupe de sa colère, la coupe qui fait perdre le sens, si tu l'as bue jusqu'à la vider, lève-toi maintenant!"
,"18":"De tant de fils qu'elle avait mis au monde, plus un pour la guider; de tous les fils qu'elle a élevés, pas un qui la prenne par la main."
,"19":"Un double malheur t'a frappée: le pillage et la ruine, la famine et l'épée; pourtant nul ne te plaint ou te console."
,"20":"Tu as vu tes fils étendus sans force au coin des rues, comme l'antilope prise au filet; la colère de Yahvé, la menace de ton Dieu, les avait enivrés."
,"21":"C'est pourquoi écoute ceci, malheureuse, victime de cette ivresse qui n'est pas de vin."
,"22":"Voici ce que dit le Seigneur Yahvé, ton Dieu qui combat pour son peuple: Regarde, je reprends de ta main la coupe qui fait perdre le sens, la coupe de ma colère; jamais plus tu ne la boiras."
,"23":"Je vais la passer à tes ennemis, à ceux qui te disaient: 'Couche-toi que nous passions!' Alors tu t'écrasais sur le sol et l'on passait sur ton dos."
}`)
	CurrentBook.AddChapter(52, `{
"1":"Réveille-toi, réveille-toi, arme-toi de force, Sion! Habille-toi de belles robes, Jérusalem ville sainte, car plus jamais l'incirconcis ou l'impur n'entreront chez toi."
,"2":"Secoue ta poussière et viens prendre ta place, Jérusalem! Arrache les chaînes de ton cou, fille de Sion, la prisonnière!"
,"3":"Car voici ce que dit Yahvé: Vous avez été vendus pour rien, vous serez rachetés sans argent."
,"4":"Oui, c'est le Seigneur Yahvé qui le dit: Mon peuple est descendu autrefois en Egypte pour y séjourner, ensuite l'Assyrie l'a opprimé sans raison."
,"5":"Que ferai-je maintenant, dit Yahvé, quand mon peuple a été enlevé sans que j'y gagne, quand ses maîtres poussent des cris de triomphe et tout au long du jour mon nom est discrédité?"
,"6":"C'est pourquoi ce jour-là mon peuple connaîtra mon Nom. Il saura qui a dit: 'Me voici'."
,"7":"Qu'ils sont beaux sur les montagnes, les pieds du porteur de bonnes nouvelles, de celui qui annonce paix et bonheur, qui proclame le salut et qui dit à Sion: 'Ton Dieu règne!'"
,"8":"Ecoute la voix de tes guetteurs, ensemble ils poussent des cris de joie, car ils l'ont vu de leurs yeux: Yahvé revenait à Sion!"
,"9":"Eclatez toutes en cris de joie, ruines de Jérusalem, car Yahvé a consolé son peuple, il a racheté Jérusalem."
,"10":"Yahvé, le Saint, a retroussé ses manches à la face des peuples, et sur la terre entière on a vu le salut de notre Dieu."
,"11":"Quittez ces lieux, sortez de Babylone!,Vous n'aurez plus à toucher rien d'impur. Sortez du milieu d'elle et purifiez-vous, vous qui portez les objets de Yahvé!"
,"12":"Vous n'en sortirez pas dans l'affolement, vous ne partirez pas comme des fuyards, car Yahvé marchera devant vous, et c'est le Dieu d'Israël qui fermera la marche."
,"13":"Mon serviteur enfin réussira: il s'élèvera et se verra porté au plus haut."
,"14":"Tous ont été horrifiés à son sujet, car il n'avait plus figure humaine, son apparence n'était plus celle d'un homme."
,"15":"De même la multitude des peuples s'émerveillera, et les rois eux-mêmes resteront sans paroles, quand ils verront ce qu'on ne leur a jamais dit, quand ils découvriront ce qu'ils n'ont pas appris."
}`)
	CurrentBook.AddChapter(53, `{
"1":"Qui pouvait croire ce que nous venons d'apprendre, le coup de maître de Yahvé, à qui en avait-il parlé?"
,"2":"Il a grandi devant lui comme un rejeton, comme une racine sortie d'une terre aride, sans éclat ni beauté pour attirer nos regards, et son apparence ne nous a pas séduits."
,"3":"Il était méprisé, rejeté par les hommes, un homme de douleur marqué par la souffrance, l'un de ceux devant qui on se cache le visage; il n'était rien et nous l'avons négligé."
,"4":"Or ce sont nos maladies dont il était chargé, nos plaies qu'il portait. Nous pensions qu'une plaie de Dieu l'avait frappé, humilié,"
,"5":"mais c'est pour nos fautes qu'il était transpercé, c'est à cause de nos péchés qu'il était écrasé; le châtiment qui nous donnait la paix pesait sur lui, et par ses blessures nous vient la guérison."
,"6":"Tous, comme des brebis, nous étions errants, chacun suivait son propre chemin. Yahvé lui a fait porter notre dette à tous."
,"7":"On le maltraitait, mais lui s'humiliait, il n'ouvrait pas la bouche, comme le mouton conduit à l'abattoir, comme la brebis qui se tait devant ceux qui la tondent."
,"8":"Il a été détenu, puis jugé, puis éliminé; qui a réfléchi à son sort?,Car s'il était retranché de la terre des vivants,et frappé, c'était pour le péché de son peuple."
,"9":"On lui a donné une sépulture au milieu des méchants, et sa tombe est avec les riches, alors qu'il n'a pas commis de violence,et qu'il n'y a jamais eu de mensonge en sa bouche."
,"10":"Yahvé a voulu l'écraser par la souffrance, mais s'il offre sa vie en sacrifice de pardon, il verra une descendance, ses jours seront prolongés,et le dessein de Yahvé réussira entre ses mains."
,"11":"Après ses épreuves il sera comblé, il jouira de la pleine connaissance. Mon serviteur, le juste, fera une multitude de justes: il aura pris sur lui leurs péchés."
,"12":"C'est pourquoi il aura sa part au milieu des grands, il partagera le butin avec les puissants, parce qu'il s'est dépouillé jusqu'à la mort,et qu'il a été mis au rang des criminels. Or, il portait sur lui le péché de la multitude,et il intercédait pour les pécheurs."
}`)
	CurrentBook.AddChapter(54, `{
"1":"Crie de joie, toi la stérile qui n'enfantais pas!,Connais la joie, la fête, toi qui ne mettais pas au monde, vois ces enfants de ta ruine, plus nombreux que ceux d'une mère installée - dit Yahvé."
,"2":"Elargis l'espace de ta tente, déroule tes toiles, allonge les cordages, renforce les piquets,"
,"3":"car tu vas déborder à droite et à gauche; ta descendance va dépouiller des nations,et repeupler des villes désertes."
,"4":"Ne crains pas, car tu ne seras plus humiliée; n'aie pas peur, car tu n'auras plus à rougir. Oublie la honte de ta jeunesse, et ne te rappelle plus les humiliations de la veuve."
,"5":"Car te voici épousée par ton Créateur: son nom est Yahvé Sabaot. Celui qui te rachète est le Saint d'Israël: il s'appelle le Dieu de toute la terre."
,"6":"Oui, comme une femme renvoyée et désolée, Yahvé te rappelle. Qui rejettera la femme de ses premières années? dit ton Dieu."
,"7":"Pour un instant je t'avais abandonnée, mais avec grande tendresse je viens te rassembler."
,"8":"La colère m'a emporté, et pour un moment je t'ai caché mon visage, mais l'amour éternel me fait prendre pitié de toi, dit Yahvé, ton Rédempteur."
,"9":"Me voici comme au déluge de Noé; j'ai juré alors que les eaux n'envahiraient plus la terre, et de même, aujourd'hui je le jure, ma colère ou mes menaces ne passeront plus sur toi."
,"10":"Les montagnes peuvent se retirer, les collines peuvent chanceler, mais mon amour ne se retirera pas de toi, mon alliance de paix ne chancellera pas, - ainsi parle Yahvé qui a pitié de toi."
,"11":"Malheureuse, battue par les vents et que nul ne console, regarde: j'embellis tes pierres avec des couleurs, je pose tes fondations sur des saphirs."
,"12":"Je te donne pour créneaux des rubis, tes portes seront bâties avec des pierres rares; ton rempart sera de pierres précieuses."
,"13":"Tous tes fils seront instruits par Yahvé, et tes enfants jouiront d'une paix profonde."
,"14":"Tu seras fondée sur la justice et tu n'auras plus à trembler, car tu seras délivrée de l'oppression, et la terreur ne s'approchera plus de toi."
,"15":"Si l'on t'attaque, cela ne viendra pas de moi, et celui qui s'en prend à toi, tombera devant toi."
,"16":"Regarde, j'ai créé le forgeron qui souffle sur les charbons à la forge pour en tirer des armes; de même j'ai créé le destructeur pour détruire ces armes."
,"17":"Aucune arme forgée contre toi ne pourra t'atteindre; tu fermeras la bouche à qui veut t'accuser; voilà la part des serviteurs de Yahvé, la victoire que je leur garantis - parole de Yahvé."
}`)
	CurrentBook.AddChapter(55, `{
"1":"Holà, vous tous qui avez soif, venez vers les eaux!,Et vous qui êtes sans argent, venez, achetez et mangez!,Venez, achetez sans argent, sans payer, du vin et du lait."
,"2":"Pourquoi dépenser pour ce qui n'est pas du pain, donner votre salaire pour ce qui ne nourrit pas?,Ecoutez-moi bien, et vous mangerez ce qui est bon, vous ferez un festin des meilleurs."
,"3":"Tendez l'oreille et venez vers moi, écoutez, et vous retrouverez vie. Je ferai avec vous une alliance éternelle, je vous accorderai les bienfaits promis à David. "
,"4":"Car j'ai fait de lui un témoin pour les peuples, un chef pour commander aux peuples. "
,"5":"Tu vas appeler une nation que tu ne connaissais pas; une nation qui ne te connaissait pas accourra vers toi,à cause de Yahvé ton Dieu, à cause du Saint d'Israël qui t'a confié cette charge."
,"6":"Cherchez Yahvé pendant qu'il se laisse trouver, tournez-vous vers lui alors qu'il est proche. "
,"7":"Que le méchant abandonne sa voie,et l'homme injuste ses pensées; qu'ils reviennent vers Yahvé qui aura pitié d'eux, vers notre Dieu qui est riche en pardon."
,"8":"Car mes pensées ne sont pas vos pensées, et vos chemins ne sont pas mes chemins - parole de Yahvé."
,"9":"Autant le ciel est élevé au-dessus de la terre, autant mes chemins sont élevés au-dessus des vôtres, et mes pensées au-dessus de vos pensées."
,"10":"De même que la pluie et la neige tombent du ciel,et n'y retournent pas sans avoir arrosé la terre, sans l'avoir fécondée et fait germer,pour qu'elle donne la semence au semeur et le pain à celui qui mange, "
,"11":"de même la parole qui sort de ma bouche ne revient pas à moi sans effet, sans avoir accompli ma volonté et réalisé ce pour quoi je l'ai envoyée."
,"12":"Oui, vous sortirez dans la joie, on vous ramènera en paix. Buttes et monts pour vous crieront de joie, et tous les arbres des champs applaudiront."
,"13":"Le cyprès se lèvera à la place du buisson, et l'on verra le myrte à la place de l'ortie; ce sera un honneur pour Yahvé, un signe éternel qui ne disparaîtra pas."
}`)
	CurrentBook.AddChapter(56, `{
"1":"Voici ce que dit Yahvé: Observez le droit et pratiquez ce qui est juste, car mon salut est proche et ma justice va se révéler."
,"2":"Heureux le mortel qui règle ainsi sa conduite, l'homme qui s'y attache, qui respecte le sabbat au lieu de le profaner et s'abstient de tout ce qui est mal."
,"3":"Le fils de l'étranger qui s'est attaché à Yahvé ne doit pas dire: 'Yahvé me tiendra toujours à l'écart de son peuple.' Et l'eunuque ne doit pas dire: 'Moi, je suis un arbre sec.'"
,"4":"Car voici ce que dit Yahvé pour les eunuques qui respectent ses sabbats, qui choisissent de faire ce qui lui plaît et qui restent fermement attachés à mon Alliance:"
,"5":"La place et la considération que je leur donnerai dans ma Maison et mes parvis, auront plus de valeur pour eux que des fils et des filles; je leur donnerai un nom éternel qui ne sera jamais effacé."
,"6":"Si des étrangers s'attachent à Yahvé pour le servir, s'ils aiment le nom de Yahvé et deviennent ses serviteurs, s'ils respectent le sabbat au lieu de le profaner et restent attachés à mon alliance,"
,"7":"je les ferai venir sur ma montagne sainte, je les comblerai de joie dans ma maison de prière, et leurs holocaustes ou sacrifices seront accueillis sur mon autel. Car ma maison sera appelée Maison-de-Prière pour tous les peuples."
,"8":"Voici ce que dit le Seigneur Yahvé, qui rassemble les déportés d'Israël: J'en rassemblerai bien d'autres autour de lui, en plus de ceux qui sont déjà réunis."
,"9":"Vous tous animaux des champs, et vous toutes bêtes de la forêt, approchez et dévorez!"
,"10":"Tous ces guetteurs sont des aveugles qui ne savent rien, ce sont des chiens muets incapables d'aboyer, qui rêvent et s'allongent et qui aiment dormir."
,"11":"Oui, ce sont des chiens voraces qui n'en ont jamais assez. Ils sont pourtant des bergers, mais incapables de comprendre. Tous cherchent leur intérêt, et chacun suit son propre chemin: "
,"12":"'Venez! Je vais chercher du vin, nous nous enivrerons de liqueurs, et demain sera comme aujourd'hui un grand, un très grand jour!'"
}`)
	CurrentBook.AddChapter(57, `{
"1":"Le juste disparaît mais personne n'y fait attention, les hommes fidèles sont emportés, et personne ne voit que c'est pour leur épargner des malheurs:"
,"2":"ils sont entrés dans la paix. Ceux qui suivent le droit chemin se couchent en paix."
,"3":"Mais vous, les fils de la sorcière, approchez ici, enfants d'adultères et de prostituées!"
,"4":"De qui vous moquez-vous? Contre qui ouvrez-vous la bouche? A qui tirez-vous la langue?,Vous êtes nés dans l'infidélité, vous n'êtes qu'une race de menteurs."
,"5":"Vous vous excitez sous vos arbres sacrés, et sous tout arbre vert; vous égorgez des enfants dans les ravins,et dans les fentes des rochers."
,"6":"Vous choisissez les pierres lisses du torrent, ce sont elles vos dieux. Sur elles vous versez des libations, et vous leur présentez vos offrandes. Pensez-vous que je sois satisfait de cela?"
,"7":"Tu as installé ton lit sur une hauteur, et tu es montée là-haut pour offrir le sacrifice."
,"8":"Tu as placé ton idole derrière les montants de la porte, loin de moi, tu t'es déshabillée, puis tu es montée sur ton lit, pour te livrer à tes excès. Tu as bien profité de ceux dont tu aimes la couche et dont tu admires les idoles."
,"9":"Tu as couru vers Mélek avec des offrandes d'huile, tu lui as offert des parfums en abondance, tu as envoyé des messagers, très loin -,ces enfants que tu as envoyés au séjour des morts."
,"10":"Tu étais fatiguée d'une si longue route, et pourtant tu n'as jamais dit: 'Ça suffit.',Mais non, tu retrouvais ta force,et tu continuais de plus belle."
,"11":"Etais-tu donc sans crainte, ni respect, pour trahir de la sorte?,Tu m'as oublié, tu n'as pas prêté attention. Je me taisais, je fermais les yeux, c'est pourquoi tu n'avais pas peur de moi!"
,"12":"Mais moi, je vais dénoncer ta belle conduite,et ces oeuvres qui ne t'ont servi de rien."
,"13":"Crie donc, on verra si tes idoles te délivrent. Le vent les emportera toutes, un souffle les fera disparaître. Mais celui qui s'abrite en moi, possèdera la terre, ma montagne sainte sera son héritage."
,"14":"Alors on dira: 'Défrichez! Défrichez! Tracez une route! Enlevez les obstacles sur la route de mon peuple!'"
,"15":"Car voici ce que dit le Très-Haut, le Très-Grand, celui qui demeure et dont le Nom est saint: Je suis saint et je réside dans les hauteurs, mais je suis proche de l'homme contrit et humble d'esprit. Je fais revivre l'esprit des humbles et les coeurs brisés."
,"16":"Je ne discuterai pas toujours, et ma colère ne sera pas sans fin; sinon les esprits se décourageraient, ces pauvres vivants que j'ai faits."
,"17":"Il courait après l'argent malhonnête, aussi me suis-je mis en colère: je l'ai frappé, et dans ma colère je lui ai caché ma face. Car lui, le rebelle, il ne faisait que suivre la pente de son coeur."
,"18":"Et j'ai vu sa conduite. Pourtant je le guérirai et je le guiderai, je lui donnerai le réconfort. Et tous les siens qui sont en deuil, "
,"19":"je ferai naître la louange sur leurs lèvres. Paix! paix pour celui qui est loin comme pour celui qui est proche, dit Yahvé, je le guérirai!"
,"20":"Mais les méchants sont une mer dérangée qui ne peut se calmer, dont les eaux rejettent de la vase et de la boue:"
,"21":"Il n'y a pas de paix pour les méchants, dit mon Dieu."
}`)
	CurrentBook.AddChapter(58, `{
"1":"Crie de toutes tes forces, ne te retiens pas, que ta voix retentisse comme un cor! Montre à mon peuple ses fautes, dis ses péchés à la maison de Jacob."
,"2":"Jour après jour ils me recherchent et veulent connaître mes chemins, comme une nation qui pratique la justice et n'oublie pas la loi de son Dieu. Ils me consultent sur leurs devoirs, ils veulent être proches de Dieu."
,"3":"'A quoi nous sert de jeûner, disent-ils, si tu ne le vois pas? Pourquoi faire pénitence si tu n'en tiens pas compte?',C'est que le jour où vous jeûnez, vous traitez vos affaires et vous pressez tous vos ouvriers. "
,"4":"Vous sortez du jeûne pour vous disputer et vous quereller; vous frappez du poing méchamment. Ce n'est pas en jeûnant de la sorte que votre voix se fera entendre là haut."
,"5":"Qu'est-ce qu'un jeûne auquel je prends plaisir, un jour où l'homme s'humilie? S'agit-il de courber la tête comme un jonc, de se coucher sur le sac et la cendre, est-ce cela que tu appelles un jeûne, un jour agréable à Yahvé?"
,"6":"Voici le jeûne qui m'est agréable: détacher les chaînes injustes, défaire les liens du joug, renvoyer libres les opprimés et briser tous les jougs."
,"7":"Tu partageras ton pain avec celui qui a faim, tu accueilleras chez toi les pauvres sans abri, tu vêtiras celui que tu vois nu au lieu de te dérober devant lui, car il est ta propre chair."
,"8":"Alors ta lumière se lèvera comme l'aurore et tes plaies se fermeront vite. Tes mérites iront devant toi, et la Gloire de Yahvé marchera sur tes pas."
,"9":"Alors, si tu appelles, Yahvé répondra. Si tu cries, il dira: Me voici!,Si tu élimines de chez toi le joug, le geste brutal, les paroles méchantes, "
,"10":"si tu partages ton bien avec celui qui a faim, si tu fais que l'opprimé mange à sa faim, ta lumière alors se lèvera dans les ténèbres et tes nuits deviendront lumière de midi."
,"11":"Yahvé te donnera en tout temps le repos; il te mettra à l'aise dans les endroits torrides. Il rafraîchira tes os, il fera de toi un jardin irrigué, dont les eaux jamais ne tarissent."
,"12":"Tu rebâtiras les ruines anciennes, tu relèveras les fondations des âges passés. Tu resteras comme celui qui a réparé les brèches et fait, des ruines, des demeures.'"
,"13":"Evite les marches quand c'est le sabbat, ne fais pas tes courses pendant mon saint jour. Traite le sabbat comme un jour délicieux, fais du jour saint de Yahvé un jour tout spécial. Honore-le, arrête tes activités, laisse là tes intérêts et les discussions d'affaires."
,"14":"Alors tu trouveras en Yahvé ta joie. Je te mènerai par les chemins des sommets et je te nourrirai sur les terres de Jacob, ton père: la bouche de Yahvé a parlé."
}`)
	CurrentBook.AddChapter(59, `{
"1":"Non, la main de Yahvé n'est pas trop courte pour sauver, son oreille n'est pas devenue incapable d'entendre,"
,"2":"mais vos fautes ont creusé un fossé,entre vous et votre Dieu, vos péchés l'ont amené à vous cacher sa face, à ne plus vous entendre."
,"3":"Car vos mains sont souillées de sang, vos fautes se voient sur vos doigts. Le mensonge est sur vos lèvres, la fausseté est sous votre langue."
,"4":"Nul ne réclame à bon droit, nul n'est sincère devant la justice: on part d'un prétexte, on cherche à tromper, on conçoit de méchants projets et il en naît une injustice."
,"5":"Ils ont fait éclore des oeufs de vipère, ils tissent des toiles d'araignée; celui qui mange de leurs oeufs en meurt, et si on les écrase, il en sort un serpent."
,"6":"On ne fera pas de vêtement avec leur toile: nulle de leurs oeuvres ne pourra les vêtir, car ce sont des oeuvres mauvaises, et leurs mains n'ont connu que la violence."
,"7":"Leurs pieds courent au mal, rapides pour verser le sang innocent; leurs projets sont des projets malhonnêtes, ils ne laissent que ruines et destruction."
,"8":"Ils ne connaissent pas le chemin de la paix, dans leurs affaires le droit n'a pas sa place, dans leurs chemins tout est tordu, celui qui y marche ne connaît pas la paix."
,"9":"C'est pourquoi le salut s'est éloigné,et la justice ne peut s'approcher de nous. Nous attendions la lumière, et ce sont les ténèbres, la clarté, et nous marchons dans la nuit."
,"10":"Nous tâtonnons comme des aveugles le long d'un mur, comme ceux qui ont perdu leurs yeux, nous trébuchons en plein midi comme si c'était le soir, et, dans la force de l'âge, nous sommes déjà des morts."
,"11":"Nous grognons tous comme des ours, nous gémissons comme des colombes. Nous attendions le jugement et rien ne vient, le salut, et il reste loin de nous."
,"12":"C'est que nous t'avons été infidèles souvent, nos péchés témoignent contre nous. Oui, nos erreurs sont là avec nous, nous connaissons nos fautes, les voici:"
,"13":"contre Yahvé c'est la trahison, le mensonge, c'est l'infidélité à notre Dieu, et puis c'est la violence et la révolte, nos pensées et nos jugements injustes."
,"14":"On a repoussé méchamment le droit, et la justice s'est tenue à distance; la vérité en prend un coup au tribunal,et la droiture n'y a plus eu accès."
,"15":"La vérité n'existe plus, ceux qui refusent de faire le mal sont dépouillés. Yahvé l'a vu, il n'a pas du tout aimé,que la justice soit absente."
,"16":"Il a vu qu'il n'y avait personne, que personne ne disait rien: il s'en est étonné. Alors il est intervenu lui-même,avec l'appui de sa justice."
,"17":"Il s'en est fait un vêtement, une cuirasse; Il avait sur sa tête le casque du salut, et la vengeance lui servait de tunique: il s'est drapé, comme d'un manteau, de son zèle,"
,"18":"pour rendre à chacun selon ses mérites, la colère à ses adversaires, un juste salaire à ses ennemis."
,"19":"On a connu en occident le Nom de Yahvé, on a vu en orient sa Gloire. Car voici qu'il vient, comme un torrent encaissé que chasse le souffle du Très-Haut."
,"20":"Mais pour Sion - parole de Yahvé -,pour les fils de Jacob revenus de leurs fautes, il viendra comme celui qui rachète."
,"21":"Quant à moi, dit Yahvé, voici l'alliance que je fais avec eux: 'Mon esprit qui est sur toi et mes paroles que j'ai mises dans ta bouche, ne disparaîtront pas de ta bouche ni de celle de tes fils et des fils de tes fils. Cela sera dès aujourd'hui et pour toujours - parole de Yahvé.'"
}`)
	CurrentBook.AddChapter(60, `{
"1":"Debout! Rayonne! Car voici ta lumière,et sur toi se lève la Gloire de Yahvé."
,"2":"Alors que les ténèbres enveloppent la terre, et que les peuples sont dans le brouillard, sur toi Yahvé se lève, et sa Gloire apparaît au-dessus de toi."
,"3":"Les nations alors marchent vers ta lumière, et les rois vers la clarté de ton aurore."
,"4":"Regarde tout autour et vois: tous se rassemblent, ils viennent vers toi; tes fils arrivent de loin,et tes filles sont portées sur les bras."
,"5":"A cette vue tu seras radieuse, ton coeur en frémira et se dilatera, car les trésors d'outremer afflueront chez toi, les richesses des nations viendront jusqu'à toi."
,"6":"Ce sera une invasion de caravanes, de dromadaires de Madian et d'Efa; tous ceux de Saba viendront, apportant l'or et l'encens,et chantant les louanges de Yahvé."
,"7":"Les troupeaux de Kédar aboutiront chez toi, pour ton culte, avec les béliers de Nébayot. On les offrira sur mon autel, ils y seront agréés: je donnerai du prestige à ma noble Maison."
,"8":"Quel est ce vol, dense comme un nuage, comme des colombes vers leur colombier?"
,"9":"C'est que les îles maintenant croient en moi,et les vaisseaux de Tarsis arrivent en tête; de loin ils ramènent tes fils avec leur argent et leur or,à cause du Nom de Yahvé ton Dieu, du Saint d'Israël qui te couvre de gloire."
,"10":"Des étrangers relèveront tes murs,et leurs rois voudront te servir. Dans ma colère je t'avais frappée, et puis dans ma bonté j'ai eu pitié de toi."
,"11":"Tes portes seront toujours ouvertes; on ne les fermera pas, car de jour et de nuit les rois des nations t'apporteront leurs richesses."
,"12":"(Si quelque nation ou royaume refuse de te servir, ils seront détruits, et ces nations seront exterminées.)"
,"13":"La gloire du Liban viendra chez toi; le cyprès, le platane et le buis tout ensemble orneront mon Sanctuaire, pour l'honneur du lieu où reposent mes pieds."
,"14":"Les fils de tes oppresseurs viendront humblement vers toi, ceux qui te méprisaient se prosterneront à tes pieds; ils t'appelleront 'Ville-de-Yahvé, Sion-du-Saint-d'Israël.'"
,"15":"N'étais-tu pas délaissée, méprisée, mise à l'écart? Eh bien, je vais te rendre fière pour tous les âges, je te donne la joie pour toujours."
,"16":"Tu suceras le lait des nations, à toi seront les trésors des rois, et tu sauras que moi, Yahvé, je te sauve, que le Puissant de Jacob t'a rachetée."
,"17":"Je fais venir de l'or pour remplacer le bronze, de l'argent pour remplacer le fer, du bronze pour remplacer le bois, du fer pour remplacer les pierres. Je ferai que seule la paix ait pouvoir chez toi; la justice remplacera tes gouverneurs."
,"18":"On n'entendra plus parler de violence dans ton pays, ni de pillage ou de ruines à l'intérieur de tes frontières. Tu appelleras tes remparts: Salut, et tes portes: Louanges."
,"19":"Plus besoin de soleil pour éclairer tes jours, ni de clartés de lune sur tes nuits; Yahvé sera pour toi lumière perpétuelle, ton Dieu sera ta fierté."
,"20":"Ton soleil ne se couchera pas, ta lune n'aura pas de décroît: Yahvé sera pour toi lumière perpétuelle, car le temps de ton deuil aura pris fin."
,"21":"Tous dans ton peuple seront des justes; ils posséderont le pays pour toujours, ils seront le rejeton que j'ai planté, l'ouvrage que mes mains ont créé pour ma gloire."
,"22":"Le moindre d'entre eux deviendra un millier, le moins considéré, une nation puissante; que vienne le temps et je ferai tout, moi Yahvé, sans traîner."
}`)
	CurrentBook.AddChapter(61, `{
"1":"L'Esprit du Seigneur Yahvé est sur moi: oui, Yahvé m'a consacré, il m'a envoyé,pour porter aux humbles de bonnes nouvelles, pour guérir ceux qui ont le coeur brisé, annoncer aux captifs la libération, à ceux qui sont au cachot, le retour à la lumière;"
,"2":"pour proclamer une année de grâce de Yahvé, le jour où notre Dieu se fera justice. Je dois réconforter ceux qui sont dans la peine,"
,"3":"leur donner une couronne au lieu de cendres, des parfums au lieu de leur deuil, une tenue de fête au lieu d'un esprit abattu. Alors on les appellera: 'Arbres de justice', 'ceux que Yahvé a plantés pour sa gloire.' "
,"4":"Ils relèveront les ruines anciennes, ils reconstruiront sur les restes du passé."
,"5":"Des étrangers s'établiront ici pour veiller sur vos troupeaux, on viendra d'ailleurs pour travailler vos champs et vos vignes."
,"6":"Mais vous, vous serez appelés prêtres de Yahvé. On dira de vous: 'Ce sont les serviteurs de notre Dieu.',Vous vivrez aux frais des nations païennes et vous vous vanterez de leur luxe. "
,"7":"Vous ne connaîtrez plus la honte: vous serez des privilégiés. Ceux de mon peuple auront en leur pays de grands domaines; leur joie sera durable."
,"8":"Car moi, Yahvé, j'aime le droit, je déteste le vol et la fraude; aussi je leur donnerai fidèlement leur récompense et leur accorderai une alliance éternelle."
,"9":"Les nations connaîtront leur race, leur descendance sera célèbre au milieu des peuples; tous ceux qui les verront, verront en eux la race que Yahvé a bénie."
,"10":"Ma joie est toute en Yahvé, mon Dieu m'a mis l'âme en fête!,Il m'a revêtue d'une robe: son salut, et d'un manteau qui est sa justice, tout comme un époux se coiffe de sa couronne, comme la fiancée se met ses bijoux."
,"11":"De même que la terre fait sortir ses pousses, et que dans le jardin germe la graine qu'on y a semée, de même le Seigneur Yahvé fera germer sa justice, avec sa louange, à la face des nations."
}`)
	CurrentBook.AddChapter(62, `{
"1":"A cause de Sion je ne me tairai pas, pour Jérusalem je n'aurai pas de cesse, jusqu'au jour où sa justice comme l'aurore se lèvera, et son salut, comme une torche enflammée."
,"2":"Les nations verront ta justice et tous les rois contempleront ta gloire; ils t'appelleront d'un nom nouveau que Yahvé t'aura donné."
,"3":"Tu seras dans la main de Yahvé une couronne éclatante, une couronne royale dans la main de ton Dieu."
,"4":"On ne t'appellera plus: 'Rejetée!' On ne dira plus de ta terre: 'L'abandonnée.' Mais on t'appellera: 'Mon-plaisir-est-en-elle', et de ta terre on dira: 'L'épousée', car Yahvé trouvera son plaisir en toi, et ta terre aura un époux."
,"5":"Celui qui te rebâtit t'épousera comme un garçon épouse une vierge; comme l'épousée fait la joie de l'époux, tu feras toi aussi la joie de ton Dieu."
,"6":"Sur tes remparts, Jérusalem, j'ai placé des veilleurs: que jamais ils ne se taisent, de jour ou de nuit: 'Vous qui devez rafraîchir la mémoire de Yahvé, ne cessez pas, "
,"7":"ne le laissez pas en paix,jusqu'à ce qu'il rétablisse Jérusalem, et qu'il en fasse la gloire de la terre.'"
,"8":"Yahvé l'a juré par sa droite et par son bras puissant: 'Je ne donnerai plus ton blé à tes ennemis pour qu'ils le mangent, les étrangers ne boiront plus ton vin, fruit de ton travail,"
,"9":"mais ceux qui auront moissonné mangeront leur blé et ils loueront Yahvé; et ceux qui font la vendange boiront leur vin dans les cours de mon Sanctuaire.'"
,"10":"Entrez, franchissez les portes!,Aménagez cette route pour le peuple, rehaussez la chaussée, enlevez les pierres, dressez un signal tourné vers les nations!"
,"11":"Car voici une annonce de Yahvé: qu'on l'entende jusqu'au bout du monde. Dites à la fille de Sion: 'Voici que ton Sauveur vient, il apporte avec lui son butin, ses récompenses le précèdent."
,"12":"Alors on les appellera: 'Peuple saint, Rachetés de Yahvé', et toi, on t'appellera: 'Cité-désirée, Ville-non-abandonnée.'"
}`)
	CurrentBook.AddChapter(63, `{
"1":"Qui est donc celui-ci qui arrive d'Edom, qui vient de Bosra vêtu de rouge?,Son vêtement lui donne fière allure, il se redresse plein d'assurance: 'C'est moi qui parle de justice,et je suis puissant pour sauver.'"
,"2":"- 'Pourquoi ce rouge de ton manteau,et ces habits tachés d'un fouleur au pressoir?'"
,"3":"- 'J'étais seul pour fouler dans la cuve, personne de mon peuple n'est venu avec moi. Aussi dans ma colère je les ai écrasés, dans ma fureur je les ai piétinés , leur jus a giclé sur mes habits, il a taché tous mes vêtements."
,"4":"Oui, j'avais fixé un jour de vengeance, l'année du rachat était venue."
,"5":"J'ai regardé: personne pour m'aider!,J'étais déconcerté: pas un pour me soutenir!,Alors j'ai agi par moi-même, ma fureur m'a donné des forces."
,"6":"J'ai écrasé des peuples dans ma colère, dans ma fureur je les ai brisés,et j'ai répandu à terre leur jus.'"
,"7":"Je veux célébrer les bienfaits de Yahvé,et dire ses louanges. Que n'a-t-il pas fait pour nous?,Quelle bonté pour la maison d'Israël!,Il leur a montré beaucoup de compassion, il leur a multiplié ses bienfaits!"
,"8":"Il avait dit: 'Ils sont vraiment mon peuple, des fils qui ne décevront pas!',C'est pourquoi il s'est fait leur sauveur "
,"9":"dans leurs épreuves. Ce n'était pas un envoyé qui les sauvait, ce n'était pas un ange, mais sa Face; dans son amour et sa miséricorde il les rachetait lui-même. Il les a portés tout au long des temps anciens."
,"10":"Mais ils se sont révoltés; comme ils attristaient son Esprit saint, il s'est fait leur ennemi: il a combattu contre eux."
,"11":"Alors ils se sont souvenus des jours d'autrefois, des jours de Moïse: Où est le berger qui sauva des eaux son troupeau?,Où est celui qui mit au milieu d'eux son Esprit saint, "
,"12":"qui aux côtés de Moïse, frappait de ses coups formidables, qui se rendit célèbre pour toujours en ouvrant les eaux devant eux?"
,"13":"Car il les a conduits sur le fond de la mer comme un cheval dans le désert; ils ont cheminé sans problèmes "
,"14":"comme le bétail qui descend dans la vallée: l'Esprit de Yahvé les menait au repos. C'est ainsi que tu conduisais ton peuple, et c'est ce qui t'a valu ton renom."
,"15":"Regarde du haut des cieux et vois de ta résidence sainte et glorieuse. Où sont aujourd'hui tes soins jaloux et ta puissance, ta tendresse et ta miséricorde?,Non, ne te ferme pas, "
,"16":"car tu es notre père. Abraham ne nous connaît plus, Israël ne sait plus rien de nous!,C'est toi, Yahvé, qui es notre père, notre 'rédempteur'. C'est là ton Nom depuis toujours!"
,"17":"Pourquoi, Yahvé, nous laisses-tu nous égarer loin de tes voies, pourquoi laisses-tu nos coeurs s'endurcir et ne plus te craindre?,Pense à tes serviteurs, aux tribus de ton héritage: reviens!"
,"18":"Pourquoi des méchants sont-ils entrés dans ton Saint-Lieu?,Pourquoi nos ennemis ont-ils piétiné ton Sanctuaire? "
,"19":"Depuis longtemps nous sommes un peuple que tu ne gouvernes plus,et que ton Nom ne protège plus. Ah! Si tu déchirais les cieux, si tu descendais, les montagnes frémiraient devant toi."
}`)
	CurrentBook.AddChapter(64, `{
"1":"Ce serait comme un fagot qui s'enflamme, comme l'eau qui bout sur le feu. Tu ferais connaître ton Nom à tes adversaires, et devant ta face les nations trembleraient, "
,"2":"te voyant accomplir des prodiges jamais vus."
,"3":"Jamais on n'a entendu dire, jamais on n'a appris, l'oeil n'a jamais vu un Dieu, en dehors de toi, faire de telles choses pour ceux qui se confient en lui."
,"4":"Tu as déconcerté ceux qui pratiquaient la justice, qui suivaient tes voies et se souvenaient de toi. Tu t'es mis en colère car nous avons péché; nous avons mal agi, mais nous serons sauvés."
,"5":"Tous nous sommes comme l'impur, et nos mérites ne valent pas mieux qu'un linge souillé: nous sommes tous comme des feuilles mortes,et nos péchés comme le vent nous emportent."
,"6":"Plus personne n'invoque ton nom, nul ne se reprend pour se raccrocher à toi: tu nous as caché ta face, tu nous as livrés au pouvoir de nos péchés."
,"7":"Pourtant, Yahvé, tu es notre père; nous sommes l'argile et tu nous as façonnés, nous sommes tous l'oeuvre de tes mains."
,"8":"Ne t'emporte pas davantage, ô Yahvé, ne te rappelle pas constamment nos fautes. Regarde-nous, ne sommes-nous pas tous ton peuple?"
,"9":"Or tes villes saintes sont devenues un désert, Sion n'est plus qu'un désert, et Jérusalem une ruine."
,"10":"Notre Temple saint et magnifique, où nos pères te célébraient, a été dévoré par les flammes; ce que nous avions de plus cher est aujourd' hui en ruines."
,"11":"Devant tout cela, Yahvé, resteras-tu sans bouger?,Vas-tu te taire et nous humilier au dernier point?"
}`)
	CurrentBook.AddChapter(65, `{
"1":"Je me suis laissé approcher par ceux qui ne s'intéressaient pas, je me suis laissé trouver par ceux qui ne me cherchaient pas. J'ai dit: 'Me voici, me voici!' à une nation qui n'invoquait pas mon nom."
,"2":"Tout le jour j'ai tendu mes mains vers un peuple rebelle, vers ceux qui marchent sur un mauvais chemin, qui n'en font qu'à leur tête,"
,"3":"vers un peuple qui me met sans cesse en colère, qui offre des sacrifices dans les jardins, qui brûle de l'encens sur des briques."
,"4":"Ils vont au milieu des tombes, ils passent la nuit dans des alvéoles, ils mangent de la chair de porc et préparent une nourriture impure."
,"5":"Ils disent: 'Eloigne-toi, ne me touche pas, j'ai en moi du fluide sacré!' Ces gens-là sont un feu qui tout le jour m'enfume."
,"6":"Mais c'est écrit sous mes yeux, dit Yahvé: Je ne me tairai pas tant que je n'aurai pas réglé avec eux"
,"7":"le compte de leurs fautes et des fautes de leurs pères qui faisaient fumer l'encens sur les montagnes et me provoquaient sur les collines. C'est pourquoi je leur revaudrai leurs actes et je réglerai mes comptes avec eux."
,"8":"Voici ce que dit Yahvé: Quand on trouve du jus dans une grappe de raisin, on dit: 'Ne la jetez pas, c'est une bénédiction!' Eh bien, je ferai de même pour mes serviteurs, je ne jetterai pas tout."
,"9":"Je ferai que Jacob ait une descendance, je ferai de Juda l'héritier de mes montagnes, mes élus les posséderont et mes serviteurs y habiteront."
,"10":"Le Saron deviendra une pâture de brebis, et la vallée d'Akor, un parc pour les boeufs, pour le bien de mon peuple qui m'aura recherché."
,"11":"Mais vous tous qui abandonnez Yahvé, qui oubliez ma Montagne Sainte, qui élevez un autel pour Gad et versez des libations pour Méni,"
,"12":"je vous livre à l'épée: tous vous plierez le genou pour vous faire égorger. Car j'ai appelé et vous n'avez pas répondu, j'ai parlé et vous n'avez pas écouté, vous avez fait ce qui est mal à mes yeux et vous avez choisi ce qui me déplaît."
,"13":"C'est pourquoi, voici ce que dit Yahvé: Mes serviteurs mangeront, mais vous, vous aurez faim. Mes serviteurs boiront, mais vous, vous aurez soif. Mes serviteurs se réjouiront, mais vous, vous serez honteux. "
,"14":"Mes serviteurs chanteront la joie au coeur, mais vous, le coeur en peine, et vous vous lamenterez désespérés."
,"15":"On n'entendra plus prononcer votre nom que lorsque mes élus voudront maudire, alors ils diront: 'Que Yahvé te fasse périr comme eux!' Mais à ses serviteurs, Yahvé donnera un nom nouveau."
,"16":"Ceux qui dans ce pays voudront une bénédiction, se feront bénir par le Dieu de vérité, et ceux qui dans ce pays jureront, jureront par le Dieu de vérité, car on oubliera les détresses d'autrefois, et moi-même je n'y penserai plus."
,"17":"Voici que je crée des cieux nouveaux et une terre nouvelle; les événements du passé vont être oubliés, ils ne reviendront plus à la mémoire."
,"18":"Je vais créer fête et joie qui ne passeront pas, je crée Jérusalem pour la joie et son peuple pour la fête."
,"19":"Jérusalem me comblera de joie, j'aurai toute satisfaction avec mon peuple. On n'y entendra plus, ni pleurs ni cris,"
,"20":"on n'y verra plus de nouveaux-nés qui ne vivent que quelques jours, ni de vieillards qui n'atteignent un grand âge; mourir à cent ans sera mourir jeune, et mourir avant cent ans sera une malédiction."
,"21":"Ils construiront des maisons et les habiteront, ils planteront des vignes et en mangeront les fruits."
,"22":"On ne fera plus la maison pour qu'un autre l'habite, on ne plantera plus pour qu'un autre le mange. Les gens de mon peuple dureront autant que les arbres, et mes élus jouiront du travail de leurs mains."
,"23":"Ils ne travailleront plus pour rien, ils n'enfanteront plus d'enfants pour qu'ils leur soient arrachés, mais eux et leur descendance après eux seront une race bénie de Yahvé."
,"24":"Aussi, avant même qu'ils n'appellent je répondrai, ils parleront encore, et déjà j'aurai entendu."
,"25":"Le loup et l'agneau iront ensemble au pré, et le lion mangera de la paille comme le boeuf; le serpent, lui, se contentera de sa poussière. On ne fera plus de mal ni de violence sur toute ma Sainte Montagne - parole de Yahvé."
}`)
	CurrentBook.AddChapter(66, `{
"1":"Voici ce que dit Yahvé: 'Le ciel est mon trône et la terre est l'escabeau de mes pieds. Quelle maison, quel lieu de repos pourriez-vous me construire -"
,"2":"parole de Yahvé - si tout est l'oeuvre de mes mains, si tout cela est à moi? Mais savez-vous à qui je m'intéresse? Au pauvre dont l'esprit est humble et qui tremble à ma parole."
,"3":"Or voici qu'on immole un boeuf mais on tue un homme, on sacrifie un agneau, mais on brise la nuque à un chien, on présente une offrande, mais c'est du sang de porc, on offre de l'encens et on bénit une idole. Puisqu'ils ont choisi le chemin qui leur plaît et qu'ils prennent leur plaisir dans leurs Ordures, "
,"4":"à mon tour je prendrai plaisir à causer leur malheur et je ferai venir sur eux ce qui les fait trembler. Car j'ai appelé et nul n'a répondu, j'ai parlé et on n'a pas écouté; ils ont fait ce qui ne me plaît pas, ils ont choisi ce que je n'accepte pas."
,"5":"Ecoutez cette parole de Yahvé, vous qui tremblez à sa parole! Vos frères qui vous détestent et qui vous rejettent à cause de mon Nom ont dit ceci: 'Que Yahvé montre sa force, nous aimerions voir votre joie!' Eh bien ce sont eux qui vont connaître la honte."
,"6":"Un bruit, une rumeur remplit la ville, une voix monte du Temple! C'est la voix de Yahvé qui rend la pareille à ses ennemis."
,"7":"Avant d'être en travail elle a enfanté, avant de connaître les douleurs, elle a mis au monde un garçon."
,"8":"Qui a jamais entendu, qui a jamais vu chose semblable? Est-ce qu'un pays peut naître en un seul jour, est-ce qu'une nation est enfantée d'un seul coup? Or, à peine en travail, Sion a mis au monde ses fils."
,"9":"Pouvais-je ouvrir le sein maternel et que l'enfant ne vienne pas? dit Yahvé. Car c'est moi qui ouvre le sein et c'est moi qui le ferme, dit ton Dieu."
,"10":"Réjouissez-vous avec Jérusalem, soyez dans la joie à cause d'elle, vous tous qui l'aimez; que vos cris de joie se mêlent aux siens, vous tous qui pleuriez sur elle!"
,"11":"Car vous serez allaités, vous serez rassasiés par ses seins qui réconfortent, vous sucerez, vous goûterez les débordements de sa gloire."
,"12":"Car voici ce que dit Yahvé: Je fais que la paix, comme un fleuve se dirige vers elle , et que la richesse des nations, comme un torrent déborde sur elle. Vous serez allaités, portés sur la hanche et caressés sur les genoux."
,"13":"Je vous consolerai comme celui que sa mère console, dans Jérusalem vous serez consolés."
,"14":"Vous le verrez, votre coeur sera dans la joie, et vos os retrouveront comme l'herbe leur fraîcheur. La main de Yahvé se montrera à ses serviteurs; à ses ennemis il fera voir sa colère."
,"15":"Car voici que Yahvé vient dans le feu, monté sur les chars de l'ouragan. Il déverse sa colère ardente, ses menaces sont des charbons de feu."
,"16":"Yahvé fait justice par le feu et par l'épée; tous sont jugés, et nombreuses sont les victimes de Yahvé:"
,"17":"ceux qui vont se sanctifier et se purifier dans les jardins sacrés, derrière quelqu'un qui se met au centre, ceux qui mangent de la chair de porc, des mets impurs ou des souris. Leurs actes et leurs stratagèmes cesseront à la fois - parole de Yahvé."
,"18":"Voici que je rassemble les païens de toutes les nations et de toutes les langues, et quand ils seront venus, ils seront témoins de ma gloire."
,"19":"Je ferai un prodige au milieu d'eux, et j'enverrai leurs survivants vers les nations: vers Tarsis, Pout, Loud, Méchek, Toubal et Yavan, vers les îles les plus lointaines qui n'ont pas encore entendu parler de moi et qui n'ont pas vu ma Gloire. Alors ils feront connaître aux nations ma gloire. "
,"20":"Ils ramèneront tous vos frères de toutes les nations, sur des chevaux et des chars, sur des brancards, des mulets et des chameaux. Voici ce que dit Yahvé: On les mènera à ma Montagne Sainte, à Jérusalem, tout comme les Israélites apportent leurs offrandes dans des vases purs à la Maison de Yahvé."
,"21":"Yahvé dit encore: Je prendrai certains d'entre eux pour en faire des prêtres et des lévites."
,"22":"De même que les cieux nouveaux et la terre nouvelle que je vais créer, doivent rester là toujours devant moi - parole de Yahvé, ainsi votre race et votre nom dureront toujours."
,"23":"De nouvelle lune en nouvelle lune, de sabbat en sabbat, toute chair viendra se prosterner devant moi, dit Yahvé."
,"24":"Et quand ils repartiront, ils verront les cadavres des hommes qui se sont révoltés contre moi. Car le ver ne finira pas de les ronger et leur bûcher ne s'éteindra pas: tous au passage seront horrifiés."
}`)

}
func FR_LBDCC_LoadVMLMChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Hélas!,Elle reste seule, la ville au peuple nombreux, elle est restée comme une veuve, la grande parmi les nations; jadis reine parmi les provinces, elle est soumise à la corvée."
,"2":"Elle a pleuré toute la nuit,et les larmes couvrent ses joues. Parmi tous ses amants, pas un ne la console. Tous ses amis l'ont trahie, sont devenus des ennemis."
,"3":"On a déporté Juda, accablé, pour un dur esclavage; il habite au milieu de païens,et ne trouve pas de repos. Ses poursuivants l'avaient rejoint,dans des gorges sans issue."
,"4":"Les routes de Sion sont en deuil, nul ne va plus à ses fêtes. Aux portes c'est un désert, ses prêtres se lamentent,et ses vierges se désolent; elle est dans l'amertume."
,"5":"Ses ennemis ont été plus forts, ses adversaires l'ont emporté: c'est Yahvé qui la frappait,pour ses fautes si nombreuses. Les petits allaient avec les captifs,l'ennemi les faisait avancer."
,"6":"Ils ont pris à la fille de Sion,tout ce qui faisait sa gloire. Ses chefs étaient comme des cerfs,qui ne trouvent plus de pâture; ils marchaient sans forces,devant ceux qui les faisaient aller."
,"7":"Jérusalem se souvient,de ses jours de peine et de détresse: son peuple tombait aux mains de l'ennemi, et nul ne venait à son secours; ses ennemis la voyaient,et se moquaient de sa ruine."
,"8":"Jérusalem a péché, de tels péchés,qu'elle n'était plus que souillure; ceux qui la respectaient l'ont méprisée, car ils ont vu sa nudité. Elle se lamente, et détourne son visage."
,"9":"Sa souillure est là sur sa robe, elle n'imaginait pas cette fin. Quelle chute étonnante, et personne pour la consoler!,O Yahvé, regarde sa misère, l'ennemi a triomphé!"
,"10":"L'adversaire a fait main basse,sur toutes ses richesses. Alors elle a vu les païens,entrer dans son Sanctuaire, ceux-là même que tu ne voulais pas,qu'ils viennent à tes assemblées."
,"11":"Tout son peuple se lamente: tous sont en quête de pain. On donnait ses bijoux pour manger, car on voulait sauver sa vie. 'O Yahvé, regarde et vois: comme j'ai été méprisée!'"
,"12":"Vous tous qui passez sur le chemin, regardez et voyez: est-il plus douloureuse douleur,que celle dont je souffre, dont Yahvé m'a frappée,au jour de son ardente colère."
,"13":"D'en haut il a envoyé un feu: il est descendu dans mes os. Il a tendu un filet sous mes pieds,et m'a jetée à la renverse. Il m'a laissée défaite, tous mes jours ne sont que souffrances."
,"14":"Il faisait le compte de mes fautes,et les gardait dans sa main. Son joug pèse sur mon cou,et les forces me manquent. Le Seigneur m'a livrée entre des mains,auxquelles je ne peux résister."
,"15":"Tous les vaillants de chez moi, le Seigneur les a enlevés. Il a convoqué contre moi une armée,pour écraser mes jeunes guerriers. Le Seigneur a foulé au pressoir,la vierge, fille de Juda."
,"16":"Et voilà pourquoi je pleure, pourquoi mes yeux fondent en larmes, car personne n'est là qui me console,et réconforte mon âme. Mes enfants sont consternés,pendant que l'ennemi triomphe."
,"17":"Sion a tendu les mains, mais pas un ne la console. Yahvé a voulu l'invasion de Jacob,par ses voisins tout à l'entour. Jérusalem au milieu d'eux,n'est plus qu'un dépotoir."
,"18":"Yahvé est juste, car j'étais, moi, rebelle à ses ordres. Entendez-moi, tous les peuples, et voyez ma douleur: mes vierges et mes jeunes,sont partis en captivité."
,"19":"J'ai fait appel à mes amants, mais ils m'ont trompée. Mes prêtres et mes anciens,rendaient l'âme dans la ville, ils cherchaient pour survivre,et ne trouvaient rien à manger."
,"20":"'Vois, Yahvé, que je suis dans l'angoise,j'en suis toute retournée,et mon coeur en moi défaille: oui, j'ai voulu ma rébellion!,Dehors, l'épée sème le deuil, rester entre les murs, c'est la mort.'"
,"21":"'Ils ont entendu mes cris, mais personne ne me console. Mes ennemis ont su mon désastre, tous riaient, te voyant agir: hâte le jour que tu as dit,où ils seront tels que je suis!"
,"22":"Leurs actes viendront devant toi, tous leurs crimes, tu les traiteras,comme tu m'as traitée moi-même,à cause de tous mes péchés. Je multiplie mes plaintes, mon coeur s'en trouve mal."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Hélas!,Le Seigneur dans sa colère, a mis en ténèbres la fille de Sion. Du ciel il a précipité sur terre,la splendeur d'Israël. Il n'a plus vu au jour de sa colère, que c'était là l'estrade sous ses pieds."
,"2":"Yahvé a détruit sans pitié, toutes les demeures de Jacob. Dans sa fureur Il a renversé,les forteresses de la fille de Juda. Il a jeté à terre, il a déshonoré,son roi et ses princes."
,"3":"Emporté par sa colère, il a brisé,toute la force d'Israël. Il lui a tiré le bras en arrière, quand il voulait frapper l'ennemi; il a allumé dans Jacob un feu, et la flamme a dévoré de tous côtés."
,"4":"Il a massacré tous ceux qu'on aimait,dans les tentes de la fille de Sion; il a déversé sa colère comme un feu."
,"5":"Yahvé s'est présenté en ennemi, il a ruiné Israël, détruisant tous ses palais, renversant ses forteresses; il a multiplié pour la fille de Juda, deuils et lamentations."
,"6":"Il a forcé la clôture de son jardin: il a démoli son Sanctuaire. Yahvé a fait cesser dans Sion, les fêtes et les sabbats. De colère il n'a plus voulu voir,le roi ni le prêtre."
,"7":"Yahvé s'est dégoûté de son autel: il a pris en horreur son Sanctuaire, il a fait tomber aux mains de l'ennemi, les murs de son palais; quel vacarme dans la maison de Yahvé!,C'était pour eux un jour de fête."
,"8":"Yahvé a renversé, il l'avait décidé, les remparts de la fille de Sion. Sa main a étendu le cordeau, il l'a ramenée quand tout était détruit. Jour de deuil pour le mur et l'avant-mur, tous deux sont dans un triste état."
,"9":"Ses portes sont là enterrées, les barres en sont tombées, brisées. Son roi et ses chefs sont en pays païen, il n'y a plus de loi. Plus rien ne vient aux prophètes: pas une vision qui soit de Yahvé."
,"10":"Les anciens de la fille de Sion,assis par terre, se taisent; ils ont jeté la poussière sur leur tête, ils se sont habillés de sacs; et les vierges de Jérusalem, la tête baissée, regardent vers le sol."
,"11":"Les larmes épuisaient mes yeux, mes intérieurs se défaisaient,et mon foie se répandait à terre,à voir les plaies de mon peuple, lorsque les petits, les enfants, défaillaient sur les places de la ville."
,"12":"Ils disaient à leurs mères: 'Où sont le pain et le vin?',Ils défaillaient, comme blessés à mort; sur les places de la ville, et sur le sein de leur mère, ils rendaient l'âme."
,"13":"Que dirai-je de toi, qui est comme toi, fille de Jérusalem?,Qui voudra te sauver et te consoler, vierge, fille de Sion?,Ta blessure est énorme comme la mer, qui pourrait te guérir?"
,"14":"Tes prophètes avaient des visions: ce n'étaient qu'illusions, ils te mentaient. Ils n'ont pas dévoilé ton péché,pour t'épargner un exil; ils t'ont donné des visions creuses, des mensonges où tu t'es laissé prendre."
,"15":"Celui qui passe sur le chemin, quand il te voit frappe dans ses mains; on siffle, on secoue la tête: 'Oui, c'est la fille de Jérusalem; n'était-ce pas la ville toute en beauté, la joie de toute la terre?'"
,"16":"Tous tes ennemis,ouvrent la bouche contre toi, ils sifflent et grincent des dents: 'Nous l'avons engloutie, disent-ils, c'est le jour que nous attendions!,C'est fait, cela s'est fait sous nos yeux!'"
,"17":"Yahvé l'avait décidé, il l'a réalisé; il a accompli sa parole. Depuis longtemps il avait averti: il a détruit sans pitié. Tu as fait la joie de tes ennemis,quand il a fait triompher tes rivaux."
,"18":"Crie donc vers Yahvé, gémis, fille de Sion; que tes larmes de jour et de nuit,coulent comme un torrent,Ne t'arrête pas, ne retiens pas la source de tes larmes."
,"19":"Lève-toi et crie dans la nuit,dès le début des rondes; laisse s'épancher ton coeur, appelle, frappe chez le Seigneur. Elève tes mains vers lui,pour le salut de tes petits."
,"20":"'O Yahvé, regarde et pense un moment: A qui en as-tu jamais fait voir de pareilles?,Des femmes ont mangé leurs nourrissons, leurs petits enfants au berceau. Prêtres et prophètes ont été égorgés,dans le Sanctuaire du Seigneur."
,"21":"Enfants et vieillards, on les voit étendus sur le sol des rues; mes vierges et mes jeunes,sont tombés sous l'épée. Tu as égorgé au jour de ta colère, tu as massacré sans pitié."
,"22":"Tu as invité à la fête,tous ceux qu'autour de moi je redoutais. Quand est venue la colère de Yahvé, il n'y a eu ni rescapé, ni fuyard; mon ennemi a exterminé,ceux que j'avais bercés et nourris.'"
}`)
	CurrentBook.AddChapter(3, `{
"1":"Je suis l'homme qui a connu le malheur,sous le bâton de sa colère."
,"2":"Il a conduit ma marche,vers les ténèbres et non vers la lumière."
,"3":"Il tourne et retourne sa main,contre moi, tout au long du jour."
,"4":"Il a usé mes chairs et ma peau, il a brisé mes os."
,"5":"Il m'a assailli, assiégé, ce n'étaient qu'amertume et poisons."
,"6":"Il m'a fait demeurer dans les ténèbres, comme les morts pour qui le temps n'est plus."
,"7":"Il m'a emmuré et je ne peux sortir, il a fait pesantes mes chaînes."
,"8":"J'ai beau crier, appeler, il ne laisse pas passer ma prière."
,"9":"Il a bloqué ma voie avec des pierres, il a barré tous mes sentiers."
,"10":"Il est pour moi comme un ours à l'affût,comme un lion qui attend sa proie;"
,"11":"il m'a écarté du chemin et m'a déchiré, il m'a laissé en pièces."
,"12":"Il a bandé son arc, faisant de moi la cible de ses flèches;"
,"13":"il m'a décoché dans les reins,sa réserve de flèches."
,"14":"Je suis devenu la risée du peuple, tout le jour ils me mettent en chanson."
,"15":"Il m'a rassasié d'amertume, il m'a enivré d'absinthe."
,"16":"Il m'a cassé les dents à coups de cailloux, il m'a enfoncé dans la cendre."
,"17":"Mon âme n'a plus droit à la paix, je ne connais plus le bonheur."
,"18":"J'ai dit: 'Ma force s'est perdue,avec mon espérance en Yahvé.'"
,"19":"Pourquoi rappeler ma misère et mon angoisse?,Ce n'est qu'absinthe et amertume."
,"20":"Ces souvenirs m'obsèdent, et mon âme en moi se défait."
,"21":"Mais je retrouve ces pensées en mon coeur, et c'est pourquoi j'espère:"
,"22":"'Les faveurs de Yahvé ne sont pas finies, ses miséricordes ne sont pas épuisées."
,"23":"Chaque matin elles reprennent, car sa fidélité est grande.'"
,"24":"Mon âme a dit: 'Yahvé est ma part, je veux espérer en lui.'"
,"25":"Yahvé est bon pour qui espère en lui, pour l'âme qui le recherche."
,"26":"Il est bon d'attendre en silence, le salut de Yahvé."
,"27":"Il est bon pour l'homme, de porter le joug dès sa jeunesse."
,"28":"Si Dieu ainsi le lui impose, qu'il s'asseye à l'écart et se taise,"
,"29":"qu'il mette sa bouche dans la poussière: peut-être reste-t-il un espoir."
,"30":"Qu'il tende la joue à celui qui le frappe, qu'il se rassasie d'humiliations."
,"31":"Car le Seigneur ne rejette pas, indéfiniment, les pécheurs."
,"32":"Il met à l'épreuve mais il a pitié, car sa miséricorde est grande."
,"33":"Ce n'est pas par jeu qu'il humilie,et qu'il afflige les humains."
,"34":"Quand on écrase et met sous ses pieds,tous les prisonniers d'un pays,"
,"35":"quand on tourne le droit d'un homme,sous le regard du Très-haut,"
,"36":"quand on lui fausse son procès, Yahvé ne le voit-il pas?"
,"37":"Peut-on dire une chose, et qu'elle se fasse, sans que Yahvé l'ait ordonné?"
,"38":"N'est-ce pas de la bouche du Très-haut,que sortent malheur et bonheur?"
,"39":"Pourquoi l'homme se plaindrait-il?,qu'il prenne conscience de son péché. "
,"40":"Rappelons-nous notre conduite, souvenons-nous, et revenons vers Yahvé."
,"41":"Elevons nos coeurs et nos mains,vers le Dieu qui est dans les cieux."
,"42":"Nous avons péché, nous étions rebelles, et toi, tu n'as pas pardonné."
,"43":"Tu nous as poursuivis, drapé dans ta colère, et tu as massacré sans pitié."
,"44":"Tu t'es enfermé dans la nuée,pour que la prière ne passe pas."
,"45":"Tu as fait de nous des balayures, des laissés pour compte au milieu des peuples."
,"46":"Tous nos ennemis, victorieux, se sont moqués de nous;"
,"47":"notre part c'était la terreur, le piège, la ruine et la désolation."
,"48":"Mon oeil laisse échapper des ruisseaux, car je revois la ruine de la fille de mon peuple."
,"49":"Mon oeil verse des larmes; il ne trouvera pas de repos"
,"50":"tant que Yahvé, du haut des cieux, ne se penchera pas pour voir."
,"51":"Mon oeil m'est une souffrance, car il a trop pleuré."
,"52":"Ceux qui sans raison me détestent, m'ont pourchassé comme un oiseau."
,"53":"Ils m'ont précipité dans la fosse, ils m'y jetaient des pierres."
,"54":"Les eaux se refermaient sur ma tête, je me disais: 'Je suis perdu!'"
,"55":"J'ai alors invoqué ton nom, Seigneur, du fond de mon souterrain,"
,"56":"et tu as entendu mon cri: 'J'appelle, ne me fais pas la sourde oreille!'"
,"57":"Tu t'es approché au jour où je t'appelais, et tu m'as dit: 'Ne crains pas.'"
,"58":"Seigneur, tu as pris ma cause en mains, tu m'as sauvé la vie."
,"59":"Tu as vu, Yahvé, qu'ils me font violence: toi, fais-moi justice."
,"60":"Tu as vu leur soif de vengeance, ce qu'ils projettent de me faire."
,"61":"Tu as entendu leurs insultes, Yahvé, tout ce qu'ils ont comploté contre moi;"
,"62":"tu sais tout ce qu'ils préparent, ce que mes ennemis murmurent contre moi."
,"63":"Vois, qu'ils s'asseyent ou qu'ils se lèvent, je suis l'objet de leurs moqueries."
,"64":"O Yahvé, rends-leur ce qu'ils méritent, rends-leur selon l'oeuvre de leurs mains."
,"65":"Rends leur esprit aveugle, et que ta malédiction les accable."
,"66":"Dans ta colère, Yahvé, tu les poursuivras, tu les extermineras de dessous les cieux."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Hélas!,Le vieil or s'est terni, le fin métal jaune; on a jeté les riches pierres sacrées, au coin de toutes les rues."
,"2":"Les fils de Sion, si nobles, qu'on estimait à leur poids d'or, sont regardés comme des pots de terre, comme un ouvrage de potier!"
,"3":"Même les chacals présentent la mamelle, et allaitent leurs petits, mais la fille de mon peuple se fait cruelle,comme les monstres du désert."
,"4":"La langue du nourrisson lui colle au palais: il meurt de soif!,Les petits enfants demandent du pain, et personne pour le partager!"
,"5":"Les habitués de la fine cuisine, tombent de faiblesse dans les rues, ceux qu'on élevait dans la pourpre, embrassent le fumier."
,"6":"Le péché de la fille de mon peuple, était plus grand que celui de Sodome, retournée en un instant,sans que main d'homme ne s'y mette."
,"7":"Ses jeunes étaient plus nets que la neige, plus blancs que le lait; leurs corps, plus bronzés que le corail, leurs visages, plus rayonnants que le saphir."
,"8":"Mais les voilà plus sombres que le soir, on ne les reconnaît plus dans les rues, la peau colle à leurs os, elle est sèche comme du bois."
,"9":"Heureux ceux qui sont morts par l'épée, plutôt que de mourir de faim: privés des produits de la terre, ils se traînent et puis s'affaissent."
,"10":"De leurs mains, faites pour la tendresse, des femmes ont fait cuire leurs enfants, elles en ont fait leur repas: mon peuple en était arrivé là!"
,"11":"Yahvé a satisfait sa fureur, il a répandu sa colère ardente. Le feu a pris dans Sion, il en a dévoré jusqu'aux fondations."
,"12":"Pouvaient-ils croire, les rois de la terre, et les habitants du monde, qu'un adversaire, une armée ennemie, franchiraient les portes de Jérusalem?"
,"13":"C'est à cause des péchés de ses prophètes, à cause des crimes de ses prêtres: ils avaient répandu dans la ville,le sang des justes."
,"14":"Ils erraient aveugles dans les rues, couverts de sang; même leurs vêtements,on ne pouvait plus les toucher:"
,"15":"'Ecartez-vous, disait-on, c'est un impur, écartez-vous, ne le touchez pas!',Ils allaient errants et fugitifs, on disait chez les païens: 'Ils ne resteront pas!'"
,"16":"La face de Yahvé les a dispersés, il ne les regarde plus: plus de considération pour les prêtres, plus de faveurs pour les anciens."
,"17":"Et nos yeux s'épuisaient,attendant un secours illusoire; nous attendions, de nos miradors, une nation incapable de sauver."
,"18":"Nos ennemis nous épiaient: impossible d'atteindre nos place!,La fin approchait, nos jours étaient comptés: nous vîmes venir la fin."
,"19":"Nos poursuivants étaient rapides, plus que les aigles du ciel; ils nous chassaient dans les montagnes, ils nous guettaient dans le désert."
,"20":"L'élu de Yahvé - il était comme notre souffle -,a été pris dans leurs filets: 'Toujours, disions-nous, nous vivrons à son ombre, au milieu de nations étrangères.'"
,"21":"Réjouis-toi, fille d'Edom, tu peux rire, toi qui habites au pays de Us!,La coupe passera jusque chez toi, elle t'enivrera et tu resteras nue."
,"22":"Voici ta faute pardonnée, fille de Sion, ton Dieu ne te mènera plus à l'exil!,Mais toi, fille d'Edom, ta faute va se payer, il dévoilera tes péchés!"
}`)
	CurrentBook.AddChapter(5, `{
"1":"Rappelle-toi, Yahvé, ce qu'a été notre sort, regarde et vois nos humiliations."
,"2":"Notre domaine est passé à des étrangers,nos maisons à des inconnus."
,"3":"Nous sommes orphelins de pères,et nos mères sont des veuves."
,"4":"Nous buvons notre eau, mais il faut la payer, et nous payons pour ramener notre bois."
,"5":"Nous sommes persécutés sur notre terre, nous sommes épuisés, pas de repos pour nous."
,"6":"Nous avons tendu la main à l'Egypte,et à l'Assyrie, pour manger notre compte;"
,"7":"Ce fut le péché de nos pères, et ils sont morts, mais nous, nous portons leurs dettes."
,"8":"Des esclaves sont devenus nos maîtres, et nul ne nous délivre de leurs mains."
,"9":"Nous rapportons notre pain au péril de nos vies, car l'épée fauche dans le désert."
,"10":"Notre peau s'est durcie comme au four, s'est parcheminée sous l'effet de la faim."
,"11":"Les femmes ont été violées dans Sion, les vierges dans les villes de Juda."
,"12":"Des chefs ont péri pendus de leurs mains, ils n'ont même pas respecté les anciens."
,"13":"Les jeunes se sont courbés sur la meule, des garçons trébuchaient sous le poids des fagots."
,"14":"Les anciens ont déserté la porte, les jeunes ont délaissé la musique."
,"15":"La joie a déserté nos coeurs, et nos danses se sont changées en deuil."
,"16":"La couronne est tombée de notre tête, notre malheur, c'est d'avoir péché!"
,"17":"De là vient que notre coeur est malade, voilà pourquoi nos yeux sont en ténèbres."
,"18":"Sur la montagne de Sion qu'ils ont saccagée, les chacals rôdent."
,"19":"Mais toi, Yahvé, tu règnes pour toujours, ton trône demeure d'âge en âge."
,"20":"Veux-tu nous oublier pour toujours, nous abandonner sans fixer un terme?"
,"21":"Ramène-nous à toi, Yahvé, et nous reviendrons, fais-nous revoir les jours d'autrefois."
,"22":"Nous aurais-tu rejetés pour toujours, ta colère contre nous doit-elle aller si loin?"
}`)

}
func FR_LBDCC_LoadVNABChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Vision d'Abdias. Voici ce que dit le Seigneur Yahvé sur Edom: 'Nous venons d'entendre un appel de Yahvé, un message qu'il fait parvenir aux nations: 'Debout! Partons en guerre contre lui!'"
,"2":"C'est fait! Te voilà le dernier des peuples, le plus méprisé de tous."
,"3":"L'orgueil de ton coeur t'a trompé, toi qui demeures aux roches de Pétra, accroché au flanc de la montagne, toi qui penses: 'Qui me jettera à terre?'"
,"4":"Eh bien, élève-toi comme l'aigle, fais ton nid au milieu des étoiles: je t'en ferai descendre, parole de Yahvé."
,"5":"Si des voleurs viennent chez toi, des pillards de nuit, ils prendront tout ce qu'ils voudront. Si les vendangeurs viennent chez toi, que laisseront-ils à grappiller?"
,"6":"On a fouillé Esaü, on a découvert toutes ses cachettes!"
,"7":"On t'a reconduit à la frontière, et c'étaient tes amis!,Tes alliés ont été plus forts que toi, ils t'avaient tendu un piège."
,"8":"En ce jour-là, parole de Yahvé, j'en finirai avec les sages d'Edom, avec les astuces de la montagne d'Esaü."
,"9":"Tes guerriers, ô Téman, sont glacés de peur: on massacre les hommes des monts d'Esaü."
,"10":"N'avais-tu pas brutalisé ton frère Jacob?,Pour cela tu seras couvert de honte,et tu disparaîtras pour toujours."
,"11":"Lorsque des étrangers capturaient son armée, tu n'étais pas loin, à l'affût; le jour où ils franchissaient ses portes,et se partagaient Jérusalem au sort, tu étais toi aussi parmi eux."
,"12":"Ne te réjouis pas de la ruine de ton frère,au jour de son malheur, ne te moque pas des fils de Juda, ne ris pas de leur misère."
,"13":"Ne viens pas regarder à la porte,le jour où mon peuple est éprouvé; faut-il que toi aussi tu le voies souffrir,au jour de son malheur?,N'en profite pas pour rafler ses biens."
,"14":"Ne va pas te poster sur le chemin,pour massacrer les fugitifs, pour capturer les rescapés,au jour de leur malheur."
,"15":"Déjà vient pour les nations le jour de Yahvé: comme tu as fait on te fera, la vengeance viendra sur toi."
,"16":"Comme vous avez bu sur ma montagne sainte, ainsi boirez-vous, nations qui m'entourez, vous boirez à en perdre la tête,et vous disparaîtrez sans laisser de traces."
,"17":"Mais il y aura des rescapés,sur le mont Sion devenu un lieu saint, la maison de Jacob retrouvera son héritage."
,"18":"La maison de Jacob sera un feu, la maison de Joseph, une flamme, et les gens d'Esaü seront la paille,brûlée par eux, dévorée!,Pas de rescapés chez les gens d'Esaü,- parole de Yahvé."
,"19":"Les habitants du Négueb occuperont la montagne d'Esaü, et ceux de la Séféla, la terre des Philistins; ils hériteront du pays d'Ephraïm et de la campagne de Samarie, et ceux de Benjamin hériteront de Galaad."
,"20":"Les déportés d'Israël domineront le pays des Cananéens jusqu'à Sarepta et les déportés de Jérusalem qui demeurent à Séfarad hériteront des villes du Négueb;"
,"21":"ils monteront victorieux à la colline de Sion, et de là ils gouverneront la montagne d'Esaü; alors Yahvé agira en roi."
}`)

}
func FR_LBDCC_LoadVNAGChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"On était dans la deuxième année du roi Darius, le premier jour du sixième mois; la parole de Yahvé fut adressée par le prophète Aggée à Zorobabel fils de Chéaltiel, gouverneur de Juda, et à Josué fils de Yosadak, le grand-prêtre, pour qu'il leur dise:"
,"2":"'Voici une parole de Yahvé Sabaot au sujet de ce que dit ce peuple, que ce n'est pas le moment de rebâtir le Temple de Yahvé.'"
,"3":"La parole de Yahvé fut donc adressée par l'intermédiaire du prophète en ces termes:"
,"4":"'Est-ce donc pour vous le moment d'habiter de bonnes maisons quand ce Temple est en ruines?"
,"5":"Voici ce que dit Yahvé Sabaot: Voyez un peu ce que vous devez faire."
,"6":"Vous avez semé beaucoup et vous avez peu récolté; vous avez mangé, mais vous aviez encore faim, vous avez bu, mais vous aviez encore soif, vous vous êtes habillés, mais vous n'étiez pas assez couverts. L'ouvrier a mis son salaire dans une bourse percée."
,"7":"Voici donc ce que dit Yahvé Sabaot: Voyez un peu ce que vous devez faire;"
,"8":"montez à la montagne, rapportez du bois et reconstruisez le Temple. Cela me fera grand plaisir et j'y ferai éclater ma gloire, dit Yahvé."
,"9":"Vous attendiez l'abondance, et la récolte a été maigre: j'ai soufflé dessus. Pourquoi donc? - demande Yahvé Sabaot. C'est parce que mon Temple est en ruine alors que chacun court à sa maison. "
,"10":"C'est pour cela que les cieux ont retenu la pluie et que la terre n'a pas donné sa récolte."
,"11":"J'ai appelé la sécheresse sur la terre et sur les montagnes, sur le blé, le vin nouveau et l'huile fraîche, et sur tout ce que produit la terre; sur les hommes et les animaux et sur tout le travail de vos mains."
,"12":"Zorobabel fils de Chéaltiel, Josué fils de Yosadak, le grand-prêtre, avec tout le reste du peuple entendirent la parole de Yahvé leur Dieu que leur adressait le prophète Aggée. Il parlait conformément à la mission qu'il avait reçue de Yahvé, leur Dieu, aussi le peuple fut-il rempli de la crainte de Yahvé."
,"13":"Aggée, le messager de Yahvé, parla ainsi au peuple, selon la mission reçue de Yahvé: 'Je suis avec vous, parole de Yahvé.'"
,"14":"Alors Yahvé amena Zorobabel fils de Chéaltiel, gouverneur de Juda, et Josué fils de Yosadak, le grand-prêtre, à se décider avec tout le reste du peuple; ils arrivèrent et se mirent au travail dans le Temple de Yahvé Sabaot, leur Dieu."
,"15":"On était au vingt-quatrième jour du sixième mois."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Le vingt et unième jour du septième mois de la deuxième année du roi Darius, le prophète Aggée fut chargé de cette parole de Yahvé:"
,"2":"'Voici ce que tu diras à Zorobabel fils de Chéaltiel, gouverneur de Juda, à Josué fils de Yosadak, le grand-prêtre, et au reste du peuple:"
,"3":"Y en a-t-il encore parmi vous qui ont connu ce Temple dans sa gloire passée? Et comment le voyez-vous maintenant? Ce n'est pas grand chose, n'est-ce pas?"
,"4":"Mais maintenant courage, Zorobabel - parole de Yahvé! Courage, Josué fils de Yosadak, grand-prêtre! Et vous aussi tout le peuple du pays, courage - parole de Yahvé! Mettez-vous au travail car je serai avec vous - parole de Yahvé Sabaot."
,"5":"Mon esprit est au milieu de vous, n'ayez pas peur."
,"6":"Voici ce que dit Yahvé Sabaot: Encore un peu de temps et j'ébranlerai les cieux et la terre, la mer et la terre ferme."
,"7":"Je secouerai toutes les nations, et tous leurs objets précieux arriveront ici. Je remplirai de gloire ce Temple - parole de Yahvé."
,"8":"A moi l'argent, à moi l'or - parole de Yahvé Sabaot."
,"9":"La gloire de ce deuxième Temple sera plus grande que celle du premier - parole de Yahvé Sabaot; dans ce lieu je mettrai la paix - parole de Yahvé Sabaot."
,"10":"On était au vingt quatrième jour du neuvième mois de la deuxième année de Darius; cette parole de Yahvé fut confiée au prophète Aggée:"
,"11":"'Voici ce que dit Yahvé Sabaot: Consulte donc les prêtres sur ce que dit la Loi."
,"12":"Si un homme porte de la viande consacrée dans le pan de son habit, et avec le pan de son habit il touche du pain, du bouillon, du vin, de l'huile ou tout autre aliment, est-ce que cela sera consacré?' Ils répondirent: 'Non.'"
,"13":"Aggée demanda encore: 'Si quelqu'un est devenu impur en touchant un cadavre, et s'il touche ensuite à l'une de ces choses, seront-elles impures?' Les prêtres répondirent: 'Oui, elles seront impures.'"
,"14":"Aggée prit alors la parole et leur dit: 'Voilà bien ce qui arrive à ce peuple, voilà comment est cette nation devant moi - parole de Yahvé. Toutes leurs actions sont impures et ce qu'ils offrent est donc impur.'"
,"15":"Regardez bien ce qui arrivera à partir d'aujourd'hui. Avant de monter pierre sur pierre pour le Temple de Yahvé,"
,"16":"que se passait-il? On venait à un tas de vingt mesures, mais il n'y en avait que dix; on venait à une cuve pour puiser cinquante mesures, mais il n'y en avait que vingt."
,"17":"Je vous ai fait perdre tout le travail de vos mains par les insectes, les pucerons et la grêle, mais vous ne reveniez pas à moi - parole de Yahvé."
,"18":"Ouvrez donc les yeux à partir d'aujourd'hui et pour l'avenir, à partir de ce vingt-quatrième jour du neuvième mois où l'on a posé les fondations du Temple de Yahvé."
,"19":"Regardez si la graine manquera encore dans le grenier. Voyez si la vigne, le figuier, le grenadier, l'olivier ne donneront rien. Car à partir d'aujourd'hui je vais vous bénir."
,"20":"Le vingt quatre du mois la parole de Yahvé fut adressée une seconde fois à Aggée:"
,"21":"'Dis ceci à Zorobabel, gouverneur de Juda: Je vais ébranler les cieux et la terre,"
,"22":"je renverserai les trônes des royaumes, j'abattrai la puissance des royaumes païens, je renverserai le char et ceux qui le montent, je jetterai à terre les chevaux et leurs cavaliers; eux-mêmes se massacreront entre frères."
,"23":"Mais en ce jour-là - parole de Yahvé Sabaot - je te prendrai, toi mon serviteur Zorobabel fils de Chéaltiel - parole de Yahvé, et tu seras comme un anneau à mon doigt, gravé à mon Nom, car c'est toi que j'ai choisi - parole de Yahvé Sabaot."
}`)

}
func FR_LBDCC_LoadVNAMChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Parole d'Amos, l'un des intendants des troupeaux de Tékoa. Voici ce qu'il a vu au sujet d'Israël au temps d'Ozias, roi de Juda, et de Jéroboam, fils de Joas, roi d'Israël. C'était deux ans avant le tremblement de terre, et voici ce qu'il a dit:"
,"2":"Yahvé rugit de Sion, de Jérusalem il fait entendre sa voix. Les pâturages des bergers sont en deuil,et le sommet du Carmel se dessèche."
,"3":"Voici ce que dit Yahvé: Je l'ai décidé et je ne reviendrai pas en arrière. Damas a dépassé la limite du crime: ils ont broyé Galaad avec des traîneaux de fer."
,"4":"C'est pourquoi j'enverrai le feu dans la maison d'Hazaël et il dévorera les palais de Ben-Hadad."
,"5":"Je briserai la forteresse de Damas; je supprimerai l'habitant de Bikeat-Aven, le roi de Beth-Eden, et le peuple d'Aram sera déporté à Kir; c'est Yahvé qui le dit."
,"6":"Je l'ai décidé et je ne reviendrai pas en arrière. Gaza a dépassé la limite du crime: ils ont déporté des populations entières pour les livrer à Edom."
,"7":"C'est pourquoi j'enverrai le feu dans les remparts de Gaza et il dévorera ses palais."
,"8":"Je supprimerai l'habitant d'Ashdod et le roi d'Askalon, je lèverai ma main contre Akaron, et ce qui reste des Philistins périra; c'est le Seigneur Yahvé qui le dit."
,"9":"Je l'ai décidé et je ne reviendrai pas en arrière. Tyr a dépassé les limites du crime: ils ont livré à Edom des populations entières de captifs, ils ont oublié l'alliance entre frères."
,"10":"C'est pourquoi j'enverrai le feu dans les remparts de Tyr et il dévorera ses palais."
,"11":"Je l'ai décidé et je ne reviendrai pas en arrière. Edom a dépassé la limite du crime: il a poursuivi son frère avec l'épée, il n'a eu aucune pitié, sa colère ne s'apaisait pas et sa fureur ne cessait pas."
,"12":"C'est pourquoi j'enverrai le feu dans Téman et il dévorera les palais de Bosra."
,"13":"Voici ce que dit Yahvé: Je l'ai décidé et je ne reviendrai pas en arrière. Les Ammonites ont dépassé les limites du crime: ils ont éventré les femmes enceintes de Galaad quand ils ont pris leur territoire;"
,"14":"c'est pourquoi je mettrai le feu dans les remparts de Rabba, et il dévorera ses palais au milieu des cris d'un jour de bataille, au milieu de l'ouragan, comme en un jour de tempête."
,"15":"Le roi partira en captivité et ses chefs avec lui; c'est Yahvé qui le dit."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Voici ce que dit Yahvé: Je l'ai décidé et je ne reviendrai pas en arrière. Moab a dépassé les limites du crime: il a brûlé les os du roi d'Edom, il les a réduits en cendres."
,"2":"C'est pourquoi j'enverrai le feu dans Moab et il dévorera les palais de Kériyot. Moab périra au milieu de la confusion, des cris de guerre et du son de la trompette."
,"3":"J'arracherai de chez lui le souverain et je l'égorgerai avec tous ses princes; c'est Yahvé qui le dit."
,"4":"Voici ce que dit Yahvé: Je l'ai décidé et je ne reviendrai pas en arrière. Juda a dépassé les limites du crimes: ils ont rejeté la Loi de Yahvé, ils n'ont pas obéi à ses commandements, ils se sont dévoyés avec les idoles de mensonge que leurs pères avaient suivies."
,"5":"C'est pourquoi j'enverrai le feu dans Juda et il dévorera les palais de Jérusalem."
,"6":"Voici ce que dit Yahvé: Je l'ai décidé et je ne reviendrai pas en arrière. Israël a dépassé les limites du crime: ils vendent le juste à prix d'argent, et le pauvre pour une paire de sandales."
,"7":"Ils écrasent la tête des petits sur la poussière du sol, avec eux les humbles ne peuvent rien faire: le fils et le père courent après la même fille et ils profanent mon saint Nom."
,"8":"A côté de tous les autels ils s'étendent sur des habits qu'ils ont pris en gage, et dans le temple de leur Dieu ils boivent le vin de ceux qu'ils ont frappés d'amende."
,"9":"Moi, j'avais détruit devant eux l'Amoréen. Il était pourtant grand comme les cèdres, fort comme le chêne; mais je l'ai dénudé de haut en bas depuis les branches jusqu'aux racines."
,"10":"Je vous ai fait monter du pays d'Egypte, et pendant quarante ans, je vous ai conduits dans le désert pour vous donner le pays de l'Amoréen."
,"11":"J'ai fait sortir des prophètes d'entre vos fils, j'avais des hommes consacrés parmi vos jeunes gens; n'est-ce pas vrai, enfants d'Israël? Parole de Yahvé."
,"12":"Mais vous avez fait boire du vin à ceux qui m'étaient consacrés, aux prophètes vous avez donné cet ordre: Ne prophétisez plus."
,"13":"Aussi vais-je labourer votre dos comme le chariot plein de gerbes laboure la terre."
,"14":"L'homme agile n'échappera pas, le fort se retrouvera sans forces, et le meilleur des braves ne sauvera pas sa vie."
,"15":"L'archer n'osera pas faire face, et l'homme au pied rapide ne se sauvera pas. Même le cavalier, son cheval ne lui sauvera pas la vie."
,"16":"Le plus courageux d'entre les braves s'enfuira tout nu ce jour-là, parole de Yahvé."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Ecoutez, Israélites, cette parole que Yahvé a prononcée contre vous,: 'Vous êtes bien la famille que j'ai fait monter du pays d'Egypte."
,"2":"Je n'ai connu que vous parmi toutes les familles de la terre, c'est pourquoi je veux vous demander compte de tous vos péchés."
,"3":"Deux hommes marchent-ils ensemble sans s'être mis d'accord?"
,"4":"Le lion rugit-il dans la forêt s'il n'a pas sa proie? Le petit lion fait-il entendre sa voix dans sa tanière sans avoir rien pris?"
,"5":"L'oiseau tombe-t-il à terre dans le filet, s'il n'y a pas d'appât? Le filet se lève-t-il du sol sans avoir rien pris?"
,"6":"Sonne-t-on de la trompette dans une ville sans que le peuple ait peur? Arrive-t-il un malheur dans une ville sans que Yahvé en soit l'auteur?"
,"7":"De même le Seigneur Yahvé ne fait rien sans en révéler le secret à ses serviteurs les prophètes."
,"8":"Le lion a rugi, qui ne craindrait? Le Seigneur Yahvé a parlé, qui ne prophétiserait?"
,"9":"Lancez un appel dans les palais d'Assyrie et dans ceux du pays d'Egypte, dites: Rendez-vous donc sur les montagnes de Samarie, et regardez. Que de désordres dans cette ville, que de violences!"
,"10":"Ils ne savent plus agir avec droiture - parole de Yahvé. Ils remplissent leurs palais par la violence et l'injustice."
,"11":"C'est pourquoi, voici ce que dit le Seigneur Yahvé: L'ennemi assiègera le pays, il te fera baisser les bras et tes palais seront pillés."
,"12":"Voici ce que dit Yahvé: les deux pattes et le bout d'oreille que le berger arrache à la gueule du lion, c'est ce qui restera des Israélites, de tous ces gens qui se prélassent à Samarie sur des divans et des coussins de Damas."
,"13":"Ecoutez cette parole du Seigneur Yahvé, le Dieu Sabaot, et redites-la à la maison de Jacob:"
,"14":"Le jour où je châtierai Israël pour ses péchés, je m'en prendrai aux autels de Béthel; les cornes de l'autel seront brisées et jetées à terre."
,"15":"Je frapperai la maison d'hiver et la maison d'été, les palais d'ivoire seront dévastés et de nombreuses maisons seront détruites - parole de Yahvé."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Ecoutez cette parole, mesdames les vaches de Bashan, mesdames du quartier haut de Samarie: Vous opprimez les petits, vous piétinez les pauvres, et puis vous dites à vos maris: Apportez du vin, que nous buvions!"
,"2":"Le Seigneur Yahvé l'a juré dans sa sainteté: Voici venir le jour où l'on vous enlèvera avec des crocs, avec un aiguillon pour piquer derrière."
,"3":"Vous sortirez par les brèches, chacune droit devant soi, et vous serez déportées vers l'Hermon, parole de Yahvé."
,"4":"Vous pouvez bien aller au sanctuaire de Béthel, ce sera pour pécher; allez à Guilgal et vous pécherez encore. Apportez chaque matin vos sacrifices et tous les trois jours vos dîmes."
,"5":"Faites fumer l'offrande de louange, le pain sans levain, annoncez vos offrandes volontaires, proclamez-les puisque cela vous plaît, Israélites - parole du Seigneur Yahvé!"
,"6":"Je vous ai fait les dents nettes dans toutes vos villes, privant de pain toutes vos maisons; mais vous n'êtes pas revenus à moi, parole de Yahvé."
,"7":"J'ai retenu la pluie trois mois avant la moisson, j'ai fait pleuvoir sur une ville, et sur une autre il ne pleuvait pas; une terre recevait la pluie, et une autre où je ne la donnais pas se desséchait."
,"8":"La population de deux, de trois villages, courait assoiffée vers le seul village où l'on trouvait l'eau, et ils avaient encore soif; mais vous n'êtes pas revenus vers moi - parole de Yahvé."
,"9":"Je vous ai envoyé les insectes et la maladie, j'ai frappé vos jardins et vos vignes, la sauterelle a dévoré vos figuiers et vos oliviers; mais vous n'êtes pas revenus vers moi - parole de Yahvé."
,"10":"J'ai envoyé contre vous la peste, comme en Egypte. J'ai tué vos jeunes gens par l'épée et vos chevaux étaient capturés. J'ai fait monter jusqu'à vos narines l'odeur de mort de votre camp, mais vous n'êtes pas revenus à moi - parole de Yahvé."
,"11":"Pour vous j'ai fait trembler la terre, un vrai séisme de Dieu, comme celui de Sodome et de Gomorrhe; vous n'étiez plus qu'un bout de tison arraché à l'incendie, mais vous n'êtes pas revenus vers moi - parole de Yahvé."
,"12":"C'est pourquoi maintenant je viens te demander des comptes, Israël: prépare-toi à paraître devant ton Dieu."
,"13":"Il produit le tonnerre, il fait souffler le vent, il en fait savoir à l'homme le pourquoi. Il change l'aurore en ténèbres, il marche sur les sommets de la terre: son nom est Yahvé, le Dieu Sabaot."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Ecoutez cette parole que je prononce contre vous, maison d'Israël, c'est une lamentation."
,"2":"La vierge d'Israël est tombée, elle ne se relèvera pas; elle est jetée à terre, personne ne la relèvera."
,"3":"Voici ce que dit Yahvé: Dites-moi les villes en Israël qui envoyaient mille hommes en campagne: elles n'en auront plus que cent; celle qui pouvait en envoyer cent n'en aura plus que dix."
,"4":"Car voici ce que dit Yahvé à la maison d'Israël: Cherchez-moi et vous vivrez!"
,"5":"Mais ne cherchez pas à Béthel, n'allez pas à Guilgal, ne passez pas à Bersabée, car Guilgal ira en captivité, et de Béthel il ne restera rien."
,"6":"Cherchez Yahvé et vous vivrez; voulez-vous qu'il envoie le feu,contre la maison de Joseph, et qu'il la dévore sans que nul ne l'éteigne?"
,"8":"C'est lui qui fit les Pléiades, Orion, qui change les ténèbres en aurore,et le jour en une nuit obscure, qui appelle les eaux de la mer,et les répand sur toute la terre; son Nom est Yahvé."
,"9":"Il déchaîne la ruine sur les puissants, et la ruine pénètre dans la forteresse."
,"7":"Malheur à qui prononce, au lieu du droit, une sentence amère, et qui piétine la justice."
,"10":"Ils détestent celui qui défend le droit; ils ont en horreur celui qui dit la vérité."
,"11":"N'est-ce pas vous qui piétinez le pauvre et lui taxez son blé? Construisez donc vos maisons de pierre, vous ne les habiterez pas; plantez de bonnes vignes, vous n'en boirez pas le vin."
,"12":"Car je connais vos crimes, ils sont nombreux; je connais vos péchés, ils sont énormes. Vous opprimez le juste, vous ramassez les pots-de-vin, et au tribunal vous retirez ses droits au pauvre."
,"13":"L'homme sage aujourd'hui se tait, car c'est un temps de malheur."
,"14":"Cherchez le bien et non le mal, et vous vivrez; alors Yahvé, le Dieu Sabaot, sera avec vous comme vous le dites."
,"15":"Détestez le mal et aimez le bien, faites régner la justice à la porte de la ville; peut-être Yahvé, le Dieu Sabaot, aura-t-il pitié du reste de Joseph!"
,"16":"Voici ce que dit Yahvé, le Dieu Sabaot, le Seigneur: Sur toutes les places on se lamente, dans toutes les rues j'entends: Hélas, hélas! On invite les laboureurs à faire ensemble le deuil, avec des pleureurs pour les lamentations."
,"17":"Car je vais passer au milieu de toi, et ce seront des lamentations dans toutes les vignes: c'est le Seigneur qui le dit."
,"18":"Vous tombez mal, vous qui soupirez après le jour de Yahvé. Que sera-t-il pour vous, le jour de Yahvé? Il sera ténèbres et non lumière."
,"19":"Ce sera comme un homme qui s'enfuit devant un lion et tombe sur un ours; il se réfugie dans sa maison, s'appuie sur le mur, et un serpent le mord."
,"20":"Le jour de Yahvé ne sera pas lumière, mais bien plutôt ténèbres, ce sera l'obscurité où plus rien ne brille."
,"21":"Je déteste, je méprise vos fêtes, je ne supporte pas vos célébrations."
,"22":"Pourquoi m'offrez-vous des holocaustes, des offrandes? Je n'y prends pas plaisir. Vos sacrifices de bêtes grasses, je ne les regarde pas."
,"23":"Eloigne de moi le bruit de tes cantiques, que je n'entende plus le son de tes harpes;"
,"24":"mais fais que le jugement coule comme l'eau, et la justice comme un torrent jamais à sec."
,"25":"M'offriez-vous des sacrifices et des offrandes pendant les quarante ans du désert, maison d'Israël?"
,"26":"Gardez donc les idoles que vous vous êtes fabriquées, Sakkout votre roi, et l'étoile de votre dieu Kévan,"
,"27":"et moi je vous déporterai au-delà de Damas, dit Yahvé; le Dieu Sabaot est son Nom."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Malheur aux notables du premier des peuples, ces hommes à qui s'adresse toute la nation d'Israël! Installés dans votre orgueil, vous vous sentez en sécurité sur la montagne de Samarie."
,"2":"Mais passez à Kalné et regardez; de là allez à Hamat-la-grande, descendez ensuite à Gat, au pays des Philistins. Vos villes valent-elles mieux que ces royaumes? Votre territoire est-il plus grand que n'était le leur?"
,"3":"Et vous croyez que vous éloignerez le jour du malheur? Vous précipitez le règne de la violence."
,"4":"Ils se couchent sur des lits d'ivoire, ils se prélassent sur leurs divans, ils mangent les agneaux du troupeau et les veaux pris à l'étable."
,"5":"Ils poussent des hurlements au son de la harpe, ils inventent comme David des instruments de musique."
,"6":"Ils boivent le vin dans de larges coupes et se pommadent avec des huiles de qualité: peu leur importe la ruine de Joseph."
,"7":"Vous qui êtes les premiers, vous serez les premiers des déportés; car le Seigneur Yahvé l'a juré par lui-même: l'orgie des paresseux est maintenant terminée."
,"8":"L'orgueil de Jacob me dégoûte, et je déteste ses palais; c'est pourquoi je livrerai la ville au pillage avec tout ce qu'elle contient."
,"9":"Et s'il reste une maison, avec dix hommes à l'intérieur, eux aussi mourront."
,"10":"Lorsqu'un proche se présentera pour sortir de la maison leurs restes, il demandera à celui qui est au fond de la maison: 'Y-a-t-il encore quelqu'un avec toi?' L'autre répondra: 'Personne!', et il ajoutera: 'Taisez-vous, il ne faut pas prononcer le nom de Yahvé.'"
,"11":"Car maintenant c'est Yahvé qui commande: de la grande maison il fait une ruine, et de la petite un tas de décombres."
,"12":"A-t-on vu des chevaux courir sur les rochers? A-t-on jamais labouré la mer avec des boeufs? Or vous, vous avez mis au lieu du droit le poison, et vous rendez amers les fruits de la justice."
,"13":"Après quoi vous vous vantez pour des bêtises: 'Cette fois encore nous avons gagné!'"
,"14":"Mais moi je fais venir contre vous, gens d'Israël, une nation qui vous réduira en esclavage, depuis l'entrée de Hamat jusqu'au torrent de la Araba - parole de Yahvé, Dieu Sabaot."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Voici ce que le Seigneur Yahvé me fit voir: au temps où l'herbe commence à repousser après la coupe pour le roi, il créait des sauterelles."
,"2":"Je les voyais dévorer toute l'herbe du pays et je dis: 'Seigneur Yahvé, pardonne, je t'en prie. Jacob est si petit, comment tiendra-t-il?'"
,"3":"Alors Yahvé se repentit et déclara: 'Cela n'arrivera pas!'"
,"4":"Le Seigneur Yahvé me fit voir autre chose: le Seigneur Yahvé appelait le feu pour punir son peuple. Le feu mit les sources à sec et dévora la campagne."
,"5":"Alors je dis: 'Seigneur Yahvé, arrête, je t'en prie! Jacob est si petit, comment tiendra-t-il?'"
,"6":"Yahvé se repentit et déclara: 'Cela non plus n'arrivera pas.'"
,"7":"Il me fit voir autre chose encore: le Seigneur se tenait le long d'un mur avec un fil à plomb dans la main."
,"8":"Yahvé me dit: 'Amos que vois-tu?' Je répondis: 'Un fil à plomb.' Le Seigneur me dit: 'Voici que je vais mettre d'aplomb mon peuple Israël, et désormais je ne lui pardonnerai plus."
,"9":"Les hauts-lieux d'Isaac seront ruinés, les sanctuaires d'Israël seront dévastés, et je m'en prendrai à la maison de Jéroboam l'épée à la main.'"
,"10":"Alors Amasias, le prêtre de Béthel, envoya dire à Jéroboam, roi d'Israël: 'Amos conspire contre toi au coeur du pays d'Israël, le pays ne peut plus supporter ses discours."
,"11":"Oui, voici ce que dit Amos: Jéroboam sera tué par l'épée et Israël sera déporté loin de sa terre.'"
,"12":"Amasias dit à Amos: 'Va-t'en, voyant! Retourne au pays de Juda, et là mange ton pain en faisant le prophète;"
,"13":"mais tu ne prophétiseras plus à Béthel, car c'est un sanctuaire royal, un temple du royaume.'"
,"14":"Amos répondit à Amasias: 'Je ne suis pas prophète, je ne fais pas partie des groupes de prophètes: je suis berger et je traite les sycomores."
,"15":"Mais Yahvé m'a pris de derrière le troupeau et m'a dit: Va, prophétise à mon peuple Israël."
,"16":"Puisque tu me dis maintenant: Ne prophétises plus contre Israël, cesse de raconter tes sornettes contre la maison d'Isaac, écoute cette parole de Yahvé:"
,"17":"Ta femme se prostituera dans la ville, tes fils et tes filles seront tués par l'épée, ta terre sera partagée, et toi tu mourras sur une terre impure; quant à Israël, il sera déporté loin de sa terre.'"
}`)
	CurrentBook.AddChapter(8, `{
"1":"Voici ce que le Seigneur Yahvé me fit voir: une corbeille de fruits mûrs."
,"2":"Il me dit: 'Amos, que vois-tu?' Je répondis: 'Une corbeille de fruits mûrs.' Yahvé me dit: 'Mon peuple Israël est mûr, sa fin est arrivée; désormais je ne lui pardonnerai plus."
,"3":"En ce jour-là, les chants de ses palais se changeront en cris de douleur - parole du Seigneur Yahvé. Les cadavres seront nombreux, on les jettera dans tous les coins.'"
,"4":"Ecoutez ceci, vous qui écrasez le pauvre et qui faites disparaître les petits du pays."
,"5":"Vous dites: 'Vite! Que passe la fête de la nouvelle lune, et nous pourrons vendre nos graines; que passe le sabbat et nous écoulerons notre blé, nous vendrons jusqu'aux déchets. Nous diminuerons la mesure, nous augmenterons les prix et nous fausserons les balances."
,"6":"Nous achèterons les pauvres avec un peu d'argent, et les petits, pour une paire de sandales.'"
,"7":"Mais Yahvé l'a juré par la Gloire de Jacob: 'Jamais je n'oublierai ce qu'ils ont fait!'"
,"8":"C'est à cause de cela que la terre a tremblé et ses habitants sont en deuil; la terre monte et puis retombe, comme le Nil d'Egypte."
,"9":"En ce jour-là - parole du Seigneur Yahvé - je ferai coucher le soleil en plein midi, les ténèbres s'étendront sur la terre au milieu du jour."
,"10":"Je changerai vos fêtes en deuil et tous vos chants en lamentations; sur tous les reins je mettrai le sac, et je rendrai chauves les têtes. Le pays portera le deuil comme on fait pour un fils unique, et l'avenir ne sera pas moins amer."
,"11":"Voici venir des jours, parole de Yahvé, où j'enverrai dans le pays la faim, non pas faim de pain ou soif d'eau, mais la soif d'entendre la parole de Yahvé."
,"12":"Alors on courra d'une mer à l'autre, on ira du nord jusqu'au levant pour chercher la parole de Yahvé, mais on ne la trouvera pas."
,"13":"En ce jour-là, les belles filles tomberont de soif et les jeunes gens de même,"
,"14":"eux qui juraient par le péché de Samarie et disaient: 'Vive ton Dieu, Dan! Vive ton Dieu-chéri, Bersabée!' Oui, ils tomberont et ne se relèveront pas."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Je vis le Seigneur debout près de l'autel; il me dit: 'Frappe le chapiteau! Que les poutres s'ébranlent et que le plafond tombe sur leurs têtes à tous. Ceux qui resteront, je les tuerai par l'épée; pas un ne se sauvera, pas un n'échappera."
,"2":"Même s'ils forçaient le séjour des morts, ma main les en retirerait, s'ils montaient jusqu'aux cieux, je les en ferais descendre."
,"3":"S'ils se cachaient au sommet du Carmel, j'irais les chercher, je les rattraperais. S'ils se sauvaient devant moi, au plus profond de la mer, je commanderais au Serpent d'y aller pour les mordre."
,"4":"S'ils s'en vont en captivité devant leurs ennemis, je commanderai à l'épée de partir là-bas pour les tuer; je ne les quitterai pas des yeux, mais ce sera pour leur malheur et non pour leur bonheur."
,"5":"Yahvé Sabaot est le Seigneur: s'il touche la terre elle fond, et ceux qui l'habitent se défont. La terre tremble, monte et retombe comme le Nil d'Egypte."
,"6":"Il a bâti dans les cieux sa demeure et recouvert d'une voûte la terre, il appelle les eaux de la mer et les répand sur la surface de la terre: Yahvé Sabaot est son Nom."
,"7":"Pour moi, fils d'Israël, vous n'êtes ni plus ni moins que les Kouchites - parole de Yahvé. Tout comme j'ai fait monter Israël du pays d'Egypte, j'ai fait venir les Philistins de Kaftor et les Araméens de Kir."
,"8":"Sachez donc que le Seigneur Yahvé a l'oeil sur ce royaume pécheur: je vais l'exterminer de la surface de la terre. Pourtant je ne détruirai pas totalement la maison de Jacob - parole de Yahvé. "
,"9":"Sachez l'ordre que maintenant je donne: je veux secouer la maison d'Israël parmi toutes les nations comme on secoue avec un tamis, sans qu'un seul grain tombe à terre."
,"10":"Mais ce sera la mort par l'épée pour les pécheurs de mon peuple, pour ceux qui disent: 'Tu ne peux faire que le malheur vienne et nous atteigne.'"
,"11":"En ces jours-là je relèverai la hutte branlante de David, j'en réparerai les brèches et je relèverai ses ruines; je la reconstruirai comme aux jours du passé."
,"12":"Alors ils hériteront de ce qui reste d'Edom et de toutes les nations sur lesquelles mon Nom était invoqué: c'est Yahvé qui le dit et qui le fera."
,"13":"Voici que des jours viennent - parole de Yahvé, où le laboureur rejoindra le moissonneur et celui qui foule les raisins rattrapera celui qui sème; le jus des raisins ruissellera sur les montagnes, et toutes les collines seront fertiles."
,"14":"Alors je ramènerai les déportés de mon peuple Israël. Ils reconstruiront les villes en ruines et ils y habiteront, ils planteront des vignes et ils en boiront le vin, ils feront des jardins et ils en mangeront les fruits;"
,"15":"je les planterai sur leur terre et ils ne seront plus déracinés, ils ne seront plus arrachés du pays que je leur ai donné - parole de Yahvé ton Dieu."
}`)

}
func FR_LBDCC_LoadVNHAChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Voici l'oracle qu'a reçu le prophète Habaquq dans une vision:"
,"2":"Jusqu'à quand, Yahvé, appellerai-je au secours sans que tu écoutes? Jusqu'à quand vais-je crier: 'Violence!' sans que tu sauves?"
,"3":"Pourquoi me fais-tu voir l'injustice? Tes yeux supportent-ils l'oppression? Je ne vois que pillage et violence; on vit de disputes et de querelles."
,"4":"Du coup la loi a disparu, et la justice jamais n'arrive; tant que le méchant opprime le juste, la sentence est faussée."
,"5":"Regardez, traîtres, observez: vous en serez abasourdis, car j'accomplirai de vos jours ce que vous ne croiriez pas si on vous le disait."
,"6":"Oui, voici que j'amène les Kaldéens, ce peuple farouche et brutal qui parcourt les étendues et s'empare de demeures qui ne sont pas à lui."
,"7":"Il est terrible et redoutable, il ne connaît de droit que le sien."
,"8":"Ses chevaux courent plus vite que le léopard, sont plus tenaces que les chacals du soir; ses cavaliers bondissent, de loin ils accourent, semblables à l'aigle qui fond sur sa proie."
,"9":"Tous arrivent pour le pillage, les yeux rivés sur ce qu'ils convoitent; ils ramassent les captifs comme grains de sable."
,"10":"Ce peuple se moque des rois et n'a que faire des princes; il se joue des forteresses: il monte un remblai de terre et s'en empare."
,"11":"Puis le vent change, il est passé... en criminel qui n'a de Dieu que sa force."
,"12":"N'es-tu plus le Yahvé d'autrefois, mon Dieu et mon Saint qui ne peux mourir? As-tu fait de ce peuple, ô Yahvé, l'instrument de ta justice? L'as-tu choisi, ô mon Rocher, pour nous corriger?"
,"13":"Tu as les yeux trop purs pour souffrir le mal, tu ne peux regarder la souffrance; pourquoi regardes-tu les traîtres sans rien dire, quand un méchant dévore un plus juste que lui?"
,"14":"Tu traites les hommes comme les poissons de la mer, comme les serpents qui n'ont pas de maître;"
,"15":"l'hameçon du Kaldéen les prend tous, il les tire dans son filet, il les ramasse dans sa nasse. Pour lui c'est la joie et la fête; "
,"16":"il offre un sacrifice à son filet, et de l'encens à sa nasse, car il leur doit la meilleure part, les aliments de premier choix."
,"17":"Il ne cessera donc pas de tirer l'épée et de massacrer les hommes sans pitié?"
}`)
	CurrentBook.AddChapter(2, `{
"1":"Je veux rester à mon poste de garde, debout sur le rempart, en éveil; je verrai ce que me dit Yahvé, ce qu'il répondra à mes reproches."
,"2":"Alors Yahvé m'a répondu, il m'a dit: 'Ecris cette vision, grave-la sur des tablettes, qu'elle se lise facilement."
,"3":"Cette vision attend son heure, elle arrivera à son terme et ne décevra pas. Si elle tarde, attends-la, car elle viendra sûrement et ne prendra pas de retard."
,"4":"Voici: Celui qui vacille n'aura jamais ma faveur, mais le juste par sa fidélité vivra."
,"5":"En vérité, la richesse est trompeuse; l'homme est un insensé, il ne gagne rien s'il a son appétit vaste comme le gouffre, s'il devient insatiable autant que la mort, s'il engloutit toutes les nations et ramasse chez lui tous les peuples."
,"6":"Un jour on le donnera en exemple et tous se moqueront de lui. On lui chantera cette chanson: 'Malheur à celui qui amasse ce qui n'est pas à lui: il ne cesse d'accumuler les dettes. "
,"7":"Soudain apparaîtront tes créanciers, certains vont s'éveiller qui te prendront tout."
,"8":"Toi qui as dépouillé beaucoup de nations, tu seras dépouillé par ce qui reste de peuples. Car tu as versé du sang humain, tu as fait violence à la terre, à la cité, à tous ses habitants."
,"9":"Malheur à qui gagne pour les siens des biens mal acquis, pour placer bien haut son repaire, espérant ainsi échapper au malheur:"
,"10":"c'est la honte que tu as amenée sur ta maison. Quand tu détruisais tant de peuples, tu attentais à ta propre vie."
,"11":"Oui, la pierre crie dans ton mur, et de ta charpente le bois lui répond."
,"12":"Malheur à celui qui bâtit une ville avec le sang, qui fonde une cité sur l'injustice."
,"13":"Yahvé Sabaot l'a voulu ainsi: que les peuples se fatiguent pour de la fumée, que les nations s'épuisent pour du rien."
,"15":"Malheur à qui fait boire à ses voisins le poison, jusqu'à l'enivrer, pour s'amuser ensuite de sa nudité."
,"16":"Tu seras rassasié maintenant, de honte et non de gloire; bois donc à ton tour et sois pris d'ivresse! La main de Yahvé retournera sur toi la coupe, et la honte couvrira ta gloire."
,"17":"Oui, la violence que tu as faite au Liban avec ses bêtes massacrées retombera sur toi et tu connaîtras la terreur, à cause du sang des hommes et de la violence que tu as faite à la terre, à la cité et à tous ceux qui l'habitent."
,"19":"Malheur à celui qui dit à un morceau de bois: 'Eveille-toi', et à la pierre silencieuse: 'Réveille-toi'. Elle est plaquée d'or et d'argent mais elle n'aura pas de souffle."
,"18":"A quoi sert une idole, pour qu'on en fabrique ainsi? Image de métal fondu, objet menteur. Comment celui qui la fabrique peut-il mettre en elle sa confiance? Ce ne sont que des idoles muettes."
,"20":"Mais Yahvé habite dans son Temple saint: terre entière, fais silence devant lui!"
}`)
	CurrentBook.AddChapter(3, `{
"1":"Prière du prophète Habaquq, sur le ton des lamentations."
,"2":"O Yahvé, j'ai bien entendu, j'ai vu cette oeuvre que tu réaliseras, que tu montreras au cours des temps: dans ta colère, n'oublie pas ta miséricorde!"
,"3":"Eloah est sorti de Théman, le Saint, du mont Paran. Sa majesté voile les cieux, la terre est pleine de sa gloire."
,"4":"Son éclat est comme la lumière, des rayons partent de ses mains, s'échappent de sa puissance secrète."
,"5":"Devant lui marche la peste,les fièvres mortelles suivent ses pas."
,"6":"Il s'est arrêté, la terre tremble, il a regardé, les nations s'effraient, les monts des origines volent en éclats, les collines antiques s'effondrent: ses chemins étaient tracés depuis toujours."
,"7":"J'ai vu l'épouvante à son passage, les tentes de Kouchan en ont été secouées."
,"8":"Ta colère est-elle pour les fleuves, t'emportes-tu, Yahvé, contre la mer, pour que tu montes sur tes chevaux, sur tes chars victorieux?"
,"9":"Tu as tendu l'arc, placé tes flèches sur la corde. Tu fends la terre et les torrents coulent,"
,"10":"à ta vue les montagnes s'ébranlent, l'averse tombe avec violence, l'abîme fait entendre sa voix. Le soleil a perdu son éclat,"
,"11":"la lune s'est arrêtée sur place, quand sont parties tes flèches de lumière, les éclairs de ta lance."
,"12":"Avec rage tu piétines la terre, furieux, tu foules aux pieds les nations."
,"13":"Tu es sorti au secours de ton peuple, pour secourir celui que tu as consacré. Tu fracasses la tête du méchant, tu le ruines jusqu'à ses racines."
,"14":"Tes flèches ont percé la tête de ses chefs,qui s'élançaient joyeux pour nous briser, pour dévorer sans bruit le malheureux."
,"15":"Sur tes chevaux tu as franchi la mer, le torrent des eaux bouillonnantes."
,"16":"A l'entendre mon sang n'a fait qu'un tour, à ce bruit je ne sais plus que balbutier; la maladie est entrée dans mes os,et mes pas ne sont plus assurés. Pourtant j'aspire à voir ce jour fatal,qui surprendra le peuple de nos oppresseurs."
,"17":"Le figuier peut-être ne fleurira plus, et la vigne ne donnera rien, la récolte d'olives fera peine à voir, et la moisson ne donnera pas de quoi manger, les bercails seront vides de brebis,et les étables de boeufs -"
,"18":"mais moi, je me réjouirai en Yahvé, je tressaille de joie en Dieu mon sauveur."
,"19":"Yahvé, le Seigneur, est ma force, il affermit mes pieds comme ceux de la biche, il entraîne mes pas sur les hauteurs. Psaume pour le maître de chant, à jouer sur des instruments à cordes."
}`)

}
func FR_LBDCC_LoadVNILChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Parole de Yahvé qui fut adressée à Joël, fils de Pétouel."
,"2":"Vieillards, écoutez ceci; prêtez l'oreille, vous tous habitants du pays: A-t-on vu de votre temps quelque chose de semblable, ou du temps de vos pères?"
,"3":"Vous le raconterez à vos fils, vos fils le rediront à leurs fils et leurs fils à la génération suivante."
,"4":"Ce que l'insecte avait laissé, la sauterelle l'a dévoré; ce que la sauterelle a laissé, le sauteur l'a dévoré; ce que le sauteur a laissé, le criquet l'a dévoré."
,"5":"Réveillez-vous, ivrognes, et pleurez. Lamentez-vous, buveurs de vin, car le vin nouveau vous est retiré de la bouche."
,"6":"Un peuple puissant, innombrable, est monté contre mon pays; ses dents sont des dents de lion, il a des mâchoires de lionne."
,"7":"Il a dévasté ma vigne, épluché mon figuier; il les a pelés, abattus, les branches sont devenues toutes blanches."
,"8":"Pleure comme une vierge qui se revêt d'un sac pour pleurer l'époux de sa jeunesse."
,"9":"Il ne reste rien d'où tirer une offrande ou une libation pour la Maison de Yahvé. Les prêtres de Yahvé qui sont là de service sont en deuil."
,"10":"Les champs sont ravagés, la terre est en deuil, car le blé est perdu; il n'y a plus de vin nouveau et l'huile se termine."
,"11":"Prenez le deuil, paysans, tout comme les vignerons; lamentez-vous sur votre blé, votre orge, car la moisson des champs est perdue."
,"12":"La vigne est lamentable, le figuier sans verdure, le grenadier, le palmier, le pommier, tous les arbres des champs sont desséchés; la joie elle-même, comme honteuse, s'est éloignée de nous."
,"13":"Prêtres, habillez-vous de sacs et poussez des cris, lamentez-vous, serviteurs de l'autel! Jeûnez, serviteurs de mon Dieu, veillez toute la nuit habillés de sacs, car il n'y a plus ni offrande ni libation dans la Maison de votre Dieu."
,"14":"Annoncez un jeûne, convoquez l'assemblée, réunissez les anciens, avec les habitants du pays, à la Maison de Yahvé votre Dieu,"
,"15":"et criez vers Yahvé: 'Ah, quel jour!' Oui, le jour de Yahvé est proche, il vient comme un châtiment envoyé par le Tout-Puissant!"
,"16":"Sous nos yeux la nourriture nous a été retirée; il n'y a plus ni joie, ni allégresse dans la Maison de notre Dieu."
,"17":"Les semences ont séché sous les mottes de terre, les greniers sont vides, les magasins sans blé font triste figure."
,"18":"Entendez les cris des bêtes! Les troupeaux de boeufs s'affolent; ils n'ont plus rien à brouter; les brebis souffrent de la faim."
,"19":"Je crie vers toi, Yahvé, pour ce feu qui a dévoré les pâturages du désert, cette flamme qui a ravagé tous les arbres des champs;"
,"20":"les bêtes sauvages ont crié vers toi, car les torrents sont à sec et le feu a dévoré les pâturages du désert."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Sonnez du cor dans Sion, sonnez de la trompette sur ma sainte montagne; que tremblent tous les habitants, car le jour de Yahvé est proche: oui, il vient!"
,"2":"C'est un jour de ténèbres et d'obscurité, un jour de nuages et de sombres nuées. Voici venir, comme une ombre qui s'étend sur les monts, un peuple nombreux, puissant, comme il n'y en a jamais eu, comme il n'y en aura plus dans les années et les générations à venir."
,"3":"Devant lui le feu dévore, et derrière lui danse la flamme; devant lui la terre semble un jardin de paradis, derrière lui c'est un désert, une solitude: rien ne lui a échappé."
,"4":"Leur aspect est celui des chevaux, ils courent comme des cavaliers;"
,"5":"c'est comme un bruit de chars qui bondissent sur les hauteurs, le bruit d'un feu violent qui dévore la paille, comme une armée immense rangée en bataille."
,"6":"A ce spectacle les peuples tremblent, tous les visages sont abattus."
,"7":"Comme des soldats les voici qui s'élancent, comme des assaillants ils escaladent la muraille; chacun fait son chemin sans que rien le détourne."
,"8":"Chacun va devant soi sans bousculer ses frères; ils foncent à travers les flèches et ne se dispersent pas."
,"9":"Voici qu'ils se jettent sur la ville, courent sur les remparts, montent aux maisons et, comme des voleurs, entrent par les fenêtres."
,"10":"En les voyant la terre s'effraie, les cieux s'agitent, soleil et lune s'assombrissent; les étoiles perdent leur éclat."
,"11":"Yahvé fait entendre son tonnerre à la tête de ses troupes, innombrables sont ses bataillons, et puissants pour exécuter ses ordres. Oui, le jour de Yahvé est grand, il est très redoutable: qui pourra l'affronter?"
,"12":"Revenez à moi de tout votre coeur - parole de Yahvé - il en est encore temps; jeûnez, pleurez et lamentez-vous."
,"13":"Déchirez vos coeurs et non vos ha bits; revenez vers Yahvé votre Dieu, car il est tendresse et pardon, lent à la colère, riche en miséricorde, il regrette bientôt le malheur qu'il a envoyé."
,"14":"Qui sait? Peut-être va-t-il se reprendre, regretter et laisser à la fin quelque bénédiction, pour que vous puissiez offrir oblations et libations à Yahvé votre Dieu?"
,"15":"Sonnez du cor dans Sion, ordonnez un jeûne, convoquez une assemblée."
,"16":"Réunissez le peuple, rassemblez les vieillards, réunissez les enfants et les nourrissons à la mamelle: même vous, jeunes mariés, sortez de votre chambre!"
,"17":"Que les prêtres serviteurs de Yahvé pleurent entre le vestibule et l'autel; qu'ils disent: 'Yahvé, prends pitié de ton peuple, ne permets pas que les tiens soient humiliés et que les païens s'en amusent. Pourquoi dirait-on parmi les peuples: Où est leur Dieu?'"
,"18":"Et voici que Yahvé s'est inquiété pour sa terre, il a eu pitié de son peuple."
,"19":"Yahvé a répondu, il a dit à son peuple: 'Je vais vous envoyer le blé, le vin nouveau et l'huile fraîche; vous pourrez vous rassasier. Désormais je ne ferai plus rien qui vous attire le mépris des étrangers."
,"20":"J'éloignerai de vous cet ennemi qui vient du nord, je le chasserai vers un pays désert et aride, son avant-garde vers la Mer Orientale, et les derniers vers la Mer Occidentale. Il s'en élèvera une odeur infecte, une vraie puanteur: voyez que Yahvé fait de grandes choses.'"
,"21":"Terre, ne crains plus; sois toute à la joie et la fête, car Yahvé fait de grandes choses."
,"22":"Bêtes des champs, ne craignez plus, car les pâturages du désert ont reverdi; de nouveau l'arbre porte des fruits, les figuiers et la vigne donnent leurs richesses."
,"23":"Et vous, enfants de Sion, soyez heureux, réjouissez-vous en Yahvé votre Dieu, car dans sa justice il vous a donné à manger. Il fera venir sur vous les pluies: pluie d'automne et pluie de printemps comme autrefois."
,"24":"Vos aires à battre se rempliront de blé, vos cuves déborderont de vin nouveau et d'huile."
,"25":"Je vous dédommagerai pour les années qu'ont dévorées la sauterelle, le sauteur, le hanneton et le criquet - toute cette armée que j'avais envoyée contre vous."
,"26":"Vous mangerez et serez rassasiés, vous louerez le Nom de Yahvé votre Dieu qui a fait pour vous des merveilles."
,"27":"Vous saurez que je suis au milieu d'Israël, que je suis, moi Yahvé, votre Dieu et qu'il n'y en a pas d'autre; mon peuple ne connaîtra plus jamais la honte."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Voici ce qui arrivera plus tard: Je répandrai mon Esprit sur tous les vivants, vos fils et vos filles prophétiseront, vos vieillards auront des rêves, et vos jeunes des visions."
,"2":"Même sur les serviteurs, les servantes,je répandrai mon Esprit en ces jours-là."
,"3":"Je ferai voir des prodiges aux cieux et sur la terre: du sang, du feu, des colonnes de fumée."
,"4":"Le soleil se changera en ténèbres,et la lune en sang,avant la venue du jour de Yahvé, un jour grand et redoutable."
,"5":"Alors sera sauvé, quel qu'il soit, celui qui invoquera le Nom de Yahvé. Car Yahvé l'a dit: Il y aura des rescapés sur le Mont Sion, il y aura des survivants à Jérusalem: ceux que Yahvé a désignés."
}`)
	CurrentBook.AddChapter(4, `{
"1":"En ces jours-là, en ce temps-là, je ramènerai les captifs de Juda et de Jérusalem."
,"2":"Je rassemblerai toutes les nations et les ferai descendre dans la vallée de Josaphat. Là je ferai leur procès, car elles ont dispersé mon peuple parmi les nations, cet Israël qui est mon héritage, et elles se sont partagé mon pays."
,"3":"On a tiré au sort les miens; ils ont donné le jeune garçon pour une prostituée, ils ont vendu la jeune fille pour du vin qu'ils ont bu."
,"4":"Qu'êtes-vous donc pour moi, Tyr et Sidon, et vous tous, royaumes de Philistie? Voulez-vous prendre votre revanche sur moi? Si jamais vous me provoquez, je ferai rapidement retomber vos menaces sur votre tête."
,"5":"Vous avez pris mon argent et mon or, vous avez emporté mes bijoux de valeur pour vos temples."
,"6":"Vous avez vendu aux Grecs les gens de Juda et de Jérusalem pour les éloigner de leur pays."
,"7":"Mais je vais les rappeler du lieu où vous les avez vendus, et je ferai retomber sur votre tête le mal que vous avez fait."
,"8":"Je ferai vendre vos fils et vos filles par les gens de Juda; ils les vendront aux Sabéens, cette nation lointaine: Yahvé a parlé."
,"9":"Annoncez ceci parmi les nations: Proclamez la guerre sainte, entraînez les soldats! Venez, guerriers, et marchez au combat!"
,"10":"De vos socs de charrues faites des épées, de vos haches faites des lances. Que le faible dise: Je suis un brave!"
,"11":"Dépêchez-vous, nations d'alentour, venez toutes, rassemblez-vous là, et toi, Yahvé, fais descendre tes Vaillants!"
,"12":"Voici venir les nations, elles montent à la vallée de Josaphat: là même je me tiens en juge pour toutes les nations d'alentour."
,"13":"Jetez votre faucille car la moisson est mûre, venez, foulez, car le pressoir est plein. Les cuves débordent, car leur péché est énorme."
,"14":"Des foules et des foules sont là, dans la Vallée-du-Jugement: sachez que le jour de Yahvé est proche dans la Vallée-du-Jugement."
,"15":"Le soleil et la lune s'assombrissent, les étoiles ont perdu leur clarté."
,"16":"De Sion Yahvé pousse un cri, de Jérusalem il fait entendre sa voix. Le ciel et la terre sont ébranlés, mais pour son peuple Yahvé est un abri, il est le refuge des fils d'Israël."
,"17":"Vous saurez que je suis Yahvé votre Dieu: c'est moi qui habite à Sion, sur ma sainte montagne. Jérusalem est un lieu saint et les étrangers n'y passeront plus."
,"18":"En ce jour-là le jus des raisins ruissellera sur les montagnes, et le lait sur les collines; tous les torrents de Juda déborderont d'eau; une source sortira du Temple de Yahvé pour irriguer le ravin des acacias."
,"19":"Mais l'Egypte deviendra une solitude, Edom, un désert abandonné, pour toutes les violences qu'ils ont faites aux fils de Juda: car ils ont répandu dans ce pays le sang innocent."
,"20":"Juda sera habité pour toujours, et Jérusalem, de génération en génération. Je vengerai leur sang - ce que je n'ai pas encore fait - et Yahvé habitera en Sion."
}`)

}
func FR_LBDCC_LoadVNINChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Une parole de Yahvé fut adressée à Jonas, fils d'Amitaï:"
,"2":"'Lève-toi, pars à Ninive, la Grande Ville, pour lui lancer des menaces, car leur méchanceté est montée jusqu'à moi.'"
,"3":"Jonas partit, mais ce fut pour s'enfuir à Tarsis, loin de Yahvé. Il descendit à Jaffa où il trouva un bateau en partance pour Tarsis, il paya son billet et s'embarqua avec eux pour gagner Tarsis, loin de Yahvé."
,"4":"Mais Yahvé déchaîna sur la mer un grand vent et la tempête était si violente que le bateau menaçait de se briser."
,"5":"Les marins avaient peur et chacun invoquait son dieu; on jeta la cargaison à la mer afin d'alléger le bateau. Jonas cependant était descendu au fond du bateau pour s'y étendre et il dormait profondément."
,"6":"Le commandant du bateau s'approcha de lui et lui dit: 'Pourquoi dors-tu? Lève-toi et crie vers ton dieu! Peut-être Dieu se souviendra-t-il de nous et ne nous laissera pas périr.'"
,"7":"Ils se dirent alors entre eux: 'Jetons les sorts pour savoir qui nous a attiré ce malheur.' On tira donc au sort et le sort tomba sur Jonas."
,"8":"Les autres lui demandèrent: 'Ce malheur est bien dû à quelqu'un, dis-nous quel est ton métier et d'où tu viens. Quel est ton pays, à quel peuple appartiens-tu?'"
,"9":"Et Jonas commença à leur raconter: 'Je suis un Hébreu et je vénère Yahvé, le Dieu du ciel, celui qui a fait la mer et les continents...'"
,"10":"Les autres furent remplis de crainte et lui dirent: 'Qu'as-tu fait là!' Car maintenant ces hommes savaient qu'il fuyait loin de Yahvé: Jonas le leur avait dit."
,"11":"Ils lui dirent: 'Que devons-nous te faire pour que la mer se calme?' Car la mer se soulevait de plus en plus."
,"12":"Jonas leur dit: 'Prenez-moi et jetez-moi à la mer, et la mer se calmera, car je sais que c'est à cause de moi que cette grande tempête s'est levée.'"
,"13":"Les hommes avaient beau ramer de toutes leurs forces pour regagner la côte, ils étaient impuissants, car la mer se soulevait de plus en plus contre eux."
,"14":"Ils lancèrent donc cet appel à Yahvé: 'O Yahvé, ne nous fais pas périr à cause de cet homme et ne nous rends pas responsables de sa mort; c'est toi, Yahvé, qui as agi comme tu le voulais.'"
,"15":"Cela dit, ils prirent Jonas et le jetèrent à la mer et la mer se calma."
,"16":"Ces hommes furent remplis d'un profond respect pour Yahvé; ils lui offrirent un sacrifice et lui firent des promesses."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Yahvé envoya un grand poisson pour avaler Jonas, et Jonas resta trois jours et trois nuits dans le ventre du grand poisson."
,"2":"Du fond des boyaux du grand poisson, Jonas adressait cette prière à Yahvé son Dieu:"
,"3":"'Du fond de ma détresse j'ai lancé un appel,à Yahvé: il m'a répondu. Du gouffre des morts j'ai crié au secours,et tu as entendu ma voix."
,"4":"Tu m'avais jeté au milieu des mers, seul au milieu du torrent; tes vagues et tes flots déferlaient sur moi."
,"5":"Je disais: 'Me voilà chassé loin de toi, plus d'espoir de revoir ton Temple saint!'"
,"6":"Les eaux me montaient jusqu'au cou, je me perdais dans les eaux de l'abîme, ma tête se prenait dans les algues."
,"7":"J'étais descendu aux racines des montagnes, au pays dont les verrous pour toujours se ferment; mais tu m'as fait remonter de la fosse, Yahvé mon Dieu."
,"8":"Lorsque mon âme en moi se fondait, je me suis souvenu de Yahvé, ma prière est montée jusqu'à toi, jusqu'à ton saint Temple."
,"9":"Ceux qui servent de vaines idoles,ont sacrifié leur propre salut."
,"10":"Mais c'est à toi que vont mes sacrifices, mes chants de louange. mes voeux que j'accomplirai, car Yahvé est celui qui sauve."
,"11":"Alors Yahvé parla au grand poisson, et le poisson vomit Jonas sur la terre sèche."
}`)
	CurrentBook.AddChapter(3, `{
"1":"La parole de Yahvé fut adressée à Jonas une seconde fois:"
,"2":"'Lève-toi, lui dit-il, pars à Ninive, la grande ville, et lance contre elle les menaces que je te dirai.'"
,"3":"Jonas s'en alla donc à Ninive, comme Yahvé le lui disait. Or Ninive était une ville extrêmement grande, on la traversait en trois jours."
,"4":"Jonas entra; il marcha tout un jour, lançant ce message: 'Encore quarante jours et Ninive sera détruite!'"
,"5":"Les gens de Ninive crurent en Dieu; ils proclamèrent un jeûne et s'habillèrent de sacs, depuis le plus grand jusqu'au plus petit."
,"6":"Lorsque la nouvelle parvint au roi de Ninive, lui aussi se leva de son trône et ôta son manteau pour s'habiller d'un sac et s'asseoir sur la cendre."
,"7":"Le roi fit publier ceci dans Ninive: 'Ordre du roi et des grands! Aucun homme, aucun animal, ni gros ni petit bétail, ne mangera quoi que ce soit; les animaux ne brouteront pas et ne boiront pas d'eau."
,"8":"On s'habillera de sacs, les hommes comme les animaux, on criera vers Dieu de toutes ses forces, chacun renoncera à sa mauvaise conduite et à la violence qu'il commet."
,"9":"Peut-être Dieu changera-t-il d'avis, peut-être se repentira-t-il? Et s'il renonce à sa violente colère, nous serons sauvés.'"
,"10":"Dieu vit ce qu'ils faisaient et comment ils renonçaient à leur mauvaise conduite; alors Dieu se repentit du mal qu'il avait parlé de leur faire, il ne le fit pas."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Jonas en fut très mécontent, il se mit même en colère."
,"2":"Il fit sa prière à Yahvé: 'Ah Yahvé, c'est bien ce que je disais quand j'étais encore dans mon pays, et c'est pour cela que je me suis empressé de fuir à Tarsis. Je te connaissais comme le Dieu qui pardonne et fait miséricorde, lent à la colère, riche en bonté et vite fatigué de punir."
,"3":"Dans ces conditions prends ma vie, Yahvé, car la mort vaut mieux pour moi que la vie.'"
,"4":"Yahvé lui répondit: 'Crois-tu que tu as raison de te mettre en colère?'"
,"5":"Jonas sortit de la ville du côté de l'est, et là il s'installa; il se fit une cabane pour y rester à l'ombre et voir ce qui arriverait à la ville."
,"6":"Yahvé Dieu fit pousser un ricin pour lui faire de l'ombre sur la tête et calmer sa colère. Le ricin grandit au-dessus de Jonas qui en était tout heureux,"
,"7":"mais le lendemain, au petit matin, Dieu fit venir un ver qui piqua le ricin; il se dessécha."
,"8":"Puis au lever du soleil Dieu fit venir de l'est un vent brûlant. Le soleil tapait si fort sur la tête de Jonas, qu'il se trouva mal et souhaita la mort. Il dit: 'La mort vaut mieux pour moi que la vie.' "
,"9":"Mais Dieu lui dit: 'As-tu raison de te mettre en colère pour ce ricin?' Il répondit: 'Oui, j'ai bien raison d'être fâché à mort!'"
,"10":"Alors Yahvé lui dit: 'Tu te mets bien en peine pour ce ricin qui ne t'a coûté aucun travail et que tu n'as pas fait grandir, qui a poussé en une nuit et qui était sec la nuit suivante."
,"11":"Et moi, je ne devrais pas me mettre en peine pour Ninive, la grande ville, où vivent plus de cent vingt mille personnes qui ne distinguent pas le bien et le mal, sans parler de tous les animaux?"
}`)

}
func FR_LBDCC_LoadVNMIChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"La parole de Yahvé fut adressée à Michée de Moréchet, au temps de Yotam, d'Akaz et d'Ezéquias, rois de Juda. Voici ses visions sur Samarie et Jérusalem."
,"2":"Tous les peuples, écoutez! Sois attentive, terre entière! C'est Yahvé qui va témoigner contre vous, le Seigneur qui nous vient de son palais de sainteté."
,"3":"Il est sorti de sa demeure, il est descendu, il s'avance sur les hauteurs de la terre."
,"4":"Les montagnes se défont à son passage, les plaines sont comme cire fondue devant le feu, comme l'eau qui se déverse sur la pente."
,"5":"Mais c'est à cause du crime de Jacob, à cause des péchés de la maison d'Israël. Quel est donc le crime de Jacob? N'est-ce pas Samarie? Et quel est le péché de Juda? N'est-ce pas Jérusalem?"
,"6":"Je ferai de Samarie un tas de décombres dans un champ, un lieu où planter la vigne; je ferai que ses pierres roulent dans les vallées, je mettrai à nu ses fondations."
,"7":"Toutes ses statues seront brisées, ses richesses consumées par le feu; je mettrai en pièces ses pierres sacrées, fruit du salaire des prostituées: elles redeviendront salaire de prostituée."
,"8":"A cause de cela je pousserai des cris, je hurlerai, je marcherai dépouillé et nu, je ferai entendre mon cri comme le chacal et ma plainte comme l'autruche."
,"9":"Oui, le coup est irrémédiable, il atteint Juda, il frappe même Jérusalem, la porte de mon peuple."
,"10":"Ne l'annoncez pas dans Gat, ne pleurez pas dans Acco, roulez-vous dans la poussière à Bet-Léafra."
,"11":"Toi qui habites à Chafir, sonne de la trompette; toi qui demeures à Saanan, ne sors pas de la cité. Bet-Ha-Esel est arrachée de ses fondations."
,"12":"Que peut encore espérer Marot, quand Yahvé fait descendre le malheur aux portes de Jérusalem?"
,"13":"Attelle ton cheval au char, ville de Lakish, car c'est là qu'a commencé le péché pour la fille de Sion. Oui, on a trouvé chez toi les péchés d'Israël."
,"14":"C'est pourquoi il te faut renoncer à Moréchèt-Gat. Bet-Akzib décevra les rois d'Israël."
,"15":"Le pillard reviendra encore chez toi qui habites à Marécha, et ceux qui faisaient la gloire d'Israël partiront pour toujours."
,"16":"Arrache-toi les cheveux, rase-les à cause de tes enfants bien-aimés et deviens chauve comme le vautour, car les voici qui partent en déportation loin de toi."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Malheur à ceux qui projettent l'injustice et tout au long de la nuit préparent le mal. Dès le lever du jour, dès qu'ils le peuvent, ils l'exécutent."
,"2":"Ils repèrent des champs et les volent, des maisons, et ils les prennent; ils s'emparent du maître et de sa maison, de l'homme et de son héritage."
,"3":"C'est pourquoi, voici ce que dit Yahvé: 'Moi aussi je prépare contre cette race un malheur, vous n'y échapperez pas; vous ne serez plus fiers quand il viendra, car ce sera un temps de malheur."
,"4":"En ce jour-là on se moquera de vous, et vous, vous ferez entendre cette plainte: 'Nous sommes privés de tout, l'héritage de notre peuple a été partagé et personne ne le lui rend; nos champs sont distribués à ceux qui nous pillent.'"
,"5":"Il n'y aura plus personne pour vous donner un héritage dans l'assemblée de Yahvé."
,"6":"'Ne perdez pas votre salive à nous annoncer ce genre de choses, disent-ils, le malheur ne nous atteindra pas."
,"7":"La maison de Jacob serait-elle maudite? Yahvé aurait-il perdu patience? Est-ce donc bien comme cela qu'il fait d'habitude? Promet-il à son peuple, à Israël, autre chose que du bien?'"
,"8":"- Mais vous, vous êtes les ennemis de mon peuple, vous arrachez son manteau à celui qui est sans reproche, et vous faites la guerre à celui qui vit en paix."
,"9":"Vous arrachez les femmes de mon peuple des maisons qu'elles aimaient, vous enlevez pour toujours à leurs enfants la dignité que je leur ai donnée."
,"10":"Vous êtes ceux qui disent: Levez-vous, marchez, ce n'est pas le moment de la pause!,C'est l'épreuve que vous allez connaître, une cruelle épreuve à cause de votre péché! "
,"11":"Trouvez-moi un prophète assez menteur pour dire: 'Je te promets vin et alcool'; il sera le prophète de ce peuple."
,"12":"Oui je veux rassembler tout Jacob et réunir le reste d'Israël, je veux les regrouper comme des brebis au bercail, comme un troupeau dans son pâturage, comme une foule joyeuse."
,"13":"Celui qui ouvre le passage montera devant eux, ils élargiront la brèche; il leur fera passer la porte et par elle ils sortiront; oui leur roi passera devant eux, Yahvé se mettra à leur tête."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Je leur disais: 'Ecoutez donc, chefs de Jacob et commandants de la maison d'Israël! Ne devriez-vous pas connaître le droit?"
,"2":"Mais vous détestez le bien et vous aimez le mal, vous arrachez aux hommes jusqu'à leur peau et la chair qu'ils ont sur les os."
,"3":"Ceux qui ont dévoré la chair de mon peuple, qui lui ont arraché la peau et brisé les os, qui le déchirent comme la viande dans la marmite, comme la viande dans un chaudron -"
,"4":"ils pourront crier vers Yahvé mais lui ne leur répondra pas. Il leur cachera son visage en ce temps-là, pour tous les crimes qu'ils ont commis.'"
,"5":"Voici que Yahvé parle, contre les prophètes qui égarent mon peuple: 'Ils promettent la paix quand on leur met quelque chose sous la dent, mais à ceux qui ne leur donnent rien, ils déclarent la guerre."
,"6":"C'est pourquoi la nuit vient sur vous: plus de vision! Les ténèbres viennent sur vous: plus de révélation! Le soleil se couche pour les prophètes et leur jour se change en ténèbres."
,"7":"Les voyants vont être couverts de honte, et ceux qui devinaient l'avenir, couverts de confusion; ils fermeront tous la bouche, ils devront se taire car Dieu ne répondra pas."
,"8":"Moi au contraire, je suis rempli de force et du souffle de Yahvé, plein de justice et de courage pour dénoncer à Jacob son crime, à Israël son péché."
,"9":"Ecoutez donc ceci, chefs de la maison de Jacob et commandants de la maison d'Israël: 'Vous détestez la justice et vous rendez tortueux ce qui est droit."
,"10":"Vous bâtissez Sion sur du sang et Jérusalem sur le péché."
,"11":"La justice des chefs dépend du pot-de-vin, l'enseignement du prêtre de ce qu'on lui paye, et le prophète parle quand il a de l'argent. Mais tous ils sont sûrs de Yahvé; ils disent: Yahvé n'est-il pas au milieu de nous? Le malheur ne viendra pas sur nous."
,"12":"C'est pourquoi, à cause de vous, Sion deviendra un champ à labourer, Jérusalem sera un monceau de ruines; la hauteur du Temple ne sera plus qu'une colline à l'abandon.'"
}`)
	CurrentBook.AddChapter(4, `{
"1":"Après de nombreux jours, la montagne de la Maison de Yahvé sera placée plus haut que les montagnes et s'élèvera au-dessus des collines. Alors les peuples se presseront vers elle. "
,"2":"Les nations viendront nombreuses et diront: 'Venez, montons à la montagne de Yahvé, au Temple du Dieu de Jacob; il nous enseignera ses voies et nous suivrons ses sentiers, car l'ensei-gnement sortira de Sion, et de Jérusalem, la Parole de Yahvé."
,"3":"Il gouvernera des peuples nombreux et jugera des nations puissantes; de leurs épées ils feront des socs de charrue, et de leurs lances des faucilles; on ne lèvera plus l'épée nation contre nation, on n'apprendra plus à faire la guerre."
,"4":"Ils pourront s'asseoir chacun sous sa vigne ou sous son figuier sans que personne ne les tourmente. La bouche de Yahvé Sabaot a parlé.'"
,"5":"Oui, tous les peuples marchent, chacun au nom de son dieu, mais nous, nous marchons au nom de Yahvé notre Dieu, pour toujours et à jamais."
,"6":"En ce jour-là, parole de Yahvé, je réunirai les brebis qui boitent, je rassemblerai les égarées et celles que j'ai maltraitées."
,"7":"De celles qui boitent je ferai un reste, et des égarées, une nation puissante. Je vais régner sur elles à la montagne de Sion, dès à présent et pour toujours."
,"8":"Et toi, tour du troupeau, Ophel de la fille de Sion, tu retrouveras ta majesté d'autrefois; le pouvoir reviendra à Jérusalem."
,"9":"Pourquoi maintenant pousses-tu des cris? N'y-a-t-il plus de roi chez toi, tes conseillers ont-ils disparu? Te voilà soudain saisie de douleurs comme la femme qui enfante!"
,"10":"Eh bien, tords-toi de douleur et crie, fille de Sion, comme la femme qui enfante, car maintenant tu vas sortir de la ville et demeurer au milieu des champs. Tu iras jusqu'à Babylone et c'est là que tu seras délivrée, c'est là que Yahvé te rachètera de la main de tes ennemis."
,"11":"Voici que des nations nombreuses se sont rassemblées contre toi: 'Saccageons-la, disent-ils, que nos yeux se réjouissent de sa ruine!'"
,"12":"Mais elles ne connaissent pas les plans de Yahvé, elles n'ont pas compris son projet; il les a rassemblées comme les gerbes sur l'aire à battre le grain."
,"13":"Alors debout, foule le grain, fille de Sion! Voici que je te fais des cornes de fer et des sabots de bronze, tu piétineras des peuples nombreux et tu consacreras à Yahvé leurs dépouilles; leurs richesses iront au Seigneur de toute la terre."
,"14":"Maintenant courage, forteresse! Ils ont dressé un retranchement contre nous, ils frappent à coups de baguette la joue du gouverneur d'Israël."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Mais toi, Bethlehem Efrata, bien que tu sois le plus petit des clans de Juda, c'est de toi que me naîtra celui qui doit régner sur Israël; ses origines remontent aux temps anciens, aux jours d'autrefois."
,"2":"Oui, Yahvé ne les abandonne que jusqu'au temps où celle qui doit enfanter aura enfanté; alors le reste de ses frères reviendra vers les fils d'Israël."
,"3":"Lui se tiendra ferme, il fera paître son troupeau par la puissance de Yahvé et pour la gloire du nom de son Dieu; ils vivront en paix sous son autorité, car elle s'étendra jusqu'aux extrémités de la terre."
,"4":"Lui-même sera leur paix. Si Assour envahit notre pays, s'il piétine notre terre, nous lui opposerons sept bergers, huit chefs de guerre, "
,"5":"et c'est eux qui mèneront Assour avec l'épée et le pays de Nemrod avec le glaive. Il nous délivrera d'Assour s'il envahit notre pays et foule notre terre."
,"6":"Alors, au milieu des peuples nombreux, le reste de Jacob sera comme une rosée venue de Yahvé, comme des gouttes d'eau sur l'herbe, car ils n'espéreront pas en l'homme et n'attendront rien des mortels."
,"8":"Que ta main se lève sur tes adversaires et que tes ennemis disparaissent!"
,"9":"En ce jour-là - parole de Yahvé - j'enlèverai de chez toi tes chevaux, et je ferai disparaître tes chars."
,"10":"Je retrancherai les cités de ton pays et je détruirai toutes tes forteresses."
,"11":"J'enlèverai de chez toi toute sorcellerie et ceux qui prétendent annoncer l'avenir."
,"12":"J'enlèverai de chez toi tes idoles et tes pierres dressées; tu ne pourras plus te prosterner devant l'oeuvre de tes mains."
,"13":"Du milieu de toi j'arracherai tes pieux sacrés et je détruirai tes stèles."
,"14":"Puis avec colère, avec fureur, je me vengerai des nations qui n'ont pas obéi."
,"7":"Alors, au milieu des peuple nombreux, le reste de Jacob sera comme un lion parmi les bêtes de la forêt, comme un jeune lion dans un troupeau de moutons: chaque fois qu'il passe, il piétine, il déchire, et nul ne lui arrache sa proie."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Ecoutez donc ce que dit Yahvé: 'Fais donc leur procès en présence des montagnes, et que les collines entendent ta voix.'"
,"2":"Montagnes, écoutez le procès de Yahvé, et vous, fondations de la terre, prêtez l'oreille, car Yahvé fait le procès de son peuple, il plaide contre Israël:"
,"3":"'Que t'ai-je fait, ô mon peuple, en quoi t'ai-je fatigué? Réponds-moi."
,"4":"Je t'ai fait sortir du pays d'Egypte, je t'ai racheté de la maison de l'esclavage, devant toi j'ai envoyé Moïse, Aaron et Miryam."
,"5":"Rappelle-toi, ô mon peuple, quel était le projet de Balak, roi de Moab et ce que lui a répondu Balaam, fils de Béor. A Chittim comme à Guilgal, tu as vu les oeuvres justes de Yahvé.'"
,"6":"- 'Avec quoi me présenterai-je devant Yahvé? Avec quoi irai-je me prosterner devant le Dieu Très Haut? Faudra-t-il que je vienne avec des holocaustes, avec des veaux d'un an?"
,"7":"Prendra-t-il plaisir à des milliers de béliers, veut-il que je lui offre des torrents d'huile? Faudra-t-il que j'offre mon fils aîné pour payer mon péché, donner celui qui est né de moi pour expier ma propre faute?"
,"8":"- 'On t'a fait savoir, homme, ce qui est bien, ce que Yahvé attend de toi; rien d'autre que ceci: accomplir la justice, aimer la bonté et marcher humblement avec ton Dieu.'"
,"9":"La voix de Yahvé se fait entendre: 'Ecoutez tribus, écoute, assemblée de la ville."
,"10":"Je ne supporte pas une mesure fausse, une mesure diminuée; c'est inacceptable!"
,"11":"Je ne peux fermer les yeux devant des balances fausses, et des poids trafiqués;"
,"12":"dans votre ville les riches se livrent à la violence, les gens sont habitués à mentir."
,"13":"C'est pourquoi, moi aussi, j'ai commencé à te frapper, à te détruire pour tes péchés."
,"14":"Tu mangeras mais tu auras encore faim, tu mettras de côté mais tu ne garderas rien, et si tu peux garder quelque chose, je le livrerai à l'épée."
,"15":"Tu sèmeras mais tu ne moissonneras pas, tu presseras les olives, mais l'huile ne sera pas pour ta toilette, tu presseras ton raisin, mais tu n'en boiras pas le vin."
,"16":"On observe les lois d'Omri et l'on imite tout ce que fait la maison d'Akab, mais si vous marchez d'après leur exemple, je vous livrerai à la ruine. Tous les peuples pourront se moquer de vous et vous mépriser'."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Malheur à moi, je suis comme un moissonneur à la fin de l'été, comme un vendangeur à la fin de la vendange: plus une grappe à manger, plus un fruit pour me rassasier."
,"2":"Les croyants ont disparu du pays, plus un juste parmi les habitants. Tous sont prêts à la violence, chacun jette son filet sur son frère."
,"3":"On ne manque pas de bras pour faire le mal, le chef est exigeant, le juge se laisse acheter et le puissant décide comme il lui convient."
,"4":"Leur bonté n'est que chardons, leur justice est pire qu'un buisson d'épines. Mais malheur! Voici venir le jugement avec leur châtiment: ils sont plongés dans la confusion"
,"5":"Méfiez-vous de votre compagnon, ne faites pas confiance à un ami; méfie-toi de celle qui partage ta couche, prends garde à ce que tu dis."
,"6":"Voici que le fils méprise son père, la fille se dresse contre sa mère et la belle-fille contre sa belle-mère; chacun a ses ennemis dans sa propre maison."
,"7":"Mais moi, j'attends Yahvé, j'espère dans le Dieu qui me sauve, mon Dieu m'écoutera!"
,"8":"O mon ennemie, ne te réjouis pas de mes maux, car si je suis tombée, je me relèverai; si j'habite dans les ténèbres, Yahvé sera ma lumière."
,"9":"Il me faut souffrir la colère de Yahvé, car j'ai péché contre lui, jusqu'au jour où il prendra ma cause en main et me fera justice. Il me fera sortir vers la lumière et je verrai sa justice."
,"10":"Mon ennemie en le voyant sera couverte de honte; elle ne cessait de dire: 'Où est ton Dieu?' Ce sera mon plaisir de la voir piétinée comme la boue des rues."
,"11":"Le jour vient où l'on relèvera tes remparts, où tes frontières seront repoussées."
,"12":"On viendra vers toi ce jour-là, de l'Assyrie comme de l'Egypte, de Tyr comme du Fleuve, de l'une et l'autre mer, de l'une à l'autre montagne."
,"13":"La terre deviendra un désert à cause de ses habitants: ce sera le fruit de leurs méfaits."
,"14":"Yahvé, fais paître ton peuple, le troupeau de ton héritage encore égaré dans les broussailles au milieu des vergers; fais-le paître en Bashan et en Galaad comme aux jours d'autrefois."
,"15":"Comme aux jours où tu sortis du pays d'Egypte, fais-nous voir tes merveilles!"
,"16":"Les nations le verront et seront confondues, pour puissantes qu'elles soient; elles mettront la main sur leur bouche, elles seront abasourdies."
,"17":"Comme le serpent, elles lècheront la poussière, comme les bêtes qui rampent sur la terre; elles sortiront tremblantes de leurs repaires, pleines de crainte et de respect devant toi."
,"18":"Y a-t-il un Dieu comme toi qui enlève la faute, qui pardonne le crime et ne laisse pas pour toujours s'enflammer sa colère, un Dieu qui prenne plaisir à faire miséricorde?"
,"19":"Une fois de plus, aie pitié de nous, piétine nos fautes, jette tous nos péchés au fond de la mer."
,"20":"Fais honneur à ta fidélité envers Jacob, à ta bonté envers Abraham, comme tu l'as juré à nos pères depuis les jours d'autrefois."
}`)

}
func FR_LBDCC_LoadVNMLChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Avertissement. Parole de Yahvé adressée à Israël par la voix de Malachie."
,"2":"'Je vous ai aimés', dit Yahvé. Mais vous allez dire: 'En quoi nous as-tu montré cet amour?' - 'Esaü était bien le frère de Jacob, dit Yahvé. Or j'ai aimé Jacob"
,"3":"et j'ai rejeté Esaü; j'ai fait de ses montagnes une solitude et livré son héritage aux chacals du désert.'"
,"4":"Edom a beau dire: Nous avons été détruits mais nous reconstruirons nos ruines; voici ce que dit Yahvé Sabaot: Qu'ils reconstruisent, mais moi, je démolirai. On les appellera: 'Terre des méchants', et: 'Peuple contre qui Yahvé est en colère pour toujours'."
,"5":"Quand vous le verrez de vos yeux, vous direz: 'Yahvé est grand, bien au-delà de la terre d'Israël.'"
,"6":"Un fils respecte son père, un serviteur craint son maître. Eh bien, si je suis père, où est le respect qui m'est dû? Si je suis maître, où donc est votre crainte? Voilà ce que Yahvé Sabaot vous dit à vous, prêtres qui méprisez mon Nom. Mais vous allez dire: 'En quoi avons-nous méprisé ton Nom?"
,"7":"- 'Regardez, vous offrez sur mon autel des aliments impurs.' Vous allez répliquer: 'En quoi t'avons-nous souillé?' Vous dites: 'La table de Yahvé n'a rien d'important.'"
,"8":"'Lorsque vous présentez une bête aveugle pour le sacrifice, n'est-ce pas une faute? Lorsque vous présentez une bête boiteuse ou malade, n'est-ce pas une faute? Va donc l'offrir à ton gouverneur et tu verras s'il est content et comment il te recevra!' - parole de Yahvé Sabaot."
,"9":"Voilà comment vous demandez à Dieu ses faveurs. Mais vous écoutera-t-il après cela? - dit Yahvé Sabaot."
,"10":"Qui aura la bonne idée de fermer mes portes pour que vous cessiez d'offrir pour rien des sacrifices?,Car vous ne me plaisez pas, dit Yahvé Sabaot, et les offrandes qui m'arrivent par vos mains ne m'intéressent guère. "
,"11":"Depuis l'orient jusqu'en occident, mon Nom est craint et vénéré parmi les nations; en tous lieux on offre à mon Nom la fumée de l'encens et l'offrande pure, car mon Nom est grand parmi les nations, dit Yahvé Sabaot."
,"12":"Mais vous, vous le profanez quand vous dites: 'La table du Seigneur est peu appétissante, et la nourriture qu'on y place n'est pas fameuse.' Vous me faites injure quand vous dites: 'Quelle corvée!'"
,"13":"Pour les sacrifices vous me présentez des bêtes volées, boiteuses ou malades. Croyez-vous que je les accepterai de votre main, dit Yahvé?"
,"14":"Maudit soit le tricheur qui a dans son troupeau une bête mâle, et qui pour accomplir son voeu sacrifie au Seigneur une bête malade. Je suis un grand Roi, dit Yahvé Sabaot, et mon Nom est redouté parmi les nations."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Ecoutez maintenant cet avertissement, vous les prêtres."
,"2":"Si vous n'écoutez pas et ne prenez pas à coeur de rendre gloire à mon Nom - parole de Yahvé Sabaot, j'enverrai contre vous la malédiction, et je maudirai vos bénédictions. Je les ai déjà maudites car vous ne prenez rien à coeur."
,"3":"Je vais vous briser les bras et vous jeter à la figure ce que je ramasserai derrière les bêtes que vous m'offrez; et je vous balayerai avec elles."
,"4":"Vous saurez alors que c'est moi qui vous ai adressé cet avertissement pour que l'alliance des Lévites subsiste devant moi, parole de Yahvé Sabaot."
,"5":"J'avais fait une alliance avec Lévi, je lui donnais vie et prospérité; il me respectait, il avait la crainte de mon Nom."
,"6":"La loi de vérité était dans sa bouche, il n'y avait point de mensonge sur ses lèvres; il marchait devant moi dans la paix et la justice et détournait du mal un grand nombre d'hommes."
,"7":"Car ce sont les lèvres du prêtre qui gardent la connaissance et l'on attend de sa bouche la doctrine, car il est l'ange de Yahvé Sabaot."
,"8":"Mais vous, vous êtes détournés de ce chemin et vous en avez fait trébucher un grand nombre; avec vous l'alliance de Lévi s'est corrompue - parole de Yahvé Sabaot."
,"9":"C'est pourquoi je vous ai livrés au mépris; tout le peuple vous a tourné le dos parce que vous n'avez pas gardé mes voies, parce que dans votre enseignement vous avez agi à la tête du client."
,"10":"Pourtant nous avons tous un père unique, c'est un seul Dieu qui nous a créés; pourquoi sommes-nous malhonnêtes les uns envers les autres? Pourquoi avons-nous violé l'alliance de nos pères?"
,"11":"Juda s'est comporté en traître, on a fait à Jérusalem des choses honteuses: Juda a profané le Temple si cher à Yahvé; il a épousé la fille d'un dieu étranger."
,"12":"L'homme qui fait cela sera maudit; Yahvé l'éliminera des demeures de Jacob et de ceux qui présentent l'offrande à Yahvé Sabaot."
,"13":"Voici une seconde chose que vous faites. Vous pleurez sur l'autel de Yahvé, vous poussez des cris et des lamentations parce que Yahvé refuse de regarder votre offrande et de la recevoir de vos mains."
,"14":"Vous dites: 'Pourquoi?',Tout simplement parce que Yahvé te donne tort vis-à-vis de la femme de ta jeunesse; elle était ta compagne, la femme de ton alliance, et tu l'as trompée. "
,"15":"Dieu n'a-t-il pas fait un seul être qui a chair et souffle de vie? Et que cherche cet être unique? Une descendance donnée par Dieu. Ne trompe donc pas la femme de ta jeunesse."
,"16":"Car je déteste le divorce, dit Yahvé, Dieu d'Israël, et ceux qui affichent tranquillement leur méfait - parole de Yahvé Sabaot. Veille sur ton esprit, et ne commets pas cette trahison."
,"17":"Yahvé est fatigué de vous entendre. Vous dites: 'Quand l'avons-nous fatigué?' Quand vous avez dit: 'Yahvé traite bien tous les mauvais, il doit aimer ces gens-là.' Vous dites encore: 'Où est la justice de Dieu?'"
}`)
	CurrentBook.AddChapter(3, `{
"1":"Voici que j'envoie mon messager pour aplanir le chemin devant moi; et soudain le Seigneur que vous cherchez entrera dans son Temple. Voici venir l'ange de l'alliance, dit Yahvé Sabaot;"
,"2":"qui résistera au jour de sa venue, qui restera debout quand il apparaîtra? Car il sera comme le feu du fondeur, comme le détergent du blanchisseur."
,"3":"Il s'installera pour purifier les fils de Lévi et les passer au feu comme on fait pour l'argent; comme l'or et l'argent ils redeviendront vrais, et dignes d'offrir à Yahvé l'offrande qui lui est due."
,"4":"Alors Yahvé acceptera l'offrande de Juda et de Jérusalem comme aux jours d'autrefois, comme dans les premiers temps."
,"5":"Quand je viendrai pour vous juger, je commencerai par accuser les devins, les adultères et les menteurs, ceux qui oppriment l'ouvrier, la veuve et l'orphelin, et qui violent le droit de l'étranger sans davantage se soucier pour moi - parole de Yahvé Sabaot."
,"6":"Moi Yahvé je n'ai pas changé, mais vous, fils de Jacob, vous n'arrêtez pas!"
,"7":"Depuis le temps de vos pères vous vous écartez de mes commandements, vous ne les observez pas; revenez à moi et je reviendrai à vous -: parole de Yahvé Sabaot. Vous allez dire: 'Revenir, mais à quel sujet?'"
,"8":"- 'Un homme peut-il tromper Dieu? Et vous voulez me tromper. Vous dites: 'En quoi t'avons-nous trompé?'- 'A propos de la dîme et des impôts.'"
,"9":"Vous tous, tout le peuple, vous me trompez; c'est pourquoi la malédiction vient sur vous."
,"10":"Apportez toute la dîme au trésor, qu'il y ait de la nourriture dans mon Temple. Alors mettez-moi à l'épreuve - dit Yahvé Sabaot, et vous verrez si je n'ouvre pas pour vous les réservoirs du ciel, si je ne vous couvre pas de bénédictions."
,"11":"Je donnerai un avertissement aux insectes pour qu'ils cessent de détruire les fruits de la terre, et la vigne ne se desséchera plus dans la campagne - parole de Yahvé Sabaot."
,"12":"Alors toutes les nations vous envieront, car votre pays sera un paradis, dit Yahvé Sabaot."
,"13":"Vous avez des paroles dures contre moi, dit Yahvé. Vous allez dire: 'Qu'avons-nous dit de toi?' Vous dites:"
,"14":"'Il est inutile de servir Dieu. Qu'avons-nous gagné à obéir à ses lois et à faire pénitence devant Yahvé Sabaot?"
,"15":"Maintenant nous envions les gens sans religion; ceux qui font le mal réussissent, ils provoquent Dieu et ils s'en tirent bien.'"
,"16":"Voilà comment parlaient entre eux ceux qui craignent Yahvé. Mais Yahvé a entendu et il en a tenu compte. Devant lui, on a écrit un livre, un aide-mémoire en faveur de ceux qui craignent Yahvé et qui respectent son nom."
,"17":"Au jour que je prépare, dit Yahvé Sabaot, ils seront miens d'une façon spéciale. Je les récompenserai, comme un homme fait pour son fils qui le sert bien."
,"18":"Alors vous verrez la différence entre le juste et le méchant, entre celui qui sert Dieu et celui qui le rejette."
,"19":"Car voici que vient le jour du feu qui les brûlera comme un four; tous ces injustes et malhonnêtes seront comme paille dans les flammes du jour qui vient - parole de Yahvé Sabaot - à tel point qu'il ne leur restera ni racines, ni branches."
,"20":"Mais pour vous qui craignez mon Nom, le soleil de justice brillera, ses rayons vous rendront la santé; vous vous élancerez, vous bondirez comme des veaux au pâturage."
,"21":"Au jour que je prépare, vous piétinerez les méchants et ils seront comme cendre sous la plante de vos pieds - parole de Yahvé Sabaot."
,"22":"Souvenez-vous de la loi de Moïse, mon serviteur; à l'Horeb je lui ai donné pour tout Israël mes lois et mes décisions."
,"23":"Maintenant je vous envoie Elie le Prophète, juste avant que vienne le jour de Yahvé, jour grand et redoutable."
,"24":"Il réconciliera les pères avec leurs fils et les fils avec leurs pères, de sorte que, lors de ma venue, je n'aie pas à maudire la terre."
}`)

}
func FR_LBDCC_LoadVNNHChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Paroles contre Ninive. Voici le livre de la vision de Nahum d'Elkoch."
,"2":"Yahvé est un Dieu jaloux et vengeur; Yahvé se venge, sa colère est terrible. Yahvé se venge de ses adversaires, il n'oublie pas ses ennemis."
,"3":"Lent à la colère, Yahvé! Mais sa puissance est redoutable; Yahvé ne laissera rien passer. Il s'avance dans l'ouragan, dans la tempête; la nuée n'est que la poussière sous ses pas."
,"4":"Il menace la mer et la dessèche, il met à sec les cours d'eau; le Bashan et le Carmel perdent leur feuillage et la fleur du Liban se fane."
,"5":"Il ébranle les montagnes et les collines disparaissent; la terre se soulève devant lui, le monde et tous ceux qui l'habitent."
,"6":"Qui peut tenir devant sa fureur, qui résistera si sa colère s'enflamme?,Sa colère est un feu galopant, devant lui les roches se fendent."
,"7":"Yahvé est un trésor, une forteresse au jour du malheur. Il connaît bien ceux qui espèrent en lui, "
,"8":"il les fait traverser lorsque les eaux débordent. Il extermine ceux qui le défient, il poursuit ses ennemis jusque dans les ténèbres."
,"9":"Quel projet préparez-vous contre Yahvé?,Il est fort pour exterminer: l'invasion du mal ne se répétera pas."
,"10":"Ils seront dévorés comme un fourré d'épines, consumés comme la paille sèche."
,"11":"Yahvé enlèvera de Juda son ennemi, celui qui fait de méchants projets."
,"12":"Voici ce que dit Yahvé: 'Si forts et si nombreux soient-ils, ils seront arrachés et disparaîtront. Oui, Juda, si je t'ai humilié, je ne recommencerai plus;"
,"13":"Je vais briser de dessus toi le joug de Ninive, je te délivrerai de tes liens.'"
,"14":"Voici ce que Yahvé a décidé pour lui: 'Plus personne après lui pour porter son nom! J'ôterai les statues du temple de ses dieux, les idoles de métal fondu; je ferai de sa tombe un lieu maudit.'"
}`)
	CurrentBook.AddChapter(2, `{
"1":"Voyez déjà sur les montagnes les pieds du messager, de celui qui nous annonce la paix. Juda, célèbre tes fêtes, accomplis tes voeux, car le brigand ne passera plus chez toi; il a été anéanti."
,"3":"Yahvé ramène la gloire de Jacob, la gloire d'Israël; des ravageurs l'avaient ravagé, ils en avaient détruit les rejetons."
,"2":"Monte la garde sur tes remparts, veille sur tes chemins, prends courage et rassemble tes forces, car le Destructeur monte contre toi."
,"4":"Ses soldats portent le bouclier rouge, ses guerriers sont habillés de pourpre, ses chars en rangs serrés scintillent comme des torches, ses hommes ont le casque sur la tête."
,"5":"Ils s'élancent à travers les rues et bondissent sur les places comme des torches enflammées, comme des éclairs de feu."
,"6":"Contre eux on fait appel aux plus vaillants, mais c'est un échec; ils s'élancent vers la muraille et mettent en place le bouclier."
,"7":"Bientôt les portes sont enfoncées, se brisent, et dans le palais c'est la déroute."
,"8":"On fait sortir la déesse, leur reine, on l'emmène captive; ses servantes sont en larmes, elles gémissent comme des colombes et se frappent les seins."
,"9":"Ninive est comme un bassin dont les eaux s'échappent; on crie: 'Arrêtez! Arrêtez!' Mais pas un ne se retourne."
,"10":"On entend des cris: 'Pillez l'argent, pillez l'or!' Ses richesses ne se pouvaient compter, quelle abondance de tout ce qu'on peut désirer!"
,"11":"Pillage, ravage, carnage! Les habitants sont dans l'épouvante, leurs genoux tremblent, les plus courageux sont désemparés, et tous sont blancs de peur."
,"12":"Qu'est devenu le repaire des lions, la caverne des lionceaux? N'est-ce pas là que le lion conduisait ses petits et nul ne les inquiétait?"
,"13":"Le lion mettait en pièces pour nourrir ses petits, il déchirait pour ses lionnes; il remplissait de ses proies ses repaires, et ses cavernes, de ce qu'il avait chassé."
,"14":"Mais voici que je viens vers toi - parole de Yahvé Sabaot. Tes chars partiront en fumée, l'épée dévorera tes lionceaux; la terre ne verra plus tes chasses et l'on n'entendra plus la voix de tes hommes."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Malheur à la ville sanguinaire, qui n'était que mensonge; elle est pleine de butin car elle n'a pas cessé de piller."
,"2":"Claquements de fouets, fracas de roues, chevaux qui galopent et chars qui bondissent!"
,"3":"Charges de cavaliers, flamboiement d'épées, éclairs à la pointe des lances; partout des hommes blessés à mort, des victimes sans nombre. Quel carnage! on trébuche sur les cadavres."
,"4":"Ainsi finissent tes nombreuses prostitutions, prostituée pleine de charme, parfaite ensorceleuse! Quelle nation ne s'est pas vendue pour ses prostitutions, quel peuple, pour ses sortilèges?"
,"5":"Me voici, j'arrive - parole de Yahvé Sabaot. Je relèverai sur ta tête les pans de ta robe, je découvrirai ta nudité devant les nations et les peuples verront ta honte."
,"6":"Je te couvrirai d'ordures, je t'abaisserai et je te livrerai en spectacle."
,"7":"Quiconque te verra tournera la tête: 'Ninive, quelle dévastation!',Qui la plaindra, où lui trouverai-je un consolateur?"
,"8":"Vaux-tu mieux que No-Ammon, assise au bord du Nil, entourée d'eau de tous côtés, protégée par la mer dont les flots lui faisaient un rempart?"
,"9":"L'Ethiopie et l'Egypte étaient sa force, Pout et la Libye venaient à son aide."
,"10":"Elle aussi a connu la captivité; ses petits enfants ont été écrasés aux carrefours des rues, on a jeté le sort sur ses nobles et ses chefs ont été chargés de chaînes."
,"11":"A ton tour maintenant de tituber comme un homme ivre, à ton tour de chercher refuge devant l'ennemi."
,"12":"Tes forteresses sont comme des figuiers porteurs de figues précoces; on les secoue et elles tombent dans la bouche de celui qui les mange."
,"13":"Regarde ton peuple, ce ne sont plus que des femmes; les portes de ton pays sont grandes ouvertes pour tes ennemis, le feu a dévoré tes verrous."
,"14":"Cherche de l'eau pour soutenir le siège, répare tes fortifications, prépare les moules, piétine la glaise et fabrique des briques;"
,"15":"tu peux bien être nombreux comme le criquet, nombreux comme la sauterelle, le feu te dévorera et l'épée t'exterminera."
,"16":"Tes marchands étaient plus nombreux que les étoiles du ciel, tes chefs et tes scribes étaient comme un essaim de sauterelles qui campe sur les haies un jour de froid;"
,"17":"mais le soleil se lève, le criquet déploie ses ailes et s'envole, il s'enfuit et personne ne sait où."
,"18":"Vois, roi d'Assyrie, tes bergers et tes nobles se sont endormis, ton peuple est dispersé sur les montagnes; il n'y a plus personne pour le rassembler."
,"19":"Il n'y a pas de remède à ta blessure, pas de guérison pour ta plaie; tous ceux qui entendent parler de toi applaudissent des deux mains; qui n'a pas souffert, constamment, de ta méchanceté?"
}`)

}
func FR_LBDCC_LoadVNOSChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Parole de Yahvé qui fut adressée à Osée, fils de Beéri, au temps d'Ozias, de Yotam, d'Akaz et d'Ezéquias, rois de Juda, et durant le règne de Jéroboam, fils de Joas, roi d'Israël."
,"2":"Lorsque Yahvé commença de parler par l'intermédiaire d'Osée, il lui dit: 'Va, prends une femme qui se prostitue et qu'elle te donne des enfants nés de la prostitution, car le pays ne fait que se prostituer en se détournant de Yahvé.'"
,"3":"Il alla donc prendre Gomer, fille de Diblayim. Elle conçut et lui enfanta un fils."
,"4":"Yahvé lui dit: 'Appelle-le Yizréel, car encore un peu de temps et je punirai la maison de Jéhu, à cause du sang versé à Yizréel; je mettrai fin à la royauté de la maison d'Israël."
,"5":"En ce jour-là, je briserai l'arc d'Israël dans la vallée d'Yizréel.'"
,"6":"Elle conçut encore et enfanta une fille; Yahvé dit à Osée: 'Appelle-la Lo-Rouhamah, car désormais je n'aurai plus pitié de la maison d'Israël; je ne lui pardonnerai plus."
,"7":"Mais j'aurai pitié de la maison de Juda et je les délivrerai par Yahvé leur Dieu; pour les sauver je n'aurai pas besoin de l'arc, ni de l'épée, ni de la guerre, ni des chevaux, ni des cavaliers.'"
,"8":"Elle sevra Lo-Rouhamah. Elle conçut encore et enfanta un fils."
,"9":"Yahvé dit: 'Appelle-le Lo-Ammi, car vous n'êtes plus mon peuple et moi, pour vous, Je ne Suis plus.'"
}`)
	CurrentBook.AddChapter(2, `{
"1":"Les Israélites seront nombreux comme le sable de la mer qu'on ne peut ni mesurer ni compter; au lieu de leur dire: 'Vous n'êtes pas mon peuple', on les appellera: 'Fils du Dieu vivant.'"
,"2":"Les fils de Juda et les fils d'Israël se réuniront, ils se donneront un chef unique, ils déborderont hors du pays, car le jour d'Yizréel sera grand."
,"3":"Vous direz à vos frères: 'Mon peuple' et vous appellerez vos soeurs: 'Celles dont on a pitié.'"
,"4":"Accusez votre mère, accusez-la, car elle n'est plus ma femme et je ne suis plus son mari. Qu'elle écarte de devant elle ses prostitutions,et d'entre ses seins ses adultères."
,"5":"Sinon je la dévêtirai et la laisserai nue, sans rien, comme au jour de sa naissance; je la rendrai semblable au désert, j'en ferai une terre aride: elle mourra de soif."
,"6":"Je n'aurai aucune pitié pour ses fils, car ce sont des enfants de prostitution."
,"7":"Oui, leur mère s'est prostituée, celle qui les a conçus s'est couverte de honte. Elle a dit: 'Je veux aller avec mes amants,qui me donnent mon pain et mon eau, ma laine et mon lin, mon huile et ma boisson.'"
,"10":"Elle n'a pas reconnu que je lui donnais, moi, le blé, le vin nouveau et l'huile fraîche. C'est moi qui lui donnais en abondance,l'argent et l'or dont elle a fait le Baal."
,"11":"Aussi vais-je reprendre mon blé en son temps, et mon vin nouveau en sa saison. Je lui retirerai ma laine et mon lin, tout ce qui couvrait sa nudité."
,"12":"Je vais dévoiler sa honte aux yeux de ses amants,et de ma main nul ne la délivrera."
,"13":"Je mettrai fin à ses réjouissances: ses fêtes et ses nouvelles lunes, ses sabbats et toutes ses solennités."
,"14":"Elle disait de sa vigne et de son figuier: 'C'est le salaire que m'ont donné mes amants'; mais moi je les dévasterai, j'en ferai une forêt,et la bête des champs les dévorera."
,"15":"Je lui demanderai compte de cette ère des Baals, où elle n'a fait que brûler pour eux l'encens, où elle mettait ses bijoux, son collier,pour aller retrouver ses amants, et moi, elle m'oubliait - parole de Yahvé."
,"8":"Aussi vais-je fermer son chemin avec des ronces, l'entourer d'une clôture: elle ne trouvera plus ses sentiers."
,"9":"Elle poursuivra ses amants sans les atteindre, elle les recherchera et ne les trouvera plus. Alors elle dira: 'Il me faut partir,et retourner vers mon premier mari, n'étais-je pas plus heureuse alors qu'aujourd'hui?'"
,"16":"C'est pourquoi maintenant je vais la séduire; je la conduirai au désert et je parlerai à son coeur."
,"17":"Je lui rendrai ses vignes, je changerai la vallée d'Akor en porte d'espérance; alors elle me répondra comme aux jours de sa jeunesse, comme au temps où elle montait du pays d'Egypte."
,"18":"Ce jour-là, parole de Yahvé, tu diras: 'Mon mari', tu ne m'appelleras plus: 'Mon Baal.'"
,"19":"J'enlèverai de sa bouche les noms des Baals, on ne prononcera plus leurs noms."
,"20":"Je passerai un accord en ce jour-là,avec les bêtes des champs, avec l'oiseau du ciel et le reptile de la terre. Je briserai l'arc, l'épée et la guerre, on ne les verra plus dans le pays; je ferai qu'on y vive en paix."
,"21":"Tu seras ma fiancée pour toujours, ce seront des fiançailles de justice, de droiture, dans la tendresse et la miséricorde."
,"22":"Je te fiancerai à moi dans la fidélité,et tu sauras qui est Yahvé."
,"23":"En ce jour-là, parole de Yahvé, je répondrai aux cieux,et eux répondront à la terre."
,"24":"La terre répondra au blé, au vin nouveau, à l'huile fraîche, et eux répondront à Yizréel."
,"25":"Je sèmerai pour moi dans le pays; j'aurai pitié de Lo-Rouhamah; je dirai à Lo-Ammi: 'Tu es mon peuple', et lui dira: 'Tu es mon Dieu.'"
}`)
	CurrentBook.AddChapter(3, `{
"1":"Yahvé me dit: 'Retourne et aime une femme qui est adultère et qui fait l'amour avec d'autres; tout comme Yahvé aime les Israélites bien qu'ils soient attachés à d'autres dieux et leur offrent des gâteaux de raisins.'"
,"2":"Alors je l'ai rachetée pour quinze sicles d'argent et une mesure et demie d'orge"
,"3":"et je lui ai dit: 'Pendant de nombreux jours tu resteras ici, tu ne te prostitueras plus et tu ne te donneras à aucun homme, et moi aussi je resterai à l'écart.'"
,"4":"Car durant de nombreux jours les Israélites resteront sans roi ni chef, sans sacrifice et sans pierre dressée, sans éphod et sans petites idoles."
,"5":"Après quoi, les Israélites reviendront. Ils chercheront de nouveau Yahvé leur Dieu et David leur roi. Ils reviendront en tremblant vers Yahvé, espérant sa bonté, à la fin des jours."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Ecoutez la parole de Yahvé, fils d'Israël, car Yahvé est en procès avec les habitants du pays: il n'y a ni fidélité, ni bonté, ni connaissance de Dieu dans le pays."
,"2":"On se parjure, on ment, on assassine et on vole, on commet l'adultère et on se livre à la violence; partout c'est le sang versé."
,"3":"Voilà pourquoi le pays est en deuil et tous ses habitants sont malades, jusqu'aux bêtes des champs et aux oiseaux du ciel, même les poissons de la mer disparaissent."
,"4":"Cependant, que personne ne se plaigne, que personne ne fasse de reproches, car c'est après toi, prêtre, que j'en ai."
,"5":"Tu trébucheras en plein jour, le prophète aussi trébuchera avec toi dans la nuit, et je réduirai au silence tes oracles."
,"6":"Mon peuple dépérit par faute de connaissance. Puisque tu as laissé se perdre la connaissance, je te ferai perdre mon sacerdoce; si toi tu as oublié l'enseignement de ton Dieu, moi j'oublierai tes fils."
,"7":"Tous, ils ont péché contre moi, ils ont échangé leur gloire contre la honte."
,"8":"Ils se nourrissent des sacrifices pour le péché de mon peuple: certainement ce péché ne leur déplaît pas."
,"9":"Il en ira du prêtre comme du peuple, je le corrigerai pour sa conduite et lui ferai payer ce qu'il a fait."
,"10":"Ils mangeront mais ils auront encore faim, ils se prostitueront mais ils n'y gagneront rien, car ils ont cessé d'obéir à Yahvé."
,"11":"La prostitution, le vin et l'alcool leur ont fait perdre la tête."
,"12":"Mon peuple consulte un poteau de bois; c'est son bâton qui lui donne des conseils. Un esprit de prostitution les égare, ils se conduisent en adultères avec leur Dieu."
,"13":"Ils offrent des sacrifices sur le sommet des montagnes et font fumer l'encens sur les collines, sous un chêne, un peuplier ou un térébinthe, car leur ombrage est bon. C'est pourquoi, si vos filles se prostituent, si vos belle-filles commettent l'adultère, "
,"14":"je ne punirai pas vos filles pour leurs prostitutions ou vos belle-filles pour leurs adultères, car vous-mêmes allez à l'écart avec les prostituées, vous offrez des sacrifices avec les prostitués sacrés. Ce peuple sans intelligence court à sa perte."
,"15":"Si toi, Israël, tu te prostitues, ce n'est pas une raison pour que Juda se rende coupable. N'allez pas à Guilgal, ne montez pas à Beth-Aven, ne jurez pas 'Par la vie de Yahvé'.)"
,"16":"Israël est pire qu'une vache obstinée: voudrait-on que Yahvé le fasse paître comme un agneau dans un pâturage?"
,"17":"Ephraïm est le complice des idoles, laissez-le!"
,"18":"A peine ont-ils fini de boire qu'ils se prostituent, ils préfèrent à leur Gloire la honteuse idole."
,"19":"Le vent l'emportera sur ses ailes et ils n'auront rien gagné avec leurs sacrifices."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Ecoutez ceci, prêtres; sois attentive, maison d'Israël, et toi maison du roi, prête l'oreille, car cette sentence vous concerne: Vous avez été un piège à Mispa et un filet tendu sur le Tabor. "
,"2":"Ce sont eux qui ont creusé la fosse de Chittim, et je vais tous les corriger."
,"3":"Je connais Ephraïm, et Israël ne m'est pas inconnu. Oui, tu t'es prostitué Ephraïm, et toi Israël, tu t'es souillé."
,"4":"Leurs fautes sont telles qu'ils ne peuvent revenir vers leur Dieu. Un esprit de prostitution les possède et ils ne connaissent pas Yahvé."
,"5":"L'orgueil d'Israël témoigne contre lui, Israël et Ephraïm sont en crise à cause de leur péché, et Juda est en crise avec eux."
,"6":"Ils iront chercher Yahvé avec leurs brebis et leurs boeufs, mais ils ne le trouveront pas, car il s'est retiré d'eux."
,"7":"Ils ont trahi Yahvé, ils ont enfanté des bâtards: le destructeur peut les dévorer, eux et leurs champs."
,"8":"Sonnez du cor à Guibéa et de la trompette à Rama, donnez l'alerte à Beth-Aven. On est sur tes pas, Benjamin!"
,"9":"Ephraïm connaîtra une ruine au jour de son châtiment, et je fais savoir aux tribus d'Israël que la décision est prise."
,"10":"Les chefs de Juda sont comme ceux qui déplacent les bornes, je déverserai sur eux ma colère comme de l'eau."
,"11":"Ephraïm est un oppresseur, il dicte des sentences injustes, il trouve plaisir à courir après le mensonge."
,"12":"C'est pourquoi je veux être comme la mite pour Ephraïm, comme une carie dans la maison de Juda."
,"13":"Quand Ephraïm a vu sa maladie, et Juda son ulcère, Ephraïm est allé en Assyrie, il a envoyé des messagers vers le grand roi. Mais il ne sera pas capable de vous guérir, ni d'apporter un remède à votre ulcère."
,"14":"Oui, je serai comme un lion pour Ephraïm, comme un jeune lion pour la maison de Juda. Je déchirerai et je m'en irai, j'emporterai ma proie et personne ne délivrera."
,"15":"Je partirai et je rentrerai chez moi jusqu'à ce qu'ils reconnaissent leurs fautes et qu'ils cherchent ma face. Dans leur détresse ils me rechercheront:"
}`)
	CurrentBook.AddChapter(6, `{
"1":"'Venez, retournons vers Yahvé; s'il a déchiré, il nous guérira; s'il nous a frappés, il soignera nos plaies."
,"2":"Après deux jours, il nous fera revivre, au troisième jour il nous relèvera et nous vivrons devant lui."
,"3":"Connaissons-le, appliquons-nous à cette connaissance de Yahvé! Sa venue est certaine comme celle de l'aurore,"
,"5b":"son intervention, soudaine comme celle du jour. Il viendra à nous comme une pluie bienfaisante, comme la pluie de printemps qui arrose la terre."
,"4":"- 'Que te ferai-je, Ephraïm, que te ferai-je, Juda? Votre fidélité est comme la nuée du matin, comme la rosée qui se dissipe de bonne heure,"
,"5":"c'est pourquoi je les ai secoués par les prophètes, je les ai tués par les paroles de ma bouche;"
,"6":"car c'est l'amour sincère que je veux et non les sacrifices, la connaissance de Dieu plutôt que les holocaustes."
,"7":"Mais à Adam ils ont désobéi à l'Alliance, ils m'ont trahi."
,"8":"Galaad est une région de bandits qui porte des traces de sang."
,"9":"Comme des brigands en embuscade, une bande de prêtres assassine sur la route de Sichem: oui, ce qu'ils font est une honte."
,"10":"A Béthel j'ai vu une chose horrible: Ephraïm se prostitue, Israël se rend impur."
,"11":"(A toi aussi Juda, est destinée une moisson lorsque je ferai revenir mon peuple et guérirai Israël.)"
}`)
	CurrentBook.AddChapter(7, `{
"1":"La faute d'Ephraïm et les méchancetés de Samarie apparaissent au grand jour; ils pratiquent le mensonge; dans la maison entre le voleur, et au-dehors la bande fait des ravages."
,"2":"Ils ne pensent pas que je me souviens de leur méchanceté, ils sont prisonniers de leurs actes que j'ai devant mes yeux."
,"3":"Leur méchanceté fait la joie du roi, leurs mensonges amusent les chefs."
,"4":"Ce sont tous des adultères, ils sont comme un four brûlant que le boulanger ne cesse d'activer depuis l'instant où il a pétri la pâte jusqu'au moment où elle est levée."
,"5":"Au jour de notre roi, les chefs s'échauffent et s'enivrent, et lui, tend la main aux rieurs"
,"6":"quand ils s'approchent. Dans leurs complots, leur coeur est comme un four, toute la nuit leur colère sommeille, mais au matin elle brûle comme un feu dévorant. "
,"7":"Tous s'échauffent comme un four, ils dévorent leurs gouvernants. Tous leurs rois sont tombés ainsi, mais pas un d'entre eux n'a crié vers moi."
,"8":"Ephraïm va vivre en terre étrangère, Ephraïm est comme une galette qu'on n'a pas retournée."
,"9":"Des étrangers dévorent sa force, mais lui ne le sait pas; il a des cheveux blancs, et lui seul l'ignore."
,"10":"L'orgueil d'Israël témoigne contre lui: malgré tout cela ils ne reviennent pas vers Yahvé leur Dieu, ils ne le cherchent pas."
,"11":"Ephraïm est une colombe naïve, sans intelligence; ils appellent l'Egypte, ils courent en Assyrie,"
,"12":"mais où qu'ils aillent, je tendrai sur eux mon filet; comme l'oiseau du ciel je les ferai tomber, mon filet les prendra pour leur malheur."
,"13":"Malheur à eux, car ils se sont retirés loin de moi! Que le mal les emporte car ils m'ont été infidèles! Dois-je les sauver alors qu'ils me mentent?"
,"14":"Ils se lamentent sur leurs lits mais ils ne m'appellent pas de tout leur coeur. Ils se font du souci à propos de leur blé et du vin nouveau, mais ils se révoltent contre moi."
,"15":"Je les ai instruits, je les ai rendus forts, et eux méditent le mal contre moi."
,"16":"Ils se tournent vers le mal, ils sont comme un arc qui se retourne. Leurs chefs vont tomber par l'épée à cause de leurs paroles méchantes, et l'on rira d'eux au pays d'Egypte."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Prépare-toi à sonner de la trompette! Le malheur s'abat comme l'aigle sur le peuple de Yahvé, car ils ont désobéi à mon alliance, ils ont été infidèles à ma Loi."
,"2":"Ils crient vers moi: 'Mon Dieu! Nous te connaissons, nous Israël!'"
,"3":"Mais Israël a rejeté le bien, c'est pourquoi l'ennemi le poursuivra."
,"4":"Ils ont établi des rois que je n'avais pas choisis; ils ont établi des chefs que je ne connaissais pas; ils ont fait des idoles avec leur argent et leur or, aussi leur argent et leur or leur seront enlevés."
,"5":"Samarie, tes veaux m'ont dégoûté et ma colère s'est enflammée contre eux. Combien de temps faudra-t-il pour vous en purifier, enfants d'Israël?"
,"6":"Ce veau n'est pas Dieu puisqu'un ouvrier l'a fabriqué: le veau de Samarie s'en ira au feu."
,"7":"Ils ont semé le vent, ils récolteront la tempête; ils sont comme un blé qui n'aura pas d'épi; s'il en a, il ne donnera pas de farine; s'il en donne, des étrangers la mangeront."
,"8":"Israël vivait à part, comme l'âne sauvage; il s'est fait dévorer. Ephraím est maintenant chez les paíens comme un objet sans valeur."
,"9":"Il se rendait en Assyrie pour offrir des cadeaux;"
,"10":"maintenant qu'il a été lui-même livré aux païens, c'est moi qui devrai le racheter. Car en quelques instants ils se sont retrouvés sans oracles, sans rois, sans chefs."
,"11":"Ephraïm a multiplié les autels: ils ne lui ont servi qu'à pécher."
,"12":"Si j'écris à son intention mille articles dans ma Loi, il les regarde comme une chose sans importance."
,"13":"Ils veulent offrir des sacrifices? Qu'ils les immolent et en mangent la viande, mais Yahvé n'y prend aucun plaisir; maintenant il se souvient de leurs fautes, il va punir leurs péchés, et ils retourneront en Egypte."
,"14":"Israël a oublié Celui qui l'avait fait, il s'est mis à construire des palais. Juda a multiplié ses forteresses; mais j'enverrai le feu dans ses villes pour dévorer ses forteresses."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Ne te réjouis pas Israël, ne laisse pas éclater ta joie comme les païens, car tu t'es prostitué loin de ton Dieu sur toutes les aires à battre le blé; tu as aimé le salaire de ta prostitution."
,"2":"Ni l'aire, ni la cuve ne les nourriront, et le vin nouveau leur manquera."
,"3":"Ils n'habiteront pas dans la terre de Yahvé; Ephraïm retournera en Egypte; en Assyrie ils mangeront des aliments impurs."
,"4":"Là-bas ils ne pourront plus présenter à Yahvé des libations de vin, ni chercher à lui plaire par des sacrifices. Ils n'auront que du pain de deuil qui rend impurs ceux qui en mangent. Leur pain restera chez eux, il n'entrera pas dans la maison de Yahvé."
,"5":"Que ferez-vous au jour de la solennité?"
,"6":"Pour la fête de Yahvé, ils partiront pour l'exil; l'Egypte les rassemblera et Memphis sera leur tombeau; l'ortie héritera de leurs objets précieux et les ronces envahiront leurs tentes."
,"7":"Le jour est arrivé où il faut rendre des comptes, les jours du châtiment sont là; Israël va l'apprendre. Les prophètes seront comme fous et l'homme inspiré perdra la tête, car ta défaite sera à la mesure de ton péché."
,"8":"Le prophète est une sentinelle pour Ephraïm; il est avec Dieu, mais on lui tend des pièges sur tous ses chemins, et dans la Maison de son Dieu il rencontre des adversaires."
,"9":"Ils sont complètement corrompus comme aux jours lointains de Guibéa. Dieu se souviendra de leur faute; il punira leurs péchés."
,"10":"J'ai trouvé Israël comme des raisins dans le désert, j'ai vu vos pères comme un fruit précoce sur un figuier; mais sitôt arrivés à Baal-Péor ils se sont vendus à Baal, ils sont devenus aussi méprisables que l'idole qu'ils aimaient."
,"11":"La gloire d'Ephraïm s'envolera comme l'oiseau; il n'y aura plus d'enfantement, même plus de grossesse, même plus de conception."
,"12":"Seront-ils capables d'élever des fils? Je les en priverai avant qu'ils ne soient devenus des hommes. Je les punirai et les abandonnerai."
,"13":"J'ai déjà vu qu'Ephraïm allait faire de ses fils un gibier; Ephraïm mènera ses fils à l'égorgeur."
,"14":"Donne-leur, Yahvé... Que leur donneras-tu? Un sein stérile et des mamelles sans lait!"
,"15":"Ils ont montré toute leur méchanceté à Guilgal; c'est là que je les ai pris en dégoût. Je les chasserai de ma maison pour tous leurs crimes. Je ne les aimerai plus car tous leurs chefs sont des rebelles."
,"16":"Ephraïm est atteint, sa racine se dessèche; il ne donnera plus de fruits. Même s'il leur naît des enfants, je ferai mourir ce fruit précieux de leur sein;"
,"17":"mon Dieu les repoussera parce qu'ils ne l'ont pas écouté, il les dispersera parmi les nations."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Israël était une vigne prospère, il donnait des fruits en abondance. Mais plus ses fruits étaient abondants, plus il multipliait les autels; à mesure que prospérait le pays, ses pierres dressées avaient plus de succès."
,"2":"Ils ne sont pas francs, et maintenant ils vont le payer; Yahvé renversera leurs autels et détruira leurs pierres dressées."
,"3":"Ils diront bientôt: 'Nous n'avons plus de roi parce que nous n'avons pas respecté Yahvé, mais, que pourrait faire pour nous le roi?'"
,"4":"Ils peuvent bien parler, faire de faux serments, conclure des alliances, leur condamnation est prête à fleurir, comme la mauvaise herbe sur les sillons des champs."
,"5":"Les habitants de Samarie tremblent pour le veau de Beth-Aven; le peuple et ses prêtres font le deuil sur lui, car leur gloire est déportée au loin."
,"6":"On l'emportera lui aussi en Assyrie, en offrande au roi vainqueur; Ephraïm sera couvert de confusion, Israël partagera la honte de son idole."
,"7":"Samarie sera détruite, son roi sera comme un fétu sur les eaux."
,"8":"Les hauts-lieux d'Aven, péché d'Israël, seront démolis; les épines et les ronces grimperont sur leurs autels. Alors ils diront aux montagnes: 'Couvrez-nous!' et aux collines: 'Tombez sur nous!'"
,"9":"Israël, tu as péché dès les jours de Guibéa. Et depuis il continue! De nouveau, à Guibéa, on fera la guerre aux méchants."
,"10":"Je viendrai les corriger; des peuples se rassembleront contre eux pour les punir de leur double faute."
,"11":"Ephraïm était comme la génisse bien dressée qui prend plaisir à fouler le blé. Mais voici que je mets sur son noble cou un joug. Je vais atteler Ephraïm; Jacob tirera la herse."
,"12":"Semez selon la justice, et faites une récolte de bonté. Défrichez pour vous des terres nouvelles, car il est temps de chercher Yahvé, jusqu'à ce qu'il vienne et répande sur vous la justice."
,"13":"Mais vous avez cultivé la méchanceté, vous avez moissonné l'injustice et mangé le fruit du mensonge. Tu as mis ta confiance dans tes chars et tes nombreux soldats;"
,"14":"mais voici de grands cris dans tes villes: toutes tes forteresses sont en ruines, comme au jour où Chalman attaqua et détruisit Beth-Arbel, et tout fut écrasé, la mère avec ses fils."
,"15":"Voilà comment je vais te traiter, Israël, pour tout le mal de vos actions mauvaises. Le roi d'Israël disparaîtra dans la tourmente."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Quand Israël était enfant je l'ai aimé, d'Egypte j'ai appelé mon fils."
,"2":"Mais plus je les appelais, plus ils se sont détournés; ils ont offert des sacrifices aux Baals, ils ont fait fumer l'encens devant les idoles."
,"3":"C'était moi, pourtant, qui apprenais à marcher à Ephraïm. Je les prenais dans mes bras, mais ils ne voyaient pas que je prenais soin d'eux."
,"4":"Je les menais avec des liens humains, avec des liens d'amour; j'étais pour eux comme celui qui soulève un nourrisson contre sa joue et lui donne à manger."
,"5":"Qu'ils retournent au pays d'Egypte! L'Assyrie régnera sur eux puisqu'ils ont refusé de revenir vers moi."
,"6":"L'épée se déchaînera dans ses villes et exterminera ses enfants; elle dévorera leurs forteresses."
,"7":"Mon peuple est malade de son infidélité; ce n'est pas Baal qui les relèvera s'ils font appel à lui."
,"8":"Comment pourrais-je t'abandonner, Ephraïm, ou te livrer, Israël? Puis-je te traiter comme Adma ou faire de toi ce que j'ai fait de Séboyim? Mon coeur se fond en moi, je suis ému au plus profond de moi-même."
,"9":"Non, je ne laisserai pas déborder ma colère, je ne détruirai pas de nouveau Ephraïm, car je suis Dieu et non pas homme; au milieu de toi je suis le Saint et je ne viendrai pas pour détruire."
,"10":"Ils se mettront à la suite de Yahvé. Il rugira comme un lion et, quand il rugira, ses fils viendront en tremblant de l'occident."
,"11":"Comme un oiseau frémissant ils reviendront d'Assyrie, ce sera un retour d'Egypte. Je ferai qu'ils habitent de nouveau dans leurs maisons - parole de Yahvé."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Ephraïm m'a entouré de mensonges, la maison d'Israël me trompe; il reste attaché au Baal et fidèle à ses divinités."
,"2":"Ephraïm se nourrit d'illusions, tout le jour il poursuit le vent d'est. Il multiplie mensonges et violences; il conclut une alliance avec l'Assyrie tout en flattant l'Egypte."
,"3":"Aussi Yahvé est-il en procès avec Israël; il va demander des comptes à Jacob pour sa conduite et le punir pour ses méfaits."
,"4":"Dès le sein maternel il est passé devant son frère et, à l'âge mûr il a lutté avec Dieu."
,"5":"Il a lutté avec l'ange et il a gagné; il l'implora et lui demanda grâce. Il le rencontra à Béthel et là Dieu lui a parlé."
,"6":"Yahvé, le Dieu Sabaot dont le nom est Yahvé."
,"7":"Et toi, reviens à ton Dieu, pratique l'amour et la justice, et espère en ton Dieu toujours.)"
,"8":"C'est un vrai Cananéen, qui tient une balance fausse et qui aime tricher."
,"9":"Ephraïm a beau dire: 'Je me suis enrichi, j'ai acquis un trésor', il ne gardera rien de tout ce qu'il a amassé, car il faisait le mal."
,"10":"Moi, Yahvé, qui suis ton Dieu depuis le pays d'Egypte, je te ferai retourner sous la tente comme au jour du Rendez-Vous."
,"11":"Je parlerai aux prophètes, je multiplierai les visions et je dirai des paraboles par la bouche des prophètes."
,"12":"A Galaad c'est le crime, mais eux ne sont que mensonge; à Guilgal ils offrent des sacrifices à des taureaux, mais leurs autels deviendront des tas de pierres dans les champs."
,"13":"Jacob s'était enfui aux campagnes d'Aram, Israël avait travaillé pour une femme; pour une femme il s'était fait gardien."
,"14":"Mais par un prophète Yahvé a fait monter Israël d'Egypte, il se l'est gardé grâce à un prophète."
,"15":"Ephraïm a gravement péché, c'est pourquoi Yahvé fera retomber sur lui le sang versé, son Seigneur lui retournera ses affronts."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Quand Ephraïm parlait, tout le monde avait peur; il était considéré en Israël, mais le péché commis avec Baal lui a valu la mort."
,"2":"Ils continuent de pécher; avec leur argent ils se sont fait une idole de métal, dessinée selon leur goût. Tout cela n'est qu'un travail d'ouvriers. Ils disent: 'Offrez-leur des sacrifices!' et des hommes envoient des baisers à des veaux."
,"3":"C'est pourquoi ils seront comme la rosée du matin, comme la rosée qui bientôt se dissipe, comme la bale emportée loin de l'aire à battre, comme la fumée qui sort par la fenêtre."
,"4":"Mais moi, Yahvé, je suis ton Dieu depuis le pays d'Egypte; tu ne connais pas d'autre Dieu que moi et tu n'as pas de sauveur en dehors de moi."
,"5":"Je t'ai connu au désert, au pays de la sécheresse."
,"6":"Je les ai fait paître et ils se sont rassasiés; mais aussitôt rassasiés leur coeur s'est gonflé d'orgueil et ils m'ont oublié."
,"7":"Je me suis donc changé pour eux en un lion. Je reste à l'affût comme le léopard au bord du chemin;"
,"8":"je tombe sur eux comme une ourse privée de ses petits, et je déchire l'enveloppe de leur coeur. Comme une lionne je les dévore sur place et les bêtes sauvages les déchirent."
,"9":"Israël, te voilà détruit; qui viendra te sauver?"
,"10":"Où donc est ton roi pour qu'il te sauve, où sont tes chefs pour qu'ils te protègent? Ne disais-tu pas: Donne-moi un roi et des chefs?"
,"11":"Eh bien, dans ma colère je t'ai donné un roi, et dans ma fureur je le reprends."
,"12":"La faute d'Ephraïm est gardée en réserve, son péché est dans un lieu sûr."
,"13":"Les douleurs de l'enfantement viennent sur lui, mais l'enfant est stupide et ne sort pas du sein le moment venu."
,"14":"Devrais-je les délivrer du séjour des morts? Devrais-je les sauver de la mort? Non! Où est donc ton fléau, ô mort? Et toi, séjour des morts, où est ta destruction? Je ne veux plus avoir pitié d'eux."
,"15":"Ephraïm a su croître plus que ses frères, mais le vent d'est viendra, le souffle de Yahvé montera du désert; il mettra à sec sa source et sa fontaine ne coulera plus; il desséchera sa terre et tout ce à quoi il tenait."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Samarie paiera car elle s'est révoltée contre son Dieu; ils tomberont sous l'épée, leurs petits enfants seront écrasés et leurs femmes enceintes éventrées."
,"2":"Reviens Israël vers Yahvé ton Dieu, c'est bien ta faute qui t'a fait trébucher."
,"3":"Revenez à Yahvé; dites-lui donc ceci: 'Enlève tout le péché et prends ce qui est bon, au lieu de taureaux ce sera l'offrande de louange."
,"4":"L'Assyrie ne nous sauvera pas, nous ne monterons plus sur des chevaux, nous ne dirons plus: 'Notre Dieu' à du fabriqué; en toi seul l'orphelin trouve de la tendresse.'"
,"5":"- Je guérirai leur infidélité, je les aimerai de tout mon coeur; déjà ma colère s'est détournée d'Israël."
,"6":"Je serai pour Israël comme la rosée; comme le lis il fleurira,et poussera ses racines comme le peuplier:"
,"7":"voyez comme s'étendent ses rejetons!,Sa splendeur sera celle de l'olivier, et sa senteur celle du Liban."
,"8":"Ils reviendront habiter à mon ombre, ils auront la vigueur des blés, ils fleuriront comme la vigne,et seront fameux comme le vin du Liban."
,"9":"Ephraïm n'a plus rien à faire avec les idoles, je l'écoute et je le regarde, moi qui suis comme un cyprès verdoyant: c'est de moi que viennent tes fruits."
,"10":"Si quelqu'un est sage, qu'il comprenne; s'il est intelligent, qu'il en ait la connaissance. Car les voies de Yahvé sont droites; les justes y font leur chemin, mais les rebelles y courent à la chute."
}`)

}
func FR_LBDCC_LoadVNSOChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Parole de Yahvé qui fut adressée à Sophonie, fils de Kouchi, fils de Guédalyas, fils d'Amaryas, fils de Hizékiyas, au temps de Josias, fils d'Amon, roi de Juda."
,"2":"J'enlèverai tout de dessus la terre - parole de Yahvé."
,"3":"J'enlèverai hommes et bêtes, j'enlèverai les oiseaux du ciel et les poissons de la mer. J'exterminerai l'homme de dessus la terre - parole de Yahvé."
,"4":"J'étendrai la main contre Juda et tous les habitants de Jérusalem, j'enlèverai de ce lieu ce qui reste du Baal et le nom des prêtres païens."
,"5":"J'exterminerai ceux qui se prosternent sur les toits devant l'armée des cieux, ceux qui se prosternent et qui jurent en même temps par Yahvé et par Milkom;"
,"6":"ceux qui se détournent de Yahvé, qui ne le recherchent pas et ne le consultent pas."
,"7":"Faites silence devant le Seigneur Yahvé, car son jour est proche. Yahvé a préparé un sacrifice, il a déjà consacré ses invités."
,"8":"Voici ce qui arrivera au jour du sacrifice de Yahvé: je demanderai des comptes aux princes, aux fils de roi et à tous ceux qui s'habillent à la mode étrangère."
,"9":"Je demanderai des comptes à tous ceux qui franchissent en sautant la porte du Temple de leur Seigneur, à ceux qui le remplissent de violence et de mensonge."
,"10":"En ce jour-là - parole de Yahvé - ce seront des cris à la porte des Poissons, des hurlements dans la ville neuve et un grand vacarme du côté des collines."
,"11":"Criez, habitants du Quartier Creux, car tout le marché de Canaan est anéanti; tous ces gens pleins d'argent sont supprimés."
,"12":"En ce temps-là je fouillerai Jérusalem avec des lanternes et je demanderai des comptes à ceux qui restent sur leurs ordures. Laissez-les dire: 'Yahvé ne fait ni bien ni mal';"
,"13":"leurs biens seront livrés au pillage et leurs maisons à la ruine."
,"14":"Le grand jour de Yahvé est proche, il est proche et il vient en courant. Quel jour amer, ce jour de Yahvé! Le plus courageux hurlera."
,"15":"Quel jour! Jour de fureur, jour d'angoisse et de détresse, jour de ravages et de ruines, jour de ténèbres et d'obscurité, jour de brouillard et de ciel couvert,"
,"16":"jour où le cor au haut du rempart, sonne l'alarme sur les villes fortes."
,"17":"Je mettrai les hommes dans l'angoisse, je les ferai marcher en aveugles, car ils ont péché contre Yahvé. Leur sang sera partout, comme la poussière, leur chair deviendra fumier."
,"18":"Ni leur argent ni leur or ne pourront les sauver au jour de la fureur de Yahvé. Toute la terre sera dévorée par le feu de sa jalousie; sur tous les habitants de la terre viendra la fin, la destruction soudaine."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Regroupez-vous, rassemblez-vous, peuple sans pudeur,"
,"2":"il est temps que vous soyez chassés comme bale soufflée en un jour, il est temps que vienne sur vous le jour des fureurs de Yahvé!"
,"3":"Et vous, les humbles, vous qui mettez en pratique les commandements, vous qui avez le souci de rester droits et humbles, cherchez Yahvé: peut-être serez-vous épargnés au jour de la fureur de Yahvé."
,"4":"Sachez-le, Gaza sera abandonnée, Askalon deviendra un désert, les gens d'Ashdod seront chassés en plein jour, Akaron sera déraciné."
,"5":"Malheur aux habitants de la Ligue de la côte, à la nation des Kérétiens! Car voici une parole de Yahvé contre vous: 'Je vais te faire disparaître, Canaan; terre des Philistins, tu n'auras plus d'habitants!'"
,"6":"La Ligue de la côte sera réduite à l'état de pâturage, ce seront des prés pour les bergers, des enclos pour les moutons."
,"7":"Ils appartiendront aux rapatriés de la maison de Juda, qui y conduiront leurs troupeaux. Au soir ils se reposeront dans les maisons d'Askalon, car Yahvé leur Dieu se souviendra d'eux et lui-même les rétablira."
,"8":"J'ai entendu les insultes de Moab et les moqueries d'Ammon lorsqu'ils insultaient mon peuple et s'agrandissaient aux dépens de son territoire."
,"9":"C'est pourquoi, aussi vrai que je suis vivant - parole de Yahvé Sabaot, le Dieu d'Israël: Moab deviendra comme Sodome, et Ammon comme Gomorrhe, une terre livrée aux orties, une carrière de sel, un désert pour toujours; le reste de mon peuple les pillera, les survivants de ma nation les recevront en héritage."
,"10":"Ce sera le prix de leur orgueil, car ils ont méprisé et insulté le peuple de Yahvé Sabaot."
,"11":"Yahvé deviendra leur terreur, il anéantira tous les dieux de la terre; devant lui se prosterneront tous ceux qui habitent les îles des païens, chacun dans son propre pays."
,"12":"Vous aussi, Ethiopiens, mon épée vous transpercera."
,"13":"Il lèvera encore la main contre le Nord et réduira l'Assyrie en ruines, il fera de Ninive une solitude, une terre aride, un désert."
,"14":"Sur son sol les troupeaux se reposeront, les animaux de toutes sortes. Le pélican, le hérisson, passeront la nuit entre ses pierres sculptées; un oiseau chantera sur la fenêtre, un corbeau devant la porte; les panneaux de cèdre auront été arrachés."
,"15":"Voilà pour la ville joyeuse qui trônait en paix et se disait: 'Moi et rien que moi!' Mais elle n'est plus qu'une ruine, le domaine des animaux sauvages. Tous ceux qui passent auprès d'elle sifflent et battent des mains."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Malheur à la rebelle, la ville tyrannique et souillée!"
,"2":"Elle n'a pas entendu l'appel, elle n'a pas reçu les leçons, elle n'a pas mis sa confiance en Yahvé, elle ne s'est pas rapprochée de son Dieu."
,"3":"Ses chefs au milieu d'elle sont comme des lions rugissants, ses juges, comme des loups du soir qui ne gardent rien pour le matin."
,"4":"Ses prophètes sont des fanfarons, prêts à tous les mensonges; ses prêtres profanent les choses saintes et violent la Loi."
,"5":"Mais au milieu d'elle se tient Yahvé, le Juste; chaque matin il prononce son jugement. Il est fidèle comme le lever du soleil; lui ne commet pas l'injustice. Mais l'injuste ne connaît pas la honte."
,"6":"J'ai supprimé des nations, leurs tours ont été détruites; j'ai laissé leurs rues désertes, nul n'y passe; leurs villes ont été saccagées, plus personne n'y habite."
,"7":"Je me disais: 'Au moins, tu me craindras, tu accepteras la leçon'. Je me disais encore: 'Elle ne pourra pas oublier toutes mes menaces.' Et pourtant ils se sont empressés de se pervertir dans tout ce qu'ils faisaient."
,"8":"C'est pourquoi attendez-moi, parole de Yahvé, pour ce jour où je me lèverai en accusateur. Ma sentence est prête: je rassemblerai les nations, je réunirai les royaumes pour déverser sur eux ma fureur et ma violente colère. Tout le pays sera dévoré par le feu de ma jalousie."
,"9":"Alors je donnerai aux peuples des lèvres pures; tous invoqueront le Nom de Yahvé et le serviront d'un même coeur."
,"10":"De plus loin que les fleuves d'Ethiopie on m'apportera l'offrande."
,"11":"En ce jour-là tu n'auras plus à rougir de tant de péchés que tu commets contre moi, car j'aurai ôté de chez toi les prétentieux qui fanfaronnent, et vous cesserez d'être arrogants jusque sur ma montagne sainte."
,"12":"Je laisserai au milieu de toi un peuple humble et pauvre qui mettra sa confiance dans le Nom de Yahvé."
,"13":"Le reste d'Israël ne commettra plus d'injustice; ils ne parleront plus pour tromper, on ne trouvera plus dans leur bouche des paroles mensongères. Alors ils seront comme le troupeau qui broute et prend son repos; nul ne viendra les troubler."
,"14":"Pousse des cris de joie, fille de Sion, fais entendre tes acclamations, Israël!,Réjouis-toi et que ton coeur soit en fête, fille de Jérusalem!"
,"15":"Car Yahvé a annulé sa sentence contre toi, il a écarté ton ennemi. Yahvé, roi d'Israël, est au milieu de toi, tu ne connaîtras plus le malheur."
,"16":"En ce jour-là on dira à Jérusalem: 'Ne crains pas, Sion, que tes mains cessent de trembler!"
,"17":"Yahvé ton Dieu est au milieu de toi, ton vaillant sauveur!,Pour toi il se sent fou de joie, son amour te refera toute neuve; pour toi il dansera et criera sa joie"
,"18":"comme tu le fais au jour de la Fête.',J'écarterai de toi le malheur et tu ne seras plus humiliée. "
,"19":"Je ferai disparaître tous ceux qui t'oppriment. En ce temps-là je guérirai l'infirme, je rassemblerai les égarés; ils seront félicités et acclamés dans tous les pays où ils avaient connu la honte."
,"20":"En ce temps-là je vous ferai du bien, en ce temps où je vous rassemblerai. Vous serez félicités et enviés par tous les peuples de la terre lorsque, sous vos yeux, je ferai revenir vos dispersés - parole de Yahvé."
}`)

}
func FR_LBDCC_LoadVNZAChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Le huitième mois de la deuxième année de Darius, la parole de Yahvé fut adressée ainsi à Zacharie, fils de Bérékyas fils de Iddo:"
,"2":"'Yahvé s'est vraiment mis en colère contre vos pères!'"
,"3":"Puis tu ajouteras: 'Voici ce que dit Yahvé Sabaot: Revenez à moi et je reviendrai à vous,"
,"4":"ne soyez pas comme vos pères. Les prophètes d'autrefois leur criaient: Voici ce que dit Yahvé Sabaot: Revenez donc de vos mauvais chemins et de vos mauvaises pratiques. Mais ils n'ont pas entendu, ils n'ont pas prêté l'oreille - parole de Yahvé."
,"5":"Vos pères, où sont-ils? Les prophètes aussi ont terminé leur vie."
,"6":"Mais les paroles et les ordres que j'avais confiés à mes serviteurs les prophètes se sont si bien accomplis pour vos pères, qu'ils sont revenus vers moi et ont reconnu: 'Yahvé Sabaot nous a traités selon nos voies et nos pratiques, comme il avait décidé de le faire.'"
,"7":"Le vingt-quatrième jour du onzième mois (c'est le mois de Chébat), en la deuxième année de Darius, une parole de Yahvé fut adressée au prophète Zacharie, fils de Bérékyas fils de Iddo."
,"8":"La voici: Durant la nuit j'ai eu une vision, un homme montait un cheval roux et se tenait au milieu de buissons à grosses racines; derrière lui il y avait des chevaux roux, bruns et blancs. "
,"9":"Je dis: 'Mon Seigneur, qui sont-ils?' Et l'ange qui me parlait répondit: 'JeA te ferai voir qui ils sont.'"
,"10":"L'homme qui se tenait au milieu des buissons répondit: 'Ce sont ceux que Yahvé a envoyés pour parcourir la terre.'"
,"11":"Alors ils se tournèrent vers l'ange de Yahvé qui se tenait au milieu des buissons et lui dirent: 'Nous venons de parcourir la terre, et voici que toute la terre est en paix et tranquille.'"
,"12":"A ce moment l'ange de Yahvé prit la parole et dit: 'Yahvé Sabaot, combien de temps encore attendras-tu pour faire miséricorde à Jérusalem et aux villes de Juda à qui tu as fait sentir ta colère depuis soixante-dix ans?'"
,"13":"Yahvé dit à l'ange qui me parlait de bonnes paroles, des paroles de consolation."
,"14":"Aussi l'ange qui me parlait me dit-il: 'Tu rediras ces paroles de Yahvé Sabaot: J'éprouve un amour jaloux pour Jérusalem et pour Sion."
,"15":"Par contre je suis très en colère contre les nations qui vivent bien tranquilles; car moi, j'étais un peu en colère, mais elles, elles ont tout laissé en ruine."
,"16":"C'est pourquoi, voici ce que dit Yahvé: Je reviens vers Jérusalem avec de bonnes dispositions; ma Maison y sera reconstruite - parole de Yahvé Sabaot, et l'on tendra sur Jérusalem le cordeau des maçons."
,"17":"Proclame encore ceci que Yahvé Sabaot vous dit: Mes villes déborderont de richesse; Yahvé consolera encore Sion, Jérusalem sera encore sa préférée.'"
}`)
	CurrentBook.AddChapter(2, `{
"1":"J'ai regardé, et voici ce que j'ai vu: il y avait quatre cornes."
,"2":"Je dis à l'ange qui me parlait: 'Que sont ces cornes?' Il me répondit: 'Ce sont les cornes qui ont dispersé Juda et Jérusalem.'"
,"3":"Puis Yahvé me fit voir quatre forgerons."
,"4":"Je dis: 'Que viennent faire ceux-ci?' Il me répondit: 'Les cornes avaient si bien dispersé Juda, que personne n'osait plus relever la tête; mais ceux-ci sont venus pour les épouvanter, pour abattre les cornes des nations qui avaient frappé Juda et l'avaient dispersé.'"
,"5":"De nouveau j'ai regardé, et voici ce que j'ai vu: un homme était là avec un cordeau pour mesurer."
,"6":"Je lui dis: 'Où vas-tu?' Il me répondit: 'Je vais mesurer Jérusalem pour savoir sa largeur et sa longueur.'"
,"7":"Alors l'ange qui me parlait s'avança et un autre ange se présenta devant lui."
,"8":"Il lui dit: 'Cours, parle à ce jeune homme et dis-lui: Jérusalem restera ouverte, vu le grand nombre d'hommes et d'animaux qui s'y trouveront."
,"9":"Mais Yahvé l'assure: 'Tout autour d'elle je serai un rempart de feu; au milieu d'elle je serai sa gloire.'"
,"10":"Holà! Holà! Fuyez du pays du Nord - parole de Yahvé, vous que j'ai dispersés aux quatre vents du ciel - parole de Yahvé."
,"11":"Holà! Sauve-toi Sion, toi qui demeures à Babylone,"
,"12":"car voici ce qu'a dit Yahvé Sabaot, lui qui m'a déjà fait parler contre les nations qui vous pillent: 'Celui qui vous touche, touche à la pupille de mon oeil!"
,"13":"Je vais lever ma main contre ces nations pour qu'elles soient pillées par leurs esclaves.' Alors vous saurez que Yahvé Sabaot m'a envoyé."
,"14":"Chante ta joie, fille de Sion, car voici que je viens. Ma demeure sera chez toi, dit Yahvé."
,"15":"Bien des nations, ce jour-là, s'attacheront à Yahvé pour être son peuple, mais c'est chez toi qu'il aura sa demeure."
,"16":"Juda sera toujours la part de Yahvé sur sa Terre Sainte; Jérusalem sera encore sa préférée."
,"17":"Que tout mortel fasse silence devant Yahvé: voici qu'il s'éveille en sa sainte Demeure."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Yahvé me fit voir le grand-prêtre Josué. Il se tenait devant l'ange de Yahvé, et Satan se tenait à sa droite pour l'accuser."
,"2":"L'ange de Yahvé dit à Satan: 'Que Yahvé te fasse taire, Satan. Oui, que Yahvé te fasse taire, lui qui a choisi Jérusalem! Celui-ci n'est-il pas un tison sauvé du feu?'"
,"3":"Or Josué se tenait devant l'ange avec des vêtements sales."
,"4":"L'ange s'adressa alors à ceux qui l'assistaient: 'Enlevez-lui ses vêtements sales, passez-lui des habits de fête"
,"5":"et mettez lui sur la tête une tiare propre.' Alors on mit sur sa tête une tiare propre et on l'habilla de vêtements de fête. L'ange de Yahvé ajouta: 'A présent je t'ai débarrassé de ta faute.'"
,"6":"Puis l'ange de Yahvé déclara à Josué: 'Voici ce que dit Yahvé Sabaot:"
,"7":"'Si tu marches dans mes sentiers, si tu gardes mes commandements, tu dirigeras ma Maison; tu seras le gardien de mon Temple et je te donnerai une place parmi ceux qui se tiennent ici."
,"9a":"Car voici la pierre que je place devant Josué; sur cette pierre unique il y a sept yeux et moi-même je vais en graver l'inscription - parole de Yahvé Sabaot."
,"8":"Toi, Josué le grand-prêtre, et tes compagnons qui sont assis autour de toi, écoutez donc car vous êtes des personnages importants. Voici que je vais introduire mon serviteur 'le Germe',"
,"9b":"et en un seul jour je supprimerai la dette de ce pays envers moi."
,"10":"Ce jour-là - parole de Yahvé Sabaot, vous vous inviterez l'un l'autre sous la vigne et sous le figuier.'"
}`)
	CurrentBook.AddChapter(4, `{
"1":"L'ange qui me parlait revint; il me réveilla comme un homme que l'on tire de son sommeil"
,"2":"et me demanda: 'Que vois-tu?' Je répondis: 'Je vois un chandelier tout en or, avec à son sommet un réservoir d'huile et sept lampes à bec.'"
,"3":"Deux oliviers se trouvaient à côté, l'un à droite de la réserve d'huile et l'autre à sa gauche."
,"4":"Alors je dis à l'ange qui parlait avec moi: 'Qu'est-ce que cela signifie?'"
,"5":"Il me répond: 'Tu ne le sais donc pas?' Je lui dis: 'Non, mon Seigneur.'"
,"6":"Il m'explique:"
,"6b":"Voici une parole de Yahvé pour Zorobabel: 'Ni par l'argent, ni par la force, mais par mon Esprit.'"
,"7":"Que la montagne est haute! Mais devant Zorobabel elle se changera en plaine. C'est lui qui portera la dernière pierre aux cris de: 'Bravo, bravo pour elle!'"
,"8":"Une parole de Yahvé me fut alors adressée:"
,"9":"'Les mains de Zorobabel ont posé les fondations de ce Temple; ses mains aussi l'achèveront."
,"10":"a Cela vous a peut-être semblé bien peu de chose le jour où l'on posait la première pierre, mais vous aurez la joie de voir la pierre de couronnement dans les mains de Zorobabel."
,"10b":"'Ces sept lampes sont les yeux de Yahvé qui observent toute la terre.'"
,"11":"Je demande de nouveau: 'Que représentent ces deux oliviers à droite et à gauche du chandelier?'"
,"13":"Il me répond: 'Tu ne le sais pas?' Je lui dis: 'Non, mon Seigneur.'"
,"14":"Il m'explique: 'Ce sont les deux hommes consacrés qui se tiennent devant le Seigneur de toute la terre.'"
}`)
	CurrentBook.AddChapter(5, `{
"1":"De nouveau je regarde, et voici ce que je vois:"
,"2":"un rouleau dans les airs. L'ange me dit: 'Que vois-tu?' Je réponds: 'Je vois un rouleau qui vole, il a dix mètres de long et cinq de large.'"
,"3":"L'ange me dit: 'C'est une malédiction qui va se répandre sur tout le pays. Il y est écrit que tout voleur sera balayé loin d'ici. Il y est encore écrit que celui qui jure sera balayé d'ici."
,"4":"J'ai lancé cette malédiction, dit Yahvé Sabaot, pour qu'elle vienne sur la maison du voleur et sur la maison de celui qui jure par mon Nom afin de cacher ses mensonges; elle s'arrêtera dans sa maison, et elle en dévorera le bois et les pierres.'"
,"5":"De nouveau l'ange prend la parole: 'Lève les yeux et regarde ce qui approche.' Je demande: 'Qu'est-ce que c'est?'"
,"6":"Il me dit: 'C'est une mesure pour peser le grain.' Il ajoute: 'C'est par là que tous pèchent dans ce pays.'"
,"7":"Alors se soulève un disque de plomb et l'on voit une femme assise dans la mesure à peser le grain."
,"8":"L'ange me dit: 'C'est la malhonnêteté.' Puis il la repousse à l'intérieur de la mesure et il en bouche l'ouverture avec la masse de plomb."
,"9":"Alors sous mes yeux se présentent deux femmes avec des ailes de cigognes; le vent enfle leurs ailes et elles enlèvent la mesure entre terre et ciel."
,"10":"Je dis alors à l'ange qui me parlait: 'Où donc ces femmes emportent-elles la mesure?'"
,"11":"Il me répond: 'Elles vont lui construire un temple dans la terre de Chinéar; on lui fera un piédestal pour la poser dessus.'"
}`)
	CurrentBook.AddChapter(6, `{
"1":"De nouveau je regarde, et voici ce que je vois: il y a là deux montagnes de bronze, et quatre chars sortent d'entre les deux montagnes."
,"2":"Le premier char est tiré par des chevaux roux, le deuxième par des chevaux noirs,"
,"3":"le troisième par des chevaux blancs et le quatrième par des chevaux blancs et noirs."
,"4":"Je prends la parole et je dis à l'ange qui me parle: 'Que veut dire cela, mon Seigneur?'"
,"5":"L'ange me répond: 'Ce sont les quatre vents du ciel qui viennent de se présenter devant le Seigneur de toute la terre."
,"6":"Le char avec les chevaux noirs part vers le pays du Nord, les blancs vont à l'ouest vers la mer, et ceux qui sont blancs et noirs s'avancent vers le pays du Sud."
,"7":"Il fallait les retenir car ils étaient impatients de parcourir toute la terre. Dès que l'ange leur dit: 'Allez, parcourez la terre!' ils partirent et ils parcoururent la terre."
,"8":"L'ange alors m'appelle et me dit: 'Regarde, ceux qui s'avancent vers le pays du Nord vont tranquilliser l'esprit de Yahvé dans le pays du Nord.'"
,"9":"Une parole de Yahvé me fut adressée:"
,"10":"'Recueille des mains de Heldaï, de Tobiya et de Yédaya, les offrandes de ceux qui sont revenus de la captivité. Tu iras ensuite chez Yochiya fils de Séfanya qui est également rentré de Babylone,"
,"11":"et avec cet argent et cet or tu feras faire une couronne que tu iras placer sur la tête de Josué fils de Yosadak, le grand-prêtre."
,"12":"Alors tu lui diras: 'Voici ce que dit Yahvé Sabaot: Le nom de cet homme est 'Germe', et de lui germera quelque chose."
,"13":"C'est lui qui rebâtira le Temple de Yahvé; il portera les vêtements royaux et siégera comme suprême gouverneur. Il aura un prêtre à sa droite et entre eux ce sera l'union parfaite."
,"14":"La couronne restera dans le Temple de Yahvé à la mémoire de Heldaï, Tobiya, Yédaya et Josué."
,"15":"Ceux qui sont au loin viendront reconstruire le Temple de Yahvé (et vous saurez que Yahvé Sabaot m'a envoyé vers vous). Mais il faut pour cela que vous écoutiez vraiment la voix de Yahvé votre Dieu.'"
}`)
	CurrentBook.AddChapter(7, `{
"1":"La quatrième année du roi Darius, la parole de Yahvé fut adressée à Zacharie, le quatrième jour du neuvième mois (c'est le mois de Kisleu)."
,"2":"La ville de Béthel avait envoyé Saréser avec ses hommes pour supplier Yahvé"
,"3":"et pour poser cette question aux prêtres de la Maison de Yahvé et aux prophètes: 'Devons-nous pleurer au cinquième mois et faire des pénitences comme nous l'avons fait durant tant d'années?'"
,"4":"Alors cette parole de Yahvé Sabaot me fut adressée:"
,"5":"'Tu diras ceci à tous les résidents et aux prêtres: Lorsque vous avez jeûné et pleuré au cinquième et au septième mois durant soixante dix ans, était-ce moi qui vous faisais jeûner?"
,"6":"C'est vous qui choisissiez de jeûner, ou de boire et de manger."
,"7":"Sans doute avez-vous oublié les paroles que Yahvé faisait dire aux anciens prophètes, lorsque Jérusalem était habitée et prospère, ainsi que les villes d'alentour, lorsque le Négueb et le Bas-Pays étaient habités."
,"9":"Voici ce que disait Yahvé Sabaot: 'Rendez la justice avec droiture, pratiquez la bonté et la miséricorde les uns envers les autres."
,"10":"N'opprimez ni la veuve, ni l'orphelin, ni l'étranger, ni le pauvre; ne cherchez pas à vous faire du mal les uns aux autres.'"
,"11":"Mais vos pères ont refusé d'écouter, refusé d'obéir; ils ont fait la sourde oreille."
,"12":"Ils se sont fait un coeur de pierre pour ne pas écouter cet enseignement et ces paroles que Yahvé Sabaot proclamait par la voix des prophètes d'autrefois. Alors la colère de Yahvé Sabaot s'est déchaînée:"
,"13":"'Puisque vous n'avez pas écouté quand Yahvé appelait, maintenant il ne vous écoutera pas quand vous l'appellerez - parole de Yahvé Sabaot.'"
,"14":"Je les ai donc emportés comme fait l'ouragan, et dispersés parmi les nations qu'ils ne connaissaient pas. Et derrière eux le pays est resté ravagé, inhabité: d'une terre fertile ils ont fait un désert."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Cette parole de Yahvé Sabaot me fut adressée:"
,"2":"'Je suis très attaché à Sion, dit Yahvé Sabaot, et je suis très en colère contre ses ennemis.'"
,"3":"Yahvé affirme: 'Je suis revenu à Sion et j'habite au milieu de Jérusalem. On appellera Jérusalem: 'Ville-de-la-Fidélité', et la montagne de Yahvé Sabaot: 'Montagne Sainte'."
,"4":"Et voici ce que dit Yahvé Sabaot: 'Des vieux et des vieilles s'assiéront encore sur les places de Jérusalem, s'appuyant sur leurs cannes à cause de leur grand âge."
,"5":"Des petits garçons et des petites filles rempliront de leurs jeux les places de la ville.'"
,"6":"Voici ce que dit Yahvé Sabaot: 'Si cela paraît un rêve aux survivants de ce peuple, est-ce que pour moi ce sera trop difficile? - parole de Yahvé Sabaot."
,"7":"Voici ce que dit Yahvé Sabaot: Je vais sauver mon peuple des pays du Levant et de l'Occident;"
,"8":"je les ferai revenir et ils s'installeront à Jérusalem. Ils seront mon peuple, et moi je serai leur Dieu dans la vérité et la justice.'"
,"9":"Voici ce que dit Yahvé Sabaot: 'Reprenez courage! Rappelez-vous donc ce que vous ont dit les prophètes le jour où l'on a posé les fondations pour la reconstruction du Temple de Yahvé."
,"10":"Auparavant, ni les gens, ni le bétail n'étaient payés de leur peine; il n'y avait pas de paix pour les habitants, on craignait l'ennemi. Et cela, parce que je les laissais se déchaîner les uns contre les autres."
,"11":"Mais désormais je n'agirai plus avec les survivants de ce peuple comme je faisais alors - parole de Yahvé Sabaot."
,"12":"Je vais semer la paix; la vigne donnera son fruit, la terre donnera sa récolte, et le ciel, sa rosée; c'est l'héritage que je donne aux survivants de ce peuple."
,"13":"De même que vous avez été un exemple de malédiction pour les autres nations, de même je vous sauverai, maison de Juda et maison d'Israël, et vous deviendrez l'exemple d'un peuple béni; ne craignez pas, reprenez courage!'"
,"14":"Voici ce que dit Yahvé Sabaot: 'De même que j'avais décidé de vous faire du mal lorsque vos pères me mettaient en colère - parole de Yahvé, et je ne suis pas revenu en arrière,"
,"15":"de même maintenant je décide de faire du bien à Jérusalem et à la maison de Juda; ne craignez donc pas!"
,"16":"Voici ce que vous devez faire: Que chacun dise la vérité à son prochain, et lorsque vous siégez à la porte pour juger, rendez des jugements justes."
,"17":"Ne cherchez pas à vous faire du mal les uns aux autres et ayez en horreur le faux serment, car tout cela je le déteste - parole de Yahvé.'"
,"18":"Cette parole de Yahvé Sabaot me fut adressée:"
,"19":"'Les jeûnes du quatrième mois, du cinquième, du septième et du dixième mois deviendront pour la maison de Juda des jours de fête et de joie avec de belles cérémonies - parole de Yahvé Sabaot; mais aimez la vérité et la paix.'"
,"20":"Voici ce que dit Yahvé Sabaot: 'Des peuples et des habitants de grandes villes viendront encore à Jérusalem;"
,"21":"les habitants d'une ville iront vers une autre ville pour les inviter: 'Venez, allons prier Yahvé, allons chercher Yahvé Sabaot! Voyez, nous aussi nous allons.'"
,"22":"Des peuples nombreux et de grandes nations viendront prier et implorer Yahvé Sabaot.'"
,"23":"Voici ce que dit Yahvé Sabaot: En ces jours-là, dix hommes de toute langue et nation saisiront un Juif par le pan de sa robe en disant: 'Nous voulons nous aussi aller avec vous, car nous avons appris que Dieu est avec vous.'"
}`)
	CurrentBook.AddChapter(9, `{
"1":"Prophétie. Yahvé s'est établi dans Hadrak et à Damas; voici que la source d'Aram appartient à Yahvé aussi bien que toutes les tribus d'Israël. "
,"2":"De même Hamat qui est à côté, ainsi que Tyr et Sidon qui mènent si bien leurs affaires."
,"3":"Tyr s'est construit une forteresse, elle y a amassé l'argent comme la poussière, et l'or fin autant que la boue des rues."
,"4":"Mais maintenant le Seigneur va s'en emparer; il jettera son rempart à la mer et le feu la dévorera."
,"5":"En voyant cela Askalon prendra peur et Gaza tremblera de tous ses membres. Akaron perdra toute assurance; le roi de Gaza disparaîtra et Askalon sera privée d'habitants."
,"6":"Un étranger habitera dans Ashdod et je détruirai l'orgueil des Philistins."
,"7":"J'arracherai de leur bouche la viande saignante, et d'entre leurs dents leurs ordures. Les survivants des Philistins deviendront pour notre Dieu comme un clan de Juda; Akaron sera traitée comme une ville jébusite."
,"8":"Je camperai comme un gardien tout autour de ma maison, surveillant les allées et venues; plus personne ne les opprimera, car maintenant j'ai vu leur oppression."
,"9":"Réjouis-toi, fille de Sion, lance des cris joyeux, fille de Jérusalem, car voici que ton roi vient à toi. Il t'apporte justice et victoire, il est humble, monté sur un âne, sur un ânon, petit d'une ânesse."
,"10":"Il détruira les chars d'Ephraïm,et les chevaux de Jérusalem; on pourra alors briser l'arc de guerre, car il imposera sa paix aux nations. Son empire s'étendra de la mer à la mer, depuis l'Euphrate jusqu'aux confins du monde."
,"11":"A cause de ton alliance scellée par le sang, je ferai sortir de la citerne les captifs."
,"12":"A toi, fille de Sion, reviendront les captifs qui attendent; aujourd'hui même je le déclare: vous recevrez en retour double bénédiction."
,"13":"Voici que je fais de Juda mon arc, et d'Ephraïm ma flèche; je lance tes fils, Sion, contre les habitants des îles, je ferai de toi comme l'épée d'un héros."
,"14":"Yahvé se lèvera au-dessus d'eux, sa flèche partira comme l'éclair, le Seigneur Yahvé sonnera de la trompette et s'avancera au milieu de l'ouragan du midi."
,"15":"Yahvé Sabaot sera leur bouclier; ils vaincront et piétineront les méchants, ils boiront leur sang comme du vin, ils s'en rempliront comme la coupe des sacrifices, comme les cornes de l'autel."
,"16":"Yahvé les sauvera; il sauvera ce peuple qui est son troupeau."
,"17":"Les voilà forts, les voilà beaux! Le blé donnera fière allure aux garçons et le vin nouveau aux vierges."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Demandez à Yahvé les pluies de printemps, car c'est lui qui lance les éclairs. Il vous donnera une pluie abondante, que chacun ait de l'herbe dans son champ."
,"2":"Car les petites idoles ont parlé pour ne rien dire et les devins ont eu des visions de mensonge. Ils racontent des songes qui n'existent pas et donnent de fausses espérances; c'est pourquoi mon peuple a été dispersé comme un troupeau; privé de bergers, ils ont été opprimés."
,"3":"Ma colère s'est emportée contre les bergers et j'ai puni les boucs. Mais Yahvé Sabaot va visiter son troupeau, la maison de Juda; il le prendra comme son cheval préféré pour la bataille. "
,"4":"C'est lui qui donnera l'armée, qui donnera la lance et l'arc de guerre, c'est lui qui donnera tous les chefs."
,"5":"Ils seront autant de héros piétinant la boue des champs de bataille; ils sauront combattre car Yahvé sera avec eux, et ils couvriront de honte les cavaliers avec leurs chevaux."
,"6":"Je redonnerai courage à la maison de Juda, je délivrerai la maison de Joseph; je les rétablirai car j'ai pitié d'eux, et ils seront comme si je ne les avais jamais rejetés. (Je suis Yahvé leur Dieu et je les exaucerai.)"
,"7":"Les hommes d'Ephraïm seront comme des héros, tout joyeux comme après avoir bu; à cette vue, leurs fils se réjouiront et leur coeur trouvera sa joie en Yahvé."
,"8":"Je les sifflerai et les rassemblerai. Ils se multiplieront comme aux temps anciens."
,"9":"Ceux que j'ai dispersés parmi les nations se souviendront de moi du fond de ces pays lointains; ils instruiront leurs enfants qui reviendront."
,"10":"Je les ramènerai du pays d'Egypte, je les rassemblerai d'Assyrie; je les installerai jusque dans le Galaad et au Liban, mais il manquera encore de la place pour eux."
,"11":"Alors ils traverseront la mer d'Egypte, car Yahvé frappera les flots de la mer et les eaux profondes du Nil seront mises à sec. L'orgueil de l'Assyrie sera abattu, à l'Egypte on arrachera son sceptre."
,"12":"Yahvé les rendra redoutables, son Nom les mènera au combat - parole de Yahvé."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Ouvre tes portes, Liban, que le feu dévore tes cèdres!"
,"2":"Que le cyprès se lamente car le cèdre est tombé; des arbres magnifiques ont été saccagés. Lamentez-vous chênes de Bashan, car la forêt impénétrable est détruite."
,"3":"Ecoutez la plainte des bergers, car leur belle prairie est saccagée, écoutez le rugissement des petits lions car la gloire du Jourdain est détruite."
,"4":"Voici ce que dit Yahvé mon Dieu: Prends soin de ces brebis qu'on égorge."
,"5":"Leurs acheteurs les abattent sans être inquiétés, leurs vendeurs disent: 'Béni soit Yahvé, je me suis enrichi!' et leurs pasteurs ne s'occupent pas d'elles. ("
,"6":"Oui, je n'épargnerai plus les habitants du pays, parole de Yahvé. Je vais livrer chaque homme aux mains de son prochain, aux mains de son roi; ils écraseront le pays et je ne les délivrerai pas de leurs mains.')"
,"7":"Alors je me fais pasteur de ces brebis destinées aux marchands de brebis; je prends deux bâtons, j'appelle le premier: 'bienveillance' et l'autre: 'union', et je m'occupe des brebis."
,"8":"Le premier mois je fais disparaître les trois pasteurs, mais ensuite je perds patience avec les brebis et elles se dégoûtent de moi."
,"9":"Alors je décide: Je ne m'occuperai plus de vous. Que celles qui doivent mourir meurent, que celles qui doivent disparaître disparaissent, et que celles qui restent se déchirent entre elles."
,"10":"Après quoi je prends mon bâton 'bienveillance' et je le brise: c'est la rupture de l'accord que Yahvé avait passé avec les autres peuples."
,"11":"Ce jour-là donc il est rompu et les marchands de brebis qui m'observent comprennent que c'est une parole de Yahvé."
,"12":"Je leur dis: 'Si cela vous semble bon, donnez-moi mon salaire, sinon, peu importe.' Et ils pèsent trente pièces d'argent qu'ils me donnent comme salaire."
,"13":"Alors Yahvé me dit: 'Jette dans le trésor cette si belle somme à laquelle ils m'ont estimé.' Je prends donc les trente pièces d'argent et je les jette dans le trésor du Temple de Yahvé."
,"14":"Ensuite je brise mon deuxième bâton 'union', et c'est la fraternité entre Juda et Israël qui est rompue."
,"15":"Yahvé me dit encore: 'Prends l'allure d'un berger sans cervelle."
,"16":"Car c'est le genre de berger que je donne maintenant à ce pays; il ne s'inquiétera pas de la brebis qui manque, il n'ira pas chercher celle qui s'est égarée, il ne soignera pas celle qui est blessée, il ne portera pas celle qui n'arrive pas à suivre, mais il dévorera la chair des bêtes grasses ou leur arrachera les sabots.'"
,"17":"Malheur à ce pasteur de rien qui délaisse son troupeau! Que l'épée le blesse au bras et à l'oeil droit, que son bras devienne sec, et son oeil droit aveugle."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Oracle de Yahvé à propos d'Israël. Parole de Yahvé qui a étendu les cieux et fondé la terre, qui a formé l'esprit de l'homme au-dedans de lui."
,"2":"Voici que je fais de Jérusalem une coupe où s'enivreront tous les peuples d'alentour; c'est tout Juda qui sera un camp retranché."
,"3":"En ce jour-là Jérusalem sera la pierre que tous les peuples essayeront de soulever, mais tous ceux qui s'y risqueront se blesseront pour de bon."
,"4":"En ce jour-là - parole de Yahvé, je frapperai les chevaux d'égarement et leurs cavaliers de folie; je frapperai tous les peuples d'aveuglement, et je veillerai de près sur la maison de Juda."
,"5":"Les clans de Juda le reconnaîtront: 'La force des habitants de Jérusalem, c'est leur Dieu, Yahvé Sabaot.'"
,"6":"En ce jour-là les clans de Juda seront comme le feu dans un tas de bois, comme une torche enflammée dans une gerbe; ils dévoreront à droite et à gauche tous les peuples qui les entourent, mais à Jérusalem, rien ne lui arrivera."
,"7":"Yahvé sauvera d'abord les cités de Juda pour que la maison de David et les habitants de Jérusalem ne se croient pas supérieurs aux gens de Juda."
,"8":"En ce jour-là, Yahvé protégera les habitants de Jérusalem; celui d'entre eux qui était chancelant sera fort comme David en ce jour-là, et les gens de David seront à leur tête comme Dieu, comme l'ange de Yahvé."
,"9":"En ce jour-là, je m'acharnerai sur les nations qui seront venues attaquer Jérusalem."
,"10":"Je répandrai sur la maison de David et sur les habitants de Jérusalem un esprit d'amour et de confiance; ils regarderont vers celui qu'on a transpercé, et se lamenteront sur lui comme on fait pour un fils unique; ils le pleureront comme on pleure un premier-né."
,"11":"La lamentation de Jérusalem en ce jour-là ne sera pas moindre que celle qu'on fait pour Haddad Rimmon dans la plaine de Méguiddo."
,"12":"Le pays se lamentera clan par clan. Le clan de David d'un côté, avec ses femmes à part; le clan de Nathan d'un côté, avec ses femmes à part."
,"13":"Le clan de Lévi d'un côté, avec ses femmes à part. Le clan de Chiméï d'un côté, avec ses femmes à part."
,"14":"Tous les clans, tous ceux qui restent, se lamenteront clan par clan, les hommes de leur côté, et leurs femmes à part."
}`)
	CurrentBook.AddChapter(13, `{
"1":"En ce jour-là une source jaillira; la maison de David et les habitants de Jérusalem y laveront leurs péchés et leurs impuretés."
,"2":"Et voici encore: En ce jour-là, dit le Seigneur, j'effacerai dans tout le pays les noms des idoles: on ne les nommera même plus. De même disparaîtront du pays les faux prophètes et leur esprit impur."
,"3":"Si quelqu'un veut encore jouer au prophète, son père et sa mère qui l'ont mis au monde lui diront: 'Tu vas mourir, car ce sont des mensonges que tu racontes au nom de Yahvé.' Et s'il prophétise, son père et sa mère qui l'ont mis au monde le transperceront."
,"4":"En ce jour-là les prophètes rougiront des visions qu'ils racontaient; ils ne se mettront plus ce manteau de poils qui les autorisait à mentir."
,"5":"Mais ils diront: 'Je ne suis pas prophète, je suis un travailleur des champs, la terre a été mon gagne-pain depuis ma jeunesse.'"
,"6":"Et si on demande à l'un d'eux: 'Que sont ces blessures sur ta poitrine?' il dira: 'Cela m'est arrivé chez mes amis.'"
,"7":"Lève-toi, épée, contre mon berger, contre l'homme avec qui je me suis lié - parole de Yahvé Sabaot. Frappe le berger, que les brebis soient dispersées, et je lèverai ma main contre leurs petits."
,"8":"Alors dans tout le pays - parole de Yahvé - deux tiers périront et le dernier tiers sera laissé."
,"9":"Je ferai passer ce tiers par le feu; je le purifierai comme on purifie l'argent, je le mettrai à l'épreuve comme on fait pour l'or; alors il invoquera mon Nom et je lui répondrai; je dirai: 'Il est mon peuple' et lui, dira: 'Yahvé est mon Dieu.'"
}`)
	CurrentBook.AddChapter(14, `{
"1":"Voici que vient ce jour de Yahvé où l'on partagera tes dépouilles au milieu de toi."
,"2":"Je ferai que toutes les nations se rassemblent pour faire la guerre à Jérusalem. La ville sera prise, les maisons pillées, les femmes violées; la moitié des habitants partira en captivité, mais une partie du peuple restera dans la ville."
,"3":"Alors Yahvé se mettra en campagne contre ces nations et leur fera la guerre comme il fait aux jours de bataille."
,"4":"En ce jour-là ses pieds se poseront sur le mont des Oliviers, face à Jérusalem à l'est; le mont des Oliviers se fendra par le milieu et une immense vallée s'ouvrira d'est en ouest. Une moitié du mont reculera vers le nord et l'autre vers le sud,"
,"5":"puis la vallée de Hinnom se comblera depuis Goa jusqu'à Yasol, comme on l'a vu dans le tremblement de terre du temps d'Ozias, roi de Juda. Alors viendra Yahvé mon Dieu, et avec lui, tous les Saints."
,"6":"En ce jour-là il n'y aura plus de froid ou de gel."
,"7":"Il n'y aura plus que le jour: non pas jour et nuit, mais au soir il fera clair."
,"8":"En ce jour-là, de Jérusalem sortiront des eaux abondantes, moitié vers la mer orientale, moitié vers la mer occidentale; elles couleront été comme hiver."
,"9":"Alors Yahvé régnera sur toute la terre; en ce jour-là Yahvé sera l'Unique et son nom sera unique."
,"10":"Depuis Guéba jusqu'à Rimmon dans le Négueb, tout le pays deviendra une plaine. Jérusalem par contre sera rehaussée sans changer de place, depuis la porte de Benjamin jusqu'à l'emplacement de l'ancienne porte, jusqu'à la porte de l'Angle et la tour de Hananéel à côté des pressoirs du roi;"
,"11":"on s'y installera. A Jérusalem on ne craindra plus de malédiction: on y habitera en paix."
,"12":"Mais voici comment Yahvé frappera tous les peuples qui auront attaqué Jérusalem: il fera pourrir leur chair alors qu'ils seront encore debout, leurs yeux pourriront dans leurs orbites et leur langue dans leur bouche."
,"15":"La plaie frappera les chevaux, les mulets, les chameaux, les ânes et tous les animaux de leurs campements.."
,"13":"En ce jour-là Yahvé fera tomber sur eux une grande panique et ils en viendront aux mains, ils se frapperont les uns les autres."
,"14":"Juda participera au combat de Jérusalem; après quoi ils rassembleront les dépouilles de toutes les nations qui les entourent: or, argent et vêtements en quantité."
,"16":"Les survivants de toutes les nations qui seront venues attaquer Jérusalem monteront chaque année pour se prosterner devant le Roi Yahvé Sabaot, ils célébreront la fête des Tentes."
,"17":"Si un peuple ne monte pas à Jérusalem pour se prosterner devant le Roi Yahvé Sabaot, il n'y aura pas de pluie pour lui."
,"18":"Si le peuple égyptien ne monte pas, il n'y aura pas de pluie pour lui, et en plus il sera frappé de cette plaie dont Yahvé frappe les nations qui ne montent pas pour célébrer la fête des Tentes."
,"19":"Voilà comment l'Egypte ou toute autre nation qui ne montera pas pour célébrer la fête des Tentes devra payer son péché."
,"20":"En ce jour-là, même les grelots des chevaux porteront l'inscription: 'Consacré à Yahvé'; les marmites du Temple de Yahvé seront aussi saintes que les coupes pour faire l'aspersion devant l'autel."
,"21":"Quand on offrira un sacrifice, on pourra prendre n'importe quelle marmite de Jérusalem ou de Juda et cuisiner dedans: tout sera consacré à Yahvé Sabaot. En ce jour-là il n'y aura plus de marchands dans le Temple de Yahvé Sabaot."
}`)

}
func FR_LBDCC_LoadVPDTChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Voici les paroles que Moïse adressa à tout Israël au-delà du Jourdain, dans le désert. On était dans la Araba en face de Souf, entre Paran et Tofel, entre Laban, Hasérot et Di-Zahab."
,"2":"Il y a onze jours de marche depuis l'Horeb jusqu'à Qadesh-Barné par le chemin de la Montagne de Séïr."
,"3":"Le premier jour du onzième mois de la quarantième année, Moïse transmit aux Israélites tout ce que Yahvé lui avait ordonné à leur sujet:"
,"4":"c'était après avoir battu Sihon, roi des Amorites qui habitait à Heshbon, et Og, roi du Bashan, qui habitait à Achtarot et à Edréï."
,"5":"On était de l'autre côté du Jourdain, dans le pays de Moab, lorsque Moïse décida d'expliquer cette loi. Voici ce qu'il dit:"
,"6":"Yahvé notre Dieu nous a parlé à l'Horeb. Vous avez suffisamment séjourné, nous a-t-il dit, au pied de cette montagne."
,"7":"Mettez-vous en route maintenant et partez. Pénétrez dans la montagne des Amorites et tous les pays qui l'entourent: la steppe, la montagne, le Bas-Pays, le Négueb et les côtes de la mer, tout le pays de Canaan et le Liban jusqu'au grand fleuve, le fleuve de l'Euphrate."
,"8":"C'est le pays que je mets à votre disposition, le pays que Yahvé a juré à vos pères Abraham, Isaac et Jacob de leur donner, ainsi qu'à leur descendance après eux: allez le conquérir."
,"9":"Je vous ai parlé alors et je vous ai dit: 'Je ne puis tout seul porter ce peuple."
,"10":"Yahvé votre Dieu vous a multipliés et vous êtes aujourd'hui aussi nombreux que les étoiles des cieux."
,"11":"Que Yahvé, le Dieu de vos pères, vous multiplie mille fois plus que vous n'êtes et qu'il vous bénisse comme il l'a dit!"
,"12":"Mais moi, comment porterai-je seul votre charge et le fardeau de vos querelles?"
,"13":"Choisissez parmi vous, dans vos tribus, des hommes sages, intelligents et instruits et je les mettrai à votre tête.'"
,"14":"Vous m'avez répondu: 'Voilà une bonne proposition.'"
,"15":"Alors j'ai pris parmi les chefs de vos tribus des hommes sages et instruits et je les ai placés à votre tête comme responsables: chefs de milliers, chefs de centaines, chefs de cinquantaines, chefs de dizaines, en plus des scribes de vos tribus."
,"16":"En ce temps-là j'ai donné à vos juges cet ordre: 'Vous écouterez vos frères et vous jugerez avec justice les différends qui opposent un homme à son frère ou à un étranger."
,"17":"Vous ne tiendrez pas compte des personnes dans votre jugement. Vous écouterez le petit comme le grand, vous ne craindrez personne, car le jugement est l'affaire de Dieu. Si une affaire est trop difficile pour vous, vous me la soumettrez et je l'étudierai.'"
,"18":"Je vous ai donc dit en ce temps-là tout ce que vous deviez faire."
,"19":"Nous sommes alors partis de l'Horeb et nous avons abordé, comme Yahvé l'ordonnait, ce désert grand et redoutable que vous avez vu, faisant route vers la montagne des Amorites. C'est ainsi que nous sommes arrivés à Qadesh-Barné."
,"20":"Là je vous ai dit: 'Vous voici arrivés à cette montagne des Amorites que Yahvé notre Dieu nous donne."
,"21":"Vois, Yahvé ton Dieu met ce pays à ta disposition, monte, envahis-le comme Yahvé, le Dieu de tes pères, te l'a dit! Ne crains pas, n'aie pas peur.'"
,"22":"Alors vous êtes tous venus me trouver et vous m'avez dit: 'Envoyons des hommes en éclaireurs pour qu'ils nous fassent une reconnaissance du pays: ils nous renseigneront sur la route par laquelle nous devons monter et sur les villes dans lesquelles nous entrerons.'"
,"23":"La chose me parut bonne et je choisis parmi vous douze hommes, un par tribu."
,"24":"Ils se dirigèrent vers la montagne, ils atteignirent le val d'Echkol et ils en firent la reconnaissance."
,"25":"Ils prirent avec eux des produits du pays et ils revinrent nous faire leur rapport. Ils nous dirent: 'C'est un bon pays que Yahvé notre Dieu nous donne.'"
,"26":"Mais vous n'avez pas voulu vous y rendre, vous avez été rebelles à l'ordre de Yahvé votre Dieu."
,"27":"Sous vos tentes vous avez critiqué, vous avez dit: 'C'est parce que Yahvé nous déteste qu'il nous a fait sortir du pays d'Egypte. Il veut nous livrer entre les mains des Amorites et nous faire mourir."
,"28":"Où veut-on nous conduire? Nos frères nous ont découragés, ils disent que c'est un peuple plus puissant et plus nombreux que nous, les hommes sont de très haute taille, les villes sont énormes et leurs remparts s'élèvent jusqu'au ciel. Ils y ont même vu des fils d'Anak.'"
,"29":"Je vous ai dit alors: 'Ne tremblez pas et ne les craignez pas:"
,"30":"Yahvé votre Dieu marchera devant vous, il combattra pour vous comme vous l'avez vu faire en Egypte."
,"31":"Vous l'avez vu au désert: Yahvé votre Dieu vous portait comme un homme porte son fils tout au long de la route que vous avez suivie, jusqu'à votre arrivée en ce lieu."
,"32":"Malgré cela, vous n'avez pas fait confiance à Yahvé votre Dieu."
,"33":"Lui pourtant marchait devant vous, il cherchait pour vous le lieu où vous alliez camper. Le jour, par la nuée, il vous montrait la route que vous deviez suivre, et la nuit c'était un feu.'"
,"34":"Quand Yahvé entendit votre vacarme, il se mit en colère et fit ce serment:"
,"35":"'Pas un homme de cette génération mauvaise ne verra le bon pays que j'ai juré à vos pères de vous donner."
,"36":"Seul Caleb, le fils de Yéfouné, le verra. Ce pays qu'il a foulé, je le lui donnerai et il sera pour ses fils car il m'a suivi fidèlement.'"
,"37":"A cause de vous, Yahvé s'est mis également en colère contre moi. Il m'a dit: 'Toi non plus tu n'entreras pas là-bas!"
,"38":"C'est Josué, fils de Noun, ton serviteur, qui y entrera. Encourage-le, car c'est lui qui mettra Israël en possession du pays."
,"39":"Vos fils, qui aujourd'hui ne savent pas encore choisir entre le bien et le mal, entreront dans ce pays; je le leur donnerai et ils le posséderont."
,"40":"Mais pour vous, demi-tour! Retournez au désert par la route de la Mer des Joncs!'"
,"41":"Vous m'avez répondu alors: 'Nous avons péché contre Yahvé, mais maintenant nous allons monter, et nous combattrons comme Yahvé notre Dieu nous l'a ordonné.' Chacun d'entre vous prit ses armes et vous pensiez que ce serait facile de gravir la montagne."
,"42":"Mais Yahvé me dit: 'Dis-leur de ne pas monter et de ne pas combattre; je ne suis pas au milieu de vous et vous vous feriez écraser par vos ennemis.'"
,"43":"Je vous ai transmis ses paroles, mais vous n'avez pas écouté. Vous avez résisté à l'ordre de Yahvé et vous avez voulu quand même gravir la montagne."
,"44":"Alors les Amorites qui habitent ces hauteurs sont sortis à votre rencontre et ils vous ont poursuivis comme le font les abeilles; ils vous ont taillés en pièces dans Séïr et jusqu'à Horma."
,"45":"A votre retour vous êtes venus pleurer devant Yahvé, mais Yahvé ne vous a pas écoutés. Il n'a pas prêté l'oreille."
,"46":"Alors vous vous êtes installés à Qadesh pour de longs jours et vous savez le temps qu'a duré votre séjour."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Nous avons donc fait demi-tour et nous sommes repartis pour le désert, par la route de la Mer des Joncs, comme Yahvé me l'avait ordonné. Pendant de longs jours nous avons contourné la montagne de Séïr."
,"2":"C'est alors que Yahvé me dit:"
,"3":"'Vous avez suffisamment tourné autour de cette montagne, repartez vers le nord."
,"4":"Tu donneras cet ordre au peuple: Vous allez arriver à la frontière de vos frères, les fils d'Esaü qui habitent en Séïr. Ils auront peur de vous, mais faites bien attention:"
,"5":"ne les attaquez pas, car je ne vous donnerai rien de leur pays, pas même la surface de la plante de vos pieds. Car j'ai donné à Esaü le mont Séïr, il est à lui."
,"6":"Vous leur achèterez donc la nourriture que vous mangerez; vous paierez même l'eau que vous boirez."
,"7":"Car Yahvé ton Dieu t'a béni dans tout ce que tu as entrepris, il avait prévu ta marche dans ce grand désert; voilà quarante ans que Yahvé ton Dieu est avec toi, et tu n'as manqué de rien.'"
,"8":"Nous sommes donc passés à l'écart de nos frères, les fils d'Esaü qui habitent en Séïr. Nous nous sommes détournés de la route de la Araba, d'Elat et d'Ezyon-Guéber, nous avons tourné et nous sommes passés par la route du désert de Moab."
,"9":"Yahvé me dit alors: 'N'attaque pas Moab, ne lui livre pas combat, car je ne te donnerai rien de son pays: j'ai donné Ar aux fils de Lot, il leur appartient.'"
,"10":"(Autrefois ce pays était celui des Emim, peuple grand et nombreux, de haute taille comme les Anakim."
,"11":"On les comptait parmi les Réphaïm, ainsi que les Anakim, mais les Moabites les appelaient les Emim."
,"12":"En Séïr habitaient autrefois les Horites, mais les fils d'Esaü les avaient dépossédés. Ils les avaient tués et s'étaient installés à leur place, comme Israël allait le faire pour le pays que Yahvé lui donnait en possession.)"
,"13":"Maintenant donc, traversez le torrent de Zéred.',Nous l'avons traversé. "
,"14":"De Qadesh-Barné à la traversée du torrent de Zéred, nous avons marché trente-huit ans, le temps que disparaisse du milieu du camp toute la génération des hommes de guerre, comme Yahvé l'avait ordonné."
,"15":"La main de Yahvé se chargea de les faire disparaître du milieu du camp."
,"16":"Après leur disparition du milieu du peuple,"
,"17":"Yahvé me dit:"
,"18":"'Aujourd'hui tu vas passer au-delà de Ar sur la frontière de Moab."
,"19":"Tu te trouveras face à face avec les Ammonites, mais ne les attaque pas, ne leur livre pas combat, car je ne te donnerai rien du pays des Ammonites: je l'ai donné aux fils de Lot, il est à eux."
,"20":"(Ce pays était considéré comme celui des Réphaïm. Les Réphaïm l'habitaient autrefois et les Ammonites les appelaient Zamzoummim."
,"21":"C'était un peuple grand et nombreux, de haute taille comme les Anakim. Mais Yahvé les avait exterminés devant les Ammonites qui les dépouillèrent et s'installèrent à leur place."
,"22":"Il les avait traités de la même façon que les Horites, qui furent exterminés en Séïr par les fils d'Esaü. Ainsi les Ammonites ont habité à la place des Réfaïm jusqu'à ce jour."
,"23":"En ce temps-là les Avvites aussi habitaient des camps en allant vers Gaza, mais les Kaftorim venus de Kaftor les exterminèrent et s'installèrent à leur place.)"
,"24":"Pars maintenant et traverse le torrent d'Arnon. Regarde! J'ai livré entre tes mains Sihon roi de Heshbon, l'Amorite, ainsi que son pays: commence la conquête, engage le combat."
,"25":"A partir d'aujourd'hui je vais répandre la peur devant toi, et tous les peuples sous les cieux seront saisis de crainte devant toi. Ceux qui entendront parler de toi, trembleront et frissonneront de frayeur à cause de toi.'"
,"26":"Du désert de Kédémot, j'ai fait porter ces paroles de paix à Sihon, roi de Heshbon:"
,"27":"'Je dois traverser ton pays, j'irai par la grand-route, je ne m'écarterai ni à droite ni à gauche."
,"28":"Tu me vendras à prix d'argent la nourriture que je mangerai; tu me vendras même l'eau que je boirai. Laisse-moi seulement traverser à pied."
,"29":"Agis envers moi comme l'ont fait les fils d'Esaü qui habitent en Séïr et les Moabites qui habitent à Ar, jusqu'au jour où je traverserai le Jourdain en direction du pays que Yahvé notre Dieu nous donne.'"
,"30":"Mais Sihon, roi de Heshbon, refusa de nous laisser passer sur ses terres. Yahvé votre Dieu avait endurci son esprit et son coeur, pour le livrer entre vos mains ce jour-là."
,"31":"Yahvé me dit alors: 'Regarde! J'ai commencé à livrer Sihon et son pays entre tes mains. Ta première conquête sera celle de son pays.'"
,"32":"Sihon sortit à notre rencontre à Yahas pour combattre avec tout son peuple,"
,"33":"et Yahvé notre Dieu le livra entre nos mains. Nous l'avons écrasé ainsi que ses fils et tout son peuple."
,"34":"A ce moment-là nous avons pris toutes ses villes et nous avons voué à l'anathème chacune de ces villes avec les hommes , les femmes et les petits-enfants. Nous n'avons laissé aucun survivant."
,"35":"Nous avons seulement gardé comme butin le bétail et les dépouilles des villes conquises."
,"36":"Depuis Aroër qui se trouve sur le versant de l'Arnon, et la ville qui est dans le torrent jusqu'à Galaad, aucune ville ne nous a échappé: Yahvé notre Dieu a tout livré entre nos mains."
,"37":"Cependant, comme Yahvé notre Dieu nous avait interdit le pays des Ammonites, le versant du torrent du Yabok et les villes de la montagne, nous ne nous en sommes pas approchés."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Après un détour, nous avons pris la route du Bashan. Og, roi du Bashan, vint à notre rencontre à Edréï pour combattre avec tout son peuple."
,"2":"Alors Yahvé me dit: 'N'aie pas peur! Je te l'ai livré avec tout son peuple et tout son pays. Tu le traiteras comme tu as traité Sihon, roi des Amorites, qui habitait à Heshbon.'"
,"3":"Yahvé notre Dieu nous livra donc Og, roi du Bashan, et tout son peuple. Nous l'avons écrasé au point de ne lui laisser aucun survivant."
,"4":"Nous avons pris toutes ses villes: des soixante villes de toute la région d'Argob, dans le royaume d'Og de Bashan, pas une seule ne nous a résisté."
,"5":"Pourtant, toutes ces villes étaient fortifiées avec de hautes murailles, des portes et des barres. Sans compter les villes non fortifiées qui étaient en très grand nombre."
,"6":"Nous les avons toutes vouées à l'anathème, comme nous l'avions fait pour Sihon, roi de Heshbon, avec les hommes, les femmes et les enfants."
,"7":"Mais nous avons gardé pour nous tout le bétail et le butin de ces villes."
,"8":"Nous avons donc enlevé dans ce temps-là aux deux rois des Amorites le pays qui est au-delà du Jourdain, depuis le torrent de l'Arnon jusqu'au mont Hermon."
,"9":"(Les habitants de Sidon appellent l'Hermon, Siryon, mais les Amorites l'appellent Sénir.)"
,"10":"Nous avons donc pris toutes les villes du Haut-Plateau, tout le Galaad et tout le Bashan jusqu'à Salka et Edréï, capitale d'Og de Bashan."
,"11":"Cet Og de Bashan était resté seul de la race des Réphaïm et c'est son lit de fer long de neuf coudées et large de quatre coudées (des coudées d'homme), qu'on voit encore à Rabba-d'Ammon."
,"12":"En ce temps-là nous avons conquis ce pays. Je l'ai donné à la tribu de Ruben et à la tribu de Gad, depuis Aroër qui est sur le torrent d'Arnon, ainsi que la moitié de la montagne de Galaad avec ses villes."
,"13":"J'ai donné à la moitié de la tribu de Manassé le reste de Galaad et tout le Bashan (le royaume d'Og, tout le district d'Argob avec tout le Bashan. On l'appelait alors le pays des Réphaïm)."
,"14":"Yaïr, fils de Manassé, s'empara de tout le district d'Argob, jusqu'à la frontière des Guéchourites et des Maakatites. Aux villages du Bashan il donna son propre nom: on les appelle encore aujourd'hui les Douars de Yaïr."
,"15":"Quant à Makir, je lui ai donné Galaad."
,"16":"A Ruben et à Gad, j'ai donné le Galaad jusqu'au torrent de l'Arnon avec comme frontière: d'un côté, le milieu du torrent, et du côté des Ammonites, le torrent du Yabok."
,"17":"Je lui ai donné aussi la Araba avec le Jourdain comme frontière, depuis Kinnéret jusqu'à la mer de la Araba qu'on appelle aussi la Mer de Sel, au pied du Pisga à l'est."
,"18":"En ce temps-là je vous ai donné des instructions. Je vous ai dit: 'Yahvé votre Dieu vous a donné ce pays pour que vous le possédiez. Vous tous, hommes courageux, vous passerez en armes devant vos frères Israélites,"
,"19":"mais vos femmes, vos petits-enfants et vos troupeaux qui sont, je le sais, très nombreux, resteront dans les villes que je vous ai données.'"
,"20":"Lorsque Yahvé aura donné à vos frères, comme à vous-mêmes, le repos, lorsqu'ils posséderont eux aussi le pays que Yahvé votre Dieu leur donne au-delà du Jourdain, alors chacun de vous pourra retourner dans l'héritage que je vous ai attribué."
,"21":"En ce temps-là j'ai donné aussi des instructions à Josué. Je lui ai dit: 'Tes yeux voient tout ce que Yahvé votre Dieu a fait à ces deux rois. Yahvé fera de même pour tous les royaumes que vous allez traverser."
,"22":"Ne les craignez donc pas, car Yahvé votre Dieu combat pour vous.'"
,"23":"En ce temps-là j'ai supplié Yahvé:"
,"24":"'Seigneur Yahvé, lui ai-je dit, tu as commencé à montrer à ton serviteur ta grandeur et la puissance de ta main. Quel Dieu dans les cieux ou sur la terre, pourrait faire des oeuvres et des exploits semblables aux tiens?"
,"25":"Aussi maintenant je voudrais passer et voir le bon pays qui est au-delà du Jourdain, cette belle montagne et le Liban.'"
,"26":"Mais Yahvé s'était fâché contre moi à cause de vous et il ne m'écouta pas. Et Yahvé me dit: 'Cela suffit, ne me parle plus de cette affaire!"
,"27":"Tu vas monter au sommet du Pisga, et tu porteras ton regard à l'ouest, au nord, au sud et à l'est. Regarde bien, car tu ne traverseras pas ce Jourdain."
,"28":"Mais donne tes ordres à Josué, encourage-le, rends-le fort: lui passera en tête de ce peuple et le mettra en possession du pays que tu auras vu.'"
,"29":"Après cela, nous sommes restés dans la Vallée en face de Beth-Péor."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Et maintenant Israël, écoute les ordres et les commandements que je vous enseigne, pour les mettre en pratique. Ainsi vous vivrez et vous entrerez, pour le posséder, dans le pays que Yahvé le Dieu de vos pères vous donne."
,"2":"Vous n'ajouterez rien à ce que je vous commande et vous n'en retrancherez rien, mais vous observerez les commandements de Yahvé votre Dieu tels que je vous les donne."
,"3":"Vos yeux ont vu ce que Yahvé a fait à Baal-Péor: tous ceux qui s'étaient mis à la suite du Baal-Péor, Yahvé ton Dieu les a éliminés d'entre vous."
,"4":"Mais vous qui êtes restés fidèles à Yahvé votre Dieu, vous êtes tous en vie aujourd'hui."
,"5":"Regardez, je vous ai enseigné règles et lois comme Yahvé mon Dieu me l'avait ordonné. Mettez-les en pratique dans le pays où vous entrerez et qui sera vôtre."
,"6":"Si vous les observez, si vous les mettez en pratique, elles vous donneront une réputation de sagesse et d'intelligence chez tous les peuples qui entendront parler de ces lois. Ils diront: 'Quelle grande nation! Elle seule a la sagesse et l'intelligence.'"
,"7":"Y a-t-il en effet une nation aussi grande et dont les dieux soient aussi proches que Yahvé notre Dieu l'est pour nous, chaque fois que nous le prions?"
,"8":"Y a-t-il une nation vraiment grande dont les lois et les commandements soient aussi justes que toute cette loi que je vous présente aujourd'hui?"
,"9":"Mais prenez garde! Prenez bien garde à vous, n'oubliez rien de ce que vos yeux ont vu. Conservez tout cela au fond de vous-mêmes tout au long de votre vie et répétez-le à vos fils et aux fils de vos fils."
,"10":"A l'Horeb, quand tu t'es tenu en présence de Yahvé ton Dieu, Yahvé m'a dit: 'Rassemble-moi le peuple pour que je lui fasse entendre mes paroles. Ils apprendront ainsi à me craindre tous les jours qu'ils vivront sur la terre et ils l'enseigneront à leurs fils."
,"11":"Ce jour-là, vous vous êtes approchés, vous êtes venus au pied de la montagne, et la montagne s'embrasa jusqu'au coeur même d'un ciel de ténèbres, de nuages et de tonnerre."
,"12":"Alors Yahvé vous a parlé du milieu du feu; vous entendiez le son de ses paroles mais vous n'avez pas vu d'image, il n'y avait que la voix."
,"13":"Il vous a alors révélé son Alliance, il vous a ordonné de mettre en pratique les Dix Paroles et il les a écrites sur deux tables de pierre."
,"14":"C'est à ce moment-là que Yahvé m'a dit de vous transmettre ses commandements et ses lois, pour que vous les mettiez en pratique dans le pays où vous allez entrer pour le posséder."
,"15":"Prenez bien garde à vous-mêmes! Vous n'avez vu aucune image le jour où Yahvé vous a parlé à l'Horeb, du milieu du feu."
,"16":"N'allez donc pas vous perdre maintenant en vous faisant des idoles, des images, que ce soient des figures d'hommes ou de femmes,"
,"17":"des figures de bêtes qui vivent sur la terre, ou d'oiseaux qui volent dans les cieux,"
,"18":"ou de reptiles qui rampent sur le sol ou de poissons qui cheminent à travers les eaux au-dessous de la terre."
,"19":"Ne vous laissez pas entraîner à adorer ce que vous voyez dans le ciel: le soleil, la lune, les étoiles et toute l'armée des cieux; ne vous prosternez pas devant eux et ne les servez pas. Yahvé ton Dieu les a donnés en partage à tous les peuples qui sont sous les cieux,"
,"20":"mais vous, Yahvé vous a pris. Il vous a fait sortir de cet enfer qu'est l'Egypte, pour que vous soyez son peuple, son héritage, comme vous l'êtes aujourd'hui."
,"21":"Lorsque Yahvé s'est mis en colère contre moi à cause de vous, il a juré que je ne traverserais pas le Jourdain et que je n'entrerais pas dans le bon pays que Yahvé ton Dieu te donne en héritage."
,"22":"Je vais donc mourir ici, je ne traverserai pas le Jourdain; mais vous, vous le passerez et ce bon pays sera vôtre."
,"23":"Prenez garde à ne pas oublier l'Alliance que Yahvé votre Dieu a conclue avec vous. Ne vous faites aucune idole, aucune image, de tout ce que Yahvé ton Dieu t'a interdit."
,"24":"Car Yahvé ton Dieu est un feu dévorant, c'est un Dieu jaloux."
,"25":"Quand tu auras engendré des fils et des petits-fils, quand vous aurez vieilli dans ce pays, il se pourrait que vous tourniez mal et que vous fassiez des idoles, des images. Alors, si vous faites ce qui est mal aux yeux de Yahvé ton Dieu, si vous le mettez en colère,"
,"26":"je le dis aujourd'hui même à la face des cieux et de la terre: vous disparaîtrez rapidement de ce pays. Il doit être vôtre quand vous aurez traversé le Jourdain, mais alors vous n'y prolongerez pas vos jours et vous serez totalement détruits."
,"27":"Yahvé vous dispersera parmi les nations et vous ne serez plus qu'une poignée au milieu des peuples où Yahvé vous conduira."
,"28":"Là, vous servirez des dieux sortis de la main des hommes, des dieux de bois et de pierre, des dieux qui ne voient pas, qui n'entendent pas, qui ne mangent pas et qui ne sentent pas."
,"29":"Là, tu rechercheras Yahvé ton Dieu et tu le trouveras si tu le cherches de tout ton coeur et de toute ton âme."
,"30":"Lorsque tu seras dans l'angoisse, lorsque plus tard toutes ces malédictions se seront réalisées, tu reviendras vers Yahvé ton Dieu et tu écouteras sa voix."
,"31":"Car Yahvé ton Dieu est un Dieu qui pardonne. Il ne t'abandonnera pas, il ne te détruira pas, il n'oubliera jamais l'Alliance qu'il a jurée à tes pères."
,"32":"Interroge les temps anciens, depuis le jour où Dieu créa l'homme sur la terre. Cherche d'une extrémité du ciel à l'autre: est-il jamais rien arrivé de pareil? A-t-on jamais rien entendu de semblable?"
,"33":"A-t-on vu un peuple rester en vie après avoir entendu du milieu du feu la voix de son Dieu, comme tu l'as entendue?"
,"34":"Un Dieu est-il jamais venu se choisir un peuple, l'arrachant des entrailles d'un autre peuple par des épreuves, des signes et des prodiges? Une intervention puissante et de grands coups qui sèment la terreur, c'est bien ce que Yahvé ton Dieu a fait en Egypte devant toi et pour toi."
,"35":"Tu as vu toi-même tout cela, et tu sais maintenant que Yahvé est Dieu et qu'il n'y en a pas d'autre que lui."
,"36":"Dieu t'a fait entendre du haut du ciel sa voix pour t'en imposer, et sur la terre il t'a fait voir son grand feu: tu as entendu ses paroles du milieu du feu."
,"37":"Il l'a fait parce qu'il aimait tes pères; il a choisi leur descendance après eux et il t'a fait sortir d'Egypte par sa présence et sa grande puissance."
,"38":"Il a chassé devant toi des peuplades grandes et puissantes; il t'a fait entrer dans leur pays et te l'a alors donné en héritage."
,"39":"Tu sais donc maintenant, et tu te le rappelleras: Yahvé est Dieu là-haut dans les cieux comme en bas sur la terre, il n'y en a pas d'autre."
,"40":"Observe donc ses lois et ses commandements que je te donne aujourd'hui: ainsi tu seras heureux, toi et tes fils après toi, et tu resteras de longs jours sur la terre que Yahvé ton Dieu te donne.'"
,"41":"Moïse mit à part trois villes de l'autre côté du Jourdain, à l'est."
,"42":"Elles devaient servir de refuge à celui qui aurait tué son prochain involontairement, sans avoir eu de haine envers lui les jours précédents. Si le meurtrier se réfugie dans l'une de ces villes, il aura la vie sauve."
,"43":"Ces villes sont: Béser, dans le désert, sur le Haut-Plateau, pour la tribu de Ruben, Ramot en Galaad, pour la tribu de Gad, et Golan dans le Bashan, pour la tribu de Manassé."
,"44":"Voici la loi que Moïse présenta aux Israélites."
,"45":"Ce sont les préceptes, les lois et les ordonnances que Moïse enseigna aux Israélites lors de leur sortie d'Egypte."
,"46":"On était au-delà du Jourdain, dans la vallée en face de Beth-Péor, dans le pays de Sihon, roi des Amorites, qui habitait Heshbon. Moïse et les Israélites l'avaient battu à leur sortie d'Egypte,"
,"47":"et ils avaient conquis son pays avec le pays d'Og, roi du Bashan. Le territoire de ces deux rois des Amorites était au-delà du Jourdain à l'est."
,"48":"Il s'étendait depuis Aroër sur le bord du torrent de l'Arnon, jusqu'à la montagne de Siryon qui est l'Hermon."
,"49":"Il comprenait aussi toute la Araba au-delà du Jourdain à l'est, jusqu'à la mer de la Araba, au pied du Pisga."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Moïse convoqua tout Israël et lui dit: Ecoute, Israël, les préceptes et les ordonnances que je t'enseigne aujourd'hui, vous les apprendrez et vous veillerez à les mettre en pratique."
,"2":"C'est avec nous que Yahvé notre Dieu a conclu une Alliance à l'Horeb."
,"3":"Yahvé ne l'a pas conclue avec nos pères, mais avec nous qui sommes ici vivants aujourd'hui."
,"4":"Yahvé vous a parlé face à face sur la montagne, du milieu des flammes."
,"5":"Moi, alors, je me tenais entre Yahvé et vous pour vous rapporter la parole de Yahvé, car vous aviez peur du feu, et vous n'êtes pas montés sur la montagne. Il a dit:"
,"6":"'Je suis Yahvé ton Dieu, qui t'ai fait sortir du pays d'Egypte, de la maison de l'esclavage."
,"7":"Tu n'auras pas d'autre Dieu que moi."
,"8":"Tu ne feras pas de statue à l'image des choses qui sont là-haut dans le ciel, en bas sur la terre ou dans les eaux sous la terre."
,"9":"Tu ne te prosterneras pas devant celles-ci et tu ne les serviras pas, car moi, Yahvé ton Dieu, je suis un Dieu jaloux. Je punis la faute des pères sur les fils, les petits-fils et les arrière-petits-fils lorsqu'ils me haïssent."
,"10":"Mais je maintiens ma faveur jusqu'à la millième génération à ceux qui m'aiment et gardent mes commandements."
,"11":"Tu ne feras pas un mauvais usage du Nom de Yahvé ton Dieu, car Yahvé ne tient pas quitte celui qui fait un mauvais usage de son nom."
,"12":"Observe le jour du sabbat et sanctifie-le comme Yahvé ton Dieu te l'a ordonné."
,"13":"Durant six jours tu serviras et tu feras tout ton travail,"
,"14":"mais le septième jour est un repos en l'honneur de Yahvé ton Dieu. Tu ne feras aucun travail, ni toi, ni ton fils, ni ta fille, ni ton serviteur, ni ta servante, ni ton boeuf, ni ton âne, ni aucune des bêtes de somme, ni l'étranger qui habite chez toi. Ainsi ton serviteur et ta servante se reposeront comme toi."
,"15":"Tu te souviendras que tu as été esclave en Egypte. Yahvé ton Dieu t'en a fait sortir à main forte, en frappant des coups puissants; c'est pourquoi Yahvé ton Dieu t'a ordonné de te reposer le jour du Sabbat."
,"16":"Entoure d'égards ton père et ta mère comme Yahvé ton Dieu te l'a ordonné. Ainsi tu vivras longtemps et les choses iront bien pour toi sur la terre que Yahvé ton Dieu te donne."
,"17":"Tu ne tueras pas."
,"18":"Tu ne commettras pas d'adultère."
,"19":"Tu ne voleras pas."
,"20":"Tu ne porteras pas de faux témoignage contre ton prochain."
,"21":"Tu ne chercheras pas à prendre la femme de ton prochain; tu ne désireras pas la maison de ton prochain, ni son champ, ni son serviteur, ni sa servante, ni son boeuf, ni son âne; en un mot, rien de ce qui est à lui.'"
,"22":"Telles sont les paroles que Yahvé a dites lorsque vous étiez rassemblés au pied de la montagne. Il les a prononcées d'une voix puissante, du milieu du feu, de la nuée et de la brume, et il n'a rien ajouté. Puis il a écrit ces paroles sur deux tables de pierre et me les a données."
,"23":"Quand vous avez entendu la voix qui sortait des ténèbres, alors que la montagne était tout en feu, vos chefs de tribus et vos anciens sont tous venus vers moi."
,"24":"Vous m'avez dit: 'Yahvé notre Dieu vient de nous révéler sa Gloire et sa puissance, et nous avons entendu sa voix du milieu du feu. Nous en sommes témoins: aujourd'hui Dieu a parlé à des humains et ils sont restés en vie."
,"25":"Mais si nous continuons d'entendre la voix de Yahvé notre Dieu, nous sommes sûrs de mourir, car ce grand feu va nous dévorer."
,"26":"Quel est le mortel qui est resté en vie après avoir entendu, comme nous, la voix du Dieu vivant parlant du milieu du feu?"
,"27":"Approche-toi donc pour entendre tout ce que dit Yahvé notre Dieu; tu nous rapporteras ensuite tout ce qu'il t'aura dit, nous l'écouterons et nous le ferons.'"
,"28":"Yahvé entendit ces paroles pendant que vous me parliez, et il me dit: 'J'ai entendu toutes les paroles que ce peuple te disait. Tout ce qu'ils ont dit est juste."
,"29":"Si seulement ils pouvaient être toujours aussi bien disposés pour me craindre et pour observer toujours tous mes commandements! Alors tout irait bien toujours pour eux et pour leurs fils."
,"30":"Va donc leur dire de retourner à leurs tentes,"
,"31":"mais toi tu vas rester ici avec moi, et je te dirai tous les commandements, les ordonnances et les règles que tu leur apprendras, pour qu'ils les mettent en pratique dans le pays que je leur donne en possession.'"
,"32":"Vous veillerez donc à faire ce que Yahvé votre Dieu vous a ordonné. Ne vous détournez ni à droite ni à gauche;"
,"33":"suivez en tout la voie que Yahvé votre Dieu vous a tracée. Ainsi vous vivrez, vous réussirez et vous connaîtrez de longs jours dans le pays qui sera vôtre."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Voici les commandements, les préceptes et les règles que Yahvé a ordonné de vous apprendre: vous les mettrez en pratique dans le pays où vous allez entrer et qui sera vôtre."
,"2":"Tu craindras Yahvé ton Dieu, toi, ton fils et ton petit-fils, et tu observeras tous les jours de ta vie ces préceptes et ces commandements que je te donne. Ainsi tu connaîtras des jours nombreux."
,"3":"Tu écouteras, Israël, et tu auras soin de mettre en pratique ce qui doit être pour toi la source du bonheur et de la prospérité dans ce pays où ruissellent le lait et le miel: ainsi me l'a dit Yahvé, le Dieu de tes pères."
,"4":"Ecoute, Israël, Yahvé notre Dieu est Yahvé-Unique."
,"5":"Tu aimeras Yahvé ton Dieu, de tout ton coeur, de toute ton âme et de tout ton pouvoir."
,"6":"Ces paroles que je te dicte aujourd'hui resteront gravées sur ton coeur."
,"7":"Tu les enseigneras à tes fils; tu en parleras, que tu sois assis dans ta maison ou que tu marches sur la route, lorsque tu te couches et lorsque tu te lèves."
,"8":"Tu les attacheras comme un signe sur ta main, elles seront comme un bandeau entre tes yeux."
,"9":"Tu les écriras sur les montants de ta maison et sur tes portes."
,"10":"Lorsque Yahvé ton Dieu t'aura fait entrer au pays qu'il a juré à tes pères Abraham, Isaac et Jacob de te donner, avec des villes grandes et belles que tu n'as pas bâties,"
,"11":"des maisons pleines de toutes sortes de biens que tu n'as pas remplies, des citernes que tu n'as pas creusées, des vignes et des oliviers que tu n'as pas plantés mais dont tu mangeras les fruits; lorsque tu seras comblé,"
,"12":"garde-toi d'oublier Yahvé qui t'a fait sortir du pays d'Egypte, de la maison de l'esclavage."
,"13":"Tu craindras Yahvé ton Dieu, tu le serviras et c'est par son nom que tu jureras."
,"14":"Vous ne suivrez pas d'autres dieux, ces dieux des nations qui sont autour de vous."
,"15":"Car Yahvé ton Dieu est au milieu de toi et c'est un Dieu jaloux. Si la colère de Yahvé ton Dieu s'enflammait contre toi, il te supprimerait de la surface de la terre."
,"16":"Vous ne mettrez pas au défi Yahvé votre Dieu comme vous l'avez fait à Massa."
,"17":"Vous observerez fidèlement les commandements de Yahvé votre Dieu, les ordonnances et les règles qu'il vous a commandées."
,"18":"Tu feras ce qui est juste et bon aux yeux de Yahvé. Ainsi, le bonheur viendra sur toi et tu parviendras à conquérir le bon pays que Yahvé a promis à vos pères par serment."
,"19":"Vous repousserez devant vous tous vos ennemis, comme Yahvé l'a dit."
,"20":"Demain, lorsque ton fils te posera cette question: 'Que sont ces lois, ces ordonnances, ces préceptes que vous a donnés Yahvé votre Dieu?'"
,"21":"tu répondras à ton fils: 'Nous étions les esclaves de Pharaon en Egypte, et Yahvé nous a fait sortir d'Egypte à main forte."
,"22":"Sous nos yeux en Egypte, Yahvé a accompli des signes, des prodiges grands et redoutables, contre Pharaon et contre toute sa maison."
,"23":"Il nous a fait sortir de là, pour nous faire entrer dans le pays qu'il avait juré à nos pères de nous donner."
,"24":"C'est alors que Yahvé nous a ordonné de pratiquer tous ces préceptes et de craindre Yahvé notre Dieu; ainsi tout ira bien pour nous et nous vivrons, comme aujourd'hui."
,"25":"Si nous pratiquons fidèlement tous ces commandements en serviteurs de Yahvé notre Dieu, comme il nous l'a commandé, nous serons justes à ses yeux."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Yahvé ton Dieu va te faire entrer dans le pays dont tu prendras possession. Devant toi il chassera de nombreuses peuplades: les Hittites, les Guirgachites, les Amorites, les Cananéens, les Périsites, les Hivvites et les Jébusites, sept nations plus nombreuses et plus fortes que toi."
,"2":"Lorsque Yahvé ton Dieu les aura livrés entre tes mains et que tu les auras écrasés, tu les voueras à l'anathème. Tu ne concluras pas d'alliance avec eux et tu n'auras pas pitié d'eux."
,"3":"Tu ne feras pas de mariage avec ces gens, tu ne donneras pas ta fille à l'un de leurs fils, et tu ne prendras pas pour ton fils une de leurs filles."
,"4":"Car elle détournerait ton fils de me suivre et il en viendrait à suivre d'autres dieux. Alors la colère de Yahvé s'enflammerait contre vous, et il vous ferait bien vite disparaître."
,"5":"Voici au contraire ce que vous leur ferez: vous démolirez leurs autels, vous renverserez leurs pierres dressées, vous abattrez leurs pieux sacrés et vous jetterez au feu leurs idoles."
,"6":"Tu es un peuple consacré à Yahvé ton Dieu. Il t'a choisi pour que tu sois son peuple à lui entre tous les peuples de la terre."
,"7":"Si Yahvé s'est attaché à vous et vous a choisis, ce n'est pas que vous soyez plus nombreux que les autres peuples, au contraire vous êtes le plus petit de tous les peuples."
,"8":"Mais c'est parce que Yahvé vous aime, parce qu'il a voulu tenir la promesse qu'il avait faite à vos pères. Alors, Yahvé vous a fait sortir par sa main puissante, il vous a libérés de la maison de l'esclavage, de la main du Pharaon, roi d'Egypte."
,"9":"Reconnais donc que c'est Yahvé ton Dieu qui est Dieu. Il est le Dieu fidèle qui maintient son Alliance et sa faveur jusqu'à mille générations pour ceux qui l'aiment et qui gardent ses commandements."
,"10":"Mais il punit sans tarder ceux qui le détestent et il se retourne contre eux."
,"11":"Aussi tu observeras les commandements, les lois et les ordonnances que je te donne aujourd'hui et tu les mettras en pratique."
,"12":"Si tu écoutes les commandements de Yahvé ton Dieu, si tu les gardes et les mets en pratique, lui à son tour te gardera l'Alliance et la faveur qu'il a promises par serment à tes pères."
,"13":"Il t'aimera, il te bénira, il te multipliera. Il bénira le fruit de tes entrailles et le fruit de ton sol, ton blé, ta vigne et ton huile fraîche, les petits de tes vaches et de tes brebis, sur la terre qu'il a promise à tes pères de te donner."
,"14":"Tu seras béni plus que tous les autres peuples. Il n'y aura chez toi, ni bête stérile, ni femme stérile."
,"15":"Yahvé détournera de toi toute maladie, toutes ces redoutables épidémies que tu as connues en Egypte. Il les chassera loin de toi et il les enverra sur tous ceux qui le détestent."
,"16":"Tu extermineras tous les peuples que Yahvé ton Dieu te livrera: pour eux ton oeil sera sans pitié. Et tu ne serviras pas leurs dieux, car ils seraient un piège pour toi."
,"17":"Tu diras peut-être: Ces peuplades sont plus nombreuses que moi, comment pourrai-je les chasser?"
,"18":"Ne crains pas! Rappelle-toi ce que Yahvé ton Dieu a fait au Pharaon et à toute l'Egypte."
,"19":"Rappelle-toi les grandes épreuves que tes yeux ont vues, les signes et les prodiges par lesquels Yahvé ton Dieu t'a fait sortir à main forte, en frappant de grands coups. Yahvé ton Dieu fera de même à l'égard de tous les peuples devant lesquels tu trembles."
,"20":"Il enverra même contre eux les frelons, pour faire mourir ceux qui resteraient encore ou qui se seraient cachés devant toi."
,"21":"Tu ne trembleras donc pas devant eux, car Yahvé ton Dieu est au milieu de toi, et c'est un Dieu grand et terrible."
,"22":"Yahvé ton Dieu chassera peu à peu ces peuplades devant toi; il ne faudrait pas que tu les supprimes rapidement, sinon les bêtes sauvages se multiplieraient pour ton malheur."
,"23":"Yahvé ton Dieu te les livrera et les mettra en fuite jusqu'à ce qu'elles aient disparu."
,"24":"Il livrera leurs rois entre tes mains et tu effaceras leurs noms de dessous les cieux. Nul ne tiendra devant toi jusqu'au jour où tu les auras fait disparaître."
,"25":"Vous jetterez au feu les idoles de leurs dieux. Tu ne rechercheras pas l'argent ni l'or dont elles sont recouvertes, tu ne prendras rien pour toi. Car c'est une horreur au regard de Yahvé ton Dieu, et cela deviendrait vite un piège pour toi."
,"26":"Tu ne dois pas le faire entrer dans ta maison car c'est une chose maudite; sinon toi aussi tu serais maudit. Tu dois avoir tout cela en horreur, tu dois le détester, car c'est maudit."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Vous veillerez à mettre en pratique tous les commandements que je vous donne aujourd'hui. Ainsi vous vivrez, vous vous multiplierez, vous entrerez dans le pays que Yahvé a juré à vos pères de vous donner, et il sera vôtre."
,"2":"Tu te souviendras de tout le chemin par lequel Yahvé ton Dieu t'a fait marcher pendant ces quarante ans dans le désert. Il t'a humilié, il t'a mis à l'épreuve pour connaître le fond de ton coeur, pour voir si tu gardais ou non ses commandements."
,"3":"Il t'a humilié et t'a fait connaître la faim, puis il t'a donné à manger la manne: tu ne la connaissais pas, tes pères non plus. Il voulait t'apprendre que l'homme ne vit pas seulement de pain, mais que tout ce qui sort de la bouche de Dieu est vie pour l'homme. "
,"4":"Durant ces quarante ans ton vêtement ne s'est pas usé sur toi, ton pied n'a pas enflé."
,"5":"Reconnais donc que Yahvé ton Dieu te corrige, comme un homme corrige son fils."
,"6":"Tu observeras les commandements de Yahvé ton Dieu, tu marcheras dans ses voies et tu le craindras."
,"7":"Yahvé ton Dieu va te faire entrer dans un bon pays, pays de torrents, de sources d'eau qui jaillissent dans les vallées et dans les montagnes;"
,"8":"terre du blé et de l'orge, de la vigne, du figuier et du grenadier, pays de l'olivier, de l'huile et du miel;"
,"9":"terre où le pain ne te sera pas mesuré et où tu ne manqueras de rien; terre dont les pierres sont du fer et d'où tu extrairas le cuivre dans la montagne."
,"10":"Tu mangeras, tu seras rassasié, et tu béniras Yahvé ton Dieu dans le bon pays qu'il te donnera."
,"11":"Garde-toi alors d'oublier Yahvé ton Dieu et de délaisser ses commandements, ses ordonnances et ses règles que je t'ordonne aujourd'hui."
,"12":"Quand tu mangeras et seras comblé, quand tu auras construit de belles maisons et que tu les habiteras,"
,"13":"quand ton gros ou petit bétail se multipliera, quand tu auras de l'argent et de l'or en quantité, et que tout ce qui est à toi ira en se développant,"
,"14":"que tout cela ne te remplisse pas d'orgueil. N'oublie pas Yahvé ton Dieu qui t'a fait sortir du pays d'Egypte, de la maison de l'esclavage, "
,"15":"te faisant traverser ce désert grand et redoutable, avec ses serpents brûlants et ses scorpions, ce pays de la soif où l'on ne trouve pas d'eau. Mais pour toi il a fait jaillir l'eau de la roche dure,"
,"16":"et dans ce désert il t'a nourri de la manne que tes pères ne connaissaient pas. Il t'a donc humilié et mis à l'épreuve pour mieux te combler par la suite."
,"17":"Ne te dis surtout pas: 'J'ai acquis tous ces biens par moi-même, par mon travail.'"
,"18":"Souviens-toi plutôt de Yahvé ton Dieu: c'est lui qui t'a donné la force pour acquérir cette richesse. Sois fidèle à l'Alliance qu'il a promise par serment à tes pères."
,"19":"Si tu en venais à oublier Yahvé ton Dieu, si tu suivais d'autres dieux pour les servir et te prosterner devant eux, je te le dis aujourd'hui solennellement, tu périras."
,"20":"Pour n'avoir pas écouté la voix de Yahvé votre Dieu, vous périrez comme les peuplades que Yahvé a exterminées devant vous."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Ecoute, Israël, aujourd'hui tu vas traverser le Jourdain, tu vas déloger des nations plus grandes et plus puissantes que toi. Leurs villes sont grandes et leurs murailles s'élèvent jusqu'au ciel,"
,"2":"leur peuple est nombreux et de haute taille, c'est la race des Anakim (tu les connais et tu as entendu dire: Qui peut résister aux fils d'Anak?)"
,"3":"Mais tu dois savoir que Yahvé ton Dieu passera lui-même devant toi comme un feu dévorant. Il exterminera ces peuplades, il te les soumettra pour que tu les dépouilles et que tu les élimines rapidement comme Yahvé te l'a dit."
,"4":"Mais lorsque Yahvé ton Dieu les aura chassées devant toi, ne dis pas: 'Je méritais bien que Yahvé me fasse venir et conquérir ce pays.' Car Yahvé chasse ces peuplades devant toi pour les punir de leurs fautes."
,"5":"Ce n'est ni ton mérite, ni ta bonne conscience qui te font conquérir ce pays. Yahvé ton Dieu chasse ces nations devant toi pour punir leurs fautes et pour accomplir la promesse jurée à tes pères Abraham, Isaac et Jacob."
,"6":"Sache-le donc bien, ce n'est pas à cause de tes mérites que Yahvé ton Dieu te donne ce bon pays et que tu le possèdes, car tu es un peuple qui fait la forte tête."
,"7":"Souviens-toi, ne l'oublie pas, tu as irrité Yahvé ton Dieu dans le désert, depuis le jour où tu es sorti du pays d'Egypte jusqu'à ton arrivée en ce lieu. Sans cesse, vous vous êtes révoltés contre Yahvé."
,"8":"Vous avez irrité Yahvé à l'Horeb, et Yahvé s'est mis en colère contre vous au point de vouloir vous exterminer."
,"9":"J'étais alors monté sur la montagne pour recevoir les tables de pierre, les tables de l'Alliance que Yahvé concluait avec vous, et j'étais resté sur la montagne quarante jours et quarante nuits sans manger de pain et sans boire d'eau."
,"10":"Alors Yahvé m'a donné les deux tables de pierre écrites du doigt de Dieu. Toutes ses paroles y étaient écrites, toutes celles que Yahvé avait dites devant vous sur la montagne, du milieu du feu, le jour où vous étiez rassemblés."
,"11":"Au bout de quarante jours et de quarante nuits, Yahvé m'a donné les deux tables de pierre, les tables de l'Alliance."
,"12":"Puis il m'a dit: 'Lève-toi, descends vite, car ton peuple que j'ai fait sortir d'Egypte a déjà mal tourné. Tout de suite ils se sont détournés de la voie que je leur avais ordonnée, ils se sont fait une idole de métal fondu.'"
,"13":"Yahvé me dit encore: 'J'ai vu que ce peuple a la tête dure."
,"14":"Laisse-moi faire, je vais les exterminer et j'effacerai leurs noms de dessous les cieux, puis je ferai sortir de toi une nation plus puissante et plus nombreuse que celle-là.'"
,"15":"Je suis alors redescendu de la montagne qui était tout en feu, je tenais de mes deux mains les deux tables de l'Alliance."
,"16":"Alors j'ai vu que vous aviez péché contre Yahvé votre Dieu, vous vous étiez fait un veau de métal fondu. Vous n'aviez vraiment pas tardé à vous détourner de la voie que Yahvé vous avait indiquée."
,"17":"J'ai pris les tables à deux mains, je les ai jetées à terre et je les ai brisées sous vos yeux."
,"18":"Puis je me suis jeté à terre devant Dieu et, comme la première fois, je suis resté quarante jours et quarante nuits sans manger de pain et sans boire d'eau, à cause de votre péché: vous aviez fait ce qui est mal aux yeux de Yahvé et vous l'aviez irrité."
,"19":"Je tremblais, pensant à la colère et à la fureur de Yahvé envers vous. Il voulait vous exterminer mais, une fois encore, Yahvé m'a écouté."
,"20":"Yahvé se mit aussi en colère contre Aaron, il voulait le faire mourir. Pour Aaron aussi, je me suis mis en prière."
,"21":"J'ai pris votre péché, ce veau que vous aviez fabriqué, et je l'ai jeté au feu; je l'ai fait passer par la meule, je l'ai réduit en poudre et j'ai jeté cette poudre dans le torrent qui descend de la montagne."
,"22":"Ce fut pareil à Tabéra, à Massa, et à Kibrot-Ha-Taava: vous avez irrité Yahvé."
,"23":"Lorsque Yahvé vous a envoyés de Qadesh Barné en vous disant: 'Montez et prenez possession du pays que je vous ai donné!', vous vous êtes révoltés contre les ordres de Yahvé votre Dieu; vous n'avez pas eu confiance en lui et vous ne l'avez pas écouté."
,"24":"Depuis le jour où je vous ai connus vous avez été rebelles à Yahvé."
,"25":"Je me suis donc jeté à terre devant Yahvé. Oui, pendant quarante jours et quarante nuits j'étais à terre devant Yahvé, car il parlait de vous exterminer."
,"26":"J'ai supplié Yahvé, je lui ai dit: 'Seigneur Yahvé, ne détruis pas ce peuple qui est ton bien propre, que tu t'es acquis par ta puissance, que tu as fait sortir d'Egypte à main forte."
,"27":"Souviens-toi de tes serviteurs Abraham, Isaac et Jacob, et oublie que ce peuple a été insupportable, mauvais et pécheur."
,"28":"Sinon l'on dira au pays dont tu nous as délivrés: Yahvé n'a pas été capable de les faire entrer dans le pays qu'il leur avait promis; les Israélites l'ont tellement dégoûté, qu'après les avoir fait sortir il les a laissés mourir dans le désert."
,"29":"Rappelle-toi qu'ils sont ton peuple et ton bien propre, et que tu les as fait sortir par la force, en frappant de grands coups."
}`)
	CurrentBook.AddChapter(10, `{
"1":"En ce temps-là Yahvé me dit: 'Taille-toi deux tables de pierre comme les premières, et remonte vers moi sur la montagne. Puis tu te feras une arche de bois."
,"2":"J'écrirai sur ces tables les paroles qui étaient inscrites sur les premières tables que tu as brisées, et tu les mettras dans l'Arche.'"
,"3":"J'ai donc fabriqué une arche en bois d'acacia et j'ai taillé deux tables de pierre comme les premières. Après quoi j'ai gravi la montagne, ayant en mains les deux tables."
,"4":"Yahvé écrivit alors sur les tables le même texte que sur les premières, c'est-à-dire les Dix Paroles que Yahvé vous avait dites sur la montagne, du milieu du feu, au jour de l'assemblée. Et il me les donna."
,"5":"C'est ainsi que je suis redescendu de la montagne; j'ai placé les tables dans l'Arche que j'avais fabriquée, comme Yahvé l'avait ordonné, et elles y sont encore."
,"6":"(Les Israélites partirent des puits des Béné-Yaakan pour Moséra. C'est là que mourut Aaron et qu'il fut enterré; Eléazar, son fils, lui succéda comme prêtre."
,"7":"Ils partirent de là pour Goudgoda, et de Goudgoda ils allèrent à Yotbata, terre riche en eau."
,"8":"Là Yahvé mit à part la tribu de Lévi pour porter l'Arche de l'Alliance et se tenir en sa présence: jusqu'à ce jour ils le servent et bénissent en son Nom."
,"9":"C'est pourquoi Lévi n'a pas eu de part ni d'héritage avec ses frères, car Yahvé est son héritage comme Yahvé ton Dieu le lui a dit.)"
,"10":"Je m'étais donc tenu sur la montagne durant quarante jours et quarante nuits et, cette fois encore, Yahvé m'avait écouté, il avait renoncé à te détruire."
,"11":"Alors Yahvé m'a dit: 'Passe à la tête de ce peuple! qu'il entre et qu'il prenne possession du pays que j'ai juré à leurs pères de leur donner.'"
,"12":"Et maintenant Israël, que te demande Yahvé ton Dieu? Tout simplement de craindre Yahvé ton Dieu, de marcher dans toutes ses voies, de l'aimer et de le servir de tout ton coeur et de toute ton âme."
,"13":"Observe les commandements de Yahvé et les ordonnances que je te donne aujourd'hui, et tout ira bien pour toi."
,"14":"Les cieux, les cieux des cieux, la terre et tout ce qu'elle contient, appartiennent à Yahvé ton Dieu."
,"15":"Pourtant, ce n'est qu'à tes pères que Yahvé s'est attaché pour les aimer. Et après eux il vous a choisis, vous, leur descendance, de préférence à tous les peuples, comme vous le voyez aujourd'hui."
,"16":"Il vous faut donc une autre circoncision, la purification du coeur, et ne plus faire la forte tête."
,"17":"Car Yahvé, votre Dieu, est le Dieu des Dieux et le Seigneur des Seigneurs. Il est le Dieu grand, puissant et redoutable, qui ne fait pas de faveur et n'accepte pas de cadeau."
,"18":"Il fait droit à l'orphelin et à la veuve, il aime l'étranger et lui donne le pain et le vêtement."
,"19":"Vous aimerez donc l'étranger, car vous-mêmes avez été des étrangers en Egypte."
,"20":"Tu craindras Yahvé ton Dieu, tu le serviras, tu t'attacheras à lui et c'est par son Nom que tu jureras."
,"21":"C'est à lui qu'ira ta louange, car il est ton Dieu, qui a fait pour toi les choses grandes et redoutables que tes yeux ont vues."
,"22":"Quand tes pères sont descendus en Egypte, ils étaient soixante-dix, et maintenant Yahvé ton Dieu t'a rendu aussi nombreux que les étoiles des cieux."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Tu aimeras donc Yahvé ton Dieu et tu observeras chaque jour ses ordonnances, ses préceptes, ses lois et ses commandements."
,"2":"Vous comprenez aujourd'hui les leçons de Yahvé votre Dieu; ce sera différent pour vos fils qui n'ont pas connu ni vu sa puissance, sa main forte et ses coups redoutables,"
,"3":"les signes et les merveilles qu'il a faites au milieu de l'Egypte contre le Pharaon, roi d'Egypte et tout son pays."
,"4":"Rappelez-vous ce qu'il a fait à l'armée d'Egypte, à ses chevaux et à ses chars, quand ils vous poursuivaient et qu'il a fait déborder sur eux les eaux de la mer des Joncs: Yahvé les a fait périr."
,"5":"Vous savez ce qu'il a fait pour vous dans le désert jusqu'à votre arrivée en ce lieu,"
,"6":"comment il a traité Datan et Abiram, fils d'Eliab, fils de Ruben, lorsque la terre a ouvert sa bouche et les a engloutis sous le regard d'Israël avec leurs familles, leurs tentes et tous ceux qui s'étaient ralliés à leur cause:"
,"7":"Vous avez vu de vos yeux toute cette oeuvre puissante que Yahvé a accomplie."
,"8":"Vous observerez donc toutes les ordonnances que je vous commande aujourd'hui: ainsi vous serez forts et vous entrerez dans le pays qui deviendra vôtre."
,"9":"Vos jours seront nombreux sur le sol que Yahvé a juré à vos pères de leur donner, et il en sera de même pour votre descendance dans ce pays où ruissellent le lait et le miel."
,"10":"Le pays où tu vas entrer pour en prendre possession, n'est pas comme l'Egypte d'où tu es sorti. Là-bas, quand tu semais la graine, tu devais irriguer en faisant des rigoles avec ton pied, comme dans un jardin à légumes."
,"11":"Mais le pays où tu vas passer pour le conquérir, est un pays de montagnes et de vallées qui reçoit ses eaux de la pluie du ciel."
,"12":"C'est un pays dont Yahvé ton Dieu prend soin et sur lequel il a sans cesse les yeux levés, du commencement jusqu'à la fin de l'année."
,"13":"Si vous écoutez bien les commandements que je vous donne aujourd'hui, si vous aimez Yahvé votre Dieu, si vous le servez de tout votre coeur et de toute votre âme,"
,"14":"j'enverrai sur votre pays la pluie en son temps: la pluie d'automne et la pluie de printemps. Vous récolterez votre blé, votre raisin et votre huile fraîche."
,"15":"Je ferai pousser dans vos champs l'herbe pour vos troupeaux, vous mangerez et vous serez rassasiés."
,"16":"Mais attention, ne vous laissez pas séduire, ne vous laissez pas détourner, ne servez pas d'autres dieux et ne vous prosternez pas devant eux."
,"17":"Sinon la colère de Yahvé s'enflammera contre vous et il fermera le ciel. Il n'y aura plus de pluie et la terre ne donnera plus sa récolte; et vous, vous dépérirez rapidement dans ce bon pays que Yahvé vous donne."
,"18":"Vous graverez donc ces paroles que je vous dicte sur votre coeur et dans votre âme, vous les attacherez comme un signe sur votre main, et elles seront comme un bandeau entre vos yeux."
,"19":"Vous les enseignerez à vos fils. Tu les leur répéteras lorsque tu seras assis dans ta maison, lorsque tu marcheras sur le chemin, quand tu te coucheras ou te lèveras."
,"20":"Tu les écriras sur les montants de ta maison et sur tes portes."
,"21":"Ainsi tes jours et les jours de tes fils seront nombreux sur cette terre que Yahvé a juré à vos pères de leur donner. Alors vous durerez tout autant que les cieux au-dessus de la terre."
,"22":"Si vous observez toutes ces ordonnances que je vous commande de mettre en pratique, si vous aimez Yahvé votre Dieu et marchez dans toutes ses voies, si vous vous attachez à lui,"
,"23":"Yahvé chassera toutes ces peuplades devant vous; vous dépouillerez des peuplades plus grandes et plus puissantes que vous."
,"24":"Tout endroit que la plante de vos pieds aura foulé, sera à vous, depuis le désert et le Liban, depuis le grand Fleuve, l'Euphrate, jusqu'à la mer Occidentale: ce seront là vos frontières."
,"25":"Personne ne vous résistera. Yahvé votre Dieu vous l'a dit, il sèmera devant vous la crainte et la terreur sur toute terre où vous mettrez le pied."
,"26":"Tu vois que je mets aujourd'hui devant vous la bénédiction et la malédiction:"
,"27":"la bénédiction, si vous obéissez aux commandements de Yahvé votre Dieu que je vous donne aujourd'hui;"
,"28":"la malédiction, si vous n'obéissez pas aux commandements de Yahvé votre Dieu, si vous vous détournez de la voie que je vous ai montrée en ce jour pour vous mettre à la traîne d'autres dieux que vous n'avez pas connus."
,"29":"Lorsque Yahvé votre Dieu vous aura fait entrer dans le pays que vous allez posséder, vous prononcerez la bénédiction sur le mont Garizim et la malédiction sur le mont Ebal."
,"30":"Ces montagnes sont de l'autre côté du Jourdain, derrière la route occidentale, au pays des Cananéens qui habitent dans la Araba en face de Guilgal, à côté du Térébinthe de Moré."
,"31":"Vous allez donc traverser le Jourdain pour conquérir le pays que Yahvé votre Dieu vous donne, vous le posséderez et vous y habiterez."
,"32":"Vous aurez soin alors d'observer toutes ces lois et toutes ces ordonnances que je vous expose aujourd'hui."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Voici les lois et les commandements que vous aurez soin de mettre en pratique tous les jours de votre vie dans le pays que Yahvé, le Dieu de vos pères, vous donne pour qu'il soit bien à vous."
,"2":"Vous ferez disparaître tous les lieux où les peuplades que vous allez dépouiller ont servi leurs propres dieux: sur les hautes montagnes, sur les collines et sous les arbres verts."
,"3":"Vous abattrez leurs autels, vous briserez leurs pierres dressées, vous jetterez au feu leurs pieux sacrés et vous briserez les idoles de leurs dieux; vous ferez disparaître leurs noms de ce lieu."
,"4":"Vous n'aurez rien de semblable pour Yahvé votre Dieu."
,"5":"Au contraire, vous fréquenterez le lieu que Yahvé votre Dieu aura choisi au milieu de toutes vos tribus. C'est là que vous irez, car c'est là qu'il a fait habiter son Nom."
,"6":"Là vous offrirez vos holocaustes et vos sacrifices, vos dîmes et vos dons, vos offrandes votives et volontaires. Là vous amènerez les premiers-nés de votre gros et de votre petit bétail."
,"7":"Là vous mangerez en présence de Yahvé votre Dieu et vous ferez la fête, vous et vos familles, pour tout ce que vous aurez reçu comme une bénédiction de Yahvé votre Dieu."
,"8":"Vous ne ferez pas comme nous le faisons ici, où chacun agit selon ce qui lui semble bon,"
,"9":"car nous ne sommes pas encore arrivés au lieu de repos et à l'héritage que nous donne Yahvé notre Dieu."
,"10":"Mais vous allez traverser le Jourdain. Vous allez habiter dans le pays que Yahvé votre Dieu remet entre vos mains, et lui fera que vos ennemis vous laissent en paix sur toutes vos frontières. Lorsque vous habiterez en paix,"
,"11":"vous offrirez tout ce que je vous demande dans le lieu que Yahvé votre Dieu aura choisi pour y faire habiter son Nom: vos holocaustes et vos sacrifices, vos dîmes, vos dons et les offrandes de choix que vous présentez à Yahvé à l'occasion d'un voeu."
,"12":"Là vous ferez la fête en présence de Yahvé votre Dieu, vous, vos fils et vos filles, vos serviteurs et vos servantes, sans oublier le Lévite qui habite au milieu de vous, car il n'a ni part, ni héritage avec vous."
,"13":"Garde-toi bien d'offrir tes holocaustes en n'importe quel lieu que tu verras."
,"14":"C'est en effet au lieu que Yahvé aura choisi dans l'une des tribus, que tu offriras tes holocaustes; et c'est là que tu accompliras tout ce que je t'ordonne."
,"15":"Tu pourras immoler et manger de la viande chez toi autant que tu le voudras et pour autant que Yahvé ton Dieu t'aura béni. Cette viande, on la mangera comme on mange de la gazelle ou du cerf, que l'on soit pur ou impur."
,"16":"Bien sûr, vous ne mangerez pas le sang mais vous le verserez par terre comme de l'eau."
,"17":"Mais tu ne pourras pas manger chez toi la dîme de ton blé, de ton vin ou de ton huile fraîche, ni les premiers-nés de tes vaches ou de tes brebis, ni les offrandes que tu apportes à l'occasion d'un voeu, ni tes offrandes volontaires, ni tout ce que tu offres à Yahvé."
,"18":"C'est devant Yahvé ton Dieu, dans le lieu que Yahvé ton Dieu aura choisi, que tu les mangeras avec ton fils et ta fille, ton serviteur et ta servante, et avec le Lévite qui habite au milieu de toi. Tu feras la fête devant Yahvé ton Dieu grâce à tous les biens que tu auras acquis."
,"19":"Dans ton pays, n'oublie surtout pas le Lévite, aussi longtemps que tu vivras."
,"20":"Yahvé ton Dieu élargira tes frontières comme il l'a promis. Si tu te dis alors: 'Je veux manger de la viande' , tu pourras en manger toutes les fois que tu en désireras et que tu le voudras."
,"21":"Si le lieu que Yahvé ton Dieu choisira pour y faire habiter son Nom est alors trop loin de toi, tu pourras tuer les boeufs et les brebis que Yahvé t'a donnés, comme je te l'ai dit, et tu en mangeras chez toi toutes les fois que tu le voudras."
,"22":"Tu en mangeras comme on mange de la gazelle ou du cerf, et qu'on soit pur ou impur, on en mangera."
,"23":"Seulement tu veilleras à ne pas manger le sang, car le sang, c'est l'âme; tu ne mangeras donc pas l'âme avec la viande."
,"24":"Tu ne le mangeras pas mais tu le verseras par terre comme de l'eau."
,"25":"Ne le mange pas si tu veux faire ce qui est juste au regard de Yahvé; ainsi tu vivras heureux, toi et tes enfants après toi."
,"26":"Par contre tu apporteras au lieu que Yahvé aura choisi, tout ce que tu lui consacreras, ainsi que tes offrandes à l'occasion d'un voeu."
,"27":"Là, tu immoleras tes holocaustes avec la chair et le sang sur l'autel de Yahvé ton Dieu. Le sang de tes sacrifices sera répandu sur l'autel et tu en mangeras la chair."
,"28":"Observe toutes ces pratiques, écoute ce que je te commande et tout ira bien pour toi et pour tes fils après toi, pour toujours, aussi longtemps que tu feras ce qui est bon et juste au regard de Yahvé ton Dieu."
,"29":"Quand Yahvé aura exterminé les peuplades du pays où tu entres et qu'il les aura dépossédées devant toi, le pays t'appartiendra et tu y habiteras."
,"30":"Mais attention, il ne faudrait pas que ces gens soient encore un piège pour toi après que tu les auras écrasés. Ne t'occupe pas de leurs dieux, ne demande pas: 'Comment ces nations servent-elles leurs dieux? Ne faut-il pas que je fasse comme elles?'"
,"31":"Non, tu ne feras pas comme elles pour servir Yahvé ton Dieu, car ces nations ont fait pour leurs dieux ce que Yahvé déteste, ce qui le dégoûte: elles ont même livré au feu en l'honneur de leurs dieux leurs fils et leurs filles."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Vous observerez tout ce que je vous ai commandé, vous le mettrez en pratique sans rien y ajouter, sans rien en retirer."
,"2":"Suppose qu'arrive chez toi un prophète ou un diseur de songes; il t'annonce un signe ou un prodige,"
,"3":"et ce signe ou ce prodige qu'il t'a prédit, se réalise. Si alors il t'invite à suivre et à servir d'autres dieux que tu n'as pas connus,"
,"4":"tu n'écouteras pas les paroles de ce prophète ou de ce diseur de songes; car c'est Yahvé ton Dieu qui te met à l'épreuve pour savoir si tu l'aimes de tout ton coeur et de toute ton âme."
,"5":"C'est Yahvé, votre Dieu, que vous suivrez. Vous le craindrez, vous garderez ses commandements, vous écouterez sa voix, vous le servirez et vous vous attacherez à lui."
,"6":"Ce prophète ou ce diseur de songes doit mourir, car il a prêché l'infidélité envers Yahvé votre Dieu qui vous a fait sortir d'Egypte et vous a libérés de la maison de l'esclavage. Il a voulu vous détourner de la voie dans laquelle Yahvé votre Dieu vous a commandé de marcher, et vous, vous ôterez le mal du milieu de vous."
,"7":"Peut-être que ton frère, fils de ta mère, ou ton fils ou ta fille, ou la femme qui dort avec toi, ou ton ami qui est comme un autre toi-même voudront t'entraîner discrètement, et te diront: 'Allons et servons d'autres dieux', des dieux que ni toi ni tes pères n'avez connus"
,"8":"(ces dieux des peuples qui vous entourent, proches ou lointains, d'un bout à l'autre de la terre)."
,"9":"Alors tu refuseras, tu ne l'écouteras pas, ton oeil sera sans pitié, tu ne l'épargneras pas et tu ne lui chercheras pas d'excuses."
,"10":"Tu le mettras à mort, toi le premier; tu lèveras la main sur lui et ensuite tout le peuple le frappera."
,"11":"Tu le lapideras et il mourra, car il a cherché à t'éloigner de Yahvé ton Dieu qui t'a fait sortir du pays d'Egypte, de la maison de l'esclavage."
,"12":"Tous les Israélites le sauront et ils craindront, et on ne recommencera plus chez toi une chose pareille."
,"13":"Peut-être apprendras-tu que dans une des villes que Yahvé ton Dieu te donne pour y habiter,"
,"14":"des gens de rien se sont manifestés, qui détournent les habitants de la ville en disant: 'Allons et servons d'autres dieux que vous ne connaissez pas!'"
,"15":"Alors, tu chercheras, tu feras ton enquête, tu interrogeras soigneusement et, si cela est vrai, si tu as la preuve que cette chose horrible existe chez les tiens,"
,"16":"tu feras périr par l'épée les habitants de cette ville. Tu la voueras à l'anathème avec tout ce qu'elle contient, et tu passeras même le bétail au fil de l'épée."
,"17":"Tu rassembleras au milieu de la place toutes ses dépouilles et tu brûleras par le feu, en l'honneur de Yahvé, la ville avec toutes ses dépouilles. Elle sera pour toujours une colline déserte, on ne la rebâtira pas."
,"18":"Tu ne garderas rien pour toi de ce qui aura été voué par anathème. Ainsi Yahvé reviendra de sa grande colère et il t'accordera sa pitié. Il aura pitié de toi et te multipliera comme il l'a juré à tes pères, "
,"19":"parce que tu auras écouté la voix de Yahvé ton Dieu, parce que tu auras gardé tous les commandements que je te donne aujourd'hui, et que tu auras fait ce qui est juste aux yeux de Yahvé ton Dieu."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Vous êtes des fils pour Yahvé votre Dieu. Vous ne vous ferez pas d'incisions ni de tonsures sur le front pour un mort."
,"2":"Tu es un peuple saint pour Yahvé ton Dieu, il t'a choisi pour que tu sois son peuple au milieu de tous les peuples de la terre."
,"3":"Tu ne mangeras rien d'abominable."
,"4":"Voici les animaux que vous pourrez manger: le boeuf, le mouton, la chèvre,"
,"5":"le cerf, la gazelle, le daim, la chèvre de Nubie, l'antilope, le boeuf sauvage et la chèvre sauvage."
,"6":"Vous mangerez de tout animal qui a le sabot divisé, le pied fourchu, et qui rumine;"
,"7":"mais vous ne mangerez pas ceux qui ruminent seulement ou qui ont seulement le sabot divisé, le pied fourchu. Ainsi vous ne mangerez pas le chameau, le lièvre et le lapin qui ruminent mais qui n'ont pas le sabot divisé. Ils seront impurs à vos yeux."
,"8":"C'est encore le cas pour le porc qui a le sabot divisé mais qui ne rumine pas: il sera impur à vos yeux. Vous ne mangerez pas de leur chair et vous ne toucherez pas leur cadavre."
,"9":"Parmi tous les êtres qui vivent dans l'eau, vous pourrez manger ceux qui ont nageoires et écailles."
,"10":"Mais vous ne mangerez pas de ceux qui n'ont ni nageoires ni écailles: ils seront impurs à vos yeux."
,"11":"Vous pourrez manger tous les oiseaux purs."
,"12":"Voici ceux que vous ne mangerez pas: l'aigle, la buse et le vautour,"
,"13":"le faucon, le milan et toute espèce de rapaces."
,"14":"Toute espèce de corbeaux,"
,"15":"l'autruche, le hibou, la mouette et toute espèce d'éperviers,"
,"16":"le chat-huant, l'ibis et la chouette,"
,"17":"le pélican, le cygne et le cormoran,"
,"18":"la cigogne, le héron de toute espèce, la huppe et la chauve-souris."
,"19":"Tous les insectes ailés seront impurs à vos yeux,"
,"20":"mais de tout oiseau pur vous pourrez manger."
,"21":"Tu ne mangeras d'aucune bête morte, mais tu pourras la donner à l'étranger qui habite au milieu de toi: il la mangera ou la vendra à un autre étranger. Mais toi, tu es un peuple saint pour Yahvé ton Dieu. Tu ne feras pas cuire un chevreau dans le lait de sa mère."
,"22":"Tu prélèveras chaque année la dîme sur le produit de ce que tu auras semé, sur le produit de tes champs."
,"23":"Tu mangeras devant Yahvé ton Dieu, dans le lieu qu'il aura choisi pour y faire habiter son Nom, la dîme de ton blé, de ton vin et de ton huile, ainsi que les premiers-nés de la vache et de la brebis. Ainsi tu apprendras à garder toujours la crainte de Yahvé, ton Dieu."
,"24":"Cependant, lorsque Yahvé ton Dieu t'aura béni, si le lieu qu'il a choisi pour y faire habiter son Nom est trop éloigné et que le chemin est trop long pour toi,"
,"25":"tu échangeras ta dîme contre de l'argent, tu prendras l'argent sur toi et tu te rendras au lieu que Yahvé ton Dieu aura choisi."
,"26":"Là, avec ton argent, tu achèteras tout ce que tu voudras: des boeufs, des brebis, du vin, des liqueurs fermentées, en un mot, tout ce que tu voudras, et tu le mangeras là devant Yahvé ton Dieu. Tu feras la fête, toi et ta famille,"
,"27":"sans oublier le Lévite qui habite au milieu de toi, car il n'a ni part ni héritage avec toi."
,"28":"Tous les trois ans, tu mettras de côté, toute la dîme de tes récoltes de l'année et tu la garderas dans ta cité."
,"29":"Alors le Lévite qui n'a ni part ni héritage avec toi, l'étranger, l'orphelin et la veuve qui habitent au milieu de toi viendront, ils mangeront et seront comblés. Ainsi Yahvé ton Dieu te bénira dans tout ce que tu entreprendras."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Tous les sept ans tu feras la rémission."
,"2":"Celui qui aura prêté de l'argent à quelqu'un effacera cette dette. Après qu'on aura publié la rémission de Yahvé, tu ne feras plus pression sur ton prochain, sur ton frère,"
,"3":"tu pourras faire pression sur l'étranger, mais tu effaceras la dette de ton frère."
,"4":"Ainsi il n'y aura pas de pauvre chez toi lorsque Yahvé t'aura béni, dans le pays que Yahvé ton Dieu te donne en héritage et en possession,"
,"5":"à condition toutefois que tu écoutes attentivement la voix de Yahvé ton Dieu, et que tu pratiques avec soin tout ce que je t'ordonne aujourd'hui."
,"6":"Alors Yahvé ton Dieu te bénira comme il l'a promis. Tu prêteras à de nombreuses nations et toi, tu n'auras pas à emprunter, tu domineras sur de nombreuses nations mais elles, ne domineront pas sur toi."
,"7":"Si, dans l'une des villes du pays que Yahvé ton Dieu te donne, tu rencontres un pauvre parmi tes frères, tu ne fermeras ni ton coeur ni ta main devant ce frère qui est dans la pauvreté."
,"8":"Tu lui ouvriras ta main et tu lui prêteras ce dont il a besoin, ce qui lui manque."
,"9":"Ne fais pas dans ta tête ce petit calcul: 'Voici que la septième année, l'année de la rémission approche'; ne regarde pas méchamment ce frère qui est pauvre, ne lui refuse pas ce dont il a besoin de peur qu'il ne crie vers Yahvé contre toi et que toi, tu ne sois chargé d'un péché."
,"10":"Tu dois lui donner, et lui donner sans regret. Alors Yahvé ton Dieu te bénira dans tous tes travaux et dans tout ce que tu entreprendras, à cause de ce que tu as fait."
,"11":"Il ne manquera jamais de pauvres au milieu du pays, c'est pourquoi je te donne ce commandement: Tu ouvriras ta main à ton frère, à celui qui est démuni, au pauvre qui est dans le pays."
,"12":"Si l'un de tes frères hébreux, homme ou femme, se vend à toi, il te servira durant six années, mais la septième année tu le renverras libre de chez toi."
,"13":"Tu le renverras libre, mais non pas les mains vides."
,"14":"Tu lui donneras en cadeau quelque chose de ton troupeau, de ton grenier et de ton pressoir: tu lui donneras une part des biens dont Yahvé ton Dieu t'aura béni."
,"15":"Tu te souviendras que tu as été esclave en Egypte et que Yahvé ton Dieu t'a racheté; c'est pourquoi aujourd'hui je te donne ce commandement."
,"16":"Mais peut-être ton esclave te dira: 'Je ne veux pas te quitter', parce qu'il t'aime, toi et ta famille, et qu'il se trouve bien chez toi,"
,"17":"alors tu prendras un poinçon et tu lui perceras l'oreille contre le montant de ta porte: il sera pour toujours ton serviteur. Tu feras la même chose s'il s'agit d'une servante."
,"18":"N'aie pas peur de le renvoyer libre de chez toi, pense que durant les six ans qu'il t'a servi il t'a économisé deux fois le salaire d'un ouvrier, et puis Yahvé ton Dieu te bénira dans tout ce que tu feras."
,"19":"Tu consacreras à Yahvé tout premier-né qui naîtra dans ton gros et dans ton petit bétail. Tu ne feras pas travailler le premier-né de ta vache et tu ne tondras pas le premier-né de tes brebis."
,"20":"Mais chaque année, toi et ta famille, tu les mangeras devant Yahvé ton Dieu, dans le lieu qu'il aura choisi."
,"21":"Cependant, si ce premier-né est infirme, boiteux ou aveugle, ou s'il a une tare quelconque, tu ne l'offriras pas en sacrifice à Yahvé ton Dieu."
,"22":"Tu le mangeras chez toi; qu'on soit pur ou impur on en mangera comme on mange de la gazelle ou du cerf."
,"23":"Seulement tu ne mangeras pas son sang, tu le verseras à terre comme l'eau."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Observe le mois d'Abib! Tu y feras la Pâque en l'honneur de Yahvé ton Dieu, car c'est au mois d'Abib qu'il t'a fait sortir d'Egypte durant la nuit."
,"2":"Tu immoleras la Pâque en l'honneur de Yahvé ton Dieu, avec des brebis et des boeufs, dans le lieu qu'il aura choisi pour y faire habiter son Nom."
,"3":"Tu ne mangeras pas de pain levé avec les victimes du sacrifice, mais pendant sept jours tu mangeras des pains sans levain, des pains de tristesse. En effet, c'est en hâte que tu es sorti d'Egypte. Ainsi tu te souviendras toute ta vie du jour où tu es sorti d'Egypte."
,"4":"Durant sept jours on ne verra pas de levain chez toi, sur tout ton territoire. Aucune partie des victimes que tu auras offertes en sacrifice le soir du premier jour, ne restera jusqu'au lendemain matin."
,"5":"Tu ne pourras pas immoler la Pâque dans n'importe quelle ville que te donne Yahvé ton Dieu,"
,"6":"mais tu la célébreras dans le lieu que Yahvé ton Dieu aura choisi pour y faire habiter son Nom. Tu la célébreras le soir au coucher du soleil, à l'heure où tu es sorti d'Egypte."
,"7":"Tu feras cuire et tu mangeras la bête du sacrifice dans le lieu que Yahvé ton Dieu aura choisi; au matin tu pourras repartir et regagner tes tentes."
,"8":"Durant six jours tu mangeras des pains sans levain, et le septième jour vous tiendrez une assemblée solennelle en l'honneur de Yahvé votre Dieu. Tu ne feras aucun travail ce jour-là."
,"9":"Tu compteras ensuite sept semaines. Tu compteras ces sept semaines à partir du jour où tu commences à faucher ton blé."
,"10":"Alors tu célébreras la Fête des Semaines en l'honneur de Yahvé ton Dieu. Tu mesureras tes offrandes volontaires d'après les bénédictions reçues de Yahvé ton Dieu,"
,"11":"et tu viendras faire la fête dans le lieu que Yahvé ton Dieu aura choisi pour y faire habiter son Nom, tu y seras en présence de Yahvé ton Dieu avec ton fils et ta fille, ton serviteur et ta servante, avec le Lévite, l'étranger, l'orphelin et la veuve qui habitent au milieu de toi."
,"12":"Souviens-toi alors que tu as été esclave en Egypte, et prends soin de mettre toutes ces lois en pratique."
,"13":"Tu célébreras chez toi la Fête des Tentes durant sept jours, après que tu auras recueilli tout ce qui vient de ton aire et de ton pressoir."
,"14":"Tu feras la fête, toi, ton fils et ta fille, ton serviteur et ta servante, avec le Lévite, l'étranger, l'orphelin et la veuve qui habitent au milieu de toi."
,"15":"Durant sept jours tu célébreras une fête en l'honneur de Yahvé ton Dieu dans le lieu que Yahvé aura choisi. Ainsi Yahvé ton Dieu bénira toutes tes ressources et tes entreprises et tu seras heureux."
,"16":"Ainsi, trois fois dans l'année, tout mâle parmi vous se présentera devant Yahvé ton Dieu, dans le lieu qu'il aura choisi. Il y viendra pour la Fête des Azymes, la Fête des Semaines et la Fête des Tentes. On ne se présentera pas devant Yahvé les mains vides,"
,"17":"mais chacun apportera une offrande, à la mesure des bénédictions de Yahvé ton Dieu."
,"18":"Dans chaque tribu, dans toutes les villes que Yahvé ton Dieu te donne, tu établiras des juges et des scribes. Ils rendront la justice et le peuple aura une justice honnête."
,"19":"Tu ne fausseras pas le jugement, tu ne favoriseras personne, tu n'accepteras pas de cadeau, car le cadeau aveugle les sages et fait tort à celui qui est dans son droit."
,"20":"Tu rechercheras la justice, je dis bien la justice, et ainsi tu vivras et tu posséderas le pays que Yahvé ton Dieu te donne."
,"21":"Tu ne planteras ni pieux sacrés, ni aucun arbre, à côté de l'autel que tu auras construit pour Yahvé ton Dieu."
,"22":"Tu ne dresseras pas non plus de pierres, car Yahvé ton Dieu déteste cela."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Tu ne présenteras pas à Yahvé ton Dieu un boeuf ou un mouton avec une tare, ou une offrande avariée, car Yahvé ton Dieu déteste cela."
,"2":"Suppose qu'au milieu de toi, dans l'une des villes que Yahvé ton Dieu te donne, un homme, ou bien une femme, fait ce qui est mal aux yeux de Yahvé et est infidèle à son Alliance."
,"3":"Il s'en va servir d'autres dieux et il se prosterne devant eux, que ce soit le soleil, la lune ou toute l'armée des cieux (chose que je n'ai pas commandée),"
,"4":"et toi tu apprends la chose, tu en entends parler. Dans ce cas tu feras soigneusement ton enquête. Si cela est vrai, s'il est prouvé que cette chose que Yahvé déteste a été commise en Israël,"
,"5":"tu conduiras hors de la ville l'homme ou la femme qui a commis ce crime, et tu le lapideras jusqu'à ce qu'il meure."
,"6":"Il faudra la déposition de deux ou de trois témoins pour condamner à mort; on ne le mettra pas à mort sur la parole d'un seul témoin."
,"7":"Les témoins frapperont les premiers celui qui doit mourir, ensuite tout le peuple frappera à son tour; ainsi tu ôteras le mal du milieu de toi."
,"8":"Si une affaire te paraît trop difficile à juger: meurtre, contestation, blessure, problème à l'intérieur de la ville, tu te lèveras et tu te rendras au lieu que Yahvé ton Dieu aura choisi."
,"9":"Là, tu iras trouver (les prêtres lévites), le juge en fonction ce jour-là et tu les consulteras. On t'expliquera comment tu dois juger."
,"10":"Dès lors, tu agiras exactement selon ce qu'ils t'auront dit en ce lieu que Yahvé a choisi. Tu veilleras à suivre exactement ce qu'ils t'auront dit."
,"11":"Tu agiras selon la loi qu'ils t'enseigneront et selon le jugement qu'ils prononceront; tu ne dévieras de leurs paroles ni à droite, ni à gauche."
,"12":"Celui qui n'en fera qu'à sa tête sans écouter le juge ou le prêtre qui est de service pour Yahvé son Dieu, mourra. Ainsi tu ôteras le mal d'Israël."
,"13":"Tous dans le peuple le sauront; ils craindront et cesseront d'agir sans aucun droit."
,"14":"Lorsque tu seras entré dans le pays que Yahvé ton Dieu te donne, lorsque tu l'auras conquis et que tu y habiteras, tu diras peut-être: 'Il faut que je me donne un roi comme toutes les nations qui vivent autour de moi.'"
,"15":"Alors tu mettras à ta tête un roi que Yahvé ton Dieu aura choisi. Tu le prendras parmi tes frères; tu ne prendras pas pour régner sur toi un étranger, un homme qui n'est pas ton frère."
,"16":"Il ne faut pas que ton roi cherche toujours davantage de chevaux, il ne faut pas qu'il ramène le peuple en Egypte pour en avoir davantage, car Yahvé l'a bien dit: 'Vous ne retournerez plus jamais par cette route-là.'"
,"17":"Il ne faut pas qu'il multiplie ses femmes, car elles détourneraient son coeur. Il ne faut pas qu'il recherche l'argent et l'or."
,"18":"Mais quand il sera assis sur le trône royal, il recopiera pour lui, cette loi sur le livre des prêtres, des Lévites."
,"19":"Il l'aura sans cesse avec lui et il la lira tous les jours de sa vie. Ainsi il apprendra à craindre Yahvé son Dieu, à observer toutes les paroles de cette loi, tous ses commandements et à les mettre en pratique."
,"20":"Ainsi il ne se croira pas supérieur à ses frères et il ne déviera pas des commandements, ni à droite, ni à gauche. Ainsi il aura un long règne en Israël, et ses fils également."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Les prêtres, les lévites, en un mot toute la tribu de Lévi, n'auront ni part, ni héritage au milieu d'Israël. Ils mangeront sur les sacrifices offerts à Yahvé et sur les offrandes."
,"2":"Lévi n'a pas d'héritage au milieu de ses frères, car Yahvé est son héritage, comme il le lui a dit."
,"3":"Voici quel sera le droit des prêtres vis-à-vis du peuple. Si on offre en sacrifice un boeuf ou un mouton, on donnera au prêtre l'épaule, les mâchoires et la panse."
,"4":"Tu lui donneras les prémices de ton blé, de ton vin et de ton huile, et les prémices de la laine de ton petit bétail;"
,"5":"car Yahvé ton Dieu l'a choisi parmi toutes les tribus pour que ses fils soient tous les jours au service de son Nom."
,"6":"Si un Lévite, quelle que soit la ville où il réside en Israël, désire s'installer au lieu que Yahvé aura choisi,"
,"7":"il pourra se mettre au service du Nom de Yahvé son Dieu, comme tous ses frères lévites qui se tiennent là au service de Yahvé."
,"8":"Il recevra avec eux sa part de nourriture, en plus des produits de son patrimoine."
,"9":"Lorsque tu seras entré dans le pays que Yahvé ton Dieu te donne, tu ne suivras pas les coutumes abominables des nations."
,"10":"On ne trouvera personne chez toi qui fasse passer son fils ou sa fille par le feu, ou qui pratique les charmes ou la divination, la magie ou la sorcellerie;"
,"11":"personne qui se livre à la superstition, qui consulte les esprits ou les augures et interroge les morts."
,"12":"Yahvé a en horreur celui qui agit de la sorte, et c'est bien à cause de ces pratiques abominables que Yahvé ton Dieu dépossède ces peuplades devant toi."
,"13":"Tu seras donc sans reproche au regard de Yahvé ton Dieu."
,"14":"Ces peuplades que tu vas dépouiller écoutent des devins et des magiciens, mais à toi, Yahvé ton Dieu t'a donné quelque chose d'autre."
,"15":"Du milieu de toi, du milieu de tes frères, Yahvé ton Dieu fera que se lève pour toi un prophète comme moi, et c'est lui que vous écouterez."
,"16":"C'est bien ce que tu as demandé à Yahvé ton Dieu au jour de l'assemblée, au mont Horeb. Tu as dit: 'Je ne peux pas supporter plus longtemps la voix de Yahvé mon Dieu et ce feu terrible; un peu plus et je meurs!'"
,"17":"Alors Yahvé m'a dit: 'Voilà une parole juste. C'est pourquoi, du milieu de leurs frères,"
,"18":"je ferai que se lève pour eux un prophète comme toi et je mettrai mes paroles dans sa bouche. Et lui leur dira tout ce que je lui commanderai."
,"19":"Si quelqu'un n'écoute pas ce que le prophète dira en mon nom, je lui en demanderai compte."
,"20":"Mais si un prophète ose dire en mon nom une parole que je ne lui ai pas commandé de dire, ou s'il parle au nom d'autres dieux, je le ferai mourir.'"
,"21":"Tu te demanderas sans doute: 'Comment reconnaîtrons-nous la parole qui ne vient pas de Yahvé?'"
,"22":"Si le prophète parle au nom de Yahvé et que sa prédiction ne se réalise pas, c'est la preuve que cette parole ne vient pas de Yahvé; ce prophète a parlé comme un prétentieux, tu n'auras donc pas peur de lui."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Lorsque Yahvé ton Dieu aura exterminé les autres peuplades dans le pays qu'il te donne, lorsque tu les auras chassées et que tu habiteras dans leurs villes et dans leurs maisons,"
,"2":"tu mettras à part trois villes de ce pays que Yahvé ton Dieu te donne."
,"3":"Tu entretiendras les chemins qui y conduisent et tu diviseras en trois secteurs le pays que Yahvé ton Dieu te donne, de façon que le meurtrier puisse s'y réfugier."
,"4":"Si quelqu'un a tué son prochain involontairement, sans avoir eu de haine pour lui auparavant, il pourra s'y réfugier et avoir la vie sauve."
,"5":"Voici un exemple: un homme part dans la forêt pour couper du bois avec un compagnon, de sa main il brandit la hache pour abattre un arbre, et le fer se détache du manche, atteint son compagnon et le tue. Dans ce cas l'homme se réfugiera dans l'une de ces villes et il aura la vie sauve."
,"6":"Le vengeur du sang va sûrement s'exciter et poursuivre le meurtrier, et si le chemin était trop long, il pourrait le rejoindre et le mettre à mort. Or, cet homme n'a pas mérité la mort puisqu'il n'avait pas de haine auparavant pour ce compagnon"
,"7":"C'est pourquoi je te donne cet ordre: mets à part trois villes."
,"8":"Si Yahvé ton Dieu agrandit tes frontières comme il l'a juré à tes pères, s'il te donne tout le pays qu'il a promis à tes pères de te donner,"
,"9":"(à condition bien sûr que tu observes tous ses commandements que je te donne aujourd'hui, et que tu les mettes en pratique, en aimant Yahvé ton Dieu et en marchant toujours dans ses voies), tu ajouteras trois nouvelles villes de refuge à ces trois-là."
,"10":"Ainsi le sang innocent ne sera pas versé au milieu du pays que Yahvé ton Dieu te donne en héritage: tu ne seras pas coupable pour avoir versé le sang innocent."
,"11":"Mais voici un homme qui déteste son prochain, il le guette, il se jette sur lui et le frappe à mort; ensuite il s'enfuit dans l'une de ces villes."
,"12":"Dans ce cas, les anciens de la ville le feront arrêter, ils le livreront au vengeur du sang et il mourra."
,"13":"Tu seras sans pitié pour lui: ainsi tu laveras Israël du sang innocent et tu vivras."
,"14":"Tu ne déplaceras pas la borne du champ de ton prochain, car elle a été posée par les ancêtres dans l'héritage que tu as reçu au pays que Yahvé ton Dieu te donne."
,"15":"Quelle que soit la faute commise, un seul témoin ne pourra accuser un homme pour un crime ou un péché, quel qu'il soit; la chose sera réglée sur la parole de deux ou trois témoins."
,"16":"Lorsqu'un témoin se lèvera pour accuser un homme d'un crime,"
,"17":"les deux se présenteront devant Yahvé et devant les prêtres et les juges en fonction en ces jours-là."
,"18":"Les juges feront soigneusement leur enquête. Si le témoin est un faux témoin et qu'il a accusé à tort son frère,"
,"19":"tu feras retomber sur lui le mal qu'il voulait faire à son frère; ainsi tu ôteras le mal du milieu de toi."
,"20":"Les autres en apprenant cela craindront, et ils ne recommenceront plus à faire de pareilles choses au milieu de toi."
,"21":"Ton oeil sera sans pitié: vie pour vie, oeil pour oeil, dent pour dent, main pour main, pied pour pied."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Lorsque tu partiras combattre tes ennemis, si tu leur vois des chevaux, des chars et des troupes plus nombreuses que les tiennes, n'aie pas peur, car Yahvé ton Dieu qui t'a fait monter du pays d'Egypte est avec toi."
,"2":"Avant qu'on engage le combat, le prêtre s'avancera et parlera au peuple."
,"3":"Il lui dira: 'Ecoute, Israël! Vous êtes aujourd'hui sur le point d'affronter vos ennemis. Ne faiblissez pas, soyez sans crainte et ne vous effrayez pas, n'ayez pas peur devant eux,"
,"4":"car Yahvé votre Dieu marche avec vous. Il combattra vos ennemis à vos côtés et il vous sauvera.'"
,"5":"Les chefs diront ensuite au peuple: 'Qui a bâti une maison neuve et n'a pas encore eu le temps de la bénir? Qu'il s'en aille et retourne chez lui, de peur qu'il ne meure dans la bataille et qu'un autre ne la bénisse à sa place."
,"6":"Qui a planté une vigne et n'a pas encore mangé de son raisin? Qu'il s'en aille et retourne chez lui, de peur qu'il ne meure dans la bataille et qu'un autre ne profite de sa vigne."
,"7":"Qui s'est fiancé à une femme et ne l'a pas encore épousée? Qu'il s'en aille et retourne chez lui, de peur qu'il ne meure dans la bataille et qu'un autre ne l'épouse.'"
,"8":"Les chefs diront encore: 'Qui a peur? Qui se sent démoralisé? Qu'il s'en aille et retourne chez lui, car il pourrait démoraliser ses frères.'"
,"9":"Lorsqu'ils auront fini de parler au peuple, les chefs prendront la tête des troupes."
,"10":"Lorsque tu t'approcheras d'une ville pour l'attaquer, tu commenceras par lui offrir la paix."
,"11":"Si elle répond pacifiquement et t'ouvre ses portes, tout le peuple qui s'y trouve paiera le tribut et te servira."
,"12":"Mais si elle refuse la paix avec toi et qu'elle veuille combattre, tu en feras le siège."
,"13":"Lorsque Yahvé ton Dieu l'aura livrée entre tes mains, tu passeras au fil de l'épée tous les mâles."
,"14":"Mais les femmes, les enfants, le bétail et tout ce qui sera dans la ville, toutes ses dépouilles, tu les prendras pour toi et tu te nourriras du butin de tes ennemis que Yahvé ton Dieu t'aura livré."
,"15":"Tu agiras ainsi envers toutes les villes qui sont très loin de toi et qui n'appartiennent pas aux étrangers du voisinage."
,"16":"Mais tu ne laisseras personne en vie dans ces villes d'étrangers que Yahvé ton Dieu te donne en héritage."
,"17":"Tu dois les vouer à l'anathème: les Hittites, les Amorites, les Cananéens, les Périsites, les Hivvites, les Jébusites, comme Yahvé ton Dieu te l'a ordonné."
,"18":"Ainsi ils ne vous apprendront pas leurs pratiques et leurs façons de servir leurs dieux: elles sont scandaleuses! Et vous, vous ne pécherez pas envers Yahvé votre Dieu."
,"19":"Lorsque tu attaqueras une ville pour t'en emparer, si tu l'assièges et que le siège se prolonge, tu n'abattras pas les arbres, tu n'y mettras pas la hache si tu peux en manger les fruits. L'arbre des champs n'est pas un homme, et tu n'es pas en guerre avec lui."
,"20":"Mais si ce n'est pas un arbre fruitier, tu peux le couper et l'abattre pour les travaux du siège, jusqu'à ce que tombe cette ville qui est en guerre avec toi."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Si on trouve dans la campagne, sur le sol que Yahvé ton Dieu te donne en possession, le corps d'une personne assassinée, et qu'on ne sait pas qui l'a frappée,"
,"2":"les anciens et les juges sortiront pour calculer la distance des villes voisines du lieu du crime."
,"3":"Les anciens de la ville la plus proche prendront alors une génisse qu'on n'a pas fait travailler et qui n'a pas encore été attelée."
,"4":"Les anciens de cette ville feront descendre la génisse vers un torrent où l'eau ne cesse de couler, mais où il n'y a ni culture ni semence, et là ils lui briseront la nuque dans le torrent."
,"5":"Les prêtres fils de Lévi s'avanceront alors, puisque Yahvé ton Dieu les a choisis pour être à son service et pour bénir au nom de Yahvé, et c'est sur leur parole que se règlent tout procès et tout échange de coups."
,"6":"Et tous les anciens de la ville la plus proche du lieu du crime laveront leurs mains dans le torrent au-dessus de la génisse dont on a brisé la nuque."
,"7":"Puis ils prononceront ces paroles: 'Nos mains n'ont pas répandu ce sang, nos yeux n'ont rien vu."
,"8":"O Yahvé, pardonne à ton peuple Israël que tu as racheté, et ne charge pas ton peuple Israël d'un sang innocent.' Ainsi ils seront quittes du sang versé:"
,"9":"tu auras lavé le sang innocent et tu auras fait ce qui est bon aux yeux de Yahvé."
,"10":"Voici un autre cas. Tu pars combattre tes ennemis et Yahvé ton Dieu les livre entre tes mains. Tu ramènes des captifs"
,"11":"et, parmi les captifs, tu vois une belle femme. Si tu t'éprends d'elle et que tu veux l'épouser,"
,"12":"tu l'introduiras dans ta maison. Là, elle se rasera la tête et se coupera les ongles,"
,"13":"elle enlèvera ses habits de captive, ceux qu'elle portait sur elle, et elle habitera dans ta maison. Durant un mois, elle fera le deuil de son père et de sa mère; ensuite tu t'approcheras d'elle, tu l'épouseras et elle sera ta femme."
,"14":"S'il arrive que tu n'en veuilles plus, tu la laisseras partir à son gré; tu ne pourras pas la vendre à prix d'argent ni en faire ton esclave puisque tu as couché avec elle."
,"15":"Voici un autre cas. Un homme a deux femmes, l'une est bien aimée et l'autre mal aimée. Toutes les deux lui ont donné des fils, et l'aîné est le fils de la mal-aimée."
,"16":"Au jour où cet homme partagera son héritage entre ses fils, il ne pourra pas donner le droit d'aînesse au fils de la bien-aimée aux dépens de l'aîné qui est fils de la mal-aimée."
,"17":"Il devra reconnaître comme aîné le fils de la mal-aimée, et il lui donnera une double part de son héritage: puisqu'il est le premier-né, le droit d'aînesse est à lui."
,"18":"Voici encore le cas du fils rebelle et révolté qui n'obéit pas à son père ni à sa mère: il ne les écoute pas quand ils le corrigent."
,"19":"Son père et sa mère le prendront et le conduiront vers les anciens, à la porte de la ville."
,"20":"Et ils diront aux anciens: 'Voici notre fils! Il est rebelle et révolté, il ne nous écoute pas, c'est un débauché et un buveur.'"
,"21":"Alors tous les hommes de la ville le lapideront à coups de pierres et il mourra. Tu enlèveras ainsi le mal du milieu de toi; tous ceux qui l'apprendront en Israël, craindront."
,"22":"Voici encore un cas. Quelqu'un a commis une faute qui mérite la mort et tu l'as mis à mort en le pendant à un arbre."
,"23":"Tu ne laisseras pas son cadavre passer la nuit sur l'arbre, mais tu le mettras au tombeau le jour-même, car un pendu est une malédiction de Dieu. Tu éviteras ainsi de rendre impur le sol que Yahvé ton Dieu te donne en héritage."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Si tu trouves le boeuf ou la brebis de ton frère qui se sont égarés, tu ne passeras pas à côté indifférent: tu les ramèneras à ton frère."
,"2":"Si ce frère n'habite pas à côté de chez toi ou si tu ne le connais pas, tu recueilleras l'animal dans ta maison, et il restera chez toi jusqu'à ce que ton frère vienne le rechercher. Alors tu le lui rendras."
,"3":"Tu feras de même pour son âne, pour son manteau, pour tout objet égaré que ton frère a perdu et que tu as trouvé. Tu ne feras pas l'ignorant."
,"4":"Si tu vois l'âne de ton frère, ou son boeuf, tombé sur le chemin, tu ne passeras pas à côté, mais tu l'aideras à se relever."
,"5":"La femme ne portera pas un costume d'homme et l'homme ne mettra pas un vêtement de femme, car Yahvé ton Dieu a en horreur celui qui fait cela."
,"6":"Si tu rencontres sur ton chemin, sur un arbre ou à terre, un nid d'oiseaux avec des petits ou des oeufs, et que la mère soit couchée sur les petits ou sur les oeufs, tu ne prendras pas la mère et ses petits."
,"7":"Tu laisseras aller la mère, et tu ne prendras pour toi que les petits: ainsi tout ira bien pour toi et tu vivras de longs jours."
,"8":"Lorsque tu construiras une nouvelle maison, tu mettras une barrière tout autour du toit, car tu serais responsable si quelqu'un tombait de là-haut."
,"9":"Tu ne sèmeras pas dans ta vigne une autre culture, sinon le tout serait consacré: la semence que tu as semée, et le fruit de ta vigne."
,"10":"Tu n'attelleras pas ensemble pour labourer, un boeuf et un âne."
,"11":"Tu ne t'habilleras pas avec un tissu fait de laine et de lin."
,"12":"Tu feras des cordons aux quatre coins du voile que tu portes."
,"13":"Voici un homme qui a épousé une femme. Il a eu des relations avec elle, mais par la suite il la déteste."
,"14":"Il lui reproche de vilaines choses et il porte atteinte à sa réputation. Il dit: 'J'ai pris cette femme, je me suis approché d'elle, mais je n'ai pas trouvé les signes de sa virginité.'"
,"15":"Dans ce cas, le père et la mère de la jeune fille prendront le linge avec les signes de la virginité de la jeune fille et l'apporteront aux anciens à la porte de la ville."
,"16":"Le père de la jeune fille dira alors aux anciens: 'J'ai donné ma fille comme épouse à cet homme, et maintenant il la déteste."
,"17":"Il lui fait une réputation de mauvaise conduite et il dit: Je n'ai pas trouvé chez ta fille les signes de sa virginité. Or voici les signes de la virginité de ma fille.' Sur ce il étendra le linge devant les anciens de la ville."
,"18":"Les anciens de la ville prendront l'homme et le corrigeront."
,"19":"Ensuite ils le condamneront à une amende de cent pièces d'argent pour avoir sali la réputation d'une vierge d'Israël, et ils les donneront au père de la jeune fille. Elle restera sa femme, et de toute sa vie il ne pourra la répudier."
,"20":"Mais si la chose est vraie, si l'on n'a pas trouvé chez la jeune fille les signes de sa virginité;"
,"21":"on fera sortir la jeune fille à l'entrée de la maison de son père, et les gens de la ville la lapideront. Elle mourra parce qu'elle a fait une chose honteuse en Israël, en se prostituant dans la maison de son père. C'est ainsi que tu ôteras le mal du milieu de toi."
,"22":"Si l'on trouve un homme couché avec une femme mariée, ils mourront tous les deux: aussi bien la femme que l'homme qui a couché avec elle. C'est ainsi que tu ôteras le mal d'Israël."
,"23":"Si un homme rencontre en ville une jeune qui est fiancée à un autre, et couche avec elle,"
,"24":"vous les ferez sortir tous les deux à la porte de cette ville, et vous les lapiderez. La jeune fille mourra, car c'était en ville et elle n'a pas crié; et l'homme mourra car il a violé la femme de son prochain. Ainsi tu ôteras le mal du milieu de toi."
,"25":"Mais si l'homme a rencontré la jeune fiancée dans la campagne, et que là il l'a violentée, seul l'homme qui a couché avec elle mourra."
,"26":"Tu ne toucheras pas à la jeune fille, car elle n'a pas commis de faute (elle était dans la même situation qu'une personne qui est attaquée et tuée)."
,"27":"L'autre l'a rencontrée dans la campagne et la jeune fille fiancée a eu beau crier, personne n'a pu lui venir en aide."
,"28":"Un autre cas. Un homme rencontre une jeune fille vierge qui n'est pas encore fiancée, il la violente et couche avec elle, et on les surprend."
,"29":"L'homme qui a couché avec la jeune fille donnera au père de celle-ci cinquante pièces d'argent, et elle deviendra sa femme. Il ne pourra pas la répudier de toute sa vie, puisqu'il l'a violée."
}`)
	CurrentBook.AddChapter(23, `{
"1":"Un homme ne prendra pas la femme de son père: il ne découvrira pas la nudité de son père."
,"2":"Si quelqu'un a les testicules écrasés ou l'urètre coupé, il n'entrera pas dans la communauté de Yahvé."
,"3":"Le métis non plus n'entrera pas dans la communauté de Yahvé. Même à la dixième génération il est exclu de la communauté de Yahvé."
,"4":"L'Ammonite et le Moabite seront exclus de la communauté de Yahvé; même à la dixième génération, ils n'entreront pas dans la communauté de Yahvé."
,"5":"En effet, ils ne sont pas venus au-devant de vous sur la route, avec du pain et de l'eau, lorsque vous sortiez d'Egypte. Plus encore, ils ont payé pour vous maudire, Balaam, fils de Béor, de Petor en Mésopotamie."
,"6":"Mais Yahvé ton Dieu n'a pas voulu écouter Balaam; Yahvé ton Dieu t'aime, et il a retourné pour toi sa malédiction en bénédiction."
,"7":"C'est pourquoi, tout au long de ta vie, tu ne te soucieras pas de leur bien-être et de leur bonheur."
,"8":"Par contre, tu n'auras pas de haine pour l'Edomite, car il est ton frère. Tu n'auras pas de haine non plus pour l'Egyptien, car tu as été un étranger dans son pays."
,"9":"A la troisième génération, leurs descendants pourront entrer dans la communauté de Yahvé."
,"10":"Lorsque tu partiras en campagne contre tes ennemis, tu veilleras à ne commettre aucune action mauvaise."
,"11":"S'il y a au milieu de toi un homme impur à la suite d'une pollution nocturne, il sortira du camp et n'y rentrera pas."
,"12":"A la tombée de la nuit il se baignera dans l'eau et, après le coucher du soleil, il rentrera à l'intérieur du camp."
,"13":"On fixera un endroit à l'extérieur du camp pour se retirer à l'écart."
,"14":"Dans ton équipement tu auras une pique; lorsque tu t'accroupiras à l'écart, tu feras un trou avec ta pique, et lorsque tu te relèveras, tu recouvriras tes excréments."
,"15":"Car Yahvé ton Dieu se promène au milieu de ton camp, pour te protéger et pour livrer tes ennemis entre tes mains; c'est pourquoi ton camp sera saint: Yahvé ne doit pas voir de saletés chez toi, sinon, il se détournerait de toi."
,"16":"Si un esclave s'est enfui de chez son maître pour venir chez toi, tu ne le lui livreras pas."
,"17":"Il demeurera chez toi, dans ta maison, au lieu qu'il aura choisi dans l'une de tes villes où bon lui semblera; et tu ne lui feras pas de mal."
,"18":"On ne trouvera pas de prostituées sacrées chez les filles d'Israël, ni de prostitués sacrés chez les fils d'Israël."
,"19":"Quel que soit le voeu que tu aies fait, tu n'offriras pas dans la maison de Yahvé ton Dieu le salaire d'une prostituée ou celui d'un chien (un prostitué sacré), car Yahvé ton Dieu a en horreur l'un et l'autre."
,"20":"Tu ne prêteras pas à ton frère avec intérêt, qu'il s'agisse d'argent, ou de nourriture, ou de toute autre chose pour laquelle on demande un intérêt."
,"21":"A l'étranger tu prêteras avec intérêt, mais tu ne le feras pas pour ton frère. Ainsi Yahvé ton Dieu te bénira dans tout ce que tu entreprendras sur cette terre où tu vas entrer pour la posséder."
,"22":"Lorsque tu feras un voeu à Yahvé ton Dieu, tu l'accompliras sans tarder, sinon Yahvé ton Dieu t'en demanderait compte et tu pécherais contre lui."
,"23":"Mais si tu ne fais pas de voeu, tu ne pèches pas."
,"24":"Tu veilleras à faire ce que tu auras promis: les voeux que tu as faits et les offrandes que tu as promises à Yahvé ton Dieu."
,"25":"Lorsque tu traverseras la vigne de ton prochain, tu pourras grappiller des raisins comme tu le voudras jusqu'à ne plus avoir faim, mais tu n'en mettras pas dans ton panier."
,"26":"De même lorsque tu traverseras les blés de ton prochain: tu pourras y cueillir des épis avec la main, mais tu ne mettras pas la faucille dans les blés de ton prochain."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Voici encore un cas. Un homme a pris une femme et l'a épousée. Mais ensuite il a trouvé quelque chose à lui reprocher, et il n'en veut plus. Il lui écrit donc une lettre de divorce, il la lui remet et la chasse de chez lui."
,"2":"La femme quitte sa maison et par la suite devient la femme d'un autre homme."
,"3":"Mais elle déplaît également à ce deuxième mari, qui va lui écrire une lettre de divorce, la lui remettre et la chasser de chez lui. Il se peut aussi que ce deuxième mari vienne à mourir."
,"4":"Dans ces deux cas, le premier mari qui l'a renvoyée ne peut pas la reprendre après qu'elle est devenue impure pour lui. Elle ne peut pas redevenir sa femme: ce serait une chose abominable au regard de Yahvé, et tu ne dois pas souiller par ton péché le pays que Yahvé ton Dieu te donne en héritage."
,"5":"Si un homme vient tout juste de se marier, il ne partira pas à la guerre, on ne lui imposera pas non plus de corvée. Pendant un an on le laissera tranquille chez lui pour qu'il rende heureuse la femme qu'il a épousée."
,"6":"On ne prendra pas en gage le moulin, ni même la meule de dessus, car ce serait prendre en gage la vie elle-même."
,"7":"Si l'on découvre un homme qui a enlevé l'un de ses frères Israélite et qui en a fait son esclave, ou qui l'a vendu, ce ravisseur sera mis à mort; ainsi tu ôteras le mal du milieu de toi."
,"8":"Méfie-toi de la plaie de la lèpre. Tu suivras exactement et tu mettras en pratique tout ce que les prêtres, les Lévites, vous enseignent. Vous ferez attention à faire comme je leur ai commandé."
,"9":"Rappelle-toi comment Yahvé ton Dieu a agi avec Miryam sur la route, après votre sortie d'Egypte."
,"10":"Lorsque tu prêteras quelque chose à ton prochain, tu n'entreras pas dans sa maison pour te servir toi-même et prendre le gage que tu veux."
,"11":"Tu resteras dehors, et celui à qui tu prêtes viendra t'apporter le gage qu'il aura choisi."
,"12":"Si c'est un homme pauvre, tu ne te coucheras pas avec son gage,"
,"13":"mais tu le lui rendras avant le coucher du soleil pour qu'il puisse se coucher dans son manteau. Ainsi il te bénira et tu auras des mérites aux yeux de Yahvé ton Dieu."
,"14":"Tu ne feras pas de tort au pauvre qui travaille pour toi, qu'il s'agisse de l'un de tes frères ou d'un étranger qui habite dans ton pays ou dans ta ville."
,"15":"Tu lui verseras son salaire le jour-même, et le soleil ne se couchera pas sur ce que tu lui dois, car il l'attend avec impatience: il est pauvre. Ainsi, il n'aura pas besoin de crier contre toi vers Yahvé, et toi tu ne pécheras pas."
,"16":"Les pères ne seront pas mis à mort pour les fautes de leurs fils, ni les fils pour celles de leur père. Chacun mourra pour son propre péché."
,"17":"Tu ne fausseras pas le jugement de l'étranger ou de l'orphelin, et tu ne prendras pas en gage le vêtement de la veuve."
,"18":"Tu te souviendras que toi-même tu as été esclave en Egypte, et que Yahvé ton Dieu t'en a libéré. C'est pourquoi je te commande de faire cela."
,"19":"Si tu as oublié une gerbe dans ton champ en faisant la moisson, ne reviens pas pour la prendre: elle sera pour l'étranger, l'orphelin ou la veuve. Ainsi Yahvé ton Dieu te bénira dans tout ce que tu entreprendras."
,"20":"Lorsque tu gauleras ton olivier, ne repasse pas une seconde fois après la cueillette: ce qui reste sera pour l'étranger, l'orphelin ou la veuve."
,"21":"Lorsque tu vendangeras, ne repasse pas une seconde fois: ce qui reste sera pour l'étranger, l'orphelin ou la veuve."
,"22":"Tu te souviendras que tu as été esclave en Egypte: c'est pourquoi je te commande de faire cela."
}`)
	CurrentBook.AddChapter(25, `{
"1":"Prends le cas de deux hommes qui se sont querellés. Ils sont venus devant le tribunal et on les a jugés: l'innocent a été libéré et le coupable, condamné."
,"2":"Si le coupable a mérité d'être battu, le juge le fera étendre à terre et l'homme recevra en sa présence le nombre de coups que mérite sa faute."
,"3":"On ne lui donnera pas plus de quarante coups car, avec davantage de coups, ton frère serait trop malmené et il resterait déshonoré à tes yeux."
,"4":"Tu ne muselleras pas le boeuf qui bat le grain."
,"5":"Lorsque des frères habitent ensemble et que l'un d'eux meurt sans avoir de fils, la femme du mort ne peut être reprise par un étranger. Son beau-frère s'approchera d'elle et la prendra pour femme. Il remplira envers elle son devoir de beau-frère,"
,"6":"et le premier enfant qu'elle mettra au monde sera regardé comme le fils de celui qui est mort; ainsi son nom ne disparaîtra pas en Israël."
,"7":"Mais si cet homme refuse de prendre sa belle-soeur, elle ira trouver les anciens à la porte de la ville et elle leur dira: 'Mon beau-frère refuse de maintenir vivant en Israël le nom de son frère. Il ne veut pas remplir envers moi son devoir de beau-frère.'"
,"8":"Alors les anciens le convoqueront et lui parleront. Et s'il s'entête à dire: 'Je ne veux pas la prendre pour femme!'"
,"9":"sa belle-soeur s'avancera vers lui en présence des anciens, elle lui enlèvera du pied sa sandale et lui crachera au visage. Elle dira: 'Voilà ce qu'on fait à celui qui n'assure pas une descendance à son frère.'"
,"10":"Dès lors, en Israël, on appellera sa maison: la maison du déchaussé."
,"11":"Un autre cas: des hommes se battent et la femme de l'un d'eux saisit par les parties honteuses celui qui frappe son mari, car elle veut le délivrer."
,"12":"Même dans ce cas tu lui trancheras la main: tu seras sans pitié pour elle."
,"13":"Tu n'auras pas dans ton sac deux poids, un lourd et un léger."
,"14":"Tu n'auras pas dans ta maison deux mesures, une grande et une petite."
,"15":"Mais tes poids seront justes, tes mesures seront justes; ainsi tu vivras de longs jours sur la terre que Yahvé ton Dieu te donne."
,"16":"Celui qui fait autrement est un malhonnête, il déplaît à Yahvé ton Dieu."
,"17":"Souviens-toi de ce que t'a fait Amalec sur la route, lorsque tu sortais d'Egypte."
,"18":"Il est venu à ta rencontre et a attaqué à l'arrière tous ceux des tiens qui étaient épuisés, car vous étiez tous fatigués et découragés. Il n'a eu aucune crainte de Dieu."
,"19":"C'est pourquoi, lorsque Yahvé ton Dieu t'aura donné du repos et t'aura délivré de tes ennemis, lorsque tu seras dans le pays que Yahvé ton Dieu te donne en héritage pour le posséder, tu effaceras la mémoire d'Amalec de dessous les cieux. Ne l'oublie pas!"
}`)
	CurrentBook.AddChapter(26, `{
"1":"Quand tu seras entré dans le pays que Yahvé ton Dieu te donne en héritage, quand il sera à toi et que tu l'habiteras,"
,"2":"tu prendras les premiers de tous les fruits du sol que tu auras récoltés dans ce pays que Yahvé ton Dieu te donne. Tu les mettras dans un panier et tu iras au lieu que Yahvé ton Dieu aura choisi pour y faire habiter son Nom."
,"3":"Tu te présenteras au prêtre qui sera en fonction ce jour-là et tu lui diras: 'Je le reconnais aujourd'hui devant Yahvé mon Dieu: oui, je suis entré au pays que Yahvé avait juré à nos pères de nous donner.'"
,"4":"Alors le prêtre prendra le panier de ta main et il le déposera devant l'autel de Yahvé ton Dieu."
,"5":"Puis tu prendras la parole et tu diras devant Yahvé ton Dieu: 'Mon père était un Araméen nomade. Quand il est descendu en Egypte, il avait peu de monde avec lui, mais ils sont devenus là-bas une nation grande, puissante et nombreuse."
,"6":"Alors les Egyptiens nous ont maltraités, ils nous ont accablés, ils nous ont imposé un dur travail."
,"7":"C'est pourquoi nous avons crié vers Yahvé, le Dieu de nos pères, et Yahvé a entendu notre voix. Il a vu notre souffrance, notre peine, notre écrasement."
,"8":"Yahvé nous a fait sortir d'Egypte par sa main redoutable, en frappant de grands coups, en inspirant la terreur par des signes et des prodiges."
,"9":"Il nous a conduits en ce lieu et nous a donné ce pays, une terre où ruissellent le lait et le miel."
,"10":"Aussi maintenant je viens apporter les premiers fruits du sol que tu m'as donné, ô Yahvé!' Alors tu déposeras ces fruits devant Yahvé ton Dieu et tu te prosterneras devant lui."
,"11":"Puis tu feras la fête, toi et ta famille, avec toutes les bonnes choses que Yahvé ton Dieu t'a données. Le Lévite et l'étranger qui sont au milieu de toi seront de la fête avec toi."
,"12":"La troisième année, qui est l'année de la dîme, tu prélèveras la dîme sur toutes tes récoltes et tu la donneras au Lévite, à l'étranger, à l'orphelin et à la veuve. Ils en mangeront dans tes villes tant qu'ils auront faim. Lorsque tu auras terminé,"
,"13":"tu diras en présence de Yahvé ton Dieu: 'J'ai enlevé de ma maison toute la part consacrée et je l'ai donnée au Lévite, à l'étranger, à l'orphelin et à la veuve selon le commandement que tu m'avais donné. Vois que je n'ai désobéi à aucun de tes ordres, je ne les ai pas oubliés."
,"14":"De ce qui restait, je n'ai rien mangé durant les jours de deuil, rien n'est devenu impur; je n'en ai pas donné à un mort, mais j'ai écouté la voix de Yahvé mon Dieu et, en tout, j'ai agi comme il me l'a commandé."
,"15":"De ta Demeure de sainteté, du haut du ciel, regarde et bénis ton peuple Israël, ainsi que la terre que tu nous a donnée comme tu l'as juré à nos pères, ce pays où ruissellent le lait et le miel.'"
,"16":"Et tu sauras que ce même jour ton Dieu te commande de mettre en pratique ses lois et ses ordonnances. Tu les observeras et tu les mettras en pratique de tout ton coeur et de toute ton âme."
,"17":"Tu viens de dire à Yahvé qu'il sera ton Dieu, que tu marcheras dans ses voies, que tu observeras ses préceptes, ses commandements et ses ordonnances et que tu écouteras sa voix."
,"18":"Yahvé à son tour te fait dire aujourd'hui que tu seras son peuple choisi, comme il te l'a promis, que tu observeras tous ses commandements."
,"19":"Et lui te donnera gloire, renommée et puissance; il te mettra au-dessus de toutes les nations qu'il a faites et tu seras pour Yahvé ton Dieu un peuple saint, comme il te l'a dit.'"
}`)
	CurrentBook.AddChapter(27, `{
"1":"Entouré des anciens d'Israël, Moïse donna ces instructions au peuple: 'Observez tous les commandements que je vous donne aujourd'hui."
,"2":"Lorsque tu auras traversé le Jourdain pour entrer au pays que Yahvé ton Dieu te donne, tu dresseras de grandes pierres et tu les enduiras de chaux."
,"3":"Tu écriras dessus à ton passage toutes les paroles de cette Loi, pour que tu entres bien au pays que Yahvé ton Dieu te donne, pays où coulent le lait et le miel, comme Yahvé ton Dieu l'a dit à tes pères."
,"4":"Lorsque tu auras traversé le Jourdain, c'est sur le mont Ebal que tu dresseras ces pierres et que tu les enduiras de chaux, comme je vous l'ordonne aujourd'hui."
,"5":"Là, tu bâtiras un autel à Yahvé, un autel de pierres qu'aucun outil de fer n'a travaillées."
,"6":"Tu bâtiras l'autel de Yahvé ton Dieu en pierres brutes et tu offriras dessus des holocaustes en l'honneur de Yahvé ton Dieu."
,"7":"Tu offriras des sacrifices de communion, tu mangeras et tu feras la fête en présence de Yahvé ton Dieu."
,"8":"Alors tu graveras clairement sur ces pierres toutes les paroles de cette Loi.'"
,"9":"Moïse et les prêtres lévites dirent alors à tout Israël: 'Garde le silence et prête l'oreille, Israël! Aujourd'hui tu es devenu le peuple de Yahvé ton Dieu."
,"10":"Tu écouteras donc la voix de Yahvé ton Dieu et tu mettras en pratique ses commandements et ses ordonnances que je te donne aujourd'hui.'"
,"11":"Ce jour-là, Moïse donna cet ordre au peuple:"
,"12":"'Lorsque vous aurez traversé le Jourdain, voici ceux qui se tiendront sur le mont Garizim pour bénir le peuple: Siméon, Lévi, Juda, Issacar, Joseph et Benjamin."
,"13":"Et voici ceux qui se tiendront sur le mont Ebal pour prononcer la malédiction: Ruben, Gad, Asher, Zabulon, Dan et Nephtali."
,"14":"Alors les Lévites prendront la parole et proclameront à haute voix devant tous les hommes d'Israël:"
,"15":"Maudit soit celui qui fait une idole ou une statue de bronze, une oeuvre d'artisan que Yahvé déteste, et qui la place dans un endroit secret! Tout le peuple répondra: Amen."
,"16":"Maudit soit celui qui méprise son père ou sa mère! Et tout le peuple dira: Amen."
,"17":"Maudit soit celui qui déplace la borne de son prochain! Et tout le peuple dira: Amen."
,"18":"Maudit soit celui qui égare un aveugle sur le chemin! Et tout le peuple dira: Amen."
,"19":"Maudit soit celui qui fausse le jugement envers l'étranger, l'orphelin ou la veuve! Et tout le peuple dira: Amen."
,"20":"Maudit soit celui qui couche avec la femme de son père, et qui découvre ainsi la nudité de son père! Et tout le peuple dira: Amen."
,"21":"Maudit soit celui qui couche avec une bête quelconque! Et tout le peuple dira: Amen."
,"22":"Maudit soit celui qui couche avec sa soeur, fille de son père ou fille de sa mère! Et tout le peuple dira: Amen."
,"23":"Maudit soit celui qui couche avec sa belle-mère! Et tout le peuple dira: Amen."
,"24":"Maudit soit celui qui frappe son prochain en cachette! Et tout le peuple dira: Amen."
,"25":"Maudit soit celui qui accepte un cadeau pour faire mourir un innocent! Et tout le peuple dira: Amen."
,"26":"Maudit soit celui qui n'est pas fidèle aux paroles de cette loi et qui ne les met pas en pratique! Et tout le peuple dira: Amen."
}`)
	CurrentBook.AddChapter(28, `{
"1":"Si tu obéis fidèlement à Yahvé ton Dieu, si tu observes et mets en pratique tous ses commandements que je te donne aujourd'hui, Yahvé ton Dieu t'élèvera au-dessus de toutes les nations de la terre."
,"2":"Et voici toutes les bénédictions qui se réaliseront pour toi si tu écoutes la voix de Yahvé ton Dieu."
,"3":"Tu seras béni dans tes villes et béni dans tes champs."
,"4":"Seront bénis le fruit de tes entrailles et le fruit de tes champs, le fruit de tes troupeaux, les portées de ton gros et de ton petit bétail."
,"5":"Ta corbeille à fruits, ta huche à pain seront bénies."
,"6":"Tu seras béni à ton départ et béni à ton retour."
,"7":"Yahvé mettra en fuite devant toi les ennemis qui t'avaient envahi. Par un seul chemin ils étaient venus contre toi: par sept chemins ils s'enfuiront devant toi."
,"8":"Yahvé commandera à la bénédiction d'être avec toi, dans tes greniers et dans tout le travail de tes mains. Il te bénira dans le pays que Yahvé ton Dieu te donne."
,"9":"Yahvé te maintiendra à son service comme un peuple saint, car il t'en a fait le serment, si tu observes les commandements de Yahvé ton Dieu et si tu marches selon ses voies."
,"10":"Tous les peuples verront que le Nom de Yahvé te protège, et ils te craindront."
,"11":"Yahvé te comblera de biens; il multipliera le fruit de tes entrailles, le fruit de tes troupeaux et le fruit de la terre, dans ce pays que Yahvé a juré à tes pères de te donner."
,"12":"Yahvé ouvrira pour toi son bon trésor, le ciel. Au temps voulu il donnera à ton pays la pluie et bénira l'ouvrage de tes mains. Tu prêteras à de nombreuses nations et toi, tu n'emprunteras à personne."
,"13":"Yahvé te mettra en tête et non en queue, il te placera au-dessus et non en-dessous, si tu écoutes les commandements de Yahvé ton Dieu que je te donne aujourd'hui, si tu les observes et si tu les mets en pratique,"
,"14":"sans dévier ni à droite ni à gauche de toutes les paroles que je te dicte aujourd'hui: ne va pas suivre et servir d'autres dieux."
,"15":"Mais voici ce qui arrivera si tu n'écoutes pas la voix de Yahvé ton Dieu, si tu ne mets pas en pratique attentivement tous ses commandements et toutes ses ordonnances que je te donne aujourd'hui. Voici toutes les malédictions qui viendront se réaliser chez toi:"
,"16":"Tu seras maudit dans la ville et maudit dans les champs."
,"17":"Maudite sera ta corbeille de fruits, ainsi que ta huche à pain."
,"18":"Maudit sera le fruit de tes entrailles, le fruit de la terre, la mise bas des vaches et les portées de tes brebis."
,"19":"Tu seras maudit à ton départ, et maudit encore à ton retour."
,"20":"Yahvé enverra sur toi la malédiction, la confusion et la menace dans tout ce que tu entreprendras, dans tout ce que tu exécuteras. Tu seras balayé, exterminé, parce que tu auras fait le mal et que tu m'auras abandonné."
,"21":"Yahvé t'enverra la peste; elle te collera à la peau jusqu'à ce que tu sois effacé de cette terre où tu vas entrer pour la posséder."
,"22":"Yahvé te frappera d'épuisement, de fièvre, de brûlures, de sécheresse, de rouille et de nielle; et tous ces fléaux te poursuivront jusqu'à ce que tu en meures."
,"23":"Au-dessus de ta tête les cieux seront de bronze, à tes pieds la terre sera de fer."
,"24":"Au lieu de pluie, Yahvé enverra sur la terre le sable et la poussière; ils descendront des cieux sur toi, et toi tu seras balayé."
,"25":"Yahvé te fera battre par tes ennemis. Tu iras à leur rencontre par un seul chemin, mais par sept chemins tu fuiras devant eux. Tu seras un objet d'horreur pour toutes les nations de la terre."
,"26":"Ton cadavre servira de pâture à tous les oiseaux du ciel et aux bêtes de la terre, et personne ne s'en préoccupera."
,"27":"Yahvé te frappera d'ulcères comme l'Egypte, d'hémorroïdes, de tumeurs et de gale, et il n'y aura pas de guérison pour toi."
,"28":"Yahvé te frappera de délire, d'aveuglement et de folie."
,"29":"Tu tâtonneras en plein midi comme un aveugle dans l'obscurité, tu échoueras dans toutes tes entreprises; tous les jours tu seras écrasé et dépouillé, mais personne ne viendra à ton secours."
,"30":"Tu te fianceras à une femme, mais c'est un autre qui la prendra. Tu bâtiras une maison, mais tu ne l'habiteras pas. Tu planteras une vigne, mais tu n'en mangeras pas les fruits."
,"31":"Ton boeuf sera égorgé sous tes yeux et tu n'en mangeras pas. Ton âne sera enlevé à côté de toi et on ne te le rendra pas. Tes brebis seront données à tes ennemis et personne ne viendra à ton secours."
,"32":"Tes fils et tes filles seront captifs d'un autre peuple, tes yeux le verront et tu en seras dans la tristesse tout au long des jours, mais ta main ne pourra rien faire."
,"33":"Un peuple que tu n'as pas connu, mangera le fruit de ton sol et tout le produit de ton travail. Tous les jours tu seras opprimé, écrasé."
,"34":"Tout ce que tu verras te rendra fou."
,"35":"Yahvé te frappera de mauvais ulcères sur les genoux et sur les cuisses, mais il n'y aura pas de guérison, de la plante des pieds au sommet de la tête."
,"36":"Yahvé vous emmènera avec le roi que tu auras établi sur toi, vers une nation que vous ne connaissiez pas, ni toi ni tes pères. Et là-bas tu seras au service d'autres dieux de bois et de pierre."
,"37":"Ainsi tu deviendras un objet d'étonnement, de moqueries; tu seras méprisé de tous les peuples où Yahvé ton Dieu t'aura conduit."
,"38":"Tu sèmeras beaucoup dans ton champ et tu récolteras peu, car la sauterelle aura dévoré la semence."
,"39":"Tu planteras des vignes, tu les travailleras, mais tu n'en boiras pas le vin; tu ne récolteras rien, car le ver aura tout mangé."
,"40":"Tu auras des oliviers dans tout ton pays, mais tu n'auras pas d'huile pour te parfumer, car tes olives seront tombées."
,"41":"Tu engendreras des fils et des filles, mais ils ne seront pas pour toi, car ils partiront en captivité."
,"42":"Le grillon dévorera tous tes arbres et les fruits de ton sol."
,"43":"L'étranger qui vit au milieu de toi se fera ton rival; il montera plus haut que toi, et toi, tu descendras plus bas que terre."
,"44":"C'est l'étranger qui te prêtera, et toi, tu emprunteras; il sera en tête et toi, tu seras à la queue."
,"45":"Toutes ces malédictions viendront sur toi, elles te poursuivront et t'atteindront jusqu'à ce que tu sois balayé, car tu n'auras pas écouté la voix de Yahvé ton Dieu, parce que tu n'auras pas obéi aux commandements et aux ordres qu'il t'a donnés."
,"46":"Ces malédictions resteront sur toi et sur ta race, à jamais, comme un signe et un prodige."
,"47":"Comme tu n'auras pas servi Yahvé ton Dieu dans la joie, en y mettant tout ton coeur, alors que tu avais tout en abondance,"
,"48":"tu serviras dans la faim et dans la soif, dans la nudité et dans la privation de tout, l'ennemi que Yahvé aura envoyé contre toi. Il posera sur ton cou un joug de fer, jusqu'à ce qu'il t'ait fait disparaître."
,"49":"Des extrémités de la terre, de très loin, Yahvé enverra contre toi, comme un vol d'aigles, une nation dont tu ne connais pas la langue."
,"50":"Cette race au visage redoutable n'aura ni égard pour le vieillard, ni pitié pour l'enfant."
,"51":"Elle mangera le produit de ton bétail et les fruits de tes champs, jusqu'à ce que tu aies disparu. Elle ne te laissera ni blé, ni vin, ni huile fraîche, ni les portées de tes vaches, ni celles de tes brebis; et elle te fera disparaître."
,"52":"Elle t'assiégera dans toutes tes villes; dans tout le pays tes hautes murailles tomberont, ces murailles fortifiées dans lesquelles tu avais placé ta confiance. Elle t'assiégera dans toutes tes villes, dans tout le pays que Yahvé ton Dieu t'avait donné."
,"53":"Tu seras réduit à une telle angoisse et une telle détresse à cause de tes ennemis, que tu mangeras le fruit de tes entrailles, la chair de tes fils et des filles que Yahvé ton Dieu t'avait donnés."
,"54":"L'homme le plus tendre et le plus raffiné parmi vous, regardera d'un oeil jaloux son frère, ou la femme qui dort sur son sein, ou les enfants qu'il aura encore épargnés."
,"55":"Car il craindra de devoir partager avec eux la chair de ses fils qu'il est en train de manger, tellement sera grand son dénuement, tellement seront grandes l'angoisse et la détresse dans tes villes à cause de tes ennemis."
,"56":"La femme la plus tendre et la plus raffinée parmi vous, qui faisait des manières pour poser le pied à terre, regardera d'un oeil mauvais l'homme qui dort avec elle ou son fils ou sa fille,"
,"57":"pendant qu'elle mangera en cachette l'arrière-faix qui est sorti d'elle et le fils qu'elle vient d'enfanter, si grand sera son dénuement à cause du siège et de la détresse à laquelle tes ennemis t'auront réduit."
,"58":"Si tu ne pratiques pas avec soin toutes les paroles de cette Loi, comme elles sont écrites dans ce livre; si tu ne crains pas le Nom glorieux et redoutable de Yahvé ton Dieu,"
,"59":"Yahvé te frappera, toi et ta descendance, de plaies extraordinaires, de grands fléaux qui ne s'arrêteront pas, d'épidémies terribles qui ne cesseront pas."
,"60":"Il fera revenir sur toi toutes les plaies d'Egypte qui te faisaient si peur, et elles s'attacheront à toi."
,"61":"Toutes ces maladies et tous les autres fléaux qui ne sont pas nommés dans ce livre de la Loi, Yahvé les fera venir contre toi jusqu'à ce que tu sois balayé."
,"62":"Vous qui étiez aussi nombreux que les étoiles du ciel, vous ne serez plus qu'un petit nombre, car vous n'aurez pas écouté la voix de Yahvé votre Dieu."
,"63":"De même que Yahvé avait pris plaisir à vous faire du bien et à vous multiplier, de même il prendra plaisir alors à vous faire périr et à vous exterminer, jusqu'à vous arracher de la terre où tu vas entrer pour la posséder."
,"64":"Yahvé te dispersera parmi toutes les nations, d'une extrémité de la terre à l'autre; là tu serviras d'autres dieux que ni toi ni tes pères n'aviez connus, des dieux de bois et de pierre."
,"65":"Au milieu de ces nations, il n'y aura pour toi ni paix ni repos. Yahvé te donnera là-bas un coeur craintif, des yeux sans vie et un esprit inquiet."
,"66":"Ta vie ne tiendra qu'à un fil, tu seras angoissé de nuit et de jour, tu ne croiras plus à l'avenir."
,"67":"Le matin tu diras: 'Vivement la nuit!' Et le soir tu diras: 'Vivement le matin!' Car l'angoisse obsédera ton coeur à cause de ce que verront tes yeux."
,"68":"Yahvé te fera retourner en Egypte par terre et par mer, - et pourtant je t'avais dit: Tu ne reverras plus ce pays. Là vous irez vous vendre à vos ennemis comme esclaves ou comme servantes, et vous ne trouverez pas d'acheteur.'"
,"69":"Ce sont là les paroles de l'Alliance que Yahvé demanda à Moïse de conclure avec les Israélites au pays de Moab, en plus de l'Alliance qu'il avait conclue avec eux à l'Horeb."
}`)
	CurrentBook.AddChapter(29, `{
"1":"Moïse rassembla tout Israël et lui dit: 'Vous avez vu tout ce que Yahvé a fait sous vos yeux dans le pays d'Egypte, contre le Pharaon, contre ses serviteurs et tout son pays."
,"2":"Vos yeux ont vu toutes ces grandes épreuves, ces signes et ces prodiges,"
,"3":"mais jusqu'à ce jour Yahvé ne vous a pas donné un coeur pour connaître, des yeux pour voir et des oreilles pour entendre."
,"4":"Cela fait quarante ans que je vous conduis dans le désert, et vos vêtements ne se sont pas usés sur vous, ni vos sandales à vos pieds."
,"5":"Vous n'aviez pas de pain à manger, vous n'aviez pas de vin ou de boisson fermentée, et c'est ainsi que vous avez appris comment je suis Yahvé votre Dieu."
,"6":"Quand vous êtes arrivés dans ce lieu, Sihon, roi de Heshbon, et Og, roi du Bashan, sont sortis à notre rencontre pour nous combattre, et nous les avons écrasés."
,"7":"Nous avons pris leur pays et nous l'avons donné en héritage à Ruben, à Gad et à la moitié de la tribu de Manassé."
,"8":"Observez donc maintenant les paroles de cette Alliance, mettez-les en pratique, afin de réussir dans toutes vos entreprises."
,"9":"Vous êtes tous ici aujourd'hui en présence de Yahvé votre Dieu, avec vos chefs, vos tribus, vos anciens et vos scribes, avec tous les hommes d'Israël,"
,"10":"avec vos enfants, vos femmes et l'étranger qui est au milieu du camp, avec celui qui coupe le bois et celui qui puise ton eau."
,"11":"C'est le moment de prêter serment et d'entrer dans l'Alliance que Yahvé ton Dieu conclut en ce jour avec toi."
,"12":"Il te choisit aujourd'hui pour son peuple et il devient ton Dieu, comme il te l'a dit et comme il l'a juré à tes pères Abraham, Isaac et Jacob."
,"13":"Ce n'est pas seulement avec vous que je conclus cette Alliance au moyen d'un serment,"
,"14":"mais avec tous ceux qui se tiennent aujourd'hui avec nous en présence de Yahvé notre Dieu et tous ceux qui ne sont pas avec nous en ce jour."
,"15":"Vous vous rappelez comment nous avons séjourné en Egypte, et comment nous sommes passés au milieu des nations que nous avons traversées."
,"16":"Vous avez vu les horreurs et les idoles de bois et de pierre, d'argent et d'or, qui se trouvent chez elles."
,"17":"Que personne parmi vous, homme, femme, famille ou clan, ne se détourne aujourd'hui de Yahvé notre Dieu pour aller servir les dieux de ces nations. Que nulle racine amère, nulle plante vénéneuse ne se lève parmi vous."
,"18":"C'est pourquoi, si quelqu'un se considère en sûreté malgré ces avertissements et qu'il pense: 'Je serai tranquille en n'en faisant qu'à ma tête: le juste et le pécheur périssent pareillement!'"
,"19":"Yahvé ne voudra pas lui pardonner. La colère et la jalousie de Yahvé s'enflammeront contre cet homme, toutes les malédictions qui sont écrites dans ce livre tomberont sur lui et Yahvé effacera son nom de dessous les cieux."
,"20":"Yahvé le retranchera des tribus d'Israël, et toutes les malédictions de l'Alliance écrites dans le livre de la Loi tomberont sur lui pour son malheur."
,"21":"Quand la génération future verra les plaies de ce pays et les fléaux dont Yahvé l'aura frappé, vos fils qui viendront après vous et l'étranger qui arrivera d'un pays lointain diront:"
,"22":"'Ce n'est que soufre et sel, une terre brûlée; rien n'est semé, rien ne germe, aucune herbe ici ne se lève. C'est comme après la catastrophe de Sodome et de Gomorrhe, d'Adma et de Séboim, que Yahvé a bouleversées dans sa colère et sa fureur.'"
,"23":"Dans tous les pays on dira: 'Pourquoi Yahvé a-t-il traité ainsi ce pays? Pourquoi sa colère s'est-elle ainsi enflammée?'"
,"24":"Et l'on répondra: 'C'est parce qu'ils ont abandonné l'Alliance de Yahvé, le Dieu de leurs pères, Alliance qu'il avait conclue avec eux quand il les fit sortir d'Egypte."
,"25":"Ils sont allés servir d'autres dieux, ils se sont prosternés devant ces dieux qu'ils ne connaissaient pas et que Yahvé ne leur avait pas donné en partage."
,"26":"C'est pourquoi sa colère s'est enflammée contre ce pays, et il a fait venir sur lui toute la malédiction qui est dite dans ce livre."
,"27":"Yahvé les a balayés de dessus leur terre avec colère, emportement et grande fureur, et il les a jetés sur cette autre terre où ils sont aujourd'hui.'"
,"28":"Les choses cachées appartiennent à Yahvé notre Dieu, mais ce qui est révélé est à nous et à nos fils à jamais: à nous de pratiquer toutes les paroles de cette Loi."
}`)
	CurrentBook.AddChapter(30, `{
"1":"Tout ce que je viens de te dire se réalisera pour toi: les promesses de bénédiction, mais aussi les malédictions. Quand tu te retrouveras chez ces nations où Yahvé ton Dieu t'aura chassé, tu te les rappelleras sérieusement."
,"2":"Si alors, toi et tes fils, vous revenez à Yahvé ton Dieu, si vous écoutez sa voix de tout votre coeur et de toute votre âme, comme je vous le demande aujourd'hui,"
,"3":"Yahvé ton Dieu ramènera tes captifs, il aura pitié de toi et te rassemblera du milieu de tous les peuples où il t'aura dispersé."
,"4":"Même si ton peuple était chassé jusqu'aux extrémités du ciel, de là-bas Yahvé te rassemblerait; ton Dieu irait là-bas te reprendre."
,"5":"Yahvé ton Dieu te ramènera dans le pays que possédaient tes pères, et de nouveau tu le posséderas, il te bénira et te rendra plus nombreux que tes pères."
,"6":"Yahvé ton Dieu circoncira ton coeur et le coeur de ta race pour que tu aimes ton Dieu de tout ton coeur et de toute ton âme et que tu vives."
,"7":"Alors Yahvé ton Dieu fera retomber toutes ces malédictions sur tes ennemis, sur ceux qui t'auront persécuté parce qu'ils te haïssent."
,"8":"Mais toi tu reviendras et tu écouteras la voix de Yahvé, tu mettras en pratique tous ses commandements que je te donne aujourd'hui."
,"9":"De son côté, Yahvé ton Dieu fera que tu sois heureux dans tout ce que tu entreprendras: il bénira le fruit de tes entrailles, le fruit de ton bétail et le fruit de tes champs. Oui, de nouveau Yahvé prendra plaisir à ton bonheur comme il prenait plaisir au bonheur de tes pères,"
,"10":"puisque tu écouteras sa voix. Car tu observeras les commandements et les préceptes de Yahvé ton Dieu, tout ce qui est écrit dans ce livre de la Loi, et tu reviendras vers Yahvé ton Dieu de tout ton coeur et de toute ton âme."
,"11":"Ce commandement que je te donne aujourd'hui n'est pas impossible pour toi, il n'est pas au-dessus de tes forces."
,"12":"Il n'est pas dans les cieux, car alors tu pourrais dire: 'Qui montera jusqu'aux cieux pour nous le chercher? Qui nous le fera entendre, pour que nous le mettions en pratique?'"
,"13":"Il n'est pas non plus au-delà des mers, car alors tu pourrais dire: 'Qui traversera la mer pour nous le chercher? Qui nous le fera entendre, pour que nous le mettions en pratique?'"
,"14":"Non, cette parole est toute proche de toi: tu l'as à la bouche, tu la sais par coeur, tu n'as qu'à la mettre en pratique."
,"15":"Regarde, je place aujourd'hui devant toi la vie et le bien, la mort et le mal."
,"16":"Ce que je te commande aujourd'hui, c'est d'aimer Yahvé ton Dieu, de marcher dans ses voies, d'observer ses commandements, ses préceptes et ses ordonnances. Alors tu vivras et tu te multiplieras: Yahvé ton Dieu te bénira dans le pays où tu vas entrer pour le posséder."
,"17":"Mais si ton coeur se détourne de Yahvé, si tu ne l'écoutes pas, si tu te laisses entraîner, si tu adores d'autres dieux et si tu les sers,"
,"18":"je te le dis aujourd'hui solennellement: vous êtes sûrs de mourir. Vous ne durerez pas dans le pays où tu vas entrer pour le posséder, après avoir traversé le Jourdain."
,"19":"Je prends aujourd'hui les cieux et la terre comme témoins de cette mise en garde: j'ai placé devant toi la vie et la mort, la bénédiction et la malédiction. Choisis donc la vie pour que tu vives, et ta race aussi après toi."
,"20":"Tu aimeras Yahvé ton Dieu, tu écouteras sa voix, tu t'attacheras à lui. C'est pour toi une question de vie, là est pour toi l'assurance de jours nombreux dans le pays que Yahvé a juré à tes pères Abraham, Isaac et Jacob, de leur donner."
}`)
	CurrentBook.AddChapter(31, `{
"1":"Moïse rapporta toutes ces paroles à Israël. Il ajouta:"
,"2":"'Me voici âgé de cent vingt ans. Déjà je ne peux plus aller et venir et Yahvé m'a dit que je ne traverserais pas ce Jourdain."
,"3":"Mais Yahvé ton Dieu passera lui-même devant toi, il chassera toutes ces peuplades devant toi et tu les déposséderas. C'est Josué qui passera devant toi, comme Yahvé l'a dit."
,"4":"Yahvé traitera ces peuplades comme il a traité les deux rois des Amorites, Sihon et Og, ainsi que leur pays: il les a exterminés."
,"5":"Yahvé vous les livrera et vous les traiterez exactement comme je vous l'ai ordonné."
,"6":"Soyez forts et pleins de courage, n'ayez pas peur et ne tremblez pas devant eux puisque Yahvé ton Dieu marche avec toi. Il ne t'oubliera pas, il ne t'abandonnera pas.'"
,"7":"Moïse fit venir Josué et, devant tout Israël, il lui dit: 'Sois fort et plein de courage! C'est toi qui entreras avec ce peuple dans le pays que Yahvé a juré à vos pères de vous donner. C'est toi qui leur donneras leur héritage."
,"8":"Yahvé marchera devant toi, il sera avec toi. Il ne peut pas t'oublier ni t'abandonner; n'aie donc pas peur, ne crains pas.'"
,"9":"Moïse écrivit ensuite cette Loi, il la donna aux prêtres, aux Lévites qui portaient l'Arche de l'Alliance de Yahvé, ainsi qu'à tous les anciens d'Israël."
,"10":"Et Moïse leur donna cet ordre: 'Tous les sept ans, l'année de la rémission, lorsqu'arrive la fête des Tentes"
,"11":"et que tout Israël se présente devant Yahvé ton Dieu au lieu choisi par lui, toi, prêtre, tu liras cette loi devant lui pour qu'il l'écoute."
,"12":"Tu rassembleras tout le peuple, les hommes, les femmes, les petits enfants, même les étrangers qui habitent dans tes villes, pour qu'ils entendent et qu'ils apprennent à craindre Yahvé ton Dieu, et à mettre en pratique toutes les paroles de cette Loi."
,"13":"Ainsi leurs fils qui ne la connaissent pas encore l'entendront et l'apprendront. Et tout le temps qu'ils vivront dans ce pays que tu vas posséder, après avoir traversé le Jourdain, ils craindront Yahvé ton Dieu.'"
,"14":"Yahvé dit à Moïse: 'Voici que les jours de ta mort approchent. Fais venir Josué et tenez-vous tous les deux dans la Tente du Rendez-Vous pour que je lui donne mes ordres.' Moïse alla donc avec Josué et ils se tinrent tous les deux dans la Tente du Rendez-Vous."
,"15":"Yahvé s'y manifesta dans une colonne de nuée: la colonne de nuée se tenait à l'entrée de la Tente."
,"16":"Yahvé dit à Moïse: 'Tu vas bientôt rejoindre tes pères, et ce peuple commencera à se prostituer avec les dieux étrangers. Il m'abandonnera et il brisera l'Alliance que j'ai conclue avec lui."
,"17":"Ce jour-là ma colère s'enflammera contre lui; j'abandonnerai ce peuple et je lui cacherai ma face: alors il sera bon à dévorer. Beaucoup de maux et de fléaux s'abattront sur lui. Ce jour-là il dira: Tous ces fléaux se sont abattus sur moi parce que mon Dieu n'était plus au milieu de moi."
,"18":"Mais moi, ce jour-là, je cacherai ma face à cause de tout le mal que ce peuple aura fait, parce qu'il se sera tourné vers d'autres dieux."
,"19":"Aussi vous allez écrire ce cantique pour l'enseigner aux Israélites; vous le leur ferez apprendre par coeur, et un jour il leur rappellera mes avertissements."
,"20":"Car je vais faire entrer ce peuple dans une terre où coulent le lait et le miel, dans la terre que j'ai juré à leurs pères de leur donner. Mais quand ils auront mangé, quand ils seront gras et rassasiés, ils se tourneront vers d'autres dieux et les serviront, ils me mépriseront et briseront mon Alliance."
,"21":"Bien des maux, bien des fléaux viendront alors s'abattre sur eux, mais ce cantique sera témoin contre eux, car leurs descendants ne l'auront pas oublié. Oui, je connais les mauvais sentiments qui vous animent aujourd'hui, avant même que je vous aie fait entrer dans ce pays que j'ai promis par serment.'"
,"22":"Moïse écrivit donc ce cantique, et il l'enseigna aux Israélites ce jour-là."
,"23":"Yahvé donna ses ordres à Josué, fils de Noun. Il lui dit: 'Sois fort et plein de courage! C'est toi qui feras entrer les Israélites dans le pays que je leur ai promis par serment, et moi je serai avec toi.'"
,"24":"Lorsque Moïse eut fini d'écrire dans un livre les paroles de la Loi,"
,"25":"il donna cet ordre aux Lévites qui portaient l'Arche de l'Alliance de Yahvé:"
,"26":"'Prenez ce livre de la Loi et mettez-le à côté de l'Arche de l'Alliance de Yahvé votre Dieu. Il sera là comme un témoin contre ce peuple."
,"27":"En effet, je connais votre esprit infidèle, votre caractère rebelle. Quand je suis encore en vie au milieu de vous, vous ne faites que vous rebeller contre Yahvé. A plus forte raison quand je serai mort!"
,"28":"Rassemblez donc autour de moi tous les anciens de vos tribus avec vos scribes. Je prononcerai ces paroles à leurs oreilles et je prendrai le ciel et la terre comme témoins contre eux."
,"29":"Oui, je le sais, après ma mort vous vous prostituerez, vous vous détournerez de la voie que je vous ai enseignée. C'est pourquoi le malheur viendra sur vous dans l'avenir, car vous aurez fait ce qui est mal aux yeux de Yahvé et vous l'aurez mis en colère par votre conduite."
,"30":"Moïse prononça donc d'un bout à l'autre devant toute l'assemblée d'Israël les paroles de ce cantique."
}`)
	CurrentBook.AddChapter(32, `{
"1":"Cieux, prêtez l'oreille et je parlerai, que la terre écoute les paroles de ma bouche!"
,"2":"Que mon enseignement descende comme la pluie, et que ma parole comme la rosée se répande , comme la pluie sur l'herbe verte, comme les ondées sur le gazon."
,"3":"Je vais invoquer le Nom de Yahvé: rendez hommage à notre Dieu!"
,"4":"Il est le rocher, son oeuvre est parfaite, toutes ses voies sont justes. Il est un Dieu de vérité, ennemi du mal, il est juste et il est droit."
,"5":"Il avait engendré des fils dans la droiture, ils se sont dévoyés: c'est une engeance perverse et mauvaise!"
,"6":"Est-ce là ta façon de remercier Yahvé, peuple fou et sans cervelle?,N'est-il pas ton père? c'est lui qui t'a créé, lui qui t'a façonné et mis en place."
,"7":"Souviens-toi des jours d'autrefois, rappelle-toi les années des siècles passés. Interroge ton père et il t'instruira, demande aux anciens et ils te répondront."
,"8":"Lorsque le Très-Haut disposait les nations, lorsqu'il répartissait les fils d'Adam, il fixa des bornes aux peuples, selon le nombre de leurs anges gardiens;"
,"9":"Mais la part de Yahvé, c'est son peuple, Jacob est son propre domaine."
,"10":"Il l'a trouvé dans une terre déserte, dans le chaos, les hurlements des terres sauvages. Il l'entoure et prend soin de lui, il le garde comme la prunelle de son oeil."
,"11":"Comme un aigle éveillant sa nichée, qui plane au-dessus de ses petits, Yahvé déploie sur Israël ses ailes, il le prend,et l'emporte sur son plumage."
,"12":"Lui n'a pas d'autre guide que Yahvé: pas un dieu étranger avec lui!"
,"13":"Yahvé l'installe au plus haut de la terre: Israël mange ce que produisent les champs. Yahvé lui donne à goûter le miel de la roche, l'huile secrète des durs rochers,"
,"14":"la crème des vaches et le lait des brebis, avec la graisse des agneaux, les béliers de Bashan et les boucs, et la meilleure farine de blé: le sang des raisins devient sa boisson."
,"15":"Mais Jacob a mangé, il est rassasié, Yéchouroun est gras et il se révolte: oui, te voilà gras, comblé, gavé!,Israël repousse son Dieu qui l'a façonné. Il méprise à présent le rocher qui le sauvait."
,"16":"Ils l'ont rendu jaloux, suivant des étrangers, ils l'ont mis en colère avec leurs horreurs."
,"17":"Ils ont offert des sacrifices,à des démons qui n'ont rien de Dieu, à des dieux qu'ils ne connaissaient pas, des dieux venus de la dernière heure, que leurs pères n'avaient pas appris à craindre."
,"18":"Quoi! tu laisses le rocher qui t'a donné la vie, tu méprises le Dieu qui t'a mis au monde?"
,"19":"Yahvé l'a vu, et il méprise,ces fils, ces filles qui l'ont mis en colère."
,"20":"Il a dit: Je leur cacherai ma face, et je verrai quel sera leur sort. Oui, c'est une race mauvaise, des fils incapables de fidélité."
,"21":"Ils m'ont rendu jaloux avec des dieux de rien, mis en colère par de sottes idoles: je les rendrai jaloux d'un peuple de rien, je les mettrai en colère par une nation sotte."
,"22":"Oui, le feu de ma colère s'est enflammé, sa flamme descend jusqu'au séjour des morts. Il dévore la terre et ses récoltes, il embrasera les fondations des montagnes."
,"23":"Je déchargerai sur eux mes fléaux, sur eux j'épuiserai mes flèches."
,"24":"Ils seront minés par la faim, les fièvres, la peste qui sème la mort. J'enverrai contre eux la dent des bêtes, et le venin de ce qui rampe dans la poussière."
,"25":"Au-dehors, l'épée fait ses ravages, et dans les maisons c'est l'effroi. Garçons et jeunes filles périront ensemble, l'enfant à la mamelle avec le vieillard."
,"26":"Je pensais les réduire en poussière, effacer leur souvenir du milieu des hommes,"
,"27":"mais je crains l'arrogance de leurs adversaires, je ne veux pas que leurs ennemis se trompent,et qu'ils disent: 'Notre main a été la plus forte, Yahvé n'y était pour rien.'"
,"28":"Cette nation ne sait pas se conduire, c'est une nation sans intelligence."
,"29":"Avec un peu de sagesse, ils comprendraient, ils verraient où cela les conduit."
,"30":"Quand un homme en poursuit mille, quand deux mettent dix mille en fuite, n'est-ce pas que leur Rocher les a vendus, que Yahvé lui-même les a livrés?"
,"31":"Lui est notre Rocher, devraient-ils dire, et ces peuples, leur roche n'est rien!,ils n'ont rien à nous apprendre."
,"32":"Car leur vigne est une vigne de Sodome, on l'a prise aux vignobles de Gomorrhe. Leurs raisins sont des raisins empoisonnés, leurs grappes sont des grappes amères."
,"33":"Leur vin est un venin de serpents, vrai poison de vipères."
,"34":"Israël n'est-il pas un joyau que je porte?,et que j'enferme dans mes trésors?"
,"35":"A moi la vengeance et le châtiment, car bientôt ils vont chanceler, tout proche est le jour de leur malheur, et sous peu viendra pour eux la ruine."
,"36":"Car Yahvé rendra justice à son peuple, il prendra en pitié ses serviteurs,lorsqu'il verra que leur vigueur s'épuise, qu'il n'y a plus chez eux esclave ni homme libre."
,"37":"Alors Il dira: Où sont leurs dieux, ce beau rocher où ils se réfugiaient,"
,"38":"qui mangeaient la graisse de leurs sacrifices,et buvaient le vin de leurs libations?,Qu'ils se lèvent aujourd'hui, qu'ils accourent,et les prennent sous leur protection!"
,"39":"Mais non, regardez: c'est moi qui suis Dieu, il n'y a pas d'autres dieux à côté de moi!,C'est moi qui fais mourir et qui fais vivre, c'est moi qui blesse et c'est moi qui guéris, et nul ne peut délivrer de ma main!"
,"40":"Je lève ma main vers le ciel et je jure: aussi vrai que je vis à jamais,"
,"41":"j'aiguiserai mon épée redoutable, et je prendrai sur moi de juger. Je me vengerai de mes ennemis, à ceux qui me haïssent, je rendrai la pareille."
,"42":"Mes flèches s'enivreront de sang, mon épée aura sa ration de victimes: le sang des morts et des prisonniers, les têtes ennemies avec leur tignasse!"
,"43":"Cieux, faites-lui fête, fils de Dieu, prosternez-vous devant lui!,Car il venge le sang de ses serviteurs, il rend la pareille à ses adversaires, et il purifie la terre de son peuple."
,"44":"Alors Moïse s'approcha avec Josué, fils de Noun, et il enseigna à tout le peuple les paroles de ce cantique."
,"45":"Lorsque Moïse eut achevé de dire toutes ces paroles à Israël,"
,"46":"il ajouta: 'Prenez à coeur toutes les paroles que je prononce aujourd'hui solennellement devant vous, ordonnez à vos fils de mettre soigneusement en pratique toutes les paroles de cette Loi."
,"47":"Vous lui apporterez toute votre attention, car elle est votre vie. C'est par elle que vous vivrez de longs jours sur la terre qui sera vôtre, quand vous aurez traversé le Jourdain.'"
,"48":"Ce même jour Yahvé dit à Moïse:"
,"49":"'Monte à cette chaîne des Abarim dans le pays de Moab, face à Jéricho, et gravis le mont Nébo. De là tu pourras voir le pays de Canaan que je donne aux Israélites en propriété."
,"50":"Puis meurs sur la montagne que tu vas gravir et tu seras réuni à ton peuple, comme Aaron ton frère est mort sur la montagne de Hor, et il a été réuni à son peuple."
,"51":"Tu sais bien que vous m'avez été infidèles aux eaux de Mériba, à Qadesh dans le désert de Tsin, quand tout Israël vous regardait: vous ne m'avez pas sanctifié devant les Israélites."
,"52":"C'est pourquoi tu verras le pays de loin, mais tu n'y entreras pas.'"
}`)
	CurrentBook.AddChapter(33, `{
"1":"Voici les bénédictions que Moïse, l'homme de Dieu, prononça sur les fils d'Israël avant de mourir."
,"2":"Il dit: Du Sinaï Yahvé est venu, de Séïr il s'est levé pour toi, Israël, du mont Paran il a montré sa splendeur. Voici qu'il arrive de Mériba de Qadesh, escorté de ses anges."
,"3":"Tu aimes tous les peuples, mais dans ta main est le peuple des saints. Les voici prosternés à tes pieds, et sur eux tombent tes paroles."
,"4":"Moïse nous a donné une Loi, elle est l'héritage de la communauté de Jacob."
,"5":"Yahvé fut alors pour Yéchouroun un roi: les chefs du peuple étaient rassemblés, les tribus d'Israël étaient unies."
,"6":"Que Ruben vive et qu'il ne meure pas, malgré le petit nombre de ses hommes."
,"7":"Voici ce qu'il dit pour Juda: O Yahvé , écoute la voix de Juda et ramène-le vers son peuple. Ses mains combattront pour lui et toi tu lui viendras en aide contre l'adversaire."
,"8":"Il dit pour Lévi: Tes Ourim et tes Toumim sont entre les mains d'un homme fidèle. Tu l'as éprouvé à Massa, tu l'as querellé aux eaux de Mériba."
,"9":"Il a pu dire de son père et de sa mère: 'Je ne les ai jamais vus', et ne pas reconnaître ses frères, et ne savoir rien de ses fils. Car il a la charge de ta Parole et la garde de ton Alliance."
,"10":"Tes prêtres enseignent tes préceptes à Jacob et ta Loi à Israël, ils présentent l'encens à tes narines, et l'holocauste sur ton autel."
,"11":"O Yahvé! bénis leur valeur, accueille l'oeuvre de leurs mains. Brise les reins de leurs ennemis, de ceux qui les haïssent, que plus jamais leurs ennemis ne se redressent!"
,"12":"Il dit pour Benjamin: Il est le bien-aimé de Yahvé, il habite en paix à côté de lui. Yahvé le protège sans cesse, il repose entre ses épaules."
,"13":"Il dit pour Joseph: Que son pays soit béni de Yahvé! qu'il lui donne la rosée, le précieux don du ciel, et les eaux de l'abîme souterrain,"
,"14":"ce que le soleil généreusement fait croître, et tout ce qui pousse au fil des mois."
,"15":"A lui les prémices des montagnes d'autrefois et les dons généreux des collines de toujours,"
,"16":"à lui le meilleur de la terre et de tous ses produits! Que les préférences de Celui qui habitait dans le Buisson reposent sur la tête de Joseph, sur celui qu'il a choisi parmi ses frères."
,"17":"Il est pour Lui comme un taureau premier-né, honneur à lui! Ses cornes sont des cornes de buffle; avec elles ils bouscule tous les peuples jusqu'aux confins de la terre: voyez ces myriades d'Ephraïm, ces milliers de Manassé!"
,"18":"Il dit pour Zabulon: Sois heureux Zabulon, dans tes expéditions, et toi, Issacar, dans tes tentes!"
,"19":"Ils rassembleront les peuples sur leur montagne, ils y offriront de justes sacrifices. Car ils goûtent les richesses des mers et les trésors cachés dans le sable."
,"20":"Il dit pour Gad: Béni soit celui qui met Gad au large! Il est couché comme une lionne, il déchire le bras et la tête."
,"21":"Il a jeté un regard sur la première part, il a vu qu'une part de chef l'attendait. Il a marché à la tête du peuple, il a accompli l'oeuvre de Yahvé et ses jugements envers Israël."
,"22":"Il dit pour Dan: Dan est comme un jeune lion qui bondit du Bashan."
,"23":"Il dit pour Nephtali: Nephtali est comblé de faveurs. Yahvé le comble de bénédictions: qu'il progresse vers la mer et vers le midi."
,"24":"Il dit pour Asher: Béni soit Asher plus que les autres fils, qu'il soit privilégié parmi ses frères et que ses pieds baignent dans l'huile!"
,"25":"Que tes verrous soient de fer et de bronze, et que ta force dure autant que tes jours!"
,"26":"O Yéchouroun, nul n'est comme Dieu, qui pour te secourir chevauche à travers les cieux, et vient sur les nuages dans sa majesté."
,"27":"Le Dieu des temps anciens est ton refuge; ses bras, qui t'abritent, sont là pour toujours. Devant toi il chasse l'ennemi et te dit: Détruis-le!"
,"28":"Israël demeure en sûreté, la source de Jacob coule à part, dans un pays de blé et de vin où le ciel répand sa rosée."
,"29":"Heureux es-tu, Israël! Qui est, comme toi, peuple sauvé par Yahvé? Il est le bouclier qui te secourt, l'épée qui te mène à la gloire. Tes ennemis chercheront à t'apaiser, mais toi, tu fouleras aux pieds leurs montagnes."
}`)
	CurrentBook.AddChapter(34, `{
"1":"Des Steppes-de-Moab, Moïse gravit le mont Nebo jusqu'au sommet du Pisga, face à Jéricho. Là Yahvé lui montra tout le pays: Galaad jusqu'à Dan, "
,"2":"Nephtali tout entier, le pays d'Ephraïm et de Manassé, tout le pays de Juda jusqu'à la mer occidentale,"
,"3":"le Négueb et la région du Jourdain, la vallée de Jéricho, la ville des palmiers, jusqu'à Soar."
,"4":"Puis Yahvé lui dit: 'Voici le pays que j'ai promis par serment à Abraham, Isaac et Jacob: je leur ai dit que je le donnerais à leur descendance. Je veux que tu voies ce pays de tes yeux, mais tu n'y entreras pas.'"
,"5":"C'est là, au pays de Moab, que Moïse le serviteur de Yahvé mourut, sur l'ordre de Yahvé."
,"6":"On l'enterra dans la vallée du pays de Moab, en face de Beth-Péor, mais personne n'a connu sa tombe jusqu'à ce jour."
,"7":"Moïse était âgé de cent vingt ans quand il mourut; son oeil ne s'était pas affaibli et sa vigueur ne s'était pas éteinte."
,"8":"Les Israélites pleurèrent Moïse dans les Steppes-de-Moab durant trente jours, après quoi s'achevèrent les jours de deuil pour Moïse."
,"9":"Josué, fils de Noun, était rempli de l'esprit de sagesse, car Moïse lui avait imposé les mains. C'est à lui qu'obéirent les Israélites: ils firent comme Yahvé l'avait ordonné à Moïse."
,"10":"Il ne s'est plus levé, en Israël, de prophète semblable à Moïse que Yahvé connaissait face à face."
,"11":"Que de signes et de prodiges pour lesquels Yahvé l'envoya! Que n'a-t-il pas fait en Egypte contre le Pharaon et tout son pays"
,"12":"quelle main puissante que celle de Moïse, et quelle autorité redoutable pour agir aux yeux de tout Israël!"
}`)

}
func FR_LBDCC_LoadVPEXChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Voici les noms des Israélites qui entrèrent en Egypte avec Jacob: chacun d'eux était venu avec sa famille."
,"2":"Ruben, Siméon, Lévi et Juda"
,"3":"Issacar, Zabulon et Benjamin"
,"4":"Dan et Nephtali, Gad et Asher."
,"5":"Les descendants de Jacob étaient au nombre de soixante-dix personnes. Quant à Joseph, il était déjà en Egypte."
,"6":"Joseph mourut le premier et, après lui, tous ses frères et toute cette génération."
,"7":"Les Israélites étaient très féconds, ils se multiplièrent et se développèrent à tel point que le pays en fut rempli."
,"8":"Un nouveau roi qui n'avait pas connu Joseph gouverna l'Egypte."
,"9":"Il dit à son peuple: 'Le peuple israélite est maintenant plus nombreux et plus fort que le nôtre."
,"10":"Il nous faut prendre des précautions pour l'empêcher de se développer davantage. Sinon, en cas de guerre, il pourrait bien se joindre à nos ennemis et nous combattre pour quitter ensuite ce pays.'"
,"11":"Alors on imposa aux Israélites des chefs de corvée pour les accabler de travail, et c'est ainsi que l'on construisit les villes qui servaient d'entrepôts pour le Pharaon: Pithom et Ramsès."
,"12":"Mais plus on les opprimait, plus le peuple grandissait et se développait, si bien que l'on ne supportait plus les Israélites."
,"13":"Les Egyptiens réduisirent les Israélites en esclavage."
,"14":"Ils leur rendirent la vie insupportable: ils leur imposèrent par la violence le travail du mortier et des briques et tous les travaux de la campagne."
,"15":"Le roi d'Egypte finit par s'adresser aux deux femmes qui accouchaient les Hébreux: Chifra et Poua. Il leur dit:"
,"16":"'Lorsque vous accoucherez les femmes des Hébreux et qu'elles seront accroupies sur les deux pierres, regardez: si c'est un fils, faites-le mourir; si c'est une fille, laissez-la vivre.'"
,"17":"Mais les accoucheuses craignaient Dieu. Elles refusèrent d'obéir au roi d'Egypte et laissèrent vivre les garçons."
,"18":"Le roi d'Egypte appela les accoucheuses et leur dit: 'Pourquoi avez-vous fait cela? Vous avez laissé vivre les garçons!'"
,"19":"Les accoucheuses répondirent au Pharaon: 'Les femmes des Hébreux ne sont pas comme les Egyptiennes, elles sont vigoureuses et, avant que l'accoucheuse n'arrive auprès d'elles, elles ont déjà accouché.'"
,"20":"Dieu était avec les accoucheuses, si bien que le peuple augmenta et devint très puissant."
,"21":"Quant aux accoucheuses qui l'avaient craint, Dieu leur donna une nombreuse famille."
,"22":"Pharaon donna donc cet ordre à tout son peuple: 'Vous jetterez dans le Nil tous les garçons qui naîtront, mais vous laisserez vivre les filles.'"
}`)
	CurrentBook.AddChapter(2, `{
"1":"Un homme de la tribu de Lévi épousa une fille de sa tribu."
,"2":"La femme fut enceinte et mit au monde un fils; voyant combien il était beau, elle le dissimula pendant trois mois."
,"3":"Comme elle ne pouvait pas le cacher plus longtemps, elle prit une corbeille de papyrus, elle boucha les fentes avec du goudron et elle y mit son enfant, puis elle déposa la corbeille dans les roseaux sur les bords du Nil."
,"4":"La soeur de l'enfant se tenait à distance pour voir ce qui allait arriver."
,"5":"Or la fille du Pharaon descendit vers le Nil pour se baigner, pendant que ses servantes faisaient les cent pas sur la rive du Nil. Quand elle aperçut la corbeille au milieu des roseaux, elle envoya sa servante pour la prendre."
,"6":"Ouvrant la corbeille, elle vit l'enfant: c'était un petit garçon qui pleurait. Elle eut pitié de lui: 'C'est un enfant des Hébreux', se dit-elle."
,"7":"La soeur de l'enfant dit à la fille du Pharaon: 'Veux-tu que je cherche parmi les femmes des hébreux? Je m'entendrai avec une nourrice qui allai tera l'enfant.'"
,"8":"'Va vite!', lui répondit la fille du Pharaon. La jeune fille partit et appela la mère de l'enfant."
,"9":"La fille du Pharaon lui dit: 'Emmène cet enfant, allaite-le moi et je te donnerai ton salaire.'"
,"10":"La femme prit donc le petit garçon et l'allaita; quand il eut grandi, elle le mena à la fille du Pharaon. Il devint pour elle comme un fils et elle lui donna le nom de Moïse, car, dit-elle: 'Je l'ai tiré des eaux!'"
,"11":"Moïse avait grandi, il alla trouver ses frères et vit avec quelle brutalité on les traitait. Il vit même un Egyptien qui frappait l'un de ses frères hébreux."
,"12":"Il regarda autour de lui: il n'y avait per sonne. Il frappa l'Egyptien et l'enterra dans le sable."
,"13":"Le lendemain encore il sortit et vit deux Hébreux qui se battaient. Il dit alors au plus méchant: 'Pourquoi frappes-tu ton camarade?'"
,"14":"L'homme lui répondit: 'Qui t'a nommé notre chef ou notre juge? Veux-tu me tuer comme tu as tué l'Egyptien?' Moïse eut peur: 'Certainement la chose est connue', se dit-il."
,"15":"Le Pharaon en effet apprit l'affaire et il chercha Moïse pour le tuer. Alors Moïse s'enfuit loin du Pharaon et alla vivre au pays de Madian. Là, il s'assit près d'un puits."
,"16":"Un prêtre de Madian avait sept filles. Elles vinrent chercher de l'eau et remplirent les abreuvoirs pour le petit bétail de leur père."
,"17":"A ce moment-là arrivèrent des bergers qui voulurent les chasser, mais Moïse se leva pour les défendre et donna à boire au petit bétail."
,"18":"Comme elles rentraient chez leur père Ragouël, celui-ci leur dit: 'Comment se fait-il que vous reveniez si vite aujourd'hui?'"
,"19":"Elles répondirent: 'Un Egyptien nous a délivrées des bergers. Il a même puisé de l'eau pour nous et a donné à boire au petit bétail.'"
,"20":"Il dit à ses filles: 'Où est cet homme? Pourquoi l'avez-vous laissé? Il faut l'inviter à manger.'"
,"21":"Moïse accepta de vivre chez cet homme qui lui donna en mariage sa fille Séfora."
,"22":"Elle lui donna un fils qu'il appela Guerchom car, dit-il: 'Je suis un immigré sur une terre étrangère.'"
,"23":"Or le roi d'Egypte mourut au cours de cette longue période. Les Israélites gémissaient sous le poids de leur esclavage, ils crièrent et leur cri montait de leurs lieux de travail jusqu'à Dieu."
,"24":"Dieu entendit leur plainte et Dieu se souvint de son alliance avec Abraham, Isaac et Jacob."
,"25":"Dieu vit les fils d'Israël et Dieu se fit connaître d'eux."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Moïse gardait le petit bétail de Jéthro, son beau-père, qui était prêtre de Madian. Il mena le petit bétail loin dans le désert et arriva jusqu'à l'Horeb, la montagne de Dieu."
,"2":"C'est alors que l'ange de Yahvé se manifesta à lui comme une flamme de feu au milieu d'un buisson. Moïse regarda: le buisson était tout en flammes, mais il n'était pas dévoré par le feu."
,"3":"Moïse se dit: 'Je vais faire un détour pour voir cette chose extraordinaire: pourquoi le buisson ne se consume-t-il pas?'"
,"4":"Yahvé vit que Moïse faisait un détour pour voir, et Dieu l'appela du milieu du buisson: 'Moïse! Moïse!' Il répondit: 'Me voici!'"
,"5":"Dieu dit: 'N'approche pas d'ici! Retire tes sandales de tes pieds, car l'endroit où tu te trouves est un lieu saint.'"
,"6":"Il ajouta: 'Je suis le Dieu de ton père, le Dieu d'Abraham, le Dieu d'Isaac et le Dieu de Jacob.' Alors Moïse se cacha le visage, car il avait peur que son regard ne rencontre Dieu."
,"7":"Yahvé dit: 'J'ai vu mon peuple humilié en Egypte et j'ai entendu ses cris lorsque ses surveillants le maltraitent. Oui, je connais ses souffrances!"
,"8":"Je suis donc descendu pour le délivrer de la main des Egyptiens et pour le faire monter d'ici vers une terre spacieuse et fertile, un pays où coulent le lait et le miel, là où habitent les Cananéens, les Hittites, les Amorites, les Périsites, les Hivvites et les Jébusites. "
,"9":"Le cri des Israélites est maintenant venu jusqu'à moi, j'ai vu les mauvais traitements que leur infligent les Egyptiens."
,"10":"Va donc! Je t'envoie vers le Pharaon pour faire sortir d'Egypte mon peuple, les fils d'Israël.'"
,"11":"Moïse dit à Dieu: 'Qui suis-je pour aller trouver le Pharaon et pour faire sortir d'Egypte les Israélites?'"
,"12":"Dieu répondit: 'Je serai avec toi, et je te donne un signe par lequel tu reconnaîtras que c'est moi qui t'ai envoyé: lorsque tu feras sortir le peuple d'Egypte, vous servirez Dieu sur cette montagne.'"
,"13":"Moïse dit à Dieu: 'Bien! Je vais aller trouver les Israélites et je leur dirai: Le Dieu de vos pères m'a envoyé vers vous. Mais ils me diront: 'Quel est son nom?' Que vais-je leur répondre?'"
,"14":"Dieu dit à Moïse: 'Je suis: JE SUIS!' Puis il ajouta: 'Tu diras aux Israélites: JE SUIS m'a envoyé vers vous.'"
,"15":"Dieu dit encore à Moïse: 'Voici ce que tu diras aux Israélites: YAHVE, le Dieu de vos pères, le Dieu d'Abraham, le Dieu d'Isaac et le Dieu de Jacob m'a envoyé vers vous. Ce sera là mon nom pour toujours, c'est ainsi que l'on m'invoquera de génération en génération."
,"16":"Va! Tu réuniras les anciens d'Israël et tu leur diras: Yahvé, le Dieu de vos pères, m'est apparu. Le Dieu d'Abraham, d'Isaac et de Jacob m'a dit: Je viens vous visiter pour de bon, car j'ai vu ce que vous font les Egyptiens."
,"17":"J'ai décidé de vous faire monter de l'Egypte où l'on vous opprime, vers le pays des Cananéens, des Hittites, des Amorites, des Périsites, des Hivvites et des Jébusites, vers un pays où coulent le lait et le miel."
,"18":"Les anciens d'Israël écouteront ta voix, et avec eux tu iras trouver le roi d'Egypte. Vous lui direz: Yahvé, le Dieu des Hébreux, est venu à notre rencontre: laisse-nous aller à trois jours de marche dans le désert pour sacrifier à Yahvé notre Dieu."
,"19":"Le roi d'Egypte ne vous laissera pas partir, il faudra une main puissante pour l'y obliger: je le sais!"
,"20":"Mais j'étendrai ma main et je ferai bien des miracles en Egypte pour frapper son pays, après quoi il vous renverra."
,"21":"Je ferai que les Egyptiens soient bien disposés pour votre peuple, et lorsque vous vous mettrez en marche, vous ne partirez pas les mains vides."
,"22":"Chaque femme empruntera à sa voisine, ou à celle qui habite dans sa maison, des objets en argent, en or et des vêtements. Vos fils et vos filles se les mettront et ainsi vous laisserez les Egyptiens sans rien.'"
}`)
	CurrentBook.AddChapter(4, `{
"1":"Moïse répondit à Dieu: 'Ils ne me croiront pas et ne m'écouteront pas. Ils me diront: Yahvé ne t'est pas apparu!'"
,"2":"Yahvé lui dit: 'Qu'as-tu dans ta main?' Il répondit: 'Un bâton!'"
,"3":"Yahvé lui dit: 'Jette-le à terre!' Il le jeta à terre et le bâton devint un serpent: Moïse se jeta en arrière."
,"4":"Yahvé lui dit: 'Etends ta main! prends-le par la queue!' Moïse étendit la main et le prit; le serpent redevint un bâton dans sa main."
,"5":"'Ainsi ils croiront que Yahvé, le Dieu de leurs pères, le Dieu d'Abraham, le Dieu d'Isaac et le Dieu de Jacob t'est bien apparu.'"
,"6":"Yahvé lui dit encore: 'Mets donc ta main dans ton vêtement!' Il mit sa main dans son vêtement et l'en retira. Or voici que sa main était couverte de lèpre, blanche comme la neige."
,"7":"Yahvé lui dit: 'Remets ta main dans ton vêtement!' Il remit sa main dans son vêtement et, quand il la retira, elle était saine comme le reste de son corps."
,"8":"'S'ils ne croient pas et ne t'écoutent pas après le premier signe, ils croiront au second."
,"9":"Et s'ils ne croient à aucun de ces deux signes, s'ils ne veulent pas t'écouter, tu prendras de l'eau dans le Nil, tu la répandras sur la terre sèche, et l'eau que tu auras prise dans le Nil se changera en sang sur la terre sèche.'"
,"10":"Moïse dit à Yahvé: 'Je t'en supplie, mon Seigneur! Je n'ai jamais su bien parler, et ce n'est pas mieux depuis que tu parles à ton serviteur. Je ne trouve pas les mots pour m'exprimer.'"
,"11":"Yahvé lui répondit: 'Qui a donné une bouche à l'homme? Qui le rend muet ou sourd, clairvoyant ou aveugle? N'est-ce pas moi, Yahvé?"
,"12":"Va donc: je mettrai dans ta bouche les paroles que tu devras dire.'"
,"13":"Moïse dit alors: 'Je t'en supplie, mon Seigneur! Envoie ton message par qui tu voudras.'"
,"14":"Cette fois, Yahvé se mit en colère contre Moïse et lui dit: 'Ton frère Aaron, le Lévite, n'est-il pas là? Je sais qu'il a la parole facile. Le voici justement qui vient à ta rencontre et il sera tout heureux de te voir."
,"15":"Tu lui parleras, tu lui diras ce qu'il devra dire, et moi, je serai dans ta bouche et dans la sienne, et je vous dirai ce que vous devrez faire."
,"16":"Il parlera au peuple à ta place: toi avec lui, ce sera comme Dieu avec son prophète."
,"17":"Tu auras en main ce bâton, et avec lui tu feras des miracles!'"
,"18":"Moïse repartit vers son beau-père Jéthro et lui dit: 'Je voudrais m'en aller pour retrouver mes frères en Egypte, je veux voir s'ils sont encore en vie.' Jéthro répondit à Moïse: 'Va-t'en en paix!'"
,"19":"Yahvé dit à Moïse, au pays de Madian: 'Va! Retourne en Egypte, car tous ceux qui en voulaient à ta vie sont morts.'"
,"20":"Moïse prit donc sa femme et ses fils, les fit monter sur un âne, et retourna en Egypte. Moïse avait en main le bâton de Dieu."
,"21":"Yahvé dit à Moïse: 'Lorsque tu retourneras en Egypte, tu feras devant le Pharaon tous les prodiges que je t'ai mis en mains. Mais moi, je ferai qu'il s'entête, et il refusera de laisser partir mon peuple."
,"22":"Alors tu diras au Pharaon: 'Voici ce que dit Yahvé: Israël est mon fils premier-né."
,"23":"Je t'ai dit: Laisse partir mon fils pour qu'il me serve, mais toi, tu as refusé de le laisser partir! C'est pourquoi je vais tuer ton fils premier-né.'"
,"24":"Durant le voyage, à l'étape, Yahvé vint à la rencontre de Moïse et chercha à le faire mourir."
,"25":"Séfora prit alors un caillou, coupa le prépuce de son fils et en toucha les pieds de Moïse, puis elle dit: 'Tu es vraiment pour moi un époux de sang.'"
,"26":"Aussitôt Yahvé le laissa. Elle avait dit: 'Epoux de sang' à cause de la circoncision."
,"27":"Yahvé dit à Aaron: 'Va à la rencontre de Moïse dans le désert!' Il partit donc à la rencontre de Moïse à la montagne de Dieu, il l'embrassa."
,"28":"Moïse raconta à Aaron toutes les paroles de Yahvé qui l'envoyait en mission et tous les signes qu'il l'avait chargé de faire."
,"29":"Moïse et Aaron allèrent donc réunir tous les anciens des Israélites."
,"30":"Aaron leur rapporta toutes les paroles que Yahvé avait dites à Moïse, et il fit les signes sous les yeux du peuple."
,"31":"Le peuple crut, il comprit que Yahvé avait eu pitié des Israélites et qu'il avait vu leur humiliation. Ils se mirent à genoux et se prosternèrent."
}`)
	CurrentBook.AddChapter(5, `{
"1":"A la suite de cela, Moïse et Aaron allèrent dire au Pharaon: 'Voici une parole de Yahvé, le Dieu d'Israël: Laisse partir mon peuple pour qu'il me célèbre une fête dans le désert.'"
,"2":"Pharaon répondit: 'Qui est Yahvé, pour que j'écoute sa parole et que je laisse partir Israël? Je ne connais pas Yahvé et je ne laisserai pas partir Israël!'"
,"3":"Ils dirent: 'Le Dieu des Hébreux s'est présenté devant nous. Laisse-nous donc partir à trois jours de marche dans le désert, pour offrir un sacrifice à Yahvé notre Dieu. Autrement, il pourrait nous frapper par la peste ou par l'épée.'"
,"4":"Le roi d'Egypte leur dit: 'Moïse et Aaron, pourquoi détournez-vous le peuple de son travail? Retournez sur vos chantiers!'"
,"5":"Le Pharaon ajouta: 'Ils sont maintenant plus nombreux que le peuple du pays, et vous voudriez qu'ils arrêtent leur travail?'"
,"6":"Le jour même, Pharaon donna des ordres aux inspecteurs du peuple et aux surveillants."
,"7":"'Vous ne leur donnerez plus de paille pour fabriquer les briques, comme vous le faisiez jusqu'ici. Ils iront eux-mêmes ramasser la paille."
,"8":"Cependant vous exigerez d'eux la même quantité de briques que dans le passé, vous ne la réduirez pas. Ce sont des paresseux! C'est pour cela qu'ils viennent me crier: Laisse-nous aller pour offrir un sacrifice à notre Dieu!"
,"9":"Faites-les travailler davantage et ils ne se laisseront plus tourner la tête avec toutes ces bêtises.'"
,"10":"Les inspecteurs du peuple et les surveillants vinrent donc dire au peuple: 'Voici ce qu'a dit le Pharaon: On ne vous donnera plus de paille,"
,"11":"vous irez la chercher vous-mêmes là où vous en trouverez. Mais on ne vous diminuera pas la tâche!'"
,"12":"Le peuple se dispersa dans toute l'Egypte pour ramasser de la paille et la broyer."
,"13":"Les surveillants étaient sur eux et leur disaient: 'Terminez votre travail! Vous devez faire chaque jour la quantité prévue, comme quand il y avait de la paille!'"
,"14":"Les surveillants des Israélites, ceux qui avaient été mis à leur tête par les inspecteurs du Pharaon, reçurent des coups. On leur disait: 'Pourquoi n'a-t-on pas fait hier et aujourd'hui la même quantité de briques qu'auparavant?'"
,"15":"Les surveillants des Israélites vinrent se plaindre auprès du Pharaon: 'Pourquoi traites-tu ainsi tes serviteurs?"
,"16":"On ne donne plus de paille à tes serviteurs, et on leur dit: Faites des briques quand même! Et maintenant, on frappe tes serviteurs... ton peuple est réellement en faute!'"
,"17":"Le Pharaon répondit: 'Vous êtes des paresseux, oui, des paresseux! Voilà pourquoi vous dites: Laisse-nous offrir un sacrifice à Yahvé!"
,"18":"Maintenant donc, retournez au travail, on ne vous donnera pas de paille et vous fournirez la même quantité de briques qu'avant.'"
,"19":"Alors les surveillants se retournèrent contre les Israélites: 'On ne diminuera pas le nombre des briques, vous ferez chaque jour la quantité fixée.'"
,"20":"Comme ils sortaient de la maison du Pharaon, ils rencontrèrent Moïse et Aaron qui les attendaient."
,"21":"Ils leur dirent: 'Que Yahvé voie, et qu'il juge! A cause de vous le Pharaon et ses serviteurs ne peuvent plus nous sentir. Vous avez mis dans leurs mains l'épée pour nous tuer.'"
,"22":"Alors Moïse se tourna vers Yahvé et lui dit: 'Mon Seigneur, pourquoi as-tu fait du mal à ce peuple? Pourquoi m'as-tu envoyé?"
,"23":"Depuis le jour où je suis venu trouver le Pharaon pour lui parler en ton nom, il n'a cessé de maltraiter ce peuple et tu n'as rien fait pour le délivrer!'"
}`)
	CurrentBook.AddChapter(6, `{
"1":"Yahvé répondit à Moïse: 'Tu vas voir, je serai plus fort que le Pharaon. Non seulement il les laissera partir, mais même il les chassera de son pays.'"
,"2":"Dieu parla à Moïse et lui dit: 'Je suis Yahvé!"
,"3":"Je me suis manifesté à Abraham, à Isaac et à Jacob comme le Dieu de la Steppe: eux ne m'ont pas connu par mon nom de Yahvé."
,"4":"Pourtant j'ai établi mon alliance avec eux pour leur donner la terre de Canaan, la terre qu'ils ont parcourue comme des nomades."
,"5":"J'ai bien entendu le cri des Israélites à cause des Egyptiens qui les traitent en esclaves, et je me suis souvenu de mon alliance."
,"6":"Tu vas donc dire aux Israélites: Je suis Yahvé, je vous ferai sortir de l'esclavage d'Egypte et je vous délivrerai de l'oppression. Je frapperai de grands coups pour vous racheter, je les corrigerai durement."
,"7":"Je ferai de vous mon peuple et je serai votre Dieu. Et vous saurez que je suis Yahvé votre Dieu, celui qui vous a fait sortir de l'esclavage d'Egypte."
,"8":"Je vous ferai entrer dans le pays que j'ai juré de vous donner, lorsque je parlais à Abraham, à Isaac et à Jacob; je vous le donnerai et il sera à vous, car je suis Yahvé.'"
,"9":"Moïse rapporta toutes ces paroles aux Israélites, mais ils n'étaient pas capables de l'écouter, vu la dureté de leur esclavage."
,"10":"Yahvé dit alors à Moïse:"
,"11":"'Va trouver Pharaon, le roi d'Egypte: qu'il renvoie les Israélites de son pays.'"
,"12":"Mais Moïse répondit à Yahvé: 'Si les Israélites ne m'ont pas écouté, comment veux-tu que le Pharaon m'écoute, moi qui ne sais même pas m'exprimer?'"
,"13":"Alors Yahvé parla à Moïse et à Aaron, il leur donna des instructions pour les Israélites et pour le Pharaon, roi d'Egypte, pour qu'il laisse sortir d'Egypte le peuple d'Israël."
,"14":"Voici les chefs des tribus: Fils de Ruben, premier-né d'Israël: Haillon, Palou, Hesron et Karmi. Ce sont les clans de Ruben."
,"15":"Fils de Siméon: Yémouel, Yamin, Ohad, Yakin, Sohar et Chaoul, qui était fils d'une Cananéenne. Ce sont les clans de Siméon."
,"16":"Voici les noms des fils de Lévi ainsi que leur descendance: Guerchon, Kahat et Mérari. Lévi vécut cent trente-sept ans."
,"17":"Fils de Guerchon: Libni et Chiméï, avec leurs clans."
,"18":"Fils de Kahat: Amram, Yisar, Hébron et Ouziel. Kahat vécut cent trente-trois ans."
,"19":"Fils de Mérari: Mali et Mouchi. Ce sont les clans de Lévi et leur descendance."
,"20":"Amram épousa Yokébed, sa tante, qui lui donna Aaron et Moïse. Amram vécut cent trente- sept ans."
,"21":"Les fils de Yisar furent: Coré, Népheg et Zikri."
,"22":"Les fils d'Ouziel: Mikaël, Elsafan et Sitri."
,"23":"Aaron épousa Elichéba, fille d'Aminadab, soeur de Nachon. Elle lui donna: Nadab, Abihou, Eléazar et Itamar."
,"24":"Fils de Coré: Assir, Elkana et Abiasaf. Ce sont les clans des Coréites."
,"25":"Eléazar fils d'Aaron épousa une fille de Poutiel qui lui donna Pinhas. Ce sont les clans des Lévites, selon leur ordre."
,"26":"Ce sont eux, Aaron et Moïse, qui reçurent de Yahvé cet ordre: 'Faites sortir d'Egypte les fils d'Israël, en ordre de bataille!'"
,"27":"Ce sont eux, Moïse et Aaron, qui parlèrent à Pharaon, le roi d'Egypte, pour faire sortir d'Egypte les Israélites. Moïse et Aaron, ce sont eux!"
,"28":"Le jour où Yahvé parla à Moïse en Egypte,"
,"29":"Yahvé lui dit: 'Je suis Yahvé! Tu rediras à Pharaon, le roi d'Egypte, tout ce que je te dirai.'"
,"30":"Mais Moïse répondit à Yahvé: 'Je ne sais pas m'exprimer, comment le Pharaon m'écoutera-t-il?'"
}`)
	CurrentBook.AddChapter(7, `{
"1":"Yahvé dit à Moïse: 'Regarde: j'ai voulu que tu sois comme un Dieu face au Pharaon, et ton frère Aaron sera ton prophète."
,"2":"Tu diras tout ce que je te commanderai, et Aaron, ton frère, parlera au Pharaon pour qu'il renvoie les Israélites de son pays."
,"3":"Mais moi, je ferai que le Pharaon s'entête, car je veux multiplier en Egypte mes signes et mes prodiges."
,"4":"Comme le Pharaon ne vous écoutera pas, je frapperai l'Egypte et j'en ferai sortir mes armées, mon peuple, les Israélites, grâce à des coups redoutables."
,"5":"Ainsi les Egyptiens sauront que je suis Yahvé, quand je lèverai la main contre eux et que je ferai sortir du milieu d'eux les Israélites.'"
,"6":"Moïse et Aaron firent ce que Yahvé leur avait ordonné."
,"7":"Moïse avait quatre-vingts ans et Aaron en avait quatre-vingt-trois, lorsqu'ils se présentèrent devant le Pharaon."
,"8":"Yahvé parla à Moïse et à Aaron:"
,"9":"'Lorsque le Pharaon vous dira: Faites un prodige pour confirmer vos paroles! Tu diras à Aaron de prendre son bâton et de le jeter devant le Pharaon pour qu'il devienne un serpent.'"
,"10":"Moïse et Aaron se présentèrent donc devant le Pharaon. Ils firent comme Yahvé le leur avait ordonné. Aaron jeta son bâton devant le Pharaon et ses serviteurs et il se transforma en serpent."
,"11":"Le Pharaon réunit alors les sages avec les sorciers, et les magiciens d'Egypte en firent autant avec leurs sortilèges."
,"12":"Chacun jeta son bâton et les bâtons se transformèrent en serpents, mais celui d'Aaron avala ceux des magiciens."
,"13":"Pourtant le Pharaon s'entêta et ne voulut pas écouter: Yahvé l'avait bien dit."
,"14":"Yahvé dit à Moïse: 'Le Pharaon s'entête, il a refusé de laisser partir le peuple."
,"15":"Tu iras donc à la rencontre du Pharaon dès le matin, lorsqu'il ira au fleuve. Tu te tiendras devant lui sur la rive du Nil et tu auras en main le bâton qui s'est changé en serpent."
,"16":"Tu lui diras: Yahvé, le Dieu des Hébreux, m'a envoyé vers toi pour te dire: Laisse partir mon peuple pour qu'il me serve dans le désert, car jusqu'à présent tu n'as pas écouté."
,"17":"Voici ce que dit Yahvé: Tu sauras que je suis Yahvé lorsque je frapperai les eaux du Nil avec le bâton que j'ai en main, car alors elles se changeront en sang."
,"18":"Les poissons du Nil crèveront, les eaux du Nil deviendront si malsaines que les Egyptiens ne pourront plus les boire.'"
,"19":"Yahvé dit à Moïse: 'Tu diras à Aaron: Prends ton bâton et étends la main vers les eaux d'Egypte, étends ta main sur les rivières, les canaux, les étangs et sur toutes les mares. Que l'eau devienne du sang! Qu'il y ait du sang dans toute l'Egypte, jusque sur les arbres et sur les pierres!'"
,"20":"Moïse et Aaron firent ce que Yahvé leur avait commandé. Aaron leva son bâton et frappa les eaux du Nil sous les yeux du Pharaon et de ses serviteurs, et toutes les eaux du Nil se changèrent en sang. "
,"21":"Les poissons qui étaient dans le Nil crevèrent et les eaux du Nil devinrent si malsaines que les Egyptiens ne pouvaient plus en boire. Il y eut du sang dans toute l'Egypte. "
,"22":"Les magiciens d'Egypte firent de même avec leurs sortilèges et le Pharaon s'entêta et ne voulut pas écouter: Yahvé l'avait bien prédit."
,"23":"Pharaon s'en retourna et rentra chez lui comme s'il n'y avait rien eu,"
,"24":"mais tous les Egyptiens durent creuser des puits près du fleuve pour pouvoir boire, car ils ne pouvaient plus boire l'eau du fleuve."
,"25":"Cela faisait déjà sept jours que Yahvé avait frappé le Nil."
,"26":"Yahvé dit à Moïse: 'Va trouver le Pharaon et dis lui de la part de Yahvé: Laisse partir mon peuple pour qu'il me serve:"
,"27":"si tu refuses de le laisser partir, je couvrirai tout ton pays de grenouilles."
,"28":"Il y aura tellement de grenouilles dans le Nil, qu'elles monteront, entreront dans ta maison, dans ta chambre à coucher et sur ton lit, dans les maisons de tes serviteurs et de ton peuple, dans les fours et dans les greniers."
,"29":"Les grenouilles viendront jusque sur toi, sur ton peuple et sur tous tes serviteurs.'"
}`)
	CurrentBook.AddChapter(8, `{
"1":"Yahvé dit à Moïse: 'Tu diras à Aaron: Etends la main avec ton bâton sur les rivières, les canaux et les étangs. Fais monter les grenouilles sur le pays d'Egypte.'"
,"2":"Aaron étendit la main sur les eaux d'Egypte et les grenouilles montèrent et couvrirent tout le pays d'Egypte."
,"3":"Les magiciens firent la même chose avec leurs sortilèges et ils firent aussi monter des grenouilles sur le pays d'Egypte."
,"4":"Le Pharaon fit appeler Moïse et Aaron: 'Priez Yahvé, leur dit-il, que les grenouilles s'en aillent loin de moi et de mon peuple, et je permettrai que votre peuple aille offrir un sacrifice à Yahvé.'"
,"5":"Moïse répondit au Pharaon: 'Peux-tu me dire quand je devrai prier Yahvé pour toi, pour tes serviteurs et pour ton peuple, pour que les grenouilles disparaissent de chez toi et de tes maisons et qu'elles retournent dans le Nil?'"
,"6":"Pharaon lui dit: 'Demain!' Alors Moïse répondit: 'D'accord! Tu vas voir qu'il n'y a personne comme Yahvé notre Dieu."
,"7":"Les grenouilles s'éloigneront de toi et de tes maisons, de tes serviteurs et de ton peuple, et retourneront dans le Nil.'"
,"8":"Après que Moïse et Aaron furent sortis de chez le Pharaon, Moïse pria Yahvé au sujet des grenouilles qu'il avait envoyées contre le Pharaon."
,"9":"Yahvé exauça Moïse et les grenouilles crevèrent dans les maisons, dans les parcs et dans les champs."
,"10":"On en fit de très grands tas et la terre en fut infestée."
,"11":"Mais quand le Pharaon vit que les choses s'arrangeaient, il s'endurcit et ne voulut pas les écouter: Yahvé l'avait bien prédit."
,"12":"Yahvé dit à Moïse: 'Tu diras à Aaron: Etends ton bâton et frappe la poussière de la terre, elle se changera en moustiques sur toute la terre d'Egypte.'"
,"13":"C'est ce qu'ils firent: Aaron étendit la main et frappa de son bâton la poussière de la terre qui se changea en moustiques sur les hommes et sur les bêtes. Toute la poussière de la terre était devenue moustiques dans toute l'Egypte."
,"14":"Les magiciens aussi firent usage de leurs sortilèges pour chasser les moustiques, mais ils ne réussirent pas, et les moustiques restèrent sur les hommes et sur les bêtes."
,"15":"Alors les magiciens dirent au Pharaon: 'Le doigt de Dieu est là!' Mais le Pharaon s'entêta et ne voulut pas les écouter: Yahvé l'avait bien prédit."
,"16":"Yahvé dit à Moïse: 'Lève-toi de bon matin et présente-toi devant le Pharaon lorsqu'il ira au fleuve. Tu lui diras: Voici ce que dit Yahvé: Laisse partir mon peuple pour qu'il me serve!"
,"17":"Si tu ne renvoies pas mon peuple, je t'enverrai des taons, à toi, à tes serviteurs, à ton peuple, plein leurs maisons. Les maisons des Egyptiens seront pleines de taons et le sol en sera couvert."
,"18":"Mais ce jour-là il n'y aura pas de taons dans le pays de Gossen, là où mon peuple est installé, pour que tu saches bien que moi, Yahvé, je suis là dans le pays,"
,"19":"et que je fais une différence entre mon peuple et ton peuple. Dès demain tu verras ce signe.'"
,"20":"C'est ce que fit Yahvé. Un énorme nuage de taons se répandit dans la maison du Pharaon, dans les maisons de ses serviteurs et dans tout le pays d'Egypte. La terre était dévorée par les taons."
,"21":"Le Pharaon appela alors Moïse et Aaron. Il leur dit: 'Allez offrir un sacrifice à votre Dieu, mais dans le pays.'"
,"22":"Moïse répondit: 'Nous ne pouvons pas faire cela, car pour les Egyptiens c'est une chose horrible de sacrifier les animaux que nous offrons en sacrifice à Yahvé, notre Dieu! Si nous faisons ce que les Egyptiens regardent comme une chose abominable, ils vont nous lapider."
,"23":"Nous irons donc dans le désert, à trois jours de marche, et là, nous offrirons un sacrifice à Yahvé notre Dieu, selon ce qu'il nous dira.'"
,"24":"Alors Pharaon dit: 'Je vais vous laisser partir: allez offrir un sacrifice à Yahvé, votre Dieu, dans le désert, mais ne partez pas trop loin et priez pour moi.'"
,"25":"Moïse dit: 'Regarde: aussitôt sorti de chez toi, je vais prier Yahvé, et dès demain les taons s'éloigneront du Pharaon, de ses serviteurs et de son peuple. Mais que le Pharaon ne continue pas de se moquer, qu'il n'empêche pas le peuple d'aller offrir un sacrifice à Yahvé.'"
,"26":"Donc, aussitôt sorti de chez le Pharaon, Moïse pria Yahvé,"
,"27":"et Yahvé fit ce que Moïse avait dit: il chassa les taons loin du Pharaon, de ses serviteurs et de son peuple, il n'en resta pas un seul."
,"28":"Mais le Pharaon s'entêta cette fois encore, et il ne laissa pas partir le peuple."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Yahvé dit à Moïse: 'Va trouver le Pharaon et dis-lui de la part de Yahvé, le Dieu des Hébreux: Laisse partir mon peuple pour qu'il me serve!"
,"2":"Si tu refuses de le renvoyer, si tu le retiens encore,"
,"3":"Yahvé frappera tes troupeaux qui sont dans la campagne, les chevaux, les ânes, les chameaux, le gros et le petit bétail. Ce sera une peste terrible."
,"4":"Mais Yahvé fera la différence entre le troupeau d'Israël et le troupeau d'Egypte. Pas une bête des Israélites ne crèvera.'"
,"5":"Yahvé fixa la date, il dit: 'Demain, Yahvé fera cela dans tout le pays.'"
,"6":"Et dès le lendemain Yahvé fit ce qu'il avait dit: tous les troupeaux d'Egypte crevèrent, mais pas une bête ne creva dans les troupeaux des Israélites."
,"7":"Le Pharaon s'informa: pas une bête n'avait crevé dans les troupeaux des Israélites. Mais le Pharaon resta dans son entêtement et il ne laissa pas partir le peuple."
,"8":"Alors, Dieu dit à Moïse et à Aaron: 'Remplissez vos deux mains de cendre fine. Moïse la lancera vers le ciel sous les yeux du Pharaon,"
,"9":"et dans toute l'Egypte ce sera de la poudre qui se déposera sur les hommes et sur les bêtes: dans toute l'Egypte elle leur donnera des ulcères et des boutons.'"
,"10":"Ils prirent donc de la cendre fine et se présentèrent devant le Pharaon. Moïse la lança vers le ciel et elle se changea en ulcères et en boutons sur les hommes et sur les bêtes."
,"11":"Cette fois les magiciens ne purent rester aux côtés de Moïse à cause de ce fléau, car ils avaient leurs ulcères comme tous les Egyptiens."
,"12":"Mais Dieu endurcit le coeur du Pharaon, il ne voulut pas écouter: Yahvé l'avait bien dit à Moïse."
,"13":"Yahvé dit encore à Moïse: 'Lève-toi de bon matin et présente-toi devant le Pharaon. Tu lui diras de la part de Yahvé, le Dieu des Hébreux: Laisse aller mon peuple pour qu'il me serve!"
,"14":"Cette fois j'envoie tous mes fléaux contre toi, tes serviteurs et ton peuple, et tu sauras ainsi qu'il n'y a personne comme moi sur toute la terre."
,"15":"J'aurais pu dès le début montrer toute ma puissance et te frapper toi et ton peuple par la peste, et tu aurais disparu de la terre."
,"16":"Mais voici pourquoi je t'ai laissé en vie: je veux te faire voir ma puissance et que mon Nom soit connu sur toute la terre."
,"17":"Tu résistes encore et tu ne laisses pas partir mon peuple?"
,"18":"Eh bien, demain à cette heure, je ferai tomber une très forte grêle comme il n'y en a pas eu de pareille depuis la fondation de l'Egypte jusqu'à ce jour."
,"19":"Ordonne donc de mettre à l'abri dès maintenant ton bétail et tout ce qui t'appartient dans les champs, car tous les hommes et toutes les bêtes qui seront dans les champs au lieu d'être à l'abri à la maison, seront frappés par la grêle et mourront.'"
,"20":"Ceux des serviteurs du Pharaon qui craignaient Yahvé se réfugièrent dans les maisons avec leurs serviteurs et leurs troupeaux."
,"21":"Mais ceux qui se moquaient de la parole de Yahvé laissèrent leurs serviteurs et leurs troupeaux dans les champs."
,"22":"Yahvé dit alors à Moïse: 'Etends ta main vers le ciel! Que la grêle tombe sur toute l'Egypte, sur les hommes, sur les bêtes et sur tout ce qui pousse dans les champs en terre d'Egypte.'"
,"23":"Moïse étendit son bâton vers le ciel, et Yahvé fit éclater les tonnerres et pleuvoir la grêle en même temps que la foudre tombait sur la terre. Yahvé fit tomber la grêle sur tout le pays d'Egypte."
,"24":"Il y eut de la grêle avec des éclairs de feu qui jaillissaient du milieu de la grêle. On n'avait rien vu de semblable dans tout le pays depuis la fondation de l'Egypte."
,"25":"Dans tout le pays d'Egypte, la grêle frappa tous ceux qui étaient dans les champs, les gens comme les bêtes. La grêle frappa aussi tout ce qui poussait dans les champs et brisa même les arbres des champs."
,"26":"Cependant il n'y eut pas de grêle dans le pays de Gossen, là où se trouvaient les Israélites."
,"27":"Le Pharaon fit alors appeler Moïse et Aaron, il leur dit: 'Cette fois, j'ai péché! C'est Yahvé qui est juste, moi et mon peuple nous sommes coupables!"
,"28":"Priez Yahvé pour que s'arrêtent ces tonnerres incroyables et cette grêle, et je ne vous retiendrai plus ici, je vous laisserai partir.'"
,"29":"Moïse répondit: 'Aussitôt sorti de la ville, je tendrai les mains vers Yahvé: les tonnerres s'arrêteront, et il n'y aura plus de grêle. Ainsi tu sauras que la terre est à Yahvé."
,"30":"Mais je sais bien que toi et tes serviteurs, vous ne craindrez encore pas Yahvé Dieu.'"
,"31":"Le lin et l'orge avaient été frappés, car l'orge était en épi, et le lin en fleur."
,"32":"Mais le blé et le seigle n'avaient pas été frappés, car ils sont tardifs."
,"33":"Aussitôt sorti de chez le Pharaon et hors de la ville, Moïse tendit les mains vers Yahvé: les tonnerres et la grêle s'arrêtèrent, et la pluie cessa de tomber sur la terre."
,"34":"Le Pharaon vit que la pluie, la grêle et les tonnerres s'étaient arrêtés. Alors il recommença à pécher et à s'entêter, lui et ses serviteurs."
,"35":"Le Pharaon s'entêta et refusa de laisser partir les Israélites: Yahvé l'avait bien dit par la bouche de Moïse."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Yahvé dit à Moïse: 'Va trouver le Pharaon. Je l'ai maintenu dans son entêtement, lui et ses serviteurs, afin de réaliser tous ces prodiges au milieu d'eux."
,"2":"Ainsi tu pourras raconter à ton fils et à ton petit-fils comment j'ai triomphé des Egyptiens: tu leur diras les signes que j'ai faits au milieu d'eux pour qu'ils sachent que je suis Yahvé.'"
,"3":"Moïse et Aaron vinrent dire au Pharaon: 'Voici ce que te dit Yahvé, le Dieu des Hébreux: Combien de temps refuseras-tu de t'abaisser devant moi? Laisse aller mon peuple pour qu'il me serve!"
,"4":"Si tu ne laisses pas aller mon peuple, dès demain je ferai venir des sauterelles dans tout ton pays."
,"5":"Elles couvriront tellement bien le sol, qu'on ne verra plus la terre. Elles mangeront tout ce qui reste encore dans les champs, tout ce que la grêle a laissé. Elles mangeront tous les arbres qui poussent pour vous dans la campagne."
,"6":"Tes maisons, les maisons de tous tes serviteurs et les maisons de tous les Egyptiens en seront remplies. Jamais, ni tes pères, ni les pères de tes pères n'ont vu chose pareille.' Alors Moïse se retira et sortit de chez le Pharaon."
,"7":"Les serviteurs du Pharaon lui dirent: 'Combien de temps encore cette affaire va-t-elle nous ruiner? Renvoie ces gens pour qu'ils servent Yahvé, leur Dieu! Ne vois-tu pas que l'Egypte est perdue?'"
,"8":"On fit donc revenir Moïse et Aaron chez le Pharaon. Il leur dit: 'Allez servir Yahvé, votre Dieu! Mais quels sont ceux qui iront?'"
,"9":"Moïse répondit: 'Nous irons avec nos jeunes gens et nos vieillards, avec nos fils et nos filles, avec notre petit et notre gros bétail, car ce sera pour nous une fête en l'honneur de Yahvé.'"
,"10":"Le Pharaon leur dit: 'Que Yahvé soit avec vous! Je dois donc vous laisser partir avec vos femmes et vos petits enfants? Mais vous avez en tête de mauvaises intentions!"
,"11":"Il n'en est pas question. Ce sont les hommes qui iront servir Yahvé, puisque c'est cela que vous voulez!' Ceci dit, on les chassa de devant le Pharaon."
,"12":"Yahvé dit alors à Moïse: 'Etends ta main sur le pays d'Egypte pour faire venir les sauterelles. Qu'elles envahissent toute l'Egypte, et qu'elles mangent tout ce qui pousse dans les champs, tout ce que la grêle a laissé!'"
,"13":"Moïse étendit son bâton sur l'Egypte: tout le jour et toute la nuit Yahvé fit souffler sur le pays un vent d'est. Au matin, le vent d'est avait apporté les sauterelles."
,"14":"Les sauterelles envahirent la terre d'Egypte et s'abattirent sur tout le pays: ce fut une terrible catastrophe! Jamais, ni avant ni après, on n'avait vu tant de sauterelles."
,"15":"Elles couvrirent si bien la terre qu'on ne la voyait plus. Elles dévorèrent tout ce qui poussait dans les champs et tous les fruits que la grêle avait laissés sur les arbres. Il ne resta pas un brin de verdure, ni sur les arbres ni dans les champs dans tout le pays d'Egypte."
,"16":"Le Pharaon se dépêcha d'appeler Moïse et Aaron; il leur dit: 'J'ai péché contre Yahvé votre Dieu et contre vous!"
,"17":"Maintenant, pardonne-moi ma faute au moins pour cette fois! Priez Yahvé, votre Dieu pour qu'il écarte de moi ce fléau mortel.'"
,"18":"Moïse sortit de chez le Pharaon et pria Yahvé,"
,"19":"qui fit tourner le vent. Un fort vent d'ouest emporta les sauterelles vers la Mer des Roseaux: il n'en resta pas une seule dans toute l'Egypte."
,"20":"Mais Yahvé voulut l'entêtement du Pharaon; celui-ci ne laissa pas partir les Israélites."
,"21":"Yahvé dit à Moïse: 'Tends ta main vers le ciel, et sur toute l'Egypte viendront des ténèbres telles que l'on ira en tâtonnant dans les ténèbres.'"
,"22":"Moïse tendit sa main vers le ciel, et durant trois jours ce furent d'épaisses ténèbres sur toute l'Egypte."
,"23":"Les gens ne se voyaient plus les uns les autres et durant trois jours nul ne bougea de sa place. Mais tous les Israélites avaient de la lumière, là où ils habitaient."
,"24":"Le Pharaon appela Moïse et lui dit: 'Allez servir Yahvé! Vos petits enfants iront avec vous, mais vous laisserez votre petit et votre gros bétail.'"
,"25":"Moïse répondit: 'Est-ce toi qui nous remettras ce qu'il convient d'offrir et de sacrifier à Yahvé, notre Dieu?"
,"26":"C'est pourquoi nos troupeaux viendront avec nous: pas une de nos bêtes ne restera ici. D'ailleurs nous devrons servir Yahvé, notre Dieu, avec des bêtes de notre troupeau et, jusqu'à notre arrivée là-bas, nous ne saurons pas exactement ce que nous devrons offrir à Yahvé.'"
,"27":"Yahvé voulut alors que le Pharaon s'en tête: il refusa de les laisser partir."
,"28":"Le Pharaon dit à Moïse: 'Va-t'en d'ici et garde-toi bien de revenir, car le jour où tu te présenteras devant moi, tu mourras!'"
,"29":"Moïse répondit: 'Tu l'as très bien dit, je ne me présenterai plus devant toi.'"
}`)
	CurrentBook.AddChapter(11, `{
"1":"Yahvé dit à Moïse: 'Je vais envoyer un dernier fléau sur le Pharaon et sur l'Egypte. Après cela, il vous laissera partir d'ici. Il vous laissera tellement bien partir, que même il vous chassera d'ici."
,"2":"Va donc dire ceci au peuple: Que chaque homme emprunte à son voisin, et chaque femme à sa voisine, des objets d'argent et d'or.'"
,"3":"Yahvé rendit le peuple sympathique aux Egyptiens, d'ailleurs Moïse était un très grand personnage en Egypte, très bien considéré par les serviteurs du Pharaon et par le peuple."
,"4":"Moïse dit: 'Voilà ce que dit Yahvé: Au milieu de la nuit je traverserai l'Egypte,"
,"5":"et tout premier-né mourra au pays d'Egypte, depuis le premier-né du Pharaon qui est assis sur son trône jusqu'au premier-né de la servante qui est derrière sa meule, jusqu'au premier-né de tout animal."
,"6":"Dans tout le pays d'Egypte on entendra un cri de douleur comme il n'y en a jamais eu et qu'il n'y en aura jamais plus de semblable."
,"7":"Mais chez les Israélites, pas un chien n'aboiera, ni pour mort d'homme, ni pour mort d'animal, afin que vous sachiez que Yahvé fait une différence entre l'Egypte et Israël."
,"8":"Tous tes serviteurs viendront vers moi et se prosterneront devant moi en disant: Sors avec tout le peuple qui te suit! Et alors je partirai.' Ceci dit, Moïse sortit de chez le Pharaon très en colère."
,"9":"Yahvé dit à Moïse: 'Le Pharaon ne vous écoutera pas, c'est pourquoi je multiplierai mes prodiges en Egypte.'"
,"10":"Moïse et Aaron avaient fait tous ces prodiges devant le Pharaon, mais Yahvé avait fait que le Pharaon s'entête, et il ne laissa pas les Israélites sortir de son pays."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Yahvé parla à Moïse et à Aaron en Egypte; il leur dit:"
,"2":"'Ce mois marquera pour vous le début des mois, ce sera pour vous le premier des mois de l'année."
,"3":"Vous direz ceci à toute la communauté d'Israël: Le dix de ce mois, que chacun se procure un agneau par famille, un agneau par maison."
,"4":"Si la maison est trop peu nombreuse pour un agneau, on se joindra au voisin le plus proche de la maison en tenant compte du nombre de personnes, et vous choisirez l'agneau en tenant compte de ce que chacun mange."
,"5":"Vous prendrez un agneau sans défaut, mâle, né dans l'année. Vous pourrez prendre, soit un agneau, soit un cabri."
,"6":"Vous le garderez jusqu'au quatorzième jour de ce mois, alors, à la tombée du jour, toute la communauté d'Israël l'immolera."
,"7":"On prendra de son sang et on en mettra sur les deux montants et au-dessus de la porte des maisons dans lesquelles on le mangera."
,"8":"On en mangera cette nuit-là la chair rôtie au feu avec des pains sans levain et des herbes amères."
,"9":"Vous n'en mangerez rien cru ou bouilli dans l'eau, mais rôti au feu avec la tête, les jambes et les tripes."
,"10":"Vous n'en garderez rien pour le matin: s'il en reste au matin, vous le brûlerez au feu."
,"11":"Voici comment vous le mangerez: une ceinture autour des reins, les sandales aux pieds et le bâton à la main. Vous le mangerez sans vous attarder, car c'est la Pâque en l'honneur de Yahvé."
,"12":"Je passerai cette nuit-là à travers l'Egypte et je frapperai tout premier-né en Egypte, depuis les hommes jusqu'aux animaux. Je ferai voir à tous les dieux des Egyptiens qui je suis, moi, Yahvé!"
,"13":"Le sang sur vos maisons sera le signe que vous êtes là. Lorsque je verrai le sang je passerai plus loin, de sorte que je frapperai l'Egypte sans que vous soyez touchés."
,"14":"Vous vous souviendrez de ce jour, vous le fêterez comme une fête de Yahvé: cette célébration sera un rite perpétuel, de génération en génération."
,"15":"Pendant sept jours vous mangerez des pains sans levain. Dès le premier jour vous ôterez le levain de vos maisons. Si quelqu'un mange du pain levé, depuis le premier jusqu'au septième jour, il sera éliminé d'Israël."
,"16":"Il y aura une assemblée sainte le premier jour et le septième jour. Ces deux jours-là personne ne travaillera, le seul travail sera la préparation de la nourriture pour chacun."
,"17":"Vous célébrerez la fête des Pains sans levain, car c'est ce jour-là que je vous ai fait sortir du pays d'Egypte. Vous observerez donc ce jour, de génération en génération, ce sera un rite perpétuel."
,"18":"Le premier mois, au soir du quatorzième jour du mois, vous mangerez du pain sans levain, et cela, jusqu'au soir du vingt et unième jour du mois."
,"19":"Pendant sept jours il n'y aura pas de levain dans vos maisons. Si quelqu'un, étranger ou habitant du pays, mange du pain levé, il sera éliminé de la communauté d'Israël."
,"20":"Vous ne mangerez pas de pain levé mais, dans vos maisons, vous mangerez du pain sans levain.'"
,"21":"Moïse rassembla tous les anciens d'Israël et leur dit: 'Prenez du petit bétail pour vous et vos familles, et immolez la Pâque."
,"22":"Vous prendrez un bouquet d'herbes, vous le tremperez dans le sang qui sera dans la cuvette et vous marquerez le haut et les deux montants de la porte avec le sang de la cuvette; per sonne de chez vous ne sortira de la maison jusqu'au matin,"
,"23":"car Yahvé passera à travers l'Egypte avec son fléau. Quand il verra le sang sur le haut et sur les deux montants de vos portes, il passera plus loin et ne permettra pas à l'exterminateur d'entrer dans vos maisons et de vous tuer."
,"24":"Vous observerez ces rites, ce sera une obligation pour vous et pour vos enfants à jamais."
,"25":"Lorsque vous serez entrés dans le pays que Yahvé vous donnera comme il l'a dit, vous observerez ce rite."
,"26":"Et si vos fils vous disent alors: Que signifie ce rite pour vous?,"
,"27":"vous leur répondrez: C'est le sacrifice de la Pâque en l'honneur de Yahvé: il a sauté par-dessus les maisons des Israélites en Egypte et les a sauvées, alors qu'il frappait les Egyptiens.' Le peuple s'agenouilla et se prosterna."
,"28":"Les Israélites s'en allèrent donc et firent comme Yahvé l'avait ordonné à Moïse et à Aaron."
,"29":"Et voici qu'au milieu de la nuit, Yahvé frappa tous les premiers-nés dans le pays d'Egypte, depuis le premier-né du Pharaon qui est assis sur son trône jusqu'au premier-né du prisonnier qui est dans son cachot, jusqu'au premier-né de tout animal."
,"30":"Le Pharaon se leva de nuit, ainsi que tous ses serviteurs et tous les Egyptiens. Un immense cri de douleur montait de toute l'Egypte: il n'y avait pas une seule maison dans laquelle il n'y eût un mort."
,"31":"Cette nuit même le Pharaon appela Moïse et Aaron pour leur dire: 'Allez, sortez de ce peuple, vous et tous les Israélites, allez servir Yahvé comme vous l'avez dit!"
,"32":"Prenez aussi votre petit et votre gros bétail, comme vous l'avez dit. Allez et obtenez-moi aussi la bénédiction! '"
,"33":"Les Egyptiens pressaient le peuple pour qu'il sorte au plus vite du pays, car ils disaient: 'Nous allons tous mourir!'"
,"34":"Le peuple emporta la pâte avant qu'elle ne soit levée, tous portaient sur leurs épaules leur pétrin enveloppé dans leur manteau."
,"35":"Les Israélites firent ce que Moïse leur avait dit: ils empruntèrent aux Egyptiens des objets d'argent et d'or, ainsi que des vêtements,"
,"36":"et les Egyptiens les leur prêtèrent car Yahvé les avait bien disposés envers son peuple; c'est ainsi qu'ils dépouillèrent les Egyptiens."
,"37":"Les Israélites partirent de Ramsès pour Soukkoth; ils étaient environ six cent mille hommes, sans compter les enfants."
,"38":"Une foule nombreuse monta avec eux, emmenant des troupeaux énormes de petit et de gros bétail."
,"39":"Ils firent cuire la pâte qu'ils avaient emportée d'Egypte en galettes non levées. En effet, quand on les avait chassés d'Egypte, ils n'avaient pu faire lever la pâte, le temps manquait pour en faire du pain."
,"40":"Les Israélites demeurèrent en Egypte durant quatre cent trente ans."
,"41":"Et c'est au bout de quatre cent trente ans, jour pour jour, que tout le peuple de Yahvé sortit du pays d'Egypte."
,"42":"C'est là la nuit de veille en l'honneur de Yahvé qui les a fait sortir d'Egypte. Cette nuit appartient à Yahvé, ce sera une nuit de veille pour tous les fils d'Israël, de génération en génération."
,"43":"Yahvé dit à Moïse et à Aaron: 'Voici le rite de la Pâque. Aucun étranger n'en mangera,"
,"44":"mais l'esclave qui aura été acheté à prix d'argent et ensuite circoncis, en mangera."
,"45":"Ni le résident ni celui qui seulement travaille pour toi, n'en mangeront."
,"46":"On la mangera à l'intérieur de la maison, tu n'en transporteras pas la viande de l'intérieur à l'extérieur, et tu ne briseras aucun de ses os."
,"47":"La communauté d'Israël tout entière fera la Pâque."
,"48":"Si un étranger de passage chez toi veut faire la Pâque de Yahvé, il devra être circoncis. Alors il viendra y prendre part comme n'importe qui du pays, mais aucun incirconcis n'en mangera."
,"49":"La loi sera la même pour l'homme du pays et pour l'étranger de passage au milieu de vous.'"
,"50":"Tous les Israélites firent ainsi, comme Yahvé l'avait ordonné à Moïse et à Aaron;"
,"51":"ce jour-là Yahvé fit sortir les Israélites d'Egypte, selon leurs corps d'armée."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Yahvé dit à Moïse:"
,"2":"'Consacre-moi tout premier-né. Tout premier-né qui ouvre le sein maternel en Israël, homme ou animal, est à moi.'"
,"3":"Moïse dit au peuple: 'Vous célébrerez ce jour où vous êtes sortis d'Egypte, du pays de l'esclavage, lorsque Yahvé, vous a fait sortir d'ici en déployant sa force: en ce jour on ne mangera pas de pain levé."
,"4":"Votre sortie a eu lieu un jour du mois d'Abib (le mois de l'Epi)."
,"5":"Lorsque Yahvé t'aura fait entrer dans le pays des Cananéens, des Hittites, des Amorites, des Hivvites et des Jébusites -ce pays où coulent le lait et le miel- qu'il a juré à tes pères de te donner, tu célébreras ce rite au cours de ce même mois."
,"6":"Durant sept jours tu mangeras du pain sans levain et le septième jour tu célébreras une fête en l'honneur de Yahvé."
,"7":"Pendant sept jours on mangera du pain sans levain; on ne verra chez toi, dans tout le pays, ni pain levé, ni levain."
,"8":"Et ce jour-là tu rediras ceci à ton fils: C'est à cause de ce que Yahvé a fait pour moi lorsque je suis sorti d'Egypte."
,"9":"Ce sera pour toi comme un signe sur ta main, comme un rappel sur ton front, pour que la Loi de Yahvé soit toujours dans ta bouche; car Yahvé t'a fait sortir d'Egypte à la force du poignet."
,"10":"Chaque année, à la date fixée, tu observeras ce rite."
,"11":"Lorsque Yahvé t'aura fait entrer au pays des Cananéens, comme il l'a juré à toi et à tes pères, lorsqu'il te l'aura donné,"
,"12":"tu consacreras à Yahvé tout premier-né: tout premier-né de ton troupeau, si c'est un mâle, appartient à Yahvé."
,"13":"Tu rachèteras tout premier-né de l'âne avec un agneau; si tu ne le rachètes pas, tu lui briseras la nuque. Mais tous les premiers-nés de l'homme, tes fils, tu les rachèteras."
,"14":"Lorsque ton fils demain te posera cette question: Qu'est-ce que cela veut dire?, tu lui répondras: Yahvé nous a fait sortir d'Egypte, du pays de l'esclavage, à la force du poignet."
,"15":"Et comme le Pharaon refusait de nous laisser partir, Yahvé a tué tous les premiers-nés en Egypte, le premier-né de l'homme et le premier-né de l'animal. C'est pour cela que je consacre à Yahvé tout premier-né parmi les mâles et que je rachète le premier-né de mes fils."
,"16":"Ce sera comme un signe sur ta main, un rappel devant tes yeux: tu te souviendras que Yahvé nous a fait sortir d'Egypte, en déployant sa force.'"
,"17":"Lorsque le Pharaon laissa partir le peuple, Dieu ne le conduisit pas par la route du pays des Philistins; c'était pourtant la route directe. Mais Dieu se disait: 'Quand il faudra combattre, le peuple pourrait bien se repentir et retourner en Egypte.'"
,"18":"Dieu fit donc prendre au peuple la route plus longue du désert de la Mer des Roseaux; les Israélites montèrent en colonnes du pays d'Egypte."
,"19":"Moïse emporta avec lui les ossements de Joseph, car celui-ci avait fait jurer les fils d'Israël, il leur avait dit: 'Soyez sûrs que Dieu vous visitera: alors vous ramènerez avec vous mes ossements.'"
,"20":"Ils partirent donc de Soukkoth et campèrent à Etam, en bordure du désert."
,"21":"Yahvé marchait devant eux, dans une colonne de nuée le jour, pour les guider sur la route, et la nuit, dans une colonne de feu pour les éclairer. Ainsi ils pouvaient marcher de jour comme de nuit."
,"22":"La colonne de nuée ne s'éloignait pas du peuple durant le jour, ni la colonne de feu durant la nuit."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Yahvé parla à Moïse:"
,"2":"'Tu ordonneras aux Israélites de changer de route et de camper devant Pi-Hahirot, entre Migdol et la mer, vis-à-vis de Baal-Séfon. Vous camperez en face de ce lieu, au bord de la mer."
,"3":"Le Pharaon se dira sûrement ceci: Les Israélites se sont perdus dans le désert et le désert s'est refermé sur eux."
,"4":"Je ferai alors que le Pharaon s'endurcisse et vous poursuive, et je me couvrirai de gloire aux dépens du Pharaon et de toute son armée. Alors les Egyptiens sauront que je suis Yahvé.' Ils firent donc ainsi."
,"5":"Quand on annonça au roi d'Egypte que le peuple s'était enfui, le Pharaon et ses serviteurs ne pensèrent plus pareil à propos du peuple. 'Qu'avons-nous fait?' dirent-ils, 'nous avons laissé partir Israël, il ne nous servira plus!'"
,"6":"Le Pharaon attela son char et entraîna son peuple avec lui."
,"7":"Il prit six cents chars d'élite, tous les chars d'Egypte avec des écuyers pour chacun."
,"8":"Yahvé avait endurci le coeur du Pharaon, roi d'Egypte, et il se lança à la poursuite des Israélites qui s'en allaient la tête haute."
,"9":"Les Egyptiens se lancèrent donc à leur poursuite et les rejoignirent alors qu'ils campaient près de la mer. Tous les chevaux et les chars du Pharaon, ses cavaliers et son armée étaient là près de Pi-Hahirot, en face de Baal-Séfon."
,"10":"Le Pharaon approchait. Les Israélites levèrent les yeux et virent les Egyptiens qui s'avançaient sur leurs traces. Alors, épouvantés, les Israélites crièrent vers Yahvé."
,"11":"Ils dirent à Moïse: 'N'y avait-il pas assez de tombeaux en Egypte pour que tu nous emmènes mourir au désert? Tu nous a bien aidés en nous faisant sortir d'Egypte!"
,"12":"Nous te le disions déjà en Egypte: Laisse-nous servir les Egyptiens! Mieux vaut pour nous servir l'Egypte que mourir dans le désert.'"
,"13":"Moïse répondit au peuple: 'N'ayez pas peur, tenez bon! Regardez simplement comment Yahvé sauve, voyez ce qu'il va faire pour vous aujourd'hui. Les Egyptiens que vous voyez aujourd'hui, vous ne les reverrez plus jamais,"
,"14":"Yahvé combattra à votre place et vous, vous n'aurez qu'à regarder!'"
,"15":"Yahvé dit à Moïse: 'Pourquoi cries-tu vers moi? Dis aux Israélites de se mettre en route."
,"16":"Puis lève ton bâton, étends la main vers la mer et coupe-la en deux: les Israélites passeront au milieu de la mer, à pied sec!"
,"17":"Je ferai que les Egyptiens s'obstinent à continuer derrière eux, et alors je me couvrirai de gloire aux dépens du Pharaon et de toute son armée, de ses chars et de ses cavaliers."
,"18":"Les Egyptiens sauront que je suis Yahvé quand je me couvrirai de gloire aux dépens du Pharaon, de ses chars et de ses cavaliers.'"
,"19":"L'ange de Dieu qui marchait en avant de la troupe d'Israël, se déplaça et passa derrière eux. La colonne de nuée qui était en avant passa aussi derrière eux"
,"20":"et se plaça entre le camp d'Egypte et le camp d'Israël; mais la nuée était sombre du côté des Egyptiens et lumineuse du côté d'Israël. Ils ne s'approchèrent pas les uns des autres durant toute la nuit."
,"21":"Moïse étendit la main sur la mer et durant toute la nuit Yahvé fit souffler sur la mer un fort vent d'est: il mit ainsi la mer à sec. Les eaux s'ouvrirent: "
,"22":"les Israélites passèrent au milieu de la mer à pied sec; les eaux formaient comme un mur à leur droite et à leur gauche."
,"23":"Les Egyptiens qui les poursuivaient entrèrent aussi derrière eux au milieu de la mer, avec tous les chevaux du Pharaon, ses chars et ses cavaliers."
,"24":"Au petit matin, de la colonne de feu et de nuée, Yahvé fixa du regard le camp des Egyptiens et il y jeta la panique."
,"25":"Il faussa les roues de leurs chars, qui n'avancèrent plus que péniblement. Les Egyptiens se dirent alors: 'Fuyons devant Israël, car Yahvé combat avec eux contre l'Egypte!'"
,"26":"Mais Yahvé dit à Moïse: 'Etends la main sur la mer, et les eaux reviendront sur les Egyptiens, sur leurs chars et leurs cavaliers.'"
,"27":"Alors Moïse étendit la main sur la mer. Au petit matin la mer revint à sa place et, comme les Egyptiens s'enfuyaient devant elle, Yahvé les culbuta au milieu de la mer."
,"28":"Les eaux revinrent et recouvrirent les chars, les cavaliers et toute l'armée du Pharaon qui étaient entrés dans la mer à la suite des Israélites: pas un d'entre eux n'échappa."
,"29":"Quant aux Israélites, ils passèrent à pied sec au milieu de la mer, les eaux étaient pour eux comme un mur à leur droite et à leur gauche."
,"30":"Ce jour-là Yahvé sauva Israël de la main des Egyptiens, et Israël vit les Egyptiens morts sur le bord de la mer."
,"31":"Israël vit les prodiges que Yahvé avait faits contre l'Egypte, et le peuple craignit Yahvé. Ils crurent en Yahvé et en Moïse, son serviteur."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Alors Moïse et les Israélites chantèrent ce chant à Yahvé: Je chanterai Yahvé, il a fait éclater sa gloire, jetant à la mer cheval et cavalier."
,"2":"Yahvé est ma force, il est mon chant, il s'est fait mon libérateur. C'est lui mon Dieu, et je l'admire, il est le Dieu de mon père, à lui la louange."
,"3":"Yahvé est un guerrier, Yahvé est son nom."
,"4":"Les chars du Pharaon et son armée, jetés à la mer!,Les meilleurs de ses cavaliers, disparus dans la Mer des Roseaux!"
,"5":"Les eaux de l'abîme les ont recouverts, comme des pierres ils ont coulé jusqu'au fond."
,"6":"Yahvé! Tu as montré la force de ton bras, ta main droite, Yahvé, brise tes ennemis."
,"7":"Par la puissance de ta Gloire, tu disperses tes adversaires. Le feu de ta colère se lève,et les dévore comme la paille."
,"8":"Au souffle de tes narines, les eaux se rassemblent, les flots se dressent comme une muraille, le sol marin devient ferme au coeur de la mer."
,"9":"L'ennemi disait: Je les poursuis, je les rejoindrai, j'aurai droit au butin et serai riche de leurs biens, je tirerai l'épée et les tuerai de ma main.'"
,"10":"Mais toi, tu as envoyé ton souffle,et la mer les a recouverts, comme du plomb ils se sont enfoncés,dans les eaux majestueuses."
,"11":"Qui est comme toi, Yahvé, parmi tous les dieux?,Qui est comme toi, riche en sainteté, terrible en tes prodiges, toi qui fais des merveilles!"
,"12":"Ton bras a frappé, la terre les a engloutis."
,"13":"Ta grâce conduit ce peuple que tu as sauvé, mène-le par ta puissance à ta sainte Demeure."
,"14":"Les peuples entendent et ils tremblent, les habitants de la Philistie sont pris de peur."
,"15":"Les chefs d'Edom sont effrayés, et les princes de Moab, terrifiés, les habitants de Canaan sont tous atterrés,"
,"16":"peur et terreur tombent sur eux!,Devant la puissance de ton bras, ils sont devenus comme pierre, tandis que passe ton peuple, ô Yahvé, tandis que passe le peuple par toi racheté."
,"17":"Tu les feras entrer, pour les y planter, sur la montagne de ton héritage, au lieu que tu as choisi pour y habiter, sanctuaire que tes mains ont préparé, Seigneur!"
,"18":"Que Yahvé règne à tout jamais!"
,"19":"Quand les chevaux du Pharaon, ses chars et ses cavaliers furent entrés dans la mer, Yahvé fit revenir sur eux les eaux de la mer, mais les Israélites étaient passés à pied sec au milieu de la mer."
,"20":"Alors Miryam la prophétesse, la soeur d'Aaron, prit en main un tambourin et les femmes derrière elle sortirent avec leurs tambourins. En choeur,"
,"21":"elles chantaient avec Miryam: 'Chantez à Yahvé, car il s'est couvert de gloire, il a jeté à la mer cheval et cavalier.'"
,"22":"Moïse fit partir le peuple d'Israël de la Mer des Roseaux et le conduisit vers le désert de Chour. Ils s'enfoncèrent trois jours dans le désert et ne trouvèrent pas d'eau."
,"23":"Ils arrivèrent à Mara, mais les eaux de Mara n'étaient pas bonnes à boire, car elle étaient amères. C'est d'ailleurs pour cela qu'on appela ce lieu 'Mara' (c'est-à-dire Amertume)."
,"24":"Le peuple murmura contre Moïse, il disait: 'Qu'allons-nous boire?'"
,"25":"Alors Moïse cria vers Yahvé et Yahvé lui montra un bois d'arbre; il le jeta dans l'eau et l'eau devint douce. Yahvé donna là à Israël une règle, et ses décisions. C'est là qu'il le mit à l'épreuve. "
,"26":"Il lui dit: 'Si tu écoutes la voix de Yahvé, ton Dieu, si tu fais ce qui est juste à ses yeux, si tu fais attention à ses ordres et que tu observes tous ses commandements, je ne te frapperai pas comme j'ai frappé l'Egypte, car je suis Yahvé qui te guéris.'"
,"27":"Puis ils arrivèrent à Elim, où il y a douze sources et soixante-dix palmiers, et ils campèrent au bord de l'eau."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Les Israélites partirent d'Elim. Ils arrivèrent au désert de Sin, entre Elim et le Sinaï, le quinzième jour du deuxième mois après leur sortie d'Egypte."
,"2":"Toute la communauté des Israélites murmura contre Moïse et Aaron dans le désert."
,"3":"Les Israélites leur dirent: 'Pourquoi Yahvé ne nous a-t-il pas fait mourir au pays d'Egypte? Là nous pouvions nous asseoir devant des marmites de viande et nous mangions du pain comme nous voulions; mais vous nous avez fait aller à ce désert pour y faire mourir de faim toute cette foule.'"
,"4":"Yahvé dit à Moïse: 'Je vais vous faire pleuvoir du pain du haut du ciel. Que le peuple sorte et ramasse chaque jour ce dont il a besoin: je vais bien voir s'il marche ou non selon ma Loi."
,"5":"Le sixième jour ils ramasseront et prépareront le double de ce qu'ils ramassent les autres jours.'"
,"6":"Moïse et Aaron dirent à tous les Israélites: 'Ce soir vous saurez que c'est Yahvé qui vous a fait sortir d'Egypte,"
,"7":"et demain matin vous verrez la Gloire de Yahvé, car il vous a entendus réclamer contre lui. Vos plaintes n'étaient pas contre nous: nous autres, qui sommes-nous?'"
,"8":"Moïse leur dit: 'Ce soir Yahvé vous donnera de la viande à manger, et demain matin du pain, car Yahvé a entendu vos murmures contre lui. Nous autres, que sommes-nous? Ce n'est pas contre nous que vous murmurez, mais bien contre Yahvé.'"
,"9":"Moïse dit à Aaron: 'Voici ce que tu diras à toute la communauté des Israélites: Approchez-vous de Yahvé, car il a entendu vos murmures.'"
,"10":"Or, pendant qu'Aaron parlait à toute la communauté des Israélites, ils se tournèrent vers le désert et voici que la Gloire de Yahvé apparut dans la nuée."
,"11":"Yahvé s'adressa à Moïse et lui dit:"
,"12":"'J'ai entendu les murmures des Israélites, voici donc ce que tu leur diras: A la tombée du jour vous mangerez de la viande et au matin vous aurez votre content de pain. Alors vous saurez que je suis Yahvé, votre Dieu.'"
,"13":"Ce même soir, des cailles montèrent et couvrirent le camp. Et le matin, il y eut une couche de rosée autour du camp. "
,"14":"Lorsque la couche de rosée se leva, voici que la surface du désert était couverte d'une croûte, pas plus épaisse que le givre sur la terre."
,"15":"Quand les Israélites la virent, ils se dirent: 'Manhou' ('Qu'est-ce que c'est?') Car ils ne savaient pas ce que c'était. Alors Moïse leur dit: 'C'est le pain que Yahvé vous donne en nourriture."
,"16":"Et voici l'ordre de Yahvé: Ramassez-en selon ce que chacun peut manger, une mesure par personne selon le nombre des personnes. Chacun en prendra pour tous ceux qui vivent sous sa tente.'"
,"17":"Les Israélites firent donc ainsi. Ils en ramassèrent, l'un plus, l'autre moins."
,"18":"Mais quand on le mesura avec une mesure, pour celui qui avait ramassé beaucoup, rien ne débordait, et pour celui qui avait ramassé moins, la mesure était pleine. Chacun ramassait donc sa ration."
,"19":"Moïse leur dit encore: 'Que personne n'en laisse jusqu'au matin.'"
,"20":"Mais on n'écouta pas Moïse et certains en gardèrent jusqu'au matin. Or voilà que les vers s'y étaient mis, c'était immangeable. Alors Moïse se mit en colère contre eux."
,"21":"Ils en ramassaient chaque matin, chacun sa ration, et dès que le soleil chauffait la manne fondait."
,"22":"Le sixième jour ils ramassèrent le double de pain: deux mesures par personne. Tous les princes de la communauté vinrent le dire à Moïse."
,"23":"Il leur répondit: 'Voici ce qu'a dit Yahvé: Demain est un sabbat, un saint repos en l'honneur de Yahvé. Ce que vous devez cuire, cuisez-le maintenant, et ce que vous devez faire bouillir, faites-le bouillir maintenant. Mais tout ce qui restera, vous le garderez pour demain.'"
,"24":"Ils en gardèrent donc jusqu'au matin selon l'ordre de Moïse, et rien ne se perdit: il n'y avait pas de vers dedans."
,"25":"Moïse dit: 'Mangez-le aujourd'hui! Aujourd'hui, c'est un sabbat pour Yahvé, et vous n'en trouverez pas dehors."
,"26":"Pendant six jours vous en ramasserez, mais le septième jour, le jour du sabbat, il n'y en aura pas.'"
,"27":"En effet, le septième jour des gens sortirent pour en ramasser mais ils n'en trouvèrent pas."
,"28":"Yahvé dit à Moïse: 'Combien de temps en core refuserez-vous d'observer mes commandements et mes lois?"
,"29":"Regardez! Yahvé vous a donné le jour du repos, c'est pour cela qu'il vous donne au sixième jour du pain pour deux jours. Restez donc chez vous et que personne ne sorte de chez lui le septième jour.'"
,"30":"Le peuple se reposa donc le septième jour."
,"31":"La maison d'Israël appela cette nourriture: la manne. C'était comme une petite graine blanche et elle avait le goût d'une galette de miel."
,"32":"Moïse leur dit: 'Voici une instruction de Yahvé: Prenez une pleine mesure de manne que vous garderez pour vos descendants. Ils pourront voir ainsi le pain que je vous ai fait manger au désert, lorsque je vous ai fait sortir du pays d'Egypte.'"
,"33":"Moïse dit à Aaron: 'Prends un pot et verse dedans une pleine mesure de manne. Tu la déposeras devant Yahvé à l'intention de vos descendants.'"
,"34":"Aaron la déposa devant l'Arche d'Alliance comme Yahvé l'avait ordonné à Moïse."
,"35":"Les Israélites mangèrent la manne pendant quarante ans, jusqu'à leur arrivée dans un pays habité; ils mangèrent la manne jusqu'à leur arrivée en pays de Canaan."
,"36":"La mesure dont on se servait faisait à peu près quatre litres."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Toute la communauté des Israélites quitta le désert de Sin; ils réglaient leurs étapes selon l'ordre de Yahvé. Ils vinrent camper à Réfidim, mais là le peuple n'avait pas d'eau à boire."
,"2":"Le peuple se révolta contre Moïse, il disait: 'Donne-nous de l'eau à boire!' Moïse leur dit: 'Pourquoi vous révoltez-vous contre moi? Pourquoi tentez-vous Yahvé?'"
,"3":"Là, le peuple eut soif et murmura contre Moïse: 'Pourquoi, dit-il, nous as-tu fait sortir d'Egypte? Est-ce pour nous faire mourir de soif, nous, nos fils et nos troupeaux?'"
,"4":"Alors Moïse cria vers Yahvé: 'Que ferai-je pour ce peuple? Encore un peu et ils vont me lapider.'"
,"5":"Yahvé répondit à Moïse: 'Passe en avant du peuple! Prends avec toi quelques anciens d'Israël, et va. Tu auras en main le bâton avec lequel tu as frappé le Nil,"
,"6":"et moi, je vais me poster devant toi sur le rocher de l'Horeb. Tu frapperas le rocher, il en sortira de l'eau et le peuple boira.' C'est ce que fit Moïse sous les yeux des anciens d'Israël."
,"7":"On appela ce lieu: Massa (c'est-à-dire: Tentation) et Mériba (c'est-à-dire: Ré volte), parce que les Israélites s'étaient révoltés et qu'ils avaient tenté Yahvé en disant: 'Dieu, est-il vraiment au milieu de nous?'"
,"8":"Quand on était à Réfidim, Amalec vint combattre Israël."
,"9":"Moïse dit à Josué: 'Trouve-nous des hommes pour aller se battre contre Amalec. Demain matin, j'irai me tenir au sommet de la montagne et je tiendrai à la main le bâton de Dieu.'"
,"10":"Josué fit donc ce que Moïse lui avait dit pour combattre Amalec, tandis que Moïse, Aaron et Hour montaient au sommet de la montagne."
,"11":"Tant que Moïse élevait ses mains vers le ciel, Israël l'emportait, mais quand il laissait retomber ses mains, Amalec était le plus fort."
,"12":"Les mains de Moïse se fatiguaient: alors on prit une pierre et on la plaça sous lui. Moïse s'assit dessus pendant qu'Aaron et Hour lui soutenaient les mains, l'un d'un côté, l'autre de l'autre. Ainsi ses mains restèrent levées jusqu'au coucher du soleil,"
,"13":"et Josué fit un massacre d'Amalec et de son peuple."
,"14":"Yahvé dit à Moïse: 'Ecris-cela dans le Livre pour qu'on s'en souvienne. Et tu diras à Josué: Plus personne sous le ciel ne se souviendra d'Amalec.'"
,"15":"Moïse construisit un autel et lui donna ce nom: 'Yahvé est ma victoire!' Car il disait: 'Une main s'est levée contre le trône de Yahvé, Yahvé est en guerre contre Amalec de génération en génération.'"
}`)
	CurrentBook.AddChapter(18, `{
"1":"Jéthro était prêtre de Madian et beau-père de Moïse. Il apprit tout ce que Dieu avait fait pour Moïse et pour Israël son peuple lorsque Yahvé avait fait sortir Israël d'Egypte."
,"2":"Jéthro, beau-père de Moïse, avait recueilli Séfora, car Moïse l'avait renvoyée"
,"3":"avec ses deux fils. L'un s'appelait Guerchom, car Moïse avait dit: 'Je suis un immigré sur une terre étrangère.'"
,"4":"Et l'autre s'appelait Eliézer, car il avait dit: 'Le Dieu de mon père est venu à mon aide et il m'a délivré de l'épée du Pharaon.'"
,"5":"Jéthro, le beau-père de Moïse, amena donc à Moïse sa femme et ses fils alors qu'il campait au désert, à la montagne de Dieu."
,"6":"Il fit dire à Moïse: 'Moi, Jéthro, ton beau-père, je suis venu te trouver avec ta femme et tes deux fils.'"
,"7":"Moïse sortit à la rencontre de son beau-père, il se prosterna et l'embrassa. Puis ils se demandèrent l'un à l'autre des nouvelles de leur santé et ils entrèrent sous la tente."
,"8":"Moïse raconta à son beau-père tout ce que Yahvé avait fait au Pharaon et à l'Egypte pour le bien d'Israël, et toutes les difficultés qu'ils avaient rencontrées sur la route, mais dont Yahvé les avait délivrés."
,"9":"Jéthro fut très heureux d'apprendre tout le bien que Yahvé avait fait à Israël et comment il l'avait délivré de la main des Egyptiens."
,"10":"Alors Jéthro dit à Moïse: 'Béni soit Yahvé qui vous a délivrés de l'Egypte et de la main du Pharaon: il a délivré son peuple de l'oppression des Egyptiens!"
,"11":"Maintenant je sais que Yahvé est plus grand que tous les autres dieux, il l'a bien montré lorsque l'on maltraitait son peuple.'"
,"12":"Jéthro, le beau-père de Moïse, offrit un sacrifice et présenta des offrandes à Dieu, puis Aaron et tous les anciens d'Israël vinrent prendre un repas avec le beau-père de Moïse en présence de Dieu."
,"13":"Le lendemain Moïse s'assit pour rendre justice au peuple, et il y eut des gens autour de Moïse du matin jusqu'au soir."
,"14":"Le beau-père de Moïse vit tout ce qu'il faisait pour le peuple. Il lui dit: 'Tu t'en donnes du mal pour ce peuple! Pourquoi sièges-tu seul, pendant que tout ce peuple reste là debout à tes côtés du matin jusqu'au soir?'"
,"15":"Moïse répondit à son beau-père: 'Le peuple vient vers moi pour consulter Dieu."
,"16":"Lorsqu'il y a un problème, on vient vers moi et je décide entre les uns et les autres. Ensuite je fais connaître les règles de Dieu et ses enseignements.'"
,"17":"Le beau-père de Moïse lui dit: 'Tu t'y prends mal!"
,"18":"Tu vas t'épuiser, tout comme le peuple qui est avec toi! La charge est trop lourde pour toi, tu ne peux pas la porter seul."
,"19":"Ecoute-moi maintenant, je vais te donner un conseil et Dieu sera avec toi! Sois pour ton peuple le représentant de Dieu et présente-lui ses problèmes."
,"20":"Tu leur expliqueras les commandements et les lois, tu leur feras connaître le chemin sur lequel ils doivent marcher et la façon dont ils doivent agir."
,"21":"Mais aussi tu choisiras du milieu du peuple des hommes de valeur qui craignent Dieu, des hommes sincères qui refusent de se laisser corrompre, et tu les mettras à leur tête comme chefs de mille, chefs de cent, chefs de cinquante et chefs de dix."
,"22":"Ils rendront la justice dans ton peuple en tout temps et, s'il y a une affaire importante, ils te la présenteront. Mais ils jugeront les petites affaires, et ta charge sera moins lourde car ils la porteront avec toi."
,"23":"Si tu fais cela, Dieu te conduira et tu pourras résister. Ainsi tout le peuple arrivera heureusement là où Dieu le conduit.'"
,"24":"Moïse écouta son beau-père et fit ce qu'il lui avait dit."
,"25":"Il choisit donc des hommes de valeur du milieu d'Israël et il les plaça à la tête du peuple comme chefs de mille, chefs de cent, chefs de cinquante et chefs de dix."
,"26":"Ils rendaient la justice au peuple en tout temps. Ils présentaient à Moïse les affaires importantes et rendaient la justice eux-mêmes pour toutes les petites affaires."
,"27":"Moïse reconduisit ensuite son beau-père, qui retourna dans son pays."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Le troisième mois après la sortie d'Egypte, les Israélites arrivèrent au désert du Sinaï."
,"2":"Ils étaient partis de Réfidim et ils arrivèrent au désert du Sinaï où ils campèrent. Les Israélites établirent leur camp face à la montagne, "
,"3":"et Moïse monta vers Dieu. Yahvé lui cria du haut de la montagne: 'Voici ce que tu diras à la maison de Jacob, voici ce que tu annonceras aux fils d'Israël:"
,"4":"'Vous avez vu ce que j'ai fait à l'Egypte et comment je vous ai portés sur les ailes de l'aigle pour vous amener jusqu'à moi."
,"5":"Maintenant, si vous écoutez attentivement ma voix et si vous gardez mon alliance, vous serez pour moi un peuple à part parmi tous les peuples. Car toute la terre est à moi,"
,"6":"mais vous, vous serez pour moi une race de prêtres, une nation sainte.',C'est ainsi que tu parleras aux Israélites.'"
,"7":"Moïse rassembla les anciens du peuple et leur transmit toutes ces paroles, selon l'ordre de Yahvé."
,"8":"Tout le peuple répondit d'une seule voix: 'Tout ce que Yahvé a dit, nous le ferons!' Et Moïse rapporta à Yahvé ces paroles du peuple."
,"9":"Yahvé dit alors à Moïse: 'Je vais venir à toi dans l'épaisseur de la nuée, pour que le peuple entende quand je parlerai avec toi et qu'il ait confiance en toi aussi, pour toujours.' Et Moïse rapporta à Yahvé les paroles du peuple."
,"10":"Yahvé dit encore à Moïse: 'Retourne vers le peuple et veille à ce qu'ils se consacrent aujourd'hui et demain. Qu'ils lavent leurs vêtements"
,"11":"et se tiennent prêts pour le troisième jour; car le troisième jour Yahvé descendra sur le mont Sinaï aux yeux de tout le peuple."
,"12":"Tu fixeras une limite au peuple et tu lui diras: Attention à ne pas monter sur la montagne, n'en touchez pas même le bord; celui qui touchera la montagne sera mis à mort!"
,"13":"On ne le frappera pas avec la main, mais il sera tué à coups de pierres ou de flèches: bête ou homme, il ne restera pas en vie. Seulement quand on sonnera de la trompe, quelques-uns monteront sur la montagne."
,"14":"Moïse redescendit de la montagne vers le peuple et le consacra. Ils lavèrent leurs vêtements,"
,"15":"puis Moïse leur dit: 'Préparez-vous pour le troisième jour, n'ayez pas de relations avec vos femmes.'"
,"16":"Le troisième jour, dès le matin, il y eut sur la montagne des tonnerres, des éclairs et une épaisse nuée. On entendit un fort son de trompe qui fit trembler tout le monde dans le camp."
,"17":"Moïse fit sortir le peuple du camp à la rencontre de Dieu, et tous se tinrent au pied de la montagne."
,"18":"La montagne du Sinaï était toute fumante parce que Yahvé était descendu sur elle dans le feu; la fumée s'élevait comme la fumée d'une fournaise, et toute la montagne tremblait."
,"19":"Le son de la trompe devint de plus en plus fort: Moïse parlait et Dieu lui répondait par le tonnerre."
,"20":"Yahvé descendit sur le mont Sinaï, au sommet de la montagne, et de là Yahvé appela Moïse. Alors Moïse monta."
,"21":"Dieu dit à Moïse: 'Redescends pour avertir le peuple. Tu leur diras: Ne vous précipitez pas vers Yahvé pour le voir, car beaucoup d'entre vous en mourraient!"
,"22":"Et que les prêtres qui s'approchent de Yahvé se sanctifient, de peur que Yahvé ne se re tourne contre eux!'"
,"23":"Moïse répondit à Yahvé: 'Le peuple ne montera pas sur la montagne du Sinaï. Toi-même tu nous as prévenus et tu nous as dit: Délimitez la montagne et faites-en un lieu sacré.'"
,"24":"Alors Yahvé lui dit: 'Va, redescends. Puis tu monteras avec Aaron. Mais que les prêtres et le peuple ne cherchent pas à monter de force vers Yahvé, car il les abattrait.'"
,"25":"Moïse descendit donc vers le peuple et lui dit..."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Alors Dieu prononça toutes ces paroles:"
,"2":"'Je suis Yahvé ton Dieu, celui qui t'a fait sortir d'Egypte, du pays de l'esclavage:"
,"3":"tu n'auras pas d'autre Dieu que moi."
,"4":"Tu ne feras pas de statue à l'image des choses qui sont là-haut dans le ciel, ou en bas sur la terre, ou dans les eaux sous la terre."
,"5":"Tu ne te prosterneras pas devant elles, tu ne les serviras pas, car moi, Yahvé, ton Dieu, je suis un Dieu jaloux. Je punis la faute des pères sur leurs fils, leurs petits-fils et arrière-petits-fils, lorsqu'ils me haïssent."
,"6":"Mais je garde ma faveur jusqu'à la millième génération pour ceux qui m'aiment et gardent mes commandements."
,"7":"Tu ne feras pas un mauvais usage du nom de Yahvé ton Dieu, car Yahvé ne tient pas quitte celui qui fait un mauvais usage de son nom."
,"8":"Souviens-toi du jour du sabbat et sanctifie-le."
,"9":"Pendant six jours tu serviras et tu feras ton travail,"
,"10":"mais le septième jour est un repos en l'honneur de Yahvé, ton Dieu. Tu ne feras aucun travail, ni toi, ni ton fils, ni ta fille, ni ton serviteur, ni ta servante, ni tes bêtes, ni l'étranger qui habite chez toi."
,"11":"Sache que Yahvé a fait en six jours les cieux, la terre, la mer et tout ce qui s'y trouve, et il s'est reposé le septième jour. C'est pour cela que Yahvé a béni ce jour de sabbat et l'a rendu saint."
,"12":"Entoure d'égards ton père et ta mère: c'est ainsi que tu vivras longtemps sur la terre que Yahvé ton Dieu te donne."
,"13":"Tu ne tueras pas."
,"14":"Tu ne commettras pas d'adultère."
,"15":"Tu ne voleras pas."
,"16":"Tu ne porteras pas de faux témoignage contre ton prochain."
,"17":"Tu ne resteras pas à désirer la maison de ton prochain, tu ne chercheras pas à prendre la femme de ton prochain, ni son serviteur, ni sa servante, ni son boeuf, ni son âne, ni rien de ce qui lui appartient.'"
,"18":"Tout le peuple regardait: ce n'étaient que tonnerre, éclairs et sons de trompes sur la montagne fumante. Le peuple en tremblait et se tenait à distance."
,"19":"Alors tous dirent à Moïse: 'Parle-nous, toi, et nous t'écouterons, mais que Dieu ne nous parle pas, ou nous allons mourir!'"
,"20":"Moïse répondit au peuple: 'C'est pour vous mettre à l'épreuve que Dieu est descendu, pour que sa crainte soit toujours en vous, et que vous ne péchiez pas.'"
,"21":"C'est ainsi que le peuple se tint à distance pendant que Moïse s'avançait vers la nuée, là où était Dieu."
,"22":"Yahvé dit à Moïse: 'Voici ce que tu diras aux Israélites: Vous avez vu que je vous parlais du haut du ciel."
,"23":"Vous ne mettrez rien sur le même plan que moi, vous ne vous ferez pas des dieux d'argent et des dieux d'or."
,"24":"Tu me feras un autel de terre où tu présenteras tes sacrifices et tes offrandes de petit et de gros bétail. Dans tous les lieux où j'aurai manifesté mon Nom, je viendrai vers toi et je te bénirai."
,"25":"Si tu me fais un autel de pierres, tu ne tailleras pas les pierres, parce qu'en les travaillant avec le fer tu les profanerais."
,"26":"Tu ne monteras pas à mon autel par des marches pour ne pas découvrir ta nudité."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Voici les lois que tu leur dicteras:"
,"2":"Si tu achètes un esclave hébreu, il te servira pendant six ans, et la septième année il partira libre, sans payer de rançon."
,"3":"S'il est entré seul à ton service, il partira seul. S'il était marié, sa femme partira avec lui."
,"4":"Si son maître lui a donné une femme qui lui a enfanté des fils ou des filles, la femme et les enfants appartiennent au maître, l'esclave partira seul."
,"5":"Mais si l'esclave dit: J'aime mon maître, ma femme et mes enfants, je ne veux pas profiter de ma liberté,"
,"6":"son maître le fera approcher de Dieu. Il le conduira vers le battant ou le montant de la porte, et là son maître lui percera l'oreille avec un poinçon; dès lors il restera pour toujours à son service."
,"7":"Si un homme a vendu sa fille comme esclave, elle ne partira pas comme n'importe quelle esclave."
,"8":"Si elle ne plaît pas à son maître qui devait la prendre, et qu'il la laisse racheter, il ne pourra pas la vendre à un étranger après lui avoir manqué de parole."
,"9":"S'il la donne à son fils, il agira envers elle selon le droit des filles."
,"10":"S'il en prend une autre pour lui, il ne retranchera rien sur sa nourriture, sur ses vêtements ou sur son logement."
,"11":"Et s'il ne fait pas pour elle ces trois choses, elle pourra partir sans payer de rançon, sans verser d'argent."
,"12":"Celui qui frappe quelqu'un et cause sa mort, devra mourir."
,"13":"S'il l'a tué involontairement, simplement parce que Dieu a disposé les choses ainsi, il pourra se mettre à l'abri de la vengeance dans un lieu que je te fixerai."
,"14":"Par contre, si un homme se jette sur son prochain pour le tuer par traîtrise, tu iras le chercher, même réfugié près de mon autel, et tu le mettras à mort."
,"15":"Celui qui frappe son père ou sa mère sera mis à mort."
,"16":"Celui qui a enlevé quelqu'un pour le vendre, si on le trouve chez lui, il sera mis à mort."
,"17":"Celui qui maudit son père ou sa mère sera mis à mort."
,"18":"Si, au cours d'une querelle, un homme en frappe un autre avec une pierre ou avec le poing, et que celui-ci ne meurt pas mais doit rester au lit;"
,"19":"si ensuite le blessé peut se lever et se promener dehors avec une canne, celui qui l'a frappé sera quitte. Mais il devra le dédommager pour son immobilisation et pour ses soins."
,"20":"Si un homme frappe son esclave ou sa servante avec un bâton et que l'autre meure sur le coup, l'esclave sera vengé."
,"21":"Mais s'il vit encore un jour ou deux, on ne le vengera pas, car il est la propriété de son maître."
,"22":"Si, en se battant, des hommes bousculent une femme enceinte et qu'elle avorte sans autre dommage, le mari de la femme fixera l'amende, et le coupable paiera selon la décision des juges."
,"23":"Mais s'il arrive un malheur, tu paieras vie pour vie,"
,"24":"oeil pour oeil, dent pour dent, main pour main, pied pour pied,"
,"25":"brûlure pour brûlure, blessure pour bles-,sure, plaie pour plaie."
,"26":"Si un homme a frappé son esclave ou sa servante à l'oeil, et que l'oeil soit perdu, il lui rendra la liberté en échange de son oeil."
,"27":"S'il a fait tomber une dent de son esclave ou de sa servante, il lui rendra la liberté en échange de sa dent."
,"28":"Si un boeuf blesse avec sa corne un homme ou une femme, et que la victime meure, le boeuf sera lapidé. On ne mangera pas sa viande, mais le propriétaire du boeuf sera quitte."
,"29":"Mais si un boeuf depuis quelque temps donnait des coups de cornes, et que son maître le savait et ne l'a pas surveillé, si ce boeuf cause la mort d'un homme ou d'une femme, le boeuf sera lapidé et le maître sera mis à mort."
,"30":"Si cependant on lui permet de racheter sa vie à prix d'argent, il paiera tout ce qui lui sera demandé."
,"31":"Si le boeuf blesse de sa corne un fils ou une fille, on agira de la même façon."
,"32":"Mais si c'est un esclave ou une servante que le boeuf a blessé de sa corne, on paiera trente pièces d'argent au maître de l'esclave et le boeuf sera lapidé."
,"33":"Si un homme a laissé une citerne ouverte, ou s'il a creusé une citerne sans la recouvrir, et qu'un boeuf ou un âne y tombe,"
,"34":"le propriétaire de la citerne versera une indemnité en argent au maître de la bête et gardera la bête pour lui."
,"35":"Si quelqu'un a eu son boeuf mortellement blessé par le boeuf de quelqu'un d'autre, ils vendront le boeuf vivant et se partageront l'argent de la vente ainsi que la bête morte."
,"36":"Mais s'il est connu que depuis quelque temps le boeuf donnait des coups de cornes, et que son maître ne l'a pas surveillé, il devra payer boeuf pour boeuf et la bête morte sera pour lui."
,"37":"Si un homme vole un boeuf ou une brebis, puis l'égorge et le vend, il paiera cinq têtes de gros bétail pour le boeuf, et quatre de petit bétail pour la brebis."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Si un voleur surpris la nuit en train de percer le mur est frappé à mort, son sang ne sera pas vengé."
,"2":"Mais si le soleil était déjà levé, son sang sera vengé. Celui qui a volé devra rembourser, et s'il n'a pas de quoi payer, il sera vendu en échange de ce qu'il a volé. "
,"3":"Si l'on retrouve chez lui ce qu'il a volé, que ce soit un boeuf, un âne ou un agneau, il rendra le double."
,"4":"Si un homme laisse ses bêtes brouter dans son champ ou dans sa vigne et qu'elles broutent dans le champ d'un autre, il devra le dédommager selon ce que rapportait ce champ ou cette vigne."
,"5":"Si un feu éclate, gagne les broussailles, et qu'une meule ou des épis ou un champ soient brûlés, celui qui a allumé l'incendie devra dédommager."
,"6":"Si un homme donne à son prochain de l'argent ou des objets à garder dans sa maison, et qu'un vol y soit commis, le voleur, s'il est trouvé, rendra le double."
,"7":"Mais si le voleur n'est pas retrouvé, le maître de la maison s'approchera de Dieu et jurera que ce n'est pas lui qui a volé le bien de son prochain."
,"8":"Quelle que soit la chose volée, que ce soit un boeuf, un âne, un agneau, un vêtement ou toute autre chose, l'affaire sera portée devant Dieu et celui qui aura été condamné par Dieu rendra le double à son prochain."
,"9":"Si un homme a donné en garde à son prochain un âne, ou un boeuf, ou une brebis, ou toute autre bête, et que l'animal est mort, ou a été blessé ou volé sans témoin,"
,"10":"l'affaire sera réglée par un serment devant Yahvé. Celui qui gardait l'animal jurera qu'il n'a pas volé le bien de son prochain et le maître de l'animal se contentera du serment: l'autre n'aura pas à payer."
,"11":"Mais si l'animal est trouvé en sa possession, il en donnera le prix à son maître."
,"12":"Si l'animal a été déchiré par des fauves, il en donnera les preuves et n'aura pas à payer pour l'animal mis en pièces."
,"13":"Si quelqu'un a emprunté à son prochain un animal, et que cet animal soit blessé ou meure en l'absence de son maître, celui qui l'a emprunté devra en payer le prix."
,"14":"Mais si le propriétaire de l'animal était sur place, il n'aura rien à payer, l'autre se contentera de la location de la bête."
,"15":"Si un homme tombe amoureux d'une vierge qui n'est pas encore fiancée et couche avec elle, il en paiera le prix et elle sera sa femme."
,"16":"Mais si son père refuse de la donner en mariage, l'autre versera en argent l'équivalent d'une dot."
,"17":"Tu ne laisseras pas vivre une sorcière."
,"18":"Celui qui couche avec une bête sera mis à mort."
,"19":"Celui qui offre des sacrifices en l'honneur de dieux autres que Yahvé, sera mis à mort."
,"20":"Vous ne maltraiterez pas l'étranger et vous ne l'opprimerez pas, car vous avez été des étrangers en Egypte."
,"21":"Vous ne maltraiterez pas la veuve ni l'orphelin."
,"22":"Si vous les maltraitez et qu'ils crient vers moi, j'entendrai leur cri."
,"23":"Alors ma colère s'enflammera contre vous: je vous ferai périr par l'épée, vos femmes resteront veuves, et vos fils orphelins."
,"24":"Si tu prêtes de l'argent à quelqu'un de ton peuple, à un pauvre qui vit au milieu de vous, tu ne te conduiras pas envers lui comme un créancier, tu ne lui imposeras pas d'intérêts."
,"25":"Si tu as pris en gage le manteau de ton prochain, tu le lui rendras au coucher du soleil,"
,"26":"car il n'a pas d'autre couverture, rien d'autre que ce manteau pour se couvrir: et comment dormira-t-il? Si jamais il crie vers moi, je l'entendrai, car moi j'ai pitié."
,"27":"Tu ne blasphèmeras pas le Nom de Dieu et tu ne maudiras pas le chef de ton peuple."
,"28":"Tu m'offriras sans tarder la sève de ton champ et le jus de ton pressoir; tu me donneras le premier-né de tes fils."
,"29":"Tu feras de même pour ton boeuf et pour ton petit bétail: durant sept jours ils resteront avec la mère, et le huitième jour tu me les offriras."
,"30":"Vous serez pour moi un peuple saint. Vous ne mangerez pas la viande d'une bête mise en pièces dans les champs, mais vous la donnerez aux chiens."
}`)
	CurrentBook.AddChapter(23, `{
"1":"Tu ne feras pas circuler des paroles mensongères. Tu n'aideras pas le méchant en donnant un faux témoignage."
,"2":"Tu ne suivras pas la majorité quand elle fait mal; ton témoignage ne s'écartera pas de la vérité pour dire comme tout le monde,"
,"3":"pas même pour aider un pauvre dans son procès."
,"4":"Si le boeuf ou l'âne de ton ennemi s'est égaré et que tu le rencontres, tu le lui ramèneras."
,"5":"Lorsque tu verras l'âne de celui qui te déteste écrasé par son fardeau, tu ne passeras pas sans t'arrêter, mais tu l'aideras."
,"6":"Tu ne feras pas dévier le droit lorsque tes pauvres auront un procès."
,"7":"Tu te garderas de toute parole mensongère. Tu ne feras pas mourir l'innocent, le juste, car moi, je fais la différence entre le juste et le coupable."
,"8":"Tu n'accepteras pas de pot de vin, car l'argent aveugle ceux qui voyaient clair et fait du tort à la cause du juste."
,"9":"Tu n'opprimeras pas l'étranger, car tu as l'expérience de ce que ressent l'étranger: vous étiez des étrangers en Egypte."
,"10":"Durant six années tu ensemenceras ta terre et tu en récolteras les produits;"
,"11":"mais la septième année, tu ne la cultiveras pas et tu la laisseras se reposer. Les pauvres de ton peuple y trouveront de quoi manger, et les bêtes des champs en mangeront les restes. Tu feras de même pour ta vigne et pour ton olivier."
,"12":"Durant six jours tu travailleras, mais le septième jour tu te reposeras. Ton boeuf et ton âne se reposeront et le fils de ta servante, comme l'étranger, pourront souffler."
,"13":"Vous observerez tout ce que je vous ai dit. Vous ne prononcerez pas le nom des autres dieux, on ne les entendra jamais de votre bouche."
,"14":"Trois fois par an tu feras une fête en mon honneur:"
,"15":"Tu observeras la fête des pains sans levain. Pendant sept jours tu mangeras des pains sans levain, à la date fixée du mois d'Abib, comme je te l'ai ordonné, car c'est en ce mois que tu es sorti d'Egypte. On ne se présentera pas devant moi les mains vides."
,"16":"Puis viendra la fête de la moisson, la fête des premiers produits de ton travail, de tout ce que tu as semé dans les champs. Enfin viendra la fête de la récolte au terme de l'année, lorsque tu récolteras les derniers fruits de ton travail dans les champs."
,"17":"Ainsi, trois fois par an, tous les mâles de ton peuple se présenteront devant le Seigneur Yahvé."
,"18":"Tu n'offriras pas le sang du sacrifice avec du pain levé, et tu ne garderas pas la graisse du sacrifice jusqu'au matin."
,"19":"Tu amèneras à la maison de Yahvé, ton Dieu, les premiers produits de tes champs. Tu ne feras pas cuire un chevreau dans le lait de sa mère."
,"20":"Maintenant j'envoie un ange devant toi pour te protéger sur la route et pour te faire entrer dans le lieu que j'ai préparé."
,"21":"Marche droit devant lui, écoute sa voix, ne te révolte pas contre lui. Sache qu'il ne pardonnera pas ton péché et que mon Nom est en lui."
,"22":"Mais si tu écoutes sa voix, si tu fais tout ce que je te dirai, je serai l'ennemi de tes ennemis et l'adversaire de tes adversaires."
,"23":"Mon ange ira devant toi, il te fera entrer au pays des Amorites, des Hittites, des Périsites, des Cananéens, des Hivvites et des Jébusites, et moi, je les exterminerai."
,"24":"Tu ne te prosterneras pas devant leurs dieux, tu ne les serviras pas, tu ne feras pas comme on fait chez eux; mais au contraire tu détruiras leurs dieux et tu briseras leurs pierres sacrées."
,"25":"Vous servirez Yahvé votre Dieu: alors je bénirai ton pain et ton eau et j'écarterai de chez toi toute maladie."
,"26":"On ne verra dans ton pays ni femme qui avorte ni femme stérile, mais je vous comblerai de jours."
,"27":"Alors j'enverrai devant toi ma Crainte, et j'enverrai la Déroute à tous les peuples chez qui tu entreras: je ferai fuir devant toi tous tes ennemis."
,"28":"J'enverrai les frelons pour qu'ils chassent devant toi les Hivvites, les Cananéens et les Hittites."
,"29":"Cependant, je ne les chasserai pas en une seule année, sinon le pays resterait en friche et les animaux sauvages se multiplieraient pour ton malheur."
,"30":"Je ne les chasserai donc que peu à peu, le temps que tu sois suffisamment fort pour occuper tout le pays."
,"31":"Je fixerai ta frontière depuis la Mer des Roseaux jusqu'à la Mer des Philistins, et depuis le désert jusqu'au fleuve. Je livrerai entre tes mains les habitants du pays et je les chasserai devant toi."
,"32":"Tu ne feras pas d'alliance avec eux ni avec leurs dieux;"
,"33":"il ne faut pas qu'ils restent dans ton pays, car ils t'amèneraient à servir leurs dieux et à pécher contre moi; ils seraient pour toi un piège.'"
}`)
	CurrentBook.AddChapter(24, `{
"1":"Dieu dit alors à Moïse: 'Monte vers Yahvé avec Aaron, Nadab, Abihou et les soixante-dix anciens d'Israël. De loin vous vous prosternerez."
,"2":"Puis Moïse s'avancera seul vers Yahvé; eux ne s'avanceront pas et le peuple ne montera pas avec eux.'"
,"3":"Moïse descendit, il répéta au peuple toutes ces paroles de Yahvé et toutes ces lois. Tous d'une seule voix répondirent: 'Nous ferons tout ce que Yahvé a dit!'"
,"4":"Alors Moïse écrivit toutes les paroles de Yahvé. De bon matin il se leva et construisit un autel au pied de la montagne, avec douze pierres dressées pour les douze tribus d'Israël. "
,"5":"Puis il chargea de jeunes Israélites d'offrir des sacrifices par le feu et de jeunes taureaux en sacrifice de communion."
,"6":"Moïse prit la moitié du sang et le mit dans des bassins; avec l'autre moitié du sang il aspergea l'autel."
,"7":"Il prit ensuite le livre de l'Alliance et le lut devant tout le peuple. Ils répondirent: 'Nous ferons tout ce que Yahvé a dit et nous l'écouterons!'"
,"8":"Alors Moïse prit le sang, il en aspergea le peuple, puis il dit: 'Voici le sang de l'Alliance que Yahvé a conclue avec vous, selon toutes ces paroles.'"
,"9":"Moïse monta ensuite avec Aaron, Nadab, Abihou et les soixante-dix anciens d'Israël."
,"10":"Ils virent le Dieu d'Israël: il y avait sous ses pieds comme un dallage de saphir, si pur que l'on aurait dit le ciel."
,"11":"Dieu ne porta pas la main sur ceux qu'il avait choisis, mais ils virent Dieu; ils mangèrent et ils burent."
,"12":"Dieu dit à Moïse: 'Monte vers moi sur la montagne, et reste là pour que je te donne des tables de pierre avec la loi et la règle que j'ai écrites pour leur instruction.'"
,"13":"Moïse se leva avec Josué, son serviteur, et ils montèrent à la montagne de Dieu."
,"14":"Il avait dit aux anciens: 'Restez ici jusqu'à ce que nous revenions. Vous avez avec vous Aaron et Hour, s'il arrive quelque chose vous verrez avec eux.'"
,"15":"Moïse fit donc l'ascension de la montagne, et la nuée la couvrit."
,"16":"La Gloire de Yahvé s'était posée sur le mont Sinaï et la nuée le couvrit pendant six jours. Le septième jour, Dieu appela Moïse du milieu de la nuée."
,"17":"La Gloire de Yahvé restait au sommet de la montagne à la vue des Israélites, semblable à un feu dévorant,"
,"18":"et Moïse entra dans la nuée tandis qu'il gravissait la montagne. Moïse resta sur la montagne quarante jours et quarante nuits."
}`)
	CurrentBook.AddChapter(25, `{
"1":"Yahvé s'adressa à Moïse et lui dit:"
,"2":"'Tu demanderas aux Israélites de verser une contribution pour moi, et tu recevras toutes leurs offrandes volontaires."
,"3":"Voici les produits que tu accepteras en contribution: l'or, l'argent et le cuivre,"
,"4":"la pourpre violette et la pourpre rouge, la teinture rouge, le lin fin, les poils de chèvres,"
,"5":"les peaux de béliers teintes en rouge, la peau de poisson et le bois d'acacia,"
,"6":"l'huile pour la lumière, le parfum pour l'huile et pour l'encens,"
,"7":"les pierres d'onyx et les pierres précieuses pour l'éphod et pour le pectoral."
,"8":"Car ils vont me faire un sanctuaire, pour que j'habite au milieu d'eux."
,"9":"Ce sanctuaire, et tous les objets qui y seront, vous les ferez selon les plans que je te ferai voir."
,"10":"Ils feront donc une Arche en bois d'acacia, sa longueur sera de deux coudées et demie, sa largeur d'une coudée et demie et sa hauteur d'une coudée et demie."
,"11":"Tu la recouvriras d'or fin, à l'intérieur comme à l'extérieur, et tu feras tout autour une bordure en or."
,"12":"Tu fondras quatre anneaux d'or et tu les placeras sur les quatre pieds: deux anneaux d'un côté, deux anneaux de l'autre côté."
,"13":"Tu feras des barres en bois d'acacia, et tu les recouvriras d'or."
,"14":"Pour porter l'arche, tu passeras les barres dans les anneaux qui sont sur les côtés de l'Arche."
,"15":"Les barres resteront dans les anneaux de l'Arche, on ne les retirera pas."
,"16":"Tu placeras dans l'Arche le Témoignage que je te donnerai."
,"17":"Le couvercle sera en or fin, sa longueur sera de deux coudées et demie et sa largeur d'une coudée et demie, ce sera l'Instrument de l'Expiation."
,"18":"Tu feras ensuite deux chérubins d'or. Tu les feras en or massif et tu les placeras aux extrémités du couvercle."
,"19":"Il y aura un chérubin à une extrémité, un chérubin à l'autre extrémité. Les chérubins ressortiront sur le couvercle aux deux bouts."
,"20":"Les chérubins étendront les deux ailes vers le haut, et ces ailes protégeront l'Instrument de l'Expiation. Leurs faces seront tournées l'une vers l'autre, et les faces des chérubins regarderont vers l'Instrument de l'Expiation."
,"21":"Tu placeras l'Instrument de l'Expiation sur l'Arche, et tu placeras dans l'Arche le Témoignage que je te donnerai."
,"22":"C'est là que je viendrai à ta rencontre: je te parlerai de dessus l'Instrument du Pardon, entre les deux chérubins posés sur l'Arche du Témoignage, afin de te donner mes ordres pour les Israélites."
,"23":"Tu feras une table en bois d'acacia. Sa longueur sera de deux coudées, sa largeur d'une coudée, sa hauteur d'une coudée et demie."
,"24":"Tu la recouvriras d'or fin et tu feras une bordure en or, tout autour."
,"25":"Tu lui feras un encadrement de la largeur d'une main, et tu feras une bordure en or pour l'encadrement."
,"26":"Tu feras quatre anneaux d'or que tu placeras aux quatre coins, à la hauteur des quatre pieds;"
,"27":"les anneaux d'or seront à côté de l'encadrement, on y passera les barres pour porter la table."
,"28":"Tu feras les barres en bois d'acacia et tu les recouvriras d'or: elles serviront pour porter la table."
,"29":"Tu feras aussi les plats et les assiettes, les gobelets et les tasses avec lesquels on versera les offrandes liquides. Ils seront en or fin."
,"30":"Tu placeras sur la table devant moi, en permanence, les pains de proposition."
,"31":"Tu feras aussi un chandelier d'or pur. Le chandelier sera en or massif, avec sa tige et ses branches; ses coupes, ses boutons et ses fleurs ne feront qu'un avec lui."
,"32":"Six branches sortiront sur les côtés, trois d'un côté du chandelier, trois de l'autre."
,"33":"Il y aura sur une branche trois coupes en forme d'amandes, avec boutons et fleurs, et sur l'autre branche, trois coupes en forme d'amandes, avec boutons et fleurs. Ainsi, six branches sortiront du chandelier."
,"34":"Quant au chandelier, il aura quatre coupes en forme d'amandes avec boutons et fleurs:"
,"35":"un bouton sous deux branches qui partent du chandelier, un bouton sous les deux autres branches, et un bouton sous les deux dernières branches. Ce sera pareil pour les six branches du chandelier."
,"36":"Les boutons et les branches ne feront qu'un avec lui: le tout ne fera qu'une seule pièce d'or fin."
,"37":"Tu feras sept lampes pour le chandelier, elles seront montées de façon à éclairer de face."
,"38":"Les ciseaux pour couper les mèches et les cendriers seront d'or fin."
,"39":"On prendra trente cinq kilos d'or fin pour le chandelier et tous les accessoires."
,"40":"Veille donc à tout faire selon le plan qui t'a été montré sur la montagne."
}`)
	CurrentBook.AddChapter(26, `{
"1":"Pour faire la Demeure, tu prendras dix tentures de lin fin, de pourpre violette et de pourpre rouge, et de tissus teints en rouge foncé, et tu les broderas de chérubins."
,"2":"La longueur d'une tenture sera de vingt huit coudées, sa largeur de quatre coudées. Toutes les tentures auront la même dimension."
,"3":"Les tentures seront attachées cinq par cinq."
,"4":"Tu feras des cordons en pourpre violette sur le bord de la première tenture, près de l'attache, et tu feras de même sur le bord de la tenture qui lui fait face."
,"5":"Tu feras cinq cordons à la première tenture, et cinq cordons à la tenture qui lui fait face. Les cordons se feront face l'un à l'autre."
,"6":"Tu feras cinq agrafes d'or et tu attacheras les tentures par ces agrafes. Ainsi, la demeure ne fera qu'un seul tout."
,"7":"Tu feras également des tentures en poils de chèvres pour couvrir la demeure. Il y en aura onze."
,"8":"La longueur d'une tenture sera de trente coudées, sa largeur de quatre coudées. Les onze tentures auront la même dimension."
,"9":"Tu attacheras séparément cinq tentures d'un côté, et six tentures de l'autre. Tu doubleras la sixième tenture qui se trouve devant l'entrée de la demeure."
,"10":"Ensuite, tu feras cinquante cordons au bord de la première tenture; ils s'attacheront aux cinquante cordons de l'autre tenture."
,"11":"Tu feras cinquante agrafes de bronze et tu passeras les agrafes dans les cordons. Ainsi tu monteras la demeure pour qu'elle ne fasse qu'un seul ensemble."
,"12":"On laissera dépasser derrière la demeure ce qu'il y a de trop dans les tentures, et on le repliera en deux."
,"13":"On laissera dépasser sur les côtés de la demeure, pour la protéger, la coudée qui est en trop dans la longueur des tentures."
,"14":"Pour couvrir la demeure, tu feras une couverture en peaux de béliers teintes en rouge et une couverture en peau de poisson par-dessus."
,"15":"Les planches de la demeure seront en bois d'acacia."
,"16":"Chaque planche aura dix coudées de long, et une coudée et demie de large."
,"17":"Chaque planche portera deux tenons, l'un à côté de l'autre. C'est ainsi que tu feras toutes les planches de la demeure."
,"18":"Tu monteras les planches de la demeure: d'abord les vingt planches tournées vers le sud."
,"19":"Tu feras quarante supports en argent pour ces planches, et il y aura un support pour chacun des tenons de chacune des planches."
,"20":"Pour le second côté de la demeure, le côté qui est tourné vers le nord, tu feras vingt planches,"
,"21":"avec leurs quarante supports en argent, deux supports sous chacune des planches."
,"22":"Pour l'arrière de la demeure qui est tourné vers l'ouest, tu feras six planches."
,"23":"Tu feras également deux planches pour les angles de la demeure à l'arrière."
,"24":"Elles seront placées côte à côte, de bas en haut, à la hauteur du premier anneau. On fera cela pour les deux angles."
,"25":"Il y aura donc huit planches avec leurs supports en argent, ce qui fera seize supports, deux pour chaque planche."
,"26":"Tu feras aussi des traverses en bois d'acacia, cinq pour les planches qui sont d'un côté de la demeure,"
,"27":"et cinq traverses pour les planches qui sont de l'autre côté de la demeure, cinq traverses encore pour les planches de l'arrière de la demeure, à l'ouest."
,"28":"La traverse médiane qui unit les planches ira de bout en bout."
,"29":"Tu recouvriras d'or les planches et les traverses et tu feras des anneaux d'or pour passer les traverses."
,"30":"Tu feras donc la demeure selon le plan qui t'a été montré sur la montagne."
,"31":"Pour le rideau il te faudra de la pourpre violette et de la pourpre rouge, des étoffes rouge sombre et du lin fin. Il sera brodé de chérubins."
,"32":"Tu le fixeras à quatre colonnes d'acacia recouvertes d'or, qui porteront des crochets en or et posées sur quatre bases d'argent."
,"33":"Tu attacheras le rideau aux agrafes d'or et, derrière le rideau, tu placeras l'Arche du Témoignage. Le rideau servira de séparation entre le Saint et le Saint des Saints."
,"34":"Tu placeras l'Instrument de l'Expiation sur l'Arche du Témoignage, dans le Saint des Saints."
,"35":"Tu mettras la table à l'extérieur du rideau, tu placeras le chandelier en face de la table, sur le côté sud de la demeure, la table étant du côté nord."
,"36":"Puis, tu feras une tenture à l'entrée de la demeure. Elle sera en pourpre violette et en pourpre rouge, en tissu teint en rouge foncé et en lin fin; elle sera brodée."
,"37":"Tu feras cinq colonnes d'acacia recouvertes d'or pour porter la tenture, les bases en seront de bronze et les crochets d'or."
}`)
	CurrentBook.AddChapter(27, `{
"1":"Tu feras l'autel en bois d'acacia, sa longueur sera de cinq coudées et sa largeur de cinq coudées. L'autel sera donc carré et sa hauteur sera de trois coudées."
,"2":"Aux quatre angles, l'autel portera des cornes qui ne feront qu'un avec lui; tu les recouvriras de bronze."
,"3":"Tu feras des chaudrons pour recueillir la cendre, des pelles et des cruchettes, des fourchettes et des cendriers; le tout sera fait de bronze."
,"4":"Tu feras également un gril ressemblant à un filet de bronze et, aux quatre coins de ce filet, tu placeras quatre anneaux de bronze."
,"5":"Tu le fixeras sous le rebord de l'autel et il tombera jusqu'au milieu de l'autel."
,"6":"Tu feras des barres en bois d'acacia recouvertes de bronze, pour porter l'autel."
,"7":"On passera les barres dans les anneaux, donc, de chaque côté, pour transporter l'autel."
,"8":"Tu feras l'autel en panneaux de bois évidé, comme on te l'a montré sur la montagne."
,"9":"Tu feras comme une cour autour de la demeure. Du côté du sud, cette cour sera fermée par des tentures de lin fin, d'une longueur de cent coudées."
,"10":"Elles seront portées par vingt colonnes dont les bases seront en bronze, mais les crochets des colonnes et les tringles seront d'argent."
,"11":"Tu feras de même sur le côté nord. Les tentures auront cent coudées de long. Leurs vingt colonnes et leurs bases seront en bronze, mais les crochets et les tringles seront en argent."
,"12":"Du côté de la mer, à l'ouest, la cour dans sa largeur sera fermée par des tentures de cinquante coudées portées par dix colonnes, sur leurs dix bases."
,"13":"Du côté de l'est, à l'orient, la largeur de la cour sera de cinquante coudées."
,"14":"D'un côté de l'entrée il y aura des tentures de quinze coudées, portées par trois colonnes sur trois bases."
,"15":"Pour l'autre côté de l'entrée, des tentures de quinze coudées, avec leur trois colonnes sur trois bases."
,"16":"Devant la porte de la cour il y aura une tenture damassée, de vingt coudées. Elle sera de pourpre violette et de pourpre rouge, de tissus teints en rouge foncé et de lin fin, et sera portée par quatre colonnes sur quatre bases."
,"17":"Les colonnes qui entourent la cour seront réunies par des tringles d'argent; leurs crochets seront en argent et les bases en bronze."
,"18":"La longueur de la cour sera de cent coudées, sa largeur de cinquante et la hauteur des tentures, de cinq coudées. Toutes les tentures seront de lin fin, les socles seront de bronze."
,"19":"Tous les objets qui serviront pour la demeure, tous ses piquets et les piquets de la cour, seront en bronze."
,"20":"Pour toi, tu donneras cet ordre aux Israélites: Qu'ils t'apportent de l'huile pure d'olives concassées pour les lampes, pour que la lampe brille perpétuellement."
,"21":"Aaron et ses fils placeront cette lampe dans la Tente du Rendez-vous, à l'extérieur de la tenture qui ferme le Saint des Saints, et elle brûlera du matin jusqu'au soir devant Yahvé. C'est un rite éternel pour les Israélites et leur descendance."
}`)
	CurrentBook.AddChapter(28, `{
"1":"Tu vas choisir parmi tous les Israélites ton frère Aaron et ses frères, tu vas les faire approcher pour qu'Aaron soit mon prêtre, avec ses fils Nadab et Abihou, Eléazar et Itamar."
,"2":"Tu feras des habits sacrés pour Aaron, ton frère, pour qu'il soit vêtu de gloire et de majesté."
,"3":"Tu t'adresseras à tous les hommes habiles, en qui j'ai mis un esprit d'intelligence. Ils feront les habits d'Aaron pour qu'il soit consacré comme prêtre à mon service."
,"4":"Voici les habits qu'ils feront: le pectoral et l'éphod, le manteau, la tunique, le turban et la ceinture. Ils feront des habits sacrés pour Aaron, ton frère, et pour ses fils, pour qu'ils soient mes prêtres."
,"5":"Ils se procureront de l'or, de la pourpre violette et de la pourpre rouge, du tissu teint en rouge foncé et du lin fin."
,"6":"L'éphod sera en or, avec de la pourpre violette et de la pourpre rouge, du tissu teint en rouge foncé et du lin fin. Il sera fait par un artiste."
,"7":"Il sera attaché par les deux épaulettes fixées à ses deux extrémités."
,"8":"La bande qui entoure l'éphod sera travaillée de la même façon et ne fera qu'un avec lui. Elle sera faite de fil d'or, de pourpre violette et de pourpre rouge, de tissu teint en rouge foncé et de lin fin."
,"9":"Tu prendras deux pierres d'onyx et tu graveras sur elles les noms des fils d'Israël."
,"10":"Six noms sur la première pierre, et six noms sur la seconde, selon l'ordre de naissance."
,"11":"Tu graveras les noms des fils d'Israël sur les deux pierres, comme font les tailleurs de pierres lorsqu'ils gravent des sceaux. Tu fixeras ces deux pierres avec des griffes d'or."
,"12":"Tu placeras ensuite les deux pierres sur les épaulettes de l'éphod en représentation des fils d'Israël. Aaron portera ces pierres sur ses deux épaules pour rappeler les fils d'Israël au souvenir de Yahvé."
,"13":"Tu feras aussi les griffes en or,"
,"14":"ainsi que deux chaînes travaillées comme des cordons tressés. Tu fixeras les chaînes et les tresses sur les griffes d'or."
,"15":"C'est un artiste qui réalisera, selon tes directives, le pectoral du jugement. Tu le feras de la même façon que l'Ephod, en or, en pourpre violette et en pourpre rouge, en tissu teint en rouge foncé et en lin fin."
,"16":"Il sera carré et doublé. Sa longueur comme sa largeur seront d'une demi-coudée."
,"17":"Il sera garni de pierres précieuses disposées en quatre rangées: la première avec un rubis, une topaze et une émeraude;"
,"18":"la deuxième, une malachite, un saphir et un diamant;"
,"19":"la troisième, une opale, une agate et une améthyste;"
,"20":"la quatrième, une chrysolithe, un onyx et un jaspe. Elles seront fixées par des griffes d'or."
,"21":"Les pierres porteront les noms des fils d'Israël. Chacune des douze sera gravée comme un sceau et portera le nom de l'une des douze tribus."
,"22":"Tu fixeras sur le pectoral des chaînettes en fil d'or tressé."
,"23":"Tu fixeras aussi sur le pectoral deux anneaux d'or qui seront placés à ses deux extrémités."
,"24":"Tu attacheras les deux chaînettes d'or aux anneaux fixés aux extrémités du pectoral."
,"25":"Le bout des deux chaînettes sera attaché aux griffes d'or et fixé aux épaulettes de l'éphod, sur la face visible."
,"26":"Tu feras encore deux anneaux d'or que tu fixeras aux extrémités du pectoral, sur le bord qui est de l'autre côté de l'éphod, à l'intérieur."
,"27":"Tu feras également deux anneaux d'or et tu les mettras sur les deux épaulettes de l'éphod en-dessous de sa face visible, près de l'attache de la bande qui couvre l'éphod."
,"28":"On attachera le pectoral par ses anneaux aux anneaux de l'éphod, avec du fil de pourpre violette: il couvrira la bande de l'éphod. Ainsi tenu, le pectoral ne bougera pas sur l'éphod."
,"29":"Aaron portera donc les noms des fils d'Israël sur le pectoral du jugement, ils seront comme un rappel sur sa poitrine lorsqu'il se présentera devant Yahvé, dans le Saint."
,"30":"Au pectoral, tu ajouteras les Ourim et les Toumim. Ils seront sur la poitrine d'Aaron quand il se présentera devant Yahvé et Aaron portera l'instrument du jugement des Israélites sur sa poitrine quand il se présentera devant Yahvé."
,"31":"Tu feras également le manteau de l'éphod en pourpre violette,"
,"32":"au milieu, il y aura un trou pour la tête. Le bord, tout autour du trou, sera brodé, ce sera comme le trou d'une cuirasse qu'on ne peut déchirer."
,"33":"Tu feras sur les côtés des grenades en pourpre violette, en pourpre rouge et en tissu teint en rouge foncé. Tu en feras sur tous ses côtés, et entre elles, tu mettras des sonnettes d'or."
,"34":"Sur tous les côtés du manteau, tout autour, il y aura des sonnettes d'or et des grenades."
,"35":"Aaron le portera pour le service dans la Demeure, on entendra tinter les sonnettes quand il entrera dans le Saint, en présence de Yahvé ou quand il en sortira, et ainsi il ne mourra pas."
,"36":"Tu feras aussi une fleur d'or fin, et tu graveras dessus, comme on grave un sceau: 'Consacré à Yahvé.'"
,"37":"Elle sera fixée avec un fil de pourpre violette sur le turban, sur le devant du turban."
,"38":"Ainsi, elle sera sur le front d'Aaron, et Aaron sera responsable de toutes les offrandes sacrées présentées par les Israélites. Elle sera sur son front pour toujours, afin de rendre les offrandes agréables à Yahvé."
,"39":"Tu feras la tunique de lin fin, le turban de lin fin, la ceinture en broderie."
,"40":"Les tuniques des fils d'Aaron et leurs ceintures, ainsi que les mitres, seront faites de la même façon. Ainsi ils seront vêtus de gloire et de majesté."
,"41":"Tu revêtiras Aaron, ton frère, ainsi que ses fils; tu leur donneras l'onction sainte, tu les institueras comme prêtres et tu les consacreras à mon service."
,"42":"Tu leur feras des caleçons de lin qui les couvriront des reins jusqu'aux cuisses, pour cacher leur nudité."
,"43":"Aaron et ses fils les porteront quand ils entreront dans la Tente du Rendez-Vous, ou quand ils monteront vers l'autel pour accomplir leur ministère dans le Saint. Ainsi ils ne commettront pas de faute et ne mourront pas. C'est un rite éternel pour lui et pour sa descendance après lui."
}`)
	CurrentBook.AddChapter(29, `{
"1":"Voici comment tu consacreras les prêtres à mon service: tu prendras un jeune taureau et deux béliers sans défaut,"
,"2":"des pains sans levain, des gâteaux sans levain trempés dans l'huile et des galettes sans levain trempées dans l'huile. Le tout sera de fleur de farine de blé."
,"3":"Tu les mettras dans une corbeille et tu les offriras dans la corbeille avec le jeune taureau et les deux béliers."
,"4":"Alors tu feras approcher Aaron et ses fils à l'entrée de la Tente du Rendez-Vous et tu les laveras dans l'eau."
,"5":"Puis tu prendras les habits et tu revêtiras Aaron de la tunique, du manteau, de l'éphod et du pectoral. Puis tu laceras sur lui la bande de l'éphod."
,"6":"Tu lui poseras sur la tête le turban, et tu placeras le diadème sacré sur le turban."
,"7":"Tu prendras l'huile pour l'onction et tu la verseras sur sa tête. C'est ainsi que tu l'oindras."
,"8":"Puis tu feras approcher ses fils et tu les habilleras de tuniques."
,"9":"Tu mettras une ceinture autour des reins d'Aaron et de ses fils, ensuite tu leur mettras les mitres. C'est ainsi que tu consacreras Aaron et ses fils comme prêtres à mon service selon un rite perpétuel."
,"10":"Alors tu feras approcher le jeune taureau devant la Tente du Rendez-Vous. Aaron et ses fils poseront leurs mains sur la tête du jeune taureau."
,"11":"Tu immoleras le jeune taureau devant Yahvé, à l'entrée de la Tente du Rendez-Vous."
,"12":"Tu prendras du sang du taureau, tu en mettras sur les cornes de l'autel avec ton doigt, et tu verseras le reste du sang au pied de l'autel."
,"13":"Tu prendras la graisse qui entoure les intestins, le foie, les deux rognons et la graisse qui les entoure, et tu brûleras le tout sur l'autel."
,"14":"Tu brûleras la chair du taureau, sa peau et ses excréments en dehors du camp, en sacrifice de réparation pour le péché."
,"15":"Ensuite tu prendras le premier bélier; Aaron et ses fils poseront leurs mains sur la tête du bélier."
,"16":"Tu immoleras le bélier et, avec son sang, tu aspergeras l'autel."
,"17":"Tu couperas le bélier en morceaux, tu laveras les intestins et les pattes, tu les poseras sur les morceaux et sur la tête du bélier,"
,"18":"et tu feras brûler le tout sur l'autel. C'est l'holocauste, c'est-à-dire le sacrifice par le feu, en l'honneur de Yahvé. Ce sera un sacrifice agréable à Yahvé."
,"19":"Tu prendras ensuite le second bélier; Aaron et ses fils poseront leurs mains sur la tête du bélier."
,"20":"Tu immoleras le bélier et, avec son sang, tu marqueras l'oreille droite d'Aaron et l'oreille droite de ses fils, le pouce de leur main droite et le pouce de leur pied droit. Puis tu aspergeras tout l'autel avec le reste du sang."
,"21":"Tu prendras du sang qui est sur l'autel et de l'huile qui sert pour l'onction, tu en aspergeras Aaron et ses habits, ses fils et leurs habits. Ils seront ainsi consacrés, lui et ses habits, ses fils et leurs habits."
,"22":"Tu prendras la graisse et la queue du bélier, la graisse qui entoure l'intestin, le foie, les deux rognons et la graisse qui les enveloppe, ainsi que le gigot droit, car c'est un bélier de consécration."
,"23":"Tu prendras une boule de pain, un gâteau de pain cuit dans l'huile et une galette de la corbeille des pains sans levain qui se trouve devant Yahvé."
,"24":"Tu mettras le tout dans les mains d'Aaron et dans les mains de ses fils, et tu les balanceras devant Yahvé."
,"25":"Puis tu reprendras le tout de leurs mains, et tu le brûleras sur l'autel, en holocauste, c'est-à-dire en sacrifice par le feu, en l'honneur de Yahvé. Ce sera un sacrifice agréable à Yahvé."
,"26":"Tu prendras alors la poitrine du bélier pour la consécration d'Aaron, et tu la balanceras devant Yahvé: elle t'appartiendra."
,"27":"Tu consacreras la poitrine que tu auras balancée, le gigot que tu auras prélevé, tout ce qui a été balancé, tout ce qui a été prélevé sur le bélier de consécration pour Aaron et sur le bélier de consécration pour ses fils."
,"28":"Ce sera un droit perpétuel pour Aaron et pour ses fils, leur dû: les Israélites le prélèveront sur les sacrifices de communion qu'ils offrent à Yahvé."
,"29":"Les vêtements sacrés d'Aaron passeront à ses fils après lui, pour qu'ils les portent au jour de leur onction et de leur consécration."
,"30":"Pendant sept jours, celui de ses fils qui lui succédera pour entrer comme lui dans la Tente du Rendez-Vous et accomplir son ministère dans le Saint, portera ces vêtements sacrés."
,"31":"Tu prendras le bélier de consécration et tu feras cuire sa viande dans un lieu sacré."
,"32":"Aaron et ses fils mangeront la viande du bélier et le pain qui est dans la corbeille à l'entrée de la Tente du Rendez-Vous."
,"33":"Ils mangeront ainsi ce qui a été offert pour le péché au moment de leur consécration. Aucun profane n'en mangera, car ce sont des viandes sacrées."
,"34":"S'il reste de la viande du sacrifice de consécration, ou du pain, jusqu'au matin, on les brûlera au feu; mais on ne les mangera pas, car ce sont des choses saintes."
,"35":"Tu feras pour Aaron et pour ses fils tout ce que je t'ai ordonné. Leur consécration durera sept jours."
,"36":"Pour la purification et la consécration de l'autel, tu préparareras chaque jour un jeune taureau pour l'expiation, en sacrifice pour le péché. Ensuite tu oindras l'autel pour le consacrer."
,"37":"Cette expiation et consécration de l'autel durera sept jours. Désormais l'autel sera très saint et tout ce qui touchera à l'autel sera consacré."
,"38":"Chaque jour, et pour toujours, tu prépareras sur l'autel deux agneaux nés durant l'année."
,"39":"Tu prépareras le premier agneau le matin, et le second à la tombée du jour."
,"40":"Tu offriras une mesure de fleur de farine trempée dans de l'huile d'olive concassée et, pour l'offrande liquide, une mesure de vin pour le premier agneau."
,"41":"A la tombée du jour tu prépareras le second agneau et tu feras pour lui comme pour l'offrande du matin, avec offrande liquide. Ce sera un sacrifice par le feu, agréable à Yahvé."
,"42":"C'est là l'holocauste perpétuel que vous présenterez à Yahvé à l'entrée de la Tente du Rendez-Vous, tout au long de vos générations, à l'endroit même où je te fixerai rendez-vous pour te parler."
,"43":"Je viendrai en ce lieu pour rencontrer les fils d'Israël, et ce lieu sera sanctifié par ma Gloire."
,"44":"Je consacrerai la Tente du Rendez-Vous et l'autel, je consacrerai aussi Aaron et ses fils pour qu'ils soient mes prêtres et me servent."
,"45":"Ainsi j'habiterai au milieu des Israélites et je serai leur Dieu."
,"46":"Ils sauront que je suis Yahvé, leur Dieu, qui les ai fait monter du pays d'Egypte pour habiter au milieu d'eux, moi, Yahvé leur Dieu!"
}`)
	CurrentBook.AddChapter(30, `{
"1":"Tu feras un autel pour faire fumer l'encens, tu le feras en bois d'acacia."
,"2":"Sa longueur sera d'une coudée, sa largeur d'une coudée, il sera carré et sa hauteur sera de deux coudées. Ses cornes ne feront qu'un avec lui."
,"3":"Tu couvriras le dessus de l'autel, ses parois et ses cornes avec de l'or, et tu feras tout autour une bordure en or."
,"4":"En-dessous de la bordure, de chaque côté, tu feras deux anneaux d'or. Tu les fixeras sur les côtés, et on y passera les barres avec lesquelles on portera l'autel."
,"5":"Tu feras les barres en bois d'acacia, recouvertes d'or."
,"6":"Tu placeras l'autel devant le rideau qui est en avant de l'Arche du Témoignage, en avant de l'Instrument de l'Expiation qui est sur le Témoignage, là où je te donne rendez-vous."
,"7":"Là, chaque matin, Aaron fera fumer l'encens parfumé; il arrangera les lampes et fera brûler l'encens."
,"8":"Quand Aaron allumera les lampes à la tombée du jour, il fera encore fumer cet encens perpétuel devant Yahvé. Cela sera pour les générations et les générations."
,"9":"Vous ne ferez pas brûler sur cet autel un encens profane. Vous n'y ferez non plus, ni sacrifice par le feu, ni sacrifice ordinaire, ni offrande de liquide."
,"10":"Aaron fera l'expiation sur les cornes de l'autel une fois l'an. Il le fera avec le sang de la victime offerte pour l'expiation, et cela, de génération en génération. Ce sera un lieu très saint en l'honneur de Yahvé.'"
,"11":"Yahvé parla à Moïse et lui dit:"
,"12":"'Lorsque tu recenseras les Israélites, ils feront au moment du recensement une offrande à Yahvé afin d'écarter de chez eux tout fléau. Chacun paiera pour sa propre personne."
,"13":"Celui qui est soumis au recensement versera un demi-sicle selon le tarif du sicle du sanctuaire, c'est-à-dire, vingt guéras par sicle. Ce demi-sicle sera une contribution pour Yahvé."
,"14":"Celui qui est soumis au recensement parce qu'il a vingt ans ou plus, donnera la contribution pour Yahvé."
,"15":"Le riche ne donnera pas plus et le pauvre ne donnera pas moins qu'un demi-sicle, c'est leur contribution pour Yahvé, pour le rachat de leur propre vie."
,"16":"Tu percevras l'argent de l'expiation auprès des Israélites, et tu le verseras pour le service de la Tente du Rendez-Vous. Ce sera pour les Israélites le moyen de se rappeler au souvenir de Yahvé et d'obtenir son salut.'"
,"17":"Yahvé s'adressa à Moïse et lui dit:"
,"18":"'Tu feras une cuve en bronze avec son support en bronze, pour l'ablution. Tu la placeras entre la Tente du Rendez-Vous et l'autel, et tu verseras de l'eau dedans."
,"19":"Aaron et ses fils s'y laveront les mains et les pieds."
,"20":"Au moment d'entrer dans la Tente du Rendez-Vous, ils se laveront avec l'eau pour ne pas mourir. De même, quand ils s'avanceront vers l'autel pour accomplir leur ministère, pour faire fumer un sacrifice par le feu en l'honneur de Yahvé,"
,"21":"ils se laveront les mains et les pieds pour ne pas mourir. Ce sera pour eux un rite perpétuel, pour Aaron et pour sa descendance, de génération en génération.'"
,"22":"Yahvé s'adressa à Moïse et lui dit:"
,"23":"'Prends toi donc des parfums de première qualité: cinq cents sicles de myrrhe liquide, la moitié de cinnamome parfumé, soit deux cent cinquante sicles, et deux cent cinquante sicles de roseaux parfumés,"
,"24":"cinq cents sicles de casse, selon le sicle du sanctuaire, trois bons litres d'huile d'olive."
,"25":"Tu en feras une huile pour l'onction sacrée, un mélange parfumé comme en fait le parfumeur. Ce sera une huile pour l'onction sacrée,"
,"26":"tu en marqueras la Tente du Rendez-Vous et l'Arche du Témoignage,"
,"27":"la table et tous ses accessoires, le chandelier et ses accessoires, l'autel des parfums,"
,"28":"l'autel des holocaustes et tous ses accessoires, la cuve et son support."
,"29":"Tu les consacreras; ils seront alors très saints, et tout ce qui les touchera sera saint."
,"30":"Tu marqueras également Aaron et ses fils lorsque tu les consacreras comme prêtres à mon service."
,"31":"Puis tu diras aux Israélites: ainsi sera, de génération en génération l'huile pour l'onction sacrée."
,"32":"Vous n'en marquerez pas la chair d'un homme, et vous n'en ferez pas de semblable à celle-là, car c'est une chose sainte, elle sera sainte à vos yeux."
,"33":"Celui qui ferait un parfum semblable et en mettrait sur quelqu'un qui n'est pas consacré, serait retranché de son peuple.'"
,"34":"Yahvé dit à Moïse: 'Prends en quantité égale de la résine odoriférante, de l'ongulum, du galbanum odoriférant et de l'encens pur."
,"35":"Tu en feras un parfum à brûler, comme en font les parfumeurs, salé, sans mélange et saint."
,"36":"Tu le réduiras en poudre et tu en mettras devant le Témoignage et dans la Tente du Rendez-vous où je viens te trouver. Ce sera pour vous une chose très sainte."
,"37":"Vous ne ferez pas pour vous de l'encens semblable à celui-ci, car c'est un encens réservé à Yahvé."
,"38":"Celui qui en ferait un semblable pour le respirer, serait retranché de son peuple.'"
}`)
	CurrentBook.AddChapter(31, `{
"1":"Yahvé s'adressa à Moïse et lui dit:"
,"2":"'Je viens d'appeler par son nom Bésaléel, fils d'Ouri, fils de Hour de la tribu de Juda."
,"3":"Je l'ai rempli de l'esprit de Dieu; je lui ai donné sagesse, intelligence et savoir-faire en toute spécialité"
,"4":"pour faire des oeuvres d'art, pour travailler l'or, l'argent et le bronze,"
,"5":"pour tailler les pierres à sertir et tailler le bois, en un mot, pour tout métier."
,"6":"J'ai choisi pour l'aider Oholiab, fils d'Akhisamac, de la tribu de Dan, et j'ai donné le savoir- faire à tous ceux qui en sont capables, de façon qu'ils puissent exécuter tout ce que je t'ai ordonné:"
,"7":"la Tente du Rendez-Vous, l'Arche du Témoignage, l'Instrument de l'Expiation qui la recouvre et tous les objets qui sont dans la Tente;"
,"8":"la table et ses accessoires, le chandelier pur et ses accessoires ainsi que l'autel de l'encens;"
,"9":"l'autel pour l'holocauste et tous ses accessoires, la cuve et son support;"
,"10":"les habits de cérémonie et les habits sacrés du prêtre Aaron, ainsi que les habits de ses fils pour accomplir leur ministère;"
,"11":"l'huile pour l'onction et l'encens parfumé pour le Saint. Ils feront tout cela de la façon que je t'ai commandé.'"
,"12":"Yahvé s'adressa à Moïse et lui dit:"
,"13":"'Voici ce que tu diras aux fils d'Israël: Ne manquez pas de garder mes Sabbats. Ils sont un signe entre moi et vous, de génération en génération, pour que vous sachiez que c'est moi, Yahvé, qui vous sanctifie."
,"14":"Vous observerez donc le Sabbat, ce sera un jour saint pour vous. Celui qui le profanera sera mis à mort; celui qui travaillera ce jour-là sera retranché du milieu de son peuple."
,"15":"Pendant six jours on travaillera, mais le septième jour sera un jour de repos complet, consacré à Yahvé. Celui qui travaillera le jour du Sabbat devra mourir."
,"16":"Les Israélites observeront donc le Sabbat, ils pratiqueront le Sabbat de génération en génération: c'est là une alliance perpétuelle."
,"17":"Ce sera un signe à jamais entre moi et les Israélites, car en six jours Yahvé a fait le ciel et la terre, mais le septième jour il s'est arrêté pour souffler.'"
,"18":"Après cela, lorsque Dieu eut fini de parler à Moïse sur le mont Sinaï, il lui donna les deux tables du Témoignage, tables de pierre écrites de la main de Dieu."
}`)
	CurrentBook.AddChapter(32, `{
"1":"Le peuple vit que Moïse tardait à descendre de la montagne. Alors le peuple se rassembla autour d'Aaron et lui dit: 'Tu vas nous faire un dieu qui marche devant nous, car ce Moïse, l'homme qui nous a fait sortir du pays d'Egypte, nous ne savons pas ce qu'il est devenu!'"
,"2":"Aaron leur dit: 'Enlevez les boucles d'or que vos femmes, vos fils et vos filles portent à leurs oreilles, et apportez-les moi.'"
,"3":"Ils enlevèrent tous les boucles d'or qu'ils avaient à leurs oreilles et ils les apportèrent à Aaron."
,"4":"Lui reçut tout cela de leurs mains, on le façonna avec un burin et on en fit un veau de métal fondu. Ils s'écrièrent alors: 'Israël! Voici ton Dieu qui t'a fait sortir du pays d'Egypte!' "
,"5":"Voyant ce veau, Aaron construisit un autel devant lui; puis il cria d'une voix forte: 'Demain sera une fête pour Yahvé!'"
,"6":"Le lendemain matin ils se levèrent, offrirent des sacrifices par le feu et présentèrent des offrandes. Le peuple s'assit pour manger et pour boire, puis on se leva pour se divertir."
,"7":"Yahvé dit alors à Moïse: 'Va, redescends! Car ton peuple s'est corrompu, ce peuple que tu as fait sortir du pays d'Egypte!"
,"8":"Ils n'ont pas été longs à se détourner de la voie que je leur avais enseignée: ils se sont fait un veau de métal fondu, ils se sont prosternés devant lui et lui ont présenté des sacrifices. Ils ont même dit: Israël, voici tes dieux qui t'ont fait sortir du pays d'Egypte!'"
,"9":"Yahvé dit encore à Moïse: 'J'ai bien compris que ce peuple a la nuque raide."
,"10":"Laisse-moi donc déchaîner contre eux ma colère: je vais les faire disparaître, mais je ferai sortir de toi une grande nation.'"
,"11":"Moïse voulut calmer Yahvé son Dieu, il lui dit: 'Yahvé! Pourquoi te fâcher contre ton peuple que tu as fait sortir d'Egypte en déployant toute ta puissance?"
,"12":"Veux-tu que les Egyptiens disent: Il avait une arrière-pensée quand il les a fait sortir; il voulait les tuer dans les montagnes et les faire disparaître de la surface de la terre? Remets-toi de ta colère et renonce au mal que tu veux faire à ton peuple."
,"13":"Souviens-toi d'Abraham, d'Isaac et de Jacob, tes serviteurs. Tu leur as juré par toi-même: Je rendrai votre descendance aussi nombreuse que les étoiles du ciel, et tout le pays dont j'ai parlé, je le donnerai à tes descendants afin qu'ils le possèdent pour toujours.'"
,"14":"Ainsi donc Yahvé renonça au mal qu'il voulait faire à son peuple."
,"15":"Moïse redescendit de la montagne, tenant dans sa main les deux tables du Témoignage: elles étaient écrites des deux côtés, sur les deux faces."
,"16":"Les tables étaient l'oeuvre de Dieu et l'écriture gravée sur les tables était l'écriture de Dieu."
,"17":"Josué entendit le vacarme du peuple en fête et dit à Moïse: 'Mais c'est un bruit de guerre dans le camp!'"
,"18":"Moïse répondit: 'Ce n'est ni un chant de victoire, ni un chant de défaite, ce que j'entends, ce sont des choeurs alternés.'"
,"19":"Quand Moïse approcha du camp, il vit le veau et les danses. Alors, au comble de la colère, il jeta les tables et les brisa au pied de la montagne."
,"20":"Moïse s'empara du veau qu'ils avaient fabriqué, il le brûla au feu, il le broya et le réduisit en poudre; puis il jeta la poudre dans de l'eau qu'il fit boire aux Israélites."
,"21":"Moïse dit à Aaron: 'Que t'a fait ce peuple pour que tu lui fasses commettre un si grand péché?'"
,"22":"Aaron lui répondit: 'Ne te mets pas en colère contre moi, mon seigneur! Tu sais toi-même combien ce peuple est porté au mal."
,"23":"Ils m'ont dit: Fais-nous un Dieu qui marche devant nous, car ce Moïse, l'homme qui nous a fait monter du pays d'Egypte, nous ne savons pas ce qu'il est devenu."
,"24":"Alors je leur ai dit: Qui a de l'or parmi vous? Ils l'ont aussitôt enlevé de leurs oreilles et me l'ont donné; je l'ai jeté dans le feu et il en est sorti ce veau.'"
,"25":"Moïse se rendit compte que le peuple était déchaîné par la faute d'Aaron, et ses ennemis auraient bien eu de quoi le mépriser."
,"26":"Alors Moïse, debout à la porte du camp, s'écria: 'Que ceux qui sont pour Yahvé viennent à moi!' Et tous les fils de Lévi se rassemblèrent autour de lui."
,"27":"Il leur dit: 'Voici ce que dit Yahvé, le Dieu d'Israël: Prenez chacun votre épée, et passez et repassez dans le camp, d'une porte à l'autre! Exterminez frères, compagnons ou amis!'"
,"28":"Les fils de Lévi firent ce que Moïse leur avait dit, et ce jour-là il y eut environ trois mille victimes dans le peuple."
,"29":"Alors Moïse leur dit: 'Aujourd'hui vous vous êtes consacrés à Yahvé par le sang, peut-être le sang d'un fils ou d'un frère, c'est pourquoi il vous donne aujourd'hui la bénédiction.'"
,"30":"Le lendemain Moïse dit au peuple: 'Vous avez commis un grand péché, mais je vais monter vers Yahvé, peut-être obtiendrai-je le pardon de votre péché.'"
,"31":"Moïse revint donc vers Yahvé et lui dit: 'Ce peuple a commis un grand péché, ils se sont fait un dieu en or;"
,"32":"veux-tu pourtant leur pardonner?... Sinon, efface-moi du livre que tu as écrit.'"
,"33":"Yahvé dit à Moïse: 'Celui qui a péché contre moi, c'est lui que j'effacerai de mon livre."
,"34":"Pour l'instant, va et conduis ce peuple où je t'ai dit! Mon ange marchera devant toi mais, au jour du châtiment, je les punirai pour leur péché.'"
,"35":"Yahvé frappa donc le peuple pour le veau qu'ils avaient fait, pour le veau qu'avait fabriqué Aaron."
}`)
	CurrentBook.AddChapter(33, `{
"1":"Yahvé dit à Moïse: 'Tu vas monter maintenant, avec le peuple que j'ai fait sortir du pays d'Egypte, vers le pays pour lequel j'ai fait ce serment à Abraham, Isaac et Jacob: Je le donnerai à ta descendance."
,"2":"J'enverrai devant toi un ange pour chasser le Cananéen, l'Amorite, le Hittite, le Périsite, le Hivvite et le Jébusite,"
,"3":"mais je ne monterai pas au milieu de vous vers ce pays où ruissellent le lait et le miel, car vous êtes un peuple à la nuque raide et je risquerais de vous exterminer en chemin.'"
,"4":"Le peuple entendit cette parole sévère; ils prirent le deuil, et personne n'osa plus mettre ses habits de fête."
,"5":"Yahvé dit encore à Moïse: 'Dis ceci aux Israélites: Vous êtes un peuple à la nuque raide. Si je venais avec vous, seulement pour un moment, je vous exterminerais. Maintenant donc, enlevez vos habits de fête et je verrai comment vous traiter.'"
,"6":"Les Israélites enlevèrent donc leurs vêtements de fête au départ du mont Horeb."
,"7":"Moïse prit la Tente et la planta pour lui à l'extérieur, loin du camp, et il l'appela la Tente du Rendez-Vous. Celui qui voulait consulter Yahvé se dirigeait vers la Tente du Rendez-Vous, à l'extérieur du camp."
,"8":"Lorsque Moïse se dirigeait vers la Tente, tout le peuple se levait et restait debout, chacun à l'entrée de sa propre tente. Et ils suivaient Moïse du regard jusqu'à ce qu'il entre dans la Tente."
,"9":"Dès que Moïse entrait dans la Tente, la colonne de nuée descendait et s'arrêtait à l'entrée de la Tente. Alors Yahvé parlait avec Moïse."
,"10":"Tout le peuple voyait la colonne de nuée s'arrêter à l'entrée de la Tente; tout le peuple aussitôt se prosternait, chacun à l'entrée de sa propre tente."
,"11":"Alors Yahvé parlait à Moïse face à face, comme un homme parle avec son ami; puis Moïse retournait vers le camp, mais son serviteur, le jeune Josué, fils de Noun, ne quittait pas la Tente."
,"12":"Moïse dit à Yahvé: 'Tu me dis de conduire ce peuple, mais tu ne m'as pas fait connaître comment tu me feras accompagner. Pourtant tu m'as dit: Je te connais par ton nom et tu as trouvé grâce à mes yeux."
,"13":"Si donc j'ai trouvé grâce à tes yeux, fais-moi connaître tes chemins pour que je te connaisse et que je trouve grâce à tes yeux. N'oublie pas que cette nation est ton peuple!'"
,"14":"Yahvé répondit: 'J'irai moi-même et je te donnerai le repos.'"
,"15":"Moïse lui dit: 'Si ta Face ne vient pas avec nous, ne nous fais pas partir d'ici;"
,"16":"mais si tu marches avec nous, je saurai que tu nous traites de façon spéciale, moi et mon peuple, et que tu nous as mis à part de tout autre peuple sur la surface de la terre.'"
,"17":"Yahvé dit alors à Moïse: 'Je ferai pour toi, même ce que tu viens de dire, car tu as trouvé grâce à mes yeux et je te connais par ton nom.'"
,"18":"Moïse dit: 'Fais-moi donc voir ta Gloire!'"
,"19":"Et Lui répondit: 'Je vais faire passer devant toi toute ma bonté, et je prononcerai devant toi le Nom de Yahvé, car ma faveur va à qui je la donne, et j'ai pitié de qui j'ai pitié.'"
,"20":"Il ajouta pourtant: 'Tu ne pourras pas voir ma Face, car l'homme ne peut me voir sans mourir.'"
,"21":"Yahvé dit: 'Vois cette place près de moi; tu te tiendras ici sur le rocher et,"
,"22":"lorsque ma Gloire passera, je te mettrai dans la fente du rocher et ma main te couvrira jusqu'à ce que je sois passé."
,"23":"Puis je retirerai ma main et tu me verras de dos, car ma face, nul ne peut la voir."
}`)
	CurrentBook.AddChapter(34, `{
"1":"Yahvé dit à Moïse: 'Taille-toi deux tables en pierre comme les premières, et j'écrirai sur les tables les paroles qui étaient gravées sur celles que tu as brisées."
,"2":"Préparez-vous pour demain, et toi dès le matin tu graviras le mont Sinaï, où tu m'attendras au sommet de la montagne."
,"3":"Personne ne viendra avec toi, et qu'on ne voie personne sur toute la montagne. Ne laissez pas vos brebis et vos bêtes paître au pied de la montagne.'"
,"4":"Moïse tailla donc deux tables de pierre semblables aux premières. Il se leva de bon matin et gravit le mont Sinaï selon l'ordre de Yahvé; il avait en main les deux tables de pierre."
,"5":"Alors Yahvé descendit au milieu de la nuée et se tint près de lui. Moïse invoqua le nom de Yahvé, "
,"6":"et Yahvé passa devant lui en disant d'une voix forte: 'Yahvé! Yahvé! Dieu de tendresse et de miséricorde! Il est lent à la colère, très généreux dans ses faveurs et sa fidélité."
,"7":"Il maintient ses faveurs pour mille générations; il supporte fautes, révoltes et péchés, mais il ne laisse pas passer la faute: il réclame la dette des pères à leurs fils et aux fils de leurs fils, jusqu'à la troisième et la quatrième génération.'"
,"8":"Moïse aussitôt s'agenouilla et se prosterna."
,"9":"Puis il dit: 'Mon Seigneur! Si j'ai trouvé grâce à tes yeux, que Mon Seigneur accepte de marcher au milieu de nous. Nous sommes un peuple à la nuque raide, mais tu pardonneras notre faute, notre péché et tu feras de nous ton héritage.'"
,"10":"Yahvé dit: 'Je prends un engagement: je ferai devant tout ton peuple des merveilles comme on n'en a jamais vu sur terre et dans aucune nation. Tout le peuple au milieu duquel tu vis verra l'oeuvre de Yahvé, car ce sont des choses grandioses que j'accomplirai avec toi."
,"11":"Observe tout ce que je te commande aujourd'hui, et moi je chasserai devant toi l'Amorite, le Cananéen, le Hittite, le Périsite, le Hivvite et le Jébusite."
,"12":"Fais attention à ne pas conclure d'alliance avec les habitants du pays dans lequel tu entreras: ils seraient vite un piège pour toi."
,"13":"Vous renverserez leurs autels, vous briserez leurs pierres sacrées et vous mettrez en pièces leurs idoles."
,"14":"Tu ne te prosterneras pas devant un autre dieu, car Yahvé s'appelle: le Jaloux. Oui, il est un Dieu jaloux!"
,"15":"Tu ne feras pas d'alliance avec les habitants du pays, qui se prostituent avec leurs dieux et leur offrent des sacrifices. Il ne faut pas qu'ils t'invitent et que tu manges avec eux de leurs sacrifices;"
,"16":"tu ne prendras pas leurs filles pour tes fils, car leurs filles, qui se prostituent avec leurs dieux, entraîneraient tes fils à faire comme elles."
,"17":"Tu ne feras pas de dieu en métal fondu."
,"18":"Tu observeras la fête des pains sans levain. Durant sept jours, à la date fixée du mois d'Abib, tu mangeras du pain sans levain comme je te l'ai commandé; car c'est au mois d'Abib que tu es sorti d'Egypte."
,"19":"Tout premier-né est à moi, ainsi que le premier-né de la vache ou de la brebis."
,"20":"Tu rachèteras le premier-né de l'âne au prix d'un agneau et, si tu ne le rachètes pas, tu lui briseras la nuque. Tu rachèteras tout premier-né parmi tes fils. On ne se présentera pas devant moi les mains vides."
,"21":"Tu travailleras pendant six jours, mais le septième jour tu te reposeras, même à la période des labours ou de la moisson."
,"22":"Tu célébreras en mon honneur la fête des Semaines: tu offriras alors les premières gerbes de blé de ta moisson. Tu célébreras aussi la fête de la récolte à la fin de l'année."
,"23":"Trois fois par an, tous les mâles de ton peuple se présenteront devant le Seigneur Yahvé, le Dieu d'Israël."
,"24":"Car je vais chasser devant toi les nations et je repousserai tes frontières. Personne ne cherchera à te prendre ta terre tant que tu monteras trois fois l'an pour te présenter devant Yahvé ton Dieu."
,"25":"Tu n'offriras pas le sang des sacrifices avec du pain levé. Quant au sacrifice de la fête de la Pâque, tu n'en garderas rien jusqu'au lendemain matin."
,"26":"Tu présenteras à la Maison de Yahvé ton Dieu les premiers fruits de ton sol. Tu ne feras pas cuire un chevreau dans le lait de sa mère.'"
,"27":"Alors Yahvé dit à Moïse: 'Ecris toutes ces paroles, car c'est le contenu de l'Alliance que j'ai faite avec toi et avec Israël.'"
,"28":"Moïse resta là avec Yahvé quarante jours et quarante nuits, sans manger de pain et sans boire d'eau. Il écrivit sur les tables toutes les paroles de l'Alliance, les Dix Paroles."
,"29":"Moïse redescendit de la montagne du Sinaï avec, dans sa main, les deux tables du Témoignage. Mais quand il descendit de la montagne, Moïse ne savait pas que la peau de son visage était rayonnante de lumière: il avait parlé avec Dieu!"
,"30":"Lorsqu'Aaron et tous les Israélites virent Moïse et son visage rayonnant de lumière, ils n'osèrent pas l'approcher."
,"31":"Mais Moïse les appela. Alors Aaron et tous les chefs de la communauté s'approchèrent de lui et Moïse leur parla. "
,"32":"Puis tous les Israélites s'approchèrent à leur tour et Moïse leur transmit tous les ordres que Yahvé avait donnés sur le mont Sinaï."
,"33":"Lorsque Moïse eut fini de parler, il se voila le visage."
,"34":"Chaque fois que Moïse se présentait devant Yahvé pour parler avec lui, il ôtait son voile jusqu'au moment où il se retirait. Alors il venait dire aux Israélites ce qui lui avait été commandé."
,"35":"Les Israélites voyaient le visage de Moïse rayonnant de lumière. Mais Moïse remettait le voile sur son visage jusqu'au moment où il se présentait de nouveau pour parler avec Dieu."
}`)
	CurrentBook.AddChapter(35, `{
"1":"Moïse réunit toute la communauté des Israélites et leur dit: 'Voici ce que Yahvé a commandé de faire:"
,"2":"durant six jours vous travaillerez, mais le septième jour sera un jour saint. Ce sera un Sabbat de repos pour Yahvé. Quiconque travaillera ce jour-là sera mis à mort."
,"3":"Vous n'allumerez pas de feu le jour du Sabbat, dans aucune de vos demeures.'"
,"4":"Moïse s'adressa à toute la communauté des Israélites: 'Voici les ordres de Yahvé:"
,"5":"Chacun apportera de chez lui une offrande pour Yahvé. Tous ceux qui sont généreux apporteront pour Yahvé de l'or, de l'argent, du cuivre,"
,"6":"de la pourpre violette, de la pourpre rouge, de la teinture rouge, du lin fin et du poil de chèvres,"
,"7":"des peaux de béliers teintes en rouge, des peaux de poissons, du bois d'acacia,"
,"8":"de l'huile pour la lumière, des parfums pour l'huile de consécration et pour l'encens parfumé,"
,"9":"des pierres précieuses et des pierres à sertir pour l'éphod et le pectoral."
,"10":"Tous ceux qui sont habiles parmi vous, se présenteront pour faire tout ce que Yahvé a commandé:"
,"11":"la Demeure avec sa Tente, sa couverture, ses agrafes, ses planches, ses traverses, ses colonnes et ses bases;"
,"12":"l'Arche et ses barres, l'Instrument de l'Expiation et le rideau;"
,"13":"la table avec ses barres, tous les ustensiles et le pain de proposition,"
,"14":"le candélabre pour l'éclairage et ses accessoires, ses lampes et l'huile pour la lumière;"
,"15":"l'autel de l'encens et ses barres, l'huile de consécration et l'encens parfumé, la tenture qui est à l'entrée de la Demeure;"
,"16":"l'autel des holocaustes et sa grille de bronze, ses barres et tous ses ustensiles, la cuve et son support;"
,"17":"les tentures de la cour avec leurs colonnes et leurs supports, la tenture de la porte de la cour;"
,"18":"les piquets de la Demeure et les piquets de la cour avec les cordes;"
,"19":"les habits de cérémonie pour officier dans le Saint, les habits de sainteté pour Aaron, le prêtre, et les habits de ses fils pour exercer leur ministère.'"
,"20":"Alors tout le peuple d'Israël se retira de devant Moïse."
,"21":"Tous ceux qui le voulaient bien revinrent vers lui. Chacun apportait selon sa générosité une offrande pour Yahvé, pour la construction de la Tente du Rendez-Vous, pour ce qui était nécessaire à son service ou pour les habits des prêtres."
,"22":"Ils arrivaient tous, hommes et femmes, animés du désir de donner généreusement; ils apportaient des boucles d'oreilles, des anneaux, des bagues, des boules, toutes sortes d'objets en or, en un mot tout l'or que chacun consacrait à Yahvé."
,"23":"Tous ceux qui possédaient de la pourpre violette ou de la pourpre rouge, de la teinture rouge, du lin fin ou du poil de chèvre, des peaux de béliers teintes en rouge ou des peaux de poissons, les apportaient."
,"24":"Ceux qui avaient mis de côté de l'argent ou du cuivre, l'apportaient en offrande pour Yahvé. Et ceux qui possédaient du bois d'acacia l'apportaient pour fabriquer ce qu'il y avait à faire."
,"25":"Toutes les femmes aux mains habiles apportaient du fil qu'elles avaient filé elles-mêmes. Elles apportaient aussi de la pourpre violette et de la pourpre rouge, de la teinture rouge et du lin fin."
,"26":"Et toutes les femmes qui étaient douées pour cela filèrent du poil de chèvres."
,"27":"Les chefs apportèrent des pierres précieuses et des pierres à sertir pour l'éphod et pour le pectoral,"
,"28":"du parfum et de l'huile pour la lumière, pour l'huile de consécration et pour l'encens parfumé."
,"29":"Tous ceux et toutes celles qui voulaient participer de bon coeur au travail que Yahvé avait ordonné de faire par la voix de Moïse, apportaient volontairement en bons Israélites une offrande pour Yahvé."
,"30":"Moïse dit alors aux Israélites: 'Regardez! Yahvé a appelé par son nom Besaléel, fils d'Ouri, fils de Hour, de la tribu de Juda."
,"31":"Il l'a rempli de son esprit, il lui a donné sagesse et intelligence, science et habileté"
,"32":"pour fabriquer des oeuvres d'art, pour travailler l'or, l'argent et le bronze,"
,"33":"pour tailler les pierres à sertir et pour travailler le bois, en un mot, pour exécuter toute sorte d'oeuvres d'art."
,"34":"Il lui a donné également comme à Oholiab, fils d'Akhisamac, de la tribu de Dan, le don d'enseigner."
,"35":"Il a fait d'eux des artisans habiles, des artistes, des brodeurs de pourpre violette et de pourpre rouge, d'étoffe de couleur, de lin fin; il a fait d'eux des tisserands, bref, des gens habiles pour faire toute sorte d'oeuvres d'art."
}`)
	CurrentBook.AddChapter(36, `{
"1":"Besaléel, Oholiab et tous ceux en qui Yahvé a mis un esprit de sagesse et d'intelligence pour réaliser des oeuvres d'art, tous ceux-là, feront tout ce qu'a ordonné Yahvé pour le service sacré."
,"2":"Moïse fit donc appel à Besaléel et à Oholiab, à tous les hommes intelligents à qui Yahvé avait donné quelque talent, à tous ceux qui de bon coeur voulaient s'appliquer à cette oeuvre pour bien l'exécuter."
,"3":"Ils retirèrent de devant Moïse les offrandes qu'avaient apportées les Israélites, pour exécuter les ouvrages destinés au service du sanctuaire. Chaque matin le peuple continuait à apporter à Moïse ses offrandes volontaires."
,"4":"Un jour, tous les artisans qui travaillaient pour le sanctuaire laissèrent leur ouvrage et vinrent trouver Moïse:"
,"5":"'Le peuple, dirent-ils, apporte beaucoup plus qu'il ne faut pour réaliser les travaux que Yahvé a ordonné de faire.'"
,"6":"Moïse donna donc un ordre et fit proclamer dans le camp: 'Hommes et femmes, écoutez! N'apportez plus d'offrandes pour le sanctuaire.' Et on interdit au peuple d'en apporter davantage,"
,"7":"car ce qui avait été réuni suffisait largement pour tous les travaux que l'on avait à faire."
,"8":"Parmi ceux qui travaillaient, les plus habiles firent la Demeure: dix tentures de lin fin tressé, de pourpre violette et de pourpre rouge, d'étoffe de couleur, avec des chérubins travaillés par des artistes."
,"9":"Chaque tenture avait une longueur de vingt-huit coudées et une largeur de quatre coudées. Toutes les tentures avaient la même dimension."
,"10":"Cinq de ces tentures furent réunies l'une à l'autre, et de même les cinq autres furent réunies l'une à l'autre."
,"11":"On fit des cordons de pourpre violette pour la lisière de la tenture qui terminait le premier assemblage, et on fit de même pour la lisière de la tenture qui terminait le second assemblage."
,"12":"On fit donc cinquante cordons pour la première tenture et cinquante pour la tenture qui terminait le second assemblage. Ces cordons se faisaient face à face."
,"13":"On fit également cinquante agrafes d'or avec lesquelles on réunit les tentures l'une à l'autre, de telle sorte que la Demeure faisait un tout."
,"14":"On fit des tentures de poils de chèvres pour former une tente au-dessus de la Demeure, et l'on fit ainsi onze tentures."
,"15":"La longueur d'une tenture était de trente coudées, et sa largeur de quatre coudées. Les onze tentures avaient la même dimension."
,"16":"On réunit d'un côté cinq tentures, et de l'autre six."
,"17":"On mit cinquante cordons sur la lisière de la tenture qui terminait le premier assemblage, et cinquante cordons sur la lisière de la tenture qui terminait le second assemblage."
,"18":"On fit cinquante agrafes de bronze pour assembler la tente, pour qu'elle forme un seul tout."
,"19":"On fit pour la tente une couverture en peaux de béliers teintes en rouge, et par-dessus, une couverture en peau de poisson."
,"20":"On fit également des planches pour la Demeure, des planches en bois d'acacia posées sur champ."
,"21":"La longueur d'une planche était de dix coudées et sa largeur d'une coudée et demie."
,"22":"Chaque planche avait deux tenons joints l'un à l'autre. On fit de même pour toutes les planches de la Demeure."
,"23":"On fit des planches pour la Demeure: vingt planches pour le sud, à droite."
,"24":"On mit sous les vingt planches quarante supports en argent, chaque planche ayant deux supports sous ses deux tenons."
,"25":"Pour le second côté de la Demeure, le côté du nord, on fit également vingt planches"
,"26":"avec leurs quarante supports en argent: deux supports pour chaque planche."
,"27":"On fit six planches pour le fond de la Demeure, du côté de l'ouest."
,"28":"On fit enfin deux planches pour les angles de la Demeure, dans le fond."
,"29":"Elles étaient doublées du haut en bas, formant un seul tout jusqu'au premier anneau. On fit la même chose pour les deux angles."
,"30":"Il y avait ainsi huit planches avec leurs supports en argent, ce qui faisait seize supports: deux sous chaque planche."
,"31":"On fit des traverses en bois d'acacia:"
,"32":"cinq pour les planches de l'un des côtés de la Demeure, cinq autres pour les planches de l'autre côté de la Demeure, et cinq traverses pour les planches qui formaient le fond de la Demeure, à l'ouest."
,"33":"La traverse du milieu s'étendait le long des planches, d'une extrémité à l'autre."
,"34":"On recouvrit d'or les planches et les traverses, et l'on fit en or les anneaux dans lesquels passaient les traverses."
,"35":"On fit la tenture en pourpre violette, en pourpre écarlate, en tissu teint en rouge et en lin fin. On broda dessus des chérubins habilement tissés."
,"36":"On fit pour la tenture quatre colonnes d'acacia recouvertes d'or, avec des crochets en or, et l'on fondit pour elles quatre supports en argent."
,"37":"Pour l'entrée de la Tente, on fit un rideau en pourpre violette, en pourpre écarlate, en étoffe de couleur et en lin fin avec des dessins variés."
,"38":"Pour ce rideau on fabriqua cinq colonnes avec leurs crochets, on recouvrit d'or les chapiteaux et les tringles; quant aux cinq supports, ils étaient en bronze."
}`)
	CurrentBook.AddChapter(37, `{
"1":"Besaléel fit l'Arche en bois d'acacia: sa longueur était de deux coudées et demie, sa largeur d'une coudée et demie et sa hauteur d'une coudée et demie."
,"2":"Il la recouvrit d'or pur, à l'extérieur et à l'intérieur, et il fit une guirlande d'or tout autour."
,"3":"Il fondit pour elle quatre anneaux d'or qu'il fixa aux quatre pieds, deux anneaux d'un côté, et deux anneaux de l'autre."
,"4":"Il fit des barres en bois d'acacia, qu'il recouvrit d'or."
,"5":"Il passa les barres dans des anneaux, sur les côtés de l'Arche, pour pouvoir la porter."
,"6":"Il fit l'Instrument de l'Expiation en or pur; sa longueur était de deux coudées et demie, sa largeur d'une coudée et demie."
,"7":"Il fit deux chérubins en or martelé qu'il fixa aux deux extrémités de l'Instrument de l'Expiation."
,"8":"Ainsi il y avait un chérubin à l'une des extrémités, et un chérubin à l'autre extrémité. Il plaça les chérubins aux extrémités de l'Instrument de l'Expiation."
,"9":"Les chérubins déployaient leurs ailes vers le haut: de leurs ailes ils couvraient l'Instrument de l'Expiation, et se faisaient face l'un à l'autre. La face des chérubins était tournée vers l'Instrument de l'Expiation."
,"10":"Il fit la table en bois d'acacia, sa longueur était de deux coudées, sa largeur d'une coudée, sa hauteur d'une coudée et demie."
,"11":"Il la recouvrit d'or pur et mit une guirlande d'or tout autour."
,"12":"Il fit également un encadrement de la largeur d'une main, avec une guirlande d'or tout autour."
,"13":"Pour la table il façonna quatre anneaux d'or et fixa les anneaux aux quatre coins, près des quatre pieds."
,"14":"Les anneaux étaient près de l'encadrement, ils recevaient les barres pour porter la table."
,"15":"Il fit des barres en bois d'acacia qu'il recouvrit d'or, elles servaient à transporter la table."
,"16":"Il fit tous les ustensiles que l'on devait poser sur la table: les plats, les écuelles, les tasses et les gobelets avec lesquels on présente les offrandes liquides. Tout cela, il le fit en or pur."
,"17":"Il fit le chandelier en or pur, en or battu, avec son pied et sa tige, les coupes, les boutons et les fleurs: tout était d'une seule pièce."
,"18":"Six branches sortaient du chandelier, trois d'un côté et trois de l'autre."
,"19":"Sur la première branche, il y avait trois coupes en fleur d'amandier, avec bouton et fleur; sur la seconde, trois coupes en fleur d'amandier, avec bouton et fleur; il en était de même pour les six autres branches sortant du chandelier."
,"20":"La tige du chandelier portait quatre coupes en fleur d'amandier, avec bouton et fleur."
,"21":"Il y avait un bouton sous les deux premières branches du chandelier, un bouton sous les deux suivantes et un autre sous les deux dernières. Il en était ainsi pour les six branches sortant du chandelier."
,"22":"Ces boutons et ces branches ne faisaient qu'un avec le chandelier, le tout était en or martelé, en or pur."
,"23":"Il fit sept lampes avec leurs mouchettes et leurs cendriers, en or pur."
,"24":"Pour faire le chandelier et tous ses accessoires, on utilisa près de trente- cinq kilos d'or pur."
,"25":"Il fit l'autel des parfums en bois d'acacia, sa longueur était d'une coudée, sa largeur d'une coudée; il était carré et sa hauteur était de deux coudées. Les cornes de l'autel faisaient corps avec lui."
,"26":"Il le recouvrit d'or pur, sur le dessus et sur les côtés; les cornes et la guirlande qui l'entouraient étaient en or."
,"27":"Il fit pour l'autel deux anneaux d'or au-dessous de la moulure sur les deux arêtes, il fit de même des deux côtés, pour recevoir les barres qui servaient à le transporter."
,"28":"Il fit les barres en bois d'acacia, recouvertes d'or."
,"29":"Il fit l'huile pour la consécration et le parfum pour l'encensement, comme le font les parfumeurs."
}`)
	CurrentBook.AddChapter(38, `{
"1":"Il fit l'autel des holocaustes en bois d'acacia. Sa longueur était de cinq coudées, sa largeur de cinq coudées; il était donc carré et sa hauteur était de trois coudées."
,"2":"Aux quatre coins il fit des cornes qui faisaient corps avec lui, et il les recouvrit de bronze."
,"3":"Il fit tous les ustensiles de l'autel: les chaudrons, les cendriers, les bassins, les fourchettes et les cassolettes. Tout était en bronze."
,"4":"Pour l'autel il fit une grille de bronze en forme de treillis, elle était placée sous la corniche de l'autel, descendant vers le bas, jusqu'à mi-hauteur."
,"5":"Il fondit quatre anneaux, placés aux quatre coins de la grille, pour recevoir les barres."
,"6":"Les barres étaient en bois d'acacia, recouvertes de bronze."
,"7":"Il fixa les barres dans les anneaux, de chaque côté de l'autel; elles servaient à le transporter. L'autel était fait de panneaux évidés."
,"8":"Avec les miroirs de bronze des femmes qui se tenaient devant l'entrée de la Tente du Rendez-Vous, il fit le bassin de bronze et son support."
,"9":"Il fit aussi la cour: les tentures de la cour du côté du midi étaient en lin fin, leur longueur était de cent coudées."
,"10":"Il y avait vingt colonnes portées par vingt supports de bronze, avec les crochets des colonnes et les tringles en argent."
,"11":"En direction du nord, des tentures de cent coudées, vingt colonnes portées par vingt supports de bronze, avec les crochets des colonnes et les tringles en argent."
,"12":"En direction de l'ouest, des tentures de cinquante coudées avec dix colonnes portées par dix supports, avec les crochets des colonnes et les tringles en argent."
,"13":"La cour, à l'est, mesurait cinquante coudées."
,"14":"Sur un côté de l'entrée, une tenture de quinze coudées, avec trois colonnes sur trois supports."
,"15":"De l'autre côté de la porte d'entrée, des tentures de quinze coudées avec trois colonnes sur trois supports."
,"16":"Toutes les tentures de la cour étaient de lin fin tressé."
,"17":"Les supports des colonnes étaient en bronze, les crochets des colonnes et les tringles en argent. Les chapiteaux étaient recouverts d'argent et garnis de tringles en argent. Il en était de même pour toutes les colonnes de la cour."
,"18":"Le rideau qui fermait la porte de la cour était un travail de broderie, en pourpre violette, en pourpre rouge, en tissu teint en rouge et lin fin tressé. Sa longueur était de cent coudées et sa hauteur de cinq coudées, à la dimension des tentures de la cour."
,"19":"Les quatre colonnes et les quatre supports étaient en bronze, les crochets et les tringles étaient en argent, et les chapiteaux, recouverts d'argent."
,"20":"Tous les piquets pour la Demeure et pour la cour étaient en bronze."
,"21":"Voici le compte de ce qui servit pour la Demeure, la Demeure du Témoignage. Ce compte fut établi sur l'ordre de Moïse par les Lévites, sous la direction d'Itamar, fils du prêtre Aaron."
,"22":"Quant à Besaléel, fils d'Ouri, fils de Hour, de la tribu de Juda, il fit tout ce qu'avait commandé Yahvé à Moïse."
,"23":"Oholiab, fils d'Akhisamac, de la tribu de Dan, était avec lui. C'était un artiste, un brodeur sur pourpre violette et sur pourpre rouge, sur étoffes de couleur et sur lin fin."
,"24":"Tout l'or utilisé pour le travail de la construction du sanctuaire avait été offert solennellement; il représentait un poids de vingt-neuf talents et sept cent trente sicles, selon le sicle du sanctuaire (soit plus d'une tonne d'or fin)."
,"25":"Le poids d'argent versé par ceux qui étaient soumis au recensement s'élevait à cent talents et mille sept cent soixante-quinze sicles, selon le sicle du sanctuaire."
,"26":"Chacun des six cent trois mille cinq cent cinquante hommes de plus de vingt ans, soumis au recensement, avait versé un béqa, soit la moitié d'un sicle, selon le sicle du sanctuaire."
,"27":"Les cent talents d'argent servirent à fondre les supports du sanctuaire, les supports des tentures: cent supports, à raison d'un talent par support."
,"28":"Avec les mille sept cent soixante- quinze sicles, on fit les crochets des colonnes et on revêtit les chapiteaux et les tringles."
,"29":"Le bronze des offrandes s'élevait à soixante-dix talents et deux mille quatre cents sicles."
,"30":"Ils servirent à faire les supports de l'entrée de la Tente du Rendez-Vous, l'autel de bronze avec sa grille de bronze, et tous les ustensiles de l'autel,"
,"31":"les supports pour le tour de la cour, et les supports pour la porte de la cour, tous les piquets de la Demeure, et tous les piquets autour de la cour."
}`)
	CurrentBook.AddChapter(39, `{
"1":"On fit les habits de cérémonie pour le service du sanctuaire en pourpre violette, en pourpre rouge, en tissu teint en rouge. On fit donc les habits sacrés pour Aaron, comme Yahvé l'avait ordonné à Moïse."
,"2":"L'éphod était en or, avec de la pourpre violette, de la pourpre rouge, du tissu de couleur et du lin fin tressé."
,"3":"Avec des lamelles d'or que l'on avait étirées, puis découpées, on fit des fils pour travailler et pour broder la pourpre violette, la pourpre rouge, le tissu de couleur et le lin fin."
,"4":"On fit des épaulettes attachées par les deux bouts."
,"5":"La bande qui entoure l'éphod par-dessus faisait corps avec lui, elle était en or, avec de la pourpre violette, de la pourpre rouge, du tissu de couleur, du lin fin tressé, comme Yahvé l'avait ordonné à Moïse."
,"6":"On travailla les pierres précieuses insérées dans des griffes en or; elles étaient gravées comme un sceau, portant les noms des fils d'Israël."
,"7":"On les fixa sur les épaulettes de l'éphod, de façon à rappeler au souvenir de Yahvé les fils d'Israël, comme Yahvé l'avait ordonné à Moïse."
,"8":"On fit le pectoral: un vrai travail d'artiste! De la même façon que l'éphod, en or avec de la pourpre violette, de la pourpre rouge, du tissu teint en rouge et du lin fin tressé."
,"9":"Il était carré, sa longueur et sa largeur étaient d'une demi-coudée; il était doublé."
,"10":"Il était serti de quatre rangées de pierres précieuses: un rubis, une topaze et une émeraude formaient la première rangée;"
,"11":"une malachite, un saphir et un diamant, la seconde rangée;"
,"12":"une opale, une agate et une améthyste, la troisième rangée;"
,"13":"une chrysolithe, un onyx et un jaspe, la quatrième rangée. Elles étaient fixées, bien serties, dans des griffes d'or."
,"14":"Les pierres portaient les noms des fils d'Israël. Toutes les douze portaient un nom, gravé comme sur un sceau, pour chacune des douze tribus."
,"15":"Pour le pectoral on fit des chaînettes d'or pur, tressées comme des cordons."
,"16":"On fit deux griffes d'or et deux anneaux d'or, et on fixa les deux anneaux aux deux extrémités du pectoral."
,"17":"Dans les deux anneaux fixés aux extrémités du pectoral on passa les deux cordonnets d'or,"
,"18":"et on attacha les extrémités des cordonnets aux deux griffes d'or. On les plaça sur les épaulettes, par devant."
,"19":"On fit encore deux anneaux d'or que l'on plaça aux deux extrémités du pectoral, sur le rebord intérieur du côté de l'éphod."
,"20":"On fit enfin deux anneaux d'or qu'on plaça sur les deux épaulettes, en-dessous de l'éphod, sur le devant, près de l'attache, par-dessus la bande de l'éphod."
,"21":"On attacha le pectoral par ces anneaux aux anneaux de l'éphod, avec un cordon de pourpre violette, pour que le pectoral se trouve au-dessus de la bande de l'éphod. Le pectoral ne pouvait donc se détacher de l'éphod, comme Yahvé l'avait ordonné à Moïse."
,"22":"Le manteau de l'éphod avait été fait par un tisserand, tout en pourpre violette."
,"23":"Au milieu du manteau de l'éphod, il y avait une ouverture semblable à celle d'une armure, et cette ouverture était bordée tout autour, pour éviter de se déchirer."
,"24":"Sur le bord inférieur du manteau il y avait des grenades de pourpre violette, de pourpre rouge, de tissu de couleur et de lin fin."
,"25":"On fit des clochettes d'or pur, et on les attacha au milieu des grenades, sur le bord inférieur du manteau."
,"26":"Clochettes et grenades alternaient sur tout le bord de la robe destinée au service du sanctuaire, comme Yahvé l'avait ordonné à Moïse."
,"27":"On tissa des tuniques de lin pour Aaron et ses fils."
,"28":"La tiare était en lin, ainsi que les mitres. Elles leur servaient de parure."
,"29":"Les caleçons blancs étaient en lin fin; quant à la ceinture de lin, elle était damassée de pourpre violette, de pourpre rouge et de tissu de couleur, comme Yahvé l'avait ordonné à Moïse."
,"30":"Une lame d'or pur ornait le diadème sacré. On avait gravé dessus, comme on grave sur un sceau: 'Consacré à Yahvé.'"
,"31":"On l'attacha avec un cordon de pourpre violette, elle fut placée sur la tiare, en haut, comme Yahvé l'avait ordonné à Moïse."
,"32":"C'est ainsi que fut terminé tout le travail de la Demeure, de la Tente du Rendez-Vous; les Israélites firent tout comme Yahvé l'avait ordonné à Moïse."
,"33":"On présenta alors à Moïse la Demeure, la Tente et tous ses ustensiles, ses agrafes, ses planches, ses traverses, ses colonnes et ses supports:"
,"34":"la couverture de peaux de béliers teinte en rouge, la couverture de peaux de poisson et la tenture de séparation,"
,"35":"l'Arche du Témoignage avec ses barres et l'Instrument de l'Expiation,"
,"36":"la table avec tous ses ustensiles et les pains de proposition;"
,"37":"le chandelier d'or pur avec ses lampes, ses ustensiles et l'huile pour la lumière;"
,"38":"l'autel d'or, l'huile pour la consécration, le parfum pour l'encens, ainsi que le rideau pour l'entrée de la tente;"
,"39":"l'autel de bronze, sa grille de bronze, ses barres et tous ses ustensiles; le bassin avec son support; les rideaux de la cour, les colonnes, les supports, la tenture de la porte de la cour;"
,"40":"la corde et les piquets, ainsi que tous les accessoires pour le service de la Demeure, pour la Tente du Rendez-Vous;"
,"41":"les vêtements de cérémonie pour le service du sanctuaire, les vêtements sacrés pour le prêtre Aaron et les vêtements de ses fils pour l'exercice de leur ministère."
,"42":"Les Israélites avaient fait tout cela en se conformant exactement à tout ce que Yahvé avait ordonné à Moïse."
,"43":"Moïse examina tout ce travail, tout ce qu'ils avaient fait: ils l'avaient fait comme Yahvé l'avait ordonné, et Moïse les bénit."
}`)
	CurrentBook.AddChapter(40, `{
"1":"Yahvé s'adressa à Moïse:"
,"2":"'Le premier jour du premier mois, lui dit-il, tu dresseras la Demeure, la Tente du Rendez-Vous."
,"3":"Tu y mettras l'Arche du témoignage et tu la couvriras avec le voile."
,"4":"Tu apporteras la table et tu la garniras. Tu apporteras le chandelier et tu y fixeras les lampes."
,"5":"Tu placeras l'autel d'or pour le parfum, devant l'Arche du témoignage, et tu mettras le rideau à l'entrée de la Demeure."
,"6":"Tu placeras l'autel des holocaustes devant l'entrée de la Demeure, devant l'entrée de la Tente du Rendez-Vous."
,"7":"Tu placeras le bassin entre la Tente du Rendez-Vous et l'autel, et tu y mettras de l'eau."
,"8":"Tu clôtureras la cour tout autour, et tu fixeras la tenture de la porte de la cour."
,"9":"Tu prendras l'huile de consécration, tu oindras avec cette huile la Demeure et tout ce qu'elle contient. Tu la consacreras avec tous ses ustensiles, et elle sera sainte."
,"10":"Tu consacreras l'autel des holocaustes et tous ses accessoires. Tu consacreras l'autel, et l'autel sera très saint."
,"11":"Tu oindras le bassin avec son support et tu le consacreras."
,"12":"Tu feras avancer Aaron et ses fils vers l'entrée de la Tente du Rendez-Vous et tu les laveras avec de l'eau."
,"13":"Puis tu habilleras Aaron avec les vêtements sacrés, tu l'oindras et tu le consacreras, et il sera prêtre à mon service."
,"14":"Tu feras ensuite approcher ses fils, tu les habilleras de leur tunique,"
,"15":"tu les oindras comme tu auras oint leur père, et ils seront prêtres à mon service. Par cette onction ils recevront le sacerdoce perpétuel, pour les générations et les générations.'"
,"16":"Moïse fit tout comme Yahvé le lui avait ordonné, c'est ainsi qu'il fit."
,"17":"Le premier jour du premier mois de la deuxième année, la Demeure fut mise en place. Moïse dressa la Demeure:"
,"18":"il en posa les supports, il mit en place les planches et les traverses, il dressa les colonnes;"
,"19":"il étendit la Tente au-dessus de la Demeure et mit par-dessus la couverture de la Tente, comme Yahvé l'avait ordonné à Moïse."
,"20":"Il prit le Témoignage et le mit dans l'Arche, il fixa les barres à l'Arche, et posa l'Instrument de l'Expiation au-dessus de l'Arche."
,"21":"Il introduisit l'Arche dans la Demeure et il plaça la couverture de protection sur l'Arche du Témoignage, comme Yahvé l'avait ordonné à Moïse."
,"22":"Il plaça la table dans la Tente du Rendez-Vous, du côté nord de la demeure, en avant du rideau,"
,"23":"et il y posa les pains devant Yahvé, comme Yahvé l'avait ordonné à Moïse."
,"24":"Il plaça le chandelier dans la Tente du Rendez-Vous, en face de la table, du côté sud de la Demeure,"
,"25":"et il alluma les lampes devant Yahvé, comme Yahvé l'avait ordonné à Moïse."
,"26":"Il mit l'autel d'or dans la Tente du Rendez-Vous, devant le rideau,"
,"27":"et il fit brûler l'encens, comme Yahvé l'avait ordonné à Moïse."
,"28":"Il fixa le rideau à l'entrée de la Demeure,"
,"29":"il mit l'autel des sacrifices par le feu devant l'entrée de la Demeure, de la Tente du Rendez-Vous, et il offrit un holocauste et une offrande, comme Yahvé l'avait ordonné à Moïse."
,"30":"Il plaça le bassin entre la Tente du Rendez-Vous et l'autel, et il le remplit d'eau pour les ablutions."
,"31":"Moïse, Aaron et ses fils s'y lavèrent les mains et les pieds."
,"32":"Quand ils entraient dans la Tente du Rendez-Vous et qu'ils s'approchaient de l'autel, ils se lavaient, comme Yahvé l'avait ordonné à Moïse."
,"33":"Il installa la cour autour de la Demeure et de l'autel, et il attacha la tenture à la porte de la cour. Et c'est ainsi que Moïse termina tout ce travail."
,"34":"Alors la nuée couvrit la Tente du Rendez-Vous et la Gloire de Yahvé emplit la Demeure."
,"35":"Moïse ne pouvait plus entrer dans la Tente du Rendez-Vous, parce que la nuée la couvrait et que la Gloire de Yahvé remplissait la Demeure."
,"36":"Tout au long de leurs étapes, les Israélites se mettaient en route lorsque la nuée s'élevait au-dessus de la Demeure."
,"37":"Mais si la nuée ne bougeait pas, ils ne se mettaient pas en route jusqu'au jour où elle se levait,"
,"38":"car la nuée de Yahvé reposait sur la Demeure durant le jour, à la vue de toute la maison d'Israël, et pendant la nuit un feu brillait au milieu d'elle. Il en fut ainsi tout au long de leur route."
}`)

}
func FR_LBDCC_LoadVPGNChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Au commencement Dieu créa le ciel et la terre."
,"2":"La terre était informe et vide, les ténèbres couvraient l'abîme, et l'Esprit de Dieu planait au-dessus des eaux."
,"3":"Dieu dit: 'Que la lumière soit!' Et la lumière fut."
,"4":"Dieu vit que la lumière était bonne, et Dieu sépara la lumière d'avec les ténèbres."
,"5":"Dieu appela la lumière: 'jour', il appela les ténèbres: 'nuit'. Il y eut un soir, il y eut un matin: premier jour."
,"6":"Dieu dit: 'Qu'il y ait une voûte au milieu des eaux, et qu'elle sépare les eaux d'avec les eaux!' Et il en fut ainsi!"
,"7":"Dieu fit donc comme une voûte, et il sépara les eaux qui sont au-dessous de la voûte, des eaux qui sont au-dessus de la voûte."
,"8":"Dieu donna un nom à cette voûte: 'le ciel'. Il y eut un soir, il y eut un matin: deuxième jour."
,"9":"Dieu dit: 'Que les eaux qui sont au-dessous du ciel s'amassent en une seule masse et que le sol ferme apparaisse!' Il en fut ainsi."
,"10":"Dieu donna un nom au sol ferme: 'la terre', et il appela 'mers' la masse des eaux; Dieu vit que cela était bon."
,"11":"Dieu dit: 'Que la terre produise de la verdure, de l'herbe portant sa semence, et des arbres qui donnent sur terre des fruits contenant leur semence, chacun selon son espèce!' Il en fut ainsi."
,"12":"La terre produisit de la verdure, de l'herbe portant sa semence selon son espèce, et des arbres dont les fruits ont en eux leur semence selon leur espèce. Dieu vit que cela était bon."
,"13":"Il y eut un soir, il y eut un matin: troisième jour."
,"14":"Dieu dit: 'Qu'il y ait des luminaires à la voûte du ciel pour séparer le jour de la nuit, pour marquer les saisons, les jours et les années:"
,"15":"ils brilleront à la voûte du ciel pour éclairer la terre!' Il en fut ainsi."
,"16":"Dieu fit donc les deux grands luminaires: le grand luminaire pour gouverner le jour, et le petit luminaire pour gouverner la nuit. Il fit aussi les étoiles."
,"17":"Dieu les fixa à la voûte du ciel pour éclairer la terre,"
,"18":"pour gouverner le jour et la nuit, pour séparer la lumière des ténèbres. Dieu vit que cela était bon."
,"19":"Il y eut un soir, il y eut un matin: quatrième jour."
,"20":"Dieu dit: 'Que les eaux se peuplent d'une multitude d'êtres vivants, et qu'il y ait des oiseaux pour voler au-dessus de la terre en dessous de la voûte du ciel!'"
,"21":"Dieu créa donc les grands monstres de la mer et tous les êtres vivants qui se glissent et qui foisonnent dans les eaux selon leur espèce, et tous les oiseaux selon leur espèce. Dieu vit que cela était bon."
,"22":"Dieu les bénit et leur dit: 'Développez-vous, multipliez-vous, remplissez les eaux de la mer, et que les oiseaux se multiplient sur la terre!'"
,"23":"Il y eut un soir, il y eut un matin: cinquième jour."
,"24":"Dieu dit: 'Que la terre produise des bêtes de toute espèce: animaux des champs, reptiles, bêtes sauvages, chacun selon son espèce!' Il en fut ainsi."
,"25":"Dieu fit les bêtes sauvages selon leur espèce, les animaux des champs selon leur espèce, et tous les reptiles de la terre selon leur espèce. Dieu vit que cela était bon."
,"26":"Dieu dit: 'Faisons l'Homme à notre image et à notre ressemblance. Qu'il ait autorité sur les poissons de la mer, les oiseaux du ciel, les animaux des champs et toutes les bêtes sauvages et les reptiles qui rampent sur la terre!'"
,"27":"Dieu créa l'Homme à son image; à l'image de Dieu il le créa; Homme et Femme il les créa."
,"28":"Dieu les bénit et leur dit: 'Développez-vous, multipliez-vous, remplissez la terre et dominez-la. Ayez autorité sur les poissons de la mer, les oiseaux du ciel et tous les animaux qui vont et viennent sur la terre!'"
,"29":"Dieu dit: 'Je vous donne en ce jour toutes les plantes à graines qui poussent sur toute la terre, et tous les arbres qui portent des fruits avec leur semence: ce sera là votre nourriture."
,"30":"L'herbe verte sera la nourriture des bêtes sauvages, des oiseaux du ciel, et de tous les animaux qui vont et viennent sur la terre.' Il en fut ainsi."
,"31":"Dieu vit tout ce qu'il avait fait: cela était très bon. Il y eut un soir, il y eut un matin: sixième jour."
}`)
	CurrentBook.AddChapter(2, `{
"1":"C'est ainsi que le ciel et la terre et tout ce qu'ils contiennent furent achevés."
,"2":"Au septième jour Dieu avait achevé son travail, et il se reposa en ce septième jour après tout le travail qu'il avait fait."
,"3":"Dieu bénit le septième jour et il en fit un jour saint, parce que ce jour-là Dieu s'était arrêté de travailler, après toute cette création qu'il avait faite."
,"4":"Voilà l'origine du ciel et de la terre lorsqu'ils furent créés. Le jour où Yahvé Dieu fit la terre et le ciel, "
,"5":"il n'y avait sur la terre aucun arbuste des champs; aucune herbe des champs ne poussait encore, car Yahvé Dieu n'avait pas fait pleuvoir sur la terre et il n'y avait pas d'homme pour travailler le sol"
,"6":"et faire monter l'eau de la terre, afin d'irriguer toute la surface du sol."
,"7":"Alors Yahvé Dieu forma l'homme; il n'était que poussière du sol, mais Dieu souffla dans ses narines une haleine de vie, et l'homme fut un être animé, vivant."
,"8":"Yahvé Dieu planta un jardin en Eden, à l'Orient, et il y plaça l'homme qu'il avait formé."
,"9":"Yahvé Dieu fit pousser du sol toutes sortes d'arbres agréables à voir et bons à manger; l'arbre de vie était au milieu du jardin, avec l'arbre qui donne la connaissance du bien et du mal."
,"10":"D'Eden sortait un fleuve qui arrosait le jardin et se divisait ensuite pour former quatre bras."
,"11":"Le premier s'appelle le Pichon: il entoure tout le pays d'Havila où l'on trouve de l'or,"
,"12":"un or très pur; on y trouve encore des résines parfumées et des pierres précieuses."
,"13":"Le deuxième s'appelle le Guihon: il entoure tout le pays de Kouch."
,"14":"Le troisième s'appelle le Tigre: il coule à l'est de l'Assyrie. Le quatrième, c'est l'Euphrate."
,"15":"Yahvé Dieu plaça l'homme dans le jardin d'Eden pour le cultiver et le garder."
,"16":"Puis Yahvé Dieu donna à l'homme un ordre, il lui dit: 'Tu mangeras tant que tu voudras de tous les arbres du jardin,"
,"17":"mais tu ne mangeras pas de l'arbre de la connaissance du bien et du mal, car le jour où tu en mangeras, ce sera la mort à coup sûr!'"
,"18":"Yahvé Dieu dit: 'Il n'est pas bon que l'homme soit seul, je veux lui faire une aide semblable à lui.'"
,"19":"Alors Yahvé Dieu forma du sol toutes les bêtes sauvages et tous les oiseaux du ciel; il les conduisit vers l'homme pour voir quel nom il leur donnerait, pour que tout animal porte le nom que l'homme allait lui donner."
,"20":"L'homme donna des noms à tous les animaux des champs, aux oiseaux des cieux, à toutes les bêtes sauvages, mais pour l'homme il ne se trouva pas d'aide qui lui corresponde."
,"21":"Yahvé Dieu fit alors tomber sur l'homme un profond sommeil pour qu'il s'endorme, il prit une de ses côtes et referma la chair à sa place."
,"22":"Avec la côte qu'il avait prise à l'homme, Yahvé Dieu fit une femme, et il vint la présenter à l'homme."
,"23":"L'homme déclara: 'Voici enfin l'os de mes os et la chair de ma chair, elle sera appelée femme parce qu'elle a été tirée de l'homme.'"
,"24":"C'est pourquoi l'homme quitte son père et sa mère, il s'attache à sa femme et ils ne font qu'une seule chair."
,"25":"Or ils étaient nus tous les deux, l'homme et sa femme, et ils n'en avaient point honte."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Le serpent était le plus rusé de toutes les bêtes sauvages que Yahvé Dieu avait faites. Il dit à la femme: 'Vraiment! Dieu a dit: Vous ne mangerez d'aucun des arbres du jardin?'"
,"2":"La femme répondit au serpent: 'Nous pouvons manger du fruit des arbres du jardin."
,"3":"Mais pour le fruit de l'arbre qui est au milieu du jardin, Dieu a dit: Vous n'en mangerez pas, vous n'y toucherez pas, sinon vous allez mourir.'"
,"4":"Le serpent dit à la femme: 'Non, ce ne sera pas la mort à coup sûr!"
,"5":"Mais Dieu sait que le jour où vous en mangerez, vos yeux s'ouvriront et vous serez alors comme des dieux, vous connaîtrez le bien et le mal!'"
,"6":"La femme vit que le fruit de l'arbre était bon à manger, agréable à voir, et très utile pour acquérir la sagesse. Elle prit de son fruit, elle en mangea et en donna également à son mari qui était avec elle, et il en mangea."
,"7":"Alors leurs yeux s'ouvrirent et ils découvrirent qu'ils étaient nus; ils se firent des pagnes avec des feuilles de figuier qu'ils avaient entrelacées."
,"8":"Soudain ils entendirent les pas de Yahvé Dieu qui se promenait dans le jardin à la brise du soir. L'homme et sa femme se cachèrent de Yahvé Dieu parmi les arbres du jardin."
,"9":"Yahvé Dieu appela l'homme et lui dit: 'Où es-tu?'"
,"10":"Il répondit: 'J'ai entendu tes pas dans le jardin et j'ai eu peur, parce que je suis nu; c'est pourquoi je me suis caché.'"
,"11":"Il dit: 'Qui t'a appris que tu étais nu? Aurais-tu mangé du fruit de l'arbre dont je t'avais défendu de manger?'"
,"12":"L'homme dit: 'La femme que tu as mise avec moi m'a donné du fruit de l'arbre et j'ai mangé.'"
,"13":"Yahvé Dieu dit à la femme: 'Qu'as-tu fait là?' La femme répondit: 'Le serpent m'a trompée et j'ai mangé.'"
,"14":"Alors Yahvé Dieu dit au serpent: 'Puisque tu as fait cela, tu seras maudit parmi tous les animaux des champs et toutes les bêtes sauvages. Tu ramperas sur ton ventre et tu mangeras de la poussière tous les jours de ta vie."
,"15":"Je mettrai la discorde entre toi et la femme, entre ta race et sa race, elle te blessera à la tête, et toi tu la blesseras au talon.'"
,"16":"Il dit à la femme: 'Je multiplierai les souffrances de tes grossesses; dans la souffrance tu enfanteras tes fils; tu ne pourras te passer d'un mari, et lui dominera sur toi.'"
,"17":"Il dit à l'homme: 'Parce que tu as écouté la voix de ta femme et que tu as mangé du fruit de l'arbre dont je t'avais interdit de manger, le sol sera maudit à cause de toi. Il t'en coûtera pour tirer du sol ta nourriture tous les jours de ta vie."
,"18":"Il te donnera épines et chardons, et tu mangeras l'herbe des champs."
,"19":"Tu mangeras ton pain à la sueur de ton front jusqu'à ce que tu retournes à la terre, puisque c'est d'elle que tu as été tiré: tu es poussière et tu retourneras en poussière.'"
,"20":"L'homme donna alors à sa femme le nom d'Eve (c'est-à-dire la Vivante) parce qu'elle fut la mère de tous les vivants."
,"21":"Puis Yahvé Dieu habilla l'homme et la femme avec les tuniques de peau qu'il leur avait faites."
,"22":"Yahvé Dieu dit alors: 'Voici que l'homme est devenu comme l'un de nous dans la connaissance du bien et du mal. Il ne faudrait pas maintenant qu'il étende la main et prenne également de l'arbre de vie; car s'il en mangeait, il pourrait vivre toujours.'"
,"23":"Yahvé Dieu le renvoya donc du jardin d'Eden pour qu'il cultive le sol d'où il avait été tiré."
,"24":"Il chassa l'homme et plaça les chérubins à l'orient du jardin d'Eden, ainsi que l'épée flamboyante et tournoyante qui gardait le chemin de l'arbre de vie."
}`)
	CurrentBook.AddChapter(4, `{
"1":"L'homme s'unit à Eve, sa femme, elle conçut et enfanta Caïn. Elle dit à cette occasion: 'Je me suis acquis un homme, grâce à Yahvé.'"
,"2":"Ensuite elle enfanta Abel, le frère de Caïn. Abel était berger de petit bétail et son frère Caïn cultivait le sol."
,"3":"Il arriva quelque temps plus tard que Caïn apporta des fruits du sol pour les offrir à Yahvé."
,"4":"Abel de son côté présenta les premiers-nés de son petit bétail avec leur graisse. Yahvé regarda avec plaisir Abel et son offrande,"
,"5":"mais il ne fit pas attention à Caïn et à son offrande. Caïn fut très en colère et son visage se durcit."
,"6":"Alors Yahvé dit à Caïn: 'Pourquoi es-tu en colère, pourquoi ton visage est-il si dur?"
,"7":"Si tu fais ce qui est bien, tu pourras relever la tête, mais si tu n'agis pas bien, le péché est couché devant ta porte prêt à se jeter sur toi; c'est à toi de le dominer.'"
,"8":"Caïn dit à Abel son frère: 'Allons dans la campagne.' Et comme ils étaient dans la campagne, Caïn se jeta sur son frère Abel et le tua."
,"9":"Yahvé dit à Caïn: 'Où est ton frère Abel?' Celui-ci répon dit: 'Je n'en sais rien; suis-je le gardien de mon frère?'"
,"10":"Il dit: 'Qu'as-tu fait? Un cri monte du sol vers moi, c'est le sang de ton frère!"
,"11":"Sois maudit maintenant de par le sol qui a ouvert sa bouche pour recevoir le sang de ton frère."
,"12":"Lorsque tu cultiveras le sol, il ne te donnera plus ses produits. Tu iras errant comme un fuyard sur la terre.'"
,"13":"Caïn dit à Yahvé: 'Ma condamnation est trop dure, je ne peux la porter!"
,"14":"Regarde, tu me chasses aujourd'hui du sol cultivable et je devrai me cacher loin de toi. J'irai errant comme un fuyard sur la terre et quiconque me rencontrera pourra me tuer.'"
,"15":"Yahvé lui dit: 'Eh bien, si quelqu'un tue Caïn, Caïn sera vengé sept fois!' Alors Yahvé mit un signe sur Caïn pour qu'il ne soit pas frappé par le premier venu."
,"16":"Caïn s'éloigna de devant Dieu et il habita au pays de Nod, à l'orient d'Eden."
,"17":"Caïn s'unit à sa femme, elle conçut et enfanta Hénok. Puis il construisit une ville et lui donna le nom de son fils Hénok."
,"18":"Hénok eut un fils, Irad, et Irad engendra Méhouyaël. Méhouyaël engendra Métouchaël et Métouchaël engendra Lamek."
,"19":"Lamek prit deux femmes, la première s'appelait Ada et la seconde s'appelait Sila."
,"20":"Ada enfanta Yabal, il fut le père de ceux qui vivent sous la tente parmi les troupeaux."
,"21":"Le nom de son frère était Youbal, il fut le père de tous ceux qui jouent de la lyre et de la flûte."
,"22":"De son côté, Sila enfanta Toubal-Caïn, il fut le père de tous ceux qui travaillent le cuivre et le fer. La soeur de Toubal-Caïn était Naama."
,"23":"Lamek dit à ses femmes Ada et Sila: 'Ecoutez ma voix, femmes de Lamek, prêtez l'oreille à ma parole: J'ai tué un homme pour une blessure, un garçon pour une égratignure."
,"24":"Car si Caïn est vengé sept fois, Lamek le sera soixante-dix-sept fois.'"
,"25":"Adam s'unit à sa femme, elle enfanta un fils et lui donna le nom de Seth, car, dit-elle: 'Dieu m'a donné une autre descendance à la place d'Abel que Caïn a tué.'"
,"26":"Seth eut un fils et il lui donna le nom d'Enos. Celui-ci fut le premier à invoquer Yahvé par son nom."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Voici le livre de la descendance d'Adam. Le jour où Dieu créa l'homme, il le créa à la ressemblance de Dieu; "
,"2":"homme et femme il les créa; il les bénit et leur donna le nom d'Adam (c'est-à-dire Homme) le jour où ils furent créés."
,"3":"Adam avait cent trente ans quand il engendra un fils à sa ressemblance, à son image; il lui donna le nom de Seth."
,"4":"Après la naissance de Seth, Adam vécut encore huit cents ans, il engendra des fils et des filles."
,"5":"La vie d'Adam atteignit au total neuf cent trente ans, après quoi il mourut."
,"6":"Seth avait cent cinq ans quand il engendra Enos."
,"7":"Après la naissance d'Enos, Seth vécut encore huit cent sept ans, il engendra des fils et des filles."
,"8":"La vie de Seth atteignit neuf cent douze ans au total, après quoi il mourut."
,"9":"Enos avait quatre-vingt-dix ans quand il engendra Kénan."
,"10":"Après la naissance de Kénan, Enos vécut encore huit cent quinze ans, il engendra des fils et des filles."
,"11":"La vie d'Enos atteignit neuf cent cinq ans au total, après quoi il mourut."
,"12":"Kénan avait soixante-dix ans quand il engendra Mahalaléel."
,"13":"Après la naissance de Mahalaléel, Kénan vécut encore huit cent quarante ans, il engendra des fils et des filles."
,"14":"La vie de Kénan atteignit neuf cent dix ans en tout, après quoi il mourut."
,"15":"Mahalaléel avait soixante-cinq ans quand il engendra Yéred."
,"16":"Après la naissance de Yéred, Mahalaléel vécut encore huit cent trente ans, il engendra des fils et des filles."
,"17":"La vie de Mahalaléel atteignit huit cent quatre-vingt-quinze ans en tout, après quoi il mourut."
,"18":"Yéred avait cent soixante-deux ans quand il engendra Hénok."
,"19":"Après la naissance d'Hénok, Yéred vécut encore huit cents ans, il engendra des fils et des filles."
,"20":"La vie de Yéred atteignit neuf cent soixante-deux ans en tout, après quoi il mourut."
,"21":"Hénok avait soixante-cinq ans quand il engendra Mathusalem."
,"22":"Hénok marcha avec Dieu. Après la naissance de Mathusalem, Hénok vécut encore trois cents ans, il engendra des fils et des filles."
,"23":"La vie d'Hénok fut de trois cent soixante-cinq ans."
,"24":"Hénok marcha avec Dieu, puis il disparut, car Dieu l'avait emporté."
,"25":"Mathusalem avait cent quatre-vingt-sept ans quand il engendra Lamek."
,"26":"Après la naissance de Lamek, Mathusalem vécut encore sept cent quatre-vingt-deux ans, il engendra des fils et des filles."
,"27":"La vie de Mathusalem atteignit neuf cent soixante-neuf ans en tout, après quoi il mourut."
,"28":"Lamek avait cent quatre-vingt-deux ans quand il engendra un fils."
,"29":"Il lui donna le nom de Noé car, dit-il, 'Il nous consolera du travail et de la peine de nos mains pour ce sol que Yahvé a maudit.'"
,"30":"Après la naissance de Noé, Lamek vécut encore cinq cent quatre-vingt-quinze ans, il engendra des fils et des filles."
,"31":"La vie de Lamek atteignit sept cent soixante-dix-sept ans en tout, après quoi il mourut."
,"32":"Noé avait cinq cents ans quand il engendra Sem, Kam et Japhet."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Les hommes commençaient à devenir nombreux sur la surface de la terre et des filles leur étaient nées."
,"2":"Les fils de Dieu virent que les filles des hommes étaient belles, et ils prirent pour femmes toutes celles qu'ils avaient remarquées."
,"3":"Aussi Yahvé dit: 'Mon esprit ne restera pas pour toujours dans l'homme car il n'est que chair, sa vie ne dépassera plus cent vingt ans.'"
,"4":"Il y eut des géants sur la terre en ce temps-là, et même après, lorsque les fils de Dieu venaient vers les filles des hommes et qu'elles enfantaient: ainsi naquirent les héros des temps anciens, ces hommes célèbres."
,"5":"Yahvé vit que la méchanceté de l'homme sur la terre était grande et que dans son coeur il n'y avait de place que pour le mal."
,"6":"Yahvé se repentit d'avoir fait l'homme sur la terre et il en fut tout triste."
,"7":"Yahvé dit: 'Je supprimerai de la surface de la terre les hommes que j'ai créés; et avec les hommes, les animaux des champs, les reptiles et les oiseaux du ciel, car je me repens de les avoir faits.'"
,"8":"Mais Noé trouva grâce aux yeux de Yahvé."
,"9":"Voici l'histoire de Noé. Noé était un homme juste et droit parmi ses contemporains: Noé marchait avec Dieu."
,"10":"Noé engendra trois fils: Sem, Kam et Japhet."
,"11":"La terre devint mauvaise aux yeux de Dieu: elle était remplie de violence."
,"12":"Dieu regarda la terre: elle était complètement corrompue parce que tout être sur la terre suivait les chemins du mal."
,"13":"Dieu dit alors à Noé: 'J'ai décidé la fin de tous les êtres vivants, car ils remplissent la terre de violence, je vais les supprimer de la terre."
,"14":"Fabrique-toi donc une arche en bois de cyprès; tu feras des niches dans l'arche et tu l'enduiras de goudron à l'intérieur et à l'extérieur."
,"15":"Voici comment tu la fabriqueras: sa longueur sera de trois cents coudées, sa largeur de cinquante coudées, sa hauteur de trente coudées."
,"16":"Tu feras un toit pour l'arche et tu laisseras un espace libre d'une coudée entre le haut des côtés et le toit. Tu placeras la porte de l'arche sur le côté et tu feras un premier, un deuxième et un troisième étage."
,"17":"Je vais amener sur la terre les eaux du déluge afin de détruire tout être qui a un souffle de vie sous le ciel: tout ce qui existe sur la terre périra."
,"18":"Mais j'établirai mon alliance avec toi et tu entreras dans l'arche, toi, tes fils, ta femme et les femmes de tes fils avec toi."
,"19":"Tu feras entrer aussi dans l'arche deux animaux de chaque espèce, un mâle et une femelle. Tu feras ainsi pour tout être vivant, pour les garder vivants avec toi."
,"20":"Il en viendra vers toi deux de chaque espèce: des oiseaux selon leur espèce, des animaux des champs selon leur espèce, de tous les reptiles de la terre selon leur espèce. Ainsi tu les garderas en vie."
,"21":"Tu te procureras de tout aliment qui se mange, tu en feras provision pour que vous ayez à manger, toi comme eux.'"
,"22":"Noé fit tout comme Dieu le lui avait ordonné."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Yahvé dit à Noé: 'Entre dans l'arche, toi et toute ta famille, car tu es le seul juste que j'aie vu dans la génération que j'ai sous les yeux."
,"2":"Tu prendras avec toi, de tous les animaux purs, sept paires, le mâle avec sa femelle, et de tous les animaux qui ne sont pas purs, une paire, le mâle avec sa femelle."
,"3":"De même pour les oiseaux du ciel, sept paires, mâle et femelle, pour conserver leur race sur la surface de la terre."
,"4":"Car encore sept jours et je ferai pleuvoir sur la terre pendant quarante jours et quarante nuits. Je supprimerai de la surface de la terre tous les êtres que j'ai faits'."
,"5":"Noé fit tout ce que Yahvé lui avait ordonné."
,"6":"Noé avait six cents ans lorsque le déluge des eaux commença à inonder la terre."
,"7":"Noé entra donc dans l'arche avec ses fils, sa femme et les femmes de ses fils pour échapper aux eaux du déluge."
,"8":"Des animaux purs et des animaux qui ne sont pas purs, des oiseaux et de tous les reptiles de la terre,"
,"9":"il en vint vers Noé dans l'arche, deux par deux, mâle et femelle, selon ce que Dieu avait ordonné à Noé."
,"10":"Et au bout de sept jours, les eaux du déluge inondèrent la terre."
,"11":"C'était la six-centième année de la vie de Noé, le dix-septième jour du deuxième mois. En ce jour-là, toutes les fontaines du fond de la mer jaillirent, et les écluses du ciel s'ouvrirent:"
,"12":"la pluie allait tomber sur terre pendant quarante jours et quarante nuits."
,"13":"Ce jour-là, Noé entra dans l'arche avec ses fils Sem, Kam et Japhet, avec sa femme et les trois femmes de ses fils."
,"14":"Avec eux entrèrent aussi toutes les bêtes selon leur espèce, tous les animaux des champs selon leur espèce, tous les reptiles qui rampent sur la terre selon leur espèce, et tous les oiseaux et tout ce qui vole, chacun selon leur espèce."
,"15":"Ils arrivaient auprès de Noé dans l'arche, deux par deux, de toutes les espèces."
,"16":"Ils entraient, le mâle avec sa femelle, il en arrivait de chaque espèce selon l'ordre de Dieu. Et puis Yahvé ferma la porte derrière Noé. "
,"17":"Le déluge dura quarante jours sur la terre; les eaux montèrent, elles soulevèrent l'arche qui s'éleva au-dessus de la terre."
,"18":"Les eaux grossirent, grossirent encore sur la terre et l'arche allait sur la surface des eaux."
,"19":"Les eaux continuèrent de grossir, toujours et encore au-dessus de la terre, et toutes les hautes montagnes qui sont sous le ciel furent recouvertes."
,"20":"Les eaux montèrent encore de quinze coudées quand toutes les montagnes étaient déjà recouvertes."
,"21":"Tous les êtres vivants de la terre périrent: oiseaux, animaux des champs, bêtes sauvages, tout ce qui vivait et bougeait sur la terre, ainsi que tous les hommes."
,"22":"Tout ce qui avait un souffle de vie dans les narines, tout ce qui existait sur la terre ferme mourut."
,"23":"Alors tous les êtres qui se trouvaient sur la surface de la terre disparurent. Depuis les hommes jusqu'aux animaux des champs, jusqu'aux reptiles et aux oiseaux du ciel: ils disparurent de la terre. Il ne resta plus que Noé et ceux qui étaient avec lui dans l'arche."
,"24":"Les eaux recouvrirent ainsi la terre pendant cent cinquante jours."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Alors Dieu se souvint de Noé, de toutes les bêtes et tous les animaux des champs qui étaient avec lui dans l'arche. Dieu fit souffler un vent qui assécha la terre et les eaux se retirèrent."
,"2":"Les fontaines du fond de la mer et les écluses du ciel se fermèrent, la pluie s'arrêta de tomber."
,"3":"Les eaux se retirèrent de sur la terre avec des flux et des reflux; elles baissèrent dès la fin des cent cinquante jours."
,"4":"Au dix-septième jour du septième mois, l'arche se posa sur le mont Ararat."
,"5":"Les eaux continuèrent de baisser jusqu'au dixième mois, et le premier jour du dixième mois les sommets des montagnes apparurent."
,"6":"Au bout de quarante jours, Noé ouvrit la fenêtre qu'il avait faite dans l'arche"
,"7":"et il lâcha le corbeau qui commença d'aller et venir jusqu'à ce que les eaux aient disparu de la terre."
,"8":"Noé lâcha ensuite la colombe pour voir si les eaux avaient baissé à la surface de la terre."
,"9":"Mais la colombe ne trouva pas d'endroit pour poser ses pattes, et elle revint vers lui dans l'arche, car les eaux couvraient encore la surface de la terre. Noé étendit la main, prit la colombe et la ramena vers lui dans l'arche."
,"10":"Il attendit encore sept autres jours et, de nouveau, il lâcha la colombe hors de l'arche."
,"11":"La colombe revint vers lui à l'heure du soir, et voici qu'elle tenait dans son bec une petite branche d'olivier toute fraîche. Alors Noé comprit que les eaux avaient baissé sur la terre."
,"12":"Il attendit encore sept autres jours et lâcha la colombe, mais elle ne revint plus vers lui."
,"13":"En l'an six cent un de la vie de Noé, le premier jour du premier mois, les eaux avaient séché sur la terre. Noé souleva le toit de l'arche et regarda: il vit que la surface du sol était sèche."
,"14":"Le vingt-septième jour du deuxième mois la terre était complètement sèche."
,"15":"Alors Dieu s'adressa à Noé et lui dit:"
,"16":"'Sors de l'arche, toi, ta femme, tes fils, et les femmes de tes fils avec toi."
,"17":"Fais sortir tous les animaux qui sont avec toi: oiseaux, animaux des champs et tous les reptiles qui rampent sur la terre. Qu'ils soient féconds et nombreux sur la terre!'"
,"18":"Noé sortit alors avec ses fils, sa femme et les femmes de ses fils."
,"19":"Tous les animaux, tous les oiseaux, tous les reptiles qui rampent sur la terre sortirent aussi de l'arche, famille par famille."
,"20":"Noé construisit un autel en l'honneur de Yahvé; il prit de tous les animaux purs et de tous les oiseaux purs et il en offrit un sacrifice par le feu sur cet autel."
,"21":"Yahvé sentit la bonne odeur et il dit en son coeur: 'Je ne maudirai plus jamais la terre à cause de l'homme, car les pensées du coeur de l'homme sont mauvaises dès sa jeunesse, je ne recommencerai plus à frapper les êtres vivants comme je l'ai fait."
,"22":"Aussi longtemps que la terre durera, semailles et moissons, gelées et chaleur, été, hiver, jour et nuit, ne cesseront plus.'"
}`)
	CurrentBook.AddChapter(9, `{
"1":"Dieu bénit Noé et ses fils, il leur dit: 'Soyez féconds et nombreux, remplissez la terre."
,"2":"Vous inspirerez crainte ou terreur à tous les animaux de la terre et aux oiseaux du ciel. Tout ce qui foisonne sur la terre est à votre disposition, et de même les poissons de la mer: prenez-en."
,"3":"Tout ce qui bouge et vit sera votre nourriture, je vous le donne tout comme les légumes."
,"4":"Cependant vous ne mangerez pas la chair avec son âme, c'est-à-dire le sang."
,"5":"Je demanderai compte de votre sang -de votre âme- à tout animal; et pour les hommes entre eux, je demanderai compte à chacun de l'âme de son frère. De l'âme de tout homme, je demanderai compte."
,"6":"Si quelqu'un répand le sang de l'homme, son sang aussi sera répandu par l'homme, car Dieu a créé l'homme à son image."
,"7":"Quant à vous, soyez féconds, nombreux, développez-vous sur la terre et dominez sur elle.'"
,"8":"Dieu adressa la parole à Noé et à ses fils:"
,"9":"'Voici que j'établis mon alliance avec vous et avec votre descendance après vous,"
,"10":"avec tous les êtres vivants qui sont avec vous: oiseaux, animaux des champs et bêtes de la terre qui vivent autour de vous, tous ces animaux de la terre qui sont sortis de l'arche."
,"11":"Oui, j'établis mon alliance avec vous: on ne verra plus tous les êtres vivants supprimés de la terre par les eaux d'un déluge; il n'y aura plus de déluge pour ravager la terre.'"
,"12":"Et Dieu dit: 'Voici le signe de l'alliance que j'établis entre moi et vous et tous les êtres vivants qui sont avec vous pour les générations à venir."
,"13":"Je place mon arc dans la nuée pour qu'il soit le signe de l'alliance entre moi et la terre."
,"14":"Lorsque je couvrirai la terre de nuages, l'arc apparaîtra dans le ciel."
,"15":"Alors je me souviendrai de l'alliance que j'ai établie entre moi et vous et tout être vivant, et on ne verra plus des eaux de déluge détruire toute chair."
,"16":"L'arc-en-ciel sera dans la nuée: je le verrai et je me souviendrai de l'alliance perpétuelle entre Dieu et tout être qui vit sur la terre.'"
,"17":"Dieu dit à Noé: 'Voici le signe de l'alliance que j'ai établie entre moi et tout ce qui vit sur la terre.'"
,"18":"Les fils de Noé qui sortirent de l'arche étaient Sem, Kam et Japhet. Kam est le père de Canaan."
,"19":"Ces trois-là sont les fils de Noé, et c'est par eux que fut peuplée toute la terre."
,"20":"Noé, homme de la terre, commença à planter une vigne."
,"21":"Il but du vin, s'enivra et se coucha nu au milieu de sa tente."
,"22":"Kam, père de Canaan, regarda son père qui était nu et il le raconta à ses deux frères qui étaient dehors."
,"23":"Mais Sem et Japhet prirent un manteau à deux, ils le mirent sur leurs épaules, puis ils marchèrent à reculons et couvrirent leur père qui était nu. Leurs visages étaient tournés en arrière pour ne pas regarder la nudité de leur père."
,"24":"Lorsque Noé sortit de son ivresse, il apprit ce qu'avait fait son fils le plus jeune."
,"25":"Il dit: 'Maudit soit Canaan! Il sera pour ses frères l'esclave des esclaves.'"
,"26":"Puis il dit: 'Béni soit Yahvé, le Dieu de Sem! Que Canaan soit son esclave!"
,"27":"Que Dieu fasse grandir Japhet! Qu'il habite dans les tentes de Sem et que Canaan soit son esclave!'"
,"28":"Noé vécut encore trois cent cinquante ans après le déluge."
,"29":"La vie de Noé atteignit neuf cent cinquante ans au total, après quoi il mourut."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Voici la descendance des fils de Noé: Sem, Kam et Japhet, lesquels engendrèrent des fils après le déluge."
,"2":"Fils de Japhet: Gomer, Magog, les Mèdes, Yavan, Toubal, Mochek, Tiras."
,"3":"Fils de Gomer: Achkenaz, Riphat, Togorma."
,"4":"Fils de Yavan: Elicha, Tarsis, Kittim, les Dananéens."
,"5":"C'est à partir d'eux que se fit la dispersion dans les îles lointaines. Ce sont là les fils de Japhet d'après leurs pays, selon leurs langues, leurs clans et leurs nations."
,"6":"Fils de Kam: Kouch, Misraïm, Pout, Canaan."
,"7":"Fils de Kouch: Séba, Havila, Sabta, Rama, Sabtéka. Fils de Rama: Chéba, Dédan."
,"8":"Kouch engendra Nemrod qui fut le premier héros sur la terre."
,"9":"C'était un vaillant chasseur devant Yahvé. C'est pour cela que l'on dit: 'Vaillant chasseur devant Yahvé comme Nemrod.'"
,"10":"Ceux qui soutenaient son empire étaient: Babel, Erek, et Akkad. Toutes ces villes sont au pays de Chinéar."
,"11":"De ce pays sortit Achour, c'est lui qui construisit Ninive, Rehobot-Ir, Kala"
,"12":"et Rèsèn entre Ninive et Kala (c'est une grande ville)."
,"13":"Misraïm engendra les gens de Loud, de Anam, de Léhab, de Naftou,"
,"14":"de Patros, de Kaslou et de Kaftor, d'où sont sortis les Philistins."
,"15":"Canaan engendra Sidon qui fut son premier-né, puis Heth,"
,"16":"et le Jébusite, l'Amorite, le Guirgachite,"
,"17":"le Hivvite, l'Arkite, le Sinite,"
,"18":"l'Arvadite, le Sémarite, le Hamatite. Ensuite les clans Cananéens se dispersèrent."
,"19":"La frontière des Cananéens partait de Sidon vers Guérar jusqu'à Gaza, et vers Sodome, Gomorrhe, Adma et Séboyim jusqu'à Lécha."
,"20":"Ce sont là les fils de Kam, selon leurs clans et leurs langues, leurs pays et leurs nations."
,"21":"Sem eut également une descendance. Il est l'ancêtre de tous les fils de Eber et le frère aîné de Japhet."
,"22":"Fils de Sem: Elam, Achour, Arpakchad, Loud, Aram."
,"23":"Fils d'Aram: Ous, Houl, Guéter et Mach."
,"24":"Arpakchad engendra Chéla et Chéla engendra Eber."
,"25":"Eber eut deux fils. Le premier s'appelait Péleg, c'est en son temps que la terre fut divisée. Son frère s'appelait Yoktan."
,"26":"Yoktan engendra Almodad, Chélef, Assarmavet, Yéra,"
,"27":"Adoram, Ouzal, Dikla,"
,"28":"Obal, Abimaël, Chéba,"
,"29":"Ofir, Havila, Yobab. Ce sont là tous les fils de Yoktan."
,"30":"Ils habitaient à partir de Mécha en allant vers Séfar, la montagne de l'Orient."
,"31":"Ce sont les fils de Sem selon leurs clans et leurs langues, leurs pays et leurs nations."
,"32":"Voilà les descendants de Noé selon leurs lignées et leurs nations. C'est à partir d'eux que les peuples se dispersèrent sur la terre après le déluge."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Sur toute la terre on parlait la même langue, on se servait des mêmes mots."
,"2":"Comme les hommes se dirigeaient vers l'orient, ils atteignirent une plaine au pays de Chinéar et s'y installèrent."
,"3":"Alors ils se dirent les uns aux autres: ' Faisons donc des briques et cuisons-les au feu.' La brique remplaça la pierre et le bitume leur servit de ciment."
,"4":"Ils dirent encore: 'Venez donc! Construisons-nous une ville, avec une tour dont le sommet sera dans le ciel et qui nous fera un nom. Cela nous évitera de nous disperser sur toute la surface de la terre.'"
,"5":"Yahvé descendit pour voir la ville et la tour que bâtissaient les hommes,"
,"6":"et il dit: 'Voici qu'ils ne forment tous qu'un seul peuple, avec une même langue; s'ils commencent ainsi, aucun projet désormais ne leur sera impossible."
,"7":"Allons, descendons, et ici-même mettons la confusion dans leur langage pour qu'ils ne comprennent plus le langage les uns des autres.'"
,"8":"De cette façon Yahvé les dispersa sur la surface de toute la terre et ils cessèrent de construire la ville."
,"9":"C'est pour cela qu'on lui donna le nom de Babel (c'est-à-dire: Confusion). Là, en effet, Yahvé avait confondu le langage de toute la terre, et c'est de là que Yahvé les avait dispersés sur la surface de toute la terre."
,"10":"Voici la descendance de Sem. A l'âge de cent ans Sem engendra Arpakchad, deux ans après le déluge."
,"11":"Après la naissance d'Arpakchad, Sem vécut encore cinq cents ans, il engendra des fils et des filles."
,"12":"A l'âge de trente-cinq ans, Arpakchad engendra Chéla."
,"13":"Après la naissance de Chéla, Arpakchad vécut encore quatre cent trois ans, il engendra des fils et des filles."
,"14":"A l'âge de trente ans, Chéla engendra Eber."
,"15":"Après la naissance de Eber, Chéla vécut encore quatre cent trois ans, il engendra des fils et des filles."
,"16":"A l'âge de trente-quatre ans, Eber engendra Péleg."
,"17":"Après la naissance de Péleg, Eber vécut encore quatre cent trente ans, il engendra des fils et des filles."
,"18":"A l'âge de trente ans, Péleg engendra Réou."
,"19":"Après la naissance de Réou, Péleg vécut encore deux cent neuf ans, il engendra des fils et des filles."
,"20":"A l'âge de trente-deux ans, Réou engendra Séroug."
,"21":"Après la naissance de Séroug, Réou vécut encore deux cent sept ans, il engendra des fils et des filles."
,"22":"A l'âge de trente ans, Séroug engendra Nahor."
,"23":"Après la naissance de Nahor, Séroug vécut encore deux cents ans, il engendra des fils et des filles."
,"24":"A l'âge de vingt-neuf ans, Nahor engendra Térah."
,"25":"Après la naissance de Térah, Nahor vécut encore cent dix-neuf ans, il engendra des fils et des filles."
,"26":"A l'âge de soixante-dix ans, Térah engendra Abram, Nahor et Harân."
,"27":"Voici la descendance de Térah: Térah engendra Abram, Nahor et Harân. Harân engendra Lot."
,"28":"Harân mourut quand son père Térah vivait encore, dans son pays natal: Our des Kaldéens."
,"29":"Abram et Nahor se marièrent. La femme d'Abram s'appelait Saraï, la femme de Nahor s'appelait Milka, elle était fille de Harân, le père de Milka et de Yiska."
,"30":"Or Saraï était stérile, elle n'avait pas d'enfant."
,"31":"Térah prit son fils Abram, son petit-fils Lot, fils de Harân et sa belle-fille Saraï, femme d'Abram. Il les fit sortir d'Our des Kaldéens pour gagner le pays de Canaan, mais, arrivés à Harrân, ils s'y installèrent."
,"32":"Le total des années que vécut Térah fut de deux cent cinq ans, après quoi il mourut à Harrân."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Yahvé dit à Abram: 'Quitte ton pays, ta parenté et la maison de ton père pour le pays que je te montrerai."
,"2":"Je ferai de toi une grande nation, je te bénirai. Je ferai que ton nom soit grand, et tu seras une source de bénédiction."
,"3":"Je bénirai ceux qui te béniront, et je maudirai celui qui te maudira: en toi seront bénies toutes les familles de la terre.'"
,"4":"Abram partit donc comme Yahvé le lui avait ordonné, et Lot partit avec lui. Abram était âgé de soixante-quinze ans lorsqu'il partit de Harrân. "
,"5":"Abram prit Saraï, sa femme, et Lot, le fils de son frère, tous les biens qu'il avait réunis et les gens qu'il avait acquis à Harrân; ils se mirent en route pour gagner le pays de Canaan. Arrivé au pays de Canaan, "
,"6":"Abram traversa le pays jusqu'au lieu saint de Sichem, jusqu'à l'Arbre de Moré. Les Cananéens occupaient alors le pays."
,"7":"Yahvé apparut à Abram et lui dit: 'Je donnerai cette terre à ta descendance.' Et Abram construisit là un autel à Yahvé qui lui était apparu."
,"8":"De là, il passa à la montagne qui est à l'orient de Béthel; il dressa sa tente entre Béthel, à l'occident, et Aï, à l'orient. Il construisit là un autel à Yahvé et invoqua le nom de Yahvé."
,"9":"Puis, de campement en campement, Abram marcha vers le Négueb."
,"10":"Il y eut alors une grande famine dans le pays et Abram descendit vers l'Egypte pour s'y installer."
,"11":"Comme il approchait de l'Egypte, il dit à Saraï, sa femme: 'Tu es une belle femme, je le sais!"
,"12":"Lorsque les Egyptiens te verront, ils diront: C'est sa femme. Alors ils me tueront et te laisseront vivre."
,"13":"Dis-leur que tu es ma soeur: ils me feront du bien à cause de toi, et grâce à toi j'aurai la vie sauve.'"
,"14":"En effet, lorsqu'Abram entra en Egypte, les Egyptiens virent que sa femme était très belle."
,"15":"Les officiers de Pharaon, quand ils la virent, en firent grand éloge auprès de leur maître et on emmena la femme dans le palais de Pharaon."
,"16":"Celui-ci combla de biens Abram à cause d'elle: il eut du petit et du gros bétail, des ânes, des serviteurs et des servantes, des ânesses et des chameaux."
,"17":"Mais, pour cette affaire de Saraï, femme d'Abram, Yahvé frappa de grandes plaies Pharaon et sa maison."
,"18":"Pharaon fit appeler Abram et lui dit: 'Que m'as-tu fait! Pourquoi ne m'as-tu pas dit qu'elle était ta femme?"
,"19":"Tu m'as dit que c'était ta soeur, c'est pourquoi je l'ai prise pour femme. Maintenant donc, voilà ta femme, prends-la et va-t'en!'"
,"20":"Pharaon donna des ordres à ses serviteurs: ils le reconduisirent jusqu'à la frontière avec sa femme et tout ce qui était à lui."
}`)
	CurrentBook.AddChapter(13, `{
"1":"D'Egypte, Abram remonta vers le Négueb, lui, sa femme et tout ce qu'il possédait, ainsi que Lot."
,"2":"Or Abram était très riche en troupeaux, en argent et en or."
,"3":"Par étapes il alla du Négueb jusqu'à Béthel, jusqu'à l'endroit où il avait planté sa tente entre Béthel et Aï,"
,"4":"à l'endroit même où se trouvait l'autel qu'il avait construit précédemment et où il avait invoqué le nom de Yahvé."
,"5":"Lot allait avec Abram. Lui aussi avait ses tentes, et il possédait du gros et du petit bétail."
,"6":"Mais le terrain ne leur permettait pas de vivre côte à côte: leurs troupeaux étaient trop nombreux pour qu'ils puissent rester ensemble."
,"7":"Il y eut une dispute entre les bergers des troupeaux d'Abram et les bergers des troupeaux de Lot (les Cananéens et les Périsites habitaient alors le pays)."
,"8":"Alors Abram dit à Lot: 'Qu'il n'y ait pas de querelle entre moi et toi, entre mes bergers et tes bergers, car nous sommes frères."
,"9":"Tout le pays n'est-il pas à ta disposition? Séparons-nous donc: si tu vas à gauche, j'irai à droite, et si tu vas à droite, j'irai à gauche.'"
,"10":"Lot leva les yeux et regarda: toute la vallée du Jourdain était bien arrosée, (c'était avant la destruction de Sodome et de Gomorrhe par Yahvé). C'était comme un jardin de Yahvé, comme le pays d'Egypte en arrivant de Soar."
,"11":"Lot choisit donc pour lui toute la vallée du Jourdain et il partit vers l'Orient. C'est ainsi qu'ils se séparèrent l'un de l'autre. "
,"12":"Abram s'établit au pays de Canaan tandis que Lot s'établissait dans les villes de la vallée et transportait ses tentes jusqu'à Sodome."
,"13":"Or les habitants de Sodome étaient mauvais, de grands pécheurs devant Yahvé!"
,"14":"Après le départ de Lot, Yahvé dit à Abram: 'Lève les yeux et regarde de l'endroit où tu te trouves vers le nord et vers le midi, vers l'orient et vers l'occident."
,"15":"Tout le pays que tu vois, je te le donnerai à toi et à ta descendance pour toujours."
,"16":"Je rendrai ta descendance aussi nombreuse que la poussière de la terre. Quand on pourra compter les grains de poussière de la terre, alors aussi on comptera tes descendants."
,"17":"Lève-toi! Parcours le pays en long et en large car c'est celui que je te donnerai.'"
,"18":"Abram leva la tente et vint s'établir au chêne de Mambré qui est à Hébron, et là il construisit un autel à Yahvé."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Lorsque régnaient Amrafel roi de Chinéar, Aryok roi d'Elasar, Kédor-Laomer roi d'Elam et Tidéal roi des Goyim,"
,"2":"ces rois firent la guerre à Béra roi de Sodome, à Bircha roi de Gomorrhe, à Chinéab roi d'Adma, à Chéméber roi de Séboyim et au roi de Béla qu'on appelle aussi Soar."
,"3":"Tous ceux-ci se rassemblèrent dans la vallée de Siddim (c'est la Mer du Sel)."
,"4":"Ils avaient été soumis pendant douze ans à Kédor-Laomer, mais la treizième année ils se révoltèrent."
,"5":"Aussi, la quatorzième année, Kédor-Laomer vint avec les rois ses alliés. Ils battirent les Réphaïm à Achtérot-Karnayim, les Zouzim à Ham, les Emim dans la plaine de Kiryatayim,"
,"6":"les Horites dans la montagne de Séïr jusqu'au Chêne de Paran, à la limite du désert."
,"7":"Ils revinrent ensuite et arrivèrent à la Source du Jugement (c'est Qadesh); ils ravagèrent toutes les campagnes des Amalécites et des Amorites qui habitent à Hassasson-Tamar."
,"8":"Alors le roi de Sodome, le roi de Gomorrhe, le roi d'Adma, le roi de Séboyim et le roi de Béla (c'est Soar) se mirent en campagne et se rangèrent en bataille dans la vallée de Siddim,"
,"9":"contre Kédor-Laomer roi d'Elam, Tidéal roi des Goyim, Amrafel roi de Chinéar et Aryok roi d'Elasar: quatre rois contre cinq."
,"10":"Or les puits de bitume étaient très nombreux dans la vallée de Siddim. En fuyant, le roi de Sodome et le roi de Gomorrhe tombèrent dedans; quant aux autres, ils se réfugièrent dans la montagne."
,"11":"Les vainqueurs pillèrent Sodome et Gomorrhe, prirent tous les vivres et s'en allèrent."
,"12":"Ils avaient pris aussi Lot et tous ses biens avant de partir: c'était le neveu d'Abram et il habitait Sodome."
,"13":"Un des rescapés vint apporter la nouvelle à Abram l'Hébreu, qui résidait alors près du chêne de Mambré l'Amorite, frère d'Echkol et d'Aner, les alliés d'Abram."
,"14":"Quand Abram apprit que son neveu avait été emmené prisonnier, il rassembla ses hommes de guerre, tous ceux qui étaient nés dans sa maison, et se lança à la poursuite des pillards jusqu'à Dan."
,"15":"Avec ses serviteurs, trois cent dix-huit en tout, il se jeta sur eux en pleine nuit, les battit et les poursuivit jusqu'à Hoba, au nord de Damas."
,"16":"Il reprit tout le butin, ainsi que son neveu Lot et ses biens, avec ses femmes et ses gens."
,"17":"Comme Abram revenait après avoir battu Kédor-Laomer et les rois qui étaient avec lui, le roi de Sodome vint à sa rencontre dans la vallée de Chavé (c'est la Vallée du Roi)."
,"18":"Alors Melquisédek, roi de Shalem, apporta du pain et du vin: il était prêtre du Dieu Très-Haut."
,"19":"Il bénit Abram et dit: 'Béni soit Abram par le Dieu Très-Haut, créateur du ciel et de la terre!"
,"20":"Béni soit le Dieu Très-Haut qui a livré tes ennemis entre tes mains!' Abram lui donna la dixième partie de tout ce qu'il ramenait."
,"21":"Le roi de Sodome dit ensuite à Abram: 'Donne-moi les personnes que tu as libérées et garde pour toi les biens.'"
,"22":"Mais Abram répondit au roi de Sodome: 'Je le jure par Yahvé, Dieu Très-Haut, créateur du ciel et de la terre:"
,"23":"je ne prendrai rien de ce qui est à toi, ni un fil, ni une courroie de sandale. Je ne veux pas que tu puisses dire: J'ai enrichi Abram."
,"24":"Non, rien pour moi, si ce n'est la nourriture de mes serviteurs. Mais les hommes qui sont venus avec moi, Aner, Echkol et Mambré, eux, prendront leur part.'"
}`)
	CurrentBook.AddChapter(15, `{
"1":"Après ces événements, la parole de Yahvé fut adressée à Abram dans une vision: 'Ne crains pas, Abram, je suis ton bouclier, ta récompense sera très grande.'"
,"2":"Abram répondit: 'Seigneur Yahvé, que me donneras-tu? Je m'en vais sans enfants, et c'est Eliézer de Damas qui héritera de ma maison.'"
,"3":"Abram dit encore: 'Comme tu ne m'as pas donné de descendance, c'est l'un de mes serviteurs qui sera mon héritier.'"
,"4":"Alors la parole de Yahvé lui fut adressée en ces termes: 'Ce n'est pas lui qui héritera de toi; ton héritier sera un enfant à toi né de ton sang.'"
,"5":"Il le fit alors sortir et lui dit: 'Regarde le ciel et compte les étoiles si tu peux les compter.' Et il ajouta: 'Ainsi sera ta descendance.'"
,"6":"Abram crut en Yahvé, et pour cela, Yahvé le regarda comme juste."
,"7":"Il lui dit: 'Je suis Yahvé qui t'ai fait sortir d'Our en Kaldée, pour te donner ce pays et qu'il soit ton domaine.'"
,"8":"Abram répondit: 'Seigneur Yahvé, comment saurai-je que je le posséderai?'"
,"9":"Il lui dit: 'Prends-moi une génisse de trois ans, une chèvre de trois ans, un bélier de trois ans, une tourterelle et un pigeonneau.'"
,"10":"Abram prit tous ces animaux et les partagea par le milieu, il plaça chaque moitié vis-à-vis de l'autre moitié, mais il ne partagea pas les oiseaux."
,"11":"Les rapaces venaient s'abattre sur les cadavres, mais Abram les chassa."
,"12":"Comme le soleil se couchait, un profond sommeil tomba sur Abram, et il se trouva pris d'angoisse, plongé dans une grande obscurité."
,"13":"Dieu dit alors à Abram: 'Tu dois savoir que tes descendants vivront comme étrangers dans un pays qui n'est pas le leur; ils deviendront esclaves, on les opprimera durant quatre cents ans."
,"14":"Mais alors je jugerai la nation de leurs maîtres, après quoi ils s'en iront comblés de richesses."
,"15":"Quant à toi, tu iras en paix rejoindre tes pères et tu seras mis au tombeau après une heureuse vieillesse."
,"16":"Ce n'est qu'à la quatrième génération que tes descendants reviendront ici, car jusqu'alors la faute des Amorites ne sera pas assez grande pour que je les chasse.'"
,"17":"Le soleil se coucha et la nuit se fit noire. Alors une fournaise et une torche embrasée passèrent entre les morceaux des victimes."
,"18":"Ce jour-là Yahvé conclut une alliance avec Abram. Il lui dit: 'Je donne à ta descendance ce pays, depuis le fleuve d'Egypte jusqu'au grand fleuve, le fleuve de l'Euphrate."
,"19":"Le pays des Kénites, des Kénizites, des Kadmonites,"
,"20":"des Hittites, des Périsites, des Réphaïm,"
,"21":"des Amorites, des Cananéens, des Guirgachites et des Jébusites."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Saraï, la femme d'Abram, ne lui avait pas donné d'enfant. Or elle avait une servante égyptienne qui s'appelait Agar."
,"2":"Saraï dit à Abram: 'Tu le vois bien, Yahvé n'a pas permis que j'enfante. Va donc vers ma servante, j'aurai peut-être un fils par elle.' Abram écouta Saraï."
,"3":"Cela faisait déjà dix ans qu'Abram était installé au pays de Canaan, lorsque Saraï, la femme d'Abram, prit sa servante Agar l'Egyptienne et la donna à son mari Abram."
,"4":"Il s'approcha d'Agar et elle fut enceinte. Quand elle se vit enceinte, elle commença à mépriser sa maîtresse. "
,"5":"Alors Saraï dit à Abram: 'Tu es responsable de mon humiliation. C'est moi qui ai mis ma servante dans tes bras et, depuis qu'elle s'est vue enceinte, elle ne cesse pas de m'humilier. Que Yahvé juge entre moi et toi!'"
,"6":"Abram dit à Saraï: 'Voici ta servante, elle est à toi, fais-lui ce qui te semble bon.' Alors Saraï la maltraita si bien qu'Agar s'enfuit loin d'elle."
,"7":"L'ange de Yahvé la trouva près d'une source d'eau dans le désert: c'est la source qui est sur la route de Chour."
,"8":"Il lui dit: 'Agar, servante de Saraï, d'où viens-tu et où vas-tu?' Elle répondit: 'Je me suis enfuie loin de Saraï, ma maîtresse.'"
,"9":"L'ange de Yahvé lui dit: 'Retourne vers ta maîtresse et humilie-toi devant elle.'"
,"10":"L'ange de Yahvé lui dit: 'Je rendrai ta descendance si nombreuse, qu'on ne pourra même pas la compter.'"
,"11":"L'ange de Yahvé lui dit: 'Tu es enceinte et tu enfanteras un fils. Tu lui donneras le nom d'Ismaël, car Yahvé a entendu le cri de ta détresse."
,"12":"Il sera un homme indomptable, il se dressera contre tous et tous se dresseront contre lui, il s'établira à l'écart de tous ses frères.'"
,"13":"Agar donna ce nom à Yahvé qui lui avait parlé: 'Tu es El-Roï' car, dit-elle, 'n'ai-je pas vu Celui qui me voit?'"
,"14":"C'est pourquoi on a appelé ce puits: le puits de Lahaï Roï. Il se trouve entre Qadesh et Bérèd."
,"15":"Agar donna un fils à Abram, et Abram appela Ismaël ce fils qu'Agar lui avait donné."
,"16":"Abram avait quatre-vingt-six ans lorsqu'Agar lui donna Ismaël."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Lorsqu'Abram avait quatre-vingt-dix-neuf ans, Yahvé lui apparut et lui dit: 'Je suis le Dieu de la Steppe, marche devant moi et sois parfait."
,"2":"J'établirai mon alliance entre moi et toi, je te multiplierai encore et encore.'"
,"3":"Abram se prosterna et Dieu lui parla ainsi:"
,"4":"'Voici quelle alliance je fais avec toi: tu vas devenir le père de nations nombreuses."
,"5":"Aussi ne t'appellera-t-on plus du nom d'Abram, mais ton nom sera Abraham, car je ferai de toi le père de nombreuses nations."
,"6":"Je te rendrai fécond, très fécond. Tu deviendras, non pas une, mais des nations, et des rois sortiront de toi."
,"7":"J'établirai mon alliance, une alliance perpétuelle, entre moi et toi et ta descendance après toi, de génération en génération: je serai ton Dieu et celui de ta descendance après toi."
,"8":"Tout ce pays de Canaan, cette terre où tu es un nomade, je te le donnerai, et à ta descendance après toi, comme une propriété perpétuelle; et je serai leur Dieu.'"
,"9":"Dieu dit à Abraham: 'Tu garderas mon alliance, toi et ta descendance après toi, de génération en génération."
,"10":"Voici l'alliance que vous garderez, que j'établis entre moi et toi, et ta descendance après toi: tout mâle parmi vous sera circoncis."
,"11":"Vous circoncirez votre chair, votre prépuce, et ce sera le signe de l'alliance entre moi et vous."
,"12":"De génération en génération, tout mâle parmi vous sera circoncis à l'âge de huit jours, aussi bien celui qui est né dans la maison, que celui qui a été acheté à prix d'argent chez des étrangers qui ne sont pas de ta race."
,"13":"Tu circonciras celui qui est né dans ta maison comme celui qui a été acheté avec ton argent. Mon alliance sera gravée dans votre chair, elle deviendra ainsi une alliance perpétuelle."
,"14":"Celui qui n'aura pas été circoncis, le mâle dont on n'aura pas coupé le prépuce, sera retranché de sa parenté: il aura violé mon alliance.'"
,"15":"Dieu dit à Abraham: 'Tu n'appelleras plus ta femme Saraï, son nom sera désormais Sara:"
,"16":"je la bénirai et je te donnerai par elle un fils. Je la bénirai et elle deviendra, non pas une, mais des nations: des peuples et des rois sortiront d'elle.'"
,"17":"Abraham tomba la face contre terre et se mit à rire; il se disait: 'Est-ce qu'un homme âgé de cent ans peut donner la vie à un fils? Et Sara, une femme de quatre-vingt-dix ans, peut-elle encore enfanter?'"
,"18":"Abraham dit à Dieu: 'Si seulement Ismaël pouvait vivre pour te servir.'"
,"19":"Mais Dieu lui répondit: 'Pas du tout! Sara, ta femme, t'enfantera un fils et tu lui donneras le nom d'Isaac. J'établirai mon alliance avec lui, une alliance perpétuelle, pour être son Dieu et celui de sa descendance après lui."
,"20":"Cependant, je t'ai entendu au sujet d'Ismaël. Oui, je le bénirai, je le rendrai fécond, je le multiplierai encore et encore, il sera le père de douze princes et je ferai de lui une grande nation."
,"21":"Mais l'an prochain à cette date, Sara t'enfantera Isaac et c'est avec lui que j'établirai mon alliance.'"
,"22":"Ayant ainsi terminé ce qu'il avait à dire à Abraham, Dieu remonta."
,"23":"Abraham prit Ismaël son fils, tous ceux qui étaient nés dans sa maison et tous ceux qu'il avait achetés à prix d'argent, en un mot tous ceux qui habitaient sa maison, et il les circoncit ce jour-là même, comme Dieu le lui avait ordonné."
,"24":"Abraham avait quatre-vingt-dix-neuf ans quand il fut circoncis;"
,"25":"son fils Ismaël avait treize ans quand il fut circoncis."
,"26":"Ce jour-là même, Abraham et son fils Ismaël furent circoncis."
,"27":"Les gens de sa maison, ceux qui étaient nés dans la maison, comme ceux qu'il avait achetés à un étranger à prix d'argent, tous furent circoncis avec lui."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Yahvé apparut à Abraham près du chêne de Mambré. Il était alors assis à l'entrée de sa tente, au plus chaud du jour:"
,"2":"quand il leva les yeux, il y avait trois hommes debout non loin de lui. Dès qu'il les vit, il courut vers eux de l'entrée de sa tente et il se prosterna. "
,"3":"Il dit: 'Mon Seigneur, si j'ai trouvé grâce à tes yeux, ne passe pas sans t'arrêter!"
,"4":"Qu'on apporte de l'eau! Vous vous laverez les pieds et vous vous étendrez sous l'arbre."
,"5":"Je vais chercher un morceau de pain, vous vous remettrez et ensuite vous reprendrez votre route: c'est bien pour cela que vous êtes venus vers votre serviteur.' Ils lui dirent alors: 'Fais comme tu le dis.'"
,"6":"Abraham courut à la tente près de Sara et lui dit: 'Vite! Trois mesures de belle farine, pétris-la et fais des galettes!'"
,"7":"Abraham courut ensuite vers le troupeau, il prit un veau tendre et bon, il le donna au serviteur et celui-ci se dépêcha de le préparer."
,"8":"Il prit du lait caillé, du lait, le veau qu'on avait préparé, et il mit le tout devant eux. Pendant qu'ils mangeaient, lui se tenait debout près d'eux sous l'arbre."
,"9":"Ils lui dirent: 'Où est Sara, ta femme?' Il répondit: 'Elle est dans la tente.'"
,"10":"Yahvé dit: 'Je reviendrai vers toi à la même époque, et alors Sara, ta femme, aura un fils.' Sara écoutait à l'entrée de la tente et se trouvait derrière lui."
,"11":"Abraham et Sara étaient vieux, avancés en âge, et Sara avait cessé d'avoir ce qui arrive aux femmes."
,"12":"Alors Sara rit en elle-même et se dit: 'Maintenant que je suis usée, vais-je encore faire l'amour avec mon mari qui est si vieux?'"
,"13":"Yahvé dit à Abraham: 'Pourquoi Sara a-t-elle ri en disant: Je suis bien trop vieille pour avoir un enfant!"
,"14":"Y a-t-il quelque chose d'impossible à Yahvé? L'an prochain, à cette même époque, je reviendrai vers toi et Sara aura un fils.'"
,"15":"Sara nia et dit: 'Je n'ai pas ri', car elle avait peur. Mais il lui dit: 'Si, tu as ri!'"
,"16":"Les hommes se levèrent et se dirigèrent du côté de Sodome; Abraham marchait avec eux pour les reconduire."
,"17":"Yahvé dit alors: 'Je ne peux pas cacher à Abraham ce que je vais faire."
,"18":"Abraham en effet va devenir une nation grande et puissante, c'est en lui que seront bénies toutes les nations de la terre."
,"19":"Je l'ai choisi pour qu'il ordonne à ses fils et à sa descendance après lui de suivre le chemin de Yahvé en pratiquant la justice et le droit: ainsi Yahvé réalisera pour Abraham ce qu'il lui a promis.'"
,"20":"Alors Yahvé dit: 'Comme il est grand le cri qui s'élève contre Sodome et Gomorrhe! Comme leur péché est grave!"
,"21":"Je vais descendre et voir si vraiment ils ont fait tout ce qui remonte jusqu'à moi, et qui crie contre eux. S'il n'en est pas ainsi, je le saurai bien.'"
,"22":"Les hommes partirent de là et se dirigèrent vers Sodome, mais Yahvé se tenait encore debout devant Abraham."
,"23":"Abraham vint à lui: 'Vraiment! Vas-tu faire mourir le juste avec le méchant?"
,"24":"Peut-être y a-t-il cinquante justes dans la ville: vas-tu détruire et ne pas pardonner à la ville à cause de ces cinquante justes?"
,"25":"Tu ne peux pas agir de cette façon-là: faire mourir le juste avec le méchant, traiter le juste comme le méchant. Non! Tu ne peux pas! Est-ce que Celui qui juge toute la terre ne pratiquerait plus la justice?'"
,"26":"Yahvé dit: 'Si je trouve cinquante justes parmi les habitants de Sodome, je pardonnerai à toute la ville à cause d'eux.'"
,"27":"Abraham reprit: 'Quelle audace ai-je eue de parler à mon Seigneur, moi qui ne suis que poussière et cendre."
,"28":"Peut-être manquera-t-il cinq justes pour en avoir cinquante: s'il en manquait cinq, détruirais-tu toute la ville?' Yahvé répondit: 'Je ne détruirai pas la ville si je trouve quarante cinq justes.'"
,"29":"Abraham reprit: 'Peut-être n'y en aura-t-il que quarante!' Yahvé répondit: 'Je ne détruirai pas s'il y en a quarante.'"
,"30":"Abraham insista: 'Que mon Seigneur ne se mette pas en colère si je parle encore. Peut-être ne s'en trouvera-t-il que trente!' Yahvé répondit: 'Je ne détruirai pas si j'y trouve les trente.'"
,"31":"Abraham continua: 'Quelle audace ai-je encore de parler à mon Seigneur! Peut-être n'y en aura-t-il que vingt!' Yahvé répondit: 'Pour vingt, je ne détruirais pas.'"
,"32":"Abraham dit: 'Que mon Seigneur ne se mette pas en colère, je ne parlerai plus qu'une seule fois: peut-être n'y aura-t-il que dix justes!' Yahvé répondit: 'Rien que pour ces dix, je ne détruirais pas.'"
,"33":"Quand il eut fini de parler avec Abraham, Yahvé s'en alla, et Abraham retourna chez lui."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Les deux anges arrivèrent le soir à Sodome. Lot était assis à la porte de Sodome. Lorsqu'il les vit, il se leva pour aller à leur rencontre et se prosterna la face contre terre."
,"2":"Il dit: 'Je vous en prie, Mes seigneurs, venez à la maison de votre serviteur pour y passer la nuit. Vous pourrez vous laver les pieds, puis demain matin vous vous lèverez et vous continuerez votre chemin.' Ils dirent: 'Non, nous passerons la nuit sur la place.'"
,"3":"Mais il insista tellement qu'ils vinrent chez lui et entrèrent dans sa maison. Il leur prépara un repas, il fit cuire des pains sans levain et ils mangèrent."
,"4":"Ils n'étaient pas encore couchés quand les hommes de la ville, les hommes de Sodome, entourèrent la maison depuis le plus jeune jusqu'au plus vieux. Toute la population était là."
,"5":"Ils appelèrent Lot et lui dirent: 'Où sont ces hommes qui sont venus chez toi pour cette nuit? Fais-les sortir et donne-les nous pour que nous abusions d'eux.'"
,"6":"Lot sortit vers eux à l'entrée de sa maison et referma la porte derrière lui."
,"7":"Il leur dit: 'Je vous en prie, mes frères, ne commettez pas cette mauvaise action."
,"8":"Voyez, j'ai deux filles, elles sont vierges. Je veux bien vous les faire sortir et vous les traiterez comme bon vous semblera. Mais ne faites rien à ces hommes puisqu'ils sont venus s'abriter chez moi.'"
,"9":"Ils lui dirent: 'Va-t'en!' et ils ajoutèrent: 'En voilà un qui est venu résider chez nous, et il voudrait faire la loi! Nous allons te faire encore plus de mal qu'à eux.',Ils pressaient Lot fortement et s'avançaient pour briser sa porte, "
,"10":"mais les deux hommes qui étaient dans la maison étendirent la main et firent rentrer Lot dans la maison, puis ils refermèrent la porte."
,"11":"Et ils brouillèrent la vue de tous ces gens qui se pressaient devant la maison, du plus petit jusqu'au plus grand, si bien qu'ils ne trouvaient plus l'entrée."
,"12":"Alors ces hommes dirent à Lot: 'Qui as-tu encore ici? Un gendre? Fais donc sortir d'ici tes fils et tes filles ainsi que tout ce qui est à toi dans la ville,"
,"13":"car nous allons détruire cet endroit. Les plaintes qui montent d'ici auprès de Yahvé sont énormes, et Yahvé nous a envoyés pour la détruire.'"
,"14":"Lot alla parler à ses gendres, à ceux qui allaient épouser ses filles. Il leur dit: 'Levez-vous! Sortez d'ici, car Yahvé va détruire la ville.' Mais ses gendres prirent cela pour une plaisanterie."
,"15":"Quand l'aurore se leva, les anges pressèrent Lot et lui dirent: 'Lève-toi, prends ta femme et tes deux filles qui sont ici, sinon tu vas périr dans le châtiment de la ville.'"
,"16":"Comme il hésitait encore, les hommes le prirent par la main; ils prirent aussi par la main sa femme et ses deux filles, parce que Yahvé avait pitié de lui. Ils le firent sortir et le conduisirent hors de la ville."
,"17":"Quand ils furent aux portes de la ville, ils lui dirent: 'Sauve-toi, si tu tiens à la vie. Ne regarde pas derrière toi. Ne t'arrête nulle part dans cette plaine. Sauve-toi vers la montagne, sinon c'est la mort!'"
,"18":"Lot répondit: 'Non, mon Seigneur, je t'en prie!"
,"19":"Tu te préoccupes beaucoup pour ton serviteur et tu as eu la bonté de me sauver la vie, mais vois que je ne peux me sauver vers la montagne, le malheur m'atteindra avant et je mourrai."
,"20":"Je voudrais me réfugier dans cette ville toute proche. Tu vois qu'elle est sans importance; permets que j'y trouve le salut et la vie, puisqu'elle est sans importance.'"
,"21":"L'autre lui répondit: 'Une fois encore, je t'accorde ce que tu me demandes: je ne détruirai pas la ville dont tu parles."
,"22":"Dépêche-toi, sauve-toi là-bas, je ne peux rien faire tant que tu n'y es pas arrivé.' C'est pour cela qu'on a donné à la ville le nom de Soar (c'est-à-dire: sans importance)."
,"23":"Le soleil allait se lever sur la terre lorsque Lot arriva à Soar."
,"24":"Alors Yahvé fit pleuvoir sur Sodome et sur Gomorrhe du soufre et du feu qui venaient du haut des cieux, de chez Yahvé."
,"25":"Il anéantit ces villes et toute la région, ainsi que tous les habitants de ces villes et ce qui poussait sur le sol."
,"26":"Comme la femme de Lot regardait derrière elle, elle devint une statue de sel."
,"27":"Abraham se rendit de bon matin au lieu où il s'était tenu devant Yahvé."
,"28":"Il regarda du côté de Sodome et de Gomorrhe, du côté de la plaine, et il vit que de la terre montait une fumée semblable à la fumée d'une fournaise."
,"29":"Ainsi, quand Dieu détruisit les villes de la région, Dieu se souvint d'Abraham: il épargna Lot alors que la catastrophe anéantissait les villes dans lesquelles Lot avait habité."
,"30":"De Soar, Lot vint s'établir dans la montagne avec ses deux filles, car il ne se sentait pas en sûreté a Soar. Il s'installa dans une grotte avec ses deux filles."
,"31":"L'aînée dit à la plus jeune: 'Notre père est âgé et il n'y a pas d'autre homme dans le pays pour s'unir à nous comme cela se fait partout."
,"32":"Faisons donc boire du vin à notre père et couchons avec lui. Ainsi nous donnerons une descendance à notre père.'"
,"33":"Elles enivrèrent leur père et, cette nuit-là, l'aînée s'en alla coucher avec son père. Lui ne se rendit compte de rien, ni quand elle se coucha, ni quand elle se leva."
,"34":"Le lendemain l'aînée dit à la plus jeune: 'Hier j'ai couché avec mon père, enivrons-le cette nuit encore et tu coucheras avec lui. Ainsi nous donnerons une descendance à notre père.'"
,"35":"Cette nuit-là encore elles enivrèrent leur père, et la plus jeune vint coucher avec lui. Il ne se rendit compte de rien, ni quand elle se coucha, ni quand elle se leva."
,"36":"C'est ainsi que les deux filles de Lot furent enceintes de leur père."
,"37":"L'aînée enfanta un fils qu'elle appela Moab: c'est le père des Moabites qui existent encore aujourd'hui."
,"38":"La plus jeune aussi enfanta un fils et elle lui donna le nom de Ben-Ammi: c'est le père des Ammonites qui existent encore aujourd'hui."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Abraham partit pour le pays du Négueb et s'installa entre Qadesh et Chour. Ensuite il vint séjourner à Guérar."
,"2":"Comme Abraham avait dit de sa femme Sara: 'C'est ma soeur', Abimélek roi de Guérar la fit enlever."
,"3":"Mais dans un songe, durant la nuit, Dieu visita Abimélek et lui dit: 'Tu vas mourir à cause de la femme que tu as prise, car c'est une femme mariée.'"
,"4":"Abimélek, qui ne s'était pas encore approché d'elle, répondit: 'Mon Seigneur, feras-tu mourir un païen quand il est innocent?"
,"5":"N'est-ce pas lui qui m'a dit: C'est ma soeur? Et elle-même l'a confirmé en disant: C'est mon frère. C'est donc avec une bonne conscience et des mains pures que j'ai agi de la sorte.'"
,"6":"Dieu lui répondit en songe: 'Moi aussi, je sais que tu as agi en bonne conscience. Aussi je t'ai retenu de pécher et je n'ai pas permis que tu la touches."
,"7":"Rends donc maintenant cette femme à son mari; c'est un prophète, et il intercédera pour toi afin que tu vives. Mais si tu ne la rends pas, tu dois bien savoir que tu mourras, toi et toute ta famille.'"
,"8":"De bon matin Abimélek se leva. Il appela tous ses serviteurs et leur raconta discrètement ce qui s'était passé. Ses hommes furent saisis d'une grande peur."
,"9":"Puis Abimélek appela Abraham et lui dit: 'Que nous as-tu fait? Quel péché ai-je commis contre toi pour que tu m'aies exposé à une si grande faute, moi et mon royaume? Tu m'as fait des choses qui ne se font pas.'"
,"10":"Abimélek ajouta: 'A quoi pensais-tu en agissant ainsi?'"
,"11":"Abraham lui répondit: 'Je m'étais dit: Si les gens de ce pays n'ont pas la crainte de Dieu, ils me tueront à cause de ma femme."
,"12":"De plus, elle est bien ma soeur: elle est fille de mon père, mais non de ma mère, et elle est devenue ma femme."
,"13":"Aussi, lorsque les dieux me firent errer loin de la maison paternelle, je lui ai dit: Je t'en supplie, en tout endroit où nous nous arrêterons, dis que je suis ton frère.'"
,"14":"Alors Abimélek prit du petit bétail et du gros bétail, des serviteurs et des servantes, et il les donna à Abraham en même temps qu'il lui rendait sa femme Sara."
,"15":"Abimélek dit encore: 'A présent mon pays est à ta disposition, installe-toi dans le lieu qui te plaira.'"
,"16":"Il dit à Sara: 'Je viens de donner mille pièces d'argent à ton frère. Elles seront comme un bandeau sur les yeux de tous ceux qui sont avec toi: ainsi personne ne dira du mal de toi.'"
,"17":"Abraham intercéda auprès de Dieu, et Dieu guérit Abimélek, ainsi que sa femme et ses servantes, pour qu'elles puissent enfanter."
,"18":"En effet Yahvé avait frappé de stérilité toute la maison d'Abimélek à cause de Sara, la femme d'Abraham."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Yahvé visita Sara comme il l'avait dit et il accomplit envers elle sa promesse."
,"2":"Sara conçut, elle donna un fils à Abraham en sa vieillesse, au temps marqué par Dieu."
,"3":"Abraham donna le nom d'Isaac à ce fils qui lui était né de Sara."
,"4":"Lorsque son fils Isaac fut âgé de huit jours, Abraham le circoncit selon l'ordre de Dieu."
,"5":"A la naissance de son fils Isaac, Abraham avait déjà cent ans."
,"6":"Sara dit alors: 'Dieu m'a bien donné l'occasion de rire, et ceux qui l'apprendront riront aussi à mon sujet.'"
,"7":"Elle ajouta: 'Qui aurait dit à Abraham: Sara allaitera des fils? Et pourtant je lui ai donné un fils dans sa vieillesse.'"
,"8":"L'enfant grandit et fut sevré. Abraham fit un grand festin le jour où Isaac fut sevré."
,"9":"A cette occasion Sara vit comment le fils de l'Egyptienne Agar, le fils qu'elle avait donné à Abraham, s'amusait de son fils Isaac."
,"10":"Elle dit à Abraham: 'Chasse-moi cette servante et son fils; le fils de cette servante ne doit pas hériter avec le mien, avec Isaac.'"
,"11":"Cela déplut beaucoup à Abraham, parce que c'était son garçon."
,"12":"Mais Dieu dit à Abraham: 'Ne te tourmente pas au sujet de ton garçon et de ta servante. Fais donc tout ce que Sara te demande, car c'est le nom d'Isaac que portera ta descendance."
,"13":"Mais je ferai que le fils de ta servante devienne lui aussi une nation puisqu'il est de ta descendance.'"
,"14":"Abraham se leva de bon matin, il prit du pain et une outre d'eau et les donna à Agar. Il mit ensuite l'enfant sur son épaule et la renvoya. Elle partit alors à l'aventure dans le désert de Bersabée."
,"15":"Lorsqu'il n'y eut plus d'eau dans l'outre, elle abandonna l'enfant sous un buisson"
,"16":"et s'assit à la distance d'une portée d'arc. Elle se disait: 'Je ne veux pas voir mourir mon enfant!' Comme elle allait s'assoir en face, l'enfant commença à pleurer et à crier."
,"17":"Dieu entendit la voix de l'enfant et l'Ange de Dieu, du haut du ciel, appela Agar. Il lui dit: 'Qu'as-tu Agar? N'aie pas peur, Dieu a entendu la voix de l'enfant, de l'endroit où il se trouve."
,"18":"Lève-toi, prends ton enfant et tiens-le ferme de la main. Je ferai de lui une grande nation.'"
,"19":"Alors Dieu lui ouvrit les yeux et elle aperçut un puits. Elle alla remplir d'eau son outre et fit boire l'enfant."
,"20":"Dieu veilla sur la croissance de cet enfant; il séjourna au désert et devint tireur à l'arc."
,"21":"Il séjourna au désert de Paran et sa mère prit pour lui une femme au pays d'Egypte."
,"22":"En ces jours-là, Abimélek et Pikol, le chef de son armée, vinrent trouver Abraham et lui dirent: 'Dieu est avec toi dans tout ce que tu fais."
,"23":"Jure-moi donc maintenant sur Dieu, de ne tromper ni moi, ni ma famille, ni ma descendance, et d'avoir pour moi et pour ce pays où tu séjournes la même attitude bienveillante que j'ai eue pour toi.'"
,"24":"Abraham répondit: 'Je le jure.'"
,"25":"Cependant Abraham fit des reproches à Abimélek au sujet d'un puits que les serviteurs d'Abimélek avaient pris."
,"26":"Abimélek répondit: 'Je ne sais pas qui a fait cela; tu ne m'as rien dit jusqu'à ce jour, et moi de mon côté je n'en savais rien.'"
,"27":"Abraham prit du petit bétail et du gros bétail, il les donna à Abimélek et tous deux conclurent une alliance."
,"28":"Sur le petit bétail, Abraham mit de côté sept brebis."
,"29":"Abimélek lui demanda donc: 'Pourquoi as-tu mis ces sept brebis de côté?'"
,"30":"Abraham répondit: 'C'est pour que tu acceptes de ma main ces sept brebis et qu'elles soient un témoignage que c'est bien moi qui ai creusé ce puits.'"
,"31":"C'est pourquoi on a appelé cet endroit Bersabée (c'est-à-dire: Puits des Sept ou encore: Puits du Serment), car c'est là qu'ils avaient tous les deux prêté serment."
,"32":"Ils conclurent donc une alliance à Bersabée, puis Abimélek et Pikol, le chef de son armée, se levèrent et retournèrent au pays des Philistins."
,"33":"Abraham planta un arbre à Bersabée et il y invoqua le nom de Yahvé, le Dieu éternel."
,"34":"Abraham séjourna longtemps encore au pays des Philistins."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Par la suite Dieu voulut éprouver Abraham; il appela: 'Abraham!' Celui-ci répondit: 'Me voici.'"
,"2":"Dieu lui dit: 'Prends Isaac, ton fils unique, celui que tu aimes, et va-t'en au pays de Moriya. Là tu l'offriras en sacri fice sur l'une des montagnes que je te montrerai.'"
,"3":"Abraham se leva de bon matin et sella son âne; il prit avec lui deux de ses serviteurs et son fils Isaac et l'on fendit le bois pour le sacrifice. Puis il marcha vers l'endroit que Dieu lui avait indiqué."
,"4":"Le troisième jour Abraham put voir l'endroit au loin."
,"5":"Alors Abraham dit à ses serviteurs: 'Restez ici avec l'âne. Moi et l'enfant, nous irons là-bas pour adorer, et nous reviendrons ensuite vers vous.'"
,"6":"Abraham prit le bois pour le sacrifice et le chargea sur son fils Isaac. Il prit ensuite dans sa main le feu et le couteau, et tous deux marchèrent ensemble."
,"7":"Isaac se tourna vers son père Abraham, il lui dit: 'Mon père!' Celui-ci répondit: 'Je t'écoute, mon fils.' Isaac dit: 'Nous avons là le feu et le bois, mais où est l'agneau pour le sacri fice par le feu?'"
,"8":"Abraham répondit: 'Dieu pourvoira à l'agneau pour le sacrifice, mon fils.' Et ils continuèrent tous deux leur chemin."
,"9":"Lorsqu'ils arrivèrent à l'endroit que Dieu avait indiqué, Abraham construisit l'autel. Il prépara le bois, attacha son fils Isaac et le plaça sur l'autel par-dessus le bois."
,"10":"Puis il étendit la main et prit le couteau pour égorger son fils."
,"11":"Alors l'Ange de Yahvé l'appela du haut des cieux: 'Abraham! Abraham!' Il répondit: 'Me voici!'"
,"12":"L'Ange lui dit: 'N'étends pas la main et ne fais rien à l'enfant, car maintenant je sais que tu crains Dieu: tu ne m'as pas refusé ton fils, ton unique.'"
,"13":"Abraham leva les yeux et regarda: il y avait là un bélier retenu par les cornes dans un buisson. Abraham alla donc prendre le bélier et il l'offrit en sacrifice par le feu à la place de son fils."
,"14":"Abraham appela cet endroit 'Yahvé pourvoira'; c'est pourquoi on dit encore aujourd'hui: 'Sur sa montagne, Yahvé pourvoira.'"
,"15":"Une seconde fois l'Ange de Yahvé appela Abraham du haut des cieux."
,"16":"Il lui dit: 'Je l'ai juré par moi-même - oracle de Yahvé - puisque tu as fait cela et que tu ne m'as pas refusé ton fils, ton unique,"
,"17":"je te bénirai et je multiplierai ta descendance comme les étoiles du ciel, comme le sable du bord de mer. Ta descendance l'emportera sur ses ennemis."
,"18":"Toutes les nations de la terre se verront bénies en ta descendance parce que tu as obéi à ma voix.'"
,"19":"Abraham revint alors vers ses serviteurs: ils se levèrent et repartirent ensemble pour Bersabée. Abraham demeura ensuite à Bersabée."
,"20":"Après cela on annonça à Abraham cette nouvelle: 'Voici que Milka a donné elle aussi des fils à ton frère Nahor:"
,"21":"Ous son premier-né, Bouz son frère, et Kémouel père d'Aram,"
,"22":"Késed, Hazo, Pildach, Yidlaf et Bétuel."
,"23":"Bétuel est le père de Rébecca. Tels sont les huit fils que Milka donna à Nahor, le frère d'Abraham."
,"24":"Sa concubine s'appelait Réouma, c'est elle qui enfanta Tébakh, Gakham, Takhach et Mahaka."
}`)
	CurrentBook.AddChapter(23, `{
"1":"Sara atteignit l'âge de cent vingt-sept ans."
,"2":"Elle mourut à Kiryat-Arba, c'est-à-dire Hébron, au pays de Canaan. Abraham vint pleurer Sara et en fit le deuil."
,"3":"Laissant là le corps, Abraham alla parler aux fils de Heth. Il leur dit:"
,"4":"'Je ne suis qu'un étranger résidant au milieu de vous, mais donnez-moi une tombe chez vous et qu'elle soit ma propriété: j'y enterrerai ma défunte.'"
,"5":"Les fils de Heth répondirent ainsi à Abraham:"
,"6":"'Ecoute-nous, mon seigneur, tu es un prince de Dieu au milieu de nous. Dépose donc ta défunte dans celle de nos tombes que tu voudras; personne parmi nous ne te refusera sa tombe pour l'enterrer.'"
,"7":"Abraham se leva et s'inclina devant les gens du pays, devant les fils de Heth."
,"8":"Puis il s'adressa à eux et leur dit: 'Si vous êtes d'accord pour qu'on enterre celle que j'ai perdue, écoutez-moi et insistez pour moi auprès d'Efron, fils de Sokhar,"
,"9":"pour qu'il me cède la grotte de Makpéla qui lui appartient et qui se trouve au bout de son champ. Qu'il me la donne contre sa valeur en argent, et que cette tombe devienne ma propriété au milieu de vous.'"
,"10":"Efron était assis au milieu des fils de Heth. Efron le Hittite répondit à Abraham de manière à être entendu des fils de Heth, de tous ceux qui passaient par la porte de la ville:"
,"11":"'Non, mon seigneur, écoute-moi: je te donne le champ et aussi la grotte qui s'y trouve. Je te fais ce don devant les fils de mon peuple: enterre ta défunte.'"
,"12":"Abraham s'inclina devant les gens du pays"
,"13":"et il dit à Efron, de manière à être entendu des gens du pays: 'Ecoute-moi, s'il te plaît. Je donne l'argent pour le champ; accepte-le de ma main. Ainsi je pourrai enterrer celle que j'ai perdue.'"
,"14":"Efron répondit à Abraham:"
,"15":"'Ecoute-moi, mon seigneur, quelle affaire entre toi et moi ce terrain qui ne vaut que quatre cents pièces d'argent? Enterres-y ta défunte!'"
,"16":"Abraham écouta Efron, et il pesa pour Efron la somme qu'il avait dite en présence des fils de Heth, soit quatre cents pièces d'argent ayant cours chez les marchands."
,"17":"Ainsi le champ d'Efron qui se trouve à Makpéla en face de Mambré, le champ et la grotte qui s'y trouve, avec tous les arbres qui sont dans le champ sur toute sa surface,"
,"18":"furent cédés à Abraham devant les fils de Heth, devant tous ceux qui passaient par la porte de la ville."
,"19":"Alors Abraham prit Sara sa femme et l'enterra dans la grotte du champ de Makpéla face à Mambré, c'est-à-dire Hébron, au pays de Canaan."
,"20":"Le champ et la grotte qui s'y trouve furent cédés par les fils de Heth à Abraham comme propriété funéraire."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Abraham vieillissait, il avançait en âge et Yahvé l'avait béni en toutes choses."
,"2":"Abraham dit au plus vieux serviteur de sa maison, qui était l'intendant de tous ses biens: 'Mets donc ta main sous ma cuisse,"
,"3":"et jure-moi par Yahvé Dieu du ciel et Dieu de la terre, de ne pas prendre comme femme pour mon fils, une fille des Cananéens au milieu desquels j'habite."
,"4":"C'est dans mon pays et dans ma parenté que tu iras chercher une femme pour mon fils Isaac.'"
,"5":"Son serviteur lui répondit: 'La femme ne voudra peut-être pas me suivre jusqu'ici, dans ce pays. Devrai-je alors reconduire ton fils au pays que tu as quitté?'"
,"6":"Abraham lui dit: 'Garde-toi bien de reconduire mon fils là-bas."
,"7":"Yahvé, le Dieu du ciel, qui m'a pris dans la maison de mon père, dans mon pays natal, qui m'a parlé et m'a juré de donner ce pays à ma descendance, lui- même enverra son ange devant toi pour que tu trouves là-bas une femme pour mon fils."
,"8":"Si la femme ne veut pas te suivre, tu seras quitte du serment que tu me prêtes aujourd'hui, mais en aucun cas tu ne reconduiras mon fils là-bas.'"
,"9":"Le serviteur mit donc sa main sous la cuisse d'Abraham son maître et lui prêta ce serment."
,"10":"Le serviteur prit dix chameaux parmi les chameaux de son maître et se mit en route. Il emportait avec lui tout ce qu'il y avait de meilleur chez son maître. Puis il se leva et s'en alla jusqu'à la ville de Nahor, au pays d'Aram-Naharaïm."
,"11":"Il fit agenouiller ses chameaux hors de la ville, à côté d'un puits: c'était à la tombée du jour, à l'heure où les femmes s'en vont puiser."
,"12":"Alors il dit: 'Yahvé, Dieu de mon maître Abraham, donne-moi de faire aujourd'hui une bonne rencontre, sois bon pour mon maître Abraham!"
,"13":"Je vais rester là près de la source d'eau, puisqu'à cette heure les filles de la ville sortent pour puiser de l'eau."
,"14":"Je vais dire à l'une d'elles: Penche ta cruche pour que je boive. Si elle me répond: Bois, et je donnerai aussi à boire à tes chameaux, fais que cette jeune fille soit celle que tu as choisie pour ton serviteur Isaac. Ainsi je saurai que tu as montré ta bonté à mon maître.'"
,"15":"Il parlait encore lorsque sortit Rébecca, portant sa cruche sur l'épaule. Elle était la fille de Bétuel, le fils que Milka avait donné à Nahor, frère d'Abraham."
,"16":"La jeune fille était très belle, elle était vierge et aucun homme ne s'était approché d'elle. Elle descendit à la source, remplit sa cruche et remonta."
,"17":"Le serviteur d'Abraham courut alors à sa rencontre et lui dit: 'Laisse-moi donc boire un peu d'eau de ta cruche.'"
,"18":"Elle dit: 'Que mon seigneur boive', et penchant aussitôt sa cruche sur sa main, elle lui donna à boire."
,"19":"Lorsqu'elle eut fini de lui donner à boire, elle ajouta: 'Je puiserai encore pour tes chameaux jusqu'à ce qu'ils aient fini de boire.'"
,"20":"Elle se dépêcha donc de vider sa cruche dans l'abreuvoir, elle courut de nouveau au puits pour puiser et puiser encore pour tous ses chameaux."
,"21":"L'homme la regardait en silence: il se demandait si Yahvé avait fait réussir son voyage."
,"22":"Lorsque les chameaux eurent fini de boire, l'homme prit un anneau d'or pesant environ six grammes, qu'il mit à son nez, et pour ses bras, deux bracelets d'or d'un poids de soixante grammes."
,"23":"Il lui dit alors: 'De qui es-tu la fille? Dis-le moi s'il te plaît. Y a-t-il dans la maison de ton père un endroit où nous pourrions passer la nuit?'"
,"24":"Elle répondit: 'Je suis la fille de Bétuel, le fils que Milka a donné à Nahor.'"
,"25":"Elle ajouta: 'Il y a beaucoup de paille et de fourrage chez nous, et de la place pour passer la nuit.'"
,"26":"L'homme se mit alors à genoux pour adorer Yahvé."
,"27":"Il s'écria: 'Béni soit Yahvé, le Dieu de mon maître Abraham! Il n'a pas manqué à sa bienveil lance et sa fidélité envers mon maître. Oui, Yahvé a fait que ma route aboutisse à la maison de la famille de mon maître.'"
,"28":"Pendant ce temps la jeune fille courait à la maison de sa mère pour raconter toute l'affaire."
,"29":"Or Rébecca avait un frère qui s'appelait Laban. Laban sortit et courut vers la source à la rencontre de l'homme."
,"30":"Il avait vu en effet l'anneau et les bracelets aux bras de sa soeur, il avait entendu Rébecca sa soeur, qui racontait: 'Voici comment m'a parlé cet homme'. Il partit donc à la rencontre de l'homme qui se tenait toujours près des chameaux, à côté de la source,"
,"31":"et il lui dit: 'Sois chez nous comme un homme béni de Yahvé! Pourquoi restes-tu dehors? J'ai débarrassé la maison et j'y ai fait de la place pour les chameaux.'"
,"32":"L'homme entra donc dans la maison et déchargea les chameaux. On donna de la paille et du fourrage aux chameaux, et on apporta pour l'homme et pour ceux qui étaient avec lui, de l'eau pour se laver les pieds."
,"33":"Ensuite on lui présenta de quoi manger, mais il dit: 'Je ne mangerai pas tant que je n'aurai pas dit ce que j'ai à dire.' On lui répondit: 'Parle!'"
,"34":"Il dit: 'Je suis le serviteur d'Abraham."
,"35":"Yahvé a comblé mon maître de ses bénédictions et il est devenu riche. Yahvé lui a donné du petit bétail et du gros bétail, de l'argent, de l'or, des serviteurs et des servantes, des chameaux et des ânes."
,"36":"Et Sara, la femme de mon maître, alors qu'elle était déjà vieille, a donné un fils à mon maître et celui-ci lui donne tout ce qui lui appartient."
,"37":"Or mon maître m'a fait prêter ce serment: Tu ne prendras pas comme femme pour mon fils une fille de ces Cananéens au milieu desquels j'habite,"
,"38":"mais tu iras dans la maison de mon père, dans ma parenté, et là tu trouveras une femme pour mon fils."
,"39":"J'ai dit alors à mon maître: La femme ne voudra peut-être pas me suivre."
,"40":"Mais il m'a répondu: Yahvé, celui que j'ai servi, enverra son ange avec toi et fera réussir ton voyage. Tu prendras pour mon fils une femme dans ma parenté, dans la maison de mon père."
,"41":"Dès le moment où tu seras arrivé dans ma famille, tu seras quitte de ton engagement. Et même si l'on te refuse cette femme, tu seras quitte de ton serment."
,"42":"Aussi, quand je suis arrivé aujourd'hui à la source, j'ai dit: Yahvé, Dieu de mon maître Abraham, accorde-moi la réussite de ce voyage que j'ai entrepris."
,"43":"Je vais rester là près de la source, et je vais dire à l'une des jeunes filles qui sortent pour puiser: Veux-tu me donner un peu d'eau pour boire, s'il te plaît."
,"44":"Et si la jeune fille me répond: Bois, et je donnerai aussi à boire à tes chameaux, fais que cette jeune fille soit la femme que Yahvé a destinée au fils de mon maître."
,"45":"Je parlais encore en moi-même lorsque Rébecca est sortie de la ville, sa cruche sur l'épaule. Quand elle est descendue à la source pour puiser, je lui ai dit: Donne-moi à boire, s'il te plaît."
,"46":"Vite, elle a descendu la cruche de son épaule et m'a dit: Bois, je donnerai aussi à boire à tes chameaux. J'ai bu et elle a donné à boire à mes chameaux."
,"47":"Je l'ai interrogée: De qui es-tu la fille? Elle m'a répondu: Je suis la fille de Bétuel fils de Nahor, celui que lui a enfanté Milka. Alors j'ai mis l'anneau à sa narine et les bracelets à ses bras."
,"48":"Puis je me suis agenouillé et j'ai adoré Yahvé. J'ai béni Yahvé, Dieu de mon maître Abraham, qui m'a mis sur le bon chemin et m'a fait trouver pour son fils la fille du frère de mon maître."
,"49":"Maintenant donc, si vous êtes bien disposés à mon égard et voulez faire une faveur à mon maître, dites-le-moi. Sinon, dites-le-moi aussi et j'irai voir ailleurs.'"
,"50":"Laban et Bétuel répondirent: 'Cette affaire vient de Yahvé, nous n'avons rien à ajouter."
,"51":"Voici Rébecca si tu la veux, prends-la et va. Qu'elle soit la femme du fils de ton maître, comme Yahvé l'a décidé.'"
,"52":"Lorsque le serviteur d'Abraham entendit ces paroles, il se prosterna à terre devant Yahvé."
,"53":"Puis le serviteur sortit des bijoux d'argent et des bijoux d'or, ainsi que des vêtements, et il les donna à Rébecca. Il fit également de magnifiques cadeaux à son frère et à sa mère."
,"54":"Lui et les hommes qui étaient avec lui mangèrent, burent, et restèrent là pour la nuit. Lorsqu'ils se levèrent de bon matin, le serviteur dit: 'Laissez-moi partir vers mon maître.' "
,"55":"Le frère et la mère de Rébecca lui répondirent: 'Que la jeune fille reste avec nous quelques jours encore, une dizaine de jours, après quoi elle partira.'"
,"56":"Le serviteur leur dit: 'Ne me retardez pas maintenant que Yahvé a fait réussir mon voyage. Laissez-moi partir pour que je retourne vers mon maître.'"
,"57":"Ils dirent: 'Appelons la jeune fille et demandons-lui son avis.'"
,"58":"Ils appelèrent donc Rébecca et lui dirent: 'Veux-tu partir avec cet homme?' Elle répondit: 'Oui.'"
,"59":"Ils laissèrent donc partir leur soeur Rébecca et sa nourrice, avec le serviteur d'Abraham et ses compagnons."
,"60":"Ils bénirent Rébecca avec ces mots: 'O notre soeur! puisses-tu devenir des milliers de myriades, et que ta descendance s'empare des places fortes de tes ennemis!'"
,"61":"Rébecca se leva avec ses servantes, elles montèrent sur les chameaux et suivirent l'homme. C'est ainsi que le serviteur ramena avec lui Rébecca."
,"62":"Isaac revenait du puits de Lahaï-Roï, car il habitait au Négueb."
,"63":"Comme Isaac sortait pour se promener dans la campagne, à la tombée du jour, il leva les yeux et vit des chameaux qui arrivaient."
,"64":"Rébecca elle aussi leva les yeux, et à la vue d'Isaac elle sauta en bas de son chameau."
,"65":"Elle dit au serviteur: 'Qui est cet homme qui vient à travers champs à notre rencontre?' Le serviteur répondit: 'C'est mon maître.' Alors elle prit son voile et s'en couvrit le visage."
,"66":"Le serviteur raconta à Isaac tout ce qu'il avait fait,"
,"67":"après quoi Isaac fit entrer Rébecca dans la tente qui avait appartenu à Sara sa mère. Il la prit, elle devint sa femme et il l'aima. Isaac se consola ainsi de la mort de sa mère."
}`)
	CurrentBook.AddChapter(25, `{
"1":"Abraham prit encore une femme du nom de Kétoura."
,"2":"Elle lui donna des fils: Zimran, Yokchan, Médan, Madian, Yichbak et Chouah."
,"3":"Yokchan engendra Chéba et Dédan; les fils de Dédan furent les Achourites, les Létouchites et les Léoumites."
,"4":"Les fils de Madian sont Efa, Efer, Hanok, Abida, Eldaa. Tous ceux-là sont fils de Kétoura."
,"5":"Abraham légua tous ses biens à Isaac."
,"6":"Quant aux fils de ses concubines, Abraham leur fit des cadeaux et les envoya de son vivant loin de son fils Isaac, à l'est, vers les pays d'Orient."
,"7":"La vie d'Abraham fut de cent soixante- quinze ans en tout."
,"8":"Abraham s'éteignit alors et mourut dans une heureuse vieillesse. Il était très âgé et rassasié de jours quand il fut réuni à ses pères."
,"9":"Ses fils Isaac et Ismaël l'enterrèrent dans la grotte de Makpéla, dans le champ d'Efron, fils de Sokar le Hittite, qui fait face à Mambré."
,"10":"C'est le champ qu'avait acheté Abraham aux fils de Heth. Là furent donc enterrés Abraham et sa femme Sara."
,"11":"Après la mort d'Abraham, Dieu bénit Isaac son fils, lequel demeura non loin du puits de Lahaï-Roï."
,"12":"Voici la descendance d'Ismaël, le fils que l'Egyptienne Agar, servante de Sara, avait donné à Abraham."
,"13":"Voici les noms des fils d'Ismaël, chacun avec sa descendance. Le premier-né d'Ismaël est Nébayot, puis viennent Kédar, Adbéel, Mibsam,"
,"14":"Michma, Douma, Massa,"
,"15":"Hadad, Téma, Yétour, Nafich et Kédma."
,"16":"Ce sont là les fils d'Ismaël, tels sont leurs noms et ceux de leurs villages et de leurs campements: tous les douze, chefs de leurs propres clans."
,"17":"La durée de la vie d'Ismaël fut de cent trente-sept ans, puis il s'éteignit et mourut, et il fut réuni à ses pères."
,"18":"Ses descendants demeurèrent dans la région qui s'étend de Havila jusqu'à Chour, à l'orient de l'Egypte en direction d'Achour; son clan se développa au milieu de ses frères."
,"19":"Voici l'histoire d'Isaac fils d'Abraham: Abraham engendra Isaac,"
,"20":"lequel avait quarante ans lorsqu'il épousa Rébecca. Elle était fille de Bétuel, l'Araméen de Paddan-Aram, et soeur de l'Araméen Laban."
,"21":"Isaac pria Yahvé pour sa femme qui était stérile. Yahvé l'exauça et Rébecca devint enceinte."
,"22":"Comme les jumeaux se heurtaient dans son sein, elle dit: 'S'il en est ainsi, pourquoi vivre?' Elle s'en alla donc consulter Yahvé."
,"23":"Yahvé lui répondit: 'Deux nations sont dans ton ventre et deux peuples s'opposeront dès la sortie de tes entrailles. Un des peuples sera plus fort que l'autre, et l'aîné servira le plus jeune.'"
,"24":"Lorsqu'arriva le jour de la naissance, il y avait bien deux jumeaux dans son ventre."
,"25":"Le premier sortit. Comme il était roux et poilu comme un manteau, on lui donna le nom d'Esaü."
,"26":"Son frère sortit ensuite; sa main tenait le talon d'Esaü, aussi lui donna-t-on le nom de Jacob (c'est-à-dire: 'le talon'). Isaac avait soixante ans à leur naissance."
,"27":"Les garçons grandirent. Esaü devint un très bon chasseur, un homme des champs. Quant à Jacob, c'était un homme tranquille qui aimait rester sous la tente."
,"28":"Isaac aimait Esaü car le gibier était à son goût, mais Rébecca préférait Jacob."
,"29":"Un jour que Jacob préparait un potage, Esaü revint épuisé de la campagne."
,"30":"Esaü dit à Jacob: 'Laisse-moi avaler cette soupe rouge, car je suis épuisé.' C'est pour cela qu'on l'a appelé Edom, ce qui veut dire: Rouge."
,"31":"Jacob lui répondit: 'Vends-moi donc tout de suite tes droits de premier-né.'"
,"32":"'Tu vois que je suis presque mort, lui dit Esaü, à quoi me servirait mon droit de premier-né?'"
,"33":"Jacob lui dit: 'Jure-le moi tout de suite!' Esaü jura et vendit à Jacob ses droits de premier-né."
,"34":"Alors Jacob donna à Esaü du pain et son potage de lentilles. Esaü mangea et il but, puis il se leva et partit. C'est ainsi qu'Esaü méprisa son droit d'aînesse."
}`)
	CurrentBook.AddChapter(26, `{
"1":"Il y avait déjà eu une famine au temps d'Abraham; mais de nouveau la famine revint dans le pays. Isaac partit donc vers Guérar, auprès d'Abimélek roi des Philistins."
,"2":"Yahvé lui apparut et lui dit: 'Ne va pas en Egypte, mais reste dans le pays que je t'indiquerai."
,"3":"Reste dans ce pays, je serai avec toi et je te bénirai. Je donnerai tout ce pays à toi et à ta descendance, car je veux tenir le serment que j'ai fait à ton père Abraham."
,"4":"Je rendrai ta descendance aussi nombreuse que les étoiles du ciel et je lui donnerai tout ce pays. Toutes les nations de la terre se verront bénies en ta descendance,"
,"5":"parce qu'Abraham a écouté ma voix, qu'il m'a obéi et qu'il a observé mes ordres, mes commandements et mes lois.'"
,"6":"Isaac habita donc à Guérar."
,"7":"Quand les gens du pays lui posaient des questions sur sa femme, il répondait: 'C'est ma soeur.' En effet il avait peur de dire: 'C'est ma femme', car il se disait: 'Les gens du pays vont me tuer à cause de Rébecca car elle est très belle.'"
,"8":"Il était là depuis longtemps déjà quand Abimélek, roi des Philistins, qui regardait par sa fenêtre, vit Isaac en train de caresser sa femme Rébecca."
,"9":"Abimélek appela Isaac: 'C'est sûrement ta femme, lui dit-il, pourquoi as-tu dit qu'elle était ta soeur?' Isaac répondit: 'C'est que je risquais de mourir à cause d'elle.'"
,"10":"Abimélek lui dit: 'Regarde ce que tu as fait! Encore un peu et quelqu'un du peuple couchait avec ta femme, et tu nous faisais porter le poids d'une faute.'"
,"11":"Abimélek donna donc cet ordre à tout le peuple: 'Quiconque touchera à cet homme ou à sa femme, sera mis à mort.'"
,"12":"Cette année-là, Isaac sema dans ce pays et récolta cent pour un. Yahvé le bénit"
,"13":"et l'homme devint riche, de plus en plus riche, jusqu'à devenir très riche."
,"14":"Ses troupeaux de petit bétail, ses troupeaux de gros bétail et ses nombreux serviteurs rendaient les Philistins jaloux."
,"15":"Les Philistins bouchèrent donc, en les remplissant de terre, tous les puits que les serviteurs de son père Abraham avaient creusés en son temps."
,"16":"Abimélek lui-même dit à Isaac: 'Va-t'en de chez nous! Tu es devenu trop puissant pour nous.'"
,"17":"Isaac partit donc de cet endroit et il campa dans la vallée de Guérar. C'est là qu'il résida."
,"18":"Isaac creusa de nouveau les puits qu'on avait creusés au temps d'Abraham, son père, et que les Philistins avaient bouchés après la mort d'Abraham. Il leur donna les mêmes noms que son père leur avait donnés."
,"19":"Les serviteurs d'Isaac creusèrent alors dans la vallée et ils y trouvèrent un puits d'eau vive."
,"20":"Les bergers de Guérar vinrent discuter avec les bergers d'Isaac: 'L'eau est à nous!' disaient-ils. Isaac appela donc le puits du nom d'Esék (c'est-à-dire: Dispute), parce qu'ils s'étaient disputés."
,"21":"Ils creusèrent un autre puits, et cette fois encore on leur fit une querelle. Il appela donc ce puits Sitna (c'est-à-dire: Désaccord)."
,"22":"Il partit plus loin, creusa un autre puits, et là, on ne leur fit pas d'histoires. Il appela donc ce puits Réhobot (c'est-à-dire: Au large), car il disait: 'Maintenant, Yahvé nous a mis au large, nous allons nous développer dans ce pays.'"
,"23":"Il partit de là pour Bersabée."
,"24":"Yahvé lui apparut cette nuit-là et lui dit: 'Je suis le Dieu d'Abraham, ton père. N'aie pas peur, je suis avec toi, je te bénirai et je multiplierai ta descendance à cause d'Abraham, mon serviteur.'"
,"25":"Il construisit là un autel et invoqua le nom de Yahvé. Il y monta sa tente, et là aussi ses serviteurs creusèrent un puits."
,"26":"De Guérar, Abimélek vint à la rencontre d'Isaac avec Akhouzzat, son ami, et Pikol, le chef de son armée."
,"27":"Isaac leur dit: 'Pourquoi êtes-vous venus vers moi, puisque vous me détestez et que vous m'avez chassé de chez vous?'"
,"28":"Ils répondirent: 'Nous avons vu clairement que Yahvé était avec toi, aussi nous te disons: Qu'il y ait une paix jurée entre nous et toi. Concluons ensemble une alliance!"
,"29":"Nous ne t'avons pas fait de mal, nous ne t'avons fait que du bien et nous t'avons renvoyé en paix. Tu ne nous feras donc aucun mal non plus, maintenant que Yahvé t'a tout donné.'"
,"30":"Isaac leur prépara un bon repas, ils mangèrent et ils burent."
,"31":"Ils se levèrent de bon matin et se prêtèrent serment l'un à l'autre, puis Isaac les laissa partir et ils s'en allèrent de chez lui en paix."
,"32":"Ce jour-là, des serviteurs qui creusaient un puits vinrent trouver Isaac avec cette bonne nouvelle: 'Nous avons trouvé de l'eau.'"
,"33":"Il appela le puits: Sabé (c'est-à-dire: Serment); c'est pour cela que la ville s'est appelée Bersabée (Puits du Serment) jusqu'à ce jour."
,"34":"A l'âge de quarante ans, Esaü épousa Ju dith fille de Bééri le Hittite, et Basmat, fille d'Elon le Hittite."
,"35":"Mais elles causèrent bien des ennuis à Isaac et à Rébecca."
}`)
	CurrentBook.AddChapter(27, `{
"1":"Isaac était âgé et ses yeux étaient si affaiblis qu'il ne voyait plus. Il appela Esaü, son fils aîné, et lui dit: 'Mon fils!' Celui-ci répondit: 'Me voici.'"
,"2":"Isaac dit: 'Je suis devenu vieux, et je ne peux pas dire le jour de ma mort."
,"3":"Aussi tu vas prendre tes armes, tes flèches et ton arc, et tu vas sortir dans la campagne pour me rapporter du gibier."
,"4":"Tu me le prépareras comme je l'aime, tu me l'apporteras pour que je le mange et je te bénirai avant de mourir.'"
,"5":"Rébecca écoutait les paroles d'Isaac à son fils Esaü. Quand Esaü partit dans la campagne pour chasser et rapporter du gibier,"
,"6":"Rébecca dit à son fils Jacob: 'Ton père a parlé à ton frère Esaü, et j'ai tout entendu. Il lui a dit:"
,"7":"Apporte-moi du gibier, tu le prépareras, j'en mangerai et je te bénirai devant Yahvé avant de mourir."
,"8":"Maintenant mon fils, écoute-moi et fais ce que je te dis."
,"9":"Va-t'en au troupeau; tu prendras deux beaux chevreaux et j'en ferai pour ton père un repas comme il aime."
,"10":"Tu le lui porteras, il en mangera et il te bénira avant de mourir.'"
,"11":"Jacob répondit à sa mère Rébecca: 'Mais mon frère Esaü est un homme velu, et moi je n'ai pas de poil!"
,"12":"Si mon père me touche, il verra que je suis un malhonnête, et je m'attirerai une malédiction, non une bénédiction.'"
,"13":"Mais sa mère lui dit: 'La malédiction sera pour moi, mon fils. Ecoute seulement ce que je te dis, et va chercher les deux chevreaux.'"
,"14":"Il alla donc les prendre au troupeau et les apporta à sa mère, laquelle prépara un repas comme l'aimait son père."
,"15":"Rébecca prit alors les meilleurs habits de son fils aîné Esaü, et de ces habits qu'elle gardait dans la maison, elle habilla son plus jeune fils Jacob."
,"16":"Puis elle lui recouvrit les mains et la partie sans poil de son cou avec les peaux des chevreaux"
,"17":"Elle mit ensuite dans les mains de son fils Jacob le repas et le pain qu'elle avait préparés."
,"18":"Jacob s'approcha de son père et lui dit: 'Mon père!' Il répondit: Je suis là. 'Qui es-tu mon fils?'"
,"19":"Jacob dit à son père: 'Je suis Esaü, ton premier-né. J'ai fait comme tu me l'as demandé. Mange donc de mon gibier, et tu me béniras.'"
,"20":"Isaac dit à son fils: 'Tu as trouvé bien vite, mon fils!' Il répondit: 'C'est que Yahvé ton Dieu m'a fait faire une bonne rencontre.'"
,"21":"Isaac dit à Jacob: 'Avance-toi donc que je te touche, mon fils, pour savoir si c'est toi mon fils Esaü, ou non.'"
,"22":"Jacob s'avança vers son père Isaac. Celui-ci le toucha et dit: 'La voix est la voix de Jacob, mais les mains sont les mains d'Esaü.'"
,"23":"Il ne le reconnut pas avec ses mains velues comme les mains de son frère Esaü, de sorte qu'il le bénit."
,"24":"Il lui demanda: 'C'est bien toi, mon fils Esaü?' Jacob répondit: 'C'est moi.'"
,"25":"Son père lui dit: 'Sers-moi donc, je veux manger du gibier de mon fils, et ensuite je te bénirai.' Jacob servit son père, qui mangea, puis il lui apporta du vin, et il but."
,"26":"Alors son père Isaac lui dit: 'Avance-toi et embrasse-moi, mon fils.'"
,"27":"Jacob s'avança et embrassa Isaac. Celui-ci respira la bonne odeur de ses habits et il lui donna cette bénédiction: 'Cette odeur de mon fils,est celle d'un champ que Yahvé a béni."
,"28":"Que Dieu te donne la rosée du ciel,et te réserve les terres grasses, qu'il te donne abondance de blé et de vin."
,"29":"Que des peuples te servent, que des nations se prosternent devant toi. Sois le chef de famille de tes frères,et que les fils de ta mère s'inclinent devant toi. Maudits soient ceux qui te maudiront, bénis soient ceux qui te béniront!'"
,"30":"Isaac venait tout juste de bénir Jacob, et Jacob quittait à peine son père Isaac, lorsque son frère Esaü rentra de la chasse."
,"31":"Il prépara lui aussi un repas et l'apporta à son père en lui disant: 'Mon père, lève-toi et mange du gibier de ton fils, ensuite tu me béniras.'"
,"32":"Son père demanda: 'Qui es-tu?' Il répondit: 'Je suis ton fils premier-né, Esaü.'"
,"33":"Isaac fut secoué d'un grand tremblement et dit: 'Qui est donc celui qui a chassé du gibier et m'en a apporté? J'ai mangé de tout avant que tu n'arrives et je l'ai béni: oui, il a la bénédiction!'"
,"34":"Lorsqu'Esaü entendit les paroles de son père, il poussa des cris amers; il dit à son père: 'Bénis-moi aussi, mon père!'"
,"35":"Isaac lui dit: 'Ton frère est venu par ruse et il a volé ta bénédiction.'"
,"36":"Esaü répondit: 'On a eu raison de l'appeler Jacob, car il m'a supplanté par deux fois. Il m'a déjà pris mon droit d'aînesse, et maintenant il me prend la bénédiction.' Il ajouta: 'Ne m'as-tu pas réservé une bénédiction?'"
,"37":"Isaac répondit à Esaü: 'Regarde, j'ai fait de lui ton chef de famille, et je lui ai donné tous ses frères pour serviteurs. Je l'ai pourvu de blé et de vin. Que puis-je encore pour toi, mon fils?'"
,"38":"Esaü dit à son père: 'N'aurais-tu donc qu'une seule bénédiction? Bénis-moi aussi mon père!' Esaü pleurait, poussait des cris."
,"39":"Alors Isaac, son père, déclara: 'Tu auras ta demeure loin des terres grasses, loin de la rosée du ciel."
,"40":"Tu vivras de ton épée et tu serviras ton frère, mais lorsque tu le voudras, tu secoueras son joug de dessus ton cou.'"
,"41":"Esaü maintenant détestait Jacob à cause de la bénédiction que lui avait donnée son père. Il se dit en lui-même: 'On fera bientôt le deuil de mon père, alors je tuerai mon frère Jacob.'"
,"42":"On rapporta à Rébecca ces paroles de son fils aîné, Esaü. Elle envoya donc chercher Jacob, son plus jeune fils, et lui dit: 'Ton frère Esaü a décidé de se venger de toi et de te tuer."
,"43":"Fais donc ce que je te dis, mon fils: il te faut partir et te réfugier chez mon frère Laban à Harrân."
,"44":"Tu resteras chez lui quelque temps, jusqu'à ce que passe la fureur de ton frère."
,"45":"Quand la colère de ton frère se sera détournée de toi et qu'il aura oublié ce que tu lui as fait, je t'enverrai chercher là-bas. Pourquoi serais-je privée de vous deux en un même jour?'"
,"46":"Rébecca dit à Isaac: 'Ces filles de Heth m'enlèvent le goût de vivre! Si Jacob aussi devait épouser une fille de Heth, une fille d'ici, je préférerais mourir.'"
}`)
	CurrentBook.AddChapter(28, `{
"1":"Isaac appela donc Jacob, il le bénit et lui donna cet ordre: 'Tu n'épouseras pas une fille de Canaan."
,"2":"Il te faut aller à Paddan-Aram, à la maison de Bétuel, le père de ta mère, et prends-toi une femme parmi les filles de ton oncle Laban."
,"3":"Que le Dieu de La Steppe te bénisse, pour que tu grandisses et te multiplies jusqu'à devenir une assemblée de peuples."
,"4":"Qu'il te donne à toi et à ta descendance après toi la bénédiction d'Abraham, pour que tu possèdes ce pays où tu séjournes, celui que Dieu a donné à Abraham.'"
,"5":"Isaac fit partir Jacob; celui-ci s'en alla vers Paddan-Aram chez Laban, le fils de Bétuel l'Araméen, le frère de Rébecca, mère de Jacob et d'Esaü."
,"6":"Isaac avait donc béni Jacob. Il l'avait envoyé à Paddan-Aram pour y prendre une femme car, en le bénissant, il lui avait donné cet ordre: 'Tu ne prendras pas pour femme une fille de Canaan!'"
,"7":"Et Jacob, écoutant son père et sa mère, s'en était allé vers Paddan-Aram. Voyant cela,"
,"8":"Esaü comprit que les filles de Canaan déplaisaient à Isaac, son père."
,"9":"Esaü se rendit donc chez Ismaël et, en plus de ses femmes, il épousa Makhalat, fille d'Ismaël fils d'Abraham, la soeur de Nébayot."
,"10":"Jacob quitta Bersabée et partit pour Harrân."
,"11":"Arrivé en un certain lieu, il se proposa d'y passer la nuit car le soleil était déjà couché. Il prit une des pierres de l'endroit et en fit son oreiller, puis il se coucha en ce même endroit."
,"12":"Et puis il eut un songe. Une échelle était là, dressée sur la terre, et son sommet touchait les cieux; des anges de Dieu montaient et descendaient sur cette échelle."
,"13":"Yahvé se tenait à côté de lui, il lui dit: 'Je suis Yahvé, le Dieu de ton père Abraham et le Dieu d'Isaac. La terre sur laquelle tu t'es couché, je te la donnerai ainsi qu'à ta descendance."
,"14":"Ta descendance sera comme la poussière de la terre, tu déborderas vers l'ouest et vers l'est, vers le nord et vers le sud. Par toi et par ta descendance se béniront toutes les familles de la terre."
,"15":"Je suis avec toi, je te protégerai partout où tu iras et je te ramènerai sur cette terre, car je ne t'abandonnerai pas jusqu'à ce que j'aie fait ce que je te dis.'"
,"16":"Quand Jacob se réveilla de son sommeil, il dit: ' Yahvé est donc en ce lieu, et je ne le savais pas!'"
,"17":"Il eut peur: 'Que ce lieu est terrible, dit-il, ce n'est rien moins qu'une maison de Dieu et la porte du ciel.'"
,"18":"Jacob se leva de bon matin: il prit la pierre qui lui avait servi d'oreiller, il la dressa et versa de l'huile sur son sommet."
,"19":"Puis il donna à ce lieu le nom de Béthel (c'est-à-dire: Maison de Dieu), car auparavant le nom de la ville était Louz."
,"20":"Jacob fit alors un voeu: 'Si Dieu est avec moi, s'il me protège dans le voyage que j'ai entrepris, s'il me donne mon pain et un habit pour me vêtir,"
,"21":"si je retourne en paix à la maison de mon père: en un mot, si Yahvé se comporte avec moi comme un Dieu,"
,"22":"cette pierre que j'ai dressée en souvenir sera une maison de Dieu, et je lui verserai la dixième partie de tout ce qu'il me donnera.'"
}`)
	CurrentBook.AddChapter(29, `{
"1":"Jacob se mit en route et s'en alla au pays d'Orient."
,"2":"Il aperçut un puits dans la campagne et trois troupeaux de petit bétail couchés près de ce puits. C'est là qu'on leur donnait à boire, mais l'ouverture du puits était recouverte d'une grande pierre."
,"3":"Quand tous les troupeaux y étaient rassemblés, on roulait la pierre de dessus l'ouverture du puits, on donnait à boire au petit bétail, et puis l'on remettait la pierre en place sur l'ouverture du puits."
,"4":"Jacob dit aux bergers: 'D'où êtes-vous, mes frères?' Ils répondirent: 'Nous sommes de Harrân.'"
,"5":"Il leur dit: 'Connaissez-vous Laban, le fils de Nahor?' Ils répondirent: 'Nous le connaissons bien.'"
,"6":"Jacob leur dit: 'Est-il en bonne santé?' 'Il est en bonne santé, répondirent-ils, voici d'ailleurs Rachel, sa fille, qui arrive avec le petit bétail.'"
,"7":"Jacob leur dit: 'Il fait encore grand jour, ce n'est pas l'heure de rassembler les bêtes. Donnez-leur à boire et emmenez-les pour paître.'"
,"8":"Les bergers répondirent: 'Nous ne pouvons pas avant que tous les troupeaux soient rassemblés. Alors on roule la pierre de dessus l'ouverture du puits et on donne à boire au petit bétail.'"
,"9":"Jacob parlait encore, lorsque Rachel arriva avec le petit bétail de son père: elle était bergère."
,"10":"Dès que Jacob vit Rachel, la fille de son oncle Laban, avec le petit bétail de Laban, il s'approcha du puits, roula la pierre qui le couvrait et donna à boire au petit bétail de son oncle Laban."
,"11":"Ensuite il embrassa Rachel et pleura abondamment."
,"12":"Jacob apprit à Rachel qu'il était de la parenté de son père, et le fils de Rébecca. Aussitôt celle-ci courut l'annoncer à son père."
,"13":"Quand Laban sut qu'il s'agissait de son neveu Jacob, il courut à sa rencontre, il l'embrassa, le couvrit de baisers et le fit entrer dans sa maison. Là Jacob le mit au courant de tout."
,"14":"Laban lui dit: 'En vérité tu es de mes os et de ma chair.' Jacob resta chez lui tout un mois."
,"15":"Laban dit alors à Jacob: 'Ce n'est pas parce que tu es mon frère que tu vas travailler chez moi pour rien. Quel salaire me demandes-tu?'"
,"16":"Laban avait deux filles. L'aînée s'appelait Léa et la plus jeune Rachel."
,"17":"Léa avait des yeux sans éclat, alors que Rachel avait belle allure et beau visage."
,"18":"Jacob aimait Rachel, il répondit: 'Je te servirai sept ans pour Rachel, ta seconde fille.'"
,"19":"Laban lui répondit: 'J'aime mieux te la donner à toi que de la donner à quelqu'un d'autre. Reste chez moi.'"
,"20":"Jacob travailla donc pour Rachel pendant sept ans qui ne lui parurent que quelques jours, tellement il l'aimait."
,"21":"Au bout de ce temps Jacob dit à Laban: 'Donne-moi ma femme puisque je t'ai servi le temps que je devais. Maintenant, je veux coucher avec elle.'"
,"22":"Laban invita donc tous les hommes de l'endroit et donna un grand repas."
,"23":"Mais lorsque la nuit fut venue, il prit sa fille Léa et la conduisit vers Jacob qui s'unit à elle."
,"24":"Laban donna alors comme servante à sa fille Léa, sa propre servante Zilpa."
,"25":"Au matin, Jacob s'aperçut que c'était Léa. Il dit à Laban: 'Que m'as-tu fait? N'est-ce pas pour Rachel que j'ai travaillé chez toi? Pourquoi m'as-tu trompé?'"
,"26":"Laban lui répondit: 'Cela ne se fait pas chez nous de marier la plus jeune avant l'aînée."
,"27":"Terminons cette semaine de noces et nous te donnerons aussi celle-là, mais dans ce cas tu travailleras encore sept ans chez moi.'"
,"28":"C'est ce que fit Jacob. Terminée la semaine de noces de Léa, Laban lui donna pour femme sa fille Rachel."
,"29":"Laban donna alors comme servante à sa fille Rachel, Bila, sa propre servante."
,"30":"Jacob s'unit aussi à Rachel et, pour dire vrai, il aimait Rachel plus que Léa. Il travailla donc chez Laban sept années de plus."
,"31":"Yahvé vit que Léa était délaissée, et il la rendit féconde alors que Rachel était stérile."
,"32":"Léa fut enceinte et donna le jour à un fils qu'elle appela Ruben; car elle disait: 'Yahvé a eu pitié de mon humiliation, maintenant mon mari m'aimera.'"
,"33":"Elle fut encore enceinte et donna le jour à un fils. Elle dit alors: 'Yahvé a vu que j'étais délaissée, et il m'a encore donné celui-ci.' C'est pourquoi elle l'appela Siméon."
,"34":"Elle fut encore enceinte et donna le jour à un fils. 'Cette fois, dit-elle, mon mari s'attachera à moi, car je lui ai donné trois fils.' Aussi on donna à l'enfant le nom de Lévi."
,"35":"Elle fut encore enceinte et donna le jour à un fils. 'Cette fois, dit-elle, je chanterai les louanges de Yahvé.' C'est pourquoi elle l'appela Juda. Puis elle cessa d'avoir des enfants."
}`)
	CurrentBook.AddChapter(30, `{
"1":"Rachel voyait qu'elle ne donnait pas de fils à Jacob: elle devint jalouse de sa soeur. Elle dit à Jacob: 'Donne-moi des fils, ou je meurs!'"
,"2":"Jacob se mit en colère contre Rachel et lui dit: 'Que puis-je faire si Dieu t'a refusé des enfants?'"
,"3":"Rachel répondit: 'Voici ma servante Bila, unis-toi à elle. Son enfant viendra au monde sur mes genoux et, par elle, moi aussi j'aurai un fils.'"
,"4":"Elle lui donna donc sa servante Bila et Jacob s'approcha d'elle."
,"5":"Bila fut enceinte et donna un fils à Jacob."
,"6":"Alors Rachel dit: 'Dieu m'a rendu justice; il a écouté ma voix et il m'a donné un fils.' Et pour cela elle lui donna le nom de Dan."
,"7":"Bila, la servante de Rachel, fut encore enceinte et donna un second fils à Jacob."
,"8":"Rachel dit alors: 'J'ai mené de sacrées luttes contre ma soeur, et j'ai gagné.' Elle lui donna donc le nom de Nephtali."
,"9":"Quand Léa vit qu'elle avait cessé d'avoir des enfants, elle prit sa servante Zilpa pour la donner à Jacob,"
,"10":"et Zilpa donna un fils à Jacob."
,"11":"Léa dit alors: 'Quel bonheur!' C'est pourquoi elle lui donna le nom de Gad."
,"12":"Zilpa, la servante de Léa, donna un second fils à Jacob."
,"13":"'Je suis heureuse, dit-elle, les femmes me féliciteront.' Aussi lui donna-t-elle le nom d'Asher."
,"14":"Au temps de la moisson des blés, Ruben sortit et trouva dans les champs des pommes d'amour. Il les rapporta à sa mère Léa. Alors Rachel dit à Léa: 'Donne-moi donc de ces pommes d'amour que ton fils a rapportées.'"
,"15":"Léa répondit: 'Ça ne te suffit donc pas d'avoir pris mon mari? Tu veux prendre encore les pommes d'amour de mon fils!' Alors Rachel lui dit: 'Bien! Qu'il couche avec toi cette nuit en échange des pommes d'amour de ton fils.'"
,"16":"Le soir, quand Jacob rentra des champs, Léa sortit à sa rencontre. 'Tu coucheras avec moi cette nuit, dit-elle, car je t'ai échangé contre les pommes d'amour de mon fils.' Il coucha donc avec elle cette nuit-là."
,"17":"Dieu écouta Léa. Elle fut enceinte et donna un cinquième fils à Jacob."
,"18":"Léa dit alors: 'Dieu m'a récompensée parce que j'ai donné ma servante à mon mari.' Et elle appela l'enfant Issacar."
,"19":"Léa fut encore enceinte et donna un sixième fils à Jacob."
,"20":"'Dieu m'a fait un beau cadeau, dit-elle, cette fois mon mari me gardera avec lui, car je lui ai donné six fils.' Et elle donna à l'enfant le nom de Zabulon."
,"21":"Après quoi elle donna le jour à une fille et l'appela Dinah."
,"22":"Alors Dieu se souvint de Rachel. Dieu l'écouta et la rendit féconde."
,"23":"Elle devint enceinte et eut un fils. 'Dieu, dit-elle, a enlevé ma honte.'"
,"24":"Elle donna à l'enfant le nom de Joseph, car elle disait: 'Que Yahvé m'ajoute un autre fils.'"
,"25":"Après que Rachel eût donné le jour à Joseph, Jacob dit à Laban: 'Laisse-moi partir, je voudrais retourner chez moi, dans mon pays."
,"26":"Donne-moi, s'il te plaît, mes femmes pour lesquelles je t'ai servi, ainsi que mes enfants, que je puisse m'en aller. Tu sais quel travail j'ai fait chez toi!'"
,"27":"Laban répondit: 'Si j'ai trouvé grâce à tes yeux, ne pars pas. Le ciel m'a fait voir que Yahvé me bénissait à cause de toi.'"
,"28":"Il ajouta: 'Fixe toi-même ton salaire, et je te le donnerai.'"
,"29":"Jacob lui dit: 'Tu sais comment je t'ai servi, et combien ton troupeau a grandi grâce à moi."
,"30":"Avant moi tu n'avais pas grand-chose, mais avec moi tout s'est considérablement développé, et Yahvé t'a béni. Quand donc pourrai-je travailler pour moi?'"
,"31":"Laban lui dit: 'Que te donnerai-je?' Jacob répondit: 'Ne me donne rien. Mais si tu fais pour moi ce que je vais te dire, je continuerai à garder ton petit bétail."
,"32":"Aujourd'hui je vais passer en revue tout ton petit bétail. Tout agneau qui aura des points ou des taches, tout agneau brun parmi les moutons, toute chèvre qui aura des taches ou des points, je les mettrai de côté: ce sera mon salaire."
,"33":"Demain tu viendras vérifier mon salaire et tu verras si je suis honnête. Les chèvres qui n'auront pas de points ou de taches, les moutons dans mon troupeau qui ne seront pas bruns, tu pourras dire qu'ils sont volés.'"
,"34":"Laban répondit: 'C'est bien! Qu'il en soit comme tu l'as dit.'"
,"35":"Ce jour-là Laban mit de côté les boucs rayés et tachetés, toutes les chèvres qui avaient des points ou des taches, tous les moutons qui avaient du blanc et du brun, et les confia à ses fils."
,"36":"Puis il les envoya loin de Jacob, à une distance de trois jours de marche, pendant que Jacob faisait paître le reste du troupeau de Laban."
,"37":"Jacob prit alors des baguettes fraîches de divers arbres, il mit à nu le bois de place en place, de sorte que l'écorce qu'il avait laissée formait comme des anneaux sur les baguettes."
,"38":"Ensuite il plaça les baguettes ainsi dénudées dans les auges et les abreuvoirs où les bêtes venaient boire. Les baguettes étaient donc sous leurs yeux lorsque les bêtes s'accouplaient en venant boire."
,"39":"Les bêtes qui s'accouplaient devant les baguettes mettaient bas des petits portant des raies, des points ou des taches."
,"40":"Alors Jacob séparait les bêtes."
,"41":"Chaque fois que les bêtes les plus vigoureuses s'accouplaient, Jacob mettait les baguettes dans les auges sous les yeux des bêtes, pour qu'elles s'accouplent devant les baguettes."
,"42":"Mais quand les bêtes étaient chétives, il ne mettait pas de baguettes. Laban avait donc les bêtes chétives, et Jacob les vigoureuses."
,"43":"Cet homme s'enrichit ainsi considérablement. Il eut beaucoup de bétail, des servantes, des serviteurs, des chameaux et des ânes."
}`)
	CurrentBook.AddChapter(31, `{
"1":"Jacob apprit ce que disaient les fils de Laban: 'Jacob, disaient-ils, a pris tout ce qu'avait notre père, il a fait sa fortune aux dépens de notre père.'"
,"2":"Jacob vit bien à la tête de Laban qu'il n'était plus avec lui comme auparavant."
,"3":"Yahvé dit alors à Jacob: 'Retourne dans le pays de tes pères, dans ta patrie, et je serai avec toi.'"
,"4":"Jacob fit donc venir Rachel et Léa dans la campagne, près de son troupeau."
,"5":"Il leur dit: 'Je vois bien à la tête de votre père qu'il n'est plus avec moi comme autrefois, mais c'est le Dieu de mon père qui est venu à mon aide."
,"6":"Vous savez que je travaillais pour votre père de toutes mes forces,"
,"7":"et votre père se moquait de moi: il a changé dix fois mon salaire. Mais Dieu ne lui a pas permis de me faire du mal."
,"8":"Quand il disait: Les bêtes avec des points seront ton salaire, toutes les brebis mettaient bas des bêtes avec des points. Quand il disait: Les bêtes rayées seront ton salaire, toutes les brebis mettaient bas des bêtes rayées."
,"9":"Ainsi Dieu a enlevé le troupeau à votre père et me l'a donné."
,"10":"Une fois, pendant que les bêtes s'accouplaient, je vis en songe des béliers avec des raies, des points et des taches qui montaient sur les brebis."
,"11":"Et l'ange de Dieu me dit en songe: Jacob! Je répondis: Me voici!"
,"12":"Il me dit: Lève les yeux et regarde tous les béliers qui montent sur les brebis: ils ont des raies, des points et des taches; c'est que j'ai vu tout le travail que tu as fait pour Laban."
,"13":"Je suis le Dieu qui t'est apparu à Béthel, et tu m'as fait un voeu en répandant de l'huile sur une pierre dressée. Maintenant va! Sors de ce pays et retourne dans ton pays natal.'"
,"14":"Rachel et Léa lui répondirent: 'Avons-nous encore une part et un héritage dans la maison de notre père?"
,"15":"Ne nous a-t-il pas traitées comme des étrangères, puisqu'il nous a vendues et que de fait il a mangé notre dot?"
,"16":"Mais toute la richesse que Dieu a enlevée à notre père est à nous désormais et à nos fils: fais donc ce que Dieu t'a dit de faire.'"
,"17":"Jacob fit donc monter ses fils et ses femmes sur des chameaux."
,"18":"Il emmena aussi tout son troupeau et tous les biens qu'il avait acquis - le troupeau qu'il s'était fait à Paddan-Aram. Il se mit en route vers Isaac, son père, au pays de Canaan."
,"19":"Comme Laban était parti pour tondre son troupeau, Rachel vola les idoles familiales de son père."
,"20":"Jacob, lui, cacha ses intentions à Laban l'Araméen. Il ne lui annonça pas son départ."
,"21":"Il partit précipitamment avec tout ce qui était à lui, traversa le fleuve et se dirigea vers la montagne de Galaad."
,"22":"C'est seulement le troisième jour qu'on annonça à Laban la fuite de Jacob."
,"23":"Laban prit ses frères avec lui et marcha sept jours à la poursuite de Jacob; il le rejoignit à la montagne de Galaad."
,"24":"Là, durant la nuit, Dieu s'approcha de Laban l'Araméen dans un songe et lui dit: 'Garde-toi bien de discuter avec Jacob, que ce soit avec ou sans menaces.'"
,"25":"Laban rejoignit Jacob, Comme celui-ci venait de planter sa tente sur la colline de Mispa, Laban planta la sienne dans la montagne de Galaad."
,"26":"Laban dit à Jacob: 'Qu'as-tu fait? Tu m'as caché tes intentions et tu as enlevé mes filles comme des captives de guerre."
,"27":"Pourquoi t'es-tu sauvé en cachette et m'as-tu trompé? Pourquoi ne m'as-tu pas averti? Je t'aurais fait une fête, je t'aurais reconduit avec des chants, des tambourins et des harpes."
,"28":"Tu ne m'as même pas laissé embrasser mes fils et mes filles. Tu t'es vraiment conduit comme un sot."
,"29":"Je pourrais te faire du mal, mais le Dieu de ton père m'a parlé cette nuit. Il m'a dit: Garde-toi de discuter avec Jacob, que ce soit avec ou sans menaces."
,"30":"Cependant, si tu es parti pour retourner chez ton père parce que tu trouvais le temps long, pourquoi as-tu volé mes dieux?'"
,"31":"Jacob répondit à Laban: 'J'ai eu peur, je pensais que tu voudrais peut-être reprendre tes filles."
,"32":"Mais si tu trouves tes dieux ici chez quelqu'un, il sera mis à mort. Devant nos frères, regarde si j'ai ici quelque chose à toi, et reprends-le.' Jacob ne savait pas que Rachel avait volé les idoles."
,"33":"Laban entra donc dans la tente de Jacob, puis dans celle de Léa et dans celle des deux servantes. Il ne trouva rien. Il sortit alors de la tente de Léa pour entrer dans celle de Rachel."
,"34":"Or Rachel, qui avait pris les idoles, les avait placées dans la selle du chameau et elle s'était assise dessus. Laban fouilla toute la tente, il ne trouva rien."
,"35":"Rachel dit à son père: 'Ne te fâche pas contre moi, mon seigneur, si je ne me lève pas devant toi, mais j'ai en ce moment ce qui arrive aux femmes.' Donc, il eut beau fouiller, il ne trouva pas les idoles."
,"36":"Jacob se mit alors en colère contre Laban. Il lui dit: 'Quel est mon crime? Quel est mon péché pour que tu t'acharnes ainsi contre moi?"
,"37":"Maintenant que tu as fouillé partout dans mes affaires, qu'as-tu trouvé qui t'appartienne? Montre-le ici, devant mes frères et tes frères, ils seront juges entre nous!"
,"38":"Voici vingt ans que je travaille pour toi: tes brebis et tes chèvres n'ont pas avorté, et je n'ai pas mangé les béliers de ton troupeau."
,"39":"Je ne t'ai jamais ramené une bête déchirée, c'est moi qui la remplaçais. Ce qui était volé de jour ou de nuit, tu me le réclamais."
,"40":"J'étais dévoré par la chaleur le jour, et par le froid la nuit, si bien que mes yeux en perdaient le sommeil."
,"41":"Voici vingt ans que je suis chez toi. Je t'ai servi quatorze ans pour tes deux filles et six ans pour le troupeau, et dix fois tu as changé mon salaire."
,"42":"Si le Dieu de mon père, le Dieu d'Abraham et le Dieu Redoutable d'Isaac, n'avait pas été avec moi, tu m'aurais maintenant renvoyé les mains vides. Mais Dieu a vu ma misère, il a vu les fatigues de mes mains, et la nuit dernière il s'est prononcé pour moi.'"
,"43":"Laban répondit à Jacob: 'Ces filles sont mes filles et ces garçons sont mes fils, ce troupeau est mon troupeau et tout ce que tu vois est à moi. Que pourrais-je faire aujourd'hui à mes filles et aux fils qu'elles ont mis au monde?"
,"44":"Concluons donc une alliance tous les deux, et qu'elle soit comme un témoin entre moi et toi.'"
,"45":"Alors Jacob prit une pierre qu'il dressa debout."
,"46":"Puis Jacob dit à ses frères: 'Ramassez des pierres!' Ils en ramassèrent et en firent un tas, et ils prirent un repas sur ce tas de pierres."
,"47":"Laban l'appela Yégar-Sahadouta, tandis que Jacob l'appelait Galéed."
,"48":"Laban dit: 'Ce tas de pierres est aujourd'hui témoin entre moi et toi.' C'est pourquoi on lui a donné le nom de Galéed ou Galaad."
,"49":"On lui a donné également le nom de Mispah, car Laban avait dit: 'Que Yahvé nous observe tous les deux quand nous serons loin l'un de l'autre."
,"50":"Si tu méprises mes filles et que tu prends d'autres femmes en plus de mes filles, ce n'est pas un homme comme nous, mais bien Dieu lui-même qui sera témoin entre moi et toi.'"
,"51":"Laban dit encore à Jacob: 'Regarde ce tas de pierres, et cette pierre dressée que j'ai mise entre moi et toi."
,"52":"Ce tas de pierres est témoin, ainsi que la pierre dressée, que je ne passerai pas de ton côté au-delà du tas de pierres, et que toi tu ne passeras pas de mon côté, au-delà de ce tas de pierres et de cette pierre dressée, avec de mauvaises intentions."
,"53":"Que le Dieu d'Abraham et le Dieu de Nahor soit juge entre nous.' Alors Jacob le lui jura par le Dieu Redoutable de son père Isaac."
,"54":"Jacob offrit un sacrifice sur la montagne et il invita ses frères à partager le pain. Ils partagèrent donc le pain et passèrent la nuit sur la montagne."
}`)
	CurrentBook.AddChapter(32, `{
"1":"Laban se leva de bon matin, il embrassa ses fils et ses filles, les bénit et s'en retourna. C'est ainsi que Laban retourna chez lui."
,"2":"Jacob continua son chemin et les anges de Dieu le rencontrèrent."
,"3":"Lorsqu'il les vit, Jacob s'écria: 'C'est un camp de Dieu!' C'est pourquoi il donna à cet endroit le nom de Double Camp."
,"4":"Jacob envoya des messagers devant lui vers son frère Esaü, à Séïr dans la campagne d'Edom."
,"5":"Il leur donna cet ordre: 'Vous parlerez ainsi à mon seigneur Esaü: Voici ce que ton serviteur Jacob te fait dire: J'ai séjourné chez Laban et je m'y suis attardé jusqu'à maintenant."
,"6":"J'y ai acquis des boeufs et des ânes, du petit bétail, des serviteurs et des servantes. J'ai donc envoyé mes gens pour te l'annoncer et trouver ainsi grâce à tes yeux.'"
,"7":"Les messagers revinrent vers Jacob en disant: 'Nous avons rejoint ton frère Esaü; il marche à ta rencontre avec quatre cents hommes.'"
,"8":"Jacob eut alors très peur et il fut saisi d'angoisse. Il partagea en deux camps les gens qui étaient avec lui, ainsi que le petit et le gros bétail; il fit de même pour les chameaux."
,"9":"Car il se disait: 'Si Esaü rejoint un camp et l'attaque, l'autre pourra s'échapper.'"
,"10":"Jacob dit alors: 'Dieu de mon père Abraham et Dieu de mon père Isaac, ô Yahvé, toi qui m'as dit: Retourne dans ton pays et dans ta patrie et je te ferai du bien,"
,"11":"je suis trop peu de chose pour mériter toutes tes faveurs et toute la fidélité que tu as montrées à ton serviteur. Je n'avais en effet que ce bâton lorsque j'ai traversé ce Jourdain, et maintenant, j'ai de quoi former deux camps."
,"12":"Délivre- moi de la main de mon frère, de la main d'Esaü, car j'ai peur qu'il ne vienne et nous frappe, la mère avec les enfants."
,"13":"Or c'est toi qui m'as dit: Je te ferai du bien et je rendrai ta descendance comme le sable de la mer: le nombre en sera tel qu'on ne pourra le compter.'"
,"14":"Et Jacob passa la nuit en cet endroit. Jacob prit sur ses biens de quoi faire un cadeau à son frère Esaü: "
,"15":"deux cents chèvres et vingt boucs, deux cents brebis et vingt béliers,"
,"16":"trente chamelles qui allaitaient, avec leurs petits, quarante vaches et dix taureaux, vingt ânesses et dix ânons."
,"17":"Il confia chaque troupeau séparément à l'un de ses serviteurs, puis il leur dit: 'Passez devant moi et laissez un espace après chaque troupeau.'"
,"18":"Au premier il donna cet ordre: 'Quand mon frère Esaü te rencontrera, il te posera la question: A qui appartiens-tu et où vas-tu? A qui appartient ce que tu as là?"
,"19":"Alors tu répondras: Tout appartient à ton serviteur Jacob. C'est un cadeau qu'il envoie à mon seigneur Esaü, lui-même arrive derrière nous.'"
,"20":"Il donna également ses instructions au deuxième, puis au troisième, bref, à tous ceux qui accompagnaient les troupeaux. Il leur disait: 'Voilà comment vous parlerez à Esaü quand vous le rencontrerez,"
,"21":"vous lui direz: Ton serviteur Jacob arrive tout de suite derrière nous.' Il pensait en effet: 'Le cadeau que j'envoie devant moi l'apaisera et je pourrai alors le regarder en face. Peut-être me fera-t-il bon accueil.'"
,"22":"Il envoya donc le cadeau en avant de lui. Quant à lui, il passa cette nuit-là dans le camp."
,"23":"Durant la nuit il alla prendre ses deux femmes et ses deux servantes ainsi que les onze enfants pour passer le gué du Yabok."
,"24":"Après les avoir pris et leur avoir fait passer le torrent, il fit passer tout ce qu'il avait."
,"25":"Et Jacob resta seul. Quelqu'un lutta avec lui jusqu'au lever du jour. "
,"26":"Voyant qu'il ne pouvait dominer Jacob, il le toucha à l'articulation de la hanche, et la hanche de Jacob se démit tandis qu'il luttait avec lui."
,"27":"L'autre lui dit: 'Laisse-moi partir, car le jour se lève.' Mais Jacob répondit: 'Je ne te laisserai pas partir avant que tu ne m'aies donné la bénédiction.'"
,"28":"L'autre lui dit: 'Quel est ton nom?' Il répondit: 'Jacob.'"
,"29":"L'autre lui dit: 'On ne t'appellera plus Jacob, mais Israël, car tu as lutté avec Dieu comme avec les hommes, et tu as eu le dessus.'"
,"30":"Jacob l'interrogea et lui dit: 'Révèle-moi ton nom'. Il répondit: 'Pourquoi demandes-tu mon nom?' Mais là, il le bénit."
,"31":"Jacob donna à ce lieu le nom de Pénuel car, dit-il: 'J'ai vu Dieu face à face et j'ai eu la vie sauve.'"
,"32":"Le soleil était déjà haut quand il passa Pénuel, et lui allait, boitant de la hanche."
,"33":"C'est pourquoi les fils d'Israël ne mangent pas jusqu'à ce jour le nerf sciatique qui est à l'articulation de la hanche, car c'est à l'articulation de la hanche que Jacob fut touché, au nerf sciatique."
}`)
	CurrentBook.AddChapter(33, `{
"1":"Jacob leva les yeux, Esaü arrivait avec quatre cents hommes. Il répartit donc les enfants autour de Léa, de Rachel et des deux servantes."
,"2":"Il mit en tête les deux servantes et leurs enfants derrière elles, puis Léa et ses enfants et enfin Rachel et Joseph."
,"3":"Quant à lui, il passa devant eux et se prosterna à terre à sept reprises, jusqu'à ce qu'il fût près de son frère."
,"4":"Esaü courut à sa rencontre et l'embrassa. Il se jeta à son cou, le couvrit de baisers et ils pleurèrent tous deux."
,"5":"Lorsqu'Esaü vit les femmes et les enfants, il demanda: 'Que sont-ils pour toi, tous ceux-ci?' Jacob répondit: 'Ce sont les enfants que Dieu a donnés à ton serviteur.'"
,"6":"Alors les servantes s'approchèrent avec leurs enfants et se prosternèrent."
,"7":"S'approchant à leur tour, Léa et ses enfants se prosternèrent. Enfin s'approchèrent Rachel et Joseph et ils se prosternèrent."
,"8":"Esaü dit encore: 'Que signifie toute cette caravane que j'ai rencontrée?' Jacob répondit: 'C'est un cadeau, car je voulais trouver grâce aux yeux de mon seigneur.'"
,"9":"Esaü lui dit: 'J'ai suffisamment pour moi, mon frère. Que tout ceci reste entre tes mains.'"
,"10":"Mais Jacob lui répondit: 'Non! Si j'ai trouvé grâce à tes yeux, accepte ce cadeau de ma main. J'ai cherché à gagner ta faveur, comme on cherche celle de Dieu, et tu m'as accueilli."
,"11":"Accepte donc ce cadeau qui t'a été présenté, car Dieu m'a comblé de tout.' Jacob insista tellement qu'Esaü finit par accepter."
,"12":"'Allons! Mettons-nous en route! dit Esaü, je marcherai devant toi.'"
,"13":"Jacob répondit: 'Mon seigneur sait que les enfants sont fragiles et que j'ai de nombreuses brebis et des vaches qui allaitent. Si on les bouscule un jour seulement, tout le troupeau périra."
,"14":"Que mon seigneur passe donc devant son serviteur, et moi, j'irai à mon pas, au pas du troupeau qui est avec moi et au pas des enfants. En suite j'irai chez mon seigneur à Séïr.'"
,"15":"Esaü lui dit: 'Accepte que je laisse avec toi quelques-uns des hommes qui m'accompagnent.' Jacob répondit: 'A quoi bon? Que je trouve seulement grâce aux yeux de mon seigneur!'"
,"16":"Esaü reprit donc ce jour-là son chemin vers Séïr,"
,"17":"et Jacob partit pour Soukkot. Il y construisit une maison pour lui et des cabanes pour le bétail. C'est pour cela qu'on a appelé cet endroit Soukkot."
,"18":"Lorsque Jacob arriva près de la ville de Sichem, au pays de Canaan, à son retour de Paddân-Aram, il campa en face de la ville."
,"19":"Là, pour cent pièces de monnaie, il acheta une parcelle de terre aux fils de Hamor, père de Sichem, et il y planta sa tente."
,"20":"Il construisit un autel et l'appela El, Dieu d'Israël."
}`)
	CurrentBook.AddChapter(34, `{
"1":"Dinah était la fille de Léa et de Jacob. Comme elle était sortie pour voir les filles du pays,"
,"2":"Sichem, fils de Hamor le Hivvite, prince du pays, la vit et la prit. Il coucha avec elle et la viola."
,"3":"Son coeur s'attacha à Dinah fille de Jacob, il aima la jeune fille et parla à son coeur."
,"4":"Sichem dit à Hamor son père: 'Prends-moi donc cette jeune fille pour femme.'"
,"5":"Jacob apprit qu'il avait souillé Dinah, sa fille; mais comme ses fils étaient dans la campagne avec le troupeau, Jacob garda le silence jusqu'à leur retour."
,"6":"Hamor, le père de Sichem, alla trouver Jacob pour parler avec lui de cette affaire."
,"7":"A leur retour des champs, les fils de Jacob apprirent ce qui s'était passé: scandalisés, ils entrèrent dans une violente colère parce que Sichem venait de commettre une chose inadmissible en Israël: il avait couché avec la fille de Jacob! Cela ne se fait pas!"
,"8":"Hamor leur dit ceci: 'Mon fils Sichem est épris de votre fille, acceptez de la lui donner en mariage."
,"9":"Alliez-vous avec nous par des mariages. Vous nous donnerez vos filles et vous prendrez nos filles."
,"10":"Vous habiterez avec nous, le pays sera vôtre. Habitez-y, parcourez-le et prenez-en possession.'"
,"11":"Sichem dit au père et aux frères de la jeune fille: 'Veuillez me pardonner et je vous donnerai ce que vous me demanderez."
,"12":"Imposez-moi un prix et un cadeau important, je donnerai ce que vous aurez demandé et ensuite vous me donnerez la jeune fille pour qu'elle soit ma femme.'"
,"13":"Les fils de Jacob donnèrent une réponse à Sichem et à son père Hamor, mais c'était seulement pour l'avoir, parce qu'il avait souillé leur soeur Dinah."
,"14":"Ils dirent donc: ' Il ne nous est pas possible de donner notre soeur à un homme incirconcis, ce serait une honte pour nous."
,"15":"Nous ne donnerons notre accord qu'à une seule condition: devenez comme nous, faites circoncire chez vous tous les mâles."
,"16":"Alors nous vous donnerons nos filles et nous prendrons vos filles pour nous, nous habiterons avec vous et nous ne ferons plus qu'un seul peuple."
,"17":"Mais si vous n'êtes pas d'accord, si vous ne vous faites pas circoncire, nous reprendrons notre fille et nous partirons.'"
,"18":"Ce discours plut à Hamor et à son fils Sichem."
,"19":"Le jeune homme ne tarda pas à s'exécuter car il désirait la fille de Jacob. Or il était le plus considéré de toute la maison de son père."
,"20":"Hamor et son fils Sichem vinrent donc à la porte de la ville et s'adressèrent ainsi aux hommes de leur ville:"
,"21":"'Ces gens sont pacifiques, laissons-les habiter le pays avec nous et qu'ils puissent y circuler: le pays est vaste. Nous épouserons leurs filles et nous leur donnerons nos filles."
,"22":"Cependant ces hommes mettent une condition pour habiter avec nous et ne plus faire qu'un seul peuple: nous devons circoncire chez nous tous les mâles comme ils le font chez eux."
,"23":"Ne voyez-vous pas que tout ce qu'ils possèdent nous appartiendra, tous leurs troupeaux, tous leurs animaux? Donnons-leur notre accord et ils habiteront avec nous.'"
,"24":"Tous ceux qui passaient par la porte de la ville écoutèrent Hamor et son fils Sichem. Tous les mâles furent donc circoncis, tous ceux qui passaient par la porte de la ville."
,"25":"Or le troisième jour, comme ils étaient souffrants, deux des fils de Jacob, Siméon et Lévi, frères de Dinah, prirent leur épée, entrèrent sans aucun risque dans la ville et tuèrent tous les mâles."
,"26":"Ils massacrèrent Hamor et son fils Sichem, ils reprirent Dinah dans la maison de Sichem et partirent."
,"27":"Les fils de Jacob dépouillèrent les morts et pillèrent la ville parce qu'on avait souillé leur soeur."
,"28":"Ils prirent leur petit bétail, leur gros bétail, leurs ânes, tout ce qui était dans la ville et tout ce qui était dans les champs."
,"29":"Ils prirent toutes leurs richesses, leurs petits enfants ainsi que leurs femmes, et pillèrent tout ce qui était dans les maisons."
,"30":"Alors Jacob dit à Siméon et à Lévi: 'Vous voulez mon malheur! Vous m'avez rendu odieux aux habitants du pays, aux Cananéens et aux Perizites, et moi je n'ai que très peu d'hommes. Ils vont se réunir contre moi, ils me battront et nous serons exterminés, moi et ma famille.'"
,"31":"Mais ses fils répondirent: 'Est-ce qu'on traite notre soeur comme une prostituée?'"
}`)
	CurrentBook.AddChapter(35, `{
"1":"Dieu dit à Jacob: 'Lève-toi, monte à Béthel. Tu t'établiras là-bas et tu construiras un autel au Dieu qui t'est apparu lorsque tu fuyais devant ton frère Esaü.'"
,"2":"Jacob dit alors à sa famille, à tous ceux qui étaient avec lui: 'Enlevez les idoles étrangères qui sont au milieu de vous; purifiez-vous et changez de vêtements."
,"3":"Puis nous nous lèverons et nous partirons pour Béthel. Là, je construirai un autel au Dieu qui m'a répondu au jour de mon angoisse et qui a été avec moi sur tous mes chemins.'"
,"4":"Ils donnèrent donc à Jacob toutes les idoles étrangères qui étaient en leurs mains, ainsi que les anneaux qu'ils avaient aux oreilles, et Jacob les enterra sous l'arbre qui est près de Sichem."
,"5":"Puis ils se mirent en route et une terreur divine s'empara de toutes les villes qui étaient aux environs, si bien qu'on ne poursuivit pas les fils de Jacob."
,"6":"Jacob arriva avec tout son monde à Louz, c'est-à-dire Béthel, au pays de Canaan."
,"7":"Il construisit là un autel et il appela ce lieu Dieu-de-Béthel, car c'était là que Dieu s'était révélé à lui lorsqu'il fuyait devant son frère."
,"8":"Débora, la nourrice de Rébecca, mourut alors. On l'enterra près de Béthel, sous le chêne auquel on donna le nom de Chêne des Pleurs."
,"9":"Dieu apparut encore à Jacob à son retour de Paddan-Aram et il lui donna cette bénédiction:"
,"10":"'Tu t'appelles Jacob, mais désormais on ne t'appellera plus Jacob: Israël sera ton nom.' On l'appela donc Israël."
,"11":"Puis Dieu lui dit: 'Je suis le Dieu de la Steppe, grandis et multiplie-toi: une nation, un ensemble de nations sortira de toi, et des rois sortiront de ton sang."
,"12":"Je veux te donner, ainsi qu'à ta descendance, le pays que j'ai donné à Abraham et à Isaac.'"
,"13":"Puis Dieu s'éloigna de lui,"
,"14":"et Jacob dressa une pierre sacrée en cet endroit où Dieu lui avait parlé. Il fit une offrande, et il la consacra avec de l'huile."
,"15":"Jacob donna ensuite le nom de Béthel à ce lieu où Dieu lui avait parlé."
,"16":"Ils partirent de Béthel, mais ils n'étaient pas encore arrivés à Efrata lorsque Rachel accoucha. L'accouchement fut difficile et,"
,"17":"tandis qu'elle accouchait péniblement, l'accoucheuse lui dit: 'Ne crains pas, c'est encore un fils que tu vas avoir.'"
,"18":"Elle était sur le point de mourir, déjà elle rendait le dernier soupir, quand elle donna à l'enfant le nom de Ben-Oni (c'est-à-dire: fils de ma douleur). Mais son père l'appela Benjamin (c'est-à-dire: fils de ma main droite)."
,"19":"Rachel mourut et on l'enterra sur la route d'Efrata (c'est Bethléem)."
,"20":"Sur sa tombe Jacob dressa une pierre, c'est la Pierre de la tombe de Rachel que l'on voit encore aujourd'hui."
,"21":"Israël se remit en marche et monta sa tente au-delà de Migdal-Edér."
,"22":"Pendant qu'Israël séjournait dans ce pays, Ruben coucha avec Bila, la concubine de son père, et Israël apprit la chose. Jacob eut douze fils:"
,"23":"Léa donna à Jacob son premier né Ruben, puis Siméon, Lévi et Juda, Issacar et Zabulon."
,"24":"Rachel lui donna Joseph et Benjamin."
,"25":"Bila, servante de Rachel, lui donna Dan et Nephtali."
,"26":"Zilpa, servante de Léa, lui donna Gad et Asher. Ce sont là les fils de Jacob qui naquirent à Paddân-Aram."
,"27":"Jacob revint près d'Isaac son père à Mambré, près de Kiryat-Arba qui est Hébron: c'est là qu'avaient séjourné Abraham et Isaac."
,"28":"Isaac avait alors cent quatre-vingts ans."
,"29":"Il était très affaibli lorsqu'il mourut et fut réuni à ses ancêtres, extrêmement âgé et comblé de jours. Ses fils Esaü et Jacob l'enterrèrent."
}`)
	CurrentBook.AddChapter(36, `{
"1":"Voici la descendance d'Esaü (ou Edom)."
,"2":"Esaü épousa des filles de Canaan: Ada, fille d'Elon le Hittite, Oholibama, fille d'Ana fils de Sibéon le Horite,"
,"3":"Basmat, fille d'Ismaël et soeur de Nébayot."
,"4":"Ada donna un fils à Esaü, Elifaz, et Basmat lui donna Réouel."
,"5":"Oholi bama donna le jour à Yéouch, Yalam et Korah. Ce sont les fils d'Esaü qui naquirent au pays de Canaan."
,"6":"Esaü prit ses femmes, ses fils, ses filles, tous les gens de sa maison, son troupeau, son bétail, tous les biens qu'il avait amassés au pays de Canaan, et il partit au pays de Séïr, loin de son frère Jacob."
,"7":"En effet, leurs biens étaient trop importants pour qu'ils puissent habiter ensemble: la terre qu'ils parcouraient ne suffisait pas pour leurs troupeaux."
,"8":"Esaü habita donc à la montagne de Séïr (Esaü est aussi nommé Edom)."
,"9":"Voici la descendance d'Esaü, l'ancêtre des Edomites, dans la montagne de Séïr."
,"10":"Les fils d'Esaü étaient: Elifaz, le fils d'Ada femme d'Esaü, et Réouel, le fils de Basmat femme d'Esaü."
,"11":"Elifaz eut des fils: Téman, Omar, Séfo, Gatam et Kénaz."
,"12":"Elifaz fils d'Esaü, eut pour concubine Timna, qui lui donna un fils, Amalec. Ceux-ci sont les fils d'Ada femme d'Esaü."
,"13":"Voici les fils de Réouel: Nahat, Zérah, Chamma et Mizza. Ils sont les fils de Basmat femme d'Esaü."
,"14":"Voici les fils d'Oholibama, fille d'Ana, fils de Sibéon, la femme d'Esaü: elle lui donna des fils Yéouch, Yalam et Korah."
,"15":"Voici les chefs des Edomites: fils d'Elifaz premier-né d'Esaü: le chef Téman, le chef Omar, le chef Séfo, le chef Kénaz,"
,"16":"le chef Korah, le chef Gatam, le chef Amalec. Ce sont les chefs d'Elifaz au pays des Edomites: ils sont fils d'Ada."
,"17":"Voici maintenant les fils de Réouel, fils d'Esaü: Le chef Nahat, le chef Zéram, le chef Chamma, le chef Mizza. Ce sont les chefs de Réouel au pays des Edomites: ils sont fils de Basmat, femme d'Esaü."
,"18":"Voici les fils d'Oholibama, la femme d'Esaü: le chef Yéouch, le chef Yalam, le chef Korah. Ce sont les chefs d'Oholibama, fille d'Ana, femme d'Esaü."
,"19":"Voici donc les fils d'Esaü, ainsi que les chefs du pays d'Edom."
,"20":"Voici les fils de Séïr le Horite qui séjournent dans le pays: Lotan, Chobal, Sibéon, Ana,"
,"21":"Dichon, Eser, Dichan sont les chefs des Horites, les fils de Séïr, au pays d'Edom."
,"22":"Hori et Hémam sont les fils de Lotan. Timna était la soeur de Lotan."
,"23":"Voici maintenant les fils de Chobal: Alvan, Manahat, Ebal, Séfo, Onam."
,"24":"Voici les fils de Sibéon: Ayya, Ana. C'est Ana qui trouva les eaux chaudes au désert en faisant paître les ânes de son père Sibéon."
,"25":"Voici les enfants d'Ana: Dichon, Oholibama fille d'Ana."
,"26":"Voici les fils de Dichon: Hemdan, Echban, Yitran, Kéran."
,"27":"Voici les fils d'Eser: Bilhan, Zaavan, Aqan."
,"28":"Voici les fils de Dichan: Ous et Aran."
,"29":"Voici les chefs des Horites: le chef Lotan, le chef Chobal, le chef Sibéon, le chef Ana,"
,"30":"le chef Dichon, le chef Eser, le chef Dichan. Ce sont les chefs des Horites selon leurs clans, dans le pays de Séïr."
,"31":"Voici maintenant les rois qui régnèrent sur les Edomites, avant que ne règne un roi sur Israël."
,"32":"En Edom régna Béla fils de Béor, sa ville était Dinhaba."
,"33":"Béla mourut et Yobab fils de Zérah de Bosra, régna à sa place."
,"34":"Yobab mourut et Oucham du pays des Témanites régna à sa place."
,"35":"Oucham mourut et Hadad fils de Bédad régna à sa place. C'est lui qui battit les Madianites dans les champs de Moab, sa capitale était Avvit."
,"36":"Hadad mourut et Samla de Masréka régna à sa place."
,"37":"Samla mourut et Chaoul de Réhobot-Ha-Nahar régna à sa place."
,"38":"Chaoul mourut et Baal-Hanan fils de Akbor régna à sa place."
,"39":"Baal-Hanan fils d'Akbor mourut et Hadad régna à sa place sa capitale était Paü et sa femme était Méhétabéel, fille de Matred de Mé-Zahab."
,"40":"Voici les noms des autres chefs d'Esaü selon leurs clans et leurs lieux, voici donc leurs noms: le chef Timna, le chef Alva, le chef Yetet,"
,"41":"le chef Oholibama, le chef Ela, le chef Pinon,"
,"42":"le chef Kénaz, le chef Téman, le chef Mibsar,"
,"43":"le chef Magdiel, le chef Iram. Voilà les chefs d'Edom, selon leurs implantations dans le pays qu'ils possédaient. Esaü est l'ancêtre des Edomites."
}`)
	CurrentBook.AddChapter(37, `{
"1":"Quant à Jacob, il demeura dans le pays où ses pères avaient séjourné, c'est-à-dire en Canaan."
,"2":"Voici maintenant les origines du peuple de Jacob. En ce temps-là Joseph était un adolescent de dix-sept ans; comme il gardait le petit bétail avec ses frères, les fils de Bila et les fils de Zilpa, les femmes de son père, il pouvait rapporter à son père le mal que l'on disait d'eux. "
,"3":"Israël préférait Joseph à tous ses autres fils, car il était le fils de sa vieillesse. Il lui avait même fait faire une tunique à manches."
,"4":"Ses frères voyaient que leur père le préférait à tous les autres, aussi ils le détestèrent: ils ne pouvaient plus lui parler amicalement."
,"5":"Joseph eut un rêve qu'il raconta à ses frères."
,"6":"Il leur dit: 'Ecoutez le rêve que j'ai eu."
,"7":"Nous étions en train de ramasser les gerbes au milieu des champs, et voici que ma gerbe se dressa debout, toute droite, pendant que vos gerbes tout autour se prosternaient devant la mienne.'"
,"8":"Ses frères lui répondirent: 'Voudrais-tu par hasard régner sur nous, devenir notre roi et dominer sur nous?' Ils le détestèrent encore plus à cause de ses rêves et de ses interprétations."
,"9":"Il eut un autre rêve qu'il raconta encore à ses frères: 'J'ai eu un rêve, dit-il: le soleil, la lune et onze étoiles se prosternaient devant moi.'"
,"10":"Mais son père le gronda: 'Qu'as-tu donc rêvé là! Devrons-nous, moi, ta mère et tes frères, nous prosterner jusqu'à terre devant toi?'"
,"11":"Ses frères étaient jaloux de lui, mais son père n'oubliait rien de tout cela."
,"12":"Comme ses frères étaient allés faire paître le troupeau de leur père à Sichem,"
,"13":"Israël dit à Joseph: 'Tes frères sont partis vers Sichem pour faire paître le troupeau, il faut que je t'envoie vers eux.' Il répondit: 'Me voici!'"
,"14":"Son père lui dit: 'Va voir comment se portent tes frères et le troupeau: tu me rapporteras les nouvelles.' Il l'envoya donc de la vallée d'Hébron et Joseph arriva à Sichem."
,"15":"Un homme le rencontra alors qu'il errait dans la campagne et lui demanda: 'Que cherches-tu?'"
,"16":"Joseph répondit: 'Je cherche mes frères, peux-tu me dire où ils font paître le troupeau?'"
,"17":"L'homme répondit: 'Ils sont partis d'ici, et je les ai entendus qui disaient: Allons à Dotan.' Joseph alla donc à la recherche de ses frères et les retrouva à Dotan."
,"18":"Ils l'aperçurent de loin et, avant qu'il n'approche, ils complotèrent contre lui pour le faire mourir."
,"19":"Ils se disaient entre eux: 'Voici qu'arrive notre maître en songes!"
,"20":"C'est le moment, tuons-le, jetons-le dans une citerne quelconque et nous dirons qu'une bête sauvage l'a dévoré. Nous verrons bien alors à quoi riment ses songes.'"
,"21":"En entendant cela, Ruben voulut le sauver de leurs mains: 'Ne le frappons pas à mort,' dit-il."
,"22":"Ruben ajouta: 'Ne répandez pas le sang, jetez-le donc dans cette citerne du désert, mais ne portez pas la main sur lui!' Il disait cela pour le sauver de leurs mains, pour le renvoyer à son père."
,"23":"Dès que Joseph arriva auprès de ses frères, ils lui arrachèrent la tunique à manches qu'il portait."
,"24":"Puis ils le prirent et le jetèrent dans la citerne. La citerne était vide: il n'y avait plus d'eau dedans."
,"25":"Ils s'étaient assis pour prendre leur repas quand, levant les yeux, ils aperçurent une caravane d'Ismaélites qui arrivait de Galaad. Leurs chameaux étaient chargés de résine et de parfums précieux qu'ils transportaient en Egypte."
,"26":"Alors Juda dit à ses frères: 'Que gagnerons-nous à tuer notre frère et à cacher son sang?"
,"27":"Vendons-le aux Ismaélites plutôt que de le tuer, car il est notre frère!' Ses frères l'écoutèrent."
,"28":"Des marchands de Madian passaient par là. Ses frères retirèrent Joseph, le firent remonter de la citerne et le vendirent aux Ismaélites pour vingt pièces d'argent. Ceux-ci emmenèrent Joseph en Egypte."
,"29":"Lorsque Ruben revint à la citerne, Joseph n'y était plus: il en déchira ses vêtements!"
,"30":"Puis il revint dire à ses frères: 'Le garçon n'est plus là, que vais-je devenir?'"
,"31":"Ils prirent alors la tunique de Joseph, égorgèrent un bouc et plongèrent la tunique dans son sang."
,"32":"Puis ils envoyèrent la tunique à manches et la firent parvenir à leur père en disant: 'Voici ce que nous avons trouvé. Regarde! N'est-ce pas la tunique de ton fils?'"
,"33":"Jacob la reconnut: 'C'est la tunique de mon fils, dit-il, une bête féroce l'aura dévoré, Joseph a été mis en pièces!'"
,"34":"Jacob déchira ses vêtements, il s'habilla d'un sac et fit le deuil de son fils durant de longs jours."
,"35":"Tous ses fils et toutes ses filles venaient pour le consoler, mais il refusait de se consoler, car il disait: 'Je garderai le deuil jusqu'à ce que j'aille rejoindre mon fils au séjour des morts.' Et son père le pleura."
,"36":"Quant aux Madianites, ils vendirent Joseph en Egypte à Putifar, un fonctionnaire chef des gardes dans le palais du Pharaon."
}`)
	CurrentBook.AddChapter(38, `{
"1":"Dans ce temps-là Juda se sépara de ses frères et se rendit chez un certain Hira d'Adoullam."
,"2":"Là il fit connaissance de la fille d'un Cananéen nommé Choua, il l'épousa et s'unit à elle."
,"3":"Elle devint enceinte et donna le jour à un fils qu'elle appela Er."
,"4":"De nouveau elle fut enceinte et donna le jour à un fils qu'elle appela Onan."
,"5":"Plus tard elle donna encore le jour à un fils qu'elle appela Chéla. Elle le mit au monde à Kézib."
,"6":"Juda prit pour son premier-né Er, une femme du nom de Tamar."
,"7":"Mais Er, le premier-né de Juda, déplut à Yahvé et Yahvé le fit mourir."
,"8":"Juda dit alors à Onan: 'Va vers la femme de ton frère et remplis envers elle ton devoir de beau-frère: donne un descendant à ton frère.'"
,"9":"Mais Onan savait que cet enfant ne serait pas pour lui, aussi, quand il s'unissait à la femme de son frère, il se retirait et se souillait à terre pour ne pas donner de descendance à son frère."
,"10":"En agissant ainsi il déplut à Yahvé qui le fit mourir lui aussi."
,"11":"Alors Juda dit à sa belle-fille Tamar: 'Retourne vivre chez ton père comme une veuve, le temps que mon fils Chéla ait grandi.' Il se disait en effet: 'Je ne veux pas que celui-ci meure comme ses frères.' Tamar s'en retourna donc chez son père."
,"12":"Après de longs jours, la femme de Juda, fille de Choua, mourut. Les jours de deuil étant passés, Juda monta à Timna avec Hira, son ami d'Adoullam, pour voir ses tondeurs de brebis."
,"13":"On l'annonça à Tamar: 'Voici que ton beau-père monte à Timna pour tondre son petit bétail.'"
,"14":"Aussitôt elle ôta ses habits de veuve, se couvrit d'un voile et, ainsi voilée, elle s'assit à l'entrée d'Enayim sur la route de Timna. C'est que Tamar voyait qu'on ne lui avait pas donné Chéla qui pourtant avait grandi."
,"15":"Quand Juda la vit avec son visage voilé, il la prit pour une prostituée."
,"16":"Ne sachant pas que c'était sa belle-fille, il s'approcha d'elle sur la route et lui dit: 'Laisse-moi coucher avec toi'. Elle lui répondit: 'Que me donneras-tu pour coucher avec moi?'"
,"17":"Il lui dit: 'Je te donnerai un chevreau de mon troupeau.' Elle répondit: 'Quel gage me donneras-tu en attendant de l'envoyer?'"
,"18":"Juda lui dit: 'Quel gage veux-tu que je te donne?' 'Le sceau que tu portes au cou avec son cordon, répondit elle, ainsi que le bâton que tu as dans la main.' Il les lui donna et coucha avec elle: il la laissa enceinte."
,"19":"Quand elle s'en retourna, elle ôta son voile et reprit ses habits de veuve."
,"20":"Juda envoya le chevreau par son ami d'Adoullam afin de reprendre les gages de la main de la femme, mais celui-ci ne la trouva pas."
,"21":"Il interrogea les gens de l'endroit: 'Où est la prostituée qu'on voyait sur la route à Enayim?' Ils répondirent: 'Il n'y a jamais eu de prostituée ici!'"
,"22":"Il revint donc vers Juda et lui dit: 'Je ne l'ai pas trouvée, et même les gens de l'endroit m'ont dit: Il n'y a jamais eu de prostituée ici.'"
,"23":"Juda lui répondit: 'Qu'elle garde tout pour elle, cela vaut mieux pour nous que d'être tournés en ridicule. Tu ne l'as peut-être pas trouvée, mais moi, j'ai bien envoyé le chevreau!'"
,"24":"Or voici que trois mois plus tard on avertit Juda: 'Ta belle-fille Tamar s'est prostituée; la voilà même enceinte à la suite de sa prostitution.' Juda répondit: 'Faites-la sortir et qu'elle soit brûlée!'"
,"25":"Comme on l'emmenait, elle envoya dire à son beau-père: 'Je suis enceinte de l'homme à qui appartiennent ces objets. Reconnais à qui appartiennent ce sceau et son cordon ainsi que ce bâton.'"
,"26":"Juda les reconnut et dit: 'Elle est plus juste que moi, car je ne lui ai pas donné mon fils Chéla.' Mais ensuite il n'eut plus de rapports avec elle."
,"27":"Quand arriva le temps où elle devait accoucher, il y avait deux jumeaux dans son ventre."
,"28":"Tandis qu'elle accouchait, l'un d'eux sortit une main; l'accoucheuse la prit et y attacha un fil de couleur rouge en disant: 'Celui-ci est sorti le premier.'"
,"29":"Mais il rentra sa main et c'est son frère qui sortit. Elle dit alors: 'Quelle brèche tu as faite!' Et l'on donna à l'enfant le nom de Farès."
,"30":"Ensuite sortit son frère qui avait à sa main le fil rouge; on lui donna le nom de Zérakh."
}`)
	CurrentBook.AddChapter(39, `{
"1":"Joseph avait donc été vendu en Egypte: Putifar, un Egyptien, fonctionnaire du Pharaon et chef des gardes, l'avait acheté aux Ismaélites qui l'avaient emmené là-bas."
,"2":"Mais Yahvé était avec Joseph, et il lui donna de réussir: il resta dans la maison de son maître l'Egyptien."
,"3":"Son maître remarqua que Yahvé était avec lui et faisait réussir tout ce qu'il entreprenait."
,"4":"Joseph fut donc bien apprécié de lui dans tout son service. Son maître en fit le chef de sa maison et lui confia toutes ses affaires."
,"5":"Lorsqu'il l'eut mis à la tête de sa maison et de tous ses biens, Yahvé bénit la maison de l'Egyptien à cause de Joseph, et la bénédiction de Yahvé s'étendit à tout ce qui lui appartenait, aussi bien dans la maison que dans les champs."
,"6":"Aussi, après avoir confié à Joseph tout ce qui lui appartenait, il ne s'occupait plus de rien, si ce n'est de sa propre nourriture. Or Joseph avait une belle allure et un beau visage."
,"7":"La femme de son maître s'éprit de lui et lui dit: 'Couche avec moi!'"
,"8":"Mais Joseph refusa et dit à la femme de son maître: 'Mon maître me fait entièrement confiance pour tout ce qui regarde sa maison, il m'a confié tout ce qui lui appartient."
,"9":"Il n'est pas plus écouté que moi dans cette maison, et il ne me refuse rien sinon toi, parce que tu es sa femme. Comment pourrais-je faire une chose pareille et pécher contre Dieu?'"
,"10":"Tous les jours, elle redisait la même chose à Joseph, mais il ne l'écoutait pas: il refusait de se coucher à ses côtés et de se donner à elle."
,"11":"Or voici qu'un jour, quand il entrait dans la maison pour faire son travail, il n'y avait dans la maison aucun des serviteurs."
,"12":"Alors elle le saisit par son habit et lui dit: 'Couche avec moi!' Mais il lui laissa son habit dans la main et sortit en courant."
,"13":"Quand elle vit qu'il s'était enfui dehors en lui laissant son habit dans la main,"
,"14":"elle appela les gens de sa maison et leur dit: 'Regardez! On nous a amené un Hébreu pour prendre du plaisir avec nous. Il s'est approché de moi pour coucher avec moi, mais j'ai crié de toutes mes forces."
,"15":"Quand il a entendu que j'élevais le ton et que je criais, il est sorti en courant et son habit m'est resté entre les mains.'"
,"16":"Elle garda donc son habit à côté d'elle jusqu'au retour du maître à la maison."
,"17":"Et voici comment elle lui raconta les choses: 'Le serviteur hébreu que tu nous a amené s'est approché de moi pour prendre son plaisir avec moi."
,"18":"Mais, lorsqu'il a entendu que j'élevais le ton et que je criais, il s'est enfui et son habit m'est resté entre les mains.'"
,"19":"Lorsque son maître entendit le rapport de sa femme: 'Et voilà ce qu'a fait ton serviteur ', il se mit en colère."
,"20":"Il fit saisir Joseph et le fit jeter dans la prison où l'on enfermait les prisonniers du roi. C'est là que Joseph fut emprisonné. "
,"21":"Mais Yahvé était avec Joseph, et il continua de le favoriser, de sorte que Joseph fut bien considéré par le chef de la prison."
,"22":"Celui-ci donna autorité à Joseph sur tous les prisonniers qui étaient enfermés là, et c'est lui qui leur faisait faire tout ce qu'il y avait à faire."
,"23":"Le chef de la prison ne contrôlait même plus tout ce que Joseph décidait, parce que Yahvé était avec lui, et tout ce qu'il entreprenait, Yahvé le lui faisait mener à bien."
}`)
	CurrentBook.AddChapter(40, `{
"1":"Or il arriva que deux fonctionnaires du roi d'Egypte, le responsable des boissons et le responsable du pain, furent pris en faute envers leur maître, le roi d'Egypte."
,"2":"Le Pharaon se mit en colère contre ces deux fonctionnaires"
,"3":"et les fit enfermer dans la maison du chef des gardes, dans la prison où se trouvait Joseph."
,"4":"Le chef des gardes préposa Joseph à leur service et ils restèrent un certain temps dans cette prison."
,"5":"C'est alors que le chef du service des boissons et le chef du service des pains qui étaient enfermés dans la prison, eurent tous les deux un rêve dans la même nuit, et les deux rêves demandaient une interprétation."
,"6":"Au matin Joseph s'approcha d'eux; il vit qu'ils étaient tourmentés."
,"7":"Il demanda donc à ces fonctionnaires du Pharaon, prisonniers avec lui dans la maison de son maître: 'Pourquoi vos visages sont-ils si tristes aujourd'hui?'"
,"8":"Ils répondirent: 'Nous avons eu un rêve, et personne ne peut nous l'expliquer.' Joseph leur dit: 'Mais c'est Dieu seul qui peut donner l'interprétation des rêves. Racontez-les moi donc!'"
,"9":"Le chef du service des boissons raconta à Joseph le songe qu'il avait fait: 'Je voyais en songe une vigne devant moi,"
,"10":"et sur le pied de vigne, trois branches. La vigne bourgeonna, les fleurs se formèrent et les grappes de raisins mûrirent."
,"11":"Comme je tenais dans ma main la coupe du Pharaon, je pris les raisins et je les pressai dans la coupe du Pharaon, puis je lui mis la coupe entre les mains.'"
,"12":"Joseph lui dit: 'Voici la signification de ce rêve: Les trois branches sont trois jours."
,"13":"Encore trois jours et tu pourras marcher la tête haute. Le Pharaon te rétablira à ton poste et de nouveau tu mettras la coupe dans la main du Pharaon, comme tu le faisais lorsque tu étais le responsable du service des boissons."
,"14":"Souviens-toi de moi lorsque tout ira bien pour toi; aie la bonté de parler de moi au Pharaon pour qu'il me fasse sortir de cette prison,"
,"15":"car j'ai été enlevé de force au pays des Hébreux et ici même, je n'ai rien fait pour mériter la prison.'"
,"16":"Le chef du service du pain vit que le songe était favorable, aussi il dit à Joseph: 'Et moi, voici mon rêve: j'avais sur la tête trois corbeilles de pain blanc."
,"17":"Dans la corbeille du haut il y avait de toutes les pâtisseries que le boulanger prépare pour Pharaon, et les oiseaux du ciel les mangeaient dans la corbeille au-dessus de ma tête.'"
,"18":"Joseph prit la parole et lui dit: 'Voici la signification de ton rêve: les trois corbeilles sont trois jours;"
,"19":"encore trois jours et toi aussi tu auras la tête haute: le Pharaon te pendra à un arbre et les oiseaux mangeront ta chair.'"
,"20":"Or le troisième jour, c'était l'anniversaire du Pharaon et il fit un grand repas pour tous ses serviteurs. Il se souvint alors du chef du service des boissons et du chef du service du pain."
,"21":"Il rétablit le chef du service des boissons dans sa charge, et de nouveau celui-ci mit la coupe dans la main du Pharaon."
,"22":"Par contre il fit pendre le chef du service du pain, comme Joseph l'avait annoncé."
,"23":"Le chef du service des boissons, pour sa part, ne pensa plus à Joseph, il l'oublia même complètement."
}`)
	CurrentBook.AddChapter(41, `{
"1":"Deux ans plus tard, le Pharaon eut également un rêve. Il se trouvait sur les bords du Nil"
,"2":"et il voyait monter du Nil sept vaches de belle apparence, bien grasses, qui paissaient au milieu des roseaux."
,"3":"Mais bientôt sept autres vaches montèrent du Nil: elles étaient laides et très maigres. Elles se rangèrent à côté des premières, sur la rive du Nil,"
,"4":"et ces vaches laides et très maigres mangèrent les sept vaches de belle apparence et bien grasses. C'est alors que le Pharaon s'éveilla. "
,"5":"Il se rendormit et eut un second rêve: sept épis montaient d'une seule tige, ils étaient lourds et bons."
,"6":"Mais bientôt, sept épis maigres et roussis par le vent d'est poussèrent à côté d'eux,"
,"7":"et ces épis maigres dévorèrent les sept épis lourds et pleins. C'est alors que le Pharaon s'éveilla et se rendit compte que c'était un rêve."
,"8":"A son réveil, le matin suivant, le Pharaon avait l'esprit troublé. Il convoqua donc tous les magiciens d'Egypte et tous les sages. Pharaon leur raconta les songes qu'il avait eus, mais personne ne pouvait lui en donner la signification."
,"9":"Alors le chef du service des boissons parla à Pharaon: 'Je vais aujourd'hui rappeler ma faute!"
,"10":"Le Pharaon s'était mis en colère contre ses serviteurs, et il m'avait enfermé dans la maison du chef des gardes, moi et le chef du service des pains."
,"11":"Or dans la même nuit nous avons eu un rêve, lui et moi, et les deux rêves demandaient une interprétation."
,"12":"Il y avait avec nous un jeune Hébreu, serviteur du chef des gardes, et quand nous lui avons raconté nos rêves, il nous les a expliqués, donnant à chacun la signification du songe qu'il avait eu."
,"13":"Et tout est arrivé comme il nous l'avait dit: j'ai été rétabli à mon poste, et l'autre a été pendu.'"
,"14":"Pharaon envoya donc chercher Joseph. Vite, on le sortit de la prison; on le rasa et il changea de vêtements pour se présenter devant le Pharaon."
,"15":"Le Pharaon dit à Joseph: 'J'ai eu un rêve et il n'y a personne pour me l'expliquer. Mais j'ai entendu dire que lorsqu'on te raconte un rêve, tu en donnes la signification.'"
,"16":"Joseph répondit au Pharaon: 'Ce n'est pas moi, c'est Dieu qui donnera la bonne réponse au Pharaon.'"
,"17":"Le Pharaon raconta donc le songe à Joseph: 'Je me tenais au bord du Nil, "
,"18":"et voici que du Nil montaient sept vaches bien grasses et de belle apparence, qui se mirent à paître au milieu des roseaux."
,"19":"Mais aussitôt derrière elles montèrent sept autres vaches malades, affreuses à voir, et si maigres que je n'en ai jamais vu de si laides dans toute l'Egypte."
,"20":"Les vaches maigres et laides mangèrent les sept premières vaches, celles qui étaient bien grasses."
,"21":"Mais quand elles les eurent avalées, on pouvait se demander où elles les avaient mises, car elles étaient toujours aussi laides qu'auparavant. C'est alors que je me suis réveillé."
,"22":"Et puis j'ai eu un autre rêve: sept épis montaient d'une seule tige, ils étaient remplis et beaux,"
,"23":"mais bientôt, sept épis secs, maigres, brûlés par le vent d'est, poussèrent à côté d'eux."
,"24":"Alors les épis maigres avalèrent les sept bons épis. J'en ai parlé aux magiciens, mais personne n'a pu me donner d'explication.'"
,"25":"Joseph dit au Pharaon: 'Les deux songes du Pharaon ne font qu'un. Dieu a révélé au Pharaon ce qu'il va faire."
,"26":"Les sept bonnes vaches sont sept années, et les sept bons épis sont sept années: c'est le même songe."
,"27":"Les sept vaches maigres et laides qui montaient derrière elles sont encore sept années, comme les sept épis vides, brûlés par le vent d'est: ce sont les sept mêmes années de famine."
,"28":"C'est ce que j'ai dit au Pharaon: Dieu a fait connaître au Pharaon ce qu'il va faire."
,"29":"Voici qu'arrivent pour l'Egypte sept années de grande abondance,"
,"30":"mais après elles viendront sept années de famine. L'Egypte oubliera le temps de l'abondance, car la famine dévorera le pays."
,"31":"On ne se souviendra plus de l'abondance dans le pays, tant sera grande la famine qui suivra."
,"32":"Si le songe a été par deux fois répété au Pharaon, c'est que la chose est bien décidée de la part de Dieu, et que Dieu va se dépêcher de l'accomplir."
,"33":"Aussi, dès maintenant, il faut que Pharaon choisisse un homme intelligent et sage pour gouverner toute l'Egypte."
,"34":"Le Pharaon établira des fonctionnaires sur tout le pays de façon à prélever le cinquième des récoltes d'Egypte pendant les années d'abondance."
,"35":"Les fonctionnaires ramasseront toute la nourriture de ces bonnes années qui viennent et, sous l'autorité du Pharaon, ils feront des réserves de blé dans les villes et les garderont."
,"36":"Il y aura ainsi de la nourriture en réserve dans le pays, en vue des sept années de famine qui viendront en Egypte, et le pays ne sera pas ruiné par la famine.'"
,"37":"Ce discours plut au Pharaon et à tous ses serviteurs."
,"38":"Le Pharaon se tourna vers ses serviteurs et leur dit: 'Trouverons-nous un homme qui ait comme lui l'esprit de Dieu?'"
,"39":"Puis le Pharaon dit à Joseph: 'Après que Dieu t'a révélé tout cela, il n'y a sûrement personne d'aussi intelligent et capable que toi."
,"40":"C'est donc toi qui seras à la tête de ma maison, et tout le peuple sera soumis à tes ordres. Seul le trône me fera plus grand que toi.'"
,"41":"Le Pharaon dit encore à Joseph: 'Regarde, je t'ai donné autorité sur tout le pays d'Egypte.'"
,"42":"Alors le Pharaon enleva son anneau pour le passer au doigt de Joseph, il le revêtit d'habits de lin fin et mit un collier d'or à son cou."
,"43":"Il le fit monter sur le second de ses chars, et l'on criait devant lui: 'Prosternez-vous!' Ce qui revenait à le mettre au-dessus de toute l'Egypte."
,"44":"Le Pharaon dit alors à Joseph: 'Je suis le Pharaon: sans ton ordre, personne ne lèvera la main ou le pied dans tout le pays d'Egypte!'"
,"45":"Le Pharaon donna à Joseph le nom de Sofnat-Panéah, et il lui donna pour femme Asnat, fille de Poti-Phéra, prêtre d'On."
,"46":"Joseph avait trente ans quand il se présenta devant Pharaon, le roi d'Egypte. Joseph se retira de devant le Pharaon et commença à parcourir tout le pays d'Egypte. "
,"47":"Pendant les sept années d'abondance, la terre produisit en quantité."
,"48":"Il rassembla donc toute la nourri ture de ces sept années où l'abondance régnait en Egypte, et la mit en réserve dans les villes. Il rassembla à l'intérieur des villes la nourriture qui venait de la campagne."
,"49":"Ainsi Joseph entassa une quantité de blé impossible à compter, comme le sable de la mer: oui c'était vraiment sans mesure!"
,"50":"Avant l'arrivée de la famine, Asnat, fille de Poti-Phéra, prêtre d'On, donna à Joseph deux fils."
,"51":"Joseph appela l'aîné Manassé car, dit-il: 'Dieu m'a fait oublier toute ma peine et la maison de mon père.'"
,"52":"Et le second, il l'appela Ephraïm, car, dit-il: 'Dieu m'a fait grandir dans le pays de ma misère.'"
,"53":"Après les sept années d'abondance du pays d'Egypte,"
,"54":"arrivèrent les sept années de famine, comme l'avait annoncé Joseph. C'était la famine dans tous les pays, mais en Egypte il y avait du pain."
,"55":"Puis l'Egypte à son tour connut la faim et le peuple fit appel au Pharaon pour avoir du pain. Le Pharaon dit à toute l'Egypte: 'Allez trouver Joseph, et faites ce qu'il vous dira.'"
,"56":"La famine s'aggravait dans tout le pays. Alors Joseph ouvrit les réserves et vendit du blé à l'Egypte au fur et à mesure que la famine s'y installait."
,"57":"De tous les pays on venait aussi en Egypte pour acheter du blé à Joseph, car la famine était grande sur toute la terre."
}`)
	CurrentBook.AddChapter(42, `{
"1":"Jacob apprit qu'il y avait du blé en Egypte; il dit à ses fils: 'Pourquoi restez-vous à vous regarder les uns les autres?'"
,"2":"Il ajouta: 'J'ai entendu dire qu'il y a du blé en Egypte. Descendez-y donc, achetez-nous du blé, c'est une question de vie ou de mort.'"
,"3":"Les frères de Joseph descendirent donc à dix pour acheter du blé en Egypte."
,"4":"Jacob n'avait pas envoyé Benjamin, le frère de Joseph, avec ses frères, car il se disait: 'Il ne faudrait pas qu'il lui arrive malheur!'"
,"5":"Les fils d'Israël arrivèrent donc avec tous ceux qui entraient dans le pays pour acheter du blé, car la famine régnait en Canaan."
,"6":"Comme Joseph était le premier ministre du pays, c'est lui qui vendait le blé à tous les gens du pays. Quand les frères de Joseph arrivèrent, ils se prosternèrent devant lui la face contre terre."
,"7":"Joseph vit ses frères et les reconnut, mais il ne se fit pas reconnaître par eux. Il leur parla même sévèrement: 'D'où venez-vous?' leur dit-il, 'De Canaan, répondirent-ils, pour acheter du blé et avoir de quoi manger.'"
,"8":"Joseph avait reconnu ses frères, mais eux ne l'avaient pas reconnu."
,"9":"Joseph se souvint alors des songes qu'il avait eus à leur sujet. Il leur dit: 'Vous êtes des espions! C'est pour voir les secrets du pays que vous êtes venus.'"
,"10":"'Non, mon seigneur, répondirent-ils, tes serviteurs sont venus pour acheter du blé et pouvoir manger."
,"11":"Nous sommes tous fils d'un même père, nous disons la vérité. Tes serviteurs ne sont pas des espions.'"
,"12":"Il leur dit: 'Non! C'est pour voir les secrets du pays que vous êtes venus!'"
,"13":"Ils répondirent: 'Tes serviteurs étaient douze frères, fils d'un même père en Canaan. Le plus petit est avec notre père en ce moment, et l'autre n'est plus.'"
,"14":"Joseph leur dit: 'J'ai dit que vous êtes des espions!"
,"15":"Mais je vais vous mettre à l'épreuve. Par la vie du Pharaon, vous ne partirez pas d'ici avant que votre plus jeune frère ne soit venu."
,"16":"Envoyez l'un d'entre vous chercher votre frère, et durant ce temps vous resterez en prison pour que l'on vérifie vos paroles; on verra bien si vous dites la vérité. Sinon, aussi vrai que Pharaon est vivant, vous n'êtes que des espions.'"
,"17":"Il les enferma donc pendant trois jours."
,"18":"Le troisième jour, Joseph leur dit: 'Je veux que vous puissiez vivre, car je crains Dieu."
,"19":"Si vous avez dit la vérité, qu'un seul d'entre vous reste enfermé ici dans la prison, et les autres s'en iront avec le blé pour que vos familles ne connaissent pas la faim."
,"20":"Puis vous ramènerez votre plus jeune frère afin que l'on vérifie vos paroles: ainsi vous ne mourrez pas.' On fit ainsi."
,"21":"Ils se disaient l'un à l'autre: 'Hélas! Nous sommes en train de payer à cause de notre frère; nous avons vu son angoisse quand il nous suppliait et nous avons refusé de l'entendre. C'est pour cela que tout ce malheur nous arrive.'"
,"22":"Alors Ruben leur dit: 'Ne vous avais-je pas avertis: Ne péchez pas contre cet enfant! Mais vous avez refusé de m'entendre, et aujourd'hui, nous payons pour sa mort.'"
,"23":"Ils ne savaient pas que Joseph comprenait tout, car il leur avait parlé avec un interprète."
,"24":"Joseph s'éloigna d'eux pour pleurer. Puis il revint vers eux, et de nouveau leur parla. Il prit l'un d'eux, Siméon, et le fit enchaîner sous leurs yeux."
,"25":"Ensuite, Joseph ordonna de remplir de blé leurs sacs, de remettre l'argent de chacun dans son sac, et de leur donner des provisions pour la route. C'est ce que l'on fit."
,"26":"Ils emportèrent donc leur blé sur leurs ânes et ils s'en retournèrent."
,"27":"A la halte de la nuit, l'un deux ouvrit son sac pour donner du fourrage à son âne, et il aperçut son argent à l'entrée de son sac."
,"28":"Il dit à ses frères: 'On m'a rendu mon argent, il est là de nouveau dans mon sac!' Très inquiets, ils se regardèrent alors l'un l'autre en tremblant. 'Qu'est-ce que Dieu nous a fait là?' dirent-ils."
,"29":"Quand ils arrivèrent en Canaan, près de leur père Jacob, ils lui racontèrent toutes leurs aventures:"
,"30":"'L'homme qui dirige le pays nous a parlé sévèrement et nous a traités d'espions."
,"31":"Nous lui avons répondu: Nous disons la vérité, nous ne sommes pas des espions."
,"32":"Nous étions douze frères, fils d'un même père. L'un d'entre nous n'est plus, et le plus jeune est en ce moment avec notre père en Canaan."
,"33":"Alors ce maître du pays nous a dit: C'est bien là que je vais voir si vous dites la vérité: laissez près de moi l'un d'entre vous, prenez de quoi mettre vos familles à l'abri de la famine, et partez!"
,"34":"Puis vous me ramènerez votre plus jeune frère, et je verrai que vous n'êtes pas des espions mais que vous dites bien la vérité. Je vous rendrai votre frère et vous pourrez circuler librement dans le pays.'"
,"35":"Or, comme ils vidaient leurs sacs, chacun trouva dans son sac une bourse avec son argent. Quand ils virent, et leur père aussi, les bourses avec leur argent, ils eurent peur."
,"36":"Leur père Jacob leur dit alors: 'Vous me privez de mes enfants: Joseph n'est plus, Siméon n'est plus, et vous voulez me prendre Benjamin! C'est sur moi que retombe tout cela.'"
,"37":"Ruben dit à son père: 'Tu pourras mettre à mort mes deux fils, si je ne te ramène pas Benjamin. Confie-le moi, et je le ferai revenir près de toi.'"
,"38":"Jacob lui répondit: 'Mon fils ne descendra pas avec vous, car son frère est mort et il reste seul. S'il lui arrivait malheur au cours de votre aventure, vous feriez descendre mes cheveux blancs dans la tristesse au séjour des morts.'"
}`)
	CurrentBook.AddChapter(43, `{
"1":"La famine s'était aggravée dans le pays;"
,"2":"quand on eut fini de manger le blé qu'ils avaient ramené d'Egypte, le père leur dit: 'Retournez acheter un peu de nourriture pour nous.'"
,"3":"Mais Juda lui dit: 'L'homme nous l'a dit clairement: Il est inutile de vous présenter devant moi sans votre frère!"
,"4":"Si tu envoies notre frère avec nous, nous descendrons et nous t'achèterons de la nourriture."
,"5":"Mais si tu ne l'envoies pas, nous ne descendrons pas, car l'homme nous a bien dit: Inutile de vous présenter devant moi sans votre frère!'"
,"6":"Alors Israël leur dit: 'Pourquoi avez-vous dit à cet homme que vous aviez encore un frère? Vous avez fait mon malheur.'"
,"7":"Ils répondirent: 'L'homme nous a tellement questionné sur nous, sur notre famille! Il nous a dit: Est-ce que votre père est encore vivant? Avez-vous un frère? Alors nous avons répondu à ses questions et nous l'avons renseigné. Pouvions-nous deviner qu'il nous dirait: Amenez-moi votre frère?'"
,"8":"Juda dit alors à son père Israël: 'Envoie le jeune homme avec moi, que nous puissions prendre le départ: c'est une question de vie ou de mort pour toi et pour nos petits enfants."
,"9":"Je répondrai pour lui, c'est à moi que tu demanderas compte de lui. Si je ne te le ramène pas, si je ne te le rends pas, je serai coupable à jamais devant toi."
,"10":"Mais si nous n'avions pas tant tardé, nous serions déjà revenus deux fois.'"
,"11":"Leur père Israël leur dit: 'S'il en est ainsi, faites donc ce que je vous dis. Prenez dans vos sacs des produits du pays, et emportez-les pour faire un cadeau à cet homme: un peu de résine pour le brûle- parfum, un peu de miel, de la gomme parfumée, des pistaches et des amandes."
,"12":"Puis emportez le double d'argent, ainsi vous rendrez l'argent qu'on a remis dans vos sacs: peut-être est-ce une erreur."
,"13":"Prenez donc votre frère, et allez retrouver cet homme."
,"14":"Que le Dieu de la Steppe vous accorde de trouver grâce à ses yeux, pour qu'il vous laisse repartir avec votre frère et avec Benjamin. Quant à moi, si je dois être privé de mes enfants, que j'en sois privé!'"
,"15":"Les hommes chargèrent donc ces cadeaux et prirent le double d'argent, ils emmenèrent aussi Benjamin. Ils descendirent en Egypte et se présentèrent devant Joseph."
,"16":"Lorsque Joseph vit que Benjamin était avec eux, il dit à son intendant: 'Fais entrer ces hommes chez moi, fais tuer une bête et préparer la viande, car ces hommes mangeront avec moi à midi.'"
,"17":"L'intendant fit ce que Joseph avait commandé; il conduisit les hommes dans la maison de Joseph."
,"18":"Quand on les fit entrer dans la maison de Joseph, les hommes eurent peur. Ils se disaient: 'C'est à cause de l'argent qu'on a remis dans nos sacs la fois précédente, qu'ils nous font entrer. Ils vont se jeter sur nous tout-à-coup et ils nous prendront comme esclaves avec nos ânes!'"
,"19":"Aussi, dès leur arrivée à la maison, ils se dirigèrent vers l'intendant de Joseph. Ils lui dirent: "
,"20":"'De grâce, mon seigneur, nous sommes déjà venus il y a quelque temps pour acheter de la nourriture."
,"21":"Il s'est trouvé qu'à la halte du soir, lorsque nous avons ouvert nos sacs, l'argent de chacun d'entre nous, avec le compte exact, était à l'entrée de son sac. Aussi l'avons-nous rapporté."
,"22":"Nous ne savons pas qui avait mis notre argent dans nos sacs, mais nous avons pris une nouvelle somme d'argent pour acheter de la nourriture.'"
,"23":"Il leur répondit: 'Soyez en paix, soyez sans crainte: votre Dieu, le Dieu de votre père a mis pour vous un trésor dans vos sacs, car votre argent m'était bien parvenu.' Puis il fit délier Siméon devant eux."
,"24":"L'homme fit entrer les frères dans la maison de Joseph. Il leur donna de l'eau et ils se lavèrent les pieds. On donna aussi du fourrage à leurs ânes."
,"25":"Alors ils préparèrent leur cadeau en attendant l'arrivée de Joseph, car on leur avait dit qu'ils prendraient là leur repas de midi."
,"26":"Quand Joseph rentra à la maison, ils lui offrirent le cadeau qu'ils avaient dans les mains, puis ils se prosternèrent jusqu'à terre devant lui."
,"27":"Il leur demanda comment ils allaient: 'Votre père, dit-il, ce vieillard dont vous m'avez parlé, est-il en bonne santé? Est-il toujours en vie?'"
,"28":"Ils lui répondirent: 'Ton serviteur, notre père, est en bonne santé, il est encore vivant.' Puis ils s'agenouillèrent et se prosternèrent."
,"29":"Joseph leva les yeux et vit son frère Benjamin, le fils de sa mère: 'Est-ce bien là votre plus jeune frère dont vous m'avez parlé?' Se tournant vers lui, il lui dit: 'Que Dieu te bénisse, mon fils!'"
,"30":"Alors, soudain, Joseph eut envie de pleurer car il était bouleversé à la vue de son frère. Il entra donc dans ses appartements et pleura."
,"31":"Puis il se lava le visage et sortit. Il se reprit et dit: 'Servez le repas!'"
,"32":"On servit Joseph à part, on servit à part ses frères, à part encore les Egyptiens invités; car les Egyptiens ne peuvent pas prendre un repas avec des Hébreux: ce serait une honte pour l'Egypte."
,"33":"Ils s'assirent donc en face de lui, chacun selon son rang, de l'aîné jusqu'au plus jeune. Ils se regardaient l'un l'autre, stupéfaits."
,"34":"Alors Joseph prit dans les plats qui étaient devant lui des portions pour chacun d'eux, mais la portion de Benjamin était cinq fois plus grande que la portion des autres. Avec lui ils burent du vin au point d'être plutôt gais."
}`)
	CurrentBook.AddChapter(44, `{
"1":"Alors Joseph donna cet ordre à son intendant: 'Remplis de nourriture les sacs de ces hommes, autant qu'ils peuvent en emporter, et remets l'argent de chacun à l'entrée de son sac."
,"2":"Puis tu mettras ma coupe, la coupe d'argent, à l'entrée du sac du plus jeune, avec l'argent de son blé.' L'intendant fit donc ce que Joseph avait commandé."
,"3":"Au lever du jour, on renvoya ces hommes avec leurs ânes."
,"4":"Ils venaient tout juste de sortir de la ville, ils n'étaient donc pas très loin, lorsque Joseph dit à son intendant: 'Lance-toi à la poursuite de ces hommes et, lorsque tu les auras rejoints, tu leur diras: Pourquoi avez-vous rendu le mal pour le bien?"
,"5":"Pourquoi avez-vous volé la coupe en argent de mon maître? N'est-ce pas celle dans laquelle il boit et avec laquelle il pratique la divination? Ce que vous avez fait là va vous porter malheur.'"
,"6":"L'intendant courut donc les rejoindre et leur répéta les paroles de Joseph."
,"7":"Ils lui répondirent: 'Pourquoi mon seigneur nous parle-t-il de cette façon? Nous n'avons pas l'habitude d'agir ainsi!"
,"8":"L'argent que nous avions trouvé sur le dessus de nos sacs, nous l'avons rapporté du pays de Canaan. Comment donc aurions-nous volé de l'argent ou de l'or dans la maison de ton maître?"
,"9":"Si tu trouves cette coupe sur l'un de tes serviteurs, qu'il soit mis à mort, et que nous devenions les esclaves de mon seigneur.'"
,"10":"Il leur dit: 'Soit! je vais vous juger sur vos paroles. Celui chez qui l'on trouvera la coupe sera mon esclave, et vous, vous serez libres.'"
,"11":"Sans perdre de temps, chacun déposa à terre son sac de blé et l'ouvrit."
,"12":"La fouille commença par l'aîné, et finit par le plus jeune: on trouva la coupe dans le sac de Benjamin."
,"13":"Tous alors déchirèrent leurs vêtements et, après avoir chargé leurs sacs sur leurs ânes, ils retournèrent vers la ville."
,"14":"Juda et ses frères rentrèrent dans la maison de Joseph; il était là et ils se prosternèrent à terre devant lui."
,"15":"Joseph leur dit: 'Qu'avez- vous fait? Ne savez-vous pas qu'un homme comme moi est capable de tout deviner?'"
,"16":"Alors Juda lui dit: 'Nous n'avons rien à répondre à mon seigneur. Comment pourrions-nous nous justifier? Dieu a dévoilé la faute de tes serviteurs; nous serons donc les esclaves de mon seigneur, nous et celui dans la main duquel on a trouvé la coupe.'"
,"17":"Mais il leur dit: 'Dieu me garde de faire cela! Celui sur qui on a trouvé ma coupe sera mon esclave, mais vous, retournez en paix vers votre père!'"
,"18":"Juda s'avança alors vers lui, et dit: 'Je t'en supplie mon seigneur, permets-moi seulement de te dire un mot. Ne te mets pas en colère contre ton serviteur, bien que tu sois comme le Pharaon."
,"19":"Mon seigneur, tu nous as interrogés; tu nous as demandé: Avez-vous un père ou un frère?"
,"20":"Nous te l'avons dit, à toi mon seigneur: Nous avons un père qui est vieux. Dans sa vieillesse, il a eu un garçon qui reste seul de sa mère, car son frère est mort. Et cet enfant, son père l'aime."
,"21":"Tu as ajouté en nous parlant: Amenez-le moi pour que je le voie!"
,"22":"Nous t'avons répondu, à toi mon seigneur: Le garçon ne peut pas quitter son père, s'il manquait à son père, celui-ci en mourrait."
,"23":"Alors tu nous as dit: Si votre plus jeune frère ne vient pas avec vous, inutile de chercher à me voir."
,"24":"Aussi, lorsque nous sommes remontés vers notre père, nous lui avons rapporté tes paroles, mon seigneur."
,"25":"Et plus tard, quand notre père nous a dit de retourner pour acheter un peu de nourriture,"
,"26":"nous lui avons répété: Nous ne pouvons pas y aller si notre plus jeune frère ne vient pas avec nous. Nous ne partirons pas, car nous ne pourrons revoir cet homme que si notre plus jeune frère est avec nous."
,"27":"Alors mon père nous a dit: Vous savez que ma femme Rachel m'a donné deux garçons."
,"28":"Le premier a disparu et j'ai dit: Il a sûrement été dévoré. Je ne l'ai jamais revu jusqu'à ce jour."
,"29":"Si vous m'enlevez en core celui-là et qu'il lui arrive malheur, vous aurez fait descendre mes cheveux blancs dans la tristesse au séjour des morts."
,"30":"Ainsi, de la vie du garçon dépend celle de mon père. Et si je rentre chez mon père sans le garçon,"
,"31":"dès qu'il verra que le garçon n'est pas là, il en mourra, et tes serviteurs auront fait descendre les cheveux blancs de notre père, dans la tristesse, au séjour des morts."
,"32":"Je me suis porté garant du garçon auprès de mon père et je lui ai dit: Si je ne le ramène pas, je serai coupable envers mon père pour toujours."
,"33":"Maintenant donc, permets que moi, ton serviteur, je reste à la place du garçon comme ton esclave, et que le garçon s'en retourne avec ses frères. Je ne pourrais pas supporter le malheur qui frapperait mon père!'"
}`)
	CurrentBook.AddChapter(45, `{
"1":"Joseph ne put se retenir davantage devant tous ceux qui étaient présents autour de lui. Alors il donna cet ordre: 'Faites sortir tout le monde d'ici!' Il n'y avait plus personne près de lui lorsque Joseph se fit reconnaître par ses frères."
,"2":"Il pleurait si fort que les Egyptiens l'entendirent, ainsi que toute la maison du Pharaon."
,"3":"Joseph dit alors à ses frères: 'Je suis Joseph! Mon père est-il encore en vie?' Ses frères étaient tellement effrayés qu'ils étaient incapables de lui répondre."
,"4":"Joseph dit alors à ses frères: 'Approchez-vous de moi!' Et ils s'approchèrent. Il dit: 'Je suis Joseph, votre frère, c'est moi que vous avez vendu aux Egyptiens."
,"5":"Maintenant, n'en soyez pas tristes, n'ayez pas de regrets de m'avoir vendu, car Dieu m'a envoyé ici en avant de vous pour vous sauver la vie."
,"6":"Depuis deux ans la famine règne dans le pays et il y aura encore cinq années sans labours ni moisson."
,"7":"Dieu m'a donc envoyé devant vous pour vous assurer de quoi vivre dans le pays et vous faire connaître une grande libération."
,"8":"Ainsi, ce n'est pas vous qui m'avez envoyé ici, mais c'est Dieu lui-même. Il a fait de moi un père pour le Pharaon, un seigneur pour toute sa maison et un gouverneur pour tout le pays d'Egypte."
,"9":"Dépêchez-vous donc de remonter vers mon père et vous lui direz: Voici ce qu'a dit ton fils Joseph: Dieu a fait de moi un seigneur pour toute l'Egypte. Descends vers moi, ne t'arrête pas en chemin."
,"10":"Tu t'installeras dans le pays de Gossen où tu seras près de moi, toi, tes fils, les fils de tes fils, ton petit et ton gros bétail, en un mot: tout ce qui t'appartient."
,"11":"J'assurerai ta nourriture pour que vous ne manquiez de rien, ni toi, ni ta famille, ni tous ceux qui sont avec toi, car il y aura encore cinq années de famine."
,"12":"Vous voyez de vos propres yeux, et mon frère Benjamin le voit aussi, c'est bien moi qui vous parle."
,"13":"Vous raconterez à mon père toute ma gloire en Egypte, tout ce que vous avez vu, et vous vous dépêcherez de ramener mon père ici.'"
,"14":"Il se jeta alors au cou de son frère Benjamin et il pleura; Benjamin pleurait aussi sur son cou."
,"15":"Puis il embrassa tous ses frères et pleura dans leurs bras. Ensuite ses frères parlèrent avec lui."
,"16":"La nouvelle arriva jusque dans la maison du Pharaon: 'Les frères de Joseph sont arrivés!' Cela ne déplut pas au Pharaon et à ses serviteurs."
,"17":"Le Pharaon donna alors ce conseil à Joseph: 'Dis à tes frères: Voici ce que vous allez faire. Chargez vos bêtes et retournez au pays de Canaan."
,"18":"Prenez-y votre père et vos familles, puis revenez vers moi pour que je vous donne la meilleure part dans le pays d'Egypte et que vous profitiez des richesses du pays."
,"19":"Quant à toi, donne-leur cet ordre: Procurez-vous en Egypte des chariots pour vos petits enfants et pour vos femmes. Prenez votre père et revenez ici!"
,"20":"N'ayez pas de regrets pour tout ce que vous laisserez là-bas, car ce qu'il y a de meilleur en Egypte sera pour vous.'"
,"21":"C'est ainsi que firent les fils d'Israël. Joseph leur fournit des chariots selon l'ordre du Pharaon et il leur donna des provisions pour la route."
,"22":"Il leur donna à tous des vêtements de rechange, mais il donna à Benjamin trois cents pièces d'argent et cinq vêtements de rechange."
,"23":"Voici ce qu'il envoya à son père: dix ânes avec ce qu'il y avait de meilleur en Egypte et dix ânesses qui portaient du blé, du pain et de la nourriture pour le voyage de son père."
,"24":"Ensuite il renvoya ses frères en leur disant: 'Ne vous faites pas de soucis en chemin.' Et ils partirent."
,"25":"Ils revinrent donc d'Egypte et arrivèrent au pays de Canaan près de leur père Jacob."
,"26":"Ils lui annoncèrent aussitôt: 'Joseph est en core en vie! Et c'est lui qui gouverne toute l'Egypte!' Mais il n'en fut pas ému, car il ne les croyait pas."
,"27":"Ils lui dirent donc tout ce que Joseph leur avait dit. Il vit les chariots que Joseph avait envoyés pour le transporter, et c'est alors que leur père Jacob se ressaisit."
,"28":"Israël leur dit: 'Cela me suffit de savoir que mon fils Joseph est en vie. Je vais aller le revoir avant de mourir.'"
}`)
	CurrentBook.AddChapter(46, `{
"1":"Israël partit donc avec tout ce qu'il possédait, et il arriva à Bersabée où il offrit des sacrifices au Dieu de son père Isaac."
,"2":"Durant la nuit, Dieu parla à Israël dans une vision: 'Jacob! Jacob!' lui dit-il. Il répondit: 'Me voici!'"
,"3":"Dieu lui dit: 'Je suis le Dieu de ton père! Ne crains pas de descendre en Egypte, car je ferai de toi une grande nation."
,"4":"Je descendrai avec toi en Egypte et je t'en ferai remonter. Et c'est Joseph qui te fermera les yeux.'"
,"5":"Jacob quitta donc Bersabée et les fils d'Israël transportèrent leur père Jacob avec leurs petits enfants et leurs femmes, sur les chariots que Pharaon avait envoyés pour les transporter."
,"6":"Ils prirent leurs troupeaux et tout ce qu'ils avaient amassé au pays de Canaan, et c'est ainsi que Jacob et toute sa famille avec lui entrèrent en Egypte."
,"7":"Il emmena toute sa descendance en Egypte: ses fils et ses filles avec tous leurs enfants."
,"8":"Voici les noms des fils d'Israël qui entrèrent en Egypte, c'est-à-dire Jacob et sa descendance: Premier-né de Jacob: Ruben."
,"9":"Fils de Ruben: Hénok, Pallu, Hesron, Karmi."
,"10":"Fils de Siméon: Yémouel, Yamin, Ohad, Yakin, Sokar, et Chaoul, le fils de la Cananéenne."
,"11":"Fils de Lévi: Guerchon, Kahat, Mérari."
,"12":"Fils de Juda: Er, Onan, Chéla, Pérès et Zérakh. Er et Onan moururent au pays de Canaan. Quant aux fils de Pérès, ce sont: Hesron et Hamoul."
,"13":"Fils d'Issacar: Tola, Pouvva, Yachoub et Chimron."
,"14":"Fils de Zabulon: Séred, Elon, Yakhléel."
,"15":"Voilà les fils que Léa donna à Jacob, à Paddan-Aram, ainsi que sa fille Dinah. Ses fils et ses filles étaient trente-trois personnes au total."
,"16":"Fils de Gad: Sifion, Haggi, Chouni, Esbon, Eri, Arodi, Aréli."
,"17":"Fils d'Asher: Yimna, Yichva, Yichvi, Béria et Sérakh, leur soeur. Fils de Béria: Héber et Malkiël."
,"18":"Ce sont là les fils que Zilpa avait donnés à Jacob. Au total: seize personnes. Zilpa était l'esclave que Laban avait donnée à sa fille Léa."
,"19":"Fils de Rachel, femme de Jacob: Joseph et Benjamin."
,"20":"En Egypte, Asnat, fille de Poti-Phéra, prêtre d'On, donna à Joseph deux fils: Manassé et Ephraïm."
,"21":"Fils de Benjamin: Béla, Béker, Achbel, Guéra, Naaman, Ekhi, Roch, Moupim, Houpim et Ard."
,"22":"Voilà les fils que Rachel donna à Jacob. Au total: quatorze personnes."
,"23":"Fils de Dan: Houchim."
,"24":"Fils de Nephtali: Yakhséel, Gouni, Yéser et Chillem."
,"25":"Ce sont là les fils que Bila avait donnés à Jacob. Au total: sept personnes. Bila était la servante que Laban avait donnée à sa fille Rachel."
,"26":"Le total des personnes qui entrèrent en Egypte avec Jacob, tous de sa descendance, sans compter les femmes des fils de Jacob, était de soixante-six. C'est le total des personnes."
,"27":"Quant aux fils que Joseph eut en Egypte, ils étaient deux; le total des personnes de la maison de Jacob qui s'installèrent en Egypte était donc de soixante-dix."
,"28":"Avant d'entrer dans le pays de Gossen, Jacob envoya devant lui Juda à la rencontre de Joseph pour le prévenir de son arrivée au pays de Gossen."
,"29":"Joseph attela son char et partit à la rencontre d'Israël, son père, en Gossen. Il se présenta devant lui, se jeta à son cou et pleura longuement dans ses bras."
,"30":"Israël dit à Joseph: Maintenant je peux mourir, car j'ai revu ton visage et je sais que tu es en vie.'"
,"31":"Joseph dit à ses frères et à la famille de son père: 'Je m'en vais avertir le Pharaon. Je lui dirai: Mes frères et la famille de mon père qui étaient en Canaan sont venus me rejoindre."
,"32":"Ces hommes sont des bergers de petit bétail, ils sont éleveurs de troupeaux. Ils ont amené leur petit bétail et leur gros bétail, ainsi que tout ce qu'ils possédaient."
,"33":"Lorsque le Pharaon vous appellera et vous dira: 'Que faisiez-vous?'"
,"34":"vous répondrez: 'Tes serviteurs ont été éleveurs de bêtes depuis leur jeunesse jusqu'à ce jour. C'est ce que nous faisons, comme le faisaient nos pères.'"
,"35":"Ainsi vous pourrez rester dans le pays de Gossen, car les bergers sont méprisés dans toute l'Egypte.'"
}`)
	CurrentBook.AddChapter(47, `{
"1":"Alors Joseph vint prévenir le Pharaon: 'Mon père et mes frères, lui dit-il, sont arrivés du pays de Canaan avec leur petit et leur gros bétail, et tout ce qui leur appartient. Ils sont au pays de Gossen.'"
,"2":"Joseph prit cinq de ses frères et les conduisit devant le Pharaon."
,"3":"Pharaon dit à ses frères: 'Que faites-vous?' Ils répondirent au Pharaon: 'Tes serviteurs élèvent du petit bétail, nous le faisons comme le faisaient nos pères.'"
,"4":"Ils firent cette demande au Pharaon: 'Nous sommes venus pour habiter dans ce pays, car il n'y a plus de pâturages pour le troupeau de tes serviteurs, tellement la famine est grande au pays de Canaan. Tes serviteurs pourront-ils s'installer maintenant au pays de Gossen?'"
,"5":"Le Pharaon dit alors à Joseph: 'Ton père et tes frères sont venus me trouver."
,"6":"Le pays d'Egypte est à ta disposition; installe ton père et tes frères dans le meilleur endroit du pays. Qu'ils habitent au pays de Gossen, et si tu sais qu'il y a parmi eux des hommes de valeur, tu les prendras comme chefs de mes propres troupeaux.'"
,"7":"Joseph fit donc venir son père Jacob; il le présenta au Pharaon et Jacob salua le Pharaon."
,"8":"Le Pharaon demanda à Jacob: 'Quel est ton âge?'"
,"9":"Jacob répondit au Pharaon: 'J'en suis à la cent trentième année de ma vie errante, mais je n'ai pas atteint le grand âge de mes pères, qui étaient nomades comme moi. Ma vie a été courte et malheureuse.'"
,"10":"Jacob salua de nouveau le Pharaon et se retira de devant lui."
,"11":"Joseph installa donc son père et ses frères, il leur donna des terres au pays d'Egypte, dans le meilleur endroit, dans la terre de Ramsès, comme l'avait ordonné le Pharaon."
,"12":"Joseph se chargea de nourrir son père et ses frères, ainsi que toute la famille de son père; il leur donna du pain selon le nombre des enfants."
,"13":"Il n'y avait plus de pain sur toute la terre, tellement la famine était grande. Le pays d'Egypte et le pays de Canaan étaient épuisés par cette famine."
,"14":"Alors Joseph rassembla tout l'argent que donnaient les Egyptiens et les Cananéens lorsqu'ils venaient acheter du blé. Et Joseph fit rentrer cet argent dans le palais du Pharaon."
,"15":"Mais bientôt il n'y eut plus d'argent, ni en Egypte, ni en Canaan. Tous les Egyptiens vinrent donc trouver Joseph: 'Donne- nous du pain, lui dirent-ils, même si nous n'avons plus d'argent. Faut-il donc que nous mourions sous tes yeux?'"
,"16":"Joseph leur répondit: 'Si vous n'avez plus d'argent, donnez-moi vos troupeaux et je vous donnerai du pain en échange.'"
,"17":"Ils amenèrent donc leurs troupeaux à Joseph, et Joseph leur donna du pain en échange des chevaux, des troupeaux de petit et gros bétail et même des ânes. Il leur fournit des aliments cette année-là au prix de tous leurs troupeaux."
,"18":"A la fin de cette année-là, ils vinrent de nouveau le trouver et lui dirent: 'Mon seigneur sait bien que nous n'avons plus d'argent et que nos troupeaux appartiennent maintenant à mon seigneur. Nous n'avons plus à lui offrir que nos corps et nos champs."
,"19":"Devons-nous donc maintenant mourir sous tes yeux, nous et nos champs? Donne-nous du pain en échange de nos corps et de nos champs. Nous serons, nous et nos champs, les esclaves du Pharaon. Donne-nous du grain pour que nous restions en vie; sinon, nous allons mourir et nos champs retourneront en friche.'"
,"20":"Ainsi Joseph acquit tous les champs d'Egypte pour le compte du Pharaon, car les Egyptiens vendaient tous leurs champs, tellement la famine pesait sur eux. Tout le pays devint ainsi la propriété du Pharaon."
,"21":"Quant au peuple, il fut réduit en esclavage dans tout le pays d'Egypte."
,"22":"Cependant Joseph ne reprit pas aux prêtres leurs terres, car il y avait une loi du Pharaon en leur faveur, et d'après cette loi, le Pharaon devait assurer la nourriture des prêtres. C'est pourquoi ils ne vendirent pas les champs qui leur appartenaient."
,"23":"Joseph dit alors au peuple: 'Je vous ai achetés aujourd'hui, vous et vos champs, pour le Pharaon. Voici donc du grain pour vous, vous ensemencerez vos champs."
,"24":"Quand viendra le temps de la récolte, vous donnerez un cinquième de cette récolte au Pharaon, et les quatre autres parts vous resteront pour ensemencer vos champs, et pour vous nourrir, vous et tous ceux de votre maison.'"
,"25":"Ils répondirent: 'Grâce à toi nous allons vivre! Puissions-nous trouver grâce aux yeux de mon seigneur: nous serons les esclaves du Pharaon!'"
,"26":"Joseph établit donc un impôt sur les champs d'Egypte et, maintenant encore, un cinquième de la récolte est remis au Pharaon. Seuls les champs des prêtres ne devinrent pas propriété du Pharaon."
,"27":"Les Israélites habitèrent en Egypte sur les terres de Gossen. Ils en prirent possession, ils s'y développèrent et se multiplièrent beaucoup."
,"28":"Jacob vécut dix-sept ans en Egypte. Le total des années de Jacob fut de cent quarante-sept ans."
,"29":"Quand Israël sentit que sa mort était proche, il appela son fils Joseph et lui dit: 'Si j'ai trouvé grâce à tes yeux, mets ta main sous ma cuisse et promets-moi de ne pas m'enterrer en Egypte, je reconnaîtrai là ta bonté et ta fidélité."
,"30":"Lorsque je me serai couché avec mes pères, tu m'emporteras d'Egypte et tu m'enterreras dans la tombe de mes pères.' Joseph répondit: 'Je ferai ce que tu me demandes.'"
,"31":"Israël lui dit: 'Jure-le moi!' Il le lui jura, et Israël s'inclina devant lui, au chevet de son lit."
}`)
	CurrentBook.AddChapter(48, `{
"1":"Après cela, on vint dire à Joseph: 'Ton père est malade!' Alors il prit avec lui ses deux fils Manassé et Ephraïm."
,"2":"On avertit Jacob: 'Ton fils Joseph est venu te voir.' Israël rassembla ses forces pour s'asseoir sur son lit."
,"3":"Jacob dit à Joseph: 'Lorsque le Dieu de la Steppe m'est apparu à Louz, au pays de Canaan, il m'a béni en ces termes:"
,"4":"Je te ferai grandir, je te multiplierai, je ferai de toi une communauté de peuples, et je donnerai ce pays à ta descendance après toi, pour qu'elle soit sa propriété pour toujours."
,"5":"Aussi je veux prendre aujourd'hui comme mes enfants ces deux fils qui te sont nés en Egypte avant que je te rejoigne: Ephraïm et Manassé sont à moi, au même titre que Ruben et Siméon."
,"6":"Mais les enfants que tu as eus après eux, resteront à toi: ils recevront de leurs frères aînés leur nom et leur part d'héritage."
,"7":"Quant à moi, lorsque je venais de Paddân, Rachel mourut dans mes bras au pays de Canaan, sur la route, à une bonne distance d'Efrata. C'est là que je l'ai enterrée, sur la route d'Efrata, c'est-à-dire Bethléem.'"
,"8":"En voyant les fils de Joseph, Israël demanda: 'Ceux-là, qui sont-ils?'"
,"9":"Joseph répondit à son père: 'Ce sont mes fils! Ce sont les fils que Dieu m'a donnés ici.' Israël lui dit: 'Amène-les moi, je te prie, et je les bénirai.'"
,"10":"La vue d'Israël avait beaucoup baissé à cause de son grand âge, et il ne voyait presque plus. Joseph fit donc venir ses deux fils près de son père qui les embrassa et les prit dans ses bras."
,"11":"Israël dit à Joseph: 'Je ne pensais plus revoir ton visage et voici que Dieu m'a même fait voir tes enfants!'"
,"12":"Alors Joseph les retira des bras de son père et se prosterna la face contre terre."
,"13":"Puis Joseph prit ses deux fils, Ephraïm à sa droite pour qu'il soit à la gauche d'Israël, et Manassé à sa gauche pour qu'il soit à la droite d'Israël. Et il les fit approcher."
,"14":"Mais Israël étendit sa main droite et la posa sur la tête d'Ephraïm, qui était le second; croisant ainsi ses mains, il posa sa main gauche sur la tête de Manassé, alors que Manassé était l'aîné."
,"15":"Israël bénit Joseph: 'Que le Dieu devant qui ont marché mes pères, Abraham et Isaac, que le Dieu qui fut mon berger depuis ma naissance jusqu'à aujourd'hui,"
,"16":"que l'Ange qui m'a délivré de tout mal, bénisse ces garçons! Que grâce à eux on se souvienne de mon nom, comme du nom de mes pères, Abraham et Isaac! Qu'ils grandissent de plus en plus au milieu du pays!'"
,"17":"Joseph remarqua que son père plaçait sa main droite sur la tête d'Ephraïm et cela lui déplut. Il prit donc la main de son père pour la déplacer de la tête d'Ephraïm sur la tête de Manassé."
,"18":"Et Joseph dit à son père: 'Ne fais pas comme cela, mon père, car c'est celui-ci qui est l'aîné. Pose ta main droite sur sa tête.'"
,"19":"Son père refusa et répondit: 'Je le sais bien, mon fils! Lui aussi deviendra un peuple, lui aussi grandira! Cependant son frère plus jeune deviendra plus grand que lui, et sa descendance deviendra un ensemble de nations.'"
,"20":"Il les bénit donc en ce jour, en disant: 'Quand on bénira, en Israël, on vous citera en exemple: Que Dieu te rende semblable à Ephraïm et à Manassé'. Mais il plaça Ephraïm avant Manassé."
,"21":"Israël dit à Joseph: 'Je vais mourir, mais Dieu sera avec vous: il vous fera revenir au pays de vos pères."
,"22":"Voici ce que je te donne de plus qu'à tes frères: cette parcelle de terre, Sichem, que j'ai conquise sur les Amorites par mon épée et par mon arc.'"
}`)
	CurrentBook.AddChapter(49, `{
"1":"Jacob appela ses fils et leur dit: 'Venez autour de moi pour que je vous annonce ce qui arrivera par la suite."
,"2":"Venez tous ici et écoutez-moi, fils de Jacob, écoutez votre père Israël."
,"3":"Ruben, tu es mon premier-né, ma force et le premier fruit de ma virilité, aussi orgueilleux que vigoureux."
,"4":"Tu auras beau déborder comme les eaux, ton pouvoir sera limité, car tu es monté sur la couche de ton père et tu as souillé mon lit en y montant."
,"5":"Siméon et Lévi sont frères dans la violence: c'est ensemble qu'ils ont frappé du poignard."
,"6":"Je n'approuve pas leurs décisions et je ne me joindrai pas à leur assemblée, car dans leur colère, ils ont massacré des hommes; dans leur violence, ils ont coupé les jarrets des taureaux."
,"7":"Maudite soit leur colère, car elle n'est que violence, et leur fureur, car elle n'est que cruauté. Je les installerai ça et là en Jacob, je les disperserai en Israël."
,"8":"Juda, tes frères feront ton éloge. Ta main pèsera sur le cou de tes ennemis, les fils de ton père se prosterneront devant toi."
,"9":"Juda, mon fils, tu es comme un jeune lion qui revient avec sa proie! Il s'est accroupi comme un lion, allongé comme une lionne: qui ira le provoquer?"
,"10":"On n'enlèvera pas à Juda le sceptre royal, ni le bâton de commandement d'entre ses pieds jusqu'au jour où viendra celui à qui tous les peuples obéiront."
,"11":"Il attache à la vigne son âne, au pied de la vigne le petit de son ânesse. Il lave dans le vin son vêtement, et dans le sang des raisins, son manteau."
,"12":"Le vin lui trouble la vue et le lait blanchit ses dents."
,"13":"Zabulon habitera sur le bord des mers, il sera matelot sur les bateaux et son territoire s'étendra jusqu'à Sidon."
,"14":"Issacar est un âne osseux qui repose au milieu de ses pâturages."
,"15":"Il a vu que le repos est bon, que le pays est agréable, aussi il tend son dos pour porter les fardeaux, il est prêt pour un travail d'esclave."
,"16":"Dan jugera son peuple comme le font les tribus d'Israël."
,"17":"Dan est un serpent sur la route, une vipère à cornes sur le sentier; il mord les talons du cheval et le cavalier tombe à la renverse."
,"18":"O Yahvé! J'espère en ton salut!"
,"19":"Gad, à peine les pillards l'ont-ils pillé que déjà il est sur leurs talons."
,"20":"Le pain d'Asher est moelleux, il fournit des pâtisseries royales."
,"21":"Nephtali est une biche en liberté, qui met bas de beaux petits."
,"22":"Joseph est un arbre fertile, c'est un arbre fertile auprès d'une source, dont les branches grimpent sur le mur."
,"23":"Les archers l'ont provoqué, ils ont tiré, ils l'ont attaqué."
,"24":"Mais son arc à lui ne s'est pas brisé et ses bras sont restés agiles, car le Puissant de Jacob le soutient, le Rocher d'Israël lui vient en aide."
,"25":"Que le Dieu de ton père te protège, que le Dieu de la Steppe te bénisse. Que d'en haut te viennent les bénédictions du ciel, et d'en bas la fécondité de ton sol. Tes champs seront bénis, et tes bêtes fécondes."
,"26":"Les bénédictions de ton père surpassent les bénédictions des montagnes antiques, elles sont meilleures que celles des cimes éternelles. Puissent-elles reposer sur la tête de Joseph, puisqu'il a été choisi entre tous ses frères!"
,"27":"Benjamin est un loup qui déchire. Le matin, il dévore sa proie, et le soir, il partage le butin.'"
,"28":"Voilà donc toutes les tribus d'Israël, les douze. Et voilà ce que leur père leur a dit lorsqu'il les a bénies. Il les a bénies, chacune a eu droit à sa bénédiction."
,"29":"Jacob leur donna alors cet ordre: 'Je vais être réuni à mon peuple. Enterrez-moi avec mes pères dans la grotte du champ d'Efron, le Hittite,"
,"30":"la grotte du champ de Makpélah, face à Mambré, au pays de Canaan. C'est le champ qu'Abraham a acheté à Efron le Hittite, pour avoir une tombe à lui."
,"31":"C'est là que l'on a enterré Abraham et Sara, sa femme. Là aussi l'on a enterré Isaac et Rébecca, sa femme; là aussi j'ai enterré Léa."
,"32":"Le champ et la grotte ont été achetés aux fils de Heth.'"
,"33":"Quand Jacob termina de donner ses instructions à ses fils, il ramena ses pieds dans son lit, il mourut et fut réuni à ses pères."
}`)
	CurrentBook.AddChapter(50, `{
"1":"Alors Joseph se jeta sur le visage de son père et le couvrit de larmes et de baisers."
,"2":"Ensuite Joseph ordonna aux médecins qui étaient à son service d'embaumer son père, et les médecins embaumèrent Israël."
,"3":"Cela dura quarante jours, car tel est le temps nécessaire pour l'embaumement. Puis les Egyptiens le pleurèrent soixante-dix jours."
,"4":"Lorsque les jours de deuil furent passés, Joseph adressa cette demande à l'entourage du Pharaon: 'Si j'ai trouvé grâce à vos yeux, parlez donc au Pharaon de ma part."
,"5":"Au moment de mourir, mon père m'a fait jurer de l'enterrer dans le tombeau qu'il s'est creusé au pays de Canaan. A présent donc, dites-lui qu'il me laisse y aller pour enterrer mon père et ensuite je reviendrai.'"
,"6":"Pharaon répondit: 'Va et enterre ton père, comme il te l'a fait jurer!'"
,"7":"Joseph partit donc pour enterrer son père, et avec lui partirent tous les serviteurs du Pharaon, les anciens de sa maison et tous les anciens d'Egypte,"
,"8":"toute la maison de Joseph, ses frères et la maison de son père. Ils ne laissèrent au pays de Gossen que leurs petits enfants, leur petit et leur gros bétail."
,"9":"Des chars et des cavaliers montèrent avec lui, c'était une énorme caravane!"
,"10":"Quand ils arrivèrent à l'Aire-de-l'Epine qui est au-delà du Jourdain, ils firent le deuil en grand, et Joseph fit encore sept jours de deuil pour son père."
,"11":"Les habitants du pays, les Cananéens, virent le deuil à l'Aire-de-l'Epine, 'C'est un deuil solennel des Egyptiens', dirent-ils. C'est pourquoi on appela ce lieu du nom d'Abel-Misraïm (ce qui veut dire: Deuil pour l'Egypte): il se trouve au-delà du Jourdain."
,"12":"Les fils de Jacob accomplirent tout ce qu'il leur avait commandé."
,"13":"Ils le transportèrent au pays de Canaan et l'enterrèrent dans la grotte du champ de Makpélah, le champ qu'Abraham avait acheté à Efron le Hittite, comme tombeau personnel en face de Mambré."
,"14":"Après l'enterrement, Joseph retourna en Egypte avec ses frères et tous ceux qui étaient venus avec lui pour enterrer son père."
,"15":"Quand les frères de Joseph virent que leur père était mort, ils se dirent: 'Si jamais Joseph nous prenait en haine et voulait nous rendre maintenant tout le mal que nous lui avons fait!'"
,"16":"Aussi envoyèrent-ils quelqu'un dire à Joseph: 'Ton père avant sa mort nous a donné cet avis:"
,"17":"Voici ce que vous direz à Joseph: Je t'en prie, pardonne le crime de tes frères et le péché qu'ils ont commis quand ils t'ont fait du mal. Pardonne donc cette faute aux serviteurs du Dieu de ton père!',Joseph pleura quand on lui rapporta ces paroles. "
,"18":"Ses frères allèrent se jeter à ses pieds et lui dirent: 'Voici que nous sommes tes esclaves!'"
,"19":"Mais Joseph leur répondit: 'N'ayez pas peur! Est-ce que je suis à la place de Dieu?"
,"20":"Vous avez cherché à me faire du mal, mais Dieu a changé ce mal en bien, pour en arriver à ce que vous voyez aujourd'hui: donner la vie à une multitude."
,"21":"Maintenant donc n'ayez pas peur, je vous donnerai à manger, à vous et à vos petits enfants.' Puis il les consola et leur parla du fond du coeur."
,"22":"Joseph resta en Egypte, lui et la famille de son père. Joseph vécut jusqu'à l'âge de cent dix ans."
,"23":"Joseph vit naître les arrière-petits-enfants d'Ephraïm et il adopta les fils de Makir, fils de Manassé."
,"24":"Joseph dit alors à ses frères: 'Je vais mourir, mais Dieu vous visitera. Il vous fera remonter de ce pays vers le pays qu'il a promis par serment à Abraham, Isaac et Jacob.'"
,"25":"Joseph fit alors prêter serment aux fils d'Israël: 'Quand Dieu vous aura visités, leur dit-il, vous ferez remonter mes ossements d'Egypte.'"
,"26":"Joseph mourut à l'âge de cent dix ans. On l'embauma, puis on le mit dans un cercueil en Egypte."
}`)

}
func FR_LBDCC_LoadVPLVChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Yahvé appela Moïse et, de la Tente du Rendez-Vous, il lui dit:"
,"2":"'Voici ce que tu diras aux Israélites: Lorsque l'un d'entre vous fera une offrande à Yahvé, ce sera du bétail qu'il offrira: du gros ou du petit bétail."
,"3":"S'il veut offrir un sacrifice totalement consumé (un 'holocauste') de gros bétail, il viendra présenter à l'entrée de la Tente du Rendez-Vous le mâle sans défaut qu'il aura choisi, et ainsi son sacrifice sera agréable à Yahvé."
,"4":"Il posera sa main sur la tête de la victime, et le sacrifice sera accepté en sa faveur pour l'expiation de ses péchés."
,"5":"Il égorgera le jeune taureau devant Yahvé, et les prêtres, fils d'Aaron, offriront le sang. Ils le répandront tout autour et sur l'autel qui est à l'entrée de la Tente du Rendez-Vous."
,"6":"On dépouillera alors la victime et on la découpera en morceaux."
,"7":"Les fils du prêtre Aaron allumeront le feu sur l'autel et mettront le bois par-dessus des braises."
,"8":"Puis les prêtres, fils d'Aaron, disposeront les morceaux avec la tête et les boyaux sur le bois placé sur le feu de l'autel."
,"9":"On lavera à l'eau les entrailles et les jambes, et le prêtre fera brûler le tout sur l'autel. C'est un holocauste, un sacrifice par le feu d'une agréable odeur à Yahvé."
,"10":"S'il s'agit d'une offrande de petit bétail, un holocauste d'agneau ou de chèvre, on offrira un mâle sans défaut."
,"11":"On l'égorgera du côté nord de l'autel, devant Yahvé, et les prêtres, fils d'Aaron, en répandront le sang sur l'autel et autour."
,"12":"On le découpera en morceaux, avec la tête et les boyaux, puis le prêtre les disposera sur le bois placé sur le feu de l'autel."
,"13":"On lavera à l'eau les entrailles et les jambes, et le prêtre offrira le tout et le fera brûler sur l'autel. C'est un holocauste, un sacrifice par le feu d'agréable odeur à Yahvé."
,"14":"Si l'offrande à Yahvé est un holocauste d'oiseaux, on offrira des tourterelles ou de jeunes pigeons."
,"15":"Le prêtre apportera l'oiseau à l'autel, il lui pincera le cou, puis le fera brûler sur l'autel. Quant au sang, il s'écoulera sur le côté de l'autel."
,"16":"On enlèvera le jabot avec les plumes, et on jettera le tout à côté de l'autel, à l'orient, près des cendres."
,"17":"On fera une fente entre les ailes, mais sans les séparer, et le prêtre le fera fumer sur l'autel, sur le bois disposé sur le feu. C'est un holocauste, un sacrifice par le feu d'agréable odeur à Yahvé."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Si quelqu'un veut présenter une offrande à Yahvé, son oblation sera de la fleur de farine. Il versera de l'huile dessus et ajoutera de l'encens,"
,"2":"puis il l'apportera aux prêtres, aux fils d'Aaron. Le prêtre prendra une poignée de cette fleur de farine arrosée d'huile, avec l'encens, et les fera fumer sur l'autel pour que Dieu se souvienne de cet homme: c'est un sacrifice par le feu d'une agréable odeur à Yahvé."
,"3":"Ce qui restera de l'offrande sera pour Aaron et ses fils: c'est une part très sainte retenue sur les sacrifices par le feu en l'honneur de Yahvé."
,"4":"Lorsque tu présenteras une offrande cuite au four, elle sera faite de gâteaux de fleur de farine sans levain, pétrie avec l'huile, ou de galettes sans levain arrosées d'huile."
,"5":"Si ton offrande est un gâteau cuit à la poêle, il sera fait avec de la fleur de farine pétrie à l'huile, sans levain."
,"6":"Tu le couperas en morceaux et tu verseras de l'huile dessus, car c'est une offrande."
,"7":"Si tu présentes en offrande un gâteau cuit à la casserole, il sera fait de fleur de farine avec de l'huile."
,"8":"Tu apporteras à Yahvé l'offrande que tu auras préparée, tu la donneras au prêtre qui l'offrira à l'autel."
,"9":"Le prêtre prélèvera une part qu'il fera fumer sur l'autel en ton nom: ce sera un sacrifice par le feu, d'agréable odeur à Yahvé."
,"10":"Ce qui restera de l'offrande sera pour Aaron et pour ses fils: c'est une part sainte prélevée sur les sacrifices par le feu en l'honneur de Yahvé."
,"11":"Toute offrande que vous présenterez à Yahvé doit être préparée sans levain. Dans les sacrifices par le feu que vous offrez en l'honneur de Yahvé, il n'y aura ni levain ni miel."
,"12":"Sinon, vous pourrez les présenter à Yahvé en offrande de prémices, mais ils ne seront pas placés sur l'autel comme sacrifices d'agréable odeur."
,"13":"Toutes les offrandes que tu présenteras seront avec sel; tout comme l'Alliance de ton Dieu est de sel, le sel ne manquera pas sur tes offrandes: toutes seront salées."
,"14":"S'il s'agit d' une offrande de prémices à Yahvé, tu présenteras des épis rôtis au feu ou du grain nouveau broyé: ce sera ton offrande de prémices."
,"15":"Tu verseras de l'huile dessus et tu y ajouteras de l'encens, car c'est une offrande."
,"16":"Le prêtre fera fumer une partie du grain broyé et de l'huile, avec l'encens, en ton nom; ce sera un sacrifice par le feu en l'honneur de Yahvé."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Si quelqu'un offre en sacrifice de communion du gros bétail, mâle ou femelle, il présentera à Yahvé une bête sans défaut."
,"2":"Il posera sa main sur la tête de la victime et il l'égorgera devant l'entrée de la Tente du Rendez-Vous. Les prêtres, fils d'Aaron, répandront le sang sur l'autel et autour."
,"3":"On prélèvera une part sur ce sacrifice de communion pour l'offrir par le feu à Yahvé: la graisse qui enveloppe les entrailles et toute la graisse qui est attachée aux entrailles,"
,"4":"les deux rognons avec la graisse qui les recouvre et celle qui les entoure, enfin l'enveloppe du foie qu'on détachera des rognons."
,"5":"Les fils d'Aaron feront fumer le tout sur l'autel, par-dessus le sacrifice par le feu disposé sur le bois de l'autel. C'est un sacrifice par le feu, d'agréable odeur à Yahvé."
,"6":"Si l'on offre du petit bétail, mâle ou femelle, en sacrifice de communion, on présentera à Yahvé une bête sans défaut."
,"7":"Si quelqu'un offre en sacrifice un agneau, il l'amènera devant Yahvé."
,"8":"Il posera sa main sur la tête de la victime et il l'égorgera devant la Tente du Rendez-Vous, puis les fils d'Aaron verseront le sang sur l'autel et autour."
,"9":"De ce sacrifice de communion, on offrira une part en sacrifice par le feu en l'honneur de Yahvé: la graisse, la queue toute entière coupée près de l'échine, la graisse qui enveloppe les entrailles et celle qui y est attachée,"
,"10":"les deux rognons avec la graisse qui les recouvre et celle qui les entoure, enfin l'enveloppe du foie que l'on détachera près des rognons."
,"11":"Le prêtre fera fumer le tout sur l'autel: c'est un aliment donné au feu, en l'honneur de Yahvé."
,"12":"Si quelqu'un offre une chèvre, il la présentera à Yahvé."
,"13":"Il posera sa main sur la tête de la victime et il l'égorgera à l'entrée de la Tente du Rendez-Vous. Les fils d'Aaron répandront le sang sur l'autel et autour."
,"14":"De la victime, il offrira une part en sacrifice par le feu, en l'honneur de Yahvé: la graisse qui enveloppe les entrailles et celle qui y est attachée,"
,"15":"les deux rognons avec la graisse qui les recouvre et celle qui les entoure, enfin l'enveloppe du foie qu'on détachera près des rognons."
,"16":"Le prêtre fera fumer le tout sur l'autel: c'est un aliment donné au feu, d'où monte une agréable odeur."
,"17":"Toute graisse appartient à Yahvé, c'est une loi perpétuelle pour vos descendants. Vous ne mangerez ni la graisse, ni le sang, en quelque endroit que vous habitiez.'"
}`)
	CurrentBook.AddChapter(4, `{
"1":"Yahvé parla à Moïse:"
,"2":"'Tu diras ceci aux Israélites: Voici les règles concernant les personnes qui auront péché par erreur contre l'un des commandements de Yahvé, lorsqu'ils auront fait quelque chose qui ne doit pas se faire."
,"3":"Si c'est le prêtre qui a péché, le peuple aussi est affecté par sa faute. Il offrira donc pour le péché qu'il a commis un jeune taureau sans défaut: ce sera pour Yahvé une victime pour le péché."
,"4":"Il amènera le taureau devant la Tente du Rendez-Vous, devant Yahvé, et il posera sa main sur la tête du taureau; puis il l'égorgera devant Yahvé."
,"5":"Le prêtre qui a reçu l'onction prendra du sang du taureau et le portera à l'intérieur de la Tente du Rendez-Vous."
,"6":"Il trempera son doigt dans le sang et fera sept fois l'aspersion devant Yahvé, face au rideau du sanctuaire."
,"7":"Le prêtre mettra du sang sur les cornes de l'autel des parfums qui est devant Yahvé dans la Tente du Rendez-Vous, et il répandra le reste du sang du taureau au pied de l'autel des holocaustes, à l'entrée de la Tente."
,"8":"Il enlèvera ensuite toute la graisse du taureau sacrifié pour le péché, la graisse qui enveloppe les entrailles et celle qui y est attachée,"
,"9":"les deux rognons avec la graisse qui les recouvre et celle qui les entoure, enfin l'enveloppe du foie qu'il détachera près des rognons."
,"10":"Il agira de la même manière que dans les sacrifices de communion: il fera fumer le tout sur l'autel des holocaustes."
,"11":"Mais la peau du taureau, la chair avec la tête, les jambes, les entrailles et les excréments -le taureau tout entier-"
,"12":"on l'emportera hors du camp, à l'endroit où l'on jette les cendres. C'est là qu'il sera brûlé sur un feu de bois."
,"13":"Si toute la communauté des Israélites a péché involontairement, s'ils ont commis sans s'en rendre compte l'une de ces choses que Yahvé a défendu de faire,"
,"14":"la communauté offrira, dès qu'elle aura pris conscience du péché qu'elle a commis, un jeune taureau en sacrifice pour le péché. On le conduira devant la Tente du Rendez-Vous,"
,"15":"puis les anciens de la communauté poseront leurs mains sur la tête du taureau, devant Yahvé. Là on égorgera le taureau."
,"16":"Le prêtre qui a reçu l'onction portera du sang du taureau à l'intérieur de la Tente du Rendez-Vous."
,"17":"Il trempera son doigt dans le sang et fera sept fois l'aspersion devant Yahvé, face au rideau."
,"18":"Il mettra du sang sur les cornes de l'autel qui est devant Yahvé, dans la Tente du Rendez-Vous, et il versera le reste du sang au pied de l'autel des holocaustes qui se trouve à l'entrée de la Tente du Rendez-Vous."
,"19":"Il enlèvera ensuite toute la graisse du taureau et la fera fumer sur l'autel."
,"20":"Il fera pour ce taureau comme pour le taureau immolé pour le péché du prêtre: on agira de la même façon. Le prêtre fera ainsi le rite d'expiation pour le peuple, et il sera pardonné."
,"21":"Il emportera le taureau hors du camp et le brûlera comme le premier taureau: c'est le sacrifice pour le péché de la communauté."
,"22":"Si un chef a péché, s'il s'est rendu coupable en faisant par erreur une de ces choses que Yahvé son Dieu a défendu de faire,"
,"23":"il amènera pour son offrande un bouc mâle sans défaut, dès qu'il se sera rendu compte du péché qu'il a commis."
,"24":"Il posera sa main sur la tête du bouc et l'égorgera à l'endroit où l'on égorge les holocaustes pour Yahvé, car c'est un sacrifice pour le péché."
,"25":"Le prêtre prendra avec son doigt du sang de la victime pour le péché, il en mettra sur les cornes de l'autel des holocaustes, et versera le reste du sang au pied de cet autel."
,"26":"Puis il fera fumer toute la graisse sur l'autel, comme on fait pour la graisse des sacrifices de communion. C'est ainsi que le prêtre fera l'expiation du péché pour cet homme, et celui-ci sera pardonné."
,"27":"Si quelqu'un du peuple du pays a péché par erreur, s'il s'est rendu coupable en faisant une de ces choses que Yahvé a défendu de faire:"
,"28":"il amènera comme offrande pour le péché qu'il a commis une chèvre, une femelle sans défaut."
,"29":"Il posera sa main sur la tête de la bête et l'égorgera dans le lieu où l'on offre les holocaustes."
,"30":"Le prêtre prendra avec son doigt du sang de la victime; il en mettra sur les cornes de l'autel des holocaustes et versera le reste du sang au pied de cet autel."
,"31":"Il enlèvera toute la graisse, comme on le fait dans le sacrifice de communion, et le prêtre la fera fumer sur l'autel, comme agréable odeur pour Yahvé. C'est ainsi que le prêtre fera l'expiation pour cet homme, et celui-ci sera pardonné."
,"32":"S'il amène une jeune brebis en sacrifice pour le péché, il prendra une femelle sans défaut."
,"33":"Il posera sa main sur la tête de la bête et l'égorgera en sacrifice pour le péché à l'endroit où l'on immole les holocaustes."
,"34":"Le prêtre prendra avec son doigt du sang de la victime, il en mettra sur les cornes de l'autel des holocaustes et il versera le reste du sang au pied de cet autel."
,"35":"Il enlèvera toute la graisse comme on enlève la graisse de l'agneau dans le sacrifice de communion. Le prêtre la fera fumer sur l'autel par-dessus les sacrifices par le feu pour Yahvé. C'est ainsi que le prêtre fera l'expiation pour cet homme, pour le péché qu'il a commis, et cet homme sera pardonné."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Ceci vaut pour la personne qui a été témoin, qui a vu quelque chose, ou on le lui a dit, et elle ne l'a pas dénoncé lorsque le juge l'interrogeait solennellement: elle a péché et est en faute."
,"2":"Ou bien quelqu'un a touché une chose impure: cadavre d'animal impur, cadavre d'animal domestique impur, cadavre de bête impure: il est lui-même impur et en faute, même s'il l'a fait involontairement."
,"3":"Ou encore quelqu'un touche sans le savoir à une impureté humaine, à une impureté qui rend l'homme impur; dès qu'il l'apprend, il est en faute."
,"4":"Ou encore quelqu'un a parlé sans réfléchir et a juré de faire du bien ou du mal, ou tout autre chose où l'homme peut parler sans réfléchir. Dès qu'il s'en rend compte il est en faute."
,"5":"Celui donc qui est en faute pour une de ces choses confessera son péché."
,"6":"Il offrira à Yahvé un sacrifice pour le péché qu'il a commis: une femelle de petit bétail, brebis ou chèvre. Ce sera son sacrifice pour le péché, et le prêtre fera sur lui l'expiation de son péché."
,"7":"S'il n'a pas le moyen de se procurer une brebis ou une chèvre, il offrira à Yahvé en sacrifice d'expiation, deux tourterelles ou deux jeunes pigeons: l'un pour le sacrifice pour le péché, l'autre pour l'holocauste."
,"8":"Il les apportera au prêtre. Celui-ci offrira la première victime en sacrifice pour le péché: le prêtre lui pincera le cou mais sans détacher la tête,"
,"9":"il fera l'aspersion avec le sang de la victime contre l'autel, et le reste du sang sera versé au pied de l'autel."
,"10":"Puis il prendra l'autre oiseau pour l'holocauste selon les rites de ce type de sacrifice. Le prêtre fera ainsi l'expiation du péché que cet homme a commis, et il sera pardonné."
,"11":"S'il n'a pas de quoi se procurer deux tourterelles ou deux jeunes pigeons, il offrira pour son péché un dixième de mesure de fleur de farine comme sacrifice pour le péché. Il ne mettra dessus, ni huile, ni encens, car c'est un sacrifice pour le péché."
,"12":"Il l'apportera au prêtre; le prêtre en prendra une part et la fera fumer sur l'autel au nom de cet homme, il la posera sur les sacrifices par le feu pour Yahvé: c'est un sacrifice pour le péché."
,"13":"Le prêtre fera ainsi l'expiation du péché que cet homme a commis, et il sera pardonné. Ce qui restera de l'offrande, sera pour le prêtre.'"
,"14":"Yahvé parla à Moïse et lui dit:"
,"15":"'Si quelqu'un pèche en retenant quelque chose par erreur sur les offrandes consacrées à Yahvé, il amènera à Yahvé, comme sacrifice de réparation, un bélier sans défaut de son troupeau, estimé par toi en sicles d'argent au cours du sicle du sanctuaire: ce sera un sacrifice de réparation."
,"16":"Il rendra ce dont il a privé le sanctuaire involontairement, et il ajoutera un cinquième en plus. Il donnera le tout au prêtre; le prêtre fera pour lui le rite de l'expiation avec le bélier offert en sacrifice de réparation, et il sera pardonné."
,"17":"Si quelqu'un pèche en faisant involontairement une des choses que Yahvé a défendu de faire, il est en faute et porte le poids de son péché."
,"18":"Si tu le juges bon, il amènera au prêtre en sacrifice de réparation un bélier sans défaut provenant de son troupeau. Le prêtre fera pour lui l'expiation pour le péché qu'il a commis involontairement, sans s'en rendre compte, et il sera pardonné."
,"19":"C'est un sacri fice de réparation, car cet homme était certainement en faute au regard de Yahvé.'"
,"20":"Yahvé parla à Moïse et lui dit:"
,"21":"'Ceci vaut pour la personne dont le péché est une infidélité envers Yahvé. Il a trompé son prochain au sujet d'un dépôt, d'un objet qu'on lui a confié ou d'une chose qu'il a volée, ou bien il a exploité son prochain;"
,"22":"ou bien il a menti au sujet d'un objet perdu et qu'il a retrouvé; ou encore il a fait un faux serment au sujet de l'une des choses dans lesquelles l'homme peut pécher."
,"23":"Cet homme qui aura péché et se sera rendu coupable, devra rendre la chose volée avec ou sans violence, ou bien le dépôt qui lui avait été remis, l'objet perdu qu'il a retrouvé, ou tout objet au sujet duquel il a prêté un faux serment."
,"24":"Il le rendra dans sa totalité en ajoutant un cinquième de la valeur de l'objet. Il le rendra à son propriétaire le jour même où il offrira le sacrifice de réparation."
,"25":"Si tu le juges bon, il amènera au prêtre de Yahvé comme sacrifice de réparation un bélier sans défaut de son troupeau."
,"26":"Le prêtre fera pour lui l'expiation devant Yahvé, et il sera pardonné du péché qu'il a commis.'"
}`)
	CurrentBook.AddChapter(6, `{
"1":"Yahvé parla à Moïse et lui dit:"
,"2":"'Tu donneras cet ordre à Aaron et à ses fils: Voici la loi de l'holocauste, du sacrifice par le feu. L'holocauste brûlera toute la nuit sur le foyer de l'autel, jusqu'au matin, et le feu de l'autel y restera allumé."
,"3":"Le prêtre s'habillera de sa tunique de lin et se couvrira de son caleçon de lin. Il enlèvera les cendres laissées par le feu qui, la veille, aura brûlé l'holocauste sur l'autel, et il les jettera à côté de l'autel."
,"4":"Ensuite il quittera ses vêtements, il en mettra d'autres pour porter les cendres en dehors du camp dans un lieu pur."
,"5":"Le feu de l'autel sera entretenu sans jamais s'éteindre. Le prêtre renouvellera le bois chaque matin, disposera dessus l'holocauste, et fera fumer la graisse des sacrifices de communion."
,"6":"Un feu perpétuel doit brûler sur l'autel, il ne doit pas s'éteindre."
,"7":"Voici la loi pour l'offrande: les fils d'Aaron la présenteront devant Yahvé, en face de l'autel."
,"8":"Le prêtre prélèvera une poignée de fleur de farine, avec l'huile et l'encens qui est sur l'offrande, et il la fera fumer sur l'autel en sacrifice d'agréable odeur à Yahvé, au nom de celui qui l'a présentée."
,"9":"Ce qui restera de l'offrande sera pour la nourriture d'Aaron et de ses fils; ils le mangeront sans levain dans un lieu pur, dans la cour de la Tente du Rendez-Vous."
,"10":"On ne le cuira pas avec du levain, car c'est la part que je leur ai donnée sur mes offrandes consumées par le feu. C'est une part très sainte, comme la victime pour le péché ou la victime de réparation."
,"11":"Tout mâle parmi les enfants d'Aaron pourra en manger. C'est une loi perpétuelle pour vos descendants, concernant les offrandes faites par le feu en l'honneur de Yahvé. Seuls les hommes consacrés pourront y toucher.'"
,"12":"Yahvé parla encore à Moïse et lui dit:"
,"13":"'Voici l'offrande qu'Aaron et ses fils feront à Yahvé le jour où ils recevront leur consécration: un dixième de mesure de fleur de farine, comme pour l'offrande perpétuelle, moitié le matin et moitié le soir."
,"14":"On la préparera dans une poêle avec de l'huile, puis tu l'apporteras quand elle sera frite; tu l'offriras en morceaux, comme une offrande partagée d'agréable odeur à Yahvé."
,"15":"Le prêtre qui a reçu la consécration, comme celui de ses fils qui lui succédera, fera cette offrande. Elle s'élèvera tout entière en fumée: c'est une loi perpétuelle de Yahvé."
,"16":"Toute offrande présentée par un prêtre sera entièrement consumée par le feu, on n'en mangera pas.'"
,"17":"Yahvé parla à Moïse et lui dit:"
,"18":"'Tu enseigneras à Aaron et à ses fils cette loi du sacrifice pour le péché: on égorgera la victime pour le péché, pour Yahvé, là même où l'on égorge l'holocauste. C'est une chose très sainte."
,"19":"Le prêtre qui offrira la victime pour le péché la mangera dans un lieu pur, dans la cour de la Tente du Rendez-Vous."
,"20":"Seuls ceux qui sont consacrés y toucheront. Si le sang gicle sur un vêtement, l'endroit où le sang aura giclé sera lavé dans un lieu pur."
,"21":"La marmite de terre dans laquelle aura cuit la viande du sacrifice sera brisée; si la marmite est de bronze, elle sera nettoyée et rincée à l'eau."
,"22":"Tout mâle parmi les prêtres en mangera: c'est une chose très sainte."
,"23":"Cependant on ne mangera pas la viande des sacrifices pour le péché dont on aura porté le sang à l'intérieur de la Tente du Rendez-Vous, pour faire l'expiation. Elle sera brûlée par le feu."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Voici la loi concernant le sacrifice de réparation: c'est un acte très saint."
,"2":"La victime de réparation sera égorgée dans le lieu où l'on égorge l'holocauste: on en répandra le sang sur l'autel et autour."
,"3":"On offrira toute la graisse, la queue, la graisse qui enveloppe les entrailles,"
,"4":"les deux rognons avec la graisse qui les recouvre et les entoure, enfin l'enveloppe du foie que l'on détachera près des rognons."
,"5":"Le prêtre les fera fumer sur l'autel en sacrifice par le feu pour Yahvé. C'est un sacrifice de réparation."
,"6":"Tout mâle parmi les prêtres en mangera. Il le mangera dans un lieu pur, car c'est une part sainte."
,"7":"Que ce soit le sacrifice de réparation ou le sacrifice pour le péché: la loi est la même pour les deux. La victime appartient au prêtre qui fait l'expiation."
,"8":"Le prêtre qui offrira un holocauste aura pour lui la peau de la victime qu'il a offerte."
,"9":"Toute offrande cuite au four, ou préparée à la casserole ou à la poêle, sera pour le prêtre qui l'a présentée."
,"10":"Toute offrande pétrie à l'huile ou sèche sera pour tous les fils d'Aaron, à parts égales."
,"11":"Voici la loi du sacrifice de communion que l'on offrira à Yahvé."
,"12":"Si c'est pour rendre grâces, on offrira en plus de la chose sacrifiée des gâteaux sans levain trempés dans l'huile, des galettes sans levain arrosées d'huile, de la fleur de farine pétrie en gâteau trempé dans l'huile."
,"13":"On ajoutera cette offrande aux gâteaux de pâte fermentée et à ce qui est offert en sacrifice de communion pour rendre grâces."
,"14":"Sur chacune de ces offrandes on prélèvera une pièce pour Yahvé: elle sera pour le prêtre qui aura fait l'aspersion avec le sang du sacrifice de communion."
,"15":"La viande de la victime d'un sacrifice de communion pour rendre grâces, sera mangée le jour même. On n'en laissera rien jusqu'au matin."
,"16":"Si la victime est offerte à la suite d'un voeu, ou en offrande volontaire, elle sera mangée le jour même, mais ce qui en reste sera mangé le lendemain."
,"17":"Ce qui resterait de la viande de la victime au troisième jour sera brûlé par le feu."
,"18":"Si, le troisième jour, quelqu'un mange de la viande d'un sacrifice de communion, ce sacrifice ne sera pas agréé: il ne vaudra pas pour celui qui l'a offert. C'est une action mauvaise, et celui qui en aura mangé portera le poids de son péché."
,"19":"On ne mangera pas de la viande qui a touché quelque chose d'impur, elle sera brûlée par le feu. Quant à la viande du sacrifice de communion, toute personne pure pourra en manger."
,"20":"Mais celui qui se trouve dans un état d'impureté et qui aura mangé de la viande du sacrifice de communion qui appartient à Yahvé, sera retranché de son peuple."
,"21":"Celui qui touchera quelque chose d'impur, que ce soit une souillure d'homme ou d'animal, ou toute autre chose impure, et qui mangera la viande du sacrifice de communion qui appartient à Yahvé, sera retranché de son peuple.'"
,"22":"Yahvé parla à Moïse et lui dit:"
,"23":"'Voici ce que tu diras aux Israélites: Vous ne mangerez pas la graisse du boeuf, de la brebis ou de la chèvre."
,"24":"La graisse d'un animal mort ou déchiqueté servira pour n'importe quel usage, mais vous n'en mangerez pas."
,"25":"Celui qui mangera de la graisse des animaux que l'on offre à Yahvé en holocauste, sera retranché de son peuple."
,"26":"Quel que soit l'endroit où vous habitiez, vous ne mangerez du sang, ni d'oiseaux, ni de quadrupèdes."
,"27":"Celui qui en mangera sera retranché de son peuple.'"
,"28":"Yahvé parla à Moïse et lui dit:"
,"29":"'Voici ce que tu diras aux Israélites: Celui qui offrira à Yahvé un sacrifice de communion en apportera une part à Yahvé."
,"30":"Il prendra dans ses mains ce qui doit être offert par le feu à Yahvé, la graisse avec la poitrine, et la poitrine sera balancée devant Yahvé."
,"31":"Le prêtre fera fumer la graisse sur l'autel, et la poitrine sera pour Aaron et ses fils."
,"32":"Vous donnerez également au prêtre la cuisse droite, prélevée sur le sacrifice de communion."
,"33":"La cuisse droite sera la part du fils d'Aaron qui offrira le sang et la graisse des sacrifices de communion."
,"34":"Oui, j'ai pris la poitrine qu'on a balancée et l'épaule qu'on a mise de côté; je les ai prélevées sur tous les sacrifices de communion offerts par les Israélites et je les donne au prêtre Aaron et à ses fils. Ce sera pour toujours une contribution des fils d'Israël."
,"35":"Ce sera la part réservée à Aaron, la part des sacrifices par le feu réservée à ses fils, à partir du jour où ils sont consacrés comme prêtres de Yahvé."
,"36":"Yahvé a commandé aux Israélites de le leur donner à partir du jour de leur consécration; cette loi vaudra d'âge en âge, pour toujours.'"
,"37":"Voilà donc la loi concernant l'holocauste, l'offrande, le sacrifice pour le péché, le sacrifice de réparation, la consécration des prêtres et le sacrifice de communion."
,"38":"Yahvé la donna à Moïse, sur la montagne du Sinaï, le jour où il commanda aux Israélites de lui présenter des offrandes dans le désert du Sinaï."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Yahvé parla à Moïse et lui dit:"
,"2":"'Prends avec toi Aaron et ses fils, leurs vêtements, l'huile de consécration, le taureau du sacrifice pour le péché, les deux béliers et la corbeille de pains sans levain,"
,"3":"et rassemble toute la communauté à l'entrée de la Tente du Rendez-Vous.'"
,"4":"Moïse fit ce que Yahvé lui avait ordonné, et la communauté se rassembla devant la Tente."
,"5":"Moïse dit alors à la communauté: 'Voici ce que Yahvé a ordonné de faire.'"
,"6":"Moïse fit approcher Aaron et ses fils et les lava à l'eau."
,"7":"Il passa à Aaron la tunique, la serra avec la ceinture. Il lui mit le manteau et l'éphod, qu'il attacha avec la bande de l'éphod, le tout soigneusement attaché."
,"8":"Il plaça sur lui le pectoral et, dans le pectoral, il mit les Ourim et les Toumim."
,"9":"Sur sa tête il posa le turban et, sur le devant du turban, la lame d'or, le diadème de sainteté, comme Yahvé avait ordonné à Moïse de le faire."
,"10":"Moïse prit alors l'huile de consécration, il oignit la Demeure et tout ce qu'il y avait à l'intérieur. Il les consacra."
,"11":"Il aspergea sept fois l'autel, il oignit l'autel et tous ses ustensiles, ainsi que le bassin avec son support, pour qu'ils soient aussi consacrés."
,"12":"Il versa l'huile de consécration sur la tête d'Aaron et l'oignit pour le consacrer."
,"13":"Moïse fit encore approcher les fils d'Aaron, il les habilla de tuniques qu'il serra avec une ceinture, et leur posa les mitres, comme Yahvé le lui avait ordonné."
,"14":"Il fit ensuite approcher le taureau du sacrifice pour le péché. Aaron et ses fils posèrent la main sur la tête du taureau du sacrifice pour le péché,"
,"15":"puis Moïse l'égorgea, prit du sang, et avec son doigt il en mit sur les cornes de l'autel pour le purifier. Il versa le reste du sang au pied de l'autel et le consacra en faisant sur lui le rite de l'expiation."
,"16":"Il prit ensuite toute la graisse qui enveloppe les entrailles, l'enveloppe du foie et les deux rognons avec leur graisse, et les fit fumer sur l'autel."
,"17":"Mais le taureau, sa peau, sa viande et ses excréments, il les brûla hors du camp, comme Yahvé avait ordonné à Moïse de le faire."
,"18":"Il fit approcher le bélier de l'holocauste. Aaron et ses fils posèrent leurs mains sur la tête du bélier,"
,"19":"puis on l'égorgea et Moïse répandit le sang sur l'autel et autour."
,"20":"On coupa ensuite le bélier en morceaux, et Moïse fit fumer la tête, les morceaux et la graisse."
,"21":"On lava dans l'eau les entrailles et les jambes, et Moïse fit fumer tout le bélier sur l'autel, en holocauste d'agréable odeur, un sacrifice par le feu pour Yahvé, comme Yahvé le lui avait ordonné."
,"22":"Il fit approcher le second bélier, le bélier pour la consécration. Aaron et ses fils posèrent leurs mains sur sa tête,"
,"23":"puis Moïse égorgea ce bélier, prit de son sang et en mit sur l'oreille droite d'Aaron, sur le pouce de sa main droite et sur le gros orteil de son pied droit."
,"24":"Il fit approcher à leur tour les fils d'Aaron. Il mit du sang sur leur oreille droite, sur le pouce de leur main droite et sur le gros orteil de leur pied droit. Puis il versa le reste du sang sur l'autel et autour."
,"25":"Il prit ensuite la graisse, la queue, toute la graisse qui couvre les entrailles, l'enveloppe du foie, les deux rognons avec leur graisse et la cuisse droite."
,"26":"Il prit aussi la corbeille de pains sans levain qui était devant Yahvé, un gâteau sans levain, un gâteau pétri à l'huile et une galette, et il posa le tout sur les graisses et sur la cuisse droite."
,"27":"Après avoir remis le tout dans les mains d'Aaron et dans les mains de ses fils, il les balança en offrande devant Yahvé."
,"28":"Alors Moïse retira le tout de leurs mains et le fit fumer sur l'autel par-dessus l'holocauste: c'était le sacrifice de consécration, un sacrifice par le feu d'agréable odeur pour Yahvé."
,"29":"Moïse prit la poitrine du bélier de consécration et la balança en offrande devant Yahvé: ce fut la part de Moïse, comme Yahvé l'avait ordonné à Moïse."
,"30":"Moïse prit alors l'huile de consécration, et de l'autel il prit du sang; il en aspergea Aaron et ses vêtements, les fils d'Aaron et leurs vêtements. Il consacra ainsi Aaron et ses vêtements, ses fils et leurs vêtements."
,"31":"Moïse dit à Aaron et à ses fils: 'Faites cuire la viande à l'entrée de la Tente du Rendez-Vous. C'est là que vous la mangerez, avec le pain qui est dans la corbeille de consécration, comme je vous l'ai ordonné quand j'ai dit: Aaron et ses fils en mangeront."
,"32":"Ce qui restera de la viande et du pain, vous le brûlerez."
,"33":"Vous ne sortirez pas de devant la Tente du Rendez-Vous avant sept jours, avant que les jours de votre consécration soient accomplis, car votre consécration durera sept jours.'"
,"34":"Moïse ajouta: 'Nous avons fait aujourd'hui, pour l'expiation en votre nom, ce que Yahvé a ordonné de faire:"
,"35":"durant sept jours et sept nuits vous resterez devant la Tente du Rendez-Vous. Vous observerez ces ordres de Yahvé sous peine de mort, c'est ainsi qu'il me l'a ordonné.'"
,"36":"Aaron et ses fils firent tout comme Yahvé l'avait ordonné à Moïse."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Le huitième jour, Moïse appela Aaron et ses fils, ainsi que les anciens d'Israël."
,"2":"Il dit à Aaron: 'Prends un jeune veau pour le sacrifice pour le péché, et un bélier pour l'holocauste, tous les deux sans défaut; tu les offriras devant Yahvé."
,"3":"Puis tu diras aux Israélites: Prenez un bouc pour le sacrifice pour le péché; un veau et un agneau âgés d'un an, sans défaut, pour l'holocauste;"
,"4":"un boeuf et un bélier qui seront immolés devant Yahvé pour le sacrifice de communion, et enfin une offrande pétrie à l'huile; car aujourd'hui Yahvé se manifestera devant vous.'"
,"5":"Ils apportèrent devant la Tente de Réu nion tout ce que Moïse avait commandé, et toute la communauté s'approcha et se tint devant Yahvé."
,"6":"Moïse dit alors: 'Voici ce que Yahvé vous demande de faire si vous voulez que la Gloire de Yahvé vous apparaisse.'"
,"7":"Puis Moïse dit à Aaron: 'Approche-toi de l'autel, offre ton sacrifice pour le péché et ton holocauste de façon à faire l'expiation pour toi et pour le peuple, présente l'offrande du peuple et fais l'expiation pour lui, comme Yahvé l'a ordonné.'"
,"8":"Aaron s'approcha donc de l'autel, il égorgea le veau du sacrifice pour son péché personnel."
,"9":"Les fils d'Aaron lui présentèrent le sang, il y trempa son doigt, en mit sur les cornes de l'autel et en versa le reste au pied de l'autel."
,"10":"Puis il fit fumer sur l'autel la graisse, les rognons et l'enveloppe du foie de la victime pour le péché, comme Yahvé avait ordonné de le faire."
,"11":"Mais la chair et la peau, il les brûla hors du camp."
,"12":"Ensuite il égorgea la victime pour l'holocauste, et les fils d'Aaron lui présentèrent le sang qu'il répandit sur l'autel et autour."
,"13":"Ils lui présentèrent l'holocauste coupé en morceaux avec la tête, et il les fit fumer sur l'autel."
,"14":"Il lava l'intestin et les pattes et les fit fumer sur l'autel, par-dessus l'holocauste."
,"15":"Il présenta alors l'offrande pour le peuple. Il prit le bouc du sacrifice pour le péché du peuple, il l'égorgea et fit l'expiation comme il l'avait fait pour le premier sacrifice."
,"16":"Il offrit ensuite l'holocauste et le sacrifia selon le même rite."
,"17":"Il présenta l'offrande, en prit une poignée et la brûla sur l'autel, par-dessus l'holocauste du matin."
,"18":"Ensuite il égorgea le taureau et le bélier, en sacrifice de communion pour le peuple. Les fils d'Aaron lui présentèrent le sang qu'il versa sur l'autel et autour."
,"19":"Quant à la graisse du taureau et du bélier, la queue, la graisse qui enveloppe les entrailles, les rognons et l'enveloppe du foie,"
,"20":"avec la graisse de la poitrine, il plaça le tout sur l'autel et le fit brûler."
,"21":"Aaron balança ensuite devant Yahvé les poitrines et la cuisse droite, en offrande balancée, selon l'ordre de Moïse."
,"22":"Aaron leva les mains vers le peuple et le bénit, puis il descendit, après avoir offert le sacrifice pour le péché, l'holocauste et le sacrifice de communion."
,"23":"Cela fait, Moïse et Aaron entrèrent dans la Tente du Rendez-Vous, puis ils en ressortirent pour bénir le peuple. Alors la Gloire de Yahvé apparut à tout le peuple:"
,"24":"un feu sortit de devant Yahvé, qui dévora sur l'autel l'holocauste et les graisses. A cette vue, tout le peuple poussa des cris de joie et se prosterna face contre terre."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Nadab et Abihou, fils d'Aaron, prirent chacun leur encensoir. Ils y mirent du feu et, sur ce feu, de l'encens qu'ils offrirent devant Yahvé. Mais ce feu n'était pas conforme à ses ordres."
,"2":"Et voilà qu'un feu sortit de devant Yahvé et les dévora: ils moururent là devant Yahvé."
,"3":"Moïse dit alors à Aaron: 'C'est bien ce qu'avait dit Yahvé: En ceux qui m'approchent je ferai voir ma sainteté, et devant tout le peuple je ferai voir ma gloire.' Aaron ne dit pas un mot."
,"4":"Moïse appela Mikaël et Elsafan, fils d'Ouziel, l'oncle d'Aaron. Il leur dit: 'Approchez et emportez vos frères loin du sanctuaire, hors du camp.'"
,"5":"Ils s'approchèrent donc et les emportèrent dans leurs vêtements hors du camp, comme Moïse l'avait ordonné."
,"6":"Moïse dit encore à Aaron, à Eléazar et à Itamar, ses fils: 'Ne dénouez pas vos cheveux et ne déchirez pas vos habits en signe de deuil, car ce serait votre mort et le Seigneur s'irriterait contre toute la communauté. Ce sont vos frères de toute la communauté d'Israël, qui se lamenteront pour ce feu qu'a envoyé Yahvé."
,"7":"Mais vous, ne sortez pas de devant la Tente du Rendez-Vous, sinon ce serait la mort, car l'huile de consécration de Yahvé est sur vous.' Ils firent donc comme Moïse l'avait dit."
,"8":"Yahvé s'adressa à Aaron et lui dit:"
,"9":"'Tu ne boiras ni vin, ni boisson enivrante, et tes fils non plus, lorsque vous entrerez dans la Tente du Rendez-Vous. Sinon, ce serait la mort. Cette règle vaudra d'âge en âge, toujours."
,"10":"Ainsi vous saurez séparer le sacré et le profane, l'impur et le pur,"
,"11":"et vous pourrez enseigner aux Israélites tous les rites que Yahvé vous a donnés par la bouche de Moïse.'"
,"12":"Moïse dit à Aaron, ainsi qu'à Eléazar et Itamar, les deux fils qui lui restaient: 'Prenez ce qui reste du sacrifice offert par le feu pour Yahvé. Mangez-le comme un pain sans levain à côté de l'autel, car c'est une part très sainte."
,"13":"Vous le mangerez dans un lieu pur, car c'est ta part et la part de tes fils sur les sacrifices offerts par le feu, pour Yahvé, comme il me l'a commandé."
,"14":"Vous mangerez dans un lieu pur, toi, tes fils et tes filles, la poitrine qui a été balancée et la cuisse qui a été prélevée, car c'est ta part et la part de tes fils, sur les sacrifices de communion que les Israélites me présentent."
,"15":"Ils apporteront en plus des graisses du sacrifice par le feu, la cuisse qui a été prélevée et la poitrine qui doit être balancée. On les balancera devant Yahvé, et ils seront pour toi et pour tes fils; c'est un droit perpétuel: Yahvé l'a ordonné."
,"16":"Moïse rechercha le bouc de l'expiation, et s'aperçut qu'il avait été brûlé. Il se mit en colère contre Eléazar et Itamar, les deux fils qui restaient à Aaron:"
,"17":"'Pourquoi n'avez-vous pas mangé la victime du sacrifice d'expiation dans un lieu saint, leur dit-il, c'est une part sainte, et Yahvé vous l'a donnée pour expier le péché de la communauté et obtenir son pardon devant Yahvé."
,"18":"Vous deviez introduire le sang de la victime à l'intérieur du sanctuaire, et la manger dans le sanctuaire, comme il me l'a ordonné.'"
,"19":"Aaron répondit à Moïse: 'Ils ont bien offert aujourd'hui un sacrifice pour le péché et un holocauste, devant Yahvé. Mais après ce qui m'est arrivé aujourd'hui, qu'aurait dit Yahvé, si j'avais mangé du sacrifice pour le péché?'"
,"20":"Cette explication parut bonne à Moïse."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Yahvé parla à Moïse et à Aaron, il leur dit:"
,"2":"'Voici ce que vous direz aux Israélites: Parmi toutes les bêtes qui sont sur la terre, voici celles que vous mangerez."
,"3":"Vous pourrez manger de tout animal qui a le sabot divisé, le pied fourchu et qui rumine,"
,"4":"mais vous ne mangerez pas de ceux qui ruminent seulement, ou qui ont seulement le sabot divisé. C'est le cas du chameau, qui rumine, mais dont le sabot n'est pas divisé: il sera impur pour vous."
,"5":"De même la marmotte, qui rumine, mais qui n'a pas le sabot divisé: elle sera impure pour vous."
,"6":"De même le lièvre, qui rumine, mais qui n'a pas le sabot divisé,: il sera impur pour vous."
,"7":"De même le porc, qui a le sabot divisé, le pied fourchu, mais qui ne rumine pas: il sera impur pour vous."
,"8":"Vous ne mangerez pas leur viande et vous ne toucherez pas à leur cadavre, ils seront impurs à vos yeux."
,"9":"Parmi tous les animaux qui vivent dans l'eau, voici ceux que vous pourrez manger: vous mangerez tous ceux qui ont des nageoires et qui vivent, soit dans la mer, soit dans les rivières."
,"10":"Mais vous aurez en horreur, parmi tout ce qui vit et s'agite dans les eaux, tous les êtres vivants qui n'ont ni nageoires ni écailles, aussi bien dans la mer que dans les rivières."
,"11":"Vous les aurez en horreur, vous ne mangerez pas leur chair et vous aurez en dégoût leur cadavre."
,"12":"Vous aurez en horreur tout ce qui vit et s'agite dans l'eau et qui n'a ni nageoires ni écailles."
,"13":"Parmi les oiseaux, voici ceux que vous aurez en horreur, ceux que vous ne mangerez pas, car ils sont répugnants:"
,"14":"l'aigle et le vautour, quelle que soit leur espèce,"
,"15":"toutes les espèces de corbeaux,"
,"16":"l'autruche, le chat-huant, la mouette et toutes les sortes d'éperviers,"
,"17":"le hibou, le cormoran et la chouette,"
,"18":"le cygne, le pélican et le vautour royal,"
,"19":"la cigogne, toutes les espèces de hérons, la huppe et la chauve-souris."
,"20":"Vous aurez en horreur tous les insectes ailés qui marchent à quatre pattes."
,"21":"Mais parmi tous les insectes ailés qui marchent à quatre pattes, vous pourrez manger ceux qui ont des jambes plus hautes que les autres pattes et qui sautent sur la terre."
,"22":"C'est ainsi que vous pourrez manger les sauterelles de toutes espèces, la Solam comme la Hargol ou la Hagab."
,"23":"Mais vous aurez en horreur tous les autres insectes ailés qui marchent à quatre pattes."
,"24":"Tous ces animaux vous rendront impurs et celui qui touchera leur cadavre sera impur jusqu'au soir."
,"25":"Si quelqu'un touche leur cadavre, il lavera ses vêtements et sera impur jusqu'au soir."
,"26":"Tout animal qui a le sabot divisé mais qui n'a pas le pied fourchu et qui ne rumine pas, sera impur à vos yeux. Si quelqu'un le touche il sera impur."
,"27":"Vous regarderez comme impur tout quadrupède qui marche sur la plante des pieds. Si quelqu'un touche son cadavre, il sera impur jusqu'au soir."
,"28":"Et si quelqu'un transporte son cadavre, il lavera ses vêtements et sera impur jusqu'au soir. Ces animaux seront impurs à vos yeux."
,"29":"Parmi les petites bêtes qui rampent sur la terre, voici celles qui seront impures à vos yeux: la belette, la souris, toutes les espèces de lézards,"
,"30":"la musaraigne, le caméléon, la salamandre, le lézard vert et la taupe."
,"31":"Tous ces reptiles seront impurs à vos yeux. Si quelqu'un touche leur cadavre, il sera impur jusqu'au soir."
,"32":"Tout objet sur lequel tombera leur cadavre sera impur, que ce soit un objet en bois ou en cuir, un vêtement, un sac ou tout autre objet usuel. On le mettra dans l'eau et il restera impur jusqu'au soir, après quoi il sera pur."
,"33":"S'il en tombe un morceau dans un vase de terre, tout ce qui sera à l'intérieur de ce vase sera impur et vous le briserez."
,"34":"S'il en tombe dans la nourriture, même dans la soupe, cette nourriture sera impure. S'il en tombe dans une boisson, quel que soit le vase qui la contienne, la boisson sera impure."
,"35":"Tout objet sur lequel il en tombera quelque chose sera impur. Le four et le vase avec son couvercle seront détruits, ils sont impurs et vous les tiendrez pour tels."
,"36":"Mais les sources et les citernes dans lesquelles on ramasse l'eau resteront pures. Quiconque touchera leur cadavre sera impur."
,"37":"S'il tombe quelque chose de leur cadavre sur du grain qui doit être semé, la semence restera pure."
,"38":"Mais si le grain a été mis dans l'eau et qu'il y tombe quelque chose de leur cadavre, vous la tiendrez pour impure."
,"39":"Si l'un des animaux qui vous servent de nourriture meurt, celui qui touchera le cadavre sera impur jusqu'au soir."
,"40":"Celui qui mangera de son cadavre lavera ses vêtements et sera impur jusqu'au soir, celui qui transportera le cadavre lavera ses vêtements et sera impur jusqu'au soir."
,"41":"Vous aurez en horreur tout reptile qui rampe sur la terre, vous n'en mangerez point."
,"42":"On ne mangera pas ceux qui se traînent sur le ventre ni ceux qui rampent sur la terre avec leur quatre pieds ou avec un grand nombre de pieds, vous les aurez en horreur."
,"43":"Ne souillez pas votre personne avec tous ces reptiles qui rampent, ne vous rendez pas impurs à cause d'eux, et ne les laissez pas vous rendre impurs."
,"44":"Car je suis Yahvé, votre Dieu; vous vous sanctifierez et vous serez saints, car moi je suis Saint. Vous ne vous souillerez pas avec tous ces reptiles qui rampent sur la terre,"
,"45":"car je suis Yahvé qui vous ai fait monter du pays d'Egypte, pour être votre Dieu. Vous serez saints parce que je suis Saint."
,"46":"Voilà donc la loi touchant les quadrupèdes, les oiseaux, tous les êtres vivants qui vivent dans l'eau et tous ceux qui rampent sur la terre."
,"47":"Vous ferez la différence entre ce qui est impur et ce qui est pur, entre l'animal que l'on peut manger et celui que l'on ne doit pas manger.'"
}`)
	CurrentBook.AddChapter(12, `{
"1":"Yahvé dit à Moïse:"
,"2":"'Voici ce que tu diras aux Israélites: lorsqu'une femme aura été fécondée et donnera le jour à un garçon, elle sera impure durant sept jours comme elle est impure à la période de ses règles."
,"3":"Le huitième jour l'enfant sera circoncis dans sa chair, son prépuce."
,"4":"Elle, elle restera trente-trois jours à se purifier de son sang, elle ne touchera aucune chose sainte et n'entrera pas dans le sanctuaire jusqu'au jour où s'achèvera le temps de sa purification."
,"5":"Si elle a mis au monde une fille, elle sera impure durant deux semaines, comme au temps de ses règles, puis elle restera soixante-six jours à se purifier de son sang."
,"6":"Lorsque le temps de sa purification sera accompli, pour un fils comme pour une fille, elle présentera au prêtre à l'entrée de la Tente du Rendez-Vous, un agneau d'un an pour l'holocauste et un jeune pigeon ou une tourterelle pour le sacrifice pour le péché."
,"7":"Le prêtre les offrira devant Yahvé et fera pour elle l'expiation, alors elle sera pure de son flux de sang. Voici la loi concernant la femme qui met au monde un fils ou une fille."
,"8":"Si la femme n'a pas de quoi se procurer un agneau, elle prendra deux tourterelles ou deux jeunes pigeons, l'un pour l'holocauste et l'autre pour le sacrifice pour le péché. Le prêtre fera pour elle l'expiation et elle sera purifiée.'"
}`)
	CurrentBook.AddChapter(13, `{
"1":"Yahvé parla à Moïse et à Aaron, il leur dit:"
,"2":"'Lorsqu'un homme aura sur la peau une tumeur, une plaque ou une tache blanche qui tourneront sur sa peau en plaie de lèpre, on le conduira à Aaron, le prêtre, ou à l'un de ses fils qui sont prêtres."
,"3":"Le prêtre examinera la plaie qui est sur la peau. Si le poil de la plaie est devenu blanc et que la plaie paraît plus profonde que la peau, c'est une plaie de lèpre. Le prêtre qui aura fait l'examen déclarera l'homme impur."
,"4":"S'il y a sur la peau une tache blanche qui n'est pas plus profonde que la peau, si le poil n'est pas devenu blanc, le prêtre isolera pendant sept jours celui qui a cette plaie."
,"5":"Le septième jour le prêtre l'examinera. Si la plaie n'a pas fait de progrès, si elle ne s'est pas développée sur la peau, le prêtre l'isolera encore pendant sept jours."
,"6":"Le septième jour le prêtre l'examinera de nouveau. Si la plaie a séché, ne s'est pas étendue sur la peau, le prêtre déclarera cet homme pur: c'est une plaque sans gravité. L'autre lavera ses vêtements et sera pur."
,"7":"Mais si la plaque s'est développée sur la peau après que le prêtre l'ait examinée en vue de sa purification, il se présentera de nouveau devant le prêtre."
,"8":"Le prêtre l'examinera encore une fois; si la plaque s'est développée sur la peau, le prêtre le déclarera impur: c'est la lèpre."
,"9":"On conduira vers le prêtre l'homme qui a une plaie de lèpre."
,"10":"Le prêtre l'examinera: y a-t-il sur la peau une tumeur blanche, cette tumeur a-t-elle fait blanchir le poil, y a-t-il dans la tumeur des traces de chair à vif?"
,"11":"Dans ce cas, c'est une lèpre caractérisée sur la peau. Le prêtre le déclarera impur, il n'y a pas à l'isoler encore car cet homme est impur: c'est évident."
,"12":"Si la lèpre s'est développée sur la peau et la couvre entièrement, depuis la tête jusqu'aux pieds, tout au moins pour ce que voient les yeux du prêtre,"
,"13":"le prêtre l'examinera. Même si la lèpre couvre tout le corps, il déclarera pur celui qui a la tache, car il est complètement blanc: il est encore pur."
,"14":"Mais le jour où apparaîtra de la chair à vif, il sera impur."
,"15":"Quand le prêtre aura vu la chair à vif, il déclarera cet homme impur: la chair à vif est impure, c'est la lèpre."
,"16":"Si la chair à vif redevient blanche, il ira trouver le prêtre."
,"17":"Le prêtre l'examinera, et si la plaie a blanchi, le prêtre déclarera cet homme pur."
,"18":"Lorsqu'un homme aura sur le corps ou sur la peau un ulcère, il se peut que l'ulcère guérisse,"
,"19":"mais qu'à la place il vienne une tumeur ou une tache rouge. Alors cet homme ira se montrer au prêtre"
,"20":"et le prêtre l'examinera. Si la tache paraît plus profonde que la peau, et que le poil y est devenu blanc, le prêtre déclarera cet homme impur: c'est une plaie de lèpre qui a pris la place de l'ulcère."
,"21":"Mais si le prêtre voit qu'il n'y a pas de poil blanc dans la tache et que celle-ci n'est pas profonde, qu'elle a séché, il isolera cet homme pendant sept jours."
,"22":"Si pendant ce temps la tache s'est développée sur la peau, le prêtre déclarera l'homme impur: c'est une plaie de lèpre."
,"23":"Si au contraire la tache n'a pas bougé, si elle ne s'est pas étendue, ce n'est que la cicatrice de l'ulcère. Le prêtre déclarera l'homme pur."
,"24":"Si un homme a sur le corps ou sur la peau une brûlure faite par le feu, s'il se forme à l'endroit de la brûlure une tache blanche ou rouge,"
,"25":"le prêtre l'examinera. Si le poil est devenu blanc à l'emplacement de la tache et qu'elle paraisse plus profonde que la peau, c'est que la brûlure s'est transformée en lèpre. Le prêtre déclarera cet homme impur: il a une plaie de lèpre."
,"26":"Si le prêtre voit qu'il n'y a pas de poil blanc à l'emplacement de la tache, qu'elle n'est pas plus profonde que la peau et qu'elle devient plus pâle, il isolera cet homme pendant sept jours."
,"27":"Le septième jour le prêtre l'examinera. Si la tache s'est développée sur la peau, le prêtre le déclarera impur: c'est une plaie de lèpre."
,"28":"Si la tache n'a pas bougé, si elle ne s'est pas étendue sur la peau et qu'elle est devenue plus claire, c'est la croûte de la brûlure. Le prêtre déclarera cet homme pur: c'est une cicatrice de brûlure."
,"29":"Si un homme ou une femme a une plaie à la tête ou au menton, le prêtre examinera la plaie."
,"30":"Si elle paraît plus profonde que la peau, si le poil y est jaune et vilain, le prêtre déclarera cette personne impure: c'est une lèpre particulière, c'est la lèpre de la tête ou du menton."
,"31":"Si le prêtre voit que la plaie de cette lèpre ne semble pas plus profonde que la peau, bien que le poil ne soit pas noir, le prêtre isolera cette personne pendant sept jours."
,"32":"Le septième jour le prêtre examinera la plaie. Si cette lèpre particulière ne s'est pas étendue, s'il n'y a pas de poil jaune et que cette lèpre n'est pas plus profonde que la peau,"
,"33":"le malade se rasera, mais il ne rasera pas l'endroit de la plaie. Le prêtre l'isolera une seconde fois pendant sept jours."
,"34":"Le septième jour le prêtre examinera sa lèpre. Si elle ne s'est pas étendue sur la peau, si elle ne paraît pas plus profonde que la peau, le prêtre déclarera cette personne pure. Elle lavera ses vêtements et sera pure."
,"35":"Cependant, si cette lèpre se développe sur la peau du malade après qu'on l'ait déclaré pur, le prêtre l'examinera de nouveau."
,"36":"Si la lèpre s'est développée sur la peau, le prêtre n'aura pas à rechercher s'il y a du poil jaune: cette personne est impure."
,"37":"Mais si, selon l'avis du prêtre, la lèpre n'a pas fait de progrès et qu'il y ait du poil noir, c'est que cette lèpre est guérie. Cette personne est pure, le prêtre la déclarera pure."
,"38":"Lorsqu'un homme ou une femme aura sur la peau des taches blanches, le prêtre l'examinera."
,"39":"S'il y a sur la peau des taches d'un blanc sale, c'est une sorte d'eczéma qui a poussé sur la peau: il est pur."
,"40":"Lorsqu'un homme a perdu ses cheveux, il est chauve, mais il est pur."
,"41":"Si ce sont les cheveux de devant qui sont tombés, il a le front chauve mais il est pur."
,"42":"Mais si une plaie rouge se forme sur la partie chauve, que ce soit devant ou derrière, c'est que la lèpre s'est développée à l'endroit où il était chauve."
,"43":"Le prêtre l'examinera: si la plaie forme une tumeur rouge sur la partie chauve, que ce soit derrière ou devant, et que cette tumeur ressemble à la lèpre de la peau,"
,"44":"cet homme est lépreux: il est impur. Le prêtre le déclarera impur, car il a à la tête une plaie de lèpre."
,"45":"Le lépreux qui a cette plaie portera ses vêtements déchirés et laissera flotter ses cheveux. Il se cachera le visage jusqu'à la moustache et criera: 'Impur! Impur!'"
,"46":"Tant que durera sa plaie il sera impur, et comme impur, il habitera seul; il restera en dehors du camp."
,"47":"Lorsqu'il y aura une plaie de lèpre sur un vêtement de lin ou de laine;"
,"48":"que ce soit sur le fil de lin ou de laine destiné à la chaîne, ou sur celui de la trame d'un tissu -ou encore sur du cuir ou sur quelque ouvrage en peau;"
,"49":"si la plaie est verdâtre ou rouge sur le vêtement ou sur le cuir, ou sur le fil de chaîne, ou de trame, ou sur tout objet de peau, c'est une plaie de lèpre: on la montrera au prêtre."
,"50":"Après avoir regardé la plaie, le prêtre enfermera l'objet suspect pendant sept jours."
,"51":"Le septième jour il examinera de nouveau la plaie. Si la plaie s'est développée sur le vêtement, sur le fil de chaîne ou de trame, sur la peau ou sur un objet quelconque en peau, c'est une plaie de lèpre: l'objet est impur."
,"52":"On brûlera le vêtement, le fil de lin ou de laine destiné à la chaîne ou à la trame du tissu, ou l'objet en peau sur lequel se trouve la plaie, car c'est la lèpre. L'objet sera donc brûlé au feu."
,"53":"Mais si le prêtre voit que la plaie ne s'est pas développée sur le vêtement, sur le fil de chaîne ou de trame, ou sur l'objet en peau,"
,"54":"il fera laver la plaie et isolera une seconde fois cet objet pendant sept jours."
,"55":"Le prêtre examinera alors la plaie qui aura été lavée. Si elle n'a pas changé d'aspect, même si elle ne s'est pas étendue, l'objet est impur. On le brûlera car la lèpre l'a rongé à l'endroit ou à l'envers."
,"56":"Mais si le prêtre voit que la plaie, après avoir été lavée, est plus claire, il l'arrachera du vêtement, de la peau ou du fil de chaîne ou de trame."
,"57":"Cependant, si elle revient sur le vêtement, sur le fil de chaîne ou de trame ou sur l'objet en peau, c'est que la lèpre est revenue. Tu brûleras alors cet objet."
,"58":"Le vêtement, le fil de chaîne ou de trame, ou l'objet de peau dont la plaie aura disparu après lavage, sera lavé une seconde fois: alors il sera pur."
,"59":"Voilà donc la loi concernant la plaie de lèpre sur les vêtements de laine ou de lin, sur le fil de chaîne ou de trame, ou sur tout objet fait en peau: elle servira pour déclarer les objets purs et les objets impurs.'"
}`)
	CurrentBook.AddChapter(14, `{
"1":"Yahvé parla à Moïse et lui dit:"
,"2":"'Voici la loi pour le jour de la purification du lépreux, quand on le conduit au prêtre."
,"3":"Le prêtre sortira du camp pour l'examiner et devra vérifier que la plaie de lèpre est guérie."
,"4":"Alors le prêtre ordonnera qu'on prenne pour celui qui doit être purifié, deux oiseaux purs, vivants, du bois de cèdre, du cramoisi et de l'hysope."
,"5":"Le prêtre ordonnera d'immoler le premier oiseau sur un vase d'argile, au-dessus d'une eau vive."
,"6":"Il prendra l'oiseau encore vivant, le bois de cèdre, le cramoisi et l'hysope, et il plongera le tout dans le sang de l'oiseau immolé au-dessus de l'eau vive."
,"7":"Ensuite il aspergera sept fois celui qui doit être purifié de la lèpre; il le déclarera pur et lâchera l'oiseau vivant en pleine campagne."
,"8":"Celui qui aura été purifié lavera ses vêtements, rasera tout son poil et se baignera dans l'eau: alors il sera pur et il pourra rentrer au camp. Mais il devra d'abord rester sept jours hors de sa tente."
,"9":"Le septième jour il se rasera de nouveau: il rasera sa tête, son menton et ses sourcils. Il rasera tout son poil, lavera ses vêtements et se baignera dans l'eau: il sera pur."
,"10":"Le huitième jour il prendra deux agneaux sans défaut, une petite brebis née dans l'année, sans défaut, trois mesures de fleur de farine arrosée d'huile pour l'offrande, et une mesure d'huile."
,"11":"Le prêtre qui fait la purification présentera l'homme qui vient pour se purifier, ainsi que ses offrandes, devant Yahvé à l'entrée de la Tente du Rendez-Vous."
,"12":"Le prêtre prendra alors le premier agneau et la mesure d'huile; il les offrira en sacrifice de réparation et les balancera solennellement devant Yahvé."
,"13":"Il immolera l'agneau à l'endroit où l'on immole les sacrifices pour le péché et l'holocauste, dans un lieu pur, car la victime de réparation est pour le prêtre, comme le sacrifice pour le péché: c'est une chose très sainte."
,"14":"Le prêtre prendra alors du sang du sacrifice de réparation, il en mettra sur l'oreille droite de celui qui vient pour être purifié, sur le pouce de sa main droite et sur le gros orteil de son pied droit."
,"15":"Le prêtre prendra ensuite la mesure d'huile et il en versera dans sa main gauche."
,"16":"Il trempera son doigt de la main droite dans l'huile qui est dans sa main gauche et, avec son doigt, il fera sept fois l'aspersion devant Yahvé."
,"17":"Avec le reste de l'huile qui est dans sa main, le prêtre fera une onction sur l'oreille droite de celui qui se purifie, par dessus le sang du sacrifice de réparation."
,"18":"Et ce qui reste d'huile dans la main du prêtre, il le mettra sur la tête de celui qui se purifie en demandant pour lui miséricorde."
,"19":"Le prêtre fera alors le rite de l'expiation et de la réparation sur celui qui se purifie de son impureté, après quoi il immolera l'holocauste."
,"20":"Le prêtre fera fumer l'holocauste et l'offrande sur l'autel, puis il demandera pour lui miséricorde: alors il sera pur."
,"21":"La personne pauvre, qui n'a que peu de moyens, prendra un seul agneau pour le sacrifice de réparation: ce sera une offrande balancée, pour la réparation de son impureté. Elle ne prendra qu'une mesure de fleur de farine pétrie dans l'huile pour l'offrande, une mesure d'huile,"
,"22":"deux tourterelles ou deux jeunes pigeons selon ses moyens: l'un pour le sacrifice pour le péché, l'autre pour l'holocauste."
,"23":"Le huitième jour il les apportera au prêtre pour sa purification, à l'entrée de la Tente du Rendez-Vous, devant Yahvé."
,"24":"Alors le prêtre prendra l'agneau pour le sacrifice de réparation et la mesure d'huile, et il les balancera devant Yahvé."
,"25":"Après avoir immolé l'agneau du sacrifice de réparation, le prêtre prendra du sang du sacrifice de réparation et en mettra sur l'oreille droite de celui qui vient se purifier, sur le pouce de sa main droite et sur le gros orteil de son pied droit."
,"26":"Le prêtre versera ensuite de l'huile dans sa main gauche,"
,"27":"il prendra avec le doigt de sa main droite de l'huile dans sa main gauche et fera sept fois l'aspersion devant Yahvé."
,"28":"Le prêtre mettra de l'huile qui est dans sa main sur l'oreille droite de celui qui vient se purifier, sur le pouce de sa main droite et sur le gros orteil de son pied droit, à l'endroit où il a déjà mis le sang de la victime de réparation."
,"29":"Ce qui restera d'huile dans la main du prêtre, il la mettra sur la tête de celui qui vient se purifier et demandera pour lui miséricorde."
,"30":"Il offrira l'une des tourterelles ou l'un des jeunes pigeons qu'il aura amenés en sacrifice pour le péché,"
,"31":"l'autre sera immolé en holocauste, avec l'offrande. C'est ainsi que le prêtre fera devant Yahvé l'expiation pour celui qui vient se purifier."
,"32":"Voilà la loi pour la purification du lépreux dont les moyens sont modestes.'"
,"33":"Yahvé parla à Moïse et à Aaron et leur dit:"
,"34":"'Lorsque vous entrerez dans le pays de Canaan et que vous le posséderez, si je frappe de la lèpre une maison du pays que vous possédez,"
,"35":"le propriétaire de la maison viendra dire au prêtre: J'ai vu comme une tache de lèpre dans la maison."
,"36":"Le prêtre, avant d'entrer, ordonnera de vider toute la maison pour que rien de ce qui est dedans ne soit impur. Ensuite le prêtre entrera pour voir la maison."
,"37":"Il regardera la tache et, si cette tache fait sur les murs de la maison, comme des crevasses profondes vertes ou rouges,"
,"38":"il fermera la maison pour sept jours."
,"39":"Le septième jour le prêtre reviendra et examinera: si la tache s'est développée sur les murs de la maison,"
,"40":"le prêtre ordonnera d'enlever toutes les pierres à l'endroit de la tache et de les jeter hors de la ville dans un lieu impur."
,"41":"Il fera ensuite gratter tout l'intérieur de la maison. On répandra la poussière que l'on aura grattée à l'extérieur de la ville dans un lieu impur,"
,"42":"on remplacera les pierres qu'on a enlevées par de nouvelles pierres, on prendra un nouvel enduit et on en crépira la maison."
,"43":"Mais voilà: la tache recommence à se développer dans la maison; pourtant on a enlevé les pierres et on a gratté la maison, on a mis un nouvel enduit."
,"44":"Dans ce cas le prêtre entrera pour examiner la maison: si la tache s'est développée, c'est une lèpre caractérisée dans la maison: elle est impure."
,"45":"Alors on démolira la maison: ses pierres, ses charpentes et tout le mortier de la maison seront jetés hors de la ville dans un lieu impur."
,"46":"Celui qui sera entré dans la maison pendant le temps où elle a été condamnée, sera impur jusqu'au soir."
,"47":"Celui qui aura dormi ou mangé dans la maison, lavera ses habits."
,"48":"Si le prêtre entre et voit que, depuis le nouvel enduit, la tache ne s'est pas développée dans la maison, il déclarera la maison pure: la tache est guérie."
,"49":"Pour faire le rite de réparation pour la maison, le prêtre prendra deux oiseaux, du bois de cèdre, du cramoisi et de l'hysope."
,"50":"Il immolera le premier oiseau sur un vase d'argile au-dessus d'une eau vive."
,"51":"Il prendra ensuite le bois de cèdre, l'hysope, le cramoisi et l'oiseau vivant; il les plongera dans le sang de l'oiseau immolé au-dessus de l'eau vive et, par sept fois, il fera l'aspersion de la maison."
,"52":"Il fera le rite de la réparation pour la maison avec le sang de l'oiseau et avec l'eau vive, avec l'oiseau vivant, le bois de cèdre, l'hysope et le cramoisi."
,"53":"Il lâchera alors l'oiseau vivant en dehors de la ville, en pleine campagne, et c'est ainsi qu'il fera le rite de réparation pour la maison: alors elle sera pure."
,"54":"Voilà la loi concernant la tache de lèpre,"
,"55":"la lèpre du vêtement ou de la maison,"
,"56":"qu'il s'agisse de la tumeur, des plaques ou des taches;"
,"57":"ainsi on saura le jour où l'on est impur et le jour où l'on est pur. C'est la loi sur la lèpre.'"
}`)
	CurrentBook.AddChapter(15, `{
"1":"Yahvé parla à Moïse et à Aaron, il leur dit:"
,"2":"'Voici ce que vous direz aux Israélites: Celui qui a eu dans son corps un écoulement est impur."
,"3":"Et voici la loi de l'impureté due à l'écoulement: qu'il soit sorti de son corps ou qu'il l'ait retenu, c'est une impureté."
,"4":"Le lit où s'est couché celui qui a eu cet écoulement est impur, et l'endroit où il s'est assis est impur."
,"5":"Celui qui touchera le lit lavera ses vêtements; il se baignera dans l'eau et sera impur jusqu'au soir."
,"6":"Celui qui s'assied à l'endroit où s'est assis celui qui a eu cet écoulement, lavera ses vêtements et se baignera dans l'eau: il sera impur jusqu'au soir."
,"7":"Si quelqu'un touche celui qui a eu cet écoulement, il devra laver ses vêtements et se baigner: il sera impur jusqu'au soir."
,"8":"Si celui qui a eu cet écoulement crache sur quelqu'un qui est pur, ce dernier lavera ses vêtements et se baignera dans l'eau: il sera impur jusqu'au soir."
,"9":"Toute selle sur laquelle sera monté celui qui a eu cet écoulement sera impure."
,"10":"Si quelqu'un touche aux affaires de celui qui a eu cet écoulement, il sera impur jusqu'au soir; s'il les porte, il devra laver ses habits et se baigner dans l'eau: il sera impur jusqu'au soir."
,"11":"Si quelqu'un a été touché par celui qui a eu cet écoulement, et n'a pas lavé ses mains dans l'eau, il devra laver ses vêtements et se baigner dans l'eau: il sera impur jusqu'au soir."
,"12":"Le vase d'argile auquel aura touché celui qui a eu cet écoulement sera brisé; si le vase est en bois, on le lavera à l'eau."
,"13":"Lorsque celui qui a eu cet écoulement sera purifié, il calculera sept jours pour sa purification. Alors il lavera ses vêtements, il baignera son corps dans l'eau vive et il sera pur."
,"14":"Le huitième jour il se procurera deux tourterelles ou deux petits pigeons. Il les apportera devant Yahvé à l'entrée de la Tente du Rendez-Vous et les donnera au prêtre."
,"15":"Le prêtre les offrira en sacrifice, l'un pour la réparation et l'autre pour l'holocauste. Alors le prêtre fera l'expiation devant Yahvé pour lui, pour son écoulement."
,"16":"L'homme qui aura un écoulement de sperme se baignera tout entier dans l'eau et sera impur jusqu'au soir."
,"17":"L'habit ou le vêtement de cuir sur lequel il y aura un écoulement de sperme sera lavé dans l'eau et sera impur jusqu'au soir."
,"18":"Si une femme couche avec un homme et qu'elle a une relation avec lui, ils se baigneront dans l'eau et seront impurs jusqu'au soir."
,"19":"Quand une femme aura ses règles, elle sera impure pendant sept jours, car c'est un flux de sang dans son corps. Quiconque la touchera sera impur jusqu'au soir."
,"20":"Tout endroit où elle se sera couchée durant son impureté sera impur, et tout endroit où elle se sera assise sera impur."
,"21":"Quiconque touchera l'endroit où elle s'est couchée, lavera ses vêtements et se baignera dans l'eau: il sera impur jusqu'au soir."
,"22":"Quiconque touchera l'endroit où elle s'est assise, lavera ses vêtements et se baignera dans l'eau: il sera impur jusqu'au soir."
,"23":"Celui qui touchera un objet qui était sur l'endroit où elle s'est couchée, ou à l'endroit où elle s'est assise, sera impur jusqu'au soir."
,"24":"Si un homme couche alors avec elle, il partagera son impureté: il sera impur durant sept jours et tout endroit où il se couchera sera impur."
,"25":"Si les règles d'une femme ont lieu en dehors de la période habituelle, ou si elles se prolongent au-delà de la durée normale, cette femme sera impure durant tous ces jours comme elle l'est chaque mois au moment de ses règles."
,"26":"Elle regardera tout endroit ou elle s'est couchée durant ces jours, comme l'endroit où elle se couche durant ses règles de chaque mois. Tout endroit où elle était alors assise sera impur comme si c'était son impureté de chaque mois."
,"27":"Quiconque y touchera sera impur, il lavera ses vêtements et se baignera dans l'eau: il sera impur jusqu'au soir."
,"28":"Lorsque ses règles s'arrêteront, elle comptera sept jours, après quoi elle sera pure."
,"29":"Le huitième jour elle prendra deux tourterelles ou deux jeunes pigeons qu'elle apportera au prêtre à l'entrée de la Tente du Rendez-Vous."
,"30":"Le prêtre les offrira, l'un pour le sacrifice pour le péché, l'autre pour l'holocauste. Le prêtre fera l'expiation devant Yahvé pour elle, pour le flux de sang qui la rendait impure."
,"31":"Vous avertirez donc les Israélites au sujet de toutes ces impuretés. Il ne faudrait pas qu'ils meurent pour avoir souillé ma Demeure qui est chez eux."
,"32":"Voilà donc les lois concernant l'homme qui a un écoulement purulent, l'homme souillé par un épanchement de sperme,"
,"33":"la femme qui a ses règles mensuelles, toute personne, homme ou femme, qui souffre d'un épanchement quelconque, l'homme qui couche avec une femme impure.'"
}`)
	CurrentBook.AddChapter(16, `{
"1":"Yahvé parla à Moïse après que moururent les deux fils d'Aaron, morts en s'approchant de Yahvé."
,"2":"Yahvé dit à Moïse: 'Que ton frère Aaron n'entre pas n'importe quand dans le Saint, derrière le rideau, devant l'Instrument de l'Expiation qui est sur l'Arche, s'il ne veut pas mourir; car c'est là, sur l'Instrument de l'Expiation, que je me manifeste dans la nuée."
,"3":"Voici comment Aaron entrera dans le Saint: il faudra qu'il se procure un jeune taureau pour l'expiation et un bélier pour l'holocauste."
,"4":"Il portera la sainte tunique de lin, il aura sur le corps des caleçons de lin, il portera une ceinture de lin et sera coiffé d'un turban de lin. Après s'être lavé tout entier dans l'eau, il revêtira ses habits sacrés."
,"5":"La communauté des Israélites lui donnera deux boucs pour le péché et un bélier pour l'holocauste."
,"6":"Aaron offrira le jeune taureau qu'il a apporté pour le péché et fera la demande de pardon pour lui et pour sa maison."
,"7":"Il prendra ensuite les deux boucs et les présentera devant Yahvé à l'entrée de la Tente du Rendez-Vous."
,"8":"Aaron tirera au sort entre les deux boucs: un pour Yahvé et un autre pour Azazel."
,"9":"Il fera approcher le bouc désigné par le sort pour Yahvé, et il l'offrira en sacrifice pour le péché."
,"10":"Le bouc désigné par le sort pour Azazel sera alors conduit vivant devant Yahvé. On fera sur lui le rite de l'expiation et on le chassera vers le désert, vers Azazel."
,"11":"Aaron offrira ensuite le taureau qu'il a amené pour le sacrifice du péché, pour lui et pour sa famille. Après avoir égorgé son taureau,"
,"12":"il prendra sur l'autel, devant Yahvé, un encensoir plein de charbons brûlants et deux poignées d'encens parfumé en poudre. Il portera le tout derrière le rideau."
,"13":"Il mettra l'encens parfumé sur le feu devant Yahvé de façon à couvrir d'un nuage d'encens l'Instrument de l'Expiation qui est sur le Témoignage. Ainsi il ne mourra pas."
,"14":"Il prendra alors du sang du jeune taureau, il aspergera avec son doigt la face de l'Instrument de l'Expiation tournée vers le levant. Et il fera sept fois l'aspersion de sang avec son doigt devant l'Instrument de l'Expiation."
,"15":"Il égorgera alors le bouc réservé pour l'expiation en faveur du peuple. Il en portera le sang derrière le rideau et il en fera ce qu'il a fait avec le sang du jeune taureau: il aspergera l'Instrument de l'Expiation et le devant de l'Instrument de l'Expiation."
,"16":"Et il fera le rite d'expiation dans le Saint pour les impuretés des Israélites: pour leurs fautes et pour tous leurs péchés. C'est ainsi qu'il fera pour la Tente du Rendez-Vous qui est avec eux au milieu de leurs impuretés."
,"17":"Il n'y aura personne dans la Tente du Rendez-Vous depuis le moment où il entrera dans le Saint pour faire le rite de l'expiation, jusqu'au moment où il en sortira. Il fera le rite de l'expiation pour lui, pour sa famille et pour toute la communauté des Israélites."
,"18":"Il sortira vers l'autel qui est devant Yahvé et fera le rite de l'expiation sur l'autel. Il prendra du sang du jeune taureau et du sang du bouc et il en mettra sur les cornes de l'autel et tout autour."
,"19":"Avec son doigt il fera sept fois l'aspersion du sang sur l'autel; ainsi il le purifiera et le sanctifiera de toutes les impuretés des Israélites."
,"20":"Lorsque Aaron aura achevé le rite de l'expiation du Saint, de la Tente du Rendez-Vous et de l'autel, il fera approcher le bouc encore vivant."
,"21":"Tenant ses deux mains posées sur la tête du bouc encore vivant, il confessera sur lui toutes les fautes des Israélites, tous leurs manquements et tous leurs péchés. Après les avoir ainsi chargés sur la tête du bouc, il le remettra à un auxiliaire pour que le bouc aille au désert,"
,"22":"et emporte sur lui toutes les fautes vers des lieux désertiques. Après avoir chassé le bouc vers le désert, "
,"23":"Aaron rentrera dans la Tente du Rendez-Vous. Il enlèvera alors les habits de lin dont il était habillé en entrant dans le Saint et il les y déposera."
,"24":"Il se baignera tout entier dans l'eau, dans un lieu saint, puis il reprendra ses habits et sortira pour offrir son holocauste et l'holocauste pour le peuple. Après quoi il fera le rite d'expiation pour lui et pour le peuple,"
,"25":"et il fera fumer sur l'autel la graisse de la victime pour le péché."
,"26":"L'homme qui aura chassé le bouc vers Azazel lavera ses habits. Il se baignera tout entier dans l'eau et rentrera ensuite dans le camp."
,"27":"On portera hors du camp le jeune taureau et le bouc que l'on aura égorgés pour l'expiation et dont le sang aura servi pour le rite de l'expiation dans le Saint. On brûlera dans le feu leur peau, leur chair et leurs excréments."
,"28":"Celui qui les aura brûlés lavera ses habits, il se baignera tout entier dans l'eau et rentrera ensuite dans le camp."
,"29":"Ceci sera pour vous un rite perpétuel: le dix du septième mois vous vous humilierez et vous ne ferez aucun travail, ni vous ni l'étranger qui habite au milieu de vous."
,"30":"Ce jour-là on fera sur vous le rite de l'expiation pour vous purifier et vous serez purifiés de tous vos péchés devant Yahvé."
,"31":"Ce sera pour vous un jour de repos, comme un sabbat, où vous vous humilierez: ce sera un rite perpétuel."
,"32":"L'expiation sera faite par le prêtre qui aura reçu l'onction et qui aura été consacré comme prêtre à la place de son père. Il devra revêtir les vêtements de lin, les vêtements sacrés."
,"33":"Il fera le rite de l'expiation pour le Sanctuaire de Sainteté, pour la Tente du Rendez-Vous et pour l'autel, pour les prêtres et pour toute la communauté du peuple."
,"34":"Ce sera pour vous un rite perpétuel. Vous ferez ainsi, une fois par an, le rite de l'expiation pour tous les péchés des Israélites.',On fit donc comme Yahvé l'avait ordonné à Moïse."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Yahvé dit à Moïse:"
,"2":"'Voici ce que tu diras à Aaron, à ses fils et à tous les Israélites. Ecoutez ce que Yahvé a ordonné:"
,"3":"Tout homme du peuple d'Israël qui égorge un boeuf, une brebis ou une chèvre, soit dans le camp, soit en dehors du camp,"
,"4":"sans le conduire à l'entrée de la Tente du Rendez-Vous pour l'offrir à Yahvé devant la demeure de Yahvé, sera coupable de ce sang. Cet homme sera retranché du milieu de son peuple car il a répandu le sang."
,"5":"Les Israélites n'offriront pas de sacrifices dans la campagne mais ils les amèneront à Yahvé à l'entrée de la Tente du Rendez-Vous, au prêtre. Et c'est là qu'ils les offriront en sacrifice de communion à Yahvé."
,"6":"Le prêtre versera le sang sur l'autel de Yahvé, devant la Tente du Rendez-Vous, et il fera fumer la graisse en odeur agréable à Yahvé."
,"7":"Ainsi ils n'offriront plus de sacrifices aux idoles à tête de bouc avec lesquelles ils se prostituaient. Ceci est un ordre pour eux de génération en génération."
,"8":"Tu leur diras encore: tout homme du peuple d'Israël, comme tout étranger habitant au milieu de vous qui offrira un holocauste ou un sacrifice"
,"9":"sans le conduire à l'entrée de la Tente du Rendez-Vous pour le présenter à Yahvé, sera retranché de sa famille."
,"10":"Pour ce qui est de manger du sang, il n'y aura pas de différence entre les gens du peuple d'Israël et les étrangers habitant au milieu de vous: je retrancherai du milieu de son peuple celui qui aura mangé le sang."
,"11":"Car l'âme de tout être vivant est dans le sang et moi je vous l'ai donné pour que vous le portiez sur l'autel pour le rite de l'expiation; c'est le sang qui paye la dette de l'âme, de la personne."
,"12":"C'est pour cela que j'ai dit aux Israélites: personne parmi vous ne mangera de sang et aucun étranger habitant au milieu de vous ne mangera de sang."
,"13":"Tout homme du peuple d'Israël, comme tout étranger habitant au milieu de vous, qui aura chassé du gibier, bête ou oiseau qui se mangent, devra en verser le sang et le recouvrir de terre."
,"14":"En effet, l'âme de tout être vivant est son sang, c'est pourquoi j'ai dit aux Israélites: vous ne mangerez du sang d'aucun être vivant, car l'âme de tout être vivant est son sang. Ceux qui en mangeront seront retranchés."
,"15":"Si quelqu'un né dans le pays, si un étranger vivant au milieu de vous, a mangé d'une bête morte ou d'une bête déchirée, il lavera ses vêtements et se baignera dans l'eau; il sera impur jusqu'au soir, et alors il sera pur."
,"16":"Mais s'il ne lave pas ses vêtements et ne se baigne pas dans l'eau, il portera sa faute.'"
}`)
	CurrentBook.AddChapter(18, `{
"1":"Yahvé dit à Moïse:"
,"2":"'Voici ce que tu diras aux Israélites: Je suis Yahvé votre Dieu!"
,"3":"Vous ne ferez pas ce qui se fait en Egypte, où vous avez habité, ou ce qui se fait au pays de Canaan où je vous ai fait entrer. Vous ne le ferez pas, vous ne suivrez pas leurs coutumes."
,"4":"C'est à mes commandements que vous obéirez, ce sont mes coutumes que vous suivrez et mettrez en pratique: je suis Yahvé votre Dieu!"
,"5":"Vous observerez mes coutumes et mes commandements, car celui qui les met en pratique vit grâce à eux: je suis Yahvé!"
,"6":"Aucun homme parmi vous ne s'approchera d'une femme qui est de sa proche parenté, pour avoir des rapports avec elle: je suis Yahvé!"
,"7":"Tu n'auras de rapports ni avec ton père ou avec ta mère: c'est ta mère, tu n'auras donc pas de rapports avec elle."
,"8":"Tu n'auras pas de rapports avec la femme de ton père, car elle est la chair de ton père."
,"9":"Tu n'auras pas de rapports avec la fille de ta soeur, ou la fille de ton père ou la fille de ta mère, qu'elle soit née dans ta maison ou au dehors."
,"10":"Tu n'auras pas de rapports avec la fille de ton fils ou de ta fille, car elles sont ta propre chair."
,"11":"Tu n'auras pas de rapports avec une fille de la femme de ton père, si elle est née de ton père: elle est ta soeur et tu n'auras pas de rapports avec elle."
,"12":"Tu n'auras pas de rapports avec la soeur de ton père, car elle est la chair de ton père."
,"13":"Tu n'auras pas de rapports avec la soeur de ta mère, car elle est la chair de ta mère."
,"14":"Respecte le frère de ton père! Tu n'auras pas de rapports avec sa femme, car elle est ta tante."
,"15":"Tu n'auras pas de rapports avec ta bru, car elle est la femme de ton fils: tu n'auras pas de rapports avec elle."
,"16":"Tu n'auras pas de rapports avec la femme de ton frère, car elle est la chair de ton frère."
,"17":"Tu n'auras pas de rapports avec une femme et sa fille; tu n'auras pas de rapports avec la fille de son fils, ou la fille de sa fille, car elles sont sa propre chair; ce serait un crime."
,"18":"Tu ne prendras pas une femme en même temps que sa soeur pour avoir des rapports avec elle alors que l'autre est encore en vie."
,"19":"Tu n'auras pas de relations avec une femme pendant la période de ses règles."
,"20":"Tu n'auras pas de rapports avec la femme de ton prochain, tu en resterais souillé."
,"21":"Tu n'iras pas sacrifier un de tes enfants à Molok, car ce serait profaner le Nom de ton Dieu: je suis Yahvé!"
,"22":"Tu ne coucheras pas avec un homme comme on couche avec une femme: c'est un acte abominable!"
,"23":"Tu ne coucheras pas avec une bête: tu en resterais souillé. La femme ne s'unira pas à une bête pour se prostituer avec elle: c'est une honte!"
,"24":"Ne vous rendez impurs par aucune de ces pratiques, car c'est ainsi que se sont souillées les nations que je vais chasser devant vous."
,"25":"Le pays en a été souillé, c'est pourquoi je vais intervenir et le pays vomira ses habitants."
,"26":"Vous observerez mes lois et mes commandements, et vous ne commettrez aucune de ces choses honteuses, ni vous, ni l'étranger qui habite au milieu de vous."
,"27":"Ceux qui habitaient ce pays avant vous s'étaient habitués à ces pratiques honteuses, et le pays en a été souillé."
,"28":"Ne souillez pas ce pays à votre tour, car il vous vomirait comme il a vomi les nations qui étaient avant vous."
,"29":"Ceux qui se livreront à l'une de ces actions honteuses devront être retranchés du milieu de leur peuple."
,"30":"Vous observerez mes commandements et vous ne suivrez aucune des pratiques honteuses qui se faisaient avant vous; vous ne vous souillerez pas de cette façon, car je suis Yahvé votre Dieu."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Yahvé dit à Moïse:"
,"2":"'Voici ce que tu diras à la communauté d'Israël: Soyez saints, car moi, Yahvé votre Dieu, je suis saint!"
,"3":"Chacun respectera sa mère et son père, et vous observerez mes sabbats: je suis Yahvé votre Dieu!"
,"4":"Vous ne vous tournerez pas vers les idoles, vous ne vous fabriquerez pas des dieux en métal fondu: je suis Yahvé votre Dieu!"
,"5":"Lorsque vous offrirez un sacrifice de communion en l'honneur de Yahvé, vous le ferez de manière à lui être agréable."
,"6":"Vous mangerez de votre sacrifice le jour même et le lendemain, mais ce qui restera le troisième jour sera brûlé."
,"7":"Si quelqu'un en mange le troisième jour, c'est un acte abominable: son sacrifice ne sera pas agréé."
,"8":"Celui qui en mangera répondra de sa faute, car il a profané ce qui est consacré à Yahvé: cet homme sera retranché de son peuple.'"
,"9":"Quand viendra le temps de moissonner vos terres, tu ne moissonneras pas jusqu'à la limite de ton champ et tu ne ramasseras pas ce qui peut être glané de ta moisson."
,"10":"Tu ne cueilleras pas non plus les grappes restées sur ta vigne et tu ne ramasseras pas les fruits tombés dans ton verger. Tu les laisseras pour le pauvre et l'étranger: je suis Yahvé ton Dieu!"
,"11":"Vous ne volerez pas, vous ne tromperez pas votre prochain, vous ne mentirez pas."
,"12":"Vous ne jurerez pas par mon Nom pour appuyer un mensonge: ce serait profaner le Nom de ton Dieu: je suis Yahvé!"
,"13":"Tu n'opprimeras pas ton prochain, tu ne le dépouilleras pas; le salaire de celui qui travaille pour toi ne restera pas chez toi jusqu'au lendemain."
,"14":"Tu ne prononceras pas de malédiction contre un sourd, tu ne mettras pas d'obstacle devant un aveugle pour le faire tomber; mais tu auras la crainte de ton Dieu: je suis Yahvé!"
,"15":"Vous ne commettrez pas d'injustice dans les jugements. Tu ne feras pas de faveur au pauvre, tu ne feras pas d'honneur au puissant, mais tu jugeras ton prochain avec justice."
,"16":"Tu ne calomnieras pas tes parents, tu n'exigeras pas le sang de ton prochain: je suis Yahvé!"
,"17":"Tu n'auras pas de haine dans ton coeur pour ton frère, mais tu le corrigeras, car en te taisant tu serais complice de son péché."
,"18":"Tu ne te vengeras pas, tu ne garderas pas de rancune envers un fils de ton peuple, mais tu aimeras ton prochain comme toi-même: je suis Yahvé!"
,"19":"Vous observerez mes coutumes: tu n'accoupleras pas deux bêtes d'espèces différentes; tu ne sèmeras pas dans ton champ deux graines d'espèces différentes; tu ne porteras pas de vêtement tissé de deux espèces de fil différentes."
,"20":"Si un homme a des rapports avec une esclave déjà fiancée à un autre homme, mais qui n'a été ni rachetée ni affranchie, ils seront châtiés tous les deux mais non punis de mort, car la femme n'était pas affranchie."
,"21":"Pour sa faute, l'homme amènera à Yahvé, devant la Tente du Rendez-Vous, un bélier pour le sacrifice d'expiation."
,"22":"Le prêtre offrira le bélier et fera pour lui l'expiation devant Yahvé pour le péché qu'il a commis, et son péché lui sera pardonné."
,"23":"Quand vous serez entrés dans le pays et que vous aurez planté toutes sortes d'arbres fruitiers, vous regarderez les fruits comme incirconcis: les trois premières années vous n'en mangerez point."
,"24":"La quatrième année, tous les fruits seront consacrés à Yahvé."
,"25":"A partir de la cinquième année vous mangerez les fruits de l'arbre car ils seront désormais pour vous: je suis Yahvé votre Dieu!"
,"26":"Vous ne mangerez rien avec le sang, vous ne pratiquerez ni sorcellerie, ni magie."
,"27":"Vous ne tondrez pas en rond les cheveux de votre tête et vous ne couperez pas les coins de votre barbe."
,"28":"Vous ne vous ferez pas d'incision sur le corps pour un mort et vous ne vous ferez pas d'inscription ou de tatouage sur le corps: je suis Yahvé!"
,"29":"Ne livre pas ta fille à la prostitution, sinon vous aurez un pays de prostituées, un réservoir de crimes."
,"30":"Vous observerez mes sabbats et vous aurez du respect pour ma Demeure: je suis Yahvé!"
,"31":"Ne vous tournez pas vers ceux qui évoquent les esprits, vers les sorciers. Ne les consultez pas, ne vous souillez pas avec eux: je suis Yahvé votre Dieu!"
,"32":"Tu te lèveras devant une personne âgée et tu honoreras le vieillard, ce sera ta façon de craindre ton Dieu: je suis Yahvé!"
,"33":"Si un étranger vient habiter dans votre pays, vous ne l'opprimerez pas."
,"34":"Vous traiterez l'étranger qui est au milieu de vous comme un homme du pays. Tu l'aimeras comme toi-même, car vous aussi vous avez été étrangers dans le pays d'Egypte: je suis Yahvé votre Dieu!"
,"35":"Vous ne commettrez pas d'injustice, ni dans vos sentences, ni dans les mesures, ni dans les poids, ni dans les contenances."
,"36":"Vos balances seront justes, vos poids seront justes, toutes vos mesures seront justes. Je suis Yahvé votre Dieu, qui vous ai fait sortir du pays d'Egypte."
,"37":"Vous observerez donc toutes mes coutumes et tous mes commandements, et vous les mettrez en pratique: je suis Yahvé!"
}`)
	CurrentBook.AddChapter(20, `{
"1":"Yahvé dit à Moïse:"
,"2":"'Voici ce que tu diras aux Israélites: si un Israélite, ou l'un des étrangers qui habitent en Israël, livre à Molok l'un de ses enfants, il sera puni de mort. Le peuple du pays le lapidera."
,"3":"Je m'en prendrai à cet homme et je le retrancherai du milieu de son peuple, car, en livrant à Molok l'un de ses enfants, il a souillé mon sanctuaire et profané mon saint Nom."
,"4":"Si le peuple du pays ferme les yeux lorsque cet homme donne ses enfants à Molok et mérite ainsi la mort,"
,"5":"je m'en prendrai, moi, à cet homme et à sa famille. Je le retrancherai du milieu de son peuple avec tous ceux qui comme lui se vendent à Molok."
,"6":"Si quelqu'un s'adresse à ceux qui évoquent les esprits et aux sorciers pour se prostituer avec eux, je m'en prendrai à cet homme et je le retrancherai du milieu de son peuple."
,"7":"Vous vous sanctifierez, vous serez saints, car je suis Yahvé votre Dieu."
,"8":"Vous observerez mes lois et vous les mettrez en pratique. Je suis Yahvé! C'est moi qui vous rends saints!"
,"9":"Celui qui maudira son père ou sa mère sera puni de mort: il a maudit son père ou sa mère, il a voulu sa propre mort."
,"10":"Si un homme commet l'adultère avec une femme mariée, s'il commet l'adultère avec la femme de son prochain: tous deux seront punis de mort, l'homme, et la femme adultère."
,"11":"Si un homme couche avec la femme de son père, ils seront tous deux punis de mort: ils ont voulu leur propre mort."
,"12":"Si un homme couche avec sa belle-fille: ils seront tous deux punis de mort, ils ont fait un acte honteux, ils ont voulu leur propre mort."
,"13":"Si un homme couche avec un autre homme comme on couche avec une femme, c'est un acte abominable; ils seront punis de mort et ils seront responsables de leur mort."
,"14":"Si un homme prend pour femmes, et la fille et la mère, c'est un crime! On les livrera au feu, lui et elles, pour que l'on ne voie plus jamais cela chez vous."
,"15":"L'homme qui aura eu des rapports avec une bête sera puni de mort, et vous tuerez aussi la bête."
,"16":"Si une femme s'approche d'une bête pour avoir des rapports avec elle, tu feras périr la femme et la bête. Elles seront mises à mort et elles seront responsables de leur mort."
,"17":"Si un homme prend sa soeur, qu'elle soit la fille de son père ou la fille de sa mère, et ils ont des rapports sexuels, c'est un crime! Il sera retranché sous les yeux des enfants de son peuple. Il a découvert la nudité de sa soeur, il portera le poids de son péché."
,"18":"Si un homme couche avec une femme durant la période de ses règles et découvre sa nudité, il a profané son propre écoulement et le flux de sang de la femme. Ils seront tous deux retranchés du milieu de leur peuple."
,"19":"Tu ne découvriras pas la nudité de la soeur de ta mère, ou de la soeur de ton père, car ils sont ta propre chair. Les coupables porteront le poids de leur péché."
,"20":"Si un homme couche avec sa tante, il profane la chair de son oncle. Ils porteront le poids de leur péché et mourront sans enfants."
,"21":"Si un homme prend la femme de son frère, c'est une faute. Comme il a profané la chair de son frère, ils seront sans enfants."
,"22":"Vous observerez toutes mes lois et tous mes commandements, et vous les mettrez en pratique. Ainsi le pays dans lequel je vous ai conduits pour y habiter ne vous rejettera pas."
,"23":"Vous ne suivrez pas les pratiques des nations que je vais chasser devant vous, car c'est à cause de ces pratiques que je les ai en horreur."
,"24":"Je vous l'ai dit: Vous posséderez leur pays, je vous donnerai cette terre où coulent le lait et le miel pour qu'elle soit vôtre: je suis Yahvé votre Dieu qui vous ai mis à part des autres peuples!"
,"25":"Vous ferez la différence entre les animaux purs et impurs; entre les oiseaux purs et impurs. Je vous ai appris à reconnaître les animaux, les oiseaux et tous les êtres vivants impurs; ainsi vous ne vous rendrez pas impurs à cause d'eux."
,"26":"Vous serez saints pour moi, car je suis saint, moi Yahvé qui vous ai mis à part des autres peuples pour que vous soyez à moi."
,"27":"Tout homme et toute femme qui évoquent les esprits ou se livrent à la sorcellerie seront mis à mort. On les lapidera, ils seront responsables de leur mort.'"
}`)
	CurrentBook.AddChapter(21, `{
"1":"Yahvé dit à Moïse: 'Tu parleras aux prêtres, aux fils d'Aaron, et tu leur diras: Aucun de vous ne se rendra impur pour un mort de son entourage."
,"2":"Seulement s'il s'agit d'un parent tout proche, de sa mère ou de son père, de son fils ou de sa fille, de son frère,"
,"3":"d'une soeur encore vierge qui vit auprès de lui sans être mariée, le prêtre pourra se rendre impur."
,"4":"Il est seigneur au milieu de son peuple, il ne se souillera donc pas et ne profanera pas sa dignité."
,"5":"Les prêtres ne se raseront pas la tête; ils ne tailleront pas les côtés de leur barbe; ils ne se feront pas d'incision dans la chair."
,"6":"Ils devront être saints pour leur Dieu et ne pas profaner son Nom. Ce sont eux qui présentent les sacrifices en l'honneur de Yahvé, les holocaustes, le pain de leur Dieu, c'est pourquoi ils seront saints."
,"7":"Ils ne prendront pas comme femme une prostituée ou une femme de mauvaise réputation. Le prêtre ne prendra pas une femme répudiée par son mari, car il a été consacré à son Dieu."
,"8":"Tu le regarderas comme saint, car il offre le pain de ton Dieu. Il sera saint à tes yeux, car je suis saint, moi Yahvé qui vous sanctifie."
,"9":"Si la fille d'un prêtre se profane elle-même en se prostituant, elle déshonore son père: elle sera brûlée vive."
,"10":"Quand le grand prêtre a été élevé au-dessus de ses frères, qu'on a versé sur sa tête l'huile de consécration et qu'il a été choisi pour revêtir les vêtements sacrés, il ne doit plus dénouer sa chevelure et déchirer ses vêtements."
,"11":"Il ne se rendra pas impur en s'approchant d'un mort, même s'il s'agit de son père ou de sa mère."
,"12":"Il ne peut pas sortir du lieu saint sans profaner l'ordre du lieu saint de son Dieu, car l'huile qui l'a consacré à son Dieu est comme un diadème sur sa tête: je suis Yahvé."
,"13":"Il prendra pour femme une vierge."
,"14":"Il ne prendra ni une veuve, ni une femme répudiée, ni une femme de mauvaise réputation, ni une prostituée, mais seulement une vierge de son peuple."
,"15":"Il ne déshonorera pas sa famille au milieu de son peuple, car je suis Yahvé, c'est moi qui le sanctifie.'"
,"16":"Yahvé parla à Moïse et lui dit:"
,"17":"'Voici ce que tu diras à Aaron: aucun de tes descendants, maintenant comme dans l'avenir, n'approchera pour offrir le pain de ton Dieu, s'il a une infirmité corporelle."
,"18":"Voici ceux qui ont une difformité corporelle: l'aveugle, le boiteux, celui qui a été mutilé ou qui a une excroissance de chair,"
,"19":"l'homme qui a eu le pied ou la main fracturé,"
,"20":"le bossu et le nain, celui qui a une tache à l'oeil, celui qui a la gale, une plaque ou les testicules écrasés. Aucun de ceux-là n'approchera."
,"21":"Aucun descendant d'Aaron ayant une infirmité corporelle ne s'approchera pour offrir à Yahvé les holocaustes. Celui qui a une infirmité ne peut pas offrir le pain de son Dieu. "
,"22":"Il pourra manger le pain de son Dieu, manger des choses saintes,"
,"23":"mais il n'ira pas vers le rideau de la Demeure; il ne s'approchera pas de l'autel, à cause de son infirmité corporelle. Ce serait profaner mon sanctuaire, et moi je suis Yahvé qui les sanctifie.'"
,"24":"C'est ainsi que Moïse parla à Aaron et à ses fils, ainsi qu'à tous les Israélites."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Yahvé dit à Moïse:"
,"2":"' Voici ce que tu diras à Aaron et à ses fils: Faites attention pour les offrandes que me présentent les Israélites, n'allez pas profaner mon saint Nom: je suis Yahvé. Tu leur diras encore:"
,"3":"Si l'un de vos descendants, maintenant comme dans l'avenir, s'approche des offrandes que les Israélites consacrent à Yahvé alors qu'il est impur pour une raison ou une autre, il sera retranché de devant moi: je suis Yahvé!"
,"4":"Tout descendant d'Aaron qui aura la lèpre ou un écoulement purulent, ne pourra manger des offrandes saintes jusqu'à ce qu'il soit pur. Il en sera de même pour celui qui aura touché une personne impure, ou qui aura touché un cadavre, ou aura eu un écoulement de sperme,"
,"5":"ou aura touché un reptile ou un homme impur qui lui a transmis son impureté."
,"6":"Celui qui aura eu l'un de ces contacts sera impur jusqu'au soir. Il ne mangera pas des offrandes saintes, mais il se baignera tout entier dans l'eau."
,"7":"Et, après le coucher du soleil, il sera pur. Alors il pourra manger des offrandes saintes, car c'est sa part de nourriture."
,"8":"Il ne mangera pas d'une bête morte ou déchirée pour ne pas en être souillé: je suis Yahvé."
,"9":"Ils observeront mes commandements; ainsi ils ne se chargeront pas d'un péché et ne risqueront pas la mort pour avoir profané les offrandes saintes: je suis Yahvé qui les sanctifie!"
,"10":"Aucun étranger ne mangera des offrandes saintes; ni celui qui demeure chez un prêtre, ni l'un de ses salariés ne pourra manger des offrandes saintes."
,"11":"Mais l'esclave qui aura été acheté par le prêtre pourra en manger. Il en sera de même de celui qui est né dans sa maison. Ceux-là mangeront de cette nourriture."
,"12":"La fille d'un prêtre, mariée avec un étranger, ne pourra manger ce qui a été prélevé sur les offrandes saintes."
,"13":"Si la fille d'un prêtre est veuve ou répudiée sans enfants, et qu'elle retourne dans la maison de son père comme elle y était dans sa jeunesse, elle pourra de nouveau manger de la nourriture de son père. Mais aucun étranger n'en mangera."
,"14":"Si un homme mange par erreur une offrande sainte, il rendra au prêtre la valeur de cette offrande et y ajoutera un cinquième."
,"15":"Les prêtres ne profaneront pas les saintes offrandes des Israélites, la part qui a été prélevée en l'honneur de Yahvé."
,"16":"Les prêtres leur feraient encourir une faute s'ils les laissaient manger les offrandes saintes: je suis Yahvé qui les sanctifie.'"
,"17":"Yahvé dit à Moïse:"
,"18":"'Voici ce que tu diras à Aaron et à ses fils, ainsi qu'à tous les Israélites: Lorsqu'un homme de la maison d'Israël, ou un étranger habitant en Israël, présente son holocauste pour l'accomplissement d'un voeu ou comme don volontaire à Yahvé,"
,"19":"son sacrifice n'est agréable que si la victime est un mâle sans défaut, qu'il s'agisse de boeufs, de moutons ou de chèvres."
,"20":"Vous n'offrirez aucune bête ayant un défaut: elle ne serait pas agréable à Yahvé."
,"21":"Quand on offre à Yahvé du gros ou du petit bétail, que ce soit un sacrifice de communion, ou pour s'acquitter d'un voeu ou comme offrande volontaire, seule une victime sans défaut est agréable à Yahvé; elle ne doit avoir aucun défaut."
,"22":"Vous n'offrirez pas à Yahvé, vous ne ferez pas d'holocauste sur l'autel de Yahvé avec un animal aveugle, estropié ou mutilé; avec un animal qui a un ulcère, la gale ou une plaie."
,"23":"Tu pourras immoler comme offrande volontaire un boeuf ou une brebis ayant un membre trop long ou trop court, mais pour l'accomplissement d'un voeu, ils ne seraient pas agréables à Yahvé."
,"24":"Vous n'offrirez pas à Yahvé un animal qui ait les testicules écrasés, arrachés ou coupés. Vous ne ferez pas cela dans votre pays,"
,"25":"et vous n'accepterez même aucun de ces animaux de la main d'un étranger pour les présenter en offrande à votre Dieu. Car cette mutilation est une tare, et ils ne vous obtiendront aucune faveur.'"
,"26":"Yahvé dit encore à Moïse:"
,"27":"'Le veau, l'agneau ou le chevreau resteront sept jours sous leur mère après leur naissance. Mais dès le huitième jour Yahvé les acceptera pour le sacrifice par le feu."
,"28":"Vous n'immolerez pas une bête de gros ou de petit bétail, ainsi que son petit le même jour."
,"29":"Lorsque vous offrirez à Yahvé un sacrifice d'action de grâces, vous l'offrirez de manière qu'il soit agréé."
,"30":"La victime sera mangée le jour même, vous n'en laisserez rien jusqu'au lendemain matin. Je suis Yahvé."
,"31":"Vous observerez mes commandements et vous les mettrez en pratique. Je suis Yahvé."
,"32":"Vous ne profanerez pas mon saint Nom et ainsi je serai sanctifié au milieu des Israélites. Je suis Yahvé qui vous sanctifie,"
,"33":"et je vous ai fait sortir d'Egypte pour être votre Dieu. Je suis Yahvé.'"
}`)
	CurrentBook.AddChapter(23, `{
"1":"Yahvé dit à Moïse:"
,"2":"'Voici ce que tu diras aux Israélites: on convoquera une assemblée sainte pour les fêtes de Yahvé. Voici ces fêtes:"
,"3":"Il y a six jours pour travailler, mais le septième jour est le sabbat, le repos complet. Il y aura une sainte assemblée. Vous ne ferez aucun travail, ce repos sera consacré à Yahvé dans tous les endroits où vous habiterez."
,"4":"Voici les fêtes de Yahvé, les saintes assemblées que vous convoquerez en leur temps:"
,"5":"Le quatorzième jour du premier mois, au coucher du soleil, c'est la Pâque de Yahvé."
,"6":"Le quinzième jour de ce même mois, c'est la fête des pains sans levain en l'honneur de Yahvé: pendant sept jours vous mangerez des pains sans levain."
,"7":"Au premier de ces jours il y aura une assemblée sainte. Vous ne ferez aucun travail de travailleur."
,"8":"Pendant sept jours vous offrirez en l'honneur de Yahvé un sacrifice par le feu, et le septième jour vous convoquerez une assemblée sainte et vous ne ferez aucun travail de travailleur.'"
,"9":"Yahvé dit à Moïse:"
,"10":"'Voici ce que tu diras aux Israélites: lorsque vous ferez la moisson, après votre entrée dans le pays que Yahvé vous donne, vous apporterez au prêtre une gerbe, ce seront les prémices de votre moisson."
,"11":"Le prêtre balancera solennellement la gerbe devant Yahvé pour qu'il vous bénisse; il la balancera le lendemain du sabbat."
,"12":"Le jour où vous balancerez la gerbe, vous offrirez à Yahvé en holocauste un agneau sans défaut né pendant l'année."
,"13":"Vous apporterez également deux mesures de fleur de farine pétrie dans l'huile, et vous les offrirez en sacrifice par le feu d'agréable odeur à Yahvé. Vous y ajouterez une libation de vin d'un quart de mesure."
,"14":"Vous ne mangerez, ni pain, ni épi grillé, ni épi frais jusqu'à ce jour où vous apporterez l'offrande à votre Dieu. C'est un rite perpétuel, vous l'observerez de génération en génération partout où vous habiterez."
,"15":"A partir de ce lendemain du sabbat où vous aurez offert la première gerbe, vous compterez sept semaines pleines."
,"16":"Au lendemain du septième sabbat, c'est-à-dire au cinquantième jour, vous présenterez de nouveau une offrande à Yahvé."
,"17":"Vous apporterez de chez vous une offrande, deux pains levés faits de deux mesures de fleur de farine: ce sont vos prémices pour Yahvé."
,"18":"Avec ces pains vous offrirez sept agneaux sans défaut nés dans l'année, un jeune taureau et deux béliers pour l'holocauste pour Yahvé, ainsi qu'une offrande et une libation: ce sera un sacrifice par le feu d'agréable odeur à Yahvé."
,"19":"Vous offrirez un bouc en sacrifice d'expiation et deux agneaux nés dans l'année en sacrifice de communion."
,"20":"Le prêtre les balancera solennellement avec les pains des prémices devant Yahvé ainsi que les deux agneaux: ils seront pour Yahvé, ce sera la part du prêtre."
,"21":"Ce jour-là vous convoquerez une sainte assemblée et vous ne ferez aucun travail de travailleur. C'est un rite perpétuel, vous l'observerez de génération en génération partout où vous habiterez."
,"22":"Lorsque vous moissonnerez vos terres, tu ne moissonneras pas jusqu'à la limite de ton champ, tu ne ramasseras pas ce qui peut être encore glané, mais tu le laisseras pour le pauvre et l'étranger: je suis Yahvé votre Dieu.'"
,"23":"Yahvé dit encore à Moïse:"
,"24":"'Voici ce que tu diras aux Israélites: Le premier jour du septième mois sera pour vous le Grand Sabbat, annoncé au son du cor: on y tiendra une assemblée sainte."
,"25":"Vous ne ferez aucun travail de travailleur, mais vous offrirez à Yahvé un sacrifice par le feu.'"
,"26":"Yahvé dit à Moïse:"
,"27":"'Le dix de ce septième mois, c'est le Jour du Pardon: vous y tiendrez une assemblée sainte. Vous vous humilierez et vous offrirez à Yahvé un sacrifice par le feu."
,"28":"Ce jour-là on ne fera aucun travail, car c'est le Jour du Pardon. Vous y ferez le rite de l'expiation pour vos péchés devant Yahvé votre Dieu."
,"29":"Toute personne qui refusera de s'humilier ce jour-là, sera retranchée de sa famille."
,"30":"Toute personne qui fera un travail quel qu'il soit ce jour-là, je la ferai périr du milieu de son peuple."
,"31":"Vous ne ferez aucun travail: c'est un rite perpétuel que vous garderez de génération en génération partout où vous habiterez."
,"32":"Ce sera pour vous le plus grand des sabbats, un repos absolu: vous vous humilierez. Le neuvième jour du mois au soir, et de ce soir jusqu'au lendemain soir, vous observerez ce sabbat.'"
,"33":"Yahvé dit à Moïse:"
,"34":"'Voici ce que tu diras aux Israélites: Le quinzième jour de ce septième mois, et pendant sept jours, c'est la Fête des Tentes en l'honneur de Yahvé."
,"35":"Le premier jour il y aura une assemblée sainte et vous ne ferez aucun travail de travailleur."
,"36":"Pendant sept jours vous offrirez à Yahvé des sacrifices par le feu. Le huitième jour vous aurez de nouveau une assemblée sainte et vous offrirez à Yahvé des sacrifices par le feu: il marquera la fin de la fête. Vous ne ferez ce jour-là aucun travail de travailleur."
,"37":"Voilà les fêtes de Yahvé où vous convoquerez une assemblée sainte. Vous offrirez à Yahvé des sacrifices par le feu, des holocaustes, des offrandes, des victimes et des libations."
,"38":"Ce sera en plus des sabbats de Yahvé, en plus de vos dons, en plus de vos voeux, en plus de vos offrandes volontaires: de tout ce que vous offrez à Yahvé."
,"39":"Le quinzième jour du septième mois, lorsque vous récolterez tous les produits du pays, vous célébrerez pendant sept jours la Fête de Yahvé; le premier et le huitième jour seront des sabbats solennels."
,"40":"Le premier jour vous cueillerez des branches sur les plus beaux arbres: des branches de palmiers, des branches d'arbres à feuilles ou de saules de rivières. Et pendant sept jours vous ferez la fête devant Yahvé votre Dieu."
,"41":"Durant sept jours, chaque année, vous célébrerez cette fête de Yahvé: c'est une loi perpétuelle pour vous et vos descendants; vous la célébrerez le septième mois."
,"42":"Pendant sept jours vous habiterez dans des huttes de feuillages; tous ceux qui sont nés en Israël habiteront dans des huttes."
,"43":"Ainsi vos descendants sauront que je vous ai fait habiter dans des huttes lorsque je vous ai fait sortir du pays d'Egypte: je suis Yahvé votre Dieu.'"
,"44":"C'est là ce que Moïse fit savoir aux Israélites à propos des fêtes de Yahvé."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Yahvé dit à Moïse:"
,"2":"'Tu donneras cet ordre aux Israélites: Apportez de l'huile pure d'olives concassées pour les lampes qui brûlent sans cesse sur le chandelier."
,"3":"Aaron entretiendra la lampe du matin jusqu'au soir en présence de Yahvé, à l'extérieur du rideau qui est devant le Témoignage de la Tente du Rendez-Vous: c'est une loi perpétuelle pour vos descendants."
,"4":"Aaron entretiendra les lampes sur le chandelier d'or pur devant Yahvé sans aucune interruption."
,"5":"Tu prendras de la fleur de farine et tu cuiras douze gâteaux: chaque gâteau sera fait de deux mesures."
,"6":"Tu les disposeras en deux piles de six sur la table d'or pur devant Yahvé,"
,"7":"et sur chacune des piles tu poseras de l'encens. Il sera sur les pains comme un rappel, comme un sacrifice à Yahvé par le feu."
,"8":"Chaque sabbat on préparera ces pains devant Yahvé, comme le signe d'une alliance perpétuelle de la part des Israélites."
,"9":"Les pains reviendront à Aaron et à ses fils, qui les mangeront dans un lieu saint. Ce sera pour eux une chose particulièrement sainte parmi tout ce qu'on offre à Yahvé par le feu: c'est une loi perpétuelle."
,"10":"Un homme né d'une mère israélite et d'un père égyptien se trouvait dans un groupe d'Israélites, et il y eut une querelle dans le camp entre ce fils d'une Israélite et un homme d'Israël."
,"11":"Le fils de la femme israélite blasphéma le Nom de Dieu, il le maudit. Sa mère s'appelait Salumit, elle était fille de Dabri de la tribu de Dan. On le conduisit à Moïse"
,"12":"et il fut placé sous bonne garde en attendant la décision de Yahvé."
,"13":"Yahvé dit à Moïse:"
,"14":"'Fais sortir du camp l'homme qui a blasphémé. Tous ceux qui l'ont entendu poseront leurs mains sur sa tête et ensuite toute l'assemblée le lapidera."
,"15":"Tu diras alors aux enfants d'Israël: Tout homme qui maudit son Dieu portera le poids de son péché."
,"16":"Celui qui blasphémera le Nom de Yahvé sera puni de mort: toute la communauté le lapidera. Etranger ou né dans le pays, celui qui blasphème le Nom sacré mourra."
,"17":"Celui qui frappe un homme à mort sera mis à mort."
,"18":"Celui qui frappe une bête à mort en donnera une autre: bête pour bête."
,"19":"Si quelqu'un blesse son prochain, on lui fera comme il a fait:"
,"20":"fracture pour fracture; oeil pour oeil; dent pour dent. On lui fera la même blessure qu'il a faite à son prochain."
,"21":"Celui qui aura tué une bête en rendra une autre, mais celui qui aura tué un homme sera mis à mort."
,"22":"La loi sera la même pour tous, pour l'étranger comme pour celui qui est né dans le pays: je suis Yahvé votre Dieu.'"
,"23":"Les Israélites écoutèrent les paroles de Moïse; ils firent sortir du camp l'homme qui avait blasphémé et le lapidèrent. Les Israélites agirent comme Yahvé l'avait ordonné à Moïse."
}`)
	CurrentBook.AddChapter(25, `{
"1":"Yahvé dit à Moïse sur la montagne du Sinaï:"
,"2":"'Voici ce que tu diras aux Israélites: Lorsque vous serez entrés dans le pays que Yahvé vous donne, la terre aura ses repos, ses sabbats en l'honneur de Yahvé."
,"3":"Pendant six ans tu ensemenceras ton champ, pendant six ans tu tailleras ta vigne et tu en récolteras les fruits."
,"4":"Mais la septième année sera un sabbat, un repos solennel pour ta terre, un sabbat en l'honneur de Yahvé. Tu n'ensemenceras pas ton champ et tu ne tailleras pas ta vigne;"
,"5":"tu ne moissonneras pas le regain de ta moisson et tu ne récolteras pas les raisins de la vigne non taillée: ce sera une année sabbatique pour la terre."
,"6":"Ce que la terre produit naturellement sera ta nourriture, la nourriture de ton serviteur et de ta servante, de celui qui travaille à ton service et de celui qui demeure en ta maison: de tous ceux qui habitent au milieu de toi."
,"7":"Ce qu'elle produit sera l'aliment de ton bétail et de tous les animaux qui sont dans ton pays."
,"8":"Lorsque tu auras compté sept semaines d'années, c'est-à-dire quarante-neuf ans,"
,"9":"au dix du septième mois tu feras sonner du cor. Ce sera alors le Jour du Pardon, et tu feras sonner du cor dans tout le pays."
,"10":"L'année des cinquante ans sera pour vous une année sainte où vous proclamerez l'affranchissement pour tous les habitants dans le pays: ce sera pour vous le Jubilé. Chacun reprendra sa propriété, chacun retournera dans sa famille."
,"11":"Cette cinquantième année sera pour vous un Jubilé. Vous ne sèmerez pas, vous ne moissonnerez pas le regain, vous ne récolterez pas sur la vigne non taillée,"
,"12":"car c'est un Jubilé. Ce sera pour vous une année sainte, vous mangerez de ce que la terre produit naturellement."
,"13":"L'année du Jubilé, chacun retournera dans sa propriété."
,"14":"Aussi, ne faites pas de tort à votre prochain, ni à la vente, ni à l'achat d'une propriété."
,"15":"Tu achèteras à ton prochain en tenant compte du nombre d'années écoulées depuis le dernier Jubilé, et lui te vendra d'après le nombre des années de récolte."
,"16":"Plus il y a d'années à venir, plus le prix sera élevé. Moins il restera d'années, plus tu baisseras le prix, car c'est le nombre des récoltes qu'il te vend."
,"17":"Que personne parmi vous ne fasse de tort à son frère. Tu craindras ton Dieu, car je suis Yahvé votre Dieu."
,"18":"Si vous mettez mes lois en pratique, si vous observez mes commandements, vous habiterez en paix dans votre pays."
,"19":"La terre donnera son fruit, vous aurez à manger en abondance et vous l'habiterez en paix."
,"20":"Vous direz peut-être: Que mangerons-nous la septième année, puisque nous ne semons pas et que nous ne récoltons pas?"
,"21":"Sache que je vous enverrai ma bénédiction la sixième année, et la terre produira pour trois ans."
,"22":"Quand vous sèmerez la huitième année, vous mangerez encore sur l'ancienne récolte. Et vous en mangerez encore jusqu'à la récolte de la neuvième année."
,"23":"Les terres ne se vendront pas pour toujours, car le pays est à moi et vous êtes chez moi des hôtes et des gens de passage."
,"24":"Dans tout le pays que vous posséderez, vous accorderez un droit de rachat pour les terres."
,"25":"Si ton frère est dans la gêne et vend sa propriété, son plus proche parent pourra racheter ce que son frère a vendu."
,"26":"Si l'homme n'a personne pour racheter en son nom, et qu'il a de quoi racheter lui-même ,"
,"27":"il calculera les années depuis le jour de la vente et rendra le surplus à l'homme à qui il a vendu, puis il retournera dans sa propriété."
,"28":"S'il ne trouve pas de quoi la racheter, la propriété restera vendue à celui qui l'a achetée jusqu'à l'année du Jubilé, mais à l'année du Jubilé elle retournera entre les mains de son premier propriétaire."
,"29":"Si un homme vend une maison d'habitation dans une ville entourée de murs, son droit de rachat durera jusqu'à la fin de l'année. Son droit de rachat durera toute l'année."
,"30":"Si la maison située dans une ville entourée de murs n'a pas été rachetée avant la fin de l'année de la vente, elle appartiendra pour toujours à l'acheteur et à ses descendants. Même l'année du Jubilé elle ne sortira pas de leur possession."
,"31":"On regardera comme faisant partie de la terre les maisons des villages qui ne sont pas entourés de murs; elles pourront être rachetées, et elles seront libérées l'année du Jubilé."
,"32":"Les Lévites auront un droit perpétuel de rachat sur les maisons qu'ils possèdent dans leurs villes."
,"33":"Si quelqu'un achète une maison appartenant à un Lévite, la maison vendue dans la ville qui leur a été donnée sera libérée l'année du Jubilé, car les maisons situées dans les villes des Lévites sont leur propriété au milieu des Israélites."
,"34":"Les champs qui entourent les villes des Lévites ne seront pas vendus: ils sont leur propriété pour toujours."
,"35":"Si ton frère est dans la gêne, si tu vois qu'il ne s'en sort pas, tu lui viendras en aide pour qu'il puisse vivre à ton côté, même s'il est déplacé ou seulement de passage."
,"36":"Tu ne tireras de lui ni intérêt, ni profit, mais tu auras la crainte de ton Dieu et ton frère vivra grâce à toi."
,"37":"Tu ne lui prêteras pas d'argent avec intérêt. Tu ne lui donneras pas de ta nourriture pour en tirer profit par la suite,"
,"38":"car je suis Yahvé, ton Dieu, qui vous ai fait sortir du pays d'Egypte, pour vous donner le pays de Canaan et pour être votre Dieu."
,"39":"Si ton frère qui est près de toi se trouve dans la gêne et se met à ton service, tu n'exigeras pas de lui un travail d'esclave."
,"40":"Il sera chez toi et te servira comme un salarié, comme un hôte, jusqu'à l'année du Jubilé."
,"41":"Après quoi il sortira de chez toi avec ses enfants et retournera dans sa famille; il rentrera dans la propriété de ses ancêtres."
,"42":"Car tous sont mes serviteurs que j'ai fait sortir du pays d'Egypte: on ne doit pas les vendre comme on vend des esclaves."
,"43":"Tu ne seras donc pas pour ton frère un maître, mais tu craindras ton Dieu."
,"44":"Si tu veux pour toi un esclave ou une servante, c'est dans les nations qui sont autour de toi que tu achèteras cet esclave ou cette servante."
,"45":"Tu pourras également l'acheter parmi les étrangers qui habitent au milieu de vous, ou dans leur famille, parmi les enfants qui sont nés dans votre pays: ceux-là seront votre propriété."
,"46":"Vous les laisserez à vos fils après vous et ils seront leur propriété; eux seront vos esclaves pour toujours. Mais avec vos frères israélites, vous n'agirez pas en maîtres exigeants, vous agirez comme on fait avec son frère."
,"47":"Si un étranger ou un homme de passage s'est enrichi près de toi et que ton frère qui est dans la gêne s'est vendu à cet étranger, ou à cet homme de passage, ou aux enfants d'un étranger,"
,"48":"il pourra se racheter après s'être vendu: un de ses frères pourra le racheter."
,"49":"Son oncle, ou le fils de son oncle, ou encore l'un de ses proches parents pourra le racheter. Lui-même pourra se racheter s'il en a les moyens."
,"50":"Il calculera avec celui qui l'a acheté depuis l'année où il s'est vendu à lui jusqu'à l'année du Jubilé. Le prix sera en proportion du nombre des années, en comptant ses journées de travail comme celles d'un mercenaire."
,"51":"S'il y a encore beaucoup d'années, il paiera son rachat selon ces années en tenant compte du prix auquel il a été acheté."
,"52":"Mais s'il reste peu d'années avant le Jubilé il en fera le compte, et paiera son rachat selon le nombre de ces années."
,"53":"Il sera au long des ans comme un travailleur salarié; il ne faut pas qu'on le traite avec dureté sous tes yeux."
,"54":"Si personne ne le rachète, il sortira libre l'année du Jubilé, et ses enfants avec lui."
,"55":"Car c'est moi que servent les Israélites, ils sont mes serviteurs que j'ai fait sortir du pays d'Egypte: je suis Yahvé votre Dieu."
}`)
	CurrentBook.AddChapter(26, `{
"1":"Vous ne vous ferez pas d'idoles. Vous ne dresserez pas de statues ou de stèles. Vous ne placerez pas dans votre pays des pierres sculptées pour vous prosterner devant elles: je suis Yahvé votre Dieu!"
,"2":"Vous observerez mes sabbats et vous respecterez mon sanctuaire: je suis Yahvé!"
,"3":"Si vous suivez mes lois, si vous observez mes commandements et les mettez en pratique,"
,"4":"je vous enverrai la pluie en sa saison; la terre donnera ses produits et les arbres des champs leurs fruits."
,"5":"Le battage du blé se prolongera chez vous jusqu'à la vendange, et le temps de la vendange rejoindra celui des semailles. Vous ne manquerez jamais de pain et vous habiterez en paix dans votre pays."
,"6":"Je donnerai la paix à votre pays et vous dormirez sans que personne ne vous inquiète. Je ferai disparaître du pays les bêtes féroces, et l'épée ne traversera pas votre pays."
,"7":"Vous poursuivrez vos ennemis et ils tomberont sous votre épée,"
,"8":"cinq d'entre vous en poursuivront cent, et cent d'entre vous en poursuivront dix mille; vos ennemis tomberont sous votre épée."
,"9":"Je m'intéresserai à vous et je ferai honneur à mon alliance avec vous: je vous ferai fructifier et vous vous multiplierez,"
,"10":"vous n'aurez pas fini de manger l'ancienne récolte que la nouvelle sera déjà là."
,"11":"Je mettrai ma Demeure au milieu de vous et je ne vous prendrai pas en horreur."
,"12":"Je me promènerai au milieu de vous, je serai votre Dieu et vous serez mon peuple."
,"13":"Car je suis Yahvé, votre Dieu, qui vous ai fait sortir du pays d'Egypte pour mettre fin à votre esclavage. J'ai brisé le joug qui pesait sur vous et je vous ai fait marcher la tête haute."
,"14":"Mais si vous ne m'écoutez pas, si vous ne mettez pas en pratique tous ces commandements,"
,"15":"si vous méprisez mes préceptes et rejetez mes ordonnances, si vous violez mon alliance au lieu de pratiquer tous mes commandements,"
,"16":"voici ce qu'à mon tour je ferai: j'enverrai contre vous la terreur, la peste et la fièvre. Vos yeux s'affaibliront et votre santé déclinera. Vous sèmerez mais vos ennemis mangeront la récolte."
,"17":"Je me joindrai à vos adversaires et vous serez battus par vos ennemis. Ceux qui vous haïssent domineront sur vous et vous fuirez alors même que personne ne vous poursuit."
,"18":"Et si après tout cela vous ne m'écoutez pas, je vous châtierai sept fois plus que vous n'aurez péché,"
,"19":"jusqu'à briser votre orgueilleuse puissance. Les cieux seront pour vous de fer et votre terre sera de bronze."
,"20":"Vous dépenserez vos forces sans résultat; votre terre ne donnera plus sa récolte et les arbres de la terre ne donneront plus leurs fruits."
,"21":"Si vous continuez de me résister et ne voulez pas m'écouter, je vous frapperai sept fois plus que vous n'aurez péché."
,"22":"Je lâcherai contre vous les animaux sauvages qui dévoreront vos enfants et déchireront votre bétail; je vous réduirai à presque rien et vos chemins deviendront déserts."
,"23":"Si après tout cela vous ne vous laissez pas corriger par moi, si vous me résistez encore,"
,"24":"moi aussi je vous résisterai et je vous frapperai sept fois plus que vous n'aurez péché."
,"25":"Je ferai venir contre vous l'épée qui vengera mon Alliance. Quand vous vous réfugierez dans vos villes, j'enverrai la peste au milieu de vous et vous serez livrés aux mains de vos ennemis."
,"26":"Je vous priverai de pain, à tel point que dix femmes le cuiront dans un seul four. Elles vous donneront le pain si mesuré que vous mangerez sans vous rassasier."
,"27":"Si après tout cela vous ne m'écoutez toujours pas et me résistez encore,"
,"28":"je m'en prendrai à vous avec colère et je vous châtierai sept fois plus que vous n'aurez péché."
,"29":"Vous mangerez la chair de vos fils et la chair de vos filles."
,"30":"Je détruirai vos hauts-lieux et je briserai vos pierres dressées. Je jetterai vos cadavres sur les cadavres de vos sales idoles et je vous rejetterai avec dégoût."
,"31":"Je réduirai vos villes en ruines et je détruirai vos sanctuaires, je me détournerai de l'odeur de vos sacrifices."
,"32":"Et je dévasterai le pays au point que vos ennemis en seront étonnés quand ils viendront l'habiter."
,"33":"Je vous disperserai parmi les nations et je dégainerai contre vous l'épée. Votre pays sera dévasté, et vos villes resteront en ruines."
,"34":"Alors la terre jouira de ses repos sabbatiques tout le temps que durera votre exil et que vous serez dans le pays de vos ennemis. Oui, la terre se reposera et elle aura son repos."
,"35":"Durant tout le temps de son abandon elle aura le repos, puisqu'elle n'avait pas connu de sabbat lorsque vous l'habitiez."
,"36":"Je mettrai la panique au coeur de tous ceux d'entre vous qui survivront dans le pays de leurs ennemis. Au seul bruit d'une feuille qui s'agite, ils fuiront comme on fuit devant l'épée, ils tomberont sans que personne ne les poursuive,"
,"37":"ils trébucheront les uns sur les autres, comme fuyant l'épée, alors que personne ne les poursuit. Vous ne pourrez pas résister à vos ennemis."
,"38":"Vous mourrez sur la terre des autres nations et le pays de vos ennemis vous dévorera."
,"39":"Ceux qui resteront pourriront en terre étrangère à cause de leurs péchés, et à cause des péchés de leurs pères qu'ils portent encore sur eux."
,"40":"Alors ils confesseront leurs péchés et les fautes de leurs pères, les infidélités qu'ils ont commises contre moi quand ils me résistaient,"
,"41":"et que, moi aussi, je leur résistais jusqu'à les déporter au pays de leurs ennemis. Peut-être alors leur coeur incirconcis se repentira-t-il? Peut-être paieront-ils leurs fautes?"
,"42":"Alors je me souviendrai de l'alliance que j'ai faite avec Jacob, et de mon alliance avec Isaac, et de mon alliance avec Abraham. Et quand je m'en souviendrai, je me souviendrai du pays."
,"43":"La terre sera donc abandonnée par eux, pour qu'elle acquitte ses sabbats, tout le temps qu'elle restera en friche loin d'eux et qu'ils paieront leurs fautes, après avoir méprisé mes commandements et n'avoir montré que du dégoût pour mes lois."
,"44":"Malgré cela, je ne les abandonnerai pas lorsqu'ils seront dispersés dans le pays de leurs ennemis. Je ne les rejetterai pas au point de les exterminer et de rompre mon alliance avec eux, car je suis Yahvé leur Dieu."
,"45":"Je me souviendrai en leur faveur de l'Alliance que j'ai faite avec leurs pères, quand je les ai fait sortir du pays d'Egypte sous les yeux des nations pour être leur Dieu: je suis Yahvé!'"
,"46":"Voilà donc les sentences, les règles, et les lois que Yahvé fixa entre lui et les Israélites sur la montagne du Sinaï par le ministère de Moïse."
}`)
	CurrentBook.AddChapter(27, `{
"1":"Yahvé dit à Moïse:"
,"2":"'Voici ce que tu diras aux Israélites: voici le prix du rachat d'une personne que l'on a consacrée à Yahvé par un voeu."
,"3":"S'il s'agit d'un homme de vingt à soixante ans, tu l'estimeras à cinquante sicles d'argent selon le sicle du sanctuaire."
,"4":"Si c'est une femme, ton estimation sera de trente sicles."
,"5":"Un garçon de cinq à vingt ans, sera estimé à vingt sicles, une fille du même âge à dix sicles."
,"6":"Un garçon d'un mois à cinq ans sera estimé à cinq sicles d'argent, une fille du même âge à trois sicles d'argent."
,"7":"Au-dessus de soixante ans, un homme sera estimé à quinze sicles, une femme à dix sicles."
,"8":"Si celui qui a fait le voeu est trop pauvre pour payer le rachat, on le présentera devant le prêtre qui fera une estimation, en tenant compte des moyens de celui qui a fait le voeu."
,"9":"Si on offre à Yahvé un animal, il est donné à Yahvé. Il est donc consacré,"
,"10":"on ne le changera pas. On ne mettra pas une vilaine bête à la place d'une bonne, ni une bonne à la place d'une vilaine. Si l'on remplace un animal par un autre, ils seront l'un et l'autre consacrés."
,"11":"S'il s'agit d'un animal impur, que l'on ne peut offrir à Yahvé, on présentera l'animal au prêtre."
,"12":"Le prêtre en fera l'estimation selon qu'il le trouve bon ou mauvais et l'on se fiera à l'estimation du prêtre."
,"13":"Si on veut le racheter, on ajoutera un cinquième au prix de l'estimation."
,"14":"Si quelqu'un consacre sa maison en la vouant à Yahvé, le prêtre en fera l'estimation selon qu'elle est bonne ou mauvaise et l'on s'en tiendra à l'estimation du prêtre."
,"15":"Si celui qui a voué sa maison veut la racheter, il ajoutera un cinquième au prix de l'estimation et elle lui reviendra."
,"16":"Si quelqu'un consacre à Yahvé une partie de son champ, l'estimation se fera d'après la quantité de semence que reçoit ce champ, à raison de cinquante sicles d'argent pour une mesure de semence d'orge."
,"17":"Si quelqu'un consacre son champ l'année même du Jubilé, on s'en tiendra à cette estimation."
,"18":"Mais s'il consacre son champ après le Jubilé, le prêtre évaluera le prix d'après le nombre d'années qui restent jusqu'au prochain Jubilé. Et il fera une réduction sur son estimation."
,"19":"Si celui qui a consacré son champ veut le racheter, il ajoutera un cinquième au prix de l'estimation et le champ lui reviendra."
,"20":"Mais s'il ne rachète pas le champ et qu'on l'a vendu à un autre, le champ ne pourra plus être racheté."
,"21":"Et quand viendra l'année du Jubilé, le champ sera voué à Yahvé comme un champ voué par anathème. Il deviendra la propriété du prêtre."
,"22":"Si quelqu'un consacre à Yahvé un champ qui ne faisait pas partie de son patrimoine, mais qu'il a acheté,"
,"23":"le prêtre en calculera le prix selon la date de l'année du Jubilé. Cet homme paiera le jour même le prix fixé, et ce paiement sera une chose sainte pour Yahvé."
,"24":"A l'année du Jubilé le champ reviendra à celui qui l'avait vendu et au patrimoine duquel il appartenait."
,"25":"Toutes tes estimations seront faites en sicles du sanctuaire. Le sicle est de vingt guéras."
,"26":"Cependant personne ne pourra consacrer le premier-né de son bétail, car le premier-né, veau ou brebis, appartient déjà à Yahvé."
,"27":"S'il s'agit d'un animal impur, on le rachètera au prix de ton estimation en y ajoutant un cinquième, et s'il n'est pas racheté, il sera vendu selon ton estimation."
,"28":"Mais lorsqu'on aura voué à Yahvé par anathème une personne, un animal ou un champ qui font partie de son patrimoine, ceux-ci ne pourront ni être vendus, ni être rachetés, car tout ce qui est voué à la mort par anathème, appartient à Yahvé et à lui seul. C'est une chose très sainte."
,"29":"C'est pourquoi aucune personne vouée par anathème ne pourra être rachetée: elle sera mise à mort."
,"30":"La dîme prélevée sur les semences de la terre ou sur les fruits des arbres appartient à Yahvé: c'est une part consacrée à Yahvé."
,"31":"Si quelqu'un veut racheter quelque chose de sa dîme, il y ajoutera un cinquième."
,"32":"Le dixième du gros et du petit bétail, de tout ce qui fait partie du troupeau, sera consacré comme dîme à Yahvé."
,"33":"On ne fera pas de choix entre bon et mauvais, on ne remplacera pas l'un par l'autre. Et si l'on fait un échange, la bête remplacée et celle qui la remplace seront consacrées: on ne pourra les racheter."
,"34":"Tels sont les commandements que Yahvé donna à Moïse pour les Israélites sur la montagne du Sinaï."
}`)

}
func FR_LBDCC_LoadVPNMChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Le premier jour du second mois, la deuxième année après la sortie d'Egypte, Yahvé parla à Moïse au désert du Sinaï, dans la Tente du Rendez-Vous."
,"2":"Il lui dit: 'Recensez toute la communauté des Israélites par clans et par familles, relevez le nom de tous les mâles et comptez-les un par un."
,"3":"Toi et Aaron, vous enregistrerez tous les Israélites de vingt ans et plus, capables de porter les armes, selon leurs formations de combat."
,"4":"Dans chaque tribu il y aura un homme, un chef de famille, pour vous aider."
,"5":"Voici les noms de ceux qui vous aideront: Pour Ruben, Elisour, fils de Chédéour; "
,"6":"pour Siméon, Cheloumiel, fils de Surichaddaï;"
,"7":"pour Juda, Nachon, fils d'Aminadab;"
,"8":"pour Issacar, Netanéel, fils de Souar;"
,"9":"pour Zabulon, Eliab, fils de Hélon;"
,"10":"pour les fils de Joseph, pour Ephraïm: Elichama, fils d'Ammihoud; pour Manassé, Gamliel, fils de Pedahsur;"
,"11":"pour Benjamin, Abidan, fils de Gidéoni;"
,"12":"pour Dan, Ahiézer, fils d'Amichaddaï;"
,"13":"pour Asher, Pagiel, fils d'Okran;"
,"14":"pour Gad, Eliasaf, fils de Réouel;"
,"15":"pour Nephtali, Ahira, fils d'Enan."
,"16":"Voilà ceux qui furent choisis dans l'assemblée. Ils étaient chefs dans la tribu de leur père, ils étaient chefs des clans d'Israël."
,"17":"Moïse et Aaron prirent ces hommes qui avaient été inscrits personnellement."
,"18":"Ils rassemblèrent toute la communauté le premier jour du second mois pour enregistrer toute leur famille, leur maison paternelle, en comptant les hommes depuis l'âge de vingt ans et au-delà, un par un,"
,"19":"selon ce que Yahvé avait ordonné à Moïse. On fit le recensement dans le désert du Sinaï."
,"20":"Pour les fils de Ruben, premier-né d'Israël, on releva leur parenté par clan et par famille, et on compta un par un tous les hommes de vingt ans et plus capables de porter les armes."
,"21":"Pour la tribu de Ruben, on en recensa quarante-six mille cinq cents."
,"22":"Pour les fils de Siméon, on releva leur parenté par clan et par famille, les noms un par un de tous les hommes de vingt ans et plus capables de porter les armes."
,"23":"Pour la tribu de Siméon, on en recensa cinquante-neuf mille trois cents."
,"24":"Pour les fils de Gad, on releva leur parenté par clan et par famille, et on compta un par un tous les hommes de vingt ans et plus capables de porter les armes."
,"25":"Pour la tribu de Gad, on en recensa quarante-cinq mille six cent cinquante."
,"26":"Pour les fils de Juda, on releva leur parenté par clan et par famille, et on compta un par un tous les hommes de vingt ans et plus capables de porter les armes."
,"27":"Pour la tribu de Juda, on en recensa soixante-quatorze mille six cents."
,"28":"Pour les fils d'Issacar, on releva leur parenté par clan et par famille, et on compta un par un tous les hommes de vingt ans et plus capables de porter les armes."
,"29":"Pour la tribu d'Issacar, on en recensa cinquante-quatre mille quatre cents."
,"30":"Pour les fils de Zabulon, on releva leur parenté par clan et par famille, et on compta un par un tous les hommes de vingt ans et plus capables de porter les armes."
,"31":"Pour la tribu de Zabulon, on en recensa cinquante-sept mille quatre cents."
,"32":"Quant aux fils de Joseph, on releva pour les fils d'Ephraïm, leur parenté par clan et par famille, et on compta un par un tous les hommes de vingt ans et plus capables de porter les armes."
,"33":"Pour la tribu d'Ephraïm, on en recensa quarante mille cinq cents."
,"34":"On releva pour les fils de Manassé, leur parenté par clan et par famille, et on compta un par un tous les hommes de vingt ans et plus capables de porter les armes."
,"35":"Pour la tribu de Manassé, on en recensa trente-deux mille deux cents."
,"36":"Pour les fils de Benjamin, on releva leur parenté par clan et par famille, et on compta un par un tous les hommes de vingt ans et plus capables de porter les armes."
,"37":"Pour la tribu de Benjamin, on en recensa trente-cinq mille quatre cents."
,"38":"Pour les fils de Dan, on releva leur parenté par clan et par famille, et on compta un par un tous les hommes de vingt ans et plus capables de porter les armes."
,"39":"Pour la tribu de Dan, on en recensa soixante-deux mille sept cents."
,"40":"Pour les fils d'Asher, on releva leur parenté par clan et par famille, et on compta un par un tous les hommes de vingt ans et plus capables de porter les armes."
,"41":"Pour la tribu d'Asher, on en recensa quarante et un mille cinq cents."
,"42":"Pour les fils de Nephtali, on releva leur parenté par clan et par famille, et on compta un par un tous les hommes de vingt ans et plus capables de porter les armes."
,"43":"Pour la tribu de Nephtali, on en recensa cinquante-trois mille quatre cents."
,"44":"Voilà ceux qui furent recensés, ceux que Moïse et Aaron recensèrent avec les chefs d'Israël, choisis au nombre de douze, un par tribu."
,"45":"On fit le total de ceux qui avaient été recensés parmi les Israélites de vingt ans et plus, selon leur tribu, de tous ceux qui étaient capables de porter les armes en Israël."
,"46":"Ce total fut de six cent trois mille cinq cent cinquante hommes."
,"47":"Les Lévites ne furent pas recensés avec eux,"
,"48":"car Yahvé avait dit à Moïse:"
,"49":"'Tu ne recenseras pas la tribu de Lévi, tu ne la compteras pas avec les autres Israélites,"
,"50":"mais tu confieras aux Lévites la Demeure du Témoignage, avec tous ses objets, tout ce qui lui appartient. Ils porteront la Demeure et tous ses objets, ils en assureront le service et camperont autour de la Demeure."
,"51":"Quand la Demeure partira, les Lévites la démonteront, et quand la Demeure s'arrêtera, les Lévites la dresseront, mais aucun profane ne s'en approchera sous peine de mort."
,"52":"Les Israélites camperont chacun dans son camp, chacun autour de sa bannière selon sa formation de combat,"
,"53":"mais les Lévites camperont autour de la Demeure du Témoignage pour que la colère de Dieu ne s'abatte pas sur la communauté des Israélites. Les Lévites auront la garde de la Demeure du Témoignage.'"
,"54":"Les Israélites firent donc tout ce que Yahvé avait ordonné à Moïse: c'est ainsi qu'ils agirent."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Yahvé dit à Moïse:"
,"2":"'Les Israélites camperont chacun autour de sa bannière sous les enseignes de leur clan; ils camperont autour de la Tente du Rendez-Vous et tournés vers elle."
,"3":"Juda campera avec ses troupes autour de sa bannière à l'orient, du côté du soleil levant, avec Nahasson, fils d'Aminadab, prince des fils de Juda."
,"4":"Sa troupe compte d'après le recensement: soixante-quatorze mille six cents hommes."
,"5":"A côté de lui campera la tribu d'Issacar avec Netanéel, fils de Souar, prince des fils d'Issacar."
,"6":"Sa troupe compte d'après le recensement: cinquante-quatre mille quatre cents hommes."
,"7":"Ensuite viendra la tribu de Zabulon avec Eliab, fils d'Hélon, prince des fils de Zabulon."
,"8":"Sa troupe compte d'après le recensement: cinquante-sept mille quatre cents hommes."
,"9":"Le total du camp de Juda d'après le recensement est donc de cent quatre-vingt-six mille quatre cents hommes: ils se mettront en marche les premiers."
,"10":"Au sud, Ruben campera avec ses troupes autour de sa bannière avec Elisur, fils de Chédéour, prince des fils de Ruben."
,"11":"Sa troupe compte d'après le recensement: quarante-six mille cinq cents hommes."
,"12":"A côté de lui campera la tribu de Siméon avec Cheloumiel, fils de Surichaddaï, prince des fils de Siméon."
,"13":"Sa troupe compte d'après le recensement: cinquante-neuf mille trois cents hommes."
,"14":"Après lui viendra la tribu de Gad avec Eliasaf, fils de Réouel, prince des fils de Gad."
,"15":"Sa troupe compte d'après le recensement: quarante-cinq mille six cent cinquante hommes."
,"16":"Le total du camp de Ruben d'après le recensement est donc de cent cinquante et un mille quatre cent cinquante hommes, ils se mettront en marche les deuxièmes."
,"17":"La Tente du Rendez-Vous partira ensuite, le camp des Lévites se trouvant au milieu des autres camps. On partira dans l'ordre du campement, chacun à sa place autour de sa bannière."
,"18":"Ephraïm campera avec ses troupes autour de sa bannière à l'occident, avec Elichama, fils d'Amiud, prince des fils d'Ephraïm."
,"19":"Sa troupe compte d'après le recensement: quarante mille cinq cents hommes."
,"20":"A côté de lui campera la tribu de Manassé avec Gamliel, fils de Pedahsur, prince des fils de Manassé."
,"21":"Sa troupe compte d'après le recensement: trente-deux mille deux cents hommes."
,"22":"Ensuite viendra la tribu de Benjamin avec Abidan, fils de Gidéoni, prince des fils de Benjamin."
,"23":"Sa troupe compte d'après le recensement: trente-cinq mille quatre cents hommes."
,"24":"Le total du camp d'Ephraïm d'après le recensement est donc de cent huit mille cent hommes; ils se mettront en marche les troisièmes."
,"25":"Dan campera avec ses troupes autour de sa bannière au nord, avec Ahiézer, fils d'Amichaddaï, prince des fils de Dan."
,"26":"Sa troupe compte d'après le recensement: soixante-deux mille sept cents hommes."
,"27":"A côté de lui campera la tribu d'Asher avec Pagiel, fils d'Ochran, prince des fils d'Asher."
,"28":"Sa troupe compte d'après le recensement: quarante et un mille cinq cents hommes."
,"29":"Ensuite viendra la tribu de Nephtali avec Ahira, fils d'Enan, prince des fils de Nephtali."
,"30":"Sa troupe compte d'après le recensement: cinquante-trois mille quatre cents hommes."
,"31":"Le total du camp de Dan d'après le recensement est donc de cent cinquante-sept mille six cents hommes; ils se mettront en marche les derniers autour de leur bannière."
,"32":"Voilà les Israélites qui furent recensés selon leurs tribus. Le total de tous ces hommes répartis dans leurs différents camps selon leurs formations, est donc de six cent trois mille cinq cent cinquante hommes."
,"33":"Les Lévites ne furent pas recensés avec les autres Israélites, puisque Yahvé l'avait ordonné ainsi à Moïse."
,"34":"Les Israélites firent tout comme Yahvé l'avait ordonné à Moïse. C'est donc ainsi qu'ils campaient autour de leur bannière et qu'ils se mettaient en marche, chacun selon sa famille, selon sa tribu."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Voici la descendance d'Aaron et de Moïse, lorsque Yahvé parla à Moïse sur la montagne du Sinaï."
,"2":"Voici les noms des fils d'Aaron: Nadab, le premier-né; Abihou, Eléazar et Itamar."
,"3":"Ce sont les noms des fils d'Aaron, les prêtres qui reçurent l'onction et furent choisis pour exercer le sacerdoce."
,"4":"Nadab et Abihou moururent devant Yahvé lorsqu'ils apportèrent à Yahvé un feu profane dans le désert du Sinaï; ils n'avaient pas de fils. Mais Eléazar et Itamar exercèrent le sacerdoce avec Aaron, leur père."
,"5":"Yahvé dit à Moïse:"
,"6":"'Fais approcher la tribu de Lévi. Elle sera au service d'Aaron, le prêtre;"
,"7":"elle partagera la responsabilité d'Aaron et de toute la communauté pour tout ce qui concerne la Tente du Rendez-Vous; elle assurera le service de la Demeure."
,"8":"Les Lévites seront chargés de tous les ustensiles de la Tente du Rendez-Vous, de tout ce qui a été confié à la charge des Israélites: Ils assureront le service de la Demeure."
,"9":"Tu confieras les Lévites à Aaron et à ses fils, ils sont pris parmi les Israélites pour lui être entièrement dévoués."
,"10":"Mais tu réserveras à Aaron et à ses fils les fonctions du sacerdoce: si un profane veut les exercer, il sera puni de mort.'"
,"11":"Yahvé dit encore à Moïse:"
,"12":"'Regarde! J'ai pris les Lévites du milieu des enfants d'Israël à la place de tout premier-né, de tout enfant qui sort le premier du sein de sa mère en Israël: les Lévites sont donc à moi."
,"13":"Car tout premier-né m'appartient depuis le jour où j'ai frappé les premiers-nés au pays d'Egypte; je me suis alors consacré tout premier-né en Israël, aussi bien parmi les hommes que parmi les animaux, et ils sont à moi: je suis Yahvé!'"
,"14":"Yahvé dit à Moïse dans le désert du Sinaï:"
,"15":"'Recense les fils de Lévi selon leurs clans, selon leurs familles. Tu feras le recensement de tous les mâles de plus d'un mois.'"
,"16":"Moïse fit donc ce recensement sur l'ordre de Yahvé, comme cela lui avait été commandé."
,"17":"Voici les noms des fils de Lévi: Guerchon, Kahat et Mérari."
,"18":"Voici les fils de Guerchon, par familles: Libni et Chiméï."
,"19":"Les fils de Kahat, par familles: Amram, Yichar, Hébron et Ouziel."
,"20":"Les fils de Mérari, par familles: Mali et Mouchi. Ce sont là les clans des fils de Lévi groupés selon leurs familles paternelles."
,"21":"Le clan de Libni et le clan de Chiméï appartiennent à Guerchon: ce sont les clans des Guerchonites."
,"22":"Les mâles recensés depuis l'âge d'un mois et au-dessus étaient au total de sept mille cinq cents."
,"23":"Les clans Guerchonites campaient derrière la Demeure, à l'ouest."
,"24":"Le chef de la maison de Guerchon était Eliasaf, fils de Laël."
,"25":"Dans la Tente du Rendez-Vous, les fils de Guerchon avaient la charge de la Demeure, de la tente et de sa couverture, du voile d'entrée de la Tente,"
,"26":"des rideaux de la cour, du rideau d'entrée de la cour qui entoure la Demeure et l'autel, enfin des cordes nécessaires pour ce travail."
,"27":"Les clans d'Amram, d'Yisar, d'Hébron et d'Ouziel appartiennent à Kahat: ce sont les clans des Kahatites."
,"28":"Les mâles recensés depuis l'âge d'un mois et au-dessus étaient au total huit mille trois cents, ils étaient chargés du sanctuaire."
,"29":"Les clans Kahatites campaient au sud de la Demeure."
,"30":"Le chef de la maison des Kahatites était Elisafan, fils d'Ouziel."
,"31":"Ils avaient la charge de l'Arche, de la table, du candélabre, des autels, des objets pour le service du sanctuaire, du voile, avec tout ce qui l'accompagne."
,"32":"Eléazar, fils d'Aaron le prêtre, avait la haute autorité sur tous les Lévites. Il surveillait tous ceux qui avaient la charge du sanctuaire."
,"33":"Le clan de Mali et le clan de Mouchi appartiennent à Mérari: ce sont les clans des Mérarites."
,"34":"Les mâles recensés depuis l'âge d'un mois et au-dessus étaient au total six mille deux cents."
,"35":"Les clans des Mérarites avaient pour chef Souriel, fils d'Abihayil. Ils campaient au nord de la Demeure."
,"36":"Les fils de Mérari avaient la charge des cadres de la Demeure, de ses traverses, des colonnes et de leurs supports, de tous les accessoires et de tout ce qui les accompagne,"
,"37":"ainsi que des colonnes qui entourent le parvis, de leurs supports, de leurs piquets et de leurs cordes."
,"38":"Moïse, Aaron et ses fils campaient devant la Demeure, à l'est, devant la Tente du Rendez-Vous à l'orient. Ils montaient la garde devant le sanctuaire au nom des fils d'Israël. Si un profane s'était approché, il aurait été mis à mort."
,"39":"Sur l'ordre de Yahvé, Moïse et Aaron recensèrent les Lévites selon leur famille. On dénombra vingt-deux mille mâles de l'âge d'un mois et au-delà."
,"40":"Yahvé dit à Moïse: 'Recense tout premier-né mâle parmi les Israélites, depuis l'âge d'un mois et au-delà, et dénombre-les un par un."
,"41":"Je suis Yahvé, tu prendras pour moi les Lévites à la place de tout premier-né parmi les Israélites, et le bétail des Lévites à la place de tout premier-né du bétail des Israélites.'"
,"42":"Moïse recensa donc tous les premiers-nés des Israélites, comme Yahvé le lui avait ordonné."
,"43":"On compta, de l'âge de un mois et au-dessus, vingt-deux mille deux cent soixante-treize premiers-nés mâles."
,"44":"Yahvé dit alors à Moïse:"
,"45":"'Prends les Lévites en échange de tout premier-né des Israélites, et le bétail des Lévites à la place du bétail des Israélites. Ainsi les Lévites seront à moi: je suis Yahvé!"
,"46":"Tu rachèteras les deux cent soixante treize premiers-nés des Israélites qui excèdent le nombre des Lévites."
,"47":"Tu prendras cinq sicles par tête, cinq sicles du sanctuaire, c'est-à-dire vingt guéras par sicle."
,"48":"Puis tu donneras cet argent à Aaron et à ses fils pour le rachat de ceux qui sont en excédent.'"
,"49":"Moïse prit donc l'argent du rachat de ceux qui étaient en excédent, et qui n'avaient pas été rachetés par les Lévites."
,"50":"Il demanda cet argent aux premiers-nés des Israélites: mille trois cent soixante-cinq sicles, d'après le sicle du sanctuaire."
,"51":"Moïse donna alors l'argent du rachat à Aaron et ses fils, selon l'ordre de Yahvé, selon ce que Yahvé avait commandé à Moïse."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Yahvé dit à Moïse et à Aaron:"
,"2":"'Parmi les fils de Lévi, tu feras le compte des fils de Kahat selon leurs familles et leurs clans,"
,"3":"depuis l'âge de trente ans et au-dessus, jusqu'à l'âge de cinquante ans. Tous ceux-ci ont à faire leur service, à remplir une fonction dans la Tente du Rendez-Vous."
,"4":"Voici le service qu'accompliront les fils de Kahat dans la Tente du Rendez-Vous: c'est un service très saint!"
,"5":"Quand on lèvera le camp, Aaron et ses fils descendront le voile et ils en couvriront l'Arche du Témoignage."
,"6":"Ils mettront dessus une couverture de peau de poisson et il étendront par-dessus un drap de pourpre violette, ensuite ils placeront les barres."
,"7":"Ils étendront sur la table des pains de proposition un drap de pourpre violette; ils mettront dessus les plats, les coupes, les assiettes et les gobelets pour les libations, ainsi que le pain d'offrande."
,"8":"Ils étendront par-dessus un drap teint en rouge qu'ils envelopperont d'une couverture de peau de poisson et ils fixeront les barres de la table."
,"9":"Ils prendront un drap de pourpre violette et ils en couvriront le chandelier, les lampes, les éteignoirs, les cendriers et les vases pour l'huile nécessaires pour son service."
,"10":"Ils placeront le tout dans une couverture de peau de poisson et le mettront sur un brancard."
,"11":"Ils étendront un drap de pourpre violette sur l'autel d'or, ils l'envelopperont d'une couverture de peau de poisson et fixeront les barres."
,"12":"Ils prendront tous les ustensiles en usage dans le sanctuaire, les mettront dans un drap de pourpre violette et les envelopperont d'une couverture de peau de poisson, ensuite ils les mettront sur un brancard."
,"13":"Ils enlèveront les cendres de l'autel et étendront par-dessus un drap de pourpre rouge."
,"14":"Ils poseront dessus tous les objets nécessaires à son service: les grils, les fourchettes, les pelles, les bassins, tous les objets qui servent pour l'autel. Ils étendront sur le tout une couverture de peau de poisson et fixeront les barres."
,"15":"Quand Aaron et ses fils achèveront d'envelopper le sanctuaire et tous les objets du sanctuaire; on lèvera le camp. Les fils de Kahat viendront pour tout emporter mais ils ne toucheront pas les objets sacrés; sinon ils mourraient. Voilà la responsabilité des fils de Kahat dans la Tente du Rendez-Vous."
,"16":"Eléazar, fils d'Aaron le prêtre, aura la charge de l'huile du chandelier, du parfum d'agréable odeur, de l'offrande perpétuelle, de l'huile de consécration. Il veillera sur toute la Demeure et tout ce qu'elle contient: il sera responsable du sanctuaire et de ses ustensiles.'"
,"17":"Yahvé dit à Moïse et à Aaron:"
,"18":"'Ne causez pas la perte d'une famille de Lévi, la tribu des Kahatites."
,"19":"Voici comment vous ferez pour qu'ils restent en vie et ne meurent pas quand ils s'approcheront des choses très saintes. Aaron et ses fils s'approcheront et fixeront à chacun d'entre eux son service et ce qu'il doit porter,"
,"20":"mais ils n'entreront pas, ne serait-ce qu'un instant, pour voir les choses saintes; autrement ils mourraient.'"
,"21":"Yahvé dit à Moïse:"
,"22":"'Compte les fils de Guerchon selon leurs clans et leurs familles."
,"23":"Tu les compteras à partir de l'âge de trente ans et au-dessus, jusqu'à l'âge de cinquante ans; tous ceux-ci auront à remplir un service, une fonction dans la Tente du Rendez-Vous."
,"24":"Voici quel sera le service des familles Guerchonites, ce qu'elles auront à faire et à porter."
,"25":"Leurs fils porteront les tentures de la Demeure, la Tente du Rendez-Vous, sa couverture et la couverture de peau de poisson qui se place par-dessus, le rideau qui est à l'entrée de la Tente du Rendez-Vous,"
,"26":"les tentures de la cour et le rideau de l'entrée de la porte de la cour qui entoure la Demeure et l'autel, les cordes et tous les accessoires: ce sera leur service et leur travail."
,"27":"Tout le service des Guerchonites se fera sous les ordres d'Aaron et de ses fils, aussi bien pour ce qu'ils auront à porter, que pour ce qu'ils auront à faire. Vous leur confierez tout ce qu'ils auront à porter."
,"28":"Voilà le service des familles des Guerchonites pour la Tente du Rendez-Vous. Ils rempliront ce service sous la direction d'Itamar, fils d'Aaron le prêtre."
,"29":"Tu compteras les fils de Mérari selon leurs familles et leurs clans."
,"30":"Tu les compteras depuis l'âge de trente ans et au-dessus, jusqu'à l'âge de cinquante ans; tous ceux-ci auront un service à remplir, une fonction dans la Tente du Rendez-Vous."
,"31":"Voici ce qui leur sera confié, ce qu'ils auront à transporter de la Tente du Rendez-Vous: les planches de la Demeure, les traverses, les colonnes et leur support,"
,"32":"les colonnes qui entourent la cour et leur support, les piquets et les cordes, tous les accessoires et tout ce qui sert à les monter. Vous recenserez un par un tous les objets qu'ils devront transporter."
,"33":"Voilà quel sera le service des familles des Mérarites pour la Tente du Rendez-Vous, sous les ordres d'Itamar, fils d'Aaron le prêtre.'"
,"34":"Moïse et Aaron, et les chefs de la communauté, recensèrent donc les fils de Kahat, selon leurs familles et leurs clans."
,"35":"Tous ceux qui avaient trente ans et au-delà, jusqu'à l'âge de cinquante ans, avaient une charge, un service dans la Tente du Rendez-Vous."
,"36":"On les recensa par familles: ils étaient deux mille sept cent cinquante."
,"37":"Voilà ceux qui furent recensés par famille, chez les Kahatites, tous ceux qui avaient une charge dans la Tente du Rendez-Vous: Moïse et Aaron les recensèrent selon l'ordre que Yahvé avait donné par la voix de Moïse."
,"38":"Ceux qu'on avait recensés parmi les fils de Guerchon, par famille et par clan,"
,"39":"de trente à cinquante ans, tous ceux qui avaient une charge dans la Tente du Rendez-Vous,"
,"40":"étaient au nombre de deux mille six cent trente."
,"41":"Voilà ceux que l'on recensa chez les familles Guerchonites, tous ceux qui avaient une charge dans la Tente du Rendez-Vous, Moïse et Aaron les recensèrent sur l'ordre de Yahvé."
,"42":"On recensa chez les Mérarites par famille et par clan,"
,"43":"à partir de l'âge de trente ans et au-delà jusqu'à l'âge de cinquante ans, tous ceux qui avaient une charge, un service, dans la Tente du Rendez-Vous."
,"44":"On les recensa par familles: ils étaient trois mille deux cents."
,"45":"Voilà ceux que l'on recensa par famille chez les Mérarites. Moïse et Aaron les recensèrent comme Yahvé l'avait ordonné à Moïse."
,"46":"Moïse et Aaron, aidés par les chefs d'Israël, recensèrent chez les Lévites, par familles et par clans,"
,"47":"tous ceux qui, âgés de trente à cinquante ans, avaient la charge de transporter la Tente du Rendez-Vous:"
,"48":"ils étaient huit mille cinq cent quatre-vingts."
,"49":"Sur l'ordre de Yahvé , on recensa chacun selon son service et ce qu'il devait porter. Le recensement est celui que Yahvé avait ordonné à Moïse."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Yahvé dit à Moïse:"
,"2":"'Ordonne ceci aux enfants d'Israël: Vous renverrez du camp les lépreux, ceux qui ont un écoulement et ceux qui se sont rendus impurs en touchant un cadavre."
,"3":"Homme ou femme, vous les enverrez à l'extérieur du camp, pour qu'ils ne rendent pas impur le camp où j'habite au milieu de vous.'"
,"4":"C'est ce que firent les Israélites. Ils renvoyèrent les impurs à l'extérieur du camp comme Yahvé l'avait dit à Moïse."
,"5":"Yahvé parla à Moïse:"
,"6":"'Voici ce que tu diras aux Israélites: Quand un homme ou une femme aura péché envers son prochain, qu'il aura commis une infidélité envers Yahvé, cette personne sera coupable."
,"7":"Elle reconnaîtra alors le péché qu'elle a commis. Puis elle rendra toute la somme pour laquelle elle s'est rendue coupable, et elle y ajoutera un cinquième qu'elle donnera à celui envers qui elle a péché."
,"8":"S'il n'y a personne à qui restituer l'objet pour lequel on s'est rendu coupable, cet objet appartiendra à Yahvé. Le coupable le donnera aux prêtres en plus du bélier pour le sacrifice de réparation, que l'on offrira pour lui."
,"9":"Car sur toutes les choses saintes que les Israélites offrent au prêtre, celui-ci a droit au prélèvement."
,"10":"Ce que chacun offre lui appartient, mais s'il le remet au prêtre, cela appartient à ce dernier.'"
,"11":"Yahvé dit à Moïse:"
,"12":"'Voici ce que tu diras aux Israélites pour le cas suivant: Un homme a une femme qui se conduit mal et qui lui est infidèle."
,"13":"Un autre homme a eu des rapports sexuels avec elle en cachette du mari, et elle-même s'est cachée pour accomplir cet acte impur de sorte qu'il n'y a pas de témoin contre elle: personne ne l'a vue."
,"14":"Il est possible qu'un esprit de jalousie soit entré dans cet homme et qu'il soupçonne sa femme parce que, de fait, elle s'est rendue impure. Mais il est possible aussi qu'un esprit de jalousie se soit emparé de lui et qu'il soupçonne sa femme alors qu'elle est innocente."
,"15":"Dans ces cas, l'homme conduira sa femme vers le prêtre et apportera l'offrande réglementaire: un dixième de mesure de farine d'orge qui ne sera pas pétrie à l'huile et sur laquelle on ne mettra pas d'encens car c'est l'offrande du soupçon, une offrande pour faire ressortir une faute."
,"16":"Le prêtre fera approcher la femme devant Yahvé."
,"17":"Il prendra de l'eau consacrée dans un vase d'argile, il ramassera de la poussière du sol de la Demeure et la mettra dans l'eau."
,"18":"Le prêtre placera alors la femme devant Yahvé et il dénouera les cheveux de sa tête, puis il mettra dans ses mains l'offrande pour faire ressortir la faute, l'offrande du soupçon. Tenant dans ses mains les eaux d'amertume qui portent la malédiction,"
,"19":"le prêtre passera à la formule solennelle de malédiction. Il dira à la femme: Si aucun homme n'a couché avec toi, si tu ne t'es pas mal conduite avec un autre que ton mari, que ces eaux d'amertume qui portent la malédiction montrent ton innocence."
,"20":"Mais si tu t'es dévoyée avec un autre que ton mari, si tu es devenue impure en ayant des rapports sexuels avec un autre que ton mari..."
,"21":"Et le prêtre continuera avec la formule de malédiction: Que Yahvé fasse de toi une malédiction et une abomination au milieu de ton peuple. Qu'il fasse dépérir tes flancs et enfler ton ventre."
,"22":"Que ces eaux t'apportent la malédiction, qu'elles entrent dans tes entrailles, qu'elles fassent enfler ton ventre et dépérir tes flancs. Et la femme répondra: Amen! Amen!"
,"23":"Alors le prêtre écrira ces imprécations sur une feuille et il les lavera dans les eaux d'amertume"
,"24":"de façon à faire boire à la femme ces eaux chargées de malédiction."
,"25":"Puis le prêtre prendra dans la main de la femme l'offrande du soupçon, il la balancera devant Yahvé et la portera à l'autel."
,"26":"Il prendra de même une poignée de l'offrande et la fera fumer sur l'autel, après quoi il fera boire à la femme les eaux d'amertume."
,"27":"Si elle s'est rendue impure en trompant son mari, ces eaux qu'elle a bues deviendront en elle source d'amertume et de malédiction; son ventre enflera et ses flancs dépériront: cette femme deviendra une maudite au milieu de son peuple."
,"28":"Mais si la femme ne s'est pas rendue impure, si elle a gardé sa pureté, elle ne souffrira pas de mal et sera féconde."
,"29":"Telle est la loi du soupçon pour la femme qui se conduit mal avec un autre que son mari et qui se rend impure,"
,"30":"et pour l'homme sur qui passe un esprit de jalousie de sorte qu'il soupçonne sa femme. Il fera venir sa femme devant Yahvé et le prêtre appliquera la totalité de cette loi."
,"31":"Ainsi l'homme sera sans reproches et la femme portera son péché.'"
}`)
	CurrentBook.AddChapter(6, `{
"1":"Yahvé dit à Moïse:"
,"2":"'Voici ce que tu diras aux Israélites: Quand un homme, ou une femme, voudra se consacrer à Yahvé par le voeu de naziréat,"
,"3":"il s'abstiendra de vin et de boisson fermentée, il ne boira pas de vinaigre de vin, ni de toute autre sorte de vinaigre. Il ne boira pas de jus de raisin, il ne mangera ni raisin frais ni raisin sec."
,"4":"Tout le temps que durera son naziréat, il ne mangera rien de tout ce qui vient de la vigne, depuis les pépins jusqu'à la peau."
,"5":"Tout le temps que durera sa consécration, il ne se rasera pas la tête; jusqu'au jour où s'achèvera le temps de sa consécration, il sera consacré et laissera pousser librement ses cheveux."
,"6":"Durant tout le temps de sa consécration à Yahvé, il ne s'approchera pas d'un mort,"
,"7":"que ce soit même son père, sa mère, son frère ou sa soeur. En un mot, il ne se rendra pas impur si ceux-ci viennent à mourir, car il porte sur sa tête la consécration de son Dieu."
,"8":"Tout le temps de son naziréat, il est consacré à Yahvé."
,"9":"Si quelqu'un tombe mort subitement à côté de lui et rend ainsi impure sa tête consacrée, il se rasera la tête le jour-même où il se purifiera, et il la rasera encore au septième jour."
,"10":"Le huitième jour il apportera au prêtre deux tourterelles ou deux jeunes pigeons à l'entrée de la Tente du Rendez-Vous."
,"11":"Le prêtre offrira le premier en sacrifice pour le péché et le second en holocauste, et c'est ainsi qu'il fera le rite de l'expiation pour l'impureté que cet homme a contractée à cause du mort. Ce jour-là le Nazir consacrera de nouveau sa tête,"
,"12":"il se consacrera à Yahvé pour toute la durée de son voeu de Nazir, en offrant un agneau d'un an, en sacrifice de réparation. Les jours précédents ne seront pas comptés puisque son voeu de Nazir a été interrompu."
,"13":"Voilà la loi concernant les Nazirs. Le jour où le Nazir aura accompli le temps de sa consécration, on le fera venir à l'entrée de la Tente du Rendez-Vous."
,"14":"Là il offrira à Yahvé un agneau d'un an sans défaut pour l'holocauste, une brebis d'un an sans défaut pour le péché, un bélier sans défaut pour le sacrifice de communion."
,"15":"Il apportera aussi une corbeille de pain sans levain, des gâteaux de fleur de farine pétris dans l'huile, et des galettes sans levain arrosées d'huile, avec l'offrande et les libations habituelles."
,"16":"Le prêtre les présentera devant Yahvé et offrira le sacrifice pour le péché, ainsi que l'holocauste."
,"17":"Il offrira à Yahvé le bélier du sacrifice de communion à Yahvé avec la corbeille des pains sans levain, puis il fera l'offrande et la libation."
,"18":"Alors le Nazir se rasera à l'entrée de la Tente du Rendez-Vous; prenant sa chevelure consacrée, il la déposera sur le feu où brûle la victime du sacrifice de communion."
,"19":"Le prêtre prendra l'épaule du bélier lorsqu'elle sera cuite; il prendra également un gâteau sans levain dans la corbeille, une galette sans levain, il les déposera dans les mains du Nazir, après que celui-ci aura rasé sa tête consacrée."
,"20":"Le prêtre les balancera devant Yahvé; cette part consacrée reviendra au prêtre en plus de la poitrine qui a été balancée et du gigot que l'on a déjà mis à part. Après cela, le Nazir pourra boire du vin."
,"21":"Voilà la loi relative au Nazir lorsqu'il paye son voeu à Yahvé à l'occasion de son Naziréat, en plus de ce qu'il peut faire par ailleurs. La loi des Nazirs lui demande d'accomplir les voeux qu'il a faits.'"
,"22":"Yahvé dit encore à Moïse,"
,"23":"pour qu'il le répète à Aaron et à ses fils: 'Voici comment vous bénirez les fils d'Israël. Vous direz:"
,"24":"'Que Yahvé te bénisse et te garde!"
,"25":"Que Yahvé fasse briller sur toi son visage, qu'il te prenne en grâce!"
,"26":"Que Yahvé tourne vers toi son visage et te donne la paix!'"
,"27":"C'est ainsi qu'ils mettront mon Nom sur les fils d'Israël, et moi, je les bénirai.'"
}`)
	CurrentBook.AddChapter(7, `{
"1":"Le jour où Moïse acheva de dresser la Demeure, il la consacra avec l'huile, ainsi que tous ses accessoires. Après la consécration de l'autel et de tous ses accessoires,"
,"2":"les princes d'Israël, les chefs de clans, et les chefs des tribus qui avaient présidé au recensement, firent une offrande."
,"3":"Ils offrirent à Yahvé: six chars couverts et douze boeufs, c'est-à-dire un char pour deux chefs et un boeuf pour chacun. Ils les présentèrent devant la Demeure."
,"4":"Yahvé dit à Moïse:"
,"5":"'Reçois cela de leur part et mets-le au service de la Tente du Rendez-Vous. Confie-le aux Lévites, à chacun selon sa responsabilité.'"
,"6":"Moïse reçut donc les chars et les boeufs et les donna aux Lévites."
,"7":"Il donna aux fils de Guerchon, en raison de leur charge, deux des chars et quatre boeufs."
,"8":"Il donna aux fils de Mérari, en raison de leur charge et sous l'autorité d'Itamar, fils d'Aaron le prêtre, quatre chars et huit boeufs."
,"9":"Mais aux fils de Kahat il n'en donna pas, car ils avaient la charge du service du sanctuaire et ils le transportaient à l'épaule."
,"10":"Les chefs firent leur offrande en ce jour de la dédicace de l'autel, ils présentèrent leur offrande devant l'autel ainsi consacré."
,"11":"Yahvé dit à Moïse: 'Chaque jour, chacun leur tour, les princes présenteront leur offrande pour la consécration de l'autel.'"
,"12":"Ce fut Nachon, fils d'Aminadab, de la tribu de Juda qui apporta l'offrande pour le premier jour."
,"13":"Voici son offrande: une coupe d'argent pesant cent trente sicles, une coupe d'argent pour l'aspersion, de soixante-dix sicles comptés selon le sicle du sanctuaire, toutes deux remplies de fleur de farine pétrie dans l'huile, pour l'oblation,"
,"14":"une coupe d'or de dix sicles, pleine d'encens,"
,"15":"un taureau, un bélier et un agneau d'un an pour l'holocauste,"
,"16":"un bouc pour le sacrifice pour le péché,"
,"17":"et deux boeufs, cinq béliers, cinq boucs, cinq agneaux d'un an, pour le sacrifice de communion. Voilà l'offrande de Nachon, fils d'Aminadab."
,"18":"Ce fut Netanéel, fils de Souar, de la tribu d'Issacar qui apporta son offrande pour le deuxième jour."
,"19":"Voici son offrande: une coupe d'argent pesant cent trente sicles, une coupe d'argent pour l'aspersion, de soixante-dix sicles comptés selon le sicle du sanctuaire, toutes deux remplies de fleur de farine pétrie dans l'huile, pour l'oblation,"
,"20":"une coupe d'or de dix sicles, pleine d'encens,"
,"21":"un taureau, un bélier et un agneau d'un an pour l'holocauste,"
,"22":"un bouc pour le sacrifice pour le péché,"
,"23":"et deux boeufs, cinq béliers, cinq boucs, cinq agneaux d'un an, pour le sacrifice de communion. Voilà l'offrande de Netanéel, fils de Souar."
,"24":"Ce fut Eliab, fils de Hélon, de la tribu de Zabulon qui apporta l'offrande pour le troisième jour."
,"25":"Voici son offrande: une coupe d'argent pesant cent trente sicles, une coupe d'argent pour l'aspersion, de soixante-dix sicles comptés selon le sicle du sanctuaire, toutes deux remplies de fleur de farine pétrie dans l'huile, pour l'oblation,"
,"26":"une coupe d'or de dix sicles, pleine d'encens,"
,"27":"un taureau, un bélier et un agneau d'un an pour l'holocauste,"
,"28":"un bouc pour le sacrifice pour le péché,"
,"29":"et deux boeufs, cinq béliers, cinq boucs, cinq agneaux d'un an, pour le sacrifice de communion. Voilà l'offrande d'Eliab, fils de Hélon."
,"30":"Ce fut Elisour, fils de Chédéour, de la tribu de Ruben qui apporta l'offrande pour le quatrième jour."
,"31":"Voici son offrande: une coupe d'argent pesant cent trente sicles, une coupe d'argent pour l'aspersion, de soixante-dix sicles comptés selon le sicle du sanctuaire, toutes deux remplies de fleur de farine pétrie dans l'huile, pour l'oblation,"
,"32":"une coupe d'or de dix sicles, pleine d'encens,"
,"33":"un taureau, un bélier et un agneau d'un an pour l'holocauste,"
,"34":"un bouc pour le sacrifice pour le péché,"
,"35":"et deux boeufs, cinq béliers, cinq boucs, cinq agneaux d'un an, pour le sacrifice de communion. Voilà l'offrande de Elisour, fils de Chédéour."
,"36":"Ce fut Cheloumiel, fils de Surichaddaï, de la tribu de Siméon qui apporta l'offrande pour le cinquième jour."
,"37":"Voici son offrande: une coupe d'argent pesant cent trente sicles, une coupe d'argent pour l'aspersion, de soixante-dix sicles comptés selon le sicle du sanctuaire, toutes deux remplies de fleur de farine pétrie dans l'huile, pour l'oblation,"
,"38":"une coupe d'or de dix sicles, pleine d'encens,"
,"39":"un taureau, un bélier et un agneau d'un an pour l'holocauste,"
,"40":"un bouc pour le sacrifice pour le péché,"
,"41":"et deux boeufs, cinq béliers, cinq boucs, cinq agneaux d'un an, pour le sacrifice de communion. Voilà l'offrande de Cheloumiel, fils de Surichaddaï."
,"42":"Ce fut Eliasaf, fils de Réouel, de la tribu de Gad qui apporta l'offrande pour le sixième jour."
,"43":"Voici son offrande: une coupe d'argent pesant cent trente sicles, une coupe d'argent pour l'aspersion, de soixante-dix sicles comptés selon le sicle du sanctuaire, toutes deux remplies de fleur de farine pétrie dans l'huile, pour l'oblation,"
,"44":"une coupe d'or de dix sicles, pleine d'encens,"
,"45":"un taureau, un bélier et un agneau d'un an pour l'holocauste,"
,"46":"un bouc pour le sacrifice pour le péché,"
,"47":"et deux boeufs, cinq béliers, cinq boucs, cinq agneaux d'un an, pour le sacrifice de communion. Voilà l'offrande d'Eliasaf, fils de Réouel."
,"48":"Ce fut Elichama, fils d'Ammihoud, de la tribu d'Ephraïm qui apporta l'offrande pour le septième jour."
,"49":"Voici son offrande: une coupe d'argent pesant cent trente sicles, une coupe d'argent pour l'aspersion, de soixante-dix sicles comptés selon le sicle du sanctuaire, toutes deux remplies de fleur de farine pétrie dans l'huile, pour l'oblation,"
,"50":"une coupe d'or de dix sicles, pleine d'encens,"
,"51":"un taureau, un bélier et un agneau d'un an pour l'holocauste,"
,"52":"un bouc pour le sacrifice pour le péché,"
,"53":"et deux boeufs, cinq béliers, cinq boucs, cinq agneaux d'un an, pour le sacrifice de communion. Voilà l'offrande d'Elichama, fils d'Ammihoud."
,"54":"Ce fut Gamliel, fils de Pedahsur, de la tribu de Manassé qui apporta l'offrande pour le huitième jour."
,"55":"Voici son offrande: une coupe d'argent pesant cent trente sicles, une coupe d'argent pour l'aspersion, de soixante-dix sicles comptés selon le sicle du sanctuaire, toutes deux remplies de fleur de farine pétrie dans l'huile, pour l'oblation,"
,"56":"une coupe d'or de dix sicles, pleine d'encens,"
,"57":"un taureau, un bélier et un agneau d'un an pour l'holocauste,"
,"58":"un bouc pour le sacrifice pour le péché,"
,"59":"et deux boeufs, cinq béliers, cinq boucs, cinq agneaux d'un an, pour le sacrifice de communion. Voilà l'offrande de Gamliel, fils de Pedahsur."
,"60":"Ce fut Abidan, fils de Gidéoni, de la tribu de Benjamin qui apporta l'offrande pour le neuvième jour."
,"61":"Voici son offrande: une coupe d'argent pesant cent trente sicles, une coupe d'argent pour l'aspersion, de soixante-dix sicles comptés selon le sicle du sanctuaire, toutes deux remplies de fleur de farine pétrie dans l'huile, pour l'oblation,"
,"62":"une coupe d'or de dix sicles, pleine d'encens,"
,"63":"un taureau, un bélier et un agneau d'un an pour l'holocauste,"
,"64":"un bouc pour le sacrifice pour le péché,"
,"65":"et deux boeufs, cinq béliers, cinq boucs, cinq agneaux d'un an, pour le sacrifice de communion. Voilà l'offrande d'Abidan, fils de Gidéoni."
,"66":"Ce fut Ahiézer, fils d'Amichaddaï, de la tribu de Dan qui apporta l'offrande pour le dixième jour."
,"67":"Voici son offrande: une coupe d'argent pesant cent trente sicles, une coupe d'argent pour l'aspersion, de soixante-dix sicles comptés selon le sicle du sanctuaire, toutes deux remplies de fleur de farine pétrie dans l'huile, pour l'oblation,"
,"68":"une coupe d'or de dix sicles, pleine d'encens,"
,"69":"un taureau, un bélier et un agneau d'un an pour l'holocauste,"
,"70":"un bouc pour le sacrifice pour le péché,"
,"71":"et deux boeufs, cinq béliers, cinq boucs, cinq agneaux d'un an, pour le sacrifice de communion. Voilà l'offrande d'Ahiézer, fils d'Amichaddaï."
,"72":"Ce fut Pagiel, fils d'Okran, de la tribu d'Asher qui apporta l'offrande pour le onzième jour."
,"73":"Voici son offrande: une coupe d'argent pesant cent trente sicles, une coupe d'argent pour l'aspersion, de soixante-dix sicles comptés selon le sicle du sanctuaire, toutes deux remplies de fleur de farine pétrie dans l'huile, pour l'oblation,"
,"74":"une coupe d'or de dix sicles, pleine d'encens,"
,"75":"un taureau, un bélier et un agneau d'un an pour l'holocauste,"
,"76":"un bouc pour le sacrifice pour le péché,"
,"77":"et deux boeufs, cinq béliers, cinq boucs, cinq agneaux d'un an, pour le sacrifice de communion. Voilà l'offrande de Pagiel, fils d'Okran."
,"78":"Ce fut Ahira, fils d'Enan, de la tribu de Nephtali qui apporta l'offrande pour le douzième jour."
,"79":"Voici son offrande: une coupe d'argent pesant cent trente sicles, une coupe d'argent pour l'aspersion, de soixante-dix sicles comptés selon le sicle du sanctuaire, toutes deux remplies de fleur de farine pétrie dans l'huile, pour l'oblation,"
,"80":"une coupe d'or de dix sicles, pleine d'encens,"
,"81":"un taureau, un bélier et un agneau d'un an pour l'holocauste,"
,"82":"un bouc pour le sacrifice pour le péché,"
,"83":"et deux boeufs, cinq béliers, cinq boucs, cinq agneaux d'un an, pour le sacrifice de communion. Voilà l'offrande d'Ahira, fils d'Enan."
,"84":"Telles furent les offrandes des princes d'Israël pour la dédicace de l'autel au jour de sa consécration: douze coupes d'argent, douze coupes d'argent pour l'aspersion, douze coupes d'or."
,"85":"Chaque coupe d'argent pesait cent trente sicles, chaque coupe pour l'aspersion soixante-dix sicles, l'argent de ces objets pesait au total deux mille quatre cents sicles, selon le sicle du sanctuaire."
,"86":"Les douze coupes d'or remplies d'encens pesaient chacune dix sicles, selon le sicle du sanctuaire. Ces coupes pesaient au total cent vingt sicles."
,"87":"Le total du bétail pour l'holocauste était de douze taureaux, douze béliers, douze agneaux d'un an avec les oblations jointes. Pour le sacrifice pour le péché il y avait douze boucs."
,"88":"Le total du bétail pour le sacrifice de communion était de vingt quatre taureaux, soixante béliers, soixante boucs, soixante agneaux d'un an. Telles furent les offrandes pour la dédicace de l'autel après sa consécration."
,"89":"Lorsque Moïse pénétrait dans la Tente du Rendez-Vous pour s'adresser à Dieu, il entendait la voix qui lui parlait du haut de l'Instrument de l'Expiation qui était sur l'Arche du Témoignage, entre les deux chérubins. Alors Moïse parlait avec Dieu."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Yahvé dit à Moïse:"
,"2":"'Voici ce que tu diras à Aaron: Lorsque tu disposeras les lampes, tu les placeras de telle sorte qu'elles donnent leur lumière sur le devant du chandelier.'"
,"3":"C'est ce que fit Aaron. Il disposa les lampes sur le devant du chandelier comme Yahvé l'avait ordonné à Moïse."
,"4":"Ce chandelier était un ouvrage en or travaillé, avec sa tige et sa corolle également en or travaillé. On avait fait le chandelier selon ce que Yahvé avait montré à Moïse."
,"5":"Yahvé dit à Moïse:"
,"6":"'Tu prendras les Lévites du milieu des Israélites et tu les purifieras."
,"7":"Voici ce que tu feras pour les purifier: tu les aspergeras avec l'eau d'expiation, et ensuite ils se raseront tout le corps, laveront leurs vêtements et se purifieront."
,"8":"Ils prendront ensuite un jeune taureau et une offrande de fleur de farine pétrie dans l'huile. Tu prendras également un second taureau tout jeune pour l'expiation."
,"9":"Alors tu feras approcher les Lévites devant la Tente du Rendez-Vous et tu réuniras toute la communauté des Israélites."
,"10":"Tu feras approcher les Lévites devant Yahvé, et les Israélites leur imposeront les mains."
,"11":"Alors, au nom des Israélites, Aaron présentera les Lévites devant Yahvé, comme on présente une offrande balancée, car ce sont eux qui assureront le service de Yahvé."
,"12":"Puis les Lévites poseront leurs mains sur la tête des jeunes taureaux. Tu immoleras le premier en sacrifice pour le péché, le second en holocauste pour faire l'expiation pour les Lévites."
,"13":"Tu placeras les Lévites devant Aaron et ses fils, puis tu les présenteras à Yahvé comme on présente une offrande balancée."
,"14":"Tu mettras ainsi les Lévites à part du reste des Israélites, et les Lévites seront à moi."
,"15":"A partir de ce moment les Lévites assureront le service dans la Tente du Rendez-Vous. Tu les purifieras et tu les présenteras comme on présente une offrande balancée "
,"16":"car ils me sont consacrés. Oui, ils m'ont été donnés du milieu des Israélites. Je les ai pris pour moi à la place de tous ceux qui sortent les premiers du sein maternel, c'est-à-dire, de tout premier-né parmi les Israélites."
,"17":"Tout premier-né parmi les Israélites m'appartient, aussi bien celui de l'homme que celui de la bête; je me les suis consacrés le jour où j'ai frappé tout premier-né au pays d'Egypte."
,"18":"Mais maintenant j'ai pris les Lévites à la place des premiers-nés des Israélites."
,"19":"Je les ai pris d'entre les Israélites et je les mets à la disposition d'Aaron et de ses fils, pour qu'ils assurent le service de la Tente du Rendez-Vous et pour qu'ils attirent la miséricorde sur les Israélites. Si les Israélites s'approchaient eux-mêmes du sanctuaire, le fléau les atteindrait.'"
,"20":"Moïse, Aaron et toute la communauté des Israélites firent pour les Lévites tout ce que Yahvé avait commandé à Moïse à ce sujet. Voilà donc ce que firent les Israélites pour les Lévites."
,"21":"Les Lévites firent leur expiation et lavèrent leurs vêtements. Aaron les présenta devant Yahvé comme on présente une offrande, puis il fit l'expiation sur eux, afin de les purifier."
,"22":"Dès ce moment les Lévites assurèrent le service dans la Tente du Rendez-Vous, devant Aaron et ses fils. On fit donc en toute chose comme Yahvé l'avait ordonné à Moïse à propos des Lévites."
,"23":"Yahvé dit à Moïse:"
,"24":"'Ceci concerne également les Lévites. A partir de l'âge de vingt-cinq ans et au-delà, le Lévite sera dans le service actif de la Tente du Rendez-Vous."
,"25":"Mais à l'âge de cinquante ans il se retirera du service actif: il n'aura plus de fonction."
,"26":"Alors il pourra aider ses frères dans la Tente du Rendez-Vous, mais il n'aura plus de fonction. Voilà comment tu agiras avec les Lévites, au sujet de leur charge.'"
}`)
	CurrentBook.AddChapter(9, `{
"1":"Au premier mois de la deuxième année après la sortie du pays d'Egypte, Yahvé dit à Moïse dans le désert du Sinaï:"
,"2":"'Les fils d'Israël célébreront la Pâque à sa date."
,"3":"Vous la célébrerez le quatorzième jour de ce mois, à la tombée du jour. Vous la célébrerez selon tous ses rites et tous ses règlements.'"
,"4":"A son tour, Moïse dit aux Israélites de célébrer la Pâque."
,"5":"Ils célébrèrent donc la Pâque dans le désert du Sinaï, le quatorzième jour du premier mois, à la tombée du jour. Les Israélites firent tout ce que Yahvé avait commandé à Moïse."
,"6":"Or, il y en eut parmi eux qui étaient impurs pour avoir touché un cadavre; ils ne purent donc célébrer la Pâque ce jour-là. Ils vinrent trouver Moïse et Aaron,"
,"7":"et ils dirent à Moïse: 'Certes, nous sommes impurs à cause de ce cadavre, quel malheur que nous ne puissions pas présenter l'offrande à Yahvé avec tous les Israélites!'"
,"8":"Moïse leur répondit: 'Restez pour que j'écoute ce que Yahvé commandera à votre sujet.'"
,"9":"Yahvé dit à Moïse:"
,"10":"'Voici ce que tu diras aux Israélites: Si quelqu'un parmi vous ou parmi vos descendants, se trouve impur à cause d'un cadavre, ou qu'il se trouve en voyage dans un pays lointain, il pourra cependant célébrer la Pâque en l'honneur de Yahvé."
,"11":"Il la célébrera au second mois, le quatorzième jour à la tombée du jour. Il la mangera avec des pains sans levain et des herbes amères;"
,"12":"on n'en laissera rien jusqu'au matin, on ne brisera aucun os; on la célébrera selon toutes les prescriptions concernant la Pâque."
,"13":"Mais si quelqu'un qui est pur et qui n'est pas en voyage ne célèbre pas la Pâque, il sera retranché de son peuple pour n'avoir pas présenté son offrande à Yahvé au temps fixé: il portera le poids de son péché."
,"14":"Si un étranger résidant au milieu de vous veut célébrer la Pâque de Yahvé, il observera les lois et les règles relatives à la Pâque. La loi sera la même pour tous, pour l'étranger comme pour l'homme du pays."
,"15":"La nuée couvrit la Demeure à partir du jour où elle fut dressée: c'est la Tente du Témoignage. Et de la tombée de la nuit jusqu'au matin il y eut comme un feu sur la Demeure."
,"16":"Il en fut ainsi continuellement: la nuée couvrait la Demeure, et la nuit c'était comme un feu."
,"17":"Lorsque la nuée s'élevait au-dessus de la Tente, les Israélites partaient, et ils établissaient leur camp là où la nuée s'arrêtait."
,"18":"Les Israélites levaient le camp sur l'ordre de Yahvé, et sur l'ordre de Yahvé ils le dressaient. Et ils campaient là aussi longtemps que la nuée reposait sur la De meure."
,"19":"Si la nuée restait longtemps sur la Demeure, les Israélites respectaient la volonté de Yahvé: ils ne levaient pas le camp."
,"20":"De même, lorsque la nuée ne restait que quelques jours sur la Demeure. Sur l'ordre de Yahvé ils dressaient le camp, et au commandement de Yahvé ils le levaient."
,"21":"Si la nuée ne se reposait que du soir au matin, dès que la nuée s'élevait le matin, ils partaient. Et si la nuée s'élevait après un jour et une nuit, dès qu'elle s'élevait ils partaient."
,"22":"Si la nuée s'arrêtait sur la Demeure plusieurs jours, un mois ou une année, les Israélites restaient là et ne levaient pas le camp. Mais dès qu'elle s'élevait, ils levaient le camp."
,"23":"Sur l'ordre de Yahvé ils dressaient le camp, et sur l'ordre de Yahvé ils levaient le camp. Ils observaient l'ordre de Yahvé, tout ce qu'il commandait à Moïse."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Yahvé dit à Moïse:"
,"2":"'Fais-toi deux trompettes d'argent. Ces trompettes d'argent martelé serviront pour convoquer la communauté et pour annoncer la levée du camp."
,"3":"Quand on en sonnera, toute la communauté se réunira autour de toi, à l'entrée de la Tente de Réunion."
,"4":"Si l'on ne sonne que d'une trompette, seulement les princes, les chefs des mille, en Israël, se rassembleront autour de toi."
,"5":"Quand vous sonnerez très fort, ceux qui campent à l'est se mettront en marche."
,"6":"Quand vous sonnerez très fort pour la seconde fois, ceux qui campent au sud se mettront en marche. On sonnera très fort pour leur départ."
,"7":"Vous sonnerez aussi pour rassembler la communauté, mais de façon plus discrète."
,"8":"Ce sont les fils d'Aaron, les prêtres, qui sonneront les trompettes: ce sera là une loi perpétuelle pour vous et pour vos descendants."
,"9":"Quand, dans votre pays, vous partirez en guerre contre un ennemi qui vous aura attaqués, vous sonnerez des trompettes avec force pour vous rappeler au souvenir de Yahvé votre Dieu, et vous serez délivrés de vos ennemis."
,"10":"Dans vos jours de joie, pour vos fêtes et vos nouvelles lunes, vous sonnerez des trompettes en offrant vos holocaustes et vos sacrifices de communion: elles seront pour vous une façon de vous rappeler à votre Dieu: je suis Yahvé votre Dieu.'"
,"11":"La seconde année, au vingtième jour du deuxième mois, la nuée s'éleva au-dessus de la Demeure du Témoignage."
,"12":"Les Israélites reprirent donc leur marche. Ils quittèrent le désert du Sinaï, et la nuée s'arrêta dans le désert de Paran."
,"13":"C'est ainsi qu'ils firent leur première étape selon l'ordre que Yahvé avait donné à Moïse."
,"14":"Le drapeau du camp des fils de Juda partit le premier, suivi des troupes. La troupe de Juda avait à sa tête Nachon, fils d'Aminadab."
,"15":"La troupe de la tribu des fils d'Issacar avait à sa tête Netanéel, fils de Souar."
,"16":"La troupe de la tribu des fils de Zabulon avait à sa tête Eliab, fils de Hélon."
,"17":"C'est alors qu'on démonta la Demeure et les fils de Guerchon partirent avec les fils de Mérari qui portaient la Demeure."
,"18":"Le drapeau du camp de Ruben partit ensuite, suivi de ses troupes. La troupe avait à sa tête Elisour, fils de Chédéour."
,"19":"La troupe de la tribu des fils de Siméon avait à sa tête Cheloumiel, fils de Surichaddaï."
,"20":"La troupe de la tribu des fils de Gad avait à sa tête Eliasaf, fils de Réouel."
,"21":"Les Kahatites partirent ensuite, emportant les objets sacrés (on devait avoir dressé la Tente avant leur arrivée)."
,"22":"Le drapeau du camp des fils d'Ephraïm partit ensuite, suivi de ses troupes. Elichama, fils d'Ammihoud, était à la tête de la troupe d'Ephraïm."
,"23":"La troupe de la tribu des fils de Manassé était commandée par Gamliel, fils de Pedahsur."
,"24":"La troupe de la tribu des fils de Benjamin avait à sa tête Abidan, fils de Gidéoni."
,"25":"Le drapeau du camp des fils de Dan partit le dernier de tous les camps, suivi de ses troupes. A la tête de sa troupe était Ahiézer, fils d'Amichaddaï."
,"26":"La troupe de la tribu des fils d'Asher avait à sa tête Pagiel, fils d'Okran."
,"27":"La troupe des fils de Nephtali avait à sa tête Ahira, fils d'Enan."
,"28":"Voilà, troupe par troupe, l'ordre de marche des Israélites lorsqu'ils partirent."
,"29":"Moïse dit à Hobab, fils de Réouel le Madianite, son beau-père: 'Nous partons pour le lieu que Yahvé a promis de nous donner: viens donc avec nous! Nous te traiterons bien, car Yahvé a promis de faire du bien à Israël."
,"30":"Hobab lui répondit: 'Je n'irai pas avec vous, je vais retourner dans mon pays et dans ma famille.'"
,"31":"Moïse lui dit: 'Ne nous quitte pas, je te prie! Tu connais les lieux où nous devrons camper dans le désert, tu seras notre oeil!"
,"32":"Si tu viens avec nous, tu auras ta part de tout le bien que Yahvé nous fera.'"
,"33":"Partis de la montagne de Yahvé, ils marchèrent trois jours, et durant ces trois jours de marche, l'Arche de l'Alliance de Yahvé s'avançait devant eux pour leur trouver un lieu de repos."
,"34":"La nuée de Yahvé était au-dessus d'eux pendant le jour, lorsqu'ils levaient le camp."
,"35":"Lorsque l'Arche partait, Moïse disait: 'Lève-toi, Yahvé! Que tes ennemis se dispersent, que ceux qui te haïssent fuient devant toi!'"
,"36":"Et lorsqu'elle s'arrêtait, il disait: 'Reviens Yahvé, vers les myriades d'Israël.'"
}`)
	CurrentBook.AddChapter(11, `{
"1":"Le peuple murmura méchamment aux oreilles de Yahvé. Yahvé l'entendit et se mit en colère: le feu de Yahvé s'alluma contre le peuple et dévora les premières tentes du camp."
,"2":"Alors le peuple supplia Moïse. Moïse intercéda auprès de Yahvé et le feu s'éteignit."
,"3":"On donna à ce lieu le nom de Tabéra car le feu de Yahvé s'y était allumé contre eux."
,"4":"Le ramassis de gens qui se trouvait au milieu des Israélites ne pensait plus qu'à la nourriture, et même les Israélites se mirent à geindre. Ils disaient: 'Qui nous fera manger de la viande?"
,"5":"Nous nous rappelons le poisson que nous mangions pour rien en Egypte, les concombres, les pastèques, les poireaux, les oignons et l'ail."
,"6":"Et maintenant, nous avons la gorge sèche, il n'y a plus rien, plus rien à l'horizon que cette manne!'"
,"7":"La manne ressemblait à la graine de coriandre, on aurait cru une pâte de guimauve."
,"8":"Les gens du peuple se dispersaient pour la ramasser, puis ils l'écrasaient entre deux meules, ou la broyaient avec un pilon. Ils la cuisaient ensuite dans un pot et en faisaient des galettes. Son goût était comme celui d'une pâte à l'huile."
,"9":"A la nuit, dès que la rosée descendait sur le camp, la manne aussi descendait."
,"10":"Moïse entendit le peuple qui pleurait, chaque famille à l'entrée de sa tente, pendant que la colère de Yahvé s'enflammait. Moïse en fut très affecté."
,"11":"Il dit à Yahvé: 'Pourquoi traites-tu si mal ton serviteur? Tu ne m'as pas fait une faveur en m'imposant la charge de tout ce peuple!"
,"12":"Est-ce moi qui lui ai donné le jour, pour que tu me dises: Porte-le sur ton sein, comme la nourrice porte son nourrisson, jusqu'au pays que tu as promis par serment à nos pères?"
,"13":"Tout ce peuple vient me trouver pour me dire: Donne-nous de la viande, nous voulons en manger? Mais où trouverai-je de la viande pour leur en donner?"
,"14":"Je ne puis à moi seul porter tout ce peuple, il est trop lourd pour moi."
,"15":"Si c'est ainsi que tu veux me traiter, tue-moi plutôt, je t'en prie, tu me feras une grâce et je ne me verrai plus dans le malheur!'"
,"16":"Yahvé répondit à Moïse: 'Rassemble-moi soixante-dix des anciens d'Israël, des hommes dont tu sais qu'ils sont des anciens et des scribes de leur peuple, et amène-les à la Tente du Rendez-Vous. Qu'ils se tiennent là à tes côtés."
,"17":"Je descendrai et je parlerai avec toi; puis je prendrai de mon esprit qui repose sur toi et je le mettrai sur eux. Avec toi ils porteront la charge du peuple, tu ne seras plus seul à la porter."
,"18":"Tu diras au peuple: Sanctifiez-vous pour demain, vous mangerez de la viande puisque vous êtes venus pleurer aux oreilles de Yahvé. Vous avez bien dit: Qui nous donnera de la viande à manger? Nous étions si bien en Egypte! Yahvé va vous donner de la viande et vous en mangerez."
,"19":"Vous n'en mangerez pas seulement un ou deux jours, ni même cinq, ou dix, ou vingt jours,"
,"20":"mais tout un mois, jusqu'à ce qu'elle vous ressorte par le nez et que vous en soyez dégoûtés. Car vous avez méprisé Yahvé qui est au milieu de vous lorsque vous êtes venus pleurer devant lui et lui dire: Pourquoi sommes-nous sortis d'Egypte?'"
,"21":"Moïse dit: 'Le peuple au milieu duquel je suis, compte six cent mille hommes de pied, et toi, tu dis: Je leur donnerai de la viande et ils en mangeront tout un mois?"
,"22":"Si on égorgeait pour eux du petit et du gros bétail, y en aurait-il assez? Si on ramassait pour eux tous les poissons de la mer, cela suffirait-il?'"
,"23":"Yahvé dit à Moïse: 'La main de Yahvé est-elle trop courte? Maintenant tu vas voir si ma parole se réalise, ou non.'"
,"24":"Moïse sortit et rapporta au peuple les paroles de Yahvé. Il rassembla soi xante-dix hommes pris parmi les anciens du peuple, ils se tenaient debout autour de la Tente."
,"25":"Alors Yahvé descendit dans la nuée et parla, puis il prit de l'esprit qui était sur Moïse et en mit sur les soixante-dix hommes, sur les anciens. Lorsque l'esprit se reposa sur eux ils prophétisèrent, mais ensuite ils ne le firent plus."
,"26":"Deux hommes étaient restés dans le camp, le premier s'appelait Eldad, le second Médad: l'esprit vint reposer sur eux. Ils étaient bien parmi les inscrits, mais ils n'étaient pas venus à la Tente, et ils prophétisèrent dans le camp."
,"27":"Un jeune homme courut pour l'annoncer à Moïse: 'Eldad et Médad, dit-il, prophétisent au milieu du camp.'"
,"28":"Josué, fils de Noun, serviteur de Moïse depuis sa jeunesse, prit la parole: 'Mon seigneur Moïse, empêche-les!'"
,"29":"Mais Moïse répondit: 'Es-tu donc jaloux pour moi? Ah! Si tout le peuple de Yahvé était prophète! Si Yahvé leur donnait à tous son esprit!'"
,"30":"Après cela Moïse revint au camp avec les anciens d'Israël."
,"31":"Le vent se leva: cela venait de Yahvé. Le vent soufflait de la mer et amenait des cailles, qu'il abattit sur le camp et autour, jusqu'à une journée de marche. Il y en avait tout autour du camp sur une épaisseur de deux coudées."
,"32":"Le peuple se leva, et toute la nuit, tout le jour suivant, il se mit à ramasser des cailles. Celui qui en avait le moins, en avait ramassé dix grandes mesures. On les étala autour du camp."
,"33":"Mais la viande était encore entre leurs dents, ils n'avaient pas fini de la mastiquer, que déjà la colère de Yahvé s'enflammait contre le peuple. Yahvé frappa le peuple d'un grand coup."
,"34":"On donna à ce lieu le nom de Kibrot-Ha-Taava, car c'est là qu'on enterra ceux qui s'étaient jetés comme des affamés sur la nourriture."
,"35":"De Kibrot-Ha-Taava, le peuple partit pour Hasérot. Comme on campait là à Hasérot..."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Miryam et Aaron murmurèrent contre Moïse parce qu'il avait pris une femme Kouchite (il avait en effet épousé une femme du pays de Kouch)."
,"2":"'Est-ce que Yahvé, dirent-ils, ne parlerait que par Moïse? N'a-t-il pas aussi parlé par nous?' Yahvé l'entendit."
,"3":"Or Moïse était un homme très humble. Il n'y avait pas plus humble que lui sur toute la terre."
,"4":"Soudain Yahvé dit à Moïse, à Aaron et à Miryam: 'Sortez du camp tous les trois et allez à la Tente du Rendez-Vous!' Ils sortirent donc tous les trois."
,"5":"Alors Yahvé descendit dans la colonne de nuée et se tint à l'entrée de la Tente. Il appela Aaron et Miryam qui s'avancèrent tous les deux."
,"6":"Puis Yahvé leur dit: 'Ecoutez bien mes paroles: S'il y a au milieu de vous un prophète, je me manifeste à lui à travers des visions, je ne lui parle qu'en songes."
,"7":"Il n'en va pas de même pour mon serviteur Moïse; je lui ai confié toute ma Maison"
,"8":"et je lui parle face à face. C'est la claire vision, non pas des énigmes; lui contemple l'image de Yahvé. Comment donc n'avez-vous pas craint de parler contre mon serviteur, contre Moïse?'"
,"9":"La colère de Yahvé s'enflamma contre eux et il se retira."
,"10":"Lorsque la nuée se retira d'au-dessus de la Tente, Miryam avait la lèpre: sa peau était blanche comme la neige. Aaron se tourna vers Miryam, elle était lépreuse!"
,"11":"Alors Aaron dit à Moïse: 'Je t'en supplie mon seigneur, ne nous fais pas payer ce péché, cette folie qui nous a pris."
,"12":"Qu'elle ne soit pas comme l'avorton dont le corps est à moitié ravagé, à peine sorti du sein de sa mère.'"
,"13":"Alors Moïse supplia Yahvé: 'Je t'en supplie, arrête! Guéris-la!'"
,"14":"Mais Yahvé répondit à Moïse: 'Si son père lui crachait au visage, elle devrait se cacher de honte durant sept jours. Qu'elle soit donc exclue du camp pour sept jours, après quoi elle reviendra.'"
,"15":"Miryam fut donc exclue du camp durant sept jours, et le peuple ne partit que lorsque Miryam fut revenue."
,"16":"Alors le peuple partit de Hasérot et campa dans le désert de Paran."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Yahvé dit à Moïse:"
,"2":"'Envoie des hommes en avant pour qu'ils explorent ce pays de Canaan que je donne aux Israélites. Chaque tribu enverra en son nom l'un de ses chefs.'"
,"3":"Moïse les envoya donc depuis le désert de Paran sur l'ordre de Yahvé. Tous ces hommes étaient chefs en Israël."
,"4":"Voici leurs noms, Pour la tribu de Ruben, Chammoua, fils de Zakour;"
,"5":"pour la tribu de Siméon, Chafat, fils de Hori;"
,"6":"pour la tribu de Juda, Caleb, fils de Yéfouné;"
,"7":"pour la tribu d'Issacar, Yiguéal, fils de Yosef;"
,"8":"pour la tribu d'Ephraïm, Hochéa, fils de Noun;"
,"9":"pour la tribu de Benjamin, Palti, fils de Rafou;"
,"10":"pour la tribu de Zabulon, Gadiel, fils de Sodi;"
,"11":"pour la tribu de Joseph, pour la tribu de Manassé, Gadi, fils de Sousi;"
,"12":"pour la tribu de Dan, Ammiel, fils de Gémali;"
,"13":"pour la tribu d'Asher, Sétour, fils de Mikaël;"
,"14":"pour la tribu de Nephtali, Nahbi, fils de Vafsi;"
,"15":"pour la tribu de Gad, Géouel, fils de Maki."
,"16":"Ce sont là les noms des hommes que Moïse envoya pour explorer le pays de Canaan (à Hochéa, Moïse donna le nom de Josué)."
,"17":"Moïse les envoya donc pour explorer le pays de Canaan. Il leur dit: 'Montez par le Négueb, puis passez à la montagne."
,"18":"Regardez bien comment est le pays et quelle est la population qui l'habite: si elle est forte ou faible, peu nombreuse ou importante."
,"19":"Regardez comment est ce pays où ils vivent; s'il est bon ou mauvais. Comment sont les villes où ils habitent: s'agit-il de camps ou de villes fortifiées?"
,"20":"Regardez comment est la terre, si elle est riche ou pauvre, s'il y a des arbres ou non. Et vous n'aurez pas peur de nous rapporter des fruits de la terre.' Car c'était la saison des premiers raisins."
,"21":"Ils partirent donc pour explorer le pays, depuis le désert de Tsin jusqu'à Réhob, vers l'Entrée de Hamat."
,"22":"Ils montèrent par le Négueb et arrivèrent à Hébron, où se trouvaient Ahiman, Chéchaï et Talmaï, de la race des Anakim. Hébron avait été fondée sept ans avant la ville de Tanis, en Egypte."
,"23":"Ils parvinrent donc au val d'Echkol, où ils coupèrent un sarment et une grappe de raisin qu'ils emportèrent à deux sur une perche, avec des grenades et des figues."
,"24":"On appela ce lieu le vallon d'Echkol, à cause de la grappe que les Israélites y avaient cueillie."
,"25":"Au bout de quarante jours, ils revinrent de leur inspection dans ce pays."
,"26":"Dès leur retour, ils se présentèrent à Moïse, à Aaron et à toute la communauté des Israélites, à Qadesh, dans le désert de Paran. Ils firent leur compte-rendu devant toute la communauté et lui montrèrent les fruits du pays."
,"27":"Voici ce qu'ils racontèrent: 'Nous sommes entrés au pays où tu nous avais envoyés. C'est véritablement un pays où ruissellent le lait et le miel: en voici les fruits!"
,"28":"Mais le peuple qui habite ce pays est très fort. Les villes sont très grandes et fortifiées, nous y avons même vu des descendants d'Anak."
,"29":"Amalec habite le Négueb; le Hittite, le Jébusite et l'Amorite habitent la montagne; le Cananéen est installé près de la mer et sur les rives du Jourdain.'"
,"30":"Caleb calma le peuple qui s'en prenait à Moïse. 'Montons, dit-il, et conquérons le pays, car nous en sommes bien capables.'"
,"31":"Mais les hommes qui étaient montés avec lui répliquèrent: 'Nous ne pouvons attaquer ce peuple, car il est trop fort pour nous.'"
,"32":"Et ils se mirent à décrier le pays qu'ils avaient visité. Ils dirent aux Israélites: 'Le pays que nous avons exploré, est un pays qui dévore ses habitants. Les hommes qui l'habitent sont de très grande taille."
,"33":"Et nous y avons même vu des géants. A côté d'eux nous avions l'impression d'être des sauterelles et c'est ainsi qu'ils nous voyaient.'"
}`)
	CurrentBook.AddChapter(14, `{
"1":"Toute la communauté se mit à pousser des cris déchirants, et le peuple passa toute sa nuit à pleurer."
,"2":"Les Israélites s'emportèrent contre Moïse et Aaron, et toute la communauté leur dit: 'Pourquoi ne sommes-nous pas morts en Egypte? Pourquoi ne sommes-nous pas morts dans ce désert?"
,"3":"Pourquoi Yahvé nous conduit-il vers ce pays? Pour y être tués par l'épée et pour que nos femmes et nos petits-enfants deviennent des esclaves? Ne vaudrait-il pas mieux pour nous retourner en Egypte?'"
,"4":"Et ils se disaient l'un à l'autre: 'Donnons-nous un chef et retournons en Egypte.'"
,"5":"Moïse et Aaron tombèrent la face contre terre en présence de toute la communauté des Israélites."
,"6":"Quant à Josué, fils de Noun, et Caleb, fils de Yéfouné, qui faisaient partie des espions, ils déchirèrent leurs habits."
,"7":"Puis ils s'adressèrent à toute la communauté des Israélites: 'Le pays par où nous sommes passés, et que nous avons exploré est bon! C'est une terre excellente!"
,"8":"Si Yahvé nous veut du bien, il nous mènera vers ce pays et il nous donnera cette terre qui ruisselle de lait et de miel."
,"9":"Mais ne vous révoltez pas contre Yahvé! N'ayez pas peur de la population de ce pays, car ils nous seront livrés en pâture. Ils n'ont plus rien à espérer, car Yahvé est avec nous. N'ayez donc pas peur d'eux.'"
,"10":"Toute la communauté parlait de les lapider, lorsque la Gloire de Yahvé apparut devant les Israélites, dans la Tente du Rendez-Vous."
,"11":"Yahvé dit à Moïse: 'Combien de temps encore ce peuple va-t-il me mépriser? Jusques à quand manquera-t-il de confiance en moi après tous les signes que j'ai faits au milieu de lui?"
,"12":"Je veux le frapper de la peste et l'exterminer, puis je ferai sortir de toi une nation plus grande et plus puissante que lui.'"
,"13":"Moïse dit à Yahvé: 'Les Egyptiens savent avec quelle force tu as fait monter ce peuple de chez eux"
,"14":"et ils l'ont dit aux habitants de ce pays. Ces gens savent que tu es au milieu de ce peuple, toi Yahvé qui lui es apparu face à face, toi Yahvé qui te tiens au milieu d'eux dans la nuée, qui marches devant eux dans une colonne de nuée le jour et dans une colonne de feu la nuit."
,"15":"Et aujourd'hui tu voudrais faire mourir ce peuple comme un seul homme?,Mais alors les nations qui ont entendu parler de toi vont dire: "
,"16":"Yahvé n'était pas capable de conduire ce peuple au pays qu'il avait juré de leur donner, c'est pourquoi il les a tués dans le désert."
,"17":"Montre plutôt ta force, Mon Seigneur! Tu as bien dit:"
,"18":"Yahvé est patient et riche en miséricorde. Il supporte la faute et le péché, et cependant il ne laisse pas passer la faute, car il punit la faute des pères sur leurs fils, leurs petits-fils et leurs arrière-petits-fils."
,"19":"Pardonne donc la faute de ce peuple avec cette grande miséricorde et cette patience que tu as eue envers lui, depuis sa sortie d'Egypte jusqu'à aujourd'hui.'"
,"20":"Yahvé répondit: 'Comme tu l'as demandé, je pardonne."
,"21":"Mais aussi vrai que je suis vivant, et que la Gloire de Yahvé remplit la terre entière,"
,"22":"malheur à tous ces hommes! Car ils ont vu ma Gloire et mes signes, ils ont vu ce que j'ai fait en Egypte et dans le désert, et malgré cela ils m'ont mis à l'épreuve plus de dix fois et ne m'ont pas écouté."
,"23":"C'est pourquoi ils ne verront pas le pays que j'ai promis à leurs pères par serment; aucun de ceux qui me méprisent ne le verra."
,"24":"Mais je ferai entrer mon serviteur Caleb, dans ce pays où il est déjà entré, et je le donnerai à sa postérité, car il a un tout autre esprit et il m'a suivi sans hésiter."
,"25":"Maintenant, comme Amalec et Canaan habitent la vallée, faites demi-tour demain et repartez vers le désert, sur la route de la mer des Joncs.'"
,"26":"Yahvé dit à Moïse et Aaron:"
,"27":"'Combien de temps cela va-t-il durer, cette méchante communauté et ces gens qui murmurent contre moi? Oui, j'ai entendu leurs murmures, les murmures des Israélites contre moi."
,"28":"Dis-leur: Aussi vrai que Yahvé est vivant, je vais vous prendre au mot, et comme vous venez de le dire à mes oreilles,"
,"29":"c'est dans ce désert que tomberont vos cadavres. Tous autant que vous êtes, vous avez murmuré contre moi: eh bien, vous tous que l'on a recensés, depuis l'âge de vingt ans et au-dessus,"
,"30":"vous n'entrerez pas dans le pays que j'ai juré par serment de vous donner. Il n'y aura d'exception que pour Caleb, fils de Yéfouné, et Josué, fils de Noun."
,"31":"Ce sont vos petits-enfants que je ferai entrer, ceux dont vous avez dit qu'ils seraient livrés en esclavage; eux connaîtront le pays que vous avez méprisé."
,"32":"Vos cadavres à vous, tomberont dans le désert,"
,"33":"et vos fils seront des nomades dans le désert pendant quarante ans. Ils porteront le poids de votre infidélité jusqu'à ce que le désert ait recueilli la totalité de vos cadavres."
,"34":"Vous avez mis quarante jours à explorer le pays; chaque jour comptera pour une année. Vous porterez donc le poids de votre péché pendant quarante ans et vous saurez ce qu'est ma colère!"
,"35":"Voilà comment je traiterai cette méchante communauté qui s'est liguée contre moi. C'est moi, Yahvé, qui le dis: dans ce désert ils disparaîtront, c'est là qu'ils mourront.'"
,"36":"Ces hommes que Moïse avait envoyés pour explorer le pays et qui, à leur retour, avaient dressé contre lui toute la communauté en décriant le pays,"
,"37":"ces hommes qui avaient critiqué le pays avec un mauvais esprit, moururent d'un fléau devant Yahvé."
,"38":"Josué, fils de Noun et Caleb, fils de Yéfouné, furent les seuls à survivre parmi tous ceux qui étaient allés explorer le pays."
,"39":"Moïse rapporta tout cela aux Israélites et le peuple en fut consterné."
,"40":"De bon matin ils décidèrent de gravir la montagne; car ils disaient: 'Nous avons péché! Il nous faut monter à cet endroit que Yahvé nous a promis.'"
,"41":"Mais Moïse leur dit: 'Voulez-vous de nouveau désobéir aux ordres de Yahvé? Vous ne réussirez pas."
,"42":"Ne montez pas, car Yahvé n'est pas au milieu de vous; ne vous exposez donc pas aux coups de vos ennemis."
,"43":"Amalec et Canaan sont là devant vous et vous périrez par l'épée, parce que vous vous êtes détournés de Yahvé et Yahvé ne sera pas avec vous.'"
,"44":"Ils s'obstinèrent cependant à monter au sommet de la montagne, alors que l'Arche de l'Alliance de Yahvé et Moïse restaient à l'intérieur du camp."
,"45":"Mais Amalec et Canaan descendirent de leur montagne; ils les battirent et les écrasèrent jusqu'à Horma."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Yahvé dit à Moïse"
,"2":"pour qu'il le répète aux Israélites: 'Ceci vaudra quand vous serez entrés dans le pays où vous allez habiter, le pays que je vous donne."
,"3":"Alors vous offrirez à Yahvé des sacrifices par le feu, holocaustes ou sacrifices de communion, vous lui offrirez des sacrifices d'agréable odeur, de gros ou de petit bétail, à l'occasion d'un voeu ou d'une fête, ou comme offrandes volontaires."
,"4":"Celui qui offre un sacrifice à Yahvé présentera une offrande d'un dixième de fleur de farine trempée dans un quart de mesure d'huile"
,"5":"et un quart de mesure de vin pour la libation; tu ajouteras cela à l'holocauste ou au sacrifice de chaque agneau."
,"6":"Si c'est un bélier, l'offrande sera de deux dixièmes de fleur de farine trempée dans un tiers de mesure d'huile,"
,"7":"et d'un tiers de mesure de vin pour la libation. Ce sera un sacrifice d'agréable odeur à Yahvé."
,"8":"Lorsque tu offriras en sacrifice un jeune taureau, soit pour un holocauste, soit pour un sacrifice de communion soit pour accomplir un voeu ou comme offrande pacifique à Yahvé,"
,"9":"tu présenteras, en plus du jeune taureau, une offrande de trois mesures de fleur de farine trempée dans une demi-mesure d'huile,"
,"10":"et tu offriras une demi-mesure de vin pour la libation. Ce sera un sacrifice par le feu, d'agréable odeur à Yahvé."
,"11":"On suivra cette règle pour chaque taureau, pour chaque bélier, pour chaque agneau ou chaque chevreau."
,"12":"Elle vaudra pour chacune des victimes, quel qu'en soit le nombre."
,"13":"Toute personne née dans le pays observera cette règle lorsqu'elle offrira à Yahvé un sacrifice par le feu d'agréable odeur."
,"14":"De même l'étranger et toute personne qui habite au milieu de vous: il suivra comme vous cette règle lorsqu'il offrira à Yahvé un sacrifice par le feu d'agréable odeur, et cela, de génération en génération."
,"15":"La règle sera la même pour toute la communauté, pour vous comme pour l'étranger qui habite au milieu de vous: ce sera une loi perpétuelle pour vos descendants; Yahvé ne fera pas de différence entre l'étranger et vous-mêmes."
,"16":"Il n'y aura qu'une loi et une règle, pour vous comme pour l'étranger qui habite au milieu de vous.'"
,"17":"Yahvé dit à Moïse:"
,"18":"'Voici ce que tu diras aux Israélites: Quand vous serez entrés dans le pays où je vous conduis"
,"19":"et que vous mangerez du pain de ce pays, vous en prélèverez une part pour Yahvé."
,"20":"Vous prélèverez un gâteau que vous mettrez de côté, à titre de prémices sur la pâte, comme vous le faites lorsque vous mettez de côté une part sur la moisson que vous battez."
,"21":"De génération en génération vous donnerez à Yahvé une part: ce seront les prémices de votre pâte."
,"22":"Supposez qu'on ait péché par erreur en n'obéissant pas à tous les ordres que Yahvé avait donnés à Moïse"
,"23":"(à tous ces ordres que Yahvé avait donnés pour la suite des âges, et qu'il avait commandés par la bouche de Moïse)."
,"24":"On a agi par mégarde et la communauté ne s'en est pas aperçue. Alors, toute la communauté présentera à Yahvé en sacrifice un jeune taureau, pour un holocauste d'agréable odeur, avec une oblation et une libation comme la règle le prévoit. Ensuite elle présentera un bouc pour l'expiation."
,"25":"Le prêtre fera alors l'expiation sur toute la communauté des Israélites et il leur sera pardonné. En effet, ils avaient agi par erreur, et pour leur faute ils ont apporté une offrande, un sacrifice par le feu en l'honneur de Yahvé, ainsi qu'un sacrifice expiatoire devant Yahvé."
,"26":"Il sera donc pardonné à toute la communauté des Israélites, ainsi qu'à l'étranger qui habite au milieu d'elle, puisque c'est par erreur que le peuple a péché."
,"27":"Si une personne pèche par erreur, elle offrira en réparation une chevrette d'un an."
,"28":"Le prêtre fera l'expiation devant Yahvé, sur cette personne, et grâce à cette expiation, il lui sera pardonné."
,"29":"Qu'il s'agisse d'un Israélite ou d'un étranger habitant au milieu de vous, la loi sera la même pour le péché par erreur."
,"30":"Mais si quelqu'un, Israélite ou étranger, pèche de façon consciente, il insulte Yahvé; il sera retranché du milieu du peuple."
,"31":"S'il méprise la parole de Yahvé et viole son commandement, il devra être retranché, il portera le poids de sa faute."
,"32":"Lorsque les Israélites étaient au désert, ils virent un homme qui ramassait du bois un jour de sabbat."
,"33":"Ceux qui l'avaient trouvé en train de ramasser du bois le conduisirent à Moïse, Aaron et toute la communauté."
,"34":"On le plaça sous bonne garde, car on ne savait pas ce que l'on ferait de lui."
,"35":"Alors Yahvé dit à Moïse: 'Cet homme doit être mis à mort. Toute la communauté le lapidera à coups de pierre hors du camp.'"
,"36":"Toute la communauté le conduisit donc hors du camp, et on le tua à coups de pierre. Il mourut donc comme Yahvé l'avait ordonné à Moïse."
,"37":"Yahvé dit à Moïse:"
,"38":"'Voici ce que tu diras aux Israélites: faites-vous une frange aux pans de vos habits, et cela, de génération en génération. Mettez sur la frange un fil de pourpre violette."
,"39":"Ce sera votre frange et lorsque vous la verrez, vous vous rappellerez tous les commandements de Yahvé. Ainsi vous les mettrez en pratique et vous ne suivrez pas les mauvais penchants de votre coeur ou de vos yeux qui vous entraînent vers l'infidélité."
,"40":"Ainsi vous vous souviendrez de tous mes commandements, vous les mettrez en pratique et vous serez saints devant votre Dieu:"
,"41":"je suis Yahvé votre Dieu, c'est moi qui vous ai fait sortir du pays d'Egypte pour être votre Dieu. Je suis Yahvé votre Dieu!"
}`)
	CurrentBook.AddChapter(16, `{
"1":"Coré fils d'Yichar, fils de Kahat, fils de Lévi et aussi Datan et Abiram, fils d'Eliab, et On, fils de Pélet, de la tribu de Ruben"
,"2":"se révoltèrent contre Moïse. Deux cent cinquante Israélites, tous chefs de la communauté, membres du conseil et personnages connus, les suivirent."
,"3":"Ils s'attroupèrent donc contre Moïse et Aaron: 'Cela commence à bien faire, dirent-ils; tous les membres de la communauté ne sont-ils pas consacrés? Et Yahvé, n'est-il pas au milieu de nous? Pourquoi donc vous mettez-vous au-dessus de la communauté de Yahvé?'"
,"4":"En entendant cela, Moïse tomba la face contre terre."
,"5":"Puis, s'adressant à Coré et à toute sa bande, il leur dit: 'Demain matin Yahvé fera connaître qui est à lui et qui lui est consacré et peut s'approcher de lui. Lui-même fera approcher de lui celui qu'il a choisi."
,"6":"Vous prendrez vos encensoirs, toi Coré et toute ta bande;"
,"7":"dès demain, vous y mettrez du feu et, arrivés devant Yahvé, de l'encens. Celui que Yahvé indiquera, c'est lui qui est consacré. Vous passez les bornes, fils de Lévi!'"
,"8":"Moïse dit à Coré: 'Ecoutez-moi bien, fils de Lévi!"
,"9":"Est-ce trop peu pour vous que le Dieu d'Israël vous ait mis à part dans la communauté des Israélites, qu'il vous aie fait approcher de lui pour le service de la Demeure de Yahvé, pour assurer le culte au nom de la communauté?"
,"10":"Il vous a fait approcher, toi et tous tes frères, les fils de Lévi, et vous réclamez encore la prêtrise?"
,"11":"C'est bien pour cela, n'est-ce pas, que toi et toute ta bande vous vous attroupez contre Yahvé? Et Aaron, qui est-il pour que vous murmuriez contre lui?'"
,"12":"Moïse envoya chercher Datan et Abiram, fils d'Eliab. Mais ils répondirent: 'Nous ne viendrons pas!"
,"13":"Cela ne te suffit donc pas de nous avoir fait sortir d'un pays où coulaient le lait et le miel, pour nous faire mourir dans ce désert? Et tu veux faire le chef?"
,"14":"Crois-tu nous avoir amenés dans un pays où coulent le lait et le miel? Tu ne nous as donné, ni champ ni vigne. Prends-tu donc tous ces gens pour des aveugles? Non, nous ne viendrons pas!'"
,"15":"Très en colère, Moïse dit à Yahvé: 'Ne regarde pas leur offrande, je ne leur ai rien pris, pas même un âne, et je n'ai fait de tort à aucun d'entre eux.'"
,"16":"Moïse dit à Coré: 'Trouvez-vous demain devant Yahvé, toi et toute ta bande, avec Aaron."
,"17":"Prenez chacun votre encensoir et mettez dedans de l'encens, puis chacun fera l'encensement devant Yahvé (deux cent cinquante encensoirs!) Toi et Aaron, vous aurez aussi chacun votre encensoir.'"
,"18":"Chacun prit donc son encensoir, mit du feu et de l'encens et se présenta à l'entrée de la Tente du Rendez-Vous, avec Moïse et Aaron."
,"19":"Comme Coré ameutait contre eux toute la communauté à l'entrée de la Tente du Rendez-Vous, la Gloire de Yahvé se manifesta à toute la communauté."
,"20":"Alors Yahvé dit à Moïse et Aaron:"
,"21":"'Séparez-vous de cette communauté, car je vais l'exterminer sur le champ.'"
,"22":"Ils tombèrent la face contre terre et dirent: 'Dieu! Dieu des esprits de tout homme! Si un seul homme a péché, te mettrais-tu en colère contre toute la communauté?'"
,"23":"Yahvé répondit à Moïse:"
,"24":"'Dis à la communauté de s'éloigner des demeures (de Coré,) de Datan et d'Abiram.'"
,"25":"Moïse s'avança vers Datan et Abiram; les anciens d'Israël le suivaient."
,"26":"Il s'adressa à la communauté: 'Ecartez-vous donc des tentes de ces hommes pervers! Ne touchez à rien de ce qui leur appartient, autrement vous allez mourir à cause de tous leurs péchés.'"
,"27":"Ils s'éloignèrent donc (des demeures de Coré, de Datan et d'Abiram,) tandis que Datan et Abiram sortaient sur le devant de leur tente avec leurs femmes, leurs fils et tous les petits-enfants."
,"28":"Moïse dit: 'Vous saurez maintenant que Yahvé m'a envoyé pour accomplir tous ces signes et que cela ne vient pas de moi."
,"29":"Si ces hommes meurent d'une mort ordinaire, et connaissent le sort de n'importe qui, c'est que Yahvé ne m'a pas envoyé."
,"30":"Mais si Yahvé opère un miracle, si le sol s'ouvre tout grand pour les engloutir avec tout ce qui leur appartient, s'ils descendent vivants au séjour des morts, alors vous saurez que ces hommes ont méprisé Yahvé.'"
,"31":"Il parlait encore que la terre s'ouvrit au-dessous d'eux."
,"32":"Elle ouvrit sa gueule et les avala avec toute leur famille (tous les hommes de la bande de Coré), avec tout ce qui leur appartenait."
,"33":"Ils descendirent vivants au séjour des morts, eux et tous ceux qui étaient avec eux. La terre les recouvrit et ils disparurent, à la vue de la communauté."
,"34":"Tous les Israélites qui étaient autour d'eux s'enfuirent, car ils disaient: 'Pourvu que la terre ne nous avale pas!'"
,"35":"Alors un feu de Dieu sortit, qui dévora les deux cent cinquante hommes qui présentaient l'encens."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Yahvé dit à Moïse:"
,"2":"'Voici ce que tu diras à Eléazar, fils d'Aaron le prêtre: Retire les encensoirs d'entre les flammes et jettes-en le feu au loin, car ils sont consacrés."
,"3":"Les encensoirs de ces hommes qui ont péché et qui en sont morts, te serviront pour faire les plaques du revêtement de l'autel. Ces encensoirs sont saints, puisqu'ils ont été en contact avec Yahvé. Ils seront un signe pour les Israélites.'"
,"4":"Eléazar, le prêtre, prit donc les encensoirs de cuivre qui appartenaient à ceux qui avaient été brûlés, et on en fit des plaques pour le revêtement de l'autel."
,"5":"Elles sont là pour rappeler aux Israélites que personne qui soit étranger à la race d'Aaron, ne peut s'approcher pour faire fumer l'encens devant Yahvé. Sinon, il aura le sort de Coré et de sa bande que Yahvé avait avertis par la voix de Moïse."
,"6":"Le lendemain, toute la communauté des Israélites murmura contre Moïse et Aaron: 'C'est vous, dirent-ils, qui avez fait mourir le peuple de Yahvé!'"
,"7":"Tandis que la communauté s'attroupait contre Moïse et Aaron, ils se tournèrent vers la Tente du Rendez-Vous: la nuée l'avait couverte et la Gloire de Yahvé apparut."
,"8":"Alors Moïse et Aaron s'approchèrent de la Tente"
,"9":"et Yahvé dit à Moïse:"
,"10":"'Retirez-vous du milieu de cette communauté, et je vais l'exterminer sur le champ!' Ils tombèrent la face contre terre."
,"11":"Moïse dit alors à Aaron: 'Prends ton encensoir, mets dedans du feu de l'autel, dispose l'encens par-dessus et cours vers la communauté avec ton encensoir. Tu feras l'expiation pour eux, car la colère de Yahvé s'est déchaînée et le châtiment commence.'"
,"12":"Aaron fit comme Moïse avait dit, et il courut vers la communauté. Déjà le fléau frappait le peuple. Aaron disposa l'encens et fit l'expiation sur le peuple;"
,"13":"il se tint debout entre les morts et les vivants, et le fléau s'arrêta."
,"14":"Ceux qui moururent frappés par le châtiment étaient au nombre de quatorze mille sept cents, sans compter ceux qui étaient morts à cause de Coré."
,"15":"Lorsqu'Aaron revint vers Moïse, à l'entrée de la Tente du Rendez-Vous, le fléau avait cessé."
,"16":"Yahvé dit à Moïse:"
,"17":"'Dis aux Israélites de t'apporter une baguette par tribu, une baguette de la part de chacun des chefs de tribu. Cela fera donc douze baguettes et tu écriras le nom de chacun sur sa baguette."
,"18":"Sur la baguette de Lévi, tu écriras le nom d'Aaron, car il n'y aura qu'une baguette par tribu."
,"19":"Tu les déposeras dans la Tente devant le Témoignage, là où je vous donne rendez-vous,"
,"20":"et celui dont la baguette fleurira, c'est lui que j'ai choisi. Ainsi j'en finirai avec toutes ces plaintes des Israélites contre moi - je parle de leurs plaintes contre vous.'"
,"21":"Moïse transmit ces paroles aux Israélites et chacun des chefs lui donna une baguette. Chaque tribu avait sa baguette, que portait son chef, soit douze baguettes. La baguette d'Aaron était avec les autres."
,"22":"Moïse déposa ces baguettes devant Yahvé dans la Tente du Témoignage."
,"23":"Le lendemain, lorsque Moïse entra dans la Tente du Témoignage, la baguette de la tribu de Lévi apportée par Aaron avait fleuri: des boutons étaient apparus, des fleurs étaient écloses et les amandes avaient mûri."
,"24":"Moïse retira donc toutes les baguettes de devant Yahvé et les apporta aux Israélites. Ils les virent et chacun reprit sa baguette."
,"25":"Yahvé dit alors à Moïse: 'Remets la baguette d'Aaron devant le Témoignage; elle y restera et ce sera un avertissement pour les rebelles. Ainsi tu éloigneras de moi leurs murmures et ils ne mourront pas.'"
,"26":"Moïse fit comme Yahvé le lui avait ordonné."
,"27":"Les Israélites dirent à Moïse: 'Nous mourons, nous sommes perdus! Nous allons tous mourir!"
,"28":"En effet, quiconque s'approche de la Demeure de Yahvé en meurt. Allons-nous tous mourir ainsi?'"
}`)
	CurrentBook.AddChapter(18, `{
"1":"Yahvé dit à Aaron: 'Toi, tes fils et ta tribu avec toi, vous portez la responsabilité du sanctuaire. Toi et tes fils avec toi, vous portez la responsabilité du sacerdoce."
,"2":"Tu feras donc participer au culte les Lévites: ils sont tes frères, de la tribu de ton père. Ils seront tes aides et t'assisteront lorsque toi et tes fils vous servirez dans la Tente du Témoignage."
,"3":"Ils vous seront associés pour tout le service de la Tente, mais ils n'approcheront pas des objets sacrés, ni de l'autel, autrement ce serait la mort pour eux et pour vous."
,"4":"Ils se joindront à vous pour le service de la Tente du Rendez-Vous, pour tout ce qui concerne le service de la Tente, mais aucun profane ne se joindra à vous."
,"5":"C'est vous qui assurerez le service du sanctuaire et celui de l'autel. Ainsi la colère de Dieu ne se déchaînera plus contre les Israélites."
,"6":"J'ai choisi moi-même vos frères les Lévites du milieu des Israélites pour vous les donner. Ils sont donnés à Dieu pour le service de la Tente du Rendez-Vous."
,"7":"Toi, et tes fils avec toi, vous remplirez votre ministère en tout ce qui concerne l'autel et ce qui se passe derrière le rideau. Vous en assurerez le service et ce sacerdoce est un don que je vous fais; l'étranger qui voudrait s'en mêler sera mis à mort.'"
,"8":"Yahvé dit à Aaron: 'Je te remets la part qu'on prélève pour moi sur toutes les offrandes des Israélites. Je te la donne en raison de la consécration que toi et tes fils vous avez reçue: c'est une loi perpétuelle."
,"9":"Voici ce qui te reviendra de tout ce qui est offert et consacré: toutes les offrandes, c'est-à-dire toutes les oblations, tous les sacrifices pour le péché et tous les sacrifices de réparation qui seront offerts; tout cela sera chose très sainte et sera pour toi et pour tes fils."
,"10":"Tu le mangeras dans un lieu très saint. Tout mâle en mangera; tu le considéreras comme une chose sainte."
,"11":"Sera encore pour toi ce qu'on prélève sur les offrandes des Israélites, sur toute offrande balancée; je te le donne à toi, à tes fils et à tes filles en loi perpétuelle. Quiconque est pur dans ta maison, pourra en manger."
,"12":"Et je te donne les prémices que les Israélites présentent à Yahvé, le meilleur de l'huile, du vin nouveau et du blé."
,"13":"Je te donne les premiers produits de la terre qu'ils apporteront à Yahvé. Quiconque est pur dans ta maison pourra en manger."
,"14":"Tout ce qui sera voué par anathème en Israël, sera pour toi."
,"15":"Le premier-né de tout être vivant, des hommes comme des animaux offerts à Yahvé, sera pour toi. Seulement tu feras racheter le premier-né de l'homme, ainsi que le premier-né d'un animal impur."
,"16":"Le rachat se fera à partir de l'âge d'un mois, tu en feras l'estimation à cinq sicles d'argent comptés selon le sicle du sanctuaire, c'est-à-dire vingt guéras."
,"17":"Mais tu ne feras pas racheter le premier-né de la vache, ni le premier-né de la brebis, ni le premier-né de la chèvre: ils sont consacrés. Tu répandras donc leur sang sur l'autel, et tu feras fumer leur graisse en sacrifice par le feu d'agréable odeur à Yahvé."
,"18":"Leur viande sera pour toi ainsi que la poitrine que l'on aura balancée et le gigot droit."
,"19":"Tout ce qui aura été prélevé sur les offrandes faites par les Israélites à Yahvé, sera autant de parts saintes; je te les donne à toi, à tes fils et à tes filles: c'est une loi perpétuelle. C'est une alliance éternelle par le sel devant Yahvé, pour toi et pour toute ta descendance avec toi.'"
,"20":"Yahvé dit encore à Aaron: 'Tu n'auras pas d'héritage dans le pays et il n'y aura pas de part pour toi au milieu de ton peuple. Car je suis, moi, ta part et ton héritage au milieu des Israélites."
,"21":"Et aux fils de Lévi je donne comme un héritage, toute dîme en Israël, en échange du service qu'ils font, c'est-à-dire le service de la Tente du Rendez-Vous."
,"22":"Les Israélites n'approcheront pas de la Tente, sous peine de commettre une faute grave."
,"23":"Ce sont les Lévites qui assureront le service de la Tente du Rendez-Vous et porteront la faute s'il y en a une: c'est une règle perpétuelle, de génération en génération. C'est pourquoi ils n'auront pas d'héritage au milieu des Israélites."
,"24":"La dîme que les Israélites prélèveront en l'honneur de Yahvé, je la donne aux Lévites comme leur part d'héritage. C'est pourquoi je leur ai dit qu'ils n'auraient pas d'héritage au milieu des Israélites.'"
,"25":"Yahvé dit à Moïse:"
,"26":"'Tu diras ceci aux Lévites: Lorsque vous percevrez sur les Israélites la dîme que je vous donne en héritage, vous en prélèverez une part pour Yahvé: ce sera la dîme de la dîme."
,"27":"Cette part que vous prélèverez, vous sera comptée comme on compte le blé de l'aire ou le vin nouveau de la cuve."
,"28":"Ainsi, vous aussi, vous prélèverez une offrande pour Yahvé sur toutes les dîmes que vous recevrez des Israélites et vous donnerez cette part à Aaron le prêtre."
,"29":"Sur tous les dons que vous recevrez, vous prélèverez une part pour Yahvé, le meilleur de tout ce qui est consacré."
,"30":"Tu leur diras encore: Lorsque vous aurez prélevé le meilleur, le reste de la dîme sera pour les Lévites comme le blé de l'aire et comme le produit du pressoir."
,"31":"Vous pourrez le manger en n'importe quel lieu, vous et votre famille: c'est votre salaire pour le service que vous accomplissez dans la Tente du Rendez-Vous."
,"32":"Si vous en avez prélevé le meilleur, vous ne commettrez aucun péché à ce sujet. Veillez donc à ne pas profaner les offrandes saintes des Israélites et vous ne mourrez pas.'"
}`)
	CurrentBook.AddChapter(19, `{
"1":"Yahvé dit à Moïse et à Aaron:"
,"2":"'Voici une prescription de la Loi que Yahvé vous ordonne. Tu diras aux Israélites de t'amener une vache rousse sans défaut et sans tare, sur laquelle on n'a jamais posé le joug."
,"3":"Vous la remettrez au prêtre Eléazar, il la fera sortir hors du camp et on l'immolera devant lui."
,"4":"Eléazar le prêtre prendra de son sang avec son doigt, et fera sept fois l'aspersion en se tournant vers l'entrée de la Tente du Rendez-Vous."
,"5":"Ensuite on brûlera la vache sous ses yeux. On brûlera sa peau, sa viande, son sang et ses excréments."
,"6":"Alors le prêtre prendra du bois de cèdre, de l'hysope et de la teinture rouge, et il les jettera au milieu du bûcher où on brûlera la vache."
,"7":"Ensuite le prêtre lavera ses habits, il se baignera dans l'eau, puis il reviendra dans le camp; le prêtre sera impur jusqu'au soir."
,"8":"Celui qui aura brûlé la vache lavera ses vêtements dans l'eau et s'y baignera; il sera impur jusqu'au soir."
,"9":"Un homme pur recueillera la cendre de la vache et la déposera hors du camp, dans un lieu pur. On la conservera pour faire l'eau de purification à l'usage de la communauté des Israélites, pour faire l'expiation."
,"10":"Celui qui aura recueilli la cendre de la vache lavera ses vêtements et sera impur jusqu'au soir: c'est une loi perpétuelle pour les Israélites, comme pour l'étranger qui habite au milieu de vous."
,"11":"Celui qui touche un mort, un cadavre d'homme, sera impur durant sept jours."
,"12":"Il se purifiera avec cette eau le troisième jour et le septième jour, après quoi il sera pur. Mais s'il ne se purifie pas au troisième et au septième jour, il reste impur."
,"13":"Si quelqu'un touche un mort, un cadavre d'homme qui est mort, et ne se purifie pas, il rend impure la Demeure de Yahvé. Cet homme sera retranché d'Israël. Tant que l'eau de purification n'a pas été répandue sur lui, il est impur, son impureté reste en lui."
,"14":"Voici la loi quand un homme meurt dans une tente: quiconque entre dans la tente sera impur durant sept jours comme tout ce qui est dans la tente."
,"15":"Tout vase non couvert sur lequel il n'y a pas un couvercle attaché, sera impur."
,"16":"Celui qui, dans un champ, touche quelqu'un qui est mort par l'épée ou autrement, des ossements d'homme ou une tombe, sera impur durant sept jours."
,"17":"Pour la purification de cette personne, on prendra de la cendre sur le bûcher où l'on a fait le sacrifice d'expiation et l'on versera dessus l'eau d'un vase."
,"18":"Ensuite un homme pur prendra de l'hysope, il la plongera dans l'eau et aspergera la tente, tous les objets et toutes les personnes qui s'y trouvent; on fera de même pour celui qui a touché les ossements, la victime, le mort ou la tombe."
,"19":"L'homme pur aspergera celui qui est impur le troisième jour et le septième jour; le septième jour il fera l'expiation. Celui-ci lavera ses vêtements et se baignera dans l'eau, et le soir il sera pur."
,"20":"Mais l'homme qui est impur et qui ne fait pas de rite d'expiation, sera retranché du milieu de la communauté pour avoir rendu impur le sanctuaire de Yahvé. Si l'eau qui purifie n'a pas été répandue sur lui, c'est un impur."
,"21":"Ce sera un rite perpétuel. Celui qui asperge avec l'eau de purification devra laver ses vêtements, et celui qui aura touché à cette eau sera impur jusqu'au soir."
,"22":"Tout ce que touche l'impur sera impur, et celui qui y touche sera impur jusqu'au soir."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Toute la communauté des Israélites arriva le premier mois au désert de Tsin. Le peuple s'établit à Qadesh, c'est là que Miryam mourut et qu'elle fut enterrée."
,"2":"Il n'y avait pas d'eau pour la communauté, et les Israélites s'en prirent à Moïse et à Aaron."
,"3":"Ils cherchèrent querelle à Moïse et lui dirent: 'Pourquoi ne sommes-nous pas morts devant Yahvé comme nos frères?"
,"4":"Pourquoi avez-vous amené la communauté de Yahvé dans ce désert pour nous y faire mourir, nous et nos bêtes?"
,"5":"Vous nous avez fait sortir d'Egypte pour nous amener dans cet endroit impossible! Pas un endroit pour semer, ni figuier, ni vigne, ni grenadier et pas même d'eau à boire!"
,"6":"Moïse et Aaron s'échappèrent du milieu de la communauté et se présentèrent à l'entrée de la Tente du Rendez-Vous. Là ils tombèrent la face contre terre, et la Gloire de Yahvé leur apparut."
,"7":"Yahvé dit à Moïse:"
,"8":"'Prends ta baguette et avec Aaron ton frère, réunis toute la communauté. Et sous les yeux de tous, vous direz au rocher de donner son eau. Tu feras jaillir pour eux l'eau du rocher et tu donneras à boire à la communauté et à son bétail.'"
,"9":"Moïse retira la baguette de devant Yahvé comme il en avait reçu l'ordre."
,"10":"Puis Moïse et Aaron réunirent la communauté devant le rocher et Moïse dit: 'Ecoutez donc, rebelles! Ferons-nous jaillir pour vous, de l'eau de ce rocher?'"
,"11":"Moïse leva la main et par deux fois, frappa le rocher avec sa baguette. Alors les eaux jaillirent en abondance: la communauté et son bétail eurent à boire."
,"12":"Mais Yahvé dit à Moïse et à Aaron: 'Vous n'avez pas eu confiance en moi! Puisque vous ne m'avez pas rendu gloire devant les Israélites, vous ne ferez pas entrer cette communauté dans le pays que je lui donne.'"
,"13":"C'était aux eaux de Mériba; les Israélites protestèrent contre Yahvé, et il leur manifesta sa sainteté."
,"14":"De Qadesh, Moïse envoya dire au roi d'Edom: 'Ainsi parle ton frère Israël. Tu connais toutes les difficultés que nous avons rencontrées."
,"15":"Nos pères sont descendus en Egypte et nous y sommes restés de nombreux jours, mais les Egyptiens nous ont maltraités, nous et nos pères."
,"16":"Nous avons alors crié vers Yahvé et il a entendu notre appel: il a envoyé un ange qui nous a fait sortir d'Egypte. Maintenant nous sommes à Qadesh, l'oasis à la frontière de ton pays. "
,"17":"Laisse-nous traverser ton pays; nous ne traverserons ni tes champs, ni tes vignes, et nous ne boirons pas l'eau de tes puits. Nous suivrons la route royale sans nous écarter ni à droite, ni à gauche, jusqu'au jour où nous aurons traversé ton pays.'"
,"18":"Edom répondit: 'Tu ne passeras pas chez moi, sinon j'irai à ta rencontre, l'épée à la main.'"
,"19":"Les Israélites lui dirent: 'Nous suivrons la route et, si nous buvons de ton eau, nous et nos troupeaux, nous en paierons le prix. Nous ne laisserons que la trace de nos pieds.'"
,"20":"Edom répondit: 'Tu ne passeras pas!' Et il s'avança vers Israël avec un peuple énorme et une grande armée."
,"21":"C'est ainsi qu'Edom interdit à Israël de traverser son territoire et Israël dut faire le détour."
,"22":"Toute la communauté des Israélites partit de Qadesh et arriva à Hor-la-Montagne."
,"23":"Yahvé dit à Moïse et à Aaron quand ils étaient à Hor-la-Montagne, à la frontière du pays d'Edom:"
,"24":"'Aaron va être réuni à ses pères, il n'entrera pas dans le pays que je donne aux Israélites, car vous avez été rebelles à mes ordres aux eaux de Mériba."
,"25":"Prends donc avec toi Aaron et son fils Eléazar, et faites l'ascension de la montagne de Hor."
,"26":"Là tu retireras ses habits à Aaron et tu les mettras à Eléazar son fils, puis Aaron ira rejoindre ses pères, c'est là qu'il mourra.'"
,"27":"Moïse fit ce que Yahvé avait ordonné. Ils gravirent la montagne de Hor sous les yeux de toute la communauté."
,"28":"Moïse enleva ses habits à Aaron et il en habilla son fils Eléazar. Puis Aaron mourut sur le haut de la montagne et Moïse redescendit de la montagne avec Eléazar."
,"29":"Toute la communauté vit qu'Aaron était mort et tout le peuple d'Israël pleura Aaron durant trente jours."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Le Roi d'Arad, un Cananéen qui habitait le Négueb, apprit qu'Israël arrivait par le chemin d'Atarim. Il attaqua Israël et lui fit des prisonniers."
,"2":"Alors Israël fit un voeu à Yahvé: 'Si tu me livres ce peuple, je vouerai ses villes à l'anathème.'"
,"3":"Yahvé exauça Israël et lui livra les Cananéens. On les voua, eux et leurs villes, à l'anathème et l'on donna à ce lieu le nom d'Horma."
,"4":"Ils quittèrent Hor-la-Montagne par le chemin de la mer de Souf pour contourner le pays d'Edom. En chemin le peuple perdit patience,"
,"5":"il murmura contre Dieu et contre Moïse: 'Pourquoi nous avoir fait monter d'Egypte pour nous faire mourir dans ce désert, sans pain et sans eau? Nous en avons assez de cette triste nourriture.'"
,"6":"Alors Dieu envoya contre le peuple des serpents brûlants. Beaucoup parmi les Israélites moururent de leurs morsures."
,"7":"Le peuple vint trouver Moïse et lui dit: 'Nous avons péché, nous avons murmuré contre Yahvé et contre toi. Prie Yahvé pour nous, pour qu'il éloigne de nous les serpents.' Moïse pria pour le peuple,"
,"8":"et Yahvé dit à Moïse: 'Fabrique-toi un serpent-brûlant et place-le sur un poteau. Celui qui sera mordu le regardera et sera sauvé.'"
,"9":"Moïse fit donc un serpent de bronze et le fixa sur un poteau. Lorsque quelqu'un était mordu par un serpent, il regardait le serpent de bronze et il était sauvé."
,"10":"Les Israélites partirent et campèrent à Obot."
,"11":"Ils partirent d'Obot et campèrent aux Ruines-des-Abarim, dans le désert, à l'est de Moab, du côté du soleil levant."
,"12":"Ils partirent de là et campèrent à côté du torrent de Zéred."
,"13":"Ils partirent de là et campèrent au-delà de l'Arnon. Ce torrent dans le désert limitait le pays des Amorites, car l'Arnon est à la frontière de Moab, entre les Moabites et les Amorites."
,"14":"C'est pour cela qu'il est dit dans le Livre des Guerres de Yahvé: '...Vaheb-en-Soufa et le torrent de l'Arnon,"
,"15":"et le versant du ravin qui descend vers Ar, adossé à la frontière de Moab.'"
,"16":"De là, ils partirent pour Béer. C'est à propos de ce puits que Yahvé dit à Moïse: 'Réunis le peuple et je lui donnerai de l'eau.'"
,"17":"Alors Israël entonna ce chant: ' O Puits! Lève-toi et chante!"
,"18":"Puits que des chefs ont creusé, puits que les princes du peuple ont foré avec leur sceptre et leur bâton!',Du désert ils montèrent à Matana, "
,"19":"de Matana à Nahaliel, de Nahaliel à Bamot,"
,"20":"et de Bamot au Vallon, dans la campagne de Moab, vers le mont Pisga, face au désert."
,"21":"Israël envoya dire à Sihon, roi des Amorites:"
,"22":"'Laisse-moi passer par ton pays. Nous ne traverserons pas tes champs ni tes vignes, nous ne boirons pas l'eau de tes puits. Nous passerons par la route royale, jusqu'au jour où nous aurons traversé ton pays.'"
,"23":"Mais Sihon ne laissa pas Israël traverser son pays, il rassembla tout son peuple et vint à la rencontre d'Israël dans le désert. Arrivé à Yahas, il attaqua Israël."
,"24":"Israël le frappa de l'épée et conquit son pays depuis l'Arnon jusqu'au Yabok, jusqu'à la frontière d'Ammon, car la frontière d'Ammon était bien défendue."
,"25":"Israël prit toutes ses villes, les Israélites s'installèrent dans toutes les villes des Amorites, à Heshbon et dans ses dépendances."
,"26":"Heshbon était la ville de Sihon roi des Amorites. Il avait vaincu le précédent roi de Moab et s'était emparé de son pays jusqu'à l'Arnon."
,"27":"C'est pour cela que les poètes disent: 'Venez à Heshbon, qu'elle soit rebâtie et fortifiée, la ville de Sihon."
,"28":"Car un feu est sorti d'Heshbon, une flamme de la ville de Sihon. Elle a dévoré Ar-Moab,et les Baals des hauts-lieux de l'Arnon!"
,"29":"Malheur à toi Moab!,Tu es perdu, peuple de Kémoch!,Il a mis ses fils en fuite, de ses filles il a fait des captives,de Sihon, roi des Amorites."
,"30":"Heshbon a semé la ruine, ses flèches sont parvenues jusqu'à Dibon. Nous avons mis le feu,de Nofa jusqu'à Medba.'"
,"31":"Quand Israël s'installa dans le pays des Amorites,"
,"32":"Moïse envoya des espions à Yazer. Les Israélites s'emparèrent de cette ville et de ses dépendances et chassèrent les Amorites qui s'y trouvaient."
,"33":"Faisant un détour, ils prirent la route du Bashan. Og, roi du Bashan, s'avança à leur rencontre avec tout son peuple et leur livra bataille à Edréï."
,"34":"Yahvé dit à Moïse: 'Ne crains pas: je l'ai livré entre tes mains avec tout son peuple et tout son pays. Tu le traiteras comme Sihon, roi des Amorites, qui habitait à Heshbon.'"
,"35":"De fait les Israélites les écrasèrent lui, ses fils et tout son peuple, au point qu'il n'en resta pas un seul en vie, et ils s'installèrent dans leur pays."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Les Israélites partirent de là et campèrent dans les Steppes-de-Moab, de l'autre côté du Jourdain, à la hauteur de Jéricho."
,"2":"Balak, fils de Sipor, vit tout ce qu'Israël avait fait aux Amorites."
,"3":"Les Moabites furent pris d'une grande peur en voyant combien ce peuple était nombreux: c'était l'effroi en Moab à cause d'Israël."
,"4":"Les Moabites dirent donc aux anciens de Madian: 'Cette foule va brouter toute la région, comme le boeuf broute l'herbe des champs!',Le roi de Moab était en ce temps-là Balak, fils de Sipor. "
,"5":"Il envoya chercher Balaam fils de Béor, à Pétor sur le fleuve, au pays des Ammonites. Il l'invita à venir en lui disant: 'Un peuple sorti d'Egypte vient de s'étendre sur tout le pays et s'est établi en face de moi."
,"6":"Viens donc, je t'en prie, et maudis-moi ce peuple car il est plus puissant que moi. Peut-être alors pourrai-je le battre et le chasser du pays car, je le sais, celui que tu bénis est béni, et celui que tu maudis est maudit!'"
,"7":"Les anciens de Moab partirent avec ceux de Madian, les mains pleines de cadeaux pour le devin, et ils arrivèrent chez Balaam. Quand ils lui rapportèrent les paroles de Balak,"
,"8":"Balaam leur dit: 'Installez-vous chez moi pour la nuit, et je vous donnerai une réponse selon ce que Yahvé me dira.' Les chefs de Moab restèrent donc chez Balaam."
,"9":"Dieu vint vers Balaam et lui dit: 'Qui sont ces hommes installés chez toi?'"
,"10":"Balaam répondit à Dieu: 'Balak, fils de Sipor, roi de Moab, me fait dire ceci:"
,"11":"Ce peuple sorti d'Egypte couvre tout le pays. Viens donc et maudis-le moi, peut-être pourrai-je lui résister et le chasser.'"
,"12":"Mais Dieu dit à Balaam: 'Tu n'iras pas avec eux et tu ne maudiras pas ce peuple, car il est béni.'"
,"13":"Balaam se leva de bon matin et dit aux chefs envoyés par Balak: 'Retournez dans votre pays, car Yahvé a refusé de me laisser aller avec vous.'"
,"14":"Les chefs de Moab se levèrent donc et retournèrent vers Balak: 'Balaam, dirent-ils, a refusé de venir avec nous!'"
,"15":"Balak envoya de nouveau des chefs plus nombreux et plus considérés que les premiers."
,"16":"Ils arrivèrent chez Balaam et lui dirent: 'Voici ce que dit Balak, fils de Sipor: Je t'en prie, ne refuse pas de venir chez moi,"
,"17":"je te traiterai royalement et je ferai tout ce que tu me diras; viens et maudis-moi ce peuple!'"
,"18":"Balaam répondit aux serviteurs de Balak: 'Même si Balak me donnait plein sa maison d'argent et d'or, je ne désobéirais pas à l'ordre de Yahvé, mon Dieu, que ce soit pour une petite ou pour une grande chose."
,"19":"Cependant, restez ici cette nuit, s'il vous plaît, pour que je sache ce que Yahvé veut me dire encore!'"
,"20":"Cette nuit-là Dieu vint vers Balaam et lui dit: 'Ces hommes sont venus pour t'inviter? Eh bien, pars avec eux, mais tu ne feras que ce que je te dirai!'"
,"21":"Balaam se leva de bon matin, sella son ânesse et partit avec les chefs de Moab."
,"22":"La colère de Dieu s'enflamma contre Balaam alors qu'il était en chemin. L'ange de Yahvé se posta sur le chemin pour lui barrer la route, tandis qu'il venait sur son ânesse accompagné de deux serviteurs."
,"23":"L'ânesse vit l'ange de Yahvé qui lui barrait la route, avec son épée dégainée à la main. L'ânesse fit un crochet par les champs et Balaam frappa son ânesse pour la ramener sur le chemin."
,"24":"Alors l'ange de Yahvé vint se poster dans un chemin creux au milieu des vignes: il y avait une clôture de chaque côté."
,"25":"L'ânesse vit l'ange de Yahvé; elle rasa le mur, écrasant le pied de Balaam contre la clôture, et Balaam la frappa de nouveau."
,"26":"L'ange de Yahvé revint se poster plus en avant et s'arrêta à un endroit si étroit que l'on ne pouvait lui échapper ni à droite ni à gauche."
,"27":"Quand l'ânesse vit l'ange de Yahvé, elle s'accroupit sous Balaam. Balaam, furieux, la frappa de son bâton."
,"28":"Cette fois Yahvé ouvrit la bouche de l'ânesse et elle dit à Balaam: 'Que t'ai-je fait pour que tu me frappes par trois fois?'"
,"29":"Balaam répondit à son ânesse: 'Mais tu te moques de moi! Si j'avais une épée à la main, je te tuerais sur le champ!'"
,"30":"L'ânesse dit à Balaam: 'Ne suis-je pas ton ânesse, que tu montes depuis que tu es au monde jusqu'à ce jour? Est-ce que j'ai l'habitude d'agir de la sorte avec toi?' 'Certes non!' répondit-il."
,"31":"Alors Yahvé ouvrit les yeux de Balaam: il vit l'ange de Yahvé debout en travers du chemin, son épée dégainée à la main. Il s'agenouilla et se prosterna le nez contre terre."
,"32":"L'ange de Yahvé lui dit: 'Pourquoi as-tu frappé ton ânesse à trois reprises? Je suis venu pour te barrer la route, car ce voyage ne me plaît pas."
,"33":"L'ânesse m'a vu et à trois reprises s'est détournée de moi. Si elle ne s'était pas détournée, je t'aurais tué sur le champ, et elle, je l'aurais laissée en vie.'"
,"34":"Balaam dit à l'ange de Yahvé: 'J'ai peut-être péché, mais je ne savais pas que tu étais en travers de ma route. Si cela ne te plaît pas, je retourne chez moi.'"
,"35":"L'ange de Yahvé dit alors à Balaam: 'Va avec ces messieurs! Mais tu ne diras que les paroles que je te dirai.' Balaam fit donc le chemin avec les chefs envoyés par Balak."
,"36":"Lorsque Balak apprit l'arrivée de Balaam, il sortit à sa rencontre à Ar-Moab, sur la frontière de l'Arnon à l'extrémité de son pays."
,"37":"Balak dit à Balaam: 'Ne t'avais-je pas envoyé des gens pour t'inviter? Pourquoi n'es-tu pas venu? Tu pensais sans doute que je n'allais pas bien te payer?'"
,"38":"Balaam répondit à Balak: 'Tu vois que j'arrive chez toi, mais que puis-je dire maintenant? Seulement les paroles que Dieu mettra dans ma bouche!'"
,"39":"Balaam s'en alla donc avec Balak et ils arrivèrent à Kiryat-Housot."
,"40":"Balak sacrifia du gros et du petit bétail et en fit porter à Balaam et aux chefs venus avec lui."
,"41":"Dès le matin Balak vint chercher Balaam et le fit monter à Bamot-Baal, car de là il pouvait voir une partie du peuple."
}`)
	CurrentBook.AddChapter(23, `{
"1":"Balaam dit à Balak: 'Elève ici sept autels et prépare-moi sept jeunes taureaux et sept béliers.!'"
,"2":"Balak fit ce que Balaam lui avait dit, et Balak et Balaam sacrifièrent un jeune taureau et un bélier sur chaque autel."
,"3":"Balaam dit à Balak: 'Reste là près de ton holocauste et moi je vais faire un tour. Peut-être Yahvé viendra-t-il à ma rencontre et je te révélerai alors ce qu'il m'aura fait connaître.' Et Balaam s'en fut sur une crête."
,"4":"Dieu se présenta à Balaam qui lui dit: 'J'ai préparé sept autels, et sur chaque autel, j'ai fait monter un jeune taureau et un bélier!'"
,"5":"Alors Yahvé mit une parole dans la bouche de Balaam et lui dit: 'Retourne vers Balak et tu lui transmettras cette parole.'"
,"6":"Il revint donc vers Balak qui se tenait toujours près de son holocauste avec tous les chefs de Moab."
,"7":"Et Balaam proclama son poème: 'D'Aram, Balak me fait venir, des monts de l'orient le roi de Moab m'appelle: 'Viens, et maudis-moi Jacob!,viens et menace Israël!'"
,"8":"Comment maudire si Dieu ne maudit pas, ou menacer, si Yahvé ne menace pas?"
,"9":"Je le vois du haut des rochers,et du haut des collines je le contemple: ce peuple demeure à part, on ne peut le compter parmi les nations!"
,"10":"Qui pourra calculer la poussière de Jacob, dénombrer seulement le quart d'Israël?,Que je meure de la mort des justes,et que ma fin soit semblable à la leur!'"
,"11":"Balak dit à Balaam: 'Quel coup m'as-tu fait? Je te prends pour maudire mes ennemis et tu les bénis!'"
,"12":"Il répondit: 'Ne dois-je pas te dire ce que Yahvé a mis dans ma bouche?'"
,"13":"Alors Balak lui dit: 'Viens donc avec moi à un autre endroit. De là tu verras le peuple, mais pas encore tout entier, et tu me le maudiras.'"
,"14":"Il le conduisit donc au Champ-des-Guetteurs, au sommet du Pisga. Il bâtit là sept autels et fit monter un jeune taureau et un bélier sur chaque autel."
,"15":"Balaam dit alors à Balak: 'Reste ici près de ton holocauste, et moi, je m'avancerai un peu plus loin.'"
,"16":"Yahvé se présenta à Balaam et mit une parole dans sa bouche, puis il lui dit: 'Retourne vers Balak et tu lui transmettras cette parole.'"
,"17":"Balaam revint donc vers lui, tandis qu'il était toujours debout près de son holocauste avec les chefs de Moab. Balak demanda à Balaam: 'Qu'a dit Yahvé?'"
,"18":"Et Balaam proclama son poème: 'Lève-toi Balak, écoute!,Prête-moi l'oreille, fils de Sipor!"
,"19":"Dieu n'est pas un homme pour mentir, il n'est pas un fils d'homme pour revenir en arrière. Dit-il quelque chose sans le faire?,Ou parle-t-il sans agir?"
,"20":"Regarde! Il m'a pris pour bénir, s'il bénit, comment dire autrement?"
,"21":"Il n'a pas vu de faute en Jacob, il n'a pas perçu de mal en Israël. Yahvé son Dieu est avec lui, chez lui on entend acclamer un roi."
,"22":"Dieu le fait sortir d'Egypte, et lui donne les cornes du buffle!"
,"23":"Point n'est besoin de magie en Jacob, ni de sorcellerie en Israël: car en temps voulu sera prédit à Jacob, à Israël, ce que Dieu prépare."
,"24":"Ce peuple se lève comme une lionne, se dresse comme un lion. Il ne revient pas sans avoir dévoré sa proie, sans avoir bu le sang de ses victimes.'"
,"25":"Balak dit à Balaam: 'Si tu ne le maudis pas, du moins ne le bénis pas!'"
,"26":"Mais Balaam répondit à Balak: 'Je te l'ai bien dit: ce que Yahvé dira, je le ferai.'"
,"27":"Balak dit à Balaam: 'Viens, je t'emmène autre part, et là peut-être ton Dieu trouvera-t-il bon de me le maudire!'"
,"28":"Alors Balak conduisit Balaam au sommet du Péor, face au désert."
,"29":"Balaam dit à Balak: 'Construis sept autels à cet endroit, et prépare sept jeunes taureaux et sept béliers.'"
,"30":"Balak fit comme Balaam le lui avait dit et sacrifia un jeune taureau et un bélier sur chaque autel."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Balaam vit que Dieu se plaisait à bénir Israël, aussi n'alla-t-il pas comme les autres fois à la recherche de signes, mais il tourna son visage vers le désert."
,"2":"Quand Balaam leva les yeux, il vit Israël groupé par tribus, et l'esprit de Dieu s'empara de lui."
,"3":"Alors il proclama son poème: 'Parole de Balaam, fils de Béor, parole de l'homme qui perce le mystère,"
,"4":"oracle de celui qui entend les paroles de Dieu, qui voit ce que le Dieu de la Steppe fait voir, qui se prosterne, et Dieu lui ouvre les yeux."
,"5":"Que tes tentes sont belles, Jacob, tes demeures, O Israël!"
,"6":"Elles s'étirent comme des vallées, comme des jardins sur le bord d'un fleuve, comme des aloès que Yahvé a plantés, comme des cèdres au bord des eaux!"
,"7":"L'eau déborde de ses deux seaux, sa semence est bien irriguée; son roi est plus puissant qu'Agag, et son règne grandit encore!"
,"8":"Dieu le fait sortir d'Egypte, et lui donne les cornes du buffle!,Il dévore les nations ennemies, il leur brise les os, il les perce de ses flèches."
,"9":"Il s'accroupit, se couche comme un lion, comme une lionne: qui le fera lever?,Bénis soient ceux qui te bénissent, maudits soient ceux qui te maudissent.'"
,"10":"Balak s'emporta contre Balaam; il frappa des mains, puis il lui dit: 'Je t'avais fait venir pour maudire mes ennemis, et toi, par trois fois tu les as bénis!"
,"11":"Maintenant file chez toi. J'avais promis de te combler d'honneurs, mais Yahvé t'en a privé!'"
,"12":"Balaam répondit à Balak: 'J'avais dit quelque chose aux hommes que tu m'as envoyés; je leur avais dit:"
,"13":"Même si Balak me donnait plein sa maison d'argent et d'or, je ne désobéirais pas à l'ordre de Yahvé. Bien ou mal, je ne ferai rien de moi-même, mais je dirai ce que Yahvé dira."
,"14":"Maintenant je m'en retourne dans mon pays! Mais laisse-moi te dire ce que ce peuple fera à ton peuple dans les jours qui viennent.'"
,"15":"Alors il proclama son poème: 'Parole de Balaam, fils de Béor, parole de l'homme qui perce le mystère,"
,"16":"oracle de celui qui entend les paroles de Dieu,et qui possède la science du Très-Haut, qui voit ce que le Dieu de la Steppe fait voir, qui se prosterne, et Dieu lui ouvre les yeux."
,"17":"Je le vois, mais non pour maintenant, je le contemple, mais non de près: un astre se lève de Jacob, un sceptre se dresse en Israël. Il frappe les deux tempes de Moab, et le crâne de tous les fils de Seth."
,"18":"Edom devient sa conquête, il enlève Séïr à ses ennemis, Israël fait de grandes choses,"
,"19":"Jacob impose sa force,et fait périr les survivants d'Ar.'"
,"20":"Balaam vit Amalec et il dit son poème: 'Amalec, la première des nations, ta postérité disparaîtra!'"
,"21":"Voyant les Kénites, il dit son poème: 'Solide est ta demeure, ton nid est établi sur un roc!"
,"22":"Le feu pourtant dévorera Kayin, et l'Assyrien à la fin l'emmènera captif.'"
,"23":"Il proclama encore ce poème: 'Hélas! qui sera là quand Dieu le décidera?"
,"24":"Voici des navires du côté des Kittim, ils soumettent l'Assyrien, ils soumettent l'Hébreu, mais eux aussi courent à la ruine.'"
,"25":"Balaam se mit en route pour rentrer chez lui, et Balak aussi s'en alla par son chemin."
}`)
	CurrentBook.AddChapter(25, `{
"1":"Israël s'installa à Chittim et le peuple se livra à la prostitution avec les filles de Moab."
,"2":"Elles invitèrent le peuple à sacrifier à leurs dieux: le peuple mangea et se prosterna devant leurs dieux."
,"3":"Israël s'attacha au Baal de Péor et la colère de Yahvé s'enflamma contre Israël."
,"4":"Yahvé dit alors à Moïse: 'Prends tous les meneurs du peuple, empale-les à la face du soleil, devant Yahvé; ainsi la colère de Yahvé se détournera d'Israël.'"
,"5":"Moïse dit aux chefs d'Israël: 'Que chacun tue ceux de ses hommes qui se sont prostitués avec le Baal de Péor.'"
,"6":"Juste à ce moment-là un Israélite ramenait à sa tente une Madianite, sous le regard de Moïse et de toute la communauté d'Israël qui pleuraient à l'entrée de la Tente du Rendez-Vous."
,"7":"A cette vue, Pinhas fils d'Eléazar, fils d'Aaron le prêtre, saisit une lance,"
,"8":"suivit l'Israélite dans l'arrière-tente et les transperça tous les deux, lui et la femme, en plein ventre. Aussitôt cessa le fléau qui pesait sur Israël:"
,"9":"car déjà vingt quatre mille d'entre eux étaient morts de ce fléau."
,"10":"Yahvé dit à Moïse:"
,"11":"'Pinhas fils d'Eléazar, fils d'Aaron le prêtre, a éloigné ma colère des Israélites quand il s'est montré jaloux pour moi au milieu d'eux."
,"12":"C'est pourquoi tu vas lui dire que je m'engage à le récompenser."
,"13":"Je m'engage à lui donner le sacerdoce pour toujours, à lui et à sa descendance, car il s'est montré jaloux pour son Dieu et a réparé au nom des Israélites.'"
,"14":"L'Israélite qui était mort, frappé avec la Madianite, s'appelait Zimri, fils de Salou; il était un des chefs de la tribu de Siméon."
,"15":"Le nom de la Madianite mise à mort était Kozbi, fille de Sour, chef d'une famille de Madian."
,"16":"Yahvé dit alors à Moïse:"
,"17":"'Attaque les Madianites et frappe-les,"
,"18":"car ils vous ont attaqués par leur idolâtrie. Ils ont rusé avec vous dans l'affaire de Péor et dans l'affaire de Kozbi, leur soeur, fille d'un prince de Madian, c'est elle qui fut frappée au jour du fléau, dans l'affaire du Péor."
}`)
	CurrentBook.AddChapter(26, `{
"1":"Yahvé dit à Moïse et à Eléazar, fils d'Aaron le prêtre:"
,"2":"'Recensez toute la communauté des Israélites, depuis l'âge de vingt ans et au-dessus, faites le compte par famille de ceux qui sont aptes à la guerre.'"
,"3":"Moïse et Eléazar le prêtre leur parlèrent donc dans les Steppes-de-Moab, près du Jourdain, en face de Jéricho:"
,"4":"l'ordre de Yahvé à Moïse valait pour tous les Israélites de l'âge de vingt ans et au-dessus. Voici les fils d'Israël sortis du pays d'Egypte:"
,"5":"Ruben premier-né d'Israël; les fils de Ruben: Hénok et le clan Hénokite, Palou et le clan Palouïte,"
,"6":"Hesron et le clan Hesronite, Karmi et le clan Karmite."
,"7":"Ce sont les clans des Rubénites, on en recensa 43730."
,"8":"Fils de Palou: Eliab,"
,"9":"les fils d'Eliab: Némuel, Datan et Abiram. Datan et Abiram, qui étaient considérés dans la communauté, se révoltèrent cependant contre Moïse et Aaron. Ils faisaient partie de la bande de Coré quand elle se révolta contre Yahvé."
,"10":"La terre ouvrit alors la bouche et les engloutit avec Coré. Leur bande disparut lorsque le feu consuma les deux cent cinquante révoltés. Ce fut un exemple,"
,"11":"cependant les fils de Coré ne moururent pas."
,"12":"Les fils de Siméon par clans: Némuel et le clan des Némuélites, Yamin et le clan Yaminite, Yakin et le clan Yakinite,"
,"13":"Zérah et le clan Zérahite, Chaoul et le clan Chaoulite."
,"14":"Dans ces clans on recensa 22200 fils de Siméon."
,"15":"Les fils de Gad par clans: Séfon et le clan Séfonite, Haggi et le clan Haggite, Chouni et le clan Chounite,"
,"16":"Ozni et le clan Oznite, Eri et le clan Erite,"
,"17":"Arod et le clan Arodite, Aréli et le clan Arélite."
,"18":"Dans ces clans on recensa 40500 fils de Gad."
,"19":"Les fils de Juda: Er et Onan. Er et Onan moururent au pays de Canaan."
,"20":"Voici les fils de Juda et leur descendance: Chéla et le clan Chélanite, Pérès et le clan Parsite, Zérah et le clan Zarhite;"
,"21":"les fils de Pérès: Hesron et le clan Hesronite, Hamoul et le clan Hamoulite."
,"22":"Dans ces clans on recensa 76500 fils de Juda."
,"23":"Les fils d'Issacar par clans: Tola et le clan Tolaïte, Pouvva et le clan pouvvite,"
,"24":"Yachoub et le clan Yachoubite, Chimron et le clan Chimronite."
,"25":"Dans ces clans on recensa 64300 fils d'Issacar."
,"26":"Les fils de Zabulon par clans: Séred et le clan Sardite, Elon et le clan Elonite, Yakhléel et le clan Yakhléélite."
,"27":"Dans ces clans on recensa 60500 fils de Zabulon."
,"28":"Les fils de Joseph étaient Manassé et Ephraïm."
,"29":"Les fils de Manassé: Makir et le clan Makirite, Makir engendra Galaad, Galaad est le clan Galaadite,"
,"30":"les fils de Galaad: Yézer et le clan Yézrite, Hélek et le clan Hélkite,"
,"31":"Asriel et le clan Asriélite, Chékem et le clan Chékemite,"
,"32":"Chémida et le clan Chémidaïte, Héfer et le clan Héfrite."
,"33":"Séloféhad n'eut pas de fils mais des filles. Voici leurs noms: Mahla, Noa, Hogla, Milka, Tirsa."
,"34":"Dans ces clans on recensa 52700 fils de Manassé."
,"35":"Voici les fils d'Ephraïm par clans: Choutéla et le clan Choutalhite, Béker et le clan Bakrite, Tahan et le clan Tahanite;"
,"36":"fils de Choutéla: Eran et le clan Eranite."
,"37":"Dans ces clans on recensa 32500 fils d'Ephraïm. Voilà les fils de Joseph par clans."
,"38":"Les fils de Benjamin par clans: Béla et le clan Baléite, Achbel et le clan Achbélite, Ahiram et le clan Ahiramite,"
,"39":"Chéfoufam et le clan Chéfoufamite, Houfam et le clan Houfamite;"
,"40":"Béla eut deux fils, Ard et Naaman: Ard et le clan Ardite, Naaman et le clan Naamite."
,"41":"Dans ces clans on recensa 45600 fils de Benjamin."
,"42":"Les fils de Dan par clans: Chouham et le clan Chouhamite. Ce sont là les clans de Dan."
,"43":"Dans ces clans on recensa 64400 fils de Chouham."
,"44":"Les fils d'Asher par clans: Yimna et le clan Yimnite, Yichvi et le clan Yichvite, Béria et le clan Bériite,"
,"45":"fils de Béria: Héber et le clan Hébrite, Malkiel et le clan Malkielite."
,"46":"La fille d'Asher se nommait Sara."
,"47":"Dans ces clans on recensa 53400 fils d'Asher."
,"48":"Les fils de Nephtali: Yakhséel et le clan Yakhséélite, Gouni et le clan Gounite,"
,"49":"Yéser et le clan Yisrite, Chillem et le clan Chillemite."
,"50":"Dans ces clans on recensa 45400 fils de Nephtali."
,"51":"On recensa donc 601730 Israélites."
,"52":"Yahvé dit à Moïse:"
,"53":"'Le pays leur sera partagé en héritage selon le nombre des recensés."
,"54":"Tu donneras un grand domaine à ceux qui sont nombreux et un petit domaine à ceux qui sont peu nombreux. Chacun aura son héritage selon le nombre des recensés."
,"55":"On devra partager au sort le pays et l'héritage se répartira selon le nom des tribus d'origine."
,"56":"C'est le sort qui départagera l'héritage, pour ceux qui sont nombreux et pour ceux qui le sont moins."
,"57":"Voici les Lévites recensés selon leurs clans: Guerchon et le clan Guerchonite, Kahat et le clan Kahatite, Mérari et le clan Mérarite."
,"58":"Voici les clans de Lévi: le clan Libnite, le clan Hébronite, le clan Mahlite, le clan Mouchite, le clan Coréite. Kahat engendra Amram."
,"59":"La femme d'Amram se nommait Yokébed, fille de Lévi; elle était née en Egypte. Elle donna à Amram: Aaron, Moïse et leur soeur Miryam."
,"60":"Aaron engendra Nadab et Abihou, Eléazar et Itamar."
,"61":"Nadab et Abihou moururent pour avoir porté devant Yahvé un feu profane."
,"62":"On recensa au total 23000 mâles d'un mois et au-dessus. On ne les avait pas recensés avec les autres Israélites, car ils n'avaient pas à partager l'héritage avec eux."
,"63":"Ce sont donc là tous les hommes recensés par Moïse et Eléazar le prêtre, lors du recensement des Israélites dans les Steppes-de-Moab, près du Jourdain, à la hauteur de Jéricho."
,"64":"Aucun d'eux n'avait été recensé par Moïse et Aaron le prêtre lorsqu'ils avaient dénombré les Israélites dans le désert du Sinaï;"
,"65":"Yahvé, en effet, avait dit à ces derniers qu'ils allaient tous mourir dans le désert, et qu'il n'en resterait pas un seul, excepté Caleb fils de Yéfouné, et Josué fils de Noun."
}`)
	CurrentBook.AddChapter(27, `{
"1":"Les filles de Séloféhad vinrent alors se présenter. Séloféhad était fils de Héfer, fils de Galaad, fils de Makir, fils de Manassé. Il appartenait au clan de Manassé, fils de Joseph. Ses filles s'appelaient Mahla, Noa, Hogla, Milka et Tirsa."
,"2":"Elles se présentèrent donc à Moïse et à Eléazar le prêtre, devant les chefs et toute la communauté, à l'entrée de la Tente du Rendez-Vous:"
,"3":"'Notre père, dirent-elles, est mort au désert, il n'appartenait pas à la bande de Coré qui se révolta contre Yahvé, mais il est mort pour son propre péché, sans avoir de fils."
,"4":"Pourquoi le nom de notre père disparaîtrait-il au milieu de son clan? Puisqu'il n'a pas eu de fils, donne-nous un domaine au milieu des frères de notre père.'"
,"5":"Moïse porta ce cas devant Yahvé,"
,"6":"et Yahvé dit à Moïse:"
,"7":"'Ce que disent les filles de Séloféhad est juste. Tu leur donneras donc en héritage une propriété au milieu des frères de leur père, et tu leur feras passer l'héritage de leur père."
,"8":"A ce sujet tu diras aux Israélites: Si un homme meurt sans avoir de fils, vous ferez passer son héritage à sa fille"
,"9":"et s'il n'a pas de fille, vous donnerez son héritage à ses frères."
,"10":"S'il n'a pas de frère, vous donnerez son héritage au frère de son père,"
,"11":"et si son père n'a pas de frère, vous donnerez l'héritage au parent le plus proche dans sa famille: c'est lui qui en héritera. Ce sera pour les Israélites une règle de droit, comme Yahvé l'a ordonné à Moïse.'"
,"12":"Yahvé dit à Moïse: 'Monte sur cette montagne de la chaîne des Abarim, et regarde le pays que je donne aux Israélites."
,"13":"Quand tu l'auras vu, tu seras réuni à ton peuple comme Aaron ton frère,"
,"14":"parce que dans le désert de Sin, lorsque la communauté a murmuré, vous avez été rebelles à mes ordres et vous n'avez pas manifesté ma sainteté devant le peuple dans l'affaire des eaux.' (Ce sont les eaux de Mériba à Qadesh, dans le désert de Sin.)"
,"15":"Moïse dit à Yahvé:"
,"16":"'Que Yahvé, le Dieu des esprits de tout être vivant, mette à la tête de la communauté un homme"
,"17":"qui sorte et rentre à sa tête. Il la fera sortir, il la fera rentrer, et la communauté de Yahvé ne sera pas comme un troupeau qui n'a pas de pasteur.'"
,"18":"Yahvé répondit à Moïse: 'Prends Josué, fils de Noun, car c'est un homme en qui se trouve l'esprit, et tu lui imposeras les mains."
,"19":"Puis tu le feras venir devant Eléazar le prêtre et devant toute la communauté, et là, tu lui donneras tes consignes sous leurs yeux."
,"20":"Tu lui transmettras une part de ton autorité pour que toute la communauté des Israélites lui obéisse."
,"21":"Désormais il pourra se présenter devant le prêtre Eléazar, qui consultera pour lui les jugements de Yahvé au moyen de l'Ourim. Et selon sa réponse, Josué sortira ou rentrera et, avec lui tous les Israélites et toute la communauté.'"
,"22":"Moïse fit ce que Yahvé lui avait commandé. Il fit venir Josué devant Eléazar le prêtre et devant toute la communauté."
,"23":"Après lui avoir imposé les mains il lui donna ses ordres, ceux que Yahvé avait donnés par la bouche de Moïse."
}`)
	CurrentBook.AddChapter(28, `{
"1":"Yahvé dit à Moïse:"
,"2":"'Tu donneras cet ordre aux Israélites: Vous veillerez à me présenter à la date fixée, l'offrande d'aliments qui me revient sur les sacrifices par le feu d'agréable odeur."
,"3":"Tu leur diras encore: Voici le sacrifice par le feu que vous offrirez à Yahvé chaque jour: deux agneaux âgés d'un an et sans défaut. C'est l'holocauste perpétuel."
,"4":"Tu offriras l'un des agneaux le matin, le second à la tombée du jour,"
,"5":"avec un dixième de mesure de fleur de farine pétrie dans un quart de mesure d'huile d'olives concassées, comme oblation."
,"6":"C'est l'holocauste perpétuel qui a été présenté à la montagne du Sinaï, un sacrifice par le feu d'agréable odeur à Yahvé."
,"7":"Tu feras la libation de vin pur devant Yahvé, dans le lieu saint: un quart de mesure pour chaque agneau."
,"8":"Tu offriras le second agneau à la tombée du jour, tu feras l'offrande et la libation comme le matin. C'est un sacrifice par le feu d'agréable odeur à Yahvé."
,"9":"Le jour du sabbat tu offriras deux agneaux d'un an, sans défaut, et en oblation deux mesures de fleur de farine pétrie dans l'huile ainsi qu'une libation."
,"10":"C'est l'holocauste du sabbat qui s'ajoute chaque sabbat à l'holocauste perpétuel et à sa libation."
,"11":"Le premier du mois vous offrirez en holocauste à Yahvé deux jeunes taureaux, un bélier et sept agneaux d'un an sans défaut."
,"12":"Pour chaque taureau vous présenterez une oblation de trois dixièmes de fleur de farine pétrie dans l'huile; pour le bélier, une oblation de deux dixièmes de fleur de farine pétrie dans l'huile;"
,"13":"et pour chaque agneau comme oblation un dixième de fleur de farine pétrie dans l'huile. C'est un holocauste d'agréable odeur, un sacrifice par le feu en l'honneur de Yahvé."
,"14":"Les libations seront d'une demi-mesure de vin pour un taureau, d'un tiers de mesure pour un bélier et d'un quart de mesure pour un agneau. C'est l'holocauste du début du mois, pour chacun des mois de l'année."
,"15":"On présentera à Yahvé un bouc en sacrifice pour le péché, qui s'ajoutera à l'holocauste perpétuel et à sa libation."
,"16":"Le quatorzième jour du premier mois, ce sera la Pâque de Yahvé."
,"17":"Le quinzième jour de ce mois sera un jour de fête, et pendant sept jours on mangera des pains sans levain."
,"18":"Le premier jour, il y aura une assemblée sainte; vous ne ferez aucun travail ce jour-là."
,"19":"Pour le sacrifice par le feu, vous offrirez en holocauste à Yahvé deux jeunes taureaux, un bélier et sept agneaux d'un an sans défaut."
,"20":"L'oblation sera de la fleur de farine trempée dans l'huile, trois dixièmes par taureau et deux dixièmes pour le bélier."
,"21":"Pour chacun des sept agneaux, l'oblation sera d'un dixième."
,"22":"Vous offrirez en plus un bouc en sacrifice pour le péché, afin de faire l'expiation sur vous."
,"23":"Vous sacrifierez cela en plus de l'holocauste du matin, qui est un holocauste perpétuel."
,"24":"Vous ferez ainsi chaque jour, pendant les sept jours de la fête: c'est un aliment, un sacrifice par le feu d'agréable odeur à Yahvé. Il sera offert avec sa libation en plus de l'holocauste perpétuel."
,"25":"Au septième jour vous aurez de nouveau une assemblée sainte et vous ne ferez ce jour-là aucun travail."
,"26":"Au jour des prémices, lors de la fête des Semaines, lorsque vous présenterez à Yahvé l'offrande nouvelle, vous tiendrez une assemblée sainte et vous ne ferez aucun travail."
,"27":"Vous offrirez comme holocauste d'agréable odeur à Yahvé: deux jeunes taureaux, un bélier et sept agneaux d'un an."
,"28":"L'oblation sera de la fleur de farine pétrie dans l'huile: trois dixièmes pour chaque taureau, deux dixièmes pour le bélier,"
,"29":"et pour chacun des sept agneaux un dixième."
,"30":"Vous offrirez également un bouc pour faire l'expiation sur vous. Vous offrirez ces sacrifices et leur libation en plus de l'holocauste perpétuel et de son oblation; vous choisirez des victimes sans défaut."
}`)
	CurrentBook.AddChapter(29, `{
"1":"Le premier jour du septième mois, vous aurez une assemblée sainte. Vous ne ferez ce jour-là aucun travail, et ce sera pour vous un jour de grandes acclamations."
,"2":"Vous offrirez un jeune taureau, un bélier et sept agneaux sans défaut d'un an, en holocauste d'agréable odeur à Yahvé."
,"3":"L'oblation sera de la fleur de farine trempée dans l'huile, trois dixièmes pour le taureau, deux dixièmes pour le bélier,"
,"4":"et pour chacun des sept agneaux, un dixième."
,"5":"Vous offrirez un bouc en sacrifice pour le péché, afin de faire l'expiation sur vous."
,"6":"Vous ferez cela en plus de l'holocauste mensuel et de son oblation, de l'holocauste perpétuel, de son oblation et de ses libations selon les règles établies; ce sont des sacrifices par le feu d'agréable odeur à Yahvé."
,"7":"Le dixième jour de ce septième mois, vous tiendrez une assemblée sainte. Vous ne ferez aucun travail, et vous vous humilierez."
,"8":"Vous offrirez un jeune taureau, un bélier et sept agneaux d'un an sans défaut, en holocauste d'agréable odeur à Yahvé."
,"9":"L'oblation sera de la fleur de farine pétrie dans l'huile: trois dixièmes pour le taureau, deux dixièmes pour le bélier,"
,"10":"et pour chacun des sept agneaux, un dixième."
,"11":"Vous offrirez un bouc en sacrifice pour le péché en plus du sacrifice habituel pour le péché et de l'holocauste perpétuel avec son oblation et ses libations."
,"12":"Le quinzième jour du septième mois, vous tiendrez une assemblée sainte et vous ne ferez aucun travail ce jour-là. Vous célébrerez durant sept jours une fête en l'honneur de Yahvé."
,"13":"En holocauste, en sacrifice par le feu d'agréable odeur à Yahvé, vous offrirez treize jeunes taureaux, deux béliers et quatorze agneaux d'un an sans défaut."
,"14":"L'oblation sera de la fleur de farine pétrie dans l'huile: trois dixièmes pour chacun des treize taureaux, deux dixièmes pour chacun des deux béliers,"
,"15":"et un dixième pour chacun des quatorze agneaux."
,"16":"Vous offrirez également un bouc en sacrifice pour le péché; tout cela s'ajoutera à l'holocauste perpétuel, à son oblation et à sa libation."
,"17":"Le second jour vous offrirez douze jeunes taureaux, deux béliers et quatorze agneaux d'un an sans défaut,"
,"18":"avec l'oblation et la libation pour les taureaux, les béliers et les agneaux selon leur nombre et selon la règle."
,"19":"Vous offrirez également un bouc en sacrifice pour le péché. Tout cela s'ajoutera à l'holocauste perpétuel, à son oblation et à ses libations."
,"20":"Le troisième jour vous offrirez onze jeunes taureaux, deux béliers et quatorze agneaux d'un an sans défaut,"
,"21":"avec l'oblation et la libation pour les taureaux, les béliers et les agneaux selon leur nombre et selon la règle."
,"22":"Vous offrirez également un bouc en sacrifice pour le péché. Tout cela s'ajoutera à l'holocauste perpétuel, à son oblation et à ses libations."
,"23":"Le quatrième jour vous offrirez dix jeunes taureaux, deux béliers et quatorze agneaux d'un an sans défaut,"
,"24":"avec l'oblation et la libation pour les taureaux, les béliers et les agneaux selon leur nombre et selon la règle."
,"25":"Vous offrirez également un bouc en sacrifice pour le péché. Tout cela s'ajoutera à l'holocauste perpétuel, à son oblation et à ses libations."
,"26":"Le cinquième jour vous offrirez neuf jeunes taureaux, deux béliers et quatorze agneaux d'un an sans défaut,"
,"27":"avec l'oblation et la libation pour les taureaux, les béliers et les agneaux selon leur nombre et selon la règle."
,"28":"Vous offrirez également un bouc en sacrifice pour le péché. Tout cela s'ajoutera à l'holocauste perpétuel, à son oblation et à ses libations."
,"29":"Le sixième jour vous offrirez huit jeunes taureaux, deux béliers et quatorze agneaux d'un an sans défaut,"
,"30":"avec l'oblation et la libation pour les taureaux, les béliers et les agneaux selon leur nombre et selon la règle."
,"31":"Vous offrirez également un bouc en sacrifice pour le péché. Tout cela s'ajoutera à l'holocauste perpétuel, à son oblation et à ses libations."
,"32":"Le septième jour vous offrirez sept jeunes taureaux, deux béliers et quatorze agneaux d'un an sans défaut,"
,"33":"avec l'oblation et la libation pour les taureaux, les béliers et les agneaux selon leur nombre et selon la règle."
,"34":"Vous offrirez également un bouc en sacrifice pour le péché. Tout cela s'ajoutera à l'holocauste perpétuel, à son oblation et à ses libations."
,"35":"Le huitième jour vous tiendrez une assemblée solennelle; vous ne ferez aucun travail ce jour-là."
,"36":"Vous offrirez en holocauste, en sacrifice par le feu d'agréable odeur à Yahvé: un taureau, un bélier et sept agneaux d'un an sans défaut,"
,"37":"avec l'oblation et la libation pour le taureau, le bélier et les agneaux, selon leur nombre et selon la règle."
,"38":"Vous offrirez également un bouc en sacrifice pour le péché, tout cela s'ajoutera à l'holocauste perpétuel, à son oblation et à sa libation."
,"39":"Voilà les sacrifices que vous offrirez à Yahvé pour vos fêtes. Ils s'ajouteront à vos sacrifices à la suite d'un voeu et à vos offrandes volontaires, à vos holocaustes, vos oblations, vos libations et vos sacrifices de communion.'"
}`)
	CurrentBook.AddChapter(30, `{
"1":"Moïse rapporta aux Israélites tout ce que Yahvé lui avait ordonné."
,"2":"Moïse parla aux chefs des tribus d'Israël: 'Voici, dit-il, ce que Yahvé ordonne:"
,"3":"Si quelqu'un a fait un voeu à Yahvé, s'il a fait un serment et s'est imposé à lui-même une obligation, il ne violera pas son serment: il accomplira exactement ce qu'il a dit."
,"4":"Mais voici le cas d'une jeune fille qui habite dans la maison de son père: elle a fait un voeu à Yahvé et s'est imposé à elle-même une obligation."
,"5":"Si son père ne dit rien lorsqu'il apprend son voeu et l'obligation qu'elle s'est imposée, ce voeu et cette obligation gardent toute leur valeur."
,"6":"Mais si son père n'est pas d'accord lorsqu'il est mis au courant, elle est quitte de son voeu et de l'obligation qu'elle s'est imposée. Yahvé lui pardonnera puisque c'est son père qui n'est pas d'accord."
,"7":"Autre cas: une femme qui a fait un voeu ou qui s'est engagée par une parole imprudente vient à se marier."
,"8":"Si son mari apprenant la chose ne dit rien, son voeu et l'obligation qu'elle s'est imposée gardent toute leur valeur."
,"9":"Mais si le mari désapprouve sa femme le jour où il est mis au courant, il casse par là même le voeu qui la liait et la parole imprudente par laquelle elle s'était engagée. Dans ce cas Yahvé lui pardonnera."
,"10":"Une veuve ou une femme répudiée est liée par le voeu qu'elle a fait: son voeu garde toute sa valeur."
,"11":"Autre cas: une femme fait un voeu ou s'impose par serment une obligation alors qu'elle vit dans la maison de son mari."
,"12":"Si son mari ne dit rien le jour où il l'apprend, c'est qu'il ne la désapprouve pas. Dans ce cas son voeu et l'obligation qu'elle s'est imposée ont toute leur valeur."
,"13":"Mais si, le jour où le mari est mis au courant, il dit son désaccord, elle est quitte de sa parole et de son serment, de son voeu et de son obligation. Yahvé pardonnera à cette femme puisque c'est son mari qui les a désapprouvés."
,"14":"Tout voeu et toute obligation qu'elle s'est imposée pour se mortifier, c'est son mari qui l'approuve et c'est lui qui l'annule."
,"15":"Si au fil des jours son mari continue de se taire, il approuve par là-même tous ses voeux et toutes les obligations qui lui incombent. Il les a confirmés par son silence, le jour où il les a appris."
,"16":"Mais s'il les annule alors qu'il les connaît depuis un certain temps, c'est lui qui portera le poids de la faute.'"
,"17":"Voilà toutes les prescriptions que Yahvé a ordonnées à Moïse au sujet de l'homme et de la femme, du père et de la fille qui, jeune encore, habite la maison de son père."
}`)
	CurrentBook.AddChapter(31, `{
"1":"Yahvé dit à Moïse:"
,"2":"'Fais payer aux Madianites la vengeance d'Israël, et ensuite tu seras réuni à tes pères.'"
,"3":"Moïse dit au peuple: 'Que des hommes parmi vous s'équipent pour la guerre et qu'ils aillent combattre Madian, pour lui infliger la vengeance de Yahvé."
,"4":"Vous enverrez à la guerre mille hommes de chacune des tribus d'Israël.'"
,"5":"On recruta donc parmi les milliers d'Israël mille hommes par tribu, soit au total douze mille hommes entraînés pour la guerre."
,"6":"Moïse envoya à la guerre ces mille hommes de chaque tribu, et Pinhas, le fils d'Eléazar le prêtre, les accompagnait; il avait avec lui les objets sacrés et les trompettes éclatantes."
,"7":"Ils allèrent attaquer Madian, selon l'ordre qu'avait donné Yahvé à Moïse, et ils tuèrent tous les mâles."
,"8":"A cette occasion ils tuèrent les rois de Madian: Evi, Rékem, Sour, Hour et Réba. C'étaient les cinq rois de Madian. Ils tuèrent encore par l'épée Balaam, fils de Béor."
,"9":"Les Israélites ramenèrent prisonnières les femmes de Madian, avec leurs petits enfants. Ils ramassèrent toutes les bêtes de somme, tous les troupeaux et tout ce qui leur appartenait,"
,"10":"et ils livrèrent aux flammes toutes leurs villes habitées et leurs campements."
,"11":"Après avoir ramassé tout le butin et toutes les dépouilles, hommes et bêtes,"
,"12":"ils amenèrent les prisonniers et le butin à Moïse, au prêtre Eléazar et à la communauté des Israélites, dans les Steppes-de-Moab, près du Jourdain face à Jéricho."
,"13":"Moïse, le prêtre Eléazar et tous les chefs de la communauté sortirent du camp à la rencontre des guerriers."
,"14":"Moïse se mit alors en colère contre les chefs de l'armée, les chefs de mille et les chefs de cent qui revenaient du combat."
,"15":"Il leur dit: 'Vous avez laissé en vie les femmes!"
,"16":"Rappelez-vous, ce sont elles qui, sur la parole de Balaam, ont entraîné les Israélites à l'infidélité envers Yahvé (dans l'affaire de Baal-Péor), et aussitôt un fléau s'est abattu sur la communauté de Yahvé."
,"17":"Maintenant donc, tuez tous les petits enfants mâles et toutes les femmes qui ont connu un homme."
,"18":"Vous ne laisserez vivre que les filles qui n'ont pas encore connu d'hommes, et elles seront pour vous."
,"19":"Parmi vous, tous ceux qui ont tué un homme, tous ceux qui ont touché un cadavre, vont rester sous la tente en-dehors du camp pendant sept jours, et ils se purifieront le troisième et le septième jour. Vous ferez de même pour les prisonnières."
,"20":"Vous purifierez également tous les habits, tous les vêtements de cuir, tout ce qui est en poil de chèvre ou en bois.'"
,"21":"Le prêtre Eléazar dit aux hommes de guerre qui étaient allés au combat: 'Voici la règle d'après la loi que Yahvé a donnée à Moïse."
,"22":"Ce qui est en or, en argent, en cuivre, en fer, en étain ou en plomb,"
,"23":"en un mot, tout ce qui va au feu, vous le purifierez par le feu et par l'eau de purification; mais ce qui ne va pas au feu, vous le passerez seulement dans l'eau."
,"24":"Le septième jour, après avoir lavé vos vêtements, vous serez purs. Alors vous pourrez regagner le camp.'"
,"25":"Yahvé dit à Moïse:"
,"26":"'Avec le prêtre Eléazar et les chefs de famille de la communauté, tu feras le recensement de tout ce qui a été capturé, personnes ou bétail."
,"27":"Tu partageras le butin en deux: une moitié sera pour les hommes de guerre qui sont allés au combat, l'autre pour la communauté."
,"28":"Sur la part des hommes de guerre qui sont allés au combat, tu prélèveras la part de Yahvé: un sur cinq cents, qu'il s'agisse des personnes, du gros bétail, des ânes ou du petit bétail."
,"29":"Tu prélèveras cette part sur la moitié qui revient aux guerriers et tu la donneras au prêtre Eléazar, comme prélèvement en l'honneur de Yahvé."
,"30":"Sur la moitié qui est aux Israélites, tu prendras un pour cinquante, qu'il s'agisse de personnes, de gros bétail, d'ânes, de petit bétail ou de bêtes de somme, et tu le donneras aux Lévites qui ont la garde de la Demeure de Yahvé.'"
,"31":"Moïse et le prêtre Eléazar firent ce que Yahvé avait ordonné à Moïse."
,"32":"Le butin qu'avait ramené les hommes de guerre comprenait: 675000 têtes de petit bétail,"
,"33":"72000 têtes de gros bétail,"
,"34":"61000 ânes."
,"35":"Quant aux prisonnières, les femmes qui n'avaient pas encore couché avec un homme, elles étaient en tout 32000."
,"36":"La moitié qui revenait aux hommes de guerre comprenait donc 337500 têtes de petit bétail,"
,"37":"et la part pour Yahvé sur le petit bétail fut de 67 5."
,"38":"Il y avait 36000 têtes de gros bétail, et la part pour Yahvé fut de 72."
,"39":"Sur les 30500 ânes, la part pour Yahvé fut de 61."
,"40":"Les prisonnières étaient au nombre de 16000 et la part pour Yahvé fut de 32."
,"41":"Moïse remit donc au prêtre Eléazar la part de Yahvé, comme Yahvé l'avait ordonné à Moïse."
,"42":"Moïse avait séparé la moitié qui revenait aux Israélites de celle qui revenait aux guerriers."
,"43":"La moitié qui revenait à la communauté comprenait: 337500 têtes de petit bétail,"
,"44":"36000 têtes de gros bétail,"
,"45":"30500 ânes,"
,"46":"et 16000 prisonnières."
,"47":"Sur la moitié qui revenait aux Israélites, Moïse préleva un pour cinquante, sur les personnes comme sur les bêtes de somme, et il les donna aux Lévites qui ont la garde de la Demeure de Yahvé, comme Yahvé l'avait ordonné à Moïse."
,"48":"Les chefs de l'armée s'approchèrent alors de Moïse. Ces chefs de milliers, ou de centaines,"
,"49":"lui dirent: 'Tes serviteurs ont fait le recensement des hommes qui sont partis au combat avec nous, il n'en manque pas un seul."
,"50":"Chacun de nous offrira donc à Yahvé ce qu'il a trouvé comme objets en or: chaînettes, bracelets, anneaux, boucles, boules, afin d'obtenir pour nous la miséricorde de Yahvé.'"
,"51":"Moïse et le prêtre Eléazar acceptèrent donc tout cet or travaillé."
,"52":"Le total de l'or qu'ils avaient apporté, ce que les chefs de milliers et les chefs de centaines avaient mis de côté pour Yahvé, fut de 16750 sicles;"
,"53":"les hommes de troupe gardèrent pour eux leur butin."
,"54":"Moïse et le prêtre Eléazar reçurent donc cet or apporté par les chefs de milliers et les chefs de centaines. Ils le remirent à la Tente du Rendez-Vous, devant Yahvé, pour qu'il se souvienne des Israélites."
}`)
	CurrentBook.AddChapter(32, `{
"1":"Les fils de Ruben et les fils de Gad avaient de très, très nombreux troupeaux. Ils virent que le pays de Yazer et le pays de Galaad étaient une bonne région pour l'élevage."
,"2":"Les fils de Gad et les fils de Ruben vinrent donc trouver Moïse et le prêtre Eléazar ainsi que les chefs de la communauté. Ils leur dirent:"
,"3":"'Voyez comment sont Atarot, Dibon, Yazer, Nimra, Heshbon, Eléalé, Sébam, Nébo et Méon,"
,"4":"en un mot tout le pays que Yahvé a livré à la communauté d'Israël. Ces lieux sont bons pour l'élevage, et il se trouve que tes serviteurs ont des troupeaux.'"
,"5":"Ils ajoutèrent: 'Si tu veux nous être agréable, donne ce pays à tes serviteurs, ne nous fais pas passer le Jourdain.'"
,"6":"Moïse répondit aux fils de Gad et aux fils de Ruben: 'Ainsi vos frères iraient à la guerre, et vous, vous resteriez ici?"
,"7":"Vous allez décourager les Israélites de passer dans le pays que Yahvé leur donne."
,"8":"Vos pères ont agi de la sorte quand je les ai envoyés de Qadesh-Barné pour explorer le pays."
,"9":"Ils se sont avancés jusqu'au Vallon d'Echkol, ils ont vu le pays, et puis ils ont découragé les Israélites d'entrer dans ce pays que Yahvé leur donnait."
,"10":"Ce jour-là la colère de Yahvé s'est enflammée, et il a fait ce serment:"
,"11":"Ces hommes qui sont montés d'Egypte, depuis l'âge de vingt ans et au-dessus, ne verront pas le pays que j'ai promis par serment à Abraham, à Isaac et à Jacob, car ils ont été infidèles."
,"12":"Seuls Caleb fils de Yéfouné, le Kénizite, et Josué fils de Noun, ont suivi Yahvé sans défaillance."
,"13":"La colère de Yahvé s'est enflammée contre Israël et pendant quarante ans il les a fait errer dans le désert, jusqu'à la disparition de cette génération qui s'était mal conduite aux yeux de Yahvé."
,"14":"Vous aussi vous êtes une race de pécheurs: vous vous insurgez comme vos pères et vous voulez ranimer le feu de la colère de Yahvé contre Israël!"
,"15":"Si vous vous détournez de lui de nouveau, il nous reconduira au désert et vous aurez ainsi causé la perte de tout ce peuple.'"
,"16":"Alors ils s'approchèrent de Moïse pour lui dire: 'Nous allons construire ici des parcs pour nos troupeaux de petit bétail, et des villes pour nos petits enfants."
,"17":"Et aussitôt nous prendrons les armes et nous serons à l'avant-garde des Israélites jusqu'au jour où nous les aurons introduits dans le pays qui leur est promis. Durant ce temps, nos petits enfants resteront dans les villes fortifiées, à l'abri des habitants du pays."
,"18":"Lorsque tous les Israélites auront pris possession de leur héritage, nous reviendrons dans nos maisons."
,"19":"Nous ne demanderons pas à partager l'héritage avec eux au-delà du Jourdain ou plus loin, puisque nous aurons notre héritage de ce côté-ci du Jourdain, à l'orient.'"
,"20":"Moïse leur dit: 'Faites cela: allez en armes devant Yahvé pour combattre;"
,"21":"que chacun d'entre vous passe le Jourdain en armes devant Yahvé jusqu'au jour où il aura chassé ses ennemis de devant lui."
,"22":"Lorsque le pays sera soumis à Yahvé vous reviendrez chez vous. Alors vous serez quittes devant Yahvé et devant Israël, et cette terre sera vôtre aux yeux de Yahvé."
,"23":"Mais si vous n'agissez pas de la sorte, vous aurez péché contre Yahvé et, sachez-le bien, votre péché retombera sur vous."
,"24":"Construisez-vous donc des villes pour vos petits enfants et des enclos pour votre petit bétail et ensuite mettez en pratique la promesse que vous venez de faire.'"
,"25":"Les fils de Gad et les fils de Ruben firent cette réponse à Moïse: 'Tes serviteurs feront ce que mon seigneur ordonne."
,"26":"Nos petits fils, nos femmes, nos troupeaux et toutes nos bêtes de somme resteront dans les villes de Galaad,"
,"27":"pendant que tes serviteurs iront en armes devant Yahvé pour combattre, comme l'a dit mon seigneur.'"
,"28":"Moïse donna donc des ordres à leur sujet au prêtre Eléazar, à Josué fils de Noun et aux chefs des tribus d'Israël."
,"29":"Moïse leur dit: 'Si les fils de Gad et les fils de Ruben, armés pour le combat, passent avec vous le Jourdain devant Yahvé, lorsque le pays vous sera soumis, vous leur donnerez en propriété le pays de Galaad."
,"30":"Mais s'ils ne passent pas en armes avec vous, ils devront s'installer au milieu de vous dans le pays de Canaan.'"
,"31":"Les fils de Gad et les fils de Ruben répondirent: 'Nous ferons ce que Yahvé a dit à tes serviteurs."
,"32":"Nous passerons en armes au pays de Canaan, devant Yahvé, mais notre propriété, notre part d'héritage sera de ce côté-ci du Jourdain.'"
,"33":"C'est ainsi que Moïse donna aux fils de Gad, aux fils de Ruben et à la demi-tribu de Manassé, fils de Joseph, le royaume de Sihon roi des Amorites, et le royaume d'Og roi du Bashan. Il leur donna ces pays avec les villes situées à l'intérieur de leurs frontières et les villages environnants."
,"34":"Les fils de Gad construisirent donc Dibon, Atarot, Aroër,"
,"35":"Atrot-Chofan, Yazer, Yogboha,"
,"36":"Beth-Nimra et Beth-Haran, autant de villes fortifiées, ainsi que des parcs pour leur petit bétail."
,"37":"Les fils de Ruben construisirent Heshbon, Eléalé, Kiryatayim,"
,"38":"Nébo et Baal-Méon dont on changea les noms, et Sibma. Ils donnèrent des noms à toutes ces villes qu'ils avaient construites."
,"39":"Les fils de Makir, fils de Manassé marchèrent sur Galaad; ils le conquirent et chassèrent les Amorites qui y étaient installés."
,"40":"Moïse donna Galaad à Makir fils de Manassé, qui s'y établit."
,"41":"Yaïr fils de Manassé, s'empara des villages et les appela les Douars de Yaïr."
,"42":"Nobah s'empara de Kénat (à laquelle il donna son nom, Nobah) et des villages qui l'entouraient."
}`)
	CurrentBook.AddChapter(33, `{
"1":"Voici les étapes des Israélites après leur sortie du pays d'Egypte sous la conduite de Moïse et d'Aaron."
,"2":"Moïse nota les points de départ de chacune de leurs étapes ordonnées par Yahvé. En voici donc le relevé:"
,"3":"Ils partirent de Ramsès le quinzième jour du premier mois. C'était le lendemain de la Pâque, et les Israélites sortirent la tête haute sous les yeux de toute l'Egypte,"
,"4":"tandis que les Egyptiens enterraient tous les leurs, tous les premiers-nés qui avaient été frappés par Yahvé. Yahvé avait fait justice de leurs dieux."
,"5":"Les Israélites partirent donc de Ramsès et campèrent à Soukkoth."
,"6":"Partis de Soukkoth, ils campèrent à Etam à la limite du désert."
,"7":"Partis d'Etam, ils revinrent sur Pi-Hahirot en face de Baal-Séfon et campèrent devant Migdol."
,"8":"Partis de Pi-Hahirot, ils passèrent à travers la mer en direction du désert et, après trois jours de marche dans le désert d'Etam, ils campèrent à Mara."
,"9":"Partis de Mara, ils arrivèrent à Elim, l'oasis des douze sources et des soixante-dix palmiers, et ils y campèrent."
,"10":"Partis d'Elim, ils campèrent près de la mer des Joncs."
,"11":"Partis de la mer des Joncs, ils campèrent dans le désert de Sin."
,"12":"Partis du désert de Sin, ils campèrent à Dofka."
,"13":"Partis de Dofka, ils campèrent à Alouch."
,"14":"Partis d'Alouch, ils campèrent à Réfidim, où le peuple ne trouva pas d'eau à boire."
,"15":"Partis de Réfidim, ils campèrent dans le désert du Sinaï."
,"16":"Partis du désert du Sinaï, ils campèrent à Kibrot-Ha-Taava."
,"17":"Partis de Kibrot-Ha-Taava, ils campèrent à Hasérot."
,"18":"Partis de Hasérot, ils campèrent à Ritma."
,"19":"Partis de Ritma, ils campèrent à Rimmon-Pérez."
,"20":"Partis de Rimmon-Pérez, ils campèrent à Libna."
,"21":"Partis de Libna, ils campèrent à Rissa."
,"22":"Partis de Rissa, ils campèrent à Kéhélata."
,"23":"Partis de Kéhélata, ils campèrent au mont Chéfer."
,"24":"Partis du mont Chéfer, ils campèrent à Harada."
,"25":"Partis de Harada, ils campèrent à Makélot."
,"26":"Partis de Makélot, ils campèrent à Tahat."
,"27":"Partis de Tahat, ils campèrent à Térah."
,"28":"Partis de Térah, ils campèrent à Mitka."
,"29":"Partis de Mitka, ils campèrent à Hachmona."
,"30":"Partis de Hachmona, ils campèrent à Mosérot."
,"31":"Partis de Mosérot, ils campèrent à Béné-Yaakan."
,"32":"Partis de Béné-Yaakan, ils campèrent à Hor-Gidgad."
,"33":"Partis de Hor-Gidgad, ils campèrent à Yotbata."
,"34":"Partis de Yotbata, ils campèrent à Abrona."
,"35":"Partis de Abrona, ils campèrent à Ezyon-Gébér."
,"36":"Partis d'Ezyon-Gébér, ils campèrent dans le désert de Tsin, plus précisément à Qadesh."
,"37":"Partis de Qadesh, ils campèrent à Hor-la-Montagne sur la frontière du pays d'Edom."
,"38":"Aaron le prêtre monta à Hor-la-Montagne sur l'ordre de Yahvé, et c'est là qu'il mourut en la quarantième année après la sortie d'Egypte des Israélites. C'était le premier jour du cinquième mois,"
,"39":"Aaron était âgé de cent vingt-trois ans lorsqu'il mourut à Hor-la-Montagne."
,"40":"(Le roi d'Arad, un Cananéen qui habitait le Négueb du pays de Canaan apprit l'arrivée des Israélites.)"
,"41":"Partis de Hor-la-Montagne, ils campèrent à Salmona."
,"42":"Partis de Salmona, ils campèrent à Pounon."
,"43":"Partis de Pounon, ils campèrent à Obot."
,"44":"Partis de Obot, ils campèrent aux Ruines-des-Abarim sur la frontière de Moab."
,"45":"Partis des Ruines, ils campèrent à Dibon-Gad."
,"46":"Partis de Dibon-Gad, ils campèrent à Almon-Diblatayim."
,"47":"Partis de Almon-Diblatayim, ils campèrent au mont Abarim en face du Nébo."
,"48":"Partis des Abarim, ils campèrent aux Steppes-de-Moab près du Jourdain face à Jéricho."
,"49":"Ils campèrent près du Jourdain, entre Beth-Ha-Yéchimot et Abel-Ha-Chittim, dans les Steppes-de-Moab."
,"50":"Yahvé dit à Moïse dans les Steppes-de-Moab, près du Jourdain, face à Jéricho:"
,"51":"'Voici ce que tu diras aux Israélites: Lorsque vous aurez traversé le Jourdain pour entrer au pays de Canaan,"
,"52":"il vous faudra chasser devant vous tous les habitants du pays. Vous briserez toutes leurs idoles, vous détruirez toutes leurs statues de métal fondu et vous laisserez en ruines les hauts-lieux."
,"53":"Vous serez alors les propriétaires du pays que vous habiterez, car je vous l'ai donné pour que vous le possédiez."
,"54":"Vous vous partagerez le pays par le sort, selon vos familles. Les plus nombreux recevront un plus grand héritage, les moins nombreux recevront un héritage moindre. On donnera à chacun ce que le sort lui attribuera. Vous partagerez entre vous d'après les tribus."
,"55":"Mais si vous ne chassez pas devant vous les habitants de ce pays, ceux que vous aurez laissés deviendront comme des épines devant vos yeux et des aiguillons dans vos flancs; ils seront vos adversaires sur votre propre terre."
,"56":"Et alors, tout ce que je pensais leur faire, c'est à vous que je le ferai.'"
}`)
	CurrentBook.AddChapter(34, `{
"1":"Yahvé dit à Moïse:"
,"2":"'Voici un ordre pour les Israélites. Tu leur diras: Lorsque vous serez entrés dans le pays de Canaan, voici le territoire qui sera votre possession: c'est le pays de Canaan selon ses frontières."
,"3":"Il s'étendra au sud jusqu'au désert de Tsin à la limite d'Edom. Votre frontière au sud commencera à l'est de la Mer Salée."
,"4":"Elle descendra ensuite vers le sud dans la direction de la Montée-des-Scorpions, elle passera par Tsin et arrivera au sud à Qadesh-Barné. Elle ira ensuite vers Hasar-Addar, elle passera par Asmon,"
,"5":"et d'Asmon, la frontière tournera vers le torrent d'Egypte pour aboutir à la mer."
,"6":"La Grande Mer vous servira de frontière maritime, ce sera votre frontière occidentale."
,"7":"Voici votre frontière au nord: de la Grande Mer vous tracerez une ligne vers Hor-la-Montagne,"
,"8":"puis de Hor-la-Montagne vous tracerez encore une ligne jusqu'à l'Entrée-de-Hamat. La frontière passera à Sédad,"
,"9":"elle se prolongera vers Zifron et s'achèvera à Hasar-Enan. Voilà quelle sera votre frontière au nord."
,"10":"Pour la frontière de l'est, vous tracerez une ligne depuis Hasar-Enan jusqu'à Chéfam."
,"11":"La frontière descendra de Chéfam vers Harbel, à l'est d'Ayin, elle descendra encore pour rejoindre la rive orientale de la mer de Kinnéret."
,"12":"Ensuite la frontière longera le Jourdain pour arriver à la Mer Salée. Voilà votre pays avec les frontières qui l'entourent.'"
,"13":"Moïse donna cet ordre aux Israélites: 'Voilà le pays que vous vous partagerez par le sort. Yahvé a ordonné de le donner aux neuf tribus et à la demi tribu."
,"14":"En effet, les clans de la tribu de Ruben, les clans de la tribu de Gad et la demi-tribu de Manassé ont déjà pris leur part d'héritage."
,"15":"Ces deux tribus et cette demi-tribu ont pris leur héritage au-delà du Jourdain, à l'est.'"
,"16":"Yahvé dit encore à Moïse:"
,"17":"'Voici les noms des hommes qui feront le partage du pays: Eléazar, le prêtre, et Josué fils de Noun."
,"18":"Vous choisirez aussi un chef par tribu pour partager le pays."
,"19":"Voici les noms de ces hommes: pour la tribu de Juda, Caleb fils de Yéfouné;"
,"20":"pour la tribu de Siméon, Chémouel fils d'Ammihoud;"
,"21":"pour la tribu de Benjamin, Elidad fils de Kislon;"
,"22":"pour la tribu de Dan, le chef Bouki fils de Yogli;"
,"23":"pour les fils de Joseph, pour la tribu de Manassé, le chef Hanniel fils d'Efod;"
,"24":"et pour la tribu d'Ephraïm, le chef Kémouel fils de Chiftan;"
,"25":"pour la tribu de Zabulon, le chef Elisafan fils de Parnak;"
,"26":"pour la tribu d'Issacar, le chef Paltiel fils d'Azzan;"
,"27":"pour la tribu d'Asher, le chef Ahioud fils de Chélomi"
,"28":"pour la tribu de Nephtali, le chef Pédahel fils d'Ammihoud."
,"29":"Ce sont eux que Yahvé désigna pour partager la terre de Canaan entre les Israélites."
}`)
	CurrentBook.AddChapter(35, `{
"1":"Yahvé dit à Moïse dans les Steppes-de-Moab près du Jourdain face à Jéricho:"
,"2":"'Ordonne ceci aux Israélites: Sur votre part d'héritage, vous donnerez aux Lévites des villes pour y habiter ainsi que les pâturages qui entourent ces villes."
,"3":"Ils auront ainsi des villes pour y habiter et des pâturages pour leur gros bétail, leurs animaux et tout ce qu'ils possèdent."
,"4":"Les pâturages s'étendront autour des villes que vous aurez données aux Lévites sur une distance de mille coudées à partir des remparts."
,"5":"Les pâturages formeront un carré de deux mille coudées à l'est, deux mille coudées au sud, deux mille coudées à l'ouest et deux mille coudées au nord; la ville sera au milieu."
,"6":"En plus des six villes de refuge que vous donnerez aux Lévites pour que les meurtriers puissent s'y mettre à l'abri, vous leur donnerez quarante-deux autres villes."
,"7":"Le total des villes que vous donnerez aux Lévites sera donc de quarante-huit villes avec leurs pâturages."
,"8":"Ces villes seront prises sur l'héritage des Israélites; vous en prendrez davantage à celui qui a beaucoup, mons à celui qui a moins. Chancun donnera aux Lévites del villes en proportion de son héritage.'"
,"9":"Dieu dit à Moïse:"
,"10":"'Voici ce que tu diras aux Israélites: Lorsque vous aurez traversé le Jourdain pour entrer au pays de Canaan,"
,"11":"vous choisirez des villes qui seront pour vous des villes de refuge. Celui qui aura tué quelqu'un involontairement pourra s'y réfugier."
,"12":"Ces villes serviront de refuge contre le vengeur du sang versé, ainsi le meurtrier ne sera pas mis à mort avant d'avoir comparu en jugement devant la communauté."
,"13":"Vous vous donnerez six villes de refuge."
,"14":"Vous prendrez trois villes au-delà du Jourdain, et trois dans le pays de Canaan: elles deviendront des villes de refuge."
,"15":"Ces six villes serviront de refuge aux Israélites comme à l'étranger ou à celui qui habite au milieu de vous, pour que celui qui a tué quelqu'un involontairement puisse s'y retirer."
,"16":"Voici plusieurs cas: Un homme avait dans la main un instrument de fer et il a frappé quelqu'un qui en est mort: cet homme est un meurtrier, il sera donc mis à mort."
,"17":"Un autre avait dans la main une pierre capable de causer la mort et il en a frappé quelqu'un qui en est mort: c'est encore un meurtrier, lui aussi sera mis à mort."
,"18":"Un autre encore avait dans la main un objet de bois capable de causer la mort et il a frappé quelqu'un qui en est mort: c'est un meurtrier qui encore sera mis à mort."
,"19":"Le vengeur du sang mettra à mort le meurtrier, il pourra le tuer dès qu'il le rencontrera."
,"20":"Un homme renverse quelqu'un par haine ou lui lance volontairement quelque chose et l'autre en meurt,"
,"21":"ou bien, par méchanceté, il frappe de la main une personne qui en meurt: celui qui a frappé sera mis à mort car c'est un meurtrier. Le vengeur du sang tuera le meurtrier dès qu'il le rencontrera."
,"22":"Mais voici un homme qui a renversé quelqu'un par hasard, sans méchanceté, ou encore il lui a jeté involontairement quelque chose,"
,"23":"ou encore il a fait tomber sur lui par mégarde une pierre capable de causer la mort. Et voici que l'autre en meurt bien qu'il ne soit pas son ennemi à qui il voulait du mal."
,"24":"Dans ce cas la communauté décidera entre celui qui a frappé et le vengeur dje suis Yahvé qui demeure au milieu des Israélites.'"
}`)
	CurrentBook.AddChapter(36, `{
"1":"Les chefs de famille du clan de Galaad, fils de Makir, fils de Manassé, l'un des clans de Joseph, s'approchèrent et dirent à Moïse et à tous les chefs des familles Israélites:"
,"2":"'Yahvé a donné l'ordre à mon seigneur de partager le pays par le sort pour le distribuer entre les Israélites. Mon seigneur a aussi reçu de Yahvé l'ordre de donner l'héritage de Séloféhad, notre frère, à ses filles."
,"3":"Mais si elles se marient avec un homme d'une autre tribu Israélite, leur héritage sera retranché de l'héritage de nos pères et s'ajoutera à l'héritage de la tribu dont elles feront désormais partie. Cet héritage sera donc retranché de notre lot."
,"4":"Quand viendra le Jubilé pour les Israélites, leur héritage sera ajouté à celui de la tribu dont elles font désormais partie et leur héritage sera retranché de celui de la tribu de nos pères.'"
,"5":"Moïse donna donc cet ordre aux Israélites, selon la volonté de Yahvé. Il dit: 'La tribu des fils de Joseph a bien parlé."
,"6":"Voici ce que Yahvé ordonne à propos des filles de Séloféhad. Elles se marieront avec qui elles voudront, à condition qu'en se mariant elles restent dans une famille de la tribu de leur père."
,"7":"Ainsi l'héritage des Israélites ne passera pas d'une tribu à l'autre. Chaque Israélite restera ainsi lié à l'héritage de la tribu de son père."
,"8":"Toute fille qui possède un héritage, dans quelque tribu d'Israël que ce soit, se mariera avec un homme appartenant à la tribu de son père. Ainsi les Israélites conserveront chacun l'héritage de leur père."
,"9":"Aucun héritage ne passera d'une tribu à l'autre; chacune des tribus israélites restera liée à son héritage.'"
,"10":"Les filles de Séloféhad firent donc comme Yahvé l'avait ordonné à Moïse."
,"11":"Mala, Tirsa, Hogla, Milka et Noa, les filles de Séloféhad, se marièrent avec des hommes de leur parenté."
,"12":"Elles se marièrent dans les familles des fils de Manassé, fils de Joseph; ainsi leur héritage resta dans la tribu de la famille de leur père."
,"13":"Voilà les ordonnances et les lois que Yahvé donna par Moïse aux Israélites dans les Steppes-de-Moab, près du Jourdain en face de Jéricho."
}`)

}
func FR_LBDCC_LoadVSCCChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Le Chant Plus Haut, qui est de Salomon."
,"2":"ELLE: Baise-moi des baisers de ta bouche!,tes caresses me sont meilleures que le vin."
,"3":"La senteur de tes huiles surpasse tout arôme, ton nom est un parfum répandu: pour cela les filles t'aiment."
,"4":"Enlève-moi, courons!,Conduis-moi, ô roi, dans ta chambre, et fais notre bonheur, notre joie. Nous célébrerons tes caresses plus que le vin: pourrait-on ne pas t'aimer?"
,"5":"Sous mon teint brûlé je suis belle, filles de Jérusalem, comme les tentes des nomades, comme les draperies de Salomon."
,"6":"Ne prenez pas garde à mon teint bronzé: c'est le soleil qui m'a brûlée. Mes frères étaient fâchés contre moi, ils m'envoyèrent garder les vignes: ma vigne à moi, je ne l'avais pas gardée!"
,"7":"Fais-moi savoir, toi que mon coeur aime, comment tu mèneras le troupeau, le faisant reposer aux heures du midi; ne permets pas que je m'égare,près des troupeaux de tes compagnons."
,"8":"Le Choeur: Si tu ne te reconnais pas, ô la plus belle des femmes, sors sur les traces du troupeau, et conduis tes chevrettes,vers les parcages des bergers!"
,"9":"LUI: A la cavale des chars de Pharaon, je te compare, ô mon amour!"
,"10":"Tes joues sont charmantes entre tes pendentifs, et ton cou gracieux avec ces colliers!"
,"11":"Nous te ferons des sautoirs en or, ornés de rosettes d'argent."
,"12":"ELLE: Tandis que le roi était en son enclos, mon parfum répandait sa senteur."
,"13":"Mon aimé m'est un sachet de myrrhe,reposant entre mes seins."
,"14":"Mon aimé est une grappe de glycine, fleurie dans les vignes d'Engaddi."
,"15":"LUI et ELLE: Que tu es belle, ô mon amour, tes yeux, toute belle, sont des colombes."
,"16":"Et tu es beau, mon bien-aimé, délicieux, notre lit n'est que verdure."
,"17":"Des cèdres font les poutres de nos demeures, des cyprès en forment les parois."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Je suis comme les roses de Sharon, comme le lis des vallées."
,"2":"Comme un lis parmi les broussailles, telle est mon aimée entre toutes les filles."
,"3":"ELLE: Comme un pommier entre les arbustes, tel est mon aimé parmi les garçons. J'ai recherché son ombre et je m'y suis assise: son fruit était doux à mon palais."
,"4":"Il m'a menée à la cave des vins; là sa devise surplombait ma tête: Amour!"
,"5":"Soutenez-moi avec des raisins secs, réconfortez-moi avec des pommes, car je défaille d'amour!"
,"6":"Son bras gauche s'est glissé sous ma tête, de sa main droite il me presse contre lui."
,"7":"LUI: Je vous en prie, filles de Jérusalem, par les gazelles et les biches des champs: ne l'éveillez pas, ne réveillez pas son amour, avant qu'elle ne veuille!"
,"8":"ELLE: La voix de mon aimé! C'est lui!,D'un saut il franchit les montagnes; il bondit de colline en colline,"
,"9":"semblable à la gazelle, mon aimé, ou aux petits des biches. Voici qu'il s'est arrêté!,il est là derrière notre mur, cherchant à voir par la fenêtre, observant à travers le grillage."
,"10":"Mon aimé a répondu, il m'a dit: LUI: Lève-toi et viens, mon amie, ma colombe:"
,"11":"voici l'hiver passé, les pluies ont fait leur temps, s'en sont allées."
,"12":"Sur la terre apparaissent les fleurs, l'heure des chansons est proche, la tourterelle s'est fait entendre sur notre terre."
,"13":"Le figuier a mûri ses premiers fruits, la vigne en fleur exhale son parfum. Lève-toi, mon aimée, belle colombe, viens!"
,"14":"Ma colombe au creux des rochers, dans les retraites escarpées, montre-moi ton visage, et que j'entende ta voix, car ta voix est douce, et ton visage charmant."
,"15":"ELLE: Attrapez-nous les renards, les sales petits renards,qui ravagent nos vignes; voyez que nos vignes sont en fleur!"
,"16":"Mon aimé est à moi, et je suis à lui, berger qui fait paître parmi les lis."
,"17":"Avant que ne souffle la brise du soir, et que déjà les ombres s'effacent, reviens! Imite, bien-aimé, la gazelle,ou le petit de la biche, viens retrouver les monts embaumés!"
}`)
	CurrentBook.AddChapter(3, `{
"1":"ELLE: Sur ma couche j'ai cherché, dans la nuit, celui que mon coeur aime: je l'ai cherché et ne l'ai pas trouvé."
,"2":"Debout! que j'arpente la ville, parcourant les rues et les places, que je cherche celui que j'aime!"
,"3":"Je l'ai cherché et ne l'ai pas trouvé. Les gardes m'ont rencontrée, ceux qui font les rondes dans la ville: 'Avez-vous vu celui que j'aime?'"
,"4":"A peine les avais-je passés,que j'ai trouvé celui que j'aime. Je l'ai saisi! Je ne le lâcherai pas,que je ne l'aie conduit au logis de ma mère, à la chambre où ma mère m'a conçue."
,"5":"LUI: Je vous en prie, filles de Jérusalem, par les gazelles et les biches des champs: ne l'éveillez pas, ne réveillez pas son amour, avant qu'elle ne veuille!"
,"6":"Le Choeur: Qui monte ainsi du désert?,Cela semble une colonne de fumée, avec des vapeurs de myrrhe et d'encens, et toute la senteur des parfums d'orient."
,"7":"C'est la litière du roi Salomon!,Soixante braves l'entourent, l'élite des braves d'Israël,"
,"8":"tous portant le glaive, entraînés au combat. Chacun a l'épée sur la hanche: de nuit on ne les surprendra pas."
,"9":"Le roi s'est fait faire un palanquin, tout en bois du Liban."
,"10":"D'argent il a fait les colonnes, le baldaquin est d'or, de pourpre le siège; le fond est d'ébène incrusté."
,"11":"Sortez, filles de Jérusalem, voyez le roi avec son diadème!,Sa mère l'en a couronné,car c'était le jour de ses noces, le jour où la joie emplissait son coeur."
}`)
	CurrentBook.AddChapter(4, `{
"1":"LUI: Que tu es belle, ô mon amour!,Tu es belle et tes yeux,derrière ton voile sont des colombes. Ta chevelure est un troupeau de chèvres,qui s'accrochent aux pentes de Galaad;"
,"2":"tes dents, des brebis tondues,qui remontent toutes blanches du lavoir; chacune a sa jumelle, pas une ne l'a perdue."
,"3":"Tes lèvres sont un ruban d'écarlate,plus charmant encore que tes paroles; tes joues, sous ton voile, sont les moitiés d'un fruit vermeil;"
,"4":"ton cou, c'est la tour de David, fier donjon; mille boucliers y sont suspendus, tous les trophées ramenés par les braves."
,"5":"Tes deux seins sont deux faons mignons, les jumeaux d'une gazelle."
,"6":"Avant que ne souffle la brise du soir, et que déjà les ombres s'effacent, j'irai à la montagne de la myrrhe, aux collines de l'encens,"
,"7":"Tu es toute belle, ô mon amour, et pas de tache en toi!"
,"8":"Du Liban viens ici, épouse, viens du Liban jusqu'ici!,Laisse les crêtes de l'Amana, les sommets de Senir et de l'Hermon, quitte ces repaires de lions, ces montagnes à léopards."
,"9":"Tu as pris mon coeur, épouse, ma soeur!,tu m'as pris: d'un seul de tes regards, d'une perle de tes colliers."
,"10":"Qu'ils sont beaux tes seins, épouse, ma soeur, tes caresses me sont meilleures que le vin, tes huiles odorantes surpassent tous les baumes!"
,"11":"Tes lèvres, épouse, distillent du nectar, lait et miel se cachent sous ta langue, et la senteur de tes vêtements,est comme le parfum du Liban."
,"12":"Tu es un jardin clos, épouse, ma soeur, un jardin clos, une fontaine scellée!"
,"13":"Tes pousses se font verger de grenadiers, avec abondance de fruits exquis,et d'aromates entremêlés:"
,"14":"thym, marjolaine, safran, cannelle, romarin, aloès et myrrhe, aux senteurs les plus délicates!"
,"15":"Fontaine de mon jardin, puits d'eau vive, cascade dont les eaux descendent du Liban!"
,"16":"ELLE: Lève-toi, brise du nord, accourez vents du midi, soufflez sur mon jardin,pour qu'il répande ses parfums!,Que mon aimé vienne à son jardin,et qu'il en goûte les fruits exquis!"
}`)
	CurrentBook.AddChapter(5, `{
"1":"LUI: Je suis venu à mon jardin, épouse, ma soeur, j'ai récolté ma myrrhe et mon encens, j'ai mangé mon rayon de miel, j'ai bu mon vin avec mon lait. A table, mes amis, buvez, mes bien-aimés, enivrez-vous!"
,"2":"ELLE: Je dormais, mais mon coeur veillait. La voix de mon aimé! Il frappe: 'Ouvre-moi, ma soeur, mon amour, ma colombe, ma toute belle; ma tête est couverte de rosée, mes boucles portent les gouttes de la nuit!'"
,"3":"'J'ai ôté ma tunique, faudra-t-il me rhabiller?,Je me suis lavé les pieds, me salirai-je encore?'"
,"4":"Mon aimé a passé la main par le loquet,et mes entrailles en ont frémi."
,"5":"D'un coup je me lève pour mon aimé: la myrrhe a dégoutté de mes mains, mes doigts se sont couverts de myrrhe,sur les poignées du verrou."
,"6":"J'ai ouvert à mon aimé: Ah! mon aimé s'en était retourné!,Quelle chose! J'ai cru rendre l'âme. Je l'ai cherché, mais je ne l'ai pas trouvé; je l'ai appelé, il ne m'a pas répondu!"
,"7":"Les gardes m'ont rencontrée, ceux qui font les rondes dans la ville: ils m'ont frappée, ils m'ont blessée. Les gardes des remparts m'ont pris mon châle!"
,"8":"Je vous en prie, filles de Jérusalem: si vous trouvez mon aimé, dites-lui donc... dites-lui que je suis malade d'amour!"
,"9":"Le Choeur: Qu'a donc ton aimé que n'aient les aimés, -ô la plus belle des femmes-,qu'a donc ton aimé que les aimés n'ont pas, pour qu'ainsi tu nous supplies?"
,"10":"ELLE: Mon aimé est frais, rayonnant, reconnaissable entre dix mille."
,"11":"Sa tête? C'est de l'or fin. Ses boucles? Elles ondulent comme des palmes, noires comme l'aile du corbeau."
,"12":"Ses yeux sont des colombes,sur le bord des eaux courantes: elles se baignent dans du lait, elles se tiennent au bord d'une mer."
,"13":"Ses joues sont des massifs parfumés, un parterre de plantes odorantes. Ses lèvres sont des lis, elles distillent la myrrhe vierge."
,"14":"Ses bras sont des plaquettes d'or, enrichies de pierres de Tarsis; son ventre est un ivoire poli, incrusté de saphirs;"
,"15":"ses jambes, des colonnes d'albâtre, dressées sur des bases d'or pur. Il est comparable au Liban, unique comme le cèdre;"
,"16":"sa bouche est toute douceur, et tout en lui n'est que charme. Voilà mon aimé, voilà mon ami, filles de Jérusalem!"
}`)
	CurrentBook.AddChapter(6, `{
"1":"Le Choeur: Où s'en est-il allé, ton aimé, -ô la plus belle des femmes-,où s'est-il dirigé, ton aimé, pour que nous le cherchions avec toi?"
,"2":"ELLE: Mon aimé est descendu à son jardin, à ses parterres de plantes odorantes; il fait paître le troupeau dans son jardin, il y cueille des lis."
,"3":"Je suis à mon aimé, et mon aimé à moi, lui qui mène le troupeau parmi les lis."
,"4":"LUI: Tu es belle, ô mon amour, comme Tirsa, gracieuse comme Jérusalem."
,"5":"Détourne de moi tes yeux, ils m'ont ensorcelé. Tes boucles sont un troupeau de chèvres,qui s'accrochent aux pentes de Galaad;"
,"6":"tes dents sont des brebis tondues,qui remontent toutes blanches du lavoir; chacune a sa jumelle, pas une ne l'a perdue."
,"7":"Tes joues, sous ton voile, sont les moitiés d'un fruit vermeil."
,"8":"Les reines sont soixante, les favorites quatre-vingts, les filles, innombrables:"
,"9":"unique est ma colombe, ma parfaite!,Elle est unique pour sa mère, la préférée de celle qui l'a enfantée. Les filles, en la voyant, l'ont dite bienheureuse, reines et favorites proclament ses louanges:"
,"10":"'Qui est celle-ci dont l'aurore se lève, belle comme la lune, flamboyante comme soleil en son midi, redoutable comme une armée bien ordonnée?'"
,"11":"Au jardin des noyers je suis descendu, pour voir si cela pousse dans la vallée, pour voir si la vigne bourgeonne, si les grenadiers sont en fleur."
,"12":"Et je ne sais, d'un coup, cela m'est venu: j'ai pris la tête des chars de mon peuple!"
}`)
	CurrentBook.AddChapter(7, `{
"1":"Le Choeur: Retourne-toi, retourne-toi, Sulamite!,Retourne-toi, que nous te voyions!,LUI: Pourquoi regardez-vous la Sulamite, quand elle entre dans la danse avec les choeurs?"
,"2":"Que tes pas sont gracieux, fille de prince, dans ces sandales!,L'arrondi de tes hanches? C'est un collier,oeuvre d'une main experte."
,"3":"Ton nombril? C'est une coupe évasée, pleine de vin capiteux; ton ventre, un monceau de blé, entouré de lis;"
,"4":"tes deux seins, des faons mignons, les jumeaux d'une gazelle;"
,"5":"ton cou, une tour d'ivoire; tes yeux, les étangs de Hesbon, aux portes de Bat-Rabbim; ton nez est égal à la tour du Liban, à l'avancée rocheuse en face de Damas."
,"6":"Ta tête se dresse: c'est le mont Carmel; ta chevelure a des reflets de pourpre, un roi y est pris dans tes boucles."
,"7":"Que tu es belle, enchanteresse, mon aimée, mes délices!"
,"8":"Tu t'élèves comme le palmier, tes seins en sont les grappes."
,"9":"Je l'ai dit, je monterai au palmier: à moi les régimes des dattes!,Que tes seins ressemblent aux grappes de la vigne, que ton haleine ait la senteur des pommes,"
,"10":"et que ta bouche verse un vin généreux!,ELLE: Que ce vin s'épanche droit vers mon aimé, sitôt sorti de mes lèvres!"
,"11":"Je suis à mon aimé, il ne saurait vivre sans moi."
,"12":"Viens, mon aimé, allons aux champs, passons la nuit dans les villages."
,"13":"Tôt le matin nous irons aux vignobles,pour voir si la vigne bourgeonne, si les boutons sont en fleur; nous passerons aux grenadiers, là, je te ferai don de mes amours."
,"14":"Sens l'odeur des pommes d'amour,et tous ces fruits de choix à nos portes, anciens ou nouveaux, que je gardais pour toi, mon aimé!"
}`)
	CurrentBook.AddChapter(8, `{
"1":"Si seulement tu étais mon frère, nourri aux seins de ma mère, je pourrais partout te prendre et t'embrasser,sans que personne ne me méprise."
,"2":"Je te conduirais au logis de ma mère, à la chambre de celle qui m'a conçu; je te ferais boire de mon vin aux épices, avec le jus de mes grenades."
,"3":"Son bras gauche s'est glissé sous ma tête, de sa main droite il me presse contre lui."
,"4":"LUI: Je vous en prie, filles de Jérusalem, ne l'éveillez pas, ne réveillez pas mon aimée, avant qu'elle ne veuille!"
,"5":"Le Choeur: Qui est celle-ci qui monte du désert, appuyée sur son aimé?,LUI: Sous le pommier je t'ai éveillée, là même où ta mère t'a conçue, où devint enceinte celle qui t'enfanta."
,"6":"ELLE: Porte-moi comme un sceau sur ton coeur, ou sur ton bras, comme un anneau à cacheter. Car l'amour est fort comme la mort, il garde jalousement, plus que l'empire des morts. Ses coups sont des brûlures de feu, c'est une flamme de Yahvé."
,"7":"Les grandes eaux n'ont nul pouvoir,pour éteindre l'amour, même des fleuves ne l'engloutiraient pas. Voudrait-on donner en échange de l'amour tout ce qu'on a dans sa maison, on n'obtiendrait que du mépris!"
,"8":"Nous avons une petite soeur, elle n'a pas encore les seins formés. Que ferons-nous pour notre soeur, le jour où on la demandera?"
,"9":"Est-elle une muraille?,nous lui bâtirons des créneaux d'argent; Est-elle une porte?,nous y adosserons des étais de cèdre."
,"10":"Je suis une muraille, et mes seins en sont les tours; c'est à ce prix qu'il voit en moi,celle qui a retrouvé la paix."
,"11":"Salomon avait une vigne à Baal-Hémon; il remit sa vigne à des gardiens, Chacun lui versait pour l'usage mille pièces."
,"12":"Prends, Salomon, tes mille pièces, et que les gardiens s'en fassent deux cents: moi, je garde ma vigne!"
,"13":"Toi qui demeures dans les jardins, tes compagnons sont attentifs à ta voix; et moi, ne l'entendrai-je pas?"
,"14":"Enfuis-toi, mon aimé, comme la gazelle ou le petit de la biche, sur les crêtes des monts embaumés!"
}`)

}
func FR_LBDCC_LoadVSEEChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Paroles de Qohélet: c'est le fils de David, roi d'Israël à Jérusalem."
,"2":"Rien qui tienne! disait Qohélet, rien qui tienne: on n'a de prise sur rien!"
,"3":"Que reste-t-il à l'homme de toute sa peine quand il s'affaire ainsi sous le soleil?"
,"4":"Une génération s'en va, une autre vient; la terre, elle, reste là toujours."
,"5":"Le soleil s'est levé, le soleil s'est couché, et toujours pressé il revient au départ."
,"6":"Soufflant du nord, et puis du sud, le vent tourne et retourne et revient sur ses tours."
,"7":"Tous les fleuves vont à la mer, et la mer jamais n'est pleine; sur les mêmes rives qui voyaient leur cours ils ont repris leur course."
,"8":"Il y a trop à dire: on s'en fatiguerait; personne ne saurait tout dire. L'oeil ne terminera pas de voir, l'oreille n'aura jamais fini d'entendre."
,"9":"Mais ce qui arrivera, c'est ce qui est arrivé, et tout ce qu'on fera, on l'a déjà fait: il n'y a rien de neuf sous le soleil!"
,"10":"Quelque chose arrive et l'on te dit: 'Regarde: voilà du nouveau!' Mais non, les choses qui sont là sous nos yeux, on les a eues déjà aux siècles passés."
,"11":"On ne se souvient pas des choses d'autrefois: ce sera pareil pour les affaires récentes, et tout ce qui peut venir dans le futur, un jour personne ne s'en souviendra."
,"12":"Moi, Qohélet, j'ai été roi d'Israël à Jérusalem,"
,"13":"et je me suis appliqué à comprendre tout ce qui se fait sous le ciel, à en acquérir la sagesse. Mais c'est une tâche ingrate que Dieu a donnée là aux humains: il y a tout pour les humilier."
,"14":"J'ai regardé de près tout ce qui se fait sous le soleil: on ne tient rien, on court après le vent!"
,"15":"On ne peut pas redresser ce qui est tordu, on ne corrige pas ce qui manque."
,"16":"J'ai dû me convaincre: 'Me voici grand, et plus avancé dans la sagesse que tous ceux qui avant moi ont régné à Jérusalem. J'ai accumulé les connaissances et le savoir."
,"17":"Je me suis appliqué à voir où sont la sagesse et la science, la sottise et la folie. Mais maintenant je le vois: même cela c'est courir après le vent."
,"18":"Plus grande est la sagesse, plus grands sont les chagrins; celui qui progresse en sagesse, s'enfonce aussi dans la souffrance.'"
}`)
	CurrentBook.AddChapter(2, `{
"1":"Je m'étais dit: 'Faisons donc l'expérience de la joie: je veux connaître le bonheur!' Mais cela aussi n'est que du vent."
,"2":"J'ai fini par dire: 'Le rire? Une sottise. La joie? A quoi bon?'"
,"3":"Car dans ma recherche de la sagesse je m'étais donné aux plaisirs du vin. Je voulais une expérience de la folie, pour savoir à la fin ce qu'il convient aux hommes de faire sous le ciel, durant les jours comptés de leur vie."
,"4":"J'ai entrepris de grands travaux. Je me suis bâti des maisons, je me suis planté des vignes,"
,"5":"je me suis aménagé des jardins et des vergers: j'y ai planté tous les arbres fruitiers."
,"6":"Je me suis creusé des citernes pour arroser mes plantations."
,"7":"J'ai acheté des esclaves, hommes et femmes, et d'autres me sont nés dans la maison. J'ai eu des troupeaux de gros et de petit bétail, bien plus que quiconque avant moi à Jérusalem."
,"8":"J'ai amassé de l'or et de l'argent, toutes les richesses qui me venaient des rois et des provinces. J'ai eu des chanteurs et des chanteuses, et ce qui est tout le plaisir d'un homme: la femme, beaucoup de femmes."
,"9":"Je suis devenu grand, j'ai surpassé tous ceux qui m'avaient précédé à Jérusalem, et ma sagesse ne m'avait pas quitté."
,"10":"Tout ce que mes yeux désiraient, je me le suis accordé; il n'y a pas de plaisir dont je me sois privé, car je trouvais ma joie dans tout ce que je faisais. Là au moins j'ai recueilli le fruit de ma peine."
,"11":"Puis j'ai réfléchi à tous les travaux que j'avais entrepris et aux peines que m'avait coûtées leur réalisation. Eh bien, on ne tient rien, on court après le vent; il n'y a rien à gagner sous le soleil!"
,"12":"Car je me suis reposé la question de la sagesse, de la sottise et de la folie: Comment sera celui qui va me succéder sur le trône? (On sait ce qu'il a fait.)"
,"13":"J'ai vu que la sagesse l'emporte sur la folie, autant que la lumière sur l'obscurité:"
,"14":"'Le sage a les yeux ouverts, alors que le sot marche dans le noir'. Mais je le sais aussi: 'Il n'y a pour tous qu'un même sort.'"
,"15":"Je me suis dit: Si le sort de l'insensé est aussi le mien, qu'est-ce que j'ai gagné avec ma sagesse?' Et là encore j'ai vu qu'on n'a prise sur rien."
,"16":"Car à la longue on ne se souvient pas plus du sage que du sot; et si tout doit être oublié dans la suite des temps, comment parler de sagesse et de folie?"
,"17":"Et j'ai trouvé la vie détestable: pour moi, tout ce qui se fait sous le soleil est une mauvaise affaire, tout nous échappe, on court après le vent."
,"18":"J'ai détesté toute la peine que je m'étais donnée sous le soleil, puisque je dois tout laisser à celui qui viendra après moi."
,"19":"Qui sait s'il sera sage ou insensé? Mais c'est lui qui recueillera ce fruit de mes travaux sous le soleil, où sont passées tout à la fois ma sagesse et mes peines: voilà que tout nous échappe!"
,"20":"J'ai donc commencé à regretter en moi-même tout ce pour quoi je m'étais affairé sous le soleil:"
,"21":"après avoir travaillé avec intelligence, savoir-faire et habileté, il faudra tout laisser à un autre qui n'a rien fait. Voilà une très mauvaise affaire: tout nous échappe! "
,"22":"Comment l'homme va-t-il jouir de ce pour quoi il a peiné sous le soleil, avec tant de fatigues et de soucis?"
,"23":"Oui, tous ses jours sont pénibles, il en perd le sommeil et même de nuit son coeur n'a pas de repos. Voilà bien une chose qui n'a pas de sens."
,"24":"L'homme n'a rien de plus à attendre que de manger et de boire, et de se sentir bien. Mais j'ai vu que là aussi est la main de Dieu."
,"25":"Car qui peut manger ou boire, si ce n'est grâce à lui!"
,"26":"Dieu donne à celui qui lui plaît la sagesse, la science et la joie; le pécheur aura la charge d'amasser et de s'enrichir pour que tout passe à celui qui est agréable à Dieu. Là encore il y aura déception: on aura couru après le vent."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Il y a sous le soleil un moment pour tout, et un temps pour chaque entreprise:"
,"2":"un temps pour naître, et un temps pour mourir; un temps pour planter, un autre pour déraciner la plante;"
,"3":"un temps pour tuer, et un temps pour soigner; un temps pour démolir, et un temps pour bâtir;"
,"4":"un temps pour pleurer, et un temps pour rire; un temps pour le deuil, et un temps pour la danse;"
,"5":"un temps pour jeter les pierres, un autre pour les ramasser; un temps pour les embrassements, un temps pour s'en abstenir;"
,"6":"un temps pour chercher, et un temps pour perdre; un temps pour conserver, un temps pour se débarrasser;"
,"7":"un temps pour déchirer, et un temps pour recoudre; un temps pour se taire, et un temps pour parler;"
,"8":"un temps pour aimer, et un temps pour haïr; un temps pour la guerre, et un temps pour la paix:"
,"9":"à la fin, quel profit retirera-t-on de ses peines?"
,"10":"J'ai bien considéré la tâche que Dieu impose aux humains pour les humilier."
,"11":"Toute oeuvre de lui vient bien en son temps, mais il a mis l'éternité dans leur coeur; or l'homme ne trouve pas le sens de l'oeuvre divine depuis le début jusqu'à la fin."
,"12":"J'ai vu alors que leur vrai bien est la joie - et de faire le bien durant leur vie."
,"13":"Si quelqu'un peut manger et boire, s'il trouve le bonheur dans son travail, c'est là un don de Dieu."
,"14":"J'ai vu que tout ce que Dieu fait est là pour toujours; il n'y a rien à ajouter, rien à supprimer. Et Dieu agit de façon qu'on le respecte."
,"15":"Ce qui est a déjà existé; ce qui sera a déjà été; Dieu va rechercher dans ce qui était passé."
,"16":"J'ai vu d'autres choses sous le soleil: à la place du droit on trouve l'injustice; au siège de la justice on trouve le méchant."
,"17":"Et je me suis dit en moi-même: Dieu jugera le juste et le méchant, car il y a temps pour toute chose, et rien n'échappe à son jugement."
,"18":"Je me suis dit en moi-même, pensant à ce qu'est l'homme: Dieu les met à l'épreuve, il leur montre qu'ils ne sont que des bêtes."
,"19":"Car l'homme et la bête ont le même sort; la mort est pour l'un comme pour l'autre. Le souffle est le même et l'homme n'a rien de plus que la bête. Voilà encore une chose qui n'a pas de sens,"
,"20":"que tout aille au même endroit. Tout est venu de la poussière, tout est retourné en poussière. "
,"21":"Qui dira si pour l'homme le souffle part vers les hauteurs, et si pour la bête il retombe à la terre?"
,"22":"Et j'ai vu que l'homme n'a rien de plus à espérer que de jouir du fruit de ses travaux; telle est sa part. Mais ce qu'il y aura après, qui le lui fera voir?"
}`)
	CurrentBook.AddChapter(4, `{
"1":"J'ai pensé de nouveau à tous ceux qu'on opprime sous le soleil. Voici les pleurs des opprimés, et nul ne les console; ils souffrent la violence de leurs oppresseurs, et personne pour leur venir en aide!"
,"2":"Je féliciterais le mort de ce qu'il est mort, plutôt que le vivant pour être encore en vie."
,"3":"Et plus heureux que l'un et l'autre, celui qui n'existe pas encore, car il n'a pas vu tout le mal qui se fait sous le soleil."
,"4":"Si je regarde toute la peine que les hommes se donnent, toute la course au succès, ce n'est que jalousie de l'un envers l'autre. Tout cela est insensé, on court après le vent!"
,"5":"Le sot qui se croise les bras, dévore sa propre chair."
,"6":"Mais jouir du repos quand une main est pleine vaut mieux que le tourment pour remplir l'autre main."
,"7":"Car j'ai vu sous le soleil une autre absurdité:"
,"8":"Voici un homme seul, il n'a personne, ni fils ni frère, et il n'en finit pas de s'exténuer au travail, jamais il n'est assez riche. Mais pour qui est-ce que je peine, pour qui ces privations? Voilà une mauvaise affaire: on ne tient rien."
,"9":"Il vaut mieux être deux que seul: le travail rendra mieux."
,"10":"Si l'un tombe, son compagnon le relèvera. Celui qui est seul, malheur à lui s'il tombe: personne ne le relèvera."
,"11":"De même, si l'on se couche à deux on se réchauffe; personne ne réchauffe celui qui est seul."
,"12":"Seul, on peut être agressé, à deux on fera face; et si le fil est triple, il ne cèdera pas facilement."
,"13":"Mieux vaut un garçon pauvre et de bon sens qu'un roi vieux et sot, qui ne sait plus se faire conseiller."
,"14":"Et cela, même s'il est passé de la prison au pouvoir, même s'il est né comme le dernier de tous dans le royaume."
,"15":"J'ai vu tous les vivants qui s'agitent sous le soleil prendre parti pour le nouveau, pour le jeune qui prenait la succession."
,"16":"La foule n'en finissait pas, de tous ceux qui venaient lui rendre hommage. Un jour, pourtant, on ne sera plus content de lui. Voilà encore des choses qui ne se tiennent pas: on court après le vent."
,"17":"Prends garde à ta démarche, quand tu vas à la Maison de Dieu. Présente l'offrande comme un homme averti, non comme les sots: ils offrent le sacrifice et ils ne voient pas qu'ils font le mal."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Ne parle pas trop vite, ne précipite pas ta décision lorsque tu t'engages devant Dieu, car Dieu est au ciel, et toi sur la terre: ne t'engage pas trop."
,"2":"Trop de soucis, tu te perds dans les rêves; trop de promesses, tu parleras de travers."
,"3":"Si tu as fait à Dieu une promesse, ne tarde pas à l'accomplir, car Dieu n'aime pas les sots: si tu l'as promis, fais-le."
,"4":"Il vaut mieux ne rien lui promettre que de promettre sans tenir ta parole:"
,"5":"vois-tu que, à cause d'elle, une épreuve te frappe, et que tu doives reconnaître devant son ange: 'Je n'avais pas réfléchi!' As-tu besoin d'une promesse qui va irriter Dieu et t'amener des ennuis?"
,"6":"C'est quand on rêve de trop qu'on s'engage à tout moment sans réfléchir: toi, aie la crainte de Dieu."
,"7":"Si tu vois dans la province le pauvre opprimé, le droit et la justice violés, ne t'effraie pas: au-dessus d'une autorité il y a un échelon supérieur, et au-dessus d'elles d'autres plus élevés."
,"8":"Le pays ira de l'avant si le roi se met au service des campagnes."
,"9":"Celui qui aime l'argent n'aura jamais assez d'argent; qui aime la richesse n'en profitera pas. Là encore tout est déception."
,"10":"Là où la richesse se multiplie, on voit se multiplier ceux qui la mangent: le propriétaire la verra, il n'aura pas d'autre avantage."
,"11":"Le sommeil sera doux au travailleur, qu'il ait peu mangé ou beaucoup; le riche a beau être rassasié, il ne dormira pas pour autant."
,"12":"Il y a sous le soleil une autre malchance, et je l'ai vue: la richesse qu'un homme gardait pour son propre malheur."
,"13":"Il a perdu cette richesse dans une mauvaise affaire, il a un fils, et il n'a rien à lui laisser."
,"14":"L'homme est sorti nu du sein de sa mère, et il s'en retourne nu comme il était venu. Il n'emporte rien de tous les travaux que ses mains ont menés à bien."
,"15":"Cela encore est une vraie malchance: s'en aller dans le même état où l'on était venu. Qu'a-t-on gagné d'autre que d'avoir travaillé pour du vent?"
,"16":"Tant de jours où l'on a mangé son pain noir, tant de déceptions, de fatigues et de mécontentements!"
,"17":"Voilà ce que je vois: tout le bien qu'il peut attendre, c'est de manger et de boire, de voir prospérer les travaux auxquels il a travaillé sous le soleil durant les jours comptés de sa vie, tels que Dieu les lui a accordés: voilà sa part."
,"18":"Lorsqu'un homme a reçu de Dieu possessions et richesses, lorsqu'il peut en manger, en jouir, et profiter de son travail, c'est là un don de Dieu."
,"19":"Alors il ne songe plus au peu de durée de la vie: Dieu lui a mis de la joie plein le coeur."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Voici un malheur que j'ai vu sous le soleil, et qui écrase un homme."
,"2":"Quelqu'un a reçu de Dieu fortune, richesse et considération: tous les désirs de son âme ont été satisfaits. Mais Dieu ne lui accorde pas d'en manger, et c'est quelqu'un d'autre qui en profite. Voilà quelque chose qui ne va pas: on n'a prise sur rien."
,"3":"Si quelqu'un avait une centaine d'enfants et vivait de très longues années, mais que durant tout ce temps il ne connaisse pas le bonheur et qu'ensuite il n'ait pas de sépulture - je dis que l'enfant mort-né est plus heureux que lui."
,"4":"Cet enfant est venu pour rien, juste pour retourner dans le noir, et son nom même restera dans le noir."
,"5":"Il n'a pas vu ni connu le soleil, mais il a le repos, et non pas l'autre."
,"6":"Cet homme aurait pu vivre deux fois mille ans, mais s'il ne connaît pas le bonheur? On pourra bien dire que tout va au même lieu."
,"7":"Tout le travail de l'homme est pour sa bouche, mais son âme n'en est pas remplie pour autant."
,"8":"Où est l'avantage du sage sur le sot? Quel est l'avantage pour un pauvre lorsqu'il sait se conduire dans la vie?"
,"9":"Il vaut mieux croire à ce qu'on voit que se laisser mener par ses désirs: là encore on ne tient rien et on court après le vent."
,"10":"Tout ce qui existe a déjà reçu son nom, et l'on sait ce qu'est un homme: il ne peut pas discuter avec plus fort que lui."
,"11":"Beaucoup de paroles? Il y aura beaucoup de vide: qu'est-ce qu'on aura gagné?"
,"12":"Qui sait ce qu'est pour l'homme le bonheur de la vie, durant ses jours comptés et fragiles qui passent comme une ombre? Qui révèlera à l'homme ce qui viendra sous le soleil après lui?"
}`)
	CurrentBook.AddChapter(7, `{
"1":"Une bonne réputation vaut plus qu'un bon parfum: le jour de la mort passe donc avant celui de la naissance."
,"2":"Va à la maison du deuil plutôt qu'à la maison en fête: tu y verras la fin de tout homme, et pour le vivant il est bon d'y réfléchir."
,"3":"Mieux vaut le chagrin que le rire: la tristesse sur le visage promet un coeur meilleur."
,"4":"La maison du deuil retient l'attention des sages, la maison en fête capte l'attention des sots."
,"5":"Sois l'homme qui écoute la réprimande d'un sage et non celui qui suit la chanson des sots;"
,"6":"le sot a ri: crépitement de ronces brûlant sous la marmite. Voilà encore une chose déroutante: "
,"7":"la corruption pervertit même le sage, les cadeaux étouffent sa conscience."
,"8":"Mener à bien une entreprise vaut mieux que la commencer: c'est la persévérance qui compte, et non la prétention."
,"9":"Ne laisse pas ton esprit céder à la colère: la colère s'installe chez le sot."
,"10":"Ne dis pas: 'Comment étaient les temps anciens? Sûrement meilleurs que ceux d'aujourd'hui.' Ce n'est pas la sagesse qui te fait poser cette question."
,"11":"La sagesse est utile pour celui qui a des terres: combien plus pour ceux qui voient le soleil!"
,"12":"La sagesse est une protection, tout comme l'argent; mais l'avantage du savoir, c'est que la sagesse donne la vie à ceux qui la possèdent."
,"13":"Regarde l'oeuvre de Dieu: qui pourrait redresser ce qu'il a courbé?"
,"14":"Aux jours heureux goûte le bonheur, et au jour du malheur, ouvre les yeux: Dieu les a disposés l'un et l'autre de telle sorte que personne ne peut savoir ce que sera sa fin."
,"15":"J'ai vu de tout durant mes jours, en cette vie ou l'on n'a prise sur rien: il y a des justes qui périssent, malgré leur justice, et des méchants qui prolongent leurs jours, en dépit de leur méchanceté."
,"16":"Ne sois pas juste à l'excès, et ne fais pas le sage plus qu'il ne faut: tu pourrais te démolir."
,"17":"Ne sois pas méchant à l'excès et ne te conduis pas comme un insensé: tu pourrais mourir avant l'heure."
,"18":"Il est bon de prendre un parti sans renoncer tout à fait à l'autre: celui qui craint Dieu tirera profit de l'un et de l'autre."
,"19":"La sagesse rend le sage plus fort que les dix chefs dans leur cité."
,"20":"Il n'y a sur terre aucun homme assez juste pour faire le bien sans jamais pécher."
,"21":"Ne prête donc pas attention à tout ce que l'on raconte: ainsi tu n'entendras pas ton serviteur dire du mal de toi."
,"22":"Toi-même d'ailleurs, tu le sais bien, tu as souvent dit du mal des autres."
,"23":"Tout cela, je l'ai expérimenté: c'est une question de sagesse. Je m'étais dit: 'Je veux être un sage.' Mais elle était si loin de moi!"
,"24":"Elle est au -delà de tout ce qui existe."
,"25":"Quand je me suis appliqué à savoir, à approfondir, à chercher la sagesse et le pourquoi des choses, j'ai reconnu que la méchanceté est une sottise et une folie."
,"26":"J'ai tiré cette conclusion que la femme est plus amère que la mort: elle est pour l'homme un piège, son coeur est un filet et ses bras, des chaînes. Celui qui plaît à Dieu lui échappe, mais le pécheur s'y fait prendre."
,"27":"Voilà ce que j'ai trouvé - disait Qohélet - réfléchissant sur toutes choses, l'une après l'autre, pour comprendre."
,"28":"Cependant je cherche encore: un homme entre mille, je l'ai trouvé, mais une femme dans tout le nombre, je ne l'ai pas trouvée."
,"29":"Et voilà encore ce que j'ai vu: l'être humain, Dieu l'a fait simple, mais eux, ils se sont cherché mille problèmes."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Qui est devenu un sage, qui est capable d'expliquer les choses? La sagesse chez un homme illumine son visage et transforme ce qu'il avait de dur."
,"2":"Observe l'ordre du roi, puisque tu lui as juré fidélité devant Dieu."
,"3":"Si tu veux t'éloigner de lui, pense-le deux fois, ne te mets pas dans une mauvaise affaire: ce que le roi veut, il le fera."
,"4":"La parole du roi sera le point final: personne ne lui dira 'Que fais-tu là?'"
,"5":"'Celui qui garde les commandements ne craindra pas le malheur. Celui qui a la sagesse en son coeur verra venir l'heure du jugement."
,"6":"Car l'heure du jugement viendra pour toute chose'. C'est vrai, mais c'est une grande misère pour les humains"
,"7":"que de ne pas savoir ce qui leur arrivera: qui leur dira comment les choses se passeront?"
,"8":"Aucun homme n'est maître du souffle de vie, aucun n'est maître du jour de sa mort. C'est un combat impitoyable et il n'y a pas de méchanceté qui puisse nous sauver."
,"9":"Tout cela je l'ai vu lorsque j'ai réfléchi sur tout ce qui se passe sous le soleil, sur la façon qu'ont les hommes de dominer les uns sur les autres et de se faire du mal."
,"10":"C'est ainsi que j'ai vu des hommes mauvais accompagnés à leur tombeau depuis le lieu saint, et dans la ville on oubliait tout ce mal qu'ils avaient fait. Voilà encore une chose qui nous déroute: "
,"11":"comme les actions mauvaises ne sont pas immédiatement jugées et punies, les hommes trouvent là un encouragement à faire le mal."
,"12":"Car le pécheur a beau faire cent fois ce qui est mal, on lui laisse tout son temps."
,"13":"Le bonheur n'est pas pour le méchant; il ne prolongera pas ses jours, mais il passera comme une ombre, parce qu'il n'a pas la crainte de Dieu.)"
,"14":"Voilà ce qui est déroutant sur cette terre: il y a des justes à qui arrive tout ce qui conviendrait aux méchants pour tout ce qu'ils ont fait, et il y a des méchants à qui arrive ce qui conviendrait aux justes: cela encore n'a pas de sens."
,"15":"Pour ma part, j'aime qu'on goûte la joie, car le seul bonheur pour l'homme sous le soleil, c'est de manger et de boire, et de se réjouir: c'est là sa part tandis qu'il trime tout au long des jours comptés de sa vie sous le soleil, tels que Dieu les lui donne."
,"16":"Comme je m'appliquais à connaître et que j'observais toutes les activités auxquelles on se livre sur la terre, j'ai vu que l'oeil humain n'a de repos ni de jour ni de nuit."
,"17":"J'ai observé l'oeuvre de Dieu dans son ensemble: l'homme ne peut pas trouver un sens à l'oeuvre qui se fait sous le soleil. L'homme a beau se fatiguer et chercher, il ne trouve pas, et même quand le sage prétend savoir, il n'a rien trouvé."
}`)
	CurrentBook.AddChapter(9, `{
"1":"J'ai donc réfléchi à tout cela et j'ai vu clairement que les justes, les sages et leurs travaux, sont dans la main de Dieu. Lui, en veut-il? Ne veut-il pas? Les humains ne le savent pas: tout peut leur arriver."
,"2":"Et c'est déroutant que tous aient le même sort: le juste et le méchant, l'homme pur et celui qui ne l'est pas, celui qui offre des sacrifices et celui qui n'en offre pas, celui qui s'engage par un voeu et celui qui craint de le faire."
,"3":"Voilà où est le mal dans tout ce qui se fait sous le soleil: tous ont le même sort; voilà pourquoi les fils d'Adam ont plein d'idées méchantes, et leurs pensées déraillent tout au long de leur vie en attendant de terminer chez les morts."
,"4":"Tant qu'on se voit parmi les vivants, on garde son assurance: 'Chien vivant vaut mieux que lion mort.'"
,"5":"Les vivants savent qu'ils mourront; les morts, eux, ne savent rien. Ils n'ont plus rien à attendre: ils ne sont plus qu'un souvenir oublié."
,"6":"Ils ont pu aimer, haïr, avoir des ambitions: tout s'est perdu et jamais plus ils ne prendront part à tout ce qui se fait sous le soleil."
,"7":"Puisses-tu prendre plaisir au pain que tu manges et boire ton vin d'un coeur joyeux: ce sera un signe que Dieu est satisfait de ton travail."
,"8":"Puisses-tu porter toujours des habits blancs, et n'être pas à court d'huile pour parfumer ta tête."
,"9":"Jouis de la vie avec la femme que tu aimes, le temps que s'envolent les jours de ta vie. Car c'est là ta part en cette vie tout le temps que tu peines sous le soleil."
,"10":"Tout ce qui sera à ta portée et que tu te sens capable de faire, fais-le; car au séjour des morts où tu t'en vas, il n'y a ni travaux, ni problèmes, ni connaissance, ni sagesse."
,"11":"J'ai vu encore ceci sous le soleil: le plus rapide n'est pas sûr de gagner la course, ni le plus courageux de gagner la bataille; le pain n'est pas assuré pour les sages, ni la richesse pour les intelligents, ni la meilleure place pour celui qui sait y faire. Car pour tous il y a l'occasion et il y a la malchance."
,"12":"Personne ne sait quand viendra son heure: les fils d'Adam se voient surpris par le malheur comme le poisson pris dans la nasse, comme l'oiseau sur qui se referme le piège."
,"13":"Parlons de sagesse: voici ce que j'ai vu sous le soleil, et qui ne m'a pas paru une petite chose."
,"14":"Il y avait une ville petite, avec peu d'habitants. Un grand roi se présente et l'assiège avec murs et fossés."
,"15":"Dans la ville, pourtant, il y a un homme plein d'astuce, un homme tout ordinaire, et grâce à son astuce la ville est sauvée. Mais c'était un homme tout ordinaire, et personne n'a plus pensé à lui."
,"16":"Alors, moi je dis: la sagesse passe avant les exploits, mais quand il s'agit des pauvres, on méprise leur sagesse: ils peuvent parler, on ne les écoute pas."
,"17":"Les paroles des sages, dites dans le calme, font plus d'effet que le tapage d'un chef d'écervelés."
,"18":"La sagesse a plus de pouvoir que les armes: une seule personne qui s'en moque détruit beaucoup de bonnes choses."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Une mouche morte gâte tout le flacon de parfum; quelques folies réduisent à rien beaucoup de sagesse."
,"2":"Le coeur du sage tient sa droite, le coeur du sot est sur la gauche;"
,"3":"Il marche sur la route à contresens, et de tous ceux qui le croisent il dit: 'Tiens, Voilà encore un sot!'"
,"4":"Si le prince se met en colère contre toi, ne quitte pas ta place, le calme évitera bien des malheurs."
,"5":"J'ai vu un autre mal sous le soleil, et l'on serait tenté de dire que l'erreur vient du Souverain:"
,"6":"les incapables sont en haut de l'échelle, et ceux qui valent restent en bas."
,"7":"J'ai vu des serviteurs qui étaient à cheval, et des nobles qui allaient à pied, comme des serviteurs."
,"8":"On creuse un trou, on peut y tomber; on démolit un mur et l'on se fait mordre par un serpent;"
,"9":"on extrait des pierres, on peut s'y meurtrir; on fend du bois, on risque de se blesser;"
,"10":"si le fer est émoussé, il faudra frapper plus fort: en tout cela on gagne avec la sagesse."
,"11":"Mais peut-être le serpent ne se laisse pas charmer, et il mord: du coup, le charmeur n'aura rien gagné."
,"12":"Les paroles du sage sont une grâce, mais les propos du sot le détruisent, lui le premier."
,"13":"Son point de départ est une bêtise, et la conclusion est dangereuse autant qu'absurde."
,"14":"C'est la sottise qui lui inspire tant de paroles."
,"15":"Le sot est vite épuisé: il ne sait pas encore le chemin qui mène à la ville."
,"16":"Malheur à toi, pays dont le roi est un gamin, et dont les chefs font la fête dès le matin!"
,"17":"Heureux es-tu, pays dont le roi est un prince bien né, et dont les chefs mangent au temps voulu, pour prendre des forces et non pour s'enivrer."
,"18":"Par manque d'entretien la charpente s'écroule; avec des mains paresseuses, la maison prend l'eau."
,"19":"On fait des banquets pour se divertir, on se donne du bon temps avec les vins: l'argent résoudra tout!"
,"20":"Ne maudis pas le roi, même en pensée; ne maudis pas le puissant, même dans le secret de ta chambre: un oiseau du ciel pourrait lui en porter la rumeur, une paire d'ailes lui ferait connaître l'affaire."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Jette ton pain à la surface des eaux; après un temps il te reviendra."
,"2":"Partage avec des associés, huit plutôt que sept, car tu ne sais pas quel malheur peut frapper le pays."
,"3":"Quand les nuages sont pleins, ils déversent la pluie sur la terre. Comme l'arbre est tombé, que ce soit au nord ou au sud, il reste où il est tombé."
,"4":"Observer le vent, ce n'est pas semer; considérer les nuages, ce n'est pas moissonner."
,"5":"Tu ne sais pas par où l'esprit est venu à l'enfant dans le sein de la femme enceinte: tu ignores tout autant l'oeuvre de Dieu prise dans son ensemble."
,"6":"Sème ton grain au matin, et que le soir encore ta main s'active: tu ne sais pas lequel des deux sera profitable, peut-être l'un et l'autre."
,"7":"Que la lumière est douce, et que c'est bon de voir de nos yeux le soleil!"
,"8":"Même après de nombreuses années, que l'homme sache les savourer toutes; mais qu'il garde en tête les jours sombres: pour l'avenir rien n'est sûr."
,"9":"Connais le bonheur, garçon, alors que tu es jeune; dirige bien ton coeur aux jours de ta jeunesse. Choisis toi-même ton chemin, comme il te semble meilleur, sans oublier que Dieu te demandera compte de tout."
,"10":"Ne laisse pas l'amertume s'installer chez toi, ni la maladie dans ton corps: jeunesse et cheveux noirs sont traîtres!"
}`)
	CurrentBook.AddChapter(12, `{
"1":"Pense à ton Créateur aux jours de ta jeunesse, avant la venue des jours mauvais, des années qui s'approchent, dont tu diras: 'Je n'en attends plus rien',"
,"2":"avant que le soleil, la lumière, la lune et les étoiles se perdent dans le noir, et que reviennent les nuages sitôt après la pluie."
,"3":"C'est alors que tremblent les gardiens de la maison, c'est le temps où se courbent les porteurs, où les meules, ce qu'il en reste, cessent de moudre, et les voyantes sont dans le noir derrière leurs fenêtres; "
,"4":"l'heure où la porte se ferme sur la rue, et le bruit du moulin s'arrête; où la voix de l'oiseau ne réveille plus, et les chansons se sont tues."
,"5":"On redoute alors les montées, et les fondrières sur le chemin; l'amandier est en fleurs, la sauterelle est repue, le câprier donne son fruit. Voici l'homme en route pour sa maison d'éternité, et les pleureuses faisant le cercle au coin de la rue."
,"6":"Le fil d'argent n'ira pas plus loin: on s'est arrêté de le filer; la lampe d'or s'est brisée, la cruche s'est fracassée à la fontaine, et la poulie sur le puits a cédé."
,"7":"La poussière retourne à la terre dont elle était venue, et l'esprit remonte à Dieu qui l'a donné."
,"8":"Rien qui tienne! disait Qohélet, on n'a de prise sur rien!"
,"9":"Oui, Qohélet était un sage, un sage qui a enseigné le savoir au peuple; il a pesé, examiné et corrigé un grand nombre de proverbes."
,"10":"Qohélet s'efforçait de bien tourner ses sentences, il mettait par écrit des vérités, de façon directe."
,"11":"Les paroles des sages sont comme des aiguillons; un recueil de sentences est comme une palis sade où le même pasteur a tout assemblé."
,"12":"Garde-toi, mon fils, d'y ajouter: quand on multiplie les livres, c'est sans fin, et trop d'étude épuise le corps."
,"13":"Conclusion du discours: tout a été dit. Crains Dieu et observe ses commandements: c'est là le tout de l'homme."
,"14":"Car Dieu jugera toutes les actions, même ce qui est caché, le bien comme le mal."
}`)

}
func FR_LBDCC_LoadVSEIChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Toute sagesse vient du Seigneur; elle reste auprès de lui pour toujours."
,"2":"Les grains de sable au bord des mers, les gouttes de la pluie, les jours déjà écoulés: qui pourrait les compter?"
,"3":"La hauteur du ciel, l'étendue de la terre, les profondeurs de l'océan: qui peut les mesurer?"
,"4":"La Sagesse, elle, fut créée avant toute chose, l'intelligence qui les dispose vient de plus loin que le début du temps."
,"6":"A qui la source de la sagesse a-t-elle été révélée? Qui a connu ses intentions secrètes?"
,"8":"Un seul est sage, très digne du plus haut respect: Celui qui siège sur son trône!"
,"9":"C'est le Seigneur qui a créé la sagesse; il l'a vue, il en a pris la mesure; il l'a répandue sur toutes ses oeuvres,"
,"10":"sur tous les êtres vivants, selon sa générosité. Il l'a distribuée avec largesse à ceux qui l'aiment."
,"11":"La crainte du Seigneur est notre gloire et nous pouvons en être fiers; elle est joie et couronne de vainqueurs."
,"12":"La crainte du Seigneur réjouit le coeur, elle donne bonne humeur, joie et longue vie."
,"13":"Tout finira bien pour celui qui craint le Seigneur; au jour de sa mort il sera béni."
,"14":"La crainte du Seigneur est le commencement de la sagesse; il a mis la sagesse au coeur de ses fidèles dès avant leur naissance."
,"15":"Elle était en place dès avant le temps; elle a fait son nid chez des humains, et elle restera fidèle à leur descendance."
,"16":"La crainte du Seigneur est la plénitude de la sagesse; elle te comble de ses fruits,"
,"17":"remplissant toute ta maison de choses fort appréciables, et tes greniers, de ses richesses."
,"18":"La crainte du Seigneur est le couronnement de la sagesse; elle fait fleurir paix et bonne santé."
,"19":"Le Seigneur l'a vue et mesurée; il a fait tomber une pluie de savoir et d'intelligence; ceux qui ont la sagesse ne peuvent pas la dissimuler."
,"20":"La crainte du Seigneur est la racine de la sagesse; sa ramure s'appelle: longue vie."
,"22":"La violence injuste n'a aucune excuse, elle se détruit par ses propres excès."
,"23":"L'homme patient tiendra bon aussi longtemps qu'il le faudra; à la fin la joie lui sera accordée;"
,"24":"il se retiendra de parler jusqu'au moment voulu, tous alors reconnaîtront sa valeur."
,"25":"La sagesse garde dans ses réserves des maximes d'un riche contenu, mais le pécheur n'a nul souci des choses de Dieu."
,"26":"Désires-tu la sagesse? Observe les commandements, et le Seigneur te l'accordera généreusement."
,"27":"Car la crainte du Seigneur est sagesse et doctrine; ce qui lui plaît, c'est la fidélité et la douceur."
,"28":"Ne te détourne pas de la crainte du Seigneur, viens à elle d'un coeur entier."
,"29":"Ne sois pas hypocrite devant les gens, mais surveille tes paroles."
,"30":"Ne chante pas tes propres louanges, tu pourrais tomber et t'attirer le déshonneur. Si tu n'as pas la crainte du Seigneur et que tu vis dans le mensonge, lui révélera tes secrets et te renversera en public."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Mon fils, si tu t'es décidé à servir le Seigneur, prépare-toi à l'épreuve!"
,"2":"Garde un coeur droit et sois résolu, ne te démonte pas quand viennent les difficultés."
,"3":"Attache-toi au Seigneur, ne t'écarte pas de lui; si tu fais ainsi, tu arriveras à bon port à la fin de tes jours."
,"4":"Accepte tout ce qui t'arrive et sois patient quand tu te retrouves à terre."
,"5":"Car on purifie l'or par le feu, et de même ceux qui plaisent à Dieu passent par le creuset de l'humiliation."
,"6":"Aie confiance en lui et il prendra soin de toi; suis le droit chemin et espère en lui."
,"7":"Vous qui craignez le Seigneur, attendez sa miséricorde; ne vous détournez pas de lui: vous tomberiez."
,"8":"Vous qui craignez le Seigneur, ayez confiance en lui: vous ne perdrez pas votre récompense."
,"9":"Vous qui craignez le Seigneur, attendez-vous à recevoir tout ce qui vaut la peine: espérez miséricorde et joie éternelle."
,"10":"Rappelez-vous ce qui est arrivé à vos ancêtres: qui a mis sa confiance dans le Seigneur et s'en est repenti? Qui a persévéré dans sa crainte et a été abandonné? Qui a fait appel à lui et n'a pas été écouté?"
,"11":"Car le Seigneur est tendresse et miséricorde; il pardonne nos péchés et nous sauve au temps de la détresse."
,"12":"Malheur aux lâches qui laissent tomber leurs bras, malheur au pécheur qui se refuse à choisir!"
,"13":"Malheur aux lâches qui n'ont pas confiance! pour cette raison ils ne seront pas protégés."
,"14":"Malheur à vous qui n'avez pas persévéré: que ferez-vous quand le Seigneur vous demandera des comptes?"
,"15":"Ceux qui craignent le Seigneur ne désobéissent pas à ses commandements; ceux qui sont fidèles à l'aimer marchent sur ses chemins."
,"16":"Ceux qui craignent le Seigneur cherchent à lui plaire; ceux qui l'aiment se nourrissent de sa loi."
,"17":"Ceux qui craignent le Seigneur gardent leur coeur disponible; ils s'humilient devant lui et disent: 'Tombons entre les mains du Seigneur plutôt qu'entre les mains des hommes, car sa miséricorde n'est pas moindre que sa puissance!'"
}`)
	CurrentBook.AddChapter(3, `{
"1":"Enfants, écoutez-moi, votre père vous parle! Suivez mes avis et vous serez sauvés."
,"2":"Car le Seigneur a voulu que les enfants respectent leur père, il a établi l'autorité de la mère sur ses fils."
,"3":"Qui respecte son père obtient le pardon de ses péchés;"
,"4":"qui honore sa mère se prépare un trésor."
,"5":"Celui qui respecte son père, ses propres enfants feront sa joie; le jour où il demandera, le Seigneur l'exaucera."
,"6":"Celui qui honore son père aura longue vie; qui obéit au Seigneur sera la consolation de sa mère."
,"7":"Il servira ceux qui lui ont donné la vie comme il servirait le Seigneur."
,"8":"Agis ainsi, honore ton père en paroles et en actes, et sa bénédiction se réalisera pour ton bien."
,"9":"Car la bénédiction d'un père affermit la maison de ses enfants, mais la malédiction d'une mère la détruit jusqu'aux fondements."
,"10":"Ne te réjouis pas du déshonneur de ton père: sa honte ne sera jamais ta gloire."
,"11":"L'honneur d'un homme dépend de la réputation de son père; lorsqu'une mère a mérité le mépris, ses enfants sont déshonorés."
,"12":"Mon enfant, prends soin de ton père lorsqu'il sera devenu vieux; aussi longtemps qu'il vivra, ne lui cause pas de peine."
,"13":"Si son esprit s'affaiblit, supporte-le; ne le méprise pas parce que tu te sens en pleine force."
,"14":"Le bien que tu auras fait à ton père ne sera pas oublié, il te sera compté comme une réparation de tes péchés."
,"15":"Au temps de l'adversité on s'en souviendra en ta faveur, et tes péchés fondront comme glace au soleil."
,"16":"Abandonner son père, c'est comme insulter le Seigneur; le Seigneur maudit celui qui a fait le malheur de sa mère."
,"17":"Mon enfant, agis en tout avec tact, et tu seras aimé des amis de Dieu."
,"18":"Plus tu es grand, plus tu dois t'abaisser: c'est ainsi que tu obtiendras la bienveillance du Seigneur."
,"20":"Car si quelqu'un est vraiment puissant, c'est le Seigneur, et ce sont les humbles qui l'honorent."
,"21":"N'aspire pas à ce qui dépasse tes forces, ne te lance pas dans une recherche qui passe tes capacités."
,"22":"Approfondis ce qui t'a été commandé, tu n'as aucune nécessité de connaître les mystères cachés."
,"23":"Ne te fatigue pas à résoudre des questions inutiles, le savoir qui t'a été remis dépasse déjà ce qu'un humain peut comprendre."
,"24":"Pense que beaucoup se sont égarés avec leurs théories, leur assurance mal fondée leur a faussé le raisonnement."
,"26":"Un obstiné terminera sur un échec, celui qui aime le danger y laissera sa vie."
,"27":"L'obstiné sera accablé d'épreuves; pécheur endurci, il accumule péchés sur péchés."
,"28":"Il n'y a pas de remède à la misère de l'orgueilleux: le mal a pris racine en lui."
,"29":"L'homme sage médite les maximes en son coeur; trouver quelqu'un qui l'écoute, c'est là tout le désir du sage."
,"30":"L'eau éteint les flammes du feu; l'aumône efface les péchés."
,"31":"Celui qui répond de façon généreuse prépare son avenir: sur le point de tomber il trouvera un soutien."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Mon enfant, ne refuse pas au pauvre son pain; ne fais pas attendre celui qui te regarde avec des yeux suppliants."
,"2":"Ne contriste pas celui qui a faim, n'exaspère pas un indigent."
,"3":"Ne discute pas avec le désespéré, ne laisse pas le nécessiteux soupirer après ton aumône."
,"4":"Ne repousse pas le mendiant accablé par sa détresse, ne tourne pas le dos au pauvre."
,"5":"Ne tourne pas le dos à celui qui est dans le besoin, ne donne à personne un motif de te maudire."
,"6":"Car si quelqu'un te maudit à force d'amertume, Celui qui l'a créé exaucera sa demande."
,"7":"Fais-toi bien voir de la communauté, incline-toi devant celui qui dirige."
,"8":"Prête l'oreille au pauvre, réponds-lui avec sérénité, dis-lui des paroles aimables."
,"9":"Délivre l'opprimé des mains de l'oppresseur, et ne sois pas lâche en rendant la justice."
,"10":"Sois comme un père pour l'orphelin, et l'égal d'un mari pour sa mère. Alors tu seras comme un fils du Très-Haut, il t'aimera plus encore que ta propre mère."
,"11":"La Sagesse élève ses enfants et prend soin de ceux qui la recherchent."
,"12":"Celui qui l'aime aime la vie; ceux qui dès le matin partent à sa recherche seront comblés de joie."
,"13":"Qui la possède atteindra à la fin la gloire; le Seigneur lui donnera sa bénédiction."
,"14":"Ceux qui la servent se font les ministres du Saint; ceux qui l'aiment sont aimés du Seigneur."
,"15":"Celui qui l'écoute aura un jugement sûr, celui qui lui obéit sera en sécurité."
,"16":"Celui qui lui fait confiance l'aura en héritage, et ses descendants en conserveront la jouissance."
,"17":"Au début elle le conduira par des chemins défoncés, lui causera des peurs et des frayeurs; elle le fatiguera par sa discipline jusqu'au moment où elle pourra compter sur lui; elle multipliera ses exigences pour le mettre à l'épreuve."
,"18":"Ensuite elle le ramènera vers des chemins aplanis, elle lui procurera la joie et lui révélera ses secrets."
,"19":"Mais s'il est sorti du chemin, elle l'abandonnera et le laissera courir à sa perte."
,"20":"En toute circonstance pèse le pour et le contre, et évite le pire. Il y a une sorte de honte, mauvaise, qui te ferait du tort. "
,"21":"Car il y a une honte qui conduit au péché, et une autre qui mérite éloges et respect."
,"22":"Ne renie pas ce qui en toi est le meilleur, par souci de te faire bien voir; il ne faut pas qu'une honte de ce genre te fasse te rabaisser."
,"23":"Ne reste pas silencieux quand tu devrais parler; ne cache pas, par orgueil mal placé, ce qui fait ta sagesse."
,"24":"C'est dans la conversation qu'on reconnaît la sagesse; c'est dans le discours que se voit l'instruction."
,"25":"Ne contredis pas si c'est vrai; il vaut mieux confesser ton ignorance."
,"26":"N'aie pas honte d'avouer tes péchés: ne nage pas à contre-courant."
,"27":"Ne t'écrase pas devant un sot, ne te laisse pas influencer par un puissant."
,"28":"Lutte à mort pour la vérité, et le Seigneur combattra pour toi."
,"29":"Ne sois pas hardi en paroles, lâche et négligent dans tes actes."
,"30":"Ne sois pas comme un lion dans ta maison, malmenant tes serviteurs, humiliant tes inférieurs."
,"31":"Que ta main ne soit pas tendue pour recevoir, et fermée quand il faut rendre."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Ne te sens pas fort de ta richesse, ne pense pas: 'Je me suffis à moi-même!'"
,"2":"Ne te laisse pas emporter par la violence où le désir de posséder: ils feraient de toi leur esclave."
,"3":"Ne dis pas: 'On ne m'arrêtera pas!' Le Seigneur saura bien te punir."
,"4":"Ne dis pas: 'J'ai péché et rien ne m'est arrivé!': le Seigneur a tout son temps."
,"5":"Ne sois pas trop sûr du pardon quand tu accumules les péchés."
,"6":"Ne dis pas: 'La miséricorde du Seigneur est grande, il pardonnera mes péchés, si nombreux soient-ils!' Car il y a chez lui miséricorde et réprobation; sa colère s'abat sur les pécheurs."
,"7":"Ne tarde pas à revenir au Seigneur, ne recule pas de jour en jour; viendra le jour du règlement de comptes, la colère du Seigneur s'enflammera soudain et tu périras."
,"8":"Ne compte pas sur des richesses mal acquises, elles ne te serviront de rien au jour du malheur."
,"9":"Ne te prête pas à tout vent, ne suis pas deux chemins à la fois, comme fait le pécheur qui joue la comédie."
,"10":"Reste ferme dans tes convictions et sois un homme de parole."
,"11":"Sache écouter et prends le temps avant de répondre."
,"12":"Si tu sais de quoi tu parles, réponds à ton interlocuteur; sinon, garde le silence."
,"13":"Tes paroles te vaudront la gloire ou le discrédit; c'est la langue d'un homme qui prépare sa chute."
,"14":"Ne permets pas qu'on te considère comme un médisant, ou comme celui qui parle pour tromper! Un voleur s'attire la honte, mais l'hypocrite aussi aura sa condamnation."
,"15":"Evite le peché, qu'il s'agisse de grandes ou de petites choses; ne deviens pas l'ennemi de celui qui était ton ami."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Celui qui fait ouvertement le mal se prépare la honte et la confusion; ce sera pareil pour le pécheur hypocrite."
,"2":"Ne capitule pas devant tes passions; elles se retourneraient contre toi, comme un taureau, et te mettraient en pièces."
,"3":"Elles mangeraient tes feuilles et détruiraient tes fruits, te laissant comme un tronc sec."
,"4":"Une passion mauvaise perd celui qu'elle possède, elle en fait la risée de ses ennemis."
,"5":"Des paroles aimables te vaudront beaucoup d'amis, un langage courtois attire des réponses bienveillantes."
,"6":"Aie beaucoup d'amis, mais pour te conseiller, choisis entre mille."
,"7":"Si tu as trouvé un nouvel ami, commence par le mettre à l'épreuve, ne lui accorde pas trop vite ta confiance."
,"8":"Il y a l'ami qui est ami quand cela lui convient, mais ne le restera pas dans les difficultés."
,"9":"Il y a l'ami qui se transforme en ennemi et qui fait savoir partout votre désaccord, pour ta confusion."
,"10":"Il y a l'ami qui est ami pour partager ta table, mais qui ne le restera pas quand tes affaires iront mal."
,"11":"Tant qu'elles marcheront bien, il sera comme ton ombre, très à l'aise avec les gens de ta maison."
,"12":"Mais si tu as des revers, il se tournera contre toi et évitera de te rencontrer."
,"13":"Prends tes distances avec tes ennemis, et fais attention avec tes amis."
,"14":"Un ami fidèle est un refuge sûr; qui le trouve a trouvé un trésor."
,"15":"Que ne donnerait-on pas pour un ami fidèle? Considère qu'il n'a pas de prix!"
,"16":"Un ami fidèle est comme un remède qui te sauve; ceux qui craignent le Seigneur le trouveront."
,"17":"Celui qui craint le Seigneur trouvera le véritable ami, car tel on est, tel sera aussi l'ami."
,"18":"Mon enfant, consacre-toi à l'étude dès ta jeunesse, et jusqu'à tes cheveux blancs tu progresseras dans la sagesse."
,"19":"Que ce soit un vrai travail, tout comme celui du laboureur ou du semeur; cultive-la et attends ses fruits excellents. La cultiver te donnera des soucis, mais bientôt tu jouiras de ses fruits."
,"20":"La sagesse paraît aux ignorants une personne bien sévère; celui qui ne pense à rien n'y persévère pas."
,"21":"Elle est pour lui une charge pesante, une épreuve difficile, et il a vite fait de la rejeter."
,"22":"La sagesse défend sa réputation et ne veut pas se révéler au premier venu."
,"23":"Aussi, mon enfant, reçois mes avis et ne rejette pas ce conseil:"
,"24":"mets ses entraves à tes pieds et place son joug sur ton cou;"
,"25":"prends son fardeau sur ton épaule et porte son joug; ne t'impatiente pas de ses chaînes."
,"26":"Va vers elle de toute ton âme, et mets toute ton énergie à suivre ses chemins."
,"27":"Lance-toi à sa poursuite, cherche-la, et elle se fera connaître; quand tu la tiendras, ne la laisse pas partir."
,"28":"Car c'est en elle à la fin que tu trouveras le repos et elle deviendra ta joie."
,"29":"Ses entraves affermiront tes pas, son collier sera ton vêtement."
,"30":"Son joug deviendra parure d'or, et ses chaînes, précieuses guirlandes de pourpre violette."
,"31":"Elle sera ton ornement, ta tunique de gala; tu la porteras sur le front comme un diadème de fête."
,"32":"Si tu le veux, mon enfant, tu deviendras instruit, si tu t'appliques, ton esprit s'ouvrira."
,"33":"Si tu aimes écouter tu apprendras, si tu prêtes l'oreille tu deviendras sage."
,"34":"Suis de près l'assemblée des anciens; si tu y vois un homme sage, attache-toi à lui."
,"35":"Ecoute volontiers tout ce qui touche aux choses de Dieu; ne laisse pas passer les maximes des sages."
,"36":"Si tu vois un homme vraiment sensé, va vers lui dès le matin, et que ton pied use le seuil de sa porte."
,"37":"Médite les préceptes du Seigneur, préoccupe-toi sans cesse de ses commandements; il te donnera du coeur et tu recevras cette sagesse tant désirée."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Ne fais pas le mal, et le mal ne te surprendra pas."
,"2":"Reste à l'écart de l'action mauvaise, elle aussi te laissera."
,"3":"Mon fils, ne sème pas dans les sentiers du mal: tu pourrais récolter sept fois plus."
,"4":"Ne demande pas au Seigneur un poste de dirigeant, ni au roi une place d'honneur."
,"5":"Ne te fais pas passer pour juste devant le Seigneur, ni pour sage devant le roi."
,"6":"N'aspire pas à un poste de responsabilité si tu n'es pas assez fort pour déraciner l'injustice: tu te laisserais intimider par un puissant et tu perdrais ton intégrité."
,"7":"N'offense pas l'assemblée de la ville, ne perds pas la confiance de la population."
,"8":"Ne commets pas deux fois le même péché; un seul suffit pour que tu sois puni."
,"9":"Ne dis pas: 'Dieu tiendra compte de mes nombreuses offrandes; je les présenterai au Très-Haut et il les acceptera.'"
,"10":"Prie plutôt avec force et n'omets pas de faire l'aumône."
,"11":"Ne te moque pas de celui qui a été humilié: il y a quelqu'un qui abaisse et qui relève."
,"12":"Ne ments pas aux dépens de ton frère, ne ments pas aux dépends de ton ami."
,"13":"Garde-toi de toute forme de mensonge: rien de bon n'en sortira."
,"14":"Ne parle pas à tort et à travers dans l'assemblée des anciens, ne multiplie pas les paroles dans ta prière."
,"15":"Ne méprise pas les tâches pénibles, ni le travail des champs institué par le Très-Haut."
,"16":"Ne va pas te joindre au groupe des pécheurs, souviens-toi que la Colère ne tardera pas."
,"17":"Ne te crois pas plus que tu n'es: celui qui vit sans Dieu sera châtié par le feu et les vers."
,"18":"N'échange pas un ami pour de l'argent, ni un vrai frère pour de l'or fin."
,"19":"Ne te sépare pas d'une épouse sage et bonne; une épouse aimable vaut plus que de l'or."
,"20":"Ne malmène pas le domestique qui travaille comme il faut, ni le salarié qui ne perd pas son temps."
,"21":"Aime comme toi-même l'esclave intelligent: tu lui rendras sa liberté."
,"22":"As-tu du bétail? Prends-en soin. Si tu en tires du profit ne t'en défais pas."
,"23":"As-tu des enfants? Eduque-les, et dès leur jeune âge apprends-leur à obéir."
,"24":"As-tu des filles? Veille à leur virginité, ne sois pas trop indulgent avec elles."
,"25":"Marie ta fille et tu auras réglé une affaire importante; mais donne-la à un homme intelligent."
,"26":"As-tu une femme selon ton coeur? Ne t'en sépare pas. Mais ne fais pas confiance à celle que tu vois d'un mauvais oeil."
,"27":"Honore ton père de tout ton coeur, n'oublie jamais ce que ta mère a souffert pour toi."
,"28":"Souviens-toi que c'est par eux que tu es né: que leur rendras-tu pour tout ce qu'ils t'ont donné?"
,"29":"Rends hommage au Seigneur de toute ton âme, et respecte ses prêtres."
,"30":"De toutes tes forces aime Celui qui t'a créé, et ne délaisse pas ses ministres."
,"31":"Crains le Seigneur et honore le prêtre; donne-lui sa part comme il t'a été prescrit: les premiers fruits de ton champ, le sacrifice pour le péché, l'épaule des victimes, les offrandes saintes et les prémices des choses saintes."
,"32":"Tends au pauvre une main généreuse, et tu recevras du Seigneur une bénédiction."
,"33":"Que les vivants reçoivent tes bienfaits, et n'oublie pas les morts."
,"34":"Ne te détourne pas de ceux qui pleurent, souffre avec ceux qui sont dans la peine."
,"35":"N'oublie pas de visiter un malade: ce genre de choses te fera aimer."
,"36":"En tout ce que tu fais souviens-toi de ta fin, et jamais tu ne pécheras."
}`)
	CurrentBook.AddChapter(8, `{
"1":"N'aie pas de discussion avec un homme puissant: tu pourrais tomber entre ses mains."
,"2":"Ne te querelle pas avec un homme riche: il pourrait jeter son poids dans la balance."
,"3":"Ne discute pas avec un bavard: ce serait jeter du bois sur son feu."
,"4":"Ne plaisante pas avec quelqu'un de grossier: il en viendrait à insulter tes ancêtres."
,"5":"Ne fais pas de reproches au pécheur repentant; souviens-toi que nous sommes tous coupables."
,"6":"Ne méprise pas un homme dans sa vieillesse: nous-mêmes serons vieux un jour."
,"7":"Ne te réjouis de la mort de personne: souviens-toi que tous nous mourrons."
,"8":"Ne dédaigne pas les propos des sages, reviens souvent à leurs préceptes: tu apprendras d'eux comment vivre et comment servir les grands."
,"9":"Ne te débarrasse pas de la doctrine des anciens, car eux-mêmes l'ont apprise de leurs pères; ils ouvriront ton intelligence et te rendront capable de répondre à propos."
,"10":"Ne fais rien pour exciter le pécheur: tu pourrais te brûler à sa flamme."
,"11":"N'énerve pas un homme de mauvais caractère: il fausserait tes paroles et en tirerait un prétexte."
,"12":"Ne prête pas à plus puissant que toi: si tu lui as prêté, tiens-le pour perdu."
,"13":"Ne te porte pas caution pour autrui au-delà de tes moyens; si tu l'as fait, prépare-toi à payer."
,"14":"N'aie pas de procès avec un juge: vu sa position, on jugera en sa faveur."
,"15":"Ne te mets pas en route avec un homme téméraire, de peur qu'il ne te force la main. Comme il n'en fera qu'à sa tête, ses folies vous feront périr tous les deux."
,"16":"Ne te querelle pas avec un homme qui s'emporte, ne reste pas avec lui dans un lieu isolé. Car il n'aura pas de scrupule à verser le sang et, loin de tout secours, il se jettera peut-être sur toi."
,"17":"Ne prends pas ta décision en présence d'un sot: il ne gardera pas le secret."
,"18":"Ne fais pas ce qui doit rester secret en présence d'un inconnu: tu ne sais pas comment il réagira."
,"19":"N'ouvre pas ton coeur à n'importe qui: ne compte pas qu'on t'en saura gré."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Ne sois pas jaloux de la femme que tu aimes: tu ferais naître chez elle la tentation de te tromper."
,"2":"Ne te remets entre les mains d'aucune femme au point qu'elle ait l'avantage sur toi."
,"3":"Ne t'approche pas d'une femme de mauvaise réputation: tu pourrais tomber dans ses filets."
,"4":"Ne traîne pas avec une chanteuse: tu te ferais prendre à ses pièges."
,"5":"N'arrête pas tes regards sur une jeune fille: tu pourrais te condamner avec elle."
,"6":"Ne tombe pas entre les mains des prostituées: tu y perdrais tout ton avoir."
,"7":"Ne regarde pas de tous côtés dans les rues de la ville, ne traîne pas dans les coins déserts."
,"8":"Détourne les yeux d'une jolie femme, ne dévisage pas une belle inconnue. La beauté d'une femme en a fait tomber beaucoup; elle suffit pour enflammer la passion."
,"9":"Ne t'assieds pas, ne t'attable avec une femme mariée pour boire du vin avec elle, de peur que cela n'éveille en toi le désir et que la passion te fasse glisser et chuter."
,"10":"N'abandonne pas un vieil ami: le nouveau ne le vaudra pas. Nouvel ami, vin nouveau; laisse-les vieillir et tu les boiras avec plaisir."
,"11":"N'envie pas la réussite du pécheur, tu ne sais pas quelle sera la fin."
,"12":"Ne te réjouis pas de la réussite des renégats: souviens-toi que leur châtiment n'attendra pas leur mort."
,"13":"Reste loin de celui qui est capable de tuer, et tu ne craindras pas de mourir. Si tu t'approches de lui, évite de le heurter, car il pourrait t'ôter la vie: tu sais que tu t'avances au milieu de pièges, que tu marches sur le haut d'un mur."
,"14":"Autant que tu le peux, montre-toi sociable, et tiens conseil avec les sages."
,"15":"Aime converser avec des gens intelligents; que tous vos entretiens roulent autour de la Loi du Très-Haut."
,"16":"Que les hommes droits fréquentent ta table; que la crainte du Seigneur soit ta fierté."
,"17":"On juge l'artisan à son travail, et le chef du peuple à ses sages interventions."
,"18":"L'homme fort en paroles est redouté dans sa ville; on déteste celui qui parle à tort et à travers."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Un sage dirigeant fait l'éducation de son peuple; le gouvernement d'un homme sensé est bien ordonné."
,"2":"Tel le chef, tels seront ses ministres; tel le gouverneur de la ville, tels seront ses habitants."
,"3":"Un roi sans sagesse fait la ruine de son peuple; une ville prospère grâce à l'intelligence de ses chefs."
,"4":"Le gouvernement du pays est dans la main du Seigneur, il envoie au bon moment l'homme qui convient."
,"5":"La réussite de qui que ce soit est dans la main du Seigneur; il revêt les chefs de sa propre autorité."
,"6":"Ne garde pas rancune à ton prochain, quelle que soit l'offense; ne fais rien sous le coup de la colère."
,"7":"L'orgueil est odieux au Seigneur comme aux hommes; pour lui comme pour eux, l'injustice est abominable."
,"8":"Ce qui fait qu'une nation perd le pouvoir au profit d'une autre, c'est l'injustice, la violence et la richesse."
,"9":"Comment peut-on avoir tant d'orgueil quand on n'est que terre et cendre? L'homme en pleine vie a déjà la pourriture en ses tripes!"
,"10":"La maladie traîne, le médecin plaisante...: le roi d'aujourd'hui demain sera mort."
,"11":"Une fois mort, l'homme n'a plus devant lui que la pourriture, les bêtes et les vers."
,"12":"Le début de l'orgueil chez un humain, c'est de s'écarter du Seigneur et de ne plus tenir compte de son Créateur."
,"13":"Le péché est au départ de l'orgueil; en persévérant dans le péché, on ouvre les portes toutes grandes à la marée du mal. Voilà pourquoi le Seigneur a envoyé aux pécheurs de sinistres châtiments; finalement ils les a anéantis."
,"14":"Le Seigneur a renversé les trônes des princes, et il les a remplacés par des gens simples."
,"15":"Le Seigneur a déraciné les orgueilleux et planté des humbles à leur place."
,"16":"Le Seigneur a bouleversé des contrées païennes, il les a totalement détruites."
,"17":"Il en a dévasté plusieurs, il a détruit leurs nations, effaçant leur souvenir de sur la terre."
,"18":"L'orgueil n'a pas été créé pour l'homme, ni les excès de colère pour ceux qui naissent de la femme."
,"19":"Quelle race est digne d'honneur? La race des humains. Quelle race est digne d'honneur? Ceux qui craignent le Seigneur. Quelle race est méprisable? La race des humains. Quelle race est méprisable? Celle qui transgresse les commandements et la Loi."
,"20":"Le chef mérite le respect de ses frères; mais lui-même respecte ceux qui craignent le Seigneur."
,"22":"Riches, illustres ou pauvres, leur unique fierté doit être de craindre le Seigneur."
,"23":"Il n'est pas juste de mépriser un pauvre qui observe la Loi; il ne convient pas de glorifier un pécheur."
,"24":"Le grand, le juge et le puissant sont dignes d'honneur, mais aucun d'eux n'est grand comme celui qui craint le Seigneur."
,"25":"Un serviteur intelligent aura des hommes libres pour le servir, et les gens de bon sens n'y trouveront rien à redire."
,"26":"Ne te vantes pas quand tu ne fais qu'accomplir ta besogne; ne fais pas le fier quand tu es dans la gêne."
,"27":"Mieux vaut être un travailleur et vivre à l'aise, que se donner des apparences et manquer de pain."
,"28":"Mon enfant, estime-toi avec modestie, apprécie-toi à ta juste valeur."
,"29":"Qui défendra celui qui attente à sa propre vie? Qui respectera celui qui se discrédite lui-même?"
,"30":"On estimera un pauvre pour sa sagesse, et un riche pour ses richesses."
,"31":"Si, bien que pauvre, on l'honore, que serait-ce dans la richesse? Si, bien que riche, on le méprise, que serait-ce dans la pauvreté?"
}`)
	CurrentBook.AddChapter(11, `{
"1":"Le pauvre, s'il est un sage, va la tête haute; il a sa place parmi les notables."
,"2":"Ne t'emballe pas pour quelqu'un parce qu'il se présente bien, ne prends personne en dégoût pour son seul aspect."
,"3":"L'abeille est fort petite parmi la gent ailée, mais vient la première pour la douceur de son miel."
,"4":"Ne tire pas vanité de l'habit que tu portes, ne sois pas orgueilleux parce que les gens t'honorent; sais-tu ce que le Seigneur prépare sans qu'on le remarque?"
,"5":"Bien des dictateurs ont été renversés, et la couronne est allée à celui qu'on n'attendait pas."
,"6":"Beaucoup qui étaient puissants ont tout perdu, des gens dont tout le monde parlait sont tombés aux mains d'un nouveau venu."
,"7":"Ne reprends personne si tu n'es pas d'abord bien informé; commence par examiner le cas et tu feras ensuite des reproches."
,"8":"Ne réponds pas avant d'avoir écouté, n'interviens pas au beau milieu du discours."
,"9":"Ne te mêle pas de ce qui ne te regarde pas, ne prends pas parti dans les disputes entre pécheurs."
,"10":"Mon enfant, n'entreprends pas trop de choses à la fois; si tu continues d'en rajouter, tu ne seras pas sans reproches; tu auras beau courir, tu n'y arriveras pas, et tu ne pourras pas davantage t'en dégager."
,"11":"Il y en a qui se fatiguent au travail, s'épuisent et se tourmentent, et ils se retrouvent plus pauvres qu'avant."
,"12":"D'autres sont faibles et vulnérables, sans ressources et manquant de tout, mais le Seigneur les regarde d'un oeil favorable."
,"13":"Il les tire de leur abaissement et leur fait redresser la tête, à tel point que beaucoup s'en étonnent."
,"14":"Prospérité et malheur, vie et mort, pauvreté et richesse, tout vient du Seigneur. ()"
,"17":"Les hommes droits peuvent compter sur la générosité du Seigneur, sa bienveillance les guidera en toute occasion."
,"18":"Pense au sort d'un homme qui s'est enrichi à force de calculs et d'économies."
,"19":"Peut-être se dit-il: 'J'ai bien gagné mon repos, je peux vivre maintenant sur ce que j'ai acquis'. Mais il ne sait pas le temps qui lui reste, il mourra bien et laissera tout à d'autres."
,"20":"Sois fidèle à ton devoir, consacres-y ta vie et poursuis ton oeuvre jusqu'en tes vieux jours."
,"21":"Ne te scandalise pas de la réussite des pécheurs; mets ta confiance dans le Seigneur et persévère dans ton labeur. C'est chose facile pour le Seigneur que de faire riche le pauvre en un instant."
,"22":"La bénédiction du Seigneur vient récompenser l'homme droit; soudain, sans se faire annoncer, elle porte ses fruits."
,"23":"Ne dis pas: 'De quoi est-ce que je manque, que pourrais-je avoir ou désirer de plus?'"
,"24":"Ne dis pas: 'J'ai tout ce qu'il me faut, quel malheur à présent pourrait m'arriver?'"
,"25":"Dans les bons jours on oublie les mauvais, dans les mauvais jours on ne se souvient plus des bons."
,"26":"Même quand la fin est proche, il est facile pour le Seigneur de rendre à chacun selon sa conduite."
,"27":"L'heure de l'épreuve fait oublier tous les plaisirs, c'est quand se termine la vie d'un homme que ses actions prennent tout leur sens."
,"28":"Ne parle pas de vie comblée de bénédictions tant que la personne n'est pas morte: tu ne la connaîtras qu'à la fin."
,"29":"N'introduis pas n'importe qui dans ta maison, car les profiteurs adroits sont nombreux."
,"30":"La pensée de l'orgueilleux est comme la perdrix encagée pour attirer le gibier: il t'observe et cherche tes points faibles;"
,"31":"il change le bien en mal, il pose ses pièges, il calomnie ce qu'il y a de meilleur."
,"32":"L'étincelle fera flamber les charbons, le pécheur avec ses pièges fera couler le sang."
,"33":"Méfie-toi du méchant car il complote le mal; il pourrait détruire ta réputation pour toujours."
,"34":"Introduis un étranger dans ta maison, il te causera des problèmes; il te brouillera avec les gens de ta maison."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Si tu fais le bien, sache à qui tu le fais, et tes bienfaits te vaudront de la reconnaissance."
,"2":"Fais du bien à un fidèle et tu en seras récompensé, sinon par lui, du moins par le Très-Haut."
,"3":"Il n'y a pas de bénédictions pour celui qui s'obstine à faire le mal, ni pour celui qui n'a pas de compassion."
,"4":"Donne à un fidèle, mais ne viens pas en aide à un pécheur."
,"5":"Fais du bien à celui qui est humble, mais ne donne pas à un impie. Refuse-lui le pain, ne lui en donne pas: il deviendrait plus puissant que toi et te rendrait le mal au double de tes bienfaits."
,"6":"Car le Très-Haut lui-même déteste les pécheurs, il se vengera des impies."
,"7":"Donne à l'homme de bien mais ne viens pas en aide au pécheur."
,"8":"Un ami ne se change pas en ennemi quand tout va bien, un ennemi ne se dissimule plus lorsque vient l'adversité."
,"9":"Quand un homme progresse, ses ennemis sont dépités; quand il a des revers, même son ami l'abandonne."
,"10":"Ne te fie jamais à ton ennemi: sa méchanceté demeure, comme le bronze sous l'oxyde."
,"11":"Même s'il se fait humble et s'avance tout courbé, sois sur tes gardes et méfie-toi de lui; agis avec lui comme l'artisan qui polit un miroir de bronze, sachant que l'oxyde ne résistera pas jusqu'au bout."
,"12":"Ne l'installe pas à ton côté: il pourrait te renverser et prendre ta place. Ne le fais pas asseoir à ta droite: il pourrait ambitionner ton siège; tu comprendrais alors que j'avais raison et tu regretterais de ne pas m'avoir écouté."
,"13":"Qui aura pitié du charmeur mordu par un serpent, ou de quelque autre qui s'approche des bêtes dangereuses?"
,"14":"Il en va de même pour celui qui fréquente le pécheur et s'associe à ses actions mauvaises."
,"15":"Le pécheur se tiendra tranquille à ton côté pendant une heure, mais à peine te laisseras-tu distraire, il jettera le masque."
,"16":"En paroles l'ennemi n'est que douceur, mais au fond de lui-même il cherche comment te jeter dans le fossé. Il sait verser des larmes, mais s'il en a l'occasion, il n'aura pas trop de ton sang."
,"17":"Si le malheur t'atteint, tu le verras devant toi: il fera semblant de t'aider, mais ce sera pour se débarrasser de toi."
,"18":"Alors il applaudira et se moquera de toi; il ironisera sur ton compte et montrera son vrai visage."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Qui touche à la poix se salit les doigts, qui se lie à un homme arrogant deviendra comme lui."
,"2":"Ne te charge pas d'un fardeau trop lourd, ne te fais pas l'ami d'un plus fort et plus riche que toi. Vas-tu mettre ensemble le pot de terre et le pot de fer. L'un des deux cognera l'autre et le brisera."
,"3":"Le riche agit mal et fait mine de rien; le pauvre est insulté et il présente ses excuses."
,"4":"Tant que tu es utile, il se sert de toi; quand tu n'auras plus rien, il te laissera."
,"5":"Il sera chez toi tant que tu auras quelque chose; il t'exploitera sans le moindre remords."
,"6":"S'il a vraiment besoin de toi, il te flattera et te fera des sourires; il te promettra des merveilles et te dira de bonnes paroles: 'De quoi as-tu besoin?'"
,"7":"Il te sera reconnaissant au point que tu en seras gêné, le temps de te prendre tout ce que tu as; après quoi il se moquera de toi. Alors, quand il te verra il s'écartera de toi, et s'il te rencontre il hochera la tête."
,"8":"Fais donc attention à ne pas te laisser avoir, et à ne pas te retrouver par terre par pure bêtise."
,"9":"Quand un personnage important t'invite, remets à plus tard: il te rappellera."
,"10":"Ne t'avance pas trop, on pourrait te repousser; ne t'écarte pas trop, on pourrait t'oublier."
,"11":"Ne pense pas lui parler d'égal à égal, ne te fie pas à tous ses discours; toutes ces paroles sont une façon de te mettre à l'épreuve, il veut te soupeser en te montrant de l'intérêt."
,"12":"Mais il répétera sans pitié tes paroles, il ne t'épargnera ni les coups ni les chaînes."
,"13":"Sois donc sur tes gardes et fais bien attention, car tu chemines avec celui qui te jettera à terre."
,"15":"Tout être vivant aime son semblable, tout homme aime celui qui lui est proche."
,"16":"Tout animal fréquente ceux de son espèce, l'homme aussi recherche son semblable."
,"17":"Le loup pourrait-il faire route avec l'agneau? C'est pareil pour le pécheur et l'homme de bien?"
,"18":"Quelle paix pourrait-il y avoir entre la hyène et le chien? Et quelle paix entre le riche et le pauvre?"
,"19":"Les ânes sauvages sont la proie des lions du désert: ainsi les pauvres sont une proie pour le riche."
,"20":"Un orgueilleux déteste l'humilité, un pauvre est pour le riche un objet d'horreur."
,"21":"Quand le riche chancelle, ses amis lui prêtent main-forte; quand le pauvre tombe, ses amis l'abandonnent."
,"22":"Quand le riche a des problèmes, beaucoup viennent à son secours; il peut dire des sottises, on lui donne raison. Quand le pauvre commet une erreur, on lui fait des reproches, s'il dit des choses sensées on n'en tient pas compte."
,"23":"Quand le riche parle tout le monde se tait, et l'on porte aux nues ses paroles; quand le pauvre a parlé on demande: 'Qui est celui-là?' Et s'il trébuche on le pousse par terre."
,"24":"La richesse est bonne quand elle est sans péché; la pauvreté n'est un mal que chez un impie qui l'a méritée."
,"25":"Le coeur de l'homme se reflète sur son visage, soit en bien, soit en mal."
,"26":"A-t-il le visage rayonnant? C'est que tout va bien pour lui. A-t-il trouvé des paroles de sagesse? C'est qu'il a réfléchi sur la souffrance.."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Heureux celui qui n'a pas péché en paroles et qui ne porte pas le regret de ses fautes!"
,"2":"Heureux celui que sa conscience ne condamne pas et qui n'a pas renoncé à son idéal!"
,"3":"La richesse ne convient pas à l'homme mesquin: pourquoi donneriez-vous de grands biens à un avare?"
,"4":"Celui qui amasse en se privant de tout, amasse pour autrui: d'autres jouiront de ses biens."
,"5":"Si quelqu'un est mauvais pour lui-même, pour qui sera-t-il bon? Il ne jouit même pas de ce qu'il a."
,"6":"Il n'y a pas pire que celui qui est mauvais avec lui-même: sa méchanceté se retourne contre lui."
,"7":"S'il fait le bien, ce sera un hasard, mais à la fin sa méchanceté ressortira."
,"8":"L'homme qui toujours convoite est un mauvais; les personnes ne l'intéressent pas, il méprise les autres."
,"9":"L'homme insatiable n'est jamais satisfait de ce qu'il a, la cupidité lui dessèche le coeur."
,"10":"L'envieux convoite la nourriture de son prochain: misère et famine seront à sa table."
,"11":"Mon enfant, fais bon usage de tout ce que tu as, et présente au Seigneur des offrandes généreuses."
,"12":"Souviens-toi que la mort ne tardera pas, et que ton heure ne t'a pas encore été révélée."
,"13":"Avant de mourir fais du bien à ton ami, sois généreux selon tes moyens."
,"14":"Jouis de la vie et ne rejette pas un plaisir légitime s'il se présente sur ton chemin."
,"15":"Ne laisseras-tu pas à d'autres le fruit de ton travail? On partagera au sort le fruit de tes peines."
,"16":"Donne et reçois, trompe tes soucis, ce n'est pas au tombeau qu'on peut chercher le plaisir."
,"17":"Tout ce qui vit vieillit comme un vêtement; c'est la loi éternelle: tu mourras!"
,"18":"Vois la verdure d'un arbre touffu: des feuilles tombent, d'autres apparaissent; de même les générations de chair et de sang: l'une meurt et l'autre naît."
,"19":"Les choses finies passent, et avec elles passe celui qui les a faites."
,"20":"Heureux celui qui s'adonne à la sagesse et peut répondre à celui qui l'interroge;"
,"21":"qui fait siennes les voies de la sagesse et en approfondit les secrets;"
,"22":"qui la prend en chasse et se met à l'affût sur son passage;"
,"23":"qui regarde par ses fenêtres et écoute à ses portes;"
,"24":"qui plante sa tente auprès de sa maison et en fixe les piquets dans ses murs."
,"25":"Il remet sa tente entre les mains de la sagesse et reste en cette heureuse demeure."
,"26":"Il place ses enfants sous sa protection et se tient à l'abri de ses branches;"
,"27":"elle le protège de la chaleur et il s'établit dans sa gloire."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Voilà bien celui qui craint le Seigneur; qui se donne à la Loi obtiendra la sagesse."
,"2":"Comme une mère elle viendra à sa rencontre, comme une jeune épouse elle l'accueillera."
,"3":"Elle le nourrira du pain de l'intelligence et lui donnera à boire l'eau de la sagesse."
,"4":"Il peut compter sur elle: il ne vacillera pas. Il s'appuiera sur elle et ne tombera pas."
,"5":"La sagesse le fera plus grand que ses amis: il saura parler devant la pleine assemblée."
,"6":"Il se verra couronné de bonheur et de joie; il sera célèbre pour toujours."
,"7":"Les imbéciles ne l'obtiendront pas, les pécheurs ne la verront jamais."
,"8":"Elle se tient loin des orgueilleux, et les menteurs n'en connaîtront rien."
,"9":"La louange ne vaut rien dans la bouche du pécheur, car elle ne vient pas du Seigneur."
,"10":"Il faut qu'elle vienne d'un sage, car alors le Seigneur l'inspire."
,"11":"Ne dis pas: 'Dieu m'a fait pécher!' car il ne fait pas ce qu'il déteste."
,"12":"Ne dis pas: 'Il m'a fait commettre une erreur!' car il n'avait pas besoin d'un pécheur."
,"13":"Le Seigneur déteste le mal, et de même le détestent ceux qui craignent le Seigneur."
,"14":"Quand au commencement il a créé l'homme, il l'a remis à sa propre conscience:"
,"15":"Si tu veux, tu peux garder les commandements; il est en ton pouvoir de rester fidèle."
,"16":"Il a mis devant toi le feu et l'eau: étends la main vers ce que tu préfères."
,"17":"Vie et mort sont là devant les humains, à chacun sera donné ce qu'il a choisi."
,"18":"Que la sagesse du Seigneur est grande, comme il est fort et puissant! et il voit toutes choses."
,"19":"Son regard se pose sur ceux qui le craignent; il connaît toutes les oeuvres des humains."
,"20":"A personne il n'a demandé d'être impie, à personne il n'a donné la permission de pécher."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Ne désire pas que tes enfants soient nombreux, s'ils doivent être inutiles; ne mets pas en eux ta joie s'ils sont impies."
,"2":"Aussi nombreux qu'ils soient, ne t'en réjouis pas s'ils n'ont pas la crainte de Dieu."
,"3":"Peu t'importe qu'ils soient nombreux et qu'ils aient longue vie, car un seul parfois vaut mieux que mille, et mieux vaut pour eux mourir que d'être des impies."
,"4":"Un homme de bon sens, et c'est assez pour qu'une ville prospère; mais les mauvais ont beau se multiplier, ils seront anéantis."
,"5":"J'en ai vu de mes yeux beaucoup d'exemples, et on m'en a conté de plus frappants encore:"
,"6":"Un feu est tombé sur une bande de pécheurs, la colère du Seigneur s'est enflammée contre une race rebelle."
,"7":"Il n'a pas pardonné aux héros d'autrefois quand ils se révoltèrent, orgueilleux de leur force."
,"8":"Il n'a pas épargné la cité où vivait Lot: il détestait ces orgueilleux."
,"9":"Il n'a pas eu pitié de cette nation vouée à la destruction: ils furent anéantis à cause de leurs péchés."
,"10":"Il a agi de même avec six cent mille hommes qui, d'un coeur obstiné, refusaient d'obéir."
,"11":"Même s'il n'y en avait eu qu'un seul à s'obstiner, il aurait été étonnant qu'il reste impuni. Car au Seigneur appartiennent la miséricorde et la colère: il est puissant pour pardonner comme pour punir."
,"12":"Sa miséricorde est grande, comme l'est sa justice; il juge les hommes selon leurs actes."
,"13":"Le pécheur n'échappera pas avec son butin, et la patience du fidèle ne sera pas sans récompense."
,"14":"Dieu récompensera tout geste charitable, et chacun sera traité selon ses actions. ()"
,"17":"Ne dis pas: 'Je me cacherai loin du Seigneur! Là-haut, qui se souviendra de moi? On ne me reconnaîtra pas au milieu de la foule: que suis-je dans l'immensité de la création?'"
,"18":"Vois: quand il paraît, le ciel lui-même en tremble, et les cieux d'au-dessus des cieux, ainsi que la terre et les mers."
,"19":"Les montagnes et les fondements de la terre sont pleins d'effroi sous son regard."
,"20":"Mais personne n'y réfléchit: qui donc s'intéresse à la manière d'agir de Dieu?"
,"21":"La plupart de ses interventions passent inaperçues, et l'on ne sait pas d'où est venue la tempête."
,"22":"'Qui nous parle d'interventions de Dieu? Qui les attend? L'alliance est loin maintenant'."
,"23":"Voilà ce que pense celui qui ne réfléchit pas, celui qui n'a pas de jugement, celui qui est corrompu et vit de ses illusions."
,"24":"Ecoutez-moi, mes enfants: apprenez et prenez à coeur ce que je vais dire."
,"25":"Je veux exposer pas à pas la doctrine et transmettre soigneusement le savoir."
,"26":"Dès l'origine les oeuvres du Seigneur ont répondu à un dessein; sitôt faites, il leur a assigné à chacune sa place."
,"27":"Il a ordonné ses créatures pour la durée des temps, leur fixant un départ et un devenir. Elles n'ont jamais faim, elles ne se fatiguent pas, elles ne s'arrêtent pas dans leur tâche."
,"28":"Les objets célestes ne choquent pas leurs voisins, ils ne désobéissent jamais à ses ordres."
,"29":"Après cela le Seigneur a regardé en bas, vers la terre, et il l'a comblée de ses richesses."
,"30":"Il lui a donné une âme, il l'a couverte d'êtres vivants, et tous retournent à la terre."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Le Seigneur a tiré l'homme de la terre, il l'y fait retourner."
,"2":"Pour chacun il a fixé le temps de sa venue et son nombre de jours; il leur a donné pouvoir sur les choses de la terre."
,"3":"Il les a revêtus d'une force semblable à la sienne, les faisant à son image."
,"4":"Il a fait que tout être animé les craigne, et qu'ils soient maîtres des bêtes sauvages et des oiseaux. ()"
,"6":"Il leur donna, pour percevoir la réalité, une conscience, une langue et des yeux, des oreilles et un entendement."
,"7":"Il les remplit de savoir et d'intelligence, et il leur enseigna le bien et le mal."
,"8":"Il a mis en eux son oeil intérieur, leur faisant ainsi découvrir les grandes choses qu'il avait faites,"
,"10":"afin qu'ils louent son nom très saint et proclament la grandeur de ses oeuvres."
,"11":"De plus il leur a révélé un savoir, il les a dotés d'une loi de vie."
,"12":"Il a conclu avec eux une Alliance éternelle et il leur a enseigné ses décrets."
,"13":"Leurs yeux ont contemplé sa gloire majestueuse, leurs oreilles ont entendu sa voix puissante."
,"14":"Il a donné à chacun d'eux des commandements vis-à-vis du prochain, leur disant: 'Gardez-vous de toute injustice.'"
,"15":"La conduite des hommes est toujours sous ses yeux, ils ne peuvent pas échapper à son regard. ()"
,"17":"Il a donné à chaque nation un guide, mais Israël appartient en propre au Seigneur. ()"
,"19":"Toutes leurs oeuvres sont devant lui comme en plein soleil, il ne perd pas de vue leurs voies."
,"20":"Leurs injustices ne lui sont pas cachées, tous leurs péchés sont devant le Seigneur. ()"
,"22":"Il garde comme un objet précieux l'aumône qu'on a faite, il préserve les bienfaits d'un homme comme la prunelle de ses yeux."
,"23":"Un jour il se lèvera, donnera les récompenses, déposant sur leurs têtes ce qui leur est dû."
,"24":"A ceux qui se repentent il accorde un redépart, il encourage ceux qui perdaient coeur."
,"25":"Tourne-toi vers le Seigneur et renonce au péché, prie-le et réduis tes offenses."
,"26":"Reviens vers le Très-Haut et détourne-toi de l'injustice, aie en horreur ce qui est abominable."
,"27":"Crois-tu qu'on loue le Très-Haut, dans le séjour des morts, à la place des vivants qui n'ont pas de reconnaissance?"
,"28":"Le mort est comme s'il n'était pas: plus de louange à espérer de lui; c'est le vivant, le bien portant, qui loue le Seigneur."
,"29":"Comme elle est grande la miséricorde du Seigneur, et son pardon pour ceux qui reviennent vers lui!"
,"30":"L'homme ne peut pas tout avoir: pour commencer, le fils d'homme n'est pas immortel."
,"31":"Quoi de plus lumineux que le soleil? Pourtant il a son déclin. Quelle erreur que la prétention d'un être de chair et de sang!"
,"32":"Le Seigneur contrôle l'armée des corps célestes, cependant que les hommes, sans exception, ne sont que terre et cendre."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Celui qui vit pour les siècles a tout créé pareillement."
,"2":"Seul le Seigneur sera reconnu juste."
,"4":"A personne il n'a donné capacité pour proclamer toutes ses oeuvres: qui pourrait aller jusqu'au fond de ses merveilles?"
,"5":"Qui peut mesurer son pouvoir éclatant, qui pourrait redire tous ses gestes de miséricorde?"
,"6":"Il n'y a rien à y retrancher, rien à y ajouter; les merveilles du Seigneur restent impénétrables."
,"7":"Quand on croit en finir, on ne fait que commencer; dès qu'on s'y arrête, on se sent dépassé."
,"8":"Qu'est-ce que l'homme? A quoi sert-il? Qu'est-ce qu'il lui faut? Qu'est-ce qui est mauvais pour lui?"
,"9":"La durée de sa vie? Tout au plus cent ans."
,"10":"Une goutte d'eau dans la mer, un grain de sable: voilà sa vie face à l'éternité."
,"11":"C'est pourquoi le Seigneur est patient avec les hommes et les couvre de sa miséricorde."
,"12":"Il voit et il sait que leur fin est misérable, aussi leur pardonne-t-il sans compter."
,"13":"La miséricorde d'un homme va à son prochain, la miséricorde du Seigneur est pour tout être vivant; il reprend, il rectifie, il enseigne: comme un berger il regroupe son troupeau."
,"14":"Il est bon avec ceux qui acceptent la correction et observent avec empressement ses décisions."
,"15":"Mon enfant, ne joins pas des reproches à tes bienfaits, ne cause pas de peine si tu fais un cadeau."
,"16":"La rosée ne refraîchit-elle pas le vent brûlant? De même la parole fait plus de bien que ce qu'on donne."
,"17":"Ne vois-tu pas que quelques mots valent mieux que le cadeau? Mais une personne généreuse unit l'un à l'autre."
,"18":"L'insensé gâche le bienfait par ses reproches, le cadeau d'un homme mesquin fait monter les larmes aux yeux."
,"19":"Avant de parler, informe-toi, et soigne-toi avant d'être malade."
,"20":"Examine-toi avant que Dieu ne te juge, et tu obtiendras le pardon à l'heure de sa visite."
,"21":"Humilie-toi avant d'être malade, et si tu as péché montre ton repentir."
,"22":"N'omets pas d'accomplir un voeu au temps fixé, n'attends pas la mort pour te mettre en règle."
,"23":"Réfléchis bien avant de faire un voeu, ne sois pas de ceux qui tentent le Seigneur."
,"24":"Pense au jugement des derniers jours, aux jours du châtiment où Dieu détournera sa face."
,"25":"Au temps de l'abondance rappelle-toi les temps de famine; aux jours de la richesse pense à la pauvreté et au manque de tout."
,"26":"Du matin au soir le temps s'est écoulé: tout passe vite devant le Seigneur."
,"27":"Celui qui est sage se surveille en toute occasion; même quand le péché abonde, il évite la faute."
,"28":"Toute personne sensée reconnaît la sagesse, et félicite ceux qui l'ont trouvée."
,"29":"Ceux dont les paroles sont pleines de bon sens ont su devenir sages; leurs maximes sont une pluie bienfaisante."
,"30":"Ne te laisse pas entraîner par tes convoitises, réfrène tes appétits."
,"31":"Si tu t'accordes ce que veulent tes passions, elles feront de toi la risée de tes ennemis."
,"32":"Ne mets pas ton bonheur à faire la fête, ne te laisse pas prendre à ce genre d'existence."
,"33":"Ne t'appauvris pas en menant joyeuse vie avec de l'argent emprunté lorsque tu n'as rien dans ta bourse."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Un ouvrier buveur ne deviendra jamais riche; qui se néglige dans les petites choses déchoira petit à petit."
,"2":"Le vin et les femmes corrompent les meilleurs; qui fréquente les prostituées perdra toute honte."
,"3":"Il n'y gagnera que la pourriture et les vers: ainsi finira celui qui n'a plus de honte."
,"4":"Qui fait trop vite confiance est une tête légère, qui cède au péché se fait du tort à lui-même."
,"5":"Qui se complaît dans la médisance sera condamné,"
,"6":"qui déteste les bavardages échappe au mal."
,"7":"Ne répète jamais ce qu'on t'a dit, et jamais tu n'auras à en souffrir."
,"8":"Ne dis rien à personne, ami ou ennemi; ne le répète pas, sauf si ton silence devait être coupable."
,"9":"On t'écouterait sans doute, mais après on se méfierait de toi et à la fin on te détesterait."
,"10":"As-tu entendu quelque chose? Enterre-le en toi; courage, cela ne te fera pas éclater!"
,"11":"Pour un mot qu'il a entendu, le sot est dans les douleurs, il est comme une femme qui attend un bébé."
,"12":"Le secret est insupportable aux entrailles du sot: c'est pour lui comme une flèche plantée dans sa cuisse."
,"13":"Explique-toi avec ton prochain: peut-être n'a-t-il rien fait, et s'il l'a fait, il ne le fera plus."
,"14":"Explique-toi avec ton prochain: peut-être n'a-t-il rien dit, et s'il l'a dit, il ne recommencera pas."
,"15":"Explique-toi avec ton prochain, car souvent on calomnie: ne crois pas tout ce qu'on raconte."
,"16":"Il arrive qu'on glisse sans mauvaise intention; qui n'a jamais péché par la langue?"
,"17":"Explique-toi donc avec ton prochain avant d'en venir aux menaces: ensuite tu t'en tiendras à la Loi du Très-Haut. ()"
,"20":"La crainte du Seigneur est le tout de la sagesse; en toute sagesse il y a la pratique de la Loi. ()"
,"22":"Savoir faire le mal n'est pas une sagesse; elle n'est pas davantage dans les desseins des pécheurs."
,"23":"Il y a une forme d'habileté qui est odieuse: elle est folie, puisqu'elle n'a nulle sagesse."
,"24":"Mieux vaut avoir l'esprit limité et craindre le Seigneur, qu'être habile à transgresser la Loi."
,"25":"Il y a une habileté qui ne cherche que l'injustice: on défigure les choses en prétendant faire valoir le droit."
,"26":"Il se fait la victime, il va plié sous le fardeau, mais au fond ce n'est que comédie."
,"27":"Il cache son visage et fait le sourd, mais attention: à la première distraction il te roulera."
,"28":"Un autre ne pèche pas parce qu'il n'en a pas les moyens; à la première occasion il fera le mal."
,"29":"C'est au regard qu'on reconnaît un homme, c'est à son visage qu'on connaît l'homme responsable."
,"30":"La façon dont un homme s'habille, sa façon de rire et de marcher disent ce qu'il est."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Il y a des reproches inopportuns, il peut être sage de se taire."
,"2":"Il vaut mieux faire une remarque que ruminer sa colère."
,"3":"Qui avoue ses torts en évite les conséquences."
,"4":"Comme un impuissant qui voudrait violer une fille, tel est celui qui veut établir la justice par la violence."
,"5":"L'un se tait et on le tient pour sage, l'autre ne fait que parler et se rend odieux."
,"6":"L'un se tait n'ayant rien à répondre, l'autre se tait parce qu'il attend le moment."
,"7":"L'homme sage se tait jusqu'au bon moment, le vantard et l'insensé parlent à contre-temps."
,"8":"Celui qui parle trop se fait détester, celui qui s'impose se fait haïr."
,"9":"Il y a des malheurs qui se changent en bien, il y a des aubaines qui tournent mal."
,"10":"Il y a des générosités qui ne te seront d'aucun profit, il y en a d'autres qui te rapporteront le double."
,"11":"L'un est abaissé parce qu'il a été honoré, un autre relève la tête après avoir été abaissé."
,"12":"L'un achète beaucoup de choses avec peu d'argent, un autre les paye sept fois trop cher."
,"13":"Le sage se fait aimer rien que par ses paroles, pendant que les générosités du sot sont en pure perte."
,"14":"Le cadeau d'un insensé ne te sert à rien, car il en attend du profit."
,"15":"Il donne peu et te demande beaucoup, il le crie à la cantonnade; il prête aujourd'hui, demain il te le réclame: quel homme odieux!"
,"16":"L'insensé dit: 'Je n'ai pas d'amis, personne ne reconnaît mes bienfaits!'"
,"17":"Mais ceux qui mangent son pain sont des mauvaises langues: combien d'entre eux se moqueront de lui! Et ils recommenceront."
,"18":"Il vaut mieux se retrouver par terre à cause d'une pierre que pour ce qu'on a dit; la chute des méchants ne manquera pas d'arriver."
,"19":"Un personne désagréable, c'est une histoire bête que des gens mal élevés racontent hors de propos."
,"20":"Une parole sage ne vaut rien dans la bouche du sot, car il ne la dit jamais quand il faudrait."
,"21":"Il y en a qui ne pèchent pas par manque de moyens: si l'occasion se présente, ils n'auront aucun remords."
,"22":"Un autre se perd par fausse honte: il suffit qu'un homme sans conscience soit là pour qu'il se perde."
,"23":"Par fausse honte, il ne pense qu'à gagner son amitié: c'est un ennemi, en fait, qu'il a gagné sans profit."
,"24":"Le mensonge est chez les humains une salissure morale; les gens mal élevés en sont les habitués."
,"25":"Mieux vaut un voleur qu'un menteur invétéré, mais tous deux vont à leur perte."
,"26":"L'habitude de mentir discrédite quelqu'un, c'est une honte qui ne le lâchera pas."
,"27":"Le sage avance grâce à ses paroles: l'homme de bon sens plaît aux grands."
,"28":"Celui qui cultive la terre augmente ses revenus, celui qui plaît aux grands fait oublier ses injustices."
,"29":"Les présents et les cadeaux aveuglent les yeux des sages, C'est un bâillon qui empêche les reproches de sortir de leur bouche."
,"30":"Sagesse cachée, trésor invisible: à quoi l'un et l'autre servent-ils?"
,"31":"Mieux vaut être sot et le cacher, qu'être sage et cacher sa sagesse."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Mon enfant, as-tu péché? Ne recommence plus, et prie pour tes fautes passées."
,"2":"Fuis devant le péché comme devant un serpent: si tu approches il te mordra; il a des dents de lion et détruit des vies humaines."
,"3":"Toute méchanceté est une épée à double tranchant dont les blessures sont sans remède."
,"4":"La démesure et l'orgueil font tomber le riche; la maison de l'orgueilleux sera renversée."
,"5":"La prière du pauvre va jusqu'aux oreilles de Dieu, il ne tardera pas à intervenir."
,"6":"Celui qui déteste les remontrances prend le chemin du péché, celui qui craint le Seigneur se tourne vers lui d'un coeur entier."
,"7":"Le beau parleur se fait remarquer partout, mais l'homme avisé a vite saisi ses points faibles."
,"8":"Bâtir sa maison avec l'argent emprunté, c'est amasser des pierres pour s'en faire un tombeau."
,"9":"Le parti des impies n'est qu'un tas de bois sec: le feu à la fin s'y mettra."
,"10":"Le chemin des pécheurs est bien dégagé de pierres, mais il conduit droit à l'abîme des morts."
,"11":"Celui qui garde la Loi domine ses pensées, la crainte du Seigneur procure la sagesse."
,"12":"Sans habileté on n'apprend pas, mais il y a une habileté qui termine en amertume."
,"13":"La connaissance du sage est comme des eaux qui débordent, ses avis sont une source de vie."
,"14":"L'entendement du sot est une cruche fêlée, il ne retient rien de ce qu'il apprend."
,"15":"L'homme instruit entend une parole sage, il l'apprécie et en ajoute une autre; qu'un bon à rien l'entende, elle lui déplaît et il la jette par-dessus son épaule."
,"16":"Le bavardage de l'insensé pèse comme un fardeau; les paroles du sage font du bien."
,"17":"Les avis de l'homme sensé sont recherchés par l'assemblée, chacun prend à coeur ce qu'il dit."
,"18":"La sagesse, pour l'insensé, n'est qu'une maison en ruines, mais le savoir de l'ignorant n'est que paroles mal ajustées."
,"19":"L'instruction gêne l'imbécile comme des entraves aux pieds, comme des menottes à sa main droite."
,"20":"Le sot rit très fort, mais l'homme habile sourit discrètement."
,"21":"L'homme sensé voit l'instruction comme un ornement d'or, c'est un bracelet à son bras droit."
,"22":"Le sot entre sans plus dans la maison, l'homme qui sait agir se présente avec discrétion."
,"23":"De la porte l'insensé se penche pour voir à l'intérieur, l'homme bien élevé reste debout dehors."
,"24":"C'est manque d'éducation que d'écouter aux portes, un homme bien élevé serait honteux de le faire.."
,"25":"Parler de tout, c'est agir comme le tout venant, l'homme sensé pèse ses paroles."
,"26":"Tout l'intérieur du sot est déjà dans sa bouche, la bouche du sage est partie de son intérieur."
,"27":"Quand l'impie maudit son adversaire, la malédiction est pour lui-même."
,"28":"Le calomniateur se salit lui-même, on le déteste dans son entourage."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Le paresseux ressemble à une pierre crottée, tout le monde rit de sa dégradation."
,"2":"Le paresseux est comme un tas de fumier, celui qui l'a touché se secoue les mains."
,"3":"Un fils mal élevé est la honte d'un père; si c'est une fille, elle sera son humiliation."
,"4":"Une fille sensée sera un trésor pour son mari, celle qui se conduit mal fera le chagrin de son père."
,"5":"Une fille qui ne rougit de rien fait honte à son père comme à son mari, l'un et l'autre la méprisent."
,"6":"Un mot dit au mauvais moment est une musique en temps de deuil, mais en tout temps conviennent le fouet et les sages remontrances. ()"
,"9":"Instruire un sot c'est comme recoller un pot cassé ou réveiller un dormeur abruti de sommeil."
,"10":"Parler à un sot, c'est parler à un homme assoupi; quand tu auras fini il demandera: 'De quoi s'agit-il?'"
,"11":"Pleure sur un mort: il a perdu la lumière; pleure sur un sot: il a perdu l'esprit. Lamente-toi moins pour le mort, car il a trouvé le repos, mais la vie d'un sot est pire que la mort."
,"12":"Sept jours de deuil pour un mort! mais pour le sot et l'impie, c'est tous les jours de leur vie."
,"13":"N'allonge pas la conversation avec l'insensé, ne voyage pas avec un homme stupide. Garde-toi de lui pour ne pas avoir d'ennuis: ses excès pourraient t'éclabousser. Détourne-toi de lui, tu seras en paix au lieu d'être fatigué par sa bêtise."
,"14":"Y a-t-il quelque chose de plus lourd que le plomb? Comment l'appelle-t-on? L'insensé!"
,"15":"Le sable, le sel, une masse de fer, cela se porte plus facilement qu'un homme dénué d'intelligence."
,"16":"Une charpente de bois bien assemblée et encordée ne se disjoint pas dans un tremblement de terre, celui qui s'est bien décidé après mûre réflexion ne sera pas ébranlé au moment du danger."
,"17":"La décision basée sur la réflexion tient aussi bien que l'enduit sur un bon mur."
,"18":"Une palissade sur une hauteur ne résiste pas au vent; de même l'insensé face à ses propres terreurs: n'importe quelle peur aura raison de lui."
,"19":"Frappe un oeil, il en jaillira des larmes; frappe une conscience, ce sera de la lucidité."
,"20":"Jette des pierres aux oiseaux, tu les fais fuir; insulte ton ami et tu briseras l'amitié."
,"21":"Si tu as tiré l'épée contre ton ami, ne désespère pas: il peut te revenir."
,"22":"Si tu as parlé durement, ne crains pas: la réconciliation est possible. Mais s'il s'agit d'outrages, de mépris, d'un secret trahi ou d'un coup perfide, n'importe quel ami s'enfuira."
,"23":"Gagne la confiance de ton prochain tandis qu'il est pauvre: ainsi, lorsqu'il sera devenu riche, tu jouiras avec lui de ses biens. Reste-lui fidèle dans les jours mauvais, et quand lui arrivera un héritage, tu le partageras avec lui."
,"24":"Fumée et vapeurs viennent avant les flammes: les injures précèdent le sang versé."
,"25":"Je n'aurai pas honte de protéger mon ami, je ne me déroberai pas;"
,"26":"et s'il m'arrive du mal par sa faute, tous ceux qui l'apprendront se méfieront de lui."
,"27":"Qui donc mettra une sûreté à ma bouche, un bon cadenas à mes lèvres, de peur qu'elles ne me fassent tomber et que ma langue ne me perde?"
}`)
	CurrentBook.AddChapter(23, `{
"1":"Seigneur, Père et maître de ma vie, ne m'abandonne pas au caprice de mes lèvres, ne permets pas que je tombe à cause de mes paroles."
,"2":"Qui donc dressera au fouet mes pensées, imposera à mon entendement la discipline de la sagesse, sans m'épargner dans mes égarements ni laisser passer mes péchés?"
,"3":"Car autrement je répéterais mes erreurs, mes péchés se reproduiraient, et je tomberais aux mains de mes adversaires pour la joie de mes ennemis."
,"4":"Seigneur, Père et Dieu de ma vie, ne permets pas que je regarde de haut,"
,"5":"et préserve-moi de la cupidité!"
,"6":"Que les plaisirs et le sexe ne s'emparent pas de moi; ne me livre pas à des passions impures!"
,"7":"Mes enfants, apprenez à contrôler votre langage; qui se surveille ne tombera pas par surprise!"
,"8":"Le pécheur se prendra à ses propres paroles, le médisant et l'orgueilleux tomberont dans leurs pièges."
,"9":"Ne dis pas à tout instant: 'Je le jure!' Ne prends pas sans cesse le Très-Haut à témoin."
,"10":"Car, de même qu'un domestique que l'on surveille de près n'échappera pas à la bastonnade, ainsi celui qui jure et invoque continuellement son nom ne sera pas trouvé sans péché."
,"11":"Qui multiplie les serments accumule les transgressions: le châtiment ne s'éloignera pas de sa maison. S'il y manque par négligence, il a déjà péché; si c'est consciemment, le péché est double; s'il a fait un faux serment, il ne sera pas pardonné: sa maison sera accablée de malheurs."
,"12":"Certaines conversations mériteraient la mort: elles sont inadmissibles chez les descendants de Jacob. Les vrais fidèles s'en abstiennent et ne se vautrent pas dans le péché."
,"13":"N'habitue pas ta bouche à l'impureté: ce serait pécher en paroles."
,"14":"Souviens-toi de ton père et de ta mère quand tu es assis au milieu des grands, de peur de te laisser aller en leur présence et de te conduire comme un sot! C'est alors que tu voudrais n'être jamais né et tu maudirais le jour de ta naissance."
,"15":"L'homme habitué à insulter ne s'en corrigera pas de toute sa vie."
,"16":"Deux sortes d'hommes multiplient les péchés, et la troisième provoque la colère du Seigneur:"
,"17":"La passion qui brûle comme un feu ardent ne s'éteindra pas avant d'être satisfaite. L'homme qui commet l'impureté dans son corps ne s'arrêtera pas avant que ce feu ne l'ait dévoré. Pour l'homme impudique toute satisfaction est bonne, il ne se calmera pas avant la mort."
,"18":"L'homme qui pèche contre le mariage se dit en lui-même: 'Qui me verra? Il fait sombre autour de moi, les murs me cachent, nul ne me regarde; pourquoi m'inquiéter? Le Très-Haut ne va pas prendre note de mes péchés.'"
,"19":"Il ne craint que les yeux des hommes, oubliant les yeux du Seigneur, mille fois plus lumineux que le soleil, qui observent toutes nos conduites et voient jusque dans les lieux les plus secrets!"
,"20":"Toutes choses lui étaient présentes avant d'être créées, et elles le seront encore quand elles auront disparu."
,"21":"Un tel homme sera châtié sur la place publique; il sera pris là où il ne s'attendait pas."
,"22":"Il en sera de même pour la femme qui trompe son mari et lui apporte un héritier conçu d'un autre."
,"23":"D'abord elle a désobéi à la loi du Très-Haut, ensuite elle a péché contre son mari, et troisièmement elle s'est souillée par un adultère, ayant des enfants d'un étranger."
,"24":"Cette femme sera amenée devant l'assemblée et l'on fera une enquête sur ses enfants."
,"25":"Ses enfants seront des plantes sans racines, leurs rameaux ne porteront aucun fruit."
,"26":"On ne se souviendra de leur mère que pour maudire, sa honte ne sera jamais effacée."
,"27":"Ainsi les autres sauront que la crainte du Seigneur est la seule chose qui vaille, et que rien n'est plus doux que d'observer ses commandements."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Voici que la Sagesse fait son propre éloge, et qu'elle se rend gloire au milieu de son peuple."
,"2":"Elle a pris la parole à l'Assemblée du Très-Haut, c'est devant le Tout-Puissant qu'elle se glorifie."
,"3":"Je suis sortie, dit-elle, de la bouche du Très-Haut, et comme un brouillard j'ai recouvert la terre."
,"4":"Dans les hauteurs du ciel est ma demeure, mon trône est dans la colonne de nuée."
,"5":"Moi seule ai fait le tour de la voûte du ciel et parcouru le fond des océans."
,"6":"J'ai pris possession des flots de la mer; à moi la terre, et tous les peuples et toutes les nations."
,"7":"Chez eux tous j'ai cherché un lieu où m'arrêter: chez qui, en quel domaine aurai-je un abri?"
,"8":"Et le Créateur de toutes choses m'a donné un ordre, celui qui m'a créée m'a indiqué où dresser ma tente. Il m'a dit: 'Installe-toi en Jacob, qu'Israël soit ton domaine!'"
,"9":"Dès le commencement le Seigneur m'avait créée, avant que n'existe le temps, et je ne passe pas avec le temps."
,"10":"Je célèbre en sa présence la liturgie de sa Sainte Demeure, et c'est pour cela même que je me suis fixée en Sion."
,"11":"Il m'a fait reposer dans la ville bien-aimée, c'est de Jérusalem que j'exerce mon pouvoir."
,"12":"J'ai pris racines dans le peuple glorifié par le Seigneur, dans ce domaine qui est son héritage."
,"13":"Je me suis élevée comme un cèdre du Liban, comme les cyprès sur les pentes de l'Hermon."
,"14":"J'ai grandi comme les palmiers d'Engaddi, comme les lauriers-roses de Jéricho, comme un bel olivier dans la plaine."
,"15":"Comme le cinnamome j'ai donné mon parfum, comme les plantes odoriférantes; comme les sèves aromatiques j'ai répandu ma senteur, comme le baume et la myrrhe de choix, comme les vapeurs de l'encens dans le sanctuaire."
,"16":"Comme le pin parasol j'ai étendu mes branches: elles s'appellent Gloire et Grâce."
,"17":"Comme une vigne j'ai fleuri, avec des fleurs belles à voir qui ont donné des fruits de gloire et de richesse. ()"
,"19":"Venez à moi, vous qui me désirez, et rassasiez-vous de mes fruits."
,"20":"Le souvenir qu'on garde de moi est plus doux que le miel, me posséder est plus suave qu'un rayon de miel."
,"21":"Ceux qui me mangent auront encore faim, et ceux qui me boivent auront encore soif."
,"22":"Celui qui m'écoute ne s'en repentira pas, ceux qui me cultivent ne pécheront pas."
,"23":"Tout cela n'est pas autre chose que le Livre de l'Alliance du Dieu Très-Haut, c'est la Loi que Moïse nous a prescrite et qui est le trésor des assemblées de Jacob."
,"25":"De cette Loi jaillissent les eaux de la sagesse, semblables à celles du Phisôn, ou à celles du Tigre au temps des fruits nouveaux."
,"26":"D'elle déborde le savoir comme une crue de l'Euphrate ou du Jourdain aux jours de la moisson,"
,"27":"d'elle s'échappent les eaux de l'instruction comme les flots du Nil, comme le Gihon aux jours de la vendange."
,"28":"Le premier qui l'a trouvée n'en verra pas la fin, le dernier arrivé ne l'épuisera pas;"
,"29":"car ses pensées sont plus vastes que la mer et ses projets embrassent plus que le grand océan."
,"30":"Pour ma part je n'étais qu'un petit chenal du fleuve, le ruisseau qu'on dérive vers un jardin."
,"31":"Mais j'ai pensé: 'Je vais irriguer mon jardin, je veux arroser mes parterres.' Et voici que mon ruisseau est devenu un fleuve, et mon fleuve, une mer!"
,"32":"Que ma doctrine brille comme l'aurore, et que s'étende au loin sa lumière!"
,"33":"Que mes leçons se propagent comme paroles prophétiques: car je veux la laisser aux générations futures."
,"34":"Voyez: je n'ai pas peiné pour moi seul, mais pour tous ceux qui cherchent la sagesse."
}`)
	CurrentBook.AddChapter(25, `{
"1":"Il y a trois choses que je trouve belles, qui sont belles pour Dieu comme pour les hommes: l'union entre des frères, l'amitié entre des proches, et la parfaite harmonie entre mari et femme."
,"2":"Il y a trois sortes de gens que je déteste, et dont je ne supporte pas la présence: un pauvre orgueilleux, un riche qui ment, un vieillard vicieux et sot."
,"3":"Si tu n'as rien amassé dans ta jeunesse, avec quoi te retrouveras-tu dans ta vieillesse?"
,"4":"C'est une belle chose qu'un homme âgé qui a bon jugement, un ancien qui sait conseiller."
,"5":"C'est une belle chose qu'un vieillard qui est sage, un homme estimé qui comprend et sait décider."
,"6":"Une riche expérience est la couronne des gens âgés; ils peuvent être fiers s'ils ont la crainte du Seigneur."
,"7":"Il y a neuf choses que j'estime heureuses, et j'en ajouterai une dixième: celui qui trouve sa joie dans ses enfants; celui qui voit avant de mourir la ruine de ses ennemis."
,"8":"Heureux encore l'homme qui vit avec une femme de bon sens; celui qui ne laboure pas avec un âne et un boeuf; celui qui n'a pas fauté en paroles; celui qui ne sert pas un maître indigne de lui."
,"9":"Heureux celui qui a acquis un bon jugement, et celui qui sait se faire écouter."
,"10":"Qu'il est grand, celui qui trouve la sagesse! Mais il ne dépasse pas celui qui craint le Seigneur."
,"11":"La crainte du Seigneur est au-dessus de tout: à qui comparer celui qui la possède?"
,"13":"N'importe quelle blessure, plutôt que blessure de coeur! N'importe quelle méchanceté, mais qu'elle ne vienne pas d'une femme!"
,"14":"N'importe quel embarras, mais pas à cause d'un adversaire! N'importe quelle sentence, mais pas dictée par un ennemi."
,"15":"Pas de tête plus redoutable que celle du serpent, pas de pire fureur que celle de l'ennemi!"
,"16":"J'habiterais plus volontiers avec un lion ou un dragon qu'avec une femme méchante."
,"17":"La méchanceté de la femme lui change le visage, il en devient plus sombre que celui d'un ours."
,"18":"Son mari part s'asseoir avec ses voisins, et il ne peut pas s'empêcher de soupirer."
,"19":"Toute méchanceté est peu de chose près d'une malice de femme: puisse la punition des pécheurs tomber sur elle!"
,"20":"Une montée sablonneuse sous les pas d'un vieillard: telle est la femme bavarde pour un mari de bon caractère."
,"21":"Ne te laisse pas prendre à la beauté d'une femme, ne la convoite pas!"
,"22":"Mauvaise humeur, impatience, reproches...  il fallait s'y attendre si c'est la femme qui commande au mari!"
,"23":"Coeur abattu, visage attristé et blessure cachée: voilà le travail d'une femme méchante! Bras ballants et genoux mal assurés: elle ne rend pas heureux son mari!"
,"24":"Le péché a commencé avec la femme: c'est à cause d'elle que tous nous mourons."
,"25":"Arrête aussitôt les fuites d'eau! ne laisse pas une méchante femme s'imposer."
,"26":"Si elle ne marche pas comme tu lui dis, plus de relations!"
}`)
	CurrentBook.AddChapter(26, `{
"1":"Heureux le mari d'une bonne épouse: le nombre de ses jours en sera doublé!"
,"2":"Une femme vaillante fait la joie de son mari, il connaîtra la paix tous les jours de sa vie."
,"3":"Une bonne épouse est le gros lot, elle reviendra à celui qui craint le Seigneur."
,"4":"Riche ou pauvre, il aura le coeur content; à tout moment l'on verra son bonheur sur son visage."
,"5":"Il y a trois choses que je redoute, et une quatrième qui m'effraie: une calomnie répandue dans l'entourage, une foule en révolte et une accusation fausse; tout cela est pire que la mort."
,"6":"Mais la femme jalouse d'une autre, c'est un deuil, une douleur intime; sa langue est un fouet qui n'épargne personne."
,"7":"La femme méchante est un joug à boeufs mal amarré: y mettre la main est aussi risqué que saisir un scorpion."
,"8":"C'est un grand scandale qu'une femme qui boit, elle ne pourra pas remédier à son discrédit."
,"9":"Une femme sans pudeur se reconnaît à ses coups d'oeil, à ses regards effrontés."
,"10":"Tiens en laisse une fille hardie, elle profiterait de ta complaisance."
,"11":"Garde-toi de suivre la femme séduisante; ne te fais pas d'illusions: elle veut t'avoir."
,"12":"Le voyageur assoiffé ouvre la bouche à toute eau qui se présente: elle aussi s'assied face à n'importe quel piquet, à toute flèche elle ouvre son carquois."
,"13":"La grâce d'une femme réjouit son mari, mais son savoir faire le réconforte jusqu'à la moelle des os."
,"14":"Une femme qui sait se taire est un don du Seigneur, rien n'est comparable à celle qui est bien éduquée."
,"15":"La femme pudique est doublement charmante, celle qui est chaste est un trésor inestimable."
,"16":"Comme le soleil levant sur les montagnes du Seigneur, tel est le charme d'une bonne épouse dans une maison bien tenue."
,"17":"Comme la lampe qui brille sur le lampadaire sacré, tel est un beau visage sur un corps harmonieux."
,"18":"Comme des colonnes d'or sur un socle d'argent, telles sont de belles jambes sur des talons bien plantés. ()"
,"28":"Pour deux choses je m'afflige, pour une troisième la colère me prend: un homme de guerre réduit à la misère, des gens sensés que l'on méprise, celui enfin qui passe d'une vie droite au péché; le Seigneur le destine à périr par l'épée."
,"29":"Il est difficile à un marchand de ne pas chercher à avoir les autres; un commerçant ne se préservera pas du péché."
}`)
	CurrentBook.AddChapter(27, `{
"1":"Beaucoup ont péché par amour du gain; qui cherche à s'enrichir ne cherche plus à voir."
,"2":"Comme un piquet s'enfonce entre deux pierres jointes, ainsi s'installe le péché entre la vente et l'achat."
,"3":"Qui ne s'attache pas fermement à la crainte du Seigneur, sa maison sera bientôt renversée."
,"4":"On retrouve les saletés dans le crible après qu'on l'a secoué; de même les défauts de l'homme dans ses discours."
,"5":"Le four sera l'épreuve pour les vases de terre; pour un homme, ce sera sa façon de raisonner."
,"6":"Les fruits de l'arbre montreront s'il a été bien cultivé: de même les paroles d'un homme font connaître son fond."
,"7":"Ne fais l'éloge de personne avant qu'il ne se soit exprimé: pour tout homme c'est l'épreuve."
,"8":"Si tu poursuis la justice, tu l'atteindras; tu t'en revêtiras comme d'un manteau de fête."
,"9":"Les oiseaux font leur nid auprès de leurs semblables, la vérité retourne à ceux qui la pratiquent."
,"10":"Le lion guette sa proie, et le péché de même ceux qui font le mal."
,"11":"La conversation d'un homme de Dieu a toujours sa sagesse, l'insensé au contraire est changeant comme la lune."
,"12":"Chez ceux qui n'entendent pas, sois avare de ton temps, donne-le largement à ceux qui réfléchissent."
,"13":"La conversation des sots est énervante, il leur faut des obscénités pour rire."
,"14":"Un langage plein de jurons met les nerfs en boule, ce genre de dispute fait se boucher les oreilles."
,"15":"Une querelle d'orgueilleux, et le sang coule; leurs injures déja font mal à entendre."
,"16":"Qui révèle des secrets perd son crédit, il ne trouvera plus d'amis selon son coeur."
,"17":"Aime ton ami et reste-lui fidèle; si tu as révélé ses secrets, ne lui cours plus après;"
,"18":"c'est comme si tu avais perdu l'un de tes proches: son amitié pour toi est morte."
,"19":"Tu as laissé l'oiseau s'échapper de ta main: ton ami est parti, inutile de partir en chasse."
,"20":"Ne le poursuis pas: comme la gazelle qui se dégage du filet, il a pris ses distances."
,"21":"On peut bander une blessure, se réconcilier après les injures, mais avoir révélé des secrets, c'est sans espoir."
,"22":"Celui qui cligne de l'oeil complote le mal, et personne ne l'en détournera."
,"23":"En ta présence sa bouche est mielleuse, il admire tout ce que tu dis, mais ensuite il parle autrement et il travestit tes paroles pour te perdre."
,"24":"Il y a bien des choses que je déteste, mais rien autant que lui: le Seigneur lui-même le déteste."
,"25":"Qui lance une pierre en l'air la lance sur sa propre tête, et qui porte un coup en traître sera blessé en retour."
,"26":"Qui creuse une fosse y tombera, et qui tend un filet s'y fera prendre."
,"27":"A qui commet des actions mauvaises elles reviendront, et de là où il ne l'attend pas."
,"28":"Les orgueilleux sont forts pour la moquerie et l'insulte, mais la justice les attend comme un lion à l'affût."
,"29":"Ceux qui prennent plaisir à faire tomber les fidèles, seront pris au filet. La douleur fera d'eux sa proie avant même qu'ils ne meurent."
,"30":"Rancune et colère, voilà encore deux choses abominables où le pécheur excelle."
}`)
	CurrentBook.AddChapter(28, `{
"1":"Celui qui se venge éprouvera la vengeance du Seigneur: il lui tiendra des comptes rigoureux pour tous ses péchés."
,"2":"Pardonne à ton prochain le tort qu'il t'a fait; alors, si tu le demandes, tes péchés te seront remis."
,"3":"Quoi! Un humain garde rancune à un autre humain, et il demande à Dieu de le guérir?"
,"4":"Il est sans miséricorde pour un autre homme, son semblable, et il supplie pour ses propres péchés!"
,"5":"S'il garde rancune, lui faible et pécheur, qui lui obtiendra son pardon?"
,"6":"Souviens-toi de ta fin, et cesse de haïr; pense à la mort, à la décomposition, et observe les commandements."
,"7":"Souviens-toi des commandements et ne garde pas rancune à ton prochain; pense à l'Alliance du Très-Haut, et oublie l'offense."
,"8":"Tiens-toi à l'écart des disputes et tu feras moins de péchés, car l'homme colérique allume les querelles."
,"9":"Le pécheur jette le trouble entre les amis, il met la brouille parmi ceux qui vivaient en paix."
,"10":"L'ardeur du feu dépend du combustible, la querelle se développe selon les passions; plus l'homme est fort, plus il s'emporte; plus il est riche, plus il gonfle sa colère."
,"11":"Une dispute imprévue allume le feu, une querelle soudaine fait couler le sang."
,"12":"Souffle sur l'étincelle, le feu s'enflamme; crache dessus, elle s'éteint: les deux dépendent de ta bouche!"
,"13":"Maudissez le calomniateur et son double discours: il a fait périr bien des gens qui vivaient en paix."
,"14":"Les insinuations d'une tierce personne les ont démolis, jusqu'à les disperser de nation en nation; elles ont détruit des villes puissantes et renversé de grandes maisons."
,"15":"La calomnie a fait répudier des femmes vaillantes et les a privées du fruit de leurs travaux."
,"16":"Qui lui prête l'oreille ne trouvera plus le repos, il ne vivra plus en paix."
,"17":"Un coup de fouet laisse une meurtrissure, un coup de langue brise les os."
,"18":"Beaucoup sont tombés victimes de l'épée, plus nombreuses encore les victimes de la langue."
,"19":"Heureux l'homme qui est resté hors de ses atteintes et n'a pas connu sa fureur, qui n'a pas traîné son joug et n'a pas eu à porter ses chaînes,"
,"20":"car son joug est un joug de fer, et ses chaînes, des chaînes de bronze."
,"21":"La langue inflige une mort misérable, mieux vaut descendre au séjour d'en-bas!"
,"22":"Mais elle n'aura pas raison des fidèles; sa flamme ne les brûlera pas."
,"23":"Ceux qui abandonnent le Seigneur, oui, s'y feront prendre. Elle brûlera en eux sans jamais s'éteindre; elle se déchaînera sur eux comme un lion, comme une panthère elle les déchirera."
,"24":"Tu entoures ta terre d'une haie d'épines, ton argent et ton or, tu les mets sous clé;"
,"25":"pour tes paroles il te faut une balance et des poids: mets à ta bouche une porte et des verrous."
,"26":"Il ne faudrait pas qu'elle te fasse trébucher, et que tu tombes devant celui qui te guette."
}`)
	CurrentBook.AddChapter(29, `{
"1":"Qui connaît la compassion, prête à son prochain, celui qui lui vient en aide observe les commandements."
,"2":"Prête à ton prochain s'il est dans le besoin; de ton côté, rembourse ton prochain au temps fixé."
,"3":"Tiens parole, sois loyal avec ton prochain, et en tout temps tu trouveras ce qu'il te faut."
,"4":"Pour beaucoup, le prêt qu'on leur a fait n'est qu'une aubaine; ils mettront en difficulté ceux qui les ont aidés."
,"5":"Tant qu'on n'a pas reçu, on baise les mains du prochain, on se fait humble en pensant à ce qu'il a; mais au moment de rendre on demande un sursis, on paye en paroles déplaisantes, on gémit sur la dureté des temps."
,"6":"Même si on peut rembourser, le prêteur aura de la chance s'il en récupère la moitié. Dans le cas contraire, il s'est fait prendre son argent et il n'y a gagné qu'un ennemi; celui-ci le paiera en malédictions et insultes, avec du mépris au lieu de reconnaissance."
,"7":"Bien des gens refusent de prêter, non par méchanceté, mais par peur d'être dépouillés sans raison."
,"8":"Sois pourtant généreux envers le pauvre, ne le laisse pas attendre ton aumône."
,"9":"Selon le commandement, prends soin de l'indigent; vois quel est son besoin, et ne le renvoie pas les mains vides."
,"10":"Perds ton argent pour un frère ou un ami, plutôt que de le laisser rouiller sous une pierre en pure perte."
,"11":"Place ton trésor selon les commandements du Très-Haut, cela te sera plus utile que de l'or."
,"12":"Remplis tes greniers de tes générosités, elles te garderont du malheur;"
,"13":"face à l'ennemi elles combattront pour toi, mieux qu'un solide bouclier ou une lourde lance."
,"14":"L'homme de bien se porte garant pour son prochain; il faudrait avoir perdu toute honte pour l'abandonner."
,"15":"N'oublie pas les services de ton garant; il s'est risqué pour toi."
,"16":"Mais le pécheur gaspille les biens de son répondant; c'est un ingrat, il oublie celui qui l'a sauvé."
,"17":"Une caution a ruiné bien des gens à l'aise, elle les a secoués comme l'écume des mers."
,"18":"Elle a forcé des hommes puissants à s'expatrier, faisant d'eux des errants en des nations étrangères."
,"19":"Le pécheur se porte garant quand il pense en tirer profit, mais ce sont des procès qu'il va récolter."
,"20":"Viens en aide à ton prochain autant que tu le peux, mais veille à ne pas tomber toi-même."
,"21":"L'indispensable pour vivre, c'est l'eau, le pain, le vêtement, et une maison pour s'abriter."
,"22":"Mieux vaut vivre comme un pauvre sous ses planches que manger comme un prince chez des étrangers."
,"23":"Accommode-toi du peu ou du beaucoup que tu as: cela vaut mieux que d'entendre les reproches de quelqu'un qui t'héberge."
,"24":"C'est une triste vie que d'aller de maison en maison; là où tu es, tu n'oses ouvrir la bouche."
,"25":"Tu as beau être celui qui donne à manger et à boire, tu entends les paroles amères d'un ingrat:"
,"26":"'Viens ici, l'étranger, prépare la table; si tu as quelque chose, donne-moi à manger!'"
,"27":"Ou encore: 'Va-t'en, l'étranger, c'était inattendu! Mon frère vient en visite et j'ai besoin de la maison!'"
,"28":"Quand on se respecte, c'est dur de s'entendre reprocher l'hospitalité et d'être traité comme un débiteur."
}`)
	CurrentBook.AddChapter(30, `{
"1":"Celui qui aime son fils ne lui épargne pas le fouet, plus tard il trouvera en lui sa joie."
,"2":"Qui élève bien son fils y trouvera des satisfactions, il en sera fier devant ses proches."
,"3":"Celui qui instruit son fils rendra jaloux son ennemi; il s'en réjouira devant ses amis."
,"4":"Quand ce père disparaît, c'est comme s'il n'était pas mort, car il laisse après lui un autre lui-même."
,"5":"Durant sa vie, c'était son bonheur de le voir; quand vient la mort il n'a pas de chagrin."
,"6":"Car il laisse, face à ses ennemis, celui qui fera justice, et pour ses amis, celui qui leur montrera de la reconnaissance."
,"7":"Celui qui gâte son fils devra panser ses blessures; au moindre de ses cris il sera retourné."
,"8":"Un cheval indompté devient impossible, un fils laissé à lui-même devient intraitable."
,"9":"Tu veux choyer ton enfant? un jour il te fera peur; folâtre avec lui, il te causera du chagrin."
,"10":"Ne ris pas avec lui, si tu ne veux pas un jour t'affliger avec lui et finalement grincer des dents."
,"11":"Ne lui laisse pas la bride sur le cou dans sa jeunesse,"
,"12":"Malmène lui les côtes quand il est petit, de peur qu'il ne s'obstine et se rebelle."
,"13":"Eduque bien ton fils, travaille-le, ou sinon son inconduite se retournera contre toi."
,"14":"Mieux vaut un pauvre en bonne santé et vigoureux qu'un riche éprouvé dans son corps."
,"15":"La santé et une bonne constitution valent mieux que tout l'or du monde, et un corps robuste, qu'une immense fortune."
,"16":"Il n'y a pas de plus grande richesse que la santé du corps, il n'y a pas de plaisir supérieur à la joie de vivre."
,"17":"Mieux vaut la mort qu'une vie de misères, et le repos éternel qu'une maladie tenace."
,"18":"Déposer sur les tombes des offrandes de nourriture, c'est présenter de bonnes choses à une bouche fermée;"
,"19":"de même l'offrande faite à une idole: à quoi bon, puisqu'elle ne mange ni ne sent rien?,Ainsi en est-il de l'homme que le Seigneur poursuit: "
,"20":"il voit la nourriture et il soupire; il est comme l'homme châtré qui enlace une jeune fille et gémit."
,"21":"Ne te laisse pas aller à la tristesse, ne te tourmente pas au sujet de ton avenir."
,"22":"Un coeur joyeux, voilà ce qui maintient l'homme en vie; c'est la gaieté qui prolonge ses jours."
,"23":"Allons! Divertis-toi et console ton coeur; chasse la tristesse loin de toi, car la tristesse en a perdu beaucoup et elle ne sert absolument à rien."
,"24":"La jalousie et la fureur abrègent la vie, les soucis font vieillir avant l'âge."
,"25":"Qui a le coeur joyeux a bon appétit; ce qu'il mange lui profite."
}`)
	CurrentBook.AddChapter(31, `{
"1":"Les veilles que réclame la richesse font perdre du poids, les soucis qu'elle apporte éloignent le sommeil."
,"2":"Veilles et soucis empêchent de s'assoupir, un mal grave écarte le sommeil."
,"3":"Le riche s'est donné de la peine pour amasser une fortune, quand il s'arrête, c'est pour jouir de son luxe."
,"4":"Le pauvre s'est donné de la peine pour survivre, dès qu'il s'arrête c'est l'indigence."
,"5":"Qui aime l'or ne sera pas sans péchés, qui poursuit le gain se laissera égarer."
,"6":"Beaucoup sont tombés à cause de l'or, la ruine est allée à leur rencontre."
,"7":"L'or jette à terre ceux qui en font leur dieu; ceux qui ne pensent pas s'y laissent tous prendre."
,"8":"Heureux le riche qu'on a trouvé irréprochable, qui n'a pas couru après l'or!"
,"9":"Qui est-il? Nous dirons: 'Heureux cet homme, il a donné au peuple un exemple admirable!'"
,"10":"Qui a passé ce test et a été reconnu sans faille? Il peut en être fier. Qui a eu les moyens de fauter et n'a pas commis la faute, qui pouvait faire le mal et ne l'a pas fait?"
,"11":"Sa fortune sera durable, on redira dans l'assemblée ses oeuvres généreuses."
,"12":"Te voilà assis à une table magnifique, ne reste pas bouche bée en t'exclamant: 'Quelle abondance!'"
,"13":"Souviens-toi que l'avidité est un mal. Y a-t-il créature pire que l'oeil avide? Et c'est pourquoi tout ce qu'il voit le fait pleurer."
,"14":"N'étends pas la main vers tout ce que tu vois, ne te précipite pas sur le plat."
,"15":"Pense que les autres sont dans la même situation que toi, agis en tout avec réflexion."
,"16":"Mange ce qu'on te présente en homme bien élevé, et pas comme un glouton, ce qui te ferait détester."
,"17":"Sois le premier à t'arrêter, question d'éducation; ne sois pas vorace, tu choquerais."
,"18":"Si tu es assis avec beaucoup d'autres, ne prends pas dans le plat le premier."
,"19":"Peu de chose suffit à un homme bien élevé; une fois au lit, il n'aura pas de mal à respirer."
,"20":"Un estomac léger procure un sommeil sain; on est levé tôt, et la tête lucide. Mais l'insomnie, les vomissements et les coliques, voilà ce qui attend l'homme glouton."
,"21":"Si tu as été forcé de trop manger, lève-toi, va vomir à l'écart et tu seras soulagé."
,"22":"Ecoute-moi, mon enfant, ne te moque pas de mes avis: à la fin tu verras que je disais vrai. Sois modéré dans tout ce que tu fais, et aucune maladie ne t'arrivera."
,"23":"Quand l'hôte fait les choses en grand, on le félicite, on parle à juste titre de sa générosité."
,"24":"Si l'hôte a été mesquin, tout le monde critique, on parle avec force détails de sa mesquinerie."
,"25":"Avec le vin ne joue pas au fort, car le vin en a perdu beaucoup."
,"26":"La fournaise éprouve la trempe de l'acier, le vin met à l'épreuve les coeurs, poussant à la dispute les orgueilleux."
,"27":"Le vin pour un homme, c'est la vie, tant que tu le bois avec mesure. Qu'est-ce qu'une vie où manque le vin? Il a été créé pour la joie des humains."
,"28":"Allégresse du coeur et réconfort de tout l'être, voilà ce qu'est le vin bu à son heure et avec mesure."
,"29":"Malaise de tout l'être, voilà ce qu'est le vin bu en quantité par vice ou par bravade."
,"30":"L'ivresse excite les insensés: ils le paieront; elle diminue les forces et attire les coups."
,"31":"Quand le vin coule largement au cours d'un banquet, n'importune pas ton voisin; ne le méprise pas s'il est joyeux. Ce n'est pas le moment pour l'insulter ou pour le harceler sur des questions d'argent."
}`)
	CurrentBook.AddChapter(32, `{
"1":"On t'a choisi pour présider le festin? Ne prends pas de grands airs. Sois avec les autres comme l'un d'entre eux; occupe-toi d'eux puis prends ta place simplement."
,"2":"Quand tu auras fait tout le nécessaire, tu t'allongeras à ta place pour te réjouir avec eux. Alors tu recevras la couronne pour ta bonne organisation."
,"3":"Parle, si tu es ancien, cela te revient; mais sache ce que tu dis et n'empêche pas la musique."
,"4":"Quand on est en train d'écouter, ce n'est pas le moment des discours, ne fais pas le sage à contretemps."
,"5":"Un concert au cours d'un banquet bien arrosé, c'est une pierre précieuse sur un bijou d'or."
,"6":"Le chant des musiciens vient sur la douceur du vin comme une émeraude sur sa monture d'or."
,"7":"Parle, toi qui es jeune, si on te le demande, mais pas plus de deux fois, et pour répondre."
,"8":"Résume ton discours, dis beaucoup en peu de mots. Montre que tu sais, mais que tu sais te taire."
,"9":"Si tu es avec des gens importants, ne les traite pas d'égal à égal; ne bavarde pas pendant qu'un autre parle."
,"10":"L'éclair part avant le tonnerre: quand arrive l'homme modeste, il est déja attendu."
,"11":"Lève-toi de table dès qu'il est temps, ne t'attarde pas. Arrive vite chez toi sans traîner en chemin."
,"12":"Là tu te changeras les idées, tu feras ce qui te plaît, mais sans pécher par des paroles insolentes."
,"13":"Finalement tu béniras celui qui t'a fait et qui te comble de ses biens."
,"14":"Celui qui craint le Seigneur accepte ses leçons, ceux qui le cherchent dès l'aurore recevront bon accueil."
,"15":"Qui s'adonne à la Loi, elle le comblera; celui qui fait semblant, elle le fera tomber."
,"16":"Ceux qui craignent le Seigneur, il les recevra; leurs bonnes actions brilleront comme la lumière."
,"17":"Le pécheur n'accepte pas la réprimande, il trouve toujours à justifier ce qui lui plaît."
,"18":"L'homme prudent ne néglige pas la réflexion, mais l'orgueilleux indifférent n'a peur de rien."
,"19":"Ne fais rien sans avoir réfléchi, et tu ne te repentiras pas de tes actes."
,"20":"Ne prends pas le chemin raboteux et tu ne trébucheras pas sur les pierres."
,"21":"Ne te fie pas au chemin bien uni:"
,"22":"garde-toi, même de tes enfants."
,"23":"Dans tout ce que tu fais, agis selon ta conscience: c'est ainsi que tu observeras les commandements."
,"24":"Qui fait confiance à la Loi est attentif aux commandements; qui obéit au Seigneur ne subira aucun dommage."
}`)
	CurrentBook.AddChapter(33, `{
"1":"Le malheur ne recherche pas celui qui craint le Seigneur; s'il connaît l'épreuve il en sera racheté."
,"2":"L'homme sage ne déteste pas la Loi, celui qui ne la suit qu'en apparence est comme un bateau dans la tempête."
,"3":"L'homme intelligent met sa confiance dans la Loi; pour lui la Loi est digne de foi comme une réponse divine."
,"4":"Prépare ton discours et tu seras écouté: fais une bonne synthèse, et ensuite parle."
,"5":"Les sentiments du sot sont comme une roue de chariot, ses raisonnements font la girouette."
,"6":"Un ami moqueur est comme un étalon excité, il hennit sous n'importe quel cavalier."
,"7":"Pourquoi tel jour est-il plus important qu'un autre, puisque tous les jours reçoivent la lumière du soleil?"
,"8":"Une décision du Seigneur les a faits différents, lui qui a disposé les fêtes et les saisons."
,"9":"Il a élevé et sanctifié certains d'entre eux; les autres il les a pris pour faire nombre."
,"10":"Les hommes aussi sont tous tirés du sol, et c'est de la terre qu'Adam fut formé."
,"11":"Le Seigneur pourtant, dans sa sagesse universelle, les a séparés, les plaçant sur des chemins différents."
,"12":"Il a béni et exalté certains d'entre eux, il les a consacrés et pris à son service; d'autres, il les a maudits et abaissés, il leur a fait perdre leur place."
,"13":"Comme la glaise est dans la main du potier qui la modèle à son goût, ainsi les hommes sont dans la main de celui qui les a faits: il traite chacun comme il le juge bon."
,"14":"D'un côté le mal, de l'autre le bien; d'un côté la mort, de l'autre la vie: et de même le pécheur face au fidèle."
,"15":"Regarde d'ailleurs toutes les oeuvres du Très-Haut; elles vont par deux, l'une s'opposant à l'autre."
,"16":"Quant à moi, j'ai veillé après tous les autres, semblable à celui qui grappille derrière les vendangeurs."
,"17":"Mais par la bénédiction du Seigneur je suis arrivé en tête et j'ai rempli de grappes le pressoir."
,"18":"Comprenez que je n'ai pas peiné pour moi seul, mais pour tous ceux qui cherchent le savoir."
,"19":"Ecoutez-moi donc, grands du peuple; prêtez l'oreille, vous qui présidez l'assemblée!"
,"20":"Ni à ton fils, ni à ta femme, ou à ton frère ou ton ami: à aucun ne donne pouvoir sur toi durant ta vie! Ne donne pas tes biens à un autre; tu pourrais le regretter et devoir les redemander."
,"21":"Tant qu'il te reste un souffle de vie, ne livre à personne ta liberté."
,"22":"Il vaut mieux que tes enfants dépendent de toi plutôt que d'avoir toi-même à les supplier."
,"23":"Garde la responsabilité de tout ce que tu fais, ne permets pas que d'autres tachent ta réputation."
,"24":"Au jour qui conclura les jours de ta vie, quand sera venue l'heure de ta fin, alors tu répartiras l'héritage."
,"25":"Pour l'âne: le fourrage, le bâton et les fardeaux; pour le serviteur: le pain, les corrections et le travail."
,"26":"Travaille sur ton esclave et tu auras la paix; relâche-lui la bride et il voudra la liberté."
,"27":"Le joug et le licol font plier le cou; pour le mauvais serviteur, les châtiments et les chaînes."
,"28":"Mets-le au travail, qu'il ne reste pas oisif, car l'oisiveté enseigne le mal."
,"29":"Fais-le travailler selon sa capacité, et s'il n'obéit pas mets-lui des fers aux pieds."
,"30":"Mais ne sois trop exigeant envers personne, ne fais rien sans discernement."
,"31":"Si tu as un domestique, qu'il soit comme un autre toi-même, puisque tu l'as acquis par le sang."
,"32":"Si tu as un domestique, traite-le comme un frère, puisque tu as besoin de lui comme de toi."
,"33":"Si tu le maltraites et qu'il prenne la fuite, où iras-tu le chercher?"
}`)
	CurrentBook.AddChapter(34, `{
"1":"Les espérances vaines et mensongères sont pour les imbéciles: les songes donnent des ailes aux insensés."
,"2":"Compter sur des songes, c'est comme poursuivre une ombre ou courir après le vent."
,"3":"Ce qu'on voit en rêve n'est qu'un reflet: la personne voit sa propre image."
,"4":"Peut-on se purifier avec une chose impure? Et trouvera-t-on la vérité dans ce qui est mensonge?"
,"5":"Prédictions, voyance et songes sont aussi vides que les fantasmes d'une femme enceinte."
,"6":"A moins qu'ils ne te soient envoyés comme une visite du Très-Haut, ne leur donne pas ton attention."
,"7":"Les songes ont égaré bien des gens; ceux qui comptaient dessus sont tombés à côté."
,"8":"La Loi par contre s'accomplira sans faute: elle est sage en ce qu'elle dit, fidèle en ce qu'elle promet."
,"9":"Celui qui a voyagé connaît bien des choses, un homme d'expérience parle en connaissance de cause."
,"10":"Celui qui n'a pas été mis à l'épreuve sait peu, celui qui a roulé sa bosse a acquis bien des savoir-faire."
,"11":"J'ai vu beaucoup de choses au cours de mes voyages, et j'en sais plus que je ne saurais dire."
,"12":"J'ai souvent été en danger de mort, et je m'en suis tiré grâce à mon expérience."
,"13":"Ceux qui craignent le Seigneur auront la vie sauve, car ils ont mis leur espérance en celui qui peut les sauver."
,"14":"Celui qui craint le Seigneur sera sans crainte, il ne s'effraiera de rien car Lui est son espérance."
,"15":"Celui qui craint le Seigneur sait son bonheur: sur qui donc s'est-il appuyé, qui donc est sa force?"
,"16":"Le regard du Seigneur couvre ceux qui l'aiment, il est une puissante protection, un soutien qui résiste, un abri contre le vent brûlant et le soleil de midi, une sécurité contre les chutes, une aide au moment de tomber."
,"17":"Le Seigneur redonne le courage et illumine les yeux, il donne guérison, vie et bénédiction."
,"18":"Donner à Dieu un bien mal acquis, c'est une offrande souillée; les dons des méchants ne sauraient plaire à Dieu."
,"19":"Le Très-Haut ne prend pas plaisir aux offrandes des impies; ce n'est pas à force de sacrifices que leurs péchés seront pardonnés."
,"20":"Offrir un sacrifice pris sur les biens des indigents, c'est mettre à mort un fils en l'honneur de son père."
,"21":"Le pain qu'ils ont mendié est la vie des pauvres; celui qui les en prive est un assassin."
,"22":"Il tue son prochain, celui qui lui enlève ses moyens de vivre; retenir le salaire du salarié, c'est tout comme verser le sang."
,"23":"L'un construit, l'autre abat; qu'ont-ils gagné de plus que leur peine?"
,"24":"L'un prie, l'autre maudit; duquel le Maître écoutera-t-il la voix?"
,"25":"Si l'on se baigne après avoir touché un mort, et qu'on le touche à nouveau, à quoi rimait la purification?"
,"26":"C'est le cas de celui qui jeûne pour ses péchés puis s'en va les recommencer: qui écoutera sa prière? A quoi lui a servi sa pénitence?"
}`)
	CurrentBook.AddChapter(35, `{
"1":"Qui observe la Loi fait mieux que de multiplier les offrandes; s'attacher aux commandements, c'est offrir un sacrifice de communion."
,"2":"Un acte généreux est une offrande de farine pure, l'aumône est un sacrifice de louange."
,"3":"Ce qui plaît au Seigneur, c'est qu'on s'éloigne du mal; quel beau sacrifice d'expiation que de fuir l'injustice!"
,"4":"Mais tu ne te présenteras pas devant le Seigneur les mains vides: tous ces sacrifices t'ont été prescrits."
,"5":"Quand le juste présente son offrande, la graisse est pour l'autel, mais la bonne odeur monte vers le Très-Haut."
,"6":"Le sacrifice du juste est bien accueilli, le Seigneur n'en perdra pas le souvenir."
,"7":"Glorifie le Seigneur d'un coeur généreux, offre-lui sans tricher les premiers fruits de ton travail."
,"8":"Chaque fois que tu donnes, montre un visage joyeux, sois heureux de présenter tes dîmes."
,"9":"Donne au Très-Haut comme il t'a donné, de bon coeur et selon tes moyens;"
,"10":"car le Seigneur paie de retour, il te rendra sept fois plus."
,"11":"Ne cherche pas à acheter ses faveurs, il ne les accepterait pas; ton offrande de biens mal acquis ne te vaudrait rien."
,"12":"Car le Seigneur est le juge, et il ne fait pas de favoritisme."
,"13":"Il ne recevra pas plus mal le pauvre, il écoutera la prière de l'opprimé."
,"14":"Il ne méprisera pas la supplication de l'orphelin, ni les gémissements de la veuve."
,"15":"Lorsque les larmes de la veuve coulent sur ses joues, son cri n'accuse-t-il pas celui qui la fait pleurer?"
,"16":"Celui qui adore Dieu d'un coeur entier trouvera bon accueil, son appel parviendra jusqu'aux cieux."
,"17":"Le prière de l'humble traverse les nuages, il ne se consolera pas qu'il ne soit exaucé."
,"18":"Il ne s'en ira pas, il faudra que le Très-Haut s'occupe de lui, que le Seigneur intervienne en faveur des justes."
,"19":"Mais le Seigneur ne tardera pas; il ne fera pas durer l'attente."
,"20":"Il cassera les reins de ceux qui sont sans pitié et tirera vengeance des nations;"
,"21":"il exterminera la multitude des violents et brisera le pouvoir des injustes."
,"22":"Il rendra à chacun, à la fin, ce qu'il mérite, d'après ses actes et ses intentions;"
,"23":"il fera justice à son peuple et son peuple se réjouira de sa miséricorde."
,"24":"Comme elle sera bienvenue, sa miséricorde, au temps de la détresse! autant que les nuages après la sécheresse."
}`)
	CurrentBook.AddChapter(36, `{
"1":"Prends pitié de nous, Maître, Dieu de toutes choses et regarde-nous, et jette ta crainte sur toutes les nations."
,"2":"Lève ta main contre les nations étrangères et fais-leur voir ta puissance!"
,"3":"Tu leur as montré ta sainteté dans ce qui nous est arrivé, fais-nous voir maintenant ta grandeur en agissant chez elles."
,"4":"Fais qu'elles te reconnaissent, comme nous t'avons reconnu: car il n'y a pas d'autre Dieu que toi, Seigneur!"
,"5":"Donne de nouveaux signes, renouvelle tes merveilles, montre ta gloire en agissant et frappant."
,"6":"Ravive ta fureur et déverse ta colère; détruis l'adversaire et supprime l'ennemi."
,"7":"Hâte le jour, souviens-toi de ton serment, et qu'on puisse bientôt raconter tes hauts faits."
,"8":"Que les survivants soient la proie du feu, que périssent les oppresseurs de ton peuple!"
,"9":"Brise la tête des ennemis, de leurs chefs qui disent: 'Il n'y a que nous!'"
,"10":"Rassemble toutes les tribus de Jacob, et donne-leur comme au commencement leur héritage."
,"11":"Prends pitié, Seigneur, de ce peuple qui porte ton Nom! pitié pour Israël que tu as considéré comme ton premier-né!"
,"12":"Aie compassion de ta Ville sainte, de Jérusalem, le lieu de ton repos."
,"13":"Remplis Sion du récit de tes merveilles, et ton peuple de ta gloire."
,"14":"Confirme les promesses que tu fis au début, et fais réapparaître les prophéties en ton nom."
,"15":"Donne leur salaire à ceux qui t'ont attendu, et montre que tes prophètes disaient vrai."
,"16":"Exauce, Seigneur, la prière de tes serviteurs, écoute tes prêtres quand ils donnent à ton peuple la bénédiction d'Aaron."
,"17":"Et que tous sur terre reconnaissent que tu es le Seigneur, le Dieu éternel!"
,"18":"L'estomac absorbe toutes les nourritures, mais certains aliments sont meilleurs que d'autres."
,"19":"Le palais reconnaît le goût du gibier, de même le coeur avisé détecte les paroles mensongères."
,"20":"Un coeur tortueux cause du chagrin, mais l'homme d'expérience saura lui répondre."
,"21":"Une femme accepte n'importe quel mari, mais il y a des filles meilleures que d'autres."
,"22":"La beauté d'une femme illumine son visage et comble tous les désirs d'un homme."
,"23":"Si ses paroles sont empreintes de bonté et de douceur, son mari est le plus heureux des hommes."
,"24":"Celui qui a pris femme a commencé à s'enrichir; il a une aide semblable à lui, une colonne pour s'y appuyer."
,"25":"Un domaine non clôturé attire les pillards: là où manque la femme on gémit et on va à l'aventure."
,"26":"Qui ferait confiance à un voleur habile courant de ville en ville?"
,"27":"C'est pareil pour celui qui n'a pas de gîte et s'arrête là où la nuit le surprend."
}`)
	CurrentBook.AddChapter(37, `{
"1":"Tous tes amis diront: 'Moi aussi, je t'aime bien', mais l'ami peut ne l'être que de nom."
,"2":"N'est-ce pas tristesse mortelle quand un compagnon ou un ami se change en ennemi?"
,"3":"O mauvais désirs, d'où êtes-vous sortis pour couvrir la terre de tromperies?"
,"4":"Voyez ce compagnon qui profite de la bonne fortune de son ami: que vienne le malheur, il se tourne contre lui."
,"5":"Voyez ce compagnon qui souffre pour son ami tant qu'il y a profit pour son ventre: que vienne le danger, il ne pense qu'à se mettre à l'abri."
,"6":"Que ton coeur n'oublie pas ton ami, ne le laisse pas tomber si tu deviens riche."
,"7":"Tout conseiller fait valoir son avis, mais plus d'un conseille dans son propre intérêt."
,"8":"Fais attention à qui te conseille: demande-toi d'abord de quoi il a besoin, car il parlera selon son intérêt. Peut-être cherche-t-il à te rouler."
,"9":"'Ta décision est bonne' dira-t-il, puis il suivra l'affaire pour voir ce qui t'arrive."
,"10":"Ne consulte pas celui qui n'a pas confiance en toi, cache tes intentions à ceux qui sont jaloux de toi."
,"11":"Ne consulte jamais une femme sur sa rivale, un lâche à propos de la guerre, un négociant pour un taux d'échange, un acheteur si tu vends, un jaloux s'il s'agit de reconnaissance, un égoïste s'il s'agit de bienfaisance, un paresseux pour quelque chose à faire, un ouvrier à la journée pour la fin du travail, un domestique fainéant pour une grosse besogne."
,"12":"Mais cherche la compagnie d'un vrai croyant que tu sais respectueux des commandements, dont l'âme est proche de la tienne, et qui partagera ta souffrance si tu échoues."
,"13":"Puis tiens-toi fermement à la décision qui naîtra de toi, car personne ne mérite davantage ta confiance."
,"14":"Notre propre intuition voit parfois plus clair que les sept sentinelles qui veillent sur la hauteur."
,"15":"Mais par-dessus tout prie le Très-Haut pour qu'il te mette dans le vrai."
,"16":"Avant d'entreprendre, il faut penser; avant toute action il y a un projet."
,"17":"La décision peut s'orienter suivant quatre chemins:"
,"18":"le bien ou le mal, la vie ou la mort. C'est ta décision qui fait le choix."
,"19":"Tel homme est bon pour instruire les autres, qui pour lui-même ne vaut rien."
,"20":"Le beau parleur se fait détester: on le laissera mourir de faim."
,"21":"Il n'a pas reçu la grâce qui vient du Seigneur: il est dépourvu de sagesse."
,"22":"Mais d'autres ont en eux la sagesse; on peut leur faire confiance quand ils déversent les fruits de leur intelligence."
,"23":"L'homme sage instruit son propre peuple: on peut se fier aux fruits de son intelligence."
,"24":"L'homme sage est comblé de bénédictions, tous ceux qui le voient disent ses louanges."
,"25":"Chacun ne vit qu'un certain nombre de jours, mais les jours d'Israël passeront toute mesure."
,"26":"Le sage jouira de la confiance de son peuple, son nom vivra à jamais."
,"27":"Mon enfant, vois toi-même ce qui te réussit: vois ce qui est mauvais pour toi et sache t'en priver."
,"28":"Car tout ne convient pas à tous, et tout le monde ne s'accommode pas des mêmes choses."
,"29":"N'abuse pas de tout ce qui te plaît, ne te jette pas sur la nourriture,"
,"30":"car trop manger rend malade, et la goinfrerie provoque l'indigestion."
,"31":"Beaucoup de gens sont morts de leurs excès, alors qu'en se modérant ils auraient prolongé leur vie."
}`)
	CurrentBook.AddChapter(38, `{
"1":"Aie pour le médecin toute l'estime qu'il mérite, à la mesure de ses services, car lui aussi le Seigneur l'a voulu."
,"2":"La guérison, de fait, vient du Très-Haut, et c'est le Roi qui lui a octroyé le don de guérir."
,"3":"Le savoir du médecin le fait marcher la tête haute, même les grands l'admirent."
,"4":"Le Seigneur a créé les plantes médicinales qui sortent de la terre: un homme avisé ne les dédaigne pas."
,"5":"N'y a-t-il pas eu jadis un bois capable d'adoucir l'eau amère? Et c'est ainsi que le Seigneur fit connaître sa puissance."
,"6":"Il donne à des humains le savoir afin de tirer gloire des merveilleux remèdes qu'il a créés."
,"7":"Le médecin s'en sert pour soigner et calmer la douleur, le pharmacien en fait ses mélanges."
,"8":"De cette façon les oeuvres du Très-Haut ne sont pas terminées: le bien-être continue de se répandre sur la terre."
,"9":"Mon enfant, quand tu es malade, ne te laisse pas abattre: prie le Seigneur pour qu'il te guérisse."
,"10":"Renonce à ta conduite mauvaise, tâche d'avoir les mains nettes et purifie ton coeur de tout péché."
,"11":"Offre à Dieu de l'encens et de la fleur de farine pour te rappeler à son souvenir, présente-lui une offrande de choix selon tes moyens."
,"12":"Puis fais venir le médecin, puisque c'est le Seigneur qui l'a créé; ne le méprise pas, car tu as besoin de lui."
,"13":"En certains cas le rétablissement passe par leurs mains;"
,"14":"ils prieront le Seigneur pour qu'il leur fasse trouver les moyens de te soulager et de te sauver la vie."
,"15":"Celui qui pèche devant son Créateur, qu'il tombe entre les mains du médecin!"
,"16":"Mon enfant, verse des larmes pour un mort et entonne la lamentation qui exprimera ta douleur. Puis enterre son corps comme il y a droit, ne néglige rien pour sa sépulture."
,"17":"Gémis amèrement, frappe-toi la poitrine, porte le deuil comme il convient durant un jour ou deux pour marquer la séparation, puis console-toi de ta tristesse."
,"18":"Car la tristesse mène à la mort, la peine intérieure consume les energies."
,"19":"Que la tristesse se termine avec les funérailles: tu ne peux pas vivre toujours affligé."
,"20":"N'abandonne pas ton coeur à la tristesse, repousse-la et songe à ta propre fin!"
,"21":"Ne l'oublie pas: c'est sans retour. Tu te ferais du mal sans lui faire aucun bien."
,"22":"Souviens-toi de ma sentence qu'un jour tu pourras répéter: hier c'était moi, aujourd'hui ce sera toi!"
,"23":"Dès que le mort repose, laisse reposer son souvenir; console-toi de lui dès que son souffle l'a quitté."
,"24":"Il faut avoir des loisirs pour acquérir la connaissance de la Loi; celui qui n'a pas le souci des affaires pourra devenir sage."
,"25":"Comment deviendrait-il sage, celui qui tient la charrue? toute sa fierté est de manier l'aiguillon; il conduit ses boeufs et les excite au travail, il ne parle que de bétail."
,"26":"Toute son attention va au sillon qu'il trace, et jusque tard dans la nuit il donne le fourrage aux génisses."
,"27":"Il en va de même pour tout ouvrier ou artisan qui travaille jour et nuit, pour ceux qui gravent les cachets et qui s'efforcent d'en varier le dessin. Leur attention va toute au travail en cours, et ils passent leurs veilles à fignoler l'ouvrage."
,"28":"Il en va de même du forgeron assis près de l'enclume, tout occupé du fer qu'il travaille tandis qu'il fond littéralement sous l'ardeur du feu. Il lui faut se protéger contre cette fournaise tandis que le bruit du marteau lui casse les oreilles. Il met toute son attention à réaliser un travail parfait et passe ses veilles à embellir son oeuvre."
,"29":"Il en va de même pour le potier qui travaille assis devant le tour et fait aller la roue avec ses pieds; il est tout à sa besogne et cherche à produire davantage."
,"30":"Du bras il pétrit la glaise, il la malaxe avec ses pieds. Il mettra toute son attention à étendre le vernis et passera ses veilles à entretenir le four."
,"31":"Tous ces gens comptent sur leurs bras et chacun d'eux est habile dans son métier."
,"32":"Sans eux on ne bâtirait pas de ville, on n'y habiterait pas, on ne circulerait pas."
,"33":"Mais on n'ira pas les chercher pour le conseil du peuple et on ne les remarquera pas dans l'assemblée. Ils ne siégeront pas au tribunal car ils ne sont pas familiers avec la Loi."
,"34":"Ils ne montreront guère d'instruction, ils n'ont pas la pratique du droit, et on ne les trouve pas parmi ceux qui interprètent les maximes. Bien sûr, ils mettent en valeur tout ce que Dieu a créé au commencement, mais leur prière ne va pas au-delà des affaires de leur métier."
}`)
	CurrentBook.AddChapter(39, `{
"1":"Il en va tout autrement de celui qui s'applique à méditer la Loi du Très-Haut. Il scrute la sagesse de tous les anciens et leurs prophéties absorbent ses loisirs."
,"2":"Il garde en mémoire les propos des hommes célèbres et pénètre les richesses des maximes;"
,"3":"il recherche le sens caché des proverbes et s'intéresse aux énigmes des paraboles."
,"4":"Il passe au service des grands et on le voit au milieu des chefs. Il voyage dans les pays étrangers et il a l'expérience de ce qui est bon ou mauvais pour les hommes."
,"5":"Dès le matin il s'applique à trouver le Seigneur qui l'a créé, il supplie en la présence du Très-Haut; il ouvre la bouche pour prier et il implore pour ses péchés."
,"6":"Si le Seigneur Sublime en a décidé ainsi, il le remplira de l'esprit d'intelligence. Alors il fera pleuvoir des paroles de sagesse, et dans sa prière il en rendra grâces au Seigneur."
,"7":"Il entrera dans les plans de Dieu et dans la connaissance: il méditera sur les secrets du Seigneur."
,"8":"Il communiquera les enseignements de sa doctrine et mettra sa fierté dans la Loi et l'Alliance du Seigneur."
,"9":"Beaucoup de gens vanteront son intelligence, elle ne tombera jamais dans l'oubli; son souvenir ne disparaîtra pas, mais son nom restera vivant de génération en génération."
,"10":"A l' étranger on reconnaîtra sa sagesse, et l'assemblée du peuple fera son éloge."
,"11":"Tant qu'il sera là, son nom passera avant mille autres, et quand il reposera, son nom lui suffira."
,"12":"Je veux encore vous faire part de mes réflexions, car j'en suis rempli comme la lune en son plein."
,"13":"Ecoutez-moi, mes enfants saints, et vous grandirez comme le laurier-rose au bord d'un cours d'eau."
,"14":"Comme l'encens répandez une odeur agréable, faites éclore vos fleurs comme le lis, donnez votre parfum et chantez un cantique. Bénissez Yahvé pour toutes ses oeuvres!"
,"15":"Exaltez son nom et dites ses louanges; chantez, jouez de la harpe, acclamez-le en disant:"
,"16":"Qu'elles sont belles, les oeuvres du Seigneur! Et tout ce qu'il décide arrive en temps voulu. Il ne faut donc pas dire: Qu'est ceci? Pourquoi cela? car tout sera utile en son temps."
,"17":"A sa parole les eaux s'arrêtèrent et s'élevèrent en un seul lieu; un mot de sa bouche ouvrit les réserves d'eau."
,"18":"Il suffit qu'il parle, et tout ce qu'il désire s'accomplit, personne ne peut détenir son oeuvre de salut."
,"19":"Devant lui sont présentes les oeuvres de chacun, et rien n'échappe à ses yeux."
,"20":"Son regard va du début jusqu'à la fin des temps, et rien ne peut le surprendre."
,"21":"Il ne faut donc pas dire: Qu'est ceci? Pourquoi cela? car tout a été fait pour servir."
,"22":"La bénédiction du Seigneur est comme un fleuve qui déborde; comme un déluge elle a inondé la terre."
,"23":"Mais les païens auront droit à sa colère, comme lorsqu'il fit d'une terre arrosée une étendue de sel."
,"24":"Ses voies sont droites pour ses fidèles, mais tout y fait trébucher les sans-Loi."
,"25":"Dès le début les bonnes choses ont été créées pour ceux qui sont bons, comme les maux pour les pécheurs."
,"26":"Voici les choses les plus nécessaires à la vie humaine: l'eau, le feu, le fer et le sel, et aussi la farine de froment, le lait et le miel, le jus des raisins, l'huile et le vêtement."
,"27":"Toutes ces choses sont bénéfiques pour les bons, mais deviennent nuisibles pour les pécheurs."
,"28":"Certains vents ont été faits pour punir; le Seigneur dans sa colère en fait ses fléaux. Arrivé le moment de détruire, ils déchaînent leur violence et satisfont la fureur de celui qui les a faits."
,"29":"Feu, grêle, famine et mort: tout cela a été créé pour servir de châtiment."
,"30":"Les dents des bêtes sauvages, les scorpions, les vipères, et l'épée vengeresse qui punit les impies."
,"31":"Toutes ces choses se réjouissent de mettre à exécution ses ordres. Elles sont prêtes pour quand ce sera nécessasire, et le moment venu elles ne désobéiront pas à ses ordres."
,"32":"Tout cela, j'en avais la conviction dès le début. Je l'ai médité et c'est pourquoi j'ai écrit:"
,"33":"Toutes les oeuvres du Seigneur sont bonnes, il pourvoit à tout quand c'est le moment."
,"34":"Il ne faut donc pas dire: Ceci est mauvais, cela est bon! car toute chose prendra sa valeur en son temps."
,"35":"Et maintenant chantez à pleine voix et de tout votre coeur: bénissez le Nom du Seigneur!"
}`)
	CurrentBook.AddChapter(40, `{
"1":"La condition faite aux humains est fort affligeante, un lourd fardeau accable les fils d'Adam depuis le jour où ils sortent du sein maternel, jusqu'à celui où ils retournent à la mère universelle."
,"2":"Dès qu'ils pensent à l'avenir, ce qui occupe leurs esprits, ce qu'ils redoutent, c'est le jour de leur mort."
,"3":"Depuis celui qui siège en roi sur un trône, jusqu'à celui qui est au plus bas sur la terre et la cendre,"
,"4":"depuis celui qui porte la couronne et la pourpre, jusqu'à celui qui se vêt de toile grossière, ce n'est que passion, jalousie, trouble, agitation, crainte de la mort, rancune et discorde!"
,"5":"Et lorsque nous nous sommes couchés pour la nuit, le sommeil fait surgir de nouvelles angoisses."
,"6":"A peine est-on au repos et endormi, que des rêves viennent nous troubler comme si on était en plein jour: on se voit échappant à un massacre."
,"7":"On se voit réduit à toute extrémité, et c'est alors qu'on s'éveille: et l'on s'étonne de voir qu'on a eu peur pour rien."
,"8":"Ceci vaut pour tous, pour les humains comme pour les bêtes, mais c'est sept fois pire pour les pécheurs:"
,"9":"mort, sang, discorde, épée, malheurs, famine, destruction et calamités."
,"10":"Car tout cela a été créé contre les sans-Loi: c'est bien à cause d'eux que le déluge est venu."
,"11":"Tout ce qui vient de la terre retourne à la terre, et ce qui vient des eaux retourne à la mer."
,"12":"L'argent de la corruption disparaîtra tout comme l'injustice, mais la fidélité durera éternellement."
,"13":"La richesse des injustes s'épuisera comme le torrent en été, comme le coup de tonnerre durant l'averse."
,"14":"Celui qui a été généreux aura de quoi s'en réjouir, mais les pécheurs iront à la ruine."
,"15":"Les rejetons des méchants n'auront guère de rameaux, leurs racines ne trouveront que la pierre lisse."
,"16":"Ils seront comme le roseau qui pousse dans les flaques du rivage: on l'arrache avant les autres herbes."
,"17":"La bienfaisance, par contre, est un jardin de bénédictions, et la miséricorde demeure à jamais."
,"18":"Se suffire à soi-même ou être un artisan procure une vie douce; trouver un trésor surpasse l'un et l'autre."
,"19":"Les enfants et la fondation d'une ville feront durer ton nom: la femme irréprochable surpasse l'un et l'autre."
,"20":"Le vin et la musique réjouissent le coeur: l'amour de la sagesse surpasse l'un et l'autre."
,"21":"La flûte et la harpe font une douce mélodie: une voix persuasive surpasse l'une et l'autre."
,"22":"L'oeil recherche la grâce et la beauté: la verdure des champs surpasse l'une et l'autre."
,"23":"Un ami, un compagnon sont bienvenus, mais plus que l'un et l'autre la femme ou le mari."
,"24":"Des frères, des protecteurs sont précieux au temps de l'épreuve! Plus que les uns et les autres, le geste charitable te vaudra le salut."
,"25":"L'or et l'argent assurent tes pas, mais plus que l'un et l'autre un bon conseil est efficace."
,"26":"La richesse, la force te donnent du coeur, mais plus que l'une et l'autre la crainte du Seigneur. Avec la crainte du Seigneur, rien ne manque, il n'y a plus d'aide à chercher ailleurs."
,"27":"La crainte du Seigneur est un jardin de bénédictions, elle protège mieux que tous les honneurs."
,"28":"Mon enfant, garde-toi de vivre en mendiant; plutôt mourir que de quémander!"
,"28":"Loucher sans cesse vers la table d'un autre, c'est exister sans vivre. La nourriture d'un autre ne peut que te souiller: un homme éduqué et instruit la refuse."
,"30":"La nourriture mendiée est douce à la bouche d'un mal élevé, mais elle lui brûlera les entrailles."
}`)
	CurrentBook.AddChapter(41, `{
"1":"O mort, que ton rappel est amer pour celui qui vit sans problèmes au milieu de ses biens, pour celui qui va de l'avant et qui réussit, qui a encore la santé pour manger!"
,"2":"O mort, que ta sentence est bonne pour celui qui est dans le besoin, que ses forces abandonnent, pour le vieillard usé qui perd la mémoire, qui se révolte et perd la patience!"
,"3":"Ne redoute pas la sentence de la mort, souviens-toi de ceux qui t'ont précédé et qui te suivront."
,"4":"Le Seigneur l'a décrétée pour tout être vivant: refuseras-tu ce qui a paru bon au Très-Haut ? Que tu vives dix, cent, ou mille ans, personne n'y prendra garde au Séjour d'en bas."
,"5":"Les enfants des pécheurs feront une race détestable, bonne à remplir les maisons des méchants."
,"6":"Les enfants des pécheurs perdront leur héritage, une malédiction reste attachée à leur race."
,"7":"Un père impie subira les reproches de ses enfants; c'est à cause de lui qu'ils seront déshonorés."
,"8":"Malheur à vous, hommes méchants qui avez abandonné la loi du Dieu Très-Haut."
,"9":"Vous n'êtes nés que pour vous faire maudire, et à votre mort vous n'emporterez qu'une malédiction."
,"10":"Tout ce qui vient de la terre retourne à la terre, et c'est ainsi que les impies passeront de la malédiction à la ruine."
,"11":"Nous devons faire le deuil de notre corps, mais pour les pécheurs c'est leur nom même qui disparaîtra, n'évoquant rien de bon."
,"12":"Veille à l'honneur de ton nom, car il restera, plus durable que mille dépôts d'or."
,"13":"Une vie, même bonne, ne dure qu'un temps, tandis que la bonne renommée est là pour toujours."
,"14":"Mes enfants, gardez mon enseignement et faites-le prospérer: si la sagesse reste cachée et le trésor enfoui, à quoi servent-ils?"
,"15":"Mieux vaut cacher sa folie que cacher sa sagesse."
,"16":"Je vais vous dire ce qui est vraiment honteux, car il ne faut pas avoir honte de n'importe quoi, même quand d'autres se font des idées fausses."
,"17":"Soyez honteux: de votre inconduite devant vos père et mère; du mensonge devant un prince ou un puissant;"
,"18":"d'un crime devant un juge ou un magistrat; de vos manquements devant l'assemblée du peuple;"
,"19":"d'une injustice devant ton compagnon et ton ami; d'un vol là où tu habites."
,"20":"Tu dois avoir honte, pensant à la vérité de Dieu et à l'Alliance: de garder les pains pour toi-même,"
,"21":"de ne pas savoir donner et recevoir, de ne pas répondre au salut d'autrui,"
,"22":"de dévisager une prostituée, de ne pas regarder ta femme légitime,"
,"23":"de t'approprier ce qui a été donné à d'autres, de regarder avec insistance une femme mariée,"
,"24":"d'être trop familier avec ta servante: ne t'approche pas de son lit!"
,"25":"d'avoir insulté un ami, de reprocher après avoir donné,"
,"26":"de répéter ce que tu as entendu, de révéler un secret."
,"27":"Si tu as honte de toutes ces choses, tous t'en sauront gré."
}`)
	CurrentBook.AddChapter(42, `{
"1":"Mais ce sera le contraire pour tout ce qui suit, si tu ne veux pas pécher. N'aie pas honte:"
,"2":"de la Loi du Très-Haut et de son Alliance, de reconnaître l'innocence, même d'un méchant,"
,"3":"de tenir des comptes précis avec tes compagnons de voyage, d'accorder à des étrangers leur part d'héritage,"
,"4":"de te servir d'une balance et de poids exacts, de réaliser des bénéfices grands ou petits,"
,"5":"de faire du profit dans une affaire commerciale, de corriger souvent tes enfants et de meurtrir les côtes d'un serviteur méchant."
,"6":"Avec une mauvaise femme un cadenas est utile; là où il y a beaucoup de mains, mets les choses sous clef!"
,"7":"Compte et pèse ce que tu fournis; note par écrit ce que tu donnes et ce que tu reçois."
,"8":"N'aie pas honte de reprendre un imbécile, un sot, et le vieillard décrépit qui retombe en enfance. Alors tu seras véritablement instruit et tous t'en sauront gré."
,"9":"Une fille est pour son père une cause inavouée d'insomnie: le souci qu'elle lui donne l'empêche de dormir. Elle est jeune, mais peut-être tardera-t-elle à se marier; elle est mariée, mais peut-être son mari va-t-il la prendre en grippe. "
,"10":"Elle est vierge: peut-être se laissera-t-elle séduire et se retrouvera-t-elle enceinte dans la maison de son père. Elle a un mari: peut-être lui sera-t-elle infidèle, ou bien elle ne lui donnera pas d'enfants."
,"11":"Si ta fille est effrontée, redouble de prudence: vois-tu qu'elle fasse de toi la risée de tes ennemis, la fable de la ville, une occasion de commérages! Elle pourrait te déshonorer devant tout le monde."
,"12":"N'arrête pas tes regards sur une beauté humaine et ne te mets pas à converser avec des femmes."
,"13":"Tout comme la mite sort d'un vêtement, ainsi de la femme sort malice de femme."
,"14":"Mieux vaut la dureté de l'homme que la bonté de la femme: la femme peut t'attirer honte et reproches."
,"15":"Je vais maintenant rappeler les oeuvres du Seigneur, je veux raconter ce que j'ai vu: les oeuvres du Seigneur sont sorties de ses paroles, conformes à ses décisions."
,"16":"Tout comme le soleil illumine ce qu'il a sous les yeux, de même l'oeuvre du Seigneur est remplie de sa gloire."
,"17":"Expliquer ce monde de merveilles est une chose qui dépasse, même les Saints du Seigneur. Car le Seigneur, Maître de l'univers, lui a donné consistance dans sa propre Gloire."
,"18":"Il sonde à la fois les abîmes des mers et l'esprit des humains: lui voit clair dans leurs projets. Car le Très-Haut connaît tout ce qu'on peut savoir: il connaît les signes des temps."
,"19":"Il dit ce qui a été et ce qui sera, il découvre les traces des choses passées."
,"20":"Pas une pensée ne lui échappe, pas une parole ne lui reste cachée."
,"21":"Il a disposé harmonieusement les chefs-d'oeuvre de sa sagesse, tels qu'ils ont toujours été et qu'ils seront toujours; il n'a eu recours à aucun conseiller, rien ne pourrait y être ajouté ou en être retranché."
,"22":"Comme toutes ses oeuvres sont belles: quel plaisir de contempler la moindre étincelle!"
,"23":"Tout cela vit et dure pour toujours, tout obéit en toute circonstance."
,"24":"Toutes les choses vont par paires, l'une à l'autre se faisant face; le Seigneur n'a rien fait d'imparfait."
,"25":"Elles se mettent l'une l'autre en relief: qui se fatiguera de contempler sa gloire?"
}`)
	CurrentBook.AddChapter(43, `{
"1":"L'orgueil du monde d'en haut est le firmament cristallin: le spectacle du ciel est une vision de gloire."
,"2":"Dès que paraît le soleil, il va proclamant: 'Objet admirable je suis, une oeuvre du Très-Haut!'"
,"3":"A midi il dessèche la campagne; qui peut supporter son feu?"
,"4":"On a beau souffler sur la flamme au travail de la forge, l'ardeur du soleil est plus du triple quand il brûle les montagnes, projetant des vapeurs torrides, des rayons qui éblouissent nos yeux!"
,"5":"Oui, grand est le Seigneur qui l'a fait et dont les paroles stimulent sa course!"
,"6":"Et puis voici la lune, toujours fidèle à son rendez-vous, elle indique les mois et le passage du temps."
,"7":"Le signal de la fête, il nous vient de la lune, lorsqu'après son plein elle revient à son déclin."
,"8":"C'est de son renouveau que le mois tient son nom: quelle merveille quand elle se reprend à croître! Elle est l'étendard des armées célestes, tandis qu'elle illumine l'étendue du firmament."
,"9":"L'éclat des étoiles fait la beauté du ciel, c'est la parure resplendissante des hauteurs du Seigneur."
,"10":"Dociles à la parole du Saint, elles se tiennent au poste qu'il leur a assigné, et montent leurs gardes sans jamais se relâcher."
,"11":"Vois l'arc-en-ciel et bénis celui qui l'a fait; comme il est beau avec toutes ses couleurs!"
,"12":"Il trace dans le ciel un cercle de gloire, un arc qui fut tendu par les mains du Très-Haut."
,"13":"Selon qu'il veut il dépêche la neige et presse les éclairs pour qu'ils exécutent ses sentences."
,"14":"S'il ouvre encore les réserves du ciel, les nuages prennent leur vol comme des oiseaux."
,"15":"Par sa puissance il congèle les nuages pour qu'ils projettent, comme des pierres, la grêle."
,"16":"Les montagnes tremblent s'il les regarde, à la voix de son tonnerre la terre est ébranlée."
,"17":"Le vent du sud souffle s'il le veut, de même les cyclones et l'ouragan du nord."
,"18":"Les flocons de la neige descendent comme des oiseaux; elle se pose comme la sauterelle. Cette blancheur immaculée ravit les yeux, la pensée reste interdite en la voyant tomber."
,"19":"Il déverse le givre comme du sel sur la terre; le gel le transforme en épines pointues."
,"20":"Quand souffle le vent froid du nord, la glace se forme sur l'eau; elle couvre les étendues liquides et les revêt d'une cuirasse."
,"21":"L'autre vent consume les montagnes et brûle le désert; semblable au feu, il dévore toute la verdure."
,"22":"Mais une nuée accourt et guérit tous ces maux: passée la canicule, la rosée ramène la joie."
,"23":"Selon son projet il a dompté l'océan, il y a planté des îles."
,"24":"Ceux qui naviguent sur la mer nous en racontent les dangers; on entend des récits stupéfiants!"
,"25":"Il y a là des êtres étranges et merveilleux, des animaux de toutes sortes, et des monstres marins!"
,"26":"Mais grâce à Dieu, celui qu'il envoie trouve son chemin, et tout s'arrange selon sa parole."
,"27":"Nous pourrions continuer, nous n'en finirions pas: en un mot, Il est le Tout!"
,"28":"Où trouver la force de le glorifier? Il est grand, lui, bien au-dessus de tout ce qu'il a fait!"
,"29":"Il est un redoutable et très-haut Seigneur, prodigieuse est sa puissance."
,"30":"Rendez-lui la louange, exaltez le Seigneur autant que vous pourrez: il est bien au-delà! Exaltez-le de toutes vos forces; ne vous lassez pas, ce ne sera jamais assez."
,"31":"Qui l'a vu et peut nous dire ce qu'il a vu? Qui le glorifiera comme il le mérite?"
,"32":"Tant de merveilles cachées sont bien plus grandes encore! Nous n'avons vu qu'une petite partie de ses oeuvres."
,"33":"Oui, le Seigneur a fait toutes choses, et à ses fidèles il accorde la sagesse."
}`)
	CurrentBook.AddChapter(44, `{
"1":"Faisons maintenant l'éloge des hommes illustres, de nos ancêtres l'un après l'autre."
,"2":"Le Seigneur leur a donné une belle gloire, une partie de sa gloire éternelle."
,"3":"Les uns furent souverains dans leur royaume, des hommes renommés pour leur énergie; d'autres ont poussé aux sages décisions, ont parlé en prophètes."
,"4":"D'autres ont guidé le peuple par leurs avis, l'ont enseigné par leurs propos pleins de sagesse."
,"5":"D'autres ont cultivé la musique, la poésie et l'art d'écrire."
,"6":"D'autres encore étaient des hommes riches, des gens puissants qui connurent la paix dans leurs domaines."
,"7":"Tous ont connu la gloire en leur temps: ils étaient un sujet de fierté pour leurs contemporains."
,"8":"Certains d'entre eux ont laissé un nom, on redit encore leurs louanges."
,"9":"D'autres sont tombés dans l'oubli, ont disparu; ce serait pareil s'ils n'avaient pas existé, et de même pour leurs descendants."
,"10":"Mais parlons des hommes de bien dont l'action bénéfique n'a pas été oubliée."
,"11":"Leurs descendants ont hérité de ce bel héritage."
,"12":"Leur race tient fidèlement à l'Alliance, leurs enfants suivent leur exemple."
,"13":"Leur race durera à jamais, leur gloire ne sera pas effacée."
,"14":"Leurs corps ont été ensevelis dans la paix mais leur nom est vivant pour toutes les générations."
,"15":"Les peuples se racontent leur sagesse et l'assemblée proclame leur louange."
,"16":"Hénok plaisait au Seigneur et fut enlevé: bel exemple de conversion pour les hommes de tous les temps."
,"17":"Noé fut trouvé juste, parfait: il fut l'instrument de la réconciliation au temps de la Colère; grâce à lui un reste fut épargné sur la terre lorsque vint le déluge."
,"18":"Le Seigneur s'engagea avec lui pour toujours: il ne détruirait plus par les eaux l'ensemble des vivants."
,"19":"Abraham est le père illustre d'une multitude de nations; personne n'a jamais égalé sa gloire."
,"20":"Il a observé la Loi du Très-Haut qui l'a fait entrer dans son alliance; cette alliance fut inscrite dans sa chair; il resta fidèle au jour de l'épreuve."
,"21":"C'est pourquoi Dieu lui fit un serment: toutes les nations seraient bénies dans sa descendance, il le multiplierait comme la poussière du sol, il élèverait jusqu'aux étoiles sa descendance, sa postérité aurait pour domaine d'une mer à l'autre, depuis l'Euphrate jusqu'où finissent les terres au couchant."
,"22":"A Isaac il renouvela cette promesse, à cause d'Abraham son père."
,"23":"Puis il fit reposer sur la tête de Jacob la bénédiction pour tous les hommes, ainsi que l'alliance; il le bénit personnellement et lui donna le pays en héritage. Il en divisa les parts et les distribua entre les douze tribus."
}`)
	CurrentBook.AddChapter(45, `{
"1":"Puis Dieu fit paraître Moïse, un descendant de Jacob, un homme de bien, aimé de Dieu et des hommes, dont la mémoire sera bénie à jamais."
,"2":"Il le rendit glorieux tout autant que les anges, il le rendit puissant, terrible pour ses ennemis;"
,"3":"mais à sa parole les prodiges cessaient. Le Seigneur le glorifia en présence des rois, il lui donna des commandements pour son peuple et lui fit entrevoir un reflet de sa gloire."
,"4":"Il fit entrer dans son mystère cet homme fidèle et doux qu'il avait choisi entre tous."
,"5":"Il lui fit entendre sa voix et l'introduisit dans la nuée obscure. Il lui parla face à face et lui donna les commandements, cette loi révélée, loi de vie, pour qu'il enseigne à Jacob l'Alliance, à Israël ses décrets."
,"6":"Dieu éleva et consacra tout comme lui son frère Aaron, de la tribu de Lévi."
,"7":"Il conclut avec lui une alliance perpétuelle, faisant de lui le prêtre de son peuple. Il le gratifia d'ornements splendides et le revêtit d'une robe d'apparat."
,"8":"Il le couvrit de parures honorifiques et lui remit les insignes de sa puissance: pagne, tunique longue, éphod."
,"9":"Au bord de son manteau étaient fixées des grenades et d'innombrables clochettes d'or qui tintaient à chacun de ses pas; on les entendait résonner dans le temple et le peuple y restait attentif."
,"10":"Il le drapa d'un vêtement sacré, brodé d'or, de pourpre et d'écarlate; par-dessus se trouvait le pectoral du jugement, avec les dés de l'ourim et du toumim, lui aussi brodé de fils écarlates."
,"11":"Des pierres précieuses étincelaient, gravées comme des cachets, fixées par le joaillier sur une monture d'or. On y lisait les noms des tribus d'Israël: c'était pour les rappeler au souvenir du Seigneur."
,"12":"Il lui mit une couronne d'or au-dessus du turban, avec en relief cette inscription: Consacré au Seigneur! C'était un ornement précieux, un ouvrage splendide qui attirait tous les regards."
,"13":"Avant lui on n'avait rien vu d'aussi beau; aucun profane n'a revêtu de tels ornements; ils sont réservés à ses fils et à ses descendants dans la suite des temps."
,"14":"Deux fois par jour, continuellement, le feu consume ses offrandes."
,"15":"Moïse lui-même l'a consacré: Aaron reçut de lui l'onction d'huile sainte; c'est ainsi qu'il a reçu ce privilège pour toujours, pour lui et pour ses descendants, tant que dureront les cieux: ils feront le service liturgique et seront prêtres, et ils donneront au peuple de Dieu la bénédiction en son Nom."
,"16":"Il a été choisi parmi tous les vivants pour présenter l'offrande au Seigneur, avec l'encens d'agréable odeur, afin que le Seigneur se souvienne de son peuple et lui pardonne ses péchés."
,"17":"Le Seigneur lui a donné d'interpréter ses commandements et de se prononcer quand il s'agit d'enseigner à Jacob ses volontés, d'éclairer Israël à propos de sa loi."
,"18":"Des étrangers ont conspiré contre Aaron, ils ont été jaloux de lui au désert; c'étaient les hommes de Datan et d'Abiram, c'était avec Coré le parti des violents et des furieux."
,"19":"Le Seigneur les vit et cela lui déplut; ils furent exterminés par l'ardeur de sa colère. Il les frappa de façon extraordinaire: des flammes de feu les dévorèrent."
,"20":"Dieu a fait plus encore pour la gloire d'Aaron: il lui a donné en guise d'héritage les premiers fruits des récoltes, lui assurant ainsi du pain à satiété."
,"21":"Il lui a donné, à lui et à sa race, les offrandes faites au Seigneur: c'est là leur pain."
,"22":"Par contre ils n'ont pas d'héritage sur la terre de leur peuple, ils n'y ont pas leur part avec le peuple, car le Seigneur a dit: 'Je serai moi-même ta part et ton héritage.'"
,"23":"Quant à Pinéas, fils d'Eléazar, il est le troisième en gloire, car il a craint le Seigneur et s'est montré jaloux pour lui. Il resta ferme quand le peuple se révolta: ses dispositions ne faiblirent pas. Et c'est lui qui obtint le pardon pour Israël."
,"24":"C'est pourquoi le Seigneur conclut avec lui une alliance de paix: il l'établit comme chef du sanctuaire et du peuple; il lui remit ainsi qu'à sa descendance la dignité de chef des prêtres, et cela, pour les siècles."
,"25":"Lorsque Dieu s'est engagé avec David, fils de Jessé, de la tribu de Juda, un seul de ses fils héritait de sa royauté; pour Aaron, par contre, son sacerdoce passe à tous ses descendants."
,"26":"(O race d'Aaron,) que le Seigneur mette la sagesse en vos coeurs pour gouverner son peuple avec droiture, afin que d'âge en âge, ni leur prospérité, ni leur gloire ne se perde!"
}`)
	CurrentBook.AddChapter(46, `{
"1":"Qu'il était vaillant à la guerre, ce Josué, fils de Noun qui remplaça Moïse comme prophète! Comme son nom le dit, il fut grand quand il s'agissait de libérer les élus de Dieu. Il tira vengeance des ennemis qui l'attaquaient et installa Israël dans son territoire."
,"2":"Comme il était glorieux lorsque, levant son bras, il frappait les villes de son épée!"
,"3":"Qui donc avant lui avait fait face comme il fit? Il savait mener les combats du Seigneur."
,"4":"N'est-ce pas sur son ordre que le soleil s'arrêta et qu'un seul jour dura autant que deux?"
,"5":"Il invoqua le Très-Haut, le Puissant, alors que ses ennemis l'attaquaient de tous côtés, et le Maître suprême l'exauça en faisant pleuvoir des grêlons fantastiques."
,"6":"Josué fondit alors sur la nation ennemie, il rattrapa ses adversaires et les massacra dans la descente. C'est ainsi que les païens firent l'expérience de ses armes et comprirent qu'il combattait pour le Seigneur."
,"7":"Josué a toujours suivi le Puissant. Aux jours de Moïse déjà, avec Caleb fils de Yéphouné, ils avaient bien agi: ils s'étaient opposés à la multitude, cherchant à détourner le peuple du péché et à faire taire les murmures mauvais."
,"8":"C'est pourquoi tous deux survécurent, seuls parmi six cent mille hommes de guerre: le Seigneur les introduisit dans son héritage, dans la terre où coulent le lait et le miel."
,"9":"A Caleb le Seigneur accorda la force: elle lui resta jusque dans sa vieillesse. Il s'établit sur les hauteurs du pays et ses descendants conservèrent cet héritage après lui."
,"10":"Tous les enfants d'Israël surent ainsi qu'il est bon de marcher à la suite du Seigneur."
,"11":"Puis vinrent les Juges, chacun avec sa propre renommée; leur coeur ne s'est pas vendu aux faux dieux, ils ne se sont pas détournés du Seigneur. Qu'ils soient bénis à jamais!"
,"12":"Que leurs ossements refleurissent de leur tombe, que les fils de ces hommes illustres soient dignes du nom de leurs pères!"
,"13":"Samuel fut aimé de son Seigneur; comme prophète du Seigneur il établit la royauté et donna l'onction sainte aux chefs de son peuple."
,"14":"Il gouverna l'Assemblée selon la loi du Seigneur, et le Seigneur s'inquiéta pour Jacob."
,"15":"On reconnut qu'il était prophète, et qu'il ne trompait pas; quand ses paroles se réalisèrent on sut que ses visions étaient vraies."
,"16":"Quand l'ennemi le pressait de toute part, il invoqua le Seigneur Puissant et sacrifia un agneau de lait."
,"17":"Alors le Seigneur tonna du haut du ciel et fit entendre sa voix avec grand fracas."
,"18":"Samuel extermina les chefs ennemis et tous les princes des Philistins."
,"19":"Quand vint le temps de son sommeil éternel, il témoigna devant le Seigneur et son Oint: 'Je n'ai rien pris à personne, ni argent, ni même une paire de sandales!' et personne ne l'accusa."
,"20":"Même après sa mort il prophétisa: du sein de la terre il éleva la voix pour annoncer au roi sa fin prochaine et dire que le Seigneur ferait payer au peuple sa faute."
}`)
	CurrentBook.AddChapter(47, `{
"1":"Puis apparut Nathan, qui prophétisait aux jours de David."
,"2":"Comme dans un sacrifice les parties grasses sont réservées au Seigneur, ainsi David fut-il mis à part parmi les fils d'Israël."
,"3":"David se jouait des lions et des ours comme si c'étaient des chevreaux ou des jeunes agneaux."
,"4":"Dans sa jeunesse n'a-t-il pas tué le géant? Avec une pierre de sa fronde il abattit l'arrogant Goliath, et lava ainsi l'affront fait à son peuple."
,"5":"Il avait fait appel au Seigneur, le Très-Haut, et celui-ci donna la force à son bras pour supprimer cet homme redoutable au combat: il rendit la victoire à son peuple."
,"6":"On lui fit gloire d'en avoir tué dix mille, on chantait ses louanges en bénissant le Seigneur et on lui offrit la couronne."
,"7":"Car il écrasa l'adversaire sur tous les fronts, il anéantit les Philistins qui lui faisaient face, et leur puissance fut brisée jusqu'à nos jours."
,"8":"Après tant de hauts faits David rendit hommage au Saint, au Très-Haut, avec des cantiques de louange; de tout son coeur il lui chanta des hymnes, il aima celui qui l'avait fait."
,"9":"David plaça devant l'autel des chanteurs avec des harpes pour qu'on y entende leurs voix mélodieuses."
,"10":"Il donna de la splendeur aux fêtes et rehaussa l'éclat des solennités en faisant louer le saint Nom du Seigneur: dès l'aurore on entendait le chant sacré."
,"11":"Le Seigneur lui pardonna ses péchés et voulut que son pouvoir dure pour des siècles; il s'engagea avec lui pour les rois à venir et promit de rendre sa dynastie glorieuse en Israël."
,"12":"David eut pour successeur un fils plein de savoir; grâce à son père il vécut au large."
,"13":"Salomon régna en un temps de paix et Dieu lui épargna tout souci sur ses frontières, car il devait élever un Temple en l'honneur de son Nom et lui préparer un sanctuaire pour les siècles."
,"14":"O Salomon, comme tu étais sage dans ta jeunesse, et comme un fleuve, tu débordais d'intelligence!"
,"15":"Ton génie a recouvert la terre; tu l'as remplie de tes proverbes et de tes énigmes."
,"16":"Ton renom est parvenu jusqu'aux îles lointaines: tu as été aimé car tu étais pacifique."
,"17":"Les nations t'admiraient pour tes chants, proverbes et paraboles: tu avais l'art de tout élucider."
,"18":"Au nom du Seigneur Dieu qui se nomme Dieu d'Israël, tu as amassé l'or comme on ferait avec l'étain, tu as accumulé l'argent comme du plomb."
,"19":"Mais il te fallait des femmes tout contre toi sur ta couche, elles étaient maîtresses de ton corps."
,"20":"C'est ainsi que tu as souillé ta gloire et déshonoré ta descendance; tu as attiré sur tes enfants la Colère, et ta folie les a plongés dans le malheur."
,"21":"On assista à la division du pouvoir: une royauté rebelle surgit en Ephraïm! ()"
,"23":"Puis Salomon alla reposer avec ses pères, mais il laissait comme successeur le plus fou du peuple un homme dénué d'intelligence: ce Roboam, par ses décisions, fut cause de la révolte du peuple."
,"24":"C'est alors que Jéroboam, fils de Nabat, fit pécher Israël, enseignant à Ephraïm les chemins du mal. Et leurs péchés allèrent en augmentant jusqu'à les faire déporter de leur pays."
,"25":"Ils se livrèrent à tout ce qui est mal jusqu'à ce que le châtiment tombe sur eux."
}`)
	CurrentBook.AddChapter(48, `{
"1":"Ensuite surgit, comme un feu, le prophète Elie, dont les paroles brûlaient comme une torche."
,"2":"Il fit venir sur eux la famine, son amour jaloux les réduisit à presque rien."
,"3":"Une parole du Seigneur, et le ciel retenait la pluie! Trois fois il fit de même tomber la foudre."
,"4":"O Elie, tes miracles ont fait ta gloire! Qui pourrait se vanter d'être ton égal?"
,"5":"D'une parole du Très-Haut, tu as fait se lever un mort, l'arrachant au monde des morts, au Séjour d'en bas."
,"6":"Par toi, des rois sont allés à leur perte, des hommes importants ne se sont pas relevés de leur lit."
,"7":"Tu as entendu, au mont Sinaï, une sentence, tu as connu à l'Horeb le châtiment décrété par Dieu."
,"8":"Tu as consacré des rois pour qu'ils fassent justice, et des prophètes pour prendre ta suite."
,"9":"Puis tu as été emporté dans un tourbillon de flammes, dans un char aux chevaux de feu."
,"10":"Il est écrit que tu reviendras un jour pour apaiser la Colère prête d'éclater, pour ramener le coeur du père vers son fils et pour rétablir les tribus de Jacob."
,"11":"O Elie, heureux ceux qui t'ont vu, puis se sont endormis dans l'amour! Car nous aussi, sûrement nous vivrons!"
,"12":"Lorsqu'Elie fut accueilli dans le tourbillon, Elisée resta rempli de son esprit. Aucun prince ne put l'intimider aussi longtemps qu'il vécut, et il ne se laissa dominer par personne. ()"
,"15":"Malgré tout cela le peuple ne se convertit pas; ils ne renoncèrent pas à leurs péchés, de sorte qu'ils furent emmenés loin de leur pays et dispersés sur toute la terre."
,"16":"Il ne resta qu'un peuple bien petit, avec un souverain de la maison de David. Parmi ces rois, les uns firent ce qui plaît au Seigneur, mais les autres multiplièrent leurs fautes."
,"17":"Le roi Ezéquias fortifia sa ville, il amena l'eau à l'intérieur de ses murailles; il creusa un tunnel dans le roc et construisit des réservoirs pour les eaux."
,"18":"Durant son règne, Sennakérib vint l'attaquer; il envoya Rabsakis, qui se présenta en son nom et mena l'assaut contre Sion. Il vint se vanter avec arrogance."
,"19":"Alors tous perdirent coeur, leurs mains en tremblaient; ils étaient dans l'angoisse comme la femme qui accouche."
,"20":"Ils invoquèrent le Seigneur, le Miséricordieux, et tendirent les mains vers lui; et le Saint, du haut du ciel, les exauça aussitôt, il les sauva par l'intervention d'Isaïe."
,"21":"Le Seigneur frappa le camp des Assyriens, son ange les extermina."
,"22":"C'est qu'Ezéquias faisait ce qui plaît au Seigneur; il s'attachait fermement aux exemples de David, son père. Le prophète Isaïe, si grand, dont les visions ne trompaient pas, se chargeait de les lui enseigner."
,"23":"C'est avec lui que le soleil fit marche arrière, lorsqu'il prolongea la vie du roi."
,"24":"Inspiré de façon extraordinaire, Isaïe vit les choses à venir et laissa un message aux affligés de Sion."
,"25":"Il indiqua ce qui arriverait jusqu'à la fin des temps et montra les choses cachées avant qu'elles n'adviennent."
}`)
	CurrentBook.AddChapter(49, `{
"1":"La mémoire de Josias a un parfum d'encens préparé avec tout l'art du parfumeur, c'est comme un miel doux à la bouche, c'est comme une musique au milieu du festin et des vins."
,"2":"Car il a pris le droit chemin et converti le peuple: c'est lui qui supprima les idoles abominables, la source du péché."
,"3":"Il avait tourné son coeur vers le Seigneur et il restaura la piété à une époque où les sans-loi triomphaient."
,"4":"A l'exception de David, Ezéquias et Josias, tous les autres ne firent que multiplier les fautes. Les rois de Juda abandonnèrent la Loi du Très-Haut, et c'est pourquoi ils furent abandonnés."
,"5":"Ils durent se soumettre à d'autres et céder leur patrimoine à une nation étrangère."
,"6":"La ville choisie, la cité sainte fut incendiée, les routes qui y menaient furent désertées."
,"7":"Jérémie était intervenu, celui qu'ils avaient maltraité. Il avait été consacré comme prophète dès le sein de sa mère: il devait arracher, détruire et ruiner, et puis bâtir et planter."
,"8":"Ensuite ce fut Ezéquiel qui contempla en une vision la gloire du Seigneur: elle lui fut montrée sur le char des chérubins."
,"9":"Ezéquiel a fait mention des rebelles pris dans l'ouragan, mais il est venu en aide à ceux qui suivent le droit chemin."
,"10":"Quant aux Douze Prophètes, que leurs ossements refleurissent là où ils sont tombés. Car ils ont consolé Jacob, ils l'ont sauvé en ravivant ses espérances."
,"11":"Pourrons-nous faire un digne éloge de Zorobabel, ne fut-il pas comme 'l'anneau qu'on porte à la main droite'?"
,"12":"Et de même pour Josué, fils de Josédek? Car c'est avec eux que la Maison de Dieu fut reconstruite; ils rebâtirent le saint temple du Seigneur, le laissant prêt pour une gloire impérissable."
,"13":"Néhémie de même a laissé un grand souvenir: il a relevé nos murs abattus, il a restauré nos portes et leurs verrous, il a rebâti nos maisons."
,"14":"Nul n'a été créé sur cette terre avec la destinée d'Hénok: il a été enlevé de ce monde!"
,"15":"Pas un homme qui soit né tel que Joseph, le chef de ses frères et le soutien de son peuple, avec la promesse d'être visité dans sa tombe!"
,"16":"Sem et Seth sont grands pour l'humanité, mais Adam est supérieur à toute créature vivante!"
}`)
	CurrentBook.AddChapter(50, `{
"1":"Parlons aussi du grand-prêtre Simon, fils d'Onias. De son vivant il répara la Maison du Seigneur, c'est de son temps que le sanctuaire fut restauré."
,"2":"Il posa les fondations du second mur et le Sanctuaire fut entouré d'un rempart."
,"3":"De son temps aussi fut creusé le réservoir des eaux, un bassin large comme la mer."
,"4":"En prévision de nouveaux malheurs pour son peuple, il fortifia la ville contre un assaut éventuel."
,"5":"Comme il était majestueux quand il sortait de derrière le voile du Temple, entouré de son peuple!"
,"6":"C'était comme l'étoile du matin au milieu des nuages, comme la lune dans son plein,"
,"7":"comme le soleil rayonnant sur le Temple du Très-Haut, comme l'arc-en-ciel dont la lumière transfigure les nuages,"
,"8":"comme le rosier en fleurs au printemps, comme le lis au bord de la source, comme les rameaux de l'arbre odoriférant en été, comme le feu et le parfum de l'encensoir, comme un vase d'or massif orné de toutes sortes de pierres précieuses, ()"
,"10":"comme l'olivier chargé de ses fruits, comme le cyprès qui s'élance vers les nues."
,"11":"Ainsi était Simon quand il montait au saint autel des sacrifices, revêtu de sa tunique d'apparat et de tous ses ornements précieux; sa gloire rejaillissait sur l'enceinte du sanctuaire."
,"12":"Debout près du brasier de l'autel, il recevait de la main des prêtres les viandes sacrifiées: autour de lui ses frères se formaient en couronne, pareils à la ramure des cèdres du Liban; ils faisaient le cercle, semblables à des troncs de palmiers."
,"13":"Alors tous les fils d'Aaron, revêtus de leurs ornements, venaient se placer face à l'assemblée d'Israël, portant dans leurs mains l'offrande du Seigneur."
,"14":"Simon accomplissait à l'autel les rites liturgiques et présentait d'un geste ample l'offrande au Très-Haut, le Tout-Puissant."
,"15":"Prenant la coupe de vin, il faisait couler doucement le jus de la grappe sur les bases de l'autel, comme un parfum agréable pour le Très-Haut, le Roi de l'univers."
,"16":"Alors les fils d'Aaron lançaient les acclamations, ils sonnaient de leurs trompettes d'argent battu et leur faisaient donner un son puissant pour se rappeler au souvenir du Très-Haut."
,"17":"Le peuple entier d'un seul élan, tombait face contre terre: ils adoraient leur Seigneur, le Tout-Puissant, le Dieu Très-Haut."
,"18":"Les chantres le louaient à pleine voix: c'était une immense et douce harmonie."
,"19":"Le peuple suppliait le Seigneur Très-Haut et se tenait en prière devant le Miséricordieux, jusqu'à ce que s'achève l'hommage au Seigneur et que se termine la liturgie."
,"20":"Alors il descendait de l'autel, étendait les mains sur toute l'assemblée des fils d'Israël: de ses lèvres il bénissait le Seigneur et prononçait avec fierté son Nom."
,"21":"Et de nouveau le peuple se prosternait pour recevoir la bénédiction du Très-Haut."
,"22":"Et maintenant, bénissez le Dieu de l'univers qui fait partout de grandes choses! Depuis que nous sommes nés il nous fait vivre, et toujours il nous traite avec miséricorde."
,"23":"Qu'il nous donne la joie du coeur, que nous ayons de nos jours la paix, qu'Israël en jouisse jusqu'à la fin des temps!"
,"24":"Puisse le Seigneur nous garder sa bienveillance, et qu'au long de nos jours il nous délivre!"
,"25":"Il y a deux nations qui m'exaspèrent, et la troisième ne mérite même pas ce nom."
,"26":"Ce sont ceux qui demeurent dans la montagne de Séïr, puis les Philistins, et aussi ces gens stupides qui habitent à Sichem!"
,"27":"C'est Jésus, fils de Sirac, fils d'Eléazar, de Jérusalem, qui a mis dans ce livre tant d'enseignements et de savoir; il y a déversé la sagesse qu'il portait en lui."
,"28":"Heureux celui qui y reviendra sans cesse! S'il leur donne son attention, il deviendra sage; s'il les met en pratique, il se sentira fort en toute circonstance, car la lumière du Seigneur illuminera son chemin."
}`)
	CurrentBook.AddChapter(51, `{
"1":"Je veux te glorifier, mon Seigneur et mon Roi, je te bénirai, ô Dieu, mon Sauveur, et je rendrai grâces à ton nom."
,"2":"Car tu t'es fait mon protecteur, mon soutien, car tu n'as pas permis que se perde mon corps, que je me prenne au piège de leurs calomnies, aux artifices des diseurs de mensonge. Quand j'étais face à mes accusateurs, tu m'as assisté et tu m'as délivré!"
,"3":"Grande est ta miséricorde, grand est ton Nom!,tu m'as arraché aux crocs prêts à me dévorer, à la main de ceux qui en voulaient à ma vie, tu m'as tiré de multiples épreuves,"
,"4":"des flammes qui m'entouraient, où je suffoquais: au beau milieu du feu je n'ai pas brûlé!"
,"5":"Tu m'as repris au Séjour d'en bas, et de même à la langue impure et mensongère,"
,"6":"quand ses calomnies arrivaient jusqu'au roi. J'étais arrivé au seuil de la tombe, et déjà ma vie basculait chez les morts."
,"7":"Ils me cernaient, et personne pour m'aider!,Je cherchais un secours humain: rien!"
,"8":"Je me suis souvenu de ta miséricorde, Seigneur, de tes interventions dans le passé; car tu délivres ceux qui s'appuient sur toi,et tu les sauves de la main de l'adversaire."
,"9":"De la terre est montée ma supplication, j'ai prié pour être délivré de la mort."
,"10":"J'ai invoqué le Seigneur, Père de mon Seigneur: Ne m'abandonne pas en ces jours de détresse, lorsque ces gens triomphent de me voir sans secours. Sans cesse je louerai ton Nom,et je te rendrai grâces avec des hymnes."
,"11":"Ma prière a été exaucée: tu m'as sauvé de la ruine,et délivré de cette heure fatale."
,"12":"C'est pourquoi je veux te rendre grâces et te chanter, je bénirai le Nom du Seigneur."
,"13":"Déjà quand j'étais jeune, avant tous mes voyages, j'ai carrément demandé la sagesse dans la prière."
,"14":"Je me tenais devant le Sanctuaire pour la demander, et jusqu'à la fin je la poursuivrai."
,"15":"J'y ai trouvé ma joie: elle venait comme la fleur d'une grappe mûrissante. J'ai avancé droit mon chemin, et dès ma jeunesse j'ai suivi sa trace."
,"16":"A peine avais-je tendu l'oreille de son côté qu'elle m'a été accordée, et j'y ai trouvé toute une doctrine."
,"17":"Comme j'ai progressé grâce à elle! Je veux rendre gloire à celui qui me l'a donnée."
,"18":"J'avais décidé de la mettre en pratique, j'ai ardemment cherché le bien et je n'ai pas à m'en repentir."
,"19":"Elle m'a fait livrer de durs combats: je suis devenu exigeant sur la pratique de la Loi. J'élevais les mains vers le ciel, déplorant mes insuffisances à son sujet."
,"20":"Je me suis tourné vers elle de toute mon âme, et je l'ai trouvée à force de purification. C'est d'ailleurs grâce à elle que, dès le début, je possédais mon coeur: maintenant elle ne m'abandonnera pas."
,"21":"Le désir de l'acquérir me tenait jusqu'aux entrailles, et grâce à cela j'ai obtenu la vraie fortune."
,"22":"Le Seigneur m'a récompensé avec le don de la parole: il me permettra de le louer."
,"23":"Approchez-vous, vous qui ne savez pas, venez passer un temps dans l'école de la sagesse!"
,"24":"Pourquoi dites-vous que la sagesse n'est pas pour vous, si vous en avez vraiment soif?"
,"25":"Je vous déclare, car je peux le dire: Faites une acquisition sans rien payer!"
,"26":"Pliez votre cou pour recevoir son joug, recevez l'instruction! Vous allez la trouver, elle est déjà là."
,"27":"Ouvrez les yeux et voyez: c'est bien peu ce que j'ai peiné pour arriver à cette fin d'étape."
,"28":"Une masse d'argent ne serait pas de trop pour payer l'instruction: avec elle vous auriez de l'or en abondance."
,"29":"Réjouissez-vous donc de la miséricorde du Seigneur, n'ayez pas honte de le louer."
,"30":"Achevez votre travail avant que l'heure ne sonne: au temps qu'il a fixé, le Seigneur vous récompensera."
}`)

}
func FR_LBDCC_LoadVSIBChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Il y avait au pays de Ous un homme du nom de Job. C'était un homme intègre et droit, il craignait Dieu et évitait le mal."
,"2":"Il avait sept fils et trois filles,"
,"3":"il possédait sept mille moutons, trois mille chameaux, cinq cents paires de boeufs, cinq cents ânesses, et de très nombreux serviteurs. Cet homme était le plus important parmi les fils de l'Orient."
,"4":"Ses fils allaient régulièrement festoyer les uns chez les autres, à tour de rôle, et ils invitaient leurs trois soeurs à manger et à boire avec eux."
,"5":"Dès que la série des fêtes était achevée, Job les faisait venir auprès de lui pour une cérémonie de pardon: il se levait de grand matin et offrait pour chacun d'eux un sacrifice pour l'expiation des péchés. En effet, Job se disait en lui-même: 'Qui sait? Peut-être mes fils ont-ils maudit Dieu dans leur coeur!' Et c'est ainsi que Job faisait invariablement."
,"6":"Un certain jour, comme les Fils de Dieu étaient venus se présenter devant Yahvé, le Satan vint avec eux."
,"7":"Yahvé dit à Satan: 'D'où viens-tu?' Il répondit: 'Je viens de parcourir la terre, je suis passé un peu partout.'"
,"8":"Et Yahvé reprit: 'As-tu remarqué mon serviteur Job? Il n'a pas son pareil sur la terre: c'est un homme intègre et droit, il craint Dieu et évite le mal.'"
,"9":"Mais Satan répondit à Yahvé: 'Si Job te craint, le fait-il sans intérêt?"
,"10":"N'as-tu pas élevé une clôture autour de lui, de sa famille et de ses biens? Tu as béni ses entreprises et ses troupeaux couvrent tout le pays."
,"11":"Mais peut-être pourrais-tu étendre la main pour et frapper là où sont ses biens. Alors sûrement il te maudirait en face.'"
,"12":"Yahvé dit à Satan: ' Soit! Je te livre tous ses biens, mais tu ne toucheras pas à lui.' Et Satan se retira de devant Yahvé."
,"13":"Un jour que les fils et les filles de Job étaient en train de manger et de boire du vin dans la maison de leur frère aîné,"
,"14":"un messager accourut auprès de Job et lui dit: 'Tes boeufs étaient en train de labourer et les ânesses étaient au pâturage à côté d'eux,"
,"15":"quand les Sabéens se sont jetés dessus et les ont enlevés après avoir massacré tes serviteurs. Moi seul j'ai été épargné, et je viens te l'annoncer.'"
,"16":"Il parlait encore quand un autre survint et dit: 'Le feu du ciel est tombé: il a frappé tes brebis et tes serviteurs, et il les a brûlés. Moi seul j'ai été épargné, et je viens te l'annoncer!'"
,"17":"Il parlait encore quand un autre survint et dit: 'Les Kaldéens sont venus de trois côtés différents; ils ont enlevé tes chameaux et sont partis avec, après avoir massacré tes serviteurs! Moi seul j'ai été épargné, et je viens te l'annoncer.'"
,"18":"Il parlait encore quand un autre survint et dit: 'Tes fils et tes filles étaient en train de manger et de boire du vin dans la maison de leur frère aîné,"
,"19":"quand un vent de tempête a soufflé du désert et enfoncé les quatre coins de la maison; elle s'est écroulée sur les jeunes qui sont tous morts! Moi seul j'ai été épargné, et je viens te l'annoncer.'"
,"20":"Alors Job se leva, déchira son manteau et se rasa la tête. Puis il se laissa tomber sur le sol et se prosterna."
,"21":"Il disait: 'Nu je suis sorti du ventre de ma mère, nu aussi j'y retournerai. Yahvé a donné, Yahvé a repris; que le nom de Yahvé soit béni!'"
,"22":"Dans tous cela Job ne pécha pas; il ne dit rien de mal contre Dieu."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Et voici que revint le jour où les Fils de Dieu se présentaient devant Yahvé. Satan vint aussi, parmi eux, et se présenta devant Yahvé."
,"2":"Yahvé lui dit: 'D'où viens-tu? ' Il répondit: 'Je viens de parcourir la terre, je suis passé un peu partout.'"
,"3":"Yahvé reprit: 'As-tu remarqué mon serviteur Job? Il n'a pas son pareil sur la terre: c'est un homme intègre et droit, il craint Dieu et évite le mal. C'est bien inutilement que tu m'as arraché la permission de le perdre, car il se maintient dans sa parfaite fidélité.'"
,"4":"Mais Satan répliqua à Yahvé: 'Peau pour peau! On donne tout ce qu'on a pour rester en vie!"
,"5":"Peut-être pourrais-tu étendre la main pour le frapper dans ses os et sa chair. Alors sûrement il te maudirait en face!'"
,"6":"Yahvé dit à Satan: 'Soit! Je te le livre, mais respecte sa vie.'"
,"7":"Satan se retira de devant Yahvé et il frappa Job de plaies purulentes, depuis la plante des pieds jusqu'au sommet de la tête."
,"8":"Job s'assit alors sur un tas de cendres et ramassa un morceau de poterie pour se gratter."
,"9":"Sa femme lui dit: 'Vas-tu te maintenir dans ta parfaite fidélité? Maudis Dieu et meurs!'"
,"10":"Il lui répondit: 'Tu parles comme une insensée! Si nous acceptons le bonheur que Dieu nous donne, pourquoi n'accepterions-nous pas aussi le malheur?' En tout cela, Job ne pécha pas en paroles."
,"11":"En apprenant tous les malheurs qui étaient arrivés à Job, trois de ses amis voulurent le visiter, et ils vinrent, chacun de son pays. C'étaient Elifaz de Téman, Bildad de Shouah et Sofar de Nahama. Ils s'étaient mis d'accord pour aller le plaindre et le consoler."
,"12":"Quand de loin ils levèrent les yeux et le virent, ils ne purent le reconnaître. Ils commencèrent à se lamenter et à pleurer; chacun déchira son manteau, puis ils jetèrent en l'air de la poussière qui leur retombait sur la tête."
,"13":"Ils restèrent ainsi sept jours et sept nuits près de lui, assis par terre. Aucun d'eux ne lui adressait la parole, car ils voyaient combien grande était sa douleur."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Alors Job ouvrit la bouche pour maudire le jour de sa naissance."
,"2":"Et voici ce que dit Job:"
,"3":"Que périsse le jour où je suis né, la nuit qui dit la nouvelle: 'Conception d'un garçon!'"
,"4":"Que ce jour s'en aille aux ténèbres, que Yahvé là-haut l'ignore à jamais, et qu'aucune lumière pour lui ne se lève!"
,"5":"Que le noir et les ténèbres s'en emparent, qu'un nuage s'installe sur lui, et que l'obscurité étouffe son jour!"
,"6":"Que la ténèbre s'empare de cette nuit, qu'elle ne puisse s'ajouter aux autres de l'année, qu'elle n'entre pas en compte pour le mois!"
,"7":"Que cette nuit soit stérile à jamais, que les cris de joie n'y pénètrent pas!"
,"8":"Que la maudissent ceux-là même qui fuient le jour, et qui s'affairent à réveiller les démons!"
,"9":"Que s'obscurcissent ses étoiles matinales, qu'elle attende l'aube sans qu'elle vienne, et ne voie plus jamais se lever son aurore!"
,"10":"Car elle n'a pas fermé pour moi les portes du ventre, afin de m'épargner, au sortir, la détresse."
,"11":"Pourquoi ne suis-je pas mort dans le sein, pourquoi ne suis-je pas né déjà mort?"
,"12":"Pourquoi ai-je trouvé deux genoux pour m'accueillir, deux mamelles pour m'allaiter?"
,"13":"Car maintenant je serais tranquille sur ma couche, je dormirais et j'aurais mon repos."
,"14":"Je serais avec les rois, et les grands de la terre, et ceux qui se construisent des tombes au désert,"
,"15":"avec les princes qui gardaient l'or,et remplissaient d'argent leurs palais."
,"16":"Pourquoi n'ai-je pas été l'avorton caché, comme ces tout-petits qui n'ont pas vu le jour?"
,"17":"Fini, là-bas, le vacarme des méchants, là-bas se reposent les épuisés,"
,"18":"les prisonniers sont élargis,et n'entendent plus le cri des surveillants."
,"19":"Petits ou grands, là-bas c'est pareil, et l'esclave est délivré de son maître."
,"20":"Pourquoi donner la lumière à un malheureux, et la vie à ceux qui iront dans la peine?"
,"21":"Ils aspirent à la mort, mais elle ne vient pas; ils soupirent après, plus qu'on ne fait pour un trésor."
,"22":"Ils sont heureux quand vient la fin, ils se réjouissent quand ils arrivent à la tombe."
,"23":"Pourquoi la vie, si l'homme ne voit plus un chemin, si Dieu lui a barré toutes les issues?"
,"24":"Pour nourriture je n'ai que mes soupirs, et mes pleurs comme l'eau s'épanchent."
,"25":"Ce qui me faisait peur est là sur moi, ce que je redoutais est venu me surprendre."
,"26":"Je n'ai plus ni paix, ni relâche, les tourments sont venus, j'ai perdu le repos."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Elifaz de Téman prit alors la parole:"
,"2":"Si nous tentons de te parler, voudras-tu?,Mais qui pourrait se taire?"
,"3":"Vois, tu as prêché à bien des gens, tu rendais la force à celui qui abandonne,"
,"4":"tes mots remettaient sur pied celui qui trébuche, tu affermissais les genoux qui fléchissent."
,"5":"Et puis, quand vient ton tour, tu faiblis, lorsque c'est toi qui es frappé, tu t'effondres!"
,"6":"Ne dois-tu pas compter sur ton respect du droit, ta vie parfaite n'est-elle pas ta raison d'espérer?"
,"7":"Rappelle-toi: quand donc un innocent a-t-il péri?,Où a-t-on vu des hommes droits disparaître?"
,"8":"J'ai observé ceux qui font le mal: ceux qui sèment le mal sont ceux qui le récoltent."
,"9":"Le souffle de Dieu les balaie, le vent de sa colère les anéantit."
,"10":"Le lion rugit, le léopard donne de la voix, mais au fauve on lui brise les dents."
,"11":"Le lion périt faute de proie, et les petits de la lionne vont à l'aventure."
,"12":"Une révélation secrète est venue jusqu'à moi, mon oreille a perçu son écho furtif."
,"13":"Au milieu de fantasmes entrevus dans la nuit,à l'heure où le sommeil s'empare des humains,"
,"14":"je fus pris de frayeur jusqu'à en trembler: tous mes os en ont été secoués."
,"15":"Un souffle alors passa sur mon visage, qui fit se hérisser tous les poils de mon corps."
,"16":"Quelqu'un était là, je n'ai rien reconnu; c'était une forme devant mes yeux. Un silence, puis j'entends une voix:"
,"17":"'Un humain sera-t-il juste devant Dieu?,quel homme sera pur pour Celui qui l'a fait?"
,"18":"Si Dieu ne se fie pas à ses serviteurs, et même dans ses anges trouve l'erreur,"
,"19":"que dire de ceux qui vivent en demeures d'argile, dont les bases même ne sont que poussière,et qu'on écrase tout net, comme un insecte?"
,"20":"Entre matin et soir on les a détruits, sans crier gare, ils disparaissent à jamais."
,"21":"On leur a dépiqué leur tente, et ils sont morts avant d'avoir compris.'"
}`)
	CurrentBook.AddChapter(5, `{
"1":"Tu voudrais appeler? Mais qui te répondra?,Vers lequel des Saints te tourneras-tu?"
,"2":"L'insensé est victime de ses délires, c'est leur propre violence qui tue les têtes folles."
,"3":"J'ai vu l'insensé bien enraciné, et tout d'un coup sa demeure s'est écroulée."
,"4":"Ses enfants ne trouvaient plus qui les aide, qui les défende en haut lieu face aux attaques."
,"5":"Des affamés pillaient leur récolte,et l'emportaient dans leurs cachettes; d'autres avaient soif de leurs biens."
,"6":"Non, le désordre ne sort pas de la terre, le malheur ne germe pas du sol."
,"7":"Mais si l'homme est né pour mal faire, c'est alors que les flammes s'élèvent."
,"8":"A ta place, j'irais droit à Dieu: c'est à lui que j'exposerais ma cause,"
,"9":"car ses oeuvres dépassent ce qu'on peut comprendre, il fait des miracles sans nombre."
,"10":"Il déverse la pluie sur la terre,pour irriguer la surface des champs."
,"11":"Il élève ceux qui étaient bas, et rend la joie aux affligés."
,"12":"Il déjoue les manoeuvres des astucieux, et quoi qu'ils fassent, ils ne peuvent s'en remettre."
,"13":"Il prend au piège les sages dans leur astuce, et réduit à rien les projets des intrigants."
,"14":"En plein jour les ténèbres les assaillent, ils tâtonnent à midi comme dans la nuit."
,"15":"Mais Dieu sauve de leur gueule les opprimés, il arrache le faible à la main du violent."
,"16":"Le pauvre alors reprend espoir: l'injustice? On lui a fermé la bouche."
,"17":"Heureux l'homme que Dieu corrige!,ne méprise pas la leçon du Tout-Puissant."
,"18":"Après avoir blessé il soigne la plaie, après avoir meurtri, ses mains guérissent."
,"19":"Par six fois il te sauve de la détresse, une septième encore? le mal ne t'atteint pas."
,"20":"Que vienne la famine, il t'arrache à la mort; au combat, il te préservera de l'épée."
,"21":"Tu échapperas aux coups de la langue, tu n'auras pas à craindre l'assaut du pillard."
,"22":"Les agressions, la pénurie, tu en riras, les bêtes féroces, tu n'en auras pas peur."
,"23":"Plus de pierres dans tes champs: la terre te servira, les bêtes nuisibles feront la paix avec toi."
,"24":"Tu sauras que tout prospère en ta tente, visitant tes terres, tu n'y verras nul dommage."
,"25":"Sous tes yeux ta race se multipliera, tes rejetons pousseront comme l'herbe des champs."
,"26":"Tu iras à la tombe quand tu seras mûr, comme une gerbe qu'on ramasse en son temps."
,"27":"Tout cela, nous l'avons observé: c'est vrai!,nous en sommes témoins, sache-le toi aussi."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Job prit la parole et dit:"
,"2":"Oh! si l'on pouvait peser à son poids ma peine, et mettre ensemble mes malheurs sur la balance,"
,"3":"ils pèseraient plus lourd que les sables des mers!,Voilà pourquoi mes paroles s'emballent."
,"4":"Je porte en moi les flèches du Puissant, mon esprit en absorbe le poison; que dirai-je à Dieu quand elles me tourmentent?"
,"5":"L'âne va-t-il braire lorsqu'il a trouvé l'herbe, ou le boeuf meugler quand il a son fourrage?"
,"6":"La nourriture a-t-elle du goût sans sel, et le blanc d'oeuf peut-il être apprécié?"
,"7":"Mais voici que j'ai maintenant pour pain, tout ce à quoi je n'aurais voulu toucher."
,"8":"Qui fera que ma demande parvienne,et que Dieu me donne ce que j'espère:"
,"9":"qu'il se décide enfin à m'écraser, qu'il laisse aller sa main et me supprime."
,"10":"Ce serait pour moi une consolation, une dernière joie dans mes tourments, de n'avoir pas renié les paroles du Saint."
,"11":"Aurai-je encore la force d'attendre, et quel avenir puis-je encore espérer?"
,"12":"Ai-je la résistance du roc, et ma chair est-elle de bronze?"
,"13":"Je ne peux plus rien pour m'en tirer, et tout autre secours a fui loin de moi."
,"14":"Quand on refuse à un ami sa compassion, on lui fait perdre la crainte du Tout-Puissant."
,"15":"Mes frères ont été pour moi un ruisseau trompeur, un torrent dont les eaux n'ont qu'un temps:"
,"16":"ce n'était que la fonte des glaces, elles sortaient de dessous les neiges."
,"17":"Vienne la saison sèche et elles tarissent, dès qu'il fait chaud leur lit est à sec."
,"18":"Les caravanes en perdent leur chemin, elles s'enfoncent dans l'inconnu et s'y perdent."
,"19":"Les caravanes de Teima s'y repéraient, les voyageurs de Sheba s'y dirigeaient,"
,"20":"mais ils sont déçus dans leur attente; arrivés sur place, ils ne savent que faire."
,"21":"Voilà bien ce que vous êtes pour moi maintenant: vous avez vu l'horreur et vous avez pris peur."
,"22":"Je ne vous ai pas dit: 'Donnez-moi, payez ma rançon sur vos biens!'"
,"23":"Ai-je dit: 'Délivrez-moi d'un ennemi, arrachez-moi aux mains d'un tyran'?"
,"24":"Eclairez-moi plutôt, je ne dirai rien, montrez-moi où est mon erreur."
,"25":"Des arguments justes, on les recevra bien, mais que reprenez-vous avec vos remontrances?"
,"26":"Cherchez-vous simplement à condamner des mots, rectifier les paroles d'un homme en peine?"
,"27":"Mais voudriez-vous tirer au sort l'orphelin, iriez-vous jusqu'à vendre votre ami?"
,"28":"Je vous le demande, regardez-moi, je ne vous mentirai pas en face."
,"29":"Recommencez, pas de fausse justice!,reprenons l'examen de ma cause."
,"30":"Est-ce que j'ai dit quelque chose de mal, est-ce que j'ai mal compris le sens du malheur?"
}`)
	CurrentBook.AddChapter(7, `{
"1":"C'est une corvée, cette vie de l'homme sur terre, ses jours sont dignes d'un mercenaire."
,"2":"Il est l'esclave qui soupire après l'ombre, l'ouvrier qui attend son salaire."
,"3":"J'ai reçu en partage des mois de malheur, les nuits de souffrance ont été mon lot."
,"4":"Au lit je me dis: 'A quand le jour?'; une fois levé je soupire: 'Quand fera-t-il nuit?',et mon esprit s'agite jusqu'à la fin du jour."
,"5":"Mon corps est recouvert de vermine et de croûtes, ma peau est crevassée et suppure partout."
,"6":"Mes jours ont couru plus vite qu'une navette, et voici qu'ils s'achèvent sans espoir."
,"7":"Rappelle-toi que ma vie n'est qu'un souffle,et que mes yeux ne reverront pas le bonheur!"
,"8":"Les yeux qui m'ont connu ne me reverront plus: si tu cherches à me voir, je ne serai plus."
,"9":"Le nuage qui se défait ne reviendra pas, qui descend chez les morts n'en remontera pas."
,"10":"Il ne reviendra pas à sa maison, les lieux qu'il fréquentait ne le reverront plus."
,"11":"C'est pourquoi je ne veux pas me taire, je veux dire la détresse de mon esprit,et faire entendre la peine de mon âme."
,"12":"O Dieu, pourquoi m'as-tu mis entre des murs?,suis-je l'Océan, ou le Monstre marin?"
,"13":"Si je me dis: 'Le lit me soulagera, ma paillasse me prendra ma peine,'"
,"14":"aussitôt tu m'effraies par des songes, et ce sont des visions d'épouvante."
,"15":"J'aimerais mieux être étranglé, et mourir plutôt que souffrir ainsi."
,"16":"J'ai tout épuisé, jamais plus je ne vivrai; laisse-moi, mes jours ne sont plus qu'un souffle!"
,"17":"L'homme mérite-t-il une telle importance?,Pourquoi lui donnes-tu ton attention,"
,"18":"et viens-tu l'inspecter tous les matins, le contrôler à chaque instant?"
,"19":"Ne cesseras-tu pas de m'observer, me donneras-tu un répit pour avaler ma salive?"
,"20":"Si j'ai fauté, que t'ai-je fait à toi, surveillant des humains?,Pourquoi m'as-tu pris pour cible?,Suis-je devenu un fardeau pour toi?"
,"21":"Ne peux-tu pas supporter ma faute,et fermer les yeux sur mon péché?,Voici que je vais me coucher dans la terre, tu me chercheras et je ne serai plus."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Bildad de Shouah prit la parole et dit:"
,"2":"Jusqu'à quand vas-tu prolonger ce discours, et ces paroles, comme un vent qui n'en finit pas?"
,"3":"Dieu est-il capable de tourner la justice?,Le Tout-Puissant fausserait-il le droit?"
,"4":"Si tes fils ont péché contre lui, il les a fait payer pour leurs fautes."
,"5":"Mais si toi tu as recours à Dieu, si tu implores le Tout-Puissant,"
,"6":"si toi, tu es pur et droit, aussitôt il prendra soin de toi,pour te mettre en la demeure que mérite ta droiture."
,"7":"Le passé te semblera peu de chose,tant l'avenir sera meilleur."
,"8":"Demande à l'ancienne génération, et remonte à l'expérience de leurs pères."
,"9":"Car nous sommes nés d'hier et ne savons guère, nos jours passent sur terre comme une ombre."
,"10":"Mais eux peuvent t'instruire et te parler, et ces quelques mots te diront ce qu'ils sentent:"
,"11":"'Le papyrus va-t-il pousser hors des marais?,Le roseau se développera-t-il sans eau?"
,"12":"Même vert, avant qu'on le coupe,avant toute autre plante il se déssèche."
,"13":"C'est ainsi que termine celui qui oublie Dieu, et que se perdent les espoirs de l'impie."
,"14":"Sa confiance s'accrochait à un fil, il faisait fond sur une toile d'araignée."
,"15":"Il s'appuie sur sa maison, et elle cède, il s'y accroche: elle s'écroule."
,"16":"Il était plein de vigueur au soleil,et couvrait le jardin de ses jeunes pousses:"
,"17":"ses racines serpentaient sur la pente, elles s'accrochaient entre les roches."
,"18":"A peine l'as-tu arraché de sa place, elle le renie: 'Je ne t'ai jamais vu!'"
,"19":"Le voilà pourrissant sur le chemin: un autre bientôt est sorti du sol."
,"20":"Non! Dieu ne méprise pas celui qui est parfait, pas plus qu'il ne soutient ceux qui sont malfaisants."
,"21":"Il remplira encore ta bouche de rires, et mettra sur tes lèvres les cris de joie."
,"22":"Tes ennemis seront couverts de honte, et l'on ne verra plus la demeure des méchants."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Job prit la parole et dit:"
,"2":"Oui, je le reconnais, tout cela est vrai: comment un homme aurait-il raison contre Dieu?"
,"3":"S'il voulait discuter avec lui, pourrait-il répondre une fois sur mille?"
,"4":"Il pense avec sagesse, sa force a tout pouvoir, peut-on lui résister impunément?"
,"5":"Il déplace les montagnes sans qu'elles le sachent, il les retourne s'il se met en colère."
,"6":"Il ébranle la terre sur son socle,et ses colonnes vacillent."
,"7":"Il suffit qu'il parle, le soleil ne brille plus, un tour de clé, et ce sont les étoiles."
,"8":"Il a déployé, tout seul, la voûte aux étoiles, il chemine sur le plancher des eaux."
,"9":"Il a fait la Grande Ourse, et puis Orion, et les Pléiades et les Chambres du Sud."
,"10":"Il fait des choses si grandes qu'on ne peut les sonder, des merveilles impossibles à compter!"
,"11":"S'il passe près de moi, je ne le vois pas, il me frôle sans que je l'aperçoive."
,"12":"S'il prend de force, va-t-on l'en empêcher, ou lui dire: 'Que fais-tu là?'"
,"13":"Dieu ne se reprend pas quand il s'est emporté, ceux qui aidaient Rahab sont toujours sous ses pieds."
,"14":"Voulez-vous que j'aille, moi, lui répliquer,et me mettre à discuter avec lui,"
,"15":"ou à supplier mon juge,qui ne me répond pas quand je suis dans mon droit?"
,"16":"Je pourrais l'appeler, attendant une réponse, mais comment croire qu'il entendra ma voix?"
,"17":"C'est lui qui m'écrase pour un cheveu, qui multiplie sans raison mes blessures."
,"18":"Il ne me laisse pas reprendre mon souffle,tandis qu'il m'envoie jusqu'à plus soif la peine."
,"19":"Employer la force? Il sera le plus fort. Aller aux juges? Qui fera la convocation?"
,"20":"Je peux être juste, mes paroles m'accuseront, même si je suis parfait, elles me condamneront."
,"21":"Mais suis-je parfait? Je ne le sais pas: la vie n'a pas de sens!"
,"22":"Tout est pareil et je peux dire: il supprime l'innocent avec le coupable."
,"23":"Quand une catastrophe répand soudain la mort, il se moque de l'épreuve des innocents."
,"24":"Quand un pays tombe aux mains des méchants, il met un bandeau sur les yeux des juges. Si ce n'est pas lui, qui donc alors?"
,"25":"Mes jours ont passé plus vite qu'un coureur: ils fuyaient sans connaître le bonheur."
,"26":"Ils glissaient comme une barque de joncs, comme un aigle qui fond sur sa proie."
,"27":"J'ai beau dire: 'Laissons là ces plaintes, montrons un autre visage: le sourire!'"
,"28":"mes épreuves me laissent angoissé,car je sais que tu ne me vois pas innocent."
,"29":"Si je dois être coupable, à quoi bon me fatiguer pour rien?"
,"30":"J'aurais beau me laver à l'eau de neige,et me blanchir les mains avec du savon,"
,"31":"tu me jetterais aussitôt dans la boue, et même ma tunique m'aurait en dégoût!"
,"32":"Il n'est pas quelqu'un comme moi, pour que je lui dise: Allons ensemble au tribunal!"
,"33":"Il faudrait un arbitre entre nous, pour nous prendre l'un et l'autre par l'épaule,"
,"34":"pour écarter son bâton qui me frappe,et l'épouvante où me jettent ses terreurs."
,"35":"Mais puisqu'il n'en est pas ainsi, je veux parler sans crainte, seul avec moi-même."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Oui, je suis dégoûté de la vie, je veux donner libre cours à mes plaintes,et laisser parler mon amertume."
,"2":"Je dirai à Dieu: 'Ne me condamne pas ainsi, mais dis-moi de quoi tu m'accuses."
,"3":"Est-ce bon pour toi d'agir en tyran, de piétiner l'oeuvre de tes mains, de justifier les théories des méchants?"
,"4":"Tes yeux sont-ils ceux du corps, vois-tu donc à la façon des hommes?"
,"5":"Ton temps est-il le même que celui des humains, tes années passent-elles comme celles d'un homme?"
,"6":"Pourquoi alors rechercher ma faute, et faire enquête sur mes dettes?"
,"7":"Tu sais bien que je ne suis pas coupable, et que personne ne m'arrachera de tes mains."
,"8":"Tes mains m'ont façonné, tu m'as fait, et maintenant, tu me détruirais?"
,"9":"Souviens-toi que tu m'as pétri comme l'argile: veux-tu me renvoyer à la terre?"
,"10":"Ne m'as-tu pas versé comme le lait, et laissé cailler comme le fromage?"
,"11":"Tu m'as revêtu de peau et de chair, prenant dans le tissu mes os et mes nerfs."
,"12":"Tu as fait en moi oeuvre de vie et de grâce, tes attentions ont maintenu mon souffle,"
,"13":"mais quelle était ton intention secrète?,Je sais ce qu'il y avait chez toi!"
,"14":"Tu voulais voir si j'allais pécher, et si je fautais, ne rien me passer."
,"15":"Si j'ai eu tort, malheur à moi!,même innocent, je n'ose pas lever la tête. Rassasié d'humiliations, saturé de peines,"
,"16":"épuisé, tu me poursuis comme un lion; toujours tu veux montrer ta supériorité."
,"17":"Tu reprends tes assauts, ta fureur se ranime, et de nouveau tu lances tes attaques contre moi."
,"18":"Mais pourquoi m'as-tu faire sortir du sein?,J'y serais mort, aucun oeil ne m'aurait vu:"
,"19":"porté du ventre à la tombe, je serais comme si je n'avais pas été."
,"20":"Puisqu'il me reste si peu à vivre, éloigne-toi, que j'aie un peu de joie"
,"21":"avant que je m'en aille, pour ne pas revenir, au pays des ténèbres et de l'ombre mortelle,"
,"22":"au pays où dans la nuit tout se confond, où même la clarté est faite de ténèbres."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Alors Sofar de Nahama prit la parole et dit:"
,"2":"Ne faut-il pas répondre à tant de discours, suffit-il de bien parler pour avoir raison?"
,"3":"Faut-il qu'on se taise quand tu radotes, qu'on ne te remette pas en place quand tu te moques?"
,"4":"Tu as dit à Dieu: 'Ma position est correcte, je suis pur devant toi!'"
,"5":"Il faudrait bien que Dieu te parle, qu'il vienne t'adresser la parole!"
,"6":"Il te dirait quelques secrets de sa sagesse, bien mystérieux pour notre intelligence, et tu verrais que Dieu t'a pris en faute."
,"7":"Pourras-tu sonder la profondeur de Dieu, t'élever jusqu'à la perfection du Puissant?"
,"8":"Elle atteint plus haut que les cieux: que feras-tu?,plus profond que le monde des morts: qu'en sauras-tu?"
,"9":"Sa mesure est plus longue que la terre, elle est plus large que la mer."
,"10":"S'il passe, s'il emprisonne, s'il fait rendre compte, qui l'en empêchera?"
,"11":"Car il a reconnu ceux qui sont faux, il a vu le péché, il l'a compris, bien sûr!"
,"12":"Du coup l'irresponsable apprend à réfléchir: c'est un ânon sauvage que l'on dresse."
,"13":"Reprends donc en main ton coeur,et tends les mains vers lui,"
,"14":"jette au loin le mal que tu faisais,et que l'injustice ne s'abrite pas chez toi."
,"15":"Alors, te sachant pur, tu lèveras ton regard, tu seras ferme et n'auras pas peur."
,"16":"Tu ne penseras plus à tes malheurs: un souvenir peut-être, comme des eaux écoulées."
,"17":"Ce sera l'existence plus brillante qu'un midi, où les recoins obscurs sont encore des matins."
,"18":"Tu te sentiras sûr, ayant une espérance; bien protégé, tu dormiras en paix."
,"19":"Personne ne troublera ton repos, et beaucoup chercheront à te plaire."
,"20":"Mais les yeux des méchants seront enténébrés, il perdront tout moyen d'échapper: leur seul espoir est de rendre l'âme."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Job prit la parole et dit:"
,"2":"Vraiment vous êtes la voix du peuple, avec vous mourra la sagesse!"
,"3":"Moi aussi je raisonne, tout comme vous: toutes ces choses ne sont neuves pour personne."
,"4":"Mais même mon ami ne fait que se moquer, lorsque je crie vers Dieu et demande une réponse. Un homme droit, parfait, on s'en moque:"
,"5":"'Tant pis pour les malchanceux!', dit celui qui réussit, 'donne un coup à celui qui chancelle'."
,"6":"Mais vois que les pillards sont tranquilles chez eux; ils peuvent provoquer Dieu en toute sécurité, ils l'ont mis dans leur poche."
,"7":"Veux-tu interroger les bêtes? elles t'instruiront; demande aux oiseaux du ciel, ils te le diront."
,"8":"Ceux qui rampent sur le sol te feront la leçon, et les poissons des mers t'en donneront les détails."
,"9":"Qui ne sait parmi eux,que tout est l'oeuvre de la main du Seigneur?"
,"10":"Il dispose de l'âme de tout être vivant,et du souffle de vie des humains."
,"11":"L'oreille, bien sûr, est faite pour comprendre, et le palais pour apprécier la nourriture;"
,"12":"ce sont les anciens qui possèdent la sa gesse, une longue vie permet de discerner..."
,"13":"Mais à Dieu appartiennent sagesse et vaillance, le discernement avec l'intelligence."
,"14":"S'il détruit, nul ne va reconstruire; celui qu'il emprisonne ne sera pas délivré."
,"15":"S'il retient les eaux, c'est la sécheresse, s'il les relâche, la terre est inondée."
,"16":"Il possède la force et l'art de décider: il sait qui trompera et qui sera trompé."
,"17":"Il fait aller pieds nus les grands seigneurs; aux gouvernants, il leur fait perdre la tête."
,"18":"Il déboucle le ceinturon des rois, et leur fixe sur les hanches le pagne du captif."
,"19":"Il fait aller pieds nus les prêtres, et il renverse les puissants."
,"20":"Il laisse sans réponse les conseillers sûrs, il prive les anciens de leur bon sens."
,"21":"Il fait que les nobles soient méprisés; aux solides, il leur déboucle le ceinturon."
,"22":"Il sort de l'obscurité la chose qui fut enfouie, il jette à la lumière ce qui était dans l'ombre."
,"23":"Il donne aux nations la grandeur, et puis la ruine, il fait s'étendre un peuple, ensuite il le supprime."
,"24":"Il fait perdre le sens aux chefs du pays: les voilà perdus dans un chaos sans issue."
,"25":"Ils tâtonnent dans le noir: aucune lumière!,ils titubent comme s'ils avaient bu."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Oui, tout cela mes yeux l'ont vu, mes oreilles l'ont entendu et compris."
,"2":"Ce que vous savez, moi aussi je le sais, je ne suis pas inférieur à vous."
,"3":"Mais je voudrais parler au Tout-Puissant,et faire à Dieu mes remontrances."
,"4":"Car peut-être vous êtes des charlatans, et vous venez avec de faux remèdes."
,"5":"Vous devriez vous taire pour de bon, et c'est alors que vous seriez des sages."
,"6":"Ecoutez plutôt ma critique, et soyez attentifs aux raisons que j'apporte."
,"7":"Allez-vous défendre Dieu avec des mensonges, le justifier avec des bêtises?"
,"8":"Voulez-vous prendre son parti,et prendre en mains sa cause?"
,"9":"C'est alors qu'il pourrait vous examiner, et vous ne l'auriez pas: lui n'est pas un humain."
,"10":"Soyez sûrs qu'il vous punira,si, en secret, vous avez choisi votre camp."
,"11":"Est-ce que sa majesté vous laisse sans crainte?,son épouvante n'est-elle jamais tombée sur vous?"
,"12":"Vos vieux refrains ne sont que poussière, vos murailles sont des murs de boue."
,"13":"Faites-moi le silence car je veux parler, peu importe ce qui m'arrivera!"
,"14":"Je vais jouer le tout pour le tout, je mets ma vie dans la balance."
,"15":"Il peut me tuer, je n'ai pas peur, je veux défendre devant lui ma façon de voir."
,"16":"Cela peut-être me sauvera, car un traître n'irait pas se présenter."
,"17":"Ecoutez bien mes paroles, et comprenez mes explications."
,"18":"J'ai mis en forme mes arguments, et je sais que j'ai raison."
,"19":"Si quelqu'un est capable de me répliquer, je n'aurai plus qu'à me taire et mourir."
,"20":"Mais toi, Seigneur, épargne-moi sur deux points, et je ne me cacherai plus devant toi:"
,"21":"que ta main cesse de me frapper, que ta terreur cesse de m'épouvanter."
,"22":"Puis explique-toi et je répondrai, ou c'est moi qui parlerai et tu me reprendras."
,"23":"Combien ai-je de dettes et de fautes?,Fais-moi connaître ma faute et mon péché!"
,"24":"Pourquoi me caches-tu ta face,et me regardes-tu comme ton ennemi?"
,"25":"Aimes-tu effrayer la feuille livrée au vent, persécuter une paille sèche?"
,"26":"Pourquoi alors rédiger contre moi tes griefs,et me reprocher mes fautes de jeunesse?"
,"27":"Tu m'empêches d'aller où je veux, tu surveilles toutes mes démarches,et tu relèves les traces de mes pas!"
}`)
	CurrentBook.AddChapter(14, `{
"1":"L'humain, né de la femme, sa vie est courte, et jamais sans problèmes."
,"2":"Comme la fleur il sort et puis se fane, comme l'ombre il court et jamais ne s'arrête. Il se défait comme un bois vermoulu, comme un habit mangé aux mites."
,"3":"Et c'est sur lui que tu as l'oeil ouvert, c'est lui que tu fais comparaître devant toi?"
,"4":"Qui fera sortir le pur de l'impur?,Personne!"
,"5":"Puisque ses jours lui sont comptés, que de toi dépend le nombre de ses mois, et qu'il ne peut passer le terme fixé par toi,"
,"6":"alors: regarde ailleurs et laisse-le, comme un ouvrier, finir sa journée."
,"7":"Pour l'arbre il y a un espoir: on l'a coupé, il reprendra vie, il ne cessera de pousser des rejets."
,"8":"Sa racine peut vieillir en terre,et son tronc mourir dans le sol,"
,"9":"rien qu'à l'odeur de l'eau il bourgeonne,et comme un jeune plant il refait un feuillage."
,"10":"Mais l'homme aussitôt mort se défait: quand il a expiré, où voudrait-on qu'il soit?"
,"11":"La mer pourrait perdre ses eaux, les fleuves se vider et rester secs,"
,"12":"celui qui gît ne se relèvera pas!,Pas de réveil pour lui tant que durent les cieux, les humains ne sortiront pas de leur sommeil."
,"14a":"S'il était possible qu'un mort revive,"
,"13":"je voudrais que tu me gardes dans le monde d'en-bas, que tu m'y caches, le temps que passe ta colère, et que tu fixes un jour pour te souvenir de moi."
,"14b":"Là-bas, tant que durerait mon service, j'attendrais l'heure de la relève."
,"15":"Alors tu appellerais et je te répondrais, tu viendrais réclamer l'oeuvre de tes mains."
,"16":"Fini le temps où tu comptais tous mes pas: tu ne regarderais plus mes péchés,"
,"17":"tu bouclerais ma faute dans un sac,et blanchirais mes dettes."
,"18":"Mais non! La montagne s'éboule, le rocher cède,"
,"19":"les eaux creusent les pierres, l'averse emporte les terres; et l'espoir de l'homme, tu l'enlèves!"
,"20":"Tu le terrasses: c'est fini, il s'en est allé; tu le défigures et tu l'envoies au diable."
,"21":"Si ses fils sont honorés, il ne le sait pas, s'ils sont méprisés, il n'en a nulle idée:"
,"22":"il n'a de chagrin que pour son propre corps, il n'a plus d'autre deuil que le sien."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Elifaz de Téman prit alors la parole:"
,"2":"Un savoir aussi creux, est-ce la réponse d'un sage: rien qu'un vent d'est, et le voilà rempli!"
,"3":"Il parle, et ce sont des critiques négatives, des mots qui n'apportent rien."
,"4":"Voilà que tu renverses la sainte crainte, tu ne veux plus penser à la manière de Dieu."
,"5":"Ton fond mauvais te fait parler, et te fournit des raisons paradoxales."
,"6":"Ce sont tes mots qui te condamnent, pas moi, ta propre bouche témoigne contre toi!"
,"7":"Es-tu né le premier dans l'espèce humaine, venu au jour quand les montagnes n'étaient pas?"
,"8":"Quand Dieu décidait, étais-tu là pour entendre, as-tu fais main basse sur la sagesse?"
,"9":"Que sais-tu que nous ne sachions?,Comprends-tu des choses qui nous échappent?"
,"10":"Dans notre camp sont nos aînés, les anciens: ils seraient plus âgés que ton père."
,"11":"Tu ne veux donc pas des consolations de Dieu,et des paroles qu'on te dit gentiment?"
,"12":"Pourquoi réagir avec tant de passion, pourquoi ces regards égarés,"
,"13":"pour te défouler contre Dieu,et déblatérer sans aucune retenue?"
,"14":"Un humain pourrait-il prétendre qu'il est pur?,peut-il se justifier, celui qui naît d'une femme?"
,"15":"A ses anges même Dieu ne fait pas confiance; la voûte cristalline n'est pas pure à ses yeux."
,"16":"Que dire de cet être écoeurant, corrompu, qui boit l'injustice comme l'eau?"
,"17":"Ecoute-moi, je veux t'instruire; je vais te raconter ce que j'ai vu."
,"18":"Voici ce qu'enseignent les sages: ce qu'ils nous disent, le tenant de leurs pères,"
,"19":"ces hommes à qui le pays fut donné,loin de toute présence étrangère:"
,"20":"c'est un tourment que la vie du méchant, les années auxquelles a droit le violent."
,"21":"Il entend sans cesse des propos alarmistes: est-il en paix? les pillards vont l'assaillir,"
,"22":"plus moyen d'échapper aux ténèbres, il en est sûr, son destin c'est l'épée,"
,"23":"après quoi il sera la proie des vautours, il sent que le jour fatal est proche: il est là!"
,"24":"Détresse et angoisse: c'est l'épouvante; attaqué par un roi, son mal ne serait pas pire."
,"25":"Mais voilà: il levait le poing contre Dieu, face au Tout-Puissant il jouait au brave."
,"26":"Il s'élançait contre lui, tête baissée, s'abritant derrière un gros bouclier,"
,"27":"on lui voyait une face bouffie, la ceinture alourdie de graisse."
,"28":"Il s'était établi en des villes détruites, avec des maisons où nul n'habite, toujours en danger de s'écrouler."
,"29":"Mais il ne s'y fera pas riche!,Sa fortune ne tiendra pas, il ne couvrira pas le pays de son ombre."
,"30":"Il n'échappera pas aux ténèbres, le feu dessèchera ses tiges vertes, le vent emportera sa fleur."
,"31":"Il a su s'élever: qu'il ne s'y fie pas, nous savons que c'est pure apparence."
,"32":"Ses rejetons se flétriront avant le jour, sa ramure ne reverdira pas."
,"33":"Comme pour la vigne ses fruits verts se perdront, comme l'olivier il laissera tomber ses fleurs."
,"34":"Oui, le parti des impies est stérile, et les corrompus, le feu dévore leurs tentes."
,"35":"Qui a conçu du Mal enfante le malheur; son propre ventre lui mûrit sa déception."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Job prit la parole et dit:"
,"2":"J'ai entendu bien des choses de ce genre: vous êtes de tristes consolateurs!"
,"3":"Ces paroles en l'air vont-elles bientôt finir?,Quel besoin as-tu de discuter ainsi?"
,"4":"Moi aussi, je pourrais parler comme vous,si vous étiez à ma place, et moi à la vôtre. Je pourrais vous accabler de discours, et hocher la tête d'un air entendu."
,"5":"J'en aurais des mots, pour vous réconforter!,je ne m'arrêterais pas."
,"6":"Mais si je parle, ma douleur ne se calme pas, et si je me tais, elle ne s'en va pas."
,"7":"Car déjà la malveillance me pousse à bout, toute cette bande "
,"8":"s'empare de moi. Elle s'est levée pour témoigner contre moi, elle me répond par des calomnies."
,"9":"Dans leur colère ils me déchirent et me poursuivent, ils grincent des dents contre moi: mes adversaires me lancent des regards de haine."
,"10":"Ils me narguent de haut,et leurs insultes m'atteignent comme des gifles; ils m'enserrent à m'étouffer."
,"11":"Oui, Dieu m'a livré à des hommes injustes, il me jette aux mains des méchants."
,"12":"Quand tout allait bien il m'a mis brisé, il m'a pris par la nuque et m'a mis en pièces. Il a fait de moi sa cible."
,"13":"De partout me viennent ses flèches, sans pitié, il me transperce les reins,et ma bile se répand sur le sol."
,"14":"Blessure après blessure, comme un guerrier il ne me lâche pas."
,"15":"J'ai cousu un sac sur ma peau, j'ai plongé mon front dans la poussière."
,"16":"Mon visage est rougi par les larmes, le tour de mes yeux est tout noir."
,"17":"Je n'ai pourtant pas commis de violence, et je priais d'un coeur pur."
,"18":"O terre, ne cache pas mon sang, et que mon cri ne s'arrête pas en chemin!"
,"19":"Mais voici que j'ai un témoin dans les cieux, j'ai là-haut un défenseur."
,"20":"Mon cri parle pour moi auprès de Dieu, tandis que mes larmes coulent devant lui."
,"21":"Ah, si l'homme pouvait discuter avec Dieu, tout comme un être humain fait avec son prochain!"
,"22":"Il me reste bien peu des années de ma vie, et je suis déjà sur le chemin sans retour."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Mon souffle s'est épuisé, mes jours s'éteignent et la tombe m'attend."
,"2":"Ne suis-je pas entouré de moqueurs?,Leurs insolences empoisonnent mes nuits."
,"3":"Garde, Seigneur, auprès de toi ma caution,puisqu'aucun ami ne s'engage pour moi."
,"4":"Tu leur as obscurci la raison, et pas un d'eux ne se risque:"
,"5":"'On ne fait pas, disent-ils, des cadeaux aux amis, pour ensuite laisser ses fils dans la gêne.'"
,"6":"Me voici devenu la risée des gens, l'individu à qui l'on crache au visage."
,"7":"Mes yeux s'obscurcissent de chagrin, je ne suis plus que l'ombre de moi-même."
,"8":"Les hommes droits en restent stupéfaits, les bons voient en moi un méchant et moralisent."
,"9":"Quel exemple pour le juste! il s'encourage, et les gens honnêtes en sont ragaillardis."
,"10":"Mais non, venez tous, reprenez-vous donc!,vous verrez qu'aucun de vous n'est un sage."
,"11":"Mes jours ont passé, mes plans ont été brisés; mon coeur désire "
,"12":"la nuit quand c'est le jour, et quand il fait noir l'approche du jour."
,"13":"Je n'ai plus à attendre ma maison chez les morts: déjà j'ai mis mon lit dans leurs ténèbres."
,"14":"Je dis au tombeau: 'Tu es mon père!',et à la vermine: 'C'est toi ma mère et ma soeur!'"
,"15":"Alors, où est mon espérance, mon bonheur, voyez-vous quelque chose?"
,"16":"Vont-ils descendre avec moi au monde d'en-bas, pour qu'ensemble nous nous trouvions dans la poussière?"
}`)
	CurrentBook.AddChapter(18, `{
"1":"Bildad de Shouah prit alors la parole:"
,"2":"Quand finiras-tu tous ces discours?,Sois raisonnable, et laisse-nous parler."
,"3":"Nous prends-tu pour des bêtes, nous regardes-tu comme des brutes?"
,"4":"Pourquoi te déchirer dans ta fureur?,La terre va-t-elle se perdre pour autant,ou les rochers changer de place?"
,"5":"Mais vois: la lumière du méchant s'éteint, son feu ne jette plus de flammes."
,"6":"La lumière baisse dans sa tente, sa lampe au-dessus de lui s'éteint."
,"7":"Sa démarche alerte devient hésitante, ses propres combines le font tomber."
,"8":"Ses pieds le conduisent vers un filet, ou le précipitent dans la trappe."
,"9":"Un noeud coulant le saisit à la cheville, le collet se resserre sur lui."
,"10":"Une corde, cachée en terre, va le prendre, un piège est sur le sentier pour l'attraper."
,"11":"Des dangers de tous côtés le menacent, et le suivent à la trace."
,"12":"La famine ne le quitte plus, le malheur se tient à ses côtés."
,"13":"Un mal ronge sa chair, une peste mortelle lui dévore les membres."
,"14":"On l'arrache au refuge de sa tente, il est bon pour aller vers le Roi des enfers."
,"15":"Installe-toi dans sa tente, elle n'est plus à lui; on répand du souffre sur son domaine."
,"16":"Ses racines en bas se dessèchent, et par le haut sa ramure se flétrit."
,"17":"On ne se souvient plus de lui dans le pays, il n'a laissé son nom sur rien."
,"18":"On le remise de la lumière aux ténèbres, il est expulsé du monde."
,"19":"Dans son peuple il n'a laissé, ni enfants ni suivants, de son campement, nul n'a survécu."
,"20":"Tout l'Occident s'étonne de son sort, tous en Orient sont saisis d'effroi."
,"21":"Voilà pour les demeures des méchants, voilà pour la contrée qui veut ignorer Dieu!"
}`)
	CurrentBook.AddChapter(19, `{
"1":"Job prit la parole et dit:"
,"2":"Combien de temps encore allez-vous me fatiguer, et m'assommer à force de paroles?"
,"3":"Dix fois déjà vous m'avez insulté, n'avez-vous pas honte de me maltraiter?"
,"4":"Si réellement je me suis trompé, mon péché ne regarde que moi."
,"5":"Mais vous me regardez de haut: voilà la vérité, et vous me reprochez mon malheur."
,"6":"Sachez que Dieu me traite injustement,et qu'il a jeté sur moi ses filets."
,"7":"Je crie à la violence, pas de réponse, j'appelle au secours, personne pour me défendre!"
,"8":"Il a barré ma route, je n'ai plus de passage, il a mis sur mon chemin les ténèbres."
,"9":"Il m'a privé de ma gloire, il a ôté de ma tête la couronne,"
,"10":"Il me descelle tout autour et me fait partir, il déracine mon espérance."
,"11":"Il décharge sur moi sa colère, il me traite en ennemi."
,"12":"Toutes ses troupes arrivent à la fois, elles se frayent un chemin jusqu'à moi, elles font le siège de ma demeure."
,"13":"Il a éloigné de moi mes frères, mes connaissances cherchent à m'éviter."
,"14":"Mes proches, mes compagnons ne me voient plus, les hôtes de ma maison m'ont oublié."
,"15":"Mes servantes me sont devenues étrangères, comme si pour elles j'étais un inconnu."
,"16":"J'appelle mon serviteur, il ne me répond pas,lorsque je vais jusqu'à le supplier."
,"17":"Mon haleine répugne à ma femme, mes propres frères sont dégoûtés de moi."
,"18":"Les gamins eux-mêmes me méprisent, si je me lève ils se moquent de moi."
,"19":"Tous mes intimes maintenant me détestent, ceux que j'aimais se sont retournés contre moi."
,"20":"Sous ma peau ma chair a pourri, mes os se dénudent comme des dents:"
,"21":"Pitié! Pitié pour moi, ô vous, mes amis: c'est la main de Dieu qui m'a frappé!"
,"22":"Faut-il me persécuter parce que Dieu le fait?,n'en avez-vous pas assez de me dévorer?"
,"23":"Ah, je voudrais qu'on écrive mes paroles, et qu'on les grave sur du bronze"
,"24":"avec un ciseau de fer, un burin, et qu'elles soient pour toujours inscrites dans la pierre."
,"25":"Je sais que mon libérateur est vivant, et qu'à la fin il se présentera sur terre."
,"26":"Alors je me mettrai debout derrière ma peau, et de ma chair je verrai Dieu!"
,"27":"Je le verrai, moi, le même, et c'est lui que mes yeux verront, pas un autre: mon coeur déjà s'épuise dans cette attente."
,"28":"Mais vous en êtes à dire: 'Comment l'attaquer?,trouvons-lui quelque parole à reprendre'."
,"29":"Alors craignez que l'épée ne vous frappe, car la Colère s'enflamme contre les fautes, et vous saurez qu'il y a une justice!"
}`)
	CurrentBook.AddChapter(20, `{
"1":"Sofar de Nahama prit alors la parole:"
,"2":"Ceci justifie mes réflexions: je veux répondre,et dire tout ce que je sens."
,"3":"Quand on me remet en place de façon humiliante, mes pensées m'inspirent une réponse."
,"4":"Ne sais-tu pas que depuis toujours, depuis que l'homme a été mis sur terre,"
,"5":"le triomphe des méchants est de courte durée,la joie de l'impie n'est que d'un instant."
,"6":"Sa taille a beau s'élever jusqu'au ciel, et sa tête toucher les nuages,"
,"7":"comme un fantôme il disparaît pour toujours, et ceux qui le voyaient demandent: 'Où est-il?'"
,"8":"C'est comme un rêve envolé: on ne le trouve plus, comme un fantasme de la nuit: il a fui."
,"9":"On s'était habitué à le voir: c'est fini, les lieux qu'il fréquentait ne le reverront plus."
,"11":"Sa carcasse était pleine de force juvénile, la voilà couchée avec lui dans la poussière!"
,"12":"Sa bouche savourait le mal, il le cachait sous sa langue,"
,"13":"il l'aimait tant qu'il ne le lâchait pas,mais le gardait sous son palais..."
,"14":"Mais cette nourriture se change en ses entrailles, elle devient un poison dans son ventre:"
,"15":"le voici qui vomit les richesses dévorées, Dieu les fait ressortir de son ventre."
,"16":"Il suçait du venin de serpent: c'est une morsure de vipère qui le tue!"
,"17":"Il ne reverra pas les ruisseaux d'huile fraîche, les torrents de miel et de crème."
,"18":"Il lui faut rendre son gain: il n'a pu l'avaler; les fruits de son commerce ne seront pas pour lui."
,"19":"C'est qu'il opprimait les pauvres, il volait la maison au lieu de la bâtir."
,"10":"Ses fils rembourseront les pauvres, de ses mains, peut-être, il redonnera sa fortune."
,"20":"Sa cupidité n'était jamais satisfaite, on ne se sauvait pas de son appétit:"
,"21":"il dévorait et nul n'y échappait. C'est pourquoi son bonheur n'a pas duré."
,"22":"En pleine réussite, les problèmes l'assaillent, et le malheur le frappe à coups redoublés."
,"23":"Alors qu'il est en train de se remplir le ventre, Dieu décharge sur lui sa colère,et fait pleuvoir sur lui ses flèches."
,"24":"Echappe-t-il à la lame de fer?,l'arc de bronze le transperce!"
,"25":"La flèche est ressortie par son dos, la pointe a traversé son foie: le voilà sous le coup d'une angoisse de mort,"
,"26":"et son destin, ce sont les ténèbres. Un feu que nul n'a allumé le dévore,et consume les survivants de sa tente."
,"27":"Les cieux ont dévoilé ses crimes, et la terre se soulève contre lui."
,"28":"L'inondation emporte sa maison: ce sont les eaux de la colère de Dieu."
,"29":"Voilà le sort que Dieu réserve au méchant, l'héritage que Dieu lui promet."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Job reprit et dit:"
,"2":"Ecoutez du moins mes paroles, cela vaudra mieux que de me consoler."
,"3":"Accordez-moi un peu la parole: tu te moqueras après que j'aurai parlé."
,"4":"Est-ce d'un humain que je me plains?,Alors, n'ai-je pas raison d'être nerveux?"
,"5":"Tournez-vous vers moi: j'ai de quoi vous étonner, et vous mettrez la main sur la bouche."
,"6":"Ce sont des choses qui m'épouvantent quand j'y songe, et j'en tremble de tout mon corps."
,"7":"Pourquoi les méchants restent-ils en vie?,Ils font de vieux os et gagnent en pouvoir."
,"8":"Leur famille à leur côté prospère, leurs petits-enfants se multiplient sous leurs yeux."
,"9":"On vit bien dans leurs maisons: pas de soucis, les coups de Dieu ne sont pas pour eux."
,"10":"Leur taureau féconde à chaque fois, leur vache met bas sans jamais avorter."
,"11":"Ils ont des gamins comme ils ont des agneaux, ils voient s'ébattre leurs enfants:"
,"12":"ils jouent du tambourin et de la guitare, ils dansent au son de la flûte."
,"13":"Leurs jours s'achèvent dans le bonheur, ils descendent sans drame au séjour des morts."
,"14":"Et c'étaient eux qui disaient à Dieu: 'Va-t-en!,Nous ne voulons pas connaître tes volontés!"
,"15":"Pourquoi faudrait-il servir le Puissant, et qu'est-ce qu'on gagne à l'invoquer?'"
,"16":"Ne sont-ils pas maîtres de leur bonheur, alors même qu'ils ont tout décidé sans Dieu?"
,"17":"Voit-on souvent s'éteindre la lampe des méchants, le malheur fondre sur eux,et la colère d'en-haut détruire les malfaisants?"
,"18":"Sont-ils vraiment la paille qu'emporte le vent, la feuille sèche livrée au tourbillon?"
,"19":"Dieu, dites-vous, fera payer pour lui ses fils?,Qu'il le fasse payer lui, et qu'il le sente!"
,"20":"Qu'il voie le malheur de ses propres yeux, qu'il boive la colère du Tout-Puissant!"
,"21":"Qu'a-t-il à faire de sa famille après lui, quand on a mis un terme au compte de ses mois?"
,"22":"Faut-il faire la leçon à Dieu, à celui qui juge les êtres supérieurs?"
,"23":"L'un meurt en pleine vigueur, heureux et prospère,"
,"24":"les flancs bien grassouillets, les os remplis de sève."
,"25":"Un autre meurt dans la tristesse, sans avoir jamais savouré le bonheur."
,"26":"Ensemble ils se couchent dans la poussière, où les vers vont grouiller sur eux."
,"27":"Oh, je devine vos pensées, et ces idées que vous vous faites sur moi."
,"28":"Vous dites: 'Où est la maison du potentat, où est la tente des méchants?'"
,"29":"N'avez-vous pas interrogé ceux qui voyagent, ne retenez vous pas leurs témoignages?"
,"30":"Au jour du malheur le méchant est épargné, au jour de la colère il échappe."
,"31":"Qui ose lui reprocher, en face, sa conduite,et lui rendre ce qu'il a fait?"
,"32":"Voici qu'on l'escorte au cimetière, et de bien haut son image regarde."
,"33":"La terre prise au torrent lui est douce, les gens défilent en avant, et derrière lui c'est un peuple sans nombre."
,"34":"Allez-vous me consoler avec du vent, avec des réponses où tout est illusoire?"
}`)
	CurrentBook.AddChapter(22, `{
"1":"Elifaz de Téman prit alors la parole:"
,"2":"Qu'est-ce qu'un homme peut apporter à Dieu?,L'homme de bon sens n'est utile qu'à lui-même."
,"3":"Qu'importe au Tout-Puissant que tu aies tes raisons?,Que gagne-t-il si tu te vois parfait?"
,"4":"Est-ce pour ta piété que Dieu te corrige,et qu'il te fait un procès?"
,"5":"N'est-ce pas plutôt que ta méchanceté est grande,et tes fautes innombrables?"
,"6":"Sans motif tu exigeais de tes frères des gages, il restaient nus car tu prenais leur manteau!"
,"7":"Tu ne donnais pas à boire à l'assoiffé, à l'affamé tu refusais le pain."
,"8":"Qu'arrive un homme fort, il s'empare des terres, et les gens en place s'y installent."
,"9":"Tu renvoyais les veuves les mains vides,et tu brisais les bras de l'orphelin."
,"10":"C'est pourquoi te voilà entouré de pièges, paralysé soudain par la peur."
,"11":"La lumière s'est éteinte et tu ne vois plus, les eaux en crue t'ont submergé."
,"12":"Bien sûr, Dieu est très haut dans les cieux: vois comme les étoiles sont hautes!"
,"13":"Mais alors tu as dit 'Qu'est-ce que Dieu sait?,Pourra-t-il juger à travers les nuages?"
,"14":"Les nuées font écran et il ne voit pas; il reste à se promener au pourtour des cieux.'"
,"15":"Veux-tu donc retomber dans les vieux chemins,où s'avançaient les habitués du mal?"
,"16":"Un instant a suffi pour les balayer, le crue des eaux emporta leurs fondations!"
,"17":"Car ils disaient à Dieu: 'Tiens-toi à l'écart!,Que peut nous faire le Tout-Puissant?'"
,"18":"C'est lui qui remplissait leurs maisons de richesses, mais les méchants prenaient leurs décisions sans lui."
,"19":"Les justes le voient et se réjouissent, l'homme intègre se moque d'eux:"
,"20":"'Leur fortune est anéantie, le feu a dévoré tout ce qu'ils possédaient!'"
,"21":"Allons, rapproche-toi de lui, fais la paix, c'est le moyen de relever ta fortune."
,"22":"Reçois de sa bouche son instruction, et garde en ton coeur ses paroles."
,"23":"Reviens humblement vers le Tout-Puissant, éloigne de ta tente ce qui est injustice,"
,"24":"ne fais pas plus de cas de l'or que de la terre, de l'or d'Ophir que des pierres du torrent."
,"25":"Le Puissant aussitôt se fera ton or, ta montagne d'argent."
,"26":"Tu trouveras ta joie dans le Tout-Puissant, tu lèveras vers lui ton regard."
,"27":"Tu l'invoqueras et il t'exaucera; si tu fais un voeu, tu n'auras plus qu'à t'acquitter."
,"28":"Tu feras des projets, ils réussiront, la lumière brillera sur tous tes chemins."
,"29":"Car Dieu abaisse l'orgueilleux,et sauve celui qui tient les yeux baissés."
,"30":"Il délivre l'innocent: si tu as les mains pures, tu seras sauvé!"
}`)
	CurrentBook.AddChapter(23, `{
"1":"Job prit alors la parole:"
,"2":"Aujourd'hui encore ma plainte est rebelle: ma main ne peut la bloquer dans ma bouche!"
,"3":"Ah, si je savais où le trouver, j'irais jusqu'à sa demeure!"
,"4":"J'exposerais ma cause devant lui, je lui dirais tous mes arguments."
,"5":"Je verrais ce qu'il me répondrait,et je pourrais comprendre sa réponse."
,"6":"Mettrait-il toute sa force dans le débat?,Non! Lui m'écouterait."
,"7":"Il verrait l'innocence de celui qui l'attaque, et je serais pour toujours libéré de mon juge."
,"8":"Mais je peux aller à l'orient, il n'y est pas, à l'occident, je ne l'y verrai pas!"
,"9":"J'ai cherché au nord sans le trouver, retournant au midi je ne l'ai pas vu."
,"10":"Il me connaît pourtant, que je marche ou m'arrête: s'il m'éprouve au creuset, je passerai avec l'or."
,"11":"Car j'ai maintenu mon pied sur son sentier, j'ai suivi sa route, je n'en suis pas sorti."
,"12":"Je n'ai pas ignoré ses commandements, j'ai gardé en moi toutes ses paroles."
,"13":"Mais s'il veut quelque chose, qui l'en empêchera?,Ce qu'il a désiré, il le fera."
,"14":"Il fera jusqu'au bout ce qu'il a décrété, ce ne sera qu'une fois de plus."
,"15":"Voilà pourquoi il m'effraie; quand j'y pense, j'ai peur de lui."
,"16":"Mais si Dieu me fait perdre coeur, si le Puissant me terrifie,"
,"17":"je ne me suis pas tu pour autant dans le noir, en dépit des ténèbres qui voilent mon visage."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Le Puissant n'aura-t-il pas son heure?,Ses fidèles ne verront-ils jamais venir son jour?"
,"2":"Les méchants déplacent les bornes,et font paître des troupeaux volés."
,"3":"Ils emmènent l'âne des orphelins,et confisquent le boeuf de la veuve."
,"9":"Ils enlèvent l'orphelin à sa nourrice,et prennent en gage le nourrisson du pauvre."
,"4":"Les pauvres ont à s'écarter du chemin, les humbles du pays, quels qu'ils soient, se cachent."
,"5":"Comme les ânes du désert ils sortent,dès le matin en quête de nourriture: au soir ils n'y a pas de pain pour leurs enfants."
,"6":"De nuit ils moissonnent dans les champs,ou récoltent dans la vigne du méchant."
,"7":"Ils passent la nuit nus, sans vêtements, sans couverture contre le froid."
,"8":"Trempés par les averses de montagne, faute d'abri ils se serrent contre le rocher."
,"10":"Ils vont et viennent, nus et sans vêtement, ils portent les gerbes, mais ils sont affamés."
,"11":"Ils écrasent les olives entre les meules, ils foulent dans la cuve les grappes, mais ils ont soif."
,"12":"Dans la ville les mourants gémissent,les blessés appellent au secours, mais Dieu n'entend pas leur prière!"
,"13":"Tous ceux-là sont de ceux qui haïssent la lumière, ils n'ont pas reconnu ses chemins,et ne reviendront pas par ses sentiers."
,"14a":"Avant le jour l'assassin s'est levé, pour tuer le pauvre et l'indigent;"
,"14c":"Le voleur rôde dans la nuit;"
,"15":"mais déjà l'adultère attend l'ombre du soir: 'Que nul oeil ne me voie!' se dit-il, et il met une étoffe sur son visage."
,"16":"de jour il avait repéré les maisons, dans l'obscurité il les force."
,"17":"L'heure sombre, pour eux, c'est le matin; quand il brille, c'est alors qu'ils ont peur."
,"18":"Ils sont comme l'écume à la surface des eaux,et dans le pays on maudit leur domaine, on évite de traverser leurs vignes."
,"19":"Comme la chaleur dessèche les eaux de neige, le royaume des morts absorbe le pécheur."
,"20":"Le sein qui l'a formé l'oublie, nul ne rappelle son nom: l'injustice déjà n'est qu'un arbre brisé."
,"21":"Il maltraitait la femme sans enfants, il ne faisait aucun bien à la veuve."
,"22":"Mais quand le Puissant s'en prend aux grands seigneurs, quand il se lève, leur vie même n'est plus sûre."
,"23":"Il les laissait confiants en leur sécurité, mais ses yeux veillaient sur leurs actes."
,"24":"Un moment ils ont été grands, et puis plus rien. Ils retombent comme les herbes cueillies, ils se fanent comme la tête des épis."
,"25":"Si tout cela n'est pas vrai, prouvez que j'ai menti: qui réfutera mes paroles?"
}`)
	CurrentBook.AddChapter(25, `{
"1":"Bildad de Shouah prit alors la parole:"
,"2":"Il a de quoi s'imposer et faire trembler, il fait régner la paix au plus haut des cieux!"
,"3":"Qui pourrait compter ses armées, sur qui sa lumière ne se lève-t-elle pas?"
,"4":"Un humain sera-t-il juste devant Dieu?,né de la femme, sera-t-il sans reproche?"
,"5":"Même la lune est pour lui sans éclat, et les étoiles lui paraissent bien pâles,"
,"6":"que dire alors des humains, cette vermine, du fils d'un homme, ce ver de terre!"
}`)
	CurrentBook.AddChapter(26, `{
"1":"Job prit la parole et dit:"
,"2":"Comme tu sais bien venir en aide au faible, encourager celui à qui tombent les bras!"
,"3":"Comme tu sais conseiller un ignorant, tu as vraiment réponse à tout!"
,"4":"Mais, au fait, pour qui ces paroles?,Qui te pousse à parler ainsi?"
,"5":"Au monde d'en-bas les Ombres tremblent, les océans s'effrayent avec leurs habitants;"
,"6":"le royaume des morts est à nu devant lui, la Mort en personne ne peut se cacher."
,"7":"Il a fixé le pôle céleste au dessus du vide,et suspendu la terre sur rien."
,"8":"Il enferme les eaux dans ses nuages, et la nuée ne crève pas sous leur poids."
,"9":"Il cache le visage de la pleine lune, déployant sur elle les nues."
,"10":"Il a tracé l'horizon sur la face des eaux, pour séparer la lumière des ténèbres."
,"11":"Les colonnes des cieux se mettent à trembler, elles s'épouvantent s'il les menace."
,"12":"Il a eu la force pour fendre la mer, l'intelligence, pour écraser son dragon."
,"13":"Par son souffle le ciel est nettoyé, sa main a percé le Serpent qui toujours fuit."
,"14":"Mais ce n'est là que l'extérieur de ses oeuvres, nous n'en percevons que les échos. Qui comprendra lorsque tonne sa puissance?"
}`)
	CurrentBook.AddChapter(27, `{
"1":"Et Job continua à parler en ces termes:"
,"2":"Par le Dieu vivant qui me refuse jus tice, par le Tout-Puissant qui m'a plongé dans la peine,"
,"3":"tant que je pourrai respirer, gardant en mes narines le souffle de Dieu,"
,"4":"je ne dirai rien de mal, pas un mensonge ne sortira de ma bouche!"
,"5":"Jamais je ne vous donnerai raison, et jusqu'à ma mort je défendrai mon innocence."
,"6":"Je maintiens que j'ai bien agi, je n'en démords pas, je n'ai pas à rougir de ma vie!"
,"7":"Que mon ennemi soit reconnu coupable, que mon adversaire ait le sort du méchant!"
,"8":"Que peut espérer l'impie lorsqu'il prie, lorsqu'il élève son âme vers Dieu?"
,"9":"Dieu entendra-t-il son cri,lorsque le malheur viendra sur lui?"
,"10":"Est-ce qu'il se plaisait auprès du Tout-Puissant, invoquait-il Dieu à tout moment?"
,"11":"Voyez, je vous montre comment agit Dieu, je ne vous cache pas les manières du Tout-Puissant."
,"12":"Vous tous vous l'avez constaté, alors, pourquoi tourner en rond sans profit?"
,"13":"Voici le sort que Dieu réserve au coupable, l'avenir que le Puissant réserve aux oppresseurs."
,"14":"Leurs fils peuvent se multiplier, l'épée les attend, leurs descendants manqueront de pain."
,"15":"La peste emportera les survivants, et leurs veuves ne pourront pas les pleurer."
,"16":"Le méchant peut ramasser l'argent comme poussière, mettre en tas les vêtements comme la boue,"
,"17":"accumuler, oui! mais c'est un juste qui s'en habille, c'est un homme intègre qui hérite de son argent."
,"18":"Il s'est bâti une maison, ce n'est qu'un nid, sa hutte ne vaut guère que pour un gardien."
,"19":"Il s'est couché riche, c'était la dernière fois; quand il ouvre les yeux il n'est plus rien."
,"20":"Tout le jour des terreurs l'ont tourmenté: un tourbillon l'emporte durant la nuit."
,"21":"Le vent d'est le soulève: le voilà parti, il a été soufflé de là où il était."
,"22":"Sans pitié on lui jette des pierres, il ne peut fuir devant la main qui le frappe."
,"23":"On applaudit à sa ruine, on le conspue partout où il va."
}`)
	CurrentBook.AddChapter(28, `{
"1":"Il y a des mines pour l'argent, et des endroits où l'on sait raffiner l'or."
,"2":"C'est du sol qu'on extrait le fer, on tire le cuivre de la roche en fusion."
,"3":"On est venu mettre fin aux ténèbres, on a fouillé toujours plus loin,dans la roche obscure et les ombres de mort."
,"4":"Un peuple étranger a ouvert des passages,dans l'inconnu où nul n'avait pénétré: suspendus, ils se balancent très loin des humains."
,"5":"C'est la terre d'où sort le pain, mais en-dessous le feu l'a transformée;"
,"6":"c'est le domaine des pierres de saphir, là se trouvent les paillettes d'or."
,"7":"Sentier inconnu des rapaces, que l'oeil du vautour n'a pas repéré,"
,"8":"où les bêtes féroces n'ont pas pénétré, que le léopard n'a pas suivi."
,"9":"Mais on s'est attaqué au granit, l'homme a violé les fondations de la montagne."
,"10":"On a creusé des canaux dans le roc, et l'oeil humain a vu tout ce qui est rare;"
,"11":"on a exploré les sources des fleuves, ramené à la lumière ce qui était caché."
,"12":"Mais la Sagesse, d'où sort-elle?,Y a-t-il un lieu de l'Intelligence?"
,"13":"L'homme n'en connaît pas le chemin, on ne la trouvera pas sur la terre des vivants."
,"14":"Le monde d'en-bas l'a dit: 'Elle n'est pas chez moi!', la mer l'a dit: 'Je ne l'ai pas ici!'"
,"15":"Offre de l'or, on ne te la donnera pas, elle ne se paye pas en argent pesé."
,"16":"On ne l'évalue pas au prix de l'or d'Ophir, du diamant ou des saphirs,"
,"17":"Ni l'or ni le cristal ne lui sont comparables, aucun vase d'orfèvre n'atteint sa valeur;"
,"18":"le corail et le verre, n'en parlons pas!,Vous cherchez des perles? mieux vaut la sagesse."
,"19":"La topaze d'Ethiopie ne tient pas devant elle, l'or pur se retrouve sans valeur."
,"20":"Mais d'où vient la Sagesse?,Y a-t-il un lieu de l'Intelligence?"
,"21":"Elle est cachée aux yeux de tous les vivants, elle se dissimule aux oiseaux du ciel."
,"22":"Le monde des morts, la Mort en personne l'ont dit: 'C'est une chose dont on nous a parlé!'"
,"23":"Mais le chemin vers elle, Dieu le connaît; il sait où la trouver,"
,"24":"lui qui observe jusqu'aux confins du monde, et voit tout ce qui est sous les cieux."
,"25":"Lorsqu'il déterminait la force du vent,et mesurait la profondeur des eaux,"
,"26":"lorsqu'il fixait le régime des pluies,et l'extension des échos du tonnerre,"
,"27":"c'est alors qu'il l'a vue et analysée, qu'il l'a mise en place en lui donnant son prix."
,"28":"Puis il a dit aux hommes: 'Craindre le Seigneur, voilà la sagesse! S'écarter du mal, voilà l'intelligence!')"
}`)
	CurrentBook.AddChapter(29, `{
"1":"Alors Job reprit son discours de sagesse:"
,"2":"Que ne puis-je revenir aux lunes d'autrefois, aux jours où Dieu veillait sur moi,"
,"3":"quand brillait sa lampe au dessus de ma tête,et qu'à sa lumière je traversais les ténèbres!"
,"4":"Comme je voudrais retrouver mon âge mûr, lorsque Dieu protégeait ma tente,"
,"5":"lorsque le Puissant était encore avec moi, et que mes garçons se tenaient autour de moi,"
,"6":"lorsque mes pieds baignaient dans la crème,et que l'huile pour moi ruisselait de la roche!"
,"7":"Quand j'allais à la Porte, au haut de la cité, j'installais mon siège sur la place."
,"8":"A ma vue les jeunes s'écartaient, les personnes d'âge se mettaient debout,"
,"9":"les chefs interrompaient leurs discours,et tenaient la main sur leur bouche;"
,"10":"les princes baissaient la voix,et devenaient comme muets."
,"11":"Celui qui m'écoutait me félicitait, celui qui me voyait m'approuvait."
,"12":"Car je délivrais le pauvre qui appelle, l'orphelin et celui qui n'a pas d'appui."
,"13":"A moi la bénédiction du désespéré!,je rendais la joie au coeur de la veuve."
,"14":"Je faisais de la justice mon vêtement, la droiture était mon manteau, mon turban."
,"15":"J'étais les yeux de l'aveugle, et le pied du boiteux c'était encore moi."
,"16":"J'étais un père pour les pauvres, je défendais la cause de l'étranger."
,"17":"Je brisais les crocs du criminel, et d'entre ses dents je faisais tomber sa proie."
,"18":"Aussi je pensais: 'Je mourrai déjà vieux, mes jours seront nombreux comme les grains de sable."
,"19":"Mes racines s'allongent vers les eaux, et sur mon feuillage la rosée se dépose."
,"20":"Ma gloire, tout comme moi se garde neuve,mon arc dans ma main reste vert.'"
,"21":"Ils m'écoutaient et ne bronchaient pas, ils se taisaient attendant mon avis."
,"22":"Quand j'avais parlé, nul ne répliquait; mon discours tombait sur eux goutte à goutte:"
,"23":"c'était la pluie qu'ils attendaient, l'averse de printemps qui calmait leur soif."
,"24":"Si je leur souriais, ils n'osaient y croire, ils ne perdaient rien de mes signes de bonne humeur."
,"25":"Je prenais la tête et leur montrais un chemin; j'étais comme le roi au milieu de ses troupes, je les menais à mon gré."
}`)
	CurrentBook.AddChapter(30, `{
"1":"Et maintenant ils se moquent de moi, des jeunes dont je méprisais les pères: ils étaient moins pour moi que les chiens de mon troupeau!"
,"2":"Qu'aurais-je fait de leurs mains: ils n'avaient plus la moindre force,"
,"3":"épuisés par la faim et le manque de tout. Ils rongeaient les racines de la steppe, des terres lugubres et désolées."
,"4":"Ils cueillaient les herbes des broussailles, n'ayant de pain que les racines de genêt."
,"5":"La société les repoussait, on criait sur eux comme sur un voleur."
,"6":"Ils demeuraient au flanc des ravins, dans les trous du sol et les rochers."
,"7":"Ils glapissaient entre les buissons, ils s'entassaient sous les épineux,"
,"8":"C'étaient des gens de rien, qui n'avaient pas un nom, ils étaient rejetés du pays."
,"9":"Mais maintenant ils me chansonnent, c'est de moi qu'ils se moquent."
,"10":"Dégoûtés, ils se tiennent à distance, et sans se gêner ils crachent à mon passage."
,"11":"Du jour qu'il a brisé ma force et m'a humilié, ils ont perdu toute retenue en ma présence."
,"12":"A ma droite se lèvent des accusateurs, mes pieds sont pris au filet, voici qu'on se fraye un chemin jusqu'à moi."
,"13":"Ils m'ont coupé la retraite, ils montent à l'assaut, et personne ne les arrête!"
,"14":"Ils ont forcé le passage: les voilà!,ils se glissent sous les décombres."
,"15":"Les terreurs fondent sur moi; comme un vent elles emportent ma dignité, mon bien-être est passé comme un nuage!"
,"16":"Et maintenant, mon âme en moi se défait, les jours de peine se sont abattus sur moi."
,"17":"La nuit le mal ronge mes os, mes nerfs n'ont pas de repos."
,"18":"De toute sa poigne il a saisi mon vêtement, il m'a pris par le col de ma tunique"
,"19":"et il m'a jeté dans la boue: je ne suis plus que poussière et cendre!"
,"20":"Tu ne me réponds pas, ô Dieu, quand je t'appelle, je me tiens là et tu ne me regardes pas!"
,"21":"Tu es devenu cruel avec moi, tu me frappes de toute ta vigueur!"
,"22":"Tu m'as fait monter le vent, il m'emporte au galop, puis un orage me défait."
,"23":"Oui, je sais, tu me ramènes à la mort, au lieu de rendez-vous de tout être vivant."
,"24":"Mais je ne portais pas la main sur le pauvre, lorsque dans sa détresse il criait vers moi."
,"25":"J'ai pleuré avec ceux qui voient de durs moments, Mon coeur ne s'est-il pas ému pour l'indigent?"
,"26":"J'attendais le bonheur, et le mal est venu; j'espérais la lumière, et tout devient obscur."
,"27":"Mon intérieur bouillonne et ne peut se calmer, les jours de détresse sont venus à ma rencontre."
,"28":"Je vais la peau brûlée, mais non par le soleil; dans l'assemblée j'ai voulu parler: c'était un cri!"
,"29":"Me voici devenu le frère des chacals, le familier des autruches."
,"30":"Ma peau a noirci et pèle, mes os sont brûlants de fièvre."
,"31":"Ma guitare a pris le deuil, ma flûte s'est mise au diapason des pleureurs."
}`)
	CurrentBook.AddChapter(31, `{
"1":"J'avais imposé une règle à mes yeux, que jamais ils ne s'arrêtent sur une vierge."
,"2":"Car, que nous enverra Dieu, de ses hauteurs, quel est le sort que nous prépare là-haut le Puissant?"
,"3":"N'est-ce pas le malheur pour le méchant, les épreuves pour les malfaisants?"
,"4":"N'a-t-il donc pas vu ma conduite?,N'a-t-il pas noté toutes mes démarches?"
,"5":"Ai-je vécu dans le mensonge, me suis-je affairé pour tromper les autres?"
,"6":"Qu'il me pèse sur la balance de la justice!,Dieu, saura que je suis sans reproches."
,"7":"Mes pas ont-ils dévié du droit chemin, me suis-je laissé mener par mes désirs, ai-je trempé dans des affaires sales?"
,"8":"Alors, qu'un autre dévore ce que j'ai semé, que soient déracinés mes rejetons!"
,"9":"Me suis-je égaré pour une femme, ai-je fait le guet à la porte de mon prochain?"
,"10":"Que ma femme, alors, tourne la meule pour d'autres, et qu'un autre couche avec elle!"
,"11":"Car c'est une chose honteuse, un crime détestable.)"
,"12":"Car j'aurais allumé le feu qui dévore, qui consumerait mes biens jusqu'à ma perte."
,"13":"Ai-je méprisé les droits de mon serviteur,ou de ma servante en conflit avec moi?"
,"14":"Que ferais-je alors au tribunal de Dieu, que lui répondrais-je quand il m'interrogera?"
,"15":"Il m'a pétri dans le sein de ma mère, eux de même, un seul Dieu nous a tous formés dans le ventre."
,"16":"Ai-je refusé aux pauvres ce qu'ils désiraient, ai-je laissé la veuve attendre en vain?"
,"17":"Ai-je mangé mon pain tout seul,sans que l'orphelin en ait sa part?"
,"18":"Tout jeune encore je me faisais son père,dès ma plus tendre enfance j'assistais la veuve."
,"19":"A peine voyais-je un pauvre à demi nu, un miséreux sans rien pour se couvrir,"
,"20":"qu'il se réchauffait sous la laine de mes bêtes, et de tout son corps il me bénissait."
,"21":"Si j'ai fait un jour violence à l'orphelin, fort de mes appuis auprès des notables,"
,"22":"que mon épaule alors se détache du tronc, que mon bras se brise au coude!"
,"23":"Car je redoute les punitions de Dieu, et je ne pourrais rien face à sa majesté."
,"24":"Ai-je mis ma confiance dans l'or, ai-je dit: 'Avec toi, mon ami, je suis tranquille'?"
,"25":"Etait-ce mon orgueil d'avoir tant de richesses,et de m'être monté une telle fortune?"
,"26":"Quand je voyais le soleil en son éclat, la marche de la lune radieuse au firmament,"
,"27":"me suis-je secrètement laissé séduire?,ai-je baisé ma main comme on fait pour un dieu?"
,"28":"Cela encore serait un crime détestable, car j'aurais renié le Dieu Très-haut."
,"29":"Me suis-je réjoui du malheur de mon ennemi, ai-je dansé de joie quand l'épreuve le frappait?"
,"30":"Non, je n'ai pas permis que ma bouche faute,en lui souhaitant la mort!"
,"31":"Tous disaient dans ma tente: 'A qui n'a-t-il pas donné, largement, sa viande?'"
,"32":"L'étranger ne passait pas la nuit dehors, car j'ouvrais mes portes au voyageur."
,"33":"Ou bien aurais-je, c'est humain, caché mes fautes,et refusé de reconnaître mes torts?"
,"34":"Ai-je alors vécu craignant les rumeurs, redoutant le mépris des familles, m'enfermant chez moi dans le silence?"
,"35":"Ah! qui me donnera d'être entendu?,Je le signe: que le Puissant maintenant me réponde, que l'adversaire écrive son réquisitoire:"
,"36":"je le porterai sur ma poitrine, je m'en ferai des couronnes."
,"37":"Je lui rendrai compte de tous mes pas, je me présenterai chez lui comme un prince."
,"38":"Si ma terre a crié vengeance contre moi, et qu'avec elle mes sillons ont pleuré,"
,"39":"parce que j'en mangeais sans avoir rien payé, et suçais jusqu'au sang de ses travailleurs,"
,"40":"qu'ils donnent désormais, non du blé mais des ronces, et de la mauvaise herbe à la place de l'orge!,Fin des paroles de Job."
}`)
	CurrentBook.AddChapter(32, `{
"1":"Alors ces trois hommes (Elifaz, Bildad et Sofar) cessèrent de répondre à Job, car il persistait à se considérer comme innocent."
,"2":"Mais Elihou, le fils de Barakel, se mit en colère. Cet homme était de la tribu de Bouz et de la famille de Ram. Il se mit en colère contre Job qui prétendait avoir raison contre Dieu,"
,"3":"mais aussi contre ses trois amis, parce qu'ils n'avaient pas trouvé de réponse, et qu'ils avaient ainsi donné tort à Dieu."
,"4":"Elihou s'était tu pendant qu'ils parlaient avec Job, car ils étaient plus âgés que lui."
,"5":"Mais quand Elihou vit qu'aucun des trois n'avait plus rien à répondre, il se mit en colère."
,"6":"Elihou, fils de Barakel, de la tribu de Bouz, prit donc la parole: Je suis jeune encore et vous êtes âgés; c'est pourquoi j'étais intimidé, craintif, et je n'osais communiquer mon savoir."
,"7":"Je me disais: 'L'âge parlera, beaucoup d'années sont une garantie de sagesse!'"
,"8":"Mais non, elle est dans l'homme un fruit de l'esprit, un souffle du Puissant nous donne de comprendre."
,"9":"Les plus anciens ne sont pas les plus sages, l'âge ne suffit pas pour discerner le vrai."
,"10":"Je vous invite donc à m'écouter, à mon tour je dirai ce que je sais."
,"11":"J'ai attendu tandis que vous parliez, suivant vos raisons tandis que vous cherchiez vos mots."
,"12":"Je vous écoutais attentivement, mais aucun de vous n'a réfuté Job, personne n'a répondu à ses déclarations."
,"13":"Cessez donc de dire que vous avez la sagesse, que c'est doctrine de Dieu et non des hommes.'"
,"14":"Je ne prends pas à mon compte vos raisons, je ne lui répondrai pas avec vos arguments."
,"15":"Consternés, vous n'aviez plus rien à dire, les mots vous manquaient."
,"16":"J'attendais! Mais si vous ne parlez plus, si vous restez là sans réponse,"
,"17":"à moi de répliquer, à mon tour de montrer mon savoir!"
,"18":"Ce ne sont pas les mots qui me manquent, une conviction intime me presse:"
,"19":"c'est en moi comme un vin qui fermente,et faute d'issues fait éclater les outres neuves."
,"20":"Parler me soulagera, j'ai besoin de parler et de répondre."
,"21":"Je serai pourtant impartial, sans flatter qui que ce soit,"
,"22":"car si je prétendais flatter, bien vite Celui qui m'a fait m'enlèverait."
}`)
	CurrentBook.AddChapter(33, `{
"1":"Toi donc, Job, entends mes arguments, sois attentif à toutes mes paroles."
,"2":"J'ai commencé et je parle."
,"3":"Ce sera pour dire des paroles de science, je ne dirai rien qui ne soit vrai."
,"5":"Réponds-moi donc si tu le peux; prépare tes arguments et donne la réplique."
,"6":"Devant Dieu je ne suis pas plus que toi, moi aussi j'ai été pétri d'argile;"
,"4":"fait par le souffle de Dieu, je suis vivant grâce à l'esprit du Puissant."
,"7":"Tu n'as pas à craindre, comme avec sa terreur, tu ne sentiras pas le poids de ma main."
,"8":"Du as donc dit devant moi, et je l'ai bien entendu:"
,"9":"'Je suis innocent et sans fautes, je suis pur de tout crime."
,"10":"C'est Dieu qui me cherche des prétextes,et qui me traite en ennemi."
,"11":"Il a mis des entraves à mes pieds, il surveille tous mes pas.'"
,"12":"Je te réponds: Tu as tort de parler ainsi, car Dieu est bien plus grand qu'un humain."
,"13":"Pourquoi lui fais-tu ce reproche,qu'il laisse sans réponse toutes tes paroles?"
,"14":"Car Dieu parle, mais il ne le répète pas deux fois."
,"15":"Ce peut être un rêve, une vision dans la nuit: tandis que l'homme repose sur sa couche, il tombe dans un état de torpeur,"
,"16":"et Dieu alors parle à l'oreille des humains, il les effraie par des apparitions."
,"17":"Il veut arrêter l'homme dans son projet,et le guérir de son orgueil."
,"18":"C'est ainsi qu'il épargne à son âme la tombe,et l'empêche de descendre au séjour des morts."
,"19":"Il corrige aussi l'être humain par la douleur, quand il est en proie aux frissons de la fièvre:"
,"20":"quand il prend en dégoût son pain, et perd tout son appétit;"
,"21":"quand il maigrit à vue d'oeil, et déjà n'a plus que la peau sur les os;"
,"22":"lorsque son âme approche de la fosse, et que sa vie aboutit au séjour des morts."
,"23":"Mais alors un ange se penche sur lui, un parmi des milliers, un de ceux qui rappellent aux humains leur devoir."
,"24":"Il prend pitié de lui et il implore: 'Ne l'oblige pas à descendre dans la fosse, j'ai trouvé le moyen de racheter sa vie!'"
,"25":"Sa chair alors reprend vie: c'est une jeunesse!,il revient aux jours de son adolescence;"
,"26":"Il se tourne vers Dieu qui le prend en grâce, il va le visiter et fait éclater sa joie, proclamant aux humains la justice de Dieu."
,"27":"Il reconnaît devant les humains: 'J'avais péché, commis l'injustice, et je n'en ai pas été puni."
,"28":"Il m'a racheté, arraché à la fosse, et je vois encore la lumière!'"
,"29":"Oui, voilà comment Dieu agit, deux fois, trois fois pour la même personne."
,"30":"C'est ainsi qu'il le ramène de la fosse, pour que brille sur lui la lumière des vivants."
,"31":"Sois donc attentif, Job, écoute-moi, tais-toi un peu, que je parle."
,"32":"S'il y a quelque chose à redire, dis-le, parle, j'aimerais que tu aies raison."
,"33":"Sinon, tais-toi, écoute-moi, fais silence, que je t'enseigne la sagesse."
}`)
	CurrentBook.AddChapter(34, `{
"1":"Elihou reprit la parole:"
,"2":"Ecoutez-moi donc, vous, les sages, prêtez l'oreille, vous qui savez!"
,"3":"Car l'oreille soupèse les mots, tout comme le palais apprécie la nourriture."
,"4":"Voyons ensemble ce qui est juste, mettons-nous d'accord sur ce qui est bien."
,"5":"Job a donc dit: 'Je suis innocent, mais il ne reconnaît pas mon droit:"
,"6":"Dieu ment à propos de mon droit, bien que sans péché, ma blessure est incurable'."
,"7":"Mais qui est-il, ce Job?,Il se moque aussi facilement qu'il boit,"
,"8":"il prend le parti des malfaiteurs, il est d'accord avec les méchants!"
,"9":"Il a bien dit: 'C'est sans profit pour l'homme, que d'être en bons termes avec Dieu'."
,"10":"Ecoutez-moi donc vous qui réfléchissez: Dieu n'a rien à faire avec le mal, le Puissant est loin de toute injustice."
,"11":"Il rend aux hommes ce qu'ils ont fait, il donne à chacun ce que mérite son chemin."
,"12":"Non, c'est certain, Dieu ne fait pas le mal, le Puissant ne tourne pas le droit."
,"13":"Est-ce un autre qui lui a confié la terre, qui lui a mis en mains le monde?"
,"14":"S'il ramenait à lui sa pensée, s'il reprenait son esprit et son souffle,"
,"15":"tous les vivants expireraient à l'instant, et les humains retourneraient à la poussière."
,"16":"Ecoute donc, toi qui es intelligent; sois attentif à ce que je te dis."
,"17":"Dieu gouvernerait-il, s'il détestait le droit?,Peux-tu le condamner s'il est juste et puissant?"
,"18":"Lui peut dire à un roi: 'Vaurien!',et à des nobles: 'C'est vous les coupables!'"
,"19":"Il ne prend pas le parti des princes, ne donne pas l'avantage au riche sur le pauvre: ils sont pareillement l'oeuvre de ses mains."
,"20":"De nuit, en moins que rien, ils meurent: un soulèvement du peuple, et ils ont disparu. Il n'a pas besoin de mains pour ôter un tyran."
,"21":"Car ses yeux se penchent sur les chemins de l'homme, surveillant sa conduite et chacun de ses pas."
,"22":"Il n'y a pas d'ombres, ou de ténèbres, où puisse se cacher le malfaiteur,"
,"23":"Il ne fixe pas de rendez-vous,pour qu'on aille se présenter devant lui:"
,"24":"il brise les grands sans enquête,et il en met d'autres à leur place."
,"24":"Il connaissait bien leurs forfaits, en une nuit il les renverse et ils sont écrasés:"
,"26":"il les gifle comme des méchants, au vu et au su de la foule."
,"27":"C'est qu'ils s'étaient détournés de lui, et ne tenaient pas compte de ses volontés,"
,"28":"tandis que le cri des faibles montait vers lui, et que lui écoutait la plainte des malheureux."
,"29":"S'il veut se taire, qui le fera bouger, s'il cache sa face, qui le verra?,Il surveille les nations et les personnes,"
,"30":"s'opposant au pouvoir de l'oppreseur du peuple."
,"31":"S'il dit à Dieu: 'Je me suis laissé tenter, mais je ne ferai plus le mal;"
,"32":"instruis-moi pour que je sache, j'ai commis des crimes, je ne le ferai plus.'"
,"33":"En ce cas, d'après toi, Dieu punira-t-il?,Toi qui n'es pas d'accord, c'est à toi de décider, pas à moi; dis donc ce que tu sais!"
,"34":"Mais les hommes sensés me diront, n'importe quel sage qui m'écoute:"
,"35":"'Job parle sans savoir, ses paroles ne sont pas raisonnables."
,"36":"Job doit être examiné à fond, car ses réponses sont celles d'un impie."
,"37":"Il s'enfonce dans ses péchés, car devant nous il nie sa faute,et multiplie ses attaques contre Dieu!"
}`)
	CurrentBook.AddChapter(35, `{
"1":"Elihou prit encore la parole:"
,"2":"Voyons, Job, crois-tu vraiment avoir raison,et pouvoir te justifier devant Dieu,quand tu lui dis: 'Que t'importe, qu'est-ce que cela te fait si je pèche?'"
,"4":"Eh bien, je veux t'en dire quelque chose, et à tes amis en même temps."
,"5":"Lève les yeux vers le ciel et regarde: vois ces nuages bien au-dessus de toi!"
,"6":"Donc, si tu pèches, atteins-tu le Très-Haut?,Tu auras beau l'offenser, que peux-tu lui faire?"
,"7":"De même si tu es juste, que lui apportes-tu, quel cadeau lui fais-tu?"
,"8":"Tu ne nuis qu'à celui qui comme toi est humain, tes vertus valent pour des hommes."
,"9":"Les hommes crient sous le poids de l'oppression, ils appellent au secours quand les grands les oppriment."
,"10":"Mais disent-ils: 'Où est le Dieu qui nous a faits, celui qui fait chanter les nuits,"
,"11":"celui qui nous instruit par les bêtes de la terre,et par l'oiseau du ciel nous livre la sagesse?'"
,"12":"Voilà pourquoi ils crient et Dieu ne répond pas,quand ils subissent les excès des méchants."
,"13":"Tout est inutile! Dieu n'écoute pas, le Puissant regarde ailleurs."
,"14":"Ce sera pire si tu dis que tu ne le vois pas, que tu veux un jugement et que tu l'attends,"
,"15":"ou si tu dis que sa colère ne sait pas punir,et qu'il n'est guère au courant des injustices."
,"16":"Job veut qu'on l'entende, mais c'est du creux; il multiplie les discours mais il ne sait pas!"
}`)
	CurrentBook.AddChapter(36, `{
"1":"Elihou continua et dit:"
,"2":"Encore un moment de patience, je veux t'instruire; j'ai plus à dire en faveur de Dieu."
,"3":"Je veux donner raison à mon Créateur, et publier ce que je sais aussi loin que possible."
,"4":"Car cette fois, ce sont des paroles qui valent, celui qui te parle est un homme entendu."
,"5":"Comprends donc! Dieu est très fort, mais il ne méprise pas l'homme au coeur pur;"
,"6":"il ne laisse pas vivre le méchant, alors qu'il fait justice aux malheureux;"
,"7":"il ne détourne pas ses yeux des justes. S'il place des rois sur le trône, il les met pour qu'ils y restent. Mais s'ils tombent dans l'orgueil,"
,"8":"ils se retrouvent liés avec des chaînes, pris dans les cordes du malheur."
,"9":"Dieu leur montre alors leur conduite, et toutes ces fautes dont ils se glorifiaient."
,"10":"Il leur donne ainsi un avertissement, un ordre de se détourner du mal."
,"11":"S'ils écoutent et le servent, leur vie s'achèvera dans le bonheur, ce seront des années plaisantes."
,"12":"S'ils n'écoutent pas, il les envoie vers la sortie: il leur faut mourir puisqu'ils n'ont pas compris."
,"13":"Ce sont des coeurs déloyaux: ils se rebellent,au lieu de supplier quand Dieu les enchaîne;"
,"14":"ils meurent en pleine jeunesse, leur vie s'achève après l'adolescence."
,"15":"Dieu sauve les pauvres par leur pauvreté, il les enseigne à travers leur misère."
,"16":"Vois, il t'arrachera aux crocs de la détresse: à la place ce sera l'abondance sans limites, ta table regorgera de bonnes choses."
,"17":"Tu feras alors le procès des méchants, entre tes mains seront la justice et le droit."
,"18":"Ne te laisse donc pas mener par la colère, ne te laisse pas séduire par la richesse."
,"19":"Fais rendre compte au grand comme au sans-avoir, au puissant comme au faible."
,"20":"N'écrase pas ceux qui ne te sont rien, pour mettre à leur place des gens de ta famille."
,"21":"Tu te garderas de dévier vers le mal, car c'est pour cela que le malheur t'a frappé."
,"22":"Vois, Dieu est souverain dans sa force, quel maître pourrait l'égaler?"
,"23":"Qui lui fera rendre compte, et lui dira: 'Tu as mal agi'?"
,"24":"Pense donc à glorifier son oeuvre, que tant d'hommes ont déjà chantée."
,"25":"Tout humain en a le spectacle, chacun la contemple de loin."
,"26":"Oui, Dieu est grand, au-delà de ce qu'on en sait, quel nombre d'années! nul n'en fera le compte."
,"27":"Il attire les gouttes d'eau, les vapeurs qui se feront pluie."
,"28":"Les nuages déversent la pluie,et la répartissent sur le monde des hommes."
,"29":"Qui comprendra le déploiement des nues, et le tonnerre qui gronde dans le ciel?"
,"30":"Voici qu'il déploie les nuées,pour en couvrir la mer immense."
,"31":"C'est ainsi qu'il nourrit les peuples,et leur donne en très grand la nourriture."
,"32":"Il brandit l'éclair à deux mains,et lui dit où il doit frapper."
,"33":"Il en avertit les bergers, tout comme le troupeau qui flaire la tempête."
}`)
	CurrentBook.AddChapter(37, `{
"1":"A ce spectacle mon coeur sursaute,et ne peut pas rester en place."
,"2":"Ecoutez donc le fracas de sa voix, le grondement qui sort de sa bouche!"
,"3":"D'un bout du ciel à l'autre il a lancé l'éclair: il atteindra les extrémités de la terre."
,"4":"Puis on entend un rugissement: c'est sa voix souveraine qui tonne,et les éclairs ne cesseront pas,tandis qu'elle se fera entendre."
,"5":"Oui, Dieu par sa voix opère des merveilles, il fait des prodiges qui nous dépassent."
,"6":"Il dit à la neige: 'Descends sur la terre!',et aux pluies d'averse: 'Allez-y fort!'"
,"7":"C'est alors qu'il enferme chacun en son abri, pour que tous reconnaissent sa puissance."
,"8":"Même les bêtes vont à leurs tanières,et se couchent dans leurs refuges."
,"9":"Du sud arrive la tempête, du nord vient le froid."
,"10":"Sous le souffle de Dieu la glace se forme, la surface des eaux se durcit."
,"11":"Il charge d'éclairs les nuages, et les nuées déchargent les éclairs."
,"12":"Lui les envoie à la ronde, les fait partir tour à tour: sur toute l'étendue de la terre,ils feront le travail qu'il ordonne."
,"13":"Si c'est pour punir, il feront ce qui lui plaît, si c'est pour une grâce, on la recevra."
,"14":"Ecoute encore ceci, Job, prends le temps d'observer les merveilles de Dieu."
,"15":"Sais-tu de quelle façon il les opère?,comment il fait briller l'éclair dans la nuée?"
,"16":"Sais-tu comment flottent les nuages?,Quel miracle de science achevée!"
,"17":"Toi qui ne supportes pas sous tes vêtements, quand la terre s'assoupit sous le vent du midi,"
,"18":"l'aurais-tu aidé à forger le firmament, et le laisser ferme comme un miroir de bronze?"
,"19":"Dis-moi: comment devons-nous lui parler?,ne discutons plus: nous sommes dans les ténèbres."
,"20":"Quand je parle, est-ce qu'on le lui répète?,Est-il informé de ce que disent les hommes?"
,"21":"Mais quoi? on ne voit plus la lumière... les nuages ont tout obscurci... voici que le vent souffle et les balaye..."
,"22":"Une lumière dorée nous arrive du nord: c'est l'éclat redoutable dont Dieu s'enve loppe!"
,"23":"C'est le Puissant que nous ne pouvions atteindre, grand par sa force, grand par sa justice, si grand en sa justice qu'il n'accable personne!"
,"24":"C'est pourquoi les humains doivent le craindre: tous les sages ensemble ne sont rien à ses yeux.'"
}`)
	CurrentBook.AddChapter(38, `{
"1":"Yahvé répondit à Job, du coeur de la tempête il lui dit:"
,"2":"Qui est cet homme qui obscurcit mes décisions et parle de ce qu'il ne sait pas?"
,"3":"Allons, prends tes armes comme un brave: je vais t'interroger et tu m'instruiras."
,"4":"Où étais-tu, quand je fondais la terre?,Parle, si ta science est exacte."
,"5":"Qui en a fixé les mesures, le sais-tu?,qui a tendu sur elle le cordeau du maçon?"
,"6":"Sais-tu sur quoi reposent ses bases, et qui en a posé la pierre angulaire?"
,"7":"Les étoiles du matin, pour elle, chantèrent en choeur: tous les fils de Dieu poussaient des acclamations."
,"8":"Qui enferma la mer à deux battants, lorsqu'elle jaillissait, sortant du sein,"
,"9":"lorsque je lui donnais, pour la couvrir, les nuées, et pour langes, des nuages sombres;"
,"10":"lorsque je lui fixais ses frontières,et la contenais avec portes et verrous?"
,"11":"Je lui ai dit alors: 'Tu n'iras pas plus loin; ici se courbera l'orgueil de tes flots!'"
,"12":"Mais toi, as-tu jamais commandé au matin, indiqué à l'aurore le lieu de son lever,"
,"13":"lorsqu'elle conquiert la terre par les ailes, et met en fuite les méchants?"
,"14":"Le sol alors prend une couleur d'argile, et se teinte de rose comme un vêtement:"
,"15":"elle fait perdre aux méchants leur lumière, et le bras menaçant est brisé."
,"16":"Es-tu allé jusqu'aux sources des mers, as-tu parcouru le fond de l'océan?"
,"17":"Est-ce qu'on t'a montré les portes de la Mort, ainsi que les gardiens du Pays des Ombres?"
,"18":"As-tu quelque idée de l'étendue du monde?,Raconte, puisque tu as tout vu."
,"19":"Où prend-on le chemin du palais de la lumière, et les ténèbres, viennent-elles de quelque endroit?"
,"20":"Si tu sais aller jusqu'à leur maison, peut-être pourrais-tu les reconduire chez elles?"
,"21":"Tu le sais, bien sûr, tu es né avant elles, tu as beaucoup, beaucoup d'années!"
,"22":"Et les réserves de neige, y es-tu allé?,As-tu visité les dépôts de la grêle"
,"23":"que je tiens en réserve pour les temps difficiles, pour les jours de rencontre et de guerre?"
,"24":"D'où sort, d'où se diffuse la lumière, et d'où, le vent qui de l'orient balaye la terre?"
,"25":"Qui ouvre un passage aux averses de l'orage, un chemin aux grondements du tonnerre,"
,"26":"amenant la pluie sur les terres sans hommes, sur le désert où nul ne s'arrête,"
,"27":"irriguant un sol aride et désolé, pour que germe sur la steppe l'herbe verte?"
,"28":"La pluie a-t-elle un père?,Qui engendre les gouttes de rosée?"
,"29":"Et la glace, est-elle sortie d'un sein maternel?,Qui enfante le givre des cieux,"
,"30":"lorsque les eaux ont durci comme la pierre, et que se prend toute l'étendue des mers?"
,"31":"Est-ce toi qui as noué les liens des Pléiades,ou qui élargiras les chaînes d'Orion?"
,"32":"Est-ce toi qui fais sortir la Couronne en son temps, et conduis la Grande Ourse avec ses petits?"
,"33":"Connais-tu les lois astrales, fais-tu venir sur terre ce qui y est écrit?"
,"34":"Vas-tu crier bien fort vers les nuages, pour qu'un déluge tombe sur toi?"
,"35":"Les éclairs partent-ils parce que tu les lâches, est-ce à toi qu'ils diront: 'Nous voici'?"
,"36":"Qui a mis dans l'ibis la sagesse, et donné au coq de l'intelligence?"
,"37":"Qui est sage au point de compter les nuages?,qui sait déverser les eaux de leurs réserves,"
,"38":"faisant que la poussière se fasse masse,et que les mottes s'agglomèrent?"
,"39":"Est-ce toi qui rabats vers la lionne sa proie, et qui apaises la faim des lionceaux,"
,"40":"quand ils sont tapis dans leurs tanières,ou se tiennent à l'aguet sous les buissons?"
,"41":"Qui prépare au corbeau son manger, quand ses petits crient vers Dieu,et s'agitent le ventre vide?"
}`)
	CurrentBook.AddChapter(39, `{
"1":"Sais-tu quand les chamois font leurs petits?,As-tu observé les biches en travail?"
,"2":"As-tu compté les mois de leur portée,et connais-tu l'époque de leur délivrance?"
,"3":"Alors elles s'accroupissent pour mettre bas: voici qu'elles déposent leurs petits."
,"4":"Ils prennent des forces, ils grandissent au désert, ils partent: ils ne reviendront plus vers elles."
,"5":"Qui a lâché en liberté l'âne sauvage,et l'a allégé de ses liens?"
,"6":"Je ne lui ai donné de maison que la steppe, il demeure dans la plaine salée."
,"7":"Il se moque du trafic de la ville, il n'entend pas les cris de l'ânier,"
,"8":"mais il explore la montagne, son pâturage, toujours à la recherche d'herbes vertes."
,"9":"Est-ce que le buffle voudra te servir,et rester pour la nuit dans ton étable?"
,"10":"Tu lui passeras peut-être une corde au cou, pour qu'il herse ton champ derrière toi?"
,"11":"Tu devrais lui faire confiance: il est si fort!,il ferait bien la besogne à ta place."
,"12":"Peux-tu compter sur lui au retour, pour qu'il dépose le grain sur ton aire."
,"13":"L'aile de l'autruche est joyeuse, son pennage est de plumes gracieuses."
,"14":"Mais elle abandonne ses oeufs sur la terre: le sol se chargera de les chauffer!"
,"15":"oubliant qu'un pied peut les écraser, qu'une bête des champs peut les briser."
,"16":"Elle traite ses petits comme s'ils n'étaient pas siens: peu lui importe qu'elle ait peiné pour rien!"
,"17":"C'est que Dieu l'a privée de sagesse, l'intelligence n'est pas son lot."
,"18":"Mais dès qu'elle se lève et s'élance, elle se rit du cheval et de son cavalier."
,"19":"Est-ce toi qui donnes au cheval sa vigueur, qui revêts son cou d'une crinière,"
,"20":"et le fais bondir comme la sauterelle?,Son fier hennissement répand la terreur."
,"21":"Il piaffe dans la vallée, joyeux de sa force, il s'élance au devant des armes."
,"22":"Il se moque de la peur, il ne s'effraie pas,et ne recule pas devant l'épée."
,"23":"Il soutient les chocs du carquois, les étincelles de la lance et du javelot."
,"24":"Frémissant d'impatience, il dévore l'espace, il ne tient plus en place s'il entend la trompette."
,"25":"Dès que sonne la trompe, pour lui c'est: 'Allons-y!', de loin il a flairé la bataille, le chambard des chefs et les cris de guerre."
,"26":"Est-ce toi qui as prévu l'envol du faucon, lorsqu'il déploie ses ailes vers le midi?"
,"27":"Est-ce sur ton ordre que l'aigle s'élève, ou qu'il a bâti son nid là-haut?"
,"28":"Il s'installe sur son rocher, il y passe la nuit,dans sa forteresse, sur une dent de roche."
,"29":"De là il guette sa proie; de loin ses yeux l'apercevront,"
,"30":"il nourrira de sang ses petits. Où que tombe le corps, aussitôt il est là."
}`)
	CurrentBook.AddChapter(40, `{
"1":"Après cela, le Seigneur s'adressa à Job et lui demanda:"
,"2":"Alors, toi qui contestes le Puissant, vas-tu t'avouer vaincu? Toi qui critiques Dieu lui-même, as-tu quelque chose à répliquer?"
,"3":"Et Job répondit à Dieu:"
,"4":"J'ai parlé à la légère; que pourrais-je répondre? Je mets ma main sur la bouche et je me tais."
,"5":"J'ai déjà trop parlé, je ne recommencerai plus!"
,"6":"Mais Dieu parla de nouveau, du coeur de la tempête, et il dit à Job:"
,"7":"Ceins tes reins comme un brave: je vais t'interroger et tu m'instruiras."
,"8":"Vraiment? Tu veux t'opposer à mes décisions et me donner tort pour avoir raison?"
,"9":"Serais-tu, par hasard, aussi fort que Dieu? Ta voix peut-elle tonner comme la sienne?"
,"10":"Alors, montre ta fierté et ton éclat! Orne-toi de gloire et d'honneur!"
,"11":"Laisse libre cours à ta fureur et à ta colère! Rabaisse les orgueilleux d'un seul regard!"
,"12":"Jette les yeux sur les superbes et les méchants, pour les humilier et les écraser sur place!"
,"13":"Fais-leur mordre la poussière, envoie-les au cachot d'où nul bruit ne remonte!"
,"14":"Alors moi-même je ferai ton éloge, pour avoir triomphé par ta propre force."
,"15":"Moi qui t'ai fait, j'ai fait aussi la Bête; étrange: comme le boeuf elle est végétarienne!"
,"16":"Mais quelle force dans sa croupe, quelle puissance dans les muscles de son ventre!"
,"17":"Elle dresse sa queue comme un cèdre, les tendons de ses cuisses ressortent comme des câbles,"
,"18":"ses os sont des tubes de bronze, ses côtes comme des barres de fer!"
,"19":"C'était la première des oeuvres de Dieu, il l'a fait souverain de ses compagnons;"
,"20":"des montagnes où s'ébattent les bêtes sauvages, ils lui apportent leur tribut."
,"21":"Il s'est couché à l'ombre des lotus, il s'est caché dans le marais entre les joncs."
,"22":"Les lotus le couvrent de leur ombre, les saules de la rive le protègent."
,"23":"Le fleuve peut déborder, il ne bronchera pas; il ne craint rien si l'eau lui monte jusqu'aux narines."
,"24":"Viendra-t-on l'affronter pour le prendre, et lui passer dans le nez une corde?"
,"25":"Où est ton hameçon pour pêcher le Léviathan,et lui lier ensuite la gueule avec des cordes?"
,"26":"Vas-tu passer un jonc dans ses narines,ou lui planter un croc dans les naseaux?"
,"27":"Le vois-tu implorant ta pitié, cherchant ses mots, te signant une capitulation,"
,"28":"se faisant pour toujours ton serviteur?"
,"29":"Vas-tu t'en amuser comme d'un oiseau, ou regarder comment tes filles le tiennent en laisse?"
,"30":"Trouvera-t-on des compagnons pour en faire le commerce, et des marchands pour débiter sa viande?"
,"31":"Peux-tu lui trouer la peau avec tes flèches, ou lui percer la tête avec un harpon?"
,"32":"Pose la main sur lui: quel combat!,tu t'en souviendras et ne recommenceras pas"
}`)
	CurrentBook.AddChapter(41, `{
"1":"Tu te trompes si tu crois l'avoir, son seul aspect te fera reculer!"
,"2":"N'est-il pas cruel dès qu'on l'éveille?,Qui lui fera face sans céder le terrain,"
,"3":"qui l'attaquera et sera le plus fort?,Personne sous les cieux."
,"4":"Je devrais parler de ses membres, il me faut rappeler sa force incomparable."
,"5":"Qui a soulevé le devant de sa tunique, et regardé sous sa carapace?"
,"6":"Qui a ouvert les battants de sa machoire?,et quelle frayeur à voir cette couronne de dents!"
,"7":"Son dos n'est qu'un tissu de plaques,qui se recouvrent sans laisser d'espace;"
,"8":"la jointure est si bonne,que pas un souffle n'y passerait."
,"9":"Chacune est soudée à sa voisine, leur assemblage ne se démonte pas."
,"10":"S'il éternue, ce sont des étincelles, ses paupières laissent jaillir une lumière."
,"11":"De sa gueule se dégagent des flammes, des étincelles de feu s'en échappent."
,"12":"Une vapeur sort de ses narines, des projections, comme d'un chaudron qui bouillonne."
,"13":"A son souffle les charbons s'enflamment, une langue de feu sort de sa gueule!"
,"14":"Toute sa force est dans son cou, l'effroi passe devant lui!"
,"15":"Sa carcasse ne fait qu'un tout, partout elle résiste et rien ne bouge."
,"16":"Son coeur est dur comme le roc, comme une pierre à broyer."
,"17":"S'il se redresse, les flots refluent, les ondes s'effraient."
,"18":"L'épée le frappe sans pénétrer, la lance et la flèche rebondissent."
,"19":"Pour lui le fer n'est que paille, et le bronze comme le bois s'émousse."
,"20":"Les traits de l'arc ne le font pas fuir, les pierres de fronde lui semblent brins de paille."
,"21":"La massue n'est pour lui qu'une baguette, le javelot résonne sur lui: il s'en moque."
,"22":"Tout son dessous est garni de pointes, il herse la vase, y laissant des sillons."
,"23":"Puis c'est un bouillonnement dans les ondes, des bulles sur l'eau, comme sur des charbons d'encens."
,"24":"Il laisse derrière lui un sillage de lumière, une mer d'écume blanche."
,"25":"Nulle bête sur terre ne saurait le vaincre: il a été fait rebelle à la peur."
,"26":"Il brave en face les plus fières, il est le roi de tous les carnassiers!"
}`)
	CurrentBook.AddChapter(42, `{
"1":"Alors Job répondit à Yahvé, il dit:"
,"2":"Je sais que tu peux tout, aucun de tes projets pour toi n'est difficile."
,"3":"J'ai parlé sans comprendre de toutes ces merveilles, elles me dépassent et je n'y atteins pas."
,"5":"Je ne te connaissais que par ouï-dire, mais maintenant mes yeux t'ont vu,"
,"6":"c'est pourquoi je veux me rétracter, m'humilier sur la poussière et la cendre."
,"7":"Après avoir ainsi parlé à Job, le Seigneur dit à Elifaz de Téman: 'Je suis très en colère contre toi et tes deux amis, car vous n'avez pas parlé correctement de moi, comme l'a fait mon serviteur Job."
,"8":"Et maintenant, prenez avec vous sept taureaux et sept béliers, et allez trouver mon serviteur Job. Vous offrirez ces animaux en sacrifice d'expiation, et mon serviteur Job priera pour vous. C'est par égard pour lui que je ne vous traite pas avec sévérité, parce que vous n'avez pas parlé correctement de moi, comme l'a fait mon serviteur Job.'"
,"9":"Elifaz de Téman, Bildad de Shouah et Sofar de Nahama s'en allèrent donc et firent ce que Yahvé leur avait ordonné. Et Yahvé accueillit favorablement la prière de Job."
,"10":"Tandis que Job intercédait pour ses amis, Yahvé retourna sa situation: il rendit à Job le double de tout ce qu'il avait possédé."
,"11":"Tous les frères et soeurs de Job vinrent le voir, avec toutes ses connaissances d'autrefois, et ils vinrent partager le pain dans sa maison. Ils le plaignaient et le consolaient de tous les malheurs que Yahvé lui avait envoyés. Chacun lui donna une pièce d'argent et un anneau d'or."
,"12":"Dès ce moment Yahvé bénit Job plus encore qu'autrefois: il eut quatorze mille brebis et six mille chameaux, mille paires de boeufs et mille ânesses."
,"13":"Job eut aussi quatorze fils et trois filles."
,"14":"A l'une il donna le nom de 'Tourterelle', il appela la seconde 'Fleur de Jasmin', et la troisième 'Coffret à Parfum'."
,"15":"Dans tout le pays on ne trouvait pas une femme aussi belle que les filles de Job. Leur père leur donna une part d'héritage tout comme à leurs frères."
,"16":"Après cela, Job vécut encore cent quarante ans, et il vit les enfants et les petits-enfants de ses fils, jusqu'à la quatrième génération."
,"17":"Puis Job mourut, vieux et rassasié de jours."
}`)

}
func FR_LBDCC_LoadVSPRChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Voici des Proverbes de Salomon, fils de David, roi d'Israël,"
,"2":"pour vous faire acquérir sagesse et instruction, et pénétrer les mots qui ouvrent l'intelligence,"
,"3":"pour vous donner des leçons de bon sens, pour que vous deveniez justes, honnêtes et loyaux."
,"4":"Les gens simples apprendront à bien juger, les jeunes s'instruiront, leur esprit s'ouvrira."
,"6":"Ils pénétreront les proverbes et les dictons, les paroles des sages et leurs énigmes."
,"5":"Que le sage écoute, il gagnera en savoir; l'homme intelligent saura diriger les autres."
,"7":"Le début du savoir, c'est la crainte de Yavé; seuls les sots méprisent sagesse et discipline."
,"8":"Ecoute, mon fils, les avis de ton père, ne rejette pas les avertissements de ta mère:"
,"9":"tu as là une belle couronne pour ta tête, un collier pour ton cou."
,"10":"Mon fils, si des pécheurs veulent t'entraîner au mal, ne les suis pas!"
,"11":"Ils te diront peut-être: 'Viens avec nous, nous attendrons le bon moment - et c'est pour tuer! Nous tendrons un piège - un piège à l'innocent qui ne l'a pas mérité!"
,"12":"Nous n'en ferons qu'une bouchée, comme fait le Séjour des Morts, nous tomberons sur eux comme la mort."
,"13":"Nous mettrons la main sur des tas de choses de valeur, nous remplirons nos maisons de notre butin."
,"14":"Toi aussi, tu en auras ta part, car nous mettrons tout en commun.'"
,"15":"Mon fils, ne fais pas route avec eux, ne marche pas sur leurs chemins."
,"16":"Vois comme leurs pieds courent vers le mal, comme ils ont vite fait de verser le sang!"
,"17":"Les oiseaux ne se prendront pas à ton filet si tu l'as tendu sous leurs yeux,"
,"18":"mais eux, c'est leur propre vie qu'ils mettent en jeu, c'est à eux-mêmes qu'ils se tendent des pièges."
,"19":"C'est ainsi que finira tout homme qui vit de rapines: un jour la rapine lui prendra sa vie."
,"20":"La Sagesse crie par les rues, elle élève la voix sur les places."
,"21":"Elle lance un appel aux carrefours, elle dit son message aux portes de la ville:"
,"22":"'Combien de temps encore, gens insignifiants, aimerez-vous vos sottises? Combien de temps encore les moqueurs s'amuseront-ils avec leurs moqueries, et les gens stupides refuseront-ils de savoir?"
,"23":"Ecoutez donc mes avertissements en ce moment où je vous ouvre mon coeur et je vous fais connaître mes pensées."
,"24":"Allez-vous refuser quand je vous appelle, ne pas faire attention quand je vous tends la main?"
,"25":"Voulez-vous négliger tous mes conseils et repousser mes avis?"
,"26":"A mon tour je rirai de votre détresse, je me moquerai lorsque la peur vous saisira,"
,"27":"lorsque le jour du malheur fondra sur vous: il viendra comme une tornade, vous serez pris dans le tourbillon fatal et resterez sous le poids de la détresse et l'angoisse."
,"28":"Alors on m'appellera et je ne répondrai pas; on me cherchera et on ne me trouvera pas."
,"29":"C'est qu'on n'avait pas voulu du savoir, on n'avait pas choisi la crainte de Yahvé;"
,"30":"ces gens-là ne cherchaient pas mes conseils, ils avaient méprisé tous mes avertissements."
,"31":"Mais ils mangeront les fruits de leurs entreprises, ils pourront se repaître de leurs initiatives."
,"32":"Car le refus de la sagesse mène les sots à la mort, l'insouciance des têtes en l'air fera leur perte."
,"33":"Mais celui qui m'écoute dormira en paix, il n'aura pas à craindre le malheur."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Reçois mes paroles, garde mon enseignement;"
,"2":"que ton oreille, mon fils, s'ouvre à la sagesse, que ton coeur se plie à la vérité;"
,"3":"fais appel à l'intelligence et laisse-toi guider par la raison;"
,"4":"cherche la sagesse comme l'argent, comme un trésor caché:"
,"5":"alors tu pénétreras dans la crainte de Yahvé et tu trouveras la connaissance de Dieu."
,"6":"Car c'est Yahvé qui donne la sagesse, de sa bouche sortent le savoir et la vérité."
,"7":"Il vient en aide aux hommes droits, il est un bouclier pour ceux qui restent honnêtes."
,"8":"Il reste en alerte tout au long du droit chemin pour y protéger la marche de ses fidèles."
,"9":"Alors tu comprendras ce qui est juste, droit et honnête, tout ce qui mène au bonheur."
,"10":"La sagesse alors entrera dans ton coeur et le savoir sera ta jouissance."
,"11":"La prudence veillera sur toi, la réflexion sera ta sauvegarde;"
,"12":"elles te tiendront à l'écart des chemins du mal et des hommes aux paroles trompeuses,"
,"13":"qui délaissent les droits sentiers et s'en vont par les routes obscures;"
,"14":"qui trouvent leur joie à faire le mal et prennent plaisir aux abominations,"
,"15":"qui vont par des chemins tortueux, par des sentiers qui se perdent."
,"16":"La sagesse te gardera de la femme d'un autre, de la belle inconnue aux douces paroles,"
,"17":"qui abandonne le partenaire de sa jeunesse et oublie les alliances de son Dieu."
,"18":"De sa maison on déboule vers la mort, ses sentiers mènent droit à la tombe."
,"19":"Ceux qui y vont n'en reviendront pas, ils ne retrouveront pas le chemin de la vie."
,"20":"Mais toi tu marcheras sur le chemin des gens honnêtes, tu suivras les sentiers des justes."
,"21":"Car les hommes droits habiteront le pays, les gens intègres y prolongeront leurs jours."
,"22":"Les méchants au contraire seront chassés du pays, les traîtres en seront expulsés."
}`)
	CurrentBook.AddChapter(3, `{
"1":"N'oublie pas, mon fils, mes avertissements, que ton coeur sache garder mes commandements."
,"2":"Ils prolongeront tes jours, ils te donneront la prospérité, des années de vie."
,"3":"Que ni la bonté, ni la fidélité, ne te fassent défaut! Attache-les à ton cou, inscris-les sur les tablettes de ton coeur;"
,"4":"c'est ainsi que tu gagneras bienveillance et estime, de Dieu et des hommes."
,"5":"D'un coeur entier fais confiance au Seigneur, et ne te fie pas à ta propre sagesse."
,"6":"Quoi que tu fasses, tiens compte de lui: il aplanira tes chemins."
,"7":"Ne te crois pas le plus sage: aie la crainte de Yahvé et tiens-toi à l'écart du mal."
,"8":"Ce sera un remède pour ton corps, tu y retrouveras la vigueur."
,"9":"Fais ton offrande à Yahvé, prise sur tes biens, les premiers fruits de tes récoltes;"
,"10":"alors tes greniers se rempliront de blé et tes cuves déborderont de vin nouveau."
,"11":"Mon fils, ne méprise pas les avertissements de Yahvé, ne t'insurge pas contre sa réprimande;"
,"12":"car le Seigneur corrige celui qu'il aime, tout comme un père reprend le fils qu'il chérit."
,"13":"Heureux le mortel qui a trouvé la sagesse, l'homme qui a obtenu l'intelligence!"
,"14":"Provision de sagesse vaut mieux qu'argent en banque; elle te rapporte plus que de l'or."
,"15":"Elle est plus précieuse que les perles, rien de ce qui t'attire ne peut l'égaler."
,"16":"De sa main droite elle t'offre longue vie, et de l'autre, richesse et gloire."
,"17":"Elle te mènera par des chemins plaisants, tous ses sentiers sont sûrs."
,"18":"Elle est un arbre de vie pour qui s'y attache; heureux ceux qui ont trouvé la sagesse!"
,"19":"C'est par la sagesse que Yahvé a mis la terre en place; par l'intelligence il a fixé le firmament;"
,"20":"par sa science les eaux jaillirent des profondeurs et les nuages déversèrent la pluie."
,"21":"Agis toujours, mon fils, avec prudence et réflexion: c'est une chose que tu n'oublieras pas."
,"22":"De là te viendra la vie: tu la sentiras en toi, elle rayonnera sur ton visage."
,"23":"Alors tu t'avanceras avec confiance, sans peur de trébucher."
,"24":"Tu iras te coucher sans crainte et durant la nuit ton sommeil sera paisible."
,"25":"Tu n'auras pas à craindre une catastrophe soudaine, ou l'attaque imprévue des malfaiteurs."
,"26":"Car Yahvé sera à tes côtés et ton pied ne se prendra pas dans le piège."
,"27":"Ne refuse pas une faveur à qui te demande, si tu peux le faire."
,"28":"Si tu peux le faire tout de suite, ne dis pas à ton prochain: 'Va-t'en, tu reviendras demain et je te le donnerai'."
,"29":"Ne joue pas un mauvais tour à ton prochain, alors qu'il a confiance en toi."
,"30":"Ne te dispute pas sans motif avec un autre, alors qu'il ne t'a rien fait de mal."
,"31":"N'envie pas les violents, n'imite pas leur conduite;"
,"32":"car Yahvé a en horreur les gens sans conscience, c'est aux justes que va son amitié."
,"33":"Yahvé maudit la maison du méchant, il bénit la demeure des justes."
,"34":"Il se moque des moqueurs, il accorde sa faveur aux humbles."
,"35":"La gloire est réservée aux sages, et les sots n'auront que le mépris."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Mes enfants, écoutez l'enseignement d'un père, soyez attentifs pour connaître la vérité."
,"2":"C'est un bon savoir que je vous donne, ne rejetez pas mon enseignement."
,"3":"J'ai été moi-même un fils docile pour mon père, l'enfant chéri de ma mère;"
,"4":"il m'instruisait alors en ces termes: 'Retiens bien mes paroles; suis mes conseils et tu vivras!"
,"5":"Recherche la sagesse! Deviens intelligent! N'oublie pas ce que je te dis, ne méprise pas mes paroles."
,"6":"Si tu n'abandonnes pas la sagesse, elle te protégera; aime-la, et elle veillera sur toi."
,"7":"Le commencement de la sagesse, c'est de courir après la sagesse; recherche l'intelligence au prix de tout ce que tu possèdes!"
,"8":"Choisis-la, elle t'élèvera; attache-toi à elle, elle t'honorera."
,"9":"Elle posera sur ta tête un diadème magnifique, elle te présentera une couronne de gloire.'"
,"10":"Ecoute, mon fils, prends mes paroles au sérieux, et tu vivras de longues années."
,"11":"Quand je t'aurai appris les chemins de sagesse, quand j'aurai orienté ta route,"
,"12":"tu marcheras d'un pas alerte, et tu pourras courir sans crainte de trébucher."
,"13":"Retiens ma discipline, ne l'abandonne pas: garde-la et tu vivras."
,"14":"Mais ne prends pas la route des méchants, ne t'avance pas sur le chemin des mauvais!"
,"15":"Evite-les, écarte-toi d'eux; fais un détour et passe plus loin."
,"16":"Car ils ne peuvent dormir s'ils n'ont pas fait le mal; ils n'ont pas de repos tant qu'ils n'ont pas causé du tort à quelqu'un."
,"17":"Le crime est devenu leur pain, et la violence, le vin dont ils ont soif."
,"18":"La route des justes est comme la lumière de l'aurore: son éclat grandit jusqu'au plein jour."
,"19":"Mais le chemin des méchants n'est qu'obscurité; ils ne voient pas ce qui les fera tomber."
,"20":"Mon fils, sois attentif à mes paroles, tends l'oreille à mes discours!"
,"21":"Tiens-les présents à l'esprit, garde-les au plus profond de ton coeur."
,"22":"Car elles sont vie pour celui qui les trouve, elles sont un remède pour son corps."
,"23":"Avant toute autre pratique, veille sur ton coeur, car là est la source de la vie."
,"24":"Refuse tout langage pervers, abstiens-toi de toute médisance."
,"25":"Que tes yeux regardent en face, que ton regard soit franc."
,"26":"Eprouve le sol sous tes pieds, pour que ta marche soit bien assurée."
,"27":"Ne te détourne ni à droite ni à gauche, mais éloigne-toi du mal."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Mon fils, sois attentif à ma sagesse, prête l'oreille à mes paroles avisées."
,"2":"Rappelle-toi mes conseils et parle toujours à bon escient."
,"3":"Les flatteries de la femme infidèle sont douces comme le miel, ses paroles plus onctueuses que l'huile."
,"4":"Mais la fin sera plus amère que l'absinthe; c'est une épée aiguisée, à double tranchant."
,"5":"Ses pieds courent droit vers la mort, ses pas descendent vers le tombeau;"
,"6":"plutôt que de prendre le chemin de la vie, elle suit le sentier qui s'égare où elle ne sait pas."
,"7":"Et maintenant, mon fils, écoute-moi; ne t'écarte pas de mes conseils."
,"8":"Fais ton chemin loin de cette femme, ne te risque pas à l'entrée de sa maison."
,"9":"Car ton honneur peut-être serait livré à des étrangers, des années de ta vie passeraient à des gens impitoyables."
,"10":"Des étrangers peut-être engloutiraient ta fortune, tes économies finiraient chez un autre!"
,"11":"C'est alors que tu gémirais, voyant épuisées tes forces et ta santé;"
,"12":"tu dirais: 'Comment ai-je pu rejeter les avertissements et mépriser tant de sages conseils?"
,"13":"Pourquoi n'ai-je pas écouté la voix de mes maîtres et suivi les avis de ceux qui m'instruisaient?"
,"14":"Me voici presque arrivé au plus bas, au milieu du peuple et de l'assemblée!'"
,"15":"Bois l'eau de ta propre citerne, bois à l'eau qui jaillit de ta source!"
,"16":"Ne permets pas que tes eaux se perdent au-dehors, qu'on les voie couler par les rues."
,"17":"Qu'elles restent pour toi seul, et pas pour des étrangers avec toi!"
,"18":"Bénie soit ta fontaine! Connais la joie avec la femme de ta jeunesse,"
,"19":"biche gracieuse, aimable gazelle! Trouve ton plaisir entre ses seins en tout temps, et sois toujours épris de son amour!"
,"20":"Pourquoi, mon fils, tomberais-tu amoureux d'une inconnue, pourquoi étreindre le sein d'une étrangère?"
,"21":"Sais-tu que Yahvé observe la démarche des humains et surveille tous leurs sentiers."
,"22":"Qui fait le mal se prendra au mal qu'il a fait, il se verra ficelé par ses propres péchés."
,"23":"Il mourra pour avoir refusé toute discipline, trop de méfaits le perdront."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Mon fils, si tu t'es porté garant pour un compagnon, si tu t'es engagé envers un inconnu,"
,"2":"te voilà lié par tes propres paroles, prisonnier de tes engagements."
,"3":"Fais donc ceci, mon fils: libère-toi au plus vite: ne vois-tu pas que tu es à la merci d'autrui? Va le voir, mets-toi à ses genoux, supplie!"
,"4":"N'accorde ni sommeil à tes yeux, ni repos à tes paupières;"
,"5":"il faut te dégager, comme le cerf de son piège, comme l'oiseau du filet!"
,"6":"Va voir la fourmi, paresseux; vois comme elle se démène et deviens sage."
,"7":"Il n'y a chez elle ni chef, ni surveillant, ni maître,"
,"8":"mais elle entasse en été des provisions, elle amasse sa nourriture au temps de la moisson."
,"9":"Combien de temps encore resteras-tu allongé, paresseux! Quand vas-tu sortir du lit?"
,"10":"On dort un peu, puis on somnole un moment, puis on s'allonge les bras croisés..."
,"11":"et soudain la pauvreté te surprend comme un rôdeur, la misère fondra sur toi comme un pillard."
,"12":"Le vaurien, le malfaisant, passe en ricanant;"
,"13":"il cligne des yeux, traîne les pieds, fait claquer ses doigts."
,"14":"Il est toujours à préparer quelque tromperie, il provoque à tout moment des querelles."
,"15":"Mais aussi, sans avertir, le malheur fondra sur lui, d'un coup il sera brisé et il ne s'en remettra pas."
,"16":"Il y a six choses que le Seigneur déteste, et même sept qu'il a en horreur:"
,"17":"le regard méprisant, la langue menteuse, les mains qui répandent le sang innocent,"
,"18":"le coeur qui médite des projets coupables, les pieds qui courent, impatients de faire le mal,"
,"19":"le faux témoin qui parle pour mentir, et l'homme qui provoque la mésentente entre frères."
,"20":"Mon fils, observe les conseils de ton père, ne rejette pas l'enseignement de ta mère."
,"21":"Tiens-les bien amarrés sur ton coeur, attache-les autour de ton cou."
,"22":"Ils guideront tes démarches; dans ton sommeil ils veilleront sur toi; dès ton réveil ils te conseilleront."
,"23":"Le commandement est une lampe, la loi, une lumière; les réprimandes t'enseignent le chemin de la vie."
,"24":"Elles te garderont de la femme mauvaise, des paroles douces de la femme d'un autre."
,"25":"Ne rêve pas à sa beauté, ne te laisse pas prendre à ses oeillades."
,"26":"La prostituée ne cherche qu'un morceau de pain, mais la femme adultère, ce qu'il lui faut c'est une vie précieuse."
,"27":"Peut-on emporter des braises dans ses poches et que les habits ne prennent pas feu?"
,"28":"Peut-on marcher sur des charbons ardents sans se brûler les pieds?"
,"29":"C'est pareil pour celui qui va vers la femme de son prochain: qui la touche ne restera pas impuni."
,"30":"On ne condamne pas le chapardeur affamé qui vole pour se remplir l'estomac."
,"31":"Pourtant, s'il est pris, il rendra sept fois plus: toute sa maison y passera."
,"32":"C'est une tout autre folie que de commettre l'adultère avec une femme; celui qui s'y risque se perd lui-même."
,"33":"Il récoltera des coups et le déshonneur, il y laissera sa réputation."
,"34":"Car la jalousie met le mari en fureur; à la première occasion il se vengera sans pitié."
,"35":"Il n'acceptera aucune compensation, tes cadeaux ne le toucheront pas."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Mon fils, retiens mes paroles, garde précieusement mes conseils."
,"2":"Observe mes commandements et tu vivras, garde mon enseignement comme la prunelle de tes yeux."
,"3":"Serre-les fermement entre tes doigts, inscris-les sur les tablettes de ton coeur!"
,"4":"Dis à la sagesse: 'Sois ma soeur', et à l'intelligence: 'Sois mon amie'."
,"5":"Alors tu sauras te garder de la femme d'un autre, de la belle inconnue aux douces paroles."
,"6":"De la fenêtre de ma maison je regardais à travers le grillage,"
,"7":"et je vis passer un naïf, un de ces jeunes qui ne pensent à rien."
,"8":"Il s'engageait dans la ruelle, près du coin où vit cette femme, il se dirigeait vers sa maison."
,"9":"C'était le soir, à la tombée du jour, déjà c'était la nuit et l'obscurité."
,"10":"Et voici qu'elle vient à sa rencontre, vêtue comme une prostituée et couverte d'un voile."
,"11":"C'est la femme effrontée, qui n'a plus de honte, qui ne tient plus en place dans sa maison."
,"12":"Tantôt dans la rue, tantôt sur les places, de tous côtés elle cherche l'aventure."
,"13":"Elle se jette sur ce jeune homme et l'embrasse; elle lui dit d'un ton assuré:"
,"14":"'Il me fallait offrir un sacrifice, aujourd'hui même je devais m'acquitter d'un voeu."
,"15":"Je suis donc sortie à ta recherche pour que tu sois au repas et je t'ai trouvé."
,"16":"J'ai garni mon divan de couvertures, de fine toile d'Egypte. J'ai parfumé mon lit avec de la myrrhe, de l'aloès et de la marjolaine."
,"18":"Viens, prenons notre plaisir, enivrons-nous d'amour jusqu'au matin!"
,"19":"Mon mari n'est pas à la maison, il est en voyage loin d'ici; il a pris l'argent avec lui et ne reviendra à la maison qu'à la pleine lune.'"
,"21":"A force d'habileté elle réussit à le convaincre, elle le séduit et l'entraîne."
,"22":"Il la suit aussitôt, comme un boeuf qu'on mène à l'abattoir, comme un cerf pris au noeud coulant,"
,"23":"à qui bientôt une flèche percera le foie. Il est comme l'oiseau qui se jette dans le filet, sans savoir qu'il y va de sa vie!"
,"24":"Donc vous, mes fils, écoutez-moi; retenez bien cette consigne:"
,"25":"ne te laisse pas séduire par une de ces femmes, ne te laisse pas égarer par ses manoeuvres."
,"26":"Car elle a déjà fait beaucoup de victimes, et les plus forts y sont tombés."
,"27":"De sa maison on passe chez les morts, c'est un chemin qui s'enfonce vers le monde des morts."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Qui appelle? n'est-ce pas la Sagesse? Cette voix, n'est-ce pas l'Intelligence?"
,"2":"Elle s'est postée sur la hauteur, au bord de la route, au carrefour des chemins."
,"3":"La voici qui appelle, juste aux portes de la ville, aux entrées les plus fréquentées:"
,"4":"'C'est à vous, les humains, que je m'adresse, je lance un appel aux enfants des hommes!"
,"5":"Apprenez à juger, vous qui ne savez pas, et vous qui ne pensez à rien, devenez réfléchis!"
,"6":"Ecoutez-moi, je dirai l'essentiel, rien ne sort de mes lèvres qui ne soit exact."
,"7":"C'est la vérité qui tombe de ma bouche, car je déteste les discours hypocrites."
,"8":"Toutes mes paroles sont sincères, pas une qui soit douteuse ou falsifiée."
,"9":"Toutes sont exactes: un esprit ouvert s'en rend compte; elles sont justes: on le voit avec un peu de savoir."
,"10":"Faites vôtre ma discipline, plutôt que l'argent, choisissez la science et non pas l'or fin."
,"11":"La sagesse est plus utile que les perles, quel trésor pourrait l'égaler?"
,"12":"Moi, la Sagesse, j'habite avec l'art de juger, l'action réfléchie me compte entre ses amies."
,"13":"(Détester le mal, c'est craindre Yahvé). Je déteste l'orgueil et l'arrogance, les chemins qui mènent au mal et l'hypocrisie."
,"14":"Mais chez moi l'on trouve bon sens et savoir-faire, l'intelligence ainsi que la puissance."
,"15":"Par moi règnent les rois, et leurs ministres décident avec justice;"
,"16":"grâce à moi se maintiennent les princes, et les grands, et ceux qui gouvernent la terre."
,"17":"J'aime ceux qui m'aiment, ceux qui me cherchent me rencontrent."
,"18":"Ils trouvent avec moi honneur et richesse, fortune durable et prospérité."
,"19":"Mes fruits sont meilleurs que l'or fin, ce que j'apporte vaut bien plus que l'argent."
,"20":"Je fais route sur un chemin de droiture, d'où partent en tout sens les sentiers de la justice;"
,"21":"je vais, comblant de biens ceux qui m'aiment, et je fais pour eux le plein de leurs réserves."
,"22":"Yahvé m'a créée, - ce fut le début de son oeuvre - avant toutes ses créatures, depuis toujours."
,"23":"Avant les siècles je fus formée, dès le commencement, bien avant la terre."
,"24":"Les océans n'étaient pas là quand je suis née, pas une des fontaines d'où jaillissent les mers."
,"25":"Les montagnes n'étaient pas apparues, pas de collines encore quand je fus enfantée,"
,"26":"Yahvé n'avait pas fait la terre et la campagne, ni même la poussière primitive du monde."
,"27":"J'étais là quand il mit les cieux en place, quand il traça sur l'océan le cercle des terres,"
,"28":"quand il mit d'office les nuées dans les hauteurs et régla au fond des mers le débit de leurs eaux,"
,"29":"quand il imposa à la mer ses frontières, une limite que ne franchiraient pas les flots. Alors qu'il posait les fondements de la terre, "
,"30":"moi, à ses côtés, je faisais maître d'oeuvre. J'étais, jour après jour, tout son plaisir, et sans cesse je jouais en sa présence."
,"31":"Je joue sur ce monde, sur la terre qu'il a faite, et mon grand plaisir, c'est d'être chez les humains."
,"32":"Vous donc, mes fils, écoutez-moi: heureux ceux qui suivent mes chemins!"
,"33":"Accueillez ma discipline et devenez des sages, ne la méprisez pas!"
,"34":"Heureux celui qui m'écoute, qui chaque jour veille à ma porte et reste sur le seuil, en éveil."
,"35":"Car celui qui me trouve a trouvé la vie, les faveurs de Yahvé viendront sur lui;"
,"36":"mais celui qui m'offense attente à sa vie, tous ceux qui me haïssent ont choisi la mort.'"
}`)
	CurrentBook.AddChapter(9, `{
"1":"La Sagesse a bâti sa maison, elle en a dressé les sept colonnes."
,"2":"Elle a abattu ses bêtes et mélangé ses vins, elle avait déjà dressé sa table."
,"3":"Elle a fait lancer un appel, par ses servantes, depuis les hauteurs de la cité haute:"
,"4":"'Faites un tour par ici, vous qui ne savez pas!',A ceux qui ne pensent à rien, elle dit: "
,"5":"'Venez, mangez mon pain, et buvez du vin que j'ai préparé!"
,"6":"Laissez là votre folie et vous vivrez, marchez sur les chemins de la vérité!'"
,"7":"Qui reprend un moqueur s'attire des insultes; qui réprimande un méchant risque d'être humilié."
,"8":"Ne reprends pas le moqueur, tu t'en ferais un ennemi; reprends le sage, et il t'aimera."
,"9":"Donne au sage, et il deviendra plus sage; instruis un homme droit, et il en saura davantage."
,"10":"La crainte de Yahvé est le commencement de la sagesse; la véritable intelligence, c'est de connaître Celui qui est Saint."
,"11":"C'est alors que tu vivras des jours nombreux, tu multiplieras les années de ta vie."
,"12":"Si tu es sage, la sagesse travaillera pour toi; si tu es moqueur, toi seul en paieras les conséquences."
,"13":"Dame Folie est agitée, sotte et ignorante."
,"14":"Elle s'est assise à la porte de sa maison, sur un siège, au sommet de la ville."
,"15":"De là elle interpelle les passants qui vont leur chemin:"
,"16":"'Faites un tour par ici, vous qui ne savez pas!' Elle dit à ceux qui ne pensent à rien:"
,"17":"'Les eaux dérobées sont plus douces, le pain qu'on mange en cachette est bien plus savoureux!'"
,"18":"Mais l'auditeur ne sait pas que les morts rôdent alentour, ceux qu'elle invite descendent aux enfers."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Proverbes de Salomon: Un fils sage fait la joie de son père; un fils insensé fait le chagrin de sa mère."
,"2":"Les trésors mal acquis ne profitent pas; une vie droite, par contre, délivre de la mort."
,"3":"Yahvé ne veut pas que le juste souffre de la faim, mais il laisse les méchants insatisfaits."
,"4":"La main paresseuse attire la pauvreté; la main diligente enrichit."
,"5":"L'homme avisé moissonne quand c'est l'été; bien sot celui qui dort à la moisson."
,"6":"Les bénédictions viendront sur la tête du juste, mais les cris des méchants seront étouffés."
,"7":"On bénira la mémoire du juste, mais le nom des méchants tombera en pourriture."
,"8":"L'homme au coeur sage accepte les conseils, alors que le prétentieux court à sa perte."
,"9":"Qui marche avec intégrité marche en sécurité, mais qui prend des chemins tortueux sera vite démasqué."
,"10":"Un clignement d'oeil te prépare des ennuis; un reproche rétablira la paix."
,"11":"La bouche de l'homme droit est une source de vie; celle des méchants dissimule la violence."
,"12":"La haine fait surgir les querelles, l'amour excuse toutes les fautes."
,"13":"La sagesse se trouve sur les lèvres de l'homme intelligent, on verra le bâton sur le dos de l'insensé."
,"14":"Les sages font des réserves de savoir, la bouche du sot répand le malheur."
,"15":"La fortune du riche lui fait un rempart, la pauvreté de l'indigent fait son malheur."
,"16":"Les travaux de l'homme droit lui procurent la vie; le gain du méchant fera sa ruine."
,"17":"Respecter l'avertissement, c'est un chemin de vie; qui néglige la réprimande se fourvoie."
,"18":"Qui dissimule sa haine est un fourbe, qui fait courir la calomnie est un insensé."
,"19":"Qui parle trop n'évitera pas le péché, l'homme sensé surveille ses paroles."
,"20":"Le juste parle: c'est un argent de choix; les pensées du méchant: elles ne valent rien."
,"21":"Beaucoup s'alimentent aux paroles du juste, tandis que les insensés meurent de leur propre sottise."
,"22":"C'est la bénédiction de Yahvé qui enrichit; l'effort de l'homme n'y ajoute rien."
,"23":"L'insensé se plaît à préparer le mal, de même l'homme avisé à cultiver la sagesse."
,"24":"Ce que le méchant redoutait lui arrive; ce que le juste a souhaité lui est accordé."
,"25":"Quand la tempête a passé, le méchant a disparu, mais le juste demeure à jamais."
,"26":"Du vinaigre sur les dents, de la fumée dans les yeux, voilà bien ce qu'est le paresseux pour son patron."
,"27":"La crainte de Yahvé te prolongera tes jours; les années du méchant seront abrégées."
,"28":"Après avoir espéré, le juste connaîtra la joie, mais l'attente des méchants sera déçue."
,"29":"Yahvé a prévu un refuge pour l'homme intègre, et la ruine pour ceux qui font le mal."
,"30":"Le juste est ébranlé, mais non pour toujours, les méchants par contre n'occuperont pas le pays."
,"31":"La sagesse sort de la bouche des justes; la langue menteuse sera arrachée."
,"32":"La bonté se loge sur les lèvres du juste, et la corruption dans la bouche des méchants."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Yahvé déteste la balance fausse, le poids juste lui est agréable."
,"2":"Aujourd'hui l'arrogance, demain la honte: la sagesse était chez les modestes."
,"3":"L'intégrité se charge de guider les hommes droits; la perversité mène les impies à la ruine."
,"4":"Au jour de la Colère la richesse ne servira de rien, mais l'honnêteté délivrera de la mort."
,"5":"A l'homme intègre la droiture ouvre un chemin droit; les méchants se prendront à leur propre malice."
,"6":"Les hommes droits se sauvent grâce à leur justice, mais les impies sont pris à leur propre convoitise."
,"7":"Quand vient la mort, plus d'espoir pour l'impie; la sécurité que lui donnait sa fortune a disparu."
,"8":"Le juste sera délivré du danger, un méchant y tombera à sa place."
,"9":"L'impie parle de façon à ruiner son prochain; les justes y échapperont par leur clairvoyance."
,"10":"Quand les justes ont le dessus, la ville est dans la joie; quand les méchants sont ruinés, c'est la fête."
,"11":"La ville prospérera si les gens honnêtes la bénissent; sa ruine viendra des intrigues des méchants."
,"12":"L'homme sans coeur dénigre son prochain, l'homme avisé garde le silence."
,"13":"Le rapporteur révèle les secrets; qui mérite confiance garde le secret."
,"14":"Faute de direction, le peuple est à la dérive; le salut dépend du nombre de conseillers."
,"15":"Qui se porte garant pour un étranger risque gros; celui qui s'en abstient sera en sécurité."
,"16":"Une femme aimable se taille une réputation, des hommes énergiques se montent une fortune."
,"17":"En étant généreux on se fait du bien, celui qui est dur blesse sa propre chair."
,"18":"Le salaire du méchant le décevra; celui qui sème le bien, sa récompense est assurée."
,"19":"La vie droite procure la vie, qui a choisi le mal va à la mort."
,"20":"Yahvé déteste l'homme corrompu, ceux qui restent intègres ont sa faveur."
,"21":"Le méchant ne restera jamais impuni, mais la descendance des justes sera sauvée."
,"22":"Une jolie femme dépourvue de bon sens, c'est un anneau d'or au nez d'un cochon."
,"23":"Les justes ne désirent que le bien; les méchants ont aussi leurs espoirs, mais ils vont à l'échec."
,"24":"L'un dépense largement et il s'enrichit, l'autre économise et il s'appauvrit."
,"25":"Celui qui est généreux sera rassasié, celui qui arrose sera arrosé."
,"26":"Le peuple maudit celui qui accapare le blé; on bénit celui qui vend son grain."
,"27":"Qui cherche à bien faire sera béni; si quelqu'un poursuit le mal, le mal l'atteindra."
,"28":"Celui qui compte sur ses richesses tombera, tandis que les justes verront croître leur ramure."
,"29":"Qui ne sait ordonner sa maison n'héritera que du vent; le sot terminera au service du sage."
,"30":"Le fruit du juste est un arbre de vie; les méchants seront arrachés avant le temps."
,"31":"Oui, le juste reçoit son dû sur cette terre, et combien plus le méchant et le pécheur!"
}`)
	CurrentBook.AddChapter(12, `{
"1":"Celui qui aime qu'on le reprenne aime le savoir; qui déteste la réprimande est un sot."
,"2":"Yahvé favorise celui qui est bon, mais il condamne l'homme retors."
,"3":"Qui fait le mal n'est jamais en sûreté; le juste, lui, est indéracinable."
,"4":"Une femme vaillante est la fierté de son mari, celle qui ne sait pas rougir lui est un cancer dans les os."
,"5":"Les justes cherchent à bien faire, les projets des méchants ne sont que tromperie."
,"6":"Les paroles des méchants sont autant de pièges, mais les hommes droits ont la réponse pour y échapper."
,"7":"Les méchants chancellent, ils ne sont plus, mais la maison des justes reste debout."
,"8":"Chacun est apprécié à la mesure de son bon sens, qui a l'esprit tortueux est voué au mépris."
,"9":"Mieux vaut être sans titres mais avoir un serviteur, que de jouer au grand quand on manque de pain."
,"10":"Le juste connaît les besoins de son bétail; le méchant, par contre, n'a pas d'entrailles."
,"11":"Qui cultive son champ aura du pain à suffisance, mais c'est manquer de bon sens que de courir après le vent."
,"12":"Les ambitions des méchants préparent leur malheur, le juste par contre est un arbre qui donne."
,"13":"Le méchant se prend dans ses propres pièges, le juste se tire de toute détresse."
,"14":"Qui sait parler ne manquera pas de pain, qui travaille de ses mains en sera récompensé."
,"15":"Le sot est sûr de ses choix, mais le sage écoute les conseils."
,"16":"Le sot montre aussitôt son mécontentement, l'homme avisé ne relève pas l'affront."
,"17":"L'homme honnête fera voir la vérité, le faux témoin embrouillera tout."
,"18":"Des paroles inconsidérées blessent comme une épée, la parole des sages est un remède."
,"19":"Une parole vraie vaudra toujours, ce qui est falsifié n'aura qu'un temps."
,"20":"La tromperie se loge dans le coeur des intrigants, la joie, dans celui du bon conseiller."
,"21":"Le malheur ne tombera pas sur le juste, tandis que les méchants auront leur compte de maux."
,"22":"Yahvé déteste les lèvres menteuses, mais il favorise ceux qui font la vérité."
,"23":"L'homme intelligent n'étale pas ce qu'il sait, les sots ne pensent qu'à manifester leurs sottises."
,"24":"La main qui travaille prendra les rênes, et les corvées seront pour le paresseux."
,"25":"Une peine intime affaiblit les énergies, une bonne nouvelle rend la joie."
,"26":"Le juste saura guider son prochain, tandis que les méchants s'égareront sur leur chemin."
,"27":"Pas de gibier à rôtir pour le nonchalant; être actif, c'est le secret de la richesse."
,"28":"La vie se trouve sur le droit chemin, le chemin tortueux conduit à la mort."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Un fils sage écoute les avis de son père, le railleur ne tient pas compte des reproches."
,"2":"Chacun récolte le fruit de ses décisions: tu goûteras au bonheur, pendant que l'impie sera rassasié de violence."
,"3":"Qui surveille ses paroles aura longue vie, qui parle sans arrêt, ce sera sa ruine."
,"4":"Si l'on en reste à désirer, rien ne vient: ce sont les actifs qui s'engraissent."
,"5":"L'homme droit a horreur du mensonge, c'est le méchant qui salit et calomnie."
,"6":"La droiture se charge de protéger l'homme droit; la méchanceté mène le méchant à sa perte."
,"7":"Tel fait le riche mais il n'a rien, tel fait le pauvre et il a de grands biens."
,"8":"Le riche paie la rançon qui le sauve, mais le pauvre ne se sent pas menacé."
,"9":"La lumière des justes brille, tandis que s'éteint la lampe des méchants."
,"10":"L'arrogance ne rapporte que des disputes, il est plus sage de se laisser conseiller."
,"11":"Fortune vite acquise ne tient pas, qui la gère à son rythme l'augmente."
,"12":"L'espoir différé décourage, le désir comblé est un arbre de vie."
,"13":"Qui méprise les avertissements se perdra, qui observe le commandement sera récom pensé."
,"14":"L'enseignement du sage est source de vie, il fait échapper aux pièges de la mort."
,"15":"Qui agit avec bon sens sera apprécié, le chemin des traîtres ne mène nulle part."
,"16":"L'homme avisé agit à bon escient, l'insensé étale sa folie."
,"17":"Un messager trompeur prépare un échec, un messager fidèle donne le réconfort."
,"18":"Misère et honte pour celui qui rejette les avis; qui observe la remontrance se fera estimer."
,"19":"C'est toujours agréable d'avoir ce qu'on désire; les sots ne veulent pas renoncer au mal."
,"20":"Qui va avec les sages devient sage, qui fréquente les insensés se pervertit."
,"21":"Le malheur poursuit les pécheurs, le bonheur viendra récompenser les justes."
,"22":"Les bons laissent à leurs enfants et petits-enfants leur héritage; la fortune des pécheurs est réservée au juste."
,"23":"Le champ que travaille le pauvre lui donne bien à manger; un autre dépérit faute de justice."
,"24":"Ne pas user du fouet, c'est ne pas aimer son fils: celui qui l'aime n'attend pas pour le corriger."
,"25":"Le juste mange à son appétit; le ventre des méchants crie famine."
}`)
	CurrentBook.AddChapter(14, `{
"1":"La sagesse construit la maison, la sottise la renverse de ses propres mains."
,"2":"Celui qui craint Yahvé prend le droit chemin, celui qui le méprise s'en éloigne."
,"3":"Les paroles du sot le font remettre en place, les propos des sages seront leur protection."
,"4":"Pas de boeufs: les greniers resteront vides; les rentrées sont à la mesure de la force des bêtes."
,"5":"Un témoin digne de foi dit la vérité, un faux témoin ment comme il respire."
,"6":"Le moqueur cherche la sagesse, mais en vain; l'homme réfléchi apprend vite."
,"7":"Ecarte-toi du sot; ce n'est pas de sa bouche que tu recevras la sagesse."
,"8":"La sagesse de l'homme habile, c'est de savoir où il va; la folie des sots les égare."
,"9":"Les sots se moquent du péché, mais Dieu favorise les hommes droits."
,"10":"Le coeur connaît ses propres chagrins, et sa joie, nul autre ne pourra la partager."
,"11":"La maison des méchants sera détruite, mais la tente des justes ne bougera pas."
,"12":"Tu en verras dont la route leur paraît droite, mais au bout du chemin c'est la mort."
,"13":"Même au milieu du rire le coeur a ses peines, la joie se termine en chagrin."
,"14":"Le dévoyé va se repaître de sa conduite, et de même l'homme de bien."
,"15":"Le naïf croit tout ce qu'on dit, mais le prudent regarde où il met les pieds."
,"16":"Le sage craint le mal et s'en détourne, le sot va de l'avant sans s'inquiéter."
,"17":"Le coléreux fait des bêtises, l'homme réfléchi supporte."
,"18":"Les naïfs n'acquièrent que la sottise, les habiles pourront être fiers de leur savoir."
,"19":"Les méchants s'inclineront devant les bons, les pécheurs attendront devant la porte du juste."
,"20":"Même à son compagnon le pauvre est insupportable, tandis que le riche a de nombreux amis."
,"21":"Qui méprise son prochain commet un péché; heureux celui qui a pitié des malheureux."
,"22":"Ne font-ils pas fausse route ceux qui complotent le mal? La bonté et la fidélité n'accompagnent-elles pas celui qui cherche le bien?"
,"23":"Toute peine a son profit, mais ce qui reste en paroles conduit au dénuement."
,"24":"La richesse vient couronner les sages, mais le sot n'aura d'autre parure que sa bêtise."
,"25":"Un témoin véridique sauve des vies, le rusé profère des mensonges."
,"26":"Qui a la crainte de Yahvé possède un ferme appui, ses enfants pourront compter sur lui."
,"27":"La crainte de Yahvé est source de vie, elle fait échapper aux pièges de la mort."
,"28":"Un peuple nombreux fait la gloire de son roi; si les sujets manquent, c'est la ruine du souverain."
,"29":"Qui est lent à la colère fait preuve de bon sens, celui qui ne se domine pas étale sa folie."
,"30":"La paix du coeur favorise la santé, mais la jalousie ronge les os."
,"31":"Qui écrase le pauvre insulte son Créateur, qui a pitié des indigents lui rend hommage."
,"32":"Le méchant est renversé par sa propre malice, mais jusque dans la mort le juste est assuré."
,"33":"La sagesse habite au coeur des hommes de bon sens, la sottise se trouve parmi les insensés."
,"34":"Une nation grandit par la justice; le péché fait la honte des peuples."
,"35":"Le serviteur avisé sera apprécié du roi, l'incapable aura droit à sa colère."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Une réponse aimable calme la fureur, une parole blessante fait monter la colère."
,"2":"Les paroles des sages répandent le savoir, tandis que la bouche des sots déborde de folie."
,"3":"Les yeux de Yahvé sont en tout lieu, ils observent les méchants et les bons."
,"4":"Les paroles apaisantes sont un arbre de vie; la langue perverse brise les énergies."
,"5":"Le sot méprise la correction de son père, c'est de l'intelligence que de tenir compte des avis."
,"6":"Il y a bien des richesses dans la maison du juste, et bien des problèmes dans les revenus du méchant."
,"7":"Les paroles des sages propagent le savoir; tout autre est le coeur des sots."
,"8":"Yahvé a horreur du sacrifice des méchants, mais il accueille avec joie la prière des justes."
,"9":"Yahvé déteste ceux qui se conduisent mal, mais il aime celui qui recherche le bien."
,"10":"Une punition sévère attend celui qui sort du chemin; s'il refuse la correction, il mourra."
,"11":"Le monde infernal et la mort sont à nu devant Yahvé, combien plus le coeur des humains!"
,"12":"Le moqueur n'aime pas qu'on le reprenne, c'est pourquoi il évite la compagnie des sages."
,"13":"Coeur joyeux, visage illuminé; coeur en peine, esprit abattu."
,"14":"L'intelligent est en recherche du savoir, la bouche des sots ressasse leurs folies."
,"15":"Pour le malheureux tous les jours sont mauvais, qui a le coeur joyeux est toujours en fête."
,"16":"Qui craint Yahvé, le peu qu'il a vaut mieux qu'un trésor qui ne laisse pas en paix."
,"17":"Le plat de légumes, là où l'on s'aime, est meilleur qu'un boeuf gras avec la mésentente."
,"18":"L'homme colérique provoque les disputes, qui est lent à la colère ramène le calme."
,"19":"Le chemin du paresseux est coupé de ronces, le sentier des actifs est comme une route."
,"20":"Un fils sage sera la joie de son père, le sot fera la honte de sa mère."
,"21":"Qui a la sagesse, c'est lui qui est intelligent."
,"22":"Faute de réflexion les projets échouent; ils réussiront si on a les a bien mûris."
,"23":"Heureux celui qui a la bonne réponse, quelle bonne chose qu'une réponse qui tombe à pic!"
,"24":"L'homme sensé monte le chemin de vie, il se garde de la descente au séjour des morts."
,"25":"Yahvé renverse la maison des orgueilleux, mais il protège l'enclos de la veuve."
,"26":"Yahvé déteste les projets pervers, la pureté qu'il attend, ce sont les paroles bienveillantes."
,"27":"Qui court après l'argent démonte sa maison, qui ne se laisse pas acheter vivra."
,"28":"L'homme droit réfléchit avant de répondre, la méchanceté sort toute seule de la bouche des mauvais."
,"29":"Yahvé se tient à l'écart des méchants, mais il écoute la prière des justes."
,"30":"Un regard bienveillant réjouit le coeur, une bonne nouvelle redonne des forces."
,"31":"Qui tend l'oreille aux avis salutaires aura sa place parmi les sages."
,"32":"Qui méprise la correction se fait tort à soi-même, qui écoute les avis forme son jugement."
,"33":"La crainte de Yahvé est l'école de la sagesse; avant la gloire il faut l'humilité."
}`)
	CurrentBook.AddChapter(16, `{
"1":"A l'homme les projets, à Yahvé la décision!"
,"2":"Chacun justifie les décisions qu'il a prises, mais Yahvé pèse les coeurs."
,"3":"Remets à Yahvé les fruits de ton travail, et tes projets se réaliseront."
,"4":"Yahvé a fait toutes choses en vue d'une fin, et même les méchants pour le jour du malheur."
,"5":"Un coeur hautain, Yahvé le déteste: il ne pourra pas rester impuni."
,"6":"Par la bonté et la fidélité on expie sa faute, mais avec la crainte de Yahvé on se détourne du mal."
,"7":"Si Yahvé apprécie ta conduite, il fera que tes ennemis se réconcilient avec toi."
,"8":"Pour qui est honnête, le peu qu'il a vaut mieux qu'un gros revenu mal acquis."
,"9":"Chacun décide en soi-même son chemin, mais c'est Yahvé qui assure ses pas."
,"10":"Le roi a parlé: c'est un oracle! Il ne se trompe pas lorsqu'il doit juger."
,"11":"Yahvé exige balance et plateaux justes; le jeu complet des poids est son affaire."
,"12":"Les rois ne font le mal à aucun prix: ils savent que leur trône a pour base la justice."
,"13":"Qui commande avec justice est apprécié du roi; il aime les hommes droits."
,"14":"Fureur du roi: danger de mort! Mais un homme sage peut l'apaiser."
,"15":"Que s'éclaire le visage du roi et c'est la vie! Sa bienveillance est comme une pluie de printemps."
,"16":"Acquiers la sagesse plutôt que l'or; acquiers un jugement sûr au lieu de rechercher l'argent."
,"17":"La route des hommes droits les éloigne du mal; qui regarde où il marche restera en vie."
,"18":"Avant la ruine il y a eu l'orgueil; l'arrogance a précédé la chute."
,"19":"Mieux vaut rester humble avec ceux d'en-bas que de partager les dépouilles avec les orgueilleux."
,"20":"Qui réfléchit sur les dits et gestes trouvera le bonheur; heureux celui qui se fie en Yahvé!"
,"21":"Qui a la sagesse, c'est lui qui est intelligent: les paroles qui tombent juste emportent l'adhésion."
,"22":"Le bon sens est source de vie pour qui le possède, la bêtise des sots sera leur châtiment."
,"23":"La sagesse qu'on a au coeur donne un sens au discours: ce sont des paroles qui emporteront l'adhésion."
,"24":"Des propos bienveillants sont comme un rayon de miel: agréables à la bouche, bons pour la santé."
,"25":"Notre chemin parfois nous semble droit, mais il conduit finalement à la mort."
,"26":"Le besoin du travailleur travaille pour lui, sa bouche a des exigences et le presse."
,"27":"Le vaurien prépare le malheur; ce qui sort de sa bouche est un feu dévorant."
,"28":"L'homme pervers provoque les disputes, et le rapporteur divise les amis."
,"29":"Qui veut abuser de son prochain commence par le séduire, et il le met sur une mauvaise voie."
,"30":"Celui qui regarde de travers médite des fourberies: il pince les lèvres, il a déjà commis le péché."
,"31":"Les cheveux blancs sont une couronne respectable: elle est au bout du chemin de la justice."
,"32":"Qui est lent à la colère vaut mieux qu'un héros; qui sait se dominer est plus qu'un preneur de villes."
,"33":"On a tiré à pile ou face dans le pan du manteau, mais c'est de Yahvé qu'est venue la décision!"
}`)
	CurrentBook.AddChapter(17, `{
"1":"Mieux vaut un morceau de pain sec et la paix, qu'une maison où les festins se terminent en dispute."
,"2":"Un serviteur astucieux l'emportera sur le fils indigne; il aura part à l'héritage avec les fils."
,"3":"On éprouve au feu l'argent, on met l'or au creuset, mais c'est Yahvé qui sonde les coeurs."
,"4":"Le méchant écoute le mauvais conseiller, le menteur prête l'oreille à celui qui déforme."
,"5":"Celui qui se moque des pauvres insulte leur Créateur; qui se réjouit du malheur d'autrui ne restera pas impuni."
,"6":"Les petits-enfants des vieillards sont leur couronne, tout comme les pères sont la fierté de leurs fils."
,"7":"Un langage noble ne va guère à un sot, et moins encore le mensonge à un prince."
,"8":"La gratification, quelle pierre magique pour celui qui en use! où qu'il se tourne, il réussit."
,"9":"En pardonnant une faute on renforce l'amitié; en la faisant savoir on perdrait son ami."
,"10":"Un reproche a plus d'effet sur l'homme intelligent que cent coups de bâton sur un sot."
,"11":"Le méchant ne pense qu'à se révolter, mais on prendra des mesures sévères contre lui."
,"12":"Plutôt rencontrer une ourse privée de ses petits qu'un sot en plein délire!"
,"13":"Qui rend le mal pour le bien, le malheur ne s'écartera pas de sa maison!"
,"14":"Entamer un procès, c'est ouvrir une écluse; désiste-toi avant que s'engage la querelle!"
,"15":"Acquitter le coupable, condamner l'innocent: deux choses également odieuses à Yahvé!"
,"16":"A quoi sert l'argent aux mains d'un sot? Puisqu'il est sot, il n'achètera pas la sagesse."
,"17":"Un ami t'aimera en tout temps: un frère t'est né, en prévision des jours mauvais."
,"18":"Il faut être bien sot pour se porter garant d'un autre et s'engager à la place de son prochain."
,"19":"Aimer la querelle, c'est rechercher les coups, qui prend un ton arrogant cherche son propre malheur."
,"20":"Qui mène un double jeu ne trouvera pas le bonheur; les mauvaises langues tomberont dans le malheur."
,"21":"Qui met au monde un sot en aura du chagrin; le père d'un insensé n'aura guère à s'en réjouir."
,"22":"La bonne humeur réussit à l'organisme; si l'esprit est triste, les nerfs sont en déprime."
,"23":"Le méchant accepte des cadeaux en sous main, pour faire une entorse à la justice."
,"24":"L'homme intelligent tient les yeux fixés sur la sagesse, les regards du sot vagabondent aux quatre coins du monde."
,"25":"Un fils insensé fait le chagrin de son père, et la tristesse de celle qui l'a enfanté."
,"26":"Punir un innocent n'est vraiment pas bien, et frapper des gens honorables va contre le droit."
,"27":"L'homme d'expérience évite de trop parler, l'homme intelligent prend le temps de réfléchir."
,"28":"Même un sot passerait pour sage s'il savait se taire; tant qu'il ferme la bouche il est intelligent."
}`)
	CurrentBook.AddChapter(18, `{
"1":"L'égoïste suit son bon plaisir; il se hérisse contre tout conseil."
,"2":"Le sot ne veut pas réfléchir, mais étaler ses opinions."
,"3":"La méchanceté attire le mépris, une conduite honteuse attire les reproches."
,"4":"La parole humaine est une eau profonde, une fontaine jaillissante, une source de vie."
,"5":"Il n'est pas bien de céder au méchant, et de condamner celui qui est dans son droit."
,"6":"Les réflexions du sot attirent la dispute; quand il parle, il appelle la bagarre."
,"7":"Le sot parle et se fait tort à lui-même: il se prépare un piège."
,"8":"Les paroles du médisant sont comme des friandises; elles glissent doucement jusqu'au fond des entrailles."
,"9":"Celui qui se relâche dans son travail est frère de celui qui démolit."
,"10":"Le nom de Yahvé est une forteresse; le juste y accourt et s'y trouve en sécurité."
,"11":"La fortune du riche, voilà sa ville forte; elle lui semble un rempart imprenable."
,"12":"L'arrogance de l'homme a précédé sa ruine; l'humilité a précédé la gloire."
,"13":"Qui répond avant d'avoir écouté passe pour stupide et se couvre de ridicule."
,"14":"L'esprit de l'homme est ce qui le maintient dans sa maladie; mais comment relever l'esprit abattu?"
,"15":"Un esprit ouvert acquiert des connaissances; l'oreille du sage est à la recherche du savoir."
,"16":"Un cadeau vous ouvre les portes; c'est la façon de s'introduire auprès des grands."
,"17":"Dans une dispute, le premier a raison; mais l'autre se présente, et tout est à revoir."
,"18":"Le tirage à pile ou face pourrait résoudre bien des querelles, et même trancher entre des puissants."
,"19":"Un frère aidé par son frère est comme une forteresse, et des amis, comme les verroux d'une tour."
,"20":"Tout ce que tu as dit, tu t'en rempliras l'estomac; tu mangeras jusqu'à plus faim ce qui est tombé de tes lèvres."
,"21":"La langue a pouvoir sur la mort et sur la vie; selon l'usage qu'on en fait, on en goûtera les fruits."
,"22":"Qui a trouvé une épouse a trouvé le bonheur; c'est Yahvé qui lui en fait la grâce."
,"23":"Le mendiant parle en suppliant, mais le riche lui répond avec dureté."
,"24":"Il y a des amis qui conduisent au malheur, mais tel autre est plus attaché qu'un frère."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Mieux vaut le pauvre qui vit honnêtement, que l'insensé qui a su se débrouiller."
,"2":"Même l'enthousiasme ne vaut rien s'il n'y a pas réflexion; qui se précipite perd son chemin."
,"3":"On se ruine par sa propre bêtise, et puis c'est à Yahvé qu'on s'en prend!"
,"4":"La fortune attire de nombreux amis, tandis qu'en devenant pauvre on perd les siens."
,"5":"Le faux témoin ne restera pas impuni, celui qui ment quand il témoigne n'échappera pas."
,"6":"Un notable a beaucoup de flatteurs, tous sont amis de celui qui arrose."
,"7":"Le pauvre est rejeté de tous ses frères, ses amis ont été les premiers à s'éloigner. Avec qui parler? Ils ne se présentent pas."
,"8":"Qui acquiert du bon sens se fait du bien à lui-même; qui agit avec intelligence trouvera le bonheur."
,"9":"Le faux témoin ne restera pas impuni, celui qui ment quand il témoigne périra."
,"10":"Il ne convient pas qu'un sot vive dans le luxe, et moins encore qu'un esclave commande à des princes."
,"11":"Un homme intelligent surmonte sa colère; en méprisant l'offense il se grandit."
,"12":"La fureur du roi est comme le rugissement du lion, sa bienveillance est comme la rosée sur l'herbe."
,"13":"Un fils stupide fait le malheur de son père; les criailleries d'une femme n'ont pas plus de fin qu'une fuite d'eau."
,"14":"On hérite de son père une maison et des biens, mais c'est Yahvé qui donne une épouse de bon sens."
,"15":"La paresse amène la torpeur; le nonchalant connaîtra la faim."
,"16":"Qui garde le commandement se garde lui-même; qui méprise la parole mourra."
,"17":"Qui a pitié du pauvre prête à Yahvé: il saura payer sa dette."
,"18":"Corrige ton fils tant qu'il y a espoir: sinon, tu serais responsable de sa mort."
,"19":"Celui qui s'est emporté doit payer; si on l'en exempte, il recommencera."
,"20":"Ecoute les conseils, reçois l'enseignement: à la fin tu seras un sage."
,"21":"L'homme soupèse les nombreuses possibilités, mais c'est le dessein de Yahvé qui se réalisera."
,"22":"C'est la bonté d'un homme qui le fait aimer, on préfère un pauvre à un arrogant."
,"23":"La crainte de Yahvé te fera vivre: tu dormiras tranquille, à l'abri du malheur."
,"24":"Quand le paresseux tend la main vers le plat, il ne la ramène pas à la bouche."
,"25":"Punis le moqueur, et le naïf fera attention; fais une remarque à l'homme sensé et il comprendra."
,"26":"Qui dépouille son père et chasse sa mère est un fils infâme et dénaturé."
,"27":"Quand le fils n'écoute plus ceux qui le reprennent, il ne peut que ruminer des pensées mauvaises."
,"28":"Un témoin pervers se moque de la justice; la bouche des méchants se complaît dans l'injustice."
,"29":"Le fouet est pour ceux qui se moquent, le bâton a été fait pour le dos des sots."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Le vin rend moqueur, l'alcool excite: celui qui s'y adonne ne sera pas un sage."
,"2":"La colère du roi est comme le rugissement du lion; qui la provoque risque sa vie."
,"3":"C'est la gloire d'un homme que d'éviter les disputes, ceux qui s'emportent sont les sots."
,"4":"Le paresseux n'a pas labouré à l'automne; l'été venu il pourra chercher: rien!"
,"5":"Les desseins qu'on porte en soi sont une eau profonde, qui est intelligent saura y puiser."
,"6":"De beaucoup de gens on dit qu'ils sont bons, mais qui trouvera un homme sûr?"
,"7":"Le juste mène une vie irréprochable; heureux ses fils après lui!"
,"8":"Quand le roi siège à son tribunal, il discerne aussitôt tout ce qui est mal."
,"9":"Qui peut dire: mon coeur est pur, je suis net de tout péché?"
,"10":"Deux poids et deux mesures: double abomination pour Yahvé!"
,"11":"Par ses actes le jeune garçon montre déjà si sa conduite sera juste et droite."
,"12":"L'oreille qui entend, l'oeil qui voit, Yahvé les a faits l'un et l'autre."
,"13":"Ne t'habitue pas à somnoler, la pauvreté viendrait; garde les yeux ouverts et tu auras du pain en abondance."
,"14":"'Mauvaise affaire, mauvaise affaire!' dit l'acheteur, mais il s'en va content de lui."
,"15":"Il y a l'or, il y a bien des perles, mais la chose la plus précieuse, c'est le savoir."
,"16":"Prends-lui son vêtement puisqu'il s'est porté garant d'un autre; fais-le payer pour un étranger!"
,"17":"Le pain mangé en fraude est savoureux, mais on se retrouve la bouche pleine de gravier."
,"18":"Les projets prennent corps grâce à la réflexion; calcule bien lorsque tu fais la guerre."
,"19":"Qui parle de trop trahit les secrets: méfie-toi du bavard!"
,"20":"Qui maudit son père et sa mère, sa lampe s'éteindra au milieu des ténèbres."
,"21":"Des biens qu'on a tout de suite acquis ne vont pas prospérer dans la suite."
,"22":"Ne dis pas: 'Je me vengerai!', fais confiance à Yahvé pour te délivrer."
,"23":"Un poids pour acheter, un autre pour vendre: Yahvé les a en horreur! On ne doit pas fausser la balance."
,"24":"C'est Yahvé qui dirige les pas de l'homme; qui sait où son chemin le mène?"
,"25":"Il est dangereux de faire trop vite une promesse: 'Ceci est pour Yahvé!' et de ne réfléchir qu'ensuite."
,"26":"Un roi sage passe les méchants au crible, il leur fait sentir le poids de sa justice."
,"27":"L'esprit en nous est la lampe de Yahvé: il fouille les recoins de notre intérieur."
,"28":"Fidélité et loyauté gardent le roi; c'est la bienveillance qui affermit son pouvoir."
,"29":"La force fait la fierté des jeunes, les cheveux blancs sont l'honneur des vieillards."
,"30":"La blessure qui saigne évite l'infection; les coups guérissent le mal intérieur."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Les pensées du roi comme l'eau coulent où Yahvé les dirige."
,"2":"Quel que soit le chemin qu'on a pris, on le croit bon, mais c'est Yahvé qui pèse les coeurs."
,"3":"La justice et le droit mis en pratique, ont plus de valeur pour Yahvé que les sacrifices."
,"4":"Les yeux méprisants, le coeur hautain: toute ce qui reluit chez les méchants n'est que péché."
,"5":"Les projets de celui qui s'active lui rapportent, mais pour l'étourdi il n'y a que déficit."
,"6":"S'amasser un trésor à force de mensonges, c'est la brève illusion de gens qui vont à la mort."
,"7":"La violence des méchants les emportera, car ils refusent de pratiquer la justice."
,"8":"Le criminel suit des chemins tortueux, tandis que l'homme intègre pratique la droiture."
,"9":"Mieux vaut rester dans un coin de grenier que de partager sa maison avec une femme querelleuse."
,"10":"Le méchant ne souhaite que le mal, personne ne trouve grâce à ses yeux."
,"11":"Punis le moqueur, et le naïf deviendra sage, instruis le sage, la leçon lui sera profitable."
,"12":"Le juste surveille la maison du méchant, il précipite les méchants dans le malheur."
,"13":"Qui fait sourde oreille au cri du malheureux, lui aussi appellera sans qu'on lui réponde."
,"14":"Un cadeau en secret apaise la colère, un présent détourne la fureur violente."
,"15":"Quand on fait régner la justice, le juste est dans la joie, mais c'est le désastre pour les malfaisants."
,"16":"Qui s'écarte du chemin de la prudence, bientôt reposera parmi les morts."
,"17":"Qui aime le plaisir est voué à l'indigence, on ne s'enrichit pas en courant après le vin et les parfums."
,"18":"Le méchant paiera pour le juste; c'est le traître qui sera frappé, et non l'homme droit."
,"19":"Mieux vaut habiter dans un coin désert, qu'avec une femme querelleuse et maussade."
,"20":"Le sage a chez lui de l'huile et des réserves, le sot ne saurait que les gaspiller."
,"21":"Qui se soucie de justice et de bonté trouvera vie, bien-être et considération."
,"22":"Le sage s'empare d'une ville bien défendue, il renverse les murailles qui la rassuraient."
,"23":"Qui met une garde à sa bouche et sa langue, se garde de bien des tourments."
,"24":"Il est arrogant et insolent: 'Je me moque de tout!' Ses actes sont le débordement de son orgueil."
,"25":"Les désirs du paresseux ne peuvent que le tuer, car ses mains se refusent à travailler."
,"26":"Tout le jour l'impie convoite, tandis que le juste donne sans épargner."
,"27":"Yahvé a en horreur le sacrifice des méchants, surtout s'ils l'offrent dans une mauvaise intention."
,"28":"Le faux témoin sera confondu, mais l'homme qui sait écouter aura le dernier mot."
,"29":"Le méchant cherche à paraître assuré, l'homme honnête veut que sa conduite soit assurée."
,"30":"Il n'y a pas de sagesse, d'intelligence ou de prudence qui tienne devant Yahvé."
,"31":"On équipe le cheval pour le jour du combat, mais la victoire dépend de Yahvé."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Mieux que de grandes richesses, un nom respecté; mieux que l'or et l'argent, être bien estimé!"
,"2":"Le riche et le pauvre ont ceci en commun: Yahvé les a faits l'un et l'autre."
,"3":"L'homme avisé voit venir le malheur et se met à l'abri; les niais vont de l'avant et ils le paient."
,"4":"La récompense de l'humilité, c'est la crainte de Yahvé, la richesse, l'honneur et la vie."
,"5":"Sur le chemin du pervers sont les épines et les pièges; qui s'en éloigne se met en sûreté."
,"6":"Montre à l'enfant le chemin à suivre; même en vieillissant il s'y tiendra."
,"7":"Le riche domine sur le pauvre, le débiteur est sous la coupe de son créancier."
,"8":"Qui sème l'injustice récolte le malheur, le pouvoir des violents sera brisé."
,"9":"Qui regarde avec bienveillance sera béni: il a su partager son pain avec le pauvre."
,"10":"Chasse le railleur et la dispute s'en ira; les querelles et les injures s'apaiseront."
,"11":"Yahvé aime les coeurs droits, celui qui parle avec souci du bien, le roi le prendra pour ami."
,"12":"Yahvé sait reconnaître le savoir, mais il démasque les discours pervers."
,"13":"Le paresseux dit: 'Il y a un lion dehors, si je sors je serai dévoré!'"
,"14":"La bouche d'une adultère est une fosse profonde; il faut être abandonné de Yahvé pour y tomber."
,"15":"La sottise est ancrée au coeur de l'enfant; la discipline et les corrections l'en délivreront."
,"16":"Opprimez le pauvre, vous le faites progresser, donnez à un riche, vous lui faites du tort."
,"17":"Ouvre tes oreilles, écoute mes paroles, sois attentif à mes enseignements."
,"18":"Tu aimeras les garder en ta mémoire et les trouver prêts sur tes lèvres chaque fois que tu voudras."
,"19":"Je veux que tu mettes ta confiance en Yahvé:"
,"20":"voilà pourquoi je t'ai écrit ces trente maximes, pour te conseiller et t'avertir,"
,"21":"pour que tu connaisses la vérité, et que tu puisses répondre avec sûreté à qui t'interrogera."
,"22":"Ne dépouille pas le pauvre parce qu'il est pauvre, et ne condamne pas le malheureux."
,"23":"Car Yahvé prendra leur parti et se fera l'oppresseur de leurs oppresseurs."
,"24":"Ne te lie pas à un homme colérique, ne fréquente pas quelqu'un d'emporté:"
,"25":"tu pourrais prendre leurs manières, et tu y risquerais ta vie."
,"26":"Ne sois pas de ceux qui s'engagent à la légère et qui donnent des garanties sur un prêt;"
,"27":"si tu n'as pas de quoi rembourser, on te prendra ton lit en te laissant sur le sol."
,"28":"Laisse la borne que tes pères ont posée, là où elle a toujours été."
,"29":"Vois-tu un homme qui sait se démener? Il entrera au service des rois, il ne restera pas au service de gens obscurs."
}`)
	CurrentBook.AddChapter(23, `{
"1":"Si tu es à table avec un notable, regarde bien ce qui est devant toi."
,"2":"Ne sois pas gourmand, tu te mettrais le couteau sur la gorge!"
,"3":"Ne te jette pas sur ses bons plats: ce sont des aliments qui trompent!"
,"4":"Ne te fatigue pas à poursuivre la richesse, cesse d'y penser;"
,"5":"à peine aperçue, sitôt disparue! Elle se fait des ailes, et comme un aigle s'envole dans les nuages."
,"6":"Ne mange pas le pain d'un homme intéressé, ne convoite pas ses mets délicats,"
,"7":"car toute son attitude est calculée. 'Mange et bois!' te dit-il, mais son coeur n'est pas avec toi."
,"8":"Tu devras vomir le morceau que tu auras mangé, et tu auras perdu tes bonnes paroles."
,"9":"Ne parle pas aux oreilles d'un sot, il mépriserait tes paroles les plus sensées."
,"10":"Ne déplace pas une borne ancienne, n'empiète pas sur le champ des orphelins."
,"11":"Ils ont un défenseur puissant, Yahvé lui- même, qui plaidera leur cause contre toi."
,"12":"Mets tout ton zèle à t'instruire, ouvre tes oreilles aux paroles du savoir."
,"13":"N'hésite pas à corriger un enfant: ce n'est pas de l'avoir fouetté qui le fera mourir."
,"14":"Il te faut le corriger: ainsi tu le sauveras du séjour des morts."
,"15":"Mon fils, si tu deviens sage, je serai le premier à m'en réjouir;"
,"16":"je serai heureux lorsque tu seras dans le vrai."
,"17":"N'envie pas les pécheurs mais reste toujours dans la crainte de Yahvé,"
,"18":"si tu la gardes, tu en verras le résultat, et ton espérance ne sera pas déçue."
,"19":"Ecoute, mon fils, et deviens sage, marche sur le droit chemin."
,"20":"Ne va pas avec les buveurs de vin et ceux qui s'empiffrent de viande;"
,"21":"car l'ivrogne et le glouton s'appauvrissent, et le fainéant portera des haillons."
,"22":"Ecoute ton père qui t'a donné la vie; ne méprise pas ta mère quand elle aura vieilli."
,"23":"Achète la vérité, ne la revends pas; acquiers la sagesse, l'instruction et l'intelligence."
,"24":"Le père du juste aura de quoi se réjouir; celle qui a mis au monde un sage, il fera son bonheur."
,"25":"Que se réjouissent donc ton père et ta mère, qu'éclate la joie de celle qui t'a mis au monde!"
,"26":"Donne-moi ton attention, mon fils, ne perds pas de vue le chemin que je t'indique;"
,"27":"sache que la prostituée est une fosse pro fonde, la femme adultère est un puits étroit."
,"28":"Comme un brigand elle se tient à l'affût; combien d'hommes n'ont-ils pas trahi pour elle!"
,"29":"Pour qui les 'Ah'? Pour qui les 'Hélas'? Pour qui les disputes et les plaintes? Pour qui les coups sans motif et les yeux qui voient double?"
,"30":"Pour ceux qui restent à boire, qui additionnent les verres et les alcools."
,"31":"Ne te laisse pas fasciner par le vin: quel beau rouge, transparent dans la coupe, et comme il descend!"
,"32":"Comme le serpent, il finira par te mordre, il te piquera comme une vipère."
,"33":"Tu ne sauras plus ce que tu vois et tu te mettras à dire des bêtises."
,"34":"Tu seras comme un homme en pleine mer, cramponné au mât du navire:"
,"35":"'On m'a frappé... non, je n'ai pas eu mal! On m'a battu... non, je n'ai rien senti!"
,"36":"Vais-je me réveiller? Je veux en redemander!'"
}`)
	CurrentBook.AddChapter(24, `{
"1":"N'envie pas les méchants, ne recherche pas leur compagnie,"
,"2":"car ils ne pensent qu'à la violence et ne parlent que de méfaits."
,"3":"C'est par la sagesse qu'on bâtit la maison, par l'expérience qu'on la consolide;"
,"4":"c'est grâce au savoir que ses chambres se remplissent de bien des choses précieuses et agréables."
,"5":"Le sage l'emporte sur le fort, l'homme d'expérience vaut plus que le fort à bras;"
,"6":"calcule bien lorsque tu fais la guerre, car la victoire vient là où beaucoup ont su penser."
,"7":"La sagesse n'est pas à la portée du sot: qu'il se taise dans l'assemblée!"
,"8":"Celui qui médite le mal, on l'appelle un faiseur d'intrigues;"
,"9":"le sot, pour sa part, s'emploie à commettre le péché, et le railleur à se faire détester de tous."
,"10":"Si tu perds courage au jour de la détresse, ta force n'était pas grand'chose."
,"11":"Délivre ceux qu'on envoie à la mort, sauve ceux qu'on traîne au supplice!"
,"12":"Après tu diras: 'Nous ne le savions pas!' Mais celui qui pèse les coeurs voit clair, celui qui t'observe le saura bien; et il rendra à chacun selon ses oeuvres."
,"13":"Mange du miel, mon fils, puisque c'est bon; le miel est doux au palais."
,"14":"La sagesse de même te sera bonne: si tu l'acquiers, tu en verras les fruits, ton espérance ne sera pas déçue."
,"15":"Arrête, méchant, de comploter contre la maison du juste, ne va pas troubler son repos!"
,"16":"Si le juste tombait sept fois, il se relèverait encore, tandis que les méchants tomberont pour rester dans le malheur."
,"17":"Ne te réjouis pas si ton ennemi tombe, n'aie pas le coeur en fête parce qu'il a trébuché;"
,"18":"Yahvé pourrait en avoir du déplaisir, et il détournerait sur toi sa colère."
,"19":"Ne t'excite pas au sujet de ceux qui font le mal, n'envie pas les impies;"
,"20":"car le mal n'a pas d'avenir, et la lampe des impies s'éteindra."
,"21":"Mon fils, crains Yahvé et le roi, ne fréquente pas les révoltés!"
,"22":"Car tous deux peuvent frapper à l'improviste, et qui sait comment ils punissent."
,"23":"Ceci encore vient des Sages. Il n'est pas bien d'être partial dans les jugements. "
,"24":"Celui qui dit à un méchant: 'Tu as raison!', le peuple le maudit, les nations le détestent."
,"25":"Mais ceux qui savent punir s'en trouveront bien, ils seront comblés de bénédictions."
,"26":"Une réponse juste vaut tous les signes d'affection."
,"27":"Commence par ton travail au-dehors, occupe-toi d'abord de tes champs; après cela tu pourras agrandir ta maison."
,"28":"Ne témoigne pas à la légère contre ton prochain, voudrais-tu donc mentir?"
,"29":"Ne dis pas: 'Je lui ferai comme il m'a fait!'"
,"30":"Je suis passé près du champ du paresseux, j'ai longé la vigne d'un étourdi:"
,"31":"partout des orties, le sol était couvert de ronces, le mur de pierres s'était écroulé!"
,"32":"Après avoir vu, j'ai réfléchi et tiré la leçon:"
,"33":"on fait une petite sieste, on s'allonge un instant pour croiser les bras;"
,"34":"mais la pauvreté s'approche de toi comme un rôdeur, la misère fond sur toi comme un homme armé!"
}`)
	CurrentBook.AddChapter(25, `{
"1":"Voici encore des proverbes de Salomon, qui ont été transcrits par les gens d'Ezéquias, roi de Juda."
,"2":"La gloire de Dieu, c'est de cacher les choses, et la gloire des rois, de les clarifier."
,"3":"Vois la hauteur du ciel et la profondeur de la terre: la pensée des rois est tout aussi insondable."
,"4":"Retire les scories de l'argent, l'orfèvre en fera sortir un vase;"
,"5":"retire le méchant de la présence du roi, et son trône s'affermira par la justice."
,"6":"Ne fais pas l'important devant le roi, ne te mets pas au milieu des grands;"
,"7":"mieux vaut qu'on te dise: 'Monte ici!' que de te voir rabaissé en présence du prince."
,"8":"Si tu as vu quelque chose, n'accuse pas trop vite; que feras-tu ensuite si ton adversaire te contredit?"
,"9":"Défends ta cause contre ton adversaire, mais sans révéler les secrets d'autrui,"
,"10":"quiconque l'apprendrait t'en ferait le reproche, et tu y perdrais ta réputation."
,"11":"Des pommes d'or enchâssées dans l'argent, c'est la parole qu'on a dite à propos;"
,"12":"l'anneau d'or d'un collier de vermeil, c'est la sage réprimande faite à qui peut l'entendre."
,"13":"Une fraîcheur de neige par un jour d'été, tel est le messager fidèle pour celui qui l'envoie: quel réconfort pour son maître!"
,"14":"Vent et nuages sans pluie, tel est le vantard avec ses promesses illusoires."
,"15":"Avec de la persévérance on peut convaincre un juge; la langue, si douce, peut briser un os."
,"16":"As-tu trouvé du miel? Manges-en avec modération. N'exagère pas, tu le vomirais."
,"17":"Ne va pas trop chez ton prochain: il pourrait s'en fatiguer et te prendre en grippe."
,"18":"Un gourdin, une épée, une flèche acérée: tel est l'homme qui parle faussement de son prochain."
,"19":"Une dent cariée, un pied foulé: tel est l'appui d'un hypocrite, le jour où tout va mal."
,"20":"Prendras-tu leur manteau en un jour d'hiver, verseras-tu du vinaigre sur leur plaie? Ne chante pas un air gai devant ceux qui souffrent."
,"21":"Si ton ennemi a faim, donne-lui à manger; s'il a soif, donne-lui à boire!"
,"22":"C'est la façon d'amasser des braises sur sa tête, et Yahvé t'en récompensera."
,"23":"Le vent du nord enfante la pluie, et les sous-entendus hypocrites des visages en colère."
,"24":"Mieux vaut rester dans un coin de grenier que de partager sa maison avec une femme querelleuse."
,"25":"De l'eau fraîche pour une gorge assoiffée: telle est une bonne nouvelle qui arrive de loin."
,"26":"Une fontaine souillée, une source corrompue: tel est l'homme honnête qui cède à la pression du méchant."
,"27":"Manger trop de miel ne réussit pas: attention aux honneurs!"
,"28":"Une ville ouverte, sans remparts, tel est l'homme qui ne contrôle pas ses esprits."
}`)
	CurrentBook.AddChapter(26, `{
"1":"De la neige en été, de la pluie à la moisson: il est tout aussi déplacé de rendre honneur à un sot."
,"2":"Comme un moineau s'échappe, comme l'hirondelle prend son vol, de même quand on a maudit sans raison: cela ne sera pas."
,"3":"Le fouet pour le cheval, la bride pour l'âne, et le bâton pour le dos des imbéciles!"
,"4":"Ne réponds pas aux sottises d'un imbécile: tu deviendrais comme lui."
,"5":"Réponds aux sottises d'un imbécile: autrement il se prendrait pour un sage."
,"6":"Il se coupe le pied, il devra avaler la pilule, celui qui confie ses messages à un imbécile."
,"7":"Des jambes de boîteux, mal assurées, telle est la parole sage dans la bouche d'un sot."
,"8":"Donner de l'importance à un sot, ce n'est pas mieux que d'attacher la pierre à la fronde."
,"9":"Une branche d'épines dans la main d'un ivrogne, telle est la parole sage dans la bouche d'un sot."
,"10":"Un tireur à l'arc qui blesse les passants: ce sera pareil si tu emploies un imbécile."
,"11":"Le chien revient à son vomissement, et l'insensé retourne à sa folie."
,"12":"Vois-tu un homme qui se prend pour un sage? Il y a plus à espérer d'un sot que de lui."
,"13":"Le paresseux dit: 'Il y a une bête féroce sur le chemin! Il y a un lion dans la rue!'"
,"14":"La porte tourne sur ses gonds, et le paresseux sur son lit."
,"15":"Quand le paresseux tend la main vers le plat, il est trop fatigué pour la ramener à la bouche."
,"16":"Le paresseux se croit plus sage que sept personnes qui répondent bien."
,"17":"Se mêler des querelles d'autrui? Autant attraper par les oreilles un chien qui passe!"
,"18":"Un fou qui lance des braises ou des flèches meurtrières:"
,"19":"tel est celui qui ment à son prochain avant de lui dire: 'C'était pour rire!'"
,"20":"Plus de bois: le feu s'éteint; plus de médisant: la querelle s'apaise."
,"21":"Le charbon et le bois activent le feu, et l'homme querelleur enflamme les disputes."
,"22":"Les paroles du médisant sont comme des friandises; elles glissent doucement jusqu'au fond des entrailles."
,"23":"Une garniture d'argent sur un pot de terre: telles sont les bonnes paroles d'un mauvais coeur."
,"24":"Celui qui a de la haine déguise son langage et cache en lui sa méchanceté."
,"25":"S'il exprime de bons sentiments, ne t'y fie pas: sept méchancetés occupent son coeur."
,"26":"Mais il a beau cacher sa haine sous des airs rusés, sa malice ressortira en public."
,"27":"Qui creuse une fosse y tombera; qui roule une pierre, elle reviendra sur lui."
,"28":"Celui qui ment hait celui qu'il blesse; il parle gentiment, mais c'est pour ruiner."
}`)
	CurrentBook.AddChapter(27, `{
"1":"Ne te vante pas du lendemain: tu ne sais pas ce que te réserve cette journée."
,"2":"Un autre peut faire ton éloge, mais pas toi; un autre parlera, mais pas toi."
,"3":"La pierre est pesante et le sable fatigant à la marche; combien plus pesant le mauvais vouloir de l'insensé!"
,"4":"La colère est cruelle, la fureur a ses excès, mais qui peut tenir devant la jalousie?"
,"5":"Mieux vaut une franche réprimande qu'une amitié opportuniste."
,"6":"Un ami loyal dit les quatre vérités; l'ennemi embrasse, mais par hypocrisie."
,"7":"Avec l'estomac plein, le miel ne dit plus rien; quand on a faim, ce qui est amer paraît doux."
,"8":"Un oiseau qui erre loin de son nid, tel est l'homme qui erre loin de chez lui."
,"9":"L'huile et les parfums réjouissent le coeur, la douceur de l'amitié réconforte l'âme."
,"10":"Ne délaisse pas ton ami, ni l'ami de ton père; un ami tout près vaut mieux qu'un frère au loin."
,"11":"Mon fils, deviens sage et tu feras ma joie; j'aurai ainsi de quoi répondre à celui qui m'insulte."
,"12":"L'homme avisé voit venir le danger et se met à l'abri; les niais vont de l'avant et ils le paient."
,"13":"Prends-lui son manteau, puisqu'il s'est porté garant pour un étranger: fais-le payer pour l'autre!"
,"14":"Si tu souhaites du bien à ton voisin en le criant très fort, on pensera que tu lui veux du mal."
,"15":"La femme querelleuse est comme une gouttière qui coule sans fin un jour de pluie;"
,"16":"La retenir? ce serait saisir du vent, ou prendre l'huile avec la main."
,"17":"Le fer aiguise le fer: on s'affine au contact de son prochain."
,"18":"Qui cultive le figuier mangera de son fruit, qui prend soin de son maître aura de l'avancement."
,"19":"Les visages ne se ressemblent pas, et les coeurs pas davantage."
,"20":"La Mort et le monde d'en-bas ne sont jamais rassasiés: de même le désir humain."
,"21":"On éprouve au feu l'argent, on met l'or au creuset: à chacun d'éprouver ceux qui le flattent."
,"22":"Tu pourrais broyer l'insensé dans un mortier, que sa sottise ne le lâcherait pas."
,"23":"Connais bien l'état de ton bétail, prends soin de ton troupeau;"
,"24":"car la richesse n'est pas éternelle, et les réserves ne durent pas des générations."
,"25":"Lorsque l'herbe est fauchée et que pousse le regain, ramasse du foin dans la montagne;"
,"26":"tu auras des agneaux pour te vêtir, des boucs pour payer ton champ,"
,"27":"du lait de chèvre, suffisamment pour te nourrir et faire vivre tes servantes."
}`)
	CurrentBook.AddChapter(28, `{
"1":"Le malfaiteur fuit quand personne ne le poursuit, le juste par contre va comme un lion, plein d'assurance."
,"2":"Les erreurs d'un violent mettent le monde en effervescence, avec un homme intelligent le calme revient."
,"3":"L'homme mauvais qui exploite les pauvres est comme la pluie dévastatrice: on reste sans pain."
,"4":"Après avoir abandonné la Loi on approuve le méchant, ceux qui observent la Loi s'indignent contre lui."
,"5":"Les mauvais n'entendent rien à la morale, ceux qui cherchent Yahvé comprennent tout."
,"6":"Mieux vaut un pauvre qui vit honnêtement, qu'un arriviste qui s'est fait riche."
,"7":"Un garçon intelligent observe la Loi, celui qui fréquente les débauchés est la honte de son père."
,"8":"Les intérêts et l'usure lui ont permis d'arrondir sa fortune: il a amassé pour celui qui a pitié des pauvres."
,"9":"Celui qui refuse d'écouter la Loi, même sa prière est abominable."
,"10":"Si quelqu'un pousse les honnêtes gens hors du chemin, c'est lui qui tombera dans le fossé."
,"11":"L'homme riche s'imagine être sage, mais le pauvre de bon sens ne s'y trompe pas."
,"12":"Quand les justes triomphent, la joie est grande; quand les méchants l'emportent, chacun se cache."
,"13":"Cacher ses fautes ne mène à rien, les reconnaître et y renoncer les fait pardonner."
,"14":"Heureux celui qui jamais ne perd la crainte: qui endurcit sa conscience tombera dans le malheur."
,"15":"Un lion rugissant, un ours affamé, tel est le méchant qui domine sur le pauvre peuple."
,"16":"Moins le chef est intelligent, plus il est oppresseur: qui déteste les abus restera longtemps."
,"17":"C'est un violent qui a versé le sang, ne l'arrêtez pas: jusqu'à sa mort il fuira!"
,"18":"Qui marche sans reproche se sauvera, qui mène un double jeu s'y perdra."
,"19":"Cultive ton champ, tu auras ton content de pain; poursuis des illusions, tu auras ton compte de privations."
,"20":"Celui qui est consciencieux, les succès ne lui feront pas défaut, celui qui veut s'enrichir vite ne saurait être innocent."
,"21":"On devrait être impartial, mais certains se vendent pour une bouchée de pain."
,"22":"L'homme intéressé court après la richesse, et il ne sait pas que la misère l'attend."
,"23":"Celui qui remet en place sera un jour plus apprécié que celui qui veut plaire."
,"24":"Qui prend à son père en disant: 'Ce n'est pas grave!' n'est qu'un brigand parmi d'autres."
,"25":"L'homme cupide ne gagne que des querelles, qui met sa confiance dans Yahvé réussira."
,"26":"Celui qui ne croit qu'à ses idées est un imbécile, qui agit avec sagesse s'en tirera."
,"27":"Qui donne au pauvre ne manquera de rien, qui préfère ne pas le voir aura toutes les malédictions."
,"28":"Quand les méchants l'emportent, chacun se cache; quand ils sont éliminés, les justes se multiplient."
}`)
	CurrentBook.AddChapter(29, `{
"1":"L'homme qui s'entête malgré les avertissements sera brisé d'un coup et sans remède."
,"2":"Quand les justes sont au pouvoir, le peuple se réjouit; quand c'est un méchant qui domine, le peuple gémit."
,"3":"Qui aime la sagesse fait la joie de son père, qui entretient les prostituées y laissera son avoir."
,"4":"Un roi, quand il est juste, affermit son pays; s'il n'est qu'un oppresseur, il le mène à la ruine."
,"5":"Flatter son prochain, c'est tendre un filet sous ses pas."
,"6":"Le péché du méchant lui prépare un piège, tandis que le juste court et n'a pas à s'en repentir."
,"7":"Le juste connaît les droits du pauvre, le mauvais n'en veut rien savoir."
,"8":"Ceux qui ne font que critiquer mettent la ville sens dessus dessous, mais les sages apaisent la colère."
,"9":"Quand le sage discute avec un fou, qu'il se fâche ou plaisante, il n'en tirera rien."
,"10":"Le juste s'attire la haine des violents, les méchants veulent sa perte."
,"11":"L'insensé donne libre cours à son impulsivité, le sage domine la sienne et la calme."
,"12":"Un chef qui prête l'oreille aux calomnies, tous ses serviteurs seront des mauvais."
,"13":"Le pauvre et l'oppresseur ont un point commun: Yahvé leur donne à tous deux de voir le jour."
,"14":"Le roi qui donne aux pauvres une vraie justice, son pouvoir sera stable."
,"15":"Le fouet et les corrections procurent la sagesse, l'enfant qu'on laisse faire sera la honte de sa mère."
,"16":"Les mauvais se multiplient, et avec eux le péché, mais les hommes droits verront leur chute."
,"17":"Corrige ton fils si tu veux qu'il te procure le repos: alors il te vaudra de grandes joies."
,"18":"Faute de visions, le peuple vit sans règle; heureux celui qui observe la Loi!"
,"19":"On ne corrige pas un serviteur rien qu'avec des paroles; il comprend mais n'obéit pas!"
,"20":"As-tu remarqué un homme qui meurt d'envie de parler? Il y a plus à espérer d'un sot que de lui."
,"21":"Si tu as gâté ton serviteur dès sa jeunesse, à la fin il sera intraitable."
,"22":"Le violent multiplie les querelles, l'homme emporté commet faute sur faute."
,"23":"C'est ton orgueil qui te vaudra d'être abaissé, celui qui est humble aura droit aux honneurs."
,"24":"Il veut sa propre perte, celui qui protège un voleur, qui ne dit rien quand on fait jurer ceux qui savent."
,"25":"C'est un piège que de trembler devant des hommes: la vraie sécurité, c'est de s'en remettre à Yahvé."
,"26":"Beaucoup recherchent les faveurs du pouvoir, mais c'est Yahvé qui décide pour chacun."
,"27":"L'homme mauvais est insupportable aux hommes droits, tout comme celui qui marche droit est insupportable aux méchants."
}`)
	CurrentBook.AddChapter(30, `{
"1":"Voici les paroles d'Agour, le fils de Yaqué, originaire de Massa. Voici les sentences de cet homme: Je me suis fatigué, ô Dieu, j'en suis fatigué et épuisé, ô mon Dieu! "
,"2":"Je suis plus stupide qu'aucun autre, et le sens commun me fait défaut:"
,"3":"oui, moi qui n'ai pas appris la sagesse, j'ai pensé connaître la science du Saint!"
,"4":"Qui est monté au ciel et en est revenu? Qui a tenu le vent de ses poings fermés? Qui a contenu les eaux dans le pli de son manteau? Qui a placé les bornes aux extrémités du monde? Peux-tu me dire son nom et le nom de son fils?"
,"5":"Les paroles de Dieu sont à toute épreuve, il est un bouclier pour ceux qui se fient en lui."
,"6":"N'ajoute rien à ses paroles: il te reprendrait et montrerait que tu mens."
,"7":"Je te demande deux choses, mon Dieu, ne me les refuse pas jusqu'au jour de ma mort:"
,"8":"éloigne de moi la fausseté et le mensonge, ne me donne ni la pauvreté ni la richesse. Donne-moi seulement mon content de pain."
,"9":"Car avec l'abondance je pourrais te laisser, et dire: 'Qui donc est Yahvé?' Et dans le dénuement je pourrais me mettre à voler: ce serait déshonorer le nom de mon Dieu!"
,"10":"N'accuse pas un serviteur devant son maître: s'il te maudissait tu serais bien puni."
,"11":"Il y a des gens qui maudissent leur père et ne bénissent pas leur mère,"
,"12":"des gens qui se considèrent purs, mais leurs souillures n'ont pas été lavées,"
,"13":"des gens dont les yeux sont méprisants et le regard hautain,"
,"14":"des gens avec des dents comme des épées et des machoires comme des couteaux, qui dévorent les humbles dans le pays et les pauvres du peuple!"
,"15":"La sangsue a deux filles, elles s'appellent 'Donne!' et 'Donne!',Il sont trois qui n'en ont jamais assez, et quatre qui ne disent jamais: 'Cela suffit!': "
,"16":"le séjour des morts, la femme stérile, la terre qui manque d'eau. Le feu non plus ne dit jamais: 'C'est assez!'"
,"17":"L'oeil qui défie son père et refuse d'obéir à sa mère, les corbeaux du torrent le crèveront, les petits de l'aigle le dévoreront."
,"18":"Il y a trois choses qui me dépassent, et quatre que je ne peux savoir:"
,"19":"où est passé l'aigle dans le ciel, et le serpent sur le rocher, et le navire en haute mer? Et comment l'homme est-il passé par la femme?"
,"20":"Vois comment fait la femme adultère: elle a mangé, puis elle s'est essuyé la bouche: 'Je n'ai rien fait de mal!'"
,"21":"Trois choses font trembler la terre, il y en a quatre qu'elle ne peut supporter:"
,"22":"l'esclave qui devient roi, le fou qui mange tout à sa guise,"
,"23":"la fille détestable qui trouve un mari, la servante qui supplante sa maîtresse!"
,"24":"Il sont quatre sur terre, petits, mais qui dépassent tous les autres en sagesse:"
,"25":"les fourmis sont un peuple chétif, mais elles font l'été leurs provisions;"
,"26":"les damans sont sans défense, mais ils se trouvent des abris au milieu des rochers;"
,"27":"les sauterelles n'ont pas de roi, mais elles savent marcher en rangs disciplinés;"
,"28":"et puis le lézard: on le prend avec la main, mais tu le trouves dans le palais des rois."
,"29":"Ils sont trois à avoir belle allure, quatre même dont la démarche est belle:"
,"30":"le lion, le plus vaillant des animaux, qui ne recule devant rien;"
,"31":"le coq, qui se dresse fièrement, et encore le bouc; et puis le roi en tête de son armée."
,"32":"Si tu as été assez bête pour t'emporter, reprends-toi et mets la main devant la bouche."
,"33":"Car en donnant des coups sur la crème elle devient du beurre, un coup sur le nez fait jaillir le sang, et un coup de colère provoque des querelles."
}`)
	CurrentBook.AddChapter(31, `{
"1":"Conseils à Lémuel, roi de Massa, qu'il a reçus de sa mère:"
,"2":"Non, mon fils! Non, mon enfant! Toi, mon premier-né, que j'ai appelé de tous mes voeux!"
,"3":"Ne livre pas ta vigueur aux femmes, ne te laisse pas étreindre par celles qui perdent les rois."
,"4":"Il ne convient pas aux rois, Lémuel, de boire du vin, ni aux princes d'abuser des liqueurs fortes,"
,"5":"car ils pourraient s'enivrer, oublier les décrets, et violer le droit des indigents."
,"6":"Procure des boissons fortes à celui qui va mourir, donne du vin à qui est dans la tristesse;"
,"7":"qu'il boive, qu'il oublie sa misère, qu'il ne se souvienne plus de son malheur."
,"8":"Ouvre la bouche en faveur du muet, soutiens la cause de tous les abandonnés."
,"9":"Ouvre la bouche et fais une vraie justice aux pauvres et aux affligés."
,"10":"Une femme de caractère, où la trouver? Elle est, de loin, plus précieuse qu'une perle."
,"11":"Son mari sait qu'il peut compter sur elle: voilà un grand avantage, qui ne se perdra pas."
,"12":"Elle lui donne du bonheur, et sans mélange, tous les jours de sa vie."
,"13":"Elle s'est procuré de la laine et du lin, car elle travaille d'une main active."
,"14":"Comme les navires des marchands, de loin elle fait venir son pain."
,"15":"Elle s'est levée, il faisait encore sombre, pour distribuer la nourriture à sa maisonnée."
,"16":"A-t-elle idée d'un champ? le voilà acheté: une vigne qu'a payée son travail."
,"17":"Elle se met vaillamment à la besogne, car elle a de la force dans les bras."
,"18":"Elle a vu que ses affaires allaient bien, de toute la nuit sa lampe ne s'est pas éteinte:"
,"19":"elle avait mis la main à la quenouille, ses doigts avaient saisi le fuseau."
,"20":"Elle a tendu la main vers le pauvre, elle l'a ouverte à l'indigent."
,"21":"La neige ne lui fait pas peur pour les siens, car tous ont double vêtement."
,"22":"Elle s'est fait des couvertures, et l'habit qu'elle porte, de lin fin et de pourpre."
,"23":"Son mari est connu parmi les officiels, car il siège avec les anciens du pays."
,"24":"Elle vend des draps qu'elle a tissés, le marchand lui a même pris une ceinture."
,"25":"Elle rayonne de santé et de dignité, elle envisage l'avenir avec optimisme."
,"26":"Ce qu'elle dit est plein de bon sens, elle a l'art d'enseigner la piété."
,"27":"Surveillant les activités de son monde, elle n'est pas de ceux qui mangent sans travailler."
,"28":"Ses fils ont voulu la féliciter, son mari est le premier à la louer:"
,"29":"'On ne peut pas compter les femmes vaillantes, mais tu les as toutes surpassées!"
,"30":"Le charme est trompeur, la beauté vite passée, c'est la sagesse qu'on admire chez une femme!"
,"31":"Reconnaissez-lui le travail de ses mains: ses oeuvres ont mérité un hommage public.'"
}`)

}
func FR_LBDCC_LoadVSPSChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Heureux cet homme!,Il ne prend pas le chemin des impies, il ne fréquente pas l'assemblée des pécheurs,et ne s'arrête pas chez ceux qui toujours se moquent."
,"2":"C'est qu'il a trouvé son bien dans la loi du Seigneur, il la médite, cette loi, de jour et de nuit."
,"3":"Il sera comme un arbre feuillu,planté juste au bord des eaux, couvert de fruits quand c'est l'époque,et dont les feuilles ne tombent pas: il mène à bien tout ce qu'il fait."
,"4":"C'est le contraire pour les pécheurs: eux sont la paille qu'emportera le vent."
,"5":"Que vienne le jugement, les impies ne tiendront pas: pas de place pour les pécheurs dans l'assemblée des justes."
,"6":"Le Seigneur veille sur les voies des justes, mais pour le pécheur à la fin, c'est l'échec."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Pourquoi tout ce tapage des nations?,Voyez ces peuples et leur projet sans espoir."
,"2":"Les rois de la terre se sont alliés, les grands chefs se sont soulevés,contre le Seigneur et contre son Christ."
,"3":"Ils ont dit: 'Brisons leurs entraves, débarrassons-nous de leur joug.'"
,"4":"Celui qui siège dans les cieux s'en amuse, le Seigneur se moque d'eux."
,"5":"Voilà qu'il leur parle tout en colère,et sa fureur les épouvante. Il dit:"
,"6":"'Moi, je viens d'établir mon roi,sur Sion, ma montagne sainte.'"
,"7":"Oui, je vais proclamer le décret du Seigneur, il m'a dit: 'Tu es mon fils, moi aujourd'hui, je t'ai transmis la vie."
,"8":"Demande-moi et je te donnerai les nations, elles seront à toi jusqu'au bout du monde."
,"9":"Tu les mèneras avec un sceptre de fer, tu les briseras comme un pot de terre.'"
,"10":"Alors soyez sages, messieurs les rois, tenez-en compte, vous qui gouvernez le monde."
,"11":"Servez le Seigneur avec crainte,"
,"12":"rendez-lui hommage et tremblez. Car sa colère n'est pas longue à partir, qu'il vienne à s'impatienter et vous êtes perdus. Heureux ceux qui se confient en lui!"
}`)
	CurrentBook.AddChapter(3, `{
"1":"De David. Quand il s'enfuit devant son fils Absalom."
,"2":"O Seigneur, mes ennemis se sont multipliés, combien d'adversaires!"
,"3":"Combien osent me dire: 'Dieu ne te servira de rien!'"
,"4":"Mais toi, Seigneur, mon bouclier protecteur, ma gloire, tu me feras relever la tête."
,"5":"Je crie, j'appelle le Seigneur, et lui, de sa montagne sainte, il m'entend."
,"6":"Je me suis couché et j'ai dormi, puis je me suis relevé: le Seigneur me tenait debout."
,"7":"Je ne crains plus ces foules,qui de toutes parts allaient tomber sur moi."
,"8a":"Lève-toi, Seigneur, Sauve-moi, ô mon Dieu."
,"8b":"Car tu as frappé: mes ennemis l'ont eu dans la mâchoire; tu as brisé les dents des pécheurs."
,"9":"C'est toi, Seigneur, qui sauves, ta bénédiction est sur ton peuple."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Au maître de chant. Avec les instruments à cordes. Psaume de David."
,"2":"Ecoute-moi quand j'appelle, ô Dieu mon défenseur, toi qui dans l'angoisse m'as fait respirer. Aie pitié de moi, entends ma prière."
,"3":"Gens prétentieux, quand donc allez-vous comprendre?,Vous aimez ce qui est creux et le mensonge vous plaît."
,"4":"Sachez que le Seigneur fait pour moi des merveilles, le Seigneur m'écoute quand je l'appelle."
,"5":"Soyez furieux, mais ne faites rien, dites-le pour vous seuls dans votre lit, et puis taisez-vous."
,"6":"Offrez le sacrifice comme il se doit,et comptez sur le Seigneur."
,"7":"Beaucoup disent: 'Qui nous donnera le bonheur?,la lumière de sa face a fui loin de nous.'"
,"8":"Mais pour moi, tu m'as mis la joie au coeur, plus qu'à voir abondance de blé et de vin."
,"9":"En paix je me couche et m'endors: oui, toi seul, Seigneur, tu mets en sûreté mon gîte."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Au maître de chant. Avec les flûtes. Psaume de David."
,"2":"Seigneur, entends mes paroles et comprends ma plainte."
,"3":"Ecoute mon cri, ô mon roi et mon Dieu. C'est toi que je supplie, Seigneur, "
,"4":"dès le matin tu entends ma voix, dès le matin j'offre mes voeux et j'attends."
,"5":"Car toi, tu n'es pas Dieu pour aimer le mal, le méchant n'entrera pas chez toi."
,"6":"Les arrogants ne tiennent pas devant tes yeux, tu détestes ceux qui font le mal"
,"7":"et tu casses les reins aux diseurs de mensonge. Le violent et celui qui fraude, le Seigneur les déteste."
,"8":"Mais moi, par ta grande bonté, j'ai accès à ta Maison, face à ton saint Temple je me prosterne et j'adore."
,"9":"Guide-moi, Seigneur, selon ta justice, tu vois que mes ennemis veillent, aplanis tes chemins devant moi."
,"10":"Car rien n'est sûr de ce qu'ils disent et ils ne pensent qu'à nuire. Ils ont la flatterie dans la bouche, mais leur gosier est une tombe ouverte."
,"11":"Condamne-les, mon Dieu, et que leurs projets échouent; chasse-les pour tous leurs crimes puisqu'ils se sont révoltés contre toi."
,"12":"Quelle fête alors pour ceux qui s'abritent en toi, quelle joie sans fin pour ceux que tu protèges, quels cris de joie chez ceux qui aiment ton nom!"
,"13":"Car toi, Seigneur, tu bénis le juste, ta grâce l'enveloppe et le protège."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Au maître de chant. Avec les instruments à cordes. A l'octave. Psaume de David."
,"2":"Seigneur, ne me punis avec fureur, ne me reprends pas si tu es en colère."
,"3":"Aie pitié de moi car je n'en peux plus; je ne tiens plus debout, guéris-moi, Seigneur."
,"4":"Mon âme attend toute bouleversée, et toi, Seigneur, jusques à quand?"
,"5":"Reprends-toi, Seigneur, et délivre mon âme, sauve-moi dans ta grande tendresse."
,"6":"On ne se souvient plus de toi chez les morts, qui donc dira tes louanges dessous terre?"
,"7":"Je ne fais que gémir, j'en suis épuisé, j'ai pleuré toute la nuit et mon lit a recueilli mes larmes."
,"8":"Le chagrin a terni mes yeux; tant d'oppositions m'ont fait vieillir."
,"9":"Loin de moi, vous tous qui travaillez pour le mal! Le Seigneur a écouté l'appel de mes larmes,"
,"10":"il a entendu mes supplications, il a recueilli ma prière."
,"11":"Mes ennemis, abattus, ne s'en remettront pas, qu'ils s'enfuient sur-le-champ, couverts de honte!"
}`)
	CurrentBook.AddChapter(7, `{
"1":"Complainte de David, qu'il chanta à Yahvé au sujet de Kouch de Benjamin."
,"2":"Seigneur, mon Dieu, tu es mon refuge, sauve-moi du persécuteur, délivre-moi."
,"3":"Comme un lion, il voudrait me déchirer, m'emporter sans que personne me délivre."
,"4":"Seigneur, mon Dieu, qu'ai-je fait de mal? L'argent a-t-il sali mes mains?"
,"5":"Ai-je rendu le mal à mes bienfaiteurs? Ai-je fait tort sans raison à mon adversaire?"
,"6":"Que l'ennemi alors me poursuive et m'atteigne, qu'il me jette à terre sans vie, et piétine mes entrailles dans la poussière."
,"7":"Lève-toi, Seigneur, montre ta colère, dresse-toi face à la rage de l'adversaire, réveille-toi, ô Dieu, ordonne le jugement."
,"8":"Que les peuples ensemble se rangent autour de toi, et toi, là-haut, tu siégeras au-dessus d'eux"
,"9":"car tu es le Seigneur, le juge des nations. Juge-moi, Seigneur, vois que je suis juste et reconnais mon innocence."
,"10":"Mets un terme au mal et aux méchants et affermis le juste, car tu sondes les reins et les coeurs: tu es un Dieu juste."
,"11":"Dieu est mon bouclier, il sauve les coeurs droits."
,"12":"Dieu est un juste juge, un Dieu toujours prêt à frapper."
,"13":"Reprenez-vous, sinon il aiguise l'épée, il bande son arc et il vise,"
,"14":"il y ajuste des armes de mort, des flèches enflammées."
,"15":"Voyez l'homme qui porte le mal en son sein: il a conçu la malchance, il enfantera l'échec."
,"16":"Il a creusé la fosse, il l'a faite profonde, il tombera dans le trou qu'il a fait."
,"17":"La malchance reviendra sur sa tête, sa violence lui retombera sur le crâne."
,"18":"Je célébrerai le Seigneur car il est juste, je jouerai ma musique pour le nom du Très-Haut."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Au maître de chant. Sur 'la guittienne'. Psaume de David."
,"2":"O Yahvé, notre Seigneur, l'éclat de ton nom est partout sur la terre, ta grandeur dépasse la hauteur des cieux."
,"3":"Même la bouche des enfants et des nourrissons,rappelle ta puissance face à l'adversaire,et remplit de honte l'ennemi et le rebelle."
,"4":"Quand je vois ton ciel, oeuvre de tes doigts, la lune et les étoiles que tu y as fixées,"
,"5":"qu'est-ce que le mortel? Et toi tu t'en souviens. Qu'est-ce que le fils d'homme? Et tu veilles sur lui."
,"6":"Tu en as fait un peu moins qu'un Dieu, tu l'as couronné de gloire et d'éclat,"
,"7":"tu lui as soumis l'oeuvre de tes mains, tu as tout rangé sous ses pieds,"
,"8":"que ce soient les brebis ou les boeufs, ou même les bêtes sauvages"
,"9":"et l'oiseau du ciel et les poissons des mers, pélerins des routes sous-marines."
,"10":"O Yahvé, notre Dieu, qu'il est grand, ton nom, partout sur la terre."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Au maître de chant. Sur l'air 'mort au fils...'. Psaume de David."
,"2":"Je veux te louer, Seigneur, de toute mon âme, je veux redire toutes tes merveilles."
,"3":"Je veux me réjouir et que ma joie éclate pour toi, je fêterai ton nom, ô Très-Haut."
,"4":"Car l'ennemi recule, il chancelle puis il tombe devant toi,"
,"5":"quand tu juges et te prononces en ma faveur depuis ton trône où tu sièges, ô juste juge."
,"6":"Tu as maté les païens, fait périr les méchants; tu as effacé leurs noms pour toujours."
,"7":"L'ennemi est achevé, ruiné à jamais, ses villes déracinées: on n'en parlera plus."
,"8":"Voici que le Seigneur règne et c'est pour toujours, son trône est là, il va juger."
,"9":"Il jugera le monde avec justice, il fera avec droiture le procès des nations."
,"10":"Que le Seigneur soit à l'opprimé son refuge, son lieu fort dans les temps de détresse."
,"11":"En toi se confient ceux qui connaissent ton nom, car tu n'oublies pas, Seigneur, ceux qui te cherchent."
,"12":"Jouez pour le Seigneur qui habite en Sion, racontez ses exploits parmi les païens."
,"13":"Car il fait rendre compte, il n'oublie pas le sang ni les cris des malheureux."
,"14":"Aie pitié de moi, Seigneur, vois comme on me maltraite, redonne-moi la vie quand je suis presque mort,"
,"15":"et je dirai toutes tes louanges aux portes et sur les places de notre chère Sion."
,"16":"Les païens sont tombés dans la fosse qu'ils ont faite, leur pied s'est pris au filet qu'ils avaient caché."
,"17":"Le Seigneur s'est montré, il a rendu justice, le méchant s'est trouvé pris dans ses propres méfaits."
,"18":"Que les méchants retournent dessous terre, tous ces païens qui oublient Dieu."
,"19":"Car le pauvre n'est pas oublié jusqu'à la fin, l'espoir des humbles ne sera pas sans fin déçu."
,"20":"Lève-toi, Seigneur, les hommes seraient-ils plus forts? Que les nations soient jugées en ta présence."
,"21":"Impose-leur ta crainte, Seigneur, que ces païens sachent qu'ils ne sont que des hommes."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Pourquoi, Seigneur, restes-tu si loin? Veux-tu te cacher dans les temps difficiles?"
,"2":"L'arrogant est mauvais jusqu'à chasser le pauvre, qu'il se prenne au piège qu'il a posé lui-même."
,"3":"Le méchant se vante de sa convoitise, le profiteur se moque, il défie le Seigneur."
,"4":"Il redresse la tête et ne veut rien savoir: 'Pas de Dieu.' Voilà toute sa pensée."
,"5":"La réussite du méchant est continuelle; il croit que tes sentences restent dans les hauteurs, et d'un souffle il balaie les opposants."
,"6":"Il se fait fort de résister à tout. Il dit: 'Ma chance et mon bonheur sont pour toujours.'"
,"7":"Il ne dit que jurons, tromperies et astuce, sous sa langue sont cachés méfaits et mauvais sorts."
,"8":"C'est une bête à l'affût dans les roseaux, qui tue l'innocent en cachette. Ses yeux guettent le malchanceux."
,"9":"Il se met à l'affût comme le lion dans son fourré, il guette le malheureux, il l'enlève, il l'a pris dans son filet."
,"10":"Il guette, il est là caché, et le malheureux tombe en son pouvoir."
,"11":"Il pense en lui-même: 'Dieu oublie, il n'a pas voulu voir, il ne voit jamais rien.'"
,"12":"Lève-toi, Seigneur, mon Dieu, lève ta main, n'oublie pas les malheureux."
,"13":"Faut-il donc que les méchants te méprisent et qu'ils pensent: 'Dieu ne fera pas d'enquête'?"
,"14":"Tu as vu, toi, le chagrin et la peine, car tu regardes et tu les prends dans ta main. A toi s'abandonne le malchanceux, c'est toi qui portes secours à l'orphelin."
,"15":"Brise le bras de l'injuste et du méchant, demande-lui des comptes et que sa méchanceté disparaisse à jamais."
,"16":"Voici que le Seigneur est roi et c'est pour toujours, les païens ont disparu de sa terre."
,"17":"Car tu entends, Seigneur, l'aspiration des humbles, tu raffermis leur coeur et tes oreilles écoutent"
,"18":"pour faire justice à l'orphelin et à l'opprimé, et que l'homme, né de la terre, jamais plus n'agisse en tyran."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Au maître de chant. De David. Je me confie dans le Seigneur; pourquoi donc me dites-vous: 'Fuyez, oiseaux, vers vos montagnes;"
,"2":"c'est l'heure où les méchants bandent leur arc, ajustent la flèche sur la corde,et visent dans l'ombre les hommes au coeur droit."
,"3":"Quand les fondations sont en ruine, que peut faire le juste?'"
,"4":"Le Seigneur est dans son saint temple, il est, lui et son trône, dans les cieux. De ses yeux il contemple le monde, il observe les fils d'Adam."
,"5":"Le Seigneur pèse le coeur du juste et du mauvais, il déteste ceux qui aiment la violence."
,"6":"Il fera pleuvoir sur les méchants,le soufre et les charbons ardents. Un prix leur est réservé: c'est le souffle de feu."
,"7":"Le Seigneur est juste et il aime la justice, ceux qui sont droits verront sa face."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Au maître de chant. A l'octave. Psaume de David."
,"2":"Interviens, Seigneur, c'en est fait des croyants, les gens sincères ont disparu de chez les hommes."
,"3":"On dit des faussetés à son prochain, on dit des mots flatteurs, mais le coeur est double."
,"4":"Que le Seigneur supprime la langue menteuse, la langue qui fait de beaux discours,"
,"5":"ces gens qui disent: 'Nous aurons le dernier mot, nous savons parler, qui va nous mettre au pas?'"
,"6":"'Les malheureux sont opprimés, dit le Seigneur, les pauvres gémissent, aussi moi je me lève, je vais secourir celui qu'on élimine.'"
,"7":"Les paroles du Seigneur sont des parole sûres, de l'argent fin, passé au creuset sept fois."
,"8":"C'est toi, Seigneur, qui prends soin de nous, protège-nous toujours de ces gens."
,"9":"Partout les méchants s'agitent et la débauche va croissant chez les fils d'Adam."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Au maître de chant. Psaume de David."
,"2":"Veux-tu donc, Seigneur, m'oublier jusqu'à la fin? Voudras-tu toujours me cacher ton visage?"
,"3":"Devrai-je sans cesse garder en moi ma souffrance, et dans mon coeur le chagrin tout au long du jour? Mon ennemi sera-t-il toujours le plus fort?"
,"4":"Regarde et réponds-moi, Seigneur mon Dieu. Que mes yeux voient ta lu mière, ou je m'endors avec les morts."
,"5":"Alors mon ennemi pourra dire: 'Je l'ai eu', et mes adversaires s'amuseront de ma chute."
,"6":"Mais moi, je m'en remets à ta grâce, donne à mon coeur la joie d'être sauvé. Alors mon chant dira: 'Le Seigneur m'a fait du bien.'"
}`)
	CurrentBook.AddChapter(14, `{
"1":"Au maître de chant. De David. L'insensé l'a décidé: 'Il n'y a pas de Dieu.',C'est la corruption, c'est l'immoralité: pas un qui fasse le bien."
,"2":"Du haut des cieux le Seigneur se penche,sur cette race d'Adam. Il cherche du regard un homme qui vaille, quelqu'un qui recherche Dieu."
,"3":"Mais tous sont dévoyés, également pervertis. Pas un qui fasse le bien, pas même un seul."
,"4":"Ils ne pensent donc pas, ces gens qui font le mal,et qui dévorent mon peuple: c'est là leur pain. Ils ne prient jamais le Seigneur."
,"5":"Mais les voici soudain frappés d'effroi: le Seigneur était là dans le parti des justes!"
,"6":"Vous pouviez bien détruire les espoirs du pauvre,mais le Seigneur est son refuge."
,"7":"Quand donc brillera en Sion le salut d'Israël?,Quand le Seigneur ramènera son peuple, ce sera la joie en Jacob, Israël sera comblé."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Psaume de David. Seigneur, qui sera ton hôte dans ta demeure, qui habitera sur ta montagne sainte?"
,"2":"Celui qui marche toujours droit,et qui pratique la justice, qui dit la vérité selon sa conscience"
,"3":"et ne parle pas de travers. Il ne fait pas de tort au prochain,et ne rabaisse pas ses voisins,"
,"4":"il méprise celui que Dieu condamne, il estime ceux qui craignent le Seigneur. Il tient parole même s'il doit en souffrir,"
,"5":"il prête son argent sans demander d'intérêt, et ne se vend pas pour nuire à l'innocent. Fais cela et tu resteras ferme."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Poème de David,Garde-moi, mon Dieu, car je m'abrite en toi!"
,"2":"Je lui ai dit: 'Tu es mon Seigneur, je ne veux rien avoir sinon toi.'"
,"3":"Les dieux de cette terre ne sont que fumier, malheur à ceux qui trouvent en eux leur plaisir"
,"4":"et courent après eux: leurs maux seront sans nombre. Je ne verserai pas le sang en leur honneur, on ne m'entendra pas prononcer leurs noms."
,"5":"Le Seigneur est ma part, mon héritage,et la coupe qui me porte bonheur: garde-moi cette part."
,"6":"Le tirage au cordeau m'a laissé le meilleur, je suis ravi de mon héritage."
,"7":"Je bénis le Seigneur qui toujours me conseille, même durant les nuits mon coeur m'avertit."
,"8":"Je garde toujours le Seigneur devant mes yeux, s'il se tient à ma droite, qui pourra m'ébranler?"
,"9":"J'en ai le coeur joyeux, je me sens tout en fête, même ma chair en éprouve sécurité,"
,"10":"car tu ne donneras pas mon âme,au royaume des morts, tu ne voudras pas pour ton fidèle,l'expérience de la corruption."
,"11":"Tu me feras connaître le chemin de la vie, une plénitude de joie en ta présence, un bonheur sans fin juste à ta droite."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Prière de David,Entends mon cri, Seigneur, écoute mes réclamations, prête l'oreille à ma prière car elle ne cache aucun mensonge."
,"2":"Je veux que de toi vienne ma sentence, car tes yeux voient ce qui est droit. Tu as fouillé mon coeur en visite de nuit, tu m'as mis à l'épreuve du feu et tu n'a rien trouvé qui me fasse honte. Je n'ai pas parlé de travers "
,"4":"comme font les hommes, j'ai gardé ta parole, j'ai suivi ton chemin."
,"5":"Affermis mes pas dans tes sentiers, ne permets pas que mon pied chancelle."
,"6":"Je t'appelle, mon Dieu, pour que tu me répondes, prête-moi l'oreille, écoute ce que je vais dire."
,"7":"Toi qui fais des merveilles pour tes fidèles, toi qui sauves ceux qui fuient l'agresseur et se réfugient à ton côté,"
,"8":"garde-moi comme la prunelle de tes yeux, place-moi en secret à l'ombre de tes ailes,"
,"9":"cache-moi aux violents, à ces méchants, mes ennemis à mort qui déjà m'encerclent."
,"10":"Leur conscience est empâtée et leur bouche est pleine d'arrogance."
,"11":"Ils me surveillent et soudain ils m'encerclent, ils se préparent pour me jeter à terre."
,"12":"Je crois voir un lion impatient de déchirer, ou son lionceau tapi dans sa cachette."
,"13":"Lève-toi, Seigneur, fais face, renverse-le, frappe de l'épée et délivre-moi du méchant."
,"14":"Fais-les périr de ta main, Seigneur, qu'ils ne soient plus comptés parmi les vivants. Fais-leur avaler ce que tu leur réserves; qu'ils en aient le ventre plein et de même leurs fils, et qu'il en reste pour leurs petit-enfants."
,"15":"Mais moi, dans un matin de justice, je contemplerai ta face; à mon réveil je me rassasierai de ton image."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Au maître de chant. Psaume de David, serviteur de Yahvé. Il adressa les paroles de ce cantique à Yahvé le jour où celui-ci l'eut délivré du pouvoir de tous ses ennemis et de la main de Saül."
,"2":"Il dit: Tu es ma force, Seigneur, et je t'aime."
,"3":"Oui, il est mon rocher, ma forteresse, il est un libérateur: il est mon Dieu. Il est le rocher: en lui j'ai mon abri, il est mon bouclier, ma percée victorieuse."
,"4":"J'invoque le Seigneur, digne de louanges, et je me vois sauvé de mes ennemis."
,"5":"Les flots de la mort m'enveloppaient, les torrents diaboliques m'épouvantaient,"
,"6":"j'étais pris dans les filets du monde infernal, je voyais devant moi les pièges de la mort,"
,"7":"dans mon angoisse j'ai appelé le Seigneur, j'ai crié vers mon Dieu. Mon cri est arrivé à ses oreilles et de son Temple il a entendu ma voix."
,"8":"Alors la terre a tremblé, elle s'est ébranlée, les fondements des cieux en ont frémi, ils tremblaient en voyant sa colère."
,"9":"Une vapeur montait à ses narines, de sa bouche s'échappait un feu dévorant, il en sortait des charbons embrasés."
,"10":"Il inclina les cieux, il descendit, dessous lui s'étendait une nuée obscure."
,"11":"Il vola, monté sur un chérubin, il apparut sur les ailes du vent."
,"12":"Tout autour de lui, un rideau de ténèbres, de lourds nuages amoncelés forment sa tente."
,"13":"Un éclat le précède, grêles et grêlons de feu."
,"14":"Puis dans les cieux éclate son tonnerre: le Seigneur fait entendre sa voix."
,"15":"Il leur lance ses flèches et les voilà en fuite, ses éclairs dispersent ses ennemis."
,"16":"Le plancher des eaux apparaît à découvert, les bases du monde sont mises à nu: c'est l'effet de ta menace, Seigneur, quand passe sur eux le souffle de ton haleine."
,"17":"D'en haut il a étendu sa main, il m'a pris et m'a arraché aux eaux."
,"18":"Il m'a délivré d'ennemis redoutables, d'un adversaire plus fort que moi,"
,"19":"Ils m'attaquaient au jour de mon malheur, mais le Seigneur s'est fait mon appui."
,"20":"Il m'a mis au large, il m'a sauvé car il m'aime."
,"21":"Le Seigneur m'a traité selon mon mérite; mes mains étaient pures, il m'a récompensé."
,"22":"Car je suivais les voies du Seigneur, je n'ai pas péché, m'écartant de mon Dieu."
,"23":"Tous ses jugements sont présents devant moi, je n'ai pas mis de côté ses commandements."
,"24":"Je suis devant lui sans reproche et je me garde bien de fauter."
,"25":"Aussi il me traite selon mes mérites, j'ai les mains pures et lui me récompense."
,"26":"Si l'on est fidèle, tu te montres fidèle, si l'on est sans reproche, tu es irréprochable."
,"27":"Si l'on a le coeur droit, tu agis de même, mais si l'homme est retors, tu sais le prendre au piège."
,"28":"Car tu viens au secours d'un peuple humilié, mais tu fais baisser les yeux aux arrogants."
,"29":"C'est toi, Seigneur, qui fais briller ma lampe, mon Dieu éclaire mes ténèbres."
,"30":"Avec toi je fonce sur l'ennemi, avec mon Dieu je saute la muraille."
,"31":"Tout est parfait chez mon Dieu et sa parole résiste au feu. Il est un bouclier pour ceux qui s'abritent en lui."
,"32":"Qui est Dieu sinon Yahvé? Qui est un roc sinon lui, notre Dieu?"
,"33":"C'est le Dieu qui me remplit de force et qui devant moi aplanit le chemin."
,"34":"Il rend mes pieds pareils à ceux des biches et me fait me tenir debout sur les hauteurs."
,"35":"Il entraîne mes mains pour le combat, mes bras, pour manier l'arc de bronze."
,"36":"Tu me donnes ton salut comme un bouclier, ta main me soutient, tes bontés me grandissent,"
,"37":"tu me fais allonger le pas sans que mes chevilles faiblissent."
,"38":"Je poursuis mes ennemis, je les atteins, je ne reviens que lorsqu'ils sont achevés."
,"39":"Je les frappe: ils ne peuvent se relever, ils tombent et restent à mes pieds."
,"40":"Tu me remplis de force pour le combat, tu fais courber l'échine à mes adversaires."
,"41":"Mon ennemi s'enfuit, je ne vois que son dos, ceux qui me détestent, je les réduis à rien."
,"42":"Ils peuvent crier, pas de sauveur pour eux, le Seigneur ne leur répond pas."
,"43":"Je les réduis en poussière que le vent emporte, je les piétine dans la boue du chemin."
,"44":"Tu me délivres des querelles de mon peuple, tu me places à la tête des nations, un peuple m'obéit qui n'était pas le mien."
,"45":"Les étrangers me font des sourires, dès qu'ils m'entendent, ils obéissent."
,"46":"Les étrangers sont à bout de forces, ils sortent en tremblant de leurs villes fortes."
,"47":"Vive le Seigneur, béni soit mon rocher! je veux rendre gloire au Dieu qui me sauve."
,"48":"O Dieu, tu m'as accordé ma vengeance, tu m'as soumis les peuples."
,"49":"Tu me délivres de mes ennemis et me rends maître de l'agresseur, tu me libères des violents."
,"50":"Aussi je veux te rendre gloire, ô Seigneur; je chanterai ton nom chez les païens, je dirai:"
,"51":"'Il donne à son roi victoire sur vic toire, gardant sa grâce à celui qu'il a consacré, à David et à sa descendance pour toujours.'"
}`)
	CurrentBook.AddChapter(19, `{
"1":"Au maître de chant. Psaume de David."
,"2":"Les cieux racontent la gloire de Dieu, la voûte aux étoiles expose l'oeuvre de ses mains."
,"3":"Le jour en parle avec le jour,et la nuit à la nuit en rafraîchit la connaissance."
,"4":"Pas besoin de bouche ni de parole, nulle voix ne se fait entendre,"
,"5":"mais sur toute la terre on en perçoit le sens, leur message est écouté jusqu'au bout du monde. Le soleil a sa tente à l'horizon des mers,"
,"6":"il sort comme un nouveau marié tout joyeux de sa chambre,et sûr de lui, il parcourt sa route."
,"7":"Il commence au plus loin des horizons des cieux,et lorsqu'il a fini à l'autre extrémité, rien n'a pu se soustraire à ses rayons."
,"8":"La Loi du Seigneur est parfaite, elle redonne vie à l'âme. Les déclarations du Seigneur ne trompent pas, elles donnent aux simples la sagesse."
,"9":"Les règles du Seigneur vont droit au but: on y trouve la joie intérieure. Le commandement du Seigneur est transparent, il donne à tes yeux la lumière."
,"10":"La crainte du Seigneur est un diamant, elle dure pour l'éternité. Les sentences du Seigneur sont vérité, où qu'elles frappent, elles sont justes."
,"11":"Elles sont plus précieuses que l'or chez l'orfèvre, plus délicieuses que le miel en son rayon."
,"12":"Aussi ton serviteur y cherche la lumière; que ne gagne-t-on pas à les observer!"
,"13":"Car, qui est conscient de ses erreurs?,Purifie-moi du mal qui m'échappe."
,"14":"Préserve aussi ton serviteur de l'orgueil, qu'il ne domine pas sur moi: alors je serai pur de tout gros péché."
,"15":"Seigneur, mon rocher, mon rédempteur, j'aimerais que mes paroles te plaisent, tout cela que je médite, seul devant toi."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Au maître de chant. Psaume de David."
,"2":"Que le Seigneur te réponde au jour de détresse, que le Nom du Dieu de Jacob te protège."
,"3":"Que lui, de son saint Temple, t'envoie le secours, et que tu reçoives de Sion son soutien."
,"4":"Qu'il se souvienne de toutes tes offrandes, qu'il prenne plaisir à tes sacrifices."
,"5":"Qu'il te donne ce que ton coeur désire et fasse réussir tes projets."
,"6":"Que nous puissions acclamer ta victoire, être orgueilleux du nom de notre Dieu. Que le Seigneur mène à bien ce que tu lui confies."
,"7":"Maintenant je sais que le Seigneur sauve son roi; il lui a répondu de son sanctuaire céleste. Il lui a donné la victoire, sa main a fait des merveilles."
,"8":"Les autres ont leurs chars, leurs chevaux, mais nous, nous invoquons le Nom du Seigneur notre Dieu."
,"9":"Alors ils fléchissent, ils tombent, et nous, nous tenons, nous repartons."
,"10":"O Seigneur, garde le roi et réponds-nous au jour de notre appel!"
}`)
	CurrentBook.AddChapter(21, `{
"1":"Au maître de chant. Psaume de David."
,"2":"Seigneur, ta puissance fait la joie du roi: tu lui promets le succès: quel bonheur!"
,"3":"Tu lui as accordé ce qu'il souhaitait, tu n'as pas refusé ce qu'il te demandait."
,"4":"Tu viens à lui avec de bonnes bénédictions, toi qui places sur sa tête une couronne d'or."
,"5":"Il te demandait la vie: tu la lui donnes, un grand nombre de jours, beaucoup, beaucoup d'années."
,"6":"Grâce à toi il aura la gloire, car tu le feras réussir; tu lui accordes honneur et majesté."
,"7":"Tu l'as béni pour la suite des temps, ta présence déjà fait sa joie."
,"8":"Le roi se confie dans le Seigneur, par la grâce du Très-Haut il ne faiblira pas."
,"9":"Oui, ta main atteindra ton ennemi, tes armes sauront trouver ceux qui te haïssent."
,"10":"Dès que tu parais, ils sont comme l'herbe au four: le Seigneur dans sa colère les dévorera comme un feu."
,"11":"Tu enlèveras de la terre leur race, et leur semence disparaîtra d'entre les hommes."
,"12":"S'ils te cherchent du mal, s'ils font des plans contre toi, ils ne pourront rien."
,"13":"Quand tu banderas face à eux la corde de l'arc, tu leur feras tourner le dos."
,"14":"Lève-toi, Seigneur, montre ta puissance, et nous jouerons, nous chanterons ta vaillance."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Au maître de chant. Sur l'air 'Biche de l'aurore...'. Psaume de David."
,"2":"Mon Dieu, mon Dieu, pourquoi m'as-tu abandonné? Que tu es loin de mon appel, loin des paroles que je crie!"
,"3":"Mon Dieu, je t'appelle de jour sans que tu répondes, de toute la nuit je ne peux me taire."
,"4":"C'est toi qui habites le Sanctuaire d'où monte vers toi la louange d'Israël."
,"5":"Nos pères ont mis en toi leur espérance, ils espéraient et tu les sauvais."
,"6":"Ils criaient vers toi et tu les délivrais, ils avaient confiance et n'étaient pas déçus."
,"7":"Mais moi je ne suis plus un homme, rien qu'un ver; on a honte de moi, le peuple me méprise."
,"8":"Ceux qui me voient se moquent, ils ricanent, ils hochent la tête et ils disent:"
,"9":"'Il s'en est remis au Seigneur, qu'il le délivre, qu'il le sauve, s'il tient à lui.'"
,"10":"C'est toi qui m'as accouché et placé entre les seins de ma mère."
,"11":"Au sortir du sein j'étais jeté sur toi, c'est toi mon Dieu dès le sein de ma mère."
,"12":"Ne t'éloigne pas de moi quand l'angoisse est là, vois que personne ne me secourt."
,"13":"Me voici encerclé: c'est une horde de taureaux sauvages, de bêtes de Bashan."
,"14":"Je crois voir la gueule grande ouverte de lions rugissants prêts à me dévorer."
,"15":"Je suis comme un vase qui perd l'eau, tous mes os se disloquent, mon coeur est une cire qui fond, il se défait dans mes entrailles."
,"16":"J'ai la gorge sèche comme un tesson, ma langue se colle à mon palais, j'ai déjà sur les lèvres la poussière de la tombe."
,"17":"Une meute de chiens m'entoure, une bande de malfaiteurs m'attaque, ils m'ont lié les mains et les pieds."
,"18":"Ils ont pu compter tous mes os, car ils me regardent et m'observent."
,"19":"Ils se partagent mes vêtements; ma tunique, ils l'ont tirée au sort."
,"20":"Mais toi, Seigneur, ne reste pas au loin, toi qui es ma force, hâte-toi de me secourir."
,"21":"Réclame à l'épée ma vie: je n'en ai qu'une; reprends-la d'entre les pattes du chien."
,"22":"Délivre-moi de la gueule du lion, sauve celui qui n'est rien, des cornes du taureau."
,"23":"Je ferai pour mes frères l'éloge de ton nom, je te louerai dans la grande assemblée:"
,"24":"'Vous qui craignez le Seigneur, louez-le, que toute la race de Jacob le vénère, que les descendants d'Israël le redoutent!"
,"25":"Car il n'a pas rougi de voir, il n'a pas méprisé le malheur du malheureux. Il n'a pas détourné de lui son regard, il a répondu à son appel.'"
,"26":"Qui vais-je louer sinon toi, dans la grande assemblée? Je tiendrai mes promesses devant ceux qui te craignent."
,"27":"Tes pauvres mangeront et seront rassasiés: vous qui cherchez le Seigneur, louez-le, et que vos coeurs vivent à jamais."
,"28":"Partout, alors, on fera mention du Seigneur, de toute la terre on reviendra vers lui, toutes les familles des nations viendront adorer."
,"29":"Car la royauté appartient au Seigneur, c'est lui qui a pouvoir sur les nations."
,"30":"Ceux-là même qui dorment dans la terre se prosterneront devant lui; ceux qui sont devenus poussière lui rendront hommage. Mon âme vivra pour lui, "
,"31":"ma race le servira, pour parler du Seigneur à la génération"
,"32":"qui vient, pour annoncer sa justice au peuple qui va naître: 'Voilà ce qu'a fait le Seigneur!'"
}`)
	CurrentBook.AddChapter(23, `{
"1":"Psaume de David. Le Seigneur est mon pasteur, je ne manque de rien."
,"2":"Sur des prés d'herbe fraîche il me fait reposer, vers les eaux du repos il me mène,"
,"3":"il y refait mon âme. Il me conduit sur les droits chemins,pour la gloire de son Nom."
,"4":"Même si je passais par le sombre ravin, je n'aurais pas de crainte: tu es avec moi,et ton bâton, ta houlette me rassurent."
,"5":"Tu me prépares la table devant moi, face à mes adversaires. Tu verses l'huile et le parfum sur ma tête, ma coupe est débordante."
,"6":"Oui, le bonheur et ta grâce me poursuivent,tout au long de ma vie, jusqu'à habiter dans ta maison, Seigneur, pour des jours sans fin."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Psaume de David. La terre est au Seigneur avec son contenu, sa surface ronde et puis ceux qui l'habitent."
,"2":"C'est lui qui l'a placée au-dessus des eaux, qui la maintient plus haut que les fleuves."
,"3":"Qui montera à la montagne du Seigneur,pour s'y tenir debout dans son lieu saint?"
,"4":"Celui qui a les mains pures et le coeur limpide, qui ne se laisse pas aller au mensonge, et ne jure pas pour tromper."
,"5":"Il emportera la bénédiction du Seigneur,et l'approbation de Dieu, son sauveur."
,"6":"Ainsi doivent être ceux qui cherchent le Seigneur, ceux qui recherchent ta face, Dieu de Jacob."
,"7":"Portes, levez vos frontons, faites-vous plus hautes, portes antiques, laissez entrer le roi de gloire!"
,"8":"- Mais qui est ce roi de gloire?,- C'est le Seigneur, le fort, le vaillant, le Seigneur vaillant au combat!"
,"9":"Portes, levez vos frontons, faites-vous plus hauts, portails antiques, laissez entrer le roi de gloire!"
,"10":"- Mais qui est ce roi de gloire?,- C'est Yahvé Sabaot, c'est lui le roi de gloire."
}`)
	CurrentBook.AddChapter(25, `{
"1":"De David. Vers toi, Seigneur j'élève mon âme, vers toi qui es mon Dieu."
,"2":"En toi je me confie, que je ne sois pas déçu, que mes ennemis n'aient pas le dessus."
,"3":"Ceux qui comptent sur toi ne seront pas déçus; seront déçus ceux qui te mentent sans raison."
,"4":"Seigneur, fais que je connaisse tes voies, enseigne-moi tes sentiers."
,"5":"Fais que je marche dans ta vérité: instruis-moi, puisque tu es pour moi le Dieu qui sauve, et tout le jour j'espère en toi,"
,"7c":"pensant à ta bonté, Seigneur."
,"6":"Réveille ta tendresse, Seigneur, et tes bontés qui sont de toujours."
,"7":"Oublie mes péchés, les erreurs de ma jeunesse, et souviens-toi de moi dans ta bonté."
,"8":"Le Seigneur est bon, il est droit, aussi il corrige le pécheur en son chemin."
,"9":"Il fait que ses pauvres vivent dans la droiture, il enseigne aux pauvres son chemin."
,"10":"L'agir du Seigneur n'est que grâce et fidélité pour ceux qui gardent son alliance et ses lois."
,"11":"Fais honneur à ton nom, Seigneur, pardonne-moi ma dette car elle est grande."
,"12":"Voyez-vous quelqu'un qui craigne le Seigneur? il lui fait voir aussitôt le chemin à prendre."
,"13":"Son âme est à demeure dans l'abondance, ses enfants posséderont la terre."
,"14":"Le secret du Seigneur est pour ceux qui le craignent, il leur fera connaître son alliance."
,"15":"Mes yeux ne se détournent pas du Seigneur, il me gardera du filet à mes pieds."
,"16":"Regarde-moi, aie compassion de moi, vois que je suis seul et sans moyens."
,"17":"Retire-moi cette angoisse qui m'oppresse et fais-moi sortir de ces épreuves."
,"18":"Vois ma misère et ma peine, enlève tous mes péchés de dessus moi."
,"19":"Regarde le nombre de mes adversaires: quelle haine, quelle violence à mon égard!"
,"20":"Garde-moi en vie et délivre-moi, que je ne sois pas déçu d'avoir compté sur toi."
,"21":"Que l'innocence et la droiture soient mes gardes; oui, je mets en toi mon espérance."
,"22":"O Dieu, sauve Israël de toutes ses épreuves!"
}`)
	CurrentBook.AddChapter(26, `{
"1":"De David. Reconnais, Seigneur, que j'ai marché tout droit, je m'appuyais sur toi et ne déviais pas."
,"2":"Sonde-moi, Seigneur: tu peux m'éprouver, passer au feu mes reins et mon coeur."
,"3":"J'ai sous les yeux sans cesse ta bonté, et tous mes pas répondent à ta fidélité."
,"4":"Je n'ai pas de rapports avec les fourbes, je n'entre pas chez les hypocrites."
,"5":"Je déteste le parti des malfaisants, je ne m'assieds pas avec les gens sans foi."
,"6":"Je lave mes mains, mais elles sont nettes, et puis je fais le tour de ton autel, Seigneur,"
,"7":"en chantant mon action de grâce, en redisant toutes tes merveilles."
,"8":"O Seigneur, que j'ai aimé ce temple où tu habites, cet endroit où réside ta Gloire."
,"9":"Que mon âme n'aille pas où vont les pécheurs et que ma vie échappe au sort des criminels,"
,"10":"ces hommes malfaisants aux mains souillées, qui ont toujours en poche un argent sale."
,"11":"Mais moi, puisque je marche droit, rachète-moi, Seigneur, aie pitié de moi."
,"12":"Mon pied tient bon sur un terrain sûr; dans ton Eglise, Seigneur, je veux te bénir."
}`)
	CurrentBook.AddChapter(27, `{
"1":"De David. Le Seigneur est ma lumière, mon salut, de qui aurai-je peur?,Si le Seigneur est le rempart de ma vie, qui peut m'effrayer?"
,"2":"Si des malfaiteurs m'assaillent, s'ils cherchent à me déchirer, ce sont eux, mes ennemis, mes adversaires, qui trébuchent et qui tombent."
,"3":"Qu'une bande armée vienne et m'assiège, mon coeur est sans crainte; qu'une guerre éclate contre moi, là encore je reste confiant."
,"4":"Je ne demande au Seigneur qu'une chose, je n'en cherche pas d'autre, c'est d'habiter dans la maison du Seigneur, tous les jours de ma vie, pour en contempler la divine harmonie,et pour servir dans son sanctuaire."
,"5":"Il me prendra sous son toit, j'y aurai mon refuge aux jours du malheur; il me cachera dans le secret de sa tente,et me tirera de l'angoisse."
,"6":"Déjà je relève la tête,et je défie les ennemis qui m'entourent. Oui, je vais offrir dans sa tente,des sacrifices pour lui rendre grâce, je vais jouer et chanter le Seigneur."
,"7":"Ecoute, Seigneur, mon appel; sois bon, réponds-moi."
,"8":"Mon coeur te dit: 'Seigneur, je cherche ta face';"
,"9":"ne me cache pas ta face, toi qui es mon secours. Ne repousse pas ton serviteur avec colère, ne me laisse pas, ne m'abandonne pas, Dieu de mon salut!"
,"10":"Mon père et ma mère pourraient m'abandonner, toi, Seigneur, tu me recueillerais."
,"11":"Enseigne-moi, Seigneur, tes chemins, montre-moi la route sûre car l'ennemi est là."
,"12":"De faux témoins m'accusent et attisent la violence, ne me livre pas à la fureur de mes adversaires."
,"13":"Je verrai, j'en suis sûr, les bontés du Seigneur sur la terre des vivants."
,"14":"-Espère en le Seigneur, sois fort, affermis ton coeur, espère en le Seigneur!"
}`)
	CurrentBook.AddChapter(28, `{
"1":"De David. Seigneur, mon rocher, je t'appelle, ne fais pas le sourd. Si tu gardes le silence, je serai l'un de ceux qui vont à la fosse."
,"2":"Ecoute ma prière quand je crie vers toi, Seigneur, quand je lève les mains vers ton saint Temple."
,"3":"Ne me ramasse pas avec les méchants, avec les hommes malfaisants toujours pleins de bonnes paroles alors qu'ils projettent le mal."
,"4":"Donne-leur ce que valent leurs actes et la méchanceté de leur conduite. Tu leur feras comme ils ont fait, tu leur rendras la pareille."
,"5":"S'ils veulent ignorer les choses du Seigneur, tout ce que fait sa main, il ira chez eux pour détruire, non pour bâtir."
,"6":"Béni soit le Seigneur! Il a entendu ma prière."
,"7":"Le Seigneur est ma force, mon bouclier: mon coeur était sûr de lui, il m'a secouru. Mon coeur en est plein de joie, je le chante, je le louerai encore."
,"8":"Le Seigneur est la force de son peuple, il est pour son roi un refuge assuré. Sauve ton peuple et bénis ton héritage, sois leur pasteur et porte-les à jamais!"
}`)
	CurrentBook.AddChapter(29, `{
"1":"Psaume de David. Fils de Dieu, rendez gloire au Seigneur; reconnaissez, fils de Dieu, que lui seul est fort,"
,"2":"rapportez au Seigneur la gloire de son nom, prosternez-vous devant lui en grande liturgie."
,"3":"Une voix au-dessus des eaux! C'est le Seigneur, c'est le tonnerre du Dieu de gloire. Le Seigneur est là au-dessus de l'orage."
,"4":"Quelle puissance dans la voix du Seigneur!,Quel éclat dans la voix du Seigneur,"
,"5":"dans sa voix qui brise les cèdres!,Le Seigneur fracasse les cèdres du Liban"
,"6":"et le Liban tout entier danse comme un cabri, le mont Sirion, comme une bande de jeunes buffles."
,"7":"Voix du Seigneur! elle déchire des éclairs de feu,"
,"8":"Voix du Seigneur! elle fait trembler le désert, le désert de Qadesh en a été secoué."
,"9":"Voix du Seigneur, elle ébranle les arbres sacrés, elle dépouille les forêts, et dans son palais tout crie: Gloire!"
,"10":"Le Seigneur siégeait au-dessus du déluge, il siégeait, car il est roi à jamais."
,"11":"C'est le Seigneur qui donne à son peuple la force, il bénira son peuple et lui donnera la paix."
}`)
	CurrentBook.AddChapter(30, `{
"1":"Psaume. Cantique pour la dédicace du temple. De David."
,"2":"Je t'exalte, Seigneur, car tu m'as relevé, tu n'as pas laissé mes ennemis rire de moi."
,"3":"O Seigneur, mon Dieu, j'ai crié vers toi et tu m'as guéri."
,"4":"Tu as rappelé mon âme en route vers les morts, et tu m'as fait revivre quand j'allais à la fosse."
,"5":"Chantez au Seigneur, vous, ses fidèles, et célébrez son Nom très saint."
,"6":"Car sa colère ne dure qu'un instant, mais ses bontés, toute une vie. Au soir les pleurs s'installent, mais au matin c'est un cri de joie."
,"7":"Je me disais quand tout allait bien: 'Rien ne pourra m'ébranler!'"
,"8":"Mais c'est par ta bonté, Seigneur, que je tenais, comme planté sur un roc élevé. A peine as-tu caché ta face que je vacillais."
,"9":"J'ai crié vers toi, Seigneur, j'ai supplié mon Dieu:"
,"10":"'Que gagnes-tu à ma mort? Si je vais à la fosse, est-ce ma poussière qui dira tes louanges? Sera-t-elle une preuve de ta fidélité?"
,"11":"Ecoute, Seigneur, aie pitié, sois mon secours.'"
,"12":"Et tu m'as fait passer du deuil à la danse, tu as déchiré le sac, tu m'as vêtu de fête,"
,"13":"car tu ne veux pas mon silence mais le chant de mon coeur. Seigneur, mon Dieu, je te bénirai à jamais."
}`)
	CurrentBook.AddChapter(31, `{
"1":"Au maître de chant. Psaume de David."
,"2":"En toi, Seigneur je me confie, que je ne sois jamais déçu! Sauve-moi, toi qui veux la justice!"
,"3":"Tends vers moi ton oreille, hâte-toi de me délivrer; sois pour moi un roc, un refuge, la cité forte où je suis en sûreté."
,"4":"Car tu es ma roche et ma forteresse, tu me guides et me diriges pour l'honneur de ton nom."
,"5":"Arrache-moi au filet qu'on m'a tendu, car c'est toi qui es mon refuge."
,"6":"Entre tes mains je remets mon esprit, car c'est toi qui me délivres, Seigneur, Dieu fidèle."
,"7":"Tu détestes ceux qui servent leurs faux dieux, mais moi, j'ai confiance dans le Seigneur."
,"8":"Tes bontés feront ma joie, mon bonheur, car tu as vu mon malheur, tu as partagé l'angoisse de mon âme;"
,"9":"la main ennemie ne s'est pas refermée sur moi, et tu as mis mes pieds au large."
,"10":"Aie pitié de moi, Seigneur, le malheur est sur moi, le chagrin a terni mes yeux, brisé mes forces."
,"11":"Ma vie s'est fanée dans les peines, mes années, dans les gémissements. La misère a épuisé mes énergies, mes os ne tiennent plus."
,"12":"De mes adversaires je n'attends que mépris, mes voisins ont peur, mes familiers sont effrayés, ceux qui me voient dans la rue s'éloignent."
,"13":"Je suis sorti de leur mémoire, comme un mort, je ne suis plus qu'un objet de rebut."
,"14":"J'entends leurs calomnies: de tous côtés ce n'est que terreur. Ensemble ils complotent contre moi car ils cherchent à m'ôter la vie."
,"15":"Mais moi je m'en remets à toi et je te dis, Seigneur: C'est toi mon Dieu,"
,"16":"ma destinée est dans ta main: l'ennemi me poursuit, délivre-moi."
,"17":"Fais briller ta face sur ton serviteur, sauve-moi dans ta bonté."
,"18":"Que je ne sois pas déçu après t'avoir appelé, mais que mes ennemis soient déçus, qu'ils aillent rejoindre le silence des morts."
,"19":"Fais taire les bouches menteuses, les arrogants pleins de mépris et d'orgueil qui toujours attaquent le juste."
,"20":"Comme elle est grande, Seigneur, ta bonté, que tu réserves à ceux qui te craignent, que tu mets en oeuvre à la vue de tous pour ceux qui espèrent en toi."
,"21":"Tu les caches en secret près de toi loin des intrigues des humains, tu les prends sous ton toit, sous ta tente, loin des mauvaises langues."
,"22":"Béni soit le Seigneur, sa grâce a fait pour moi des merveilles!"
,"23":"Moi qui disais dans mon trouble: 'Tu m'as ôté de devant tes yeux.' Mais non, tu écoutais ma prière alors que je criais vers toi."
,"24":"Aimez le Seigneur, vous tous qui le servez; il garde celui qui mérite sa confiance, mais ceux qui le défient, il leur rend le double."
,"25":"Soyez forts et reprenez coeur, vous tous qui espérez dans le Seigneur."
}`)
	CurrentBook.AddChapter(32, `{
"1":"De David. Méditation. Heureux qui a sa faute pardonnée, son péché effacé;"
,"2":"heureux cet homme que le Seigneur voit sans dette,et dont l'esprit n'a rien à cacher."
,"3":"Tant que je me suis tu, un feu rongeait mes os. Tout le jour je criais ma plainte"
,"4":"car nuit et jour ta main pesait sur moi; pour moi plus de verdeur mais le feu de l'été."
,"5":"Je t'ai fait connaître mon péché, je n'ai plus caché ma faute, j'ai dit: 'Devant le Seigneur je reconnaîtrai mon tort', et tu as remis ma dette, pardonné mon péché."
,"6":"Chacun de tes fidèles, de même, te priera,au temps de la détresse. Les eaux peut-être déborderont, elles ne l'atteindront pas."
,"7":"Tu es pour moi le secret refuge, de l'épreuve tu me rachètes,et ton salut m'enveloppe."
,"8":"'Je vais t'instruire, te montrer la route à suivre, je te suivrai des yeux pour te conseiller."
,"9":"Ne sois pas comme le cheval ou la mule, privés d'intelligence; si tu n'as ni mors, ni frein pour les dompter, tu ne pourras les approcher; ils sont beaucoup trop fiers.'"
,"10":"Bien des peines attendent le pécheur, mais celui qui espère en le Seigneur, la grâce l'entoure de toutes parts."
,"11":"Réjouissez-vous dans le Seigneur, vous, ses fidèles, criez votre joie, vous qui avez le coeur droit."
}`)
	CurrentBook.AddChapter(33, `{
"1":"Fêtez le Seigneur, peuple des justes, c'est aux coeurs droits de l'acclamer."
,"2":"Prenez la guitare pour lui rendre grâce, jouez pour lui sur la harpe à dix cordes."
,"3":"Chantez pour lui un chant nouveau,avec de beaux accords pour l'ovation!"
,"4":"Car la parole du Seigneur est droite, sa fidélité paraît en toutes ses oeuvres."
,"5":"Il aime la justice et le droit, la terre est remplie de sa grâce."
,"6":"Par sa parole les cieux ont été faits, par son souffle ils ont reçu leur panoplie,"
,"7":"lorsqu'il avait encore l'eau des mers en son outre,et dans ses réservoirs retenait les eaux profondes."
,"8":"Terre entière, redoute le Seigneur, et que tes habitants soient saisis de crainte"
,"9":"car il n'a dit qu'un mot et cela fut, il a donné un ordre et tout est apparu."
,"10":"Il mène à l'échec le projet des nations, il réduit à rien ce qu'ont pensé les peuples."
,"11":"Mais son projet à lui tient à jamais, ce qu'a pensé le Seigneur passera les âges."
,"12":"Heureuse la nation qui a le Seigneur pour Dieu, le peuple qu'il a choisi pour en faire son peuple!"
,"13":"Du ciel le Seigneur regarde,et voit tous les fils d'Adam."
,"14":"Depuis le lieu de sa demeure,il observe les habitants du monde."
,"15":"Il a formé, lui seul, tous les coeurs, et de même il comprend tous leurs actes."
,"16":"Le roi ne vaincra pas parce qu'il a du monde, le brave ne se sauvera pas parce qu'il est fort."
,"17":"Pour vaincre, le cheval n'est pas le moyen sûr, quelle que soit sa valeur, ce n'est pas lui qui sauve."
,"18":"Mais le Seigneur suit des yeux ceux qui le craignent, ceux qui comptent sur son amour,"
,"19":"pour les sauver de la mort violente,et les maintenir en vie en temps de famine."
,"20":"Nos âmes espèrent dans le Seigneur, il est notre secours et notre bouclier."
,"21":"Nos coeurs trouvent en lui leur joie, en son saint Nom nous avons mis notre espérance."
,"22":"Que ta grâce, Seigneur, nous protège,notre confiance est toute en toi!"
}`)
	CurrentBook.AddChapter(34, `{
"1":"De David. Quand il fit le fou devant Abimélek et que, chassé par lui, il s'en alla."
,"2":"Je bénirai le Seigneur en tout temps, sa louange sans cesse dans ma bouche."
,"3":"Mon âme ne cesse de le chanter, que les humbles l'entendent et se réjouissent."
,"4":"Dites avec moi que le Seigneur est grand, ensemble exaltons son nom."
,"5":"J'ai cherché le Seigneur et j'ai eu sa réponse: il m'a délivré de toutes mes craintes."
,"6":"Regardez vers lui: ce sera la lumière, vous n'aurez plus le visage abattu."
,"7":"Cet homme tout simple a appelé: il est exaucé, le Seigneur l'a sauvé de toutes ses angoisses."
,"8":"L'ange du Seigneur campe et fait la ronde,tout autour de ceux qui le craignent."
,"9":"Goûtez et voyez que le Seigneur est bon, heureux l'homme qui se confie en lui."
,"10":"Craignez le Seigneur, vous, son peuple saint, ceux qui le craignent ne manquent de rien."
,"11":"Les riches n'ont plus rien et ils ont faim, mais ceux qui espèrent en le Seigneur, les bonnes choses ne leur font pas défaut."
,"12":"Venez, fils, écoutez-moi, je vous enseignerai la crainte du Seigneur."
,"13":"Es-tu l'homme qui veut vivre,et connaître des jours heureux?"
,"14":"Garde ta langue du mal,et tes lèvres de la parole trompeuse,"
,"15":"abstiens-toi du mal et fais le bien, recherche la paix et poursuis-la."
,"17":"Le Seigneur fait face aux méchants, il effacera de cette terre leur souvenir."
,"16":"Les yeux du Seigneur sont tournés vers ses justes, il prête l'oreille à leur clameur."
,"18":"S'ils crient, le Seigneur entend, il les délivre de toutes leurs angoisses."
,"19":"Le Seigneur est tout proche du coeur brisé, il sauve les esprits désemparés."
,"20":"Les malheurs du juste sont-ils nombreux?,le Seigneur toujours le délivre."
,"21":"Si le Seigneur garde ses os, pas un seul ne sera brisé."
,"22":"Le méchant mourra de sa méchanceté, ceux qui détestent le juste devront le payer."
,"23":"Le Seigneur délivre l'âme de ses serviteurs, ceux qui espèrent en lui ne seront pas perdants."
}`)
	CurrentBook.AddChapter(35, `{
"1":"De David. Attaque, Seigneur, ceux qui m'attaquent, fais la guerre à ceux qui me la font."
,"2":"Prends un bouclier d'attaque, et un de défense, puis lève-toi et viens me protéger."
,"3":"Fais face à mes persécuteurs, avec la lance, avec la hache, et dis à mon âme: 'Je suis ton salut.'"
,"4":"Couvre de honte ceux qui en veulent à ma vie, qu'ils reculent et soient humiliés: un échec total."
,"5":"Qu'ils soient comme la paille au vent, que l'ange du Seigneur les emporte!"
,"6":"Mets-les sur une voie ténébreuse et glissante et que l'ange du Seigneur soit dans leur dos."
,"7":"Sais-tu que les méchants m'ont tendu un filet? Sans raison ils ont creusé le sol sous mes pieds."
,"8":"Le mal leur reviendra d'où ils ne savent, ils se prendront au filet qu'ils ont tendu, ce sont eux qui tomberont dans la fosse."
,"9":"Et moi j'en serai tout joyeux devant Dieu, mon âme se réjouira de ses interventions."
,"10":"Alors tout en moi te célébrera: 'Seigneur, qui est comme toi?' Tu protèges le désemparé de ceux qui sont plus forts, et le pauvre, le faible, de celui qui les dépouille."
,"11":"Des témoins à charge se lèvent, on m'interroge pour des choses que j'ignore,"
,"12":"ils me rendent le mal pour le bien et me regardent me débattre."
,"13":"Mais moi, s'ils étaient malades je prenais le sac, je jeûnais et faisais pénitence, je ne cessais de redire ma prière."
,"14":"J'allais comme perdu, comme pour mon frère, comme pour un ami; j'allais tout courbé, comme on pleure sa mère."
,"15":"Mais à peine je tombe, ils s'en amusent, les voilà rassemblés tous ensemble contre moi, comme des étrangers, des inconnus."
,"16":"Ils ne cessent de me déchirer, de vrais hypocrites qui ne cessent de se moquer et de grincer des dents contre moi."
,"17":"Seigneur, vas-tu rester à regarder? Arrache-moi à ces lions rugissants: je n'ai qu'une vie!"
,"18":"Je dirai tes louanges à la grande assemblée, je te célébrerai quand tout le peuple est là."
,"19":"Ne permets pas qu'ils se rient de moi, et qu'ils se fassent des clins d'oeil à mon sujet, ces ennemis, ces menteurs qui n'ont pas d'excuses."
,"20":"Car ce n'est pas la paix qu'ils préparent pour les gens paisibles du pays. Ils ont mis au point des discours mensongers"
,"21":"et ils parlent ouvertement contre moi. Ils disent: 'Oui, nous l'avons vu.'"
,"22":"Mais toi, Seigneur, tu as vu, ne te tais pas, ne t'éloigne pas de moi, Seigneur."
,"23":"Eveille-toi et lève-toi, rends ton jugement. Seigneur, mon Dieu, parle à mon procès."
,"24":"Prononce ma sentence, toi qui es juste, Seigneur, qu'ils ne puissent pas rire de moi,"
,"25":"ni penser, ni dire: 'Enfin, nous l'avons eu!'"
,"26":"Que soient confondus, humiliés tous ensemble, ceux qui rient de mes malheurs, qu'ils aillent couverts de honte et de mépris, ceux qui me regardent de haut."
,"27":"Encourage ceux qui défendent mon innocence, qu'ils puissent dire: 'Le Seigneur est grand, lui qui réhabilite son serviteur.'"
,"28":"Alors je pourrai dire et redire ta justice, tout le jour je te célébrerai."
}`)
	CurrentBook.AddChapter(36, `{
"1":"Au maître de chant. De David, serviteur de Yahvé."
,"2":"Le méchant, dans son coeur, n'entend que la voix du péché. La crainte de Dieu n'est pas présente à ses yeux."
,"3":"Il se voit d'un trop bon oeil pour découvrir son mal,"
,"4":"pour taire ses paroles méchantes et mensongères; il ne pense même plus à faire le bien."
,"5":"Jusque sur son lit il médite l'injustice. Il s'obstine sur un chemin qui n'est pas le bon, il ne condamne pas le mal."
,"6":"Seigneur, ta grâce est à la hauteur des cieux, ta vérité s'élève jusqu'aux nuées."
,"7":"Ta justice est l'égale des montagnes altières, et tes jugements comme le grand abîme; hommes ou bêtes, tu es le sauveur de tous."
,"8":"O Dieu, que ta grâce est précieuse, les fils d'Adam s'abritent à l'ombre de tes ailes."
,"9":"Ils se rassasient de l'opulence de ta maison, et tu leur donnes à boire au torrent de tes délices."
,"10":"En toi se trouve la source de vie, et c'est par ta lumière que nous voyons la lumière."
,"11":"Donne encore ta grâce à ceux qui te connaissent et ta justice aux hommes au coeur droit."
,"12":"Ne permets pas que l'orgueilleux me piétine ou que la main du méchant me chasse."
,"13":"Mais non, voilà ces malfaisants à terre, les voilà renversés sans pouvoir se relever."
}`)
	CurrentBook.AddChapter(37, `{
"1":"De David. Ne va pas t'échauffer quand tu penses aux méchants, n'envie pas ceux qui font le mal."
,"2":"Comme l'herbe ils seront vite passés, comme la verdure des champs si tôt flétrie."
,"3":"Confie-toi dans le Seigneur et fais le bien, demeure au pays et trouves-y ta subsistance."
,"4":"Si tu mets ta joie dans le Seigneur, lui comblera les désirs de ton coeur."
,"5":"Confie au Seigneur tes entreprises, compte sur lui: il va les mener à bien."
,"6":"Il rendra tes mérites aussi clairs que le jour, tes droits s'imposeront comme un soleil de midi."
,"7":"Tais-toi devant le Seigneur et attends-le. Ne t'échauffe pas pour celui qui réussit"
,"14":"c et qui marche sur le pauvre, le petit."
,"8":"Laisse-là ta colère, cesse de t'indigner, ne t'échauffe pas, cela ne fait que du mal."
,"9":"Sache que les méchants seront écartés, la terre sera pour ceux qui espèrent en le Seigneur."
,"10":"Attends un moment, vois: le méchant n'est plus là; tu demandes où il est, il a disparu."
,"11":"Les humbles posséderont la terre et jouiront d'une paix sans menaces."
,"12":"Le méchant cherche du mal au juste et grince des dents contre lui."
,"13":"Mais le Seigneur s'en amuse car il voit venir son jour."
,"14":"Les méchants déjà ont tiré l'épée, tendu leur arc pour massacrer les gens honnêtes,"
,"15":"mais l'épée entre en leur propre coeur, l'arc se brise."
,"16":"Les méchants ont beaucoup de tout, mais le peu qu'a le juste est meilleur."
,"17":"Car aux méchants on brisera les bras, mais le Seigneur soutient les justes."
,"18":"Le Seigneur veille sur les jours des parfaits, leur héritage est à eux pour toujours."
,"19":"Ils ne seront pas déçus au temps du malheur, ils auront à manger quand viendra la famine."
,"20":"Mais les méchants périssent, les ennemis du Seigneur,"
,"25":"c comme la parure des prés, ils passent et s'en vont en fumée."
,"21":"Le méchant emprunte, il ne rend pas; le juste a pitié et il donne."
,"22":"Ceux que Dieu bénit posséderont la terre, ceux qu'il maudit seront éliminés."
,"23":"C'est le Seigneur qui maintient l'homme debout; il l'affermit quand il prend plaisir à sa conduite."
,"24":"Si l'homme chute, il ne roule pas à terre, car le Seigneur le tenait par la main."
,"25":"J'ai été jeune, j'ai eu le temps de vieillir, mais je n'ai pas vu le juste abandonné, ni ses rejetons mendier leur pain."
,"26":"Tout le jour il a compassion et il prête, et ses enfants ont une réussite exemplaire."
,"27":"Détourne-toi du mal et fais le bien, ta maison sera stable pour toujours."
,"28":"Car le Seigneur aime la justice, il n'abandonne pas ses fidèles. Mais la perte des mauvais est définitive, la race des méchants est extirpée. "
,"29":"Les justes posséderont la terre, ils l'habiteront pour toujours."
,"30":"La bouche du juste redit les mots de la sagesse, il parle pour dire ce qui est juste."
,"31":"Si la loi de Dieu est dans son coeur, ses pas ne vacilleront pas."
,"32":"Le mauvais observe tout du juste, car il voudrait le perdre."
,"33":"Mais le Seigneur ne le livrera pas, on peut le juger, il ne sera pas condamné."
,"34":"Espère dans le Seigneur et reste sur sa voie,"
,"40":"b il te délivrera des méchants"
,"34":"b et t'élèvera jusqu'à posséder la terre. Le mauvais sera éliminé, tu le verras."
,"35":"J'ai vu le méchant devenu un tyran, il se dressait comme le cèdre du Liban."
,"36":"Puis je suis repassé, il n'était déjà plus; je l'ai cherché, je n'ai pu le trouver."
,"37":"Vois ceux qui sont parfaits, regarde l'homme droit: ceux qui aiment la paix laissent une descendance,"
,"38":"mais les pécheurs seront supprimés tous ensemble et la descendance des méchants sera exterminée."
,"39":"Le salut des justes leur vient du Seigneur, il est leur refuge au temps du malheur."
,"40":"Le Seigneur les aide, il les délivre de l'oppresseur et les sauve, car ils ont espéré en lui."
}`)
	CurrentBook.AddChapter(38, `{
"1":"Psaume de David. Pour faire mémoire."
,"2":"Seigneur, ne me punis pas avec emportement, ne me reprends pas si tu es en colère."
,"3":"Car tes flèches m'ont atteint, tu as fait peser ta main sur moi."
,"4":"Ta colère n'a rien laissé d'intact en ma chair, rien n'est sain dans mes os: c'est le prix de ma faute."
,"5":"Je suis enterré dans mes dettes, elles sont un fardeau trop pesant pour moi."
,"6":"Mes plaies sont purulentes et sentent mauvais, c'est le prix de ma folie."
,"7":"Je marche courbé, tout plié, tout le jour je vais et viens l'air sombre."
,"8":"J'ai les reins congestionnés, en feu, et plus rien n'est intact en mon corps."
,"9":"Je suis paralysé, tout courbaturé, je crie, car au fond de moi c'est un rugissement."
,"10":"Seigneur, tout mon désir est à nu devant toi, mes plaintes ne te sont pas cachées."
,"11":"Mon coeur a des arrêts, mes forces m'abandonnent, même la lumière de mes yeux me fait défaut."
,"12":"Mes plaies tiennent à distance amis et compagnons, mes familiers se gardent d'approcher."
,"13":"Ceux qui désirent ma mort font déjà des projets, jusque dans leurs paroles ils cherchent mon malheur, tout le jour ils arrangent leurs mensonges."
,"14":"Mais moi je fais le sourd, je n'entends pas, je joue au muet et n'ouvre pas la bouche."
,"15":"Je fais celui qui n'entend pas et qui n'a rien à répondre."
,"16":"Car c'est en toi que j'espère, Seigneur, réponds-moi, mon Dieu!"
,"17":"Car j'ai dit: 'Il ne faut pas qu'ils se réjouissent ou qu'ils gagnent sur moi quand je lâche pied.'"
,"18":"Me voilà au bord de la chute et mon tourment ne me quitte pas."
,"19":"Je dois confesser ma faute, mon péché me tient inquiet."
,"20":"Mes ennemis sont puissants et beaucoup me détestent sans raison,"
,"21":"ils me rendent le mal pour le bienfait, me persécutent parce que je veux le bien."
,"22":"Ne m'abandonne pas, Seigneur, pourquoi rester si loin de moi, mon Dieu?"
,"23":"Hâte-toi de venir à mon aide, Seigneur, mon sauveur."
}`)
	CurrentBook.AddChapter(39, `{
"1":"Au maître de chant. A Idithun. Psaume de David."
,"2":"J'avais dit: 'Je tiendrai bien ma route, je ne pécherai pas en paroles. Je mettrai un boeuf sur ma langue, tant que j'aurai sous les yeux le méchant.'"
,"3":"Je m'enfermais dans le silence, je me taisais, mais son bonheur me rendait fou."
,"4":"Mon coeur bouillait en moi, le scandale entretenait le feu, il a fallu que je parle:"
,"5":"'Fais-moi savoir, Seigneur, ce que sera ma fin et quelle sera la mesure de mes jours, que je sache combien je suis fragile.'"
,"6":"Tu m'as donné mes jours à la petite mesure, à ton échelle ma durée n'est rien: en vérité, les humains ne pèsent guère."
,"7":"L'homme fait son chemin, tout comme une ombre; il se démène, mais il n'est qu'un souffle; il accumule, mais il ne sait qui aura le tout."
,"8":"Alors, que puis-je attendre, Seigneur? Je mettrai en toi mon espérance."
,"9":"Délivre-moi de toutes mes fautes, ne me fais pas honte devant les incroyants."
,"10":"Je vais me taire, je n'ouvre plus la bouche, puisque c'est toi qui agis."
,"11":"Détourne de moi tes coups, ta main m'a frappé jusqu'à m'achever."
,"12":"Car tu corriges l'homme en punissant la faute, tu ronges, comme la teigne, tout ce qui lui était cher. C'est vrai, l'homme n'est qu'un souffle."
,"13":"Seigneur, écoute ma prière, prête l'oreille à mon cri, ne reste pas sourd à mes pleurs. Je ne suis qu'un hôte sur tes terres, rien qu'un passant, comme ont été mes pères."
,"14":"Ne me regarde plus ainsi, que je respire, avant que je parte et ne sois plus rien."
}`)
	CurrentBook.AddChapter(40, `{
"1":"Au maître de chant. Psaume de David."
,"2":"Je comptais vraiment sur le Seigneur, il s'est penché vers moi, il a entendu mon cri."
,"3":"Il m'a fait remonter du trou fatal, de la boue du bourbier. Il m'a remis les pieds sur le roc, il a affermi mes pas."
,"4":"C'est pourquoi j'ai à la bouche un chant nouveau, une louange pour notre Dieu. Le peuple le saura; ils craindront le Seigneur, ils auront confiance en lui."
,"5":"Heureux l'homme qui a choisi le Seigneur et met en lui son espérance au lieu d'aller vers les rebelles, avec ceux qui choisissent le mensonge."
,"6":"Seigneur, mon Dieu, combien de merveilles as-tu faites, que de projets en notre faveur! Qui pourrait t'être comparé?,Je voudrais les redire, les détailler, ils sont trop nombreux pour que je les compte."
,"7":"Tu n'aimais pas vraiment l'offrande, les sacrifices: tu me l'as fait comprendre; holocaustes et victimes pour le péché, tu ne les as pas demandés."
,"8":"Alors j'ai dit: 'Me voici, le rouleau du livre a parlé de moi.'"
,"9":"O Dieu, tout mon plaisir est de faire ton vouloir, ta loi est au plus profond de mon être."
,"10":"J'ai annoncé ta justice dans la grande assemblée, je ne suis pas resté bouche fermée, tu le sais bien, Seigneur."
,"11":"Tes décrets ne sont pas restés enclos en mon coeur, j'ai dit ta fidélité, ton oeuvre de salut. Je n'ai pas laissé dans l'ombre ta grâce, ni ta vérité, durant la grande assemblée."
,"12":"Toi, Seigneur, ne te ferme pas, aie pitié de moi, que ta grâce et ta vérité me gardent toujours."
,"13":"Car des maux sans nombre m'ont assailli, mes fautes retombent sur moi et me bouchent la vue; car il y en a plus que de cheveux sur ma tête, et je perds courage."
,"14":"Seigneur, daigne me délivrer, Seigneur, hâte-toi de me secourir."
,"15":"Qu'ils soient déçus et humiliés, ceux qui en veulent à ma vie, qu'ils reculent couverts de honte, ceux qui cherchent à me nuire."
,"16":"Qu'ils aillent cacher leur confusion, ceux qui m'accusent et disent: 'Le voilà pris!'"
,"17":"Donne cette joie à ceux qui te cherchent, qu'ils puissent se réjouir en toi. Que ceux qui désirent ton salut puissent redire: 'Le Seigneur est grand.'"
,"18":"Et moi, si humble et malheureux, Seigneur, pense un peu à moi! Tu es mon secours, mon sauveur, ne tarde donc pas, ô mon Dieu!"
}`)
	CurrentBook.AddChapter(41, `{
"1":"Au maître de chant. Psaume de David."
,"2":"Heureux celui qui pense au pauvre et au malheureux, le Seigneur le sauvera au jour du malheur."
,"3":"Il le gardera en vie, heureux sur cette terre: tu ne le donneras pas à ceux qui le haïssent."
,"4":"Le Seigneur l'assistera sur le lit de douleurs: - tu refaisais son lit quand il était malade!"
,"5":"J'ai dit au Seigneur: 'Aie pitié de moi, me voilà malade, j'ai dû pécher contre toi.'"
,"6":"Mes ennemis ont des paroles méchantes: 'Quand donc va-t-il mourir, et qu'on n'en parle plus?'"
,"7":"Celui qui vient me voir dit des paroles en l'air, mais il s'informe pour me nuire, à peine sorti, il se met à parler."
,"8":"Tous ceux qui me détestent se parlent à voix basse, ils interprètent au pire le mal qui m'afflige:"
,"9":"'C'est une sale affaire, cette attaque, il est au lit pour ne pas se relever.'"
,"10":"Même le bon ami en qui j'avais confiance, qui partageait mon pain, se retourne contre moi."
,"11":"Mais toi, Seigneur, aie compassion, remets-moi sur pied,que je puisse leur rendre la pareille."
,"12":"Ce sera pour moi un signe que tu m'aimes,si mon ennemi ne peut triompher."
,"13":"Tu me soutiendras, car je serai sans faute, tu me garderas sous tes yeux pour toujours."
,"14":"Béni soit le Seigneur, le Dieu d'Israël, depuis toujours et pour toujours, Amen! Amen!"
}`)
	CurrentBook.AddChapter(42, `{
"1":"Au maître de chant. Méditation. Des fils de Coré."
,"2":"Comme la biche aspire aux eaux vives, mon âme aspire à toi, mon Dieu."
,"3":"Mon âme a soif de Dieu, du Dieu vivant, quand donc irai-je me présenter devant Dieu?"
,"4":"Les larmes nuit et jour sont mon pain, quand on me dit: 'Où est ton Dieu?'"
,"5":"Aussi je me rappelle, je me mets à rêver, le temps où je passais entouré de notables,jusqu'à la maison de Dieu, alors que résonnaient les louanges,et les cris de joie d'une foule en fête."
,"6":"Mais pourquoi broyer du noir, ô mon âme, pourquoi ces gémissements où tu te replies?,Espère en Dieu: j'irai louer encore,celui qui est mon Dieu, le salut de ma face."
,"7":"Le coeur me manque et je me souviens, en ces terres du Jourdain et de l'Hermon: - où es-tu, toute petite montagne?"
,"8":"L'abîme crie à l'abîme l'écho de tes cataractes, tous tes orages, tes vagues ont passé sur moi."
,"9":"Que le Seigneur, de jour, m'envoie sa grâce,et que son chant m'accompagne de nuit,pour prier mon Dieu vivant."
,"10":"Je veux dire à mon Dieu, mon rocher: 'Pourquoi m'as-tu oublié?',Pourquoi dois-je marcher l'air défait,sous l'oppression de l'ennemi,"
,"11":"et ces moqueries de l'adversaire,qui me tourmentent jusqu'aux os,quand tout le jour ils me disent: 'Où est ton Dieu?'"
,"12":"Mais pourquoi broyer du noir, ô mon âme, pourquoi ces gémissements où tu te replies?,Espère en Dieu, j'irai louer encore,celui qui est mon Dieu, le salut de ma face."
}`)
	CurrentBook.AddChapter(43, `{
"1":"Rends-moi justice, ô Dieu, défends ma cause,face à la nation infidèle. Délivre-moi des gens malhonnêtes et pervers."
,"2":"Si tu es mon Dieu, mon refuge, pourquoi m'as-tu abandonné?,Pourquoi dois-je marcher l'air défait,sous l'oppression de l'ennemi?"
,"3":"Envoie ta lumière et ta vérité, elles me guideront, elles me conduiront,jusqu'à ta montagne sainte et ta demeure."
,"4":"Avec elles j'arriverai à l'autel de Dieu, du Dieu qui est ma joie, et je jouerai; je te louerai sur la harpe, ô Dieu, mon Dieu."
,"5":"Pourquoi broyer du noir, ô mon âme, pourquoi ces gémissements où tu te replies?,Espère en Dieu: j'irai louer encore,celui qui est mon Dieu, le salut de ma face."
}`)
	CurrentBook.AddChapter(44, `{
"1":"Au maître de chant. Des fils de Coré. Méditation."
,"2":"O Dieu, nos oreilles l'ont entendu, nos pères nous l'ont raconté, ce que tu as fait de leur temps, de ta propre main: c'était dans les jours anciens."
,"3":"Pour les installer, tu as déplanté des nations; tu les as mis au large en malmenant des peuples."
,"4":"Ce n'est pas leur épée qui leur donna leur terre, ce n'est pas leur force qui les fit réussir. C'est ta main, c'est ton bras, c'est l'éclat de ta face, parce que tu les aimais."
,"5":"C'est toi, mon roi et mon Dieu, qui décides les victoires de Jacob."
,"6":"Grâce à toi nous enfonçons l'adversaire, grâce à ton Nom nous piétinons celui d'en face."
,"7":"Je ne mettrai pas ma confiance dans mon arc, et ce n'est pas mon épée qui me sauvera."
,"8":"Mais c'est toi qui nous sauves de l'adversaire, c'est toi qui mets l'ennemi en déroute."
,"9":"Nous sommes prêts à te louer tous les jours, nous voulons célébrer à jamais ton Nom."
,"10":"Pourtant tu nous as rejetés, couverts de honte, et tu ne sors plus avec nos armées."
,"11":"Tu nous fais reculer face à l'adversaire et nos ennemis pillent comme ils le veulent."
,"12":"Tu as fait de nous des moutons d'abattoir, et tu nous as dispersés entre les nations."
,"13":"Tu vends ton peuple à prix dérisoire sans rien gagner dans l'opération."
,"14":"Tu nous couvres de honte devant nos voisins, les peuples tout autour en parlent et se moquent."
,"15":"Tu fais de nous la fable des nations, à l'étranger on fait des gestes de mépris."
,"16":"Tous les jours je porte mon humiliation. Je vais le visage couvert de honte"
,"17":"sous les cris d'insulte et les blasphèmes, et j'ai sous les yeux celui qui hait et se venge."
,"18":"Que de coups! et nous ne t'avions pas oublié, ni délaissé ton alliance,"
,"19":"nos coeurs ne s'étaient pas repris, nos pas n'avaient pas dévié de ta route."
,"20":"Mais tu nous as écrasés au désert des serpents, tu as fait tomber sur nous l'obscurité."
,"21":"Si nous avions oublié le nom de notre Dieu et tendu nos mains vers un dieu étranger,"
,"22":"Dieu l'aurait vu, bien sûr, car il connaît les secrets du coeur."
,"23":"Mais c'est pour toi qu'on nous massacre tous les jours et qu'on nous traite comme moutons d'abattoir."
,"24":"Réveille-toi, pourquoi dors-tu, Seigneur? Lève-toi, ne nous rejette pas jusqu'au bout."
,"25":"Pourquoi cacher ta face? Oublies-tu notre misère et l'oppression?"
,"26":"Nous nous traînons dans la poussière, non pas vivants mais rampant sur la terre."
,"27":"Debout, viens nous secourir, fais honneur à ta bonté et libère-nous."
}`)
	CurrentBook.AddChapter(45, `{
"1":"Au maître de chant. Sur l'air 'les lis...'. Des fils de Coré. Méditation. Chant."
,"2":"Tout mon esprit s'affaire pour une noble tâche, je vais dire mes poèmes au roi. Habile écrivain, j'aurai pour plume ma langue."
,"3":"Tu es le plus beau de la race d'Adam, la grâce est répandue sur tes lèvres, Dieu t'a donné la bénédiction à jamais!"
,"4":"Revêts-toi d'honneur et de gloire, qu'ils soient pour toi comme l'épée à ton côté."
,"5":"Bondis, chevauche, pour la cause de la vérité, pour la miséricorde et la justice. L'arme à la main tu fais des prodiges."
,"6":"Tes flèches sont pénétrantes, des peuples tombent sous tes pas, les ennemis du roi perdent coeur."
,"7":"Ton trône, ô Dieu, est ferme pour toujours, ton sceptre royal est un sceptre de droiture."
,"8":"Tu aimes la justice, tu détestes le mal, aussi Dieu, ton Dieu, t'a donné l'onction,et l'huile de la joie plutôt qu'à tes compagnons."
,"9":"La myrrhe, l'aloès et la casse imprègnent tes vêtements, tu t'égayes au son des harpes en tes palais d'ivoire."
,"10":"Des filles de roi sont au nombre de tes aimées, une reine à ta droite est parée d'un or rare."
,"11":"Ecoute, fille, regarde et prête l'oreille: oublie ton peuple et la maison de ton père;"
,"12":"alors le roi sera épris de ta beauté. Sache qu'il est ton Seigneur:"
,"13":"les puissants de Tyr se courberont devant lui. Voici les riches du pays venus te rendre hommage."
,"14":"La fille du roi est conduite à l'intérieur, ses vêtements rehaussés d'or;"
,"15":"en ses broderies, elle est amenée au roi. Des vierges, ses compagnes, la suivent, elles sont introduites auprès de toi."
,"16":"On les amène dans la joie et la fête, elles sont introduites dans le palais du roi."
,"17":"Pour remplacer tes pères tu auras des fils, tu en feras des princes par toute la terre."
,"18":"Je veux que grâce à moi ton nom vive d'âge en âge,et que les peuples te louent à jamais."
}`)
	CurrentBook.AddChapter(46, `{
"1":"Au maître de chant. Des fils de Coré. Sur l'air 'les jeunes filles...'. Cantique."
,"2":"Dieu est pour nous l'espérance, la force, le secours près de nous au moment du péril:"
,"3":"nous n'avons pas de crainte: le monde peut trembler, les montagnes s'enfoncer au coeur des mers."
,"4":"Leurs eaux peuvent mugir et bouillonner, se soulever jusqu'à ébranler les monts. Le Seigneur Sabaot est avec nous, le Dieu de Jacob s'est fait pour nous forteresse."
,"5":"Un fleuve - ses canaux réjouissent la cité -,sanctifie les demeures du Très-Haut."
,"6":"Dieu est au milieu d'elle, elle ne bougera pas, Dieu la secourt à l'approche du matin."
,"7":"Les nations mugissaient, les royaumes s'ébranlaient, il donne de la voix et le monde se défait!"
,"8":"Le Seigneur Sabaot est avec nous, le Dieu de Jacob s'est fait pour nous forteresse."
,"9":"Allez voir les oeuvres du Seigneur, voyez les ravages qu'il a faits sur cette terre."
,"10":"Il a fait taire les armes jusqu'au bout du monde, il a brisé l'arc et cassé la lance, il a mis le feu aux chars."
,"11":"'C'est assez, sachez que je suis Dieu,bien au-dessus des nations, au-dessus de la terre.'"
,"12":"Le Seigneur Sabaot est avec nous, le Dieu de Jacob s'est fait pour nous forteresse."
}`)
	CurrentBook.AddChapter(47, `{
"1":"Au maître de chant. Des fils de Coré. Psaume."
,"2":"Tous les peuples, battez des mains, acclamez Dieu avec des cris de joie!"
,"3":"Car le Seigneur, le Très-Haut, est redoutable, il est Grand Roi sur toute la terre."
,"4":"A son ordre les peuples nous sont soumis, les nations sont sous nos pieds."
,"5":"C'est lui qui nous a choisi notre lot, c'est notre gloire, il aime le peuple de Jacob."
,"6":"Voici que Dieu monte en fanfare, le Seigneur s'élève au son du cor."
,"7":"Chantez pour Dieu, chantez, chantez pour notre Dieu, chantez!"
,"8":"Car Dieu est roi sur toute la terre, chantez pour lui de votre mieux."
,"9":"Dieu va régner sur les nations, depuis son trône, siège de la sainteté."
,"10":"Voici venir les princes des peuples, ils s'unissent au peuple du Dieu d'Abraham; oui, Dieu est le maître des grands de la terre, bien haut, dans les hauteurs!"
}`)
	CurrentBook.AddChapter(48, `{
"1":"Cantique. Psaume des fils de Coré."
,"2":"Le Seigneur est grand, à lui grande louange en la ville de notre Dieu, sur sa montagne sainte,"
,"3":"si fière, si belle, la joie de notre terre!,Mont Sion, montagne sacrée, cité du Grand Roi:"
,"4":"Dieu s'est fait citadelle au coeur de ses remparts."
,"5":"Les rois s'étaient unis, ils avançaient comme un seul homme."
,"6":"A peine l'ont-ils vue qu'ils restent stupéfaits, ils sont pris de panique et s'enfuient."
,"7":"Un tremblement les a saisis, un spasme, comme d'une femme qui met au monde,"
,"8":"une bourrasque du vent d'est,qui brise les navires de Tarsis."
,"9":"On nous l'avait dit, nous l'avons vu, dans la ville du Seigneur Sabaot, dans la ville de notre Dieu. Dieu l'a mise en place pour toujours."
,"10":"Nous venons rappeler tes grâces, Seigneur, dans l'enceinte de ton Temple."
,"11":"Que ta louange, Seigneur, égale ton Nom,et s'étende aux confins du monde: ta main puissante apporte la justice."
,"12":"La joie éclate sur le mont Sion: enfin tes jugements! les cités de Juda sont en fête."
,"13":"Visitez Sion, faites-en le tour, observez son enceinte, "
,"14":"regardez les murs, voyez en détail ses châteaux,pour en instruire la jeune génération:"
,"15":"oui, c'est notre Dieu qui est Dieu, et il l'est pour toujours, lui qui nous mène."
}`)
	CurrentBook.AddChapter(49, `{
"1":"Au maître de chant. Des fils de Coré."
,"2":"Ecoutez ceci, tous les peuples, tous, prêtez l'oreille, habitants du monde,"
,"3":"enfants du peuple ou fils à papa, le riche aussi bien que le pauvre."
,"4":"Je veux dire des paroles de sagesse, ce qu'en mon coeur je médite donne à réfléchir."
,"5":"Je cherche à bien entendre une maxime, puis j'explique mon énigme au son de la cithare."
,"6":"Pourquoi craindrais-je dans les jours mauvais, quand je vois tout autour les traîtres et leurs méfaits."
,"7":"Leur assurance vient de leur fortune, eux qui se font gloire de leur grande richesse."
,"8":"Mais qui rachètera son frère,et donnera à Dieu la rançon?"
,"9":"Racheter la vie? C'est bien trop cher, et voilà tout fini à jamais."
,"10":"Pourraient-ils vivre toujours,et ne jamais passer par la tombe?"
,"11":"On voit que le sage meurt, tout comme le fou et l'imbécile. Ils périront, laissant à d'autres leur fortune."
,"12":"Leur tombe est leur maison définitive, d'âge en âge ils y seront à demeure: leur nom seulement restera sur leurs terres."
,"13":"L'homme arrivé ne pense plus à rien, comme le bétail, il va à l'abattoir."
,"14":"Voilà où courent ceux qui comptent sur eux-mêmes, c'est là qu'aboutiront ceux qui s'écoutent parler."
,"15":"Comme des moutons ils sont parqués au séjour d'en-bas, la mort les mène paître et leur impose sa loi. Ils sont le fantasme dissipé au matin, qui rentre chez lui au séjour d'en-bas."
,"16":"Moi, par contre, Dieu me rachètera, il me réclamera au séjour d'en-bas."
,"17":"Ne crains donc pas si tu vois l'homme s'enrichir, et sa maison puissante:"
,"18":"il n'emportera rien de cela à sa mort, sa richesse ne le suivra pas."
,"19":"Il se félicitait quand il vivait: 'On pourra dire que tu t'es fait la vie belle';"
,"20":"mais il lui faut aller rejoindre ses pères,et jamais il ne reverra la lumière."
,"21":"L'homme arrivé ne pense plus à rien, comme le bétail, il va à l'abattoir."
}`)
	CurrentBook.AddChapter(50, `{
"1":"Psaume d'Asaph. Le Dieu des dieux, Yahvé, a parlé: du lever du soleil jusqu'à son couchant,il a convoqué toute la terre."
,"2":"De Sion, la toute belle, Dieu resplendit,"
,"3":"voici venir notre Dieu, il sort de son silence!,Devant lui passe un feu dévorant, autour de lui c'est la tempête."
,"4":"Il s'adresse aux cieux là-haut, puis à la terre, il les convoque au jugement de son peuple."
,"5":"'Rassemblez devant moi mes fidèles, ceux qui sacrifient, qui ont juré mon alliance.'"
,"6":"Ce sont les cieux qui proclameront la sentence, car le juge, c'est Dieu."
,"7":"'Ecoute, mon peuple, c'est moi qui parle, Israël, je vais témoigner contre toi, moi, Dieu, ton Dieu."
,"8":"Je n'ai rien à redire pour tes sacrifices, tes holocaustes qui toujours fument devant moi."
,"9":"Comment irais-je prendre un taureau dans ta maison,ou des boucs à ta bergerie?"
,"10":"J'ai pour moi tous les animaux de la forêt, les bêtes des montagnes - et ce sont des milliers!"
,"11":"Je connais tous les oiseaux des cieux, tout le bétail des champs m'appartient."
,"12":"Si j'avais faim, je ne te le dirais pas, car le monde est à moi et tout ce qui s'y trouve."
,"13":"Est-ce que je mange la viande des taureaux?,est-ce que je bois du sang de boucs?"
,"14":"Offre à Dieu pourtant le sacrifice d'action de grâce,et donne au Très-Haut ce que tu as promis."
,"15":"Appelle-moi au temps du malheur,pour que je te délivre et que tu rendes grâce.'"
,"16":"Mais alors Dieu dit au méchant: 'Pourquoi viens-tu réciter mes commandements?,Tu n'as que mon alliance à la bouche, "
,"17":"mais tu détestes la morale,et tu jettes mes paroles derrière toi."
,"18":"Si tu trouves un voleur, tu cours avec lui, tu n'es qu'un de plus parmi les adultères;"
,"19":"tu ne te gênes pas pour dire du mal,et tu te sers de ta langue pour tromper."
,"20":"Tu vas t'asseoir, c'est pour parler contre ton frère, et tu salis le fils de ta propre mère."
,"21":"Si tu le fais, dois-je me taire?,Ou bien voudrais-tu que je sois comme toi?,Je veux te corriger et te dire tout en face."
,"22":"Tâchez de comprendre, vous qui oubliez Dieu, sinon, gare à ma griffe! nul ne vous délivrera."
,"23":"Celui qui offre l'action de grâce m'honore, mais celui qui marche droit, c'est à lui que je ferai voir le salut de Dieu.'"
}`)
	CurrentBook.AddChapter(51, `{
"1":"Au maître de chant. Psaume de David."
,"2":"Quand le prophète Nathan est venu le trouver après qu'il fut allé vers Bethsabée."
,"3":"Aie pitié de moi, ô Dieu, dans ta bonté, dans ta grande tendresse efface mon péché."
,"4":"Lave-moi complètement de ma faute, purifie-moi de mon péché."
,"5":"Car je connais mes actions mauvaises, mon péché est devant moi sans relâche."
,"6":"Contre toi, toi seul, j'ai péché, ce qui est mal à tes yeux je l'ai fait. Ainsi tu es juste dans ta sentence, nul ne peut te critiquer lorsque tu juges."
,"7":"J'étais mauvais déjà à la naissance, quand ma mère m'a conçu le péché était là."
,"8":"Mais tu veux la vérité au coeur de l'homme,et dans le secret tu m'enseignes la sagesse."
,"9":"Fais sur moi l'aspersion et je serai pur, lave-moi et je serai plus blanc que neige."
,"10":"Fais que j'entende à nouveau la joie et la fête,et que dansent mes os que tu as brisés."
,"11":"Voile-toi la face devant mes péchés, efface toutes mes fautes."
,"12":"O Dieu, refais-moi un coeur pur,et qu'un esprit sans failles renouvelle mon intérieur."
,"13":"Ne me rejette pas loin de ta face, ne me reprends pas ton esprit saint."
,"14":"Redonne-moi la joie de ton salut, rends-moi ferme par un esprit généreux."
,"15":"J'enseignerai tes voies à ceux qui fautent, et les pécheurs reviendront vers toi."
,"16":"Délivre-moi de la dette du sang, ô Dieu, Dieu de mon salut, et ma bouche célébrera ta justice."
,"17":"Ouvre mes lèvres, Seigneur, que ma bouche dise tes louanges."
,"18":"Ce n'est pas le sacrifice que tu aimes, je pourrais offrir des victimes, tu ne t'y plais pas."
,"19":"Un esprit brisé, voilà mon sacrifice à Dieu, tu ne regardes pas de haut le coeur brisé et humilié."
,"20":"Par bonté, Seigneur, fais du bien à Sion, tu dois rebâtir les murailles de Jérusalem."
,"21":"Alors tu prendras goût aux offrandes qui sont dues, aux sacrifices et holocaustes, aux jeunes bêtes offertes sur ton autel."
}`)
	CurrentBook.AddChapter(52, `{
"1":"Au maître de chant. Méditation. De David."
,"2":"Lorsque Doëg, l'Edomite, était venu dire à Saül: David est entré chez Ahimélek."
,"3":"Pourquoi es-tu si fier de tes méfaits, toi qui te sens fort de ton injustice et tout le jour"
,"4":"t'occupes à des crimes? Tu ne fais que tromper, ta langue est un rasoir tranchant."
,"5":"Tu aimes le mal plus que le bien et tu mens, tu ne dis pas la vérité."
,"6":"Tu aimes lancer tout ce qui fera mal, langue trompeuse."
,"7":"Mais Dieu veut en finir avec toi, il va te saisir, t'arracher de ta tente, te déraciner de la terre des vivants."
,"8":"Les justes le verront et ils craindront Dieu. Ils diront en se moquant de lui:"
,"9":"'Voilà bien l'homme! Il n'a pas fait de Dieu son refuge, mais il comptait sur ses richesses et se faisait fort de ses crimes.'"
,"10":"Mais moi je veux être olivier plein de sève dans la maison de Dieu, pour toujours, je mets ma confiance dans la grâce de Dieu."
,"11":"Je te bénirai pour ce que tu as fait, ton Nom sera toujours mon espérance car il est bienfaisant envers tes fidèles."
}`)
	CurrentBook.AddChapter(53, `{
"1":"Au maître de chant. Sur un ton plaintif. Méditation. De David."
,"2":"L'insensé a décidé: 'Il n'y a pas de Dieu.' C'est la corruption, c'est l'immoralité: pas un qui fasse le bien."
,"3":"Dieu se penche du haut des cieux sur cette race d'Adam. Il cherche du regard un homme qui vaille, quelqu'un qui recherche Dieu."
,"4":"Mais tous se sont dévoyés, également pervertis, pas un qui fasse le bien, pas même un seul."
,"5":"Ils ne pensent donc pas, ces gens qui font le mal et qui dévorent mon peuple: c'est là leur pain, ils ne prient jamais Dieu."
,"6":"Mais les voici frappés d'effroi, sans raison, Dieu soudain disperse les os du renégat. Dieu les a rejetés, c'est pourquoi ils restent couverts de honte."
,"7":"Quand donc brillera en Sion le salut d'Israël? Quand Dieu ramènera son peuple, ce sera la joie en Jacob, Israël sera comblé."
}`)
	CurrentBook.AddChapter(54, `{
"1":"Au maître de chant. Avec les instruments à cordes. Méditation. De David."
,"2":"Lorsque les gens de Ziph sont venus dire à Saül: David s'est caché parmi nous."
,"3":"O Dieu, sauve-moi par ton Nom, toi, le Vaillant, fais-moi justice."
,"4":"O Dieu, entends ma prière, prête l'oreille aux paroles de ma bouche."
,"5":"Car des arrogants m'attaquent, des violents en veulent à ma vie. Ils n'ont pas pensé à Dieu, "
,"6":"mais voici qu'il vient à mon secours, il se joint à ceux qui me soutiennent."
,"7":"Que le mal les surprenne quand ils guettent ma chute; toi, Dieu fidèle, détruis-les."
,"8":"Je te ferai des offrandes généreuses et je chanterai ton Nom, Seigneur, car il est bon."
,"9":"Oui, tu me délivreras de toutes mes épreuves et je verrai à terre mes ennemis."
}`)
	CurrentBook.AddChapter(55, `{
"1":"Au maître de chant. Avec les instruments à cordes. Méditation. De David."
,"2":"O Dieu, prête l'oreille à ma prière, ne te dérobe pas à mes supplications."
,"3":"Tu vois: je suis dans tous mes états, écoute-moi, réponds-moi. Je frémis "
,"4":"car j'entends l'ennemi, les menaces des méchants. Ils m'assourdissent de leurs cris, et me persécutent avec rage."
,"5":"Mon coeur se met à battre, une angoisse mortelle m'étreint,"
,"6":"crainte et tremblements s'emparent de moi, la frayeur me paralyse "
,"7":"et je dis: 'Si j'avais seulement l'aile de la colombe, je volerais jusqu'où je puisse me poser."
,"8":"Je m'enfuirais au loin, je passerais la nuit au désert."
,"9":"Je me trouverais en hâte, dans la tempête, un abri contre le vent déchaîné,"
,"10":"quand leur langue, Seigneur, dévore et divise. Je ne vois dans la ville que violence et querelles,"
,"11":"jour et nuit elles en occupent les murailles; au-dedans c'est l'injustice et le crime,"
,"12":"astuce et tromperie sont à demeure sur la place."
,"13":"Si l'offense venait d'un adversaire, je le supporterais, si un ennemi se dressait contre moi, je me cacherais de lui."
,"14":"Mais c'est toi, un homme de ma condition, un compagnon, un familier."
,"15":"Ensemble nous allions à la maison de Dieu, la confidence au coeur."
,"16":"Qu'une mort subite les surprenne, qu'ils descendent pleins de vie au séjour d'en-bas."
,"17":"Pour moi je crie vers Dieu, le Seigneur me sauvera."
,"18":"Le soir, le matin, à midi, je me plains et m'afflige: lui m'entendra."
,"19":"Oui, il m'a retiré de la bataille,et m'a donné la paix: ils étaient nombreux pourtant contre moi."
,"20":"Dieu entendra, lui qui règne depuis toujours, il les rabaissera. Pourraient-ils se convertir?,ils ne craignent pas Dieu."
,"21":"On lève la main contre ses amis, on ne respecte pas ses engagements,"
,"22":"la bouche se fait douce comme une crème, mais le coeur est armé. Les paroles sont douces, pommadées, mais l'épée est au clair."
,"23":"Décharge ton fardeau sur le Seigneur, lui répondra pour toi; il ne laisse pas le juste à terre pour toujours."
,"24":"Tu les jetteras, Seigneur, au puits de la mort: violents ou fourbes, ils n'atteindront pas la moitié de leurs jours!,Mais moi, je me fie en toi."
}`)
	CurrentBook.AddChapter(56, `{
"1":"Au maître de chant. Sur l'air 'la silencieuse colombe des pays lointains...'. De David. Poème. Lorsque les Philistins s'emparèrent de lui à Gat."
,"2":"O Dieu, aie pitié de moi quand on me harcèle! tout le jour l'assaillant me presse,"
,"3":"tout le jour il me harcèle et me regarde me débattre. Qu'ils sont nombreux, mes adversaires!,C'est en toi, Très-Haut, "
,"4":"que je me confie, le jour où je prends peur:"
,"5":"je réveille ma foi aux paroles de Dieu, en Dieu je me confie et je n'ai plus de crainte: que peut me faire un mortel?"
,"6":"Tout le jour j'entends des paroles blessantes, ils ne pensent qu'à me faire du mal."
,"7":"Ils s'ameutent et se cachent, ils relèvent mes traces, ils partent en chasse contre moi."
,"8":"Pas de salut pour eux après tant d'injustices, ô Dieu, fais tomber sur eux la fureur des païens."
,"9":"Tu as fait le compte de mes déboires, recueille mes larmes dans ton fermoir."
,"10":"Mes ennemis reviendront en arrière le jour où je ferai appel, car je sais bien que Dieu est pour moi."
,"11":"Je réveille ma foi aux paroles de Dieu,"
,"12":"en Dieu je me confie et je n'ai plus de crainte: que peut me faire un mortel?"
,"13":"Je n'oublie pas, ô Dieu, mes promesses, je t'offrirai la victime pour l'action de grâce."
,"14":"Car tu as gardé mes pieds d'un faux pas et je marcherai en présence de Dieu dans la lumière des vivants."
}`)
	CurrentBook.AddChapter(57, `{
"1":"Au maître de chant. Sur l'air 'ne détruis pas...'. De David. Poème. Lorsqu'il s'enfuit de devant Saül dans la grotte."
,"2":"Aie pitié de moi, ô Dieu, aie pitié de moi, car en toi s'abrite mon âme; je m'abriterai à l'ombre de tes ailes le temps que passe le fléau."
,"3":"Je crie vers le Très-Haut, vers le Dieu qui est ma providence."
,"4":"Que du ciel il m'envoie le secours et me sauve de mes oppresseurs, que Dieu envoie sa grâce et sa vérité!"
,"5":"Je vis entouré de lions; leur proie, ce sont les fils d'Adam, leurs dents, des lances et des flèches. Ils ont fait de leur langue une épée tranchante."
,"6":"Montre-toi, ô Dieu, au-dessus des cieux, que ta Gloire se lève sur la terre entière."
,"7":"Ils avaient tendu un lacet sous mes pas, ils voulaient y prendre ma vie. Ils avaient creusé devant moi un trou, mais ils sont tombés dedans."
,"8":"Mon coeur est prêt, ô Dieu, mon coeur attend, je veux chanter et jouer pour toi."
,"9":"Que ma flamme s'éveille, éveillez-vous, harpe et cithare, que je fasse, moi, lever l'aurore."
,"10":"Je te louerai, Seigneur, parmi les peuples, je jouerai pour toi dans toutes les provinces,"
,"11":"car ta grâce est à la hauteur des cieux, ta vérité s'élève jusqu'aux nues."
,"12":"O Dieu, montre-toi au-dessus des cieux, que ta Gloire se lève sur la terre entière."
}`)
	CurrentBook.AddChapter(58, `{
"1":"Au maître de chant. Sur l'air 'ne détruis pas...'. De David. Poème."
,"2":"Est-elle bien vraie, messieurs les dieux, votre justice, et jugez-vous selon le droit les fils d'Adam?"
,"3":"Mais non, vous faites consciemment des injustices et votre main impose au pays la violence."
,"4":"Ces méchants sont dévoyés dès le sein de leur mère, ces menteurs n'en sont sortis que pour s'égarer."
,"5":"Ils ont du venin, un venin de serpent, ils sont sourds comme l'aspic quand il se bouche l'oreille"
,"6":"et ne veut pas entendre la voix du charmeur qui sait l'art de charmer le serpent."
,"7":"O Dieu, brise-leur les dents dans la bouche, arrache, Seigneur, les crocs des lionceaux."
,"8":"Qu'ils s'écoulent comme l'eau d'un vase qui perd, qu'ils se fanent comme l'herbe piétinée."
,"9":"Qu'ils soient comme la limace qui se fond en marchant, ou comme l'avorton qui ne voit pas le jour,"
,"10":"comme ronces brûlées avant de donner l'épine. Qu'un ouragan les emporte!"
,"11":"Le juste verra la sanction, elle fera sa joie, il lavera ses pieds dans le sang du méchant."
,"12":"Et l'on dira: 'Oui, on gagne à être juste, il y avait bien un Dieu pour juger le monde!'"
}`)
	CurrentBook.AddChapter(59, `{
"1":"Au maître de chant. Sur l'air 'ne détruis pas...'. De David. Poème. Lorsque Saül envoya garder sa maison pour le mettre à mort."
,"2":"Mon Dieu, délivre-moi de mes ennemis, protège-moi contre mes agresseurs."
,"3":"Délivre-moi des hommes malfaisants et sauve-moi des violents."
,"4":"Que de monde à l'affût sur mes pas, combien de puissants ameutés contre moi!,Mais je n'ai, Seigneur, ni faute, ni péché, "
,"5":"je n'y suis pour rien s'ils accourent et se préparent: éveille-toi, viens à moi et regarde."
,"6":"Seigneur, Dieu Sabaot et Dieu d'Israël, réveille-toi, fais rendre compte à ces païens, sois sans pitié pour tous ces renégats."
,"7":"Ils reviennent au soir, ils aboient comme des chiens qui rôdent par la ville."
,"8":"Ils disent des horreurs sans même se cacher, leurs lèvres s'ouvrent, il en sort des épées: 'Qui donc pourrait nous entendre?'"
,"9":"Mais toi, Seigneur, tu t'en amuses, tu te moques de tous ces païens."
,"10":"O toi, ma force, je regarde vers toi, ma forteresse, c'est Dieu."
,"11":"S'il vient à moi dans sa bonté, je verrai la perte de ceux qui m'attendent."
,"12":"O Dieu, ordonne leur massacre, il ne faut pas que ton peuple oublie. Toi, si vaillant, chasse-les et tue."
,"13":"Leurs paroles ont laissé dans leur bouche un péché, ils seront victimes de leur orgueil, des insultes et des mensonges qu'ils ont dits."
,"14":"Ecrase-les dans ta fureur, écrase-les et qu'ils ne soient plus. Alors on saura que Dieu est maître en Jacob et jusqu'au bout du monde."
,"15":"Laissons-les revenir le soir, qu'ils aboient comme des chiens rôdant par la ville."
,"16":"Qu'ils chassent pour manger et qu'ils grognent s'ils ne sont pas repus."
,"17":"Mais moi je chanterai ta force, dès le matin je redirai tes bontés. Car tu t'es fait ma citadelle et mon refuge au jour de l'angoisse."
,"18":"O toi, ma force, je veux te chanter; Dieu, ma citadelle, n'est pour moi que bonté."
}`)
	CurrentBook.AddChapter(60, `{
"1":"Au maître de chant. Sur l'air 'le lis du témoignage...'. Poème de David pour l'enseignement."
,"2":"Lorsque David fit la guerre aux Syriens de Mésopotamie et à ceux de Soba, et que Joab revint de la vallée du Sel, victorieux de 12 000 Edomites."
,"3":"O Dieu, tu nous as rejetés, mis en pièces, tu étais irrité, reviens donc à nous."
,"4":"Tu as ébranlé le pays, il s'est lézardé; répare ses brèches, car il s'écroule."
,"5":"Tu en as fait voir de dures à ton peuple, nous faisant boire un vin qui donne le vertige."
,"6":"Tu portais l'étendard de ceux qui te craignent, mais tu l'as mis derrière: ils ont fui devant l'arc."
,"7":"Délivre maintenant ceux que tu aimes, que ta main nous sauve, aie pitié de nous!"
,"8":"Dieu a parlé dans son sanctuaire: 'Je suis plein d'allant, je vais partager Sichem et lotir la vallée des Tentes."
,"9":"Je prends pour moi Galaad et Manassé, Ephraïm aussi, il sera mon casque, et Juda, mon bâton de commandement."
,"10":"Alors Moab sera ma cuvette, pour m'y laver, je jetterai ma sandale sur Edom, je lancerai le cri de guerre contre les Philistins.'"
,"11":"Qui donc nous mènera à la ville forte, qui nous conduira jusqu'en terre d'Edom?"
,"12":"Qui sinon toi, ô Dieu? Mais tu nous as rejetés, tu ne sors plus avec nos troupes."
,"13":"Aide-nous contre l'oppresseur, car rien n'est décevant comme un secours humain."
,"14":"Avec Dieu nous ferons des merveilles, il écrasera nos adversaires."
}`)
	CurrentBook.AddChapter(61, `{
"1":"Au maître de chant. Avec les instruments à cordes. De David."
,"2":"Entends mon cri, ô mon Dieu, sois attentif à ma prière."
,"3":"Des frontières de notre terre, je crie vers toi, découragé, conduis-moi à la roche trop haute pour moi."
,"4":"Oui, tu es mon refuge, ma tour forte face à l'ennemi."
,"5":"Je veux partager ta tente à jamais, m'abriter au creux de tes ailes."
,"6":"Déjà, tu as exaucé mes voeux, et les désirs de ceux qui craignent ton Nom."
,"7":"Prolonge les jours du roi, multiplie-les, qu'il voie s'écouler des générations!"
,"8":"Qu'il règne et serve Dieu à jamais, donne-lui pour couronne ta grâce, ta fidélité!"
,"9":"Alors sans fin je louerai ton nom, et j'accomplirai jour après jour mes promesses."
}`)
	CurrentBook.AddChapter(62, `{
"1":"Au maître de chant. A Idithun. Psaume de David."
,"2":"En Dieu seul mon âme se repose, c'est de lui que j'attends mon salut."
,"3":"Il est mon rocher, mon sauveur, s'il est ma citadelle je ne broncherai pas."
,"4":"Jusqu'à quand vous lancerez-vous tous contre un, pour le démolir ensemble, comme on renverse un mur, comme on enfonce une clôture?"
,"5":"Tous leurs projets visent à tromper, ils ne font que mentir; des lèvres ils bénissent, mais le coeur voudrait maudire."
,"6":"En Dieu seul, ô mon âme, sera ton repos, car je n'ai d'espoir qu'en lui."
,"7":"Il est mon salut, mon sauveur, s'il est ma citadelle je ne broncherai pas."
,"8":"En Dieu est mon salut, en lui ma gloire, il est la roche qui fait ma force, mon refuge, c'est Dieu."
,"9":"Vous de même, ô mon peuple, espérez en lui toujours, ouvrez-lui votre coeur, Dieu est notre refuge."
,"10":"Les fils d'Adam ne pèsent guère, et les enfants des grands, qui peut compter sur eux?,Faites-les monter sur la balance, tous ensemble feront le poids d'une poussière!"
,"11":"Ne misez pas sur la violence, n'espérez rien de l'injustice, si vos richesses augmentent, n'y mettez pas le coeur."
,"12":"Car Dieu n'a dit qu'une parole, mais j'ai entendu ces deux choses: la puissance n'appartient qu'à Dieu,"
,"13":"et la bonté, Seigneur, est encore à toi. Tu sais rendre à chacun selon ses oeuvres."
}`)
	CurrentBook.AddChapter(63, `{
"1":"Psaume de David. Lorsqu'il était dans le désert de Juda."
,"2":"O Dieu, tu es mon Dieu et je te cherche. Mon âme a soif de toi,et pour toi ma chair même se dessèche,comme une terre brûlée, épuisée, sans eau."
,"3":"C'est pourquoi j'allais te voir à ton sanctuaire,pour contempler ta puissance et ta gloire."
,"4":"Ta grâce est meilleure que la vie, mes lèvres chanteront ta gloire."
,"5":"Je veux te bénir tout au long de ma vie, et les mains levées, invoquer ton Nom."
,"6":"Mon âme s'en trouve rassasiée, grasse et moelleuse, et mes lèvres joyeuses disent tes louanges."
,"7":"Je pense à toi sur ma couche, je médite sur toi tout au long des veilles."
,"8":"Oui, tu es venu à mon aide, et je crie ma joie à l'ombre de tes ailes."
,"9":"Je te suis, je me serre contre toi, et tu me prends de ta main."
,"10":"C'est en vain qu'on en veut à ma vie, tous ces gens s'en iront quelque part sous la terre,"
,"11":"ils seront livrés à l'épée, leurs cadavres seront la part du chacal."
,"12":"Le roi se réjouira en Dieu, et les fidèles de Dieu diront avec fierté: 'Enfin, on a fermé la bouche aux menteurs!'"
}`)
	CurrentBook.AddChapter(64, `{
"1":"Au maître de chant. Psaume de David."
,"2":"Entends ma voix, mon Dieu, tu vois que je me plains, protège ma vie des menaces de l'ennemi."
,"3":"Fais que j'échappe au parti des méchants, aux manoeuvres des malfaisants."
,"4":"Ils ont fait de leur langue une épée aiguisée, ils ont leurs flèches: des paroles menaçantes"
,"5":"qu'ils décochent soudain sur les gens honnêtes. Ils tirent à l'improviste, sans prendre de risques."
,"6":"Ils s'encouragent à faire le mal, ils voient la manière de dissimuler le piège, et ils disent: 'Qui verra,"
,"7":"qui percera nos secrets?',Celui qui scrute le fond de l'homme les mettra à jour."
,"8":"Voici que Dieu leur décoche sa flèche et d'un coup on les voit blessés."
,"9":"Leurs propres paroles les ont fait tomber, et ceux qui les voient n'en ont pas pitié."
,"10":"Alors chacun découvre la crainte et dit hautement que c'est l'oeuvre de Dieu: on comprend son action."
,"11":"Le juste se réjouira dans le Seigneur et se confiera en lui; ceux qui ont le coeur droit en tireront fierté."
}`)
	CurrentBook.AddChapter(65, `{
"1":"Au maître de chant. Psaume de David. Cantique."
,"2":"Il est bon de te louer, ô Dieu, en Sion, et d'acquitter à Jérusalem nos promesses,"
,"3":"car toi, tu as entendu la prière. Tout mortel traîne jusqu'à toi "
,"4":"ses actions coupables, le mal est plus fort que nous, mais toi tu pardonnes."
,"5":"Heureux celui que tu choisis pour qu'il t'approche,et qu'il demeure en tes parvis!,Donne-nous tout notre saoul des biens de ta maison, des choses saintes de ton Temple."
,"6":"Réponds-nous comme il convient, fais des prodiges, ô Dieu, notre salut, espoir des terres les plus lointaines,et des îles du grand large."
,"7":"Dieu fort, tu as planté les montagnes; Dieu vêtu de puissance,"
,"8":"tu domptes le tumulte des mers, le tumulte de leurs flots. Tu domptes le grondement des peuples,"
,"9":"et tes signes glacent d'effroi les peuples lointains. Mais quelle joie aux portes du soleil levant, et sur les lieux là-bas où il se couche!"
,"10":"Tu visites la terre pour lui donner son eau, tu lui fais donner ses richesses. Le ruisseau céleste regorge d'eau,pour préparer la terre et le blé des hommes."
,"11":"Tu la prépares, arrosant les sillons, aplanissant les mottes. Les averses la détrempent et tu bénis ses germes."
,"12":"Les biens que tu donnes sont à l'année sa couronne, sur tes sentiers la graisse ruisselle."
,"13":"Les prairies du désert en deviennent moelleuses. les collines ont pris leur habit de fête,"
,"14":"les prés se couvrent de bétail,les vallées revêtent leur manteau de blé. Enfin leurs cris de joie, écoutez leur chant!"
}`)
	CurrentBook.AddChapter(66, `{
"1":"Au maître de chant. Cantique. De David. Acclamez Dieu, toute la terre,"
,"2":"que vos chants rendent gloire à son nom,et que sa louange soit votre gloire."
,"3":"Dites à Dieu: Tes oeuvres sont terribles, ta force est telle que l'ennemi se fait flatteur."
,"4":"Toute la terre se prosterne devant toi, elle te chante et célèbre ton Nom."
,"5":"Venez et voyez les oeuvres de Dieu: elles ont de quoi faire trembler les humains!"
,"6":"Il a changé la mer en terre ferme, on a passé le fleuve à pied sec; faisons-lui donc fête."
,"7":"Il et fort et domine pour toujours, il tient à l'oeil les nations et il veille: il ne faudrait pas qu'un rebelle se dresse."
,"8":"Peuples, bénissez notre Dieu, faites entendre sa louange,"
,"9":"car il nous a rendus à la vie, il n'a pas permis que nos pieds chancellent."
,"10":"Mais pourquoi, ô Dieu, nous as-tu éprouvés,et passés par le feu, comme l'argent?"
,"11":"Tu nous as fait tomber dans le piège, et nous avons connu l'angoisse."
,"12":"Des hommes de rien cavalcadaient sur nos têtes,et nous sommes passés par le feu et par l'eau. Mais enfin tu nous as fait respirer."
,"13":"J'irai à ta maison pour des sacrifices, pour m'acquitter de mes promesses,"
,"14":"pour les voeux que je t'ai faits dans ma détresse."
,"15":"Je ferai monter vers toi la fumée des victimes, mes animaux gras et mes béliers, les boeufs et les boucs de mes holocaustes."
,"16":"Venez, vous tous qui craignez Dieu, écoutez, que je vous raconte, bien en détail, ce qu'il a fait pour mon âme."
,"17":"Ma bouche lui a crié des louanges,car elles étaient déjà sur ma langue."
,"18":"Si j'avais vu du mal dans mon coeur, le Seigneur ne m'aurait pas entendu."
,"19":"Mais Dieu m'a entendu, il a écouté ma prière."
,"20":"Béni soit-il! Il n'a pas écarté ma prière,et ne m'a pas refusé sa grâce."
}`)
	CurrentBook.AddChapter(67, `{
"1":"Au maître de chant. Avec les intruments à cordes. Psaume. Cantique."
,"2":"Que Dieu nous prenne en grâce et nous bénisse, et qu'il tourne vers nous la lumière de sa face!"
,"3":"Alors la terre connaîtra ton chemin,et toutes les nations ton salut."
,"4":"O Dieu, que les peuples te célèbrent!,Que tous ensemble te célèbrent."
,"5":"avec leur joie, leur fête, en toutes leurs provinces, car tu gouvernes les nations avec droiture, et tu conduis les peuples de la terre."
,"6":"O Dieu, que les peuples te célèbrent, que tous ensemble te célèbrent!"
,"7":"La terre a donné son fruit, le Seigneur nous a bénis. Que Dieu nous bénisse et qu'on le craigne,jusqu'aux extrémités du monde."
}`)
	CurrentBook.AddChapter(68, `{
"1":"Au maître de chant. De David. Psaume. Cantique."
,"2":"Que Dieu se lève et ses ennemis se dispersent, que devant lui s'enfuient ceux qui le haïssent!"
,"3":"Tu n'en laisses que fumée qui se dissipe, ils se défont comme la cire sur le feu. Sous la face de Dieu les méchants périssent, "
,"4":"les justes au contraire se réjouissent, ils sautent et crient de joie devant Dieu."
,"5":"Chantez à Dieu, jouez et célébrez son nom, frayez la route au Chevalier céleste. Réjouissez-vous pour le Seigneur et dansez devant lui."
,"6":"Père de l'orphelin, défenseur de la veuve, il est Dieu dans sa sainte demeure."
,"7":"Il donne à l'isolé la famille et la maison, il renvoie libre celui qu'on avait enchaîné, mais il maintient les rebelles dans leurs geôles."
,"8":"O Dieu, tu es sorti précédant ton peuple sur les chemins du désert."
,"9":"En ce temps la terre trembla, les cieux se défirent, à l'approche du Seigneur, le Dieu d'Israël."
,"10":"Alors tu déversas une pluie de largesses, ô Dieu, pour raffermir ton peuple épuisé."
,"11":"Les tiens trouvèrent une demeure que toi, toujours bon, tu destinais à l'indigent."
,"12":"Puis le Seigneur met en branle les messagères: 'Le Seigneur a dispersé une armée immense!'"
,"13":"Ils fuient! Les rois des armées sont en fuite, et c'est une ménagère qui répartit le butin:"
,"14":"des ailes de colombe revêtues d'argent, avec leurs plumes couleur d'or."
,"15":"Et comme le tout-Puissant mettait les rois en fuite, la neige tombait sur le Mont Sombre."
,"16":"Quelle montagne altière, la montagne de Bashan, quels monts escarpés, les monts de Bashan!"
,"17":"Mais vous voilà jaloux, monts escarpés, jaloux de la montagne où Dieu met sa demeure: sachez que le Seigneur y sera à jamais."
,"18":"Dieu a ses chars, par dizaines de milliers, avec eux il est passé du Sinaï au sanctuaire."
,"19":"Tu es monté sur les hauteurs, tu as capturé des captifs, tu as reçu des hommes en tribut et même les rebelles resteront près de Dieu."
,"20":"Béni soit le Seigneur, jour après jour, ce Dieu qui sauve et qui nous prend en charge!"
,"21":"Ce Dieu s'est fait pour nous Dieu des délivrances, Yahvé, le Seigneur, nous fait échapper à la mort."
,"22":"C'est le Dieu qui fracasse la tête de l'ennemi, le crâne chevelu des habitués du crime."
,"23":"Il a dit: 'Je les rechercherai en Bashan et jusqu'au fond de la mer."
,"24":"Je ferai que ton pied baigne dans le sang, que tes chiens goûtent au sang de l'ennemi.'"
,"25":"O Dieu, on a vu tes processions, les processions de mon Dieu, de mon Roi, au sanctuaire."
,"26":"Les chantres vont devant, les musiciens derrière, les filles au milieu avec leurs tambourins."
,"27":"En choeurs ils bénissent Dieu, ils bénissent le Seigneur aux fêtes d'Israël."
,"28":"Benjamin d'abord, le plus jeune, il ouvre la marche; les princes de Juda en habits brodés, les princes de Zabulon et ceux de Nephtali."
,"29":"O Dieu, parle avec force, avec cette force que tu mis en oeuvre pour nous."
,"30":"De ton Temple, le toit de Jérusalem, où les rois viennent avec leurs présents,"
,"31":"menace la bête des roseaux, avec ses taureaux, tous ces peuples et leurs maîtres qui aiment la guerre. Qu'ils t'offrent repentants, l'or et l'argent."
,"32":"D'Egypte viendront les plus riches, l'Ethiopie élèvera ses mains vers Dieu."
,"33":"Royaumes de la terre, chantez pour Dieu, jouez pour le Seigneur,"
,"34":"le Chevalier des cieux, des cieux du premier jour. Voici qu'il élève la voix, une voix puissante."
,"35":"Reconnaissez à Dieu la puissance; en Israël il est grand, dans les nuées il est puissant."
,"36":"Il est redoutable en son sanctuaire, lui, le Dieu d'Israël; il donne à son peuple force et puissance: Béni soit Dieu!"
}`)
	CurrentBook.AddChapter(69, `{
"1":"Au maître de chant. Sur l'air 'les lis...'. De David."
,"2":"O Dieu, sauve-moi, les eaux m'arrivent jusqu'à la gorge."
,"3":"Je suis pris dans la boue du gouffre et rien pour m'appuyer. J'ai glissé jusqu'aux eaux profondes et le flot me submerge."
,"4":"Je m'épuise à crier, j'en ai la gorge en fièvre. J'ai les yeux fatigués d'attendre mon Dieu."
,"5":"Partout des ennemis à qui je n'ai rien fait, il y en a plus que de cheveux sur ma tête! Ils sont plus forts que moi, ceux qui sans raison me haïssent: comment puis-je rendre ce que je n'ai pas pris?"
,"6":"Mais toi, ô Dieu, tu sais si j'ai fauté, mes erreurs ne te sont pas cachées."
,"7":"Ne déçois pas à mon sujet ceux qui espèrent en toi, Seigneur, Dieu Sabaot; n'humilie pas à cause de moi ceux qui te cherchent, ô Dieu d'Israël."
,"8":"C'est pour toi que j'ai connu les affronts et que la honte me couvre le visage."
,"9":"Je suis devenu un étranger pour mes frères, un inconnu pour les fils de ma mère."
,"10":"Un amour jaloux pour ta Maison me dévore, m'attire les insultes de ceux qui t'insultent."
,"11":"Si je fais pénitence, si je jeûne, cela me vaut des affronts."
,"12":"Si je revêts le sac on s'amuse de moi."
,"13":"Je fais rire les gens qui traînent sur la place, les habitués du vin ont un sujet de chanson."
,"14":"Mais je reste à te prier, mon Dieu, que vienne l'heure de ton bon vouloir. Aie pitié de moi dans ta grande bonté, sauve-moi, toi qui es fidèle."
,"15":"Tire-moi de la boue, que je n'enfonce pas, fais-moi échapper à l'orage comme aux eaux profondes."
,"16":"Que le flot ne vienne à me recouvrir, que le tourbillon ne me submerge, que le puits ne referme pas sur moi sa bouche."
,"17":"Réponds-moi, Seigneur, ta grâce apporte le bienfait, tourne vers moi le visage de ta miséricorde."
,"18":"Ne cache pas ta face à ton serviteur, tu me vois dans l'angoisse, hâte-toi de me répondre."
,"19":"Délivre-moi de tant d'ennemis, viens assez près pour leur reprendre ma vie."
,"20":"Tu connais mes adversaires et tu sais mes humiliations;"
,"21":"tant d'affronts m'ont brisé le coeur, ma honte et ma confusion sont sans remède. J'attendais de la compassion, mais rien; quelqu'un qui me réconforte: personne n'a bougé."
,"22":"Ils ont mis du poison dans mes aliments, et pour ma soif ils m'ont versé du vinaigre."
,"23":"Que leur banquet se termine en trahison, qu'on leur tende le piège au repas du sacrifice."
,"24":"Qu'ils perdent la vue et restent dans le noir, condamne-les à marcher tout courbés."
,"25":"Déverse sur eux ta fureur, que le feu de ta colère les rejoigne."
,"26":"Que leur enclos soit laissé dévasté et leur tente sans habitants."
,"27":"Car ils ont persécuté celui que tu frappais, ils ont rajouté aux douleurs de ta victime."
,"28":"Aussi vas-tu les charger de fautes, ta remise de dettes ne sera pas pour eux."
,"29":"Qu'ils soient effacés du livre de vie, qu'ils ne soient pas inscrits au nombre des justes!"
,"30":"Quant à moi, humilié et brisé, ton salut, mon Dieu, me relèvera."
,"31":"Alors je chanterai le nom de Dieu, je dirai ses grandeurs, je lui rendrai grâce."
,"32":"Cela lui plaira mieux qu'une bête sacrifiée, un taureau, avec ses sabots et ses cornes."
,"33":"Soyez témoins, vous les humbles, et réjouissez-vous, vous qui cherchez Dieu de tout votre coeur!"
,"34":"Voyez que le Seigneur entend ses pauvres, il ne dédaigne pas les siens prisonniers."
,"35":"Que les cieux et la terre l'acclament, les mers et tout ce qui frétille à l'intérieur."
,"36":"Sachez que Dieu sauvera Sion et fera rebâtir les villes de Juda: on y reverra maisons et domaines."
,"37":"Les enfants de ses serviteurs seront les héritiers, ceux qui aiment son Nom y feront leur demeure."
}`)
	CurrentBook.AddChapter(70, `{
"1":"Au maître de chant. De David. Pour faire mémoire."
,"2":"O Dieu, daigne me délivrer, Seigneur, hâte-toi de me secourir."
,"3":"Qu'ils soient déçus et humiliés, ceux qui en veulent à ma vie, qu'ils reculent, couverts de honte, ceux qui cherchent à me nuire!"
,"4":"Qu'ils aillent cacher leur confusion, ceux qui m'accusent et disent: 'Le voilà pris!'"
,"5":"Donne cette joie à ceux qui te cherchent, qu'ils puissent se réjouir en toi. Ceux qui attendent ton salut rediront alors: 'Le Seigneur est grand!'"
,"6":"Je suis si humble et malheureux, Seigneur, pense un peu à moi. Tu es mon secours, mon sauveur, ne tarde pas, ô mon Dieu."
}`)
	CurrentBook.AddChapter(71, `{
"1":"En toi, Seigneur, j'ai mon abri, ne me laisse pas sur une déception."
,"2":"Dans ta justice tu voudras me défendre, tends vers moi ton oreille et sauve-moi."
,"3":"Sois pour moi un roc, un refuge, une cité forte où je me vois sauvé, toi mon refuge et ma roche."
,"4":"O Dieu, libère-moi de la main du méchant, tire-moi des griffes du pervers et du violent."
,"5":"Car tu es mon espérance, Seigneur, depuis ma jeunesse je me confie en toi."
,"6":"Je m'appuyais sur toi pour mes premiers pas, c'est toi qui m'as tiré du sein de ma mère, et c'est toi que je loue en tout temps."
,"7":"Je suis devenu un scandale pour beaucoup, mais tu me restes, toi, mon abri."
,"8":"Je n'ai que tes louanges à la bouche et ta splendeur tout au long du jour."
,"9":"Ne me renvoie pas maintenant que je suis vieux, ne t'éloigne pas quand mes forces m'abandonnent."
,"10":"Mes adversaires parlent à mon sujet, ceux qui espèrent ma mort font leurs plans."
,"11":"Et l'on dit: 'Même Dieu l'a abandonné, allons-y, empoignez-le, nul ne viendra l'aider.'"
,"12":"O Dieu, mon Dieu, ne t'éloigne pas de moi, dépêche-toi de me secourir."
,"13":"Qu'ils soient confondus, couverts de honte, ceux qui me mettent des embûches! Qu'ils soient humiliés, couverts de mépris, ceux qui veulent me nuire!"
,"14":"Alors moi je pourrai compter sur toi, je te louerai comme on n'a jamais fait."
,"15":"Je n'aurai que ta justice à la bouche, tout le jour je conterai les pas de ton salut: ils sont plus nombreux que je ne saurais dire."
,"16":"Je veux creuser les exploits du Seigneur, mettre en valeur cette justice qui n'est qu'à toi."
,"17":"Car tu m'as instruit, ô Dieu, dès le jeune âge, et jusqu'à présent j'ai annoncé tes merveilles."
,"18":"Si je suis maintenant vieux et usé, ne m'abandonne pas, ô mon Dieu, que je puisse dire à la jeune génération je dirai ta force, à tous ceux qui viendront, ta vaillance,"
,"19":"et ta justice si haute, ô Dieu. Car tu as fait de grandes choses: ô Dieu, qui est comme toi?"
,"20":"Mes épreuves ont été nombreuses et dures, mais toujours tu reviens pour me redonner vie. Tu me feras remonter des abîmes de la terre, "
,"21":"tu me remettras sur pied, et de nouveau j'aurai ton réconfort."
,"22":"Alors je prendrai ma harpe pour chanter ta fidélité, ô Dieu. Je te chanterai au son du luth, Saint d'Israël."
,"23":"Mes lèvres t'acclameront, et mon âme que tu as rachetée."
,"24":"Tout le jour ma langue dira: 'Oui, il est juste, ils ont été confondus, humiliés, ceux qui voulaient mon malheur.'"
}`)
	CurrentBook.AddChapter(72, `{
"1":"De Salomon. O Dieu, donne au roi tes jugements, donne à ce fils de roi ta justice,"
,"2":"pour qu'il gouverne ton peuple avec justice, avec les jugements que réclament tes pauvres."
,"3":"Monts et collines, livrez enfin au peuple,le don de la justice et la paix."
,"4":"Il fera justice aux petits du peuple, il sera un sauveur pour les enfants du pauvre, car il saura casser l'oppresseur."
,"5":"Il restera aussi longtemps que le soleil, comme la lune au long des âges."
,"6":"Il sera la rosée qui descend sur le gazon, semblable aux averses qui fécondent le sol."
,"7":"Durant ses jours la justice fleurira, la paix s'établira jusqu'à la fin des lunes."
,"8":"Car voici qu'il domine d'une mer à l'autre mer, depuis le fleuve jusqu'au bout des terres."
,"9":"Son adversaire pliera le genou devant lui, ses ennemis lécheront la poussière."
,"10":"Les princes de Tarsis et les îles lointaines, apportent leurs offrandes; les rois de Shéba, de Séba, paient la redevance;"
,"11":"tous les rois devant lui se prosternent, tous les peuples veulent le servir."
,"12":"Car il délivre celui qui fait appel, le pauvre, le petit, celui qui n'a pas d'appui."
,"13":"Il a compassion du faible et du pauvre, car il veut sauver, lui, la vie des pauvres."
,"14":"Il les sauve de la violence, des abus, leur âme et leur sang ont du prix à ses yeux."
,"15":"Qu'il vive, et qu'on lui donne l'or de Shéba, que nul ne cesse de prier pour lui, que tout le jour on le bénisse!"
,"16":"Alors les blés couvriront la terre, onduleront sur les cimes. Leur prospérité sera celle du Liban, ils se multiplieront comme l'herbe sur la terre."
,"17":"Que son nom demeure à jamais, que toujours son nom perdure sous le soleil!,En lui seront bénies toutes les races de la terre, toutes les nations le diront bienheureux."
,"18":"Béni soit le Seigneur, le Dieu d'Israël, lui qui seul fait des merveilles."
,"19":"Béni soit à jamais son Nom très saint, que sa gloire emplisse la terre entière!"
,"20":"Ici se terminent les prières de David, fils de Jessé."
}`)
	CurrentBook.AddChapter(73, `{
"1":"Psaume d'Asaph. Oui, Dieu est bon pour Israël: je le dis pour ceux qui ont le coeur pur."
,"2":"Pourtant, pour un peu mon pied achoppait, un rien et mes pas glissaient."
,"3":"J'en étais à envier les gens sans foi,car je voyais le bonheur des méchants."
,"4":"Ils ne connaissent pas la souffrance, ils sont bien nourris, leur corps est sain."
,"5":"La peine de l'homme ne les touche pas, ils ne sont pas éprouvés comme les humains."
,"6":"De là leur orgueil: ils le portent en collier; la violence est le vêtement qui les couvre,"
,"7":"leur graisse sue la méchanceté,et leur coeur déborde d'inventions mauvaises."
,"8":"Ils ricanent, ils cherchent comment nuire, ils parlent de très haut, et c'est pour tromper."
,"9":"Ils savent tout du ciel, et la terre pour eux n'a pas de secret."
,"10":"C'est pourquoi mon peuple penche vers eux, car on ne voit chez eux que réussite."
,"11":"Et l'on dit: 'Dieu voit-il?,Le Très-Haut, en a-t-il connaissance?"
,"12":"Ces gens-là sont mauvais,et sans aucun problème ils entassent leurs richesses."
,"13":"Alors, à quoi bon garder, moi, un coeur pur, et conserver les mains nettes,"
,"14":"si tout le jour je reçois des coups,et chaque matin une nouvelle leçon?'"
,"15":"Mais comment dire: 'Je parlerai leur langage'?,Ce serait trahir le parti de tes fils."
,"16":"Je cherchais à y voir clair, et c'était pour moi chose difficile."
,"17":"Mais un jour je suis entré dans les secrets de Dieu, et j'ai compris comment ils terminent."
,"18":"Tu les mets sur un terrain glissant, puis tu les précipites dans l'abîme."
,"19":"Comment, les voilà ruinés?,Comme c'est vite fait!,Ils ne sont plus, tout a fini dans l'épouvante."
,"20":"Comme un songe au réveil, Seigneur; tu t'es réveillé et tu as chassé leur image."
,"21":"Quand j'étais aigri, aiguillonné par mes ressentiments,"
,"22":"c'était de la bêtise, non de la sagesse, je ne te comprenais guère plus que les bêtes."
,"23":"Ne suis-je pas en tout temps avec toi?,Tu m'as saisi de la main droite,"
,"24":"tu me guides selon ton dessein, et ta Gloire derrière elle m'entraîne."
,"25":"Que pourrais-je avoir aux cieux, si ce n'est toi, et à part toi, je ne désire rien sur la terre."
,"26":"Ma chair et mon coeur se consument pour toi, mon Dieu, mon roc, qui es mien à jamais."
,"27":"Nul doute: qui s'éloigne de toi se perd, tu réduis à rien ceux qui te sont infidèles."
,"28":"Pour moi rien de meilleur que d'être près de Dieu; j'ai fait du Seigneur mon refuge,et je redirai tes oeuvres aux portes de Sion."
}`)
	CurrentBook.AddChapter(74, `{
"1":"Méditation d'Asaph. Pourquoi, ô Dieu, ce rejet jusqu'au bout, cette colère contre les brebis de ton bercail?"
,"2":"Souviens-toi de ta communauté, tu l'as acquise aux temps anciens, rachetée, pour qu'elle devienne ta propre tribu, avec le mont Sion où tu demeures."
,"3":"Porte tes pas vers ces ruines sans espoir; l'ennemi a tout saccagé dans le sanctuaire."
,"4":"Ils ont poussé des hurlements dans ta tente, ils ont mis à l'entrée le drapeau étranger."
,"5":"Ils ont tout abattu, tel un bûcheron dans un fourré."
,"6":"Ils ont manié la hache, comme en forêt, abattu les portes, martelé les boiseries,"
,"7":"ils ont mis le feu à ton sanctuaire et profané le lieu où ton Nom demeure."
,"8":"Ils disaient: 'C'est le moment d'en finir avec eux', et par tout le pays ils détruisaient les lieux sacrés."
,"9":"Nous ne voyons plus rien, ni signes, ni prophètes, et personne parmi nous qui sache jusqu'à quand."
,"10":"Jusqu'à quand, ô Dieu, ces païens qui insultent? L'ennemi pourra-t-il sans fin mépriser ton nom?"
,"11":"Pourquoi retiens-tu ta main, l'as-tu prise dans ta ceinture?"
,"12":"N'es-tu pas depuis toujours mon Dieu, mon Roi, toi qui donnes au pays ses délivrances?"
,"13":"Tu avais eu la force pour fendre la mer, et pour briser, sur les flots, les têtes des dragons;"
,"14":"car tu as fracassé les têtes du Monstre, tu l'as donné en pâture aux fossoyeurs des mers."
,"15":"C'est toi qui fis jaillir la source et le torrent, c'est toi qui mis à sec des fleuves intarissables."
,"16":"A toi le jour, à toi la nuit, les lois de la lumière et du soleil."
,"17":"C'est toi qui as fixé à la terre ses limites, et qui lui as donné un été, un hiver."
,"18":"Pense au présent: l'ennemi insulte le Seigneur, un peuple de fous a méprisé ton nom."
,"19":"Ne livre pas à la bête l'âme qui te rend grâce, n'oublie pas, n'efface pas la vie de tes pauvres."
,"20":"Vois comme ils gardent ton alliance dans leurs repaires, dans les lieux de résistance."
,"21":"Que les opprimés ne reviennent pas humiliés, fais que le pauvre et le petit célèbrent ton nom."
,"22":"Lève-toi, ô Dieu, et prends en main ta cause; tout le jour on t'insulte, n'oublie pas ces fous."
,"23":"Entends tes adversaires et n'oublie pas, les cris de ceux qui t'en veulent vont toujours grandissant."
}`)
	CurrentBook.AddChapter(75, `{
"1":"Au maître de chant. Sur l'air 'Ne détruis pas...'. Psaume d'Asaph. Cantique."
,"2":"Nous voulons, ô Dieu, nous voulons te louer, ceux qui vénèrent ton nom rediront tes merveilles."
,"3":"'Laissez-moi fixer la date, et je ferai le juge, je mettrai la justice."
,"4":"Le monde est bouleversé avec ses habitants, à moi de rétablir ses bases!"
,"5":"Je dis aux arrogants: Baissez le ton! Je dis aux mécréants: Vous n'êtes pas les plus forts!'"
,"6":"Cessez de vous imposer par la force, ne parlez plus de Dieu avec orgueil."
,"7":"Car le voici qui vient: pas de l'orient, ni du couchant, ni du désert, ni des montagnes:"
,"8":"mais il est là, Dieu, le juge, pour abaisser les uns, élever les autres."
,"9":"Le Seigneur tient en main la coupe avec son vin drogué, épicé. Il la passe, et les méchants tour à tour la vident, ils en avalent le mélange."
,"10":"J'ai là de quoi me réjouir, je n'en finirai pas; je chanterai le Dieu de Jacob."
,"11":"Aux méchants, il sciera les cornes, et ce sont les justes qui relèveront la tête."
}`)
	CurrentBook.AddChapter(76, `{
"1":"Au maître de chant. Avec les instruments à cordes. Psaume d'Asaph. Cantique."
,"2":"En Juda Dieu s'est fait connaître, son nom est grand en Israël,"
,"3":"lui qui a sa tente à Jérusalem, une demeure au mont Sion."
,"4":"C'est là qu'il a brisé les flèches, le bouclier et l'épée: la guerre!"
,"5":"Te voilà rayonnant de lumière, triomphant sur des montagnes de butin:"
,"6":"on leur a tout pris!,Les vaillants étaient de pierre dans leur sommeil, l'armée entière: leur force s'était éteinte."
,"7":"Tu n'avais dit qu'un mot, Dieu de Jacob, et les chars, les chevaux s'étaient figés."
,"8":"Que tu es redoutable, qui tiendra devant toi au jour de ta colère?"
,"9":"Si dans les cieux tu fais entendre une sentence, la terre s'effraie et reste sans parole."
,"10":"Dieu alors se lève, il fait justice,et sauve tous les humbles de la terre."
,"11":"La fureur des hommes tournera à ta gloire, ceux qui échappent à ta fureur te rendront grâce."
,"12":"Faites des promesses au Seigneur votre Dieu, et de partout venez les accomplir, apportez l'offrande au Dieu Terrible!"
,"13":"Il saura refroidir votre ardeur, mes princes, Il est redoutable aux rois de la terre!"
}`)
	CurrentBook.AddChapter(77, `{
"1":"Au maître de chant. A Idithun. Psaume d'Asaph."
,"2":"J'appelle Dieu à haute voix, à haute voix, pour qu'il m'entende."
,"3":"Je cherche le Seigneur au temps de l'épreuve; de nuit, sans me lasser, je tends la main vers lui et mon âme refuse de se consoler."
,"4":"Je ne me souviens pas de Dieu sans tristesse, je médite et le doute assaille mon esprit."
,"5":"Il m'empêche de fermer l'oeil, je me trouble et les paroles me manquent."
,"6":"C'est que je repense aux jours d'autrefois, il y a très longtemps... Je me souviens,"
,"7":"et toute la nuit mon coeur s'en tourmente; je médite et mon esprit s'interroge."
,"8":"Le Seigneur voudra-t-il se taire pour des siècles et ne pas rouvrir le temps de ses faveurs?"
,"9":"A-t-il mis sous clé, pour toujours, sa grâce, enfermé sa parole pour les temps à venir?"
,"10":"Est-ce que Dieu oublie sa compassion, la colère a-t-elle fermé son coeur?"
,"11":"Et je dis: Voilà ce qui me brise, que le Très-Haut ait changé ses façons d'agir."
,"12":"Je me souviens des exploits du Seigneur, je me rappelle ses miracles d'autrefois."
,"13":"Je reprends une à une tes oeuvres et je médite sur tes exploits."
,"14":"O Dieu, tout est saint dans tes oeuvres, y a-t-il un Dieu grand comme est notre Dieu?"
,"15":"Tu es le Dieu qui fis des merveilles, qui fis connaître aux nations ta force;"
,"16":"tu as racheté ton peuple, les fils de Jacob et de Joseph."
,"17":"Les eaux t'ont vu, ô Dieu, elles t'ont vu, elles se sont effrayées, jusqu'en leurs profondeurs elles se sont émues."
,"18":"Les nuées ont déchargé leurs eaux, les nuages ont donné de la voix, cependant que tes flèches tourbillonnaient!"
,"19":"On entendait le roulement de ton tonnerre et tes éclairs illuminaient le monde, une terre étonnée et tremblante."
,"20":"Ton chemin croisait la mer, tes sentiers couraient sur le fond des eaux, et nul ensuite n'a retrouvé tes traces."
,"21":"Alors tu conduisais ton peuple, ton troupeau, par la main de Moïse, avec Aaron."
}`)
	CurrentBook.AddChapter(78, `{
"1":"Méditation d'Asaph. Ecoute, ô mon peuple, cet enseignement, prends au sérieux ces paroles de ma bouche."
,"2":"Je te parle: c'est un poème, je reprendrai les énigmes du passé."
,"3":"Ce qu'on nous a transmis, et ce que nous savons, ce que nos pères nous ont raconté,"
,"4":"il ne faut pas que nos fils l'ignorent. Nous redirons à la génération qui monte les exploits du Seigneur, sa puissance, les merveilles qu'il a faites."
,"5":"Il enracina en Jacob ses déclarations, à Israël il donna une loi. Puis il ordonna à nos pères de le faire connaître à leurs enfants,"
,"6":"pour que leurs successeurs en aient la connaissance, tous ces fils qui allaient naître. Ils devaient se charger d'en instruire leurs fils "
,"7":"pour que ceux-ci mettent en Dieu leur espoir, qu'ils n'oublient pas les exploits de leur Dieu mais qu'ils observent ses lois;"
,"8":"qu'ils n'aillent pas imiter leurs pères, cette génération rebelle et révoltée, incapable de fixer sa décision, dont l'esprit n'était pas fidèle à Dieu."
,"9":"Voyez Ephraïm et ses tireurs à l'arc: ils ont pris la fuite au jour du combat."
,"10":"C'est qu'ils ne respectaient pas l'alliance de Dieu, ils avaient refusé de suivre sa loi."
,"11":"Ils avaient oublié ses exploits, ses merveilles déjà faites sous leurs yeux."
,"12":"Quelles merveilles ne fit-il pas devant leurs pères, au pays d'Egypte, aux champs de Tanis?"
,"13":"Il ouvrit la mer et les fit passer entre deux barrières d'eau."
,"14":"Il les guida de jour par une nuée, et chaque nuit, par une lueur de feu."
,"15":"Il fendit les roches dans le désert afin qu'ils aient, pour boire, toute l'eau du monde."
,"16":"Il fit jaillir des ruisseaux de la roche, des eaux qui s'écoulaient comme les eaux d'un fleuve."
,"17":"Mais ils recommencèrent à pécher contre lui: aux terres arides ils ont défié le Très-Haut."
,"18":"Ils voulurent le mettre à l'épreuve, ils lui demandèrent à manger pour survivre,"
,"19":"avec des paroles insultantes pour Dieu. Ils disaient: 'Dieu en est-il capable, va-t-il nous dresser la table au désert?"
,"20":"Il a frappé la roche et l'eau a coulé, des torrents se sont échappés; sera-t-il capable aussi de donner du pain, de servir de la viande à son peuple?'"
,"21":"Le Seigneur avait entendu, il s'emporta; un feu flamba contre Jacob, une fois de plus la colère frappa Israël."
,"22":"C'est qu'ils n'avaient pas cru en Dieu, ils n'avaient pas compté sur lui pour les sauver."
,"23":"Mais il donna un ordre aux nuées d'en-haut, il ouvrit les portillons du firmament."
,"24":"Il leur fit pleuvoir le manger: c'était la manne, le blé céleste."
,"25":"Et l'homme a mangé le pain des Forts quand Dieu donnait à la pause autant qu'on en voulait."
,"26":"Il fit souffler dans les cieux le vent d'est, il déchaîna sa force avec le vent du sud"
,"27":"et fit pleuvoir sur eux, non la poussière mais la viande, des volailles sans nombre comme sables des mers, "
,"28":"qui tombaient dans leur camp tout autour de leurs tentes."
,"29":"Ils mangèrent plus que leur compte: c'était tout leur désir et Dieu l'avait comblé."
,"30":"Le désir était encore là, dans leur coeur, et la nourriture encore dans leur bouche,"
,"31":"quand la colère de Dieu se retourna contre eux. Il fit périr les plus solides d'entre eux, il massacra l'élite de la jeunesse d'Israël."
,"32":"Après tout cela ils péchèrent encore, ils ne croyaient toujours pas à ses miracles."
,"33":"Aussi Dieu, d'un souffle, éteignait leurs jours, leurs années s'achevaient dans l'épouvante."
,"34":"Quand Dieu les massacrait, ils le cherchaient, ils revenaient, ils étaient tout à lui."
,"35":"Ils se rappelaient que Dieu est leur rocher, que le Très-Haut est leur rédempteur."
,"36":"Mais tout restait en paroles, leur langue ne pouvait que mentir"
,"37":"car leur coeur ne se donnait pas à fond: ils n'avaient pas foi en son alliance."
,"38":"Lui était toujours tendresse et compassion, il pardonnait la faute plutôt que de les perdre. Que de fois n'a-t-il pas fait taire sa colère au lieu de réveiller toute sa fureur!"
,"39":"Ils ne sont que chair, se disait-il, quand le souffle s'échappe, il ne revient pas."
,"40":"Comme ils l'ont défié au désert, comme ils ont su l'énerver dans la steppe!"
,"41":"Une fois de plus ils mettaient Dieu à l'épreuve, ils exaspéraient le Saint d'Israël."
,"42":"Ils ne pensaient plus à son intervention au jour qu'il les sauva de l'adversaire,"
,"43":"quand il fit en Egypte des signes, des miracles en terre de Tanis."
,"44":"Il avait changé les eaux du fleuve en sang, l'eau des ruisseaux n'était plus bonne à boire."
,"45":"Puis c'étaient des moustiques pour les dévorer, et des grenouilles qui faisaient des ravages."
,"46":"Il avait livré leurs récoltes au criquet, la sauterelle avait mangé tout leur travail."
,"47":"Les grêlons massacraient la vigne, le givre avait tué le sycomore."
,"48":"Il avait livré à la grêle leur bétail, la foudre tombait sur leurs bêtes."
,"49":"Il déchaîna sur eux l'ardeur de sa colère, et ce fut l'emportement, la fureur, la détresse, un bel envoi d'anges de malheur."
,"50":"Comme il donnait libre cours à sa colère, il ne leur épargna pas même la mort: il les livra à la peste."
,"51":"Il frappa tout premier-né en Egypte, les premiers engendrés dans les tentes de Kam."
,"52":"Alors il fit partir son peuple, ses brebis, il guida son troupeau au désert."
,"53":"Il les fit aller sûrs et sans crainte tandis que la mer passait sur leurs ennemis."
,"54":"Il les fit entrer dans ses frontières saintes, les montagnes que lui-même a conquises."
,"55":"Il chassa devant eux les nations, pour installer dans leurs tentes les tribus d'Israël et répartir au cordeau cet héritage."
,"56":"Mais eux, ils défiaient le Dieu Très-Haut, ils le mettaient à l'épreuve: ils ne tenaient pas compte de ses paroles."
,"57":"Ils déviaient comme leurs pères, ils trahissaient, ils se retournaient comme l'arc qui tire à faux."
,"58":"Leurs sanctuaires l'ont irrité, leurs idoles l'ont rendu jaloux."
,"59":"Dieu les entendait, il s'est emporté, il a rejeté pour de bon Israël."
,"60":"Il abandonna sa demeure de Silo, sa tente qu'il avait plantée chez les hommes."
,"61":"Il voulut que sa Gloire aille en captivité, que son diadème tombe aux mains de l'ennemi."
,"62":"Il en voulait tellement aux siens qu'il livra son peuple à l'épée."
,"63":"Les garçons périrent dans les flammes et les filles restèrent sans se marier."
,"64":"Ses prêtres tombèrent sous l'épée, et leurs veuves ne se lamentèrent pas."
,"65":"Mais le Seigneur, comme un dormeur, se réveilla, comme un homme solide qui a cuvé son vin."
,"66":"Il frappa l'adversaire par derrière, il le laissa humilié pour toujours."
,"67":"Puis il a écarté la famille de Joseph, il n'a pas choisi la tribu d'Ephraïm."
,"68":"Son choix est allé à la tribu de Juda, à ce mont Sion qu'il aimait."
,"69":"Il a bâti son sanctuaire, pareil aux montagnes, et comme le monde, stable à jamais."
,"70":"Il a choisi David, son serviteur, qu'il trouva à l'enclos des moutons"
,"71":"alors qu'il soignait les brebis mères. Il lui a fait paître Jacob, son peuple, Israël, son héritage. "
,"72":"Il s'est fait leur pasteur, son coeur était sans faille, et d'une main sage, il les guidait."
}`)
	CurrentBook.AddChapter(79, `{
"1":"Psaume d'Asaph. O Dieu, les païens sont entrés dans ton domaine, ils y ont profané ton sanctuaire, ils ont laissé Jérusalem en ruines."
,"2":"Ils ont livré les corps de tes serviteurs aux oiseaux du ciel pour les déchirer; la chair de tes fidèles est la proie des bêtes."
,"3":"Ils ont versé le sang comme l'eau partout dans Jérusalem - et personne pour enterrer!"
,"4":"Nous sommes couverts de honte devant nos voisins, les peuples tout autour nous insultent et se moquent."
,"5":"Jusques à quand, Seigneur, durera ta colère? Va-t-elle brûler sans fin pour venger tes droits?"
,"6":"Décharge ta fureur sur les nations qui t'ignorent, sur les dynasties qui n'invoquent pas ton nom."
,"7":"Car elles ont dévoré le peuple de Jacob, elles ont ravagé son domaine."
,"8":"Ne nous tiens pas rancune des fautes de nos pères, que ta miséricorde coure à notre rencontre, car nous n'en pouvons plus."
,"9":"Aide-nous, ô Dieu; toi seul peux nous sauver, délivre-nous, pardonne-nous pour l'honneur de ton nom."
,"10":"Veux-tu que les païens disent: 'Où est leur Dieu?' Que les païens sachent, et que nous voyions, comment tu venges le sang de tes serviteurs."
,"11":"Que vienne jusqu'à toi la plainte du prisonnier, lève-toi, sauve ceux qui vont à la mort."
,"12":"Punis nos voisins, fais-leur payer sept fois leurs insultes contre toi, Seigneur."
,"13":"Et nous, ton peuple, le troupeau de ton héritage, nous te célébrerons à jamais; d'âge en âge nous redirons tes louanges."
}`)
	CurrentBook.AddChapter(80, `{
"1":"Au maître de chant. Sur l'air 'les lis du témoignage...'. Psaume d'Asaph."
,"2":"Prête l'oreille, berger d'Israël, des enfants de Joseph, le troupeau que tu guides. Toi qui sièges sur les Chérubins, resplendis "
,"3":"devant Ephraïm, Benjamin et Manassé! Réveille ta vaillance, viens et sauve-nous."
,"4":"O Dieu, reprends-nous en main, fais briller sur nous ta face, sauve-nous!"
,"5":"Jusques à quand, Seigneur des armées, vas-tu te raidir face aux prières de ton peuple?"
,"6":"Tu leur as fait manger le pain des larmes; leurs larmes, ils les ont bues jusqu'à plus soif."
,"7":"Nous sommes la proie que s'arrachent nos voisins, et nos ennemis se moquent de nous."
,"8":"O Dieu Sabaot, reprends-nous en main, fais briller sur nous ta face, sauve-nous!"
,"9":"Tu avais une vigne; dépiquée d'Egypte, tu avais, pour la planter, chassé des peuples."
,"10":"Tu avais défriché pour qu'elle prenne racine, elle occupait tout le pays."
,"11":"Son ombre couvrait les collines, ses pousses couraient sur les grands cèdres."
,"12":"Elle étendait ses branches jusqu'à la mer et ses rejetons s'allongeaient jusqu'au fleuve."
,"13":"Pourquoi lui as-tu défait sa clôture? Celui qui passe sur la route, maintenant y entre,"
,"14":"les sangliers la ravagent, les bêtes en liberté la broutent."
,"15":"O Dieu Sabaot, il est temps que tu reviennes; du haut des cieux regarde et vois: fais quelque chose pour ta vigne,"
,"16":"protège-la puisque tu l'as plantée."
,"17":"Ceux qui l'ont mise au feu, comme une ordure, d'un mot, d'un regard tu les feras périr."
,"18":"Couvre de ta main l'homme qui fait tes oeuvres, ce fils d'homme que tu as confirmé."
,"19":"Nous ne t'échapperons plus, tu nous feras vivre et nous invoquerons ton nom."
,"20":"Seigneur, Dieu Sabaot, reprends-nous en main, fais briller sur nous ta face, sauve-nous!"
}`)
	CurrentBook.AddChapter(81, `{
"1":"Au maître de chant. Sur la githienne. D'Asaph."
,"2":"Criez de joie pour Dieu, notre force, acclamez le Dieu de Jacob!"
,"3":"Allez-y pour le chant, faites donner les tambours, la harpe mélodieuse et la lyre!"
,"4":"Sonnez du cor pour le premier du mois, puis à la pleine lune, au jour de notre fête!"
,"5":"C'est une règle en Israël,par décision du Dieu de Jacob,"
,"6":"un décret qu'il imposa aux enfants de Joseph,quand ils quittaient le pays d'Egypte. Alors ils entendirent une voix inconnue:"
,"7":"'J'ai enlevé le fardeau de ton épaule, tu n'auras plus les mains rivées aux corbeilles."
,"8":"Tu criais dans la détresse, je t'ai délivré, je t'ai répondu dans le secret de la nuée, je t'ai mis à l'épreuve aux eaux de Mériba."
,"9":"Ecoute, mon peuple, car je veux t'avertir, Israël, écoute-moi:"
,"10":"On ne verra pas chez toi un dieu étranger; tu ne serviras pas un dieu venu d'ailleurs:"
,"11":"Je suis Yahvé, ton Dieu, qui t'ai fait remonter d'Egypte. Ouvre ta bouche toute grande, que je la remplisse.'"
,"12":"Mon peuple, pourtant, n'a pas voulu m'entendre, Israël ne m'a pas obéi."
,"13":"Je les ai donc laissés: 'N'en faites qu'à votre tête, allez par où bon vous semble!'"
,"14":"Ah! si mon peuple m'écoutait, si Israël prenait mes chemins,"
,"15":"en peu de temps je soumettrais ses ennemis, d'un revers de main je frapperais l'adversaire."
,"16":"Les ennemis du Seigneur lui feraient des sourires, ils seraient effrayés pour de bon."
,"17":"Mais lui, je le nourrirais des blés les meilleurs, avec le miel du rocher, plus qu'il n'en peut prendre."
}`)
	CurrentBook.AddChapter(82, `{
"1":"Cantique d'Asaph. Dieu s'est levé dans l'assemblée divine, au milieu des dieux; il dicte le jugement:"
,"2":"'Jusqu'à quand serez-vous des juges pour le mal, avec tant de respect pour les méchants?"
,"3":"Défendez les droits du faible, de l'orphelin, faites justice au malheureux et au pauvre."
,"4":"Vous les voyez si faibles, misérables, délivrez-les du méchant qui les opprime.'"
,"5":"Ces gens ne savent rien, ils ne comprennent pas, ils tournent en rond dans leurs ténèbres, mais les bases du monde en sont ébranlées."
,"6":"J'avais dit: 'Vous serez des dieux, vous serez tous comme les fils du Très-Haut!'"
,"7":"Mais non: vous serez humains et mortels, vous tomberez comme n'importe qui."
,"8":"Lève-toi, ô Dieu, et juge le monde, c'est bien toi qui mènes les peuples!"
}`)
	CurrentBook.AddChapter(83, `{
"1":"Cantique. Psaume d'Asaph."
,"2":"O Dieu, ne reste pas muet, ne te tais pas, mon Dieu, ne reste pas tranquille"
,"3":"quand tes ennemis font du bruit, et ceux qui te détestent relèvent la tête."
,"4":"Ils montent un coup contre ton peuple, ils s'en prennent à ceux que tu protèges."
,"5":"Ils ont dit: 'Terminons-en avec cette nation, et que plus personne ne parle d'Israël.'"
,"6":"Ils se sont mis tous d'accord, ils ont fait une alliance contre toi:"
,"7":"les clans d'Edom et d'Ismaël, ceux de Moab et les fils d'Agar."
,"8":"Guébal, Amon, Amalec, les Philistins et les gens de Tyr."
,"9":"Même ceux d'Achour sont avec eux et prêtent main forte aux fils de Lot."
,"10":"Fais-leur subir le sort de Madian et de Siséra, de Yabin au torrent du Quison:"
,"11":"ils ont été exterminés à En Dor, ils y sont restés comme du fumier sur le sol."
,"12":"Traite leurs princes comme Oreb et Zéeb, et leurs généraux comme Zébah et Salmouna"
,"13":"qui parlaient de conquérir le domaine de Dieu."
,"14":"O Dieu, emporte-les dans un tourbillon, comme la paille soufflée par le vent,"
,"15":"comme l'incendie dans la forêt, comme le feu qui court sur les monts."
,"16":"Tu lanceras derrière eux la tempête, ton ouragan les remplira d'épouvante."
,"17":"Qu'ils aient la face couverte de honte, peut-être rechercheront-ils ton Nom."
,"18":"Qu'ils soient confondus, épouvantés à jamais, qu'ils soient humiliés et qu'ils disparaissent."
,"19":"Qu'ils te connaissent: ton nom n'est-il pas Yahvé? Et tu es le Très-Haut, le seul pour toute la terre."
}`)
	CurrentBook.AddChapter(84, `{
"1":"Au maître de chant. Sur la githienne. Des fils de Coré. Psaume."
,"2":"Que tes demeures nous sont bonnes, ô Seigneur Sabaot!"
,"3":"Mon âme désire, jusqu'à s'en consumer, les esplanades du Seigneur. Mon coeur et ma chair crient de joie: je vais au Dieu vivant!"
,"4":"Même les moineaux trouvent là leur maison,et l'hirondelle un nid pour y loger ses petits,juste à côté de tes autels, ô Seigneur Sabaot, mon roi et mon Dieu!"
,"5":"Heureux ceux qui demeurent en ta maison, ils resteront là pour te louer!"
,"6":"Heureux ces pèlerins qui cherchent en toi la force,et qui ont à coeur de monter vers toi!"
,"7":"Ils font étape au val des Saules, ils y boivent à la source,déjà bénie par les premières pluies;"
,"8":"ils passent les murailles, l'une après l'autre, jusqu'à se présenter devant Dieu à Sion."
,"9":"Seigneur, Dieu Sabaot, entends ma prière, écoute donc, Dieu de Jacob!"
,"10":"O Dieu, notre bouclier, ouvre les yeux, aie un regard pour ton roi."
,"11":"Une journée sur tes esplanades en vaut mille,et je choisis de rester sur le seuil, devant la maison de mon Dieu, plutôt que de partager la demeure des méchants."
,"12":"Le Seigneur est un rempart, un bouclier, le Seigneur donne la grâce, et puis la gloire,à ceux dont la conduite est irréprochable: aucun bien ne leur sera refusé."
,"13":"O Seigneur Sabaot, heureux celui qui espère en toi!"
}`)
	CurrentBook.AddChapter(85, `{
"1":"Au maître de chant. Des fils de Coré. Psaume."
,"2":"Tu as été bon, Seigneur, pour ta terre, tu as fait revenir les exilés de Jacob."
,"3":"Tu as supprimé la dette de ton peuple, tu as pardonné totalement son péché!"
,"4":"Tu as retrouvé ton calme, tu es revenu de tes emportements."
,"5":"Reprends-nous en main, ô Dieu, notre Sauveur, et mets un terme à ton ressentiment."
,"6":"Seras-tu pour toujours irrité contre nous,faut-il que ta colère se prolonge d'âge en âge?"
,"7":"Ne vas-tu pas te reprendre, nous donner la vie, que nous ayons plaisir à te louer?"
,"8":"Fais-nous voir, Seigneur, ta bonté,et donne-nous ton salut."
,"9":"Comme je voudrais entendre une parole de Dieu, que le Seigneur parle de paix,pour son peuple, pour ses fidèles, et qu'ils ne reviennent pas à leur folie."
,"10":"Oui, son salut est proche pour ceux qui le craignent,et sa Gloire va se poser sur notre terre."
,"11":"Grâce et Fidélité se rencontrent, Justice et Paix s'embrassent,"
,"12":"la Fidélité germe de la terre,et du haut du ciel, la Justice se penche."
,"13":"Le Seigneur lui-même va donner ses bienfaits,et notre terre donnera son fruit."
,"14":"La droiture marchera devant lui, la paix suivra les traces de ses pas."
}`)
	CurrentBook.AddChapter(86, `{
"1":"Prière; de David. Ecoute, Seigneur, et réponds-moi! Ne vois-tu pas comme je suis misérable?"
,"2":"Veille sur ma vie, ne suis-je pas ton fidèle? Sauve ton serviteur qui a confiance en toi."
,"3":"Seigneur, mon Dieu, aie pitié de moi quand tout le jour je crie vers toi."
,"4":"Vers toi, Seigneur, j'élève mon âme: fais donc plaisir à ton serviteur!"
,"5":"Tu es bon, Seigneur, et tu pardonnes, et tu es plein d'égards pour ceux qui t'invoquent."
,"6":"Ecoute ma prière, Seigneur, prête attention à mes appels de détresse."
,"7":"Je t'invoque au temps de mes épreuves: tu me répondras."
,"8":"Nul n'est comme toi, Seigneur, parmi les dieux, où trouver des oeuvres comme les tiennes?"
,"9":"Tous les païens viendront, Seigneur, pour t'adorer, ils rendront gloire à ton nom."
,"10":"Car tu es grand et tu fais des merveilles, toi seul es Dieu."
,"11":"Enseigne-moi tes chemins, que je marche dans ta vérité, que mon coeur soit entier dans la crainte de ton Nom."
,"12":"De tout coeur je te louerai, Seigneur, je rendrai gloire à ton nom à jamais"
,"13":"pour la faveur si grande que tu m'as faite: tu m'as épargné la descente chez les morts."
,"14":"O Dieu, des arrogants s'en prennent à moi, une bande de violents en veulent à ma vie, des gens qui ne pensent pas à Dieu."
,"15":"Mais toi, Seigneur, Dieu de tendresse et de pitié, lent à la colère, riche en grâce et fidélité,"
,"16":"communique ta force à ton serviteur, sauve le fils de ta servante, tourne-toi, prends pitié de moi"
,"17":"et fais-moi la faveur d'un miracle!,Mes ennemis verront - ils en seront humiliés - que toi, Seigneur, tu m'as aidé, tu m'as relevé."
}`)
	CurrentBook.AddChapter(87, `{
"1":"Des fils de Coré. Psaume. Cantique. Lui-même l'a fondée sur sa montagne sainte,"
,"2":"le Seigneur aime les portes de Sion,plus que nulle autre demeure en Jacob."
,"3":"On dit sur toi de bien belles choses, cité de Dieu!"
,"4":"Nous parlons entre amis de l'Egypte, de Babel, et puis de Tyr, des Philistins, de l'Ethiopie: tel et tel y sont nés."
,"5":"Mais pour Sion, que dirons-nous?,L'un après l'autre, tous y viennent renaître, le Très-Haut, en personne, la met en place."
,"6":"Le Seigneur inscrit sur le registre des peuples: 'Celui-ci est né chez elle, celui-là encore.'"
,"7":"Cependant que chez toi tous font la fête, et l'on chante et l'on danse."
}`)
	CurrentBook.AddChapter(88, `{
"1":"Cantique. Psaume. Des fils de Coré. Au maître de chant. A chanter sur un ton plaintif. Méditation d'Héman l'Ezrahite."
,"2":"Seigneur, mon Dieu, tout le jour je t'appelle, et de nuit je me lamente devant toi."
,"3":"Que ma prière parvienne jusqu'à toi, prête attention quand j'appelle à l'aide."
,"4":"Car je me vois rassasié d'épreuves et mon âme est bien près de rejoindre les morts."
,"5":"Tu peux me compter parmi ceux qu'on enterre, je suis un homme brisé,"
,"6":"qui a déjà sa place parmi les morts, semblable aux corps allongés dans la tombe, dont tu n'as plus souvenir et qui échappent à ta providence."
,"7":"Tu m'as relégué dans les cavernes d'en-bas, dans les ténèbres de l'abîme."
,"8":"Tu m'as écrasé dans ta fureur, toutes tes vagues ont passé sur moi."
,"9":"Tu as éloigné de moi ceux qui me connaissent, tu as su faire qu'ils me regardent avec horreur. Je suis enfermé, je ne peux sortir, "
,"10":"et la souffrance a terni mon regard. Tout le jour je t'appelle, Seigneur, et je tends les mains vers toi."
,"11":"Feras-tu des miracles chez les défunts, pour que leurs ombres se redressent et t'applaudissent?"
,"12":"Parlera-t-on de ta bonté chez les morts, de ta fidélité, là où tout est perdu?"
,"13":"Vont-ils admirer tes merveilles dans le noir, et ta justice quand tout est oublié?"
,"14":"Alors, Seigneur, je crie vers toi, ma prière au matin s'élève à ta rencontre."
,"15":"Pourquoi, Seigneur, m'as-tu rejeté et me caches-tu ta face?"
,"16":"Malheureux et souffrant depuis l'enfance, tu m'as porté des coups terribles, je suis à bout."
,"17":"Tes colères ont passé sur moi, tes épouvantes m'ont anéanti."
,"18":"Comme des eaux, tout le jour elles m'enveloppent et toutes ensemble elles m'assaillent."
,"19":"Tu as éloigné de moi amis et compagnons: plus personne qui me connaisse!"
}`)
	CurrentBook.AddChapter(89, `{
"1":"Méditation d'Ethan l'Ezrahite."
,"2":"Je voudrais chanter toujours les grâces du Seigneur, proclamer d'âge en âge ta fidélité."
,"3":"Ta faveur, je le sais, est indestructible, tu fis le ciel, tu y mis la fidélité."
,"4":"Quand tu fis une alliance avec ton préféré, avec David, ton serviteur, tu lui dis:"
,"5":"'J'établis ta descendance pour toujours, je te bâtis un trône qui tiendra d'âge en âge.'"
,"6":"Les cieux entendent chanter tes merveilles, et ta fidélité, dans l'assemblée des saints."
,"7":"Qui donc, dans les nues, est l'égal du Seigneur? Qui ressemble à Yahvé parmi les fils des dieux?"
,"8":"Lui, le Dieu redouté au Grand Conseil des Saints, il est craint de tous ceux qui l'entourent."
,"9":"Seigneur, Dieu Sabaot, qui est comme toi? Puissant Seigneur, ta fidélité t'enveloppe!"
,"10":"Tu domines la fureur des mers, quand les flots se soulèvent, toi tu les apaises."
,"11":"Tu as frappé le Monstre, tu l'as laissé mort, tes coups puissants ont dispersé tes ennemis."
,"12":"Les cieux sont à toi, la terre de même; tu mis en place le globe et tout ce qui s'y loge."
,"13":"Au nord comme au sud, tout fut créé par toi, le Thabor et l'Hermon célèbrent ton nom."
,"14":"Rien ne te manque: la vaillance, les grands coups, une main puissante, une main prête à frapper."
,"15":"Ton trône repose sur la droiture et la justice, Faveur et Fidélité marchent devant toi."
,"16":"Heureux le peuple qui a lieu de t'acclamer et qui s'avance dans la lumière de ta face,"
,"17":"pour qui ton Nom, tout le jour, est source de joie, et que ta justice élève au premier rang."
,"18":"C'est toi qui nous donnes l'éclat, la puissance, et c'est de ta bonté que nous vient la victoire."
,"19":"Notre protecteur est dans ta main, Seigneur, notre roi n'existe que par le Saint d'Israël."
,"20":"Tu as parlé jadis, c'était une vision; tu mentionnais ton fidèle, et tu as dit: 'J'ai accordé mon aide à ce guerrier, je l'ai pris parmi mon peuple, je l'ai élevé."
,"21":"J'ai trouvé David, mon serviteur, je l'ai consacré avec l'huile sainte."
,"22":"Je le soutiendrai de ma main, mes coups d'éclat le rendront fort."
,"23":"Les embûches de l'adversaire échoueront, les scélérats n'auront pas sur lui le dessus."
,"24":"J'écraserai devant lui ses agresseurs, je frapperai ceux qui le haïssent."
,"25":"Ma grâce et ma fidélité seront avec lui, mon Nom lui assurera la victoire."
,"26":"Je ferai passer la mer sous sa baguette, les fleuves feront partie de son domaine."
,"27":"Il pourra faire appel à moi: 'Tu es mon Père, mon Dieu, le rocher où je m'abrite!'"
,"28":"J'en ferai mon premier-né, le plus fameux des rois de la terre."
,"29":"Je lui garderai à jamais ma faveur, je serai fidèle à mon alliance avec lui."
,"30":"Je lui garantis une descendance, un trône qui durera autant que les cieux."
,"31":"Si ses fils négligent ma loi et ne suivent pas mes décisions,"
,"32":"s'ils violent mes préceptes et ne gardent pas mes commandements,"
,"33":"je punirai leurs fautes avec des verges, ils recevront des coups pour leurs erreurs."
,"34":"Mais je ne lui reprendrai pas ma faveur, je ne ferai pas mentir ma fidélité."
,"35":"Je ne briserai pas mon alliance, je ne changerai pas ce qui est sorti de mes lèvres."
,"36":"Il suffit que j'aie juré par ma sainteté: je ne mentirai pas à David."
,"37":"Sa descendance n'aura pas de fin, son trône, comme le soleil, restera devant moi."
,"38":"Il est là pour toujours, comme la lune, ce témoin fidèle au-delà des nues.'"
,"39":"Et pourtant tu as rejeté ton roi, tu t'es emporté contre lui."
,"40":"Tu as renié l'alliance donnée à ton serviteur, tu as jeté à terre sa couronne."
,"41":"Tu as fait des brèches dans sa clôture, tu as laissé détruire ses forteresses."
,"42":"Qui passe sur la route emporte ce qu'il veut, et ses voisins ne le respectent plus."
,"43":"Tu as donné l'avantage à ses adversaires, tu as mis en joie ses ennemis."
,"44":"L'ennemi a repoussé son glaive et tu ne l'as pas soutenu au combat."
,"45":"Tu as fait tomber de sa main le sceptre, tu as renversé à terre son trône."
,"46":"Tu as mis fin, bien vite, à ses jours de jeunesse, et tu l'as enfoncé dans le mépris."
,"47":"Jusqu'à quand, Seigneur, vas-tu te cacher? Connaîtrons-nous sans fin le feu de ta fureur?"
,"48":"Rappelle-toi, Seigneur, ce qu'est notre existence, et pour quelle misère tu as créé les fils d'Adam."
,"49":"Qui donc, à son heure, ne verra pas sa fin, et sauvera sa vie des griffes de la mort?"
,"50":"Où sont donc, Seigneur, tes faveurs d'autrefois, tes serments à David, et ta fidélité?"
,"51":"Vois, Seigneur: que d'affronts pour ton serviteur!"
,"52":"Que d'insultes des ennemis du Seigneur, qu'ils jettent sur les pas de ton roi, ton élu!"
,"53":"Bénit soit le Seigneur, amen, amen!"
}`)
	CurrentBook.AddChapter(90, `{
"1":"Prière de Moïse, homme de Dieu. Seigneur, tu as été pour nous,d'âge en âge un refuge."
,"2":"Bien avant la naissance des monts, avant la mise au monde du globe de la terre, tu étais déjà Dieu, tu l'es à jamais,"
,"3":"toi qui renvoies les mortels à la poussière, et qui leur dis: 'Repartez, fils d'Adam!'"
,"4":"Mille années ont passé: pour toi c'était hier!,mille années: le temps d'une veille!"
,"5":"Tu les sèmes tour à tour, et le matin voit sortir l'herbe verte."
,"6":"Au matin vient sa fleur, elle s'ouvre, et puis se fane au soir, elle se dessèche."
,"7":"Tu nous vois consumés par ta colère, désarçonnés par ta fureur."
,"8":"Tu as rappelé nos fautes en ta présence, tu as mis nos secrets sous les feux de ta face,"
,"9":"et nos jours ont couru sous ta colère, nos années ont passé comme un soupir."
,"10":"Combien d'années? Soixante-dix ans peut-être, quatre-vingts, si l'on est vigoureux. La plupart ne sont que peine et déception, elles passent vite et nous voilà envolés."
,"11":"Qui a connu la force de ta colère, qui a sondé le fond de ta fureur?"
,"12":"Apprends-nous à compter nos jours, que notre coeur enfin vienne à la sagesse."
,"13":"Reviens, Seigneur, jusques à quand?,Aie compassion de tes serviteurs."
,"14":"Comble-nous de tes faveurs dès le matin, que le rire et la joie soient toujours avec nous."
,"15":"Fais que dure la joie comme ont duré nos misères, et les années où nous avons connu le malheur."
,"16":"Agis enfin et que tes serviteurs le voient, que leurs enfants découvrent ta majesté."
,"17":"Que le Seigneur nous couvre de sa douceur,et qu'il mène à bien l'oeuvre de nos mains!"
}`)
	CurrentBook.AddChapter(91, `{
"1":"Toi qui demeures au refuge du Très-Haut,et qui te loges à l'ombre du Puissant,"
,"2":"dis au Seigneur: 'Tu es mon abri, mon rempart, mon Dieu en qui je me confie!'"
,"3":"Il te fera échapper au filet du chasseur, il te protégera des démons du malheur."
,"4":"Il te couvrira de son plumage,et tu te serreras au creux de son aile."
,"5":"Tu ne craindras pas, de nuit, la terreur, ni de jour, la flèche qui vole,"
,"6":"ni le fléau qui s'avance dans le noir, ni la peste qui frappe en plein midi."
,"7":"Mille, peut-être, tomberont près de toi, dix mille, rien qu'à ta droite, mais tu seras hors d'atteinte,"
,"4c":"sa fidélité sera ton mur, ton bouclier."
,"8":"Ouvre les yeux et regarde: tu verras ce qu'on rend aux méchants!"
,"9":"Mais toi, tu as le Seigneur pour refuge, tu as fait du Très-Haut ton asile."
,"10":"Le mal ne t'atteindra pas, la plaie ne frappera pas jusqu'à toi."
,"11":"Car il donnera un ordre à ses anges, pour qu'ils t'escortent sur tous tes chemins."
,"12":"Dans leurs mains ils te porteront,pour que ton pied ne bute pas sur la pierre."
,"13":"Tu passeras sur les fauves et les serpents, tu piétineras le jeune lion et le dragon."
,"14":"'Puisqu'il s'est lié à moi, je le délivrerai, je veux le protéger, car il a connu mon Nom."
,"15":"Qu'il m'appelle, je lui répondrai, je serai avec lui dans l'angoisse; je le sauverai, je lui donnerai la gloire."
,"16":"J'allongerai ses jours autant qu'il le désire, et je ferai qu'il voie mon salut.'"
}`)
	CurrentBook.AddChapter(92, `{
"1":"Psaume. Cantique pour le jour du sabbat."
,"2":"Il est bon de louer le Seigneur,et de célébrer ton nom, Dieu Très-Haut!"
,"3":"de rappeler tes faveurs au matin,et ta fidélité tout au long de la nuit,"
,"4":"avec la lyre et la cithare, sur un fond de harpe."
,"5":"Tu as agi, Seigneur, et j'en suis tout joyeux; à voir les oeuvres de tes mains je m'écrie:"
,"6":"'Que tes oeuvres sont grandes, Seigneur, et tes pensées, qu'elles sont profondes!'"
,"7":"Les esprits bornés n'en savent rien, l'homme sans cervelle ne peut pas comprendre."
,"8":"Si les méchants poussent comme l'herbe, si les malfaisants prospèrent, c'est pour être détruits à jamais,"
,"9":"alors que toi, Seigneur, tu domines pour toujours."
,"10":"Il vient un temps où tes ennemis périssent, où tous les malfaisants se dispersent."
,"11":"Mais à moi tu me donnes l'assurance du buffle; tu m'as fait le massage aux huiles de vigueur,"
,"12":"et je regarde de haut mes adversaires, j'écoute, sans plus, ces criminels."
,"13":"Le juste s'élève comme le palmier, il émerge, comme le cèdre du Liban."
,"14":"Ceux qui sont plantés dans la maison du Seigneur,fleuriront dans les parterres de notre Dieu."
,"15":"Dans la vieillesse encore ils porteront du fruit, ils seront verts et vigoureux."
,"16":"Ils pourront redire que le Seigneur est juste: 'Il est mon rocher: lui est sans faille!'"
}`)
	CurrentBook.AddChapter(93, `{
"1":"Le Seigneur règne, vêtu de Majesté, il s'est fait du Pouvoir une ceinture: le monde désormais est stable, inébranlable."
,"2":"Depuis toujours ton trône était dressé, car tu es, toi, de toute éternité."
,"3":"Les fleuves, Seigneur, ont fait monter, les fleuves ont fait monter leur vacarme, les fleuves ont fait monter leur grondement."
,"4":"Mais il est plus fort que les eaux qui grondent, plus grandiose que les vagues de la mer, lui, le Seigneur, grandiose dans les hauteurs."
,"5":"Il n'y a pas plus sûr que tes paroles, ta Maison sera le lieu de la sainteté, jour après jour et toujours, ô Seigneur!"
}`)
	CurrentBook.AddChapter(94, `{
"1":"Dieu vengeur, ô mon Seigneur, Dieu vengeur, montre-toi!"
,"2":"Impose-toi, juge de la terre, et rends leur dû aux orgueilleux."
,"3":"Jusqu'à quand, Seigneur, ces méchants, jusqu'à quand ces méchants qui triomphent?"
,"4":"Ils parlent de travers, ils parlent de haut, ils parlent et se vantent, tous ces malfaisants."
,"5":"Ils écrasent ton peuple, Seigneur, ils oppriment ta famille."
,"6":"Ils tuent la veuve et l'isolé, ils massacrent les orphelins."
,"7":"Ils croient que le Seigneur ne voit pas, que le Dieu de Jacob n'en sait rien."
,"8":"Prenez garde, esprits plus bornés que les autres! Imbéciles, quand donc comprendrez-vous?"
,"9":"Lui qui a fait l'oreille, n'entend-il pas? Lui qui a créé l'oeil, ne voit-il pas?"
,"10":"Peut-il reprendre les nations et vous ignorer, lui qui enseigne à l'homme ce qu'il doit savoir?"
,"11":"Le Seigneur connaît les projets des hommes: ils ne sont que du vent."
,"12":"Heureux celui que tu corriges, Seigneur, celui à qui tu enseignes ta loi!"
,"13":"Tu le maintiens au calme dans les jours mauvais, le temps qu'on creuse au méchant sa fosse."
,"14":"Car le Seigneur ne rejette pas son peuple, il n'abandonne jamais les siens."
,"15":"Le jugement reviendra à Celui qui est juste, et tous les coeurs droits pourront applaudir."
,"16":"Qui se met de mon côté contre les méchants? Qui veut avec moi tenir tête aux malfaisants?"
,"17":"Par bonheur le Seigneur m'a secouru, un peu plus, et je finissais chez les morts."
,"18":"A peine ai-je dit: 'Mes pieds chancellent!' ta grâce, Seigneur, m'a raffermi."
,"19":"Mes soucis avaient beau m'assiéger, tes secours réconfortaient mon âme."
,"20":"Pourrais-tu supporter un pouvoir criminel, auteur de lois oppressives?"
,"21":"Tous conspirent contre la vie du juste et font condamner l'innocent."
,"22":"Mais le Seigneur, ma citadelle, est toujours là, mon Dieu m'est un rocher, un refuge."
,"23":"Il retourne contre eux leur injustice, et leur propre malice les renvoie au néant: le Seigneur notre Dieu les réduira à rien."
}`)
	CurrentBook.AddChapter(95, `{
"1":"Venez donc, nous chanterons le Seigneur, nous irons acclamer le rocher qui nous sauve!"
,"2":"Allons à sa rencontre dans l'action de grâce, avec des chants, des acclamations."
,"3":"Car le Seigneur est le grand Dieu,et le grand roi par-dessus tous les dieux."
,"4":"Les dessous de la terre sont au creux de sa main,et les sommets des monts sont encore à lui."
,"5":"A lui la mer, puisqu'il l'a faite, et puis les terres: sa main les a formées."
,"6":"Entrez, à genoux, prosternons-nous, plions le genou devant le Dieu qui nous a faits."
,"7":"C'est lui notre Dieu, et nous sommes son peuple, le troupeau sous sa main. Si vous pouviez aujourd'hui écouter sa voix!"
,"8":"'Ne vous obstinez pas comme à Mériba, comme au jour de Massa dans le désert,"
,"9":"quand vos pères m'ont défié, mis à l'épreuve, alors qu'ils avaient vu mes oeuvres."
,"10":"Je me suis dégoûté d'eux tous pour quarante ans, et j'ai dit: 'C'est un peuple qui toujours échappe, ils ne connaissent pas mes voies.'"
,"11":"Et j'ai juré dans ma colère: 'Jamais ils n'atteindront le lieu de mon repos.'"
}`)
	CurrentBook.AddChapter(96, `{
"1":"Chantez au Seigneur un chant nouveau, Chantez au Seigneur, toute la terre!"
,"2":"Chantez au Seigneur et bénissez son nom, annoncez jour après jour son salut."
,"3":"Racontez parmi les nations sa gloire, redites à tous les peuples ses prodiges!"
,"4":"Car le Seigneur est grand, très digne de louange, et redoutable, bien au-dessus des dieux."
,"5":"Ces dieux des peuples ne sont que des idoles, mais lui, Yahvé, a fait les cieux."
,"6":"Honneur et Majesté marchent devant lui, Force et Splendeur sont en son sanctuaire."
,"7":"Venez, tribus et peuples, pour l'offrande au Seigneur, retournez au Seigneur la gloire et la puissance!"
,"8":"Rendez au Seigneur la gloire de son nom, apportez vos offrandes jusque sur ses parvis."
,"9":"Courbez-vous devant lui sur le parvis sacré, tremblez devant sa face, gens de toute la terre!"
,"10":"Annoncez-le chez les païens: le Seigneur règne!,Il jugera les peuples selon la droiture."
,"11":"Joie dans les cieux, fête sur la terre, grondement des eaux et du monde marin!"
,"12":"Que la campagne, les fruits du sol, crient leur joie, que les arbres de la forêt lancent des vivats"
,"13":"sur le passage du Seigneur, car il vient, car il vient pour juger la terre. Il jugera le monde avec justice, et les peuples selon sa vérité."
}`)
	CurrentBook.AddChapter(97, `{
"1":"Le Seigneur est roi, que la terre soit en fête, réjouissez-vous, peuples des îles!"
,"2":"Une nuée ténébreuse l'entoure, la justice et le droit sont les pieds de son trône."
,"3":"Un feu avance devant lui pour dévorer ses adversaires à l'entour."
,"4":"Les éclairs illuminent le monde, la terre regarde et tremble."
,"5":"Les montagnes comme cire se liquéfient devant lui, devant le Seigneur de toute la terre."
,"6":"Les cieux proclament sa justice et tous les peuples voient sa gloire."
,"7":"Les adorateurs d'idoles en restent confondus, ceux-là mêmes qui se vantaient de ces choses stupides. Devant lui se prosternent tous les dieux."
,"8":"Sion l'a su, elle est dans la joie, et les cités de Juda sont en fête"
,"9":"dans l'attente de tes sentences, Seigneur. Car tu es maintenant Très-Haut sur la terre, car tu es élevé bien au-dessus des dieux."
,"10":"Vous qui aimez le Seigneur, détestez le mal, car il prend soin des âmes de ses fidèles et les délivre de la main des méchants."
,"11":"La lumière s'est levée pour le juste, la joie a visité ceux qui ont le coeur droit."
,"12":"Réjouissez-vous, justes, dans le Seigneur, et rendez grâce, au rappel de son saint nom!"
}`)
	CurrentBook.AddChapter(98, `{
"1":"Psaume. Chantez au Seigneur un chant nouveau pour les merveilles qu'il a faites, pour la victoire qu'il a remportée, pour les coups d'éclat de sa sainteté."
,"2":"Le Seigneur a révélé son salut, il a fait voir aux païens sa justice."
,"3":"Il s'est rappelé sa préférence pour Jacob, sa fidélité à Israël. Tous ont vu jusqu'aux confins du monde le salut de notre Dieu."
,"4":"Acclamez le Seigneur, toute la terre, éclatez en cris de joie!"
,"5":"Chantez le Seigneur sur la cithare, faites entendre la cithare avec les chants;"
,"6":"aux accents de la trompette et du cor, acclamez sur son passage le Roi, le Seigneur."
,"7":"Que grondent les eaux et le monde marin, la terre et tous ceux qui l'habitent."
,"8":"Que les fleuves battent des mains et que les monts soient en fête"
,"9":"au passage du Seigneur, car il vient, car il va juger la terre. Il jugera le monde avec justice, et chacun des peuples selon son droit."
}`)
	CurrentBook.AddChapter(99, `{
"1":"Le Seigneur règne, les peuples en ont tremblé; il est là sur les Chérubins, la terre s'affole."
,"2":"Le Seigneur est dans Sion, très grand, très haut par-dessus tous les peuples."
,"3":"Ils célèbrent ton Nom, grand et terrible: 'Oui, il est saint,"
,"4":"c'est un roi puissant qui aime le droit!',Car tu es venu restaurer la droiture et tu mets en Israël le droit, le juste jugement."
,"5":"Exaltez le Seigneur notre Dieu, courbez-vous devant l'arche, il y pose ses pieds, dites: 'Oui, il est saint!'"
,"6":"Moïse, Aaron étaient ses prêtres, Samuel aussi invoquait son nom. Ils invoquaient le Seigneur et lui leur répondait."
,"7":"De la colonne de nuée il leur parlait, ils observaient ses ordres, les lois qu'il leur donnait."
,"8":"O Seigneur, notre Dieu, tu leur répondais, tu étais avec eux un Dieu patient, mais tu ne leur passais rien."
,"9":"Exaltez le Seigneur notre Dieu, adorez-le sur sa sainte montagne, dites: 'Oui, il est saint, le Seigneur notre Dieu!'"
}`)
	CurrentBook.AddChapter(100, `{
"1":"Psaume de louange. Terre entière, acclame le Seigneur!"
,"2":"Venez le servir dans la joie, venez à lui, et que ce soit la fête!"
,"3":"Sachez que c'est lui, Yahvé, qui est Dieu, il nous a faits et nous sommes à lui, son peuple, le troupeau de son pâturage."
,"4":"Passez ses portes en rendant grâce, sur ses parvis chantez sa louange. Rendez-lui grâce et bénissez son nom:"
,"5":"'Le Seigneur est bon, sa grâce est pour toujours, sa fidélité demeure d'âge en âge.'"
}`)
	CurrentBook.AddChapter(101, `{
"1":"De David. Psaume. Je veux chanter la bonté, la justice, mon psaume sera pour toi, Seigneur."
,"2":"Je veux m'entraîner pour la voie parfaite; mais toi, viendras-tu vers moi?,Je n'aurai que des intentions droites pour agir en ma maison."
,"3":"Je n'aurai rien en vue qui puisse être mauvais. Je hais la conduite des dévoyés, elle ne prendra pas sur moi."
,"4":"L'homme au coeur pervers devra s'écarter: je ne veux rien savoir du mal."
,"5":"Celui qui diffame en secret son prochain, je le ferai taire. L'homme aux yeux arrogants, plein d'orgueil en son coeur, je ne le supporterai pas."
,"6":"Je chercherai en ce pays parmi tes fidèles ceux qui demeureront avec moi. Celui qui suit la voie parfaite, je le mettrai à mon service."
,"7":"Je ne garderai pas dans ma maison un homme qui agit par-dessous: celui qui ment devra laisser sa place: je ne veux pas le voir."
,"8":"Tous les matins je nettoierai, je supprimerai les méchants du pays, pour en finir, dans la cité de Dieu, avec tous ceux qui font le mal."
}`)
	CurrentBook.AddChapter(102, `{
"1":"Prière d'un malheureux, accablé, qui fait monter sa plainte vers Yahvé."
,"2":"Seigneur, entends ma prière, que mon cri parvienne jusqu'à toi."
,"3":"Ne me cache pas ta face au jour de mon malheur, tends l'oreille vers moi le jour où j'appelle, hâte-toi de me répondre."
,"4":"Car mes jours s'en vont en fumée, mes os se consument comme braise,"
,"5":"mon coeur est comme l'herbe battue, desséchée. C'est que j'oublie de manger mon pain, "
,"6":"à force de crier ma plainte, et mes os se voient à travers la peau."
,"7":"Je suis pareil au pélican du désert, comme le hibou sur ses ruines."
,"8":"Je veille et je gémis comme l'oiseau solitaire sur son toit."
,"9":"Tout le jour mes ennemis m'insultent, ceux qui m'en veulent me maudissent."
,"10":"J'ai remplacé mon pain par la cendre, et mes larmes se mêlent à ma boisson,"
,"11":"à cause de ta colère, de ton emportement, car tu m'as déraciné et rejeté."
,"12":"Mes jours s'effacent comme une ombre, et comme l'herbe je me dessèche."
,"13":"Mais toi, Seigneur, tu sièges à jamais et d'âge en âge on a recours à toi."
,"14":"Il faut que tu te lèves: aie pitié de Sion, car le temps est venu où tu dois faire grâce."
,"15":"Vois que tes serviteurs s'attachent à ses pierres et souffrent quand ils voient sa poussière."
,"16":"Mais agis: les nations craindront ton Nom, Seigneur, tous les rois de la terre reconnaîtront ta gloire,"
,"17":"quand le Seigneur rebâtira Sion et qu'on l'y verra dans sa gloire."
,"18":"Car il aura accueilli la prière des pauvres, il ne l'aura pas méprisée."
,"19":"Ecrivez-le pour la génération qui vient: 'Un peuple qu'il aura formé louera le Seigneur.'"
,"20":"Car de là-haut où tout est saint, il s'est penché, des cieux le Seigneur a regardé la terre"
,"21":"pour entendre les soupirs du captif, pour libérer celui qui allait à la mort,"
,"22":"pour que Sion s'emplisse du renom du Seigneur, et Jérusalem, de sa louange."
,"23":"Alors se joindront les peuples, et les nations serviront le Seigneur."
,"24":"Il a permis que ma marche m'épuise, il a abrégé mes jours"
,"25":"et je lui dis: 'Mon Dieu, ne me prends pas au milieu de ma vie, tes années à toi durent bien d'âge en âge!"
,"26":"Voici longtemps que tu as fait la terre, les cieux sont l'oeuvre de tes mains."
,"27":"Vont-ils passer? Même alors tu resterais. Ils peuvent bien s'user comme un vêtement, tu les remplaces comme un habit, ils cèdent la place."
,"28":"Mais toi, tu Es, tes années n'ont pas de fin."
,"29":"Les fils de tes serviteurs demeureront, et leur race te servira toujours."
}`)
	CurrentBook.AddChapter(103, `{
"1":"De David. Mon âme, bénis le Seigneur, que tout en moi bénisse son saint nom!"
,"2":"Mon âme, bénis le Seigneur, et n'oublie aucun de ses bienfaits."
,"3":"C'est lui qui pardonne tes fautes, lui qui te guérit de toute maladie,"
,"4":"lui qui retient ta vie quand la mort te réclame, et te laisse parée de sa grâce, de sa tendresse."
,"5":"Il remplit de ses bienfaits ton existence, et renouvelle comme à l'aigle ta jeunesse."
,"6":"Le Seigneur intervient pour la justice, il rend à tous les opprimés leur dû."
,"7":"Il a révélé à Moïse ses voies, les enfants d'Israël ont vu ses exploits."
,"8":"Le Seigneur est tendresse et compassion, lent à la colère, riche en grâce."
,"9":"S'il dispute, ce ne sera pas sans fin, s'il garde rancune, cela n'aura qu'un temps."
,"10":"Il ne nous traite pas à la mesure de nos péchés, il ne réclame pas ce que méritent nos fautes."
,"11":"Vois la hauteur des cieux par-dessus la terre: aussi haute est sa bonté, elle couvre ceux qui le craignent."
,"12":"Vois quelle distance de l'orient à l'occident: c'est la distance qu'il met entre nos fautes et nous."
,"13":"La tendresse d'un père pour ses enfants, c'est la tendresse du Seigneur pour ceux qui le craignent."
,"14":"Lui sait de quoi nous sommes faits, il n'oublie pas que nous sommes poussière."
,"15":"L'homme de terre, ses jours sont comme l'herbe, il donne sa fleur, comme la fleur des champs."
,"16":"Qu'un souffle passe sur lui, il n'est plus, son coin de terre ne le reverra plus."
,"17":"Mais la grâce du Seigneur, depuis toujours et pour toujours est sur ceux qui le craignent. Il défendra jusqu'aux enfants de leurs enfants "
,"18":"s'ils gardent son alliance, s'ils pensent à mettre en oeuvre ses consignes."
,"19":"Le Seigneur a déjà son trône dans les cieux, il règne, il a pouvoir sur tout."
,"20":"Bénissez le Seigneur, vous ses anges, ses gardes puissants, vous qui accomplissez ses ordres dès que résonnent ses paroles!"
,"21":"Bénissez le Seigneur, toutes ses armées, ses serviteurs, au service de ses volontés!"
,"22":"Bénissez le Seigneur, vous toutes ses oeuvres, dans tous les lieux où s'exerce sa puissance! Toi aussi, mon âme, bénis le Seigneur!"
}`)
	CurrentBook.AddChapter(104, `{
"1":"Mon âme, bénis le Seigneur!,Seigneur, mon Dieu, tu es si grand, paré de gloire et de majesté!"
,"2":"Tu t'es fait de la lumière un manteau, les cieux sont les tentures de ta demeure,"
,"3":"au-dessus de leurs eaux s'élèvent tes chambres hautes. Tu fais des nuées ton char,lorsque tu t'avances sur les ailes du vent."
,"4":"Tu prends les vents pour messagers, les éclairs de feu sont tes serviteurs."
,"5":"Tu as posé la terre sur ses bases, rien ne viendra l'ébranler jamais."
,"6":"Tu l'as couverte du manteau des océans, avec des eaux en réserve au haut des monts;"
,"7":"à ta menace elles fuient: ton tonnerre se fait entendre, elles se précipitent."
,"8":"Elles gravissent les monts, descendent les vallées, courant au lieu que tu leur as indiqué."
,"9":"Tu as fixé les bornes qu'elles ne passeront pas: elles ne reviendront plus pour submerger la terre."
,"10":"Tu conduis vers les ravins les eaux des sources, elles cheminent entre les montagnes"
,"11":"pour abreuver tout ce qui vit sur terre: les ânes sauvages y étanchent leur soif."
,"12":"Les oiseaux du ciel s'arrêtent aux abords,et dans la ramure lancent leurs appels."
,"13":"Du haut de tes demeures tu abreuves les monts, la terre se rassasie de tes oeuvres."
,"14":"Tu fais pousser l'herbe pour le bétail, et les plantes où l'homme aura son travail. Il fera sortir de la terre le pain,"
,"15":"le vin aussi, qui réjouit le coeur de l'homme. L'huile fera briller son visage, le pain lui donnera du coeur."
,"16":"Les arbres du Seigneur sont rassasiés, les cèdres du Liban qu'il a plantés lui-même."
,"17":"Les passereaux y font leur nid,et tout en haut la cigogne a sa maison."
,"18":"La haute montagne appartient aux chamois, le creux des roches est le refuge des damans."
,"19":"Tu as placé la lune pour le calendrier, le soleil, qui sait au moins l'heure de son coucher."
,"20":"Tu amènes les ténèbres et c'est la nuit: les bêtes de la forêt vont commencer leurs rondes."
,"21":"Les jeunes lions rugissent après la proie, dans leur langage ils réclament à Dieu leur manger."
,"22":"Quand le soleil se lève, ils se retirent,et vont au repos dans leurs demeures,"
,"23":"alors que l'homme sort pour sa tâche, pour son travail jusqu'au soir."
,"24":"Que tes oeuvres sont nombreuses, Seigneur, tu les fis toutes avec sagesse, remplissant le monde de tes inventions!"
,"25":"Voici la mer, grande, ouverte en tous sens, où fourmillent innombrables,les êtres vivants petits et grands."
,"26":"Les bateaux s'y risquent sans craindre Léviathan, le monstre que tu fis pour t'en amuser."
,"27":"Tous attendent de toi,que tu leur donnes la provende en son temps."
,"28":"Tu la leur donnes, ils la recueillent, tu ouvres ta main, et les voilà rassasiés."
,"29":"Tu caches ta face, ils ne sont plus; tu leur reprends le souffle, ils expirent,et retournent à leur poussière."
,"30":"Mais tu envoies ton souffle, ils sont créés, tu renouvelles la face de la terre."
,"31":"Que le Seigneur ait à jamais sa gloire, que le Seigneur jouisse de ses oeuvres,"
,"32":"lui qui regarde la terre, et elle tremble, et s'il touche aux montagnes, elles jettent le feu."
,"33":"Je veux toute ma vie chanter le Seigneur, le célébrer aussi longtemps que je serai."
,"34":"Mon poème peut-être plaira à mon Seigneur: moi, de toute façon, je suis content de lui."
,"35":"Que les pécheurs disparaissent de la terre, qu'on n'y voie plus de méchanceté!,Mais toi, ô mon âme, bénis le Seigneur!"
}`)
	CurrentBook.AddChapter(105, `{
"1":"Louez le Seigneur, invoquez son nom, faites connaître ses bienfaits parmi les peuples!"
,"2":"Chantez-le, célébrez-le et méditez tous ses hauts faits."
,"3":"Soyez fiers de son nom très saint, ayez la joie au coeur, vous qui cherchez le Seigneur."
,"4":"Recherchez le Seigneur, ce sera votre force, recherchez le Seigneur toujours."
,"5":"Rappelez-vous les miracles qu'il a faits, ses prodiges, les sentences qu'il a prononcées,"
,"6":"race d'Abraham, son serviteur, enfants de Jacob, son élu!"
,"7":"Il est le Seigneur, il est notre Dieu, ses décisions touchent la terre entière."
,"8":"N'oubliez jamais son alliance, cette parole imposée à mille générations."
,"9":"Il l'a donnée à Abraham, il l'a promise par serment à Isaac."
,"10":"Il lui a donné force de loi en Jacob, et c'est pour Israël une alliance à jamais:"
,"11":"'Je te donnerai la terre de Canaan, elle sera ta part d'héritage.'"
,"12":"Ils n'étaient guère nombreux dans ce pays, des étrangers, bien peu de chose."
,"13":"Ils erraient de nation en nation, après chaque royaume, c'était un autre peuple."
,"14":"Mais il n'a pas permis qu'on les opprime, reprenant à cause d'eux, même des rois:"
,"15":"'Ne touchez pas à ceux qui me sont consacrés, ce sont mes prophètes, ne leur faites pas de mal!'"
,"16":"Il fit venir le malheur sur le pays, il leur coupa les vivres."
,"17":"Il leur envoya l'homme qui serait à leur tête: Joseph, vendu comme esclave."
,"18":"Il fut humilié, avec des fers aux pieds et la chaîne qui pesait sur son cou,"
,"19":"jusqu'au jour où il commença à par- ler: la parole du Seigneur le fit reconnaître."
,"20":"Le roi envoya le délier, le souverain des peuples le fit délivrer."
,"21":"Il fit de lui le maître de sa maison, le seigneur de tout son domaine,"
,"22":"pour donner en son nom des instructions aux princes, et à ses conseillers, des leçons de sagesse."
,"23":"Et voici qu'Israël entra en Egypte, Jacob vint séjourner en terre de Kam."
,"24":"Dieu voulut que son peuple se multiplie, il le rendit plus fort que ses adversaires."
,"25":"Leur humeur changea: ils détestèrent son peuple, ils cherchèrent à nuire à ses serviteurs."
,"26":"Alors il envoya Moïse, son serviteur, avec Aaron qu'il s'était choisi."
,"27":"Il leur confia ses paroles, ses signes, ses prodiges sur tout le pays de Kam."
,"28":"Il envoya les ténèbres et tout devint ténèbres, rien ne put annuler sa parole."
,"29":"Il changea leurs eaux en sang, faisant mourir tous leurs poissons."
,"30":"Leur pays se retrouva couvert de grenouilles, jusque dans le palais de leurs rois."
,"31":"Une parole encore, et vinrent les moucherons, des insectes sur tout leur territoire."
,"32":"Au lieu de pluie il leur donna la grêle, et les feux de la foudre par tout le pays."
,"33":"Il frappa leurs vignes, leurs figuiers, il brisa tous leurs arbres."
,"34":"Une parole encore, ce furent les sauterelles, des hannetons sans nombre."
,"35":"Ils mangèrent dans le pays tout ce qui était vert, tous les produits de leur terre."
,"36":"Puis il frappa dans leur pays les premiers-nés, les premiers fruits de leur virilité."
,"37":"Il fit sortir son peuple chargé d'or et d'argent, et leurs tribus allaient sans aucun éclopé."
,"38":"L'Egypte était en joie de leur départ car la terreur était tombée sur elle."
,"39":"Il déploya la nuée comme un voile, avec un feu la nuit pour les éclairer."
,"40":"A leur demande il fit venir les cailles et le pain des cieux dont ils furent rassasiés."
,"41":"Il ouvrit le rocher, il fit jaillir les eaux, un torrent qui se perdait dans les sables."
,"42":"C'est qu'il se souvenait de sa parole sainte à Abraham, son serviteur."
,"43":"Il voulait que son peuple sorte dans la joie, que ses élus soient à la fête"
,"44":"quand il leur remettait la terre d'autres nations et leur donnait sans plus le travail d'autres peuples."
,"45":"Mais il voulait qu'ils y gardent ses lois et qu'ils observent ses préceptes."
}`)
	CurrentBook.AddChapter(106, `{
"1":"Alléluia! Louez le Seigneur car il est bon, car sa faveur jamais ne se reprend!"
,"2":"Qui redira les hauts faits du Seigneur et nous fera entendre toute sa louange?"
,"3":"Heureux ceux qui se règlent sur ses lois, et dont les oeuvres sont droites en tout temps!"
,"4":"Souviens-toi de moi, Seigneur, toi qui aimes ton peuple, que ta visite apporte ton salut!"
,"5":"Fais-nous voir enfin tes élus heureux, que notre joie soit la joie de tout ton peuple, et notre orgueil celui de ta famille!"
,"6":"Nous avons péché, nous et nos pères, nous sommes en faute et coupables."
,"7":"Nos pères déjà, en Egypte, n'ont rien compris à tes miracles. Ils ont vite oublié tes grâces sans nombre, ils se sont révoltés à la Mer des Joncs."
,"8":"Mais lui les a sauvés pour l'honneur de son nom, pour faire connaître au monde sa vaillance."
,"9":"Il menaça la Mer des Joncs: elle en resta sèche, et sur les fonds, ils marchèrent comme en un désert."
,"10":"Il ne les livra pas à leurs poursuivants, il les reprit de la main de l'ennemi."
,"11":"Les eaux recouvrirent leurs adversaires, pas un seul n'en réchappa."
,"12":"C'est alors qu'ils crurent à sa parole et qu'ils chantèrent sa louange."
,"13":"Mais bien vite ils oublièrent ses oeuvres et cessèrent de compter sur sa prévoyance."
,"14":"Leur convoitise se réveilla au désert, et dans la steppe ils mirent Dieu à l'épreuve."
,"15":"Il leur donna ce qu'ils demandaient, il leur en envoya jusqu'à les dégoûter."
,"16":"On les vit dans leur camp, jaloux de Moïse et d'Aaron, l'homme consacré au Seigneur."
,"17":"La terre s'ouvrit alors pour engloutir Datan, elle se referma sur la bande d'Abiron."
,"18":"Un feu s'enflamma contre leur groupe, une flamme dévora ces méchants."
,"19":"Puis ils firent à l'Horeb un veau et se prosternèrent devant leur idole."
,"20":"Ils échangèrent leur Gloire contre l'image d'un boeuf mangeur d'herbe,"
,"21":"oubliant le Dieu qui les avait sauvés, celui qui fit de grandes choses en Egypte,"
,"22":"des miracles au pays de Kam, un prodige inouï à la Mer des Joncs!"
,"23":"Déjà il parlait de les exterminer, mais Moïse, son élu, était là. Il se tint sur la brèche face à lui, pour empêcher que sa fureur ne les détruise."
,"24":"Ils firent peu de cas d'une terre de délices, car ils ne croyaient pas à sa promesse."
,"25":"Ils restaient à récriminer dans leurs tentes, au lieu d'entendre l'appel du Seigneur,"
,"26":"jusqu'à ce qu'il levât sa main. Il jura qu'il les ferait mourir au désert"
,"27":"et disperserait leur race parmi les païens, qu'il les sèmerait partout sur toutes les terres."
,"28":"Ils se mirent à la traîne du Baal de Péor et mangèrent ce qu'on offre à des morts."
,"29":"Ils l'agacèrent si bien avec leurs pratiques, qu'un fléau éclata contre eux."
,"30":"Ce fut l'heure de Pinhas: il intervint et le fléau cessa."
,"31":"Ce fut là son mérite, on le lui reconnut, d'âge en âge on le rappellera."
,"32":"Ils l'irritèrent aux eaux de Mériba, Moïse y fut victime de leur faute"
,"33":"quand ils aigrirent son esprit, et lui, parla comme il ne fallait pas."
,"34":"Ils ne firent pas disparaître les païens, comme le Seigneur le leur demandait."
,"35":"Ils se mélangeaient avec les païens, ils apprenaient leurs façons de faire."
,"36":"Ils rendaient un culte à leurs pieux sacrés et ils se laissaient prendre,"
,"37":"si bien qu'ils sacrifiaient leurs fils et leurs filles à des démons."
,"38":"Ils répandaient le sang innocent (le sang de leurs fils et de leurs filles sacrifiés aux idoles de Canaan) et laissaient la terre souillée de sang."
,"39":"Ils se souillaient en faisant de telles choses, ils se prostituaient avec de telles pratiques."
,"40":"Et le Seigneur s'emporta contre son peuple, il prit les siens en horreur."
,"41":"Il les livra au pouvoir des nations et ceux qui les haïssaient les dominèrent."
,"42":"Leurs ennemis les opprimèrent, ils durent se courber sous le joug."
,"43":"Combien de fois ne les a-t-il pas délivrés! Mais eux rejetaient ses avis et s'enfonçaient dans leurs torts."
,"44":"Dès qu'il les voyait dans la détresse, dès qu'il entendait leurs cris,"
,"45":"il se rappelait son alliance avec eux et se laissait fléchir par sa grande bonté."
,"46":"Alors il les faisait prendre en pitié par ceux qui les tenaient captifs."
,"47":"O Seigneur notre Dieu, sauve-nous, rassemble-nous de toutes les nations, que nous puissions célébrer ton saint Nom et que notre gloire soit de te louer."
,"48":"Béni soit le Seigneur, le Dieu d'Israël, depuis toujours et à jamais!,Et le peuple entier dira: Amen!"
}`)
	CurrentBook.AddChapter(107, `{
"1":"Louez le Seigneur car il est bon, éternel est son amour!"
,"2":"Dites-le, vous qu'il a rachetés, vous qu'il a repris à l'adversaire,"
,"3":"vous qu'il a rassemblés de toutes les terres, du levant et du couchant, du midi et du nord!"
,"4":"Ils erraient par le désert, au long des steppes, sans trouver le chemin d'une ville d'étape."
,"5":"Ils avaient faim; la soif surtout faisait défaillir en eux leur âme."
,"6":"Mais dans l'angoisse ils crièrent vers le Seigneur, et il les tira de leur détresse."
,"7":"Il les fit cheminer par un droit chemin jusqu'à trouver une ville où pouvoir s'arrêter."
,"8":"Qu'ils célèbrent le Seigneur pour sa grâce, pour ses miracles en faveur des humains!"
,"9":"Car il a désaltéré la gorge assoiffée, il a comblé de biens les affamés."
,"10":"Ils étaient là en un monde de ténèbres, rivés à la misère, rivés à leurs fers,"
,"11":"pour n'avoir pas écouté les paroles de Dieu, pour avoir méprisé les avis du Très-Haut."
,"12":"Il les avait brisés par les épreuves, ils chancelaient et nul ne les secourait."
,"13":"Mais dans l'angoisse ils crièrent vers le Seigneur: lui les tira de leur détresse."
,"14":"Il les fit sortir du noir, des ténèbres: il avait rompu leurs chaînes!"
,"15":"Qu'ils célèbrent le Seigneur pour sa grâce, pour ses miracles en faveur des humains!"
,"16":"Car il a brisé les portes de bronze, il a mis en pièces les verrous de fer."
,"17":"Ils faisaient les fous sur les chemins du péché, puis ils devaient payer leurs fautes."
,"18":"Ils ne supportaient plus aucun aliment, ils étaient arrivés aux portes de la mort."
,"19":"Mais dans l'angoisse ils crièrent vers le Seigneur et il les tira de leur détresse."
,"20":"Il envoya sa parole: elle les remit sur pied et les fit échapper à la tombe."
,"21":"Qu'ils célèbrent le Seigneur pour sa grâce, pour ses miracles en faveur des humains!"
,"22":"Qu'ils lui offrent un sacrifice de louange, que dans leur joie ils disent et proclament ses oeuvres,"
,"23":"ceux qui descendent en mer sur des navires, pour leur négoce au-delà de l'océan!"
,"24":"Ceux-là ont vu le travail du Seigneur et ses miracles sur les abîmes."
,"25":"Car à son ordre une bourrasque s'est levée, qui soulevait les vagues de la mer."
,"26":"Portés aux cieux, retombant dans les abîmes, leur âme fondait dans les malaises."
,"27":"Pris de vertige, ils titubaient comme un ivrogne, leur sagesse était toute avalée."
,"28":"Mais dans l'angoisse ils crièrent vers le Seigneur, et il les tira de leur détresse."
,"29":"Il rétablit le calme après la tempête, il apaisa les flots."
,"30":"Quelle joie pour eux quand l'onde fut tranquille, et qu'il les mena au port désiré!"
,"31":"Qu'ils célèbrent le Seigneur pour sa grâce, pour ses miracles en faveur des humains!"
,"32":"Qu'ils l'exaltent dans l'assemblée du peuple et disent ses louanges au conseil des Anciens."
,"33":"Il épuise le fleuve et c'est le désert, là où étaient les sources, il n'y a que la steppe;"
,"34":"les riches terres se couvrent de sel pour les crimes de leurs habitants."
,"35":"Il crée un lac au milieu du désert, et la terre aride se voit irriguée,"
,"36":"pour qu'y habitent ceux qui avaient faim, et qu'ils y bâtissent leur cité."
,"37":"Ils ensemencent leurs champs et plantent des vignes, ils en récoltent les fruits."
,"38":"Il les bénit pour qu'ils se multiplient, et leur bétail ne dépérit pas."
,"39":"Car ils étaient amoindris, prostrés, plongés dans le malheur et la peine."
,"40":"Mais lui, qui déverse le mépris sur les grands et fait qu'ils se perdent en un désert sans chemin,"
,"41":"il relève le pauvre en sa misère: sa famille prospère et se multiplie."
,"42":"Que l'homme droit regarde et se réjouisse, mais tout ce qui est vil ne pourra que se taire."
,"43":"Qui aura la sagesse de méditer ces choses, qui saura reconnaître les bontés du Seigneur?"
}`)
	CurrentBook.AddChapter(108, `{
"1":"Cantique. Psaume. De David."
,"2":"Mon coeur est prêt, ô Dieu, mon coeur est prêt, je veux chanter et jouer pour toi."
,"3":"Que ma flamme s'éveille, éveillez-vous, harpe et cithare, que je fasse, moi, lever l'aurore!"
,"4":"Je te louerai, Seigneur, parmi les peuples, je jouerai pour toi dans toutes les provinces,"
,"5":"car ta grâce est à la hauteur des cieux, et ta vérité s'élève jusqu'aux nuées."
,"6":"O Dieu, montre-toi au-dessus des cieux, que ta Gloire se lève sur la terre entière!"
,"7":"Délivre maintenant ceux que tu aimes,"
,"8":"Dieu a parlé dans son sanctuaire: 'Je suis en forme, je m'en vais partager Sichem, et lotir la vallée des Tentes."
,"9":"Je prends avec moi Galaad et Manassé; Ephraïm aussi, il sera mon casque, et Juda, mon bâton de commandement."
,"10":"Alors Moab sera ma cuvette, pour m'y laver; je jetterai ma sandale sur Edom, je lancerai le cri de guerre contre les Philistins!'"
,"11":"Qui donc nous mènera à la ville forte, qui nous conduira jusqu'en terre d'Edom?"
,"12":"Qui, sinon toi, ô Dieu? Mais tu nous as rejetés, tu ne sors plus avec nos troupes."
,"13":"Aide-nous contre l'oppresseur, car rien n'est décevant comme un secours humain."
,"14":"Avec Dieu nous ferons des merveilles, et lui écrasera nos adversaires."
}`)
	CurrentBook.AddChapter(109, `{
"1":"Au maître de chant. De David. Psaume. O Dieu que je célèbre, ne garde pas le silence "
,"2":"face aux attaques d'une bouche méchante: d'une langue qui ment aussitôt qu'elle me parle,"
,"3":"Ce sont autour de moi des paroles de haine, c'est une guerre continuelle, sans raison."
,"4":"On m'accuse alors que je prie,"
,"5":"on me rend le mal pour le bien et la haine au lieu de l'amour."
,"6":"Fais-lui rendre compte à un homme méchant, avec un accusateur debout à sa droite."
,"7":"Que la sentence le déclare coupable, et qu'en appel de nouveau on le condamne!"
,"8":"Que sa vie soit écourtée, et que sa charge passe à un autre!"
,"9":"Que ses enfants restent sans père et sa femme sans mari!"
,"10":"Que ses fils aillent quêter de place en place, et qu'on les chasse de leur masure!"
,"11":"Que son créancier enlève tout chez lui, que des étrangers prennent ce qui lui a coûté!"
,"12":"Que personne ne lui fasse grâce, que nul n'ait pitié de ses orphelins!"
,"13":"Que ses descendants soient exterminés, qu'en une génération son nom soit effacé!"
,"14":"Que le Seigneur se rappelle la faute de ses pères, que le péché de sa mère ne puisse s'effacer,"
,"15":"et reste toujours sous les yeux du Seigneur jusqu'à ce que tous aient disparu de la terre!"
,"16":"Car il n'a pas songé à faire grâce, il a poursuivi le pauvre, l'indigent et le désemparé, jusqu'à la mort."
,"17":"Il aimait les malédictions: elles seront pour lui. Il n'appelait pas la bénédiction: elle restera loin de lui."
,"18":"Il faisait de la malédiction sa chemise, elle entrera en lui comme de l'eau, elle passera, comme l'huile, jusqu'à ses os."
,"19":"Elle l'enveloppera comme son vêtement, elle sera la ceinture qui ne le quittera plus."
,"20":"Que le Seigneur paie ce salaire à ceux qui m'accusent, à ceux qui me calomnient!"
,"21":"Et puis pour moi, Seigneur, fais honneur à ton nom et sauve-moi, car tu es bon,"
,"22":"car je suis pauvre et malheureux, et j'en porte au-dedans de moi la blessure."
,"23":"Je m'en vais comme une ombre qui décline, comme la sauterelle emportée par le vent."
,"24":"J'ai tant jeûné que mes genoux chancellent, mon corps amaigri n'a plus un soupçon de graisse."
,"25":"Je suis un prétexte pour leurs insultes, et quand ils me voient, ils se font des signes."
,"26":"Viens à mon aide, Seigneur, sauve-moi car tu es bon,"
,"27":"et qu'ils reconnaissent là ta main, qu'ils voient que c'est ton oeuvre."
,"28":"Ils ont beau maudire, toi tu béniras: mes adversaires seront confondus, et ton serviteur sera dans la joie."
,"29":"Que ceux qui m'accusent soient couverts de mépris, que la honte soit sur eux comme leur manteau!"
,"30":"Et moi je rendrai grâce au Seigneur plus qu'un peu, je le louerai au milieu de la foule:"
,"31":"parce qu'il s'est tenu à la droite du pauvre et qu'il l'a sauvé face à ses juges."
}`)
	CurrentBook.AddChapter(110, `{
"1":"De David. Psaume. Le Seigneur a dit à mon Seigneur: 'Siège à ma droite, et vois comme je fais de tes ennemis ton marchepied.'"
,"2":"De Sion le Seigneur étend ton sceptre, ta puissance, domine au milieu de tes ennemis!"
,"3":"'Toute noblesse est en toi,depuis le jour de ta naissance au mont sacré; tu es né de moi, comme de l'aurore la rosée.'"
,"4":"Le Seigneur a juré, il ne peut se reprendre: 'Tu es prêtre à jamais, à la manière de Melquisédek!'"
,"5":"Le Seigneur est à ta droite,pour briser les rois au jour de sa colère."
,"6":"Il juge les nations: on ne voit que cadavres,et leurs têtes brisées sur la plaine immense."
,"7":"Il a bu au torrent, sur le chemin, c'est pourquoi il relèvera la tête."
}`)
	CurrentBook.AddChapter(111, `{
"1":"Alléluia!,De tout coeur je louerai le Seigneur, quand se rencontrent les justes, et dans l'assemblée."
,"2":"Les oeuvres du Seigneur sont toujours grandes, ceux qui s'y plaisent les repensent sans cesse."
,"3":"Grandeur et splendeur, c'est là toute son oeuvre, sa justice tiendra à jamais."
,"4":"Il a voulu qu'on rappelle ses miracles, le Seigneur n'est-il pas tendresse et pitié?"
,"5":"Il a nourri ceux qui le craignent, toujours il se souvient de son alliance."
,"6":"Son peuple a vu sa force dans ses oeuvres,quand il leur a donné la terre des païens."
,"7":"Ses mains travaillent pour la fidélité, la justice, et ses décrets sont sûrs,"
,"8":"appuyés sur une base inébranlable,porteurs de vérité et de droiture."
,"9":"Il a envoyé à son peuple ses délivrances, il lui a prescrit son alliance éternelle: son Nom est saint et redoutable."
,"10":"La sagesse commence avec la crainte du Seigneur,bien avisés ceux qui en savent les pratiques!,Sa louange sera là pour toujours."
}`)
	CurrentBook.AddChapter(112, `{
"1":"Alléluia!,Heureux est l'homme qui craint le Seigneur,et qui tient par-dessus tout à ses préceptes!"
,"2":"C'est de la bonne race qu'il laissera dans le pays, les rejetons d'un homme droit seront bénis."
,"3":"Biens et richesses se trouvent en sa maison, son honnêteté y restera à jamais."
,"4":"Il est pour les coeurs droits lumière dans la nuit, il comprend, il a pitié, il est juste."
,"5":"Tout ira bien pour qui a pitié et prête,et mène ses affaires selon le droit."
,"6":"Rien ne viendra l'ébranler: la mémoire du juste jamais ne se perdra."
,"7":"Il ne redoute pas la mauvaise nouvelle, car son coeur est prêt, assuré dans le Seigneur."
,"8":"Son coeur a sur quoi s'appuyer, il ne craint pas, c'est lui qui, à la fin, méprisera l'adversaire."
,"9":"Il est généreux pour donner aux pauvres, cette justice restera à jamais, et sa grandeur se tournera en gloire."
,"10":"Le méchant voit, et cela lui fait mal, il en grince des dents, il en dépérit; les désirs des méchants, il n'en restera rien!"
}`)
	CurrentBook.AddChapter(113, `{
"1":"Alléluia!,Louez, serviteurs du Seigneur, louez le nom du Seigneur!"
,"2":"Car il faut bénir le nom du Seigneur,aujourd'hui et toujours."
,"3":"Des terres du levant jusques en occident,louez le nom du Seigneur!"
,"4":"Le Seigneur domine toutes les nations, sa gloire est bien au-dessus des cieux."
,"5":"Qui est semblable au Seigneur notre Dieu?,Il siège très haut, "
,"6":"mais il sait se pencher, il observe la terre aussi bien que le ciel."
,"7":"Il ramasse le pauvre à terre, il va chercher sur son fumier le miséreux,"
,"8":"pour lui donner un siège entre les grands, entre les nobles de son peuple."
,"9":"Il donne un foyer à la femme stérile, maintenant elle est mère, et joyeuse avec ses enfants!"
}`)
	CurrentBook.AddChapter(114, `{
"1":"Alléluia!,Quand Israël sortit d'Egypte, quand les fils de Jacob laissèrent ce peuple barbare,"
,"2":"Juda devint son sanctuaire, Israël devint son domaine."
,"3":"La mer le vit et s'enfuit, le Jourdain de même retourna en arrière."
,"4":"Les montagnes bondissaient comme des béliers, les collines, comme un troupeau."
,"5":"Que t'arrive-t-il, ô mer, tu t'enfuis?,Et toi, Jourdain, pourquoi retournes-tu?"
,"6":"Et vous montagnes, pourquoi sauter comme des béliers, et vous collines, comme des agneaux?"
,"7":"Tremble, terre, devant ton Maître, devant le Dieu de Jacob!"
,"8":"C'est lui qui change la rocaille en nappe d'eau, et par lui le rocher devient source."
}`)
	CurrentBook.AddChapter(115, `{
"1":"Ce n'est pas à nous, Seigneur, qu'il faut donner la gloire; non pas à nous mais à ton nom!"
,"2":"Veux-tu que les païens disent: 'Où est leur Dieu?'"
,"3":"Notre Dieu est dans les cieux, ce qui lui plaît il le fait."
,"4":"Mais leurs idoles ne sont qu'or et argent,travaillés par des mains humaines."
,"5":"Elles ont une bouche mais elles ne parlent pas, elles ont des yeux et elles ne voient pas,"
,"6":"des oreilles, et elles n'entendent pas, elles ont un nez et ne sentent rien."
,"7":"Elles ont des mains qui ne savent pas toucher, des pieds qui ne marchent pas, et un gosier qui ne donne aucun son."
,"8":"Que leurs fabricants deviennent comme elles,avec tous ceux qui se confient en elles!"
,"9":"Israël, mets ta confiance dans le Seigneur, il est pour vous secours et bouclier!"
,"10":"Maison d'Aaron, mets ta confiance dans le Seigneur, il est pour vous secours et bouclier!"
,"11":"Vous qui craignez le Seigneur, mettez en lui votre foi: il est pour vous secours et bouclier!"
,"12":"Le Seigneur ne nous oublie pas, il nous bénira: il bénira la maison d'Israël, il bénira la maison d'Aaron."
,"13":"Il bénira, petits ou grands, ceux qui le craignent."
,"14":"Que le Seigneur vous fasse bonne mesure, à vous et à vos enfants,"
,"15":"soyez bénis du Seigneur, créateur de la terre et des cieux!"
,"16":"Les cieux sont la demeure du Seigneur,mais il a donné aux fils d'Adam la terre."
,"17":"Sa louange ne lui vient pas des morts, ceux qui vont au silence ne louent pas le Seigneur."
,"18":"Mais c'est à nous de louer le Seigneur, dès aujourd'hui et toujours."
}`)
	CurrentBook.AddChapter(116, `{
"1":"Il me plaît que le Seigneur ait entendu,l'appel de ma prière,"
,"2":"qu'il ait tourné vers moi son oreille,le jour où je criais vers lui."
,"3":"Les filets de la mort se refermaient sur moi, j'étais pris au lacet fatal,et ne voyais plus qu'angoisse et tristesse."
,"4":"J'ai invoqué le nom du Seigneur: 'O Seigneur, sauve mon âme!'"
,"5":"Le Seigneur est vraiment bon, il est juste, notre Dieu est compatissant."
,"6":"Le Seigneur prend soin des humbles, il m'a sauvé, me voyant faible."
,"7":"Reviens, mon âme, à ton repos,car le Seigneur t'a pris en charge."
,"8":"Il a gardé mon âme de la mort, mes yeux n'ont pas connu les larmes, ni mon pied les faux pas."
,"9":"Je marcherai en présence du Seigneur,sur la terre des vivants."
,"10":"J'ai eu foi alors même que je disais: 'Je suis vraiment bien en peine.'"
,"11":"Alors j'ai dit dans mon trouble: 'Tout l'humain est déception!'"
,"12":"Comment rendrai-je au Seigneur,tant d'attentions pour moi?"
,"13":"J'élèverai la coupe pour une délivrance,et je célébrerai le Nom du Seigneur."
,"14":"J'accomplirai les voeux que je fis au Seigneur,et tout le peuple sera là."
,"15":"Il en coûte au Seigneur,de voir la mort de ses fidèles:"
,"16":"'Vois donc, Seigneur, je suis ton serviteur, ton serviteur et le fils de ta servante: tu as brisé mes liens!'"
,"17":"Je t'offrirai le sacrifice d'action de grâce,et je célébrerai le Nom du Seigneur."
,"18":"J'accomplirai mes voeux que je fis au Seigneur,et tout le peuple sera là,"
,"19":"dans les parvis de la maison du Seigneur,et tout alentour dans Jérusalem."
}`)
	CurrentBook.AddChapter(117, `{
"1":"Alléluia!,Louez le Seigneur en toutes les nations, fêtez-le tous, peuples et peuplades!"
,"2":"Car sa bonté pour nous s'est surpassée, la fidélité du Seigneur est là à jamais."
}`)
	CurrentBook.AddChapter(118, `{
"1":"Alléluia!,Louez le Seigneur car il est bon, sa grâce est là pour toujours."
,"2":"Israël peut le dire: sa grâce est là pour toujours!"
,"3":"Les fils d'Aaron peuvent le dire: sa grâce est là pour toujours!"
,"4":"Ceux qui craignent le Seigneur peuvent aussi le dire: sa grâce est là pour toujours!"
,"5":"Dans mon angoisse je l'ai invoqué, il m'a répondu, il m'a mis au large."
,"6":"Si le Seigneur est pour moi, je n'ai pas peur, que peuvent-ils me faire?"
,"7":"Le Seigneur est pour moi, parmi mes alliés, et je verrai mes ennemis à mes pieds."
,"8":"Il est bon d'espérer dans le Seigneur,plutôt que de compter sur des hommes."
,"9":"Il est bon d'espérer dans le Seigneur,plutôt que de compter sur les grands."
,"10":"Tous les païens m'entouraient: mais pour le nom du Seigneur je les ai mis au pas."
,"11":"Ils m'entouraient, ils m'avaient encerclé: mais pour le nom du Seigneur je les ai mis au pas."
,"12":"Ils m'entouraient comme des guêpes, mais ce ne fut qu'une flambée d'épines, car au nom du Seigneur je les ai mis au pas."
,"13":"On m'a poussé, bien poussé pour me mettre à terre, mais le Seigneur m'a secouru."
,"14":"Il est ma force et c'est lui que je chante, car lui m'a sauvé."
,"15":"Ecoutez dans les tentes des justes,les cris de joie et de triomphe: 'La droite du Seigneur s'est surpassée,"
,"16":"la droite du Seigneur l'a emporté, la droite du Seigneur s'est surpassée!'"
,"17":"Je ne mourrai pas, mais je vivrai,et je dirai les hauts faits du Seigneur."
,"18":"Le Seigneur m'a bien corrigé, mais il ne m'a pas livré à la mort."
,"19":"Ouvrez-moi les portes du Juste, car je veux entrer et le louer!"
,"20":"- C'est ici la porte qui mène au Seigneur, les justes pourront la passer."
,"21":"- Je veux te rendre grâces car tu m'as entendu, tu t'es fait mon sauveur!"
,"22":"- La pierre rejetée par les bâtisseurs,est devenue pierre d'angle."
,"23":"C'est là l'oeuvre du Seigneur, nos yeux ne pouvaient le croire."
,"24":"Voici le jour qu'a fait le Seigneur, soyons tout à la joie, à la fête!"
,"25":"O Seigneur, sauve-nous, Seigneur, délivre-nous!"
,"26":"'Béni soit celui qui vient au nom du Seigneur: de la maison du Seigneur nous vous bénissons."
,"27":"Que le Seigneur Dieu soit pour nous lumière!',Rangez la procession, rameaux en mains,jusqu'aux cornes de l'autel."
,"28":"Tu es mon Dieu, je veux te louer; ô Dieu, je dis que tu es grand!"
,"29":"- Louez le Seigneur car il est bon, car sa grâce est là pour toujours."
}`)
	CurrentBook.AddChapter(119, `{
"1":"Heureux ceux qui suivent sans erreur la voie, marchant selon la Loi du Seigneur."
,"2":"Heureux ceux qui observent tes avis et qui les recherchent de tout leur coeur."
,"3":"Ils ne commettront pas d'injustice tant qu'ils iront par tes chemins."
,"4":"Tu as prescrit tes ordonnances: il faut les observer avant tout."
,"5":"Je voudrais que ma marche soit sûre quand j'observe tes préceptes."
,"6":"Alors je n'aurai pas honte quand je me rappellerai tes commandements."
,"7":"Je veux apprendre tes justes jugements, afin de te louer d'un coeur pur."
,"8":"Je veux garder tes préceptes, ne m'abandonne pas entièrement."
,"9":"Comment, dès la jeunesse, purifier son chemin? Il suffit d'observer tes paroles."
,"10":"De tout mon coeur je t'ai cherché, ne me laisse pas dévier de tes commandements."
,"11":"J'ai enfoui tes paroles en mon coeur car je ne veux pas pécher."
,"12":"Béni sois-tu, Seigneur, enseigne-moi tes préceptes!"
,"13":"J'ai sur les lèvres et je récite toutes les décisions de ta bouche."
,"14":"J'ai pris plaisir à suivre tes avis, ils me sont un trésor."
,"15":"Je veux méditer tes ordonnances et garder à la vue tes sentiers."
,"16":"Tes préceptes font ma joie, comment oublierais-je tes paroles?"
,"17":"Prends-moi en charge, que je vive: je veux observer tes paroles."
,"18":"Ouvre mes yeux pour que je voie toutes les merveilles de ta Loi."
,"19":"Je vis sur terre en étranger, ne me cache pas tes commandements."
,"20":"En tout temps mon âme désire jusqu'à l'obsession tes commandements."
,"21":"Tu as laissé des menaces pour les arrogants, ces maudits qui désertent tes commandements."
,"22":"Epargne-moi le mépris et la honte, alors que je tiens compte de tes avis."
,"23":"Même si des officiels me cherchaient des prétextes, ton serviteur reviendrait à tes préceptes."
,"24":"Tes avis sont ma joie, tes préceptes sont mes conseillers."
,"25":"Mon âme est collée à la poussière, redonne-moi vie comme tu l'as promis."
,"26":"Je t'ai exposé mes voies et tu m'as répondu: enseigne-moi tes préceptes."
,"27":"Fais que je découvre la voie de tes volontés, car je voudrais méditer sur tes merveilles."
,"28":"Mon âme est déprimée de chagrin, relève-moi selon ta promesse."
,"29":"Eloigne de moi le chemin des illusions, que ta Loi me fasse vivre."
,"30":"J'ai choisi un chemin de vérité et j'ai désiré tes décisions."
,"31":"Je me suis attaché, Seigneur, à tes avis, que je ne sois pas déçu!"
,"32":"Sur le chemin de tes commandements je cours, car tu y mets mon coeur au large."
,"33":"Enseigne-moi, Seigneur, la voie de tes préceptes: comme je voudrais les garder jusqu'au bout!"
,"34":"Donne-moi l'intelligence, que je garde ta Loi, de tout coeur je voudrais l'observer."
,"35":"Fais-moi cheminer par la voie de tes commandements, car c'est là que je me plais."
,"36":"Fais que mon coeur penche vers tes avis et non pas du côté du gain."
,"37":"Que mes regards ne s'arrêtent pas sur ce qui est vain, et je vivrai grâce à ta parole."
,"38":"Tiens ta promesse avec ton serviteur, puisque tu as parlé pour ceux qui te craignent."
,"39":"Fais passer loin de moi le mépris dont j'ai peur, car tes décisions sont pour mon bien."
,"40":"Vois que je recherche tes volontés, toi qui es le Juste, donne-moi la vie."
,"41":"Que ta grâce, Seigneur, vienne à moi, et ton salut selon ta promesse."
,"42":"Que je puisse répondre à celui qui se moque, car je n'ai pas cessé de compter sur ta parole."
,"43":"Je redirai sans cesse la parole de vérité, car j'espère en tes décisions."
,"44":"Comme je voudrais observer ta Loi, toujours, sans cesse et sans fin."
,"45":"Je serai à l'aise en tous mes chemins, car je m'attacherai à tes volontés."
,"46":"Je redirai tes avis en présence des rois, je n'aurai nulle honte."
,"47":"Je me suis plu en tes commandements et je les aimés."
,"48":"Je lèverai les mains vers toi et je méditerai tes préceptes."
,"49":"Rappelle-toi ta promesse à ton serviteur: elle maintenait mon espérance."
,"50":"C'est là mon réconfort dans mes peines: ta parole me fera vivre."
,"51":"Les orgueilleux ont eu beau me railler, je n'ai pas bougé de ta Loi."
,"52":"Car je me souviens de tes décisions passées, et cela, Seigneur, me réconforte."
,"53":"La fureur m'emporte quand je pense aux méchants: pourquoi abandonnent-ils ta Loi?"
,"54":"Tes préceptes sont devenus ma chanson dans la demeure où l'on me reçoit."
,"55":"De nuit ton nom me revient, Seigneur, et la volonté d'observer ta Loi."
,"56":"Cela au moins me restera, que j'ai gardé tes préceptes."
,"57":"Je l'ai dit, Seigneur: 'Mon bien est là, dans l'attention à tes paroles.'"
,"58":"J'ai tout fait pour te disposer en ma faveur, aie compassion de moi selon ta parole."
,"59":"J'ai réfléchi sur mes façons d'agir, je remettrai mon pas dans tes sentiers."
,"60":"Plutôt en avance qu'en retard: c'est ainsi que j'obéis à tes commandements."
,"61":"Les infidèles ont bien des pièges pour me séduire, mais je n'ai pas oublié ta Loi."
,"62":"Dès la minuit je me lève, et je te rends grâce pour tes justes décisions."
,"63":"Je me suis lié à tous ceux qui te craignent et qui observent tes volontés."
,"64":"De ta grâce, Seigneur, la terre est pleine, enseigne-moi tes préceptes."
,"65":"Tu as été bon avec ton serviteur et tu l'avais promis, Seigneur."
,"66":"Tu m'enseigneras le bon sens et le savoir car j'ai foi en tes commandements."
,"67":"Avant d'être humilié je m'écartais, mais maintenant j'observe tes paroles."
,"68":"Toi qui es bon et bienfaisant, enseigne-moi tes préceptes."
,"69":"Les orgueilleux m'ont saturé de leurs sottises, mais de tout coeur j'ai observé tes volontés."
,"70":"Qu'ils restent avec leur conscience encrassée, c'est ta Loi qui fait mes délices."
,"71":"Il était bon pour moi que je sois humilié et que j'en vienne à apprendre tes préceptes."
,"72":"La Loi sortie de ta bouche fait mon bonheur, plus que des ruisseaux d'or et d'argent."
,"73":"Tes mains m'ont créé et mis en place, donne-moi l'intelligence pour apprendre tes préceptes."
,"74":"Ceux qui te craignent verront, ce sera leur joie, que j'ai bien fait d'espérer en tes paroles."
,"75":"Je sais, Seigneur, que tes décisions sont justes; tu étais dans le vrai quand tu m'as humilié."
,"76":"Que ta grâce vienne et me réconforte comme tu l'as promis à ton serviteur."
,"77":"Que tes miséricordes viennent me donner vie, car en ta Loi sont mes délices."
,"78":"Qu'ils aient honte, ces orgueilleux qui me calomnient alors que je vais méditant tes volontés."
,"79":"Que reviennent à moi ceux qui te craignent et connaissent tes déclarations."
,"80":"D'un coeur sans partage j'obéis à tes préceptes, je ne connaîtrai pas la déception."
,"81":"Mon âme s'est usée dans l'attente de ton salut, je n'ai fait qu'espérer en ta parole."
,"82":"Mes yeux se sont usés attendant ta réponse: quand viendras-tu me réconforter?"
,"83":"Je ne vaux guère mieux qu'un cuir enfumé, mais je n'ai toujours pas oublié tes préceptes."
,"84":"Qu'adviendra-t-il de ton serviteur, quand feras-tu justice de ceux qui me persécutent?"
,"85":"Les orgueilleux m'ont creusé des chausse-trapes, tout était en conflit avec ta Loi."
,"86":"Tous tes commandements sont vérité, ils me persécutent à tort, viens à mon secours!"
,"87":"Un peu plus, ils me laissaient à terre, je n'ai pas pour autant oublié tes volontés."
,"88":"Tu es si bon, donne-moi de vivre et d'observer tes déclarations."
,"89":"Ta parole, Seigneur, est pour toujours, elle reste là, dans les cieux."
,"90":"Ta vérité subsiste au fil des générations, n'as-tu pas fixé la terre, et elle demeure?"
,"91":"Elle tient jusqu'à présent, car c'est ta décision, et toutes choses te servent."
,"92":"Si je n'avais pas en ta Loi mon bonheur, déjà je serais mort de misère."
,"93":"Jamais je n'oublierai tes volontés, puisque tu m'y fais trouver la vie."
,"94":"Je suis à toi, sauve-moi, puisque j'ai recherché tes volontés."
,"95":"Les infidèles me guettaient pour me perdre, mais j'avais l'intelligence de tes préceptes."
,"96":"J'ai vu le bout de toute perfection, ton commandement va toujours au-delà."
,"97":"Que j'aime ta Loi, j'en fais tous les jours ma méditation."
,"98":"Ton commandement m'a fait plus sage que mes ennemis, car il est toujours à mon côté."
,"99":"Je vois plus loin que ceux qui m'enseignent: c'est grâce à tes sentences, car je les médite."
,"100":"J'ai dépassé les anciens en savoir, à force de me plier à tes volontés."
,"101":"J'ai retenu mes pas loin des sentiers du mal, car je voulais être fidèle à tes paroles."
,"102":"Je n'ai pas bougé de tes décisions: toi-même tu m'avais enseigné."
,"103":"Tes paroles sont douces à mon palais, plus que le miel à ma bouche."
,"104":"Tes volontés m'ont donné l'intelligence: j'ai détesté tous les chemins mensongers."
,"105":"Ta parole est une lampe pour mes pas, une lumière sur mon sentier."
,"106":"Je l'ai juré et je le ferai: je garderai tes justes décisions."
,"107":"J'ai été humilié plus qu'un peu, fais-moi revivre, Seigneur, selon ta promesse."
,"108":"Accueille, Seigneur, les voeux que je te fais, enseigne-moi tes décisions."
,"109":"Toujours je tiens en main mon âme et jamais je n'oublie ta Loi."
,"110":"Les méchants m'ont tendu un piège, mais je n'ai pas dévié de tes volontés."
,"111":"Tes avis sont pour toujours mon héritage, ils font la joie de mon coeur."
,"112":"J'ai incliné mon coeur à pratiquer tes lois, toujours et jusqu'au bout."
,"113":"Je hais les coeurs partagés et j'aime ta Loi."
,"114":"Tu es mon refuge et mon bouclier, mon espérance est en ta parole."
,"115":"Eloignez-vous de moi, agents du mal, que je garde les commandements de mon Dieu."
,"116":"Sois mon soutien, comme tu l'as dit, et je vivrai; ne déçois pas mon attente."
,"117":"Sois mon appui et je serai sauvé, et tes préceptes sans cesse feront mes délices."
,"118":"Tu méprises ceux qui renient tes préceptes, leurs projets ne sont qu'illusion."
,"119":"Les sans-loi du pays sont pour toi la scorie, je n'en aime que mieux tes déclarations."
,"120":"Ma chair s'effraie et tremble devant toi, tes jugements me remplissent de crainte."
,"121":"J'ai agi selon le droit et la justice, ne me livre pas aux violents."
,"122":"Soutiens la cause de ton serviteur, ne permets pas que les orgueilleux m'écrasent."
,"123":"Mes yeux se sont usés attendant ton salut et ta juste décision."
,"124":"Agis avec ton serviteur selon ta bonté, enseigne-moi tes préceptes."
,"125":"Je suis ton serviteur, ouvre mon intelligence et je connaîtrai tes déclarations."
,"126":"Il est temps d'agir, Seigneur, puisqu'on viole ta Loi."
,"127":"Je n'en aime que mieux tes commandements, plus que l'or et l'argent."
,"128":"Je me dirige en tout selon tes volontés, je hais les chemins mensongers."
,"129":"Tes volontés sont admirables et c'est bien pourquoi mon âme s'y tient."
,"130":"Présenter tes paroles, c'est donner la lumière et ouvrir l'intelligence des simples."
,"131":"Ma bouche voudrait s'ouvrir et aspirer ces commandements, tant je les désire."
,"132":"Tourne-toi vers moi, aie pitié de moi, car ce n'est que justice pour qui aime ton nom."
,"133":"Que ta parole affermisse mes pas, le mal pourrait être trop fort pour moi."
,"134":"Libère-moi, quand vient l'humaine oppression, si je peux ainsi observer tes volontés."
,"135":"Donne à ton serviteur la lumière de ta face, enseigne-moi tes préceptes."
,"136":"Mes yeux versent des ruisseaux de larmes, voyant qu'on n'observe pas ta Loi."
,"137":"Tu es juste, Seigneur, et tes jugements sont droits."
,"138":"Tu dictes des préceptes, et c'est la justice, c'est la plus haute vérité."
,"139":"Je me consume d'indignation, voyant que mes adversaires oublient tes paroles."
,"140":"Ta parole est on ne peut plus éprouvée, et ton serviteur l'aime ainsi."
,"141":"Je ne suis rien, je ne compte pas, mais je n'oublie pas tes volontés."
,"142":"Ta justice est justice, et ta Loi est vérité."
,"143":"Si l'épreuve et l'angoisse m'ont saisi, tes commandements restent mes délices."
,"144":"Tes avis sont porteurs de justice éternelle, donne-moi l'intelligence et je vivrai."
,"145":"J'appelle de tout mon coeur, Seigneur, réponds-moi: tu sais que je garde tes préceptes."
,"146":"Sauve-moi quand j'appelle, je veux observer tes volontés."
,"147":"Mes appels ont devancé l'aurore dans l'attente de ta promesse."
,"148":"Mes yeux ont devancé les heures, revenant à méditer ta parole."
,"149":"grâce, écoute mon appel, Seigneur, que tes décisions viennent me rendre vie."
,"150":"Mes persécuteurs ont pris le chemin du crime, ils n'ont fait que s'éloigner de ta Loi."
,"151":"Tu es proche, Seigneur, et tes commandements sont vérité."
,"152":"Ce que d'abord j'ai su de tes ordres, c'est que tu les donnes pour l'éternité."
,"153":"Vois ma misère et délivre-moi, car je n'ai pas oublié ta Loi."
,"154":"Défends ma cause et fais-moi justice, que ta parole me fasse vivre."
,"155":"Ton salut est loin des infidèles, ils ne s'intéressent pas à tes préceptes."
,"156":"Que tes miséricordes, Seigneur, sont fréquentes! Fais-moi vivre selon tes jugements."
,"157":"Nombreux sont mes ennemis, mes persécuteurs, mais je n'ai pas dévié de tes avis."
,"158":"J'ai vu les traîtres et j'en ai eu le dégoût, ils n'ont aucun égard pour tes paroles."
,"159":"Vois que j'aime tes volontés, fais-moi vivre, Seigneur."
,"160":"La vérité est le principe de ta parole, tes jugements sont justes pour toujours."
,"161":"Quand les officiels me poursuivaient sans raison, c'étaient tes paroles que je craignais plus encore."
,"162":"Ta parole me comblait de joie, car j'avais là un trésor sans prix."
,"163":"Je déteste le mensonge, je l'ai en horreur, et j'aime ta Loi."
,"164":"Je te loue sept fois le jour pour tes jugements qui sont justes."
,"165":"La paix inonde ceux qui aiment ta Loi, rien ne les fait trébucher."
,"166":"Je vis, Seigneur, dans l'attente de ton salut, cependant que je pratique tes commandements."
,"167":"Mon âme ne peut qu'observer tes avis, je les ai beaucoup aimés."
,"168":"J'ai observé tes volontés, tes avis, j'ai agi en tout sous ton regard."
,"169":"Que mon cri, Seigneur, parvienne jusqu'à ta face, donne-moi l'intelligence puisque tu l'as promis."
,"170":"Que ma prière entre là où tu sièges, délivre-moi selon ta parole."
,"171":"Que mes lèvres publient ta louange, car tu m'enseignes tes préceptes."
,"172":"Que ma langue célèbre ta parole, car tous tes commandements sont justes."
,"173":"Que ta main vienne me secourir car j'ai choisi tes volontés."
,"174":"J'ai désiré ton salut, Seigneur, j'ai fait de ta Loi mes délices."
,"175":"Que mon âme vive pour ta louange, et tes décisions viendront à mon aide."
,"176":"J'ai erré comme la brebis perdue, mais viens chercher ton serviteur: tu vois que je n'ai pas oublié tes préceptes."
}`)
	CurrentBook.AddChapter(120, `{
"1":"Cantique des montées,Vers le Seigneur, du milieu de ma détresse, j'ai crié attendant sa réponse."
,"2":"Sauve-moi, Seigneur, de la lèvre menteuse, de la langue bonne pour calomnier."
,"3":"Que va-t-on lui donner, que va-t-on lui souhaiter, à cette langue médisante?"
,"4":"Les flèches à pointe de l'archer,durcies sur des braises de genêt. C'est là ma malchance: je vis avec des sauvages, j'habite au milieu de pillards."
,"6":"Mon âme trouve long son séjour,entre ceux qui détestent la paix."
,"7":"Je suis pour la paix, mais que dirai-je?,Eux ne pensent qu'à se battre."
}`)
	CurrentBook.AddChapter(121, `{
"1":"Cantique des montées,J'élève mon regard vers les monts: d'où me viendra le secours?"
,"2":"Mon secours est dans le Seigneur,qui a fait le ciel et la terre."
,"3":"- Ne laissera-t-il pas broncher ton pied, ne pourrait-il sommeiller, celui qui te garde?"
,"4":"- Mais non, il ne sommeille pas, il ne dort pas, le gardien d'Israël."
,"5":"Le Seigneur te protège et te garde à son ombre, il est là à ta droite."
,"6":"Les coups de soleil, de jour, ne seront pas pour toi, ni les sorts de la lune à la nuit."
,"7":"Le Seigneur te gardera de tout mal, il veillera sur ton âme."
,"8":"Le Seigneur te garde à l'aller, au retour, dès maintenant et jusqu'à la fin."
}`)
	CurrentBook.AddChapter(122, `{
"1":"Cantique des montées. De David. J'étais tout joyeux quand on m'a dit,'Allons à la maison du Seigneur!'"
,"2":"Nos pas nous ont conduits jusqu'à toi, jusqu'à tes portes, Jérusalem,"
,"3":"Jérusalem, la ville bien bâtie,où tout s'assemble dans l'unité."
,"4":"C'est là que montent les tribus, - les tribus du Seigneur, l'assemblée d'Israël -,pour louer le nom du Seigneur."
,"5":"Là se tiennent les cours de justice, les ministères de la maison de David."
,"6":"Demandez pour Jérusalem la paix, et la sécurité pour qui la porte en son coeur."
,"7":"Que la paix garde tes murs,et la sécurité soit en tes palais!"
,"8":"Je pense à mes amis, à mes frères, lorsque je demande pour toi la paix."
,"9":"Je pense à la maison du Seigneur notre Dieu,et je voudrais pour toi tous les biens."
}`)
	CurrentBook.AddChapter(123, `{
"1":"Cantique des montées,Vers toi j'ai levé les yeux, toi qui sièges au haut des cieux."
,"2":"Les esclaves ne voient,que la main de leur seigneur, et la servante, la main de sa maîtresse; nos yeux à nous sont rivés sur le Seigneur: quand notre Dieu aura-t-il pitié de nous?"
,"3":"Aie pitié de nous, Seigneur, aie pitié: nous en avons plus qu'assez d'être méprisés."
,"4":"Notre âme en a plus qu'assez,de ces moqueries des gens à l'aise, de ce mépris des gens supérieurs."
}`)
	CurrentBook.AddChapter(124, `{
"1":"Cantique des montées. De David. Heureusement le Seigneur était avec nous, Israël peut bien le dire."
,"2":"Heureusement le Seigneur était avec nous,quand le monde s'en prit à nous."
,"3":"Sinon ils nous avalaient vivants,tant ils étaient emportés contre nous."
,"4":"Un peu plus et les eaux nous submergeaient, le torrent nous passait par-dessus,"
,"5":"et nos âmes restaient sous les eaux écumantes."
,"6":"Béni soit le Seigneur!,Il n'a pas fait de nous la proie de nos ennemis."
,"7":"Comme l'oiseau notre âme s'est échappée,du filet de l'oiseleur. Le filet s'est rompu,et nous avons échappé."
,"8":"Notre secours est dans le Nom du Seigneur,qui a fait le ciel et la terre."
}`)
	CurrentBook.AddChapter(125, `{
"1":"Cantique des montées,Ceux qui comptent sur le Seigneur,sont comme le mont Sion: assis à jamais, inébranlable."
,"2":"Jérusalem, entourée de ses monts, et le Seigneur entourant son peuple!"
,"3":"Le sceptre du méchant ne s'imposera pas,sur le domaine des justes. Car il ne faudrait pas que les justes,trempent leurs mains dans le crime."
,"4":"O Seigneur, sois bon avec ceux qui sont bons, ceux dont la droiture habite le coeur."
,"5":"Mais ceux qui mènent un double jeu et trahissent, le Seigneur les chassera avec les malfaiteurs."
,"6":"Que la paix vienne sur Israël!"
}`)
	CurrentBook.AddChapter(126, `{
"1":"Cantique des montées,Quand le Seigneur fit rentrer les captifs de Sion,nous pensions rêver."
,"2":"Nous en avions le rire aux lèvres,et des chants plein la bouche. Les païens eux-mêmes disaient: 'Le Seigneur s'est surpassé, que n'a-t-il fait pour eux!'"
,"3":"Oui, pour nous le Seigneur a fait de grandes choses,et nous étions dans la joie."
,"4":"Fais donc, Seigneur, que rentrent nos exilés,irrigue à nouveau les terres arides."
,"5":"Ceux qui sèment dans les larmes,moissonneront dans la joie."
,"6":"C'est en pleurant qu'on fait la route, emportant la semence des semailles, mais on revient dans la joie, portant les gerbes."
}`)
	CurrentBook.AddChapter(127, `{
"1":"Cantique des montées. Si le Seigneur ne bâtit la maison, les bâtisseurs ont perdu leur peine. Si le Seigneur ne garde la cité, le gardien a perdu ses veilles."
,"2":"En pure perte vous devancez le matin,et retardez au soir le repos: faut-il tant de peine pour le pain que vous mangez?,Dieu le donne à ses bien-aimés, et ils dorment."
,"3":"La richesse de l'homme, ce sont ses fils, le fruit des entrailles sera son salaire."
,"4":"Tel un combattant, il aura en main ces flèches, ces fils nés au temps qu'il était jeune."
,"5":"Heureux ce combattant, cet homme, qui en a son plein carquois. Quand ils viendront demander justice, l'adversaire ne les fera pas taire."
}`)
	CurrentBook.AddChapter(128, `{
"1":"Cantique des montées,Heureux celui qui craint le Seigneur,et qui marche dans ses voies!"
,"2":"Car tu mangeras du labeur de tes mains, ce sera ton bonheur, ce sera ta richesse."
,"3":"Ton épouse, telle une vigne, donnera ses fruits au-dedans de ta maison; tes fils, comme des plants d'olivier, se serreront autour de ta table."
,"4":"C'est ainsi que sera béni,l'homme qui craint le Seigneur."
,"5":"Que le Seigneur, de Sion, te bénisse!,Puisses-tu voir tous les jours de ta vie,une Jérusalem heureuse!"
,"6":"Puisses-tu voir les fils de tes fils, et la paix sur Israël!"
}`)
	CurrentBook.AddChapter(129, `{
"1":"Cantique des montées,On m'a beaucoup attaqué depuis ma jeunesse,- Israël peut bien le dire."
,"2":"On m'a beaucoup attaqué depuis ma jeunesse, mais nul n'a eu raison de moi."
,"3":"Des laboureurs ont labouré mon dos,et laissé tout au long des sillons."
,"4":"Mais le Seigneur est juste, lui qui tranche les cordes des méchants."
,"5":"Qu'ils connaissent l'échec, et puis la retraite, tous ceux qui détestent Sion."
,"6":"Qu'ils soient comme l'herbe du jardin,qui se dessèche sans attendre qu'on l'arrache."
,"7":"Pas de moissonneur pour en remplir sa main, pour la mettre en gerbes et la prendre en son manteau;"
,"8":"et pas un passant sur le chemin pour dire: 'Que le Seigneur vous bénisse!'"
,"9":"Nous vous bénissons au nom du Seigneur."
}`)
	CurrentBook.AddChapter(130, `{
"1":"Cantique des montées,Des profondeurs, j'ai crié vers toi, Seigneur,"
,"2":"Seigneur écoute mon appel!,Que ton oreille se fasse accueillante,au cri de ma prière."
,"3":"Si tu tiens compte de nos dettes, Seigneur, qui donc, Seigneur, se maintiendra?"
,"4":"Mais le pardon est près de toi, il fera qu'on te vénère."
,"5":"J'ai attendu, Seigneur, mon âme attendait,et je faisais confiance à ta parole."
,"6":"Mon âme comptait sur le Seigneur, plus sûre que le veilleur de la venue du jour."
,"7":"Compte, Israël, compte sur le Seigneur, car la grâce est toujours là près de lui, et près de lui sont aussi ses délivrances."
,"8":"Le Seigneur rachètera Israël,et prendra sur lui ses dettes."
}`)
	CurrentBook.AddChapter(131, `{
"1":"Cantique des montées. De David. Tu ne verras pas d'orgueil en mon coeur, ni d'arrogance en mon regard, Seigneur; je n'ai pas recherché les grandeurs, ni rêvé de ce qui me dépasse."
,"2":"J'ai assagi et tranquillisé mon âme,comme l'enfant sevré sur le sein de sa mère: mon âme en moi rien ne réclame."
,"3":"Compte, Israël, compte sur le Seigneur,dès maintenant et à jamais."
}`)
	CurrentBook.AddChapter(132, `{
"1":"Cantique des montées,O Seigneur, souviens-toi de David, de son entière disponibilité, "
,"2":"lorsqu'il fit au Seigneur son serment, lorsqu'il fit ce voeu au Puissant de Jacob:"
,"3":"'Je n'entrerai pas dans ma maison de toile, je ne monterai pas sur le lit où je me couche,"
,"4":"le sommeil ne fermera pas mes yeux et mes paupières n'auront point de repos"
,"5":"jusqu'à ce que je trouve un lieu pour le Seigneur, une demeure pour le Fort de Jacob.'"
,"6":"Bientôt c'est une rumeur: 'L'arche est à Ephrata, nous l'avons trouvée aux terres de Yaar.'"
,"7":"Allons donc jusqu'à sa demeure, prosternons-nous devant l'escabeau de ses pieds."
,"8":"Lève-toi, Seigneur! viens au lieu de ton repos, toi et ton arche, sacrement de ta force."
,"9":"Que tes prêtres se vêtent comme pour un triomphe, et que tes fidèles soient en fête."
,"10":"Souviens-toi de David, ton serviteur, et ne te détourne pas du roi, ton élu."
,"11":"Le Seigneur l'a juré à David, - c'est donc vrai, il ne peut se reprendre: 'Je veux maintenir sur ton trône, des rois nés de ton sang. "
,"12":"Si tes fils observent mon alliance et mes volontés que je leur ferai connaître, leurs fils aussi, au long des âges, siégeront sur ton trône.'"
,"13":"Car le Seigneur a choisi Sion, il l'a désirée pour sa résidence:"
,"14":"'Elle sera pour toujours le lieu où je repose, je l'ai aimée, c'est assez pour que j'y reste.'"
,"15":"Ma bénédiction sera sur ses greniers, et ses pauvres mangeront à leur faim."
,"16":"Ses prêtres se verront couverts de mon salut, et ses fidèles crieront leur joie."
,"17":"David aura toujours là sa lampe allumée, c'est de là que je ferai sortir sa victoire."
,"18":"Je couvrirai ses ennemis de honte, mais sur lui fleuriront les fleurons de sa couronne."
}`)
	CurrentBook.AddChapter(133, `{
"1":"Cantique des montées. De David. Que c'est une bonne chose, et combien douce, ces frères qui habitent tous ensemble!"
,"2":"C'est l'huile précieuse qui, de la tête consacrée, descend jusque sur la barbe,et sur le col du prêtre Aaron."
,"3":"C'est la rosée qui descend de l'Hermon,vers les montagnes de Sion."
,"4":"C'est là que le Seigneur envoie la bénédiction, il y a mis la vie éternelle."
}`)
	CurrentBook.AddChapter(134, `{
"1":"Cantique des montées,Maintenant bénissez le Seigneur, vous tous, serviteurs du Seigneur,qui êtes de service dans la maison du Seigneur, sur les parvis de la maison de notre Dieu."
,"2":"Levez vos mains dans la nuit vers le Sanctuaire,et bénissez le Seigneur."
,"3":"Que de Sion te bénisse le Seigneur, le créateur du ciel et de la terre!"
}`)
	CurrentBook.AddChapter(135, `{
"1":"Alléluia!,Louez le nom du Seigneur, louez-le, serviteurs du Seigneur "
,"2":"qui êtes de service dans la maison du Seigneur, sur les parvis de la maison de notre Dieu!"
,"3":"Louez le Seigneur car il est bon, chantez son nom car il est délicieux!"
,"4":"Car le Seigneur s'est choisi Jacob, il a fait d'Israël son domaine."
,"5":"Je sais, moi, que Yahvé est grand, notre Seigneur est au-delà de tous les dieux."
,"6":"Tout ce qu'il veut, le Seigneur le fait dans les cieux et sur la terre, et dans les mers, au plus profond des eaux."
,"7":"Il amène les nuages du fond de l'horizon, et puis jaillit l'éclair, et il pleut. Il fait sortir les vents de ses chambres secrètes."
,"8":"Il a frappé les premiers-nés d'Egypte, dans leurs familles, mais aussi parmi leurs bêtes."
,"9":"Il a fait des prodiges, envoyé des signes, par tout le pays d'Egypte, contre le Pharaon et ses serviteurs."
,"10":"Il a frappé de grandes nations, faisant périr des rois puissants,"
,"11":"Sihon, le roi amorite, et Og, souverain du Bashan, sans parler de tous les rois de Canaan."
,"12":"Puis il a distribué leurs terres, c'est l'héritage de son peuple Israël."
,"13":"Ton nom, Seigneur, durera à jamais, d'âge en âge on invoquera ton nom."
,"14":"Car le Seigneur fait justice à son peuple, il a pitié de ses serviteurs."
,"15":"Les idoles des nations ne sont qu'or et argent, un travail de la main des hommes."
,"16":"Elles ont une bouche et ne parlent pas, elles ont des yeux qui ne voient pas,"
,"17":"et des oreilles qui n'entendent pas; il n'y a pas de souffle en leur bouche."
,"18":"Que leurs fabricants deviennent comme elles, avec tous ceux qui se confient en elles!"
,"19":"Maison d'Israël, bénissez le Seigneur, maison d'Aaron, bénissez le Seigneur,"
,"20":"maison de Lévi, bénissez le Seigneur, vous qui craignez le Seigneur, bénissez le Seigneur!"
,"21":"Que de Sion le Seigneur reçoive la louange, lui qui demeure en Jérusalem."
}`)
	CurrentBook.AddChapter(136, `{
"1":"Louez le Seigneur car il est bon, car sa grâce est là pour toujours."
,"2":"Louez le Dieu des dieux, car sa grâce est là pour toujours."
,"3":"Louez le Seigneur des seigneurs, car sa grâce est là pour toujours."
,"4":"Lui seul a fait de grandes merveilles, car sa grâce est là pour toujours."
,"5":"Il fit les cieux, oeuvre d'intelligence, car sa grâce est là pour toujours."
,"6":"Il étendit la terre sur les eaux, car sa grâce est là pour toujours."
,"7":"Il fit les grands luminaires, car sa grâce est là pour toujours,"
,"8":"le soleil, haut commissaire du jour, car sa grâce est là pour toujours,"
,"9":"La lune et les étoiles, commissaires de la nuit, car sa grâce est là pour toujours."
,"10":"Il frappa les Egyptiens en leurs premiers-nés, car sa grâce est là pour toujours,"
,"11":"et fit sortir Israël de chez eux, car sa grâce est là pour toujours,"
,"12":"d'une main puissante, en frappant de grands coups, car sa grâce est là pour toujours."
,"13":"Il fendit en deux la mer des Joncs, car sa grâce est là pour toujours,"
,"14":"et fit passer Israël en son milieu, car sa grâce est là pour toujours."
,"15":"Il culbuta dans la mer Pharaon et ses troupes, car sa grâce est là pour toujours."
,"16":"Il fit aller son peuple par le désert, car sa grâce est là pour toujours."
,"17":"Il frappa de grands rois, car sa grâce est là pour toujours."
,"18":"Il tua des rois puissants, car sa grâce est là pour toujours,"
,"19":"Sihon, roi des Amorites, car sa grâce est là pour toujours,"
,"20":"et Og, roi de Bashan, car sa grâce est là pour toujours."
,"21":"Il donna leur pays en héritage, car sa grâce est là pour toujours,"
,"22":"en héritage à Israël son serviteur, car sa grâce est là pour toujours."
,"23":"Il s'est souvenu de nous dans nos humiliations, car sa grâce est là pour toujours,"
,"24":"et nous a délivrés de nos oppresseurs, car sa grâce est là pour toujours."
,"25":"C'est lui qui donne le pain à toute chair, car sa grâce est là pour toujours."
,"26":"Louez le Dieu des cieux, car sa grâce est là pour toujours!"
}`)
	CurrentBook.AddChapter(137, `{
"1":"Sur les bords des canaux de Babel,nous venions nous asseoir et pleurer, nous souvenant de Sion."
,"2":"Lorsqu'aux saules de la rive,nous pendions nos cithares,"
,"3":"nos vainqueurs nous demandaient,de leur redire une chanson. Nos bourreaux réclamaient des chants joyeux: 'Chantez-nous un cantique de Sion!'"
,"4":"Comment chanterions-nous un cantique du Seigneur,sur une terre étrangère?"
,"5":"Que ma main droite se détache,si je t'oublie, Jérusalem!"
,"6":"Que ma langue se colle à mon palais,si ton souvenir en moi se perd, si Jérusalem n'est plus en tête de mes joies."
,"7":"Souviens-toi, Seigneur, des fils d'Edom,quand vint le jour de Jérusalem, et qu'ils disaient: 'Mettez tout par terre!,Que rien ne reste sur les fondations!'"
,"8":"Mais toi, Babel, tu seras dévastée, heureux celui qui te rendra,cela même que tu nous as fait,"
,"9":"heureux qui prendra tes enfants à deux mains,pour les briser sur le roc."
}`)
	CurrentBook.AddChapter(138, `{
"1":"De tout mon coeur je te rends grâce, Seigneur, car tu as entendu les paroles de ma bouche; je te chante en présence des êtres divins."
,"2":"Je me prosterne devant ton temple saint, je rends gloire à ton nom pour ta grâce, ta vérité, car ta parole a surpassé tout éloge."
,"3":"Le jour où j'appelais, tu m'as répondu, tu m'as rendu l'audace, la force."
,"4":"Tous les rois de la terre, Seigneur, te rendront gloire, sitôt qu'ils entendront les paroles de ta bouche;"
,"5":"Ils célébreront tes voies et diront: 'Grande est la gloire du Seigneur!"
,"6":"Le Seigneur, de là-haut, voit ce qui est humble, et de très loin reconnaît les orgueilleux.'"
,"7":"Au milieu de l'épreuve tu me fais revivre, d'un geste tu arrêtes l'ennemi, et ta main me sauve."
,"8":"Comme le Seigneur prend soin de moi!,tes bontés, Seigneur, n'auront pas de fin, tu ne peux interrompre l'oeuvre de tes mains."
}`)
	CurrentBook.AddChapter(139, `{
"1":"Au maître de chant. De David. Psaume. Seigneur, tu me sondes et me connais,"
,"2":"que je m'assoie, que je me lève, tu le sais: bien avant que je n'y pense, tu le savais."
,"3":"Que je sois en voyage ou couché, tu m'observes, tu me suivras en tous mes chemins."
,"4":"Les mots ne sont pas encore sur ma langue,que déjà tu en connais le tout."
,"5":"Tu fermes sur moi l'espace, derrière comme devant, et sur moi se pose ta main."
,"6":"Ta science est pour moi un mystère, ce sont des hauteurs où je n'atteins pas."
,"7":"Où irai-je que ton esprit n'y soit, où fuir de devant ta face?"
,"8":"Si je monte au ciel, tu y es, si je vais au dortoir des morts, tu m'y retrouves."
,"9":"Ne pourrais-je emprunter les ailes de l'aurore,et qu'elles me déposent au-delà des mers?"
,"10":"Mais ce sera ta main qui m'y aura conduit, seule ta main droite peut ainsi m'emporter."
,"11":"Dirai-je alors: 'Que les ténèbres m'enveloppent, j'ai fait choix de la nuit comme lumière'?"
,"12":"Mais les ténèbres mêmes ne te sont pas obscures, et la nuit n'est pas moins lumière que le jour."
,"13":"C'est toi qui as créé mes reins, qui m'as tissé dans le sein de ma mère."
,"14":"Je t'admire pour cet étonnant mystère; prodigieuses sont tes oeuvres, mon âme le sait."
,"15":"Mes os n'échappaient pas à ta vue, lorsque j'étais formé dans le secret, brodé dans les profondeurs de la terre."
,"16":"Tes yeux voyaient la suite de mes jours, ils étaient tous écrits sur ton livre, formés avant que le premier n'apparût."
,"17":"O Dieu, que tes pensées me dépassent!,Leur ensemble défie la raison;"
,"18":"plus que le sable, leur nombre échappe à mes calculs, et je n'en finis pas d'être avec toi."
,"19":"O Dieu, si tu voulais faire périr le méchant,et tenir les violents loin de moi!"
,"20":"Ils te trahissent de façon hypocrite, ils comptent pour rien tes desseins."
,"21":"Ne dois-je pas, Seigneur, haïr qui te déteste, avoir en horreur ceux qui te résistent?"
,"22":"Je les déteste, ma haine est entière,ils sont aussi pour moi des ennemis."
,"23":"Sonde-moi, ô Dieu, et connais mon coeur, éprouve-moi et connais mon désir;"
,"24":"vois si je me trace un chemin de mensonge,et conduis-moi par le chemin des origines."
}`)
	CurrentBook.AddChapter(140, `{
"1":"Au maître de chant. Psaume de David."
,"2":"Délivre-moi, Seigneur, de l'homme mauvais, garde-moi des violents"
,"3":"qui méditent le mal en leur coeur, et tout le jour incitent à la guerre."
,"4":"Ils ont aiguisé leur langue comme le serpent, un venin de vipère est caché sous leur langue."
,"5":"Garde-moi, Seigneur, de la main du méchant et protège-moi du violent, quand il s'apprête à faire trébucher mes pas."
,"6":"Des insolents m'ont caché un filet, ils ont tendu des lacets à mes pieds, ils m'ont posé des pièges au bord du sentier."
,"7":"Et j'ai dit au Seigneur: 'C'est toi mon Dieu, entends ma voix, Seigneur, quand je t'appelle."
,"8":"Tu es puissant pour me sauver, Seigneur, toi qui couvres ma tête au jour du combat."
,"9":"Ne donne pas au méchant, Seigneur, ce qu'il a désiré, ne laisse pas aboutir ses plans."
,"10":"Que mes assiégeants ne puissent relever la tête, accablés par les maux qu'ils me préparaient."
,"11":"Que Dieu leur envoie sa pluie de charbons ardents, puis qu'il les jette au gouffre, qu'ils n'en ressortent pas!"
,"12":"Que le pays les rejette avec leurs mensonges, que le mal sans trêve pourchasse les violents!"
,"13":"Je sais que le Seigneur défend l'opprimé, il fera justice aux pauvres."
,"14":"Les justes célébreront ton Nom, les hommes droits jouiront de ta présence."
}`)
	CurrentBook.AddChapter(141, `{
"1":"Psaume de David. Seigneur, je t'appelle, accours vers moi, entends mes appels."
,"2":"Que ma prière monte à toi comme une nuée d'encens, mes mains levées vers toi en offrande du soir!"
,"3":"Mets une garde, Seigneur, à ma bouche, veille sur la porte de mes lèvres."
,"4":"N'incline pas mon coeur à des oeuvres mauvaises, que je n'aie pas de part à quelque sombre affaire avec les habitués du mal."
,"5":"Plutôt le reproche et la gifle méritée, que l'huile des méchants pour pommader ma tête! Ma prière témoigne contre leurs méfaits."
,"6":"Leurs meneurs seront jetés dans le ravin, ils comprendront alors comme j'étais indulgent."
,"7":"Une faille s'ouvrira dans la terre, et leurs os joncheront le passage aux enfers."
,"8":"Vers toi, Seigneur, se tournent mes yeux; en toi je me confie, ne lâche pas ma vie."
,"9":"Garde-moi du piège qu'on m'a tendu, et du filet où les méchants m'attendent."
,"10":"Que les pécheurs se prennent à leur propre piège, et que moi, tout seul, je m'en tire."
}`)
	CurrentBook.AddChapter(142, `{
"1":"Méditation de David. Quand il était dans la grotte. Prière."
,"2":"Je crie, j'appelle le Seigneur, je le supplie; vers le Seigneur ma voix s'élève..."
,"3":"Devant lui je déverse ma plainte, devant lui je redis ma détresse,"
,"4":"et mon esprit défaille en moi. Mais toi, ne connais-tu pas mon sentier?,Sur ce chemin où j'avance,ils m'ont tendu un piège."
,"5":"Regarde sur ma droite, et vois: pas un qui me reconnaisse. Tout espoir de fuir s'est envolé, et personne ne s'inquiète pour moi."
,"6":"Aussi ai-je crié vers toi, Seigneur; j'ai dit: 'Tu es mon espoir, mon seul bien sur la terre des vivants.'"
,"7":"Sois attentif à mon appel,et vois mon sort pitoyable. Délivre-moi de ceux qui me poursuivent,et se savent plus forts que moi."
,"8":"Fais-moi sortir vivant de la prison, et je pourrai rendre grâce à ton nom. Les justes autour de moi formeront le cercle,car ils sauront que tu m'as assisté."
}`)
	CurrentBook.AddChapter(143, `{
"1":"Psaume de David. Seigneur, écoute ma prière, prête l'oreille à ma supplication. Toi, toujours fidèle et juste, réponds-moi."
,"2":"N'entre pas en procès avec ton serviteur, car nul vivant n'est sans tort devant toi."
,"3":"L'ennemi me poursuit à mort, déjà il me piétine sur le sol, et me renvoie au séjour des ténèbres, avec les morts de tous les temps."
,"4":"Mon esprit en moi défaille, mon coeur au fond de moi se déconcerte."
,"5":"Alors je me rappelle les jours du passé, je repasse une à une tes interventions, je réfléchis sur l'oeuvre de tes mains."
,"6":"Je tends les mains vers toi, mon âme aspire à toi comme une terre assoiffée."
,"7":"Seigneur, hâte-toi de me répondre, car déjà mon esprit s'obscurcit. Ne me cache pas ta face comme tu fais pour ceux qui descendent à la fosse."
,"8":"Que vienne ce matin où j'entendrai ta grâce, car mon espérance est en toi. Montre-moi un chemin où je passerai, car vers toi j'élève mon âme."
,"9":"Délivre-moi de mes ennemis, Seigneur, car j'ai cherché refuge en toi."
,"10":"Enseigne-moi à faire ta volonté, puisque mon Dieu, c'est toi! Que ton bon esprit me guide sur un terrain aplani."
,"11":"Fais-moi vivre, Seigneur, pour l'honneur de ton nom; toi, le Juste, fais-moi sortir de la détresse."
,"12":"Toi, le Secourable, écrase mes ennemis, et fais périr ceux qui s'en prennent à ma vie: tu sais que je suis ton serviteur."
}`)
	CurrentBook.AddChapter(144, `{
"1":"De David. Béni soit le Seigneur, mon rocher: il exerce mes mains, mes doigts, à l'art de la guerre!"
,"2":"Il est mon refuge, mon rempart, ma cité haute et mon libérateur. Il est mon bouclier: je m'abrite en lui, et lui abaisse sous moi les peuples."
,"3":"Qu'est-ce que l'homme? Et toi tu t'en souviens. Qu'est-ce que le fils d'homme? Et tu veilles sur lui."
,"4":"L'homme n'est guère plus qu'un souffle, et ses jours comme une ombre passent."
,"5":"Ne veux-tu pas, Seigneur, incliner tes cieux, descendre, et d'une touche réveiller les volcans?"
,"6":"Fais jaillir les éclairs et disperse l'ennemi, lance tes flèches qui les mettront en déroute!"
,"7":"D'en haut tu étendras ta main pour me sauver des grandes eaux, tu me reprendras de la main des étrangers."
,"8":"Ils n'ont que le mensonge à la bouche, et lorsqu'ils tendent la main, c'est pour trahir."
,"9":"Je veux chanter pour toi, mon Dieu, un chant nouveau, et jouer pour toi de la harpe à dix cordes."
,"10":"Car c'est toi qui donnes au roi la victoire et qui sauves David ton serviteur. Sauve-moi de l'épée du malheur "
,"11":"et reprends-moi de la main des étrangers, qui n'ont que le mensonge à la bouche, qui ne tendent la main que pour mieux trahir."
,"12":"Voici nos fils, comme des plants qui ont grandi dès leurs premiers ans, et nos filles, colonnes sculptées qui rehaussent les lignes du temple."
,"13":"Nos greniers sont pleins, ils débordent de récoltes de toute espèce. Nos brebis se multiplient par milliers, par dizaines de mille dans nos campagnes, "
,"14":"et nos bestiaux font bon poids. Il n'y a pas d'angoisse sur nos places, ni brèche au mur, ni reddition à l'ennemi."
,"15":"Heureux le peuple qui peut en dire autant, heureux le peuple qui a pour Dieu l'Unique!"
}`)
	CurrentBook.AddChapter(145, `{
"1":"Louange. De David. Je veux t'exalter, mon Dieu et mon roi, je bénirai ton nom toujours et à jamais."
,"2":"Chaque jour je te bénirai,et je louerai ton nom, toujours et à jamais."
,"3":"Le Seigneur est grand, très digne de louange, sa grandeur passe toute mesure."
,"4":"Chaque âge conte au suivant tes oeuvres, l'un à l'autre redit tes exploits."
,"5":"Je veux chanter tes oeuvres merveilleuses, et rehausser la gloire de ta louange,"
,"6":"pour que l'on dise ta puissance en tes prodiges, et qu'on fasse le compte de tes grandeurs."
,"7":"On fera mémoire de ta grande bonté, on acclamera ta justice."
,"8":"Le Seigneur est tendresse et miséricorde, il tarde à s'irriter, sa grâce est abondante."
,"9":"Le Seigneur est bon avec tous, sa miséricorde embrasse toute son oeuvre."
,"10":"Que tes oeuvres te louent, Seigneur, et que tes fidèles te bénissent."
,"11":"Qu'ils proclament la gloire de ton règne,et nous redisent tes exploits."
,"12":"Qu'ils fassent connaître aux hommes ta vaillance, et la gloire, et l'honneur de ton règne."
,"13":"Si tu règnes, tu règnes pour les siècles, ta souveraineté s'impose d'âge en âge: le Seigneur est fidèle en toute ses paroles, il montre sa bonté en toutes ses oeuvres."
,"14":"Le Seigneur retient celui qui tombe, et redresse celui qu'on a courbé."
,"15":"Tous attendent de toi,que tu leur donnes la nourriture en son temps."
,"16":"Tu ouvres ta main, et pour tous les vivants c'est l'abondance de tes biens."
,"17":"Le Seigneur est juste, quelles que soient ses voies, il montre sa bonté en toutes ses oeuvres."
,"18":"Le Seigneur est proche de celui qui l'appelle, proche de tous ceux qui l'appellent, s'ils sont vrais."
,"19":"Il exauce le désir de ceux qui le craignent, il entend leur clameur et vient les secourir."
,"20":"Tous ceux qui l'aiment, le Seigneur les garde, mais tous les méchants, il les fait périr."
,"21":"Que ma bouche proclame la louange du Seigneur,et que toute chair bénisse son saint nom,toujours et à jamais!"
}`)
	CurrentBook.AddChapter(146, `{
"1":"Alléluia!,O mon âme, loue le Seigneur!"
,"2":"Toute ma vie je voudrais le louer, et chanter pour lui tant que je suis là."
,"3":"Ne comptez pas sur les grands, sur quelque personnage qui ne vous sauvera pas."
,"4":"Que de lui l'esprit s'échappe, il retourne à sa poussière, et le jour même c'en est fini de ses projets."
,"5":"Heureux celui qui a pour lui le Dieu de Jacob, et dont l'espoir est en Yahvé son Dieu!"
,"6":"C'est lui le créateur du ciel et de la terre, de la mer et de tout ce qu'on y trouve. Jamais il ne revient sur sa fidélité;"
,"7":"il fait justice aux opprimés, il donne le pain aux affamés. Le Seigneur renvoie libres les prisonniers,"
,"8":"le Seigneur ouvre les yeux de l'aveugle, le Seigneur redresse celui qui va courbé,"
,"9":"Le Seigneur protège l'émigré, il rend courage à l'orphelin, à la veuve."
,"8c":"Le Seigneur aime les justes"
,"9c":"mais il fait que s'égare la voie des méchants."
,"10":"Le Seigneur est roi à jamais; ton Dieu, ô Sion, règne d'âge en âge."
}`)
	CurrentBook.AddChapter(147, `{
"1":"Alléluia!,Louez le Seigneur car il est bon. Chantez pour notre Dieu, car c'est chose douce, et c'est bien juste de le louer,"
,"2":"quand il bâtit Jérusalem,et qu'il rassemble les exilés d'Israël;"
,"3":"quand il guérit les coeurs brisés,et qu'il panse les blessures."
,"4":"Il a compté le nombre des étoiles, à chacune il a donné son nom."
,"5":"Notre Seigneur est grand, il est puissant, et son intelligence passe toute mesure."
,"6":"Le Seigneur rend courage aux humbles, mais il abaisse jusqu'à terre les méchants."
,"7":"Chantez pour le Seigneur et rendez-lui grâce, jouez de vos harpes pour notre Dieu!"
,"8":"C'est lui qui couvre de nuages le ciel, lorsqu'il prépare à la terre ses pluies; c'est lui qui fait pousser l'herbe sur les collines,et toutes les verdures à l'usage des hommes."
,"9":"C'est lui qui donne la pâture aux bêtes, même aux petits corbeaux, quand ils crient vers lui."
,"10":"La force du cheval n'a pas d'attrait pour lui, ce n'est pas par ses muscles qu'un homme lui plaît."
,"11":"Le Seigneur se complaît en ceux qui le craignent, en ceux qui vivent, espérant sa grâce."
,"12":"Jérusalem, glorifie le Seigneur!,Donne louange à son nom, ô Sion!"
,"13":"Car il donne sa force aux barres de tes portes, il a béni en toi tes fils."
,"14":"Il garde en paix tes frontières, et te donne en abondance le pain et la farine."
,"15":"S'il envoie ses ordres à la terre, sans perdre un instant, sa parole s'élance."
,"16":"Alors vient la neige, comme flocons de laine, et le givre, comme une pluie de cendres."
,"17":"S'il jette sa glace par morceaux, qui pourra soutenir les coups de sa froidure?"
,"18":"Mais il envoie sa parole, il les fait fondre, il fait passer son souffle, et les eaux coulent."
,"19":"C'est lui qui fait connaître à Jacob sa parole, à Israël, ses lois et décisions."
,"20":"Cela, il ne l'a fait pour aucun autre peuple, eux n'ont pas su, de lui, ses décisions. Louez le Seigneur!"
}`)
	CurrentBook.AddChapter(148, `{
"1":"Alléluia!,Louez le Seigneur du haut des cieux, louez-le dans les hauteurs,"
,"2":"louez-le, vous, ses anges, louez-le, toutes ses armées!"
,"3":"Louez-le, soleil et lune, louez-le, vous tous, astres de lumière;"
,"4":"louez-le, cieux d'au-delà du ciel, ainsi que les eaux de dessus les cieux!"
,"5":"Qu'ils louent le nom du Seigneur, car lui donna un ordre et ils furent créés."
,"6":"Il les a mis en place pour l'éternité, leur donnant des lois qui ne passeront pas."
,"7":"Louez le Seigneur depuis la terre, monstres de la mer et profondeurs des eaux,"
,"8":"feux et grêles, neige, brouillards,et vents de tempête au service de sa parole!"
,"9":"Et vous aussi, monts et collines, arbres fruitiers et cèdres altiers,"
,"10":"bêtes sauvages et bestiaux de tous ordres, reptiles et oiseaux de haut vol,"
,"11":"rois de la terre avec tous vos peuples, grands seigneurs et gouverneurs du monde,"
,"12":"jeunes garçons aussi bien que les vierges, vieillards avec les enfants!"
,"13":"Qu'ils louent le Nom du Seigneur, car seul son Nom est élevé, sa majesté surpasse la terre et les cieux."
,"14":"Voici qu'il a donné à son peuple le prestige, et la fierté à tous ses fidèles, aux enfants d'Israël, le peuple qui l'approche."
}`)
	CurrentBook.AddChapter(149, `{
"1":"Alléluia!,Chantez au Seigneur un chant nouveau, pour sa louange dans l'assemblée des saints."
,"2":"Qu'Israël soit en joie pour celui qui l'a fait, que les fils de Sion fassent fête à leur roi."
,"3":"Qu'ils louent son nom par la danse, qu'ils jouent pour lui de la harpe et du tambourin."
,"4":"Car le Seigneur se complaît en son peuple, son salut est la parure qu'il réserve aux humbles."
,"5":"Ses fidèles, dans leur gloire, ne se contiendront pas: ils crieront de joie jusque dans leur lit."
,"6":"Dans leur bouche seront les louanges de Dieu, et dans leurs mains l'épée à deux tranchants,"
,"7":"pour exercer la vengeance contre les nations, quand les peuples recevront leur châtiment;"
,"8":"pour passer des chaînes à leurs rois et des menottes de fer à leurs grands seigneurs,"
,"9":"pour leur appliquer la sentence écrite: c'est là l'honneur réservé à ses fidèles. Alléluia!"
}`)
	CurrentBook.AddChapter(150, `{
"1":"Alléluia!,Louez Dieu dans son sanctuaire, à la voûte du ciel, louez sa force!"
,"2":"Louez-le pour ses hauts faits, louez-le autant qu'il est grand!"
,"3":"Louez-le par l'éclat du cor, louez-le sur la harpe et la cithare,"
,"4":"louez-le par les tambourins et la danse, louez-le sur le luth et la flûte,"
,"5":"louez-le avec les cymbales sonores, louez-le avec les cymbales de fanfare!"
,"6":"Vous tous qui avez souffle de vie, louez le Seigneur!,Alléluia!"
}`)

}
func FR_LBDCC_LoadVSSPChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Aimez la justice, vous qui gouvernez la terre; ayez pour le Seigneur les sentiments qui conviennent, cherchez-le d'un coeur sincère."
,"2":"Car il se laisse trouver par ceux qui ne le provoquent pas, il se manifeste à ceux qui lui font confiance."
,"3":"Sachez que les raisonnements tortueux éloignent de Dieu: la Toute- Puissance remettra en place les insensés qui la mettent à l'épreuve."
,"4":"La Sagesse n'entrera pas dans une âme mal disposée, elle n'habitera pas dans un corps esclave du péché."
,"5":"L'Esprit saint qui nous éduque fuit la duplicité; il refuse les pensées stupides et reste paralysé face à la méchanceté."
,"6":"La Sagesse est un esprit qui aime les hommes, mais elle ne laissera pas impuni celui qui blasphéme, car Dieu connaît ses pensées intimes, il voit clair dans son coeur, comme il entend ses paroles."
,"7":"En effet, l'Esprit du Seigneur remplit l'univers, et il lui donne sa cohésion: il sait donc tout ce qui se dit."
,"8":"C'est pourquoi quiconque prend des décisions injustes ne peut lui échapper; la justice ne le manquera pas, elle le réduira au silence."
,"9":"Les desseins de l'impie feront l'objet d'une enquête, ses paroles seront transmises au Seigneur et ses crimes seront punis."
,"10":"Sachez qu'une oreille vigilante écoute tout, et rien de ce qu'on a murmuré ne lui échappe."
,"11":"Gardez-vous donc des plaintes injustifiées, évitez les propos condamnables, puisque même la parole dite en secret ne reste pas sans conséquences, et la bouche menteuse tue l'âme."
,"12":"Pas de vie désordonnée! ce serait rechercher la mort. Cessez de faire ce qui amènerait votre perte."
,"13":"Car Dieu n'a pas fait la mort, et la perte des vivants ne lui cause aucun plaisir."
,"14":"S'il a créé toutes choses, c'était pour qu'elles existent; elles sont pour notre bien et n'apparaissent pas en ce monde chargées d'un poison mortel. La terre n'est pas soumise à la mort,"
,"15":"car l'ordre de la Justice est au-delà de la mort."
,"16":"Les impies pourtant appellent la mort du geste et de la voix; ils ont vu en elle une amie et se sont épris d'elle; ils ont fait un pacte avec elle et ils méritent de lui appartenir."
}`)
	CurrentBook.AddChapter(2, `{
"1":"A partir de raisonnements faux ils tirent ces conclusions: 'Notre vie est courte et pleine de déceptions, nous aurons une fin, et ce sera sans remède: on n'a jamais vu que quelqu'un soit remonté du monde des morts."
,"2":"Un hasard nous a fait naître; arrivés au bout, ce sera comme si nous n'avions pas été. Notre souffle vital n'est que la vapeur de notre haleine, notre pensée jaillit comme une étincelle du battement de notre coeur!"
,"3":"Qu'elle vienne à s'éteindre, le corps tombera en poussière, et l'esprit se dispersera comme une bouffée d'air."
,"4":"Avec le temps notre nom s'oubliera, personne ne pensera plus à ce que nous avons fait; notre vie passe comme l'ombre d'un nuage, elle s'évanouira comme le brouillard aux rayons du soleil."
,"5":"Notre vie n'est que le passage d'une ombre, la fin arrive et c'est sans retour: les scellés sont mis et nul ne revient."
,"6":"Venez donc, jouissons des biens présents, profitons des créatures, allons-y: c'est la jeunesse!"
,"7":"Du vin et des parfums!"
,"8":"Ne laissons pas se faner les roses, qu'elles s'ajoutent à notre couronne!"
,"9":"Qu'aucun d'entre nous ne manque à nos orgies; nous laisserons partout des souvenirs de nos fêtes, puisque c'est là notre part et notre lot."
,"10":"Nous en ferons voir aux pauvres bien corrects, et ce sera pareil pour les veuves; pas de respect pour les vieillards aux cheveux blancs!"
,"11":"La force justifiera notre bon droit: la faiblesse est la preuve qu'on ne sert à rien!"
,"12":"Faisons la guerre à celui qui nous ennuie avec sa Loi: il critique notre conduite, il nous reproche de violer la Loi et nous fait honte de notre éducation."
,"13":"Il se vante de connaître Dieu et se proclame un enfant du Seigneur."
,"14":"Sa seule présence contredit nos idées, et rien que de le voir nous irrite!"
,"15":"Car il ne vit pas comme les autres, et son comportement est bizarre."
,"16":"Il nous considère comme des dégénérés, il croirait se souiller s'il faisait comme nous. Il parle de bonheur pour les justes tout à la fin, et il se vante d'avoir Dieu pour père."
,"17":"Voyons donc si ce qu'il dit est vrai et faisons l'expérience: comment s'en tirera-t-il?"
,"18":"Si le juste est fils de Dieu, Dieu lui viendra en aide et le délivrera de ses adversaires."
,"19":"Essayons sur lui les humiliations et la torture, voyons comment il les accepte, éprouvons sa patience."
,"20":"Et puis condamnons-le à une mort infamante puisque, d'après lui, quelqu'un interviendra.'"
,"21":"C'est ainsi qu'ils raisonnent, mais ils sont dans l'erreur. Leur méchanceté les aveugle,"
,"22":"de sorte qu'ils ne connaissent pas les secrets de Dieu. Ils n'attendent pas la récompense d'une vie sainte, ils ne croient pas que les âmes pures auront leur salaire."
,"23":"Mais Dieu a créé l'homme pour qu'il échappe à la corruption, il l'a créé à l'image de ce qui en lui est invisible."
,"24":"La jalousie du diable a introduit la mort dans le monde, et c'est quand on prend son parti qu'on en fait l'expérience."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Les âmes des justes sont dans la main de Dieu, et plus aucun tourment ne peut les atteindre."
,"2":"Aux yeux des insensés ils sont bien morts, et leur départ apparaît comme une défaite."
,"3":"lls nous ont quitté: il semble qu'il n'est rien resté d'eux. En réalité, ils sont entrés dans la paix."
,"4":"Même si les hommes y ont vu un châtiment, la vie immortelle était là pour soutenir leur espérance:"
,"5":"après une courte épreuve ils recevront de grands bienfaits. Oui, Dieu les a mis à l'épreuve et les a trouvés dignes de lui. "
,"6":"Il les a éprouvés comme l'or au creuset, il les a agréés comme une offrande parfaite."
,"7":"Quand Dieu viendra nous visiter, ils seront lumière, semblables à la flamme légère qui court dans les broussailles."
,"8":"Ils gouverneront des nations et domineront sur les peuples, et le Seigneur sera leur roi pour toujours."
,"9":"Ceux qui ont compté sur lui connaîtront la vérité, ceux qui ont été fidèles dans l'amour resteront auprès de lui."
,"10":"Mais les impies qui auront méprisé le juste et renié le Seigneur seront châtiés pour leurs mauvais desseins."
,"11":"Oui, malheur à ceux qui rejettent la sagesse et la discipline: pour eux tout espoir est vain, tout effort est inutile, toute oeuvre stérile!"
,"12":"Leurs femmes aussi sont stupides et leurs enfants mauvais: il y a une malédiction sur leur descendance."
,"13":"Heureuse la femme sans enfants si elle est restée pure, si elle n'a pas connu d'union coupable; lorsque les âmes seront jugées, on lui verra des fruits."
,"14":"Heureux aussi l'eunuque s'il n'a pas pris part au mal et n'a pas entretenu des pensées de révolte contre le Seigneur: sa fidélité sera bien récompensée, avec une place de choix dans le temple du Seigneur."
,"15":"Car tout effort vers le bien produit des fruits admirables; la vraie connaissance est une racine qui ne dépérit jamais."
,"16":"Par contre, les enfants nés de l'adultère ne mûrissent pas, la descendance d'une union illégitime disparaît."
,"17":"S'il arrive que leur vie se prolonge, ils seront comptés pour rien, et finalement ils vieilliront sans gloire."
,"18":"Et s'ils meurent jeunes, c'est sans espérance: l'attente du jugement ne saurait les consoler."
,"19":"Oui, une race mauvaise est vouée à un sort cruel."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Mieux vaut n'avoir pas d'enfants, mais avoir bien agi: on sera alors considéré de Dieu et des hommes et on laissera un souvenir impérissable."
,"2":"Cette vie droite, on l'imite quand on la voit, on la regrette quand elle disparaît; dans l'éternité elle reçoit la couronne de gloire, car elle a triomphé dans des combats irréprochables."
,"3":"A l'opposé, la nombreuse postérité d'un impie ne signifie rien: ces rejetons bâtards ne feront pas de racines profondes et ne se fixeront pas sur une base solide."
,"4":"Pour un temps ils poussent des rameaux, et puis leurs faibles branches sont secouées par le vent, la tempête les déracine."
,"5":"Leurs branches seront brisées avant de s'être développées, leurs fruits ne vaudront rien: trop verts pour être mangés, bons à jeter!"
,"6":"Au jour du jugement, les enfants nés d'étreintes coupables témoigneront contre le péché de leurs parents."
,"7":"Le juste au contraire, même s'il meurt avant l'âge, trouvera le repos."
,"8":"L'âge qui mérite le respect ne dépend pas d'une durée de vie, il ne se mesure pas au nombre des années."
,"9":"La vraie connaissance, voilà les cheveux blancs! Une vie sans taches a valeur d'âge mûr."
,"10":"Il était droit, il a plu à Dieu qui l'aimait; mais comme il vivait au milieu des pécheurs, il en a été retiré."
,"11":"Dieu l'a enlevé de peur que le mal ne corrompe son jugement, ou que son âme se laisse égarer par le mensonge."
,"12":"Car la fascination du mal occulte les vraies valeurs et les appels du désir ébranlent une âme sans malice."
,"13":"Il a vite terminé, mais il avait fait un long chemin."
,"14":"Son âme était précieuse pour le Seigneur, c'est pourquoi il l'a vite retiré de la corruption environnante. La foule qui l'a vu n'a rien compris; ils n'ont pas réalisé "
,"15":"que la bienveillance et la miséricorde de Dieu accompagnent ses élus, et qu'il veille sur ceux qui sont siens."
,"16":"Le juste qui meurt condamne les impies qui survivent; une vie jeune, arrivée tôt à la perfection, dénonce la vieillesse interminable des mauvais."
,"17":"Ils verront donc la mort du sage, mais sans comprendre les intentions divines à son sujet, ni pourquoi le Seigneur l'a mis en sécurité."
,"18":"En le voyant ils pourront se moquer, mais le Seigneur aussi se moquera d'eux"
,"19":"quand ils seront à leur tour des cadavres repoussants et sans défense parmi les morts. Car le Seigneur les réduira au silence et les précipitera la tête la première; il les arrachera du lieu où ils vivaient et les détruira irrémédiablement: alors ils connaîtront la douleur quand tous les auront oubliés."
,"20":"Ils viendront en tremblant tandis qu'on fera le compte de leurs péchés, et face à eux se dresseront leurs crimes."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Alors le juste se tiendra plein d'assurance face à ceux qui l'ont persécuté, qui ont réduit à rien tous ses efforts."
,"2":"En le voyant ils seront saisis d'une peur énorme, stupéfaits de le voir sauvé contre toute attente."
,"3":"Pleins de remords, ils se diront, pris d'angoisse, avec des gémissements:"
,"4":"'C'est lui que nous tournions en dérision, notre tête de turc: imbéciles que nous étions! Sa vie nous semblait une folie, sa mort nous a paru l'échec final."
,"5":"Et voyez, on l'a admis parmi les fils de Dieu: comment a-t-il reçu sa place parmi les saints?"
,"6":"Comme nous avons erré, loin de la vérité! La lumière de la justice ne nous éclairait pas, le soleil ne s'est pas levé sur nous."
,"7":"Nous nous sommes rassasiés d'injustices et de crimes, parcourant des déserts dont nous ne sortions pas, au lieu de reconnaître la voie du Seigneur."
,"8":"A quoi notre orgueil nous a-t-il servi? Que nous a valu la richesse dont nous nous vantions?"
,"9":"Tout cela a passé comme une ombre, comme une rumeur qui s'efface,"
,"10":"comme le navire qui fend l'écume des eaux et de son passage il n'y a pas de trace, nulle empreinte de sa quille dans les flots."
,"11":"Ou comme l'oiseau qui traverse l'espace, et nul n'y retrouve les vestiges de sa course; qui ne laisse aucune marque de son passage. Ses plumes ont frappé l'air léger, il l'a fendu avec un sifflement, à tire d'ailes il s'est frayé un chemin, et puis, qui trouvera un signe de son vol?"
,"12":"Telle est encore la flèche décochée vers le but: à peine divisé, l'air revient sur lui- même, sans plus laisser voir son chemin."
,"13":"Nous de même, à peine nés nous avons disparu; nous nous sommes dépensés dans nos méfaits et n'avons aucun mérite que nous puissions montrer.'"
,"14":"Oui, l'espoir des impies est comme la paille lorsque le vent l'emporte, ou le flocon de neige chassé par la tempête, comme la fumée que dissipe le vent, ou le souvenir de l'hôte d'un jour: effacé!"
,"15":"Les justes, eux, vivent pour toujours, et leur récompense est auprès du Seigneur: chez le Très-Haut on a pris soin d'eux."
,"16":"Ils vont recevoir de la main du Seigneur la couronne magnifique, le diadème étincelant; de sa main droite il les couvrira, de son bras il les protégera."
,"17":"Son amour jaloux lui fait déployer ses armes, il arme l'univers pour punir ses ennemis."
,"18":"Il prend la droiture pour cuirasse, il a choisi pour casque ses jugements équitables."
,"19":"Sa sainteté invincible lui sert de bouclier,"
,"20":"de sa colère inflexible il s'est fait une épée, et l'univers avec lui combat les insensés."
,"21":"Les coups de la foudre frapperont droit au but, décochés des nuages comme d'un arc bien tendu;"
,"22":"les grêlons de sa colère s'abattront sur eux, l'océan s'indignera contre eux, et les fleuves les noieront sans pitié."
,"23":"Le souffle de sa Puissance se lèvera contre eux et comme un ouragan les dispersera. Leur péché aura fait de la terre un désert, les méfaits des puissants auront renversé leurs trônes."
}`)
	CurrentBook.AddChapter(6, `{
"1":"O rois, écoutez donc et comprenez! Laissez-vous instruire, vous qui gouvernez les terres lointaines!"
,"2":"Prêtez l'oreille, vous qui commandez à la multitude, qui êtes si fiers du grand nombre de vos peuples!"
,"3":"Car c'est le Seigneur qui vous a donné la puissance, votre pouvoir vient du Très-Haut; c'est lui qui examinera votre conduite et vérifiera vos intentions."
,"4":"Vous êtes les représentants de son pouvoir royal; si donc vous n'avez pas jugé selon la justice, ni observé sa loi, ni marché selon la volonté de Dieu,"
,"5":"il s'en prendra à vous brusquement, de façon terrifiante. Car la sentence et rigoureuse pour les gens haut placés. "
,"6":"On a pitié des petits et on leur pardonne, mais les puissants seront strictement contrôlés."
,"7":"Le Maître universel ne redoute personne, et les dignités humaines ne l'impressionnent pas: petits et grands, c'est lui qui les a faits; il prend le même soin de tous,"
,"8":"mais les puissants seront examinés plus à fond."
,"9":"C'est donc à vous, princes, que je m'adresse, pour que vous appreniez la sagesse et ne tombiez pas."
,"10":"Car ceux qui observent saintement les lois saintes deviendront saints eux-mêmes, et ceux qui les auront approfondies y trouveront leur défense."
,"11":"Soyez donc avides de mes paroles et recherchez-les: elles vous instruiront."
,"12":"La Sagesse est lumière et ne se flétrit pas; elle se montre volontiers à ceux qui l'aiment, elle se laisse trouver par ceux qui la recherchent."
,"13":"Elle va à la rencontre de ceux qui désirent la connaître;"
,"14":"celui qui pour elle s'est levé tôt n'aura guère à peiner: il la trouvera assise à sa porte."
,"15":"Se passionner pour elle est la meilleure des ambitions, celui qui aura veillé à cause d'elle sera bientôt sans soucis."
,"16":"Elle va elle-même de tous côtés à la recherche de ceux qui sont dignes d'elle; elle se montre avec bienveillance sur leurs chemins, elle vient les retrouver dans toutes leurs pensées."
,"17":"Le commencement de la sagesse est un vrai désir de se former; chercher l'instruction, c'est l'aimer."
,"18":"Qui l'aime observe ses lois, qui obéit à ses lois s'assure la vie qui ne dépérit pas,"
,"19":"et la vie qui ne dépérit pas nous met tout près de Dieu."
,"20":"Voià comment la sagesse conduit à la royauté!"
,"21":"Vous donc, souverains des peuples, si vous appréciez le trône et les insignes du pouvoir, honorez la Sagesse, et vous régnerez pour toujours."
,"22":"Je vais vous dire ce qu'est la Sagesse et quelle est son origine, je ne vous cacherai aucun secret. Je veux la suivre depuis ses débuts et vous exposer clairement, sans m'écarter de la vérité, tout ce qu'on en peut savoir."
,"23":"Car ici, pas de secrets à garder jalousement: cela n'aurait rien à voir avec la Sagesse."
,"24":"Si les sages se multipliaient, ce serait le salut du monde, car un roi intelligent fait la prospérité de son peuple."
,"25":"Instruisez-vous donc grâce à mes paroles, et vous y trouverez du profit."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Je ne suis moi-même qu'un mortel comme tous les autres, un descendant de ce premier qui fut formé de la terre. Mon corps s'est élaboré dans le ventre de ma mère"
,"2":"où, durant dix mois, j'ai été pétri dans son sang, à partir de la semence virile et du plaisir partagé sur la couche."
,"3":"Une fois né, j'ai respiré le même air que les autres, je suis tombé sur la même terre, j'ai poussé le premier cri et j'ai pleuré comme eux;"
,"4":"on m'a enveloppé de langes et on a pris soin de moi."
,"5":"Aucun roi n'a commencé sa vie autrement:"
,"6":"la vie n'a qu'une entrée, et la sortie en est la même pour tous."
,"7":"J'ai prié, et l'intelligence m'a été donnée; j'ai supplié, et l'esprit de sagesse est venu à moi."
,"8":"Je l'ai préférée aux sceptres et aux trônes, et j'ai tenu la richesse pour rien à côté d'elle."
,"9":"J'ai vu qu'elle valait plus que les pierres précieuses; l'or n'est jamais qu'un peu de sable devant elle, et l'argent, moins que la boue."
,"10":"Je l'ai aimée plus que la santé et la beauté, je l'ai même préférée à la lumière du soleil, car sa clarté n'a pas de coucher."
,"11":"Avec elle me sont venus tous les autres biens: ses mains étaient chargées de richesses sans nombre."
,"12":"Je recevais avec joie toutes ces choses que la sagesse me procurait, mais je ne savais pas encore qu'elle en était la mère."
,"13":"J'ai étudié de façon désintéressée, c'est pourquoi j'en fais le partage sans arrière-pensée: c'est une richesse que je ne cacherai pas."
,"14":"Car la Sagesse est pour les humains le trésor inépuisable; ceux qui y puisent deviennent amis de Dieu, grâce aux un esprit irrésistible, bienfaisant, ami des hommes, ferme, sûr, paisible, qui peut tout et fruits de son éducation."
,"15":"Que Dieu me donne d'en parler correctement et de me passionner pour elle à la mesure des bienfaits reçus! Car c'est lui qui oriente vers la Sagesse et dirige les sages."
,"16":"Nous sommes dans les mains de Dieu, nous et nos paroles, nos réflexions et notre savoir-faire."
,"17":"C'est lui qui m'a donné la connaissance vraie du réel: la constitution du monde et les propriétés des éléments,"
,"18":"les commencements, les fins et l'entre-deux, les positions du soleil et l'alternance des saisons,"
,"19":"les cycles de l'année et le mouvement des étoiles,"
,"20":"les différentes espèces et le comportement des bêtes sauvages, le pouvoir des esprits et les problèmes des humains, la variété des plantes et les propriétés de leurs racines."
,"21":"J'ai donc su tout ce qui est caché et tout ce qui se voit, puisque la Sagesse qui a tout mis en oeuvre me l'enseignait."
,"22":"En elle se trouve un esprit intelligent, saint, unique, multiple, agile, mobile, pénétrant, pur, limpide; il ne peut se corrompre, il est porté au bien et efficace."
,"23":"C'est qui veille sur tout; il imprègne tous les autres esprits, aussi intelligents, purs et subtils qu'ils soient."
,"24":"La Sagesse est plus mobile que tout, grâce à sa pureté elle traverse et pénètre tout."
,"25":"Elle se dégage, comme une vapeur, de la puissance de Dieu, c'est une émanation très pure de sa gloire; aussi bien, rien de souillé ne s'introduit en elle."
,"26":"Elle est le rayonnement de la lumière éternelle, le miroir sans tache de l'activité de Dieu et l'image de sa perfection."
,"27":"Elle est une, mais elle peut toutes choses; sans sortir d'elle-même, elle renouvelle tout. D'âge en âge, elle passe dans les âmes saintes dont elle fait des amis de Dieu et des prophètes."
,"28":"Car Dieu n'aime rien sinon celui qui cohabite avec la Sagesse."
,"29":"Elle est plus belle que le soleil et surpasse toute constellation; comparée à la lumière, elle arrive première,"
,"30":"car la nuit vient remplacer le jour, tandis que jamais le mal n'est plus fort que la Sagesse."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Oui, la Sagesse s'étend d'une extrémité de la terre à l'autre, et partout elle établit l'ordre."
,"2":"Je l'ai aimée et désirée dès ma jeunesse; j'ai cherché à la prendre comme épouse, car j'étais amoureux de sa beauté."
,"3":"Le fait qu'elle soit auprès de Dieu fait ressortir sa noble origine: le Maître de toutes choses l'a aimée."
,"4":"Elle est initiée à la connaissance même de Dieu, et c'est elle qui décide des oeuvres à réaliser."
,"5":"Si la richesse est ce qu'on désire en ce monde, y a-t-il richesse plus grande que la Sagesse, la réalisatrice universelle?"
,"6":"Et si l'intelligence est réalisatrice, qui donc parmi les vivants fait les choses mieux qu'elle?"
,"7":"Aimez-vous la droiture? Sachez que toutes les vertus sont les fruits de son labeur; elle enseigne la prudence et l'intelligence, la justice et la vaillance: il n'y a rien dans la vie qui soit plus utile aux hommes."
,"8":"Cherche-t-on des connaissances étendues? La Sagesse connaît les choses passées et prévoit l'avenir; elle sait interpréter les discours et résoudre les énigmes, elle annonce d'avance les signes de la nature et les prodiges, la fin des âges et des temps."
,"9":"Voilà pourquoi j'ai décidé d'en faire la compagne de ma vie: je savais qu'elle me conseillerait dans les temps heureux, et me soutiendrait dans les soucis et les peines."
,"10":"'Grâce à la Sagesse, me disais-je, je serai honoré par les foules et, malgré ma jeunesse, respecté des anciens."
,"11":"On me reconnaîtra un jugement pénétrant, et les puissants m'admireront."
,"12":"Si je me tais, ils seront dans l'attente; si je parle, ils seront attentifs; même si mon discours se prolonge, ils resteront à m'écouter."
,"13":"Grâce à la Sagesse j'obtiendrai l'immortalité, et je laisserai un souvenir éternel à ceux qui viendront après moi."
,"14":"Je gouvernerai les peuples, et les nations me seront soumises."
,"15":"Des souverains redoutables prendront peur en entendant parler de moi; je serai bon avec mes gens et courageux à la guerre."
,"16":"De retour chez moi, je me reposerai auprès d'elle, car sa compagnie n'est pas amère; vivre avec elle n'a rien de pénible, mais apporte au contraire, joie et bonheur.'"
,"17":"Voilà comment je raisonnais en moi-même. Je comprenais qu'on trouve la vie immortelle dans l'union avec la Sagesse,"
,"18":"qu'on acquiert une joie supérieure grâce à son amitié, une richesse durable grâce à ses travaux, l'intelligence quand on s'exerce à l'entendre, et la renommée dans les entretiens avec elle. Je suis donc parti à sa recherche afin de la prendre chez moi."
,"19":"J'étais de naissance un enfant bien doté, j'avais reçu en partage une âme bonne;"
,"20":"ou plutôt, étant bon, j'étais venu dans un corps sans défauts."
,"21":"Mais j'avais compris aussi que le seul moyen pour la posséder était que Dieu me la donne, et c'était déjà un signe d'intelligence de l'avoir compris. C'est pourquoi je me suis tourné vers le Seigneur et je l'ai supplié; de tout mon coeur je lui ai dit:"
}`)
	CurrentBook.AddChapter(9, `{
"1":"Dieu de nos Pères, Seigneur de miséricorde, par ta Parole tu as fait toutes choses,"
,"2":"et par ta Sagesse tu as formé l'homme pour qu'il domine sur toutes les créatures au-dessous de toi,"
,"3":"pour qu'il gouverne le monde avec sainteté et justice, et prenne ses décisions avec droite conscience:"
,"4":"donne-moi donc la Sagesse qui partage ton trône, et ne me rejette pas du nombre de tes enfants."
,"5":"Vois, je suis ton serviteur, le fils de ta servante, un homme faible dont la vie est brève, trop limité pour comprendre la justice et les lois!"
,"6":"Même le plus parfait parmi les humains ne serait rien, sans la Sagesse qui vient de toi."
,"7":"Tu m'as choisi comme roi de ton peuple, comme juge pour tes fils et tes filles."
,"8":"Tu m'as dit de bâtir un temple sur ta sainte montagne, un autel dans la ville où tu habites, à la ressemblance de cette Tente céleste que tu avais préparée pour toi dès le commencement."
,"9":"Auprès de toi est cette Sagesse qui connaît toutes tes oeuvres, qui était là lorsque tu faisais le monde, qui sait ce qui t'est agréable et s'accorde avec tes commandements."
,"10":"Fais qu'elle descende depuis le ciel où tout est saint, envoie-la de ton trône glorieux, pour qu'elle soit à mes côtés dans mes travaux et que je sache ce qui te plaît."
,"11":"Car elle connaît et comprend tout; elle me guidera d'une main avisée dans mes entreprises, et sa majesté me protégera."
,"12":"Alors mes oeuvres te seront agréables, je gouvernerai ton peuple avec justice, et je serai digne du trône de mon père."
,"13":"Qui donc, en effet, connaîtra le vouloir de Dieu? Qui se passionnera pour ce que veut le Seigneur?"
,"14":"La raison humaine avance timidement, nos réflexions sont mal assurées,"
,"15":"car un corps périssable pèse lourdement sur l'âme, et notre gangue d'argile paralyse l'esprit toujours en éveil."
,"16":"S'il nous coûte de connaître les choses terrestres, de découvrir ce qui est à portée de main, qui pourrait comprendre ce qui est dans les cieux?"
,"17":"Et qui connaîtrait tes intentions, si tu ne lui avais pas d'abord donné la Sagesse, si tu ne lui avais pas envoyé d'en-haut ton Esprit saint?"
,"18":"C'est ainsi que les habitants de la terre ont pu corriger leur conduite; ayant appris ce qui te plaît, ils ont été sauvés par la Sagesse."
}`)
	CurrentBook.AddChapter(10, `{
"1":"La Sagesse a protégé le père du monde, ce premier homme qui fut formé par Dieu et qu'il créa unique. Elle l'a relevé de sa faute"
,"2":"et lui a départi la force, afin qu'il domine sur toutes choses."
,"3":"L'homme s'est éloigné d'elle, emporté par sa fureur; il a été mauvais jusqu'à tuer son frère, et il s'est perdu, lui et son emportement."
,"4":"Mais lorsqu'à cause de lui la terre fut noyée sous les eaux, la Sagesse l'a sauvé encore: elle pilotait son radeau."
,"5":"Plus tard les peuples se sont unis pour faire le mal, et la discorde s'est installée entre eux. La Sagesse alors a reconnu un autre juste: elle l'a gardé irréprochable devant Dieu et lui a donné la force de surmonter sa tendresse pour son enfant."
,"6":"C'est elle aussi qui a délivré le juste dans sa fuite, lorsque le feu descendait sur les cinq villes pour anéantir les impies."
,"7":"Et maintenant encore il reste un témoignage de leur perversité: une terre aride et toujours fumante, des arbustes dont les fruits ne mûrissent pas, une colonne de sel en souvenir de celle qui n'a pas cru."
,"8":"Ceux qui s'étaient écartés du chemin de la Sagesse ont donc été punis, perdant tout leur bonheur; bien plus, leurs ruines sont là comme un rappel pour les vivants, afin que leurs fautes ne soient jamais oubliées."
,"9":"Par contre la Sagesse a délivré de leurs épreuves ceux qui la servaient."
,"10":"Elle a conduit par de droits chemins le juste qui fuyait la colère de son frère. Elle lui a montré le royaume de Dieu et lui a fait connaître les saints anges. Elle a fait réussir ses travaux et fructifier ses efforts."
,"11":"Elle a pris son parti contre l'avarice de ses maîtres et l'a rendu très riche."
,"12":"Elle l'a gardé de ses ennemis et l'a protégé contre ceux qui lui tendaient des pièges. Elle lui a donné la victoire dans un rude combat, pour lui faire comprendre que la piété est plus puissante que tout."
,"13":"La Sagesse n'a pas abandonné le juste quand on l'a vendu: elle l'a préservé du péché."
,"14":"Elle est descendue vers lui dans la citerne et ne l'a pas délaissé non plus dans les chaînes; bien au contraire, elle lui a remis le pouvoir dans le royaume et lui a donné autorité sur ceux qui l'avaient persécuté. Elle a fait apparaître le mensonge de ses calomniateurs et lui a procuré une gloire qui ne passera pas."
,"15":"La Sagesse a arraché le peuple saint, la race irréprochable, de la nation de ses oppresseurs."
,"16":"Elle est entrée dans l'âme d'un serviteur du Seigneur pour tenir tête à des rois redoutables, au moyen de signes et de prodiges."
,"17":"Elle a remis au peuple saint le salaire de ses peines, elle les a guidés par un chemin étonnant. Elle les abritait de son ombre durant le jour et les éclairait comme un astre durant la nuit."
,"18":"Elle leur a fait passer la mer Rouge: ils ont traversé les grandes eaux!"
,"19":"Mais elle a englouti leurs ennemis, pour ensuite rejeter leurs corps du plus profond des eaux."
,"20":"C'est ainsi que les justes dépouillèrent ces impies; ils chantèrent des hymnes à ton saint Nom, ô Seigneur! D'un seul coeur ils te rendirent grâces, parce que tu les avais délivrés."
,"21":"Car le Seigneur ouvre la bouche des muets et fait parler les tout-petits."
}`)
	CurrentBook.AddChapter(11, `{
"1":"La Sagesse fit donc réussir leur entreprise par la main d'un saint prophète."
,"2":"Ils traversèrent un désert inhabité et dressèrent leurs tentes en des lieux inaccessibles."
,"3":"Ils tinrent tête à leurs adversaires et repoussèrent leurs ennemis."
,"4":"Quand ils souffrirent de la soif, ils t'invoquèrent; tu leur donnas de l'eau jaillie d'une roche dure: oui, c'est une pierre brute qui apaisa leur soif."
,"5":"Les mêmes éléments qui avaient servi à punir leurs ennemis devenaient ainsi bénéfiques pour le peuple saint."
,"6":"Les Egyptiens avaient vu leur fleuve, un vrai fleuve qui coulait en toutes saisons, souillé par une boue de sang:"
,"7":"c'était en punition du décret ordonnant de tuer les nouveaux-nés d'Israël. Par contre, tu donnais à ton peuple, contre toute attente, une eau abondante."
,"8":"Après avoir souffert de la soif, ils comprirent mieux comment tu châtiais leurs ennemis."
,"9":"Pour eux l'épreuve n'avait été qu'une légère correction, mais ils voyaient quel châtiment tourmentait les impies, quand ta juste colère les frappait."
,"10":"Tu éprouvais ton peuple comme un père corrige son enfant, mais tu condamnais leurs ennemis à la façon d'un roi sévère."
,"11":"Ils avaient eu à souffrir avant le départ d'Israël, ils souffrirent aussi par la suite."
,"12":"Quand ils se rappelèrent tout ce qui était arrivé, leur peine redoubla."
,"13":"Lorsqu'ils apprirent que l'eau, instrument de leur châtiment, s'était retournée en faveur d'israël, ils reconnurent la main du Seigneur."
,"14":"Longtemps auparavant ils avaient exposé Moïse à la mort; plus tard ils l'avaient repoussé avec mépris. Mais maintenant ils l'admiraient, car cette soif qui les dévorait, bien différente de celle des justes, les y contraignait."
,"15":"Leur coeur mauvais les avait égarés: c'était de la folie quand ils adoraient des reptiles sans raison et de vils animaux. C'est pourquoi tu leur envoyas en punition des hordes de bêtes,"
,"16":"leur faisant voir par là qu'on est puni par où l'on a péché."
,"17":"Ta main toute-puissante n'avait que le choix: puisque tu avais créé le monde à partir d'une matière informe, tu aurais pu sans difficulté expédier contre eux des bandes d'ours ou de lions indomptables."
,"18":"Pour les punir tu aurais pu créer des espèces nouvelles, des bêtes pleines de fureur, au souffle de feu, dont les narines auraient projeté une fumée brûlante, dont les yeux lanceraient des éclairs terrifiants!"
,"19":"Rien qu'à les voir, avant même d'être attaqués par elles, ils seraient morts de frayeur."
,"20":"Même sans tout cela, il suffisait que ta justice les poursuive, que ton souffle puissant les disperse: tu pouvais les faire tomber d'un souffle. Tu n'as pas voulu, car tu respectes en tout ce que tu disposes: mesure, nombre et poids."
,"21":"Certes, tu peux toujours t'imposer souverainement, et qui pourrait s'opposer à la force de ton bras?"
,"22":"Le monde entier est devant toi comme un grain sur la balance, comme une goutte de rosée descendue au matin sur le sol."
,"23":"Mais parce que tu peux tout, tu as pitié de tous et tu sembles ignorer les péchés des hommes afin qu'ils se repentent."
,"24":"Car tu aimes tous les êtres, tu ne détestes rien de ce que tu as fait: si tu n'en voulais pas, tu ne l'aurais pas fait."
,"25":"Comment pourrait durer une chose que tu n'aies pas voulue? Qu'est-ce qui pourrait subsister, si tu ne l'avais pas appelé?"
,"26":"Mais tu épargnes tout, parce que tout est à toi, ô Maître qui aimes la vie,"
}`)
	CurrentBook.AddChapter(12, `{
"1":"et ton Esprit impérissable est en tout!"
,"2":"C'est ainsi que tu corriges par degrés ceux qui pèchent; tu leur fais voir, grâce à tes réprimandes, en quoi ils ont péché, pour qu'ils renoncent au mal et croient en toi, Seigneur."
,"3":"Ce fut le cas pour les anciens habitants de ta Terre sainte:"
,"4":"tu les avais en horreur à cause de leurs pratiques détestables, leur sorcellerie et leurs rites impies,"
,"5":"le meurtre impitoyable des petits enfants, les festins sanguinaires où ils mangeaient de la chair humaine avec le sang et les entrailles, tandis qu'ils célébraient leurs cultes secrets."
,"6":"Ces parents meurtriers d'êtres sans défense, tu avais décidé de les anéantir par la main de nos pères."
,"7":"Tu voulais que cette terre qui t'est chère entre toutes, devienne la patrie d'enfants de Dieu dignes d'elle."
,"8":"Pourtant, même envers ces anciens habitants, tu as fait preuve de modération, parce que c'étaient des êtres humains. C'est ainsi qu'en avant-garde de ton armée tu as envoyé sur eux des frelons, pour les détruire peu à peu."
,"9":"Tu aurais pu, bien sûr, faire écraser les impies par les justes au cours d'une bataille, ou les anéantir d'un seul coup par des bêtes terrifiantes ou par un mot venu de toi."
,"10":"Mais en les punissant progressivement, tu leur laissais l'occasion de se repentir. Tu n'ignorais pourtant pas que leur fond était mauvais et leur méchanceté innée, et qu'ils ne changeraient jamais,"
,"11":"car leur race avait été maudite dès le commencement. En tous cas, ce n'est pas par peur de qui que ce soit que tu laissais leurs crimes impunis. "
,"12":"Car, qui pourrait te dire: 'Qu'as-tu fait?'; qui pourrait s'opposer à tes décisions? Qui te fera des reproches si tu anéantis des nations que tu as créées? Qui t'empêchera de punir des hommes injustes?"
,"13":"En dehors de toi qui prends soin de tous, il n'y a pas d'autre Dieu auquel tu devrais prouver que tu n'agis pas injustement."
,"14":"Il n'y a pas davantage de roi ou de souverain qui puisse s'opposer à toi quand tu as décidé de punir."
,"15":"Parce que tu es parfaitement juste, tu conduis tout avec justice: tu ferais un mauvais usage de ton pouvoir si tu condamnais celui qui ne mérite pas d'être puni."
,"16":"Ta force est le fondement de ta justice; étant le maître de toutes choses, tu peux aussi les épargner."
,"17":"Ceux qui mettent en doute ta puissance absolue, tu leur montres ta force; tu punis l'audace de ceux qui la bravent."
,"18":"Mais bien que tu sois un puissant Seigneur, tu juges avec modération et tu nous gouvernes avec beaucoup de patience, car tu es libre d'intervenir quand il te plaît."
,"19":"En agissant ainsi tu as montré à ton peuple que le juste doit aimer tous les hommes, et tu as donné à tes fils cette douce espérance qu'après le péché tu leur permettras de se repentir."
,"20":"Envers les Cananéens eux-mêmes, pourtant ennemis de tes enfants et bien dignes de mort, tu as agi avec retenue et indulgence, pour leur donner le temps et l'occasion de se convertir."
,"21":"Mais envers tes fils tu as agi avec encore beaucoup plus de précautions, puisque tu t'étais lié avec leurs ancêtres par des serments, des alliances et tant de belles promesses."
,"22":"Ainsi donc, lorsque tu frappes nos ennemis avec modération, c'est pour notre instruction, pour que nous songions à ta bonté lorsque nous aurons nous-mêmes à juger, et que nous comptions sur ta miséricorde lorsque nous sommes jugés."
,"23":"Ceux qui vivaient follement dans le mal, tu les as punis par le moyen de leurs idoles abominables."
,"24":"Ils s'étaient vraiment égarés trop loin sur les chemins de l'erreur, en prenant pour dieux les plus laids et les plus méprisables parmi les animaux! Ils s'étaient laissé berner comme des enfants sans raison."
,"25":"Comme pour des enfants qui ne pensent pas, tu leur avais d'abord envoyé un avertissement léger,"
,"26":"mais ils n'avaient pas compris ces remontrances bénignes, si bien qu'ils méritèrent de faire l'expérience du jugement de Dieu."
,"27":"Dans leurs souffrances ils s'indignaient contre ces animaux qu'ils avaient pris pour des dieux et qui maintenant devenaient les instruments de leur châtiment. C'est alors qu'ils découvrirent et reconnurent comme Dieu celui qu'autrefois ils avaient refusé de voir: c'était là la raison du châtiment suprême qui tombait sur eux."
}`)
	CurrentBook.AddChapter(13, `{
"1":"L'incapacité naturelle des humains se révèle dans leur ignorance de Dieu. Tout ce qu'ils admirent de valable ne les a pas amenés à connaître Celui-qui-est. Ils en sont restés aux oeuvres et n'ont pas reconnu l'Artisan!"
,"2":"Ils ont regardé comme des dieux gouverneurs du monde, aussi bien le feu que le vent, l'air léger, le firmament étoilé, l'eau impétueuse ou les luminaires du ciel."
,"3":"Fascinés par tant de beauté, ils les ont considérés comme des dieux; mais alors, n'auraient-ils pas dû savoir que leur souverain est plus grand encore? Car ce ne sont que les créatures de celui qui fait apparaître la beauté."
,"4":"S'ils ont été impressionnés par leur force et leur activité, ils doivent comprendre que leur Créateur est encore plus puissant."
,"5":"Car la grandeur et la beauté des créatures donnent quelque idée de celui qui leur a donné l'être."
,"6":"Mais sans doute il ne faudrait pas trop blâmer ces gens-là: peut-être se sont-ils égarés alors qu'ils cherchaient Dieu et voulaient le trouver."
,"7":"Ils étudiaient les créatures qui les entouraient, et ce qu'ils voyaient était si beau qu'ils en sont restés à l'extérieur."
,"8":"Pourtant, même ainsi, ils ne sont pas excusables:"
,"9":"s'ils ont été capables de scruter l'univers, comment n'ont-ils pas découvert d'abord celui qui en est le Maître?"
,"10":"Combien plus à plaindre sont ceux qui mettent leur confiance en des choses mortes, et qui donnent le nom de dieux à ce qui est sorti de mains humaines: or, argent ciselé, figures d'animaux, et jusqu'à la pierre inutilisable qu'un beau jour quelqu'un a sculptée!"
,"11":"Voici par exemple un bûcheron: il scie un arbre facile à transporter, il en racle soigneusement toute l'écorce, puis il le débite avec adresse et en fait un meuble quelconque d'usage courant."
,"12":"Les déchets de son travail, il les emploie pour cuire son repas et ainsi refaire ses forces."
,"13":"Parmi le peu de bois qui lui reste et qui n'est bon à rien, il aperçoit un morceau tordu et plein de noeuds; il le prend et le sculpte à ses moments perdus; il y met tout son art et lui donne forme humaine,"
,"14":"à moins qu'il ne représente un vulgaire animal. Il y met de la peinture rouge après avoir passé l'enduit pour recouvrir tous les défauts."
,"15":"Puis il lui prépare sur le mur une niche à sa taille, et il le fixe au mur avec des clous de fer."
,"16":"Il a pris ses précautions pour qu'il ne tombe pas, car il sait bien que son dieu est incapable de s'aider lui-même: il faut l'aider car il n'est rien de plus qu'une image."
,"17":"Et malgré cela, qu'il s'agisse de ses affaires, de son mariage ou de ses enfants, il ne rougit pas d'adresser la parole à cette chose sans vie. Pour sa santé, il invoque un objet sans force;"
,"18":"pour vivre, il rend hommage à ce qui ne vit pas; pour se faire aider, il s'adresse à ce bois impuissant; avant un voyage, il invoque celui qui ne sait pas marcher!"
,"19":"Pour son gain, pour son travail, pour son art, il recourt à une statue dont les mains n'ont pas la moindre habileté."
}`)
	CurrentBook.AddChapter(14, `{
"1":"En voici un autre qui se prépare à naviguer. Avant d'affronter la fureur des flots, il invoque un morceau de bois plus fragile encore que le bateau qui le porte."
,"2":"Ce bateau, il est né du désir du gain, et c'est l'art du technicien qui l'a réalisé,"
,"3":"mais c'est ta Providence, ô Père, qui le conduit. C'est toi qui as ouvert un chemin dans la mer et tracé une route sûre parmi les flots."
,"4":"Tu nous as montré ainsi que tu peux nous sauver où que ce soit, si bien qu'on s'embarque même sans grande expérience."
,"5":"Tu ne veux pas que les hommes, oeuvres de ta Sagesse, restent sans rien faire, et voilà qu'ils confient leur vie à un simple bout de bois: un radeau leur permet de traverser les vagues sans dommages."
,"6":"Déjà aux temps anciens, tandis que périssaient les géants orgueilleux, le juste qui portait l'espoir de l'univers se réfugia sur un radeau; conduit par ta main, il laissa au monde la semence d'une humanité nouvelle."
,"7":"Béni soit le bois qui fut l'instrument de ton salut!"
,"8":"Quant à l'idole fabriquée et celui qui l'a faite, qu'ils soient maudits l'un et l'autre: l'ouvrier, parce qu'il l'a faite, et la chose, parce qu'elle a été appelée dieu!"
,"9":"Tous les deux sont insupportables pour Dieu, l'impie et le produit de son impiété;"
,"10":"l'oeuvre sera détruite avec son artisan!"
,"11":"C'est pourquoi le châtiment atteindra, même les idoles des nations, parce qu'elles sont des choses abominables au sein de la création: elles font choir les âmes des humains, et les insensés se prennent à leur piège."
,"12":"L'invention des idoles a été le commencement de la perversion; cette invention a corrompu la vie."
,"13":"Car elles n'existaient pas à l'origine et elles ne dureront pas toujours."
,"14":"La vanité humaine les a introduites dans le monde et voilà pourquoi leur destruction prochaine est décidée."
,"15":"Voici un père affligé par un deuil brutal; il fait faire une image de son enfant trop tôt disparu, et puis il honore comme un dieu celui qui n'était qu'un défunt. Il transmet à sa famille des rites et des cérémonies,"
,"16":"et avec le temps cette coutume impie se fortifie jusqu'à devenir obligatoire pour tous."
,"17":"De la même façon des statues ont été vénérées sur l'ordre des princes. Ceux de leurs sujets qui ne pouvaient les honorer en personne car ils habitaient au loin, ont voulu avoir leur portrait. Grâce à cette image, ils pouvaient vénérer le roi comme s'il était présent."
,"18":"Le talent de l'artiste donna de l'ampleur à ce culte parmi ceux qui ne connaissaient pas le souverain."
,"19":"Dans le désir de lui plaire, on s'ingénia à le représenter plus beau que nature."
,"20":"La chose était si parfaite que la foule se laissa séduire: on en vint rapidement à voir un dieu en celui qu'on vénérait."
,"21":"Voilà comment l'image est devenue un piège pour les vivants: des hommes frappés par le malheur ou asservis aux puissants ont donné à des pierres ou à du bois le Nom incommunicable."
,"22":"Une telle erreur dans la connaissance de Dieu ne leur suffisait pas. L'ignorance les a amenés à de telles contradictions qu'ils ont regardé comme normaux les pires excès:"
,"23":"les meurtres d'enfants offerts en sacrifice, les rites secrets, les orgies furieuses et extravagantes!"
,"24":"Plus la moindre pureté dans leur vie ou leur mariage: on supprime l'autre par traîtrise, ou on le déshonore par l'adultère."
,"25":"Partout ce n'est que sang et meurtres, vols, fraudes, corruption, mauvaise foi, révoltes, parjures,"
,"26":"désarroi des gens de bien, oubli des bienfaits, scandales, pratiques contre nature, désordres dans le mariage, adultère, débauche."
,"27":"Le culte de ces dieux qui n'en méritent pas le nom, est le commencement, la cause et le terme du mal."
,"28":"Il y en a qui aiment s'exciter jusqu'au délire, et alors ils rendent des faux oracles. D'autres vivent dans le mal et vont jusqu'à se parjurer;"
,"29":"vu qu'ils s'appuient sur des idoles sans vie, comment auraient-ils peur que leurs faux-serments soient punis?"
,"30":"Mais ils seront châtiés en toute justice pour ce double motif: d'abord, parce qu'ils ont méconnu Dieu en s'attachant à des idoles; ensuite, parce qu'ils ont fraudé, faisant de faux-serments au mépris de ce qui est sacré."
,"31":"Même si les idoles sont impuissantes, le châtiment réservé aux pécheurs atteindra les impies."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Mais toi, ô notre Dieu, tu es bon et vrai; tu es patient et tu gouvernes l'univers avec miséricorde."
,"2":"Même si nous péchons, nous sommes à toi et nous savons ta puissance; mais, sachant que nous sommes à toi, nous éviterons le péché."
,"3":"Te connaître, c'est toute la droiture; reconnaître ta puissance, c'est le point de départ de l'immortalité."
,"4":"Pour nous, nous ne nous sommes pas laissé égarer par une invention trompeuse des hommes, par ces oeuvres inutiles des artistes, ces idoles barbouillées de couleurs."
,"5":"Elles n'émeuvent que des insensés, capables de s'exciter pour la beauté sans âme d'images mortes."
,"6":"Vraiment, les faiseurs d'images cherchent leur malheur et méritent d'y tomber, et de même ceux qui y croient et qui les adorent!"
,"7":"Voici encore un potier: il pétrit consciencieusement l'argile molle, il modèle pour notre utilité toutes sortes d'objets. De la même pâte il tire les vases destinés à de nobles usages, et d'autres, destinés à des emplois tout opposés. A quoi servira tel vase? C'est le potier qui en décide."
,"8":"De la même argile il façonne la statue d'un faux dieu: voilà bien de la peine perdue pour un homme tout juste sorti de la terre et qui d'ici peu y retournera quand on lui redemandera son âme."
,"9":"Il ne réfléchit pas qu'il lui faudra mourir et que sa vie est brève: il ne pense qu'à rivaliser avec les orfèvres et les fondeurs d'argent, il imite ceux qui coulent le bronze et met sa gloire à fabriquer du faux."
,"10":"Son coeur n'est que cendres, ses ambitions sont plus inconsistantes que la terre; mais son existence même a moins de valeur que l'argile"
,"11":"tant qu'il ignore celui qui l'a formé et ne reconnaît pas celui qui lui a insufflé une âme consciente, mettant en lui le souffle vital."
,"12":"A ses yeux, la vie n'est qu'un jeu, et l'existence une suite de marchés: 'Il faut gagner, dit-il, d'où que cela vienne, même si c'est mal!'"
,"13":"Cet homme-là, plus que les autres, sait qu'il pèche en fabriquant ainsi, d'une même glaise, des choses et des images divines."
,"14":"Mais les ennemis de ton peuple, ceux qui l'ont opprimé, étaient vraiment insensés, plus à plaindre que de pauvres enfants naïfs!"
,"15":"Ils avaient adopté pour dieux des idoles venues de toutes les nations - des images incapables de voir avec leurs yeux, de respirer avec leur nez, d'entendre avec leurs oreilles; qui ne peuvent ni toucher avec leurs doigts, ni marcher avec leurs pieds."
,"16":"C'est normal: un homme les a faites. Celui qui les a façonnées n'a de vie que celle qu'on lui a prêtée, et il n'est même pas capable de faire un dieu qui lui ressemble,"
,"17":"puisque ses mains impies de mortel ne produisent que des choses mortes. Cet homme a plus de valeur que les objets qu'il adore: lui du moins aura vécu, mais ceux-là, jamais."
,"18":"Les gens adorent jusqu'aux bêtes les plus répugnantes (car en fait de stupidité elles sont pires que les autres)."
,"19":"Elles n'ont absolument rien d'attirant et chassent tout désir de louer Dieu et de lui rendre grâces."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Voilà pourquoi nos persécuteurs ont été fort justement châtiés par des bêtes de ce genre, et tourmentés par une multitude d'insectes."
,"2":"Quant à ton peuple, loin de le punir, tu le comblais de bienfaits: tu lui envoyais un aliment merveilleux - des cailles! pour assouvir sa faim dévorante."
,"3":"Quand nos ennemis avaient faim, ils étaient remplis de dégoût par l'aspect hideux des animaux que tu leur envoyais; ton peuple, au contraire, après une brève privation, jouissait d'un aliment de choix."
,"4":"Les oppresseurs méritaient d'être frappés par une famine implacable, mais pour ton peuple il suffisait qu'il comprenne comment ses ennemis étaient torturés."
,"5":"Même lorsque des bêtes féroces s'en prirent furieusement aux tiens et qu'ils succombaient sous la morsure de serpents venimeux, ta colère ne dura pas jusqu'à la fin."
,"6":"Leur châtiment, qui ne dura qu'un temps, avait valeur d'avertissement: ils reçurent un signe de salut pour leur rappeler les commandements de ta Loi."
,"7":"En effet, quiconque se tournait vers cet objet de bronze était sauvé, non par ce qu'il avait sous les yeux, mais par toi, le Sauveur de tous."
,"8":"Et là encore, tu prouvais à nos ennemis que c'est toi qui délivres de tout mal."
,"9":"C'étaient des morsures de sauterelles et de mouches qui les faisaient mourir, sans qu'on trouve de remède pour les garder en vie: voilà la preuve qu'ils avaient pleinement mérité un tel châtiment."
,"10":"Tes fils, au contraire, résistaient même aux dents des serpents venimeux, et cela, parce que tu faisais preuve de miséricorde et tu les sauvais."
,"11":"Ils étaient mordus, juste pour leur rappeler tes oracles, de peur qu'ils ne t'oublient complètement et ne deviennent insensibles à tes bienfaits; et bien vite ils étaient guéris."
,"12":"Leur guérison ne fut pas l'oeuvre d'herbes ou de pommades, mais de ta parole, Seigneur, car toi tu guéris tout."
,"13":"Oui, tu as pouvoir sur la vie et sur la mort; tu fais descendre les hommes au séjour souterrain, ou tu les en préserves."
,"14":"L'homme, dans sa méchanceté, est capable de tuer, mais il ne fait pas revenir le souffle lorsqu'il s'est échappé, il ne peut rappeler l'âme qui s'en est allée."
,"15":"Impossible d'échapper à ta main!"
,"16":"Les impies qui refusaient de te reconnaître ont été flagellés par ton bras puissant, poursuivis par des pluies extraordinaires, par la grêle et des orages impitoyables, et dévorés par le feu."
,"17":"Phénomène étrange: c'est précisément dans l'eau qui éteint tout, que le feu brûlait le plus violemment, car tous les éléments se liguaient pour protéger les justes."
,"18":"Tantôt la flamme baissait pour ne pas brûler les animaux envoyés contre les impies: ainsi ils comprendraient que Dieu voulait les punir;"
,"19":"tantôt, au contraire, la flamme reprenait sous l'averse afin de détruire les récoltes d'un pays pervers."
,"20":"Par contre tu distribuais à ton peuple la nourriture des anges, tu lui envoyais du ciel inlassablement un pain tout préparé, qui avait en lui toutes les saveurs et s'adaptait au goût de chacun."
,"21":"Cette nourriture faisait voir ta tendresse pour tes enfants: elle répondait aux désirs de celui qui en mangeait et se transformait en ce que chacun voulait."
,"22":"Elle paraissait une neige mais supportait le feu sans fondre; pendant ce temps les récoltes des ennemis étaient la proie de flammes qui brûlaient au milieu de la grêle: les éclairs brillaient sous la pluie."
,"23":"Mais le feu semblait perdre ses propriétés dès qu'il s'agissait de la nourriture des justes."
,"24":"Ta création est à ton service puisque tu en es l'auteur. Elle s'emploie à châtier les mauvais, puis elle se relâche en faveur de ceux qui mettent en toi leur confiance."
,"25":"Pour servir ta bonté qui donne à tous leur nourriture, elle se transformait, se conformant au désir de ceux qui l'attendaient."
,"26":"Tes fils bien-aimés apprenaient ainsi, Seigneur, que ce ne sont pas les produits de la terre qui nourrissent l'homme, mais que c'est ta parole qui soutient ceux qui croient en toi."
,"27":"Cette nourriture que le feu ne détruisait pas, fondait cependant à la chaleur du premier rayon de soleil,"
,"28":"afin que l'on sache qu'il faut devancer le soleil pour te rendre grâces et te prier dès le lever du jour."
,"29":"Car les espoirs des ingrats fondront comme le givre hivernal, et s'écouleront comme une eau perdue."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Comme tes projets sont élevés et difficiles à comprendre! C'est pourquoi ceux qui n'en savaient rien se sont égarés."
,"2":"Les impies pensaient tenir en leur pouvoir la nation sainte: c'est eux qui se retrouvèrent captifs, prisonniers d'une longue nuit, enfermés sous leur propres toits, exilés loin de ton infallible protection."
,"3":"Ils comptaient se dissimuler avec leurs péchés sous le voile de l'oubli, mais ils furent dispersés, livrés à de terribles frayeurs, épouvantés par des fantômes."
,"4":"Les recoins où ils s'étaient réfugiés ne les mettaient pas à l'abri de la peur: des bruits terrifiants retentissaient tout autour d'eux, et des spectres livides, aux traits lugubres, leur apparaissaient."
,"5":"Aucun feu ne pouvait les éclairer, et l'éclat brillant des étoiles n'osait pas percer cette sombre nuit."
,"6":"La seule chose qu'ils pouvaient voir, c'était un feu terrifiant qui ne s'apaisait pas; et lorsque cette vision avait disparu, dans leur épouvante ils exagéraient encore ce qu'ils venaient de voir."
,"7":"Les artifices de la magie ne servaient à rien, et leur prétention à la sagesse recevait un démenti cinglant;"
,"8":"car ceux qui se vantaient de guérir les esprits de leurs troubles et de leurs craintes étaient pris eux aussi d'une peur ridicule."
,"9":"Même quand il n'y avait rien à craindre, le simple passage d'une bête ou le sifflement d'un reptile suffisait pour les terrifier; ils mouraient convulsés de peur, n'osant regarder vers cet air qui nous entoure et que nul ne saurait fuir."
,"10":"En effet, la méchanceté est peureuse: elle se condamne elle-même. Poursuivie par sa conscience, elle s'attend toujours au pire."
,"11":"Avoir peur, c'est tout simplement renoncer aux secours de la raison;"
,"12":"moins on compte sur cette aide intérieure, plus on grossit la cause inconnue de ses soufrances."
,"13":"Cette nuit était issue du monde infernal, monde de l'impuissance; elle s'était emparée d'eux dans leur sommeil et les tenait dans l'impuissance. Tout au long de cette nuit"
,"14":"ils se voyaient poursuivis par des spectres et restaient cloués sur place: une peur horrible et soudaine les submergeait."
,"15":"Chacun restait là où il tombait, immobilisé dans cette prison sans grilles."
,"16":"Qu'on fût laboureur, berger ou travailleur solitaire, chacun était saisi à l'improviste, sans pouvoir résister; une même obscurité les tenait tous enchaînés."
,"17":"Tout les remplissait de terreur et les paralysait, que ce soit le murmure de la brise, le gazouillis d'un oiseau dans la ramure, ou le bruit régulier d'une chute d'eau,"
,"18":"ou le fracas d'un éboulis de pierres sur une pente, ou la course invisible d'animaux bondissants, ou encore le hurlement de bêtes sauvages et l'écho renvoyé par les replis des montagnes."
,"19":"Le reste du monde jouissait d'une brillante lumière sans que rien l'empêchât de s'affairer à ses travaux;"
,"20":"sur eux par contre pesait une lourde nuit, image des ténèbres qui seraient un jour leur sort: n'étaient-ils pas en eux-mêmes plus pesants que les ténèbres?"
}`)
	CurrentBook.AddChapter(18, `{
"1":"Pour tes saints, au contraire, la lumière resplendissait. Les Egyptiens ne les voyaient pas, mais ils les entendaient et pensaient qu'ils avaient bien de la chance d'y échapper."
,"2":"Ils les remerciaient même de ne pas se venger après tout ce qu'ils avaient subi, et ils leur en demandaient pardon."
,"3":"A la place de cette obscurité, tu donnas à ton peuple une colonne de feu pour les guider dans ce voyage à l'aventure: leur glorieuse migration se ferait ainsi sous un soleil qui ne les brûlait pas."
,"4":"Les Egyptiens méritaient cette privation de lumière, ces ténèbres qui les emprisonnaient: n'avaient-ils pas eux-mêmes retenu captifs tes fils qui devaient porter au monde l'impérissable lumière de ta Loi?"
,"5":"Ils avaient voulu exterminer les nouveaux-nés du peuple saint. Seul parmi ceux qu'on abandonnait, Moïse fut sauvé. Pour les punir, Seigneur, tu as fait périr un grand nobmre des leurs, puis tu les as noyés, tous ensemble, dans la mer impétueuse."
,"6":"Cette nuit avait été prédite à nos pères, pour qu'ils sachent ensuite la valeur de tes promesses et qu'ils y puisent leur confiance."
,"7":"Oui, ton peuple attendait ce moment où les justes seraient sauvés et leurs ennemis ruinés;"
,"8":"en punissant nos adversaires, tu couvrais de gloire tes élus, c'est-à-dire nous-mêmes."
,"9":"Tes saints enfants, la race des bons, offrirent donc en secret le sacrifice et s'engagèrent à observer cette loi divine: le peuple saint resterait solidaire dans le succès comme dans les périls; après quoi ils entonnèrent les chants de leurs pères."
,"10":"Au même moment les clameurs confuses de leurs ennemis leur faisaient écho, avec les cris lamentables de ceux qui pleuraient leurs enfants."
,"11":"Une même sentence frappait le serviteur et le maître; l'homme du peuple souffrait comme le roi."
,"12":"Ils pleuraient des morts innombrables, tous frappés de la même mort; les vivants ne suffisaient plus pour les enterrer: toute la fleur de leur race avait péri en un instant."
,"13":"Ils avaient d'abord refusé de croire, trompés par leurs magiciens, mais après la mort de leurs premiers-nés ils reconnurent que ce peuple était fils de Dieu."
,"14":"Alors que tout était tranquille dans le silence, et que la nuit parvenait au milieu de sa course,"
,"15":"ta Parole toute-puissante s'élança du haut des cieux, d'auprès de ton trône royal, et se précipita comme un guerrier farouche sur le pays voué à l'extermination. Elle portait, comme un glaive acéré, ton irrévocable décision; "
,"16":"elle touchait le ciel et foulait la terre; lorsqu'elle frappa, elle jeta partout la mort."
,"17":"Aussitôt ils furent troublés par des apparitions et d'horribles cauchemars: une terreur sans nom s'abattit sur eux."
,"18":"Lorsqu'ils tombaient demi-morts en tout lieu, ils savaient dire pourquoi ils mouraient,"
,"19":"car les songes qui les avaient troublés les avaient instruits. Ils ne devaient pas succomber sans savoir pourquoi il leur fallait souffrir."
,"20":"Il est vrai que les justes aussi firent l'expérience de la mort: le fléau frappa beaucoup d'entre eux dans le désert; mais la colère de Dieu ne dura pas."
,"21":"Un homme irréprochable prit aussitôt leur défense avec les armes de son ministère: la prière et l'encens des sacrifices expiatoires. C'est ainsi qu'il affronta ta colère, Seigneur, et mit un terme à leur épreuve: on vit ainsi qu'il était ton serviteur. "
,"22":"Il vint à bout de ton ressentiment, non par la force physique ou l'efficacité des armes, mais grâce à ses paroles: il rappela à l'Exterminateur les promesses et les alliances conclues jadis avec nos pères."
,"23":"Les morts déjà s'entassaient lorsqu'il s'interposa, mit fin à la Colère et lui barra le chemin des vivants."
,"24":"Le monde entier était représenté sur sa longue tunique, il portait sur quatre rangs de pierres précieuses les noms glorieux de nos pères, et sur son front, le diadème de ta majesté."
,"25":"A sa vue, l'Exterminateur recula et prit peur: cet avant-goût de ta colère avait suffi."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Pour les impies par contre, une fureur impitoyable les frappa jusqu'au bout, car Dieu savait d'avance ce qu'ils feraient:"
,"2":"après avoir autorisé ton peuple à s'en aller, et l'y avoir même poussé, ils changèrent d'avis et se mirent à sa poursuite."
,"3":"Ils n'avaient pas fini de pleurer les morts et de se lamenter sur les tombes lorsqu'ils prirent la folle décision de poursuivre comme des fugitifs ceux qu'ils avaient supplié de partir."
,"4":"Une juste fatalité les poussa à cette mesure extrême et leur fit oublier tout ce qui était déjà arrivé: il fallait que de nouveaux tourments mettent le comble à leur châtiment."
,"5":"Ton peuple allait faire l'expérience d'un voyage incroyable, mais eux devaient connaître une mort peu commune."
,"6":"Sur ton ordre toute la création, avec ses propriétés naturelles, fut renouvelée d'en-haut afin de protéger tes enfants."
,"7":"On vit une nuée couvrir le camp de son ombre et la terre sèche apparaître au milieu de l'eau; un passage sûr s'ouvrit dans la mer Rouge, une plaine verdoyante remplaça les flots impétueux,"
,"8":"et tout le peuple y passa. Protégé par ta main, il fut témoin de ces prodiges étonnants."
,"9":"Ils folâtraient comme des chevaux au pâturage, ils gambadaient comme des agneaux, ils te louaient, Seigneur, car tu les avais délivrés."
,"10":"Ils pouvaient se rappeler ce qu'ils avaient vu dans le pays de leur exil, comment le sol s'était couvert, non pas d'animaux mais de moustiques, et comment le fleuve avait rejeté, non pas des poissons, mais d'innombrables grenouilles."
,"11":"Plus tard, ils virent encore des oiseaux naître d'une nouvelle façon, lorsque la faim les pressait et qu'ils demandaient une nourriture plus substantielle;"
,"12":"des cailles sortirent de la mer pour subvenir à leurs besoins."
,"13":"Les autres, les pécheurs, avaient été avertis par de violents orages, avant que les châtiments ne s'abattent sur eux. Ils étaient punis en toute justice pour leur propre méchanceté, car ils avaient montré une haine cruelle envers des étrangers."
,"14":"Ailleurs on avait refusé d'accueillir des inconnus, mais eux avaient réduit en servitude un peuple bienfaisant installé chez eux."
,"15":"Ceux qui avaient odieusement reçu des étrangers devaient être punis,"
,"16":"mais eux, qui avaient accueilli nos pères avec des fêtes, ils les avaient ensuite accablés de terribles corvées après les avoir traités en égaux!"
,"17":"Aussi furent-ils frappés d'aveuglement, comme il était arrivé aux habitants de Sodome devant la porte de Lot, le juste: ils s'étaient retrouvés dans le noir et chacun allait à tâtons, cherchant sa propre porte."
,"18":"C'est ainsi que les différents éléments du monde interchangeaient leurs propriétés, tout comme sur la cithare l'alternance des sons change le rythme, chaque note gardant toutefois sa tonalité propre. Et, si l'on examine les faits, c'est bien ce qui arrivait."
,"19":"Ce qui vit sur terre s'adaptait à l'eau, ce qui est fait pour l'eau devenait terrestre."
,"20":"Le feu brûlait plus fort au contact de l'eau, et celle-ci oubliait de l'éteindre."
,"21":"Les flammes ne brûlaient pas les insectes fragiles qui les traversaient; elles ne faisaient pas fondre la manne, cette nourriture divine qui aurait dû se liquéfier, comme le givre, en un instant."
,"22":"Oui, Seigneur, de mille façons tu as exalté et glorifié ton peuple! Jamais tu ne l'as oublié, mais tu l'as assisté toujours et partout!"
}`)

}
